;;
;; DO NOT EDIT THIS FILE
;;
;; this file is automatically generated from fetch.l on (Linux ip-172-30-1-179 4.4.0-1072-aws x86_64) at 2018-12-17 11:22:22 PST
;;
;; /tmp/binarydeb/ros-indigo-fetcheus-1.1.0 $ ;;

;;
;; copy euscollada-robot class definition from euscollada/src/euscollada-robot.l
;;
(defclass euscollada-robot
;; This euscollada-robot class is for robots converted from collada files.
;; This class provides :init-ending override.
  :super robot-model
  :slots ()
  )
(defmethod euscollada-robot
  (:init-ending
   (&optional (type :urdf))
   (when (eq type :collada)
     ;; fix all links' mass properties ;; root link relative (collada) -> link local (euslisp)
     (dolist (l (append links
                        (mapcan #'(lambda (x) (if (and (derivedp (cdr x) bodyset-link)
                                                       (not (memq (cdr x) links)))
                                                  (list (cdr x)))) (send self :slots))))
       (unless (= (send l :weight) 0.0)
       (setq (l . acentroid) (send l :inverse-transform-vector
                                   (send (send (car links) :worldcoords) :transform-vector
                                         (l . acentroid))))
       (setq (l . inertia-tensor) (m* (transpose (send l :worldrot))
                                      (m* (send (car links) :worldrot)
                                          (l . inertia-tensor))))
       )))
   (send-super :init-ending)
   (send self :make-collision-model-for-links)
   ;;
   (dolist (j (mapcan #'(lambda (x) (if (and (derivedp (cdr x) joint)
                                             (not (memq (cdr x) (send self :joint-list))))
                                        (list (cdr x)))) (send self :slots)))
     (send (send j :child-link) :add-joint j)
     (send (send j :child-link) :add-parent-link (send j :parent-link))
     (send (send j :parent-link) :add-child-links (send j :child-link)))
   )
  (:change-visual
   (&optional (visual :convex))
   (dolist (lk (send self :links))
     (dolist (bd (send lk :bodies))
       (when (derivedp bd collada-body)
         (send bd :change-visual visual)))))
  ;; fullbody-inverse-kinematics overwrite
  ;;  reduce root-link's weight based on leg's joint limit
  ;;  increase stop and cog-gain
  (:fullbody-inverse-kinematics
   (target-coords &rest args &key (stop 250) (cog-gain 2.0) (additional-weight-list) (use-6dof-joint-leg-gain nil) &allow-other-keys)
   (let* ((leg-ul (send self :calc-union-link-list (send self :legs :links))))
     (send self :reset-joint-angle-limit-weight-old leg-ul)
     (send-message* self robot-model :fullbody-inverse-kinematics
                    target-coords
                    :stop stop :cog-gain cog-gain
                    :additional-weight-list
                    (append
                     additional-weight-list
                     (if use-6dof-joint-leg-gain
                         (list
                          (list (car (send self :links))
                                #'(lambda ()
                                    ;; set root-link 6dof-joint's weight based on legs' joint limit
                                    (let* ((min-weight
                                            (reduce #'(lambda (x y) (min x y))
                                                    (coerce (send self :calc-inverse-kinematics-weight-from-link-list
                                                                  leg-ul :union-link-list leg-ul) cons))))
                                      (fill (instantiate float-vector 6) min-weight)))
                                )
                          )))
                    args)
     ))
  ;; make collision model from faces or gl-vertices
  (:make-collision-model-for-links
   (&key (fat 0) (collision-func 'pqp-collision-check) ((:links ls) (send self :links)))
   (dolist (ll ls)
     (let (fs glv usefs)
       (dolist (bd (send ll :bodies))
         (if (derivedp bd collada-body)
             (push (send bd :glvertices) glv)
           (push (send bd :faces) fs)))
       (setq fs (flatten fs))
       (cond
        ((and (not fs) glv) ;; if there is no faces, use glvertices for creating pqpmodel
         (setq usefs (instance gl::glvertices :init nil))
         (send usefs :transform (send ll :worldcoords))
         (send usefs :append-glvertices glv)
         (let ((m (send usefs (read-from-string
                               (format nil ":make-~Amodel"
                                       (string-right-trim "-COLLISION-CHECK" (string collision-func))))
                        :fat fat)))
           (setf (get ll :pqpmodel) m)
           ))
        (fs
         (setq usefs
               (append fs
                       (mapcar #'(lambda (gv) (send gv :convert-to-faces :wrt :world)) glv)))
         (send ll
               (read-from-string
                (format nil ":make-~Amodel"
                        (string-right-trim "-COLLISION-CHECK" (string collision-func))))
               :fat fat
               :faces usefs))
        ))
     ))
  )

;; copy euscollada-body class definition from euscollada/src/euscollada-robot.l
;; This euscollada-body class is for bodies in robot model converted from collada files.
(defclass collada-body
  :super gl::glbody
  :slots (glvertices) ;; glvertices slot for backward compatibility
  )
(defmethod collada-body
  (:init (&key (name) (replace-obj))
    (if replace-obj
        (replace-object self replace-obj)
      (replace-object self (make-cube 10 10 10)))
    (if name (send self :name name))
    (setq glvertices gl::aglvertices)
    self)
  (:change-visual
   (&optional (visual :convex))
   (case visual
     ((list :convex :hull :convex-hull)
      (unless (send self :get :original-mesh)
        (send self :put :original-mesh gl::aglvertices)) ;; store original mesh
      (let* ((org-mesh (send self :get :original-mesh))
             (org-cds (send org-mesh :copy-worldcoords))
             (glv (gl::make-glvertices-from-faces (send self :faces))))
        (send glv :set-offset (send org-cds :inverse-transformation))
        (send glv :transform org-cds)
        (send org-mesh :assoc glv)
        (setq gl::aglvertices glv)
        glv))
     ((list :original :mesh :glvertices :original-mesh)
      (let ((org-mesh (send self :get :original-mesh)))
        (when org-mesh
          (dolist (d (send org-mesh :descendants)) ;; dissoc all discendants
            (send org-mesh :dissoc d))
          (setq gl::aglvertices org-mesh)
          org-mesh)))
     ))
  )
;;
;; end of copy from /opt/ros/indigo/share/euscollada/src/euscollada-robot.l
;;
(defun fetch () (setq *fetch* (instance fetch-robot :init)))

(defclass fetch-robot
  :super euscollada-robot
  :slots ( ;; link names
          base_link_lk bellows_link_lk bellows_link2_lk elbow_flex_link_lk estop_link_lk forearm_roll_link_lk gripper_link_lk head_camera_depth_frame_lk head_camera_depth_optical_frame_lk head_camera_link_lk head_camera_rgb_frame_lk head_camera_rgb_optical_frame_lk head_pan_link_lk head_tilt_link_lk l_gripper_finger_link_lk l_wheel_link_lk laser_link_lk r_gripper_finger_link_lk r_wheel_link_lk shoulder_lift_link_lk shoulder_pan_link_lk torso_fixed_link_lk torso_lift_link_lk upperarm_roll_link_lk wrist_flex_link_lk wrist_roll_link_lk
         ;; joint names
          bellows_joint_jt bellows_joint2_fixed_jt elbow_flex_joint_jt estop_joint_fixed_jt forearm_roll_joint_jt gripper_axis_fixed_jt head_camera_depth_joint_fixed_jt head_camera_depth_optical_joint_fixed_jt head_camera_joint_fixed_jt head_camera_rgb_joint_fixed_jt head_camera_rgb_optical_joint_fixed_jt head_pan_joint_jt head_tilt_joint_jt l_gripper_finger_joint_jt l_wheel_joint_jt laser_joint_fixed_jt r_gripper_finger_joint_jt r_wheel_joint_jt shoulder_lift_joint_jt shoulder_pan_joint_jt torso_fixed_joint_fixed_jt torso_lift_joint_jt upperarm_roll_joint_jt wrist_flex_joint_jt wrist_roll_joint_jt
         ;; sensor names
         
         )
  )
(defmethod fetch-robot
  (:init
   (&rest args)
   (let ()
     (send-super* :init :name "fetch" args)

     ;; link: l_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_wheel_link"))
       ;; inertial parameter for l_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send l_wheel_link_lk :weight 4354.200)
         (setq (l_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 4.5000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 4.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.2914000000000001e+00 1.8738000000000000e+02 5.5324999999999996e+01))
                        ))
         (send l_wheel_link_lk :transform world-cds))
       )

     ;; link: estop_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_estop_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq estop_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "estop_link"))
       ;; inertial parameter for estop_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 2.4345127370720006e+00 -3.3060831523989975e+00 6.6513919665003582e+00)
                                   :rot (quaternion2matrix (float-vector -1.8135978370637712e-01 3.7737992945742199e-01 8.9765484242839588e-01 -1.3750927809256769e-01)))
                      ))
         (send estop_link_lk :weight 1.961)
         (setq (estop_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.3907229084280334e+02 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 2.8325249388296766e+02 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.0232143163343412e+02))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (estop_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for estop_link_lk
       (let ((world-cds (make-coords :pos (float-vector -1.2464999999999999e+02 2.3891999999999999e+02 3.1126999999999998e+02)
                                   :rot (quaternion2matrix (float-vector 7.0710548251123639e-01 7.0710807985947355e-01 0.0000000000000000e+00 0.0000000000000000e+00)))
                        ))
         (send estop_link_lk :transform world-cds))
       )

     ;; link: base_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_base_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq base_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "base_link"))
       ;; inertial parameter for base_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -3.6000000000000001e+00 0.0000000000000000e+00 1.3999999999999999e+00)
                                   :rot (quaternion2matrix (float-vector 9.9678697486942491e-01 5.0693159331570564e-03 1.3706509815053390e-02 7.8753795815314151e-02)))
                      ))
         (send base_link_lk :weight 70129.400)
         (setq (base_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2236035794744101e+09 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.2869026736118920e+09 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 9.8679374691369808e+08))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (base_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for base_link_lk
       (let ((world-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                        ))
         (send base_link_lk :transform world-cds))
       )

     ;; link: laser_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_laser_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq laser_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "laser_link"))
       ;; inertial parameter for laser_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -3.0622897017564100e+01 7.0916829082774002e-01 5.5197411947130156e+01)
                                   :rot (quaternion2matrix (float-vector -7.0400153754082506e-01 -6.9462702866095449e-01 1.3665193539356812e-01 5.6580692351719600e-02)))
                      ))
         (send laser_link_lk :weight 8.336)
         (setq (laser_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0032293231161771e+03 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.3048654927097341e+03 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 5.0331610182989630e+02))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (laser_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for laser_link_lk
       (let ((world-cds (make-coords :pos (float-vector 2.3500000000000000e+02 0.0000000000000000e+00 2.8780000000000001e+02)
                                   :rot (quaternion2matrix (float-vector -1.0286788442024686e-13 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))
                        ))
         (send laser_link_lk :transform world-cds))
       )

     ;; link: r_wheel_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_wheel_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_wheel_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_wheel_link"))
       ;; inertial parameter for r_wheel_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                      ))
         (send r_wheel_link_lk :weight 4354.200)
         (setq (r_wheel_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 4.5000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 5.0000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 4.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_wheel_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_wheel_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.2914000000000001e+00 -1.8738000000000000e+02 5.5324999999999996e+01))
                        ))
         (send r_wheel_link_lk :transform world-cds))
       )

     ;; link: torso_fixed_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_torso_fixed_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq torso_fixed_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "torso_fixed_link"))
       ;; inertial parameter for torso_fixed_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -7.2200000000000003e+01 5.7000000000000171e+00 2.6559999999999997e+02)
                                   :rot (quaternion2matrix (float-vector 9.9947345297728563e-01 -2.4860940660755976e-02 -1.7711461488166880e-02 -1.1002479496790596e-02)))
                      ))
         (send torso_fixed_link_lk :weight 13277.500)
         (setq (torso_fixed_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.8649019381620610e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.3935515121265501e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0085465497113889e+08))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (torso_fixed_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for torso_fixed_link_lk
       (let ((world-cds (make-coords :pos (float-vector -8.6875000000000000e+01 0.0000000000000000e+00 3.7742500000000001e+02))
                        ))
         (send torso_fixed_link_lk :transform world-cds))
       )

     ;; link: torso_lift_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_torso_lift_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq torso_lift_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "torso_lift_link"))
       ;; inertial parameter for torso_lift_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.2999999999999956e+00 -8.9999999999998193e-01 2.9350000000000006e+02)
                                   :rot (quaternion2matrix (float-vector 9.9926537384690506e-01 6.2122875823932043e-04 -3.3557853238680040e-02 -1.8498572686733539e-02)))
                      ))
         (send torso_lift_link_lk :weight 10779.600)
         (setq (torso_lift_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.3649004913699543e+08 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.3539999999999994e+08 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 9.4309950863004446e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (torso_lift_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for torso_lift_link_lk
       (let ((world-cds (make-coords :pos (float-vector -8.6875000000000000e+01 0.0000000000000000e+00 3.7743000000000001e+02))
                        ))
         (send torso_lift_link_lk :transform world-cds))
       )

     ;; link: bellows_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_bellows_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq bellows_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "bellows_link"))
       ;; inertial parameter for bellows_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.9132000028622794e+01 -1.7547745080721359e-13 -1.3486162544338697e+02)
                                   :rot (quaternion2matrix (float-vector 7.0710678108795899e-01 7.0710678108909353e-01 -1.1773826368840821e-05 -1.1773826364834692e-05)))
                      ))
         (send bellows_link_lk :weight 169.374)
         (setq (bellows_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.3115912894148580e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.6941756794208821e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7444729278662701e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (bellows_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for bellows_link_lk
       (let ((world-cds (make-coords :pos (float-vector -8.6875000000000000e+01 0.0000000000000000e+00 3.7743000000000001e+02))
                        ))
         (send bellows_link_lk :transform world-cds))
       )

     ;; link: bellows_link2_lk
     (let ((geom-lst (list
                       (send self :_make_instance_bellows_link2_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq bellows_link2_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "bellows_link2"))
       ;; inertial parameter for bellows_link2_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.9132000028622794e+01 -1.7547745080721359e-13 -1.3486162544338697e+02)
                                   :rot (quaternion2matrix (float-vector 7.0710678108795899e-01 7.0710678108909353e-01 -1.1773826368840821e-05 -1.1773826364834692e-05)))
                      ))
         (send bellows_link2_lk :weight 169.374)
         (setq (bellows_link2_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 3.3115912894148580e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.6941756794208821e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.7444729278662701e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (bellows_link2_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for bellows_link2_lk
       (let ((world-cds (make-coords :pos (float-vector -8.6875000000000000e+01 0.0000000000000000e+00 3.7743000000000001e+02))
                        ))
         (send bellows_link2_lk :transform world-cds))
       )

     ;; link: head_pan_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_pan_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_pan_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_pan_link"))
       ;; inertial parameter for head_pan_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 3.2099999999999994e+01 1.6100000000000041e+01 3.8999999999999922e+01)
                                   :rot (quaternion2matrix (float-vector 9.9760911012504527e-01 -4.7692349121199309e-04 -6.2334443976991484e-02 -2.9837108331374068e-02)))
                      ))
         (send head_pan_link_lk :weight 2255.600)
         (setq (head_pan_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.2824154093896851e+07 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 9.4880843617810812e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.8487761544322066e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_pan_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_pan_link_lk
       (let ((world-cds (make-coords :pos (float-vector -3.3749999999999993e+01 0.0000000000000000e+00 9.8043141771393903e+02))
                        ))
         (send head_pan_link_lk :transform world-cds))
       )

     ;; link: head_tilt_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_head_tilt_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_tilt_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_tilt_link"))
       ;; inertial parameter for head_tilt_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 8.1000000000000103e+00 2.5000000000000409e+00 1.1300000000000088e+01)
                                   :rot (quaternion2matrix (float-vector 6.4676446756119577e-01 -6.6044386088863993e-01 -2.7288135731249935e-01 2.6654342037663920e-01)))
                      ))
         (send head_tilt_link_lk :weight 908.700)
         (setq (head_tilt_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 5.9011077527822489e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 6.3010227971924739e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.3978694500252779e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (head_tilt_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for head_tilt_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.0877999999999999e+02 0.0000000000000000e+00 1.0384304177139391e+03))
                        ))
         (send head_tilt_link_lk :transform world-cds))
       )

     ;; link: shoulder_pan_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_shoulder_pan_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq shoulder_pan_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "shoulder_pan_link"))
       ;; inertial parameter for shoulder_pan_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 9.2699999999999974e+01 -5.5999999999999748e+00 5.6400000000000006e+01)
                                   :rot (quaternion2matrix (float-vector 5.4139821062645066e-01 -8.3398517181196474e-01 -6.4844594722820295e-02 8.4568843337710767e-02)))
                      ))
         (send shoulder_pan_link_lk :weight 2558.700)
         (setq (shoulder_pan_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 4.0821205934237596e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.9693361939200163e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.6485432126562223e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (shoulder_pan_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for shoulder_pan_link_lk
       (let ((world-cds (make-coords :pos (float-vector 3.2650000000000013e+01 0.0000000000000000e+00 7.2600999999999999e+02))
                        ))
         (send shoulder_pan_link_lk :transform world-cds))
       )

     ;; link: head_camera_link_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_camera_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_camera_link"))
       (progn (send head_camera_link_lk :weight 0.0) (setq (head_camera_link_lk . acentroid) (float-vector 0 0 0)) (send head_camera_link_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_camera_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.6377999999999997e+02 0.0000000000000000e+00 1.0609304177139388e+03))
                        ))
         (send head_camera_link_lk :transform world-cds))
       )

     ;; link: head_camera_depth_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_camera_depth_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_camera_depth_frame"))
       (progn (send head_camera_depth_frame_lk :weight 0.0) (setq (head_camera_depth_frame_lk . acentroid) (float-vector 0 0 0)) (send head_camera_depth_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_camera_depth_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 1.6377999999999997e+02 4.5000000000000000e+01 1.0609304177139388e+03))
                        ))
         (send head_camera_depth_frame_lk :transform world-cds))
       )

     ;; link: head_camera_depth_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_camera_depth_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_camera_depth_optical_frame"))
       (progn (send head_camera_depth_optical_frame_lk :weight 0.0) (setq (head_camera_depth_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send head_camera_depth_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_camera_depth_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 1.6377999999999997e+02 4.5000000000000000e+01 1.0609304177139388e+03)
                                   :rot (quaternion2matrix (float-vector 5.0000000000244815e-01 -5.0000000000000011e-01 4.9999999999755174e-01 -5.0000000000000011e-01)))
                        ))
         (send head_camera_depth_optical_frame_lk :transform world-cds))
       )

     ;; link: head_camera_rgb_optical_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_camera_rgb_optical_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_camera_rgb_optical_frame"))
       (progn (send head_camera_rgb_optical_frame_lk :weight 0.0) (setq (head_camera_rgb_optical_frame_lk . acentroid) (float-vector 0 0 0)) (send head_camera_rgb_optical_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_camera_rgb_optical_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 1.6377999999999997e+02 2.0000000000000000e+01 1.0609304177139388e+03)
                                   :rot (quaternion2matrix (float-vector 5.0000000000244815e-01 -5.0000000000000011e-01 4.9999999999755174e-01 -5.0000000000000011e-01)))
                        ))
         (send head_camera_rgb_optical_frame_lk :transform world-cds))
       )

     ;; link: head_camera_rgb_frame_lk
     (let ((geom-lst (list
)))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq head_camera_rgb_frame_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "head_camera_rgb_frame"))
       (progn (send head_camera_rgb_frame_lk :weight 0.0) (setq (head_camera_rgb_frame_lk . acentroid) (float-vector 0 0 0)) (send head_camera_rgb_frame_lk :inertia-tensor #2f((0 0 0)(0 0 0)(0 0 0))))
       ;; global coordinates for head_camera_rgb_frame_lk
       (let ((world-cds (make-coords :pos (float-vector 1.6377999999999997e+02 2.0000000000000000e+01 1.0609304177139388e+03))
                        ))
         (send head_camera_rgb_frame_lk :transform world-cds))
       )

     ;; link: shoulder_lift_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_shoulder_lift_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq shoulder_lift_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "shoulder_lift_link"))
       ;; inertial parameter for shoulder_lift_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.4319999999999999e+02 7.2000000000000250e+00 -1.0000000000010001e-01)
                                   :rot (quaternion2matrix (float-vector 9.9315001174971607e-01 -3.0405287609717568e-17 -3.5772489947382882e-18 -1.1684628432919442e-01)))
                      ))
         (send shoulder_lift_link_lk :weight 2661.500)
         (setq (shoulder_lift_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.2989248554769619e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.1601075144523039e+07 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.1200000000000000e+07))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (shoulder_lift_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for shoulder_lift_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.4965000000000001e+02 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send shoulder_lift_link_lk :transform world-cds))
       )

     ;; link: upperarm_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_upperarm_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq upperarm_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "upperarm_roll_link"))
       ;; inertial parameter for upperarm_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.1649999999999999e+02 1.4000000000000250e+00 -1.1102230246251565e-13)
                                   :rot (quaternion2matrix (float-vector 9.9981582055117035e-01 -3.0609361346174080e-17 -5.8755678818656691e-19 -1.9191794485924119e-02)))
                      ))
         (send upperarm_roll_link_lk :weight 2331.100)
         (setq (upperarm_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.8961595189594701e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 4.5038404810405290e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 4.7000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (upperarm_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for upperarm_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 3.6865000000000003e+02 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send upperarm_roll_link_lk :transform world-cds))
       )

     ;; link: elbow_flex_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_elbow_flex_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq elbow_flex_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "elbow_flex_link"))
       ;; inertial parameter for elbow_flex_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.2789999999999991e+02 7.3000000000000256e+00 -1.1102230246251565e-13)
                                   :rot (quaternion2matrix (float-vector 9.9206728159918389e-01 -3.0372139826159010e-17 -3.8485513352747915e-18 -1.2570802989628591e-01)))
                      ))
         (send elbow_flex_link_lk :weight 2129.900)
         (setq (elbow_flex_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.9879009676641610e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 8.6120990323358402e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 8.4000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (elbow_flex_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for elbow_flex_link_lk
       (let ((world-cds (make-coords :pos (float-vector 5.0165000000000003e+02 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send elbow_flex_link_lk :transform world-cds))
       )

     ;; link: forearm_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_forearm_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq forearm_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "forearm_roll_link"))
       ;; inertial parameter for forearm_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 1.0970000000000002e+02 -2.6599999999999969e+01 -1.1102230246251565e-13)
                                   :rot (quaternion2matrix (float-vector 9.9488133031068815e-01 -3.0458291927461708e-17 -3.0936512184666988e-18 -1.0105017862050297e-01)))
                      ))
         (send forearm_roll_link_lk :weight 1656.300)
         (setq (forearm_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.5384226894136088e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 3.0615773105863910e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 3.5000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (forearm_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for forearm_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 6.9864999999999998e+02 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send forearm_roll_link_lk :transform world-cds))
       )

     ;; link: l_gripper_finger_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_l_gripper_finger_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq l_gripper_finger_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "l_gripper_finger_link"))
       ;; inertial parameter for l_gripper_finger_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.0000000000000009e+01 1.9081958235744878e-14 -1.1102230246251565e-13))
                      ))
         (send l_gripper_finger_link_lk :weight 79.800)
         (setq (l_gripper_finger_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (l_gripper_finger_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for l_gripper_finger_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.1281000000000001e+03 -1.5424999999999999e+01 7.8600999999999999e+02))
                        ))
         (send l_gripper_finger_link_lk :transform world-cds))
       )

     ;; link: r_gripper_finger_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_r_gripper_finger_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq r_gripper_finger_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "r_gripper_finger_link"))
       ;; inertial parameter for r_gripper_finger_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -1.0000000000000009e+01 2.0816681711721685e-14 -1.1102230246251565e-13))
                      ))
         (send r_gripper_finger_link_lk :weight 79.800)
         (setq (r_gripper_finger_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 2.0000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (r_gripper_finger_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for r_gripper_finger_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.1281000000000001e+03 1.5424999999999999e+01 7.8600999999999999e+02))
                        ))
         (send r_gripper_finger_link_lk :transform world-cds))
       )

     ;; link: wrist_flex_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_wrist_flex_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wrist_flex_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wrist_flex_link"))
       ;; inertial parameter for wrist_flex_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 8.8199999999999832e+01 9.0000000000002500e-01 -1.0000000000010001e-01)
                                   :rot (quaternion2matrix (float-vector 9.9978399326318534e-01 -3.0608386953752416e-17 -6.3629638483869283e-19 -2.0783811361708079e-02)))
                      ))
         (send wrist_flex_link_lk :weight 1725.000)
         (setq (wrist_flex_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.7958405421207701e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 4.2041594578792294e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 4.2000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (wrist_flex_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for wrist_flex_link_lk
       (let ((world-cds (make-coords :pos (float-vector 8.2315000000000009e+02 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send wrist_flex_link_lk :transform world-cds))
       )

     ;; link: wrist_roll_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_wrist_roll_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq wrist_roll_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "wrist_roll_link"))
       ;; inertial parameter for wrist_roll_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector 9.4999999999997300e+00 4.0000000000002500e-01 -2.0000000000008900e-01))
                      ))
         (send wrist_roll_link_lk :weight 135.400)
         (setq (wrist_roll_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.0000000000000000e+05 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.0000000000000000e+05 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+05))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (wrist_roll_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for wrist_roll_link_lk
       (let ((world-cds (make-coords :pos (float-vector 9.6165000000000009e+02 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send wrist_roll_link_lk :transform world-cds))
       )

     ;; link: gripper_link_lk
     (let ((geom-lst (list
                       (send self :_make_instance_gripper_link_geom0))))
       (dolist (g (cdr geom-lst)) (send (car geom-lst) :assoc g))
       (setq gripper_link_lk
             (instance bodyset-link
                       :init (make-cascoords)
                       :bodies geom-lst
                       :name "gripper_link"))
       ;; inertial parameter for gripper_link_lk
       (let ((tmp-cds (make-coords :pos (float-vector -9.0000000000000085e+01 -9.9999999999975095e-02 -1.7000000000001458e+00))
                      ))
         (send gripper_link_lk :weight 1517.500)
         (setq (gripper_link_lk . inertia-tensor)
               (m* (m* (send tmp-cds :worldrot) (matrix
                                                  (float-vector 1.3000000000000000e+06 0.0000000000000000e+00 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 1.9000000000000000e+06 0.0000000000000000e+00)
                                                  (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 2.4000000000000000e+06))
                 ) (transpose (send tmp-cds :worldrot))))
         (setq (gripper_link_lk . acentroid) (copy-seq (send tmp-cds :worldpos)))
         )
       ;; global coordinates for gripper_link_lk
       (let ((world-cds (make-coords :pos (float-vector 1.1281000000000001e+03 0.0000000000000000e+00 7.8600999999999999e+02))
                        ))
         (send gripper_link_lk :transform world-cds))
       )

     (send torso_lift_link_lk :assoc bellows_link_lk)
     (send torso_lift_link_lk :assoc bellows_link2_lk)
     (send upperarm_roll_link_lk :assoc elbow_flex_link_lk)
     (send base_link_lk :assoc estop_link_lk)
     (send elbow_flex_link_lk :assoc forearm_roll_link_lk)
     (send wrist_roll_link_lk :assoc gripper_link_lk)
     (send head_camera_link_lk :assoc head_camera_depth_frame_lk)
     (send head_camera_depth_frame_lk :assoc head_camera_depth_optical_frame_lk)
     (send head_tilt_link_lk :assoc head_camera_link_lk)
     (send head_camera_link_lk :assoc head_camera_rgb_frame_lk)
     (send head_camera_rgb_frame_lk :assoc head_camera_rgb_optical_frame_lk)
     (send torso_lift_link_lk :assoc head_pan_link_lk)
     (send head_pan_link_lk :assoc head_tilt_link_lk)
     (send gripper_link_lk :assoc l_gripper_finger_link_lk)
     (send base_link_lk :assoc l_wheel_link_lk)
     (send base_link_lk :assoc laser_link_lk)
     (send gripper_link_lk :assoc r_gripper_finger_link_lk)
     (send base_link_lk :assoc r_wheel_link_lk)
     (send shoulder_pan_link_lk :assoc shoulder_lift_link_lk)
     (send torso_lift_link_lk :assoc shoulder_pan_link_lk)
     (send base_link_lk :assoc torso_fixed_link_lk)
     (send base_link_lk :assoc torso_lift_link_lk)
     (send shoulder_lift_link_lk :assoc upperarm_roll_link_lk)
     (send forearm_roll_link_lk :assoc wrist_flex_link_lk)
     (send wrist_flex_link_lk :assoc wrist_roll_link_lk)
     (send self :assoc base_link_lk)

     ;; joint models
     ;; joint: bellows_joint_jt
     (setq bellows_joint_jt
           (instance linear-joint :init
                     :name "bellows_joint"
                     :parent-link torso_lift_link_lk :child-link bellows_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 -1.0000000000000000e+00)
                     :min 0.000000 :max 400.000000
                     :max-joint-velocity 0.100000
                     :max-joint-torque 5.000000
                     ))
     ;; joint: bellows_joint2_fixed_jt
     (setq bellows_joint2_fixed_jt
           (instance rotational-joint :init
                     :name "bellows_joint2"
                     :parent-link torso_lift_link_lk :child-link bellows_link2_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: elbow_flex_joint_jt
     (setq elbow_flex_joint_jt
           (instance rotational-joint :init
                     :name "elbow_flex_joint"
                     :parent-link upperarm_roll_link_lk :child-link elbow_flex_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -128.972796 :max 128.972796
                     :max-joint-velocity 1.521000
                     :max-joint-torque 66.180000
                     ))
     ;; joint: estop_joint_fixed_jt
     (setq estop_joint_fixed_jt
           (instance rotational-joint :init
                     :name "estop_joint"
                     :parent-link base_link_lk :child-link estop_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: forearm_roll_joint_jt
     (setq forearm_roll_joint_jt
           (instance rotational-joint :init
                     :name "forearm_roll_joint"
                     :parent-link elbow_flex_link_lk :child-link forearm_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 1.571000
                     :max-joint-torque 29.350000
                     ))
     ;; joint: gripper_axis_fixed_jt
     (setq gripper_axis_fixed_jt
           (instance rotational-joint :init
                     :name "gripper_axis"
                     :parent-link wrist_roll_link_lk :child-link gripper_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_camera_depth_joint_fixed_jt
     (setq head_camera_depth_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_camera_depth_joint"
                     :parent-link head_camera_link_lk :child-link head_camera_depth_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_camera_depth_optical_joint_fixed_jt
     (setq head_camera_depth_optical_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_camera_depth_optical_joint"
                     :parent-link head_camera_depth_frame_lk :child-link head_camera_depth_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_camera_joint_fixed_jt
     (setq head_camera_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_camera_joint"
                     :parent-link head_tilt_link_lk :child-link head_camera_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_camera_rgb_joint_fixed_jt
     (setq head_camera_rgb_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_camera_rgb_joint"
                     :parent-link head_camera_link_lk :child-link head_camera_rgb_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_camera_rgb_optical_joint_fixed_jt
     (setq head_camera_rgb_optical_joint_fixed_jt
           (instance rotational-joint :init
                     :name "head_camera_rgb_optical_joint"
                     :parent-link head_camera_rgb_frame_lk :child-link head_camera_rgb_optical_frame_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: head_pan_joint_jt
     (setq head_pan_joint_jt
           (instance rotational-joint :init
                     :name "head_pan_joint"
                     :parent-link torso_lift_link_lk :child-link head_pan_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -89.954377 :max 89.954377
                     :max-joint-velocity 1.570000
                     :max-joint-torque 0.320000
                     ))
     ;; joint: head_tilt_joint_jt
     (setq head_tilt_joint_jt
           (instance rotational-joint :init
                     :name "head_tilt_joint"
                     :parent-link head_pan_link_lk :child-link head_tilt_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -43.544792 :max 83.078883
                     :max-joint-velocity 1.570000
                     :max-joint-torque 0.680000
                     ))
     ;; joint: l_gripper_finger_joint_jt
     (setq l_gripper_finger_joint_jt
           (instance linear-joint :init
                     :name "l_gripper_finger_joint"
                     :parent-link gripper_link_lk :child-link l_gripper_finger_link_lk
                     :axis (float-vector 0.0000000000000000e+00 -1.0000000000000000e+00 0.0000000000000000e+00)
                     :min 0.000000 :max 50.000000
                     :max-joint-velocity 0.050000
                     :max-joint-torque 60.000000
                     ))
     ;; joint: l_wheel_joint_jt
     (setq l_wheel_joint_jt
           (instance rotational-joint :init
                     :name "l_wheel_joint"
                     :parent-link base_link_lk :child-link l_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 17.400000
                     :max-joint-torque 8.850000
                     ))
     ;; joint: laser_joint_fixed_jt
     (setq laser_joint_fixed_jt
           (instance rotational-joint :init
                     :name "laser_joint"
                     :parent-link base_link_lk :child-link laser_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: r_gripper_finger_joint_jt
     (setq r_gripper_finger_joint_jt
           (instance linear-joint :init
                     :name "r_gripper_finger_joint"
                     :parent-link gripper_link_lk :child-link r_gripper_finger_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min 0.000000 :max 50.000000
                     :max-joint-velocity 0.050000
                     :max-joint-torque 60.000000
                     ))
     ;; joint: r_wheel_joint_jt
     (setq r_wheel_joint_jt
           (instance rotational-joint :init
                     :name "r_wheel_joint"
                     :parent-link base_link_lk :child-link r_wheel_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 17.400000
                     :max-joint-torque 8.850000
                     ))
     ;; joint: shoulder_lift_joint_jt
     (setq shoulder_lift_joint_jt
           (instance rotational-joint :init
                     :name "shoulder_lift_joint"
                     :parent-link shoulder_pan_link_lk :child-link shoulder_lift_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -69.958144 :max 86.974994
                     :max-joint-velocity 1.454000
                     :max-joint-torque 131.760000
                     ))
     ;; joint: shoulder_pan_joint_jt
     (setq shoulder_pan_joint_jt
           (instance rotational-joint :init
                     :name "shoulder_pan_joint"
                     :parent-link torso_lift_link_lk :child-link shoulder_pan_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min -91.994104 :max 91.994104
                     :max-joint-velocity 1.256000
                     :max-joint-torque 33.820000
                     ))
     ;; joint: torso_fixed_joint_fixed_jt
     (setq torso_fixed_joint_fixed_jt
           (instance rotational-joint :init
                     :name "torso_fixed_joint"
                     :parent-link base_link_lk :child-link torso_fixed_link_lk
                     :axis (float-vector 1 1 1) ;; fixed joint??
                     :min 0.000000 :max 0.000000
                     :max-joint-velocity 0.500000
                     :max-joint-torque 0.000000
                     ))
     ;; joint: torso_lift_joint_jt
     (setq torso_lift_joint_jt
           (instance linear-joint :init
                     :name "torso_lift_joint"
                     :parent-link base_link_lk :child-link torso_lift_link_lk
                     :axis (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00)
                     :min 0.000000 :max 386.149994
                     :max-joint-velocity 0.100000
                     :max-joint-torque 450.000000
                     ))
     ;; joint: upperarm_roll_joint_jt
     (setq upperarm_roll_joint_jt
           (instance rotational-joint :init
                     :name "upperarm_roll_joint"
                     :parent-link shoulder_lift_link_lk :child-link upperarm_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 1.571000
                     :max-joint-torque 76.940000
                     ))
     ;; joint: wrist_flex_joint_jt
     (setq wrist_flex_joint_jt
           (instance rotational-joint :init
                     :name "wrist_flex_joint"
                     :parent-link forearm_roll_link_lk :child-link wrist_flex_link_lk
                     :axis (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00)
                     :min -123.758889 :max 123.758889
                     :max-joint-velocity 2.268000
                     :max-joint-torque 25.700000
                     ))
     ;; joint: wrist_roll_joint_jt
     (setq wrist_roll_joint_jt
           (instance rotational-joint :init
                     :name "wrist_roll_joint"
                     :parent-link wrist_flex_link_lk :child-link wrist_roll_link_lk
                     :axis (float-vector 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)
                                          :min *-inf* :max *inf*
                     :max-joint-velocity 2.268000
                     :max-joint-torque 7.360000
                     ))
     ;; end coords from yaml file
     (setq torso-end-coords (make-cascoords :coords (send torso_lift_link_lk :copy-worldcoords) :name :torso-end-coords))
     (send torso_lift_link_lk :assoc torso-end-coords)
     (setq rarm-end-coords (make-cascoords :coords (send gripper_link_lk :copy-worldcoords) :name :rarm-end-coords))
     (send rarm-end-coords :translate (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))
     (send rarm-end-coords :rotate 0.0000000000000000e+00 (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 1.0000000000000000e+00))
     (send gripper_link_lk :assoc rarm-end-coords)
     (setq head-end-coords (make-cascoords :coords (send head_tilt_link_lk :copy-worldcoords) :name :head-end-coords))
     (send head-end-coords :translate (float-vector 6.0000000000000000e+01 0.0000000000000000e+00 2.5000000000000000e+01))
     (send head-end-coords :rotate 1.5707963267948966e+00 (float-vector 0.0000000000000000e+00 1.0000000000000000e+00 0.0000000000000000e+00))
     (send head_tilt_link_lk :assoc head-end-coords)

     ;; limbs
     (setq torso (list torso_lift_link_lk))

     (setq torso-root-link
           (labels ((find-parent (l) (if (find (send l :parent) torso) (find-parent (send l :parent)) l)))
             (find-parent (car torso))))
     (setq rarm (list shoulder_pan_link_lk shoulder_lift_link_lk upperarm_roll_link_lk elbow_flex_link_lk forearm_roll_link_lk wrist_flex_link_lk wrist_roll_link_lk))

     (setq rarm-root-link
           (labels ((find-parent (l) (if (find (send l :parent) rarm) (find-parent (send l :parent)) l)))
             (find-parent (car rarm))))
     (setq head (list head_pan_link_lk head_tilt_link_lk))

     (setq head-root-link
           (labels ((find-parent (l) (if (find (send l :parent) head) (find-parent (send l :parent)) l)))
             (find-parent (car head))))

     ;; links
     (setq links (list base_link_lk torso_lift_link_lk shoulder_pan_link_lk shoulder_lift_link_lk upperarm_roll_link_lk elbow_flex_link_lk forearm_roll_link_lk wrist_flex_link_lk wrist_roll_link_lk head_pan_link_lk head_tilt_link_lk))

     ;; joint-list
     (setq joint-list (list torso_lift_joint_jt shoulder_pan_joint_jt shoulder_lift_joint_jt upperarm_roll_joint_jt elbow_flex_joint_jt forearm_roll_joint_jt wrist_flex_joint_jt wrist_roll_joint_jt head_pan_joint_jt head_tilt_joint_jt))

     ;; sensor-coords

     ;; attach_sensor lists
     (setq force-sensors (list ))
     (setq imu-sensors (list ))
     (setq cameras (list ))

     ;; init-ending
     (send self :init-ending) ;; :urdf

     ;; overwrite bodies to return draw-things links not (send link :bodies)
     (setq bodies (flatten (mapcar #'(lambda (b) (if (find-method b :bodies) (send b :bodies))) (list base_link_lk bellows_link_lk bellows_link2_lk elbow_flex_link_lk estop_link_lk forearm_roll_link_lk gripper_link_lk head_camera_depth_frame_lk head_camera_depth_optical_frame_lk head_camera_link_lk head_camera_rgb_frame_lk head_camera_rgb_optical_frame_lk head_pan_link_lk head_tilt_link_lk l_gripper_finger_link_lk l_wheel_link_lk laser_link_lk r_gripper_finger_link_lk r_wheel_link_lk shoulder_lift_link_lk shoulder_pan_link_lk torso_fixed_link_lk torso_lift_link_lk upperarm_roll_link_lk wrist_flex_link_lk wrist_roll_link_lk))))

     (when (member :reset-pose (send self :methods))           (send self :reset-pose)) ;; :set reset-pose

     self)) ;; end of :init

  ;; pre-defined pose methods

    (:reset-pose (&optional (limbs '(:torso :rarm :head)))
      "Predefined pose named reset-pose."
      (unless (listp limbs) (setq limbs (list limbs)))
      (dolist (limb limbs)
        (case limb
          (:torso (send self limb :angle-vector (float-vector 20.000000)))
          (:rarm (send self limb :angle-vector (float-vector 75.630400 80.214100 -11.459200 98.548700 0.000000 95.111000 0.000000)))
          (:head (send self limb :angle-vector (float-vector 0.000000 0.000000)))
          (t (format t "Unknown limb is passed: ~a~%" limb))))
      (send self :angle-vector))
  ;; all joints
  (:bellows_joint (&rest args) (forward-message-to bellows_joint_jt args))
  (:bellows_joint2 (&rest args) (forward-message-to bellows_joint2_fixed_jt args))
  (:elbow_flex_joint (&rest args) (forward-message-to elbow_flex_joint_jt args))
  (:estop_joint (&rest args) (forward-message-to estop_joint_fixed_jt args))
  (:forearm_roll_joint (&rest args) (forward-message-to forearm_roll_joint_jt args))
  (:gripper_axis (&rest args) (forward-message-to gripper_axis_fixed_jt args))
  (:head_camera_depth_joint (&rest args) (forward-message-to head_camera_depth_joint_fixed_jt args))
  (:head_camera_depth_optical_joint (&rest args) (forward-message-to head_camera_depth_optical_joint_fixed_jt args))
  (:head_camera_joint (&rest args) (forward-message-to head_camera_joint_fixed_jt args))
  (:head_camera_rgb_joint (&rest args) (forward-message-to head_camera_rgb_joint_fixed_jt args))
  (:head_camera_rgb_optical_joint (&rest args) (forward-message-to head_camera_rgb_optical_joint_fixed_jt args))
  (:head_pan_joint (&rest args) (forward-message-to head_pan_joint_jt args))
  (:head_tilt_joint (&rest args) (forward-message-to head_tilt_joint_jt args))
  (:l_gripper_finger_joint (&rest args) (forward-message-to l_gripper_finger_joint_jt args))
  (:l_wheel_joint (&rest args) (forward-message-to l_wheel_joint_jt args))
  (:laser_joint (&rest args) (forward-message-to laser_joint_fixed_jt args))
  (:r_gripper_finger_joint (&rest args) (forward-message-to r_gripper_finger_joint_jt args))
  (:r_wheel_joint (&rest args) (forward-message-to r_wheel_joint_jt args))
  (:shoulder_lift_joint (&rest args) (forward-message-to shoulder_lift_joint_jt args))
  (:shoulder_pan_joint (&rest args) (forward-message-to shoulder_pan_joint_jt args))
  (:torso_fixed_joint (&rest args) (forward-message-to torso_fixed_joint_fixed_jt args))
  (:torso_lift_joint (&rest args) (forward-message-to torso_lift_joint_jt args))
  (:upperarm_roll_joint (&rest args) (forward-message-to upperarm_roll_joint_jt args))
  (:wrist_flex_joint (&rest args) (forward-message-to wrist_flex_joint_jt args))
  (:wrist_roll_joint (&rest args) (forward-message-to wrist_roll_joint_jt args))

  ;; all links forwarding
  (:links (&rest args)
   (if (null args) (return-from :links (send-super :links)))
   (let ((key (car args))
           (nargs (cdr args)))
     (unless (keywordp key)
         (return-from :links (send-super* :links args)))
       (case key
       (:base_link (forward-message-to base_link_lk nargs))
       (:bellows_link (forward-message-to bellows_link_lk nargs))
       (:bellows_link2 (forward-message-to bellows_link2_lk nargs))
       (:elbow_flex_link (forward-message-to elbow_flex_link_lk nargs))
       (:estop_link (forward-message-to estop_link_lk nargs))
       (:forearm_roll_link (forward-message-to forearm_roll_link_lk nargs))
       (:gripper_link (forward-message-to gripper_link_lk nargs))
       (:head_camera_depth_frame (forward-message-to head_camera_depth_frame_lk nargs))
       (:head_camera_depth_optical_frame (forward-message-to head_camera_depth_optical_frame_lk nargs))
       (:head_camera_link (forward-message-to head_camera_link_lk nargs))
       (:head_camera_rgb_frame (forward-message-to head_camera_rgb_frame_lk nargs))
       (:head_camera_rgb_optical_frame (forward-message-to head_camera_rgb_optical_frame_lk nargs))
       (:head_pan_link (forward-message-to head_pan_link_lk nargs))
       (:head_tilt_link (forward-message-to head_tilt_link_lk nargs))
       (:l_gripper_finger_link (forward-message-to l_gripper_finger_link_lk nargs))
       (:l_wheel_link (forward-message-to l_wheel_link_lk nargs))
       (:laser_link (forward-message-to laser_link_lk nargs))
       (:r_gripper_finger_link (forward-message-to r_gripper_finger_link_lk nargs))
       (:r_wheel_link (forward-message-to r_wheel_link_lk nargs))
       (:shoulder_lift_link (forward-message-to shoulder_lift_link_lk nargs))
       (:shoulder_pan_link (forward-message-to shoulder_pan_link_lk nargs))
       (:torso_fixed_link (forward-message-to torso_fixed_link_lk nargs))
       (:torso_lift_link (forward-message-to torso_lift_link_lk nargs))
       (:upperarm_roll_link (forward-message-to upperarm_roll_link_lk nargs))
       (:wrist_flex_link (forward-message-to wrist_flex_link_lk nargs))
       (:wrist_roll_link (forward-message-to wrist_roll_link_lk nargs))
       (t (send-super* :links args)))))

  ;; all links
  (:base_link_lk (&rest args) (forward-message-to base_link_lk args))
  (:bellows_link_lk (&rest args) (forward-message-to bellows_link_lk args))
  (:bellows_link2_lk (&rest args) (forward-message-to bellows_link2_lk args))
  (:elbow_flex_link_lk (&rest args) (forward-message-to elbow_flex_link_lk args))
  (:estop_link_lk (&rest args) (forward-message-to estop_link_lk args))
  (:forearm_roll_link_lk (&rest args) (forward-message-to forearm_roll_link_lk args))
  (:gripper_link_lk (&rest args) (forward-message-to gripper_link_lk args))
  (:head_camera_depth_frame_lk (&rest args) (forward-message-to head_camera_depth_frame_lk args))
  (:head_camera_depth_optical_frame_lk (&rest args) (forward-message-to head_camera_depth_optical_frame_lk args))
  (:head_camera_link_lk (&rest args) (forward-message-to head_camera_link_lk args))
  (:head_camera_rgb_frame_lk (&rest args) (forward-message-to head_camera_rgb_frame_lk args))
  (:head_camera_rgb_optical_frame_lk (&rest args) (forward-message-to head_camera_rgb_optical_frame_lk args))
  (:head_pan_link_lk (&rest args) (forward-message-to head_pan_link_lk args))
  (:head_tilt_link_lk (&rest args) (forward-message-to head_tilt_link_lk args))
  (:l_gripper_finger_link_lk (&rest args) (forward-message-to l_gripper_finger_link_lk args))
  (:l_wheel_link_lk (&rest args) (forward-message-to l_wheel_link_lk args))
  (:laser_link_lk (&rest args) (forward-message-to laser_link_lk args))
  (:r_gripper_finger_link_lk (&rest args) (forward-message-to r_gripper_finger_link_lk args))
  (:r_wheel_link_lk (&rest args) (forward-message-to r_wheel_link_lk args))
  (:shoulder_lift_link_lk (&rest args) (forward-message-to shoulder_lift_link_lk args))
  (:shoulder_pan_link_lk (&rest args) (forward-message-to shoulder_pan_link_lk args))
  (:torso_fixed_link_lk (&rest args) (forward-message-to torso_fixed_link_lk args))
  (:torso_lift_link_lk (&rest args) (forward-message-to torso_lift_link_lk args))
  (:upperarm_roll_link_lk (&rest args) (forward-message-to upperarm_roll_link_lk args))
  (:wrist_flex_link_lk (&rest args) (forward-message-to wrist_flex_link_lk args))
  (:wrist_roll_link_lk (&rest args) (forward-message-to wrist_roll_link_lk args))

  ;; user-defined joint
  (:torso-waist-z (&rest args) (forward-message-to torso_lift_joint_jt args))
  (:rarm-shoulder-y (&rest args) (forward-message-to shoulder_pan_joint_jt args))
  (:rarm-shoulder-p (&rest args) (forward-message-to shoulder_lift_joint_jt args))
  (:rarm-shoulder-r (&rest args) (forward-message-to upperarm_roll_joint_jt args))
  (:rarm-elbow-p (&rest args) (forward-message-to elbow_flex_joint_jt args))
  (:rarm-elbow-r (&rest args) (forward-message-to forearm_roll_joint_jt args))
  (:rarm-wrist-p (&rest args) (forward-message-to wrist_flex_joint_jt args))
  (:rarm-wrist-r (&rest args) (forward-message-to wrist_roll_joint_jt args))
  (:head-neck-y (&rest args) (forward-message-to head_pan_joint_jt args))
  (:head-neck-p (&rest args) (forward-message-to head_tilt_joint_jt args))

  ;; attach_sensor methods

  ;; geometries
  (:_make_instance_l_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.2914000000000001e+00 1.8738000000000000e+02 5.5324999999999996e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 7 8 0 0 8 9 0 9 1 481 7 0 481 0 482 482 0 2 7 6 8 6 465 8 8 465 454 8 454 9 9 454 455 9 455 1 454 417 455 465 419 454 454 419 418 454 418 417 464 420 465 465 420 419 6 464 465 411 418 419 411 419 410 410 419 420 412 417 418 412 418 411 410 58 411 411 58 60 411 60 412 409 56 410 410 56 58 410 420 409 409 420 421 464 421 420 408 54 409 409 54 56 409 421 408 54 55 56 56 55 57 56 57 58 52 53 54 54 53 55 408 52 54 407 52 408 408 421 422 408 422 407 422 421 464 407 422 423 463 423 422 463 422 464 406 50 407 407 50 52 407 423 406 406 423 424 462 424 423 462 423 463 18 462 463 18 463 19 19 463 464 19 464 6 5 18 19 5 19 6 17 16 18 17 18 5 16 462 18 458 424 462 16 458 462 15 16 17 15 22 16 22 458 16 478 15 17 478 17 479 479 17 5 20 21 15 15 21 22 477 20 15 477 15 478 21 457 22 22 457 458 20 32 21 32 456 21 21 456 457 456 427 457 457 427 426 457 426 458 467 429 456 456 429 428 456 428 427 32 467 456 20 31 32 31 467 32 466 430 467 467 430 429 31 466 467 390 428 429 390 429 389 389 429 430 391 427 428 391 428 390 389 108 390 390 108 38 390 38 391 388 106 389 389 106 108 389 430 388 388 430 431 466 431 430 387 104 388 388 104 106 388 431 387 104 105 106 106 105 107 106 107 108 102 103 104 104 103 105 387 102 104 386 102 387 387 431 432 387 432 386 466 432 431 386 432 433 468 433 432 468 432 466 385 100 386 386 100 102 386 433 385 385 433 434 461 434 433 461 433 468 28 461 468 28 468 29 29 468 466 29 466 31 14 28 29 14 29 30 30 29 31 13 28 14 13 461 28 12 13 14 474 12 14 474 14 475 475 14 30 30 31 20 475 30 476 476 30 20 469 474 475 469 475 476 473 12 474 471 473 474 471 474 469 472 10 473 473 10 12 472 473 471 469 23 471 471 23 25 471 25 472 472 25 10 10 11 12 25 26 10 10 26 27 10 27 11 23 24 25 25 24 26 24 452 26 26 452 453 26 453 27 27 453 459 27 459 11 452 439 453 439 438 453 453 438 437 453 437 459 451 440 452 452 440 439 24 451 452 380 438 439 380 439 402 402 439 440 381 437 438 381 438 380 382 436 437 382 437 381 459 437 436 380 90 381 381 90 92 381 92 382 382 92 94 382 94 383 383 436 382 383 435 436 459 436 460 460 436 435 383 94 96 383 96 384 384 435 383 384 434 435 460 435 461 435 434 461 11 459 460 11 460 13 13 460 461 12 11 13 385 434 384 384 96 98 384 98 385 385 98 100 96 97 98 98 97 99 98 99 100 100 99 101 100 101 102 115 101 99 115 99 116 116 99 97 96 95 97 116 97 117 117 97 95 169 115 116 169 116 170 170 116 117 117 95 118 170 117 171 171 117 118 94 93 95 94 95 96 118 95 93 118 93 119 171 118 172 172 118 119 172 209 171 171 209 210 171 210 170 172 119 173 173 208 172 172 208 209 119 93 91 119 91 120 173 119 120 173 120 174 174 207 173 173 207 208 207 242 208 208 242 243 208 243 209 174 206 207 206 241 207 207 241 242 174 120 121 174 121 175 175 206 174 175 205 206 205 240 206 206 240 241 265 242 241 265 241 240 205 239 240 265 240 266 266 240 239 176 204 205 176 205 175 204 239 205 175 121 122 175 122 176 176 122 123 176 123 177 177 204 176 177 203 204 203 238 204 204 238 239 177 123 124 177 124 178 178 203 177 122 85 123 123 85 83 123 83 124 124 83 81 124 81 125 178 124 125 178 125 179 179 202 178 178 202 203 125 81 79 125 79 126 179 125 126 80 79 81 80 81 82 82 81 83 78 77 79 78 79 80 126 79 77 126 77 127 179 126 145 145 126 127 76 75 77 76 77 78 127 77 75 398 76 78 398 78 399 399 78 80 74 75 76 397 74 76 397 76 398 74 73 75 127 75 128 128 75 73 72 73 74 396 72 74 396 74 397 398 444 397 397 444 445 397 445 396 395 72 396 396 413 395 396 445 413 70 71 72 72 71 73 395 70 72 394 70 395 395 413 414 395 414 394 447 414 413 447 413 448 448 413 445 394 414 415 446 414 447 446 415 414 393 68 394 394 68 70 394 415 393 393 415 416 446 416 415 455 416 446 1 455 446 1 446 3 3 446 447 393 416 392 392 416 417 455 417 416 392 66 393 393 66 68 412 62 392 392 62 64 392 64 66 392 417 412 64 65 66 66 65 67 66 67 68 62 63 64 64 63 65 60 61 62 62 61 63 412 60 62 133 65 63 133 63 134 134 63 61 132 67 65 132 65 133 151 132 133 151 133 152 152 133 134 134 61 135 152 134 153 153 134 135 60 59 61 135 61 59 58 59 60 58 57 59 135 59 136 136 59 57 153 135 154 154 135 136 154 192 153 153 192 193 153 193 152 154 136 155 155 191 154 154 191 192 136 57 137 155 136 137 137 57 55 137 55 138 155 137 156 156 137 138 156 190 155 155 190 191 190 225 191 191 225 226 191 226 192 156 189 190 189 224 190 190 224 225 156 138 157 157 189 156 157 188 189 188 223 189 189 223 224 257 225 224 257 224 258 258 224 223 188 222 223 258 223 259 259 223 222 158 187 188 158 188 157 187 222 188 187 221 222 259 222 260 260 222 221 260 305 259 259 305 306 259 306 258 260 221 261 261 304 260 260 304 305 186 220 221 186 221 187 261 221 220 261 220 262 262 303 261 261 303 304 328 305 304 328 304 318 318 304 303 262 302 303 318 303 302 262 220 219 262 219 263 263 302 262 185 219 220 185 220 186 184 218 219 184 219 185 263 219 218 263 218 264 264 301 263 263 301 302 318 302 319 319 302 301 264 300 301 319 301 320 301 300 320 264 218 217 264 217 252 252 300 264 183 217 218 183 218 184 182 216 217 182 217 183 252 217 216 163 182 183 163 183 162 162 183 184 164 181 182 164 182 163 181 216 182 181 251 216 252 216 251 180 181 164 180 251 181 163 110 164 164 110 111 164 111 165 165 180 164 165 215 180 215 250 180 180 250 251 252 251 250 215 249 250 252 250 253 253 250 277 277 250 249 166 214 215 166 215 165 214 249 215 214 248 249 277 249 278 278 249 248 278 297 277 277 297 298 277 298 253 253 298 299 253 299 252 333 299 298 333 298 334 298 297 334 278 296 297 334 297 296 278 248 279 279 296 278 279 295 296 334 296 337 337 296 295 355 333 334 355 334 356 356 334 337 337 295 338 356 337 357 357 337 338 280 294 295 280 295 279 338 295 294 338 294 339 357 338 358 358 338 339 377 356 357 377 357 358 379 355 356 379 356 377 377 358 378 486 379 377 486 377 487 487 377 378 358 339 359 378 358 359 378 359 375 487 378 488 488 378 375 487 488 486 485 379 486 486 488 489 486 489 485 488 375 489 375 361 376 375 359 360 375 360 361 489 375 376 359 339 340 359 340 360 360 340 335 360 335 361 361 335 336 361 336 362 376 361 362 335 289 336 340 291 335 335 291 290 335 290 289 339 292 340 340 292 291 284 290 291 284 291 283 283 291 292 265 289 290 265 290 284 283 243 284 284 243 242 284 242 265 282 244 283 283 244 243 283 292 282 282 292 293 339 293 292 281 245 282 282 245 244 282 293 281 209 243 244 209 244 210 210 244 245 210 245 211 211 245 246 281 246 245 280 246 281 281 293 294 281 294 280 294 293 339 279 247 280 280 247 246 211 246 212 212 246 247 212 247 213 213 247 248 279 248 247 169 211 212 169 212 168 168 212 213 168 213 167 167 213 214 213 248 214 167 114 168 168 114 115 168 115 169 170 211 169 170 210 211 114 101 115 113 103 114 114 103 101 167 113 114 102 101 103 113 105 103 112 105 113 166 112 113 166 113 167 112 107 105 111 107 112 165 111 112 165 112 166 167 214 166 110 109 111 111 109 107 108 107 109 108 109 38 38 109 39 110 39 109 41 39 110 144 41 110 163 144 110 38 39 40 40 39 41 38 40 391 40 41 42 391 40 42 42 41 43 144 43 41 143 43 144 162 143 144 162 144 163 42 43 44 44 43 45 143 45 43 391 42 403 403 42 44 403 427 391 403 44 404 404 426 403 403 426 427 44 45 46 404 44 46 46 45 47 142 47 45 142 45 143 46 47 48 404 46 405 405 46 48 405 425 404 404 425 426 426 425 458 405 424 425 458 425 424 405 48 406 406 424 405 48 47 49 48 49 50 406 48 50 50 49 51 140 51 49 140 49 141 141 49 47 50 51 52 52 51 53 139 53 51 139 51 140 158 139 140 158 140 159 159 140 141 138 53 139 157 138 139 157 139 158 138 55 53 159 187 158 159 141 160 160 186 159 159 186 187 160 141 142 160 142 161 161 185 160 160 185 186 141 47 142 161 142 143 161 143 162 162 184 161 161 184 185 266 289 265 266 239 267 267 288 266 266 288 289 336 289 288 267 287 288 336 288 330 330 288 287 267 239 238 267 238 268 268 287 267 268 286 287 330 287 286 330 286 331 362 336 330 362 330 363 363 330 331 269 285 286 269 286 268 331 286 285 268 238 237 268 237 269 203 237 238 202 236 237 202 237 203 269 237 236 269 236 270 270 285 269 270 317 285 331 285 332 332 285 317 270 236 235 270 235 271 271 317 270 201 235 236 201 236 202 179 201 202 145 200 201 145 201 179 200 235 201 200 234 235 271 235 234 271 234 272 272 316 271 271 316 317 199 233 234 199 234 200 272 234 233 146 199 200 146 200 145 145 127 146 146 127 128 146 128 147 147 199 146 147 198 199 198 233 199 198 232 233 272 233 273 273 233 232 148 197 198 148 198 147 197 232 198 147 128 129 147 129 148 128 73 129 129 73 71 129 71 130 148 129 130 148 130 149 149 197 148 149 196 197 196 231 197 197 231 232 149 130 131 149 131 150 150 196 149 130 71 69 130 69 131 70 69 71 68 67 69 68 69 70 131 69 67 131 67 132 150 131 132 150 132 151 151 195 150 150 195 196 152 194 151 151 194 195 194 229 195 195 229 230 195 230 196 152 193 194 193 228 194 194 228 229 276 230 229 276 229 254 254 229 228 196 230 231 275 231 230 275 230 276 254 311 276 276 311 312 276 312 275 274 231 275 275 312 313 275 313 274 274 232 231 273 232 274 274 313 314 274 314 273 314 313 327 327 313 312 327 312 329 329 312 311 326 314 327 344 326 327 344 327 345 345 327 329 273 314 315 326 315 314 273 315 272 272 315 316 325 315 326 325 316 315 343 325 326 343 326 344 332 317 325 325 317 316 342 332 325 342 325 343 370 343 371 371 343 344 370 342 343 341 332 342 370 341 342 341 331 332 363 331 341 374 341 370 374 363 341 491 374 370 491 370 492 492 370 371 376 362 374 374 362 363 490 376 374 490 374 491 489 376 490 489 490 499 491 497 490 490 497 498 490 498 499 485 489 499 498 366 499 499 366 365 499 365 485 497 367 498 498 367 366 353 365 366 353 366 352 352 366 367 364 365 353 365 364 485 485 364 379 353 354 364 364 354 355 364 355 379 352 319 353 353 319 320 353 320 354 354 320 333 354 333 355 320 300 299 320 299 333 252 299 300 352 318 319 351 328 318 351 318 352 350 328 351 367 350 351 367 351 352 324 305 328 350 324 328 349 324 350 369 349 350 369 350 367 497 369 367 368 349 369 496 368 369 496 369 497 348 323 349 349 323 324 368 348 349 373 347 368 368 347 348 495 373 368 495 368 496 495 496 497 491 495 497 494 373 495 494 495 491 372 346 373 373 346 347 494 372 373 346 321 347 347 321 322 347 322 348 345 329 346 346 329 321 372 345 346 321 309 322 329 311 321 321 311 310 321 310 309 322 309 308 322 308 323 348 322 323 256 308 309 256 309 255 255 309 310 255 310 254 254 310 311 254 227 255 255 227 226 255 226 256 256 226 225 256 225 257 257 308 256 192 226 227 192 227 193 193 227 228 254 228 227 257 307 308 323 308 307 258 307 257 258 306 307 323 307 324 307 306 324 324 306 305 344 345 372 371 344 372 493 371 372 493 372 494 492 371 493 492 493 491 491 493 494 3 447 33 33 447 448 2 1 3 2 3 4 3 33 4 4 33 34 33 448 34 448 445 449 34 448 449 4 34 35 35 34 36 34 449 36 445 444 449 449 444 443 449 443 450 36 449 450 35 36 23 23 36 37 36 450 37 4 35 469 469 35 23 23 37 24 37 450 451 37 451 24 450 443 442 450 442 451 442 441 451 451 441 440 400 441 442 400 442 399 399 442 443 401 440 441 401 441 400 402 440 401 400 82 401 401 82 84 401 84 402 399 80 400 400 80 82 399 443 398 398 443 444 82 83 84 84 83 85 84 85 86 402 84 86 402 86 380 86 85 87 86 87 88 380 86 88 122 87 85 88 87 89 121 89 87 121 87 122 88 89 90 380 88 90 90 89 91 120 91 89 120 89 121 90 91 92 92 91 93 92 93 94 469 470 4 476 477 469 469 477 470 484 4 470 470 477 484 483 2 4 483 4 484 484 477 482 484 482 483 476 20 477 478 482 477 482 2 483 479 481 482 479 482 478 479 5 480 480 481 479 480 7 481 480 5 7 5 6 7 500 501 502 566 567 500 500 567 501 502 1043 500 500 1043 1042 500 1042 566 564 565 566 566 565 567 566 1042 1041 566 1041 564 989 1041 1042 989 1042 990 990 1042 1043 988 1040 1041 988 1041 989 564 1041 1040 936 988 989 936 989 937 937 989 990 937 990 938 938 990 991 990 1043 991 884 936 937 884 937 885 885 937 938 885 938 833 833 938 886 938 991 886 886 991 939 991 1043 1044 991 1044 939 502 1044 1043 939 1044 992 502 992 1044 886 939 887 887 939 940 939 992 940 833 886 834 834 886 887 834 887 835 835 887 888 887 940 888 888 940 941 940 992 993 940 993 941 504 992 502 504 993 992 941 993 994 504 994 993 888 941 889 889 941 942 941 994 942 835 888 836 836 888 889 836 889 837 837 889 890 889 942 890 890 942 943 942 994 995 942 995 943 506 995 994 506 994 504 943 995 996 508 996 995 508 995 506 890 943 891 891 943 944 943 996 944 837 890 838 838 890 891 838 891 839 839 891 892 891 944 892 892 944 945 944 996 997 944 997 945 997 996 508 945 997 998 508 510 997 510 998 997 892 945 893 893 945 946 945 998 946 839 892 840 840 892 893 840 893 841 841 893 894 893 946 894 894 946 947 946 998 999 946 999 947 510 999 998 947 999 1000 512 1000 999 512 999 510 894 947 895 895 947 948 947 1000 948 841 894 842 842 894 895 842 895 843 843 895 896 895 948 896 896 948 949 948 1000 1001 948 1001 949 843 896 844 844 896 897 896 949 897 790 842 843 790 843 791 791 843 844 791 844 792 792 844 845 844 897 845 845 897 898 897 949 950 897 950 898 792 845 793 793 845 846 845 898 846 739 791 792 739 792 740 740 792 793 740 793 741 741 793 794 793 846 794 794 846 847 846 898 899 846 899 847 741 794 742 742 794 795 794 847 795 688 740 741 688 741 689 689 741 742 689 742 690 690 742 743 742 795 743 743 795 796 795 847 848 795 848 796 690 743 691 691 743 744 743 796 744 637 689 690 637 690 638 638 690 691 638 691 639 639 691 692 691 744 692 692 744 745 744 796 797 744 797 745 639 692 640 640 692 693 692 745 693 577 638 639 577 639 605 605 639 640 605 640 606 606 640 641 640 693 641 641 693 694 693 745 746 693 746 694 606 641 607 607 641 642 641 694 642 527 605 606 527 606 529 529 606 607 577 605 527 526 525 527 526 527 528 528 527 529 527 525 577 528 529 530 530 529 531 529 607 531 528 1011 526 530 1013 528 528 1013 1012 528 1012 1011 530 531 532 532 1014 530 530 1014 1013 960 1012 1013 960 1013 961 961 1013 1014 959 1011 1012 959 1012 960 907 959 960 907 960 908 908 960 961 908 961 909 909 961 962 961 1014 962 962 1014 1015 532 1015 1014 909 962 910 910 962 963 962 1015 963 856 908 909 856 909 857 857 909 910 855 907 908 855 908 856 803 855 856 803 856 804 804 856 857 804 857 805 805 857 858 857 910 858 751 803 804 751 804 752 752 804 805 750 802 803 750 803 751 802 855 803 698 750 751 698 751 699 699 751 752 699 752 700 700 752 753 752 805 753 646 698 699 646 699 647 647 699 700 645 697 698 645 698 646 697 750 698 575 645 646 575 646 576 576 646 647 576 647 582 582 647 648 647 700 648 535 575 576 535 576 537 576 582 537 533 575 535 533 598 575 598 645 575 534 533 535 534 535 536 536 535 537 532 531 533 532 533 534 531 597 533 533 597 598 597 644 598 598 644 645 531 608 597 608 643 597 597 643 644 531 607 608 607 642 608 608 642 643 642 695 643 643 695 696 643 696 644 644 696 697 644 697 645 695 748 696 696 748 749 696 749 697 642 694 695 694 747 695 695 747 748 747 800 748 748 800 801 748 801 749 697 749 750 749 801 802 749 802 750 800 853 801 801 853 854 801 854 802 747 799 800 799 852 800 800 852 853 852 905 853 853 905 906 853 906 854 802 854 855 854 906 907 854 907 855 905 958 906 906 958 959 906 959 907 852 904 905 904 957 905 905 957 958 957 1010 958 958 1010 1011 958 1011 959 904 956 957 956 1009 957 957 1009 1010 851 903 904 851 904 852 903 956 904 903 955 956 955 1008 956 956 1008 1009 526 1009 524 524 1009 1008 526 1010 1009 955 1007 1008 524 1008 522 522 1008 1007 902 954 955 902 955 903 954 1007 955 954 1006 1007 522 1007 1006 520 521 522 522 521 523 522 523 524 520 522 1006 953 1005 1006 953 1006 954 1006 1005 520 901 953 954 901 954 902 900 952 953 900 953 901 952 1005 953 952 1004 1005 520 1005 1004 899 951 952 899 952 900 951 1004 952 847 899 900 847 900 848 848 900 901 848 901 849 849 901 902 796 848 849 796 849 797 797 849 850 849 902 850 850 902 903 797 850 798 798 850 851 850 903 851 745 797 798 745 798 746 746 798 799 798 851 799 799 851 852 746 799 747 694 746 747 898 951 899 898 950 951 950 1003 951 951 1003 1004 949 1002 950 950 1002 1003 518 1004 1003 518 1003 516 516 1003 1002 520 1004 518 516 517 518 518 517 519 518 519 520 514 515 516 516 515 517 516 1002 514 949 1001 1002 514 1002 1001 512 513 514 514 513 515 514 1000 512 514 1001 1000 513 599 515 515 599 600 515 600 517 512 511 513 511 603 513 513 603 604 513 604 599 510 511 512 510 509 511 509 602 511 511 602 603 602 627 603 603 627 628 603 628 604 604 628 629 604 629 599 627 680 628 628 680 681 628 681 629 602 626 627 626 679 627 627 679 680 509 601 602 601 626 602 601 625 626 625 678 626 626 678 679 678 731 679 679 731 732 679 732 680 625 677 678 677 730 678 678 730 731 587 624 625 587 625 601 624 677 625 587 601 509 509 507 587 507 613 587 613 624 587 613 623 624 623 676 624 624 676 677 507 612 613 612 623 613 612 622 623 622 675 623 623 675 676 675 728 676 676 728 729 676 729 677 622 674 675 674 727 675 675 727 728 727 780 728 728 780 781 728 781 729 677 729 730 729 781 782 729 782 730 780 833 781 781 833 834 781 834 782 727 832 780 832 885 780 780 885 833 779 831 832 779 832 727 831 884 832 832 884 885 726 778 779 726 779 674 674 779 727 778 831 779 778 830 831 830 883 831 831 883 884 883 936 884 830 882 883 882 935 883 883 935 936 777 829 830 777 830 778 829 882 830 829 881 882 881 934 882 882 934 935 934 987 935 935 987 988 935 988 936 881 933 934 933 986 934 934 986 987 828 880 881 828 881 829 880 933 881 880 932 933 932 985 933 933 985 986 985 1038 986 986 1038 1039 986 1039 987 932 984 985 984 1037 985 985 1037 1038 879 931 932 879 932 880 931 984 932 931 983 984 983 1036 984 984 1036 1037 562 1038 1037 562 1037 560 560 1037 1036 1039 1038 562 560 561 562 562 561 563 562 563 564 562 564 1039 558 559 560 560 559 561 560 1036 558 983 1035 1036 558 1036 1035 556 557 558 558 557 559 558 1034 556 558 1035 1034 557 578 559 559 578 579 559 579 561 556 555 557 555 591 557 557 591 592 557 592 578 592 663 578 578 663 664 578 664 579 561 579 580 579 664 665 579 665 580 663 716 664 664 716 717 664 717 665 580 665 666 665 717 718 665 718 666 561 580 572 580 666 572 561 572 563 563 572 573 572 666 667 572 667 573 666 718 719 666 719 667 717 770 718 718 770 771 718 771 719 667 719 720 719 771 772 719 772 720 573 667 668 667 720 668 563 573 569 573 668 569 569 668 669 668 720 721 668 721 669 720 772 773 720 773 721 771 824 772 772 824 825 772 825 773 721 773 774 773 825 826 773 826 774 669 721 722 721 774 722 722 774 775 774 826 827 774 827 775 825 878 826 826 878 879 826 879 827 824 877 825 825 877 878 877 930 878 878 930 931 878 931 879 827 879 880 775 827 828 827 880 828 775 828 776 776 828 829 723 775 776 723 776 724 724 776 777 776 829 777 670 722 723 670 723 671 671 723 724 722 775 723 671 724 672 672 724 725 724 777 725 725 777 778 672 725 673 673 725 726 725 778 726 568 671 672 568 672 609 609 672 673 609 673 610 610 673 621 673 726 621 621 726 674 610 621 611 611 621 622 621 674 622 501 609 610 501 610 503 503 610 611 568 609 501 502 501 503 501 567 568 502 503 504 504 503 505 503 611 505 505 611 612 611 622 612 504 505 506 506 505 507 505 612 507 506 507 508 508 507 509 508 509 510 567 571 568 571 671 568 567 570 571 570 670 571 571 670 671 565 569 570 565 570 567 569 669 570 570 669 670 669 722 670 563 569 565 564 563 565 564 1040 1039 987 1039 1040 987 1040 988 930 983 931 877 929 930 929 982 930 930 982 983 982 1035 983 929 981 982 981 1034 982 982 1034 1035 876 928 929 876 929 877 928 981 929 824 876 877 823 875 876 823 876 824 875 928 876 875 927 928 927 980 928 928 980 981 822 874 875 822 875 823 874 927 875 770 822 823 770 823 771 771 823 824 769 821 822 769 822 770 821 874 822 821 873 874 873 926 874 874 926 927 768 820 821 768 821 769 820 873 821 716 768 769 716 769 717 717 769 770 715 767 768 715 768 716 767 820 768 767 819 820 819 872 820 820 872 873 714 766 767 714 767 715 766 819 767 662 714 715 662 715 663 663 715 716 661 713 714 661 714 662 713 766 714 713 765 766 765 818 766 766 818 819 660 712 713 660 713 661 712 765 713 590 660 661 590 661 591 591 661 662 589 659 660 589 660 590 659 712 660 659 711 712 711 764 712 712 764 765 588 658 659 588 659 589 658 711 659 551 588 589 551 589 553 553 589 590 581 588 551 581 658 588 581 657 658 657 710 658 658 710 711 551 549 581 549 596 581 596 657 581 596 656 657 656 709 657 657 709 710 709 762 710 710 762 763 710 763 711 656 708 709 708 761 709 709 761 762 761 814 762 762 814 815 762 815 763 711 763 764 763 815 816 763 816 764 814 867 815 815 867 868 815 868 816 761 813 814 813 866 814 814 866 867 866 919 867 867 919 920 867 920 868 816 868 869 868 920 921 868 921 869 919 972 920 920 972 973 920 973 921 866 918 919 918 971 919 919 971 972 971 1024 972 972 1024 1025 972 1025 973 921 973 974 973 1025 1026 973 1026 974 546 1025 544 544 1025 1024 546 1026 1025 971 1023 1024 544 1024 1023 918 970 971 970 1023 971 970 1022 1023 544 1023 542 542 1023 1022 542 543 544 544 543 545 544 545 546 540 541 542 542 541 543 542 1022 540 969 1021 1022 969 1022 970 540 1022 1021 538 539 540 540 539 541 540 1020 538 540 1021 1020 539 584 541 541 584 585 541 585 543 538 537 539 537 583 539 539 583 584 583 649 584 584 649 650 584 650 585 543 585 586 585 650 651 585 651 586 649 702 650 650 702 703 650 703 651 586 651 652 651 703 704 651 704 652 543 586 574 586 652 574 545 543 574 574 593 545 574 652 653 574 653 593 652 704 705 652 705 653 703 756 704 704 756 757 704 757 705 653 705 706 705 757 758 705 758 706 593 653 654 653 706 654 545 593 594 593 654 594 594 654 655 654 706 707 654 707 655 706 758 759 706 759 707 757 810 758 758 810 811 758 811 759 707 759 760 759 811 812 759 812 760 655 707 708 707 760 708 708 760 761 760 812 813 760 813 761 811 864 812 812 864 865 812 865 813 810 863 811 811 863 864 863 916 864 864 916 917 864 917 865 813 865 866 865 917 918 865 918 866 916 969 917 917 969 970 917 970 918 863 915 916 915 968 916 916 968 969 968 1021 969 915 967 968 967 1020 968 968 1020 1021 862 914 915 862 915 863 914 967 915 914 966 967 966 1019 967 967 1019 1020 538 1020 1019 966 1018 1019 538 1019 536 536 1019 1018 913 965 966 913 966 914 965 1018 966 965 1017 1018 536 1018 1017 536 537 538 534 536 1017 964 1016 1017 964 1017 965 1017 1016 534 912 964 965 912 965 913 911 963 964 911 964 912 963 1016 964 963 1015 1016 534 1016 1015 534 1015 532 910 963 911 858 910 911 858 911 859 859 911 912 859 912 860 860 912 913 806 858 859 806 859 807 807 859 860 805 858 806 753 805 806 753 806 754 754 806 807 754 807 755 755 807 808 807 860 808 701 753 754 701 754 702 702 754 755 700 753 701 648 700 701 648 701 649 649 701 702 702 755 703 703 755 756 755 808 756 756 808 809 756 809 757 757 809 810 808 861 809 809 861 862 809 862 810 810 862 863 861 914 862 808 860 861 860 913 861 861 913 914 583 648 649 537 582 583 582 648 583 655 708 656 594 655 595 595 655 656 595 656 596 547 594 595 547 595 549 549 595 596 545 594 547 546 545 547 546 547 548 548 547 549 548 549 550 550 549 551 550 1028 548 548 1028 1027 548 1027 546 546 1027 1026 974 1026 1027 974 1027 975 975 1027 1028 975 1028 976 976 1028 1029 550 1029 1028 922 974 975 922 975 923 923 975 976 921 974 922 869 921 922 869 922 870 870 922 923 870 923 871 871 923 924 923 976 924 817 869 870 817 870 818 818 870 871 816 869 817 764 816 817 764 817 765 765 817 818 818 871 819 819 871 872 871 924 872 872 924 925 872 925 873 873 925 926 924 977 925 925 977 978 925 978 926 926 978 979 926 979 927 977 1030 978 978 1030 1031 978 1031 979 924 976 977 976 1029 977 977 1029 1030 1031 1030 552 552 1030 1029 979 1031 1032 552 554 1031 554 1032 1031 550 551 552 552 551 553 552 553 554 552 1029 550 554 553 555 554 555 556 556 1033 554 554 1033 1032 979 1032 980 980 1032 1033 980 1033 981 981 1033 1034 556 1034 1033 927 979 980 553 590 555 555 590 591 591 662 592 592 662 663 730 782 783 782 834 835 782 835 783 730 783 731 731 783 784 783 835 836 783 836 784 731 784 732 732 784 785 784 836 837 784 837 785 680 732 733 732 785 733 733 785 786 785 837 838 785 838 786 680 733 681 681 733 734 733 786 734 734 786 787 786 838 839 786 839 787 681 734 682 682 734 735 734 787 735 629 681 682 629 682 630 630 682 683 682 735 683 683 735 736 735 787 788 735 788 736 630 683 631 631 683 684 683 736 684 599 629 630 599 630 600 600 630 631 600 631 618 618 631 632 631 684 632 632 684 685 684 736 737 684 737 685 618 632 619 619 632 633 632 685 633 600 618 517 517 618 619 517 619 519 519 619 620 619 633 620 620 633 634 633 685 686 633 686 634 519 620 614 620 634 614 520 519 521 519 614 521 521 614 615 614 634 635 614 635 615 634 686 687 634 687 635 615 635 636 635 687 688 635 688 636 521 615 523 523 615 616 615 636 616 616 636 637 636 688 689 636 689 637 687 740 688 686 739 687 687 739 740 685 738 686 686 738 739 738 791 739 685 737 738 737 790 738 738 790 791 736 789 737 737 789 790 789 842 790 736 788 789 788 841 789 789 841 842 787 840 788 788 840 841 787 839 840 616 637 617 617 637 638 523 616 525 525 616 617 525 617 577 617 638 577 524 523 525 524 525 526 526 1011 1010))
                   (list :vertices (let ((mat (make-matrix 1045 3))) (fvector-replace (array-entity mat) #f(5.9832100868225098e+00 -1.4487998962402344e+02 -5.9525001525878906e+01 1.4056200027465820e+01 -1.4487998962402344e+02 -6.9658599853515625e+01 3.6460001468658447e+00 -1.4487998962402344e+02 -6.2120697021484375e+01 9.6198596954345703e+00 -1.4487998962402344e+02 -7.3267799377441406e+01 4.5505800843238831e-01 -1.4487998962402344e+02 -6.3541397094726562e+01 6.6974697113037109e+00 -1.4487998962402344e+02 -5.2729301452636719e+01 1.9659599304199219e+01 -1.4487998962402344e+02 -5.3891899108886719e+01 7.0625801086425781e+00 -1.4487998962402344e+02 -5.6202999114990234e+01 1.9269399642944336e+01 -1.4487998962402344e+02 -5.9597599029541016e+01 1.7354200363159180e+01 -1.4487998962402344e+02 -6.4986396789550781e+01 -9.6453800201416016e+00 -1.4487998962402344e+02 -5.6202999114990234e+01 -2.2242401123046875e+01 -1.4487998962402344e+02 -5.3891899108886719e+01 -9.2802696228027344e+00 -1.4487998962402344e+02 -5.2729301452636719e+01 -2.1078899383544922e+01 -1.4487998962402344e+02 -4.8292499542236328e+01 -7.5338196754455566e+00 -1.4487998962402344e+02 -4.9704299926757812e+01 2.1251900196075439e+00 -1.4487998962402344e+02 -4.7651203155517578e+01 1.1961400032043457e+01 -1.4487998962402344e+02 -3.9035099029541016e+01 4.9510197639465332e+00 -1.4487998962402344e+02 -4.9704299926757812e+01 1.5864999771118164e+01 -1.4487998962402344e+02 -4.3214702606201172e+01 1.8496099472045898e+01 -1.4487998962402344e+02 -4.8292499542236328e+01 -1.2914000749588013e+00 -1.4487998962402344e+02 -4.6924999237060547e+01 1.5680999755859375e+00 -1.4487998962402344e+02 -3.4520599365234375e+01 7.0750203132629395e+00 -1.4487998962402344e+02 -3.6063598632812500e+01 -6.2287998199462891e+00 -1.4487998962402344e+02 -6.2120697021484375e+01 -1.6638999938964844e+01 -1.4487998962402344e+02 -6.9658599853515625e+01 -8.5660095214843750e+00 -1.4487998962402344e+02 -5.9525001525878906e+01 -1.9936998367309570e+01 -1.4487998962402344e+02 -6.4986396789550781e+01 -2.1852201461791992e+01 -1.4487998962402344e+02 -5.9597599029541016e+01 -1.8447799682617188e+01 -1.4487998962402344e+02 -4.3214702606201172e+01 -1.4544199943542480e+01 -1.4487998962402344e+02 -3.9035099029541016e+01 -4.7079901695251465e+00 -1.4487998962402344e+02 -4.7651203155517578e+01 -9.6578197479248047e+00 -1.4487998962402344e+02 -3.6063598632812500e+01 -4.1508998870849609e+00 -1.4487998962402344e+02 -3.4520599365234375e+01 4.3743300437927246e+00 -1.4487998962402344e+02 -7.5546302795410156e+01 -1.2914000749588013e+00 -1.4487998962402344e+02 -7.6324996948242188e+01 -3.0378599166870117e+00 -1.4487998962402344e+02 -6.3541397094726562e+01 -6.9571299552917480e+00 -1.4487998962402344e+02 -7.5546302795410156e+01 -1.2202699661254883e+01 -1.4487998962402344e+02 -7.3267799377441406e+01 -1.0147500038146973e+01 -1.5863000488281250e+02 -5.0998101234436035e+00 -1.2914000749588013e+00 -1.6188000488281250e+02 -4.3250002861022949e+00 -1.2914000749588013e+00 -1.5863000488281250e+02 -4.3250002861022949e+00 7.5646600723266602e+00 -1.6188000488281250e+02 -5.0998101234436035e+00 7.5646600723266602e+00 -1.5863000488281250e+02 -5.0998101234436035e+00 1.6151599884033203e+01 -1.6188000488281250e+02 -7.4006800651550293e+00 1.6151599884033203e+01 -1.5863000488281250e+02 -7.4006800651550293e+00 2.4208599090576172e+01 -1.6188000488281250e+02 -1.1157699584960938e+01 2.4208599090576172e+01 -1.5863000488281250e+02 -1.1157699584960938e+01 3.1490798950195312e+01 -1.6188000488281250e+02 -1.6256698608398438e+01 3.1490798950195312e+01 -1.5863000488281250e+02 -1.6256698608398438e+01 3.7776897430419922e+01 -1.6188000488281250e+02 -2.2542800903320312e+01 3.7776897430419922e+01 -1.5863000488281250e+02 -2.2542800903320312e+01 4.2875900268554688e+01 -1.6188000488281250e+02 -2.9825000762939453e+01 4.2875900268554688e+01 -1.5863000488281250e+02 -2.9825000762939453e+01 4.6632900238037109e+01 -1.6188000488281250e+02 -3.7881999969482422e+01 4.6632900238037109e+01 -1.5863000488281250e+02 -3.7881999969482422e+01 4.8933799743652344e+01 -1.6188000488281250e+02 -4.6468898773193359e+01 4.8933799743652344e+01 -1.5863000488281250e+02 -4.6468898773193359e+01 4.9708602905273438e+01 -1.6188000488281250e+02 -5.5325000762939453e+01 4.9708602905273438e+01 -1.5863000488281250e+02 -5.5325000762939453e+01 4.8933799743652344e+01 -1.6188000488281250e+02 -6.4181098937988281e+01 4.8933799743652344e+01 -1.5863000488281250e+02 -6.4181098937988281e+01 4.6632900238037109e+01 -1.6188000488281250e+02 -7.2768005371093750e+01 4.6632900238037109e+01 -1.5863000488281250e+02 -7.2768005371093750e+01 4.2875900268554688e+01 -1.6188000488281250e+02 -8.0825004577636719e+01 4.2875900268554688e+01 -1.5863000488281250e+02 -8.0825004577636719e+01 3.7776897430419922e+01 -1.6188000488281250e+02 -8.8107200622558594e+01 3.7776897430419922e+01 -1.5863000488281250e+02 -8.8107200622558594e+01 3.1490798950195312e+01 -1.6188000488281250e+02 -9.4393295288085938e+01 3.1490798950195312e+01 -1.5863000488281250e+02 -9.4393295288085938e+01 2.4208599090576172e+01 -1.6188000488281250e+02 -9.9492294311523438e+01 2.4208599090576172e+01 -1.5863000488281250e+02 -9.9492294311523438e+01 1.6151599884033203e+01 -1.6188000488281250e+02 -1.0324900054931641e+02 1.6151599884033203e+01 -1.5863000488281250e+02 -1.0324900054931641e+02 7.5646600723266602e+00 -1.6188000488281250e+02 -1.0554999542236328e+02 7.5646600723266602e+00 -1.5863000488281250e+02 -1.0554999542236328e+02 -1.2914000749588013e+00 -1.6188000488281250e+02 -1.0632499694824219e+02 -1.2914000749588013e+00 -1.5863000488281250e+02 -1.0632499694824219e+02 -1.0147500038146973e+01 -1.6188000488281250e+02 -1.0554999542236328e+02 -1.0147500038146973e+01 -1.5863000488281250e+02 -1.0554999542236328e+02 -1.8734399795532227e+01 -1.6188000488281250e+02 -1.0324900054931641e+02 -1.8734399795532227e+01 -1.5863000488281250e+02 -1.0324900054931641e+02 -2.6791399002075195e+01 -1.6188000488281250e+02 -9.9492294311523438e+01 -2.6791399002075195e+01 -1.5863000488281250e+02 -9.9492294311523438e+01 -3.4073596954345703e+01 -1.6188000488281250e+02 -9.4393295288085938e+01 -3.4073596954345703e+01 -1.5863000488281250e+02 -9.4393295288085938e+01 -4.0359699249267578e+01 -1.6188000488281250e+02 -8.8107200622558594e+01 -4.0359699249267578e+01 -1.5863000488281250e+02 -8.8107200622558594e+01 -4.5458702087402344e+01 -1.6188000488281250e+02 -8.0825004577636719e+01 -4.5458702087402344e+01 -1.5863000488281250e+02 -8.0825004577636719e+01 -4.9215702056884766e+01 -1.6188000488281250e+02 -7.2768005371093750e+01 -4.9215702056884766e+01 -1.5863000488281250e+02 -7.2768005371093750e+01 -5.1516601562500000e+01 -1.6188000488281250e+02 -6.4181098937988281e+01 -5.1516601562500000e+01 -1.5863000488281250e+02 -6.4181098937988281e+01 -5.2291400909423828e+01 -1.6188000488281250e+02 -5.5325000762939453e+01 -5.2291400909423828e+01 -1.5863000488281250e+02 -5.5325000762939453e+01 -5.1516601562500000e+01 -1.6188000488281250e+02 -4.6468898773193359e+01 -5.1516601562500000e+01 -1.5863000488281250e+02 -4.6468898773193359e+01 -4.9215702056884766e+01 -1.6188000488281250e+02 -3.7881999969482422e+01 -4.9215702056884766e+01 -1.5863000488281250e+02 -3.7881999969482422e+01 -4.5458702087402344e+01 -1.6188000488281250e+02 -2.9825000762939453e+01 -4.5458702087402344e+01 -1.5863000488281250e+02 -2.9825000762939453e+01 -4.0359699249267578e+01 -1.6188000488281250e+02 -2.2542800903320312e+01 -4.0359699249267578e+01 -1.5863000488281250e+02 -2.2542800903320312e+01 -3.4073596954345703e+01 -1.6188000488281250e+02 -1.6256698608398438e+01 -3.4073596954345703e+01 -1.5863000488281250e+02 -1.6256698608398438e+01 -2.6791399002075195e+01 -1.6188000488281250e+02 -1.1157699584960938e+01 -2.6791399002075195e+01 -1.5863000488281250e+02 -1.1157699584960938e+01 -1.8734399795532227e+01 -1.6188000488281250e+02 -7.4006800651550293e+00 -1.8734399795532227e+01 -1.5863000488281250e+02 -7.4006800651550293e+00 -1.0147500038146973e+01 -1.6188000488281250e+02 -5.0998101234436035e+00 -5.6389098167419434e+00 -1.6188000488281250e+02 -7.0202498435974121e+00 -1.4194199562072754e+01 -1.6188000488281250e+02 -8.5727996826171875e+00 -2.2334798812866211e+01 -1.6188000488281250e+02 -1.1628000259399414e+01 -2.9798999786376953e+01 -1.6188000488281250e+02 -1.6087699890136719e+01 -3.6347000122070312e+01 -1.6188000488281250e+02 -2.1808500289916992e+01 -4.1768199920654297e+01 -1.6188000488281250e+02 -2.8606500625610352e+01 -4.5888500213623047e+01 -1.6188000488281250e+02 -3.6263298034667969e+01 -4.8575401306152344e+01 -1.6188000488281250e+02 -4.4532699584960938e+01 -4.9742603302001953e+01 -1.6188000488281250e+02 -5.3149101257324219e+01 -4.9352500915527344e+01 -1.6188000488281250e+02 -6.1835300445556641e+01 -4.7417598724365234e+01 -1.6188000488281250e+02 -7.0312301635742188e+01 -4.4000301361083984e+01 -1.6188000488281250e+02 -7.8307601928710938e+01 -3.9210201263427734e+01 -1.6188000488281250e+02 -8.5564300537109375e+01 -3.3201400756835938e+01 -1.6188000488281250e+02 -9.1848999023437500e+01 -2.6166999816894531e+01 -1.6188000488281250e+02 -9.6959800720214844e+01 -1.8333099365234375e+01 -1.6188000488281250e+02 -1.0073200225830078e+02 -9.9514102935791016e+00 -1.6188000488281250e+02 -1.0304599761962891e+02 -1.2914000749588013e+00 -1.6188000488281250e+02 -1.0382500457763672e+02 7.3686099052429199e+00 -1.6188000488281250e+02 -1.0304599761962891e+02 1.5750300407409668e+01 -1.6188000488281250e+02 -1.0073200225830078e+02 2.3584199905395508e+01 -1.6188000488281250e+02 -9.6959800720214844e+01 3.0618600845336914e+01 -1.6188000488281250e+02 -9.1848999023437500e+01 3.6627399444580078e+01 -1.6188000488281250e+02 -8.5564300537109375e+01 4.1417499542236328e+01 -1.6188000488281250e+02 -7.8307601928710938e+01 4.4834800720214844e+01 -1.6188000488281250e+02 -7.0312301635742188e+01 4.6769699096679688e+01 -1.6188000488281250e+02 -6.1835300445556641e+01 4.7159797668457031e+01 -1.6188000488281250e+02 -5.3149101257324219e+01 4.5992603302001953e+01 -1.6188000488281250e+02 -4.4532699584960938e+01 4.3305698394775391e+01 -1.6188000488281250e+02 -3.6263298034667969e+01 3.9185401916503906e+01 -1.6188000488281250e+02 -2.8606500625610352e+01 3.3764198303222656e+01 -1.6188000488281250e+02 -2.1808500289916992e+01 2.7216199874877930e+01 -1.6188000488281250e+02 -1.6087699890136719e+01 1.9751998901367188e+01 -1.6188000488281250e+02 -1.1628000259399414e+01 1.1611400604248047e+01 -1.6188000488281250e+02 -8.5727996826171875e+00 3.0561101436614990e+00 -1.6188000488281250e+02 -7.0202498435974121e+00 -9.9514102935791016e+00 -2.1288000488281250e+02 -1.0304599761962891e+02 -1.2914000749588013e+00 -2.1288000488281250e+02 -1.0382500457763672e+02 7.3686099052429199e+00 -2.1288000488281250e+02 -1.0304599761962891e+02 1.5750300407409668e+01 -2.1288000488281250e+02 -1.0073200225830078e+02 2.3584199905395508e+01 -2.1288000488281250e+02 -9.6959800720214844e+01 3.0618600845336914e+01 -2.1288000488281250e+02 -9.1848999023437500e+01 3.6627399444580078e+01 -2.1288000488281250e+02 -8.5564300537109375e+01 4.1417499542236328e+01 -2.1288000488281250e+02 -7.8307601928710938e+01 4.4834800720214844e+01 -2.1288000488281250e+02 -7.0312301635742188e+01 4.6769699096679688e+01 -2.1288000488281250e+02 -6.1835300445556641e+01 4.7159797668457031e+01 -2.1288000488281250e+02 -5.3149101257324219e+01 4.5992603302001953e+01 -2.1288000488281250e+02 -4.4532699584960938e+01 4.3305698394775391e+01 -2.1288000488281250e+02 -3.6263298034667969e+01 3.9185401916503906e+01 -2.1288000488281250e+02 -2.8606500625610352e+01 3.3764198303222656e+01 -2.1288000488281250e+02 -2.1808500289916992e+01 2.7216199874877930e+01 -2.1288000488281250e+02 -1.6087699890136719e+01 1.9751998901367188e+01 -2.1288000488281250e+02 -1.1628000259399414e+01 1.1611400604248047e+01 -2.1288000488281250e+02 -8.5727996826171875e+00 3.0561101436614990e+00 -2.1288000488281250e+02 -7.0202498435974121e+00 -5.6389098167419434e+00 -2.1288000488281250e+02 -7.0202498435974121e+00 -1.4194199562072754e+01 -2.1288000488281250e+02 -8.5727996826171875e+00 -2.2334798812866211e+01 -2.1288000488281250e+02 -1.1628000259399414e+01 -2.9798999786376953e+01 -2.1288000488281250e+02 -1.6087699890136719e+01 -3.6347000122070312e+01 -2.1288000488281250e+02 -2.1808500289916992e+01 -4.1768199920654297e+01 -2.1288000488281250e+02 -2.8606500625610352e+01 -4.5888500213623047e+01 -2.1288000488281250e+02 -3.6263298034667969e+01 -4.8575401306152344e+01 -2.1288000488281250e+02 -4.4532699584960938e+01 -4.9742603302001953e+01 -2.1288000488281250e+02 -5.3149101257324219e+01 -4.9352500915527344e+01 -2.1288000488281250e+02 -6.1835300445556641e+01 -4.7417598724365234e+01 -2.1288000488281250e+02 -7.0312301635742188e+01 -4.4000301361083984e+01 -2.1288000488281250e+02 -7.8307601928710938e+01 -3.9210201263427734e+01 -2.1288000488281250e+02 -8.5564300537109375e+01 -3.3201400756835938e+01 -2.1288000488281250e+02 -9.1848999023437500e+01 -2.6166999816894531e+01 -2.1288000488281250e+02 -9.6959800720214844e+01 -1.8333099365234375e+01 -2.1288000488281250e+02 -1.0073200225830078e+02 -1.8734399795532227e+01 -2.1288000488281250e+02 -7.4006800651550293e+00 -1.0147500038146973e+01 -2.1288000488281250e+02 -5.0998101234436035e+00 -1.2914000749588013e+00 -2.1288000488281250e+02 -4.3250002861022949e+00 7.5646600723266602e+00 -2.1288000488281250e+02 -5.0998101234436035e+00 1.6151599884033203e+01 -2.1288000488281250e+02 -7.4006800651550293e+00 2.4208599090576172e+01 -2.1288000488281250e+02 -1.1157699584960938e+01 3.1490798950195312e+01 -2.1288000488281250e+02 -1.6256698608398438e+01 3.7776897430419922e+01 -2.1288000488281250e+02 -2.2542800903320312e+01 4.2875900268554688e+01 -2.1288000488281250e+02 -2.9825000762939453e+01 4.6632900238037109e+01 -2.1288000488281250e+02 -3.7881999969482422e+01 4.8933799743652344e+01 -2.1288000488281250e+02 -4.6468898773193359e+01 4.9708602905273438e+01 -2.1288000488281250e+02 -5.5325000762939453e+01 4.8933799743652344e+01 -2.1288000488281250e+02 -6.4181098937988281e+01 4.6632900238037109e+01 -2.1288000488281250e+02 -7.2768005371093750e+01 4.2875900268554688e+01 -2.1288000488281250e+02 -8.0825004577636719e+01 3.7776897430419922e+01 -2.1288000488281250e+02 -8.8107200622558594e+01 3.1490798950195312e+01 -2.1288000488281250e+02 -9.4393295288085938e+01 2.4208599090576172e+01 -2.1288000488281250e+02 -9.9492294311523438e+01 1.6151599884033203e+01 -2.1288000488281250e+02 -1.0324900054931641e+02 7.5646600723266602e+00 -2.1288000488281250e+02 -1.0554999542236328e+02 -1.2914000749588013e+00 -2.1288000488281250e+02 -1.0632499694824219e+02 -1.0147500038146973e+01 -2.1288000488281250e+02 -1.0554999542236328e+02 -1.8734399795532227e+01 -2.1288000488281250e+02 -1.0324900054931641e+02 -2.6791399002075195e+01 -2.1288000488281250e+02 -9.9492294311523438e+01 -3.4073596954345703e+01 -2.1288000488281250e+02 -9.4393295288085938e+01 -4.0359699249267578e+01 -2.1288000488281250e+02 -8.8107200622558594e+01 -4.5458702087402344e+01 -2.1288000488281250e+02 -8.0825004577636719e+01 -4.9215702056884766e+01 -2.1288000488281250e+02 -7.2768005371093750e+01 -5.1516601562500000e+01 -2.1288000488281250e+02 -6.4181098937988281e+01 -5.2291400909423828e+01 -2.1288000488281250e+02 -5.5325000762939453e+01 -5.1516601562500000e+01 -2.1288000488281250e+02 -4.6468898773193359e+01 -4.9215702056884766e+01 -2.1288000488281250e+02 -3.7881999969482422e+01 -4.5458702087402344e+01 -2.1288000488281250e+02 -2.9825000762939453e+01 -4.0359699249267578e+01 -2.1288000488281250e+02 -2.2542800903320312e+01 -3.4073596954345703e+01 -2.1288000488281250e+02 -1.6256698608398438e+01 -2.6791399002075195e+01 -2.1288000488281250e+02 -1.1157699584960938e+01 -1.2914000749588013e+00 -2.1613000488281250e+02 -4.3250002861022949e+00 7.5646600723266602e+00 -2.1613000488281250e+02 -5.0998101234436035e+00 1.6151599884033203e+01 -2.1613000488281250e+02 -7.4006800651550293e+00 2.4208599090576172e+01 -2.1613000488281250e+02 -1.1157699584960938e+01 3.1490798950195312e+01 -2.1613000488281250e+02 -1.6256698608398438e+01 3.7776897430419922e+01 -2.1613000488281250e+02 -2.2542800903320312e+01 4.2875900268554688e+01 -2.1613000488281250e+02 -2.9825000762939453e+01 4.6632900238037109e+01 -2.1613000488281250e+02 -3.7881999969482422e+01 4.8933799743652344e+01 -2.1613000488281250e+02 -4.6468898773193359e+01 4.9708602905273438e+01 -2.1613000488281250e+02 -5.5325000762939453e+01 4.8933799743652344e+01 -2.1613000488281250e+02 -6.4181098937988281e+01 4.6632900238037109e+01 -2.1613000488281250e+02 -7.2768005371093750e+01 4.2875900268554688e+01 -2.1613000488281250e+02 -8.0825004577636719e+01 3.7776897430419922e+01 -2.1613000488281250e+02 -8.8107200622558594e+01 3.1490798950195312e+01 -2.1613000488281250e+02 -9.4393295288085938e+01 2.4208599090576172e+01 -2.1613000488281250e+02 -9.9492294311523438e+01 1.6151599884033203e+01 -2.1613000488281250e+02 -1.0324900054931641e+02 7.5646600723266602e+00 -2.1613000488281250e+02 -1.0554999542236328e+02 -1.2914000749588013e+00 -2.1613000488281250e+02 -1.0632499694824219e+02 -1.0147500038146973e+01 -2.1613000488281250e+02 -1.0554999542236328e+02 -1.8734399795532227e+01 -2.1613000488281250e+02 -1.0324900054931641e+02 -2.6791399002075195e+01 -2.1613000488281250e+02 -9.9492294311523438e+01 -3.4073596954345703e+01 -2.1613000488281250e+02 -9.4393295288085938e+01 -4.0359699249267578e+01 -2.1613000488281250e+02 -8.8107200622558594e+01 -4.5458702087402344e+01 -2.1613000488281250e+02 -8.0825004577636719e+01 -4.9215702056884766e+01 -2.1613000488281250e+02 -7.2768005371093750e+01 -5.1516601562500000e+01 -2.1613000488281250e+02 -6.4181098937988281e+01 -5.2291400909423828e+01 -2.1613000488281250e+02 -5.5325000762939453e+01 -5.1516601562500000e+01 -2.1613000488281250e+02 -4.6468898773193359e+01 -4.9215702056884766e+01 -2.1613000488281250e+02 -3.7881999969482422e+01 -4.5458702087402344e+01 -2.1613000488281250e+02 -2.9825000762939453e+01 -4.0359699249267578e+01 -2.1613000488281250e+02 -2.2542800903320312e+01 -3.4073596954345703e+01 -2.1613000488281250e+02 -1.6256698608398438e+01 -2.6791399002075195e+01 -2.1613000488281250e+02 -1.1157699584960938e+01 -1.8734399795532227e+01 -2.1613000488281250e+02 -7.4006800651550293e+00 -1.0147500038146973e+01 -2.1613000488281250e+02 -5.0998101234436035e+00 -5.4738698005676270e+00 -2.1613000488281250e+02 -1.1524200439453125e+01 -1.3687600135803223e+01 -2.1613000488281250e+02 -1.3107299804687500e+01 3.8732398986816406e+01 -2.1613000488281250e+02 -7.3603302001953125e+01 4.1468299865722656e+01 -2.1613000488281250e+02 -6.5698402404785156e+01 4.2658798217773438e+01 -2.1613000488281250e+02 -5.7418598175048828e+01 4.2260700225830078e+01 -2.1613000488281250e+02 -4.9063102722167969e+01 4.0288600921630859e+01 -2.1613000488281250e+02 -4.0934001922607422e+01 3.6813697814941406e+01 -2.1613000488281250e+02 -3.3325000762939453e+01 3.1961601257324219e+01 -2.1613000488281250e+02 -2.6511098861694336e+01 2.5907600402832031e+01 -2.1613000488281250e+02 -2.0738700866699219e+01 1.8870599746704102e+01 -2.1613000488281250e+02 -1.6216199874877930e+01 1.1104800224304199e+01 -2.1613000488281250e+02 -1.3107299804687500e+01 2.8910698890686035e+00 -2.1613000488281250e+02 -1.1524200439453125e+01 -4.1315200805664062e+01 -2.1613000488281250e+02 -7.3603302001953125e+01 -3.7132698059082031e+01 -2.1613000488281250e+02 -8.0847503662109375e+01 -3.1654901504516602e+01 -2.1613000488281250e+02 -8.7169296264648438e+01 -2.5079601287841797e+01 -2.1613000488281250e+02 -9.2340202331542969e+01 -1.7644500732421875e+01 -2.1613000488281250e+02 -9.6173194885253906e+01 -9.6184501647949219e+00 -2.1613000488281250e+02 -9.8529899597167969e+01 -1.2914000749588013e+00 -2.1613000488281250e+02 -9.9325004577636719e+01 7.0356497764587402e+00 -2.1613000488281250e+02 -9.8529899597167969e+01 1.5061699867248535e+01 -2.1613000488281250e+02 -9.6173194885253906e+01 2.2496801376342773e+01 -2.1613000488281250e+02 -9.2340202331542969e+01 2.9072099685668945e+01 -2.1613000488281250e+02 -8.7169296264648438e+01 3.4549900054931641e+01 -2.1613000488281250e+02 -8.0847503662109375e+01 -2.1453399658203125e+01 -2.1613000488281250e+02 -1.6216199874877930e+01 -2.8490400314331055e+01 -2.1613000488281250e+02 -2.0738700866699219e+01 -3.4544399261474609e+01 -2.1613000488281250e+02 -2.6511098861694336e+01 -3.9396499633789062e+01 -2.1613000488281250e+02 -3.3325000762939453e+01 -4.2871398925781250e+01 -2.1613000488281250e+02 -4.0934001922607422e+01 -4.4843498229980469e+01 -2.1613000488281250e+02 -4.9063102722167969e+01 -4.5241600036621094e+01 -2.1613000488281250e+02 -5.7418598175048828e+01 -4.4051097869873047e+01 -2.1613000488281250e+02 -6.5698402404785156e+01 -7.3947501182556152e+00 -2.2788000488281250e+02 -8.6992195129394531e+01 -1.3277500152587891e+01 -2.2788000488281250e+02 -8.5264900207519531e+01 -1.8727100372314453e+01 -2.2788000488281250e+02 -8.2455398559570312e+01 -2.3546400070190430e+01 -2.2788000488281250e+02 -7.8665397644042969e+01 -2.7561500549316406e+01 -2.2788000488281250e+02 -7.4031799316406250e+01 -3.0626998901367188e+01 -2.2788000488281250e+02 -6.8722099304199219e+01 -3.2632297515869141e+01 -2.2788000488281250e+02 -6.2928199768066406e+01 -3.3504898071289062e+01 -2.2788000488281250e+02 -5.6859500885009766e+01 -3.3213100433349609e+01 -2.2788000488281250e+02 -5.0735298156738281e+01 -3.1767700195312500e+01 -2.2788000488281250e+02 -4.4777099609375000e+01 -2.9220699310302734e+01 -2.2788000488281250e+02 -3.9200000762939453e+01 -2.5664299011230469e+01 -2.2788000488281250e+02 -3.4205699920654297e+01 -2.1227001190185547e+01 -2.2788000488281250e+02 -2.9974800109863281e+01 -1.6069200515747070e+01 -2.2788000488281250e+02 -2.6660099029541016e+01 -1.0377300262451172e+01 -2.2788000488281250e+02 -2.4381399154663086e+01 -4.3569598197937012e+00 -2.2788000488281250e+02 -2.3220998764038086e+01 1.7741599082946777e+00 -2.2788000488281250e+02 -2.3220998764038086e+01 7.7944798469543457e+00 -2.2788000488281250e+02 -2.4381399154663086e+01 1.3486400604248047e+01 -2.2788000488281250e+02 -2.6660099029541016e+01 1.8644201278686523e+01 -2.2788000488281250e+02 -2.9974800109863281e+01 2.3081501007080078e+01 -2.2788000488281250e+02 -3.4205699920654297e+01 2.6637901306152344e+01 -2.2788000488281250e+02 -3.9200000762939453e+01 2.9184900283813477e+01 -2.2788000488281250e+02 -4.4777099609375000e+01 3.0630300521850586e+01 -2.2788000488281250e+02 -5.0735298156738281e+01 3.0922100067138672e+01 -2.2788000488281250e+02 -5.6859500885009766e+01 3.0049499511718750e+01 -2.2788000488281250e+02 -6.2928199768066406e+01 2.8044198989868164e+01 -2.2788000488281250e+02 -6.8722099304199219e+01 2.4978698730468750e+01 -2.2788000488281250e+02 -7.4031799316406250e+01 2.0963600158691406e+01 -2.2788000488281250e+02 -7.8665397644042969e+01 1.6144300460815430e+01 -2.2788000488281250e+02 -8.2455398559570312e+01 1.0694700241088867e+01 -2.2788000488281250e+02 -8.5264900207519531e+01 4.8119502067565918e+00 -2.2788000488281250e+02 -8.6992195129394531e+01 -1.2914000749588013e+00 -2.2788000488281250e+02 -8.7575004577636719e+01 7.0750203132629395e+00 -2.2788000488281250e+02 -3.6063598632812500e+01 1.5680999755859375e+00 -2.2788000488281250e+02 -3.4520599365234375e+01 -4.1508998870849609e+00 -2.2788000488281250e+02 -3.4520599365234375e+01 1.9269399642944336e+01 -2.2788000488281250e+02 -5.9597599029541016e+01 1.9659599304199219e+01 -2.2788000488281250e+02 -5.3891899108886719e+01 1.8496099472045898e+01 -2.2788000488281250e+02 -4.8292499542236328e+01 1.5864999771118164e+01 -2.2788000488281250e+02 -4.3214702606201172e+01 4.3743300437927246e+00 -2.2788000488281250e+02 -7.5546302795410156e+01 9.6198596954345703e+00 -2.2788000488281250e+02 -7.3267799377441406e+01 1.4056200027465820e+01 -2.2788000488281250e+02 -6.9658599853515625e+01 1.1961400032043457e+01 -2.2788000488281250e+02 -3.9035099029541016e+01 1.7354200363159180e+01 -2.2788000488281250e+02 -6.4986396789550781e+01 -1.2202699661254883e+01 -2.2788000488281250e+02 -7.3267799377441406e+01 -6.9571299552917480e+00 -2.2788000488281250e+02 -7.5546302795410156e+01 -1.2914000749588013e+00 -2.2788000488281250e+02 -7.6324996948242188e+01 -9.6578197479248047e+00 -2.2788000488281250e+02 -3.6063598632812500e+01 -1.4544199943542480e+01 -2.2788000488281250e+02 -3.9035099029541016e+01 -1.9936998367309570e+01 -2.2788000488281250e+02 -6.4986396789550781e+01 -1.6638999938964844e+01 -2.2788000488281250e+02 -6.9658599853515625e+01 -1.8447799682617188e+01 -2.2788000488281250e+02 -4.3214702606201172e+01 -2.1078899383544922e+01 -2.2788000488281250e+02 -4.8292499542236328e+01 -2.2242401123046875e+01 -2.2788000488281250e+02 -5.3891899108886719e+01 -2.1852201461791992e+01 -2.2788000488281250e+02 -5.9597599029541016e+01 -6.9571299552917480e+00 -2.2988000488281250e+02 -7.5546302795410156e+01 -1.2914000749588013e+00 -2.2988000488281250e+02 -7.6324996948242188e+01 4.3743300437927246e+00 -2.2988000488281250e+02 -7.5546302795410156e+01 9.6198596954345703e+00 -2.2988000488281250e+02 -7.3267799377441406e+01 1.4056200027465820e+01 -2.2988000488281250e+02 -6.9658599853515625e+01 1.7354200363159180e+01 -2.2988000488281250e+02 -6.4986396789550781e+01 1.9269399642944336e+01 -2.2988000488281250e+02 -5.9597599029541016e+01 1.9659599304199219e+01 -2.2988000488281250e+02 -5.3891899108886719e+01 1.8496099472045898e+01 -2.2988000488281250e+02 -4.8292499542236328e+01 1.5864999771118164e+01 -2.2988000488281250e+02 -4.3214702606201172e+01 1.1961400032043457e+01 -2.2988000488281250e+02 -3.9035099029541016e+01 7.0750203132629395e+00 -2.2988000488281250e+02 -3.6063598632812500e+01 1.5680999755859375e+00 -2.2988000488281250e+02 -3.4520599365234375e+01 -4.1508998870849609e+00 -2.2988000488281250e+02 -3.4520599365234375e+01 -9.6578197479248047e+00 -2.2988000488281250e+02 -3.6063598632812500e+01 -1.4544199943542480e+01 -2.2988000488281250e+02 -3.9035099029541016e+01 -1.8447799682617188e+01 -2.2988000488281250e+02 -4.3214702606201172e+01 -2.1078899383544922e+01 -2.2988000488281250e+02 -4.8292499542236328e+01 -2.2242401123046875e+01 -2.2988000488281250e+02 -5.3891899108886719e+01 -2.1852201461791992e+01 -2.2988000488281250e+02 -5.9597599029541016e+01 -1.9936998367309570e+01 -2.2988000488281250e+02 -6.4986396789550781e+01 -1.6638999938964844e+01 -2.2988000488281250e+02 -6.9658599853515625e+01 -1.2202699661254883e+01 -2.2988000488281250e+02 -7.3267799377441406e+01 -3.0378599166870117e+00 -2.2988000488281250e+02 -4.7108600616455078e+01 -1.2914000749588013e+00 -2.2988000488281250e+02 -4.6924999237060547e+01 4.5505800843238831e-01 -2.2988000488281250e+02 -4.7108600616455078e+01 3.6460001468658447e+00 -2.2988000488281250e+02 -4.8529300689697266e+01 7.0625801086425781e+00 -2.2988000488281250e+02 -5.4446998596191406e+01 5.9832100868225098e+00 -2.2988000488281250e+02 -5.1125000000000000e+01 -1.2914000749588013e+00 -2.2988000488281250e+02 -6.3725002288818359e+01 2.1251900196075439e+00 -2.2988000488281250e+02 -6.2998802185058594e+01 4.9510197639465332e+00 -2.2988000488281250e+02 -6.0945701599121094e+01 6.6974697113037109e+00 -2.2988000488281250e+02 -5.7920700073242188e+01 -4.7079901695251465e+00 -2.2988000488281250e+02 -6.2998802185058594e+01 -9.2802696228027344e+00 -2.2988000488281250e+02 -5.7920700073242188e+01 -7.5338196754455566e+00 -2.2988000488281250e+02 -6.0945701599121094e+01 -8.5660095214843750e+00 -2.2988000488281250e+02 -5.1125000000000000e+01 -9.6453800201416016e+00 -2.2988000488281250e+02 -5.4446998596191406e+01 -6.2287998199462891e+00 -2.2988000488281250e+02 -4.8529300689697266e+01 -4.1315200805664062e+01 -1.5863000488281250e+02 -7.3603302001953125e+01 -4.4051097869873047e+01 -1.5863000488281250e+02 -6.5698402404785156e+01 -4.5241600036621094e+01 -1.5863000488281250e+02 -5.7418598175048828e+01 -4.4843498229980469e+01 -1.5863000488281250e+02 -4.9063102722167969e+01 -4.2871398925781250e+01 -1.5863000488281250e+02 -4.0934001922607422e+01 -3.9396499633789062e+01 -1.5863000488281250e+02 -3.3325000762939453e+01 -3.4544399261474609e+01 -1.5863000488281250e+02 -2.6511098861694336e+01 -2.8490400314331055e+01 -1.5863000488281250e+02 -2.0738700866699219e+01 -2.1453399658203125e+01 -1.5863000488281250e+02 -1.6216199874877930e+01 -1.3687600135803223e+01 -1.5863000488281250e+02 -1.3107299804687500e+01 -5.4738698005676270e+00 -1.5863000488281250e+02 -1.1524200439453125e+01 2.8910698890686035e+00 -1.5863000488281250e+02 -1.1524200439453125e+01 3.4549900054931641e+01 -1.5863000488281250e+02 -8.0847503662109375e+01 2.9072099685668945e+01 -1.5863000488281250e+02 -8.7169296264648438e+01 2.2496801376342773e+01 -1.5863000488281250e+02 -9.2340202331542969e+01 1.5061699867248535e+01 -1.5863000488281250e+02 -9.6173194885253906e+01 7.0356497764587402e+00 -1.5863000488281250e+02 -9.8529899597167969e+01 -1.2914000749588013e+00 -1.5863000488281250e+02 -9.9325004577636719e+01 -9.6184501647949219e+00 -1.5863000488281250e+02 -9.8529899597167969e+01 -1.7644500732421875e+01 -1.5863000488281250e+02 -9.6173194885253906e+01 -2.5079601287841797e+01 -1.5863000488281250e+02 -9.2340202331542969e+01 -3.1654901504516602e+01 -1.5863000488281250e+02 -8.7169296264648438e+01 -3.7132698059082031e+01 -1.5863000488281250e+02 -8.0847503662109375e+01 1.1104800224304199e+01 -1.5863000488281250e+02 -1.3107299804687500e+01 1.8870599746704102e+01 -1.5863000488281250e+02 -1.6216199874877930e+01 2.5907600402832031e+01 -1.5863000488281250e+02 -2.0738700866699219e+01 3.1961601257324219e+01 -1.5863000488281250e+02 -2.6511098861694336e+01 3.6813697814941406e+01 -1.5863000488281250e+02 -3.3325000762939453e+01 4.0288600921630859e+01 -1.5863000488281250e+02 -4.0934001922607422e+01 4.2260700225830078e+01 -1.5863000488281250e+02 -4.9063102722167969e+01 4.2658798217773438e+01 -1.5863000488281250e+02 -5.7418598175048828e+01 4.1468299865722656e+01 -1.5863000488281250e+02 -6.5698402404785156e+01 3.8732398986816406e+01 -1.5863000488281250e+02 -7.3603302001953125e+01 4.8119502067565918e+00 -1.4688000488281250e+02 -8.6992195129394531e+01 1.0694700241088867e+01 -1.4688000488281250e+02 -8.5264900207519531e+01 1.6144300460815430e+01 -1.4688000488281250e+02 -8.2455398559570312e+01 2.0963600158691406e+01 -1.4688000488281250e+02 -7.8665397644042969e+01 2.4978698730468750e+01 -1.4688000488281250e+02 -7.4031799316406250e+01 2.8044198989868164e+01 -1.4688000488281250e+02 -6.8722099304199219e+01 3.0049499511718750e+01 -1.4688000488281250e+02 -6.2928199768066406e+01 3.0922100067138672e+01 -1.4688000488281250e+02 -5.6859500885009766e+01 3.0630300521850586e+01 -1.4688000488281250e+02 -5.0735298156738281e+01 2.9184900283813477e+01 -1.4688000488281250e+02 -4.4777099609375000e+01 2.6637901306152344e+01 -1.4688000488281250e+02 -3.9200000762939453e+01 2.3081501007080078e+01 -1.4688000488281250e+02 -3.4205699920654297e+01 1.8644201278686523e+01 -1.4688000488281250e+02 -2.9974800109863281e+01 1.3486400604248047e+01 -1.4688000488281250e+02 -2.6660099029541016e+01 7.7944798469543457e+00 -1.4688000488281250e+02 -2.4381399154663086e+01 1.7741599082946777e+00 -1.4688000488281250e+02 -2.3220998764038086e+01 -4.3569598197937012e+00 -1.4688000488281250e+02 -2.3220998764038086e+01 -1.0377300262451172e+01 -1.4688000488281250e+02 -2.4381399154663086e+01 -1.6069200515747070e+01 -1.4688000488281250e+02 -2.6660099029541016e+01 -2.1227001190185547e+01 -1.4688000488281250e+02 -2.9974800109863281e+01 -2.5664299011230469e+01 -1.4688000488281250e+02 -3.4205699920654297e+01 -2.9220699310302734e+01 -1.4688000488281250e+02 -3.9200000762939453e+01 -3.1767700195312500e+01 -1.4688000488281250e+02 -4.4777099609375000e+01 -3.3213100433349609e+01 -1.4688000488281250e+02 -5.0735298156738281e+01 -3.3504898071289062e+01 -1.4688000488281250e+02 -5.6859500885009766e+01 -3.2632297515869141e+01 -1.4688000488281250e+02 -6.2928199768066406e+01 -3.0626998901367188e+01 -1.4688000488281250e+02 -6.8722099304199219e+01 -2.7561500549316406e+01 -1.4688000488281250e+02 -7.4031799316406250e+01 -2.3546400070190430e+01 -1.4688000488281250e+02 -7.8665397644042969e+01 -1.8727100372314453e+01 -1.4688000488281250e+02 -8.2455398559570312e+01 -1.3277500152587891e+01 -1.4688000488281250e+02 -8.5264900207519531e+01 -7.3947501182556152e+00 -1.4688000488281250e+02 -8.6992195129394531e+01 -1.2914000749588013e+00 -1.4688000488281250e+02 -8.7575004577636719e+01 9.6198596954345703e+00 -1.4688000488281250e+02 -7.3267799377441406e+01 4.3743300437927246e+00 -1.4688000488281250e+02 -7.5546302795410156e+01 -1.2914000749588013e+00 -1.4688000488281250e+02 -7.6324996948242188e+01 -6.9571299552917480e+00 -1.4688000488281250e+02 -7.5546302795410156e+01 -1.2202699661254883e+01 -1.4688000488281250e+02 -7.3267799377441406e+01 -1.6638999938964844e+01 -1.4688000488281250e+02 -6.9658599853515625e+01 -1.9936998367309570e+01 -1.4688000488281250e+02 -6.4986396789550781e+01 -2.1852201461791992e+01 -1.4688000488281250e+02 -5.9597599029541016e+01 1.7354200363159180e+01 -1.4688000488281250e+02 -6.4986396789550781e+01 1.4056200027465820e+01 -1.4688000488281250e+02 -6.9658599853515625e+01 1.5680999755859375e+00 -1.4688000488281250e+02 -3.4520599365234375e+01 7.0750203132629395e+00 -1.4688000488281250e+02 -3.6063598632812500e+01 1.1961400032043457e+01 -1.4688000488281250e+02 -3.9035099029541016e+01 -2.2242401123046875e+01 -1.4688000488281250e+02 -5.3891899108886719e+01 -2.1078899383544922e+01 -1.4688000488281250e+02 -4.8292499542236328e+01 -1.8447799682617188e+01 -1.4688000488281250e+02 -4.3214702606201172e+01 1.5864999771118164e+01 -1.4688000488281250e+02 -4.3214702606201172e+01 1.8496099472045898e+01 -1.4688000488281250e+02 -4.8292499542236328e+01 1.9659599304199219e+01 -1.4688000488281250e+02 -5.3891899108886719e+01 1.9269399642944336e+01 -1.4688000488281250e+02 -5.9597599029541016e+01 -9.6578197479248047e+00 -1.4688000488281250e+02 -3.6063598632812500e+01 -4.1508998870849609e+00 -1.4688000488281250e+02 -3.4520599365234375e+01 -1.4544199943542480e+01 -1.4688000488281250e+02 -3.9035099029541016e+01 -3.0378599166870117e+00 -1.4262998962402344e+02 -6.3541397094726562e+01 -1.2914000749588013e+00 -1.4262998962402344e+02 -6.3725002288818359e+01 -6.2287998199462891e+00 -1.4262998962402344e+02 -6.2120697021484375e+01 -8.5660095214843750e+00 -1.4262998962402344e+02 -5.9525001525878906e+01 -9.6453800201416016e+00 -1.4262998962402344e+02 -5.6202999114990234e+01 -9.2802696228027344e+00 -1.4262998962402344e+02 -5.2729301452636719e+01 -7.5338196754455566e+00 -1.4262998962402344e+02 -4.9704299926757812e+01 -4.7079901695251465e+00 -1.4262998962402344e+02 -4.7651203155517578e+01 -1.2914000749588013e+00 -1.4262998962402344e+02 -4.6924999237060547e+01 2.1251900196075439e+00 -1.4262998962402344e+02 -4.7651203155517578e+01 4.9510197639465332e+00 -1.4262998962402344e+02 -4.9704299926757812e+01 6.6974697113037109e+00 -1.4262998962402344e+02 -5.2729301452636719e+01 7.0625801086425781e+00 -1.4262998962402344e+02 -5.6202999114990234e+01 5.9832100868225098e+00 -1.4262998962402344e+02 -5.9525001525878906e+01 3.6460001468658447e+00 -1.4262998962402344e+02 -6.2120697021484375e+01 4.5505800843238831e-01 -1.4262998962402344e+02 -6.3541397094726562e+01 -3.0378599166870117e+00 -2.3213000488281250e+02 -4.7108600616455078e+01 -6.2287998199462891e+00 -2.3213000488281250e+02 -4.8529300689697266e+01 -8.5660095214843750e+00 -2.3213000488281250e+02 -5.1125000000000000e+01 -9.6453800201416016e+00 -2.3213000488281250e+02 -5.4446998596191406e+01 -9.2802696228027344e+00 -2.3213000488281250e+02 -5.7920700073242188e+01 -7.5338196754455566e+00 -2.3213000488281250e+02 -6.0945701599121094e+01 -4.7079901695251465e+00 -2.3213000488281250e+02 -6.2998802185058594e+01 -1.2914000749588013e+00 -2.3213000488281250e+02 -6.3725002288818359e+01 2.1251900196075439e+00 -2.3213000488281250e+02 -6.2998802185058594e+01 4.9510197639465332e+00 -2.3213000488281250e+02 -6.0945701599121094e+01 6.6974697113037109e+00 -2.3213000488281250e+02 -5.7920700073242188e+01 7.0625801086425781e+00 -2.3213000488281250e+02 -5.4446998596191406e+01 5.9832100868225098e+00 -2.3213000488281250e+02 -5.1125000000000000e+01 3.6460001468658447e+00 -2.3213000488281250e+02 -4.8529300689697266e+01 4.5505800843238831e-01 -2.3213000488281250e+02 -4.7108600616455078e+01 -2.0768399238586426e+00 -1.6188000488281250e+02 -6.8313598632812500e+00 -1.0974200248718262e+01 -2.1288000488281250e+02 -7.8013801574707031e+00 -1.0974200248718262e+01 -1.6188000488281250e+02 -7.8013801574707031e+00 -1.9541700363159180e+01 -2.1288000488281250e+02 -1.0389800071716309e+01 -1.9541700363159180e+01 -1.6188000488281250e+02 -1.0389800071716309e+01 -2.7487798690795898e+01 -2.1288000488281250e+02 -1.4508399963378906e+01 -2.7487798690795898e+01 -1.6188000488281250e+02 -1.4508399963378906e+01 -3.4541801452636719e+01 -2.1288000488281250e+02 -2.0016899108886719e+01 -3.4541801452636719e+01 -1.6188000488281250e+02 -2.0016899108886719e+01 -4.0463500976562500e+01 -2.1288000488281250e+02 -2.6727899551391602e+01 -4.0463500976562500e+01 -1.6188000488281250e+02 -2.6727899551391602e+01 -4.5051197052001953e+01 -2.1288000488281250e+02 -3.4412601470947266e+01 -4.5051197052001953e+01 -1.6188000488281250e+02 -3.4412601470947266e+01 -4.8148799896240234e+01 -2.1288000488281250e+02 -4.2809501647949219e+01 -4.8148799896240234e+01 -1.6188000488281250e+02 -4.2809501647949219e+01 -4.9650596618652344e+01 -2.1288000488281250e+02 -5.1632698059082031e+01 -4.9650596618652344e+01 -1.6188000488281250e+02 -5.1632698059082031e+01 -4.9505699157714844e+01 -2.1288000488281250e+02 -6.0581501007080078e+01 -4.9505699157714844e+01 -1.6188000488281250e+02 -6.0581501007080078e+01 -4.7718902587890625e+01 -2.1288000488281250e+02 -6.9351394653320312e+01 -4.7718902587890625e+01 -1.6188000488281250e+02 -6.9351394653320312e+01 -4.4351001739501953e+01 -2.1288000488281250e+02 -7.7643600463867188e+01 -4.4351001739501953e+01 -1.6188000488281250e+02 -7.7643600463867188e+01 -3.9516799926757812e+01 -2.1288000488281250e+02 -8.5175697326660156e+01 -3.9516799926757812e+01 -1.6188000488281250e+02 -8.5175697326660156e+01 -3.3380901336669922e+01 -2.1288000488281250e+02 -9.1691398620605469e+01 -3.3380901336669922e+01 -1.6188000488281250e+02 -9.1691398620605469e+01 -2.6152198791503906e+01 -2.1288000488281250e+02 -9.6968597412109375e+01 -2.6152198791503906e+01 -1.6188000488281250e+02 -9.6968597412109375e+01 -1.8076900482177734e+01 -2.1288000488281250e+02 -1.0082800292968750e+02 -1.8076900482177734e+01 -1.6188000488281250e+02 -1.0082800292968750e+02 -9.4300203323364258e+00 -2.1288000488281250e+02 -1.0313700103759766e+02 -9.4300203323364258e+00 -1.6188000488281250e+02 -1.0313700103759766e+02 -5.0595897436141968e-01 -2.1288000488281250e+02 -1.0381900024414062e+02 -5.0595897436141968e-01 -1.6188000488281250e+02 -1.0381900024414062e+02 8.3913497924804688e+00 -2.1288000488281250e+02 -1.0284899902343750e+02 8.3913497924804688e+00 -1.6188000488281250e+02 -1.0284899902343750e+02 1.6958900451660156e+01 -2.1288000488281250e+02 -1.0025999450683594e+02 1.6958900451660156e+01 -1.6188000488281250e+02 -1.0025999450683594e+02 2.4905000686645508e+01 -2.1288000488281250e+02 -9.6141601562500000e+01 2.4905000686645508e+01 -1.6188000488281250e+02 -9.6141601562500000e+01 3.1959001541137695e+01 -2.1288000488281250e+02 -9.0633102416992188e+01 3.1959001541137695e+01 -1.6188000488281250e+02 -9.0633102416992188e+01 3.7880699157714844e+01 -2.1288000488281250e+02 -8.3922103881835938e+01 3.7880699157714844e+01 -1.6188000488281250e+02 -8.3922103881835938e+01 4.2468399047851562e+01 -2.1288000488281250e+02 -7.6237403869628906e+01 4.2468399047851562e+01 -1.6188000488281250e+02 -7.6237403869628906e+01 4.5566001892089844e+01 -2.1288000488281250e+02 -6.7840499877929688e+01 4.5566001892089844e+01 -1.6188000488281250e+02 -6.7840499877929688e+01 4.7067798614501953e+01 -2.1288000488281250e+02 -5.9017299652099609e+01 4.7067798614501953e+01 -1.6188000488281250e+02 -5.9017299652099609e+01 4.6922901153564453e+01 -2.1288000488281250e+02 -5.0068500518798828e+01 4.6922901153564453e+01 -1.6188000488281250e+02 -5.0068500518798828e+01 4.5136100769042969e+01 -2.1288000488281250e+02 -4.1298603057861328e+01 4.5136100769042969e+01 -1.6188000488281250e+02 -4.1298603057861328e+01 4.1768199920654297e+01 -2.1288000488281250e+02 -3.3006401062011719e+01 4.1768199920654297e+01 -1.6188000488281250e+02 -3.3006401062011719e+01 3.6933998107910156e+01 -2.1288000488281250e+02 -2.5474300384521484e+01 3.6933998107910156e+01 -1.6188000488281250e+02 -2.5474300384521484e+01 3.0798099517822266e+01 -2.1288000488281250e+02 -1.8958600997924805e+01 3.0798099517822266e+01 -1.6188000488281250e+02 -1.8958600997924805e+01 2.3569398880004883e+01 -2.1288000488281250e+02 -1.3681399345397949e+01 2.3569398880004883e+01 -1.6188000488281250e+02 -1.3681399345397949e+01 1.5494099617004395e+01 -2.1288000488281250e+02 -9.8222904205322266e+00 1.5494099617004395e+01 -1.6188000488281250e+02 -9.8222904205322266e+00 6.8472199440002441e+00 -2.1288000488281250e+02 -7.5127396583557129e+00 6.8472199440002441e+00 -1.6188000488281250e+02 -7.5127396583557129e+00 -2.0768399238586426e+00 -2.1288000488281250e+02 -6.8313598632812500e+00 -5.7242898941040039e+00 -2.1288000488281250e+02 -1.6785600185394287e+00 1.3232899665832520e+01 -2.1288000488281250e+02 -3.4922401905059814e+00 7.0005302429199219e+00 -2.1288000488281250e+02 -2.1382100582122803e+00 6.5175896883010864e-01 -2.1288000488281250e+02 -1.5308099985122681e+00 2.5001300811767578e+01 -2.1288000488281250e+02 -8.3539199829101562e+00 1.9261400222778320e+01 -2.1288000488281250e+02 -5.5738797187805176e+00 4.3159400939941406e+01 -2.1288000488281250e+02 -8.5684700012207031e+01 6.3117499351501465e+00 -2.1288000488281250e+02 -1.0861500549316406e+02 1.2561100006103516e+01 -2.1288000488281250e+02 -1.0734099578857422e+02 -3.5478302001953125e+01 -2.1288000488281250e+02 -9.6904396057128906e+01 3.9711299896240234e+01 -2.1288000488281250e+02 -2.0448600769042969e+01 3.5298599243164062e+01 -2.1288000488281250e+02 -1.5843799591064453e+01 3.0372200012207031e+01 -2.1288000488281250e+02 -1.1793299674987793e+01 5.2536800384521484e+01 -2.1288000488281250e+02 -5.5673202514648438e+01 1.8616001129150391e+01 -2.1288000488281250e+02 -1.0533799743652344e+02 2.4391500473022461e+01 -2.1288000488281250e+02 -1.0263200378417969e+02 2.9806400299072266e+01 -2.1288000488281250e+02 -9.9262702941894531e+01 3.4784801483154297e+01 -2.1288000488281250e+02 -9.5276199340820312e+01 3.9256698608398438e+01 -2.1288000488281250e+02 -9.0728996276855469e+01 -3.9670898437500000e+01 -2.1288000488281250e+02 -1.7581100463867188e+01 5.2200099945068359e+01 -2.1288000488281250e+02 -4.9304298400878906e+01 5.1112598419189453e+01 -2.1288000488281250e+02 -4.3020000457763672e+01 4.9289402008056641e+01 -2.1288000488281250e+02 -3.6908397674560547e+01 4.6756198883056641e+01 -2.1288000488281250e+02 -3.1055299758911133e+01 4.3548500061035156e+01 -2.1288000488281250e+02 -2.5542900085449219e+01 4.6438198089599609e+01 -2.1288000488281250e+02 -8.0214302062988281e+01 4.9046901702880859e+01 -2.1288000488281250e+02 -7.4394500732421875e+01 5.0949001312255859e+01 -2.1288000488281250e+02 -6.8306900024414062e+01 5.2117702484130859e+01 -2.1288000488281250e+02 -6.2037200927734375e+01 -6.4179501533508301e+00 -2.1288000488281250e+02 -1.0891000366210938e+02 -4.4343903660774231e-02 -2.1288000488281250e+02 -1.0913999938964844e+02 -5.4209098815917969e+01 -2.1288000488281250e+02 -4.5460601806640625e+01 -5.5004398345947266e+01 -2.1288000488281250e+02 -5.1788597106933594e+01 -4.3865600585937500e+01 -2.1288000488281250e+02 -2.2385299682617188e+01 -4.7462699890136719e+01 -2.1288000488281250e+02 -2.7651901245117188e+01 -5.0411602020263672e+01 -2.1288000488281250e+02 -3.3306999206542969e+01 -5.2671001434326172e+01 -2.1288000488281250e+02 -3.9271102905273438e+01 -3.0320600509643555e+01 -2.1288000488281250e+02 -1.0065600585937500e+02 -2.4755399703979492e+01 -2.1288000488281250e+02 -1.0377100372314453e+02 -1.8860799789428711e+01 -2.1288000488281250e+02 -1.0620600128173828e+02 -1.2719600677490234e+01 -2.1288000488281250e+02 -1.0792700195312500e+02 -1.2038099288940430e+01 -2.1288000488281250e+02 -2.5793900489807129e+00 -1.8201099395751953e+01 -2.1288000488281250e+02 -4.2206597328186035e+00 -2.4126699447631836e+01 -2.1288000488281250e+02 -6.5793199539184570e+00 -2.9731700897216797e+01 -2.1288000488281250e+02 -9.6222600936889648e+00 -3.4937500000000000e+01 -2.1288000488281250e+02 -1.3306799888610840e+01 -5.0692401885986328e+01 -2.1288000488281250e+02 -7.6705703735351562e+01 -4.7816898345947266e+01 -2.1288000488281250e+02 -8.2398498535156250e+01 -4.4288200378417969e+01 -2.1288000488281250e+02 -8.7711196899414062e+01 -4.0155998229980469e+01 -2.1288000488281250e+02 -9.2569198608398438e+01 -5.5045600891113281e+01 -2.1288000488281250e+02 -5.8166198730468750e+01 -5.4332302093505859e+01 -2.1288000488281250e+02 -6.4503997802734375e+01 -5.2874401092529297e+01 -2.1288000488281250e+02 -7.0712898254394531e+01 -1.9083301544189453e+01 -2.0686000061035156e+02 -1.5543600320816040e+00 -2.5318099975585938e+01 -2.0686000061035156e+02 -4.0360698699951172e+00 -3.1215499877929688e+01 -2.0686000061035156e+02 -7.2377800941467285e+00 -3.6692897796630859e+01 -2.0686000061035156e+02 -1.1114500045776367e+01 -4.1673297882080078e+01 -2.0686000061035156e+02 -1.5611900329589844e+01 -4.6086898803710938e+01 -2.0686000061035156e+02 -2.0666700363159180e+01 -4.9871601104736328e+01 -2.0686000061035156e+02 -2.6208101272583008e+01 -5.2974399566650391e+01 -2.0686000061035156e+02 -3.2158199310302734e+01 -5.5351699829101562e+01 -2.0686000061035156e+02 -3.8433498382568359e+01 -5.6970001220703125e+01 -2.0686000061035156e+02 -4.4945999145507812e+01 -5.7806800842285156e+01 -2.0686000061035156e+02 -5.1604099273681641e+01 -5.7850200653076172e+01 -2.0686000061035156e+02 -5.8314498901367188e+01 -5.7099597930908203e+01 -2.0686000061035156e+02 -6.4982894897460938e+01 -5.5565700531005859e+01 -2.0686000061035156e+02 -7.1515701293945312e+01 -5.3269798278808594e+01 -2.0686000061035156e+02 -7.7821205139160156e+01 -5.0244300842285156e+01 -2.0686000061035156e+02 -8.3810997009277344e+01 -4.6531497955322266e+01 -2.0686000061035156e+02 -8.9400901794433594e+01 -4.2183700561523438e+01 -2.0686000061035156e+02 -9.4512405395507812e+01 -3.7261898040771484e+01 -2.0686000061035156e+02 -9.9073799133300781e+01 -3.1835102081298828e+01 -2.0686000061035156e+02 -1.0302100372314453e+02 -2.5979600906372070e+01 -2.0686000061035156e+02 -1.0629899597167969e+02 -1.9777498245239258e+01 -2.0686000061035156e+02 -1.0886100006103516e+02 -1.3315799713134766e+01 -2.0686000061035156e+02 -1.1067199707031250e+02 -6.6854200363159180e+00 -2.0686000061035156e+02 -1.1170499420166016e+02 2.0719299092888832e-02 -2.0686000061035156e+02 -1.1194799804687500e+02 6.7084398269653320e+00 -2.0686000061035156e+02 -1.1139500427246094e+02 1.3283900260925293e+01 -2.0686000061035156e+02 -1.1005500030517578e+02 1.9654701232910156e+01 -2.0686000061035156e+02 -1.0794699859619141e+02 2.5731399536132812e+01 -2.0686000061035156e+02 -1.0509999847412109e+02 3.1428899765014648e+01 -2.0686000061035156e+02 -1.0155500030517578e+02 3.6666999816894531e+01 -2.0686000061035156e+02 -9.7360603332519531e+01 4.1372299194335938e+01 -2.0686000061035156e+02 -9.2576103210449219e+01 4.5478599548339844e+01 -2.0686000061035156e+02 -8.7268699645996094e+01 4.8928398132324219e+01 -2.0686000061035156e+02 -8.1512901306152344e+01 5.1673301696777344e+01 -2.0686000061035156e+02 -7.5389396667480469e+01 5.3674602508544922e+01 -2.0686000061035156e+02 -6.8984298706054688e+01 5.4904300689697266e+01 -2.0686000061035156e+02 -6.2387397766113281e+01 5.5345199584960938e+01 -2.0686000061035156e+02 -5.5691398620605469e+01 5.4991001129150391e+01 -2.0686000061035156e+02 -4.8990200042724609e+01 5.3846698760986328e+01 -2.0686000061035156e+02 -4.2378002166748047e+01 5.1928401947021484e+01 -2.0686000061035156e+02 -3.5947502136230469e+01 4.9263000488281250e+01 -2.0686000061035156e+02 -2.9789001464843750e+01 4.5888000488281250e+01 -2.0686000061035156e+02 -2.3989000320434570e+01 4.1850601196289062e+01 -2.0686000061035156e+02 -1.8628900527954102e+01 3.7207599639892578e+01 -2.0686000061035156e+02 -1.3783999443054199e+01 3.2024200439453125e+01 -2.0686000061035156e+02 -9.5221300125122070e+00 2.6373100280761719e+01 -2.0686000061035156e+02 -5.9032702445983887e+00 2.0333700180053711e+01 -2.0686000061035156e+02 -2.9781901836395264e+00 1.3990699768066406e+01 -2.0686000061035156e+02 -7.8793102502822876e-01 7.4331498146057129e+00 -2.0686000061035156e+02 6.3673901557922363e-01 7.5314003229141235e-01 -2.0686000061035156e+02 1.2758300304412842e+00 -5.9555697441101074e+00 -2.0686000061035156e+02 1.1203700304031372e+00 -1.2598799705505371e+01 -2.0686000061035156e+02 1.7253500223159790e-01 -1.9723499298095703e+01 -2.0053700256347656e+02 3.8028699159622192e-01 -2.6182500839233398e+01 -2.0053700256347656e+02 -2.1907200813293457e+00 -3.2292198181152344e+01 -2.0053700256347656e+02 -5.5076198577880859e+00 -3.7966602325439453e+01 -2.0053700256347656e+02 -9.5238399505615234e+00 -4.3126300811767578e+01 -2.0053700256347656e+02 -1.4182999610900879e+01 -4.7698596954345703e+01 -2.0053700256347656e+02 -1.9419700622558594e+01 -5.1619499206542969e+01 -2.0053700256347656e+02 -2.5160501480102539e+01 -5.4833900451660156e+01 -2.0053700256347656e+02 -3.1324699401855469e+01 -5.7296699523925781e+01 -2.0053700256347656e+02 -3.7825801849365234e+01 -5.8973300933837891e+01 -2.0053700256347656e+02 -4.4572498321533203e+01 -5.9840198516845703e+01 -2.0053700256347656e+02 -5.1470199584960938e+01 -5.9885200500488281e+01 -2.0053700256347656e+02 -5.8422000885009766e+01 -5.9107601165771484e+01 -2.0053700256347656e+02 -6.5330299377441406e+01 -5.7518402099609375e+01 -2.0053700256347656e+02 -7.2098205566406250e+01 -5.5139999389648438e+01 -2.0053700256347656e+02 -7.8630599975585938e+01 -5.2005599975585938e+01 -2.0053700256347656e+02 -8.4835899353027344e+01 -4.8159301757812500e+01 -2.0053700256347656e+02 -9.0626899719238281e+01 -4.3654998779296875e+01 -2.0053700256347656e+02 -9.5922302246093750e+01 -3.8556098937988281e+01 -2.0053700256347656e+02 -1.0064800262451172e+02 -3.2934101104736328e+01 -2.0053700256347656e+02 -1.0473699951171875e+02 -2.6867799758911133e+01 -2.0053700256347656e+02 -1.0813300323486328e+02 -2.0442600250244141e+01 -2.0053700256347656e+02 -1.1078699493408203e+02 -1.3748499870300293e+01 -2.0053700256347656e+02 -1.1266300201416016e+02 -6.8794898986816406e+00 -2.0053700256347656e+02 -1.1373400115966797e+02 6.7928604781627655e-02 -2.0053700256347656e+02 -1.1398500061035156e+02 6.9962697029113770e+00 -2.0053700256347656e+02 -1.1341200256347656e+02 1.3808300018310547e+01 -2.0053700256347656e+02 -1.1202400207519531e+02 2.0408300399780273e+01 -2.0053700256347656e+02 -1.0984099578857422e+02 2.6703701019287109e+01 -2.0053700256347656e+02 -1.0689099884033203e+02 3.2606098175048828e+01 -2.0053700256347656e+02 -1.0321799468994141e+02 3.8032699584960938e+01 -2.0053700256347656e+02 -9.8873100280761719e+01 4.2907302856445312e+01 -2.0053700256347656e+02 -9.3916404724121094e+01 4.7161399841308594e+01 -2.0053700256347656e+02 -8.8417999267578125e+01 5.0735298156738281e+01 -2.0053700256347656e+02 -8.2455101013183594e+01 5.3578899383544922e+01 -2.0053700256347656e+02 -7.6111305236816406e+01 5.5652202606201172e+01 -2.0053700256347656e+02 -6.9475700378417969e+01 5.6926197052001953e+01 -2.0053700256347656e+02 -6.2641502380371094e+01 5.7382900238037109e+01 -2.0053700256347656e+02 -5.5704601287841797e+01 5.7015998840332031e+01 -2.0053700256347656e+02 -4.8762298583984375e+01 5.5830501556396484e+01 -2.0053700256347656e+02 -4.1912200927734375e+01 5.3843200683593750e+01 -2.0053700256347656e+02 -3.5250297546386719e+01 5.1081897735595703e+01 -2.0053700256347656e+02 -2.8870300292968750e+01 4.7585403442382812e+01 -2.0053700256347656e+02 -2.2861598968505859e+01 4.3402797698974609e+01 -2.0053700256347656e+02 -1.7308599472045898e+01 3.8592800140380859e+01 -2.0053700256347656e+02 -1.2289299964904785e+01 3.3222900390625000e+01 -2.0053700256347656e+02 -7.8741602897644043e+00 2.7368501663208008e+01 -2.0053700256347656e+02 -4.1250896453857422e+00 2.1111799240112305e+01 -2.0053700256347656e+02 -1.0947600603103638e+00 1.4540499687194824e+01 -2.0053700256347656e+02 1.1742899417877197e+00 7.7470498085021973e+00 -2.0053700256347656e+02 2.6502199172973633e+00 8.2670199871063232e-01 -2.0053700256347656e+02 3.3122999668121338e+00 -6.1233901977539062e+00 -2.0053700256347656e+02 3.1512501239776611e+00 -1.3005599975585938e+01 -2.0053700256347656e+02 2.1693198680877686e+00 -2.0111600875854492e+01 -1.9401000976562500e+02 1.5532300472259521e+00 -2.6706600189208984e+01 -1.9401000976562500e+02 -1.0719100236892700e+00 -3.2944900512695312e+01 -1.9401000976562500e+02 -4.4586501121520996e+00 -3.8738899230957031e+01 -1.9401000976562500e+02 -8.5594406127929688e+00 -4.4007202148437500e+01 -1.9401000976562500e+02 -1.3316699981689453e+01 -4.8675800323486328e+01 -1.9401000976562500e+02 -1.8663700103759766e+01 -5.2679298400878906e+01 -1.9401000976562500e+02 -2.4525299072265625e+01 -5.5961299896240234e+01 -1.9401000976562500e+02 -3.0819299697875977e+01 -5.8476001739501953e+01 -1.9401000976562500e+02 -3.7457298278808594e+01 -6.0187896728515625e+01 -1.9401000976562500e+02 -4.4346099853515625e+01 -6.1073001861572266e+01 -1.9401000976562500e+02 -5.1388999938964844e+01 -6.1118900299072266e+01 -1.9401000976562500e+02 -5.8487197875976562e+01 -6.0325000762939453e+01 -1.9401000976562500e+02 -6.5541000366210938e+01 -5.8702400207519531e+01 -1.9401000976562500e+02 -7.2451400756835938e+01 -5.6273799896240234e+01 -1.9401000976562500e+02 -7.9121406555175781e+01 -5.3073398590087891e+01 -1.9401000976562500e+02 -8.5457305908203125e+01 -4.9146099090576172e+01 -1.9401000976562500e+02 -9.1370201110839844e+01 -4.4547000885009766e+01 -1.9401000976562500e+02 -9.6777198791503906e+01 -3.9340801239013672e+01 -1.9401000976562500e+02 -1.0160200500488281e+02 -3.3600299835205078e+01 -1.9401000976562500e+02 -1.0577799987792969e+02 -2.7406400680541992e+01 -1.9401000976562500e+02 -1.0924500274658203e+02 -2.0845800399780273e+01 -1.9401000976562500e+02 -1.1195500183105469e+02 -1.4010800361633301e+01 -1.9401000976562500e+02 -1.1387000274658203e+02 -6.9971599578857422e+00 -1.9401000976562500e+02 -1.1496400451660156e+02 9.6551105380058289e-02 -1.9401000976562500e+02 -1.1522000122070312e+02 7.1707696914672852e+00 -1.9401000976562500e+02 -1.1463499450683594e+02 1.4126200675964355e+01 -1.9401000976562500e+02 -1.1321800231933594e+02 2.0865200042724609e+01 -1.9401000976562500e+02 -1.1098799896240234e+02 2.7293199539184570e+01 -1.9401000976562500e+02 -1.0797700500488281e+02 3.3319900512695312e+01 -1.9401000976562500e+02 -1.0422699737548828e+02 3.8860702514648438e+01 -1.9401000976562500e+02 -9.9790000915527344e+01 4.3837902069091797e+01 -1.9401000976562500e+02 -9.4728996276855469e+01 4.8181602478027344e+01 -1.9401000976562500e+02 -8.9114799499511719e+01 5.1830799102783203e+01 -1.9401000976562500e+02 -8.3026298522949219e+01 5.4734302520751953e+01 -1.9401000976562500e+02 -7.6549003601074219e+01 5.6851200103759766e+01 -1.9401000976562500e+02 -6.9773696899414062e+01 5.8152000427246094e+01 -1.9401000976562500e+02 -6.2795497894287109e+01 5.8618400573730469e+01 -1.9401000976562500e+02 -5.5712497711181641e+01 5.8243698120117188e+01 -1.9401000976562500e+02 -4.8624099731445312e+01 5.7033302307128906e+01 -1.9401000976562500e+02 -4.1629703521728516e+01 5.5004100799560547e+01 -1.9401000976562500e+02 -3.4827602386474609e+01 5.2184700012207031e+01 -1.9401000976562500e+02 -2.8313199996948242e+01 4.8614597320556641e+01 -1.9401000976562500e+02 -2.2177999496459961e+01 4.4343898773193359e+01 -1.9401000976562500e+02 -1.6508100509643555e+01 3.9432601928710938e+01 -1.9401000976562500e+02 -1.1383199691772461e+01 3.3949600219726562e+01 -1.9401000976562500e+02 -6.8750200271606445e+00 2.7972000122070312e+01 -1.9401000976562500e+02 -3.0470199584960938e+00 2.1583499908447266e+01 -1.9401000976562500e+02 4.7115202993154526e-02 1.4873900413513184e+01 -1.9401000976562500e+02 2.3639500141143799e+00 7.9373698234558105e+00 -1.9401000976562500e+02 3.8709499835968018e+00 8.7130099534988403e-01 -1.9401000976562500e+02 4.5469799041748047e+00 -6.2251300811767578e+00 -1.9401000976562500e+02 4.3825402259826660e+00 -1.3252300262451172e+01 -1.9401000976562500e+02 3.3799200057983398e+00 -2.0241600036621094e+01 -1.8738000488281250e+02 1.9462399482727051e+00 -2.6882200241088867e+01 -1.8738000488281250e+02 -6.9703799486160278e-01 -3.3163700103759766e+01 -1.8738000488281250e+02 -4.1071801185607910e+00 -3.8997600555419922e+01 -1.8738000488281250e+02 -8.2363100051879883e+00 -4.4302299499511719e+01 -1.8738000488281250e+02 -1.3026499748229980e+01 -4.9003200531005859e+01 -1.8738000488281250e+02 -1.8410400390625000e+01 -5.3034301757812500e+01 -1.8738000488281250e+02 -2.4312500000000000e+01 -5.6339099884033203e+01 -1.8738000488281250e+02 -3.0649999618530273e+01 -5.8871101379394531e+01 -1.8738000488281250e+02 -3.7333801269531250e+01 -6.0594799041748047e+01 -1.8738000488281250e+02 -4.4270198822021484e+01 -6.1486099243164062e+01 -1.8738000488281250e+02 -5.1361801147460938e+01 -6.1532299041748047e+01 -1.8738000488281250e+02 -5.8509101867675781e+01 -6.0732902526855469e+01 -1.8738000488281250e+02 -6.5611602783203125e+01 -5.9099102020263672e+01 -1.8738000488281250e+02 -7.2569694519042969e+01 -5.6653701782226562e+01 -1.8738000488281250e+02 -7.9285797119140625e+01 -5.3431201934814453e+01 -1.8738000488281250e+02 -8.5665504455566406e+01 -4.9476799011230469e+01 -1.8738000488281250e+02 -9.1619300842285156e+01 -4.4845901489257812e+01 -1.8738000488281250e+02 -9.7063598632812500e+01 -3.9603698730468750e+01 -1.8738000488281250e+02 -1.0192199707031250e+02 -3.3823596954345703e+01 -1.8738000488281250e+02 -1.0612599945068359e+02 -2.7586799621582031e+01 -1.8738000488281250e+02 -1.0961700439453125e+02 -2.0980899810791016e+01 -1.8738000488281250e+02 -1.1234600067138672e+02 -1.4098700523376465e+01 -1.8738000488281250e+02 -1.1427500152587891e+02 -7.0365796089172363e+00 -1.8738000488281250e+02 -1.1537599945068359e+02 1.0614199936389923e-01 -1.8738000488281250e+02 -1.1563400268554688e+02 7.2292499542236328e+00 -1.8738000488281250e+02 -1.1504500579833984e+02 1.4232699394226074e+01 -1.8738000488281250e+02 -1.1361800384521484e+02 2.1018301010131836e+01 -1.8738000488281250e+02 -1.1137300109863281e+02 2.7490699768066406e+01 -1.8738000488281250e+02 -1.0834100341796875e+02 3.3559097290039062e+01 -1.8738000488281250e+02 -1.0456500244140625e+02 3.9138202667236328e+01 -1.8738000488281250e+02 -1.0009700012207031e+02 4.4149799346923828e+01 -1.8738000488281250e+02 -9.5001304626464844e+01 4.8523502349853516e+01 -1.8738000488281250e+02 -8.9348304748535156e+01 5.2197898864746094e+01 -1.8738000488281250e+02 -8.3217704772949219e+01 5.5121398925781250e+01 -1.8738000488281250e+02 -7.6695602416992188e+01 5.7252998352050781e+01 -1.8738000488281250e+02 -6.9873497009277344e+01 5.8562801361083984e+01 -1.8738000488281250e+02 -6.2847198486328125e+01 5.9032299041748047e+01 -1.8738000488281250e+02 -5.5715198516845703e+01 5.8655101776123047e+01 -1.8738000488281250e+02 -4.8577800750732422e+01 5.7436298370361328e+01 -1.8738000488281250e+02 -4.1535102844238281e+01 5.5393100738525391e+01 -1.8738000488281250e+02 -3.4686000823974609e+01 5.2554203033447266e+01 -1.8738000488281250e+02 -2.8126598358154297e+01 4.8959499359130859e+01 -1.8738000488281250e+02 -2.1949001312255859e+01 4.4659301757812500e+01 -1.8738000488281250e+02 -1.6239900588989258e+01 3.9714000701904297e+01 -1.8738000488281250e+02 -1.1079500198364258e+01 3.4193099975585938e+01 -1.8738000488281250e+02 -6.5402398109436035e+00 2.8174200057983398e+01 -1.8738000488281250e+02 -2.6857900619506836e+00 2.1741500854492188e+01 -1.8738000488281250e+02 4.2972502112388611e-01 1.4985599517822266e+01 -1.8738000488281250e+02 2.7625701427459717e+00 8.0011405944824219e+00 -1.8738000488281250e+02 4.2799801826477051e+00 8.8624501228332520e-01 -1.8738000488281250e+02 4.9606800079345703e+00 -6.2592201232910156e+00 -1.8738000488281250e+02 4.7951002120971680e+00 -1.3334899902343750e+01 -1.8738000488281250e+02 3.7855598926544189e+00 -2.0111600875854492e+01 -1.8075000000000000e+02 1.5532300472259521e+00 -2.6706600189208984e+01 -1.8075000000000000e+02 -1.0719100236892700e+00 -3.2944900512695312e+01 -1.8075000000000000e+02 -4.4586501121520996e+00 -3.8738899230957031e+01 -1.8075000000000000e+02 -8.5594406127929688e+00 -4.4007202148437500e+01 -1.8075000000000000e+02 -1.3316699981689453e+01 -4.8675800323486328e+01 -1.8075000000000000e+02 -1.8663700103759766e+01 -5.2679298400878906e+01 -1.8075000000000000e+02 -2.4525299072265625e+01 -5.5961299896240234e+01 -1.8075000000000000e+02 -3.0819299697875977e+01 -5.8476001739501953e+01 -1.8075000000000000e+02 -3.7457298278808594e+01 -6.0187896728515625e+01 -1.8075000000000000e+02 -4.4346099853515625e+01 -6.1073001861572266e+01 -1.8075000000000000e+02 -5.1388999938964844e+01 -6.1118900299072266e+01 -1.8075000000000000e+02 -5.8487197875976562e+01 -6.0325000762939453e+01 -1.8075000000000000e+02 -6.5541000366210938e+01 -5.8702400207519531e+01 -1.8075000000000000e+02 -7.2451400756835938e+01 -5.6273799896240234e+01 -1.8075000000000000e+02 -7.9121406555175781e+01 -5.3073398590087891e+01 -1.8075000000000000e+02 -8.5457305908203125e+01 -4.9146099090576172e+01 -1.8075000000000000e+02 -9.1370201110839844e+01 -4.4547000885009766e+01 -1.8075000000000000e+02 -9.6777198791503906e+01 -3.9340801239013672e+01 -1.8075000000000000e+02 -1.0160200500488281e+02 -3.3600299835205078e+01 -1.8075000000000000e+02 -1.0577799987792969e+02 -2.7406400680541992e+01 -1.8075000000000000e+02 -1.0924500274658203e+02 -2.0845800399780273e+01 -1.8075000000000000e+02 -1.1195500183105469e+02 -1.4010800361633301e+01 -1.8075000000000000e+02 -1.1387000274658203e+02 -6.9971599578857422e+00 -1.8075000000000000e+02 -1.1496400451660156e+02 9.6551105380058289e-02 -1.8075000000000000e+02 -1.1522000122070312e+02 7.1707696914672852e+00 -1.8075000000000000e+02 -1.1463499450683594e+02 1.4126200675964355e+01 -1.8075000000000000e+02 -1.1321800231933594e+02 2.0865200042724609e+01 -1.8075000000000000e+02 -1.1098799896240234e+02 2.7293199539184570e+01 -1.8075000000000000e+02 -1.0797700500488281e+02 3.3319900512695312e+01 -1.8075000000000000e+02 -1.0422699737548828e+02 3.8860702514648438e+01 -1.8075000000000000e+02 -9.9790000915527344e+01 4.3837902069091797e+01 -1.8075000000000000e+02 -9.4728996276855469e+01 4.8181602478027344e+01 -1.8075000000000000e+02 -8.9114799499511719e+01 5.1830799102783203e+01 -1.8075000000000000e+02 -8.3026298522949219e+01 5.4734302520751953e+01 -1.8075000000000000e+02 -7.6549003601074219e+01 5.6851200103759766e+01 -1.8075000000000000e+02 -6.9773696899414062e+01 5.8152000427246094e+01 -1.8075000000000000e+02 -6.2795497894287109e+01 5.8618400573730469e+01 -1.8075000000000000e+02 -5.5712497711181641e+01 5.8243698120117188e+01 -1.8075000000000000e+02 -4.8624099731445312e+01 5.7033302307128906e+01 -1.8075000000000000e+02 -4.1629703521728516e+01 5.5004100799560547e+01 -1.8075000000000000e+02 -3.4827602386474609e+01 5.2184700012207031e+01 -1.8075000000000000e+02 -2.8313199996948242e+01 4.8614597320556641e+01 -1.8075000000000000e+02 -2.2177999496459961e+01 4.4343898773193359e+01 -1.8075000000000000e+02 -1.6508100509643555e+01 3.9432601928710938e+01 -1.8075000000000000e+02 -1.1383199691772461e+01 3.3949600219726562e+01 -1.8075000000000000e+02 -6.8750200271606445e+00 2.7972000122070312e+01 -1.8075000000000000e+02 -3.0470199584960938e+00 2.1583499908447266e+01 -1.8075000000000000e+02 4.7115202993154526e-02 1.4873900413513184e+01 -1.8075000000000000e+02 2.3639500141143799e+00 7.9373698234558105e+00 -1.8075000000000000e+02 3.8709499835968018e+00 8.7130099534988403e-01 -1.8075000000000000e+02 4.5469799041748047e+00 -6.2251300811767578e+00 -1.8075000000000000e+02 4.3825402259826660e+00 -1.3252300262451172e+01 -1.8075000000000000e+02 3.3799200057983398e+00 -1.9723499298095703e+01 -1.7422300720214844e+02 3.8028699159622192e-01 -2.6182500839233398e+01 -1.7422300720214844e+02 -2.1907200813293457e+00 -3.2292198181152344e+01 -1.7422300720214844e+02 -5.5076198577880859e+00 -3.7966602325439453e+01 -1.7422300720214844e+02 -9.5238399505615234e+00 -4.3126300811767578e+01 -1.7422300720214844e+02 -1.4182999610900879e+01 -4.7698596954345703e+01 -1.7422300720214844e+02 -1.9419700622558594e+01 -5.1619499206542969e+01 -1.7422300720214844e+02 -2.5160501480102539e+01 -5.4833900451660156e+01 -1.7422300720214844e+02 -3.1324699401855469e+01 -5.7296699523925781e+01 -1.7422300720214844e+02 -3.7825801849365234e+01 -5.8973300933837891e+01 -1.7422300720214844e+02 -4.4572498321533203e+01 -5.9840198516845703e+01 -1.7422300720214844e+02 -5.1470199584960938e+01 -5.9885200500488281e+01 -1.7422300720214844e+02 -5.8422000885009766e+01 -5.9107601165771484e+01 -1.7422300720214844e+02 -6.5330299377441406e+01 -5.7518402099609375e+01 -1.7422300720214844e+02 -7.2098205566406250e+01 -5.5139999389648438e+01 -1.7422300720214844e+02 -7.8630599975585938e+01 -5.2005599975585938e+01 -1.7422300720214844e+02 -8.4835899353027344e+01 -4.8159301757812500e+01 -1.7422300720214844e+02 -9.0626899719238281e+01 -4.3654998779296875e+01 -1.7422300720214844e+02 -9.5922302246093750e+01 -3.8556098937988281e+01 -1.7422300720214844e+02 -1.0064800262451172e+02 -3.2934101104736328e+01 -1.7422300720214844e+02 -1.0473699951171875e+02 -2.6867799758911133e+01 -1.7422300720214844e+02 -1.0813300323486328e+02 -2.0442600250244141e+01 -1.7422300720214844e+02 -1.1078699493408203e+02 -1.3748499870300293e+01 -1.7422300720214844e+02 -1.1266300201416016e+02 -6.8794898986816406e+00 -1.7422300720214844e+02 -1.1373400115966797e+02 6.7928604781627655e-02 -1.7422300720214844e+02 -1.1398500061035156e+02 6.9962697029113770e+00 -1.7422300720214844e+02 -1.1341200256347656e+02 1.3808300018310547e+01 -1.7422300720214844e+02 -1.1202400207519531e+02 2.0408300399780273e+01 -1.7422300720214844e+02 -1.0984099578857422e+02 2.6703701019287109e+01 -1.7422300720214844e+02 -1.0689099884033203e+02 3.2606098175048828e+01 -1.7422300720214844e+02 -1.0321799468994141e+02 3.8032699584960938e+01 -1.7422300720214844e+02 -9.8873100280761719e+01 4.2907302856445312e+01 -1.7422300720214844e+02 -9.3916404724121094e+01 4.7161399841308594e+01 -1.7422300720214844e+02 -8.8417999267578125e+01 5.0735298156738281e+01 -1.7422300720214844e+02 -8.2455101013183594e+01 5.3578899383544922e+01 -1.7422300720214844e+02 -7.6111305236816406e+01 5.5652202606201172e+01 -1.7422300720214844e+02 -6.9475700378417969e+01 5.6926197052001953e+01 -1.7422300720214844e+02 -6.2641502380371094e+01 5.7382900238037109e+01 -1.7422300720214844e+02 -5.5704601287841797e+01 5.7015998840332031e+01 -1.7422300720214844e+02 -4.8762298583984375e+01 5.5830501556396484e+01 -1.7422300720214844e+02 -4.1912200927734375e+01 5.3843200683593750e+01 -1.7422300720214844e+02 -3.5250297546386719e+01 5.1081897735595703e+01 -1.7422300720214844e+02 -2.8870300292968750e+01 4.7585403442382812e+01 -1.7422300720214844e+02 -2.2861598968505859e+01 4.3402797698974609e+01 -1.7422300720214844e+02 -1.7308599472045898e+01 3.8592800140380859e+01 -1.7422300720214844e+02 -1.2289299964904785e+01 3.3222900390625000e+01 -1.7422300720214844e+02 -7.8741602897644043e+00 2.7368501663208008e+01 -1.7422300720214844e+02 -4.1250896453857422e+00 2.1111799240112305e+01 -1.7422300720214844e+02 -1.0947600603103638e+00 1.4540499687194824e+01 -1.7422300720214844e+02 1.1742899417877197e+00 7.7470498085021973e+00 -1.7422300720214844e+02 2.6502199172973633e+00 8.2670199871063232e-01 -1.7422300720214844e+02 3.3122999668121338e+00 -6.1233901977539062e+00 -1.7422300720214844e+02 3.1512501239776611e+00 -1.3005599975585938e+01 -1.7422300720214844e+02 2.1693198680877686e+00 -1.9083301544189453e+01 -1.6789999389648438e+02 -1.5543600320816040e+00 -2.5318099975585938e+01 -1.6789999389648438e+02 -4.0360698699951172e+00 -3.1215499877929688e+01 -1.6789999389648438e+02 -7.2377800941467285e+00 -3.6692897796630859e+01 -1.6789999389648438e+02 -1.1114500045776367e+01 -4.1673297882080078e+01 -1.6789999389648438e+02 -1.5611900329589844e+01 -4.6086898803710938e+01 -1.6789999389648438e+02 -2.0666700363159180e+01 -4.9871601104736328e+01 -1.6789999389648438e+02 -2.6208101272583008e+01 -5.2974399566650391e+01 -1.6789999389648438e+02 -3.2158199310302734e+01 -5.5351699829101562e+01 -1.6789999389648438e+02 -3.8433498382568359e+01 -5.6970001220703125e+01 -1.6789999389648438e+02 -4.4945999145507812e+01 -5.7806800842285156e+01 -1.6789999389648438e+02 -5.1604099273681641e+01 -5.7850200653076172e+01 -1.6789999389648438e+02 -5.8314498901367188e+01 -5.7099597930908203e+01 -1.6789999389648438e+02 -6.4982894897460938e+01 -5.5565700531005859e+01 -1.6789999389648438e+02 -7.1515701293945312e+01 -5.3269798278808594e+01 -1.6789999389648438e+02 -7.7821205139160156e+01 -5.0244300842285156e+01 -1.6789999389648438e+02 -8.3810997009277344e+01 -4.6531497955322266e+01 -1.6789999389648438e+02 -8.9400901794433594e+01 -4.2183700561523438e+01 -1.6789999389648438e+02 -9.4512405395507812e+01 -3.7261898040771484e+01 -1.6789999389648438e+02 -9.9073799133300781e+01 -3.1835102081298828e+01 -1.6789999389648438e+02 -1.0302100372314453e+02 -2.5979600906372070e+01 -1.6789999389648438e+02 -1.0629899597167969e+02 -1.9777498245239258e+01 -1.6789999389648438e+02 -1.0886100006103516e+02 -1.3315799713134766e+01 -1.6789999389648438e+02 -1.1067199707031250e+02 -6.6854200363159180e+00 -1.6789999389648438e+02 -1.1170499420166016e+02 2.0719299092888832e-02 -1.6789999389648438e+02 -1.1194799804687500e+02 6.7084398269653320e+00 -1.6789999389648438e+02 -1.1139500427246094e+02 1.3283900260925293e+01 -1.6789999389648438e+02 -1.1005500030517578e+02 1.9654701232910156e+01 -1.6789999389648438e+02 -1.0794699859619141e+02 2.5731399536132812e+01 -1.6789999389648438e+02 -1.0509999847412109e+02 3.1428899765014648e+01 -1.6789999389648438e+02 -1.0155500030517578e+02 3.6666999816894531e+01 -1.6789999389648438e+02 -9.7360603332519531e+01 4.1372299194335938e+01 -1.6789999389648438e+02 -9.2576103210449219e+01 4.5478599548339844e+01 -1.6789999389648438e+02 -8.7268699645996094e+01 4.8928398132324219e+01 -1.6789999389648438e+02 -8.1512901306152344e+01 5.1673301696777344e+01 -1.6789999389648438e+02 -7.5389396667480469e+01 5.3674602508544922e+01 -1.6789999389648438e+02 -6.8984298706054688e+01 5.4904300689697266e+01 -1.6789999389648438e+02 -6.2387397766113281e+01 5.5345199584960938e+01 -1.6789999389648438e+02 -5.5691398620605469e+01 5.4991001129150391e+01 -1.6789999389648438e+02 -4.8990200042724609e+01 5.3846698760986328e+01 -1.6789999389648438e+02 -4.2378002166748047e+01 5.1928401947021484e+01 -1.6789999389648438e+02 -3.5947502136230469e+01 4.9263000488281250e+01 -1.6789999389648438e+02 -2.9789001464843750e+01 4.5888000488281250e+01 -1.6789999389648438e+02 -2.3989000320434570e+01 4.1850601196289062e+01 -1.6789999389648438e+02 -1.8628900527954102e+01 3.7207599639892578e+01 -1.6789999389648438e+02 -1.3783999443054199e+01 3.2024200439453125e+01 -1.6789999389648438e+02 -9.5221300125122070e+00 2.6373100280761719e+01 -1.6789999389648438e+02 -5.9032702445983887e+00 2.0333700180053711e+01 -1.6789999389648438e+02 -2.9781901836395264e+00 1.3990699768066406e+01 -1.6789999389648438e+02 -7.8793102502822876e-01 7.4331498146057129e+00 -1.6789999389648438e+02 6.3673901557922363e-01 7.5314003229141235e-01 -1.6789999389648438e+02 1.2758300304412842e+00 -5.9555697441101074e+00 -1.6789999389648438e+02 1.1203700304031372e+00 -1.2598799705505371e+01 -1.6789999389648438e+02 1.7253500223159790e-01 -1.8201099395751953e+01 -1.6188000488281250e+02 -4.2206597328186035e+00 -2.4126699447631836e+01 -1.6188000488281250e+02 -6.5793199539184570e+00 -2.9731700897216797e+01 -1.6188000488281250e+02 -9.6222600936889648e+00 -3.4937500000000000e+01 -1.6188000488281250e+02 -1.3306799888610840e+01 -3.9670898437500000e+01 -1.6188000488281250e+02 -1.7581100463867188e+01 -4.3865600585937500e+01 -1.6188000488281250e+02 -2.2385299682617188e+01 -4.7462699890136719e+01 -1.6188000488281250e+02 -2.7651901245117188e+01 -5.0411602020263672e+01 -1.6188000488281250e+02 -3.3306999206542969e+01 -5.2671001434326172e+01 -1.6188000488281250e+02 -3.9271102905273438e+01 -5.4209098815917969e+01 -1.6188000488281250e+02 -4.5460601806640625e+01 -5.5004398345947266e+01 -1.6188000488281250e+02 -5.1788597106933594e+01 -5.5045600891113281e+01 -1.6188000488281250e+02 -5.8166198730468750e+01 -5.4332302093505859e+01 -1.6188000488281250e+02 -6.4503997802734375e+01 -5.2874401092529297e+01 -1.6188000488281250e+02 -7.0712898254394531e+01 -5.0692401885986328e+01 -1.6188000488281250e+02 -7.6705703735351562e+01 -4.7816898345947266e+01 -1.6188000488281250e+02 -8.2398498535156250e+01 -4.4288200378417969e+01 -1.6188000488281250e+02 -8.7711196899414062e+01 -4.0155998229980469e+01 -1.6188000488281250e+02 -9.2569198608398438e+01 -3.5478302001953125e+01 -1.6188000488281250e+02 -9.6904396057128906e+01 -3.0320600509643555e+01 -1.6188000488281250e+02 -1.0065600585937500e+02 -2.4755399703979492e+01 -1.6188000488281250e+02 -1.0377100372314453e+02 -1.8860799789428711e+01 -1.6188000488281250e+02 -1.0620600128173828e+02 -1.2719600677490234e+01 -1.6188000488281250e+02 -1.0792700195312500e+02 -6.4179501533508301e+00 -1.6188000488281250e+02 -1.0891000366210938e+02 -4.4343903660774231e-02 -1.6188000488281250e+02 -1.0913999938964844e+02 6.3117499351501465e+00 -1.6188000488281250e+02 -1.0861500549316406e+02 1.2561100006103516e+01 -1.6188000488281250e+02 -1.0734099578857422e+02 1.8616001129150391e+01 -1.6188000488281250e+02 -1.0533799743652344e+02 2.4391500473022461e+01 -1.6188000488281250e+02 -1.0263200378417969e+02 2.9806400299072266e+01 -1.6188000488281250e+02 -9.9262702941894531e+01 3.4784801483154297e+01 -1.6188000488281250e+02 -9.5276199340820312e+01 3.9256698608398438e+01 -1.6188000488281250e+02 -9.0728996276855469e+01 4.3159400939941406e+01 -1.6188000488281250e+02 -8.5684700012207031e+01 4.6438198089599609e+01 -1.6188000488281250e+02 -8.0214302062988281e+01 4.9046901702880859e+01 -1.6188000488281250e+02 -7.4394500732421875e+01 5.0949001312255859e+01 -1.6188000488281250e+02 -6.8306900024414062e+01 5.2117702484130859e+01 -1.6188000488281250e+02 -6.2037200927734375e+01 5.2536800384521484e+01 -1.6188000488281250e+02 -5.5673202514648438e+01 5.2200099945068359e+01 -1.6188000488281250e+02 -4.9304298400878906e+01 5.1112598419189453e+01 -1.6188000488281250e+02 -4.3020000457763672e+01 4.9289402008056641e+01 -1.6188000488281250e+02 -3.6908397674560547e+01 4.6756198883056641e+01 -1.6188000488281250e+02 -3.1055299758911133e+01 4.3548500061035156e+01 -1.6188000488281250e+02 -2.5542900085449219e+01 3.9711299896240234e+01 -1.6188000488281250e+02 -2.0448600769042969e+01 3.5298599243164062e+01 -1.6188000488281250e+02 -1.5843799591064453e+01 3.0372200012207031e+01 -1.6188000488281250e+02 -1.1793299674987793e+01 2.5001300811767578e+01 -1.6188000488281250e+02 -8.3539199829101562e+00 1.9261400222778320e+01 -1.6188000488281250e+02 -5.5738797187805176e+00 1.3232899665832520e+01 -1.6188000488281250e+02 -3.4922401905059814e+00 7.0005302429199219e+00 -1.6188000488281250e+02 -2.1382100582122803e+00 6.5175896883010864e-01 -1.6188000488281250e+02 -1.5308099985122681e+00 -5.7242898941040039e+00 -1.6188000488281250e+02 -1.6785600185394287e+00 -1.2038099288940430e+01 -1.6188000488281250e+02 -2.5793900489807129e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 6258 -> 100 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8734399229288101e+01 -1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector -2.5318099185824394e+01 -1.6789999604225159e+02 -4.0360698476433754e+00) (float-vector -4.1673298925161362e+01 -1.6789999604225159e+02 -1.5611900016665459e+01) (float-vector -4.0359698235988617e+01 -1.5862999856472015e+02 -2.2542800754308701e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0442599430680275e+01 -2.0053699612617493e+02 -1.1078699678182602e+02) (float-vector -2.0442599430680275e+01 -1.7422300577163696e+02 -1.1078699678182602e+02) (float-vector -3.9603698998689651e+01 -1.8738000094890594e+02 -1.0192199796438217e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7741599585860968e+00 -1.4688000082969666e+02 -2.3220999166369438e+01) (float-vector -7.5338198803365231e+00 -1.4262999594211578e+02 -4.9704298377037048e+01) (float-vector 7.0625799708068371e+00 -1.4262999594211578e+02 -5.6203000247478485e+01) (float-vector 2.6637900620698929e+01 -1.4688000082969666e+02 -3.9200000464916229e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3546399548649788e+01 -1.4688000082969666e+02 -7.8665398061275482e+01) (float-vector -7.5338198803365231e+00 -1.4262999594211578e+02 -4.9704298377037048e+01) (float-vector -3.3213101327419281e+01 -1.4688000082969666e+02 -5.0735298544168472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0442599430680275e+01 -1.7422300577163696e+02 -1.1078699678182602e+02) (float-vector -3.7261899560689926e+01 -1.6789999604225159e+02 -9.9073797464370728e+01) (float-vector -3.9603698998689651e+01 -1.8738000094890594e+02 -1.0192199796438217e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8119500279426575e+00 -1.4688000082969666e+02 -8.6992196738719940e+01) (float-vector 2.8044199571013451e+01 -1.4688000082969666e+02 -6.8722099065780640e+01) (float-vector 7.0625799708068371e+00 -1.4262999594211578e+02 -5.6203000247478485e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8044199571013451e+01 -1.4688000082969666e+02 -6.8722099065780640e+01) (float-vector 2.6637900620698929e+01 -1.4688000082969666e+02 -3.9200000464916229e+01) (float-vector 7.0625799708068371e+00 -1.4262999594211578e+02 -5.6203000247478485e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -3.7882000207901001e+01) (float-vector 4.9263000488281250e+01 -1.6789999604225159e+02 -2.9789000749588013e+01) (float-vector 3.5298600792884827e+01 -1.6188000142574310e+02 -1.5843799337744713e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5318099185824394e+01 -1.6789999604225159e+02 -4.0360698476433754e+00) (float-vector -3.2944899052381516e+01 -1.8074999749660492e+02 -4.4586500152945518e+00) (float-vector -4.4302299618721008e+01 -1.8738000094890594e+02 -1.3026500120759010e+01) (float-vector -4.1673298925161362e+01 -1.6789999604225159e+02 -1.5611900016665459e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6637900620698929e+01 -1.4688000082969666e+02 -3.9200000464916229e+01) (float-vector 2.4208599701523781e+01 -1.5862999856472015e+02 -1.1157699860632420e+01) (float-vector 1.7741599585860968e+00 -1.4688000082969666e+02 -2.3220999166369438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5298600792884827e+01 -1.6188000142574310e+02 -1.5843799337744713e+01) (float-vector 2.4208599701523781e+01 -1.5862999856472015e+02 -1.1157699860632420e+01) (float-vector 2.6637900620698929e+01 -1.4688000082969666e+02 -3.9200000464916229e+01) (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -3.7882000207901001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.7016000151634216e+01 -2.0053699612617493e+02 -4.8762299120426178e+01) (float-vector 5.3843200206756592e+01 -2.0053699612617493e+02 -3.5250298678874969e+01) (float-vector 5.5004101246595383e+01 -1.8074999749660492e+02 -3.4827601164579391e+01) (float-vector 5.9032298624515533e+01 -1.8738000094890594e+02 -5.5715199559926987e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3578898310661316e+01 -2.0053699612617493e+02 -7.6111301779747009e+01) (float-vector 5.2117701619863510e+01 -2.1288000047206879e+02 -6.2037199735641479e+01) (float-vector 5.7016000151634216e+01 -2.0053699612617493e+02 -4.8762299120426178e+01) (float-vector 5.9032298624515533e+01 -1.8738000094890594e+02 -5.5715199559926987e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.4734300822019577e+01 -1.8074999749660492e+02 -7.6549001038074493e+01) (float-vector 4.7161400318145752e+01 -1.7422300577163696e+02 -8.8417999446392059e+01) (float-vector 4.3837901204824448e+01 -1.9401000440120697e+02 -9.4728998839855194e+01) (float-vector 5.3578898310661316e+01 -2.0053699612617493e+02 -7.6111301779747009e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6926198303699493e+01 -1.7422300577163696e+02 -6.2641501426696777e+01) (float-vector 5.4734300822019577e+01 -1.8074999749660492e+02 -7.6549001038074493e+01) (float-vector 5.3578898310661316e+01 -2.0053699612617493e+02 -7.6111301779747009e+01) (float-vector 5.9032298624515533e+01 -1.8738000094890594e+02 -5.5715199559926987e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -1.0632500052452087e+02) (float-vector 1.8616000190377235e+01 -1.6188000142574310e+02 -1.0533799976110458e+02) (float-vector 4.8119500279426575e+00 -1.4688000082969666e+02 -8.6992196738719940e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3319901674985886e+01 -1.9401000440120697e+02 -1.0422699898481369e+02) (float-vector 4.3837901204824448e+01 -1.9401000440120697e+02 -9.4728998839855194e+01) (float-vector 4.7161400318145752e+01 -1.7422300577163696e+02 -8.8417999446392059e+01) (float-vector 3.9256699383258820e+01 -1.6188000142574310e+02 -9.0728998184204102e+01) (float-vector 2.7293199673295021e+01 -1.8074999749660492e+02 -1.0797700285911560e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1767699867486954e+01 -2.2788000106811523e+02 -4.4777099043130875e+01) (float-vector -1.0377299971878529e+01 -2.2788000106811523e+02 -2.4381399154663086e+01) (float-vector -6.2287999317049980e+00 -2.3213000595569611e+02 -4.8529300838708878e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0626999214291573e+01 -2.2788000106811523e+02 -6.8722099065780640e+01) (float-vector -4.0359698235988617e+01 -2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector -5.0692401826381683e+01 -2.1288000047206879e+02 -7.6705701649188995e+01) (float-vector -5.7850200682878494e+01 -2.0686000585556030e+02 -5.8314498513936996e+01) (float-vector -5.1516599953174591e+01 -2.1613000333309174e+02 -4.6468898653984070e+01) (float-vector -3.1767699867486954e+01 -2.2788000106811523e+02 -4.4777099043130875e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1516599953174591e+01 -1.5862999856472015e+02 -4.6468898653984070e+01) (float-vector -5.0411600619554520e+01 -1.6188000142574310e+02 -3.3307000994682312e+01) (float-vector -5.7296700775623322e+01 -1.7422300577163696e+02 -3.7825800478458405e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3034301847219467e+01 -1.8738000094890594e+02 -2.4312499910593033e+01) (float-vector -5.7296700775623322e+01 -1.7422300577163696e+02 -3.7825800478458405e+01) (float-vector -5.0411600619554520e+01 -1.6188000142574310e+02 -3.3307000994682312e+01) (float-vector -4.0359698235988617e+01 -1.5862999856472015e+02 -2.2542800754308701e+01) (float-vector -4.1673298925161362e+01 -1.6789999604225159e+02 -1.5611900016665459e+01) (float-vector -4.4302299618721008e+01 -1.8738000094890594e+02 -1.3026500120759010e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1227000281214714e+01 -1.4688000082969666e+02 -2.9974799603223801e+01) (float-vector -1.8734399229288101e+01 -1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector -4.0359698235988617e+01 -1.5862999856472015e+02 -2.2542800754308701e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1227000281214714e+01 -1.4688000082969666e+02 -2.9974799603223801e+01) (float-vector -7.5338198803365231e+00 -1.4262999594211578e+02 -4.9704298377037048e+01) (float-vector 1.7741599585860968e+00 -1.4688000082969666e+02 -2.3220999166369438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5338198803365231e+00 -1.4262999594211578e+02 -4.9704298377037048e+01) (float-vector -2.1227000281214714e+01 -1.4688000082969666e+02 -2.9974799603223801e+01) (float-vector -3.3213101327419281e+01 -1.4688000082969666e+02 -5.0735298544168472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3213101327419281e+01 -1.4688000082969666e+02 -5.0735298544168472e+01) (float-vector -2.1227000281214714e+01 -1.4688000082969666e+02 -2.9974799603223801e+01) (float-vector -4.0359698235988617e+01 -1.5862999856472015e+02 -2.2542800754308701e+01) (float-vector -5.0411600619554520e+01 -1.6188000142574310e+02 -3.3307000994682312e+01) (float-vector -5.1516599953174591e+01 -1.5862999856472015e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5338198803365231e+00 -1.4262999594211578e+02 -4.9704298377037048e+01) (float-vector -2.3546399548649788e+01 -1.4688000082969666e+02 -7.8665398061275482e+01) (float-vector 4.8119500279426575e+00 -1.4688000082969666e+02 -8.6992196738719940e+01) (float-vector 7.0625799708068371e+00 -1.4262999594211578e+02 -5.6203000247478485e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9215700477361679e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector -2.3546399548649788e+01 -1.4688000082969666e+02 -7.8665398061275482e+01) (float-vector -3.3213101327419281e+01 -1.4688000082969666e+02 -5.0735298544168472e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5045600980520248e+01 -1.6188000142574310e+02 -5.8166198432445526e+01) (float-vector -4.9215700477361679e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector -3.3213101327419281e+01 -1.4688000082969666e+02 -5.0735298544168472e+01) (float-vector -5.1516599953174591e+01 -1.5862999856472015e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8860800191760063e+01 -1.6188000142574310e+02 -1.0620599985122681e+02) (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -1.0632500052452087e+02) (float-vector 4.8119500279426575e+00 -1.4688000082969666e+02 -8.6992196738719940e+01) (float-vector -2.3546399548649788e+01 -1.4688000082969666e+02 -7.8665398061275482e+01) (float-vector -3.4073598682880402e+01 -1.5862999856472015e+02 -9.4393298029899597e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4073598682880402e+01 -1.5862999856472015e+02 -9.4393298029899597e+01) (float-vector -3.7261899560689926e+01 -1.6789999604225159e+02 -9.9073797464370728e+01) (float-vector -2.0442599430680275e+01 -1.7422300577163696e+02 -1.1078699678182602e+02) (float-vector -1.8860800191760063e+01 -1.6188000142574310e+02 -1.0620599985122681e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 5.2536800503730774e+01 -1.6188000142574310e+02 -5.5673200637102127e+01) (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -3.7882000207901001e+01) (float-vector 2.6637900620698929e+01 -1.4688000082969666e+02 -3.9200000464916229e+01) (float-vector 2.8044199571013451e+01 -1.4688000082969666e+02 -6.8722099065780640e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8616000190377235e+01 -1.6188000142574310e+02 -1.0533799976110458e+02) (float-vector 3.9256699383258820e+01 -1.6188000142574310e+02 -9.0728998184204102e+01) (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 2.8044199571013451e+01 -1.4688000082969666e+02 -6.8722099065780640e+01) (float-vector 4.8119500279426575e+00 -1.4688000082969666e+02 -8.6992196738719940e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6926198303699493e+01 -1.7422300577163696e+02 -6.2641501426696777e+01) (float-vector 5.2536800503730774e+01 -1.6188000142574310e+02 -5.5673200637102127e+01) (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 3.9256699383258820e+01 -1.6188000142574310e+02 -9.0728998184204102e+01) (float-vector 4.7161400318145752e+01 -1.7422300577163696e+02 -8.8417999446392059e+01) (float-vector 5.4734300822019577e+01 -1.8074999749660492e+02 -7.6549001038074493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3846698254346848e+01 -1.6789999604225159e+02 -4.2378000915050507e+01) (float-vector 4.9263000488281250e+01 -1.6789999604225159e+02 -2.9789000749588013e+01) (float-vector 4.6632900834083557e+01 -1.5862999856472015e+02 -3.7882000207901001e+01) (float-vector 5.2536800503730774e+01 -1.6188000142574310e+02 -5.5673200637102127e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3846698254346848e+01 -1.6789999604225159e+02 -4.2378000915050507e+01) (float-vector 5.5004101246595383e+01 -1.8074999749660492e+02 -3.4827601164579391e+01) (float-vector 4.4659301638603210e+01 -1.8738000094890594e+02 -1.6239900141954422e+01) (float-vector 4.9263000488281250e+01 -1.6789999604225159e+02 -2.9789000749588013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3846698254346848e+01 -1.6789999604225159e+02 -4.2378000915050507e+01) (float-vector 5.2536800503730774e+01 -1.6188000142574310e+02 -5.5673200637102127e+01) (float-vector 5.6926198303699493e+01 -1.7422300577163696e+02 -6.2641501426696777e+01) (float-vector 5.9032298624515533e+01 -1.8738000094890594e+02 -5.5715199559926987e+01) (float-vector 5.5004101246595383e+01 -1.8074999749660492e+02 -3.4827601164579391e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5318099185824394e+01 -1.6789999604225159e+02 -4.0360698476433754e+00) (float-vector -1.3005600310862064e+01 -1.7422300577163696e+02 2.1693198941648006e+00) (float-vector -2.0241599529981613e+01 -1.8738000094890594e+02 1.9462399650365114e+00) (float-vector -3.2944899052381516e+01 -1.8074999749660492e+02 -4.4586500152945518e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6182500645518303e+01 -2.0053699612617493e+02 -2.1907200571149588e+00) (float-vector -2.0241599529981613e+01 -1.8738000094890594e+02 1.9462399650365114e+00) (float-vector -1.3005600310862064e+01 -1.7422300577163696e+02 2.1693198941648006e+00) (float-vector 8.8624499039724469e-01 -1.8738000094890594e+02 4.9606799148023129e+00) (float-vector -1.2598799541592598e+01 -2.0686000585556030e+02 1.7253500118386000e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6632900834083557e+01 -2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector 5.3843200206756592e+01 -2.0053699612617493e+02 -3.5250298678874969e+01) (float-vector 5.7016000151634216e+01 -2.0053699612617493e+02 -4.8762299120426178e+01) (float-vector 5.2117701619863510e+01 -2.1288000047206879e+02 -6.2037199735641479e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8616000190377235e+01 -1.6188000142574310e+02 -1.0533799976110458e+02) (float-vector 1.3808299787342548e+01 -1.7422300577163696e+02 -1.1202400177717209e+02) (float-vector 2.7293199673295021e+01 -1.8074999749660492e+02 -1.0797700285911560e+02) (float-vector 3.9256699383258820e+01 -1.6188000142574310e+02 -9.0728998184204102e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3578898310661316e+01 -2.0053699612617493e+02 -7.6111301779747009e+01) (float-vector 4.3159399181604385e+01 -2.1288000047206879e+02 -8.5684701800346375e+01) (float-vector 5.2117701619863510e+01 -2.1288000047206879e+02 -6.2037199735641479e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3159399181604385e+01 -2.1288000047206879e+02 -8.5684701800346375e+01) (float-vector 5.3578898310661316e+01 -2.0053699612617493e+02 -7.6111301779747009e+01) (float-vector 4.3837901204824448e+01 -1.9401000440120697e+02 -9.4728998839855194e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7850200682878494e+01 -2.0686000585556030e+02 -5.8314498513936996e+01) (float-vector -5.8702401816844940e+01 -1.9401000440120697e+02 -7.2451397776603699e+01) (float-vector -6.1532299965620041e+01 -1.8738000094890594e+02 -5.8509100228548050e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.3073398768901825e+01 -1.9401000440120697e+02 -8.5457302629947662e+01) (float-vector -5.8702401816844940e+01 -1.9401000440120697e+02 -7.2451397776603699e+01) (float-vector -5.7850200682878494e+01 -2.0686000585556030e+02 -5.8314498513936996e+01) (float-vector -5.0692401826381683e+01 -2.1288000047206879e+02 -7.6705701649188995e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1532299965620041e+01 -1.8738000094890594e+02 -5.8509100228548050e+01) (float-vector -5.8702401816844940e+01 -1.9401000440120697e+02 -7.2451397776603699e+01) (float-vector -5.3073398768901825e+01 -1.9401000440120697e+02 -8.5457302629947662e+01) (float-vector -5.2005600184202194e+01 -1.7422300577163696e+02 -8.4835901856422424e+01) (float-vector -5.9107601642608643e+01 -1.7422300577163696e+02 -6.5330296754837036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2005600184202194e+01 -1.7422300577163696e+02 -8.4835901856422424e+01) (float-vector -5.3073398768901825e+01 -1.9401000440120697e+02 -8.5457302629947662e+01) (float-vector -4.3655000627040863e+01 -2.0053699612617493e+02 -9.5922298729419708e+01) (float-vector -3.9603698998689651e+01 -1.8738000094890594e+02 -1.0192199796438217e+02) (float-vector -3.7261899560689926e+01 -1.6789999604225159e+02 -9.9073797464370728e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0442599430680275e+01 -2.0053699612617493e+02 -1.1078699678182602e+02) (float-vector 6.7928602220490575e-02 -2.0053699612617493e+02 -1.1398500204086304e+02) (float-vector 1.0614199709380046e-01 -1.8738000094890594e+02 -1.1563400179147720e+02) (float-vector -2.0442599430680275e+01 -1.7422300577163696e+02 -1.1078699678182602e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7293199673295021e+01 -1.8074999749660492e+02 -1.0797700285911560e+02) (float-vector 1.3808299787342548e+01 -1.7422300577163696e+02 -1.1202400177717209e+02) (float-vector 1.0614199709380046e-01 -1.8738000094890594e+02 -1.1563400179147720e+02) (float-vector 6.7928602220490575e-02 -2.0053699612617493e+02 -1.1398500204086304e+02) (float-vector 1.3808299787342548e+01 -2.0053699612617493e+02 -1.1202400177717209e+02) (float-vector 3.3319901674985886e+01 -1.9401000440120697e+02 -1.0422699898481369e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7296700775623322e+01 -1.7422300577163696e+02 -3.7825800478458405e+01) (float-vector -6.0594800859689713e+01 -1.8738000094890594e+02 -4.4270198792219162e+01) (float-vector -6.1532299965620041e+01 -1.8738000094890594e+02 -5.8509100228548050e+01) (float-vector -5.9107601642608643e+01 -1.7422300577163696e+02 -6.5330296754837036e+01) (float-vector -5.5045600980520248e+01 -1.6188000142574310e+02 -5.8166198432445526e+01) (float-vector -5.1516599953174591e+01 -1.5862999856472015e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0594800859689713e+01 -1.8738000094890594e+02 -4.4270198792219162e+01) (float-vector -5.7296700775623322e+01 -1.7422300577163696e+02 -3.7825800478458405e+01) (float-vector -5.3034301847219467e+01 -1.8738000094890594e+02 -2.4312499910593033e+01) (float-vector -5.4833900183439255e+01 -2.0053699612617493e+02 -3.1324699521064758e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1516599953174591e+01 -2.1613000333309174e+02 -4.6468898653984070e+01) (float-vector -5.7850200682878494e+01 -2.0686000585556030e+02 -5.8314498513936996e+01) (float-vector -6.1532299965620041e+01 -1.8738000094890594e+02 -5.8509100228548050e+01) (float-vector -6.0594800859689713e+01 -1.8738000094890594e+02 -4.4270198792219162e+01) (float-vector -5.4833900183439255e+01 -2.0053699612617493e+02 -3.1324699521064758e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9215700477361679e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector -4.4288199394941330e+01 -1.6188000142574310e+02 -8.7711200118064880e+01) (float-vector -3.4073598682880402e+01 -1.5862999856472015e+02 -9.4393298029899597e+01) (float-vector -2.3546399548649788e+01 -1.4688000082969666e+02 -7.8665398061275482e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4288199394941330e+01 -1.6188000142574310e+02 -8.7711200118064880e+01) (float-vector -4.9215700477361679e+01 -1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector -5.5045600980520248e+01 -1.6188000142574310e+02 -5.8166198432445526e+01) (float-vector -5.9107601642608643e+01 -1.7422300577163696e+02 -6.5330296754837036e+01) (float-vector -5.2005600184202194e+01 -1.7422300577163696e+02 -8.4835901856422424e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4073598682880402e+01 -1.5862999856472015e+02 -9.4393298029899597e+01) (float-vector -4.4288199394941330e+01 -1.6188000142574310e+02 -8.7711200118064880e+01) (float-vector -5.2005600184202194e+01 -1.7422300577163696e+02 -8.4835901856422424e+01) (float-vector -3.7261899560689926e+01 -1.6789999604225159e+02 -9.9073797464370728e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.5298600792884827e+01 -1.6188000142574310e+02 -1.5843799337744713e+01) (float-vector 2.7971999719738960e+01 -1.8074999749660492e+02 -3.0470199417322874e+00) (float-vector 7.4331499636173248e+00 -1.6789999604225159e+02 6.3673901604488492e-01) (float-vector 2.4208599701523781e+01 -1.5862999856472015e+02 -1.1157699860632420e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7585401684045792e+01 -2.0053699612617493e+02 -2.2861599922180176e+01) (float-vector 4.4659301638603210e+01 -1.8738000094890594e+02 -1.6239900141954422e+01) (float-vector 5.5004101246595383e+01 -1.8074999749660492e+02 -3.4827601164579391e+01) (float-vector 5.3843200206756592e+01 -2.0053699612617493e+02 -3.5250298678874969e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -1.0632500052452087e+02) (float-vector 2.0719298845506273e-02 -1.6789999604225159e+02 -1.1194799840450287e+02) (float-vector 1.3808299787342548e+01 -1.7422300577163696e+02 -1.1202400177717209e+02) (float-vector 1.8616000190377235e+01 -1.6188000142574310e+02 -1.0533799976110458e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0719298845506273e-02 -1.6789999604225159e+02 -1.1194799840450287e+02) (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -1.0632500052452087e+02) (float-vector -1.8860800191760063e+01 -1.6188000142574310e+02 -1.0620599985122681e+02) (float-vector -2.0442599430680275e+01 -1.7422300577163696e+02 -1.1078699678182602e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3808299787342548e+01 -1.7422300577163696e+02 -1.1202400177717209e+02) (float-vector 2.0719298845506273e-02 -1.6789999604225159e+02 -1.1194799840450287e+02) (float-vector -2.0442599430680275e+01 -1.7422300577163696e+02 -1.1078699678182602e+02) (float-vector 1.0614199709380046e-01 -1.8738000094890594e+02 -1.1563400179147720e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0922099947929382e+01 -2.2788000106811523e+02 -5.6859500706195831e+01) (float-vector 2.6637900620698929e+01 -2.2788000106811523e+02 -3.9200000464916229e+01) (float-vector 4.6632900834083557e+01 -2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector 5.2117701619863510e+01 -2.1288000047206879e+02 -6.2037199735641479e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5731399655342102e+01 -2.0686000585556030e+02 -1.0509999841451645e+02) (float-vector 3.3319901674985886e+01 -1.9401000440120697e+02 -1.0422699898481369e+02) (float-vector 1.3808299787342548e+01 -2.0053699612617493e+02 -1.1202400177717209e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5478301346302032e+01 -2.1288000047206879e+02 -9.6904397010803223e+01) (float-vector -2.0442599430680275e+01 -2.0053699612617493e+02 -1.1078699678182602e+02) (float-vector -3.9603698998689651e+01 -1.8738000094890594e+02 -1.0192199796438217e+02) (float-vector -4.3655000627040863e+01 -2.0053699612617493e+02 -9.5922298729419708e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2719600461423397e+01 -2.1288000047206879e+02 -1.0792700201272964e+02) (float-vector -2.0442599430680275e+01 -2.0053699612617493e+02 -1.1078699678182602e+02) (float-vector -3.5478301346302032e+01 -2.1288000047206879e+02 -9.6904397010803223e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0359698235988617e+01 -2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector -3.5478301346302032e+01 -2.1288000047206879e+02 -9.6904397010803223e+01) (float-vector -4.3655000627040863e+01 -2.0053699612617493e+02 -9.5922298729419708e+01) (float-vector -5.3073398768901825e+01 -1.9401000440120697e+02 -8.5457302629947662e+01) (float-vector -5.0692401826381683e+01 -2.1288000047206879e+02 -7.6705701649188995e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4208599701523781e+01 -1.5862999856472015e+02 -1.1157699860632420e+01) (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -4.3250001035630703e+00) (float-vector 1.7741599585860968e+00 -1.4688000082969666e+02 -2.3220999166369438e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7741599585860968e+00 -1.4688000082969666e+02 -2.3220999166369438e+01) (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -4.3250001035630703e+00) (float-vector -1.8734399229288101e+01 -1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector -2.1227000281214714e+01 -1.4688000082969666e+02 -2.9974799603223801e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.4833900183439255e+01 -2.0053699612617493e+02 -3.1324699521064758e+01) (float-vector -4.7462701797485352e+01 -2.1288000047206879e+02 -2.7651900425553322e+01) (float-vector -5.1516599953174591e+01 -2.1613000333309174e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7462701797485352e+01 -2.1288000047206879e+02 -2.7651900425553322e+01) (float-vector -3.4073598682880402e+01 -2.1613000333309174e+02 -1.6256699338555336e+01) (float-vector -3.1767699867486954e+01 -2.2788000106811523e+02 -4.4777099043130875e+01) (float-vector -5.1516599953174591e+01 -2.1613000333309174e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4343902118271217e-02 -2.1288000047206879e+02 -1.0914000123739243e+02) (float-vector 6.7928602220490575e-02 -2.0053699612617493e+02 -1.1398500204086304e+02) (float-vector -2.0442599430680275e+01 -2.0053699612617493e+02 -1.1078699678182602e+02) (float-vector -1.2719600461423397e+01 -2.1288000047206879e+02 -1.0792700201272964e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9555699117481709e+00 -1.6789999604225159e+02 1.1203699978068471e+00) (float-vector 7.4331499636173248e+00 -1.6789999604225159e+02 6.3673901604488492e-01) (float-vector 8.8624499039724469e-01 -1.8738000094890594e+02 4.9606799148023129e+00) (float-vector -1.3005600310862064e+01 -1.7422300577163696e+02 2.1693198941648006e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -4.3250001035630703e+00) (float-vector -5.9555699117481709e+00 -1.6789999604225159e+02 1.1203699978068471e+00) (float-vector -1.3005600310862064e+01 -1.7422300577163696e+02 2.1693198941648006e+00) (float-vector -2.5318099185824394e+01 -1.6789999604225159e+02 -4.0360698476433754e+00) (float-vector -1.8734399229288101e+01 -1.5862999856472015e+02 -7.4006798677146435e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9555699117481709e+00 -1.6789999604225159e+02 1.1203699978068471e+00) (float-vector -1.2914000544697046e+00 -1.5862999856472015e+02 -4.3250001035630703e+00) (float-vector 2.4208599701523781e+01 -1.5862999856472015e+02 -1.1157699860632420e+01) (float-vector 7.4331499636173248e+00 -1.6789999604225159e+02 6.3673901604488492e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7462701797485352e+01 -2.1288000047206879e+02 -2.7651900425553322e+01) (float-vector -4.3126299977302551e+01 -2.0053699612617493e+02 -1.4182999730110168e+01) (float-vector -3.4073598682880402e+01 -2.1613000333309174e+02 -1.6256699338555336e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0241599529981613e+01 -1.8738000094890594e+02 1.9462399650365114e+00) (float-vector -2.6182500645518303e+01 -2.0053699612617493e+02 -2.1907200571149588e+00) (float-vector -4.3126299977302551e+01 -2.0053699612617493e+02 -1.4182999730110168e+01) (float-vector -4.4302299618721008e+01 -1.8738000094890594e+02 -1.3026500120759010e+01) (float-vector -3.2944899052381516e+01 -1.8074999749660492e+02 -4.4586500152945518e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4126699194312096e+01 -2.1288000047206879e+02 -6.5793199464678764e+00) (float-vector -3.4073598682880402e+01 -2.1613000333309174e+02 -1.6256699338555336e+01) (float-vector -4.3126299977302551e+01 -2.0053699612617493e+02 -1.4182999730110168e+01) (float-vector -2.6182500645518303e+01 -2.0053699612617493e+02 -2.1907200571149588e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4302299618721008e+01 -1.8738000094890594e+02 -1.3026500120759010e+01) (float-vector -4.3126299977302551e+01 -2.0053699612617493e+02 -1.4182999730110168e+01) (float-vector -4.7462701797485352e+01 -2.1288000047206879e+02 -2.7651900425553322e+01) (float-vector -5.4833900183439255e+01 -2.0053699612617493e+02 -3.1324699521064758e+01) (float-vector -5.3034301847219467e+01 -1.8738000094890594e+02 -2.4312499910593033e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4873900450766087e+01 -1.9401000440120697e+02 2.3639500141143799e+00) (float-vector 8.8624499039724469e-01 -1.8738000094890594e+02 4.9606799148023129e+00) (float-vector 7.4331499636173248e+00 -1.6789999604225159e+02 6.3673901604488492e-01) (float-vector 2.7971999719738960e+01 -1.8074999749660492e+02 -3.0470199417322874e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.0005301386117935e+00 -2.1288000047206879e+02 -2.1382099948823452e+00) (float-vector 3.0372200533747673e+01 -2.1288000047206879e+02 -1.1793299578130245e+01) (float-vector 7.7944798395037651e+00 -2.2788000106811523e+02 -2.4381399154663086e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.0005301386117935e+00 -2.1288000047206879e+02 -2.1382099948823452e+00) (float-vector 7.7944798395037651e+00 -2.2788000106811523e+02 -2.4381399154663086e+01) (float-vector -1.0377299971878529e+01 -2.2788000106811523e+02 -2.4381399154663086e+01) (float-vector -1.0147499851882458e+01 -2.1613000333309174e+02 -5.0998101942241192e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0147499851882458e+01 -2.1613000333309174e+02 -5.0998101942241192e+00) (float-vector -2.4126699194312096e+01 -2.1288000047206879e+02 -6.5793199464678764e+00) (float-vector -2.6182500645518303e+01 -2.0053699612617493e+02 -2.1907200571149588e+00) (float-vector -1.2598799541592598e+01 -2.0686000585556030e+02 1.7253500118386000e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4126699194312096e+01 -2.1288000047206879e+02 -6.5793199464678764e+00) (float-vector -1.0147499851882458e+01 -2.1613000333309174e+02 -5.0998101942241192e+00) (float-vector -1.0377299971878529e+01 -2.2788000106811523e+02 -2.4381399154663086e+01) (float-vector -3.1767699867486954e+01 -2.2788000106811523e+02 -4.4777099043130875e+01) (float-vector -3.4073598682880402e+01 -2.1613000333309174e+02 -1.6256699338555336e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4873900450766087e+01 -1.9401000440120697e+02 2.3639500141143799e+00) (float-vector 7.0005301386117935e+00 -2.1288000047206879e+02 -2.1382099948823452e+00) (float-vector -1.0147499851882458e+01 -2.1613000333309174e+02 -5.0998101942241192e+00) (float-vector -1.2598799541592598e+01 -2.0686000585556030e+02 1.7253500118386000e-01) (float-vector 8.8624499039724469e-01 -1.8738000094890594e+02 4.9606799148023129e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6637900620698929e+01 -2.2788000106811523e+02 -3.9200000464916229e+01) (float-vector 3.0922099947929382e+01 -2.2788000106811523e+02 -5.6859500706195831e+01) (float-vector 4.9510197713971138e+00 -2.3213000595569611e+02 -6.0945700854063034e+01) (float-vector -6.2287999317049980e+00 -2.3213000595569611e+02 -4.8529300838708878e+01) (float-vector -1.0377299971878529e+01 -2.2788000106811523e+02 -2.4381399154663086e+01) (float-vector 7.7944798395037651e+00 -2.2788000106811523e+02 -2.4381399154663086e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3159399181604385e+01 -2.1288000047206879e+02 -8.5684701800346375e+01) (float-vector 2.4978699162602425e+01 -2.2788000106811523e+02 -7.4031800031661987e+01) (float-vector 3.0922099947929382e+01 -2.2788000106811523e+02 -5.6859500706195831e+01) (float-vector 5.2117701619863510e+01 -2.1288000047206879e+02 -6.2037199735641479e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0922099947929382e+01 -2.2788000106811523e+02 -5.6859500706195831e+01) (float-vector 2.4978699162602425e+01 -2.2788000106811523e+02 -7.4031800031661987e+01) (float-vector 4.8119500279426575e+00 -2.2788000106811523e+02 -8.6992196738719940e+01) (float-vector 4.9510197713971138e+00 -2.3213000595569611e+02 -6.0945700854063034e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3277499936521053e+01 -2.2788000106811523e+02 -8.5264898836612701e+01) (float-vector -4.0359698235988617e+01 -2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector -3.0626999214291573e+01 -2.2788000106811523e+02 -6.8722099065780640e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3277499936521053e+01 -2.2788000106811523e+02 -8.5264898836612701e+01) (float-vector -3.0626999214291573e+01 -2.2788000106811523e+02 -6.8722099065780640e+01) (float-vector -3.1767699867486954e+01 -2.2788000106811523e+02 -4.4777099043130875e+01) (float-vector -6.2287999317049980e+00 -2.3213000595569611e+02 -4.8529300838708878e+01) (float-vector 4.9510197713971138e+00 -2.3213000595569611e+02 -6.0945700854063034e+01) (float-vector 4.8119500279426575e+00 -2.2788000106811523e+02 -8.6992196738719940e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2719600461423397e+01 -2.1288000047206879e+02 -1.0792700201272964e+02) (float-vector -1.3277499936521053e+01 -2.2788000106811523e+02 -8.5264898836612701e+01) (float-vector 4.8119500279426575e+00 -2.2788000106811523e+02 -8.6992196738719940e+01) (float-vector -4.4343902118271217e-02 -2.1288000047206879e+02 -1.0914000123739243e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0359698235988617e+01 -2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector -1.3277499936521053e+01 -2.2788000106811523e+02 -8.5264898836612701e+01) (float-vector -1.2719600461423397e+01 -2.1288000047206879e+02 -1.0792700201272964e+02) (float-vector -3.5478301346302032e+01 -2.1288000047206879e+02 -9.6904397010803223e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0372200533747673e+01 -2.1288000047206879e+02 -1.1793299578130245e+01) (float-vector 4.3548498302698135e+01 -2.1288000047206879e+02 -2.5542899966239929e+01) (float-vector 4.6632900834083557e+01 -2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector 2.6637900620698929e+01 -2.2788000106811523e+02 -3.9200000464916229e+01) (float-vector 7.7944798395037651e+00 -2.2788000106811523e+02 -2.4381399154663086e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3548498302698135e+01 -2.1288000047206879e+02 -2.5542899966239929e+01) (float-vector 4.7585401684045792e+01 -2.0053699612617493e+02 -2.2861599922180176e+01) (float-vector 5.3843200206756592e+01 -2.0053699612617493e+02 -3.5250298678874969e+01) (float-vector 4.6632900834083557e+01 -2.1613000333309174e+02 -3.7882000207901001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3949598670005798e+01 -1.9401000440120697e+02 -6.8750199861824512e+00) (float-vector 1.4873900450766087e+01 -1.9401000440120697e+02 2.3639500141143799e+00) (float-vector 2.7971999719738960e+01 -1.8074999749660492e+02 -3.0470199417322874e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3949598670005798e+01 -1.9401000440120697e+02 -6.8750199861824512e+00) (float-vector 3.0372200533747673e+01 -2.1288000047206879e+02 -1.1793299578130245e+01) (float-vector 7.0005301386117935e+00 -2.1288000047206879e+02 -2.1382099948823452e+00) (float-vector 1.4873900450766087e+01 -1.9401000440120697e+02 2.3639500141143799e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.4659301638603210e+01 -1.8738000094890594e+02 -1.6239900141954422e+01) (float-vector 3.3949598670005798e+01 -1.9401000440120697e+02 -6.8750199861824512e+00) (float-vector 2.7971999719738960e+01 -1.8074999749660492e+02 -3.0470199417322874e+00) (float-vector 3.5298600792884827e+01 -1.6188000142574310e+02 -1.5843799337744713e+01) (float-vector 4.9263000488281250e+01 -1.6789999604225159e+02 -2.9789000749588013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3949598670005798e+01 -1.9401000440120697e+02 -6.8750199861824512e+00) (float-vector 4.4659301638603210e+01 -1.8738000094890594e+02 -1.6239900141954422e+01) (float-vector 4.7585401684045792e+01 -2.0053699612617493e+02 -2.2861599922180176e+01) (float-vector 4.3548498302698135e+01 -2.1288000047206879e+02 -2.5542899966239929e+01) (float-vector 3.0372200533747673e+01 -2.1288000047206879e+02 -1.1793299578130245e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4208599701523781e+01 -2.1613000333309174e+02 -9.9492296576499939e+01) (float-vector -4.4343902118271217e-02 -2.1288000047206879e+02 -1.0914000123739243e+02) (float-vector 4.8119500279426575e+00 -2.2788000106811523e+02 -8.6992196738719940e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4208599701523781e+01 -2.1613000333309174e+02 -9.9492296576499939e+01) (float-vector 2.4978699162602425e+01 -2.2788000106811523e+02 -7.4031800031661987e+01) (float-vector 4.3159399181604385e+01 -2.1288000047206879e+02 -8.5684701800346375e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4978699162602425e+01 -2.2788000106811523e+02 -7.4031800031661987e+01) (float-vector 2.4208599701523781e+01 -2.1613000333309174e+02 -9.9492296576499939e+01) (float-vector 4.8119500279426575e+00 -2.2788000106811523e+02 -8.6992196738719940e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4343902118271217e-02 -2.1288000047206879e+02 -1.0914000123739243e+02) (float-vector 2.4208599701523781e+01 -2.1613000333309174e+02 -9.9492296576499939e+01) (float-vector 2.5731399655342102e+01 -2.0686000585556030e+02 -1.0509999841451645e+02) (float-vector 1.3808299787342548e+01 -2.0053699612617493e+02 -1.1202400177717209e+02) (float-vector 6.7928602220490575e-02 -2.0053699612617493e+02 -1.1398500204086304e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5731399655342102e+01 -2.0686000585556030e+02 -1.0509999841451645e+02) (float-vector 2.4208599701523781e+01 -2.1613000333309174e+02 -9.9492296576499939e+01) (float-vector 4.3159399181604385e+01 -2.1288000047206879e+02 -8.5684701800346375e+01) (float-vector 4.3837901204824448e+01 -1.9401000440120697e+02 -9.4728998839855194e+01) (float-vector 3.3319901674985886e+01 -1.9401000440120697e+02 -1.0422699898481369e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_l_wheel_link_xEgDUO.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_estop_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -1.2464999999999999e+02 2.3891999999999999e+02 3.1126999999999998e+02)
                                    :rot (quaternion2matrix (float-vector 7.0710548251123639e-01 7.0710807985947355e-01 0.0000000000000000e+00 0.0000000000000000e+00)))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.400000 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.800000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 284 1 0 284 0 287 287 0 342 2 352 0 0 352 342 282 283 284 286 282 284 286 284 287 283 1 284 290 286 287 290 287 291 287 342 291 285 282 286 289 285 286 289 286 290 293 289 290 293 290 291 291 342 293 292 289 293 363 293 342 363 373 293 293 373 374 293 374 292 288 285 289 292 288 289 251 250 288 288 250 285 251 288 292 249 250 251 251 292 249 249 248 250 248 278 250 250 278 280 250 280 285 247 248 249 249 292 294 249 294 247 246 245 247 247 245 248 294 246 247 244 245 246 294 244 246 244 243 245 243 274 245 245 274 276 245 276 248 242 243 244 295 242 244 295 244 294 242 240 243 240 272 243 243 272 274 241 240 242 241 242 295 239 238 240 239 240 241 238 270 240 240 270 272 270 271 272 272 271 273 272 273 274 268 269 270 270 269 271 238 268 270 269 303 271 271 303 304 271 304 273 274 273 275 273 304 275 274 275 276 276 275 277 275 304 313 275 313 277 303 302 304 304 302 313 301 302 303 267 301 303 267 303 269 268 267 269 266 265 267 266 267 268 265 301 267 301 305 302 263 305 301 263 301 265 264 263 265 264 265 266 234 264 266 234 266 236 236 266 268 236 268 238 235 234 236 235 236 237 237 236 238 233 232 234 233 234 235 232 264 234 262 263 264 232 262 264 231 229 232 231 232 233 229 262 232 297 231 233 297 233 296 296 233 235 296 235 237 237 238 239 239 296 237 239 295 296 295 370 296 296 370 371 296 371 297 241 295 239 294 369 295 295 369 370 369 444 370 370 444 445 370 445 371 297 371 372 371 445 446 371 446 372 444 484 445 445 484 485 445 485 446 369 443 444 443 483 444 444 483 484 484 531 485 483 537 484 484 537 538 484 538 531 446 485 486 485 531 532 485 532 486 617 532 531 617 531 622 622 531 538 622 538 621 621 538 537 621 576 622 617 622 618 618 622 576 613 617 579 579 617 618 613 532 617 486 532 533 613 533 532 613 579 614 614 534 613 534 533 613 578 579 569 614 579 578 579 618 569 618 576 569 576 577 569 620 577 576 620 576 621 619 577 620 619 623 577 577 623 624 577 624 569 621 537 620 537 536 620 620 536 535 620 535 619 619 535 413 619 413 623 413 535 411 411 535 536 411 536 483 483 536 537 411 412 413 442 412 411 442 411 443 443 411 483 412 539 413 413 539 623 441 412 442 441 494 412 412 494 539 375 441 442 375 442 376 376 442 443 376 443 369 294 375 376 294 376 369 292 374 375 292 375 294 374 441 375 374 456 441 441 456 494 373 456 374 373 455 456 455 493 456 456 493 494 363 455 373 363 454 455 454 492 455 455 492 493 492 543 493 493 543 544 493 544 494 454 491 492 491 542 492 492 542 543 626 544 543 626 543 630 543 542 630 494 544 545 625 545 544 625 544 626 494 545 539 623 539 545 623 545 625 625 626 627 623 625 624 624 625 627 627 626 574 630 574 626 627 574 569 624 627 569 574 575 569 629 575 574 629 574 630 628 575 629 628 631 575 575 631 633 575 633 569 630 541 629 629 541 540 629 540 628 540 549 628 628 549 548 628 548 631 489 540 490 490 540 541 489 549 540 490 541 491 491 541 542 630 542 541 452 489 490 452 490 453 453 490 491 453 491 454 360 452 453 360 453 368 368 453 454 359 451 452 359 452 360 451 489 452 359 360 200 349 200 360 349 360 350 350 360 368 350 368 351 351 368 363 368 454 363 6 349 350 6 350 4 4 350 351 8 341 349 8 349 6 341 200 349 4 5 6 6 5 7 6 7 8 2 3 4 4 3 5 4 351 2 335 7 5 335 5 337 337 5 3 8 7 9 334 7 335 334 9 7 334 335 314 335 337 314 314 337 338 337 3 338 314 338 315 338 3 315 2 1 3 3 1 315 2 351 352 351 363 352 352 363 342 313 314 315 279 313 315 279 315 281 281 315 1 281 1 283 280 279 281 280 281 282 282 281 283 278 277 279 278 279 280 277 313 279 285 280 282 311 312 313 313 312 314 313 302 319 313 319 311 319 22 311 311 22 312 302 20 319 319 20 22 20 21 22 22 21 23 22 23 24 22 24 312 17 19 20 20 19 21 302 17 20 19 355 21 21 355 356 21 356 23 17 18 19 18 354 19 19 354 355 362 356 355 354 362 355 23 356 344 344 356 362 187 23 344 187 344 191 191 344 192 344 362 192 186 184 187 190 186 187 190 187 191 184 23 187 190 191 192 189 186 190 190 192 189 185 182 186 186 182 184 189 185 186 182 183 184 183 24 184 184 24 23 180 181 182 182 181 183 185 180 182 151 180 185 188 151 185 188 185 189 178 179 180 180 179 181 151 178 180 312 183 181 181 179 312 312 24 183 312 179 177 312 177 314 178 177 179 176 177 178 149 176 178 149 178 151 176 175 177 314 177 175 174 175 176 113 174 176 113 176 149 148 113 149 148 149 150 150 149 151 113 114 115 115 147 113 114 113 148 147 174 113 194 148 150 194 114 148 150 151 152 194 150 193 193 150 152 152 151 188 193 152 188 189 192 193 189 193 188 192 381 193 193 381 382 193 382 194 192 362 364 192 364 365 365 380 192 192 380 381 381 457 382 380 470 381 381 470 457 365 469 380 380 469 470 364 468 365 365 468 469 362 467 364 364 467 468 467 501 468 468 501 502 468 502 469 469 502 503 469 503 470 470 503 504 457 470 504 502 564 503 503 564 565 503 565 504 501 563 502 502 563 564 644 565 564 644 564 645 645 564 563 504 565 566 643 566 565 643 565 644 590 643 644 590 644 591 591 644 645 591 645 592 645 562 592 645 563 562 501 562 563 500 561 562 500 562 501 592 562 561 592 593 591 597 593 592 592 561 597 590 591 569 591 593 569 588 569 593 596 588 593 596 593 597 561 560 597 597 560 422 597 422 596 420 560 561 420 561 500 422 560 420 420 421 422 421 507 422 596 422 507 595 588 596 596 507 595 588 589 569 595 589 588 594 589 595 595 507 506 595 506 594 505 506 507 421 505 507 505 509 506 594 506 509 594 602 589 594 509 602 589 602 587 589 587 569 601 587 602 509 510 602 602 510 514 602 514 601 505 508 509 508 510 509 508 475 510 475 514 510 475 513 514 514 513 601 600 587 601 601 513 512 601 512 600 474 512 513 474 513 475 431 474 475 423 431 475 423 475 508 424 423 508 424 508 505 402 401 423 402 423 424 401 431 423 400 430 431 400 431 401 430 474 431 400 401 110 110 401 402 110 402 111 111 402 403 403 402 424 111 403 112 112 403 404 403 464 404 403 424 464 112 404 361 404 464 465 404 465 361 464 421 465 464 424 505 464 505 421 361 465 466 465 421 420 465 420 466 361 362 112 361 466 362 362 466 467 466 420 500 466 500 467 353 112 362 353 362 354 16 343 353 16 353 18 18 353 354 343 112 353 15 14 16 15 16 17 16 18 17 14 343 16 31 112 343 31 343 28 28 343 14 12 13 14 12 14 15 28 14 29 29 14 13 28 29 30 31 28 32 28 30 32 30 29 13 328 30 13 328 13 324 324 13 12 324 12 15 323 324 322 322 324 325 323 326 324 324 326 327 324 327 328 324 15 325 322 325 302 325 15 17 325 17 302 302 321 322 79 323 322 79 322 81 81 322 83 83 322 321 302 320 321 83 321 85 85 321 87 87 321 320 82 81 83 82 83 84 84 83 85 80 79 81 80 81 82 51 80 82 51 82 53 53 82 84 84 85 86 53 84 56 56 84 86 86 85 87 86 87 88 56 86 58 58 86 88 55 53 56 55 56 57 57 56 58 57 58 59 59 58 60 60 58 61 58 88 61 107 55 57 107 57 106 106 57 59 54 53 55 107 54 55 52 53 54 107 52 54 52 51 53 50 51 52 108 50 52 108 52 107 50 48 51 48 80 51 49 48 50 108 49 50 47 46 48 47 48 49 46 78 48 48 78 80 78 79 80 76 77 78 78 77 79 46 76 78 45 25 46 45 46 47 25 76 46 74 75 76 76 75 77 25 74 76 75 323 77 77 323 79 74 73 75 73 326 75 75 326 323 72 73 74 44 72 74 44 74 25 72 71 73 71 326 73 71 327 326 70 69 71 70 71 72 69 327 71 41 70 72 41 72 44 27 41 44 27 44 25 25 26 27 43 41 27 110 43 27 110 27 109 109 27 26 26 25 45 109 26 45 109 45 47 109 47 108 108 399 109 109 399 400 109 400 110 108 47 49 107 398 108 108 398 399 398 429 399 399 429 430 399 430 400 107 397 398 397 428 398 398 428 429 106 397 107 106 396 397 396 427 397 397 427 428 427 471 428 428 471 472 428 472 429 396 426 427 426 417 427 427 417 471 379 396 106 379 426 396 379 425 426 425 418 426 426 418 417 417 418 419 419 515 417 417 515 516 417 516 471 425 482 418 418 482 519 418 519 419 604 515 419 604 419 605 419 519 605 603 516 515 603 515 604 471 516 517 517 516 603 603 604 584 598 603 586 586 603 584 598 517 603 584 604 605 582 569 584 584 605 582 586 584 569 585 586 569 598 586 599 599 586 585 599 518 598 598 518 517 599 585 600 600 511 599 599 511 518 585 569 587 600 585 587 600 512 511 472 511 473 473 511 512 472 518 511 472 517 518 429 472 473 471 517 472 429 473 430 430 473 474 473 512 474 567 568 569 570 571 569 572 573 569 580 581 569 582 583 569 568 590 569 581 612 569 583 580 569 612 578 569 633 572 569 571 567 569 573 570 569 568 643 590 567 642 568 568 642 643 571 640 567 640 641 567 567 641 642 641 407 642 407 559 642 642 559 566 642 566 643 640 555 641 641 555 407 405 406 407 407 555 405 406 559 407 406 504 559 504 566 559 457 406 458 458 406 405 457 504 406 382 457 458 382 458 383 383 458 459 458 405 459 382 383 194 194 383 384 383 459 384 384 459 460 459 405 495 459 495 460 194 384 195 195 384 385 384 460 385 195 115 194 194 115 114 146 144 115 115 144 147 195 146 115 145 144 146 145 146 195 140 144 145 145 195 140 140 143 144 143 170 144 144 170 172 144 172 147 147 172 174 170 171 172 172 171 173 172 173 174 168 169 170 170 169 171 143 168 170 135 143 140 135 168 143 166 167 168 168 167 169 135 166 168 329 169 330 330 169 167 329 171 169 329 173 171 329 330 331 329 331 314 314 173 329 331 330 332 330 165 332 330 167 165 166 165 167 164 163 165 164 165 166 332 165 163 331 332 333 332 161 333 332 163 161 162 161 163 162 163 164 130 162 164 130 164 137 137 164 166 160 161 162 132 160 162 132 162 130 160 159 161 333 161 159 158 159 160 125 158 160 125 160 132 130 131 132 132 131 133 132 133 125 125 126 127 125 133 134 125 134 126 127 158 125 198 133 131 198 134 133 130 139 131 198 131 197 197 131 139 137 138 130 130 138 139 197 139 138 137 136 138 197 138 136 197 136 196 196 386 197 197 386 387 197 387 198 135 136 137 135 142 136 196 136 142 137 166 135 140 141 135 135 141 142 196 142 141 140 196 141 140 195 196 195 385 196 196 385 386 385 460 461 385 461 386 460 495 496 460 496 461 386 461 462 461 496 497 461 497 462 496 551 497 495 557 496 496 557 558 496 558 551 405 556 495 495 556 557 637 558 557 637 557 640 557 556 640 638 551 558 638 558 637 637 571 638 637 640 571 640 556 555 405 555 556 638 571 570 638 570 639 639 551 638 573 639 570 634 639 573 634 552 639 639 552 551 634 573 635 635 573 572 635 554 634 554 553 634 634 553 552 497 551 552 497 552 498 498 552 553 498 553 499 499 553 554 499 554 550 635 550 554 463 498 499 448 463 499 448 499 409 409 499 550 462 497 498 462 498 463 387 462 463 387 463 388 388 463 448 388 448 389 389 448 449 448 409 449 408 409 410 449 409 408 409 550 410 389 449 390 390 449 450 449 408 450 198 388 389 198 389 199 199 389 390 387 388 198 386 462 387 199 126 198 198 126 134 127 126 128 199 128 126 127 128 121 121 156 127 127 156 158 121 128 129 199 129 128 121 122 123 121 129 122 123 154 121 121 154 156 154 155 156 156 155 157 156 157 158 158 157 159 333 157 331 331 157 155 333 159 157 154 153 155 331 155 153 120 153 154 123 120 154 120 118 153 118 336 153 153 336 331 314 331 336 314 336 334 336 11 334 118 11 336 116 117 118 116 118 120 117 11 118 119 116 120 119 120 123 119 341 116 116 341 10 116 10 117 117 10 11 10 9 11 334 11 9 8 9 10 10 341 8 119 200 341 123 124 119 124 200 119 123 122 124 200 124 122 200 122 199 199 390 200 200 390 391 200 391 359 199 122 129 391 451 359 390 450 391 391 450 451 450 488 451 451 488 489 450 408 488 408 547 488 488 547 548 488 548 489 489 548 549 631 548 547 408 546 547 631 547 632 632 547 546 410 546 408 632 546 636 636 546 410 631 632 633 633 632 572 636 572 632 635 572 636 636 410 635 410 550 635 314 175 173 174 173 175 614 578 615 615 578 616 612 616 578 615 416 614 416 530 614 614 530 534 616 526 615 615 526 416 611 616 612 611 527 616 616 527 526 581 611 612 607 611 581 607 528 611 611 528 527 414 526 527 414 527 476 476 527 528 416 526 414 414 415 416 433 415 414 433 414 434 434 414 476 434 476 435 435 476 477 476 528 477 477 528 529 607 529 528 435 477 436 436 477 478 477 520 478 477 529 520 395 434 435 395 435 357 357 435 436 357 436 358 358 436 437 436 478 437 437 478 479 478 520 521 478 521 479 358 437 366 366 437 438 437 479 438 438 479 480 479 521 522 479 522 480 609 522 521 609 521 608 608 521 520 480 522 523 523 522 609 438 480 439 439 480 481 480 523 481 481 523 524 610 524 523 610 523 609 608 580 609 609 580 610 606 610 583 583 610 580 606 524 610 481 524 482 482 524 525 606 525 524 439 481 440 440 481 482 425 440 482 482 525 519 605 519 525 605 525 606 582 605 606 582 606 583 377 439 440 377 440 378 378 440 425 378 425 379 105 377 378 105 378 104 104 378 379 367 377 105 367 439 377 367 438 439 105 366 367 366 438 367 366 105 358 104 101 105 105 101 102 105 102 103 103 340 105 358 105 340 100 97 101 101 97 98 101 98 102 104 100 101 102 98 99 102 99 103 99 340 103 99 201 340 201 348 340 358 340 348 98 96 99 96 201 99 97 94 98 98 94 96 94 95 96 95 202 96 96 202 201 201 202 203 203 348 201 203 347 348 348 347 358 203 202 204 203 204 205 205 347 203 204 202 318 93 318 202 93 202 95 94 93 95 92 91 93 92 93 94 91 318 93 302 317 318 318 320 302 317 204 318 91 320 318 90 89 91 90 91 92 89 320 91 87 320 89 88 87 89 88 89 90 61 88 90 61 90 63 63 90 92 60 61 62 62 61 63 62 63 64 63 92 97 64 63 100 100 63 97 64 104 62 62 104 106 62 106 60 106 59 60 104 379 106 64 100 104 97 92 94 205 204 206 316 206 204 316 204 317 205 206 207 207 346 205 205 346 347 207 206 208 310 208 206 310 206 316 310 316 302 302 316 317 302 309 310 309 208 310 207 208 209 209 208 210 309 210 208 302 308 309 308 212 309 309 212 210 302 305 306 302 306 307 307 308 302 214 212 308 214 308 252 252 308 307 211 210 212 213 212 214 213 211 212 209 210 211 215 339 211 215 211 213 211 339 209 213 214 215 215 214 216 214 252 216 216 252 253 252 307 253 215 216 217 216 253 254 217 216 220 220 216 254 217 339 215 220 219 217 219 300 217 217 300 339 218 219 220 218 220 221 221 220 222 220 254 222 300 219 299 299 219 218 299 218 221 221 222 223 223 299 221 223 222 224 222 254 256 222 256 224 223 224 225 225 298 223 223 298 299 298 393 299 299 393 394 299 394 300 298 392 393 392 432 393 393 432 433 393 433 394 300 394 395 394 433 434 394 434 395 432 415 433 392 447 432 432 447 487 432 487 415 415 487 530 415 530 416 447 486 487 486 533 487 487 533 534 487 534 530 446 486 447 372 446 447 372 447 392 297 372 298 372 392 298 298 228 297 297 228 230 297 230 231 225 226 298 298 226 228 226 227 228 228 227 229 228 229 230 230 229 231 227 260 229 229 260 262 226 224 227 224 258 227 227 258 260 225 224 226 224 256 258 256 257 258 258 257 259 258 259 260 260 259 261 260 261 262 262 261 263 259 305 261 261 305 263 257 306 259 259 306 305 256 255 257 255 306 257 254 255 256 254 253 255 253 307 255 255 307 306 300 395 357 357 358 300 339 300 345 345 300 358 345 358 346 346 358 347 209 339 345 209 345 207 207 345 346 608 581 580 607 581 608 608 520 607 520 529 607 111 37 110 110 37 42 110 42 43 37 41 42 42 41 43 37 40 41 40 70 41 33 40 37 33 68 40 40 68 70 68 69 70 66 67 68 68 67 69 33 66 68 67 327 69 66 65 67 65 328 67 67 328 327 32 65 66 35 32 66 35 66 33 32 30 65 65 30 328 31 32 35 33 34 35 35 34 36 35 36 31 36 112 31 34 112 36 33 39 34 39 111 34 34 111 112 37 38 33 33 38 39 39 38 111 111 38 37 467 500 501 276 277 278 248 276 278 646 647 648 646 648 690 1116 647 646 1116 646 1117 1117 646 690 988 1115 1116 1116 1117 988 1115 647 1116 1052 1054 1117 988 1117 1054 1117 690 1052 1052 1053 1054 1053 1052 690 1053 1108 1054 1054 1108 1107 1054 1107 1343 988 1054 989 989 1054 1343 1053 690 1108 1106 1107 1108 1108 690 691 1108 691 1106 1103 1105 1106 1106 1105 1107 691 692 1106 1106 692 1103 690 660 691 691 660 659 691 659 692 690 648 660 647 654 648 1233 660 648 1233 648 1234 1234 648 654 647 653 654 1234 654 1235 1235 654 1236 1236 654 653 1234 1235 870 870 1233 1234 1231 1232 1233 870 1231 1233 1232 660 1233 1050 1232 1051 1051 1232 1231 1050 660 1232 1049 1050 1051 1049 708 1050 1050 708 660 1049 1051 1244 708 1049 706 706 1049 1244 706 707 708 708 707 709 708 709 660 706 1244 1643 1656 706 1643 706 2195 707 706 1656 2195 2194 709 707 707 2195 2196 707 2196 2194 660 709 710 2193 710 709 2193 709 2194 2188 2193 2194 2188 2194 2189 2189 2194 2196 2189 2196 2190 2190 2196 2195 1696 2188 2189 1696 2189 1694 1694 2189 2190 1698 2187 2188 1698 2188 1696 2187 2193 2188 2192 710 2193 2187 2192 2193 1700 2186 2187 1700 2187 1698 2186 2192 2187 1696 1697 1698 1698 1697 1699 1698 1699 1700 1700 1699 1701 1700 1701 1702 1702 2186 1700 1702 2185 2186 2185 2191 2186 2186 2191 2192 1702 1701 1703 1702 1703 1704 1704 2185 1702 1704 2184 2185 2184 2226 2185 2185 2226 2191 1704 1703 1705 1704 1705 1706 1706 2184 1704 1701 2038 1703 1703 2038 2039 1703 2039 1705 1706 1705 1707 1705 2025 1707 1705 2039 2040 1705 2040 2025 1706 1707 1708 1708 2183 1706 1706 2183 2184 1708 1707 1709 1707 2025 2026 1707 2026 1709 2108 2026 2025 2108 2025 2109 2109 2025 2040 2109 2040 2110 2110 2040 2039 2100 2108 2109 2100 2109 2099 2099 2109 2110 2102 2107 2108 2102 2108 2100 2107 2026 2108 1709 2026 2027 2107 2027 2026 2101 2106 2107 2101 2107 2102 2106 2027 2107 1709 2027 2009 2106 2009 2027 2104 2105 2106 2104 2106 2101 2105 2009 2106 1709 2009 1711 1711 2009 2010 2105 2010 2009 2103 2105 2104 2103 2154 2105 2154 2010 2105 1711 2010 1713 1713 2010 2011 2154 2011 2010 1710 1709 1711 1710 1711 1712 1712 1711 1713 1708 1709 1710 1712 2181 1710 1710 2181 2182 1710 2182 1708 1712 1713 1714 1714 2180 1712 1712 2180 2181 2180 2222 2181 2181 2222 2223 2181 2223 2182 1708 2182 2183 2182 2224 2183 2182 2223 2224 2222 1673 2223 2223 1673 1672 2223 1672 2224 2221 1674 2222 2222 1674 1673 2180 2221 2222 1510 1672 1673 1510 1673 1511 1511 1673 1674 1509 1671 1672 1509 1672 1510 2224 1672 1671 1083 1509 1510 1083 1510 1081 1081 1510 1511 1079 1080 1081 1081 1080 1082 1081 1082 1083 1081 1511 1079 1077 1078 1079 1079 1078 1080 1511 1077 1079 1082 1080 1346 1078 1346 1080 1083 1082 1084 1346 1368 1082 1082 1368 1084 1347 1479 1346 1347 1346 1078 1479 1366 1346 1346 1366 1368 1077 1076 1078 1078 1076 1347 1348 1477 1347 1348 1347 1074 1074 1347 1076 1477 1479 1347 1477 1478 1479 1478 1449 1479 1479 1449 1366 1475 1476 1477 1475 1477 1348 1476 1478 1477 1981 1449 1478 1981 1478 1982 1982 1478 1476 1448 1366 1449 1980 1448 1449 1980 1449 1981 1928 1980 1981 1928 1981 1929 1929 1981 1982 1929 1982 1930 1930 1982 1983 1982 1476 1983 1805 1928 1929 1805 1929 1802 1802 1929 1930 1808 1927 1928 1808 1928 1805 1927 1980 1928 1802 1804 1805 1804 1806 1805 1805 1806 1807 1805 1807 1808 1802 1803 1804 1806 1804 2060 2060 1804 1803 2059 1807 1806 2059 1806 2060 1807 1809 1808 1809 1807 2059 2058 1809 2059 2060 2149 2059 2059 2149 2150 2059 2150 2058 2060 1803 2061 2061 2148 2060 2060 2148 2149 2148 2023 2149 2149 2023 2022 2149 2022 2150 2058 2150 2151 2150 2022 2021 2150 2021 2151 1717 2021 2022 1717 2022 1719 1719 2022 2023 1719 2023 1721 1721 2023 2024 2148 2024 2023 1718 1717 1719 1718 1719 1720 1720 1719 1721 1720 1721 1722 1722 1721 1723 1721 2005 1723 1721 2024 2005 2147 2005 2024 2147 2024 2148 1723 2005 2006 2146 2006 2005 2146 2005 2147 1722 1723 1724 1724 1723 1725 1723 2006 1725 2006 2050 1725 2145 2050 2006 2145 2006 2146 2063 2145 2146 2063 2146 2062 2062 2146 2147 2064 2144 2145 2064 2145 2063 2144 2050 2145 1725 2050 2051 2144 2051 2050 2065 2143 2144 2065 2144 2064 2143 2051 2144 1725 2051 1727 1727 2051 2052 2143 2052 2051 2066 2142 2143 2066 2143 2065 2142 2052 2143 1727 2052 1729 1729 2052 2053 2142 2053 2052 1726 1725 1727 1726 1727 1728 1728 1727 1729 1728 1729 1730 1730 1729 1731 1729 2053 1731 1731 2053 2054 2141 2054 2053 2141 2053 2142 1730 1731 1732 1732 1731 1733 1731 2034 1733 1731 2054 2034 2140 2034 2054 2140 2054 2141 2067 2140 2141 2067 2141 2068 2068 2141 2142 2070 2139 2140 2070 2140 2067 2139 2034 2140 1733 2034 2035 2139 2035 2034 2069 2138 2139 2069 2139 2070 2138 2035 2139 1733 2035 1735 1735 2035 2036 2138 2036 2035 2072 2137 2138 2072 2138 2069 2137 2036 2138 1735 2036 2019 2137 2019 2036 2071 2136 2137 2071 2137 2072 2136 2019 2137 1735 2019 1737 1737 2019 2020 2136 2020 2019 2073 2135 2136 2073 2136 2071 2135 2020 2136 1737 2020 1739 2020 2030 1739 2135 2030 2020 1736 1735 1737 1736 1737 1738 1738 1737 1739 1734 1735 1736 1738 2167 1736 1736 2167 2168 1736 2168 1734 1734 1733 1735 1732 1733 1734 1734 2168 2169 1734 2169 1732 2167 2209 2168 2168 2209 2210 2168 2210 2169 1732 2169 2170 2169 2210 2211 2169 2211 2170 1732 2170 1730 2170 2171 1730 2170 2211 2212 2170 2212 2171 2210 1666 2211 2211 1666 1665 2211 1665 2212 2209 1667 2210 2210 1667 1666 1518 1665 1666 1518 1666 1520 1520 1666 1667 1514 1664 1665 1514 1665 1518 2212 1665 1664 2212 1664 2213 2171 2212 2213 1517 1663 1664 1517 1664 1514 2213 1664 1663 2213 1663 2214 2171 2213 2172 2172 2213 2214 1649 684 1663 1516 1649 1663 1516 1663 1517 2214 1663 684 2214 684 2215 2172 2214 2173 2173 2214 2215 1730 2171 2172 1730 2172 1728 1728 2172 2173 1728 2173 1726 1726 2173 2174 2173 2215 2174 1724 1725 1726 1726 2174 1724 1724 2174 2175 2174 2215 2216 2174 2216 2175 1724 2175 1722 1722 2175 2176 2175 2216 2217 2175 2217 2176 2215 655 2216 2216 655 689 2216 689 2217 2217 689 688 2217 688 2218 2176 2217 2218 657 688 689 657 689 655 655 656 657 2215 656 655 684 656 2215 683 657 656 683 656 684 683 684 1204 1204 684 1190 684 1649 1190 682 657 683 1206 682 683 1206 683 1204 1204 1205 1206 1192 1205 1204 1192 1204 1190 1190 1191 1192 1190 1649 1650 1190 1650 1191 1515 1650 1649 1515 1649 1516 1191 1650 1651 1651 1650 1515 1192 1191 1193 1203 1193 1191 1191 1651 1203 1203 1651 1515 1202 1193 1203 1203 1515 1202 1200 1202 1515 1200 1515 1198 1198 1515 1516 1200 1201 1202 1202 1201 1193 1192 1193 1456 1456 1193 1201 1200 1199 1201 1456 1201 1451 1451 1201 1199 1198 1199 1200 1196 1197 1198 1198 1197 1199 1198 1516 1196 1451 1199 1452 1452 1199 1197 1451 1452 1453 1453 1455 1451 1451 1455 1456 1427 1453 1452 1427 1452 1356 1356 1452 1195 1452 1197 1195 1196 1195 1197 1189 1194 1195 1189 1195 1196 1356 1195 1194 1194 1188 1356 1429 1427 1356 1429 1356 1357 1357 1356 1188 1188 1194 1189 1187 1186 1188 1187 1188 1189 1357 1188 1186 1186 1184 1357 1431 1429 1357 1431 1357 1358 1358 1357 1184 1185 1184 1186 1185 1186 1187 1189 1517 1187 1517 1185 1187 1183 1184 1185 1517 1183 1185 1183 1182 1184 1358 1184 1182 1181 1182 1183 1181 1183 1514 1514 1183 1517 1189 1516 1517 1196 1516 1189 1181 1514 1178 1178 1514 1518 1178 1180 1181 1181 1180 1182 1182 1180 1358 1178 1179 1180 1359 1358 1180 1359 1180 1179 1176 1177 1178 1177 1179 1178 1178 1518 1176 1179 1177 1359 1435 1433 1359 1435 1359 1360 1360 1359 1177 1433 1358 1359 1433 1431 1358 1432 1430 1433 1432 1433 1435 1430 1431 1433 1434 1432 1435 1434 1435 1437 1437 1435 1360 1996 1430 1432 1996 1432 1997 1997 1432 1434 1430 1428 1431 1995 1428 1430 1995 1430 1996 1428 1429 1431 1428 1425 1429 1994 1425 1428 1994 1428 1995 1942 1994 1995 1942 1995 1943 1943 1995 1996 1941 1993 1994 1941 1994 1942 1993 1425 1994 1425 1426 1427 1425 1427 1429 1993 1426 1425 1940 1992 1993 1940 1993 1941 1992 1426 1993 1769 1940 1941 1769 1941 1767 1767 1941 1942 1772 1939 1940 1772 1940 1769 1939 1992 1940 1939 1991 1992 1991 1454 1992 1992 1454 1426 1775 1938 1939 1775 1939 1772 1938 1991 1939 1938 1990 1991 1990 1460 1991 1991 1460 1454 1426 1454 1453 1453 1454 1455 1454 1460 1455 1455 1460 1461 1460 1462 1461 1990 1462 1460 1455 1461 1456 1456 1461 1355 1461 1462 1463 1461 1463 1355 1462 1464 1463 1989 1464 1462 1989 1462 1990 1355 1463 1354 1463 1464 1465 1463 1465 1354 1464 1466 1465 1988 1466 1464 1988 1464 1989 1936 1988 1989 1936 1989 1937 1937 1989 1990 1935 1987 1988 1935 1988 1936 1987 1466 1988 1784 1935 1936 1784 1936 1781 1781 1936 1937 1781 1937 1778 1778 1937 1938 1937 1990 1938 1778 1780 1781 1780 1782 1781 1781 1782 1783 1781 1783 1784 1778 1779 1780 1780 2067 2068 2068 1782 1780 1780 1779 2067 2068 1783 1782 1783 1785 1784 2066 1785 1783 2066 1783 2068 2068 2142 2066 2065 1788 2066 2066 1788 1786 1786 1785 2066 1784 1785 1786 1784 1786 1787 1786 1788 1787 1787 1788 1789 2065 1789 1788 2064 1791 2065 1791 1789 2065 1787 1789 1790 1789 1791 1790 1790 1934 1787 1787 1934 1935 1787 1935 1784 1790 1791 1792 1790 1792 1793 1793 1933 1790 1790 1933 1934 2064 1792 1791 2063 1794 2064 1794 1792 2064 1792 1794 1793 1793 1794 1795 1793 1795 1796 1796 1932 1793 1793 1932 1933 1932 1985 1933 1933 1985 1986 1933 1986 1934 1796 1931 1932 1931 1984 1932 1932 1984 1985 1984 1472 1985 1985 1472 1470 1985 1470 1986 1934 1986 1987 1986 1470 1468 1986 1468 1987 1468 1470 1469 1469 1470 1471 1470 1472 1471 1466 1468 1467 1467 1468 1469 1987 1468 1466 1934 1987 1935 1465 1466 1467 1465 1467 1353 1353 1467 1352 1467 1469 1352 1352 1469 1351 1469 1471 1351 1325 1326 1352 1353 1352 1041 1041 1352 1326 1352 1351 1325 1058 1324 1351 1325 1351 1324 1351 1471 1350 1351 1350 1058 1324 1031 1325 1325 1031 1326 1031 1042 1326 1326 1042 1041 1040 1041 1042 1041 1040 1353 1027 1342 1042 1042 1342 1045 1042 1045 1040 1031 1027 1042 1040 1045 1044 1044 1353 1040 1354 1465 1353 1354 1353 1044 1043 1044 1045 1044 1043 1354 1048 1043 1045 1048 1045 1340 1340 1045 1342 1047 1043 1048 1047 1354 1043 1355 1354 1047 1046 1047 1048 1047 1046 1355 1340 1341 1048 1046 1048 1205 1205 1048 1341 1342 977 1340 1340 977 975 1340 975 1341 980 978 1342 1342 978 977 1027 980 1342 975 977 976 976 977 978 969 974 975 969 975 976 1341 975 974 976 978 979 979 1008 976 976 1008 1009 976 1009 969 978 980 979 979 980 981 979 981 982 982 801 979 979 801 1008 1008 801 731 731 1009 1008 969 1009 1010 731 1010 1009 678 730 731 678 731 718 731 801 800 731 800 718 730 1010 731 801 802 800 982 802 801 798 799 800 800 802 803 800 803 798 718 800 799 678 718 719 718 796 719 718 799 796 798 796 799 785 795 796 785 796 797 797 796 798 719 796 795 784 795 785 719 795 784 782 783 784 782 784 785 783 719 784 793 783 782 793 782 794 1563 1552 782 782 1552 794 1563 782 785 792 783 793 794 1552 793 793 1552 1553 793 1553 792 1552 1563 1566 1553 1552 1537 1537 1552 1533 1533 1552 1566 785 1566 1563 785 1564 1566 1533 1566 1534 1534 1566 1564 810 1532 1533 810 1533 808 808 1533 1534 1533 1532 1537 808 1534 806 806 1534 1535 1534 1564 1535 806 807 808 808 807 809 808 809 810 804 805 806 806 805 807 806 1535 804 804 1535 1536 1535 1564 1565 1535 1565 1536 984 985 804 804 985 986 804 986 805 804 1536 984 986 1128 805 805 1128 1129 805 1129 807 985 1127 986 986 1127 1128 677 1129 1128 1127 677 1128 807 1129 1130 677 1130 1129 650 677 678 678 677 679 650 1130 677 1127 679 677 985 1126 1127 1126 679 1127 678 679 680 680 679 681 1055 681 679 1055 679 1126 1055 1126 985 1055 985 1056 1056 681 1055 680 681 682 682 681 657 1056 657 681 1056 985 1033 1056 1033 1057 1057 657 1056 984 983 985 985 983 1033 1031 1032 1033 1057 1033 1032 1033 983 1027 1033 1027 1031 1032 1063 1057 1063 657 1057 1032 1062 1063 1062 687 1063 1063 687 657 1061 1062 1032 687 1062 685 685 1062 1061 685 686 687 687 686 688 687 688 657 685 1061 1637 1670 685 1637 685 2219 686 685 1670 2219 2218 688 686 686 2219 2220 686 2220 2218 2176 2218 2177 2177 2218 2220 2177 2220 2178 2178 2220 2219 1720 2176 2177 1720 2177 1718 1718 2177 2178 1722 2176 1720 1718 2178 1716 1716 2178 2179 2178 2219 2179 1716 1717 1718 1714 1715 1716 1716 1715 1717 1716 2179 1714 1714 2179 2180 2179 2219 2221 2179 2221 2180 1714 1713 1715 1713 2007 1715 1715 2007 2008 1715 2008 1717 2008 2021 1717 2151 2021 2008 2151 2008 2152 2152 2008 2007 1713 2011 2007 2152 2007 2153 2153 2007 2011 2057 2151 2152 2057 2152 2055 2055 2152 2153 2058 2151 2057 2055 1815 2057 1815 1813 2057 2057 1813 1812 2057 1812 2058 1812 1810 2058 2058 1810 1809 1810 1812 1811 1811 1812 1813 1811 1813 1814 1813 1815 1814 1814 1815 1816 2055 1816 1815 1814 1816 1817 1817 1925 1814 1814 1925 1926 1814 1926 1811 1808 1810 1811 1811 1926 1927 1811 1927 1808 1808 1809 1810 1926 1979 1927 1927 1979 1980 1925 1978 1926 1926 1978 1979 1978 1423 1979 1979 1423 1448 1979 1448 1980 1925 1977 1978 1977 1421 1978 1978 1421 1423 1423 1421 1424 1423 1367 1448 1423 1424 1367 1448 1367 1366 1366 1367 1368 1367 1424 1480 1367 1480 1368 1421 1422 1424 1424 1422 1481 1424 1481 1480 1421 1419 1422 1977 1419 1421 1419 1420 1422 1422 1420 1482 1422 1482 1481 1481 1090 1088 1480 1481 1088 1481 1482 1092 1481 1092 1090 1482 1094 1092 1420 1483 1482 1482 1483 1095 1482 1095 1094 1091 1090 1092 1091 1092 1093 1092 1094 1093 1089 1088 1090 1089 1090 1091 1509 1089 1091 1509 1091 1508 1508 1091 1093 1093 1094 1095 1093 1095 1096 1508 1093 1096 1096 1095 1097 1483 1097 1095 1096 1097 1098 1098 1508 1096 1098 1507 1508 1507 1669 1508 1508 1669 1671 1508 1671 1509 1087 1089 1509 1087 1509 1083 1083 1086 1087 1087 1086 1088 1087 1088 1089 1084 1085 1083 1083 1085 1086 1480 1086 1085 1480 1088 1086 1368 1480 1085 1368 1085 1084 2224 1671 2225 2225 1671 1669 2183 2224 2225 2225 1669 2226 2183 2225 2184 2184 2225 2226 1640 692 1669 1507 1640 1669 2226 1669 692 2226 692 2191 692 1640 1103 2191 692 659 1103 1640 1641 1506 1641 1640 1506 1640 1507 1100 1506 1507 1100 1507 1098 1098 1099 1100 1100 1099 1101 1100 1101 1102 1102 1506 1100 1098 1097 1099 1484 1101 1099 1483 1484 1099 1483 1099 1097 1112 1102 1101 1484 1112 1101 1111 1110 1102 1111 1102 1112 1102 1110 1506 1485 1111 1112 1484 1485 1112 1418 1416 1484 1418 1484 1483 1416 1485 1484 1420 1418 1483 1417 1415 1418 1417 1418 1420 1415 1416 1418 1415 1413 1416 1413 1414 1416 1416 1414 1485 1974 1413 1415 1974 1415 1975 1975 1415 1417 1419 1417 1420 1975 1417 1976 1976 1417 1419 1922 1974 1975 1922 1975 1923 1923 1975 1976 1921 1973 1974 1921 1974 1922 1973 1413 1974 1825 1921 1922 1825 1922 1822 1822 1922 1923 1822 1923 1819 1819 1923 1924 1923 1976 1924 1819 1821 1822 1821 1823 1822 1822 1823 1824 1822 1824 1825 1819 1820 1821 2103 1823 1821 2103 1821 2056 2056 1821 1820 1824 1823 2103 1824 1826 1825 1824 2103 2104 2104 1826 1824 2056 2154 2103 2055 2056 1818 2056 1820 1818 2055 2153 2056 2056 2153 2154 1818 1820 1819 1817 1816 1818 1817 1818 1819 1818 1816 2055 1819 1924 1817 1817 1924 1925 1924 1976 1977 1924 1977 1925 1976 1419 1977 2153 2011 2154 1825 1826 1827 2104 1827 1826 1825 1827 1828 1828 1921 1825 1827 1829 1828 2101 1829 1827 2101 1827 2104 1828 1829 1830 1828 1830 1831 1831 1920 1828 1828 1920 1921 1920 1973 1921 1831 1919 1920 1919 1972 1920 1920 1972 1973 1972 1411 1973 1973 1411 1413 1919 1971 1972 1971 1409 1972 1972 1409 1411 1834 1918 1919 1834 1919 1831 1918 1971 1919 1918 1970 1971 1970 1407 1971 1971 1407 1409 1409 1407 1410 1411 1409 1412 1409 1410 1412 1407 1405 1408 1407 1408 1410 1970 1405 1407 1917 1969 1970 1917 1970 1918 1969 1405 1970 1405 1403 1406 1405 1406 1408 1969 1403 1405 1410 1408 1488 1408 1406 1489 1408 1489 1488 1403 1404 1406 1406 1404 1490 1406 1490 1489 1403 1401 1404 1968 1401 1403 1968 1403 1969 1401 1402 1404 1404 1402 1491 1404 1491 1490 1401 1399 1402 1967 1399 1401 1967 1401 1968 1915 1967 1968 1915 1968 1916 1916 1968 1969 1914 1966 1967 1914 1967 1915 1966 1399 1967 1846 1914 1915 1846 1915 1843 1843 1915 1916 1843 1916 1840 1840 1916 1917 1916 1969 1917 1840 1842 1843 1842 1844 1843 1843 1844 1845 1843 1845 1846 1840 1841 1842 1844 1842 2098 2098 1842 1841 2097 1845 1844 2097 1844 2098 1845 1847 1846 1847 1845 2097 2096 1847 2097 2098 2111 2097 2097 2111 2112 2097 2112 2096 2098 1841 2099 2099 2110 2098 2098 2110 2111 2110 2039 2111 2111 2039 2038 2111 2038 2112 2096 2112 2113 2112 2038 2037 2112 2037 2113 1701 2037 2038 2013 2037 1701 2113 2037 2013 2096 2113 2095 2095 2113 2114 2113 2013 2114 1699 2012 2013 1699 2013 1701 2114 2013 2012 2095 2114 2094 2094 2114 2115 2114 2012 2115 1697 2012 1699 1697 2049 2012 2115 2012 2049 2094 2115 2093 2093 2115 2116 2115 2049 2116 1697 2048 2049 2116 2049 2048 1696 1695 1697 1695 2048 1697 1695 2047 2048 2116 2048 2117 2117 2048 2047 2093 2116 2092 2092 2116 2117 2092 2117 2091 2091 2117 2118 2117 2047 2118 1693 2046 2047 1693 2047 1695 2118 2047 2046 1694 1693 1695 1694 1695 1696 1692 1691 1693 1692 1693 1694 1691 2046 1693 1691 2045 2046 2118 2046 2119 2119 2046 2045 2091 2118 2090 2090 2118 2119 2090 2119 2089 2089 2119 2120 2119 2045 2120 2029 2045 1691 2120 2045 2029 2089 2120 2087 2087 2120 2121 2120 2029 2121 1689 2028 2029 1689 2029 1691 2121 2029 2028 2087 2121 2088 2088 2121 2122 2121 2028 2122 1687 2028 1689 1687 2044 2028 2122 2028 2044 1688 1687 1689 1688 1689 1690 1690 1689 1691 1686 1687 1688 1690 2157 1688 1688 2157 2158 1688 2158 1686 1690 1691 1692 1692 2156 1690 1690 2156 2157 2156 2198 2157 2157 2198 2199 2157 2199 2158 1686 2158 2159 2158 2199 2200 2158 2200 2159 2198 1659 2199 2199 1659 1658 2199 1658 2200 2197 1660 2198 2198 1660 1659 2156 2197 2198 1527 1658 1659 1527 1659 1528 1528 1659 1660 1526 1657 1658 1526 1658 1527 2200 1658 1657 1525 1655 1657 1525 1657 1526 2200 1657 2201 2201 1657 1655 1275 1524 1525 1275 1525 1273 1273 1525 1526 1524 1655 1525 1273 1274 1275 1275 1274 1276 1275 1276 1277 1277 1524 1275 1271 1272 1273 1273 1272 1274 1273 1526 1271 1500 1276 1274 1499 1500 1274 1499 1274 1272 1276 1278 1277 1500 1278 1276 1386 1384 1500 1386 1500 1499 1384 1501 1500 1500 1501 1278 1277 1278 1279 1501 1279 1278 1384 1382 1501 1382 1502 1501 1501 1502 1281 1501 1281 1279 1383 1381 1384 1383 1384 1386 1381 1382 1384 1381 1379 1382 1379 1380 1382 1382 1380 1502 1957 1379 1381 1957 1381 1958 1958 1381 1383 1385 1383 1386 1958 1383 1959 1959 1383 1385 1905 1957 1958 1905 1958 1906 1906 1958 1959 1906 1959 1907 1907 1959 1960 1959 1385 1960 1872 1905 1906 1872 1906 1870 1870 1906 1907 1875 1904 1905 1875 1905 1872 1904 1957 1905 1878 1903 1904 1878 1904 1875 1903 1956 1904 1904 1956 1957 1956 1379 1957 1903 1955 1956 1955 1377 1956 1956 1377 1379 1881 1902 1903 1881 1903 1878 1902 1955 1903 1902 1954 1955 1954 1375 1955 1955 1375 1377 1377 1375 1378 1379 1377 1380 1377 1378 1380 1375 1372 1376 1375 1376 1378 1954 1372 1375 1901 1953 1954 1901 1954 1902 1953 1372 1954 1372 1373 1374 1372 1374 1376 1953 1373 1372 1378 1376 1504 1376 1374 1457 1376 1457 1504 1374 1373 1450 1457 1374 1458 1458 1374 1450 1447 1450 1373 1952 1373 1953 1952 1447 1373 1458 1450 1459 1369 1459 1450 1369 1450 1447 1459 1323 1458 1458 1323 1035 1458 1035 1457 1371 1321 1459 1371 1459 1369 1321 1322 1459 1459 1322 1323 1369 1370 1371 1446 1370 1369 1446 1369 1447 1444 1370 1446 1444 1445 1370 1370 1445 1365 1370 1365 1371 2003 1444 1446 2003 1446 2004 2004 1446 1447 1444 1442 1445 2002 1442 1444 2002 1444 2003 1950 2002 2003 1950 2003 1951 1951 2003 2004 1951 2004 1899 1899 2004 1952 2004 1447 1952 1896 1950 1951 1896 1951 1893 1893 1951 1899 1745 1949 1950 1745 1950 1896 1949 2002 1950 1893 1895 1896 1896 1895 1897 1896 1897 1745 1744 1745 1746 1745 1897 1898 1745 1898 1746 1744 1949 1745 1744 1948 1949 1948 2001 1949 1949 2001 2002 1749 1947 1948 1749 1948 1744 1947 2000 1948 1948 2000 2001 2000 1440 2001 2001 1440 1442 2001 1442 2002 1947 1999 2000 1999 1438 2000 2000 1438 1440 1752 1946 1947 1752 1947 1749 1946 1999 1947 1946 1998 1999 1998 1436 1999 1999 1436 1438 1438 1436 1439 1440 1438 1441 1438 1439 1441 1436 1434 1437 1436 1437 1439 1998 1434 1436 1945 1997 1998 1945 1998 1946 1997 1434 1998 1758 1944 1945 1758 1945 1755 1755 1945 1946 1944 1997 1945 1944 1996 1997 1761 1943 1944 1761 1944 1758 1943 1996 1944 1758 1760 1761 1760 1762 1761 1761 1762 1763 1761 1763 1764 1764 1943 1761 1764 1942 1943 1763 1765 1764 1764 1765 1766 1764 1766 1767 1767 1942 1764 1765 1763 2073 2073 1763 1762 2073 1762 2074 1762 1760 2074 2071 1765 2073 2074 2135 2073 2071 1766 1765 1767 1766 1768 1768 1766 2071 1767 1768 1769 1768 1770 1769 1768 2071 2072 2072 1770 1768 1769 1770 1771 1769 1771 1772 2072 1771 1770 2069 1771 2072 1771 1773 1772 2069 1773 1771 1772 1773 1774 1772 1774 1775 1774 1773 2069 1774 2069 2070 1774 1776 1775 2070 1776 1774 1775 1776 1777 1775 1777 1778 1778 1938 1775 2070 1777 1776 2067 1777 2070 1777 1779 1778 2067 1779 1777 2074 2134 2135 2134 2030 2135 2074 1760 1759 2074 1759 2075 2075 2134 2074 2075 2133 2134 2133 2031 2134 2134 2031 2030 1739 2030 2031 1739 2031 1741 1741 2031 2032 2133 2032 2031 2076 2132 2133 2076 2133 2075 2132 2032 2133 1741 2032 1743 1743 2032 2033 2132 2033 2032 1740 1739 1741 1740 1741 1742 1742 1741 1743 1738 1739 1740 1742 2165 1740 1740 2165 2166 1740 2166 1738 1742 1743 1676 1676 2164 1742 1742 2164 2165 2164 2206 2165 2165 2206 2208 2165 2208 2166 1738 2166 2167 2166 2208 2207 2166 2207 2167 666 2207 2208 666 2208 2206 2205 668 2206 2206 668 666 2164 2205 2206 1676 2163 2164 2163 2205 2164 2204 670 2205 2205 670 668 2163 2204 2205 667 666 668 667 668 669 669 668 670 665 666 667 665 2207 666 1149 667 1150 1150 667 669 667 1149 665 669 670 671 1150 669 1143 1143 669 1144 671 1144 669 1141 1149 1150 1141 1150 1143 1148 1149 1141 665 1149 1148 1140 1141 1142 1142 1141 1143 1152 1148 1141 1152 1141 1321 1321 1141 1140 1142 1143 1144 1338 1140 1142 1338 1142 964 964 1142 1144 1338 1339 1036 1036 1140 1338 964 963 1338 1338 963 959 1338 959 1339 959 963 960 960 963 964 959 960 961 1339 959 961 961 960 958 960 964 939 939 1004 960 960 1004 1005 960 1005 958 961 958 962 1339 961 962 962 958 957 1345 1339 962 1345 962 957 955 956 957 955 957 958 1345 957 956 1293 1337 1345 1293 1345 1295 1295 1345 956 1337 1339 1345 1337 1036 1339 1335 1336 1337 1337 1336 1034 1335 1337 1293 1034 1036 1337 1034 1035 1036 1035 1323 1036 1036 1323 1140 1457 1035 1034 1457 1034 1336 1504 1457 1336 1504 1336 1335 1335 1293 1290 1504 1335 1290 1378 1504 1503 1503 1504 1290 1380 1378 1503 1503 1288 1285 1380 1503 1502 1502 1503 1285 1503 1290 1288 1287 1285 1288 1287 1288 1289 1289 1288 1290 1283 1284 1285 1283 1285 1286 1286 1285 1287 1502 1285 1284 1502 1284 1281 1281 1284 1283 1282 1281 1283 1283 1523 1282 1286 1523 1283 1287 1648 1286 1286 1648 1523 1289 1648 1287 1289 1647 1648 1648 1647 1523 1282 1523 1524 1523 1647 1646 1523 1646 1524 1280 1281 1282 1282 1524 1280 1280 1279 1281 1277 1279 1280 1280 1524 1277 1524 1646 1655 698 1646 1291 1291 1646 1647 1646 698 1655 1291 1647 1289 1289 1290 1291 1290 1292 1291 1292 698 1291 1290 1293 1292 1292 1293 1294 1294 696 1292 696 698 1292 1294 1293 1295 1294 1295 1296 1296 694 1294 1294 694 696 694 695 696 696 695 697 696 697 698 694 670 695 2203 697 695 2203 695 2204 2204 695 670 698 697 2203 2202 1655 698 2202 698 2203 2161 2202 2203 2161 2203 2162 2162 2203 2204 2162 2204 2163 1680 2161 2162 1680 2162 1678 1678 2162 2163 1682 2160 2161 1682 2161 1680 2160 2202 2161 1678 1679 1680 1680 1679 1681 1680 1681 1682 1676 1677 1678 1678 1677 1679 1678 2163 1676 1679 2014 1681 1677 2017 1679 1679 2017 2018 1679 2018 2014 1682 1681 1683 1681 2014 2015 1681 2015 1683 2127 2015 2014 2127 2014 2128 2128 2014 2018 2128 2018 2129 2129 2018 2017 2081 2127 2128 2081 2128 2080 2080 2128 2129 2082 2126 2127 2082 2127 2081 2126 2015 2127 2015 2041 1683 2126 2041 2015 2084 2125 2126 2084 2126 2082 2125 2041 2126 1683 2041 2042 2125 2042 2041 2083 2124 2125 2083 2125 2084 2124 2042 2125 1683 2042 1685 1685 2042 2043 2124 2043 2042 2086 2123 2124 2086 2124 2083 2123 2043 2124 1685 2043 1687 1687 2043 2044 2123 2044 2043 1684 1683 1685 1684 1685 1686 1686 1685 1687 1682 1683 1684 1686 2159 1684 1684 2159 2160 1684 2160 1682 2159 2200 2201 2159 2201 2160 2160 2201 2202 2201 1655 2202 2122 2044 2123 2088 2122 2085 2085 2122 2123 2085 2123 2086 1880 2085 2086 1880 1879 2085 2085 1879 1877 2085 1877 2088 1874 2087 2088 2088 1877 1876 2088 1876 1874 1875 1876 1877 1875 1877 1878 1877 1879 1878 1878 1879 1880 1878 1880 1881 1880 1882 1881 1881 1882 1883 1881 1883 1884 1884 1902 1881 2086 1883 1882 2086 1882 1880 1883 1885 1884 2083 1885 1883 2083 1883 2086 1884 1885 1886 1886 1885 2083 1886 2083 2084 1884 1886 1887 1886 1888 1887 2084 1888 1886 2082 1889 2084 2084 1889 1888 1887 1888 1889 1887 1889 1890 1890 1900 1887 1887 1900 1901 1887 1901 1884 1889 1891 1890 2082 1891 1889 1890 1891 1892 1892 1891 2082 2081 1894 2082 2082 1894 1892 1890 1892 1893 1892 1894 1893 1893 1894 1895 2081 1895 1894 2080 1897 2081 1897 1895 2081 2079 1898 2080 2080 1898 1897 2080 2129 2079 2079 1746 1898 2078 1747 2079 1747 1746 2079 2079 2129 2130 2079 2130 2078 2129 2017 2130 2078 2130 2131 2130 2017 2016 2130 2016 2131 1677 2016 2017 1743 2016 1677 1743 2033 2016 2131 2016 2033 2078 2131 2077 2077 2131 2132 2131 2033 2132 2076 1753 2077 1753 1751 2077 2077 1751 1750 2077 1750 2078 2077 2132 2076 2075 1756 2076 1756 1754 2076 2076 1754 1753 1751 1753 1752 1752 1753 1754 1749 1750 1751 1749 1751 1752 1748 1750 1749 1750 1748 2078 2078 1748 1747 1744 1747 1748 1744 1748 1749 1746 1747 1744 1752 1754 1755 1755 1946 1752 1754 1756 1755 1755 1756 1757 1755 1757 1758 1757 1759 1758 1759 1757 2075 2075 1757 1756 1758 1759 1760 1676 1743 1677 1893 1899 1890 1890 1899 1900 1899 1952 1900 1900 1952 1953 1900 1953 1901 1884 1901 1902 1872 1874 1875 1874 1876 1875 1870 1871 1872 1871 1873 1872 1872 1873 1874 1874 1873 2087 2087 1873 1871 1870 1869 1871 2087 1871 2089 1871 1869 2089 1867 1869 1870 1870 1907 1867 1867 1868 1869 2089 1869 1868 2089 1868 2090 1866 1868 1867 1868 1866 2090 1864 1866 1867 1867 1907 1908 1867 1908 1864 1907 1960 1908 1864 1908 1909 1908 1960 1961 1908 1961 1909 1960 1385 1387 1960 1387 1961 1909 1961 1962 1961 1387 1389 1961 1389 1962 1864 1909 1861 1861 1909 1910 1909 1962 1910 1910 1962 1963 1962 1389 1391 1962 1391 1963 1389 1387 1390 1391 1389 1392 1389 1390 1392 1393 1391 1394 1391 1392 1394 1963 1391 1393 1910 1963 1911 1911 1963 1964 1963 1393 1964 1395 1393 1396 1393 1394 1396 1964 1393 1395 1396 1394 1495 1394 1392 1496 1394 1496 1495 1395 1396 1398 1398 1396 1494 1396 1495 1494 1397 1395 1398 1964 1395 1965 1965 1395 1397 1397 1398 1400 1400 1398 1493 1398 1494 1493 1399 1397 1400 1965 1397 1966 1966 1397 1399 1912 1964 1965 1912 1965 1913 1913 1965 1966 1913 1966 1914 1852 1912 1913 1852 1913 1849 1849 1913 1914 1855 1911 1912 1855 1912 1852 1911 1964 1912 1849 1851 1852 1851 1853 1852 1852 1853 1854 1852 1854 1855 1849 1850 1851 1853 1851 2095 2095 1851 1850 2094 1854 1853 2094 1853 2095 1854 1856 1855 1856 1854 2094 2093 1856 2094 1855 1856 1857 2093 1857 1856 2092 1859 2093 1859 1857 2093 1855 1857 1858 1857 1859 1858 1858 1859 1860 2092 1860 1859 2091 1862 2092 1862 1860 2092 1858 1860 1861 1860 1862 1861 1861 1910 1858 1858 1910 1911 1858 1911 1855 1861 1862 1863 1861 1863 1864 2091 1863 1862 2090 1865 2091 1865 1863 2091 1863 1865 1864 1864 1865 1866 2090 1866 1865 2095 1850 2096 1848 1850 1849 1850 1848 2096 2096 1848 1847 1846 1847 1848 1846 1848 1849 1849 1914 1846 1399 1400 1402 1402 1400 1492 1400 1493 1492 1402 1492 1491 1492 1246 1245 1491 1492 1245 1492 1493 1248 1492 1248 1246 1493 1250 1248 1493 1494 1252 1493 1252 1250 1247 1246 1248 1247 1248 1249 1249 1248 1250 1238 1245 1246 1238 1246 1247 1240 1245 1238 1491 1245 1240 1238 1239 1240 1530 1239 1238 1530 1238 1531 1238 1247 1531 1531 1247 1249 1249 1250 1251 1531 1249 1529 1529 1249 1251 1529 1661 1531 1531 1661 1656 1531 1656 1530 1645 1239 1530 1530 1656 1643 1530 1643 1645 2195 1656 1661 1529 1660 1661 2195 1661 2197 2197 1661 1660 2190 2195 2155 2155 2195 2197 2155 2197 2156 1694 2155 1692 1692 2155 2156 1694 2190 2155 1528 1660 1529 1260 1527 1528 1260 1528 1258 1258 1528 1255 1255 1528 1529 1255 1529 1253 1529 1251 1253 1253 1254 1255 1254 1256 1255 1255 1256 1257 1255 1257 1258 1258 1257 1259 1258 1259 1260 1495 1257 1256 1495 1259 1257 1494 1495 1256 1494 1256 1254 1253 1252 1254 1494 1254 1252 1251 1252 1253 1251 1250 1252 1495 1496 1259 1260 1259 1261 1496 1261 1259 1392 1497 1496 1496 1497 1263 1496 1263 1261 1260 1261 1262 1262 1261 1263 1262 1527 1260 1262 1263 1264 1262 1264 1527 1264 1263 1265 1497 1265 1263 1264 1265 1266 1527 1264 1266 1527 1266 1526 1265 1267 1266 1266 1267 1268 1266 1268 1269 1526 1266 1269 1497 1267 1265 1498 1268 1267 1497 1498 1267 1269 1268 1270 1498 1270 1268 1269 1270 1271 1526 1269 1271 1271 1270 1272 1499 1272 1270 1498 1499 1270 1390 1388 1498 1390 1498 1497 1388 1499 1498 1388 1386 1499 1387 1385 1388 1387 1388 1390 1385 1386 1388 1392 1390 1497 1644 1241 1645 1645 1241 1239 1645 1643 1644 1643 1243 1644 1644 1243 1241 1240 1239 1241 1240 1241 1242 1242 1241 1243 1243 1244 1242 1643 1244 1243 1242 1244 1051 1242 1051 1332 1491 1240 1242 1490 1491 1242 1490 1242 1332 1332 1051 1333 1051 1231 1333 1332 1333 1334 1490 1332 1334 1489 1490 1334 1334 1333 1331 1489 1334 1331 1333 1231 1344 1331 1333 1029 1029 1333 1344 1000 1344 1231 1000 1231 870 1344 999 998 1029 1344 1030 1030 1344 998 999 1344 1000 867 999 1000 867 1000 870 997 998 999 997 999 867 996 998 997 1030 998 996 1028 1029 1030 996 995 1030 1030 995 1026 1030 1026 1028 994 995 996 994 996 997 1022 994 997 1022 997 1023 1023 997 867 1021 994 1022 1022 1023 732 1022 732 1021 1023 867 1024 1023 1024 732 647 732 733 647 736 732 732 1024 864 732 864 733 1021 732 736 1020 994 1021 1021 736 1020 647 735 736 735 1018 736 736 1018 1019 736 1019 1020 1019 991 1020 1020 991 994 1018 776 1019 1019 776 991 1017 774 1018 1018 774 776 735 1017 1018 1015 1016 1017 1017 1016 774 735 1015 1017 774 775 776 774 1550 775 1550 774 1562 1562 774 1016 1015 1014 1016 1562 1016 1561 1561 1016 1014 1561 1547 1562 1547 1548 1562 1562 1548 1549 1562 1549 1550 775 1550 1549 776 775 777 775 1549 777 1548 772 1549 1549 772 777 1547 770 1548 1548 770 772 770 771 772 772 771 773 773 987 772 772 987 988 772 988 777 777 988 989 777 989 776 1113 1114 988 988 1114 1115 988 987 1113 1113 987 773 1113 773 1118 1118 773 771 1118 675 1113 1113 675 651 1113 651 1114 1114 651 1115 1115 651 647 652 653 647 651 735 647 652 647 699 699 647 733 652 1315 653 653 1315 1314 653 1314 1237 1236 653 1237 873 1314 1315 873 1315 875 875 1315 1316 652 1316 1315 1237 1314 873 871 1236 1237 871 1237 873 870 1235 1236 870 1236 871 868 870 871 868 871 872 872 871 873 872 873 874 874 873 875 874 1570 872 872 1570 1571 872 1571 868 867 868 869 867 870 868 868 1571 869 1599 865 1571 1571 865 1025 1571 1025 869 1570 1599 1571 1024 867 869 1024 869 864 864 869 1025 864 1025 865 864 865 743 743 865 866 1599 1600 865 1600 866 865 1570 1600 1599 1601 741 1600 1600 741 866 1569 1601 1600 1569 1600 1570 743 866 741 741 742 743 742 741 860 741 744 860 1601 744 741 733 742 737 737 742 860 733 743 742 860 744 746 860 746 861 737 860 861 744 745 746 861 746 862 745 1587 746 746 1587 1588 746 1588 862 861 862 843 861 843 737 843 862 863 862 1588 1589 862 1589 1590 1590 863 862 843 844 845 843 863 844 737 843 845 1590 844 863 1591 844 1590 1589 1574 1590 1590 1574 1575 1590 1575 1591 1588 1574 1589 1573 813 1574 1574 813 817 1574 817 1575 1588 1573 1574 1575 817 819 1575 819 1576 1591 1575 1576 813 815 817 817 815 818 817 818 819 813 814 815 1573 814 813 815 814 816 1572 1567 814 814 1567 816 1572 814 1573 878 879 816 816 879 880 816 880 815 816 1567 878 878 1567 1568 1568 1567 1572 1588 1587 1572 1572 1587 1568 1572 1573 1588 878 1568 876 876 1568 1569 1568 1587 1601 1568 1601 1569 1598 1587 744 744 1587 745 1587 1598 1601 1598 744 1601 876 1569 874 874 1569 1570 874 875 876 876 875 877 875 1316 877 876 877 878 878 877 879 877 1316 1317 877 1317 879 652 1317 1316 879 1317 1318 705 1317 652 705 1318 1317 879 1318 880 880 1318 1319 705 1319 1318 652 704 705 704 1319 705 880 1319 815 815 1319 1320 704 1320 1319 652 703 704 1313 1320 704 1313 704 1312 1312 704 703 815 1320 818 818 1320 1313 1312 821 1313 818 1313 820 820 1313 821 1311 823 1312 1312 823 821 1312 703 1311 819 820 821 819 821 822 822 821 823 818 820 819 1576 819 822 822 823 824 1576 822 1577 1577 822 824 824 823 825 1311 825 823 1310 825 1311 703 1310 1311 824 825 826 825 827 826 1310 827 825 1577 824 1578 1578 824 826 826 827 828 826 828 829 1578 826 1579 1579 826 829 1309 828 827 1309 827 1310 703 1309 1310 702 703 652 702 1309 703 1308 828 1309 702 1308 1309 829 828 830 1308 830 828 1307 830 1308 701 1307 1308 701 1308 702 652 701 702 699 700 652 652 700 701 1306 1307 701 1306 701 1305 1305 701 700 1306 832 1307 1307 832 830 829 830 831 831 830 832 831 832 833 832 834 833 1306 834 832 1305 834 1306 1304 835 1305 1305 835 834 1305 700 1304 833 834 835 833 835 836 1581 831 833 1581 833 1582 1582 833 836 1580 829 831 1580 831 1581 1579 829 1580 1586 1579 1580 1586 1580 1595 1595 1580 1581 1595 1581 1596 1596 1581 1582 1582 836 1583 1596 1582 1597 1582 1583 1597 854 1595 1596 1597 858 1596 1596 858 856 1596 856 854 854 1586 1595 853 852 854 853 854 855 855 854 856 852 1586 854 855 856 857 857 856 858 857 858 859 839 859 858 1597 839 858 712 855 857 712 857 711 711 857 859 853 855 712 851 852 853 853 712 851 851 850 852 852 850 1586 849 850 851 851 712 714 851 714 849 849 848 850 848 1593 850 850 1593 1594 850 1594 1586 1594 1579 1586 1593 1579 1594 848 1592 1593 1592 1577 1593 1577 1578 1593 1593 1578 1579 1592 1576 1577 1591 1592 844 844 1592 846 846 1592 848 1591 1576 1592 845 844 846 845 846 847 847 846 848 737 845 714 714 845 847 847 848 849 714 847 849 712 713 714 713 737 714 713 733 737 712 693 713 699 733 713 1300 699 713 1300 713 1297 1297 713 693 711 693 712 664 670 711 711 670 693 1002 1001 711 711 1001 664 711 859 1002 693 670 694 664 671 670 1296 1299 694 1298 693 694 1298 694 1299 1295 1299 1296 1295 1298 1299 1297 1298 954 954 1298 1295 1297 693 1298 1295 956 954 841 953 954 841 954 955 954 956 955 1297 954 1300 1300 954 953 842 952 953 842 953 841 1300 953 1301 1301 953 952 1301 699 1300 1301 952 1302 1301 1302 699 838 951 952 838 952 842 1302 952 951 1302 951 1303 1303 699 1302 1303 700 699 1303 951 837 1303 837 1304 1304 700 1303 837 951 838 836 835 837 836 837 838 1304 837 835 1583 836 838 1583 838 1584 1597 1583 1584 1584 838 842 840 1585 1584 840 1584 842 1597 1584 1585 1585 839 1597 839 1585 840 839 840 841 841 840 842 841 859 839 955 1002 841 841 1002 859 958 1001 955 955 1001 1002 958 1005 1006 958 1006 1001 1001 1006 664 664 1006 1005 664 1005 663 663 1005 1004 663 662 664 662 671 664 661 662 663 662 1145 671 661 1147 662 662 1147 1146 662 1146 1145 671 1145 1144 964 1145 965 965 1145 1146 964 1144 1145 965 1146 966 966 1146 1147 966 1147 1139 661 1139 1147 940 965 966 940 966 942 942 966 967 1138 967 966 1138 966 1139 939 964 965 939 965 940 939 940 941 942 1606 940 940 1606 941 941 1003 939 939 1003 1004 938 937 941 941 937 1003 938 941 1606 937 663 1003 663 1004 1003 936 935 937 936 937 938 935 716 937 937 716 663 938 1606 936 934 935 936 934 936 1634 936 1606 1635 936 1635 1634 934 933 935 935 933 716 926 933 934 934 1634 926 926 1634 1636 1604 1636 1634 1604 1634 1605 1605 1634 1635 1605 1635 1606 944 1604 1605 944 1605 942 942 1605 1606 946 1603 1604 946 1604 944 1603 1636 1604 942 943 944 944 943 945 944 945 946 942 967 943 1137 945 943 1137 943 967 946 945 947 1230 947 945 1230 945 1137 946 947 948 948 1603 946 948 947 949 1229 949 947 1229 947 1230 1137 715 1230 715 1229 1230 1228 949 1229 715 1228 1229 948 949 889 889 949 950 1228 950 949 889 1602 948 948 1602 1603 887 888 889 889 950 887 888 1602 889 1227 887 950 1227 950 1228 717 1227 1228 717 1228 715 1226 887 1227 721 1226 1227 721 1227 717 885 886 887 887 886 888 1226 885 887 1225 885 1226 1225 1226 721 883 884 885 885 884 886 1225 883 885 1608 888 886 1608 886 1609 1609 886 884 883 882 884 1609 884 1610 1610 884 882 881 882 883 1224 881 883 1224 883 1225 1225 721 1224 1223 881 1224 1224 721 723 1224 723 1223 740 739 881 881 739 882 1223 740 881 1222 740 1223 1223 723 1222 721 722 723 723 722 724 723 724 725 1222 723 725 717 716 721 721 716 722 715 716 717 715 663 716 716 933 932 716 932 722 661 663 715 1137 661 715 1138 661 1137 1138 1139 661 1137 967 1138 922 724 722 922 722 924 722 932 928 722 928 924 923 922 924 923 924 925 925 924 929 929 924 928 926 927 928 929 928 930 930 928 927 928 932 926 926 932 933 1633 927 926 926 1636 1633 930 927 931 1633 1622 927 927 1622 931 1622 1633 1636 1603 1622 1636 931 1622 930 930 1622 1623 1623 1622 1607 1607 1622 1603 930 1623 929 1623 1624 929 1607 1608 1623 1623 1608 1609 1623 1609 1624 1607 1602 888 1607 888 1608 1603 1602 1607 929 1624 1625 1624 1609 1610 1624 1610 1625 929 1625 925 925 1625 923 923 1625 1626 1625 1610 1611 1625 1611 1626 1610 882 1611 1611 882 739 1611 739 1612 1626 1611 1627 1627 1611 1612 923 1626 921 921 1626 1627 921 922 923 919 920 921 921 920 922 921 1627 919 919 1627 1628 1627 1612 1628 917 918 919 919 918 920 919 1628 917 920 918 724 920 724 922 917 915 918 724 918 915 916 915 917 916 917 1621 917 1628 1629 917 1629 1621 914 913 915 914 915 916 724 915 727 727 915 913 725 724 726 726 724 727 1222 725 1221 726 1219 725 725 1219 1220 725 1220 1221 1221 890 1222 1222 890 740 1220 891 1221 1221 891 890 1219 893 1220 1220 893 891 738 890 891 738 891 892 892 891 893 740 890 738 738 739 740 1612 739 738 1612 738 1613 1613 738 892 892 893 894 1613 892 1614 1614 892 894 894 893 895 1219 895 893 894 895 896 1614 894 1615 1615 894 896 1628 1613 1614 1628 1614 1629 1629 1614 1615 1612 1613 1628 1615 896 1616 1629 1615 1621 1621 1615 1616 1616 896 899 1616 899 1617 1621 1616 1630 1630 1616 1631 1631 1616 1617 916 1621 914 914 1621 1630 914 1630 1631 1632 910 1631 1631 910 912 1631 912 914 1631 1617 1632 912 913 914 910 911 912 912 911 913 908 909 910 910 909 911 910 904 908 1632 904 910 911 909 727 727 913 911 727 909 908 908 904 906 908 906 1007 727 908 730 730 908 1007 904 905 906 904 1620 905 1620 904 1632 906 905 907 905 1620 1619 905 1619 907 1632 1619 1620 1617 1618 1632 1632 1618 1619 1618 903 1619 1619 903 907 971 906 907 971 907 972 972 907 903 901 902 903 972 903 973 973 903 902 1618 901 903 1617 901 1618 1617 899 901 899 900 901 901 900 902 1215 973 902 1215 902 1216 1216 902 900 1209 972 973 1209 973 1215 971 972 1209 1209 1210 971 1210 1209 729 729 1209 1215 729 1215 728 728 1215 1216 1216 900 1217 728 1216 1217 899 898 900 1217 900 898 896 898 899 896 897 898 1217 898 1218 1218 898 897 728 1217 726 726 1217 1218 726 727 728 728 727 729 726 1218 1219 1218 897 1219 895 897 896 897 895 1219 729 727 730 729 730 678 1210 729 1211 1211 729 678 730 1007 1010 1007 906 969 969 1010 1007 970 969 906 970 906 971 968 969 970 968 974 969 1207 1341 968 1207 968 970 1341 974 968 1205 1341 1207 1206 1205 1207 1046 1205 1192 1206 1207 1208 1208 682 1206 1207 1214 1208 1208 1214 682 1213 680 682 1213 682 1214 1207 1213 1214 970 1212 1213 970 1213 1207 1212 680 1213 1212 678 680 1211 1212 970 1211 678 1212 971 1211 970 971 1210 1211 650 678 651 651 678 719 649 650 651 649 1131 650 650 1131 1130 809 1130 1131 809 1131 811 811 1131 1132 649 1132 1131 807 1130 809 810 809 811 810 811 754 754 811 812 811 1132 812 812 1132 1133 1133 1132 649 754 812 752 812 1133 752 752 753 754 754 1532 810 753 1532 754 750 751 752 752 751 753 752 1133 1134 752 1134 750 1133 649 1134 750 1134 1135 1134 649 676 1134 676 1135 749 748 750 750 748 751 750 1135 749 749 1135 1136 1135 676 1136 651 673 676 651 676 649 1136 676 673 749 1136 755 755 1136 1125 1136 673 1125 747 748 749 749 755 747 747 755 756 755 1125 756 1124 758 1125 756 1125 758 1125 673 1124 747 756 757 757 756 758 1540 748 747 1540 747 1541 1541 747 757 757 758 759 1541 757 1542 1542 757 759 759 758 760 1124 760 758 759 760 761 1542 759 1543 1543 759 761 1557 1541 1542 1557 1542 1558 1542 1543 1558 1543 761 1544 1558 1543 1544 761 760 762 761 762 763 1544 761 763 762 760 1124 763 762 764 1123 764 762 1123 762 1124 763 764 765 1544 763 1545 1545 763 765 764 766 765 1122 766 764 1122 764 1123 1124 672 1123 672 1122 1123 1124 673 672 672 673 674 674 1121 672 672 1121 1122 1121 766 1122 765 766 767 1121 767 766 1120 767 1121 674 1120 1121 674 673 675 675 1120 674 675 673 651 1118 1119 675 675 1119 1120 1119 769 1120 1120 769 767 765 767 768 768 767 769 768 769 770 770 769 771 1119 771 769 1118 771 1119 1547 768 770 1546 765 768 1546 768 1547 1545 765 1546 1560 1545 1546 1560 1546 1561 1561 1546 1547 1551 1544 1545 1551 1545 1560 1012 1551 1560 1012 1560 1561 1561 1014 1012 781 1011 1012 781 1012 1013 1013 1012 1014 1011 1551 1012 1013 1014 1015 781 1013 734 734 1013 1015 780 779 781 779 1011 781 734 780 781 1011 779 1551 778 779 780 778 1558 779 779 1558 1559 779 1559 1551 778 780 786 786 780 787 734 787 780 786 1557 778 778 1557 1558 1558 1544 1559 1559 1544 1551 1556 1557 788 788 1557 786 1556 1541 1557 786 787 788 788 787 789 720 789 787 720 787 734 788 789 790 1556 788 1555 1555 788 790 1555 1541 1556 1555 1540 1541 792 1554 1555 1555 790 792 1554 1540 1555 790 789 791 790 791 792 791 789 720 792 791 783 791 720 783 792 1553 1554 1553 1539 1554 1554 1539 1540 1539 748 1540 1538 751 1539 1539 751 748 1553 1538 1539 1537 1538 1553 1537 753 1538 1538 753 751 1537 1532 753 783 720 719 651 719 720 720 734 651 651 734 735 734 1015 735 1456 1355 1192 1192 1355 1046 733 864 743 776 989 990 776 990 991 989 1343 990 990 992 991 990 1343 992 991 992 993 991 993 994 993 992 1026 1026 992 1343 1026 1343 1039 1039 1343 1107 995 993 1026 1028 1026 1039 993 995 994 1037 1038 1039 1039 1107 1037 1028 1039 1327 1327 1039 1038 1037 1107 1105 1486 1037 1105 1486 1038 1037 1487 1327 1038 1486 1487 1038 1327 1328 1028 1487 1328 1327 1028 1328 1329 1028 1329 1029 1488 1329 1328 1487 1488 1328 1412 1410 1487 1412 1487 1486 1410 1488 1487 1488 1489 1330 1488 1330 1329 1029 1329 1330 1029 1330 1331 1489 1331 1330 1414 1412 1486 1414 1486 1485 1485 1486 1105 1411 1412 1414 1413 1411 1414 1103 1104 1105 1104 1109 1105 1105 1109 1110 1105 1110 1111 1485 1105 1111 1103 1641 1104 1104 1641 1642 1104 1642 1109 1109 1642 1506 1109 1506 1110 1642 1641 1506 1321 1140 1322 1322 1140 1323 1152 1321 1371 1151 1152 1153 1153 1152 1154 1151 1148 1152 1371 1154 1152 1371 1365 1154 1153 1154 1155 1155 1154 1156 1156 1154 1365 1653 1151 1153 1653 1153 1654 1654 1153 1155 1155 1156 1157 1654 1155 1522 1522 1155 1157 1157 1156 1158 1365 1158 1156 1445 1364 1365 1365 1364 1158 1157 1158 1159 1159 1158 1160 1160 1158 1364 1522 1157 1521 1521 1157 1159 1159 1160 1161 1521 1159 1161 1161 1160 1162 1160 1163 1162 1364 1163 1160 1162 1521 1161 1162 1519 1521 1519 1668 1521 1521 1668 1662 1521 1662 1522 1162 1163 1164 1162 1164 1165 1165 1519 1162 1164 1163 1363 1364 1363 1163 1165 1164 1166 1363 1166 1164 1165 1166 1167 1165 1167 1519 1166 1168 1167 1168 1166 1362 1363 1362 1166 1443 1441 1363 1443 1363 1364 1441 1362 1363 1445 1443 1364 1442 1440 1443 1442 1443 1445 1440 1441 1443 1441 1439 1362 1439 1437 1361 1439 1361 1362 1437 1360 1361 1171 1169 1361 1362 1361 1169 1361 1360 1173 1361 1173 1171 1175 1173 1360 1360 1177 1175 1172 1171 1173 1172 1173 1174 1174 1173 1175 1170 1169 1171 1170 1171 1172 1520 1170 1172 1520 1172 1518 1518 1172 1174 1174 1175 1176 1518 1174 1176 1176 1175 1177 1519 1170 1520 1520 1667 1519 1167 1169 1170 1519 1167 1170 1519 1667 1668 2209 1668 1667 2207 1662 1668 2207 1668 2209 2167 2207 2209 665 1662 2207 1662 665 1652 1522 1662 1652 665 1148 1652 1652 1148 1151 1652 1151 1653 1522 1652 1654 1654 1652 1653 1167 1168 1169 1362 1169 1168 2099 1841 1839 1839 1838 2099 2099 1838 1836 2099 1836 2100 1839 1841 1840 1837 1838 1839 1837 1839 1840 1836 1838 1837 1834 1835 1836 1834 1836 1837 1836 1835 2100 2100 1835 1833 2100 1833 2102 1833 1835 1834 1831 1833 1834 1837 1918 1834 1840 1917 1837 1837 1917 1918 1831 1832 1833 2102 1833 1832 1830 2101 2102 2102 1832 1830 1830 1832 1831 1830 1829 2101 658 659 660 2191 659 658 660 710 658 2191 658 2192 2192 658 710 2219 1675 2221 2221 1675 1674 2219 1670 1675 1505 1674 1675 1505 1675 1512 1512 1675 1670 1511 1674 1505 1072 1075 1505 1505 1075 1511 1072 1505 1070 1070 1505 1512 1511 1075 1077 1072 1074 1075 1075 1074 1076 1075 1076 1077 1070 1071 1072 1071 1073 1072 1072 1073 1074 1068 1069 1070 1070 1069 1071 1070 1512 1068 1071 1069 1349 1349 1348 1071 1071 1348 1073 1074 1073 1348 1349 1475 1348 1350 1473 1349 1350 1349 1067 1067 1349 1069 1473 1475 1349 1068 1067 1069 1066 1067 1068 1068 1512 1066 1066 1065 1067 1067 1065 1350 1058 1350 1065 1471 1473 1350 1064 1058 1065 1064 1065 1066 1066 1512 1513 1066 1513 1064 1512 1670 1513 1639 1064 1513 1513 1670 1637 1513 1637 1639 1059 1058 1064 1639 1059 1064 1638 1059 1639 1639 1637 1638 1637 1061 1060 1637 1060 1638 1638 1060 1059 1058 1059 1060 1060 1061 1058 1058 1061 1032 1058 1032 1324 1324 1032 1031 1471 1472 1473 1472 1474 1473 1473 1474 1475 1984 1474 1472 1474 1476 1475 1983 1476 1474 1983 1474 1984 1931 1983 1984 1930 1983 1931 1799 1930 1931 1799 1931 1796 1802 1930 1799 1796 1798 1799 1798 1800 1799 1799 1800 1801 1799 1801 1802 1795 1797 1796 1796 1797 1798 1800 1798 2062 2062 1798 1797 2061 1801 1800 2061 1800 2062 1801 1803 1802 1803 1801 2061 2062 2147 2061 2061 2147 2148 2062 1797 2063 1797 1795 2063 2063 1795 1794 983 981 1027 981 980 1027 982 981 983 982 983 984 984 802 982 984 1536 802 803 802 1536 803 1536 798 798 1536 1565 797 798 1564 798 1565 1564 797 1564 785 1426 1453 1427 2227 2228 2229 2303 2302 2227 2303 2227 2229 2344 2228 2227 2344 2227 2345 2345 2227 2302 2229 2228 2230 2343 2230 2228 2343 2228 2344 2324 2343 2344 2324 2344 2323 2323 2344 2345 2323 2345 2322 2322 2345 2346 2345 2302 2346 2322 2303 2323 2323 2303 2229 2323 2229 2324 2324 2229 2231 2324 2231 2325 2342 2343 2324 2325 2342 2324 2342 2230 2343 2325 2380 2342 2380 2232 2342 2342 2232 2230 2325 2231 2233 2325 2233 2326 2326 2380 2325 2326 2379 2380 2379 2234 2380 2380 2234 2232 2231 2230 2232 2231 2232 2233 2233 2232 2234 2229 2230 2231 2233 2234 2235 2235 2234 2236 2379 2236 2234 2326 2233 2235 2326 2235 2327 2327 2379 2326 2327 2378 2379 2378 2236 2379 2235 2236 2237 2237 2236 2238 2378 2238 2236 2327 2235 2237 2327 2237 2328 2328 2378 2327 2328 2377 2378 2377 2238 2378 2237 2238 2239 2239 2238 2240 2377 2240 2238 2328 2237 2239 2328 2239 2329 2329 2377 2328 2329 2376 2377 2376 2240 2377 2239 2240 2241 2241 2240 2242 2376 2242 2240 2329 2239 2241 2329 2241 2330 2330 2376 2329 2330 2375 2376 2375 2242 2376 2241 2242 2243 2243 2242 2244 2375 2244 2242 2330 2241 2243 2330 2243 2331 2331 2375 2330 2331 2374 2375 2374 2244 2375 2243 2244 2245 2245 2244 2246 2374 2246 2244 2331 2243 2245 2331 2245 2332 2332 2374 2331 2332 2373 2374 2373 2246 2374 2245 2246 2247 2247 2246 2248 2373 2248 2246 2332 2245 2247 2332 2247 2333 2333 2373 2332 2333 2372 2373 2372 2248 2373 2247 2248 2249 2249 2248 2250 2372 2250 2248 2333 2247 2249 2333 2249 2334 2334 2372 2333 2334 2371 2372 2371 2250 2372 2249 2250 2251 2251 2250 2252 2371 2252 2250 2334 2249 2251 2334 2251 2335 2335 2371 2334 2335 2370 2371 2370 2252 2371 2251 2252 2253 2253 2252 2254 2370 2254 2252 2335 2251 2253 2335 2253 2336 2336 2370 2335 2336 2369 2370 2369 2254 2370 2253 2254 2255 2255 2254 2256 2369 2256 2254 2336 2253 2255 2336 2255 2337 2337 2369 2336 2337 2368 2369 2368 2256 2369 2255 2256 2257 2257 2256 2258 2368 2258 2256 2337 2255 2257 2337 2257 2338 2338 2368 2337 2338 2367 2368 2367 2258 2368 2257 2258 2259 2259 2258 2260 2367 2260 2258 2338 2257 2259 2338 2259 2339 2339 2367 2338 2339 2366 2367 2366 2260 2367 2259 2260 2261 2261 2260 2262 2366 2262 2260 2339 2259 2261 2339 2261 2340 2340 2366 2339 2340 2365 2366 2365 2262 2366 2261 2262 2263 2263 2262 2264 2365 2264 2262 2340 2261 2263 2340 2263 2341 2341 2365 2340 2341 2364 2365 2364 2264 2365 2263 2264 2265 2265 2264 2266 2364 2266 2264 2341 2263 2265 2341 2265 2304 2304 2364 2341 2304 2363 2364 2363 2266 2364 2265 2266 2267 2267 2266 2268 2363 2268 2266 2304 2265 2267 2304 2267 2305 2305 2363 2304 2305 2362 2363 2362 2268 2363 2267 2268 2269 2269 2268 2270 2362 2270 2268 2305 2267 2269 2269 2270 2271 2305 2269 2306 2306 2269 2271 2271 2270 2272 2361 2272 2270 2361 2270 2362 2306 2361 2362 2306 2362 2305 2306 2271 2307 2307 2361 2306 2271 2272 2273 2307 2271 2273 2273 2272 2274 2360 2274 2272 2360 2272 2361 2307 2360 2361 2307 2273 2308 2308 2360 2307 2273 2274 2275 2308 2273 2275 2275 2274 2276 2359 2276 2274 2359 2274 2360 2308 2359 2360 2308 2275 2309 2309 2359 2308 2275 2276 2277 2309 2275 2277 2277 2276 2278 2358 2278 2276 2358 2276 2359 2309 2358 2359 2309 2277 2310 2310 2358 2309 2277 2278 2279 2310 2277 2279 2279 2278 2280 2357 2280 2278 2357 2278 2358 2310 2357 2358 2310 2279 2311 2311 2357 2310 2279 2280 2281 2311 2279 2281 2281 2280 2282 2356 2282 2280 2356 2280 2357 2311 2356 2357 2311 2281 2312 2312 2356 2311 2281 2282 2283 2312 2281 2283 2283 2282 2284 2355 2284 2282 2355 2282 2356 2312 2355 2356 2312 2283 2313 2313 2355 2312 2283 2284 2285 2313 2283 2285 2285 2284 2286 2354 2286 2284 2354 2284 2355 2313 2354 2355 2313 2285 2314 2314 2354 2313 2285 2286 2287 2314 2285 2287 2287 2286 2288 2353 2288 2286 2353 2286 2354 2314 2353 2354 2314 2287 2315 2315 2353 2314 2287 2288 2289 2315 2287 2289 2289 2288 2290 2352 2290 2288 2352 2288 2353 2315 2352 2353 2315 2289 2316 2316 2352 2315 2289 2290 2291 2316 2289 2291 2291 2290 2292 2351 2292 2290 2351 2290 2352 2316 2351 2352 2316 2291 2317 2317 2351 2316 2291 2292 2293 2317 2291 2293 2293 2292 2294 2350 2294 2292 2350 2292 2351 2317 2350 2351 2317 2293 2318 2318 2350 2317 2293 2294 2295 2318 2293 2295 2295 2294 2296 2349 2296 2294 2349 2294 2350 2318 2349 2350 2318 2295 2319 2319 2349 2318 2295 2296 2297 2319 2295 2297 2297 2296 2298 2348 2298 2296 2348 2296 2349 2319 2348 2349 2319 2297 2320 2320 2348 2319 2297 2298 2299 2320 2297 2299 2299 2298 2300 2347 2300 2298 2347 2298 2348 2320 2347 2348 2320 2299 2321 2321 2347 2320 2299 2300 2301 2321 2299 2301 2301 2300 2302 2346 2302 2300 2346 2300 2347 2321 2346 2347 2321 2301 2322 2322 2346 2321 2301 2302 2303 2322 2301 2303 2890 2842 2305 2305 2842 2841 2305 2841 2891 2891 2907 2305 2305 2907 2908 2305 2908 2890 2891 2841 2874 2891 2874 2892 2892 2939 2891 2891 2939 2907 2960 2908 2907 2960 2907 2961 2961 2907 2939 2890 2908 2909 2959 2909 2908 2959 2908 2960 2961 2972 2960 2960 2972 2973 2960 2973 2959 2961 2939 2962 2962 3003 2961 2961 3003 2972 3003 3011 2972 2972 3011 3012 2972 3012 2973 2959 2973 2974 2973 3012 3013 2973 3013 2974 3011 3038 3012 3012 3038 3039 3012 3039 3013 3003 3010 3011 3010 3071 3011 3011 3071 3038 3039 3038 3057 3057 3038 3071 3013 3039 3040 3039 3057 3040 2974 3013 3014 3013 3040 3014 2974 3014 2975 2975 3014 3015 3014 3040 3041 3014 3041 3015 2958 2974 2975 2958 2975 2957 2957 2975 2976 2975 3015 2976 2976 3015 3016 3015 3041 3042 3015 3042 3016 3040 3053 3041 3041 3053 3042 3016 3042 3043 3043 3042 3053 2976 3016 2977 2977 3016 3017 3016 3043 3017 2957 2976 2956 2956 2976 2977 2956 2977 2955 2955 2977 2978 2977 3017 2978 2978 3017 3018 3017 3043 3044 3017 3044 3018 3053 3044 3043 3018 3044 3045 3053 3045 3044 2978 3018 2979 2979 3018 3019 3018 3045 3019 2955 2978 2954 2954 2978 2979 2954 2979 2953 2953 2979 2980 2979 3019 2980 3019 3020 2980 3019 3045 3046 3019 3046 3020 2953 2980 2952 2952 2980 2981 2980 3020 3021 2980 3021 2981 3020 3046 3047 3020 3047 3021 3045 3049 3046 3046 3049 3048 3046 3048 3047 3021 3047 3048 2981 3021 3022 3021 3048 3022 2952 2981 2951 2951 2981 2982 2981 3022 2982 2982 3022 3023 3022 3048 3049 3022 3049 3023 3023 3049 3050 3045 3050 3049 2982 3023 2983 2983 3023 3024 3023 3050 3024 2951 2982 2950 2950 2982 2983 2950 2983 2949 2949 2983 2984 2983 3024 2984 2984 3024 3025 3024 3050 3051 3024 3051 3025 3051 3050 3045 3052 3051 3045 3052 3045 3053 3025 3051 3052 2984 3025 2985 2985 3025 3026 3025 3052 3026 2949 2984 2948 2948 2984 2985 2948 2985 2947 2947 2985 2986 2985 3026 2986 2986 3026 3027 3026 3052 3053 3026 3053 3027 3027 3053 3054 3040 3054 3053 2986 3027 2987 2987 3027 3028 3027 3054 3028 2947 2986 2946 2946 2986 2987 2946 2987 2945 2945 2987 2988 2987 3028 2988 2988 3028 3029 3028 3054 3055 3028 3055 3029 3055 3054 3040 3040 3057 3056 3040 3056 3055 3029 3055 3056 2988 3029 2989 2989 3029 3030 3029 3056 3030 2945 2988 2944 2944 2988 2989 2944 2989 2943 2943 2989 2990 2989 3030 2990 2990 3030 3031 3030 3056 3057 3030 3057 3031 2943 2990 2942 2942 2990 2991 2990 3031 2991 2942 2925 2943 2943 2925 2924 2943 2924 2944 2944 2924 2923 2944 2923 2945 2875 2923 2924 2875 2924 2906 2906 2924 2925 2906 2925 2905 2905 2925 2926 2942 2926 2925 2905 2860 2906 2906 2860 2859 2906 2859 2875 2904 2861 2905 2905 2861 2860 2905 2926 2904 2904 2926 2927 2941 2927 2926 2941 2926 2942 2903 2862 2904 2904 2862 2861 2904 2927 2903 2903 2927 2928 2940 2928 2927 2940 2927 2941 2942 2991 2941 2941 2991 2992 2941 2992 2940 2929 2928 2940 2971 2929 2940 2940 2992 2993 2940 2993 2971 2903 2928 2902 2902 2928 2929 2902 2929 2901 2901 2929 2930 2971 2930 2929 2970 2930 2971 2971 2993 2994 2971 2994 2970 2992 3033 2993 2993 3033 3034 2993 3034 2994 2970 2994 2995 2994 3034 3035 2994 3035 2995 2969 2931 2970 2970 2931 2930 2970 2995 2969 2969 2995 2996 2995 3035 3036 2995 3036 2996 3034 3061 3035 3035 3061 3062 3035 3062 3036 2996 3036 3037 3036 3062 3063 3036 3063 3037 3057 3063 3062 3057 3062 3061 3034 3060 3061 3061 3060 3057 3033 3059 3060 3033 3060 3034 3057 3060 3059 2992 3032 3033 3032 3059 3033 3032 3058 3059 3057 3059 3058 2991 3031 3032 2991 3032 2992 3031 3058 3032 3031 3057 3058 3057 3071 3070 3070 3069 3057 3057 3069 3068 3057 3068 3067 3067 3066 3057 3057 3066 3065 3057 3065 3064 3064 3063 3057 3010 3070 3071 3002 3009 3010 3002 3010 3003 3009 3070 3010 2963 3001 3002 2963 3002 2962 2962 3002 3003 3001 3009 3002 3001 3008 3009 3008 3069 3009 3009 3069 3070 2964 3000 3001 2964 3001 2963 3000 3008 3001 3000 3007 3008 3007 3068 3008 3008 3068 3069 2965 2999 3000 2965 3000 2964 2999 3007 3000 2963 2937 2964 2964 2937 2936 2964 2936 2965 2965 2936 2935 2965 2935 2966 2966 2999 2965 2966 2998 2999 2998 3006 2999 2999 3006 3007 2966 2935 2934 2966 2934 2967 2967 2998 2966 2896 2934 2935 2896 2935 2895 2895 2935 2936 2897 2933 2934 2897 2934 2896 2967 2934 2933 2967 2933 2968 2968 2997 2967 2967 2997 2998 2898 2932 2933 2898 2933 2897 2968 2933 2932 2896 2869 2897 2897 2869 2868 2897 2868 2898 2898 2868 2867 2898 2867 2899 2899 2932 2898 2899 2931 2932 2968 2932 2969 2969 2932 2931 2899 2867 2866 2899 2866 2900 2900 2931 2899 2900 2930 2931 2900 2866 2865 2900 2865 2901 2901 2930 2900 2865 2825 2864 2866 2823 2865 2865 2823 2822 2865 2822 2825 2901 2865 2864 2901 2864 2902 2864 2827 2863 2864 2825 2824 2864 2824 2827 2902 2864 2863 2762 2824 2825 2762 2825 2822 2762 2822 2763 2763 2822 2823 2763 2823 2819 2866 2819 2823 2726 2762 2763 2726 2763 2727 2727 2763 2764 2763 2819 2764 2764 2819 2820 2866 2820 2819 2867 2820 2866 2764 2820 2765 2765 2820 2821 2867 2821 2820 2727 2764 2728 2728 2764 2765 2728 2765 2729 2729 2765 2766 2765 2817 2766 2765 2821 2817 2867 2817 2821 2868 2817 2867 2766 2817 2818 2868 2818 2817 2869 2816 2868 2868 2816 2818 2766 2818 2816 2815 2766 2816 2869 2815 2816 2870 2814 2869 2869 2814 2815 2896 2870 2869 2814 2767 2815 2815 2767 2766 2813 2767 2814 2870 2813 2814 2730 2766 2767 2730 2767 2731 2731 2767 2768 2813 2768 2767 2812 2768 2813 2870 2812 2813 2731 2768 2732 2732 2768 2769 2811 2769 2768 2811 2768 2812 2674 2730 2731 2674 2731 2675 2675 2731 2732 2675 2732 2676 2676 2732 2733 2732 2769 2733 2626 2674 2675 2626 2675 2628 2628 2675 2676 2628 2676 2630 2630 2676 2677 2676 2733 2677 2677 2733 2734 2733 2769 2770 2733 2770 2734 2630 2677 2632 2632 2677 2678 2677 2734 2678 2629 2628 2630 2629 2630 2631 2631 2630 2632 2631 2632 2633 2633 2632 2634 2632 2678 2634 2634 2678 2679 2678 2734 2735 2678 2735 2679 2633 2634 2635 2635 2634 2636 2634 2679 2636 3150 2631 2633 3150 2633 3151 3151 2633 2635 2635 2636 2637 3151 2635 3152 3152 2635 2637 2637 2636 2638 2636 2679 2680 2636 2680 2638 2637 2638 2639 3152 2637 3153 3153 2637 2639 3103 3151 3152 3103 3152 3102 3102 3152 3153 3102 3153 3101 3101 3153 3154 3153 2639 3154 2639 2638 2640 2640 2665 2639 3154 2639 2665 3101 3154 3129 3129 3154 3155 3154 2665 3155 3101 3095 3102 3129 3096 3101 3101 3096 3095 3128 3097 3129 3129 3097 3096 3129 3155 3128 3128 3155 3156 3155 2665 2664 3155 2664 3156 2640 2664 2665 2663 2662 2664 2663 2664 2640 3156 2664 2662 3128 3156 3127 3127 3156 3157 3156 2662 3157 3127 3098 3128 3128 3098 3097 3096 3097 3094 3094 3097 3098 3094 3098 3085 3127 3085 3098 3126 3085 3127 3127 3157 3126 3126 3157 3158 3157 2662 2660 3157 2660 3158 3125 3088 3126 3126 3088 3085 3126 3158 3125 3125 3158 3159 3158 2660 2658 3158 2658 3159 2659 2658 2660 2659 2660 2661 2661 2660 2662 2657 2656 2658 2657 2658 2659 3159 2658 2656 2661 2684 2659 2659 2684 2685 2659 2685 2657 2661 2662 2663 2663 2683 2661 2661 2683 2684 2684 2698 2685 2683 2709 2684 2684 2709 2710 2684 2710 2698 2657 2685 2686 2685 2698 2699 2685 2699 2686 2710 2743 2698 2698 2743 2744 2698 2744 2699 2709 2742 2710 2710 2742 2743 2791 2744 2743 2791 2743 2792 2792 2743 2793 2793 2743 2742 2709 2741 2742 2793 2742 2794 2794 2742 2795 2795 2742 2741 2846 2792 2793 2846 2793 2794 2847 2792 2846 2847 2791 2792 2790 2744 2791 2847 2790 2791 2848 2790 2847 2885 2848 2847 2885 2847 2886 2886 2847 2846 2846 2794 2845 2886 2846 2887 2887 2846 2845 2845 2794 2795 2845 2796 2844 2845 2795 2796 2887 2845 2888 2888 2845 2844 2888 2911 2887 2887 2911 2912 2887 2912 2886 2886 2912 2913 2886 2913 2885 2955 2913 2912 2955 2912 2956 2956 2912 2911 2888 2910 2911 2956 2911 2957 2957 2911 2910 2888 2844 2889 2889 2910 2888 2889 2909 2910 2957 2910 2958 2958 2910 2909 2889 2844 2843 2889 2843 2890 2890 2909 2889 2958 2909 2959 2959 2974 2958 2890 2843 2842 2841 2842 2802 2843 2800 2842 2842 2800 2801 2842 2801 2802 2802 2803 2841 2841 2803 2804 2841 2804 2874 2801 2738 2802 2802 2738 2803 2800 2739 2801 2801 2739 2738 2799 2739 2800 2843 2799 2800 2706 2738 2739 2706 2739 2707 2707 2739 2740 2799 2740 2739 2798 2740 2799 2843 2798 2799 2844 2798 2843 2797 2740 2798 2844 2797 2798 2707 2740 2708 2708 2740 2741 2797 2741 2740 2796 2741 2797 2844 2796 2797 2708 2741 2709 2795 2741 2796 2682 2707 2708 2682 2708 2683 2683 2708 2709 2640 2681 2682 2640 2682 2663 2663 2682 2683 2681 2707 2682 2638 2681 2640 2638 2680 2681 2680 2706 2681 2681 2706 2707 2679 2705 2680 2680 2705 2706 2705 2738 2706 2679 2736 2705 2736 2737 2705 2705 2737 2738 2679 2735 2736 2735 2772 2736 2736 2772 2737 2803 2738 2737 2803 2737 2804 2804 2737 2772 2735 2771 2772 2804 2772 2805 2805 2772 2771 2734 2771 2735 2734 2770 2771 2805 2771 2806 2806 2771 2807 2807 2771 2770 2874 2804 2805 2874 2805 2806 2874 2806 2873 2873 2806 2807 2807 2770 2808 2873 2807 2808 2808 2770 2809 2809 2770 2769 2873 2808 2872 2872 2808 2809 2892 2874 2873 2892 2873 2893 2893 2873 2872 2872 2810 2871 2872 2809 2810 2893 2872 2894 2894 2872 2871 2809 2769 2810 2810 2769 2811 2871 2810 2811 2871 2812 2870 2871 2811 2812 2894 2871 2895 2895 2871 2870 2895 2936 2894 2894 2936 2937 2894 2937 2893 2895 2870 2896 2893 2937 2938 2893 2938 2892 2963 2938 2937 2892 2938 2939 2962 2939 2938 2962 2938 2963 2954 2913 2955 2953 2914 2954 2954 2914 2913 2885 2913 2914 2885 2914 2884 2884 2914 2915 2953 2915 2914 2952 2915 2953 2884 2915 2883 2883 2915 2916 2952 2916 2915 2883 2849 2884 2884 2849 2848 2884 2848 2885 2882 2850 2883 2883 2850 2849 2883 2916 2882 2882 2916 2917 2951 2917 2916 2951 2916 2952 2881 2851 2882 2882 2851 2850 2882 2917 2881 2881 2917 2918 2950 2918 2917 2950 2917 2951 2880 2852 2881 2881 2852 2851 2881 2918 2880 2880 2918 2919 2949 2919 2918 2949 2918 2950 2879 2853 2880 2880 2853 2852 2880 2919 2879 2879 2919 2920 2948 2920 2919 2948 2919 2949 2878 2854 2879 2879 2854 2853 2879 2920 2878 2878 2920 2921 2947 2921 2920 2947 2920 2948 2877 2855 2878 2878 2855 2854 2878 2921 2877 2877 2921 2922 2946 2922 2921 2946 2921 2947 2876 2856 2877 2877 2856 2855 2877 2922 2876 2876 2922 2923 2945 2923 2922 2945 2922 2946 2875 2857 2876 2876 2857 2856 2876 2923 2875 2875 2859 2858 2875 2858 2857 2857 2836 2856 2858 2838 2857 2857 2838 2837 2857 2837 2836 2859 2840 2858 2858 2840 2839 2858 2839 2838 2754 2837 2838 2754 2838 2755 2755 2838 2839 2753 2836 2837 2753 2837 2754 2776 2836 2753 2856 2836 2776 2695 2752 2753 2695 2753 2720 2720 2753 2754 2752 2776 2753 2720 2754 2718 2718 2754 2755 2718 2719 2720 2720 2719 2721 2720 2721 2695 2716 2717 2718 2718 2717 2719 2718 2755 2716 3166 2721 2719 3166 2719 3167 3167 2719 2717 2695 2721 2722 3165 2722 2721 3165 2721 3166 3162 3165 3166 3162 3166 3161 3161 3166 3167 3167 3168 3161 3167 2717 3168 2716 2715 2717 3168 2717 2715 3161 3168 3169 3168 2715 3169 2714 2713 2715 2714 2715 2716 3169 2715 2713 3161 3169 3164 3169 2713 3164 2712 2694 2713 2712 2713 2714 3164 2713 2694 2716 2756 2714 2714 2756 2757 2714 2757 2712 2716 2755 2756 2756 2834 2757 2755 2839 2756 2756 2839 2840 2756 2840 2834 2757 2834 2835 2859 2835 2834 2859 2834 2840 2757 2835 2832 2860 2835 2859 2860 2832 2835 2757 2832 2758 2758 2832 2833 2860 2833 2832 2861 2833 2860 2758 2833 2830 2861 2830 2833 2712 2757 2758 2712 2758 2711 2711 2758 2759 2758 2830 2759 2759 2830 2831 2861 2831 2830 2862 2831 2861 2759 2831 2828 2862 2828 2831 2711 2759 2723 2723 2759 2760 2759 2828 2760 2760 2828 2829 2862 2829 2828 2863 2829 2862 2903 2863 2862 2760 2829 2826 2863 2826 2829 2723 2760 2724 2724 2760 2761 2760 2826 2761 2711 2723 2668 2668 2723 2724 2668 2724 2669 2669 2724 2725 2724 2761 2725 2612 2667 2668 2612 2668 2614 2614 2668 2669 2668 2667 2711 2614 2669 2616 2616 2669 2670 2669 2725 2670 2670 2725 2726 2725 2761 2762 2725 2762 2726 2616 2670 2618 2618 2670 2671 2670 2726 2671 2615 2614 2616 2615 2616 2617 2617 2616 2618 2617 2618 2619 2619 2618 2620 2618 2671 2620 2620 2671 2672 2671 2726 2727 2671 2727 2672 2619 2620 2621 2621 2620 2622 2620 2672 2622 3143 2617 2619 3143 2619 3144 3144 2619 2621 2621 2622 2623 3144 2621 3145 3145 2621 2623 2623 2622 2624 2622 2672 2673 2622 2673 2624 2623 2624 2625 3145 2623 3146 3146 2623 2625 3144 3145 3109 3109 3145 3146 3110 3143 3144 3110 3144 3109 3108 3087 3109 3109 3087 3086 3109 3086 3110 3109 3146 3108 3108 3146 3147 3146 2625 3147 3107 3091 3108 3108 3091 3087 3108 3147 3107 3085 3086 3087 3087 3091 3085 3085 3084 3086 3110 3086 3084 3083 3084 3085 3110 3084 3111 3111 3084 3083 3083 3085 3074 3111 3083 3112 3112 3083 3074 3112 3142 3111 3111 3142 3143 3111 3143 3110 3112 3074 3113 3113 3141 3112 3112 3141 3142 3141 2615 3142 3142 2615 2617 3142 2617 3143 3113 3140 3141 3140 2613 3141 3141 2613 2615 3113 3074 3079 3113 3079 3114 3114 3140 3113 3114 3130 3140 3130 2611 3140 3140 2611 2613 2611 2612 2613 2613 2612 2614 2613 2614 2615 2609 2610 2611 2611 2610 2612 3130 2609 2611 2610 2667 2612 2609 2415 2610 2415 2666 2610 2610 2666 2667 2416 2415 2609 2416 2609 3130 2415 2416 2417 2417 2416 2418 2585 2418 2416 2416 2415 2585 3139 3161 2416 3139 2416 3130 2416 3161 3163 3163 2694 2416 2416 2694 2448 2416 2448 2415 3116 3138 3139 3116 3139 3130 3138 3161 3139 3138 3162 3161 3163 3161 3164 3164 2694 3163 2666 2448 2694 2711 2666 2694 2711 2694 2712 2415 2448 2666 2667 2666 2711 2448 2415 2417 2585 2415 2448 2417 2418 2419 2448 2417 2449 2449 2417 2419 2419 2418 2420 2586 2420 2418 2586 2418 2585 2585 2533 2586 2585 2448 2533 2505 2504 2448 2505 2448 2449 2533 2448 2504 2449 2419 2450 2449 2450 2505 2450 2419 2421 2450 2421 2451 2505 2450 2451 2419 2420 2421 2421 2420 2422 2421 2422 2423 2451 2421 2423 2451 2423 2452 2505 2451 2526 2526 2451 2452 2423 2422 2424 2423 2424 2425 2452 2423 2425 2588 2424 2422 2588 2422 2587 2587 2422 2420 2425 2424 2426 2604 2426 2424 2604 2424 2588 2425 2426 2427 2452 2425 2453 2453 2425 2427 2427 2426 2428 2606 2428 2426 2606 2426 2604 2588 2535 2604 2604 2535 2605 2604 2605 2606 2606 2605 2607 2606 2607 2589 2589 2428 2606 2427 2428 2429 2429 2428 2430 2589 2430 2428 2589 2590 2591 2589 2607 2608 2589 2608 2590 2591 2430 2589 2429 2430 2431 2431 2430 2432 2591 2432 2430 2591 2590 2592 2591 2592 2593 2593 2432 2591 2431 2432 2433 2433 2432 2434 2593 2434 2432 2455 2429 2431 2455 2431 2456 2456 2431 2433 2433 2434 2435 2456 2433 2457 2457 2433 2435 2435 2434 2436 2595 2436 2434 2595 2434 2593 2435 2436 2437 2457 2435 2458 2458 2435 2437 2458 2520 2457 2457 2520 2521 2457 2521 2456 2458 2437 2459 2459 2512 2458 2512 2519 2458 2458 2519 2520 2519 2598 2520 2520 2598 2596 2520 2596 2521 2456 2521 2522 2521 2596 2594 2521 2594 2522 2595 2594 2596 2595 2596 2597 2597 2596 2598 2593 2592 2594 2593 2594 2595 2522 2594 2592 2456 2522 2455 2455 2522 2523 2522 2592 2523 2523 2592 2590 2455 2523 2454 2454 2523 2524 2523 2590 2524 2454 2429 2455 2453 2427 2454 2454 2427 2429 2454 2524 2453 2453 2524 2525 2524 2590 2608 2524 2608 2525 2453 2525 2452 2527 2452 2525 2525 2608 2607 2525 2607 2527 2526 2452 2527 2527 2607 2605 2527 2605 2526 2526 2605 2535 2526 2535 2505 2533 2534 2535 2586 2533 2535 2586 2535 2587 2587 2535 2588 2505 2535 2534 2503 2504 2505 2505 2534 2503 2533 2532 2534 2503 2534 2532 2501 2502 2503 2503 2502 2504 2503 2532 2501 2533 2504 2502 2501 2500 2502 2533 2502 2531 2531 2502 2500 2499 2500 2501 2501 2532 2529 2501 2529 2499 2531 2529 2532 2531 2532 2533 2530 2529 2531 2531 2500 2530 2499 2498 2500 2530 2500 2498 2487 2498 2499 2499 2528 2487 2499 2529 2528 2528 2529 2530 2530 2551 2528 2530 2498 2551 2487 2497 2498 2551 2498 2497 2485 2486 2487 2486 2497 2487 2487 2528 2553 2487 2553 2485 2528 2551 2552 2528 2552 2553 2551 2497 2552 2552 2497 2486 2485 2484 2486 2552 2486 2554 2554 2486 2484 2483 2484 2485 2485 2553 2555 2485 2555 2483 2553 2552 2554 2553 2554 2555 2555 2554 2556 2554 2484 2556 2483 2482 2484 2556 2484 2482 2481 2482 2483 2483 2555 2557 2483 2557 2481 2555 2556 2557 2557 2556 2558 2556 2482 2558 2557 2558 2559 2481 2557 2559 2481 2488 2482 2481 2559 2488 2482 2488 2479 2518 2477 2488 2488 2477 2478 2488 2478 2479 2488 2559 2569 2488 2569 2518 2517 2476 2518 2518 2476 2477 2518 2569 2567 2518 2567 2517 2476 2388 2477 2477 2388 2386 2477 2386 2478 2478 2386 2384 2478 2384 2479 2385 2384 2386 2385 2386 2387 2387 2386 2388 2387 2388 2389 2389 2388 2390 2476 2390 2388 2570 2385 2387 2570 2387 2568 2568 2387 2389 2383 2384 2385 2571 2383 2385 2571 2385 2570 2568 2569 2570 2570 2569 2559 2570 2559 2571 2566 2567 2568 2568 2567 2569 2568 2389 2566 2564 2565 2566 2566 2565 2567 2566 2389 2391 2566 2391 2564 2517 2567 2565 2564 2563 2565 2517 2565 2516 2516 2565 2563 2550 2563 2564 2564 2391 2393 2564 2393 2550 2389 2390 2391 2391 2390 2392 2391 2392 2393 2393 2392 2394 2393 2394 2395 2550 2393 2395 2474 2394 2392 2474 2392 2475 2475 2392 2390 2475 2390 2476 2516 2474 2475 2516 2475 2517 2517 2475 2476 2473 2394 2474 2515 2473 2474 2515 2474 2516 2472 2396 2473 2473 2396 2394 2514 2472 2473 2514 2473 2515 2516 2563 2515 2515 2563 2562 2515 2562 2514 2513 2472 2514 2514 2562 2549 2514 2549 2513 2549 2562 2550 2550 2562 2563 2548 2547 2549 2548 2549 2550 2513 2549 2547 2496 2471 2513 2513 2471 2472 2513 2547 2496 2546 2545 2547 2546 2547 2548 2496 2547 2545 2550 2395 2548 2548 2395 2397 2548 2397 2546 2544 2545 2546 2546 2397 2399 2546 2399 2544 2544 2543 2545 2496 2545 2495 2495 2545 2543 2495 2471 2496 2494 2470 2495 2495 2470 2471 2495 2543 2494 2542 2541 2543 2542 2543 2544 2494 2543 2541 2544 2399 2401 2544 2401 2542 2540 2541 2542 2542 2401 2403 2542 2403 2540 2540 2539 2541 2494 2541 2493 2493 2541 2539 2538 2539 2540 2540 2403 2405 2540 2405 2538 2401 2402 2403 2403 2402 2404 2403 2404 2405 2405 2404 2406 2405 2406 2407 2538 2405 2407 2536 2537 2538 2538 2537 2539 2538 2407 2536 2407 2406 2408 2407 2408 2409 2536 2407 2409 2467 2408 2406 2467 2406 2468 2468 2406 2404 2409 2408 2410 2466 2410 2408 2466 2408 2467 2409 2410 2411 2536 2409 2582 2582 2409 2411 2411 2410 2412 2465 2412 2410 2465 2410 2466 2490 2465 2466 2490 2466 2491 2491 2466 2467 2464 2412 2465 2464 2465 2489 2489 2465 2490 2411 2412 2413 2413 2412 2414 2464 2414 2412 2463 2414 2464 2489 2506 2464 2464 2506 2507 2464 2507 2463 2490 2583 2489 2489 2583 2581 2489 2581 2506 2506 2581 2579 2506 2579 2507 2463 2507 2508 2507 2579 2577 2507 2577 2508 2578 2577 2579 2578 2579 2580 2580 2579 2581 2580 2581 2582 2582 2581 2583 2582 2411 2580 2580 2411 2413 2580 2413 2578 2576 2577 2578 2578 2413 2447 2578 2447 2576 2576 2575 2577 2508 2577 2575 2574 2575 2576 2576 2447 2446 2576 2446 2574 2414 2446 2447 2414 2447 2413 2445 2444 2446 2445 2446 2414 2574 2446 2444 2572 2573 2574 2574 2573 2575 2574 2444 2572 2508 2575 2509 2509 2575 2573 2572 2603 2573 2509 2573 2510 2510 2573 2603 2462 2508 2509 2462 2509 2461 2461 2509 2510 2463 2508 2462 2461 2443 2462 2462 2443 2445 2462 2445 2463 2460 2441 2461 2461 2441 2443 2461 2510 2460 2460 2510 2511 2510 2603 2511 2459 2439 2460 2460 2439 2441 2460 2511 2459 2439 2440 2441 2441 2440 2442 2441 2442 2443 2443 2442 2444 2443 2444 2445 2572 2444 2442 2572 2442 2601 2601 2442 2440 2439 2438 2440 2601 2440 2599 2599 2440 2438 2599 2600 2601 2601 2600 2602 2601 2602 2572 2572 2602 2603 2511 2603 2602 2511 2602 2512 2512 2602 2600 2599 2598 2600 2512 2600 2519 2519 2600 2598 2597 2598 2599 2599 2438 2597 2597 2438 2436 2597 2436 2595 2437 2436 2438 2437 2438 2439 2459 2437 2439 2459 2511 2512 2463 2445 2414 2582 2583 2536 2536 2583 2584 2490 2584 2583 2536 2584 2537 2491 2537 2584 2491 2584 2490 2492 2539 2537 2492 2537 2491 2491 2467 2492 2492 2467 2468 2492 2468 2493 2493 2539 2492 2468 2404 2469 2493 2468 2469 2493 2469 2494 2469 2404 2402 2469 2402 2470 2494 2469 2470 2401 2400 2402 2470 2402 2400 2470 2400 2471 2399 2398 2400 2399 2400 2401 2471 2400 2398 2471 2398 2472 2397 2396 2398 2397 2398 2399 2472 2398 2396 2395 2396 2397 2395 2394 2396 2571 2559 2561 2561 2383 2571 2559 2558 2560 2559 2560 2561 2560 2381 2561 2561 2381 2383 2381 2382 2383 2383 2382 2384 2479 2384 2382 2479 2382 2480 2482 2479 2480 2558 2482 2560 2560 2482 2480 2560 2480 2381 2381 2480 2382 2641 2693 2480 2641 2480 2382 2480 2693 2695 2695 2722 2480 2382 2480 2381 2381 2480 2722 2382 2381 2641 2641 2381 2642 2641 2642 2643 2643 2693 2641 2643 2692 2693 2695 2693 2692 2695 2692 2696 2696 2752 2695 2645 2691 2692 2645 2692 2643 2696 2692 2691 2643 2642 2644 2643 2644 2645 2645 2644 2646 2645 2646 2647 2647 2691 2645 2647 2690 2691 2696 2691 2697 2697 2691 2690 2647 2646 2648 2647 2648 2649 2649 2690 2647 3134 2648 2646 3134 2646 3135 3135 2646 2644 2649 2648 2650 3133 2650 2648 3133 2648 3134 2649 2650 2651 2651 2689 2649 2649 2689 2690 2651 2650 2652 3132 2652 2650 3132 2650 3133 3122 3132 3133 3122 3133 3121 3121 3133 3134 3123 3131 3132 3123 3132 3122 3131 2652 3132 2651 2652 2653 2653 2652 2654 3131 2654 2652 3124 3131 3123 3124 3160 3131 3160 2654 3131 3122 3089 3123 3123 3089 3076 3123 3076 3124 3124 3076 3075 3124 3075 3125 3125 3159 3124 3124 3159 3160 3159 2656 3160 3160 2656 2654 2655 2654 2656 2655 2656 2657 2653 2654 2655 2657 2686 2655 2655 2686 2687 2655 2687 2653 2686 2699 2700 2686 2700 2687 2653 2687 2688 2687 2700 2701 2687 2701 2688 2653 2688 2651 2651 2688 2689 2688 2701 2702 2688 2702 2689 2700 2746 2701 2701 2746 2747 2701 2747 2702 2699 2745 2700 2700 2745 2746 2699 2744 2745 2787 2746 2745 2787 2745 2788 2788 2745 2789 2789 2745 2744 2786 2747 2746 2786 2746 2787 2849 2786 2787 2849 2787 2788 2849 2788 2848 2848 2788 2789 2789 2744 2790 2848 2789 2790 2850 2786 2849 2773 2747 2786 2850 2773 2786 2851 2774 2850 2850 2774 2773 2773 2774 2747 2747 2774 2748 2748 2774 2785 2851 2785 2774 2852 2784 2851 2851 2784 2785 2748 2785 2784 2783 2748 2784 2852 2783 2784 2853 2782 2852 2852 2782 2783 2782 2749 2783 2783 2749 2748 2781 2749 2782 2853 2781 2782 2854 2780 2853 2853 2780 2781 2780 2750 2781 2781 2750 2749 2703 2748 2749 2703 2749 2704 2704 2749 2750 2704 2750 2697 2697 2750 2751 2779 2751 2750 2779 2750 2780 2854 2779 2780 2778 2751 2779 2854 2778 2779 2855 2778 2854 2777 2751 2778 2855 2777 2778 2697 2751 2696 2696 2751 2752 2777 2752 2751 2690 2704 2697 2690 2703 2704 2689 2703 2690 2689 2702 2703 2702 2748 2703 2702 2747 2748 2775 2776 2752 2775 2752 2777 2856 2775 2855 2855 2775 2777 2856 2776 2775 3125 3075 3088 3075 3076 3074 3074 3088 3075 3074 3085 3088 3072 3073 3074 3073 3079 3074 3076 3089 3074 3074 3089 3090 3074 3090 3072 3120 3073 3072 3120 3072 3121 3121 3072 3090 3121 3090 3122 3122 3090 3089 3121 3134 3120 3119 3073 3120 3120 3134 3135 3120 3135 3119 3118 3077 3119 3119 3077 3073 3119 3135 3136 3119 3136 3118 3135 2644 3136 3118 3136 3137 3136 2644 2642 3136 2642 3137 3117 3080 3118 3118 3080 3077 3118 3137 3117 3077 3078 3073 3077 3080 3078 3078 3080 3081 3117 3081 3080 3116 3081 3117 3117 3137 3138 3117 3138 3116 3078 3081 3082 3116 3082 3081 3115 3082 3116 3115 3116 3130 3115 3078 3082 3114 3078 3115 3115 3130 3114 3114 3079 3078 3073 3078 3079 3137 2381 3138 3138 2381 3162 3137 2642 2381 2381 3165 3162 2381 2722 3165 3085 3091 3092 3085 3092 3093 3093 3099 3085 3085 3099 3100 3085 3100 3094 3107 3092 3091 3106 3093 3092 3106 3092 3107 3105 3099 3093 3105 3093 3106 3104 3100 3099 3104 3099 3105 3103 3094 3100 3103 3100 3104 3094 3095 3096 3102 3095 3094 3102 3094 3103 3104 3151 3103 3105 3150 3104 3104 3150 3151 3106 3149 3105 3105 3149 3150 3149 2631 3150 3106 3148 3149 3148 2629 3149 3149 2629 2631 3107 3147 3148 3107 3148 3106 3147 2627 3148 3148 2627 2629 2627 2628 2629 2625 2626 2627 2627 2626 2628 3147 2625 2627 2625 2624 2626 2624 2674 2626 2624 2673 2674 2673 2729 2674 2729 2730 2674 2672 2728 2673 2673 2728 2729 2729 2766 2730 2672 2727 2728 2587 2420 2586 2761 2824 2762 2761 2826 2827 2761 2827 2824 2863 2827 2826 2902 2863 2903 2969 2996 2968 2968 2996 2997 2996 3004 2997 2996 3037 3004 2997 3004 3005 2997 3005 2998 3037 3064 3004 3004 3064 3065 3004 3065 3005 3037 3063 3064 2998 3005 3006 3005 3065 3066 3005 3066 3006 3006 3066 3067 3006 3067 3007 3007 3067 3068 3170 3171 3172 3175 3174 3170 3175 3170 3176 3176 3170 3172 3171 3170 3205 3205 3170 3234 3234 3170 3277 3277 3170 3267 3170 3174 3267 3173 3174 3175 3174 3173 3265 3267 3174 3265 3265 3173 3266 3175 3266 3173 3265 3266 3267 3267 3266 3268 3175 3268 3266 3268 3269 3267 3176 3269 3268 3176 3268 3175 3172 3269 3176 3267 3269 3270 3172 3270 3269 3171 3270 3172 3267 3270 3271 3171 3271 3270 3204 3203 3171 3204 3171 3205 3203 3271 3171 3271 3274 3264 3271 3264 3267 3203 3274 3271 3202 3203 3204 3202 3274 3203 3264 3274 3275 3202 3275 3274 3204 3215 3202 3215 3275 3202 3264 3275 3263 3215 3263 3275 3204 3214 3215 3214 3263 3215 3261 3262 3263 3263 3262 3264 3214 3261 3263 3213 3214 3204 3214 3213 3261 3261 3213 3262 3213 3204 3262 3262 3204 3264 3204 3205 3264 3205 3201 3212 3219 3206 3205 3205 3206 3208 3205 3208 3220 3229 3219 3205 3229 3205 3230 3230 3205 3212 3205 3234 3201 3264 3205 3276 3205 3220 3276 3276 3220 3285 3285 3220 3208 3267 3264 3276 3267 3276 3277 3277 3276 3244 3244 3276 3285 3244 3285 3242 3208 3242 3285 3242 3243 3244 3208 3243 3242 3207 3316 3243 3207 3243 3208 3316 3244 3243 3206 3207 3208 3316 3207 3317 3317 3207 3206 3317 3244 3316 3317 3206 3320 3299 3244 3317 3320 3299 3317 3219 3184 3206 3320 3206 3184 3320 3184 3321 3321 3299 3320 3297 3298 3299 3299 3298 3246 3299 3246 3244 3321 3297 3299 3321 3184 3319 3319 3297 3321 3290 3272 3297 3297 3272 3298 3319 3290 3297 3298 3185 3246 3272 3239 3298 3298 3239 3185 3228 3218 3239 3239 3218 3240 3239 3240 3185 3272 3228 3239 3185 3240 3241 3322 3241 3240 3218 3324 3240 3240 3324 3325 3240 3325 3322 3185 3241 3224 3224 3241 3294 3294 3241 3322 3294 3322 3273 3325 3273 3322 3324 3255 3325 3325 3255 3273 3218 3323 3324 3323 3256 3324 3324 3256 3255 3255 3256 3257 3257 3247 3255 3255 3247 3273 3247 3272 3273 3294 3273 3295 3295 3273 3272 3224 3294 3295 3295 3272 3296 3224 3295 3223 3223 3295 3296 3272 3290 3291 3296 3272 3291 3247 3228 3272 3223 3296 3222 3222 3296 3291 3222 3185 3223 3223 3185 3224 3221 3183 3222 3222 3183 3185 3222 3291 3221 3318 3221 3291 3318 3291 3290 3318 3290 3319 3318 3319 3183 3183 3221 3318 3183 3184 3185 3183 3319 3184 3185 3184 3219 3246 3185 3219 3228 3219 3229 3246 3219 3247 3247 3219 3228 3245 3246 3247 3245 3292 3246 3246 3292 3302 3246 3302 3244 3244 3302 3304 3244 3304 3277 3277 3304 3307 3277 3307 3312 3312 3234 3277 3304 3306 3307 3306 3236 3307 3307 3236 3235 3307 3235 3312 3235 3234 3312 3234 3235 3236 3201 3234 3236 3201 3236 3199 3306 3199 3236 3305 3306 3304 3305 3199 3306 3199 3200 3201 3305 3200 3199 3201 3334 3335 3201 3335 3212 3334 3201 3337 3337 3201 3200 3337 3200 3305 3304 3334 3305 3305 3334 3337 3334 3304 3335 3212 3335 3336 3335 3304 3303 3335 3303 3336 3302 3303 3304 3302 3301 3303 3336 3303 3301 3212 3336 3333 3336 3301 3333 3300 3301 3302 3313 3301 3314 3314 3301 3300 3313 3333 3301 3302 3292 3229 3300 3302 3230 3230 3302 3229 3292 3245 3293 3292 3293 3308 3229 3292 3209 3292 3308 3209 3229 3209 3228 3209 3210 3211 3228 3209 3211 3209 3308 3210 3308 3293 3309 3308 3309 3300 3308 3300 3210 3300 3309 3310 3330 3310 3309 3330 3309 3332 3332 3309 3293 3300 3310 3311 3314 3300 3315 3315 3300 3311 3210 3300 3230 3329 3311 3310 3329 3310 3330 3329 3197 3311 3196 3315 3311 3196 3311 3197 3225 3314 3315 3225 3315 3196 3227 3313 3314 3227 3314 3225 3196 3198 3225 3225 3198 3226 3225 3226 3227 3196 3197 3198 3198 3197 3329 3329 3330 3198 3188 3226 3198 3233 3188 3198 3198 3330 3233 3332 3233 3330 3232 3188 3233 3331 3232 3233 3331 3233 3332 3332 3293 3331 3328 3232 3331 3331 3293 3328 3231 3186 3232 3232 3186 3188 3328 3231 3232 3327 3231 3328 3328 3245 3327 3293 3245 3328 3231 3327 3254 3231 3254 3186 3186 3187 3188 3252 3187 3186 3186 3254 3253 3186 3253 3252 3245 3253 3254 3327 3245 3254 3247 3252 3245 3245 3252 3253 3247 3251 3252 3251 3187 3252 3188 3187 3251 3250 3251 3247 3250 3188 3251 3257 3250 3247 3286 3257 3287 3287 3257 3256 3258 3250 3257 3286 3211 3257 3211 3180 3257 3257 3180 3258 3287 3237 3286 3237 3211 3286 3287 3256 3288 3288 3238 3287 3287 3238 3237 3288 3256 3289 3323 3289 3256 3289 3216 3288 3288 3216 3238 3211 3237 3238 3218 3211 3238 3218 3238 3216 3216 3217 3218 3289 3217 3216 3326 3217 3289 3326 3289 3323 3323 3218 3326 3228 3211 3218 3326 3218 3217 3211 3210 3188 3211 3188 3180 3230 3212 3210 3210 3212 3226 3210 3226 3188 3191 3195 3188 3180 3188 3195 3191 3188 3250 3191 3194 3195 3180 3195 3182 3194 3248 3195 3195 3248 3284 3195 3284 3182 3193 3194 3191 3193 3249 3194 3194 3249 3248 3248 3249 3250 3284 3248 3258 3258 3248 3250 3258 3283 3284 3182 3284 3283 3181 3180 3182 3182 3283 3181 3258 3282 3283 3181 3283 3282 3179 3180 3181 3181 3282 3179 3179 3178 3180 3180 3178 3258 3177 3178 3179 3179 3282 3260 3179 3260 3177 3260 3282 3258 3258 3259 3260 3259 3177 3260 3258 3178 3259 3178 3177 3259 3280 3279 3250 3280 3250 3281 3281 3250 3249 3279 3191 3250 3278 3279 3280 3278 3189 3279 3189 3191 3279 3189 3190 3191 3191 3190 3192 3191 3192 3193 3190 3189 3278 3190 3278 3280 3190 3280 3192 3192 3280 3281 3192 3281 3193 3193 3281 3249 3227 3226 3313 3313 3226 3333 3333 3226 3212 3338 3339 3340 3378 3377 3338 3338 3377 3339 3378 3338 3373 3373 3338 3340 3340 3339 3341 3377 3341 3339 3377 3378 3370 3370 3341 3377 3370 3378 3373 3368 3369 3370 3370 3373 3368 3369 3341 3370 3340 3341 3342 3342 3341 3343 3343 3341 3369 3369 3368 3343 3343 3368 3342 3368 3373 3372 3372 3382 3368 3368 3382 3383 3368 3383 3384 3384 3391 3368 3368 3391 3392 3368 3392 3381 3381 3342 3368 3348 3383 3382 3348 3382 3349 3349 3382 3372 3347 3384 3383 3347 3383 3348 3363 3391 3384 3363 3384 3347 3362 3392 3391 3362 3391 3363 3342 3362 3363 3342 3363 3347 3347 3348 3342 3342 3348 3349 3342 3349 3340 3340 3349 3350 3349 3372 3350 3344 3362 3342 3344 3342 3381 3344 3361 3362 3361 3392 3362 3354 3361 3344 3354 3393 3361 3393 3392 3361 3381 3392 3393 3381 3393 3379 3354 3379 3393 3344 3353 3354 3353 3379 3354 3379 3380 3381 3353 3380 3379 3344 3352 3353 3352 3380 3353 3380 3385 3381 3352 3385 3380 3346 3352 3344 3346 3385 3352 3381 3385 3386 3346 3386 3385 3344 3345 3346 3345 3357 3346 3357 3386 3346 3381 3386 3376 3376 3386 3387 3357 3387 3386 3345 3356 3357 3356 3387 3357 3376 3387 3374 3356 3374 3387 3355 3356 3345 3355 3374 3356 3374 3375 3376 3355 3375 3374 3345 3360 3355 3360 3375 3355 3375 3388 3376 3360 3388 3375 3345 3359 3360 3359 3388 3360 3376 3388 3389 3389 3388 3359 3340 3358 3359 3340 3359 3345 3358 3389 3359 3376 3389 3373 3373 3389 3390 3358 3390 3389 3351 3358 3340 3351 3390 3358 3340 3350 3351 3345 3373 3340 3376 3373 3345 3345 3344 3364 3364 3376 3345 3371 3372 3373 3373 3390 3371 3351 3371 3390 3350 3371 3351 3350 3372 3371 3366 3367 3376 3376 3367 3381 3366 3376 3364 3364 3365 3366 3364 3344 3365 3381 3367 3344 3344 3367 3365 3366 3365 3367 3394 3395 3396 3428 3427 3394 3394 3427 3395 3428 3394 3429 3429 3394 3396 3396 3395 3397 3427 3397 3395 3427 3428 3429 3429 3424 3427 3427 3424 3426 3426 3397 3427 3396 3397 3398 3398 3397 3399 3399 3397 3425 3425 3397 3426 3424 3425 3426 3425 3424 3399 3399 3424 3398 3429 3431 3424 3431 3438 3424 3424 3438 3439 3424 3439 3440 3440 3447 3424 3424 3447 3448 3424 3448 3434 3434 3398 3424 3404 3439 3438 3404 3438 3405 3405 3438 3431 3403 3440 3439 3403 3439 3404 3419 3447 3440 3419 3440 3403 3418 3448 3447 3418 3447 3419 3398 3418 3419 3398 3419 3403 3403 3404 3398 3398 3404 3405 3398 3405 3396 3396 3405 3406 3405 3431 3406 3408 3418 3398 3408 3398 3434 3408 3417 3418 3417 3448 3418 3410 3417 3408 3410 3449 3417 3449 3448 3417 3434 3448 3449 3434 3449 3432 3410 3432 3449 3408 3409 3410 3409 3432 3410 3432 3433 3434 3409 3433 3432 3408 3413 3409 3413 3433 3409 3433 3441 3434 3413 3441 3433 3408 3412 3413 3412 3441 3413 3434 3441 3442 3412 3442 3441 3402 3411 3412 3402 3412 3408 3411 3442 3412 3434 3442 3435 3435 3442 3443 3411 3443 3442 3401 3411 3402 3401 3443 3411 3435 3443 3436 3401 3436 3443 3400 3401 3402 3400 3436 3401 3435 3436 3437 3400 3437 3436 3402 3416 3400 3416 3437 3400 3437 3444 3435 3416 3444 3437 3402 3415 3416 3415 3444 3416 3435 3444 3445 3445 3444 3415 3396 3414 3415 3396 3415 3402 3414 3445 3415 3435 3445 3429 3429 3445 3446 3414 3446 3445 3407 3414 3396 3407 3446 3414 3396 3406 3407 3402 3429 3396 3435 3429 3402 3402 3408 3420 3420 3435 3402 3430 3431 3429 3429 3446 3430 3407 3430 3446 3406 3430 3407 3406 3431 3430 3422 3423 3435 3435 3423 3434 3422 3435 3420 3420 3421 3422 3420 3408 3421 3434 3423 3408 3408 3423 3421 3422 3421 3423 3450 3451 3452 3508 3507 3450 3508 3450 3509 3509 3450 3452 3748 3451 3450 3748 3450 3779 3779 3450 3780 3780 3450 3507 3509 3452 3510 3510 3794 3509 3509 3794 3793 3509 3793 3508 3793 3794 3580 3580 3794 3795 3510 3795 3794 3793 3580 3582 3582 3856 3793 3508 3793 3856 3582 3855 3856 3508 3856 3486 3486 3856 3855 3486 3507 3508 3486 3506 3507 3506 3758 3507 3507 3758 3757 3507 3757 3778 3780 3507 3778 3485 3506 3486 3506 3485 3758 3485 3486 3487 3771 3485 3770 3770 3485 3487 3758 3485 3771 3487 3486 3488 3487 3488 3489 3770 3487 3768 3768 3487 3489 3768 3769 3770 3770 3769 3760 3770 3760 3771 3771 3760 3758 3759 3758 3760 3674 3759 3760 3674 3760 3676 3676 3760 3769 3768 3765 3769 3676 3769 3678 3678 3769 3765 3675 3674 3676 3675 3676 3677 3677 3676 3678 3673 3672 3674 3673 3674 3675 3672 3759 3674 3587 3673 3675 3587 3675 3589 3589 3675 3677 3677 3678 3679 3589 3677 3590 3590 3677 3679 3587 3589 3588 3588 3589 3590 3586 3585 3587 3586 3587 3588 3585 3673 3587 3584 3585 3586 3588 3851 3586 3851 3852 3586 3586 3852 3853 3586 3853 3584 3584 3583 3585 3583 3671 3585 3585 3671 3673 3582 3581 3583 3582 3583 3584 3581 3669 3583 3583 3669 3671 3669 3670 3671 3671 3670 3672 3671 3672 3673 3667 3668 3669 3669 3668 3670 3581 3667 3669 3580 3579 3581 3580 3581 3582 3579 3667 3581 3584 3855 3582 3853 3854 3584 3584 3854 3855 3486 3855 3854 3488 3486 3854 3854 3853 3488 3488 3853 3852 3489 3488 3490 3488 3852 3490 3852 3851 3490 3489 3490 3491 3491 3490 3492 3490 3851 3850 3490 3850 3492 3768 3489 3767 3767 3489 3491 3491 3492 3470 3767 3491 3766 3766 3491 3470 3766 3763 3767 3767 3763 3765 3767 3765 3768 3470 3469 3766 3766 3469 3763 3468 3469 3470 3470 3492 3456 3470 3456 3468 3763 3469 3761 3761 3469 3468 3761 3762 3763 3763 3762 3764 3763 3764 3765 3678 3765 3680 3680 3765 3764 3680 3764 3681 3681 3764 3762 3681 3762 3761 3632 3680 3681 3632 3681 3633 3633 3681 3761 3679 3678 3680 3679 3680 3632 3632 3633 3634 3592 3679 3632 3592 3632 3594 3594 3632 3634 3590 3679 3592 3591 3590 3592 3591 3592 3593 3593 3592 3594 3593 3594 3595 3595 3594 3596 3594 3634 3596 3595 3845 3593 3845 3846 3593 3593 3846 3847 3593 3847 3591 3595 3844 3845 3846 3845 3457 3457 3845 3844 3456 3847 3846 3456 3846 3457 3847 3848 3591 3848 3847 3456 3456 3457 3458 3468 3456 3458 3492 3848 3456 3591 3848 3849 3492 3849 3848 3850 3849 3492 3591 3849 3588 3849 3850 3588 3588 3590 3591 3588 3850 3851 3457 3537 3458 3537 3684 3458 3458 3684 3683 3458 3683 3791 3791 3792 3458 3458 3792 3468 3457 3536 3537 3537 3536 3684 3535 3536 3457 3457 3844 3535 3535 3534 3536 3689 3536 3690 3690 3536 3534 3684 3536 3689 3533 3532 3534 3533 3534 3535 3690 3534 3693 3693 3534 3532 3484 3532 3533 3535 3842 3533 3533 3842 3841 3533 3841 3484 3484 3531 3532 3693 3532 3692 3692 3532 3531 3692 3685 3693 3693 3685 3694 3693 3694 3690 3691 3686 3692 3692 3686 3685 3692 3531 3691 3455 3531 3484 3691 3531 3455 3455 3454 3691 3691 3454 3686 3685 3686 3687 3687 3686 3688 3686 3454 3688 3453 3454 3455 3688 3454 3453 3482 3453 3455 3482 3455 3483 3483 3455 3484 3481 3453 3482 3688 3453 3789 3789 3453 3790 3790 3453 3481 3688 3789 3774 3774 3789 3790 3774 3790 3775 3775 3790 3788 3790 3481 3788 3645 3688 3774 3774 3775 3645 3645 3775 3697 3775 3788 3697 3481 3697 3788 3697 3698 3699 3645 3697 3647 3647 3697 3699 3481 3698 3697 3699 3698 3700 3647 3699 3649 3649 3699 3700 3646 3645 3647 3646 3647 3648 3648 3647 3649 3648 3649 3650 3650 3649 3651 3649 3700 3651 3539 3646 3648 3539 3648 3541 3541 3648 3650 3644 3645 3646 3605 3644 3646 3605 3646 3539 3538 3539 3540 3540 3539 3541 3538 3605 3539 3540 3541 3542 3542 3541 3543 3541 3650 3543 3542 3831 3540 3831 3832 3540 3540 3832 3833 3540 3833 3538 3542 3830 3831 3832 3831 3467 3467 3831 3830 3466 3833 3832 3466 3832 3467 3833 3834 3538 3834 3833 3466 3538 3834 3835 3466 3835 3834 3538 3835 3603 3835 3836 3603 3482 3836 3835 3482 3835 3466 3603 3836 3837 3837 3836 3482 3601 3602 3603 3603 3602 3604 3603 3604 3538 3603 3837 3601 3837 3838 3601 3483 3838 3837 3483 3837 3482 3466 3481 3482 3465 3466 3467 3465 3480 3466 3466 3480 3481 3480 3698 3481 3480 3465 3698 3467 3530 3465 3711 3465 3710 3710 3465 3530 3698 3465 3711 3528 3529 3467 3467 3529 3530 3467 3830 3528 3710 3530 3708 3708 3530 3529 3708 3709 3710 3710 3709 3700 3710 3700 3711 3711 3700 3698 3651 3700 3709 3708 3705 3709 3651 3709 3653 3653 3709 3705 3707 3705 3708 3708 3529 3707 3703 3704 3705 3707 3703 3705 3653 3705 3655 3655 3705 3704 3652 3651 3653 3652 3653 3654 3654 3653 3655 3650 3651 3652 3543 3650 3652 3543 3652 3545 3545 3652 3654 3654 3655 3606 3545 3654 3547 3547 3654 3606 3606 3655 3656 3655 3704 3656 3606 3656 3607 3656 3704 3702 3656 3702 3607 3606 3607 3608 3607 3702 3701 3607 3701 3608 3701 3702 3703 3703 3702 3704 3706 3703 3707 3703 3478 3701 3706 3478 3703 3707 3527 3706 3706 3527 3479 3479 3478 3706 3707 3529 3527 3526 3479 3527 3526 3527 3528 3528 3527 3529 3477 3478 3479 3525 3477 3479 3525 3479 3526 3701 3478 3477 3524 3523 3477 3524 3477 3525 3701 3477 3787 3523 3787 3477 3526 3826 3525 3525 3826 3825 3525 3825 3524 3499 3523 3524 3524 3825 3824 3524 3824 3499 3548 3824 3825 3548 3825 3546 3825 3826 3546 3546 3826 3827 3526 3827 3826 3544 3545 3546 3546 3545 3547 3546 3547 3548 3546 3827 3544 3827 3828 3544 3828 3827 3526 3528 3828 3526 3544 3828 3829 3528 3829 3828 3542 3543 3544 3544 3543 3545 3544 3829 3542 3829 3830 3542 3830 3829 3528 3548 3547 3549 3548 3549 3550 3550 3823 3548 3823 3824 3548 3550 3549 3551 3547 3606 3549 3549 3606 3609 3549 3609 3551 3550 3551 3552 3552 3551 3553 3551 3609 3611 3551 3611 3553 3606 3608 3609 3609 3608 3610 3609 3610 3611 3611 3610 3612 3611 3612 3613 3553 3611 3613 3552 3553 3554 3553 3555 3554 3553 3613 3555 3613 3612 3614 3613 3614 3615 3555 3613 3615 3610 3726 3612 3612 3726 3725 3612 3725 3614 3615 3614 3616 3614 3725 3724 3614 3724 3616 3615 3616 3617 3555 3615 3556 3556 3615 3617 3554 3555 3556 3554 3556 3557 3557 3556 3558 3556 3617 3558 3617 3616 3618 3617 3618 3619 3558 3617 3619 3616 3724 3715 3616 3715 3618 3619 3618 3620 3618 3715 3717 3618 3717 3620 3619 3620 3621 3558 3619 3560 3560 3619 3621 3557 3558 3559 3559 3558 3560 3559 3560 3561 3561 3560 3562 3560 3621 3562 3621 3620 3622 3621 3622 3623 3562 3621 3623 3561 3562 3563 3563 3562 3564 3562 3623 3564 3623 3622 3624 3623 3624 3625 3564 3623 3625 3620 3727 3622 3622 3727 3729 3622 3729 3624 3625 3624 3626 3624 3729 3730 3624 3730 3626 3625 3626 3627 3564 3625 3566 3566 3625 3627 3627 3626 3628 3626 3730 3739 3626 3739 3628 3627 3628 3629 3566 3627 3568 3568 3627 3629 3565 3564 3566 3565 3566 3567 3567 3566 3568 3567 3568 3569 3569 3568 3570 3568 3629 3570 3569 3805 3567 3805 3806 3567 3567 3806 3807 3567 3807 3565 3569 3804 3805 3496 3806 3805 3496 3805 3495 3805 3804 3495 3807 3806 3496 3807 3808 3565 3497 3808 3807 3497 3807 3496 3495 3461 3496 3496 3461 3497 3461 3515 3497 3497 3515 3516 3497 3516 3517 3517 3809 3497 3809 3808 3497 3565 3808 3809 3565 3809 3563 3809 3810 3563 3517 3810 3809 3517 3516 3518 3517 3518 3519 3519 3810 3517 3563 3810 3811 3519 3811 3810 3563 3564 3565 3563 3811 3561 3811 3812 3561 3812 3811 3519 3519 3518 3520 3519 3520 3463 3463 3812 3519 3561 3812 3813 3463 3813 3812 3561 3813 3559 3813 3814 3559 3814 3813 3463 3462 3463 3464 3463 3520 3521 3463 3521 3464 3462 3814 3463 3559 3814 3815 3462 3815 3814 3559 3815 3557 3815 3816 3557 3816 3815 3462 3557 3816 3817 3557 3817 3554 3505 3817 3816 3505 3816 3462 3817 3818 3554 3818 3817 3505 3554 3818 3819 3554 3819 3552 3503 3819 3818 3503 3818 3505 3504 3503 3505 3504 3505 3476 3476 3505 3462 3502 3501 3503 3502 3503 3504 3501 3820 3503 3820 3819 3503 3819 3820 3552 3552 3820 3821 3552 3821 3550 3501 3821 3820 3500 3499 3501 3500 3501 3502 3499 3822 3501 3822 3821 3501 3821 3822 3550 3550 3822 3823 3499 3823 3822 3498 3499 3500 3498 3522 3499 3499 3522 3523 3824 3823 3499 3719 3498 3720 3720 3498 3500 3522 3498 3714 3714 3498 3719 3522 3714 3523 3523 3714 3713 3523 3713 3786 3786 3787 3523 3713 3787 3786 3712 3713 3714 3701 3713 3608 3608 3713 3712 3701 3787 3713 3714 3726 3712 3608 3712 3610 3610 3712 3726 3714 3725 3726 3720 3724 3725 3720 3725 3714 3723 3715 3724 3723 3724 3720 3722 3715 3723 3720 3500 3723 3723 3500 3502 3723 3502 3722 3715 3716 3717 3722 3716 3715 3721 3716 3722 3722 3502 3504 3722 3504 3721 3717 3716 3718 3716 3475 3718 3721 3475 3716 3620 3717 3718 3620 3718 3776 3718 3475 3474 3718 3474 3784 3718 3784 3776 3474 3475 3476 3476 3475 3721 3721 3504 3476 3476 3462 3474 3474 3462 3464 3784 3474 3785 3785 3474 3464 3776 3784 3785 3776 3777 3620 3776 3785 3777 3620 3777 3727 3777 3785 3783 3777 3783 3727 3785 3464 3783 3521 3728 3464 3464 3728 3727 3464 3727 3783 3727 3728 3729 3729 3728 3730 3741 3730 3728 3521 3520 3728 3728 3520 3741 3740 3739 3730 3740 3730 3741 3741 3520 3740 3740 3520 3518 3738 3739 3740 3740 3518 3738 3738 3735 3739 3628 3739 3735 3737 3735 3738 3738 3518 3516 3738 3516 3737 3733 3734 3735 3737 3733 3735 3628 3735 3630 3630 3735 3734 3629 3628 3630 3629 3630 3631 3630 3657 3631 3630 3734 3657 3733 3732 3734 3657 3734 3732 3631 3657 3658 3658 3657 3731 3657 3732 3731 3731 3732 3733 3731 3743 3658 3733 3460 3731 3731 3460 3459 3731 3459 3782 3731 3782 3743 3459 3460 3461 3461 3460 3736 3736 3460 3733 3494 3459 3495 3495 3459 3461 3494 3782 3459 3743 3782 3781 3781 3782 3494 3494 3743 3781 3472 3493 3494 3472 3494 3495 3493 3744 3494 3494 3744 3743 3495 3804 3803 3495 3803 3472 3803 3804 3569 3571 3802 3803 3571 3803 3569 3472 3803 3802 3569 3570 3571 3570 3572 3571 3570 3629 3631 3570 3631 3572 3571 3572 3573 3572 3631 3659 3572 3659 3573 3631 3658 3659 3659 3658 3660 3659 3660 3661 3573 3659 3661 3571 3573 3574 3574 3573 3575 3573 3661 3575 3661 3660 3662 3661 3662 3663 3575 3661 3663 3658 3742 3660 3660 3742 3756 3660 3756 3662 3658 3743 3742 3742 3743 3744 3744 3756 3742 3744 3755 3756 3662 3756 3755 3663 3662 3664 3662 3755 3664 3750 3754 3755 3750 3755 3744 3664 3755 3754 3744 3749 3750 3493 3471 3744 3744 3471 3749 3749 3471 3750 3753 3754 3750 3750 3471 3514 3750 3514 3753 3753 3745 3754 3664 3754 3666 3666 3754 3745 3752 3745 3753 3753 3514 3513 3753 3513 3752 3473 3513 3514 3473 3514 3471 3471 3472 3473 3471 3493 3472 3512 3513 3473 3472 3800 3473 3800 3799 3473 3473 3799 3798 3473 3798 3512 3512 3511 3513 3752 3513 3511 3510 3452 3511 3510 3511 3512 3752 3511 3751 3751 3511 3452 3512 3796 3510 3796 3795 3510 3795 3796 3578 3578 3796 3797 3512 3797 3796 3580 3795 3578 3576 3577 3578 3578 3577 3579 3578 3579 3580 3578 3797 3576 3797 3798 3576 3798 3797 3512 3576 3798 3799 3574 3575 3576 3576 3575 3577 3576 3799 3574 3799 3800 3574 3574 3800 3801 3574 3801 3571 3472 3801 3800 3801 3802 3571 3802 3801 3472 3575 3663 3577 3577 3663 3665 3577 3665 3579 3663 3664 3665 3665 3664 3666 3665 3666 3667 3579 3665 3667 3667 3666 3668 3666 3745 3668 3668 3745 3747 3668 3747 3670 3745 3746 3747 3752 3746 3745 3747 3746 3748 3670 3747 3748 3772 3773 3670 3670 3773 3757 3670 3757 3672 3670 3748 3772 3746 3451 3748 3748 3779 3772 3772 3779 3780 3772 3780 3773 3773 3780 3778 3773 3778 3757 3757 3758 3759 3672 3757 3759 3452 3451 3751 3751 3451 3746 3751 3746 3752 3736 3515 3461 3736 3733 3737 3737 3515 3736 3737 3516 3515 3714 3719 3720 3484 3839 3483 3839 3838 3483 3841 3840 3484 3484 3840 3839 3601 3838 3839 3601 3839 3599 3839 3840 3599 3599 3840 3841 3599 3841 3597 3841 3842 3597 3597 3598 3599 3599 3598 3600 3599 3600 3601 3601 3600 3602 3598 3638 3600 3600 3638 3640 3600 3640 3602 3597 3596 3598 3596 3636 3598 3598 3636 3638 3636 3637 3638 3638 3637 3639 3638 3639 3640 3640 3639 3641 3640 3641 3642 3602 3640 3642 3602 3642 3604 3642 3641 3643 3642 3643 3644 3604 3642 3644 3639 3694 3641 3641 3694 3685 3641 3685 3643 3637 3695 3639 3639 3695 3694 3690 3694 3695 3690 3695 3684 3684 3695 3696 3637 3696 3695 3684 3689 3690 3682 3683 3684 3684 3696 3682 3635 3682 3696 3635 3696 3637 3636 3635 3637 3634 3633 3635 3634 3635 3636 3633 3682 3635 3633 3683 3682 3761 3683 3633 3761 3792 3683 3683 3792 3791 3761 3468 3792 3596 3634 3636 3595 3596 3597 3597 3843 3595 3843 3844 3595 3597 3842 3843 3844 3843 3535 3535 3843 3842 3644 3643 3645 3643 3685 3687 3643 3687 3645 3604 3644 3605 3538 3604 3605 3645 3687 3688))
                   (list :vertices (let ((mat (make-matrix 3857 3))) (fvector-replace (array-entity mat) #f(1.1625300598144531e+02 -3.0976199340820312e+02 2.2615299987792969e+02 1.1591500091552734e+02 -3.0937399291992188e+02 2.2562100219726562e+02 1.1795999908447266e+02 -3.0989398193359375e+02 2.2516799926757812e+02 1.1763800048828125e+02 -3.0950497436523438e+02 2.2461999511718750e+02 1.1976000213623047e+02 -3.1017102050781250e+02 2.2440600585937500e+02 1.1983200073242188e+02 -3.0984899902343750e+02 2.2370399475097656e+02 1.2161800384521484e+02 -3.1058801269531250e+02 2.2388299560546875e+02 1.2210199737548828e+02 -3.1038800048828125e+02 2.2312500000000000e+02 1.2349600219726562e+02 -3.1113601684570312e+02 2.2360899353027344e+02 1.2438400268554688e+02 -3.1110598754882812e+02 2.2289900207519531e+02 1.2535400390625000e+02 -3.1180300903320312e+02 2.2359100341796875e+02 1.2550400543212891e+02 -3.1152499389648438e+02 2.2292100524902344e+02 1.3305599975585938e+02 -3.2426800537109375e+02 2.4306201171875000e+02 1.3280799865722656e+02 -3.2432699584960938e+02 2.4336299133300781e+02 1.3228700256347656e+02 -3.2395397949218750e+02 2.4299200439453125e+02 1.3439799499511719e+02 -3.2379598999023438e+02 2.4112500000000000e+02 1.3344700622558594e+02 -3.2360198974609375e+02 2.4143299865722656e+02 1.3541699218750000e+02 -3.2313699340820312e+02 2.3905099487304688e+02 1.3438400268554688e+02 -3.2311599731445312e+02 2.3976499938964844e+02 1.3508000183105469e+02 -3.2250299072265625e+02 2.3802099609375000e+02 1.3608599853515625e+02 -3.2231100463867188e+02 2.3689599609375000e+02 1.3551998901367188e+02 -3.2177798461914062e+02 2.3623699951171875e+02 1.3638499450683594e+02 -3.2133999633789062e+02 2.3471800231933594e+02 1.3569499206542969e+02 -3.2095599365234375e+02 2.3445098876953125e+02 1.3639900207519531e+02 -3.2116799926757812e+02 2.3436300659179688e+02 1.2668099975585938e+02 -3.2508901977539062e+02 2.4606298828125000e+02 1.2646399688720703e+02 -3.2478500366210938e+02 2.4556500244140625e+02 1.2738899993896484e+02 -3.2486901855468750e+02 2.4505700683593750e+02 1.3205300903320312e+02 -3.2510598754882812e+02 2.4257699584960938e+02 1.3252799987792969e+02 -3.2509698486328125e+02 2.4298001098632812e+02 1.3186100769042969e+02 -3.2522299194335938e+02 2.4372200012207031e+02 1.3157800292968750e+02 -3.2495700073242188e+02 2.4220399475097656e+02 1.3141099548339844e+02 -3.2522698974609375e+02 2.4329200744628906e+02 1.3030599975585938e+02 -3.2515499877929688e+02 2.4353800964355469e+02 1.3054800415039062e+02 -3.2476898193359375e+02 2.4253700256347656e+02 1.3096299743652344e+02 -3.2507299804687500e+02 2.4288800048828125e+02 1.3113499450683594e+02 -3.2465802001953125e+02 2.4188500976562500e+02 1.2912300109863281e+02 -3.2490100097656250e+02 2.4384899902343750e+02 1.2959199523925781e+02 -3.2486999511718750e+02 2.4344200134277344e+02 1.2992100524902344e+02 -3.2484799194335938e+02 2.4315699768066406e+02 1.2946900939941406e+02 -3.2521099853515625e+02 2.4426300048828125e+02 1.2858100891113281e+02 -3.2521798706054688e+02 2.4492900085449219e+02 1.2827700805664062e+02 -3.2490798950195312e+02 2.4448400878906250e+02 1.2783500671386719e+02 -3.2488800048828125e+02 2.4476901245117188e+02 1.2764999389648438e+02 -3.2517800903320312e+02 2.4552999877929688e+02 1.2590900421142578e+02 -3.2471002197265625e+02 2.4582099914550781e+02 1.2568099975585938e+02 -3.2495401000976562e+02 2.4652400207519531e+02 1.2551100921630859e+02 -3.2465600585937500e+02 2.4600399780273438e+02 1.2465599822998047e+02 -3.2477200317382812e+02 2.4690901184082031e+02 1.2453400421142578e+02 -3.2448199462890625e+02 2.4637100219726562e+02 1.2387100219726562e+02 -3.2433798217773438e+02 2.4656700134277344e+02 1.2361499786376953e+02 -3.2454498291015625e+02 2.4721600341796875e+02 1.2354000091552734e+02 -3.2426599121093750e+02 2.4666400146484375e+02 1.2256299591064453e+02 -3.2427499389648438e+02 2.4744300842285156e+02 1.2253700256347656e+02 -3.2400799560546875e+02 2.4688099670410156e+02 1.2178199768066406e+02 -3.2378500366210938e+02 2.4698500061035156e+02 1.2150800323486328e+02 -3.2396298217773438e+02 2.4758799743652344e+02 1.2153199768066406e+02 -3.2371099853515625e+02 2.4701899719238281e+02 1.2045800018310547e+02 -3.2361199951171875e+02 2.4765100097656250e+02 1.2052999877929688e+02 -3.2337600708007812e+02 2.4707899475097656e+02 1.1970099639892578e+02 -3.2306600952148438e+02 2.4706300354003906e+02 1.1941899871826172e+02 -3.2322399902343750e+02 2.4763000488281250e+02 1.1953900146484375e+02 -3.2300601196289062e+02 2.4705999755859375e+02 1.1839900207519531e+02 -3.2280099487304688e+02 2.4752700805664062e+02 1.1856600189208984e+02 -3.2260299682617188e+02 2.4696099853515625e+02 1.3114799499511719e+02 -3.2531298828125000e+02 2.4442599487304688e+02 1.3072399902343750e+02 -3.2531399536132812e+02 2.4397000122070312e+02 1.3024101257324219e+02 -3.2537298583984375e+02 2.4521299743652344e+02 1.2985000610351562e+02 -3.2537200927734375e+02 2.4472799682617188e+02 1.2927900695800781e+02 -3.2538101196289062e+02 2.4593499755859375e+02 1.2892300415039062e+02 -3.2538000488281250e+02 2.4542399597167969e+02 1.2826899719238281e+02 -3.2533700561523438e+02 2.4658699035644531e+02 1.2794999694824219e+02 -3.2533700561523438e+02 2.4605200195312500e+02 1.2721900939941406e+02 -3.2524099731445312e+02 2.4716400146484375e+02 1.2693800354003906e+02 -3.2524499511718750e+02 2.4660800170898438e+02 1.2613500976562500e+02 -3.2509402465820312e+02 2.4766300964355469e+02 1.2589399719238281e+02 -3.2510302734375000e+02 2.4708900451660156e+02 1.2502400207519531e+02 -3.2489700317382812e+02 2.4808099365234375e+02 1.2482400512695312e+02 -3.2491299438476562e+02 2.4749099731445312e+02 1.2389499664306641e+02 -3.2465100097656250e+02 2.4841299438476562e+02 1.2373600006103516e+02 -3.2467700195312500e+02 2.4781199645996094e+02 1.2275499725341797e+02 -3.2435797119140625e+02 2.4866000366210938e+02 1.2263700103759766e+02 -3.2439498901367188e+02 2.4804901123046875e+02 1.2161199951171875e+02 -3.2401998901367188e+02 2.4881700134277344e+02 1.2153600311279297e+02 -3.2406900024414062e+02 2.4820100402832031e+02 1.2047299957275391e+02 -3.2363998413085938e+02 2.4888500976562500e+02 1.2043900299072266e+02 -3.2370199584960938e+02 2.4826599121093750e+02 1.1934700012207031e+02 -3.2321899414062500e+02 2.4886299133300781e+02 1.1935299682617188e+02 -3.2329602050781250e+02 2.4824499511718750e+02 1.1824099731445312e+02 -3.2276098632812500e+02 2.4875100708007812e+02 1.1828800201416016e+02 -3.2285498046875000e+02 2.4813699340820312e+02 1.1716199493408203e+02 -3.2226800537109375e+02 2.4855000305175781e+02 1.1724800109863281e+02 -3.2238098144531250e+02 2.4794299316406250e+02 1.1611899566650391e+02 -3.2174499511718750e+02 2.4826100158691406e+02 1.1624299621582031e+02 -3.2187597656250000e+02 2.4766500854492188e+02 1.1511199951171875e+02 -3.2119100952148438e+02 2.4788400268554688e+02 1.1527299499511719e+02 -3.2134301757812500e+02 2.4730200195312500e+02 1.1740399932861328e+02 -3.2234698486328125e+02 2.4734100341796875e+02 1.1644099426269531e+02 -3.2186401367187500e+02 2.4707501220703125e+02 1.1551200103759766e+02 -3.2135400390625000e+02 2.4672700500488281e+02 1.1769200134277344e+02 -3.2220397949218750e+02 2.4679798889160156e+02 1.1761700439453125e+02 -3.2216998291015625e+02 2.4678399658203125e+02 1.1669900512695312e+02 -3.2170901489257812e+02 2.4652999877929688e+02 1.1581300354003906e+02 -3.2122201538085938e+02 2.4619799804687500e+02 1.1796600341796875e+02 -3.2144998168945312e+02 2.4717498779296875e+02 1.1608800506591797e+02 -3.2046801757812500e+02 2.4657299804687500e+02 1.1997499847412109e+02 -3.2231399536132812e+02 2.4744300842285156e+02 1.2205599975585938e+02 -3.2303399658203125e+02 2.4736698913574219e+02 1.2414799499511719e+02 -3.2358801269531250e+02 2.4694900512695312e+02 1.2618699645996094e+02 -3.2396099853515625e+02 2.4620401000976562e+02 1.2811500549316406e+02 -3.2414001464843750e+02 2.4515100097656250e+02 1.2987298583984375e+02 -3.2412100219726562e+02 2.4382301330566406e+02 1.3140901184082031e+02 -3.2390402221679688e+02 2.4225900268554688e+02 1.3405500793457031e+02 -3.1954199218750000e+02 2.2947500610351562e+02 1.3349699401855469e+02 -3.1949499511718750e+02 2.2974600219726562e+02 1.3310000610351562e+02 -3.1894699096679688e+02 2.2893301391601562e+02 1.2501500701904297e+02 -3.1277099609375000e+02 2.2288200378417969e+02 1.2522299957275391e+02 -3.1229498291015625e+02 2.2253898620605469e+02 1.2633599090576172e+02 -3.1275601196289062e+02 2.2265100097656250e+02 1.2483999633789062e+02 -3.1314700317382812e+02 2.2334700012207031e+02 1.2608699798583984e+02 -3.1321499633789062e+02 2.2299000549316406e+02 1.2686100769042969e+02 -3.1402600097656250e+02 2.2363600158691406e+02 1.2568700408935547e+02 -3.1380099487304688e+02 2.2400100708007812e+02 1.2586599731445312e+02 -3.1357199096679688e+02 2.2345001220703125e+02 1.2470899963378906e+02 -3.1339599609375000e+02 2.2390200805664062e+02 1.2874699401855469e+02 -3.1501599121093750e+02 2.2424800109863281e+02 1.2755400085449219e+02 -3.1469400024414062e+02 2.2443200683593750e+02 1.2782398986816406e+02 -3.1450799560546875e+02 2.2390200805664062e+02 1.2670899963378906e+02 -3.1427099609375000e+02 2.2419799804687500e+02 1.2663600158691406e+02 -3.1423397827148438e+02 2.2417799377441406e+02 1.3045300292968750e+02 -3.1609298706054688e+02 2.2516700744628906e+02 1.2927299499511719e+02 -3.1568399047851562e+02 2.2516400146484375e+02 1.2962600708007812e+02 -3.1554602050781250e+02 2.2467100524902344e+02 1.2857200622558594e+02 -3.1526101684570312e+02 2.2482800292968750e+02 1.2843499755859375e+02 -3.1517898559570312e+02 2.2476199340820312e+02 1.3193200683593750e+02 -3.1722702026367188e+02 2.2636700439453125e+02 1.3079699707031250e+02 -3.1674099731445312e+02 2.2617800903320312e+02 1.3122399902343750e+02 -3.1665499877929688e+02 2.2573399353027344e+02 1.3024499511718750e+02 -3.1633898925781250e+02 2.2577198791503906e+02 1.3006199645996094e+02 -3.1620599365234375e+02 2.2563800048828125e+02 1.3208399963378906e+02 -3.1783898925781250e+02 2.2744599914550781e+02 1.3167601013183594e+02 -3.1747100830078125e+02 2.2700401306152344e+02 1.3147200012207031e+02 -3.1728698730468750e+02 2.2678300476074219e+02 1.3257400512695312e+02 -3.1780599975585938e+02 2.2706300354003906e+02 1.3314401245117188e+02 -3.1838699340820312e+02 2.2781700134277344e+02 1.3262799072265625e+02 -3.1839300537109375e+02 2.2816499328613281e+02 1.3282499694824219e+02 -3.1862500000000000e+02 2.2848600769042969e+02 1.3363899230957031e+02 -3.1896701049804688e+02 2.2862200927734375e+02 1.3365699768066406e+02 -3.1976602172851562e+02 2.3017500305175781e+02 1.3438999938964844e+02 -3.2010702514648438e+02 2.3036900329589844e+02 1.3381600952148438e+02 -3.2003399658203125e+02 2.3059800720214844e+02 1.3464100646972656e+02 -3.2066000366210938e+02 2.3129800415039062e+02 1.3405599975585938e+02 -3.2055999755859375e+02 2.3148399353027344e+02 1.2741400146484375e+02 -3.1324801635742188e+02 2.2285301208496094e+02 1.2712599182128906e+02 -3.1369000244140625e+02 2.2318400573730469e+02 1.2845799255371094e+02 -3.1377099609375000e+02 2.2314199829101562e+02 1.2813200378417969e+02 -3.1419400024414062e+02 2.2346200561523438e+02 1.2945899963378906e+02 -3.1432199096679688e+02 2.2351600646972656e+02 1.2909700012207031e+02 -3.1472399902343750e+02 2.2382299804687500e+02 1.3041200256347656e+02 -3.1489599609375000e+02 2.2397399902343750e+02 1.3001400756835938e+02 -3.1527700805664062e+02 2.2426499938964844e+02 1.3130799865722656e+02 -3.1548898315429688e+02 2.2451199340820312e+02 1.3087800598144531e+02 -3.1584899902343750e+02 2.2478300476074219e+02 1.3214399719238281e+02 -3.1609799194335938e+02 2.2512699890136719e+02 1.3168301391601562e+02 -3.1643499755859375e+02 2.2537500000000000e+02 1.3291200256347656e+02 -3.1671801757812500e+02 2.2581399536132812e+02 1.3242300415039062e+02 -3.1703298950195312e+02 2.2603700256347656e+02 1.3360699462890625e+02 -3.1734600830078125e+02 2.2656799316406250e+02 1.3309300231933594e+02 -3.1763800048828125e+02 2.2676399230957031e+02 1.3422499084472656e+02 -3.1797601318359375e+02 2.2738499450683594e+02 1.3368899536132812e+02 -3.1824499511718750e+02 2.2755099487304688e+02 1.3476200866699219e+02 -3.1860501098632812e+02 2.2825799560546875e+02 1.3420599365234375e+02 -3.1885098266601562e+02 2.2839199829101562e+02 1.3521299743652344e+02 -3.1922799682617188e+02 2.2918200683593750e+02 1.3464100646972656e+02 -3.1945101928710938e+02 2.2928300476074219e+02 1.3557598876953125e+02 -3.1984002685546875e+02 2.3015100097656250e+02 1.3499000549316406e+02 -3.2004101562500000e+02 2.3021600341796875e+02 1.3584800720214844e+02 -3.2043902587890625e+02 2.3115800476074219e+02 1.3525299072265625e+02 -3.2061801147460938e+02 2.3118600463867188e+02 1.3602799987792969e+02 -3.2101898193359375e+02 2.3219599914550781e+02 1.3542599487304688e+02 -3.2117700195312500e+02 2.3218600463867188e+02 1.3610600280761719e+02 -3.2148800659179688e+02 2.3308200073242188e+02 1.3550099182128906e+02 -3.2162899780273438e+02 2.3304000854492188e+02 1.3611799621582031e+02 -3.2193801879882812e+02 2.3398100280761719e+02 1.3551298522949219e+02 -3.2206298828125000e+02 2.3390600585937500e+02 1.3480700683593750e+02 -3.2119500732421875e+02 2.3225498962402344e+02 1.3487899780273438e+02 -3.2162698364257812e+02 2.3307299804687500e+02 1.3489100646972656e+02 -3.2204299926757812e+02 2.3390200805664062e+02 1.3414900207519531e+02 -3.2085998535156250e+02 2.3202101135253906e+02 1.3421400451660156e+02 -3.2107098388671875e+02 2.3239700317382812e+02 1.3428300476074219e+02 -3.2148297119140625e+02 2.3317700195312500e+02 1.3429299926757812e+02 -3.2187899780273438e+02 2.3396800231933594e+02 1.3456800842285156e+02 -3.2112500000000000e+02 2.3434199523925781e+02 1.3443299865722656e+02 -3.2010800170898438e+02 2.3239199829101562e+02 1.3394198608398438e+02 -3.1901300048828125e+02 2.3054499816894531e+02 1.3310900878906250e+02 -3.1787100219726562e+02 2.2885400390625000e+02 1.3195799255371094e+02 -3.1671597290039062e+02 2.2737200927734375e+02 1.3052499389648438e+02 -3.1558297729492188e+02 2.2614001464843750e+02 1.2884999084472656e+02 -3.1450598144531250e+02 2.2519700622558594e+02 1.2698500061035156e+02 -3.1351501464843750e+02 2.2456900024414062e+02 1.2498299407958984e+02 -3.1264099121093750e+02 2.2427600097656250e+02 1.1575700378417969e+02 -3.2024700927734375e+02 2.4764601135253906e+02 1.1539199829101562e+02 -3.2042102050781250e+02 2.4826599121093750e+02 1.1422599792480469e+02 -3.1929202270507812e+02 2.4684500122070312e+02 1.1444499969482422e+02 -3.1985101318359375e+02 2.4781001281738281e+02 1.1286499786376953e+02 -3.1828900146484375e+02 2.4582299804687500e+02 1.1271300506591797e+02 -3.1864801025390625e+02 2.4665800476074219e+02 1.1170300292968750e+02 -3.1726101684570312e+02 2.4460198974609375e+02 1.1125000000000000e+02 -3.1740100097656250e+02 2.4521699523925781e+02 1.1076300048828125e+02 -3.1622601318359375e+02 2.4320698547363281e+02 1.1009500122070312e+02 -3.1614199829101562e+02 2.4352600097656250e+02 1.1006400299072266e+02 -3.1520700073242188e+02 2.4166700744628906e+02 1.0939399719238281e+02 -3.1511199951171875e+02 2.4196598815917969e+02 1.0911299896240234e+02 -3.1588198852539062e+02 2.4158399963378906e+02 1.0901599884033203e+02 -3.1567800903320312e+02 2.4124499511718750e+02 1.0949300384521484e+02 -3.1622799682617188e+02 2.4123199462890625e+02 1.0912200164794922e+02 -3.1545199584960938e+02 2.3994099426269531e+02 1.0997900390625000e+02 -3.1645599365234375e+02 2.4091499328613281e+02 1.1019799804687500e+02 -3.1584298706054688e+02 2.3947801208496094e+02 1.1053600311279297e+02 -3.1655200195312500e+02 2.4065600585937500e+02 1.0962300109863281e+02 -3.1571298217773438e+02 2.3968000793457031e+02 1.1007999420166016e+02 -3.1546301269531250e+02 2.3879699707031250e+02 1.0945800018310547e+02 -3.1517800903320312e+02 2.3872200012207031e+02 1.1004000091552734e+02 -3.1533300781250000e+02 2.3856500244140625e+02 1.0937800598144531e+02 -3.1466299438476562e+02 2.3774301147460938e+02 1.0996399688720703e+02 -3.1484197998046875e+02 2.3763099670410156e+02 1.0997000122070312e+02 -3.1445300292968750e+02 2.3684300231933594e+02 1.0938599395751953e+02 -3.1417199707031250e+02 2.3674800109863281e+02 1.0997200012207031e+02 -3.1437399291992188e+02 2.3668199157714844e+02 1.0948100280761719e+02 -3.1370898437500000e+02 2.3574400329589844e+02 1.1006200408935547e+02 -3.1393200683593750e+02 2.3572500610351562e+02 1.1022100067138672e+02 -3.1355398559570312e+02 2.3484700012207031e+02 1.0966300201416016e+02 -3.1327600097656250e+02 2.3473899841308594e+02 1.1023500061035156e+02 -3.1351901245117188e+02 2.3476600646972656e+02 1.0993000030517578e+02 -3.1287701416015625e+02 2.3373899841308594e+02 1.1049000549316406e+02 -3.1313897705078125e+02 2.3381300354003906e+02 1.1027999877929688e+02 -3.1251400756835938e+02 2.3275099182128906e+02 1.1082399749755859e+02 -3.1279199218750000e+02 2.3286999511718750e+02 1.1071099853515625e+02 -3.1219000244140625e+02 2.3178199768066406e+02 1.1123400115966797e+02 -3.1248300170898438e+02 2.3194599914550781e+02 1.1122000122070312e+02 -3.1190600585937500e+02 2.3083700561523438e+02 1.1172000122070312e+02 -3.1221301269531250e+02 2.3104499816894531e+02 1.1176699829101562e+02 -3.1219400024414062e+02 2.3097200012207031e+02 1.1180300140380859e+02 -3.1166601562500000e+02 2.2992500305175781e+02 1.1227600097656250e+02 -3.1198400878906250e+02 2.3017500305175781e+02 1.1245700073242188e+02 -3.1147000122070312e+02 2.2905099487304688e+02 1.1289999389648438e+02 -3.1179699707031250e+02 2.2934199523925781e+02 1.1301699829101562e+02 -3.1177301025390625e+02 2.2920700073242188e+02 1.1317700195312500e+02 -3.1132000732421875e+02 2.2822000122070312e+02 1.1358699798583984e+02 -3.1165399169921875e+02 2.2855000305175781e+02 1.1395899963378906e+02 -3.1121701049804688e+02 2.2744000244140625e+02 1.1433200073242188e+02 -3.1155599975585938e+02 2.2780500793457031e+02 1.0872799682617188e+02 -3.1507699584960938e+02 2.4024400329589844e+02 1.0854899597167969e+02 -3.1449700927734375e+02 2.3920599365234375e+02 1.0894899749755859e+02 -3.1489300537109375e+02 2.3894099426269531e+02 1.0846299743652344e+02 -3.1393899536132812e+02 2.3814498901367188e+02 1.0886599731445312e+02 -3.1435498046875000e+02 2.3791799926757812e+02 1.0847100067138672e+02 -3.1340701293945312e+02 2.3706599426269531e+02 1.0887500000000000e+02 -3.1384201049804688e+02 2.3687901306152344e+02 1.0857400512695312e+02 -3.1290399169921875e+02 2.3597801208496094e+02 1.0897399902343750e+02 -3.1335800170898438e+02 2.3583100891113281e+02 1.0877099609375000e+02 -3.1243499755859375e+02 2.3488900756835938e+02 1.0916400146484375e+02 -3.1290600585937500e+02 2.3478099060058594e+02 1.0905999755859375e+02 -3.1200201416015625e+02 2.3380500793457031e+02 1.0944200134277344e+02 -3.1248901367187500e+02 2.3373599243164062e+02 1.0944000244140625e+02 -3.1160900878906250e+02 2.3273399353027344e+02 1.0980799865722656e+02 -3.1211001586914062e+02 2.3270399475097656e+02 1.0990699768066406e+02 -3.1125799560546875e+02 2.3168299865722656e+02 1.1025799560546875e+02 -3.1177200317382812e+02 2.3169200134277344e+02 1.1045899963378906e+02 -3.1095098876953125e+02 2.3065899658203125e+02 1.1078900146484375e+02 -3.1147598266601562e+02 2.3070600891113281e+02 1.1109100341796875e+02 -3.1068997192382812e+02 2.2966999816894531e+02 1.1139900207519531e+02 -3.1122500610351562e+02 2.2975300598144531e+02 1.1180000305175781e+02 -3.1047799682617188e+02 2.2872200012207031e+02 1.1208200073242188e+02 -3.1101998901367188e+02 2.2883999633789062e+02 1.1258100128173828e+02 -3.1031500244140625e+02 2.2782200622558594e+02 1.1283399963378906e+02 -3.1086401367187500e+02 2.2797200012207031e+02 1.1342799377441406e+02 -3.1020401000976562e+02 2.2697601318359375e+02 1.1365000152587891e+02 -3.1075601196289062e+02 2.2715699768066406e+02 1.1433599853515625e+02 -3.1014401245117188e+02 2.2618899536132812e+02 1.1452500152587891e+02 -3.1069799804687500e+02 2.2639900207519531e+02 1.1529699707031250e+02 -3.1013500976562500e+02 2.2546800231933594e+02 1.1545199584960938e+02 -3.1069100952148438e+02 2.2570399475097656e+02 1.1563500213623047e+02 -3.1014498901367188e+02 2.2523899841308594e+02 1.1577700042724609e+02 -3.1069897460937500e+02 2.2548300170898438e+02 1.1479599761962891e+02 -3.1116198730468750e+02 2.2671400451660156e+02 1.1568299865722656e+02 -3.1115499877929688e+02 2.2604798889160156e+02 1.1599399566650391e+02 -3.1116299438476562e+02 2.2583700561523438e+02 1.1453499603271484e+02 -3.1154299926757812e+02 2.2762901306152344e+02 1.1512999725341797e+02 -3.1150299072265625e+02 2.2711299133300781e+02 1.1597699737548828e+02 -3.1149600219726562e+02 2.2647799682617188e+02 1.1627300262451172e+02 -3.1150399780273438e+02 2.2627699279785156e+02 1.1480500030517578e+02 -3.1078402709960938e+02 2.2799800109863281e+02 1.1654800415039062e+02 -3.1075000000000000e+02 2.2665100097656250e+02 1.1328700256347656e+02 -3.1101501464843750e+02 2.2957899475097656e+02 1.1203900146484375e+02 -3.1143798828125000e+02 2.3134500122070312e+02 1.1109799957275391e+02 -3.1203799438476562e+02 2.3324499511718750e+02 1.1049199676513672e+02 -3.1279901123046875e+02 2.3522200012207031e+02 1.1023899841308594e+02 -3.1369702148437500e+02 2.3721800231933594e+02 1.1034700012207031e+02 -3.1470599365234375e+02 2.3917298889160156e+02 1.1081100463867188e+02 -3.1579699707031250e+02 2.4103100585937500e+02 1.1127000427246094e+02 -3.0658099365234375e+02 2.3522900390625000e+02 1.3696701049804688e+02 -3.1887899780273438e+02 2.4116400146484375e+02 1.1228899383544922e+02 -3.0592199707031250e+02 2.3315399169921875e+02 1.1362999725341797e+02 -3.0544900512695312e+02 2.3121800231933594e+02 1.1060099792480469e+02 -3.0740698242187500e+02 2.3738400268554688e+02 1.1030200195312500e+02 -3.0837802124023438e+02 2.3956100463867188e+02 1.1037900543212891e+02 -3.0946798706054688e+02 2.4170201110839844e+02 1.1083100128173828e+02 -3.1064700317382812e+02 2.4374600219726562e+02 1.1164499664306641e+02 -3.1188299560546875e+02 2.4563899230957031e+02 1.1280000305175781e+02 -3.1314199829101562e+02 2.4733000183105469e+02 1.3793499755859375e+02 -3.1708099365234375e+02 2.3683099365234375e+02 1.3785800170898438e+02 -3.1599102783203125e+02 2.3469099426269531e+02 1.1525800323486328e+02 -3.0517501831054688e+02 2.2947099304199219e+02 1.3740600585937500e+02 -3.1481201171875000e+02 2.3264599609375000e+02 1.1712799835205078e+02 -3.0510699462890625e+02 2.2796299743652344e+02 1.1426300048828125e+02 -3.1439001464843750e+02 2.4877099609375000e+02 1.1599499511718750e+02 -3.1559197998046875e+02 2.4992300415039062e+02 1.1794900512695312e+02 -3.1671701049804688e+02 2.5075599670410156e+02 1.3763499450683594e+02 -3.1805300903320312e+02 2.3900898742675781e+02 1.2007099914550781e+02 -3.1773199462890625e+02 2.5124600219726562e+02 1.2230300140380859e+02 -3.1861099243164062e+02 2.5137998962402344e+02 1.2458499908447266e+02 -3.1933001708984375e+02 2.5115498352050781e+02 1.2685500335693359e+02 -3.1986901855468750e+02 2.5057598876953125e+02 1.3460600280761719e+02 -3.2001000976562500e+02 2.4517500305175781e+02 1.3594799804687500e+02 -3.1953701782226562e+02 2.4323800659179688e+02 1.2904899597167969e+02 -3.2021298217773438e+02 2.4965899658203125e+02 1.3110899353027344e+02 -3.2035198974609375e+02 2.4842999267578125e+02 1.3297900390625000e+02 -3.2028399658203125e+02 2.4692100524902344e+02 1.3659199523925781e+02 -3.1357601928710938e+02 2.3075300598144531e+02 1.3543699645996094e+02 -3.1231701660156250e+02 2.2906300354003906e+02 1.3028800964355469e+02 -3.0874301147460938e+02 2.2563700866699219e+02 1.3397399902343750e+02 -3.1107000732421875e+02 2.2762200927734375e+02 1.3224198913574219e+02 -3.0986700439453125e+02 2.2646899414062500e+02 1.2593300628662109e+02 -3.0684799194335938e+02 2.2501200866699219e+02 1.2365100097656250e+02 -3.0612899780273438e+02 2.2523799133300781e+02 1.2816600036621094e+02 -3.0772702026367188e+02 2.2514698791503906e+02 1.2138199615478516e+02 -3.0559097290039062e+02 2.2581700134277344e+02 1.1918800354003906e+02 -3.0524700927734375e+02 2.2673300170898438e+02 1.1038500213623047e+02 -3.1573599243164062e+02 2.4122099304199219e+02 1.1585600280761719e+02 -3.2057897949218750e+02 2.4696699523925781e+02 1.2507799530029297e+02 -3.1246502685546875e+02 2.2385099792480469e+02 1.1633300018310547e+02 -3.1050299072265625e+02 2.2631298828125000e+02 1.3174099731445312e+02 -3.2414099121093750e+02 2.4249400329589844e+02 1.3501499938964844e+02 -3.2126000976562500e+02 2.3428599548339844e+02 1.1105599975585938e+02 -3.1671499633789062e+02 2.4270098876953125e+02 1.1195999908447266e+02 -3.1770898437500000e+02 2.4404199218750000e+02 1.1307700347900391e+02 -3.1869799804687500e+02 2.4521499633789062e+02 1.1438400268554688e+02 -3.1966098022460938e+02 2.4619599914550781e+02 1.2329199981689453e+02 -3.1182400512695312e+02 2.2386799621582031e+02 1.2148799896240234e+02 -3.1129699707031250e+02 2.2413099670410156e+02 1.1970300292968750e+02 -3.1089700317382812e+02 2.2463400268554688e+02 1.1797200012207031e+02 -3.1063101196289062e+02 2.2536599731445312e+02 1.3285499572753906e+02 -3.2380300903320312e+02 2.4099600219726562e+02 1.3375599670410156e+02 -3.2333599853515625e+02 2.3939299011230469e+02 1.3442399597167969e+02 -3.2274697875976562e+02 2.3771699523925781e+02 1.3484700012207031e+02 -3.2205099487304688e+02 2.3600299072265625e+02 1.1262200164794922e+02 -3.1655599975585938e+02 2.4123098754882812e+02 1.1325400543212891e+02 -3.1731997680664062e+02 2.4230799865722656e+02 1.2365200042724609e+02 -3.1287100219726562e+02 2.2571499633789062e+02 1.2226200103759766e+02 -3.1243099975585938e+02 2.2584800720214844e+02 1.3092898559570312e+02 -3.2291601562500000e+02 2.4061900329589844e+02 1.3168800354003906e+02 -3.2259100341796875e+02 2.3940899658203125e+02 1.1951200103759766e+02 -3.1181399536132812e+02 2.2662199401855469e+02 1.3228700256347656e+02 -3.2217898559570312e+02 2.3813800048828125e+02 1.3271699523925781e+02 -3.2168499755859375e+02 2.3682899475097656e+02 1.1404299926757812e+02 -3.1808700561523438e+02 2.4327500915527344e+02 1.1497399902343750e+02 -3.1884301757812500e+02 2.4411499023437500e+02 1.2087400054931641e+02 -3.1207699584960938e+02 2.2615200805664062e+02 1.1387300109863281e+02 -3.1197900390625000e+02 2.3109098815917969e+02 1.1311499786376953e+02 -3.1230398559570312e+02 2.3230099487304688e+02 1.1251599884033203e+02 -3.1271600341796875e+02 2.3357200622558594e+02 1.1208499908447266e+02 -3.1321002197265625e+02 2.3488200378417969e+02 1.1819999694824219e+02 -3.1164801025390625e+02 2.2725099182128906e+02 1.1695899963378906e+02 -3.1158200073242188e+02 2.2802600097656250e+02 1.1581200408935547e+02 -3.1161499023437500e+02 2.2893499755859375e+02 1.1477700042724609e+02 -3.1174902343750000e+02 2.2996299743652344e+02 1.1603300476074219e+02 -3.1957501220703125e+02 2.4481298828125000e+02 1.1720100402832031e+02 -3.2026998901367188e+02 2.4535800170898438e+02 1.1845700073242188e+02 -3.2091799926757812e+02 2.4574099731445312e+02 1.3297100830078125e+02 -3.2111901855468750e+02 2.3550199890136719e+02 1.3304400634765625e+02 -3.2049099731445312e+02 2.3418200683593750e+02 1.3293400573730469e+02 -3.1980999755859375e+02 2.3288999938964844e+02 1.3264498901367188e+02 -3.1908801269531250e+02 2.3164900207519531e+02 1.3218000793457031e+02 -3.1833898925781250e+02 2.3047999572753906e+02 1.3154800415039062e+02 -3.1757501220703125e+02 2.2940200805664062e+02 1.3075999450683594e+02 -3.1680798339843750e+02 2.2843598937988281e+02 1.2982800292968750e+02 -3.1605200195312500e+02 2.2759599304199219e+02 1.2876899719238281e+02 -3.1531997680664062e+02 2.2689700317382812e+02 1.2760199737548828e+02 -3.1462500000000000e+02 2.2635200500488281e+02 1.2634499359130859e+02 -3.1397698974609375e+02 2.2597000122070312e+02 1.2502099609375000e+02 -3.1338998413085938e+02 2.2575601196289062e+02 1.1183200073242188e+02 -3.1377600097656250e+02 2.3620800781250000e+02 1.1175900268554688e+02 -3.1440402221679688e+02 2.3752899169921875e+02 1.1186800384521484e+02 -3.1508499145507812e+02 2.3882099914550781e+02 1.1215700531005859e+02 -3.1580700683593750e+02 2.4006199645996094e+02 1.1978100585937500e+02 -3.2150500488281250e+02 2.4595401000976562e+02 1.2115000152587891e+02 -3.2202398681640625e+02 2.4599499511718750e+02 1.2254100036621094e+02 -3.2246398925781250e+02 2.4586199951171875e+02 1.2392900085449219e+02 -3.2281802368164062e+02 2.4555799865722656e+02 1.2529000854492188e+02 -3.2308099365234375e+02 2.4508799743652344e+02 1.2660300445556641e+02 -3.2324697875976562e+02 2.4446000671386719e+02 1.2784300994873047e+02 -3.2331298828125000e+02 2.4368501281738281e+02 1.2899099731445312e+02 -3.2327999877929688e+02 2.4277499389648438e+02 1.3002499389648438e+02 -3.2314599609375000e+02 2.4174800109863281e+02 1.2849000549316406e+02 -3.1939501953125000e+02 2.3381900024414062e+02 1.2855599975585938e+02 -3.1980099487304688e+02 2.3458999633789062e+02 1.2636399078369141e+02 -3.1924899291992188e+02 2.3489700317382812e+02 1.2530900573730469e+02 -3.1630099487304688e+02 2.2991799926757812e+02 1.2600499725341797e+02 -3.1671597290039062e+02 2.3024400329589844e+02 1.2468399810791016e+02 -3.1721600341796875e+02 2.3203399658203125e+02 1.1827400207519531e+02 -3.1450500488281250e+02 2.3145899963378906e+02 1.1895899963378906e+02 -3.1448501586914062e+02 2.3091700744628906e+02 1.2004200744628906e+02 -3.1574697875976562e+02 2.3247799682617188e+02 1.1585600280761719e+02 -3.1616900634765625e+02 2.3658700561523438e+02 1.1589899444580078e+02 -3.1579400634765625e+02 2.3579899597167969e+02 1.1802700042724609e+02 -3.1660900878906250e+02 2.3569400024414062e+02 1.1985199737548828e+02 -3.2005599975585938e+02 2.4148699951171875e+02 1.1910299682617188e+02 -3.1966900634765625e+02 2.4125898742675781e+02 1.2013700103759766e+02 -3.1916201782226562e+02 2.3928999328613281e+02 1.2675399780273438e+02 -3.2138601684570312e+02 2.3910400390625000e+02 1.2613700103759766e+02 -3.2146499633789062e+02 2.3971800231933594e+02 1.2477099609375000e+02 -3.2034500122070312e+02 2.3827500915527344e+02 1.2563699340820312e+02 -3.2241799926757812e+02 2.4256700134277344e+02 1.2662899780273438e+02 -3.2247201538085938e+02 2.4194699096679688e+02 1.1812199401855469e+02 -3.2003900146484375e+02 2.4328500366210938e+02 1.1912699890136719e+02 -3.2055700683593750e+02 2.4358999633789062e+02 1.2018500518798828e+02 -3.2102700805664062e+02 2.4376100158691406e+02 1.2127899932861328e+02 -3.2144100952148438e+02 2.4379399108886719e+02 1.2238999938964844e+02 -3.2179299926757812e+02 2.4368699645996094e+02 1.2350000000000000e+02 -3.2207598876953125e+02 2.4344400024414062e+02 1.2458799743652344e+02 -3.2228601074218750e+02 2.4306900024414062e+02 1.1383100128173828e+02 -3.1484799194335938e+02 2.3597100830078125e+02 1.1377199554443359e+02 -3.1535101318359375e+02 2.3702600097656250e+02 1.1386000061035156e+02 -3.1589498901367188e+02 2.3805900573730469e+02 1.1409100341796875e+02 -3.1647100830078125e+02 2.3905099487304688e+02 1.1446300506591797e+02 -3.1707000732421875e+02 2.3998600769042969e+02 1.1496800231933594e+02 -3.1768200683593750e+02 2.4084700012207031e+02 1.1559799957275391e+02 -3.1829397583007812e+02 2.4161900329589844e+02 1.1634300231933594e+02 -3.1889901733398438e+02 2.4229100036621094e+02 1.1718899536132812e+02 -3.1948400878906250e+02 2.4284901428222656e+02 1.1792899322509766e+02 -3.1309399414062500e+02 2.2943099975585938e+02 1.1701200103759766e+02 -3.1312100219726562e+02 2.3015699768066406e+02 1.1618500518798828e+02 -3.1322799682617188e+02 2.3097898864746094e+02 1.1546300506591797e+02 -3.1341201782226562e+02 2.3188099670410156e+02 1.1485599517822266e+02 -3.1367199707031250e+02 2.3284800720214844e+02 1.1437699890136719e+02 -3.1400100708007812e+02 2.3386399841308594e+02 1.1403299713134766e+02 -3.1439599609375000e+02 2.3491099548339844e+02 1.2736900329589844e+02 -3.1608300781250000e+02 2.2852900695800781e+02 1.2643599700927734e+02 -3.1552697753906250e+02 2.2809300231933594e+02 1.2543199920654297e+02 -3.1500900268554688e+02 2.2778700256347656e+02 1.2437299346923828e+02 -3.1454000854492188e+02 2.2761599731445312e+02 1.2327899932861328e+02 -3.1412500000000000e+02 2.2758399963378906e+02 1.2216799926757812e+02 -3.1377301025390625e+02 2.2769000244140625e+02 1.2105799865722656e+02 -3.1348999023437500e+02 2.2793299865722656e+02 1.1997000122070312e+02 -3.1328100585937500e+02 2.2830900573730469e+02 1.1892099761962891e+02 -3.1314797973632812e+02 2.2881098937988281e+02 1.3078599548339844e+02 -3.2021499633789062e+02 2.3435099792480469e+02 1.3069799804687500e+02 -3.1967098999023438e+02 2.3331800842285156e+02 1.3046699523925781e+02 -3.1909497070312500e+02 2.3232600402832031e+02 1.3009600830078125e+02 -3.1849600219726562e+02 2.3139199829101562e+02 1.2959001159667969e+02 -3.1788500976562500e+02 2.3053100585937500e+02 1.2895999145507812e+02 -3.1727200317382812e+02 2.2975799560546875e+02 1.2821499633789062e+02 -3.1666799926757812e+02 2.2908699035644531e+02 1.2754599761962891e+02 -3.2244500732421875e+02 2.4122000122070312e+02 1.2837300109863281e+02 -3.2233801269531250e+02 2.4039900207519531e+02 1.2909600830078125e+02 -3.2215399169921875e+02 2.3949700927734375e+02 1.2970199584960938e+02 -3.2189398193359375e+02 2.3852999877929688e+02 1.3018099975585938e+02 -3.2156500244140625e+02 2.3751400756835938e+02 1.3052499389648438e+02 -3.2117001342773438e+02 2.3646701049804688e+02 1.3072801208496094e+02 -3.2071798706054688e+02 2.3540599060058594e+02 1.2064199829101562e+02 -3.2040597534179688e+02 2.4161399841308594e+02 1.2145899963378906e+02 -3.2071600341796875e+02 2.4163900756835938e+02 1.2228900146484375e+02 -3.2097799682617188e+02 2.4155900573730469e+02 1.2311699676513672e+02 -3.2119000244140625e+02 2.4137799072265625e+02 1.2392900085449219e+02 -3.2134600830078125e+02 2.4109700012207031e+02 1.1592099761962891e+02 -3.1657598876953125e+02 2.3735800170898438e+02 1.1609300231933594e+02 -3.1700598144531250e+02 2.3809799194335938e+02 1.1637099456787109e+02 -3.1745300292968750e+02 2.3879598999023438e+02 1.1674800109863281e+02 -3.1790899658203125e+02 2.3943899536132812e+02 1.1721800231933594e+02 -3.1836700439453125e+02 2.4001499938964844e+02 1.1777400207519531e+02 -3.1881799316406250e+02 2.4051699829101562e+02 1.1840599822998047e+02 -3.1925399780273438e+02 2.4093299865722656e+02 1.1765699768066406e+02 -3.1458499145507812e+02 2.3207299804687500e+02 1.1711700439453125e+02 -3.1472302246093750e+02 2.3274600219726562e+02 1.1666500091552734e+02 -3.1491601562500000e+02 2.3346800231933594e+02 1.1630699920654297e+02 -3.1516201782226562e+02 2.3422599792480469e+02 1.1604999542236328e+02 -3.1545700073242188e+02 2.3500799560546875e+02 1.2455899810791016e+02 -3.1591497802734375e+02 2.2969000244140625e+02 1.2376899719238281e+02 -3.1556399536132812e+02 2.2956300354003906e+02 1.2295199584960938e+02 -3.1525497436523438e+02 2.2953799438476562e+02 1.2212199401855469e+02 -3.1499200439453125e+02 2.2961799621582031e+02 1.2129399871826172e+02 -3.1478100585937500e+02 2.2979899597167969e+02 1.2048199462890625e+02 -3.1462402343750000e+02 2.3007998657226562e+02 1.1969900512695312e+02 -3.1452499389648438e+02 2.3045399475097656e+02 1.2831799316406250e+02 -3.1896398925781250e+02 2.3307899475097656e+02 1.2803999328613281e+02 -3.1851699829101562e+02 2.3238099670410156e+02 1.2766300201416016e+02 -3.1806100463867188e+02 2.3173800659179688e+02 1.2719300079345703e+02 -3.1760400390625000e+02 2.3116099548339844e+02 1.2663699340820312e+02 -3.1715301513671875e+02 2.3066000366210938e+02 1.2729400634765625e+02 -3.2124798583984375e+02 2.3843099975585938e+02 1.2774600219726562e+02 -3.2105401611328125e+02 2.3770899963378906e+02 1.2810400390625000e+02 -3.2080798339843750e+02 2.3695098876953125e+02 1.2836100769042969e+02 -3.2051400756835938e+02 2.3616899108886719e+02 1.2851199340820312e+02 -3.2017599487304688e+02 2.3537799072265625e+02 1.2545299530029297e+02 -3.2148501586914062e+02 2.4026000976562500e+02 1.2431999969482422e+02 -3.2035800170898438e+02 2.3863198852539062e+02 1.2451300048828125e+02 -3.2035198974609375e+02 2.3847900390625000e+02 1.2471199798583984e+02 -3.2144497680664062e+02 2.4072299194335938e+02 1.2383200073242188e+02 -3.2033200073242188e+02 2.3893701171875000e+02 1.2338999938964844e+02 -3.2027600097656250e+02 2.3914900207519531e+02 1.2215799713134766e+02 -3.2000000000000000e+02 2.3949598693847656e+02 1.2223600006103516e+02 -3.2002401733398438e+02 2.3948800659179688e+02 1.2278099822998047e+02 -3.2016400146484375e+02 2.3936900329589844e+02 1.2331700134277344e+02 -3.2026699829101562e+02 2.3918400573730469e+02 1.2063100433349609e+02 -3.1941598510742188e+02 2.3943998718261719e+02 1.2092799377441406e+02 -3.1954898071289062e+02 2.3948800659179688e+02 1.2115100097656250e+02 -3.1964801025390625e+02 2.3952400207519531e+02 1.2168900299072266e+02 -3.1985101318359375e+02 2.3953999328613281e+02 1.1980899810791016e+02 -3.1896701049804688e+02 2.3913699340820312e+02 1.1828500366210938e+02 -3.1761801147460938e+02 2.3753700256347656e+02 1.1833699798583984e+02 -3.1770199584960938e+02 2.3766799926757812e+02 1.1858599853515625e+02 -3.1800299072265625e+02 2.3809100341796875e+02 1.1889600372314453e+02 -3.1830401611328125e+02 2.3847100830078125e+02 1.1926200103759766e+02 -3.1860101318359375e+02 2.3880099487304688e+02 1.1967800140380859e+02 -3.1888897705078125e+02 2.3907600402832031e+02 1.1799799346923828e+02 -3.1685702514648438e+02 2.3621299743652344e+02 1.1801599884033203e+02 -3.1697100830078125e+02 2.3643000793457031e+02 1.1804100036621094e+02 -3.1712402343750000e+02 2.3672099304199219e+02 1.1815499877929688e+02 -3.1740798950195312e+02 2.3720799255371094e+02 1.1811199951171875e+02 -3.1641900634765625e+02 2.3524699401855469e+02 1.1857399749755859e+02 -3.1601300048828125e+02 2.3408999633789062e+02 1.1853100585937500e+02 -3.1603100585937500e+02 2.3415798950195312e+02 1.1829599761962891e+02 -3.1619302368164062e+02 2.3465800476074219e+02 1.1812599945068359e+02 -3.1638699340820312e+02 2.3517199707031250e+02 1.1959099578857422e+02 -3.1575997924804688e+02 2.3283499145507812e+02 1.1935900115966797e+02 -3.1579000854492188e+02 2.3306599426269531e+02 1.1918499755859375e+02 -3.1581301879882812e+02 2.3323899841308594e+02 1.1882899475097656e+02 -3.1590301513671875e+02 2.3368299865722656e+02 1.2038999938964844e+02 -3.1576602172851562e+02 2.3226000976562500e+02 1.2282600402832031e+02 -3.1631198120117188e+02 2.3157400512695312e+02 1.2267299652099609e+02 -3.1625399780273438e+02 2.3157000732421875e+02 1.2212599945068359e+02 -3.1608099365234375e+02 2.3162199401855469e+02 1.2158100128173828e+02 -3.1594198608398438e+02 2.3174099731445312e+02 1.2104499816894531e+02 -3.1583898925781250e+02 2.3192599487304688e+02 1.2052999877929688e+02 -3.1577301025390625e+02 2.3217298889160156e+02 1.2422499847412109e+02 -3.1694299316406250e+02 2.3182000732421875e+02 1.2401300048828125e+02 -3.1683401489257812e+02 2.3175500488281250e+02 1.2373100280761719e+02 -3.1668902587890625e+02 2.3167001342773438e+02 1.2321099853515625e+02 -3.1645797729492188e+02 2.3158599853515625e+02 1.2504099273681641e+02 -3.1746301269531250e+02 2.3227000427246094e+02 1.2581199645996094e+02 -3.1814501953125000e+02 2.3307899475097656e+02 1.2577599334716797e+02 -3.1810299682617188e+02 2.3301899719238281e+02 1.2546600341796875e+02 -3.1780099487304688e+02 2.3263899230957031e+02 1.2509999847412109e+02 -3.1750399780273438e+02 2.3230900573730469e+02 1.2632099914550781e+02 -3.1898098754882812e+02 2.3438900756835938e+02 1.2625600433349609e+02 -3.1881900024414062e+02 2.3411099243164062e+02 1.2620699310302734e+02 -3.1869799804687500e+02 2.3390200805664062e+02 1.2602500915527344e+02 -3.1840301513671875e+02 2.3344198608398438e+02 1.2634299468994141e+02 -3.1942498779296875e+02 2.3526799011230469e+02 1.2517799377441406e+02 -3.2029299926757812e+02 2.3787100219726562e+02 1.2543099975585938e+02 -3.2022799682617188e+02 2.3755400085449219e+02 1.2553299713134766e+02 -3.2020199584960938e+02 2.3742700195312500e+02 1.2583099365234375e+02 -3.2007400512695312e+02 2.3695201110839844e+02 1.2606600189208984e+02 -3.1991198730468750e+02 2.3645199584960938e+02 1.2623600769042969e+02 -3.1971801757812500e+02 2.3593800354003906e+02 1.2633499145507812e+02 -3.1949600219726562e+02 2.3541600036621094e+02 1.2389399719238281e+02 -3.1966400146484375e+02 2.3465899658203125e+02 1.2386499786376953e+02 -3.1985900878906250e+02 2.3507400512695312e+02 1.2179399871826172e+02 -3.1911700439453125e+02 2.3502699279785156e+02 1.2368000030517578e+02 -3.1920700073242188e+02 2.3389599609375000e+02 1.2383099365234375e+02 -3.1944299316406250e+02 2.3425999450683594e+02 1.2314099884033203e+02 -3.1873001098632812e+02 2.3333000183105469e+02 1.2344599914550781e+02 -3.1896600341796875e+02 2.3358100891113281e+02 1.2194000244140625e+02 -3.1815499877929688e+02 2.3305200195312500e+02 1.2237100219726562e+02 -3.1831600952148438e+02 2.3305999755859375e+02 1.2034300231933594e+02 -3.1796398925781250e+02 2.3383900451660156e+02 1.2068600463867188e+02 -3.1793798828125000e+02 2.3353399658203125e+02 1.1974099731445312e+02 -3.1832299804687500e+02 2.3500500488281250e+02 1.1985900115966797e+02 -3.1816101074218750e+02 2.3459100341796875e+02 1.1992599487304688e+02 -3.1897601318359375e+02 2.3618299865722656e+02 1.1977499389648438e+02 -3.1874002075195312e+02 2.3581900024414062e+02 1.2046500396728516e+02 -3.1945300292968750e+02 2.3674899291992188e+02 1.2015999603271484e+02 -3.1921701049804688e+02 2.3649800109863281e+02 1.2082900238037109e+02 -3.1967300415039062e+02 2.3692500305175781e+02 1.2166600036621094e+02 -3.2002801513671875e+02 2.3702700805664062e+02 1.2123500061035156e+02 -3.1986700439453125e+02 2.3701899719238281e+02 1.2210299682617188e+02 -3.2014700317382812e+02 2.3694700622558594e+02 1.2291899871826172e+02 -3.2024499511718750e+02 2.3654499816894531e+02 1.2252700042724609e+02 -3.2022100830078125e+02 2.3678399658203125e+02 1.2374600219726562e+02 -3.2002197265625000e+02 2.3548799133300781e+02 1.2354299926757812e+02 -3.2014300537109375e+02 2.3588299560546875e+02 1.2507000732421875e+02 -3.2118099975585938e+02 2.3706999206542969e+02 1.2326300048828125e+02 -3.2021902465820312e+02 2.3624000549316406e+02 1.2327899932861328e+02 -3.2127197265625000e+02 2.3856599426269531e+02 1.2406300354003906e+02 -3.2132000732421875e+02 2.3808799743652344e+02 1.2416099548339844e+02 -3.2131298828125000e+02 2.3800100708007812e+02 1.2475000000000000e+02 -3.2126800537109375e+02 2.3747799682617188e+02 1.2069599914550781e+02 -3.2056497192382812e+02 2.3903599548339844e+02 1.2155699920654297e+02 -3.2088598632812500e+02 2.3905000305175781e+02 1.2180699920654297e+02 -3.2095401000976562e+02 2.3900500488281250e+02 1.2243099975585938e+02 -3.2112500000000000e+02 2.3889199829101562e+02 1.2303700256347656e+02 -3.2122998046875000e+02 2.3865899658203125e+02 1.2058000183105469e+02 -3.2050897216796875e+02 2.3900898742675781e+02 1.1988300323486328e+02 -3.2017599487304688e+02 2.3884800720214844e+02 1.1946800231933594e+02 -3.1992501831054688e+02 2.3864700317382812e+02 1.1915600585937500e+02 -3.1973699951171875e+02 2.3849600219726562e+02 1.1777700042724609e+02 -3.1831100463867188e+02 2.3663600158691406e+02 1.1794999694824219e+02 -3.1858102416992188e+02 2.3705198669433594e+02 1.1807900238037109e+02 -3.1878298950195312e+02 2.3736500549316406e+02 1.1854600524902344e+02 -3.1926501464843750e+02 2.3799400329589844e+02 1.1766899871826172e+02 -3.1793298339843750e+02 2.3595201110839844e+02 1.1971200561523438e+02 -3.1851898193359375e+02 2.3541999816894531e+02 1.1794599914550781e+02 -3.1715499877929688e+02 2.3418000793457031e+02 1.1777600097656250e+02 -3.1738598632812500e+02 2.3477200317382812e+02 1.1770800018310547e+02 -3.1747900390625000e+02 2.3500799560546875e+02 1.1765100097656250e+02 -3.1786999511718750e+02 2.3583799743652344e+02 1.1823700714111328e+02 -3.1698098754882812e+02 2.3361698913574219e+02 1.2006299591064453e+02 -3.1804000854492188e+02 2.3419601440429688e+02 1.1959899902343750e+02 -3.1670800781250000e+02 2.3206800842285156e+02 1.1901000213623047e+02 -3.1675299072265625e+02 2.3259100341796875e+02 1.1891199493408203e+02 -3.1676098632812500e+02 2.3267799377441406e+02 1.1835300445556641e+02 -3.1691198730468750e+02 2.3339199829101562e+02 1.2004700469970703e+02 -3.1673602294921875e+02 2.3179499816894531e+02 1.2107899475097656e+02 -3.1796200561523438e+02 2.3329499816894531e+02 1.2038300323486328e+02 -3.1675601196289062e+02 2.3158999633789062e+02 1.2123099517822266e+02 -3.1690298461914062e+02 2.3126399230957031e+02 1.2150300598144531e+02 -3.1803598022460938e+02 2.3313200378417969e+02 1.2296699523925781e+02 -3.1746301269531250e+02 2.3112001037597656e+02 1.2247399902343750e+02 -3.1727999877929688e+02 2.3111199951171875e+02 1.2210500335693359e+02 -3.1714199829101562e+02 2.3110499572753906e+02 1.2366300201416016e+02 -3.1779699707031250e+02 2.3128099060058594e+02 1.2377899932861328e+02 -3.1785198974609375e+02 2.3130700683593750e+02 1.2277700042724609e+02 -3.1851000976562500e+02 2.3315399169921875e+02 1.2511600494384766e+02 -3.1876300048828125e+02 2.3216200256347656e+02 1.2468000030517578e+02 -3.1842602539062500e+02 2.3180299377441406e+02 1.2450599670410156e+02 -3.1829199218750000e+02 2.3165998840332031e+02 1.2588599395751953e+02 -3.1971697998046875e+02 2.3352000427246094e+02 1.2558299255371094e+02 -3.1924502563476562e+02 2.3279100036621094e+02 1.2544999694824219e+02 -3.1910699462890625e+02 2.3261100769042969e+02 1.2590399169921875e+02 -3.1977999877929688e+02 2.3363400268554688e+02 1.2601100158691406e+02 -3.2015802001953125e+02 2.3431700134277344e+02 1.2597799682617188e+02 -3.2038198852539062e+02 2.3479199218750000e+02 1.2595400238037109e+02 -3.2054901123046875e+02 2.3514799499511719e+02 1.2571700286865234e+02 -3.2087399291992188e+02 2.3597499084472656e+02 1.2530900573730469e+02 -3.2111599731445312e+02 2.3676399230957031e+02 1.1673699951171875e+02 -3.1042901611328125e+02 2.2676499938964844e+02 1.1670999908447266e+02 -3.1046499633789062e+02 2.2685700988769531e+02 1.2502099609375000e+02 -3.1228701782226562e+02 2.2443299865722656e+02 1.1045300292968750e+02 -3.1338400268554688e+02 2.3732901000976562e+02 1.1055000305175781e+02 -3.1437399291992188e+02 2.3925199890136719e+02 1.1663999938964844e+02 -3.1047601318359375e+02 2.2693099975585938e+02 1.2712300109863281e+02 -3.1325000000000000e+02 2.2483200073242188e+02 1.2516101074218750e+02 -3.1238699340820312e+02 2.2453199768066406e+02 1.2507399749755859e+02 -3.1234100341796875e+02 2.2450199890136719e+02 1.1330799865722656e+02 -3.1925900268554688e+02 2.4707398986816406e+02 1.1523999786376953e+02 -3.2049798583984375e+02 2.4815400695800781e+02 1.1087300109863281e+02 -3.1551901245117188e+02 2.4132199096679688e+02 1.1818700408935547e+02 -3.0971701049804688e+02 2.2426599121093750e+02 1.1597100067138672e+02 -3.0951501464843750e+02 2.2548300170898438e+02 1.2501600646972656e+02 -3.1223999023437500e+02 2.2434201049804688e+02 1.3140100097656250e+02 -3.2354199218750000e+02 2.4243399047851562e+02 1.3148400878906250e+02 -3.2354199218750000e+02 2.4237300109863281e+02 1.2580799865722656e+02 -3.1936401367187500e+02 2.3811599731445312e+02 1.2649300384521484e+02 -3.1902600097656250e+02 2.3693299865722656e+02 1.3283500671386719e+02 -3.2444598388671875e+02 2.4320399475097656e+02 1.3283898925781250e+02 -3.2444500732421875e+02 2.4319900512695312e+02 1.3280299377441406e+02 -3.2441900634765625e+02 2.4317300415039062e+02 1.3428199768066406e+02 -3.2396298217773438e+02 2.4116900634765625e+02 1.3166799926757812e+02 -3.2361401367187500e+02 2.4238299560546875e+02 1.3536700439453125e+02 -3.2327301025390625e+02 2.3898300170898438e+02 1.3158099365234375e+02 -3.2356799316406250e+02 2.4235400390625000e+02 1.1222699737548828e+02 -3.1116598510742188e+02 2.3155799865722656e+02 1.1130400085449219e+02 -3.1175698852539062e+02 2.3342500305175781e+02 1.1344899749755859e+02 -3.1074899291992188e+02 2.2982099914550781e+02 1.1493399810791016e+02 -3.1051699829101562e+02 2.2826300048828125e+02 1.1070700073242188e+02 -3.1250399780273438e+02 2.3536799621582031e+02 1.1099500274658203e+02 -3.1544302368164062e+02 2.4108099365234375e+02 1.1623100280761719e+02 -3.2012100219726562e+02 2.4666699218750000e+02 1.1099900054931641e+02 -3.1549002075195312e+02 2.4117199707031250e+02 1.1613700103759766e+02 -3.2010498046875000e+02 2.4670300292968750e+02 1.1095400238037109e+02 -3.1551699829101562e+02 2.4126000976562500e+02 1.1606600189208984e+02 -3.2011499023437500e+02 2.4677600097656250e+02 1.1526499938964844e+02 -3.2048602294921875e+02 2.4811099243164062e+02 1.1524500274658203e+02 -3.2050100708007812e+02 2.4815599060058594e+02 1.0937899780273438e+02 -3.1530899047851562e+02 2.4199600219726562e+02 1.0938099670410156e+02 -3.1531301879882812e+02 2.4200099182128906e+02 1.0942800140380859e+02 -3.1531900024414062e+02 2.4197999572753906e+02 1.1033300018310547e+02 -3.1662698364257812e+02 2.4395098876953125e+02 1.1165499877929688e+02 -3.1795599365234375e+02 2.4565899658203125e+02 1.1671400451660156e+02 -3.1037899780273438e+02 2.2667900085449219e+02 1.1599399566650391e+02 -3.0954199218750000e+02 2.2552099609375000e+02 1.1596600341796875e+02 -3.0951501464843750e+02 2.2548699951171875e+02 1.3468299865722656e+02 -3.2083898925781250e+02 2.3457899475097656e+02 1.3477600097656250e+02 -3.2087899780273438e+02 2.3459201049804688e+02 1.3606199645996094e+02 -3.2239700317382812e+02 2.3670700073242188e+02 1.3629699707031250e+02 -3.2134500122070312e+02 2.3441499328613281e+02 1.3634599304199219e+02 -3.2135998535156250e+02 2.3441000366210938e+02 1.3634599304199219e+02 -3.2135702514648438e+02 2.3440399169921875e+02 1.3459199523925781e+02 -3.2073501586914062e+02 2.3443699645996094e+02 1.3444699096679688e+02 -3.1973300170898438e+02 2.3252398681640625e+02 1.3395599365234375e+02 -3.1865502929687500e+02 2.3071199035644531e+02 1.3313299560546875e+02 -3.1753298950195312e+02 2.2905400085449219e+02 1.3200099182128906e+02 -3.1639901733398438e+02 2.2759799194335938e+02 1.3059399414062500e+02 -3.1528601074218750e+02 2.2638699340820312e+02 1.2895199584960938e+02 -3.1422601318359375e+02 2.2545599365234375e+02 1.2534199523925781e+02 -3.1161697387695312e+02 2.2284700012207031e+02 1.2533600616455078e+02 -3.1161499023437500e+02 2.2284700012207031e+02 1.2532599639892578e+02 -3.1163400268554688e+02 2.2289300537109375e+02 1.2294100189208984e+02 -3.1078298950195312e+02 2.2292700195312500e+02 1.2053400421142578e+02 -3.1014401245117188e+02 2.2340499877929688e+02 1.2678800201416016e+02 -3.1850201416015625e+02 2.3566099548339844e+02 1.2666599273681641e+02 -3.1784298706054688e+02 2.3442199707031250e+02 1.3461599731445312e+02 -3.2078601074218750e+02 2.3452299499511719e+02 1.2613700103759766e+02 -3.1711398315429688e+02 2.3333999633789062e+02 1.2988301086425781e+02 -3.2374899291992188e+02 2.4396400451660156e+02 1.2480200195312500e+02 -3.1948300170898438e+02 2.3909400939941406e+02 1.2815100097656250e+02 -3.2376300048828125e+02 2.4526199340820312e+02 1.1837200164794922e+02 -3.1640600585937500e+02 2.3760899353027344e+02 1.1825000000000000e+02 -3.1574697875976562e+02 2.3637100219726562e+02 1.1854500579833984e+02 -3.1522302246093750e+02 2.3509800720214844e+02 1.2625600433349609e+02 -3.2358398437500000e+02 2.4629199218750000e+02 1.2357199859619141e+02 -3.1937100219726562e+02 2.3976998901367188e+02 1.2425099945068359e+02 -3.2321701049804688e+02 2.4702299499511719e+02 1.2223899841308594e+02 -3.1903900146484375e+02 2.4007899475097656e+02 1.2219699859619141e+02 -3.2267401123046875e+02 2.4743499755859375e+02 1.2015199279785156e+02 -3.2196899414062500e+02 2.4751399230957031e+02 1.2093400573730469e+02 -3.1851898193359375e+02 2.3998899841308594e+02 1.1817500305175781e+02 -3.2112301635742188e+02 2.4726000976562500e+02 1.1632499694824219e+02 -3.2016101074218750e+02 2.4667898559570312e+02 1.1978299713134766e+02 -3.1786297607421875e+02 2.3951100158691406e+02 1.1890100097656250e+02 -3.1713500976562500e+02 2.3869100952148438e+02 1.2279900360107422e+02 -3.1521002197265625e+02 2.3195298767089844e+02 1.2410400390625000e+02 -3.1572900390625000e+02 2.3204199218750000e+02 1.1923000335693359e+02 -3.1488497924804688e+02 2.3391500854492188e+02 1.2023600006103516e+02 -3.1476599121093750e+02 2.3293699645996094e+02 1.2146600341796875e+02 -3.1487799072265625e+02 2.3226100158691406e+02 1.2525500488281250e+02 -3.1638500976562500e+02 2.3252000427246094e+02 1.2255100250244141e+02 -3.2304299926757812e+02 2.4324700927734375e+02 1.2285400390625000e+02 -3.2312597656250000e+02 2.4319100952148438e+02 1.2319100189208984e+02 -3.2397299194335938e+02 2.4537500000000000e+02 1.2493199920654297e+02 -3.1738000488281250e+02 2.2949301147460938e+02 1.2390599822998047e+02 -3.1802899169921875e+02 2.3120500183105469e+02 1.2336900329589844e+02 -3.1775097656250000e+02 2.3103900146484375e+02 1.2507799530029297e+02 -3.1752099609375000e+02 2.2964799499511719e+02 1.2534099578857422e+02 -3.1736901855468750e+02 2.2924899291992188e+02 1.2591299438476562e+02 -3.1772198486328125e+02 2.2954000854492188e+02 1.1353400421142578e+02 -3.1525701904296875e+02 2.3416999816894531e+02 1.1347200012207031e+02 -3.1537802124023438e+02 2.3445799255371094e+02 1.1143199920654297e+02 -3.1415100097656250e+02 2.3420600891113281e+02 1.1117199707031250e+02 -3.1468002319335938e+02 2.3546299743652344e+02 1.1328700256347656e+02 -3.1573999023437500e+02 2.3532499694824219e+02 1.1116999816894531e+02 -3.1469299316406250e+02 2.3549099731445312e+02 1.1321099853515625e+02 -3.1614300537109375e+02 2.3619100952148438e+02 1.1289199829101562e+02 -3.1600601196289062e+02 2.3624700927734375e+02 1.1148699951171875e+02 -3.1408898925781250e+02 2.3404100036621094e+02 1.1184600067138672e+02 -3.1368600463867188e+02 2.3296501159667969e+02 1.1394400024414062e+02 -3.1484298706054688e+02 2.3303399658203125e+02 1.1200899505615234e+02 -3.1357199096679688e+02 2.3261601257324219e+02 1.1408499908447266e+02 -3.1475799560546875e+02 2.3276100158691406e+02 1.1240900421142578e+02 -3.1329101562500000e+02 2.3175799560546875e+02 1.1450900268554688e+02 -3.1450598144531250e+02 2.3194000244140625e+02 1.1272100067138672e+02 -3.1314999389648438e+02 2.3124400329589844e+02 1.1504100036621094e+02 -3.1431500244140625e+02 2.3116700744628906e+02 1.1311100006103516e+02 -3.1297399902343750e+02 2.3060299682617188e+02 1.1521800231933594e+02 -3.1425198364257812e+02 2.3090901184082031e+02 1.1361000061035156e+02 -3.1283200073242188e+02 2.2995098876953125e+02 1.1394300079345703e+02 -3.1273800659179688e+02 2.2951600646972656e+02 1.1605699920654297e+02 -3.1408700561523438e+02 2.2996099853515625e+02 1.1466000366210938e+02 -3.1262298583984375e+02 2.2875900268554688e+02 1.1629599761962891e+02 -3.1406900024414062e+02 2.2975000000000000e+02 1.1489199829101562e+02 -3.1258599853515625e+02 2.2851400756835938e+02 1.1701100158691406e+02 -3.1401397705078125e+02 2.2911499023437500e+02 1.1585199737548828e+02 -3.1252700805664062e+02 2.2769099426269531e+02 1.1868900299072266e+02 -3.1533102416992188e+02 2.3002200317382812e+02 1.1826499938964844e+02 -3.1472302246093750e+02 2.2933200073242188e+02 1.1850099945068359e+02 -3.1473498535156250e+02 2.2918400573730469e+02 1.1778900146484375e+02 -3.1402099609375000e+02 2.2855700683593750e+02 1.1618000030517578e+02 -3.1570199584960938e+02 2.3260900878906250e+02 1.1658699798583984e+02 -3.1555700683593750e+02 2.3201799011230469e+02 1.1814499664306641e+02 -3.1702999877929688e+02 2.3341900634765625e+02 1.1849399566650391e+02 -3.1690600585937500e+02 2.3291200256347656e+02 1.1564900207519531e+02 -3.1713598632812500e+02 2.3578800964355469e+02 1.1754400634765625e+02 -3.1763800048828125e+02 2.3508299255371094e+02 1.1752399444580078e+02 -3.1777099609375000e+02 2.3536700439453125e+02 1.1556000518798828e+02 -3.1720599365234375e+02 2.3601800537109375e+02 1.1585500335693359e+02 -3.1589498901367188e+02 2.3323699951171875e+02 1.1786699676513672e+02 -3.1719601440429688e+02 2.3395698547363281e+02 1.1574699401855469e+02 -3.1595999145507812e+02 2.3344599914550781e+02 1.1781700134277344e+02 -3.1724700927734375e+02 2.3409600830078125e+02 1.1543399810791016e+02 -3.1627700805664062e+02 2.3431498718261719e+02 1.1766500091552734e+02 -3.1739999389648438e+02 2.3451499938964844e+02 1.1538600158691406e+02 -3.1636898803710938e+02 2.3453601074218750e+02 1.1524500274658203e+02 -3.1664700317382812e+02 2.3519900512695312e+02 1.1518699645996094e+02 -3.1695397949218750e+02 2.3586100769042969e+02 1.1750499725341797e+02 -3.1790499877929688e+02 2.3565000915527344e+02 1.1754900360107422e+02 -3.1819598388671875e+02 2.3620500183105469e+02 1.1519200134277344e+02 -3.1749798583984375e+02 2.3697000122070312e+02 1.1514299774169922e+02 -3.1753799438476562e+02 2.3709901428222656e+02 1.1764399719238281e+02 -3.1842800903320312e+02 2.3660301208496094e+02 1.1767599487304688e+02 -3.1850601196289062e+02 2.3673599243164062e+02 1.1788199615478516e+02 -3.1882797241210938e+02 2.3723399353027344e+02 1.1464499664306641e+02 -3.1791601562500000e+02 2.3841999816894531e+02 1.1475899505615234e+02 -3.1782901000976562e+02 2.3811599731445312e+02 1.1448699951171875e+02 -3.1774801635742188e+02 2.3822399902343750e+02 1.1134199523925781e+02 -3.1657098388671875e+02 2.3914900207519531e+02 1.1383499908447266e+02 -3.1705297851562500e+02 2.3741499328613281e+02 1.1119899749755859e+02 -3.1612301635742188e+02 2.3835099792480469e+02 1.1376200103759766e+02 -3.1697601318359375e+02 2.3732499694824219e+02 1.1112699890136719e+02 -3.1589901733398438e+02 2.3795300292968750e+02 1.1308699798583984e+02 -3.1622399902343750e+02 2.3648899841308594e+02 1.1108000183105469e+02 -3.1537802124023438e+02 2.3693800354003906e+02 1.1106999969482422e+02 -3.1526602172851562e+02 2.3671800231933594e+02 1.2723300170898438e+02 -3.1714599609375000e+02 2.2792799377441406e+02 1.2648400878906250e+02 -3.1668499755859375e+02 2.2754800415039062e+02 1.2868400573730469e+02 -3.1646200561523438e+02 2.2620899963378906e+02 1.2667199707031250e+02 -3.1656900024414062e+02 2.2727299499511719e+02 1.2791200256347656e+02 -3.1762799072265625e+02 2.2840100097656250e+02 1.2939100646972656e+02 -3.1693597412109375e+02 2.2664700317382812e+02 1.2813800048828125e+02 -3.1778799438476562e+02 2.2855799865722656e+02 1.2981900024414062e+02 -3.1726800537109375e+02 2.2700199890136719e+02 1.3030799865722656e+02 -3.1764797973632812e+02 2.2740800476074219e+02 1.2892199707031250e+02 -3.1845001220703125e+02 2.2931799316406250e+02 1.3080400085449219e+02 -3.1809899902343750e+02 2.2795399475097656e+02 1.2908399963378906e+02 -3.1861697387695312e+02 2.2953599548339844e+02 1.3110501098632812e+02 -3.1837298583984375e+02 2.2828500366210938e+02 1.2957000732421875e+02 -3.1911901855468750e+02 2.3019100952148438e+02 1.3162100219726562e+02 -3.1893899536132812e+02 2.2904699707031250e+02 1.3176800537109375e+02 -3.1910000610351562e+02 2.2926400756835938e+02 1.2994400024414062e+02 -3.1961700439453125e+02 2.3091900634765625e+02 1.3225500488281250e+02 -3.1977200317382812e+02 2.3026100158691406e+02 1.3006800842285156e+02 -3.1978198242187500e+02 2.3116099548339844e+02 1.3228900146484375e+02 -3.1981997680664062e+02 2.3033200073242188e+02 1.3040800476074219e+02 -3.2042599487304688e+02 2.3220999145507812e+02 1.3266099548339844e+02 -3.2052099609375000e+02 2.3147200012207031e+02 1.3267999267578125e+02 -3.2058001708984375e+02 2.3157800292968750e+02 1.3045201110839844e+02 -3.2057897949218750e+02 2.3248599243164062e+02 1.3287599182128906e+02 -3.2119302368164062e+02 2.3266799926757812e+02 1.3058200073242188e+02 -3.2103900146484375e+02 2.3331600952148438e+02 1.2849099731445312e+02 -3.2102999877929688e+02 2.3431600952148438e+02 1.2947799682617188e+02 -3.2124200439453125e+02 2.3424499511718750e+02 1.2946600341796875e+02 -3.2136300659179688e+02 2.3449699401855469e+02 1.3060200500488281e+02 -3.2147000122070312e+02 2.3417100524902344e+02 1.2484799957275391e+02 -3.1864498901367188e+02 2.3175599670410156e+02 1.2720600128173828e+02 -3.1872000122070312e+02 2.3060299682617188e+02 1.2523299407958984e+02 -3.1897000122070312e+02 2.3212899780273438e+02 1.2733000183105469e+02 -3.1884802246093750e+02 2.3077000427246094e+02 1.2539300537109375e+02 -3.1913500976562500e+02 2.3234399414062500e+02 1.2770199584960938e+02 -3.1923199462890625e+02 2.3127099609375000e+02 1.2555200195312500e+02 -3.1929901123046875e+02 2.3255799865722656e+02 1.2798799896240234e+02 -3.1961199951171875e+02 2.3182800292968750e+02 1.2579700469970703e+02 -3.1962600708007812e+02 2.3303599548339844e+02 1.2808300781250000e+02 -3.1973901367187500e+02 2.3201400756835938e+02 1.2592199707031250e+02 -3.1986300659179688e+02 2.3342298889160156e+02 1.2834300231933594e+02 -3.2023098754882812e+02 2.3281599426269531e+02 1.2596400451660156e+02 -3.1994198608398438e+02 2.3355099487304688e+02 1.2837600708007812e+02 -3.2034799194335938e+02 2.3302699279785156e+02 1.2604999542236328e+02 -3.2024301147460938e+02 2.3409600830078125e+02 1.2847599792480469e+02 -3.2069998168945312e+02 2.3366198730468750e+02 1.2605200958251953e+02 -3.2052297973632812e+02 2.3465800476074219e+02 1.2440200042724609e+02 -3.1832901000976562e+02 2.3144599914550781e+02 1.2451399993896484e+02 -3.1840802001953125e+02 2.3152301025390625e+02 1.2643299865722656e+02 -3.1808999633789062e+02 2.2990199279785156e+02 1.2660600280761719e+02 -3.1821298217773438e+02 2.3002200317382812e+02 1.2280000305175781e+02 -3.1750000000000000e+02 2.3094999694824219e+02 1.2424299621582031e+02 -3.1671301269531250e+02 2.2876199340820312e+02 1.2432499694824219e+02 -3.1679202270507812e+02 2.2884899902343750e+02 1.2263099670410156e+02 -3.1559197998046875e+02 2.2788099670410156e+02 1.2343700408935547e+02 -3.1588699340820312e+02 2.2788398742675781e+02 1.2341699981689453e+02 -3.1588299560546875e+02 2.2788800048828125e+02 1.2350499725341797e+02 -3.1392199707031250e+02 2.2488899230957031e+02 1.2459799957275391e+02 -3.1434399414062500e+02 2.2493701171875000e+02 1.2370699310302734e+02 -3.1594699096679688e+02 2.2783200073242188e+02 1.2479899597167969e+02 -3.1442098999023438e+02 2.2494601440429688e+02 1.2490600585937500e+02 -3.1621200561523438e+02 2.2759899902343750e+02 1.2605300903320312e+02 -3.1498101806640625e+02 2.2515499877929688e+02 1.2503999328613281e+02 -3.1624099731445312e+02 2.2757301330566406e+02 1.2724800109863281e+02 -3.1559301757812500e+02 2.2551199340820312e+02 1.2630500030517578e+02 -3.1649499511718750e+02 2.2734100341796875e+02 1.2742100524902344e+02 -3.1569497680664062e+02 2.2558900451660156e+02 1.2836599731445312e+02 -3.1624798583984375e+02 2.2601098632812500e+02 1.2443599700927734e+02 -3.2423999023437500e+02 2.4500000000000000e+02 1.2404800415039062e+02 -3.2337399291992188e+02 2.4281500244140625e+02 1.2468899536132812e+02 -3.2427999877929688e+02 2.4489399719238281e+02 1.2433599853515625e+02 -3.2341400146484375e+02 2.4268400573730469e+02 1.2570301055908203e+02 -3.2443698120117188e+02 2.4446701049804688e+02 1.2520100402832031e+02 -3.2353298950195312e+02 2.4229000854492188e+02 1.2613399505615234e+02 -3.2447601318359375e+02 2.4422999572753906e+02 1.2602399444580078e+02 -3.2359201049804688e+02 2.4180400085449219e+02 1.2619400024414062e+02 -3.2373999023437500e+02 2.4207499694824219e+02 1.2313300323486328e+02 -3.2396099853515625e+02 2.4539199829101562e+02 1.2181399536132812e+02 -3.2360198974609375e+02 2.4563699340820312e+02 1.2164099884033203e+02 -3.2279397583007812e+02 2.4341200256347656e+02 1.2166800689697266e+02 -3.2355401611328125e+02 2.4564799499511719e+02 1.2073500061035156e+02 -3.2248699951171875e+02 2.4345700073242188e+02 1.2049800109863281e+02 -3.2317001342773438e+02 2.4573199462890625e+02 1.2043300628662109e+02 -3.2238500976562500e+02 2.4347299194335938e+02 1.2015299987792969e+02 -3.2303698730468750e+02 2.4571600341796875e+02 1.1920400238037109e+02 -3.2267001342773438e+02 2.4567399597167969e+02 1.1925499725341797e+02 -3.2190499877929688e+02 2.4337199401855469e+02 1.1867400360107422e+02 -3.2243402099609375e+02 2.4558599853515625e+02 1.1897299957275391e+02 -3.2177099609375000e+02 2.4330699157714844e+02 1.1794999694824219e+02 -3.2211102294921875e+02 2.4546499633789062e+02 1.1812700653076172e+02 -3.2136599731445312e+02 2.4311099243164062e+02 1.1833699798583984e+02 -3.2061499023437500e+02 2.4092799377441406e+02 1.1786199951171875e+02 -3.2076800537109375e+02 2.4180899047851562e+02 1.1763899993896484e+02 -3.2063601684570312e+02 2.4170599365234375e+02 1.1732900238037109e+02 -3.2092800903320312e+02 2.4281401062011719e+02 1.1940599822998047e+02 -3.2011499023437500e+02 2.3870899963378906e+02 1.1992500305175781e+02 -3.2040399169921875e+02 2.3891299438476562e+02 1.1894799804687500e+02 -3.2095001220703125e+02 2.4115599060058594e+02 1.2020199584960938e+02 -3.2053698730468750e+02 2.3897700500488281e+02 1.1959500122070312e+02 -3.2126000976562500e+02 2.4130499267578125e+02 1.2047900390625000e+02 -3.2067001342773438e+02 2.3904100036621094e+02 1.1980999755859375e+02 -3.2136300659179688e+02 2.4135499572753906e+02 1.2105899810791016e+02 -3.2090499877929688e+02 2.3908999633789062e+02 1.2071199798583984e+02 -3.2172998046875000e+02 2.4143199157714844e+02 1.2094300079345703e+02 -3.2180801391601562e+02 2.4141999816894531e+02 1.2150399780273438e+02 -3.2105599975585938e+02 2.3906800842285156e+02 1.2163600158691406e+02 -3.2204299926757812e+02 2.4138600158691406e+02 1.2165299987792969e+02 -3.2110699462890625e+02 2.3906100463867188e+02 1.2233200073242188e+02 -3.2223300170898438e+02 2.4125898742675781e+02 1.2224900054931641e+02 -3.2126998901367188e+02 2.3895199584960938e+02 1.2256400299072266e+02 -3.2229699707031250e+02 2.4121699523925781e+02 1.2283599853515625e+02 -3.2139199829101562e+02 2.3876699829101562e+02 1.2347699737548828e+02 -3.2248602294921875e+02 2.4092898559570312e+02 1.2499500274658203e+02 -3.2247399902343750e+02 2.3971398925781250e+02 1.2475099945068359e+02 -3.2242797851562500e+02 2.3977600097656250e+02 1.2340299987792969e+02 -3.2147000122070312e+02 2.3850900268554688e+02 1.2369800567626953e+02 -3.2251699829101562e+02 2.4082798767089844e+02 1.2435899353027344e+02 -3.2260800170898438e+02 2.4052700805664062e+02 1.2498900604248047e+02 -3.2265298461914062e+02 2.4015599060058594e+02 1.2393900299072266e+02 -3.2150302124023438e+02 2.3818199157714844e+02 1.2406200408935547e+02 -3.2150000000000000e+02 2.3808500671386719e+02 1.2600700378417969e+02 -3.2266799926757812e+02 2.3945599365234375e+02 1.2443199920654297e+02 -3.2148999023437500e+02 2.3779399108886719e+02 1.2614299011230469e+02 -3.2269400024414062e+02 2.3942098999023438e+02 1.2487400054931641e+02 -3.2143099975585938e+02 2.3735200500488281e+02 1.2722100067138672e+02 -3.2288101196289062e+02 2.3915701293945312e+02 1.2804699707031250e+02 -3.2279501342773438e+02 2.3842399597167969e+02 1.2753500366210938e+02 -3.2294198608398438e+02 2.3909600830078125e+02 1.2754299926757812e+02 -3.2293701171875000e+02 2.3907800292968750e+02 1.2742100524902344e+02 -3.2301199340820312e+02 2.3934500122070312e+02 1.2911100769042969e+02 -3.2450601196289062e+02 2.4210600280761719e+02 1.2691899871826172e+02 -3.2332000732421875e+02 2.4044700622558594e+02 1.2875999450683594e+02 -3.2452700805664062e+02 2.4240699768066406e+02 1.2686300659179688e+02 -3.2335400390625000e+02 2.4056999206542969e+02 1.2805799865722656e+02 -3.2457101440429688e+02 2.4300900268554688e+02 1.2634499359130859e+02 -3.2365301513671875e+02 2.4173699951171875e+02 1.2750000000000000e+02 -3.2455899047851562e+02 2.4339599609375000e+02 1.2691600799560547e+02 -3.2454699707031250e+02 2.4380000305175781e+02 1.3288999938964844e+02 -3.2134698486328125e+02 2.3296899414062500e+02 1.3293299865722656e+02 -3.2182601928710938e+02 2.3390200805664062e+02 1.3289299011230469e+02 -3.2205999755859375e+02 2.3440399169921875e+02 1.3283100891113281e+02 -3.2241201782226562e+02 2.3515699768066406e+02 1.2932200622558594e+02 -3.2181298828125000e+02 2.3550898742675781e+02 1.3268699645996094e+02 -3.2270602416992188e+02 2.3585600280761719e+02 1.3257099914550781e+02 -3.2294100952148438e+02 2.3641499328613281e+02 1.2903399658203125e+02 -3.2220700073242188e+02 2.3651400756835938e+02 1.3166900634765625e+02 -3.2374798583984375e+02 2.3870199584960938e+02 1.2860600280761719e+02 -3.2253598022460938e+02 2.3749198913574219e+02 1.3215699768066406e+02 -3.2340600585937500e+02 2.3765599060058594e+02 1.3227600097656250e+02 -3.2327200317382812e+02 2.3729699707031250e+02 1.3159400939941406e+02 -3.2379998779296875e+02 2.3886300659179688e+02 1.3089199829101562e+02 -3.2411798095703125e+02 2.4001799011230469e+02 1.3087399291992188e+02 -3.2412298583984375e+02 2.4004200744628906e+02 1.3005999755859375e+02 -3.2435400390625000e+02 2.4110400390625000e+02 1.2989099121093750e+02 -3.2438098144531250e+02 2.4128199768066406e+02 1.1472599792480469e+02 -3.2023199462890625e+02 2.4404400634765625e+02 1.1679899597167969e+02 -3.2008599853515625e+02 2.4121501159667969e+02 1.1563699340820312e+02 -3.2084399414062500e+02 2.4460899353027344e+02 1.1593499755859375e+02 -3.2101800537109375e+02 2.4474200439453125e+02 1.1675500488281250e+02 -3.2149899291992188e+02 2.4510900878906250e+02 1.1726000213623047e+02 -3.2175698852539062e+02 2.4525900268554688e+02 1.1461199951171875e+02 -3.2015499877929688e+02 2.4397399902343750e+02 1.1369499969482422e+02 -3.1944400024414062e+02 2.4321200561523438e+02 1.1605799865722656e+02 -3.1951400756835938e+02 2.4060598754882812e+02 1.1365900421142578e+02 -3.1941101074218750e+02 2.4317300415039062e+02 1.1289800262451172e+02 -3.1871899414062500e+02 2.4233500671386719e+02 1.1543000030517578e+02 -3.1892999267578125e+02 2.3988999938964844e+02 1.1276599884033203e+02 -3.1857299804687500e+02 2.4213999938964844e+02 1.1223500061035156e+02 -3.1799099731445312e+02 2.4135600280761719e+02 1.1492700195312500e+02 -3.1834600830078125e+02 2.3908099365234375e+02 1.1204899597167969e+02 -3.1773498535156250e+02 2.4097700500488281e+02 1.1463400268554688e+02 -3.1790499877929688e+02 2.3840600585937500e+02 1.1171399688720703e+02 -3.1727200317382812e+02 2.4028900146484375e+02 1.1152400207519531e+02 -3.1691400146484375e+02 2.3970599365234375e+02 1.1594499969482422e+02 -3.1252099609375000e+02 2.2761100769042969e+02 1.1708699798583984e+02 -3.1254397583007812e+02 2.2682000732421875e+02 1.1716799926757812e+02 -3.1255200195312500e+02 2.2677600097656250e+02 1.1829999542236328e+02 -3.1265499877929688e+02 2.2615400695800781e+02 1.1948400115966797e+02 -3.1483398437500000e+02 2.2866200256347656e+02 1.1858099365234375e+02 -3.1269799804687500e+02 2.2603500366210938e+02 1.1956700134277344e+02 -3.1285101318359375e+02 2.2561999511718750e+02 1.2051399993896484e+02 -3.1501300048828125e+02 2.2826699829101562e+02 1.2005899810791016e+02 -3.1295700073242188e+02 2.2547200012207031e+02 1.2087000274658203e+02 -3.1313101196289062e+02 2.2522799682617188e+02 1.2156999969482422e+02 -3.1526699829101562e+02 2.2800500488281250e+02 1.2157299804687500e+02 -3.1332202148437500e+02 2.2509799194335938e+02 1.2218900299072266e+02 -3.1348898315429688e+02 2.2498300170898438e+02 1.2309599304199219e+02 -3.1378701782226562e+02 2.2491799926757812e+02 1.2580999755859375e+02 -3.2099801635742188e+02 2.3579100036621094e+02 1.2597200012207031e+02 -3.2077600097656250e+02 2.3522599792480469e+02 1.2506500244140625e+02 -3.2137997436523438e+02 2.3710800170898438e+02 1.2525500488281250e+02 -3.2132800292968750e+02 2.3686500549316406e+02 1.2556999969482422e+02 -3.2118298339843750e+02 2.3634100341796875e+02 1.2575699615478516e+02 -3.2104699707031250e+02 2.3592999267578125e+02 1.1905200195312500e+02 -3.1988299560546875e+02 2.3850199890136719e+02 1.1816500091552734e+02 -3.1915600585937500e+02 2.3768800354003906e+02 1.1851800537109375e+02 -3.1948400878906250e+02 2.3808999633789062e+02 1.1893399810791016e+02 -3.1980599975585938e+02 2.3843299865722656e+02 1.1672200012207031e+02 -3.1550799560546875e+02 2.3182099914550781e+02 1.1736399841308594e+02 -3.1538201904296875e+02 2.3109599304199219e+02 1.1890699768066406e+02 -3.1682501220703125e+02 2.3244599914550781e+02 1.1754599761962891e+02 -3.1536801147460938e+02 2.3093399047851562e+02 1.1937500000000000e+02 -3.1678900146484375e+02 2.3202999877929688e+02 1.1809300231933594e+02 -3.1532601928710938e+02 2.3044900512695312e+02 1.1950399780273438e+02 -3.1679098510742188e+02 2.3194000244140625e+02 1.1989100646972656e+02 -3.1679901123046875e+02 2.3167199707031250e+02 1.2044300079345703e+02 -3.1685501098632812e+02 2.3137899780273438e+02 1.2073300170898438e+02 -3.1690499877929688e+02 2.3126699829101562e+02 1.2102200317382812e+02 -3.1695498657226562e+02 2.3115600585937500e+02 1.2161499786376953e+02 -3.1709799194335938e+02 2.3100900268554688e+02 1.2206300354003906e+02 -3.1723498535156250e+02 2.3095700073242188e+02 1.2221199798583984e+02 -3.1728100585937500e+02 2.3094000244140625e+02 1.2360700225830078e+02 -3.1607299804687500e+02 2.2808900451660156e+02 1.1934899902343750e+02 -3.1190499877929688e+02 2.2452700805664062e+02 1.1110099792480469e+02 -3.1768701171875000e+02 2.4222799682617188e+02 1.1917700195312500e+02 -3.1086502075195312e+02 2.2351499938964844e+02 1.2080100250244141e+02 -3.1121298217773438e+02 2.2302600097656250e+02 1.2081400299072266e+02 -3.1222000122070312e+02 2.2408599853515625e+02 1.1003299713134766e+02 -3.1727401733398438e+02 2.4313700866699219e+02 1.0938400268554688e+02 -3.1637701416015625e+02 2.4180599975585938e+02 1.1051499938964844e+02 -3.1687799072265625e+02 2.4102699279785156e+02 1.3679899597167969e+02 -3.2352700805664062e+02 2.3736199951171875e+02 1.3624400329589844e+02 -3.2414999389648438e+02 2.3902499389648438e+02 1.3487599182128906e+02 -3.2402600097656250e+02 2.3852301025390625e+02 1.1629100036621094e+02 -3.0937600708007812e+02 2.2388699340820312e+02 1.1732300567626953e+02 -3.0947000122070312e+02 2.2332000732421875e+02 1.1759700012207031e+02 -3.1061999511718750e+02 2.2417999267578125e+02 1.1031700134277344e+02 -3.1808599853515625e+02 2.4582099914550781e+02 1.0994700622558594e+02 -3.1775000000000000e+02 2.4541500854492188e+02 1.1086100006103516e+02 -3.1818099975585938e+02 2.4435800170898438e+02 1.1143600463867188e+02 -3.1905099487304688e+02 2.4694601440429688e+02 1.1103499603271484e+02 -3.1873898315429688e+02 2.4661199951171875e+02 1.1185400390625000e+02 -3.1908499145507812e+02 2.4545199584960938e+02 1.1270999908447266e+02 -3.1999499511718750e+02 2.4791400146484375e+02 1.1228700256347656e+02 -3.1971099853515625e+02 2.4765199279785156e+02 1.1299800109863281e+02 -3.1997299194335938e+02 2.4640100097656250e+02 1.2503700256347656e+02 -3.1242999267578125e+02 2.2249899291992188e+02 1.2498900604248047e+02 -3.1253601074218750e+02 2.2261900329589844e+02 1.2408699798583984e+02 -3.1220001220703125e+02 2.2260198974609375e+02 1.1627999877929688e+02 -3.1157299804687500e+02 2.2608599853515625e+02 1.1626599884033203e+02 -3.1154598999023438e+02 2.2606300354003906e+02 1.1655899810791016e+02 -3.1155999755859375e+02 2.2587699890136719e+02 1.1051200103759766e+02 -3.1673101806640625e+02 2.4065699768066406e+02 1.1043799591064453e+02 -3.1671301269531250e+02 2.4072900390625000e+02 1.1040700531005859e+02 -3.1670098876953125e+02 2.4074800109863281e+02 1.0832999420166016e+02 -3.1577398681640625e+02 2.4262001037597656e+02 1.0895399475097656e+02 -3.1597097778320312e+02 2.4158898925781250e+02 1.0900799560546875e+02 -3.1602297973632812e+02 2.4161698913574219e+02 1.0907199859619141e+02 -3.1607400512695312e+02 2.4161599731445312e+02 1.0913800048828125e+02 -3.1611499023437500e+02 2.4158500671386719e+02 1.0926399993896484e+02 -3.1618099975585938e+02 2.4149699401855469e+02 1.0891999816894531e+02 -3.1592498779296875e+02 2.4153399658203125e+02 1.0802400207519531e+02 -3.1519601440429688e+02 2.4167999267578125e+02 1.0862699890136719e+02 -3.1533398437500000e+02 2.4055799865722656e+02 1.0782299804687500e+02 -3.1481701660156250e+02 2.4106399536132812e+02 1.0841899871826172e+02 -3.1468798828125000e+02 2.3940800476074219e+02 1.0764999389648438e+02 -3.1427999877929688e+02 2.4010800170898438e+02 1.0835099792480469e+02 -3.1447500610351562e+02 2.3902900695800781e+02 1.0752799987792969e+02 -3.1389999389648438e+02 2.3943099975585938e+02 1.0827799987792969e+02 -3.1366500854492188e+02 2.3745100402832031e+02 1.0748400115966797e+02 -3.1341000366210938e+02 2.3847599792480469e+02 1.0745000457763672e+02 -3.1303500366210938e+02 2.3774499511718750e+02 1.0830000305175781e+02 -3.1354000854492188e+02 2.3718200683593750e+02 1.0752700042724609e+02 -3.1259701538085938e+02 2.3680700683593750e+02 1.0840900421142578e+02 -3.1291699218750000e+02 2.3584700012207031e+02 1.0758999633789062e+02 -3.1223498535156250e+02 2.3603099060058594e+02 1.0860299682617188e+02 -3.1252200317382812e+02 2.3490800476074219e+02 1.0777799987792969e+02 -3.1185299682617188e+02 2.3512400817871094e+02 1.0874099731445312e+02 -3.1223999023437500e+02 2.3423999023437500e+02 1.0794499969482422e+02 -3.1151199340820312e+02 2.3431498718261719e+02 1.0927099609375000e+02 -3.1164602661132812e+02 2.3265299987792969e+02 1.0823299407958984e+02 -3.1118899536132812e+02 2.3345098876953125e+02 1.0851100158691406e+02 -3.1087698364257812e+02 2.3261999511718750e+02 1.0888800048828125e+02 -3.1061300659179688e+02 2.3181100463867188e+02 1.0998999786376953e+02 -3.1114199829101562e+02 2.3111000061035156e+02 1.0927899932861328e+02 -3.1033898925781250e+02 2.3097200012207031e+02 1.1036299896240234e+02 -3.1097299194335938e+02 2.3049600219726562e+02 1.0973100280761719e+02 -3.1013500976562500e+02 2.3022801208496094e+02 1.1088700103759766e+02 -3.1073599243164062e+02 2.2963400268554688e+02 1.1023799896240234e+02 -3.0990499877929688e+02 2.2939399719238281e+02 1.1177200317382812e+02 -3.1048501586914062e+02 2.2847799682617188e+02 1.1075199890136719e+02 -3.0975900268554688e+02 2.2872300720214844e+02 1.1137400054931641e+02 -3.0958300781250000e+02 2.2791099548339844e+02 1.1195100402832031e+02 -3.1043402099609375e+02 2.2824501037597656e+02 1.1193600463867188e+02 -3.0949301147460938e+02 2.2731700134277344e+02 1.1316400146484375e+02 -3.1023999023437500e+02 2.2696398925781250e+02 1.1266999816894531e+02 -3.0937600708007812e+02 2.2654299926757812e+02 1.1349800109863281e+02 -3.1021899414062500e+02 2.2667799377441406e+02 1.1326699829101562e+02 -3.0933898925781250e+02 2.2603100585937500e+02 1.1451100158691406e+02 -3.1015701293945312e+02 2.2581001281738281e+02 1.1566600036621094e+02 -3.1027297973632812e+02 2.2508999633789062e+02 1.1560700225830078e+02 -3.1021697998046875e+02 2.2507699584960938e+02 1.1566699981689453e+02 -3.0931900024414062e+02 2.2423001098632812e+02 1.1570500183105469e+02 -3.1033700561523438e+02 2.2512599182128906e+02 1.1608399963378906e+02 -3.1048199462890625e+02 2.2501100158691406e+02 1.1575900268554688e+02 -3.1046600341796875e+02 2.2521699523925781e+02 1.1553700256347656e+02 -3.1017898559570312e+02 2.2508799743652344e+02 1.1546699523925781e+02 -3.1016400146484375e+02 2.2512200927734375e+02 1.1472499847412109e+02 -3.0930001831054688e+02 2.2488200378417969e+02 1.1410800170898438e+02 -3.0928701782226562e+02 2.2530999755859375e+02 1.1538200378417969e+02 -3.1170401000976562e+02 2.2690100097656250e+02 1.1619100189208984e+02 -3.1170999145507812e+02 2.2631900024414062e+02 1.1623100280761719e+02 -3.1170599365234375e+02 2.2628599548339844e+02 1.1626300048828125e+02 -3.1169302368164062e+02 2.2624800109863281e+02 1.1629500579833984e+02 -3.1164300537109375e+02 2.2616299438476562e+02 1.1449500274658203e+02 -3.1175900268554688e+02 2.2766200256347656e+02 1.1421900177001953e+02 -3.1177600097656250e+02 2.2789799499511719e+02 1.1317099761962891e+02 -3.1194299316406250e+02 2.2900498962402344e+02 1.1300999450683594e+02 -3.1198901367187500e+02 2.2921499633789062e+02 1.1225199890136719e+02 -3.1220401000976562e+02 2.3020500183105469e+02 1.1179599761962891e+02 -3.1241000366210938e+02 2.3095500183105469e+02 1.1147599792480469e+02 -3.1255499267578125e+02 2.3148100280761719e+02 1.1085499572753906e+02 -3.1299002075195312e+02 2.3281300354003906e+02 1.1055199432373047e+02 -3.1671801757812500e+02 2.4056201171875000e+02 1.1055500030517578e+02 -3.1670001220703125e+02 2.4051399230957031e+02 1.1054599761962891e+02 -3.1667599487304688e+02 2.4046899414062500e+02 1.1029899597167969e+02 -3.1617700195312500e+02 2.3964299011230469e+02 1.1011700439453125e+02 -3.1560998535156250e+02 2.3863500976562500e+02 1.1005999755859375e+02 -3.1543499755859375e+02 2.3832200622558594e+02 1.0999699401855469e+02 -3.1473498535156250e+02 2.3695899963378906e+02 1.1001699829101562e+02 -3.1462200927734375e+02 2.3671600341796875e+02 1.1011000061035156e+02 -3.1408798217773438e+02 2.3557299804687500e+02 1.1027899932861328e+02 -3.1374499511718750e+02 2.3475700378417969e+02 1.1039800262451172e+02 -3.1350399780273438e+02 2.3418399047851562e+02 1.2992100524902344e+02 -3.2493902587890625e+02 2.4290899658203125e+02 1.3095300292968750e+02 -3.2477600097656250e+02 2.4182200622558594e+02 1.3097200012207031e+02 -3.2477301025390625e+02 2.4180500793457031e+02 1.3417500305175781e+02 -3.2451800537109375e+02 2.4002799987792969e+02 1.3329899597167969e+02 -3.2491400146484375e+02 2.4146800231933594e+02 1.3208700561523438e+02 -3.2457901000976562e+02 2.4072200012207031e+02 1.3126200866699219e+02 -3.2482000732421875e+02 2.4181300354003906e+02 1.3123300170898438e+02 -3.2480801391601562e+02 2.4179100036621094e+02 1.3113899230957031e+02 -3.2478201293945312e+02 2.4175199890136719e+02 1.3103700256347656e+02 -3.2476998901367188e+02 2.4176399230957031e+02 1.3099099731445312e+02 -3.2477099609375000e+02 2.4178799438476562e+02 1.3256700134277344e+02 -3.2523199462890625e+02 2.4284001159667969e+02 1.3251300048828125e+02 -3.2521502685546875e+02 2.4277900695800781e+02 1.3238400268554688e+02 -3.2518099975585938e+02 2.4267800903320312e+02 1.3259199523925781e+02 -3.2525198364257812e+02 2.4291600036621094e+02 1.3451699829101562e+02 -3.2512200927734375e+02 2.4225000000000000e+02 1.3258599853515625e+02 -3.2526998901367188e+02 2.4299398803710938e+02 1.3344499206542969e+02 -3.2542602539062500e+02 2.4365000915527344e+02 1.3255200195312500e+02 -3.2528298950195312e+02 2.4305699157714844e+02 1.3338099670410156e+02 -3.2544500732421875e+02 2.4373400878906250e+02 1.3254899597167969e+02 -3.2528399658203125e+02 2.4306201171875000e+02 1.3218200683593750e+02 -3.2563598632812500e+02 2.4499900817871094e+02 1.3133900451660156e+02 -3.2547698974609375e+02 2.4433900451660156e+02 1.3208399963378906e+02 -3.2565200805664062e+02 2.4510200500488281e+02 1.3077500915527344e+02 -3.2551101684570312e+02 2.4482199096679688e+02 1.2999301147460938e+02 -3.2555899047851562e+02 2.4549299621582031e+02 1.3078199768066406e+02 -3.2573199462890625e+02 2.4621899414062500e+02 1.3064601135253906e+02 -3.2574002075195312e+02 2.4633500671386719e+02 1.2877499389648438e+02 -3.2553500366210938e+02 2.4633699035644531e+02 1.2926399230957031e+02 -3.2571200561523438e+02 2.4729299926757812e+02 1.2853399658203125e+02 -3.2552999877929688e+02 2.4650399780273438e+02 1.2908799743652344e+02 -3.2570898437500000e+02 2.4741500854492188e+02 1.2764999389648438e+02 -3.2557699584960938e+02 2.4820500183105469e+02 1.2698300170898438e+02 -3.2538900756835938e+02 2.4735600280761719e+02 1.2743100738525391e+02 -3.2555801391601562e+02 2.4832501220703125e+02 1.2657700347900391e+02 -3.2532598876953125e+02 2.4752700805664062e+02 1.2596200561523438e+02 -3.2532998657226562e+02 2.4894400024414062e+02 1.2536400604248047e+02 -3.2513699340820312e+02 2.4803799438476562e+02 1.2570099639892578e+02 -3.2528900146484375e+02 2.4905400085449219e+02 1.2425400543212891e+02 -3.2489898681640625e+02 2.4837200927734375e+02 1.2422499847412109e+02 -3.2497201538085938e+02 2.4949800109863281e+02 1.2369900512695312e+02 -3.2477999877929688e+02 2.4853900146484375e+02 1.2392300415039062e+02 -3.2490701293945312e+02 2.4958898925781250e+02 1.2246099853515625e+02 -3.2451000976562500e+02 2.4986000061035156e+02 1.2201300048828125e+02 -3.2432199096679688e+02 2.4885200500488281e+02 1.2212199401855469e+02 -3.2441799926757812e+02 2.4992300415039062e+02 1.2187400054931641e+02 -3.2427600097656250e+02 2.4886199951171875e+02 1.2069699859619141e+02 -3.2394998168945312e+02 2.5002598571777344e+02 1.2033000183105469e+02 -3.2376901245117188e+02 2.4897299194335938e+02 1.2032399749755859e+02 -3.2382800292968750e+02 2.5005200195312500e+02 1.1950500488281250e+02 -3.2345101928710938e+02 2.4893600463867188e+02 1.1895700073242188e+02 -3.2330001831054688e+02 2.4999200439453125e+02 1.1867500305175781e+02 -3.2313098144531250e+02 2.4889900207519531e+02 1.1495800018310547e+02 -3.2128302001953125e+02 2.4779798889160156e+02 1.1496800231933594e+02 -3.2129898071289062e+02 2.4787699890136719e+02 1.1368700408935547e+02 -3.2065100097656250e+02 2.4851899719238281e+02 1.1411900329589844e+02 -3.2090399169921875e+02 2.4871200561523438e+02 1.1855699920654297e+02 -3.2314498901367188e+02 2.4997399902343750e+02 1.1726499938964844e+02 -3.2256799316406250e+02 2.4975900268554688e+02 1.1720999908447266e+02 -3.2247601318359375e+02 2.4865499877929688e+02 1.1684499359130859e+02 -3.2238098144531250e+02 2.4968899536132812e+02 1.1707299804687500e+02 -3.2241500854492188e+02 2.4863200378417969e+02 1.1564499664306641e+02 -3.2176599121093750e+02 2.4933000183105469e+02 1.1554600524902344e+02 -3.2163302612304688e+02 2.4817599487304688e+02 1.1521399688720703e+02 -3.2154598999023438e+02 2.4920199584960938e+02 1.1506199645996094e+02 -3.2136199951171875e+02 2.4798500061035156e+02 1.1500500488281250e+02 -3.2132699584960938e+02 2.4794299316406250e+02 1.1497599792480469e+02 -3.2128201293945312e+02 2.4771598815917969e+02 1.1427700042724609e+02 -3.2083200073242188e+02 2.4719400024414062e+02 1.1503800201416016e+02 -3.2129098510742188e+02 2.4756098937988281e+02 1.1492800140380859e+02 -3.2089599609375000e+02 2.4588699340820312e+02 1.1561500549316406e+02 -3.2131002807617188e+02 2.4621800231933594e+02 1.1627700042724609e+02 -3.2161901855468750e+02 2.4622500610351562e+02 1.1587599945068359e+02 -3.2139501953125000e+02 2.4606700134277344e+02 1.1583200073242188e+02 -3.2137100219726562e+02 2.4605599975585938e+02 1.1578399658203125e+02 -3.2135000610351562e+02 2.4605799865722656e+02 1.1569499969482422e+02 -3.2131900024414062e+02 2.4609999084472656e+02 1.1563099670410156e+02 -3.2130899047851562e+02 2.4618299865722656e+02 1.1759600067138672e+02 -3.2229400634765625e+02 2.4661900329589844e+02 1.1772900390625000e+02 -3.2235400390625000e+02 2.4664099121093750e+02 1.1897999572753906e+02 -3.2291201782226562e+02 2.4684899902343750e+02 1.1970700073242188e+02 -3.2319302368164062e+02 2.4688099670410156e+02 1.2041000366210938e+02 -3.2346401977539062e+02 2.4691299438476562e+02 1.2174900054931641e+02 -3.2390402221679688e+02 2.4681698608398438e+02 1.2186299896240234e+02 -3.2394201660156250e+02 2.4680801391601562e+02 1.2331999969482422e+02 -3.2433798217773438e+02 2.4653799438476562e+02 1.2379900360107422e+02 -3.2444000244140625e+02 2.4639299011230469e+02 1.2475900268554688e+02 -3.2464599609375000e+02 2.4610499572753906e+02 1.2580199432373047e+02 -3.2480801391601562e+02 2.4566600036621094e+02 1.2615799713134766e+02 -3.2486297607421875e+02 2.4551600646972656e+02 1.2749800109863281e+02 -3.2498498535156250e+02 2.4477900695800781e+02 1.2769700622558594e+02 -3.2498898315429688e+02 2.4464100646972656e+02 1.2875799560546875e+02 -3.2501098632812500e+02 2.4390600585937500e+02 1.2942098999023438e+02 -3.2497000122070312e+02 2.4333700561523438e+02 1.2377799987792969e+02 -3.1310900878906250e+02 2.2370399475097656e+02 1.2459100341796875e+02 -3.1341299438476562e+02 2.2371899414062500e+02 1.2458100128173828e+02 -3.1343499755859375e+02 2.2374899291992188e+02 1.2458000183105469e+02 -3.1350100708007812e+02 2.2383000183105469e+02 1.2462699890136719e+02 -3.1356900024414062e+02 2.2389300537109375e+02 1.2466600036621094e+02 -3.1359799194335938e+02 2.2391099548339844e+02 1.2471199798583984e+02 -3.1362100219726562e+02 2.2391999816894531e+02 1.2582799530029297e+02 -3.1258599853515625e+02 2.2240400695800781e+02 1.2528599548339844e+02 -3.1236599731445312e+02 2.2235800170898438e+02 1.2493000030517578e+02 -3.1139300537109375e+02 2.2161500549316406e+02 1.2520999908447266e+02 -3.1234802246093750e+02 2.2236500549316406e+02 1.2443000030517578e+02 -3.1119900512695312e+02 2.2159300231933594e+02 1.2513500213623047e+02 -3.1235400390625000e+02 2.2239399719238281e+02 1.2507399749755859e+02 -3.1238299560546875e+02 2.2244100952148438e+02 1.2619799041748047e+02 -3.1188198852539062e+02 2.2167100524902344e+02 1.2665000915527344e+02 -3.1208398437500000e+02 2.2174600219726562e+02 1.2743100738525391e+02 -3.1330200195312500e+02 2.2266999816894531e+02 1.2790900421142578e+02 -3.1264599609375000e+02 2.2195599365234375e+02 1.2756100463867188e+02 -3.1336901855468750e+02 2.2270899963378906e+02 1.2830899047851562e+02 -3.1285101318359375e+02 2.2207499694824219e+02 1.2895800781250000e+02 -3.1408398437500000e+02 2.2312599182128906e+02 1.2953999328613281e+02 -3.1348199462890625e+02 2.2244299316406250e+02 1.2967399597167969e+02 -3.1450399780273438e+02 2.2344699096679688e+02 1.2988600158691406e+02 -3.1368399047851562e+02 2.2259800720214844e+02 1.3038699340820312e+02 -3.1492098999023438e+02 2.2376499938964844e+02 1.3106698608398438e+02 -3.1437600708007812e+02 2.2312500000000000e+02 1.3135699462890625e+02 -3.1457098388671875e+02 2.2330500793457031e+02 1.3158898925781250e+02 -3.1572799682617188e+02 2.2450999450683594e+02 1.3246699523925781e+02 -3.1531597900390625e+02 2.2399299621582031e+02 1.3169700622558594e+02 -3.1580099487304688e+02 2.2457699584960938e+02 1.3270300292968750e+02 -3.1549899291992188e+02 2.2418899536132812e+02 1.3287001037597656e+02 -3.1671099853515625e+02 2.2555099487304688e+02 1.3372000122070312e+02 -3.1628799438476562e+02 2.2503300476074219e+02 1.3320899963378906e+02 -3.1701898193359375e+02 2.2592399597167969e+02 1.3390399169921875e+02 -3.1645599365234375e+02 2.2523599243164062e+02 1.3388800048828125e+02 -3.1763699340820312e+02 2.2667098999023438e+02 1.3480700683593750e+02 -3.1727798461914062e+02 2.2622999572753906e+02 1.3494400024414062e+02 -3.1742700195312500e+02 2.2643199157714844e+02 1.3452400207519531e+02 -3.1833401489257812e+02 2.2760899353027344e+02 1.3571299743652344e+02 -3.1827099609375000e+02 2.2756700134277344e+02 1.3473600769042969e+02 -3.1856701660156250e+02 2.2792300415039062e+02 1.3580699157714844e+02 -3.1840100097656250e+02 2.2775900268554688e+02 1.3540199279785156e+02 -3.1948699951171875e+02 2.2928799438476562e+02 1.3642500305175781e+02 -3.1925299072265625e+02 2.2902500915527344e+02 1.3548100280761719e+02 -3.1963500976562500e+02 2.2952799987792969e+02 1.3648199462890625e+02 -3.1936099243164062e+02 2.2920100402832031e+02 1.3587699890136719e+02 -3.2038302612304688e+02 2.3074499511718750e+02 1.3693200683593750e+02 -3.2021002197265625e+02 2.3058099365234375e+02 1.3695899963378906e+02 -3.2029699707031250e+02 2.3073500061035156e+02 1.3603700256347656e+02 -3.2088198852539062e+02 2.3163299560546875e+02 1.3722599792480469e+02 -3.2112802124023438e+02 2.3221400451660156e+02 1.3615299987792969e+02 -3.2124200439453125e+02 2.3227400207519531e+02 1.3622599792480469e+02 -3.2204898071289062e+02 2.3384700012207031e+02 1.3723200988769531e+02 -3.2119302368164062e+02 2.3234100341796875e+02 1.3730398559570312e+02 -3.2199298095703125e+02 2.3389999389648438e+02 1.3622399902343750e+02 -3.2205099487304688e+02 2.3385200500488281e+02 1.3620799255371094e+02 -3.2208300781250000e+02 2.3391600036621094e+02 1.3729600524902344e+02 -3.2203799438476562e+02 2.3399700927734375e+02 1.3616000366210938e+02 -3.2211300659179688e+02 2.3397299194335938e+02 1.3716499328613281e+02 -3.2279199218750000e+02 2.3561399841308594e+02 1.3608999633789062e+02 -3.2213299560546875e+02 2.3400999450683594e+02 1.3600698852539062e+02 -3.2214001464843750e+02 2.3402099609375000e+02 1.3571701049804688e+02 -3.2278698730468750e+02 2.3540699768066406e+02 1.3583999633789062e+02 -3.2214099121093750e+02 2.3401499938964844e+02 1.3426899719238281e+02 -3.2265899658203125e+02 2.3525500488281250e+02 1.3438000488281250e+02 -3.2207699584960938e+02 2.3399899291992188e+02 1.3416899108886719e+02 -3.2201400756835938e+02 2.3391300964355469e+02 1.3424099731445312e+02 -3.2205297851562500e+02 2.3397700500488281e+02 1.3434199523925781e+02 -3.2207299804687500e+02 2.3399899291992188e+02 1.3414900207519531e+02 -3.2199200439453125e+02 2.3387100219726562e+02 1.3414601135253906e+02 -3.2198001098632812e+02 2.3384899902343750e+02 1.3414299011230469e+02 -3.2196798706054688e+02 2.3382499694824219e+02 1.3407998657226562e+02 -3.2127999877929688e+02 2.3248500061035156e+02 1.3397698974609375e+02 -3.2096200561523438e+02 2.3191801452636719e+02 1.3384098815917969e+02 -3.2053802490234375e+02 2.3116500854492188e+02 1.3349600219726562e+02 -3.1988702392578125e+02 2.3010499572753906e+02 1.3343099975585938e+02 -3.1976397705078125e+02 2.2990599060058594e+02 1.3285600280761719e+02 -3.1897000122070312e+02 2.2872700500488281e+02 1.3266999816894531e+02 -3.1876599121093750e+02 2.2845199584960938e+02 1.3212298583984375e+02 -3.1816699218750000e+02 2.2764498901367188e+02 1.3153700256347656e+02 -3.1763299560546875e+02 2.2700000000000000e+02 1.3124400329589844e+02 -3.1736599731445312e+02 2.2667700195312500e+02 1.3022999572753906e+02 -3.1657998657226562e+02 2.2583599853515625e+02 1.2515999603271484e+02 -3.1380297851562500e+02 2.2395800781250000e+02 1.2654399871826172e+02 -3.1442098999023438e+02 2.2418899536132812e+02 1.2667099761962891e+02 -3.1448599243164062e+02 2.2422698974609375e+02 1.2786300659179688e+02 -3.1509597778320312e+02 2.2458299255371094e+02 1.2849099731445312e+02 -3.1546398925781250e+02 2.2486299133300781e+02 1.2909799194335938e+02 -3.1582000732421875e+02 2.2513499450683594e+02 1.3014100646972656e+02 -3.1652001953125000e+02 2.2578099060058594e+02 1.3455299377441406e+02 -3.2510501098632812e+02 2.4219099426269531e+02 1.3547599792480469e+02 -3.2468798828125000e+02 2.4067300415039062e+02 1.3549000549316406e+02 -3.2467800903320312e+02 2.4064199829101562e+02 1.0859799957275391e+02 -3.1614498901367188e+02 2.4316999816894531e+02 1.0904100036621094e+02 -3.1675601196289062e+02 2.4407800292968750e+02 1.0936599731445312e+02 -3.1711199951171875e+02 2.4455699157714844e+02 1.1794299316406250e+02 -3.0956597900390625e+02 2.2305900573730469e+02 1.1905300140380859e+02 -3.0973800659179688e+02 2.2259100341796875e+02 1.1965700531005859e+02 -3.0986801147460938e+02 2.2240998840332031e+02 1.2083200073242188e+02 -3.1011999511718750e+02 2.2205599975585938e+02 1.2140899658203125e+02 -3.1027697753906250e+02 2.2194898986816406e+02 1.2317500305175781e+02 -3.1078698730468750e+02 2.2168299865722656e+02 1.2244599914550781e+02 -3.1166101074218750e+02 2.2272000122070312e+02 1.2263300323486328e+02 -3.1060900878906250e+02 2.2172099304199219e+02 1.3715100097656250e+02 -3.2281900024414062e+02 2.3567800903320312e+02 1.3680900573730469e+02 -3.2351498413085938e+02 2.3733000183105469e+02 1.3539299011230469e+02 -3.2344601440429688e+02 2.3697500610351562e+02 1.3287701416015625e+02 -3.2422097778320312e+02 2.3942300415039062e+02 1.3350999450683594e+02 -3.2377801513671875e+02 2.3806500244140625e+02 1.1274299621582031e+02 -3.1932101440429688e+02 2.4431500244140625e+02 1.1377500152587891e+02 -3.2012200927734375e+02 2.4517199707031250e+02 1.1184700012207031e+02 -3.1850497436523438e+02 2.4332901000976562e+02 1.1792299652099609e+02 -3.1168402099609375e+02 2.2512699890136719e+02 1.2229699707031250e+02 -3.1262298583984375e+02 2.2380999755859375e+02 1.3397599792480469e+02 -3.2325500488281250e+02 2.3666900634765625e+02 1.0763899993896484e+02 -3.1169302368164062e+02 2.3516200256347656e+02 1.0738500213623047e+02 -3.1244598388671875e+02 2.3686500549316406e+02 1.0734199523925781e+02 -3.1326898193359375e+02 2.3855400085449219e+02 1.0751100158691406e+02 -3.1414898681640625e+02 2.4020500183105469e+02 1.0788899993896484e+02 -3.1507598876953125e+02 2.4179600524902344e+02 1.0847100067138672e+02 -3.1603598022460938e+02 2.4330299377441406e+02 1.0924800109863281e+02 -3.1701498413085938e+02 2.4470600891113281e+02 1.1020999908447266e+02 -3.1799899291992188e+02 2.4598400878906250e+02 1.1134400177001953e+02 -3.1897601318359375e+02 2.4712100219726562e+02 1.1263299560546875e+02 -3.1993099975585938e+02 2.4809999084472656e+02 1.1895299530029297e+02 -3.2327200317382812e+02 2.5019801330566406e+02 1.2071300506591797e+02 -3.2392901611328125e+02 2.5023100280761719e+02 1.2249700164794922e+02 -3.2449499511718750e+02 2.5006198120117188e+02 1.2427899932861328e+02 -3.2496099853515625e+02 2.4969500732421875e+02 1.2603600311279297e+02 -3.2532199096679688e+02 2.4913301086425781e+02 1.2774200439453125e+02 -3.2557202148437500e+02 2.4838499450683594e+02 1.2937199401855469e+02 -3.2570700073242188e+02 2.4746200561523438e+02 1.3090499877929688e+02 -3.2572601318359375e+02 2.4637500000000000e+02 1.3231900024414062e+02 -3.2562802124023438e+02 2.4514100646972656e+02 1.3359400939941406e+02 -3.2541497802734375e+02 2.4377700805664062e+02 1.0759100341796875e+02 -3.1151898193359375e+02 2.3522500610351562e+02 1.0805599975585938e+02 -3.1084298706054688e+02 2.3352099609375000e+02 1.0809999847412109e+02 -3.1102099609375000e+02 2.3346899414062500e+02 1.3579299926757812e+02 -3.2456799316406250e+02 2.4083699035644531e+02 1.3484199523925781e+02 -3.2500399780273438e+02 2.4241200256347656e+02 1.3471199035644531e+02 -3.2508999633789062e+02 2.4230200195312500e+02 1.3757699584960938e+02 -3.2253201293945312e+02 2.3586900329589844e+02 1.3721499633789062e+02 -3.2325198364257812e+02 2.3758499145507812e+02 1.3712400817871094e+02 -3.2339797973632812e+02 2.3750199890136719e+02 1.3772599792480469e+02 -3.2173602294921875e+02 2.3415499877929688e+02 1.3748399353027344e+02 -3.2267901611328125e+02 2.3578999328613281e+02 1.3766300964355469e+02 -3.2087500000000000e+02 2.3246699523925781e+02 1.3763398742675781e+02 -3.2188497924804688e+02 2.3408000183105469e+02 1.3738699340820312e+02 -3.1996200561523438e+02 2.3082899475097656e+02 1.3756999206542969e+02 -3.2102700805664062e+02 2.3239601135253906e+02 1.3690200805664062e+02 -3.1900900268554688e+02 2.2926400756835938e+02 1.3729499816894531e+02 -3.2011499023437500e+02 2.3076200866699219e+02 1.3621499633789062e+02 -3.1802899169921875e+02 2.2779299926757812e+02 1.3681100463867188e+02 -3.1916400146484375e+02 2.2920001220703125e+02 1.3533599853515625e+02 -3.1703698730468750e+02 2.2643800354003906e+02 1.3612500000000000e+02 -3.1818701171875000e+02 2.2773300170898438e+02 1.3427700805664062e+02 -3.1604598999023438e+02 2.2521800231933594e+02 1.3524800109863281e+02 -3.1719699096679688e+02 2.2638099670410156e+02 1.3305300903320312e+02 -3.1507000732421875e+02 2.2414900207519531e+02 1.3419200134277344e+02 -3.1620800781250000e+02 2.2516299438476562e+02 1.3168099975585938e+02 -3.1412197875976562e+02 2.2324598693847656e+02 1.3297000122070312e+02 -3.1523400878906250e+02 2.2409700012207031e+02 1.3018000793457031e+02 -3.1321701049804688e+02 2.2252301025390625e+02 1.3160200500488281e+02 -3.1428900146484375e+02 2.2319599914550781e+02 1.2857200622558594e+02 -3.1236700439453125e+02 2.2199000549316406e+02 1.3010400390625000e+02 -3.1338598632812500e+02 2.2247500610351562e+02 1.2687900543212891e+02 -3.1158398437500000e+02 2.2165299987792969e+02 1.2850000000000000e+02 -3.1253799438476562e+02 2.2194198608398438e+02 1.2512500762939453e+02 -3.1087802124023438e+02 2.2151699829101562e+02 1.2681099700927734e+02 -3.1175601196289062e+02 2.2160600280761719e+02 1.2333399963378906e+02 -3.1026000976562500e+02 2.2158599853515625e+02 1.2506100463867188e+02 -3.1105200195312500e+02 2.2147099304199219e+02 1.2153100585937500e+02 -3.0973898315429688e+02 2.2185699462890625e+02 1.2327400207519531e+02 -3.1043600463867188e+02 2.2153900146484375e+02 1.1974299621582031e+02 -3.0932098388671875e+02 2.2232598876953125e+02 1.2147600555419922e+02 -3.0991500854492188e+02 2.2180999755859375e+02 1.1799400329589844e+02 -3.0901300048828125e+02 2.2298799133300781e+02 1.1969100189208984e+02 -3.0949801635742188e+02 2.2227799987792969e+02 1.1630800628662109e+02 -3.0881802368164062e+02 2.2383299255371094e+02 1.1794599914550781e+02 -3.0919097900390625e+02 2.2293800354003906e+02 1.1470899963378906e+02 -3.0873999023437500e+02 2.2484800720214844e+02 1.1626399993896484e+02 -3.0899700927734375e+02 2.2378100585937500e+02 1.1322000122070312e+02 -3.0878002929687500e+02 2.2602101135253906e+02 1.1466900634765625e+02 -3.0891900634765625e+02 2.2479499816894531e+02 1.1186100006103516e+02 -3.0893701171875000e+02 2.2733299255371094e+02 1.1318299865722656e+02 -3.0895901489257812e+02 2.2596398925781250e+02 1.1065200042724609e+02 -3.0920898437500000e+02 2.2876800537109375e+02 1.1182700347900391e+02 -3.0911499023437500e+02 2.2727400207519531e+02 1.0961000061035156e+02 -3.0959201049804688e+02 2.3030400085449219e+02 1.1062099456787109e+02 -3.0938699340820312e+02 2.2870500183105469e+02 1.0874900054931641e+02 -3.1008099365234375e+02 2.3192100524902344e+02 1.0958100128173828e+02 -3.0976901245117188e+02 2.3023800659179688e+02 1.0808100128173828e+02 -3.1066799926757812e+02 2.3359500122070312e+02 1.0872200012207031e+02 -3.1025601196289062e+02 2.3185099792480469e+02 1.2080599975585938e+02 -3.2369100952148438e+02 2.5050500488281250e+02 1.1902999877929688e+02 -3.2302798461914062e+02 2.5047201538085938e+02 1.1897999572753906e+02 -3.2317401123046875e+02 2.5035899353027344e+02 1.2260500335693359e+02 -3.2426199340820312e+02 2.5033500671386719e+02 1.2075099945068359e+02 -3.2383599853515625e+02 2.5039300537109375e+02 1.2440399932861328e+02 -3.2473199462890625e+02 2.4996400451660156e+02 1.2254699707031250e+02 -3.2440502929687500e+02 2.5022300720214844e+02 1.2617600250244141e+02 -3.2509600830078125e+02 2.4939799499511719e+02 1.2434100341796875e+02 -3.2487500000000000e+02 2.4985299682617188e+02 1.2789699554443359e+02 -3.2534799194335938e+02 2.4864299011230469e+02 1.2610900115966797e+02 -3.2523699951171875e+02 2.4928799438476562e+02 1.2954199218750000e+02 -3.2548400878906250e+02 2.4771099853515625e+02 1.2782600402832031e+02 -3.2548901367187500e+02 2.4853500366210938e+02 1.3108900451660156e+02 -3.2550299072265625e+02 2.4661499023437500e+02 1.2946798706054688e+02 -3.2562500000000000e+02 2.4760499572753906e+02 1.3251499938964844e+02 -3.2540499877929688e+02 2.4537100219726562e+02 1.3101100158691406e+02 -3.2564398193359375e+02 2.4651199340820312e+02 1.3380099487304688e+02 -3.2519000244140625e+02 2.4399400329589844e+02 1.3243399047851562e+02 -3.2554598999023438e+02 2.4527000427246094e+02 1.3492900085449219e+02 -3.2486199951171875e+02 2.4250599670410156e+02 1.3371699523925781e+02 -3.2533099365234375e+02 2.4389700317382812e+02 1.3588200378417969e+02 -3.2442501831054688e+02 2.4092700195312500e+02 1.3664799499511719e+02 -3.2388601684570312e+02 2.3927900695800781e+02 1.0761599731445312e+02 -3.1134600830078125e+02 2.3530299377441406e+02 1.0736000061035156e+02 -3.1210601806640625e+02 2.3702099609375000e+02 1.3655699157714844e+02 -3.2402999877929688e+02 2.3919200134277344e+02 1.1560200500488281e+02 -3.2172201538085938e+02 2.4953100585937500e+02 1.1724100494384766e+02 -3.2253302001953125e+02 2.4996299743652344e+02 1.1725699615478516e+02 -3.2243002319335938e+02 2.5012300109863281e+02 1.1730300140380859e+02 -3.2228198242187500e+02 2.5023498535156250e+02 1.1560700225830078e+02 -3.2161398315429688e+02 2.4968800354003906e+02 1.1405899810791016e+02 -3.2085000610351562e+02 2.4890699768066406e+02 1.3697799682617188e+02 -3.2349398803710938e+02 2.3742399597167969e+02 1.3641600036621094e+02 -3.2412298583984375e+02 2.3910299682617188e+02 1.3565699768066406e+02 -3.2465698242187500e+02 2.4073699951171875e+02 1.1565000152587891e+02 -3.2146398925781250e+02 2.4979899597167969e+02 1.1405400085449219e+02 -3.2073699951171875e+02 2.4905999755859375e+02 1.1409299468994141e+02 -3.2058502197265625e+02 2.4916900634765625e+02 1.1261799621582031e+02 -3.1981097412109375e+02 2.4824800109863281e+02 1.1265399932861328e+02 -3.1965701293945312e+02 2.4835499572753906e+02 1.1132099914550781e+02 -3.1885000610351562e+02 2.4726300048828125e+02 1.1135400390625000e+02 -3.1869400024414062e+02 2.4736799621582031e+02 1.1018000030517578e+02 -3.1786700439453125e+02 2.4611799621582031e+02 1.1020999908447266e+02 -3.1770797729492188e+02 2.4622100830078125e+02 1.0921099853515625e+02 -3.1687600708007812e+02 2.4483099365234375e+02 1.0923899841308594e+02 -3.1671499633789062e+02 2.4493099975585938e+02 1.0842900085449219e+02 -3.1589001464843750e+02 2.4341900634765625e+02 1.0845500183105469e+02 -3.1572698974609375e+02 2.4351599121093750e+02 1.0784299468994141e+02 -3.1492401123046875e+02 2.4190199279785156e+02 1.0786800384521484e+02 -3.1475897216796875e+02 2.4199501037597656e+02 1.0746300506591797e+02 -3.1399099731445312e+02 2.4030200195312500e+02 1.0748699951171875e+02 -3.1382400512695312e+02 2.4039100646972656e+02 1.0729299926757812e+02 -3.1310498046875000e+02 2.3863999938964844e+02 1.0731600189208984e+02 -3.1293600463867188e+02 2.3872500610351562e+02 1.0733599853515625e+02 -3.1227697753906250e+02 2.3694000244140625e+02 1.0876200103759766e+02 -3.1043899536132812e+02 2.3180999755859375e+02 1.0961599731445312e+02 -3.0995397949218750e+02 2.3020799255371094e+02 1.1064899444580078e+02 -3.0957498168945312e+02 2.2868501281738281e+02 1.1184700012207031e+02 -3.0930502319335938e+02 2.2726300048828125e+02 1.1319400024414062e+02 -3.0914898681640625e+02 2.2596200561523438e+02 1.1466999816894531e+02 -3.0910998535156250e+02 2.2480000305175781e+02 1.1625400543212891e+02 -3.0918698120117188e+02 2.2379299926757812e+02 1.1792600250244141e+02 -3.0938000488281250e+02 2.2295600891113281e+02 1.1965999603271484e+02 -3.0968600463867188e+02 2.2229998779296875e+02 1.2143199920654297e+02 -3.1009997558593750e+02 2.2183399963378906e+02 1.2321900177001953e+02 -3.1061700439453125e+02 2.2156600952148438e+02 1.2499400329589844e+02 -3.1122900390625000e+02 2.2149800109863281e+02 1.2673300170898438e+02 -3.1192898559570312e+02 2.2163200378417969e+02 1.2841099548339844e+02 -3.1270501708984375e+02 2.2196600341796875e+02 1.3000500488281250e+02 -3.1354800415039062e+02 2.2249501037597656e+02 1.3149200439453125e+02 -3.1444497680664062e+02 2.2321200561523438e+02 1.3285200500488281e+02 -3.1538400268554688e+02 2.2410600280761719e+02 1.3406500244140625e+02 -3.1635098266601562e+02 2.2516600036621094e+02 1.3511499023437500e+02 -3.1733398437500000e+02 2.2637599182128906e+02 1.3598699951171875e+02 -3.1831698608398438e+02 2.2771899414062500e+02 1.3666699218750000e+02 -3.1928799438476562e+02 2.2917599487304688e+02 1.3714799499511719e+02 -3.2023300170898438e+02 2.3072799682617188e+02 1.3742199707031250e+02 -3.2113900756835938e+02 2.3235099792480469e+02 1.3748500061035156e+02 -3.2199200439453125e+02 2.3402400207519531e+02 1.3733599853515625e+02 -3.2278100585937500e+02 2.3572300720214844e+02 1.0855300140380859e+02 -3.1280099487304688e+02 2.3754699707031250e+02 1.1573500061035156e+02 -3.0942999267578125e+02 2.2548599243164062e+02 1.1375299835205078e+02 -3.0947500610351562e+02 2.2702999877929688e+02 1.1202799987792969e+02 -3.0974298095703125e+02 2.2883599853515625e+02 1.1060900115966797e+02 -3.1022702026367188e+02 2.3085099792480469e+02 1.0953799438476562e+02 -3.1091201782226562e+02 2.3301699829101562e+02 1.0884600067138672e+02 -3.1177801513671875e+02 2.3527101135253906e+02 1.0866799926757812e+02 -3.1395001220703125e+02 2.3977799987792969e+02 1.0918699645996094e+02 -3.1519100952148438e+02 2.4189900207519531e+02 1.2213999938964844e+02 -3.2354598999023438e+02 2.4923400878906250e+02 1.1532899475097656e+02 -3.2062799072265625e+02 2.4834899902343750e+02 1.1747500610351562e+02 -3.2174499511718750e+02 2.4902699279785156e+02 1.1976700592041016e+02 -3.2272698974609375e+02 2.4932501220703125e+02 1.2452399444580078e+02 -3.2417700195312500e+02 2.4875700378417969e+02 1.2904899597167969e+02 -3.2480902099609375e+02 2.4671099853515625e+02 1.2684999084472656e+02 -3.2460202026367188e+02 2.4790798950195312e+02 1.3105699157714844e+02 -3.2479101562500000e+02 2.4520300292968750e+02 1.3281599426269531e+02 -3.2454998779296875e+02 2.4342599487304688e+02 1.3649299621582031e+02 -3.2131500244140625e+02 2.3421099853515625e+02 1.3632899475097656e+02 -3.2015298461914062e+02 2.3198999023437500e+02 1.3576098632812500e+02 -3.1890298461914062e+02 2.2988699340820312e+02 1.3480700683593750e+02 -3.1760098266601562e+02 2.2796200561523438e+02 1.3349400329589844e+02 -3.1628399658203125e+02 2.2627299499511719e+02 1.3186100769042969e+02 -3.1499298095703125e+02 2.2486799621582031e+02 1.2995498657226562e+02 -3.1376300048828125e+02 2.2378900146484375e+02 1.2555299377441406e+02 -3.1163201904296875e+02 2.2272200012207031e+02 1.2783199310302734e+02 -3.1263198852539062e+02 2.2306600952148438e+02 1.1282900238037109e+02 -3.1617700195312500e+02 2.3616200256347656e+02 1.1325500488281250e+02 -3.1665200805664062e+02 2.3668899536132812e+02 1.1370000457763672e+02 -3.1714697265625000e+02 2.3724000549316406e+02 1.1397399902343750e+02 -3.1743899536132812e+02 2.3758000183105469e+02 1.1458300018310547e+02 -3.1808700561523438e+02 2.3833499145507812e+02 1.1314900207519531e+02 -3.1631402587890625e+02 2.3610598754882812e+02 1.1318399810791016e+02 -3.1606500244140625e+02 2.3557800292968750e+02 1.1338400268554688e+02 -3.1556002807617188e+02 2.3441400146484375e+02 1.1339700317382812e+02 -3.1554400634765625e+02 2.3437300109863281e+02 1.1375099945068359e+02 -3.1512298583984375e+02 2.3326399230957031e+02 1.1402799987792969e+02 -3.1493197631835938e+02 2.3267599487304688e+02 1.1427700042724609e+02 -3.1476101684570312e+02 2.3214900207519531e+02 1.1495199584960938e+02 -3.1448300170898438e+02 2.3109300231933594e+02 1.1496700286865234e+02 -3.1448001098632812e+02 2.3107600402832031e+02 1.1576300048828125e+02 -3.1429299926757812e+02 2.3011599731445312e+02 1.1623699951171875e+02 -3.1424398803710938e+02 2.2966799926757812e+02 1.1669400024414062e+02 -3.1419598388671875e+02 2.2923600769042969e+02 1.1772699737548828e+02 -3.1419198608398438e+02 2.2847200012207031e+02 1.1862699890136719e+02 -3.1550198364257812e+02 2.2993699645996094e+02 1.1651499938964844e+02 -3.1572198486328125e+02 2.3192800903320312e+02 1.1512500000000000e+02 -3.1712500000000000e+02 2.3577600097656250e+02 1.1515100097656250e+02 -3.1693499755859375e+02 2.3537300109863281e+02 1.1530400085449219e+02 -3.1654800415039062e+02 2.3448200988769531e+02 1.1531400299072266e+02 -3.1653698730468750e+02 2.3445098876953125e+02 1.1558499908447266e+02 -3.1621398925781250e+02 2.3360200500488281e+02 1.1579699707031250e+02 -3.1606799316406250e+02 2.3315299987792969e+02 1.1598799896240234e+02 -3.1593701171875000e+02 2.3275000000000000e+02 1.1650399780273438e+02 -3.1572500610351562e+02 2.3194200134277344e+02 1.1712500000000000e+02 -3.1557901000976562e+02 2.3119400024414062e+02 1.1748699951171875e+02 -3.1554098510742188e+02 2.3085198974609375e+02 1.1783699798583984e+02 -3.1550500488281250e+02 2.3052099609375000e+02 1.1558700561523438e+02 -3.1730700683593750e+02 2.3570300292968750e+02 1.1508000183105469e+02 -3.1770898437500000e+02 2.3701399230957031e+02 1.1500599670410156e+02 -3.1776498413085938e+02 2.3721099853515625e+02 1.1539099884033203e+02 -3.1746200561523438e+02 2.3621099853515625e+02 1.2660999298095703e+02 -3.1674002075195312e+02 2.2718800354003906e+02 1.2581199645996094e+02 -3.1657998657226562e+02 2.2733500671386719e+02 1.2497799682617188e+02 -3.1641198730468750e+02 2.2748799133300781e+02 1.2447399902343750e+02 -3.1630099487304688e+02 2.2758599853515625e+02 1.2335500335693359e+02 -3.1605398559570312e+02 2.2780300903320312e+02 1.2642200469970703e+02 -3.1685598754882812e+02 2.2746301269531250e+02 1.2688499450683594e+02 -3.1713500976562500e+02 2.2768499755859375e+02 1.2782800292968750e+02 -3.1777301025390625e+02 2.2827899169921875e+02 1.2785800170898438e+02 -3.1779699707031250e+02 2.2830499267578125e+02 1.2865400695800781e+02 -3.1843502807617188e+02 2.2900801086425781e+02 1.2901799011230469e+02 -3.1878900146484375e+02 2.2945498657226562e+02 1.2934399414062500e+02 -3.1910699462890625e+02 2.2985600280761719e+02 1.2988800048828125e+02 -3.1977700805664062e+02 2.3080799865722656e+02 1.2989500427246094e+02 -3.1978900146484375e+02 2.3082600402832031e+02 1.3027200317382812e+02 -3.2043099975585938e+02 2.3184399414062500e+02 1.3038400268554688e+02 -3.2075000000000000e+02 2.3240299987792969e+02 1.3049099731445312e+02 -3.2105700683593750e+02 2.3294400024414062e+02 1.3053999328613281e+02 -3.2164199829101562e+02 2.3408601379394531e+02 1.2842900085449219e+02 -3.2120098876953125e+02 2.3423098754882812e+02 1.2793500518798828e+02 -3.1978399658203125e+02 2.3173699951171875e+02 1.2527899169921875e+02 -3.1753997802734375e+02 2.2916400146484375e+02 1.2563300323486328e+02 -3.1775399780273438e+02 2.2933499145507812e+02 1.2635501098632812e+02 -3.1824200439453125e+02 2.2978900146484375e+02 1.2637699890136719e+02 -3.1826000976562500e+02 2.2980900573730469e+02 1.2698600006103516e+02 -3.1874798583984375e+02 2.3034599304199219e+02 1.2726399230957031e+02 -3.1901898193359375e+02 2.3068800354003906e+02 1.2751499938964844e+02 -3.1926199340820312e+02 2.3099499511718750e+02 1.2793000030517578e+02 -3.1977499389648438e+02 2.3172299194335938e+02 1.2822500610351562e+02 -3.2027499389648438e+02 2.3251600646972656e+02 1.2830999755859375e+02 -3.2051901245117188e+02 2.3294400024414062e+02 1.2839199829101562e+02 -3.2075399780273438e+02 2.3335699462890625e+02 1.2501600646972656e+02 -3.1769201660156250e+02 2.2956399536132812e+02 1.2405699920654297e+02 -3.1676000976562500e+02 2.2854701232910156e+02 1.2418099975585938e+02 -3.1688400268554688e+02 2.2867700195312500e+02 1.2469200134277344e+02 -3.1737899780273438e+02 2.2922000122070312e+02 1.2613199615478516e+02 -3.2391101074218750e+02 2.4199000549316406e+02 1.2645899963378906e+02 -3.2372299194335938e+02 2.4125399780273438e+02 1.2680000305175781e+02 -3.2352502441406250e+02 2.4048500061035156e+02 1.2701100158691406e+02 -3.2339599609375000e+02 2.4002200317382812e+02 1.2748000335693359e+02 -3.2310800170898438e+02 2.3899301147460938e+02 1.2596200561523438e+02 -3.2376300048828125e+02 2.4171899414062500e+02 1.2546400451660156e+02 -3.2373300170898438e+02 2.4202500915527344e+02 1.2432099914550781e+02 -3.2360000610351562e+02 2.4259400939941406e+02 1.2427799987792969e+02 -3.2359201049804688e+02 2.4260899353027344e+02 1.2312900543212891e+02 -3.2337600708007812e+02 2.4301600646972656e+02 1.2248699951171875e+02 -3.2321200561523438e+02 2.4315699768066406e+02 1.2191099548339844e+02 -3.2306500244140625e+02 2.4328199768066406e+02 1.2069300079345703e+02 -3.2267300415039062e+02 2.4338699340820312e+02 1.2067099761962891e+02 -3.2266500854492188e+02 2.4338600158691406e+02 1.1949700164794922e+02 -3.2220901489257812e+02 2.4332901000976562e+02 1.1891199493408203e+02 -3.2194000244140625e+02 2.4321598815917969e+02 1.1834700012207031e+02 -3.2168099975585938e+02 2.4310800170898438e+02 1.1726699829101562e+02 -3.2109899902343750e+02 2.4272898864746094e+02 1.1827500152587891e+02 -3.2078601074218750e+02 2.4084399414062500e+02 1.2087999725341797e+02 -3.2198397827148438e+02 2.4134600830078125e+02 1.2492700195312500e+02 -3.2282400512695312e+02 2.4007099914550781e+02 1.2454599761962891e+02 -3.2280099487304688e+02 2.4030500793457031e+02 1.2367100524902344e+02 -3.2269900512695312e+02 2.4074000549316406e+02 1.2363899993896484e+02 -3.2269299316406250e+02 2.4075199890136719e+02 1.2275900268554688e+02 -3.2252801513671875e+02 2.4106300354003906e+02 1.2226899719238281e+02 -3.2240200805664062e+02 2.4116999816894531e+02 1.2182799530029297e+02 -3.2229000854492188e+02 2.4126699829101562e+02 1.2089599609375000e+02 -3.2199002075195312e+02 2.4134700012207031e+02 1.1998099517822266e+02 -3.2163500976562500e+02 2.4130200195312500e+02 1.1953300476074219e+02 -3.2142901611328125e+02 2.4121600341796875e+02 1.1910200500488281e+02 -3.2123101806640625e+02 2.4113301086425781e+02 1.2468899536132812e+02 -3.2259899902343750e+02 2.3969100952148438e+02 1.2608100128173828e+02 -3.2286502075195312e+02 2.3933599853515625e+02 1.2628999328613281e+02 -3.2290100097656250e+02 2.3928500366210938e+02 1.2522800445556641e+02 -3.2270199584960938e+02 2.3955400085449219e+02 1.0935299682617188e+02 -3.1530200195312500e+02 2.4199899291992188e+02 1.0928100585937500e+02 -3.1527099609375000e+02 2.4199099731445312e+02 1.0922299957275391e+02 -3.1523199462890625e+02 2.4195500183105469e+02 1.1594699859619141e+02 -3.0950100708007812e+02 2.2547300720214844e+02 1.1587999725341797e+02 -3.0946499633789062e+02 2.2544999694824219e+02 1.1580599975585938e+02 -3.0943997192382812e+02 2.2545500183105469e+02 1.2535500335693359e+02 -3.1161099243164062e+02 2.2282400512695312e+02 1.2540900421142578e+02 -3.1160198974609375e+02 2.2276699829101562e+02 1.2547899627685547e+02 -3.1161001586914062e+02 2.2273098754882812e+02 1.3637100219726562e+02 -3.2136099243164062e+02 2.3439300537109375e+02 1.3643400573730469e+02 -3.2136099243164062e+02 2.3434600830078125e+02 1.3647698974609375e+02 -3.2134399414062500e+02 2.3428199768066406e+02 1.1523899841308594e+02 -3.2051101684570312e+02 2.4818099975585938e+02 1.1524199676513672e+02 -3.2054702758789062e+02 2.4825100708007812e+02 1.1527399444580078e+02 -3.2058798217773438e+02 2.4830999755859375e+02 1.3284799194335938e+02 -3.2445999145507812e+02 2.4322299194335938e+02 1.3286599731445312e+02 -3.2450000000000000e+02 2.4328900146484375e+02 1.3285499572753906e+02 -3.2453097534179688e+02 2.4336000061035156e+02 1.3620899963378906e+02 -3.2019497680664062e+02 2.3216099548339844e+02 1.2764500427246094e+02 -3.1261398315429688e+02 2.2316700744628906e+02 1.3565600585937500e+02 -3.1893600463867188e+02 2.3002999877929688e+02 1.3470500183105469e+02 -3.1762200927734375e+02 2.2808100891113281e+02 1.3338198852539062e+02 -3.1629299926757812e+02 2.2637200927734375e+02 1.3173001098632812e+02 -3.1498901367187500e+02 2.2495700073242188e+02 1.2979798889160156e+02 -3.1375000000000000e+02 2.2387799072265625e+02 1.3108299255371094e+02 -3.2470501708984375e+02 2.4501000976562500e+02 1.1739300537109375e+02 -3.2163400268554688e+02 2.4886399841308594e+02 1.1970199584960938e+02 -3.2263400268554688e+02 2.4918399047851562e+02 1.2209600067138672e+02 -3.2346600341796875e+02 2.4910398864746094e+02 1.2450399780273438e+02 -3.2410498046875000e+02 2.4862701416015625e+02 1.2685100555419922e+02 -3.2453201293945312e+02 2.4776600646972656e+02 1.2906600952148438e+02 -3.2473400878906250e+02 2.4654800415039062e+02 1.1395500183105469e+02 -3.0954400634765625e+02 2.2702099609375000e+02 1.0882900238037109e+02 -3.1405401611328125e+02 2.3986999511718750e+02 1.1219800567626953e+02 -3.0980398559570312e+02 2.2883300781250000e+02 1.1075600433349609e+02 -3.1028500366210938e+02 2.3086199951171875e+02 1.0966999816894531e+02 -3.1097497558593750e+02 2.3304800415039062e+02 1.0897499847412109e+02 -3.1185202026367188e+02 2.3532398986816406e+02 1.0869200134277344e+02 -3.1288900756835938e+02 2.3762098693847656e+02 1.3681100463867188e+02 -3.1322500610351562e+02 2.4583299255371094e+02 1.3854600524902344e+02 -3.1069500732421875e+02 2.4466699218750000e+02 1.3786399841308594e+02 -3.1256802368164062e+02 2.4373699951171875e+02 1.3920199584960938e+02 -3.0984802246093750e+02 2.4247900390625000e+02 1.3852000427246094e+02 -3.1172100830078125e+02 2.4154899597167969e+02 1.3943899536132812e+02 -3.0883999633789062e+02 2.4027400207519531e+02 1.3875700378417969e+02 -3.1071298217773438e+02 2.3934399414062500e+02 1.3924800109863281e+02 -3.0770498657226562e+02 2.3812699890136719e+02 1.3856600952148438e+02 -3.0957901000976562e+02 2.3719699096679688e+02 1.3863700866699219e+02 -3.0648199462890625e+02 2.3611100769042969e+02 1.3795500183105469e+02 -3.0835598754882812e+02 2.3518099975585938e+02 1.3762500000000000e+02 -3.0521301269531250e+02 2.3429499816894531e+02 1.3694299316406250e+02 -3.0708599853515625e+02 2.3336500549316406e+02 1.3624800109863281e+02 -3.0394000244140625e+02 2.3274000549316406e+02 1.3556599426269531e+02 -3.0581399536132812e+02 2.3180999755859375e+02 1.3455200195312500e+02 -3.0270700073242188e+02 2.3150000000000000e+02 1.3387001037597656e+02 -3.0458099365234375e+02 2.3057000732421875e+02 1.3259600830078125e+02 -3.0155700683593750e+02 2.3061599731445312e+02 1.3191400146484375e+02 -3.0342999267578125e+02 2.2968600463867188e+02 1.3044500732421875e+02 -3.0052700805664062e+02 2.3011900329589844e+02 1.2976300048828125e+02 -3.0240100097656250e+02 2.2919000244140625e+02 1.2817298889160156e+02 -2.9965399169921875e+02 2.3002600097656250e+02 1.2749099731445312e+02 -3.0152801513671875e+02 2.2909700012207031e+02 1.2585699462890625e+02 -2.9896701049804688e+02 2.3033999633789062e+02 1.2517500305175781e+02 -3.0083999633789062e+02 2.2940998840332031e+02 1.2357600402832031e+02 -2.9848901367187500e+02 2.3105000305175781e+02 1.2289399719238281e+02 -3.0036300659179688e+02 2.3012001037597656e+02 1.2140799713134766e+02 -2.9823699951171875e+02 2.3213200378417969e+02 1.2072599792480469e+02 -3.0011099243164062e+02 2.3120201110839844e+02 1.1942700195312500e+02 -2.9821899414062500e+02 2.3354899597167969e+02 1.1874500274658203e+02 -3.0009298706054688e+02 2.3261900329589844e+02 1.1770000457763672e+02 -2.9843597412109375e+02 2.3525300598144531e+02 1.1701799774169922e+02 -3.0030999755859375e+02 2.3432398986816406e+02 1.1628600311279297e+02 -2.9888098144531250e+02 2.3718600463867188e+02 1.1560399627685547e+02 -3.0075399780273438e+02 2.3625599670410156e+02 1.1523299407958984e+02 -2.9953701782226562e+02 2.3928199768066406e+02 1.1455100250244141e+02 -3.0141101074218750e+02 2.3835299682617188e+02 1.1457700347900391e+02 -3.0038400268554688e+02 2.4147000122070312e+02 1.1389499664306641e+02 -3.0225802612304688e+02 2.4053999328613281e+02 1.1433999633789062e+02 -3.0139199829101562e+02 2.4367498779296875e+02 1.1365800476074219e+02 -3.0326599121093750e+02 2.4274499511718750e+02 1.1453100585937500e+02 -3.0252700805664062e+02 2.4582199096679688e+02 1.1384899902343750e+02 -3.0440100097656250e+02 2.4489199829101562e+02 1.1514200592041016e+02 -3.0375000000000000e+02 2.4783801269531250e+02 1.1445999908447266e+02 -3.0562402343750000e+02 2.4690798950195312e+02 1.1615399932861328e+02 -3.0501898193359375e+02 2.4965399169921875e+02 1.1547200012207031e+02 -3.0689300537109375e+02 2.4872399902343750e+02 1.1753099822998047e+02 -3.0629199218750000e+02 2.5120898437500000e+02 1.1684899902343750e+02 -3.0816598510742188e+02 2.5027900695800781e+02 1.1922699737548828e+02 -3.0752499389648438e+02 2.5244900512695312e+02 1.1854500579833984e+02 -3.0939801025390625e+02 2.5151899719238281e+02 1.2118299865722656e+02 -3.0867498779296875e+02 2.5333300781250000e+02 1.2050199890136719e+02 -3.1054898071289062e+02 2.5240298461914062e+02 1.2333399963378906e+02 -3.0970498657226562e+02 2.5382998657226562e+02 1.2265299987792969e+02 -3.1157897949218750e+02 2.5290000915527344e+02 1.2560700225830078e+02 -3.1057800292968750e+02 2.5392300415039062e+02 1.2492500305175781e+02 -3.1245199584960938e+02 2.5299298095703125e+02 1.2792199707031250e+02 -3.1126498413085938e+02 2.5360900878906250e+02 1.2724000549316406e+02 -3.1313897705078125e+02 2.5267898559570312e+02 1.3020298767089844e+02 -3.1174298095703125e+02 2.5289898681640625e+02 1.2952099609375000e+02 -3.1361700439453125e+02 2.5196900939941406e+02 1.3237098693847656e+02 -3.1199499511718750e+02 2.5181698608398438e+02 1.3168899536132812e+02 -3.1386898803710938e+02 2.5088700866699219e+02 1.3435200500488281e+02 -3.1201300048828125e+02 2.5040000915527344e+02 1.3366999816894531e+02 -3.1388699340820312e+02 2.4947000122070312e+02 1.3607899475097656e+02 -3.1179602050781250e+02 2.4869599914550781e+02 1.3539700317382812e+02 -3.1367001342773438e+02 2.4776600646972656e+02 1.3749299621582031e+02 -3.1135101318359375e+02 2.4676300048828125e+02 1.3743499755859375e+02 -3.1546398925781250e+02 2.4654998779296875e+02 1.3833099365234375e+02 -3.1505297851562500e+02 2.4506500244140625e+02 1.3880699157714844e+02 -3.1183999633789062e+02 2.4641000366210938e+02 1.3798800659179688e+02 -3.1220098876953125e+02 2.4773899841308594e+02 1.3788299560546875e+02 -3.1224700927734375e+02 2.4790798950195312e+02 1.3637500000000000e+02 -3.1577200317382812e+02 2.4794900512695312e+02 1.3697099304199219e+02 -3.1249401855468750e+02 2.4907299804687500e+02 1.3678500366210938e+02 -3.1254397583007812e+02 2.4931100463867188e+02 1.3516600036621094e+02 -3.1597399902343750e+02 2.4924198913574219e+02 1.3581399536132812e+02 -3.1268499755859375e+02 2.5030699157714844e+02 1.3552999877929688e+02 -3.1272598266601562e+02 2.5059800720214844e+02 1.3382600402832031e+02 -3.1606701660156250e+02 2.5041198730468750e+02 1.3453199768066406e+02 -3.1277099609375000e+02 2.5142198181152344e+02 1.3413800048828125e+02 -3.1278900146484375e+02 2.5174700927734375e+02 1.3237200927734375e+02 -3.1604901123046875e+02 2.5144198608398438e+02 1.3314299011230469e+02 -3.1275299072265625e+02 2.5240400695800781e+02 1.3263099670410156e+02 -3.1273400878906250e+02 2.5274198913574219e+02 1.3082499694824219e+02 -3.1592102050781250e+02 2.5231799316406250e+02 1.3166600036621094e+02 -3.1263000488281250e+02 2.5323899841308594e+02 1.3103300476074219e+02 -3.1256100463867188e+02 2.5356501770019531e+02 1.2920799255371094e+02 -3.1568399047851562e+02 2.5302699279785156e+02 1.3012200927734375e+02 -3.1240298461914062e+02 2.5391500854492188e+02 1.2936801147460938e+02 -3.1227200317382812e+02 2.5420401000976562e+02 1.2754200744628906e+02 -3.1534201049804688e+02 2.5356001281738281e+02 1.2853201293945312e+02 -3.1207699584960938e+02 2.5442298889160156e+02 1.2585200500488281e+02 -3.1490002441406250e+02 2.5390899658203125e+02 1.2766400146484375e+02 -3.1187298583984375e+02 2.5464999389648438e+02 1.2691799926757812e+02 -3.1165502929687500e+02 2.5475599670410156e+02 1.2415999603271484e+02 -3.1436300659179688e+02 2.5406799316406250e+02 1.2594599914550781e+02 -3.1136999511718750e+02 2.5489500427246094e+02 1.2530400085449219e+02 -3.1114300537109375e+02 2.5490998840332031e+02 1.2249100494384766e+02 -3.1373999023437500e+02 2.5403698730468750e+02 1.2424299621582031e+02 -3.1076898193359375e+02 2.5493499755859375e+02 1.2370999908447266e+02 -3.1054898071289062e+02 2.5488099670410156e+02 1.2086799621582031e+02 -3.1303900146484375e+02 2.5381500244140625e+02 1.2258100128173828e+02 -3.1008200073242188e+02 2.5476899719238281e+02 1.2215899658203125e+02 -3.0988101196289062e+02 2.5467199707031250e+02 1.1931400299072266e+02 -3.1226998901367188e+02 2.5340499877929688e+02 1.2098500061035156e+02 -3.0931900024414062e+02 2.5440100097656250e+02 1.2067399597167969e+02 -3.0914700317382812e+02 2.5428300476074219e+02 1.1784999847412109e+02 -3.1144299316406250e+02 2.5281301879882812e+02 1.1948300170898438e+02 -3.0849099731445312e+02 2.5383499145507812e+02 1.1927300262451172e+02 -3.0835900878906250e+02 2.5372099304199219e+02 1.1649800109863281e+02 -3.1057101440429688e+02 2.5204798889160156e+02 1.1809600067138672e+02 -3.0761297607421875e+02 2.5308200073242188e+02 1.1797799682617188e+02 -3.0752600097656250e+02 2.5299400329589844e+02 1.1527500152587891e+02 -3.0966601562500000e+02 2.5111898803710938e+02 1.1684700012207031e+02 -3.0669702148437500e+02 2.5215199279785156e+02 1.1680599975585938e+02 -3.0666101074218750e+02 2.5211099243164062e+02 1.1420100402832031e+02 -3.0873999023437500e+02 2.5004101562500000e+02 1.1577600097656250e+02 -3.0577600097656250e+02 2.5108099365234375e+02 1.1575599670410156e+02 -3.0575799560546875e+02 2.5106001281738281e+02 1.1328800201416016e+02 -3.0780599975585938e+02 2.4882901000976562e+02 1.1490800476074219e+02 -3.0488299560546875e+02 2.4991799926757812e+02 1.1483900451660156e+02 -3.0481100463867188e+02 2.4982499694824219e+02 1.1255100250244141e+02 -3.0687698364257812e+02 2.4749900817871094e+02 1.1420800018310547e+02 -3.0399502563476562e+02 2.4864399719238281e+02 1.1411199951171875e+02 -3.0387100219726562e+02 2.4846400451660156e+02 1.1199900054931641e+02 -3.0596701049804688e+02 2.4606900024414062e+02 1.1368499755859375e+02 -3.0312600708007812e+02 2.4727598571777344e+02 1.1358599853515625e+02 -3.0295300292968750e+02 2.4700000000000000e+02 1.1164099884033203e+02 -3.0508898925781250e+02 2.4456100463867188e+02 1.1334600067138672e+02 -3.0228799438476562e+02 2.4583500671386719e+02 1.1326800537109375e+02 -3.0207199096679688e+02 2.4545599365234375e+02 1.1148100280761719e+02 -3.0425302124023438e+02 2.4299499511718750e+02 1.1319599914550781e+02 -3.0149099731445312e+02 2.4433900451660156e+02 1.1316500091552734e+02 -3.0123999023437500e+02 2.4385600280761719e+02 1.1152099609375000e+02 -3.0347299194335938e+02 2.4139399719238281e+02 1.1323699951171875e+02 -3.0074700927734375e+02 2.4280999755859375e+02 1.1327700042724609e+02 -3.0047100830078125e+02 2.4222500610351562e+02 1.1176200103759766e+02 -3.0276000976562500e+02 2.3977899169921875e+02 1.1346800231933594e+02 -3.0006597900390625e+02 2.4126799011230469e+02 1.1360400390625000e+02 -2.9977801513671875e+02 2.4058898925781250e+02 1.1219899749755859e+02 -3.0212200927734375e+02 2.3817298889160156e+02 1.1388600158691406e+02 -2.9945800781250000e+02 2.3973600769042969e+02 1.1282700347900391e+02 -3.0157000732421875e+02 2.3659999084472656e+02 1.1413899993896484e+02 -2.9917202758789062e+02 2.3897399902343750e+02 1.1448500061035156e+02 -2.9893099975585938e+02 2.3823399353027344e+02 1.1363600158691406e+02 -3.0110998535156250e+02 2.3508000183105469e+02 1.1487400054931641e+02 -2.9866098022460938e+02 2.3740499877929688e+02 1.1525700378417969e+02 -2.9849200439453125e+02 2.3678300476074219e+02 1.1461599731445312e+02 -3.0075000000000000e+02 2.3363600158691406e+02 1.1579799652099609e+02 -2.9825402832031250e+02 2.3590699768066406e+02 1.1619100189208984e+02 -2.9814700317382812e+02 2.3540400695800781e+02 1.1575300598144531e+02 -3.0049499511718750e+02 2.3228800964355469e+02 1.1689600372314453e+02 -2.9795700073242188e+02 2.3450399780273438e+02 1.1727500152587891e+02 -2.9790197753906250e+02 2.3411599731445312e+02 1.1702999877929688e+02 -3.0034701538085938e+02 2.3105398559570312e+02 1.1815100097656250e+02 -2.9777600097656250e+02 2.3321800231933594e+02 1.1849199676513672e+02 -2.9776000976562500e+02 2.3293598937988281e+02 1.1842900085449219e+02 -3.0030999755859375e+02 2.2995199584960938e+02 1.1954299926757812e+02 -2.9771200561523438e+02 2.3206800842285156e+02 1.1982700347900391e+02 -2.9772201538085938e+02 2.3188099670410156e+02 1.1993200683593750e+02 -3.0038299560546875e+02 2.2899700927734375e+02 1.2105000305175781e+02 -2.9776699829101562e+02 2.3107400512695312e+02 1.2126100158691406e+02 -2.9778997802734375e+02 2.3096499633789062e+02 1.2151700592041016e+02 -3.0056597900390625e+02 2.2820300292968750e+02 1.2264900207519531e+02 -2.9793997192382812e+02 2.3025099182128906e+02 1.2277399444580078e+02 -2.9796200561523438e+02 2.3020201110839844e+02 1.2316100311279297e+02 -3.0085598754882812e+02 2.2758099365234375e+02 1.2431299591064453e+02 -2.9822900390625000e+02 2.2961099243164062e+02 1.2434499359130859e+02 -2.9823602294921875e+02 2.2960301208496094e+02 1.2484200286865234e+02 -3.0124899291992188e+02 2.2713999938964844e+02 1.2595300292968750e+02 -2.9861300659179688e+02 2.2918200683593750e+02 1.2601800537109375e+02 -2.9862799072265625e+02 2.2916500854492188e+02 1.2653599548339844e+02 -3.0173901367187500e+02 2.2688500976562500e+02 1.2757299804687500e+02 -2.9908401489257812e+02 2.2894400024414062e+02 1.2773500061035156e+02 -2.9913198852539062e+02 2.2892098999023438e+02 1.2822000122070312e+02 -3.0232000732421875e+02 2.2682099914550781e+02 1.2918099975585938e+02 -2.9964102172851562e+02 2.2888700866699219e+02 1.2943800354003906e+02 -2.9973199462890625e+02 2.2888099670410156e+02 1.2986900329589844e+02 -3.0298297119140625e+02 2.2694799804687500e+02 1.3075601196289062e+02 -3.0027600097656250e+02 2.2901199340820312e+02 1.3110099792480469e+02 -3.0041900634765625e+02 2.2904699707031250e+02 1.3145999145507812e+02 -3.0371902465820312e+02 2.2726499938964844e+02 1.3227499389648438e+02 -3.0098098754882812e+02 2.2931799316406250e+02 1.3269599914550781e+02 -3.0118200683593750e+02 2.2941499328613281e+02 1.3297200012207031e+02 -3.0451800537109375e+02 2.2776600646972656e+02 1.3371699523925781e+02 -3.0174499511718750e+02 2.2979899597167969e+02 1.3419898986816406e+02 -3.0201000976562500e+02 2.2998001098632812e+02 1.3438198852539062e+02 -3.0536898803710938e+02 2.2844601440429688e+02 1.3506199645996094e+02 -3.0255700683593750e+02 2.3044999694824219e+02 1.3558499145507812e+02 -3.0288897705078125e+02 2.3073400878906250e+02 1.3567199707031250e+02 -3.0625900268554688e+02 2.2929400634765625e+02 1.3629199218750000e+02 -3.0340701293945312e+02 2.3125999450683594e+02 1.3683399963378906e+02 -3.0380499267578125e+02 2.3166400146484375e+02 1.3682200622558594e+02 -3.0717700195312500e+02 2.3029899597167969e+02 1.3738999938964844e+02 -3.0428298950195312e+02 2.3222000122070312e+02 1.3781799316406250e+02 -3.0810800170898438e+02 2.3144699096679688e+02 1.3792500305175781e+02 -3.0474298095703125e+02 2.3275500488281250e+02 1.3833999633789062e+02 -3.0517199707031250e+02 2.3331399536132812e+02 1.3864399719238281e+02 -3.0904098510742188e+02 2.3272000122070312e+02 1.3884199523925781e+02 -3.0569000244140625e+02 2.3399099731445312e+02 1.3912998962402344e+02 -3.0606201171875000e+02 2.3452999877929688e+02 1.3929000854492188e+02 -3.0996200561523438e+02 2.3410198974609375e+02 1.3956900024414062e+02 -3.0662997436523438e+02 2.3535099792480469e+02 1.3974800109863281e+02 -3.0694100952148438e+02 2.3584799194335938e+02 1.3974600219726562e+02 -3.1085800170898438e+02 2.3557400512695312e+02 1.4009500122070312e+02 -3.0754797363281250e+02 2.3681500244140625e+02 1.4018499755859375e+02 -3.0779702758789062e+02 2.3725199890136719e+02 1.4000500488281250e+02 -3.1171701049804688e+02 2.3711300659179688e+02 1.4041299438476562e+02 -3.0842999267578125e+02 2.3835900878906250e+02 1.4043598937988281e+02 -3.0861801147460938e+02 2.3872099304199219e+02 1.4006500244140625e+02 -3.1252600097656250e+02 2.3869999694824219e+02 1.4051599121093750e+02 -3.0926098632812500e+02 2.3996000671386719e+02 1.4049699401855469e+02 -3.0939199829101562e+02 2.4023599243164062e+02 1.3992401123046875e+02 -3.1327398681640625e+02 2.4031098937988281e+02 1.4040400695800781e+02 -3.1002999877929688e+02 2.4158999633789062e+02 1.4036700439453125e+02 -3.1010800170898438e+02 2.4177500915527344e+02 1.3958500671386719e+02 -3.1395098876953125e+02 2.4192399597167969e+02 1.4007798767089844e+02 -3.1072299194335938e+02 2.4322601318359375e+02 1.4004699707031250e+02 -3.1075701904296875e+02 2.4331800842285156e+02 1.3905101013183594e+02 -3.1454699707031250e+02 2.4351599121093750e+02 1.3954299926757812e+02 -3.1132998657226562e+02 2.4484098815917969e+02 1.3884899902343750e+02 -3.1181201171875000e+02 2.4632200622558594e+02 1.3895500183105469e+02 -3.1710101318359375e+02 2.4050100708007812e+02 1.3930499267578125e+02 -3.1640197753906250e+02 2.3883599853515625e+02 1.3945100402832031e+02 -3.1562997436523438e+02 2.3717199707031250e+02 1.3938899230957031e+02 -3.1479498291015625e+02 2.3553399658203125e+02 1.3912100219726562e+02 -3.1390802001953125e+02 2.3394499206542969e+02 1.3864999389648438e+02 -3.1298300170898438e+02 2.3242601013183594e+02 1.3798399353027344e+02 -3.1203201293945312e+02 2.3099899291992188e+02 1.3713000488281250e+02 -3.1106900024414062e+02 2.2968399047851562e+02 1.3610299682617188e+02 -3.1010699462890625e+02 2.2849899291992188e+02 1.3491499328613281e+02 -3.0916000366210938e+02 2.2746199035644531e+02 1.3358299255371094e+02 -3.0824099731445312e+02 2.2658599853515625e+02 1.3212699890136719e+02 -3.0736300659179688e+02 2.2588400268554688e+02 1.3056599426269531e+02 -3.0653799438476562e+02 2.2536599731445312e+02 1.2892300415039062e+02 -3.0577700805664062e+02 2.2503900146484375e+02 1.2722100067138672e+02 -3.0509298706054688e+02 2.2490798950195312e+02 1.2548300933837891e+02 -3.0449301147460938e+02 2.2497399902343750e+02 1.2373399353027344e+02 -3.0398699951171875e+02 2.2523699951171875e+02 1.2199799346923828e+02 -3.0358099365234375e+02 2.2569300842285156e+02 1.2030000305175781e+02 -3.0328198242187500e+02 2.2633500671386719e+02 1.1866399383544922e+02 -3.0309298706054688e+02 2.2715499877929688e+02 1.1711199951171875e+02 -3.0301699829101562e+02 2.2813999938964844e+02 1.1566699981689453e+02 -3.0305599975585938e+02 2.2927799987792969e+02 1.1434899902343750e+02 -3.0320800781250000e+02 2.3055200195312500e+02 1.1317499542236328e+02 -3.0347201538085938e+02 2.3194400024414062e+02 1.1216400146484375e+02 -3.0384399414062500e+02 2.3343600463867188e+02 1.1132799530029297e+02 -3.0431802368164062e+02 2.3500399780273438e+02 1.1068000030517578e+02 -3.0488900756835938e+02 2.3662899780273438e+02 1.1022800445556641e+02 -3.0554699707031250e+02 2.3828700256347656e+02 1.0998000335693359e+02 -3.0628399658203125e+02 2.3995399475097656e+02 1.0993800354003906e+02 -3.0708898925781250e+02 2.4160798645019531e+02 1.1010300445556641e+02 -3.0795098876953125e+02 2.4322399902343750e+02 1.1047299957275391e+02 -3.0885897827148438e+02 2.4478100585937500e+02 1.1104299926757812e+02 -3.0979800415039062e+02 2.4625700378417969e+02 1.1180400085449219e+02 -3.1075701904296875e+02 2.4763000488281250e+02 1.1274600219726562e+02 -3.1172100830078125e+02 2.4888198852539062e+02 1.1385600280761719e+02 -3.1267700195312500e+02 2.4999499511718750e+02 1.1511799621582031e+02 -3.1361199951171875e+02 2.5095399475097656e+02 1.1651399993896484e+02 -3.1451300048828125e+02 2.5174400329589844e+02 1.1802499389648438e+02 -3.1536599731445312e+02 2.5235501098632812e+02 1.1963000488281250e+02 -3.1616000366210938e+02 2.5277799987792969e+02 1.2130599975585938e+02 -3.1688400268554688e+02 2.5300801086425781e+02 1.2302899932861328e+02 -3.1752700805664062e+02 2.5303999328613281e+02 1.2477600097656250e+02 -3.1808099365234375e+02 2.5287500000000000e+02 1.2652100372314453e+02 -3.1853802490234375e+02 2.5251498413085938e+02 1.2824099731445312e+02 -3.1889099121093750e+02 2.5196498107910156e+02 1.2991101074218750e+02 -3.1913500976562500e+02 2.5123301696777344e+02 1.3150799560546875e+02 -3.1926797485351562e+02 2.5032899475097656e+02 1.3300900268554688e+02 -3.1928598022460938e+02 2.4926499938964844e+02 1.3439300537109375e+02 -3.1919000244140625e+02 2.4805699157714844e+02 1.3564099121093750e+02 -3.1898199462890625e+02 2.4672200012207031e+02 1.3673500061035156e+02 -3.1866400146484375e+02 2.4527700805664062e+02 1.3766099548339844e+02 -3.1823999023437500e+02 2.4374499511718750e+02 1.3840399169921875e+02 -3.1771697998046875e+02 2.4214500427246094e+02 1.3816400146484375e+02 -3.2020397949218750e+02 2.3905400085449219e+02 1.3852200317382812e+02 -3.1949099731445312e+02 2.3735398864746094e+02 1.3867098999023438e+02 -3.1870300292968750e+02 2.3565599060058594e+02 1.3860699462890625e+02 -3.1785000610351562e+02 2.3398399353027344e+02 1.3833399963378906e+02 -3.1694497680664062e+02 2.3236199951171875e+02 1.3785398864746094e+02 -3.1600100708007812e+02 2.3081199645996094e+02 1.3717300415039062e+02 -3.1503100585937500e+02 2.2935501098632812e+02 1.3630200195312500e+02 -3.1404800415039062e+02 2.2801300048828125e+02 1.3525299072265625e+02 -3.1306600952148438e+02 2.2680400085449219e+02 1.3404100036621094e+02 -3.1209899902343750e+02 2.2574501037597656e+02 1.3268199157714844e+02 -3.1116101074218750e+02 2.2485099792480469e+02 1.3119601440429688e+02 -3.1026501464843750e+02 2.2413499450683594e+02 1.2960299682617188e+02 -3.0942300415039062e+02 2.2360600280761719e+02 1.2792601013183594e+02 -3.0864700317382812e+02 2.2327200317382812e+02 1.2618799591064453e+02 -3.0794799804687500e+02 2.2313900756835938e+02 1.2441399383544922e+02 -3.0733599853515625e+02 2.2320599365234375e+02 1.2262900543212891e+02 -3.0681900024414062e+02 2.2347399902343750e+02 1.2085800170898438e+02 -3.0640499877929688e+02 2.2394000244140625e+02 1.1912500000000000e+02 -3.0610000610351562e+02 2.2459500122070312e+02 1.1745500183105469e+02 -3.0590701293945312e+02 2.2543199157714844e+02 1.1587099456787109e+02 -3.0583001708984375e+02 2.2643800354003906e+02 1.1439599609375000e+02 -3.0586901855468750e+02 2.2759899902343750e+02 1.1304999542236328e+02 -3.0602499389648438e+02 2.2889900207519531e+02 1.1185300445556641e+02 -3.0629400634765625e+02 2.3032000732421875e+02 1.1081999969482422e+02 -3.0667300415039062e+02 2.3184199523925781e+02 1.0996700286865234e+02 -3.0715701293945312e+02 2.3344400024414062e+02 1.0930599975585938e+02 -3.0773898315429688e+02 2.3510200500488281e+02 1.0884500122070312e+02 -3.0841101074218750e+02 2.3679299926757812e+02 1.0859200286865234e+02 -3.0916299438476562e+02 2.3849501037597656e+02 1.0854899597167969e+02 -3.0998501586914062e+02 2.4018299865722656e+02 1.0871700286865234e+02 -3.1086599731445312e+02 2.4183300781250000e+02 1.0909500122070312e+02 -3.1179199218750000e+02 2.4342199707031250e+02 1.0967600250244141e+02 -3.1275100708007812e+02 2.4492800903320312e+02 1.1045300292968750e+02 -3.1372897338867188e+02 2.4632998657226562e+02 1.1141500091552734e+02 -3.1471301269531250e+02 2.4760800170898438e+02 1.1254800415039062e+02 -3.1568899536132812e+02 2.4874400329589844e+02 1.1383599853515625e+02 -3.1664300537109375e+02 2.4972200012207031e+02 1.1526100158691406e+02 -3.1756201171875000e+02 2.5052801513671875e+02 1.1680300140380859e+02 -3.1843298339843750e+02 2.5115200805664062e+02 1.1844100189208984e+02 -3.1924301147460938e+02 2.5158399963378906e+02 1.2015100097656250e+02 -3.1998199462890625e+02 2.5181800842285156e+02 1.2190999603271484e+02 -3.2063900756835938e+02 2.5185099792480469e+02 1.2369299316406250e+02 -3.2120401000976562e+02 2.5168299865722656e+02 1.2547400665283203e+02 -3.2166998291015625e+02 2.5131600952148438e+02 1.2722900390625000e+02 -3.2203100585937500e+02 2.5075399780273438e+02 1.2893399047851562e+02 -3.2227999877929688e+02 2.5000700378417969e+02 1.3056401062011719e+02 -3.2241500854492188e+02 2.4908399963378906e+02 1.3209599304199219e+02 -3.2243402099609375e+02 2.4799899291992188e+02 1.3350799560546875e+02 -3.2233599853515625e+02 2.4676600646972656e+02 1.3478199768066406e+02 -3.2212399291992188e+02 2.4540199279785156e+02 1.3589900207519531e+02 -3.2179901123046875e+02 2.4392799377441406e+02 1.3684399414062500e+02 -3.2136599731445312e+02 2.4236399841308594e+02 1.3760200500488281e+02 -3.2083200073242188e+02 2.4073199462890625e+02 1.1595500183105469e+02 -3.0561599731445312e+02 2.5100299072265625e+02 1.1703199768066406e+02 -3.0654202270507812e+02 2.5207901000976562e+02 1.1351100158691406e+02 -3.0040197753906250e+02 2.4228700256347656e+02 1.1339999389648438e+02 -3.0116000366210938e+02 2.4389599609375000e+02 1.1508499908447266e+02 -2.9861599731445312e+02 2.3753300476074219e+02 1.1436000061035156e+02 -2.9911999511718750e+02 2.3908099365234375e+02 1.1383200073242188e+02 -2.9971798706054688e+02 2.4067401123046875e+02 1.2777200317382812e+02 -2.9908001708984375e+02 2.2916400146484375e+02 1.2607799530029297e+02 -2.9858300781250000e+02 2.2940499877929688e+02 1.4026800537109375e+02 -3.0983001708984375e+02 2.4166200256347656e+02 1.4037899780273438e+02 -3.0907199096679688e+02 2.4005299377441406e+02 1.3869400024414062e+02 -3.1161599731445312e+02 2.4641600036621094e+02 1.3941900634765625e+02 -3.1111199951171875e+02 2.4486799621582031e+02 1.3994699096679688e+02 -3.1051400756835938e+02 2.4327500915527344e+02 1.3102499389648438e+02 -3.1232699584960938e+02 2.5347300720214844e+02 1.3260099792480469e+02 -3.1249801635742188e+02 2.5266099548339844e+02 1.1350200653076172e+02 -3.0197998046875000e+02 2.4547499084472656e+02 1.1381500244140625e+02 -3.0285000610351562e+02 2.4699800109863281e+02 1.1433399963378906e+02 -3.0375601196289062e+02 2.4844200134277344e+02 1.1505100250244141e+02 -3.0468301391601562e+02 2.4978399658203125e+02 1.1831800079345703e+02 -2.9774298095703125e+02 2.3340299987792969e+02 1.1708000183105469e+02 -2.9792199707031250e+02 2.3467098999023438e+02 1.1599700164794922e+02 -2.9821398925781250e+02 2.3605599975585938e+02 1.3782400512695312e+02 -3.0461599731445312e+02 2.3294599914550781e+02 1.3674700927734375e+02 -3.0368997192382812e+02 2.3186999511718750e+02 1.3408799743652344e+02 -3.1255200195312500e+02 2.5167999267578125e+02 1.3546099853515625e+02 -3.1248901367187500e+02 2.5054600524902344e+02 1.3669900512695312e+02 -3.1230999755859375e+02 2.4927799987792969e+02 1.3778199768066406e+02 -3.1201800537109375e+02 2.4789300537109375e+02 1.2600700378417969e+02 -3.1115200805664062e+02 2.5478500366210938e+02 1.2770099639892578e+02 -3.1164898681640625e+02 2.5454399108886719e+02 1.2938299560546875e+02 -3.1204199218750000e+02 2.5410398864746094e+02 1.2439700317382812e+02 -2.9819000244140625e+02 2.2984500122070312e+02 1.2275499725341797e+02 -2.9790499877929688e+02 2.3047601318359375e+02 1.2117800140380859e+02 -2.9773397827148438e+02 2.3128799438476562e+02 1.1969100189208984e+02 -2.9767999267578125e+02 2.3226899719238281e+02 1.4027699279785156e+02 -3.0825201416015625e+02 2.3847399902343750e+02 1.3996400451660156e+02 -3.0738198852539062e+02 2.3695098876953125e+02 1.3944500732421875e+02 -3.0647598266601562e+02 2.3550700378417969e+02 1.3872799682617188e+02 -3.0554898071289062e+02 2.3416499328613281e+02 1.3551499938964844e+02 -3.0278598022460938e+02 2.3095298767089844e+02 1.3414700317382812e+02 -3.0191900634765625e+02 2.3020899963378906e+02 1.3266499328613281e+02 -3.0110299682617188e+02 2.2965200805664062e+02 1.3109199523925781e+02 -3.0035000610351562e+02 2.2928799438476562e+02 1.2945201110839844e+02 -2.9967199707031250e+02 2.2912500000000000e+02 1.1826399993896484e+02 -3.0744601440429688e+02 2.5299600219726562e+02 1.1963199615478516e+02 -3.0831301879882812e+02 2.5374000549316406e+02 1.2111399841308594e+02 -3.0912899780273438e+02 2.5429698181152344e+02 1.2268699645996094e+02 -3.0988198852539062e+02 2.5466099548339844e+02 1.2432699584960938e+02 -3.1055999755859375e+02 2.5482400512695312e+02 1.1366400146484375e+02 -2.9972399902343750e+02 2.4062699890136719e+02 1.1419699859619141e+02 -2.9911801147460938e+02 2.3901599121093750e+02 1.1333799743652344e+02 -3.0041500854492188e+02 2.4225900268554688e+02 1.1322599792480469e+02 -3.0118099975585938e+02 2.4388499450683594e+02 1.1333000183105469e+02 -3.0201101684570312e+02 2.4548100280761719e+02 1.1364600372314453e+02 -3.0289001464843750e+02 2.4702101135253906e+02 1.1417099761962891e+02 -3.0380599975585938e+02 2.4848100280761719e+02 1.1489599609375000e+02 -3.0474298095703125e+02 2.4983799743652344e+02 1.1580999755859375e+02 -3.0568701171875000e+02 2.5107099914550781e+02 1.1689900207519531e+02 -3.0662399291992188e+02 2.5215899658203125e+02 1.1814399719238281e+02 -3.0753698730468750e+02 2.5308599853515625e+02 1.1952700042724609e+02 -3.0841299438476562e+02 2.5383799743652344e+02 1.2261699676513672e+02 -3.1000000000000000e+02 2.5476899719238281e+02 1.2102600097656250e+02 -3.0923901367187500e+02 2.5440200805664062e+02 1.2597399902343750e+02 -3.1128399658203125e+02 2.5489500427246094e+02 1.2427500152587891e+02 -3.1068499755859375e+02 2.5493400573730469e+02 1.2938598632812500e+02 -3.1218499755859375e+02 2.5420600891113281e+02 1.2768700408935547e+02 -3.1178601074218750e+02 2.5465101623535156e+02 1.3104699707031250e+02 -3.1247198486328125e+02 2.5356799316406250e+02 1.3264100646972656e+02 -3.1264498901367188e+02 2.5274699401855469e+02 1.3414399719238281e+02 -3.1270001220703125e+02 2.5175601196289062e+02 1.3553201293945312e+02 -3.1263699340820312e+02 2.5060900878906250e+02 1.3678399658203125e+02 -3.1245498657226562e+02 2.4932600402832031e+02 1.3787899780273438e+02 -3.1215997314453125e+02 2.4792700195312500e+02 1.3880099487304688e+02 -3.1175399780273438e+02 2.4643299865722656e+02 1.3953399658203125e+02 -3.1124401855468750e+02 2.4486799621582031e+02 1.4006799316406250e+02 -3.1063900756835938e+02 2.4325700378417969e+02 1.4039300537109375e+02 -3.0994799804687500e+02 2.4162599182128906e+02 1.4040200805664062e+02 -3.0835198974609375e+02 2.3840299987792969e+02 1.4050500488281250e+02 -3.0918099975585938e+02 2.3999899291992188e+02 1.3955999755859375e+02 -3.0655700683593750e+02 2.3540299987792969e+02 1.4008599853515625e+02 -3.0747198486328125e+02 2.3686300659179688e+02 1.3792100524902344e+02 -3.0467501831054688e+02 2.3281399536132812e+02 1.3883499145507812e+02 -3.0562002563476562e+02 2.3404598999023438e+02 1.3683299255371094e+02 -3.0373901367187500e+02 2.3172500610351562e+02 1.3558700561523438e+02 -3.0282598876953125e+02 2.3079800415039062e+02 1.3420399475097656e+02 -3.0194900512695312e+02 2.3004600524902344e+02 1.3270500183105469e+02 -3.0112399291992188e+02 2.2948199462890625e+02 1.3111500549316406e+02 -3.0036199951171875e+02 2.2911499023437500e+02 1.2945700073242188e+02 -2.9967700195312500e+02 2.2894999694824219e+02 1.2775799560546875e+02 -2.9907901000976562e+02 2.2899000549316406e+02 1.2604500579833984e+02 -2.9857598876953125e+02 2.2923399353027344e+02 1.2434499359130859e+02 -2.9817797851562500e+02 2.2967800903320312e+02 1.2268499755859375e+02 -2.9789001464843750e+02 2.3031599426269531e+02 1.2109100341796875e+02 -2.9771798706054688e+02 2.3113699340820312e+02 1.1958800506591797e+02 -2.9766299438476562e+02 2.3212899780273438e+02 1.1694799804687500e+02 -2.9790698242187500e+02 2.3455799865722656e+02 1.1819899749755859e+02 -2.9772601318359375e+02 2.3327499389648438e+02 1.1493099975585938e+02 -2.9860897827148438e+02 2.3745100402832031e+02 1.1585199737548828e+02 -2.9820300292968750e+02 2.3595799255371094e+02 1.1500599670410156e+02 -2.9859301757812500e+02 2.3749700927734375e+02 1.1592300415039062e+02 -2.9818902587890625e+02 2.3601100158691406e+02 1.1701300048828125e+02 -2.9789501953125000e+02 2.3461799621582031e+02 1.1825899505615234e+02 -2.9771398925781250e+02 2.3334098815917969e+02 1.1964099884033203e+02 -2.9765100097656250e+02 2.3219999694824219e+02 1.2113600158691406e+02 -2.9770599365234375e+02 2.3121400451660156e+02 1.2272299957275391e+02 -2.9787799072265625e+02 2.3039599609375000e+02 1.2437500000000000e+02 -2.9816400146484375e+02 2.2976200866699219e+02 1.2606600189208984e+02 -2.9855999755859375e+02 2.2931900024414062e+02 1.2777100372314453e+02 -2.9905999755859375e+02 2.2907699584960938e+02 1.2946099853515625e+02 -2.9965600585937500e+02 2.2903700256347656e+02 1.3111099243164062e+02 -3.0033801269531250e+02 2.2920100402832031e+02 1.3269400024414062e+02 -3.0109597778320312e+02 2.2956700134277344e+02 1.3418600463867188e+02 -3.0191699218750000e+02 2.3012800598144531e+02 1.3556199645996094e+02 -3.0278900146484375e+02 2.3087599182128906e+02 1.3680200195312500e+02 -3.0369799804687500e+02 2.3179901123046875e+02 1.3788500976562500e+02 -3.0463000488281250e+02 2.3288198852539062e+02 1.3879400634765625e+02 -3.0556900024414062e+02 2.3410800170898438e+02 1.3951599121093750e+02 -3.0650201416015625e+02 2.3545899963378906e+02 1.4003900146484375e+02 -3.0741302490234375e+02 2.3691200256347656e+02 1.4035398864746094e+02 -3.0828799438476562e+02 2.3844400024414062e+02 1.4045600891113281e+02 -3.0911401367187500e+02 2.4003199768066406e+02 1.4034500122070312e+02 -3.0987600708007812e+02 2.4165100097656250e+02 1.4002099609375000e+02 -3.1056402587890625e+02 2.4327500915527344e+02 1.3948999023437500e+02 -3.1116699218750000e+02 2.4487799072265625e+02 1.3875999450683594e+02 -3.1167401123046875e+02 2.4643499755859375e+02 1.3784300231933594e+02 -3.1207699584960938e+02 2.4792100524902344e+02 1.3675299072265625e+02 -3.1237200927734375e+02 2.4931399536132812e+02 1.3550799560546875e+02 -3.1255200195312500e+02 2.5059100341796875e+02 1.3412599182128906e+02 -3.1261502075195312e+02 2.5173199462890625e+02 1.3263000488281250e+02 -3.1256100463867188e+02 2.5271800231933594e+02 1.3104400634765625e+02 -3.1238897705078125e+02 2.5353598022460938e+02 1.2939199829101562e+02 -3.1210198974609375e+02 2.5416999816894531e+02 1.2770000457763672e+02 -3.1170599365234375e+02 2.5461300659179688e+02 1.2599599456787109e+02 -3.1120602416992188e+02 2.5485501098632812e+02 1.2430500030517578e+02 -3.1061102294921875e+02 2.5489500427246094e+02 1.2265499877929688e+02 -3.0992901611328125e+02 2.5473100280761719e+02 1.2107199859619141e+02 -3.0917098999023438e+02 2.5436499023437500e+02 1.1958100128173828e+02 -3.0835000610351562e+02 2.5380400085449219e+02 1.1820399475097656e+02 -3.0747698974609375e+02 2.5305598449707031e+02 1.1696500396728516e+02 -3.0656799316406250e+02 2.5213301086425781e+02 1.1588200378417969e+02 -3.0563699340820312e+02 2.5104998779296875e+02 1.1497200012207031e+02 -3.0469702148437500e+02 2.4982400512695312e+02 1.1425000000000000e+02 -3.0376397705078125e+02 2.4847300720214844e+02 1.1372800445556641e+02 -3.0285299682617188e+02 2.4702000427246094e+02 1.1341300201416016e+02 -3.0197799682617188e+02 2.4548800659179688e+02 1.1331000518798828e+02 -3.0115301513671875e+02 2.4389999389648438e+02 1.1342199707031250e+02 -3.0039001464843750e+02 2.4228100585937500e+02 1.1374600219726562e+02 -2.9970199584960938e+02 2.4065699768066406e+02 1.1427700042724609e+02 -2.9910000610351562e+02 2.3905400085449219e+02 1.3331199645996094e+02 -3.0369699096679688e+02 2.2919900512695312e+02 1.3519700622558594e+02 -3.0490600585937500e+02 2.3025199890136719e+02 1.3680999755859375e+02 -3.0617800903320312e+02 2.3163299560546875e+02 1.3809999084472656e+02 -3.0747500610351562e+02 2.3330099487304688e+02 1.3902899169921875e+02 -3.0875701904296875e+02 2.3520300292968750e+02 1.3956800842285156e+02 -3.0998599243164062e+02 2.3728300476074219e+02 1.3970201110839844e+02 -3.1112301635742188e+02 2.3947801208496094e+02 1.3942498779296875e+02 -3.1213500976562500e+02 2.4171899414062500e+02 1.3874700927734375e+02 -3.1299099731445312e+02 2.4394099426269531e+02 1.3768800354003906e+02 -3.1366400146484375e+02 2.4607400512695312e+02 1.3627999877929688e+02 -3.1413400268554688e+02 2.4805499267578125e+02 1.3456599426269531e+02 -3.1438800048828125e+02 2.4982299804687500e+02 1.3259799194335938e+02 -3.1441598510742188e+02 2.5132400512695312e+02 1.3043600463867188e+02 -3.1421899414062500e+02 2.5251200866699219e+02 1.2814498901367188e+02 -3.1380200195312500e+02 2.5335198974609375e+02 1.2579500579833984e+02 -3.1317800903320312e+02 2.5381898498535156e+02 1.2345800018310547e+02 -3.1236599731445312e+02 2.5389701843261719e+02 1.2120500183105469e+02 -3.1139099121093750e+02 2.5358399963378906e+02 1.1910299682617188e+02 -3.1028198242187500e+02 2.5289100646972656e+02 1.1721800231933594e+02 -3.0907299804687500e+02 2.5183699035644531e+02 1.1560499572753906e+02 -3.0780099487304688e+02 2.5045600891113281e+02 1.1431500244140625e+02 -3.0650399780273438e+02 2.4878900146484375e+02 1.1338599395751953e+02 -3.0522201538085938e+02 2.4688600158691406e+02 1.1284700012207031e+02 -3.0399298095703125e+02 2.4480599975585938e+02 1.1271300506591797e+02 -3.0285598754882812e+02 2.4261199951171875e+02 1.1298999786376953e+02 -3.0184399414062500e+02 2.4037001037597656e+02 1.1366799926757812e+02 -3.0098797607421875e+02 2.3814900207519531e+02 1.1472699737548828e+02 -3.0031500244140625e+02 2.3601499938964844e+02 1.1613500213623047e+02 -2.9984500122070312e+02 2.3403399658203125e+02 1.1784899902343750e+02 -2.9959197998046875e+02 2.3226701354980469e+02 1.1981700134277344e+02 -2.9956298828125000e+02 2.3076599121093750e+02 1.2197999572753906e+02 -2.9976000976562500e+02 2.2957701110839844e+02 1.2426999664306641e+02 -3.0017700195312500e+02 2.2873699951171875e+02 1.2661999511718750e+02 -3.0080099487304688e+02 2.2827099609375000e+02 1.2895700073242188e+02 -3.0161300659179688e+02 2.2819299316406250e+02 1.3121000671386719e+02 -3.0258798217773438e+02 2.2850500488281250e+02 1.1807900238037109e+02 -3.0372399902343750e+02 2.2835699462890625e+02 1.2029500579833984e+02 -3.0392599487304688e+02 2.2713899230957031e+02 1.2264200592041016e+02 -3.0435299682617188e+02 2.2627799987792969e+02 1.2504899597167969e+02 -3.0499200439453125e+02 2.2580101013183594e+02 1.2975299072265625e+02 -3.0682299804687500e+02 2.2604100036621094e+02 1.2744400024414062e+02 -3.0582400512695312e+02 2.2572100830078125e+02 1.3190600585937500e+02 -3.0795898437500000e+02 2.2675100708007812e+02 1.3383799743652344e+02 -3.0919799804687500e+02 2.2783100891113281e+02 1.3549000549316406e+02 -3.1050198364257812e+02 2.2924600219726562e+02 1.3681199645996094e+02 -3.1183099365234375e+02 2.3095401000976562e+02 1.3776400756835938e+02 -3.1314401245117188e+02 2.3290400695800781e+02 1.3831700134277344e+02 -3.1440298461914062e+02 2.3503500366210938e+02 1.3845401000976562e+02 -3.1556900024414062e+02 2.3728401184082031e+02 1.3816999816894531e+02 -3.1660598754882812e+02 2.3958100891113281e+02 1.3747500610351562e+02 -3.1748199462890625e+02 2.4185700988769531e+02 1.3638999938964844e+02 -3.1817199707031250e+02 2.4404299926757812e+02 1.3319100952148438e+02 -3.1891302490234375e+02 2.4788400268554688e+02 1.3494700622558594e+02 -3.1865399169921875e+02 2.4607199096679688e+02 1.3117399597167969e+02 -3.1894299316406250e+02 2.4942199707031250e+02 1.2895899963378906e+02 -3.1874099731445312e+02 2.5063899230957031e+02 1.2661199188232422e+02 -3.1831298828125000e+02 2.5150001525878906e+02 1.2420400238037109e+02 -3.1767401123046875e+02 2.5197801208496094e+02 1.2180999755859375e+02 -3.1684197998046875e+02 2.5205799865722656e+02 1.1950099945068359e+02 -3.1584298706054688e+02 2.5173800659179688e+02 1.1734700012207031e+02 -3.1470700073242188e+02 2.5102699279785156e+02 1.1541500091552734e+02 -3.1346801757812500e+02 2.4994799804687500e+02 1.1376300048828125e+02 -3.1216400146484375e+02 2.4853298950195312e+02 1.1244100189208984e+02 -3.1083499145507812e+02 2.4682398986816406e+02 1.1093699645996094e+02 -3.0826300048828125e+02 2.4274400329589844e+02 1.1148899841308594e+02 -3.0952200317382812e+02 2.4487500000000000e+02 1.1079999542236328e+02 -3.0709698486328125e+02 2.4049499511718750e+02 1.1108300018310547e+02 -3.0606100463867188e+02 2.3819799804687500e+02 1.1177799987792969e+02 -3.0518402099609375e+02 2.3592199707031250e+02 1.1286400604248047e+02 -3.0449398803710938e+02 2.3373599243164062e+02 1.1430599975585938e+02 -3.0401199340820312e+02 2.3170599365234375e+02 1.1606299591064453e+02 -3.0375299072265625e+02 2.2989498901367188e+02 1.3835600280761719e+02 -3.1132598876953125e+02 2.4087300109863281e+02 1.3792799377441406e+02 -3.1210198974609375e+02 2.4275100708007812e+02 1.3698100280761719e+02 -3.1214599609375000e+02 2.4353300476074219e+02 1.3719599914550781e+02 -3.1274499511718750e+02 2.4458399963378906e+02 1.3612699890136719e+02 -3.1269799804687500e+02 2.4527200317382812e+02 1.3617999267578125e+02 -3.1323999023437500e+02 2.4632499694824219e+02 1.3500199890136719e+02 -3.1309399414062500e+02 2.4689599609375000e+02 1.3490599060058594e+02 -3.1357199096679688e+02 2.4793000793457031e+02 1.3363699340820312e+02 -3.1332400512695312e+02 2.4836100769042969e+02 1.3340699768066406e+02 -3.1373501586914062e+02 2.4935699462890625e+02 1.3206900024414062e+02 -3.1338098144531250e+02 2.4962500000000000e+02 1.3172100830078125e+02 -3.1372201538085938e+02 2.5056800842285156e+02 1.3034201049804688e+02 -3.1326400756835938e+02 2.5065600585937500e+02 1.2989201354980469e+02 -3.1353500366210938e+02 2.5153300476074219e+02 1.2850199890136719e+02 -3.1297601318359375e+02 2.5142500305175781e+02 1.2796700286865234e+02 -3.1317800903320312e+02 2.5222599792480469e+02 1.2659899902343750e+02 -3.1252398681640625e+02 2.5191000366210938e+02 1.2599800872802734e+02 -3.1266201782226562e+02 2.5262901306152344e+02 1.2468600463867188e+02 -3.1192098999023438e+02 2.5209901428222656e+02 1.2403299713134766e+02 -3.1199801635742188e+02 2.5273200988769531e+02 1.2281400299072266e+02 -3.1118399047851562e+02 2.5198701477050781e+02 1.2212500000000000e+02 -3.1120498657226562e+02 2.5253298950195312e+02 1.2103500366210938e+02 -3.1033300781250000e+02 2.5157600402832031e+02 1.2032300567626953e+02 -3.1030200195312500e+02 2.5203601074218750e+02 1.1939600372314453e+02 -3.0939001464843750e+02 2.5087800598144531e+02 1.1867299652099609e+02 -3.0931402587890625e+02 2.5125399780273438e+02 1.1794400024414062e+02 -3.0838201904296875e+02 2.4991099548339844e+02 1.1721800231933594e+02 -3.0826501464843750e+02 2.5020799255371094e+02 1.1671700286865234e+02 -3.0733599853515625e+02 2.4870300292968750e+02 1.1599600219726562e+02 -3.0718402099609375e+02 2.4892500305175781e+02 1.1574900054931641e+02 -3.0627999877929688e+02 2.4728601074218750e+02 1.1503900146484375e+02 -3.0609701538085938e+02 2.4743800354003906e+02 1.1506600189208984e+02 -3.0524398803710938e+02 2.4569799804687500e+02 1.1437100219726562e+02 -3.0503298950195312e+02 2.4578500366210938e+02 1.1468700408935547e+02 -3.0425500488281250e+02 2.4398399353027344e+02 1.1400900268554688e+02 -3.0402099609375000e+02 2.4400900268554688e+02 1.1462199401855469e+02 -3.0334100341796875e+02 2.4218901062011719e+02 1.1396299743652344e+02 -3.0308499145507812e+02 2.4215600585937500e+02 1.1487400054931641e+02 -3.0252600097656250e+02 2.4036399841308594e+02 1.1423500061035156e+02 -3.0225000000000000e+02 2.4027499389648438e+02 1.1543399810791016e+02 -3.0183398437500000e+02 2.3855599975585938e+02 1.1481600189208984e+02 -3.0153799438476562e+02 2.3841400146484375e+02 1.1628899383544922e+02 -3.0128198242187500e+02 2.3681700134277344e+02 1.1569300079345703e+02 -3.0096701049804688e+02 2.3661999511718750e+02 1.1741400146484375e+02 -3.0088497924804688e+02 2.3519299316406250e+02 1.1684200286865234e+02 -3.0055200195312500e+02 2.3494200134277344e+02 1.1877799987792969e+02 -3.0065499877929688e+02 2.3372900390625000e+02 1.1823300170898438e+02 -3.0030398559570312e+02 2.3342100524902344e+02 1.2034600067138672e+02 -3.0059799194335938e+02 2.3246400451660156e+02 1.1983100128173828e+02 -3.0022900390625000e+02 2.3209799194335938e+02 1.2207300567626953e+02 -3.0071499633789062e+02 2.3143299865722656e+02 1.2159399414062500e+02 -3.0032901000976562e+02 2.3100698852539062e+02 1.2391299438476562e+02 -3.0100399780273438e+02 2.3066499328613281e+02 1.2347699737548828e+02 -3.0060198974609375e+02 2.3017500305175781e+02 1.2581600189208984e+02 -3.0145498657226562e+02 2.3017900085449219e+02 1.2543000030517578e+02 -3.0104000854492188e+02 2.2962500000000000e+02 1.2772899627685547e+02 -3.0205801391601562e+02 2.2999000549316406e+02 1.2740400695800781e+02 -3.0163198852539062e+02 2.2937100219726562e+02 1.2960099792480469e+02 -3.0279498291015625e+02 2.3010299682617188e+02 1.2934599304199219e+02 -3.0236300659179688e+02 2.2941899108886719e+02 1.3138101196289062e+02 -3.0364700317382812e+02 2.3051400756835938e+02 1.3120700073242188e+02 -3.0321401977539062e+02 2.2976799011230469e+02 1.3301899719238281e+02 -3.0458898925781250e+02 2.3121200561523438e+02 1.3293899536132812e+02 -3.0416198730468750e+02 2.3040998840332031e+02 1.3447099304199219e+02 -3.0559799194335938e+02 2.3217800903320312e+02 1.3449600219726562e+02 -3.0518402099609375e+02 2.3132600402832031e+02 1.3569799804687500e+02 -3.0664398193359375e+02 2.3338699340820312e+02 1.3583900451660156e+02 -3.0625299072265625e+02 2.3249499511718750e+02 1.3666600036621094e+02 -3.0769900512695312e+02 2.3480400085449219e+02 1.3693200683593750e+02 -3.0733999633789062e+02 2.3388500976562500e+02 1.3734899902343750e+02 -3.0873599243164062e+02 2.3639099121093750e+02 1.3774800109863281e+02 -3.0841897583007812e+02 2.3545999145507812e+02 1.3772801208496094e+02 -3.0972399902343750e+02 2.3810600280761719e+02 1.3826499938964844e+02 -3.0946002197265625e+02 2.3717999267578125e+02 1.3779299926757812e+02 -3.1063800048828125e+02 2.3989999389648438e+02 1.3846899414062500e+02 -3.1043801879882812e+02 2.3900000000000000e+02 1.3754100036621094e+02 -3.1145300292968750e+02 2.4172599792480469e+02 1.1642400360107422e+02 -2.9826800537109375e+02 2.4247700500488281e+02 1.1698400115966797e+02 -2.9757501220703125e+02 2.4066999816894531e+02 1.1783900451660156e+02 -2.9702301025390625e+02 2.3893000793457031e+02 1.1896300506591797e+02 -2.9662701416015625e+02 2.3730599975585938e+02 1.2032800292968750e+02 -2.9639700317382812e+02 2.3584201049804688e+02 1.2189599609375000e+02 -2.9633999633789062e+02 2.3457699584960938e+02 1.2362300109863281e+02 -2.9645700073242188e+02 2.3354600524902344e+02 1.2546299743652344e+02 -2.9674499511718750e+02 2.3277799987792969e+02 1.2736600494384766e+02 -2.9719702148437500e+02 2.3229199218750000e+02 1.2927900695800781e+02 -2.9780001831054688e+02 2.3210301208496094e+02 1.3115100097656250e+02 -2.9853698730468750e+02 2.3221600341796875e+02 1.3293099975585938e+02 -2.9938800048828125e+02 2.3262699890136719e+02 1.3456900024414062e+02 -3.0033099365234375e+02 2.3332501220703125e+02 1.3602099609375000e+02 -3.0133898925781250e+02 2.3429100036621094e+02 1.3724800109863281e+02 -3.0238598632812500e+02 2.3550000000000000e+02 1.3821600341796875e+02 -3.0344097900390625e+02 2.3691700744628906e+02 1.3889900207519531e+02 -3.0447702026367188e+02 2.3850399780273438e+02 1.3927799987792969e+02 -3.0546600341796875e+02 2.4021899414062500e+02 1.3934298706054688e+02 -3.0638000488281250e+02 2.4201300048828125e+02 1.3909100341796875e+02 -3.0719500732421875e+02 2.4383898925781250e+02 1.3853100585937500e+02 -3.0788699340820312e+02 2.4564599609375000e+02 1.3767599487304688e+02 -3.0843899536132812e+02 2.4738499450683594e+02 1.3655099487304688e+02 -3.0883599853515625e+02 2.4900900268554688e+02 1.3518699645996094e+02 -3.0906600952148438e+02 2.5047399902343750e+02 1.3361898803710938e+02 -3.0912301635742188e+02 2.5173899841308594e+02 1.3189199829101562e+02 -3.0900601196289062e+02 2.5276899719238281e+02 1.3005200195312500e+02 -3.0871701049804688e+02 2.5353800964355469e+02 1.2814900207519531e+02 -3.0826602172851562e+02 2.5402297973632812e+02 1.2623600769042969e+02 -3.0766299438476562e+02 2.5421199035644531e+02 1.2436400604248047e+02 -3.0692602539062500e+02 2.5409999084472656e+02 1.2258399963378906e+02 -3.0607400512695312e+02 2.5368899536132812e+02 1.2094599914550781e+02 -3.0513198852539062e+02 2.5299099731445312e+02 1.1949399566650391e+02 -3.0412301635742188e+02 2.5202400207519531e+02 1.1826699829101562e+02 -3.0307702636718750e+02 2.5081599426269531e+02 1.1729899597167969e+02 -3.0202200317382812e+02 2.4939900207519531e+02 1.1661600494384766e+02 -3.0098501586914062e+02 2.4781100463867188e+02 1.1623699951171875e+02 -2.9999700927734375e+02 2.4609700012207031e+02 1.1617199707031250e+02 -2.9908300781250000e+02 2.4430200195312500e+02 1.3772999572753906e+02 -3.0898202514648438e+02 2.4843899536132812e+02 1.3874598693847656e+02 -3.0848699951171875e+02 2.4669699096679688e+02 1.3947799682617188e+02 -3.0784402465820312e+02 2.4486399841308594e+02 1.3990600585937500e+02 -3.0706799316406250e+02 2.4298599243164062e+02 1.4001899719238281e+02 -3.0617999267578125e+02 2.4111300659179688e+02 1.3981401062011719e+02 -3.0520199584960938e+02 2.3929299926757812e+02 1.3929800415039062e+02 -3.0416000366210938e+02 2.3757299804687500e+02 1.3848200988769531e+02 -3.0308200073242188e+02 2.3599800109863281e+02 1.3738900756835938e+02 -3.0199398803710938e+02 2.3460800170898438e+02 1.3604600524902344e+02 -3.0092599487304688e+02 2.3344000244140625e+02 1.3448899841308594e+02 -2.9990399169921875e+02 2.3252299499511719e+02 1.3275698852539062e+02 -2.9895498657226562e+02 2.3188200378417969e+02 1.3089599609375000e+02 -2.9810501098632812e+02 2.3153199768066406e+02 1.2895298767089844e+02 -2.9737402343750000e+02 2.3148399353027344e+02 1.2698000335693359e+02 -2.9678198242187500e+02 2.3173800659179688e+02 1.2502700042724609e+02 -2.9634402465820312e+02 2.3228800964355469e+02 1.2314399719238281e+02 -2.9607098388671875e+02 2.3311999511718750e+02 1.2138099670410156e+02 -2.9597100830078125e+02 2.3421099853515625e+02 1.1978299713134766e+02 -2.9604598999023438e+02 2.3553399658203125e+02 1.1839099884033203e+02 -2.9629400634765625e+02 2.3705500793457031e+02 1.1724299621582031e+02 -2.9670901489257812e+02 2.3873400878906250e+02 1.1636599731445312e+02 -2.9727999877929688e+02 2.4052700805664062e+02 1.1578399658203125e+02 -2.9799200439453125e+02 2.4238800048828125e+02 1.1551300048828125e+02 -2.9882601928710938e+02 2.4427000427246094e+02 1.1555899810791016e+02 -2.9976202392578125e+02 2.4612200927734375e+02 1.1591999816894531e+02 -3.0077499389648438e+02 2.4789799499511719e+02 1.1658900451660156e+02 -3.0183898925781250e+02 2.4955099487304688e+02 1.1754599761962891e+02 -3.0292498779296875e+02 2.5103800964355469e+02 1.1876799774169922e+02 -3.0400698852539062e+02 2.5232199096679688e+02 1.2022299957275391e+02 -3.0505499267578125e+02 2.5336799621582031e+02 1.2187300109863281e+02 -3.0604400634765625e+02 2.5414898681640625e+02 1.2367500305175781e+02 -3.0694601440429688e+02 2.5464599609375000e+02 1.2558299255371094e+02 -3.0773999023437500e+02 2.5484498596191406e+02 1.2754799652099609e+02 -3.0840298461914062e+02 2.5474198913574219e+02 1.2951699829101562e+02 -3.0891998291015625e+02 2.5433900451660156e+02 1.3144200134277344e+02 -3.0927700805664062e+02 2.5364598083496094e+02 1.3326998901367188e+02 -3.0946401977539062e+02 2.5268098449707031e+02 1.3495600891113281e+02 -3.0947598266601562e+02 2.5147000122070312e+02 1.3645599365234375e+02 -3.0931402587890625e+02 2.5004299926757812e+02 1.3930099487304688e+02 -3.0107400512695312e+02 2.5004399108886719e+02 1.3885499572753906e+02 -3.0085998535156250e+02 2.4994100952148438e+02 1.3845300292968750e+02 -3.0141897583007812e+02 2.5136000061035156e+02 1.3777500915527344e+02 -3.0125701904296875e+02 2.5153300476074219e+02 1.3713400268554688e+02 -3.0169000244140625e+02 2.5287399291992188e+02 1.3642900085449219e+02 -3.0147000122070312e+02 2.5294900512695312e+02 1.3558000183105469e+02 -3.0176800537109375e+02 2.5417102050781250e+02 1.3486599731445312e+02 -3.0149200439453125e+02 2.5413900756835938e+02 1.3384300231933594e+02 -3.0164999389648438e+02 2.5520799255371094e+02 1.3313999938964844e+02 -3.0132101440429688e+02 2.5506201171875000e+02 1.3198300170898438e+02 -3.0134100341796875e+02 2.5594898986816406e+02 1.3131100463867188e+02 -3.0096499633789062e+02 2.5568399047851562e+02 1.3006300354003906e+02 -3.0085098266601562e+02 2.5636999511718750e+02 1.2944300842285156e+02 -3.0043399047851562e+02 2.5598498535156250e+02 1.2814700317382812e+02 -3.0019598388671875e+02 2.5645599365234375e+02 1.2760199737548828e+02 -2.9974899291992188e+02 2.5595399475097656e+02 1.2630200195312500e+02 -2.9939898681640625e+02 2.5620300292968750e+02 1.2585300445556641e+02 -2.9893197631835938e+02 2.5559100341796875e+02 1.2458900451660156e+02 -2.9848699951171875e+02 2.5562199401855469e+02 1.2425500488281250e+02 -2.9801300048828125e+02 2.5491101074218750e+02 1.2306600189208984e+02 -2.9749102783203125e+02 2.5473100280761719e+02 1.2286599731445312e+02 -2.9702301025390625e+02 2.5393501281738281e+02 1.2178599548339844e+02 -2.9644400024414062e+02 2.5356001281738281e+02 1.2173400115966797e+02 -2.9599801635742188e+02 2.5269898986816406e+02 1.2079100036621094e+02 -2.9538198852539062e+02 2.5214999389648438e+02 1.2089900207519531e+02 -2.9497299194335938e+02 2.5124600219726562e+02 1.2011600494384766e+02 -2.9434100341796875e+02 2.5054899597167969e+02 1.2038899993896484e+02 -2.9398400878906250e+02 2.4962699890136719e+02 1.1978299713134766e+02 -2.9335702514648438e+02 2.4880899047851562e+02 1.2022399902343750e+02 -2.9306500244140625e+02 2.4789799499511719e+02 1.1980299377441406e+02 -2.9246301269531250e+02 2.4699200439453125e+02 1.2040699768066406e+02 -2.9225000000000000e+02 2.4612001037597656e+02 1.2017700195312500e+02 -2.9168798828125000e+02 2.4515699768066406e+02 1.2093400573730469e+02 -2.9156600952148438e+02 2.4435499572753906e+02 1.3991198730468750e+02 -2.9992999267578125e+02 2.4729100036621094e+02 1.4035800170898438e+02 -3.0014398193359375e+02 2.4739399719238281e+02 1.4017700195312500e+02 -2.9914297485351562e+02 2.4551100158691406e+02 1.4061500549316406e+02 -2.9951599121093750e+02 2.4594099426269531e+02 1.4009300231933594e+02 -2.9824600219726562e+02 2.4376499938964844e+02 1.4062400817871094e+02 -2.9861898803710938e+02 2.4412500000000000e+02 1.3966400146484375e+02 -2.9727102661132812e+02 2.4211399841308594e+02 1.4027999877929688e+02 -2.9763201904296875e+02 2.4238999938964844e+02 1.3890299987792969e+02 -2.9625100708007812e+02 2.4061700439453125e+02 1.3959400939941406e+02 -2.9658999633789062e+02 2.4079299926757812e+02 1.3783699035644531e+02 -2.9522299194335938e+02 2.3932600402832031e+02 1.3858898925781250e+02 -2.9552798461914062e+02 2.3938999938964844e+02 1.3650399780273438e+02 -2.9422198486328125e+02 2.3828601074218750e+02 1.3730000305175781e+02 -2.9448300170898438e+02 2.3822799682617188e+02 1.3495098876953125e+02 -2.9328298950195312e+02 2.3753399658203125e+02 1.3577101135253906e+02 -2.9348800659179688e+02 2.3734700012207031e+02 1.3323199462890625e+02 -2.9243902587890625e+02 2.3709500122070312e+02 1.3405198669433594e+02 -2.9258001708984375e+02 2.3677600097656250e+02 1.3140699768066406e+02 -2.9172000122070312e+02 2.3698500061035156e+02 1.3220300292968750e+02 -2.9178698730468750e+02 2.3653500366210938e+02 1.2953900146484375e+02 -2.9115200805664062e+02 2.3720799255371094e+02 1.3028700256347656e+02 -2.9113702392578125e+02 2.3663200378417969e+02 1.2769599151611328e+02 -2.9075302124023438e+02 2.3775700378417969e+02 1.2836801147460938e+02 -2.9065298461914062e+02 2.3706300354003906e+02 1.2593999481201172e+02 -2.9053802490234375e+02 2.3861199951171875e+02 1.2651099395751953e+02 -2.9034997558593750e+02 2.3781399536132812e+02 1.2433300018310547e+02 -2.9051397705078125e+02 2.3974198913574219e+02 1.2477899932861328e+02 -2.9023901367187500e+02 2.3886000061035156e+02 1.2293199920654297e+02 -2.9068197631835938e+02 2.4110899353027344e+02 1.2323100280761719e+02 -2.9032299804687500e+02 2.4016499328613281e+02 1.2178599548339844e+02 -2.9103698730468750e+02 2.4266499328613281e+02 1.2192100524902344e+02 -2.9060000610351562e+02 2.4168499755859375e+02 1.2089099884033203e+02 -2.9105999755859375e+02 2.4336799621582031e+02 1.3935400390625000e+02 -3.0146301269531250e+02 2.4653099060058594e+02 1.3961898803710938e+02 -3.0067599487304688e+02 2.4475000000000000e+02 1.3953599548339844e+02 -2.9977899169921875e+02 2.4300399780273438e+02 1.3910600280761719e+02 -2.9880398559570312e+02 2.4135400390625000e+02 1.3834500122070312e+02 -2.9778399658203125e+02 2.3985700988769531e+02 1.3727900695800781e+02 -2.9675601196289062e+02 2.3856599426269531e+02 1.3594599914550781e+02 -2.9575399780273438e+02 2.3752600097656250e+02 1.3439300537109375e+02 -2.9481597900390625e+02 2.3677299499511719e+02 1.3267399597167969e+02 -2.9397198486328125e+02 2.3633399963378906e+02 1.3084899902343750e+02 -2.9325299072265625e+02 2.3622399902343750e+02 1.2898199462890625e+02 -2.9268499755859375e+02 2.3644799804687500e+02 1.2713800048828125e+02 -2.9228601074218750e+02 2.3699600219726562e+02 1.2538200378417969e+02 -2.9207101440429688e+02 2.3785099792480469e+02 1.2377500152587891e+02 -2.9204699707031250e+02 2.3898200988769531e+02 1.2237400054931641e+02 -2.9221499633789062e+02 2.4034899902343750e+02 1.2122800445556641e+02 -2.9257000732421875e+02 2.4190400695800781e+02 1.2037599945068359e+02 -2.9309899902343750e+02 2.4359400939941406e+02 1.1984899902343750e+02 -2.9378302001953125e+02 2.4535900878906250e+02 1.1966600036621094e+02 -2.9459802246093750e+02 2.4713699340820312e+02 1.1983100128173828e+02 -2.9551699829101562e+02 2.4886601257324219e+02 1.2034100341796875e+02 -2.9650598144531250e+02 2.5048500061035156e+02 1.2117599487304688e+02 -2.9753100585937500e+02 2.5193899536132812e+02 1.2230799865722656e+02 -2.9855599975585938e+02 2.5317401123046875e+02 1.2369699859619141e+02 -2.9954598999023438e+02 2.5415000915527344e+02 1.2529499816894531e+02 -3.0046499633789062e+02 2.5483099365234375e+02 1.2704400634765625e+02 -3.0128198242187500e+02 2.5519299316406250e+02 1.2888499450683594e+02 -3.0196697998046875e+02 2.5522398376464844e+02 1.3075299072265625e+02 -3.0249801635742188e+02 2.5492399597167969e+02 1.3258200073242188e+02 -3.0285400390625000e+02 2.5430101013183594e+02 1.3430799865722656e+02 -3.0302499389648438e+02 2.5337800598144531e+02 1.3587098693847656e+02 -3.0300302124023438e+02 2.5218800354003906e+02 1.3721699523925781e+02 -3.0278997802734375e+02 2.5077200317382812e+02 1.3829701232910156e+02 -3.0239297485351562e+02 2.4918000793457031e+02 1.3855000305175781e+02 -3.0499899291992188e+02 2.5424600219726562e+02 1.3892201232910156e+02 -3.0269198608398438e+02 2.4932398986816406e+02 1.4010299682617188e+02 -3.0472201538085938e+02 2.5254800415039062e+02 1.3954899597167969e+02 -3.0292098999023438e+02 2.4932600402832031e+02 1.4138600158691406e+02 -3.0425900268554688e+02 2.5067498779296875e+02 1.4015600585937500e+02 -3.0301300048828125e+02 2.4906500244140625e+02 1.4236399841308594e+02 -3.0362200927734375e+02 2.4867300415039062e+02 1.3676600646972656e+02 -3.0508300781250000e+02 2.5572299194335938e+02 1.1608800506591797e+02 -2.9269598388671875e+02 2.4592700195312500e+02 1.1596099853515625e+02 -2.9368698120117188e+02 2.4801799011230469e+02 1.1618900299072266e+02 -2.9477798461914062e+02 2.5005000305175781e+02 1.1676599884033203e+02 -2.9594100952148438e+02 2.5196998596191406e+02 1.1767599487304688e+02 -2.9714501953125000e+02 2.5372799682617188e+02 1.1889699554443359e+02 -2.9835900878906250e+02 2.5527998352050781e+02 1.2039600372314453e+02 -2.9955200195312500e+02 2.5658398437500000e+02 1.2213400268554688e+02 -3.0069198608398438e+02 2.5760702514648438e+02 1.4062400817871094e+02 -3.0294900512695312e+02 2.4859300231933594e+02 1.4085899353027344e+02 -3.0274200439453125e+02 2.4800300598144531e+02 1.4301399230957031e+02 -3.0282699584960938e+02 2.4659500122070312e+02 1.4081500244140625e+02 -3.0243301391601562e+02 2.4741299438476562e+02 1.4331700134277344e+02 -3.0189498901367188e+02 2.4449501037597656e+02 1.4050100708007812e+02 -3.0208297729492188e+02 2.4693901062011719e+02 1.4326499938964844e+02 -3.0085098266601562e+02 2.4242700195312500e+02 1.3997900390625000e+02 -3.0176202392578125e+02 2.4667500305175781e+02 1.4286199951171875e+02 -2.9972000122070312e+02 2.4044500732421875e+02 1.1656499481201172e+02 -2.9183001708984375e+02 2.4383200073242188e+02 1.1738199615478516e+02 -2.9111099243164062e+02 2.4178500366210938e+02 1.1851599884033203e+02 -2.9055899047851562e+02 2.3984100341796875e+02 1.1993800354003906e+02 -2.9018801879882812e+02 2.3805000305175781e+02 1.2161199951171875e+02 -2.9000698852539062e+02 2.3645700073242188e+02 1.2349399566650391e+02 -2.9002099609375000e+02 2.3510499572753906e+02 1.2553599548339844e+02 -2.9023001098632812e+02 2.3402799987792969e+02 1.2406700134277344e+02 -3.0175097656250000e+02 2.5832302856445312e+02 1.2614500427246094e+02 -3.0270098876953125e+02 2.5871301269531250e+02 1.2831300354003906e+02 -3.0351702880859375e+02 2.5876699829101562e+02 1.3051599121093750e+02 -3.0417800903320312e+02 2.5848300170898438e+02 1.3269700622558594e+02 -3.0466699218750000e+02 2.5786901855468750e+02 1.3479800415039062e+02 -3.0497100830078125e+02 2.5694097900390625e+02 1.2768399810791016e+02 -2.9062799072265625e+02 2.3325500488281250e+02 1.2988301086425781e+02 -2.9120498657226562e+02 2.3280499267578125e+02 1.3207499694824219e+02 -2.9194598388671875e+02 2.3268899536132812e+02 1.3420500183105469e+02 -2.9283099365234375e+02 2.3291200256347656e+02 1.3621699523925781e+02 -2.9383901977539062e+02 2.3346600341796875e+02 1.3805900573730469e+02 -2.9494198608398438e+02 2.3433900451660156e+02 1.3968299865722656e+02 -2.9611300659179688e+02 2.3550599670410156e+02 1.4211599731445312e+02 -2.9853298950195312e+02 2.3859899902343750e+02 1.4104699707031250e+02 -2.9732000732421875e+02 2.3693899536132812e+02 1.4251998901367188e+02 -3.0319601440429688e+02 2.4888400268554688e+02 1.4316900634765625e+02 -3.0240100097656250e+02 2.4680699157714844e+02 1.4097100830078125e+02 -3.0200698852539062e+02 2.4762500000000000e+02 1.4065599060058594e+02 -3.0165698242187500e+02 2.4715100097656250e+02 1.4347200012207031e+02 -3.0146899414062500e+02 2.4470600891113281e+02 1.4013400268554688e+02 -3.0133599853515625e+02 2.4688699340820312e+02 1.4342098999023438e+02 -3.0042401123046875e+02 2.4263800048828125e+02 1.4301699829101562e+02 -2.9929400634765625e+02 2.4065600585937500e+02 1.1919100189208984e+02 -2.9441601562500000e+02 2.4830200195312500e+02 1.1634500122070312e+02 -2.9435198974609375e+02 2.5026100158691406e+02 1.1952999877929688e+02 -2.9541799926757812e+02 2.5007298278808594e+02 1.1692099761962891e+02 -2.9551501464843750e+02 2.5218099975585938e+02 1.2021700286865234e+02 -2.9647698974609375e+02 2.5170401000976562e+02 1.1783200073242188e+02 -2.9671902465820312e+02 2.5393998718261719e+02 1.2122999572753906e+02 -2.9755801391601562e+02 2.5313999938964844e+02 1.1905200195312500e+02 -2.9793301391601562e+02 2.5549098205566406e+02 1.2253300476074219e+02 -2.9862402343750000e+02 2.5433099365234375e+02 1.2055099487304688e+02 -2.9912500000000000e+02 2.5679598999023438e+02 1.2408399963378906e+02 -2.9963897705078125e+02 2.5523901367187500e+02 1.2228900146484375e+02 -3.0026599121093750e+02 2.5781900024414062e+02 1.2582799530029297e+02 -3.0056698608398438e+02 2.5583100891113281e+02 1.2422200012207031e+02 -3.0132498168945312e+02 2.5853500366210938e+02 1.2770700073242188e+02 -3.0137899780273438e+02 2.5608700561523438e+02 1.4101399230957031e+02 -3.0231600952148438e+02 2.4821501159667969e+02 1.4077900695800781e+02 -3.0252200317382812e+02 2.4880400085449219e+02 1.4154100036621094e+02 -3.0383300781250000e+02 2.5088598632812500e+02 1.4031199645996094e+02 -3.0258599853515625e+02 2.4927600097656250e+02 1.4025900268554688e+02 -3.0429598999023438e+02 2.5275999450683594e+02 1.3970401000976562e+02 -3.0249499511718750e+02 2.4953700256347656e+02 1.3870500183105469e+02 -3.0457299804687500e+02 2.5445700073242188e+02 1.3907699584960938e+02 -3.0226599121093750e+02 2.4953599548339844e+02 1.3692199707031250e+02 -3.0465701293945312e+02 2.5593400573730469e+02 1.3907598876953125e+02 -3.0226599121093750e+02 2.4953599548339844e+02 1.3820100402832031e+02 -3.0262399291992188e+02 2.5089999389648438e+02 1.2630001068115234e+02 -3.0227499389648438e+02 2.5892498779296875e+02 1.2846800231933594e+02 -3.0308999633789062e+02 2.5897900390625000e+02 1.2965699768066406e+02 -3.0204498291015625e+02 2.5600000000000000e+02 1.3067098999023438e+02 -3.0375097656250000e+02 2.5869500732421875e+02 1.3161300659179688e+02 -3.0254400634765625e+02 2.5557199096679688e+02 1.3285200500488281e+02 -3.0423999023437500e+02 2.5808099365234375e+02 1.3350599670410156e+02 -3.0285900878906250e+02 2.5481701660156250e+02 1.3495300292968750e+02 -3.0454498291015625e+02 2.5715301513671875e+02 1.3527500915527344e+02 -3.0297900390625000e+02 2.5376200866699219e+02 1.3685700988769531e+02 -3.0289999389648438e+02 2.5244099426269531e+02 1.2427700042724609e+02 -2.9124002075195312e+02 2.3817199707031250e+02 1.2176699829101562e+02 -2.8958099365234375e+02 2.3666900634765625e+02 1.2270200347900391e+02 -2.9132598876953125e+02 2.3950100708007812e+02 1.2009400177001953e+02 -2.8976199340820312e+02 2.3826100158691406e+02 1.2136699676513672e+02 -2.9160800170898438e+02 2.4104798889160156e+02 1.1867099761962891e+02 -2.9013299560546875e+02 2.4005299377441406e+02 1.2031900024414062e+02 -2.9207699584960938e+02 2.4276199340820312e+02 1.1753700256347656e+02 -2.9068499755859375e+02 2.4199700927734375e+02 1.1959200286865234e+02 -2.9271600341796875e+02 2.4458399963378906e+02 1.1672000122070312e+02 -2.9140298461914062e+02 2.4404299926757812e+02 1.1921199798583984e+02 -2.9350500488281250e+02 2.4645100402832031e+02 1.1624299621582031e+02 -2.9226898193359375e+02 2.4613900756835938e+02 1.1611600494384766e+02 -2.9326098632812500e+02 2.4822999572753906e+02 1.4013299560546875e+02 -3.0133599853515625e+02 2.4688699340820312e+02 1.4040200805664062e+02 -3.0068698120117188e+02 2.4538198852539062e+02 1.4041101074218750e+02 -2.9977301025390625e+02 2.4353300476074219e+02 1.4005999755859375e+02 -2.9876800537109375e+02 2.4176600646972656e+02 1.3702699279785156e+02 -2.9556097412109375e+02 2.3752899169921875e+02 1.3821400451660156e+02 -2.9451599121093750e+02 2.3455000305175781e+02 1.3546900939941406e+02 -2.9454898071289062e+02 2.3663200378417969e+02 1.3637199401855469e+02 -2.9341198730468750e+02 2.3367799377441406e+02 1.3372000122070312e+02 -2.9362402343750000e+02 2.3604998779296875e+02 1.3436099243164062e+02 -2.9240499877929688e+02 2.3312300109863281e+02 1.3183699035644531e+02 -2.9281698608398438e+02 2.3580500793457031e+02 1.3223100280761719e+02 -2.9151898193359375e+02 2.3290100097656250e+02 1.2988600158691406e+02 -2.9215600585937500e+02 2.3590299987792969e+02 1.3003799438476562e+02 -2.9077801513671875e+02 2.3301600646972656e+02 1.2793099975585938e+02 -2.9166201782226562e+02 2.3634199523925781e+02 1.2783899688720703e+02 -2.9020101928710938e+02 2.3346600341796875e+02 1.2604099273681641e+02 -2.9135400390625000e+02 2.3710699462890625e+02 1.2569099426269531e+02 -2.8980401611328125e+02 2.3423999023437500e+02 1.2365000152587891e+02 -2.8959500122070312e+02 2.3531700134277344e+02 1.3936201477050781e+02 -2.9770700073242188e+02 2.4013999938964844e+02 1.4227099609375000e+02 -2.9810601806640625e+02 2.3881100463867188e+02 1.3833900451660156e+02 -2.9662600708007812e+02 2.3871199035644531e+02 1.4120199584960938e+02 -2.9689300537109375e+02 2.3715100097656250e+02 1.3983799743652344e+02 -2.9568600463867188e+02 2.3571800231933594e+02 1.4063499450683594e+02 -2.9941799926757812e+02 2.4572900390625000e+02 1.4018499755859375e+02 -2.9905502319335938e+02 2.4532798767089844e+02 1.4058000183105469e+02 -2.9841299438476562e+02 2.4374400329589844e+02 1.4003300476074219e+02 -2.9804998779296875e+02 2.4341400146484375e+02 1.4010099792480469e+02 -2.9730999755859375e+02 2.4187199401855469e+02 1.3946199035644531e+02 -2.9695800781250000e+02 2.4163099670410156e+02 1.3921701049804688e+02 -2.9615301513671875e+02 2.4018800354003906e+02 1.3849699401855469e+02 -2.9582501220703125e+02 2.4005499267578125e+02 1.3796299743652344e+02 -2.9498898315429688e+02 2.3876400756835938e+02 1.3717800903320312e+02 -2.9469900512695312e+02 2.3875399780273438e+02 1.3639299011230469e+02 -2.9386801147460938e+02 2.3765499877929688e+02 1.3556300354003906e+02 -2.9362899780273438e+02 2.3778300476074219e+02 1.3456900024414062e+02 -2.9283300781250000e+02 2.3690899658203125e+02 1.3371899414062500e+02 -2.9266101074218750e+02 2.3718299865722656e+02 1.3256600952148438e+02 -2.9192901611328125e+02 2.3655499267578125e+02 1.3172599792480469e+02 -2.9183398437500000e+02 2.3698001098632812e+02 1.3046699523925781e+02 -2.9119100952148438e+02 2.3660800170898438e+02 1.2966799926757812e+02 -2.9118600463867188e+02 2.3718200683593750e+02 1.2835699462890625e+02 -2.9065100097656250e+02 2.3706599426269531e+02 1.2763300323486328e+02 -2.9074200439453125e+02 2.3778199768066406e+02 1.2632299804687500e+02 -2.9032901000976562e+02 2.3791000366210938e+02 1.2570800018310547e+02 -2.9052297973632812e+02 2.3875199890136719e+02 1.2444799804687500e+02 -2.9023999023437500e+02 2.3910600280761719e+02 1.2397400665283203e+02 -2.9053698730468750e+02 2.4005200195312500e+02 1.2280799865722656e+02 -2.9038699340820312e+02 2.4060400390625000e+02 1.2250599670410156e+02 -2.9078399658203125e+02 2.4162699890136719e+02 1.2147200012207031e+02 -2.9076300048828125e+02 2.4234400939941406e+02 1.2136500549316406e+02 -2.9125402832031250e+02 2.4340899658203125e+02 1.2049300384521484e+02 -2.9135501098632812e+02 2.4425299072265625e+02 1.2060199737548828e+02 -2.9192501831054688e+02 2.4532299804687500e+02 1.1991100311279297e+02 -2.9213601684570312e+02 2.4625399780273438e+02 1.2024800109863281e+02 -2.9277102661132812e+02 2.4728700256347656e+02 1.3764700317382812e+02 -3.0128799438476562e+02 2.5168898010253906e+02 1.3831399536132812e+02 -3.0145999145507812e+02 2.5154501342773438e+02 1.3612200927734375e+02 -3.0149099731445312e+02 2.5321498107910156e+02 1.3681900024414062e+02 -3.0172299194335938e+02 2.5317201232910156e+02 1.3434500122070312e+02 -3.0145901489257812e+02 2.5445600891113281e+02 1.3505200195312500e+02 -3.0175201416015625e+02 2.5452598571777344e+02 1.3239199829101562e+02 -3.0119601440429688e+02 2.5535699462890625e+02 1.3308799743652344e+02 -3.0154498291015625e+02 2.5555101013183594e+02 1.3034599304199219e+02 -3.0071099853515625e+02 2.5588101196289062e+02 1.3100500488281250e+02 -3.0111199951171875e+02 2.5620498657226562e+02 1.2829299926757812e+02 -3.0002600097656250e+02 2.5600497436523438e+02 1.2888899230957031e+02 -3.0046902465820312e+02 2.5646200561523438e+02 1.2632299804687500e+02 -2.9916900634765625e+02 2.5572401428222656e+02 1.2682800292968750e+02 -2.9964398193359375e+02 2.5631100463867188e+02 1.2451699829101562e+02 -2.9817700195312500e+02 2.5505000305175781e+02 1.2490499877929688e+02 -2.9866998291015625e+02 2.5575798034667969e+02 1.2295400238037109e+02 -2.9709301757812500e+02 2.5401100158691406e+02 1.2319899749755859e+02 -2.9758599853515625e+02 2.5482600402832031e+02 1.2169999694824219e+02 -2.9596200561523438e+02 2.5265199279785156e+02 1.2177899932861328e+02 -2.9643801879882812e+02 2.5355300903320312e+02 1.2080900573730469e+02 -2.9483300781250000e+02 2.5103100585937500e+02 1.2070500183105469e+02 -2.9527200317382812e+02 2.5199099731445312e+02 1.2031699371337891e+02 -2.9375399780273438e+02 2.4921701049804688e+02 1.2002000427246094e+02 -2.9413598632812500e+02 2.5020399475097656e+02 1.1975199890136719e+02 -2.9307601928710938e+02 2.4826499938964844e+02 1.3962699890136719e+02 -3.0058801269531250e+02 2.4456700134277344e+02 1.3947500610351562e+02 -2.9958297729492188e+02 2.4265299987792969e+02 1.3890400695800781e+02 -2.9849099731445312e+02 2.4086999511718750e+02 1.3793901062011719e+02 -2.9735800170898438e+02 2.3929501342773438e+02 1.3661999511718750e+02 -2.9623202514648438e+02 2.3799400329589844e+02 1.3500500488281250e+02 -2.9516198730468750e+02 2.3702299499511719e+02 1.3316200256347656e+02 -2.9419400024414062e+02 2.3642300415039062e+02 1.3116799926757812e+02 -2.9336700439453125e+02 2.3622000122070312e+02 1.2911000061035156e+02 -2.9271899414062500e+02 2.3642199707031250e+02 1.2707500457763672e+02 -2.9227502441406250e+02 2.3702099609375000e+02 1.2514999389648438e+02 -2.9205599975585938e+02 2.3799101257324219e+02 1.2341600036621094e+02 -2.9207000732421875e+02 2.3929199218750000e+02 1.2194799804687500e+02 -2.9231701660156250e+02 2.4086601257324219e+02 1.2080699920654297e+02 -2.9278698730468750e+02 2.4264900207519531e+02 1.2004399871826172e+02 -2.9345800781250000e+02 2.4456300354003906e+02 1.1969000244140625e+02 -2.9430401611328125e+02 2.4652600097656250e+02 1.1975900268554688e+02 -2.9528701782226562e+02 2.4845700073242188e+02 1.2025099945068359e+02 -2.9636599731445312e+02 2.5027099609375000e+02 1.2114199829101562e+02 -2.9749499511718750e+02 2.5189199829101562e+02 1.2239599609375000e+02 -2.9862600708007812e+02 2.5325099182128906e+02 1.2395899963378906e+02 -2.9970999145507812e+02 2.5428900146484375e+02 1.2576499938964844e+02 -3.0070199584960938e+02 2.5496301269531250e+02 1.2773500061035156e+02 -3.0155899047851562e+02 2.5524398803710938e+02 1.2978799438476562e+02 -3.0224401855468750e+02 2.5512001037597656e+02 1.3183399963378906e+02 -3.0272900390625000e+02 2.5459599304199219e+02 1.3378700256347656e+02 -3.0299197387695312e+02 2.5369500732421875e+02 1.3556399536132812e+02 -3.0302398681640625e+02 2.5245500183105469e+02 1.3708900451660156e+02 -3.0282101440429688e+02 2.5092800903320312e+02 1.4027899169921875e+02 -3.0190597534179688e+02 2.4674400329589844e+02 1.3818299865722656e+02 -3.0509100341796875e+02 2.5469898986816406e+02 1.3617298889160156e+02 -3.0511999511718750e+02 2.5623199462890625e+02 1.3396600341796875e+02 -3.0491799926757812e+02 2.5744500732421875e+02 1.1882199859619141e+02 -2.9836499023437500e+02 2.5534599304199219e+02 1.2046899414062500e+02 -2.9966400146484375e+02 2.5675601196289062e+02 1.2239400482177734e+02 -3.0089898681640625e+02 2.5783200073242188e+02 1.2454000091552734e+02 -3.0203100585937500e+02 2.5854000854492188e+02 1.2684099578857422e+02 -3.0302700805664062e+02 2.5885900878906250e+02 1.2922700500488281e+02 -3.0385598754882812e+02 2.5877899169921875e+02 1.3162699890136719e+02 -3.0449301147460938e+02 2.5830297851562500e+02 1.1684400177001953e+02 -2.9140798950195312e+02 2.4277799987792969e+02 1.1615100097656250e+02 -2.9228198242187500e+02 2.4504699707031250e+02 1.1586900329589844e+02 -2.9331500244140625e+02 2.4733599853515625e+02 1.1600500488281250e+02 -2.9447698974609375e+02 2.4957699584960938e+02 1.1655600738525391e+02 -2.9573101806640625e+02 2.5170100402832031e+02 1.1750499725341797e+02 -2.9703997802734375e+02 2.5364398193359375e+02 1.4329100036621094e+02 -3.0059600830078125e+02 2.4189500427246094e+02 1.4342799377441406e+02 -3.0175701904296875e+02 2.4413500976562500e+02 1.4087100219726562e+02 -3.0228497314453125e+02 2.4707501220703125e+02 1.4314498901367188e+02 -3.0279098510742188e+02 2.4642500305175781e+02 1.4116198730468750e+02 -3.0268798828125000e+02 2.4767201232910156e+02 1.4245300292968750e+02 -3.0366400146484375e+02 2.4869300842285156e+02 1.4107499694824219e+02 -3.0300500488281250e+02 2.4837500000000000e+02 1.4137100219726562e+02 -3.0435198974609375e+02 2.5087197875976562e+02 1.4063400268554688e+02 -3.0315301513671875e+02 2.4899600219726562e+02 1.3993299865722656e+02 -3.0483200073242188e+02 2.5289401245117188e+02 1.3995500183105469e+02 -3.0309100341796875e+02 2.4936898803710938e+02 1.3922200012207031e+02 -3.0283599853515625e+02 2.4939399719238281e+02 1.4274099731445312e+02 -2.9934201049804688e+02 2.3977099609375000e+02 1.4179199218750000e+02 -2.9803198242187500e+02 2.3782800292968750e+02 1.4047500610351562e+02 -2.9670797729492188e+02 2.3612600708007812e+02 1.3882798767089844e+02 -2.9540899658203125e+02 2.3471499633789062e+02 1.3690299987792969e+02 -2.9417398071289062e+02 2.3363900756835938e+02 1.3475700378417969e+02 -2.9304199218750000e+02 2.3293099975585938e+02 1.3245600891113281e+02 -2.9204602050781250e+02 2.3261199951171875e+02 1.3006900024414062e+02 -2.9121701049804688e+02 2.3269200134277344e+02 1.2767000579833984e+02 -2.9058001708984375e+02 2.3316799926757812e+02 1.2533100128173828e+02 -2.9015402221679688e+02 2.3402600097656250e+02 1.2312300109863281e+02 -2.8995300292968750e+02 2.3523999023437500e+02 1.2111399841308594e+02 -2.8998199462890625e+02 2.3677200317382812e+02 1.1936299896240234e+02 -2.9024099731445312e+02 2.3857699584960938e+02 1.1792600250244141e+02 -2.9072100830078125e+02 2.4060000610351562e+02 1.1668899536132812e+02 -2.9183398437500000e+02 2.4256700134277344e+02 1.1599600219726562e+02 -2.9270800781250000e+02 2.4483500671386719e+02 1.1571399688720703e+02 -2.9374099731445312e+02 2.4712500000000000e+02 1.1584999847412109e+02 -2.9490200805664062e+02 2.4936599731445312e+02 1.1640100097656250e+02 -2.9615701293945312e+02 2.5148901367187500e+02 1.1734999847412109e+02 -2.9746600341796875e+02 2.5343200683593750e+02 1.1866699981689453e+02 -2.9879098510742188e+02 2.5513499450683594e+02 1.2031400299072266e+02 -3.0008999633789062e+02 2.5654501342773438e+02 1.2223899841308594e+02 -3.0132400512695312e+02 2.5762100219726562e+02 1.2438500213623047e+02 -3.0245700073242188e+02 2.5832901000976562e+02 1.2668600463867188e+02 -3.0345300292968750e+02 2.5864801025390625e+02 1.2907199096679688e+02 -3.0428201293945312e+02 2.5856799316406250e+02 1.3147200012207031e+02 -3.0491900634765625e+02 2.5809197998046875e+02 1.3381100463867188e+02 -3.0534399414062500e+02 2.5723400878906250e+02 1.3601799011230469e+02 -3.0554501342773438e+02 2.5602001953125000e+02 1.3802799987792969e+02 -3.0551599121093750e+02 2.5448799133300781e+02 1.3977799987792969e+02 -3.0525799560546875e+02 2.5268301391601562e+02 1.4121598815917969e+02 -3.0477700805664062e+02 2.5066000366210938e+02 1.4229800415039062e+02 -3.0408999633789062e+02 2.4848200988769531e+02 1.4298999023437500e+02 -3.0321697998046875e+02 2.4621299743652344e+02 1.4327299499511719e+02 -3.0218301391601562e+02 2.4392401123046875e+02 1.4313600158691406e+02 -3.0102200317382812e+02 2.4168301391601562e+02 1.4258599853515625e+02 -2.9976699829101562e+02 2.3955899047851562e+02 1.4163699340820312e+02 -2.9845800781250000e+02 2.3761700439453125e+02 1.4032000732421875e+02 -2.9713400268554688e+02 2.3591400146484375e+02 1.3867298889160156e+02 -2.9583401489257812e+02 2.3450399780273438e+02 1.3674800109863281e+02 -2.9460000610351562e+02 2.3342800903320312e+02 1.3460198974609375e+02 -2.9346798706054688e+02 2.3272000122070312e+02 1.3230101013183594e+02 -2.9247201538085938e+02 2.3240100097656250e+02 1.2991400146484375e+02 -2.9164300537109375e+02 2.3248100280761719e+02 1.2751499938964844e+02 -2.9100601196289062e+02 2.3295700073242188e+02 1.2517599487304688e+02 -2.9058001708984375e+02 2.3381500244140625e+02 1.2296800231933594e+02 -2.9037899780273438e+02 2.3502799987792969e+02 1.2095899963378906e+02 -2.9040798950195312e+02 2.3656100463867188e+02 1.1920800018310547e+02 -2.9066699218750000e+02 2.3836599731445312e+02 1.1777099609375000e+02 -2.9114700317382812e+02 2.4038900756835938e+02 1.2577299499511719e+02 -3.0310299682617188e+02 2.5683901977539062e+02 1.2674400329589844e+02 -3.0352301025390625e+02 2.5697299194335938e+02 1.3691299438476562e+02 -3.0537399291992188e+02 2.5324401855468750e+02 1.3829800415039062e+02 -3.0516897583007812e+02 2.5181498718261719e+02 1.3659500122070312e+02 -3.0537799072265625e+02 2.5348600769042969e+02 1.3511100769042969e+02 -3.0540002441406250e+02 2.5461799621582031e+02 1.3464599609375000e+02 -3.0535699462890625e+02 2.5487300109863281e+02 1.3313099670410156e+02 -3.0521899414062500e+02 2.5570600891113281e+02 1.3251499938964844e+02 -3.0510699462890625e+02 2.5593200683593750e+02 1.3103399658203125e+02 -3.0483801269531250e+02 2.5647500610351562e+02 1.3027600097656250e+02 -3.0463598632812500e+02 2.5662600708007812e+02 1.2888301086425781e+02 -3.0426699829101562e+02 2.5690200805664062e+02 1.2800300598144531e+02 -3.0396099853515625e+02 2.5693099975585938e+02 1.2468099975585938e+02 -3.0263098144531250e+02 2.5668698120117188e+02 1.2366200256347656e+02 -3.0209298706054688e+02 2.5635098266601562e+02 1.2275700378417969e+02 -3.0161499023437500e+02 2.5605200195312500e+02 1.2174099731445312e+02 -3.0096398925781250e+02 2.5548500061035156e+02 1.2103099822998047e+02 -3.0050799560546875e+02 2.5508799743652344e+02 1.2007500457763672e+02 -2.9975500488281250e+02 2.5426998901367188e+02 1.1955499267578125e+02 -2.9934399414062500e+02 2.5382398986816406e+02 1.1872100067138672e+02 -2.9850500488281250e+02 2.5274598693847656e+02 1.1837300109863281e+02 -2.9815600585937500e+02 2.5229701232910156e+02 1.1772299957275391e+02 -2.9725799560546875e+02 2.5096499633789062e+02 1.1752300262451172e+02 -2.9698199462890625e+02 2.5055500793457031e+02 1.1711599731445312e+02 -2.9605599975585938e+02 2.4898699951171875e+02 1.1702899932861328e+02 -2.9585800170898438e+02 2.4865100097656250e+02 1.1692099761962891e+02 -2.9493902587890625e+02 2.4687799072265625e+02 1.1690699768066406e+02 -2.9481597900390625e+02 2.4664199829101562e+02 1.1714500427246094e+02 -2.9394400024414062e+02 2.4470999145507812e+02 1.1716000366210938e+02 -2.9389001464843750e+02 2.4458999633789062e+02 1.1778099822998047e+02 -2.9310699462890625e+02 2.4255599975585938e+02 1.1875099945068359e+02 -2.9249099731445312e+02 2.4060299682617188e+02 1.1882600402832031e+02 -2.9246499633789062e+02 2.4049600219726562e+02 1.2004000091552734e+02 -2.9205999755859375e+02 2.3879000854492188e+02 1.2022399902343750e+02 -2.9203298950195312e+02 2.3860000610351562e+02 1.2160900115966797e+02 -2.9182800292968750e+02 2.3717098999023438e+02 1.2192700195312500e+02 -2.9182299804687500e+02 2.3692900085449219e+02 1.2341100311279297e+02 -2.9180200195312500e+02 2.3579699707031250e+02 1.2387599945068359e+02 -2.9184402465820312e+02 2.3554199218750000e+02 1.2538999176025391e+02 -2.9198199462890625e+02 2.3470899963378906e+02 1.2600700378417969e+02 -2.9209500122070312e+02 2.3448300170898438e+02 1.2748700714111328e+02 -2.9236401367187500e+02 2.3394000244140625e+02 1.2824598693847656e+02 -2.9256600952148438e+02 2.3378900146484375e+02 1.2963800048828125e+02 -2.9293502807617188e+02 2.3351300048828125e+02 1.3177799987792969e+02 -2.9367797851562500e+02 2.3344198608398438e+02 1.3051899719238281e+02 -2.9324099731445312e+02 2.3348399353027344e+02 1.3485899353027344e+02 -2.9510900878906250e+02 2.3406399536132812e+02 1.3384098815917969e+02 -2.9457101440429688e+02 2.3372801208496094e+02 1.3274900817871094e+02 -2.9409899902343750e+02 2.3357600402832031e+02 1.3677999877929688e+02 -2.9623800659179688e+02 2.3492999267578125e+02 1.3576499938964844e+02 -2.9558599853515625e+02 2.3436300659179688e+02 1.3844599914550781e+02 -2.9744699096679688e+02 2.3614500427246094e+02 1.3749099731445312e+02 -2.9669299316406250e+02 2.3532701110839844e+02 1.3980099487304688e+02 -2.9869699096679688e+02 2.3766900634765625e+02 1.3896701049804688e+02 -2.9785800170898438e+02 2.3659100341796875e+02 1.4079899597167969e+02 -2.9994299316406250e+02 2.3944999694824219e+02 1.4014799499511719e+02 -2.9904498291015625e+02 2.3811799621582031e+02 1.4140600585937500e+02 -3.0114599609375000e+02 2.4142800903320312e+02 1.4099900817871094e+02 -3.0021899414062500e+02 2.3986000061035156e+02 1.4159999084472656e+02 -3.0226300048828125e+02 2.4353698730468750e+02 1.4149299621582031e+02 -3.0134399414062500e+02 2.4176399230957031e+02 1.4137600708007812e+02 -3.0325698852539062e+02 2.4570498657226562e+02 1.4161500549316406e+02 -3.0238500976562500e+02 2.4377299499511719e+02 1.3848200988769531e+02 -3.0514199829101562e+02 2.5162500000000000e+02 1.3969500732421875e+02 -3.0473599243164062e+02 2.4991899108886719e+02 1.3977099609375000e+02 -3.0471102905273438e+02 2.4981201171875000e+02 1.4074101257324219e+02 -3.0409500122070312e+02 2.4785900878906250e+02 1.4136199951171875e+02 -3.0331201171875000e+02 2.4582499694824219e+02 1.1627799987792969e+02 -2.9723699951171875e+02 2.4050599670410156e+02 1.1563199615478516e+02 -2.9807098388671875e+02 2.4266099548339844e+02 1.1539799499511719e+02 -2.9906399536132812e+02 2.4483200073242188e+02 1.1558599853515625e+02 -3.0018200683593750e+02 2.4694700622558594e+02 1.1618799591064453e+02 -3.0138598632812500e+02 2.4893200683593750e+02 1.1718399810791016e+02 -3.0263598632812500e+02 2.5072100830078125e+02 1.1854100036621094e+02 -3.0388998413085938e+02 2.5225201416015625e+02 1.2021099853515625e+02 -3.0510397338867188e+02 2.5347399902343750e+02 1.2213800048828125e+02 -3.0623699951171875e+02 2.5434399414062500e+02 1.2425599670410156e+02 -3.0725100708007812e+02 2.5483300781250000e+02 1.2649400329589844e+02 -3.0811102294921875e+02 2.5492501831054688e+02 1.2877499389648438e+02 -3.0878698730468750e+02 2.5461599731445312e+02 1.3102099609375000e+02 -3.0925802612304688e+02 2.5391700744628906e+02 1.3315600585937500e+02 -3.0950601196289062e+02 2.5285101318359375e+02 1.3510699462890625e+02 -3.0952398681640625e+02 2.5145500183105469e+02 1.3680799865722656e+02 -3.0930999755859375e+02 2.4977700805664062e+02 1.3819999694824219e+02 -3.0887200927734375e+02 2.4787400817871094e+02 1.3923699951171875e+02 -3.0822500610351562e+02 2.4580900573730469e+02 1.3988299560546875e+02 -3.0739099121093750e+02 2.4365499877929688e+02 1.4011700439453125e+02 -3.0639898681640625e+02 2.4148300170898438e+02 1.3992900085449219e+02 -3.0528100585937500e+02 2.3936900329589844e+02 1.3932701110839844e+02 -3.0407699584960938e+02 2.3738299560546875e+02 1.3833000183105469e+02 -3.0282699584960938e+02 2.3559500122070312e+02 1.3697401428222656e+02 -3.0157299804687500e+02 2.3406300354003906e+02 1.3530400085449219e+02 -3.0035900878906250e+02 2.3284199523925781e+02 1.3337699890136719e+02 -2.9922598266601562e+02 2.3197200012207031e+02 1.3125898742675781e+02 -2.9821200561523438e+02 2.3148199462890625e+02 1.2902101135253906e+02 -2.9735198974609375e+02 2.3139099121093750e+02 1.2673999023437500e+02 -2.9667498779296875e+02 2.3169999694824219e+02 1.2449400329589844e+02 -2.9620501708984375e+02 2.3239900207519531e+02 1.2235900115966797e+02 -2.9595700073242188e+02 2.3346400451660156e+02 1.2040799713134766e+02 -2.9593899536132812e+02 2.3486000061035156e+02 1.1870700073242188e+02 -2.9615301513671875e+02 2.3653799438476562e+02 1.1731500244140625e+02 -2.9658999633789062e+02 2.3844200134277344e+02 1.3807299804687500e+02 -3.0822302246093750e+02 2.4665899658203125e+02 1.3688400268554688e+02 -3.0874401855468750e+02 2.4858100891113281e+02 1.3536399841308594e+02 -3.0904702758789062e+02 2.5030601501464844e+02 1.3356900024414062e+02 -3.0912200927734375e+02 2.5177299499511719e+02 1.3156401062011719e+02 -3.0896600341796875e+02 2.5292900085449219e+02 1.2942199707031250e+02 -3.0858401489257812e+02 2.5373199462890625e+02 1.2721900939941406e+02 -3.0799099731445312e+02 2.5415199279785156e+02 1.2503600311279297e+02 -3.0720800781250000e+02 2.5417599487304688e+02 1.2295199584960938e+02 -3.0626300048828125e+02 2.5380099487304688e+02 1.2104100036621094e+02 -3.0519100952148438e+02 2.5304100036621094e+02 1.1937200164794922e+02 -3.0402899169921875e+02 2.5192401123046875e+02 1.1800699615478516e+02 -3.0282101440429688e+02 2.5049000549316406e+02 1.1699400329589844e+02 -3.0160998535156250e+02 2.4879100036621094e+02 1.1637099456787109e+02 -3.0043798828125000e+02 2.4688899230957031e+02 1.1615800476074219e+02 -2.9935000610351562e+02 2.4485200500488281e+02 1.1636499786376953e+02 -2.9838400268554688e+02 2.4275300598144531e+02 1.1799199676513672e+02 -2.9695300292968750e+02 2.3867599487304688e+02 1.1935299682617188e+02 -2.9653900146484375e+02 2.3684400939941406e+02 1.2101799774169922e+02 -2.9634899902343750e+02 2.3523999023437500e+02 1.2292599487304688e+02 -2.9638998413085938e+02 2.3392300415039062e+02 1.2500900268554688e+02 -2.9666000366210938e+02 2.3293901062011719e+02 1.2719200897216797e+02 -2.9714999389648438e+02 2.3232400512695312e+02 1.2939498901367188e+02 -2.9784100341796875e+02 2.3210200500488281e+02 1.3153800964355469e+02 -2.9870901489257812e+02 2.3227799987792969e+02 1.3354499816894531e+02 -2.9972198486328125e+02 2.3284800720214844e+02 1.3534300231933594e+02 -3.0084402465820312e+02 2.3379100036621094e+02 1.3686599731445312e+02 -3.0203399658203125e+02 2.3507200622558594e+02 1.3806100463867188e+02 -3.0325000000000000e+02 2.3664500427246094e+02 1.3888299560546875e+02 -3.0444699096679688e+02 2.3845399475097656e+02 1.3930299377441406e+02 -3.0558099365234375e+02 2.4043299865722656e+02 1.3930499267578125e+02 -3.0661300659179688e+02 2.4251000976562500e+02 1.3889099121093750e+02 -3.0750399780273438e+02 2.4461099243164062e+02 1.1540299987792969e+02 -3.0191900634765625e+02 2.3851400756835938e+02 1.1478500366210938e+02 -3.0272799682617188e+02 2.4059799194335938e+02 1.1457800292968750e+02 -3.0369400024414062e+02 2.4269700622558594e+02 1.1479000091552734e+02 -3.0478201293945312e+02 2.4473400878906250e+02 1.1541400146484375e+02 -3.0595300292968750e+02 2.4663600158691406e+02 1.1642599487304688e+02 -3.0716500854492188e+02 2.4833500671386719e+02 1.1779100036621094e+02 -3.0837301635742188e+02 2.4976899719238281e+02 1.1945999908447266e+02 -3.0953402709960938e+02 2.5088598632812500e+02 1.2137100219726562e+02 -3.1060699462890625e+02 2.5164500427246094e+02 1.2345500183105469e+02 -3.1155200195312500e+02 2.5202000427246094e+02 1.2563799285888672e+02 -3.1233502197265625e+02 2.5199699401855469e+02 1.2784099578857422e+02 -3.1292797851562500e+02 2.5157699584960938e+02 1.2998298645019531e+02 -3.1330902099609375e+02 2.5077400207519531e+02 1.3198800659179688e+02 -3.1346499633789062e+02 2.4961799621582031e+02 1.3378300476074219e+02 -3.1338998413085938e+02 2.4815100097656250e+02 1.3530300903320312e+02 -3.1308697509765625e+02 2.4642500305175781e+02 1.3649299621582031e+02 -3.1256698608398438e+02 2.4450399780273438e+02 1.3730999755859375e+02 -3.1184802246093750e+02 2.4245500183105469e+02 1.3772399902343750e+02 -3.1095599365234375e+02 2.4035499572753906e+02 1.3772200012207031e+02 -3.0992498779296875e+02 2.3827799987792969e+02 1.3730200195312500e+02 -3.0879000854492188e+02 2.3629899597167969e+02 1.3648001098632812e+02 -3.0759298706054688e+02 2.3449000549316406e+02 1.3528601074218750e+02 -3.0637802124023438e+02 2.3291699218750000e+02 1.3376200866699219e+02 -3.0518698120117188e+02 2.3163500976562500e+02 1.3196400451660156e+02 -3.0406500244140625e+02 2.3069299316406250e+02 1.2995700073242188e+02 -3.0305200195312500e+02 2.3012300109863281e+02 1.2781399536132812e+02 -3.0218399047851562e+02 2.2994599914550781e+02 1.2561100769042969e+02 -3.0149298095703125e+02 2.3016899108886719e+02 1.2342900085449219e+02 -3.0100399780273438e+02 2.3078300476074219e+02 1.2134599304199219e+02 -3.0073400878906250e+02 2.3176699829101562e+02 1.1943700408935547e+02 -3.0069299316406250e+02 2.3308500671386719e+02 1.1777199554443359e+02 -3.0088299560546875e+02 2.3468800354003906e+02 1.1641100311279297e+02 -3.0129598999023438e+02 2.3652000427246094e+02 1.3648399353027344e+02 -3.0801498413085938e+02 2.3533599853515625e+02 1.3715000915527344e+02 -3.0918899536132812e+02 2.3721400451660156e+02 1.3739399719238281e+02 -3.1028198242187500e+02 2.3923799133300781e+02 1.3720799255371094e+02 -3.1125198364257812e+02 2.4133000183105469e+02 1.3659700012207031e+02 -3.1206198120117188e+02 2.4340899658203125e+02 1.3558499145507812e+02 -3.1267898559570312e+02 2.4539599609375000e+02 1.3421299743652344e+02 -3.1308200073242188e+02 2.4721400451660156e+02 1.3253100585937500e+02 -3.1325299072265625e+02 2.4879299926757812e+02 1.3060499572753906e+02 -3.1318701171875000e+02 2.5007200622558594e+02 1.2850900268554688e+02 -3.1288702392578125e+02 2.5100401306152344e+02 1.2632299804687500e+02 -3.1236199951171875e+02 2.5154998779296875e+02 1.2413199615478516e+02 -3.1163497924804688e+02 2.5169200134277344e+02 1.2201899719238281e+02 -3.1073300170898438e+02 2.5142300415039062e+02 1.2006600189208984e+02 -3.0968899536132812e+02 2.5075299072265625e+02 1.1834799957275391e+02 -3.0854602050781250e+02 2.4970799255371094e+02 1.1693099975585938e+02 -3.0734597778320312e+02 2.4832899475097656e+02 1.1586900329589844e+02 -3.0613500976562500e+02 2.4666899108886719e+02 1.1520300292968750e+02 -3.0496002197265625e+02 2.4479100036621094e+02 1.1495899963378906e+02 -3.0386700439453125e+02 2.4276701354980469e+02 1.1514600372314453e+02 -3.0289700317382812e+02 2.4067500305175781e+02 1.1575599670410156e+02 -3.0208798217773438e+02 2.3859600830078125e+02 1.1676800537109375e+02 -3.0147000122070312e+02 2.3660899353027344e+02 1.1814100646972656e+02 -3.0106799316406250e+02 2.3479100036621094e+02 1.1982200622558594e+02 -3.0089599609375000e+02 2.3321199035644531e+02 1.2174800109863281e+02 -3.0096200561523438e+02 2.3193299865722656e+02 1.2384399414062500e+02 -3.0126300048828125e+02 2.3100100708007812e+02 1.2602999877929688e+02 -3.0178698730468750e+02 2.3045500183105469e+02 1.2822100830078125e+02 -3.0251501464843750e+02 2.3031300354003906e+02 1.3033399963378906e+02 -3.0341699218750000e+02 2.3058200073242188e+02 1.3228700256347656e+02 -3.0445999145507812e+02 2.3125199890136719e+02 1.3400498962402344e+02 -3.0560400390625000e+02 2.3229699707031250e+02 1.3542201232910156e+02 -3.0680401611328125e+02 2.3367599487304688e+02 1.1473400115966797e+02 -3.0489797973632812e+02 2.3720100402832031e+02 1.1412300109863281e+02 -3.0570797729492188e+02 2.3927999877929688e+02 1.1393599700927734e+02 -3.0667800903320312e+02 2.4137200927734375e+02 1.1418000030517578e+02 -3.0777099609375000e+02 2.4339599609375000e+02 1.1484600067138672e+02 -3.0894500732421875e+02 2.4527400207519531e+02 1.1590799713134766e+02 -3.1015597534179688e+02 2.4693499755859375e+02 1.1732499694824219e+02 -3.1135601806640625e+02 2.4831399536132812e+02 1.1904399871826172e+02 -3.1250000000000000e+02 2.4935800170898438e+02 1.2099600219726562e+02 -3.1354299926757812e+02 2.5002801513671875e+02 1.2310900115966797e+02 -3.1444601440429688e+02 2.5029701232910156e+02 1.2530100250244141e+02 -3.1517300415039062e+02 2.5015599060058594e+02 1.2748600769042969e+02 -3.1569702148437500e+02 2.4960899353027344e+02 1.2958200073242188e+02 -3.1599798583984375e+02 2.4867799377441406e+02 1.3150799560546875e+02 -3.1606399536132812e+02 2.4739801025390625e+02 1.3319000244140625e+02 -3.1589199829101562e+02 2.4581900024414062e+02 1.3456300354003906e+02 -3.1549002075195312e+02 2.4400100708007812e+02 1.3557400512695312e+02 -3.1487200927734375e+02 2.4201499938964844e+02 1.3618501281738281e+02 -3.1406301879882812e+02 2.3993499755859375e+02 1.3637199401855469e+02 -3.1309301757812500e+02 2.3784400939941406e+02 1.3612699890136719e+02 -3.1200000000000000e+02 2.3581999206542969e+02 1.3546099853515625e+02 -3.1082498168945312e+02 2.3394100952148438e+02 1.3439900207519531e+02 -3.0961499023437500e+02 2.3228100585937500e+02 1.3298199462890625e+02 -3.0841400146484375e+02 2.3090200805664062e+02 1.3126400756835938e+02 -3.0727099609375000e+02 2.2985699462890625e+02 1.2931098937988281e+02 -3.0622799682617188e+02 2.2918798828125000e+02 1.2719799804687500e+02 -3.0532501220703125e+02 2.2891799926757812e+02 1.2500700378417969e+02 -3.0459799194335938e+02 2.2905999755859375e+02 1.2282100677490234e+02 -3.0407299804687500e+02 2.2960699462890625e+02 1.2072499847412109e+02 -3.0377297973632812e+02 2.3053799438476562e+02 1.1879900360107422e+02 -3.0370700073242188e+02 2.3181800842285156e+02 1.1711800384521484e+02 -3.0387802124023438e+02 2.3339700317382812e+02 1.1574500274658203e+02 -3.0428100585937500e+02 2.3521499633789062e+02 1.2865499877929688e+02 -3.0536599731445312e+02 2.2793200683593750e+02 1.2641699981689453e+02 -3.0450601196289062e+02 2.2784100341796875e+02 1.2413700103759766e+02 -3.0382901000976562e+02 2.2814999389648438e+02 1.2188999938964844e+02 -3.0335900878906250e+02 2.2884899902343750e+02 1.1975599670410156e+02 -3.0311001586914062e+02 2.2991499328613281e+02 1.1780400085449219e+02 -3.0309298706054688e+02 2.3130999755859375e+02 1.1610399627685547e+02 -3.0330700683593750e+02 2.3298800659179688e+02 1.1471099853515625e+02 -3.0374398803710938e+02 2.3489199829101562e+02 1.1367400360107422e+02 -3.0439099121093750e+02 2.3695599365234375e+02 1.1302799987792969e+02 -3.0522500610351562e+02 2.3911100769042969e+02 1.1279500579833984e+02 -3.0621798706054688e+02 2.4128199768066406e+02 1.1298199462890625e+02 -3.0733599853515625e+02 2.4339700317382812e+02 1.1358499908447266e+02 -3.0853997802734375e+02 2.4538198852539062e+02 1.1458099365234375e+02 -3.0978997802734375e+02 2.4717100524902344e+02 1.1593700408935547e+02 -3.1104400634765625e+02 2.4870201110839844e+02 1.1760699462890625e+02 -3.1225799560546875e+02 2.4992401123046875e+02 1.1953400421142578e+02 -3.1339099121093750e+02 2.5079399108886719e+02 1.2165200042724609e+02 -3.1440499877929688e+02 2.5128298950195312e+02 1.2388999938964844e+02 -3.1526501464843750e+02 2.5137498474121094e+02 1.2617098999023438e+02 -3.1594100952148438e+02 2.5106599426269531e+02 1.2841700744628906e+02 -3.1641198730468750e+02 2.5036698913574219e+02 1.3055198669433594e+02 -3.1665997314453125e+02 2.4930099487304688e+02 1.3250300598144531e+02 -3.1667797851562500e+02 2.4790499877929688e+02 1.3420399475097656e+02 -3.1646401977539062e+02 2.4622698974609375e+02 1.3559600830078125e+02 -3.1602600097656250e+02 2.4432400512695312e+02 1.3663299560546875e+02 -3.1537899780273438e+02 2.4225900268554688e+02 1.3727999877929688e+02 -3.1454501342773438e+02 2.4010499572753906e+02 1.3751300048828125e+02 -3.1355300903320312e+02 2.3793299865722656e+02 1.3732499694824219e+02 -3.1243499755859375e+02 2.3581900024414062e+02 1.3672299194335938e+02 -3.1123098754882812e+02 2.3383299255371094e+02 1.3572700500488281e+02 -3.0998001098632812e+02 2.3204499816894531e+02 1.3436999511718750e+02 -3.0872698974609375e+02 2.3051300048828125e+02 1.3269999694824219e+02 -3.0751300048828125e+02 2.2929200744628906e+02 1.3077299499511719e+02 -3.0638000488281250e+02 2.2842199707031250e+02 1.1342600250244141e+02 -3.0507299804687500e+02 2.3661799621582031e+02 1.1277999877929688e+02 -3.0590701293945312e+02 2.3877301025390625e+02 1.1254700469970703e+02 -3.0689901733398438e+02 2.4094400024414062e+02 1.1273400115966797e+02 -3.0801699829101562e+02 2.4305899047851562e+02 1.1333700561523438e+02 -3.0922100830078125e+02 2.4504399108886719e+02 1.1433299255371094e+02 -3.1047100830078125e+02 2.4683299255371094e+02 1.1568900299072266e+02 -3.1172497558593750e+02 2.4836399841308594e+02 1.1735900115966797e+02 -3.1293899536132812e+02 2.4958599853515625e+02 1.1928600311279297e+02 -3.1407202148437500e+02 2.5045600891113281e+02 1.2140499877929688e+02 -3.1508599853515625e+02 2.5094500732421875e+02 1.2364199829101562e+02 -3.1594601440429688e+02 2.5103700256347656e+02 1.2592299652099609e+02 -3.1662301635742188e+02 2.5072801208496094e+02 1.2816900634765625e+02 -3.1709301757812500e+02 2.5002899169921875e+02 1.3030400085449219e+02 -3.1734100341796875e+02 2.4896299743652344e+02 1.3225500488281250e+02 -3.1735900878906250e+02 2.4756700134277344e+02 1.3395599365234375e+02 -3.1714498901367188e+02 2.4588899230957031e+02 1.3534800720214844e+02 -3.1670800781250000e+02 2.4398500061035156e+02 1.3638499450683594e+02 -3.1606100463867188e+02 2.4192098999023438e+02 1.3703199768066406e+02 -3.1522698974609375e+02 2.3976699829101562e+02 1.3726499938964844e+02 -3.1423397827148438e+02 2.3759500122070312e+02 1.3707701110839844e+02 -3.1311602783203125e+02 2.3548098754882812e+02 1.3647499084472656e+02 -3.1191198730468750e+02 2.3349499511718750e+02 1.3547900390625000e+02 -3.1066198730468750e+02 2.3170700073242188e+02 1.3412199401855469e+02 -3.0940802001953125e+02 2.3017500305175781e+02 1.3245199584960938e+02 -3.0819400024414062e+02 2.2895399475097656e+02 1.3052499389648438e+02 -3.0706097412109375e+02 2.2808399963378906e+02 1.2840699768066406e+02 -3.0604699707031250e+02 2.2759400939941406e+02 1.2616899871826172e+02 -3.0518698120117188e+02 2.2750300598144531e+02 1.2388899993896484e+02 -3.0451000976562500e+02 2.2781201171875000e+02 1.2164199829101562e+02 -3.0404000854492188e+02 2.2851100158691406e+02 1.1950799560546875e+02 -3.0379199218750000e+02 2.2957600402832031e+02 1.1755599975585938e+02 -3.0377398681640625e+02 2.3097200012207031e+02 1.1585600280761719e+02 -3.0398800659179688e+02 2.3264999389648438e+02 1.1446300506591797e+02 -3.0442602539062500e+02 2.3455398559570312e+02 1.3424099731445312e+02 -2.9503698730468750e+02 2.5744302368164062e+02 1.3611199951171875e+02 -2.9528900146484375e+02 2.5657901000976562e+02 1.4076399230957031e+02 -2.9119598388671875e+02 2.4491999816894531e+02 1.2675599670410156e+02 -2.9207901000976562e+02 2.5697299194335938e+02 1.2844699096679688e+02 -2.9304901123046875e+02 2.5768701171875000e+02 1.3780300903320312e+02 -2.9530798339843750e+02 2.5537600708007812e+02 1.4139700317382812e+02 -2.9319198608398438e+02 2.4847698974609375e+02 1.4129100036621094e+02 -2.9223901367187500e+02 2.4663500976562500e+02 1.3923699951171875e+02 -2.9509197998046875e+02 2.5389001464843750e+02 1.4034500122070312e+02 -2.9465197753906250e+02 2.5219100952148438e+02 1.4107600402832031e+02 -2.9400900268554688e+02 2.5035798645019531e+02 1.3984001159667969e+02 -2.9011099243164062e+02 2.4341000366210938e+02 1.3856300354003906e+02 -2.8903500366210938e+02 2.4217700195312500e+02 1.2421700286865234e+02 -2.8993899536132812e+02 2.5452200317382812e+02 1.3699198913574219e+02 -2.8801699829101562e+02 2.4127900695800781e+02 1.3520100402832031e+02 -2.8710601806640625e+02 2.4075700378417969e+02 1.2532399749755859e+02 -2.9102600097656250e+02 2.5590101623535156e+02 1.3031700134277344e+02 -2.9389001464843750e+02 2.5801000976562500e+02 1.3227899169921875e+02 -2.9456298828125000e+02 2.5792800903320312e+02 1.3327400207519531e+02 -2.8634500122070312e+02 2.4063600158691406e+02 1.3130000305175781e+02 -2.8576800537109375e+02 2.4092100524902344e+02 1.2937300109863281e+02 -2.8540301513671875e+02 2.4159899902343750e+02 1.2473099517822266e+02 -2.8569497680664062e+02 2.4559300231933594e+02 1.2380599975585938e+02 -2.8624002075195312e+02 2.4737001037597656e+02 1.2327700042724609e+02 -2.8697500610351562e+02 2.4923800659179688e+02 1.2316899871826172e+02 -2.8786502075195312e+02 2.5111100769042969e+02 1.2348799896240234e+02 -2.8886801147460938e+02 2.5290000915527344e+02 1.2758100128173828e+02 -2.8526699829101562e+02 2.4263900756835938e+02 1.2600900268554688e+02 -2.8536599731445312e+02 2.4399099731445312e+02 1.2374199676513672e+02 -2.8569702148437500e+02 2.4987199401855469e+02 1.2427099609375000e+02 -2.8496301269531250e+02 2.4800399780273438e+02 1.2519599151611328e+02 -2.8441799926757812e+02 2.4622698974609375e+02 1.2647399139404297e+02 -2.8408798217773438e+02 2.4462500000000000e+02 1.2804600524902344e+02 -2.8398901367187500e+02 2.4327301025390625e+02 1.2983799743652344e+02 -2.8412500000000000e+02 2.4223298645019531e+02 1.3176499938964844e+02 -2.8448999023437500e+02 2.4155500793457031e+02 1.3373899841308594e+02 -2.8506698608398438e+02 2.4127000427246094e+02 1.3566600036621094e+02 -2.8582901000976562e+02 2.4139100646972656e+02 1.3745700073242188e+02 -2.8673999023437500e+02 2.4191300964355469e+02 1.3902799987792969e+02 -2.8775701904296875e+02 2.4281098937988281e+02 1.4030499267578125e+02 -2.8883401489257812e+02 2.4404400634765625e+02 1.4122900390625000e+02 -2.8991897583007812e+02 2.4555400085449219e+02 1.4175599670410156e+02 -2.9096200561523438e+02 2.4726899719238281e+02 1.4186199951171875e+02 -2.9191400146484375e+02 2.4911099243164062e+02 1.4154100036621094e+02 -2.9273098754882812e+02 2.5099200439453125e+02 1.4080999755859375e+02 -2.9337500000000000e+02 2.5282499694824219e+02 1.3970201110839844e+02 -2.9381497192382812e+02 2.5452398681640625e+02 1.3826799011230469e+02 -2.9402999877929688e+02 2.5601000976562500e+02 1.3657699584960938e+02 -2.9401202392578125e+02 2.5721298217773438e+02 1.3470600891113281e+02 -2.9376000976562500e+02 2.5807699584960938e+02 1.3274400329589844e+02 -2.9328601074218750e+02 2.5856201171875000e+02 1.3078199768066406e+02 -2.9261300659179688e+02 2.5864401245117188e+02 1.2891200256347656e+02 -2.9177200317382812e+02 2.5832098388671875e+02 1.2722100067138672e+02 -2.9080200195312500e+02 2.5760598754882812e+02 1.2578900146484375e+02 -2.8974899291992188e+02 2.5653500366210938e+02 1.2468199920654297e+02 -2.8866101074218750e+02 2.5515499877929688e+02 1.2395300292968750e+02 -2.8759100341796875e+02 2.5353300476074219e+02 1.2363400268554688e+02 -2.8658700561523438e+02 2.5174400329589844e+02 1.4317601013183594e+02 -2.9243499755859375e+02 2.4919499206542969e+02 1.2937001037597656e+02 -2.9266101074218750e+02 2.5977700805664062e+02 1.3143099975585938e+02 -2.9348599243164062e+02 2.5992797851562500e+02 1.3354699707031250e+02 -2.9412799072265625e+02 2.5967098999023438e+02 1.3562899780273438e+02 -2.9456201171875000e+02 2.5901699829101562e+02 1.3759399414062500e+02 -2.9476800537109375e+02 2.5799099731445312e+02 1.3936000061035156e+02 -2.9473901367187500e+02 2.5663800048828125e+02 1.4085600280761719e+02 -2.9447601318359375e+02 2.5501000976562500e+02 1.4202000427246094e+02 -2.9398999023437500e+02 2.5317698669433594e+02 1.4280400085449219e+02 -2.9329998779296875e+02 2.5121098327636719e+02 1.4312200927734375e+02 -2.9142999267578125e+02 2.4720899963378906e+02 1.4264300537109375e+02 -2.9032598876953125e+02 2.4533699035644531e+02 1.4175799560546875e+02 -2.8916900634765625e+02 2.4365399169921875e+02 1.4050500488281250e+02 -2.8800601196289062e+02 2.4222900390625000e+02 1.3893400573730469e+02 -2.8688400268554688e+02 2.4112098693847656e+02 1.3711000061035156e+02 -2.8584997558593750e+02 2.4037399291992188e+02 1.3510800170898438e+02 -2.8494500732421875e+02 2.4002101135253906e+02 1.3300900268554688e+02 -2.8420800781250000e+02 2.4007398986816406e+02 1.3089900207519531e+02 -2.8366699218750000e+02 2.4053199768066406e+02 1.2886500549316406e+02 -2.8334600830078125e+02 2.4137599182128906e+02 1.2698900604248047e+02 -2.8325598144531250e+02 2.4257099914550781e+02 1.2534999847412109e+02 -2.8340301513671875e+02 2.4406999206542969e+02 1.2401300048828125e+02 -2.8377999877929688e+02 2.4580900573730469e+02 1.2303399658203125e+02 -2.8437100219726562e+02 2.4771800231933594e+02 1.2245299530029297e+02 -2.8515301513671875e+02 2.4972000122070312e+02 1.2229299926757812e+02 -2.8609201049804688e+02 2.5173100280761719e+02 1.2256199645996094e+02 -2.8715197753906250e+02 2.5367001342773438e+02 1.2324699401855469e+02 -2.8828799438476562e+02 2.5545701599121094e+02 1.2432099914550781e+02 -2.8945401000976562e+02 2.5701901245117188e+02 1.2574000549316406e+02 -2.9060299682617188e+02 2.5829199218750000e+02 1.2744699096679688e+02 -2.9168600463867188e+02 2.5922399902343750e+02 1.4026199340820312e+02 -3.0028302001953125e+02 2.4774600219726562e+02 1.3947799682617188e+02 -3.0097299194335938e+02 2.4971101379394531e+02 1.4083700561523438e+02 -3.0037298583984375e+02 2.4750498962402344e+02 1.4142900085449219e+02 -3.0075201416015625e+02 2.4783599853515625e+02 1.3977999877929688e+02 -3.0130300903320312e+02 2.5015399169921875e+02 1.4051300048828125e+02 -3.0155798339843750e+02 2.5013000488281250e+02 1.4119100952148438e+02 -3.0161999511718750e+02 2.4975700378417969e+02 1.4163301086425781e+02 -3.0147201538085938e+02 2.4913600158691406e+02 1.4172000122070312e+02 -3.0115499877929688e+02 2.4843199157714844e+02 1.2652300262451172e+02 -2.8636801147460938e+02 2.4563500976562500e+02 1.2389399719238281e+02 -2.8628201293945312e+02 2.4738999938964844e+02 1.2450099945068359e+02 -2.8588101196289062e+02 2.4613699340820312e+02 1.2733200073242188e+02 -2.8531900024414062e+02 2.4292799377441406e+02 1.2758000183105469e+02 -2.8543798828125000e+02 2.4298599243164062e+02 1.2623999786376953e+02 -2.8539401245117188e+02 2.4387899780273438e+02 1.2528899383544922e+02 -2.8558297729492188e+02 2.4495700073242188e+02 1.3723400878906250e+02 -2.9527499389648438e+02 2.5572801208496094e+02 1.3698600769042969e+02 -2.9515600585937500e+02 2.5567001342773438e+02 1.3832600402832031e+02 -2.9520098876953125e+02 2.5477700805664062e+02 1.3804299926757812e+02 -2.9422598266601562e+02 2.5302099609375000e+02 1.3927699279785156e+02 -2.9501199340820312e+02 2.5369900512695312e+02 1.4006500244140625e+02 -2.9471298217773438e+02 2.5251901245117188e+02 1.2799899291992188e+02 -2.9219699096679688e+02 2.5629898071289062e+02 1.2697399902343750e+02 -2.9153601074218750e+02 2.5571798706054688e+02 1.2995700073242188e+02 -2.9198397827148438e+02 2.5443299865722656e+02 1.4007400512695312e+02 -2.9043600463867188e+02 2.4389399719238281e+02 1.4067700195312500e+02 -2.9118899536132812e+02 2.4496899414062500e+02 1.3923899841308594e+02 -2.9245401000976562e+02 2.4857200622558594e+02 1.4082600402832031e+02 -2.9177798461914062e+02 2.4604499816894531e+02 1.4107400512695312e+02 -2.9189599609375000e+02 2.4610200500488281e+02 1.3976899719238281e+02 -2.9270700073242188e+02 2.4869400024414062e+02 1.4128700256347656e+02 -2.9259500122070312e+02 2.4735499572753906e+02 1.4128999328613281e+02 -2.9324099731445312e+02 2.4865299987792969e+02 1.4108399963378906e+02 -2.9381701660156250e+02 2.4996699523925781e+02 1.4067199707031250e+02 -2.9431201171875000e+02 2.5126600646972656e+02 1.3613099670410156e+02 -2.8760000610351562e+02 2.4107099914550781e+02 1.3712899780273438e+02 -2.8814898681640625e+02 2.4144400024414062e+02 1.3656300354003906e+02 -2.8839498901367188e+02 2.4235501098632812e+02 1.3044000244140625e+02 -2.8562500000000000e+02 2.4126400756835938e+02 1.3145700073242188e+02 -2.8585101318359375e+02 2.4097399902343750e+02 1.3155200195312500e+02 -2.8636599731445312e+02 2.4194100952148438e+02 1.2327600097656250e+02 -2.8735400390625000e+02 2.5000300598144531e+02 1.2348199462890625e+02 -2.8677697753906250e+02 2.4868899536132812e+02 1.2479700469970703e+02 -2.8788699340820312e+02 2.4996200561523438e+02 1.2532700347900391e+02 -2.8814102172851562e+02 2.5008401489257812e+02 1.2608599853515625e+02 -2.9084301757812500e+02 2.5497201538085938e+02 1.2527600097656250e+02 -2.9091500854492188e+02 2.5571298217773438e+02 1.2449300384521484e+02 -2.9015899658203125e+02 2.5476300048828125e+02 1.3358700561523438e+02 -2.8951000976562500e+02 2.4678399658203125e+02 1.3460899353027344e+02 -2.8861099243164062e+02 2.4422299194335938e+02 1.3751300048828125e+02 -2.9397299194335938e+02 2.5289898681640625e+02 1.3266600036621094e+02 -2.8668002319335938e+02 2.4175700378417969e+02 1.2374000549316406e+02 -2.8881698608398438e+02 2.5261100769042969e+02 1.2349200439453125e+02 -2.8869799804687500e+02 2.5255400085449219e+02 1.2327899932861328e+02 -2.8799899291992188e+02 2.5130099487304688e+02 1.3412599182128906e+02 -2.9497000122070312e+02 2.5739199829101562e+02 1.3311000061035156e+02 -2.9474401855468750e+02 2.5768200683593750e+02 1.3301399230957031e+02 -2.9422900390625000e+02 2.5671499633789062e+02 1.3097900390625000e+02 -2.9108499145507812e+02 2.5187200927734375e+02 1.2388899993896484e+02 -2.8940499877929688e+02 2.5368699645996094e+02 1.2743299865722656e+02 -2.9244299316406250e+02 2.5720999145507812e+02 1.2843200683593750e+02 -2.9299200439453125e+02 2.5758401489257812e+02 1.2949299621582031e+02 -2.9349899291992188e+02 2.5782598876953125e+02 1.3059799194335938e+02 -2.9395401000976562e+02 2.5793298339843750e+02 1.3507099914550781e+02 -2.8709500122070312e+02 2.4083000183105469e+02 1.3377299499511719e+02 -2.8706399536132812e+02 2.4172000122070312e+02 1.3396800231933594e+02 -2.8664099121093750e+02 2.4072299194335938e+02 1.3150900268554688e+02 -2.9133798217773438e+02 2.5199401855468750e+02 1.3305699157714844e+02 -2.8925601196289062e+02 2.4666200256347656e+02 1.3407899475097656e+02 -2.8835699462890625e+02 2.4410099792480469e+02 1.3929200744628906e+02 -2.8967999267578125e+02 2.4294400024414062e+02 1.3848200988769531e+02 -2.8975299072265625e+02 2.4368501281738281e+02 1.3759100341796875e+02 -2.8905801391601562e+02 2.4293699645996094e+02 1.2705299377441406e+02 -2.8662197875976562e+02 2.4575700378417969e+02 1.2849099731445312e+02 -2.8535699462890625e+02 2.4215400695800781e+02 1.2944699096679688e+02 -2.8545999145507812e+02 2.4166000366210938e+02 1.3607600402832031e+02 -2.9523699951171875e+02 2.5650201416015625e+02 1.3511900329589844e+02 -2.9513497924804688e+02 2.5699600219726562e+02 1.3048699951171875e+02 -2.9223699951171875e+02 2.5455499267578125e+02 1.3189999389648438e+02 -2.9391500854492188e+02 2.5689898681640625e+02 1.3079299926757812e+02 -2.9353100585937500e+02 2.5693600463867188e+02 1.2495800018310547e+02 -2.8888101196289062e+02 2.5539698791503906e+02 1.2545099639892578e+02 -2.8937701416015625e+02 2.5603399658203125e+02 1.2663100433349609e+02 -2.8927099609375000e+02 2.5495498657226562e+02 1.3886700439453125e+02 -2.8876998901367188e+02 2.4497100830078125e+02 1.3144400024414062e+02 -2.8980700683593750e+02 2.5250598144531250e+02 1.3197399902343750e+02 -2.9006100463867188e+02 2.5262800598144531e+02 1.4113700866699219e+02 -2.9303500366210938e+02 2.5189999389648438e+02 1.4154901123046875e+02 -2.9254000854492188e+02 2.5060099792480469e+02 1.4023399353027344e+02 -2.9142999267578125e+02 2.4932800292968750e+02 1.3970401000976562e+02 -2.9117599487304688e+02 2.4920600891113281e+02 1.4114199829101562e+02 -2.8991198730468750e+02 2.4560299682617188e+02 1.4053900146484375e+02 -2.8915899658203125e+02 2.4452799987792969e+02 1.4004699707031250e+02 -2.8866400146484375e+02 2.4389100646972656e+02 1.3263299560546875e+02 -2.9249700927734375e+02 2.5705401611328125e+02 1.3390699768066406e+02 -2.9282800292968750e+02 2.5678598022460938e+02 1.3797799682617188e+02 -2.9269497680664062e+02 2.5353300476074219e+02 1.3850801086425781e+02 -2.9294900512695312e+02 2.5365498352050781e+02 1.3745098876953125e+02 -2.9387899780273438e+02 2.5630398559570312e+02 1.3769898986816406e+02 -2.9399801635742188e+02 2.5636199951171875e+02 1.2395700073242188e+02 -2.8742098999023438e+02 2.5318801879882812e+02 1.2420500183105469e+02 -2.8753997802734375e+02 2.5324499511718750e+02 1.2374400329589844e+02 -2.8672201538085938e+02 2.5193499755859375e+02 1.2526200866699219e+02 -2.8661001586914062e+02 2.5059599304199219e+02 1.2804499816894531e+02 -2.8416101074218750e+02 2.4361999511718750e+02 1.2779698944091797e+02 -2.8404199218750000e+02 2.4356199645996094e+02 1.2698799133300781e+02 -2.8509100341796875e+02 2.4626899719238281e+02 1.2670500946044922e+02 -2.8411599731445312e+02 2.4451300048828125e+02 1.2575399780273438e+02 -2.8430499267578125e+02 2.4559100341796875e+02 1.2496600341796875e+02 -2.8460400390625000e+02 2.4676998901367188e+02 1.2435899353027344e+02 -2.8500500488281250e+02 2.4802400207519531e+02 1.3095199584960938e+02 -2.9096002197265625e+02 2.5518899536132812e+02 1.3134700012207031e+02 -2.9206100463867188e+02 2.5711700439453125e+02 1.2394699859619141e+02 -2.8550000000000000e+02 2.4932299804687500e+02 1.2374099731445312e+02 -2.8607699584960938e+02 2.5063699340820312e+02 1.2579199981689453e+02 -2.8686300659179688e+02 2.5071800231933594e+02 1.2751799774169922e+02 -2.8534399414062500e+02 2.4639099121093750e+02 1.4153900146484375e+02 -2.9061898803710938e+02 2.4673600769042969e+02 1.4129100036621094e+02 -2.9050000000000000e+02 2.4667898559570312e+02 1.4175199890136719e+02 -2.9131799316406250e+02 2.4798800659179688e+02 1.4175500488281250e+02 -2.9196301269531250e+02 2.4928698730468750e+02 1.3879100036621094e+02 -2.9392300415039062e+02 2.5541099548339844e+02 1.3974200439453125e+02 -2.9373400878906250e+02 2.5433299255371094e+02 1.4052999877929688e+02 -2.9343600463867188e+02 2.5315299987792969e+02 1.2435399627685547e+02 -2.8812799072265625e+02 2.5432101440429688e+02 1.3654100036621094e+02 -2.9395999145507812e+02 2.5713598632812500e+02 1.3558399963378906e+02 -2.9385699462890625e+02 2.5763000488281250e+02 1.3459100341796875e+02 -2.9369198608398438e+02 2.5802600097656250e+02 1.3404699707031250e+02 -2.9357800292968750e+02 2.5819500732421875e+02 1.2872099304199219e+02 -2.9080798339843750e+02 2.5651898193359375e+02 1.2789799499511719e+02 -2.9116601562500000e+02 2.5784399414062500e+02 1.3405198669433594e+02 -2.8823199462890625e+02 2.4741799926757812e+02 1.3825898742675781e+02 -2.8824401855468750e+02 2.4435499572753906e+02 1.3106300354003906e+02 -2.9267697143554688e+02 2.5856701660156250e+02 1.2995800781250000e+02 -2.9222100830078125e+02 2.5845999145507812e+02 1.2889700317382812e+02 -2.9171499633789062e+02 2.5821798706054688e+02 1.2794500732421875e+02 -2.9031698608398438e+02 2.5609899902343750e+02 1.3042199707031250e+02 -2.9070599365234375e+02 2.5506698608398438e+02 1.2723700714111328e+02 -2.8979598999023438e+02 2.5556799316406250e+02 1.3454400634765625e+02 -2.8707998657226562e+02 2.4473500061035156e+02 1.3414900207519531e+02 -2.8597900390625000e+02 2.4280599975585938e+02 1.3352200317382812e+02 -2.8797900390625000e+02 2.4729600524902344e+02 1.3286300659179688e+02 -2.8554202270507812e+02 2.4286900329589844e+02 1.3158898925781250e+02 -2.8521200561523438e+02 2.4313800048828125e+02 1.3144900512695312e+02 -2.8446200561523438e+02 2.4172900390625000e+02 1.3090499877929688e+02 -2.8434698486328125e+02 2.4189799499511719e+02 1.2991200256347656e+02 -2.8418200683593750e+02 2.4229399108886719e+02 1.3507400512695312e+02 -2.8733300781250000e+02 2.4485699462890625e+02 1.3754800415039062e+02 -2.8772100830078125e+02 2.4382400512695312e+02 1.3677099609375000e+02 -2.8722900390625000e+02 2.4340299987792969e+02 1.3759399414062500e+02 -2.8687097167968750e+02 2.4207800292968750e+02 1.2895500183105469e+02 -2.8407998657226562e+02 2.4278799438476562e+02 1.3443299865722656e+02 -2.8536297607421875e+02 2.4135699462890625e+02 1.3553599548339844e+02 -2.8581802368164062e+02 2.4146400451660156e+02 1.3659599304199219e+02 -2.8632299804687500e+02 2.4170500183105469e+02 1.2565200042724609e+02 -2.8988400268554688e+02 2.5622497558593750e+02 1.2646199798583984e+02 -2.8981097412109375e+02 2.5548400878906250e+02 1.2837399291992188e+02 -2.9116500854492188e+02 2.5681100463867188e+02 1.2755200195312500e+02 -2.9064498901367188e+02 2.5636499023437500e+02 1.2679800415039062e+02 -2.9009100341796875e+02 2.5580099487304688e+02 1.2735800170898438e+02 -2.9050201416015625e+02 2.5622000122070312e+02 1.3116900634765625e+02 -2.9249899291992188e+02 2.5744799804687500e+02 1.3338899230957031e+02 -2.9319699096679688e+02 2.5722698974609375e+02 1.3253599548339844e+02 -2.9296301269531250e+02 2.5738098144531250e+02 1.3227699279785156e+02 -2.9287500000000000e+02 2.5739398193359375e+02 1.3348500061035156e+02 -2.9371197509765625e+02 2.5819400024414062e+02 1.3966700744628906e+02 -2.8864898681640625e+02 2.4345600891113281e+02 1.3885700988769531e+02 -2.8872201538085938e+02 2.4419699096679688e+02 1.3693800354003906e+02 -2.8736300659179688e+02 2.4286698913574219e+02 1.3776300048828125e+02 -2.8788500976562500e+02 2.4331300354003906e+02 1.3851899719238281e+02 -2.8844000244140625e+02 2.4387899780273438e+02 1.3795800781250000e+02 -2.8802801513671875e+02 2.4345899963378906e+02 1.3414799499511719e+02 -2.8603198242187500e+02 2.4223199462890625e+02 1.3192799377441406e+02 -2.8533398437500000e+02 2.4245298767089844e+02 1.3278100585937500e+02 -2.8556799316406250e+02 2.4229901123046875e+02 1.3303999328613281e+02 -2.8565600585937500e+02 2.4228599548339844e+02 1.3183200073242188e+02 -2.8481900024414062e+02 2.4148599243164062e+02 1.4110499572753906e+02 -2.9000399780273438e+02 2.4581600952148438e+02 1.4063999938964844e+02 -2.9128201293945312e+02 2.4518199157714844e+02 1.4092900085449219e+02 -2.9015899658203125e+02 2.4625801086425781e+02 1.3930099487304688e+02 -2.9245999145507812e+02 2.4853800964355469e+02 1.3994200134277344e+02 -2.9102700805664062e+02 2.4873001098632812e+02 1.3976599121093750e+02 -2.9118200683593750e+02 2.4917199707031250e+02 1.4225199890136719e+02 -2.8468200683593750e+02 2.5187901306152344e+02 1.4323799133300781e+02 -2.8381402587890625e+02 2.4940599060058594e+02 1.4257398986816406e+02 -2.8471697998046875e+02 2.5040998840332031e+02 1.4170399475097656e+02 -2.8682800292968750e+02 2.4980198669433594e+02 1.4173300170898438e+02 -2.8687799072265625e+02 2.4957600402832031e+02 1.4179899597167969e+02 -2.8684600830078125e+02 2.4935301208496094e+02 1.4189399719238281e+02 -2.8673602294921875e+02 2.4916999816894531e+02 1.4200300598144531e+02 -2.8656500244140625e+02 2.4905300903320312e+02 1.4247900390625000e+02 -2.8482699584960938e+02 2.5059300231933594e+02 1.4236999511718750e+02 -2.8499798583984375e+02 2.5071000671386719e+02 1.4226399230957031e+02 -2.8520397949218750e+02 2.5074299621582031e+02 1.4265499877929688e+02 -2.8485998535156250e+02 2.4976399230957031e+02 1.4266900634765625e+02 -2.8473498535156250e+02 2.4996099853515625e+02 1.4264099121093750e+02 -2.8468399047851562e+02 2.5018798828125000e+02 1.4210900878906250e+02 -2.8635900878906250e+02 2.4901998901367188e+02 1.4219699096679688e+02 -2.8614898681640625e+02 2.4907701110839844e+02 1.4260000610351562e+02 -2.8504199218750000e+02 2.4962699890136719e+02 1.4217700195312500e+02 -2.8541400146484375e+02 2.5068598937988281e+02 1.4177400207519531e+02 -2.8652099609375000e+02 2.5013700866699219e+02 1.4171899414062500e+02 -2.8670199584960938e+02 2.4999900817871094e+02 1.4330000305175781e+02 -2.8355700683593750e+02 2.5014401245117188e+02 1.4270100402832031e+02 -2.8408398437500000e+02 2.5164500427246094e+02 1.4357099914550781e+02 -2.8368698120117188e+02 2.5020599365234375e+02 1.4297200012207031e+02 -2.8421398925781250e+02 2.5170800781250000e+02 1.4038400268554688e+02 -2.9123800659179688e+02 2.4883200073242188e+02 1.4020800781250000e+02 -2.9139300537109375e+02 2.4927400207519531e+02 1.3974299621582031e+02 -2.9267098999023438e+02 2.4863999938964844e+02 1.4244499206542969e+02 -2.8677600097656250e+02 2.4915499877929688e+02 1.4233599853515625e+02 -2.8694702148437500e+02 2.4927200317382812e+02 1.4136999511718750e+02 -2.9036999511718750e+02 2.4636000061035156e+02 1.4311100769042969e+02 -2.8494598388671875e+02 2.5006300354003906e+02 1.4309599304199219e+02 -2.8507199096679688e+02 2.4986599731445312e+02 1.4368000793457031e+02 -2.8402600097656250e+02 2.4950799560546875e+02 1.4108100891113281e+02 -2.9149301147460938e+02 2.4528401184082031e+02 1.4154598999023438e+02 -2.9021499633789062e+02 2.4591799926757812e+02 1.4270600891113281e+02 -2.8541500854492188e+02 2.5084498596191406e+02 1.4281199645996094e+02 -2.8520901489257812e+02 2.5081199645996094e+02 1.4269299316406250e+02 -2.8489398193359375e+02 2.5198098754882812e+02 1.4224099731445312e+02 -2.8705700683593750e+02 2.4945500183105469e+02 1.4217401123046875e+02 -2.8708898925781250e+02 2.4967700195312500e+02 1.4214601135253906e+02 -2.8703900146484375e+02 2.4990400695800781e+02 1.4292100524902344e+02 -2.8503799438476562e+02 2.5069499206542969e+02 1.4301599121093750e+02 -2.8492800903320312e+02 2.5051200866699219e+02 1.4308300781250000e+02 -2.8489599609375000e+02 2.5029000854492188e+02 1.4304100036621094e+02 -2.8525299072265625e+02 2.4972898864746094e+02 1.4263800048828125e+02 -2.8635998535156250e+02 2.4917900085449219e+02 1.4255101013183594e+02 -2.8657000732421875e+02 2.4912199401855469e+02 1.4216000366210938e+02 -2.8691400146484375e+02 2.5010099792480469e+02 1.4221600341796875e+02 -2.8673199462890625e+02 2.5023901367187500e+02 1.4261799621582031e+02 -2.8562500000000000e+02 2.5078800964355469e+02 1.3710699462890625e+02 -2.9412100219726562e+02 2.5704501342773438e+02 1.3664199829101562e+02 -2.9539901733398438e+02 2.5641098022460938e+02 1.3728399658203125e+02 -2.9396600341796875e+02 2.5660299682617188e+02 1.3798100280761719e+02 -2.9422100830078125e+02 2.5305500793457031e+02 1.3827000427246094e+02 -2.9309799194335938e+02 2.5413099670410156e+02 1.3844599914550781e+02 -2.9294299316406250e+02 2.5368899536132812e+02 1.3960499572753906e+02 -2.8814300537109375e+02 2.5861599731445312e+02 1.3971200561523438e+02 -2.8793698120117188e+02 2.5858300781250000e+02 1.3959300231933594e+02 -2.8762100219726562e+02 2.5975201416015625e+02 1.3934500122070312e+02 -2.8950399780273438e+02 2.5692599487304688e+02 1.3923600769042969e+02 -2.8967498779296875e+02 2.5704299926757812e+02 1.3914099121093750e+02 -2.8978500366210938e+02 2.5722598266601562e+02 1.3907400512695312e+02 -2.8981701660156250e+02 2.5744799804687500e+02 1.3904600524902344e+02 -2.8976699829101562e+02 2.5767498779296875e+02 1.4057899475097656e+02 -2.8675299072265625e+02 2.5727902221679688e+02 1.4001100158691406e+02 -2.8767401123046875e+02 2.5783398437500000e+02 1.3999600219726562e+02 -2.8779901123046875e+02 2.5763699340820312e+02 1.3982099914550781e+02 -2.8776602172851562e+02 2.5846600341796875e+02 1.3991600036621094e+02 -2.8765600585937500e+02 2.5828298950195312e+02 1.3998199462890625e+02 -2.8762298583984375e+02 2.5806100463867188e+02 1.3906001281738281e+02 -2.8964099121093750e+02 2.5787197875976562e+02 1.3911500549316406e+02 -2.8945999145507812e+02 2.5801000976562500e+02 1.3951799011230469e+02 -2.8835299682617188e+02 2.5855899047851562e+02 1.3994100952148438e+02 -2.8798101806640625e+02 2.5750000000000000e+02 1.3953800964355469e+02 -2.8908801269531250e+02 2.5694998168945312e+02 1.3945100402832031e+02 -2.8929800415039062e+02 2.5689300537109375e+02 1.3987100219726562e+02 -2.8694097900390625e+02 2.5947897338867188e+02 1.4047000122070312e+02 -2.8641400146484375e+02 2.5797702026367188e+02 1.3960101318359375e+02 -2.8681201171875000e+02 2.5941601562500000e+02 1.4019999694824219e+02 -2.8628500366210938e+02 2.5791497802734375e+02 1.3782800292968750e+02 -2.9288699340820312e+02 2.5402900695800781e+02 1.3800500488281250e+02 -2.9273199462890625e+02 2.5358700561523438e+02 1.3753999328613281e+02 -2.9400900268554688e+02 2.5295298767089844e+02 1.3620098876953125e+02 -2.9518701171875000e+02 2.5630899047851562e+02 1.3666600036621094e+02 -2.9391000366210938e+02 2.5694299316406250e+02 1.3684199523925781e+02 -2.9375500488281250e+02 2.5650097656250000e+02 1.3860400390625000e+02 -2.8955502319335938e+02 2.5757299804687500e+02 1.3863200378417969e+02 -2.8960601806640625e+02 2.5734600830078125e+02 1.3955500793457031e+02 -2.8758801269531250e+02 2.5753500366210938e+02 1.3956900024414062e+02 -2.8746301269531250e+02 2.5773199462890625e+02 1.4013800048828125e+02 -2.8654199218750000e+02 2.5717700195312500e+02 1.3915100097656250e+02 -2.8741000366210938e+02 2.5964999389648438e+02 1.3926998901367188e+02 -2.8772601318359375e+02 2.5848098754882812e+02 1.3916400146484375e+02 -2.8793200683593750e+02 2.5851397705078125e+02 1.3869898986816406e+02 -2.8957400512695312e+02 2.5712399291992188e+02 1.3879400634765625e+02 -2.8946398925781250e+02 2.5694097900390625e+02 1.3890299987792969e+02 -2.8929202270507812e+02 2.5682397460937500e+02 1.3954100036621094e+02 -2.8741198730468750e+02 2.5795901489257812e+02 1.3947399902343750e+02 -2.8744400024414062e+02 2.5818099975585938e+02 1.3937899780273438e+02 -2.8755502319335938e+02 2.5836398315429688e+02 1.3907699584960938e+02 -2.8814102172851562e+02 2.5845700073242188e+02 1.3867401123046875e+02 -2.8924899291992188e+02 2.5790798950195312e+02 1.3861900329589844e+02 -2.8942999267578125e+02 2.5776998901367188e+02 1.3900900268554688e+02 -2.8908602905273438e+02 2.5679098510742188e+02 1.3909600830078125e+02 -2.8887701416015625e+02 2.5684802246093750e+02 1.3949899291992188e+02 -2.8776898193359375e+02 2.5739801025390625e+02 1.4603300476074219e+02 -2.9585598754882812e+02 2.5163000488281250e+02 1.4573100280761719e+02 -2.9479699707031250e+02 2.4971699523925781e+02 1.4375500488281250e+02 -2.9385098266601562e+02 2.4925999450683594e+02 1.2190800476074219e+02 -2.9129202270507812e+02 2.6012701416015625e+02 1.2385799407958984e+02 -2.9222598266601562e+02 2.6057800292968750e+02 1.2552900695800781e+02 -2.9209799194335938e+02 2.5909500122070312e+02 1.3526399230957031e+02 -2.9552297973632812e+02 2.5885702514648438e+02 1.3331900024414062e+02 -2.9511599731445312e+02 2.5946301269531250e+02 1.3345600891113281e+02 -2.9681900024414062e+02 2.6279397583007812e+02 1.4296800231933594e+02 -2.8844897460937500e+02 2.3895199584960938e+02 1.4101800537109375e+02 -2.8751599121093750e+02 2.3850099182128906e+02 1.3934800720214844e+02 -2.8764401245117188e+02 2.3998400878906250e+02 1.2961199951171875e+02 -2.8421899414062500e+02 2.4022200012207031e+02 1.3155700683593750e+02 -2.8462600708007812e+02 2.3961601257324219e+02 1.3142100524902344e+02 -2.8292300415039062e+02 2.3628500366210938e+02 1.2199700164794922e+02 -2.8897198486328125e+02 2.5538600158691406e+02 1.2328199768066406e+02 -2.8978799438476562e+02 2.5608999633789062e+02 1.2241899871826172e+02 -2.8870599365234375e+02 2.5453999328613281e+02 1.3550299072265625e+02 -2.9727798461914062e+02 2.6221798706054688e+02 1.3715100097656250e+02 -2.9715200805664062e+02 2.6075500488281250e+02 1.3684600830078125e+02 -2.9607800292968750e+02 2.5881500244140625e+02 1.4287899780273438e+02 -2.9076998901367188e+02 2.4369299316406250e+02 1.4159500122070312e+02 -2.8995300292968750e+02 2.4299000549316406e+02 1.4245800781250000e+02 -2.9103601074218750e+02 2.4453898620605469e+02 1.2937399291992188e+02 -2.8246398925781250e+02 2.3686100769042969e+02 1.2772500610351562e+02 -2.8258999633789062e+02 2.3832400512695312e+02 1.2802999877929688e+02 -2.8366400146484375e+02 2.4026399230957031e+02 1.1884400177001953e+02 -2.8388500976562500e+02 2.4744898986816406e+02 1.1914499664306641e+02 -2.8494500732421875e+02 2.4936300659179688e+02 1.2112099456787109e+02 -2.8589001464843750e+02 2.4981900024414062e+02 1.2032700347900391e+02 -2.8910000610351562e+02 2.5686898803710938e+02 1.2062799835205078e+02 -2.9015899658203125e+02 2.5878302001953125e+02 1.2445600128173828e+02 -2.9087399291992188e+02 2.5741601562500000e+02 1.2590299224853516e+02 -2.9192501831054688e+02 2.5847399902343750e+02 1.2757099914550781e+02 -2.9290701293945312e+02 2.5922702026367188e+02 1.4164199829101562e+02 -2.9571099853515625e+02 2.5455900573730469e+02 1.4148199462890625e+02 -2.9518899536132812e+02 2.5362399291992188e+02 1.4076699829101562e+02 -2.9594900512695312e+02 2.5567999267578125e+02 1.4027600097656250e+02 -2.9556799316406250e+02 2.5527200317382812e+02 1.3950199890136719e+02 -2.9612298583984375e+02 2.5695800781250000e+02 1.3880300903320312e+02 -2.9575299072265625e+02 2.5672598266601562e+02 1.3807600402832031e+02 -2.9615499877929688e+02 2.5806701660156250e+02 1.3711300659179688e+02 -2.9573800659179688e+02 2.5793399047851562e+02 1.4455000305175781e+02 -2.9064199829101562e+02 2.4221000671386719e+02 1.4424900817871094e+02 -2.8958300781250000e+02 2.4029600524902344e+02 1.4041999816894531e+02 -2.8886801147460938e+02 2.4166299438476562e+02 1.3897399902343750e+02 -2.8781597900390625e+02 2.4060598754882812e+02 1.3730500793457031e+02 -2.8683502197265625e+02 2.3985198974609375e+02 1.2323500061035156e+02 -2.8403100585937500e+02 2.4452101135253906e+02 1.2339399719238281e+02 -2.8455297851562500e+02 2.4545599365234375e+02 1.2411000061035156e+02 -2.8379299926757812e+02 2.4339999389648438e+02 1.2460099792480469e+02 -2.8417300415039062e+02 2.4380700683593750e+02 1.2537500000000000e+02 -2.8361898803710938e+02 2.4212199401855469e+02 1.2607399749755859e+02 -2.8398800659179688e+02 2.4235400390625000e+02 1.2680000305175781e+02 -2.8358700561523438e+02 2.4101200866699219e+02 1.2776300048828125e+02 -2.8400399780273438e+02 2.4114500427246094e+02 1.4361700439453125e+02 -2.9665698242187500e+02 2.5501498413085938e+02 1.4526599121093750e+02 -2.9653100585937500e+02 2.5355101013183594e+02 1.4238000488281250e+02 -2.9462899780273438e+02 2.5183599853515625e+02 1.4294000244140625e+02 -2.9390698242187500e+02 2.4997000122070312e+02 1.4314199829101562e+02 -2.9304699707031250e+02 2.4808900451660156e+02 1.4384700012207031e+02 -2.9323898315429688e+02 2.4795800781250000e+02 1.4297898864746094e+02 -2.9207901000976562e+02 2.4625801086425781e+02 1.4372900390625000e+02 -2.9240301513671875e+02 2.4636100769042969e+02 1.4335499572753906e+02 -2.9150997924804688e+02 2.4483500671386719e+02 1.3820899963378906e+02 -2.8695498657226562e+02 2.3942999267578125e+02 1.3666600036621094e+02 -2.8615100097656250e+02 2.3894299316406250e+02 1.3547000122070312e+02 -2.8595700073242188e+02 2.3942799377441406e+02 1.3502700805664062e+02 -2.8543200683593750e+02 2.3869599914550781e+02 1.3353300476074219e+02 -2.8521200561523438e+02 2.3934899902343750e+02 1.3367601013183594e+02 -2.8492999267578125e+02 2.3867399597167969e+02 1.3337100219726562e+02 -2.8385601806640625e+02 2.3673500061035156e+02 1.2125899505615234e+02 -2.8308499145507812e+02 2.4406401062011719e+02 1.1960999298095703e+02 -2.8321099853515625e+02 2.4552799987792969e+02 1.2249600219726562e+02 -2.8511300659179688e+02 2.4724299621582031e+02 1.2193699645996094e+02 -2.8583499145507812e+02 2.4910899353027344e+02 1.2173500061035156e+02 -2.8669500732421875e+02 2.5099000549316406e+02 1.2103000640869141e+02 -2.8650299072265625e+02 2.5112101745605469e+02 1.2189699554443359e+02 -2.8766302490234375e+02 2.5282099914550781e+02 1.2114699554443359e+02 -2.8733898925781250e+02 2.5271800231933594e+02 1.2152100372314453e+02 -2.8823199462890625e+02 2.5424400329589844e+02 1.2666800689697266e+02 -2.9278698730468750e+02 2.5964901733398438e+02 1.2821101379394531e+02 -2.9359100341796875e+02 2.6013601684570312e+02 1.2940600585937500e+02 -2.9378500366210938e+02 2.5965100097656250e+02 1.2984899902343750e+02 -2.9430999755859375e+02 2.6038400268554688e+02 1.3134400939941406e+02 -2.9452999877929688e+02 2.5973001098632812e+02 1.3120100402832031e+02 -2.9481198120117188e+02 2.6040499877929688e+02 1.3150599670410156e+02 -2.9588500976562500e+02 2.6234399414062500e+02 1.2275599670410156e+02 -2.9419897460937500e+02 2.5400502014160156e+02 1.2006299591064453e+02 -2.9351400756835938e+02 2.5460099792480469e+02 1.2181500244140625e+02 -2.9312597656250000e+02 2.5253298950195312e+02 1.1921199798583984e+02 -2.9233999633789062e+02 2.5285899353027344e+02 1.2122399902343750e+02 -2.9208499145507812e+02 2.5086799621582031e+02 1.1871899414062500e+02 -2.9121597290039062e+02 2.5095498657226562e+02 1.2100800323486328e+02 -2.9111599731445312e+02 2.4907499694824219e+02 1.1859700012207031e+02 -2.9017401123046875e+02 2.4894599914550781e+02 1.2117400360107422e+02 -2.9025598144531250e+02 2.4722099304199219e+02 1.1884999847412109e+02 -2.8924798583984375e+02 2.4689300537109375e+02 1.2171500396728516e+02 -2.8953900146484375e+02 2.4537800598144531e+02 1.1947100067138672e+02 -2.8846499633789062e+02 2.4486000061035156e+02 1.2261100006103516e+02 -2.8899099731445312e+02 2.4361700439453125e+02 1.2044000244140625e+02 -2.8784899902343750e+02 2.4290600585937500e+02 1.2382800292968750e+02 -2.8863497924804688e+02 2.4200599670410156e+02 1.2172900390625000e+02 -2.8741799926757812e+02 2.4109300231933594e+02 1.2531800842285156e+02 -2.8848300170898438e+02 2.4060598754882812e+02 1.2329900360107422e+02 -2.8718600463867188e+02 2.3947499084472656e+02 1.2509999847412109e+02 -2.8716000366210938e+02 2.3810101318359375e+02 1.2702499389648438e+02 -2.8854098510742188e+02 2.3947200012207031e+02 1.2707999420166016e+02 -2.8733999633789062e+02 2.3701300048828125e+02 1.2888301086425781e+02 -2.8880798339843750e+02 2.3864700317382812e+02 1.2917700195312500e+02 -2.8772198486328125e+02 2.3624398803710938e+02 1.3082000732421875e+02 -2.8927200317382812e+02 2.3816200256347656e+02 1.3132800292968750e+02 -2.8829299926757812e+02 2.3581700134277344e+02 1.3276199340820312e+02 -2.8991699218750000e+02 2.3803700256347656e+02 1.3346701049804688e+02 -2.8903601074218750e+02 2.3574499511718750e+02 1.3463499450683594e+02 -2.9071701049804688e+02 2.3827600097656250e+02 1.3552999877929688e+02 -2.8992901611328125e+02 2.3603099060058594e+02 1.3636599731445312e+02 -2.9164199829101562e+02 2.3886900329589844e+02 1.3745401000976562e+02 -2.9094400024414062e+02 2.3666600036621094e+02 1.3788899230957031e+02 -2.9265499877929688e+02 2.3979499816894531e+02 1.3918099975585938e+02 -2.9205099487304688e+02 2.3762998962402344e+02 1.3914500427246094e+02 -2.9371899414062500e+02 2.4101699829101562e+02 1.4065699768066406e+02 -2.9321600341796875e+02 2.3889500427246094e+02 1.4183799743652344e+02 -2.9440298461914062e+02 2.4042098999023438e+02 1.4008599853515625e+02 -2.9479199218750000e+02 2.4248899841308594e+02 1.4268800354003906e+02 -2.9557699584960938e+02 2.4216300964355469e+02 1.4067700195312500e+02 -2.9583297729492188e+02 2.4415400695800781e+02 1.4318199157714844e+02 -2.9670199584960938e+02 2.4406700134277344e+02 1.4089299011230469e+02 -2.9680200195312500e+02 2.4594700622558594e+02 1.4330400085449219e+02 -2.9774298095703125e+02 2.4607600402832031e+02 1.4072700500488281e+02 -2.9766101074218750e+02 2.4780101013183594e+02 1.4305099487304688e+02 -2.9866998291015625e+02 2.4812899780273438e+02 1.4018598937988281e+02 -2.9837899780273438e+02 2.4964399719238281e+02 1.4242999267578125e+02 -2.9945300292968750e+02 2.5016200256347656e+02 1.3929000854492188e+02 -2.9892599487304688e+02 2.5140499877929688e+02 1.4146099853515625e+02 -3.0006900024414062e+02 2.5211599731445312e+02 1.3807299804687500e+02 -2.9928298950195312e+02 2.5301599121093750e+02 1.4017100524902344e+02 -3.0050000000000000e+02 2.5392898559570312e+02 1.3658200073242188e+02 -2.9943499755859375e+02 2.5441598510742188e+02 1.3860200500488281e+02 -3.0073199462890625e+02 2.5554698181152344e+02 1.3680101013183594e+02 -3.0075799560546875e+02 2.5692098999023438e+02 1.3487599182128906e+02 -2.9937698364257812e+02 2.5555000305175781e+02 1.3482099914550781e+02 -3.0057702636718750e+02 2.5800897216796875e+02 1.3301800537109375e+02 -2.9910998535156250e+02 2.5637500000000000e+02 1.3272399902343750e+02 -3.0019598388671875e+02 2.5877899169921875e+02 1.3108099365234375e+02 -2.9864498901367188e+02 2.5685998535156250e+02 1.3057299804687500e+02 -2.9962399291992188e+02 2.5920501708984375e+02 1.2913800048828125e+02 -2.9800097656250000e+02 2.5698501586914062e+02 1.2843400573730469e+02 -2.9888098144531250e+02 2.5927697753906250e+02 1.2726600646972656e+02 -2.9720101928710938e+02 2.5674700927734375e+02 1.2636999511718750e+02 -2.9798800659179688e+02 2.5899099731445312e+02 1.2553499603271484e+02 -2.9627600097656250e+02 2.5615298461914062e+02 1.2444700622558594e+02 -2.9697299194335938e+02 2.5835601806640625e+02 1.2401200103759766e+02 -2.9526202392578125e+02 2.5522700500488281e+02 1.2272000122070312e+02 -2.9586602783203125e+02 2.5739199829101562e+02 1.2124399566650391e+02 -2.9470199584960938e+02 2.5612701416015625e+02 1.1925399780273438e+02 -2.8906100463867188e+02 2.4456399536132812e+02 1.1786500549316406e+02 -2.8839599609375000e+02 2.4424299621582031e+02 1.1831900024414062e+02 -2.8805300903320312e+02 2.4321701049804688e+02 1.2022299957275391e+02 -2.8844500732421875e+02 2.4261100769042969e+02 1.1946699523925781e+02 -2.8749401855468750e+02 2.4125000000000000e+02 1.2151200103759766e+02 -2.8801400756835938e+02 2.4079699707031250e+02 1.2090699768066406e+02 -2.8711798095703125e+02 2.3943699645996094e+02 1.2308200073242188e+02 -2.8778201293945312e+02 2.3917900085449219e+02 1.2260100555419922e+02 -2.8693499755859375e+02 2.3782501220703125e+02 1.2488300323486328e+02 -2.8775598144531250e+02 2.3780499267578125e+02 1.2450599670410156e+02 -2.8694998168945312e+02 2.3645700073242188e+02 1.2686300659179688e+02 -2.8793698120117188e+02 2.3671699523925781e+02 1.2657199859619141e+02 -2.8716098022460938e+02 2.3536700439453125e+02 1.2895999145507812e+02 -2.8831799316406250e+02 2.3594799804687500e+02 1.2874501037597656e+02 -2.8756298828125000e+02 2.3458399963378906e+02 1.3111099243164062e+02 -2.8888897705078125e+02 2.3552099609375000e+02 1.3097099304199219e+02 -2.8814700317382812e+02 2.3412899780273438e+02 1.3325000000000000e+02 -2.8963198852539062e+02 2.3544900512695312e+02 1.3319000244140625e+02 -2.8889700317382812e+02 2.3401199340820312e+02 1.3531300354003906e+02 -2.9052499389648438e+02 2.3573500061035156e+02 1.3534500122070312e+02 -2.8979302978515625e+02 2.3423699951171875e+02 1.3723699951171875e+02 -2.9154101562500000e+02 2.3636999511718750e+02 1.3738099670410156e+02 -2.9081298828125000e+02 2.3479800415039062e+02 1.3896400451660156e+02 -2.9264700317382812e+02 2.3733499145507812e+02 1.3924501037597656e+02 -2.9192999267578125e+02 2.3568099975585938e+02 1.4044000244140625e+02 -2.9381201171875000e+02 2.3859899902343750e+02 1.3250700378417969e+02 -3.0079202270507812e+02 2.5848300170898438e+02 1.3161199951171875e+02 -3.0127600097656250e+02 2.6011599731445312e+02 1.3035600280761719e+02 -3.0022100830078125e+02 2.5891000366210938e+02 1.2938200378417969e+02 -3.0060699462890625e+02 2.6040301513671875e+02 1.2821699523925781e+02 -2.9947702026367188e+02 2.5898098754882812e+02 1.2718799591064453e+02 -2.9978201293945312e+02 2.6034899902343750e+02 1.2615300750732422e+02 -2.9858499145507812e+02 2.5869500732421875e+02 1.2508499908447266e+02 -2.9882101440429688e+02 2.5995401000976562e+02 1.2422999572753906e+02 -2.9756900024414062e+02 2.5805999755859375e+02 1.2312900543212891e+02 -2.9774902343750000e+02 2.5922998046875000e+02 1.2250299835205078e+02 -2.9646301269531250e+02 2.5709597778320312e+02 1.2137000274658203e+02 -2.9659500122070312e+02 2.5819400024414062e+02 1.2102700042724609e+02 -2.9529800415039062e+02 2.5583100891113281e+02 1.1985299682617188e+02 -2.9538800048828125e+02 2.5687399291992188e+02 1.1984600067138672e+02 -2.9410998535156250e+02 2.5430500793457031e+02 1.1861799621582031e+02 -2.9415899658203125e+02 2.5530401611328125e+02 1.1899500274658203e+02 -2.9293701171875000e+02 2.5256300354003906e+02 1.1769599914550781e+02 -2.9294100952148438e+02 2.5352400207519531e+02 1.1850199890136719e+02 -2.9181201171875000e+02 2.5065899658203125e+02 1.1711299896240234e+02 -2.9176397705078125e+02 2.5158100891113281e+02 1.1838000488281250e+02 -2.9076998901367188e+02 2.4864999389648438e+02 1.1688199615478516e+02 -2.9066000366210938e+02 2.4952499389648438e+02 1.1863300323486328e+02 -2.8984399414062500e+02 2.4659800720214844e+02 1.1700999450683594e+02 -2.8965600585937500e+02 2.4740899658203125e+02 1.1749300384521484e+02 -2.8877999877929688e+02 2.4528799438476562e+02 1.4088900756835938e+02 -2.9311401367187500e+02 2.3686300659179688e+02 1.4226899719238281e+02 -2.9433599853515625e+02 2.3831300354003906e+02 1.4162098693847656e+02 -2.9500000000000000e+02 2.4012500000000000e+02 1.4335099792480469e+02 -2.9556301879882812e+02 2.3999301147460938e+02 1.4247099304199219e+02 -2.9617300415039062e+02 2.4186700439453125e+02 1.4410600280761719e+02 -2.9676501464843750e+02 2.4186000061035156e+02 1.4296499633789062e+02 -2.9729800415039062e+02 2.4377200317382812e+02 1.4451399230957031e+02 -2.9790899658203125e+02 2.4386698913574219e+02 1.4308700561523438e+02 -2.9833901977539062e+02 2.4577999877929688e+02 1.4456599426269531e+02 -2.9896600341796875e+02 2.4595899963378906e+02 1.4283399963378906e+02 -2.9926602172851562e+02 2.4783299255371094e+02 1.4425900268554688e+02 -2.9990899658203125e+02 2.4808500671386719e+02 1.4221299743652344e+02 -3.0004901123046875e+02 2.4986700439453125e+02 1.4360200500488281e+02 -3.0071398925781250e+02 2.5018701171875000e+02 1.4124398803710938e+02 -3.0066497802734375e+02 2.5181999206542969e+02 1.4261199951171875e+02 -3.0135900878906250e+02 2.5221299743652344e+02 1.3995399475097656e+02 -3.0109597778320312e+02 2.5363299560546875e+02 1.4131399536132812e+02 -3.0182702636718750e+02 2.5411001586914062e+02 1.3838499450683594e+02 -3.0132800292968750e+02 2.5525099182128906e+02 1.3974200439453125e+02 -3.0210800170898438e+02 2.5582701110839844e+02 1.3658399963378906e+02 -3.0135400390625000e+02 2.5662500000000000e+02 1.3793699645996094e+02 -3.0219201660156250e+02 2.5732202148437500e+02 1.3460400390625000e+02 -3.0117300415039062e+02 2.5771398925781250e+02 1.3594500732421875e+02 -3.0207897949218750e+02 2.5855499267578125e+02 1.3381799316406250e+02 -3.0177099609375000e+02 2.5949499511718750e+02 1.3210099792480469e+02 -3.0018402099609375e+02 2.6110601806640625e+02 1.3216499328613281e+02 -3.0020098876953125e+02 2.6109201049804688e+02 1.3026599121093750e+02 -2.9929199218750000e+02 2.6065399169921875e+02 1.2338400268554688e+02 -2.9655999755859375e+02 2.6019497680664062e+02 1.2261900329589844e+02 -2.9563201904296875e+02 2.5888699340820312e+02 1.2157599639892578e+02 -2.9537298583984375e+02 2.5913101196289062e+02 1.2071900177001953e+02 -2.9472299194335938e+02 2.5844897460937500e+02 1.3015699768066406e+02 -2.9891000366210938e+02 2.5996301269531250e+02 1.2830700683593750e+02 -2.9823397827148438e+02 2.5995800781250000e+02 1.2321299743652344e+02 -2.9558700561523438e+02 2.5835897827148438e+02 1.2475500488281250e+02 -2.9653399658203125e+02 2.5913800048828125e+02 1.2647800445556641e+02 -2.9743099975585938e+02 2.5968200683593750e+02 1.2539400482177734e+02 -2.9766101074218750e+02 2.6093899536132812e+02 1.2755500030517578e+02 -2.9864801025390625e+02 2.6134500122070312e+02 1.2981001281738281e+02 -2.9949700927734375e+02 2.6140100097656250e+02 1.1937999725341797e+02 -2.9353799438476562e+02 2.5704199218750000e+02 1.1908700561523438e+02 -2.9250601196289062e+02 2.5517800903320312e+02 1.1874800109863281e+02 -2.9286999511718750e+02 2.5616101074218750e+02 1.1780200195312500e+02 -2.9161798095703125e+02 2.5433200073242188e+02 1.1761199951171875e+02 -2.8731997680664062e+02 2.4580799865722656e+02 1.1759299468994141e+02 -2.8734298706054688e+02 2.4586900329589844e+02 1.1790499877929688e+02 -2.8835101318359375e+02 2.4767201232910156e+02 1.1709600067138672e+02 -2.8824298095703125e+02 2.4804798889160156e+02 1.1696500396728516e+02 -2.8927499389648438e+02 2.5022300720214844e+02 1.1860900115966797e+02 -2.8868801879882812e+02 2.4783499145507812e+02 1.1845899963378906e+02 -2.8951699829101562e+02 2.4961500549316406e+02 1.1858999633789062e+02 -2.9045001220703125e+02 2.5139901733398438e+02 1.1720199584960938e+02 -2.9040899658203125e+02 2.5233500671386719e+02 1.1900799560546875e+02 -2.9144702148437500e+02 2.5310200500488281e+02 1.1968199920654297e+02 -2.9246099853515625e+02 2.5464999389648438e+02 1.1844200134277344e+02 -2.8659600830078125e+02 2.4374101257324219e+02 1.1841400146484375e+02 -2.8661401367187500e+02 2.4379899597167969e+02 1.2001899719238281e+02 -2.8649200439453125e+02 2.4237400817871094e+02 1.2479899597167969e+02 -2.8546200561523438e+02 2.3679399108886719e+02 1.2648500823974609e+02 -2.8599700927734375e+02 2.3663400268554688e+02 1.2692199707031250e+02 -2.8567901611328125e+02 2.3567399597167969e+02 1.2809098815917969e+02 -2.8587402343750000e+02 2.3520899963378906e+02 1.2072299957275391e+02 -2.8682800292968750e+02 2.4253599548339844e+02 1.2189900207519531e+02 -2.8648999023437500e+02 2.4099299621582031e+02 1.2659400939941406e+02 -2.8637899780273438e+02 2.3732400512695312e+02 1.2490200042724609e+02 -2.8626000976562500e+02 2.3832600402832031e+02 1.2331099700927734e+02 -2.8629602050781250e+02 2.3956599426269531e+02 1.2284100341796875e+02 -2.8544802856445312e+02 2.3819999694824219e+02 1.2110099792480469e+02 -2.8563601684570312e+02 2.3985600280761719e+02 1.1962100219726562e+02 -2.8602200317382812e+02 2.4171899414062500e+02 1.3023200988769531e+02 -2.8635400390625000e+02 2.3460600280761719e+02 1.3213099670410156e+02 -2.8726300048828125e+02 2.3504499816894531e+02 1.3144200134277344e+02 -2.8669299316406250e+02 2.3440200805664062e+02 1.3372200012207031e+02 -2.8746301269531250e+02 2.3428199768066406e+02 1.4167700195312500e+02 -2.9183200073242188e+02 2.3725000000000000e+02 1.4163400268554688e+02 -2.9179699707031250e+02 2.3721099853515625e+02 1.3977799987792969e+02 -2.9092300415039062e+02 2.3681100463867188e+02 1.3994500732421875e+02 -2.9058001708984375e+02 2.3599700927734375e+02 1.3802999877929688e+02 -2.8943197631835938e+02 2.3508999633789062e+02 1.3918399047851562e+02 -2.9096798706054688e+02 2.3733900451660156e+02 1.3764199829101562e+02 -2.9002099609375000e+02 2.3656100463867188e+02 1.3591900634765625e+02 -2.8912402343750000e+02 2.3601600646972656e+02 1.3593701171875000e+02 -2.8838400268554688e+02 2.3451300048828125e+02 1.3408898925781250e+02 -2.8832098388671875e+02 2.3574000549316406e+02 1.3223899841308594e+02 -2.8764501953125000e+02 2.3573500061035156e+02 1.4305200195312500e+02 -2.9305200195312500e+02 2.3870100402832031e+02 1.4301699829101562e+02 -2.9301699829101562e+02 2.3865600585937500e+02 1.4330999755859375e+02 -2.9404898071289062e+02 2.4052000427246094e+02 1.4541200256347656e+02 -2.9780999755859375e+02 2.4655899047851562e+02 1.4449099731445312e+02 -2.9820300292968750e+02 2.4802600097656250e+02 1.4509700012207031e+02 -2.9877999877929688e+02 2.4874299621582031e+02 1.4478500366210938e+02 -2.9923498535156250e+02 2.4988999938964844e+02 1.4271501159667969e+02 -2.9409399414062500e+02 2.4104798889160156e+02 1.4338900756835938e+02 -2.9510800170898438e+02 2.4259599304199219e+02 1.4378799438476562e+02 -2.9786700439453125e+02 2.4786399841308594e+02 1.4393800354003906e+02 -2.9703799438476562e+02 2.4608300781250000e+02 1.4380699157714844e+02 -2.9610501098632812e+02 2.4429998779296875e+02 1.4535899353027344e+02 -2.9672399902343750e+02 2.4440798950195312e+02 1.4494000244140625e+02 -2.9554800415039062e+02 2.4234700012207031e+02 1.4416400146484375e+02 -2.9431399536132812e+02 2.4042799377441406e+02 1.4398300170898438e+02 -2.9994000244140625e+02 2.5189900207519531e+02 1.4237800598144531e+02 -3.0006301879882812e+02 2.5332400512695312e+02 1.4340499877929688e+02 -3.0026901245117188e+02 2.5298500061035156e+02 1.4207099914550781e+02 -3.0075000000000000e+02 2.5493400573730469e+02 1.3430599975585938e+02 -3.0068099975585938e+02 2.6048999023437500e+02 1.3436900329589844e+02 -3.0069299316406250e+02 2.6046697998046875e+02 1.3591200256347656e+02 -3.0055801391601562e+02 2.5906399536132812e+02 1.3655400085449219e+02 -3.0100900268554688e+02 2.5950198364257812e+02 1.3860099792480469e+02 -3.0112500000000000e+02 2.5823501586914062e+02 1.3580299377441406e+02 -3.0017599487304688e+02 2.5837399291992188e+02 1.3749400329589844e+02 -3.0029400634765625e+02 2.5737197875976562e+02 1.3908599853515625e+02 -3.0025900268554688e+02 2.5613299560546875e+02 1.4045600891113281e+02 -3.0103799438476562e+02 2.5669900512695312e+02 1.4049800109863281e+02 -3.0006500244140625e+02 2.5470501708984375e+02 1.4167399597167969e+02 -2.9972698974609375e+02 2.5316200256347656e+02 1.4442199707031250e+02 -2.9960598754882812e+02 2.5090301513671875e+02 1.4421199035644531e+02 -2.9977801513671875e+02 2.5140399169921875e+02 1.2001799774169922e+02 -2.9413299560546875e+02 2.5777398681640625e+02 1.1969100189208984e+02 -2.9383599853515625e+02 2.5741500854492188e+02 1.2915499877929688e+02 -2.8609298706054688e+02 2.3486999511718750e+02 1.2969200134277344e+02 -2.8621798706054688e+02 2.3472799682617188e+02 1.4402600097656250e+02 -2.9993701171875000e+02 2.5186100769042969e+02 1.4479299926757812e+02 -2.9926300048828125e+02 2.4993998718261719e+02 1.4444400024414062e+02 -2.9961700439453125e+02 2.5090798950195312e+02 1.4300900268554688e+02 -2.9298898315429688e+02 2.3860600280761719e+02 1.4172799682617188e+02 -2.9185598754882812e+02 2.3726100158691406e+02 1.3018099975585938e+02 -2.8633001708984375e+02 2.3459400939941406e+02 1.2813400268554688e+02 -2.8587100219726562e+02 2.3517001342773438e+02 1.2915199279785156e+02 -2.8608099365234375e+02 2.3484799194335938e+02 1.1837100219726562e+02 -2.8661798095703125e+02 2.4383700561523438e+02 1.1760400390625000e+02 -2.8729199218750000e+02 2.4575799560546875e+02 1.1938800048828125e+02 -2.9356597900390625e+02 2.5709201049804688e+02 1.2066899871826172e+02 -2.9469900512695312e+02 2.5843701171875000e+02 1.1999900054931641e+02 -2.9413500976562500e+02 2.5779101562500000e+02 1.3221600341796875e+02 -3.0022497558593750e+02 2.6110397338867188e+02 1.3426300048828125e+02 -3.0068399047851562e+02 2.6052798461914062e+02 1.4194599914550781e+02 -2.9430099487304688e+02 2.4960101318359375e+02 1.4195700073242188e+02 -2.9425100708007812e+02 2.4949200439453125e+02 1.4213299560546875e+02 -2.9350299072265625e+02 2.4785398864746094e+02 1.4211399841308594e+02 -2.9339001464843750e+02 2.4764199829101562e+02 1.4198200988769531e+02 -2.9260299682617188e+02 2.4615299987792969e+02 1.4189100646972656e+02 -2.9242199707031250e+02 2.4585400390625000e+02 1.4149800109863281e+02 -2.9163500976562500e+02 2.4455599975585938e+02 1.4129798889160156e+02 -2.9138299560546875e+02 2.4419699096679688e+02 1.4069599914550781e+02 -2.9062899780273438e+02 2.4311700439453125e+02 1.4035600280761719e+02 -2.9031399536132812e+02 2.4273200988769531e+02 1.3960499572753906e+02 -2.8962002563476562e+02 2.4188500976562500e+02 1.3910198974609375e+02 -2.8925399780273438e+02 2.4151701354980469e+02 1.3826200866699219e+02 -2.8864398193359375e+02 2.4090200805664062e+02 1.3758399963378906e+02 -2.8824499511718750e+02 2.4059599304199219e+02 1.3671099853515625e+02 -2.8773199462890625e+02 2.4020199584960938e+02 1.3585899353027344e+02 -2.8732400512695312e+02 2.4000500488281250e+02 1.3500698852539062e+02 -2.8691598510742188e+02 2.3980900573730469e+02 1.3399400329589844e+02 -2.8652700805664062e+02 2.3976699829101562e+02 1.3320700073242188e+02 -2.8622500610351562e+02 2.3973500061035156e+02 1.3206001281738281e+02 -2.8588400268554688e+02 2.3988999938964844e+02 1.3137200927734375e+02 -2.8567999267578125e+02 2.3998300170898438e+02 1.3012899780273438e+02 -2.8542001342773438e+02 2.4037001037597656e+02 1.2956500244140625e+02 -2.8530200195312500e+02 2.4054600524902344e+02 1.2827600097656250e+02 -2.8515197753906250e+02 2.4118899536132812e+02 1.2784799957275391e+02 -2.8510202026367188e+02 2.4140299987792969e+02 1.2657199859619141e+02 -2.8508999633789062e+02 2.4231599426269531e+02 1.2627799987792969e+02 -2.8508801269531250e+02 2.4252600097656250e+02 1.2508000183105469e+02 -2.8523800659179688e+02 2.4370799255371094e+02 1.2490999603271484e+02 -2.8525997924804688e+02 2.4387599182128906e+02 1.2385900115966797e+02 -2.8558999633789062e+02 2.4531201171875000e+02 1.2378899383544922e+02 -2.8561199951171875e+02 2.4540800476074219e+02 1.2295500183105469e+02 -2.8613201904296875e+02 2.4706800842285156e+02 1.2243500518798828e+02 -2.8680300903320312e+02 2.4880200195312500e+02 1.2242300415039062e+02 -2.8685299682617188e+02 2.4891099548339844e+02 1.2224700164794922e+02 -2.8760202026367188e+02 2.5054899597167969e+02 1.2226599884033203e+02 -2.8771398925781250e+02 2.5076100158691406e+02 1.2239799499511719e+02 -2.8850100708007812e+02 2.5224998474121094e+02 1.2248899841308594e+02 -2.8868200683593750e+02 2.5254899597167969e+02 1.2288300323486328e+02 -2.8947000122070312e+02 2.5384700012207031e+02 1.2308300018310547e+02 -2.8972100830078125e+02 2.5420600891113281e+02 1.2368399810791016e+02 -2.9047598266601562e+02 2.5528601074218750e+02 1.2402500152587891e+02 -2.9079101562500000e+02 2.5567098999023438e+02 1.2477500152587891e+02 -2.9148400878906250e+02 2.5651800537109375e+02 1.2527899169921875e+02 -2.9185000610351562e+02 2.5688601684570312e+02 1.2611900329589844e+02 -2.9246099853515625e+02 2.5750100708007812e+02 1.2679700469970703e+02 -2.9285897827148438e+02 2.5780697631835938e+02 1.2766900634765625e+02 -2.9337200927734375e+02 2.5820098876953125e+02 1.2852099609375000e+02 -2.9377999877929688e+02 2.5839801025390625e+02 1.2937399291992188e+02 -2.9418798828125000e+02 2.5859399414062500e+02 1.3038600158691406e+02 -2.9457699584960938e+02 2.5863598632812500e+02 1.3117399597167969e+02 -2.9488000488281250e+02 2.5866799926757812e+02 1.3232099914550781e+02 -2.9522000122070312e+02 2.5851300048828125e+02 1.3300900268554688e+02 -2.9542401123046875e+02 2.5841998291015625e+02 1.3425099182128906e+02 -2.9568499755859375e+02 2.5803302001953125e+02 1.3481600952148438e+02 -2.9580300903320312e+02 2.5785699462890625e+02 1.3610400390625000e+02 -2.9595300292968750e+02 2.5721401977539062e+02 1.3653300476074219e+02 -2.9600302124023438e+02 2.5700000000000000e+02 1.3780899047851562e+02 -2.9601400756835938e+02 2.5608700561523438e+02 1.3810299682617188e+02 -2.9601699829101562e+02 2.5587698364257812e+02 1.3930000305175781e+02 -2.9586602783203125e+02 2.5469499206542969e+02 1.3947099304199219e+02 -2.9584500122070312e+02 2.5452700805664062e+02 1.4052200317382812e+02 -2.9551501464843750e+02 2.5309100341796875e+02 1.4059199523925781e+02 -2.9549301147460938e+02 2.5299501037597656e+02 1.4142599487304688e+02 -2.9497201538085938e+02 2.5133499145507812e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 23208 -> 19 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1186099797487259e+02 -3.0893701314926147e+02 2.2733299434185028e+02) (float-vector 1.1960999667644501e+02 -2.8321099281311035e+02 2.4552799761295319e+02) (float-vector 1.0729300230741501e+02 -3.1310498714447021e+02 2.3863999545574188e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4329999685287476e+02 -2.8355699777603149e+02 2.5014400482177734e+02) (float-vector 1.4296799898147583e+02 -2.8844898939132690e+02 2.3895199596881866e+02) (float-vector 1.4603300392627716e+02 -2.9585599899291992e+02 2.5163000822067261e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4296799898147583e+02 -2.8844898939132690e+02 2.3895199596881866e+02) (float-vector 1.4329999685287476e+02 -2.8355699777603149e+02 2.5014400482177734e+02) (float-vector 1.3337099552154541e+02 -2.8385600447654724e+02 2.3673500120639801e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1186099797487259e+02 -3.0893701314926147e+02 2.2733299434185028e+02) (float-vector 1.2479899823665619e+02 -2.8546199202537537e+02 2.3679399490356445e+02) (float-vector 1.1960999667644501e+02 -2.8321099281311035e+02 2.4552799761295319e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3337099552154541e+02 -2.8385600447654724e+02 2.3673500120639801e+02) (float-vector 1.2479899823665619e+02 -2.8546199202537537e+02 2.3679399490356445e+02) (float-vector 1.1186099797487259e+02 -3.0893701314926147e+02 2.2733299434185028e+02) (float-vector 1.2506100535392761e+02 -3.1105199456214905e+02 2.2147099673748016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4329999685287476e+02 -2.8355699777603149e+02 2.5014400482177734e+02) (float-vector 1.1960999667644501e+02 -2.8321099281311035e+02 2.4552799761295319e+02) (float-vector 1.2479899823665619e+02 -2.8546199202537537e+02 2.3679399490356445e+02) (float-vector 1.3337099552154541e+02 -2.8385600447654724e+02 2.3673500120639801e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0729300230741501e+02 -3.1310498714447021e+02 2.3863999545574188e+02) (float-vector 1.1558700352907181e+02 -3.1730699539184570e+02 2.3570300638675690e+02) (float-vector 1.2506100535392761e+02 -3.1105199456214905e+02 2.2147099673748016e+02) (float-vector 1.1186099797487259e+02 -3.0893701314926147e+02 2.2733299434185028e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3305300474166870e+02 -3.1507000327110291e+02 2.2414900362491608e+02) (float-vector 1.4296799898147583e+02 -2.8844898939132690e+02 2.3895199596881866e+02) (float-vector 1.3337099552154541e+02 -2.8385600447654724e+02 2.3673500120639801e+02) (float-vector 1.2506100535392761e+02 -3.1105199456214905e+02 2.2147099673748016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4603300392627716e+02 -2.9585599899291992e+02 2.5163000822067261e+02) (float-vector 1.4296799898147583e+02 -2.8844898939132690e+02 2.3895199596881866e+02) (float-vector 1.3305300474166870e+02 -3.1507000327110291e+02 2.2414900362491608e+02) (float-vector 1.3664799928665161e+02 -3.2388600707054138e+02 2.3927900195121765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3550299406051636e+02 -2.9727798700332642e+02 2.6221799850463867e+02) (float-vector 1.3987100124359131e+02 -2.8694099187850952e+02 2.5947898626327515e+02) (float-vector 1.4603300392627716e+02 -2.9585599899291992e+02 2.5163000822067261e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3987100124359131e+02 -2.8694099187850952e+02 2.5947898626327515e+02) (float-vector 1.4329999685287476e+02 -2.8355699777603149e+02 2.5014400482177734e+02) (float-vector 1.4603300392627716e+02 -2.9585599899291992e+02 2.5163000822067261e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3987100124359131e+02 -2.8694099187850952e+02 2.5947898626327515e+02) (float-vector 1.3550299406051636e+02 -2.9727798700332642e+02 2.6221799850463867e+02) (float-vector 1.2539400160312653e+02 -2.9766100645065308e+02 2.6093900203704834e+02) (float-vector 1.2062799930572510e+02 -2.9015898704528809e+02 2.5878301262855530e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1960999667644501e+02 -2.8321099281311035e+02 2.4552799761295319e+02) (float-vector 1.4329999685287476e+02 -2.8355699777603149e+02 2.5014400482177734e+02) (float-vector 1.3987100124359131e+02 -2.8694099187850952e+02 2.5947898626327515e+02) (float-vector 1.2062799930572510e+02 -2.9015898704528809e+02 2.5878301262855530e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2440399825572968e+02 -3.2473200559616089e+02 2.4996399879455566e+02) (float-vector 1.1560700088739395e+02 -3.2161399722099304e+02 2.4968799948692322e+02) (float-vector 1.2539400160312653e+02 -2.9766100645065308e+02 2.6093900203704834e+02) (float-vector 1.3550299406051636e+02 -2.9727798700332642e+02 2.6221799850463867e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2506100535392761e+02 -3.1105199456214905e+02 2.2147099673748016e+02) (float-vector 1.1558700352907181e+02 -3.1730699539184570e+02 2.3570300638675690e+02) (float-vector 1.1560700088739395e+02 -3.2161399722099304e+02 2.4968799948692322e+02) (float-vector 1.2440399825572968e+02 -3.2473200559616089e+02 2.4996399879455566e+02) (float-vector 1.3664799928665161e+02 -3.2388600707054138e+02 2.3927900195121765e+02) (float-vector 1.3305300474166870e+02 -3.1507000327110291e+02 2.2414900362491608e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2440399825572968e+02 -3.2473200559616089e+02 2.4996399879455566e+02) (float-vector 1.3550299406051636e+02 -2.9727798700332642e+02 2.6221799850463867e+02) (float-vector 1.4603300392627716e+02 -2.9585599899291992e+02 2.5163000822067261e+02) (float-vector 1.3664799928665161e+02 -3.2388600707054138e+02 2.3927900195121765e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0923899710178375e+02 -3.1671500205993652e+02 2.4493099749088287e+02) (float-vector 1.1560700088739395e+02 -3.2161399722099304e+02 2.4968799948692322e+02) (float-vector 1.1558700352907181e+02 -3.1730699539184570e+02 2.3570300638675690e+02) (float-vector 1.0729300230741501e+02 -3.1310498714447021e+02 2.3863999545574188e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1560700088739395e+02 -3.2161399722099304e+02 2.4968799948692322e+02) (float-vector 1.0923899710178375e+02 -3.1671500205993652e+02 2.4493099749088287e+02) (float-vector 1.2062799930572510e+02 -2.9015898704528809e+02 2.5878301262855530e+02) (float-vector 1.2539400160312653e+02 -2.9766100645065308e+02 2.6093900203704834e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0923899710178375e+02 -3.1671500205993652e+02 2.4493099749088287e+02) (float-vector 1.0729300230741501e+02 -3.1310498714447021e+02 2.3863999545574188e+02) (float-vector 1.1960999667644501e+02 -2.8321099281311035e+02 2.4552799761295319e+02) (float-vector 1.2062799930572510e+02 -2.9015898704528809e+02 2.5878301262855530e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_estop_link_sy47vh.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_base_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.178000 0.180500 0.188000 1.000000))
                    (list :diffuse (float-vector 0.356000 0.361000 0.376000 1.000000))))
                   (list :indices #i( 0 1 2 1 0 3 4 5 0 4 0 2 0 5 606 607 0 606 609 0 607 0 609 3 6 5 4 2 1617 4 6 4 1617 2 1616 1617 1618 6 1617 1617 1616 1627 1618 1617 1627 1615 1616 1 1 1616 2 1627 1616 1615 1627 1615 1632 1615 1 1632 2733 1 3 2733 1632 1 1627 1632 1633 2733 1633 1632 2636 2732 2733 2733 3 2636 1633 2733 1650 1650 2733 2732 1633 1650 1627 1627 1650 1651 2459 1651 1650 2459 1650 2732 2632 2459 2732 2632 2732 2636 2635 2632 2636 2635 2636 3 2631 2460 2632 2635 2631 2632 2460 2459 2632 2634 2631 2635 2635 3 2634 2630 2627 2631 2631 2627 2460 2634 2630 2631 2459 2460 2311 2626 2311 2460 2626 2460 2624 2627 2624 2460 2624 2627 2628 2630 2628 2627 2629 2628 2630 2633 2629 2630 2633 2630 2634 2665 2624 2628 2666 2665 2628 2666 2628 2629 2624 2625 2626 2665 2625 2624 2658 2328 2665 2665 2328 2625 2662 2658 2665 2662 2665 2666 2629 2598 2666 2666 2598 2599 2666 2599 2662 2597 2566 2598 2598 2566 2567 2598 2567 2599 2629 2597 2598 2599 2567 2568 2599 2568 2600 2662 2599 2600 2566 2562 2567 2567 2562 2564 2567 2564 2568 2600 2568 2564 2600 2564 2601 2662 2600 2664 2664 2600 2601 2562 2563 2564 2601 2564 2563 2601 2563 2602 2664 2601 2602 2602 2563 2562 2566 2565 2562 2620 2602 2562 2562 2565 2620 2602 2620 2690 2664 2602 2696 2696 2602 2690 2620 2704 2690 2704 2777 2690 2690 2777 2778 2690 2778 2696 2696 2778 2779 2696 2779 2664 2777 207 2778 215 2779 2778 215 2778 214 214 2778 207 2776 208 2777 2777 208 207 2704 2776 2777 207 208 209 207 209 214 212 213 214 214 213 215 214 209 216 214 216 212 215 213 221 221 2779 215 221 213 225 213 2345 2338 2338 225 213 213 212 2345 2345 212 216 2345 216 209 2338 2345 2336 2336 2345 2344 2345 209 211 2345 211 2344 2336 2337 2338 2337 2349 2338 2349 219 2338 2338 219 225 221 225 219 219 220 221 2779 221 220 219 218 220 2779 220 2780 2780 220 218 2780 2664 2779 2663 2664 2780 2663 2780 2781 2780 218 2781 217 218 219 2781 218 217 2663 2781 2660 2660 2781 2782 2781 217 2782 2660 2662 2663 2663 2662 2664 2660 2661 2658 2660 2658 2662 2660 2782 2661 2782 217 224 2782 224 2783 2661 2782 2783 219 224 217 219 223 224 2783 224 223 222 223 219 232 233 219 219 233 234 219 234 222 2349 232 219 2783 223 222 234 2470 222 2783 222 2470 233 2327 234 234 2327 2470 2327 2326 2470 2657 2783 2470 2657 2470 2326 2325 2326 2327 2657 2326 2325 2325 2327 2328 2310 2328 2327 2310 2327 2329 233 2329 2327 2657 2325 2658 2658 2325 2328 2658 2659 2657 2659 2783 2657 2658 2661 2659 2661 2783 2659 2314 2328 2310 2328 2314 2625 2310 2313 2314 2313 2626 2314 2314 2626 2625 2309 2312 2313 2309 2313 2310 2312 2626 2313 2312 2311 2626 2295 2311 2312 2295 2312 2309 2308 2295 2309 2308 2309 2307 2307 2309 2310 2293 2294 2295 2297 2293 2295 2297 2295 2308 2294 2311 2295 2307 2306 2308 2308 2306 2300 2308 2300 2297 2296 2293 2297 2297 2300 2302 2297 2302 2296 2300 2301 2302 2304 2301 2300 2304 2300 2305 2305 2300 2306 2302 2301 2299 2302 2299 2296 2298 2296 2299 2298 2299 2301 2298 2465 2296 5577 2298 2276 2276 2298 5578 5578 2298 2301 2465 2298 5664 5664 2298 2454 2454 2298 5577 2281 5577 2276 2281 2454 5577 2454 2281 2455 2454 2455 1655 1654 2454 1655 1654 5664 2454 1676 5664 1654 2465 5664 1676 1654 1655 1656 1656 1676 1654 2455 1656 1655 2455 2281 2283 2455 2283 2456 2456 1656 2455 1659 1674 1656 1656 1674 1676 2456 1659 1656 1674 1675 1676 2465 1676 1675 1659 1681 1674 1681 2466 1674 1674 2466 2465 1674 2465 1675 2296 2465 2466 2296 2466 2293 2293 2466 2462 2462 2466 1681 1626 1681 1659 1681 1626 2462 2293 2462 2294 2294 2462 2463 1625 2463 2462 1625 2462 1626 2294 2463 2311 2311 2463 2464 1625 1673 2463 2463 1673 2464 1625 1626 1627 1627 1673 1625 1627 1653 1673 2464 1673 2461 2461 1673 1653 2311 2464 2461 2311 2461 2459 2461 1653 2459 1627 1652 1653 2459 1653 1652 2459 1652 1651 1651 1652 1627 1618 1627 1645 1645 1627 1646 1626 1680 1627 2451 1646 1627 2451 1627 1680 1645 6 1618 1683 5 6 6 1687 1683 1687 6 1688 1645 1688 6 1687 1686 1683 1686 2054 1683 2056 5 1683 2056 1683 2054 606 5 604 604 5 2056 2054 2055 2056 2056 2055 499 2056 499 604 1686 2052 2054 2052 2053 2054 2054 2053 2055 1852 2055 1854 1854 2055 2053 2055 1852 499 1857 2053 2051 1854 2053 1856 1856 2053 1857 2052 2051 2053 1853 1852 1854 1853 1854 1855 1855 1854 1856 1851 499 1852 1851 1852 1853 1855 126 1853 1853 126 128 1853 128 1851 1855 1856 1857 1855 1857 1858 1858 118 1855 1855 118 126 118 119 126 126 119 127 126 127 128 128 127 129 128 129 130 1851 128 130 119 627 127 127 627 621 127 621 129 118 117 119 117 628 119 119 628 627 621 627 619 619 627 628 619 620 621 621 620 622 129 621 622 619 628 629 948 620 619 948 619 629 629 628 630 115 630 628 115 628 117 629 630 631 631 1024 629 629 1024 948 631 630 632 630 633 632 114 633 630 114 630 115 114 115 116 116 115 117 124 123 114 124 114 125 125 114 116 123 633 114 122 123 124 125 1780 124 124 1780 1782 1782 122 124 122 121 123 636 633 123 123 121 636 113 121 122 1782 113 122 1780 1781 1782 1782 1781 1783 1782 1783 1784 1784 113 1782 112 111 113 111 120 113 113 120 121 1784 112 113 636 121 120 636 120 111 109 111 110 110 111 112 636 111 638 638 111 641 641 111 109 1786 110 112 1786 112 1784 108 109 110 1788 108 110 1788 110 1786 1784 1785 1786 1786 1785 1787 1786 1787 1788 1784 1783 1785 2006 1787 1785 2006 1785 2003 2003 1785 1783 1788 1787 1789 2005 1787 2006 2005 1789 1787 2003 2004 2006 2006 2004 2008 2006 2008 2005 2000 1694 2004 2004 1694 1696 2004 1696 2008 2003 2000 2004 2008 1696 1697 2008 1697 2009 2005 2008 2009 1695 1696 1692 1692 1696 1694 1696 1695 1697 1693 1692 1694 2000 1693 1694 1685 1691 1692 1693 1685 1692 1692 1752 1753 1692 1753 1695 1692 1691 1752 1685 1693 2000 1684 1685 1686 1690 1691 1685 1690 1685 1684 2000 2001 1685 1685 2001 2052 1686 1685 2052 1684 1686 1687 1687 1689 1684 1684 1689 1690 1662 1690 1663 1663 1690 1689 1662 1691 1690 1687 1688 1689 1663 1689 1664 1664 1689 1688 1662 1663 1621 1621 1663 1664 1621 1661 1662 1661 1691 1662 1637 1752 1691 1637 1691 1660 1660 1691 1661 1621 1660 1661 1637 1660 1621 1621 1636 1637 1636 1752 1637 1636 1753 1752 1635 1636 1621 1635 1753 1636 1695 1753 1750 1635 1750 1753 1621 1634 1635 1634 1750 1635 1695 1750 1751 1634 1751 1750 1697 1695 1698 1695 1751 1698 1698 1751 1749 1631 1749 1751 1631 1751 1634 1631 1634 1621 1621 1630 1631 1749 1631 1630 1698 1749 1699 1699 1749 1747 1749 1630 1747 1699 1700 1698 1698 1700 1697 1703 1702 1699 1699 1702 1700 1699 1747 1748 1699 1748 1703 1747 1630 1629 1629 1748 1747 1629 1630 1621 1621 1644 1629 1644 1745 1629 1629 1745 1748 1703 1748 1745 1703 1745 1746 1644 1746 1745 1621 1643 1644 1643 1746 1644 1703 1746 1707 1707 1746 1744 1643 1744 1746 1621 1620 1643 1620 1744 1643 1707 1744 1704 1704 1744 1743 1744 1620 1743 1704 1706 1707 1706 1708 1707 1707 1708 1703 1704 1705 1706 2016 1708 1706 2016 1706 2022 2022 1706 1705 1703 1708 1701 1708 2016 2017 2017 1701 1708 1701 1702 1703 2018 1702 1701 2018 1701 2017 1999 2018 2017 1999 2017 2021 2021 2017 2016 2021 2016 2020 2020 2016 2022 2020 1807 2021 2021 1807 1999 2019 1809 2020 2020 1809 1807 2020 2022 2019 1806 1804 1807 1806 1807 1808 1808 1807 1809 1999 1807 1804 1808 1809 1810 1810 1809 1811 1811 1809 1812 2019 1812 1809 1810 87 1808 1808 87 89 1808 89 1806 1811 87 1810 85 86 87 87 86 88 87 88 89 1811 85 87 89 88 90 89 90 91 1806 89 91 663 90 88 663 88 666 666 88 86 85 84 86 666 86 84 665 663 666 665 666 667 667 666 668 672 668 666 666 84 672 83 82 84 83 84 85 672 84 82 669 671 672 672 671 668 672 82 669 671 957 668 668 957 667 669 670 671 670 678 671 671 678 957 956 667 957 678 1002 957 957 1002 1004 957 1004 956 1000 1001 1002 1002 1001 1003 1002 1003 1004 678 1000 1002 1004 1003 1005 1004 1005 1006 956 1004 1006 1005 1003 1861 1861 1003 1001 1000 999 1001 1861 1001 1865 1865 1001 999 1861 1862 1005 2081 2086 1861 2081 1861 1865 1862 1861 2086 1006 1005 1007 1005 1862 1007 1006 1007 1008 1008 1007 1009 1007 1862 1009 1008 1009 1010 955 1006 1008 955 1008 954 954 1008 1010 1010 1009 1011 1011 1009 1012 1862 1012 1009 954 1010 951 951 1010 1011 660 954 658 658 954 951 954 660 662 954 662 955 658 659 660 660 659 661 660 661 662 656 657 658 658 657 659 658 951 656 657 94 659 659 94 661 662 661 663 661 94 92 661 92 90 661 90 663 662 663 664 664 663 665 955 662 664 955 664 956 664 665 956 956 665 667 956 1006 955 91 90 92 91 92 93 1806 91 1805 1805 91 93 93 92 94 93 94 95 1805 93 1802 1802 93 95 1802 1804 1805 1805 1804 1806 1801 1800 1802 1800 1803 1802 1802 1803 1804 1802 95 1801 95 94 17 95 17 1801 17 94 96 657 96 94 16 17 18 17 96 18 1801 17 1799 1799 17 16 1799 1800 1801 1797 1798 1799 1799 1798 1800 1799 16 97 1799 97 1797 16 18 97 97 18 98 97 98 99 1797 97 99 1795 1796 1797 1797 1796 1798 1797 99 1795 2011 1798 1796 1798 2011 1800 1795 1794 1796 2011 1796 2012 2012 1796 1794 1793 1794 1795 1795 99 101 1795 101 1793 1793 1792 1794 2012 1794 2007 2007 1794 1792 2007 2010 2012 2012 2010 2013 2012 2013 2011 2007 1792 2005 2005 2009 2007 2007 2009 2010 1791 1790 1792 1791 1792 1793 2005 1792 1790 2005 1790 1789 1788 1789 1790 1788 1790 1791 1793 103 1791 1791 103 104 1791 104 106 1791 106 1788 1788 106 108 104 105 106 106 105 107 106 107 108 103 102 104 104 102 105 101 102 103 1793 101 103 101 100 102 105 102 647 647 102 649 649 102 100 99 100 101 99 98 100 649 100 651 651 100 98 648 647 649 648 649 650 650 649 651 650 651 652 652 651 653 651 98 653 653 98 18 652 653 654 654 653 655 653 18 655 952 650 652 952 652 654 953 648 650 953 650 952 654 951 952 951 1013 952 952 1013 1015 952 1015 953 654 655 656 656 951 654 951 1011 1013 1011 1012 1013 1013 1012 1014 1013 1014 1015 1015 1014 1016 1015 1016 1017 953 1015 1017 1862 1016 1014 1014 1012 1862 1017 1016 1018 1862 1018 1016 1017 1018 1019 953 1017 950 950 1017 1019 1019 1018 1020 1862 1020 1018 1019 1020 1021 950 1019 949 949 1019 1021 949 644 950 644 646 950 950 646 648 950 648 953 642 643 644 644 643 645 644 645 646 949 642 644 646 645 647 646 647 648 643 105 645 645 105 647 642 641 643 641 109 643 109 107 643 643 107 105 640 641 642 949 640 642 640 638 641 639 638 640 639 640 949 637 639 949 949 1021 637 637 638 639 637 636 638 635 636 637 634 635 637 637 1021 1023 637 1023 634 1021 1020 1022 1021 1022 1023 1023 1022 1024 634 1023 1024 1024 1022 1025 1862 1022 1020 1862 1025 1022 1024 1025 948 634 1024 631 948 1025 1026 1026 1025 1862 1864 1028 1862 1862 1028 1026 2090 1862 2086 2090 1864 1862 948 1026 1027 1027 1026 1028 948 1027 620 1027 1028 947 620 1027 947 947 1028 942 1863 942 1028 1863 1028 1864 1863 1864 2095 1863 2095 2099 942 1863 2100 2100 1863 2098 2098 1863 2099 2091 2094 2095 2091 2095 2090 2090 2095 1864 2099 2095 2094 2090 2086 2091 2091 2086 2085 2091 2085 1760 1760 2094 2091 1760 1762 2094 2099 2094 2059 2059 2094 1762 1760 1761 1762 1870 2065 1760 1760 2065 1761 1760 2085 1870 1762 1761 2059 2059 1761 2060 2059 2060 2061 2061 2099 2059 2065 2104 1761 1761 2104 2105 2060 1761 2105 1870 1871 2065 1871 2104 2065 2101 2103 2104 2101 2104 1871 2105 2104 2103 2105 2103 2106 2106 2107 2105 2105 2107 2060 1877 1876 2103 2102 1877 2103 2102 2103 2101 2106 2103 1876 2106 1876 1878 1878 1879 2106 2106 1879 2107 1876 872 1878 1878 872 1879 1879 872 871 1879 871 2107 871 872 873 873 872 874 874 872 875 1876 875 872 850 871 873 2107 871 2108 871 850 2108 850 873 853 853 873 874 850 851 852 850 853 851 852 1033 850 2108 850 1033 2107 2108 2062 2062 2108 2057 2108 1033 2057 517 519 1033 2058 1033 519 2057 1033 2058 1033 852 517 2057 2058 516 2063 2062 2057 2063 2057 2064 2064 2057 516 516 2058 519 516 519 517 516 517 518 1031 516 1032 1031 2098 516 516 2098 2064 1032 516 518 2064 2098 2063 2061 2062 2063 2061 2063 2098 2098 2099 2061 1031 2100 2098 1031 1032 940 940 2100 1031 940 942 2100 940 941 942 618 941 940 618 940 1032 947 942 1029 946 1029 942 946 942 941 618 617 941 941 617 614 941 614 946 614 613 946 946 613 625 946 625 947 947 1029 946 625 623 947 947 623 620 624 623 625 624 625 626 626 625 613 613 614 615 626 613 615 615 614 616 616 614 617 616 617 618 616 140 615 616 618 2826 2826 140 616 615 140 138 615 138 136 615 136 626 139 138 140 139 140 141 141 140 142 2826 142 140 137 136 138 137 138 139 134 135 136 134 136 137 626 136 135 500 134 137 500 137 502 502 137 139 498 499 500 498 500 501 501 500 502 500 499 1851 1851 134 500 501 502 503 139 503 502 501 503 507 501 605 498 507 605 501 605 603 498 498 603 499 603 604 499 605 604 603 606 604 605 608 606 605 608 605 507 507 503 504 507 504 497 497 608 507 139 504 503 504 505 506 497 504 506 593 505 504 593 504 139 495 496 497 497 506 495 496 608 497 607 606 608 496 607 608 609 607 496 496 495 2707 2707 609 496 2707 495 2685 2685 495 506 2685 506 2686 2686 506 505 2633 2685 2607 2607 2685 2686 2633 2707 2685 2634 3 2707 2634 2707 2633 3 609 2707 2607 2608 2633 2633 2608 2603 2633 2603 2629 2607 2557 2608 2608 2557 2558 2608 2558 2603 2545 2566 2603 2603 2566 2597 2603 2558 2545 2603 2597 2629 2557 2546 2558 2558 2546 2545 2555 2556 2557 2557 2556 2546 2607 2555 2557 2606 2556 2555 2606 2555 2607 2605 2546 2556 2605 2556 2606 2607 2686 2606 2606 2686 2687 2606 2687 2605 2604 2546 2605 2605 2687 2688 2605 2688 2604 2687 2759 2760 2687 2760 2688 2787 2687 2686 2787 2759 2687 2787 2686 2788 2686 505 2788 2788 2808 2787 2787 2808 2759 2759 144 146 2760 2759 146 2808 144 2759 2760 146 2761 2688 2760 2761 144 143 146 146 143 147 146 147 148 2761 146 148 143 144 145 2808 145 144 145 142 143 2825 147 143 2825 143 2826 2826 143 142 148 147 149 147 2824 149 2824 147 2825 148 149 150 148 150 2761 150 149 151 149 2824 2823 149 2823 151 2716 2823 2824 2716 2824 2825 2714 2822 2823 2714 2823 2716 151 2823 153 153 2823 2822 150 151 152 152 151 153 2761 150 152 153 154 152 152 154 156 152 156 164 2761 152 2762 2762 152 164 153 2822 154 154 155 156 154 2822 2821 154 2821 155 155 157 156 155 2821 157 2821 2711 2820 2711 2821 2712 2712 2821 2822 157 2821 2820 156 157 158 157 2820 158 156 158 159 158 160 159 158 2820 160 159 160 161 159 161 162 156 159 1034 1034 159 162 160 2820 161 2710 2818 2820 2820 2711 2710 161 2820 2818 2709 2708 2710 2709 2710 2711 2708 2818 2710 2818 2708 2819 161 2818 242 242 2818 2819 852 851 2708 852 2708 2709 851 734 2708 2819 2708 734 2819 734 735 242 2819 735 241 161 242 241 242 243 735 243 242 734 733 735 733 243 735 732 733 734 734 736 732 734 851 736 851 853 736 732 736 737 737 736 738 736 853 738 737 248 732 732 248 733 733 248 245 733 245 243 245 246 243 245 248 246 243 246 247 246 248 249 246 249 250 250 247 246 249 248 250 250 248 251 739 251 248 739 248 737 737 738 739 738 740 739 739 740 741 741 253 739 739 253 251 250 251 252 252 251 253 252 253 254 254 253 255 741 255 253 741 740 742 741 742 743 743 255 741 254 255 256 256 255 257 743 257 255 743 742 744 743 744 745 745 259 743 743 259 257 256 257 258 258 257 259 254 256 1971 1971 256 258 258 259 260 1971 258 260 260 259 261 261 259 262 747 262 259 747 259 745 745 744 746 745 746 747 744 742 746 746 748 747 742 877 746 746 877 879 746 879 748 747 748 749 749 262 747 749 748 750 748 879 880 748 880 750 877 878 879 879 878 880 876 875 877 877 875 878 742 876 877 740 876 742 874 875 876 740 874 876 1876 878 875 880 878 881 881 878 1876 880 881 882 750 880 882 882 881 883 1876 883 881 882 883 884 750 882 753 753 882 884 884 883 885 1876 885 883 884 885 886 753 884 757 757 884 886 886 885 887 1876 887 885 886 887 888 757 886 854 854 886 888 756 755 757 756 757 758 755 753 757 758 757 854 754 753 755 754 755 756 751 753 754 756 273 754 754 273 270 754 270 269 754 269 267 267 751 754 270 273 272 272 273 274 756 274 273 268 269 270 268 270 271 271 270 272 267 269 268 266 267 268 268 271 266 266 265 267 749 751 267 267 265 749 264 262 265 264 265 266 749 265 262 749 750 751 751 750 752 752 750 753 751 752 753 261 262 263 263 262 264 1881 263 264 1881 264 266 1881 261 263 260 261 1881 1880 1881 266 260 1881 1970 1881 1974 1972 1881 1972 1970 1881 1880 1974 260 1970 1971 1970 1972 1973 1973 250 1970 1970 250 254 1970 254 1971 1974 1979 1972 1972 1979 1978 1972 1978 1973 534 250 1973 1973 1978 534 1978 1979 1980 557 534 1978 1978 1980 557 1980 1979 1977 1974 1977 1979 557 1980 1981 1977 1982 1980 1980 1982 1981 538 534 557 538 557 553 557 1981 553 534 533 250 533 534 538 526 533 530 250 533 526 538 540 533 540 530 533 526 247 250 250 252 254 525 247 526 526 530 525 527 529 525 525 529 247 525 530 531 525 531 527 527 528 529 1035 529 1034 1034 529 166 166 529 528 1035 247 529 1034 162 1035 1035 162 163 1035 163 241 1035 241 247 166 165 1034 1034 165 156 164 156 165 165 166 164 164 166 167 528 167 166 164 167 168 2762 164 2763 2763 164 168 167 174 168 528 174 167 168 174 175 168 175 176 168 176 2763 175 174 528 176 175 177 528 177 175 171 528 524 524 528 527 171 173 528 528 173 177 176 177 178 178 177 173 2763 176 178 178 173 172 2763 178 2764 2764 178 172 171 172 173 171 170 172 2764 172 2765 2765 172 170 2695 2763 2764 2695 2764 2694 2694 2764 2765 2698 2762 2763 2698 2763 2695 2612 2697 2698 2612 2698 2695 2697 2762 2698 2697 2761 2762 2611 2688 2697 2611 2697 2612 2688 2761 2697 2546 2604 2611 2546 2611 2547 2547 2611 2612 2604 2688 2611 2545 2546 2547 2547 2559 2545 2612 2559 2547 2545 2559 2560 2612 2560 2559 2545 2560 2540 2540 2560 2541 2614 2541 2560 2614 2560 2612 2540 2541 2542 2613 2542 2541 2613 2541 2614 2695 2613 2614 2695 2614 2612 2609 2542 2613 2694 2609 2613 2694 2613 2695 2542 2548 2540 2609 2548 2542 2548 2549 2540 2549 2548 2609 2549 2609 2610 2692 2610 2609 2692 2609 2693 2693 2609 2694 2694 2765 2693 2693 2765 2766 2693 2766 2692 2691 2610 2692 2692 2766 2767 2692 2767 2691 2689 2610 2691 2691 2767 2768 2691 2768 2689 2766 188 2767 2767 188 186 2767 186 2768 2768 186 185 185 2769 2768 2689 2768 2769 184 185 186 184 186 187 187 186 188 187 188 179 179 188 189 2766 189 188 169 524 187 187 524 2791 187 2791 184 179 169 187 179 180 181 179 189 180 181 169 179 180 189 2766 2765 182 2766 2766 182 180 181 180 182 181 182 169 169 182 183 2765 183 182 170 183 2765 169 183 170 169 170 171 524 169 171 522 523 524 524 527 522 524 523 2791 527 532 522 523 522 547 547 522 532 523 547 537 523 537 2791 544 547 542 537 547 544 547 532 542 535 536 537 537 544 535 537 536 2794 2791 537 2794 184 2791 2792 2791 2794 2795 2795 2792 2791 2795 2794 2796 2796 2794 2838 2838 2794 536 2795 2796 2797 2797 2792 2795 2793 195 2792 2792 195 184 2797 2793 2792 195 196 184 184 196 185 190 194 195 195 194 196 2793 2339 195 2339 190 195 196 2769 185 194 2769 196 190 193 194 193 2771 194 194 2771 2769 190 191 192 192 193 190 191 190 2339 2339 2340 201 2339 201 191 2340 2339 2793 201 202 191 191 202 192 192 2770 2771 192 2771 193 192 202 2770 201 200 202 2770 202 200 2770 200 2772 2699 2771 2770 2699 2770 2700 2700 2770 2772 199 198 200 199 200 201 2772 200 198 2772 198 2773 2700 2772 2701 2701 2772 2773 2616 2699 2700 2616 2700 2618 2618 2700 2701 2616 2552 2540 2616 2540 2615 2618 2553 2616 2616 2553 2552 2615 2699 2616 2617 2554 2618 2618 2554 2553 2618 2701 2617 2552 2553 2545 2545 2553 2554 2545 2540 2552 2540 2549 2550 2540 2550 2551 2615 2540 2551 2610 2550 2549 2610 2551 2550 2615 2551 2610 2610 2689 2615 2615 2689 2699 2689 2769 2771 2689 2771 2699 2543 2544 2545 2554 2561 2545 2545 2561 2543 2545 2544 2565 2545 2565 2566 2619 2543 2561 2619 2544 2543 2620 2565 2544 2620 2544 2619 2619 2561 2617 2617 2701 2619 2619 2701 2702 2619 2702 2703 2619 2703 2620 2617 2561 2554 2620 2703 2704 2702 2775 2703 2703 2775 2776 2703 2776 2704 2701 2774 2702 2702 2774 2775 2701 2773 2774 2773 197 2774 197 203 2774 2774 203 205 2774 205 2775 2775 205 2776 205 210 2776 2776 210 208 203 204 205 205 204 210 197 199 203 203 199 206 203 206 204 197 198 199 2773 198 197 206 199 201 201 2340 2341 201 2341 206 2371 2341 2340 2371 2340 2373 2373 2340 2793 206 2341 2342 2369 2342 2341 2369 2341 2371 2370 2369 2371 2370 2371 2372 2372 2371 2373 2797 2798 2373 2373 2798 2372 2373 2793 2797 2429 2370 2372 2429 2372 2427 2427 2372 2798 2368 2369 2370 2423 2368 2370 2423 2370 2429 2427 2428 2429 2429 2428 2430 2429 2430 2423 2428 2427 2798 2428 1290 1291 1291 2430 2428 1290 2428 1041 2798 1041 2428 2423 2430 2424 2424 2430 1291 2423 2424 2425 2425 2368 2423 2425 2424 2426 1292 2426 2424 2424 1291 1293 2424 1293 1292 2425 2426 2412 2412 2366 2425 2425 2366 2368 2412 2426 2413 2426 1292 1294 1294 2413 2426 1215 1292 1293 1215 1294 1292 1215 1293 1213 1213 1293 1291 1213 1214 1215 1217 1218 1213 1213 1218 1214 1217 1213 1221 1221 1213 1291 1221 1291 1290 1290 1041 1221 1041 1042 1043 1221 1041 1043 2837 1042 1041 2837 1041 2798 1043 1042 1431 2839 1431 1042 2837 2839 1042 2837 2798 2796 2796 2839 2837 2797 2796 2798 2838 2839 2796 2838 1587 2839 1587 1430 2839 1430 1431 2839 1043 1431 1225 1225 1431 1430 1229 1225 1430 1229 1430 1428 1587 1428 1430 1227 1229 1230 1230 1229 1231 1229 1428 1429 1229 1429 1231 1227 1225 1229 1589 1429 1428 1589 1428 1587 1231 1429 1427 1427 1429 1589 1587 1584 1589 1584 1590 1589 1590 1427 1589 1426 1231 1427 1590 1426 1427 1584 1591 1590 1591 1610 1590 1610 1426 1590 1424 1233 1426 1426 1233 1231 1610 1424 1426 1609 1425 1610 1610 1425 1424 1591 1609 1610 1581 1591 1584 1581 1592 1591 1591 1592 1609 1423 1422 1609 1609 1422 1421 1609 1421 1425 1592 1423 1609 1424 1425 1233 1233 1425 1421 1421 1422 1233 1233 1422 1423 1233 1423 1419 1419 1423 1420 1592 1420 1423 1416 1415 1419 1416 1419 1420 1237 1233 1419 1237 1419 1103 1103 1419 1415 1592 1416 1420 1415 1416 1417 1418 1417 1416 1418 1416 1592 1415 1417 1413 1413 1417 1418 1103 1415 1100 1100 1415 1413 1100 1102 1103 1102 1238 1103 1103 1238 1237 1100 1101 1102 1102 1570 1238 1101 1570 1102 2120 1557 1101 1101 1557 1556 1101 1556 1570 2120 1101 1100 1570 1556 1555 1570 1555 1571 1238 1570 1571 1437 1555 1556 1437 1556 1557 1557 1558 1437 2120 1558 1557 2119 1558 2120 2120 1100 2119 1437 1558 1559 1111 1559 1558 1111 1558 2119 2119 1100 1111 1105 1110 1100 1100 1110 1111 1100 1413 1105 2118 1559 1111 2118 1111 1110 1437 1559 1471 2118 1471 1559 1109 1471 2118 2118 1110 1109 1105 1109 1110 1104 1109 1105 1104 1471 1109 1471 1472 1437 1104 1472 1471 1104 1105 1106 2117 1472 1104 1104 1106 2117 1437 1472 1473 2117 1473 1472 2149 1473 2117 2117 1106 1108 2117 1108 2149 1106 1105 1107 1106 1107 1108 1107 1113 1108 2149 1108 2148 2148 1108 1113 2148 1511 2149 2149 1511 1473 1473 1511 1437 1437 1511 1512 2148 1512 1511 2147 1512 2148 2148 1113 2147 1437 1512 1513 2147 1513 1512 2146 1513 2147 2147 1113 2146 1513 1514 1437 2146 1514 1513 2145 1514 2146 2146 1113 1116 2146 1116 2145 1437 1514 1515 2145 1515 1514 2145 1116 1115 2145 1115 1515 1112 1115 1116 1112 1116 1113 1114 1115 1112 1114 1118 1115 1515 1115 1118 1437 1515 1516 1118 1516 1515 1117 1118 1114 1117 1121 1118 2144 1516 1118 2144 1118 1121 1112 1405 1114 1114 1405 1403 1114 1403 1117 1119 1121 1117 1117 1403 1399 1117 1399 1119 1402 1399 1403 1402 1403 1404 1404 1403 1405 1404 1405 1406 1406 1405 1407 1112 1407 1405 2203 1402 1404 2203 1404 2197 2197 1404 1406 1400 1399 1402 1400 1402 2203 1399 1400 1401 2264 1401 1400 2264 1400 2203 1399 1401 1397 1397 1401 1398 1398 1401 2264 2207 1398 2264 2207 2264 2201 2201 2264 2203 1397 1398 1395 1395 1398 1396 2205 1396 1398 2205 1398 2207 2206 2205 2207 2206 2207 2200 2200 2207 2201 2200 2201 2202 2202 2201 2203 2202 1930 2200 2200 1930 1932 2200 1932 2206 2204 2205 2206 2206 1932 1934 2206 1934 2204 1930 1931 1932 1932 1931 1933 1932 1933 1934 1928 1929 1930 1930 1929 1931 2202 1928 1930 1929 1912 1931 1931 1912 1914 1931 1914 1933 1934 1933 1935 1933 1914 1909 1933 1909 1935 1912 284 1914 1914 284 1915 1914 1915 1909 1912 1913 284 1913 1912 1916 1929 1916 1912 1913 1916 275 2109 1913 275 284 1913 2109 275 1916 1917 1927 1917 1916 1927 1916 1929 275 1917 271 271 1917 1918 1925 1918 1917 1925 1917 1927 1926 1925 1927 1926 1927 1928 1928 1927 1929 1924 1923 1925 1924 1925 1926 1923 1918 1925 271 1918 266 266 1918 1880 1923 1880 1918 271 272 275 272 274 275 275 274 276 276 2109 275 274 277 276 756 277 274 276 277 278 276 278 279 276 279 2109 2109 279 280 2109 280 282 2109 282 284 279 278 280 280 278 281 280 281 282 762 281 278 762 278 759 759 278 277 759 277 756 756 758 759 758 760 759 759 760 761 759 761 762 758 854 760 760 854 761 762 761 763 761 854 763 763 854 855 854 888 855 762 763 764 763 855 764 764 855 766 855 888 890 855 890 766 888 887 889 888 889 890 890 889 891 890 891 892 766 890 892 891 889 1876 1876 889 887 892 891 893 893 891 894 1876 894 891 766 892 856 856 892 893 893 894 895 893 895 896 856 893 857 857 893 896 1877 895 894 1877 894 1876 896 895 897 1877 897 895 896 897 898 857 896 858 858 896 898 898 897 899 899 897 1877 1875 901 1877 1877 901 899 2102 1875 1877 898 899 900 900 899 901 858 898 778 778 898 900 776 857 858 776 858 778 777 776 778 777 778 779 779 778 780 780 778 859 778 900 859 900 901 902 859 900 902 780 859 782 782 859 860 859 902 860 779 780 781 781 780 782 781 782 783 782 784 783 782 860 784 784 860 785 785 860 861 860 902 903 860 903 861 902 901 903 903 901 904 903 904 905 861 903 905 1875 904 901 905 904 906 906 904 907 1875 907 904 861 905 862 862 905 906 906 907 908 862 906 908 908 907 909 1875 909 907 908 909 910 862 908 863 863 908 910 910 909 911 1874 909 1875 1874 911 909 910 911 912 863 910 864 864 910 912 797 862 863 797 863 798 798 863 864 798 864 800 800 864 801 801 864 803 864 912 803 796 797 798 796 798 799 799 798 800 796 795 797 795 862 797 794 793 795 794 795 796 793 862 795 791 861 862 791 862 793 792 791 793 792 793 794 788 790 791 788 791 792 790 861 791 785 861 787 787 861 789 789 861 790 788 789 790 788 787 789 786 785 787 786 787 788 314 788 316 316 788 792 788 314 786 783 785 786 786 314 313 786 313 783 783 784 785 783 313 309 783 309 781 311 312 313 310 309 313 310 313 312 313 314 311 311 314 315 1898 312 311 1898 311 1900 311 315 1900 310 312 1904 1904 312 1898 308 309 310 1902 308 310 1902 310 1904 1903 1902 1904 1903 1904 1897 1897 1904 1898 1897 1898 1899 1899 1898 1900 2265 1903 1897 2265 1897 2266 2266 1897 1899 1901 1902 1903 1901 1903 2265 1943 1901 2265 1943 2265 1945 1945 2265 2266 2266 1899 2267 1945 2266 1947 1947 2266 2267 1899 1900 1883 2267 1899 1883 2267 1883 1951 1947 2267 1949 1949 2267 1951 1946 1945 1947 1946 1947 1948 1948 1947 1949 1948 1949 1950 1950 1949 1951 1948 1950 2217 2213 1946 1948 2213 1948 2219 2219 1948 2217 1944 1945 1946 2215 1944 1946 2215 1946 2213 2213 2214 2215 2219 2220 2213 2213 2220 2214 2217 2218 2219 2219 2218 2220 2218 1268 2220 1268 1270 2220 2220 1270 1272 2220 1272 2214 2215 2214 2216 2214 1272 2216 2215 2216 2194 2194 1944 2215 2194 2216 1256 1272 1260 2216 2216 1260 1258 2216 1258 1256 1270 1271 1272 1272 1271 1261 1272 1261 1260 1259 1258 1260 1259 1260 1261 1257 1256 1258 1257 1258 1259 2249 1257 1259 2249 1259 1261 1261 2248 2249 1271 2248 1261 1270 1269 1271 1269 2248 1271 1269 2251 2248 2252 2249 2248 2252 2248 2253 2253 2248 2251 2247 1257 2249 2247 2249 2252 2187 2247 2252 2187 2252 2253 2253 2251 2189 2187 2253 2188 2188 2253 2189 2180 2181 2187 2180 2187 2188 2181 2247 2187 2180 2188 2189 2189 2251 2250 2189 2250 2254 2189 2254 2180 2178 2179 2180 2180 2179 2181 2178 2180 2254 2181 2179 2247 2178 2177 2179 2179 2177 2246 2247 2179 2246 2176 2177 2178 2178 2254 2176 2176 2254 1280 2254 2250 1280 2174 2175 2176 2176 2175 2177 2176 1280 2174 2177 2175 1252 2246 2177 1252 2174 2173 2175 1252 2175 2173 2172 2173 2174 2174 2184 2172 2174 1280 2184 1252 2173 2172 2172 2184 2185 2172 2185 1254 1252 2172 1254 2184 1280 2185 2186 1254 2185 2185 1280 1277 2185 1277 1276 2185 1276 2186 1276 2170 2186 2186 2170 1254 1276 1277 1278 1278 1275 1276 1276 1275 2156 1276 2156 2170 1278 1277 1279 1277 1280 1279 1279 1280 1262 1262 1280 1263 2250 1263 1280 1262 1263 1264 1262 2223 1279 1262 1264 2223 1264 1263 1265 2250 1265 1263 1265 2250 1267 1267 2250 2251 1264 1265 1266 1266 1265 1267 2223 1264 1266 1266 1267 1268 2223 1266 2218 2218 1266 1268 1268 1267 1269 1267 2251 1269 1268 1269 1270 2217 2223 2218 2222 2223 2217 2217 1950 1952 2217 1952 2222 2221 1279 2222 2222 1279 2223 2222 1952 1954 2222 1954 2221 1950 1951 1952 1952 1951 1953 1952 1953 1954 1954 1953 1955 1954 1955 1956 2221 1954 1956 1951 1882 1953 1953 1882 1893 1953 1893 1955 1951 1883 1882 1882 1883 1884 1884 324 1882 1882 324 1894 1882 1894 1893 1893 1894 1895 1955 1893 1895 1895 1894 1896 324 325 1894 325 327 1894 1894 327 328 1896 1894 328 1895 1896 1891 1955 1895 1957 1957 1895 1891 1891 334 1892 1891 1896 334 1957 1891 1959 1959 1891 1892 1956 1955 1957 1956 1957 1958 1958 1957 1959 1958 1959 1960 1960 1959 1961 1959 1892 1961 1892 334 337 1892 337 1890 1961 1892 1890 1960 1961 1962 1962 1961 1963 1961 1890 1963 2224 1958 1960 2224 1960 2230 2230 1960 1962 1962 1963 1964 2230 1962 2229 2229 1962 1964 1964 1963 1965 1963 1890 1889 1963 1889 1965 1964 1965 1966 2229 1964 2232 2232 1964 1966 2227 2228 2229 2229 2228 2230 2227 2229 2232 2227 2232 2233 2233 2232 2234 2232 1966 2234 1966 1965 1967 1966 1967 1921 2234 1966 1921 2233 2234 1374 1374 2234 2235 2234 1921 2235 1919 1920 1921 1921 1967 1968 1921 1968 1919 2235 1921 1920 1374 2235 2192 2192 2235 2236 2235 1920 2236 1919 1991 1920 2236 1920 1991 2192 2236 2190 2241 2190 2236 2236 1991 2241 2190 2191 2192 1374 2192 1375 1375 2192 2191 2243 2191 2190 2243 2190 2241 2241 2242 2243 2241 1991 1992 2241 1992 2242 1919 1989 1991 1989 1992 1991 1987 1992 1989 2245 2242 1992 2245 1992 1987 2243 2242 2244 2244 2242 2245 2243 2244 2191 1608 2244 2245 1608 1367 2244 2244 1367 1369 2244 1369 2191 1608 2245 570 570 2245 1987 570 571 572 1606 1608 570 570 572 1606 1987 571 570 572 571 573 573 574 572 1606 572 574 1606 1603 1596 1596 1608 1606 1606 574 1603 573 579 574 1603 574 579 1603 1604 1596 1603 579 1604 573 578 579 579 578 575 1604 579 575 1596 1604 1605 575 1605 1604 575 576 577 576 575 578 577 1602 575 575 1602 1605 576 578 573 582 583 576 576 583 577 586 587 576 576 587 582 573 592 576 576 592 561 576 561 586 582 581 583 577 583 581 581 1602 577 580 581 582 580 1599 581 581 1599 1602 580 582 584 1599 580 1601 584 1601 580 1598 1593 1599 1599 1600 1598 1600 1599 1601 1593 1602 1599 1600 1349 1348 1600 1348 1598 1600 1601 2840 1349 1600 2840 1347 1348 1349 1347 1349 1345 1345 1349 1346 1349 2840 1346 1348 1347 1350 1348 1350 1598 1350 1347 1351 1177 1351 1347 1177 1347 1179 1179 1347 1345 1345 1346 1343 1179 1345 1181 1181 1345 1343 1343 1346 1344 1346 2840 1344 1342 1341 1343 1342 1343 1344 1181 1343 1184 1184 1343 1341 2843 1342 1344 2804 2843 1344 2804 1344 2840 1339 1341 1342 1339 1342 2843 2842 1339 2843 2842 2843 2804 1339 1340 1341 1339 2434 2435 1339 2435 1340 2434 1339 2842 2804 2803 2842 2842 2803 2410 2842 2410 2434 2435 2434 2436 2434 2410 2408 2434 2408 2436 2435 2436 2437 2437 1340 2435 2437 2436 2438 2436 2408 2406 2436 2406 2438 2407 2406 2408 2407 2408 2409 2409 2408 2410 2409 2410 2802 2802 2410 2803 2409 2388 2389 2409 2389 2407 2802 2388 2409 2405 2406 2407 2407 2389 2386 2407 2386 2405 2405 2404 2406 2438 2406 2404 2403 2404 2405 2405 2386 2387 2405 2387 2403 2386 440 2387 2389 436 2386 2386 436 440 2388 431 2389 2389 431 436 431 435 436 436 435 437 436 437 438 436 438 440 430 435 431 2747 437 435 2747 435 2748 2748 435 430 438 437 439 439 437 2747 438 439 440 440 439 441 2746 441 439 2746 439 2747 2680 2746 2747 2680 2747 2679 2679 2747 2748 2748 430 2749 2679 2748 2678 2678 2748 2749 2678 2583 2679 2679 2583 2582 2679 2582 2680 2680 2582 2581 2680 2581 2681 2681 2746 2680 2527 2581 2582 2527 2582 2528 2528 2582 2583 2528 2583 2529 2529 2583 2584 2678 2584 2583 2510 2527 2528 2528 2529 2510 2524 2527 2510 2524 2581 2527 2524 2580 2581 2581 2580 2681 2510 2523 2524 2523 2580 2524 2523 2579 2580 2681 2580 2682 2580 2579 2682 2515 2523 2510 2515 2579 2523 2515 2578 2579 2682 2579 2578 2682 2578 2683 2683 2744 2682 2682 2744 2745 2682 2745 2681 2683 2578 2684 2684 2743 2683 2683 2743 2744 2743 446 2744 2744 446 444 2744 444 2745 445 444 446 445 446 447 446 453 447 2743 453 446 442 443 444 442 444 445 444 443 2745 440 441 442 441 443 442 442 445 440 2745 443 441 2745 441 2746 2681 2745 2746 2387 440 445 2387 445 2375 2403 2387 2375 2374 2375 2376 2375 445 2376 2403 2375 2401 2401 2375 2374 2401 2402 2403 2403 2402 2404 2399 2400 2401 2401 2400 2402 2401 2374 2399 2439 2404 2402 2439 2402 2441 2441 2402 2400 2438 2404 2439 2437 2438 2439 2437 2439 2440 2440 2439 2441 2431 2433 2441 2441 2433 2440 2441 2400 2431 2399 2398 2400 2431 2400 2398 2431 2432 2433 2431 2398 2432 2397 2396 2398 2397 2398 2399 2432 2398 2396 2444 2445 2432 2432 2445 2433 2432 2396 2444 2395 2394 2396 2395 2396 2397 2444 2396 2394 2442 2443 2444 2444 2443 2445 2444 2394 2442 1328 2445 2443 2445 1328 1330 1330 2433 2445 2442 2449 2443 2443 2449 1325 2443 1325 1329 2443 1329 1328 1327 1328 1329 1328 1327 1330 1330 1327 1331 1330 1331 1332 1332 2433 1330 1327 1329 1324 1197 1331 1327 1197 1327 1049 1049 1327 1324 1324 1329 1325 1324 1325 1321 1049 1324 1199 1199 1324 1321 1047 1048 1049 1049 1048 1197 1047 1049 1198 1198 1049 1199 1198 1199 1200 1200 1199 1086 1199 1321 1086 2484 1047 1198 2484 1198 2485 2485 1198 1200 2483 1048 1047 2483 1047 2484 2482 1197 1048 2482 1048 2483 2484 1492 2483 2483 1492 1491 2483 1491 2482 2485 1493 2484 2484 1493 1492 1491 1492 1490 1490 1492 1493 1490 1489 1491 2482 1491 1489 2481 1197 2482 2482 1489 2481 1434 1489 1490 2481 1489 1434 2480 1196 2481 2481 1196 1197 2481 1434 2480 2479 1050 2480 2480 1050 1196 2480 1434 1461 2480 1461 2479 1050 1052 1196 1196 1052 1197 1050 1051 1052 2479 1051 1050 2478 1051 2479 2479 1461 1460 2479 1460 2478 1433 1460 1461 1433 1461 1434 1446 1460 1433 2478 1460 1446 2478 1195 1051 2478 1446 1195 1052 1051 1194 1194 1051 1195 1194 1195 1192 2477 1192 1195 1195 1446 1445 1195 1445 2477 1445 1446 1433 1433 1488 1445 2477 1445 1488 2477 1488 1192 1433 1487 1488 1192 1488 1487 1484 1487 1433 1192 1487 2476 2476 1487 1484 1484 1433 1485 2476 1484 1193 1193 1484 1485 1193 1192 2476 1191 1192 1193 1191 1193 1187 1187 1193 1188 2475 1188 1193 1193 1485 2475 1485 1433 1486 2475 1485 1486 2474 1188 2475 2475 1486 2474 1187 1188 1189 2473 1189 1188 2473 1188 2474 2474 1486 1526 2474 1526 2473 1433 1526 1486 1433 1525 1526 2473 1526 2472 2472 1526 1525 2472 1189 2473 1187 1189 1184 1184 1189 1190 2472 1190 1189 2471 1185 2472 1185 1190 2472 2472 1525 2471 1483 1525 1433 2471 1525 1483 2471 1483 1186 1186 1185 2471 1184 1185 1181 1181 1185 1186 1184 1190 1185 1184 1341 1187 1341 1340 1337 1187 1341 1337 1187 1337 1191 1337 1338 1335 1337 1340 1338 1191 1337 1335 1338 1340 2437 1335 1338 1336 1338 2437 1336 1335 1336 1333 1191 1335 1194 1194 1335 1333 1192 1191 1194 1194 1333 1052 1332 1331 1333 1332 1333 1334 1333 1336 1334 1052 1333 1331 1052 1331 1197 1332 1334 2433 2433 1334 1336 1336 2440 2433 2437 2440 1336 1186 1483 2827 2827 1181 1186 1433 1482 1483 2827 1483 1482 2827 1482 2828 2828 1181 2827 1181 1182 1179 2828 1182 1181 2828 1482 1470 2828 1470 1182 1470 1482 1433 1433 1469 1470 1182 1470 1469 1179 1182 1183 1182 1469 1183 1179 1180 1177 2831 1180 1179 2831 1179 2830 2830 1179 1183 1183 1469 2829 2830 1183 2829 1433 1468 1469 2829 1469 1468 2829 1468 2830 2830 1468 1459 2830 1459 2831 2831 1459 1458 2831 1458 1560 1560 1180 2831 1433 1458 1459 1459 1468 1433 1433 1457 1458 1560 1458 1457 1560 1457 1561 1180 1560 1178 1178 1560 1561 1444 1457 1433 1561 1457 1444 1561 1444 1562 1178 1561 1562 1433 1443 1444 1562 1444 1443 1562 1443 1563 1178 1562 1563 1433 1437 1443 1563 1443 1437 1563 1437 1564 1564 1176 1563 1178 1563 1176 1564 1437 1456 1564 1456 1565 1565 1173 1564 1564 1173 1176 1175 1176 1172 1172 1176 1173 1175 1178 1176 1172 1173 1171 1171 1173 1174 1566 1174 1173 1566 1173 1565 1565 1456 1455 1565 1455 1566 1566 1455 1567 1567 1174 1566 1171 1174 1170 1567 1170 1174 1567 1455 1451 1567 1451 1568 1568 1170 1567 1451 1455 1436 1436 1455 1456 1436 1450 1451 1568 1451 1450 1568 1450 1569 1569 1170 1568 1436 1540 1450 1569 1450 1540 1569 1540 1168 1569 1168 1170 1436 1539 1540 1168 1540 1539 1053 1055 1168 1168 1055 1169 1168 1169 1170 1168 1539 1053 1524 1539 1436 1524 1053 1539 1053 1054 1055 1524 1054 1053 1436 1523 1524 1523 2115 1524 1524 2115 1054 1055 1054 1167 1054 2115 1167 1523 2114 2115 1167 2115 2114 1522 1523 1436 1522 2114 1523 1522 1163 2114 1167 2114 1163 1055 1167 1162 1162 1167 1163 1161 1162 1163 1521 1163 1522 1521 1161 1163 1436 1521 1522 1520 1521 1436 1159 1161 1521 1159 1521 1520 1159 1160 1161 1161 1160 1162 1160 1372 1162 1162 1372 1368 1162 1368 1055 1367 1366 1368 1367 1368 1369 1372 1373 1368 1368 1373 1369 1055 1368 1366 1055 1366 1169 1365 1362 1366 1365 1366 1367 1169 1366 1362 1365 1367 1608 1363 1362 1365 1608 1363 1365 1362 1363 1364 1362 1364 1360 1169 1362 1171 1171 1362 1360 1170 1169 1171 1171 1360 1172 1359 1355 1360 1359 1360 1361 1360 1364 1361 1172 1360 1355 1361 1364 1607 1607 1364 1363 1607 1363 1608 1597 1607 1596 1596 1607 1608 1597 1361 1607 1597 1359 1361 1596 1595 1597 1595 1611 1597 1611 1359 1597 1593 1595 1596 1596 1605 1593 1593 1594 1595 1594 1611 1595 1594 1353 1611 1353 1358 1611 1611 1358 1357 1611 1357 1359 1353 1354 1355 1355 1358 1353 1594 1354 1353 1357 1358 1355 1357 1355 1359 1355 1354 1356 1355 1356 1351 1172 1355 1175 1175 1355 1351 1356 1354 1594 1351 1356 1352 1598 1352 1356 1598 1356 1594 1350 1351 1352 1175 1351 1177 1177 1178 1175 1177 1180 1178 1598 1350 1352 1594 1593 1598 1593 1605 1602 2191 1369 1373 2191 1370 1375 1371 1370 2191 2191 1373 1371 1372 1371 1373 1370 1371 1372 1372 1375 1370 1374 1375 1376 1376 1375 1372 1160 1376 1372 1374 1376 1377 1377 1376 1378 1158 1378 1376 1158 1376 1160 1374 1377 2233 1377 1378 1379 2233 1377 1379 1379 1378 1380 1058 1380 1378 1058 1378 1158 1379 1380 1381 2233 1379 2262 2262 1379 1381 2262 2227 2233 2262 1381 1383 2262 1383 2228 2262 2228 2227 1380 1383 1381 1382 1383 1380 1382 1385 1383 2228 1383 1385 2230 2228 2231 2228 1385 2231 1384 1385 1382 1384 1388 1385 2231 1385 1388 1153 1384 1382 1153 1382 1155 1155 1382 1380 1386 1388 1384 1149 1386 1384 1149 1384 1153 1152 1149 1153 1152 1153 1154 1154 1153 1155 1149 1150 1151 1149 1151 1144 1150 1149 1152 1144 1386 1149 2127 1150 1152 2127 1152 2128 2128 1152 1154 2125 1151 1150 2125 1150 2126 2126 1150 2127 1144 1151 1145 2124 1145 1151 2124 1151 2125 1478 2124 2125 1478 2125 1552 1552 2125 2126 1552 2126 1538 1538 2126 2127 1533 1478 1552 1533 1552 1538 1476 1477 1478 1535 1476 1478 1535 1478 1533 1477 2124 1478 1477 2123 2124 2123 1145 2124 1476 2123 1477 1551 1476 1535 1476 2122 2123 1476 1551 2122 1533 1534 1535 2122 1551 1535 2122 1535 2130 2130 1535 1534 2130 1146 2122 2122 1146 1145 2122 1145 2123 2130 1534 1148 1148 1147 2130 2130 1147 1146 1148 1534 2131 2131 1534 1533 1139 1147 1148 1139 1148 1140 2131 1140 1148 1143 1146 1147 1143 1147 1139 1145 1146 1143 1143 1144 1145 1139 1282 1143 1143 1282 1283 1283 1274 1143 1143 1274 1273 1143 1273 1144 1144 1273 1386 1273 1274 1275 1389 1386 1273 1389 1273 1278 1278 1273 1275 1274 2156 1275 1283 2158 1274 1274 2158 2156 1242 2155 2156 1242 2156 2157 2157 2156 2158 2156 2155 2170 2158 2159 2157 1283 2159 2158 2157 2159 1283 2157 1283 2160 2160 1244 2157 2157 1244 1242 2160 1283 2161 1282 2161 1283 2160 2161 2162 2162 1239 2160 2160 1239 1244 1127 1242 1244 1127 1244 1132 1132 1244 1239 1242 1127 1243 1242 1243 2155 1245 1246 1243 1127 1245 1243 1243 1246 2155 2170 2155 2171 1246 2171 2155 1254 1246 1253 1253 1246 1245 1254 2182 1246 1246 2182 2171 2171 2182 2170 2170 2182 2183 2170 2183 1254 1253 1252 1254 1254 2183 2182 1251 1252 1253 1253 1245 1390 1253 2212 1251 1253 1390 2212 1251 1250 1252 1250 2246 1252 1249 1248 1250 1249 1250 1251 1250 1248 2246 1247 2246 1248 2246 1247 1255 2246 1255 2247 1247 1248 1249 1247 1249 1255 1255 1249 1256 1256 1249 1251 1255 1256 1257 2247 1255 1257 2193 2194 1256 1256 1251 2193 2193 1942 2194 2194 1942 1944 1940 1941 1942 1942 1941 1943 1942 1943 1944 2193 1940 1942 1944 1943 1945 1941 1901 1943 1940 1939 1941 1939 1907 1941 1941 1907 1901 1907 1908 1901 1901 1908 1902 1905 1906 1907 1907 1906 1908 1939 1905 1907 1938 1937 1939 1938 1939 1940 1937 1905 1939 1906 1905 2110 2110 1905 1911 1937 1911 1905 1936 1935 1937 1936 1937 1938 1935 1911 1937 1909 1910 1911 2110 1911 1910 1935 1909 1911 1934 1935 1936 2204 1934 1936 2204 1936 2210 2210 1936 1938 2210 2211 2204 2204 2211 2205 2208 2209 2210 2210 2209 2211 2210 1938 2208 2193 2212 2208 2208 2212 2209 2208 1938 1940 2208 1940 2193 2212 1391 2209 2209 1391 1392 2209 1392 2211 2193 1251 2212 2212 1390 1391 1390 1245 1391 1391 1245 1392 1392 1245 1393 1392 1393 1394 2211 1392 1394 1127 1393 1245 1394 1393 1395 1124 1395 1393 1124 1393 1127 1394 1395 1396 2211 1394 1396 1396 2205 2211 1123 1397 1395 1123 1395 1124 1122 1119 1123 1124 1125 1123 1123 1125 1126 1123 1126 1122 1119 1397 1123 1119 1399 1397 1119 1120 1121 1120 1119 1122 1120 1122 1442 1442 1122 1126 2142 1462 1126 1126 1462 1442 2142 1126 1125 1441 1442 1437 1437 1442 1462 1120 1442 1441 1120 1441 2143 2143 1121 1120 1437 1518 1441 2143 1441 1518 2143 1518 1121 1121 1518 1517 1121 1517 2144 1437 1517 1518 1516 1517 1437 2144 1517 1516 1435 1436 1437 1438 1439 1437 1437 1439 1440 1438 1437 1433 1440 1447 1437 1437 1447 1448 1437 1448 1449 1436 1456 1437 1437 1462 1463 1463 1474 1437 1437 1474 1475 1437 1475 1435 1449 1508 1437 1437 1508 1509 1437 1509 1510 1510 1548 1437 1437 1548 1549 1437 1549 1550 1550 1555 1437 1574 1548 1510 1574 1510 1575 1575 1510 1509 1573 1549 1548 1573 1548 1574 1572 1550 1549 1572 1549 1573 1571 1555 1550 1571 1550 1572 1238 1571 1572 1238 1572 1573 1574 1235 1573 1238 1573 1235 1575 1234 1574 1574 1234 1235 1575 1509 1576 1576 1234 1575 1576 1509 1508 1576 1508 1577 1577 1232 1576 1576 1232 1234 1577 1508 1449 1577 1449 1578 1578 1230 1577 1577 1230 1232 1230 1231 1232 1231 1234 1232 1578 1227 1230 1578 1449 1448 1578 1448 1579 1579 1227 1578 1227 1228 1225 1228 1227 1579 1579 1448 1447 1579 1447 1580 1579 1580 1228 1225 1228 1223 1228 1580 2832 1228 2832 1223 1223 1224 1225 1225 1224 1043 1223 2833 1224 1223 2832 2833 1580 1440 2832 2832 1440 2833 1580 1447 1440 2833 1440 1439 2833 1439 2834 1224 2833 2834 1043 1224 1226 1224 2834 1226 1043 1226 1219 1221 1043 1219 1226 2834 2835 1226 2835 1219 2834 1439 1438 2834 1438 2835 2835 1438 1433 2835 1433 1219 1219 1220 1221 1219 1433 2836 1219 2836 1220 1220 1222 1221 1221 1222 1217 2836 1432 1220 1220 1432 1529 1220 1529 1222 2836 1433 1432 1432 1433 1434 1434 1529 1432 1507 1529 1434 1222 1529 1218 1218 1529 1507 1218 1217 1222 2508 1214 1218 1218 1507 2508 1434 1506 1507 2508 1507 1506 1506 1214 2508 1215 1214 1216 1214 1506 1216 1434 1547 1506 1216 1506 1547 1215 1216 1211 2507 1211 1216 1216 1547 2507 1211 1208 1215 1215 1208 1294 1211 1212 1208 2507 1212 1211 2506 1212 2507 2507 1547 1505 2507 1505 2506 1505 1547 1434 1434 1504 1505 2506 1505 1504 2505 1212 2506 2506 1504 2505 1208 1212 1209 2505 1209 1212 2504 1209 2505 2505 1504 1503 2505 1503 2504 1503 1504 1434 1434 1554 1503 2504 1503 1554 2503 1207 2504 2504 1207 1209 2504 1554 2503 1208 1209 1210 1210 1209 1207 1206 1205 1207 1207 1205 1210 2502 1206 1207 2502 1207 2503 2503 1554 1553 2503 1553 2502 1434 1553 1554 1546 1553 1434 1553 1546 2502 2501 1206 2502 2502 1546 1545 2502 1545 2501 1434 1545 1546 1434 1544 1545 2501 1545 1544 2500 1206 2501 1544 2500 2501 1543 1544 1434 1543 2499 1544 1544 2499 2500 2499 1204 2500 2500 1204 1206 2498 1202 2499 2499 1202 1204 1543 2498 2499 1434 1542 1543 1542 2498 1543 2497 1202 2498 1542 2497 2498 1044 1046 1202 1202 1203 1204 1046 1203 1202 2497 1044 1202 2496 1044 2497 1542 1541 2497 2497 1541 1490 2497 1490 2496 1434 1541 1542 1490 1541 1434 1490 1493 1494 1499 1502 1490 1494 1527 1490 1490 1527 1528 1490 1528 1499 2496 1490 1502 2485 1494 1493 2486 1527 1494 2486 1494 2485 2487 1528 1527 2487 1527 2486 2488 1499 1528 2488 1528 2487 2486 1200 2487 2487 1200 2488 2485 1200 2486 1200 1086 1060 1200 1060 2488 2488 1060 1059 2488 1059 2489 2489 1499 2488 1059 1060 1061 1061 1060 1082 1060 1086 1082 1061 1083 1059 2489 1059 1083 2489 1083 1500 2489 1500 1499 1495 1499 1500 1495 1501 1499 1499 1501 1502 1495 1500 1496 1500 1083 1077 1500 1077 2490 2490 1496 1500 1061 1077 1083 1077 1078 1079 1077 1079 1080 1080 1081 1077 1078 1077 1061 2490 1077 1081 2490 1081 1073 1073 1496 2490 1080 1073 1081 1072 1073 1080 1072 1080 5667 1079 5667 1080 1072 1071 1073 1073 1071 2491 2491 1498 1073 1073 1498 1496 1070 1071 1072 5667 5666 1072 1072 5666 1070 1070 1069 1071 2491 1071 1069 2491 1069 2492 2492 1497 2491 2491 1497 1498 1497 1496 1498 1495 1496 1497 2492 1495 1497 2492 1069 1075 2492 1075 1074 2492 1074 2493 2493 1495 2492 2494 1501 1495 2494 1495 2493 2493 1074 1062 2493 1062 2494 1062 1074 1063 1063 1074 1075 1063 1075 1076 1076 1075 1069 1062 1063 1064 5590 5665 1063 1063 5665 1064 1063 1076 5590 1062 1064 1067 1062 1067 1201 2494 1062 1201 1065 1067 1064 1064 5665 1065 5587 5588 5665 5665 5588 1096 5665 1096 1065 5590 5587 5665 1065 1066 1067 1065 1096 1066 1066 1096 1067 1067 1096 1097 5588 5603 1096 1097 1096 5605 5605 1096 5603 5587 5511 5588 5588 5511 5603 5603 5511 5535 5535 5605 5603 5537 5604 5605 5537 5605 5535 1098 1097 5605 1098 5605 5604 1067 1097 1040 1040 1097 1098 1201 1067 1045 1045 1067 1046 1046 1067 1301 1306 1307 1067 1067 1307 1308 1067 1308 1301 1040 1039 1067 1067 1039 1309 1067 1309 1306 1046 1301 1302 1301 1308 5673 1301 5673 1302 5673 1308 1307 5673 1307 5674 5674 1307 1306 5674 1306 1309 5674 1309 5675 5675 1309 1039 1038 1039 1040 5675 1039 5676 1039 1038 5676 5625 5628 5675 5625 5675 5676 5628 5674 5675 5673 5674 5628 5627 5628 5629 5629 5628 5624 5624 5628 5625 5627 5673 5628 5624 5625 5622 5622 5625 5626 5625 5676 5626 5635 5629 5624 5635 5624 5643 5643 5624 5622 5627 5629 5635 5635 5636 5627 5652 5636 5635 5652 5635 5653 5653 5635 5643 5643 5622 5644 5653 5643 5654 5654 5643 5644 5654 5558 5653 5653 5558 5548 5653 5548 5652 5642 5636 5652 5652 5548 5546 5652 5546 5642 5547 5546 5548 5548 5558 5547 5547 5558 5559 5654 5559 5558 5654 5644 5655 5655 5559 5654 5547 5559 5555 5555 5559 5560 5655 5560 5559 5655 5644 5645 5655 5645 5656 5656 5560 5655 5555 5560 5556 5656 5556 5560 5656 5645 5646 5656 5646 5657 5657 5556 5656 5644 5617 5645 5645 5617 5619 5645 5619 5646 5646 5619 5608 5646 5608 5647 5657 5646 5647 5657 5647 5658 5658 5557 5657 5657 5557 5556 5647 5608 5607 5647 5607 5648 5658 5647 5648 5658 5648 5659 5659 5543 5658 5658 5543 5557 5542 5556 5557 5542 5557 5543 5542 5543 5544 5659 5544 5543 5659 5648 5649 5659 5649 5660 5660 5544 5659 5648 5607 5610 5648 5610 5649 5649 5610 5612 5649 5612 5650 5660 5649 5650 5660 5650 5661 5661 5554 5660 5660 5554 5544 5542 5544 5538 5538 5544 5554 5538 5554 5539 5661 5539 5554 5661 5650 5651 5661 5651 5662 5662 5539 5661 5650 5612 5614 5650 5614 5651 5651 5614 5633 5662 5651 5633 5662 5633 5663 5663 5540 5662 5662 5540 5539 5538 5539 5540 5538 5540 5541 5540 5549 5541 5663 5549 5540 5663 5633 5632 5663 5632 5630 5630 5549 5663 5632 5633 5634 5633 5614 5634 5630 5632 5631 5631 5632 1322 1322 5632 5634 5630 5631 5565 5565 5550 5630 5630 5550 5549 5541 5549 5550 5541 5550 5551 5551 5550 5552 5565 5552 5550 5553 5565 2447 5565 5553 5552 1319 5565 5631 1319 2447 5565 5551 5552 5553 5553 2447 5551 2446 2447 2448 2448 2447 2449 1319 1326 2447 2447 1326 1325 1325 2449 2447 5576 5551 2447 2447 2446 5576 2392 2391 2446 2448 2392 2446 5576 2446 2391 2448 2449 2442 2442 2392 2448 2390 2391 2392 2390 2392 2393 2393 2392 2394 2442 2394 2392 2390 2377 2391 5576 2391 5575 5575 2391 2377 2393 2379 2390 2390 2379 2377 2393 2394 2395 2395 2381 2393 2393 2381 2379 2378 2377 2379 2378 2379 2380 2380 2379 2381 2380 2381 2382 2395 2382 2381 2397 2382 2395 2380 2382 2383 2383 2382 2384 2397 2384 2382 2399 2384 2397 2374 2385 2384 2384 2385 2383 2399 2374 2384 2376 2385 2374 457 2385 2376 457 450 2385 2385 450 473 2385 473 2383 445 447 2376 2376 447 455 2376 455 457 447 453 454 447 454 455 455 454 456 455 456 457 454 2743 456 454 453 2743 457 456 458 456 2743 2742 456 2742 458 2684 2742 2743 2656 2739 2742 458 2742 2739 2656 2742 2684 457 458 448 448 458 459 458 2739 459 2738 459 2739 2655 2738 2739 2655 2739 2656 448 459 449 2738 449 459 448 449 450 457 448 450 450 449 451 2737 451 449 2737 449 2738 2650 2737 2738 2650 2738 2655 2654 2650 2655 2654 2655 2656 2648 2649 2650 2653 2648 2650 2653 2650 2654 2649 2737 2650 2649 2736 2737 2736 451 2737 2648 2651 2649 2651 2736 2649 2319 2468 2736 2319 2736 2651 2468 452 2736 2736 452 451 2648 2319 2651 2318 2319 2320 2468 2319 2318 2648 2320 2319 2318 472 2468 2468 472 474 2468 474 452 450 451 452 474 450 452 472 473 474 474 473 450 470 471 472 472 471 473 2318 470 472 2383 473 471 470 469 471 2383 471 469 468 469 470 2321 468 470 2321 470 2318 468 467 469 467 2380 469 469 2380 2383 466 467 468 2322 466 468 2322 468 2321 2318 2268 2321 2321 2268 2271 2321 2271 2322 2322 2271 2286 2322 2286 2323 2323 466 2322 2271 2272 2273 2273 2286 2271 2268 2272 2271 2273 2285 2286 2323 2286 2285 2323 2285 2324 2324 464 2323 2323 464 466 2279 2284 2285 2279 2285 2273 2324 2285 2284 2282 2279 2273 2282 2273 2287 2287 2273 2272 2275 2278 2279 2278 2284 2279 2280 2275 2279 2280 2279 2282 2324 2284 2278 2275 2277 2278 2324 2278 2316 2316 2278 2277 2274 2275 2276 2274 2277 2275 2276 2275 2280 2276 2280 2281 2281 2280 2282 2276 5578 2301 2301 5579 2276 2274 2276 5579 2274 5579 2315 2274 2315 2277 2277 2315 2316 2331 2315 2301 2301 2315 5579 5580 5581 2315 5580 2315 2331 5581 2316 2315 2303 2301 2304 2301 2303 2331 2331 2303 2332 2332 5580 2331 2304 2335 2303 2303 2335 2332 2305 2334 2304 2304 2334 2335 2469 2332 2335 2469 2335 239 239 2335 2334 5580 2332 2469 239 238 2469 5580 2469 5585 5585 2469 238 238 239 240 5585 238 5584 240 5584 238 5584 5508 5585 5585 5508 5580 5507 5508 5584 5507 5584 5509 5509 5584 5582 240 5582 5584 5507 5456 5508 5456 5507 5455 5455 5507 5509 5510 5459 5509 5509 5459 5455 5509 5582 5510 5459 5510 5504 5504 5510 5571 5510 5582 5571 5458 5455 5459 5459 5460 5458 5504 5460 5459 5488 5489 5504 5504 5489 5460 5504 5571 5488 5458 5460 5461 5489 5461 5460 5457 5455 5458 5458 5461 5457 5457 5461 5410 5489 5410 5461 5488 5431 5489 5489 5431 5410 5410 5374 5408 5431 5374 5410 5457 5410 5408 5408 5409 5457 5457 5409 5455 5408 5373 5409 5408 5374 5373 5409 5373 5406 5409 5406 5405 5405 5455 5409 5456 5455 5405 5404 5405 5406 5404 5508 5405 5405 5508 5456 5404 5406 5407 5454 5404 5407 5454 5505 5404 5404 5505 5508 5505 5580 5508 5454 5451 5505 5505 5451 5506 5506 5581 5505 5505 5581 5580 5448 5451 5452 5452 5451 5454 5506 5451 5448 5506 5448 5447 5447 5570 5506 5506 5570 5581 5581 5570 2467 2316 5581 2467 2467 460 462 2316 2467 2324 2324 2467 462 2467 5570 5586 2467 5586 460 460 461 462 5586 461 460 462 461 463 462 463 464 2324 462 464 461 475 463 5583 475 461 5583 461 5586 5586 5570 5569 5586 5569 5568 5586 5568 5583 5574 477 5583 5583 5568 5567 5583 5567 5574 477 475 5583 463 475 476 476 475 477 477 2377 2378 477 2378 476 477 5574 2377 476 2378 463 465 463 2378 2380 465 2378 464 463 465 464 465 466 466 465 467 467 465 2380 2377 5574 5575 5575 5574 5576 5478 5551 5574 5576 5574 5551 5478 5574 5494 5494 5574 5567 5551 5478 5495 5551 5495 5541 5478 5479 5495 5495 5479 5490 5495 5490 5541 5541 5490 5496 5541 5496 5538 5479 5441 5490 5490 5441 5480 5490 5480 5496 5478 5446 5479 5479 5446 5441 5441 5393 5442 5446 5392 5441 5441 5392 5393 5441 5442 5480 5480 5442 5443 5480 5443 5491 5496 5480 5491 5496 5491 5538 5491 5443 5481 5491 5481 5497 5538 5491 5497 5442 5371 5443 5443 5371 5440 5443 5440 5481 5442 5393 5371 5332 5371 5331 5331 5371 5330 5330 5371 5393 5371 5332 5394 5394 5440 5371 5394 5439 5440 5481 5440 5439 5394 5332 5370 5394 5370 5395 5395 5439 5394 5395 5438 5439 5481 5439 5482 5482 5439 5438 5395 5370 5369 5395 5369 5396 5396 5438 5395 5396 5437 5438 5482 5438 5483 5483 5438 5437 5497 5481 5482 5497 5482 5498 5498 5482 5483 5483 5437 5484 5498 5483 5499 5499 5483 5484 5542 5497 5498 5542 5498 5499 5538 5497 5542 5555 5556 5542 5499 5555 5542 5499 5484 5500 5499 5500 5555 5555 5500 5501 5555 5501 5547 5500 5484 5485 5500 5485 5501 5501 5485 5492 5501 5492 5547 5545 5546 5547 5547 5492 5502 5547 5502 5545 5485 5435 5492 5492 5435 5486 5492 5486 5502 5484 5436 5485 5485 5436 5435 5434 5435 5399 5399 5435 5436 5435 5434 5486 5486 5434 5433 5486 5433 5493 5502 5486 5493 5502 5493 5545 5493 5433 5487 5493 5487 5503 5545 5493 5503 5400 5432 5433 5400 5433 5434 5433 5432 5487 5400 5434 5399 5399 5337 5400 5400 5337 5338 5400 5338 5364 5364 5432 5400 5364 5430 5432 5487 5432 5430 5339 5364 5338 5364 5339 5401 5401 5430 5364 5337 5280 5338 5338 5280 5300 5338 5300 5339 5339 5300 5298 5339 5298 5340 5340 5363 5339 5401 5339 5363 5280 5298 5300 5280 5281 5298 5298 5281 5299 5340 5298 5299 5340 5299 5341 5341 5363 5340 5341 5401 5363 5341 5299 5296 5341 5296 5342 5342 5374 5341 5341 5374 5401 5299 5281 5296 5296 5279 5297 5296 5281 5279 5342 5296 5297 5342 5297 5295 5295 5355 5342 5374 5342 5355 5374 5355 5373 5431 5401 5374 5343 5355 5295 5373 5355 5343 5343 5295 5294 5343 5294 5344 5344 5354 5343 5373 5343 5354 5277 5276 5294 5277 5294 5295 5344 5294 5276 5344 5276 5345 5345 5354 5344 5345 5353 5354 5354 5353 5373 5345 5276 5275 5345 5275 5346 5346 5353 5345 5346 5352 5353 5373 5353 5352 5346 5275 5284 5346 5284 5316 5318 5352 5346 5316 5318 5346 5373 5352 5359 5359 5352 5318 5373 5359 5361 5361 5389 5373 5373 5389 5406 5361 5359 5362 5389 5361 5390 5390 5361 5362 5390 5402 5389 5389 5402 5403 5389 5403 5406 5406 5403 5407 5450 5453 5403 5450 5403 5402 5453 5454 5403 5403 5454 5407 5402 5390 5428 5428 5450 5402 5390 5362 5426 5428 5390 5426 5426 5429 5428 5428 5429 5447 5447 5450 5428 5447 5449 5450 5449 5453 5450 5449 5452 5453 5452 5454 5453 5447 5448 5449 5448 5452 5449 5429 5570 5447 5427 5429 5426 5427 5570 5429 5427 5569 5570 5426 5425 5427 5427 5425 5475 5475 5569 5427 5475 5568 5569 5425 5423 5475 5475 5423 5473 5475 5473 5476 5476 5568 5475 5423 5425 5426 5423 5387 5424 5426 5387 5423 5474 5473 5423 5474 5423 5424 5472 5471 5473 5472 5473 5474 5476 5473 5471 5476 5471 5470 5470 5568 5476 5470 5471 5472 5472 5474 5477 5470 5472 5477 5474 5424 5444 5474 5444 5477 5424 5387 5388 5424 5388 5444 5444 5388 5391 5444 5391 5445 5477 5444 5445 5477 5445 5478 5470 5477 5494 5494 5477 5478 5470 5567 5568 5494 5567 5470 5478 5445 5446 5445 5391 5446 5446 5391 5392 5391 5372 5392 5392 5372 5329 5392 5329 5393 5329 5372 5328 5328 5372 5327 5391 5327 5372 5327 5308 5328 5328 5308 5307 5328 5307 5329 5315 5308 5327 5327 5349 5315 5349 5327 5391 5391 5388 5349 5315 5349 5287 5287 5349 5350 5349 5348 5350 5388 5348 5349 5287 5270 5315 5315 5270 5268 5315 5268 5308 5268 5307 5308 4082 4081 5268 5268 4081 5269 5268 4095 4096 4096 4166 5268 5268 4166 4082 5268 4100 4101 5268 4101 4094 5268 4094 4095 4131 4123 5268 5270 4145 5268 4145 4139 5268 5268 4139 4140 4140 4227 5268 5268 4227 4130 5268 4130 4131 4115 5268 4114 4115 4109 5268 5268 4109 4110 4207 4113 5268 5268 4113 4114 4181 4100 5268 4181 5268 4110 4124 4207 5268 4124 5268 4123 5269 5307 5268 4123 2935 4124 4124 2935 2934 4124 2934 4125 4125 4207 4124 4131 2932 4123 4123 2932 2935 2934 2935 2932 2934 2932 2931 4125 2934 4126 4126 2934 2931 4125 4126 4207 4126 2931 4127 4207 4126 4206 4206 4126 4127 4205 3005 4206 4206 3005 4207 4206 4127 4205 4204 3007 4205 4205 3007 3005 4204 4205 4320 4320 4205 4127 3003 3004 3005 3003 3005 3006 3007 3006 3005 4207 3005 3004 3007 3008 3006 4204 3008 3007 4202 3003 3006 4202 3006 4203 4203 3006 3008 4201 3004 3003 4201 3003 4202 4200 3004 4201 4207 3004 4200 4201 4111 4112 4201 4112 4200 4201 4202 4111 4111 4202 4294 4203 4294 4202 4110 2922 4111 4111 2922 2919 4111 2919 4112 4111 4294 4110 4109 2922 4110 4110 4294 4183 4181 4110 4182 4182 4110 4183 2922 2920 2919 4109 2920 2922 2919 2920 2921 2923 2919 2921 4112 2919 2923 4115 2921 2920 4115 2920 4109 4113 2923 2921 4113 2921 4114 4114 2921 4115 4112 2923 4113 4207 4112 4113 4200 4112 4207 2986 4182 4183 2986 4183 2988 2988 4183 4184 4294 4184 4183 2985 2984 2986 2988 2985 2986 2984 4182 2986 2988 2989 2985 2988 4184 2989 2989 4184 4178 4184 4294 4287 4184 4287 4178 2989 4178 2985 2983 2984 2985 2985 4178 4179 2985 4179 2983 2987 2984 2983 2983 4179 4180 2983 4180 2987 4180 4179 4274 4274 4179 4273 4273 4179 4178 4180 4181 2987 4097 4098 4180 4180 4098 4181 4097 4180 4274 2987 4181 2984 2984 4181 4182 4181 4098 4099 4099 4100 4181 4097 2910 4098 4098 2910 2912 4098 2912 4099 4099 2912 2911 4099 2911 4100 4100 2911 2909 4100 2909 4101 2911 2912 2910 2911 2910 2909 2907 2909 2910 4097 2907 2910 2907 2908 2909 4101 2909 4094 4094 2909 2908 4095 2908 2907 4095 2907 4096 4096 2907 4097 4094 2908 4095 4097 4274 4096 4165 4166 4096 4096 4274 4165 4164 2966 4165 4165 2966 2964 4165 2964 4166 4274 4164 4165 4166 2964 2963 4166 2963 4160 4160 4083 4166 4166 4083 4082 2962 2963 2964 2962 2964 2965 2966 2965 2964 2966 2967 2965 4164 2967 2966 4162 2962 2965 4162 2965 4163 4163 2965 2967 4160 2963 2962 4160 2962 4161 4161 2962 4162 4083 4160 4161 4083 4161 4247 4247 4161 4162 4247 4162 4248 4163 4268 4162 4268 4248 4162 4163 2967 4164 4164 4267 4163 4163 4267 4268 4267 3070 4268 4268 3070 3069 4268 3069 4269 4269 4248 4268 4274 3070 4267 4164 4274 4267 3067 3069 3070 3067 3070 3065 4274 3065 3070 3067 3068 3069 4269 3069 3068 4269 3068 4270 4270 4248 4269 4270 3068 3067 3065 3066 3067 3067 3066 3071 4270 3067 4271 4271 3067 3071 4273 3066 3065 4273 3065 4274 4272 3071 3066 4272 3066 4273 4271 3071 4272 4405 4270 4271 4405 4271 4272 4405 4249 4270 4270 4249 4248 3051 4247 4248 3051 4248 3052 3052 4248 4249 3048 3050 3051 3051 3052 3048 3050 4247 3051 3050 4252 4247 4252 4149 4247 4247 4149 4150 4247 4150 4083 3048 3049 3050 3049 4252 3050 3048 4250 3049 4250 4251 3049 3049 4251 4252 3048 4249 4250 4352 4250 4382 4382 4250 4249 4234 4251 4250 4234 4250 4352 3052 4249 3048 4382 4249 4383 4405 4404 4249 4249 4404 4383 3172 4382 4383 3172 4383 3173 3173 4383 4378 4383 4404 4378 3195 4403 4404 3195 4404 3196 3196 4404 4405 4378 4404 4403 3173 4378 3174 3174 4378 4379 4378 4403 4408 4378 4408 4379 3171 3172 3173 3171 3173 3174 3174 4379 3171 3169 3170 3171 3171 3170 3172 3171 4379 3169 3169 4379 4380 3169 4380 4381 3169 4381 3170 3170 4381 4382 3170 4382 3172 4382 4381 4352 4352 4381 4380 4531 4352 4380 4531 4380 4379 3322 4530 4531 3322 4531 3320 3320 4531 4532 4531 4379 4532 4530 4352 4531 3320 3319 3322 3319 4530 3322 3318 3319 3320 3318 3320 3321 3320 4532 3321 4532 4379 4561 4561 3321 4532 4379 4408 4561 3197 4407 4408 3197 4408 3194 3194 4408 4402 4403 4402 4408 4408 4407 4432 4432 4431 4408 4408 4431 4600 4408 4600 4566 4566 4559 4408 4408 4559 4561 3194 4402 4403 3194 4403 3195 3194 3195 3196 3194 3196 3192 3196 4405 3192 3192 3193 3194 3192 4405 3193 3194 3193 3197 3193 4405 4406 3193 4406 4407 3193 4407 3197 4432 4407 4406 4432 4406 4433 4406 4405 4433 3222 4431 4432 3222 4432 3218 3218 4432 3219 4432 4433 3219 3221 3222 3218 3221 4431 3222 3221 4430 4431 4431 4430 4600 3221 3218 3220 3220 3223 3221 3223 4430 3221 3218 3219 3220 3219 4433 3220 3220 4428 4429 3220 4429 3223 3220 4433 4428 3223 4429 4430 4600 4430 3249 3249 4430 4429 4428 3249 4429 4433 4316 4428 4428 4316 4317 4428 4317 3249 4433 4405 4316 4405 4272 4178 4178 4288 4405 4405 4288 4289 4291 4316 4405 4291 4405 4290 4290 4405 4289 4273 4178 4272 4178 4287 4288 4287 3090 4288 4288 3090 3089 4288 3089 4289 4289 3089 3088 4289 3088 4290 4290 3088 4291 3086 3087 3088 3088 3089 3090 3088 3090 3086 3088 3087 3091 4291 3088 3091 4287 3086 3090 4294 3086 4287 4293 3087 3086 4293 3086 4294 4292 3091 3087 4292 3087 4293 4291 3091 4292 4315 4291 4292 4315 4292 4314 4314 4292 4293 4314 4293 4203 4203 4293 4294 4314 3112 4315 4320 3109 4314 4314 3109 3112 4204 4320 4314 4204 4314 4203 4203 3008 4204 4319 3110 4320 4320 3110 3109 4223 4319 4320 4223 4320 4222 4320 4127 4222 3109 3110 3111 3109 3111 3112 4319 3111 3110 3113 3112 3111 4318 3113 3111 4318 3111 4319 3113 3114 3112 4316 3114 3113 4316 3113 4317 4317 3113 4318 4315 3112 3114 4315 3114 4316 4315 4316 4291 4341 4318 4319 4341 4342 4318 4318 4342 4371 4317 4318 4460 4460 4318 4371 3249 4317 4460 3250 3249 4460 3250 4460 4455 4460 4371 4455 3248 3249 3250 3248 4459 3249 4459 4600 3249 3250 3251 3252 3252 3248 3250 3250 4455 3251 3252 3253 3248 3253 4459 3248 3253 4458 4459 4458 4600 4459 3252 4458 3253 3251 3254 3252 3252 3254 3255 3255 4457 3252 3252 4457 4458 3251 4455 3254 3254 4455 3255 3255 4455 4456 3255 4456 4457 4600 4458 4457 4600 4457 4491 4456 4491 4457 4492 4491 4456 4455 4493 4456 4456 4493 4492 3287 4491 4492 3287 4492 3281 3281 4492 3285 3285 4492 4493 3285 4493 3284 3284 4493 4488 4371 4488 4493 4455 4371 4493 3284 3281 3285 3282 3281 3284 3284 4488 3282 3281 3282 3283 3286 3287 3281 3286 3281 3283 3286 4491 3287 3283 4490 3286 3286 4490 4491 3282 4489 3283 3283 4489 4490 3282 4488 4489 4489 4488 4371 4399 4489 4371 4525 4490 4489 4525 4489 4399 4524 4523 4490 4490 4523 4491 4524 4490 4525 3313 4523 4524 3313 4524 3314 3314 4524 4525 3316 4522 4523 3316 4523 3313 4491 4523 4663 4663 4523 4522 3313 3314 3315 3313 3315 3316 3314 4525 3315 3316 3315 3317 3315 4521 3317 3315 4525 4526 3315 4526 4521 3317 4522 3316 3317 4521 4522 4663 4522 4664 4664 4522 4521 4424 4454 4521 4424 4521 4423 4398 4422 4521 4521 4422 4423 4526 4398 4521 4521 4454 4453 4453 4557 4521 4521 4557 4556 4556 4664 4521 4422 3216 4423 4423 3216 4424 3212 3214 3216 3216 3214 3217 4422 3212 3216 4424 3216 3217 3212 3213 3214 4422 3213 3212 3213 3215 3214 4426 3217 3214 4426 3214 4427 4427 3214 3215 4424 3217 4425 4425 3217 4426 4425 4426 4454 4454 4426 4310 4310 4426 4427 4427 3215 4420 4420 4310 4427 4420 3215 3213 4420 3213 4421 4397 4420 4398 4397 4310 4420 4420 4421 4398 4421 3213 4422 4398 4421 4422 3189 4397 4398 3189 4398 3186 3186 4398 3187 4526 3187 4398 3186 3187 3188 3188 3189 3186 3187 4399 3188 4525 3187 4526 4525 4399 3187 3189 3188 3190 3188 4399 3190 3190 4399 4400 4399 4374 4400 4399 4371 4373 4399 4373 4374 3189 3190 3191 3190 4400 3191 3191 4400 4401 3191 4401 3189 3189 4401 4397 4401 4308 4397 4283 4308 4401 4283 4401 4400 4397 4308 4309 4309 4310 4397 4308 3104 4309 4309 3104 3107 4309 3107 4310 3103 3104 3105 3104 3103 3107 4308 3105 3104 3107 3103 3108 4310 3107 3108 3103 3105 3106 4311 3108 3103 4311 3103 4312 4312 3103 3106 4313 3106 3105 4313 3105 4308 4312 3106 4313 4310 4311 4312 4313 4214 4312 4214 4310 4312 4310 3108 4311 4214 4220 4310 4310 4220 4237 4334 4310 4339 4339 4310 4237 4310 4334 4335 4310 4335 4454 4334 3130 3129 4334 3129 4335 4339 3130 4334 4338 3131 4339 4339 3131 3130 4339 4237 4338 3128 3129 3130 3128 3130 3131 3129 3128 3132 4335 3129 3132 4335 3132 4336 4454 4335 4336 3132 3128 3133 4336 3132 4337 4337 3132 3133 4338 3133 3128 4338 3128 3131 4337 3133 4338 4369 4337 4338 4369 4338 4237 4454 4336 4337 4454 4337 4369 3246 4453 4454 3246 4454 3247 3247 4454 4451 4425 4454 4424 4451 4454 4450 4450 4454 4369 3245 3246 3247 4451 3245 3247 4450 3245 4451 3245 4450 3242 3242 4450 4452 4452 4450 4365 4450 4369 4365 3245 3244 3246 3244 3245 3242 3242 3243 3244 3242 4452 3243 3244 3243 4453 3244 4453 3246 4452 3352 3243 3243 3352 4558 3243 4558 4453 4453 4558 4557 3354 4557 4558 3354 4558 3350 3350 4558 3352 3351 4556 4557 3351 4557 3354 3350 3351 3354 3350 3349 3351 3350 3352 3353 3349 3350 3347 3347 3350 3353 3349 4556 3351 3349 3348 4556 4556 3348 4664 3347 3348 3349 3353 4555 3347 3347 4555 3348 3353 3352 4555 4587 4555 4586 4586 4555 3352 4587 3348 4555 4587 4664 3348 4586 3383 4587 4587 3383 3381 4587 3381 4588 4587 4588 4708 4708 4664 4587 3382 3381 3383 3382 3383 3384 4586 3384 3383 3380 3381 3382 4588 3381 3380 4588 3380 4589 4588 4589 4708 3380 3382 3385 4589 3380 3385 4589 3385 4590 4708 4589 4624 4624 4589 4590 3385 3382 3386 4590 3385 3386 4590 3386 4591 4624 4590 4591 4591 3386 3382 4591 3382 4592 4624 4591 4365 4365 4591 4592 4592 3382 3384 4592 3384 4586 4365 4592 4452 4586 4452 4592 4586 3352 4452 4364 3160 4365 4365 3160 4366 4366 4393 4365 4365 4369 4364 4393 4392 4365 4365 4392 4515 4365 4515 4485 4485 4486 4365 4365 4486 4487 4365 4487 4481 4482 4624 4365 4482 4365 4481 4485 3275 4486 4486 3275 3278 4486 3278 4487 4487 3278 3277 4487 3277 4481 4481 3277 3276 4481 3276 4482 4482 3276 4483 4483 4624 4482 3275 3276 3277 3276 3275 3279 4483 3276 3279 3275 3277 3278 3279 3275 3280 4485 3280 3275 4483 3279 4484 4484 3279 3280 4624 4483 4484 4484 3280 4485 4624 4484 4515 4515 4484 4485 4623 3418 4624 4624 3418 3413 4624 3413 4625 4520 4624 4515 4624 4520 4519 4624 4519 4653 4624 4626 4627 4624 4627 4708 4623 4624 4653 4624 4625 4626 4625 3413 4626 4626 3413 3416 4626 3416 4627 4627 3416 3415 4627 3415 4621 4627 4621 4708 3413 3415 3416 3413 3414 3415 4621 3415 3414 4621 3414 4622 4621 4747 4746 4708 4621 4746 4747 4621 4622 3414 3413 3417 4622 3414 3417 4622 3417 4623 4747 4622 4748 4748 4622 4623 3530 4746 4747 3530 4747 3527 3527 4747 4748 3527 4748 3531 3531 4748 4749 4749 4748 4653 4653 4748 4623 4623 3417 3418 3417 3413 3418 4653 3447 4654 4662 3450 4653 4653 3450 3447 4518 4517 4653 4545 4554 4653 4518 4653 4519 4653 4554 4553 4653 4553 4703 4517 4545 4653 4749 4653 4825 4825 4653 4791 4654 4789 4653 4653 4789 4790 4653 4790 4791 4703 4660 4653 4653 4660 4661 4653 4661 4662 4789 3566 4790 4790 3566 3571 4790 3571 4791 3566 3570 3571 4791 3571 3570 3567 3570 3566 4791 3570 4782 4782 3570 3567 3566 3565 3567 4782 3567 4783 4783 3567 3565 4825 4791 4782 4782 4783 4825 4783 3565 4784 4825 4783 4784 3564 3565 3566 4784 3565 3564 4784 3564 4785 4825 4784 4785 3562 3563 3564 3564 3566 3562 4785 3564 3563 4785 3563 4786 4785 4786 4825 4786 3563 3562 3562 3566 3569 4786 3562 3569 3566 3568 3569 4789 3568 3566 4786 3569 4787 4787 3569 4788 4788 3569 3568 4825 4786 4787 4787 4788 4654 4654 4655 4787 4787 4655 4656 4787 4656 4825 4788 3568 4789 4654 4788 4789 4654 3447 3445 4654 3445 4655 4655 3445 3444 4655 3444 4656 4656 3444 3443 4656 3443 4657 4825 4656 4657 3442 3443 3444 3444 3445 3446 3444 3446 3442 3446 3445 3447 3447 3450 3446 3446 3450 3451 4662 3451 3450 4661 3446 3451 4661 3451 4662 4660 3446 4661 3446 3448 3449 3442 3446 3449 4660 3448 3446 4659 3448 4660 4703 4659 4660 4659 3449 3448 4657 3442 3449 4657 3449 4658 4658 3449 4659 4658 4659 4703 4703 4657 4658 4657 3443 3442 4703 4825 4657 4702 3486 4703 4703 3486 3485 4703 3485 4697 4551 4550 4703 4703 4553 4552 4703 4552 4551 4550 4549 4703 4703 4549 4581 4703 4581 4585 4703 4697 4825 4585 4700 4703 4703 4700 4701 4703 4701 4702 4700 3488 4701 4701 3488 3483 4701 3483 4702 4702 3483 3486 3483 3484 3485 3483 3485 3486 3484 3483 3487 3487 3483 3488 4699 3487 3488 4699 3488 4700 4698 3484 3487 4698 3487 4699 4697 3485 3484 4697 3484 4698 4698 4829 4828 4698 4828 4697 4698 4699 4829 4829 4699 4830 4830 4699 4700 3604 4828 4829 3604 4829 3608 3608 4829 4830 3604 4827 4828 4697 4828 4827 4825 4697 4827 3607 4826 4827 3607 4827 3604 4825 4827 4826 3604 3606 3607 3606 4826 3607 3606 4825 4826 3605 3606 3604 3605 4825 3606 3604 3603 3605 3603 4825 3605 3602 3603 3604 3602 4824 3603 3603 4824 4825 3602 3604 3608 3608 4830 3602 3602 4830 4824 4868 4824 4830 4700 4868 4830 4867 3644 4868 4868 3644 3643 4868 3643 4862 4954 4868 4953 4824 4868 4954 4700 4742 4868 4742 4736 4868 4868 4736 4737 4868 4737 4776 4868 4993 4953 4868 4862 4993 4776 4866 4868 4868 4866 4867 4736 3522 4737 4742 3522 4736 3520 3521 3522 4737 3522 3521 4742 3520 3522 3521 3520 3523 3523 3520 3524 4741 3524 3520 4741 3520 4742 4737 3521 4738 4738 3521 3523 4738 3523 4739 4739 3523 4740 4740 3523 3524 4740 3524 4741 4652 4740 4741 4652 4741 4700 4700 4741 4742 4652 4739 4740 4776 4738 4739 4776 4739 4652 4776 4737 4738 4775 3557 4776 4776 3557 4777 4781 4775 4776 4781 4776 4652 4776 4777 4778 4905 4906 4776 4776 4778 4905 4776 4906 4907 4776 4907 5042 5042 4864 4776 4776 4864 4865 4776 4865 4866 4905 3675 4906 4906 3675 3677 4906 3677 4907 3675 3676 3677 3679 3676 3675 4905 3679 3675 3677 3676 3678 4907 3677 3678 4901 3678 3676 4907 3678 4901 3679 3680 3676 4901 3676 4902 4902 3676 4903 4903 3676 3680 4904 3680 3679 4904 3679 4905 4903 3680 4904 4902 4903 4861 4821 4861 4903 4821 4903 4822 4904 4822 4903 4861 5042 4902 4902 5042 4901 5042 4907 4901 3805 5041 5042 3805 5042 3806 4861 4948 5042 5042 4948 4949 5042 4949 3806 5042 4991 4992 5042 4992 4993 5041 4991 5042 4993 4862 5042 5042 4862 4863 4863 4864 5042 4991 3762 4992 4992 3762 3764 4992 3764 4993 3762 3763 3764 4991 3763 3762 3764 3763 3761 4993 3764 3761 3761 3763 3765 4990 3765 3763 4990 3763 4991 3759 3760 3761 3761 3765 3759 4993 3761 4994 4994 3761 3760 4989 3759 3765 4989 3765 4990 5041 4989 4990 5041 4990 4991 4988 3759 4989 5138 4988 4989 5138 4989 5040 5040 4989 5041 4988 3760 3759 4994 3760 4988 4993 4994 5138 4994 4988 5138 4950 4951 4993 4993 4951 4952 4953 4993 4952 5139 4950 4993 4993 5138 5139 4950 3723 4951 4951 3723 3722 4951 3722 4952 4952 3722 3726 4952 3726 4953 4953 3726 4954 3722 3725 3726 4954 3726 3725 3722 3723 3724 3722 3724 3725 4956 3724 3723 4956 3723 4950 4955 3725 3724 4955 3724 4956 4954 3725 4955 4824 4954 4955 4824 4955 4956 4950 4824 4956 4950 4825 4824 4017 5250 4950 5096 4871 4950 5096 4950 5095 5250 5094 4950 4950 5094 3860 4950 3860 5095 4871 4910 4950 4950 4910 4911 4911 4912 4950 4950 4912 4825 5138 4017 4950 5138 4950 5141 5141 4950 5140 5140 4950 5139 5140 3908 5141 5141 3908 5135 5138 5141 5135 5139 3903 5140 5140 3903 3908 5138 3907 5139 5139 3907 3903 3903 3904 3905 3904 3903 3906 3906 3903 3907 3903 3905 3908 5135 3908 3905 5135 3905 5136 5138 5135 5136 5136 3905 3904 5136 3904 5137 5137 3904 3906 5137 3906 5138 5138 3906 3907 5136 5137 5138 5138 5040 5039 5138 5134 5129 5083 5088 5138 5083 5138 5038 5038 5138 5039 5138 5088 5087 5138 5087 5086 5086 5133 5138 5138 5133 5134 5258 5249 5138 5249 4017 5138 5187 5188 5138 5138 5188 5182 5138 5182 5258 5187 5138 5186 5129 5185 5138 5138 5185 5186 5186 3948 5187 5187 3948 3947 5187 3947 5188 5188 3947 3949 5188 3949 5182 3945 3946 3947 3945 3947 3948 3947 3946 3949 5185 3945 3948 5185 3948 5186 5184 3945 5185 5184 5185 5129 5184 3946 3945 5182 3946 5183 5183 3946 5184 5182 3949 3946 5129 5183 5184 5258 5182 5183 5258 5183 5129 5257 4023 5258 5258 4023 4022 5258 4022 5259 4463 4462 5258 4462 4670 5258 5258 4670 4671 4671 4672 5258 5258 4672 4714 5181 5175 5258 5129 5180 5258 5258 5180 5181 5258 5263 5254 5254 5255 5258 5258 5255 5256 5258 5256 5257 5258 5248 5249 5259 5248 5258 4714 4996 5258 5258 4996 4997 5045 5263 5258 5045 5258 4997 4463 5258 5244 5240 5241 5258 5258 5241 5242 5258 5242 5243 5258 5243 5244 5169 5240 5258 5169 5258 5175 5240 4002 4001 5240 4001 5241 4002 5240 5169 5241 4001 4009 5241 4009 5242 5242 4009 4010 5242 4010 5243 5243 4010 4005 5243 4005 5244 4009 4003 4010 4010 4003 4005 4009 4001 4003 4001 4002 4003 5239 4003 4002 5169 5239 4002 4003 4004 4005 5239 4004 4003 4005 4004 4006 4006 4007 4005 4005 4007 4008 5244 4005 4008 5238 4006 4004 5238 4004 5239 5169 5238 5239 5237 4006 5238 5237 5238 5169 5237 4007 4006 5236 4007 5237 5236 4008 4007 5244 4008 5236 4463 5244 5236 5236 5237 4463 4463 5237 5169 3259 4462 4463 3259 4463 3260 3260 4463 4464 4464 4463 4167 4167 4463 5226 5233 5234 4463 5234 5235 4463 4463 5235 5227 5227 5225 4463 4463 5225 5226 4463 5169 5233 5233 4000 5234 5234 4000 3993 5234 3993 5235 5235 3993 3996 5235 3996 5227 3991 3992 3993 3993 3992 3994 3994 3995 3993 3993 3995 3996 4000 3991 3993 3999 3991 4000 5233 3999 4000 3997 3998 3999 3999 3998 3991 5232 3997 3999 5232 3999 5233 5233 5169 5232 5169 3997 5232 5231 3998 3997 5169 5231 3997 5231 3991 3998 5230 3991 5231 5230 5231 5222 5222 5231 5169 5229 3992 5230 5230 3992 3991 5230 5222 5229 5228 3994 5229 5229 3994 3992 5229 5222 5228 5227 3995 5228 5228 3995 3994 5228 5224 5227 5228 5222 5223 5228 5223 5224 5227 3996 3995 5227 5224 5225 5223 3989 5224 5224 3989 3990 5224 3990 5225 5222 3987 5223 5223 3987 3989 3987 3988 3989 3989 3988 3981 3989 3981 3990 3990 3981 3983 5225 3990 3983 5225 3983 5226 3981 3982 3983 3983 3982 3984 3984 3985 3983 3983 3985 3986 5226 3983 3986 5226 3986 5217 4167 5226 5217 5217 3986 3985 5217 3985 5218 5218 3985 3984 5218 3984 5219 5219 3984 3982 5219 3982 5220 5220 3982 3981 4167 5218 5219 4167 5219 5222 5222 5219 5220 5217 5218 4167 2973 4167 2972 2972 4167 4168 2971 4171 4167 2971 4167 2973 4167 4171 4188 4188 4296 4167 4167 4296 4297 4167 4465 4464 4167 4297 4298 4167 4298 4465 5222 5214 4167 5212 4167 3978 3978 4167 5213 5213 4167 5214 4167 5212 4076 4167 4076 4168 3974 3977 3978 3977 5212 3978 3974 3978 5213 3974 5213 3980 3980 5213 5214 3979 3972 3980 3980 3972 3974 3980 5214 3979 3979 3970 3972 3979 5214 5215 3979 5215 3970 3970 3971 3972 3970 5215 5216 3970 5216 3971 5216 5215 5222 5222 5215 5214 3971 5216 5208 5216 5159 5158 5216 5158 5151 5159 5216 5222 4076 5211 5216 5216 5211 5210 5210 5209 5216 5216 5209 5208 5203 5204 5216 5216 5204 5205 5216 5205 4076 5216 5155 5203 5151 5154 5216 5216 5154 5155 5203 3960 5204 5204 3960 3968 5204 3968 5205 5205 3968 3969 5205 3969 5206 4076 5205 5206 3968 3960 3962 3968 3962 3969 3960 3961 3962 5203 3961 3960 3962 3963 3964 3969 3962 3964 5202 3963 3962 5202 3962 3961 5206 3969 3964 5206 3964 5207 4076 5206 5207 3964 3963 3965 3965 3966 3964 3964 3966 3967 5207 3964 3967 5201 3965 3963 5201 3963 5202 5203 5201 5202 5203 5202 3961 5200 3965 5201 4033 5200 5201 4033 5201 5203 5200 3966 3965 5199 3966 5200 5199 3967 3966 5207 3967 5199 4033 5207 5199 4033 4076 5207 5199 5200 4033 2849 4032 4033 2849 4033 4034 4035 4034 4033 4033 4032 4031 4079 4033 4040 5198 5189 4033 4033 5189 5265 4033 5265 4035 5203 5196 4033 4033 5196 5197 4033 5197 5198 4079 4078 4033 4033 4078 4076 4040 4033 4031 5195 3958 5196 5196 3958 3959 5196 3959 5197 5203 5195 5196 5197 3959 3954 5197 3954 5198 3958 3952 3959 3959 3952 3954 3958 3950 3952 5195 3950 3958 5194 3950 5195 5194 5195 5203 3950 3951 3952 5193 3951 3950 5193 3950 5194 5203 5193 5194 5192 3952 5193 5193 3952 3951 5282 5192 5193 5203 5282 5193 3952 3953 3954 5192 3953 3952 5191 3953 5192 5282 5191 5192 3954 3953 3955 5191 3955 3953 5190 3955 5191 5283 5190 5191 5283 5191 5282 3955 3956 3954 5190 3956 3955 5189 3956 5190 5265 5189 5190 5265 5190 5283 3954 3956 3957 5189 3957 3956 5198 3954 3957 5198 3957 5189 5282 5301 5283 5265 5283 5303 5301 5313 5283 5283 5313 5314 5283 5314 5303 5301 5282 5302 5302 5312 5301 5301 5312 5313 5334 5314 5313 5334 5313 5335 5335 5313 5312 5303 5314 5266 5333 5266 5314 5333 5314 5334 5303 5266 5265 4041 5265 4042 4042 5265 5266 4037 5265 4041 4035 5265 4036 4036 5265 4037 2853 4041 4042 2853 4042 2851 4042 5266 2851 2851 2852 2853 2852 2855 2853 2855 4041 2853 2852 2851 4038 2863 4038 2851 5266 2863 2851 2856 2855 2852 2852 4038 2856 2854 2855 2856 2854 4040 2855 2855 4040 4041 2856 4038 4039 2856 4039 2854 4040 4039 4038 4040 4038 2863 2854 4039 4040 4031 4041 4040 4092 4040 4093 4093 4040 2863 4079 4040 4080 4092 4080 4040 4037 4041 4031 2850 4031 2845 2845 4031 4032 2850 4037 4031 4036 4037 2850 2850 2845 2847 2847 4036 2850 2845 2846 2847 2846 2845 2848 2845 4032 2848 2848 4032 2849 2846 2848 2849 2849 4034 2846 2846 4034 4035 2846 4035 2847 2847 4035 4036 2892 4079 4080 2892 4080 2888 2888 4080 4075 4092 4075 4080 2892 2888 2890 2890 4079 2892 2890 4078 4079 2888 2889 2890 2890 2889 2891 2891 4078 2890 2888 4075 2889 2889 4075 4076 2889 4076 4077 2889 4077 2891 2891 4077 4078 4076 4078 4077 4169 4076 4075 4168 4076 4169 4076 5212 5211 2972 4168 2969 2969 4168 2970 2970 4168 4169 2969 2971 2972 2972 2971 2973 2968 2969 2970 2969 2968 2971 2975 2968 2970 2970 4169 2975 2974 2968 2975 2968 2974 4170 2968 4170 4171 2968 4171 2971 2975 4169 2974 4188 4170 2974 4188 2974 4091 4091 2974 4169 4188 4171 4170 2996 4187 4188 2996 4188 4189 4091 4189 4188 4188 4301 4295 4188 4187 4496 4188 4496 4301 4188 4295 4296 4300 3097 4301 4301 3097 4295 4301 4496 4300 4295 3094 4296 4295 3097 3094 4296 3094 3093 4296 3093 4297 3092 3093 3094 3094 3097 3092 4300 3092 3097 3092 3095 3093 4300 3095 3092 3093 3095 3096 4297 3093 3096 4297 3096 4298 4298 3096 4299 4299 3096 3095 4299 3095 4300 4299 4467 4298 4467 4299 4300 4298 4467 4466 4465 4298 4466 3258 4465 4466 3258 4466 3261 3261 4466 4467 3257 4464 4465 3257 4465 3258 3256 3257 3258 3261 3256 3258 3261 3262 3256 3261 4467 3262 3257 3256 3259 3262 4461 3256 3256 4461 4462 3256 4462 3259 3257 3259 3260 3260 4464 3257 4461 4668 4462 4462 4668 4669 4462 4669 4670 4668 3463 4669 4674 3464 4668 4668 3464 3463 4674 4668 4461 4669 3463 3459 4669 3459 4670 4670 3459 3461 4670 3461 4671 3459 3460 3461 3463 3460 3459 3463 3464 3460 4673 3460 3464 4673 3464 4674 4673 4674 4714 4714 4674 4461 4672 3460 4673 4714 4672 4673 3461 3460 3462 4672 3462 3460 4671 3461 3462 4671 3462 4672 4713 3495 4714 4714 3495 3494 4714 3494 4715 4714 4461 4496 4496 4497 4714 4714 4497 4498 4498 4529 4714 4714 4529 4528 4712 4713 4714 4528 4527 4714 4714 4527 4561 4714 4561 4712 5045 4714 4715 4714 4995 4996 5045 5001 4714 4714 5001 4995 3321 4527 3323 3323 4527 4528 4527 3321 4561 3318 3321 3323 3323 4528 4529 3323 4529 3318 3318 4529 4530 3318 4530 3319 4498 4530 4529 4530 4500 4352 4530 4498 4499 4530 4499 4500 4497 3289 4498 4498 3289 3288 4498 3288 4499 4499 3288 4500 4500 3288 3292 4500 3292 4494 4352 4500 4494 3288 3289 3290 3291 3292 3288 3288 3290 3291 3293 3290 3289 4497 3293 3289 4496 3293 4497 4496 3290 3293 4495 3291 3290 4495 3290 4496 4494 3291 4495 4494 3292 3291 4495 4352 4494 4496 4352 4495 4325 4326 4496 4187 4324 4496 4496 4324 4325 4467 4300 4496 4467 4496 4461 4496 4326 4352 4324 3120 4325 4325 3120 4326 4323 3117 4324 4324 3117 3120 4187 4323 4324 3120 3117 3116 4326 3120 3116 3115 3116 3117 3115 3117 3121 4323 3121 3117 4322 3121 4323 4322 4323 4187 3115 3121 3118 4322 3118 3121 4321 3118 4322 4185 4321 4322 4185 4322 4186 4186 4322 4187 4186 4187 2991 2991 4187 2996 2990 4185 4186 2990 4186 2991 2990 2991 2992 2996 2992 2991 2996 4189 2992 2990 2992 2995 2992 4189 2995 2993 2994 2990 2993 2990 2995 2994 4185 2990 2995 4189 4190 2995 4190 4191 2995 4191 2993 4190 4189 4091 4191 4190 4192 4192 4190 4091 2993 4191 4192 2993 4192 2994 2994 4192 4185 4209 4185 4192 4185 4209 4321 4327 3115 4321 4321 3115 3119 4321 3119 3118 4321 4349 4327 4321 4209 4349 3118 3119 3115 4326 3116 3115 4326 3115 4327 4326 4327 4352 3145 4352 4327 4327 4349 3145 3140 3142 3145 3142 4348 3145 3140 3145 4349 4348 4352 3145 3140 3141 3142 3141 3140 3143 3143 3140 3144 3140 4349 3144 3141 4352 3142 3142 4352 4348 3143 4351 3141 3141 4351 4352 3144 4349 3143 3143 4349 4350 3143 4350 4351 4351 4350 4211 4352 4351 4211 4208 4213 4350 4349 4208 4350 4350 4213 4212 4350 4212 4211 3015 4208 3012 3012 4208 4209 3015 4213 4208 4209 4208 4349 3014 4212 4213 3014 4213 3015 3013 4211 4212 3013 4212 3014 3012 3013 3014 3012 3014 3015 3013 3012 3011 3011 3012 3009 3012 4209 3009 3011 4211 3013 3009 3010 3011 3011 3010 4211 3009 4209 4210 3009 4210 3010 3010 4210 4209 3010 4209 4211 4211 4209 4192 4211 4229 4230 4352 4211 4231 4231 4211 4230 4211 4119 4120 4133 4229 4211 4133 4211 4121 4121 4211 4120 4211 4192 4119 4352 4231 4232 4232 4233 4352 4352 4233 4234 4230 3029 4231 4231 3029 4232 4232 3029 3033 4232 3033 4233 4233 3033 3032 4233 3032 4234 4234 3032 4228 4228 4251 4234 3029 3031 3032 3029 3032 3033 4228 3032 3031 3029 3030 3031 4230 3030 3029 4228 3031 4229 4229 3031 3030 4228 4133 4251 4228 4229 4133 4133 4134 4251 4251 4134 4135 4135 4252 4251 4133 2941 4134 4134 2941 2940 4134 2940 4135 4135 2940 2943 4135 2943 4136 4136 4252 4135 4136 4137 4252 4137 4148 4252 4252 4148 4149 4136 2943 2939 4136 2939 4137 2940 2939 2943 2938 2939 2940 4137 2939 2938 2940 2941 2942 2940 2942 2938 4133 2942 2941 4132 2942 4133 4132 2938 2942 4137 2938 4138 4138 2938 4132 4132 4064 4138 4133 4064 4132 4064 4063 4138 4138 4063 4069 4138 4069 4070 4138 4070 4137 2881 4062 4063 2881 4063 2878 2878 4063 4064 4069 4063 4062 2877 2881 2878 2877 4061 2881 2881 4061 4062 4069 4062 4068 4062 4061 4068 2877 4067 4061 5267 4061 4067 4068 4061 5267 2877 2878 2879 2879 4067 2877 2879 2878 2880 2878 4064 2880 2880 4065 2879 2879 4065 4066 2879 4066 4067 5267 4067 4066 5267 4066 4058 4065 4058 4066 2880 4064 4065 4065 4133 4058 4065 4064 4133 4121 4122 4133 4133 4122 4116 4133 4116 4058 4120 2930 4121 4121 2930 2929 4121 2929 4122 4122 2929 2928 4122 2928 4116 4116 2927 4117 4116 2928 2927 4058 4116 4117 2924 2927 2928 2928 2929 2924 2924 2929 2930 4120 2924 2930 4119 2924 4120 2924 2925 2926 2924 2926 2927 4119 2925 2924 4117 2927 2926 4117 2926 2925 4117 2925 4118 4118 4119 4117 4117 4119 4058 4118 2925 4119 4058 4119 4051 4119 4108 4102 4119 4102 4051 4119 4192 4107 4119 4107 4108 4107 2917 4108 4108 2917 2916 4108 2916 4102 4102 2915 4103 4102 2916 2915 4051 4102 4103 2913 2915 2916 2916 2917 2913 2913 2917 2918 4107 2918 2917 4106 2918 4107 4192 4106 4107 4106 2913 2918 2913 2914 2915 4104 2914 2913 4104 2913 4105 4105 2913 4106 4103 2915 2914 4103 2914 4104 4103 4104 4088 4088 4051 4103 4088 4104 4105 4088 4105 4192 4192 4105 4106 4090 4089 4192 4192 4089 4088 4192 4091 4090 2905 4089 4090 2905 4090 2906 2906 4090 4091 2901 4088 4089 2901 4089 2905 2903 2904 2905 2903 2905 2906 2905 2904 2901 2906 4091 2903 2903 4091 4092 4091 4169 4075 4091 4075 4092 2903 4092 2904 2901 2904 2902 2904 4092 4093 2904 4093 2902 2900 2901 2902 2900 4088 2901 2902 4093 2900 4093 2863 2900 2863 4088 2900 2863 4044 4088 4088 4044 4051 2861 4043 4044 2861 4044 2862 2862 4044 2863 4043 4051 4044 2860 2859 2861 2861 2862 2860 2859 4043 2861 2859 4047 4043 4043 4047 4051 2857 2858 2859 2857 2859 2860 2858 4046 2859 2859 4046 4047 2860 2862 2863 2860 2863 4045 2860 4045 2857 2857 4045 2858 2858 4045 4046 4047 4046 2863 4046 4045 2863 5266 4047 2863 5267 4047 5266 5266 5304 5267 5332 5304 5266 5332 5266 5333 5305 5267 5304 5331 5305 5304 5331 5304 5332 5333 5370 5332 5334 5370 5333 5368 5369 5370 5334 5368 5370 5335 5368 5334 5366 5367 5368 5368 5367 5369 5335 5366 5368 5396 5369 5367 5366 5365 5367 5396 5367 5397 5397 5367 5365 5336 5365 5366 5336 5366 5335 5335 5312 5336 5336 5312 5302 5336 5302 5337 5365 5336 5398 5398 5336 5399 5336 5337 5399 5397 5365 5398 5398 5437 5397 5397 5437 5396 5399 5436 5398 5398 5436 5437 5484 5437 5436 5337 5302 5280 5302 5282 5280 5282 5104 5103 5103 5102 5282 3821 5280 5282 5101 3821 5282 5101 5282 5102 5203 5142 5282 5282 5142 5143 5282 5143 5144 5147 5104 5282 5147 5282 5145 5145 5282 5144 5142 3911 5143 5143 3911 5144 5148 3913 5142 5142 3913 3911 5148 5142 5203 3909 3910 3911 3911 3913 3909 5144 3911 3910 5144 3910 5145 5145 3910 3912 5145 3912 5146 5147 5145 5146 3910 3909 3912 5146 3912 3909 5146 3909 5147 5147 3909 5148 5148 3909 3913 5203 5147 5148 5155 5149 5203 5203 5149 5150 5203 5150 5151 5151 5147 5203 5154 3915 5155 5155 3915 3918 5155 3918 5149 5149 3917 5150 5149 3918 3917 5150 3917 3914 5150 3914 5151 3917 3918 3915 3917 3915 3914 3914 3915 3916 5153 3916 3915 5153 3915 5154 5151 5153 5154 5152 3916 5153 5151 5152 5153 5152 3914 3916 5151 3914 5152 5100 5151 5049 5151 3871 5109 5151 5109 5049 3871 5151 5106 5106 5151 5157 5158 5157 5151 5100 5099 5151 5151 5099 5147 3921 5157 5158 3921 5158 3925 3925 5158 3919 3919 5158 5159 3919 3920 3921 3925 3919 3921 3920 5157 3921 3919 3922 3920 3919 5159 5160 3919 5160 3922 5222 5160 5159 3922 5160 5161 5115 5161 5160 5115 5160 5222 3920 3922 3923 3923 3922 3924 3922 5161 3924 3923 5157 3920 3924 5156 3923 3923 5156 5157 3924 5161 5156 5115 5156 5161 5115 5157 5156 5055 5105 5157 5106 5157 5105 5157 5113 5055 5115 5114 5157 5157 5114 5113 5105 3876 5106 5105 5107 3876 5055 5107 5105 5106 3876 3872 5106 3872 3871 3874 3875 3876 3876 3875 3872 3876 5107 3874 3871 3872 3873 3872 3875 3873 3873 5109 3871 3875 5109 3873 3874 5108 3875 3875 5108 5109 3874 5107 5108 5108 5107 5050 5050 5049 5108 5049 5109 5108 3819 5049 5050 3819 5050 3820 3820 5050 5051 5050 5107 5051 3818 3817 3819 3819 3820 3818 3817 5049 3819 3818 3820 3821 3820 5051 3821 3821 5051 5008 5008 5051 5107 5008 5107 5056 5107 5055 5056 5055 3822 5056 5056 3822 5057 5056 5057 5008 3822 3823 3824 5057 3822 3824 5055 3823 3822 5057 3824 5058 5008 5057 5058 3825 3826 3824 3825 3824 3823 5058 3824 3826 5061 3825 3823 5061 3823 5055 5059 3826 3825 5059 3825 5060 5060 3825 5061 5058 3826 5059 5016 5058 5059 5058 5016 5008 5016 5059 5060 5016 5060 5055 5055 5060 5061 5055 5113 5112 5112 3883 5055 5055 3883 5068 5055 5068 5016 3879 5112 5113 3879 5113 5114 3882 3883 5112 3882 5112 3879 3882 3878 3883 3878 5111 3883 5068 3883 5111 3882 3879 3878 3877 3878 3879 3880 3877 3879 3879 5114 3880 3880 5114 5115 3880 3881 3877 3880 5115 3881 3881 5110 3877 3877 5110 5111 3877 5111 3878 3881 5115 5110 5117 5111 5110 5115 5171 5110 5110 5171 5116 5110 5116 5117 5116 3884 5117 5117 3884 5118 5118 5111 5117 5120 3886 5116 5116 3886 3885 5116 3885 3884 5120 5116 5171 3884 3885 3886 3886 3888 3884 5118 3884 3888 5118 3888 3887 5118 3887 5111 3887 3888 3889 3889 3888 3886 5119 3889 3886 5119 3886 5120 5119 5120 5073 5073 5120 5171 3887 3889 5119 5119 5073 3887 5111 3887 5068 5068 3887 5073 5067 3829 5068 5068 3829 3828 5068 3828 5062 5068 5062 5063 5073 5067 5068 5016 5068 5063 3827 3828 3829 3827 3829 3830 5067 3830 3829 5062 3828 3827 5062 3827 5063 3831 3832 3827 3831 3827 3830 5063 3827 3832 5065 3831 3830 5065 3830 5066 5066 3830 5067 5064 3832 3831 5064 3831 5065 5063 3832 5064 5063 5064 5065 5063 5065 5022 5022 5065 5066 5067 5070 5066 5066 5070 5071 5066 5071 5022 5073 5069 5067 5067 5069 5070 5069 3836 5070 5070 3836 3838 5070 3838 5071 5071 3838 3837 5071 3837 5072 5022 5071 5072 3837 3838 3836 3833 3835 3836 3837 3836 3835 5069 3833 3836 5074 3833 5069 5074 5069 5073 3833 3834 3835 5074 3834 3833 5072 3837 3835 5072 3835 5073 5073 3835 3834 5022 5072 5073 5021 3789 5022 5022 3789 3784 5022 3784 5023 5023 5024 5022 5022 5024 5063 4971 4976 5022 4976 5021 5022 5022 5028 4971 5022 5029 5028 5077 5029 5022 5077 5022 5076 5076 5022 5073 5075 3842 5076 5076 3842 3845 5076 3845 5077 5076 5073 5075 5082 3842 5075 5075 5073 5082 5081 3839 5082 5082 3839 3842 5082 5073 5036 5082 5036 5081 5080 3840 5081 5081 3840 3839 5036 5080 5081 3839 3840 3841 3839 3841 3842 5080 3841 3840 5079 3841 5080 5033 5079 5080 5033 5080 5036 3842 3841 3843 5079 3843 3841 5078 3843 5079 5025 5079 5033 5025 5078 5079 3842 3843 3844 5078 3844 3843 5077 3844 5078 5030 5077 5078 5030 5078 5025 3842 3844 3845 5077 3845 3844 5030 5029 5077 3790 5029 5030 3790 5030 3791 3791 5030 5025 3794 5028 5029 3794 5029 3795 3795 5029 3790 3790 3791 3792 3792 3795 3790 3791 3796 3792 3791 5025 3796 3793 3795 3792 3796 5026 3792 3792 5026 5027 3792 5027 3793 3793 3794 3795 3793 5028 3794 3793 5027 5028 4971 5028 5027 4971 5027 4972 4972 5027 5026 3796 5025 5026 5026 5025 4936 5026 4936 4972 3745 4971 4972 3745 4972 3746 3746 4972 3747 4972 4936 4930 4972 4930 3747 3744 4971 3745 3744 4976 4971 3741 3744 3745 3745 3746 3741 3741 3746 3747 3741 3742 3743 3741 3743 3744 3741 3747 4973 3741 4973 3742 3743 4976 3744 3743 4975 4976 4975 5021 4976 3742 4975 3743 3742 4973 4974 3742 4974 4975 4973 3747 4882 4929 4974 4973 4929 4973 4924 4924 4973 4882 3701 4928 4929 3701 4929 3702 3702 4929 4924 4929 4928 4974 3702 4924 3703 3703 4924 4925 4924 4882 4925 3702 3703 3699 3702 3699 3701 3699 3700 3701 3700 4928 3701 3700 4927 4928 4927 4966 4928 4974 4928 4966 3699 4927 3700 3703 4925 3699 3699 4925 4926 3699 4926 4927 4925 4882 4881 4925 4881 4926 4876 4927 4926 4876 4926 4881 4880 3656 4881 4881 3656 3654 4881 3654 4876 4882 4843 4881 4881 4843 4880 3656 3657 3655 3656 3655 3654 4880 3657 3656 3652 3653 3654 3652 3654 3655 4876 3654 3653 4878 3652 3655 4878 3655 4879 4879 3655 3657 4879 3657 4880 5281 4878 4879 4880 5281 4879 4877 3652 4878 5280 4877 4878 5280 4878 5281 4877 3653 3652 4876 3653 4877 4876 4877 3692 3692 4877 5280 3692 4919 4876 4919 4927 4876 3691 3692 3693 3691 4919 3692 3693 3692 4920 5280 4920 3692 3697 4918 4919 3697 4919 3691 4919 4918 4927 4927 4918 4966 3698 4918 3697 3698 4923 4918 4923 4966 4918 3697 3691 3693 3697 3693 3698 3698 3693 3696 3696 4923 3698 3696 4922 4923 4922 4960 4923 4923 4960 4966 3693 3695 3696 3695 4922 3696 3695 4921 4922 4960 4922 4921 3693 3694 3695 3694 4921 3695 3694 4920 4921 4960 4921 5280 5280 4921 4920 3693 4920 3694 5003 5280 3821 5280 5003 5004 5004 5005 5280 5280 5005 4960 5002 3775 5003 5003 3775 3774 5003 3774 5004 3821 5002 5003 5004 3774 3773 5004 3773 5005 5005 3773 3776 5005 3776 5006 5005 5006 4960 3771 3772 3773 3773 3774 3775 3773 3775 3771 3773 3772 3776 5002 3771 3775 5007 3772 3771 5007 3771 5008 5008 3771 5002 5006 3776 3772 5006 3772 5007 4960 5006 5008 5008 5006 5007 5008 5002 3821 5008 5016 4957 4957 4958 5008 5008 4958 4960 3818 3821 5052 5052 3821 5053 5101 5053 3821 3815 3817 3818 3818 5052 3815 3815 5052 3816 3816 5052 5053 3816 5053 3817 3817 5053 5054 5054 5053 5101 3815 3816 3817 3817 5054 5049 5054 5101 5049 5101 3870 5049 5100 5049 3870 3869 3865 3870 5100 3870 3865 3870 5101 3869 3864 5099 5100 3864 5100 3865 3864 3865 3866 3869 3866 3865 3869 5101 3866 3864 3866 3867 3866 5101 5102 3866 5102 5103 3866 5103 3867 3867 3868 3864 3868 5099 3864 3868 5104 5099 5099 5104 5147 3867 5104 3868 3867 5103 5104 4959 3729 4960 4960 3729 4961 5011 4960 5010 5010 4960 5016 5011 5012 4960 4960 5012 4966 4960 4958 4959 4960 4961 4962 4960 4962 5016 4961 3729 3733 4961 3733 4962 4962 3733 3728 4962 3728 4963 5016 4962 4963 3729 3728 3733 3727 3728 3729 4963 3728 3727 4963 3727 4957 4963 4957 5016 3729 3732 3727 4957 3727 3732 3729 3730 3731 3729 3731 3732 4959 3730 3729 4957 3732 4958 4958 3732 3731 4958 3731 3730 4958 3730 4959 5015 3777 5016 5016 3777 5009 5010 5016 5009 5016 5063 5015 5014 3778 5015 5015 3778 3777 5063 5014 5015 5013 3782 5014 5014 3782 3778 4966 5013 5014 4966 5014 5063 3777 3778 3779 3779 3778 3782 5013 3779 3782 5012 3779 5013 4966 5012 5013 3779 3780 3781 3779 3781 3777 5012 3780 3779 5011 3780 5012 5010 3781 3780 5010 3780 5011 5009 3781 5010 5009 3777 3781 4965 3737 4966 4966 3737 3736 4966 3736 4967 5063 4965 4966 4974 4966 4967 3736 3737 3738 4965 3738 3737 4964 3738 4965 5063 4964 4965 5018 4964 5063 5018 5063 5017 5017 5063 5024 4964 3739 3738 4970 3739 4964 4970 4964 5018 3736 3738 3739 3736 3739 3734 4970 3734 3739 4969 3734 4970 4970 5018 5019 4970 5019 4969 3734 3735 3736 4969 3735 3734 4968 3735 4969 4969 5019 5020 4969 5020 4968 5018 3786 5019 5019 3786 5020 5020 3786 3785 5020 3785 5021 4975 5020 5021 4968 5020 4975 3785 3786 3787 5018 3787 3786 3785 3787 3788 5018 3788 3787 5017 3788 5018 3785 3788 3783 5024 3783 3788 5024 3788 5017 3783 3784 3785 5023 3784 3783 5023 3783 5024 3785 3784 3789 5021 3785 3789 4968 4975 4974 4967 3740 4968 4968 3740 3735 4968 4974 4967 4967 3736 3740 3736 3735 3740 4841 4840 5281 4880 4841 5281 4840 4800 5281 4800 4801 5281 5281 4801 5279 4842 4880 4843 4842 4841 4880 3618 4841 4842 3618 4842 3619 3619 4842 4843 3619 4843 3616 3616 4843 4838 4882 4838 4843 3618 3619 3616 3618 3616 3615 3615 4841 3618 3615 3616 3617 3616 4838 3617 3620 3615 3621 3621 3615 3617 3620 4840 3615 3615 4840 4841 3617 4838 4839 3617 4839 3621 3621 4839 3620 3620 4839 4840 4839 4800 4840 4839 4799 4800 4839 4885 4799 4838 4884 4839 4839 4884 4885 4799 3579 4800 4800 3579 3578 4800 3578 4801 3578 3579 3580 4799 3580 3579 3578 3580 3581 4801 3578 3581 4801 3581 4802 5279 4801 4802 3582 3583 3581 3582 3581 3580 4802 3581 3583 4804 3582 3580 4804 3580 4799 4803 3583 3582 4803 3582 4804 4802 3583 4803 4802 4803 5279 5279 4803 4844 4844 4803 4804 4844 4804 4845 4845 4804 4799 4885 4886 4799 4845 4799 4886 3622 4844 4845 3622 4845 3625 3625 4845 4846 4845 4886 4846 4885 3662 4886 4886 3662 4887 4846 4886 4887 4884 3663 4885 4885 3663 3662 3662 3663 3661 3662 3661 3660 4887 3662 3660 4887 3660 4882 4846 4887 4934 4934 4887 4882 3658 3659 3660 3658 3660 3661 4882 3660 3659 4884 3658 3661 4884 3661 3663 4883 3658 4884 4883 4884 4838 4883 3659 3658 4882 3659 4883 4882 4883 4838 4932 4882 4931 4931 4882 3747 4934 4882 4932 4931 3705 4932 4932 3705 3704 4932 3704 4933 4934 4932 4933 4930 3706 4931 4931 3706 3705 3747 4930 4931 3704 3705 3706 3704 3706 3707 4930 3707 3706 4936 3707 4930 3704 3707 3708 4936 3708 3707 4935 3708 4936 4978 4935 4936 4978 4936 4979 4979 4936 5025 3708 3709 3704 4935 3709 3708 4934 3709 4935 4977 4934 4935 4977 4935 4978 3750 4977 4978 3750 4978 3751 3751 4978 4979 3748 3749 3750 3750 3751 3752 3750 3752 3748 3750 3749 3753 3753 4977 3750 3751 4979 3752 3752 4979 4980 3752 4980 3748 3748 4980 4981 3748 4981 3749 3749 4981 4982 3749 4982 3753 3753 4982 4977 4981 4938 4982 4854 4977 4982 4939 4854 4982 4982 4938 4939 4937 3715 4938 4938 3715 3714 4938 3714 4939 4981 4937 4938 4939 3714 3713 4939 3713 4940 4940 4854 4939 3713 3714 3715 3713 3715 3711 4937 3711 3715 4943 3711 4937 4900 4943 4937 4937 4981 4900 3711 3712 3713 4943 3712 3711 3713 3712 3716 4940 3713 3716 4940 3716 4941 4854 4940 4941 4941 3716 4942 4942 3716 3712 4942 3712 4943 4900 4942 4943 4900 4854 4942 4854 4941 4942 4899 3669 4900 4900 3669 4894 4861 4899 4900 4894 4895 4900 4900 4895 4854 4900 4981 5033 4986 4861 4900 4986 4900 3756 3756 4900 4985 4985 4900 5033 4894 3673 4895 4894 3669 3673 3671 3672 3673 3671 3673 3669 4895 3673 3672 3669 3670 3671 3671 3670 3674 4896 3672 3671 4896 3671 4897 4897 3671 3674 4895 3672 4896 4897 4855 4896 4896 4855 4854 4896 4854 4895 4897 3674 4898 4898 4859 4897 4897 4859 4855 4898 3674 3670 4898 3670 4899 4899 4860 4898 4898 4860 4859 4899 3670 3669 4899 4861 4860 3639 4859 4860 3639 4860 3634 3634 4860 3638 3638 4860 4861 3636 3639 3634 3636 4859 3639 3634 3635 3636 3637 3635 3634 3637 3634 3638 3638 4861 3637 3637 4856 3635 3637 4861 4856 3635 4856 4857 3635 4857 4858 3635 4858 3636 3636 4858 4859 4859 4858 4768 4768 4858 4774 4774 4858 4821 4821 4858 4857 4821 4857 4856 4856 4861 4821 3596 4820 4821 3596 4821 3597 3597 4821 3598 3598 4821 4822 4774 4821 4820 3595 3596 3597 3595 4820 3596 3595 4819 4820 4774 4820 4773 4773 4820 4819 3597 3599 3595 3599 4819 3595 3597 3598 3599 3598 3600 3599 3598 4822 4823 3598 4823 3600 4904 4823 4822 3600 4823 3601 4905 3601 4823 4905 4823 4904 3599 3600 3601 3599 3601 4818 3599 4818 4819 4778 4818 3601 4778 3601 4905 4733 4819 4818 4733 4818 4778 3515 4732 4733 3515 4733 3516 3516 4733 4734 4733 4691 4734 4691 4733 4778 4732 4819 4733 3513 3514 3515 3513 3515 3516 3514 4732 3515 3516 4734 3513 3514 3513 3517 3517 3513 3518 3513 4734 4735 3513 4735 3518 3517 4731 3514 3514 4731 4732 3517 3518 3519 3517 3519 4730 3517 4730 4731 3518 4735 3519 3519 4771 4730 4689 4771 3519 4689 3519 4645 4645 3519 4646 4646 3519 4735 4730 4771 4772 4730 4772 4731 4772 4732 4731 4771 3555 4772 4772 3555 3551 4772 3551 4773 4772 4773 4732 4732 4773 4819 4773 3551 3553 4773 3553 4774 3551 3552 3553 4774 3553 3552 4774 3552 4768 3550 3552 3551 4768 3552 3550 4768 3550 4769 4859 4768 4769 3549 3550 3551 4769 3550 3549 3549 3551 3554 4769 3549 4770 4770 3549 3554 3554 3551 3555 4770 3554 3555 4770 3555 4771 4769 4770 4689 4770 4771 4689 4689 4682 4769 4769 4682 4726 4769 4726 4725 4769 4725 4811 4769 4811 4859 4859 4811 4817 4859 4817 4816 4859 4816 4815 4859 4815 4855 3590 4816 4817 3590 4817 3594 3594 4817 4811 3589 4815 4816 3589 4816 3590 3593 4814 4815 3593 4815 3589 4855 4815 4814 3632 4854 4855 3632 4855 4850 4814 4850 4855 3592 4813 4814 3592 4814 3593 4813 4767 4814 4814 4767 4850 3592 3593 3591 3591 3593 3589 3589 3590 3591 3590 3594 3591 3594 4811 3591 3591 4811 4812 3591 4812 3592 3592 4812 4813 4813 4766 4767 4812 4766 4813 4811 4725 4812 4812 4725 4729 4729 4675 4812 4812 4675 4766 4765 3548 4766 4766 3548 3545 4766 3545 4767 4675 4765 4766 4764 3546 4765 4765 3546 3548 4764 4765 4675 3548 3546 3545 3544 3545 3546 3544 3547 3545 4767 3545 3547 4764 3544 3546 4762 3547 3544 4762 3544 4763 4763 3544 4764 4767 3547 4762 4850 4767 4851 4851 4767 4762 4851 4762 4763 4851 4763 4724 4724 4763 4764 3633 4850 4851 3633 4851 3630 3630 4851 3628 3628 4851 4852 4724 4809 4851 4851 4809 4810 4851 4810 4852 3632 4850 3633 3632 3633 3630 3628 3629 3630 3630 3629 3631 3632 3630 3631 3628 4852 4853 3628 4853 3629 4852 4810 4853 3629 4853 4854 4853 4810 4805 4853 4805 4888 4888 4854 4853 3629 4854 3631 3631 4854 3632 4893 4854 4888 4854 4893 4892 4854 4892 4977 3668 4888 3664 3664 4888 4889 3668 4893 4888 4889 4888 4805 3667 4892 4893 3667 4893 3668 3666 4891 4892 3666 4892 3667 4977 4892 4891 4977 4891 4934 3666 4890 4891 4890 4934 4891 3664 3665 3666 3664 3666 3667 3665 4890 3666 3667 3668 3664 3664 4889 3665 4889 4890 3665 4889 4847 4890 4890 4847 4846 4890 4846 4934 4933 3710 4934 4934 3710 3709 4933 3704 3710 3704 3709 3710 3625 4846 4847 3625 3623 3622 3625 4847 3623 3622 3623 3624 3623 4847 3624 3626 3627 3622 3626 3622 3624 3627 4844 3622 3624 4847 4848 3624 4848 3626 3626 4848 4849 3626 4849 3627 3627 4849 4844 4757 5279 4844 4757 4844 4756 4756 4844 4849 4849 4848 4756 4756 4848 4889 4889 4848 4847 4806 4756 4889 4806 4889 4805 4805 3587 4806 4806 3587 3584 4806 3584 4807 4807 4761 4806 4806 4761 4756 4810 3585 4805 4805 3585 3587 3584 3587 3585 3584 3585 3586 4807 3584 3586 3588 3586 3585 4810 3588 3585 4809 3588 4810 4809 3586 3588 4807 3586 4808 4808 3586 4809 4808 4809 4724 4718 4807 4808 4718 4808 4724 4723 3502 4724 4724 3502 3501 4724 3501 4718 4724 4764 4723 3500 3501 3502 3500 3502 3503 3504 3503 3502 4723 3504 3502 4718 3501 3500 4718 3500 4719 4719 3500 3503 3504 3505 3503 4719 3503 4720 4720 3503 4721 4721 3503 3505 4722 3505 3504 4722 3504 4723 4721 3505 4722 5278 4720 4721 5278 4721 4722 5279 4719 4720 5279 4720 5278 4718 4719 4759 4759 4719 5279 4757 4758 5279 5279 4758 4759 5297 5279 5278 4758 3543 4759 4759 3543 3542 4759 3542 4760 4718 4759 4760 4718 4760 4807 4760 3542 3540 4760 3540 4761 4807 4760 4761 3542 3543 3541 3542 3541 3540 4758 3541 3543 4757 3541 4758 3538 3540 3541 4757 3538 3541 3538 3539 3540 4761 3540 4756 4756 3540 3539 4756 3539 3538 4756 3538 4757 5278 4636 4637 5278 4637 5277 4678 5278 4722 4678 4679 5278 5278 4679 4680 4728 4636 5278 4728 5278 4680 5277 5295 5278 5297 5278 5295 4678 4722 4677 4677 4722 4723 4676 3468 4677 4677 3468 3465 4677 3465 4678 4677 4723 4676 4676 4723 4675 4723 4764 4675 4675 3469 4676 4676 3469 3468 3468 3469 3466 3468 3466 3465 3465 3466 3467 4678 3465 3467 3470 3467 3466 4678 3467 4679 4679 3467 3470 4679 3470 4680 4680 3470 3466 4680 3466 4681 4681 3466 4675 4675 3466 3469 4729 4681 4675 4729 4680 4681 4728 4680 4729 3512 4728 4729 3512 4729 3509 3509 4729 3506 3506 4729 4725 3511 3512 3509 3511 4728 3512 3506 3508 3509 3509 3508 3510 3511 3509 3510 3506 3507 3508 3506 4725 3507 3507 4725 3508 3508 4725 4726 3508 4726 3510 3510 4726 4727 3510 4727 3511 3511 4727 4728 4634 4728 4727 4726 4682 4727 4727 4682 4683 4683 4634 4727 4682 3472 3471 4682 3471 4683 4689 3472 4682 4683 3471 4684 4684 4640 4683 4683 4640 4634 3471 3472 3473 3471 3473 3474 3471 3474 3476 4684 3471 3476 3473 3472 3475 4689 3475 3472 4686 3474 3473 4686 3473 4687 4687 3473 4688 4688 3473 3475 4685 3476 3474 4685 3474 4686 4684 3476 4685 4602 4684 4685 4602 4685 4603 4603 4685 4686 4687 4603 4686 4688 4689 4687 4687 4689 4603 4688 3475 4689 4689 4645 4644 4689 4644 4603 3431 4644 4645 3431 4645 4646 3436 4643 4644 3436 4644 3431 4603 4644 4604 4604 4644 4643 3431 3433 3436 3433 4643 3436 3431 3432 3433 3431 3434 3432 3431 4646 3434 3434 4646 3435 4646 4735 3435 3432 3434 3435 3435 4641 3432 3432 4641 4642 3432 4642 3433 3433 4642 4643 4642 4641 4573 4642 4573 4567 4642 4567 4643 4572 3365 4573 4573 3365 3362 4573 3362 4567 4573 4641 4572 4567 3362 3361 4567 3361 4568 4643 4567 4604 4604 4567 4568 3361 3362 3363 3363 3362 3365 4572 3363 3365 3361 3363 3364 4571 3364 3363 4571 3363 4572 3361 3364 3366 4568 3361 3366 4569 3366 3364 4569 3364 4570 4570 3364 4571 4572 3329 4571 4571 3329 5276 4571 5276 4570 5276 4569 4570 5276 3329 4537 5276 4537 5275 4606 4569 5276 4606 5276 5277 3328 4536 4537 3328 4537 3329 5275 4537 4536 3326 3328 3324 3324 3328 3329 3326 4536 3328 3326 4535 4536 4536 4535 5275 3324 3325 3326 3326 3325 3327 3327 4535 3326 3324 3329 4533 3324 4533 3325 3325 4533 4534 3325 4534 3327 3327 4534 4535 5275 4535 4504 4535 4534 4504 4504 4534 4609 4609 4534 4533 3329 4641 4533 4533 4641 4609 4572 4641 3329 3435 4609 4641 3435 4735 4609 4608 4735 4607 4607 4735 4734 4735 4608 4609 4607 3402 4608 4608 3402 4609 3401 3402 3403 3402 3401 3405 4607 3403 3402 4609 3402 3405 3401 3403 3404 4612 3404 3403 4612 3403 4607 4611 3401 3404 4611 3404 4612 3405 3401 3406 4610 3406 3401 4610 3401 4611 4609 3405 3406 4609 3406 4610 4609 4610 4611 4609 4611 4612 4609 4576 4504 4612 4575 4609 4609 4575 4576 4575 3371 4576 4576 3371 3372 4576 3372 4577 4504 4576 4577 4574 3368 4575 4575 3368 3371 4612 4574 4575 3368 3367 3371 3371 3367 3372 4577 3372 3367 4577 3367 4578 4504 4577 4578 3367 3368 3369 3367 3369 3370 4578 3367 4579 4579 3367 3370 4574 3369 3368 4580 3369 4574 4612 4580 4574 4580 3370 3369 4579 3370 4580 4580 4578 4579 4504 4578 4580 4503 3298 4504 4504 3298 4505 4469 4470 4504 4504 4470 3268 4504 3268 5275 4580 4502 4504 4504 4502 4503 4505 4506 4504 4504 4506 4468 4504 4468 4469 4505 3298 3299 4505 3299 4506 4506 3299 3296 4506 3296 3297 4506 3297 4507 4468 4506 4507 3298 3296 3299 3294 3295 3296 3296 3295 3297 3294 3296 3298 4507 3297 3295 4507 3295 4501 4468 4507 4580 4580 4507 4501 4501 3295 4502 4502 3295 3294 4502 3294 4503 4503 3294 3298 4580 4501 4502 4543 4539 4580 4580 4539 4540 4580 4540 4541 4580 4541 4468 4649 4648 4580 4580 4648 4543 4649 4580 4612 4539 3330 4540 4540 3330 3335 4540 3335 4541 4541 3335 4542 4468 4541 4542 3330 3332 3335 4542 3335 3332 3330 3331 3332 4539 3331 3330 3331 3333 3332 3332 3333 3334 4542 3332 4543 4543 3332 3334 4542 4543 4509 4468 4542 4509 4543 3334 4544 4543 4544 4538 4543 4538 4539 4511 4510 4543 4543 4510 4509 4543 4648 4652 4543 4618 4583 4543 4583 4511 4652 4616 4543 4543 4616 4617 4543 4617 4618 4538 3331 4539 4538 3333 3331 4544 3334 3333 4544 3333 4538 4617 3412 4618 4618 3412 3407 4618 3407 4619 4618 4619 4583 3411 3407 3412 4616 3411 3412 4616 3412 4617 3408 3407 3411 4615 3408 3411 4615 3411 4616 4652 4615 4616 4614 3408 4615 4652 4614 4615 3407 3408 3409 4613 3409 3408 4613 3408 4614 4700 4613 4614 4700 4614 4652 4620 3409 4613 4700 4620 4613 3407 3409 3410 4620 3410 3409 4619 3410 4620 4700 4619 4620 4585 4584 4700 4584 4583 4700 4583 4619 4700 4619 3407 3410 3375 4582 4583 3375 4583 3379 3379 4583 3378 3378 4583 4584 4512 4511 4583 4583 4582 4477 4583 4477 4512 3375 3377 4582 4477 4582 4475 4582 3377 4475 3375 3376 3377 3376 4581 3377 4475 3377 4549 4549 3377 4581 3375 3374 3376 3374 4581 3376 3374 4585 4581 3373 3374 3375 3373 4585 3374 3373 4584 4585 3373 3375 3378 3378 4584 3373 3378 3375 3379 4548 4549 3343 3343 4549 3346 3346 4549 4550 4549 4548 4475 3342 4547 4548 3342 4548 3343 4475 4548 4547 3340 3342 3343 3336 3340 3343 3336 3343 3346 3346 4550 3336 3336 4550 3337 3337 4550 4551 3336 3337 3338 3338 3340 3336 3337 4551 3338 3338 4551 4552 3338 3339 3340 3338 4552 3339 3339 4552 4553 3340 3339 3341 3339 4553 3341 3341 4553 4554 3340 3341 3344 3341 4554 3344 3344 4554 4545 3340 3344 3345 3344 4545 3345 3345 4545 4546 3345 4546 3340 3340 4546 4547 4545 4547 4546 3340 4547 3342 4475 4547 4545 4474 3270 4475 4475 3270 4476 4545 4442 4475 4475 4442 4443 4443 4444 4475 4475 4444 4384 4477 4475 4476 4384 4480 4475 4475 4480 4474 4476 3270 3273 4476 3273 4477 3270 3269 3273 3273 3269 3274 4477 3273 3274 3269 3270 3271 3269 3271 3272 4478 3274 3269 4478 3269 4479 4479 3269 3272 4477 3274 4478 4478 4479 4410 4410 4477 4478 4479 3272 4480 4410 4479 4384 4384 4479 4480 4480 3272 3271 4480 3271 4474 4474 3271 3270 4384 3177 4385 4390 3177 4384 4384 4385 4410 5274 4390 4384 4384 4355 4356 4356 4357 4384 4384 4357 4358 4384 4358 5274 4446 4447 4384 4384 4447 4440 4384 4444 4445 4384 4445 4446 4384 4440 4355 4445 3239 4446 4446 3239 3238 4446 3238 4447 4444 3239 4445 4443 3233 4444 4444 3233 3232 4444 3232 3239 3236 3238 3239 3232 3236 3239 4447 3238 3236 4447 3236 4448 4447 4448 4440 4448 3236 3241 4448 3241 4449 4449 4440 4448 3236 3240 3241 4449 3241 3240 4449 3240 4440 3237 3240 3236 4440 3240 3237 3236 3235 3237 4440 3237 4441 4441 3237 3235 3234 3235 3236 4441 3235 4442 4442 3235 3234 4440 4441 4545 4545 4441 4442 4442 3234 4443 3232 3233 3234 3234 3236 3232 4443 3234 3233 4417 4545 4418 4418 4545 4515 4545 4417 4416 4545 4416 4440 4545 4517 4515 3210 4416 4417 3210 4417 3207 3207 4417 4418 3211 4415 4416 3211 4416 3210 4416 4415 4440 3207 3206 3210 3210 3206 3211 3206 3207 3208 3207 4418 3208 3208 3209 3206 3209 4414 3206 3206 4414 4415 3206 4415 3211 4440 4415 4414 4332 4331 4440 4354 4440 4353 4353 4440 4362 4331 4330 4440 4440 4330 5273 4440 5273 4362 4440 4414 4332 4355 4440 4354 4353 3151 4354 4362 3154 4353 4353 3154 3151 4361 3155 4362 4362 3155 3154 5273 4361 4362 3151 3154 3150 3150 3154 3155 3150 3149 3151 4354 3151 3149 3148 3149 3150 4354 3149 4355 4355 3149 3148 4355 3148 4356 3146 3147 3148 3148 3150 3146 4356 3148 3147 4356 3147 4357 4357 3147 3146 3146 3150 3153 4357 3146 4358 4358 3146 3153 3150 3152 3153 4358 3153 4359 4359 3153 3152 5274 4358 4359 4359 3152 4360 5274 4359 5285 5285 4359 4360 4360 3152 3150 4360 3150 4361 5285 4360 5273 5273 4360 4361 4361 3150 3155 4306 5272 5273 4306 5273 4307 5273 4328 4307 5273 4330 4329 5273 4329 4328 5291 5273 5272 5273 5291 5285 3125 4328 3124 3124 4328 4329 3125 4333 4328 4307 4328 4333 3124 4329 3127 3127 4329 4330 3127 4330 3126 3126 4330 4331 3126 3124 3127 3122 3123 3124 3123 3125 3124 3122 3124 3126 3123 4333 3125 3123 4332 4333 4307 4333 4332 3122 4332 3123 3126 4331 3122 3122 4331 4332 4307 4332 4302 4332 4414 4302 3102 4306 4307 3102 4307 3101 3101 4307 4302 3101 4302 4303 4303 4302 4414 3099 3098 3101 3101 3098 3102 3101 4303 3099 3098 4306 3102 3098 4305 4306 4306 4305 5272 3098 3099 3100 3100 4305 3098 3099 4303 4304 3099 4304 3100 4303 4414 4304 3209 4419 4414 4304 4414 4396 4419 4396 4414 3208 4419 3209 4418 4419 3208 4419 4515 4391 4419 4391 4396 4418 4515 4419 3311 4515 3307 3307 4515 4516 3311 4520 4515 4515 4392 4391 4515 4517 4516 3184 4391 4392 3184 4396 4391 3184 4392 3181 3181 4392 4393 3181 3183 3184 3184 3183 3185 3185 4396 3184 3181 3182 3183 3181 4393 3182 3182 4393 4394 4366 4394 4393 3182 4394 4395 3182 4395 3183 3183 4395 3185 3185 4395 4396 4304 4396 4395 4395 4394 4304 4304 4394 4366 3100 4304 4305 4276 4275 4304 4305 4304 4275 4304 4366 4276 5272 4305 4275 4256 5264 5272 5272 4275 4256 5264 5290 5272 5272 5309 5291 5290 5324 5272 5272 5324 5309 5290 5264 5289 5290 5289 5326 5326 5351 5290 5290 5351 5324 5323 5322 5324 5323 5324 5325 5309 5324 5322 5324 5351 5325 5326 5358 5351 5325 5351 5358 5321 5323 5325 5360 5321 5325 5360 5325 5387 5387 5325 5358 5321 5322 5323 5321 5320 5322 5309 5322 5310 5310 5322 5320 5317 5320 5321 5359 5317 5321 5359 5321 5360 5362 5359 5360 5362 5360 5387 5318 5317 5359 5316 5317 5318 5316 5319 5317 5317 5319 5320 5316 5284 5293 5293 5319 5316 5311 5320 5319 5311 5319 5293 5293 5274 5292 5293 5284 5274 5292 5311 5293 5285 5310 5311 5285 5311 5292 5310 5320 5311 5274 5285 5292 5291 5310 5285 5291 5309 5310 5274 4409 4413 5274 4413 4412 5274 4412 4385 4439 3205 5274 5274 3205 4409 5274 5284 4439 4388 4389 5274 5274 4389 4390 4385 4387 5274 5274 4387 4388 4387 3180 4388 4388 3180 3175 4388 3175 4389 4389 3175 3178 4389 3178 4390 4390 3178 3177 3175 3177 3178 3175 3176 3177 3176 3175 3179 3179 3175 3180 4387 3179 3180 4386 3179 4387 4385 4386 4387 4386 3176 3179 4385 3177 3176 4385 3176 4386 4385 4412 4411 4385 4411 4410 3202 4411 4412 3202 4412 3203 3203 4412 4413 3200 4410 4411 3200 4411 3202 3201 3200 3202 3201 3202 3203 3203 4413 3201 3201 4413 4409 3200 3201 3198 3198 3201 3204 3201 4409 3204 3198 3199 3200 3199 4410 3200 3198 3204 3205 3198 3205 4410 3198 4410 3199 3204 4409 3205 4438 3205 4439 4437 3205 4438 4437 4410 3205 3228 4437 4438 3228 4438 3224 3224 4438 3230 3230 4438 4439 3230 4439 3231 4439 5284 3231 3229 3224 3230 3229 3230 3231 3225 3224 3229 3229 3231 4434 3229 4434 3225 3224 3225 3226 3225 4434 4435 3225 4435 3226 4435 4434 4468 4468 4434 3231 4435 4436 3226 4468 4509 4435 4435 4509 4436 3226 3227 3224 3226 4436 3227 3227 4436 4437 4436 4509 4508 4436 4508 4410 4436 4410 4437 3306 4508 4509 3306 4509 3304 3304 4509 4510 3304 3305 3306 3305 4508 3306 3302 4514 4508 3302 4508 3305 4508 4514 4410 4513 4477 4410 4513 4410 4514 3302 4513 4514 3303 4512 4513 3303 4513 3302 4512 4477 4513 3302 3301 3303 3301 4512 3303 3301 4511 4512 3300 3301 3302 3300 4511 3301 3300 4510 4511 3300 3302 3304 3304 4510 3300 3304 3302 3305 3227 4437 3228 3224 3227 3228 4468 3265 4469 4473 3265 4468 3231 4473 4468 3263 3264 3265 3263 3265 3266 4469 3265 3264 4473 3266 3265 4469 3264 4470 3264 3263 3267 4470 3264 3267 4470 3267 3268 3267 3263 3268 4471 3268 3263 4471 3263 4472 4472 3263 3266 4472 3266 4473 3231 4472 4473 3231 5284 4472 4472 5284 4471 5284 3268 4471 5275 3268 5284 5387 5358 5356 5356 5357 5387 5387 5357 5348 5387 5348 5388 5426 5362 5387 5356 5358 5326 5326 5347 5356 5356 5347 5357 5348 5357 5347 5347 5286 5348 5286 5350 5348 5326 5288 5347 5347 5288 5286 5326 5289 5288 5271 5286 5288 5271 5288 5264 5264 5288 5289 5286 5271 5270 5286 5270 5287 5287 5350 5286 4215 4198 5271 5271 4198 4199 5271 4199 4175 4175 4174 5271 5271 4174 5270 5264 4216 5271 5271 4216 4215 4198 3001 4199 4199 3001 2998 4199 2998 4193 4175 4199 4193 2999 2998 3001 4198 2999 3001 2997 2998 2999 4193 2998 2997 4193 2997 4194 4175 4193 4176 4176 4193 4194 2997 2999 3000 2997 3000 3002 4194 2997 4195 4195 2997 3002 4197 3000 2999 4197 2999 4198 4196 3002 3000 4196 3000 4197 4195 3002 4196 4286 4194 4195 4286 4195 4285 4285 4195 4196 4176 4194 4286 4285 3083 4286 4286 3083 3082 4286 3082 4281 4176 4286 4177 4177 4286 4281 3081 3082 3083 4285 3081 3083 3081 3080 3082 4281 3082 3080 4281 3080 4282 4282 4172 4281 4281 4172 4177 2979 4176 4177 2979 4177 2981 2981 4177 4172 2978 2977 2979 2978 2979 2981 2977 4176 2979 2977 4175 4176 2976 2977 2978 2977 2976 2980 2980 4175 2977 2978 2981 2982 2978 2982 2976 2981 4172 2982 2976 2982 4173 4173 2982 5270 5270 2982 4266 4266 2982 4172 2976 4173 4174 2976 4174 2980 2980 4174 4175 5270 4174 4173 4144 4145 5270 5270 4158 4159 4159 4152 5270 5270 4152 4153 4153 4241 5270 5270 4241 4144 4266 4157 5270 5270 4157 4158 4157 2958 4158 4158 2958 2960 4158 2960 4159 4159 2960 2957 4159 2957 4152 4152 2957 2956 4152 2956 4153 2956 2957 2958 2958 2957 2960 2956 2958 2959 4156 2959 2958 4156 2958 4157 4266 4156 4157 4155 2959 4156 4375 4155 4156 4156 4260 4261 4156 4261 4375 4260 4156 4266 4154 2959 4155 4376 4154 4155 4376 4155 4375 4153 2961 4154 4154 2961 2959 4153 4154 4377 4377 4154 4376 4375 3166 4376 4376 3166 4377 3164 3165 3166 4375 3164 3166 4377 3166 3165 3163 3165 3164 4377 3165 4370 4370 3165 3163 3162 3163 3164 4370 3163 4371 4371 3163 3162 4371 3045 4370 3045 4377 4370 3045 3046 3047 3047 4243 3045 3046 3045 4244 4244 3045 4371 4243 4377 3045 3047 3046 3043 3046 4244 3043 3047 3043 3044 3044 4243 3047 3044 4242 4243 4242 4377 4243 4242 4153 4377 3044 4241 4242 4241 4153 4242 3043 3042 3044 3042 4241 3044 3041 3042 3043 3043 4244 4245 3043 4245 3041 3041 4246 3042 3042 4246 4241 4144 4241 4143 4143 4241 4246 3041 4245 4246 4143 4246 4142 4245 4142 4246 4244 4346 4245 4245 4346 4347 4245 4347 4142 4141 2944 4142 4142 2944 2949 4142 2949 4143 4347 4141 4142 4143 2949 2948 4143 2948 4144 2948 2949 2944 2948 2944 2946 4144 2948 2946 2944 2945 2946 2947 2945 2944 4140 2947 2944 4140 2944 4141 4347 4140 4141 4139 2947 4140 4225 4140 4347 4225 4226 4140 4140 4226 4227 4139 2945 2947 4145 2946 2945 4145 2945 4139 4144 2946 4145 4226 3024 4227 4227 3024 3027 4227 3027 4221 4227 4128 4129 4227 4129 4130 4128 4227 4127 4127 4227 4221 3026 3027 3024 4221 3027 3026 4221 3026 4222 4222 4127 4221 4127 2931 2937 4127 2937 4128 4128 2937 2936 4128 2936 4129 4129 2936 2933 4129 2933 4130 4130 2933 4131 2931 2932 2933 2936 2931 2933 4131 2933 2932 2936 2937 2931 4222 3026 3023 4222 3023 4223 3026 3024 3023 3023 3024 3025 3028 3023 3025 4223 3023 3028 4223 3028 4224 4224 4347 4223 4223 4347 4319 4224 3028 4225 4225 3028 3025 4225 3025 4226 4226 3025 3024 4225 4347 4224 4346 3134 4347 4347 3134 4340 4340 4319 4347 4341 4319 4340 4340 3138 4341 4340 3134 3138 3134 3135 3136 3136 3138 3134 4346 3135 3134 4345 3135 4346 4244 4345 4346 3136 3135 3139 4345 3139 3135 3136 3137 3138 4342 3137 3136 4342 3136 4343 4343 3136 3139 4341 3138 3137 4341 3137 4342 4371 4342 4343 4343 3139 4344 4343 4344 4371 4344 3139 4345 4371 4344 4345 4371 4345 4244 4371 3162 4372 4371 4372 4373 3162 3164 3167 4372 3162 3167 4372 3167 4373 4373 3167 3168 4373 3168 4374 3167 3164 3168 4374 3168 3164 4374 3164 4375 4400 4374 4375 4375 4262 4263 4375 4261 4262 4263 4264 4375 4375 4264 4400 4261 3059 4262 4262 3059 3064 4262 3064 4263 4263 3064 3062 4263 3062 4264 4264 3062 3061 4264 3061 4265 4400 4264 4265 3059 3061 3062 3059 3062 3064 3059 3060 3061 4260 3060 3059 4260 3059 4261 3061 3060 3063 4265 3061 3063 4265 3063 4266 4400 4265 4172 4172 4265 4266 4266 3063 3060 4266 3060 4260 4282 4400 4172 4283 4400 4282 4282 3080 3079 4282 3079 4283 4283 3079 3084 4283 3084 4284 4284 4308 4283 3079 3080 3081 3079 3081 3084 3084 3081 3085 4284 3084 3085 4284 3085 4285 4308 4284 4313 4285 4313 4284 4285 3085 3081 4285 4197 4313 4285 4196 4197 4197 4198 4313 4313 4198 4215 4313 4215 4214 4214 4215 3018 3018 4215 3020 3020 4215 4216 3018 3017 4214 3017 4220 4214 3016 3017 3018 3019 3018 3020 3018 3019 3016 3019 3020 3021 3020 4216 3021 3021 4216 4217 5264 4217 4216 3021 4217 3019 3016 3019 3022 3019 4217 4218 3019 4218 3022 4218 4217 5264 3022 4218 4219 5264 4237 4218 4218 4237 4219 3022 4219 3016 3016 4219 4220 4237 4220 4219 3016 4220 3017 3035 3034 4237 4237 3034 4238 5264 4236 4237 4237 4236 3035 4369 4237 5264 5264 4237 4238 3034 3035 3036 4236 3036 3035 3036 3037 3034 3034 3037 3040 4238 3034 3040 4238 3040 4239 5264 4238 4239 4239 3040 3037 3037 3036 3038 3037 3038 3039 4239 3037 4240 4240 3037 3039 4236 3038 3036 4235 3038 4236 4235 3039 3038 4240 3039 4235 4239 4240 5264 5264 4240 4235 4235 4236 5264 5264 4255 4369 5264 4259 4253 5264 4256 4259 4254 4255 5264 4254 5264 4253 4258 3056 4259 4259 3056 3055 4259 3055 4253 4259 4256 4258 4253 3055 3054 4253 3054 4254 4254 3054 3057 4254 3057 4255 3053 3054 3055 3054 3053 3057 3053 3055 3056 4258 3053 3056 4257 3053 4258 4257 4258 4256 3057 3053 3058 4256 3058 3053 4256 3053 4257 4255 3057 3058 4255 3058 4256 4275 4278 4255 4255 4278 4277 4275 4255 4256 4277 4366 4255 4255 4366 4367 4255 4367 4368 4368 4369 4255 4366 3160 3161 4366 3161 4367 4366 4277 4276 4367 3161 3158 4367 3158 4368 4368 3158 3159 4368 3159 4369 4369 3159 3157 4369 3157 4363 4369 4363 4364 3158 3157 3159 3156 3157 3158 3156 3158 3160 3160 3158 3161 4364 3156 3160 4363 3157 4364 4364 3157 3156 3077 4275 4276 3077 4276 3073 3073 4276 4277 3073 3072 3077 3077 3072 3078 3078 4275 3077 3078 4280 4275 4280 4279 4275 4275 4279 4278 3072 4280 3078 3072 4279 4280 3075 4278 4279 3075 4279 3076 3076 4279 3072 4277 4278 3074 3074 4278 3075 3073 4277 3074 3072 3073 3074 3074 3075 3072 3072 3075 3076 4153 2956 2961 2956 2959 2961 3307 4516 3308 3308 4516 4517 3307 3308 3309 3310 3311 3307 3310 3307 3312 3312 3307 3309 3308 4517 3309 3309 4517 3312 3312 4517 4518 3312 4518 4519 3312 4519 3310 3310 4519 4520 3310 4520 3311 3438 4651 4652 3438 4652 3439 3439 4652 4647 4781 4652 4780 4651 4779 4652 4652 4779 4780 4652 4648 4647 3438 4650 4651 4651 4650 4779 3440 4649 4650 3440 4650 3438 4779 4650 4612 4612 4650 4649 3438 3437 3440 3440 3437 3441 3441 4649 3440 3441 4648 4649 3437 4647 4648 3437 4648 3441 3437 3438 3439 3439 4647 3437 4612 4695 4696 4612 4696 4778 4607 4693 4612 4612 4693 4694 4612 4694 4695 4612 4778 4779 4734 4692 4607 4607 4692 4693 4692 3481 4693 4693 3481 3482 4693 3482 4694 4694 3482 3477 4694 3477 4695 3481 3477 3482 3478 3477 3481 4692 3478 3481 4691 3478 4692 4691 4692 4734 3477 3478 3479 4691 3479 3478 3477 3479 3480 4695 3477 3480 4690 3479 4691 4696 3480 3479 4696 3479 4690 4691 4778 4690 4690 4778 4696 4695 3480 4696 4777 3560 4778 4778 3560 3561 4778 3561 4779 4777 3557 3560 3557 3556 3560 3560 3556 3561 4779 3561 3556 4779 3556 4780 3556 3557 3558 3556 3558 3559 4780 3556 3559 4775 3558 3557 4781 3559 3558 4781 3558 4775 4780 3559 4781 4606 5277 4601 4601 5277 4638 5277 4637 4638 4637 3428 4638 4638 3428 3427 4638 3427 4639 4601 4638 4639 4636 3430 4637 4637 3430 3428 3425 3427 3428 3425 3428 3430 3425 3426 3427 3427 3426 3429 4639 3427 3429 4639 3429 4640 4602 4601 4639 4602 4639 4640 4640 3429 4634 4634 3429 3426 4634 3426 4635 4635 3426 3425 4635 3425 4636 4636 3425 3430 4635 4636 4728 4635 4728 4634 4684 4602 4640 3400 4601 4602 3400 4602 3397 3397 4602 3394 3394 4602 4603 3397 3398 3400 3398 4601 3400 3398 4606 4601 3397 3396 3398 3396 4606 3398 3394 3396 3397 3394 3395 3396 3394 4603 3395 3395 4603 3399 3399 4603 4604 3396 3395 3399 3399 4604 3396 3396 4604 4605 3396 4605 4606 4605 4569 4606 4604 4568 4605 4605 4568 4569 4568 3366 4569 4947 4861 4946 4986 4946 4861 4947 4948 4861 4946 3721 4947 4947 3721 3720 4947 3720 4948 4945 3717 4946 4946 3717 3721 4986 4945 4946 3720 3721 3717 3720 3717 3719 4948 3720 3719 4948 3719 4949 3717 3718 3719 4949 3719 3718 4944 3718 3717 4944 3717 4945 4944 4945 4986 4949 3718 4944 4987 4944 4986 3806 4949 4944 4987 3806 4944 4986 3755 4987 4987 3755 3754 4987 3754 4983 4983 5037 4987 4987 5037 3806 3803 3805 3806 3803 3806 5037 3803 5037 3804 3804 5037 5038 4983 5083 5037 5083 5038 5037 3803 3804 3805 3805 3804 3807 3807 5041 3805 3807 3804 3808 3804 5038 3808 3808 5038 5039 3808 5039 3807 3807 5039 5040 3807 5040 5041 3852 3853 5083 3852 5083 3851 3853 5089 5083 5035 3851 5083 4983 5035 5083 5089 5088 5083 3852 3847 3853 3847 5089 3853 3847 5088 5089 3846 5087 5088 3846 5088 3847 3846 3847 3848 3852 3848 3847 3849 3850 3846 3846 3848 3849 3850 5087 3846 3850 5086 5087 3849 5086 3850 3848 5084 3849 3849 5084 5085 3849 5085 5086 3851 3848 3852 3848 3851 5084 3851 5036 5084 5036 5131 5084 5084 5131 5085 5132 5086 5085 5132 5085 5131 5132 5133 5086 5131 3899 5132 5132 3899 3901 5132 3901 5133 5130 3900 5131 5131 3900 3899 5036 5130 5131 3899 3900 3901 3901 3900 3898 5133 3901 3898 5133 3898 5134 3896 3897 3898 3898 3900 3902 3898 3902 3896 5134 3898 3897 5130 3902 3900 5129 3902 5130 5129 5130 5036 5129 3896 3902 5128 3896 5129 5128 3897 3896 5134 3897 5128 5129 5134 5128 5178 5179 5129 5170 5178 5129 5170 5129 3935 3935 5129 5171 5179 5180 5129 5036 5126 5129 5129 5126 5127 5129 5127 5171 3934 3935 3936 3934 5170 3935 3936 3935 5171 3932 3931 3934 3932 3934 3936 3931 5170 3934 3936 5171 3932 3931 3932 3933 3932 5171 5172 3932 5172 3933 3937 3938 3931 3937 3931 3933 3938 5169 3931 3931 5169 5170 3933 5172 5173 3933 5173 3937 5166 5173 5172 5166 5172 5165 5165 5172 5171 3937 5173 5174 5173 5166 5174 3937 5174 3938 3938 5174 5169 5166 5167 5174 5174 5167 5169 5165 3929 5166 5166 3929 3927 5166 3927 5167 5167 3927 3926 5167 3926 5168 5169 5167 5168 3926 3927 3928 3928 3927 3929 5165 3928 3929 3930 3926 3928 5163 3930 3928 5163 3928 5164 5164 3928 5165 5168 3926 5162 5162 3926 3930 5168 5222 5169 5168 5162 5222 5162 3930 5163 5222 5162 5163 5222 5163 5115 5163 5164 5115 5115 5164 5165 5165 5171 5115 5073 5171 5122 5122 5171 5121 5171 5127 5121 5073 3834 5074 5122 5123 5073 5073 5123 5124 5073 5124 5036 5121 3894 5122 5122 3894 5123 5121 3893 3894 5127 3893 5121 5126 3890 5127 5127 3890 3893 3893 3890 3894 3890 3892 3894 5123 3894 3892 5123 3892 3895 5123 3895 5124 5124 3895 5125 5036 5124 5125 3895 3892 3891 5125 3895 3891 3890 3891 3892 5126 3891 3890 5125 3891 5126 5125 5126 5036 5035 3799 5036 5036 3799 3798 5036 3798 5031 5036 3851 5035 5036 5031 5033 3797 3798 3799 5031 3798 3797 5031 3797 5032 5033 5031 5032 3797 3799 3800 5032 3797 3800 5032 3800 5033 3801 3802 3800 3801 3800 3799 5033 3800 3802 5034 3802 3801 5034 3801 5035 5035 3801 3799 5033 3802 5034 4985 5033 5034 4985 5034 4984 4984 5034 5035 4984 5035 4983 4983 3754 4984 4984 3754 3757 4984 3757 4985 4985 3757 3756 3756 3757 3754 3754 3755 3756 3756 3755 3758 4986 3756 3758 4986 3758 3755 4981 4980 5033 5033 4980 5025 5025 4980 4979 5221 3988 5222 5222 3988 3987 5222 5220 5221 5220 3981 5221 5221 3981 3988 5169 5176 5170 5169 5175 5176 5175 3941 5176 5176 3941 5177 5170 5176 5177 5177 5178 5170 5177 3941 3940 5177 3940 5178 3939 3940 3941 3939 3941 3944 5175 3944 3941 5181 3944 5175 5181 3939 3944 3940 3939 3942 3942 3939 3943 5180 3943 3939 5180 3939 5181 5178 3940 3942 5178 3942 5179 5179 3942 3943 5179 3943 5180 5330 5305 5331 5329 5306 5330 5330 5306 5305 5393 5329 5330 5267 5305 5306 5267 5306 5269 5269 5306 5307 5329 5307 5306 4081 4087 5269 5269 4087 4086 4068 5267 5269 4068 5269 4074 4074 5269 4086 2894 4081 2895 2895 4081 4082 2894 4087 4081 2897 4086 4087 2897 4087 2894 2893 2894 2895 2896 2897 2894 2896 2894 2893 2899 2893 2895 2895 4082 2899 2899 4082 2898 2898 4082 4083 2898 2893 2899 2898 4084 2893 2893 4084 4085 2893 4085 2896 2896 4085 4086 2896 4086 2897 4146 4072 4085 4085 4072 4073 4085 4073 4086 4146 4085 4084 2898 4083 4084 4146 4084 4151 4151 4084 4083 4083 4150 4151 4150 2951 4151 4151 2951 2950 4151 2950 4146 4149 2952 4150 4150 2952 2951 2950 2951 2952 2950 2952 2953 4146 2950 2953 2954 2953 2952 4149 2954 2952 4148 2954 4149 2954 2955 2953 4148 2955 2954 4146 2953 4147 4147 2953 2955 4147 2955 4148 4147 4148 4137 4147 4137 4071 4147 4071 4146 4146 4071 4072 4070 2885 4071 4071 2885 2887 4071 2887 4072 4137 4070 4071 4072 2887 2886 4072 2886 4073 2886 2887 2885 2882 2884 2885 2886 2885 2884 4069 2882 2885 4069 2885 4070 4073 2886 2884 4073 2884 4074 4074 4086 4073 2882 2883 2884 4074 2884 2883 4068 2883 2882 4068 2882 4069 4074 2883 4068 4055 5267 4060 4055 4056 5267 5267 4056 4057 4058 4060 5267 5267 4049 4047 4053 4054 5267 5267 4054 4048 5267 4048 4049 4051 4053 5267 4051 5267 4058 4058 5267 4057 4049 4050 4047 4047 4050 4051 4050 2867 4051 4051 2867 2866 4051 2866 4052 4052 4053 4051 4049 2867 4050 2866 2867 2868 4049 2868 2867 2866 2868 2869 4049 2869 2868 2864 2865 2866 2866 2869 2864 2866 2865 2870 4052 2866 2870 4052 2870 4053 4053 2870 2865 4053 2865 4054 4054 2865 2864 4054 2864 2869 4048 2869 4049 4054 2869 4048 4056 2874 4057 4057 2874 2873 4057 2873 4058 4055 2875 4056 4056 2875 2874 2873 2874 2875 2873 2875 2871 4055 2871 2875 4060 2871 4055 2871 2872 2873 4060 2872 2871 4059 2876 4060 4060 2876 2872 4058 4059 4060 4058 2873 4059 4059 2873 2876 2873 2872 2876 4229 3030 4230 3262 4467 4461 4560 3358 4561 4561 3358 3357 4561 3357 4562 4561 4559 4560 4712 4561 4711 4750 4751 4561 4562 4798 4561 4561 4798 4750 4751 4717 4561 4561 4717 4711 4711 3499 4712 4712 3499 3498 4712 3498 4713 4717 3497 4711 4711 3497 3499 4716 3497 4717 4751 4716 4717 3496 3495 3497 3497 3495 3498 3497 3498 3499 4716 3496 3497 4713 3498 3495 3494 3495 3496 4715 3494 3496 4715 3496 4716 4752 4715 4716 4752 4716 4751 5045 4715 4752 4751 3534 4752 4752 3534 3537 4752 3537 4753 5045 4752 4753 4750 3535 4751 4751 3535 3534 3532 3533 3534 3537 3534 3533 3532 3534 3535 4753 3537 3533 4753 3533 4754 5045 4753 4754 4754 3533 3532 3535 3536 3532 4754 3532 4755 4755 3532 3536 4750 3536 3535 4755 3536 4750 4755 4750 4798 4798 4754 4755 5045 4754 4798 5044 3811 5045 5045 3811 3810 5045 3810 5046 5045 5253 5245 5245 5262 5045 5045 5262 5263 4793 5045 4798 4833 4834 5045 4793 4794 5045 5045 4794 4833 5045 5046 4871 5045 4871 5253 4834 5043 5045 5045 5043 5044 5045 5000 5001 4997 4998 5045 5045 4998 4999 5045 4999 5000 5043 3813 5044 5044 3813 3811 3813 3814 3809 3813 3809 3811 5043 3814 3813 3809 3810 3811 3810 3809 3812 5047 3812 3809 5047 3809 5048 5048 3809 3814 5048 3814 5043 4834 5047 5048 4834 5048 5043 5046 3812 5047 4871 5046 5047 4871 5047 4834 5046 3810 3812 4833 3613 4834 4834 3613 3612 4834 3612 4835 4706 4707 4834 4798 4666 4834 4834 4666 4665 4706 4834 4665 4707 4708 4834 4834 4708 4875 4834 4875 4869 4870 4871 4834 4870 4834 4869 4836 4798 4834 4836 4834 4835 4869 3646 4870 4875 3646 4869 4870 3646 3648 4870 3648 4871 3646 3647 3648 4875 3647 3646 3648 3647 3649 3648 3649 3650 3648 3650 3651 4871 3648 3651 4874 3649 3647 4874 3647 4875 4873 3650 3649 4873 3649 4874 4873 3651 3650 4871 3651 4872 4872 3651 4873 4873 4874 4744 4871 4872 4873 4873 4744 4743 4873 4743 4871 4744 4874 4708 4708 4874 4875 3525 4743 4744 3525 4744 3526 3526 4744 4745 4708 4745 4744 3525 4749 4743 4825 4743 4749 4871 4743 4825 3525 3526 3527 3525 3527 3531 3531 4749 3525 3527 3526 3528 3526 4745 3528 3528 4745 3529 3529 4745 4746 4746 4745 4708 3528 3529 3527 3527 3529 3530 3529 4746 3530 4707 3493 4708 4708 3493 3491 4708 3491 4709 4708 4709 4664 4706 3489 4707 4707 3489 3493 3489 3491 3493 3489 3490 3491 4706 3490 3489 3490 3492 3491 4709 3491 4710 4710 3491 3492 4709 4710 4664 4710 3492 4704 4704 4664 4710 4704 3492 3490 4704 3490 4705 4705 3490 4706 4706 4665 4705 4705 4664 4704 4705 4665 4664 3458 4664 4665 3458 4665 3455 3455 4665 4666 3455 3457 3458 3457 4664 3458 3455 3453 3457 3453 4664 3457 3453 3452 4664 4664 3452 4663 3452 3453 3454 3454 3453 3455 3454 4663 3452 3456 4667 4663 3456 4663 3454 4667 4491 4663 3454 3455 3456 3455 4667 3456 3455 4666 4667 4667 4798 4491 4667 4666 4798 4633 4628 4491 4798 4632 4491 4491 4632 4633 4628 4600 4491 4632 3420 4633 4633 3420 3419 4633 3419 4628 4628 3423 4629 4628 3419 3423 4628 4629 4600 3419 3420 3421 3421 3423 3419 3421 3420 3424 4632 3424 3420 4631 3424 4632 4798 4631 4632 4631 3421 3424 3421 3422 3423 4630 3422 3421 4630 3421 4631 4629 3423 3422 4629 3422 4630 4629 4599 4600 4630 4599 4629 4798 4630 4631 4630 4798 4598 4630 4598 4599 4598 3393 4599 4599 3393 3392 4599 3392 4600 4597 3387 4598 4598 3387 3393 4798 4597 4598 3387 3392 3393 3391 3392 3387 4600 3392 3391 4600 3391 3390 4600 3390 4593 4593 4565 4600 4600 4565 4566 3387 3390 3391 3387 3389 3390 4593 3390 3389 4593 3389 4594 4594 4564 4593 4593 4564 4565 4564 3356 4565 4565 3356 4566 4566 3356 3355 4566 3355 4559 3355 3356 3357 3357 3356 3360 4564 3360 3356 4563 3360 4564 4594 4563 4564 4594 3389 4595 4595 4563 4594 4562 3357 4563 4563 3357 3360 4563 4595 4596 4563 4596 4562 3357 3358 3359 3357 3359 3355 4559 3355 3359 4559 3359 4560 4560 3359 3358 4596 4597 4562 4562 4597 4798 4595 3388 4596 4596 3388 3387 4596 3387 4597 4595 3389 3388 3387 3388 3389 4797 3576 4798 4798 3576 4792 4793 4798 4792 4796 4797 4798 4837 4798 4836 4831 4796 4798 4831 4798 4837 4796 3572 4797 4797 3572 3576 3575 3576 3572 4792 3576 3575 4792 3575 4793 4793 3575 3574 4793 3574 4794 3572 3574 3575 3572 3573 3574 4796 3573 3572 3577 3574 3573 4794 3574 3577 4794 3577 4795 4833 4794 4795 4795 3577 3573 4795 3573 4796 4833 4795 4832 4832 4795 4796 4832 3611 4833 4833 3611 3613 4831 3609 4832 4832 3609 3611 4832 4796 4831 3609 3610 3611 3610 3613 3611 3612 3613 3614 3614 3613 3610 4837 3614 3610 4837 3610 4831 4831 3610 3609 4835 3612 3614 4835 3614 4836 4836 3614 4837 4825 4916 4917 4871 4825 4917 4916 4825 4915 4915 4825 4914 4825 4912 4913 4825 4913 4914 4914 3687 4915 4915 3687 3685 4915 3685 4916 4913 3688 4914 4914 3688 3687 4912 3688 4913 4911 3682 4912 4912 3682 3681 4912 3681 3688 3685 3687 3688 3681 3685 3688 3681 3682 3683 3683 3685 3681 4911 3683 3682 4910 3683 4911 3683 3684 3685 4910 3684 3683 4909 3684 4910 4871 4909 4910 3685 3684 3686 4909 3686 3684 4908 3686 4909 4908 4909 4871 3686 3689 3685 4908 3689 3686 4917 3689 4908 4871 4917 4908 3685 3689 3690 4917 3690 3689 4916 3685 3690 4916 3690 4917 5097 5098 4871 4871 5098 5090 4871 5090 5252 5097 4871 5096 5253 4871 5252 5097 3856 5098 5098 3856 3859 5098 3859 5090 3856 3858 3859 5090 3859 3858 5090 3858 5091 5252 5090 5091 3857 3858 3856 5091 3858 3857 5091 3857 5092 5252 5091 5251 5251 5091 5092 3856 3855 3857 5092 3857 3855 5092 3855 5093 5251 5092 5250 5250 5092 5093 5250 4019 5251 5251 4019 4020 5251 4020 5252 5250 4017 4019 5093 5094 5250 5093 3855 3854 5093 3854 5094 3854 3855 3856 3862 3861 3854 3862 3854 3863 3863 3854 3856 5094 3854 3861 5094 3861 3860 3860 3861 3862 5095 3860 3862 5095 3862 5096 5096 3862 3863 5096 3863 5097 5097 3863 3856 4017 4018 4019 4019 4018 4011 4019 4011 4020 5249 4011 4018 5249 4018 4017 4011 4012 4013 4020 4011 4013 5248 4012 4011 5248 4011 5249 5252 4020 4013 5252 4013 5253 4013 4012 4014 4014 4015 4013 4013 4015 4016 5253 4013 4016 5247 4014 4012 5247 4012 5248 5259 5247 5248 5246 4014 5247 5246 5247 5259 5246 4015 4014 5245 4015 5246 5245 4016 4015 5253 4016 5245 5246 5261 5245 5245 5261 5262 5259 5260 5246 5246 5260 5261 5259 4022 4021 5259 4021 5260 5260 4021 4029 5260 4029 5261 5261 4029 4030 5261 4030 5262 5262 4030 4025 5262 4025 5263 4029 4023 4030 4030 4023 4025 4029 4021 4023 4021 4022 4023 4023 4024 4025 5257 4024 4023 4025 4024 4026 5256 4026 4024 5256 4024 5257 4026 4027 4025 5255 4027 4026 5255 4026 5256 4025 4027 4028 5254 4027 5255 5254 4028 4027 5263 4025 4028 5263 4028 5254 4999 3767 5000 5000 3767 3770 5000 3770 5001 4998 3768 4999 4999 3768 3767 3766 3767 3768 3769 3770 3767 3769 3767 3766 5001 3770 4995 4995 3770 3769 4995 3769 4996 4996 3769 3766 4996 3766 4997 4997 3766 3768 4997 3768 4998 3975 5210 5211 3975 5211 3976 5211 5212 3976 3974 3973 3975 3975 3976 3974 3973 5210 3975 3973 5209 5210 3972 3973 3974 3972 5209 3973 3974 3976 3977 3976 5212 3977 3972 5208 5209 3971 5208 3972 4863 3640 4864 4864 3640 3645 4864 3645 4865 4862 3641 4863 4863 3641 3640 3640 3641 3642 3640 3642 3645 4865 3645 3642 4865 3642 4866 3642 3641 3643 3642 3643 3644 4866 3642 4867 4867 3642 3644 4862 3643 3641 5430 5401 5431 5487 5430 5488 5488 5430 5431 5503 5487 5488 5571 5561 5488 5561 5503 5488 5545 5503 5561 5561 5563 5545 5545 5563 5564 5545 5564 5546 5561 5562 5563 5563 5562 5566 5640 5564 5563 5640 5563 5566 5642 5546 5564 5642 5564 5640 5640 5641 5642 5640 5566 5641 5566 5562 2414 2414 1305 5566 5566 1305 5641 2414 5562 5561 2414 2415 2416 1300 1305 2414 2414 2416 1298 2414 1298 1300 5561 2415 2414 1300 1304 1305 1304 5641 1305 1300 1298 1046 1046 1304 1300 1298 1299 1203 1046 1298 1203 2418 1299 1298 2418 1298 2416 1044 1045 1046 1302 1303 1046 1046 1303 1304 1303 5641 1304 1302 5639 1303 1303 5639 5641 5639 1302 5638 5673 5638 1302 5637 5639 5638 5642 5641 5639 5639 5637 5642 5637 5638 5636 5636 5638 5627 5673 5627 5638 5642 5637 5636 2495 1201 1045 2495 1045 2496 2496 1045 1044 2494 1201 2495 2496 1502 2495 2495 1502 1501 2495 1501 2494 2416 2415 2417 2416 2417 2418 2415 2354 2353 2415 2353 2417 5561 5573 2415 5573 2354 2415 2418 2417 2419 2417 2353 2356 2417 2356 2419 2353 2354 2355 2353 2355 2356 2356 2355 2357 2356 2357 2358 2419 2356 2358 2418 2419 2420 2419 2358 2420 2358 2357 2359 2358 2359 2360 2420 2358 2360 2355 2346 2357 2357 2346 2348 2357 2348 2359 2360 2359 2361 2359 2348 2337 2359 2337 2361 2360 2361 2362 2420 2360 2422 2422 2360 2362 2362 2361 2363 2361 2337 2336 2361 2336 2363 2348 2349 2337 2346 2347 2348 2348 2347 2349 2347 230 2349 230 232 2349 2346 2351 2347 2351 226 2347 226 228 2347 2347 228 230 228 229 230 230 229 231 230 231 232 232 231 233 229 2330 231 231 2330 233 228 227 229 227 2333 229 229 2333 2330 226 227 228 226 239 227 239 2334 227 227 2334 2333 2330 2333 2306 2306 2333 2305 2305 2333 2334 2307 2330 2306 2307 2329 2330 2330 2329 233 2310 2329 2307 237 240 239 237 239 226 235 236 237 236 240 237 235 237 2351 2351 237 226 236 5582 240 236 235 5582 235 5571 5582 2351 2350 235 235 2350 5572 235 5572 5571 2350 2351 2352 2352 2351 2346 2354 2350 2355 2350 2352 2355 5572 2350 2354 5572 5573 5561 5571 5572 5561 5573 5572 2354 2355 2352 2346 2362 2363 2364 2364 2363 2365 2363 2336 2344 2363 2344 2365 2422 2362 2411 2411 2362 2364 2364 2365 2366 2411 2364 2412 2412 2364 2366 2411 2412 2413 2411 2413 2422 2421 2420 2422 2413 2421 2422 1294 1296 2413 2413 1296 1295 2413 1295 1297 1297 2421 2413 2418 2420 2421 2418 2421 1297 1210 1205 1297 1210 1297 1295 1205 1299 1297 1299 2418 1297 1210 1295 1296 1210 1296 1208 1208 1296 1294 1203 1299 1205 1204 1203 1205 1204 1205 1206 2366 2365 2367 2366 2367 2368 2365 2344 2343 2365 2343 2367 2368 2367 2369 2367 2343 2342 2367 2342 2369 206 2342 2343 206 2343 211 211 2343 2344 204 206 211 210 204 211 210 211 209 209 208 210 2281 2282 2283 2287 2291 2282 2282 2291 2283 2456 2283 2457 2457 2283 2291 2457 1659 2456 2457 2291 2458 2458 1659 2457 1658 1626 1659 2458 1658 1659 2458 2291 2453 2453 1657 2458 2458 1657 1658 1657 1626 1658 1657 1678 1626 1626 1678 1679 1679 1680 1626 2453 1678 1657 2452 2453 2290 2290 2453 2291 2452 1678 2453 2452 1679 1678 1680 1679 2451 2451 1679 2452 2289 2451 2452 2289 2452 2290 2289 2290 2288 2288 2290 2291 2288 2291 2287 2287 2272 2288 2292 2289 2288 2292 2288 2270 2270 2288 2272 2450 2451 2289 2621 2450 2289 2621 2289 2292 2621 2292 2270 2268 2269 2270 2270 2272 2268 2623 2621 2270 2623 2270 2269 2621 2622 2450 2622 2621 2623 2623 2269 2317 2652 2622 2623 2623 2317 2652 2317 2269 2268 2318 2317 2268 2320 2317 2318 2652 2317 2320 2652 2320 2648 2637 2645 2652 2645 2622 2652 2637 2652 2653 2653 2652 2648 2622 2645 2646 2637 2646 2645 2622 2646 2647 2640 2647 2646 2640 2646 2637 2647 2450 2622 2642 2450 2647 2642 2647 2640 2637 2639 2640 2640 2639 2641 2640 2641 2642 2642 2641 2643 2642 2643 2644 2644 2450 2642 2644 2735 2450 2450 2735 2451 2643 2734 2644 2644 2734 2735 1621 2735 1666 1666 2735 2734 2735 1621 1665 2735 1665 2451 1665 1646 2451 1621 1664 1665 1665 1664 1645 1665 1645 1646 1664 1688 1645 1619 1620 1621 1622 1623 1621 1621 1623 1624 1624 1628 1621 1621 1628 1619 1638 1639 1621 1639 1640 1621 1621 1640 1641 1621 1641 1642 1613 1621 1614 1614 1621 1647 1621 1613 1612 1642 1648 1621 1621 1648 1649 1621 1666 1667 1621 1667 1647 1612 1668 1621 1621 1668 1638 1649 1669 1621 1621 1669 1670 1670 1671 1621 1621 1671 1672 1672 1677 1621 1621 1677 1622 1669 1733 1670 1649 1733 1669 1731 1724 1733 1733 1724 1722 1722 1735 1733 1670 1733 1735 1649 1731 1733 1648 1732 1649 1649 1732 1731 1731 1732 1724 1724 1732 1727 1727 1732 1729 1732 1648 1642 1642 1729 1732 1728 1727 1729 1728 1729 1730 1642 1730 1729 1641 1730 1642 1730 1759 1754 1754 1728 1730 1641 1640 1730 1730 1640 1759 1754 1759 1758 1640 1639 1759 1759 1639 1758 1754 1755 1756 1755 1754 11 1754 1758 11 1756 1728 1754 11 1758 1757 1639 1638 1758 1638 1757 1758 1757 9 11 1668 9 1757 1668 1757 1638 1612 9 1668 1612 1613 9 7 8 9 9 8 10 9 10 11 9 1613 7 1614 15 1613 1613 15 7 8 7 15 8 15 12 1614 12 15 1614 1647 12 12 13 8 13 12 14 12 1647 14 1667 14 1647 13 14 2643 2643 14 2734 14 1667 1666 14 1666 2734 2641 2706 2643 2643 2706 13 2639 2706 2641 2639 2705 2706 2706 2705 601 602 13 2706 602 2706 601 2637 2638 2639 2638 2705 2639 2705 2638 2667 2667 491 2705 2705 491 601 491 492 601 601 492 600 601 600 602 602 600 599 602 599 13 595 599 600 595 600 493 493 600 492 492 491 484 492 484 493 493 484 485 493 485 494 493 494 595 482 483 484 482 484 491 478 485 484 478 484 483 2784 483 482 2784 482 2785 2785 482 2668 2668 482 491 594 478 483 2784 594 483 2785 2844 2784 2784 2844 594 2785 2668 2786 2786 2844 2785 2758 402 2844 2844 402 594 2786 2758 2844 402 401 594 594 401 478 399 401 402 399 402 398 2758 398 402 400 401 399 401 400 478 398 397 399 2810 400 399 2810 399 397 395 397 398 398 2758 395 395 396 397 396 2811 397 397 2811 2810 2789 2809 2810 2789 2810 2726 2726 2810 2811 2809 400 2810 2726 2811 2725 2812 2725 2811 393 2812 2811 393 2811 396 393 396 395 391 392 393 391 393 394 394 393 395 392 2812 393 391 385 392 392 2813 2812 385 2814 392 392 2814 2813 384 385 386 391 386 385 384 2814 385 2721 2813 2814 2721 2814 2727 2727 2814 2815 384 2815 2814 2721 2812 2813 2721 2722 515 2721 515 2723 2727 2722 2721 2723 2812 2721 2728 513 2727 2727 513 2722 2727 2815 2728 2728 2815 2816 2815 384 2816 514 513 2728 2728 2729 514 2728 2816 2729 512 513 514 512 2722 513 515 2722 512 512 514 510 512 510 511 512 511 515 514 2729 2730 514 2730 845 514 845 510 2730 2729 2731 2729 2816 2817 2729 2817 2731 2730 2731 844 844 845 2730 845 846 847 845 844 846 847 510 845 843 842 844 842 846 844 2731 2817 844 844 2817 843 2816 378 2817 2817 378 380 2817 380 843 840 842 843 843 380 365 843 365 840 840 841 842 841 846 842 838 839 840 840 839 841 840 365 367 840 367 838 841 839 846 838 837 839 837 848 839 839 848 846 848 849 846 846 849 2083 847 846 2083 936 935 848 848 935 849 837 936 848 849 935 1872 849 1872 2083 847 2083 2084 2083 1872 2084 847 508 510 847 2084 508 508 509 510 509 508 2067 2067 508 2068 508 2084 2068 510 509 511 1030 509 943 2067 943 509 511 509 1030 2067 2068 2069 2069 943 2067 2069 2068 2070 2068 2084 2070 2069 2070 2071 2075 943 2069 2071 2075 2069 2071 2070 2072 2072 2070 2084 2071 2072 2073 2077 2075 2071 2073 2077 2071 2075 938 943 2077 938 2075 2078 938 2077 2078 2077 2076 2076 2077 2073 2073 2072 2074 2073 2074 1763 2073 1763 2076 1763 2079 2076 2076 2079 2080 2076 2080 2078 1866 938 2078 2078 2080 1867 2078 1867 1866 2081 1867 2080 2081 2080 2082 2082 2080 2079 2066 2079 1763 2082 2079 1868 1868 2079 2066 1868 2085 2082 2082 2085 2086 2082 2086 2081 1865 1867 2081 1865 995 993 1865 993 1867 999 997 1865 1865 997 995 994 993 995 994 995 996 996 995 997 992 991 993 992 993 994 1867 993 991 962 992 994 962 994 961 961 994 996 996 997 998 961 996 958 958 996 998 998 997 999 998 999 1000 958 998 959 959 998 1000 959 1000 960 960 1000 678 611 958 959 960 676 959 959 676 674 959 674 611 678 677 960 960 677 676 669 677 678 669 678 670 675 676 677 675 677 669 675 674 676 673 611 674 673 674 675 669 78 675 675 78 76 675 76 74 675 74 673 669 82 80 669 80 78 77 76 78 77 78 79 79 78 80 75 74 76 75 76 77 73 72 74 73 74 75 673 74 72 1819 73 75 1819 75 77 77 1816 1819 1816 77 79 79 80 81 1816 79 1814 1814 79 81 81 80 82 81 82 83 1814 81 83 1811 1813 1814 1814 1813 1815 1814 1815 1816 1814 83 1811 1811 83 85 1811 1812 1813 2024 1813 2019 2019 1813 1812 2024 1815 1813 1815 1817 1816 2025 1815 2024 2025 1817 1815 2019 2023 2024 2024 2023 2026 2024 2026 2025 2019 2022 2023 2022 1705 2023 2023 1705 2026 2026 1705 1710 2026 1710 2027 2025 2026 2027 2030 1817 2025 2025 2027 2030 2027 1710 2028 2030 2027 2028 1709 1710 1705 1710 1709 1711 1710 1711 2028 1709 1705 1704 1711 1709 1712 1741 1742 1709 1709 1742 1712 1741 1709 1704 1711 1712 1713 2028 1711 1713 1714 1716 1712 1712 1716 1713 1712 1740 1714 1712 1742 1740 1741 1628 1742 1742 1628 1624 1742 1624 1740 1741 1704 1743 1743 1628 1741 1743 1619 1628 1743 1620 1619 1714 1740 1738 1740 1624 1623 1623 1738 1740 1738 1739 1714 1622 1739 1738 1622 1738 1623 1714 1739 1717 1717 1739 1736 1736 1739 1677 1677 1739 1622 1717 1736 1737 1672 1736 1677 1672 1737 1736 1717 1737 1720 1720 1737 1734 1671 1737 1672 1671 1734 1737 1720 1734 1735 1670 1734 1671 1670 1735 1734 1720 1735 1722 1719 1717 1720 1719 1720 1721 1721 1720 1722 1721 1722 1723 1724 1726 1722 1722 1726 1723 2042 1719 1721 2042 1721 1723 1723 2041 2042 1726 2041 1723 1724 1725 1726 1725 2046 1726 1726 2046 2041 1725 1724 1727 1725 2045 2046 1725 1727 2045 2044 2041 2046 2044 2046 2047 2047 2046 2045 2040 2042 2041 2040 2041 2044 1840 2040 2044 1840 2044 1842 2047 1843 2044 2044 1843 1842 2047 2045 2048 2048 1843 2047 2045 1727 2049 2045 2049 2048 1844 1846 2048 2048 1846 1843 2048 2049 2050 2048 2050 1844 1995 2050 2049 1995 2049 1727 1844 2050 1849 1993 1849 2050 1993 2050 1995 1994 1993 1995 1994 1995 1728 1727 1728 1995 1775 1777 1993 1774 1775 1993 1774 1993 1994 1777 1849 1993 1728 1756 1994 1994 1756 1996 1994 1996 1774 1756 1755 1996 1774 1996 1770 1996 1755 1997 1996 1997 1770 1755 11 1997 597 1998 1997 597 1997 11 1770 1997 1998 10 597 11 596 490 597 598 596 597 598 597 10 490 1998 597 1770 1998 1766 1766 1998 490 488 489 490 596 488 490 1766 490 489 487 488 596 595 487 596 595 596 598 8 598 10 598 8 599 598 599 595 494 487 595 485 486 487 487 486 488 494 485 487 488 486 489 22 489 486 22 486 480 480 486 485 480 485 478 478 479 480 480 479 22 21 20 22 22 479 481 22 481 21 20 489 22 19 20 21 19 33 20 489 20 33 489 1778 1766 489 33 1778 19 32 33 1778 33 32 31 32 19 722 31 19 722 19 21 31 30 32 1778 32 1779 1779 32 30 1766 1778 1779 1766 1779 1771 1766 1771 1770 1771 1779 1769 30 1769 1779 29 28 30 29 30 31 28 1769 30 23 28 29 717 23 29 717 29 31 25 28 23 25 1773 28 28 1773 1772 28 1772 1769 23 24 25 716 24 23 716 23 717 25 24 26 24 716 713 713 26 24 715 713 716 717 715 716 712 711 713 712 713 714 714 713 715 711 35 713 713 35 26 710 711 712 710 712 714 710 709 711 35 711 709 34 26 35 34 35 36 35 37 36 709 37 35 708 707 709 708 709 710 707 37 709 36 37 38 38 37 39 39 37 40 707 40 37 1845 34 36 36 38 1845 1845 38 39 39 40 41 1845 39 1847 1847 39 41 41 40 42 705 42 40 705 40 707 41 42 43 1847 41 1848 1848 41 43 1846 1845 1847 1846 1847 1843 1843 1847 1848 1843 1848 1841 1848 43 45 1848 45 1841 43 42 44 43 44 45 44 42 705 45 44 46 701 46 44 701 44 703 703 44 705 45 46 47 1841 45 47 47 46 48 48 46 701 700 699 701 700 701 702 702 701 703 699 48 701 702 703 704 704 703 705 702 965 966 966 700 702 702 704 965 698 699 700 966 698 700 698 697 699 697 48 699 696 697 698 967 696 698 967 698 966 965 984 966 966 984 986 966 986 967 964 696 967 967 986 988 967 988 964 694 695 696 696 695 697 964 694 696 694 964 692 692 964 963 964 988 990 964 990 963 986 987 988 988 987 989 988 989 990 990 989 991 990 991 992 963 990 992 1867 991 989 1867 989 987 986 985 987 1867 987 985 984 985 986 984 983 985 1867 985 983 982 983 984 965 982 984 982 981 983 983 981 1867 980 981 982 968 980 982 968 982 965 965 704 706 965 706 968 968 706 708 968 708 710 710 980 968 978 979 980 980 979 981 710 978 980 1867 981 979 978 977 979 1867 979 977 976 977 978 714 976 978 714 978 710 976 975 977 1867 977 975 975 973 1867 1867 973 970 1867 970 1866 974 973 975 974 975 976 715 974 976 715 976 714 972 973 974 718 972 974 718 974 715 972 970 973 971 970 972 720 971 972 720 972 718 717 718 715 718 717 719 718 719 720 720 719 721 720 721 723 720 723 724 724 971 720 969 970 971 724 969 971 723 722 724 724 722 725 727 969 724 724 725 727 721 722 723 721 719 722 725 722 726 719 31 722 722 21 726 725 726 727 727 726 728 728 944 727 727 944 937 727 937 969 728 726 729 726 21 729 729 21 481 728 729 730 730 729 731 479 731 729 729 481 479 728 730 944 945 944 730 730 731 2789 2789 945 730 2789 731 2809 731 479 400 731 400 2809 478 400 479 945 2789 2790 2789 2726 2790 2790 2726 2724 1030 945 2790 511 1030 2790 511 2790 2724 2725 2724 2726 2723 515 2724 2723 2724 2725 511 2724 515 2812 2723 2725 945 1030 943 943 944 945 938 937 943 943 937 944 937 938 939 1866 939 938 969 937 939 969 939 970 1866 970 939 717 31 719 706 707 708 704 705 706 706 705 707 963 992 962 962 688 963 963 688 690 963 690 692 961 685 962 685 686 962 962 686 688 686 687 688 688 687 689 688 689 690 690 689 691 690 691 692 692 691 693 692 693 694 689 60 691 691 60 58 691 58 693 687 62 689 689 62 60 59 58 60 59 60 61 61 60 62 57 55 58 57 58 59 693 58 55 1835 57 59 1835 59 1833 1833 59 61 61 62 63 1833 61 1830 1830 61 63 1830 1832 1833 1833 1832 1834 1833 1834 1835 1835 1834 1836 1835 1836 1837 57 1835 1837 1832 2034 1834 1834 2034 2038 1834 2038 1836 1830 1831 1832 1832 1831 2034 1830 1829 1831 2034 1831 1829 2034 1829 2035 2035 2036 2034 2034 2036 2037 2034 2037 2038 1836 2038 2039 2038 2037 2043 2038 2043 2039 2036 1718 2037 2037 1718 1719 2037 1719 2043 2033 1715 2036 2036 1715 1718 2035 2033 2036 1717 1718 1715 1718 1717 1719 2043 1719 2042 2039 2043 2042 1836 2039 2040 2039 2042 2040 1837 1836 1838 1838 1836 1839 1836 2040 1839 1839 2040 1840 1838 1839 1840 1838 1840 1841 1840 1842 1841 1841 1842 1843 1841 47 1838 47 48 49 1838 47 49 49 48 50 697 50 48 49 50 51 49 51 1838 51 50 52 52 50 697 695 52 697 51 52 53 52 54 53 693 54 52 693 52 695 1838 51 53 53 54 55 53 55 56 1838 53 1837 1837 53 56 55 54 693 694 693 695 56 55 57 1837 56 57 1717 1715 1714 1714 1715 1716 1715 2033 1716 2032 1713 1716 1716 2033 2032 2031 2032 2033 2031 2033 2035 2028 1713 2032 2029 2028 2032 2029 2032 2031 2031 1822 2029 2035 1827 2031 2031 1827 1824 2031 1824 1822 2035 1829 1827 1826 1824 1827 1826 1827 1828 1828 1827 1829 1823 1822 1824 1823 1824 1825 1825 1824 1826 1828 67 1826 1826 67 69 1826 69 1825 1828 1829 1830 1830 67 1828 65 66 67 67 66 68 67 68 69 1830 65 67 63 65 1830 63 64 65 65 64 66 684 68 66 684 66 64 69 68 70 682 70 68 682 68 684 69 70 71 71 70 72 612 72 70 612 70 680 680 70 682 680 682 681 681 682 683 683 682 684 679 612 680 679 680 681 958 679 681 958 681 961 681 683 961 683 684 685 961 683 685 685 684 686 686 684 687 684 64 687 687 64 62 63 62 64 611 610 958 958 610 679 610 611 612 612 611 673 610 612 679 673 72 612 71 72 73 1823 69 71 1823 71 1821 1821 71 73 1821 73 1819 1819 1820 1821 1821 1820 1822 1821 1822 1823 1825 69 1823 2029 1822 1820 1819 1818 1820 2029 1820 1818 1816 1818 1819 1816 1817 1818 2029 1818 2030 2030 1818 1817 2030 2028 2029 1844 1845 1846 1849 1850 1844 1844 1850 1845 1850 34 1845 1849 1776 1850 1776 27 1850 1850 27 34 1777 1776 1849 1775 1773 1776 1775 1776 1777 27 1776 25 1776 1773 25 25 26 27 27 26 34 1767 1772 1773 1767 1773 1774 1774 1773 1775 1767 1768 1769 1769 1772 1767 1768 1767 1774 1774 1770 1768 1769 1768 1770 1769 1770 1771 13 599 8 1868 1870 2085 1868 1869 1870 1869 1868 2066 1870 1869 1871 1869 2066 1765 1765 2097 1869 1871 1869 2097 1765 2066 1763 1763 1764 1765 1765 1764 2089 1765 2089 2092 2092 2097 1765 2092 2096 2097 1871 2097 2101 2101 2097 2096 2092 2089 2087 2092 2087 2093 2093 2096 2092 2088 2087 2089 2088 2089 2074 2074 2089 1764 1763 2074 1764 2072 2088 2074 1872 2087 2088 2084 1872 2088 2084 2088 2072 1872 1873 2087 2093 2087 1873 1872 935 1873 1873 935 1874 2093 1873 1874 934 933 935 934 935 936 1874 935 933 932 933 934 832 932 934 832 934 834 834 934 936 932 931 933 1874 933 931 930 931 932 829 930 932 829 932 832 831 829 832 831 832 833 833 832 834 830 829 831 364 831 833 831 364 830 833 834 835 835 373 833 833 373 375 833 375 364 371 372 373 373 372 374 373 374 375 835 371 373 375 374 376 375 376 364 372 376 374 364 376 377 1983 377 376 559 1984 376 376 1984 1983 376 372 559 364 377 363 361 377 1983 361 363 377 1983 1984 1985 361 1983 1885 1885 1983 1985 1984 559 1986 1985 1984 1988 1986 1988 1984 1885 1985 1886 1969 1886 1985 1988 1990 1985 1985 1990 1969 1986 1987 1988 1988 1987 1989 1988 1989 1990 1986 559 571 1987 1986 571 558 559 372 589 571 559 559 558 589 589 573 571 589 590 573 589 558 564 589 564 590 563 564 558 563 558 372 563 562 564 564 562 1682 590 564 591 591 564 1682 590 591 573 573 591 592 1682 592 591 561 592 1682 1682 562 561 560 561 562 561 560 588 586 561 588 565 566 560 565 560 562 588 560 566 582 587 588 582 588 566 588 587 586 566 565 567 585 582 566 566 567 585 567 565 416 562 412 565 565 412 416 567 416 422 2801 567 422 585 567 2801 2801 422 2800 585 2801 2805 2805 2801 2800 2800 2804 2805 2805 2804 2806 2805 2806 585 2800 2803 2804 2840 2841 2804 2841 2806 2804 585 2806 584 1601 584 2806 1601 2806 2841 2840 1601 2841 585 584 582 2802 2803 2800 2800 2799 2802 2802 2799 2388 429 2388 2799 429 2799 425 425 2799 2800 431 2388 429 430 431 432 432 431 433 433 431 429 430 432 2749 432 433 434 2749 432 434 434 433 429 434 429 428 2749 434 2750 2750 434 428 2678 2749 2677 2677 2749 2750 2750 428 2751 2677 2750 2676 2676 2750 2751 427 426 428 427 428 429 428 426 2751 2751 426 424 2751 424 2752 2676 2751 2752 425 424 426 425 426 427 425 427 429 422 424 425 2800 422 425 422 423 424 2752 424 423 420 421 422 421 423 422 416 420 422 2752 423 421 418 421 420 2752 421 2741 2741 421 418 419 418 420 419 420 416 416 415 418 416 418 419 418 2740 2741 418 415 2740 2675 2752 2741 2675 2741 2740 2740 415 2753 2675 2740 2674 2674 2740 2753 414 415 416 415 414 2753 2753 414 411 2753 411 2754 2674 2753 2673 2673 2753 2754 2673 2587 2674 2674 2587 2675 2672 2589 2673 2673 2589 2588 2673 2588 2587 2673 2754 2755 2673 2755 2672 2754 411 410 2754 410 2755 2755 410 407 2755 407 404 2755 404 2756 2672 2755 2756 407 410 408 408 410 411 407 408 404 404 405 403 404 408 409 404 409 405 2756 404 403 2756 403 2757 2672 2756 2671 2671 2756 2757 2671 2590 2672 2672 2590 2589 2670 2592 2671 2592 2591 2671 2671 2591 2590 2671 2757 2670 2519 2589 2590 2519 2590 2531 2531 2590 2591 2517 2588 2589 2517 2589 2518 2518 2589 2519 2510 2518 2519 2519 2531 2510 2510 2531 2532 2531 2591 2532 2532 2591 2592 2510 2532 2533 2533 2532 2534 2532 2592 2534 2539 2533 2534 2592 2539 2534 2538 2533 2539 2596 2538 2539 2596 2539 2592 2536 2537 2538 2538 2537 2533 2595 2536 2538 2595 2538 2596 2669 2595 2596 2669 2596 2670 2670 2596 2592 2594 2536 2595 2668 2594 2595 2668 2595 2669 2594 2537 2536 2593 2533 2537 2593 2537 2594 2638 2593 2594 2638 2594 2667 2667 2594 2668 2786 2668 2669 2668 491 2667 2669 2758 2786 395 2758 2757 2670 2757 2758 2670 2758 2669 395 2757 394 2757 403 391 394 2757 391 403 386 391 403 405 406 403 406 386 409 1037 405 405 1037 406 406 1037 386 1036 386 1037 1037 568 1036 409 412 1037 1037 412 568 408 412 409 408 411 412 412 411 413 568 412 562 416 412 413 413 411 414 413 414 417 413 417 416 417 414 416 563 568 562 563 569 568 383 569 563 563 372 383 365 382 383 365 383 366 366 383 372 383 382 569 371 370 372 372 370 366 365 366 367 367 366 368 370 368 366 380 382 365 380 381 382 569 382 381 378 379 380 380 379 381 569 381 379 379 378 387 379 387 388 569 379 388 2816 387 378 388 387 389 389 387 390 2816 390 387 569 388 1036 1036 388 389 1036 568 569 1036 389 386 389 390 386 386 390 384 2816 384 390 367 368 369 369 368 370 838 367 369 369 370 371 838 369 371 835 837 838 838 371 835 835 834 836 835 836 837 836 834 837 834 936 837 2570 2593 2638 2570 2638 2569 2569 2638 2637 2569 2533 2570 2570 2533 2593 2510 2533 2569 2574 2535 2569 2569 2535 2510 2569 2637 2574 2574 2637 2573 2573 2637 2653 2573 2520 2574 2574 2520 2535 2522 2510 2535 2522 2535 2520 2520 2521 2522 2573 2521 2520 2572 2521 2573 2573 2653 2572 2572 2653 2654 2571 2522 2572 2572 2522 2521 2654 2571 2572 2512 2510 2522 2571 2512 2522 2512 2571 2577 2656 2571 2654 2656 2577 2571 2512 2513 2510 2512 2577 2513 2513 2577 2578 2684 2578 2577 2684 2577 2656 2510 2513 2514 2513 2578 2514 2514 2578 2515 2510 2514 2515 2509 2510 2511 2516 2517 2510 2510 2517 2518 2509 2525 2510 2510 2525 2526 2510 2529 2511 2510 2526 2530 2510 2530 2516 2517 2516 2587 2587 2516 2530 2587 2588 2517 2587 2530 2576 2675 2587 2576 2576 2530 2526 2576 2526 2525 2525 2575 2576 2675 2576 2575 2675 2575 2676 2676 2752 2675 2525 2586 2575 2575 2586 2676 2676 2586 2677 2509 2585 2586 2509 2586 2525 2677 2586 2585 2677 2585 2584 2677 2584 2678 2511 2584 2585 2511 2585 2509 2529 2584 2511 1919 1969 1990 1990 1989 1919 1919 1968 1969 1968 1886 1969 1967 1887 1968 1968 1887 1886 1885 1886 1887 355 1885 1887 355 1887 1888 1967 1888 1887 1965 1888 1967 1889 346 1888 1888 346 355 1965 1889 1888 1889 1890 346 337 2111 1890 1890 2111 346 335 336 337 337 336 338 338 2111 337 334 335 337 334 333 335 333 336 335 336 339 338 807 339 336 807 336 806 806 336 333 338 339 340 338 340 341 338 341 2111 810 340 339 810 339 807 341 340 342 342 340 343 343 340 810 2111 341 342 342 343 344 2111 342 344 344 343 345 815 345 343 815 343 812 812 343 810 344 345 346 2111 344 346 346 345 347 347 345 815 812 814 815 815 814 816 815 816 347 810 811 812 811 813 812 812 813 814 814 817 816 814 813 867 814 867 817 816 817 818 816 818 819 347 816 819 817 867 869 817 869 818 819 818 820 818 869 820 819 820 821 347 819 821 821 820 822 822 820 870 869 924 820 820 924 926 820 926 870 867 922 869 869 922 924 922 923 924 924 923 925 924 925 926 926 925 927 926 927 928 870 926 928 925 923 1874 1874 927 925 922 921 923 1874 923 921 920 921 922 867 920 922 920 919 921 921 919 1874 918 919 920 868 918 920 868 920 867 867 813 811 867 811 868 868 811 809 868 809 865 865 918 868 916 917 918 918 917 919 865 916 918 1874 919 917 916 915 917 1874 917 915 914 915 916 866 914 916 866 916 865 914 913 915 915 913 1874 912 913 914 803 912 914 803 914 866 865 805 866 866 805 803 802 801 803 802 803 804 804 803 805 804 805 806 806 805 807 807 805 808 865 808 805 806 333 804 804 333 331 331 802 804 331 333 332 332 333 334 330 329 331 330 331 332 329 802 331 1896 330 332 1896 332 334 328 329 330 328 330 1896 328 326 329 326 799 329 329 799 802 799 801 802 799 800 801 326 796 799 321 794 796 321 796 323 323 796 326 320 319 321 320 321 322 322 321 323 319 794 321 318 792 794 318 794 319 317 318 319 317 319 320 317 320 1884 1884 320 322 322 323 324 1884 322 324 1883 1900 1884 1900 317 1884 315 316 317 316 318 317 1900 315 317 316 792 318 315 314 316 324 323 325 323 326 325 325 326 327 327 326 328 807 808 809 865 809 808 807 809 810 810 809 811 912 911 913 1874 913 911 931 929 1874 1874 929 927 1874 1875 2093 930 929 931 928 927 929 928 929 930 826 928 930 826 930 829 870 928 826 822 870 824 824 870 826 821 822 823 823 822 824 823 824 825 825 824 826 825 356 823 823 356 354 823 354 353 823 353 821 821 353 350 821 350 349 821 349 347 350 353 352 352 353 354 352 354 355 355 354 356 351 350 352 2112 351 352 2112 352 355 348 349 350 348 350 351 347 349 348 346 347 348 348 2112 346 348 351 2112 346 2112 355 355 356 357 357 2113 355 355 2113 1885 357 356 358 357 358 359 359 2113 357 2113 359 361 1885 2113 361 359 358 360 359 360 361 827 360 358 827 358 825 825 358 356 361 360 362 360 827 830 830 362 360 361 362 363 363 362 364 830 364 362 827 829 830 827 828 829 828 826 829 827 826 828 825 826 827 2093 1875 2096 2102 2096 1875 2101 2096 2102 1321 1325 1326 1321 1326 1319 1319 1320 1321 5631 1320 1319 1320 1322 1321 1322 1320 5631 1321 1322 1323 5634 1323 1322 1321 1323 1093 1093 1323 1316 1316 1323 5634 5614 5681 5634 5681 1316 5634 1316 1317 1093 5680 1317 1316 5680 1316 5681 5613 5680 5681 5613 5681 5614 5612 5613 5614 5612 5611 5613 5611 5680 5613 5679 1317 5680 5611 5679 5680 1093 1317 1318 5679 1318 1317 1313 5679 1314 1314 5679 5615 5679 1313 1318 5615 5679 5616 5616 5679 5611 5610 5611 5612 5610 5616 5611 5607 5615 5616 5607 5616 5610 5609 5615 5607 1314 5615 5678 5609 5621 5615 5621 5678 5615 5607 5608 5609 5608 5621 5609 5608 5620 5621 5620 5678 5621 5677 1310 5678 5678 1310 1315 5678 1315 1314 5677 5678 5620 5619 5618 5620 5619 5620 5608 5618 5677 5620 5676 1311 5677 5677 1311 1310 5618 5676 5677 1088 1310 1311 1088 1315 1310 1088 1314 1315 1090 1313 1314 1090 1314 1088 1088 1089 1090 1040 1099 1088 1088 1099 1089 1088 1311 1040 1040 1311 1312 5676 1312 1311 1040 1098 1099 1040 1312 1038 1099 1098 1089 1089 1098 5672 5601 5602 1098 1098 5602 5672 1098 5606 5601 5604 5606 1098 5671 5672 5602 1089 5672 5671 5601 5533 5602 5602 5533 5528 5602 5528 5598 5671 5602 5598 5606 5533 5601 5604 5537 5606 5606 5537 5533 5528 5533 5534 5537 5536 5533 5533 5536 5534 5535 5536 5537 5535 5514 5536 5514 5469 5536 5536 5469 5422 5536 5422 5534 5528 5534 5529 5529 5534 5468 5534 5422 5468 5528 5529 5530 5530 5529 5531 5529 5467 5531 5529 5468 5467 5420 5467 5468 5420 5468 5422 5418 5419 5467 5418 5467 5420 5531 5467 5419 5530 5531 5532 5532 5531 5527 5531 5419 5527 5532 5527 5526 5532 1094 5600 5532 5600 5530 1094 5532 5597 5597 5532 5526 5521 5526 5527 5521 5594 5526 5526 5594 5597 5597 5594 5670 1095 5597 5670 1094 5597 1095 5594 5521 5595 5594 5595 5670 5521 5522 5523 5521 5527 5522 5595 5521 5523 5595 5523 5596 5670 5595 1082 5596 1082 5595 5523 5522 5524 5523 5524 5525 5596 5523 1078 1078 5523 5525 1078 1061 5596 1061 1082 5596 1086 1087 1082 1082 1087 5670 1084 1085 1086 1086 1085 1087 1086 1321 1093 1086 1093 1084 1085 5670 1087 1095 5670 1084 1084 5670 1085 1084 1093 1095 1090 1092 1093 1093 1092 1094 1093 1094 1095 1093 1318 1090 1090 1089 1091 1091 1092 1090 1090 1318 1313 1094 1092 5600 1092 1091 5600 5671 5599 1091 5600 1091 5599 1089 5671 1091 5530 5600 5599 5598 5528 5599 5599 5528 5530 5599 5671 5598 1078 5525 1079 5525 5524 5519 1079 5525 5519 1079 5519 5592 1079 5592 5669 1079 5669 5667 5515 5519 5520 5519 5524 5520 5592 5519 5593 5593 5519 5515 5592 5593 5669 5669 5593 5668 5669 5668 5667 5668 5589 5667 5667 5589 5666 5593 5589 5668 5593 5515 5589 5589 5515 1068 5589 1068 5666 5666 1068 1070 1068 1069 1070 1076 1069 1068 1068 5515 5517 5517 5591 1068 1076 1068 5591 5590 1076 5591 5518 5590 5591 5518 5591 5517 5590 5518 5587 5518 5517 5513 5518 5513 5512 5587 5518 5512 5587 5512 5511 5511 5512 5513 5511 5513 5514 5514 5513 5462 5517 5412 5513 5513 5412 5462 5511 5514 5535 5514 5462 5469 5413 5462 5412 5413 5469 5462 5421 5422 5469 5421 5469 5413 5412 5386 5413 5413 5386 5378 5378 5376 5413 5413 5376 5421 5421 5376 5422 5422 5376 5380 5422 5380 5420 5379 5380 5376 5420 5380 5379 5375 5376 5377 5377 5376 5378 5379 5376 5381 5381 5376 5375 5385 5377 5378 5385 5378 5386 5412 5385 5386 5383 5377 5385 5411 5385 5412 5383 5385 5414 5414 5385 5411 5411 5412 5463 5517 5463 5412 5411 5463 5414 5416 5384 5414 5414 5384 5383 5414 5463 5464 5414 5464 5416 5383 5384 5377 5416 5377 5384 5415 5377 5416 5415 5416 5465 5524 5465 5416 5524 5416 5520 5520 5416 5464 5516 5520 5464 5516 5464 5463 5515 5520 5516 5515 5516 5517 5516 5463 5517 5522 5465 5524 5415 5465 5417 5417 5465 5466 5522 5466 5465 5417 5377 5415 5375 5377 5417 5419 5382 5417 5417 5382 5375 5417 5466 5419 5522 5527 5466 5527 5419 5466 5418 5381 5419 5419 5381 5382 5381 5375 5382 5379 5381 5420 5420 5381 5418 5676 1038 1312 5626 5676 5623 5623 5676 5618 5622 5626 5623 5622 5623 5617 5617 5623 5618 5617 5618 5619 5644 5622 5617 1233 1234 1231 1235 1234 1236 1236 1234 1233 1236 1233 1237 1235 1236 1237 1237 1238 1235 2137 1436 1435 2137 1435 2138 2138 1435 2139 2139 1435 1475 2136 1436 2137 1131 2137 2138 2137 1131 2136 2139 1128 2138 2138 1128 1133 2138 1133 1131 2139 1475 2140 2140 1128 2139 2140 1475 1474 2140 1474 2141 2141 1129 2140 2140 1129 1128 1127 1128 1124 1124 1128 1129 1127 1133 1128 1132 1131 1133 1132 1133 1127 1130 1131 1132 1132 1239 1240 1240 1241 1132 1132 1241 1134 1132 1134 1130 2255 1240 1239 2166 2255 1239 2166 1239 2163 2163 1239 2162 2255 1241 1240 1241 1288 1134 1241 2255 1288 1130 1134 1135 1135 1134 1136 1134 1288 1136 1136 1288 1289 1288 2255 2259 1288 2259 2257 1288 2257 1289 1136 1289 1287 1289 2257 1287 1287 2257 1284 2260 1284 2257 2260 2257 2261 2261 2257 2259 2261 2259 2154 2154 2259 2255 2152 2260 2261 2152 2261 2153 2153 2261 2154 2258 1284 2260 2152 2258 2260 2150 2151 2152 2150 2152 2153 2151 2258 2152 2150 2153 2154 2154 2255 2150 2168 2150 2255 2168 2255 2166 2168 2169 2150 2150 2169 2151 2151 2169 2258 2256 1285 2258 2258 1285 1284 2258 2169 2256 2168 2167 2169 2169 2167 2256 2166 2167 2168 2163 2165 2166 2166 2165 2167 2167 2165 1282 2256 2167 1282 2163 2164 2165 1282 2165 2164 2162 2161 2163 2161 2164 2163 1282 2164 2161 1139 1281 1282 1281 2256 1282 1139 1140 1141 1141 1285 1139 1139 1285 1286 1139 1286 1281 1286 2256 1281 2256 1286 1285 1284 1285 1141 1141 1287 1284 1141 1136 1287 1137 1138 1136 1136 1138 1135 1137 1136 1141 2133 1138 1137 2133 1137 2132 2132 1137 1141 2133 1531 1138 1138 1531 1530 1530 1135 1138 2134 1130 1135 2134 1135 1530 1465 1530 1467 1467 1530 1531 2134 1530 1465 1467 1531 1532 2133 1532 1531 2132 1532 2133 1532 1536 1467 2132 1536 1532 1467 1536 1533 1142 1533 1536 1142 1536 2132 1467 1533 1537 1537 1533 1538 2131 1533 1142 1141 1140 1142 2132 1141 1142 2131 1142 1140 1538 2127 1537 1537 2127 2128 1537 2128 1467 1467 2128 1154 1466 1465 1467 1467 1154 1466 1154 1155 1156 1466 1154 1453 1453 1154 2129 1154 1156 2129 1453 1465 1466 1453 1464 1465 2134 1465 2135 2135 1465 1464 1452 1464 1453 2135 1464 2136 1464 1452 2136 2136 1130 2135 2135 1130 2134 2136 1452 1436 2136 1131 1130 1452 1453 1436 1436 1453 1454 1453 2129 1454 1454 2129 1156 1454 1479 1436 1454 1156 1479 1436 1479 1480 1056 1480 1479 1479 1156 1056 1155 1057 1156 1156 1057 1056 1056 1057 1058 1056 1058 1157 1157 1480 1056 1436 1480 1481 1157 1481 1480 1157 1058 1158 1158 1166 1157 2121 1481 1157 2121 1157 1166 1058 1057 1155 1155 1380 1058 1158 1165 1166 2116 1520 1166 1166 1520 1519 1166 1519 2121 1166 1165 2116 1160 1165 1158 1160 1164 1165 2116 1165 1164 1159 1520 2116 1164 1159 2116 1436 1519 1520 1481 1519 1436 2121 1519 1481 1159 1164 1160 1124 1129 1125 2141 1125 1129 2142 1125 2141 2141 1474 1463 2141 1463 2142 2142 1463 1462 1909 1915 1910 284 286 1915 1915 286 289 1915 289 1910 1910 289 290 290 293 1910 1910 293 294 1910 294 2110 286 288 289 289 288 290 288 291 290 290 291 292 290 292 293 293 292 294 294 292 295 294 295 296 2110 294 296 300 1906 2110 2110 296 298 2110 298 300 296 295 297 296 297 298 773 297 295 773 295 771 771 295 292 298 297 299 775 299 297 775 297 773 298 299 300 300 299 301 775 301 299 773 774 775 775 774 776 775 776 777 777 301 775 771 772 773 773 772 774 772 857 774 774 857 776 770 772 771 770 856 772 772 856 857 769 767 770 769 770 771 767 856 770 767 766 856 765 766 767 765 767 768 768 767 769 771 292 769 769 292 291 769 291 768 765 768 287 768 291 288 768 288 287 285 287 286 286 287 288 765 287 285 284 283 285 284 285 286 765 285 762 762 285 283 282 283 284 282 281 283 762 283 281 762 764 765 765 764 766 300 301 302 302 301 303 777 303 301 300 302 1906 302 303 304 1906 302 304 304 303 305 303 777 779 779 305 303 304 305 306 1906 304 1908 1908 304 306 306 305 307 779 307 305 781 309 779 779 309 307 306 307 308 308 307 309 1908 306 1902 306 308 1902 2263 1389 1278 2263 1278 1279 1387 1386 1389 2263 1387 1389 1386 1387 1388 1387 2263 1388 2263 2225 1388 1388 2225 2231 2224 2225 2226 2224 2231 2225 2263 2226 2225 2230 2231 2224 2226 1958 2224 2263 2221 2226 2221 1956 2226 2226 1956 1958 1279 2221 2263 1923 1974 1880 1922 1923 1924 1977 1974 1923 1977 1923 1975 1975 1923 1922 2196 1922 2198 1922 1924 2198 2196 1975 1922 2198 1924 1926 2197 2196 2198 2197 2198 2199 2198 1926 2199 2195 2196 2197 2196 2195 2239 2196 2239 1975 1975 1976 1977 2239 1976 1975 1977 1976 1982 2239 2238 1976 2238 1982 1976 1981 1982 2238 2237 2238 1412 1412 2238 2239 2237 1981 2238 553 1981 2237 1412 1418 2237 2237 1418 553 538 553 554 1583 554 553 1583 553 1418 1413 1418 1411 1418 1592 1583 1412 1411 1418 1581 1582 1583 1583 1592 1581 554 1583 555 555 1583 1582 554 555 538 538 555 556 550 556 555 555 1582 550 1581 1586 1582 550 1582 1586 1584 1586 1581 1584 1585 1586 1585 549 1586 1586 549 550 549 541 550 541 556 550 538 556 541 541 540 538 539 540 541 539 530 540 541 546 539 546 530 539 546 531 530 541 545 546 546 545 543 532 531 546 543 532 546 527 531 532 542 532 543 542 543 544 544 543 545 544 545 541 544 548 535 541 551 544 544 551 552 544 552 548 541 549 551 552 551 549 1585 548 552 1585 552 549 1588 535 548 1588 548 1585 536 535 1588 1587 536 1588 1584 1588 1585 1588 1584 1587 536 1587 2838 1411 1412 1413 1413 1412 1414 2239 2240 1412 2240 1414 1412 1413 1414 1408 1105 1413 1408 1408 1414 1409 2239 1409 1414 2239 1414 2240 2195 1409 2239 1408 1409 1407 1407 1409 1410 2195 1410 1409 1105 1408 1107 1107 1408 1407 1407 1410 1406 1107 1407 1112 1410 2195 1406 2197 1406 2195 2199 2203 2197 2202 2203 2199 2199 1926 1928 2199 1928 2202 1112 1113 1107 243 247 244 247 241 244 241 243 244 163 161 241 162 161 163 853 874 738 738 874 740 2709 2711 521 521 517 2709 2709 517 852 521 2711 2712 521 520 517 521 2712 2713 520 521 2713 517 520 518 518 520 2719 2719 520 2717 2717 520 2715 2715 520 2713 2713 2712 2714 2713 2714 2715 2712 2822 2714 2715 2714 2716 2715 2716 2717 2717 2716 2718 2717 2718 2719 2825 2718 2716 2719 2718 2720 2718 2825 2720 2720 2825 2826 2719 2720 1032 1032 2720 618 2826 618 2720 1032 518 2719 141 142 145 145 593 141 141 593 139 593 145 2807 2807 145 2808 505 593 2807 505 2807 2808 505 2808 2788 132 133 134 134 133 135 1851 132 134 130 131 132 132 131 133 1851 130 132 626 135 133 131 624 133 133 624 626 130 129 131 129 622 131 131 622 624 622 623 624 622 620 623 2061 2060 2062 2060 2107 2062 631 632 634 632 633 634 634 633 635 633 636 635 108 107 109 656 655 657 655 18 96 655 96 657 2009 1697 2010 1697 1700 2010 2010 1700 2013 2013 1700 1702 2013 1702 2014 2011 2013 2014 2014 1702 2018 2011 2014 2015 2015 2014 2018 1800 2011 2015 1800 2015 1999 2015 2018 1999 1999 1803 1800 1999 1804 1803 2001 2051 2052 2001 2000 2002 2001 2002 2051 2002 1860 2051 2051 1860 1857 1781 2002 2003 2002 2000 2003 2002 1781 1860 1857 1860 1859 1859 1860 1781 1858 1857 1859 1859 1781 1780 1858 1859 116 116 1859 1780 2003 1783 1781 1780 125 116 116 117 118 116 118 1858 5682 5683 5684 5684 5686 5682 5691 5683 5682 5691 5682 5692 5692 5682 5693 5693 5682 5686 5683 5685 5684 5685 5683 5687 5691 5687 5683 5689 5684 5685 5689 5685 5690 5690 5685 5687 5690 5687 5691 5691 5697 5690 5690 5697 5698 5690 5698 5689 5688 5684 5689 5689 5698 5694 5689 5694 5688 5697 5703 5698 5698 5703 5700 5698 5700 5694 5688 5694 5693 5693 5694 5695 5694 5700 5701 5694 5701 5695 5693 5684 5688 5693 5686 5684 5693 5695 5692 5692 5695 5699 5695 5701 5699 5699 5696 5692 5692 5696 5691 5691 5696 5697 5696 5699 5702 5696 5702 5697 5712 5703 5697 5712 5697 5713 5713 5697 5714 5714 5697 5702 5711 5703 5712 5713 5706 5712 5712 5706 5741 5712 5741 5711 5709 5700 5703 5709 5703 5710 5710 5703 5711 5741 5740 5711 5711 5740 5710 5706 5740 5741 5707 5739 5740 5707 5740 5706 5710 5740 5739 5710 5739 5709 5708 5700 5709 5709 5739 5707 5709 5707 5708 5725 5701 5700 5725 5700 5708 5707 5738 5708 5708 5738 5725 5724 5701 5725 5724 5725 5736 5725 5738 5737 5725 5737 5736 5737 5738 5707 5707 5736 5737 5705 5736 5707 5724 5736 5705 5706 5705 5707 5704 5705 5706 5704 5734 5705 5734 5735 5705 5724 5705 5721 5705 5735 5721 5721 5701 5724 5720 5701 5721 5721 5735 5720 5735 5734 5720 5704 5733 5734 5720 5734 5719 5719 5734 5733 5719 5701 5720 5718 5701 5719 5719 5733 5718 5732 5733 5704 5733 5732 5718 5717 5699 5718 5718 5699 5701 5718 5732 5717 5731 5732 5704 5732 5731 5717 5723 5699 5717 5717 5731 5723 5722 5702 5699 5722 5699 5723 5723 5731 5730 5723 5730 5722 5704 5730 5731 5704 5729 5730 5722 5730 5729 5706 5727 5704 5727 5728 5704 5704 5728 5729 5722 5729 5716 5716 5729 5728 5716 5702 5722 5714 5702 5715 5715 5702 5716 5716 5728 5715 5728 5727 5715 5706 5726 5727 5715 5727 5714 5714 5727 5726 5726 5706 5713 5714 5726 5713 5742 5743 5744 5747 5743 5742 5752 5742 5744 5753 5747 5742 5742 5752 5753 5744 5751 5750 5743 5751 5744 5755 5744 5750 5744 5755 5752 5771 5752 5755 5773 5752 5771 5773 5753 5752 5762 5745 5753 5753 5745 5747 5773 5762 5753 5762 5754 5746 5762 5746 5745 5772 5754 5762 5772 5762 5773 5745 5746 5747 5760 5743 5747 5760 5747 5757 5757 5747 5746 5759 5743 5760 5760 5763 5759 5760 5766 5763 5760 5757 5766 5759 5751 5743 5761 5751 5759 5759 5763 5764 5759 5764 5765 5759 5765 5761 5771 5764 5763 5771 5763 5773 5773 5763 5766 5773 5766 5757 5773 5757 5772 5769 5754 5772 5772 5768 5769 5772 5757 5768 5754 5748 5746 5754 5756 5748 5769 5756 5754 5748 5749 5746 5748 5750 5749 5756 5750 5748 5757 5746 5758 5758 5746 5749 5758 5768 5757 5769 5768 5758 5758 5749 5761 5761 5765 5758 5765 5767 5758 5769 5758 5767 5751 5749 5750 5761 5749 5751 5756 5755 5750 5755 5756 5770 5771 5755 5770 5769 5770 5756 5769 5767 5770 5770 5767 5765 5770 5765 5771 5771 5765 5764 5774 5775 5776 5774 5785 5775 5786 5785 5774 5791 5786 5774 5791 5774 5792 5792 5774 5776 5776 5775 5777 5802 5777 5775 5802 5775 5785 5786 5787 5785 5802 5785 5803 5803 5785 5787 5801 5777 5802 5793 5802 5792 5792 5802 5803 5793 5801 5802 5792 5776 5793 5792 5803 5791 5803 5787 5804 5791 5803 5804 5786 5780 5787 5804 5787 5780 5804 5780 5796 5791 5804 5796 5778 5779 5780 5778 5780 5786 5796 5780 5779 5796 5779 5797 5791 5796 5790 5790 5796 5797 5778 5784 5779 5797 5779 5784 5797 5784 5798 5790 5797 5798 5790 5778 5791 5795 5783 5790 5790 5783 5778 5790 5798 5795 5791 5778 5786 5783 5784 5778 5783 5789 5784 5798 5784 5799 5799 5784 5789 5795 5798 5799 5794 5788 5795 5795 5788 5783 5795 5799 5800 5795 5800 5794 5788 5789 5783 5788 5782 5789 5799 5789 5800 5800 5789 5782 5781 5782 5788 5794 5781 5788 5793 5781 5794 5794 5801 5793 5794 5800 5801 5800 5782 5801 5781 5777 5782 5801 5782 5777 5776 5777 5781 5793 5776 5781 5805 5806 5807 5822 5806 5805 5829 5822 5805 5829 5805 5807 5820 5821 5822 5822 5821 5806 5820 5822 5829 5829 5807 5830 5846 5829 5847 5846 5820 5829 5830 5847 5829 5830 5807 5831 5830 5831 5851 5830 5851 5847 5847 5907 5846 5851 5911 5847 5847 5911 5907 5846 5907 5908 5931 5908 5907 5959 5931 5907 5959 5907 5911 5851 5910 5911 5961 5959 5911 5974 5961 5911 5974 5911 5910 5958 5931 5959 5961 5958 5959 5931 5955 5908 5931 5972 5955 5931 5958 5972 5954 5955 5972 5957 5954 5972 5972 5958 5957 5954 5953 5955 5951 5950 5954 5949 5953 5954 5950 5949 5954 5951 5954 5957 5952 5951 5957 5952 5957 5958 5950 5951 5913 5913 5951 5914 5914 5951 5952 5949 5950 5913 5912 5948 5949 5912 5949 5913 5949 5948 5953 5896 5912 5913 5896 5913 5895 5895 5913 5914 5895 5914 5893 5893 5914 5915 5914 5952 5915 5893 5863 5895 5895 5863 5860 5895 5860 5896 5896 5860 5861 5896 5861 5892 5892 5912 5896 5858 5859 5860 5860 5859 5861 5858 5860 5863 5859 5891 5861 5861 5891 5892 5892 5891 5897 5897 5929 5892 5892 5929 5912 5889 5891 5857 5859 5857 5891 5889 5897 5891 5858 5857 5859 5837 5857 5858 5838 5882 5857 5857 5882 5889 5837 5838 5857 5882 5883 5889 5883 5890 5889 5889 5890 5897 5890 5929 5897 5898 5890 5883 5898 5928 5890 5890 5928 5929 5882 5881 5883 5898 5883 5899 5881 5899 5883 5899 5927 5898 5898 5927 5928 5946 5928 5927 5928 5946 5929 5899 5926 5927 5926 5945 5927 5945 5946 5927 5947 5929 5946 5945 5980 5946 5947 5946 5980 5929 5947 5948 5929 5948 5912 5980 5981 5947 5948 5947 5981 5969 5971 5980 5969 5980 5945 5980 5971 5970 5980 5970 5981 5981 5970 5953 5948 5981 5953 5970 5971 5955 5953 5970 5955 5969 5979 5971 5971 5979 5955 5955 5956 5908 5979 5956 5955 5905 5979 5968 5968 5979 5969 5905 5909 5979 5979 5909 5956 5956 5909 5908 5908 5909 5846 5849 5909 5905 5846 5909 5849 5820 5846 5834 5848 5834 5846 5849 5848 5846 5849 5833 5848 5849 5832 5833 5849 5850 5832 5849 5905 5850 5834 5848 5833 5833 5818 5834 5834 5818 5820 5818 5819 5820 5820 5819 5821 5816 5817 5818 5818 5817 5819 5833 5816 5818 5832 5816 5833 5814 5815 5816 5816 5815 5817 5832 5814 5816 5817 5821 5819 5817 5825 5821 5815 5825 5817 5814 5812 5815 5826 5815 5812 5815 5826 5825 5813 5812 5814 5835 5813 5814 5835 5814 5832 5811 5812 5813 5835 5811 5813 5811 5810 5812 5812 5827 5826 5810 5827 5812 5809 5810 5811 5831 5809 5811 5831 5811 5835 5809 5808 5810 5808 5828 5810 5810 5828 5827 5807 5808 5809 5831 5807 5809 5851 5831 5835 5851 5835 5850 5850 5906 5851 5851 5906 5910 5832 5850 5835 5850 5905 5906 5906 5905 5930 5968 5930 5905 5967 5930 5968 5906 5930 5976 5967 5976 5930 5968 5969 5967 5945 5944 5969 5967 5969 5978 5978 5969 5944 5944 5945 5926 5925 5943 5944 5925 5944 5926 5944 5943 5978 5942 5977 5978 5978 5977 5967 5978 5943 5942 5943 5925 5924 5943 5924 5942 5900 5924 5925 5900 5925 5899 5899 5925 5926 5901 5923 5924 5901 5924 5900 5923 5942 5924 5923 5941 5942 5942 5941 5977 5902 5922 5923 5902 5923 5888 5888 5923 5901 5940 5923 5922 5923 5940 5941 5941 5940 5977 5940 5922 5939 5940 5939 5966 5940 5966 5977 5902 5921 5922 5921 5938 5922 5938 5939 5922 5939 5938 5964 5964 5966 5939 5964 5967 5966 5966 5967 5977 5937 5963 5964 5964 5963 5965 5938 5937 5964 5964 5965 5976 5976 5967 5964 5937 5938 5921 5937 5920 5936 5920 5937 5921 5936 5962 5937 5937 5962 5963 5962 5975 5963 5963 5975 5974 5974 5965 5963 5935 5934 5962 5962 5934 5975 5962 5936 5935 5919 5935 5936 5919 5936 5920 5934 5935 5918 5918 5935 5919 5918 5933 5934 5934 5933 5960 5934 5960 5973 5973 5975 5934 5974 5975 5973 5973 5961 5974 5965 5974 5910 5960 5958 5973 5973 5958 5961 5932 5952 5960 5960 5952 5958 5933 5932 5960 5932 5917 5916 5932 5933 5917 5932 5915 5952 5915 5932 5916 5904 5916 5917 5904 5917 5918 5917 5933 5918 5894 5915 5916 5894 5916 5904 5893 5915 5894 5868 5893 5894 5904 5868 5894 5852 5904 5853 5852 5868 5904 5904 5918 5853 5853 5918 5919 5852 5853 5854 5853 5870 5854 5870 5853 5903 5853 5919 5903 5854 5867 5852 5868 5852 5867 5854 5866 5867 5869 5866 5854 5869 5854 5870 5870 5884 5872 5870 5872 5869 5870 5903 5884 5884 5903 5886 5903 5919 5920 5903 5920 5886 5885 5872 5884 5885 5884 5886 5871 5869 5872 5885 5874 5872 5872 5874 5871 5885 5875 5874 5885 5886 5902 5885 5902 5875 5886 5920 5921 5886 5921 5902 5875 5902 5888 5873 5874 5875 5873 5875 5887 5887 5875 5888 5873 5871 5874 5841 5871 5873 5876 5841 5873 5887 5877 5873 5873 5877 5876 5887 5880 5877 5880 5887 5901 5901 5887 5888 5876 5877 5878 5878 5877 5879 5879 5877 5880 5856 5843 5876 5876 5843 5841 5876 5878 5856 5878 5879 5881 5856 5878 5882 5882 5878 5881 5899 5881 5879 5899 5879 5900 5880 5900 5879 5900 5880 5901 5838 5856 5882 5838 5836 5839 5839 5856 5838 5836 5838 5837 5836 5837 5824 5824 5821 5836 5836 5821 5839 5839 5821 5825 5839 5825 5856 5821 5824 5806 5806 5824 5823 5845 5823 5824 5824 5837 5845 5837 5858 5862 5845 5837 5862 5855 5823 5845 5862 5855 5845 5862 5858 5863 5864 5862 5863 5855 5862 5866 5866 5862 5864 5842 5855 5866 5823 5855 5842 5866 5864 5867 5842 5866 5869 5864 5863 5865 5867 5864 5868 5868 5864 5865 5893 5865 5863 5865 5893 5868 5844 5842 5869 5844 5869 5871 5842 5828 5823 5844 5828 5842 5844 5827 5828 5840 5844 5871 5840 5827 5844 5871 5841 5840 5827 5840 5841 5843 5826 5827 5827 5841 5843 5856 5826 5843 5826 5856 5825 5808 5823 5828 5806 5823 5808 5807 5806 5808 5965 5910 5906 5965 5906 5976 5982 5983 5984 6012 5983 5982 5984 5985 5982 6015 6012 5982 6015 5982 6016 6016 5982 5985 5991 5983 6012 5992 5991 6012 6014 6012 6015 6014 5992 6012 6039 6014 6015 6015 6042 6039 6042 6015 6016 6016 5985 6017 6016 6037 6042 6017 6037 6016 6059 6042 6037 6069 6039 6042 6069 6042 6070 6042 6059 6070 6036 6037 6017 6060 6037 6036 6060 6071 6037 6037 6071 6059 6071 6095 6059 6059 6095 6094 6059 6094 6070 6093 6069 6070 6093 6070 6094 6089 6094 6095 6090 6093 6094 6090 6094 6089 6104 6095 6071 6089 6095 6104 6060 6097 6071 6104 6071 6097 6104 6082 6083 6104 6083 6089 6104 6097 6091 6082 6104 6091 6060 6096 6097 6091 6097 6096 6080 6081 6091 6080 6091 6079 6098 6079 6091 6091 6081 6082 6091 6096 6098 6062 6096 6060 6062 6098 6096 6063 6099 6098 6063 6098 6062 6099 6078 6098 6098 6078 6079 6062 6058 6063 6058 6062 6060 6060 6036 6058 6058 6036 6041 6063 6058 6041 6063 6041 6064 6064 6099 6063 6020 6041 6019 6020 6038 6041 6019 6041 6036 6057 6041 6038 6064 6041 6057 6018 6036 6017 6019 6036 6018 6017 5987 6018 6018 5987 6010 6018 6010 6019 6017 5985 5987 5985 5986 5987 5987 5986 5988 5988 5989 5987 5987 5989 6010 6010 5989 6011 6019 6010 6011 5999 5989 6000 5997 5989 6001 6001 5989 5999 6000 5989 5988 6011 5989 5997 5997 6013 6011 6019 6011 6013 5997 5998 5992 5997 6001 6002 5997 6002 5998 5992 6013 5997 6001 6026 6002 5999 6028 6001 6001 6028 6026 5998 6002 6003 6003 6002 6022 6002 6026 6022 5992 5998 5990 5998 6003 5990 5990 6003 6004 6003 6022 6023 6003 6023 6004 6047 6048 6022 6022 6048 6023 6026 6047 6022 6004 6023 6024 6023 6046 6024 6023 6048 6046 5990 6004 5993 6004 6024 5993 5990 5991 5992 5991 5990 5993 5991 5993 5994 5994 5993 6005 5993 6024 6025 5993 6025 6005 6024 6045 6025 6024 6046 6045 6005 6025 6032 6045 6056 6025 6025 6056 6032 5994 6005 6006 6005 6032 6006 5991 5994 5983 5994 6006 5983 5983 6006 5995 6006 6032 6033 6006 6033 5995 6055 6033 6032 6032 6056 6055 6087 6055 6056 6087 6056 6072 6072 6056 6045 6033 6055 6054 6086 6054 6055 6086 6055 6087 5995 6033 6034 6054 6035 6033 6034 6033 6035 6054 6053 6035 6086 6053 6054 6085 6053 6086 6086 6087 6090 6086 6090 6085 6090 6087 6072 6090 6072 6103 6090 6092 6093 6090 6103 6092 6085 6090 6089 6084 6053 6085 6085 6089 6084 6084 6089 6083 6083 6052 6084 6084 6052 6053 6082 6061 6083 6083 6061 6052 6031 6052 6051 6031 6053 6052 6061 6051 6052 6082 6051 6061 6081 6050 6082 6082 6050 6051 6051 6030 6029 6051 6029 6031 6030 6051 6050 6030 6050 6027 6027 6050 6043 6080 6043 6050 6080 6050 6081 6009 6029 6030 6009 6030 6027 6008 6029 6009 6008 6031 6029 5988 6008 6009 6000 5988 6009 6009 6027 6000 6000 6027 6028 6027 6043 6028 6000 6028 5999 6043 6044 6028 6028 6044 6049 6028 6049 6026 6078 6049 6044 6078 6044 6079 6079 6044 6043 6049 6047 6026 6077 6047 6049 6077 6049 6078 6099 6077 6078 6076 6047 6077 6077 6088 6076 6088 6077 6099 6076 6048 6047 6075 6048 6076 6076 6088 6075 6103 6075 6088 6088 6101 6100 6088 6100 6103 6088 6099 6101 6099 6064 6065 6065 6101 6099 6066 6100 6101 6066 6101 6065 6100 6066 6067 6067 6102 6100 6103 6100 6102 6065 6038 6066 6066 6038 6040 6066 6040 6067 6064 6057 6065 6065 6057 6038 6021 6038 6020 6021 6040 6038 6039 6040 6014 6014 6040 6021 6067 6040 6039 6020 6013 6021 6021 6013 5992 6021 5992 6014 6019 6013 6020 6067 6039 6068 6068 6039 6069 6092 6068 6069 6092 6102 6068 6068 6102 6067 6092 6069 6093 6103 6102 6092 6072 6073 6103 6103 6073 6074 6103 6074 6075 6072 6045 6073 6073 6045 6074 6074 6045 6046 6074 6046 6075 6075 6046 6048 6079 6043 6080 5986 6008 5988 5985 5984 5986 5984 5996 5986 5986 5996 6007 5986 6007 6008 6007 6031 6008 5996 6035 6007 6007 6035 6031 5984 5995 5996 5995 6034 5996 5996 6034 6035 5983 5995 5984 6035 6053 6031 6105 6106 6107 6108 6109 6110 6110 6111 6109 6112 6113 6114 6114 6188 6112 6112 6188 6189 6112 6189 6186 6112 6212 6113 6186 6213 6112 6112 6213 6214 6112 6214 6212 6113 6116 6114 6188 6114 6116 6188 6187 6189 6116 6187 6188 6186 6189 6187 6186 6187 6184 6184 6215 6186 6186 6215 6213 6214 6213 6215 6214 6215 6211 6212 6214 6211 6113 6212 6211 6113 6211 6115 6115 6211 6210 6211 6215 6210 6115 6116 6113 6117 6119 6115 6115 6119 6116 6115 6210 6117 6117 6118 6119 6116 6119 6118 6118 6117 6120 6116 6118 6122 6120 6122 6118 6120 6117 6121 6120 6121 6122 6208 6121 6117 6208 6117 6209 6117 6210 6209 6206 6121 6208 6210 6206 6208 6210 6208 6209 6123 6124 6121 6121 6124 6122 6121 6206 6207 6121 6207 6123 6207 6206 6202 6255 6202 6206 6206 6210 6256 6255 6206 6256 6123 6207 6205 6205 6207 6202 6123 6205 6125 6125 6205 6204 6204 6205 6202 6125 6126 6123 6127 6128 6125 6125 6128 6126 6125 6204 6127 6127 6204 6202 6131 6132 6127 6127 6132 6128 6127 6202 6131 6130 6126 6128 6130 6128 6132 6131 6130 6132 6129 6130 6131 6130 6134 6126 6129 6134 6130 6129 6131 6133 6129 6133 6134 6199 6133 6131 6131 6202 6203 6131 6203 6199 6199 6200 6133 6199 6203 6200 6200 6203 6202 6200 6202 6258 6202 6255 6442 6202 6442 6258 6133 6200 6201 6201 6200 6197 6200 6258 6197 6133 6201 6135 6135 6201 6198 6201 6197 6198 6135 6136 6133 6137 6138 6135 6135 6138 6136 6135 6198 6137 6137 6198 6197 6139 6140 6137 6137 6140 6138 6137 6197 6139 6138 6140 6136 6133 6136 6134 6134 6136 6140 6139 6144 6140 6142 6140 6144 6134 6140 6238 6140 6142 6238 6143 6144 6139 6139 6196 6143 6139 6197 6196 6143 6142 6144 6141 6142 6143 6141 6143 6145 6194 6145 6143 6194 6143 6195 6143 6196 6195 6195 6196 6197 6254 6195 6197 6260 6197 6258 6254 6197 6260 6190 6192 6195 6194 6195 6192 6253 6195 6254 6195 6253 6190 6192 6145 6194 6145 6192 6193 6190 6193 6192 6145 6193 6146 6146 6193 6191 6190 6191 6193 6146 6147 6145 6148 6149 6146 6146 6149 6147 6146 6191 6148 6148 6191 6190 6152 6153 6148 6152 6148 6190 6149 6148 6153 6153 6155 6149 6149 6155 6147 6152 6151 6153 6153 6151 6155 6150 6151 6152 6190 6236 6152 6152 6236 6237 6152 6237 6150 6150 6155 6151 6154 6155 6150 6150 6235 6154 6150 6237 6235 6237 6236 6235 6236 6190 6235 6262 6235 6190 6262 6190 6253 6355 6235 6262 6262 6253 6423 6262 6423 6428 6355 6262 6428 6368 6370 6253 6253 6370 6373 6253 6373 6423 6254 6368 6253 6368 6367 6369 6368 6369 6370 6368 6365 6367 6254 6365 6368 6370 6369 6371 6370 6371 6372 6370 6372 6373 6367 6325 6369 6369 6325 6371 6371 6325 6326 6371 6326 6372 6373 6372 6374 6372 6326 6327 6372 6327 6374 6325 6305 6326 6326 6305 6306 6326 6306 6327 6272 6305 6325 6367 6272 6325 6271 6284 6305 6305 6284 6297 6305 6297 6306 6272 6271 6305 6306 6297 6285 6306 6285 6307 6327 6306 6307 6284 6242 6297 6297 6242 6285 6285 6242 6247 6285 6247 6286 6307 6285 6286 6307 6286 6276 6327 6307 6328 6328 6307 6277 6277 6307 6276 6286 6247 6278 6276 6286 6278 6278 6155 6279 6247 6155 6278 6276 6278 6308 6308 6278 6279 6279 6155 6240 6298 6279 6240 6308 6279 6298 6274 6276 6308 6274 6308 6329 6329 6308 6298 6298 6240 6299 6309 6298 6299 6329 6298 6330 6330 6298 6309 6378 6274 6329 6378 6329 6379 6379 6329 6380 6380 6329 6330 6274 6275 6276 6275 6274 6378 6377 6275 6378 6377 6378 6379 6377 6379 6380 6377 6380 6381 6381 6380 6382 6380 6330 6382 6423 6275 6377 6428 6423 6377 6428 6377 6429 6429 6377 6381 6423 6373 6376 6423 6376 6275 6373 6374 6375 6373 6375 6376 6375 6277 6376 6376 6277 6275 6374 6327 6375 6375 6327 6328 6375 6328 6277 6276 6275 6277 6381 6382 6383 6381 6383 6384 6430 6381 6384 6261 6429 6381 6261 6381 6430 6382 6330 6383 6330 6309 6331 6383 6330 6331 6309 6299 6300 6331 6309 6332 6332 6309 6300 6383 6331 6332 6332 6300 6333 6383 6332 6385 6385 6332 6333 6333 6300 6334 6385 6333 6387 6387 6333 6388 6388 6333 6334 6384 6383 6385 6384 6385 6386 6386 6385 6387 6386 6387 6388 6386 6388 6389 6389 6388 6390 6388 6334 6390 6430 6384 6386 6430 6386 6431 6431 6386 6389 6389 6390 6391 6389 6391 6392 6431 6389 6432 6432 6389 6392 6390 6334 6335 6390 6335 6391 6392 6391 6393 6391 6335 6393 6334 6310 6335 6335 6310 6311 6335 6311 6336 6393 6335 6336 6334 6300 6310 6300 6287 6310 6310 6287 6280 6310 6280 6311 6299 6239 6300 6300 6239 6287 6287 6239 6280 6239 6171 6280 6280 6171 6174 6288 6280 6174 6311 6280 6288 6239 6240 6161 6239 6161 6171 6299 6240 6239 6240 6155 6161 6154 6158 6155 6155 6158 6157 6155 6157 6161 6247 6147 6155 6156 6158 6154 6154 6234 6156 6154 6235 6234 6156 6157 6158 6157 6156 6159 6159 6161 6157 6159 6156 6160 6232 6160 6156 6232 6156 6233 6156 6234 6233 6233 6234 6235 6235 6230 6233 6261 6230 6235 6261 6235 6355 6230 6232 6233 6230 6160 6232 6160 6230 6231 6229 6230 6227 6231 6230 6229 6252 6227 6230 6252 6230 6261 6355 6429 6261 6261 6430 6252 6355 6428 6429 6251 6227 6252 6252 6430 6431 6252 6431 6251 6257 6225 6251 6251 6225 6227 6251 6431 6432 6251 6432 6433 6251 6433 6257 6432 6392 6433 6433 6392 6395 6433 6395 6434 6257 6433 6434 6392 6393 6394 6392 6394 6395 6395 6394 6396 6395 6396 6397 6434 6395 6397 6434 6397 6435 6257 6434 6435 6397 6396 6398 6397 6398 6399 6397 6399 6400 6435 6397 6400 6394 6338 6396 6396 6338 6398 6393 6337 6394 6394 6337 6338 6393 6336 6337 6336 6311 6337 6337 6311 6312 6337 6312 6338 6338 6312 6313 6338 6313 6339 6398 6338 6339 6311 6288 6312 6312 6288 6289 6312 6289 6313 6313 6289 6290 6313 6290 6314 6339 6313 6340 6340 6313 6314 6398 6339 6340 6340 6314 6341 6398 6340 6399 6399 6340 6341 6341 6314 6342 6399 6341 6401 6401 6341 6342 6400 6399 6401 6400 6401 6402 6401 6342 6343 6401 6343 6402 6342 6314 6315 6342 6315 6343 6343 6315 6316 6343 6316 6344 6402 6343 6404 6404 6343 6344 6403 6402 6404 6403 6400 6402 6403 6404 6405 6405 6404 6406 6404 6344 6265 6404 6265 6406 6344 6316 6265 6263 6264 6265 6265 6316 6263 6406 6265 6407 6407 6265 6264 6405 6406 6407 6405 6407 6408 6408 6407 6409 6407 6264 6266 6407 6266 6409 6264 6263 6317 6264 6317 6266 6316 6302 6263 6263 6302 6317 6317 6302 6281 6317 6281 6267 6266 6317 6267 6266 6267 6268 6409 6266 6410 6410 6266 6268 6408 6409 6410 6411 6410 6412 6424 6408 6410 6424 6410 6411 6410 6268 6269 6410 6269 6412 6268 6267 6269 6269 6267 6270 6412 6269 6270 6411 6412 6359 6412 6270 6345 6412 6345 6359 6270 6267 6318 6270 6318 6345 6345 6318 6346 6359 6345 6346 6346 6358 6359 6411 6359 6358 6346 6318 6319 6346 6319 6347 6357 6358 6346 6357 6346 6347 6267 6291 6318 6318 6291 6292 6318 6292 6319 6319 6292 6320 6347 6319 6348 6348 6319 6320 6357 6347 6414 6414 6347 6348 6358 6357 6413 6413 6357 6414 6413 6414 6415 6414 6348 6349 6414 6349 6415 6348 6320 6349 6320 6292 6282 6320 6282 6303 6349 6320 6303 6349 6303 6350 6415 6349 6417 6417 6349 6350 6416 6415 6417 6416 6413 6415 6256 6358 6413 6256 6413 6416 6416 6417 6418 6441 6416 6418 6255 6256 6416 6255 6416 6441 6256 6210 6356 6425 6358 6256 6356 6425 6256 6425 6411 6358 6440 6411 6425 6356 6440 6425 6356 6210 6259 6259 6440 6356 6259 6210 6215 6259 6215 6250 6250 6438 6259 6259 6438 6439 6259 6439 6440 6440 6424 6411 6439 6424 6440 6438 6405 6439 6439 6405 6408 6439 6408 6424 6437 6403 6438 6438 6403 6405 6250 6437 6438 6436 6400 6437 6437 6400 6403 6249 6436 6437 6249 6437 6250 6435 6400 6436 6249 6435 6436 6219 6249 6250 6249 6224 6257 6249 6219 6224 6257 6435 6249 6219 6250 6217 6250 6215 6217 6216 6217 6183 6183 6217 6218 6217 6215 6218 6216 6219 6217 6184 6218 6215 6183 6218 6184 6182 6179 6183 6184 6185 6183 6183 6185 6182 6216 6183 6179 6216 6179 6219 6179 6220 6219 6219 6220 6221 6219 6221 6224 6177 6220 6179 6177 6221 6220 6175 6221 6177 6175 6222 6221 6224 6221 6222 6172 6223 6224 6172 6224 6173 6173 6224 6222 6223 6257 6224 6173 6222 6175 6175 6176 6173 6177 6178 6175 6175 6178 6176 6173 6174 6172 6173 6176 6174 6178 6181 6176 6174 6176 6241 6241 6176 6244 6244 6176 6181 6177 6181 6178 6179 6180 6181 6179 6181 6177 6181 6180 6182 6182 6244 6181 6180 6179 6182 6187 6182 6185 6248 6182 6187 6244 6182 6248 6184 6187 6185 6243 6187 6116 6248 6187 6281 6281 6187 6243 6301 6244 6248 6301 6248 6302 6302 6248 6281 6281 6243 6291 6267 6281 6291 6291 6243 6292 6292 6243 6282 6243 6122 6282 6282 6122 6245 6282 6245 6293 6303 6282 6293 6122 6124 6126 6122 6243 6116 6245 6122 6126 6123 6126 6124 6245 6126 6134 6246 6245 6134 6246 6134 6238 6283 6246 6238 6294 6245 6246 6295 6246 6283 6295 6294 6246 6238 6142 6242 6283 6238 6284 6284 6238 6242 6142 6141 6147 6142 6147 6242 6242 6147 6247 6145 6147 6141 6296 6283 6284 6271 6296 6284 6304 6283 6296 6324 6304 6296 6324 6296 6273 6273 6296 6271 6271 6272 6273 6364 6324 6273 6364 6273 6366 6366 6273 6367 6367 6273 6272 6323 6304 6324 6362 6323 6324 6362 6324 6364 6363 6362 6364 6363 6364 6365 6365 6364 6366 6365 6366 6367 6427 6363 6365 6260 6427 6365 6260 6365 6254 6360 6362 6363 6427 6360 6363 6360 6361 6362 6361 6323 6362 6421 6422 6360 6360 6422 6361 6426 6360 6427 6426 6421 6360 6258 6426 6427 6258 6427 6260 6442 6421 6426 6258 6442 6426 6418 6420 6421 6421 6420 6422 6442 6418 6421 6441 6418 6442 6255 6441 6442 6418 6417 6419 6418 6419 6420 6419 6352 6420 6420 6352 6353 6420 6353 6422 6417 6351 6419 6419 6351 6352 6417 6350 6351 6350 6303 6351 6351 6303 6321 6351 6321 6352 6352 6321 6353 6353 6321 6322 6353 6322 6354 6422 6353 6354 6303 6293 6321 6321 6293 6294 6321 6294 6322 6293 6245 6294 6322 6294 6295 6304 6295 6283 6322 6295 6304 6323 6322 6304 6354 6322 6323 6422 6354 6323 6422 6323 6361 6316 6301 6302 6315 6301 6316 6315 6244 6301 6314 6244 6315 6290 6241 6244 6314 6290 6244 6289 6241 6290 6289 6174 6241 6288 6174 6289 6172 6174 6168 6171 6168 6174 6168 6170 6172 6223 6172 6225 6225 6172 6170 6168 6169 6170 6171 6169 6168 6170 6169 6171 6170 6171 6166 6225 6170 6226 6166 6227 6170 6170 6227 6226 6225 6226 6227 6257 6223 6225 6166 6228 6227 6228 6229 6227 6166 6167 6164 6166 6171 6167 6164 6228 6166 6164 6229 6228 6162 6229 6164 6162 6231 6229 6164 6165 6162 6164 6167 6165 6171 6165 6167 6171 6161 6165 6162 6165 6163 6161 6163 6165 6162 6163 6160 6160 6231 6162 6160 6163 6161 6159 6160 6161 6443 6444 6445 6443 6445 6446 6463 6444 6443 6481 6463 6443 6481 6443 6482 6482 6443 6446 6463 6464 6444 6469 6445 6444 6469 6444 6464 6463 6461 6464 6469 6464 6470 6470 6464 6461 6470 6461 6477 6486 6469 6470 6486 6470 6477 6477 6461 6475 6486 6477 6487 6487 6477 6475 6475 6459 6467 6475 6461 6459 6487 6475 6488 6488 6475 6467 6488 6508 6487 6508 6514 6487 6487 6514 6486 6488 6467 6489 6489 6506 6488 6506 6507 6488 6488 6507 6508 6507 6534 6508 6508 6534 6533 6508 6533 6514 6486 6514 6515 6514 6533 6532 6514 6532 6515 6478 6532 6533 6478 6533 6504 6504 6533 6534 6504 6534 6535 6507 6535 6534 6506 6535 6507 6504 6535 6503 6503 6535 6536 6506 6536 6535 6503 6479 6504 6504 6479 6478 6460 6478 6479 6480 6456 6479 6479 6456 6458 6479 6458 6460 6503 6480 6479 6458 6459 6460 6460 6459 6461 6460 6461 6462 6462 6478 6460 6456 6457 6458 6458 6457 6459 6467 6459 6457 6456 6455 6457 6467 6457 6468 6457 6455 6468 6489 6467 6490 6490 6467 6468 6468 6455 6473 6490 6468 6491 6491 6468 6473 6454 6453 6455 6454 6455 6456 6473 6455 6453 6473 6453 6474 6491 6473 6492 6492 6473 6474 6491 6509 6490 6492 6511 6491 6491 6511 6509 6492 6474 6493 6493 6510 6492 6492 6510 6511 6474 6453 6472 6493 6474 6472 6472 6451 6465 6472 6453 6451 6493 6472 6465 6450 6449 6451 6450 6451 6452 6452 6451 6453 6465 6451 6449 6465 6449 6466 6493 6465 6494 6494 6465 6466 6466 6449 6476 6494 6466 6476 6448 6447 6449 6448 6449 6450 6476 6449 6447 6446 6447 6448 6482 6446 6448 6482 6448 6483 6483 6448 6450 6446 6445 6447 6476 6447 6445 6471 6445 6469 6476 6445 6471 6496 6476 6471 6496 6471 6497 6497 6471 6469 6485 6469 6486 6497 6469 6485 6485 6522 6497 6497 6522 6496 6486 6512 6485 6485 6512 6513 6485 6513 6522 6486 6515 6512 6512 6499 6513 6515 6531 6512 6512 6531 6498 6512 6498 6499 6513 6499 6530 6513 6530 6522 6499 6529 6530 6522 6530 6529 6500 6528 6529 6500 6529 6499 6522 6529 6519 6519 6529 6528 6500 6527 6528 6519 6528 6520 6520 6528 6527 6496 6519 6520 6496 6522 6519 6496 6520 6495 6495 6520 6494 6494 6520 6521 6520 6527 6521 6501 6527 6500 6521 6527 6501 6494 6521 6517 6521 6501 6517 6494 6476 6495 6494 6517 6518 6494 6518 6493 6495 6476 6496 6493 6516 6510 6493 6518 6516 6517 6526 6518 6518 6526 6525 6518 6525 6524 6518 6524 6516 6517 6501 6526 6484 6525 6526 6484 6526 6501 6484 6524 6525 6484 6523 6524 6516 6524 6510 6510 6524 6523 6540 6511 6510 6510 6523 6540 6502 6523 6484 6540 6523 6502 6540 6502 6538 6540 6538 6511 6539 6509 6511 6511 6538 6539 6502 6537 6538 6539 6538 6537 6484 6480 6502 6502 6480 6503 6503 6537 6502 6539 6537 6509 6509 6537 6503 6490 6509 6505 6509 6503 6505 6505 6503 6536 6490 6505 6489 6489 6505 6506 6505 6536 6506 6480 6454 6456 6484 6452 6480 6480 6452 6454 6452 6453 6454 6483 6450 6452 6483 6452 6484 6501 6483 6484 6500 6482 6483 6500 6483 6501 6499 6482 6500 6499 6481 6482 6498 6481 6499 6478 6463 6481 6478 6481 6498 6498 6531 6478 6478 6462 6463 6478 6531 6532 6462 6461 6463 6515 6532 6531 6541 6542 6543 6541 6543 6544 6563 6542 6541 6568 6563 6541 6568 6541 6569 6541 6544 6569 6544 6543 6545 6545 6543 6579 6579 6543 6542 6544 6545 6546 6569 6544 6570 6544 6546 6570 6546 6545 6547 6547 6545 6578 6578 6545 6579 6546 6547 6548 6570 6546 6548 6548 6547 6549 6549 6547 6577 6577 6547 6578 6548 6549 6550 6570 6548 6571 6571 6548 6572 6548 6550 6572 6550 6549 6551 6551 6549 6552 6552 6549 6577 6550 6551 6572 6551 6552 6553 6572 6551 6573 6573 6551 6553 6553 6552 6554 6553 6554 6555 6564 6553 6555 6573 6553 6564 6555 6554 6556 6556 6554 6576 6576 6554 6552 6555 6556 6557 6564 6555 6565 6555 6557 6565 6557 6556 6558 6558 6556 6575 6575 6556 6576 6557 6558 6559 6565 6557 6566 6557 6559 6566 6559 6558 6560 6574 6560 6558 6574 6558 6575 6559 6560 6561 6566 6559 6567 6559 6561 6567 6561 6560 6562 6562 6560 6574 6561 6562 6563 6561 6563 6567 6563 6562 6542 6542 6562 6574 6567 6563 6568 6567 6580 6566 6600 6580 6567 6568 6582 6567 6567 6582 6574 6567 6574 6600 6568 6696 6567 6696 6715 6567 6567 6715 6714 6567 6714 6566 6738 6567 6580 6738 6723 6567 6567 6723 6568 6600 6574 6580 6575 6581 6574 6574 6582 6542 6580 6574 6581 6576 6592 6575 6566 6581 6575 6566 6575 6565 6565 6575 6592 6580 6581 6566 6566 6731 6580 6580 6731 6722 6580 6722 6730 6580 6730 6738 6722 6731 6721 6566 6721 6731 6714 6711 6566 6566 6711 6565 6565 6721 6566 6713 6711 6714 6713 6714 6715 6710 6709 6711 6710 6711 6712 6712 6711 6713 6711 6709 6565 6708 6709 6710 6708 6710 6721 6721 6710 6712 6708 6707 6709 6565 6709 6564 6564 6709 6707 6599 6564 6565 6565 6592 6599 6739 6565 6564 6739 6721 6565 6599 6592 6576 6599 6576 6564 6552 6590 6576 6576 6590 6591 6564 6576 6591 6577 6588 6552 6552 6588 6589 6552 6589 6590 6598 6591 6590 6598 6590 6597 6597 6590 6589 6564 6591 6598 6597 6564 6598 6597 6573 6564 6597 6589 6573 6573 6589 6588 6573 6588 6596 6596 6588 6577 6596 6572 6573 6596 6577 6572 6572 6577 6571 6573 6707 6572 6572 6707 6705 6705 6703 6572 6572 6703 6571 6571 6737 6572 6572 6737 6736 6572 6736 6720 6572 6720 6573 6706 6705 6707 6706 6707 6708 6564 6707 6573 6704 6705 6706 6704 6706 6720 6720 6706 6708 6704 6703 6705 6702 6703 6704 6702 6704 6719 6719 6704 6720 6700 6701 6702 6702 6701 6703 6718 6700 6702 6718 6702 6719 6698 6699 6700 6700 6699 6701 6698 6700 6718 6571 6703 6701 6571 6701 6570 6701 6699 6570 6698 6697 6699 6570 6699 6569 6699 6697 6569 6695 6697 6698 6695 6698 6718 6695 6696 6697 6569 6697 6696 6717 6715 6696 6717 6696 6695 6569 6696 6568 6716 6715 6717 6716 6717 6723 6723 6717 6695 6713 6715 6716 6713 6716 6722 6722 6716 6723 6721 6712 6713 6721 6713 6722 6722 6723 6730 6738 6730 6723 6695 6728 6723 6723 6728 6729 6568 6723 6729 6718 6726 6695 6695 6726 6727 6695 6727 6728 6745 6728 6569 6569 6728 6727 6745 6729 6728 6568 6729 6745 6745 6569 6568 6601 6568 6602 6602 6568 6569 6601 6583 6568 6568 6583 6582 6602 6584 6601 6601 6584 6583 6569 6584 6602 6542 6583 6584 6542 6584 6579 6579 6584 6585 6569 6585 6584 6542 6582 6583 6593 6579 6585 6593 6585 6569 6578 6579 6586 6594 6586 6579 6594 6579 6593 6593 6569 6594 6594 6569 6570 6570 6586 6594 6570 6578 6586 6578 6587 6577 6595 6587 6578 6595 6578 6570 6571 6577 6587 6571 6587 6595 6595 6570 6571 6742 6571 6570 6742 6719 6571 6571 6719 6737 6570 6724 6742 6742 6724 6719 6719 6724 6718 6720 6736 6719 6719 6736 6737 6718 6724 6725 6570 6725 6724 6743 6726 6718 6743 6718 6570 6570 6718 6725 6743 6570 6569 6743 6569 6744 6744 6726 6743 6744 6727 6726 6569 6727 6744 6708 6735 6720 6573 6720 6735 6721 6732 6708 6708 6732 6733 6708 6733 6734 6708 6734 6735 6573 6735 6741 6741 6735 6734 6741 6564 6573 6740 6564 6741 6741 6734 6740 6740 6734 6733 6740 6733 6564 6564 6733 6732 6564 6732 6739 6739 6732 6721 6603 6604 6605 6620 6621 6603 6603 6621 6622 6603 6622 6604 6635 6620 6603 6635 6603 6636 6636 6603 6605 6617 6619 6620 6620 6619 6621 6635 6617 6620 6627 6621 6623 6623 6621 6619 6627 6622 6621 6617 6618 6619 6623 6619 6624 6624 6619 6618 6644 6627 6623 6644 6623 6645 6645 6623 6624 6629 6622 6627 6644 6629 6627 6628 6622 6629 6643 6628 6629 6643 6629 6644 6630 6604 6628 6628 6604 6622 6643 6630 6628 6630 6606 6604 6631 6606 6630 6653 6631 6630 6653 6630 6654 6654 6630 6643 6605 6604 6606 6605 6606 6607 6607 6606 6608 6631 6608 6606 6636 6605 6637 6637 6605 6607 6607 6608 6609 6637 6607 6641 6641 6607 6609 6609 6608 6610 6631 6610 6608 6609 6610 6611 6641 6609 6642 6642 6609 6611 6611 6610 6612 6632 6610 6631 6632 6612 6610 6611 6612 6613 6642 6611 6638 6638 6611 6613 6613 6612 6614 6613 6614 6615 6638 6613 6615 6638 6615 6639 6642 6638 6656 6656 6638 6639 6615 6614 6616 6615 6616 6617 6639 6615 6617 6626 6616 6614 6626 6614 6633 6633 6614 6612 6617 6616 6618 6625 6616 6626 6625 6618 6616 6639 6617 6640 6640 6617 6635 6657 6639 6640 6640 6635 6658 6658 6692 6640 6640 6692 6693 6640 6693 6657 6656 6639 6657 6657 6694 6656 6665 6694 6657 6665 6657 6693 6665 6693 6666 6666 6693 6692 6666 6692 6675 6675 6692 6658 6646 6665 6666 6646 6666 6645 6666 6675 6645 6647 6660 6665 6647 6665 6646 6660 6694 6665 6656 6694 6678 6660 6678 6694 6647 6659 6660 6659 6678 6660 6646 6626 6647 6647 6626 6648 6648 6659 6647 6645 6625 6646 6646 6625 6626 6648 6626 6633 6633 6612 6634 6648 6633 6634 6634 6612 6632 6648 6634 6649 6649 6634 6632 6649 6632 6650 6650 6632 6651 6651 6632 6631 6649 6671 6648 6650 6674 6649 6649 6674 6671 6651 6668 6650 6650 6668 6669 6650 6669 6674 6651 6631 6652 6652 6667 6651 6651 6667 6668 6652 6631 6653 6653 6662 6652 6662 6667 6652 6662 6684 6667 6667 6684 6683 6667 6683 6655 6667 6655 6668 6653 6661 6662 6661 6685 6662 6662 6685 6684 6654 6661 6653 6654 6670 6661 6670 6686 6661 6661 6686 6685 6641 6684 6685 6641 6685 6637 6637 6685 6686 6641 6683 6684 6655 6683 6641 6655 6641 6642 6656 6680 6642 6642 6680 6681 6642 6681 6682 6642 6682 6655 6678 6679 6656 6656 6679 6680 6674 6681 6680 6674 6680 6671 6671 6680 6679 6669 6682 6681 6669 6681 6674 6668 6655 6682 6668 6682 6669 6671 6679 6672 6672 6679 6678 6672 6678 6659 6648 6671 6672 6648 6672 6659 6637 6686 6687 6670 6687 6686 6637 6687 6688 6637 6688 6636 6664 6688 6687 6664 6687 6670 6643 6664 6670 6643 6670 6654 6643 6663 6664 6663 6688 6664 6636 6688 6689 6663 6689 6688 6636 6689 6635 6635 6689 6690 6673 6690 6689 6673 6689 6663 6644 6663 6643 6644 6673 6663 6644 6677 6673 6677 6690 6673 6635 6690 6691 6677 6691 6690 6635 6691 6658 6676 6658 6691 6676 6691 6677 6645 6676 6677 6645 6677 6644 6645 6675 6676 6675 6658 6676 6645 6624 6625 6624 6618 6625 6746 6747 6748 6767 6768 6746 6746 6768 6747 6792 6767 6746 6792 6746 6793 6793 6746 6748 6748 6747 6749 6789 6749 6747 6789 6747 6768 6767 6766 6768 6789 6768 6790 6790 6768 6766 6765 6766 6767 6792 6765 6767 6765 6764 6766 6790 6766 6764 6790 6764 6777 6805 6789 6790 6805 6790 6806 6806 6790 6777 6763 6761 6764 6763 6764 6765 6777 6764 6761 6791 6765 6792 6791 6763 6765 6762 6761 6763 6803 6762 6763 6803 6763 6791 6822 6803 6791 6822 6791 6792 6822 6792 6821 6821 6792 6793 6793 6748 6794 6821 6793 6794 6748 6749 6750 6794 6748 6750 6794 6750 6752 6794 6752 6795 6794 6795 6821 6750 6749 6751 6750 6751 6752 6788 6751 6749 6788 6749 6789 6752 6751 6753 6753 6751 6754 6787 6754 6751 6787 6751 6788 6795 6752 6753 6795 6753 6796 6821 6795 6796 6753 6754 6755 6796 6753 6755 6796 6755 6797 6821 6796 6824 6824 6796 6797 6837 6822 6821 6837 6821 6838 6838 6821 6824 6803 6822 6802 6802 6822 6823 6840 6823 6822 6840 6822 6837 6802 6762 6803 6801 6760 6802 6802 6760 6762 6802 6823 6801 6760 6761 6762 6758 6759 6760 6760 6759 6761 6801 6758 6760 6800 6776 6801 6801 6776 6758 6801 6823 6800 6776 6759 6758 6776 6775 6759 6779 6761 6759 6779 6759 6780 6780 6759 6775 6777 6761 6778 6778 6761 6779 6809 6778 6779 6809 6779 6810 6810 6779 6780 6780 6775 6781 6810 6780 6817 6817 6780 6781 6817 6834 6810 6810 6834 6809 6808 6778 6809 6809 6834 6835 6809 6835 6808 6808 6777 6778 6807 6777 6808 6808 6835 6836 6808 6836 6807 6837 6836 6835 6837 6835 6840 6840 6835 6834 6817 6833 6834 6840 6834 6833 6839 6823 6840 6833 6832 6840 6840 6832 6839 6818 6832 6833 6818 6833 6817 6819 6831 6832 6819 6832 6818 6839 6832 6831 6817 6781 6818 6818 6781 6782 6818 6782 6819 6819 6782 6783 6819 6783 6820 6820 6831 6819 6820 6830 6831 6831 6830 6839 6820 6783 6784 6820 6784 6811 6811 6830 6820 6782 6770 6783 6783 6770 6784 6784 6770 6756 6784 6756 6785 6811 6784 6785 6811 6785 6812 6812 6830 6811 6812 6829 6830 6839 6830 6829 6812 6785 6813 6813 6829 6812 6785 6756 6754 6785 6754 6786 6813 6785 6786 6813 6786 6814 6814 6828 6813 6813 6828 6829 6839 6829 6838 6838 6829 6828 6838 6824 6839 6839 6824 6823 6826 6837 6838 6826 6838 6827 6838 6828 6827 6815 6827 6828 6815 6828 6814 6816 6826 6827 6816 6827 6815 6814 6787 6815 6815 6787 6788 6815 6788 6816 6816 6788 6789 6816 6789 6804 6804 6826 6816 6804 6789 6805 6805 6826 6804 6806 6825 6805 6805 6825 6826 6806 6777 6807 6807 6836 6806 6806 6836 6825 6836 6837 6825 6825 6837 6826 6786 6754 6787 6814 6786 6787 6755 6754 6756 6755 6756 6757 6797 6755 6757 6757 6756 6769 6769 6756 6770 6797 6757 6769 6797 6769 6798 6824 6797 6798 6769 6770 6771 6798 6769 6771 6771 6770 6772 6772 6770 6773 6782 6773 6770 6798 6771 6799 6799 6771 6772 6824 6798 6799 6823 6824 6799 6799 6772 6774 6799 6774 6800 6823 6799 6800 6772 6773 6774 6774 6773 6775 6782 6775 6773 6781 6775 6782 6774 6775 6776 6800 6774 6776 6841 6842 6843 6862 6863 6841 6841 6863 6842 6885 6862 6841 6885 6841 6886 6886 6841 6843 6843 6842 6844 6886 6843 6844 6886 6844 6887 6887 6913 6886 6913 6885 6886 6884 6862 6885 6915 6885 6913 6915 6884 6885 6884 6858 6860 6884 6860 6862 6895 6858 6884 6915 6895 6884 6857 6856 6858 6858 6856 6859 6858 6859 6860 6895 6857 6858 6860 6859 6861 6860 6861 6862 6871 6859 6856 6883 6861 6859 6883 6859 6871 6862 6861 6863 6882 6863 6861 6882 6861 6883 6908 6882 6883 6908 6883 6909 6909 6883 6871 6881 6863 6882 6908 6881 6882 6881 6842 6863 6880 6842 6881 6901 6880 6881 6901 6881 6908 6909 6916 6908 6908 6916 6917 6908 6917 6901 6900 6880 6901 6901 6917 6900 6900 6917 6918 6916 6928 6917 6917 6928 6929 6917 6929 6918 6909 6927 6916 6916 6927 6928 6911 6926 6927 6911 6927 6910 6910 6927 6909 6928 6927 6926 6910 6871 6911 6911 6871 6872 6911 6872 6902 6902 6926 6911 6902 6925 6926 6928 6926 6931 6931 6926 6925 6902 6873 6903 6902 6872 6873 6903 6925 6902 6903 6924 6925 6931 6925 6924 6903 6873 6874 6903 6874 6904 6904 6924 6903 6872 6853 6873 6873 6853 6870 6873 6870 6874 6874 6870 6875 6904 6874 6875 6904 6875 6905 6905 6923 6904 6904 6923 6924 6923 6931 6924 6906 6922 6923 6906 6923 6905 6931 6923 6930 6930 6923 6922 6905 6875 6876 6905 6876 6906 6875 6870 6867 6875 6867 6876 6876 6867 6865 6876 6865 6851 6876 6851 6877 6906 6876 6907 6907 6876 6877 6907 6922 6906 6907 6877 6896 6896 6921 6907 6907 6921 6922 6877 6851 6849 6877 6849 6878 6896 6877 6878 6896 6878 6897 6897 6920 6896 6896 6920 6921 6930 6921 6920 6930 6922 6921 6897 6919 6920 6930 6920 6929 6929 6920 6919 6897 6878 6879 6897 6879 6898 6898 6919 6897 6899 6918 6919 6899 6919 6898 6929 6919 6918 6928 6913 6929 6929 6913 6914 6929 6914 6930 6928 6915 6913 6931 6915 6928 6913 6888 6914 6913 6887 6888 6887 6847 6888 6888 6847 6848 6888 6848 6889 6914 6888 6889 6887 6844 6847 6844 6846 6847 6847 6846 6848 6848 6846 6849 6848 6849 6850 6889 6848 6850 6889 6850 6864 6889 6864 6890 6914 6889 6890 6850 6849 6851 6850 6851 6864 6878 6849 6846 6878 6846 6879 6879 6846 6845 6879 6845 6880 6898 6879 6899 6899 6879 6880 6844 6842 6845 6844 6845 6846 6880 6845 6842 6899 6880 6900 6900 6918 6899 6864 6851 6865 6864 6865 6866 6890 6864 6891 6891 6864 6866 6866 6865 6867 6866 6867 6868 6891 6866 6868 6891 6868 6892 6912 6914 6891 6912 6891 6892 6914 6890 6891 6868 6867 6869 6892 6868 6869 6869 6867 6870 6869 6870 6852 6892 6869 6852 6892 6852 6893 6892 6893 6912 6852 6853 6854 6852 6870 6853 6893 6852 6854 6893 6854 6894 6912 6893 6894 6854 6853 6855 6854 6855 6856 6854 6856 6857 6894 6854 6895 6895 6854 6857 6872 6855 6853 6872 6856 6855 6871 6856 6872 6909 6871 6910 6915 6894 6895 6912 6894 6915 6931 6912 6915 6930 6914 6912 6930 6912 6931 6932 6933 6934 6983 6982 6932 6932 6982 6933 6983 6932 6979 6979 6932 6976 6935 6932 6934 6932 6989 6976 6989 6932 6991 6991 6932 6935 6933 6982 6934 6981 6982 6983 6934 6982 6978 6978 6982 6981 6981 6983 6979 6979 6980 6981 6980 6978 6981 6979 6978 6980 6978 6979 6976 6976 6977 6978 6974 6978 6977 6968 6978 6974 6978 6995 6996 6978 6996 6934 6978 7001 6995 7001 6978 6968 6976 6975 6977 6977 6975 6974 6974 6975 6976 6973 6974 6976 6976 6987 6973 6987 6976 6989 7011 6989 7012 7012 6989 6991 7011 7034 6989 6989 7034 6987 7033 7011 7012 7011 7033 7034 7012 6991 7013 7013 7051 7012 7012 7051 7033 7051 7074 7033 7033 7074 7076 7034 7033 7076 6987 7034 7035 7034 7076 7077 7035 7034 7077 7076 7074 7085 7076 7085 7077 7051 7073 7074 7074 7073 7075 7075 7107 7074 7074 7107 7085 7051 7050 7073 7049 7048 7073 7048 7075 7073 7050 7049 7073 6991 7049 7050 6991 7050 7013 7013 7050 7051 6990 7048 7049 6990 7049 7014 7014 7049 6991 6935 6990 6991 7014 6991 6990 6939 6990 6935 6939 6994 6990 6994 7048 6990 6935 6934 6936 6935 6936 6937 6937 6939 6935 6936 6934 6937 6937 6934 6938 6996 6938 6934 6937 6938 6939 6939 6938 6940 6942 6938 6944 6944 6938 6945 6938 6942 6940 7000 6945 6938 7000 6938 6996 6939 6940 6941 6941 6940 6942 6941 6942 6943 6943 6942 6944 6944 6945 6946 6943 6944 6946 6939 6941 6943 6939 6943 6946 6994 6939 6946 6994 6946 6988 7015 6994 7016 7016 6994 6988 7015 7047 6994 6994 7047 7048 7016 7046 7015 7015 7046 7047 6988 7045 7016 7016 7045 7046 7046 7045 7083 7047 7046 7083 7047 7083 7088 7047 7088 7089 7048 7047 7089 7089 7075 7048 7089 7088 7134 7089 7135 7136 7089 7134 7135 7075 7089 7136 7075 7137 7138 7075 7136 7137 7107 7075 7139 7139 7075 7138 7202 7138 7137 7202 7137 7203 7203 7137 7204 7204 7137 7136 7202 7139 7138 7139 7140 7107 7200 7140 7139 7200 7139 7201 7201 7139 7202 7085 7107 7115 7140 7115 7107 7085 7115 7116 7077 7085 7117 7085 7116 7141 7141 7117 7085 7116 7115 7196 7196 7115 7197 7197 7115 7140 7195 7141 7116 7195 7116 7196 7192 7117 7141 7192 7141 7193 7193 7141 7194 7194 7141 7195 7195 7193 7194 7196 7193 7195 7196 7197 7193 7193 7191 7192 7277 7191 7193 7277 7193 7281 7193 7197 7281 7191 7117 7192 7190 7117 7191 7191 7189 7190 7277 7189 7191 7189 7118 7190 7190 7118 7117 7077 7118 7119 7117 7118 7077 7119 7118 7189 7078 7035 7077 7077 7086 7078 7086 7077 7119 7086 7119 7142 7187 7142 7119 7187 7119 7188 7188 7119 7189 7078 7086 7079 7079 7086 7112 7112 7086 7120 7142 7120 7086 7185 7120 7142 7185 7142 7186 7186 7142 7187 7187 7189 7186 7188 7189 7187 7186 7189 7185 7189 7277 7278 7189 7278 7185 7302 7277 7303 7278 7277 7301 7301 7277 7321 7303 7277 7281 7332 7321 7277 7302 7332 7277 7300 7278 7301 7300 7301 7379 7379 7301 7321 7379 7321 7332 7379 7332 7302 7302 7347 7379 7379 7347 7348 7379 7348 7349 7379 7349 7300 7378 7278 7300 7349 7272 7300 7300 7272 7378 7348 7272 7349 7347 7271 7348 7348 7271 7272 7271 7347 7371 7302 7371 7347 7302 7271 7371 7302 7303 7380 7380 7271 7302 7303 7281 7322 7380 7303 7381 7381 7303 7322 7381 7346 7380 7380 7346 7271 7381 7322 7323 7381 7323 7382 7382 7344 7381 7381 7344 7345 7381 7345 7346 7322 7281 7323 7323 7281 7382 7382 7281 7383 7383 7343 7382 7382 7343 7344 7343 7254 7344 7344 7254 7345 7345 7254 7346 7346 7254 7271 7223 7271 7254 7271 7223 7224 7224 7272 7271 7170 7171 7223 7223 7171 7224 7170 7223 7253 7253 7223 7254 7171 7152 7224 7224 7152 7225 7225 7272 7224 7091 7171 7170 7152 7171 7091 7170 7149 7093 7170 7093 7091 7170 7253 7149 7149 7253 7254 7149 7150 7093 7149 7254 7255 7149 7255 7150 7255 7254 7256 7289 7256 7254 7343 7289 7254 7150 7255 7256 7150 7144 7093 7150 7256 7144 7144 7256 7257 7257 7256 7258 7258 7256 7260 7289 7260 7256 7093 7144 7145 7145 7144 7146 7144 7257 7258 7144 7258 7146 7146 7258 7259 7258 7260 7259 7177 7145 7146 7146 7259 7177 7145 7105 7093 7147 7109 7145 7147 7145 7177 7109 7105 7145 7177 7259 7260 7177 7260 7147 7109 7147 7148 7147 7260 7261 7147 7261 7262 7147 7262 7148 7105 7109 7094 7109 7110 7094 7148 7110 7109 7148 7168 7110 7148 7262 7263 7148 7263 7168 7270 7263 7262 7261 7260 7262 7262 7260 7270 7168 7263 7264 7270 7264 7263 7168 7169 7110 7168 7264 7265 7168 7265 7169 7264 7270 7252 7264 7252 7265 7169 7265 7252 7167 7110 7169 7252 7167 7169 7251 7167 7252 7251 7252 7249 7285 7249 7252 7285 7252 7270 7167 7165 7095 7095 7110 7167 7250 7165 7167 7250 7167 7251 7251 7249 7250 7249 7165 7250 7165 7166 7095 7166 7165 7176 7248 7176 7165 7248 7165 7249 7094 7095 7096 7094 7110 7095 7096 7095 7166 7175 7111 7166 7166 7111 7096 7166 7176 7175 7247 7175 7176 7247 7176 7248 7249 7247 7248 7246 7175 7247 7249 7269 7247 7247 7269 7246 7249 7285 7269 7335 7269 7285 7335 7285 7336 7337 7285 7270 7391 7336 7285 7391 7285 7390 7390 7285 7337 7335 7336 7363 7392 7363 7336 7392 7336 7391 7390 7328 7391 7328 7282 7391 7391 7282 7392 7392 7282 7329 7392 7329 7307 7392 7307 7306 7306 7363 7392 7306 7335 7363 7306 7307 7267 7306 7267 7393 7393 7335 7306 7329 7282 7307 7307 7282 7267 7275 7207 7282 7207 7210 7282 7282 7210 7267 7327 7275 7282 7327 7282 7328 7209 7133 7210 7210 7133 7211 7208 7210 7207 7210 7208 7209 7211 7267 7210 7208 7134 7209 7209 7134 7133 7088 7133 7134 7132 7133 7088 7211 7133 7132 7212 7267 7211 7132 7212 7211 7088 7131 7132 7212 7132 7131 7084 7088 7083 7084 7114 7088 7088 7114 7131 7114 7130 7131 7212 7131 7213 7213 7131 7214 7131 7130 7214 7084 7106 7114 7114 7106 7129 7114 7129 7130 7214 7130 7215 7215 7130 7129 7266 7213 7214 7215 7266 7214 7266 7212 7213 7266 7267 7212 7308 7309 7267 7308 7267 7266 7393 7267 7309 7308 7266 7294 7309 7308 7394 7394 7308 7294 7269 7335 7309 7394 7269 7309 7393 7309 7335 7394 7294 7395 7395 7291 7394 7394 7291 7269 7293 7294 7266 7395 7294 7293 7293 7361 7395 7395 7361 7291 7293 7266 7396 7396 7359 7293 7293 7359 7360 7293 7360 7361 7360 7291 7361 7359 7291 7360 7359 7290 7291 7396 7290 7359 7245 7291 7290 7245 7269 7291 7288 7242 7290 7245 7290 7242 7358 7288 7290 7397 7358 7290 7397 7290 7396 7358 7364 7365 7288 7358 7365 7397 7364 7358 7295 7365 7364 7295 7364 7397 7396 7310 7397 7397 7310 7311 7397 7311 7331 7397 7331 7295 7295 7279 7296 7295 7331 7279 7295 7296 7398 7398 7365 7295 7398 7288 7365 7398 7296 7399 7399 7288 7398 7296 7279 7268 7399 7296 7268 7279 7266 7217 7268 7279 7217 7266 7279 7310 7310 7279 7311 7331 7311 7279 7215 7217 7266 7266 7310 7396 7215 7129 7216 7216 7217 7215 7106 7128 7129 7216 7129 7217 7217 7129 7128 7087 7106 7082 7082 7106 7084 7106 7123 7128 7123 7106 7087 7044 7043 7082 7082 7042 7087 7043 7042 7082 7044 7082 7084 7083 7045 7084 7084 7045 7044 7003 7043 7044 7003 7044 6988 6988 7044 7045 6992 7042 7043 6992 7043 7003 7003 6988 6992 6952 6988 6946 6988 6952 6992 6949 6951 6952 6952 6951 6953 6946 6949 6952 6953 6955 6952 6955 6992 6952 6946 6945 6947 6947 6949 6946 6947 6948 6949 6949 6948 6950 6949 6950 6951 6947 6945 6950 6948 6947 6950 6950 6945 6984 7002 6984 6945 7002 6945 7000 6984 6951 6950 6954 6984 6957 6984 6954 6951 6957 6984 6999 7031 6999 6984 7032 6984 7002 7061 7031 6984 7061 6984 7062 7062 6984 7032 7060 6999 7031 7060 7031 7061 7101 7099 7061 7061 7099 7060 7101 7061 7102 7102 7061 7062 7062 7032 7063 7063 7102 7062 7063 7032 7002 7063 7002 7064 7063 7064 7102 7096 7102 7064 7096 7111 7102 7102 7111 7101 7064 7002 7017 7064 7017 7065 7064 7065 7096 7017 7002 7000 7017 7000 7018 7065 7017 7018 7065 7018 7066 7096 7065 7066 7094 7096 7066 7066 7018 7000 7066 7000 7019 7066 7019 7067 7094 7066 7067 7019 7000 7020 7020 7000 6996 7067 7019 7020 7067 7020 7068 7067 7068 7094 7094 7068 7072 7094 7072 7103 7094 7103 7105 7068 7020 7021 7021 7072 7068 7020 6996 7021 7021 6996 7022 7022 7072 7021 7022 7071 7072 7071 7103 7072 6996 7071 7022 7023 6996 6995 7023 7071 6996 7023 7070 7071 7070 7103 7071 6995 7070 7023 7024 6995 7001 7024 7070 6995 7024 7069 7070 7070 7069 7092 7070 7092 7103 7024 7001 7025 7025 7069 7024 7025 7052 7069 7069 7052 7092 7025 7001 7052 7052 7001 7053 7053 7092 7052 7001 6968 6997 7026 7001 6997 7053 7001 7026 7026 7059 7053 7090 7092 7053 7090 7053 7058 7058 7053 7059 6997 7059 7026 6997 7058 7059 7027 7057 7058 7027 7058 6997 7090 7058 7104 7104 7058 7097 7097 7058 7057 7090 7091 7092 7091 7090 7153 7090 7104 7153 7091 7093 7092 7153 7152 7091 7103 7092 7093 7105 7103 7093 7151 7152 7153 7225 7152 7151 7155 7151 7153 7153 7104 7155 7225 7151 7226 7226 7151 7155 7272 7225 7226 7226 7155 7227 7227 7228 7226 7226 7228 7272 7154 7155 7104 7227 7155 7228 7228 7155 7154 7104 7156 7154 7154 7156 7172 7228 7154 7229 7229 7154 7230 7230 7154 7172 7097 7108 7104 7156 7104 7108 7173 7156 7108 7172 7156 7231 7156 7173 7231 7172 7231 7230 7228 7229 7230 7230 7231 7228 7286 7287 7228 7231 7286 7228 7272 7228 7287 7350 7272 7287 7378 7272 7350 7378 7350 7377 7377 7350 7287 7377 7320 7378 7378 7320 7278 7376 7319 7377 7319 7320 7377 7377 7287 7376 7319 7278 7320 7280 7185 7278 7318 7280 7278 7318 7278 7319 7376 7318 7319 7317 7280 7318 7376 7317 7318 7374 7280 7317 7374 7317 7375 7375 7317 7376 7376 7351 7375 7375 7351 7369 7375 7369 7374 7287 7286 7351 7286 7369 7351 7287 7351 7370 7376 7370 7351 7369 7286 7374 7286 7231 7292 7352 7286 7292 7374 7286 7352 7231 7173 7232 7231 7232 7237 7231 7237 7235 7292 7231 7235 7108 7174 7173 7232 7173 7174 7174 7237 7232 7158 7236 7237 7158 7237 7174 7235 7237 7236 7158 7174 7108 7097 7098 7108 7108 7098 7158 7157 7158 7159 7159 7158 7098 7157 7235 7158 7158 7235 7236 7098 7097 7099 7099 7100 7098 7159 7098 7100 7097 7057 7056 7099 7097 7055 7056 7055 7097 7099 7054 7060 7100 7099 7101 7099 7055 7054 7054 7055 7030 7030 7055 7029 7029 7055 7056 7054 7030 6999 7054 6999 7060 7029 6998 7030 7030 6998 6999 7029 7056 6998 6997 6963 6998 6998 6963 6999 7028 6997 6998 6998 7056 7028 6999 6963 6957 6960 6962 6963 6960 6963 6964 6964 6963 6965 6965 6963 6966 6963 6968 6966 6963 6962 6961 6963 6961 6957 6997 6968 6963 6960 6961 6962 6960 6964 6959 6961 6960 6959 6961 6959 6957 6958 6957 6959 6958 6959 6955 6959 6964 6985 6992 6955 6959 6992 6959 6985 6955 6957 6958 6953 6954 6955 6955 6954 6956 6955 6956 6957 6954 6957 6956 6953 6951 6954 6985 6964 6986 7005 6992 6985 7006 6985 6986 7006 7040 6985 6985 7040 7041 6985 7041 7005 7004 6992 7005 7005 7041 7004 7004 7041 7042 7041 7040 7080 7041 7080 7081 7081 7042 7041 7004 7042 6992 7087 7042 7081 7081 7080 7087 7080 7113 7087 7087 7113 7123 7113 7112 7122 7123 7113 7124 7080 7112 7113 7113 7122 7143 7113 7143 7124 7080 7079 7112 7112 7121 7122 7120 7121 7112 7143 7122 7181 7181 7122 7182 7182 7122 7121 7179 7124 7143 7179 7143 7180 7180 7143 7181 7182 7180 7181 7180 7182 7179 7178 7124 7179 7179 7222 7178 7179 7182 7222 7222 7125 7178 7178 7125 7124 7221 7125 7222 7268 7221 7222 7273 7222 7182 7273 7268 7222 7123 7124 7125 7123 7125 7126 7221 7126 7125 7220 7126 7221 7221 7268 7220 7123 7126 7127 7220 7127 7126 7127 7128 7123 7219 7128 7127 7219 7127 7220 7268 7219 7220 7218 7128 7219 7217 7219 7268 7217 7218 7219 7217 7128 7218 7312 7268 7273 7399 7268 7312 7312 7273 7313 7399 7312 7313 7399 7313 7400 7400 7356 7399 7399 7356 7357 7399 7357 7288 7400 7313 7401 7401 7313 7273 7401 7366 7400 7400 7366 7356 7356 7284 7357 7284 7356 7366 7357 7284 7288 7284 7238 7288 7288 7238 7242 7284 7235 7238 7292 7235 7284 7355 7292 7284 7401 7355 7284 7401 7284 7366 7157 7234 7235 7238 7235 7234 7159 7234 7157 7159 7233 7234 7233 7238 7234 7100 7161 7159 7159 7161 7233 7233 7161 7238 7160 7161 7100 7238 7161 7239 7239 7161 7160 7160 7100 7162 7162 7100 7101 7160 7162 7164 7239 7160 7240 7240 7160 7241 7241 7160 7164 7238 7239 7240 7241 7242 7240 7240 7242 7238 7241 7164 7242 7163 7164 7162 7242 7164 7163 7163 7162 7111 7162 7101 7111 7111 7175 7163 7242 7163 7243 7243 7163 7244 7244 7163 7175 7243 7245 7242 7245 7243 7244 7244 7175 7245 7245 7175 7246 7246 7269 7245 7401 7273 7299 7401 7299 7402 7402 7355 7401 7273 7182 7274 7299 7273 7297 7297 7273 7274 7297 7298 7299 7402 7299 7298 7298 7354 7402 7402 7354 7355 7354 7292 7355 7298 7292 7354 7298 7297 7274 7298 7274 7372 7372 7292 7298 7274 7182 7280 7314 7274 7280 7274 7314 7372 7372 7314 7373 7373 7353 7372 7372 7353 7292 7352 7292 7353 7373 7352 7353 7373 7314 7315 7373 7315 7374 7374 7352 7373 7314 7280 7315 7315 7280 7316 7374 7315 7316 7280 7182 7185 7316 7280 7374 7182 7121 7183 7182 7183 7184 7184 7185 7182 7184 7120 7185 7183 7121 7184 7184 7121 7120 7037 7078 7079 7039 7038 7079 7039 7079 7080 7038 7037 7079 7036 7035 7078 7078 7037 7036 7010 7035 7036 7010 7036 7009 7009 7036 6993 6993 7036 7037 6987 7035 7010 7009 6987 7010 7009 6993 6987 6993 6973 6987 6972 6971 6973 6970 6973 6969 6970 6972 6973 6974 6973 6971 6993 6969 6973 6970 6971 6972 6970 6968 6971 6968 6974 6971 6969 6968 6970 6967 6968 6969 6964 6965 6969 6965 6967 6969 6993 6964 6969 6968 6967 6966 6965 6966 6967 6986 6964 6993 7007 6986 6993 7007 7039 6986 7039 7040 6986 6986 7040 7006 7007 6993 7008 6993 7037 7008 7008 7038 7007 7007 7038 7039 7040 7039 7080 7008 7037 7038 7027 6997 7028 7028 7057 7027 7028 7056 7057 7376 7287 7370 7208 7135 7134 7207 7135 7208 7206 7136 7135 7206 7135 7207 7206 7207 7205 7205 7207 7203 7203 7207 7275 7205 7136 7206 7204 7136 7205 7203 7204 7205 7202 7203 7201 7203 7275 7276 7276 7201 7203 7197 7199 7201 7201 7199 7200 7197 7201 7283 7283 7201 7276 7197 7140 7198 7197 7198 7199 7197 7283 7281 7198 7140 7199 7199 7140 7200 7324 7281 7283 7383 7281 7324 7333 7324 7283 7383 7324 7333 7383 7333 7384 7383 7342 7343 7384 7341 7383 7383 7341 7342 7333 7283 7384 7384 7283 7385 7385 7289 7384 7384 7289 7341 7341 7289 7342 7342 7289 7343 7289 7270 7260 7270 7289 7340 7289 7367 7340 7385 7367 7289 7385 7283 7325 7385 7325 7386 7386 7367 7385 7386 7340 7367 7340 7362 7270 7305 7362 7340 7305 7340 7386 7386 7325 7334 7386 7334 7305 7283 7276 7325 7334 7325 7276 7305 7334 7276 7304 7305 7276 7305 7304 7387 7387 7362 7305 7387 7270 7362 7387 7304 7388 7388 7270 7387 7304 7276 7275 7304 7275 7326 7388 7304 7326 7330 7326 7275 7388 7330 7275 7388 7275 7389 7389 7275 7390 7390 7275 7327 7388 7326 7330 7389 7368 7388 7388 7368 7339 7388 7339 7270 7390 7338 7389 7389 7338 7368 7390 7327 7328 7390 7337 7338 7337 7270 7338 7338 7270 7339 7339 7368 7338 7403 7404 7405 7653 7672 7403 7403 7405 7653 7672 7673 7403 7404 7403 7674 7403 7673 7674 7405 7449 7653 7653 7449 7657 7653 7657 7658 7658 7672 7653 7658 7657 7659 7449 7663 7657 7657 7663 7659 7658 7659 7660 7660 7672 7658 7660 7659 7661 7659 7663 7550 7659 7550 7661 7449 7448 7663 7550 7663 7448 7548 7549 7550 7547 7550 7542 7548 7550 7547 7550 7448 7542 7549 7661 7550 7549 7548 7551 7548 7547 7567 7548 7567 7553 7553 7551 7548 7547 7542 7541 7541 7567 7547 7541 7542 7543 7543 7542 7544 7448 7544 7542 7543 7578 7541 7578 7567 7541 7543 7544 7545 7543 7573 7578 7573 7543 7545 7545 7544 7546 7546 7544 7667 7667 7544 7448 7545 7546 7539 7576 7573 7545 7576 7545 7539 7572 7573 7574 7574 7573 7576 7572 7578 7573 7577 7578 7572 7574 7646 7572 7572 7646 7647 7572 7647 7577 7574 7576 7575 7575 7645 7574 7574 7645 7646 7614 7647 7646 7614 7646 7618 7618 7646 7645 7577 7647 7648 7647 7614 7648 7568 7578 7577 7577 7648 7568 7566 7567 7568 7568 7567 7578 7568 7648 7566 7579 7580 7566 7566 7580 7567 7566 7648 7635 7566 7635 7579 7580 7553 7567 7579 7589 7580 7554 7553 7580 7580 7556 7554 7580 7589 7556 7552 7553 7516 7516 7553 7514 7514 7553 7554 7553 7552 7551 7516 7518 7552 7552 7518 7520 7552 7520 7551 7514 7515 7516 7516 7515 7517 7516 7517 7518 7512 7513 7514 7514 7513 7515 7514 7554 7512 7612 7517 7515 7612 7515 7606 7606 7515 7513 7518 7517 7519 7611 7519 7517 7611 7517 7612 7518 7519 7520 7520 7519 7521 7610 7521 7519 7610 7519 7611 7520 7521 7522 7522 7521 7523 7609 7523 7521 7609 7521 7610 7610 7611 7609 7605 7604 7611 7611 7604 7609 7606 7605 7611 7606 7611 7612 7511 7603 7605 7511 7605 7606 7603 7604 7605 7510 7509 7511 7510 7511 7512 7512 7511 7513 7509 7603 7511 7606 7513 7511 7603 7509 7506 7506 7604 7603 7508 7506 7509 7508 7509 7510 7505 7504 7506 7505 7506 7507 7507 7506 7508 7602 7506 7504 7506 7602 7604 7510 7555 7508 7508 7555 7556 7508 7556 7507 7507 7556 7505 7556 7559 7505 7554 7556 7555 7556 7589 7559 7510 7554 7555 7512 7554 7510 7505 7559 7502 7502 7559 7560 7559 7589 7560 7502 7503 7504 7502 7504 7505 7557 7502 7558 7502 7560 7558 7557 7503 7502 7582 7558 7560 7582 7560 7589 7557 7558 7496 7496 7558 7561 7561 7558 7582 7503 7557 7496 7495 7496 7497 7497 7496 7498 7561 7498 7496 7503 7496 7495 7562 7498 7561 7561 7582 7664 7664 7562 7561 7497 7498 7499 7499 7498 7500 7498 7562 7500 7499 7597 7497 7600 7495 7497 7600 7497 7597 7499 7500 7489 7489 7596 7499 7596 7597 7499 7489 7500 7501 7563 7501 7500 7563 7500 7562 7562 7664 7563 7501 7563 7564 7664 7665 7563 7563 7665 7564 7489 7501 7490 7501 7564 7490 7490 7564 7492 7564 7565 7492 7665 7591 7564 7564 7591 7565 7664 7582 7665 7591 7665 7582 7581 7582 7583 7584 7582 7581 7583 7582 7589 7584 7591 7582 7583 7638 7581 7581 7638 7639 7581 7639 7584 7583 7589 7588 7588 7637 7583 7583 7637 7638 7588 7589 7579 7579 7636 7588 7588 7636 7637 7638 7637 7598 7637 7602 7598 7636 7602 7637 7638 7600 7639 7638 7598 7600 7599 7495 7600 7600 7594 7639 7596 7594 7600 7596 7600 7597 7599 7600 7598 7598 7495 7599 7598 7503 7495 7504 7503 7601 7601 7503 7598 7504 7601 7602 7598 7602 7601 7604 7602 7636 7609 7604 7635 7604 7636 7635 7579 7635 7636 7648 7609 7635 7607 7608 7609 7608 7523 7609 7648 7607 7609 7648 7614 7607 7613 7608 7607 7614 7613 7607 7524 7523 7608 7672 7608 7613 7672 7670 7608 7608 7670 7524 7522 7523 7524 7424 7440 7524 7524 7440 7522 7434 7424 7524 7524 7670 7434 7434 7670 7431 7431 7670 7671 7670 7672 7671 7660 7671 7672 7672 7613 7673 7431 7671 7660 7660 7661 7431 7431 7661 7441 7661 7445 7441 7549 7445 7661 7440 7444 7445 7445 7444 7441 7522 7445 7549 7440 7445 7522 7551 7520 7549 7520 7522 7549 7438 7439 7440 7440 7439 7444 7438 7440 7424 7439 7438 7436 7427 7436 7438 7427 7438 7426 7424 7426 7438 7424 7425 7426 7434 7433 7424 7424 7433 7425 7426 7425 7423 7426 7423 7427 7427 7423 7422 7422 7436 7427 7421 7422 7423 7425 7439 7423 7423 7439 7435 7423 7435 7421 7433 7444 7425 7425 7444 7439 7441 7444 7442 7433 7442 7444 7441 7442 7443 7431 7441 7432 7432 7441 7443 7447 7443 7442 7430 7447 7442 7430 7442 7433 7447 7446 7443 7432 7443 7446 7435 7446 7447 7421 7435 7447 7421 7447 7430 7430 7431 7432 7430 7432 7421 7431 7430 7433 7431 7433 7434 7421 7428 7429 7421 7429 7422 7421 7432 7428 7432 7446 7428 7428 7446 7437 7428 7437 7429 7435 7437 7446 7435 7436 7437 7439 7436 7435 7429 7437 7436 7429 7436 7422 7673 7613 7615 7674 7673 7615 7614 7615 7613 7616 7617 7615 7615 7614 7616 7674 7615 7676 7676 7615 7617 7404 7674 7675 7675 7674 7676 7675 7676 7619 7676 7617 7619 7618 7619 7617 7617 7616 7618 7616 7614 7618 7620 7621 7618 7618 7621 7619 7645 7624 7618 7620 7618 7624 7619 7621 7668 7619 7668 7675 7675 7668 7407 7404 7675 7407 7407 7668 7651 7651 7668 7649 7649 7668 7669 7668 7621 7669 7622 7621 7620 7669 7621 7622 7622 7620 7624 7623 7622 7624 7669 7622 7623 7649 7669 7654 7669 7623 7654 7623 7624 7625 7654 7623 7411 7411 7623 7410 7623 7625 7488 7410 7623 7488 7411 7461 7654 7654 7461 7655 7654 7655 7649 7649 7655 7656 7461 7533 7655 7655 7538 7656 7538 7655 7533 7649 7656 7650 7538 7662 7656 7656 7662 7650 7537 7538 7532 7532 7538 7533 7537 7540 7538 7540 7662 7538 7650 7662 7652 7451 7652 7662 7666 7451 7662 7540 7666 7662 7649 7650 7651 7651 7650 7652 7651 7652 7406 7406 7652 7452 7451 7452 7652 7451 7450 7452 7667 7450 7451 7667 7451 7666 7666 7540 7546 7667 7666 7546 7448 7450 7667 7448 7449 7450 7452 7450 7449 7406 7452 7405 7405 7452 7449 7405 7404 7406 7406 7404 7407 7406 7407 7651 7539 7546 7540 7539 7540 7537 7537 7576 7539 7532 7576 7537 7575 7576 7571 7571 7576 7532 7532 7533 7534 7571 7532 7536 7536 7532 7534 7534 7533 7525 7533 7461 7465 7533 7465 7487 7533 7487 7525 7534 7525 7485 7534 7485 7535 7536 7534 7535 7525 7487 7485 7484 7483 7485 7484 7485 7486 7486 7485 7487 7535 7485 7483 7535 7483 7536 7482 7481 7483 7482 7483 7484 7536 7483 7481 7625 7482 7484 7625 7484 7486 7486 7487 7488 7625 7486 7488 7634 7482 7625 7625 7624 7633 7634 7625 7633 7480 7481 7482 7634 7480 7482 7480 7479 7481 7536 7481 7479 7478 7479 7480 7633 7478 7480 7633 7480 7634 7632 7478 7633 7633 7624 7631 7632 7633 7631 7476 7477 7478 7478 7477 7479 7632 7476 7478 7536 7479 7531 7531 7479 7477 7571 7536 7531 7475 7529 7531 7531 7477 7475 7571 7531 7529 7476 7475 7477 7474 7475 7476 7631 7474 7476 7631 7476 7632 7474 7473 7475 7473 7529 7475 7529 7473 7471 7471 7530 7529 7528 7571 7529 7528 7529 7530 7472 7471 7473 7472 7473 7474 7630 7472 7474 7630 7474 7631 7470 7471 7472 7629 7470 7472 7629 7472 7630 7630 7631 7628 7629 7630 7628 7642 7631 7624 7642 7593 7631 7628 7631 7593 7627 7470 7628 7628 7470 7629 7628 7593 7626 7627 7628 7626 7626 7468 7627 7627 7468 7470 7593 7468 7626 7466 7467 7468 7468 7467 7469 7468 7469 7470 7593 7466 7468 7592 7466 7593 7466 7592 7493 7493 7494 7466 7466 7494 7467 7526 7467 7527 7527 7467 7494 7467 7526 7469 7470 7469 7471 7528 7471 7469 7469 7526 7528 7527 7586 7526 7586 7528 7526 7494 7565 7527 7591 7527 7565 7591 7586 7527 7585 7586 7587 7585 7571 7586 7586 7591 7587 7586 7571 7528 7471 7528 7530 7569 7570 7571 7575 7571 7570 7569 7571 7585 7585 7642 7569 7569 7642 7643 7569 7643 7570 7570 7643 7644 7570 7644 7575 7575 7644 7645 7644 7624 7645 7624 7644 7643 7642 7624 7643 7585 7641 7642 7641 7593 7642 7587 7640 7641 7587 7641 7585 7640 7593 7641 7592 7593 7640 7590 7639 7640 7590 7640 7587 7639 7594 7640 7640 7594 7592 7587 7591 7590 7590 7591 7584 7584 7639 7590 7493 7592 7594 7493 7594 7491 7491 7594 7595 7595 7594 7596 7491 7492 7493 7493 7492 7494 7489 7490 7491 7491 7490 7492 7491 7595 7489 7595 7596 7489 7492 7565 7494 7488 7487 7408 7408 7410 7488 7453 7408 7487 7453 7487 7465 7408 7409 7410 7414 7413 7408 7408 7413 7409 7453 7414 7408 7410 7409 7411 7411 7409 7412 7464 7412 7409 7464 7409 7454 7454 7409 7413 7411 7412 7417 7417 7462 7411 7411 7462 7461 7417 7412 7418 7460 7418 7412 7460 7412 7464 7417 7418 7419 7462 7417 7419 7416 7420 7418 7418 7420 7419 7457 7416 7418 7457 7418 7460 7460 7461 7462 7460 7462 7457 7461 7460 7464 7462 7463 7457 7462 7419 7463 7463 7419 7420 7416 7415 7420 7463 7420 7458 7458 7420 7415 7413 7415 7416 7456 7413 7416 7456 7416 7457 7457 7458 7456 7457 7463 7458 7456 7458 7459 7458 7415 7459 7413 7414 7415 7459 7415 7414 7454 7413 7456 7455 7454 7456 7456 7459 7455 7459 7414 7455 7455 7414 7453 7453 7454 7455 7453 7464 7454 7465 7464 7453 7461 7464 7465 7677 7678 7679 7680 7678 7677 7938 7680 7677 7938 7677 7939 7939 7677 7679 7679 7678 7686 7679 7686 7687 7939 7679 7940 7940 7679 7687 7938 7939 7958 7940 7957 7939 7939 7957 7958 7937 7680 7938 7938 7958 7937 7936 7681 7937 7937 7681 7680 7937 7959 7936 7937 7958 7959 7935 7683 7936 7936 7683 7681 7936 7959 7935 7680 7681 7682 7683 7682 7681 7684 7685 7683 7683 7685 7682 7935 7684 7683 7934 7684 7935 7934 7935 7955 7935 7959 7955 7690 7691 7684 7684 7691 7685 7934 7690 7684 7685 7691 7747 7747 7793 7685 7685 7793 7682 7691 7791 7747 7747 7791 7792 7747 7792 7793 7682 7793 7794 7825 7794 7793 7792 7825 7793 7791 7826 7792 7826 7825 7792 7791 7851 7826 7826 7848 7829 7826 7829 7828 7826 7828 7825 7851 7848 7826 7847 7811 7848 7811 7829 7848 7851 7847 7848 7812 7828 7829 7812 7829 7811 7813 7828 7812 7813 7830 7828 7825 7828 7830 7811 7749 7812 7812 7749 7748 7812 7748 7784 7812 7784 7813 7813 7784 7783 7813 7783 7814 7814 7830 7813 7830 7814 7831 7825 7830 7831 7814 7783 7782 7814 7782 7781 7814 7781 7815 7831 7814 7815 7727 7781 7782 7727 7782 7783 7784 7740 7783 7783 7740 7727 7748 7740 7784 7739 7697 7740 7740 7697 7696 7727 7740 7696 7748 7739 7740 7727 7696 7728 7728 7781 7727 7728 7696 7718 7728 7718 7741 7728 7741 7780 7728 7780 7781 7713 7715 7718 7696 7720 7718 7718 7720 7713 7741 7718 7715 7779 7741 7778 7778 7741 7715 7780 7741 7779 7815 7781 7780 7815 7780 7816 7816 7780 7779 7816 7779 7817 7817 7779 7778 7816 7831 7815 7817 7832 7816 7816 7832 7831 7817 7778 7818 7818 7832 7817 7832 7818 7833 7855 7832 7833 7854 7831 7832 7854 7832 7855 7825 7831 7854 7824 7825 7854 7824 7854 7855 7824 7855 7856 7856 7855 7833 7819 7833 7818 7819 7834 7833 7856 7833 7834 7849 7824 7856 7856 7834 7858 7856 7858 7849 7794 7824 7795 7824 7794 7825 7795 7824 7849 7682 7794 7746 7746 7794 7795 7746 7795 7678 7678 7795 7796 7795 7849 7796 7746 7678 7682 7680 7682 7678 7678 7796 7797 7678 7797 7686 7796 7849 7797 7686 7797 7785 7823 7785 7797 7797 7849 7823 7687 7686 7688 7688 7686 7689 7745 7689 7686 7686 7785 7745 7745 7785 7786 7785 7823 7786 7745 7786 7787 7745 7787 7689 7787 7786 7788 7786 7823 7850 7786 7850 7788 7689 7787 7788 7688 7689 7695 7695 7689 7694 7744 7694 7689 7689 7788 7744 7695 7694 7693 7930 7688 7695 7930 7695 7931 7931 7695 7693 7693 7694 7692 7931 7693 7932 7932 7693 7692 7692 7691 7690 7692 7694 7691 7932 7692 7933 7933 7692 7690 7932 7951 7931 7933 7951 7932 7933 7690 7934 7934 7955 7933 7933 7955 7951 7951 7947 7943 7951 7943 7952 7955 7947 7951 7931 7951 7952 7955 7949 7947 7959 7949 7955 7946 7943 7947 7949 7946 7947 7948 7946 7949 7959 7948 7949 7959 7958 7948 7948 7945 7946 7958 7945 7948 7945 7943 7946 7944 7943 7945 7954 7944 7945 7954 7945 7958 7957 7954 7958 7953 7944 7954 7957 7953 7954 7942 7943 7944 7953 7942 7944 7956 7942 7953 7957 7956 7953 7940 7956 7957 7940 7687 7941 7941 7956 7940 7687 7688 7929 7941 7687 7929 7929 7956 7941 7929 7688 7930 7929 7930 7956 7930 7931 7956 7956 7950 7942 7931 7950 7956 7931 7952 7950 7950 7943 7942 7952 7943 7950 7694 7790 7691 7691 7790 7791 7744 7789 7694 7694 7789 7790 7790 7789 7827 7790 7827 7791 7791 7827 7851 7851 7827 7788 7788 7827 7789 7744 7788 7789 7788 7852 7853 7853 7851 7788 7850 7852 7788 7851 7862 7847 7851 7853 7862 7853 7844 7845 7853 7845 7862 7852 7843 7853 7853 7843 7844 7862 7845 7846 7862 7846 7847 7846 7810 7847 7847 7810 7811 7846 7845 7809 7846 7809 7810 7809 7753 7810 7810 7753 7752 7810 7752 7751 7810 7751 7811 7811 7751 7750 7811 7750 7749 7751 7726 7750 7726 7751 7738 7738 7751 7752 7738 7752 7753 7737 7700 7738 7738 7700 7726 7753 7737 7738 7726 7700 7699 7726 7699 7697 7739 7726 7697 7750 7726 7739 7750 7739 7749 7748 7749 7739 7696 7697 7698 7698 7697 7699 7719 7720 7696 7696 7698 7719 7698 7877 7719 7877 7698 7872 7699 7872 7698 7719 7893 7720 7893 7719 7877 7720 7880 7713 7880 7720 7893 7881 7880 7893 7881 7893 7876 7876 7893 7877 7876 7877 7871 7871 7877 7872 7871 7919 7876 7919 7917 7876 7876 7917 7916 7876 7916 7881 7879 7880 7881 7881 7916 7915 7881 7915 7879 7911 7915 7916 7911 7916 7917 7917 7919 7911 7918 7919 7920 7920 7919 7921 7918 7923 7919 7919 7923 7924 7919 7924 7925 7911 7919 7926 7926 7919 7925 7873 7921 7919 7873 7919 7871 7904 7925 7924 7904 7924 7867 7867 7924 7923 7899 7926 7925 7899 7925 7904 7901 7911 7926 7901 7926 7899 7899 7900 7901 7904 7905 7899 7899 7905 7906 7899 7906 7900 7867 7908 7904 7904 7908 7905 7908 7702 7905 7708 7906 7905 7708 7905 7704 7704 7905 7702 7906 7708 7900 7707 7708 7709 7725 7709 7708 7725 7708 7704 7707 7900 7708 7709 7711 7707 7707 7902 7900 7902 7707 7903 7903 7707 7711 7901 7900 7902 7901 7902 7897 7897 7902 7903 7897 7903 7898 7711 7898 7903 7897 7898 7894 7894 7928 7897 7897 7928 7911 7897 7911 7901 7894 7898 7895 7898 7711 7895 7894 7895 7885 7885 7927 7894 7894 7927 7928 7914 7911 7928 7914 7928 7927 7909 7910 7911 7910 7915 7911 7909 7911 7914 7868 7910 7909 7868 7909 7869 7869 7909 7914 7879 7915 7910 7879 7910 7868 7868 7869 7870 7870 7878 7868 7868 7878 7879 7882 7883 7869 7869 7883 7884 7869 7884 7870 7869 7914 7882 7714 7870 7884 7870 7714 7878 7879 7878 7880 7713 7878 7714 7878 7713 7880 7713 7714 7715 7715 7714 7716 7716 7714 7717 7714 7884 7717 7883 7717 7884 7882 7889 7883 7717 7883 7889 7721 7717 7722 7730 7716 7717 7730 7717 7731 7731 7717 7721 7717 7889 7722 7729 7715 7716 7729 7716 7730 7729 7778 7715 7730 7776 7729 7729 7776 7777 7729 7777 7778 7775 7730 7774 7774 7730 7731 7730 7775 7776 7721 7773 7731 7774 7731 7773 7819 7775 7774 7819 7774 7820 7820 7774 7773 7819 7776 7775 7818 7777 7776 7818 7776 7819 7818 7778 7777 7820 7834 7819 7820 7773 7821 7821 7835 7820 7820 7835 7834 7721 7772 7773 7821 7773 7772 7821 7772 7771 7821 7771 7822 7822 7836 7821 7821 7836 7835 7858 7834 7835 7858 7835 7836 7836 7822 7798 7836 7798 7837 7857 7836 7837 7849 7858 7836 7849 7836 7857 7822 7771 7770 7822 7770 7798 7723 7724 7770 7770 7724 7769 7723 7770 7771 7770 7769 7798 7721 7722 7723 7723 7722 7710 7723 7710 7724 7723 7771 7721 7724 7710 7712 7732 7724 7712 7769 7724 7732 7769 7732 7768 7798 7769 7768 7768 7732 7767 7767 7732 7712 7798 7768 7799 7799 7768 7767 7799 7837 7798 7799 7767 7800 7800 7838 7799 7799 7838 7837 7712 7766 7767 7800 7767 7766 7800 7766 7801 7801 7838 7800 7801 7839 7838 7857 7837 7838 7857 7838 7859 7859 7838 7839 7801 7766 7765 7801 7765 7802 7802 7839 7801 7766 7733 7765 7733 7766 7712 7765 7742 7764 7765 7733 7742 7802 7765 7764 7733 7712 7709 7733 7709 7742 7710 7711 7712 7712 7711 7709 7742 7709 7725 7764 7742 7763 7763 7742 7725 7802 7764 7763 7725 7762 7763 7802 7763 7803 7803 7763 7762 7743 7725 7704 7743 7761 7725 7725 7761 7762 7803 7762 7761 7803 7761 7804 7840 7802 7803 7803 7841 7840 7804 7841 7803 7743 7760 7761 7804 7761 7760 7760 7743 7759 7804 7760 7759 7804 7759 7805 7804 7842 7841 7805 7842 7804 7860 7840 7841 7860 7841 7852 7852 7841 7842 7805 7843 7842 7852 7842 7843 7805 7759 7758 7805 7758 7806 7806 7843 7805 7759 7734 7758 7759 7743 7734 7705 7757 7758 7758 7734 7705 7806 7758 7757 7734 7704 7705 7743 7704 7734 7704 7703 7705 7705 7703 7706 7735 7705 7706 7735 7757 7705 7735 7756 7757 7806 7757 7756 7735 7706 7736 7736 7755 7735 7735 7755 7756 7806 7756 7807 7807 7756 7755 7755 7736 7754 7807 7755 7808 7808 7755 7754 7736 7706 7701 7736 7701 7737 7754 7736 7737 7754 7737 7753 7808 7754 7809 7809 7754 7753 7808 7845 7807 7809 7845 7808 7807 7845 7806 7806 7845 7844 7843 7806 7844 7737 7701 7700 7699 7700 7701 7699 7874 7872 7874 7699 7892 7699 7701 7892 7873 7872 7874 7873 7874 7875 7875 7874 7892 7871 7872 7873 7875 7921 7873 7875 7892 7890 7890 7922 7875 7875 7922 7921 7890 7892 7891 7892 7701 7891 7891 7701 7706 7890 7891 7863 7863 7891 7864 7891 7706 7864 7863 7920 7890 7890 7920 7922 7920 7921 7922 7863 7918 7920 7863 7864 7865 7865 7918 7863 7865 7864 7866 7864 7706 7866 7703 7866 7706 7865 7866 7867 7866 7907 7867 7703 7907 7866 7867 7923 7865 7865 7923 7918 7867 7907 7908 7907 7703 7908 7702 7703 7704 7702 7908 7703 7850 7860 7852 7823 7861 7850 7850 7861 7860 7861 7840 7860 7859 7839 7861 7861 7839 7840 7823 7859 7861 7849 7857 7823 7823 7857 7859 7839 7802 7840 7710 7895 7711 7710 7896 7895 7896 7710 7886 7722 7886 7710 7885 7895 7896 7885 7896 7886 7885 7886 7887 7887 7886 7888 7722 7888 7886 7888 7722 7889 7887 7888 7882 7882 7888 7889 7882 7913 7887 7887 7913 7912 7887 7912 7885 7885 7912 7927 7912 7913 7914 7912 7914 7927 7882 7914 7913 7721 7771 7772 7960 7961 7962 7981 7960 7982 7982 7960 7962 7994 7961 7960 7994 7960 7981 7997 7994 7981 7997 7981 8009 7981 7982 8009 7982 7962 7968 7982 7968 7983 8008 7982 7983 8009 7982 8008 7975 7997 8009 7975 8009 7976 7976 8009 8008 7996 7994 7997 7975 7996 7997 7975 7961 7974 7976 7961 7975 7974 7998 7975 7975 7998 7996 7976 7962 7961 7978 7962 7976 7976 8008 7978 7974 7961 7973 7993 7973 7961 7993 7961 7994 7974 7973 7972 7972 7998 7974 7965 7972 7973 7991 7965 7973 7991 7973 7992 7992 7973 7993 7972 7965 7970 7970 8000 7972 7972 8000 7999 7972 7999 7998 8000 7989 7999 8001 7989 8000 7970 8001 8000 7999 7989 7995 7999 7995 7998 7998 7993 7996 7998 7995 7993 7991 7995 7989 7995 7991 7992 7995 7992 7993 7993 7994 7996 7990 7965 7991 7989 7990 7991 7989 7963 7990 7990 7963 7965 7963 7964 7965 7970 7965 7964 7988 7964 7963 7988 7963 7989 7987 7964 7988 8004 7988 8001 8001 7988 7989 7987 7988 8004 8005 7987 8004 7971 8004 7970 7970 8004 8001 7971 8005 8004 7970 7964 7971 7971 7967 7980 7971 7964 7967 7980 8005 7971 8002 7985 8005 8005 7985 7987 7980 8002 8005 7980 7967 7979 7979 8002 7980 8002 8003 7985 7979 8003 8002 7979 7967 7969 7979 7969 7977 7977 8003 7979 8006 7985 8003 7977 8006 8003 7977 7969 7962 7977 7962 7978 7978 8008 7977 7977 8008 8007 7977 8007 8006 8007 7985 8006 8007 7983 7985 8008 7983 8007 7983 7968 7969 7983 7969 7984 7984 7985 7983 7968 7962 7969 7984 7969 7985 7969 7967 7985 7985 7967 7986 7986 7987 7985 7966 7967 7964 7986 7967 7966 7986 7966 7987 7987 7966 7964 8010 8011 8012 8012 8014 8010 8019 8011 8010 8019 8010 8020 8020 8010 8021 8021 8010 8014 8011 8013 8012 8013 8011 8015 8019 8015 8011 8017 8012 8013 8017 8013 8018 8018 8013 8015 8018 8015 8019 8019 8025 8018 8018 8025 8026 8018 8026 8017 8016 8012 8017 8017 8026 8022 8017 8022 8016 8025 8031 8026 8026 8031 8032 8026 8032 8022 8019 8024 8025 8024 8030 8025 8025 8030 8031 8020 8024 8019 8027 8024 8020 8024 8027 8030 8021 8023 8020 8020 8023 8027 8021 8014 8012 8021 8012 8016 8016 8022 8021 8021 8022 8023 8022 8028 8023 8023 8028 8029 8023 8029 8027 8022 8032 8028 8037 8032 8038 8038 8032 8039 8039 8032 8040 8040 8032 8031 8037 8028 8032 8039 8036 8038 8038 8036 8068 8038 8068 8037 8040 8069 8039 8039 8069 8036 8040 8031 8041 8041 8070 8040 8070 8069 8040 8041 8031 8042 8042 8031 8030 8042 8055 8041 8041 8055 8070 8036 8069 8070 8036 8070 8055 8035 8036 8055 8035 8055 8042 8042 8030 8043 8043 8035 8042 8043 8030 8044 8044 8030 8045 8045 8030 8027 8044 8056 8043 8043 8056 8035 8033 8034 8035 8036 8035 8034 8035 8056 8033 8056 8057 8033 8057 8056 8044 8045 8057 8044 8033 8057 8058 8045 8058 8057 8045 8027 8051 8051 8058 8045 8033 8058 8059 8051 8059 8058 8051 8027 8052 8052 8059 8051 8033 8059 8060 8052 8060 8059 8052 8027 8046 8046 8060 8052 8060 8061 8033 8061 8060 8046 8046 8029 8047 8046 8027 8029 8047 8061 8046 8061 8062 8033 8062 8061 8047 8047 8029 8048 8048 8062 8047 8048 8029 8049 8049 8029 8050 8029 8028 8050 8049 8063 8048 8048 8063 8062 8033 8062 8063 8033 8063 8034 8063 8064 8034 8064 8063 8049 8050 8064 8049 8050 8028 8053 8053 8034 8050 8034 8064 8050 8053 8028 8054 8054 8028 8037 8053 8054 8065 8053 8065 8034 8034 8065 8066 8066 8067 8034 8034 8067 8036 8054 8066 8065 8037 8067 8054 8054 8067 8066 8068 8067 8037 8067 8068 8036 8071 8072 8073 8071 8073 8074 8075 8072 8071 8083 8071 8074 8085 8075 8071 8083 8085 8071 8072 8077 8073 8075 8077 8072 8086 8073 8087 8086 8074 8073 8087 8073 8077 8075 8076 8077 8087 8077 8088 8077 8076 8088 8084 8076 8075 8084 8075 8085 8078 8079 8076 8088 8076 8089 8089 8076 8079 8076 8084 8078 8097 8084 8085 8099 8084 8097 8099 8078 8084 8079 8078 8081 8099 8081 8078 8080 8079 8081 8089 8079 8080 8090 8082 8081 8081 8082 8080 8101 8090 8081 8101 8081 8099 8082 8074 8080 8086 8089 8080 8080 8074 8086 8090 8074 8082 8090 8083 8074 8100 8083 8090 8100 8090 8101 8098 8085 8083 8098 8083 8100 8100 8093 8098 8101 8096 8100 8100 8096 8093 8097 8085 8098 8098 8093 8092 8098 8092 8097 8087 8092 8093 8087 8093 8086 8086 8093 8094 8093 8096 8094 8101 8094 8096 8086 8094 8089 8094 8095 8089 8101 8095 8094 8099 8095 8101 8089 8095 8091 8099 8091 8095 8089 8091 8088 8099 8088 8091 8097 8088 8099 8097 8092 8088 8088 8092 8087 8102 8103 8104 8102 8113 8103 8114 8115 8102 8102 8115 8113 8119 8114 8102 8119 8102 8120 8120 8102 8104 8129 8103 8113 8129 8113 8130 8130 8113 8115 8114 8107 8115 8130 8115 8131 8131 8115 8107 8120 8130 8119 8119 8130 8131 8120 8129 8130 8118 8114 8119 8119 8131 8118 8131 8107 8123 8118 8131 8123 8105 8106 8107 8105 8107 8114 8123 8107 8106 8123 8106 8124 8118 8123 8117 8117 8123 8124 8117 8105 8118 8118 8105 8114 8111 8112 8105 8105 8112 8106 8117 8111 8105 8124 8106 8112 8124 8112 8125 8117 8124 8125 8122 8111 8117 8117 8125 8122 8109 8116 8111 8111 8116 8112 8122 8109 8111 8125 8112 8116 8125 8116 8126 8122 8125 8126 8121 8109 8122 8122 8127 8121 8122 8126 8127 8126 8116 8110 8126 8110 8127 8109 8110 8116 8104 8108 8109 8109 8108 8110 8121 8104 8109 8120 8104 8121 8121 8128 8120 8121 8127 8128 8127 8110 8108 8127 8108 8128 8104 8103 8108 8128 8108 8103 8128 8103 8129 8120 8128 8129 8132 8133 8134 8146 8133 8132 8155 8146 8132 8155 8132 8156 8156 8132 8134 8134 8133 8135 8134 8135 8136 8156 8134 8157 8157 8134 8136 8172 8155 8156 8177 8156 8157 8156 8177 8172 8160 8146 8155 8155 8172 8160 8159 8145 8160 8160 8145 8146 8173 8160 8172 8160 8173 8159 8143 8144 8145 8145 8144 8146 8159 8143 8145 8141 8142 8143 8143 8142 8144 8159 8141 8143 8146 8144 8147 8148 8144 8142 8147 8144 8151 8144 8148 8151 8146 8147 8133 8147 8149 8133 8151 8149 8147 8151 8164 8149 8171 8151 8148 8151 8171 8164 8133 8149 8150 8162 8149 8163 8162 8150 8149 8149 8164 8163 8133 8150 8135 8135 8150 8137 8137 8150 8154 8162 8170 8150 8170 8154 8150 8187 8162 8163 8162 8187 8192 8192 8170 8162 8163 8184 8187 8163 8164 8184 8188 8187 8189 8187 8184 8210 8210 8189 8187 8192 8187 8188 8164 8183 8184 8184 8185 8186 8185 8184 8183 8210 8184 8186 8164 8171 8183 8182 8171 8148 8171 8182 8183 8182 8148 8166 8182 8166 8204 8182 8204 8183 8142 8152 8148 8152 8166 8148 8152 8165 8166 8201 8166 8165 8166 8201 8204 8139 8153 8152 8139 8152 8142 8165 8152 8153 8141 8139 8142 8138 8137 8139 8138 8139 8140 8140 8139 8141 8137 8153 8139 8158 8141 8159 8161 8140 8141 8161 8141 8158 8161 8138 8140 8136 8137 8138 8157 8136 8138 8157 8138 8161 8136 8135 8137 8137 8154 8153 8168 8169 8154 8169 8153 8154 8181 8154 8170 8168 8154 8181 8167 8153 8169 8168 8167 8169 8168 8181 8193 8167 8168 8195 8168 8193 8195 8193 8181 8170 8170 8192 8193 8194 8193 8180 8193 8192 8178 8178 8180 8193 8195 8193 8194 8192 8188 8190 8192 8190 8178 8178 8179 8180 8178 8226 8179 8178 8190 8226 8180 8211 8194 8180 8179 8225 8180 8225 8211 8226 8239 8179 8179 8239 8240 8179 8240 8225 8224 8211 8225 8225 8240 8241 8225 8241 8224 8194 8211 8212 8211 8213 8212 8211 8224 8213 8241 8242 8224 8224 8242 8213 8213 8197 8212 8223 8197 8213 8213 8242 8243 8213 8243 8223 8195 8194 8212 8212 8197 8195 8196 8195 8197 8223 8196 8197 8200 8223 8222 8196 8223 8200 8223 8243 8244 8223 8244 8222 8242 8259 8243 8260 8243 8259 8243 8260 8244 8222 8244 8245 8244 8260 8261 8244 8261 8245 8221 8202 8222 8202 8200 8222 8222 8245 8221 8221 8245 8246 8245 8261 8262 8262 8246 8245 8261 8260 8290 8261 8290 8291 8262 8261 8291 8263 8246 8262 8291 8294 8262 8263 8262 8294 8221 8246 8220 8220 8246 8247 8246 8263 8247 8247 8263 8293 8293 8263 8294 8291 8295 8294 8293 8294 8295 8264 8293 8265 8265 8293 8297 8264 8247 8293 8295 8297 8293 8220 8247 8248 8264 8248 8247 8248 8264 8265 8248 8265 8249 8266 8249 8265 8297 8266 8265 8298 8266 8297 8298 8297 8299 8299 8297 8295 8266 8250 8249 8250 8266 8267 8267 8266 8298 8214 8248 8249 8214 8249 8219 8219 8249 8250 8220 8248 8214 8205 8214 8206 8219 8206 8214 8214 8205 8220 8209 8208 8219 8219 8208 8206 8219 8250 8209 8204 8205 8206 8207 8206 8208 8207 8204 8206 8201 8203 8205 8204 8201 8205 8203 8220 8205 8220 8203 8221 8201 8199 8203 8199 8202 8203 8202 8221 8203 8201 8165 8199 8165 8198 8199 8199 8198 8200 8199 8200 8202 8167 8165 8153 8165 8167 8198 8167 8195 8198 8198 8195 8196 8196 8200 8198 8207 8183 8204 8207 8208 8183 8185 8183 8208 8185 8208 8209 8209 8186 8185 8218 8186 8209 8209 8233 8218 8209 8250 8233 8186 8218 8210 8217 8210 8218 8218 8233 8234 8218 8234 8217 8250 8267 8233 8267 8268 8233 8233 8268 8234 8217 8234 8235 8234 8268 8235 8215 8210 8217 8217 8235 8215 8215 8189 8210 8189 8215 8191 8191 8215 8216 8215 8235 8236 8215 8236 8216 8269 8235 8268 8235 8269 8236 8268 8267 8300 8269 8268 8300 8270 8236 8269 8269 8300 8301 8301 8275 8269 8270 8269 8275 8216 8236 8237 8236 8270 8255 8236 8255 8237 8255 8270 8274 8274 8270 8275 8275 8273 8276 8275 8301 8273 8278 8275 8276 8274 8275 8278 8271 8273 8301 8271 8301 8300 8273 8271 8253 8273 8253 8229 8229 8276 8273 8253 8230 8229 8271 8272 8253 8272 8230 8253 8172 8229 8230 8177 8229 8172 8177 8232 8229 8276 8229 8232 8173 8172 8174 8172 8230 8174 8173 8174 8159 8174 8158 8159 8174 8175 8158 8158 8175 8161 8176 8161 8175 8175 8174 8176 8174 8227 8176 8174 8228 8227 8174 8230 8228 8176 8157 8161 8177 8157 8176 8176 8231 8177 8176 8227 8231 8177 8231 8232 8280 8232 8231 8282 8280 8231 8282 8231 8227 8280 8276 8232 8279 8276 8280 8279 8280 8282 8287 8286 8282 8279 8282 8286 8282 8227 8287 8289 8286 8287 8252 8287 8227 8289 8287 8252 8284 8285 8286 8288 8286 8289 8285 8279 8286 8284 8286 8288 8284 8258 8285 8259 8258 8284 8284 8288 8259 8279 8285 8283 8258 8283 8285 8258 8242 8241 8258 8259 8242 8241 8283 8258 8260 8259 8288 8260 8288 8290 8289 8290 8288 8290 8289 8291 8291 8289 8292 8292 8295 8291 8289 8252 8292 8295 8292 8296 8292 8252 8228 8228 8296 8292 8295 8296 8272 8299 8295 8272 8228 8251 8296 8272 8296 8251 8251 8228 8230 8227 8228 8252 8272 8251 8230 8271 8299 8272 8298 8299 8271 8267 8298 8271 8300 8267 8271 8283 8281 8279 8257 8281 8283 8283 8241 8257 8257 8256 8281 8277 8279 8281 8277 8281 8256 8278 8276 8279 8277 8278 8279 8277 8274 8278 8256 8254 8277 8277 8254 8274 8239 8254 8256 8239 8256 8257 8254 8238 8255 8238 8254 8239 8274 8254 8255 8226 8238 8239 8239 8257 8240 8226 8237 8238 8255 8238 8237 8226 8190 8216 8216 8237 8226 8190 8188 8191 8216 8190 8191 8188 8189 8191 8240 8257 8241 8302 8303 8304 8304 8305 8302 8329 8303 8302 8335 8329 8302 8335 8302 8336 8336 8302 8305 8329 8309 8303 8332 8309 8329 8334 8332 8329 8334 8329 8335 8359 8334 8335 8335 8362 8359 8362 8335 8336 8336 8305 8337 8336 8357 8362 8337 8357 8336 8378 8362 8357 8389 8359 8362 8389 8362 8390 8362 8378 8390 8356 8357 8337 8379 8357 8356 8379 8391 8357 8357 8391 8378 8391 8415 8378 8378 8415 8390 8414 8389 8390 8390 8415 8414 8391 8411 8415 8415 8411 8426 8408 8414 8415 8407 8415 8426 8407 8408 8415 8410 8411 8391 8410 8391 8379 8426 8411 8410 8425 8401 8426 8426 8401 8402 8426 8402 8407 8425 8426 8410 8404 8407 8403 8403 8407 8402 8407 8404 8408 8401 8380 8402 8402 8380 8381 8402 8381 8372 8402 8372 8403 8403 8372 8373 8403 8373 8404 8404 8373 8405 8405 8408 8404 8355 8373 8372 8374 8373 8355 8405 8373 8374 8372 8351 8355 8381 8351 8372 8380 8351 8381 8326 8351 8327 8327 8351 8352 8326 8325 8351 8325 8355 8351 8380 8352 8351 8306 8325 8326 8306 8326 8307 8307 8326 8327 8318 8307 8327 8327 8352 8318 8318 8352 8348 8352 8371 8348 8352 8380 8371 8401 8371 8380 8348 8371 8363 8400 8363 8371 8400 8371 8401 8318 8348 8349 8348 8363 8349 8363 8364 8349 8399 8364 8363 8399 8363 8400 8400 8401 8409 8400 8409 8399 8409 8401 8425 8424 8398 8409 8409 8398 8399 8425 8416 8409 8409 8416 8418 8424 8409 8418 8398 8364 8399 8349 8364 8370 8398 8370 8364 8397 8370 8398 8424 8397 8398 8423 8397 8424 8424 8418 8417 8423 8424 8417 8384 8417 8418 8384 8418 8383 8383 8418 8416 8417 8384 8385 8423 8417 8385 8383 8361 8384 8384 8361 8376 8384 8376 8385 8382 8377 8383 8383 8377 8361 8383 8416 8382 8377 8382 8379 8382 8416 8379 8377 8356 8361 8379 8356 8377 8379 8416 8410 8425 8410 8416 8338 8356 8337 8339 8361 8356 8339 8356 8338 8337 8331 8338 8338 8331 8328 8338 8328 8339 8337 8305 8331 8331 8317 8328 8305 8307 8331 8331 8307 8317 8328 8317 8311 8311 8330 8328 8339 8328 8330 8339 8330 8340 8340 8361 8339 8330 8310 8333 8310 8330 8311 8340 8330 8341 8341 8330 8333 8341 8358 8340 8340 8358 8361 8376 8361 8358 8341 8360 8358 8385 8376 8358 8385 8358 8386 8386 8358 8360 8341 8333 8334 8334 8360 8341 8359 8360 8334 8386 8360 8387 8387 8360 8359 8419 8420 8386 8386 8420 8385 8419 8386 8387 8423 8385 8420 8422 8420 8419 8423 8420 8422 8387 8412 8419 8422 8419 8421 8421 8419 8412 8387 8359 8388 8388 8412 8387 8388 8359 8389 8412 8388 8389 8412 8389 8413 8421 8412 8413 8392 8393 8421 8421 8393 8422 8413 8392 8421 8422 8393 8395 8422 8395 8423 8392 8366 8393 8393 8366 8365 8393 8365 8394 8395 8393 8394 8406 8375 8392 8392 8375 8366 8413 8406 8392 8365 8366 8346 8366 8375 8346 8375 8374 8353 8346 8375 8353 8406 8374 8375 8405 8374 8406 8405 8406 8408 8408 8406 8413 8374 8355 8354 8353 8374 8354 8322 8353 8323 8323 8353 8354 8322 8346 8353 8323 8354 8315 8315 8354 8324 8324 8354 8355 8324 8355 8325 8304 8315 8324 8304 8324 8325 8303 8314 8315 8303 8315 8304 8314 8323 8315 8314 8322 8323 8309 8314 8303 8309 8322 8314 8308 8309 8310 8308 8321 8309 8309 8321 8322 8333 8309 8332 8333 8310 8309 8310 8313 8308 8308 8313 8321 8311 8312 8310 8310 8312 8320 8310 8320 8313 8320 8343 8313 8313 8343 8344 8313 8344 8321 8312 8342 8320 8320 8342 8343 8311 8319 8312 8319 8347 8312 8312 8347 8342 8319 8311 8316 8316 8311 8317 8316 8350 8319 8319 8350 8347 8370 8369 8347 8347 8369 8342 8349 8370 8347 8350 8349 8347 8316 8349 8350 8316 8317 8318 8318 8349 8316 8318 8317 8307 8305 8306 8307 8305 8304 8306 8304 8325 8306 8397 8369 8370 8396 8369 8397 8423 8396 8397 8395 8368 8396 8396 8368 8369 8395 8396 8423 8394 8367 8395 8395 8367 8368 8343 8368 8367 8369 8368 8342 8342 8368 8343 8344 8367 8365 8367 8344 8343 8394 8365 8367 8321 8344 8345 8345 8344 8365 8345 8365 8346 8321 8345 8346 8321 8346 8322 8334 8333 8332 8413 8389 8414 8413 8414 8408 8427 8428 8429 8430 8427 8429 8428 8427 8430 8429 8428 8430 8431 8432 8433 8433 8506 8431 8431 8506 8507 8431 8507 8504 8431 8528 8432 8504 8529 8431 8431 8529 8530 8431 8530 8528 8433 8507 8506 8432 8435 8433 8433 8437 8440 8433 8435 8437 8433 8440 8560 8560 8507 8433 8434 8435 8432 8434 8437 8435 8436 8437 8438 8438 8437 8434 8440 8437 8436 8434 8526 8438 8432 8527 8434 8434 8527 8526 8432 8528 8527 8526 8527 8523 8528 8531 8527 8568 8527 8531 8568 8523 8527 8526 8523 8438 8436 8438 8439 8523 8439 8438 8436 8439 8440 8441 8442 8439 8439 8442 8440 8523 8524 8439 8439 8524 8525 8439 8525 8441 8443 8444 8441 8441 8444 8442 8441 8522 8443 8441 8525 8522 8522 8525 8521 8524 8523 8525 8525 8523 8521 8443 8522 8521 8445 8446 8443 8443 8446 8444 8443 8521 8445 8442 8444 8446 8445 8450 8446 8448 8452 8446 8446 8452 8442 8446 8450 8448 8449 8450 8445 8445 8519 8449 8445 8521 8519 8449 8448 8450 8447 8448 8449 8447 8452 8448 8447 8449 8451 8518 8451 8449 8449 8519 8520 8449 8520 8518 8519 8521 8520 8517 8520 8521 8518 8520 8517 8516 8451 8518 8516 8518 8517 8451 8516 8517 8447 8451 8452 8453 8452 8451 8451 8517 8453 8454 8455 8453 8453 8455 8452 8453 8515 8454 8453 8517 8515 8456 8457 8454 8454 8457 8455 8454 8514 8456 8454 8515 8514 8515 8517 8514 8456 8514 8513 8512 8513 8514 8574 8514 8517 8512 8514 8574 8456 8513 8458 8458 8513 8512 8458 8460 8456 8456 8460 8457 8457 8460 8455 8458 8459 8460 8460 8461 8464 8460 8459 8461 8455 8460 8556 8460 8464 8556 8459 8458 8461 8461 8458 8462 8462 8464 8461 8511 8462 8458 8511 8458 8512 8463 8464 8462 8462 8509 8510 8462 8510 8463 8509 8462 8511 8511 8512 8509 8508 8510 8509 8508 8509 8512 8463 8510 8508 8465 8466 8463 8463 8466 8464 8463 8508 8465 8469 8470 8465 8465 8551 8469 8466 8465 8470 8551 8465 8508 8586 8464 8466 8466 8470 8583 8590 8586 8466 8590 8466 8583 8469 8468 8470 8468 8472 8470 8583 8470 8472 8583 8472 8591 8602 8590 8583 8602 8583 8603 8603 8583 8591 8614 8586 8590 8614 8590 8602 8581 8614 8602 8581 8602 8603 8615 8603 8591 8579 8581 8603 8579 8603 8640 8640 8603 8615 8579 8580 8581 8581 8580 8582 8582 8614 8581 8694 8579 8640 8693 8580 8579 8693 8579 8694 8691 8582 8580 8691 8580 8693 8639 8614 8582 8670 8639 8582 8670 8582 8690 8690 8582 8691 8689 8690 8691 8740 8689 8691 8740 8691 8693 8692 8693 8694 8740 8693 8692 8746 8689 8740 8746 8740 8668 8668 8740 8692 8689 8671 8670 8689 8670 8690 8746 8671 8689 8745 8671 8746 8569 8745 8746 8569 8746 8668 8668 8508 8569 8550 8508 8668 8668 8692 8747 8550 8668 8747 8512 8569 8508 8512 8745 8569 8744 8687 8745 8745 8687 8671 8512 8744 8745 8574 8743 8512 8512 8743 8744 8743 8685 8744 8744 8685 8687 8685 8686 8687 8687 8686 8688 8687 8688 8672 8687 8672 8671 8682 8684 8685 8685 8684 8686 8743 8682 8685 8742 8682 8743 8574 8742 8743 8682 8683 8684 8682 8681 8683 8742 8681 8682 8683 8633 8684 8684 8633 8634 8684 8634 8635 8684 8635 8686 8681 8633 8683 8679 8680 8681 8742 8679 8681 8680 8632 8681 8681 8632 8633 8632 8600 8633 8633 8600 8634 8634 8600 8611 8634 8611 8635 8635 8611 8636 8686 8635 8636 8600 8588 8611 8611 8588 8601 8611 8601 8612 8636 8611 8612 8636 8612 8637 8686 8636 8637 8686 8637 8688 8637 8612 8638 8688 8637 8672 8672 8637 8638 8612 8601 8589 8612 8589 8613 8638 8612 8613 8601 8588 8556 8601 8556 8589 8589 8556 8586 8613 8589 8586 8613 8586 8614 8638 8613 8639 8639 8613 8614 8672 8638 8670 8670 8638 8639 8670 8671 8672 8556 8464 8586 8555 8455 8556 8588 8555 8556 8452 8455 8555 8563 8452 8555 8587 8555 8588 8587 8563 8555 8600 8587 8588 8599 8563 8587 8610 8587 8600 8630 8599 8587 8630 8587 8610 8562 8442 8563 8563 8442 8452 8599 8562 8563 8629 8562 8599 8629 8599 8630 8665 8629 8630 8665 8630 8666 8666 8630 8667 8667 8630 8610 8632 8610 8600 8667 8610 8632 8739 8666 8667 8739 8667 8632 8738 8665 8666 8738 8666 8739 8664 8629 8665 8736 8664 8665 8736 8665 8738 8737 8736 8738 8737 8738 8679 8679 8738 8739 8679 8739 8680 8739 8632 8680 8759 8737 8679 8759 8679 8742 8735 8736 8737 8735 8737 8759 8669 8735 8759 8573 8759 8574 8574 8759 8742 8573 8669 8759 8732 8734 8735 8735 8734 8736 8758 8732 8735 8758 8735 8669 8573 8521 8669 8669 8521 8570 8570 8758 8669 8517 8521 8573 8574 8517 8573 8521 8523 8570 8570 8523 8568 8570 8757 8729 8570 8729 8758 8568 8757 8570 8758 8729 8732 8729 8674 8673 8729 8673 8730 8729 8730 8731 8729 8731 8732 8757 8674 8729 8756 8674 8757 8568 8756 8757 8756 8727 8676 8756 8676 8674 8567 8727 8756 8568 8567 8756 8676 8677 8678 8727 8677 8676 8676 8678 8674 8727 8728 8677 8728 8576 8677 8677 8576 8678 8674 8678 8675 8678 8576 8578 8678 8578 8659 8678 8659 8675 8673 8674 8660 8660 8674 8675 8675 8659 8660 8578 8626 8659 8659 8626 8660 8576 8577 8578 8578 8577 8626 8577 8596 8626 8626 8596 8597 8626 8597 8609 8660 8626 8609 8660 8609 8631 8673 8660 8631 8673 8631 8730 8631 8609 8627 8661 8631 8627 8730 8631 8661 8609 8597 8598 8627 8609 8598 8627 8598 8628 8661 8627 8662 8662 8627 8628 8730 8661 8662 8730 8662 8731 8662 8628 8663 8731 8662 8733 8733 8662 8663 8628 8598 8562 8628 8562 8629 8663 8628 8629 8597 8440 8598 8598 8440 8562 8440 8442 8562 8597 8560 8440 8596 8560 8597 8585 8507 8560 8595 8585 8560 8595 8560 8596 8577 8595 8596 8625 8585 8595 8625 8595 8577 8576 8625 8577 8624 8585 8625 8657 8624 8625 8657 8625 8658 8658 8625 8576 8728 8658 8576 8728 8657 8658 8656 8624 8657 8726 8656 8657 8726 8657 8728 8727 8726 8728 8725 8724 8726 8725 8726 8727 8724 8656 8726 8655 8624 8656 8724 8655 8656 8722 8723 8724 8722 8724 8725 8723 8654 8724 8724 8654 8655 8754 8722 8725 8755 8725 8727 8755 8754 8725 8567 8755 8727 8564 8754 8755 8564 8755 8567 8754 8720 8722 8753 8720 8754 8571 8753 8754 8571 8754 8564 8535 8564 8531 8567 8531 8564 8564 8535 8571 8531 8567 8568 8503 8531 8504 8504 8531 8529 8503 8533 8531 8530 8529 8531 8530 8531 8528 8531 8533 8535 8504 8505 8503 8504 8507 8505 8503 8505 8502 8507 8502 8505 8585 8502 8507 8500 8501 8502 8503 8502 8501 8502 8499 8500 8502 8561 8499 8561 8502 8585 8594 8561 8585 8624 8594 8585 8561 8557 8499 8593 8557 8561 8593 8561 8594 8608 8593 8594 8623 8608 8594 8623 8594 8624 8655 8623 8624 8653 8608 8623 8653 8623 8654 8654 8623 8655 8607 8593 8608 8653 8607 8608 8607 8557 8593 8553 8557 8607 8622 8553 8607 8651 8622 8607 8651 8607 8652 8652 8607 8653 8716 8622 8651 8716 8651 8652 8621 8553 8622 8650 8621 8622 8715 8650 8622 8715 8622 8716 8714 8715 8716 8714 8716 8717 8717 8716 8718 8716 8652 8718 8718 8652 8719 8719 8652 8653 8717 8718 8719 8741 8714 8717 8720 8717 8719 8753 8741 8717 8753 8717 8720 8720 8719 8721 8719 8653 8721 8721 8653 8654 8720 8721 8722 8722 8721 8723 8721 8654 8723 8752 8741 8753 8571 8752 8753 8752 8714 8741 8752 8712 8714 8752 8751 8712 8572 8751 8752 8572 8752 8571 8571 8536 8572 8571 8535 8536 8572 8538 8565 8539 8572 8536 8572 8539 8538 8565 8751 8572 8565 8543 8566 8565 8538 8543 8566 8749 8565 8565 8749 8750 8565 8750 8751 8566 8543 8545 8566 8545 8575 8566 8575 8748 8566 8748 8749 8748 8702 8749 8749 8702 8704 8749 8704 8750 8750 8704 8707 8750 8707 8751 8702 8703 8704 8704 8703 8705 8704 8705 8706 8704 8706 8707 8702 8701 8703 8701 8644 8703 8703 8644 8705 8705 8644 8645 8705 8645 8706 8707 8706 8708 8706 8645 8646 8706 8646 8708 8644 8617 8645 8645 8617 8606 8645 8606 8618 8645 8618 8646 8643 8617 8644 8701 8643 8644 8616 8605 8617 8617 8605 8606 8643 8616 8617 8605 8558 8606 8606 8558 8584 8618 8606 8584 8618 8584 8619 8646 8618 8647 8647 8618 8619 8558 8488 8584 8584 8488 8554 8584 8554 8592 8619 8584 8592 8619 8592 8620 8647 8619 8648 8648 8619 8620 8709 8646 8647 8709 8647 8648 8648 8620 8649 8709 8648 8711 8711 8648 8713 8713 8648 8649 8620 8592 8621 8649 8620 8621 8649 8621 8650 8713 8649 8650 8712 8711 8713 8712 8713 8714 8714 8713 8715 8713 8650 8715 8710 8709 8711 8710 8711 8712 8751 8710 8712 8707 8709 8710 8751 8707 8710 8707 8708 8709 8708 8646 8709 8621 8592 8553 8592 8554 8553 8553 8554 8491 8553 8491 8557 8554 8488 8491 8487 8486 8488 8487 8488 8483 8483 8488 8484 8488 8478 8482 8488 8482 8484 8488 8492 8491 8488 8486 8485 8488 8485 8492 8558 8478 8488 8485 8486 8487 8485 8487 8489 8489 8492 8485 8489 8491 8492 8490 8491 8489 8489 8538 8539 8489 8539 8490 8538 8489 8540 8540 8489 8487 8490 8494 8491 8491 8494 8557 8493 8494 8490 8493 8496 8494 8496 8499 8494 8557 8494 8499 8495 8496 8493 8493 8536 8495 8490 8537 8493 8493 8537 8536 8495 8499 8496 8497 8498 8499 8497 8499 8495 8499 8498 8500 8495 8534 8497 8495 8536 8534 8535 8534 8536 8537 8539 8536 8490 8539 8537 8497 8534 8535 8497 8535 8532 8532 8535 8533 8532 8533 8501 8532 8501 8497 8501 8533 8503 8500 8497 8501 8498 8497 8500 8540 8487 8541 8483 8542 8487 8487 8542 8541 8541 8538 8540 8542 8543 8541 8538 8541 8543 8483 8543 8542 8483 8484 8481 8481 8543 8483 8481 8544 8543 8544 8545 8543 8481 8482 8479 8481 8484 8482 8479 8544 8481 8479 8546 8544 8546 8545 8544 8479 8480 8477 8479 8482 8480 8477 8546 8479 8478 8480 8482 8477 8480 8478 8476 8473 8477 8476 8477 8478 8477 8545 8546 8545 8477 8547 8547 8477 8473 8472 8474 8478 8476 8478 8474 8558 8559 8478 8559 8472 8478 8474 8473 8476 8473 8474 8475 8472 8475 8474 8473 8475 8471 8471 8475 8472 8471 8472 8467 8467 8472 8468 8591 8472 8559 8604 8591 8559 8604 8559 8605 8605 8559 8558 8615 8591 8604 8616 8604 8605 8641 8615 8604 8641 8604 8642 8642 8604 8616 8640 8615 8641 8697 8640 8641 8697 8641 8698 8698 8641 8700 8700 8641 8642 8642 8616 8643 8700 8642 8643 8699 8698 8700 8699 8700 8701 8700 8643 8701 8696 8697 8698 8696 8698 8699 8696 8695 8697 8695 8640 8697 8694 8640 8695 8692 8694 8695 8692 8695 8696 8747 8692 8696 8747 8696 8748 8748 8696 8699 8699 8701 8702 8748 8699 8702 8575 8747 8748 8550 8747 8575 8575 8545 8550 8545 8547 8549 8549 8550 8545 8473 8549 8547 8473 8548 8549 8549 8548 8550 8471 8548 8473 8471 8550 8548 8467 8550 8471 8467 8468 8469 8469 8552 8467 8467 8552 8550 8469 8551 8552 8552 8551 8550 8551 8508 8550 8663 8629 8664 8733 8663 8734 8734 8663 8736 8736 8663 8664 8732 8731 8733 8732 8733 8734 8760 8761 8762 8760 8762 8763 8779 8761 8760 8798 8779 8760 8798 8760 8763 8763 8762 8764 8788 8762 8789 8789 8762 8761 8788 8764 8762 8763 8764 8765 8798 8763 8799 8799 8763 8765 8765 8764 8766 8782 8766 8764 8782 8764 8788 8813 8782 8788 8813 8788 8814 8814 8788 8789 8781 8766 8782 8812 8781 8782 8812 8782 8813 8765 8766 8767 8781 8767 8766 8790 8767 8781 8811 8790 8781 8811 8781 8812 8812 8831 8832 8812 8832 8811 8813 8835 8812 8812 8835 8831 8810 8790 8811 8811 8830 8810 8811 8832 8833 8811 8833 8830 8831 8840 8832 8832 8840 8833 8833 8840 8839 8833 8839 8830 8810 8830 8809 8809 8830 8825 8830 8839 8816 8830 8816 8825 8809 8790 8810 8808 8791 8809 8809 8791 8790 8809 8825 8826 8809 8826 8808 8854 8826 8825 8825 8816 8838 8825 8838 8854 8854 8838 8837 8854 8837 8826 8808 8826 8807 8807 8826 8824 8853 8824 8826 8826 8837 8853 8796 8837 8838 8796 8852 8837 8853 8837 8852 8796 8838 8816 8816 8800 8796 8800 8816 8839 8800 8839 8840 8800 8840 8815 8831 8815 8840 8815 8799 8800 8815 8841 8799 8831 8841 8815 8835 8841 8831 8799 8841 8842 8835 8842 8841 8799 8765 8800 8799 8842 8843 8799 8843 8798 8834 8843 8842 8834 8842 8835 8813 8834 8835 8814 8834 8813 8814 8836 8834 8836 8843 8834 8798 8843 8844 8836 8844 8843 8797 8779 8798 8798 8844 8845 8798 8845 8797 8828 8845 8844 8828 8844 8836 8801 8828 8836 8801 8836 8814 8814 8789 8801 8801 8785 8786 8801 8786 8802 8801 8789 8785 8802 8827 8801 8801 8827 8828 8827 8845 8828 8797 8845 8846 8827 8846 8845 8802 8829 8827 8829 8846 8827 8802 8786 8787 8802 8787 8803 8803 8829 8802 8785 8780 8786 8786 8780 8787 8787 8780 8778 8787 8778 8793 8803 8787 8793 8803 8793 8804 8804 8822 8803 8803 8822 8823 8803 8823 8829 8793 8776 8792 8793 8778 8776 8804 8793 8792 8804 8792 8805 8805 8821 8804 8804 8821 8822 8821 8849 8822 8822 8849 8848 8822 8848 8823 8823 8848 8847 8823 8847 8829 8794 8847 8848 8794 8848 8849 8794 8849 8818 8821 8818 8849 8777 8794 8795 8794 8777 8779 8794 8779 8797 8818 8795 8794 8797 8847 8794 8797 8846 8847 8829 8847 8846 8796 8772 8795 8795 8772 8775 8795 8775 8777 8817 8796 8795 8817 8795 8818 8796 8770 8772 8800 8770 8796 8817 8852 8796 8768 8769 8770 8770 8769 8771 8770 8771 8772 8800 8768 8770 8800 8765 8768 8765 8767 8768 8768 8767 8769 8791 8769 8790 8790 8769 8767 8791 8771 8769 8772 8771 8773 8784 8773 8771 8784 8771 8791 8808 8784 8791 8783 8773 8784 8806 8783 8784 8806 8784 8807 8807 8784 8808 8772 8773 8774 8783 8774 8773 8772 8774 8775 8775 8774 8776 8792 8774 8783 8792 8776 8774 8805 8792 8783 8805 8783 8806 8806 8820 8805 8820 8821 8805 8806 8819 8820 8819 8851 8820 8820 8851 8850 8820 8850 8821 8821 8850 8818 8818 8850 8817 8817 8850 8851 8819 8817 8851 8806 8824 8819 8824 8817 8819 8824 8852 8817 8807 8824 8806 8853 8852 8824 8775 8776 8777 8777 8776 8778 8777 8778 8779 8779 8778 8780 8779 8780 8761 8785 8761 8780 8789 8761 8785 8855 8856 8857 8874 8873 8855 8855 8873 8856 8878 8874 8855 8878 8855 8879 8855 8857 8879 8872 8873 8874 8872 8874 8878 8872 8871 8873 8883 8884 8873 8873 8871 8883 8884 8856 8873 8870 8871 8872 8870 8872 8877 8877 8872 8878 8870 8869 8871 8883 8871 8885 8885 8871 8869 8867 8869 8870 8867 8870 8876 8876 8870 8877 8867 8868 8869 8885 8869 8886 8869 8868 8886 8865 8866 8867 8867 8866 8868 8875 8865 8867 8875 8867 8876 8886 8868 8887 8868 8866 8887 8865 8864 8866 8887 8866 8888 8888 8866 8864 8863 8864 8865 8863 8865 8882 8882 8865 8875 8863 8862 8864 8888 8864 8889 8889 8864 8862 8861 8862 8863 8861 8863 8881 8881 8863 8882 8861 8860 8862 8889 8862 8890 8890 8862 8860 8859 8860 8861 8880 8859 8861 8880 8861 8881 8859 8858 8860 8860 8858 8890 8857 8858 8859 8857 8859 8880 8857 8856 8858 8890 8858 8891 8858 8856 8891 8879 8857 8880 8901 8879 8880 8910 8878 8879 8879 8894 8910 8901 8891 8879 8879 8891 8894 8880 9009 8879 9009 9007 8879 8879 9007 8878 9053 8880 8879 9053 8879 9054 9055 8879 8878 9055 9037 8879 8879 9037 9027 8879 9027 9054 9054 9027 9036 9054 9036 9053 9053 9036 9028 9053 9028 8880 9028 9036 9027 9027 9006 9008 9027 9008 9028 9027 9025 9006 9027 9037 9025 9025 9037 9038 9055 9038 9037 8878 9038 9055 9025 9038 9039 9046 9039 9038 9046 9038 8878 9025 9039 9033 9033 9039 9040 9047 9040 9039 9047 9039 9046 9046 8878 9047 9047 8878 8877 8877 9040 9047 8877 9033 9040 8908 8877 8878 8908 8885 8877 8877 8885 8892 8877 8892 8911 8878 9024 8877 8877 9024 9022 8877 9022 8876 8876 8911 8877 8911 9033 8877 8886 8892 8885 8885 8893 8883 8908 8893 8885 8911 8892 8886 8886 8887 8900 8911 8886 8876 8876 8886 8900 8888 8898 8887 8887 8898 8899 8907 8900 8887 8907 8887 8906 8906 8887 8899 8876 8900 8907 8906 8875 8907 8907 8875 8876 8906 8899 8875 8875 8899 8898 8875 8898 8905 8905 8898 8888 8905 8882 8875 8905 8888 8882 8889 8897 8888 8882 8888 8897 8890 8896 8889 8904 8897 8889 8904 8889 8881 8881 8889 8902 8902 8889 8896 8882 8897 8904 8904 8881 8882 8902 8903 8881 8882 9015 8881 9015 9013 8881 8881 9013 9011 8881 9011 8880 8880 8903 8881 9051 8882 8881 9052 8881 8903 9052 9029 8881 8881 9029 9045 8881 9045 9051 9051 9045 9030 9051 9030 8882 9030 9045 9029 9029 9014 9030 9014 9016 9030 9030 9016 9031 9031 9044 9030 8882 9030 9044 9012 9013 9014 9014 9013 9015 9014 9015 9016 9012 9014 9029 9016 9015 9017 9016 9017 9018 9031 9016 9018 9017 9015 8882 9018 9017 9019 8875 9019 9017 8875 9017 8882 9018 9019 9020 9018 9020 9021 9031 9018 9032 9032 9018 9021 9020 9019 8875 9021 9020 9022 9022 9020 8876 8876 9020 8875 9021 9022 9023 9032 9021 9033 9021 9023 9033 9023 9022 9024 9023 9024 9025 9033 9023 9025 9033 9041 9032 8911 9041 9033 8876 9032 9041 8876 9041 8911 9048 8876 8875 9048 9032 8876 9048 8875 9049 9049 9042 9048 9048 9042 9032 9050 8875 8882 9050 9031 8875 8875 9031 9049 9049 9031 9043 9049 9043 9042 9032 9042 9031 9031 9042 9043 9050 9044 9031 8882 9044 9050 9025 9024 9026 9025 9026 9007 9025 9007 9006 8878 9026 9024 8878 9007 9026 9006 9007 9008 9008 9007 9009 9008 9009 9010 9028 9008 9010 9010 9009 9011 9011 9009 8880 9010 9011 9012 9028 9010 9029 9029 9010 9012 9029 9034 9028 9028 9034 9035 8880 9028 9035 9052 9034 9029 8903 9035 9034 8903 9034 9052 8880 9035 8903 8902 8896 8903 8903 8896 8890 8903 8890 8895 8903 8895 8880 8890 8891 8895 8880 8895 8891 8891 8856 8884 8884 8894 8891 8880 8891 8901 8910 8894 8884 8910 8884 8878 8878 8884 8883 8908 8878 8909 8878 8883 8909 8909 8883 8893 8909 8893 8908 9012 9011 9013 8912 8913 8914 8929 8930 8912 8912 8930 8913 8946 8929 8912 8946 8912 8914 8914 8913 8915 8914 8915 8916 8946 8914 8947 8947 8914 8916 8916 8915 8917 8916 8917 8918 8947 8916 8950 8950 8916 8918 8918 8917 8919 8940 8917 8915 8941 8919 8917 8941 8917 8940 8918 8919 8920 8950 8918 8920 8920 8919 8921 8941 8921 8919 8920 8921 8922 8950 8920 8951 8951 8920 8948 8948 8920 8922 8922 8921 8923 8942 8921 8943 8942 8923 8921 8943 8921 8941 8922 8923 8924 8922 8924 8925 8948 8922 8925 8944 8924 8923 8944 8923 8942 8959 8944 8942 8959 8942 8943 8959 8943 8960 8960 8943 8941 8960 8941 8961 8961 8985 8960 8960 8985 8959 8961 8941 8962 8962 8941 8940 8962 8979 8961 8961 8979 8980 8961 8980 8985 8962 8940 8963 8963 8973 8962 8973 8978 8962 8962 8978 8979 8940 8915 8939 8963 8940 8939 8963 8939 8964 8964 8972 8963 8963 8972 8973 8972 8995 8973 8973 8995 8994 8973 8994 8978 8978 8994 8993 8978 8993 8979 8967 8993 8994 8967 8994 8966 8966 8994 8995 8972 8966 8995 8964 8981 8972 8981 8947 8972 8972 8947 8966 8966 8947 8950 8966 8950 8967 8965 8946 8947 8947 8996 8965 8981 8996 8947 8952 8975 8981 8952 8981 8964 8975 8996 8981 8965 8996 8997 8975 8997 8996 8965 8997 8998 8965 8998 8946 8974 8997 8975 8974 8998 8997 8952 8974 8975 8953 8974 8952 8953 8984 8974 8984 8998 8974 8946 8998 8999 8984 8999 8998 8954 8984 8953 8954 8989 8984 8989 9000 8984 8984 9000 8999 8952 8936 8953 8953 8936 8935 8953 8935 8954 8954 8935 8931 8954 8931 8955 8955 8989 8954 8955 8988 8989 8988 9001 8989 8989 9001 9000 8955 8987 8988 8987 8970 8988 8988 8970 9001 8970 9000 9001 8969 8945 8970 8970 8945 8946 8946 9000 8970 8969 8970 9002 8987 9002 8970 8977 8987 8955 8977 9002 8987 8977 8969 9002 8969 8949 8945 8969 9003 8949 8977 9003 8969 8945 8929 8946 8949 8927 8945 8945 8927 8929 8946 8999 9000 8927 8928 8929 8929 8928 8930 8925 8926 8927 8927 8926 8928 8949 8925 8927 8931 8928 8932 8932 8928 8926 8935 8930 8928 8935 8928 8931 8936 8930 8935 8936 8913 8930 8938 8913 8936 8952 8938 8936 8937 8913 8938 8937 8915 8913 8964 8937 8938 8964 8938 8952 8939 8915 8937 8964 8939 8937 8955 8931 8932 8955 8932 8933 8955 8933 8956 8956 8977 8955 8956 8933 8957 8957 8977 8956 8933 8924 8934 8932 8926 8933 8933 8926 8924 8957 8933 8934 8925 8924 8926 8934 8924 8944 8957 8934 8958 8958 8934 8944 8958 8944 8959 8958 8971 8957 8959 8983 8958 8958 8983 8971 8959 8982 8983 8959 8985 8986 8959 8986 8982 8982 8990 8983 8983 8990 9005 8983 9005 8971 8986 8991 8982 8982 8991 8990 8985 8968 8986 8986 8968 8991 8980 8992 8985 8985 8992 8968 8979 8993 8980 8980 8993 8967 8980 8967 8992 8968 8992 8967 8967 8950 8968 8968 8950 8951 8968 8951 8948 8948 8991 8968 8948 8990 8991 8948 8925 8949 8949 9004 8948 8948 9004 9005 8948 9005 8990 8949 9003 9004 8971 9005 9004 8971 9004 8976 8976 9004 9003 8976 9003 8977 8971 8976 8957 8957 8976 8977 9056 9057 9058 9078 9079 9056 9056 9079 9057 9101 9078 9056 9101 9056 9102 9102 9056 9058 9058 9057 9059 9058 9059 9060 9102 9058 9060 9102 9060 9103 9130 9101 9102 9130 9102 9103 9060 9059 9061 9060 9061 9062 9103 9060 9062 9096 9061 9059 9096 9059 9097 9097 9059 9057 9095 9061 9096 9123 9095 9096 9123 9096 9112 9112 9096 9097 9097 9057 9098 9112 9097 9098 9098 9057 9079 9098 9079 9099 9112 9098 9113 9113 9098 9099 9113 9134 9112 9112 9134 9135 9112 9135 9123 9113 9099 9114 9114 9133 9113 9113 9133 9134 9133 9145 9134 9134 9145 9146 9134 9146 9135 9123 9135 9136 9146 9136 9135 9145 9130 9146 9146 9130 9132 9146 9132 9147 9146 9137 9136 9147 9137 9146 9123 9136 9122 9122 9136 9121 9121 9136 9137 9121 9137 9120 9120 9137 9119 9119 9137 9138 9147 9138 9137 9120 9094 9121 9121 9094 9095 9121 9095 9122 9122 9095 9123 9094 9064 9095 9095 9064 9061 9063 9061 9064 9063 9064 9065 9065 9064 9066 9094 9066 9064 9062 9061 9063 9104 9062 9063 9104 9063 9065 9065 9066 9067 9104 9065 9105 9105 9065 9067 9067 9066 9068 9094 9068 9066 9067 9068 9080 9105 9067 9080 9105 9080 9106 9132 9105 9106 9132 9104 9105 9080 9068 9081 9080 9081 9082 9106 9080 9107 9107 9080 9082 9093 9081 9068 9093 9068 9094 9092 9081 9093 9127 9092 9093 9127 9093 9128 9128 9093 9119 9119 9093 9094 9119 9094 9120 9119 9138 9128 9128 9138 9139 9128 9139 9127 9126 9092 9127 9127 9139 9140 9127 9140 9126 9147 9140 9139 9139 9138 9147 9126 9140 9125 9125 9140 9141 9141 9140 9148 9148 9140 9147 9125 9091 9126 9126 9091 9092 9124 9091 9125 9125 9141 9124 9124 9141 9142 9148 9142 9141 9118 9090 9124 9124 9090 9091 9124 9142 9118 9090 9086 9091 9091 9086 9084 9091 9084 9092 9092 9084 9081 9083 9081 9084 9083 9084 9085 9085 9084 9086 9085 9086 9069 9069 9086 9070 9090 9070 9086 9089 9070 9090 9089 9090 9118 9069 9070 9071 9071 9070 9072 9089 9072 9070 9108 9085 9069 9108 9069 9109 9109 9069 9071 9108 9083 9085 9107 9083 9108 9109 9131 9108 9131 9107 9108 9109 9071 9110 9110 9131 9109 9071 9072 9073 9110 9071 9073 9110 9073 9111 9111 9129 9110 9110 9129 9131 9073 9072 9074 9111 9073 9074 9111 9074 9100 9129 9111 9100 9074 9072 9075 9074 9075 9076 9100 9074 9076 9100 9076 9101 9129 9100 9101 9076 9075 9077 9076 9077 9078 9101 9076 9078 9087 9075 9072 9099 9077 9075 9099 9075 9087 9078 9077 9079 9099 9079 9077 9114 9099 9115 9115 9099 9087 9087 9072 9088 9115 9087 9116 9116 9087 9088 9088 9072 9089 9116 9088 9117 9117 9088 9089 9117 9143 9116 9116 9143 9144 9116 9144 9115 9115 9133 9114 9115 9144 9133 9144 9145 9133 9145 9144 9143 9117 9142 9143 9145 9143 9148 9148 9143 9142 9117 9089 9118 9118 9142 9117 9147 9131 9148 9148 9131 9129 9148 9129 9145 9145 9129 9130 9129 9101 9130 9130 9104 9132 9103 9104 9130 9103 9062 9104 9131 9132 9107 9132 9106 9107 9147 9132 9131 9107 9082 9083 9082 9081 9083 9149 9150 9151 9170 9171 9149 9149 9171 9150 9193 9170 9149 9193 9149 9194 9194 9149 9151 9151 9150 9152 9189 9152 9150 9189 9150 9171 9151 9152 9153 9194 9151 9153 9194 9153 9195 9195 9221 9194 9221 9193 9194 9153 9152 9154 9153 9154 9155 9195 9153 9155 9188 9154 9152 9188 9152 9189 9155 9154 9156 9187 9156 9154 9187 9154 9188 9155 9156 9157 9195 9155 9196 9196 9155 9157 9221 9195 9196 9196 9157 9197 9221 9196 9222 9222 9196 9197 9157 9156 9158 9157 9158 9159 9197 9157 9159 9187 9158 9156 9159 9158 9160 9186 9160 9158 9186 9158 9187 9159 9160 9172 9197 9159 9172 9197 9172 9198 9222 9197 9198 9172 9160 9173 9172 9173 9174 9198 9172 9174 9185 9173 9160 9185 9160 9186 9204 9186 9205 9205 9186 9187 9204 9185 9186 9184 9173 9185 9204 9184 9185 9214 9184 9204 9205 9229 9204 9204 9229 9214 9183 9173 9184 9213 9183 9184 9213 9184 9214 9214 9229 9230 9214 9230 9213 9205 9228 9229 9238 9229 9228 9238 9230 9229 9213 9230 9231 9238 9231 9230 9212 9183 9213 9213 9231 9212 9212 9231 9232 9239 9231 9238 9231 9239 9232 9211 9182 9212 9212 9182 9183 9212 9232 9211 9211 9232 9233 9239 9233 9232 9210 9181 9211 9211 9181 9182 9211 9233 9210 9181 9178 9182 9182 9178 9175 9182 9175 9183 9180 9164 9181 9181 9164 9162 9181 9162 9178 9210 9180 9181 9219 9180 9210 9210 9233 9219 9179 9164 9180 9219 9179 9180 9163 9162 9164 9163 9164 9165 9165 9164 9166 9179 9166 9164 9161 9162 9163 9161 9178 9162 9201 9161 9163 9201 9163 9202 9202 9163 9203 9203 9163 9165 9165 9166 9167 9203 9165 9167 9167 9166 9168 9179 9168 9166 9167 9168 9169 9192 9167 9169 9203 9167 9192 9223 9202 9203 9223 9203 9192 9220 9202 9223 9220 9201 9202 9223 9193 9221 9223 9192 9193 9236 9223 9221 9239 9220 9223 9239 9223 9236 9192 9169 9170 9192 9170 9193 9169 9168 9170 9170 9168 9171 9189 9171 9190 9190 9171 9191 9191 9171 9168 9209 9188 9189 9209 9189 9190 9209 9190 9215 9215 9190 9191 9208 9188 9209 9215 9225 9209 9209 9225 9226 9209 9226 9208 9207 9187 9188 9207 9188 9208 9208 9226 9207 9207 9226 9227 9225 9237 9226 9237 9227 9226 9215 9224 9225 9224 9236 9225 9225 9236 9237 9217 9224 9216 9216 9224 9215 9217 9235 9224 9224 9235 9236 9236 9221 9237 9236 9235 9234 9236 9234 9239 9218 9234 9235 9218 9235 9217 9219 9233 9234 9219 9234 9218 9239 9234 9233 9238 9220 9239 9237 9222 9238 9238 9222 9220 9238 9228 9237 9200 9201 9220 9220 9222 9199 9220 9199 9200 9222 9198 9199 9237 9221 9222 9237 9228 9227 9205 9227 9228 9207 9227 9206 9206 9227 9205 9205 9187 9206 9206 9187 9207 9198 9174 9199 9199 9174 9176 9199 9176 9200 9174 9173 9175 9174 9175 9176 9176 9175 9177 9200 9176 9177 9177 9175 9178 9183 9175 9173 9177 9178 9161 9200 9177 9161 9200 9161 9201 9217 9179 9218 9218 9179 9219 9216 9191 9217 9217 9191 9179 9191 9168 9179 9215 9191 9216 9240 9241 9242 9290 9289 9240 9240 9289 9241 9290 9240 9287 9287 9240 9283 9243 9240 9242 9240 9295 9283 9295 9240 9297 9297 9240 9243 9241 9289 9242 9288 9289 9290 9242 9289 9285 9285 9289 9288 9288 9290 9287 9287 9286 9288 9286 9285 9288 9285 9286 9287 9285 9287 9283 9283 9284 9285 9284 9292 9285 9285 9292 9302 9285 9302 9242 9283 9282 9284 9284 9282 9281 9281 9292 9284 9281 9282 9283 9280 9281 9283 9281 9280 9277 9276 9292 9281 9276 9281 9277 9283 9294 9280 9283 9295 9294 9317 9294 9295 9318 9295 9297 9295 9318 9339 9295 9339 9340 9295 9340 9317 9316 9294 9317 9317 9340 9341 9317 9341 9316 9340 9380 9381 9340 9339 9380 9341 9340 9381 9316 9341 9342 9342 9341 9382 9341 9381 9382 9316 9342 9294 9294 9342 9315 9315 9342 9343 9343 9342 9382 9344 9382 9383 9382 9344 9343 9381 9410 9382 9382 9410 9383 9315 9343 9314 9314 9343 9344 9314 9294 9315 9314 9296 9294 9314 9344 9345 9314 9345 9296 9345 9344 9383 9296 9345 9346 9346 9345 9383 9296 9346 9313 9346 9347 9313 9346 9383 9384 9347 9346 9384 9313 9293 9296 9313 9347 9293 9293 9347 9312 9312 9347 9348 9348 9347 9384 9348 9384 9385 9383 9391 9384 9384 9391 9385 9312 9348 9311 9311 9348 9349 9349 9348 9385 9311 9293 9312 9311 9299 9293 9311 9349 9299 9299 9349 9350 9349 9385 9386 9350 9349 9386 9299 9350 9310 9310 9350 9309 9309 9350 9351 9351 9350 9386 9351 9386 9388 9385 9411 9386 9386 9411 9388 9309 9351 9298 9298 9351 9352 9388 9352 9351 9309 9298 9299 9309 9299 9310 9298 9260 9299 9300 9254 9298 9298 9254 9260 9322 9300 9298 9352 9322 9298 9322 9352 9353 9387 9352 9388 9353 9352 9387 9322 9353 9300 9300 9353 9354 9354 9353 9389 9389 9353 9387 9388 9393 9387 9389 9387 9393 9355 9354 9389 9355 9389 9378 9389 9393 9376 9389 9376 9378 9300 9354 9321 9321 9354 9355 9321 9355 9320 9320 9355 9297 9297 9355 9356 9356 9355 9378 9320 9300 9321 9320 9297 9300 9247 9297 9243 9297 9247 9300 9318 9297 9319 9297 9356 9319 9319 9356 9357 9357 9356 9378 9339 9318 9319 9319 9357 9339 9357 9378 9379 9357 9379 9339 9339 9379 9380 9379 9378 9377 9380 9379 9390 9377 9412 9379 9379 9412 9390 9376 9377 9378 9412 9377 9419 9377 9376 9419 9393 9421 9376 9376 9442 9443 9419 9376 9444 9442 9376 9421 9376 9443 9444 9445 9419 9444 9412 9419 9445 9506 9445 9444 9506 9444 9507 9507 9444 9508 9508 9444 9443 9508 9443 9509 9509 9443 9510 9510 9443 9442 9507 9508 9509 9510 9511 9509 9509 9511 9507 9510 9442 9511 9421 9441 9442 9511 9442 9441 9511 9441 9512 9512 9514 9511 9507 9511 9582 9582 9511 9587 9511 9514 9587 9441 9421 9440 9512 9441 9513 9513 9441 9440 9514 9512 9513 9513 9440 9514 9421 9439 9440 9514 9440 9439 9421 9393 9439 9393 9438 9439 9514 9439 9515 9515 9439 9516 9516 9439 9438 9388 9420 9393 9393 9420 9438 9438 9420 9437 9516 9438 9517 9517 9438 9437 9573 9574 9516 9573 9516 9517 9516 9574 9515 9515 9574 9514 9587 9514 9574 9633 9582 9587 9633 9587 9634 9634 9587 9635 9636 9587 9617 9617 9587 9574 9635 9587 9699 9699 9587 9700 9700 9587 9636 9698 9633 9634 9698 9634 9635 9698 9635 9699 9700 9642 9699 9699 9642 9643 9699 9643 9698 9700 9636 9616 9616 9577 9700 9700 9577 9642 9616 9636 9617 9616 9617 9574 9616 9574 9701 9701 9640 9616 9616 9640 9641 9641 9577 9616 9618 9619 9574 9618 9574 9573 9701 9574 9619 9701 9619 9640 9640 9578 9641 9578 9640 9619 9641 9578 9577 9577 9578 9554 9554 9578 9553 9553 9578 9552 9594 9552 9578 9669 9594 9578 9669 9578 9670 9702 9670 9578 9702 9578 9619 9619 9618 9702 9702 9618 9600 9702 9600 9703 9703 9670 9702 9703 9669 9670 9599 9594 9669 9599 9669 9703 9703 9600 9599 9599 9600 9573 9618 9573 9600 9599 9573 9704 9704 9594 9599 9704 9573 9620 9704 9620 9705 9705 9668 9704 9704 9668 9594 9620 9573 9602 9637 9620 9602 9705 9620 9637 9601 9602 9603 9602 9573 9575 9602 9575 9603 9601 9637 9602 9705 9637 9601 9601 9603 9706 9706 9666 9601 9601 9666 9672 9601 9672 9705 9706 9603 9604 9604 9603 9575 9604 9591 9706 9706 9591 9666 9666 9591 9667 9667 9672 9666 9705 9672 9667 9667 9591 9594 9667 9594 9668 9705 9667 9668 9591 9549 9594 9552 9594 9549 9551 9469 9552 9552 9469 9553 9550 9552 9549 9552 9550 9551 9550 9469 9551 9549 9481 9550 9550 9481 9469 9468 9469 9408 9408 9469 9416 9469 9481 9416 9553 9469 9468 9553 9468 9471 9554 9553 9471 9408 9471 9468 9470 9471 9408 9554 9471 9555 9555 9471 9470 9577 9554 9555 9555 9470 9556 9577 9555 9556 9472 9470 9415 9408 9415 9470 9556 9470 9557 9557 9470 9472 9577 9556 9557 9558 9577 9557 9558 9579 9577 9642 9577 9579 9557 9472 9558 9415 9474 9472 9558 9472 9559 9559 9472 9474 9559 9579 9558 9474 9572 9559 9572 9579 9559 9473 9474 9415 9473 9572 9474 9473 9571 9572 9571 9579 9572 9473 9415 9414 9473 9414 9452 9452 9569 9473 9473 9569 9570 9473 9570 9571 9571 9568 9579 9568 9571 9570 9568 9570 9569 9452 9568 9569 9414 9451 9452 9451 9567 9452 9452 9567 9568 9567 9566 9568 9579 9568 9596 9596 9568 9593 9593 9568 9566 9451 9566 9567 9451 9414 9454 9454 9565 9451 9451 9565 9566 9564 9566 9565 9564 9562 9566 9593 9566 9562 9454 9564 9565 9397 9453 9454 9397 9454 9414 9453 9564 9454 9453 9563 9564 9563 9562 9564 9456 9453 9397 9456 9562 9453 9453 9562 9563 9455 9456 9395 9397 9395 9456 9455 9561 9456 9456 9561 9562 9475 9455 9395 9475 9560 9455 9455 9560 9561 9561 9560 9562 9475 9527 9560 9560 9527 9562 9395 9458 9475 9475 9458 9527 9527 9458 9528 9580 9527 9528 9562 9527 9592 9592 9527 9580 9457 9458 9395 9528 9458 9529 9458 9457 9529 9580 9528 9529 9529 9457 9530 9530 9531 9529 9529 9531 9580 9457 9395 9394 9394 9459 9457 9457 9459 9476 9530 9457 9476 9530 9476 9531 9477 9476 9459 9531 9476 9532 9532 9476 9477 9459 9394 9407 9477 9459 9407 9394 9395 9396 9394 9396 9398 9398 9407 9394 9398 9396 9359 9395 9372 9396 9396 9372 9358 9359 9396 9358 9398 9359 9363 9363 9362 9398 9407 9398 9399 9399 9398 9362 9358 9327 9359 9327 9328 9359 9328 9363 9359 9326 9327 9358 9326 9358 9372 9326 9292 9327 9327 9292 9305 9327 9305 9328 9305 9363 9328 9305 9362 9363 9305 9276 9306 9305 9292 9276 9329 9305 9306 9329 9362 9305 9275 9274 9276 9275 9276 9277 9270 9276 9274 9306 9276 9270 9273 9274 9275 9275 9277 9278 9273 9275 9278 9274 9273 9272 9270 9274 9272 9271 9270 9272 9271 9272 9273 9278 9280 9273 9296 9271 9273 9296 9273 9294 9294 9273 9280 9278 9277 9279 9278 9279 9280 9279 9277 9280 9293 9271 9296 9268 9270 9271 9268 9271 9267 9267 9271 9293 9299 9267 9293 9299 9260 9263 9299 9263 9267 9263 9264 9265 9262 9263 9260 9265 9267 9263 9263 9262 9291 9263 9291 9264 9265 9264 9266 9266 9267 9265 9266 9264 9267 9264 9269 9267 9264 9291 9261 9264 9261 9259 9259 9253 9264 9301 9269 9264 9301 9264 9303 9303 9264 9307 9307 9264 9253 9262 9261 9291 9260 9261 9262 9260 9259 9261 9258 9259 9260 9254 9255 9260 9260 9255 9258 9255 9257 9258 9258 9257 9259 9254 9253 9255 9255 9253 9256 9255 9256 9257 9252 9253 9254 9247 9251 9254 9251 9252 9254 9300 9247 9254 9251 9250 9252 9250 9246 9252 9252 9246 9253 9249 9250 9251 9247 9249 9251 9249 9248 9250 9246 9250 9248 9247 9248 9249 9247 9246 9248 9245 9246 9247 9245 9247 9243 9243 9244 9245 9244 9242 9245 9245 9242 9246 9243 9242 9244 9302 9246 9242 9308 9246 9302 9308 9302 9324 9325 9302 9292 9325 9373 9302 9302 9373 9374 9302 9374 9324 9324 9374 9375 9324 9375 9308 9373 9406 9374 9374 9406 9375 9292 9372 9373 9292 9373 9325 9373 9372 9406 9326 9372 9292 9395 9397 9372 9406 9372 9397 9409 9375 9406 9409 9406 9397 9308 9375 9371 9409 9371 9375 9409 9404 9371 9409 9397 9414 9409 9414 9404 9370 9323 9371 9371 9323 9308 9371 9404 9370 9304 9246 9308 9304 9308 9323 9370 9304 9323 9369 9304 9370 9404 9369 9370 9337 9336 9369 9369 9336 9304 9404 9405 9369 9337 9369 9403 9403 9369 9405 9336 9337 9335 9368 9335 9337 9337 9403 9368 9335 9304 9336 9334 9307 9335 9335 9307 9304 9368 9334 9335 9367 9334 9368 9367 9368 9403 9367 9307 9334 9307 9253 9304 9333 9303 9307 9367 9333 9307 9366 9333 9367 9403 9402 9367 9366 9367 9402 9366 9303 9333 9332 9301 9303 9332 9303 9365 9365 9303 9366 9402 9365 9366 9401 9365 9402 9403 9416 9402 9416 9401 9402 9364 9332 9365 9365 9400 9364 9400 9365 9401 9364 9301 9332 9338 9301 9364 9400 9338 9364 9400 9399 9338 9399 9400 9413 9464 9413 9400 9464 9400 9401 9338 9331 9301 9331 9338 9360 9360 9338 9399 9399 9361 9360 9399 9362 9361 9399 9413 9407 9331 9360 9330 9330 9360 9361 9330 9301 9331 9330 9306 9301 9330 9361 9306 9306 9361 9329 9329 9361 9362 9306 9270 9301 9301 9270 9269 9268 9269 9270 9269 9268 9267 9460 9461 9407 9460 9407 9413 9477 9407 9478 9461 9478 9407 9464 9463 9413 9463 9460 9413 9462 9463 9464 9465 9466 9464 9465 9464 9401 9466 9462 9464 9539 9460 9463 9462 9539 9463 9466 9544 9462 9462 9544 9539 9465 9542 9466 9466 9542 9543 9466 9543 9544 9538 9539 9544 9538 9544 9542 9542 9544 9543 9538 9460 9539 9537 9461 9460 9537 9460 9538 9536 9461 9537 9537 9538 9536 9536 9538 9534 9538 9595 9534 9595 9538 9598 9598 9538 9542 9535 9461 9536 9534 9535 9536 9535 9478 9461 9534 9478 9535 9533 9477 9478 9533 9478 9534 9532 9477 9533 9533 9534 9532 9532 9534 9531 9531 9534 9597 9580 9531 9597 9597 9534 9595 9654 9580 9597 9654 9597 9655 9655 9597 9656 9597 9595 9657 9686 9656 9597 9686 9597 9685 9685 9597 9657 9654 9655 9674 9608 9674 9655 9608 9655 9656 9608 9656 9686 9685 9606 9686 9686 9606 9608 9606 9607 9608 9608 9607 9626 9608 9626 9687 9687 9674 9608 9688 9654 9674 9688 9674 9687 9626 9627 9687 9687 9627 9688 9607 9585 9626 9626 9585 9627 9606 9588 9607 9607 9588 9585 9685 9588 9606 9576 9489 9588 9493 9588 9489 9588 9493 9585 9685 9576 9588 9684 9576 9685 9685 9657 9658 9685 9658 9684 9683 9576 9684 9684 9658 9676 9684 9676 9683 9657 9595 9658 9595 9676 9658 9683 9676 9595 9659 9595 9598 9683 9595 9659 9659 9598 9660 9683 9659 9682 9682 9659 9660 9660 9598 9661 9682 9660 9681 9681 9660 9661 9681 9584 9682 9682 9584 9683 9680 9623 9681 9681 9623 9584 9681 9661 9680 9661 9598 9680 9679 9622 9680 9680 9622 9623 9680 9598 9679 9622 9584 9623 9622 9581 9584 9679 9581 9622 9678 9581 9679 9679 9598 9662 9679 9662 9678 9708 9638 9678 9678 9638 9581 9678 9662 9663 9678 9663 9708 9662 9598 9663 9663 9598 9590 9708 9663 9590 9598 9542 9590 9590 9542 9545 9590 9545 9591 9664 9590 9591 9590 9664 9673 9708 9590 9673 9465 9541 9542 9545 9542 9541 9467 9479 9465 9467 9465 9401 9479 9541 9465 9479 9540 9541 9540 9545 9541 9540 9479 9545 9545 9479 9467 9467 9401 9416 9480 9467 9416 9545 9467 9546 9546 9467 9480 9408 9416 9403 9416 9481 9480 9546 9480 9547 9547 9480 9548 9480 9481 9548 9545 9546 9547 9548 9549 9547 9547 9549 9545 9548 9481 9549 9591 9545 9549 9664 9591 9665 9604 9665 9591 9707 9673 9664 9707 9664 9604 9604 9664 9665 9604 9575 9605 9604 9605 9707 9707 9605 9708 9708 9673 9707 9605 9575 9581 9605 9581 9621 9708 9605 9621 9708 9621 9638 9638 9621 9581 9581 9526 9486 9581 9486 9584 9581 9575 9526 9584 9486 9576 9584 9576 9624 9683 9584 9624 9624 9576 9625 9683 9624 9625 9487 9576 9486 9576 9487 9488 9488 9489 9576 9683 9625 9576 9486 9428 9487 9487 9428 9488 9488 9428 9449 9488 9449 9489 9449 9448 9489 9489 9448 9490 9490 9493 9489 9448 9449 9410 9449 9428 9417 9449 9417 9410 9417 9428 9429 9486 9429 9428 9391 9383 9417 9410 9417 9383 9417 9429 9450 9391 9417 9450 9410 9381 9427 9410 9427 9448 9380 9390 9381 9381 9390 9418 9381 9418 9426 9381 9426 9427 9390 9412 9422 9390 9422 9425 9418 9390 9425 9424 9418 9425 9424 9426 9418 9427 9426 9493 9493 9426 9494 9494 9426 9424 9494 9424 9495 9495 9424 9496 9496 9424 9425 9495 9493 9494 9492 9427 9493 9491 9493 9490 9492 9493 9491 9585 9493 9495 9497 9495 9496 9585 9495 9497 9496 9425 9497 9425 9422 9447 9497 9425 9498 9498 9425 9447 9422 9412 9423 9447 9422 9500 9500 9422 9501 9501 9422 9423 9498 9447 9499 9499 9447 9500 9499 9497 9498 9500 9497 9499 9500 9501 9497 9501 9423 9502 9501 9502 9503 9501 9503 9505 9497 9501 9586 9501 9589 9586 9501 9505 9589 9502 9423 9503 9503 9423 9446 9503 9446 9504 9505 9503 9504 9412 9445 9446 9446 9423 9412 9504 9446 9505 9505 9446 9445 9505 9445 9506 9506 9507 9505 9507 9582 9583 9583 9505 9507 9614 9583 9582 9632 9582 9633 9696 9614 9582 9696 9582 9632 9614 9615 9583 9615 9614 9695 9695 9614 9696 9694 9639 9615 9615 9639 9583 9695 9671 9615 9615 9671 9646 9615 9646 9694 9696 9596 9695 9695 9596 9671 9646 9671 9596 9596 9593 9646 9694 9646 9593 9693 9631 9694 9694 9631 9639 9694 9593 9693 9639 9631 9583 9589 9583 9631 9693 9589 9631 9692 9589 9693 9693 9593 9647 9693 9647 9692 9589 9505 9583 9613 9586 9589 9611 9613 9589 9611 9589 9692 9612 9611 9692 9692 9647 9648 9692 9648 9612 9647 9593 9648 9648 9593 9592 9648 9592 9649 9612 9648 9649 9562 9592 9593 9649 9592 9650 9651 9592 9652 9652 9592 9580 9691 9650 9592 9691 9592 9610 9610 9592 9651 9612 9649 9650 9612 9650 9691 9610 9609 9691 9691 9609 9613 9691 9613 9612 9609 9610 9586 9609 9586 9613 9611 9612 9613 9585 9497 9586 9629 9585 9586 9629 9586 9630 9610 9630 9586 9627 9585 9628 9689 9628 9585 9689 9585 9629 9689 9629 9630 9689 9630 9690 9690 9630 9610 9610 9652 9690 9690 9652 9653 9690 9653 9689 9610 9651 9652 9652 9580 9653 9580 9677 9653 9689 9653 9677 9689 9677 9580 9689 9580 9688 9688 9580 9654 9688 9628 9689 9688 9627 9628 9645 9579 9596 9696 9645 9596 9644 9579 9645 9645 9675 9644 9696 9675 9645 9642 9579 9643 9698 9643 9579 9698 9579 9644 9698 9644 9697 9697 9644 9675 9697 9675 9696 9696 9632 9633 9696 9633 9697 9697 9633 9698 9490 9448 9491 9491 9448 9427 9491 9427 9492 9391 9450 9430 9483 9430 9450 9483 9450 9484 9484 9450 9485 9450 9429 9485 9385 9391 9392 9392 9391 9430 9385 9392 9411 9392 9430 9431 9392 9431 9432 9392 9432 9433 9411 9392 9433 9411 9433 9434 9388 9411 9420 9420 9411 9435 9435 9411 9434 9523 9434 9433 9523 9433 9524 9524 9433 9432 9524 9432 9525 9525 9432 9431 9575 9523 9524 9525 9575 9524 9522 9434 9523 9521 9523 9575 9521 9522 9523 9575 9525 9526 9521 9575 9573 9525 9431 9526 9526 9431 9482 9483 9526 9482 9483 9486 9526 9482 9431 9430 9482 9430 9483 9484 9486 9483 9485 9429 9486 9486 9484 9485 9573 9517 9518 9519 9573 9518 9519 9521 9573 9517 9437 9518 9518 9437 9436 9518 9436 9519 9519 9436 9435 9519 9435 9520 9520 9521 9519 9520 9435 9521 9521 9435 9434 9521 9434 9522 9420 9435 9436 9420 9436 9437 9403 9405 9408 9404 9415 9405 9405 9415 9408 9404 9414 9415 9304 9253 9246 9256 9253 9259 9257 9256 9259 9709 9710 9711 9954 9977 9709 9709 9711 9954 9977 9978 9709 9710 9709 9979 9709 9978 9979 9711 9755 9954 9954 9755 9958 9954 9958 9959 9959 9977 9954 9754 9755 9756 9758 9756 9755 9711 9758 9755 9755 9754 9958 9959 9958 9960 9958 9754 9964 9958 9964 9960 9959 9960 9961 9961 9977 9959 9961 9960 9962 9960 9964 9858 9960 9858 9962 9858 9964 9754 9856 9857 9858 9855 9858 9849 9856 9858 9855 9858 9754 9849 9857 9962 9858 9857 9856 9859 9856 9855 9965 9965 9859 9856 9848 9855 9849 9966 9965 9855 9966 9855 9848 9848 9849 9850 9848 9850 9966 9850 9849 9851 9972 9851 9849 9972 9849 9754 9850 9851 9852 9882 9966 9850 9852 9882 9850 9877 9966 9882 9877 9965 9966 9876 9875 9877 9876 9877 9881 9881 9877 9882 9877 9875 9965 9874 9875 9876 9881 9948 9876 9876 9948 9949 9876 9949 9874 9881 9882 9883 9883 9947 9881 9881 9947 9948 9948 9912 9949 9948 9920 9912 9920 9948 9947 9874 9949 9938 9949 9912 9938 9894 9875 9874 9874 9938 9894 9894 9938 9939 9912 9907 9938 9907 9939 9938 9893 9895 9894 9894 9895 9875 9894 9939 9893 9892 9891 9893 9893 9891 9895 9893 9939 9940 9893 9940 9892 9890 9891 9892 9892 9940 9890 9890 9940 9941 9940 9903 9941 9940 9939 9904 9940 9904 9903 9896 9891 9890 9890 9941 9896 9887 9897 9896 9896 9897 9891 9896 9941 9887 9887 9888 9889 9889 9897 9887 9887 9941 9942 9887 9942 9888 9878 9889 9888 9888 9942 9943 9888 9943 9878 9930 9942 9899 9899 9942 9941 9930 9931 9942 9942 9931 9943 9878 9943 9944 9943 9935 9944 9943 9931 9935 9930 9775 9931 9931 9775 9777 9932 9935 9931 9777 9932 9931 9773 9774 9775 9775 9774 9776 9775 9776 9777 9930 9773 9775 9777 9776 9778 9777 9778 9779 9932 9777 9779 9932 9779 9933 9934 9935 9932 9933 9934 9932 9779 9778 9780 9779 9780 9781 9933 9779 9781 9933 9781 9934 9934 9781 9783 9934 9783 9935 9781 9780 9782 9781 9782 9783 9836 9780 9778 9780 9836 9782 9783 9782 9784 9782 9836 9838 9838 9784 9782 9783 9784 9785 9935 9783 9785 9785 9784 9786 9838 9786 9784 9785 9786 9787 9935 9785 9936 9936 9785 9787 9787 9786 9788 9843 9788 9786 9843 9786 9838 9787 9788 9789 9936 9787 9937 9937 9787 9789 9936 9937 9935 9937 9789 9927 9937 9927 9935 9789 9788 9790 9789 9790 9791 9927 9789 9791 9843 9790 9788 9791 9790 9792 9842 9792 9790 9842 9790 9843 9791 9792 9793 9927 9791 9928 9928 9791 9793 9793 9792 9794 9832 9794 9792 9841 9832 9792 9841 9792 9842 9969 9842 9843 9969 9841 9842 9839 9840 9841 9841 9840 9832 9969 9839 9841 9840 9794 9832 9839 9845 9840 9840 9768 9772 9768 9840 9956 9845 9956 9840 9840 9772 9794 9844 9845 9839 9844 9839 9885 9885 9839 9969 9846 9847 9844 9844 9847 9845 9844 9885 9846 9853 9854 9846 9846 9854 9847 9846 9885 9882 9846 9882 9853 9847 9971 9963 9847 9963 9845 9971 9847 9854 9971 9757 9963 9756 9971 9854 9756 9757 9971 9845 9963 9957 9957 9963 9951 9951 9963 9953 9757 9953 9963 9956 9845 9957 9950 9956 9957 9950 9957 9951 9950 9951 9952 9952 9951 9953 9952 9953 9712 9712 9953 9758 9757 9758 9953 9757 9756 9758 9712 9758 9711 9711 9710 9712 9712 9710 9713 9712 9713 9952 9713 9973 9952 9952 9973 9950 9713 9710 9980 9980 9973 9713 9710 9979 9980 9981 9973 9980 9980 9979 9983 9980 9983 9981 9950 9973 9974 9981 9982 9973 9973 9982 9974 9981 9923 9982 9981 9983 9921 9981 9921 9923 9979 9978 9983 9983 9918 9921 9983 9978 9918 9920 9921 9918 9922 9923 9921 9921 9920 9922 9924 9923 9922 9982 9923 9924 9982 9924 9925 9974 9982 9925 9925 9924 9926 9924 9922 9926 9920 9947 9922 9922 9947 9946 9927 9922 9946 9926 9922 9927 9919 9920 9918 9919 9912 9920 9919 9918 9912 9918 9913 9912 9977 9913 9918 9977 9918 9978 9961 9976 9977 9975 9977 9976 9977 9975 9913 9961 9962 9736 9736 9976 9961 9736 9975 9976 9739 9975 9736 9831 9975 9739 9913 9975 9831 9736 9738 9739 9739 9738 9730 9739 9730 9831 9829 9830 9831 9730 9746 9831 9831 9746 9829 9831 9830 9913 9829 9828 9830 9913 9830 9914 9914 9830 9828 9912 9913 9914 9914 9828 9915 9915 9912 9914 9827 9826 9828 9827 9828 9829 9915 9828 9826 9915 9826 9916 9915 9916 9912 9911 9907 9912 9911 9912 9916 9916 9826 9824 9916 9824 9917 9917 9911 9916 9825 9824 9826 9825 9826 9827 9823 9822 9824 9823 9824 9825 9917 9824 9822 9917 9822 9911 9821 9820 9822 9821 9822 9823 9911 9822 9820 9823 9825 9860 9860 9861 9823 9823 9861 9821 9860 9825 9827 9860 9827 9859 9861 9860 9965 9965 9860 9859 9821 9861 9862 9965 9875 9861 9862 9861 9875 9875 9895 9862 9891 9967 9895 9866 9868 9895 9895 9868 9862 9967 9866 9895 9891 9968 9967 9897 9968 9891 9869 9867 9967 9867 9866 9967 9967 9968 9869 9865 9809 9866 9865 9866 9867 9809 9868 9866 9865 9867 9803 9803 9867 9869 9870 9805 9869 9869 9805 9803 9968 9870 9869 9802 9803 9804 9804 9803 9805 9810 9865 9803 9810 9803 9802 9865 9810 9809 9809 9810 9811 9904 9810 9802 9811 9810 9906 9906 9810 9904 9904 9802 9905 9905 9802 9804 9804 9805 9806 9806 9903 9804 9905 9804 9903 9905 9903 9904 9939 9908 9904 9906 9904 9908 9811 9906 9908 9811 9908 9907 9908 9939 9907 9907 9813 9811 9813 9907 9909 9909 9907 9911 9909 9816 9813 9816 9909 9818 9818 9909 9910 9909 9911 9910 9818 9910 9911 9911 9820 9818 9817 9816 9818 9817 9818 9819 9819 9818 9820 9815 9813 9816 9815 9816 9817 9819 9862 9817 9817 9862 9863 9817 9863 9815 9819 9820 9821 9821 9862 9819 9862 9868 9864 9862 9864 9863 9815 9863 9864 9814 9813 9815 9815 9864 9814 9814 9864 9812 9864 9868 9812 9812 9868 9809 9809 9811 9812 9812 9811 9813 9812 9813 9814 9806 9902 9903 9903 9901 9941 9902 9901 9903 9901 9902 9806 9806 9805 9807 9806 9807 9796 9796 9901 9806 9900 9901 9796 9941 9901 9899 9900 9899 9901 9796 9797 9798 9796 9807 9808 9796 9808 9797 9798 9900 9796 9899 9900 9798 9800 9898 9899 9800 9899 9798 9898 9930 9899 9798 9797 9799 9798 9799 9800 9800 9799 9801 9800 9773 9898 9800 9801 9773 9773 9930 9898 9773 9801 9774 9834 9774 9801 9799 9873 9801 9801 9873 9834 9797 9873 9799 9797 9872 9873 9873 9872 9897 9897 9834 9873 9833 9774 9834 9897 9889 9834 9889 9833 9834 9774 9833 9776 9776 9833 9835 9889 9970 9833 9833 9970 9835 9878 9880 9889 9889 9880 9970 9970 9837 9835 9970 9880 9837 9835 9778 9776 9778 9835 9837 9778 9837 9836 9880 9838 9837 9837 9838 9836 9880 9969 9838 9838 9969 9843 9880 9885 9969 9884 9885 9880 9886 9885 9884 9886 9882 9885 9884 9880 9879 9879 9945 9884 9884 9945 9946 9884 9946 9886 9883 9882 9886 9886 9946 9883 9853 9882 9852 9852 9851 9853 9853 9851 9854 9854 9851 9972 9756 9854 9972 9756 9972 9754 9883 9946 9947 9945 9927 9946 9927 9928 9929 9929 9925 9927 9927 9945 9944 9944 9935 9927 9926 9927 9925 9929 9928 9795 9928 9793 9795 9793 9794 9795 9795 9794 9714 9716 9929 9795 9714 9716 9795 9759 9714 9794 9759 9794 9772 9714 9715 9716 9720 9719 9714 9714 9719 9715 9759 9720 9714 9716 9715 9717 9717 9929 9716 9974 9929 9955 9955 9929 9717 9974 9925 9929 9950 9974 9955 9717 9768 9955 9955 9768 9956 9955 9956 9950 9767 9768 9769 9768 9767 9771 9768 9771 9772 9717 9769 9768 9767 9769 9764 9764 9724 9767 9767 9724 9718 9767 9718 9771 9723 9718 9724 9723 9724 9725 9722 9726 9724 9724 9726 9725 9764 9722 9724 9717 9715 9718 9717 9718 9723 9771 9718 9715 9723 9769 9717 9769 9723 9725 9769 9725 9770 9770 9725 9726 9722 9721 9726 9770 9726 9765 9765 9726 9721 9769 9770 9764 9764 9770 9765 9764 9765 9763 9763 9765 9766 9765 9721 9766 9719 9720 9721 9719 9721 9722 9766 9721 9720 9763 9766 9761 9766 9720 9761 9761 9720 9759 9759 9760 9761 9761 9760 9762 9761 9762 9763 9772 9771 9759 9759 9771 9760 9771 9715 9760 9760 9715 9719 9760 9719 9762 9762 9719 9763 9763 9719 9722 9763 9722 9764 9878 9944 9879 9879 9944 9945 9878 9879 9880 9871 9968 9897 9871 9897 9872 9871 9808 9807 9871 9807 9870 9808 9871 9872 9870 9968 9871 9808 9872 9797 9805 9870 9807 9859 9827 9857 9827 9829 9857 9829 9751 9857 9857 9751 9962 9746 9751 9829 9746 9750 9751 9751 9750 9747 9962 9751 9747 9736 9962 9747 9747 9748 9749 9747 9750 9748 9736 9747 9737 9737 9747 9749 9735 9736 9737 9736 9735 9738 9735 9737 9727 9727 9737 9733 9737 9749 9752 9737 9752 9733 9753 9752 9749 9753 9749 9748 9744 9745 9752 9744 9752 9753 9733 9752 9745 9727 9733 9734 9733 9745 9734 9744 9743 9745 9734 9745 9743 9740 9743 9744 9727 9740 9744 9727 9744 9753 9735 9753 9748 9727 9753 9735 9735 9748 9738 9738 9748 9750 9746 9741 9750 9738 9750 9731 9731 9750 9741 9742 9741 9746 9742 9746 9730 9740 9741 9742 9731 9741 9740 9730 9731 9732 9732 9731 9729 9730 9738 9731 9731 9740 9729 9730 9732 9742 9740 9742 9743 9728 9743 9742 9728 9742 9732 9732 9729 9728 9727 9728 9729 9729 9740 9727 9727 9734 9728 9734 9743 9728 9984 9985 9986 9987 9988 9984 9984 9988 9985 10241 9987 9984 10241 9984 10242 10242 9984 9986 9987 9989 9988 10239 9989 9987 10239 9987 10240 10240 9987 10241 10240 10241 10260 10242 10260 10241 10242 9986 10243 10243 10258 10242 10242 10258 10260 10258 10252 10260 10260 10252 10253 10260 10253 10239 10240 10260 10239 10252 10244 10246 10252 10246 10253 10258 10244 10252 10253 10246 10247 10253 10247 10251 10239 10253 10251 10244 10245 10246 10246 10245 10247 10250 10245 10244 10257 10250 10244 10257 10244 10258 10247 10245 10248 10248 10245 10249 10249 10245 10250 10251 10247 10248 10254 10251 10248 10259 10251 10254 10239 10251 10259 10255 10254 10248 10255 10248 10249 10255 10249 10256 10256 10249 10250 10256 10250 10257 10235 10255 10256 10234 10256 10233 10233 10256 10257 10234 10235 10256 10235 10254 10255 10235 10259 10254 10234 9996 10235 10235 9996 10236 10236 10237 10235 10237 10259 10235 10233 9997 10234 10234 9997 9996 10232 9999 10233 10233 9999 9997 10233 10257 10232 9997 9998 9996 9999 10000 9997 9997 10000 9998 10001 9995 9999 9999 9995 10000 10232 10001 9999 10050 10000 9995 10050 10094 10000 10000 10094 10095 10000 10095 9998 9995 10092 10050 10050 10092 10093 10050 10093 10094 10093 10154 10094 10154 10095 10094 9998 10095 10096 10096 10095 10155 10155 10095 10154 9998 10096 10051 10051 10096 10097 10096 10129 10097 10096 10155 10129 10154 10146 10155 10155 10146 10148 10155 10148 10149 10155 10149 10129 10129 10128 10097 10129 10149 10164 10129 10164 10128 10148 10115 10149 10149 10115 10116 10149 10116 10150 10149 10150 10164 10164 10150 10130 10164 10130 10128 10130 10150 10117 10117 10150 10116 10115 10057 10116 10116 10057 10056 10116 10056 10055 10116 10055 10117 10117 10055 10054 10117 10054 10090 10117 10090 10118 10118 10130 10117 10118 10131 10130 10128 10130 10131 10118 10090 10089 10118 10089 10119 10119 10131 10118 10090 10034 10089 10054 10034 10090 10054 10055 10049 10054 10049 10034 10034 10003 10027 10035 10034 10027 10049 10003 10034 10089 10034 10035 10035 10088 10089 10119 10089 10088 10035 10027 10026 10043 10035 10026 10043 10087 10035 10035 10087 10088 10119 10088 10087 10043 10086 10087 10119 10087 10120 10120 10087 10086 10043 10026 10036 10086 10043 10085 10085 10043 10036 10120 10086 10121 10121 10086 10085 10132 10119 10120 10132 10120 10133 10121 10133 10120 10121 10085 10122 10122 10133 10121 10085 10036 10084 10122 10085 10084 10036 10026 10025 10084 10036 10025 10025 10083 10084 10122 10084 10123 10123 10084 10083 10123 10134 10122 10122 10134 10133 10123 10083 10082 10123 10082 10124 10134 10123 10135 10124 10136 10123 10123 10136 10135 10022 10082 10083 10022 10083 10025 10022 10081 10082 10124 10082 10081 10020 10021 10022 10025 10024 10022 10022 10024 10020 10044 10022 10021 10022 10044 10081 10081 10044 10080 10124 10081 10080 10080 10044 10079 10079 10044 10021 10124 10080 10125 10125 10080 10079 10045 10078 10079 10045 10079 10021 10125 10079 10126 10126 10079 10078 10125 10137 10124 10126 10138 10125 10125 10138 10137 10126 10078 10077 10126 10077 10127 10127 10139 10126 10126 10139 10138 10045 10077 10078 10018 10076 10077 10018 10077 10045 10127 10077 10076 10127 10076 10103 10139 10127 10140 10140 10127 10103 10018 10029 10076 10076 10029 10075 10076 10075 10103 10103 10075 10074 10103 10074 10104 10104 10140 10103 10104 10141 10140 10162 10139 10140 10162 10140 10141 10104 10074 10073 10104 10073 10105 10105 10141 10104 10074 10037 10073 10075 10029 10074 10074 10029 10037 10038 10072 10073 10038 10073 10037 10105 10073 10072 10105 10072 10106 10106 10141 10105 10072 10038 10014 10072 10014 10071 10106 10072 10071 10037 10015 10038 10038 10015 10014 10037 10029 10015 10012 10014 10015 10016 10017 10015 10015 10017 10012 10029 10016 10015 10029 10018 10016 10018 10019 10016 10021 10019 10018 10045 10021 10018 10021 10020 10019 10019 10190 10188 10019 10188 10016 10190 10019 10191 10020 10191 10019 10020 10185 10191 10185 10020 10186 10024 10186 10020 10184 10190 10191 10184 10191 10185 10189 10188 10190 10189 10190 10184 10184 10185 10171 10171 10216 10184 10184 10216 10215 10184 10215 10189 10171 10185 10186 10171 10186 10172 10024 10172 10186 10170 10171 10172 10170 10211 10171 10171 10211 10216 10172 10180 10170 10172 10024 10180 10170 10180 10181 10181 10212 10170 10170 10212 10211 10211 10212 10213 10211 10213 10216 10212 10217 10213 10181 10217 10212 10181 10180 10182 10181 10182 10183 10183 10217 10181 10023 10180 10024 10180 10023 10182 10183 10182 10195 10028 10182 10023 10182 10028 10195 10183 10195 10178 10178 10218 10183 10183 10218 10217 10213 10217 10218 10213 10218 10219 10178 10219 10218 10178 10179 10173 10178 10195 10179 10173 10221 10178 10221 10219 10178 10027 10195 10028 10195 10027 10179 10027 10028 10026 10026 10028 10023 10003 10002 10027 10002 10179 10027 10173 10179 10174 10179 10002 10174 10173 10174 10175 10175 10221 10173 10175 10174 10176 10004 10176 10174 10004 10174 10002 10002 10003 10004 10032 10004 10003 10049 10032 10003 10032 10033 10004 10176 10004 10033 10175 10176 10177 10177 10176 10194 10176 10033 10194 10177 10223 10175 10175 10223 10221 10177 10194 10192 10192 10224 10177 10177 10224 10223 10192 10194 10193 10194 10033 10193 10192 10193 10165 10165 10222 10192 10192 10222 10224 10222 10223 10224 10222 10221 10223 10220 10221 10222 10165 10220 10222 10165 10166 10167 10165 10193 10166 10167 10220 10165 10193 10033 10006 10193 10006 10005 10193 10005 10166 10167 10166 10168 10166 10005 10168 10167 10168 10169 10169 10225 10167 10167 10225 10220 10220 10225 10221 10221 10225 10226 10169 10226 10225 10168 10209 10169 10169 10209 10210 10169 10210 10206 10206 10226 10169 10010 10209 10168 10010 10168 10005 10209 10010 10210 10206 10210 10207 10009 10210 10010 10210 10009 10207 10206 10207 10201 10201 10227 10206 10206 10227 10226 10221 10226 10227 10228 10221 10227 10201 10228 10227 10201 10202 10203 10201 10207 10208 10201 10208 10202 10203 10228 10201 10213 10221 10228 10203 10213 10228 10203 10202 10204 10203 10204 10199 10199 10213 10203 10219 10221 10213 10216 10213 10230 10199 10230 10213 10199 10200 10196 10199 10204 10205 10199 10205 10200 10196 10230 10199 10012 10204 10202 10204 10012 10205 10017 10200 10205 10205 10012 10017 10196 10200 10197 10200 10017 10197 10196 10197 10187 10187 10229 10196 10196 10229 10230 10216 10230 10229 10214 10216 10229 10187 10214 10229 10187 10188 10189 10187 10197 10198 10187 10198 10188 10189 10214 10187 10016 10198 10197 10016 10197 10017 10198 10016 10188 10214 10215 10216 10189 10215 10214 10012 10013 10014 10012 10202 10013 10030 10014 10013 10046 10014 10030 10071 10014 10046 10030 10013 10031 10031 10069 10030 10069 10046 10030 10070 10046 10069 10071 10046 10070 10106 10071 10107 10107 10071 10070 10107 10070 10069 10031 10068 10069 10107 10069 10108 10108 10069 10068 10107 10141 10106 10141 10107 10142 10142 10107 10108 10108 10068 10067 10108 10067 10109 10108 10143 10142 10109 10143 10108 10031 10067 10068 10047 10066 10067 10047 10067 10031 10109 10067 10066 10047 10031 10011 10047 10011 10039 10066 10047 10065 10065 10047 10039 10109 10066 10065 10065 10039 10064 10109 10065 10110 10110 10065 10064 10039 10011 10008 10064 10039 10008 10008 10063 10064 10110 10064 10111 10111 10064 10063 10110 10144 10109 10111 10145 10110 10110 10145 10144 10111 10063 10062 10111 10062 10112 10145 10111 10146 10112 10146 10111 10007 10062 10063 10007 10063 10008 10007 10061 10062 10112 10062 10061 10112 10061 10113 10113 10147 10112 10112 10147 10146 10146 10147 10148 10154 10145 10146 10148 10147 10114 10114 10147 10113 10113 10061 10060 10113 10060 10114 10061 10040 10060 10040 10061 10007 10060 10041 10059 10060 10040 10041 10114 10060 10059 10114 10059 10115 10148 10114 10115 10042 10058 10059 10059 10041 10042 10115 10059 10058 10040 10006 10041 10041 10006 10042 10040 10007 10006 10005 10006 10007 10042 10006 10033 10005 10007 10008 10008 10010 10005 10011 10010 10008 10009 10010 10011 10031 10013 10011 10013 10207 10011 10011 10207 10009 10013 10208 10207 10208 10013 10202 10042 10033 10032 10048 10042 10032 10048 10057 10042 10042 10057 10058 10048 10032 10049 10056 10048 10055 10055 10048 10049 10057 10048 10056 10115 10058 10057 10160 10144 10145 10154 10160 10145 10160 10143 10144 10160 10159 10143 10153 10159 10160 10153 10160 10154 10109 10144 10143 10142 10143 10159 10152 10142 10159 10153 10152 10159 10091 10152 10153 10091 10153 10093 10093 10153 10154 10091 10151 10152 10152 10163 10142 10151 10163 10152 10163 10141 10142 10162 10141 10163 10151 10162 10163 10151 10139 10162 10161 10138 10139 10151 10161 10139 10156 10137 10161 10161 10137 10138 10156 10161 10151 10124 10137 10136 10156 10136 10137 10158 10135 10136 10158 10136 10156 10158 10134 10135 10157 10134 10158 10156 10157 10158 10157 10133 10134 10099 10128 10157 10099 10157 10156 10128 10133 10157 10128 10132 10133 10128 10099 10098 10097 10128 10098 10128 10131 10132 10131 10119 10132 9992 10097 10098 9992 10098 10052 10052 10098 10099 10051 10097 9992 10051 9992 9998 9996 9998 9992 9996 9992 9991 10236 9996 9991 9991 9992 9990 10236 9991 10237 10237 9991 9990 9990 9988 9989 9990 9992 9988 10237 9990 10238 10238 9990 9989 10238 10259 10237 10238 9989 10239 10238 10239 10259 9992 10052 9988 10052 10099 9988 9988 10099 10100 9988 10100 9985 10100 10099 10156 9985 10100 10101 10100 10156 10101 9986 9985 9993 9985 10053 9993 9985 10101 10053 10053 10101 10102 10101 10151 10102 10101 10156 10151 10053 10102 9993 9986 9993 9994 9994 9993 9995 9993 10091 9995 9993 10102 10091 9986 9994 10231 10243 9986 10231 9994 9995 10001 10231 9994 10232 10232 9994 10001 9995 10091 10092 10092 10091 10093 10102 10151 10091 10231 10232 10258 10232 10257 10258 10231 10258 10243 10023 10024 10025 10023 10025 10026 10261 10262 10263 10282 10261 10283 10283 10261 10263 10295 10262 10261 10295 10261 10282 10298 10295 10282 10298 10282 10310 10282 10283 10310 10283 10263 10269 10283 10269 10284 10309 10283 10284 10310 10283 10309 10276 10298 10310 10276 10310 10277 10277 10310 10309 10297 10295 10298 10276 10297 10298 10276 10262 10275 10277 10262 10276 10275 10299 10276 10276 10299 10297 10277 10263 10262 10280 10263 10277 10277 10309 10280 10275 10262 10274 10294 10274 10262 10294 10262 10295 10275 10274 10273 10273 10299 10275 10266 10273 10274 10292 10266 10274 10292 10274 10293 10293 10274 10294 10273 10266 10271 10271 10301 10273 10273 10301 10300 10273 10300 10299 10301 10290 10300 10302 10290 10301 10271 10302 10301 10300 10290 10296 10300 10296 10299 10299 10294 10297 10299 10296 10294 10292 10296 10290 10296 10292 10293 10296 10293 10294 10294 10295 10297 10291 10266 10292 10290 10291 10292 10290 10264 10291 10291 10264 10266 10264 10265 10266 10271 10266 10265 10289 10265 10264 10289 10264 10290 10288 10265 10289 10305 10289 10302 10302 10289 10290 10288 10289 10305 10306 10288 10305 10272 10305 10271 10271 10305 10302 10272 10306 10305 10271 10265 10272 10272 10268 10281 10272 10265 10268 10281 10306 10272 10303 10286 10306 10306 10286 10288 10281 10303 10306 10281 10268 10278 10278 10303 10281 10303 10304 10286 10278 10304 10303 10278 10270 10279 10278 10268 10270 10279 10308 10278 10278 10308 10307 10278 10307 10304 10307 10286 10304 10308 10286 10307 10308 10284 10286 10309 10284 10308 10279 10309 10308 10279 10270 10263 10279 10263 10280 10280 10309 10279 10269 10263 10270 10284 10269 10270 10284 10270 10285 10285 10286 10284 10285 10270 10286 10270 10268 10286 10286 10268 10287 10287 10288 10286 10267 10268 10265 10287 10268 10267 10287 10267 10288 10288 10267 10265 10311 10312 10313 10313 10315 10311 10320 10312 10311 10320 10311 10321 10321 10311 10322 10322 10311 10315 10312 10314 10313 10314 10312 10316 10320 10316 10312 10318 10313 10314 10318 10314 10319 10319 10314 10316 10319 10316 10320 10320 10326 10319 10319 10326 10327 10319 10327 10318 10317 10313 10318 10318 10327 10323 10318 10323 10317 10326 10332 10327 10327 10332 10329 10327 10329 10323 10320 10325 10326 10325 10331 10326 10326 10331 10332 10321 10325 10320 10328 10325 10321 10325 10328 10331 10322 10324 10321 10321 10324 10328 10322 10315 10313 10322 10313 10317 10317 10323 10322 10322 10323 10324 10323 10330 10324 10324 10330 10328 10323 10329 10330 10337 10329 10338 10338 10329 10339 10339 10329 10340 10340 10329 10332 10354 10330 10329 10354 10329 10337 10338 10336 10337 10336 10368 10337 10337 10368 10354 10339 10369 10338 10369 10336 10338 10340 10370 10339 10339 10370 10369 10336 10369 10370 10336 10370 10334 10334 10370 10340 10340 10332 10341 10341 10334 10340 10333 10334 10335 10334 10333 10336 10334 10355 10335 10341 10355 10334 10341 10332 10342 10342 10355 10341 10355 10356 10335 10356 10355 10342 10342 10332 10343 10343 10356 10342 10356 10357 10335 10357 10356 10343 10343 10332 10331 10343 10331 10344 10344 10357 10343 10344 10335 10357 10344 10331 10345 10345 10335 10344 10345 10331 10351 10351 10331 10328 10351 10358 10345 10358 10335 10345 10351 10328 10352 10352 10359 10351 10351 10359 10358 10335 10358 10359 10335 10359 10360 10335 10360 10333 10352 10360 10359 10352 10328 10346 10346 10360 10352 10360 10361 10333 10361 10360 10346 10346 10328 10347 10347 10361 10346 10333 10361 10362 10347 10362 10361 10347 10328 10348 10348 10362 10347 10362 10363 10333 10363 10362 10348 10348 10328 10330 10348 10330 10349 10349 10363 10348 10333 10363 10364 10349 10364 10363 10349 10330 10350 10350 10364 10349 10350 10330 10353 10353 10330 10354 10353 10365 10350 10365 10364 10350 10364 10365 10333 10333 10365 10366 10353 10366 10365 10353 10354 10366 10354 10368 10367 10354 10367 10366 10333 10366 10336 10336 10366 10367 10367 10368 10336 10371 10372 10373 10374 10375 10371 10371 10375 10372 10373 10382 10371 10401 10371 10402 10401 10374 10371 10402 10371 10382 10373 10372 10388 10388 10372 10375 10373 10378 10377 10382 10373 10377 10389 10373 10388 10389 10378 10373 10377 10378 10379 10379 10378 10380 10389 10380 10378 10384 10377 10379 10377 10384 10382 10380 10376 10379 10379 10376 10381 10385 10379 10381 10385 10384 10379 10384 10385 10397 10399 10384 10397 10399 10382 10384 10390 10385 10381 10397 10385 10398 10398 10385 10390 10383 10381 10376 10390 10381 10383 10390 10383 10374 10398 10390 10400 10400 10390 10374 10400 10395 10398 10398 10395 10397 10400 10374 10401 10400 10393 10395 10401 10396 10400 10400 10396 10393 10374 10376 10375 10374 10383 10376 10386 10375 10376 10386 10376 10380 10375 10386 10387 10387 10388 10375 10380 10393 10386 10386 10393 10387 10380 10395 10393 10393 10396 10387 10387 10396 10394 10401 10394 10396 10402 10394 10401 10387 10394 10388 10402 10388 10394 10388 10391 10389 10402 10391 10388 10402 10382 10399 10399 10391 10402 10389 10391 10392 10399 10392 10391 10389 10392 10380 10392 10395 10380 10397 10395 10392 10397 10392 10399 10403 10404 10405 10403 10405 10406 10415 10416 10403 10403 10416 10404 10421 10415 10403 10421 10403 10422 10422 10403 10406 10409 10417 10415 10415 10417 10416 10420 10409 10415 10420 10415 10421 10433 10404 10416 10433 10416 10434 10434 10416 10417 10409 10410 10417 10434 10417 10426 10426 10417 10410 10420 10434 10426 10421 10433 10434 10421 10434 10420 10422 10433 10421 10432 10404 10433 10422 10432 10433 10431 10405 10432 10432 10405 10404 10422 10431 10432 10430 10411 10431 10431 10411 10405 10423 10431 10422 10423 10430 10431 10406 10405 10411 10406 10411 10412 10412 10411 10418 10430 10418 10411 10422 10406 10423 10423 10406 10412 10423 10412 10424 10424 10430 10423 10429 10418 10430 10424 10429 10430 10412 10418 10413 10413 10418 10414 10429 10414 10418 10424 10412 10413 10424 10413 10425 10425 10428 10424 10424 10428 10429 10428 10414 10429 10413 10414 10407 10407 10414 10408 10427 10408 10414 10427 10414 10428 10425 10413 10407 10425 10407 10419 10419 10427 10425 10425 10427 10428 10407 10408 10409 10419 10407 10409 10409 10408 10410 10427 10410 10408 10426 10410 10427 10419 10426 10427 10419 10409 10420 10420 10426 10419 10435 10436 10437 10449 10451 10435 10435 10451 10436 10457 10449 10435 10457 10435 10458 10458 10435 10437 10437 10436 10438 10458 10437 10459 10459 10437 10438 10457 10458 10475 10475 10458 10459 10459 10438 10440 10459 10440 10463 10481 10459 10463 10475 10459 10481 10438 10436 10439 10438 10439 10440 10440 10439 10441 10440 10441 10442 10463 10440 10442 10439 10456 10441 10474 10456 10439 10474 10439 10472 10472 10439 10436 10441 10456 10455 10470 10455 10456 10473 10456 10474 10456 10473 10470 10468 10455 10470 10473 10498 10470 10470 10498 10499 10468 10470 10504 10470 10499 10504 10498 10473 10474 10498 10495 10499 10498 10474 10495 10474 10482 10495 10495 10482 10494 10495 10494 10499 10482 10472 10471 10482 10492 10494 10482 10471 10492 10482 10474 10472 10465 10471 10452 10452 10471 10472 10465 10489 10471 10471 10489 10492 10472 10436 10452 10452 10436 10451 10451 10454 10452 10465 10452 10454 10464 10465 10454 10465 10464 10489 10489 10464 10487 10492 10489 10490 10489 10487 10490 10454 10467 10464 10467 10512 10464 10464 10512 10487 10487 10484 10488 10490 10487 10491 10487 10512 10484 10491 10487 10488 10492 10490 10493 10490 10491 10493 10491 10524 10493 10524 10491 10488 10488 10484 10486 10486 10514 10488 10524 10488 10514 10493 10524 10525 10514 10543 10524 10524 10543 10544 10524 10544 10525 10493 10515 10492 10515 10493 10525 10533 10515 10525 10525 10544 10545 10525 10545 10546 10525 10546 10533 10516 10492 10515 10515 10533 10516 10532 10516 10533 10533 10546 10547 10533 10547 10532 10494 10492 10516 10516 10496 10494 10516 10532 10517 10516 10517 10496 10532 10547 10548 10532 10548 10517 10496 10517 10497 10497 10517 10531 10517 10548 10549 10517 10549 10531 10494 10496 10497 10499 10494 10497 10518 10500 10497 10497 10500 10499 10497 10531 10518 10530 10518 10531 10549 10550 10531 10531 10550 10530 10548 10565 10549 10566 10550 10549 10566 10549 10565 10530 10550 10551 10550 10566 10567 10550 10567 10551 10503 10502 10530 10518 10530 10502 10530 10551 10503 10518 10502 10500 10501 10500 10502 10501 10502 10503 10499 10500 10501 10504 10499 10501 10519 10501 10503 10501 10519 10504 10519 10503 10529 10503 10551 10552 10503 10552 10529 10519 10520 10506 10519 10506 10504 10520 10519 10529 10468 10504 10505 10505 10504 10506 10506 10520 10508 10506 10508 10505 10520 10528 10508 10528 10520 10529 10529 10552 10553 10529 10553 10528 10527 10508 10528 10528 10553 10554 10528 10554 10527 10507 10505 10508 10507 10508 10509 10508 10527 10509 10505 10507 10468 10483 10469 10507 10507 10509 10510 10483 10507 10511 10469 10468 10507 10510 10511 10507 10509 10521 10510 10521 10509 10527 10510 10522 10523 10523 10511 10510 10521 10522 10510 10527 10555 10521 10521 10555 10556 10521 10556 10522 10523 10522 10526 10522 10556 10557 10522 10557 10526 10511 10523 10485 10485 10523 10526 10526 10513 10485 10526 10541 10513 10526 10557 10558 10526 10558 10541 10556 10573 10557 10574 10558 10557 10574 10557 10573 10558 10574 10575 10558 10575 10541 10612 10574 10573 10575 10574 10612 10573 10556 10572 10573 10572 10602 10573 10602 10612 10612 10602 10611 10611 10603 10612 10575 10612 10579 10579 10612 10603 10541 10575 10579 10541 10579 10576 10576 10579 10581 10579 10603 10581 10541 10576 10542 10576 10577 10542 10577 10576 10580 10581 10580 10576 10580 10581 10582 10604 10582 10581 10603 10604 10581 10585 10577 10580 10582 10585 10580 10542 10577 10543 10578 10543 10577 10577 10585 10578 10514 10542 10543 10543 10578 10544 10544 10578 10585 10544 10563 10545 10563 10544 10584 10544 10585 10584 10562 10546 10563 10563 10546 10545 10563 10584 10562 10584 10585 10586 10562 10584 10586 10546 10562 10564 10564 10562 10586 10546 10564 10547 10547 10564 10587 10564 10586 10607 10607 10587 10564 10586 10585 10583 10586 10583 10606 10607 10586 10606 10607 10606 10590 10607 10590 10587 10605 10606 10583 10606 10605 10608 10590 10606 10608 10583 10582 10559 10585 10582 10583 10583 10559 10605 10605 10559 10540 10608 10605 10540 10608 10540 10539 10539 10592 10608 10608 10592 10590 10475 10539 10540 10475 10540 10536 10536 10540 10559 10536 10559 10582 10536 10582 10604 10476 10536 10477 10536 10538 10477 10475 10536 10476 10604 10538 10536 10476 10457 10475 10481 10535 10475 10475 10535 10539 10476 10477 10457 10462 10449 10457 10457 10477 10462 10461 10447 10462 10462 10447 10449 10477 10478 10462 10462 10478 10461 10447 10448 10449 10449 10448 10450 10449 10450 10451 10446 10445 10447 10447 10445 10448 10461 10446 10447 10445 10453 10448 10448 10453 10454 10448 10454 10450 10450 10454 10451 10466 10467 10454 10466 10454 10453 10467 10466 10453 10511 10467 10483 10483 10467 10453 10467 10511 10512 10485 10484 10511 10511 10484 10512 10484 10485 10486 10485 10513 10486 10486 10513 10514 10513 10541 10542 10513 10542 10514 10444 10453 10445 10444 10455 10453 10469 10453 10455 10483 10453 10469 10443 10441 10444 10443 10444 10445 10441 10455 10444 10443 10445 10446 10461 10443 10446 10442 10441 10443 10460 10443 10461 10463 10442 10443 10463 10443 10460 10479 10461 10478 10479 10460 10461 10479 10480 10460 10460 10480 10463 10480 10481 10463 10479 10481 10480 10481 10534 10535 10479 10534 10481 10479 10537 10534 10535 10534 10561 10600 10561 10534 10600 10534 10537 10539 10535 10592 10592 10535 10594 10535 10561 10594 10591 10590 10592 10591 10592 10594 10594 10561 10591 10589 10590 10591 10591 10593 10589 10591 10610 10593 10597 10591 10561 10597 10610 10591 10590 10589 10587 10588 10587 10589 10589 10593 10588 10567 10588 10593 10609 10567 10593 10593 10610 10609 10569 10609 10610 10597 10596 10610 10610 10596 10569 10568 10567 10609 10569 10568 10609 10567 10568 10551 10566 10588 10567 10587 10588 10565 10566 10565 10588 10565 10547 10587 10565 10548 10547 10551 10568 10569 10551 10569 10552 10552 10569 10570 10552 10570 10553 10570 10554 10553 10570 10571 10554 10595 10570 10596 10570 10569 10596 10571 10570 10595 10527 10554 10555 10554 10571 10555 10572 10555 10571 10572 10571 10595 10595 10596 10598 10602 10595 10598 10572 10595 10602 10596 10597 10598 10598 10597 10599 10603 10598 10599 10603 10611 10598 10598 10611 10602 10599 10597 10561 10599 10600 10601 10599 10561 10600 10603 10599 10601 10603 10601 10560 10604 10603 10560 10537 10601 10600 10537 10560 10601 10560 10537 10538 10560 10538 10604 10479 10538 10537 10477 10538 10479 10479 10478 10477 10572 10556 10555 10455 10468 10469 10613 10614 10615 10613 10615 10616 10613 10616 10617 10644 10614 10613 10644 10613 10645 10645 10613 10617 10617 10616 10618 10617 10618 10641 10645 10617 10646 10646 10617 10641 10671 10644 10645 10645 10673 10671 10646 10667 10645 10645 10667 10673 10646 10641 10647 10666 10667 10646 10647 10666 10646 10693 10667 10666 10693 10703 10667 10667 10703 10704 10667 10704 10673 10702 10671 10673 10673 10704 10702 10703 10729 10704 10704 10729 10730 10704 10730 10727 10704 10727 10702 10703 10728 10729 10728 10703 10693 10729 10728 10723 10720 10730 10729 10720 10729 10723 10739 10727 10730 10739 10730 10720 10717 10720 10716 10716 10720 10715 10723 10714 10720 10720 10714 10715 10720 10717 10739 10739 10717 10721 10721 10727 10739 10716 10686 10717 10717 10686 10688 10717 10688 10689 10717 10689 10718 10721 10717 10718 10715 10687 10716 10716 10687 10686 10714 10685 10715 10715 10685 10687 10685 10686 10687 10664 10686 10685 10686 10664 10663 10663 10688 10686 10689 10688 10663 10690 10689 10663 10718 10689 10719 10719 10689 10690 10721 10718 10719 10719 10690 10705 10719 10705 10721 10690 10663 10662 10677 10690 10665 10665 10690 10662 10705 10690 10677 10705 10677 10706 10705 10706 10722 10721 10705 10722 10676 10677 10655 10655 10677 10665 10706 10677 10676 10633 10655 10665 10633 10665 10662 10632 10654 10655 10632 10655 10633 10655 10678 10676 10654 10678 10655 10676 10678 10679 10706 10676 10707 10707 10676 10679 10679 10678 10653 10654 10653 10678 10631 10653 10654 10631 10654 10632 10630 10652 10653 10630 10653 10631 10653 10680 10679 10652 10680 10653 10707 10679 10708 10708 10679 10680 10708 10722 10707 10707 10722 10706 10708 10680 10709 10722 10708 10736 10736 10708 10737 10737 10708 10709 10681 10680 10652 10709 10680 10681 10709 10681 10682 10709 10682 10710 10710 10724 10709 10737 10709 10724 10737 10733 10698 10737 10698 10736 10737 10724 10733 10736 10698 10735 10736 10735 10722 10697 10668 10698 10698 10668 10670 10698 10670 10699 10697 10698 10733 10735 10698 10699 10699 10725 10735 10722 10735 10725 10699 10670 10669 10699 10669 10700 10700 10725 10699 10669 10670 10643 10643 10670 10650 10650 10670 10668 10669 10643 10644 10669 10644 10671 10700 10669 10701 10701 10669 10671 10725 10700 10701 10701 10671 10702 10725 10701 10726 10726 10701 10727 10727 10701 10702 10721 10725 10726 10721 10726 10727 10722 10725 10721 10643 10614 10644 10621 10624 10614 10614 10624 10615 10642 10621 10614 10643 10642 10614 10621 10632 10624 10624 10632 10633 10624 10633 10634 10624 10634 10615 10615 10634 10635 10615 10635 10636 10615 10636 10616 10633 10662 10634 10634 10662 10663 10634 10663 10635 10635 10663 10636 10616 10636 10637 10636 10663 10664 10636 10664 10637 10616 10637 10638 10616 10638 10618 10637 10664 10661 10637 10661 10638 10664 10685 10661 10638 10661 10659 10661 10685 10659 10618 10638 10619 10638 10659 10619 10618 10619 10620 10641 10618 10620 10626 10620 10619 10619 10659 10660 10619 10660 10626 10659 10685 10684 10659 10684 10660 10714 10684 10685 10684 10683 10660 10713 10683 10684 10713 10684 10714 10626 10660 10656 10660 10683 10656 10674 10656 10683 10712 10674 10683 10712 10683 10713 10713 10714 10723 10713 10723 10712 10711 10674 10712 10712 10723 10711 10674 10675 10657 10656 10674 10657 10711 10675 10674 10626 10656 10657 10626 10657 10625 10625 10657 10627 10627 10657 10658 10657 10675 10682 10657 10682 10658 10710 10682 10675 10710 10675 10711 10682 10681 10651 10682 10651 10658 10627 10658 10651 10627 10628 10625 10628 10627 10629 10627 10651 10629 10651 10652 10629 10651 10681 10652 10628 10629 10622 10622 10629 10630 10629 10652 10630 10621 10622 10623 10622 10630 10623 10640 10622 10642 10642 10622 10621 10622 10640 10628 10631 10623 10630 10623 10631 10621 10621 10631 10632 10625 10628 10620 10639 10620 10628 10628 10640 10639 10625 10620 10626 10641 10620 10639 10647 10641 10639 10647 10639 10648 10648 10639 10640 10648 10666 10647 10648 10640 10649 10649 10672 10648 10648 10672 10666 10692 10666 10672 10693 10666 10692 10694 10692 10695 10695 10692 10672 10692 10694 10693 10694 10731 10693 10693 10731 10732 10693 10732 10728 10695 10731 10694 10695 10672 10696 10696 10734 10695 10695 10734 10731 10738 10732 10731 10738 10731 10734 10723 10728 10732 10723 10732 10738 10724 10710 10738 10738 10710 10711 10738 10711 10723 10738 10734 10724 10733 10734 10696 10724 10734 10733 10733 10696 10697 10696 10691 10697 10697 10691 10668 10691 10672 10668 10696 10672 10691 10650 10668 10649 10649 10668 10672 10649 10640 10650 10650 10640 10642 10650 10642 10643 10740 10741 10742 10743 10744 10745 10746 10747 10748 10748 10821 10746 10746 10821 10822 10746 10822 10819 10746 10844 10747 10819 10845 10746 10746 10845 10846 10746 10846 10844 10821 10820 10822 10748 10820 10821 10819 10822 10820 10819 10820 10818 10818 10847 10819 10819 10847 10845 10846 10845 10847 10846 10847 10844 10747 10844 10843 10844 10847 10842 10843 10844 10842 10747 10843 10749 10749 10843 10842 10749 10750 10747 10747 10750 10748 10753 10752 10749 10749 10752 10750 10749 10842 10753 10748 10750 10752 10748 10752 10755 10748 10755 10877 10880 10820 10748 10880 10748 10877 10751 10752 10753 10755 10752 10751 10751 10753 10754 10751 10754 10755 10839 10754 10753 10842 10839 10753 10839 10842 10892 10892 10842 10893 10893 10842 10847 10883 10893 10847 10883 11064 10893 10893 11064 11042 10893 11042 11065 10893 11065 10892 10818 10849 10847 10847 10849 10851 10851 10883 10847 10883 11063 11064 10851 11063 10883 11063 11032 11035 11063 11035 11037 11063 11037 11064 11062 11032 11063 10851 11062 11063 11032 11034 11035 11035 11034 11036 11035 11036 11037 11037 11036 11038 11037 11038 11039 11037 11039 11040 11064 11037 11040 11034 10970 11036 11036 10970 11038 11038 10970 10971 11038 10971 10972 11038 10972 11039 11040 11039 11041 11039 10972 10973 11039 10973 11041 11040 11041 11042 11064 11040 11042 11042 11041 10991 11041 10973 10974 11041 10974 10895 11041 10895 10991 10972 10940 10973 10973 10940 10974 10971 10923 10972 10972 10923 10940 10940 10923 10903 10940 10903 10941 10974 10940 10941 10974 10941 10895 10941 10903 10880 10941 10880 10896 10895 10941 10896 10878 10820 10903 10903 10820 10880 10910 10878 10903 10923 10910 10903 10939 10910 10923 10971 10939 10923 10909 10878 10910 10939 10909 10910 10878 10873 10814 10820 10878 10814 10909 10873 10878 10922 10873 10909 10937 10922 10909 10937 10909 10938 10938 10909 10939 10967 10922 10937 10967 10937 10968 10968 10937 10938 10968 10938 10969 10969 10938 10939 11030 10967 10968 11030 10968 11033 11033 10968 11034 11034 10968 10969 10966 10922 10967 11030 10966 10967 10965 10922 10966 11029 10965 10966 11029 10966 11030 10965 10947 10922 11028 10947 10965 11028 10965 11029 11027 11028 11029 11027 11029 11030 11027 11026 11028 11026 10964 11028 11028 10964 10947 10947 10921 10922 10964 10921 10947 10921 10869 10922 10922 10869 10873 10921 10908 10869 10936 10908 10921 10964 10936 10921 10963 10936 10964 11024 10963 10964 11024 10964 11026 10936 10920 10908 10936 10935 10920 10963 10935 10936 10908 10870 10869 10920 10870 10908 10920 10907 10870 10935 10907 10920 10934 10907 10935 10961 10934 10935 10961 10935 10962 10962 10935 10963 11024 10962 10963 11021 10961 10962 11021 10962 11023 11023 10962 11024 10960 10934 10961 11020 10960 10961 11020 10961 11021 11019 11020 11021 11019 11021 11022 11022 11021 11023 11022 11023 11024 11022 11024 11025 11059 11019 11022 11059 11022 11060 11060 11022 11025 11019 11018 11020 11059 11018 11019 11018 10960 11020 11016 11017 11018 11059 11016 11018 11017 10960 11018 10885 11016 11059 10885 11059 10884 10884 11059 11060 10890 11060 11025 10884 11060 10890 10884 10859 10885 10890 10854 10884 10884 10854 10859 10890 10855 10854 10890 11025 11061 10855 10890 11061 10804 10854 10855 10854 10804 10856 10857 10854 10856 10854 10857 10859 10856 10804 10802 10856 10802 10857 10802 10858 10857 10858 10859 10857 10800 10801 10802 10802 10801 10803 10802 10803 10798 10800 10802 10804 10798 10858 10802 10798 10859 10858 10798 10799 10796 10798 10803 10799 10796 10859 10798 10796 10860 10859 10860 10861 10859 10885 10859 10861 10796 10797 10794 10796 10799 10797 10794 10860 10796 10803 10797 10799 10794 10797 10795 10803 10793 10797 10793 10795 10797 10794 10795 10792 10792 10862 10794 10794 10862 10860 10862 10861 10860 10792 10861 10862 10791 10788 10792 10791 10792 10793 10792 10795 10793 10861 10792 10863 10863 10792 10788 10789 10788 10791 10791 10793 10789 10788 10789 10790 10787 10789 10793 10787 10790 10789 10788 10790 10786 10786 10790 10787 10786 10864 10788 10788 10864 10865 10788 10865 10863 10861 10863 10865 10865 10864 10866 10865 10866 10861 10786 10866 10864 10786 10787 10782 10782 10866 10786 10782 10783 10784 10782 10787 10783 10784 10868 10782 10782 10868 10866 10784 10783 10785 10783 10787 10785 10784 10785 10780 10784 10780 10823 10823 10867 10784 10784 10867 10868 10868 10867 10866 10886 10867 10823 10984 10867 10886 10866 10867 10984 10886 10828 10887 10828 10886 10823 10886 11056 11054 10886 11054 10984 10887 11056 10886 10984 11054 11057 10866 10984 11057 11057 11054 11008 11057 11008 11013 11057 11013 11058 10894 11057 11058 10866 11057 10894 10894 10861 10866 10885 10861 10894 10894 11058 10885 11058 11013 11016 10885 11058 11016 11013 11015 11016 11016 11015 11017 11013 11014 11015 11014 10959 11015 11015 10959 11017 11017 10959 10933 11017 10933 10960 10958 10918 10959 10959 10918 10933 11014 10958 10959 11013 11012 11014 11012 10958 11014 10957 10932 10958 10958 10932 10918 11012 10957 10958 11008 11011 11012 11008 11012 11013 11011 10957 11012 10898 10931 10957 10957 10931 10932 11010 10898 10957 11010 10957 11011 10931 10902 10932 10932 10902 10906 10932 10906 10918 10900 10902 10931 10898 10900 10931 10898 10899 10900 11009 10899 10898 11009 10898 11010 11008 11009 11010 11008 11010 11011 11054 11009 11008 11054 11007 11009 11007 10899 11009 10900 10899 10901 11007 10901 10899 10930 10905 10900 10900 10905 10902 10901 10930 10900 10956 10930 10901 11005 10956 10901 11005 10901 11006 11006 10901 11007 11004 11006 11007 11054 11004 11007 11056 11004 11054 11001 11003 11004 11004 11003 11005 11004 11005 11006 11056 11001 11004 11003 10955 11005 11005 10955 10956 10955 10929 10956 10956 10929 10930 10954 10928 10955 10955 10928 10929 11003 10954 10955 11001 11002 11003 11002 10954 11003 10953 10928 10954 11000 10953 10954 11000 10954 11002 10927 10916 10928 10928 10916 10917 10928 10917 10929 10953 10927 10928 10952 10927 10953 11000 10952 10953 10926 10915 10927 10927 10915 10916 10951 10926 10927 10951 10927 10952 10915 10872 10916 10916 10872 10876 10916 10876 10917 10917 10876 10904 10929 10917 10904 10872 10775 10876 10775 10779 10876 10876 10779 10879 10904 10876 10879 10904 10879 10905 10929 10904 10930 10930 10904 10905 10779 10781 10879 10879 10781 10785 10879 10785 10902 10905 10879 10902 10780 10781 10778 10778 10781 10779 10781 10780 10785 10902 10785 10787 10902 10787 10906 10875 10787 10793 10906 10787 10875 10918 10906 10875 10874 10875 10793 10918 10875 10919 10919 10875 10874 10874 10793 10803 10874 10803 10870 10907 10874 10870 10919 10874 10907 10933 10918 10919 10933 10919 10934 10934 10919 10907 10933 10934 10960 10869 10870 10806 10870 10803 10806 10869 10806 10873 10805 10806 10804 10804 10806 10807 10805 10809 10806 10803 10807 10806 10806 10809 10873 10873 10809 10814 10808 10809 10805 10808 10811 10809 10811 10814 10809 10810 10811 10808 10808 10852 10810 10805 10853 10808 10808 10853 10852 10810 10814 10811 10812 10814 10810 10810 10850 10812 10810 10852 10850 10851 10850 10852 10853 10855 10852 10855 10851 10852 10805 10855 10853 10804 10855 10805 10855 11061 11062 10855 11062 10851 10812 10850 10851 10812 10851 10848 10848 10851 10849 10848 10849 10816 10848 10816 10812 10816 10849 10818 10815 10812 10816 10815 10816 10817 10818 10817 10816 10818 10820 10817 10820 10815 10817 10813 10812 10815 10820 10814 10815 10814 10813 10815 10812 10813 10814 11062 11031 11032 11061 11031 11062 11027 11030 11031 11031 11030 11032 11061 11027 11031 11032 11030 11033 11032 11033 11034 11034 10969 10970 10969 10939 10970 10970 10939 10971 11025 11026 11027 11061 11025 11027 11025 11024 11026 10804 10807 10800 10803 10800 10807 10803 10801 10800 10778 10824 10780 10780 10824 10823 10778 10779 10777 10777 10826 10778 10778 10826 10824 10823 10824 10826 10823 10826 10825 10823 10825 10828 10777 10825 10826 10776 10773 10777 10777 10779 10776 10825 10777 10827 10827 10777 10773 10775 10776 10779 10774 10773 10776 10775 10774 10776 10773 10774 10775 10773 10775 10771 10771 10775 10772 10772 10775 10770 10770 10775 10872 10771 10772 10769 10771 10829 10773 10769 10830 10771 10771 10830 10829 10769 10772 10770 10769 10770 10768 10768 10831 10769 10769 10831 10830 10768 10767 10766 10768 10770 10767 10766 10833 10768 10768 10833 10831 10831 10833 10830 10766 10832 10833 10833 10836 10837 10834 10836 10833 10832 10834 10833 10833 10837 10889 10891 10830 10833 10891 10833 10889 10832 10766 10834 10834 10766 10764 10764 10836 10834 10764 10835 10836 10835 10837 10836 10762 10763 10764 10764 10763 10765 10764 10765 10760 10762 10764 10766 10760 10835 10764 10760 10837 10835 10760 10761 10758 10760 10765 10761 10758 10837 10760 10761 10765 10763 10763 10767 10761 10762 10767 10763 10762 10766 10767 10761 10767 10757 10767 10770 10871 10882 10757 10767 10882 10767 10871 10758 10761 10759 10757 10759 10761 10758 10759 10756 10756 10759 10757 10756 10757 10754 10756 10838 10758 10754 10841 10756 10756 10841 10838 10754 10757 10755 10839 10840 10754 10754 10840 10841 10838 10841 10837 10840 10839 10841 10841 10839 10837 10758 10838 10837 10837 10839 10888 10889 10837 10985 10985 10837 10986 10986 10837 10888 10888 10839 10892 10888 10892 11067 10888 11067 10986 11067 11045 10986 10986 11045 11048 10986 11048 11068 10986 11068 10985 11066 11043 11067 11067 11043 11045 10892 11066 11067 10892 11065 11066 11065 10988 11066 11066 10988 11043 11043 10988 10987 11043 10987 11044 11043 11044 11045 10987 10988 10976 10987 10976 10977 10987 10977 11044 11045 11044 11046 11044 10977 10978 11044 10978 10979 11044 10979 11046 10976 10942 10977 10977 10942 10943 10977 10943 10978 10978 10943 10979 10942 10911 10943 10943 10911 10944 10979 10943 10944 10896 10877 10942 10942 10877 10911 10975 10896 10942 10975 10942 10976 10911 10877 10755 10911 10755 10912 10944 10911 10912 10944 10912 10945 10979 10944 10945 10912 10755 10881 10924 10912 10881 10945 10912 10924 10755 10757 10881 10881 10757 10882 10881 10882 10913 10924 10881 10913 10946 10924 10913 10948 10924 10946 10981 10945 10924 10981 10924 10948 10913 10882 10871 10914 10913 10871 10946 10913 10925 10925 10913 10914 10871 10770 10872 10914 10871 10915 10915 10871 10872 10925 10914 10926 10926 10914 10915 10949 10925 10926 10949 10946 10925 10949 10926 10950 10950 10926 10951 10995 10949 10950 10995 10950 10997 10997 10950 10998 10998 10950 10951 10998 10951 10952 10996 10997 10998 10996 10998 10999 10999 10998 11000 10998 10952 11000 10996 10995 10997 11055 10995 10996 10996 10999 10887 11055 10996 10891 10891 10996 10887 10999 11000 11001 10887 10999 11001 11001 11000 11002 10887 11001 11056 10887 10828 10830 10887 10830 10891 10889 11055 10891 10889 10985 11055 11068 11051 10985 10985 11051 10993 10985 10993 11055 11068 11048 11051 11048 11050 11051 11051 11050 11052 11051 11052 10993 11045 11047 11048 11048 11047 11049 11048 11049 11050 11045 11046 11047 11046 10979 11047 11047 10979 10980 11047 10980 11049 11049 10980 11050 10979 10945 10980 10980 10945 10981 11050 10980 10981 11050 10981 10948 10982 10948 10946 11050 10948 11052 11052 10948 10982 10982 10946 10983 11052 10982 11053 11053 10982 10983 10983 10946 10949 11053 10983 10949 10993 11052 11053 10993 11053 10994 11053 10949 10994 10994 10949 10995 10993 10994 10995 11055 10993 10995 10828 10829 10830 10827 10773 10828 10773 10829 10828 10827 10828 10825 10896 10880 10877 10895 10896 10897 10897 10896 10975 10991 10895 10992 10992 10895 10897 10992 10897 10975 10992 10975 10989 10989 10975 10976 10990 10991 10992 10990 10992 10988 10988 10992 10989 11042 10991 10990 11042 10990 11065 11065 10990 10988 10976 10988 10989 11069 11070 11071 11088 11089 11069 11069 11089 11070 11105 11088 11069 11105 11069 11071 11085 11087 11088 11088 11087 11089 11085 11088 11105 11095 11089 11096 11095 11070 11089 11096 11089 11087 11085 11086 11087 11096 11087 11102 11102 11087 11086 11110 11095 11096 11110 11096 11111 11111 11096 11102 11097 11070 11095 11109 11095 11110 11109 11097 11095 11111 11139 11110 11110 11139 11140 11110 11140 11109 11122 11097 11109 11109 11140 11149 11109 11149 11122 11139 11158 11140 11140 11158 11157 11140 11157 11149 11111 11142 11139 11142 11159 11139 11139 11159 11158 11123 11157 11158 11123 11158 11159 11106 11156 11157 11106 11157 11123 11149 11157 11156 11122 11149 11146 11149 11156 11146 11124 11156 11106 11146 11156 11124 11122 11146 11121 11121 11146 11147 11146 11124 11147 11124 11106 11125 11125 11155 11124 11147 11124 11155 11121 11147 11148 11147 11155 11148 11120 11101 11121 11121 11101 11122 11121 11148 11120 11120 11148 11145 11148 11155 11154 11148 11154 11145 11125 11154 11155 11125 11153 11154 11145 11154 11153 11120 11145 11119 11119 11145 11143 11145 11153 11143 11119 11091 11120 11120 11091 11101 11090 11075 11091 11091 11075 11101 11119 11090 11091 11098 11077 11090 11090 11077 11075 11119 11098 11090 11074 11073 11075 11074 11075 11076 11076 11075 11077 11101 11075 11073 11076 11077 11078 11078 11077 11079 11098 11079 11077 11106 11074 11076 11106 11076 11107 11107 11076 11078 11071 11073 11074 11106 11071 11074 11071 11072 11073 11101 11073 11072 11101 11072 11097 11122 11101 11097 11071 11070 11072 11097 11072 11070 11105 11071 11106 11123 11105 11106 11125 11106 11107 11130 11085 11105 11130 11105 11123 11123 11159 11160 11123 11160 11130 11129 11085 11130 11130 11160 11161 11135 11129 11130 11135 11130 11161 11141 11161 11160 11141 11160 11142 11142 11160 11159 11135 11161 11141 11112 11134 11135 11112 11135 11141 11134 11129 11135 11112 11141 11111 11111 11141 11142 11111 11102 11112 11112 11102 11100 11112 11100 11113 11113 11134 11112 11102 11086 11100 11100 11084 11092 11100 11086 11084 11113 11100 11114 11114 11100 11092 11114 11134 11113 11114 11092 11115 11115 11132 11114 11114 11132 11133 11114 11133 11134 11092 11082 11093 11092 11084 11082 11115 11092 11093 11081 11080 11082 11081 11082 11083 11083 11082 11084 11093 11082 11094 11094 11082 11080 11115 11093 11094 11094 11080 11099 11115 11094 11116 11116 11094 11099 11078 11079 11080 11078 11080 11081 11099 11080 11079 11103 11081 11083 11103 11078 11081 11107 11078 11108 11108 11078 11103 11125 11107 11126 11126 11107 11108 11126 11108 11103 11126 11103 11127 11126 11150 11151 11126 11152 11125 11127 11150 11126 11144 11152 11126 11144 11126 11151 11125 11152 11153 11143 11153 11152 11143 11152 11144 11119 11143 11144 11119 11144 11118 11118 11144 11137 11144 11151 11137 11137 11151 11150 11118 11137 11117 11117 11137 11138 11137 11150 11138 11117 11099 11118 11118 11099 11098 11118 11098 11119 11116 11099 11117 11117 11138 11116 11116 11138 11136 11138 11150 11165 11138 11165 11136 11116 11136 11115 11115 11136 11131 11136 11165 11127 11136 11127 11164 11136 11164 11131 11127 11165 11150 11127 11103 11128 11128 11164 11127 11131 11164 11128 11115 11131 11132 11131 11128 11132 11128 11103 11104 11128 11104 11129 11129 11162 11128 11128 11162 11163 11132 11128 11163 11103 11083 11104 11104 11083 11085 11129 11104 11085 11134 11162 11129 11133 11163 11162 11133 11162 11134 11132 11163 11133 11083 11084 11085 11085 11084 11086 11099 11079 11098 11166 11167 11168 11188 11187 11166 11166 11187 11167 11193 11188 11166 11193 11166 11194 11194 11166 11168 11186 11187 11188 11186 11188 11192 11192 11188 11193 11184 11185 11186 11186 11185 11187 11184 11186 11192 11182 11183 11184 11184 11183 11185 11190 11182 11184 11190 11184 11191 11191 11184 11192 11200 11187 11185 11200 11185 11201 11201 11185 11183 11182 11181 11183 11183 11181 11201 11180 11181 11182 11190 11180 11182 11180 11179 11181 11201 11181 11202 11181 11179 11202 11178 11179 11180 11178 11180 11189 11189 11180 11190 11178 11176 11179 11202 11179 11203 11203 11179 11176 11177 11176 11178 11198 11177 11178 11198 11178 11189 11175 11174 11176 11175 11176 11177 11203 11176 11204 11204 11176 11174 11175 11177 11197 11197 11177 11198 11173 11174 11175 11173 11175 11197 11173 11172 11174 11204 11174 11172 11171 11172 11173 11171 11173 11195 11195 11173 11196 11196 11173 11197 11171 11170 11172 11204 11172 11205 11172 11170 11205 11168 11170 11171 11168 11171 11195 11168 11169 11170 11205 11170 11206 11170 11169 11206 11168 11167 11169 11194 11168 11195 11169 11167 11206 11206 11167 11199 11199 11167 11187 11199 11187 11200 11201 11207 11200 11200 11208 11199 11192 11208 11200 11192 11200 11191 11191 11200 11207 11191 11207 11227 11227 11207 11201 11201 11202 11217 11227 11201 11190 11190 11201 11217 11227 11190 11191 11189 11190 11226 11190 11217 11226 11191 11347 11190 11347 11345 11190 11345 11343 11190 11190 11343 11189 11370 11191 11190 11371 11190 11189 11371 11356 11190 11190 11356 11357 11190 11357 11370 11226 11217 11202 11226 11202 11189 11203 11215 11202 11202 11215 11216 11189 11202 11216 11225 11216 11215 11225 11215 11224 11224 11215 11203 11189 11216 11225 11224 11189 11225 11224 11198 11189 11224 11203 11198 11204 11214 11203 11198 11203 11214 11205 11212 11204 11204 11212 11213 11223 11214 11204 11223 11204 11197 11197 11204 11213 11198 11214 11223 11223 11197 11198 11222 11196 11197 11197 11213 11222 11198 11338 11197 11197 11338 11336 11197 11336 11196 11374 11198 11197 11375 11197 11196 11375 11367 11197 11197 11367 11355 11197 11355 11374 11374 11355 11198 11354 11335 11355 11335 11337 11355 11337 11339 11355 11355 11339 11341 11341 11366 11355 11355 11367 11354 11198 11355 11366 11354 11367 11368 11375 11368 11367 11196 11354 11368 11196 11368 11376 11376 11368 11375 11375 11196 11376 11221 11195 11196 11222 11212 11196 11196 11212 11205 11196 11205 11221 11196 11336 11333 11196 11333 11195 11195 11353 11196 11196 11353 11354 11222 11213 11212 11353 11334 11354 11354 11334 11335 11331 11333 11334 11334 11333 11335 11353 11331 11334 11352 11331 11353 11353 11359 11352 11195 11359 11353 11329 11330 11331 11331 11330 11332 11331 11332 11333 11352 11329 11331 11350 11351 11329 11329 11351 11330 11350 11329 11358 11358 11329 11352 11332 11330 11194 11194 11330 11193 11193 11330 11351 11333 11332 11195 11195 11332 11194 11335 11333 11336 11335 11336 11337 11337 11336 11338 11337 11338 11339 11339 11338 11340 11340 11338 11198 11339 11340 11341 11341 11340 11342 11342 11340 11343 11189 11343 11340 11189 11340 11198 11373 11189 11198 11198 11366 11373 11372 11189 11373 11372 11341 11189 11189 11341 11364 11189 11364 11371 11373 11366 11365 11373 11365 11372 11341 11365 11366 11372 11365 11341 11341 11342 11344 11341 11344 11356 11356 11364 11341 11371 11364 11356 11356 11344 11346 11356 11346 11357 11342 11343 11344 11344 11343 11345 11344 11345 11346 11346 11345 11347 11346 11347 11348 11357 11346 11348 11348 11347 11349 11191 11349 11347 11348 11349 11350 11357 11348 11358 11348 11350 11358 11350 11349 11351 11351 11349 11192 11192 11349 11191 11370 11363 11191 11191 11363 11362 11191 11362 11192 11370 11357 11363 11357 11362 11363 11358 11362 11357 11192 11362 11358 11352 11360 11358 11358 11360 11361 11192 11358 11369 11369 11358 11361 11377 11360 11352 11377 11352 11194 11194 11352 11359 11378 11360 11377 11378 11361 11360 11369 11361 11193 11193 11361 11378 11369 11193 11192 11228 11192 11193 11228 11208 11192 11193 11351 11192 11193 11209 11228 11228 11209 11208 11199 11208 11209 11193 11199 11209 11199 11210 11206 11218 11210 11199 11218 11199 11193 11219 11206 11210 11219 11210 11218 11206 11211 11205 11220 11211 11206 11220 11206 11194 11194 11206 11219 11218 11194 11219 11218 11193 11194 11220 11194 11195 11377 11194 11378 11378 11194 11193 11194 11359 11195 11220 11195 11221 11221 11211 11220 11221 11205 11211 11229 11230 11231 11247 11248 11229 11229 11248 11249 11229 11249 11230 11265 11247 11229 11265 11229 11266 11266 11229 11231 11247 11246 11248 11255 11248 11250 11250 11248 11246 11255 11249 11248 11255 11230 11249 11257 11230 11255 11272 11257 11255 11272 11255 11273 11273 11255 11274 11274 11255 11250 11250 11246 11251 11274 11250 11275 11275 11250 11251 11275 11308 11274 11274 11308 11273 11273 11298 11272 11273 11308 11309 11273 11309 11298 11275 11313 11308 11313 11293 11308 11308 11293 11324 11308 11324 11309 11309 11324 11323 11309 11323 11298 11272 11298 11299 11298 11266 11299 11298 11323 11266 11266 11323 11293 11293 11323 11324 11292 11265 11293 11293 11265 11266 11313 11292 11293 11275 11312 11313 11312 11292 11313 11291 11270 11292 11292 11270 11265 11292 11325 11291 11312 11325 11292 11270 11247 11265 11269 11243 11270 11270 11243 11245 11270 11245 11247 11291 11269 11270 11245 11246 11247 11243 11244 11245 11245 11244 11246 11240 11242 11243 11243 11242 11244 11268 11240 11243 11268 11243 11269 11254 11246 11244 11254 11244 11252 11252 11244 11242 11251 11246 11254 11276 11251 11254 11276 11254 11277 11277 11254 11252 11252 11242 11253 11277 11252 11278 11278 11252 11253 11278 11300 11277 11277 11300 11301 11277 11301 11302 11277 11302 11276 11278 11253 11264 11278 11264 11279 11279 11294 11278 11294 11300 11278 11253 11242 11264 11264 11242 11241 11264 11241 11262 11279 11264 11262 11240 11241 11242 11240 11239 11241 11262 11241 11239 11262 11239 11263 11279 11262 11280 11280 11262 11263 11238 11237 11239 11238 11239 11240 11263 11239 11237 11268 11238 11240 11235 11237 11238 11271 11235 11238 11271 11238 11268 11235 11236 11237 11263 11237 11260 11260 11237 11236 11233 11234 11235 11235 11234 11236 11267 11233 11235 11267 11235 11271 11259 11236 11234 11260 11236 11261 11261 11236 11259 11281 11263 11260 11281 11260 11282 11282 11260 11261 11282 11261 11283 11283 11261 11259 11259 11234 11258 11283 11259 11258 11258 11232 11256 11258 11234 11232 11283 11258 11284 11284 11258 11256 11256 11232 11257 11284 11256 11285 11285 11256 11257 11285 11295 11284 11284 11295 11296 11284 11296 11283 11285 11257 11272 11272 11305 11285 11285 11305 11295 11257 11232 11230 11231 11230 11232 11231 11232 11233 11266 11231 11267 11267 11231 11233 11233 11232 11234 11286 11266 11267 11286 11267 11287 11287 11267 11271 11299 11266 11286 11287 11321 11286 11286 11321 11322 11299 11286 11322 11271 11319 11287 11287 11319 11320 11287 11320 11321 11305 11322 11321 11305 11321 11295 11295 11321 11320 11299 11322 11305 11272 11299 11305 11295 11320 11296 11296 11320 11297 11297 11320 11319 11283 11296 11297 11283 11297 11303 11297 11319 11303 11283 11303 11304 11283 11304 11282 11303 11319 11318 11303 11318 11304 11282 11304 11310 11304 11318 11317 11304 11317 11310 11282 11310 11281 11281 11310 11306 11310 11317 11316 11310 11316 11315 11310 11315 11306 11288 11316 11317 11288 11317 11271 11271 11317 11318 11271 11318 11319 11288 11271 11268 11288 11268 11289 11289 11315 11288 11288 11315 11316 11289 11314 11315 11306 11315 11314 11306 11314 11307 11307 11314 11289 11279 11306 11307 11279 11307 11294 11307 11289 11294 11280 11306 11279 11280 11263 11281 11281 11306 11280 11294 11289 11328 11294 11328 11327 11294 11327 11300 11289 11327 11328 11290 11327 11289 11300 11327 11290 11300 11290 11301 11289 11269 11290 11290 11269 11291 11301 11290 11291 11289 11268 11269 11291 11325 11326 11301 11291 11302 11302 11291 11326 11311 11326 11325 11311 11325 11312 11302 11326 11311 11276 11302 11311 11276 11311 11312 11276 11312 11275 11275 11251 11276 11379 11380 11381 11400 11380 11379 11425 11400 11379 11425 11379 11426 11426 11379 11381 11381 11380 11382 11381 11382 11383 11426 11381 11427 11427 11381 11383 11453 11425 11426 11453 11426 11427 11427 11383 11384 11427 11384 11428 11453 11427 11454 11427 11428 11454 11383 11382 11384 11384 11382 11385 11384 11385 11386 11428 11384 11386 11428 11386 11388 11428 11388 11429 11454 11428 11429 11386 11385 11387 11386 11387 11388 11420 11387 11385 11420 11385 11421 11421 11385 11382 11388 11387 11389 11419 11389 11387 11419 11387 11420 11388 11389 11401 11418 11401 11389 11418 11389 11419 11444 11418 11419 11444 11419 11420 11417 11401 11418 11443 11418 11444 11452 11417 11418 11452 11418 11443 11444 11463 11443 11443 11463 11452 11451 11417 11452 11452 11463 11464 11452 11464 11451 11444 11462 11463 11464 11463 11472 11472 11463 11462 11451 11464 11465 11464 11472 11473 11473 11465 11464 11450 11416 11451 11451 11416 11417 11451 11465 11450 11450 11465 11466 11466 11465 11470 11470 11465 11473 11472 11456 11473 11473 11456 11470 11471 11454 11472 11472 11454 11456 11472 11461 11471 11472 11462 11461 11454 11430 11456 11454 11429 11430 11471 11453 11454 11429 11402 11430 11430 11402 11403 11430 11403 11431 11456 11430 11431 11429 11388 11402 11388 11401 11402 11402 11401 11403 11403 11401 11404 11403 11404 11405 11431 11403 11405 11431 11405 11407 11431 11407 11432 11456 11431 11432 11405 11404 11406 11405 11406 11407 11417 11406 11404 11417 11404 11401 11407 11406 11408 11416 11408 11406 11416 11406 11417 11407 11408 11409 11432 11407 11409 11432 11409 11433 11433 11456 11432 11409 11408 11410 11409 11410 11390 11433 11409 11390 11415 11410 11408 11415 11408 11416 11449 11415 11416 11449 11416 11450 11414 11391 11415 11415 11391 11410 11442 11414 11415 11442 11415 11449 11390 11410 11391 11390 11391 11392 11433 11390 11392 11392 11391 11393 11414 11393 11391 11413 11393 11414 11441 11413 11414 11441 11414 11442 11392 11393 11394 11413 11394 11393 11412 11394 11413 11440 11412 11413 11440 11413 11441 11442 11468 11441 11441 11468 11440 11439 11412 11440 11440 11468 11469 11440 11469 11439 11411 11394 11412 11439 11411 11412 11438 11411 11439 11439 11469 11457 11439 11457 11438 11471 11457 11469 11471 11469 11470 11470 11469 11468 11442 11467 11468 11470 11468 11467 11470 11455 11471 11470 11456 11455 11470 11467 11466 11442 11466 11467 11449 11466 11442 11450 11466 11449 11455 11425 11453 11435 11455 11434 11434 11455 11456 11455 11435 11424 11455 11424 11425 11471 11455 11453 11434 11456 11433 11433 11392 11434 11434 11392 11435 11435 11392 11395 11435 11395 11396 11435 11396 11424 11424 11396 11398 11424 11398 11425 11395 11394 11396 11396 11394 11397 11396 11397 11398 11392 11394 11395 11411 11397 11394 11398 11397 11399 11411 11399 11397 11398 11399 11400 11425 11398 11400 11400 11399 11380 11423 11380 11399 11423 11399 11411 11437 11423 11411 11437 11411 11438 11422 11380 11423 11436 11423 11437 11436 11422 11423 11422 11382 11380 11421 11382 11422 11448 11421 11422 11448 11422 11436 11437 11458 11436 11436 11458 11459 11436 11459 11448 11447 11421 11448 11448 11459 11460 11448 11460 11447 11446 11420 11421 11446 11421 11447 11447 11460 11446 11446 11460 11461 11459 11471 11460 11471 11461 11460 11458 11471 11459 11437 11457 11458 11457 11471 11458 11438 11457 11437 11446 11461 11445 11445 11461 11444 11444 11461 11462 11445 11420 11446 11444 11420 11445 11474 11475 11476 11494 11493 11474 11474 11493 11475 11521 11494 11474 11521 11474 11476 11476 11475 11477 11476 11477 11478 11521 11476 11522 11522 11476 11478 11520 11494 11521 11549 11521 11522 11549 11520 11521 11492 11493 11494 11520 11492 11494 11519 11492 11520 11552 11520 11549 11552 11519 11520 11490 11491 11492 11492 11491 11493 11519 11490 11492 11530 11490 11519 11530 11519 11552 11489 11488 11490 11490 11488 11491 11530 11489 11490 11505 11491 11506 11506 11491 11488 11505 11493 11491 11506 11488 11507 11547 11505 11506 11547 11506 11548 11548 11506 11507 11507 11488 11508 11548 11507 11538 11538 11507 11508 11538 11563 11548 11548 11563 11564 11548 11564 11547 11546 11505 11547 11547 11564 11546 11546 11564 11553 11565 11553 11564 11565 11564 11563 11545 11505 11546 11546 11553 11545 11545 11553 11554 11553 11565 11554 11544 11518 11545 11545 11518 11505 11545 11554 11544 11518 11493 11505 11517 11475 11518 11518 11475 11493 11537 11517 11518 11537 11518 11544 11544 11554 11555 11544 11555 11537 11554 11565 11566 11554 11566 11555 11537 11555 11536 11536 11555 11556 11555 11566 11556 11536 11517 11537 11535 11516 11536 11536 11516 11517 11536 11556 11535 11535 11556 11557 11566 11557 11556 11534 11515 11535 11535 11515 11516 11535 11557 11534 11515 11479 11516 11516 11479 11477 11516 11477 11517 11514 11479 11515 11533 11514 11515 11533 11515 11534 11534 11557 11533 11532 11514 11533 11533 11557 11558 11533 11558 11532 11531 11514 11532 11532 11558 11559 11532 11559 11531 11567 11559 11558 11567 11558 11557 11531 11559 11543 11543 11559 11560 11567 11560 11559 11543 11512 11531 11531 11512 11513 11531 11513 11514 11542 11512 11543 11543 11560 11542 11542 11560 11561 11568 11560 11567 11568 11561 11560 11541 11511 11542 11542 11511 11512 11542 11561 11541 11541 11561 11540 11540 11561 11562 11561 11568 11562 11540 11511 11541 11539 11510 11540 11540 11510 11511 11540 11562 11539 11539 11562 11563 11568 11563 11562 11538 11509 11539 11539 11509 11510 11539 11563 11538 11509 11504 11510 11510 11504 11502 11510 11502 11511 11508 11486 11509 11509 11486 11504 11538 11508 11509 11503 11502 11504 11503 11504 11485 11485 11504 11486 11501 11500 11502 11501 11502 11503 11511 11502 11500 11528 11501 11503 11528 11503 11529 11529 11503 11485 11485 11486 11487 11529 11485 11487 11529 11487 11530 11528 11529 11551 11551 11529 11552 11552 11529 11530 11527 11501 11528 11551 11527 11528 11526 11498 11527 11527 11498 11499 11527 11499 11501 11551 11526 11527 11525 11496 11526 11526 11496 11498 11550 11525 11526 11550 11526 11551 11496 11497 11498 11498 11497 11499 11499 11497 11500 11499 11500 11501 11496 11495 11497 11511 11500 11497 11511 11497 11512 11512 11497 11495 11483 11495 11496 11525 11483 11496 11483 11484 11495 11512 11495 11513 11513 11495 11484 11481 11482 11483 11483 11482 11484 11525 11481 11483 11513 11484 11514 11514 11484 11482 11481 11479 11482 11514 11482 11479 11480 11479 11481 11524 11480 11481 11524 11481 11525 11550 11524 11525 11523 11480 11524 11550 11523 11524 11478 11479 11480 11523 11478 11480 11478 11477 11479 11522 11478 11523 11549 11523 11550 11523 11549 11522 11566 11549 11550 11566 11550 11567 11567 11550 11551 11565 11552 11549 11565 11549 11566 11566 11567 11557 11567 11551 11568 11568 11551 11552 11568 11552 11565 11568 11565 11563 11517 11477 11475 11530 11487 11489 11487 11486 11488 11487 11488 11489 11508 11488 11486 11569 11570 11571 11622 11621 11569 11569 11621 11570 11622 11569 11619 11619 11569 11615 11572 11569 11571 11569 11625 11615 11625 11569 11627 11627 11569 11572 11570 11621 11571 11620 11621 11622 11571 11621 11617 11617 11621 11620 11620 11622 11619 11619 11618 11620 11618 11617 11620 11617 11618 11619 11617 11619 11615 11615 11616 11617 11613 11617 11616 11607 11617 11613 11617 11637 11638 11617 11638 11571 11633 11617 11607 11637 11617 11633 11615 11614 11616 11616 11614 11613 11613 11614 11615 11608 11612 11615 11612 11613 11615 11631 11615 11625 11631 11608 11615 11611 11610 11612 11608 11609 11612 11609 11611 11612 11613 11612 11610 11609 11610 11611 11609 11607 11610 11607 11613 11610 11608 11607 11609 11606 11607 11608 11607 11606 11603 11607 11603 11599 11633 11607 11634 11634 11607 11599 11605 11606 11608 11606 11605 11603 11604 11603 11605 11604 11605 11608 11630 11604 11608 11630 11608 11631 11624 11604 11630 11646 11624 11630 11646 11630 11647 11648 11630 11631 11648 11677 11630 11630 11677 11678 11630 11678 11647 11646 11674 11624 11647 11679 11646 11646 11679 11674 11647 11678 11679 11678 11715 11716 11715 11678 11677 11679 11678 11716 11649 11676 11677 11649 11677 11648 11677 11676 11715 11648 11631 11649 11631 11676 11649 11631 11675 11676 11715 11676 11714 11676 11675 11714 11650 11631 11625 11650 11675 11631 11651 11673 11675 11651 11675 11650 11675 11713 11714 11675 11673 11713 11650 11625 11651 11673 11651 11625 11627 11691 11625 11625 11691 11673 11691 11712 11673 11673 11712 11713 11712 11745 11713 11713 11745 11714 11691 11711 11712 11712 11711 11710 11712 11710 11745 11627 11690 11691 11691 11690 11711 11709 11710 11711 11689 11688 11711 11688 11709 11711 11690 11689 11711 11652 11689 11690 11652 11690 11627 11654 11688 11689 11654 11689 11653 11653 11689 11652 11626 11687 11688 11626 11688 11654 11688 11687 11726 11726 11709 11688 11653 11626 11654 11652 11627 11653 11653 11627 11626 11576 11626 11572 11572 11626 11627 11576 11632 11626 11632 11687 11626 11572 11571 11573 11572 11573 11574 11574 11576 11572 11573 11571 11574 11574 11571 11575 11638 11575 11571 11574 11575 11576 11576 11575 11577 11579 11575 11581 11581 11575 11582 11575 11579 11577 11639 11582 11575 11639 11575 11641 11641 11575 11638 11576 11577 11578 11578 11577 11579 11578 11579 11580 11580 11579 11581 11581 11582 11583 11580 11581 11583 11576 11578 11580 11576 11580 11583 11632 11576 11583 11583 11582 11584 11583 11584 11587 11632 11583 11628 11628 11583 11587 11655 11632 11656 11656 11632 11628 11655 11687 11632 11656 11686 11655 11655 11686 11687 11628 11685 11656 11656 11685 11686 11686 11685 11720 11687 11686 11720 11687 11720 11725 11687 11725 11726 11719 11724 11720 11684 11719 11720 11720 11724 11725 11720 11685 11684 11628 11684 11685 11642 11683 11684 11642 11684 11628 11684 11683 11719 11642 11628 11629 11629 11683 11642 11629 11682 11683 11683 11682 11719 11643 11681 11682 11643 11682 11629 11682 11681 11718 11682 11718 11719 11643 11629 11644 11644 11681 11643 11623 11680 11681 11623 11681 11644 11681 11680 11717 11681 11717 11718 11644 11629 11623 11628 11587 11629 11629 11587 11591 11591 11598 11629 11629 11598 11623 11584 11586 11587 11587 11586 11588 11587 11588 11589 11587 11589 11590 11587 11590 11591 11584 11582 11585 11584 11585 11586 11586 11585 11588 11585 11582 11588 11592 11589 11588 11588 11582 11592 11590 11589 11591 11591 11589 11592 11591 11592 11593 11591 11595 11598 11593 11595 11591 11593 11594 11595 11593 11592 11594 11594 11592 11599 11636 11599 11592 11636 11592 11640 11640 11592 11582 11640 11582 11639 11666 11636 11640 11667 11640 11668 11668 11640 11639 11701 11666 11640 11701 11640 11667 11699 11636 11666 11699 11666 11700 11700 11666 11701 11701 11667 11670 11740 11700 11701 11740 11701 11670 11670 11667 11668 11668 11639 11669 11669 11670 11668 11670 11669 11702 11741 11740 11670 11732 11670 11702 11670 11732 11741 11739 11700 11740 11741 11739 11740 11739 11737 11700 11700 11737 11699 11738 11737 11739 11741 11751 11739 11782 11738 11739 11782 11739 11751 11751 11741 11732 11703 11731 11732 11703 11732 11702 11732 11731 11751 11702 11639 11703 11703 11639 11641 11703 11641 11704 11731 11703 11744 11744 11703 11704 11702 11669 11639 11704 11641 11671 11704 11671 11744 11657 11641 11638 11641 11657 11671 11657 11708 11671 11744 11671 11708 11657 11638 11658 11658 11708 11657 11659 11638 11637 11659 11706 11638 11638 11706 11707 11638 11707 11658 11658 11707 11708 11707 11742 11708 11744 11708 11742 11706 11742 11707 11637 11705 11706 11637 11706 11659 11706 11705 11742 11660 11637 11661 11661 11637 11633 11660 11705 11637 11660 11661 11692 11660 11692 11705 11692 11661 11693 11693 11661 11633 11662 11633 11634 11662 11698 11633 11633 11698 11693 11733 11729 11693 11733 11693 11698 11693 11729 11692 11705 11692 11729 11727 11728 11729 11727 11729 11733 11728 11705 11729 11728 11730 11705 11742 11705 11730 11744 11742 11730 11744 11730 11749 11749 11750 11744 11744 11750 11731 11802 11731 11750 11803 11804 11750 11750 11749 11803 11750 11804 11802 11802 11800 11731 11751 11731 11800 11800 11801 11751 11884 11801 11800 11884 11800 11885 11885 11800 11886 11886 11800 11802 11783 11782 11751 11751 11810 11783 11751 11801 11810 11883 11810 11801 11883 11801 11884 11905 11883 11884 11905 11884 11885 11905 11885 11886 11886 11802 11887 11887 11905 11886 11887 11802 11888 11888 11802 11804 11888 11907 11887 11887 11907 11905 11804 11901 11888 11901 11907 11888 11803 11901 11804 11803 11900 11901 11900 11907 11901 11803 11749 11785 11785 11898 11803 11803 11898 11899 11803 11899 11900 11900 11897 11907 11897 11900 11899 11897 11899 11898 11785 11897 11898 11749 11784 11785 11784 11896 11785 11785 11896 11897 11730 11787 11749 11784 11749 11787 11787 11894 11784 11784 11894 11895 11784 11895 11896 11896 11895 11897 11893 11895 11894 11893 11891 11895 11922 11895 11891 11922 11897 11895 11787 11893 11894 11730 11786 11787 11786 11893 11787 11788 11730 11728 11788 11786 11730 11788 11891 11786 11786 11891 11892 11786 11892 11893 11892 11891 11893 11788 11890 11891 11890 11908 11891 11891 11921 11922 11891 11908 11921 11805 11788 11728 11805 11890 11788 11805 11889 11890 11908 11890 11889 11805 11728 11790 11790 11889 11805 11857 11889 11790 11889 11857 11908 11789 11790 11728 11857 11790 11789 11857 11789 11858 11858 11860 11857 11908 11857 11929 11929 11857 11860 11792 11789 11728 11789 11792 11858 11858 11792 11859 11859 11860 11858 11791 11792 11727 11728 11727 11792 11859 11792 11791 11859 11791 11860 11806 11791 11727 11860 11791 11806 11733 11743 11727 11743 11806 11727 11806 11743 11807 11860 11806 11861 11861 11806 11862 11862 11806 11807 11743 11733 11735 11735 11748 11743 11794 11807 11743 11743 11748 11794 11697 11733 11698 11735 11733 11697 11734 11735 11672 11697 11672 11735 11734 11748 11735 11634 11672 11697 11634 11697 11662 11662 11697 11698 11634 11635 11672 11635 11696 11672 11734 11672 11696 11736 11734 11695 11696 11695 11734 11734 11736 11748 11635 11695 11696 11694 11695 11663 11663 11695 11635 11736 11695 11694 11737 11736 11694 11736 11737 11738 11795 11748 11736 11795 11736 11738 11694 11699 11737 11694 11665 11699 11699 11665 11636 11664 11636 11665 11694 11664 11665 11694 11663 11664 11663 11635 11664 11664 11635 11636 11635 11599 11636 11634 11599 11635 11598 11597 11599 11599 11600 11601 11599 11601 11598 11599 11597 11594 11602 11600 11599 11599 11603 11602 11596 11594 11597 11596 11597 11598 11595 11594 11596 11596 11598 11595 11601 11604 11598 11598 11604 11623 11601 11603 11604 11623 11604 11624 11601 11602 11603 11601 11600 11602 11645 11623 11624 11674 11680 11624 11624 11680 11645 11645 11680 11623 11680 11674 11717 11674 11679 11716 11674 11716 11717 11716 11722 11717 11717 11722 11718 11715 11746 11716 11722 11716 11752 11746 11752 11716 11714 11721 11715 11721 11746 11715 11752 11746 11758 11746 11721 11779 11779 11758 11746 11752 11758 11759 11752 11759 11760 11722 11752 11760 11817 11759 11758 11817 11758 11818 11818 11758 11779 11815 11760 11759 11815 11759 11816 11816 11759 11817 11904 11816 11817 11817 11818 11904 11818 11779 11819 11819 11822 11818 11904 11818 11917 11822 11917 11818 11819 11779 11820 11820 11822 11819 11820 11779 11757 11820 11757 11821 11821 11822 11820 11721 11756 11757 11721 11757 11779 11821 11757 11822 11757 11756 11822 11778 11756 11721 11778 11721 11714 11822 11756 11823 11823 11756 11778 11777 11778 11714 11823 11778 11824 11824 11778 11825 11825 11778 11777 11714 11745 11754 11714 11754 11777 11745 11710 11753 11754 11745 11755 11753 11755 11745 11828 11777 11754 11828 11754 11829 11754 11755 11829 11829 11755 11830 11830 11755 11753 11829 11826 11828 11829 11830 11826 11827 11777 11828 11828 11826 11827 11826 11777 11827 11825 11777 11826 11826 11824 11825 11914 11824 11826 11914 11826 11915 11826 11830 11915 11824 11822 11823 11914 11822 11824 11917 11822 11914 11939 11917 11940 11940 11917 11914 12014 11904 11917 12014 11917 11939 11939 11940 11941 12014 11939 12015 12015 11939 11941 11940 11914 11957 11941 11940 11957 11957 11914 11958 11941 11957 12016 11957 11958 12016 11958 11914 11959 12016 11958 12017 12017 11958 11959 12017 12005 12016 12016 12005 11941 12017 11959 12018 12018 11985 12017 12017 11985 11929 12017 11929 12005 12018 11959 11914 12018 11914 11970 12018 11970 11960 12018 11960 12019 12019 11908 12018 12018 11908 12009 12018 12009 11985 11908 11929 11985 11908 11985 12009 11929 11860 11924 11929 11924 11986 11929 11986 12005 11861 11863 11860 11860 11863 11924 11862 11863 11861 11862 11807 11863 11863 11807 11864 11864 11807 11794 11864 11794 11865 11863 11864 11865 11793 11794 11748 11865 11794 11866 11866 11794 11793 11866 11867 11865 11865 11867 11863 11866 11793 11867 11748 11796 11793 11867 11793 11868 11868 11793 11796 11795 11796 11748 11798 11796 11795 11798 11873 11796 11796 11873 11868 11867 11868 11873 11798 11872 11873 11867 11873 11871 11871 11873 11872 11797 11798 11795 11797 11871 11798 11798 11871 11872 11797 11795 11738 11799 11808 11797 11799 11797 11738 11808 11870 11797 11797 11870 11871 11874 11871 11870 11920 11871 11874 11920 11867 11871 11808 11869 11870 11869 11874 11870 11869 11808 11874 11874 11808 11799 11874 11799 11875 11874 11875 11876 11876 11878 11874 11920 11874 11925 11925 11874 11878 11875 11799 11809 11875 11809 11876 11876 11809 11877 11877 11878 11876 11781 11809 11782 11782 11809 11799 11877 11809 11781 11877 11781 11878 11781 11782 11783 11878 11781 11783 11799 11738 11782 11878 11783 11879 11879 11783 11880 11880 11783 11810 11879 11881 11878 11881 11879 11880 11880 11810 11881 11881 11810 11882 11882 11810 11883 11882 11906 11881 11881 11926 11878 11881 11906 11926 11926 11925 11878 11998 11925 11926 11998 11926 11999 12000 11926 12001 12001 11926 11906 12033 11999 11926 12033 11926 12000 11931 11925 11998 11931 11998 12034 12034 11998 11999 12034 11999 12033 12033 11930 12034 12034 11930 11931 12032 11951 12033 12033 11951 11952 12033 11952 11930 12033 12000 12032 12032 12000 12001 12032 12001 12031 12031 12001 11906 12031 11951 12032 11951 11902 11952 12031 11902 11951 11952 11902 11912 11952 11912 11930 11930 11912 11931 11912 11902 11847 11912 11847 11851 11851 11903 11912 11933 11912 11903 11969 11912 11933 11931 11912 11969 11932 11933 11934 11933 11903 11934 11932 11969 11933 11931 11969 11932 11932 11925 11931 11932 11934 12035 12035 12007 11932 11932 12007 11925 12035 11934 11935 11935 11934 11903 11935 11997 12035 12035 11997 12007 11925 12007 11997 11996 11920 11925 11996 11925 11997 11935 11996 11997 11935 11903 11936 11935 11936 12036 12036 11995 11935 11935 11995 11996 11995 11920 11996 12036 11920 11995 12036 11936 12037 12037 11920 12036 11936 11903 11909 11936 11909 11953 12037 11936 11953 12037 11953 11909 12037 11909 12038 12038 11994 12037 12037 11994 12004 12037 12004 11920 12038 11909 11938 11938 11993 12038 12038 11993 11994 11993 11920 11994 11920 12004 11994 11992 11920 11993 11938 11992 11993 11927 11867 11920 11992 11927 11920 11991 11927 11992 11991 11992 11938 12010 11927 11991 12010 11991 11938 11938 11954 12010 12010 11954 11913 12010 11913 12011 12011 11927 12010 11937 11913 11954 11938 11937 11954 11937 11938 11909 11937 11909 11913 11909 11856 11815 11909 11815 11913 11909 11903 11856 11851 11853 11903 11903 11853 11854 11855 11903 11854 11903 11855 11856 11852 11765 11853 11853 11765 11764 11853 11764 11854 11851 11852 11853 11854 11764 11763 11854 11763 11855 11855 11763 11762 11855 11762 11856 11723 11762 11763 11723 11763 11764 11747 11764 11765 11747 11723 11764 11747 11765 11766 11851 11766 11765 11851 11765 11852 11718 11723 11747 11718 11747 11719 11719 11747 11724 11724 11747 11766 11718 11722 11723 11723 11722 11761 11723 11761 11762 11722 11760 11761 11811 11761 11812 11812 11761 11813 11813 11761 11760 11811 11762 11761 11813 11760 11814 11814 11760 11815 11813 11815 11812 11815 11813 11814 11812 11856 11811 11812 11815 11856 11856 11762 11811 11816 11904 11815 11913 11815 11904 11913 11904 11955 11955 11904 11956 12012 11956 11904 12012 11904 12013 12013 11904 12014 12011 11913 12012 12012 11913 11955 12012 11955 11956 12013 11923 12012 12012 11923 12008 12012 12008 11990 12012 11990 12011 12014 11989 12013 12013 11989 11923 12015 11924 12014 12014 11924 11988 12014 11988 11989 11988 11924 11989 11989 11924 11923 11863 11923 11924 11986 11924 11987 12015 11987 11924 11941 11987 12015 11941 11986 11987 11941 12005 11986 11863 11927 11923 11923 11927 11990 11923 11990 12008 11867 11927 11863 12011 11990 11927 11724 11766 11767 11849 11767 11766 11849 11766 11850 11850 11766 11851 11768 11724 11767 11725 11724 11768 11848 11768 11767 11848 11767 11849 11849 11847 11848 11850 11851 11849 11849 11851 11847 11847 11768 11848 11725 11768 11769 11846 11769 11768 11846 11768 11847 11847 11902 11845 11847 11845 11846 11845 11769 11846 11725 11769 11770 11769 11845 11770 11845 11902 11844 11770 11845 11844 11844 11902 11843 11918 11843 11902 11968 11918 11902 11968 11902 12031 11843 11771 11844 11844 11771 11770 11770 11771 11725 11725 11771 11772 11842 11772 11771 11842 11771 11843 11726 11725 11772 11772 11773 11726 11840 11773 11772 11840 11772 11841 11841 11772 11842 11843 11841 11842 11841 11843 11840 11840 11843 11916 11916 11843 11918 11949 11918 11950 11966 11916 11918 11966 11918 11967 11950 11918 11968 11949 11967 11918 11949 11950 12030 12030 11950 12002 12002 11950 11968 12002 11968 12031 11906 11972 12002 12031 11906 12002 12030 12002 11972 12030 11972 11949 11972 11906 11973 11949 11972 11973 11905 11906 11883 11883 11906 11882 11973 11906 11905 11973 11905 11949 11974 11905 11907 11949 11905 12029 12029 11905 11974 12029 11966 11949 11949 11966 11967 12028 11916 12029 12029 11916 11966 12029 11974 12028 11974 11907 11975 12028 11974 11975 12027 11965 12028 11965 11916 12028 12028 11975 12027 11910 11840 11916 11963 11910 11916 11963 11916 11964 11964 11916 11965 12027 11964 11965 12027 11963 11964 11962 11910 11963 12025 11962 11963 12025 11963 12026 12026 11963 12027 12025 11910 11962 12024 11947 12025 12025 11947 11910 12026 12006 12025 12025 12006 11977 12025 11977 11928 12025 11928 12024 12027 11976 12026 12026 11976 12006 11977 12006 11976 11976 11907 11977 11977 11907 11928 12027 11907 11976 12027 11975 11907 11907 11897 11928 11928 11897 11922 11928 11922 11978 11978 12003 11928 12024 11928 12003 11948 12003 11978 11948 11978 12023 12023 11978 11922 12024 12003 11948 11948 11947 12024 11947 11948 11911 12023 11971 11948 11948 11971 11911 12022 11961 12023 12023 11961 11971 12023 11922 12022 11971 11961 11911 11919 11911 11961 12022 11919 11961 12021 11919 12022 12022 11922 11979 12022 11979 12021 11945 11944 12021 11944 11919 12021 12021 11979 11980 12021 11980 11945 11979 11922 11980 11980 11922 11921 11980 11921 11981 11945 11980 11981 11981 11921 11982 11945 11981 11982 11944 11945 11946 12020 11946 11945 11945 11982 12020 11944 11946 11919 11942 11915 11946 11946 11915 11919 12020 11942 11946 11943 11942 12020 12020 11982 11921 12020 11921 11943 11942 11943 11915 11830 11919 11915 11960 11914 11915 11943 11960 11915 11830 11834 11919 11919 11834 11911 11830 11753 11831 11830 11831 11832 11830 11832 11834 11776 11753 11710 11831 11753 11832 11832 11753 11833 11833 11753 11776 11834 11832 11833 11833 11776 11834 11710 11775 11776 11834 11776 11835 11835 11776 11775 11710 11709 11775 11709 11774 11775 11835 11775 11774 11835 11774 11836 11835 11836 11834 11709 11780 11774 11836 11774 11837 11837 11774 11780 11709 11726 11773 11709 11773 11780 11837 11780 11838 11838 11780 11839 11839 11780 11773 11836 11837 11838 11839 11840 11838 11838 11840 11836 11839 11773 11840 11836 11840 11910 11836 11910 11911 11947 11911 11910 11911 11834 11836 11970 11914 11960 12019 11960 11943 11943 11984 12019 12019 11984 11908 11943 11921 11983 11943 11983 11984 11983 11921 11984 11984 11921 11908 12039 12040 12041 12288 12310 12039 12039 12041 12288 12310 12312 12039 12040 12039 12313 12039 12312 12313 12041 12084 12288 12288 12084 12292 12288 12292 12293 12293 12310 12288 12293 12292 12294 12084 12297 12292 12292 12297 12298 12292 12298 12294 12293 12294 12295 12295 12310 12293 12295 12294 12296 12294 12298 12187 12294 12187 12296 12187 12298 12297 12185 12186 12187 12184 12187 12179 12185 12187 12184 12187 12297 12179 12186 12296 12187 12186 12185 12188 12185 12205 12190 12190 12188 12185 12205 12185 12184 12184 12179 12178 12301 12184 12178 12301 12205 12184 12178 12179 12180 12180 12211 12178 12301 12178 12211 12301 12211 12205 12210 12211 12212 12212 12211 12213 12213 12211 12215 12210 12205 12211 12300 12215 12211 12300 12211 12183 12211 12180 12183 12213 12280 12212 12212 12280 12210 12213 12215 12214 12214 12279 12213 12213 12279 12280 12210 12280 12281 12250 12281 12280 12250 12280 12254 12254 12280 12279 12214 12278 12279 12278 12259 12279 12279 12259 12254 12214 12215 12208 12208 12278 12214 12208 12277 12278 12259 12278 12277 12207 12208 12209 12208 12215 12209 12207 12277 12208 12207 12209 12223 12223 12277 12207 12223 12224 12225 12223 12209 12224 12225 12276 12223 12223 12276 12277 12225 12224 12219 12225 12219 12228 12228 12276 12225 12228 12219 12222 12222 12275 12228 12228 12275 12276 12222 12219 12218 12218 12274 12222 12222 12274 12275 12231 12276 12275 12274 12231 12275 12218 12273 12274 12273 12235 12274 12274 12235 12231 12218 12219 12220 12218 12220 12221 12221 12273 12218 12221 12272 12273 12237 12235 12273 12272 12236 12273 12273 12236 12237 12221 12226 12227 12221 12220 12226 12227 12272 12221 12227 12226 12216 12216 12272 12227 12216 12271 12272 12240 12272 12271 12272 12240 12236 12236 12139 12237 12238 12139 12236 12238 12236 12240 12140 12139 12238 12238 12240 12239 12140 12238 12239 12138 12139 12140 12138 12140 12141 12141 12140 12142 12239 12142 12140 12142 12239 12240 12141 12142 12143 12143 12142 12144 12144 12142 12145 12240 12145 12142 12143 12193 12141 12193 12197 12141 12141 12197 12138 12144 12193 12143 12144 12145 12146 12146 12192 12144 12144 12192 12193 12146 12145 12147 12145 12240 12147 12146 12147 12148 12148 12191 12146 12146 12191 12192 12191 12193 12192 12150 12190 12191 12150 12191 12148 12191 12190 12217 12217 12226 12191 12226 12193 12191 12148 12147 12149 12148 12149 12150 12150 12149 12151 12150 12151 12152 12152 12190 12150 12189 12190 12152 12205 12217 12190 12190 12189 12188 12152 12151 12153 12152 12153 12154 12152 12154 12189 12189 12154 12156 12189 12156 12188 12188 12156 12186 12154 12155 12156 12156 12155 12157 12156 12157 12158 12156 12158 12186 12154 12153 12155 12246 12157 12155 12246 12155 12247 12247 12155 12153 12158 12157 12159 12245 12159 12157 12245 12157 12246 12246 12247 12243 12246 12243 12245 12247 12153 12248 12247 12242 12243 12248 12242 12247 12248 12153 12151 12248 12151 12242 12242 12151 12149 12242 12149 12147 12147 12240 12241 12147 12241 12242 12240 12271 12242 12241 12240 12242 12271 12243 12242 12204 12283 12271 12204 12271 12216 12283 12243 12271 12204 12205 12206 12216 12217 12204 12204 12217 12205 12206 12283 12204 12206 12282 12283 12282 12243 12283 12206 12205 12210 12210 12282 12206 12210 12281 12282 12281 12250 12282 12282 12250 12243 12250 12249 12243 12251 12249 12250 12251 12250 12252 12252 12250 12254 12252 12253 12251 12249 12251 12311 12253 12311 12251 12254 12255 12252 12252 12255 12253 12254 12256 12255 12254 12259 12256 12315 12255 12316 12316 12255 12256 12315 12317 12255 12317 12253 12255 12317 12311 12253 12313 12311 12317 12314 12317 12315 12314 12313 12317 12315 12316 12306 12315 12306 12314 12316 12256 12258 12307 12316 12258 12306 12316 12307 12256 12259 12258 12257 12258 12259 12307 12258 12257 12284 12306 12307 12284 12307 12289 12307 12257 12289 12043 12306 12286 12286 12306 12284 12314 12306 12043 12284 12285 12286 12289 12290 12284 12284 12290 12291 12284 12291 12285 12047 12097 12289 12289 12097 12290 12289 12257 12047 12097 12169 12290 12290 12175 12291 12175 12290 12169 12175 12174 12291 12291 12174 12285 12168 12174 12175 12168 12175 12169 12173 12174 12168 12173 12177 12174 12285 12174 12086 12177 12086 12174 12168 12169 12170 12173 12168 12299 12299 12168 12303 12303 12168 12170 12176 12177 12173 12173 12299 12215 12173 12215 12176 12209 12215 12299 12209 12299 12303 12209 12303 12167 12167 12303 12172 12303 12171 12172 12303 12170 12171 12224 12209 12164 12209 12167 12164 12219 12224 12304 12304 12224 12163 12163 12224 12162 12224 12164 12162 12201 12302 12219 12201 12219 12202 12219 12302 12220 12219 12304 12202 12202 12304 12203 12304 12163 12203 12137 12201 12202 12137 12202 12126 12126 12202 12128 12202 12203 12128 12128 12203 12130 12130 12203 12163 12127 12126 12128 12127 12128 12129 12129 12128 12130 12125 12126 12127 12125 12137 12126 12125 12136 12137 12201 12137 12136 12135 12136 12125 12127 12233 12125 12125 12233 12234 12125 12234 12135 12135 12134 12136 12134 12199 12136 12201 12136 12199 12199 12302 12201 12199 12134 12200 12220 12302 12199 12220 12199 12200 12133 12132 12134 12133 12134 12135 12200 12134 12132 12200 12132 12196 12196 12220 12200 12198 12226 12220 12198 12220 12195 12195 12220 12196 12194 12195 12196 12194 12196 12132 12131 12132 12133 12139 12194 12132 12139 12132 12131 12194 12138 12195 12194 12139 12138 12138 12198 12195 12138 12197 12198 12226 12198 12193 12193 12198 12197 12216 12226 12217 12237 12139 12131 12237 12131 12133 12237 12133 12235 12135 12235 12133 12234 12235 12135 12232 12231 12235 12232 12235 12233 12233 12235 12234 12231 12232 12127 12127 12232 12233 12129 12229 12231 12129 12231 12127 12231 12230 12276 12229 12230 12231 12102 12229 12129 12129 12130 12102 12229 12102 12230 12230 12102 12104 12230 12104 12262 12276 12230 12264 12262 12264 12230 12276 12264 12277 12259 12277 12270 12264 12270 12277 12257 12259 12260 12260 12259 12270 12260 12261 12257 12047 12257 12046 12257 12261 12124 12046 12257 12124 12270 12118 12260 12260 12118 12120 12260 12120 12261 12261 12120 12122 12261 12122 12124 12122 12123 12124 12124 12123 12044 12044 12046 12124 12044 12045 12046 12046 12045 12047 12050 12049 12044 12044 12049 12045 12089 12050 12044 12089 12044 12123 12047 12045 12048 12100 12048 12045 12100 12045 12090 12090 12045 12049 12047 12048 12053 12053 12048 12054 12096 12054 12048 12096 12048 12100 12053 12098 12047 12047 12098 12097 12053 12054 12055 12098 12053 12055 12096 12097 12098 12096 12098 12093 12098 12099 12093 12098 12055 12099 12097 12096 12100 12093 12054 12096 12097 12100 12101 12169 12097 12101 12101 12100 12089 12089 12123 12101 12169 12101 12123 12170 12169 12161 12169 12123 12161 12122 12121 12123 12161 12123 12121 12170 12161 12121 12170 12121 12171 12120 12119 12121 12120 12121 12122 12171 12121 12119 12171 12119 12172 12118 12117 12119 12118 12119 12120 12172 12119 12117 12172 12117 12115 12172 12115 12167 12116 12115 12117 12116 12117 12118 12270 12116 12118 12114 12115 12116 12269 12114 12116 12269 12116 12270 12114 12113 12115 12167 12115 12113 12111 12165 12167 12167 12113 12111 12164 12167 12165 12112 12111 12113 12112 12113 12114 12268 12112 12114 12268 12114 12269 12269 12270 12268 12268 12270 12264 12267 12112 12268 12268 12264 12266 12267 12268 12266 12110 12111 12112 12267 12110 12112 12266 12110 12267 12265 12108 12266 12266 12108 12110 12265 12266 12264 12263 12106 12264 12264 12106 12265 12264 12262 12263 12265 12106 12108 12106 12107 12108 12108 12107 12109 12108 12109 12110 12110 12109 12111 12165 12109 12107 12109 12165 12111 12106 12105 12107 12164 12107 12105 12107 12164 12166 12107 12166 12165 12164 12165 12166 12105 12162 12164 12104 12103 12105 12104 12105 12106 12103 12162 12105 12162 12103 12163 12102 12103 12104 12163 12103 12130 12102 12130 12103 12262 12104 12263 12263 12104 12106 12089 12090 12091 12089 12100 12090 12091 12050 12089 12091 12090 12092 12090 12049 12092 12092 12095 12091 12095 12050 12091 12049 12050 12051 12095 12051 12050 12049 12051 12052 12092 12049 12052 12093 12095 12092 12092 12052 12093 12093 12094 12095 12094 12051 12095 12052 12051 12056 12094 12056 12051 12052 12056 12054 12093 12052 12054 12093 12099 12094 12099 12056 12094 12054 12056 12055 12099 12055 12056 12176 12215 12300 12183 12182 12176 12176 12182 12177 12300 12183 12176 12180 12182 12183 12180 12181 12182 12305 12177 12182 12305 12182 12181 12086 12177 12305 12086 12305 12087 12087 12305 12085 12085 12305 12181 12180 12179 12181 12181 12179 12085 12083 12084 12085 12084 12087 12085 12297 12083 12085 12179 12297 12085 12086 12087 12088 12088 12087 12084 12285 12086 12287 12086 12088 12287 12042 12287 12088 12042 12088 12041 12041 12088 12084 12084 12083 12297 12041 12040 12042 12042 12040 12043 12286 12287 12042 12042 12043 12286 12286 12285 12287 12043 12040 12314 12040 12313 12314 12313 12312 12311 12310 12249 12312 12312 12249 12311 12295 12309 12310 12308 12310 12309 12310 12244 12249 12310 12308 12244 12249 12244 12243 12243 12244 12245 12244 12159 12245 12160 12159 12244 12244 12308 12160 12070 12308 12067 12067 12308 12309 12160 12308 12070 12067 12309 12295 12295 12296 12067 12066 12067 12068 12067 12066 12069 12067 12069 12070 12067 12296 12074 12067 12074 12068 12070 12069 12060 12070 12060 12160 12060 12069 12061 12066 12075 12069 12069 12075 12079 12069 12079 12061 12060 12061 12062 12060 12062 12071 12071 12073 12060 12060 12073 12160 12062 12061 12059 12062 12059 12063 12063 12071 12062 12071 12072 12073 12072 12071 12077 12063 12077 12071 12063 12059 12058 12058 12077 12063 12072 12077 12078 12077 12081 12078 12065 12081 12077 12065 12077 12058 12057 12058 12059 12057 12065 12058 12057 12064 12065 12064 12081 12065 12078 12081 12082 12082 12081 12076 12068 12076 12081 12068 12081 12064 12057 12068 12064 12066 12068 12057 12068 12074 12076 12074 12075 12076 12082 12076 12075 12066 12082 12075 12057 12078 12082 12057 12082 12066 12059 12078 12057 12061 12072 12059 12059 12072 12078 12061 12079 12072 12073 12072 12079 12073 12079 12080 12080 12079 12074 12074 12079 12075 12296 12080 12074 12158 12080 12186 12186 12080 12296 12073 12080 12158 12160 12073 12158 12158 12159 12160 12318 12319 12320 12318 12321 12319 12579 12321 12318 12579 12318 12580 12580 12318 12320 12319 12327 12320 12320 12327 12328 12580 12320 12581 12581 12320 12328 12579 12580 12597 12581 12596 12580 12580 12596 12597 12581 12328 12582 12582 12596 12581 12328 12327 12329 12328 12329 12570 12582 12328 12570 12570 12592 12582 12582 12592 12596 12592 12584 12596 12596 12584 12583 12596 12583 12597 12592 12588 12584 12595 12588 12592 12570 12571 12592 12571 12595 12592 12570 12329 12571 12571 12329 12334 12571 12334 12572 12572 12595 12571 12595 12589 12588 12594 12589 12595 12594 12595 12573 12573 12595 12572 12587 12584 12588 12589 12587 12588 12593 12587 12589 12594 12593 12589 12599 12593 12594 12574 12594 12573 12574 12599 12594 12572 12333 12573 12573 12333 12330 12573 12330 12574 12572 12334 12333 12333 12331 12330 12334 12335 12333 12333 12335 12331 12330 12331 12332 12574 12330 12332 12574 12332 12326 12574 12326 12575 12575 12599 12574 12332 12331 12326 12326 12325 12322 12326 12331 12325 12575 12326 12576 12576 12326 12322 12575 12576 12599 12576 12322 12577 12577 12598 12576 12576 12598 12599 12322 12323 12324 12322 12325 12323 12577 12322 12324 12577 12324 12578 12578 12598 12577 12324 12323 12321 12578 12324 12321 12388 12321 12323 12325 12435 12323 12323 12435 12436 12323 12436 12388 12387 12319 12321 12387 12321 12388 12578 12321 12579 12579 12598 12578 12579 12597 12598 12597 12583 12585 12597 12585 12598 12598 12585 12590 12598 12590 12591 12599 12598 12591 12583 12584 12585 12585 12584 12586 12590 12585 12586 12591 12590 12586 12591 12586 12587 12593 12591 12587 12599 12591 12593 12586 12584 12587 12388 12436 12437 12388 12437 12387 12436 12465 12437 12465 12436 12466 12466 12436 12435 12435 12494 12466 12466 12494 12496 12496 12470 12466 12466 12470 12471 12466 12471 12465 12325 12434 12435 12434 12494 12435 12389 12325 12331 12389 12434 12325 12389 12433 12434 12433 12494 12434 12331 12432 12389 12389 12432 12433 12390 12331 12335 12390 12431 12331 12331 12431 12432 12433 12432 12493 12493 12432 12492 12492 12432 12431 12433 12493 12494 12495 12494 12493 12492 12486 12493 12493 12486 12487 12493 12487 12495 12494 12468 12467 12494 12467 12496 12495 12468 12494 12495 12487 12488 12495 12488 12468 12486 12452 12487 12487 12452 12453 12487 12453 12488 12453 12468 12488 12454 12467 12468 12454 12468 12453 12455 12467 12454 12455 12469 12467 12496 12467 12469 12496 12469 12470 12456 12469 12455 12469 12456 12470 12454 12427 12455 12455 12427 12426 12455 12426 12456 12456 12426 12425 12456 12425 12424 12456 12424 12457 12470 12456 12457 12457 12471 12470 12457 12424 12423 12457 12423 12458 12458 12471 12457 12366 12423 12424 12366 12424 12365 12365 12424 12425 12365 12425 12426 12365 12360 12358 12365 12358 12366 12365 12426 12360 12366 12358 12357 12366 12357 12367 12423 12366 12367 12423 12367 12422 12458 12423 12422 12458 12422 12459 12459 12471 12458 12422 12367 12421 12459 12422 12421 12367 12357 12356 12421 12367 12356 12355 12356 12357 12357 12358 12355 12355 12354 12356 12368 12356 12354 12368 12420 12356 12356 12420 12421 12459 12421 12460 12460 12421 12420 12460 12472 12459 12459 12472 12471 12460 12420 12419 12460 12419 12461 12472 12460 12473 12461 12473 12460 12368 12419 12420 12368 12418 12419 12461 12419 12418 12461 12418 12417 12461 12417 12462 12461 12474 12473 12462 12474 12461 12472 12473 12497 12497 12473 12474 12462 12475 12474 12497 12474 12500 12500 12474 12475 12462 12417 12416 12462 12416 12463 12463 12475 12462 12463 12476 12475 12500 12475 12476 12497 12500 12489 12489 12500 12476 12489 12465 12497 12465 12472 12497 12437 12465 12489 12465 12471 12472 12387 12437 12319 12319 12437 12438 12437 12489 12438 12386 12327 12319 12319 12438 12439 12319 12439 12386 12438 12489 12439 12386 12439 12428 12439 12489 12490 12439 12490 12428 12386 12428 12327 12329 12327 12335 12385 12335 12327 12327 12428 12385 12329 12335 12334 12385 12430 12335 12335 12430 12390 12385 12428 12429 12385 12429 12430 12429 12428 12430 12390 12430 12431 12428 12491 12430 12430 12491 12492 12430 12492 12431 12428 12490 12491 12491 12499 12492 12490 12501 12491 12491 12501 12502 12491 12502 12499 12492 12503 12486 12492 12499 12503 12502 12482 12499 12499 12482 12483 12499 12483 12503 12501 12481 12502 12502 12481 12482 12446 12482 12481 12446 12483 12482 12447 12483 12446 12448 12483 12447 12483 12448 12484 12503 12483 12484 12446 12402 12447 12447 12402 12401 12447 12401 12448 12448 12401 12400 12448 12400 12399 12448 12399 12449 12449 12484 12448 12449 12485 12484 12503 12484 12485 12449 12399 12398 12449 12398 12450 12450 12485 12449 12373 12398 12399 12373 12399 12400 12373 12400 12372 12372 12400 12401 12372 12344 12373 12373 12344 12345 12373 12345 12374 12374 12398 12373 12398 12374 12397 12450 12398 12397 12450 12397 12451 12451 12485 12450 12397 12375 12396 12397 12374 12375 12451 12397 12396 12374 12345 12340 12374 12340 12375 12375 12340 12339 12375 12339 12376 12376 12396 12375 12376 12395 12396 12451 12396 12452 12452 12396 12395 12451 12486 12485 12486 12451 12452 12452 12395 12394 12452 12394 12453 12376 12394 12395 12376 12339 12377 12377 12394 12376 12394 12377 12393 12453 12394 12393 12453 12393 12392 12453 12392 12454 12393 12378 12392 12393 12377 12378 12377 12339 12338 12377 12338 12378 12378 12338 12337 12378 12337 12379 12391 12392 12378 12378 12379 12391 12454 12392 12391 12454 12391 12427 12391 12379 12427 12379 12337 12360 12427 12379 12426 12426 12379 12360 12336 12337 12338 12337 12336 12360 12359 12358 12360 12360 12336 12359 12336 12518 12359 12518 12336 12513 12338 12513 12336 12359 12534 12358 12534 12359 12518 12358 12521 12355 12521 12358 12534 12522 12521 12534 12522 12534 12517 12517 12534 12518 12517 12518 12512 12512 12518 12513 12512 12560 12517 12560 12558 12517 12517 12558 12557 12517 12557 12522 12520 12521 12522 12522 12557 12556 12522 12556 12520 12552 12556 12557 12552 12557 12558 12558 12560 12552 12559 12560 12561 12561 12560 12562 12559 12564 12560 12560 12564 12565 12560 12565 12566 12552 12560 12567 12567 12560 12566 12514 12562 12560 12514 12560 12512 12545 12566 12565 12545 12565 12508 12508 12565 12564 12540 12567 12566 12540 12566 12545 12542 12552 12567 12542 12567 12540 12540 12541 12542 12545 12546 12540 12540 12546 12547 12540 12547 12541 12508 12549 12545 12545 12549 12546 12549 12341 12546 12347 12547 12546 12347 12546 12343 12343 12546 12341 12547 12347 12541 12346 12347 12348 12364 12348 12347 12364 12347 12343 12346 12541 12347 12341 12342 12343 12343 12342 12344 12371 12364 12343 12371 12343 12344 12341 12549 12342 12344 12342 12345 12342 12548 12507 12342 12507 12345 12548 12342 12549 12384 12371 12344 12384 12344 12372 12402 12384 12401 12401 12384 12372 12402 12371 12384 12403 12371 12402 12446 12403 12402 12371 12403 12404 12446 12404 12403 12445 12404 12446 12446 12481 12445 12371 12404 12364 12364 12404 12405 12445 12405 12404 12383 12348 12364 12364 12405 12406 12406 12383 12364 12445 12406 12405 12407 12383 12406 12444 12407 12406 12444 12406 12445 12382 12348 12383 12408 12383 12407 12408 12382 12383 12444 12408 12407 12443 12408 12444 12444 12479 12443 12479 12444 12480 12480 12444 12445 12409 12382 12408 12443 12409 12408 12382 12363 12348 12382 12409 12363 12363 12409 12410 12442 12410 12409 12442 12409 12443 12443 12478 12442 12443 12479 12478 12441 12410 12442 12442 12478 12441 12411 12381 12410 12410 12381 12363 12441 12411 12410 12363 12351 12348 12381 12351 12363 12381 12370 12351 12412 12381 12411 12412 12370 12381 12440 12412 12411 12440 12411 12441 12441 12477 12440 12441 12478 12477 12413 12412 12440 12464 12413 12440 12477 12464 12440 12413 12370 12412 12370 12362 12351 12362 12370 12413 12362 12413 12414 12464 12414 12413 12463 12414 12464 12464 12476 12463 12476 12464 12477 12498 12476 12477 12498 12477 12478 12489 12476 12498 12489 12498 12490 12490 12498 12478 12490 12478 12479 12490 12479 12501 12501 12479 12480 12501 12480 12481 12445 12481 12480 12463 12416 12415 12463 12415 12414 12380 12415 12416 12380 12416 12353 12417 12353 12416 12380 12414 12415 12362 12414 12380 12380 12353 12362 12353 12361 12362 12362 12361 12349 12362 12349 12351 12349 12350 12351 12349 12537 12536 12349 12536 12350 12537 12349 12527 12361 12527 12349 12351 12350 12348 12348 12350 12346 12350 12539 12544 12539 12350 12536 12544 12346 12350 12535 12536 12526 12526 12536 12537 12535 12539 12536 12526 12537 12527 12526 12527 12528 12528 12553 12526 12526 12553 12568 12526 12568 12535 12538 12539 12535 12535 12568 12569 12535 12569 12538 12538 12544 12539 12538 12543 12544 12543 12346 12544 12542 12543 12538 12538 12569 12552 12538 12552 12542 12555 12552 12569 12555 12569 12568 12553 12555 12568 12553 12554 12555 12528 12554 12553 12550 12552 12555 12510 12550 12555 12510 12555 12523 12523 12555 12554 12550 12551 12552 12551 12556 12552 12509 12551 12550 12509 12550 12510 12520 12556 12551 12520 12551 12509 12509 12510 12511 12511 12519 12509 12509 12519 12520 12520 12519 12521 12511 12354 12519 12355 12519 12354 12519 12355 12521 12510 12525 12511 12354 12511 12525 12352 12353 12354 12368 12354 12369 12369 12354 12353 12354 12525 12352 12510 12524 12525 12524 12352 12525 12353 12352 12361 12352 12524 12530 12352 12530 12361 12417 12369 12353 12368 12369 12418 12418 12369 12417 12361 12529 12527 12529 12361 12530 12523 12529 12530 12523 12530 12524 12523 12524 12510 12528 12529 12523 12523 12554 12528 12528 12527 12529 12542 12541 12543 12346 12543 12541 12508 12548 12549 12506 12507 12508 12507 12548 12508 12508 12564 12506 12504 12505 12506 12506 12505 12507 12506 12564 12559 12506 12559 12504 12505 12345 12507 12504 12532 12505 12532 12345 12505 12531 12532 12504 12504 12559 12561 12504 12561 12531 12531 12533 12532 12533 12340 12532 12532 12340 12345 12516 12533 12531 12531 12561 12563 12531 12563 12516 12561 12562 12563 12516 12563 12562 12514 12515 12516 12516 12515 12533 12516 12562 12514 12515 12338 12533 12338 12340 12533 12338 12339 12340 12338 12515 12513 12514 12513 12515 12512 12513 12514 12503 12485 12486 12600 12601 12602 12621 12600 12622 12622 12600 12602 12634 12601 12600 12634 12600 12621 12637 12634 12621 12637 12621 12649 12621 12622 12649 12622 12602 12608 12622 12608 12623 12648 12622 12623 12649 12622 12648 12615 12637 12649 12615 12649 12616 12616 12649 12648 12636 12634 12637 12615 12636 12637 12615 12601 12614 12616 12601 12615 12614 12638 12615 12615 12638 12636 12616 12602 12601 12619 12602 12616 12616 12648 12619 12614 12601 12613 12633 12613 12601 12633 12601 12634 12614 12613 12612 12612 12638 12614 12605 12612 12613 12631 12605 12613 12631 12613 12632 12632 12613 12633 12612 12605 12610 12610 12640 12612 12612 12640 12639 12612 12639 12638 12640 12629 12639 12641 12629 12640 12610 12641 12640 12639 12629 12635 12639 12635 12638 12638 12633 12636 12638 12635 12633 12631 12635 12629 12635 12631 12632 12635 12632 12633 12633 12634 12636 12630 12605 12631 12629 12630 12631 12629 12603 12630 12630 12603 12605 12603 12604 12605 12610 12605 12604 12628 12604 12603 12628 12603 12629 12627 12604 12628 12644 12628 12641 12641 12628 12629 12627 12628 12644 12645 12627 12644 12611 12644 12610 12610 12644 12641 12611 12645 12644 12610 12604 12611 12611 12607 12620 12611 12604 12607 12620 12645 12611 12642 12625 12645 12645 12625 12627 12620 12642 12645 12620 12607 12617 12617 12642 12620 12642 12643 12625 12617 12643 12642 12617 12609 12618 12617 12607 12609 12618 12647 12617 12617 12647 12646 12617 12646 12643 12646 12625 12643 12647 12625 12646 12647 12623 12625 12648 12623 12647 12618 12648 12647 12618 12609 12602 12618 12602 12619 12619 12648 12618 12608 12602 12609 12623 12608 12609 12623 12609 12624 12624 12625 12623 12624 12609 12625 12609 12607 12625 12625 12607 12626 12626 12627 12625 12606 12607 12604 12626 12607 12606 12626 12606 12627 12627 12606 12604 12650 12651 12652 12652 12654 12650 12659 12651 12650 12659 12650 12660 12660 12650 12661 12661 12650 12654 12661 12654 12652 12661 12652 12656 12656 12662 12661 12661 12662 12663 12661 12663 12660 12667 12664 12660 12660 12664 12659 12660 12663 12667 12662 12669 12663 12663 12669 12667 12657 12666 12662 12657 12662 12656 12662 12668 12669 12666 12668 12662 12656 12652 12657 12657 12652 12653 12657 12653 12658 12658 12666 12657 12658 12665 12666 12665 12672 12666 12666 12672 12668 12658 12653 12655 12658 12655 12651 12658 12651 12659 12659 12665 12658 12651 12653 12652 12653 12651 12655 12659 12664 12665 12664 12671 12665 12665 12671 12672 12667 12670 12664 12664 12670 12671 12686 12667 12687 12687 12667 12688 12688 12667 12689 12689 12667 12669 12686 12670 12667 12688 12702 12687 12687 12702 12701 12687 12701 12686 12689 12703 12688 12703 12702 12688 12689 12669 12690 12690 12704 12689 12689 12704 12703 12690 12669 12693 12693 12669 12694 12694 12669 12668 12693 12705 12690 12705 12704 12690 12673 12703 12704 12704 12705 12673 12702 12703 12673 12673 12701 12702 12673 12674 12675 12674 12673 12676 12675 12700 12673 12700 12701 12673 12673 12705 12706 12673 12706 12676 12693 12706 12705 12676 12706 12707 12693 12694 12706 12694 12707 12706 12707 12708 12676 12694 12708 12707 12676 12708 12677 12677 12708 12694 12677 12668 12678 12694 12668 12677 12678 12676 12677 12678 12668 12679 12679 12668 12672 12679 12709 12678 12709 12676 12678 12679 12672 12680 12680 12710 12679 12679 12710 12709 12680 12672 12681 12681 12672 12671 12681 12674 12680 12674 12710 12680 12676 12709 12710 12676 12710 12674 12674 12695 12675 12681 12695 12674 12681 12671 12682 12682 12695 12681 12695 12696 12675 12696 12695 12682 12682 12671 12683 12683 12696 12682 12696 12697 12675 12697 12696 12683 12683 12671 12684 12684 12697 12683 12684 12675 12697 12684 12671 12685 12685 12675 12684 12671 12670 12685 12685 12670 12691 12691 12698 12685 12698 12675 12685 12691 12670 12692 12692 12670 12686 12692 12699 12691 12691 12699 12698 12675 12698 12699 12675 12699 12700 12692 12700 12699 12686 12700 12692 12701 12700 12686 12711 12712 12713 12714 12715 12711 12715 12712 12711 12711 12713 12722 12731 12714 12711 12731 12711 12722 12731 12715 12714 12723 12718 12715 12726 12715 12718 12726 12712 12715 12731 12723 12715 12732 12723 12731 12741 12732 12731 12741 12731 12742 12742 12731 12722 12732 12718 12723 12732 12725 12718 12725 12732 12739 12739 12732 12741 12741 12735 12734 12741 12734 12739 12742 12735 12741 12742 12722 12743 12743 12736 12742 12742 12736 12735 12726 12734 12735 12726 12735 12736 12730 12733 12734 12730 12734 12726 12739 12734 12738 12738 12734 12733 12738 12725 12739 12724 12725 12738 12740 12724 12738 12738 12733 12737 12738 12737 12740 12729 12727 12733 12729 12733 12730 12727 12737 12733 12740 12737 12727 12740 12721 12724 12743 12721 12740 12740 12727 12743 12727 12713 12712 12727 12712 12728 12729 12720 12727 12727 12720 12713 12743 12727 12728 12729 12717 12720 12730 12717 12729 12719 12713 12720 12720 12717 12716 12724 12719 12720 12724 12720 12716 12716 12717 12718 12730 12718 12717 12726 12718 12730 12725 12716 12718 12725 12724 12716 12719 12724 12721 12721 12713 12719 12713 12721 12722 12743 12722 12721 12743 12728 12736 12726 12728 12712 12726 12736 12728 12744 12745 12746 12744 12746 12747 12756 12757 12744 12744 12757 12745 12763 12756 12744 12763 12744 12764 12764 12744 12747 12747 12746 12752 12747 12752 12753 12764 12747 12753 12753 12752 12760 12772 12760 12752 12772 12752 12773 12773 12752 12746 12753 12760 12754 12764 12753 12765 12765 12753 12754 12754 12760 12759 12771 12759 12760 12771 12760 12772 12765 12772 12764 12764 12772 12773 12765 12771 12772 12773 12746 12774 12764 12773 12774 12774 12746 12745 12774 12745 12775 12764 12774 12763 12763 12774 12775 12775 12745 12757 12775 12757 12758 12775 12758 12776 12763 12775 12762 12762 12775 12776 12762 12756 12763 12761 12750 12762 12762 12750 12756 12762 12776 12761 12776 12758 12768 12761 12776 12768 12767 12748 12761 12761 12748 12750 12761 12768 12769 12761 12769 12767 12768 12751 12769 12768 12758 12751 12769 12751 12749 12769 12749 12755 12769 12755 12770 12767 12769 12770 12750 12749 12751 12750 12751 12758 12748 12749 12750 12748 12755 12749 12750 12758 12756 12756 12758 12757 12754 12755 12748 12754 12759 12755 12770 12755 12759 12767 12754 12748 12765 12754 12766 12766 12754 12767 12766 12771 12765 12767 12770 12766 12766 12770 12771 12770 12759 12771 12777 12778 12779 12794 12793 12777 12777 12793 12778 12799 12794 12777 12799 12777 12779 12779 12778 12780 12799 12779 12800 12800 12779 12780 12792 12794 12799 12821 12792 12799 12800 12821 12799 12792 12793 12794 12792 12791 12793 12795 12778 12793 12793 12791 12795 12790 12791 12792 12803 12790 12792 12821 12822 12792 12792 12822 12803 12790 12788 12791 12788 12797 12791 12791 12797 12795 12789 12788 12790 12802 12789 12790 12802 12790 12803 12822 12823 12803 12803 12823 12802 12801 12787 12802 12802 12787 12789 12824 12802 12823 12824 12801 12802 12787 12788 12789 12785 12786 12787 12787 12786 12788 12801 12785 12787 12805 12785 12801 12824 12825 12801 12801 12825 12805 12783 12784 12785 12785 12784 12786 12805 12783 12785 12786 12798 12788 12798 12786 12784 12783 12782 12784 12784 12782 12798 12780 12782 12783 12804 12780 12783 12804 12783 12805 12780 12778 12781 12780 12781 12782 12800 12780 12804 12826 12804 12805 12804 12827 12800 12827 12804 12826 12800 12827 12821 12827 12887 12888 12826 12887 12827 12827 12888 12821 12821 12883 12822 12821 12888 12883 12936 12883 12888 12940 12936 12888 12940 12888 12887 12826 12882 12887 12941 12940 12887 12941 12887 12882 12937 12940 12941 12937 12936 12940 12946 12944 12941 12946 12941 12947 12944 12937 12941 12941 12882 12947 12826 12881 12882 12882 12881 12907 12907 12947 12882 12946 12947 12907 12951 12946 12907 12952 12907 12881 12907 12952 12951 12824 12885 12881 12824 12881 12826 12952 12881 12957 12957 12881 12885 12825 12826 12805 12825 12824 12826 12824 12823 12822 12824 12886 12885 12822 12886 12824 12928 12957 12885 12885 12886 12928 12956 12952 12957 12956 12957 12928 12927 12928 12884 12928 12886 12884 12927 12956 12928 12884 12886 12822 12822 12883 12884 12884 12933 12927 12936 12933 12884 12936 12884 12883 12932 12930 12933 12927 12933 12930 12932 12933 12936 12932 12936 12937 12931 12930 12932 12932 12935 12931 12932 12937 12935 12929 12923 12930 12926 12927 12930 12926 12930 12923 12930 12931 12929 12925 12929 12931 12934 12931 12935 12931 12934 12925 12908 12935 12937 12935 12908 12934 12909 12925 12934 12934 12908 12909 12925 12892 12924 12892 12925 12909 12924 12929 12925 12924 12923 12929 12924 12891 12923 12891 12924 12892 12860 12891 12892 12860 12892 12868 12868 12892 12893 12892 12909 12893 12908 12894 12909 12909 12894 12893 12868 12893 12861 12861 12893 12894 12838 12860 12868 12838 12868 12839 12861 12839 12868 12839 12861 12842 12880 12842 12861 12861 12894 12880 12880 12894 12895 12894 12908 12910 12894 12910 12895 12879 12842 12880 12880 12895 12879 12841 12839 12842 12842 12844 12841 12879 12844 12842 12841 12840 12839 12818 12840 12841 12815 12841 12843 12843 12841 12844 12815 12818 12841 12843 12844 12845 12844 12879 12845 12828 12815 12843 12843 12845 12862 12846 12828 12843 12848 12843 12862 12848 12846 12843 12845 12878 12862 12878 12845 12879 12862 12850 12848 12862 12878 12877 12862 12877 12850 12847 12846 12848 12847 12848 12849 12849 12848 12850 12877 12849 12850 12863 12847 12849 12864 12853 12849 12849 12853 12863 12849 12877 12864 12863 12853 12852 12863 12852 12847 12851 12847 12852 12813 12846 12847 12847 12851 12813 12852 12853 12854 12855 12851 12852 12854 12865 12852 12852 12865 12855 12812 12813 12851 12851 12810 12812 12810 12851 12855 12810 12855 12856 12855 12865 12858 12856 12855 12858 12865 12874 12858 12874 12865 12875 12854 12875 12865 12875 12854 12853 12875 12853 12876 12876 12901 12875 12875 12901 12902 12875 12902 12874 12876 12853 12864 12864 12900 12876 12876 12900 12901 12900 12916 12901 12917 12902 12901 12917 12901 12916 12874 12902 12903 12902 12917 12903 12917 12918 12903 12918 12917 12953 12949 12917 12916 12953 12917 12949 12900 12915 12916 12949 12916 12950 12950 12916 12915 12953 12949 12951 12949 12950 12951 12953 12951 12956 12918 12953 12958 12953 12956 12958 12950 12946 12951 12956 12951 12952 12946 12950 12945 12945 12950 12948 12915 12948 12950 12945 12944 12946 12943 12942 12945 12945 12942 12944 12948 12943 12945 12915 12914 12948 12914 12943 12948 12912 12942 12943 12914 12913 12943 12913 12912 12943 12942 12939 12944 12912 12939 12942 12939 12937 12944 12911 12938 12939 12937 12939 12938 12912 12911 12939 12896 12911 12912 12896 12912 12897 12913 12897 12912 12913 12898 12897 12913 12914 12898 12879 12896 12897 12879 12897 12878 12897 12898 12878 12879 12895 12896 12895 12910 12896 12911 12896 12910 12910 12938 12911 12938 12908 12937 12910 12908 12938 12878 12898 12877 12877 12898 12899 12898 12914 12899 12877 12899 12900 12877 12900 12864 12915 12900 12899 12915 12899 12914 12954 12958 12956 12956 12959 12954 12959 12956 12927 12958 12919 12918 12919 12958 12954 12919 12904 12918 12904 12919 12905 12920 12905 12919 12954 12920 12919 12903 12918 12904 12874 12903 12904 12874 12904 12873 12873 12904 12905 12873 12905 12872 12872 12905 12906 12920 12906 12905 12906 12920 12921 12920 12954 12955 12921 12920 12955 12872 12906 12871 12871 12906 12889 12906 12921 12889 12889 12921 12922 12922 12921 12926 12921 12955 12926 12954 12959 12955 12926 12955 12959 12926 12923 12922 12926 12959 12927 12889 12922 12890 12922 12923 12890 12871 12889 12870 12870 12889 12890 12870 12890 12869 12869 12890 12891 12890 12923 12891 12869 12834 12870 12833 12870 12834 12870 12833 12871 12860 12835 12869 12869 12835 12834 12869 12891 12860 12832 12834 12835 12832 12833 12834 12832 12831 12833 12831 12867 12833 12871 12833 12867 12871 12867 12872 12866 12859 12867 12831 12866 12867 12859 12872 12867 12830 12831 12832 12831 12857 12866 12831 12830 12857 12836 12830 12832 12832 12835 12836 12806 12829 12830 12806 12830 12836 12857 12830 12808 12829 12808 12830 12857 12810 12856 12808 12810 12857 12856 12866 12857 12856 12859 12866 12856 12858 12859 12873 12859 12858 12873 12858 12874 12872 12859 12873 12810 12797 12811 12810 12811 12798 12798 12812 12810 12810 12808 12797 12788 12798 12797 12808 12809 12797 12809 12795 12797 12811 12797 12798 12814 12798 12820 12820 12798 12782 12812 12798 12814 12813 12812 12814 12814 12820 12813 12820 12782 12816 12820 12828 12846 12820 12846 12813 12828 12820 12816 12781 12796 12782 12816 12782 12796 12815 12816 12796 12828 12816 12815 12795 12796 12778 12778 12796 12781 12807 12818 12796 12807 12796 12795 12796 12818 12815 12806 12807 12795 12817 12818 12807 12807 12806 12817 12818 12817 12837 12818 12837 12840 12817 12806 12836 12817 12836 12837 12806 12795 12819 12819 12829 12806 12819 12795 12809 12829 12819 12809 12809 12808 12829 12837 12836 12835 12837 12835 12838 12837 12838 12839 12840 12837 12839 12835 12860 12838 12960 12961 12962 12960 12962 12963 12991 12960 12963 12992 12961 12960 12993 12960 12994 12994 12960 12991 12993 12992 12960 12963 12964 12991 12994 12991 12995 12995 12991 12964 13019 12993 12994 12994 13022 13019 13022 12994 12995 13001 12992 12993 13019 13020 12993 12993 13020 13001 13049 13020 13019 13049 13019 13050 13050 13019 13051 13051 13019 13022 13001 13020 13000 13000 13020 13021 13048 13021 13020 13048 13020 13049 13000 12992 13001 12999 12971 13000 13000 12971 12992 13000 13021 12999 12992 12971 12961 12969 12970 12971 12971 12970 12972 12972 12961 12971 12971 12989 12969 12999 12989 12971 12961 12972 12975 12961 12975 12962 12970 12973 12972 12972 12973 12974 12972 12974 12979 12972 12979 12975 12969 12978 12970 12970 12978 12973 12973 12978 13002 12973 13002 13003 12973 13003 12974 12974 13003 13004 12974 13004 12979 12975 12979 12980 12979 13004 13005 12979 13005 12980 13026 13005 13004 13004 13027 13026 13027 13004 13003 13003 13028 13027 13002 13028 13003 13056 13026 13027 13056 13027 13057 13057 13027 13028 13025 13005 13026 13055 13025 13026 13055 13026 13056 12980 13005 13012 13005 13025 13012 13025 13039 13012 13054 13025 13055 13054 13039 13025 13056 13073 13055 13055 13073 13054 13057 13071 13056 13073 13056 13071 13088 13054 13073 13073 13086 13085 13073 13085 13075 13071 13086 13073 13088 13073 13075 13069 13039 13054 13088 13069 13054 13068 13038 13069 13069 13038 13039 13088 13068 13069 13067 13037 13068 13068 13037 13038 13067 13068 13088 13038 13037 13014 13039 13038 13013 13013 13038 13014 13014 13037 13015 13015 13037 13035 13067 13035 13037 12983 13013 13014 12983 13014 13015 12982 13012 13013 12982 13013 12983 13039 13013 13012 12962 12982 12983 12962 12983 12963 12963 12983 12984 12983 13015 12984 12962 12980 12982 12980 13012 12982 12975 12980 12962 12963 12984 12965 12965 12984 12985 12984 13015 12985 12964 12963 12965 12964 12965 12966 12965 12985 12986 12965 12986 12966 12985 13015 13011 12985 13011 12986 12966 12986 12981 12986 13009 12981 12986 13011 13009 12964 12966 12967 12967 12966 12968 12981 12968 12966 12987 12968 12981 12981 13009 13010 12981 13010 12987 13011 13034 13009 13009 13034 13032 13009 13032 13010 13015 13034 13011 13015 13035 13034 13034 13035 13036 13064 13032 13034 13064 13034 13065 13065 13034 13036 13066 13036 13035 13066 13035 13067 13065 13036 13066 13066 13072 13065 13087 13064 13065 13087 13065 13072 13063 13032 13064 13087 13063 13064 13062 13023 13063 13063 13023 13033 13063 13033 13032 13074 13062 13063 13074 13063 13087 13061 13023 13062 13074 13061 13062 13060 13024 13061 13061 13024 13023 13061 13074 13060 13059 13030 13060 13060 13030 13024 13060 13074 13059 13023 13024 13008 13008 13024 13030 13030 13029 13006 13008 13030 13006 13059 13029 13030 13058 13029 13059 13059 13070 13058 13070 13059 13074 13029 13028 13002 13006 13029 13002 13058 13028 13029 12977 13006 12978 12977 13008 13006 12978 13006 13002 12969 12976 12977 12969 12977 12978 12976 13008 12977 12968 12976 12969 12988 12968 12969 12969 12989 12988 12976 12968 12987 12987 13007 12976 12976 13007 13008 12990 12968 12988 12967 12968 12990 12997 12967 12990 12997 12990 12988 12996 12964 12967 12996 12967 12997 12997 12988 12998 12997 13016 12996 12998 13016 12997 12995 12964 12996 13016 13017 12996 12996 13017 12995 12998 13018 13016 13041 13016 13018 13043 13017 13016 13043 13016 13041 12998 12988 12999 13018 12998 12999 12999 12988 12989 12999 13021 13018 13040 13018 13021 13047 13040 13021 13047 13021 13048 13046 13018 13040 13046 13040 13047 13082 13046 13047 13048 13084 13047 13047 13084 13082 13084 13048 13049 13049 13086 13084 13070 13082 13084 13071 13070 13084 13071 13084 13086 13082 13083 13046 13070 13083 13082 13045 13018 13046 13046 13083 13045 13045 13083 13044 13044 13083 13080 13074 13080 13083 13074 13083 13070 13058 13070 13057 13057 13070 13071 13057 13028 13058 13087 13080 13074 13044 13080 13043 13043 13080 13081 13087 13081 13080 13087 13079 13078 13087 13078 13081 13072 13079 13087 13043 13081 13053 13053 13081 13078 13041 13044 13043 13043 13053 13017 13017 13053 13042 13053 13078 13079 13053 13079 13042 13042 13079 13077 13072 13077 13079 13066 13067 13072 13067 13077 13072 13076 13052 13077 13042 13077 13052 13088 13076 13077 13067 13088 13077 13042 13022 13017 13022 13042 13052 12995 13017 13022 13051 13022 13052 13076 13051 13052 13075 13051 13076 13088 13075 13076 13075 13050 13051 13075 13085 13050 13050 13085 13049 13049 13085 13086 13044 13041 13045 13045 13041 13018 13031 13023 13008 13007 13031 13008 13032 13033 13031 13010 13032 13031 13010 13031 13007 13023 13031 13033 12987 13010 13007 13089 13090 13091 13092 13091 13089 13093 13094 13095 13095 13168 13093 13093 13168 13169 13093 13169 13166 13093 13192 13094 13166 13193 13093 13093 13193 13194 13093 13194 13192 13094 13097 13095 13168 13095 13097 13168 13167 13169 13097 13167 13168 13166 13169 13167 13166 13167 13164 13164 13195 13166 13166 13195 13193 13194 13193 13195 13194 13195 13191 13192 13194 13191 13094 13192 13191 13094 13191 13096 13096 13191 13190 13191 13195 13190 13096 13097 13094 13098 13100 13096 13096 13100 13097 13096 13190 13098 13098 13099 13100 13097 13100 13099 13099 13098 13101 13097 13099 13103 13101 13103 13099 13101 13098 13102 13101 13102 13103 13188 13102 13098 13188 13098 13189 13098 13190 13189 13186 13102 13188 13190 13186 13188 13190 13188 13189 13104 13105 13102 13102 13105 13103 13102 13186 13187 13102 13187 13104 13187 13186 13182 13238 13182 13186 13186 13190 13239 13238 13186 13239 13104 13187 13185 13185 13187 13182 13104 13185 13106 13106 13185 13184 13184 13185 13182 13106 13107 13104 13108 13109 13106 13106 13109 13107 13106 13184 13108 13108 13184 13182 13112 13113 13108 13108 13113 13109 13108 13182 13112 13111 13107 13109 13111 13109 13113 13112 13111 13113 13110 13111 13112 13111 13115 13107 13110 13115 13111 13110 13112 13114 13110 13114 13115 13179 13114 13112 13112 13182 13183 13112 13183 13179 13179 13180 13114 13179 13183 13180 13180 13183 13182 13180 13182 13241 13182 13238 13416 13182 13416 13241 13114 13180 13181 13181 13180 13177 13180 13243 13177 13243 13180 13241 13241 13340 13243 13416 13401 13241 13241 13401 13340 13396 13398 13416 13416 13398 13401 13238 13396 13416 13398 13400 13401 13401 13400 13402 13401 13402 13340 13396 13397 13398 13398 13397 13399 13398 13399 13400 13399 13301 13400 13400 13301 13331 13400 13331 13402 13397 13330 13399 13399 13330 13301 13301 13298 13280 13301 13280 13299 13330 13298 13301 13331 13301 13299 13331 13299 13332 13402 13331 13332 13299 13280 13273 13299 13273 13274 13302 13299 13274 13332 13299 13302 13280 13272 13273 13298 13272 13280 13272 13107 13273 13273 13107 13228 13273 13228 13220 13274 13273 13220 13272 13262 13107 13279 13262 13272 13297 13279 13272 13297 13272 13298 13224 13103 13262 13262 13103 13107 13271 13224 13262 13279 13271 13262 13103 13105 13107 13103 13224 13097 13104 13107 13105 13228 13107 13115 13228 13115 13220 13114 13117 13115 13115 13117 13121 13115 13121 13220 13220 13121 13221 13274 13220 13221 13121 13123 13221 13263 13221 13123 13281 13274 13221 13281 13221 13251 13251 13221 13263 13302 13274 13303 13303 13274 13281 13303 13281 13253 13253 13281 13251 13251 13252 13253 13251 13263 13282 13252 13251 13304 13304 13251 13282 13344 13303 13253 13344 13253 13345 13345 13253 13347 13347 13253 13252 13342 13302 13303 13342 13303 13344 13343 13342 13344 13343 13344 13345 13343 13345 13346 13346 13345 13347 13346 13347 13348 13348 13347 13349 13347 13252 13304 13347 13304 13349 13404 13343 13346 13404 13346 13236 13236 13346 13348 13340 13342 13343 13243 13340 13343 13243 13343 13404 13243 13404 13242 13242 13404 13236 13235 13175 13236 13236 13175 13177 13236 13177 13242 13236 13348 13235 13242 13177 13243 13118 13177 13120 13120 13177 13176 13118 13178 13177 13175 13176 13177 13181 13177 13178 13120 13121 13118 13124 13125 13120 13120 13125 13121 13120 13176 13124 13124 13176 13175 13122 13123 13124 13124 13123 13125 13122 13124 13126 13174 13126 13124 13174 13124 13175 13123 13121 13125 13118 13121 13119 13119 13121 13117 13118 13119 13116 13116 13178 13118 13116 13119 13117 13116 13117 13114 13114 13181 13116 13116 13181 13178 13123 13122 13128 13123 13128 13226 13263 13123 13264 13264 13123 13226 13226 13128 13136 13226 13136 13258 13264 13226 13265 13265 13226 13258 13282 13263 13264 13282 13264 13283 13283 13264 13265 13283 13265 13284 13284 13265 13256 13256 13265 13258 13258 13136 13259 13275 13258 13259 13256 13258 13275 13254 13255 13256 13256 13255 13257 13257 13284 13256 13254 13256 13275 13285 13275 13259 13254 13275 13307 13307 13275 13285 13358 13254 13307 13255 13254 13358 13357 13255 13358 13357 13356 13255 13356 13257 13255 13355 13284 13257 13355 13257 13356 13354 13355 13356 13354 13356 13357 13357 13358 13359 13333 13354 13357 13333 13357 13359 13359 13358 13360 13358 13307 13360 13359 13360 13361 13360 13307 13361 13359 13361 13362 13405 13359 13362 13333 13359 13244 13244 13359 13405 13333 13215 13245 13244 13215 13333 13245 13354 13333 13244 13210 13215 13232 13210 13244 13244 13405 13232 13405 13362 13365 13405 13365 13406 13232 13405 13406 13229 13207 13232 13232 13207 13210 13232 13406 13229 13406 13365 13367 13406 13367 13407 13229 13406 13407 13362 13364 13365 13365 13364 13366 13365 13366 13367 13362 13361 13363 13362 13363 13364 13363 13308 13364 13364 13308 13300 13364 13300 13309 13364 13309 13366 13367 13366 13368 13366 13309 13310 13366 13310 13368 13309 13300 13276 13309 13276 13286 13309 13286 13310 13300 13285 13276 13308 13285 13300 13259 13223 13276 13276 13223 13266 13285 13259 13276 13276 13266 13286 13307 13285 13308 13361 13307 13308 13361 13308 13363 13286 13266 13277 13286 13277 13287 13310 13286 13311 13311 13286 13287 13277 13266 13260 13287 13277 13260 13287 13260 13288 13311 13287 13312 13312 13287 13288 13369 13310 13311 13369 13311 13371 13371 13311 13312 13368 13310 13369 13367 13368 13369 13367 13369 13370 13370 13369 13371 13370 13371 13372 13371 13312 13372 13370 13372 13373 13407 13367 13370 13407 13370 13408 13408 13370 13373 13373 13372 13374 13372 13312 13374 13373 13374 13375 13373 13375 13376 13408 13373 13409 13409 13373 13376 13374 13312 13313 13374 13313 13314 13374 13314 13375 13376 13375 13377 13375 13314 13315 13375 13315 13377 13313 13288 13314 13314 13288 13289 13314 13289 13315 13312 13288 13313 13288 13260 13278 13288 13278 13289 13289 13278 13219 13289 13219 13290 13315 13289 13290 13278 13260 13219 13222 13150 13260 13260 13150 13219 13266 13222 13260 13222 13223 13142 13222 13142 13150 13266 13223 13222 13223 13136 13142 13259 13136 13223 13135 13136 13131 13131 13136 13132 13135 13140 13136 13136 13140 13137 13136 13137 13142 13134 13136 13130 13130 13136 13128 13134 13132 13136 13131 13132 13133 13133 13132 13134 13133 13134 13129 13130 13129 13134 13129 13130 13127 13127 13130 13128 13127 13128 13126 13126 13128 13122 13127 13171 13129 13126 13173 13127 13127 13173 13171 13133 13129 13170 13129 13171 13170 13170 13171 13173 13126 13172 13173 13170 13173 13172 13172 13126 13174 13170 13172 13175 13174 13175 13172 13175 13235 13170 13245 13170 13235 13235 13348 13351 13235 13351 13245 13245 13215 13170 13245 13351 13354 13348 13350 13351 13351 13350 13352 13351 13352 13353 13351 13353 13354 13348 13349 13350 13349 13304 13350 13350 13304 13305 13350 13305 13352 13352 13305 13306 13352 13306 13353 13354 13353 13355 13353 13306 13355 13305 13283 13306 13306 13283 13284 13355 13306 13284 13304 13282 13305 13305 13282 13283 13170 13216 13133 13216 13170 13215 13133 13216 13217 13217 13216 13215 13133 13217 13131 13131 13217 13215 13131 13215 13135 13135 13215 13214 13213 13214 13215 13215 13210 13213 13139 13140 13135 13135 13214 13139 13139 13214 13213 13212 13139 13213 13210 13212 13213 13141 13210 13211 13210 13141 13212 13209 13210 13207 13211 13210 13209 13212 13141 13139 13137 13139 13141 13137 13141 13142 13143 13142 13141 13141 13211 13143 13143 13211 13209 13143 13209 13144 13144 13209 13208 13208 13209 13207 13144 13145 13143 13143 13145 13142 13150 13142 13145 13144 13147 13145 13150 13145 13147 13146 13147 13144 13144 13208 13146 13146 13208 13207 13148 13150 13146 13146 13150 13147 13146 13207 13148 13148 13149 13150 13150 13149 13151 13150 13151 13154 13219 13150 13154 13149 13148 13151 13151 13148 13152 13152 13154 13151 13205 13152 13148 13205 13148 13206 13148 13207 13206 13153 13154 13152 13152 13203 13204 13152 13204 13153 13203 13152 13205 13205 13206 13207 13230 13205 13207 13230 13203 13205 13229 13230 13207 13240 13203 13230 13230 13229 13408 13230 13408 13410 13230 13410 13240 13203 13240 13204 13237 13204 13240 13240 13410 13403 13240 13403 13237 13409 13376 13410 13410 13376 13378 13410 13378 13403 13408 13409 13410 13229 13407 13408 13403 13378 13381 13403 13381 13383 13237 13403 13383 13376 13377 13378 13378 13377 13379 13378 13379 13380 13378 13380 13381 13381 13380 13382 13381 13382 13383 13379 13317 13380 13380 13317 13318 13380 13318 13382 13377 13315 13379 13379 13315 13316 13379 13316 13317 13316 13290 13317 13317 13290 13291 13317 13291 13318 13318 13291 13319 13382 13318 13319 13290 13267 13291 13291 13267 13268 13291 13268 13292 13319 13291 13292 13290 13219 13267 13315 13290 13316 13219 13218 13267 13267 13218 13268 13268 13218 13225 13268 13225 13227 13292 13268 13293 13293 13268 13227 13319 13292 13320 13320 13292 13293 13382 13319 13320 13320 13293 13321 13382 13320 13384 13384 13320 13386 13386 13320 13321 13293 13227 13294 13321 13293 13322 13322 13293 13294 13386 13321 13322 13385 13384 13386 13385 13386 13339 13386 13322 13339 13383 13382 13384 13383 13384 13385 13385 13339 13338 13411 13385 13338 13231 13383 13385 13231 13385 13411 13337 13338 13339 13339 13322 13337 13322 13294 13323 13337 13322 13323 13387 13338 13337 13387 13337 13388 13337 13323 13246 13337 13246 13388 13411 13338 13387 13233 13411 13387 13233 13231 13411 13387 13388 13334 13412 13387 13334 13233 13387 13412 13334 13388 13335 13388 13246 13335 13334 13335 13336 13389 13334 13336 13412 13334 13389 13412 13389 13413 13233 13412 13234 13234 13412 13413 13389 13336 13390 13389 13390 13391 13413 13389 13391 13413 13391 13414 13239 13413 13414 13234 13413 13239 13195 13233 13234 13234 13190 13195 13239 13190 13234 13239 13414 13415 13239 13415 13238 13414 13391 13393 13414 13393 13415 13415 13393 13396 13238 13415 13396 13391 13392 13393 13393 13392 13394 13393 13394 13395 13396 13393 13395 13396 13395 13397 13394 13328 13395 13395 13328 13397 13392 13326 13394 13394 13326 13327 13394 13327 13328 13327 13279 13328 13328 13279 13297 13328 13297 13329 13397 13328 13329 13397 13329 13330 13329 13297 13298 13329 13298 13330 13296 13271 13279 13326 13296 13279 13326 13279 13327 13250 13270 13296 13296 13270 13271 13324 13250 13296 13324 13296 13325 13325 13296 13326 13270 13224 13271 13269 13224 13270 13250 13269 13270 13224 13167 13097 13261 13167 13224 13269 13261 13224 13295 13261 13269 13295 13269 13247 13247 13269 13250 13227 13167 13261 13294 13227 13261 13294 13261 13295 13323 13294 13295 13323 13295 13246 13246 13295 13247 13246 13247 13248 13248 13247 13249 13249 13247 13250 13335 13246 13248 13335 13248 13249 13335 13249 13336 13336 13249 13250 13336 13250 13324 13336 13324 13390 13390 13324 13325 13391 13390 13392 13390 13325 13392 13392 13325 13326 13227 13162 13167 13225 13162 13227 13164 13167 13165 13167 13162 13165 13164 13165 13163 13163 13198 13164 13164 13198 13195 13163 13165 13162 13162 13159 13163 13196 13197 13163 13163 13197 13198 13196 13163 13159 13197 13195 13198 13233 13195 13197 13196 13199 13197 13199 13231 13197 13233 13197 13231 13196 13159 13199 13159 13200 13199 13199 13200 13201 13199 13201 13204 13231 13199 13237 13237 13199 13204 13237 13383 13231 13153 13204 13202 13204 13201 13202 13155 13201 13157 13157 13201 13200 13155 13202 13201 13157 13200 13159 13157 13158 13155 13159 13161 13157 13157 13161 13158 13155 13156 13153 13155 13158 13156 13153 13202 13155 13153 13156 13154 13158 13161 13156 13154 13156 13218 13218 13156 13225 13225 13156 13161 13159 13160 13161 13161 13160 13162 13162 13225 13161 13160 13159 13162 13218 13219 13154 13137 13138 13139 13140 13138 13137 13139 13138 13140 13340 13341 13342 13340 13402 13341 13402 13302 13341 13341 13302 13342 13402 13332 13302 13417 13418 13419 13417 13419 13420 13437 13436 13417 13417 13436 13418 13455 13437 13417 13455 13417 13456 13456 13417 13420 13420 13419 13421 13420 13421 13422 13456 13420 13422 13422 13421 13423 13423 13421 13424 13439 13424 13421 13439 13421 13449 13449 13421 13419 13456 13422 13423 13423 13424 13425 13456 13423 13457 13457 13423 13425 13425 13424 13426 13438 13424 13439 13438 13426 13424 13466 13438 13439 13466 13439 13467 13467 13439 13449 13445 13426 13438 13466 13445 13438 13446 13426 13445 13465 13446 13445 13465 13445 13466 13447 13428 13446 13446 13428 13426 13465 13447 13446 13441 13428 13447 13464 13441 13447 13464 13447 13465 13427 13426 13428 13427 13428 13429 13429 13428 13430 13430 13428 13441 13425 13426 13427 13457 13425 13427 13457 13427 13453 13453 13427 13429 13429 13430 13431 13453 13429 13454 13454 13429 13431 13431 13430 13432 13454 13431 13432 13454 13432 13452 13474 13454 13452 13474 13509 13454 13454 13509 13510 13454 13510 13453 13481 13510 13509 13481 13509 13476 13476 13509 13474 13453 13510 13495 13483 13495 13510 13483 13510 13481 13464 13481 13463 13463 13481 13476 13464 13483 13481 13463 13476 13462 13462 13476 13477 13476 13474 13477 13462 13441 13463 13463 13441 13464 13465 13483 13464 13465 13482 13483 13482 13495 13483 13466 13489 13465 13465 13489 13482 13489 13496 13482 13482 13496 13495 13466 13488 13489 13488 13497 13489 13489 13497 13496 13467 13490 13466 13466 13490 13491 13466 13491 13488 13491 13498 13488 13488 13498 13497 13473 13496 13497 13473 13497 13498 13453 13495 13496 13453 13496 13473 13472 13457 13473 13473 13457 13453 13473 13498 13499 13473 13499 13472 13491 13499 13498 13490 13499 13491 13490 13472 13499 13467 13493 13490 13493 13472 13490 13471 13456 13472 13472 13456 13457 13472 13500 13471 13493 13500 13472 13467 13492 13493 13492 13500 13493 13471 13500 13501 13492 13501 13500 13468 13492 13467 13468 13494 13492 13494 13502 13492 13492 13502 13501 13467 13449 13468 13468 13449 13450 13468 13450 13442 13468 13442 13469 13469 13494 13468 13469 13485 13494 13485 13503 13494 13494 13503 13502 13471 13501 13502 13471 13502 13503 13471 13503 13470 13511 13470 13503 13511 13503 13485 13458 13484 13485 13458 13485 13469 13511 13485 13484 13469 13442 13458 13458 13443 13444 13458 13444 13459 13458 13442 13443 13459 13484 13458 13459 13487 13484 13487 13504 13484 13484 13504 13511 13511 13504 13470 13470 13504 13475 13475 13504 13505 13487 13505 13504 13460 13486 13487 13460 13487 13459 13486 13505 13487 13459 13444 13460 13460 13444 13451 13460 13451 13448 13460 13448 13461 13461 13480 13460 13480 13486 13460 13480 13506 13486 13486 13506 13505 13475 13505 13506 13475 13506 13452 13480 13452 13506 13461 13479 13480 13479 13507 13480 13480 13507 13452 13461 13478 13479 13478 13507 13479 13452 13507 13474 13474 13507 13508 13478 13508 13507 13462 13477 13478 13462 13478 13461 13477 13508 13478 13477 13474 13508 13461 13448 13440 13461 13440 13462 13462 13440 13441 13440 13430 13441 13448 13433 13440 13440 13433 13430 13432 13430 13433 13432 13433 13434 13448 13434 13433 13451 13434 13448 13432 13434 13435 13435 13434 13436 13451 13436 13434 13435 13452 13432 13435 13436 13437 13452 13435 13437 13444 13418 13436 13444 13436 13451 13443 13418 13444 13442 13419 13418 13442 13418 13443 13450 13419 13442 13449 13419 13450 13452 13437 13455 13475 13452 13455 13470 13455 13471 13471 13455 13456 13475 13455 13470 13512 13513 13514 13533 13534 13512 13512 13534 13513 13533 13512 13538 13538 13512 13539 13539 13512 13514 13531 13532 13533 13533 13532 13534 13531 13533 13537 13537 13533 13538 13544 13534 13545 13545 13534 13532 13544 13513 13534 13531 13530 13532 13545 13532 13546 13546 13532 13530 13529 13528 13530 13529 13530 13531 13530 13528 13546 13527 13528 13529 13527 13529 13536 13536 13529 13531 13527 13526 13528 13546 13528 13547 13528 13526 13547 13525 13526 13527 13525 13527 13535 13535 13527 13536 13525 13524 13526 13547 13526 13524 13523 13524 13525 13543 13523 13525 13543 13525 13535 13521 13522 13523 13523 13522 13524 13521 13523 13542 13542 13523 13543 13519 13520 13521 13521 13520 13522 13519 13521 13542 13524 13522 13548 13522 13520 13548 13519 13516 13520 13548 13520 13516 13518 13516 13519 13518 13519 13541 13541 13519 13542 13517 13516 13518 13517 13518 13541 13514 13516 13517 13514 13517 13540 13540 13517 13541 13514 13513 13515 13514 13515 13516 13539 13514 13540 13515 13513 13550 13550 13513 13544 13516 13515 13550 13548 13516 13549 13549 13516 13550 13550 13555 13549 13549 13556 13548 13564 13556 13549 13564 13549 13541 13541 13549 13555 13541 13555 13540 13540 13555 13550 13564 13541 13565 13565 13541 13542 13542 13681 13541 13681 13679 13541 13541 13679 13540 13719 13542 13541 13540 13696 13541 13541 13696 13702 13541 13702 13719 13565 13556 13564 13542 13548 13565 13565 13548 13556 13543 13557 13542 13542 13557 13548 13543 13684 13542 13542 13684 13682 13542 13682 13681 13718 13542 13719 13718 13712 13542 13542 13712 13698 13542 13698 13543 13548 13557 13524 13524 13557 13558 13524 13558 13559 13524 13559 13560 13524 13560 13547 13566 13559 13558 13566 13558 13543 13543 13558 13557 13567 13560 13559 13567 13559 13566 13547 13560 13561 13567 13561 13560 13566 13543 13567 13567 13543 13535 13567 13535 13568 13568 13561 13567 13568 13547 13561 13568 13535 13569 13569 13547 13568 13569 13535 13536 13536 13562 13569 13569 13562 13547 13547 13562 13546 13546 13562 13563 13536 13563 13562 13546 13551 13545 13571 13551 13546 13571 13546 13570 13570 13546 13563 13570 13563 13536 13570 13536 13571 13536 13531 13537 13537 13690 13536 13690 13689 13536 13536 13689 13535 13536 13571 13537 13715 13571 13536 13716 13536 13535 13716 13699 13536 13536 13699 13708 13536 13708 13715 13715 13708 13700 13715 13700 13571 13700 13708 13699 13699 13691 13700 13691 13693 13700 13700 13693 13701 13700 13701 13707 13571 13700 13707 13537 13551 13571 13571 13707 13537 13537 13707 13701 13572 13537 13538 13572 13545 13537 13537 13545 13551 13538 13694 13537 13694 13692 13537 13537 13692 13690 13714 13538 13537 13537 13701 13714 13545 13552 13544 13572 13552 13545 13573 13544 13552 13573 13552 13572 13572 13538 13573 13573 13538 13574 13574 13544 13573 13544 13553 13550 13574 13553 13544 13574 13538 13539 13574 13539 13575 13575 13553 13574 13550 13553 13554 13575 13554 13553 13540 13550 13539 13539 13550 13554 13539 13554 13575 13540 13675 13539 13539 13675 13674 13539 13674 13538 13720 13539 13538 13720 13704 13539 13539 13704 13703 13539 13703 13540 13538 13674 13694 13538 13705 13720 13714 13706 13538 13538 13706 13705 13720 13705 13704 13673 13703 13704 13673 13704 13705 13696 13703 13673 13540 13703 13696 13673 13676 13696 13676 13678 13696 13696 13678 13680 13696 13680 13697 13697 13702 13696 13673 13675 13676 13676 13675 13677 13676 13677 13678 13678 13677 13679 13678 13679 13680 13679 13677 13540 13677 13675 13540 13673 13674 13675 13695 13694 13674 13695 13674 13673 13693 13694 13695 13693 13695 13701 13701 13695 13673 13693 13692 13694 13691 13692 13693 13691 13690 13692 13688 13690 13691 13688 13691 13699 13688 13689 13690 13686 13687 13688 13688 13687 13689 13686 13688 13699 13699 13709 13686 13716 13709 13699 13686 13709 13710 13535 13710 13709 13535 13709 13716 13686 13710 13711 13717 13711 13710 13717 13710 13535 13689 13687 13535 13535 13687 13543 13717 13535 13543 13686 13684 13687 13543 13687 13684 13543 13698 13711 13543 13711 13717 13686 13711 13698 13697 13683 13698 13683 13685 13698 13698 13685 13686 13698 13712 13697 13680 13682 13683 13683 13682 13684 13683 13684 13685 13680 13683 13697 13685 13684 13686 13697 13712 13713 13719 13702 13697 13719 13697 13718 13718 13697 13713 13718 13713 13712 13680 13679 13681 13680 13681 13682 13673 13705 13701 13701 13705 13706 13714 13701 13706 13576 13577 13578 13576 13578 13579 13595 13577 13576 13611 13595 13576 13611 13576 13612 13612 13576 13579 13579 13578 13580 13579 13580 13581 13612 13579 13613 13579 13581 13613 13630 13612 13613 13611 13612 13630 13613 13659 13630 13630 13659 13660 13630 13660 13661 13630 13661 13662 13630 13662 13611 13613 13658 13659 13637 13660 13659 13637 13659 13638 13638 13659 13658 13646 13661 13660 13646 13660 13637 13641 13662 13661 13641 13661 13646 13611 13662 13663 13640 13662 13641 13640 13663 13662 13617 13640 13641 13617 13641 13646 13617 13646 13629 13629 13646 13637 13629 13637 13638 13628 13605 13629 13629 13605 13603 13629 13603 13604 13629 13604 13617 13629 13638 13628 13617 13602 13618 13617 13604 13602 13618 13640 13617 13603 13578 13604 13604 13578 13602 13605 13580 13603 13603 13580 13578 13602 13578 13577 13602 13577 13601 13618 13602 13601 13595 13594 13577 13601 13577 13594 13601 13594 13596 13618 13601 13619 13619 13601 13596 13593 13592 13594 13593 13594 13595 13596 13594 13592 13610 13595 13611 13610 13593 13595 13591 13592 13593 13610 13591 13593 13591 13590 13592 13596 13592 13597 13597 13592 13598 13598 13592 13590 13589 13590 13591 13589 13591 13610 13589 13588 13590 13598 13590 13599 13599 13590 13600 13590 13588 13600 13621 13597 13598 13621 13598 13622 13622 13598 13599 13620 13596 13597 13620 13597 13621 13622 13643 13621 13621 13643 13651 13621 13651 13652 13621 13652 13620 13622 13599 13623 13623 13642 13622 13622 13642 13643 13623 13636 13642 13671 13643 13642 13636 13668 13642 13642 13668 13634 13642 13634 13671 13623 13635 13636 13635 13633 13636 13636 13633 13669 13636 13669 13668 13634 13668 13633 13633 13668 13669 13632 13614 13633 13633 13614 13589 13633 13589 13634 13633 13670 13632 13635 13670 13633 13614 13587 13589 13616 13587 13614 13632 13616 13614 13587 13588 13589 13634 13589 13610 13585 13586 13587 13587 13586 13588 13616 13585 13587 13615 13585 13616 13631 13615 13616 13631 13616 13632 13583 13584 13585 13585 13584 13586 13615 13583 13585 13608 13586 13609 13608 13588 13586 13609 13586 13584 13600 13588 13608 13623 13600 13608 13623 13608 13624 13624 13608 13609 13609 13584 13606 13624 13609 13625 13625 13609 13606 13583 13582 13584 13606 13584 13582 13606 13582 13607 13625 13606 13626 13626 13606 13607 13625 13647 13624 13626 13650 13625 13625 13650 13647 13624 13647 13635 13624 13635 13623 13623 13599 13600 13672 13635 13647 13672 13670 13635 13650 13654 13647 13647 13654 13632 13647 13632 13672 13672 13632 13670 13632 13654 13631 13631 13654 13655 13650 13655 13654 13613 13615 13631 13631 13655 13656 13631 13657 13613 13645 13657 13631 13645 13631 13656 13650 13656 13655 13645 13656 13650 13627 13644 13645 13627 13645 13626 13626 13645 13650 13644 13657 13645 13613 13657 13658 13639 13658 13657 13639 13657 13644 13628 13639 13644 13628 13644 13627 13626 13607 13627 13627 13607 13605 13627 13605 13628 13628 13638 13639 13638 13658 13639 13605 13582 13580 13607 13582 13605 13581 13580 13582 13581 13582 13583 13613 13581 13583 13613 13583 13615 13611 13664 13610 13610 13664 13665 13610 13665 13666 13610 13666 13634 13611 13663 13664 13653 13665 13664 13653 13664 13648 13648 13664 13663 13652 13666 13665 13652 13665 13653 13620 13652 13653 13620 13653 13648 13620 13648 13619 13619 13648 13618 13618 13648 13649 13648 13663 13649 13649 13663 13640 13618 13649 13640 13619 13596 13620 13651 13666 13652 13643 13666 13651 13634 13666 13667 13643 13667 13666 13671 13667 13643 13671 13634 13667 13721 13722 13723 13740 13741 13721 13721 13741 13722 13765 13740 13721 13765 13721 13766 13766 13721 13723 13738 13739 13740 13740 13739 13741 13765 13738 13740 13763 13722 13741 13763 13741 13750 13750 13741 13739 13738 13737 13739 13750 13739 13737 13736 13737 13738 13764 13738 13765 13764 13736 13738 13736 13734 13737 13750 13737 13751 13751 13737 13734 13735 13734 13736 13775 13735 13736 13775 13736 13764 13795 13775 13764 13795 13764 13765 13774 13735 13775 13775 13795 13774 13733 13734 13735 13774 13733 13735 13773 13733 13774 13774 13795 13796 13774 13796 13773 13731 13732 13733 13733 13732 13734 13773 13731 13733 13772 13731 13773 13773 13796 13772 13749 13748 13731 13731 13748 13732 13772 13749 13731 13753 13734 13732 13753 13732 13754 13754 13732 13755 13755 13732 13748 13752 13734 13753 13781 13752 13753 13781 13753 13782 13782 13753 13754 13751 13734 13752 13780 13751 13752 13780 13752 13781 13782 13807 13781 13781 13807 13780 13782 13754 13755 13782 13755 13789 13789 13806 13782 13782 13806 13807 13780 13807 13808 13809 13807 13806 13809 13808 13807 13779 13751 13780 13780 13808 13779 13779 13750 13751 13778 13750 13779 13779 13808 13797 13779 13797 13778 13810 13797 13808 13810 13808 13809 13778 13797 13777 13777 13797 13798 13797 13810 13798 13777 13750 13778 13777 13763 13750 13776 13763 13777 13777 13798 13799 13777 13799 13776 13798 13810 13799 13776 13799 13788 13788 13799 13800 13799 13810 13800 13788 13762 13776 13776 13762 13763 13762 13722 13763 13761 13724 13762 13762 13724 13722 13787 13761 13762 13787 13762 13788 13788 13800 13787 13787 13800 13801 13810 13801 13800 13786 13761 13787 13787 13801 13786 13760 13724 13761 13786 13760 13761 13785 13760 13786 13786 13801 13785 13785 13801 13802 13811 13801 13810 13811 13802 13801 13784 13759 13785 13785 13759 13760 13785 13802 13784 13759 13727 13760 13760 13727 13724 13758 13729 13759 13759 13729 13727 13784 13758 13759 13783 13758 13784 13784 13802 13803 13784 13803 13783 13811 13803 13802 13783 13803 13792 13792 13803 13804 13804 13803 13811 13792 13758 13783 13791 13757 13792 13792 13757 13758 13792 13804 13791 13791 13804 13790 13790 13804 13805 13804 13811 13812 13805 13804 13812 13790 13756 13791 13791 13756 13757 13756 13746 13757 13757 13746 13744 13757 13744 13758 13755 13748 13756 13756 13748 13746 13789 13755 13756 13789 13756 13790 13745 13744 13746 13745 13746 13747 13747 13746 13748 13747 13748 13749 13771 13745 13747 13771 13747 13772 13772 13747 13749 13743 13744 13745 13771 13743 13745 13770 13743 13771 13796 13770 13771 13796 13771 13772 13730 13742 13743 13743 13742 13744 13769 13730 13743 13769 13743 13770 13794 13770 13796 13794 13769 13770 13768 13728 13769 13769 13728 13730 13794 13768 13769 13728 13729 13730 13729 13742 13730 13758 13744 13742 13758 13742 13729 13728 13727 13729 13726 13727 13728 13768 13726 13728 13767 13725 13768 13768 13725 13726 13767 13768 13794 13725 13724 13726 13726 13724 13727 13723 13724 13725 13767 13723 13725 13766 13723 13767 13793 13767 13794 13793 13766 13767 13723 13722 13724 13793 13765 13766 13795 13765 13793 13810 13795 13793 13810 13793 13794 13810 13794 13811 13811 13794 13796 13809 13795 13810 13809 13796 13795 13811 13796 13812 13812 13796 13809 13809 13805 13812 13809 13806 13805 13790 13805 13789 13789 13805 13806 13813 13814 13815 13834 13833 13813 13813 13833 13814 13860 13834 13813 13860 13813 13815 13815 13814 13816 13815 13816 13817 13860 13815 13861 13861 13815 13817 13859 13834 13860 13887 13860 13861 13887 13859 13860 13832 13833 13834 13859 13832 13834 13858 13832 13859 13890 13859 13887 13890 13858 13859 13830 13831 13832 13832 13831 13833 13858 13830 13832 13869 13830 13858 13869 13858 13890 13828 13829 13830 13830 13829 13831 13869 13828 13830 13843 13831 13844 13844 13831 13829 13857 13833 13831 13857 13831 13843 13828 13826 13829 13844 13829 13845 13845 13829 13826 13827 13826 13828 13869 13827 13828 13825 13826 13827 13825 13842 13826 13845 13826 13846 13846 13826 13842 13885 13844 13845 13885 13845 13886 13886 13845 13846 13846 13842 13847 13876 13846 13877 13877 13846 13847 13886 13846 13876 13876 13901 13886 13886 13901 13902 13886 13902 13885 13884 13844 13885 13885 13902 13884 13884 13902 13891 13903 13891 13902 13903 13902 13901 13876 13900 13901 13906 13903 13901 13906 13901 13900 13877 13900 13876 13878 13899 13900 13878 13900 13877 13899 13906 13900 13877 13847 13878 13878 13847 13879 13879 13899 13878 13880 13898 13899 13880 13899 13879 13906 13899 13898 13879 13847 13848 13879 13848 13880 13847 13842 13839 13847 13839 13848 13848 13839 13837 13848 13837 13849 13880 13848 13849 13880 13849 13881 13881 13898 13880 13849 13837 13835 13849 13835 13850 13881 13849 13850 13836 13835 13837 13836 13837 13838 13838 13837 13839 13823 13824 13835 13823 13835 13836 13850 13835 13824 13850 13824 13851 13870 13850 13851 13881 13850 13870 13823 13822 13824 13851 13824 13822 13821 13822 13823 13864 13821 13823 13864 13823 13836 13821 13819 13822 13851 13822 13852 13852 13822 13819 13870 13851 13871 13871 13851 13852 13852 13819 13853 13871 13852 13872 13872 13852 13853 13872 13895 13871 13871 13895 13896 13871 13896 13870 13872 13853 13873 13873 13895 13872 13853 13819 13816 13853 13816 13854 13873 13853 13854 13873 13854 13874 13874 13894 13873 13873 13894 13895 13854 13816 13855 13874 13854 13855 13817 13816 13818 13818 13816 13819 13855 13816 13814 13855 13814 13856 13874 13855 13875 13855 13856 13875 13856 13814 13833 13856 13833 13857 13875 13856 13882 13882 13856 13857 13882 13893 13875 13875 13893 13874 13882 13857 13883 13883 13891 13882 13882 13891 13892 13882 13892 13893 13883 13857 13843 13883 13843 13884 13884 13891 13883 13891 13903 13892 13892 13903 13904 13892 13904 13893 13903 13890 13887 13903 13887 13904 13906 13890 13903 13889 13868 13890 13890 13868 13869 13906 13889 13890 13905 13889 13906 13906 13898 13905 13881 13897 13898 13905 13898 13897 13870 13897 13881 13870 13896 13897 13905 13897 13896 13905 13896 13895 13904 13905 13895 13904 13895 13894 13904 13887 13888 13904 13888 13905 13893 13904 13894 13874 13893 13894 13905 13888 13889 13867 13868 13889 13889 13866 13867 13888 13865 13889 13889 13865 13866 13866 13840 13867 13867 13840 13841 13867 13841 13868 13868 13841 13825 13868 13825 13827 13868 13827 13869 13840 13839 13841 13841 13839 13842 13841 13842 13825 13838 13839 13840 13866 13838 13840 13866 13836 13838 13864 13836 13865 13865 13836 13866 13863 13821 13864 13888 13863 13864 13888 13864 13865 13862 13820 13863 13863 13820 13821 13888 13862 13863 13820 13819 13821 13818 13819 13820 13862 13818 13820 13861 13817 13862 13862 13817 13818 13887 13862 13888 13862 13887 13861 13884 13843 13844 13907 13908 13909 13957 13956 13907 13907 13956 13908 13957 13907 13953 13953 13907 13950 13910 13907 13909 13907 13961 13950 13961 13907 13963 13963 13907 13910 13908 13956 13909 13955 13956 13957 13909 13956 13952 13952 13956 13955 13955 13957 13953 13953 13954 13955 13954 13952 13955 13953 13952 13954 13952 13953 13950 13950 13951 13952 13948 13952 13951 13942 13952 13948 13952 13970 13971 13952 13971 13909 13952 13976 13970 13976 13952 13942 13950 13949 13951 13951 13949 13948 13948 13949 13950 13947 13948 13950 13950 13960 13947 13950 13961 13960 13948 13947 13945 13942 13948 13945 13944 13942 13945 13944 13945 13946 13946 13945 13947 13943 13942 13944 13944 13947 13943 13944 13946 13947 13966 13943 13947 13966 13947 13960 13941 13942 13943 13938 13939 13943 13939 13941 13943 13966 13938 13943 13939 13940 13941 13942 13941 13940 13938 13937 13939 13939 13937 13940 13936 13942 13940 13936 13940 13937 13934 13936 13937 13934 13937 13938 13934 13935 13936 13975 13942 13936 13975 13936 13968 13968 13936 13935 13934 13938 13933 13935 13934 13933 13931 13935 13933 13968 13935 13931 13932 13931 13933 13932 13933 13930 13933 13938 13958 13965 13930 13933 13965 13933 13958 13930 13931 13932 13930 13929 13931 13968 13931 13969 13969 13931 13929 13928 13930 13927 13930 13928 13929 13965 13927 13930 13928 13926 13929 13926 13923 13929 13969 13929 13923 13927 13926 13928 13924 13925 13926 13924 13926 13927 13925 13923 13926 13920 13923 13924 13924 13923 13925 13927 13920 13924 13921 13920 13927 13964 13927 13965 13964 13921 13927 13920 13921 13922 13920 13922 13923 13922 13921 13919 13923 13922 13919 13914 13918 13921 13918 13919 13921 13967 13914 13921 13967 13921 13964 13918 13917 13919 13919 13917 13923 13916 13917 13918 13914 13916 13918 13916 13915 13917 13915 13913 13917 13972 13923 13917 13972 13917 13973 13973 13917 13913 13914 13915 13916 13914 13913 13915 13912 13913 13914 13912 13909 13913 13973 13913 13971 13971 13913 13909 13910 13911 13912 13912 13914 13910 13911 13909 13912 13910 13909 13911 13914 13962 13910 13910 13962 13963 13914 13967 13962 13990 13967 13991 13991 13967 13964 13990 14020 13967 13967 14020 13962 13991 14019 13990 13990 14019 14020 13964 14018 13991 13991 14018 14019 13978 13964 13965 13978 14017 13964 13964 14017 14018 14019 14018 14056 14056 14018 14017 14020 14019 14056 14055 14060 14056 14017 14055 14056 14056 14060 14061 14020 14056 14061 13978 14016 14017 14017 14016 14055 13965 14016 13978 13965 14015 14016 14016 14015 14055 14015 14054 14055 14054 14080 14055 14055 14080 14060 13979 14014 14015 13979 14015 13965 14015 14014 14054 14054 14053 14059 14053 14054 14014 14054 14059 14080 13958 14013 14014 13958 14014 13980 13980 14014 13979 14014 14013 14053 13979 13965 13980 13980 13965 13958 13958 13938 13959 13981 13958 13959 13981 14013 13958 13959 13938 13966 13982 13959 13966 13982 14007 13959 14007 14013 13959 13959 14013 13981 13983 13966 13960 13983 14010 13966 13966 14010 14011 13966 14011 13982 13982 14011 14012 13982 14012 14007 14007 14012 14052 14013 14007 14052 14012 14011 14052 14011 14050 14051 14050 14011 14010 14052 14011 14051 14052 14051 14058 14053 14052 14058 14052 14053 14013 14058 14051 14085 14051 14050 14086 14086 14085 14051 14010 14009 14050 14050 14009 14049 14049 14086 14050 13984 14008 14009 13984 14009 13960 13960 14009 14010 14009 14008 14049 14008 14048 14049 14048 14057 14049 14057 14086 14049 14006 14047 14048 14048 14047 14057 14008 14006 14048 13961 13986 14006 14006 13986 13987 13961 14006 14008 13987 14024 14006 14024 14047 14006 13984 13960 13961 13984 13961 13985 13986 13961 13963 13961 14008 13985 13986 13963 13987 13963 14023 13987 13987 14023 14024 14024 14023 14046 14024 14046 14047 13963 14022 14023 14023 14022 14046 13988 13963 13962 13988 14022 13963 13989 14021 14022 13989 14022 13988 14022 14021 14046 14044 14045 14046 14047 14046 14045 14021 14044 14046 13962 14020 14021 13962 14021 13989 14021 14020 14044 13988 13962 13989 14020 14061 14044 14061 14087 14044 14105 14115 14044 14105 14044 14087 14045 14044 14115 14102 14061 14103 14087 14061 14102 14061 14060 14114 14061 14114 14103 14087 14102 14104 14105 14087 14104 14178 14105 14104 14178 14104 14179 14179 14104 14102 14177 14105 14178 14179 14177 14178 14179 14102 14180 14177 14179 14176 14180 14237 14179 14176 14179 14252 14252 14179 14237 14176 14105 14177 14176 14115 14105 14045 14115 14116 14175 14116 14115 14175 14115 14176 14106 14045 14116 14173 14106 14116 14173 14116 14174 14174 14116 14175 14175 14176 14174 14172 14173 14174 14174 14176 14172 14172 14106 14173 14045 14106 14107 14171 14107 14106 14171 14106 14172 14171 14172 14170 14172 14246 14247 14172 14176 14246 14247 14170 14172 14170 14108 14171 14171 14108 14107 14045 14107 14108 14079 14045 14108 14108 14109 14079 14169 14109 14108 14169 14108 14170 14045 14079 14047 14047 14079 14057 14088 14079 14089 14057 14079 14088 14109 14089 14079 14168 14089 14109 14168 14109 14169 14170 14168 14169 14167 14089 14168 14166 14167 14168 14166 14168 14170 14166 14088 14089 14166 14089 14167 14165 14088 14166 14165 14166 14162 14162 14166 14251 14166 14253 14251 14166 14170 14253 14253 14170 14247 14276 14277 14247 14253 14247 14296 14276 14247 14246 14305 14296 14247 14277 14305 14247 14356 14253 14296 14356 14296 14357 14357 14296 14305 14357 14305 14277 14277 14311 14357 14357 14311 14257 14357 14257 14356 14355 14253 14356 14356 14257 14312 14356 14312 14355 14354 14304 14355 14304 14253 14355 14355 14312 14313 14355 14313 14354 14312 14257 14313 14313 14257 14256 14313 14256 14314 14354 14313 14314 14314 14256 14315 14354 14314 14315 14354 14315 14353 14353 14315 14256 14352 14294 14353 14294 14251 14353 14353 14251 14354 14353 14256 14352 14293 14251 14294 14352 14293 14294 14248 14162 14251 14275 14248 14251 14275 14251 14293 14295 14251 14253 14354 14251 14295 14352 14275 14293 14274 14248 14275 14274 14275 14351 14351 14275 14352 14352 14317 14351 14351 14317 14242 14351 14242 14274 14316 14256 14317 14317 14256 14242 14352 14316 14317 14352 14256 14316 14226 14256 14257 14226 14192 14256 14256 14192 14242 14257 14230 14226 14257 14241 14230 14241 14257 14311 14311 14337 14241 14277 14337 14311 14358 14241 14337 14358 14337 14277 14277 14276 14358 14358 14276 14359 14359 14241 14358 14276 14246 14297 14359 14276 14297 14246 14176 14252 14298 14246 14299 14299 14246 14252 14297 14246 14359 14359 14246 14298 14359 14298 14360 14360 14298 14361 14361 14298 14299 14299 14252 14300 14361 14299 14300 14361 14300 14362 14362 14255 14361 14361 14255 14308 14361 14308 14309 14361 14309 14360 14360 14309 14340 14360 14340 14359 14308 14255 14309 14309 14255 14241 14309 14241 14310 14310 14340 14309 14359 14340 14310 14359 14310 14241 14234 14241 14223 14241 14234 14233 14241 14233 14232 14232 14230 14241 14255 14223 14241 14140 14233 14234 14140 14234 14235 14234 14223 14235 14140 14232 14233 14121 14231 14232 14121 14232 14140 14231 14230 14232 14140 14141 14083 14140 14082 14121 14140 14083 14082 14140 14235 14141 14141 14235 14223 14083 14141 14139 14223 14139 14141 14074 14082 14083 14074 14083 14072 14139 14137 14083 14072 14083 14137 14221 14137 14139 14221 14139 14222 14222 14139 14223 14137 14138 14072 14138 14137 14219 14219 14137 14220 14220 14137 14221 14222 14220 14221 14222 14223 14220 14255 14220 14223 14220 14240 14218 14220 14218 14219 14220 14255 14240 14218 14138 14219 14072 14138 14135 14218 14135 14138 14217 14135 14218 14218 14240 14217 14135 14136 14072 14217 14136 14135 14216 14136 14217 14217 14240 14216 14215 14136 14216 14214 14216 14213 14216 14214 14215 14216 14259 14258 14216 14258 14213 14216 14240 14259 14214 14136 14215 14213 14134 14214 14214 14134 14136 14212 14134 14213 14212 14213 14211 14211 14213 14209 14258 14209 14213 14134 14133 14084 14133 14134 14131 14136 14134 14084 14131 14134 14212 14211 14131 14212 14210 14131 14211 14209 14210 14211 14131 14132 14133 14210 14132 14131 14068 14133 14132 14133 14068 14070 14133 14070 14084 14068 14132 14130 14209 14130 14132 14209 14132 14210 14130 14129 14068 14130 14204 14205 14130 14205 14129 14204 14130 14209 14204 14209 14205 14129 14205 14206 14209 14206 14205 14254 14206 14209 14254 14209 14258 14262 14206 14254 14327 14262 14254 14328 14254 14329 14329 14254 14330 14330 14254 14258 14254 14339 14327 14372 14339 14254 14372 14254 14371 14371 14254 14328 14371 14328 14370 14370 14328 14329 14370 14329 14330 14330 14258 14331 14370 14330 14369 14369 14330 14331 14331 14258 14332 14369 14331 14265 14265 14331 14332 14265 14266 14369 14369 14266 14370 14265 14250 14266 14368 14302 14265 14265 14302 14250 14265 14332 14368 14368 14332 14258 14333 14258 14334 14334 14258 14259 14368 14258 14333 14368 14333 14367 14367 14333 14334 14334 14259 14335 14367 14334 14263 14263 14334 14335 14335 14259 14336 14366 14336 14259 14366 14259 14365 14365 14259 14240 14263 14335 14336 14263 14336 14366 14263 14264 14236 14366 14264 14263 14263 14236 14367 14365 14264 14366 14281 14280 14365 14365 14280 14264 14365 14240 14281 14306 14240 14255 14240 14306 14281 14280 14281 14237 14364 14237 14281 14364 14281 14306 14280 14236 14264 14280 14237 14236 14236 14237 14181 14181 14237 14180 14278 14279 14237 14279 14252 14237 14278 14237 14364 14364 14306 14278 14363 14279 14278 14278 14306 14338 14278 14338 14363 14301 14252 14279 14363 14301 14279 14300 14252 14362 14362 14252 14363 14363 14252 14301 14363 14338 14307 14363 14307 14362 14306 14307 14338 14306 14255 14307 14362 14307 14255 14180 14102 14181 14181 14102 14103 14181 14103 14114 14181 14114 14182 14236 14181 14182 14060 14101 14114 14182 14114 14183 14114 14101 14183 14236 14182 14183 14183 14101 14184 14184 14236 14183 14060 14100 14101 14184 14101 14100 14060 14080 14100 14100 14080 14099 14184 14100 14185 14185 14100 14099 14185 14186 14184 14184 14186 14236 14185 14099 14186 14080 14098 14099 14098 14113 14099 14186 14099 14187 14187 14099 14113 14080 14059 14098 14059 14097 14098 14188 14113 14098 14188 14098 14189 14189 14098 14097 14187 14113 14188 14186 14187 14188 14186 14188 14238 14238 14188 14189 14189 14097 14190 14190 14238 14189 14059 14096 14097 14190 14097 14096 14190 14096 14191 14238 14190 14191 14059 14095 14096 14191 14096 14147 14147 14096 14095 14148 14191 14147 14148 14151 14191 14244 14191 14151 14244 14238 14191 14147 14095 14148 14148 14095 14149 14149 14151 14148 14059 14058 14095 14058 14094 14095 14149 14095 14094 14149 14094 14150 14151 14149 14150 14085 14093 14094 14058 14085 14094 14150 14094 14151 14151 14094 14093 14053 14058 14059 14085 14092 14093 14151 14093 14152 14152 14093 14153 14153 14093 14092 14085 14086 14092 14112 14092 14086 14153 14092 14154 14154 14092 14112 14239 14152 14153 14153 14154 14239 14152 14239 14151 14244 14151 14245 14245 14151 14239 14284 14238 14244 14284 14244 14285 14269 14244 14267 14267 14244 14245 14372 14285 14244 14372 14244 14269 14370 14238 14284 14370 14284 14285 14238 14250 14186 14266 14250 14238 14370 14266 14238 14370 14285 14371 14371 14285 14372 14372 14269 14373 14373 14327 14372 14372 14327 14339 14373 14269 14268 14268 14326 14373 14373 14326 14327 14326 14262 14327 14268 14262 14326 14260 14202 14262 14262 14202 14206 14260 14262 14325 14268 14325 14262 14129 14206 14207 14202 14208 14206 14206 14208 14207 14129 14081 14068 14081 14129 14127 14129 14207 14127 14127 14207 14208 14127 14208 14203 14202 14203 14208 14127 14128 14081 14127 14203 14128 14202 14128 14203 14128 14146 14081 14146 14128 14202 14081 14146 14126 14200 14126 14146 14200 14146 14201 14201 14146 14202 14126 14076 14081 14126 14145 14076 14199 14145 14126 14199 14126 14200 14198 14199 14200 14201 14202 14200 14200 14202 14198 14202 14260 14198 14198 14260 14261 14323 14261 14260 14323 14260 14324 14345 14324 14260 14345 14260 14344 14344 14260 14325 14323 14324 14341 14346 14341 14324 14346 14324 14345 14344 14286 14345 14345 14286 14287 14345 14287 14346 14268 14245 14344 14245 14286 14344 14344 14325 14268 14286 14245 14287 14287 14245 14288 14346 14287 14288 14288 14245 14239 14268 14267 14245 14267 14268 14269 14158 14249 14239 14158 14239 14154 14270 14239 14271 14288 14239 14289 14289 14239 14290 14271 14239 14249 14270 14290 14239 14154 14112 14155 14155 14158 14154 14086 14091 14112 14155 14112 14156 14156 14112 14091 14156 14158 14155 14156 14091 14157 14157 14158 14156 14086 14090 14091 14157 14091 14158 14091 14090 14158 14111 14090 14086 14111 14086 14057 14158 14090 14159 14159 14090 14111 14160 14158 14159 14158 14248 14249 14248 14158 14160 14159 14111 14160 14110 14111 14057 14160 14111 14161 14161 14111 14110 14057 14088 14110 14161 14110 14162 14162 14110 14163 14163 14110 14164 14164 14110 14088 14162 14160 14161 14248 14160 14162 14164 14162 14163 14165 14162 14164 14164 14088 14165 14249 14248 14273 14273 14248 14292 14303 14292 14248 14274 14303 14248 14272 14249 14273 14272 14273 14350 14350 14273 14292 14350 14292 14303 14350 14303 14274 14274 14242 14343 14274 14343 14318 14274 14318 14350 14350 14318 14319 14350 14319 14272 14318 14242 14319 14242 14318 14343 14242 14192 14193 14242 14193 14194 14194 14243 14242 14319 14242 14243 14319 14243 14320 14272 14319 14320 14320 14243 14272 14195 14243 14194 14243 14195 14196 14196 14198 14243 14243 14198 14261 14321 14243 14261 14272 14243 14349 14349 14243 14321 14197 14145 14198 14198 14145 14199 14197 14198 14196 14196 14144 14197 14197 14144 14145 14144 14076 14145 14144 14124 14062 14062 14076 14144 14196 14124 14144 14065 14076 14062 14076 14065 14067 14067 14081 14076 14066 14067 14028 14067 14065 14029 14029 14028 14067 14066 14081 14067 14066 14068 14081 14068 14066 14069 14028 14069 14066 14069 14070 14068 14070 14069 14005 14028 14027 14069 14005 14069 14027 14070 14005 14031 14032 14070 14031 14070 14032 14071 14071 14084 14070 13968 14005 14002 14005 14027 14002 14005 13968 14031 14002 14027 14001 14001 14027 14028 14001 13968 14002 14001 13975 13968 13968 13969 14003 14031 13968 14003 14000 13975 14001 14001 14028 14000 14000 14028 13975 13975 14028 14029 13974 13942 13975 13999 13974 13975 13975 14029 13999 13999 14029 14030 14029 14065 14030 13999 14030 13974 13976 13942 13974 13998 13976 13974 13974 14030 13998 13998 14030 14026 14065 14026 14030 14062 14064 14065 14065 14064 14026 14025 13976 14026 14026 13976 13998 14026 14064 14025 13996 13970 13976 13996 13976 13997 13997 13976 14025 13997 14025 14040 14040 14025 14064 14062 14063 14064 14063 14040 14064 13997 14040 13996 13996 14040 14041 14041 14040 14075 14075 14040 14063 13996 14041 13970 13970 14041 13971 13971 14041 14042 14041 14075 14042 14042 14075 14043 14077 14043 14075 14077 14075 14078 14078 14075 14063 13971 14042 13995 13995 14042 14043 13994 13973 13971 13994 13971 13995 13995 14043 13994 13994 14043 14039 14077 14039 14043 13993 13973 13994 14039 13993 13994 13992 13972 13973 14037 13992 13973 14037 13973 14038 14038 13973 13993 14038 13993 14039 14038 14039 14077 14074 14037 14038 14077 14074 14038 14036 13992 14037 14072 14036 14037 14074 14072 14037 14036 13972 13992 13977 13923 13972 13977 13972 14035 14035 13972 14036 14072 14073 14036 14035 14036 14073 14072 14071 14073 14072 14084 14071 14072 14136 14084 14073 14071 14035 14034 13977 14035 14071 14034 14035 14071 14032 14033 14034 14071 14033 14033 14004 14034 14034 14004 13977 14032 13969 14033 14033 13969 14004 14031 14003 14032 14032 14003 13969 13969 13923 13977 14004 13969 13977 14077 14082 14074 14078 14082 14077 14082 14120 14121 14117 14120 14082 14117 14082 14078 14117 14078 14063 14117 14118 14119 14063 14118 14117 14117 14119 14120 14119 14230 14120 14120 14230 14231 14120 14231 14121 14118 14228 14119 14119 14228 14229 14119 14229 14230 14228 14230 14229 14228 14226 14230 14118 14227 14228 14227 14226 14228 14123 14225 14226 14123 14226 14118 14118 14226 14227 14224 14192 14226 14225 14224 14226 14122 14123 14063 14123 14118 14063 14122 14225 14123 14122 14224 14225 14122 14192 14224 14122 14142 14192 14192 14142 14193 14142 14122 14063 14063 14143 14142 14063 14062 14143 14125 14142 14143 14193 14142 14194 14142 14125 14194 14143 14062 14125 14124 14125 14062 14194 14125 14195 14195 14125 14124 14195 14124 14196 14349 14321 14348 14348 14321 14261 14348 14291 14349 14349 14291 14249 14349 14249 14272 14270 14271 14348 14271 14291 14348 14348 14261 14270 14322 14261 14323 14261 14322 14342 14270 14261 14342 14347 14290 14270 14270 14342 14322 14270 14322 14347 14347 14322 14323 14347 14323 14346 14346 14323 14341 14346 14290 14347 14346 14289 14290 14346 14288 14289 14271 14249 14291 14250 14236 14186 14236 14250 14282 14282 14250 14283 14302 14283 14250 14236 14282 14367 14367 14282 14368 14368 14282 14283 14368 14283 14302 14304 14295 14253 14354 14295 14304 13985 14008 13984 13960 14010 13983 14374 14375 14376 14618 14637 14374 14374 14376 14618 14637 14638 14374 14374 14638 14375 14376 14375 14377 14377 14421 14376 14376 14421 14418 14376 14418 14618 14618 14418 14622 14618 14622 14623 14623 14637 14618 14417 14418 14419 14421 14419 14418 14418 14417 14628 14418 14628 14622 14623 14622 14624 14622 14628 14624 14623 14624 14625 14625 14637 14623 14625 14624 14626 14624 14628 14520 14624 14520 14626 14520 14628 14417 14518 14519 14520 14517 14520 14512 14518 14520 14517 14520 14417 14512 14519 14626 14520 14519 14518 14521 14518 14538 14523 14523 14521 14518 14538 14518 14517 14517 14512 14511 14511 14538 14517 14511 14512 14513 14513 14512 14514 14514 14512 14417 14511 14630 14538 14513 14630 14511 14513 14514 14515 14513 14515 14516 14513 14516 14630 14633 14515 14514 14419 14633 14514 14419 14514 14417 14516 14515 14509 14509 14515 14510 14633 14510 14515 14547 14544 14516 14547 14516 14509 14544 14630 14516 14538 14630 14544 14543 14544 14545 14545 14544 14547 14539 14544 14543 14539 14538 14544 14537 14538 14539 14549 14538 14537 14549 14558 14538 14558 14523 14538 14543 14612 14539 14539 14612 14613 14539 14613 14537 14537 14613 14601 14537 14601 14549 14559 14558 14549 14549 14601 14602 14549 14602 14559 14573 14602 14601 14613 14581 14601 14601 14581 14573 14612 14582 14613 14613 14582 14581 14543 14611 14612 14582 14612 14611 14545 14611 14543 14545 14610 14611 14582 14611 14585 14585 14611 14610 14545 14547 14548 14548 14610 14545 14546 14609 14610 14546 14610 14548 14609 14585 14610 14548 14547 14546 14546 14547 14542 14507 14631 14547 14507 14547 14509 14542 14547 14631 14546 14542 14541 14541 14609 14546 14541 14608 14609 14590 14585 14609 14590 14609 14608 14540 14541 14542 14540 14608 14541 14540 14542 14556 14540 14556 14555 14555 14608 14540 14555 14556 14557 14557 14607 14555 14555 14607 14608 14557 14556 14560 14560 14606 14557 14557 14606 14607 14606 14593 14607 14607 14593 14608 14560 14605 14606 14561 14606 14562 14605 14562 14606 14561 14593 14606 14560 14551 14550 14560 14556 14551 14550 14605 14560 14550 14604 14605 14604 14565 14605 14605 14565 14562 14550 14551 14552 14552 14604 14550 14554 14603 14604 14554 14604 14552 14604 14603 14566 14604 14566 14565 14552 14551 14553 14552 14553 14554 14554 14558 14559 14554 14553 14558 14559 14603 14554 14559 14602 14603 14603 14568 14566 14602 14568 14603 14568 14602 14573 14473 14472 14568 14568 14472 14569 14473 14568 14570 14569 14566 14568 14572 14568 14573 14570 14568 14572 14472 14566 14569 14471 14472 14473 14566 14472 14464 14527 14472 14471 14472 14527 14465 14472 14465 14464 14566 14464 14567 14567 14565 14566 14464 14465 14466 14567 14464 14466 14466 14465 14467 14527 14529 14465 14532 14467 14465 14532 14465 14529 14527 14471 14528 14527 14528 14529 14529 14553 14629 14529 14528 14553 14529 14629 14532 14467 14532 14533 14629 14533 14532 14553 14551 14629 14629 14551 14533 14531 14553 14528 14558 14553 14531 14471 14531 14528 14471 14530 14531 14558 14531 14526 14526 14531 14530 14524 14523 14558 14524 14558 14526 14483 14523 14524 14483 14524 14481 14481 14524 14479 14479 14524 14525 14524 14526 14525 14522 14523 14485 14485 14523 14483 14523 14522 14521 14485 14487 14522 14522 14487 14489 14522 14489 14521 14483 14484 14485 14485 14484 14486 14485 14486 14487 14487 14486 14488 14487 14488 14489 14489 14488 14490 14489 14490 14491 14521 14489 14519 14489 14491 14519 14577 14490 14488 14577 14488 14578 14578 14488 14486 14578 14486 14579 14579 14486 14484 14579 14577 14578 14579 14484 14574 14579 14574 14577 14576 14490 14577 14574 14573 14577 14577 14573 14581 14576 14577 14581 14480 14573 14574 14574 14484 14482 14574 14482 14480 14480 14571 14573 14571 14572 14573 14571 14478 14475 14475 14572 14571 14478 14571 14480 14475 14570 14572 14474 14473 14475 14474 14475 14476 14476 14475 14477 14477 14475 14478 14570 14475 14473 14477 14478 14479 14479 14478 14480 14479 14525 14477 14477 14525 14526 14477 14526 14476 14476 14526 14474 14526 14530 14474 14474 14530 14471 14471 14473 14474 14479 14480 14481 14481 14480 14482 14481 14482 14483 14483 14482 14484 14580 14575 14581 14581 14582 14580 14576 14581 14575 14582 14583 14580 14582 14584 14583 14584 14582 14587 14587 14582 14585 14638 14580 14583 14641 14583 14584 14641 14638 14583 14587 14586 14584 14642 14584 14586 14642 14641 14584 14585 14586 14587 14588 14586 14585 14588 14585 14590 14586 14640 14642 14640 14586 14588 14642 14640 14639 14639 14641 14642 14375 14638 14641 14639 14375 14641 14637 14580 14638 14625 14636 14637 14635 14637 14636 14637 14575 14580 14637 14635 14575 14625 14626 14401 14401 14636 14625 14401 14635 14636 14404 14635 14401 14493 14635 14404 14575 14635 14493 14575 14492 14576 14493 14492 14575 14491 14492 14493 14395 14411 14493 14493 14411 14491 14404 14395 14493 14401 14403 14404 14404 14403 14395 14395 14396 14397 14395 14403 14396 14395 14397 14407 14407 14411 14395 14401 14400 14403 14400 14413 14403 14403 14413 14415 14403 14415 14396 14400 14401 14402 14400 14402 14392 14400 14409 14413 14392 14409 14400 14412 14413 14414 14412 14415 14413 14409 14414 14413 14416 14415 14412 14401 14626 14412 14401 14412 14402 14402 14412 14414 14626 14416 14412 14392 14402 14399 14402 14414 14399 14409 14410 14414 14399 14414 14410 14392 14399 14393 14399 14410 14393 14409 14408 14410 14393 14410 14408 14392 14393 14394 14398 14394 14393 14393 14408 14398 14405 14408 14409 14405 14407 14408 14398 14408 14407 14397 14394 14398 14398 14407 14397 14405 14406 14407 14407 14406 14411 14396 14406 14405 14396 14405 14394 14394 14405 14409 14411 14406 14415 14396 14415 14406 14411 14415 14416 14411 14416 14491 14491 14416 14519 14519 14416 14626 14491 14490 14492 14576 14492 14490 14397 14396 14394 14394 14409 14392 14377 14375 14378 14378 14375 14639 14616 14617 14377 14377 14617 14421 14377 14378 14616 14639 14640 14378 14378 14640 14616 14614 14615 14616 14616 14615 14617 14614 14616 14634 14616 14640 14634 14615 14627 14617 14420 14421 14617 14420 14617 14627 14420 14419 14421 14510 14420 14627 14420 14510 14633 14420 14633 14419 14508 14627 14621 14621 14627 14615 14510 14627 14508 14614 14621 14615 14614 14620 14621 14620 14508 14621 14507 14508 14502 14502 14508 14503 14507 14510 14508 14508 14620 14503 14509 14510 14507 14631 14507 14502 14502 14503 14504 14631 14502 14504 14542 14631 14632 14632 14631 14504 14504 14503 14494 14504 14494 14454 14504 14454 14505 14632 14504 14505 14542 14632 14501 14501 14632 14506 14632 14505 14506 14556 14542 14500 14542 14501 14500 14551 14556 14536 14556 14496 14536 14496 14556 14495 14556 14498 14495 14556 14500 14498 14440 14498 14500 14440 14500 14499 14500 14501 14499 14498 14440 14438 14438 14495 14498 14495 14436 14496 14436 14495 14438 14496 14436 14497 14536 14496 14497 14435 14436 14437 14437 14436 14438 14497 14436 14463 14435 14463 14436 14437 14438 14439 14439 14438 14440 14592 14435 14437 14592 14437 14593 14593 14437 14439 14435 14561 14462 14435 14592 14561 14462 14463 14435 14462 14461 14463 14461 14536 14463 14463 14536 14497 14460 14461 14462 14462 14561 14562 14462 14562 14460 14592 14593 14561 14593 14439 14594 14608 14593 14598 14595 14598 14593 14594 14595 14593 14594 14439 14595 14595 14439 14441 14595 14441 14596 14597 14598 14595 14597 14595 14596 14439 14440 14441 14441 14440 14442 14441 14442 14443 14596 14441 14443 14596 14443 14597 14597 14443 14445 14597 14445 14598 14443 14442 14444 14443 14444 14445 14499 14442 14440 14442 14499 14444 14445 14444 14446 14444 14499 14501 14501 14446 14444 14445 14446 14447 14598 14445 14447 14447 14446 14448 14501 14448 14446 14506 14448 14501 14447 14448 14449 14449 14448 14450 14506 14450 14448 14598 14447 14599 14599 14447 14449 14608 14598 14590 14600 14590 14598 14599 14600 14598 14599 14449 14600 14449 14450 14451 14600 14449 14451 14451 14450 14452 14506 14452 14450 14505 14452 14506 14451 14452 14453 14453 14452 14454 14505 14454 14452 14600 14451 14591 14591 14451 14453 14590 14600 14591 14589 14588 14590 14589 14590 14591 14591 14453 14455 14589 14591 14457 14591 14455 14457 14453 14454 14455 14455 14454 14456 14494 14456 14454 14455 14456 14457 14457 14456 14379 14381 14589 14457 14379 14381 14457 14422 14379 14456 14422 14456 14434 14503 14434 14456 14503 14456 14494 14430 14433 14434 14434 14433 14422 14503 14430 14434 14430 14503 14620 14619 14430 14620 14619 14620 14614 14382 14430 14619 14614 14634 14619 14634 14589 14619 14619 14589 14382 14640 14588 14634 14634 14588 14589 14382 14589 14381 14379 14380 14381 14381 14380 14382 14385 14384 14379 14379 14384 14380 14422 14385 14379 14382 14380 14383 14433 14383 14380 14433 14380 14423 14423 14380 14384 14382 14383 14388 14388 14383 14389 14429 14389 14383 14429 14383 14433 14430 14429 14433 14422 14433 14423 14422 14423 14424 14424 14423 14425 14423 14384 14425 14425 14428 14424 14428 14385 14424 14424 14385 14422 14426 14427 14425 14425 14427 14428 14425 14384 14387 14425 14387 14426 14427 14386 14428 14428 14386 14385 14384 14385 14386 14384 14386 14387 14390 14389 14387 14387 14386 14391 14387 14391 14390 14426 14387 14389 14427 14391 14386 14426 14432 14427 14432 14391 14427 14432 14390 14391 14388 14389 14390 14431 14388 14390 14431 14390 14432 14426 14389 14429 14429 14430 14431 14429 14431 14426 14431 14432 14426 14388 14431 14382 14382 14431 14430 14458 14459 14460 14460 14459 14461 14460 14562 14563 14460 14563 14458 14458 14470 14459 14470 14535 14459 14459 14535 14461 14535 14536 14461 14470 14534 14535 14535 14551 14536 14534 14551 14535 14458 14469 14470 14534 14470 14533 14533 14470 14469 14551 14534 14533 14467 14533 14469 14468 14467 14469 14468 14469 14458 14466 14467 14468 14458 14564 14468 14564 14565 14468 14468 14565 14466 14563 14564 14458 14562 14565 14564 14563 14562 14564 14567 14466 14565 14643 14644 14645 14646 14647 14643 14643 14647 14644 14900 14646 14643 14900 14643 14901 14901 14643 14645 14648 14649 14646 14646 14649 14647 14899 14648 14646 14899 14646 14900 14649 14756 14647 14647 14756 14757 14647 14757 14644 14650 14649 14648 14650 14651 14649 14651 14755 14649 14649 14755 14756 14756 14786 14757 14786 14756 14787 14787 14756 14755 14644 14757 14758 14757 14810 14758 14757 14786 14810 14786 14817 14818 14786 14787 14817 14786 14818 14810 14817 14793 14794 14817 14792 14793 14818 14817 14794 14787 14792 14817 14818 14794 14795 14818 14795 14796 14818 14796 14810 14793 14780 14794 14781 14794 14780 14781 14795 14794 14780 14793 14779 14779 14793 14792 14779 14741 14780 14780 14741 14740 14780 14740 14739 14780 14739 14781 14778 14742 14779 14779 14742 14741 14779 14792 14778 14684 14740 14741 14742 14685 14741 14741 14685 14684 14693 14739 14740 14693 14740 14684 14693 14738 14739 14781 14739 14738 14693 14684 14682 14693 14682 14694 14693 14694 14738 14683 14682 14684 14683 14684 14685 14685 14686 14683 14683 14840 14682 14840 14683 14842 14686 14842 14683 14832 14840 14830 14830 14840 14841 14841 14840 14842 14832 14682 14840 14841 14842 14843 14843 14842 14855 14842 14686 14855 14843 14877 14841 14841 14877 14872 14841 14872 14830 14830 14831 14832 14830 14872 14871 14830 14871 14831 14871 14872 14873 14872 14877 14873 14873 14877 14878 14843 14878 14877 14843 14855 14838 14838 14878 14843 14873 14878 14879 14838 14879 14878 14838 14839 14833 14838 14855 14839 14833 14881 14838 14881 14879 14838 14879 14881 14873 14880 14881 14882 14882 14881 14883 14880 14885 14881 14881 14885 14886 14881 14886 14887 14873 14881 14888 14888 14881 14887 14835 14883 14881 14835 14881 14833 14829 14886 14885 14829 14885 14827 14827 14885 14880 14866 14887 14886 14866 14886 14829 14861 14888 14887 14861 14887 14866 14863 14873 14888 14863 14888 14861 14861 14862 14863 14866 14867 14861 14861 14867 14868 14861 14868 14862 14829 14870 14866 14866 14870 14867 14870 14669 14867 14674 14868 14867 14674 14867 14671 14671 14867 14669 14868 14674 14862 14673 14674 14675 14675 14674 14690 14690 14674 14671 14673 14862 14674 14673 14675 14676 14697 14676 14675 14697 14675 14698 14698 14675 14690 14706 14690 14671 14706 14725 14690 14690 14725 14726 14726 14698 14690 14727 14698 14726 14728 14698 14727 14728 14697 14698 14764 14727 14726 14764 14726 14765 14765 14726 14725 14706 14724 14725 14765 14725 14724 14765 14724 14766 14802 14764 14765 14766 14803 14765 14765 14803 14802 14706 14723 14724 14766 14724 14723 14766 14723 14722 14766 14722 14767 14766 14804 14803 14767 14804 14766 14820 14803 14804 14823 14802 14803 14823 14803 14820 14767 14805 14804 14820 14804 14805 14767 14722 14721 14767 14721 14768 14768 14805 14767 14722 14699 14721 14723 14699 14722 14699 14723 14706 14699 14671 14672 14706 14671 14699 14721 14699 14672 14672 14720 14721 14768 14721 14720 14671 14670 14672 14672 14670 14667 14700 14672 14667 14700 14720 14672 14669 14670 14671 14670 14869 14828 14670 14828 14667 14869 14670 14870 14669 14870 14670 14828 14869 14829 14829 14869 14870 14827 14826 14828 14827 14828 14829 14826 14667 14828 14825 14826 14827 14827 14880 14825 14825 14853 14826 14853 14667 14826 14852 14853 14825 14825 14880 14882 14825 14882 14852 14852 14854 14853 14854 14666 14853 14853 14666 14667 14837 14854 14852 14852 14882 14884 14852 14884 14837 14882 14883 14884 14837 14884 14883 14835 14836 14837 14837 14836 14854 14837 14883 14835 14836 14664 14854 14664 14666 14854 14835 14834 14836 14664 14836 14834 14833 14834 14835 14833 14839 14834 14839 14663 14834 14664 14834 14663 14855 14687 14839 14663 14839 14687 14661 14662 14663 14663 14662 14664 14661 14663 14687 14661 14687 14686 14687 14855 14686 14691 14661 14686 14704 14661 14691 14704 14662 14661 14703 14664 14662 14707 14703 14662 14707 14662 14704 14747 14704 14746 14746 14704 14691 14707 14704 14711 14711 14704 14747 14711 14712 14707 14713 14707 14712 14713 14703 14707 14774 14712 14711 14774 14711 14747 14774 14747 14775 14775 14747 14746 14691 14745 14746 14775 14746 14776 14776 14746 14745 14775 14789 14774 14776 14789 14775 14773 14712 14774 14774 14789 14790 14774 14790 14773 14773 14713 14712 14714 14703 14713 14773 14714 14713 14772 14714 14773 14809 14772 14773 14773 14790 14809 14703 14714 14715 14772 14715 14714 14702 14665 14703 14703 14665 14664 14703 14715 14702 14702 14715 14716 14772 14716 14715 14702 14668 14665 14716 14668 14702 14664 14665 14666 14668 14666 14665 14667 14666 14668 14701 14667 14668 14717 14668 14716 14717 14701 14668 14771 14717 14716 14771 14716 14772 14718 14701 14717 14770 14718 14717 14770 14717 14771 14700 14667 14701 14701 14718 14700 14700 14718 14719 14769 14719 14718 14769 14718 14770 14770 14807 14769 14771 14807 14770 14808 14807 14771 14808 14771 14772 14808 14772 14809 14824 14807 14808 14815 14808 14809 14813 14824 14808 14813 14808 14815 14769 14807 14806 14824 14806 14807 14768 14719 14769 14769 14806 14768 14805 14768 14806 14821 14805 14806 14821 14806 14824 14812 14821 14824 14812 14824 14813 14820 14805 14821 14812 14820 14821 14750 14811 14812 14750 14812 14751 14813 14788 14812 14812 14788 14751 14811 14820 14812 14811 14823 14820 14749 14785 14811 14749 14811 14750 14785 14823 14811 14819 14802 14823 14785 14819 14823 14799 14800 14819 14819 14800 14801 14819 14801 14802 14785 14799 14819 14801 14764 14802 14764 14801 14763 14763 14801 14800 14762 14800 14761 14761 14800 14799 14763 14800 14762 14762 14729 14763 14763 14729 14728 14763 14728 14764 14764 14728 14727 14729 14697 14728 14729 14696 14697 14696 14729 14730 14762 14730 14729 14761 14730 14762 14696 14730 14695 14731 14695 14730 14761 14731 14730 14696 14676 14697 14695 14676 14696 14695 14679 14676 14732 14695 14731 14732 14679 14695 14760 14732 14731 14760 14731 14761 14733 14679 14732 14733 14732 14760 14784 14733 14760 14798 14784 14760 14798 14760 14799 14761 14799 14760 14689 14679 14733 14689 14733 14734 14784 14734 14733 14783 14734 14784 14784 14798 14783 14783 14798 14797 14797 14798 14816 14816 14798 14799 14785 14816 14799 14810 14816 14785 14810 14797 14816 14783 14797 14796 14810 14796 14797 14759 14810 14785 14758 14810 14759 14748 14785 14749 14785 14748 14759 14644 14758 14759 14644 14759 14708 14708 14759 14748 14708 14748 14652 14652 14748 14749 14652 14749 14659 14659 14749 14750 14659 14750 14710 14710 14750 14751 14659 14710 14657 14710 14751 14752 14710 14752 14657 14752 14751 14788 14657 14752 14753 14752 14788 14753 14753 14788 14813 14657 14753 14709 14709 14753 14754 14753 14813 14814 14753 14814 14754 14815 14814 14813 14754 14814 14755 14755 14814 14787 14815 14790 14814 14814 14790 14822 14814 14822 14787 14709 14754 14755 14709 14651 14657 14709 14755 14651 14655 14651 14650 14655 14657 14651 14656 14657 14655 14656 14659 14657 14895 14656 14655 14895 14655 14896 14896 14655 14650 14896 14650 14897 14897 14650 14648 14897 14648 14898 14898 14918 14897 14897 14918 14896 14898 14648 14899 14899 14918 14898 14918 14913 14914 14921 14913 14918 14896 14918 14914 14899 14921 14918 14900 14921 14899 14921 14912 14913 14921 14920 14912 14921 14901 14920 14900 14901 14921 14913 14907 14914 14913 14912 14907 14912 14906 14907 14920 14906 14912 14906 14905 14907 14907 14905 14908 14914 14907 14908 14904 14905 14906 14920 14904 14906 14908 14905 14909 14909 14905 14910 14904 14910 14905 14911 14908 14909 14914 14908 14911 14915 14909 14910 14919 14911 14909 14919 14909 14915 14916 14915 14910 14917 14910 14904 14917 14916 14910 14917 14904 14920 14891 14892 14917 14892 14916 14917 14891 14917 14903 14903 14917 14920 14916 14919 14915 14893 14919 14916 14893 14916 14892 14891 14654 14892 14892 14654 14660 14892 14660 14893 14653 14654 14891 14903 14653 14891 14902 14653 14903 14903 14920 14902 14902 14920 14901 14901 14645 14902 14902 14645 14653 14645 14652 14653 14653 14652 14654 14654 14652 14659 14654 14659 14660 14660 14659 14658 14893 14660 14658 14658 14659 14656 14893 14658 14656 14893 14656 14894 14894 14656 14895 14894 14919 14893 14895 14919 14894 14895 14896 14919 14896 14911 14919 14896 14914 14911 14645 14644 14652 14708 14652 14644 14787 14822 14791 14787 14791 14792 14822 14790 14789 14822 14789 14791 14789 14776 14791 14791 14776 14777 14777 14792 14791 14778 14792 14777 14776 14744 14777 14777 14744 14743 14777 14743 14778 14776 14745 14744 14692 14743 14744 14692 14744 14691 14691 14744 14745 14692 14685 14743 14743 14685 14742 14778 14743 14742 14691 14686 14692 14692 14686 14685 14815 14809 14790 14783 14796 14782 14782 14796 14795 14782 14736 14783 14783 14736 14735 14783 14735 14734 14781 14737 14782 14782 14737 14736 14782 14795 14781 14705 14735 14736 14705 14736 14681 14737 14681 14736 14705 14734 14735 14689 14734 14705 14705 14681 14689 14680 14681 14682 14681 14680 14688 14681 14688 14689 14694 14682 14681 14737 14694 14681 14738 14694 14737 14781 14738 14737 14682 14832 14846 14682 14846 14680 14831 14846 14832 14831 14845 14846 14845 14680 14846 14844 14845 14831 14831 14871 14876 14831 14876 14844 14844 14851 14845 14680 14845 14851 14844 14850 14851 14850 14688 14851 14680 14851 14688 14849 14848 14850 14849 14850 14844 14688 14850 14848 14689 14688 14677 14688 14848 14677 14847 14848 14849 14847 14858 14848 14858 14677 14848 14844 14875 14849 14849 14875 14874 14849 14874 14847 14844 14876 14875 14874 14875 14876 14874 14876 14889 14847 14874 14889 14871 14873 14876 14876 14873 14890 14876 14890 14889 14847 14889 14856 14856 14889 14890 14856 14890 14859 14859 14890 14873 14859 14873 14863 14859 14860 14856 14863 14864 14859 14859 14864 14865 14859 14865 14860 14856 14857 14847 14856 14860 14857 14678 14860 14865 14860 14678 14857 14864 14673 14865 14865 14673 14678 14863 14862 14864 14673 14864 14862 14676 14678 14673 14677 14678 14679 14679 14678 14676 14677 14857 14678 14847 14857 14858 14677 14858 14857 14689 14677 14679 14768 14720 14719 14700 14719 14720 14922 14923 14924 14943 14922 14944 14944 14922 14924 14956 14923 14922 14956 14922 14943 14959 14956 14943 14959 14943 14972 14943 14944 14972 14944 14924 14930 14944 14930 14945 14971 14944 14945 14972 14944 14971 14937 14959 14972 14937 14972 14938 14938 14972 14971 14958 14956 14959 14937 14958 14959 14937 14923 14936 14938 14923 14937 14936 14960 14937 14937 14960 14958 14938 14924 14923 14941 14924 14938 14938 14971 14941 14936 14923 14935 14955 14935 14923 14955 14923 14956 14954 14935 14955 14957 14954 14955 14955 14956 14958 14960 14955 14958 14960 14957 14955 14961 14957 14960 14936 14961 14960 14953 14957 14951 14957 14953 14954 14962 14951 14957 14962 14957 14961 14953 14935 14954 14952 14927 14953 14953 14927 14935 14951 14952 14953 14951 14925 14952 14952 14925 14927 14925 14926 14927 14932 14927 14926 14927 14934 14935 14934 14927 14932 14950 14926 14925 14950 14925 14951 14949 14926 14950 14967 14950 14964 14964 14950 14951 14949 14950 14967 14968 14949 14967 14933 14967 14932 14932 14967 14964 14933 14968 14967 14964 14951 14963 14932 14964 14963 14963 14951 14962 14932 14963 14934 14934 14963 14962 14934 14962 14961 14934 14961 14936 14936 14935 14934 14932 14926 14933 14928 14929 14926 14933 14926 14929 14949 14928 14926 14948 14929 14928 14948 14928 14949 14948 14949 14947 14968 14947 14949 14947 14929 14948 14946 14931 14947 14931 14929 14947 14946 14947 14945 14965 14966 14947 14965 14947 14968 14969 14947 14966 14970 14945 14947 14970 14947 14969 14942 14965 14968 14942 14968 14933 14939 14966 14965 14939 14965 14942 14939 14969 14966 14939 14970 14969 14971 14945 14970 14940 14971 14970 14940 14970 14939 14939 14931 14940 14939 14929 14931 14942 14929 14939 14933 14929 14942 14930 14924 14931 14940 14931 14924 14945 14930 14931 14945 14931 14946 14940 14924 14941 14941 14971 14940))
                   (list :vertices (let ((mat (make-matrix 14973 3))) (fvector-replace (array-entity mat) #f(5.8334999084472656e+01 2.5305200195312500e+02 3.5848901367187500e+02 3.3097301483154297e+01 2.4316200256347656e+02 3.5885598754882812e+02 5.4506099700927734e+01 2.4274099731445312e+02 3.5885501098632812e+02 2.3980600357055664e+01 2.5317098999023438e+02 3.5849801635742188e+02 7.6454902648925781e+01 2.4197900390625000e+02 3.5885501098632812e+02 9.5703498840332031e+01 2.5119999694824219e+02 3.5848901367187500e+02 9.6807601928710938e+01 2.4062800598144531e+02 3.5885598754882812e+02 7.8682701110839844e+01 -2.4188299560546875e+02 3.5885501098632812e+02 7.2685401916503906e+01 -2.5265899658203125e+02 3.5848901367187500e+02 9.8566703796386719e+01 -2.4040199279785156e+02 3.5885400390625000e+02 9.1912796020507812e+01 -2.5159100341796875e+02 3.5848901367187500e+02 1.0867600250244141e+02 -2.4932600402832031e+02 3.5848901367187500e+02 3.4053096771240234e+01 -2.4311499023437500e+02 3.5885598754882812e+02 2.7162300109863281e+01 -2.5365701293945312e+02 3.5849301147460938e+02 2.8608800888061523e+01 -2.4275199890136719e+02 3.5887301635742188e+02 5.5938899993896484e+01 -2.4269599914550781e+02 3.5885598754882812e+02 2.5239300537109375e+02 1.3548800659179688e+02 3.3466101074218750e+02 2.6220199584960938e+02 1.1530799865722656e+02 3.3465399169921875e+02 2.5616000366210938e+02 1.2824800109863281e+02 3.1883801269531250e+02 1.0517700195312500e+02 -2.6038000488281250e+02 3.1380099487304688e+02 1.0072500610351562e+02 -2.6076699829101562e+02 3.3510198974609375e+02 8.9908195495605469e+01 -2.6203997802734375e+02 3.1329400634765625e+02 8.9154304504394531e+01 -2.6169699096679688e+02 3.3512197875976562e+02 1.3823199462890625e+02 -2.5016299438476562e+02 3.1485998535156250e+02 1.4209899902343750e+02 -2.4855500793457031e+02 3.1498400878906250e+02 1.4442700195312500e+02 -2.4724101257324219e+02 3.3490301513671875e+02 1.5563899230957031e+02 -2.4097299194335938e+02 3.1542797851562500e+02 1.5853900146484375e+02 -2.3895999145507812e+02 3.3484500122070312e+02 1.3853800964355469e+02 -2.5006198120117188e+02 3.3494897460937500e+02 1.2687400054931641e+02 -2.5488900756835938e+02 3.1449801635742188e+02 1.2438700103759766e+02 -2.5550601196289062e+02 3.3501300048828125e+02 1.1994999694824219e+02 -2.5707199096679688e+02 3.1427700805664062e+02 1.2023799896240234e+02 -2.5676199340820312e+02 3.3504800415039062e+02 1.0556600189208984e+02 -2.6005798339843750e+02 3.3508898925781250e+02 1.6953900146484375e+02 -2.3123899841308594e+02 3.3482800292968750e+02 1.7195401000976562e+02 -2.2955699157714844e+02 3.1597998046875000e+02 1.8067900085449219e+02 -2.2233801269531250e+02 3.3480798339843750e+02 1.8067399597167969e+02 -2.2271099853515625e+02 3.1627398681640625e+02 1.8691700744628906e+02 -2.1735299682617188e+02 3.3479602050781250e+02 1.9274600219726562e+02 -2.1217500305175781e+02 3.3478500366210938e+02 1.9744599914550781e+02 -2.0789300537109375e+02 3.1685198974609375e+02 1.9962799072265625e+02 -2.0538499450683594e+02 3.3477200317382812e+02 1.9970199584960938e+02 -2.0556401062011719e+02 3.1692901611328125e+02 2.0856300354003906e+02 -1.9656999206542969e+02 3.3475399780273438e+02 2.1293798828125000e+02 -1.9189700317382812e+02 3.1737899780273438e+02 2.1702099609375000e+02 -1.8682600402832031e+02 3.3473599243164062e+02 2.1704598999023438e+02 -1.8694000244140625e+02 3.1751800537109375e+02 2.2311199951171875e+02 -1.7980999755859375e+02 3.3472399902343750e+02 2.2710501098632812e+02 -1.7480300903320312e+02 3.1786001586914062e+02 2.3273500061035156e+02 -1.6682099914550781e+02 3.3470401000976562e+02 2.3270300292968750e+02 -1.6687600708007812e+02 3.1804901123046875e+02 2.3636900329589844e+02 -1.6191600036621094e+02 3.3469702148437500e+02 2.3992800903320312e+02 -1.5664399719238281e+02 3.1829299926757812e+02 2.4664599609375000e+02 -1.4551899719238281e+02 3.3467700195312500e+02 2.4408900451660156e+02 -1.5004800415039062e+02 3.1843298339843750e+02 2.4660200500488281e+02 -1.4555799865722656e+02 3.1851800537109375e+02 2.4828800964355469e+02 -1.4290000915527344e+02 3.3467297363281250e+02 2.5195599365234375e+02 -1.3630799865722656e+02 3.3466601562500000e+02 2.5504800415039062e+02 -1.3046499633789062e+02 3.1880200195312500e+02 2.5848300170898438e+02 -1.2300199890136719e+02 3.3465499877929688e+02 2.5847399902343750e+02 -1.2304600524902344e+02 3.1891699218750000e+02 2.6174200439453125e+02 -1.1635600280761719e+02 3.3464898681640625e+02 2.6438098144531250e+02 -1.1025099945068359e+02 3.1911502075195312e+02 2.6841598510742188e+02 -9.9587295532226562e+01 3.3463800048828125e+02 2.6833700561523438e+02 -9.9590103149414062e+01 3.1924798583984375e+02 2.6994897460937500e+02 -9.5735496520996094e+01 3.3463601684570312e+02 2.7210101318359375e+02 -8.9447700500488281e+01 3.1937500000000000e+02 2.7655999755859375e+02 -7.4454200744628906e+01 3.3464898681640625e+02 2.7820001220703125e+02 -6.8090400695800781e+01 3.1957901000976562e+02 2.8153198242187500e+02 -5.2600303649902344e+01 3.3462100219726562e+02 2.7997000122070312e+02 -6.0387699127197266e+01 3.1963900756835938e+02 2.8288201904296875e+02 -4.4766197204589844e+01 3.3461999511718750e+02 2.8382800292968750e+02 -3.8316101074218750e+01 3.1976800537109375e+02 2.8518200683593750e+02 -2.5381999969482422e+01 3.3461898803710938e+02 2.8506402587890625e+02 -2.5374900817871094e+01 3.1980999755859375e+02 2.8549700927734375e+02 -2.2731000900268555e+01 3.3461801147460938e+02 2.8594198608398438e+02 -1.6186599731445312e+01 3.1984002685546875e+02 2.8639901733398438e+02 -5.8955800533294678e-01 3.3461801147460938e+02 2.8623101806640625e+02 1.9100400386378169e-03 3.1985000610351562e+02 2.8637799072265625e+02 -1.9099400378763676e-03 3.3461801147460938e+02 2.8633801269531250e+02 5.9622497558593750e+00 3.1985299682617188e+02 2.8558200073242188e+02 2.1628801345825195e+01 3.3461801147460938e+02 2.8517999267578125e+02 2.5386600494384766e+01 3.1981399536132812e+02 2.8515100097656250e+02 2.5376298904418945e+01 3.3461898803710938e+02 2.8501800537109375e+02 2.8106899261474609e+01 3.1980899047851562e+02 2.8301901245117188e+02 4.3893199920654297e+01 3.3461999511718750e+02 2.8411099243164062e+02 3.6151599884033203e+01 3.1977798461914062e+02 2.8169699096679688e+02 5.1714500427246094e+01 3.3461898803710938e+02 2.8041500854492188e+02 5.8276298522949219e+01 3.1965301513671875e+02 2.7684399414062500e+02 7.3402801513671875e+01 3.3462500000000000e+02 2.7616900634765625e+02 7.5384399414062500e+01 3.1951098632812500e+02 2.7623699951171875e+02 7.5382499694824219e+01 3.3462597656250000e+02 2.7505300903320312e+02 7.9881401062011719e+01 3.1947399902343750e+02 2.7034500122070312e+02 9.4606597900390625e+01 3.3463299560546875e+02 2.6805999755859375e+02 1.0093600463867188e+02 3.1922201538085938e+02 2.6839199829101562e+02 9.9572395324707031e+01 3.3463601684570312e+02 2.5944702148437500e+02 1.2143500518798828e+02 3.1894900512695312e+02 2.4983100891113281e+02 1.4016899108886719e+02 3.3466500854492188e+02 2.4665699768066406e+02 1.4557200622558594e+02 3.1851800537109375e+02 2.4658801269531250e+02 1.4547500610351562e+02 3.3467098999023438e+02 2.4536499023437500e+02 1.4792601013183594e+02 3.1847500610351562e+02 2.3823500061035156e+02 1.5913800048828125e+02 3.3468600463867188e+02 2.3317599487304688e+02 1.6655099487304688e+02 3.1803598022460938e+02 2.3270399475097656e+02 1.6678799438476562e+02 3.3469598388671875e+02 2.2522799682617188e+02 1.7713000488281250e+02 3.3470898437500000e+02 2.1962599182128906e+02 1.8413500976562500e+02 3.1760400390625000e+02 2.1701901245117188e+02 1.8681100463867188e+02 3.3472399902343750e+02 2.1709300231933594e+02 1.8694400024414062e+02 3.1751800537109375e+02 2.1082800292968750e+02 1.9411199951171875e+02 3.3473501586914062e+02 2.0474700927734375e+02 2.0063200378417969e+02 3.1709899902343750e+02 1.9964900207519531e+02 2.0538899230957031e+02 3.3475500488281250e+02 1.9922999572753906e+02 2.0614199829101562e+02 3.1691101074218750e+02 1.9503599548339844e+02 2.1004299926757812e+02 3.3476300048828125e+02 1.8068798828125000e+02 2.2233499145507812e+02 3.3478701782226562e+02 1.6034600830078125e+02 2.3768701171875000e+02 3.1558297729492188e+02 1.5628900146484375e+02 2.4051300048828125e+02 3.1544400024414062e+02 1.5440000915527344e+02 2.4159899902343750e+02 3.3483099365234375e+02 1.4965899658203125e+02 2.4451899719238281e+02 3.1522799682617188e+02 1.4090299987792969e+02 2.4894599914550781e+02 3.3489297485351562e+02 1.3825599670410156e+02 2.5018798828125000e+02 3.1486199951171875e+02 1.8483300781250000e+02 2.1921699523925781e+02 3.1641998291015625e+02 1.8073100280761719e+02 2.2247399902343750e+02 3.1627899169921875e+02 1.7654899597167969e+02 2.2587998962402344e+02 3.3479400634765625e+02 1.7033499145507812e+02 2.3072900390625000e+02 3.1592300415039062e+02 1.6036300659179688e+02 2.3761199951171875e+02 3.3481799316406250e+02 1.5852899169921875e+02 2.3894200134277344e+02 3.3482098388671875e+02 1.3649499511718750e+02 2.5093901062011719e+02 3.3491400146484375e+02 1.3604000854492188e+02 2.5128999328613281e+02 3.1479098510742188e+02 1.2225700378417969e+02 2.5613998413085938e+02 3.3498800659179688e+02 1.2192299652099609e+02 2.5644299316406250e+02 3.1434197998046875e+02 1.1428499603271484e+02 2.5824298095703125e+02 3.3502099609375000e+02 1.1424900054931641e+02 2.5829101562500000e+02 3.1409500122070312e+02 1.1314199829101562e+02 2.5854501342773438e+02 3.3502600097656250e+02 1.0734600067138672e+02 2.5995401000976562e+02 3.1387399291992188e+02 1.0071899414062500e+02 2.6073501586914062e+02 3.3506301879882812e+02 1.0287500000000000e+02 2.6068402099609375e+02 3.1372897338867188e+02 8.9155303955078125e+01 2.6194000244140625e+02 3.1326800537109375e+02 8.2133895874023438e+01 2.6221401977539062e+02 3.3507699584960938e+02 8.5407196044921875e+01 2.6228298950195312e+02 3.1314199829101562e+02 7.5613296508789062e+01 2.6253198242187500e+02 3.3509600830078125e+02 4.9038398742675781e+01 2.6364099121093750e+02 3.1188000488281250e+02 3.8361698150634766e+01 2.6352899169921875e+02 3.3511999511718750e+02 4.0700901031494141e+01 2.6380499267578125e+02 3.1012100219726562e+02 3.4334201812744141e+01 2.6390902709960938e+02 3.0713299560546875e+02 2.7094301223754883e+01 2.6379800415039062e+02 3.3242700195312500e+02 3.3139797210693359e+01 2.6366299438476562e+02 3.3517001342773438e+02 1.9758399963378906e+01 2.6397299194335938e+02 3.2656799316406250e+02 2.9466699600219727e+01 2.6397201538085938e+02 3.0280499267578125e+02 2.6844699382781982e+00 2.6414199829101562e+02 3.1342398071289062e+02 2.5466001510620117e+01 2.6401699829101562e+02 2.9767199707031250e+02 -9.9832401275634766e+00 2.6411898803710938e+02 3.0429397583007812e+02 2.3039300918579102e+01 2.6404101562500000e+02 2.9216702270507812e+02 -1.2475299835205078e+01 2.6409597778320312e+02 3.0253500366210938e+02 2.1952699661254883e+01 2.6405001831054688e+02 2.8575701904296875e+02 2.2048599243164062e+01 2.6404898071289062e+02 2.7925598144531250e+02 2.3607000350952148e+01 2.6403497314453125e+02 2.7344702148437500e+02 -1.2477600097656250e+01 2.6410601806640625e+02 2.2004798889160156e+02 2.5080499649047852e+01 2.6401998901367188e+02 2.7024499511718750e+02 2.8482500076293945e+01 2.6398300170898438e+02 2.6527801513671875e+02 -1.5104399919509888e+00 2.6414199829101562e+02 2.2004798889160156e+02 3.0937099456787109e+01 2.6395199584960938e+02 2.6274401855468750e+02 3.5799102783203125e+01 2.6388400268554688e+02 2.5917898559570312e+02 2.2523799896240234e+01 2.6404299926757812e+02 2.2004798889160156e+02 3.4540199279785156e+01 2.6390100097656250e+02 2.2004798889160156e+02 -3.2385299682617188e+01 2.6391400146484375e+02 2.8848498535156250e+02 -1.3527500152587891e+01 2.6410299682617188e+02 2.2004798889160156e+02 -3.7560798645019531e+01 2.6384100341796875e+02 2.2004798889160156e+02 -4.9575897216796875e+01 2.6360501098632812e+02 2.2004798889160156e+02 -6.3307800292968750e+01 2.6316400146484375e+02 2.6771301269531250e+02 -1.0134999847412109e+02 2.6089700317382812e+02 2.1982200622558594e+02 -1.0195100402832031e+02 2.6085699462890625e+02 2.4562199401855469e+02 -9.3673103332519531e+01 2.6167999267578125e+02 2.1981599426269531e+02 -9.3686096191406250e+01 2.6168899536132812e+02 2.4925399780273438e+02 -8.8693595886230469e+01 2.6196899414062500e+02 2.2004798889160156e+02 -6.1589500427246094e+01 2.6328201293945312e+02 2.2004798889160156e+02 -6.3300102233886719e+01 2.6322000122070312e+02 2.2004798889160156e+02 -6.8859596252441406e+01 2.6302999877929688e+02 2.6398400878906250e+02 -7.3600395202636719e+01 2.6284500122070312e+02 2.2004798889160156e+02 -8.9525199890136719e+01 2.6198101806640625e+02 2.5152099609375000e+02 -1.1387200164794922e+02 2.5856301879882812e+02 2.2004798889160156e+02 -1.1389399719238281e+02 2.5872702026367188e+02 2.4216101074218750e+02 -1.0195100402832031e+02 2.6083499145507812e+02 2.2004798889160156e+02 -1.1289800262451172e+02 2.5895300292968750e+02 2.4237699890136719e+02 -1.0338299560546875e+02 2.6066198730468750e+02 2.4511599731445312e+02 -1.3150698852539062e+02 2.5345701599121094e+02 2.1981799316406250e+02 -1.3411900329589844e+02 2.5249900817871094e+02 2.4035699462890625e+02 -1.3213198852539062e+02 2.5326600646972656e+02 2.4029199218750000e+02 -1.1694000244140625e+02 2.5798699951171875e+02 2.1981900024414062e+02 -1.2372899627685547e+02 2.5613000488281250e+02 2.4061399841308594e+02 -1.1521899414062500e+02 2.5842800903320312e+02 2.4187500000000000e+02 -1.5887100219726562e+02 2.3950799560546875e+02 2.2004798889160156e+02 -1.6032899475097656e+02 2.3845700073242188e+02 2.2004798889160156e+02 -1.5886599731445312e+02 2.3963198852539062e+02 2.4630000305175781e+02 -1.5230200195312500e+02 2.4370298767089844e+02 2.4370600891113281e+02 -1.5021101379394531e+02 2.4488999938964844e+02 2.4304699707031250e+02 -1.4524101257324219e+02 2.4744000244140625e+02 2.1981799316406250e+02 -1.4228401184082031e+02 2.4896099853515625e+02 2.4122000122070312e+02 -1.8075199890136719e+02 2.2348100280761719e+02 2.6108398437500000e+02 -1.7574598693847656e+02 2.2755900573730469e+02 2.5700900268554688e+02 -1.8072000122070312e+02 2.2329199218750000e+02 2.2004798889160156e+02 -1.6915098571777344e+02 2.3249700927734375e+02 2.5242599487304688e+02 -1.7712399291992188e+02 2.2634098815917969e+02 2.1981799316406250e+02 -1.6095100402832031e+02 2.3823899841308594e+02 2.4744599914550781e+02 -1.8756100463867188e+02 2.1793299865722656e+02 2.6662701416015625e+02 -1.9970500183105469e+02 2.0641299438476562e+02 2.2004798889160156e+02 -1.9866000366210938e+02 2.0786898803710938e+02 2.7750302124023438e+02 -1.9409599304199219e+02 2.1196499633789062e+02 2.1981700134277344e+02 -2.1720799255371094e+02 1.8819299316406250e+02 3.0084500122070312e+02 -2.1234300231933594e+02 1.9386000061035156e+02 2.9379998779296875e+02 -2.1714498901367188e+02 1.8795100402832031e+02 2.2004798889160156e+02 -2.0904800415039062e+02 1.9741299438476562e+02 2.8955099487304688e+02 -2.0983900451660156e+02 1.9638900756835938e+02 2.1981900024414062e+02 -2.2918699645996094e+02 1.7341700744628906e+02 2.2004798889160156e+02 -2.3292100524902344e+02 1.6805799865722656e+02 2.2004798889160156e+02 -2.2350099182128906e+02 1.8086299133300781e+02 3.0995700073242188e+02 -2.3304299926757812e+02 1.6827900695800781e+02 3.2647698974609375e+02 -2.2438299560546875e+02 1.7959100341796875e+02 2.2004798889160156e+02 -2.3727198791503906e+02 1.6226699829101562e+02 3.3267999267578125e+02 -2.3598800659179688e+02 1.6413900756835938e+02 3.3121499633789062e+02 -2.4682800292968750e+02 1.4681201171875000e+02 2.2004798889160156e+02 -2.3408399963378906e+02 1.6685899353027344e+02 3.2832400512695312e+02 -2.3355500793457031e+02 1.6760400390625000e+02 3.2736300659179688e+02 -2.4111900329589844e+02 1.5647299194335938e+02 3.3464801025390625e+02 -2.3988800048828125e+02 1.5835798645019531e+02 3.3443499755859375e+02 -2.3877499389648438e+02 1.6003799438476562e+02 3.3389498901367188e+02 -2.4204600524902344e+02 1.5496200561523438e+02 2.2004798889160156e+02 -2.6884298706054688e+02 1.0110100555419922e+02 2.2004798889160156e+02 -2.6614498901367188e+02 1.0848200225830078e+02 3.3462100219726562e+02 -2.6303900146484375e+02 1.1579799652099609e+02 2.2004798889160156e+02 -2.6237802124023438e+02 1.1730699920654297e+02 3.3462399291992188e+02 -2.5883099365234375e+02 1.2443699645996094e+02 2.2004798889160156e+02 -2.5883901977539062e+02 1.2447500610351562e+02 3.3462701416015625e+02 -2.5332701110839844e+02 1.3573800659179688e+02 2.2004798889160156e+02 -2.5251600646972656e+02 1.3728199768066406e+02 3.3463299560546875e+02 -2.4681698608398438e+02 1.4687899780273438e+02 3.3464102172851562e+02 -2.7662500000000000e+02 7.7957099914550781e+01 2.2004798889160156e+02 -2.7689001464843750e+02 7.7009796142578125e+01 2.2502699279785156e+02 -2.7118600463867188e+02 9.5165794372558594e+01 2.2004798889160156e+02 -2.7689001464843750e+02 7.7009796142578125e+01 3.3461801147460938e+02 -2.7375500488281250e+02 8.7505500793457031e+01 3.3461801147460938e+02 -2.7689001464843750e+02 7.7009796142578125e+01 2.7722000122070312e+02 3.8352500915527344e+01 2.6382000732421875e+02 2.2004798889160156e+02 4.1849899291992188e+01 2.6377999877929688e+02 2.5671600341796875e+02 4.9038898468017578e+01 2.6363598632812500e+02 2.5534298706054688e+02 5.8570602416992188e+01 2.6339001464843750e+02 2.2004798889160156e+02 7.4256599426269531e+01 2.6283801269531250e+02 2.5446900939941406e+02 8.9149803161621094e+01 2.6190298461914062e+02 2.2004798889160156e+02 7.0727104187011719e+01 2.6298001098632812e+02 2.1980999755859375e+02 8.9750602722167969e+01 2.6198199462890625e+02 2.5393501281738281e+02 9.4596397399902344e+01 2.6158599853515625e+02 2.2004798889160156e+02 1.0055100250244141e+02 2.6095397949218750e+02 2.1980099487304688e+02 1.0486300659179688e+02 2.6034100341796875e+02 2.5343298339843750e+02 1.1429399871826172e+02 2.5826199340820312e+02 2.2004798889160156e+02 1.1426699829101562e+02 2.5822897338867188e+02 2.5312298583984375e+02 1.1644699859619141e+02 2.5784100341796875e+02 2.1981300354003906e+02 1.1945100402832031e+02 2.5706402587890625e+02 2.5295201110839844e+02 1.3159100341796875e+02 2.5282600402832031e+02 2.2004798889160156e+02 1.2691399383544922e+02 2.5467700195312500e+02 2.5270301818847656e+02 1.3831800842285156e+02 2.4988200378417969e+02 2.2004798889160156e+02 1.4219099426269531e+02 2.4819400024414062e+02 2.5219100952148438e+02 1.3951901245117188e+02 2.4935699462890625e+02 2.1981100463867188e+02 1.5322799682617188e+02 2.4191999816894531e+02 2.2004798889160156e+02 1.5740699768066406e+02 2.3944898986816406e+02 2.5168600463867188e+02 1.5831999206542969e+02 2.3867599487304688e+02 2.2004798889160156e+02 1.6038099670410156e+02 2.3723199462890625e+02 2.2004798889160156e+02 1.6034500122070312e+02 2.3735299682617188e+02 2.5158798217773438e+02 1.7009001159667969e+02 2.3043299865722656e+02 2.1981700134277344e+02 1.7464399719238281e+02 2.2715600585937500e+02 2.5110998535156250e+02 1.8069000244140625e+02 2.2195500183105469e+02 2.2004798889160156e+02 1.7955499267578125e+02 2.2328599548339844e+02 2.5094598388671875e+02 1.8077500915527344e+02 2.2222100830078125e+02 2.5090501403808594e+02 1.8748199462890625e+02 2.1651899719238281e+02 2.1981799316406250e+02 1.9968800354003906e+02 2.0509199523925781e+02 2.2004798889160156e+02 1.9644099426269531e+02 2.0855200195312500e+02 2.5038099670410156e+02 1.9969000244140625e+02 2.0523800659179688e+02 2.5027299499511719e+02 2.0367399597167969e+02 2.0136100769042969e+02 2.1981799316406250e+02 2.1714100646972656e+02 1.8663200378417969e+02 2.2004798889160156e+02 2.1200900268554688e+02 1.9267300415039062e+02 2.4986100769042969e+02 2.1704499816894531e+02 1.8666999816894531e+02 2.4969300842285156e+02 2.1871200561523438e+02 1.8491398620605469e+02 2.2004798889160156e+02 2.2357699584960938e+02 1.7900000000000000e+02 2.2004798889160156e+02 2.2625599670410156e+02 1.7569300842285156e+02 2.4938499450683594e+02 2.3274600219726562e+02 1.6659001159667969e+02 2.2004798889160156e+02 2.3271400451660156e+02 1.6666198730468750e+02 2.4916900634765625e+02 2.3673999023437500e+02 1.6118598937988281e+02 2.1981799316406250e+02 2.3916400146484375e+02 1.5764201354980469e+02 2.4895300292968750e+02 2.4665400695800781e+02 1.4533799743652344e+02 2.2004798889160156e+02 2.4332598876953125e+02 1.5112799072265625e+02 2.4881399536132812e+02 2.4658801269531250e+02 1.4537799072265625e+02 2.4870500183105469e+02 2.4850300598144531e+02 1.4238099670410156e+02 2.2004798889160156e+02 2.5865499877929688e+02 1.2295100402832031e+02 2.2004798889160156e+02 2.5438401794433594e+02 1.3163900756835938e+02 2.4844400024414062e+02 2.5847100830078125e+02 1.2291699981689453e+02 2.4830700683593750e+02 2.5879498291015625e+02 1.2268300628662109e+02 2.2004798889160156e+02 2.6759100341796875e+02 1.0208200073242188e+02 2.2004798889160156e+02 2.6381799316406250e+02 1.1151000213623047e+02 2.4812799072265625e+02 2.6852200317382812e+02 9.9538497924804688e+01 2.2004798889160156e+02 2.6834698486328125e+02 9.9507598876953125e+01 2.4797599792480469e+02 2.7022000122070312e+02 9.4903099060058594e+01 2.2004798889160156e+02 2.7164099121093750e+02 9.0779197692871094e+01 2.4786599731445312e+02 2.7625097656250000e+02 7.5336097717285156e+01 2.2004798889160156e+02 2.7614501953125000e+02 7.5326896667480469e+01 2.4771499633789062e+02 2.7675399780273438e+02 7.3706405639648438e+01 2.2004798889160156e+02 2.7784799194335938e+02 6.9483505249023438e+01 2.4765800476074219e+02 2.8162197875976562e+02 5.2095199584960938e+01 2.2004798889160156e+02 2.7963098144531250e+02 6.1910396575927734e+01 2.4759800720214844e+02 2.8184500122070312e+02 5.0560398101806641e+01 2.2004798889160156e+02 2.8168499755859375e+02 5.0539299011230469e+01 2.4752900695800781e+02 2.8481399536132812e+02 3.0102100372314453e+01 2.2004798889160156e+02 2.8361199951171875e+02 3.9870098114013672e+01 2.4746499633789062e+02 2.8512701416015625e+02 2.5374500274658203e+01 2.2004798889160156e+02 2.8639599609375000e+02 -9.5446192426607013e-04 2.2004798889160156e+02 2.8629498291015625e+02 7.7508702278137207e+00 2.2004798889160156e+02 2.8584899902343750e+02 1.7761899948120117e+01 2.4738800048828125e+02 2.8636599731445312e+02 -4.3800501823425293e+00 2.4737100219726562e+02 2.8554901123046875e+02 -2.2067100524902344e+01 2.2004798889160156e+02 2.8523098754882812e+02 -2.5386798858642578e+01 2.4740899658203125e+02 2.8516400146484375e+02 -2.5373699188232422e+01 2.2004798889160156e+02 2.8516900634765625e+02 -2.6524900436401367e+01 2.4741099548339844e+02 2.8434399414062500e+02 -3.4260700225830078e+01 2.4743899536132812e+02 2.8298898315429688e+02 -4.4068599700927734e+01 2.2004798889160156e+02 2.8173199462890625e+02 -5.0554100036621094e+01 2.4752700805664062e+02 2.8172299194335938e+02 -5.0536098480224609e+01 2.2004798889160156e+02 2.8079699707031250e+02 -5.6383899688720703e+01 2.4755899047851562e+02 2.7870300292968750e+02 -6.5957397460937500e+01 2.1981799316406250e+02 2.7610098266601562e+02 -7.5298500061035156e+01 2.2004798889160156e+02 2.7558099365234375e+02 -7.7997001647949219e+01 2.4773399353027344e+02 2.7272000122070312e+02 -8.7458297729492188e+01 2.2004798889160156e+02 2.7028500366210938e+02 -9.4717193603515625e+01 2.2004798889160156e+02 2.6873001098632812e+02 -9.9076301574707031e+01 2.4796299743652344e+02 2.6214599609375000e+02 -1.1534700012207031e+02 2.2004798889160156e+02 2.6026202392578125e+02 -1.1958599853515625e+02 2.4824699401855469e+02 2.5848300170898438e+02 -1.2286999511718750e+02 2.2004798889160156e+02 2.5700302124023438e+02 -1.2644700622558594e+02 2.4835600280761719e+02 2.5241101074218750e+02 -1.3533599853515625e+02 2.1981700134277344e+02 2.4656399536132812e+02 -1.4529199218750000e+02 2.2004798889160156e+02 2.4633898925781250e+02 -1.4616400146484375e+02 2.4871299743652344e+02 2.4115798950195312e+02 -1.5450000000000000e+02 2.1981599426269531e+02 2.3272999572753906e+02 -1.6658799743652344e+02 2.2004798889160156e+02 2.3427000427246094e+02 -1.6484500122070312e+02 2.4911500549316406e+02 2.3282099914550781e+02 -1.6674600219726562e+02 2.4916400146484375e+02 2.2839500427246094e+02 -1.7281100463867188e+02 2.2004798889160156e+02 2.2369700622558594e+02 -1.7884999084472656e+02 2.2004798889160156e+02 2.2083699035644531e+02 -1.8247799682617188e+02 2.4956401062011719e+02 2.1703800964355469e+02 -1.8655000305175781e+02 2.2004798889160156e+02 2.1707199096679688e+02 -1.8669799804687500e+02 2.4969000244140625e+02 2.0920401000976562e+02 -1.9560700988769531e+02 2.1981799316406250e+02 2.0606399536132812e+02 -1.9903999328613281e+02 2.5005799865722656e+02 1.9965100097656250e+02 -2.0506500244140625e+02 2.2004798889160156e+02 2.0067800903320312e+02 -2.0448100280761719e+02 2.5023698425292969e+02 1.9976300048828125e+02 -2.0532099914550781e+02 2.5026800537109375e+02 1.9344400024414062e+02 -2.1120800781250000e+02 2.2004798889160156e+02 1.8071200561523438e+02 -2.2199400329589844e+02 2.2004798889160156e+02 1.8607299804687500e+02 -2.1788400268554688e+02 2.5072601318359375e+02 1.8072200012207031e+02 -2.2216600036621094e+02 2.5090399169921875e+02 1.7651599121093750e+02 -2.2554899597167969e+02 2.1981399536132812e+02 1.7125399780273438e+02 -2.2974200439453125e+02 2.5122100830078125e+02 1.6035800170898438e+02 -2.3720599365234375e+02 2.2004798889160156e+02 1.6034799194335938e+02 -2.3737500000000000e+02 2.5158399963378906e+02 1.5831999206542969e+02 -2.3867599487304688e+02 2.2004798889160156e+02 1.5676200866699219e+02 -2.3988400268554688e+02 2.5170401000976562e+02 1.4439299011230469e+02 -2.4692698669433594e+02 2.1981201171875000e+02 1.4954400634765625e+02 -2.4428201293945312e+02 2.5194200134277344e+02 1.3823799133300781e+02 -2.4971299743652344e+02 2.2004798889160156e+02 1.3607199096679688e+02 -2.5107299804687500e+02 2.5239300537109375e+02 8.4029693603515625e+01 -2.6236798095703125e+02 2.5412699890136719e+02 8.9150695800781250e+01 -2.6195700073242188e+02 2.2004798889160156e+02 8.9146194458007812e+01 -2.6192199707031250e+02 2.5395399475097656e+02 9.2418601989746094e+01 -2.6177099609375000e+02 2.2004798889160156e+02 1.0187999725341797e+02 -2.6081201171875000e+02 2.5352600097656250e+02 1.0058300018310547e+02 -2.6095101928710938e+02 2.2004798889160156e+02 1.0776899719238281e+02 -2.5984899902343750e+02 2.5333300781250000e+02 1.0654000091552734e+02 -2.6003100585937500e+02 2.1977999877929688e+02 1.1425700378417969e+02 -2.5823797607421875e+02 2.5311898803710938e+02 1.1426499938964844e+02 -2.5817498779296875e+02 2.2004798889160156e+02 1.2213999938964844e+02 -2.5627899169921875e+02 2.5285801696777344e+02 1.2091500091552734e+02 -2.5657699584960938e+02 2.1981300354003906e+02 1.2985198974609375e+02 -2.5350999450683594e+02 2.1981201171875000e+02 4.1361099243164062e+01 -2.6379998779296875e+02 2.5675601196289062e+02 3.6192497253417969e+01 -2.6387597656250000e+02 2.2004798889160156e+02 4.9037696838378906e+01 -2.6364700317382812e+02 2.5534098815917969e+02 4.8208301544189453e+01 -2.6365301513671875e+02 2.2004798889160156e+02 6.0222499847412109e+01 -2.6334197998046875e+02 2.2004798889160156e+02 7.2152503967285156e+01 -2.6292199707031250e+02 2.1981100463867188e+02 2.6434499740600586e+01 -2.6401300048828125e+02 2.6808200073242188e+02 2.3036598205566406e+01 -2.6404800415039062e+02 2.7505499267578125e+02 -1.2481199264526367e+01 -2.6407901000976562e+02 2.2004798889160156e+02 3.4333000183105469e+01 -2.6391400146484375e+02 2.6008798217773438e+02 1.2158400535583496e+01 -2.6411502075195312e+02 2.2004798889160156e+02 1.4104500412940979e-01 -2.6414199829101562e+02 2.2004798889160156e+02 3.1525100708007812e+01 -2.6395300292968750e+02 2.6221902465820312e+02 -1.2465600013732910e+01 -2.6404397583007812e+02 3.0265899658203125e+02 2.1881601333618164e+01 -2.6405902099609375e+02 2.8621499633789062e+02 2.3602100372314453e+01 -2.6404602050781250e+02 2.9377600097656250e+02 -5.8564800024032593e-01 -2.6414199829101562e+02 3.1106500244140625e+02 2.6736299991607666e+00 -2.6414300537109375e+02 3.1342398071289062e+02 2.8476400375366211e+01 -2.6399801635742188e+02 3.0194400024414062e+02 3.0930700302124023e+01 -2.6397000122070312e+02 3.0447799682617188e+02 2.7016599655151367e+01 -2.6378900146484375e+02 3.3247598266601562e+02 3.5792201995849609e+01 -2.6390600585937500e+02 3.0804199218750000e+02 4.4733200073242188e+01 -2.6375698852539062e+02 3.1138598632812500e+02 3.8359298706054688e+01 -2.6355999755859375e+02 3.3517599487304688e+02 3.2928897857666016e+01 -2.6364999389648438e+02 3.3546502685546875e+02 -3.6177200317382812e+01 -2.6384799194335938e+02 2.8588198852539062e+02 -6.3312397003173828e+01 -2.6316198730468750e+02 2.6771398925781250e+02 -3.5910301208496094e+01 -2.6386700439453125e+02 2.2004798889160156e+02 -2.3893701553344727e+01 -2.6402099609375000e+02 2.2004798889160156e+02 -6.9201904296875000e+01 -2.6301300048828125e+02 2.6377099609375000e+02 -6.3306301116943359e+01 -2.6321499633789062e+02 2.2004798889160156e+02 -5.9940898895263672e+01 -2.6333200073242188e+02 2.2004798889160156e+02 -7.4300292968750000e+01 -2.6281100463867188e+02 2.6053698730468750e+02 -8.6151397705078125e+01 -2.6221499633789062e+02 2.5336399841308594e+02 -7.1851402282714844e+01 -2.6291799926757812e+02 2.1980999755859375e+02 -8.8697402954101562e+01 -2.6191699218750000e+02 2.2004798889160156e+02 -9.6873405456542969e+01 -2.6142300415039062e+02 2.4764199829101562e+02 -1.0166099548339844e+02 -2.6090197753906250e+02 2.4567700195312500e+02 -1.0131199645996094e+02 -2.6090600585937500e+02 2.1980300903320312e+02 -9.5966194152832031e+01 -2.6148400878906250e+02 2.2004798889160156e+02 -1.0480800628662109e+02 -2.6046899414062500e+02 2.4457000732421875e+02 -1.0195100402832031e+02 -2.6083697509765625e+02 2.2004798889160156e+02 -1.1387500000000000e+02 -2.5854400634765625e+02 2.2004798889160156e+02 -1.1380200195312500e+02 -2.5877401733398438e+02 2.4211099243164062e+02 -1.1743000030517578e+02 -2.5786099243164062e+02 2.1981799316406250e+02 -1.2247000122070312e+02 -2.5652700805664062e+02 2.4067799377441406e+02 -1.2419799804687500e+02 -2.5600497436523438e+02 2.4050801086425781e+02 -1.3170401000976562e+02 -2.5338700866699219e+02 2.1981799316406250e+02 -1.3258900451660156e+02 -2.5310998535156250e+02 2.4024600219726562e+02 -1.3801699829101562e+02 -2.5060299682617188e+02 2.2004798889160156e+02 -1.3938299560546875e+02 -2.5026300048828125e+02 2.4081599426269531e+02 -1.4565100097656250e+02 -2.4723400878906250e+02 2.1981799316406250e+02 -1.5886599731445312e+02 -2.3964299011230469e+02 2.4626800537109375e+02 -1.6034799194335938e+02 -2.3845899963378906e+02 2.1981399536132812e+02 -1.5134201049804688e+02 -2.4426499938964844e+02 2.4335600280761719e+02 -1.5887199401855469e+02 -2.3950799560546875e+02 2.2004798889160156e+02 -1.4327000427246094e+02 -2.4850300598144531e+02 2.4134700012207031e+02 -1.6035200500488281e+02 -2.3862199401855469e+02 2.4713499450683594e+02 -1.7360598754882812e+02 -2.2905000305175781e+02 2.1981799316406250e+02 -1.7096499633789062e+02 -2.3118099975585938e+02 2.5359898376464844e+02 -1.8068200683593750e+02 -2.2324299621582031e+02 2.2004798889160156e+02 -1.8076699829101562e+02 -2.2351499938964844e+02 2.6100000000000000e+02 -1.9077200317382812e+02 -2.1496200561523438e+02 2.1981799316406250e+02 -1.8340699768066406e+02 -2.2145100402832031e+02 2.6299301147460938e+02 -1.9969700622558594e+02 -2.0640200805664062e+02 2.2004798889160156e+02 -1.9538499450683594e+02 -2.1096499633789062e+02 2.7405499267578125e+02 -1.9981500244140625e+02 -2.0673100280761719e+02 2.7878601074218750e+02 -2.0676399230957031e+02 -1.9962500000000000e+02 2.1981799316406250e+02 -2.0186900329589844e+02 -2.0476800537109375e+02 2.8097900390625000e+02 -2.1717199707031250e+02 -1.8797200012207031e+02 2.2004798889160156e+02 -2.3522700500488281e+02 -1.6513099670410156e+02 2.2004798889160156e+02 -2.3556600952148438e+02 -1.6475300598144531e+02 3.3064300537109375e+02 -2.3963600158691406e+02 -1.5866400146484375e+02 2.2004798889160156e+02 -2.3711399841308594e+02 -1.6250399780273438e+02 3.3251800537109375e+02 -2.3909600830078125e+02 -1.5955899047851562e+02 3.3407199096679688e+02 -2.1396400451660156e+02 -1.9208399963378906e+02 2.9593200683593750e+02 -2.1722100830078125e+02 -1.8821699523925781e+02 3.0078500366210938e+02 -2.2159300231933594e+02 -1.8302200317382812e+02 2.2004798889160156e+02 -2.2523899841308594e+02 -1.7869900512695312e+02 3.1273001098632812e+02 -2.3297299194335938e+02 -1.6808900451660156e+02 2.2004798889160156e+02 -2.3304499816894531e+02 -1.6829000854492188e+02 3.2645602416992188e+02 -2.3356098937988281e+02 -1.6760200500488281e+02 3.2736300659179688e+02 -2.7689001464843750e+02 -7.7009796142578125e+01 3.3461801147460938e+02 -2.7689001464843750e+02 -7.7009796142578125e+01 3.2941201782226562e+02 -2.7143798828125000e+02 -9.4449996948242188e+01 3.3461898803710938e+02 -2.6969900512695312e+02 -9.9302001953125000e+01 2.2004798889160156e+02 -2.6882998657226562e+02 -1.0110600280761719e+02 3.3462100219726562e+02 -2.6894097900390625e+02 -1.0113899993896484e+02 2.2004798889160156e+02 -2.6328997802734375e+02 -1.1524400329589844e+02 3.3462399291992188e+02 -2.6120300292968750e+02 -1.1988300323486328e+02 2.2004798889160156e+02 -2.5878799438476562e+02 -1.2445300292968750e+02 3.3462899780273438e+02 -2.5888400268554688e+02 -1.2446100616455078e+02 2.2004798889160156e+02 -2.5251298522949219e+02 -1.3729000854492188e+02 3.3463497924804688e+02 -2.5117799377441406e+02 -1.3967500305175781e+02 2.2004798889160156e+02 -2.4681698608398438e+02 -1.4688099670410156e+02 3.3464300537109375e+02 -2.4683799743652344e+02 -1.4681500244140625e+02 2.2004798889160156e+02 -2.4112300109863281e+02 -1.5647000122070312e+02 3.3465100097656250e+02 -2.7689001464843750e+02 -7.7009796142578125e+01 2.2502699279785156e+02 -2.7662500000000000e+02 -7.7957099914550781e+01 2.2004798889160156e+02 -2.7693399047851562e+02 -7.6724800109863281e+01 2.1981100463867188e+02 4.9619800567626953e+01 -2.6336602783203125e+02 3.3516699218750000e+02 4.9027000427246094e+01 -2.6366900634765625e+02 3.1187701416015625e+02 8.2974098205566406e+01 -2.6219400024414062e+02 3.3513198852539062e+02 7.4254501342773438e+01 -2.6289199829101562e+02 3.1274899291992188e+02 3.3792400360107422e+01 -2.5964199829101562e+02 3.4956600952148438e+02 3.3649799346923828e+01 -2.6076300048828125e+02 3.4720297241210938e+02 4.9552799224853516e+01 -2.6048999023437500e+02 3.4720501708984375e+02 6.6607200622558594e+01 -2.5989300537109375e+02 3.4720700073242188e+02 8.2812500000000000e+01 -2.5932800292968750e+02 3.4720199584960938e+02 8.3094596862792969e+01 -2.5469100952148438e+02 3.5677297973632812e+02 9.2116294860839844e+01 -2.5419100952148438e+02 3.5677297973632812e+02 1.0034700012207031e+02 -2.5792300415039062e+02 3.4721401977539062e+02 9.9739700317382812e+01 -2.5318699645996094e+02 3.5731100463867188e+02 3.4203201293945312e+01 -2.5641799926757812e+02 3.5635998535156250e+02 5.3504096984863281e+01 -2.5586700439453125e+02 3.5677499389648438e+02 6.6457702636718750e+01 -2.5546199035644531e+02 3.5677401733398438e+02 7.2789993286132812e+01 -2.5526300048828125e+02 3.5677401733398438e+02 3.4266300201416016e+01 2.5681701660156250e+02 3.5556997680664062e+02 3.1287900924682617e+01 2.5576100158691406e+02 3.5756799316406250e+02 4.0487098693847656e+01 2.5612802124023438e+02 3.5677401733398438e+02 9.2162803649902344e+01 2.5416799926757812e+02 3.5677200317382812e+02 9.9794898986816406e+01 2.5315698242187500e+02 3.5731698608398438e+02 1.0034299468994141e+02 2.5789401245117188e+02 3.4722201538085938e+02 7.3282897949218750e+01 2.5523098754882812e+02 3.5677297973632812e+02 8.1993202209472656e+01 2.5934799194335938e+02 3.4721801757812500e+02 7.5269203186035156e+01 2.5967300415039062e+02 3.4720800781250000e+02 4.0563598632812500e+01 2.6059698486328125e+02 3.4721499633789062e+02 3.3128101348876953e+01 2.6074600219726562e+02 3.4746899414062500e+02 3.3890899658203125e+01 2.5968600463867188e+02 3.4951800537109375e+02 5.3595699310302734e+01 2.5587600708007812e+02 3.5677297973632812e+02 6.9840202331542969e+01 -2.5656100463867188e+02 2.6884201049804688e+02 6.9840202331542969e+01 -2.5656100463867188e+02 2.9837100219726562e+02 4.9369598388671875e+01 -2.5727600097656250e+02 2.6951101684570312e+02 4.0541202545166016e+01 -2.5758401489257812e+02 2.9394998168945312e+02 3.5855300903320312e+01 -2.5774801635742188e+02 2.8218902587890625e+02 3.7019401550292969e+01 -2.5783200073242188e+02 2.7587597656250000e+02 4.0583801269531250e+01 -2.5758801269531250e+02 2.7202001953125000e+02 3.5701000213623047e+01 -2.5786297607421875e+02 2.8853500366210938e+02 6.9840202331542969e+01 2.5656100463867188e+02 2.9838601684570312e+02 4.4455902099609375e+01 2.5744799804687500e+02 2.7138000488281250e+02 4.4495899200439453e+01 2.5744598388671875e+02 2.9644799804687500e+02 6.9840202331542969e+01 2.5656100463867188e+02 2.6883599853515625e+02 3.7438999176025391e+01 2.5769299316406250e+02 2.8915798950195312e+02 3.5776500701904297e+01 2.5786700439453125e+02 2.7848800659179688e+02 -8.3660995483398438e+01 2.6071398925781250e+02 2.1968600463867188e+02 -1.0169800567626953e+02 2.5892498779296875e+02 2.1962599182128906e+02 -1.0183499908447266e+02 2.5995800781250000e+02 2.1975299072265625e+02 3.1247900009155273e+01 2.6306301879882812e+02 2.1975299072265625e+02 9.0357803344726562e+01 2.6104199218750000e+02 2.1975299072265625e+02 -6.2987899780273438e+01 2.6235501098632812e+02 2.1975299072265625e+02 -6.8495597839355469e+01 2.6300299072265625e+02 2.1980400085449219e+02 -1.5102599859237671e+00 2.6390902709960938e+02 2.1979899597167969e+02 5.2299400329589844e+01 2.6198101806640625e+02 2.1969099426269531e+02 -2.1383199691772461e+00 2.6262500000000000e+02 2.1970700073242188e+02 -4.8444301605224609e+01 2.6200900268554688e+02 2.1967900085449219e+02 8.9859199523925781e+01 2.6011898803710938e+02 2.1964199829101562e+02 9.9560699462890625e+01 2.5917498779296875e+02 2.1962001037597656e+02 -8.3524505615234375e+01 2.6043399047851562e+02 2.1803799438476562e+02 -1.0169900512695312e+02 2.5892498779296875e+02 2.1772399902343750e+02 -1.0168900299072266e+02 2.5885098266601562e+02 2.1867500305175781e+02 9.0596694946289062e+01 2.5990499877929688e+02 2.1867500305175781e+02 3.3840801239013672e+01 2.6195700073242188e+02 2.1939698791503906e+02 6.4755996704101562e+01 2.6134197998046875e+02 2.1949900817871094e+02 3.1595800399780273e+01 2.6192199707031250e+02 2.1867500305175781e+02 -5.7871498107910156e+01 2.6144097900390625e+02 2.1938999938964844e+02 -3.4895500183105469e+01 2.6191900634765625e+02 2.1933500671386719e+02 -6.2744400024414062e+01 2.6122497558593750e+02 2.1867500305175781e+02 -5.5971698760986328e+00 2.6213500976562500e+02 2.1920899963378906e+02 -2.5971498489379883e+00 2.6226498413085938e+02 2.1954100036621094e+02 -8.3720695495605469e+01 2.6042102050781250e+02 2.1931100463867188e+02 -5.7790100097656250e+01 2.6144299316406250e+02 2.1796299743652344e+02 -5.2395802736282349e-01 2.6222598266601562e+02 2.1790499877929688e+02 3.5128196716308594e+01 2.6196099853515625e+02 2.1785099792480469e+02 -5.5971698760986328e+00 2.6213500976562500e+02 2.1814100646972656e+02 -3.4538600921630859e+01 2.6191500854492188e+02 2.1803799438476562e+02 9.9398300170898438e+01 2.5920800781250000e+02 2.1771900939941406e+02 8.7798995971679688e+01 2.6021798706054688e+02 2.1772299194335938e+02 6.4829498291015625e+01 2.6133499145507812e+02 2.1782299804687500e+02 5.4760002136230469e+01 2.6149401855468750e+02 2.1814100646972656e+02 1.0032500457763672e+02 2.5896499633789062e+02 2.1867500305175781e+02 8.2241500854492188e+01 -2.6080099487304688e+02 2.1968600463867188e+02 1.0032399749755859e+02 -2.5904598999023438e+02 2.1963900756835938e+02 -6.4183700561523438e+01 -2.6163598632812500e+02 2.1970799255371094e+02 -2.9021900177001953e+01 -2.6223999023437500e+02 2.1966099548339844e+02 -3.3552200317382812e+01 -2.6302099609375000e+02 2.1975299072265625e+02 6.1236099243164062e+01 -2.6242700195312500e+02 2.1975299072265625e+02 4.7016502380371094e+01 -2.6205502319335938e+02 2.1967900085449219e+02 -9.1909896850585938e+01 -2.6093301391601562e+02 2.1975299072265625e+02 -8.8950904846191406e+01 -2.6014599609375000e+02 2.1964100646972656e+02 -1.0087799835205078e+02 -2.5934402465820312e+02 2.1969699096679688e+02 1.4107799530029297e-01 -2.6391000366210938e+02 2.1979899597167969e+02 4.4438800811767578e+01 -2.6366601562500000e+02 2.1980400085449219e+02 1.0033499908447266e+02 -2.5904000854492188e+02 2.1772399902343750e+02 1.0032500457763672e+02 -2.5896499633789062e+02 2.1867500305175781e+02 8.2126899719238281e+01 -2.6051901245117188e+02 2.1803799438476562e+02 6.0994400024414062e+01 -2.6129901123046875e+02 2.1867500305175781e+02 5.6469600677490234e+01 -2.6149401855468750e+02 2.1796501159667969e+02 1.1191999912261963e+00 -2.6227999877929688e+02 2.1779200744628906e+02 -3.3892097473144531e+01 -2.6187802124023438e+02 2.1867500305175781e+02 -3.6243400573730469e+01 -2.6193197631835938e+02 2.1785099792480469e+02 4.2216801643371582e+00 -2.6213900756835938e+02 2.1814100646972656e+02 3.3009799957275391e+01 -2.6195098876953125e+02 2.1802999877929688e+02 -9.0624694824218750e+01 -2.6003799438476562e+02 2.1773100280761719e+02 -6.6266403198242188e+01 -2.6126998901367188e+02 2.1782499694824219e+02 -9.2142593383789062e+01 -2.5979400634765625e+02 2.1867500305175781e+02 -5.6131797790527344e+01 -2.6144097900390625e+02 2.1814100646972656e+02 -1.0170999908447266e+02 -2.5884802246093750e+02 2.1804800415039062e+02 -1.0067600250244141e+02 -2.5904501342773438e+02 2.1936399841308594e+02 -3.5025600433349609e+01 -2.6192901611328125e+02 2.1939698791503906e+02 -5.6131797790527344e+01 -2.6144097900390625e+02 2.1920899963378906e+02 -6.5716102600097656e+01 -2.6130102539062500e+02 2.1953399658203125e+02 8.2325103759765625e+01 -2.6050698852539062e+02 2.1931100463867188e+02 5.6570796966552734e+01 -2.6149200439453125e+02 2.1938800048828125e+02 3.3271999359130859e+01 -2.6195700073242188e+02 2.1934500122070312e+02 4.2216801643371582e+00 -2.6213900756835938e+02 2.1920899963378906e+02 3.3769397735595703e+01 2.6221499633789062e+02 3.4116900634765625e+02 3.3670600891113281e+01 -2.6220199584960938e+02 3.4119097900390625e+02 7.2764503479003906e+01 -2.5462800598144531e+02 3.5765698242187500e+02 9.2066696166992188e+01 -2.5355699157714844e+02 3.5765600585937500e+02 9.6535697937011719e+01 -2.5235598754882812e+02 3.5825399780273438e+02 7.2727996826171875e+01 -2.5371998596191406e+02 3.5825399780273438e+02 5.3467197418212891e+01 -2.5432299804687500e+02 3.5825399780273438e+02 5.3488899230957031e+01 -2.5523098754882812e+02 3.5765698242187500e+02 3.1934000015258789e+01 -2.5562699890136719e+02 3.5764898681640625e+02 3.4207000732421875e+01 -2.5467601013183594e+02 3.5825399780273438e+02 9.2112800598144531e+01 2.5353399658203125e+02 3.5765600585937500e+02 9.5945297241210938e+01 2.5239100646972656e+02 3.5825198364257812e+02 7.2833503723144531e+01 2.5461997985839844e+02 3.5765600585937500e+02 7.2796203613281250e+01 2.5371098327636719e+02 3.5825399780273438e+02 5.3557399749755859e+01 2.5433099365234375e+02 3.5825399780273438e+02 5.3579898834228516e+01 2.5523999023437500e+02 3.5765600585937500e+02 3.2221397399902344e+01 2.5473100280761719e+02 3.5825601196289062e+02 2.7744601440429688e+02 -5.2428497314453125e+01 3.0819897460937500e+02 2.7801098632812500e+02 -4.8629600524902344e+01 3.0821801757812500e+02 2.8110098266601562e+02 -4.9212699890136719e+01 3.1575900268554688e+02 8.9583396911621094e+01 2.5764797973632812e+02 3.0164700317382812e+02 8.3991401672363281e+01 2.5788900756835938e+02 3.0145199584960938e+02 8.5498306274414062e+01 2.6135699462890625e+02 3.0895297241210938e+02 4.9164398193359375e+01 2.6271398925781250e+02 3.0768499755859375e+02 5.5646198272705078e+01 2.5911099243164062e+02 3.0046200561523438e+02 4.9403800964355469e+01 2.5908801269531250e+02 2.9986599731445312e+02 1.3848699951171875e+02 2.4554100036621094e+02 3.0335101318359375e+02 1.2482199859619141e+02 2.5086599731445312e+02 3.0254098510742188e+02 1.2901599121093750e+02 2.5291201782226562e+02 3.1045898437500000e+02 1.2179800415039062e+02 2.5554800415039062e+02 3.1020901489257812e+02 1.1056900024414062e+02 2.5492700195312500e+02 3.0237799072265625e+02 1.0733399963378906e+02 2.5903500366210938e+02 3.0970901489257812e+02 1.0564500427246094e+02 2.5586798095703125e+02 3.0220700073242188e+02 1.0288699340820312e+02 2.5976300048828125e+02 3.0955499267578125e+02 1.3581399536132812e+02 2.5042900085449219e+02 3.1069500732421875e+02 1.4932299804687500e+02 2.4371099853515625e+02 3.1117199707031250e+02 1.5167799377441406e+02 2.3825100708007812e+02 3.0346200561523438e+02 1.5592298889160156e+02 2.3972099304199219e+02 3.1139401245117188e+02 1.6029199218750000e+02 2.3260499572753906e+02 3.0378298950195312e+02 1.6870700073242188e+02 2.2653399658203125e+02 3.0440399169921875e+02 1.7004299926757812e+02 2.2988699340820312e+02 3.1190402221679688e+02 1.7557099914550781e+02 2.2123699951171875e+02 3.0428601074218750e+02 1.8229199218750000e+02 2.1568399047851562e+02 3.0487899780273438e+02 1.8436399841308594e+02 2.1849900817871094e+02 3.1238699340820312e+02 1.9056401062011719e+02 2.0841400146484375e+02 3.0481900024414062e+02 1.9857501220703125e+02 2.0559700012207031e+02 3.1289099121093750e+02 1.9521099853515625e+02 2.0403599548339844e+02 3.0533001708984375e+02 2.0524899291992188e+02 1.9413200378417969e+02 3.0567999267578125e+02 2.0421299743652344e+02 1.9997500610351562e+02 3.1307901000976562e+02 2.0989599609375000e+02 1.8907899475097656e+02 3.0584201049804688e+02 2.1904200744628906e+02 1.8353100585937500e+02 3.1359600830078125e+02 2.1806700134277344e+02 1.7922900390625000e+02 3.0612701416015625e+02 2.2059400939941406e+02 1.8151800537109375e+02 3.1365002441406250e+02 2.2396800231933594e+02 1.7211599731445312e+02 3.0633300781250000e+02 2.3254400634765625e+02 1.6601200866699219e+02 3.1406701660156250e+02 2.3666600036621094e+02 1.5412998962402344e+02 3.0677600097656250e+02 2.4099099731445312e+02 1.5310099792480469e+02 3.1436099243164062e+02 2.3836299133300781e+02 1.5127799987792969e+02 3.0683499145507812e+02 2.4469499206542969e+02 1.4744000244140625e+02 3.1448999023437500e+02 2.4796398925781250e+02 1.3514900207519531e+02 3.0717001342773438e+02 2.5545298767089844e+02 1.2782600402832031e+02 3.1486499023437500e+02 2.5782202148437500e+02 1.1518399810791016e+02 3.0751400756835938e+02 2.5872900390625000e+02 1.2103600311279297e+02 3.1498001098632812e+02 2.6055801391601562e+02 1.0884200286865234e+02 3.0760897827148438e+02 2.6506997680664062e+02 1.0594599914550781e+02 3.1520101928710938e+02 2.6210998535156250e+02 1.0466799926757812e+02 3.0766400146484375e+02 2.6730999755859375e+02 1.0061399841308594e+02 3.1527899169921875e+02 2.6824398803710938e+02 8.8176498413085938e+01 3.0787799072265625e+02 2.7428201293945312e+02 7.9621299743652344e+01 3.1552301025390625e+02 2.7429199218750000e+02 6.7007202148437500e+01 3.0808898925781250e+02 2.7963400268554688e+02 5.8121601104736328e+01 3.1576300048828125e+02 2.7676000976562500e+02 5.4858402252197266e+01 3.0817498779296875e+02 2.7868701171875000e+02 4.5367401123046875e+01 3.0824200439453125e+02 2.8330999755859375e+02 3.6032199859619141e+01 3.1583599853515625e+02 2.7963198852539062e+02 3.7657001495361328e+01 3.0827502441406250e+02 2.8139401245117188e+02 2.3286899566650391e+01 3.0833599853515625e+02 2.8553100585937500e+02 5.9319701194763184e+00 3.1592300415039062e+02 2.8222998046875000e+02 2.8427197933197021e+00 3.0836499023437500e+02 2.8152001953125000e+02 2.0194898605346680e+01 3.0834100341796875e+02 2.8421398925781250e+02 2.8013999938964844e+01 3.1586700439453125e+02 2.8302700805664062e+02 -3.8189498901367188e+01 3.1582598876953125e+02 2.8069299316406250e+02 -3.0596099853515625e+01 3.0831201171875000e+02 2.8513900756835938e+02 -1.6130300521850586e+01 3.1591601562500000e+02 2.8182299804687500e+02 -1.4391699790954590e+01 3.0835101318359375e+02 2.8222500610351562e+02 -8.6231803894042969e+00 3.0836499023437500e+02 2.8218399047851562e+02 -8.0630302429199219e-01 3.0797201538085938e+02 2.7603201293945312e+02 -5.9432800292968750e+01 3.0814901733398438e+02 2.7918197631835938e+02 -6.0188499450683594e+01 3.1569201660156250e+02 2.7441900634765625e+02 -6.5725997924804688e+01 3.0809301757812500e+02 2.7741900634765625e+02 -6.7865798950195312e+01 3.1563101196289062e+02 2.7056198120117188e+02 -8.0780403137207031e+01 3.0795800781250000e+02 2.7134201049804688e+02 -8.9151504516601562e+01 3.1542199707031250e+02 2.6990197753906250e+02 -8.2715103149414062e+01 3.0793499755859375e+02 2.6345800781250000e+02 -1.0161499786376953e+02 3.0771099853515625e+02 2.6364700317382812e+02 -1.0988800048828125e+02 3.1515100097656250e+02 2.5765100097656250e+02 -1.1510800170898438e+02 3.0750799560546875e+02 2.6058200073242188e+02 -1.1652600097656250e+02 3.1504397583007812e+02 2.5472700500488281e+02 -1.2190100097656250e+02 3.0740600585937500e+02 2.5434500122070312e+02 -1.3003599548339844e+02 3.1482699584960938e+02 2.4435600280761719e+02 -1.4159999084472656e+02 3.0704400634765625e+02 2.4342300415039062e+02 -1.4955499267578125e+02 3.1444601440429688e+02 2.4074800109863281e+02 -1.4766999816894531e+02 3.0691799926757812e+02 2.3927600097656250e+02 -1.5613000488281250e+02 3.1430200195312500e+02 2.2852000427246094e+02 -1.6602499389648438e+02 3.0649200439453125e+02 2.2649600219726562e+02 -1.7422898864746094e+02 3.1385601806640625e+02 2.2171699523925781e+02 -1.7469300842285156e+02 3.0625500488281250e+02 2.2427799987792969e+02 -1.7690499877929688e+02 3.1377899169921875e+02 2.1491999816894531e+02 -1.8335301208496094e+02 3.0601699829101562e+02 2.1237699890136719e+02 -1.9126699829101562e+02 3.1336297607421875e+02 2.0537699890136719e+02 -1.9373500061035156e+02 3.0568399047851562e+02 2.0766999816894531e+02 -1.9612799072265625e+02 3.1319900512695312e+02 1.9997100830078125e+02 -1.9961599731445312e+02 3.0549600219726562e+02 1.9693598937988281e+02 -2.0721200561523438e+02 3.1282498168945312e+02 1.8367199707031250e+02 -2.1477200317382812e+02 3.0492700195312500e+02 1.8210400390625000e+02 -2.2031700134277344e+02 3.1230700683593750e+02 1.8012599182128906e+02 -2.1761601257324219e+02 3.0480300903320312e+02 1.8017900085449219e+02 -2.2201699829101562e+02 3.1223999023437500e+02 1.6856999206542969e+02 -2.2667199707031250e+02 3.0404800415039062e+02 1.7152899169921875e+02 -2.2880500793457031e+02 3.1193798828125000e+02 1.5675898742675781e+02 -2.3502899169921875e+02 3.0398800659179688e+02 1.5523800659179688e+02 -2.4020199584960938e+02 3.1137298583984375e+02 1.5229499816894531e+02 -2.3791400146484375e+02 3.0347100830078125e+02 1.3909800720214844e+02 -2.4511499023437500e+02 3.0302102661132812e+02 1.4183000183105469e+02 -2.4771099853515625e+02 3.1090399169921875e+02 1.2670600128173828e+02 -2.5400900268554688e+02 3.1038800048828125e+02 1.2374900054931641e+02 -2.5126000976562500e+02 3.0248699951171875e+02 1.1977999877929688e+02 -2.5619000244140625e+02 3.1014697265625000e+02 1.1391499328613281e+02 -2.5393501281738281e+02 3.0203302001953125e+02 1.1259999847412109e+02 -2.5453001403808594e+02 3.0244897460937500e+02 1.0500899505615234e+02 -2.5949298095703125e+02 3.0964801025390625e+02 1.0302100372314453e+02 -2.5614602661132812e+02 3.0211499023437500e+02 9.7945800781250000e+01 -2.5682501220703125e+02 3.0157299804687500e+02 9.1525398254394531e+01 -2.5746398925781250e+02 3.0171398925781250e+02 8.9908699035644531e+01 -2.6112500000000000e+02 3.0913000488281250e+02 8.2828399658203125e+01 -2.5795800781250000e+02 3.0107098388671875e+02 6.6863594055175781e+01 -2.5880700683593750e+02 3.0085400390625000e+02 7.4361396789550781e+01 -2.6196398925781250e+02 3.0856399536132812e+02 4.9359199523925781e+01 -2.5929098510742188e+02 3.0024298095703125e+02 4.9162101745605469e+01 -2.6274200439453125e+02 3.0768499755859375e+02 8.3889999389648438e+01 2.6138497924804688e+02 2.5832800292968750e+02 7.4362899780273438e+01 2.6191198730468750e+02 2.5866000366210938e+02 4.8923896789550781e+01 2.5927499389648438e+02 2.6700900268554688e+02 4.9165000915527344e+01 2.6270999145507812e+02 2.5953997802734375e+02 8.5833099365234375e+01 2.5787799072265625e+02 2.6570901489257812e+02 8.9831001281738281e+01 2.6105697631835938e+02 2.5812100219726562e+02 1.0307800292968750e+02 2.5610900878906250e+02 2.6541000366210938e+02 1.0483599853515625e+02 2.5943099975585938e+02 2.5757598876953125e+02 1.0934499359130859e+02 2.5498300170898438e+02 2.6521798706054688e+02 1.1934000396728516e+02 2.5616799926757812e+02 2.5709500122070312e+02 1.2369100189208984e+02 2.5110301208496094e+02 2.6474197387695312e+02 1.2675200653076172e+02 2.5379800415039062e+02 2.5682699584960938e+02 1.2752300262451172e+02 2.4975000000000000e+02 2.6425497436523438e+02 1.4191999816894531e+02 2.4735699462890625e+02 2.5630899047851562e+02 1.3708299255371094e+02 2.4580499267578125e+02 2.6424499511718750e+02 1.4946200561523438e+02 2.4302099609375000e+02 2.5604699707031250e+02 1.5023300170898438e+02 2.3883599853515625e+02 2.6377697753906250e+02 1.5703800964355469e+02 2.3866499328613281e+02 2.5578298950195312e+02 1.6003898620605469e+02 2.3244999694824219e+02 2.6346902465820312e+02 1.7381100463867188e+02 2.2672499084472656e+02 2.5512498474121094e+02 1.6782299804687500e+02 2.2688800048828125e+02 2.6284997558593750e+02 1.7511999511718750e+02 2.2128500366210938e+02 2.6296801757812500e+02 1.7910798645019531e+02 2.2255499267578125e+02 2.5501498413085938e+02 1.8145500183105469e+02 2.1611900329589844e+02 2.6237402343750000e+02 1.9593399047851562e+02 2.0787200927734375e+02 2.5442698669433594e+02 1.9006100463867188e+02 2.0859498596191406e+02 2.6244198608398438e+02 1.9434199523925781e+02 2.0463299560546875e+02 2.6192501831054688e+02 2.1145300292968750e+02 1.9204100036621094e+02 2.5389001464843750e+02 2.0497999572753906e+02 1.9418600463867188e+02 2.6155401611328125e+02 2.0961199951171875e+02 1.8917498779296875e+02 2.6139199829101562e+02 2.2572399902343750e+02 1.7502400207519531e+02 2.5338700866699219e+02 2.2371000671386719e+02 1.7226699829101562e+02 2.6090100097656250e+02 2.2841799926757812e+02 1.6563198852539062e+02 2.6073599243164062e+02 2.3882701110839844e+02 1.5664799499511719e+02 2.5298600769042969e+02 2.3626899719238281e+02 1.5427799987792969e+02 2.6083599853515625e+02 2.3834800720214844e+02 1.5113699340820312e+02 2.6039001464843750e+02 2.4266400146484375e+02 1.5063099670410156e+02 2.5280401611328125e+02 2.5368299865722656e+02 1.3120600891113281e+02 2.5242098999023438e+02 2.4776199340820312e+02 1.3540400695800781e+02 2.6006201171875000e+02 2.5785800170898438e+02 1.2229699707031250e+02 2.5227499389648438e+02 2.5764797973632812e+02 1.1548699951171875e+02 2.5971697998046875e+02 2.6308502197265625e+02 1.1114199829101562e+02 2.5209298706054688e+02 2.6037899780273438e+02 1.0919100189208984e+02 2.5962200927734375e+02 2.7088299560546875e+02 9.0479393005371094e+01 2.5182199096679688e+02 2.6809600830078125e+02 8.8574295043945312e+01 2.5935299682617188e+02 2.7706799316406250e+02 6.9254005432128906e+01 2.5160598754882812e+02 2.7400299072265625e+02 6.7490501403808594e+01 2.5949902343750000e+02 2.7884500122070312e+02 6.1705898284912109e+01 2.5154501342773438e+02 2.7676300048828125e+02 5.4835201263427734e+01 2.5905001831054688e+02 2.8281301879882812e+02 3.9738498687744141e+01 2.5140699768066406e+02 2.7860702514648438e+02 4.5840900421142578e+01 2.5898599243164062e+02 2.8472201538085938e+02 2.0861198425292969e+01 2.5133999633789062e+02 2.8135202026367188e+02 2.3786699295043945e+01 2.5889001464843750e+02 2.8148699951171875e+02 2.0611299514770508e+01 2.5888500976562500e+02 2.8504199218750000e+02 1.7703199386596680e+01 2.5132901000976562e+02 2.8222799682617188e+02 3.2652599811553955e+00 2.5885998535156250e+02 2.8554598999023438e+02 -4.4436502456665039e+00 2.5135299682617188e+02 2.8235598754882812e+02 2.5677600502967834e-01 2.5885498046875000e+02 2.8228100585937500e+02 -6.5285000801086426e+00 2.5885800170898438e+02 2.8180502319335938e+02 -1.4165500640869141e+01 2.5887399291992188e+02 2.8436401367187500e+02 -2.6437299728393555e+01 2.5135200500488281e+02 2.8091101074218750e+02 -2.8517499923706055e+01 2.5890600585937500e+02 2.8354199218750000e+02 -3.4147399902343750e+01 2.5138101196289062e+02 2.8011102294921875e+02 -3.5523998260498047e+01 2.5893301391601562e+02 2.7998797607421875e+02 -5.6315700531005859e+01 2.5148001098632812e+02 2.7790701293945312e+02 -4.8741199493408203e+01 2.5900997924804688e+02 2.7649200439453125e+02 -5.7227100372314453e+01 2.5905999755859375e+02 2.7480300903320312e+02 -7.7759399414062500e+01 2.5168898010253906e+02 2.7120199584960938e+02 -7.8557296752929688e+01 2.5924398803710938e+02 2.6996801757812500e+02 -8.2266700744628906e+01 2.5928698730468750e+02 2.6798098754882812e+02 -9.8750701904296875e+01 2.5192201232910156e+02 2.6408300781250000e+02 -9.9471199035644531e+01 2.5983801269531250e+02 2.5954199218750000e+02 -1.1919199371337891e+02 2.5221601867675781e+02 2.5560501098632812e+02 -1.1994400024414062e+02 2.5979000854492188e+02 2.5629400634765625e+02 -1.2602999877929688e+02 2.5232899475097656e+02 2.4570100402832031e+02 -1.4563700866699219e+02 2.5266900634765625e+02 2.4705999755859375e+02 -1.3668499755859375e+02 2.6008599853515625e+02 2.4161801147460938e+02 -1.4567900085449219e+02 2.6027600097656250e+02 2.3363800048828125e+02 -1.6430200195312500e+02 2.5311801147460938e+02 2.3566700744628906e+02 -1.5551100158691406e+02 2.6048400878906250e+02 2.2454100036621094e+02 -1.7624600219726562e+02 2.5343400573730469e+02 2.2281999206542969e+02 -1.7342599487304688e+02 2.6093200683593750e+02 2.2217999267578125e+02 -1.7418499755859375e+02 2.6095397949218750e+02 2.2025099182128906e+02 -1.8187800598144531e+02 2.5358399963378906e+02 2.0767300415039062e+02 -1.9598199462890625e+02 2.5402099609375000e+02 2.0851998901367188e+02 -1.9038900756835938e+02 2.6142999267578125e+02 2.0540499877929688e+02 -1.9359199523925781e+02 2.6153900146484375e+02 2.0552799987792969e+02 -1.9838699340820312e+02 2.5409600830078125e+02 1.9578201293945312e+02 -2.0324101257324219e+02 2.6224398803710938e+02 2.0002500915527344e+02 -2.0393299865722656e+02 2.5430300903320312e+02 1.9309100341796875e+02 -2.0585900878906250e+02 2.6196798706054688e+02 1.8560198974609375e+02 -2.1717399597167969e+02 2.5478800964355469e+02 1.7955900573730469e+02 -2.1790798950195312e+02 2.6247799682617188e+02 1.7083500671386719e+02 -2.2899099731445312e+02 2.5530299377441406e+02 1.6178500366210938e+02 -2.3126300048828125e+02 2.6338897705078125e+02 1.5652899169921875e+02 -2.3901901245117188e+02 2.5576600646972656e+02 1.5639099121093750e+02 -2.3490199279785156e+02 2.6324798583984375e+02 1.4762001037597656e+02 -2.4035499572753906e+02 2.6390798950195312e+02 1.4922399902343750e+02 -2.4347000122070312e+02 2.5605401611328125e+02 1.3582499694824219e+02 -2.5022599792480469e+02 2.5651498413085938e+02 1.3392298889160156e+02 -2.4722399902343750e+02 2.6436297607421875e+02 1.2200900268554688e+02 -2.5538900756835938e+02 2.5700100708007812e+02 1.1989600372314453e+02 -2.5232699584960938e+02 2.6487100219726562e+02 1.0773999786376953e+02 -2.5894601440429688e+02 2.5745001220703125e+02 1.1363299560546875e+02 -2.5396200561523438e+02 2.6473901367187500e+02 1.0551599884033203e+02 -2.5569499206542969e+02 2.6538500976562500e+02 1.0189299774169922e+02 -2.5989401245117188e+02 2.5769601440429688e+02 8.9728302001953125e+01 -2.5737500000000000e+02 2.6601202392578125e+02 8.4179901123046875e+01 -2.6143899536132812e+02 2.5831900024414062e+02 8.8454093933105469e+01 -2.5773001098632812e+02 2.6561700439453125e+02 7.0313995361328125e+01 -2.5865100097656250e+02 2.6625000000000000e+02 4.9163898468017578e+01 -2.6272100830078125e+02 2.5953900146484375e+02 4.9354400634765625e+01 -2.5911199951171875e+02 2.6732501220703125e+02 4.9479701995849609e+01 -2.5764401245117188e+02 2.6837097167968750e+02 7.0181396484375000e+01 -2.5819000244140625e+02 2.6687600708007812e+02 7.0008201599121094e+01 -2.5679098510742188e+02 2.6789599609375000e+02 8.8421905517578125e+01 -2.5679202270507812e+02 2.6650900268554688e+02 7.7990699768066406e+01 -2.5684899902343750e+02 2.6699700927734375e+02 7.0879798889160156e+01 2.5750799560546875e+02 2.6720101928710938e+02 4.8610298156738281e+01 2.5890600585937500e+02 2.6754098510742188e+02 4.7417201995849609e+01 2.5782400512695312e+02 2.6834600830078125e+02 8.5828201293945312e+01 2.5749398803710938e+02 2.6624398803710938e+02 2.0724099731445312e+02 1.9141801452636719e+02 2.6200802612304688e+02 2.2342300415039062e+02 1.7203199768066406e+02 2.6144299316406250e+02 2.4744200134277344e+02 1.3521899414062500e+02 2.6060501098632812e+02 2.5885998535156250e+02 1.1217000579833984e+02 2.6020602416992188e+02 2.6774902343750000e+02 8.8453300476074219e+01 2.5989599609375000e+02 2.7824597167968750e+02 4.5778198242187500e+01 2.5952899169921875e+02 2.8098602294921875e+02 2.3754199981689453e+01 2.5943402099609375e+02 2.8211297607421875e+02 -3.0132498741149902e+00 2.5939700317382812e+02 2.8031097412109375e+02 -3.2025402069091797e+01 2.5945498657226562e+02 2.7613400268554688e+02 -5.7148899078369141e+01 2.5960299682617188e+02 2.7085000610351562e+02 -7.8450004577636719e+01 2.5978698730468750e+02 2.4674198913574219e+02 -1.3649800109863281e+02 2.6062899780273438e+02 2.5527000427246094e+02 -1.1979199981689453e+02 2.6033099365234375e+02 2.2253500366210938e+02 -1.7318899536132812e+02 2.6147399902343750e+02 2.3536500549316406e+02 -1.5529899597167969e+02 2.6102600097656250e+02 2.0825399780273438e+02 -1.9012899780273438e+02 2.6197201538085938e+02 1.7933900451660156e+02 -2.1762899780273438e+02 2.6298098754882812e+02 7.8223304748535156e+01 2.5670401000976562e+02 2.6698898315429688e+02 1.0277799987792969e+02 2.5469100952148438e+02 2.6613101196289062e+02 8.5806602478027344e+01 2.5694000244140625e+02 2.6660000610351562e+02 1.0603099822998047e+02 2.5500000000000000e+02 2.6589599609375000e+02 1.2989201354980469e+02 2.4711799621582031e+02 2.6518499755859375e+02 1.2338099670410156e+02 2.5039898681640625e+02 2.6528799438476562e+02 1.3686999511718750e+02 2.4503700256347656e+02 2.6481698608398438e+02 1.5437300109863281e+02 2.3445199584960938e+02 2.6432998657226562e+02 1.4994000244140625e+02 2.3809799194335938e+02 2.6436099243164062e+02 1.5949598693847656e+02 2.3189199829101562e+02 2.6402700805664062e+02 1.7424101257324219e+02 2.2020399475097656e+02 2.6363598632812500e+02 1.7463700866699219e+02 2.2071099853515625e+02 2.6349899291992188e+02 1.8930900573730469e+02 2.0738999938964844e+02 2.6311001586914062e+02 1.8973899841308594e+02 2.0786698913574219e+02 2.6297100830078125e+02 2.0616899108886719e+02 1.9060400390625000e+02 2.6252099609375000e+02 2.0677099609375000e+02 1.9112100219726562e+02 2.6237698364257812e+02 2.2249099731445312e+02 1.7129998779296875e+02 2.6195098876953125e+02 2.2299699401855469e+02 1.7169400024414062e+02 2.6180999755859375e+02 2.3514399719238281e+02 1.5346899414062500e+02 2.6150900268554688e+02 2.3567900085449219e+02 1.5382099914550781e+02 2.6136700439453125e+02 2.4640800476074219e+02 1.3464399719238281e+02 2.6111599731445312e+02 2.4696899414062500e+02 1.3495300292968750e+02 2.6097299194335938e+02 2.5828701782226562e+02 1.1212200164794922e+02 2.6057897949218750e+02 2.5895501708984375e+02 1.0857900238037109e+02 2.6067797851562500e+02 2.6662799072265625e+02 8.8077095031738281e+01 2.6041000366210938e+02 2.6723599243164062e+02 8.8279396057128906e+01 2.6026498413085938e+02 2.7267501831054688e+02 6.7068893432617188e+01 2.6019900512695312e+02 2.7329598999023438e+02 6.7222900390625000e+01 2.6005398559570312e+02 2.7708102416992188e+02 4.5583499908447266e+01 2.6004498291015625e+02 2.7771197509765625e+02 4.5688201904296875e+01 2.5989999389648438e+02 2.7980999755859375e+02 2.3653099060058594e+01 2.5994900512695312e+02 2.8044702148437500e+02 2.3707399368286133e+01 2.5980401611328125e+02 2.8157299804687500e+02 -2.9307000637054443e+00 2.5976602172851562e+02 2.7931500244140625e+02 -2.6374601364135742e+01 2.5996701049804688e+02 2.8000799560546875e+02 -2.8422599792480469e+01 2.5982000732421875e+02 2.7921102905273438e+02 -3.5405700683593750e+01 2.5984698486328125e+02 2.7497799682617188e+02 -5.6905899047851562e+01 2.6011801147460938e+02 2.7560400390625000e+02 -5.7036602020263672e+01 2.5997299194335938e+02 2.6971701049804688e+02 -7.8116294860839844e+01 2.6030200195312500e+02 2.7033099365234375e+02 -7.8295799255371094e+01 2.6015698242187500e+02 2.6279800415039062e+02 -9.8921905517578125e+01 2.6054299926757812e+02 2.6339599609375000e+02 -9.9149101257324219e+01 2.6039901733398438e+02 2.5420298767089844e+02 -1.1928199768066406e+02 2.6084399414062500e+02 2.5478100585937500e+02 -1.1955599975585938e+02 2.6069998168945312e+02 2.4571000671386719e+02 -1.3591699218750000e+02 2.6113998413085938e+02 2.4627000427246094e+02 -1.3623001098632812e+02 2.6099801635742188e+02 2.3438101196289062e+02 -1.5463900756835938e+02 2.6153601074218750e+02 2.3491500854492188e+02 -1.5499400329589844e+02 2.6139398193359375e+02 2.2160600280761719e+02 -1.7245300292968750e+02 2.6198199462890625e+02 2.2211000061035156e+02 -1.7284899902343750e+02 2.6184100341796875e+02 2.0738500976562500e+02 -1.8932099914550781e+02 2.6247900390625000e+02 2.0785699462890625e+02 -1.8975601196289062e+02 2.6233898925781250e+02 1.9492199707031250e+02 -2.0213400268554688e+02 2.6291400146484375e+02 1.9536599731445312e+02 -2.0259800720214844e+02 2.6277499389648438e+02 1.7859300231933594e+02 -2.1670300292968750e+02 2.6348400878906250e+02 1.7899900817871094e+02 -2.1720098876953125e+02 2.6334597778320312e+02 1.6117100524902344e+02 -2.2996099853515625e+02 2.6409201049804688e+02 1.6153700256347656e+02 -2.3049000549316406e+02 2.6395602416992188e+02 1.4699900817871094e+02 -2.3909201049804688e+02 2.6458697509765625e+02 1.4731500244140625e+02 -2.3965299987792969e+02 2.6445300292968750e+02 1.3339201354980469e+02 -2.4590499877929688e+02 2.6506201171875000e+02 1.3364399719238281e+02 -2.4649900817871094e+02 2.6493002319335938e+02 1.1955799865722656e+02 -2.5095001220703125e+02 2.6554598999023438e+02 1.1973900604248047e+02 -2.5156999206542969e+02 2.6541500854492188e+02 1.0526800537109375e+02 -2.5431001281738281e+02 2.6604397583007812e+02 1.0537400054931641e+02 -2.5494700622558594e+02 2.6591699218750000e+02 8.3052597045898438e+01 -2.5716098022460938e+02 3.0052899169921875e+02 8.0535705566406250e+01 -2.5640600585937500e+02 3.0031600952148438e+02 9.8050903320312500e+01 -2.5538400268554688e+02 3.0092800903320312e+02 6.9539001464843750e+01 2.5714099121093750e+02 2.9967001342773438e+02 5.5654800415039062e+01 2.5872702026367188e+02 2.9992700195312500e+02 7.7417999267578125e+01 2.5722198486328125e+02 3.0020800781250000e+02 7.0670997619628906e+01 -2.5688998413085938e+02 2.9954400634765625e+02 6.6868995666503906e+01 -2.5842199707031250e+02 3.0031900024414062e+02 4.7421699523925781e+01 -2.5787899780273438e+02 2.9891500854492188e+02 8.9575294494628906e+01 2.5726397705078125e+02 3.0111102294921875e+02 1.0819999694824219e+02 2.5491699218750000e+02 3.0152801513671875e+02 1.3820700073242188e+02 2.4499699401855469e+02 3.0258300781250000e+02 2.0746800231933594e+02 1.9139599609375000e+02 3.0522500610351562e+02 2.2368099975585938e+02 1.7188101196289062e+02 3.0579098510742188e+02 2.5896899414062500e+02 1.1197700500488281e+02 3.0701699829101562e+02 2.4764401245117188e+02 1.3496400451660156e+02 3.0662799072265625e+02 2.3636099243164062e+02 1.5391999816894531e+02 3.0623400878906250e+02 2.6789599609375000e+02 8.8056198120117188e+01 3.0733401489257812e+02 2.7393698120117188e+02 6.6915695190429688e+01 3.0754501342773438e+02 2.7832498168945312e+02 4.5305400848388672e+01 3.0769799804687500e+02 2.8102899169921875e+02 2.3255100250244141e+01 3.0779299926757812e+02 2.7654098510742188e+02 -5.5844898223876953e+01 3.0762899780273438e+02 2.8032897949218750e+02 -3.0554199218750000e+01 3.0776797485351562e+02 2.8185800170898438e+02 -8.6113805770874023e+00 3.0782199096679688e+02 2.7021099853515625e+02 -8.0670196533203125e+01 3.0741500854492188e+02 2.6311697387695312e+02 -1.0147599792480469e+02 3.0716799926757812e+02 2.5439799499511719e+02 -1.2173500061035156e+02 3.0686300659179688e+02 2.4237300109863281e+02 -1.4454100036621094e+02 3.0644500732421875e+02 1.9971600341796875e+02 -1.9934399414062500e+02 3.0495397949218750e+02 2.1464500427246094e+02 -1.8310398864746094e+02 3.0547601318359375e+02 2.2822700500488281e+02 -1.6579901123046875e+02 3.0594998168945312e+02 1.8344000244140625e+02 -2.1447999572753906e+02 3.0438598632812500e+02 9.8116004943847656e+01 -2.5602700805664062e+02 3.0105502319335938e+02 1.1781199645996094e+02 -2.5144601440429688e+02 3.0161898803710938e+02 1.1242099761962891e+02 -2.5361401367187500e+02 3.0155398559570312e+02 1.2353800201416016e+02 -2.5052299499511719e+02 3.0194198608398438e+02 1.3841799926757812e+02 -2.4388400268554688e+02 3.0233801269531250e+02 1.3869000244140625e+02 -2.4446701049804688e+02 3.0247100830078125e+02 1.5163500976562500e+02 -2.3667199707031250e+02 3.0279998779296875e+02 1.5197000122070312e+02 -2.3722100830078125e+02 3.0293499755859375e+02 1.6782901000976562e+02 -2.2547399902343750e+02 3.0336499023437500e+02 1.6821000671386719e+02 -2.2599099731445312e+02 3.0350198364257812e+02 1.8267500305175781e+02 -2.1356999206542969e+02 3.0388400268554688e+02 1.8309100341796875e+02 -2.1405999755859375e+02 3.0402099609375000e+02 1.9888299560546875e+02 -1.9849899291992188e+02 3.0445001220703125e+02 1.9933601379394531e+02 -1.9895399475097656e+02 3.0458898925781250e+02 2.1374900817871094e+02 -1.8232699584960938e+02 3.0496902465820312e+02 2.1423498535156250e+02 -1.8274499511718750e+02 3.0510900878906250e+02 2.2727299499511719e+02 -1.6509599304199219e+02 3.0544097900390625e+02 2.2779100036621094e+02 -1.6547399902343750e+02 3.0558200073242188e+02 2.4122700500488281e+02 -1.4382499694824219e+02 3.0592797851562500e+02 2.4187600708007812e+02 -1.4430400085449219e+02 3.0607299804687500e+02 2.5333398437500000e+02 -1.2121900177001953e+02 3.0635101318359375e+02 2.5391099548339844e+02 -1.2149699401855469e+02 3.0649398803710938e+02 2.6201599121093750e+02 -1.0104600524902344e+02 3.0665399169921875e+02 2.6261300659179688e+02 -1.0127700042724609e+02 3.0679800415039062e+02 2.6908001708984375e+02 -8.0327697753906250e+01 3.0690100097656250e+02 2.6969299316406250e+02 -8.0511894226074219e+01 3.0704501342773438e+02 2.7522299194335938e+02 -5.5617000579833984e+01 3.0711499023437500e+02 2.7599099731445312e+02 -5.5870399475097656e+01 3.0726400756835938e+02 2.7915499877929688e+02 -3.0424301147460938e+01 3.0725299072265625e+02 2.7979098510742188e+02 -3.0494199752807617e+01 3.0739797973632812e+02 2.8074398803710938e+02 -4.4074597358703613e+00 3.0730798339843750e+02 2.8158300781250000e+02 -4.4131898880004883e+00 3.0745898437500000e+02 2.7985198974609375e+02 2.3156200408935547e+01 3.0727700805664062e+02 2.8048898315429688e+02 2.3209400177001953e+01 3.0742199707031250e+02 2.7716000366210938e+02 4.5112800598144531e+01 3.0718298339843750e+02 2.7779199218750000e+02 4.5216400146484375e+01 3.0732797241210938e+02 2.7279000854492188e+02 6.6631401062011719e+01 3.0702999877929688e+02 2.7341101074218750e+02 6.6784301757812500e+01 3.0717501831054688e+02 2.6677502441406250e+02 8.7682296752929688e+01 3.0682000732421875e+02 2.6738299560546875e+02 8.7883300781250000e+01 3.0696499633789062e+02 2.5777200317382812e+02 1.1138500213623047e+02 3.0650601196289062e+02 2.5972198486328125e+02 1.0847999572753906e+02 3.0669702148437500e+02 2.5699499511718750e+02 1.1480200195312500e+02 3.0660198974609375e+02 2.4660900878906250e+02 1.3439199829101562e+02 3.0611602783203125e+02 2.4716999816894531e+02 1.3469999694824219e+02 3.0625900268554688e+02 2.3537300109863281e+02 1.5326699829101562e+02 3.0572399902343750e+02 2.3590899658203125e+02 1.5361799621582031e+02 3.0586599731445312e+02 2.2274600219726562e+02 1.7115199279785156e+02 3.0528302001953125e+02 2.2325399780273438e+02 1.7154400634765625e+02 3.0542401123046875e+02 2.0644299316406250e+02 1.9053300476074219e+02 3.0471398925781250e+02 2.0716699218750000e+02 1.9091600036621094e+02 3.0486102294921875e+02 1.8953799438476562e+02 2.0744299316406250e+02 3.0412301635742188e+02 1.8997000122070312e+02 2.0791900634765625e+02 3.0426202392578125e+02 1.7441400146484375e+02 2.2035899353027344e+02 3.0359500122070312e+02 1.7481100463867188e+02 2.2086399841308594e+02 3.0373199462890625e+02 1.5499299621582031e+02 2.3546400451660156e+02 3.0303900146484375e+02 1.4438299560546875e+02 2.4058799743652344e+02 3.0254598999023438e+02 1.2430300140380859e+02 2.4954100036621094e+02 3.0184500122070312e+02 1.2450399780273438e+02 2.5015399169921875e+02 3.0197598266601562e+02 1.0784500122070312e+02 2.5383898925781250e+02 3.0127099609375000e+02 8.9548904418945312e+01 2.5670999145507812e+02 3.0075601196289062e+02 4.7331001281738281e+01 -2.5748599243164062e+02 2.9832101440429688e+02 6.9807205200195312e+01 2.5670498657226562e+02 2.9908499145507812e+02 4.6830799102783203e+01 2.5754699707031250e+02 2.9839599609375000e+02 7.1375099182128906e+01 2.5665100097656250e+02 2.6810601806640625e+02 -7.2765898704528809e+00 2.6409597778320312e+02 2.1987199401855469e+02 2.9137001037597656e+01 2.6393600463867188e+02 2.1986801147460938e+02 6.2461500167846680e+00 -2.6409701538085938e+02 2.1986900329589844e+02 -3.0843698501586914e+01 -2.6391198730468750e+02 2.1987300109863281e+02 -2.8603698730468750e+02 2.2522300720214844e+01 1.5465100097656250e+02 -2.8555398559570312e+02 2.7717800140380859e+01 1.5665699768066406e+02 -2.8529400634765625e+02 2.7684099197387695e+01 1.3745899963378906e+02 -1.4560900878906250e+02 2.4724400329589844e+02 2.1730099487304688e+02 -1.3167999267578125e+02 2.5338900756835938e+02 2.1730099487304688e+02 -1.3756300354003906e+02 2.4999299621582031e+02 1.3745899963378906e+02 -2.7181100463867188e+02 8.4167198181152344e+01 6.4515701293945312e+01 -2.7251699829101562e+02 8.1540298461914062e+01 6.4515396118164062e+01 -2.7454400634765625e+02 8.2070404052734375e+01 1.3745899963378906e+02 -2.6472500610351562e+02 -1.0427300262451172e+02 6.4518302917480469e+01 -2.6328997802734375e+02 -1.0752700042724609e+02 6.4518600463867188e+01 -2.6440298461914062e+02 -1.0791899871826172e+02 9.7703399658203125e+01 -2.4181599426269531e+02 -1.4982899475097656e+02 6.4523597717285156e+01 -2.3748600769042969e+02 -1.5623100280761719e+02 6.4524200439453125e+01 -2.3852999877929688e+02 -1.5687500000000000e+02 9.7703399658203125e+01 1.0052799987792969e+02 -2.5811599731445312e+02 6.4467597961425781e+01 1.1519899749755859e+02 -2.5542100524902344e+02 6.4460700988769531e+01 1.1046999359130859e+02 -2.5755700683593750e+02 9.8350601196289062e+01 1.9959500122070312e+02 -2.0286999511718750e+02 6.4462104797363281e+01 2.0295700073242188e+02 -1.9932000732421875e+02 6.4517402648925781e+01 2.0368299865722656e+02 -2.0001600646972656e+02 9.9779998779296875e+01 -2.7930300903320312e+02 -5.4521900177001953e+01 6.4512405395507812e+01 -2.7924499511718750e+02 -5.4795501708984375e+01 6.4512405395507812e+01 -2.8426599121093750e+02 -2.7634799957275391e+01 9.4149795532226562e+01 -2.7905099487304688e+02 5.4759300231933594e+01 6.4512001037597656e+01 -2.8420901489257812e+02 2.8640300750732422e+01 9.5617797851562500e+01 -2.8420498657226562e+02 3.0230400085449219e+01 1.0136499786376953e+02 -2.8442300415039062e+02 3.0356698989868164e+01 1.1012400054931641e+02 -2.8462100219726562e+02 3.0472000122070312e+01 1.1888399505615234e+02 -2.8124600219726562e+02 5.5127799987792969e+01 1.3745899963378906e+02 -2.8465200805664062e+02 2.2695199966430664e+01 9.1759895324707031e+01 -2.8308801269531250e+02 2.7508399963378906e+01 6.4510398864746094e+01 -2.8485299682617188e+02 1.8921699523925781e+01 8.9759605407714844e+01 -2.8437500000000000e+02 1.1338899612426758e+01 6.4509597778320312e+01 -2.8547000122070312e+02 1.8009500503540039e+00 8.9405502319335938e+01 -2.8438198852539062e+02 -9.6113100647926331e-02 6.4447204589843750e+01 -2.8158898925781250e+02 4.1187099456787109e+01 6.4510704040527344e+01 -2.8260800170898438e+02 3.3540699005126953e+01 6.4510704040527344e+01 -2.8427301025390625e+02 2.7591501235961914e+01 9.4353500366210938e+01 -2.8310598754882812e+02 -2.7510299682617188e+01 6.4510299682617188e+01 -2.8456500244140625e+02 -2.3992101669311523e+01 9.2508399963378906e+01 -2.8478698730468750e+02 -2.0676700592041016e+01 9.1151298522949219e+01 -2.8485299682617188e+02 -1.8921699523925781e+01 8.9759605407714844e+01 -2.8439797973632812e+02 -1.0754400253295898e+01 6.4509597778320312e+01 -2.8417098999023438e+02 -2.9572099685668945e+01 9.7666297912597656e+01 -2.8270401000976562e+02 -3.2720600128173828e+01 6.4510505676269531e+01 -2.8462100219726562e+02 -3.0472000122070312e+01 1.1888399505615234e+02 -2.8442300415039062e+02 -3.0356698989868164e+01 1.1012400054931641e+02 -2.8033798217773438e+02 -5.4958801269531250e+01 9.7703399658203125e+01 -2.8420498657226562e+02 -3.0230400085449219e+01 1.0136499786376953e+02 -2.8664801025390625e+02 0.0000000000000000e+00 1.3745899963378906e+02 -2.8652899169921875e+02 -1.5200999975204468e+00 1.3145999145507812e+02 -2.8529400634765625e+02 -2.7684099197387695e+01 1.3745899963378906e+02 -2.8589401245117188e+02 -1.8921400070190430e+01 1.3108999633789062e+02 -2.8507598876953125e+02 -2.7661800384521484e+01 1.2652100372314453e+02 -2.8124600219726562e+02 -5.5127799987792969e+01 1.3745899963378906e+02 -2.8507400512695312e+02 -2.7816200256347656e+01 1.2449199676513672e+02 -2.8469299316406250e+02 -3.0284299850463867e+01 1.2116500091552734e+02 -2.8476901245117188e+02 2.9900199890136719e+01 1.2271399688720703e+02 -2.8503900146484375e+02 2.8028200149536133e+01 1.2632699584960938e+02 -2.8555599975585938e+02 2.3194700241088867e+01 1.3001998901367188e+02 -2.8589401245117188e+02 1.8921400070190430e+01 1.3108999633789062e+02 1.1046999359130859e+02 2.5755700683593750e+02 9.8350601196289062e+01 1.0495399475097656e+02 2.5748397827148438e+02 6.4452499389648438e+01 1.0053700256347656e+02 2.5811599731445312e+02 6.4517196655273438e+01 8.2902793884277344e+01 2.6064102172851562e+02 9.8084899902343750e+01 1.4405599975585938e+02 2.4471501159667969e+02 6.4479797363281250e+01 1.3681599426269531e+02 2.4915200805664062e+02 9.8665100097656250e+01 1.5723699951171875e+02 2.3704299926757812e+02 6.4532196044921875e+01 1.6097700500488281e+02 2.3556800842285156e+02 9.9016304016113281e+01 1.6204699707031250e+02 2.3379499816894531e+02 6.4531295776367188e+01 1.3754899597167969e+02 2.4780699157714844e+02 6.4461898803710938e+01 1.3649400329589844e+02 2.4820899963378906e+02 6.4529296875000000e+01 1.2341299438476562e+02 2.5314099121093750e+02 6.4486999511718750e+01 1.8318598937988281e+02 2.1882400512695312e+02 9.9391998291015625e+01 1.7970300292968750e+02 2.2058000183105469e+02 6.4526603698730469e+01 2.0368299865722656e+02 2.0001600646972656e+02 9.9779998779296875e+01 2.0123500061035156e+02 2.0125601196289062e+02 6.4517997741699219e+01 1.8489299011230469e+02 2.1627299499511719e+02 6.4524894714355469e+01 2.2227000427246094e+02 1.7932200622558594e+02 1.0016799926757812e+02 2.1634001159667969e+02 1.8504800415039062e+02 6.4460998535156250e+01 2.3876699829101562e+02 1.5694000244140625e+02 1.0054399871826172e+02 2.4273200988769531e+02 1.4911698913574219e+02 6.4447998046875000e+01 2.3018499755859375e+02 1.6766999816894531e+02 6.4455802917480469e+01 2.4597000122070312e+02 1.4376998901367188e+02 6.4487602233886719e+01 2.5301200866699219e+02 1.3308200073242188e+02 1.0089600372314453e+02 2.6486700439453125e+02 1.0797599792480469e+02 1.0121099853515625e+02 2.6384402465820312e+02 1.0764700317382812e+02 6.4469398498535156e+01 2.5647198486328125e+02 1.2429199981689453e+02 6.4436302185058594e+01 2.7421298217773438e+02 8.1861900329589844e+01 1.0147699737548828e+02 2.7276000976562500e+02 8.3264900207519531e+01 6.4458099365234375e+01 2.6540399169921875e+02 1.0412599945068359e+02 6.4467803955078125e+01 2.8343298339843750e+02 3.2855400085449219e+01 6.4442199707031250e+01 2.8001098632812500e+02 5.4582302093505859e+01 6.4447700500488281e+01 2.8095901489257812e+02 5.4989299774169922e+01 1.0168199920654297e+02 2.7849798583984375e+02 6.1742900848388672e+01 6.4449302673339844e+01 2.8503601074218750e+02 2.7614799499511719e+01 1.0181400299072266e+02 2.8514700317382812e+02 1.0966400146484375e+01 6.4439300537109375e+01 2.8639999389648438e+02 0.0000000000000000e+00 1.0186100006103516e+02 2.8384100341796875e+02 -2.7538200378417969e+01 6.4441596984863281e+01 2.8514297485351562e+02 -1.1057600021362305e+01 6.4412498474121094e+01 2.8095901489257812e+02 -5.4989299774169922e+01 1.0168199920654297e+02 2.7976000976562500e+02 -5.4820602416992188e+01 6.4447296142578125e+01 2.8503601074218750e+02 -2.7614799499511719e+01 1.0181400299072266e+02 2.8232397460937500e+02 -4.1202999114990234e+01 6.4443298339843750e+01 2.7421298217773438e+02 -8.1861900329589844e+01 1.0147699737548828e+02 2.6486700439453125e+02 -1.0797599792480469e+02 1.0121099853515625e+02 2.6512597656250000e+02 -1.0482299804687500e+02 6.4468200683593750e+01 2.7252001953125000e+02 -8.4035598754882812e+01 6.4458694458007812e+01 2.7316900634765625e+02 -8.1635803222656250e+01 6.4457702636718750e+01 2.7825497436523438e+02 -6.2813899993896484e+01 6.4426200866699219e+01 2.5301200866699219e+02 -1.3308200073242188e+02 1.0089600372314453e+02 2.5251498413085938e+02 -1.3206500244140625e+02 6.4481803894042969e+01 2.5605700683593750e+02 -1.2513800048828125e+02 6.4477699279785156e+01 2.4142999267578125e+02 -1.5119500732421875e+02 6.4492301940917969e+01 2.3876699829101562e+02 -1.5694000244140625e+02 1.0054399871826172e+02 2.2890699768066406e+02 -1.6939500427246094e+02 6.4455001831054688e+01 2.2227000427246094e+02 -1.7932200622558594e+02 1.0016799926757812e+02 2.1495599365234375e+02 -1.8664201354980469e+02 6.4468803405761719e+01 1.9218899536132812e+02 -2.0985501098632812e+02 6.4464401245117188e+01 1.8318598937988281e+02 -2.1882400512695312e+02 9.9391998291015625e+01 1.5340200805664062e+02 -2.3948199462890625e+02 6.4490898132324219e+01 1.6097700500488281e+02 -2.3556800842285156e+02 9.9016304016113281e+01 1.3996798706054688e+02 -2.4671000671386719e+02 6.4530403137207031e+01 1.3681599426269531e+02 -2.4915200805664062e+02 9.8665100097656250e+01 1.3607899475097656e+02 -2.4845199584960938e+02 6.4471199035644531e+01 1.5723699951171875e+02 -2.3704299926757812e+02 6.4532196044921875e+01 1.6046899414062500e+02 -2.3472399902343750e+02 6.4531402587890625e+01 1.7517399597167969e+02 -2.2417399597167969e+02 6.4476493835449219e+01 1.2186499786376953e+02 -2.5361401367187500e+02 6.4523506164550781e+01 8.5850402832031250e+01 -2.5936300659179688e+02 6.4459007263183594e+01 8.2902793884277344e+01 -2.6064102172851562e+02 9.8084899902343750e+01 6.3572399139404297e+01 -2.6036502075195312e+02 6.4512298583984375e+01 5.5142601013183594e+01 -2.6173599243164062e+02 9.7880401611328125e+01 -3.0569601058959961e-01 -2.6242199707031250e+02 9.7703399658203125e+01 7.7014598846435547e+00 -2.6127801513671875e+02 6.4508399963378906e+01 3.7388801574707031e+01 -2.6099398803710938e+02 6.4509696960449219e+01 -5.5603103637695312e+01 -2.6171600341796875e+02 9.7703399658203125e+01 -4.6298900604248047e+01 -2.6082699584960938e+02 6.4510299682617188e+01 -8.3246093750000000e+01 -2.6061199951171875e+02 9.7703399658203125e+01 -8.0560897827148438e+01 -2.5966598510742188e+02 6.4514503479003906e+01 -1.1073899841308594e+02 -2.5752801513671875e+02 9.7703399658203125e+01 -1.0053700256347656e+02 -2.5812301635742188e+02 6.4516799926757812e+01 -1.3712500000000000e+02 -2.4918399047851562e+02 9.7703399658203125e+01 -1.2386000061035156e+02 -2.5302401733398438e+02 6.4466094970703125e+01 -1.1985400390625000e+02 -2.5422000122070312e+02 6.4518898010253906e+01 -1.6125201416015625e+02 -2.3558799743652344e+02 9.7703399658203125e+01 -1.5724400329589844e+02 -2.3705400085449219e+02 6.4524200439453125e+01 -1.4433000183105469e+02 -2.4461999511718750e+02 6.4475204467773438e+01 -1.8333799743652344e+02 -2.1881001281738281e+02 9.7703399658203125e+01 -1.8407798767089844e+02 -2.1685400390625000e+02 6.4526000976562500e+01 -1.7853599548339844e+02 -2.2144200134277344e+02 6.4525100708007812e+01 -1.6075498962402344e+02 -2.3468301391601562e+02 6.4524398803710938e+01 -2.0370599365234375e+02 -1.9997599792480469e+02 9.7703399658203125e+01 -2.1546200561523438e+02 -1.8570100402832031e+02 6.4463104248046875e+01 -2.0038800048828125e+02 -2.0187098693847656e+02 6.4468101501464844e+01 -2.2216099548339844e+02 -1.7926600646972656e+02 9.7703399658203125e+01 -2.2930000305175781e+02 -1.6833200073242188e+02 6.4467903137207031e+01 -2.4534700012207031e+02 -1.4398500061035156e+02 6.4522399902343750e+01 -2.5265499877929688e+02 -1.3301800537109375e+02 9.7703399658203125e+01 -2.7205801391601562e+02 -8.3366699218750000e+01 6.4515502929687500e+01 -2.7366000366210938e+02 -8.1816596984863281e+01 9.7703399658203125e+01 -2.7777697753906250e+02 -6.1793098449707031e+01 6.4512603759765625e+01 -2.7753298950195312e+02 6.2877296447753906e+01 6.4512794494628906e+01 -2.6442700195312500e+02 1.0502299499511719e+02 6.4518402099609375e+01 -2.6525399780273438e+02 1.0825599670410156e+02 1.3745899963378906e+02 -2.5536599731445312e+02 1.2540399932861328e+02 6.4520301818847656e+01 -2.5346600341796875e+02 1.3343598937988281e+02 1.3745899963378906e+02 -2.5195300292968750e+02 1.3211199951171875e+02 6.4521606445312500e+01 -2.4090798950195312e+02 1.5128199768066406e+02 6.4523597717285156e+01 -2.2286799621582031e+02 1.7983599853515625e+02 1.3745899963378906e+02 -2.2842399597167969e+02 1.6952000427246094e+02 6.4525299072265625e+01 -2.3929199218750000e+02 1.5737199401855469e+02 1.3745899963378906e+02 -2.0286799621582031e+02 1.9915299987792969e+02 6.4526397705078125e+01 -2.1451799011230469e+02 1.8679299926757812e+02 6.4526298522949219e+01 -1.8391600036621094e+02 2.1951199340820312e+02 1.3745899963378906e+02 -1.9140400695800781e+02 2.1041200256347656e+02 6.4525703430175781e+01 -2.0435099792480469e+02 2.0061500549316406e+02 1.3745899963378906e+02 -1.9917700195312500e+02 2.0306498718261719e+02 6.4461502075195312e+01 -1.6063598632812500e+02 2.3461399841308594e+02 6.4524398803710938e+01 -1.7444000244140625e+02 2.2468400573730469e+02 6.4470703125000000e+01 -1.4001600646972656e+02 2.4673199462890625e+02 6.4521606445312500e+01 -1.5329800415039062e+02 2.3957600402832031e+02 6.4478897094726562e+01 -1.6175900268554688e+02 2.3634700012207031e+02 1.3745899963378906e+02 -1.5724000549316406e+02 2.3705400085449219e+02 6.4465095520019531e+01 -1.1520200347900391e+02 2.5543698120117188e+02 6.4518493652343750e+01 -1.2195099639892578e+02 2.5361201477050781e+02 6.4519401550292969e+01 -1.1110900115966797e+02 2.5839297485351562e+02 1.3745899963378906e+02 -1.3613499450683594e+02 2.4846998596191406e+02 6.4521301269531250e+01 -8.5965301513671875e+01 2.5936199951171875e+02 6.4514999389648438e+01 -1.0053700256347656e+02 2.5812301635742188e+02 6.4516799926757812e+01 -8.3526794433593750e+01 2.6152398681640625e+02 1.3745899963378906e+02 -6.3647396087646484e+01 2.6036502075195312e+02 6.4512603759765625e+01 -5.5776996612548828e+01 2.6264797973632812e+02 1.3745899963378906e+02 -3.7411701202392578e+01 2.6099398803710938e+02 6.4509895324707031e+01 -3.0627000331878662e-01 2.6336700439453125e+02 1.3745899963378906e+02 -7.6620602607727051e+00 2.6127801513671875e+02 6.4508499145507812e+01 4.6317699432373047e+01 2.6082598876953125e+02 6.4510002136230469e+01 -3.0569601058959961e-01 2.6242199707031250e+02 9.7703399658203125e+01 5.5142601013183594e+01 2.6173599243164062e+02 9.7880401611328125e+01 8.0654998779296875e+01 2.5965698242187500e+02 6.4514305114746094e+01 2.8050198364257812e+02 5.7327598571777344e+01 1.1832799530029297e+02 2.8223300170898438e+02 4.8240100860595703e+01 1.1665599822998047e+02 2.8268499755859375e+02 4.5559200286865234e+01 1.1637400054931641e+02 2.7930398559570312e+02 6.2929698944091797e+01 1.2148300170898438e+02 2.7916101074218750e+02 6.3575698852539062e+01 1.4029499816894531e+02 2.7954800415039062e+02 6.1756900787353516e+01 1.2014800262451172e+02 2.7424899291992188e+02 8.2040695190429688e+01 1.4018798828125000e+02 2.7917001342773438e+02 6.3714103698730469e+01 1.7201499938964844e+02 2.8268600463867188e+02 4.5819000244140625e+01 1.7772500610351562e+02 2.8119598388671875e+02 5.4165401458740234e+01 1.7658200073242188e+02 2.8079797363281250e+02 5.5261299133300781e+01 2.1730200195312500e+02 2.8098400878906250e+02 5.5206398010253906e+01 1.7630599975585938e+02 2.7871298217773438e+02 6.5909996032714844e+01 2.1753199768066406e+02 2.8010699462890625e+02 5.9502502441406250e+01 1.7516499328613281e+02 2.7416699218750000e+02 8.2251304626464844e+01 2.1730200195312500e+02 2.7935900878906250e+02 6.2920196533203125e+01 1.7286900329589844e+02 2.8405899047851562e+02 3.6419498443603516e+01 1.7851200866699219e+02 2.8298501586914062e+02 4.4101902008056641e+01 2.1753401184082031e+02 2.8486401367187500e+02 2.7716501235961914e+01 1.7897399902343750e+02 2.8488497924804688e+02 2.7766799926757812e+01 2.1730200195312500e+02 2.8595297241210938e+02 1.5941100120544434e+01 1.7959899902343750e+02 2.8554901123046875e+02 2.2063798904418945e+01 2.1730200195312500e+02 2.8627099609375000e+02 -2.5860699824988842e-03 1.7978100585937500e+02 2.8090399169921875e+02 -5.5278900146484375e+01 2.1730200195312500e+02 2.8215399169921875e+02 -4.8968799591064453e+01 1.7738699340820312e+02 2.8162301635742188e+02 -5.2090202331542969e+01 2.1730200195312500e+02 2.8268600463867188e+02 -4.5819000244140625e+01 1.7772500610351562e+02 2.8481399536132812e+02 -3.0098199844360352e+01 2.1730200195312500e+02 2.8496301269531250e+02 -2.7722999572753906e+01 1.7903100585937500e+02 2.8496798706054688e+02 -2.7780401229858398e+01 2.1730200195312500e+02 2.8528298950195312e+02 -2.5182201385498047e+01 1.7921400451660156e+02 2.8629498291015625e+02 -7.7480702400207520e+00 2.1730200195312500e+02 2.8636300659179688e+02 -4.5915799140930176e+00 1.7983399963378906e+02 2.8639999389648438e+02 -9.4880193471908569e-02 2.1730200195312500e+02 2.7424899291992188e+02 -8.2040695190429688e+01 1.4018798828125000e+02 2.7916101074218750e+02 -6.3471099853515625e+01 1.2243500518798828e+02 2.7916101074218750e+02 -6.3615299224853516e+01 1.4704800415039062e+02 2.7916101074218750e+02 -6.3751495361328125e+01 1.7166101074218750e+02 2.7953500366210938e+02 -6.2112701416015625e+01 1.7391200256347656e+02 2.7412399291992188e+02 -8.2233398437500000e+01 2.1730200195312500e+02 2.7674002075195312e+02 -7.3759399414062500e+01 2.1753199768066406e+02 2.8044500732421875e+02 -5.7901302337646484e+01 1.7569000244140625e+02 2.8119500732421875e+02 -5.3878898620605469e+01 1.1751600646972656e+02 2.8009899902343750e+02 -5.9239601135253906e+01 1.1894599914550781e+02 2.7935400390625000e+02 -6.2664398193359375e+01 1.2125299835205078e+02 2.8597799682617188e+02 -1.5512700080871582e+01 1.1488199615478516e+02 2.8405499267578125e+02 -3.6236598968505859e+01 1.1558899688720703e+02 2.8268499755859375e+02 -4.5559200286865234e+01 1.1637400054931641e+02 2.8627099609375000e+02 2.5451099500060081e-03 1.1431999969482422e+02 2.8528298950195312e+02 2.5025098800659180e+01 1.1488600158691406e+02 2.8636300659179688e+02 4.5533199310302734e+00 1.1426699829101562e+02 -1.5886500549316406e+02 2.3949800109863281e+02 2.1730099487304688e+02 -1.7357600402832031e+02 2.2906098937988281e+02 2.1730099487304688e+02 -2.0673599243164062e+02 1.9964300537109375e+02 2.1730099487304688e+02 -1.9072200012207031e+02 2.1499400329589844e+02 2.1730099487304688e+02 -2.2158500671386719e+02 1.8302301025390625e+02 2.1730099487304688e+02 -2.3963500976562500e+02 1.5865800476074219e+02 2.1730099487304688e+02 -2.3522000122070312e+02 1.6513299560546875e+02 2.1730099487304688e+02 -2.5117599487304688e+02 1.3967298889160156e+02 2.1730099487304688e+02 -2.6969900512695312e+02 9.9300300598144531e+01 2.1730099487304688e+02 -2.6120300292968750e+02 1.1987799835205078e+02 2.1730099487304688e+02 -2.7517300415039062e+02 8.2428901672363281e+01 2.1730099487304688e+02 -2.8175399780273438e+02 5.5265998840332031e+01 1.7418899536132812e+02 -2.8053097534179688e+02 6.1516899108886719e+01 1.8098799133300781e+02 -2.7939001464843750e+02 6.6774703979492188e+01 1.8870500183105469e+02 -2.7826898193359375e+02 7.1562294006347656e+01 1.9851699829101562e+02 -2.7756198120117188e+02 7.4430397033691406e+01 2.0734199523925781e+02 -2.8374298095703125e+02 4.3353698730468750e+01 1.6448100280761719e+02 -2.8351000976562500e+02 4.4929000854492188e+01 1.6554899597167969e+02 -2.8196298217773438e+02 5.4193099975585938e+01 1.7302200317382812e+02 -2.8503799438476562e+02 3.3264701843261719e+01 1.5879899597167969e+02 -2.8686898803710938e+02 -2.6740999221801758e+00 1.5133599853515625e+02 -2.8675900268554688e+02 8.5766296386718750e+00 1.5176899719238281e+02 -2.8624200439453125e+02 1.9611000061035156e+01 1.5382600402832031e+02 -2.8540600585937500e+02 -2.9768598556518555e+01 1.5725000000000000e+02 -2.8627700805664062e+02 -1.9059200286865234e+01 1.5368400573730469e+02 -2.8677401733398438e+02 -8.0518703460693359e+00 1.5171200561523438e+02 -2.8196298217773438e+02 -5.4193099975585938e+01 1.7302200317382812e+02 -2.8347998046875000e+02 -4.5125202178955078e+01 1.6568598937988281e+02 -2.8481100463867188e+02 -3.5241397857666016e+01 1.5976600646972656e+02 -2.7756198120117188e+02 -7.4430397033691406e+01 2.0734199523925781e+02 -2.7826898193359375e+02 -7.1562294006347656e+01 1.9851699829101562e+02 -2.7454400634765625e+02 -8.2070404052734375e+01 1.3745899963378906e+02 -2.7939001464843750e+02 -6.6774703979492188e+01 1.8870500183105469e+02 -2.8053097534179688e+02 -6.1516899108886719e+01 1.8098799133300781e+02 -2.6525399780273438e+02 -1.0825599670410156e+02 1.3745899963378906e+02 -2.7119000244140625e+02 -9.5153800964355469e+01 2.1730099487304688e+02 -2.7520700073242188e+02 -8.2440803527832031e+01 2.1730099487304688e+02 -2.5346600341796875e+02 -1.3343598937988281e+02 1.3745899963378906e+02 -2.5333100891113281e+02 -1.3572500610351562e+02 2.1730099487304688e+02 -2.6304501342773438e+02 -1.1578199768066406e+02 2.1730099487304688e+02 -2.4205101013183594e+02 -1.5494799804687500e+02 2.1730099487304688e+02 -2.3929199218750000e+02 -1.5737199401855469e+02 1.3745899963378906e+02 -2.2919200134277344e+02 -1.7340299987792969e+02 2.1730099487304688e+02 -2.2286799621582031e+02 -1.7983599853515625e+02 1.3745899963378906e+02 -2.2437599182128906e+02 -1.7958999633789062e+02 2.1730099487304688e+02 -2.0435099792480469e+02 -2.0061500549316406e+02 1.3745899963378906e+02 -2.0983499145507812e+02 -1.9638400268554688e+02 2.1730099487304688e+02 -1.8391600036621094e+02 -2.1951199340820312e+02 1.3745899963378906e+02 -1.9405700683593750e+02 -2.1198899841308594e+02 2.1730099487304688e+02 -1.5885700988769531e+02 -2.3950700378417969e+02 2.1753199768066406e+02 -1.7706599426269531e+02 -2.2637399291992188e+02 2.1730099487304688e+02 -1.6175900268554688e+02 -2.3634700012207031e+02 1.3745899963378906e+02 -1.4525000000000000e+02 -2.4742700195312500e+02 2.1730099487304688e+02 -1.3756300354003906e+02 -2.4999299621582031e+02 1.3745899963378906e+02 -1.3156098937988281e+02 -2.5343400573730469e+02 2.1730099487304688e+02 -1.1110900115966797e+02 -2.5839297485351562e+02 1.3745899963378906e+02 -1.1702399444580078e+02 -2.5795800781250000e+02 2.1730099487304688e+02 -8.3526794433593750e+01 -2.6152398681640625e+02 1.3745899963378906e+02 -9.3666999816894531e+01 -2.6167898559570312e+02 2.1730200195312500e+02 -1.0195100402832031e+02 -2.6083300781250000e+02 2.1730099487304688e+02 -7.3618499755859375e+01 -2.6284399414062500e+02 2.1730200195312500e+02 -5.5776996612548828e+01 -2.6264797973632812e+02 1.3745899963378906e+02 -6.1606498718261719e+01 -2.6328201293945312e+02 2.1730200195312500e+02 -1.3539400100708008e+01 -2.6410299682617188e+02 2.1730200195312500e+02 -2.5557399749755859e+01 -2.6400399780273438e+02 2.1730200195312500e+02 -3.0627000331878662e-01 -2.6336700439453125e+02 1.3745899963378906e+02 -4.9591701507568359e+01 -2.6360501098632812e+02 2.1730200195312500e+02 2.2515499114990234e+01 -2.6404299926757812e+02 2.1730200195312500e+02 1.0497399330139160e+01 -2.6412200927734375e+02 2.1730200195312500e+02 4.6550399780273438e+01 -2.6368701171875000e+02 2.1730200195312500e+02 5.5121803283691406e+01 -2.6267498779296875e+02 1.3758699035644531e+02 5.8565898895263672e+01 -2.6338897705078125e+02 2.1730200195312500e+02 8.2852500915527344e+01 -2.6156900024414062e+02 1.3773500061035156e+02 9.4595703125000000e+01 -2.6158499145507812e+02 2.1730200195312500e+02 7.0578796386718750e+01 -2.6298300170898438e+02 2.1730200195312500e+02 1.0058200073242188e+02 -2.6094799804687500e+02 2.1730200195312500e+02 1.1044899749755859e+02 -2.5844201660156250e+02 1.3792700195312500e+02 1.1647100067138672e+02 -2.5783099365234375e+02 2.1730200195312500e+02 1.3692100524902344e+02 -2.4987199401855469e+02 1.3815499877929688e+02 1.3159799194335938e+02 -2.5281599426269531e+02 2.1730200195312500e+02 1.5831300354003906e+02 -2.3866600036621094e+02 2.1730200195312500e+02 1.5322399902343750e+02 -2.4190899658203125e+02 2.1730200195312500e+02 1.6113899230957031e+02 -2.3614900207519531e+02 1.3840899658203125e+02 1.3952999877929688e+02 -2.4934199523925781e+02 2.1730200195312500e+02 1.8745399475097656e+02 -2.1653300476074219e+02 2.1753300476074219e+02 1.7012699890136719e+02 -2.3039401245117188e+02 2.1730200195312500e+02 1.8335198974609375e+02 -2.1934999084472656e+02 1.3867999267578125e+02 2.0365199279785156e+02 -2.0137100219726562e+02 2.1730099487304688e+02 2.0384100341796875e+02 -2.0048399353027344e+02 1.3896099853515625e+02 2.1872000122070312e+02 -1.8489299011230469e+02 2.1730099487304688e+02 2.2240899658203125e+02 -1.7973199462890625e+02 1.3924198913574219e+02 2.2358099365234375e+02 -1.7898500061035156e+02 2.1730099487304688e+02 2.3888200378417969e+02 -1.5729100036621094e+02 1.3951300048828125e+02 2.3675900268554688e+02 -1.6114999389648438e+02 2.1730099487304688e+02 2.5310000610351562e+02 -1.3337500000000000e+02 1.3976701354980469e+02 2.4850698852539062e+02 -1.4236799621582031e+02 2.1730099487304688e+02 2.6492700195312500e+02 -1.0821199798583984e+02 1.3999499511718750e+02 2.6759298706054688e+02 -1.0206999969482422e+02 2.1730200195312500e+02 2.5879800415039062e+02 -1.2267000579833984e+02 2.1730099487304688e+02 2.7022100830078125e+02 -9.4895698547363281e+01 2.1730200195312500e+02 2.7272097778320312e+02 8.7452003479003906e+01 2.1730200195312500e+02 2.7028500366210938e+02 9.4712699890136719e+01 2.1730200195312500e+02 2.6486999511718750e+02 1.0843899536132812e+02 2.1730200195312500e+02 2.6492700195312500e+02 1.0821199798583984e+02 1.3999499511718750e+02 2.6214599609375000e+02 1.1534199523925781e+02 2.1730099487304688e+02 2.5310000610351562e+02 1.3337500000000000e+02 1.3976701354980469e+02 2.5244799804687500e+02 1.3525700378417969e+02 2.1730099487304688e+02 2.3888200378417969e+02 1.5729100036621094e+02 1.3951300048828125e+02 2.4119999694824219e+02 1.5442399597167969e+02 2.1730099487304688e+02 2.2240899658203125e+02 1.7973199462890625e+02 1.3924198913574219e+02 2.2369299316406250e+02 1.7884500122070312e+02 2.1730099487304688e+02 2.2839399719238281e+02 1.7280101013183594e+02 2.1730099487304688e+02 2.0918499755859375e+02 1.9561700439453125e+02 2.1730099487304688e+02 2.0384100341796875e+02 2.0048399353027344e+02 1.3896099853515625e+02 1.9343901062011719e+02 2.1120100402832031e+02 2.1730099487304688e+02 1.8335198974609375e+02 2.1934999084472656e+02 1.3867999267578125e+02 1.7648098754882812e+02 2.2556399536132812e+02 2.1730200195312500e+02 1.6113899230957031e+02 2.3614900207519531e+02 1.3840899658203125e+02 1.3692100524902344e+02 2.4987199401855469e+02 1.3815499877929688e+02 1.4443699645996094e+02 2.4689100646972656e+02 2.1730200195312500e+02 1.5831300354003906e+02 2.3866600036621094e+02 2.1730200195312500e+02 1.0655300140380859e+02 2.6002499389648438e+02 2.1730200195312500e+02 1.2095800018310547e+02 2.5656100463867188e+02 2.1755200195312500e+02 1.1044899749755859e+02 2.5844201660156250e+02 1.3792700195312500e+02 1.2992399597167969e+02 2.5347300720214844e+02 2.1730200195312500e+02 8.2852500915527344e+01 2.6156900024414062e+02 1.3773500061035156e+02 7.2242401123046875e+01 2.6291598510742188e+02 2.1730200195312500e+02 9.2422599792480469e+01 2.6176800537109375e+02 2.1730200195312500e+02 1.0055000305175781e+02 2.6095599365234375e+02 2.1755500793457031e+02 5.5121803283691406e+01 2.6267498779296875e+02 1.3758699035644531e+02 6.0230300903320312e+01 2.6333999633789062e+02 2.1730200195312500e+02 1.2163800239562988e+01 2.6411502075195312e+02 2.1730200195312500e+02 2.4181499481201172e+01 2.6402700805664062e+02 2.1730200195312500e+02 4.8215400695800781e+01 2.6365100097656250e+02 2.1730200195312500e+02 -2.3889900207519531e+01 2.6402200317382812e+02 2.1730200195312500e+02 -1.1872300148010254e+01 2.6411199951171875e+02 2.1730200195312500e+02 -4.7923900604248047e+01 2.6364300537109375e+02 2.1730200195312500e+02 -5.9938697814941406e+01 2.6333300781250000e+02 2.1730200195312500e+02 -9.5965599060058594e+01 2.6148098754882812e+02 2.1730200195312500e+02 -7.1950897216796875e+01 2.6291299438476562e+02 2.1730200195312500e+02 -1.0195100402832031e+02 2.6083300781250000e+02 2.1730099487304688e+02 -1.1742199707031250e+02 2.5785800170898438e+02 2.1730099487304688e+02 -1.4213000488281250e+02 2.4270599365234375e+02 3.8100002288818359e+01 -1.4181600952148438e+02 2.4284001159667969e+02 3.8100002288818359e+01 -2.4825898742675781e+02 -1.3323199462890625e+02 3.8100002288818359e+01 2.7370300292968750e+02 7.0075401306152344e+01 3.8100002288818359e+01 2.7804397583007812e+02 4.9984397888183594e+01 3.8100002288818359e+01 -3.3217098236083984e+01 -2.5835498046875000e+02 3.8100002288818359e+01 -1.2769900512695312e+02 2.4888198852539062e+02 3.8100002288818359e+01 -1.2297399902343750e+02 2.5025201416015625e+02 3.8100002288818359e+01 -1.1244200134277344e+02 2.5330599975585938e+02 3.8100002288818359e+01 2.3593800354003906e+02 1.5470899963378906e+02 3.8100002288818359e+01 2.4791699218750000e+02 1.3489900207519531e+02 3.8100002288818359e+01 -6.6876899719238281e+01 -2.5754998779296875e+02 3.8100002288818359e+01 -7.4359901428222656e+01 -2.5715600585937500e+02 3.8100002288818359e+01 -2.2352999877929688e+02 -1.7151400756835938e+02 3.8100002288818359e+01 -2.2974800109863281e+02 -1.6268699645996094e+02 3.8100002288818359e+01 -1.0020200347900391e+02 2.5544100952148438e+02 3.8100002288818359e+01 -7.8690498352050781e+01 2.5705401611328125e+02 3.8100002288818359e+01 -7.6573699951171875e+01 2.5711502075195312e+02 3.8100002288818359e+01 7.7815597534179688e+01 -2.5707598876953125e+02 3.8100002288818359e+01 3.9318599700927734e+01 -2.5818698120117188e+02 3.8100002288818359e+01 2.7856900024414062e+02 4.7554897308349609e+01 3.8100002288818359e+01 2.1565901184082031e+02 -1.8132199096679688e+02 3.8100002288818359e+01 2.0918099975585938e+02 -1.8905400085449219e+02 3.8100002288818359e+01 3.3767601013183594e+01 -2.5834701538085938e+02 3.8100002288818359e+01 2.9243199825286865e+00 -2.5835101318359375e+02 3.8100002288818359e+01 -9.2364997863769531e+01 -2.5620800781250000e+02 3.8100002288818359e+01 -1.0020200347900391e+02 -2.5544100952148438e+02 3.8100002288818359e+01 -1.0404199981689453e+02 -2.5472099304199219e+02 3.8100002288818359e+01 -2.3696101379394531e+02 -1.5244898986816406e+02 3.8100002288818359e+01 -2.3945700073242188e+02 -1.4820399475097656e+02 3.8100002288818359e+01 2.5733200073242188e+02 1.1597499847412109e+02 3.8100002288818359e+01 2.5826901245117188e+02 1.1409100341796875e+02 3.8100002288818359e+01 2.8156799316406250e+02 2.4639999389648438e+01 3.8100002288818359e+01 2.8197399902343750e+02 1.5988100051879883e+01 3.8100002288818359e+01 2.2423901367187500e+02 -1.7107998657226562e+02 3.8100002288818359e+01 2.2665199279785156e+02 -1.6766299438476562e+02 3.8100002288818359e+01 -1.1560700225830078e+02 -2.5255400085449219e+02 3.8100002288818359e+01 -1.1612699890136719e+02 -2.5238900756835938e+02 3.8100002288818359e+01 -1.3052900695800781e+02 -2.4783100891113281e+02 3.8100002288818359e+01 1.3472200012207031e+02 2.4587500000000000e+02 3.8100002288818359e+01 1.4487100219726562e+02 2.4124499511718750e+02 3.8100002288818359e+01 1.5574899291992188e+02 2.3478700256347656e+02 3.8100002288818359e+01 2.6691201782226562e+02 9.2376205444335938e+01 3.8100002288818359e+01 2.6957199096679688e+02 8.3638694763183594e+01 3.8100002288818359e+01 2.6382000732421875e+02 -1.0009400177001953e+02 3.8100002288818359e+01 2.5952301025390625e+02 -1.1124300384521484e+02 3.8100002288818359e+01 2.5710897827148438e+02 -1.1623600006103516e+02 3.8100002288818359e+01 2.0394000244140625e+02 -1.9435598754882812e+02 3.8100002288818359e+01 1.9285101318359375e+02 -2.0557199096679688e+02 3.8100002288818359e+01 1.7874800109863281e+02 -2.1767399597167969e+02 3.8100002288818359e+01 -1.3499000549316406e+02 -2.4579399108886719e+02 3.8100002288818359e+01 -1.4497399902343750e+02 -2.4123400878906250e+02 3.8100002288818359e+01 -2.0800900268554688e+02 -1.8998800659179688e+02 3.8100002288818359e+01 -1.9212699890136719e+02 -2.0607099914550781e+02 3.8100002288818359e+01 -1.8305200195312500e+02 -2.1386599731445312e+02 3.8100002288818359e+01 -2.0848600769042969e+02 -1.8950498962402344e+02 3.8100002288818359e+01 -2.1922099304199219e+02 -1.7666799926757812e+02 3.8100002288818359e+01 -2.4868800354003906e+02 -1.3250100708007812e+02 3.8100002288818359e+01 -2.6852499389648438e+02 8.4873802185058594e+01 3.8100002288818359e+01 -2.5879098510742188e+02 -1.1154799652099609e+02 3.8100002288818359e+01 -2.6254299926757812e+02 -1.0177400207519531e+02 3.8100002288818359e+01 -2.6717800903320312e+02 -8.9699699401855469e+01 3.8100002288818359e+01 -2.7334600830078125e+02 -6.8539299011230469e+01 3.8100002288818359e+01 -2.7780200195312500e+02 4.7758602142333984e+01 3.8100002288818359e+01 -2.8183001708984375e+02 -1.8743701279163361e-01 3.8100002288818359e+01 -2.8079000854492188e+02 2.4913700103759766e+01 3.8100002288818359e+01 -2.8189501953125000e+02 1.6426399946212769e+00 3.8100002288818359e+01 -2.7951898193359375e+02 -3.4592502593994141e+01 3.8100002288818359e+01 -2.8106100463867188e+02 -2.1663398742675781e+01 3.8100002288818359e+01 -2.7337802124023438e+02 6.8285797119140625e+01 3.8100002288818359e+01 -2.7292401123046875e+02 7.0394004821777344e+01 3.8100002288818359e+01 -2.2161300659179688e+02 1.7398298645019531e+02 3.8100002288818359e+01 -2.1959100341796875e+02 1.7634700012207031e+02 3.8100002288818359e+01 -2.0821200561523438e+02 1.8965299987792969e+02 3.8100002288818359e+01 -1.8990499877929688e+02 2.0812199401855469e+02 3.8100002288818359e+01 -1.7208500671386719e+02 2.2309100341796875e+02 3.8100002288818359e+01 -3.7744201660156250e+01 2.5823300170898438e+02 3.8100002288818359e+01 -3.3767700195312500e+01 2.5834701538085938e+02 3.8100002288818359e+01 -3.4512300491333008e+00 2.5835000610351562e+02 3.8100002288818359e+01 1.7128300476074219e+02 2.2368699645996094e+02 3.8100002288818359e+01 1.7266600036621094e+02 2.2269799804687500e+02 3.8100002288818359e+01 1.9035099792480469e+02 2.0787500000000000e+02 3.8100002288818359e+01 1.9741700744628906e+02 2.0089300537109375e+02 3.8100002288818359e+01 2.0694599914550781e+02 1.9147999572753906e+02 3.8100002288818359e+01 2.2081300354003906e+02 1.7531199645996094e+02 3.8100002288818359e+01 2.2222900390625000e+02 1.7366099548339844e+02 3.8100002288818359e+01 2.3126399230957031e+02 1.6117100524902344e+02 3.8100002288818359e+01 1.7516699218750000e+02 -2.2074699401855469e+02 3.8100002288818359e+01 1.5574899291992188e+02 -2.3478700256347656e+02 3.8100002288818359e+01 1.4188099670410156e+02 -2.4278399658203125e+02 3.8100002288818359e+01 1.2725000000000000e+02 -2.4900900268554688e+02 3.8100002288818359e+01 1.2290399932861328e+02 -2.5025599670410156e+02 3.8100002288818359e+01 1.1189900207519531e+02 -2.5341299438476562e+02 3.8100002288818359e+01 -1.5574800109863281e+02 -2.3480198669433594e+02 3.8100002288818359e+01 -1.7456900024414062e+02 -2.2115100097656250e+02 3.8100002288818359e+01 -2.7370397949218750e+02 -6.7310897827148438e+01 3.8100002288818359e+01 -2.7831500244140625e+02 -4.4692699432373047e+01 3.8100002288818359e+01 -1.5574800109863281e+02 2.3480198669433594e+02 3.8100002288818359e+01 2.8265802001953125e+02 1.4392100572586060e+00 3.8100002288818359e+01 2.8202899169921875e+02 -1.5701299667358398e+01 3.8100002288818359e+01 2.8180599975585938e+02 -2.1793899536132812e+01 3.8100002288818359e+01 2.7793402099609375e+02 -5.0113800048828125e+01 3.8100002288818359e+01 2.7443899536132812e+02 -6.7175300598144531e+01 3.8100002288818359e+01 2.6962899780273438e+02 -8.3604499816894531e+01 3.8100002288818359e+01 2.7906701660156250e+02 -4.4581497192382812e+01 3.8100002288818359e+01 2.3770899963378906e+02 -1.5200099182128906e+02 3.8100002288818359e+01 2.4558200073242188e+02 -1.3863700866699219e+02 3.8100002288818359e+01 1.0020100402832031e+02 -2.5543499755859375e+02 3.8100002288818359e+01 7.8678504943847656e+01 -2.5705099487304688e+02 3.8100002288818359e+01 -2.6613800048828125e+02 9.2731498718261719e+01 3.8100002288818359e+01 -2.6274697875976562e+02 1.0127600097656250e+02 3.8100002288818359e+01 -2.5752801513671875e+02 1.1442500305175781e+02 3.8100002288818359e+01 -2.5601599121093750e+02 1.1747599792480469e+02 3.8100002288818359e+01 -2.4827000427246094e+02 1.3310299682617188e+02 3.8100002288818359e+01 -2.4725900268554688e+02 1.3514399719238281e+02 3.8100002288818359e+01 -2.0638099670410156e+02 1.9179501342773438e+02 3.8100002288818359e+01 3.3288799285888672e+01 2.5835400390625000e+02 3.8100002288818359e+01 6.6913497924804688e+01 2.5754602050781250e+02 3.8100002288818359e+01 7.4070198059082031e+01 2.5716900634765625e+02 3.8100002288818359e+01 2.6790402221679688e+02 -8.9494201660156250e+01 3.8100002288818359e+01 2.4946699523925781e+02 -1.3204299926757812e+02 3.8100002288818359e+01 -2.3528100585937500e+02 1.5502500915527344e+02 3.8100002288818359e+01 -2.2997399902343750e+02 1.6238600158691406e+02 3.8100002288818359e+01 9.2309997558593750e+01 2.5620700073242188e+02 3.8100002288818359e+01 1.0020100402832031e+02 2.5543499755859375e+02 3.8100002288818359e+01 1.1242800140380859e+02 2.5313699340820312e+02 3.8100002288818359e+01 1.1555699920654297e+02 2.5254899597167969e+02 3.8100002288818359e+01 1.3042700195312500e+02 2.4783399963378906e+02 3.8100002288818359e+01 -1.0053600311279297e+02 -2.5811401367187500e+02 6.4388000488281250e+01 -8.0560501098632812e+01 -2.5965698242187500e+02 6.4387001037597656e+01 -7.4479499816894531e+01 -2.5986297607421875e+02 6.4386505126953125e+01 -4.6298702239990234e+01 -2.6081799316406250e+02 6.4384803771972656e+01 2.9279000759124756e+00 -2.6122900390625000e+02 6.4384201049804688e+01 7.7014002799987793e+00 -2.6126901245117188e+02 6.4384201049804688e+01 3.7388702392578125e+01 -2.6098498535156250e+02 6.4384803771972656e+01 3.9367298126220703e+01 -2.6093798828125000e+02 6.4384803771972656e+01 6.3572196960449219e+01 -2.6035601806640625e+02 6.4386001586914062e+01 7.7942100524902344e+01 -2.5971099853515625e+02 6.4386703491210938e+01 1.0053499603271484e+02 2.5810699462890625e+02 6.4388198852539062e+01 8.0654602050781250e+01 2.5964801025390625e+02 6.4386802673339844e+01 7.4188796997070312e+01 2.5986901855468750e+02 6.4386398315429688e+01 4.6317497253417969e+01 2.6081698608398438e+02 6.4384696960449219e+01 -3.4555199146270752e+00 2.6123397827148438e+02 6.4384201049804688e+01 -7.6620001792907715e+00 2.6126901245117188e+02 6.4384201049804688e+01 -3.7411602020263672e+01 2.6098498535156250e+02 6.4384803771972656e+01 -6.3647201538085938e+01 2.6035601806640625e+02 6.4386100769042969e+01 -7.6695999145507812e+01 2.5976898193359375e+02 6.4386703491210938e+01 -8.5964797973632812e+01 2.5935299682617188e+02 6.4387199401855469e+01 -1.0053600311279297e+02 2.5811401367187500e+02 6.4388000488281250e+01 3.1342397689819336e+01 2.6306097412109375e+02 2.1759700012207031e+02 4.3387302398681641e+01 2.6227200317382812e+02 2.1764099121093750e+02 9.0441802978515625e+01 2.6103500366210938e+02 2.1759700012207031e+02 -6.2943302154541016e+01 2.6235501098632812e+02 2.1759700012207031e+02 -4.7420501708984375e+01 2.6202099609375000e+02 2.1767201232910156e+02 -2.4449799060821533e+00 2.6244799804687500e+02 2.1768299865722656e+02 -9.9700302124023438e+01 2.6112899780273438e+02 2.1754299926757812e+02 -8.3883300781250000e+01 2.6070401000976562e+02 2.1766300964355469e+02 -7.2160804748535156e+01 2.6278298950195312e+02 2.1754499816894531e+02 -5.2878200531005859e+01 2.6338500976562500e+02 2.1754699707031250e+02 1.4581300318241119e-01 2.6383599853515625e+02 2.1755099487304688e+02 6.5717201232910156e+01 2.6313000488281250e+02 2.1754199218750000e+02 -3.3645702362060547e+01 -2.6301800537109375e+02 2.1759700012207031e+02 -2.1388999938964844e+01 -2.6395800781250000e+02 2.1754299926757812e+02 1.6504899978637695e+01 -2.6385000610351562e+02 2.1755099487304688e+02 6.1191398620605469e+01 -2.6242700195312500e+02 2.1759700012207031e+02 5.1509998321533203e+01 -2.6343399047851562e+02 2.1754699707031250e+02 -7.1333602905273438e+01 -2.6284997558593750e+02 2.1754400634765625e+02 -9.1993400573730469e+01 -2.6092498779296875e+02 2.1759700012207031e+02 -9.9771003723144531e+01 -2.6110900878906250e+02 2.1754100036621094e+02 -1.0175000000000000e+02 -2.5931201171875000e+02 2.1764199829101562e+02 -4.4782096862792969e+01 -2.6223098754882812e+02 2.1764099121093750e+02 5.9474597930908203e+01 -2.6170901489257812e+02 2.1766099548339844e+02 3.6315998077392578e+01 -2.6215298461914062e+02 2.1768299865722656e+02 3.8086199760437012e+00 -2.6260699462890625e+02 2.1764199829101562e+02 8.2518898010253906e+01 -2.6077899169921875e+02 2.1766699218750000e+02 7.0807701110839844e+01 -2.6285202026367188e+02 2.1754499816894531e+02 9.8841400146484375e+01 -2.6115301513671875e+02 2.1754100036621094e+02 1.8454500198364258e+01 2.6404199218750000e+02 2.1747599792480469e+02 -1.8528200149536133e+01 2.6403799438476562e+02 2.1747698974609375e+02 1.7161098480224609e+01 -2.6405398559570312e+02 2.1747698974609375e+02 9.8131202697753906e+01 -2.4043699645996094e+02 3.5742501831054688e+02 7.5243003845214844e+01 -2.4204200744628906e+02 3.5742501831054688e+02 3.4053096771240234e+01 -2.4311499023437500e+02 3.5742501831054688e+02 3.4154697418212891e+01 2.4314099121093750e+02 3.5742501831054688e+02 4.5088298797607422e+01 2.4283399963378906e+02 3.5742501831054688e+02 7.7771499633789062e+01 2.4191600036621094e+02 3.5742501831054688e+02 9.8130195617675781e+01 2.4041600036621094e+02 3.5742501831054688e+02 2.6411398315429688e+02 3.2147800445556641e+01 3.5742501831054688e+02 2.6045098876953125e+02 5.4375999450683594e+01 3.5742501831054688e+02 -2.0882000732421875e+02 -1.5693399047851562e+02 3.5742501831054688e+02 2.5969299316406250e+02 -5.7893501281738281e+01 3.5742501831054688e+02 2.6367102050781250e+02 -3.5606498718261719e+01 3.5742501831054688e+02 2.6574099731445312e+02 -1.3079700469970703e+01 3.5742501831054688e+02 -2.3633399963378906e+02 1.2440299987792969e+02 3.5742501831054688e+02 -2.4285200500488281e+02 1.1061599731445312e+02 3.5742501831054688e+02 -2.1847100830078125e+02 -1.5129899597167969e+02 3.5742501831054688e+02 2.6589099121093750e+02 9.5675001144409180e+00 3.5742501831054688e+02 2.3832200622558594e+02 1.1837400054931641e+02 3.5742501831054688e+02 2.2748300170898438e+02 1.3810699462890625e+02 3.5742501831054688e+02 2.1497898864746094e+02 1.5691299438476562e+02 3.5742501831054688e+02 2.8299699783325195e+01 2.4267298889160156e+02 3.5742501831054688e+02 2.2700000762939453e+01 2.4120100402832031e+02 3.5742501831054688e+02 2.0085699462890625e+02 1.7468099975585938e+02 3.5742501831054688e+02 1.8524398803710938e+02 1.9121900939941406e+02 3.5742501831054688e+02 1.6833500671386719e+02 2.0632099914550781e+02 3.5742501831054688e+02 1.5122799682617188e+02 2.1922900390625000e+02 3.5742501831054688e+02 1.2644400024414062e+02 -2.3300700378417969e+02 3.5742501831054688e+02 1.3974900817871094e+02 -2.2656900024414062e+02 3.5742501831054688e+02 1.4720800781250000e+02 -2.2197698974609375e+02 3.5742501831054688e+02 1.6548300170898438e+02 -2.0863999938964844e+02 3.5742501831054688e+02 1.7778700256347656e+02 -1.9795399475097656e+02 3.5742501831054688e+02 2.5491101074218750e+02 7.6260002136230469e+01 3.5742501831054688e+02 2.4753199768066406e+02 9.7613800048828125e+01 3.5742501831054688e+02 1.0600800323486328e+02 2.3913200378417969e+02 3.5742501831054688e+02 -2.1754199218750000e+02 -1.5208299255371094e+02 3.5742501831054688e+02 3.1149599075317383e+01 -2.4288299560546875e+02 3.5742501831054688e+02 1.8248599243164062e+02 -1.9387300109863281e+02 3.5742501831054688e+02 1.9821299743652344e+02 -1.7769400024414062e+02 3.5742501831054688e+02 -2.0881900024414062e+02 1.5693501281738281e+02 3.5742501831054688e+02 -2.1574600219726562e+02 1.5339900207519531e+02 3.5742501831054688e+02 -2.1763800048828125e+02 1.5200799560546875e+02 3.5742501831054688e+02 -2.2312300109863281e+02 1.4657400512695312e+02 3.5742501831054688e+02 -2.5666299438476562e+02 -7.2379501342773438e+01 3.5742501831054688e+02 -2.5625799560546875e+02 -7.5194801330566406e+01 3.5742501831054688e+02 -2.4896499633789062e+02 -9.6645500183105469e+01 3.5742501831054688e+02 -2.3713600158691406e+02 -1.2246900177001953e+02 3.5742501831054688e+02 -2.3988301086425781e+02 -1.1740499877929688e+02 3.5742501831054688e+02 -2.4284799194335938e+02 -1.1062899780273438e+02 3.5742501831054688e+02 1.4720199584960938e+02 2.2196600341796875e+02 3.5742501831054688e+02 1.3413398742675781e+02 2.2952600097656250e+02 3.5742501831054688e+02 1.3339201354980469e+02 2.2983500671386719e+02 3.5742501831054688e+02 1.2558799743652344e+02 2.3308299255371094e+02 3.5742501831054688e+02 1.2029500579833984e+02 2.3528599548339844e+02 3.5742501831054688e+02 -2.1094299316406250e+02 -1.5607499694824219e+02 3.5742501831054688e+02 2.2628000259399414e+01 -2.4117399597167969e+02 3.5742501831054688e+02 2.8212100982666016e+01 -2.4264801025390625e+02 3.5742501831054688e+02 1.1252899932861328e+02 -2.3764599609375000e+02 3.5742501831054688e+02 2.1263400268554688e+02 -1.6009298706054688e+02 3.5742501831054688e+02 2.2550000000000000e+02 -1.4133499145507812e+02 3.5742501831054688e+02 2.3668099975585938e+02 -1.2163200378417969e+02 3.5742501831054688e+02 2.4609400939941406e+02 -1.0119499969482422e+02 3.5742501831054688e+02 -2.2494000244140625e+02 1.4401599121093750e+02 3.5742501831054688e+02 -2.5394898986816406e+02 8.2660697937011719e+01 3.5742501831054688e+02 -2.5625799560546875e+02 7.5194702148437500e+01 3.5742501831054688e+02 -2.5666299438476562e+02 7.2379501342773438e+01 3.5742501831054688e+02 2.5382701110839844e+02 -7.9799499511718750e+01 3.5742501831054688e+02 -2.2906999206542969e+02 -1.3733898925781250e+02 3.5742501831054688e+02 -2.2494200134277344e+02 -1.4401400756835938e+02 3.5742501831054688e+02 -2.1997499084472656e+02 -1.5001699829101562e+02 3.5742501831054688e+02 -2.4602799987792969e+02 1.0389900207519531e+02 3.5742501831054688e+02 3.7394800186157227e+00 -2.6225799560546875e+02 2.1954899597167969e+02 1.1552600097656250e+02 2.4747698974609375e+02 3.5848901367187500e+02 1.4094599914550781e+02 2.3189799499511719e+02 3.5867199707031250e+02 1.5302600097656250e+02 2.3070300292968750e+02 3.5848901367187500e+02 1.3408599853515625e+02 2.4091600036621094e+02 3.5848901367187500e+02 1.2018500518798828e+02 2.4085000610351562e+02 3.5867199707031250e+02 1.1453299713134766e+02 2.3712699890136719e+02 3.5885998535156250e+02 1.2755500030517578e+02 2.3240100097656250e+02 3.5885302734375000e+02 1.3354598999023438e+02 2.2981700134277344e+02 3.5885598754882812e+02 1.4720199584960938e+02 2.2196600341796875e+02 3.5885598754882812e+02 1.7731900024414062e+02 2.0563800048828125e+02 3.5867199707031250e+02 1.6895399475097656e+02 2.1925100708007812e+02 3.5848901367187500e+02 1.8563499450683594e+02 2.0525799560546875e+02 3.5848901367187500e+02 2.0138500976562500e+02 1.8199501037597656e+02 3.5867199707031250e+02 2.0341799926757812e+02 1.8755200195312500e+02 3.5848901367187500e+02 2.1944200134277344e+02 1.6848599243164062e+02 3.5848901367187500e+02 2.2267800903320312e+02 1.5511900329589844e+02 3.5867199707031250e+02 2.4045599365234375e+02 1.2576800537109375e+02 3.5867199707031250e+02 2.3194299316406250e+02 1.5075900268554688e+02 3.5848901367187500e+02 2.6456698608398438e+02 8.0605796813964844e+01 3.5848901367187500e+02 2.5273698425292969e+02 1.1236900329589844e+02 3.5848901367187500e+02 2.5437799072265625e+02 9.4407402038574219e+01 3.5867199707031250e+02 2.6985897827148438e+02 2.8047399520874023e+01 3.5867199707031250e+02 2.7572198486328125e+02 2.1554300308227539e+01 3.5848901367187500e+02 2.7392898559570312e+02 3.8088600158691406e+01 3.5848901367187500e+02 2.6420401000976562e+02 6.1705001831054688e+01 3.5867199707031250e+02 2.7007101440429688e+02 5.9589698791503906e+01 3.5848901367187500e+02 2.7124499511718750e+02 -6.0826497077941895e+00 3.5867199707031250e+02 2.7650601196289062e+02 -5.5927600860595703e+00 3.5848901367187500e+02 2.7521701049804688e+02 -2.7256000518798828e+01 3.5848901367187500e+02 2.6834500122070312e+02 -4.0012798309326172e+01 3.5867199707031250e+02 2.7223397827148438e+02 -4.8753700256347656e+01 3.5848901367187500e+02 2.6119100952148438e+02 -7.3434799194335938e+01 3.5867199707031250e+02 2.5906198120117188e+02 -9.6872497558593750e+01 3.5848901367187500e+02 2.6755099487304688e+02 -7.0051994323730469e+01 3.5848901367187500e+02 2.4985099792480469e+02 -1.0583399963378906e+02 3.5867199707031250e+02 2.5069099426269531e+02 -1.1687400054931641e+02 3.5848901367187500e+02 2.4074900817871094e+02 -1.3622399902343750e+02 3.5848901367187500e+02 2.3462599182128906e+02 -1.3635499572753906e+02 3.5867199707031250e+02 2.2922399902343750e+02 -1.5487899780273438e+02 3.5848901367187500e+02 2.1554200744628906e+02 -1.6491999816894531e+02 3.5867199707031250e+02 2.1653099060058594e+02 -1.7222900390625000e+02 3.5848901367187500e+02 1.9315899658203125e+02 -1.9075801086425781e+02 3.5867199707031250e+02 1.8716200256347656e+02 -2.0387100219726562e+02 3.5848901367187500e+02 2.0245100402832031e+02 -1.8863398742675781e+02 3.5848901367187500e+02 1.7068600463867188e+02 -2.1791200256347656e+02 3.5848901367187500e+02 1.5303300476074219e+02 -2.3071299743652344e+02 3.5848901367187500e+02 1.6415600585937500e+02 -2.0969000244140625e+02 3.5885598754882812e+02 1.4720800781250000e+02 -2.2197698974609375e+02 3.5885598754882812e+02 1.9832800292968750e+02 -1.7756498718261719e+02 3.5885501098632812e+02 1.8190200805664062e+02 -1.9452899169921875e+02 3.5885400390625000e+02 2.1191600036621094e+02 -1.6103999328613281e+02 3.5886199951171875e+02 2.3247300720214844e+02 -1.2918501281738281e+02 3.5885598754882812e+02 2.2416799926757812e+02 -1.4344300842285156e+02 3.5885598754882812e+02 2.4584999084472656e+02 -1.0178700256347656e+02 3.5885598754882812e+02 2.3688499450683594e+02 -1.2123300170898438e+02 3.5885598754882812e+02 2.5896899414062500e+02 -6.1052402496337891e+01 3.5885598754882812e+02 2.5321701049804688e+02 -8.1713699340820312e+01 3.5885598754882812e+02 2.6348199462890625e+02 -3.7667503356933594e+01 3.5885699462890625e+02 2.6597000122070312e+02 7.0164198875427246e+00 3.5885598754882812e+02 2.6572000122070312e+02 -1.3836099624633789e+01 3.5885598754882812e+02 2.6454498291015625e+02 2.8387100219726562e+01 3.5885598754882812e+02 2.6101898193359375e+02 5.2097000122070312e+01 3.5885501098632812e+02 2.4856999206542969e+02 9.4936500549316406e+01 3.5885598754882812e+02 2.5537800598144531e+02 7.4677101135253906e+01 3.5885598754882812e+02 2.3005599975585938e+02 1.3376599121093750e+02 3.5885598754882812e+02 2.4013299560546875e+02 1.1464600372314453e+02 3.5885598754882812e+02 2.2091400146484375e+02 1.4841400146484375e+02 3.5885598754882812e+02 1.9432099914550781e+02 1.8194900512695312e+02 3.5885598754882812e+02 2.0830400085449219e+02 1.6569801330566406e+02 3.5885501098632812e+02 1.6455699157714844e+02 2.0936199951171875e+02 3.5885598754882812e+02 1.7897500610351562e+02 1.9712199401855469e+02 3.5885598754882812e+02 1.3083999633789062e+02 -2.3688699340820312e+02 3.5867102050781250e+02 1.2258100128173828e+02 -2.4561299133300781e+02 3.5848901367187500e+02 1.4059600830078125e+02 -2.3804299926757812e+02 3.5848901367187500e+02 1.1562900543212891e+02 -2.3684700012207031e+02 3.5885998535156250e+02 1.2960700988769531e+02 -2.3167500305175781e+02 3.5886401367187500e+02 1.3499699401855469e+02 -2.2911199951171875e+02 3.5885598754882812e+02 1.9125099182128906e+02 6.9776100158691406e+01 3.0243600463867188e+02 9.0618293762207031e+01 2.4407600402832031e+02 2.6830300903320312e+02 9.0618293762207031e+01 2.4407600402832031e+02 2.9892199707031250e+02 9.0618293762207031e+01 -2.4407600402832031e+02 2.9892199707031250e+02 9.0618293762207031e+01 -2.4407600402832031e+02 2.6830300903320312e+02 1.9125099182128906e+02 -6.9776100158691406e+01 2.6478897094726562e+02 1.0919999694824219e+02 -2.5187998962402344e+02 3.5677200317382812e+02 1.4064199829101562e+02 -2.4087300109863281e+02 3.5676699829101562e+02 1.2824400329589844e+02 -2.4637899780273438e+02 3.5676898193359375e+02 1.2349900054931641e+02 -2.5278698730468750e+02 3.4722998046875000e+02 1.2522200012207031e+02 -2.4704701232910156e+02 3.5758099365234375e+02 1.2211499786376953e+02 -2.4843299865722656e+02 3.5677001953125000e+02 1.3735699462890625e+02 -2.4747000122070312e+02 3.4724301147460938e+02 1.4310600280761719e+02 -2.4471699523925781e+02 3.4725000000000000e+02 1.4298999023437500e+02 -2.3931098937988281e+02 3.5752200317382812e+02 1.4610099792480469e+02 -2.3803800964355469e+02 3.5676699829101562e+02 1.5702299499511719e+02 -2.3655900573730469e+02 3.4724102783203125e+02 1.5448098754882812e+02 -2.3288600158691406e+02 3.5676599121093750e+02 1.0507599639892578e+02 -2.5723202514648438e+02 3.4721600341796875e+02 1.1947200012207031e+02 -2.5400502014160156e+02 3.4722598266601562e+02 1.5694599914550781e+02 2.3658500671386719e+02 3.4726300048828125e+02 1.5447399902343750e+02 2.3287500000000000e+02 3.5676501464843750e+02 1.7479100036621094e+02 2.2365699768066406e+02 3.4726699829101562e+02 1.7055200195312500e+02 2.2131599426269531e+02 3.5676397705078125e+02 1.8369799804687500e+02 2.1602900695800781e+02 3.4726901245117188e+02 1.8084399414062500e+02 2.1268301391601562e+02 3.5676397705078125e+02 1.9309901428222656e+02 2.0797898864746094e+02 3.4727200317382812e+02 1.8739099121093750e+02 2.0719100952148438e+02 3.5676397705078125e+02 2.0873800659179688e+02 1.9221000671386719e+02 3.4727499389648438e+02 2.0316400146484375e+02 1.9169000244140625e+02 3.5676199340820312e+02 2.0751998901367188e+02 1.8694900512695312e+02 3.5676199340820312e+02 2.2303298950195312e+02 1.7537200927734375e+02 3.4723202514648438e+02 2.2148600769042969e+02 1.7013200378417969e+02 3.5674200439453125e+02 2.3113800048828125e+02 1.6414399719238281e+02 3.4728302001953125e+02 2.2751000976562500e+02 1.6157699584960938e+02 3.5676101684570312e+02 2.3588400268554688e+02 1.5758100891113281e+02 3.4728399658203125e+02 2.3413600158691406e+02 1.5218099975585938e+02 3.5676101684570312e+02 2.4737100219726562e+02 1.3879800415039062e+02 3.4728802490234375e+02 2.4535400390625000e+02 1.3329499816894531e+02 3.5676000976562500e+02 2.4990800476074219e+02 1.3416400146484375e+02 3.4728900146484375e+02 2.5512701416015625e+02 1.1342900085449219e+02 3.5676000976562500e+02 2.5962002563476562e+02 1.1418899536132812e+02 3.4729199218750000e+02 2.6411798095703125e+02 1.0275799560546875e+02 3.4729299926757812e+02 2.5987197875976562e+02 1.0206700134277344e+02 3.5675900268554688e+02 2.6016500854492188e+02 1.0122500610351562e+02 3.5675900268554688e+02 2.6768899536132812e+02 9.3681900024414062e+01 3.4729400634765625e+02 2.7412600708007812e+02 7.2684700012207031e+01 3.4729498291015625e+02 2.6706799316406250e+02 8.1366500854492188e+01 3.5675900268554688e+02 2.7491400146484375e+02 6.9159904479980469e+01 3.4729498291015625e+02 2.7262399291992188e+02 6.0152400970458984e+01 3.5675900268554688e+02 2.7892700195312500e+02 5.1229301452636719e+01 3.4729598999023438e+02 2.8024301147460938e+02 4.3428199768066406e+01 3.4730398559570312e+02 2.7651797485351562e+02 3.8448402404785156e+01 3.5675900268554688e+02 2.7695797729492188e+02 3.4395198822021484e+01 3.5675900268554688e+02 2.8277999877929688e+02 2.1419300079345703e+01 3.4729498291015625e+02 2.7832800292968750e+02 2.1757900238037109e+01 3.5675900268554688e+02 2.8358798217773438e+02 -5.8082801103591919e-01 3.4729702758789062e+02 2.7917700195312500e+02 -1.5914799273014069e-01 3.5675900268554688e+02 2.7911999511718750e+02 -5.6456298828125000e+00 3.5675900268554688e+02 2.8269500732421875e+02 -2.2507999420166016e+01 3.4729702758789062e+02 2.7781799316406250e+02 -2.7513399124145508e+01 3.5675900268554688e+02 2.8137500000000000e+02 -3.3631599426269531e+01 3.4729702758789062e+02 2.7704199218750000e+02 -3.3110698699951172e+01 3.5675900268554688e+02 2.8010601806640625e+02 -4.4327999114990234e+01 3.4729598999023438e+02 2.7480700683593750e+02 -4.9214099884033203e+01 3.5675900268554688e+02 2.7876800537109375e+02 -5.2085601806640625e+01 3.4729598999023438e+02 2.7515100097656250e+02 -6.7990798950195312e+01 3.4729498291015625e+02 2.7008102416992188e+02 -7.0713294982910156e+01 3.5675900268554688e+02 2.7384201049804688e+02 -7.3748001098632812e+01 3.4729498291015625e+02 2.6836700439453125e+02 -7.6969497680664062e+01 3.5675900268554688e+02 2.6729397583007812e+02 -9.4801498413085938e+01 3.4729800415039062e+02 2.6151098632812500e+02 -9.7786705017089844e+01 3.5675900268554688e+02 2.6051800537109375e+02 -1.0015899658203125e+02 3.5675900268554688e+02 2.5916699218750000e+02 -1.1522000122070312e+02 3.4729098510742188e+02 2.5306098937988281e+02 -1.1797699737548828e+02 3.5676000976562500e+02 2.4947399902343750e+02 -1.3497599792480469e+02 3.4728802490234375e+02 2.4302400207519531e+02 -1.3750801086425781e+02 3.5676000976562500e+02 2.4584100341796875e+02 -1.4150300598144531e+02 3.4728598022460938e+02 2.3404200744628906e+02 -1.6032099914550781e+02 3.4727999877929688e+02 2.3139199829101562e+02 -1.5633900451660156e+02 3.5676101684570312e+02 2.2811999511718750e+02 -1.6081100463867188e+02 3.5676101684570312e+02 2.2091000366210938e+02 -1.7804100036621094e+02 3.4727902221679688e+02 2.1857899475097656e+02 -1.7385198974609375e+02 3.5676199340820312e+02 2.0427200317382812e+02 -1.9047399902343750e+02 3.5680801391601562e+02 1.8176100158691406e+02 -2.1190199279785156e+02 3.5676397705078125e+02 1.8505700683593750e+02 -2.1521499633789062e+02 3.4726501464843750e+02 1.8893200683593750e+02 -2.0579199218750000e+02 3.5676397705078125e+02 1.9082899475097656e+02 -2.1008900451660156e+02 3.4726699829101562e+02 2.0650000000000000e+02 -1.9463600158691406e+02 3.4727099609375000e+02 1.7230099487304688e+02 -2.1996400451660156e+02 3.5676501464843750e+02 1.6784599304199219e+02 -2.2896000671386719e+02 3.4726000976562500e+02 1.1248999786376953e+02 2.5575798034667969e+02 3.4722799682617188e+02 1.0932499694824219e+02 2.5183499145507812e+02 3.5677099609375000e+02 1.2142600250244141e+02 2.5341099548339844e+02 3.4722500610351562e+02 1.2352100372314453e+02 2.4803199768066406e+02 3.5676898193359375e+02 1.3533000183105469e+02 2.4833700561523438e+02 3.4724600219726562e+02 1.2837500000000000e+02 2.4631201171875000e+02 3.5676800537109375e+02 1.4191700744628906e+02 2.4028199768066406e+02 3.5676599121093750e+02 1.3966400146484375e+02 2.4638200378417969e+02 3.4725201416015625e+02 1.5287899780273438e+02 2.3919799804687500e+02 3.4726397705078125e+02 1.4623199462890625e+02 2.3794799804687500e+02 3.5676599121093750e+02 1.9633700561523438e+02 5.7276100158691406e+01 3.0436099243164062e+02 1.9274699401855469e+02 7.0676101684570312e+01 3.0423501586914062e+02 8.9297103881835938e+01 2.4822200012207031e+02 3.0062100219726562e+02 9.2114295959472656e+01 2.4497599792480469e+02 3.0072097778320312e+02 1.9633700561523438e+02 -5.7276100158691406e+01 3.0436099243164062e+02 9.2114295959472656e+01 -2.4497599792480469e+02 3.0072097778320312e+02 1.9274699401855469e+02 -7.0676101684570312e+01 3.0423501586914062e+02 1.9460000610351562e+02 -5.7276100158691406e+01 3.0256201171875000e+02 1.9460000610351562e+02 -5.7282699584960938e+01 2.6466302490234375e+02 1.9460000610351562e+02 5.7282699584960938e+01 3.0256201171875000e+02 1.9460000610351562e+02 5.7276100158691406e+01 2.6466302490234375e+02 8.9281898498535156e+01 -2.4824101257324219e+02 2.6660498046875000e+02 9.2114295959472656e+01 -2.4497599792480469e+02 2.6650399780273438e+02 1.9274699401855469e+02 -7.0676101684570312e+01 2.6298999023437500e+02 1.9633700561523438e+02 -5.7279602050781250e+01 2.6286398315429688e+02 1.9274699401855469e+02 7.0676101684570312e+01 2.6298999023437500e+02 1.9633700561523438e+02 5.7276100158691406e+01 2.6286398315429688e+02 9.2114295959472656e+01 2.4497599792480469e+02 2.6650399780273438e+02 8.2304901123046875e+01 2.5478601074218750e+02 2.6684600830078125e+02 1.5746499633789062e+02 2.3738800048828125e+02 2.1970799255371094e+02 1.5199699401855469e+02 2.4276899719238281e+02 2.1978900146484375e+02 2.7626998901367188e+02 -6.9448905944824219e+01 2.1970799255371094e+02 2.8103399658203125e+02 -4.6560802459716797e+01 2.1970799255371094e+02 2.8275997924804688e+02 -4.4032901763916016e+01 2.1979899597167969e+02 1.5801000976562500e+02 -2.3820899963378906e+02 2.1977600097656250e+02 1.5739999389648438e+02 -2.3728999328613281e+02 2.1966900634765625e+02 1.7640100097656250e+02 -2.2367599487304688e+02 2.1970799255371094e+02 1.9414801025390625e+02 -2.0845800781250000e+02 2.1970799255371094e+02 2.1058799743652344e+02 -1.9183599853515625e+02 2.1970799255371094e+02 2.2560900878906250e+02 -1.7392100524902344e+02 2.1970799255371094e+02 2.5100201416015625e+02 -1.3470700073242188e+02 2.1970799255371094e+02 2.3911100769042969e+02 -1.5483500671386719e+02 2.1970799255371094e+02 2.6964501953125000e+02 -9.1869194030761719e+01 2.1970799255371094e+02 2.7198602294921875e+02 -8.9606101989746094e+01 2.1979699707031250e+02 2.6120300292968750e+02 -1.1367099761962891e+02 2.1970799255371094e+02 2.6193402099609375e+02 -1.1525399780273438e+02 2.1979899597167969e+02 2.8486499023437500e+02 0.0000000000000000e+00 2.1970799255371094e+02 2.8616699218750000e+02 9.2292696237564087e-02 2.1979899597167969e+02 2.8390600585937500e+02 -2.3359001159667969e+01 2.1970799255371094e+02 2.8531701660156250e+02 -2.2049200057983398e+01 2.1979899597167969e+02 2.8103399658203125e+02 4.6560802459716797e+01 2.1970799255371094e+02 2.8458200073242188e+02 3.0077699661254883e+01 2.1979899597167969e+02 2.8390600585937500e+02 2.3359001159667969e+01 2.1970799255371094e+02 2.8606298828125000e+02 7.7445497512817383e+00 2.1979899597167969e+02 2.6964501953125000e+02 9.1869194030761719e+01 2.1970799255371094e+02 2.7652902221679688e+02 7.3646499633789062e+01 2.1979899597167969e+02 2.7626998901367188e+02 6.9448905944824219e+01 2.1970799255371094e+02 2.8139300537109375e+02 5.2052898406982422e+01 2.1979899597167969e+02 2.5100201416015625e+02 1.3470700073242188e+02 2.1970799255371094e+02 2.5858499145507812e+02 1.2258399963378906e+02 2.1979899597167969e+02 2.6120300292968750e+02 1.1367099761962891e+02 2.1970799255371094e+02 2.2560900878906250e+02 1.7392100524902344e+02 2.1970799255371094e+02 2.2096499633789062e+02 1.8180899047851562e+02 2.1979899597167969e+02 2.3911100769042969e+02 1.5483500671386719e+02 2.1970799255371094e+02 2.4830200195312500e+02 1.4226600646972656e+02 2.1979899597167969e+02 2.1058799743652344e+02 1.9183599853515625e+02 2.1970799255371094e+02 1.9414801025390625e+02 2.0845800781250000e+02 2.1970799255371094e+02 1.7640100097656250e+02 2.2367599487304688e+02 2.1970799255371094e+02 1.5720799255371094e+02 -2.3700000000000000e+02 2.1867500305175781e+02 1.5719999694824219e+02 -2.3702099609375000e+02 2.1797999572753906e+02 1.7610000610351562e+02 -2.2332400512695312e+02 2.1800000000000000e+02 1.5725700378417969e+02 2.3700399780273438e+02 2.1787899780273438e+02 1.5719300842285156e+02 2.3700900268554688e+02 2.1927600097656250e+02 1.7612800598144531e+02 2.2330300903320312e+02 2.1799800109863281e+02 1.7610000610351562e+02 2.2332400512695312e+02 2.1935099792480469e+02 1.9385301208496094e+02 2.0810099792480469e+02 2.1799899291992188e+02 1.9381300354003906e+02 2.0813800048828125e+02 2.1935099792480469e+02 2.1026399230957031e+02 1.9150399780273438e+02 2.1799899291992188e+02 2.1022799682617188e+02 1.9154399108886719e+02 2.1935099792480469e+02 2.2526000976562500e+02 1.7361700439453125e+02 2.1799899291992188e+02 2.2522700500488281e+02 1.7365998840332031e+02 2.1935099792480469e+02 2.3873800659179688e+02 1.5456100463867188e+02 2.1799899291992188e+02 2.3870800781250000e+02 1.5460699462890625e+02 2.1935099792480469e+02 2.5060800170898438e+02 1.3446398925781250e+02 2.1799899291992188e+02 2.5058201599121094e+02 1.3451200866699219e+02 2.1935099792480469e+02 2.6078997802734375e+02 1.1346199798583984e+02 2.1799899291992188e+02 2.6076800537109375e+02 1.1351100158691406e+02 2.1935099792480469e+02 2.6921600341796875e+02 9.1694396972656250e+01 2.1799899291992188e+02 2.6919799804687500e+02 9.1745597839355469e+01 2.1935099792480469e+02 2.7582800292968750e+02 6.9310096740722656e+01 2.1799899291992188e+02 2.7581500244140625e+02 6.9362602233886719e+01 2.1935099792480469e+02 2.8058300781250000e+02 4.6458400726318359e+01 2.1799899291992188e+02 2.8057400512695312e+02 4.6511798858642578e+01 2.1935099792480469e+02 2.8345700073242188e+02 2.3251300811767578e+01 2.1789201354980469e+02 2.8344198608398438e+02 2.3320899963378906e+01 2.1920899963378906e+02 2.8440899658203125e+02 -7.0466399192810059e-02 2.1789201354980469e+02 2.8439999389648438e+02 0.0000000000000000e+00 2.1920899963378906e+02 2.8344500732421875e+02 -2.3391698837280273e+01 2.1789201354980469e+02 2.8344198608398438e+02 -2.3320899963378906e+01 2.1920899963378906e+02 2.8057400512695312e+02 -4.6511798858642578e+01 2.1799899291992188e+02 2.8058300781250000e+02 -4.6458400726318359e+01 2.1935099792480469e+02 2.7581500244140625e+02 -6.9362602233886719e+01 2.1799899291992188e+02 2.7582800292968750e+02 -6.9310096740722656e+01 2.1935099792480469e+02 2.6919799804687500e+02 -9.1745697021484375e+01 2.1799899291992188e+02 2.6921600341796875e+02 -9.1694396972656250e+01 2.1935099792480469e+02 2.6076800537109375e+02 -1.1351100158691406e+02 2.1799899291992188e+02 2.6078997802734375e+02 -1.1346199798583984e+02 2.1935099792480469e+02 2.5058201599121094e+02 -1.3451200866699219e+02 2.1799899291992188e+02 2.5060800170898438e+02 -1.3446398925781250e+02 2.1935099792480469e+02 2.3870800781250000e+02 -1.5460699462890625e+02 2.1799899291992188e+02 2.3873800659179688e+02 -1.5456100463867188e+02 2.1935099792480469e+02 2.2522700500488281e+02 -1.7365998840332031e+02 2.1799899291992188e+02 2.2526000976562500e+02 -1.7361700439453125e+02 2.1935099792480469e+02 2.1022799682617188e+02 -1.9154399108886719e+02 2.1799899291992188e+02 2.1026399230957031e+02 -1.9150399780273438e+02 2.1935099792480469e+02 1.9381300354003906e+02 -2.0813800048828125e+02 2.1799899291992188e+02 1.9385301208496094e+02 -2.0810099792480469e+02 2.1935099792480469e+02 1.7612800598144531e+02 -2.2330300903320312e+02 2.1935200500488281e+02 1.5723300170898438e+02 -2.3699800109863281e+02 2.1936300659179688e+02 1.2310900115966797e+02 2.5496101379394531e+02 2.1975299072265625e+02 1.3172799682617188e+02 2.5265100097656250e+02 2.1980899047851562e+02 1.3031700134277344e+02 2.5149899291992188e+02 2.1966999816894531e+02 1.1376200103759766e+02 2.5665899658203125e+02 2.1966200256347656e+02 1.4413000488281250e+02 2.4507600402832031e+02 2.1964900207519531e+02 1.4647300720214844e+02 2.4366799926757812e+02 2.1770399475097656e+02 1.3850698852539062e+02 2.4774398803710938e+02 2.1774600219726562e+02 1.4474099731445312e+02 2.4446398925781250e+02 2.1867599487304688e+02 1.1363999938964844e+02 2.5648599243164062e+02 2.1920899963378906e+02 1.3072698974609375e+02 2.5110798645019531e+02 2.1926400756835938e+02 1.2287600708007812e+02 2.5385800170898438e+02 2.1867500305175781e+02 1.1363999938964844e+02 2.5648599243164062e+02 2.1814100646972656e+02 1.3071299743652344e+02 2.5111299133300781e+02 2.1808700561523438e+02 1.3548500061035156e+02 -2.5023001098632812e+02 2.1975399780273438e+02 1.2768099975585938e+02 -2.5267198181152344e+02 2.1969300842285156e+02 1.4420098876953125e+02 -2.4497799682617188e+02 2.1966200256347656e+02 1.1022900390625000e+02 -2.5728500366210938e+02 2.1944599914550781e+02 1.1206399536132812e+02 -2.5685900878906250e+02 2.1866999816894531e+02 1.2760199737548828e+02 -2.5233799743652344e+02 2.1929100036621094e+02 1.3492100524902344e+02 -2.4925199890136719e+02 2.1867500305175781e+02 1.4417700195312500e+02 -2.4476799011230469e+02 2.1920899963378906e+02 1.4420600891113281e+02 -2.4475000000000000e+02 2.1812599182128906e+02 1.2749700164794922e+02 -2.5237301635742188e+02 2.1806199645996094e+02 1.5412899780273438e+02 -2.3235699462890625e+02 3.5765200805664062e+02 1.4286999511718750e+02 -2.3817799377441406e+02 3.5825198364257812e+02 1.5362399291992188e+02 -2.3160000610351562e+02 3.5825299072265625e+02 1.2545399475097656e+02 -2.4591499328613281e+02 3.5825198364257812e+02 1.0888999938964844e+02 -2.5036698913574219e+02 3.5825399780273438e+02 1.0907199859619141e+02 -2.5125798034667969e+02 3.5765499877929688e+02 2.5928100585937500e+02 1.0183600616455078e+02 3.5764898681640625e+02 1.6960600280761719e+02 2.2009399414062500e+02 3.5825299072265625e+02 1.5361698913574219e+02 2.3158900451660156e+02 3.5825299072265625e+02 1.5412199401855469e+02 2.3234700012207031e+02 3.5765200805664062e+02 1.7016300964355469e+02 2.2081401062011719e+02 3.5765200805664062e+02 1.8635099792480469e+02 2.0604699707031250e+02 3.5825299072265625e+02 2.0498300170898438e+02 1.8900300598144531e+02 3.5764599609375000e+02 1.8696400451660156e+02 2.0672099304199219e+02 3.5765100097656250e+02 2.2101199340820312e+02 1.6968800354003906e+02 3.5765002441406250e+02 2.0425500488281250e+02 1.8843499755859375e+02 3.5825399780273438e+02 2.2028900146484375e+02 1.6913400268554688e+02 3.5825299072265625e+02 2.3283799743652344e+02 1.5133999633789062e+02 3.5825299072265625e+02 2.4479499816894531e+02 1.3299200439453125e+02 3.5765002441406250e+02 2.3360299682617188e+02 1.5183599853515625e+02 3.5765002441406250e+02 2.4399400329589844e+02 1.3255799865722656e+02 3.5825299072265625e+02 2.5371301269531250e+02 1.1280100250244141e+02 3.5825299072265625e+02 2.5454598999023438e+02 1.1317099761962891e+02 3.5765002441406250e+02 2.7111398315429688e+02 5.9819400787353516e+01 3.5825198364257812e+02 2.6558798217773438e+02 8.0916503906250000e+01 3.5825198364257812e+02 2.5843301391601562e+02 1.0150299835205078e+02 3.5825299072265625e+02 2.7588900756835938e+02 3.8361099243164062e+01 3.5764898681640625e+02 2.7200399780273438e+02 6.0015701293945312e+01 3.5764898681640625e+02 2.6645999145507812e+02 8.1181900024414062e+01 3.5764898681640625e+02 2.7498599243164062e+02 3.8235500335693359e+01 3.5825198364257812e+02 2.7678601074218750e+02 2.1637399673461914e+01 3.5825198364257812e+02 2.7769500732421875e+02 2.1708400726318359e+01 3.5764898681640625e+02 2.7854202270507812e+02 -1.5878899395465851e-01 3.5764898681640625e+02 2.7763000488281250e+02 -1.5827199816703796e-01 3.5825198364257812e+02 2.7757299804687500e+02 -5.6143398284912109e+00 3.5825198364257812e+02 2.7627899169921875e+02 -2.7361101150512695e+01 3.5825198364257812e+02 2.7718698120117188e+02 -2.7450901031494141e+01 3.5764898681640625e+02 2.7848498535156250e+02 -5.6328201293945312e+00 3.5764898681640625e+02 2.7418200683593750e+02 -4.9102298736572266e+01 3.5764898681640625e+02 2.7328500366210938e+02 -4.8941699981689453e+01 3.5825198364257812e+02 2.6789599609375000e+02 -7.3393997192382812e+01 3.5825399780273438e+02 2.6091598510742188e+02 -9.7564598083496094e+01 3.5764898681640625e+02 2.6874099731445312e+02 -7.3734001159667969e+01 3.5765499877929688e+02 2.6006201171875000e+02 -9.7245796203613281e+01 3.5825299072265625e+02 2.5165901184082031e+02 -1.1732400512695312e+02 3.5825299072265625e+02 2.5248500061035156e+02 -1.1770899963378906e+02 3.5765002441406250e+02 2.4247200012207031e+02 -1.3719599914550781e+02 3.5765002441406250e+02 2.3086500549316406e+02 -1.5598399353027344e+02 3.5765002441406250e+02 2.1736698913574219e+02 -1.7289100646972656e+02 3.5825299072265625e+02 2.3010900878906250e+02 -1.5547500610351562e+02 3.5825299072265625e+02 2.4167799377441406e+02 -1.3674800109863281e+02 3.5825299072265625e+02 2.1808099365234375e+02 -1.7345799255371094e+02 3.5765002441406250e+02 1.8788499450683594e+02 -2.0465501403808594e+02 3.5825299072265625e+02 2.0323300170898438e+02 -1.8935998535156250e+02 3.5825299072265625e+02 2.0389999389648438e+02 -1.8997999572753906e+02 3.5765100097656250e+02 1.8850199890136719e+02 -2.0532501220703125e+02 3.5765200805664062e+02 1.7134500122070312e+02 -2.1874900817871094e+02 3.5825299072265625e+02 1.7190800476074219e+02 -2.1946499633789062e+02 3.5765200805664062e+02 1.4331799316406250e+02 2.3894599914550781e+02 3.5765600585937500e+02 1.4279399108886719e+02 2.3818600463867188e+02 3.5825601196289062e+02 1.2584100341796875e+02 2.4671200561523438e+02 3.5766198730468750e+02 1.2540900421142578e+02 2.4590699768066406e+02 3.5825601196289062e+02 1.0919599914550781e+02 2.5121200561523438e+02 3.5765499877929688e+02 1.0901300048828125e+02 2.5032099914550781e+02 3.5825399780273438e+02 7.7660301208496094e+01 2.5501701354980469e+02 2.6878802490234375e+02 7.1806900024414062e+01 2.5641500854492188e+02 2.6879000854492188e+02 8.8195602416992188e+01 2.4755400085449219e+02 2.9883099365234375e+02 8.1766395568847656e+01 2.5292799377441406e+02 2.6863400268554688e+02 8.1391700744628906e+01 2.5236698913574219e+02 2.9857699584960938e+02 8.1467704772949219e+01 2.5322698974609375e+02 2.6864498901367188e+02 7.7628395080566406e+01 2.5502801513671875e+02 2.9843597412109375e+02 7.6431495666503906e+01 2.5543600463867188e+02 2.9841101074218750e+02 1.9125399780273438e+02 6.9770401000976562e+01 2.6478897094726562e+02 1.9125399780273438e+02 -6.9770401000976562e+01 3.0243701171875000e+02 7.0966102600097656e+01 -2.5649600219726562e+02 2.9840402221679688e+02 7.6431495666503906e+01 -2.5543600463867188e+02 2.6881500244140625e+02 7.7499298095703125e+01 -2.5507598876953125e+02 2.9843099975585938e+02 7.7607200622558594e+01 -2.5503599548339844e+02 2.6879000854492188e+02 8.1467704772949219e+01 -2.5322698974609375e+02 2.9857998657226562e+02 8.1391296386718750e+01 -2.5236499023437500e+02 2.6864801025390625e+02 8.1766395568847656e+01 -2.5292799377441406e+02 2.9859097290039062e+02 8.8181198120117188e+01 -2.4757099914550781e+02 2.6839398193359375e+02 7.7569198608398438e+01 -2.5554698181152344e+02 2.9971701049804688e+02 9.0811698913574219e+01 -2.4420599365234375e+02 2.9980599975585938e+02 8.1716903686523438e+01 -2.5366101074218750e+02 2.9988101196289062e+02 9.1357299804687500e+01 -2.4453399658203125e+02 3.0046200561523438e+02 1.9144700622558594e+02 -6.9899703979492188e+01 3.0332101440429688e+02 1.9199299621582031e+02 -7.0227897644042969e+01 3.0397702026367188e+02 1.9546400451660156e+02 -5.7276100158691406e+01 3.0409899902343750e+02 1.9483099365234375e+02 -5.7276100158691406e+01 3.0344400024414062e+02 7.7519294738769531e+01 -2.5611199951171875e+02 2.6726098632812500e+02 7.7307296752929688e+01 -2.5551301574707031e+02 2.6791598510742188e+02 1.9483099365234375e+02 5.7282699584960938e+01 3.0344400024414062e+02 1.9546400451660156e+02 5.7282897949218750e+01 3.0409899902343750e+02 9.1357299804687500e+01 -2.4453399658203125e+02 2.6676300048828125e+02 8.8347702026367188e+01 -2.4773600769042969e+02 2.6750799560546875e+02 9.0811698913574219e+01 -2.4420599365234375e+02 2.6741900634765625e+02 1.9199000549316406e+02 7.0233802795410156e+01 3.0397702026367188e+02 1.9144400024414062e+02 6.9905601501464844e+01 3.0331997680664062e+02 1.9144400024414062e+02 -6.9905601501464844e+01 2.6390499877929688e+02 1.9199000549316406e+02 -7.0233802795410156e+01 2.6324902343750000e+02 9.0811698913574219e+01 2.4420599365234375e+02 2.9980599975585938e+02 9.1357299804687500e+01 2.4453399658203125e+02 3.0046200561523438e+02 1.9546400451660156e+02 -5.7282897949218750e+01 2.6312597656250000e+02 1.9483099365234375e+02 -5.7282699584960938e+01 2.6378100585937500e+02 7.7322700500488281e+01 2.5551000976562500e+02 2.9930999755859375e+02 8.8362297058105469e+01 2.4771800231933594e+02 2.9971701049804688e+02 7.7561500549316406e+01 2.5609698486328125e+02 2.9996899414062500e+02 1.9483099365234375e+02 5.7276100158691406e+01 2.6378100585937500e+02 1.9546400451660156e+02 5.7276100158691406e+01 2.6312597656250000e+02 1.9199299621582031e+02 7.0227699279785156e+01 2.6324798583984375e+02 1.9144700622558594e+02 6.9899795532226562e+01 2.6390399169921875e+02 9.0811698913574219e+01 2.4420599365234375e+02 2.6741900634765625e+02 9.1357299804687500e+01 2.4453399658203125e+02 2.6676300048828125e+02 8.1717102050781250e+01 2.5365998840332031e+02 2.6734500122070312e+02 7.7734298706054688e+01 2.5548600769042969e+02 2.6750399780273438e+02 2.2124800109863281e+02 1.8200500488281250e+02 2.1986801147460938e+02 2.6903302001953125e+02 9.8483001708984375e+01 2.1987199401855469e+02 2.2615000915527344e+02 -1.7587399291992188e+02 2.1986700439453125e+02 1.9338400268554688e+02 -2.1118199157714844e+02 2.1987899780273438e+02 1.5824600219726562e+02 -2.3864700317382812e+02 2.1986999511718750e+02 1.2373799896240234e+02 -2.5292399597167969e+02 6.4391395568847656e+01 1.2186299896240234e+02 -2.5360501098632812e+02 6.4391098022460938e+01 1.5723199462890625e+02 -2.3703500366210938e+02 6.4395195007324219e+01 1.5723199462890625e+02 2.3703500366210938e+02 6.4395195007324219e+01 1.3583099365234375e+02 2.4844900512695312e+02 6.4393699645996094e+01 1.1962000274658203e+02 2.5425601196289062e+02 6.4390602111816406e+01 1.1300299835205078e+02 2.5570899963378906e+02 6.4389701843261719e+01 1.8043400573730469e+02 -2.1973699951171875e+02 6.4392097473144531e+01 2.7236199951171875e+02 -8.4458702087402344e+01 6.4361198425292969e+01 2.6511898803710938e+02 -1.0481999969482422e+02 6.4365501403808594e+01 2.5952600097656250e+02 -1.1734799957275391e+02 6.4367897033691406e+01 2.5604998779296875e+02 -1.2513500213623047e+02 6.4369499206542969e+01 2.5250801086425781e+02 -1.3206100463867188e+02 6.4371696472167969e+01 2.4792300415039062e+02 -1.3997399902343750e+02 6.4373703002929688e+01 2.4142298889160156e+02 -1.5119099426269531e+02 6.4376602172851562e+01 2.1778799438476562e+02 -1.8312800598144531e+02 6.4384605407714844e+01 2.7251300048828125e+02 -8.4033401489257812e+01 6.4361099243164062e+01 2.8054800415039062e+02 -5.0595001220703125e+01 6.4354797363281250e+01 2.8338900756835938e+02 -3.3171600341796875e+01 6.4353599548339844e+01 2.8475698852539062e+02 -1.5848599433898926e+01 6.4352500915527344e+01 2.8473498535156250e+02 1.6141500473022461e+01 6.4352500915527344e+01 2.8342599487304688e+02 3.2854602813720703e+01 6.4353302001953125e+01 2.8065197753906250e+02 5.0466602325439453e+01 6.4355400085449219e+01 2.8000399780273438e+02 5.4580902099609375e+01 6.4355903625488281e+01 2.7849099731445312e+02 6.1741298675537109e+01 6.4356300354003906e+01 2.7275198364257812e+02 8.3262695312500000e+01 6.4360603332519531e+01 2.7231698608398438e+02 8.4497695922851562e+01 6.4360900878906250e+01 2.6539700317382812e+02 1.0412299346923828e+02 6.4365295410156250e+01 2.5967199707031250e+02 1.1704800415039062e+02 6.4367897033691406e+01 2.3350100708007812e+02 1.6275300598144531e+02 6.4379600524902344e+01 2.2280999755859375e+02 1.7691500854492188e+02 6.4383003234863281e+01 1.9940599060058594e+02 2.0292500305175781e+02 6.4388793945312500e+01 1.8488700866699219e+02 2.1626600646972656e+02 6.4391799926757812e+01 1.7969700622558594e+02 2.2057299804687500e+02 6.4392593383789062e+01 1.7282701110839844e+02 2.2571499633789062e+02 6.4393402099609375e+01 1.6204100036621094e+02 2.3378799438476562e+02 6.4394699096679688e+01 2.8171200561523438e+02 4.5235599517822266e+01 1.1810700225830078e+02 2.8171200561523438e+02 -4.5235599517822266e+01 1.1810700225830078e+02 2.8495498657226562e+02 -1.5746200561523438e+01 1.1623500061035156e+02 2.8536297607421875e+02 4.5208301544189453e+00 1.1599900054931641e+02 2.8462899780273438e+02 2.5359399795532227e+01 1.1638599395751953e+02 2.7921200561523438e+02 6.3021503448486328e+01 1.2243699645996094e+02 2.7921200561523438e+02 -6.3021503448486328e+01 1.2243699645996094e+02 2.7948599243164062e+02 6.1319198608398438e+01 1.2080399322509766e+02 2.7921701049804688e+02 -6.2988304138183594e+01 1.2221099853515625e+02 2.7926998901367188e+02 -6.2664203643798828e+01 1.2168000030517578e+02 2.7952200317382812e+02 6.1085899353027344e+01 1.2073100280761719e+02 2.7952798461914062e+02 -6.1050998687744141e+01 1.2073200225830078e+02 2.8006100463867188e+02 5.7603298187255859e+01 1.1964900207519531e+02 2.8016299438476562e+02 5.6921096801757812e+01 1.1950399780273438e+02 2.7961901855468750e+02 -6.0485401153564453e+01 1.2046199798583984e+02 2.7987701416015625e+02 -5.8819599151611328e+01 1.1994499969482422e+02 2.8041699218750000e+02 5.5058097839355469e+01 1.1925700378417969e+02 2.8041000366210938e+02 -5.5172599792480469e+01 1.1924500274658203e+02 2.8139099121093750e+02 4.7897598266601562e+01 1.1830899810791016e+02 2.8065402221679688e+02 -5.3496597290039062e+01 1.1892399597167969e+02 2.7921200561523438e+02 -6.3303501129150391e+01 1.7166400146484375e+02 2.7921200561523438e+02 6.3303501129150391e+01 1.7166400146484375e+02 2.7952798461914062e+02 6.1350402832031250e+01 1.7336900329589844e+02 2.7962399291992188e+02 6.0749900817871094e+01 1.7365299987792969e+02 2.8012298583984375e+02 -5.7494598388671875e+01 1.7454100036621094e+02 2.7988299560546875e+02 5.9084499359130859e+01 1.7416600036621094e+02 2.8042199707031250e+02 -5.5306400299072266e+01 1.7483999633789062e+02 2.8040899658203125e+02 5.5471500396728516e+01 1.7485600280761719e+02 2.8133401489257812e+02 -4.8624797821044922e+01 1.7575299072265625e+02 2.8065499877929688e+02 5.3784900665283203e+01 1.7517800903320312e+02 2.8171200561523438e+02 -4.5497001647949219e+01 1.7599398803710938e+02 2.8171200561523438e+02 4.5497001647949219e+01 1.7599398803710938e+02 2.7921798706054688e+02 6.3266395568847656e+01 1.7191700744628906e+02 2.7927301025390625e+02 6.2935501098632812e+01 1.7244400024414062e+02 2.8003500366210938e+02 -5.8082901000976562e+01 1.7441200256347656e+02 2.7947698974609375e+02 -6.1676403045654297e+01 1.7327099609375000e+02 2.7930200195312500e+02 -6.2758201599121094e+01 1.7261000061035156e+02 2.8495599365234375e+02 1.5829000473022461e+01 1.7786698913574219e+02 2.8536297607421875e+02 -4.5592799186706543e+00 1.7810200500488281e+02 2.8462899780273438e+02 -2.5519001007080078e+01 1.7771499633789062e+02 1.5782499694824219e+02 -2.3792999267578125e+02 2.1759700012207031e+02 1.5315400695800781e+02 -2.4208100891113281e+02 2.1753700256347656e+02 1.6998899841308594e+02 -2.3020700073242188e+02 2.1755099487304688e+02 2.7626998901367188e+02 6.9448905944824219e+01 2.1764199829101562e+02 2.8103399658203125e+02 4.6560802459716797e+01 2.1764199829101562e+02 1.5812799072265625e+02 2.3865699768066406e+02 2.1753900146484375e+02 1.5746499633789062e+02 2.3738800048828125e+02 2.1764199829101562e+02 1.7633799743652344e+02 2.2538099670410156e+02 2.1755099487304688e+02 1.7640100097656250e+02 2.2367599487304688e+02 2.1764199829101562e+02 1.9414801025390625e+02 2.0845800781250000e+02 2.1764199829101562e+02 2.2560900878906250e+02 1.7392100524902344e+02 2.1764199829101562e+02 2.2351199340820312e+02 1.7869999694824219e+02 2.1755099487304688e+02 2.1058799743652344e+02 1.9183599853515625e+02 2.1764199829101562e+02 2.0901499938964844e+02 1.9545799255371094e+02 2.1755099487304688e+02 2.5100201416015625e+02 1.3470700073242188e+02 2.1764199829101562e+02 2.5224301147460938e+02 1.3514700317382812e+02 2.1755099487304688e+02 2.3911100769042969e+02 1.5483500671386719e+02 2.1764199829101562e+02 2.4100399780273438e+02 1.5429901123046875e+02 2.1755099487304688e+02 2.6964501953125000e+02 9.1869194030761719e+01 2.1764199829101562e+02 2.7006597900390625e+02 9.4635803222656250e+01 2.1755099487304688e+02 2.6120300292968750e+02 1.1367099761962891e+02 2.1764199829101562e+02 2.6193402099609375e+02 1.1524800109863281e+02 2.1755099487304688e+02 2.7250000000000000e+02 8.7380897521972656e+01 2.1755099487304688e+02 2.8486499023437500e+02 0.0000000000000000e+00 2.1764199829101562e+02 2.8616699218750000e+02 -9.4802998006343842e-02 2.1755099487304688e+02 2.8390600585937500e+02 2.3359001159667969e+01 2.1764199829101562e+02 2.8531701660156250e+02 2.2045898437500000e+01 2.1755099487304688e+02 2.8103399658203125e+02 -4.6560802459716797e+01 2.1764199829101562e+02 2.8458300781250000e+02 -3.0073799133300781e+01 2.1755099487304688e+02 2.8390600585937500e+02 -2.3359001159667969e+01 2.1764199829101562e+02 2.8606298828125000e+02 -7.7417502403259277e+00 2.1755099487304688e+02 2.6964501953125000e+02 -9.1869194030761719e+01 2.1764199829101562e+02 2.7626998901367188e+02 -6.9448905944824219e+01 2.1764199829101562e+02 2.8139401245117188e+02 -5.2047801971435547e+01 2.1755099487304688e+02 2.5100201416015625e+02 -1.3470700073242188e+02 2.1764199829101562e+02 2.5858798217773438e+02 -1.2256999969482422e+02 2.1755099487304688e+02 2.6120300292968750e+02 -1.1367099761962891e+02 2.1764199829101562e+02 2.1854299926757812e+02 -1.8474299621582031e+02 2.1755099487304688e+02 2.3656700134277344e+02 -1.6101899719238281e+02 2.1755099487304688e+02 2.2560900878906250e+02 -1.7392100524902344e+02 2.1764199829101562e+02 2.3911100769042969e+02 -1.5483500671386719e+02 2.1764199829101562e+02 2.4830499267578125e+02 -1.4225199890136719e+02 2.1755099487304688e+02 2.1058799743652344e+02 -1.9183599853515625e+02 2.1764199829101562e+02 2.0348699951171875e+02 -2.0120700073242188e+02 2.1755099487304688e+02 1.9414801025390625e+02 -2.0845800781250000e+02 2.1764199829101562e+02 1.7640100097656250e+02 -2.2367599487304688e+02 2.1764199829101562e+02 1.5746499633789062e+02 -2.3738800048828125e+02 2.1764199829101562e+02 1.1355400085449219e+02 2.5672799682617188e+02 2.1768400573730469e+02 1.3018899536132812e+02 2.5153898620605469e+02 2.1768200683593750e+02 1.4435101318359375e+02 2.4680499267578125e+02 2.1754100036621094e+02 1.2984100341796875e+02 2.5325599670410156e+02 2.1755099487304688e+02 1.4456300354003906e+02 -2.4492500305175781e+02 2.1766099548339844e+02 1.2790299987792969e+02 -2.5257901000976562e+02 2.1765899658203125e+02 1.3545700073242188e+02 -2.5023498535156250e+02 2.1759700012207031e+02 1.1642099761962891e+02 -2.5767800903320312e+02 2.1754699707031250e+02 1.1070700073242188e+02 -2.5737597656250000e+02 2.1767700195312500e+02 2.8183300781250000e+02 5.0259502410888672e+01 1.7652099609375000e+02 2.8383999633789062e+02 3.6068099975585938e+01 1.7752200317382812e+02 2.8624200439453125e+02 -4.5832400321960449e+00 1.7914999389648438e+02 2.8583300781250000e+02 1.5912199020385742e+01 1.7891499328613281e+02 2.8251901245117188e+02 -4.6200099945068359e+01 1.7701899719238281e+02 2.8516500854492188e+02 -2.5136598587036133e+01 1.7852999877929688e+02 2.8548699951171875e+02 1.5873199462890625e+01 1.7831300354003906e+02 2.8589498901367188e+02 -4.5720300674438477e+00 1.7854798889160156e+02 2.8182199096679688e+02 -4.8684997558593750e+01 1.7619200134277344e+02 2.8227200317382812e+02 4.6846302032470703e+01 1.1750300598144531e+02 2.8181698608398438e+02 -5.0073898315429688e+01 1.1759100341796875e+02 2.8624298095703125e+02 4.5449700355529785e+00 1.1495099639892578e+02 2.8383599853515625e+02 -3.5884601593017578e+01 1.1658100128173828e+02 2.8516500854492188e+02 2.4979301452636719e+01 1.1557099914550781e+02 2.8548602294921875e+02 -1.5790900230407715e+01 1.1578900146484375e+02 2.8589498901367188e+02 4.5337100028991699e+00 1.1555300140380859e+02 2.2122900390625000e+02 -1.8204200744628906e+02 2.1747100830078125e+02 2.6900799560546875e+02 -9.8528900146484375e+01 2.1748100280761719e+02 2.2621199035644531e+02 1.7579100036621094e+02 2.1748001098632812e+02 2.8357397460937500e+02 2.3242399215698242e+01 2.1955999755859375e+02 2.8452600097656250e+02 -8.8922500610351562e-02 2.1955999755859375e+02 2.8355999755859375e+02 -2.3419498443603516e+01 2.1955999755859375e+02 -2.4337600708007812e+02 -1.3845799255371094e+02 3.5675900268554688e+02 -2.3599200439453125e+02 -1.5107400512695312e+02 3.5676000976562500e+02 -2.3545700073242188e+02 -1.5073199462890625e+02 3.5765002441406250e+02 -2.4709999084472656e+02 -1.3209500122070312e+02 3.5675900268554688e+02 -2.4653999328613281e+02 -1.3179600524902344e+02 3.5764898681640625e+02 -2.5396800231933594e+02 -1.1682499694824219e+02 3.5764898681640625e+02 -2.6906399536132812e+02 -7.5818206787109375e+01 3.5764898681640625e+02 -2.6764199829101562e+02 -8.0693199157714844e+01 3.5764898681640625e+02 -2.6822399902343750e+02 -7.5252693176269531e+01 3.5825500488281250e+02 -2.6825000000000000e+02 -8.0876502990722656e+01 3.5675900268554688e+02 -2.6472100830078125e+02 -9.1431701660156250e+01 3.5675900268554688e+02 -2.6234600830078125e+02 -9.6533905029296875e+01 3.5764898681640625e+02 -2.6676898193359375e+02 -8.0430000305175781e+01 3.5825299072265625e+02 -2.6574700927734375e+02 -8.0121894836425781e+01 3.5848901367187500e+02 -2.6149099731445312e+02 -9.6219200134277344e+01 3.5825299072265625e+02 -2.6048898315429688e+02 -9.5850898742675781e+01 3.5848999023437500e+02 -2.6294198608398438e+02 -9.6752998352050781e+01 3.5675900268554688e+02 -2.5848001098632812e+02 -1.0755900573730469e+02 3.5675900268554688e+02 -2.5454499816894531e+02 -1.1709000396728516e+02 3.5675900268554688e+02 -2.5313999938964844e+02 -1.1644400024414062e+02 3.5825198364257812e+02 -2.4573500061035156e+02 -1.3136599731445312e+02 3.5825198364257812e+02 -2.3378999328613281e+02 -1.4966699218750000e+02 3.5848999023437500e+02 -2.4479399108886719e+02 -1.3086299133300781e+02 3.5848901367187500e+02 -2.5216999816894531e+02 -1.1599800109863281e+02 3.5848901367187500e+02 -2.3468899536132812e+02 -1.5024200439453125e+02 3.5825299072265625e+02 -2.5244099426269531e+02 1.1540499877929688e+02 3.5848901367187500e+02 -2.4479399108886719e+02 1.3086399841308594e+02 3.5848901367187500e+02 -2.4573500061035156e+02 1.3136700439453125e+02 3.5825299072265625e+02 -2.6071301269531250e+02 9.5240104675292969e+01 3.5848901367187500e+02 -2.5341200256347656e+02 1.1584799957275391e+02 3.5825198364257812e+02 -2.6716299438476562e+02 7.5252693176269531e+01 3.5848901367187500e+02 -2.6714501953125000e+02 7.9172401428222656e+01 3.5825299072265625e+02 -2.6257101440429688e+02 9.5918800354003906e+01 3.5764898681640625e+02 -2.6914199829101562e+02 7.6003204345703125e+01 3.5764898681640625e+02 -2.6171499633789062e+02 9.5606201171875000e+01 3.5825299072265625e+02 -2.6862799072265625e+02 7.9611900329589844e+01 3.5675900268554688e+02 -2.6498602294921875e+02 9.0635398864746094e+01 3.5675900268554688e+02 -2.6316799926757812e+02 9.6136596679687500e+01 3.5675900268554688e+02 -2.5874700927734375e+02 1.0691499328613281e+02 3.5675900268554688e+02 -2.5481900024414062e+02 1.1649099731445312e+02 3.5675900268554688e+02 -2.5424200439453125e+02 1.1622699737548828e+02 3.5764898681640625e+02 -2.4653900146484375e+02 1.3179600524902344e+02 3.5764898681640625e+02 -2.4707800292968750e+02 1.3215400695800781e+02 3.5674398803710938e+02 -2.3378799438476562e+02 1.4966900634765625e+02 3.5848999023437500e+02 -2.3468699645996094e+02 1.5024400329589844e+02 3.5825299072265625e+02 -2.3545500183105469e+02 1.5073400878906250e+02 3.5765002441406250e+02 -2.3598899841308594e+02 1.5107600402832031e+02 3.5676000976562500e+02 -2.6977700805664062e+02 -7.5252693176269531e+01 3.5675900268554688e+02 -2.7408901977539062e+02 -7.6591796875000000e+01 3.4729702758789062e+02 -2.3706500244140625e+02 -1.5257499694824219e+02 3.5308901977539062e+02 -2.4724499511718750e+02 -1.4065499877929688e+02 3.4729299926757812e+02 -2.3833499145507812e+02 -1.5555099487304688e+02 3.4744302368164062e+02 -2.3851899719238281e+02 -1.5461199951171875e+02 3.4810598754882812e+02 -2.5003799438476562e+02 -1.3595199584960938e+02 3.4729299926757812e+02 -2.6071398925781250e+02 -1.1411900329589844e+02 3.4729498291015625e+02 -2.6260998535156250e+02 -1.0927899932861328e+02 3.4729598999023438e+02 -2.6871200561523438e+02 -9.3642700195312500e+01 3.4735400390625000e+02 -2.3851600646972656e+02 1.5461500549316406e+02 3.4810501098632812e+02 -2.3875300598144531e+02 1.5494799804687500e+02 3.4729098510742188e+02 -2.4748800659179688e+02 1.4024299621582031e+02 3.4729299926757812e+02 -2.3636900329589844e+02 1.5160700988769531e+02 3.5546099853515625e+02 -2.5004199218750000e+02 1.3594299316406250e+02 3.4729400634765625e+02 -2.5980697631835938e+02 1.1616600036621094e+02 3.4729998779296875e+02 -2.6977700805664062e+02 7.5252693176269531e+01 3.5675900268554688e+02 -2.7408901977539062e+02 7.6591697692871094e+01 3.4729702758789062e+02 -2.6354000854492188e+02 1.0742299652099609e+02 3.4729598999023438e+02 -2.6911999511718750e+02 9.2044700622558594e+01 3.4729598999023438e+02 -2.7107699584960938e+02 8.6650100708007812e+01 3.4729702758789062e+02 -2.3100399780273438e+02 1.6839300537109375e+02 2.1970799255371094e+02 -2.4237400817871094e+02 1.5157099914550781e+02 2.1970799255371094e+02 -2.4185000610351562e+02 1.5483599853515625e+02 2.1979899597167969e+02 -1.5874299621582031e+02 2.3931401062011719e+02 2.1979899597167969e+02 -1.5801799011230469e+02 2.3822100830078125e+02 2.1970799255371094e+02 -1.7452900695800781e+02 2.2640399169921875e+02 2.1970799255371094e+02 -1.9015899658203125e+02 2.1344400024414062e+02 2.1970799255371094e+02 -2.0483000183105469e+02 1.9940798950195312e+02 2.1970799255371094e+02 -2.1846800231933594e+02 1.8436500549316406e+02 2.1970799255371094e+02 -2.2686099243164062e+02 1.7651799011230469e+02 2.1980999755859375e+02 -2.6139501953125000e+02 1.1572200012207031e+02 2.1970799255371094e+02 -2.6282699584960938e+02 1.1570500183105469e+02 2.1979899597167969e+02 -2.5252101135253906e+02 1.3398500061035156e+02 2.1970799255371094e+02 -2.5312098693847656e+02 1.3562899780273438e+02 2.1979899597167969e+02 -2.7522000122070312e+02 7.6553703308105469e+01 2.1968400573730469e+02 -2.7096701049804688e+02 9.5088798522949219e+01 2.1979899597167969e+02 -2.6894998168945312e+02 9.6875801086425781e+01 2.1970799255371094e+02 -2.6850399780273438e+02 9.6748504638671875e+01 2.1799899291992188e+02 -2.7498400878906250e+02 7.6502899169921875e+01 2.1883499145507812e+02 -2.6852499389648438e+02 9.6689598083496094e+01 2.1935099792480469e+02 -2.6095898437500000e+02 1.1556400299072266e+02 2.1799899291992188e+02 -2.6098498535156250e+02 1.1550600433349609e+02 2.1935099792480469e+02 -2.5209799194335938e+02 1.3379600524902344e+02 2.1799899291992188e+02 -2.5212699890136719e+02 1.3373999023437500e+02 2.1935099792480469e+02 -2.4196499633789062e+02 1.5135200500488281e+02 2.1799899291992188e+02 -2.4199800109863281e+02 1.5129899597167969e+02 2.1935099792480469e+02 -2.3061199951171875e+02 1.6814599609375000e+02 2.1799899291992188e+02 -2.3064799499511719e+02 1.6809498596191406e+02 2.1935099792480469e+02 -2.1809400939941406e+02 1.8409100341796875e+02 2.1799899291992188e+02 -2.1813499450683594e+02 1.8404299926757812e+02 2.1935099792480469e+02 -2.0447698974609375e+02 1.9910800170898438e+02 2.1799899291992188e+02 -2.0452099609375000e+02 1.9906300354003906e+02 2.1935099792480469e+02 -1.8982798767089844e+02 2.1311999511718750e+02 2.1799899291992188e+02 -1.8987500000000000e+02 2.1307800292968750e+02 2.1935099792480469e+02 -1.7422200012207031e+02 2.2605699157714844e+02 2.1799899291992188e+02 -1.7427099609375000e+02 2.2601799011230469e+02 2.1935099792480469e+02 -1.5774198913574219e+02 2.3784899902343750e+02 2.1799699401855469e+02 -1.5778199768066406e+02 2.3782299804687500e+02 2.1934799194335938e+02 -2.3100399780273438e+02 -1.6839300537109375e+02 2.1970799255371094e+02 -2.1846800231933594e+02 -1.8436500549316406e+02 2.1970799255371094e+02 -2.2141400146484375e+02 -1.8287399291992188e+02 2.1979899597167969e+02 -2.7519900512695312e+02 -7.6527900695800781e+01 2.1968400573730469e+02 -2.6948101806640625e+02 -9.9221702575683594e+01 2.1979899597167969e+02 -2.6894998168945312e+02 -9.6875801086425781e+01 2.1970799255371094e+02 -2.6099200439453125e+02 -1.1978600311279297e+02 2.1979899597167969e+02 -2.6139501953125000e+02 -1.1572200012207031e+02 2.1970799255371094e+02 -2.5252101135253906e+02 -1.3398500061035156e+02 2.1970799255371094e+02 -2.5097399902343750e+02 -1.3956199645996094e+02 2.1979899597167969e+02 -2.4237400817871094e+02 -1.5157099914550781e+02 2.1970799255371094e+02 -2.3825299072265625e+02 -1.6069400024414062e+02 2.1979899597167969e+02 -1.9015899658203125e+02 -2.1344400024414062e+02 2.1970799255371094e+02 -2.0483000183105469e+02 -1.9940798950195312e+02 2.1970799255371094e+02 -1.5801799011230469e+02 -2.3822100830078125e+02 2.1970799255371094e+02 -1.7452900695800781e+02 -2.2640399169921875e+02 2.1970799255371094e+02 -2.6850399780273438e+02 -9.6748504638671875e+01 2.1935099792480469e+02 -2.7498498535156250e+02 -7.6501899719238281e+01 2.1850900268554688e+02 -2.6852499389648438e+02 -9.6689598083496094e+01 2.1799899291992188e+02 -2.6095898437500000e+02 -1.1556400299072266e+02 2.1935099792480469e+02 -2.6098498535156250e+02 -1.1550600433349609e+02 2.1799899291992188e+02 -2.5209799194335938e+02 -1.3379600524902344e+02 2.1935099792480469e+02 -2.5212699890136719e+02 -1.3373999023437500e+02 2.1799899291992188e+02 -2.4196499633789062e+02 -1.5135200500488281e+02 2.1935099792480469e+02 -2.4199800109863281e+02 -1.5129899597167969e+02 2.1799899291992188e+02 -2.3061199951171875e+02 -1.6814599609375000e+02 2.1935099792480469e+02 -2.3064799499511719e+02 -1.6809498596191406e+02 2.1799899291992188e+02 -2.1809400939941406e+02 -1.8409100341796875e+02 2.1935099792480469e+02 -2.1813499450683594e+02 -1.8404299926757812e+02 2.1799899291992188e+02 -2.0447698974609375e+02 -1.9910800170898438e+02 2.1935099792480469e+02 -2.0452099609375000e+02 -1.9906300354003906e+02 2.1799899291992188e+02 -1.8982798767089844e+02 -2.1311999511718750e+02 2.1935099792480469e+02 -1.8987500000000000e+02 -2.1307800292968750e+02 2.1799899291992188e+02 -1.7422200012207031e+02 -2.2605699157714844e+02 2.1935099792480469e+02 -1.7427099609375000e+02 -2.2601799011230469e+02 2.1799899291992188e+02 -1.5774198913574219e+02 -2.3784899902343750e+02 2.1935301208496094e+02 -1.5778199768066406e+02 -2.3782299804687500e+02 2.1800099182128906e+02 -2.3100399780273438e+02 1.6839300537109375e+02 2.1764199829101562e+02 -2.1846800231933594e+02 1.8436500549316406e+02 2.1764199829101562e+02 -2.3736399841308594e+02 1.6211999511718750e+02 2.1753900146484375e+02 -2.7709698486328125e+02 7.6249198913574219e+01 2.1753799438476562e+02 -2.7520098876953125e+02 7.6521705627441406e+01 2.1766600036621094e+02 -2.6948101806640625e+02 9.9220001220703125e+01 2.1755099487304688e+02 -2.6894998168945312e+02 9.6875801086425781e+01 2.1764199829101562e+02 -2.6099200439453125e+02 1.1978100585937500e+02 2.1755099487304688e+02 -2.6139501953125000e+02 1.1572200012207031e+02 2.1764199829101562e+02 -2.5252101135253906e+02 1.3398500061035156e+02 2.1764199829101562e+02 -2.5097200012207031e+02 1.3955999755859375e+02 2.1755099487304688e+02 -2.4237400817871094e+02 1.5157099914550781e+02 2.1764199829101562e+02 -1.9015899658203125e+02 2.1344400024414062e+02 2.1764199829101562e+02 -1.9056799316406250e+02 2.1482099914550781e+02 2.1755099487304688e+02 -2.0483000183105469e+02 1.9940798950195312e+02 2.1764199829101562e+02 -2.0656900024414062e+02 1.9948199462890625e+02 2.1755099487304688e+02 -1.5801799011230469e+02 2.3822100830078125e+02 2.1764199829101562e+02 -1.5873699951171875e+02 2.3930400085449219e+02 2.1755099487304688e+02 -1.7452900695800781e+02 2.2640399169921875e+02 2.1764199829101562e+02 -1.7343499755859375e+02 2.2887500000000000e+02 2.1755099487304688e+02 -2.3100399780273438e+02 -1.6839300537109375e+02 2.1764199829101562e+02 -2.4237400817871094e+02 -1.5157099914550781e+02 2.1764199829101562e+02 -2.2590998840332031e+02 -1.7761199951171875e+02 2.1755200195312500e+02 -1.5801799011230469e+02 -2.3822100830078125e+02 2.1764199829101562e+02 -1.7692199707031250e+02 -2.2619099426269531e+02 2.1755099487304688e+02 -1.7452900695800781e+02 -2.2640399169921875e+02 2.1764199829101562e+02 -1.9389900207519531e+02 -2.1181799316406250e+02 2.1755099487304688e+02 -1.9015899658203125e+02 -2.1344400024414062e+02 2.1764199829101562e+02 -2.0483000183105469e+02 -1.9940798950195312e+02 2.1764199829101562e+02 -2.0966499328613281e+02 -1.9622500610351562e+02 2.1755099487304688e+02 -2.1846800231933594e+02 -1.8436500549316406e+02 2.1764199829101562e+02 -2.6139501953125000e+02 -1.1572200012207031e+02 2.1764199829101562e+02 -2.6283200073242188e+02 -1.1568800354003906e+02 2.1755099487304688e+02 -2.5252101135253906e+02 -1.3398500061035156e+02 2.1764199829101562e+02 -2.5312599182128906e+02 -1.3561500549316406e+02 2.1755099487304688e+02 -2.7522201538085938e+02 -7.6546997070312500e+01 2.1766600036621094e+02 -2.7712197875976562e+02 -7.6163200378417969e+01 2.1753900146484375e+02 -2.6894998168945312e+02 -9.6875801086425781e+01 2.1764199829101562e+02 -2.7097000122070312e+02 -9.5076797485351562e+01 2.1755099487304688e+02 -2.2404800415039062e+02 -1.6032400512695312e+02 3.5856301879882812e+02 -2.1797401428222656e+02 -1.5178201293945312e+02 3.5891198730468750e+02 -2.2494200134277344e+02 -1.4401400756835938e+02 3.5885900878906250e+02 -2.3561100769042969e+02 -1.2576800537109375e+02 3.5885501098632812e+02 -2.5666299438476562e+02 -7.2379501342773438e+01 3.5885598754882812e+02 -2.5259101867675781e+02 -8.6720802307128906e+01 3.5885800170898438e+02 -2.4923800659179688e+02 -9.5347503662109375e+01 3.5885699462890625e+02 -2.4481100463867188e+02 -1.0673899841308594e+02 3.5885598754882812e+02 -2.4171499633789062e+02 -1.1314299774169922e+02 3.5885598754882812e+02 -2.1748199462890625e+02 1.5217300415039062e+02 3.5890899658203125e+02 -2.2289199829101562e+02 1.6224899291992188e+02 3.5851098632812500e+02 -2.2156399536132812e+02 1.4840699768066406e+02 3.5887399291992188e+02 -2.4116699218750000e+02 1.1472599792480469e+02 3.5885501098632812e+02 -2.3125999450683594e+02 1.3361300659179688e+02 3.5885998535156250e+02 -2.2494000244140625e+02 1.4401599121093750e+02 3.5885998535156250e+02 -2.5625799560546875e+02 7.5194702148437500e+01 3.5885598754882812e+02 -2.4952600097656250e+02 9.5185699462890625e+01 3.5885598754882812e+02 -2.7630001831054688e+02 -7.6525596618652344e+01 3.4115899658203125e+02 -2.4044898986816406e+02 -1.5621800231933594e+02 3.4110998535156250e+02 -2.7617898559570312e+02 7.6903900146484375e+01 3.4112100219726562e+02 -2.4051600646972656e+02 1.5608599853515625e+02 3.4112301635742188e+02 -1.5723899841308594e+02 -2.3704600524902344e+02 6.4391395568847656e+01 -1.6075000000000000e+02 -2.3467601013183594e+02 6.4391502380371094e+01 -1.7852999877929688e+02 -2.2143499755859375e+02 6.4391502380371094e+01 -1.8407200622558594e+02 -2.1684700012207031e+02 6.4392295837402344e+01 -1.8492900085449219e+02 -2.1605900573730469e+02 6.4392295837402344e+01 -2.0987098693847656e+02 -1.9168800354003906e+02 6.4392295837402344e+01 -2.2130499267578125e+02 -1.7835600280761719e+02 6.4392204284667969e+01 -2.3201799011230469e+02 -1.6429998779296875e+02 6.4391700744628906e+01 -2.4180799865722656e+02 -1.4982398986816406e+02 6.4391204833984375e+01 -2.4533900451660156e+02 -1.4397999572753906e+02 6.4390396118164062e+01 -2.5047099304199219e+02 -1.3442300415039062e+02 6.4389900207519531e+01 -2.5580599975585938e+02 -1.2448600006103516e+02 6.4389305114746094e+01 -2.6471600341796875e+02 -1.0426999664306641e+02 6.4388702392578125e+01 -2.6522500610351562e+02 -1.0281800079345703e+02 6.4388603210449219e+01 -2.7204998779296875e+02 -8.3364097595214844e+01 6.4387298583984375e+01 -2.7581500244140625e+02 -6.9160499572753906e+01 6.4386199951171875e+01 -2.7776901245117188e+02 -6.1791198730468750e+01 6.4385696411132812e+01 -2.7929400634765625e+02 -5.4520099639892578e+01 6.4385894775390625e+01 -2.8234899902343750e+02 -3.4940998077392578e+01 6.4385101318359375e+01 -2.8438897705078125e+02 -1.0754000663757324e+01 6.4384696960449219e+01 -2.8436599731445312e+02 1.1338600158691406e+01 6.4384696960449219e+01 -2.8259899902343750e+02 3.3539699554443359e+01 6.4385200500488281e+01 -2.8158102416992188e+02 4.1185798645019531e+01 6.4384902954101562e+01 -2.7752398681640625e+02 6.2875396728515625e+01 6.4385894775390625e+01 -2.7590100097656250e+02 6.8912994384765625e+01 6.4386299133300781e+01 -2.7180200195312500e+02 8.4164596557617188e+01 6.4387496948242188e+01 -2.7124700927734375e+02 8.5732604980468750e+01 6.4387596130371094e+01 -2.6441897583007812e+02 1.0502000427246094e+02 6.4388793945312500e+01 -2.5839199829101562e+02 1.1857499694824219e+02 6.4389099121093750e+01 -2.5535801696777344e+02 1.2540000915527344e+02 6.4389305114746094e+01 -2.5194499206542969e+02 1.3210700988769531e+02 6.4390197753906250e+01 -2.5064099121093750e+02 1.3437100219726562e+02 6.4390304565429688e+01 -2.4089999389648438e+02 1.5127700805664062e+02 6.4391098022460938e+01 -2.2841699218750000e+02 1.6951400756835938e+02 6.4391998291015625e+01 -2.2160800170898438e+02 1.7797200012207031e+02 6.4392204284667969e+01 -2.1451100158691406e+02 1.8678698730468750e+02 6.4392402648925781e+01 -2.1015199279785156e+02 1.9141200256347656e+02 6.4392402648925781e+01 -1.8504199218750000e+02 2.1575300598144531e+02 6.4391799926757812e+01 -1.3352900695800781e+02 -2.4172000122070312e+02 2.5978198242187500e+02 -1.9859899902343750e+02 -1.7467401123046875e+02 3.4716601562500000e+02 -1.3836100769042969e+02 -2.3932600402832031e+02 2.6106301879882812e+02 -2.0653199768066406e+02 -1.7720899963378906e+02 3.3623901367187500e+02 -1.9699501037597656e+02 -1.8921099853515625e+02 3.1904598999023438e+02 -1.9052400207519531e+02 -1.9641200256347656e+02 3.0928201293945312e+02 -1.8743299865722656e+02 -1.9985101318359375e+02 3.0461901855468750e+02 -1.0875000000000000e+02 -2.4882299804687500e+02 2.6364401245117188e+02 -9.7158096313476562e+01 -2.4980000305175781e+02 2.7017700195312500e+02 -7.1975601196289062e+01 -2.5088700866699219e+02 2.8645599365234375e+02 -6.1943099975585938e+01 -2.5115400695800781e+02 2.9327700805664062e+02 -2.0454800415039062e+02 -1.7372299194335938e+02 3.4471899414062500e+02 -2.0646899414062500e+02 -1.7433700561523438e+02 3.4207202148437500e+02 -2.0717201232910156e+02 -1.7557301330566406e+02 3.3906497192382812e+02 -1.7759500122070312e+02 -2.0961999511718750e+02 2.9214901733398438e+02 -1.6696099853515625e+02 -2.1903700256347656e+02 2.8097097778320312e+02 -1.2610800933837891e+02 -2.4470899963378906e+02 2.5920297241210938e+02 -1.2034200286865234e+02 -2.4650199890136719e+02 2.5981701660156250e+02 -1.5808999633789062e+02 -2.2610400390625000e+02 2.7323699951171875e+02 -1.4702999877929688e+02 -2.3402600097656250e+02 2.6538500976562500e+02 -1.4509500122070312e+02 -2.3531700134277344e+02 2.6420098876953125e+02 -1.1247000122070312e+02 -2.4826200866699219e+02 2.6204602050781250e+02 -5.5263599395751953e+01 -2.5124299621582031e+02 2.9799700927734375e+02 -2.1463500976562500e+01 -2.5169200134277344e+02 3.2188400268554688e+02 -6.7967200279235840e+00 -2.4448400878906250e+02 3.4716601562500000e+02 -3.9190599918365479e+00 -2.5169500732421875e+02 3.3474499511718750e+02 -2.0175599670410156e+02 -1.7384300231933594e+02 3.4652502441406250e+02 -1.2270200252532959e+00 -2.4803599548339844e+02 3.4409399414062500e+02 -3.5036199092864990e+00 -2.4608700561523438e+02 3.4635098266601562e+02 -4.8996099829673767e-01 -2.4988299560546875e+02 3.4091201782226562e+02 -1.4616800546646118e+00 -2.5120401000976562e+02 3.3753698730468750e+02 -1.3989099121093750e+02 2.3848699951171875e+02 2.6163101196289062e+02 -1.0120400238037109e+02 2.4952600097656250e+02 2.6776199340820312e+02 -1.0775000000000000e+02 2.4894200134277344e+02 2.6413800048828125e+02 -1.7867399597167969e+02 2.0860198974609375e+02 2.9341000366210938e+02 -1.8742799377441406e+02 1.9985699462890625e+02 3.0461099243164062e+02 -6.7967200279235840e+00 2.4448400878906250e+02 3.4716601562500000e+02 -3.9190599918365479e+00 2.5169500732421875e+02 3.3474499511718750e+02 -3.6743297576904297e+01 2.5157600402832031e+02 3.1090997314453125e+02 -1.1608800506591797e+02 2.4754899597167969e+02 2.6082901000976562e+02 -1.2080900573730469e+02 2.4637300109863281e+02 2.5973498535156250e+02 -1.2840400695800781e+02 2.4386900329589844e+02 2.5921099853515625e+02 -1.3287199401855469e+02 2.4201800537109375e+02 2.5966400146484375e+02 -1.4447900390625000e+02 2.3572000122070312e+02 2.6384298706054688e+02 -1.5187998962402344e+02 2.3066699218750000e+02 2.6859600830078125e+02 -1.5743699645996094e+02 2.2659799194335938e+02 2.7272000122070312e+02 -4.8996099829673767e-01 2.4988299560546875e+02 3.4091201782226562e+02 -1.4616800546646118e+00 2.5120401000976562e+02 3.3753698730468750e+02 -1.2270200252532959e+00 2.4803599548339844e+02 3.4409399414062500e+02 -3.5036199092864990e+00 2.4608700561523438e+02 3.4635098266601562e+02 -4.4851200103759766e+01 2.5147399902343750e+02 3.0516897583007812e+02 -8.0350700378417969e+01 2.5060600280761719e+02 2.8088000488281250e+02 -1.6844000244140625e+02 2.1779200744628906e+02 2.8239501953125000e+02 -2.0653199768066406e+02 1.7720899963378906e+02 3.3623901367187500e+02 -2.0717201232910156e+02 1.7557301330566406e+02 3.3906497192382812e+02 -2.0646899414062500e+02 1.7433700561523438e+02 3.4207202148437500e+02 -1.9745300292968750e+02 1.8867098999023438e+02 3.1980099487304688e+02 -1.9859899902343750e+02 1.7467401123046875e+02 3.4716601562500000e+02 -2.0175599670410156e+02 1.7384300231933594e+02 3.4652502441406250e+02 -2.0454800415039062e+02 1.7372299194335938e+02 3.4471899414062500e+02 -2.0009599304199219e+02 -1.7878800964355469e+02 3.4724301147460938e+02 -8.2940406799316406e+00 -2.4859799194335938e+02 3.4724301147460938e+02 -2.0669400024414062e+02 -1.8004399108886719e+02 3.3987298583984375e+02 -2.0617599487304688e+02 -1.7852799987792969e+02 3.4330801391601562e+02 -2.0469099426269531e+02 -1.7805300903320312e+02 3.4535198974609375e+02 -2.0253500366210938e+02 -1.7814500427246094e+02 3.4674798583984375e+02 -1.2772199249267578e+02 -2.4718501281738281e+02 2.6249502563476562e+02 -1.1991199493408203e+02 -2.4955599975585938e+02 2.6344400024414062e+02 -2.0349598693847656e+02 -1.8434399414062500e+02 3.3355297851562500e+02 -1.9365798950195312e+02 -1.9624800109863281e+02 3.1677899169921875e+02 -1.8285299682617188e+02 -2.0774699401855469e+02 3.0153201293945312e+02 -1.7242399597167969e+02 -2.1756201171875000e+02 2.8940200805664062e+02 -1.6153498840332031e+02 -2.2666899108886719e+02 2.7903698730468750e+02 -1.5849200439453125e+02 -2.2891600036621094e+02 2.7673901367187500e+02 -1.4947399902343750e+02 -2.3557800292968750e+02 2.6992898559570312e+02 -1.4399899291992188e+02 -2.3912399291992188e+02 2.6679901123046875e+02 -1.4124499511718750e+02 -2.4090798950195312e+02 2.6522500610351562e+02 -1.3415400695800781e+02 -2.4456900024414062e+02 2.6304699707031250e+02 -1.1201100158691406e+02 -2.5112199401855469e+02 2.6608300781250000e+02 -1.0272499847412109e+02 -2.5203799438476562e+02 2.7104800415039062e+02 -8.3857795715332031e+01 -2.5302600097656250e+02 2.8289602661132812e+02 -5.7364700317382812e+01 -2.5370500183105469e+02 3.0095898437500000e+02 -4.9270000457763672e+01 -2.5391297912597656e+02 3.0647799682617188e+02 -6.0710902214050293e+00 -2.5416899108886719e+02 3.3764700317382812e+02 -5.7501201629638672e+00 -2.4983599853515625e+02 3.4661297607421875e+02 -3.9914798736572266e+00 -2.5134199523925781e+02 3.4486898803710938e+02 -3.4220800399780273e+00 -2.5276899719238281e+02 3.4241101074218750e+02 -4.1727399826049805e+00 -2.5378900146484375e+02 3.3980398559570312e+02 -2.0009599304199219e+02 1.7878800964355469e+02 3.4724301147460938e+02 -2.0253500366210938e+02 1.7814500427246094e+02 3.4674798583984375e+02 -2.0469099426269531e+02 1.7805300903320312e+02 3.4535198974609375e+02 -2.0617599487304688e+02 1.7852799987792969e+02 3.4330801391601562e+02 -2.0671899414062500e+02 1.7948300170898438e+02 3.4098397827148438e+02 -2.0622499084472656e+02 1.8074600219726562e+02 3.3880099487304688e+02 -8.2940406799316406e+00 2.4859799194335938e+02 3.4724301147460938e+02 -6.0710902214050293e+00 2.5416899108886719e+02 3.3764700317382812e+02 -4.1727399826049805e+00 2.5378900146484375e+02 3.3980398559570312e+02 -3.4220800399780273e+00 2.5276899719238281e+02 3.4241101074218750e+02 -3.9914798736572266e+00 2.5134199523925781e+02 3.4486898803710938e+02 -5.7501201629638672e+00 2.4983599853515625e+02 3.4661297607421875e+02 -1.1416699981689453e+02 2.5076600646972656e+02 2.6522000122070312e+02 -1.2825100708007812e+02 2.4697000122070312e+02 2.6254000854492188e+02 -1.0251300811767578e+01 2.5412500000000000e+02 3.3467001342773438e+02 -6.8916198730468750e+01 2.5350601196289062e+02 2.9288800048828125e+02 -1.0086599731445312e+02 2.5216699218750000e+02 2.7215200805664062e+02 -8.5904098510742188e+01 2.5294400024414062e+02 2.8155999755859375e+02 -1.3666500854492188e+02 2.4306900024414062e+02 2.6422799682617188e+02 -1.4104199218750000e+02 2.4102899169921875e+02 2.6513000488281250e+02 -1.5723100280761719e+02 2.2979600524902344e+02 2.7589199829101562e+02 -1.5472399902343750e+02 2.3184199523925781e+02 2.7360699462890625e+02 -1.7450300598144531e+02 2.1569200134277344e+02 2.9164498901367188e+02 -1.9103500366210938e+02 1.9917599487304688e+02 3.1280300903320312e+02 -2.2967300415039062e+02 -1.5729499816894531e+02 3.5811199951171875e+02 -2.2546499633789062e+02 -1.6210099792480469e+02 3.5751300048828125e+02 -2.3057901000976562e+02 -1.5793399047851562e+02 3.5683102416992188e+02 -2.2529899597167969e+02 1.6190600585937500e+02 3.5771600341796875e+02 -2.3057598876953125e+02 1.5793499755859375e+02 3.5683102416992188e+02 -2.2984799194335938e+02 1.5728199768066406e+02 3.5803601074218750e+02 -2.2082998657226562e+02 1.6493000793457031e+02 3.5770199584960938e+02 -2.2116600036621094e+02 1.6547299194335938e+02 3.5683398437500000e+02 -2.1330400085449219e+02 1.6925799560546875e+02 3.5675900268554688e+02 -2.1308700561523438e+02 1.6866099548339844e+02 3.5764898681640625e+02 -2.1277500915527344e+02 1.6780500793457031e+02 3.5825198364257812e+02 -2.1241000366210938e+02 1.6680101013183594e+02 3.5848901367187500e+02 1.8214599609375000e+01 2.5352400207519531e+02 3.5675900268554688e+02 1.8431798934936523e+01 2.5292700195312500e+02 3.5764898681640625e+02 1.8743600845336914e+01 2.5207099914550781e+02 3.5825198364257812e+02 1.9108800888061523e+01 2.5106701660156250e+02 3.5848901367187500e+02 -2.1330599975585938e+02 -1.6925700378417969e+02 3.5675900268554688e+02 1.8142599105834961e+01 -2.5349798583984375e+02 3.5675900268554688e+02 1.8359800338745117e+01 -2.5290098571777344e+02 3.5764898681640625e+02 -2.1308801269531250e+02 -1.6866099548339844e+02 3.5764898681640625e+02 1.8671701431274414e+01 -2.5204399108886719e+02 3.5825198364257812e+02 -2.1277700805664062e+02 -1.6780400085449219e+02 3.5825198364257812e+02 1.9036800384521484e+01 -2.5104100036621094e+02 3.5848901367187500e+02 -2.1241200256347656e+02 -1.6680101013183594e+02 3.5848901367187500e+02 -2.2116400146484375e+02 -1.6547399902343750e+02 3.5683398437500000e+02 -2.2082899475097656e+02 -1.6493099975585938e+02 3.5770199584960938e+02 -2.2035800170898438e+02 -1.6416000366210938e+02 3.5828799438476562e+02 -2.2843399047851562e+02 -1.6508999633789062e+02 3.4903601074218750e+02 -2.2883200073242188e+02 -1.6676800537109375e+02 3.4588998413085938e+02 -2.2596000671386719e+02 -1.6950700378417969e+02 3.4446398925781250e+02 -2.3377299499511719e+02 -1.6147799682617188e+02 3.4722799682617188e+02 -2.2695399475097656e+02 -1.6312600708007812e+02 3.5402999877929688e+02 -2.1600100708007812e+02 -1.7259100341796875e+02 3.4806399536132812e+02 -2.1733300781250000e+02 -1.7429100036621094e+02 3.4366101074218750e+02 -2.2432499694824219e+02 -1.7103399658203125e+02 3.4370199584960938e+02 -2.1845700073242188e+02 -1.7570300292968750e+02 3.3999099731445312e+02 -2.3580200195312500e+02 1.5892800903320312e+02 3.4738800048828125e+02 -2.2843099975585938e+02 1.6509098815917969e+02 3.4903601074218750e+02 -2.3300500488281250e+02 1.6231500244140625e+02 3.4701699829101562e+02 -2.2552500915527344e+02 1.6996299743652344e+02 3.4433200073242188e+02 -2.2913600158691406e+02 1.6648899841308594e+02 3.4593298339843750e+02 -2.1597099304199219e+02 1.7258801269531250e+02 3.4809197998046875e+02 -2.2199598693847656e+02 1.7300100708007812e+02 3.4207998657226562e+02 -2.1845201110839844e+02 1.7570201110839844e+02 3.3999697875976562e+02 -2.2624699401855469e+02 1.6219299316406250e+02 3.5640600585937500e+02 -2.1370799255371094e+02 1.6976100158691406e+02 3.5544799804687500e+02 1.8098701477050781e+01 -2.5385000610351562e+02 3.5601699829101562e+02 1.7699201583862305e+01 -2.5704397583007812e+02 3.4928799438476562e+02 1.7410999298095703e+01 -2.5934899902343750e+02 3.4443200683593750e+02 -9.8536605834960938e+00 -2.5969100952148438e+02 3.2374298095703125e+02 -4.4994400024414062e+01 -2.5940100097656250e+02 2.9855297851562500e+02 -7.7385902404785156e+01 -2.5858300781250000e+02 2.7644400024414062e+02 -9.8536499023437500e+01 -2.5745901489257812e+02 2.6319699096679688e+02 -1.0960300445556641e+02 -2.5635800170898438e+02 2.5729699707031250e+02 -1.1991800689697266e+02 -2.5417399597167969e+02 2.5413400268554688e+02 -1.3118800354003906e+02 -2.5063198852539062e+02 2.5300401306152344e+02 -1.4577400207519531e+02 -2.4375799560546875e+02 2.5615899658203125e+02 -1.5205599975585938e+02 -2.3987899780273438e+02 2.5936801147460938e+02 -1.6239399719238281e+02 -2.3263398742675781e+02 2.6638699340820312e+02 -1.7353500366210938e+02 -2.2392498779296875e+02 2.7576397705078125e+02 -1.8425999450683594e+02 -2.1454100036621094e+02 2.8680999755859375e+02 -1.9006399536132812e+02 -2.0899600219726562e+02 2.9372500610351562e+02 -2.0089498901367188e+02 -1.9764199829101562e+02 3.0866302490234375e+02 -2.1099501037597656e+02 -1.8565499877929688e+02 3.2540899658203125e+02 1.8126800537109375e+01 2.5420901489257812e+02 3.5531500244140625e+02 1.7758600234985352e+01 2.5707800292968750e+02 3.4926300048828125e+02 1.7466100692749023e+01 2.5935598754882812e+02 3.4445700073242188e+02 1.0225399971008301e+01 2.5952700805664062e+02 3.3880200195312500e+02 -1.3518400573730469e+02 2.4891999816894531e+02 2.5352299499511719e+02 -1.9944599914550781e+02 1.9922799682617188e+02 3.0652899169921875e+02 -1.2427999877929688e+02 2.5298300170898438e+02 2.5333398437500000e+02 -1.1674100494384766e+02 2.5497999572753906e+02 2.5483998107910156e+02 -1.0847900390625000e+02 2.5650701904296875e+02 2.5782202148437500e+02 -9.7554306030273438e+01 2.5756201171875000e+02 2.6370901489257812e+02 -7.7045402526855469e+01 2.5860000610351562e+02 2.7665899658203125e+02 -2.0943998718261719e+02 1.8758900451660156e+02 3.2265298461914062e+02 -1.9149400711059570e+01 2.5966799926757812e+02 3.1697100830078125e+02 -4.1260799407958984e+01 2.5946600341796875e+02 3.0116098022460938e+02 -1.4652299499511719e+02 2.4331698608398438e+02 2.5649801635742188e+02 -1.5343099975585938e+02 2.3894700622558594e+02 2.6023699951171875e+02 -1.6667700195312500e+02 2.2938999938964844e+02 2.6978201293945312e+02 -1.7725700378417969e+02 2.2077299499511719e+02 2.7938601684570312e+02 -1.8719400024414062e+02 2.1176600646972656e+02 2.9024801635742188e+02 -1.9649400329589844e+02 2.0240899658203125e+02 3.0228298950195312e+02 2.4128900527954102e+01 -2.5527098083496094e+02 3.5680599975585938e+02 2.5222200393676758e+01 -2.5429400634765625e+02 3.5815798950195312e+02 2.5098100662231445e+01 2.5542100524902344e+02 3.5708801269531250e+02 4.3455898284912109e+01 2.5928399658203125e+02 2.6863198852539062e+02 3.9996898651123047e+01 2.5790100097656250e+02 2.7182400512695312e+02 3.8889602661132812e+01 2.5940298461914062e+02 2.7157699584960938e+02 3.5531299591064453e+01 2.5948797607421875e+02 2.7584799194335938e+02 3.3786899566650391e+01 2.5948699951171875e+02 2.8119201660156250e+02 3.4656299591064453e+01 2.5810302734375000e+02 2.8364898681640625e+02 3.3899898529052734e+01 2.5948397827148438e+02 2.8666699218750000e+02 3.5510200500488281e+01 2.5807601928710938e+02 2.8863299560546875e+02 3.5943000793457031e+01 2.5942999267578125e+02 2.9196301269531250e+02 3.7964298248291016e+01 2.5799700927734375e+02 2.9307199096679688e+02 3.9434997558593750e+01 2.5938800048828125e+02 2.9609997558593750e+02 4.1756702423095703e+01 2.5787197875976562e+02 2.9646798706054688e+02 4.4192703247070312e+01 2.5926699829101562e+02 2.9890798950195312e+02 3.3569499969482422e+01 -2.5950598144531250e+02 2.8325799560546875e+02 3.4517501831054688e+01 -2.5808599853515625e+02 2.8210198974609375e+02 3.4343299865722656e+01 -2.5953100585937500e+02 2.8886199951171875e+02 3.7998699188232422e+01 -2.5795098876953125e+02 2.9303399658203125e+02 3.7086700439453125e+01 -2.5948797607421875e+02 2.9382000732421875e+02 4.1298603057861328e+01 -2.5936599731445312e+02 2.9747799682617188e+02 3.4728698730468750e+01 -2.5948599243164062e+02 2.7764099121093750e+02 3.7569797515869141e+01 -2.5943197631835938e+02 2.7294998168945312e+02 4.1619400024414062e+01 -2.5932199096679688e+02 2.6965100097656250e+02 4.4701900482177734e+01 -2.5778897094726562e+02 2.6928201293945312e+02 4.6618202209472656e+01 -2.5920700073242188e+02 2.6764801025390625e+02 -2.0881900024414062e+02 1.5693501281738281e+02 3.5885598754882812e+02 2.2700000762939453e+01 2.4120100402832031e+02 3.5885598754882812e+02 2.2628000259399414e+01 -2.4117399597167969e+02 3.5885598754882812e+02 -2.0882000732421875e+02 -1.5693399047851562e+02 3.5885598754882812e+02 -2.3681199645996094e+02 -1.6140399169921875e+02 3.4079199218750000e+02 -2.3367098999023438e+02 -1.6551600646972656e+02 3.3937100219726562e+02 -2.3090000915527344e+02 -1.6891400146484375e+02 3.3750399780273438e+02 -2.2718200683593750e+02 -1.7314900207519531e+02 3.3411999511718750e+02 -1.0740800476074219e+02 -2.5922201538085938e+02 2.5111898803710938e+02 -1.1537599945068359e+02 -2.5764099121093750e+02 2.4864399719238281e+02 -2.1914599609375000e+02 -1.8355999755859375e+02 3.1946701049804688e+02 -2.0829499816894531e+02 -1.9610800170898438e+02 3.0264300537109375e+02 -1.9668998718261719e+02 -2.0799798583984375e+02 2.8765298461914062e+02 -1.9048100280761719e+02 -2.1380599975585938e+02 2.8071200561523438e+02 -1.7902999877929688e+02 -2.2364201354980469e+02 2.6962500000000000e+02 -1.6715399169921875e+02 -2.3277500915527344e+02 2.6021200561523438e+02 -1.5614900207519531e+02 -2.4038200378417969e+02 2.5316598510742188e+02 -1.4890000915527344e+02 -2.4474099731445312e+02 2.4993499755859375e+02 -1.4056700134277344e+02 -2.4902099609375000e+02 2.4759899902343750e+02 -1.3213500976562500e+02 -2.5253001403808594e+02 2.4677999877929688e+02 -1.2381199645996094e+02 -2.5540701293945312e+02 2.4706999206542969e+02 -1.0033900451660156e+02 -2.6016000366210938e+02 2.5419900512695312e+02 -9.0097801208496094e+01 -2.6097598266601562e+02 2.5992501831054688e+02 -7.3482398986816406e+01 -2.6180300903320312e+02 2.7033697509765625e+02 -4.0771099090576172e+01 -2.6267700195312500e+02 2.9245800781250000e+02 -5.4024996757507324e+00 -2.6300497436523438e+02 3.1765301513671875e+02 2.2045598983764648e+01 -2.6260699462890625e+02 3.3870501708984375e+02 2.2110898971557617e+01 2.6262500000000000e+02 3.3869299316406250e+02 1.4818499565124512e+01 2.6281198120117188e+02 3.3293597412109375e+02 -1.4749799728393555e+01 2.6297399902343750e+02 3.1087899780273438e+02 -3.7008201599121094e+01 2.6274697875976562e+02 2.9506399536132812e+02 -7.3141098022460938e+01 2.6182101440429688e+02 2.7055099487304688e+02 -9.4145401000976562e+01 2.6069000244140625e+02 2.5758001708984375e+02 -1.0613200378417969e+02 2.5940499877929688e+02 2.5165701293945312e+02 -1.1553599548339844e+02 2.5761398315429688e+02 2.4859300231933594e+02 -1.2422799682617188e+02 2.5522801208496094e+02 2.4713101196289062e+02 -1.3262901306152344e+02 2.5235301208496094e+02 2.4678399658203125e+02 -1.4080299377441406e+02 2.4885200500488281e+02 2.4776400756835938e+02 -1.5761099243164062e+02 2.3940299987792969e+02 2.5404301452636719e+02 -1.4898300170898438e+02 2.4472599792480469e+02 2.4991198730468750e+02 -1.6542500305175781e+02 2.3400900268554688e+02 2.5903298950195312e+02 -1.7171600341796875e+02 2.2937199401855469e+02 2.6362500000000000e+02 -1.8299899291992188e+02 2.2033900451660156e+02 2.7326397705078125e+02 -1.9361700439453125e+02 2.1090100097656250e+02 2.8416500854492188e+02 -2.0357499694824219e+02 2.0110000610351562e+02 2.9624301147460938e+02 -2.0673899841308594e+02 1.9777000427246094e+02 3.0050299072265625e+02 -2.1747200012207031e+02 1.8558700561523438e+02 3.1669299316406250e+02 -2.2717599487304688e+02 1.7314900207519531e+02 3.3412298583984375e+02 -2.2817300415039062e+02 1.7205000305175781e+02 3.3512301635742188e+02 -2.3166799926757812e+02 1.6799000549316406e+02 3.3808300781250000e+02 -2.3395399475097656e+02 1.6515299987792969e+02 3.3952999877929688e+02 -2.3701199340820312e+02 1.6115600585937500e+02 3.4077700805664062e+02 2.9226501464843750e+01 -2.6065298461914062e+02 3.4710299682617188e+02 2.5563199996948242e+01 -2.6040802001953125e+02 3.4665301513671875e+02 2.0634298324584961e+01 -2.5985501098632812e+02 3.4551599121093750e+02 2.2932800292968750e+01 2.6015100097656250e+02 3.4612701416015625e+02 2.7300600051879883e+01 2.6055200195312500e+02 3.4691500854492188e+02 4.6388900756835938e+01 -2.5923098754882812e+02 2.9955200195312500e+02 4.1870502471923828e+01 -2.5780697631835938e+02 2.9643301391601562e+02 -1.1656200408935547e+02 2.5604598999023438e+02 2.1966299438476562e+02 -1.3108601379394531e+02 2.5197398376464844e+02 2.1970799255371094e+02 -1.4494299316406250e+02 2.4586300659179688e+02 2.1970799255371094e+02 -1.1650100708007812e+02 2.5603100585937500e+02 2.1800000000000000e+02 -1.3094200134277344e+02 2.5153500366210938e+02 2.1935099792480469e+02 -1.3081700134277344e+02 2.5160598754882812e+02 2.1768899536132812e+02 -1.4475000000000000e+02 2.4544200134277344e+02 2.1935099792480469e+02 -1.4462800598144531e+02 2.4553300476074219e+02 2.1768299865722656e+02 -1.4494299316406250e+02 -2.4586300659179688e+02 2.1970799255371094e+02 -1.3081700134277344e+02 -2.5160598754882812e+02 2.1966099548339844e+02 -1.1662599945068359e+02 -2.5647698974609375e+02 2.1970799255371094e+02 -1.4471499633789062e+02 -2.4546000671386719e+02 2.1935099792480469e+02 -1.4475000000000000e+02 -2.4544200134277344e+02 2.1799899291992188e+02 -1.3106500244140625e+02 -2.5151602172851562e+02 2.1768400573730469e+02 -1.1649499511718750e+02 -2.5603298950195312e+02 2.1935099792480469e+02 -1.1652899932861328e+02 -2.5602499389648438e+02 2.1799899291992188e+02 3.2605598449707031e+01 2.6285400390625000e+02 3.4131900024414062e+02 2.7357698440551758e+01 2.6280902099609375e+02 3.4069699096679688e+02 4.5507301330566406e+01 -2.6282699584960938e+02 3.0728701782226562e+02 3.9094799041748047e+01 -2.6295098876953125e+02 3.0525900268554688e+02 3.2492202758789062e+01 -2.6305300903320312e+02 3.0041998291015625e+02 2.7538599014282227e+01 -2.6314398193359375e+02 2.9314102172851562e+02 2.5836999893188477e+01 -2.6311901855468750e+02 2.8579299926757812e+02 2.6519001007080078e+01 -2.6310699462890625e+02 2.7767398071289062e+02 2.9840400695800781e+01 -2.6308898925781250e+02 2.7013998413085938e+02 3.5696102142333984e+01 -2.6297698974609375e+02 2.6413500976562500e+02 4.2669502258300781e+01 -2.6287100219726562e+02 2.6049899291992188e+02 3.9127799987792969e+01 2.6291998291015625e+02 2.6196499633789062e+02 4.5514301300048828e+01 2.6279800415039062e+02 2.5993600463867188e+02 3.2555301666259766e+01 2.6302999877929688e+02 2.6673901367187500e+02 2.7956501007080078e+01 2.6309100341796875e+02 2.7345898437500000e+02 2.5838001251220703e+01 2.6311199951171875e+02 2.8131298828125000e+02 2.6466098785400391e+01 2.6310699462890625e+02 2.8952801513671875e+02 2.9586500167846680e+01 2.6308599853515625e+02 2.9673699951171875e+02 3.5177101135253906e+01 2.6300399780273438e+02 3.0282299804687500e+02 4.2613700866699219e+01 2.6285699462890625e+02 3.0667001342773438e+02 -1.3797999572753906e+02 -2.4765299987792969e+02 6.4390197753906250e+01 -1.3610299682617188e+02 -2.4836599731445312e+02 6.4390098571777344e+01 -1.1677300262451172e+02 -2.5488999938964844e+02 6.4388793945312500e+01 -1.0516600036621094e+02 -2.5745001220703125e+02 6.4388198852539062e+01 -1.0448899841308594e+02 -2.5754699707031250e+02 6.4388099670410156e+01 -1.1519999694824219e+02 2.5542799377441406e+02 6.4388900756835938e+01 -1.2194799804687500e+02 2.5360301208496094e+02 6.4389198303222656e+01 -1.2380900573730469e+02 2.5292799377441406e+02 6.4389305114746094e+01 -1.3613099670410156e+02 2.4846200561523438e+02 6.4390098571777344e+01 -1.4295500183105469e+02 2.4513800048828125e+02 6.4390396118164062e+01 -1.3159899902343750e+02 2.5317201232910156e+02 2.1755099487304688e+02 -1.1662599945068359e+02 2.5647698974609375e+02 2.1764199829101562e+02 -1.1736399841308594e+02 2.5763299560546875e+02 2.1755099487304688e+02 -1.1696799468994141e+02 -2.5773300170898438e+02 2.1755099487304688e+02 -1.1662599945068359e+02 -2.5647698974609375e+02 2.1764199829101562e+02 -1.4494299316406250e+02 -2.4586300659179688e+02 2.1764199829101562e+02 -1.4514500427246094e+02 -2.4721899414062500e+02 2.1755099487304688e+02 2.9870800018310547e+01 -2.6282501220703125e+02 3.4141799926757812e+02 -2.6950100708007812e+02 -6.4825401306152344e+00 2.0020599365234375e+02 -2.6950201416015625e+02 -4.7405900955200195e+00 1.9747599792480469e+02 -2.6950201416015625e+02 -6.3385400772094727e+00 1.9697099304199219e+02 -2.6950000000000000e+02 -5.1617598533630371e+00 2.0002000427246094e+02 -2.6953302001953125e+02 -4.3796300888061523e+00 1.9911299133300781e+02 -2.6954098510742188e+02 -7.7422299385070801e+00 1.9849600219726562e+02 -2.7949301147460938e+02 -1.3417700767517090e+01 2.0002299499511719e+02 -2.6950100708007812e+02 -1.3024300575256348e+01 2.0104299926757812e+02 -2.6950900268554688e+02 -1.2610699653625488e+01 1.9830999755859375e+02 -2.6950601196289062e+02 -1.0224400520324707e+01 2.0038400268554688e+02 -2.6950201416015625e+02 -1.0596099853515625e+01 1.9875000000000000e+02 -2.6950201416015625e+02 -1.1471400260925293e+01 2.0151800537109375e+02 -2.6950000000000000e+02 -1.6034999847412109e+01 2.0116000366210938e+02 -2.6953302001953125e+02 -1.6942199707031250e+01 2.0037800598144531e+02 -2.6950399780273438e+02 -1.8907501220703125e+01 2.0100399780273438e+02 -2.6950000000000000e+02 -1.5816500663757324e+01 2.0197500610351562e+02 -2.6950201416015625e+02 -1.8677999496459961e+01 2.0311099243164062e+02 -2.6950799560546875e+02 -1.7086099624633789e+01 2.0361199951171875e+02 -2.7949899291992188e+02 -1.6248199462890625e+01 2.0292599487304688e+02 -2.6950000000000000e+02 -2.4119300842285156e+01 2.0566299438476562e+02 -2.6950299072265625e+02 -2.3212200164794922e+01 2.0644499206542969e+02 -2.6950100708007812e+02 -2.1070400238037109e+01 2.0448599243164062e+02 -2.6953302001953125e+02 -2.2201700210571289e+01 2.0325000000000000e+02 -2.6950000000000000e+02 -2.3522300720214844e+01 2.0343499755859375e+02 -2.6950100708007812e+02 -2.4304800033569336e+01 2.0434199523925781e+02 -2.6953302001953125e+02 -2.1576000213623047e+01 2.0608399963378906e+02 -2.6950100708007812e+02 -2.9140598297119141e+01 2.0880000305175781e+02 -2.6950299072265625e+02 -2.8009399414062500e+01 2.1003599548339844e+02 -2.6950100708007812e+02 -2.5867599487304688e+01 2.0807699584960938e+02 -2.6953302001953125e+02 -2.6998899459838867e+01 2.0684100341796875e+02 -2.6950201416015625e+02 -2.8635301589965820e+01 2.0720199584960938e+02 -2.6953302001953125e+02 -2.6373199462890625e+01 2.0967500305175781e+02 -2.6950900268554688e+02 -3.3492301940917969e+01 2.1256700134277344e+02 -2.6950000000000000e+02 -3.0926000595092773e+01 2.1408799743652344e+02 -2.6950900268554688e+02 -3.1629398345947266e+01 2.1092599487304688e+02 -2.6950698852539062e+02 -3.0015399932861328e+01 2.1267900085449219e+02 -2.6953198242187500e+02 -3.2232601165771484e+01 2.1427400207519531e+02 -2.6950299072265625e+02 -3.5693897247314453e+01 2.1583599853515625e+02 -2.6953302001953125e+02 -3.6930099487304688e+01 2.1696800231933594e+02 -2.6950100708007812e+02 -3.6569198608398438e+01 2.1860400390625000e+02 -2.6950100708007812e+02 -3.4096000671386719e+01 2.1634199523925781e+02 -2.6950299072265625e+02 -3.4971302032470703e+01 2.1911000061035156e+02 -2.6953302001953125e+02 -3.3735099792480469e+01 2.1797799682617188e+02 -2.6950698852539062e+02 -7.4285902976989746e+00 2.0552799987792969e+02 -2.6950201416015625e+02 -5.5639700889587402e+00 2.0630801391601562e+02 -2.6950100708007812e+02 -5.4200301170349121e+00 2.0307299804687500e+02 -2.6954299926757812e+02 -4.1759600639343262e+00 2.0478298950195312e+02 -2.6950399780273438e+02 -7.1077299118041992e+00 2.0346299743652344e+02 -2.6950100708007812e+02 -3.6967899322509766e+01 2.2160099792480469e+02 -2.6950000000000000e+02 -3.9616901397705078e+01 2.2354798889160156e+02 -2.6950000000000000e+02 -3.9019996643066406e+01 2.2414498901367188e+02 -2.6950299072265625e+02 -3.8565898895263672e+01 2.2109599304199219e+02 -2.6953302001953125e+02 -3.9802101135253906e+01 2.2222700500488281e+02 -2.6954202270507812e+02 -3.6742797851562500e+01 2.2371099853515625e+02 -2.6950000000000000e+02 -3.8204498291015625e+01 2.2436399841308594e+02 -2.7948999023437500e+02 -1.3174500465393066e+01 2.0583699035644531e+02 -2.6950100708007812e+02 -1.2872000694274902e+01 2.0729798889160156e+02 -2.6950299072265625e+02 -1.2820400238037109e+01 2.0489401245117188e+02 -2.6950698852539062e+02 -1.0066900253295898e+01 2.0574000549316406e+02 -2.6950100708007812e+02 -1.1183799743652344e+01 2.0453298950195312e+02 -2.6950201416015625e+02 -1.1327800750732422e+01 2.0776699829101562e+02 -2.6950000000000000e+02 -1.0276700019836426e+01 2.0694599914550781e+02 -2.6950299072265625e+02 -4.0660099029541016e+01 2.2671099853515625e+02 -2.6953302001953125e+02 -4.1896202087402344e+01 2.2784201049804688e+02 -2.6950100708007812e+02 -4.1535297393798828e+01 2.2947799682617188e+02 -2.6950100708007812e+02 -3.9062103271484375e+01 2.2721600341796875e+02 -2.6950299072265625e+02 -3.9937400817871094e+01 2.2998399353027344e+02 -2.6953302001953125e+02 -3.8701099395751953e+01 2.2885200500488281e+02 -2.6950100708007812e+02 -1.5497599601745605e+01 2.0815800476074219e+02 -2.6953302001953125e+02 -1.6628900527954102e+01 2.0692098999023438e+02 -2.6950399780273438e+02 -1.8593599319458008e+01 2.0754699707031250e+02 -2.6950201416015625e+02 -1.8370698928833008e+01 2.0964999389648438e+02 -2.6950000000000000e+02 -1.7134099960327148e+01 2.1015000915527344e+02 -2.6953302001953125e+02 -1.6003200531005859e+01 2.0975500488281250e+02 -2.6950100708007812e+02 -4.0335899353027344e+01 2.3307199096679688e+02 -2.6950900268554688e+02 -4.3322399139404297e+01 2.3409100341796875e+02 -2.6950201416015625e+02 -4.2077796936035156e+01 2.3580099487304688e+02 -2.6950299072265625e+02 -4.1933799743652344e+01 2.3256599426269531e+02 -2.6954202270507812e+02 -4.0113399505615234e+01 2.3517399597167969e+02 -2.6950100708007812e+02 -2.0475101470947266e+01 2.1141000366210938e+02 -2.6953302001953125e+02 -2.1606401443481445e+01 2.1017298889160156e+02 -2.6950000000000000e+02 -2.2927099227905273e+01 2.1035900878906250e+02 -2.6950100708007812e+02 -2.3709600448608398e+01 2.1126599121093750e+02 -2.6950201416015625e+02 -2.3348199844360352e+01 2.1290199279785156e+02 -2.6950000000000000e+02 -2.2111700057983398e+01 2.1340200805664062e+02 -2.6953302001953125e+02 -2.0980701446533203e+01 2.1300700378417969e+02 -2.6950100708007812e+02 -4.0763401031494141e+01 2.3904899597167969e+02 -2.6950000000000000e+02 -4.3412399291992188e+01 2.4099501037597656e+02 -2.6950201416015625e+02 -4.2505302429199219e+01 2.4177799987792969e+02 -2.6950299072265625e+02 -4.2361301422119141e+01 2.3854299926757812e+02 -2.6953302001953125e+02 -4.3597499847412109e+01 2.3967500305175781e+02 -2.6950000000000000e+02 -4.1184501647949219e+01 2.4159201049804688e+02 -2.6953302001953125e+02 -4.0402400970458984e+01 2.4068499755859375e+02 -2.6950100708007812e+02 -2.8122499465942383e+01 2.1615899658203125e+02 -2.6950299072265625e+02 -2.6991300582885742e+01 2.1739601135253906e+02 -2.6950100708007812e+02 -2.4849500656127930e+01 2.1543699645996094e+02 -2.6953302001953125e+02 -2.5980800628662109e+01 2.1420001220703125e+02 -2.6950201416015625e+02 -2.7617198944091797e+01 2.1456100463867188e+02 -2.6953302001953125e+02 -2.5355100631713867e+01 2.1703399658203125e+02 -2.6950100708007812e+02 -4.0335899353027344e+01 2.4502600097656250e+02 -2.6950900268554688e+02 -4.3322399139404297e+01 2.4604499816894531e+02 -2.6950201416015625e+02 -4.2077796936035156e+01 2.4775500488281250e+02 -2.6950299072265625e+02 -4.1933799743652344e+01 2.4452101135253906e+02 -2.6950000000000000e+02 -4.0756999969482422e+01 2.4756999206542969e+02 -2.6953302001953125e+02 -3.9974903106689453e+01 2.4666200256347656e+02 -2.6950299072265625e+02 -3.1774497985839844e+01 2.2085099792480469e+02 -2.6953302001953125e+02 -3.0643100738525391e+01 2.2208699035644531e+02 -2.6950100708007812e+02 -2.9006698608398438e+01 2.2172599792480469e+02 -2.6950100708007812e+02 -3.1269199371337891e+01 2.1925300598144531e+02 -2.6950299072265625e+02 -2.8501399993896484e+01 2.2012899780273438e+02 -2.6953302001953125e+02 -2.9632699966430664e+01 2.1889199829101562e+02 -2.6950100708007812e+02 -4.0659999847412109e+01 2.5037599182128906e+02 -2.6950299072265625e+02 -4.1896598815917969e+01 2.5150701904296875e+02 -2.6950100708007812e+02 -3.9937297821044922e+01 2.5364900207519531e+02 -2.6950299072265625e+02 -3.8700698852539062e+01 2.5251800537109375e+02 -2.6953302001953125e+02 -4.1534999847412109e+01 2.5314399719238281e+02 -2.6953302001953125e+02 -3.9062400817871094e+01 2.5088200378417969e+02 -2.6950299072265625e+02 -3.3329200744628906e+01 2.2408200073242188e+02 -2.6953302001953125e+02 -3.4565299987792969e+01 2.2521400451660156e+02 -2.6950100708007812e+02 -3.4204402923583984e+01 2.2685000610351562e+02 -2.6950100708007812e+02 -3.1731199264526367e+01 2.2458801269531250e+02 -2.6950299072265625e+02 -3.2606502532958984e+01 2.2735501098632812e+02 -2.6953302001953125e+02 -3.1370300292968750e+01 2.2622399902343750e+02 -2.6950601196289062e+02 -6.8246698379516602e+00 2.1221600341796875e+02 -2.6950000000000000e+02 -5.0372500419616699e+00 2.0934399414062500e+02 -2.6950201416015625e+02 -6.2140197753906250e+00 2.0912001037597656e+02 -2.6950399780273438e+02 -4.7214598655700684e+00 2.1199299621582031e+02 -2.6950000000000000e+02 -4.4402499198913574e+00 2.0994099426269531e+02 -2.6950000000000000e+02 -4.2217998504638672e+00 2.1075599670410156e+02 -2.7692098999023438e+02 -7.3864398002624512e+00 2.1075599670410156e+02 -2.6950000000000000e+02 -7.2650899887084961e+00 2.0994099426269531e+02 -2.6950900268554688e+02 -3.9666599273681641e+01 2.5664898681640625e+02 -2.6950100708007812e+02 -3.7843101501464844e+01 2.5926397705078125e+02 -2.6950000000000000e+02 -3.8204498291015625e+01 2.5599598693847656e+02 -2.6950299072265625e+02 -3.6606597900390625e+01 2.5813299560546875e+02 -2.6953302001953125e+02 -3.9440799713134766e+01 2.5875799560546875e+02 -2.6950000000000000e+02 -3.6792098999023438e+01 2.5681201171875000e+02 -2.7948498535156250e+02 -3.7925899505615234e+01 2.5611300659179688e+02 -2.6950201416015625e+02 -3.4393096923828125e+01 2.2974499511718750e+02 -2.6950100708007812e+02 -3.6504699707031250e+01 2.3176499938964844e+02 -2.6950000000000000e+02 -3.3485900878906250e+01 2.3052699279785156e+02 -2.6950201416015625e+02 -3.5403697967529297e+01 2.3294000244140625e+02 -2.6951101684570312e+02 -3.6073600769042969e+01 2.3013099670410156e+02 -2.6951000976562500e+02 -3.3767303466796875e+01 2.3257899475097656e+02 -2.6950000000000000e+02 -3.3267501831054688e+01 2.3134300231933594e+02 -2.6950100708007812e+02 -1.1933500289916992e+01 2.1406500244140625e+02 -2.6950299072265625e+02 -1.0339099884033203e+01 2.1370300292968750e+02 -2.6950000000000000e+02 -1.0664999961853027e+01 2.1105099487304688e+02 -2.6951000976562500e+02 -1.3078300476074219e+01 2.1195800781250000e+02 -2.6950000000000000e+02 -1.2892900466918945e+01 2.1327899169921875e+02 -2.6950201416015625e+02 -1.1841799736022949e+01 2.1082699584960938e+02 -2.6950698852539062e+02 -9.8440093994140625e+00 2.1210198974609375e+02 -2.6950100708007812e+02 -3.5693897247314453e+01 2.6125000000000000e+02 -2.6950299072265625e+02 -3.6930599212646484e+01 2.6238198852539062e+02 -2.6950100708007812e+02 -3.4971199035644531e+01 2.6452301025390625e+02 -2.6950299072265625e+02 -3.3734703063964844e+01 2.6339199829101562e+02 -2.6953302001953125e+02 -3.6568897247314453e+01 2.6401800537109375e+02 -2.6953302001953125e+02 -3.4096401214599609e+01 2.6175601196289062e+02 -2.6950299072265625e+02 -3.6238399505615234e+01 2.3557099914550781e+02 -2.6953302001953125e+02 -3.7474597930908203e+01 2.3670199584960938e+02 -2.6950100708007812e+02 -3.7113597869873047e+01 2.3833799743652344e+02 -2.6950100708007812e+02 -3.4640399932861328e+01 2.3607600402832031e+02 -2.6950299072265625e+02 -3.5515701293945312e+01 2.3884400939941406e+02 -2.6953302001953125e+02 -3.4279499053955078e+01 2.3771199035644531e+02 -2.6950000000000000e+02 -1.5851599693298340e+01 2.1382299804687500e+02 -2.7923101806640625e+02 -1.7033298492431641e+01 2.1372100830078125e+02 -2.6950201416015625e+02 -1.7798301696777344e+01 2.1399900817871094e+02 -2.6950399780273438e+02 -1.4941599845886230e+01 2.1523599243164062e+02 -2.6950100708007812e+02 -1.8303598403930664e+01 2.1559700012207031e+02 -2.6950299072265625e+02 -1.7172399520874023e+01 2.1683399963378906e+02 -2.6950000000000000e+02 -1.5851599693298340e+01 2.1664799499511719e+02 -2.6950201416015625e+02 -3.0104900360107422e+01 2.6732299804687500e+02 -2.6950000000000000e+02 -3.0926000595092773e+01 2.6627200317382812e+02 -2.6950100708007812e+02 -3.2149299621582031e+01 2.6605999755859375e+02 -2.6950000000000000e+02 -3.1741399765014648e+01 2.6931500244140625e+02 -2.6950299072265625e+02 -3.3339401245117188e+01 2.6717901611328125e+02 -2.6953302001953125e+02 -3.2977699279785156e+01 2.6881500244140625e+02 -2.6950698852539062e+02 -3.0610300064086914e+01 2.6892098999023438e+02 -2.6950100708007812e+02 -3.4640399932861328e+01 2.4202198791503906e+02 -2.6950000000000000e+02 -3.7289398193359375e+01 2.4396800231933594e+02 -2.6950201416015625e+02 -3.6382297515869141e+01 2.4475100708007812e+02 -2.6950299072265625e+02 -3.6238399505615234e+01 2.4151599121093750e+02 -2.6953302001953125e+02 -3.7474597930908203e+01 2.4264801025390625e+02 -2.6954202270507812e+02 -3.4417900085449219e+01 2.4412500000000000e+02 -2.6950100708007812e+02 -1.9576700210571289e+01 2.1860499572753906e+02 -2.6950799560546875e+02 -2.1101198196411133e+01 2.1721699523925781e+02 -2.6950100708007812e+02 -2.2811100006103516e+01 2.1846101379394531e+02 -2.6950900268554688e+02 -2.2185100555419922e+01 2.2042599487304688e+02 -2.6953302001953125e+02 -2.0082199096679688e+01 2.2020300292968750e+02 -2.6950201416015625e+02 -2.5867599487304688e+01 2.7156002807617188e+02 -2.7931402587890625e+02 -2.6534198760986328e+01 2.7074301147460938e+02 -2.6950100708007812e+02 -2.7865499496459961e+01 2.7028500366210938e+02 -2.6950000000000000e+02 -2.7504098892211914e+01 2.7355200195312500e+02 -2.6950299072265625e+02 -2.9101999282836914e+01 2.7141601562500000e+02 -2.6953302001953125e+02 -2.8740400314331055e+01 2.7305200195312500e+02 -2.6950698852539062e+02 -2.6373001098632812e+01 2.7315802001953125e+02 -2.6951000976562500e+02 -3.6029499053955078e+01 2.4778099060058594e+02 -2.6950799560546875e+02 -3.6478401184082031e+01 2.4979400634765625e+02 -2.6950000000000000e+02 -3.4898399353027344e+01 2.4738700866699219e+02 -2.6950100708007812e+02 -3.4536998748779297e+01 2.5065400695800781e+02 -2.7949200439453125e+02 -3.3398300170898438e+01 2.4901800537109375e+02 -2.6950698852539062e+02 -3.3661800384521484e+01 2.4788600158691406e+02 -2.6950000000000000e+02 -3.3485900878906250e+01 2.4983300781250000e+02 -2.6950500488281250e+02 -2.3185199737548828e+01 2.2363198852539062e+02 -2.6953100585937500e+02 -2.4441101074218750e+01 2.2190499877929688e+02 -2.6950201416015625e+02 -2.6075199127197266e+01 2.2227600097656250e+02 -2.6950399780273438e+02 -2.6526899337768555e+01 2.2428900146484375e+02 -2.6950698852539062e+02 -2.4575500488281250e+01 2.2515699768066406e+02 -2.6950100708007812e+02 -2.2345500946044922e+01 2.7714898681640625e+02 -2.6950100708007812e+02 -2.3068201065063477e+01 2.7387600708007812e+02 -2.6950299072265625e+02 -2.4304800033569336e+01 2.7500701904296875e+02 -2.6953302001953125e+02 -2.3943201065063477e+01 2.7664398193359375e+02 -2.6950201416015625e+02 -2.1470300674438477e+01 2.7438101196289062e+02 -2.6950698852539062e+02 -2.1108999252319336e+01 2.7601800537109375e+02 -2.6950100708007812e+02 -3.3329097747802734e+01 2.5300401306152344e+02 -2.6950299072265625e+02 -3.4565696716308594e+01 2.5413600158691406e+02 -2.6950100708007812e+02 -3.2606399536132812e+01 2.5627801513671875e+02 -2.6950299072265625e+02 -3.1369897842407227e+01 2.5514599609375000e+02 -2.6953302001953125e+02 -3.4204097747802734e+01 2.5577198791503906e+02 -2.6953302001953125e+02 -3.1731500625610352e+01 2.5350999450683594e+02 -2.6950000000000000e+02 -2.9128799438476562e+01 2.2951499938964844e+02 -2.6950299072265625e+02 -2.8221700668334961e+01 2.3029699707031250e+02 -2.6950100708007812e+02 -2.6079799652099609e+01 2.2833799743652344e+02 -2.6953302001953125e+02 -2.7211200714111328e+01 2.2710198974609375e+02 -2.6950000000000000e+02 -2.8531799316406250e+01 2.2728698730468750e+02 -2.6950100708007812e+02 -2.9314300537109375e+01 2.2819400024414062e+02 -2.6953302001953125e+02 -2.6585399627685547e+01 2.2993600463867188e+02 -2.6950000000000000e+02 -1.7447401046752930e+01 2.8001498413085938e+02 -2.6950100708007812e+02 -1.7808700561523438e+01 2.7674801635742188e+02 -2.6950000000000000e+02 -1.8859800338745117e+01 2.7756900024414062e+02 -2.6950000000000000e+02 -1.9078298568725586e+01 2.7838500976562500e+02 -2.6953302001953125e+02 -1.8683700561523438e+01 2.7951602172851562e+02 -2.6950799560546875e+02 -1.5873000144958496e+01 2.7760699462890625e+02 -2.6950698852539062e+02 -1.6316299438476562e+01 2.7962100219726562e+02 -2.6950100708007812e+02 -2.9632600784301758e+01 2.5827200317382812e+02 -2.6950000000000000e+02 -3.0953399658203125e+01 2.5845797729492188e+02 -2.6950000000000000e+02 -3.0138000488281250e+01 2.6150100708007812e+02 -2.6950299072265625e+02 -3.1735900878906250e+01 2.5936499023437500e+02 -2.6953302001953125e+02 -3.1374301910400391e+01 2.6100097656250000e+02 -2.6950201416015625e+02 -2.8501399993896484e+01 2.5950900268554688e+02 -2.6950698852539062e+02 -2.9006799697875977e+01 2.6110699462890625e+02 -2.6950100708007812e+02 -3.1060001373291016e+01 2.3468899536132812e+02 -2.6950299072265625e+02 -2.9928800582885742e+01 2.3592500305175781e+02 -2.6950100708007812e+02 -2.7787000656127930e+01 2.3396598815917969e+02 -2.6953302001953125e+02 -2.8918300628662109e+01 2.3272999572753906e+02 -2.6950201416015625e+02 -3.0554700851440430e+01 2.3309100341796875e+02 -2.6953302001953125e+02 -2.8292600631713867e+01 2.3556399536132812e+02 -2.6950000000000000e+02 -6.5590100288391113e+00 2.1829000854492188e+02 -2.6950201416015625e+02 -4.5069398880004883e+00 2.1574600219726562e+02 -2.6950900268554688e+02 -6.5214600563049316e+00 2.1530599975585938e+02 -2.6950201416015625e+02 -5.3821802139282227e+00 2.1851399230957031e+02 -2.6953302001953125e+02 -4.1459798812866211e+00 2.1738299560546875e+02 -2.6953302001953125e+02 -7.3796501159667969e+00 2.1723901367187500e+02 -2.6950500488281250e+02 -1.2804699897766113e+01 2.8193798828125000e+02 -2.6950100708007812e+02 -1.2194099426269531e+01 2.7884201049804688e+02 -2.6950299072265625e+02 -1.3441100120544434e+01 2.7997601318359375e+02 -2.6950799560546875e+02 -1.0250000000000000e+01 2.7970300292968750e+02 -2.6950698852539062e+02 -1.0701600074768066e+01 2.8171499633789062e+02 -2.6950100708007812e+02 -2.6124700546264648e+01 2.6619900512695312e+02 -2.6950100708007812e+02 -2.6847400665283203e+01 2.6292602539062500e+02 -2.6950299072265625e+02 -2.8083999633789062e+01 2.6405700683593750e+02 -2.6953302001953125e+02 -2.7722299575805664e+01 2.6569302368164062e+02 -2.6950201416015625e+02 -2.5249399185180664e+01 2.6343099975585938e+02 -2.6950698852539062e+02 -2.4888200759887695e+01 2.6506701660156250e+02 -2.6950299072265625e+02 -3.1636499404907227e+01 2.4054100036621094e+02 -2.6953302001953125e+02 -3.0505201339721680e+01 2.4177799987792969e+02 -2.6950100708007812e+02 -2.8868799209594727e+01 2.4141700744628906e+02 -2.6950100708007812e+02 -3.1131099700927734e+01 2.3894299316406250e+02 -2.6950299072265625e+02 -2.8363500595092773e+01 2.3981900024414062e+02 -2.6953302001953125e+02 -2.9494800567626953e+01 2.3858200073242188e+02 -2.6950100708007812e+02 -1.1658599853515625e+01 2.2052699279785156e+02 -2.6950000000000000e+02 -1.0337900161743164e+01 2.2034199523925781e+02 -2.6950201416015625e+02 -9.9167203903198242e+00 2.1779798889160156e+02 -2.6950299072265625e+02 -1.2284499168395996e+01 2.1769200134277344e+02 -2.6953302001953125e+02 -1.2789400100708008e+01 2.1929000854492188e+02 -2.6950698852539062e+02 -9.5554599761962891e+00 2.1943399047851562e+02 -2.6950000000000000e+02 -1.1153300285339355e+01 2.1729800415039062e+02 -2.6950100708007812e+02 -5.4719400405883789e+00 2.8015399169921875e+02 -2.6950201416015625e+02 -7.1362800598144531e+00 2.8053097534179688e+02 -2.6950500488281250e+02 -6.0892100334167480e+00 2.8350201416015625e+02 -2.6950698852539062e+02 -7.5976200103759766e+00 2.8216699218750000e+02 -2.6950000000000000e+02 -4.5647597312927246e+00 2.8093698120117188e+02 -2.6950698852539062e+02 -4.3793301582336426e+00 2.8225799560546875e+02 -2.6950100708007812e+02 -2.1750200271606445e+01 2.7022601318359375e+02 -2.6950100708007812e+02 -2.2472999572753906e+01 2.6695300292968750e+02 -2.6950299072265625e+02 -2.3709499359130859e+01 2.6808398437500000e+02 -2.6953302001953125e+02 -2.3347898483276367e+01 2.6972000122070312e+02 -2.6950201416015625e+02 -2.0875000000000000e+01 2.6745797729492188e+02 -2.6950698852539062e+02 -2.0513801574707031e+01 2.6909399414062500e+02 -2.6950100708007812e+02 -3.1060001373291016e+01 2.4639399719238281e+02 -2.6950299072265625e+02 -2.9928899765014648e+01 2.4763099670410156e+02 -2.6950100708007812e+02 -2.7787000656127930e+01 2.4567100524902344e+02 -2.6953302001953125e+02 -2.8918399810791016e+01 2.4443499755859375e+02 -2.6950201416015625e+02 -3.0554800033569336e+01 2.4479598999023438e+02 -2.6953302001953125e+02 -2.8292600631713867e+01 2.4726899719238281e+02 -2.6950100708007812e+02 -1.4278399467468262e+01 2.2185400390625000e+02 -2.6950100708007812e+02 -1.7551399230957031e+01 2.2257701110839844e+02 -2.6951599121093750e+02 -1.6020898818969727e+01 2.2397099304199219e+02 -2.6950799560546875e+02 -1.6729900360107422e+01 2.2067800903320312e+02 -2.6950000000000000e+02 -1.5099500656127930e+01 2.2080299377441406e+02 -2.7937799072265625e+02 -1.4421800613403320e+01 2.2265599060058594e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.8136502075195312e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.8076800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.8054898071289062e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.8076800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.8381100463867188e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.8136502075195312e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.8359197998046875e+02 -2.6950698852539062e+02 1.5978800058364868e+00 2.8268499755859375e+02 -2.6950799560546875e+02 -1.6363799571990967e+00 2.8254101562500000e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.8359197998046875e+02 -2.6950000000000000e+02 -1.7134099960327148e+01 2.7020999145507812e+02 -2.6950900268554688e+02 -1.8593500137329102e+01 2.7086898803710938e+02 -2.6950100708007812e+02 -1.6772701263427734e+01 2.7347799682617188e+02 -2.6953302001953125e+02 -1.8370300292968750e+01 2.7297198486328125e+02 -2.6950201416015625e+02 -1.5897400856018066e+01 2.7070999145507812e+02 -2.6950698852539062e+02 -1.5536200523376465e+01 2.7234597778320312e+02 -2.6950000000000000e+02 -2.7716299057006836e+01 2.5003001403808594e+02 -2.6950201416015625e+02 -2.8847599029541016e+01 2.5042399597167969e+02 -2.6950100708007812e+02 -2.7354999542236328e+01 2.5329699707031250e+02 -2.6950000000000000e+02 -2.9347200393676758e+01 2.5165998840332031e+02 -2.6953302001953125e+02 -2.8952600479125977e+01 2.5279098510742188e+02 -2.6950201416015625e+02 -2.6479799270629883e+01 2.5052899169921875e+02 -2.6950698852539062e+02 -2.6118499755859375e+01 2.5216600036621094e+02 -2.6951101684570312e+02 -1.8542900085449219e+01 2.2536500549316406e+02 -2.6950698852539062e+02 -2.0609998703002930e+01 2.2504800415039062e+02 -2.6950100708007812e+02 -1.8153600692749023e+01 2.2705200195312500e+02 -2.6950000000000000e+02 -2.1382499694824219e+01 2.2654600524902344e+02 -2.6950900268554688e+02 -2.0719600677490234e+01 2.2800999450683594e+02 -2.6950000000000000e+02 -1.8936100006103516e+01 2.2795899963378906e+02 -2.6950100708007812e+02 6.3386001586914062e+00 2.8338900756835938e+02 -2.6950100708007812e+02 5.6158900260925293e+00 2.8011599731445312e+02 -2.6950299072265625e+02 4.3792700767517090e+00 2.8124697875976562e+02 -2.6953302001953125e+02 4.7409501075744629e+00 2.8288299560546875e+02 -2.6950201416015625e+02 7.2137699127197266e+00 2.8062100219726562e+02 -2.6950698852539062e+02 7.5750899314880371e+00 2.8225799560546875e+02 -2.6950500488281250e+02 -1.2481900215148926e+01 2.7266101074218750e+02 -2.6953900146484375e+02 -1.3225099563598633e+01 2.7504598999023438e+02 -2.6950000000000000e+02 -1.1689100265502930e+01 2.7586001586914062e+02 -2.6950799560546875e+02 -1.0107899665832520e+01 2.7345300292968750e+02 -2.6950698852539062e+02 -1.0557999610900879e+01 2.7546600341796875e+02 -2.6950100708007812e+02 -2.3299600601196289e+01 2.5647900390625000e+02 -2.7944897460937500e+02 -2.4098501205444336e+01 2.5561198425292969e+02 -2.6950100708007812e+02 -2.5353099822998047e+01 2.5523400878906250e+02 -2.6950399780273438e+02 -2.4167900085449219e+01 2.5842999267578125e+02 -2.6950299072265625e+02 -2.6552398681640625e+01 2.5634399414062500e+02 -2.6953302001953125e+02 -2.6180398941040039e+01 2.5797799682617188e+02 -2.6950100708007812e+02 -2.4063199996948242e+01 2.3205799865722656e+02 -2.6950299072265625e+02 -2.2945699691772461e+01 2.3326699829101562e+02 -2.6950100708007812e+02 -2.0797100067138672e+01 2.3130198669433594e+02 -2.6953302001953125e+02 -2.1935199737548828e+01 2.3007200622558594e+02 -2.6950201416015625e+02 -2.3580699920654297e+01 2.3043798828125000e+02 -2.6953302001953125e+02 -2.1309400558471680e+01 2.3290600585937500e+02 -2.6950000000000000e+02 1.3245200157165527e+01 2.7966299438476562e+02 -2.6950000000000000e+02 1.2648200035095215e+01 2.7906600952148438e+02 -2.6950100708007812e+02 1.1471400260925293e+01 2.7884201049804688e+02 -2.6950100708007812e+02 1.2250499725341797e+01 2.8211599731445312e+02 -2.6950299072265625e+02 1.0224400520324707e+01 2.7997601318359375e+02 -2.6953302001953125e+02 1.0596400260925293e+01 2.8161001586914062e+02 -2.6950000000000000e+02 1.3245200157165527e+01 2.8129397583007812e+02 -2.7949899291992188e+02 1.3335499763488770e+01 2.8047698974609375e+02 -2.6950100708007812e+02 -5.5639700889587402e+00 2.7732598876953125e+02 -2.6950100708007812e+02 -6.2866802215576172e+00 2.7405300903320312e+02 -2.6950000000000000e+02 -7.3378100395202637e+00 2.7487399291992188e+02 -2.6953399658203125e+02 -7.4282298088073730e+00 2.7654598999023438e+02 -2.6950201416015625e+02 -4.6887998580932617e+00 2.7455801391601562e+02 -2.6950698852539062e+02 -4.3274803161621094e+00 2.7619400024414062e+02 -2.6950000000000000e+02 -2.1213199615478516e+01 2.5976199340820312e+02 -2.6950201416015625e+02 -2.2344398498535156e+01 2.6015698242187500e+02 -2.6950100708007812e+02 -2.0851900100708008e+01 2.6302999877929688e+02 -2.6954299926757812e+02 -2.2784198760986328e+01 2.6217098999023438e+02 -2.6950201416015625e+02 -1.9976598739624023e+01 2.6026202392578125e+02 -2.6950698852539062e+02 -1.9615299224853516e+01 2.6189898681640625e+02 -2.6950000000000000e+02 -2.4640399932861328e+01 2.3587500000000000e+02 -2.6950000000000000e+02 -2.5237400054931641e+01 2.3647200012207031e+02 -2.6950399780273438e+02 -2.5396799087524414e+01 2.3806600952148438e+02 -2.6950100708007812e+02 -2.2188499450683594e+01 2.3692601013183594e+02 -2.6953302001953125e+02 -2.3319799423217773e+01 2.3569000244140625e+02 -2.6954299926757812e+02 -2.3047300338745117e+01 2.3885800170898438e+02 -2.6950000000000000e+02 1.7447401046752930e+01 2.8001498413085938e+02 -2.6950100708007812e+02 1.7086099624633789e+01 2.7674801635742188e+02 -2.6950000000000000e+02 1.6034999847412109e+01 2.7756900024414062e+02 -2.6950000000000000e+02 1.5816500663757324e+01 2.7838500976562500e+02 -2.6953302001953125e+02 1.6211200714111328e+01 2.7951602172851562e+02 -2.6950201416015625e+02 1.8677900314331055e+01 2.7724902343750000e+02 -2.6950698852539062e+02 1.8578498840332031e+01 2.7962100219726562e+02 -2.7949700927734375e+02 1.8947401046752930e+01 2.7838500976562500e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.7536401367187500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.7476800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.7454901123046875e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.7476800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.7781100463867188e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.7536401367187500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.7759201049804688e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.7668499755859375e+02 -2.6950799560546875e+02 -1.6363799571990967e+00 2.7654098510742188e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.7759201049804688e+02 -2.6950500488281250e+02 -1.4941599845886230e+01 2.6512399291992188e+02 -2.7947598266601562e+02 -1.6233098983764648e+01 2.6363198852539062e+02 -2.6950100708007812e+02 -1.7028400421142578e+01 2.6348800659179688e+02 -2.6950500488281250e+02 -1.6603900909423828e+01 2.6686798095703125e+02 -2.6950299072265625e+02 -1.8264999389648438e+01 2.6461898803710938e+02 -2.6950000000000000e+02 -1.8079500198364258e+01 2.6594000244140625e+02 -2.6950000000000000e+02 -2.4640399932861328e+01 2.4166000366210938e+02 -2.7949600219726562e+02 -2.5124099731445312e+01 2.4232299804687500e+02 -2.6950100708007812e+02 -2.5462598800659180e+01 2.4350799560546875e+02 -2.6950000000000000e+02 -2.4640399932861328e+01 2.4448500061035156e+02 -2.6950100708007812e+02 -2.2188499450683594e+01 2.4271099853515625e+02 -2.6953302001953125e+02 -2.3319799423217773e+01 2.4147500610351562e+02 -2.6950000000000000e+02 -2.3824998855590820e+01 2.4470399475097656e+02 -2.6953302001953125e+02 -2.2693998336791992e+01 2.4430899047851562e+02 -2.6950100708007812e+02 -6.0483198165893555e+00 2.2465998840332031e+02 -2.6950000000000000e+02 -4.7467899322509766e+00 2.2164799499511719e+02 -2.6950201416015625e+02 -5.9236302375793457e+00 2.2142399597167969e+02 -2.6950000000000000e+02 -4.7467899322509766e+00 2.2447299194335938e+02 -2.6953500366210938e+02 -3.8360300064086914e+00 2.2306700134277344e+02 -2.6951000976562500e+02 -7.1601300239562988e+00 2.2255599975585938e+02 -2.6950000000000000e+02 -6.9746999740600586e+00 2.2387600708007812e+02 -2.6950399780273438e+02 2.3484901428222656e+01 2.7708398437500000e+02 -2.6950100708007812e+02 2.2345500946044922e+01 2.7387600708007812e+02 -2.6950299072265625e+02 2.1108999252319336e+01 2.7500701904296875e+02 -2.6953302001953125e+02 2.1470600128173828e+01 2.7664398193359375e+02 -2.6950201416015625e+02 2.3943500518798828e+01 2.7438101196289062e+02 -2.7949801635742188e+02 2.4218299865722656e+01 2.7514700317382812e+02 -2.6950100708007812e+02 6.2867999076843262e+00 2.7732598876953125e+02 -2.6950100708007812e+02 5.5640296936035156e+00 2.7405300903320312e+02 -2.6950299072265625e+02 4.3274803161621094e+00 2.7518399047851562e+02 -2.6953302001953125e+02 4.6891002655029297e+00 2.7682000732421875e+02 -2.6950201416015625e+02 7.1619696617126465e+00 2.7455801391601562e+02 -2.6950698852539062e+02 7.5232400894165039e+00 2.7619400024414062e+02 -2.6950100708007812e+02 -1.1119100570678711e+01 2.6953302001953125e+02 -2.6950100708007812e+02 -1.1841799736022949e+01 2.6626000976562500e+02 -2.6950299072265625e+02 -1.3078399658203125e+01 2.6739099121093750e+02 -2.6953302001953125e+02 -1.2716700553894043e+01 2.6902700805664062e+02 -2.6950201416015625e+02 -1.0243900299072266e+01 2.6676498413085938e+02 -2.6950698852539062e+02 -9.8825702667236328e+00 2.6840200805664062e+02 -2.6950000000000000e+02 -2.2440399169921875e+01 2.4705999755859375e+02 -2.6950299072265625e+02 -2.3316699981689453e+01 2.5018098449707031e+02 -2.6950000000000000e+02 -2.1624900817871094e+01 2.5010299682617188e+02 -2.6950000000000000e+02 -2.4071300506591797e+01 2.4869099426269531e+02 -2.6953302001953125e+02 -2.3571298599243164e+01 2.4745401000976562e+02 -2.6950299072265625e+02 -2.0833600997924805e+01 2.4919400024414062e+02 -2.6953302001953125e+02 -2.1204101562500000e+01 2.4755999755859375e+02 -2.6950100708007812e+02 -1.1085400581359863e+01 2.2721600341796875e+02 -2.6951300048828125e+02 -9.1206998825073242e+00 2.2658999633789062e+02 -2.6950100708007812e+02 -1.0074799537658691e+01 2.2402000427246094e+02 -2.6950299072265625e+02 -1.1711299896240234e+01 2.2438099670410156e+02 -2.6953302001953125e+02 -1.2216199874877930e+01 2.2597900390625000e+02 -2.7925399780273438e+02 -9.2783002853393555e+00 2.2486599731445312e+02 -2.6950100708007812e+02 2.8009500503540039e+01 2.7032400512695312e+02 -2.6950900268554688e+02 2.6044700622558594e+01 2.7094998168945312e+02 -2.6950000000000000e+02 2.7504098892211914e+01 2.7355200195312500e+02 -2.6953302001953125e+02 2.6267801284790039e+01 2.7305200195312500e+02 -2.6950201416015625e+02 2.9140598297119141e+01 2.7156002807617188e+02 -2.6950698852539062e+02 2.8635301589965820e+01 2.7315802001953125e+02 -2.6950100708007812e+02 1.2194499969482422e+01 2.7263098144531250e+02 -2.6950900268554688e+02 1.0222099304199219e+01 2.7326000976562500e+02 -2.6950100708007812e+02 1.2050499916076660e+01 2.7586599731445312e+02 -2.6953302001953125e+02 1.0452899932861328e+01 2.7535998535156250e+02 -2.6950000000000000e+02 1.3101599693298340e+01 2.7341397094726562e+02 -2.6950000000000000e+02 1.3101599693298340e+01 2.7504501342773438e+02 -2.6950000000000000e+02 1.3320099830627441e+01 2.7422900390625000e+02 -2.6950399780273438e+02 -6.7204799652099609e+00 2.7109597778320312e+02 -2.6950000000000000e+02 -5.0372500419616699e+00 2.7101599121093750e+02 -2.6950000000000000e+02 -4.4402499198913574e+00 2.7041900634765625e+02 -2.6950399780273438e+02 -6.6306600570678711e+00 2.6803201293945312e+02 -2.6950000000000000e+02 -7.4836001396179199e+00 2.6960400390625000e+02 -2.6950698852539062e+02 -4.3019599914550781e+00 2.6880300903320312e+02 -2.6950000000000000e+02 -1.9751600265502930e+01 2.5218298339843750e+02 -2.6950900268554688e+02 -2.1211000442504883e+01 2.5284201049804688e+02 -2.6950500488281250e+02 -2.0719600677490234e+01 2.5527700805664062e+02 -2.6950201416015625e+02 -1.8542900085449219e+01 2.5263198852539062e+02 -2.6953500366210938e+02 -1.8282699584960938e+01 2.5475498962402344e+02 -2.6950100708007812e+02 -1.2925700187683105e+01 2.2923800659179688e+02 -2.6950299072265625e+02 -1.4057000160217285e+01 2.2800199890136719e+02 -2.6950201416015625e+02 -1.6161199569702148e+01 2.2910900878906250e+02 -2.6953698730468750e+02 -1.5515600204467773e+01 2.3102799987792969e+02 -2.6950000000000000e+02 -1.5377700805664062e+01 2.2818798828125000e+02 -2.6953302001953125e+02 -1.3431400299072266e+01 2.3083599853515625e+02 -2.6950100708007812e+02 3.1333700180053711e+01 2.6605999755859375e+02 -2.6950299072265625e+02 3.0143499374389648e+01 2.6717901611328125e+02 -2.6950500488281250e+02 3.2519401550292969e+01 2.6925598144531250e+02 -2.6953302001953125e+02 3.0505201339721680e+01 2.6881500244140625e+02 -2.6950799560546875e+02 3.3377899169921875e+01 2.6732299804687500e+02 -2.7949801635742188e+02 3.2385799407958984e+01 2.6631600952148438e+02 -2.6950100708007812e+02 1.7639400482177734e+01 2.7024298095703125e+02 -2.6950201416015625e+02 1.6002799987792969e+01 2.7060400390625000e+02 -2.6950100708007812e+02 1.7495500564575195e+01 2.7347799682617188e+02 -2.6950000000000000e+02 1.5503199577331543e+01 2.7184100341796875e+02 -2.6953302001953125e+02 1.5897799491882324e+01 2.7297198486328125e+02 -2.6950698852539062e+02 1.8883998870849609e+01 2.7195297241210938e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.6936502075195312e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.6876800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.6854898071289062e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.6876800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.7181100463867188e+02 -2.6950299072265625e+02 -1.5978800058364868e+00 2.6967498779296875e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.7159197998046875e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.7099499511718750e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.7099499511718750e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.7159197998046875e+02 -2.6950000000000000e+02 1.6308999061584473e+00 2.7017999267578125e+02 -2.6950000000000000e+02 -1.4502500534057617e+01 2.5732897949218750e+02 -2.7902697753906250e+02 -1.4938600540161133e+01 2.5696798706054688e+02 -2.6950100708007812e+02 -1.6303899765014648e+01 2.5652099609375000e+02 -2.6950000000000000e+02 -1.5914899826049805e+01 2.5977502441406250e+02 -2.6950299072265625e+02 -1.7512901306152344e+01 2.5763897705078125e+02 -2.7949398803710938e+02 -1.5164899826049805e+01 2.5944302368164062e+02 -2.6950698852539062e+02 -1.4317000389099121e+01 2.5864898681640625e+02 -2.6953302001953125e+02 -1.7151199340820312e+01 2.5927499389648438e+02 -2.6950100708007812e+02 -1.8755498886108398e+01 2.3497900390625000e+02 -2.6950299072265625e+02 -1.7624300003051758e+01 2.3621598815917969e+02 -2.6950100708007812e+02 -1.5482500076293945e+01 2.3425599670410156e+02 -2.6953302001953125e+02 -1.6613800048828125e+01 2.3301998901367188e+02 -2.6950201416015625e+02 -1.8250200271606445e+01 2.3338099670410156e+02 -2.6953302001953125e+02 -1.5988100051879883e+01 2.3585400390625000e+02 -2.6950100708007812e+02 3.4971302032470703e+01 2.6125000000000000e+02 -2.6950299072265625e+02 3.3734703063964844e+01 2.6238198852539062e+02 -2.6950100708007812e+02 3.5694000244140625e+01 2.6452301025390625e+02 -2.6950299072265625e+02 3.6930599212646484e+01 2.6339199829101562e+02 -2.6953302001953125e+02 3.4096401214599609e+01 2.6401800537109375e+02 -2.6953302001953125e+02 3.6568897247314453e+01 2.6175601196289062e+02 -2.6950100708007812e+02 2.2472999572753906e+01 2.7022601318359375e+02 -2.6950100708007812e+02 2.1750299453735352e+01 2.6695300292968750e+02 -2.6950299072265625e+02 2.0513700485229492e+01 2.6808398437500000e+02 -2.6953302001953125e+02 2.0875400543212891e+01 2.6972000122070312e+02 -2.6950201416015625e+02 2.3348199844360352e+01 2.6745797729492188e+02 -2.6950698852539062e+02 2.3709499359130859e+01 2.6909399414062500e+02 -2.6950399780273438e+02 5.0747399330139160e+00 2.6803201293945312e+02 -2.6950000000000000e+02 4.2217998504638672e+00 2.6960400390625000e+02 -2.6950500488281250e+02 6.6357798576354980e+00 2.7117401123046875e+02 -2.6950000000000000e+02 4.4402499198913574e+00 2.7041900634765625e+02 -2.7948199462890625e+02 5.0891599655151367e+00 2.7089501953125000e+02 -2.6950201416015625e+02 7.0892601013183594e+00 2.6847198486328125e+02 -2.6950000000000000e+02 7.4836001396179199e+00 2.6960400390625000e+02 -2.6950100708007812e+02 -1.0647900581359863e+01 2.5983300781250000e+02 -2.6950000000000000e+02 -1.1968799591064453e+01 2.6001800537109375e+02 -2.6950000000000000e+02 -1.1153300285339355e+01 2.6306201171875000e+02 -2.6950299072265625e+02 -1.2751299858093262e+01 2.6092599487304688e+02 -2.6953302001953125e+02 -1.2389600753784180e+01 2.6256201171875000e+02 -2.6950201416015625e+02 -9.5168294906616211e+00 2.6107000732421875e+02 -2.6950698852539062e+02 -1.0022199630737305e+01 2.6266699218750000e+02 -2.6950100708007812e+02 -1.6363399505615234e+01 2.3981900024414062e+02 -2.6953302001953125e+02 -1.7494798660278320e+01 2.3858200073242188e+02 -2.6950201416015625e+02 -1.9131200790405273e+01 2.3894299316406250e+02 -2.6950500488281250e+02 -1.9630798339843750e+01 2.4018000793457031e+02 -2.6950201416015625e+02 -1.9236600875854492e+01 2.4131100463867188e+02 -2.6950000000000000e+02 -1.7999900817871094e+01 2.4181100463867188e+02 -2.6953302001953125e+02 -1.6869100570678711e+01 2.4141600036621094e+02 -2.6950000000000000e+02 3.7388999938964844e+01 2.5621499633789062e+02 -2.6950299072265625e+02 3.6605201721191406e+01 2.5714300537109375e+02 -2.6950100708007812e+02 3.8565898895263672e+01 2.5926397705078125e+02 -2.6950000000000000e+02 3.8204498291015625e+01 2.5599598693847656e+02 -2.6952001953125000e+02 3.9978298187255859e+01 2.5766198730468750e+02 -2.6953302001953125e+02 3.6968299865722656e+01 2.5875799560546875e+02 -2.6950000000000000e+02 3.9019996643066406e+01 2.5621499633789062e+02 -2.6950100708007812e+02 2.6847400665283203e+01 2.6619900512695312e+02 -2.6950500488281250e+02 2.6598001480102539e+01 2.6281198120117188e+02 -2.6950299072265625e+02 2.4888099670410156e+01 2.6405700683593750e+02 -2.6953302001953125e+02 2.5249799728393555e+01 2.6569302368164062e+02 -2.6950000000000000e+02 2.7898399353027344e+01 2.6374700927734375e+02 -2.6950698852539062e+02 2.8083900451660156e+01 2.6506701660156250e+02 -2.6950100708007812e+02 1.1841899871826172e+01 2.6953302001953125e+02 -2.6950100708007812e+02 1.1119199752807617e+01 2.6626000976562500e+02 -2.6950299072265625e+02 9.8825702667236328e+00 2.6739099121093750e+02 -2.6953302001953125e+02 1.0244199752807617e+01 2.6902700805664062e+02 -2.6950201416015625e+02 1.2717100143432617e+01 2.6676498413085938e+02 -2.6950698852539062e+02 1.3078300476074219e+01 2.6840200805664062e+02 -2.6950100708007812e+02 -5.3821201324462891e+00 2.6511898803710938e+02 -2.6950100708007812e+02 -6.1048898696899414e+00 2.6184600830078125e+02 -2.6950299072265625e+02 -7.3414397239685059e+00 2.6297698974609375e+02 -2.6953302001953125e+02 -6.9798197746276855e+00 2.6461398315429688e+02 -2.6950201416015625e+02 -4.5069398880004883e+00 2.6235101318359375e+02 -2.6950698852539062e+02 -4.1456799507141113e+00 2.6398797607421875e+02 -2.6950100708007812e+02 -1.8755498886108398e+01 2.4610400390625000e+02 -2.6950299072265625e+02 -1.7624300003051758e+01 2.4733999633789062e+02 -2.6950100708007812e+02 -1.5482500076293945e+01 2.4538099670410156e+02 -2.6953302001953125e+02 -1.6613800048828125e+01 2.4414500427246094e+02 -2.6950201416015625e+02 -1.8250200271606445e+01 2.4450599670410156e+02 -2.6953302001953125e+02 -1.5988100051879883e+01 2.4697900390625000e+02 -2.6950100708007812e+02 3.9937297821044922e+01 2.5037599182128906e+02 -2.6950299072265625e+02 3.8700698852539062e+01 2.5150701904296875e+02 -2.6950100708007812e+02 4.0660099029541016e+01 2.5364900207519531e+02 -2.6950299072265625e+02 4.1896598815917969e+01 2.5251800537109375e+02 -2.6953302001953125e+02 3.9062400817871094e+01 2.5314399719238281e+02 -2.6953302001953125e+02 4.1534999847412109e+01 2.5088200378417969e+02 -2.6950500488281250e+02 2.9361799240112305e+01 2.5828701782226562e+02 -2.6950100708007812e+02 3.0540199279785156e+01 2.6148599243164062e+02 -2.6950299072265625e+02 3.1735900878906250e+01 2.6037500000000000e+02 -2.6950799560546875e+02 2.8501600265502930e+01 2.6023098754882812e+02 -2.7949499511718750e+02 2.9119699478149414e+01 2.6098199462890625e+02 -2.6953302001953125e+02 3.1374200820922852e+01 2.5873898315429688e+02 -2.6950100708007812e+02 1.6230798721313477e+01 2.6672598266601562e+02 -2.6950100708007812e+02 1.6305700302124023e+01 2.6348800659179688e+02 -2.6952001953125000e+02 1.4894999504089355e+01 2.6508398437500000e+02 -2.6950201416015625e+02 1.7903699874877930e+01 2.6399298095703125e+02 -2.6953598022460938e+02 1.8129199981689453e+01 2.6610400390625000e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.6336499023437500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.6276800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.6254901123046875e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.6276800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.6581100463867188e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.6336499023437500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.6559201049804688e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.6468499755859375e+02 -2.6950799560546875e+02 -1.6363799571990967e+00 2.6454098510742188e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.6559201049804688e+02 -2.7946002197265625e+02 -1.4889200210571289e+01 2.5225401306152344e+02 -2.6950100708007812e+02 -1.4200900077819824e+01 2.5239700317382812e+02 -2.6950000000000000e+02 -1.5974700927734375e+01 2.5157600402832031e+02 -2.6950500488281250e+02 -1.4453499794006348e+01 2.4900900268554688e+02 -2.6950799560546875e+02 -1.6161098480224609e+01 2.5027000427246094e+02 -2.6950000000000000e+02 -1.3149900436401367e+01 2.5157600402832031e+02 -2.6953302001953125e+02 -1.2926200866699219e+01 2.5039898681640625e+02 -2.6950100708007812e+02 -4.7012600898742676e+00 2.2777000427246094e+02 -2.6950500488281250e+02 -5.3185801506042480e+00 2.3111799621582031e+02 -2.6950000000000000e+02 -3.7941899299621582e+00 2.2855299377441406e+02 -2.6953302001953125e+02 -3.6089999675750732e+00 2.2987399291992188e+02 -2.6950299072265625e+02 -6.3377599716186523e+00 2.2813198852539062e+02 -2.6953302001953125e+02 -6.8426699638366699e+00 2.2972999572753906e+02 -2.6950201416015625e+02 4.2077796936035156e+01 2.4455900573730469e+02 -2.6950100708007812e+02 4.0335899353027344e+01 2.4728800964355469e+02 -2.6950900268554688e+02 4.3322399139404297e+01 2.4626899719238281e+02 -2.6950000000000000e+02 4.0756999969482422e+01 2.4474499511718750e+02 -2.6953302001953125e+02 3.9974903106689453e+01 2.4565200805664062e+02 -2.6950299072265625e+02 4.1933799743652344e+01 2.4779400634765625e+02 -2.6950100708007812e+02 3.2606502532958984e+01 2.5300401306152344e+02 -2.6950299072265625e+02 3.1369897842407227e+01 2.5413600158691406e+02 -2.6950100708007812e+02 3.3329200744628906e+01 2.5627801513671875e+02 -2.6950299072265625e+02 3.4565696716308594e+01 2.5514599609375000e+02 -2.6953302001953125e+02 3.1731500625610352e+01 2.5577198791503906e+02 -2.6953302001953125e+02 3.4204097747802734e+01 2.5350999450683594e+02 -2.6950100708007812e+02 2.1574499130249023e+01 2.6302999877929688e+02 -2.6950100708007812e+02 2.0851900100708008e+01 2.5975701904296875e+02 -2.6950299072265625e+02 1.9615200042724609e+01 2.6088800048828125e+02 -2.6953302001953125e+02 1.9976900100708008e+01 2.6252401733398438e+02 -2.6950201416015625e+02 2.2449800491333008e+01 2.6026202392578125e+02 -2.6950698852539062e+02 2.2810998916625977e+01 2.6189898681640625e+02 -2.6950100708007812e+02 6.1049499511718750e+00 2.6511898803710938e+02 -2.6950100708007812e+02 5.3822398185729980e+00 2.6184600830078125e+02 -2.6950299072265625e+02 4.1456198692321777e+00 2.6297698974609375e+02 -2.6953302001953125e+02 4.5072999000549316e+00 2.6461398315429688e+02 -2.6950201416015625e+02 6.9801201820373535e+00 2.6235101318359375e+02 -2.6950698852539062e+02 7.3414397239685059e+00 2.6398797607421875e+02 -2.6950399780273438e+02 -9.6081504821777344e+00 2.5328298950195312e+02 -2.6950201416015625e+02 -1.1711299896240234e+01 2.5350601196289062e+02 -2.6950100708007812e+02 -1.0218700408935547e+01 2.5637899780273438e+02 -2.6954299926757812e+02 -1.2151100158691406e+01 2.5551998901367188e+02 -2.6950698852539062e+02 -8.9822406768798828e+00 2.5524801635742188e+02 -2.6950698852539062e+02 -7.7840700149536133e+00 2.3320298767089844e+02 -2.6950201416015625e+02 -8.1453294754028320e+00 2.3156700134277344e+02 -2.6950201416015625e+02 -9.0205698013305664e+00 2.3433500671386719e+02 -2.6950900268554688e+02 -1.0953400611877441e+01 2.3347599792480469e+02 -2.6950000000000000e+02 -9.3819503784179688e+00 2.3106700134277344e+02 -2.6950299072265625e+02 -1.0513099670410156e+01 2.3146200561523438e+02 -2.6950299072265625e+02 4.1638603210449219e+01 2.3854299926757812e+02 -2.6953302001953125e+02 4.0402400970458984e+01 2.3967500305175781e+02 -2.6950100708007812e+02 4.0763401031494141e+01 2.4131100463867188e+02 -2.6950100708007812e+02 4.3236499786376953e+01 2.3904899597167969e+02 -2.6950299072265625e+02 4.2361301422119141e+01 2.4181700134277344e+02 -2.6953302001953125e+02 4.3597499847412109e+01 2.4068499755859375e+02 -2.6951000976562500e+02 3.3767303466796875e+01 2.4778099060058594e+02 -2.6950000000000000e+02 3.3267501831054688e+01 2.4901699829101562e+02 -2.6950000000000000e+02 3.3485900878906250e+01 2.4983300781250000e+02 -2.6950000000000000e+02 3.4898399353027344e+01 2.4738700866699219e+02 -2.6950100708007812e+02 3.4393001556396484e+01 2.5061500549316406e+02 -2.6950201416015625e+02 3.6073600769042969e+01 2.5023001098632812e+02 -2.6952999877929688e+02 3.6399200439453125e+01 2.4816299438476562e+02 -2.6950000000000000e+02 2.4944101333618164e+01 2.5847799682617188e+02 -2.6950100708007812e+02 2.4582599639892578e+01 2.5521099853515625e+02 -2.6950299072265625e+02 2.3335700988769531e+01 2.5634399414062500e+02 -2.6953302001953125e+02 2.3707799911499023e+01 2.5797799682617188e+02 -2.6950100708007812e+02 2.6136299133300781e+01 2.5568601989746094e+02 -2.6950698852539062e+02 2.6075199127197266e+01 2.5808398437500000e+02 -2.7949600219726562e+02 2.6447700500488281e+01 2.5709597778320312e+02 -2.6950500488281250e+02 1.0181400299072266e+01 2.6289001464843750e+02 -2.6950500488281250e+02 1.1265299797058105e+01 2.5968099975585938e+02 -2.6950299072265625e+02 9.5553998947143555e+00 2.6092599487304688e+02 -2.6950201416015625e+02 1.2789799690246582e+01 2.6107000732421875e+02 -2.6950698852539062e+02 1.2284499168395996e+01 2.6266699218750000e+02 -2.6950399780273438e+02 -4.5837802886962891e+00 2.5583699035644531e+02 -2.6950000000000000e+02 -6.3777599334716797e+00 2.5588700866699219e+02 -2.6950100708007812e+02 -5.2009201049804688e+00 2.5893597412109375e+02 -2.6950000000000000e+02 -6.9746999740600586e+00 2.5648400878906250e+02 -2.6950000000000000e+02 -7.1932101249694824e+00 2.5729901123046875e+02 -2.6953302001953125e+02 -6.7985596656799316e+00 2.5842999267578125e+02 -2.6950698852539062e+02 -3.9644198417663574e+00 2.5780401611328125e+02 -2.6950100708007812e+02 -1.2204400062561035e+01 2.3910800170898438e+02 -2.6950399780273438e+02 -1.0567899703979492e+01 2.3874600219726562e+02 -2.6950100708007812e+02 -1.1193699836730957e+01 2.3591200256347656e+02 -2.6950299072265625e+02 -1.2830300331115723e+01 2.3627301025390625e+02 -2.6953302001953125e+02 -1.3335200309753418e+01 2.3787100219726562e+02 -2.6950698852539062e+02 -1.0062599182128906e+01 2.3714799499511719e+02 -2.6950299072265625e+02 4.1211097717285156e+01 2.3256599426269531e+02 -2.6953302001953125e+02 3.9974903106689453e+01 2.3369799804687500e+02 -2.6950100708007812e+02 4.0335899353027344e+01 2.3533399963378906e+02 -2.6950100708007812e+02 4.2809097290039062e+01 2.3307199096679688e+02 -2.6950299072265625e+02 4.1933799743652344e+01 2.3583898925781250e+02 -2.6953302001953125e+02 4.3170001983642578e+01 2.3470799255371094e+02 -2.6950900268554688e+02 3.5989002227783203e+01 2.4140299987792969e+02 -2.6950100708007812e+02 3.4640399932861328e+01 2.4428399658203125e+02 -2.6950900268554688e+02 3.7626899719238281e+01 2.4326499938964844e+02 -2.6953302001953125e+02 3.4279499053955078e+01 2.4264801025390625e+02 -2.6950299072265625e+02 3.6238399505615234e+01 2.4478900146484375e+02 -2.6950100708007812e+02 2.8221700668334961e+01 2.5006198120117188e+02 -2.6950201416015625e+02 2.6585201263427734e+01 2.5042399597167969e+02 -2.6950100708007812e+02 2.8077800750732422e+01 2.5329699707031250e+02 -2.6950000000000000e+02 2.6085399627685547e+01 2.5165998840332031e+02 -2.6953302001953125e+02 2.6480098724365234e+01 2.5279098510742188e+02 -2.6950000000000000e+02 2.9128799438476562e+01 2.5084498596191406e+02 -2.6950698852539062e+02 2.9314199447631836e+01 2.5216600036621094e+02 -2.6950100708007812e+02 1.6276199340820312e+01 2.5978100585937500e+02 -2.6950100708007812e+02 1.5553499221801758e+01 2.5650799560546875e+02 -2.6950299072265625e+02 1.4317000389099121e+01 2.5763897705078125e+02 -2.6953302001953125e+02 1.4678600311279297e+01 2.5927499389648438e+02 -2.6950201416015625e+02 1.7151498794555664e+01 2.5701300048828125e+02 -2.6950698852539062e+02 1.7512800216674805e+01 2.5864898681640625e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.5736499023437500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.5676797485351562e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.5654901123046875e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.5676797485351562e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.5981100463867188e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.5736499023437500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.5959201049804688e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.5868499755859375e+02 -2.6950799560546875e+02 -1.6363799571990967e+00 2.5854098510742188e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.5959201049804688e+02 -2.6950100708007812e+02 -1.2204400062561035e+01 2.4444801330566406e+02 -2.6950399780273438e+02 -1.0567899703979492e+01 2.4408699035644531e+02 -2.6950100708007812e+02 -1.1193799972534180e+01 2.4125199890136719e+02 -2.6950299072265625e+02 -1.2830300331115723e+01 2.4161399841308594e+02 -2.6953302001953125e+02 -1.3335200309753418e+01 2.4321200561523438e+02 -2.6950698852539062e+02 -1.0062599182128906e+01 2.4248899841308594e+02 -2.6950299072265625e+02 3.9937297821044922e+01 2.2671099853515625e+02 -2.6953302001953125e+02 3.8701099395751953e+01 2.2784201049804688e+02 -2.6950100708007812e+02 3.9062103271484375e+01 2.2947799682617188e+02 -2.6950100708007812e+02 4.1535297393798828e+01 2.2721600341796875e+02 -2.6950299072265625e+02 4.0659999847412109e+01 2.2998399353027344e+02 -2.6953302001953125e+02 4.1896202087402344e+01 2.2885200500488281e+02 -2.6950900268554688e+02 3.5989002227783203e+01 2.3545700073242188e+02 -2.6950100708007812e+02 3.4640399932861328e+01 2.3833799743652344e+02 -2.6950900268554688e+02 3.7626899719238281e+01 2.3731900024414062e+02 -2.6953302001953125e+02 3.4279499053955078e+01 2.3670199584960938e+02 -2.6950299072265625e+02 3.6238399505615234e+01 2.3884400939941406e+02 -2.6950100708007812e+02 2.7787000656127930e+01 2.4639399719238281e+02 -2.6950000000000000e+02 2.8608100891113281e+01 2.4744500732421875e+02 -2.6950100708007812e+02 3.1021499633789062e+01 2.4653799438476562e+02 -2.6951101684570312e+02 3.0642999649047852e+01 2.4487100219726562e+02 -2.6950698852539062e+02 2.8579000473022461e+01 2.4452200317382812e+02 -2.6950698852539062e+02 2.9791900634765625e+01 2.4767700195312500e+02 -2.6950201416015625e+02 2.1388099670410156e+01 2.5345199584960938e+02 -2.6950000000000000e+02 2.0567100524902344e+01 2.5240100097656250e+02 -2.6950000000000000e+02 1.9751600265502930e+01 2.5218298339843750e+02 -2.6950201416015625e+02 1.8609600067138672e+01 2.5259301757812500e+02 -2.6950399780273438e+02 2.0609998703002930e+01 2.5531199645996094e+02 -2.6950799560546875e+02 1.8115200042724609e+01 2.5417500305175781e+02 -2.7941198730468750e+02 1.8795000076293945e+01 2.5500700378417969e+02 -2.6950399780273438e+02 6.5407700538635254e+00 2.5583699035644531e+02 -2.6950000000000000e+02 4.7467899322509766e+00 2.5588700866699219e+02 -2.6950100708007812e+02 5.9236302375793457e+00 2.5893597412109375e+02 -2.6950000000000000e+02 4.1498498916625977e+00 2.5648400878906250e+02 -2.6950000000000000e+02 3.9313397407531738e+00 2.5729901123046875e+02 -2.6953302001953125e+02 4.3259797096252441e+00 2.5842999267578125e+02 -2.6950698852539062e+02 7.1601300239562988e+00 2.5780401611328125e+02 -2.6950000000000000e+02 -1.0794300079345703e+01 2.4684600830078125e+02 -2.6950900268554688e+02 -1.0953400611877441e+01 2.4844000244140625e+02 -2.6950201416015625e+02 -9.7433300018310547e+00 2.4602499389648438e+02 -2.6950698852539062e+02 -7.7840700149536133e+00 2.4816699218750000e+02 -2.6950201416015625e+02 -8.1453905105590820e+00 2.4653099060058594e+02 -2.6950201416015625e+02 -9.0206298828125000e+00 2.4929800415039062e+02 -2.6950100708007812e+02 3.9441101074218750e+01 2.2160099792480469e+02 -2.6950000000000000e+02 3.6792098999023438e+01 2.2354798889160156e+02 -2.6950000000000000e+02 3.7388999938964844e+01 2.2414498901367188e+02 -2.6950299072265625e+02 3.7843200683593750e+01 2.2109599304199219e+02 -2.6953302001953125e+02 3.6607002258300781e+01 2.2222700500488281e+02 -2.6954202270507812e+02 3.9666198730468750e+01 2.2371099853515625e+02 -2.6950000000000000e+02 3.8204498291015625e+01 2.2436399841308594e+02 -2.6950500488281250e+02 3.5829601287841797e+01 2.2987001037597656e+02 -2.6950000000000000e+02 3.3485900878906250e+01 2.3215800476074219e+02 -2.6950201416015625e+02 3.4393096923828125e+01 2.3294000244140625e+02 -2.6954202270507812e+02 3.3432701110839844e+01 2.3037300109863281e+02 -2.6951000976562500e+02 3.6029499053955078e+01 2.3257899475097656e+02 -2.6950000000000000e+02 3.6529300689697266e+01 2.3134300231933594e+02 -2.6951000976562500e+02 3.1236499786376953e+01 2.3904899597167969e+02 -2.6950100708007812e+02 2.9631999969482422e+01 2.3853599548339844e+02 -2.6950000000000000e+02 3.1630899429321289e+01 2.4018000793457031e+02 -2.6950100708007812e+02 2.8402000427246094e+01 2.3967500305175781e+02 -2.6950201416015625e+02 2.8782699584960938e+01 2.4134600830078125e+02 -2.6953100585937500e+02 3.0847999572753906e+01 2.4168699645996094e+02 -2.6950000000000000e+02 2.2440399169921875e+01 2.4705999755859375e+02 -2.6950100708007812e+02 2.1934999465942383e+01 2.5028800964355469e+02 -2.6950900268554688e+02 2.3907199859619141e+01 2.4966000366210938e+02 -2.6950100708007812e+02 2.0797201156616211e+01 2.4905799865722656e+02 -2.6953302001953125e+02 2.1309400558471680e+01 2.4745401000976562e+02 -2.6953302001953125e+02 2.3676599502563477e+01 2.4755999755859375e+02 -2.6950399780273438e+02 1.1552100181579590e+01 2.5328298950195312e+02 -2.6950000000000000e+02 9.7646703720092773e+00 2.5332998657226562e+02 -2.6950100708007812e+02 1.0941400527954102e+01 2.5637899780273438e+02 -2.6950299072265625e+02 8.9821796417236328e+00 2.5423699951171875e+02 -2.6953302001953125e+02 9.3438596725463867e+00 2.5587300109863281e+02 -2.6950698852539062e+02 1.2178000450134277e+01 2.5524801635742188e+02 -2.6954202270507812e+02 -6.6656498908996582e+00 2.5002000427246094e+02 -2.6950201416015625e+02 -6.4432001113891602e+00 2.5212300109863281e+02 -2.6950100708007812e+02 -4.7012600898742676e+00 2.4939399719238281e+02 -2.6950100708007812e+02 -4.8452000617980957e+00 2.5262800598144531e+02 -2.6950000000000000e+02 -3.7941899299621582e+00 2.5180700683593750e+02 -2.6953302001953125e+02 -3.5705001354217529e+00 2.5062998962402344e+02 -2.6950299072265625e+02 3.4971302032470703e+01 2.1583599853515625e+02 -2.6953302001953125e+02 3.3735099792480469e+01 2.1696800231933594e+02 -2.6950100708007812e+02 3.4096099853515625e+01 2.1860400390625000e+02 -2.6950100708007812e+02 3.6569198608398438e+01 2.1634199523925781e+02 -2.6950299072265625e+02 3.5694000244140625e+01 2.1911000061035156e+02 -2.6953302001953125e+02 3.6930099487304688e+01 2.1797799682617188e+02 -2.6950299072265625e+02 3.2606502532958984e+01 2.2408200073242188e+02 -2.6953302001953125e+02 3.1370300292968750e+01 2.2521400451660156e+02 -2.6950100708007812e+02 3.1731199264526367e+01 2.2685000610351562e+02 -2.6950100708007812e+02 3.4204402923583984e+01 2.2458801269531250e+02 -2.6950299072265625e+02 3.3329097747802734e+01 2.2735501098632812e+02 -2.6953302001953125e+02 3.4565399169921875e+01 2.2622399902343750e+02 -2.6950100708007812e+02 3.1060001373291016e+01 2.3396598815917969e+02 -2.6953100585937500e+02 2.9926498413085938e+01 2.3272000122070312e+02 -2.6950399780273438e+02 2.7963998794555664e+01 2.3335499572753906e+02 -2.6950201416015625e+02 2.8186998367309570e+01 2.3545800781250000e+02 -2.6954202270507812e+02 3.0199499130249023e+01 2.3590899658203125e+02 -2.6950100708007812e+02 2.2188499450683594e+01 2.4343399047851562e+02 -2.6950299072265625e+02 2.3319700241088867e+01 2.4467100524902344e+02 -2.6950100708007812e+02 2.5461500167846680e+01 2.4271099853515625e+02 -2.6953302001953125e+02 2.4330200195312500e+01 2.4147500610351562e+02 -2.6950201416015625e+02 2.2693799972534180e+01 2.4183599853515625e+02 -2.6953302001953125e+02 2.4955900192260742e+01 2.4430899047851562e+02 -2.6950100708007812e+02 1.4923599243164062e+01 2.5239700317382812e+02 -2.6950100708007812e+02 1.4200900077819824e+01 2.4912400817871094e+02 -2.6950201416015625e+02 1.3325699806213379e+01 2.5189099121093750e+02 -2.6953302001953125e+02 1.2964700698852539e+01 2.5025498962402344e+02 -2.6950299072265625e+02 1.6160200119018555e+01 2.5126498413085938e+02 -2.6953302001953125e+02 1.5798600196838379e+01 2.4962901306152344e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.5136399841308594e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.5076800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.5054899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.5076800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.5381100463867188e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.5136399841308594e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.5359201049804688e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.5268501281738281e+02 -2.6950799560546875e+02 -1.6363799571990967e+00 2.5254100036621094e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.5359201049804688e+02 -2.6950000000000000e+02 3.2556900024414062e+01 2.1408799743652344e+02 -2.7949600219726562e+02 3.3040500640869141e+01 2.1342599487304688e+02 -2.6950100708007812e+02 3.3378002166748047e+01 2.1231399536132812e+02 -2.6953302001953125e+02 3.2246601104736328e+01 2.1107800292968750e+02 -2.6950201416015625e+02 3.0610300064086914e+01 2.1143899536132812e+02 -2.6950000000000000e+02 3.0110500335693359e+01 2.1267601013183594e+02 -2.6950399780273438e+02 3.1250200271606445e+01 2.1427500915527344e+02 -2.6950000000000000e+02 3.0329000473022461e+01 2.1349099731445312e+02 -2.6950500488281250e+02 3.1709499359130859e+01 2.1971200561523438e+02 -2.6950100708007812e+02 2.9769399642944336e+01 2.1884500122070312e+02 -2.6950100708007812e+02 2.8540000915527344e+01 2.1998500061035156e+02 -2.6950900268554688e+02 2.9169099807739258e+01 2.2195799255371094e+02 -2.6950698852539062e+02 3.1269100189208984e+01 2.2172599792480469e+02 -2.6950100708007812e+02 2.9352899551391602e+01 2.2833799743652344e+02 -2.6953302001953125e+02 2.8221498489379883e+01 2.2710198974609375e+02 -2.6950201416015625e+02 2.6585201263427734e+01 2.2746301269531250e+02 -2.6950000000000000e+02 2.6085399627685547e+01 2.2869999694824219e+02 -2.6950201416015625e+02 2.6479799270629883e+01 2.2983099365234375e+02 -2.6950000000000000e+02 2.7716299057006836e+01 2.3033000183105469e+02 -2.6953302001953125e+02 2.8847299575805664e+01 2.2993600463867188e+02 -2.6950000000000000e+02 2.2412599563598633e+01 2.3810299682617188e+02 -2.6950299072265625e+02 2.3319700241088867e+01 2.3888499450683594e+02 -2.6950100708007812e+02 2.5461500167846680e+01 2.3692601013183594e+02 -2.6950799560546875e+02 2.3937000274658203e+01 2.3553698730468750e+02 -2.6950100708007812e+02 2.2227001190185547e+01 2.3678199768066406e+02 -2.6953302001953125e+02 2.4955900192260742e+01 2.3852301025390625e+02 -2.6950500488281250e+02 1.7231000900268555e+01 2.4399200439453125e+02 -2.6953698730468750e+02 1.5369500160217285e+01 2.4562998962402344e+02 -2.6950100708007812e+02 1.6613698959350586e+01 2.4733999633789062e+02 -2.6950399780273438e+02 1.8250200271606445e+01 2.4697900390625000e+02 -2.6950698852539062e+02 1.8755399703979492e+01 2.4538099670410156e+02 -2.6950500488281250e+02 5.3185801506042480e+00 2.4924198913574219e+02 -2.6953302001953125e+02 3.6089999675750732e+00 2.5048599243164062e+02 -2.6950201416015625e+02 3.9699702262878418e+00 2.5212300109863281e+02 -2.6950399780273438e+02 5.9845399856567383e+00 2.5256300354003906e+02 -2.6953302001953125e+02 6.8426699638366699e+00 2.5062998962402344e+02 -2.6950000000000000e+02 2.6091699600219727e+01 2.0925399780273438e+02 -2.6950299072265625e+02 2.6998798370361328e+01 2.1003599548339844e+02 -2.6950100708007812e+02 2.9140598297119141e+01 2.0807699584960938e+02 -2.6953302001953125e+02 2.8009298324584961e+01 2.0684100341796875e+02 -2.6950000000000000e+02 2.6688699722290039e+01 2.0702600097656250e+02 -2.6950100708007812e+02 2.5906200408935547e+01 2.0793299865722656e+02 -2.6953302001953125e+02 2.8635000228881836e+01 2.0967500305175781e+02 -2.6950000000000000e+02 2.5073598861694336e+01 2.1661299133300781e+02 -2.6950299072265625e+02 2.5980800628662109e+01 2.1739601135253906e+02 -2.6950100708007812e+02 2.8122499465942383e+01 2.1543699645996094e+02 -2.6953302001953125e+02 2.6991199493408203e+01 2.1420001220703125e+02 -2.6950000000000000e+02 2.5670598983764648e+01 2.1438500976562500e+02 -2.6950100708007812e+02 2.4888099670410156e+01 2.1529200744628906e+02 -2.6953302001953125e+02 2.7617000579833984e+01 2.1703399658203125e+02 -2.6950100708007812e+02 2.6560100555419922e+01 2.2311000061035156e+02 -2.6953302001953125e+02 2.5449300765991211e+01 2.2191500854492188e+02 -2.6950201416015625e+02 2.3812898635864258e+01 2.2227600097656250e+02 -2.6950000000000000e+02 2.3313199996948242e+01 2.2351300048828125e+02 -2.6950201416015625e+02 2.3751800537109375e+01 2.2467399597167969e+02 -2.6950799560546875e+02 2.5305398941040039e+01 2.2514900207519531e+02 -2.7949301147460938e+02 2.6118900299072266e+01 2.2448199462890625e+02 -2.6950100708007812e+02 2.0817499160766602e+01 2.3205799865722656e+02 -2.6950299072265625e+02 2.1934999465942383e+01 2.3326699829101562e+02 -2.6950100708007812e+02 2.4083499908447266e+01 2.3130198669433594e+02 -2.6953302001953125e+02 2.2945501327514648e+01 2.3007200622558594e+02 -2.6950201416015625e+02 2.1299999237060547e+01 2.3043798828125000e+02 -2.6953302001953125e+02 2.3571298599243164e+01 2.3290600585937500e+02 -2.6950500488281250e+02 1.6250000000000000e+01 2.4006800842285156e+02 -2.6950299072265625e+02 1.7494701385498047e+01 2.4177799987792969e+02 -2.6950399780273438e+02 1.9630498886108398e+01 2.3987998962402344e+02 -2.6950799560546875e+02 1.8111999511718750e+01 2.3842999267578125e+02 -2.6953302001953125e+02 1.9130901336669922e+01 2.4141600036621094e+02 -2.6950299072265625e+02 8.2507705688476562e+00 2.4642500305175781e+02 -2.6953302001953125e+02 7.7458600997924805e+00 2.4802301025390625e+02 -2.6950000000000000e+02 8.5664997100830078e+00 2.4907398986816406e+02 -2.6950698852539062e+02 1.0979799270629883e+01 2.4816699218750000e+02 -2.6950201416015625e+02 1.0618500709533691e+01 2.4653099060058594e+02 -2.6950201416015625e+02 9.7432708740234375e+00 2.4929800415039062e+02 -2.6950000000000000e+02 9.3819503784179688e+00 2.4603100585937500e+02 -2.6950601196289062e+02 -4.2241201400756836e+00 2.3572100830078125e+02 -2.6950500488281250e+02 -5.3081498146057129e+00 2.3893000793457031e+02 -2.6953302001953125e+02 -3.5985698699951172e+00 2.3768499755859375e+02 -2.6950299072265625e+02 -6.3273301124572754e+00 2.3594300842285156e+02 -2.6953302001953125e+02 -6.8322401046752930e+00 2.3754100036621094e+02 -2.6950100708007812e+02 2.1070400238037109e+01 2.0520899963378906e+02 -2.6950299072265625e+02 2.2201599121093750e+01 2.0644499206542969e+02 -2.6950100708007812e+02 2.4343399047851562e+01 2.0448599243164062e+02 -2.6953302001953125e+02 2.3212099075317383e+01 2.0325000000000000e+02 -2.6950201416015625e+02 2.1575700759887695e+01 2.0361100769042969e+02 -2.6953302001953125e+02 2.3837799072265625e+01 2.0608399963378906e+02 -2.6950100708007812e+02 2.0475101470947266e+01 2.1213200378417969e+02 -2.6950299072265625e+02 2.1606300354003906e+01 2.1336900329589844e+02 -2.6950100708007812e+02 2.3748199462890625e+01 2.1141000366210938e+02 -2.6953302001953125e+02 2.2616800308227539e+01 2.1017298889160156e+02 -2.6950201416015625e+02 2.0980398178100586e+01 2.1053401184082031e+02 -2.6953302001953125e+02 2.3242500305175781e+01 2.1300700378417969e+02 -2.6950000000000000e+02 1.9800800323486328e+01 2.1978199768066406e+02 -2.6950299072265625e+02 2.0707899093627930e+01 2.2056500244140625e+02 -2.6950100708007812e+02 2.2849699020385742e+01 2.1860499572753906e+02 -2.6953302001953125e+02 2.1718399047851562e+01 2.1736900329589844e+02 -2.6950000000000000e+02 2.0397701263427734e+01 2.1755400085449219e+02 -2.6950100708007812e+02 1.9615200042724609e+01 2.1846101379394531e+02 -2.6953302001953125e+02 2.2344099044799805e+01 2.2020300292968750e+02 -2.6950100708007812e+02 1.8115001678466797e+01 2.2690800476074219e+02 -2.6950000000000000e+02 1.8936100006103516e+01 2.2795899963378906e+02 -2.6950000000000000e+02 2.1382499694824219e+01 2.2654600524902344e+02 -2.6951000976562500e+02 2.0988100051879883e+01 2.2541500854492188e+02 -2.6950000000000000e+02 1.9751600265502930e+01 2.2491600036621094e+02 -2.6950201416015625e+02 1.8609600067138672e+01 2.2532600402832031e+02 -2.6953500366210938e+02 2.0609800338745117e+01 2.2804400634765625e+02 -2.6950399780273438e+02 1.5987800598144531e+01 2.3338099670410156e+02 -2.6950698852539062e+02 1.5482500076293945e+01 2.3497900390625000e+02 -2.6950100708007812e+02 1.6613698959350586e+01 2.3621598815917969e+02 -2.6950100708007812e+02 1.7624300003051758e+01 2.3301998901367188e+02 -2.6950399780273438e+02 1.8250200271606445e+01 2.3585400390625000e+02 -2.6950698852539062e+02 1.8755399703979492e+01 2.3425599670410156e+02 -2.6950000000000000e+02 1.3330000877380371e+01 2.4285000610351562e+02 -2.6950500488281250e+02 1.2563800811767578e+01 2.4135699462890625e+02 -2.6950201416015625e+02 1.2060500144958496e+01 2.4448699951171875e+02 -2.7949700927734375e+02 1.3127099990844727e+01 2.4339799499511719e+02 -2.6950900268554688e+02 1.0127699851989746e+01 2.4362799072265625e+02 -2.6950299072265625e+02 1.0567899703979492e+01 2.4161399841308594e+02 -2.6950500488281250e+02 -5.3081498146057129e+00 2.4492999267578125e+02 -2.6950201416015625e+02 -3.9595398902893066e+00 2.4204899597167969e+02 -2.6950201416015625e+02 -5.5574202537536621e+00 2.4154299926757812e+02 -2.6953302001953125e+02 -3.5985698699951172e+00 2.4368501281738281e+02 -2.6950000000000000e+02 -6.6085400581359863e+00 2.4236399841308594e+02 -2.6953302001953125e+02 -6.8322401046752930e+00 2.4354100036621094e+02 -2.6950000000000000e+02 1.8859800338745117e+01 2.0116000366210938e+02 -2.6953302001953125e+02 1.7952600479125977e+01 2.0037800598144531e+02 -2.6950399780273438e+02 1.5987298965454102e+01 2.0100399780273438e+02 -2.6950000000000000e+02 1.9078298568725586e+01 2.0197500610351562e+02 -2.6950201416015625e+02 1.6216798782348633e+01 2.0311099243164062e+02 -2.6950799560546875e+02 1.7808700561523438e+01 2.0361199951171875e+02 -2.7949899291992188e+02 1.8746400833129883e+01 2.0272499084472656e+02 -2.6950900268554688e+02 1.6356100082397461e+01 2.0694799804687500e+02 -2.6950698852539062e+02 1.5562600135803223e+01 2.0929699707031250e+02 -2.6950201416015625e+02 1.8370698928833008e+01 2.0738800048828125e+02 -2.6950201416015625e+02 1.7495399475097656e+01 2.1015499877929688e+02 -2.6950698852539062e+02 1.8731899261474609e+01 2.0902400207519531e+02 -2.6950100708007812e+02 1.5535900115966797e+01 2.1399900817871094e+02 -2.6953302001953125e+02 1.5031000137329102e+01 2.1559700012207031e+02 -2.6950000000000000e+02 1.5851599693298340e+01 2.1664799499511719e+02 -2.6950500488281250e+02 1.7444999694824219e+01 2.1680699157714844e+02 -2.6950299072265625e+02 1.8303598403930664e+01 2.1487500000000000e+02 -2.6953302001953125e+02 1.7172298431396484e+01 2.1363798522949219e+02 -2.6950299072265625e+02 1.4278399467468262e+01 2.2257701110839844e+02 -2.6953302001953125e+02 1.5409699440002441e+01 2.2381300354003906e+02 -2.6950100708007812e+02 1.7046098709106445e+01 2.2345199584960938e+02 -2.6950100708007812e+02 1.4783699989318848e+01 2.2097900390625000e+02 -2.6950299072265625e+02 1.7551399230957031e+01 2.2185400390625000e+02 -2.6953302001953125e+02 1.6420099258422852e+01 2.2061799621582031e+02 -2.6950000000000000e+02 1.3149900436401367e+01 2.3041500854492188e+02 -2.6953302001953125e+02 1.4057100296020508e+01 2.3119700622558594e+02 -2.6950201416015625e+02 1.5693500518798828e+01 2.3083599853515625e+02 -2.6950100708007812e+02 1.2964300155639648e+01 2.2909500122070312e+02 -2.6950100708007812e+02 1.6198801040649414e+01 2.2923800659179688e+02 -2.6950000000000000e+02 1.5377700805664062e+01 2.2818798828125000e+02 -2.6953302001953125e+02 1.4201000213623047e+01 2.2796400451660156e+02 -2.6950100708007812e+02 1.1193799972534180e+01 2.3910800170898438e+02 -2.6950000000000000e+02 1.2514599800109863e+01 2.3892199707031250e+02 -2.6950100708007812e+02 1.2204500198364258e+01 2.3591200256347656e+02 -2.6950299072265625e+02 1.0567899703979492e+01 2.3627301025390625e+02 -2.6953302001953125e+02 1.0062999725341797e+01 2.3787100219726562e+02 -2.7949499511718750e+02 1.2998200416564941e+01 2.3676000976562500e+02 -2.6950000000000000e+02 1.3330000877380371e+01 2.3750999450683594e+02 -2.6950000000000000e+02 1.3111499786376953e+01 2.3832499694824219e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.4476799011230469e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.4454901123046875e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.4759199523925781e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.4476799011230469e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.4536499023437500e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.4654100036621094e+02 -2.7928997802734375e+02 1.3014100790023804e+00 2.4693099975585938e+02 -2.6950698852539062e+02 1.6364400386810303e+00 2.4581900024414062e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.4759199523925781e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.4781100463867188e+02 -2.6950100708007812e+02 1.1327400207519531e+01 2.0147900390625000e+02 -2.6950000000000000e+02 1.2648200035095215e+01 2.0129400634765625e+02 -2.6950601196289062e+02 1.2811499595642090e+01 1.9841900634765625e+02 -2.6950299072265625e+02 1.0701499938964844e+01 1.9864498901367188e+02 -2.6953100585937500e+02 1.0188699722290039e+01 2.0025000000000000e+02 -2.6950000000000000e+02 1.3463700294494629e+01 1.9988099670410156e+02 -2.7855700683593750e+02 1.2947300910949707e+01 2.0093501281738281e+02 -2.7949200439453125e+02 1.0182000160217285e+01 2.0589099121093750e+02 -2.6950100708007812e+02 1.0506299972534180e+01 2.0729798889160156e+02 -2.6950299072265625e+02 1.0557900428771973e+01 2.0489401245117188e+02 -2.6950000000000000e+02 1.3320099830627441e+01 2.0613099670410156e+02 -2.6950500488281250e+02 1.2555999755859375e+01 2.0463800048828125e+02 -2.6950900268554688e+02 1.2474599838256836e+01 2.0769999694824219e+02 -2.6950100708007812e+02 1.1027400016784668e+01 2.1406500244140625e+02 -2.6950000000000000e+02 1.2295999526977539e+01 2.1387599182128906e+02 -2.6950500488281250e+02 1.1592499732971191e+01 2.1071400451660156e+02 -2.6951000976562500e+02 9.8826293945312500e+00 2.1195800781250000e+02 -2.6950000000000000e+02 1.0067999839782715e+01 2.1327899169921875e+02 -2.6950698852539062e+02 1.3116899490356445e+01 2.1210198974609375e+02 -2.7738500976562500e+02 1.2999399185180664e+01 2.1291799926757812e+02 -2.6950299072265625e+02 1.0022199630737305e+01 2.1769200134277344e+02 -2.6953302001953125e+02 9.5171899795532227e+00 2.1929000854492188e+02 -2.6950500488281250e+02 1.1041300773620605e+01 2.2067900085449219e+02 -2.7947000122070312e+02 1.2580400466918945e+01 2.1839498901367188e+02 -2.6950100708007812e+02 1.1658699989318848e+01 2.1733100891113281e+02 -2.6950698852539062e+02 1.2751200675964355e+01 2.1943399047851562e+02 -2.6950100708007812e+02 1.0074799537658691e+01 2.2721600341796875e+02 -2.6950399780273438e+02 1.1711299896240234e+01 2.2685400390625000e+02 -2.6950000000000000e+02 1.1395599365234375e+01 2.2420500183105469e+02 -2.6954202270507812e+02 8.8306703567504883e+00 2.2550599670410156e+02 -2.6950201416015625e+02 1.0218700408935547e+01 2.2398098754882812e+02 -2.6950698852539062e+02 1.2216599464416504e+01 2.2525599670410156e+02 -2.6950299072265625e+02 8.2507095336914062e+00 2.3146200561523438e+02 -2.6953302001953125e+02 7.7458600997924805e+00 2.3305900573730469e+02 -2.6950000000000000e+02 8.5664997100830078e+00 2.3411099243164062e+02 -2.6950698852539062e+02 1.0979799270629883e+01 2.3320298767089844e+02 -2.6950201416015625e+02 1.0618599891662598e+01 2.3156700134277344e+02 -2.6950201416015625e+02 9.7432708740234375e+00 2.3433500671386719e+02 -2.6950000000000000e+02 9.3819503784179688e+00 2.3106700134277344e+02 -2.6950500488281250e+02 5.0841002464294434e+00 2.4492999267578125e+02 -2.6950100708007812e+02 5.7014198303222656e+00 2.4158200073242188e+02 -2.6950299072265625e+02 4.0649199485778809e+00 2.4194300842285156e+02 -2.6950000000000000e+02 6.6085400581359863e+00 2.4236399841308594e+02 -2.6953302001953125e+02 6.7936801910400391e+00 2.4368501281738281e+02 -2.6953302001953125e+02 3.5600101947784424e+00 2.4354100036621094e+02 -2.6950500488281250e+02 5.8651599884033203e+00 2.0035700988769531e+02 -2.6950201416015625e+02 7.2137699127197266e+00 1.9747599792480469e+02 -2.6950900268554688e+02 5.1992497444152832e+00 1.9703599548339844e+02 -2.6953302001953125e+02 7.5747399330139160e+00 1.9911299133300781e+02 -2.6953302001953125e+02 4.3410596847534180e+00 1.9896900939941406e+02 -2.6950601196289062e+02 6.8973298072814941e+00 2.0321199035644531e+02 -2.6950500488281250e+02 5.8133602142333984e+00 2.0642100524902344e+02 -2.6953302001953125e+02 7.5229401588439941e+00 2.0517599487304688e+02 -2.6950299072265625e+02 4.7941799163818359e+00 2.0343400573730469e+02 -2.6953302001953125e+02 4.2892699241638184e+00 2.0503201293945312e+02 -2.6950799560546875e+02 4.3019599914550781e+00 2.1155700683593750e+02 -2.6950000000000000e+02 6.6681499481201172e+00 2.0934399414062500e+02 -2.6950201416015625e+02 5.4913201332092285e+00 2.0912001037597656e+02 -2.6951000976562500e+02 6.6305999755859375e+00 2.1232800292968750e+02 -2.6950000000000000e+02 7.2650899887084961e+00 2.0994099426269531e+02 -2.6950000000000000e+02 7.4836001396179199e+00 2.1075599670410156e+02 -2.6950000000000000e+02 4.4402499198913574e+00 2.0994099426269531e+02 -2.6950900268554688e+02 4.1720900535583496e+00 2.1765499877929688e+02 -2.6950201416015625e+02 6.1048898696899414e+00 2.1851399230957031e+02 -2.6950601196289062e+02 6.7155399322509766e+00 2.1541799926757812e+02 -2.6953302001953125e+02 7.3410902023315430e+00 2.1738299560546875e+02 -2.6950299072265625e+02 4.6123299598693848e+00 2.1564100646972656e+02 -2.6950100708007812e+02 5.0762300491333008e+00 2.2465998840332031e+02 -2.6950000000000000e+02 6.3777599334716797e+00 2.2164799499511719e+02 -2.6950201416015625e+02 5.2009201049804688e+00 2.2142500305175781e+02 -2.6950000000000000e+02 6.3777599334716797e+00 2.2447299194335938e+02 -2.7947802734375000e+02 6.8615698814392090e+00 2.2381100463867188e+02 -2.6950799560546875e+02 7.1986899375915527e+00 2.2269999694824219e+02 -2.6951000976562500e+02 3.9644198417663574e+00 2.2255599975585938e+02 -2.6950000000000000e+02 4.1498498916625977e+00 2.2387600708007812e+02 -2.6950500488281250e+02 5.0945901870727539e+00 2.3111799621582031e+02 -2.6950100708007812e+02 5.7119097709655762e+00 2.2777000427246094e+02 -2.6950299072265625e+02 4.0754098892211914e+00 2.2813198852539062e+02 -2.6950000000000000e+02 6.6189799308776855e+00 2.2855299377441406e+02 -2.6953302001953125e+02 6.8041100502014160e+00 2.2987399291992188e+02 -2.6953302001953125e+02 3.5705001354217529e+00 2.2972999572753906e+02 -2.6950201416015625e+02 6.4327101707458496e+00 2.3604899597167969e+02 -2.6950900268554688e+02 4.4181900024414062e+00 2.3560899353027344e+02 -2.6950100708007812e+02 4.6908302307128906e+00 2.3877799987792969e+02 -2.6952099609375000e+02 6.6554498672485352e+00 2.3815199279785156e+02 -2.6953302001953125e+02 3.5600101947784424e+00 2.3754100036621094e+02 -2.6950698852539062e+02 1.5978199243545532e+00 1.9868501281738281e+02 -2.6950000000000000e+02 1.4123899936676025e+00 1.9736500549316406e+02 -2.6950000000000000e+02 8.1545400619506836e-01 1.9676800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 1.9654899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 1.9959199523925781e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 1.9676800537109375e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 1.9736500549316406e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 1.9854100036621094e+02 -2.6950000000000000e+02 8.1545400619506836e-01 1.9959199523925781e+02 -2.6950000000000000e+02 0.0000000000000000e+00 1.9981098937988281e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.0468499755859375e+02 -2.7917401123046875e+02 1.3027200698852539e+00 2.0342799377441406e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.0276800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.0254899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.0559201049804688e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.0276800537109375e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.0336500549316406e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.0454100036621094e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.0559201049804688e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.0581098937988281e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.1068499755859375e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.0936499023437500e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.0876799011230469e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.0854899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.1159201049804688e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.0876799011230469e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.0936499023437500e+02 -2.6950000000000000e+02 -1.6308999061584473e+00 2.1017999267578125e+02 -2.7944799804687500e+02 -1.2996200323104858e+00 2.1093000793457031e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.1159201049804688e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.1181100463867188e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.1476800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.1454901123046875e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.1759199523925781e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.1476800537109375e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.1536499023437500e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.1654100036621094e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.1699499511718750e+02 -2.6950698852539062e+02 1.6364400386810303e+00 2.1581900024414062e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.1759199523925781e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.1781100463867188e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.2076800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.2054899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.2359199523925781e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.2076800537109375e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.2136401367187500e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.2254100036621094e+02 -2.7908700561523438e+02 1.3036700487136841e+00 2.2293299865722656e+02 -2.6950698852539062e+02 1.6363799571990967e+00 2.2181900024414062e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.2359199523925781e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.2381100463867188e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.2868501281738281e+02 -2.7937200927734375e+02 1.3004499673843384e+00 2.2742900085449219e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.2676699829101562e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.2654899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.2959199523925781e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.2676699829101562e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.2736399841308594e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.2854100036621094e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.2959199523925781e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.2981100463867188e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.3876799011230469e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.3854899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.4159201049804688e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.3876799011230469e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.3936499023437500e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.4054100036621094e+02 -2.7949099731445312e+02 1.4916099309921265e+00 2.4061900329589844e+02 -2.6950698852539062e+02 1.6363799571990967e+00 2.3981900024414062e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.4159201049804688e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.4181100463867188e+02 -2.6950698852539062e+02 1.5978199243545532e+00 2.3468499755859375e+02 -2.6950000000000000e+02 1.4123899936676025e+00 2.3336500549316406e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.3276800537109375e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.3254899597167969e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.3559199523925781e+02 -2.6950000000000000e+02 -8.1545400619506836e-01 2.3276800537109375e+02 -2.6950000000000000e+02 -1.4123899936676025e+00 2.3336500549316406e+02 -2.6953302001953125e+02 -1.6360900402069092e+00 2.3454100036621094e+02 -2.6950000000000000e+02 8.1545400619506836e-01 2.3559199523925781e+02 -2.6950000000000000e+02 0.0000000000000000e+00 2.3581098937988281e+02 -2.7950000000000000e+02 -7.0744700431823730e+00 1.9971699523925781e+02 -2.7950701904296875e+02 -5.4948301315307617e+00 2.0006900024414062e+02 -2.7950000000000000e+02 -4.6781301498413086e+00 1.9935800170898438e+02 -2.7950000000000000e+02 -4.4772000312805176e+00 1.9860800170898438e+02 -2.7950000000000000e+02 -4.9523701667785645e+00 1.9745899963378906e+02 -2.7950000000000000e+02 -6.4595298767089844e+00 1.9714599609375000e+02 -2.7950000000000000e+02 -7.3600401878356934e+00 1.9801400756835938e+02 -2.7950097656250000e+02 -1.2145899772644043e+01 2.0138800048828125e+02 -2.7950097656250000e+02 -1.0942299842834473e+01 2.0108399963378906e+02 -2.7950000000000000e+02 -1.0332800865173340e+01 1.9988099670410156e+02 -2.7950000000000000e+02 -1.0807899475097656e+01 1.9873300170898438e+02 -2.7950000000000000e+02 -1.2315099716186523e+01 1.9841900634765625e+02 -2.7950000000000000e+02 -1.8746400833129883e+01 2.0272499084472656e+02 -2.7950000000000000e+02 -1.7760601043701172e+01 2.0348300170898438e+02 -2.7951199340820312e+02 -1.6311201095581055e+01 2.0088800048828125e+02 -2.7950000000000000e+02 -1.7447401046752930e+01 2.0047500610351562e+02 -2.7950000000000000e+02 -1.8623399734497070e+01 2.0097000122070312e+02 -2.7950000000000000e+02 -2.4005899429321289e+01 2.0409700012207031e+02 -2.7950097656250000e+02 -2.3189300537109375e+01 2.0338598632812500e+02 -2.7950000000000000e+02 -2.1956899642944336e+01 2.0354800415039062e+02 -2.7950000000000000e+02 -2.1245000839233398e+01 2.0436500549316406e+02 -2.7950399780273438e+02 -2.1558198928833008e+01 2.0587199401855469e+02 -2.7950799560546875e+02 -2.3019998550415039e+01 2.0635400390625000e+02 -2.7950601196289062e+02 -2.4168699264526367e+01 2.0533000183105469e+02 -2.7950000000000000e+02 -2.9011299133300781e+01 2.0812500000000000e+02 -2.7950097656250000e+02 -2.7986499786376953e+01 2.0697698974609375e+02 -2.7950097656250000e+02 -2.6479400634765625e+01 2.0728999328613281e+02 -2.7950000000000000e+02 -2.6004100799560547e+01 2.0843901062011719e+02 -2.7950500488281250e+02 -2.6355499267578125e+01 2.0946299743652344e+02 -2.7950201416015625e+02 -2.8194601058959961e+01 2.0989399719238281e+02 -2.7950000000000000e+02 -3.3204101562500000e+01 2.1314799499511719e+02 -2.7950000000000000e+02 -3.2491401672363281e+01 2.1397499084472656e+02 -2.7950000000000000e+02 -3.1390298843383789e+01 2.1414799499511719e+02 -2.7950000000000000e+02 -3.0442399978637695e+01 2.1342599487304688e+02 -2.7950000000000000e+02 -3.0279598236083984e+01 2.1219299316406250e+02 -2.7950000000000000e+02 -3.1428298950195312e+01 2.1116900634765625e+02 -2.7950097656250000e+02 -3.2890098571777344e+01 2.1165100097656250e+02 -2.7950000000000000e+02 -3.6481300354003906e+01 2.1644799804687500e+02 -2.7950000000000000e+02 -3.5019401550292969e+01 2.1596600341796875e+02 -2.7950000000000000e+02 -3.4033599853515625e+01 2.1672299194335938e+02 -2.7950000000000000e+02 -3.3825401306152344e+01 2.1778599548339844e+02 -2.7950000000000000e+02 -3.4582599639892578e+01 2.1877198791503906e+02 -2.7950097656250000e+02 -3.5645801544189453e+01 2.1897999572753906e+02 -2.7950000000000000e+02 -3.6794498443603516e+01 2.1795498657226562e+02 -2.7950097656250000e+02 -7.0435400009155273e+00 2.0576899719238281e+02 -2.7950000000000000e+02 -5.9253602027893066e+00 2.0617100524902344e+02 -2.7950299072265625e+02 -4.7767200469970703e+00 2.0569599914550781e+02 -2.7950000000000000e+02 -4.4634900093078613e+00 2.0418899536132812e+02 -2.7950097656250000e+02 -5.6121897697448730e+00 2.0316400146484375e+02 -2.7950000000000000e+02 -7.0991501808166504e+00 2.0366799926757812e+02 -2.7950000000000000e+02 -3.9503601074218750e+01 2.2348300170898438e+02 -2.7950000000000000e+02 -3.8204597473144531e+01 2.2423699951171875e+02 -2.7950000000000000e+02 -3.6905502319335938e+01 2.2348300170898438e+02 -2.7950000000000000e+02 -3.6742698669433594e+01 2.2225000000000000e+02 -2.7950000000000000e+02 -3.7891399383544922e+01 2.2122499084472656e+02 -2.7950000000000000e+02 -3.8954498291015625e+01 2.2143399047851562e+02 -2.7950097656250000e+02 -3.9711700439453125e+01 2.2241899108886719e+02 -2.7950000000000000e+02 -1.2988200187683105e+01 2.0688099670410156e+02 -2.7950097656250000e+02 -1.2002299308776855e+01 2.0763800048828125e+02 -2.7950000000000000e+02 -1.0858699798583984e+01 2.0737400817871094e+02 -2.7950000000000000e+02 -1.0189199447631836e+01 2.0613099670410156e+02 -2.7950000000000000e+02 -1.0664299964904785e+01 2.0498199462890625e+02 -2.7950000000000000e+02 -1.2171600341796875e+01 2.0466900634765625e+02 -2.7950000000000000e+02 -4.1805900573730469e+01 2.2803401184082031e+02 -2.7950000000000000e+02 -4.1048702239990234e+01 2.2704798889160156e+02 -2.7950000000000000e+02 -4.0298698425292969e+01 2.2684700012207031e+02 -2.7950000000000000e+02 -3.9548698425292969e+01 2.2704798889160156e+02 -2.7950201416015625e+02 -3.8836799621582031e+01 2.2786499023437500e+02 -2.7950097656250000e+02 -3.9150001525878906e+01 2.2937199401855469e+02 -2.7950000000000000e+02 -4.0611801147460938e+01 2.2985400390625000e+02 -2.7950000000000000e+02 -4.1597702026367188e+01 2.2909700012207031e+02 -2.7950201416015625e+02 -1.8641199111938477e+01 2.0820599365234375e+02 -2.7950601196289062e+02 -1.7616498947143555e+01 2.0705700683593750e+02 -2.7951498413085938e+02 -1.6109399795532227e+01 2.0736999511718750e+02 -2.7950000000000000e+02 -1.5634100914001465e+01 2.0851899719238281e+02 -2.7952200317382812e+02 -1.5985600471496582e+01 2.0954299926757812e+02 -2.7950000000000000e+02 -1.7134099960327148e+01 2.1001901245117188e+02 -2.7950799560546875e+02 -1.8158800125122070e+01 2.0966799926757812e+02 -2.7950097656250000e+02 -4.2721099853515625e+01 2.3317800903320312e+02 -2.7950000000000000e+02 -4.1572498321533203e+01 2.3270300292968750e+02 -2.7950000000000000e+02 -4.0547698974609375e+01 2.3305400085449219e+02 -2.7950097656250000e+02 -4.0065299987792969e+01 2.3451599121093750e+02 -2.7950000000000000e+02 -4.1090099334716797e+01 2.3566499328613281e+02 -2.7950000000000000e+02 -4.2322399139404297e+01 2.3550199890136719e+02 -2.7950000000000000e+02 -4.3034301757812500e+01 2.3468499755859375e+02 -2.7950201416015625e+02 -2.3618801116943359e+01 2.1145799255371094e+02 -2.7951199340820312e+02 -2.2593999862670898e+01 2.1030900573730469e+02 -2.7950000000000000e+02 -2.1361600875854492e+01 2.1047200012207031e+02 -2.7950000000000000e+02 -2.0649799346923828e+01 2.1128800964355469e+02 -2.7950701904296875e+02 -2.0962999343872070e+01 2.1279600524902344e+02 -2.7950000000000000e+02 -2.2111700057983398e+01 2.1327101135253906e+02 -2.7950701904296875e+02 -2.3136400222778320e+01 2.1291999816894531e+02 -2.7950097656250000e+02 -4.3507198333740234e+01 2.3986700439453125e+02 -2.7950000000000000e+02 -4.2750000000000000e+01 2.3888101196289062e+02 -2.7950000000000000e+02 -4.2000000000000000e+01 2.3868000793457031e+02 -2.7950097656250000e+02 -4.0975101470947266e+01 2.3903100585937500e+02 -2.7950000000000000e+02 -4.0500000000000000e+01 2.4018000793457031e+02 -2.7950097656250000e+02 -4.0851299285888672e+01 2.4120500183105469e+02 -2.7950000000000000e+02 -4.2000000000000000e+01 2.4167999267578125e+02 -2.7950000000000000e+02 -4.2750000000000000e+01 2.4147898864746094e+02 -2.7950000000000000e+02 -4.3298999786376953e+01 2.4093000793457031e+02 -2.7950201416015625e+02 -2.7634700775146484e+01 2.1477299499511719e+02 -2.7950000000000000e+02 -2.6172800064086914e+01 2.1429100036621094e+02 -2.7950201416015625e+02 -2.5024200439453125e+01 2.1531599426269531e+02 -2.7950097656250000e+02 -2.5337299346923828e+01 2.1682299804687500e+02 -2.7950000000000000e+02 -2.6486000061035156e+01 2.1729800415039062e+02 -2.7950000000000000e+02 -2.7510900497436523e+01 2.1694599914550781e+02 -2.7950000000000000e+02 -2.7986000061035156e+01 2.1579800415039062e+02 -2.7950000000000000e+02 -4.2721099853515625e+01 2.4513200378417969e+02 -2.7950000000000000e+02 -4.1259300231933594e+01 2.4465000915527344e+02 -2.7950000000000000e+02 -4.0273399353027344e+01 2.4540699768066406e+02 -2.7950000000000000e+02 -4.0065299987792969e+01 2.4647000122070312e+02 -2.7950000000000000e+02 -4.0822498321533203e+01 2.4745599365234375e+02 -2.7950000000000000e+02 -4.1885700225830078e+01 2.4766400146484375e+02 -2.7950000000000000e+02 -4.3034301757812500e+01 2.4663999938964844e+02 -2.7950000000000000e+02 -3.1645200729370117e+01 2.2017700195312500e+02 -2.7950000000000000e+02 -3.0620399475097656e+01 2.1902799987792969e+02 -2.7950000000000000e+02 -2.9113199234008789e+01 2.1934098815917969e+02 -2.7950097656250000e+02 -2.8630800247192383e+01 2.2080299377441406e+02 -2.7950000000000000e+02 -2.9655599594116211e+01 2.2195201110839844e+02 -2.7950000000000000e+02 -3.1162799835205078e+01 2.2163900756835938e+02 -2.7950097656250000e+02 -4.1447402954101562e+01 2.5098800659179688e+02 -2.7950000000000000e+02 -3.9985500335693359e+01 2.5050601196289062e+02 -2.7950000000000000e+02 -3.8836799621582031e+01 2.5152999877929688e+02 -2.7950000000000000e+02 -3.8999599456787109e+01 2.5276300048828125e+02 -2.7950000000000000e+02 -3.9548698425292969e+01 2.5331199645996094e+02 -2.7950000000000000e+02 -4.0298698425292969e+01 2.5351301574707031e+02 -2.7950000000000000e+02 -4.1323501586914062e+01 2.5316101074218750e+02 -2.7950000000000000e+02 -4.1798698425292969e+01 2.5201300048828125e+02 -2.7950201416015625e+02 -3.4116500854492188e+01 2.2469400024414062e+02 -2.7950000000000000e+02 -3.2967800140380859e+01 2.2421899414062500e+02 -2.7950000000000000e+02 -3.1943000793457031e+01 2.2457000732421875e+02 -2.7950000000000000e+02 -3.1467798233032227e+01 2.2571900939941406e+02 -2.7950097656250000e+02 -3.1819101333618164e+01 2.2674400329589844e+02 -2.7950000000000000e+02 -3.3280998229980469e+01 2.2722599792480469e+02 -2.7950000000000000e+02 -3.4429698944091797e+01 2.2620100402832031e+02 -2.7950000000000000e+02 -4.3396296501159668e+00 2.1105700683593750e+02 -2.7950000000000000e+02 -5.4010701179504395e+00 2.0924900817871094e+02 -2.7950000000000000e+02 -6.9910302162170410e+00 2.0972500610351562e+02 -2.7950701904296875e+02 -6.8774199485778809e+00 2.1190499877929688e+02 -2.7950097656250000e+02 -5.3703198432922363e+00 2.1221800231933594e+02 -2.7950000000000000e+02 -3.6905502319335938e+01 2.5687701416015625e+02 -2.7950000000000000e+02 -3.9503601074218750e+01 2.5687701416015625e+02 -2.7950000000000000e+02 -3.9666400909423828e+01 2.5810998535156250e+02 -2.7950000000000000e+02 -3.8954498291015625e+01 2.5892700195312500e+02 -2.7950000000000000e+02 -3.7722099304199219e+01 2.5908898925781250e+02 -2.7950000000000000e+02 -3.6697299957275391e+01 2.5794100952148438e+02 -2.7950000000000000e+02 -3.3398399353027344e+01 2.3134300231933594e+02 -2.7950097656250000e+02 -3.3943298339843750e+01 2.3015600585937500e+02 -2.7950000000000000e+02 -3.5380798339843750e+01 2.2988099670410156e+02 -2.7950000000000000e+02 -3.6417598724365234e+01 2.3101599121093750e+02 -2.7950000000000000e+02 -3.6197402954101562e+01 2.3209199523925781e+02 -2.7950000000000000e+02 -3.5211601257324219e+01 2.3285000610351562e+02 -2.7950097656250000e+02 -3.3749698638916016e+01 2.3236698913574219e+02 -2.7950000000000000e+02 -1.2529299736022949e+01 2.1361799621582031e+02 -2.7950000000000000e+02 -1.1480400085449219e+01 2.1396400451660156e+02 -2.7950000000000000e+02 -1.0326600074768066e+01 2.1351200866699219e+02 -2.7950000000000000e+02 -9.9804992675781250e+00 2.1246400451660156e+02 -2.7950000000000000e+02 -1.0455699920654297e+01 2.1131500244140625e+02 -2.7950000000000000e+02 -1.1480400085449219e+01 2.1096398925781250e+02 -2.7950201416015625e+02 -1.2629099845886230e+01 2.1143899536132812e+02 -2.7950000000000000e+02 -1.2980500221252441e+01 2.1246400451660156e+02 -2.7950097656250000e+02 -3.6481300354003906e+01 2.6186199951171875e+02 -2.7950000000000000e+02 -3.5332599639892578e+01 2.6138699340820312e+02 -2.7950097656250000e+02 -3.4307800292968750e+01 2.6173800659179688e+02 -2.7950000000000000e+02 -3.3832599639892578e+01 2.6288699340820312e+02 -2.7950000000000000e+02 -3.4183898925781250e+01 2.6391198730468750e+02 -2.7950000000000000e+02 -3.5645801544189453e+01 2.6439398193359375e+02 -2.7950000000000000e+02 -3.6794498443603516e+01 2.6336898803710938e+02 -2.7950000000000000e+02 -3.7176097869873047e+01 2.3645700073242188e+02 -2.7950000000000000e+02 -3.6626998901367188e+01 2.3590800476074219e+02 -2.7950000000000000e+02 -3.5563800811767578e+01 2.3569999694824219e+02 -2.7950000000000000e+02 -3.4415199279785156e+01 2.3672500610351562e+02 -2.7950097656250000e+02 -3.4728298187255859e+01 2.3823199462890625e+02 -2.7950000000000000e+02 -3.6190200805664062e+01 2.3871398925781250e+02 -2.7950000000000000e+02 -3.7176097869873047e+01 2.3795700073242188e+02 -2.7950000000000000e+02 -3.7376998901367188e+01 2.3720700073242188e+02 -2.7950000000000000e+02 -1.5917099952697754e+01 2.1653500366210938e+02 -2.7950000000000000e+02 -1.5140199661254883e+01 2.1486500549316406e+02 -2.7950000000000000e+02 -1.5917099952697754e+01 2.1393699645996094e+02 -2.7950000000000000e+02 -1.7966098785400391e+01 2.1448600769042969e+02 -2.7950097656250000e+02 -1.8128900527954102e+01 2.1571800231933594e+02 -2.7950097656250000e+02 -1.6980199813842773e+01 2.1674301147460938e+02 -2.7950000000000000e+02 -3.0991399765014648e+01 2.6638497924804688e+02 -2.7950000000000000e+02 -3.2347702026367188e+01 2.6628802490234375e+02 -2.7950000000000000e+02 -3.3248699188232422e+01 2.6737100219726562e+02 -2.7950000000000000e+02 -3.2766300201416016e+01 2.6883300781250000e+02 -2.7950000000000000e+02 -3.1741399765014648e+01 2.6918399047851562e+02 -2.7950097656250000e+02 -3.0592800140380859e+01 2.6870901489257812e+02 -2.7950000000000000e+02 -3.0279598236083984e+01 2.6720199584960938e+02 -2.7950097656250000e+02 -3.7025699615478516e+01 2.4212800598144531e+02 -2.7950000000000000e+02 -3.5563800811767578e+01 2.4164601135253906e+02 -2.7950000000000000e+02 -3.4415199279785156e+01 2.4266999816894531e+02 -2.7950097656250000e+02 -3.4728298187255859e+01 2.4417799377441406e+02 -2.7950000000000000e+02 -3.6190200805664062e+01 2.4466000366210938e+02 -2.7950000000000000e+02 -3.7176097869873047e+01 2.4390299987792969e+02 -2.7950000000000000e+02 -3.7376998901367188e+01 2.4315299987792969e+02 -2.7950000000000000e+02 -2.2720399856567383e+01 2.1865400695800781e+02 -2.7950000000000000e+02 -2.1695600509643555e+01 2.1750498962402344e+02 -2.7950097656250000e+02 -2.0188400268554688e+01 2.1781800842285156e+02 -2.7950000000000000e+02 -1.9713201522827148e+01 2.1896701049804688e+02 -2.7950000000000000e+02 -1.9914199829101562e+01 2.1971699523925781e+02 -2.7950097656250000e+02 -2.0730800628662109e+01 2.2042900085449219e+02 -2.7950000000000000e+02 -2.2237998962402344e+01 2.2011500549316406e+02 -2.7950000000000000e+02 -2.9011299133300781e+01 2.7160800170898438e+02 -2.7950097656250000e+02 -2.7986499786376953e+01 2.7046002197265625e+02 -2.7950000000000000e+02 -2.6004100799560547e+01 2.7192199707031250e+02 -2.7950500488281250e+02 -2.6355400085449219e+01 2.7294601440429688e+02 -2.7950000000000000e+02 -2.7504098892211914e+01 2.7342098999023438e+02 -2.7950000000000000e+02 -2.8528900146484375e+01 2.7307000732421875e+02 -2.7950000000000000e+02 -3.6009597778320312e+01 2.5011900329589844e+02 -2.7950000000000000e+02 -3.4898399353027344e+01 2.5051799011230469e+02 -2.7950097656250000e+02 -3.3893802642822266e+01 2.5014099121093750e+02 -2.7950000000000000e+02 -3.3873600006103516e+01 2.4786900329589844e+02 -2.7950000000000000e+02 -3.5380798339843750e+01 2.4755599975585938e+02 -2.7950000000000000e+02 -3.6226898193359375e+01 2.4832899475097656e+02 -2.7950000000000000e+02 -2.6447198867797852e+01 2.2319099426269531e+02 -2.7950000000000000e+02 -2.5702899932861328e+01 2.2482901000976562e+02 -2.7950000000000000e+02 -2.4082300186157227e+01 2.2474899291992188e+02 -2.7950000000000000e+02 -2.3440099716186523e+01 2.2310000610351562e+02 -2.7950000000000000e+02 -2.4194101333618164e+01 2.2221400451660156e+02 -2.7950000000000000e+02 -2.5587999343872070e+01 2.2214900207519531e+02 -2.7951400756835938e+02 -2.3855400085449219e+01 2.7448800659179688e+02 -2.7950500488281250e+02 -2.2393699645996094e+01 2.7400601196289062e+02 -2.7950000000000000e+02 -2.1245000839233398e+01 2.7502999877929688e+02 -2.7950000000000000e+02 -2.1558198928833008e+01 2.7653698730468750e+02 -2.7950000000000000e+02 -2.2706899642944336e+01 2.7701300048828125e+02 -2.7950500488281250e+02 -2.3731599807739258e+01 2.7666101074218750e+02 -2.7950000000000000e+02 -2.4206899642944336e+01 2.7551300048828125e+02 -2.7950097656250000e+02 -3.4116500854492188e+01 2.5361601257324219e+02 -2.7950000000000000e+02 -3.2967800140380859e+01 2.5314099121093750e+02 -2.7950201416015625e+02 -3.1943000793457031e+01 2.5349200439453125e+02 -2.7950000000000000e+02 -3.1467798233032227e+01 2.5464099121093750e+02 -2.7950000000000000e+02 -3.1819101333618164e+01 2.5566598510742188e+02 -2.7950201416015625e+02 -3.3280998229980469e+01 2.5614801025390625e+02 -2.7950000000000000e+02 -3.4429698944091797e+01 2.5512298583984375e+02 -2.7950000000000000e+02 -2.9015399932861328e+01 2.2795001220703125e+02 -2.7950000000000000e+02 -2.8466299057006836e+01 2.2740000915527344e+02 -2.7950097656250000e+02 -2.7403200149536133e+01 2.2719200134277344e+02 -2.7950000000000000e+02 -2.6254499435424805e+01 2.2821701049804688e+02 -2.7950299072265625e+02 -2.6567699432373047e+01 2.2972399902343750e+02 -2.7950000000000000e+02 -2.8029499053955078e+01 2.3020700073242188e+02 -2.7950000000000000e+02 -2.9015399932861328e+01 2.2944900512695312e+02 -2.7950000000000000e+02 -2.9216300964355469e+01 2.2869999694824219e+02 -2.7950000000000000e+02 -1.5942700386047363e+01 2.7870300292968750e+02 -2.7950097656250000e+02 -1.6440299987792969e+01 2.7722601318359375e+02 -2.7950000000000000e+02 -1.7929800033569336e+01 2.7692300415039062e+02 -2.7950000000000000e+02 -1.8746400833129883e+01 2.7763500976562500e+02 -2.7950997924804688e+02 -1.8583599090576172e+01 2.7947198486328125e+02 -2.7951400756835938e+02 -1.6965101242065430e+01 2.7984600830078125e+02 -2.7950000000000000e+02 -3.1286600112915039e+01 2.5884500122070312e+02 -2.7950000000000000e+02 -2.9824800491333008e+01 2.5836300659179688e+02 -2.7950000000000000e+02 -2.8676099777221680e+01 2.5938800048828125e+02 -2.7950097656250000e+02 -2.8989198684692383e+01 2.6089501953125000e+02 -2.7950000000000000e+02 -3.0451099395751953e+01 2.6137701416015625e+02 -2.7950000000000000e+02 -3.1599800109863281e+01 2.6035299682617188e+02 -2.7950000000000000e+02 -3.0722499847412109e+01 2.3357699584960938e+02 -2.7950000000000000e+02 -2.9905900955200195e+01 2.3286500549316406e+02 -2.7950097656250000e+02 -2.8398799896240234e+01 2.3317900085449219e+02 -2.7950000000000000e+02 -2.7923500061035156e+01 2.3432699584960938e+02 -2.7950000000000000e+02 -2.8124500274658203e+01 2.3507699584960938e+02 -2.7950201416015625e+02 -2.8941198348999023e+01 2.3578900146484375e+02 -2.7950000000000000e+02 -3.0448398590087891e+01 2.3547599792480469e+02 -2.7950000000000000e+02 -3.0923500061035156e+01 2.3432699584960938e+02 -2.7950399780273438e+02 -6.8921999931335449e+00 2.1585301208496094e+02 -2.7950000000000000e+02 -5.4303998947143555e+00 2.1536999511718750e+02 -2.7950201416015625e+02 -4.2817001342773438e+00 2.1639500427246094e+02 -2.7950000000000000e+02 -4.4444799423217773e+00 2.1762699890136719e+02 -2.7950097656250000e+02 -5.2611799240112305e+00 2.1833898925781250e+02 -2.7950097656250000e+02 -6.7683396339416504e+00 2.1802600097656250e+02 -2.7950000000000000e+02 -7.2435698509216309e+00 2.1687699890136719e+02 -2.7950000000000000e+02 -1.0533699989318848e+01 2.7972900390625000e+02 -2.7950097656250000e+02 -1.1519599914550781e+01 2.7897097778320312e+02 -2.7950000000000000e+02 -1.2970100402832031e+01 2.7944601440429688e+02 -2.7950000000000000e+02 -1.3214200019836426e+01 2.8109298706054688e+02 -2.7950000000000000e+02 -1.2145899772644043e+01 2.8198599243164062e+02 -2.7950000000000000e+02 -1.0576399803161621e+01 2.8139300537109375e+02 -2.7950097656250000e+02 -2.7401401519775391e+01 2.6323599243164062e+02 -2.7950097656250000e+02 -2.5461200714111328e+01 2.6341302490234375e+02 -2.7950000000000000e+02 -2.4986000061035156e+01 2.6456201171875000e+02 -2.7951498413085938e+02 -2.5337499618530273e+01 2.6558700561523438e+02 -2.7950299072265625e+02 -2.6799301147460938e+01 2.6606900024414062e+02 -2.7950000000000000e+02 -2.7947900772094727e+01 2.6504498291015625e+02 -2.7950000000000000e+02 -3.1298997879028320e+01 2.3942999267578125e+02 -2.7950201416015625e+02 -3.0482299804687500e+01 2.3871800231933594e+02 -2.7950000000000000e+02 -2.8975099563598633e+01 2.3903100585937500e+02 -2.7950000000000000e+02 -2.8500000000000000e+01 2.4018000793457031e+02 -2.7950000000000000e+02 -2.8851301193237305e+01 2.4120500183105469e+02 -2.7950000000000000e+02 -3.0313100814819336e+01 2.4168699645996094e+02 -2.7950000000000000e+02 -3.1461801528930664e+01 2.4066198730468750e+02 -2.7950000000000000e+02 -1.2759099960327148e+01 2.1905900573730469e+02 -2.7950097656250000e+02 -1.1635700225830078e+01 2.1746699523925781e+02 -2.7950000000000000e+02 -1.0403299331665039e+01 2.1763000488281250e+02 -2.7950097656250000e+02 -9.6914796829223633e+00 2.1844700622558594e+02 -2.7950000000000000e+02 -9.8543205261230469e+00 2.1967900085449219e+02 -2.7950000000000000e+02 -1.0670900344848633e+01 2.2039100646972656e+02 -2.7950000000000000e+02 -1.1903300285339355e+01 2.2022799682617188e+02 -2.7950000000000000e+02 -7.0744700431823730e+00 2.8286199951171875e+02 -2.7950000000000000e+02 -5.4947700500488281e+00 2.8321398925781250e+02 -2.7950000000000000e+02 -4.4699897766113281e+00 2.8206597900390625e+02 -2.7950000000000000e+02 -4.6781301498413086e+00 2.8100201416015625e+02 -2.7950000000000000e+02 -5.6641101837158203e+00 2.8024499511718750e+02 -2.7950201416015625e+02 -7.2015500068664551e+00 2.8080499267578125e+02 -2.7950500488281250e+02 -2.3260299682617188e+01 2.6756399536132812e+02 -2.7950097656250000e+02 -2.1798500061035156e+01 2.6708200073242188e+02 -2.7950000000000000e+02 -2.0812601089477539e+01 2.6783901977539062e+02 -2.7950201416015625e+02 -2.0604400634765625e+01 2.6890200805664062e+02 -2.7954098510742188e+02 -2.1981800079345703e+01 2.7019400024414062e+02 -2.7950201416015625e+02 -2.3573499679565430e+01 2.6907101440429688e+02 -2.7950000000000000e+02 -3.0722499847412109e+01 2.4528298950195312e+02 -2.7950097656250000e+02 -2.9905900955200195e+01 2.4457099914550781e+02 -2.7950000000000000e+02 -2.8398700714111328e+01 2.4488400268554688e+02 -2.7950097656250000e+02 -2.7916399002075195e+01 2.4634599304199219e+02 -2.7950000000000000e+02 -2.8673500061035156e+01 2.4733200073242188e+02 -2.7950000000000000e+02 -2.9736700057983398e+01 2.4753999328613281e+02 -2.7950000000000000e+02 -3.0722499847412109e+01 2.4678300476074219e+02 -2.7950000000000000e+02 -3.0923500061035156e+01 2.4603300476074219e+02 -2.7951800537109375e+02 -1.5438699722290039e+01 2.2369700622558594e+02 -2.7950000000000000e+02 -1.4881099700927734e+01 2.2108000183105469e+02 -2.7950000000000000e+02 -1.6479499816894531e+01 2.2080400085449219e+02 -2.7950000000000000e+02 -1.7422100067138672e+01 2.2190299987792969e+02 -2.7950000000000000e+02 -1.6939699172973633e+01 2.2336399841308594e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.8142999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.8088098144531250e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.8067999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.8088098144531250e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.8142999267578125e+02 -2.7950000000000000e+02 1.5071600675582886e+00 2.8249298095703125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.8347900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.8367999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.8347900390625000e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.8266201782226562e+02 -2.7950799560546875e+02 -1.8282699584960938e+01 2.7081600952148438e+02 -2.7952099609375000e+02 -1.6821001052856445e+01 2.7033401489257812e+02 -2.7950000000000000e+02 -1.5835000038146973e+01 2.7109100341796875e+02 -2.7950000000000000e+02 -1.5626899719238281e+01 2.7215399169921875e+02 -2.7950701904296875e+02 -1.6651699066162109e+01 2.7330300903320312e+02 -2.7950000000000000e+02 -1.7884099960327148e+01 2.7314001464843750e+02 -2.7950000000000000e+02 -1.8595899581909180e+01 2.7232299804687500e+02 -2.7950097656250000e+02 -2.8864999771118164e+01 2.5063601684570312e+02 -2.7950000000000000e+02 -2.7716299057006836e+01 2.5016099548339844e+02 -2.7950299072265625e+02 -2.6691600799560547e+01 2.5051200866699219e+02 -2.7950000000000000e+02 -2.6209199905395508e+01 2.5197398376464844e+02 -2.7950097656250000e+02 -2.7233900070190430e+01 2.5312200927734375e+02 -2.7950000000000000e+02 -2.8466299057006836e+01 2.5295999145507812e+02 -2.7950000000000000e+02 -2.9015399932861328e+01 2.5241101074218750e+02 -2.7950000000000000e+02 -2.9216300964355469e+01 2.5165998840332031e+02 -2.7950097656250000e+02 -2.0076398849487305e+01 2.2804800415039062e+02 -2.7950097656250000e+02 -1.8282100677490234e+01 2.2717300415039062e+02 -2.7950000000000000e+02 -1.8641799926757812e+01 2.2552099609375000e+02 -2.7950000000000000e+02 -1.9751600265502930e+01 2.2504598999023438e+02 -2.7950097656250000e+02 -2.0900299072265625e+01 2.2552200317382812e+02 -2.7950000000000000e+02 -2.1213499069213867e+01 2.2702899169921875e+02 -2.7950000000000000e+02 4.6781301498413086e+00 2.8100201416015625e+02 -2.7950000000000000e+02 5.4948301315307617e+00 2.8029098510742188e+02 -2.7952099609375000e+02 7.0018200874328613e+00 2.8060400390625000e+02 -2.7950299072265625e+02 7.4843802452087402e+00 2.8206597900390625e+02 -2.7950000000000000e+02 6.4595899581909180e+00 2.8321398925781250e+02 -2.7950000000000000e+02 5.2272100448608398e+00 2.8305200195312500e+02 -2.7950000000000000e+02 4.5153498649597168e+00 2.8223498535156250e+02 -2.7950000000000000e+02 -1.0207599639892578e+01 2.7375299072265625e+02 -2.7950000000000000e+02 -1.1376000404357910e+01 2.7272201538085938e+02 -2.7950000000000000e+02 -1.2824599266052246e+01 2.7319601440429688e+02 -2.7950000000000000e+02 -1.3098499298095703e+01 2.7479800415039062e+02 -2.7950097656250000e+02 -1.2002299308776855e+01 2.7573699951171875e+02 -2.7950000000000000e+02 -1.0540500640869141e+01 2.7525399780273438e+02 -2.7950000000000000e+02 -2.4194101333618164e+01 2.5814599609375000e+02 -2.7950000000000000e+02 -2.3440898895263672e+01 2.5716900634765625e+02 -2.7950000000000000e+02 -2.5471899032592773e+01 2.5536399841308594e+02 -2.7950000000000000e+02 -2.6448101043701172e+01 2.5726000976562500e+02 -2.7950000000000000e+02 -2.5535099029541016e+01 2.5822201538085938e+02 -2.7950000000000000e+02 -2.0940401077270508e+01 2.3166899108886719e+02 -2.7950000000000000e+02 -2.1635700225830078e+01 2.3039999389648438e+02 -2.7950000000000000e+02 -2.2995500564575195e+01 2.3022399902343750e+02 -2.7950000000000000e+02 -2.3951000213623047e+01 2.3207199096679688e+02 -2.7950000000000000e+02 -2.3190399169921875e+01 2.3296899414062500e+02 -2.7950000000000000e+02 -2.2440399169921875e+01 2.3316900634765625e+02 -2.7950000000000000e+02 -2.1291698455810547e+01 2.3269400024414062e+02 -2.7950000000000000e+02 1.2582699775695801e+01 2.8177801513671875e+02 -2.7950000000000000e+02 1.2250200271606445e+01 2.7896899414062500e+02 -2.7950097656250000e+02 1.0695399284362793e+01 2.7944601440429688e+02 -2.7950000000000000e+02 1.0451299667358398e+01 2.8109298706054688e+02 -2.7950000000000000e+02 1.1519599914550781e+01 2.8198599243164062e+02 -2.7950000000000000e+02 -7.0435400009155273e+00 2.7678701782226562e+02 -2.7950097656250000e+02 -5.4429802894592285e+00 2.7715100097656250e+02 -2.7950000000000000e+02 -4.4181900024414062e+00 2.7600198364257812e+02 -2.7950299072265625e+02 -4.9005699157714844e+00 2.7454000854492188e+02 -2.7950399780273438e+02 -6.4076800346374512e+00 2.7422698974609375e+02 -2.7950000000000000e+02 -7.2417798042297363e+00 2.7497299194335938e+02 -2.7950000000000000e+02 -2.2720399856567383e+01 2.6107998657226562e+02 -2.7950000000000000e+02 -2.1963199615478516e+01 2.6009399414062500e+02 -2.7950000000000000e+02 -2.0899999618530273e+01 2.5988598632812500e+02 -2.7950000000000000e+02 -1.9914199829101562e+01 2.6064300537109375e+02 -2.7950000000000000e+02 -1.9713201522827148e+01 2.6139300537109375e+02 -2.7950000000000000e+02 -1.9914199829101562e+01 2.6214297485351562e+02 -2.7950000000000000e+02 -2.0730800628662109e+01 2.6285498046875000e+02 -2.7950097656250000e+02 -2.2237998962402344e+01 2.6254202270507812e+02 -2.7950000000000000e+02 -2.5284700393676758e+01 2.3779701232910156e+02 -2.7950000000000000e+02 -2.3826099395751953e+01 2.3878700256347656e+02 -2.7950000000000000e+02 -2.2676300048828125e+01 2.3831201171875000e+02 -2.7950000000000000e+02 -2.2363100051879883e+01 2.3680500793457031e+02 -2.7950201416015625e+02 -2.3853101730346680e+01 2.3570199584960938e+02 -2.7950000000000000e+02 -2.5124000549316406e+01 2.3653698730468750e+02 -2.7950097656250000e+02 1.8454500198364258e+01 2.7722601318359375e+02 -2.7950000000000000e+02 1.6965000152587891e+01 2.7692300415039062e+02 -2.7950000000000000e+02 1.6148399353027344e+01 2.7763500976562500e+02 -2.7950000000000000e+02 1.6146200180053711e+01 2.7913098144531250e+02 -2.7950399780273438e+02 1.7134201049804688e+01 2.7989199829101562e+02 -2.7950000000000000e+02 1.8596099853515625e+01 2.7940899658203125e+02 -2.7950000000000000e+02 -1.5071600675582886e+00 2.7586697387695312e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.7488101196289062e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.7467999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.7488101196289062e+02 -2.7950097656250000e+02 1.4617999792098999e+00 2.7569799804687500e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.7692999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.7747900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.7768002319335938e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.7747900390625000e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.7692999267578125e+02 -2.7950000000000000e+02 -1.6307100296020508e+01 2.6665899658203125e+02 -2.7950000000000000e+02 -1.7966098785400391e+01 2.6587399291992188e+02 -2.7950000000000000e+02 -1.5140199661254883e+01 2.6475302124023438e+02 -2.7950000000000000e+02 -1.7417098999023438e+01 2.6382501220703125e+02 -2.7950000000000000e+02 -1.8174299240112305e+01 2.6481100463867188e+02 -2.7950097656250000e+02 -2.4225999832153320e+01 2.4458200073242188e+02 -2.7950000000000000e+02 -2.3074998855590820e+01 2.4437199401855469e+02 -2.7950000000000000e+02 -2.2317800521850586e+01 2.4338600158691406e+02 -2.7950097656250000e+02 -2.2800199508666992e+01 2.4192399597167969e+02 -2.7950097656250000e+02 -2.4240499496459961e+01 2.4160600280761719e+02 -2.7950000000000000e+02 -2.5294700622558594e+01 2.4345600891113281e+02 -2.7950000000000000e+02 -6.6008601188659668e+00 2.2421299743652344e+02 -2.7950000000000000e+02 -5.2291202545166016e+00 2.2453500366210938e+02 -2.7950000000000000e+02 -4.2632198333740234e+00 2.2381100463867188e+02 -2.7950000000000000e+02 -4.1004400253295898e+00 2.2257901000976562e+02 -2.7950000000000000e+02 -4.8123002052307129e+00 2.2176200866699219e+02 -2.7950097656250000e+02 -6.0446796417236328e+00 2.2159899902343750e+02 -2.7950097656250000e+02 -7.0694699287414551e+00 2.2274800109863281e+02 -2.7950000000000000e+02 2.1407800674438477e+01 2.7476300048828125e+02 -2.7950201416015625e+02 2.2224500656127930e+01 2.7405102539062500e+02 -2.7950000000000000e+02 2.3456899642944336e+01 2.7421398925781250e+02 -2.7950097656250000e+02 2.3855600357055664e+01 2.7653698730468750e+02 -2.7950000000000000e+02 2.2393699645996094e+01 2.7702001953125000e+02 -2.7950000000000000e+02 2.1245100021362305e+01 2.7599499511718750e+02 -2.7950299072265625e+02 4.7767200469970703e+00 2.7466400146484375e+02 -2.7950000000000000e+02 5.9253602027893066e+00 2.7418899536132812e+02 -2.7951300048828125e+02 6.9501399993896484e+00 2.7454098510742188e+02 -2.7950000000000000e+02 7.4325799942016602e+00 2.7600198364257812e+02 -2.7950000000000000e+02 6.6753597259521484e+00 2.7698800659179688e+02 -2.7950097656250000e+02 5.6121897697448730e+00 2.7719598388671875e+02 -2.7950000000000000e+02 4.4635500907897949e+00 2.7617098999023438e+02 -2.7950299072265625e+02 -1.2629099845886230e+01 2.6687197875976562e+02 -2.7950000000000000e+02 -1.1480400085449219e+01 2.6639599609375000e+02 -2.7950201416015625e+02 -1.0455699920654297e+01 2.6674801635742188e+02 -2.7950000000000000e+02 -9.9732904434204102e+00 2.6820999145507812e+02 -2.7950097656250000e+02 -1.0998100280761719e+01 2.6935800170898438e+02 -2.7950000000000000e+02 -1.2230499267578125e+01 2.6919497680664062e+02 -2.7950000000000000e+02 -1.2942299842834473e+01 2.6837899780273438e+02 -2.7950000000000000e+02 -2.3739398956298828e+01 2.4944099426269531e+02 -2.7950000000000000e+02 -2.2753499984741211e+01 2.5019801330566406e+02 -2.7950000000000000e+02 -2.1614500045776367e+01 2.4993699645996094e+02 -2.7950000000000000e+02 -2.0929800033569336e+01 2.4828800964355469e+02 -2.7950201416015625e+02 -2.2127199172973633e+01 2.4718299865722656e+02 -2.7950299072265625e+02 -2.3733800888061523e+01 2.4781799316406250e+02 -2.7950201416015625e+02 -1.1728799819946289e+01 2.2459300231933594e+02 -2.7950000000000000e+02 -1.0580100059509277e+01 2.2411799621582031e+02 -2.7950000000000000e+02 -9.8301200866699219e+00 2.2431900024414062e+02 -2.7950000000000000e+02 -9.0728998184204102e+00 2.2593099975585938e+02 -2.7950000000000000e+02 -1.0097700119018555e+01 2.2707901000976562e+02 -2.7950000000000000e+02 -1.1330100059509277e+01 2.2691699218750000e+02 -2.7950000000000000e+02 -1.2041999816894531e+01 2.2609999084472656e+02 -2.7950097656250000e+02 2.6355400085449219e+01 2.7089700317382812e+02 -2.7950000000000000e+02 2.7504098892211914e+01 2.7042199707031250e+02 -2.7950997924804688e+02 2.8528800964355469e+01 2.7077297973632812e+02 -2.7950000000000000e+02 2.9004100799560547e+01 2.7192199707031250e+02 -2.7950900268554688e+02 2.8652700424194336e+01 2.7294601440429688e+02 -2.7950097656250000e+02 2.7190999984741211e+01 2.7342901611328125e+02 -2.7950000000000000e+02 2.6042299270629883e+01 2.7240399169921875e+02 -2.7950000000000000e+02 1.2828299522399902e+01 2.7526101684570312e+02 -2.7950000000000000e+02 1.3189099311828613e+01 2.7422900390625000e+02 -2.7950000000000000e+02 1.2456399917602539e+01 2.7294000244140625e+02 -2.7950000000000000e+02 1.1131199836730957e+01 2.7278500366210938e+02 -2.7950000000000000e+02 1.0189199447631836e+01 2.7422900390625000e+02 -2.7950000000000000e+02 1.0664299964904785e+01 2.7537799072265625e+02 -2.7950000000000000e+02 1.1689100265502930e+01 2.7572900390625000e+02 -2.7950000000000000e+02 -7.3274998664855957e+00 2.7008200073242188e+02 -2.7950201416015625e+02 -6.1658601760864258e+00 2.7111102294921875e+02 -2.7950000000000000e+02 -4.7143101692199707e+00 2.7063598632812500e+02 -2.7950000000000000e+02 -4.4190902709960938e+00 2.6907501220703125e+02 -2.7950000000000000e+02 -5.5395402908325195e+00 2.6809600830078125e+02 -2.7950399780273438e+02 -7.0013399124145508e+00 2.6857901000976562e+02 -2.7950000000000000e+02 -1.9001600265502930e+01 2.5511300659179688e+02 -2.7950000000000000e+02 -1.8244400024414062e+01 2.5412699890136719e+02 -2.7950000000000000e+02 -1.8734001159667969e+01 2.5265399169921875e+02 -2.7950000000000000e+02 -2.0478799819946289e+01 2.5250100708007812e+02 -2.7950000000000000e+02 -2.1258798599243164e+01 2.5350001525878906e+02 -2.7950097656250000e+02 -2.0745199203491211e+01 2.5500000000000000e+02 -2.7950000000000000e+02 -1.4562300682067871e+01 2.3109999084472656e+02 -2.7950000000000000e+02 -1.3812299728393555e+01 2.3089900207519531e+02 -2.7950000000000000e+02 -1.3055100440979004e+01 2.2991299438476562e+02 -2.7950097656250000e+02 -1.3921899795532227e+01 2.2810200500488281e+02 -2.7950000000000000e+02 -1.5861300468444824e+01 2.2885000610351562e+02 -2.7950097656250000e+02 -1.6034700393676758e+01 2.2994900512695312e+02 -2.7950097656250000e+02 3.0629899978637695e+01 2.6659100341796875e+02 -2.7950399780273438e+02 3.0279598236083984e+01 2.6816699218750000e+02 -2.7950097656250000e+02 3.1428298950195312e+01 2.6919100952148438e+02 -2.7950097656250000e+02 3.2890098571777344e+01 2.6870901489257812e+02 -2.7950000000000000e+02 3.3203300476074219e+01 2.6720199584960938e+02 -2.7950201416015625e+02 1.5985399246215820e+01 2.7081600952148438e+02 -2.7950000000000000e+02 1.7134099960327148e+01 2.7034100341796875e+02 -2.7950799560546875e+02 1.8158800125122070e+01 2.7069198608398438e+02 -2.7950201416015625e+02 1.8641199111938477e+01 2.7215399169921875e+02 -2.7950299072265625e+02 1.7616498947143555e+01 2.7330300903320312e+02 -2.7950000000000000e+02 1.6109300613403320e+01 2.7298999023437500e+02 -2.7950000000000000e+02 1.5634100914001465e+01 2.7184100341796875e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.7092999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.7147900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.7167999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.7147900390625000e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.7092999267578125e+02 -2.7950000000000000e+02 1.2998600006103516e+00 2.6943099975585938e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.6888098144531250e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.6867999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.6888098144531250e+02 -2.7950097656250000e+02 -1.4783099889755249e+00 2.6980599975585938e+02 -2.7950097656250000e+02 -1.4407799720764160e+01 2.5845700073242188e+02 -2.7950997924804688e+02 -1.6900299072265625e+01 2.5689599609375000e+02 -2.7950000000000000e+02 -1.7376798629760742e+01 2.5862698364257812e+02 -2.7950000000000000e+02 -1.6403099060058594e+01 2.5956799316406250e+02 -2.7950000000000000e+02 -1.8267700195312500e+01 2.3359300231933594e+02 -2.7950299072265625e+02 -1.6805799484252930e+01 2.3311099243164062e+02 -2.7950000000000000e+02 -1.5820000648498535e+01 2.3386799621582031e+02 -2.7950000000000000e+02 -1.5619000434875488e+01 2.3461799621582031e+02 -2.7950000000000000e+02 -1.5820000648498535e+01 2.3536799621582031e+02 -2.7950201416015625e+02 -1.6636600494384766e+01 2.3607901000976562e+02 -2.7950000000000000e+02 -1.7868999481201172e+01 2.3591700744628906e+02 -2.7950000000000000e+02 -1.8580900192260742e+01 2.3510000610351562e+02 -2.7950000000000000e+02 3.4183898925781250e+01 2.6186199951171875e+02 -2.7950097656250000e+02 3.5645702362060547e+01 2.6137997436523438e+02 -2.7950000000000000e+02 3.6794498443603516e+01 2.6240499877929688e+02 -2.7950000000000000e+02 3.6631599426269531e+01 2.6363699340820312e+02 -2.7950000000000000e+02 3.5815002441406250e+01 2.6434899902343750e+02 -2.7950000000000000e+02 3.4307800292968750e+01 2.6403601074218750e+02 -2.7950000000000000e+02 3.3832599639892578e+01 2.6288699340820312e+02 -2.7950500488281250e+02 2.0962999343872070e+01 2.6756399536132812e+02 -2.7950000000000000e+02 2.2424800872802734e+01 2.6708200073242188e+02 -2.7950000000000000e+02 2.3573499679565430e+01 2.6810699462890625e+02 -2.7950097656250000e+02 2.3260299682617188e+01 2.6961401367187500e+02 -2.7950000000000000e+02 2.2111700057983398e+01 2.7008898925781250e+02 -2.7950799560546875e+02 2.1086898803710938e+01 2.6973797607421875e+02 -2.7950000000000000e+02 2.0611598968505859e+01 2.6858898925781250e+02 -2.7950000000000000e+02 4.3526902198791504e+00 2.6960400390625000e+02 -2.7950000000000000e+02 6.3818101882934570e+00 2.7105798339843750e+02 -2.7950000000000000e+02 7.3696398735046387e+00 2.6921200561523438e+02 -2.7950299072265625e+02 6.1658000946044922e+00 2.6809600830078125e+02 -2.7950000000000000e+02 4.7039999961853027e+00 2.6857901000976562e+02 -2.7950097656250000e+02 -1.2759099960327148e+01 2.6156100463867188e+02 -2.7950000000000000e+02 -1.1903300285339355e+01 2.6013201904296875e+02 -2.7950097656250000e+02 -1.0840100288391113e+01 2.5992398071289062e+02 -2.7950000000000000e+02 -9.6914796829223633e+00 2.6094897460937500e+02 -2.7950097656250000e+02 -1.0004599571228027e+01 2.6245599365234375e+02 -2.7950000000000000e+02 -1.1153300285339355e+01 2.6293099975585938e+02 -2.7950000000000000e+02 -1.1903300285339355e+01 2.6273001098632812e+02 -2.7950000000000000e+02 -1.9298999786376953e+01 2.3942999267578125e+02 -2.7950000000000000e+02 -1.8750000000000000e+01 2.3888101196289062e+02 -2.7950097656250000e+02 -1.7686800003051758e+01 2.3867300415039062e+02 -2.7950000000000000e+02 -1.6700899124145508e+01 2.3942999267578125e+02 -2.7950000000000000e+02 -1.6500000000000000e+01 2.4018000793457031e+02 -2.7950000000000000e+02 -1.6700899124145508e+01 2.4093000793457031e+02 -2.7950097656250000e+02 -1.7517601013183594e+01 2.4164199829101562e+02 -2.7950000000000000e+02 -1.9024801254272461e+01 2.4132899475097656e+02 -2.7950000000000000e+02 3.9665500640869141e+01 2.5713400268554688e+02 -2.7950000000000000e+02 3.8204498291015625e+01 2.5612301635742188e+02 -2.7950000000000000e+02 3.6694900512695312e+01 2.5721099853515625e+02 -2.7950000000000000e+02 3.7179702758789062e+01 2.5877600097656250e+02 -2.7950000000000000e+02 3.8204498291015625e+01 2.5912698364257812e+02 -2.7950000000000000e+02 3.9353199005126953e+01 2.5865200805664062e+02 -2.7950000000000000e+02 2.5337299346923828e+01 2.6353698730468750e+02 -2.7950097656250000e+02 2.6799200057983398e+01 2.6305499267578125e+02 -2.7950000000000000e+02 2.7947900772094727e+01 2.6407998657226562e+02 -2.7950399780273438e+02 2.7634700775146484e+01 2.6558700561523438e+02 -2.7950097656250000e+02 2.6172800064086914e+01 2.6606900024414062e+02 -2.7950000000000000e+02 2.5024200439453125e+01 2.6504498291015625e+02 -2.7950299072265625e+02 1.0331800460815430e+01 2.6687197875976562e+02 -2.7950000000000000e+02 1.1480400085449219e+01 2.6639599609375000e+02 -2.7953298950195312e+02 1.2505000114440918e+01 2.6674801635742188e+02 -2.7950000000000000e+02 1.2980500221252441e+01 2.6789599609375000e+02 -2.7950000000000000e+02 1.2779500007629395e+01 2.6864599609375000e+02 -2.7950097656250000e+02 1.1962900161743164e+01 2.6935800170898438e+02 -2.7950000000000000e+02 1.0455699920654297e+01 2.6904498291015625e+02 -2.7950000000000000e+02 9.9804992675781250e+00 2.6789599609375000e+02 -2.7950097656250000e+02 -6.8922600746154785e+00 2.6245800781250000e+02 -2.7950097656250000e+02 -5.4304599761962891e+00 2.6197497558593750e+02 -2.7950097656250000e+02 -4.2817001342773438e+00 2.6300000000000000e+02 -2.7950000000000000e+02 -4.5948600769042969e+00 2.6450698852539062e+02 -2.7950000000000000e+02 -5.7435598373413086e+00 2.6498300170898438e+02 -2.7950601196289062e+02 -6.7682900428771973e+00 2.6463101196289062e+02 -2.7950000000000000e+02 -7.2435698509216309e+00 2.6348300170898438e+02 -2.7950097656250000e+02 -1.8626098632812500e+01 2.4542900085449219e+02 -2.7950097656250000e+02 -1.7601400375366211e+01 2.4428099060058594e+02 -2.7950299072265625e+02 -1.5793299674987793e+01 2.4482699584960938e+02 -2.7950299072265625e+02 -1.5970300674438477e+01 2.4676699829101562e+02 -2.7950000000000000e+02 -1.7432098388671875e+01 2.4724900817871094e+02 -2.7950000000000000e+02 -1.8417999267578125e+01 2.4649200439453125e+02 -2.7950000000000000e+02 3.8791500091552734e+01 2.5170001220703125e+02 -2.7950000000000000e+02 3.9548698425292969e+01 2.5071400451660156e+02 -2.7950000000000000e+02 4.0611801147460938e+01 2.5050601196289062e+02 -2.7950000000000000e+02 4.1760501861572266e+01 2.5152999877929688e+02 -2.7950000000000000e+02 4.1447299957275391e+01 2.5303799438476562e+02 -2.7950097656250000e+02 3.9985500335693359e+01 2.5352001953125000e+02 -2.7950000000000000e+02 3.8999599456787109e+01 2.5276300048828125e+02 -2.7950000000000000e+02 3.0137899398803711e+01 2.6136999511718750e+02 -2.7950097656250000e+02 3.1286600112915039e+01 2.6089501953125000e+02 -2.7950000000000000e+02 3.1638000488281250e+01 2.5986999511718750e+02 -2.7950000000000000e+02 3.1053100585937500e+01 2.5861401367187500e+02 -2.7950000000000000e+02 2.9387901306152344e+01 2.5857098388671875e+02 -2.7950097656250000e+02 2.8630800247192383e+01 2.5955700683593750e+02 -2.7950299072265625e+02 1.5205900192260742e+01 2.6561499023437500e+02 -2.7950000000000000e+02 1.6667098999023438e+01 2.6663000488281250e+02 -2.7950097656250000e+02 1.8176599502563477e+01 2.6553698730468750e+02 -2.7950097656250000e+02 1.7691898345947266e+01 2.6397500610351562e+02 -2.7950000000000000e+02 1.6667098999023438e+01 2.6362402343750000e+02 -2.7950000000000000e+02 1.5518400192260742e+01 2.6409899902343750e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.6342999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.6288101196289062e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.6267999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.6288101196289062e+02 -2.7950000000000000e+02 1.4617999792098999e+00 2.6369799804687500e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.6493002319335938e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.6547900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.6567999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.6547900390625000e+02 -2.7950601196289062e+02 -1.4617400169372559e+00 2.6466198730468750e+02 -2.7950000000000000e+02 -1.6022800445556641e+01 2.5126000976562500e+02 -2.7950000000000000e+02 -1.3413499832153320e+01 2.5178500366210938e+02 -2.7950000000000000e+02 -1.3100399971008301e+01 2.5027799987792969e+02 -2.7950201416015625e+02 -1.4287499427795410e+01 2.4923800659179688e+02 -2.7950000000000000e+02 -1.5861300468444824e+01 2.5001000976562500e+02 -2.7950097656250000e+02 -6.3552303314208984e+00 2.2834399414062500e+02 -2.7950097656250000e+02 -4.8934197425842285e+00 2.2786100769042969e+02 -2.7950000000000000e+02 -3.9075598716735840e+00 2.2861799621582031e+02 -2.7950701904296875e+02 -3.6994800567626953e+00 2.2968199157714844e+02 -2.7950701904296875e+02 -4.7241997718811035e+00 2.3083000183105469e+02 -2.7950997924804688e+02 -6.2313098907470703e+00 2.3051699829101562e+02 -2.7950000000000000e+02 -6.7065896987915039e+00 2.2936799621582031e+02 -2.7950000000000000e+02 4.0065299987792969e+01 2.4584400939941406e+02 -2.7950000000000000e+02 4.0822498321533203e+01 2.4485800170898438e+02 -2.7950097656250000e+02 4.1885601043701172e+01 2.4465000915527344e+02 -2.7950000000000000e+02 4.3034301757812500e+01 2.4567500305175781e+02 -2.7950097656250000e+02 4.2721099853515625e+01 2.4718199157714844e+02 -2.7950000000000000e+02 4.1259300231933594e+01 2.4766400146484375e+02 -2.7950000000000000e+02 4.0273399353027344e+01 2.4690699768066406e+02 -2.7950000000000000e+02 3.1819101333618164e+01 2.5361601257324219e+02 -2.7950000000000000e+02 3.2967800140380859e+01 2.5314099121093750e+02 -2.7950000000000000e+02 3.3992599487304688e+01 2.5349200439453125e+02 -2.7950000000000000e+02 3.4467800140380859e+01 2.5464099121093750e+02 -2.7950201416015625e+02 3.4116397857666016e+01 2.5566598510742188e+02 -2.7950000000000000e+02 3.2967800140380859e+01 2.5614102172851562e+02 -2.7950399780273438e+02 3.1943000793457031e+01 2.5578999328613281e+02 -2.7950000000000000e+02 3.1467798233032227e+01 2.5464099121093750e+02 -2.7950000000000000e+02 1.9914199829101562e+01 2.6064300537109375e+02 -2.7950000000000000e+02 2.0730800628662109e+01 2.5993099975585938e+02 -2.7950000000000000e+02 2.2237899780273438e+01 2.6024401855468750e+02 -2.7950097656250000e+02 2.2720298767089844e+01 2.6170599365234375e+02 -2.7950000000000000e+02 2.1695600509643555e+01 2.6285498046875000e+02 -2.7950201416015625e+02 2.0188400268554688e+01 2.6254202270507812e+02 -2.7950000000000000e+02 1.9713201522827148e+01 2.6139300537109375e+02 -2.7950000000000000e+02 4.5948600769042969e+00 2.6245800781250000e+02 -2.7950097656250000e+02 6.0566701889038086e+00 2.6197497558593750e+02 -2.7950201416015625e+02 7.2053699493408203e+00 2.6300000000000000e+02 -2.7950000000000000e+02 7.0425901412963867e+00 2.6423300170898438e+02 -2.7950097656250000e+02 6.2259397506713867e+00 2.6494400024414062e+02 -2.7950201416015625e+02 4.7187800407409668e+00 2.6463101196289062e+02 -2.7950000000000000e+02 4.2435498237609863e+00 2.6348300170898438e+02 -2.7950000000000000e+02 -1.2087300300598145e+01 2.5442901611328125e+02 -2.7950000000000000e+02 -1.1330100059509277e+01 2.5344300842285156e+02 -2.7950000000000000e+02 -1.0266900062561035e+01 2.5323501586914062e+02 -2.7950000000000000e+02 -9.1182594299316406e+00 2.5426000976562500e+02 -2.7950000000000000e+02 -9.4314203262329102e+00 2.5576698303222656e+02 -2.7950000000000000e+02 -1.0580100059509277e+01 2.5624200439453125e+02 -2.7950201416015625e+02 -1.1604899406433105e+01 2.5589099121093750e+02 -2.7950097656250000e+02 -1.0530600547790527e+01 2.3167300415039062e+02 -2.7950000000000000e+02 -9.3819503784179688e+00 2.3119799804687500e+02 -2.7951699829101562e+02 -8.3572902679443359e+00 2.3154998779296875e+02 -2.7950000000000000e+02 -7.8819403648376465e+00 2.3269799804687500e+02 -2.7950000000000000e+02 -8.2332496643066406e+00 2.3372300720214844e+02 -2.7950201416015625e+02 -9.6951103210449219e+00 2.3420498657226562e+02 -2.7950000000000000e+02 -1.0843800544738770e+01 2.3318099975585938e+02 -2.7950000000000000e+02 4.0851299285888672e+01 2.3915499877929688e+02 -2.7950000000000000e+02 4.2313198089599609e+01 2.3867300415039062e+02 -2.7950000000000000e+02 4.3298999786376953e+01 2.3942999267578125e+02 -2.7950000000000000e+02 4.3507198333740234e+01 2.4049299621582031e+02 -2.7950000000000000e+02 4.2482398986816406e+01 2.4164199829101562e+02 -2.7950000000000000e+02 4.1250000000000000e+01 2.4147898864746094e+02 -2.7950000000000000e+02 4.0538097381591797e+01 2.4066198730468750e+02 -2.7950000000000000e+02 3.3397701263427734e+01 2.4869099426269531e+02 -2.7950000000000000e+02 3.3943401336669922e+01 2.5020399475097656e+02 -2.7950097656250000e+02 3.5599399566650391e+01 2.5041401672363281e+02 -2.7950000000000000e+02 3.6399200439453125e+01 2.4859899902343750e+02 -2.7950097656250000e+02 3.4768501281738281e+01 2.4741200256347656e+02 -2.7950000000000000e+02 2.6243099212646484e+01 2.5609698486328125e+02 -2.7950097656250000e+02 2.5257200241088867e+01 2.5534001159667969e+02 -2.7950000000000000e+02 2.4049798965454102e+01 2.5564700317382812e+02 -2.7950000000000000e+02 2.3440099716186523e+01 2.5726000976562500e+02 -2.7950000000000000e+02 2.4194101333618164e+01 2.5814599609375000e+02 -2.7950000000000000e+02 2.5426401138305664e+01 2.5830902099609375e+02 -2.7950000000000000e+02 9.8543205261230469e+00 2.6068099975585938e+02 -2.7950000000000000e+02 1.0670900344848633e+01 2.5996899414062500e+02 -2.7950097656250000e+02 1.2178099632263184e+01 2.6028201293945312e+02 -2.7950000000000000e+02 1.2653299331665039e+01 2.6143099975585938e+02 -2.7950097656250000e+02 1.2302000045776367e+01 2.6245599365234375e+02 -2.7950000000000000e+02 1.0840199470520020e+01 2.6293798828125000e+02 -2.7950000000000000e+02 9.6914796829223633e+00 2.6191299438476562e+02 -2.7950000000000000e+02 -4.5236897468566895e+00 2.5614700317382812e+02 -2.7950000000000000e+02 -5.8954300880432129e+00 2.5582501220703125e+02 -2.7950000000000000e+02 -6.8613300323486328e+00 2.5654901123046875e+02 -2.7950500488281250e+02 -7.0240502357482910e+00 2.5778100585937500e+02 -2.7950097656250000e+02 -5.8754701614379883e+00 2.5880599975585938e+02 -2.7950000000000000e+02 -4.8123002052307129e+00 2.5859799194335938e+02 -2.7950000000000000e+02 -4.0550799369812012e+00 2.5761199951171875e+02 -2.7950000000000000e+02 -1.3206300735473633e+01 2.3719699096679688e+02 -2.7950000000000000e+02 -1.2181500434875488e+01 2.3604800415039062e+02 -2.7950097656250000e+02 -1.0373399734497070e+01 2.3659400939941406e+02 -2.7950097656250000e+02 -1.0550399780273438e+01 2.3853500366210938e+02 -2.7950000000000000e+02 -1.2012200355529785e+01 2.3901699829101562e+02 -2.7950000000000000e+02 -1.2998200416564941e+01 2.3825999450683594e+02 -2.7950000000000000e+02 4.0116802215576172e+01 2.3351199340820312e+02 -2.7950000000000000e+02 4.1885601043701172e+01 2.3269599914550781e+02 -2.7950097656250000e+02 4.3034301757812500e+01 2.3372000122070312e+02 -2.7950000000000000e+02 4.2721099853515625e+01 2.3522700500488281e+02 -2.7950000000000000e+02 4.1259300231933594e+01 2.3570999145507812e+02 -2.7950000000000000e+02 4.0273399353027344e+01 2.3495300292968750e+02 -2.7950097656250000e+02 3.4728298187255859e+01 2.4212800598144531e+02 -2.7950000000000000e+02 3.6190200805664062e+01 2.4164601135253906e+02 -2.7950000000000000e+02 3.7338802337646484e+01 2.4266999816894531e+02 -2.7950097656250000e+02 3.7025699615478516e+01 2.4417799377441406e+02 -2.7950000000000000e+02 3.5563800811767578e+01 2.4466000366210938e+02 -2.7950000000000000e+02 3.4415199279785156e+01 2.4363499450683594e+02 -2.7950201416015625e+02 2.6567699432373047e+01 2.5063601684570312e+02 -2.7950000000000000e+02 2.8029600143432617e+01 2.5015299987792969e+02 -2.7950201416015625e+02 2.9178199768066406e+01 2.5117799377441406e+02 -2.7950000000000000e+02 2.9015399932861328e+01 2.5241101074218750e+02 -2.7950097656250000e+02 2.8198799133300781e+01 2.5312200927734375e+02 -2.7950000000000000e+02 2.6691600799560547e+01 2.5280899047851562e+02 -2.7950000000000000e+02 2.6216400146484375e+01 2.5165998840332031e+02 -2.7950500488281250e+02 1.4766300201416016e+01 2.5712002563476562e+02 -2.7950000000000000e+02 1.5914899826049805e+01 2.5664401245117188e+02 -2.7950299072265625e+02 1.6939699172973633e+01 2.5699600219726562e+02 -2.7950000000000000e+02 1.7422100067138672e+01 2.5845700073242188e+02 -2.7950000000000000e+02 1.6664899826049805e+01 2.5944302368164062e+02 -2.7950000000000000e+02 1.5601799964904785e+01 2.5965197753906250e+02 -2.7950000000000000e+02 1.4453000068664551e+01 2.5862698364257812e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.5742999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.5688101196289062e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.5668002319335938e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.5688101196289062e+02 -2.7950701904296875e+02 1.4617400169372559e+00 2.5769799804687500e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.5892999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.5947897338867188e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.5967999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.5947897338867188e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.5866198730468750e+02 -2.7950201416015625e+02 -1.2847800254821777e+01 2.4182600402832031e+02 -2.7950000000000000e+02 -1.1385999679565430e+01 2.4134300231933594e+02 -2.7950000000000000e+02 -1.0237299919128418e+01 2.4236799621582031e+02 -2.7950201416015625e+02 -1.0550399780273438e+01 2.4387500000000000e+02 -2.7950000000000000e+02 -1.2012200355529785e+01 2.4435700988769531e+02 -2.7950000000000000e+02 -1.2998200416564941e+01 2.4359999084472656e+02 -2.7950000000000000e+02 -1.3199100494384766e+01 2.4285000610351562e+02 -2.7950000000000000e+02 3.8791500091552734e+01 2.2803401184082031e+02 -2.7950000000000000e+02 3.9816299438476562e+01 2.2688500976562500e+02 -2.7950000000000000e+02 4.1323501586914062e+01 2.2719799804687500e+02 -2.7950097656250000e+02 4.1805900573730469e+01 2.2866000366210938e+02 -2.7950000000000000e+02 4.0780998229980469e+01 2.2980900573730469e+02 -2.7950097656250000e+02 3.9273899078369141e+01 2.2949600219726562e+02 -2.7950000000000000e+02 3.4369800567626953e+01 2.3689399719238281e+02 -2.7950000000000000e+02 3.5394599914550781e+01 2.3574499511718750e+02 -2.7950000000000000e+02 3.6901802062988281e+01 2.3605799865722656e+02 -2.7950097656250000e+02 3.7384201049804688e+01 2.3751998901367188e+02 -2.7950000000000000e+02 3.6359397888183594e+01 2.3866899108886719e+02 -2.7950097656250000e+02 3.4852199554443359e+01 2.3835598754882812e+02 -2.7950000000000000e+02 2.9898698806762695e+01 2.4751699829101562e+02 -2.7950000000000000e+02 3.0930799484252930e+01 2.4634599304199219e+02 -2.7950000000000000e+02 3.0585100173950195e+01 2.4508300781250000e+02 -2.7950000000000000e+02 2.9423500061035156e+01 2.4453300476074219e+02 -2.7950000000000000e+02 2.8274801254272461e+01 2.4500801086425781e+02 -2.7950097656250000e+02 2.7961698532104492e+01 2.4651499938964844e+02 -2.7950000000000000e+02 2.8673500061035156e+01 2.4733200073242188e+02 -2.7950000000000000e+02 2.0478799819946289e+01 2.5512600708007812e+02 -2.7950000000000000e+02 2.1258798599243164e+01 2.5412699890136719e+02 -2.7950000000000000e+02 2.1050600051879883e+01 2.5306401062011719e+02 -2.7950000000000000e+02 2.0076398849487305e+01 2.5231201171875000e+02 -2.7950000000000000e+02 1.9001600265502930e+01 2.5251498413085938e+02 -2.7950097656250000e+02 1.8244400024414062e+01 2.5350001525878906e+02 -2.7950201416015625e+02 5.7758698463439941e+00 2.5571000671386719e+02 -2.7950000000000000e+02 4.2632198333740234e+00 2.5654901123046875e+02 -2.7950000000000000e+02 4.0622897148132324e+00 2.5729901123046875e+02 -2.7950097656250000e+02 4.5374598503112793e+00 2.5844799804687500e+02 -2.7950000000000000e+02 5.5622997283935547e+00 2.5879898071289062e+02 -2.7950000000000000e+02 6.3122501373291016e+00 2.5859799194335938e+02 -2.7950097656250000e+02 7.0864000320434570e+00 2.5756698608398438e+02 -2.7950000000000000e+02 -1.0889199256896973e+01 2.4734899902343750e+02 -2.7950000000000000e+02 -1.0131899833679199e+01 2.4636300659179688e+02 -2.7950000000000000e+02 -9.0687894821166992e+00 2.4615499877929688e+02 -2.7950000000000000e+02 -7.9200901985168457e+00 2.4717999267578125e+02 -2.7951699829101562e+02 -8.2334299087524414e+00 2.4868699645996094e+02 -2.7950000000000000e+02 -9.3819503784179688e+00 2.4916200256347656e+02 -2.7950097656250000e+02 -1.0406799316406250e+01 2.4880999755859375e+02 -2.7950000000000000e+02 3.6905502319335938e+01 2.2348300170898438e+02 -2.7950000000000000e+02 3.8204597473144531e+01 2.2423699951171875e+02 -2.7950000000000000e+02 3.9714099884033203e+01 2.2314900207519531e+02 -2.7950000000000000e+02 3.9229301452636719e+01 2.2158399963378906e+02 -2.7950201416015625e+02 3.7722198486328125e+01 2.2127099609375000e+02 -2.7950000000000000e+02 3.6697299957275391e+01 2.2241899108886719e+02 -2.7950000000000000e+02 3.6197402954101562e+01 2.3059300231933594e+02 -2.7950000000000000e+02 3.5211601257324219e+01 2.2983500671386719e+02 -2.7950000000000000e+02 3.3744201660156250e+01 2.3032099914550781e+02 -2.7950097656250000e+02 3.3744499206542969e+01 2.3241400146484375e+02 -2.7950000000000000e+02 3.5380798339843750e+01 2.3280400085449219e+02 -2.7950000000000000e+02 3.6226898193359375e+01 2.3203100585937500e+02 -2.7950000000000000e+02 3.0418998718261719e+01 2.4167999267578125e+02 -2.7950000000000000e+02 3.1507202148437500e+01 2.4049299621582031e+02 -2.7950000000000000e+02 3.1298997879028320e+01 2.3942999267578125e+02 -2.7950000000000000e+02 3.0327501296997070e+01 2.3868000793457031e+02 -2.7950000000000000e+02 2.8518098831176758e+01 2.3961099243164062e+02 -2.7950000000000000e+02 2.8850700378417969e+01 2.4114799499511719e+02 -2.7950097656250000e+02 2.0959300994873047e+01 2.4916699218750000e+02 -2.7950000000000000e+02 2.1690401077270508e+01 2.4999000549316406e+02 -2.7950000000000000e+02 2.2995500564575195e+01 2.5013598632812500e+02 -2.7950000000000000e+02 2.3951000213623047e+01 2.4828800964355469e+02 -2.7950097656250000e+02 2.2753499984741211e+01 2.4718299865722656e+02 -2.7950000000000000e+02 2.1291698455810547e+01 2.4766600036621094e+02 -2.7950000000000000e+02 9.4314203262329102e+00 2.5371798706054688e+02 -2.7950097656250000e+02 1.0893300056457520e+01 2.5323501586914062e+02 -2.7950097656250000e+02 1.2041999816894531e+01 2.5426000976562500e+02 -2.7950799560546875e+02 1.1728700637817383e+01 2.5576698303222656e+02 -2.7950000000000000e+02 1.0580100059509277e+01 2.5624200439453125e+02 -2.7950500488281250e+02 9.5553398132324219e+00 2.5589099121093750e+02 -2.7950000000000000e+02 9.0801105499267578e+00 2.5474198913574219e+02 -2.7950997924804688e+02 -6.3551702499389648e+00 2.4996699523925781e+02 -2.7950701904296875e+02 -4.8934197425842285e+00 2.4948500061035156e+02 -2.7950000000000000e+02 -3.9075598716735840e+00 2.5024198913574219e+02 -2.7950000000000000e+02 -3.7065699100494385e+00 2.5099200439453125e+02 -2.7950097656250000e+02 -4.0578799247741699e+00 2.5201600646972656e+02 -2.7950097656250000e+02 -5.5197501182556152e+00 2.5249900817871094e+02 -2.7950097656250000e+02 -6.6684498786926270e+00 2.5147399902343750e+02 -2.7950097656250000e+02 3.3726799011230469e+01 2.1760299682617188e+02 -2.7950000000000000e+02 3.4850200653076172e+01 2.1601100158691406e+02 -2.7950000000000000e+02 3.6082599639892578e+01 2.1617401123046875e+02 -2.7950000000000000e+02 3.6794498443603516e+01 2.1699101257324219e+02 -2.7950000000000000e+02 3.6481300354003906e+01 2.1849800109863281e+02 -2.7950000000000000e+02 3.5019401550292969e+01 2.1897999572753906e+02 -2.7950000000000000e+02 3.1460601806640625e+01 2.2540600585937500e+02 -2.7950299072265625e+02 3.2485401153564453e+01 2.2425700378417969e+02 -2.7950601196289062e+02 3.4293498992919922e+01 2.2480400085449219e+02 -2.7950000000000000e+02 3.4116500854492188e+01 2.2674400329589844e+02 -2.7950000000000000e+02 3.2967800140380859e+01 2.2721899414062500e+02 -2.7950000000000000e+02 3.1943000793457031e+01 2.2686799621582031e+02 -2.7950000000000000e+02 3.0531499862670898e+01 2.3542700195312500e+02 -2.7950000000000000e+02 3.0885400772094727e+01 2.3384500122070312e+02 -2.7950000000000000e+02 2.9754199981689453e+01 2.3280400085449219e+02 -2.7950000000000000e+02 2.8274801254272461e+01 2.3330200195312500e+02 -2.7950000000000000e+02 2.7961698532104492e+01 2.3480999755859375e+02 -2.7950097656250000e+02 2.8805099487304688e+01 2.3568899536132812e+02 -2.7950097656250000e+02 2.2676300048828125e+01 2.4204798889160156e+02 -2.7950000000000000e+02 2.4138198852539062e+01 2.4156600952148438e+02 -2.7950000000000000e+02 2.5124000549316406e+01 2.4232299804687500e+02 -2.7950000000000000e+02 2.5332199096679688e+01 2.4338600158691406e+02 -2.7950097656250000e+02 2.4307399749755859e+01 2.4453500366210938e+02 -2.7950000000000000e+02 2.2800098419189453e+01 2.4422200012207031e+02 -2.7950000000000000e+02 2.2324998855590820e+01 2.4307299804687500e+02 -2.7953698730468750e+02 1.3414000511169434e+01 2.4973599243164062e+02 -2.7950000000000000e+02 1.4562300682067871e+01 2.4925999450683594e+02 -2.7950000000000000e+02 1.5587100028991699e+01 2.4961100769042969e+02 -2.7950097656250000e+02 1.6069499969482422e+01 2.5107299804687500e+02 -2.7950000000000000e+02 1.5044599533081055e+01 2.5222200012207031e+02 -2.7950097656250000e+02 1.3537500381469727e+01 2.5190898132324219e+02 -2.7950000000000000e+02 1.3062299728393555e+01 2.5075999450683594e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.5143000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.5088098144531250e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.5067999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.5088098144531250e+02 -2.7950000000000000e+02 1.4617999792098999e+00 2.5169798278808594e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.5292999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.5347900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.5367999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.5347900390625000e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.5266200256347656e+02 -2.7950000000000000e+02 3.0991399765014648e+01 2.1397499084472656e+02 -2.7950000000000000e+02 3.2092601776123047e+01 2.1414799499511719e+02 -2.7950000000000000e+02 3.3203300476074219e+01 2.1219299316406250e+02 -2.7950097656250000e+02 3.2054599761962891e+01 2.1116900634765625e+02 -2.7950601196289062e+02 3.0592800140380859e+01 2.1165100097656250e+02 -2.7950000000000000e+02 3.0243198394775391e+01 2.1269799804687500e+02 -2.7950000000000000e+02 3.0138000488281250e+01 2.2199000549316406e+02 -2.7950097656250000e+02 3.1286600112915039e+01 2.2151499938964844e+02 -2.7950097656250000e+02 3.1599800109863281e+01 2.2000700378417969e+02 -2.7950000000000000e+02 3.0459299087524414e+01 2.1898600769042969e+02 -2.7950000000000000e+02 2.8896799087524414e+01 2.1963400268554688e+02 -2.7950201416015625e+02 2.8707099914550781e+01 2.2108900451660156e+02 -2.7950097656250000e+02 2.6567699432373047e+01 2.2767500305175781e+02 -2.7950000000000000e+02 2.8029600143432617e+01 2.2719200134277344e+02 -2.7950097656250000e+02 2.9178199768066406e+01 2.2821701049804688e+02 -2.7950601196289062e+02 2.8864999771118164e+01 2.2972399902343750e+02 -2.7950000000000000e+02 2.7716400146484375e+01 2.3019999694824219e+02 -2.7950097656250000e+02 2.6691600799560547e+01 2.2984799194335938e+02 -2.7950000000000000e+02 2.6216400146484375e+01 2.2869999694824219e+02 -2.7950000000000000e+02 2.2317800521850586e+01 2.3697399902343750e+02 -2.7950097656250000e+02 2.3342599868774414e+01 2.3582499694824219e+02 -2.7950000000000000e+02 2.4849800109863281e+01 2.3613800048828125e+02 -2.7950097656250000e+02 2.5332099914550781e+01 2.3760000610351562e+02 -2.7950000000000000e+02 2.4575000762939453e+01 2.3858599853515625e+02 -2.7950000000000000e+02 2.3511800765991211e+01 2.3879400634765625e+02 -2.7950000000000000e+02 2.2525999069213867e+01 2.3803700256347656e+02 -2.7950000000000000e+02 1.5970300674438477e+01 2.4471800231933594e+02 -2.7950201416015625e+02 1.7432098388671875e+01 2.4423500061035156e+02 -2.7950097656250000e+02 1.8580900192260742e+01 2.4525999450683594e+02 -2.7950201416015625e+02 1.8267599105834961e+01 2.4676699829101562e+02 -2.7950000000000000e+02 1.6805799484252930e+01 2.4724900817871094e+02 -2.7950000000000000e+02 1.5657100677490234e+01 2.4622500610351562e+02 -2.7950000000000000e+02 3.9074997901916504e+00 2.5024198913574219e+02 -2.7950601196289062e+02 4.7241997718811035e+00 2.4952999877929688e+02 -2.7950701904296875e+02 6.2313098907470703e+00 2.4984300231933594e+02 -2.7950000000000000e+02 6.7065896987915039e+00 2.5099200439453125e+02 -2.7950097656250000e+02 6.3552799224853516e+00 2.5201600646972656e+02 -2.7950097656250000e+02 4.8934197425842285e+00 2.5249900817871094e+02 -2.7950201416015625e+02 3.7447199821472168e+00 2.5147399902343750e+02 -2.7950000000000000e+02 2.5996898651123047e+01 2.0812500000000000e+02 -2.7950097656250000e+02 2.7021699905395508e+01 2.0697698974609375e+02 -2.7950900268554688e+02 2.8528900146484375e+01 2.0728999328613281e+02 -2.7950000000000000e+02 2.9004100799560547e+01 2.0843901062011719e+02 -2.7950997924804688e+02 2.8652700424194336e+01 2.0946299743652344e+02 -2.7950000000000000e+02 2.7504098892211914e+01 2.0993800354003906e+02 -2.7950097656250000e+02 2.6479299545288086e+01 2.0958699035644531e+02 -2.7950000000000000e+02 2.5337299346923828e+01 2.1477299499511719e+02 -2.7950000000000000e+02 2.6799200057983398e+01 2.1429100036621094e+02 -2.7950000000000000e+02 2.7947900772094727e+01 2.1531599426269531e+02 -2.7950097656250000e+02 2.7634700775146484e+01 2.1682299804687500e+02 -2.7950000000000000e+02 2.6172901153564453e+01 2.1730500793457031e+02 -2.7950000000000000e+02 2.5187000274658203e+01 2.1654798889160156e+02 -2.7950000000000000e+02 2.4986000061035156e+01 2.1579800415039062e+02 -2.7950000000000000e+02 2.3645000457763672e+01 2.2426300048828125e+02 -2.7950000000000000e+02 2.4630901336669922e+01 2.2502000427246094e+02 -2.7950000000000000e+02 2.6323699951171875e+01 2.2289498901367188e+02 -2.7950000000000000e+02 2.5694099426269531e+01 2.2221400451660156e+02 -2.7950000000000000e+02 2.4461700439453125e+01 2.2205099487304688e+02 -2.7950000000000000e+02 2.3552398681640625e+01 2.2295700073242188e+02 -2.7950000000000000e+02 2.3948600769042969e+01 2.3198098754882812e+02 -2.7950000000000000e+02 2.3244998931884766e+01 2.3039999389648438e+02 -2.7950000000000000e+02 2.1885198593139648e+01 2.3022399902343750e+02 -2.7950000000000000e+02 2.0940401077270508e+01 2.3166899108886719e+02 -2.7950000000000000e+02 2.1415599822998047e+01 2.3281799316406250e+02 -2.7950000000000000e+02 2.2922800064086914e+01 2.3313101196289062e+02 -2.7950000000000000e+02 1.6492801666259766e+01 2.3986700439453125e+02 -2.7950097656250000e+02 1.7517601013183594e+01 2.3871800231933594e+02 -2.7950000000000000e+02 1.9024801254272461e+01 2.3903100585937500e+02 -2.7950201416015625e+02 1.8915298461914062e+01 2.4150599670410156e+02 -2.7950000000000000e+02 1.6975200653076172e+01 2.4132899475097656e+02 -2.7950000000000000e+02 8.0829296112060547e+00 2.4691200256347656e+02 -2.7950000000000000e+02 8.8995704650878906e+00 2.4619999694824219e+02 -2.7950000000000000e+02 1.0131899833679199e+01 2.4636300659179688e+02 -2.7950000000000000e+02 1.0843800544738770e+01 2.4717999267578125e+02 -2.7950299072265625e+02 1.0530600547790527e+01 2.4868699645996094e+02 -2.7950000000000000e+02 9.0688505172729492e+00 2.4916900634765625e+02 -2.7950500488281250e+02 7.9201498031616211e+00 2.4814399719238281e+02 -2.7950097656250000e+02 -6.3447899818420410e+00 2.3615499877929688e+02 -2.7950000000000000e+02 -4.8829298019409180e+00 2.3567298889160156e+02 -2.7950000000000000e+02 -3.7342898845672607e+00 2.3669799804687500e+02 -2.7950000000000000e+02 -3.8970699310302734e+00 2.3792999267578125e+02 -2.7950000000000000e+02 -4.7137699127197266e+00 2.3864201354980469e+02 -2.7950299072265625e+02 -6.2209401130676270e+00 2.3832899475097656e+02 -2.7950000000000000e+02 -6.6961102485656738e+00 2.3717999267578125e+02 -2.7950201416015625e+02 2.1558198928833008e+01 2.0382299804687500e+02 -2.7950000000000000e+02 2.3020099639892578e+01 2.0333999633789062e+02 -2.7950000000000000e+02 2.4005899429321289e+01 2.0409700012207031e+02 -2.7950000000000000e+02 2.4214099884033203e+01 2.0516000366210938e+02 -2.7950097656250000e+02 2.3189300537109375e+01 2.0630900573730469e+02 -2.7950399780273438e+02 2.1682100296020508e+01 2.0599600219726562e+02 -2.7950000000000000e+02 2.1206899642944336e+01 2.0484700012207031e+02 -2.7950799560546875e+02 2.0962999343872070e+01 2.1074600219726562e+02 -2.7950000000000000e+02 2.2111700057983398e+01 2.1027099609375000e+02 -2.7950000000000000e+02 2.2861700057983398e+01 2.1047200012207031e+02 -2.7950000000000000e+02 2.3573499679565430e+01 2.1128800964355469e+02 -2.7950097656250000e+02 2.3260299682617188e+01 2.1279600524902344e+02 -2.7950000000000000e+02 2.2111700057983398e+01 2.1327101135253906e+02 -2.7950701904296875e+02 2.1086898803710938e+01 2.1291999816894531e+02 -2.7950000000000000e+02 2.0611598968505859e+01 2.1177099609375000e+02 -2.7950000000000000e+02 1.9914199829101562e+01 2.1821699523925781e+02 -2.7950000000000000e+02 2.0730800628662109e+01 2.1750498962402344e+02 -2.7950000000000000e+02 2.1963199615478516e+01 2.1766799926757812e+02 -2.7950000000000000e+02 2.2674999237060547e+01 2.1848399353027344e+02 -2.7950097656250000e+02 2.2361900329589844e+01 2.1999200439453125e+02 -2.7950000000000000e+02 2.1213199615478516e+01 2.2046699523925781e+02 -2.7950097656250000e+02 2.0188400268554688e+01 2.2011500549316406e+02 -2.7950000000000000e+02 1.9713201522827148e+01 2.1896701049804688e+02 -2.7950000000000000e+02 1.9427898406982422e+01 2.2806300354003906e+02 -2.7950000000000000e+02 2.0900199890136719e+01 2.2757099914550781e+02 -2.7950097656250000e+02 2.1213399887084961e+01 2.2606399536132812e+02 -2.7950000000000000e+02 2.0465000152587891e+01 2.2522999572753906e+02 -2.7950299072265625e+02 1.8653400421142578e+01 2.2542900085449219e+02 -2.7950097656250000e+02 1.8289699554443359e+01 2.2702899169921875e+02 -2.7950000000000000e+02 1.5970300674438477e+01 2.3359300231933594e+02 -2.7950299072265625e+02 1.7432098388671875e+01 2.3311099243164062e+02 -2.7950000000000000e+02 1.8580900192260742e+01 2.3413499450683594e+02 -2.7950201416015625e+02 1.8267700195312500e+01 2.3564199829101562e+02 -2.7950000000000000e+02 1.6805799484252930e+01 2.3612500000000000e+02 -2.7950000000000000e+02 1.5657100677490234e+01 2.3510000610351562e+02 -2.7950097656250000e+02 1.2795800209045410e+01 2.4174099731445312e+02 -2.7950097656250000e+02 1.1216799736022949e+01 2.4138800048828125e+02 -2.7950000000000000e+02 1.0400099754333496e+01 2.4210000610351562e+02 -2.7950000000000000e+02 1.0237299919128418e+01 2.4333299255371094e+02 -2.7950201416015625e+02 1.1385999679565430e+01 2.4435700988769531e+02 -2.7950000000000000e+02 1.2449099540710449e+01 2.4414900207519531e+02 -2.7950097656250000e+02 -6.7033200263977051e+00 2.4286698913574219e+02 -2.7950097656250000e+02 -5.6784696578979492e+00 2.4171798706054688e+02 -2.7950000000000000e+02 -4.1713099479675293e+00 2.4203099060058594e+02 -2.7950000000000000e+02 -3.6889300346374512e+00 2.4349301147460938e+02 -2.7950000000000000e+02 -4.7137098312377930e+00 2.4464199829101562e+02 -2.7950097656250000e+02 -6.2209401130676270e+00 2.4432901000976562e+02 -2.7950000000000000e+02 1.6148399353027344e+01 2.0272499084472656e+02 -2.7950000000000000e+02 1.6697399139404297e+01 2.0327400207519531e+02 -2.7950000000000000e+02 1.7929800033569336e+01 2.0343699645996094e+02 -2.7950997924804688e+02 1.8583599090576172e+01 2.0088800048828125e+02 -2.7950000000000000e+02 1.7447401046752930e+01 2.0047500610351562e+02 -2.7950097656250000e+02 1.6271499633789062e+01 2.0097000122070312e+02 -2.7950000000000000e+02 1.5626899719238281e+01 2.0820599365234375e+02 -2.7950201416015625e+02 1.6651699066162109e+01 2.0705700683593750e+02 -2.7950000000000000e+02 1.7884099960327148e+01 2.0722000122070312e+02 -2.7950201416015625e+02 1.8595899581909180e+01 2.0803700256347656e+02 -2.7950799560546875e+02 1.8282699584960938e+01 2.0954400634765625e+02 -2.7950000000000000e+02 1.7134099960327148e+01 2.1001901245117188e+02 -2.7950201416015625e+02 1.6109300613403320e+01 2.0966799926757812e+02 -2.7950299072265625e+02 1.5518400192260742e+01 2.1421099853515625e+02 -2.7950000000000000e+02 1.6980199813842773e+01 2.1372898864746094e+02 -2.7950000000000000e+02 1.7966098785400391e+01 2.1448600769042969e+02 -2.7950000000000000e+02 1.8174299240112305e+01 2.1554901123046875e+02 -2.7950000000000000e+02 1.7149400711059570e+01 2.1669801330566406e+02 -2.7950000000000000e+02 1.5917099952697754e+01 2.1653500366210938e+02 -2.7950000000000000e+02 1.5205200195312500e+01 2.1571800231933594e+02 -2.7950097656250000e+02 1.4766200065612793e+01 2.2119100952148438e+02 -2.7950097656250000e+02 1.6228099822998047e+01 2.2070899963378906e+02 -2.7950000000000000e+02 1.7376798629760742e+01 2.2173300170898438e+02 -2.7950299072265625e+02 1.7063598632812500e+01 2.2324099731445312e+02 -2.7950000000000000e+02 1.5601699829101562e+01 2.2372299194335938e+02 -2.7950500488281250e+02 1.4453100204467773e+01 2.2269799804687500e+02 -2.7950000000000000e+02 1.3263200759887695e+01 2.2885000610351562e+02 -2.7950000000000000e+02 1.4079900741577148e+01 2.2813800048828125e+02 -2.7950000000000000e+02 1.5312200546264648e+01 2.2830101013183594e+02 -2.7950097656250000e+02 1.6024099349975586e+01 2.2911700439453125e+02 -2.7950000000000000e+02 1.5710899353027344e+01 2.3062500000000000e+02 -2.7950000000000000e+02 1.4562300682067871e+01 2.3109999084472656e+02 -2.7953698730468750e+02 1.3537799835205078e+01 2.3074800109863281e+02 -2.7950000000000000e+02 1.3062299728393555e+01 2.2959999084472656e+02 -2.7950000000000000e+02 1.3159999847412109e+01 2.3793399047851562e+02 -2.7950000000000000e+02 1.2012300491333008e+01 2.3600299072265625e+02 -2.7950000000000000e+02 1.0949100494384766e+01 2.3621099853515625e+02 -2.7950000000000000e+02 1.0191899299621582e+01 2.3719699096679688e+02 -2.7950000000000000e+02 1.0400099754333496e+01 2.3825999450683594e+02 -2.7950097656250000e+02 1.1385999679565430e+01 2.3901699829101562e+02 -2.7950000000000000e+02 1.2449099540710449e+01 2.3880900573730469e+02 -2.7950201416015625e+02 -1.5071600675582886e+00 2.4586700439453125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.4488099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.4468000793457031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.4488099670410156e+02 -2.7950201416015625e+02 1.4617999792098999e+00 2.4569799804687500e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.4747900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.4767999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.4747900390625000e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.4693000793457031e+02 -2.7950000000000000e+02 1.0533699989318848e+01 2.0063099670410156e+02 -2.7950097656250000e+02 1.1519599914550781e+01 2.0138800048828125e+02 -2.7950000000000000e+02 1.3337199211120605e+01 1.9988400268554688e+02 -2.7950000000000000e+02 1.2582699775695801e+01 1.9858200073242188e+02 -2.7950000000000000e+02 1.1350399971008301e+01 1.9841900634765625e+02 -2.7950000000000000e+02 1.0439200401306152e+01 1.9933000183105469e+02 -2.7950000000000000e+02 1.2215100288391113e+01 2.0758599853515625e+02 -2.7950000000000000e+02 1.0881099700927734e+01 2.0739799499511719e+02 -2.7950000000000000e+02 1.3189099311828613e+01 2.0613099670410156e+02 -2.7950000000000000e+02 1.2783100128173828e+01 2.0501998901367188e+02 -2.7950000000000000e+02 1.1206699371337891e+01 2.0466900634765625e+02 -2.7950000000000000e+02 1.0431599617004395e+01 2.1361799621582031e+02 -2.7950000000000000e+02 1.1660599708557129e+01 2.1394898986816406e+02 -2.7950000000000000e+02 1.2779500007629395e+01 2.1171400451660156e+02 -2.7950097656250000e+02 1.1793600082397461e+01 2.1095600891113281e+02 -2.7950201416015625e+02 1.0331800460815430e+01 2.1143899536132812e+02 -2.7950000000000000e+02 9.9804992675781250e+00 2.1246400451660156e+02 -2.7950399780273438e+02 9.5475301742553711e+00 2.1905900573730469e+02 -2.7950000000000000e+02 1.0403299331665039e+01 2.1763000488281250e+02 -2.7950097656250000e+02 1.1466500282287598e+01 2.1742199707031250e+02 -2.7950097656250000e+02 1.2302000045776367e+01 2.1995399475097656e+02 -2.7950000000000000e+02 1.0840199470520020e+01 2.2043600463867188e+02 -2.7950500488281250e+02 9.4314804077148438e+00 2.2459300231933594e+02 -2.7950000000000000e+02 1.0580100059509277e+01 2.2411799621582031e+02 -2.7950799560546875e+02 1.1604800224304199e+01 2.2446900939941406e+02 -2.7950000000000000e+02 1.2080100059509277e+01 2.2561801147460938e+02 -2.7950097656250000e+02 1.1728799819946289e+01 2.2664199829101562e+02 -2.7950000000000000e+02 1.0266999244689941e+01 2.2712500000000000e+02 -2.7950000000000000e+02 9.1182594299316406e+00 2.2609999084472656e+02 -2.7952700805664062e+02 8.2335500717163086e+00 2.3167399597167969e+02 -2.7950000000000000e+02 9.3819503784179688e+00 2.3119799804687500e+02 -2.7950299072265625e+02 1.0406700134277344e+01 2.3154998779296875e+02 -2.7950000000000000e+02 1.0889199256896973e+01 2.3301100158691406e+02 -2.7950000000000000e+02 1.0131899833679199e+01 2.3399700927734375e+02 -2.7950000000000000e+02 9.0687894821166992e+00 2.3420498657226562e+02 -2.7950097656250000e+02 7.9200901985168457e+00 2.3318099975585938e+02 -2.7950299072265625e+02 4.0474500656127930e+00 2.4215499877929688e+02 -2.7950097656250000e+02 5.5092601776123047e+00 2.4167298889160156e+02 -2.7950000000000000e+02 6.4951801300048828e+00 2.4243000793457031e+02 -2.7950000000000000e+02 6.7033200263977051e+00 2.4349301147460938e+02 -2.7950000000000000e+02 5.6785297393798828e+00 2.4464199829101562e+02 -2.7950097656250000e+02 4.1713099479675293e+00 2.4432901000976562e+02 -2.7950000000000000e+02 3.6961398124694824e+00 2.4318000793457031e+02 -2.7950000000000000e+02 4.4699897766113281e+00 1.9829400634765625e+02 -2.7950000000000000e+02 5.4948301315307617e+00 1.9714599609375000e+02 -2.7950097656250000e+02 7.0020003318786621e+00 1.9745899963378906e+02 -2.7950000000000000e+02 7.4772200584411621e+00 1.9860800170898438e+02 -2.7952099609375000e+02 7.1256699562072754e+00 1.9963200378417969e+02 -2.7950000000000000e+02 5.6639900207519531e+00 2.0011499023437500e+02 -2.7950000000000000e+02 4.6781301498413086e+00 1.9935800170898438e+02 -2.7950000000000000e+02 4.6263298988342285e+00 2.0392100524902344e+02 -2.7950097656250000e+02 5.4429802894592285e+00 2.0320899963378906e+02 -2.7950000000000000e+02 6.9502000808715820e+00 2.0352200317382812e+02 -2.7950000000000000e+02 7.4253702163696289e+00 2.0467098999023438e+02 -2.7951300048828125e+02 7.0739398002624512e+00 2.0569599914550781e+02 -2.7950299072265625e+02 5.6121897697448730e+00 2.0617799377441406e+02 -2.7950000000000000e+02 4.4634900093078613e+00 2.0515299987792969e+02 -2.7950000000000000e+02 7.3527097702026367e+00 2.1075599670410156e+02 -2.7950000000000000e+02 6.3042597770690918e+00 2.0924900817871094e+02 -2.7950000000000000e+02 4.7143101692199707e+00 2.0972500610351562e+02 -2.7950097656250000e+02 4.4190902709960938e+00 2.1128498840332031e+02 -2.7950097656250000e+02 5.5395402908325195e+00 2.1226400756835938e+02 -2.7950500488281250e+02 7.0013399124145508e+00 2.1178099060058594e+02 -2.7950000000000000e+02 4.4444799423217773e+00 2.1612699890136719e+02 -2.7950000000000000e+02 5.2611799240112305e+00 2.1541600036621094e+02 -2.7950299072265625e+02 6.7683396339416504e+00 2.1572900390625000e+02 -2.7950000000000000e+02 7.2435698509216309e+00 2.1687699890136719e+02 -2.7950097656250000e+02 6.8921999931335449e+00 2.1790200805664062e+02 -2.7950000000000000e+02 5.4303398132324219e+00 2.1838499450683594e+02 -2.7950000000000000e+02 4.2817001342773438e+00 2.1736000061035156e+02 -2.7950000000000000e+02 4.5236897468566895e+00 2.2421299743652344e+02 -2.7950000000000000e+02 5.8954300880432129e+00 2.2453500366210938e+02 -2.7950000000000000e+02 7.0241699218750000e+00 2.2257901000976562e+02 -2.7950000000000000e+02 6.3122501373291016e+00 2.2176200866699219e+02 -2.7950097656250000e+02 5.0798597335815430e+00 2.2159899902343750e+02 -2.7950097656250000e+02 4.0550799369812012e+00 2.2274800109863281e+02 -2.7950201416015625e+02 3.6994199752807617e+00 2.2905500793457031e+02 -2.7950000000000000e+02 4.4565801620483398e+00 2.2806900024414062e+02 -2.7950097656250000e+02 5.5197501182556152e+00 2.2786100769042969e+02 -2.7950000000000000e+02 6.5056099891662598e+00 2.2861799621582031e+02 -2.7950799560546875e+02 6.7136898040771484e+00 2.2968199157714844e+02 -2.7950701904296875e+02 5.6889600753784180e+00 2.3083000183105469e+02 -2.7950601196289062e+02 4.1817998886108398e+00 2.3051699829101562e+02 -2.7950000000000000e+02 3.6889300346374512e+00 2.3686698913574219e+02 -2.7950000000000000e+02 4.7137098312377930e+00 2.3571800231933594e+02 -2.7950000000000000e+02 5.9461002349853516e+00 2.3588099670410156e+02 -2.7950000000000000e+02 6.6579599380493164e+00 2.3669799804687500e+02 -2.7950299072265625e+02 6.3447899818420410e+00 2.3820500183105469e+02 -2.7950097656250000e+02 4.8829898834228516e+00 2.3868699645996094e+02 -2.7950000000000000e+02 3.8970699310302734e+00 2.3792999267578125e+02 -2.7950000000000000e+02 -1.5071600675582886e+00 1.9786700439453125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 1.9688099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 1.9667999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 1.9688099670410156e+02 -2.7950000000000000e+02 1.4617999792098999e+00 1.9769799804687500e+02 -2.7950000000000000e+02 1.2990200519561768e+00 1.9892999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 1.9947900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 1.9968000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 1.9947900390625000e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 1.9892999267578125e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.0342999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.0288099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.0268000793457031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.0288099670410156e+02 -2.7950000000000000e+02 1.5071600675582886e+00 2.0449299621582031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.0547898864746094e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.0567999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.0547898864746094e+02 -2.7950097656250000e+02 -1.4617999792098999e+00 2.0466200256347656e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.0942999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.0888101196289062e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.0868000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.0888101196289062e+02 -2.7950097656250000e+02 -1.5096099376678467e+00 2.0986399841308594e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.1147898864746094e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.1167999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.1147898864746094e+02 -2.7950000000000000e+02 1.5055500268936157e+00 2.1049700927734375e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.1543000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.1488099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.1468000793457031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.1488099670410156e+02 -2.7950500488281250e+02 1.4617400169372559e+00 2.1569799804687500e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.1693000793457031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.1747900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.1768000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.1747900390625000e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.1666200256347656e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.2143000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.2088099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.2067999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.2088099670410156e+02 -2.7950000000000000e+02 1.4617999792098999e+00 2.2169799804687500e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.2347900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.2368000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.2347900390625000e+02 -2.7950701904296875e+02 -1.4617400169372559e+00 2.2266200256347656e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.2743000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.2688099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.2667999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.2688099670410156e+02 -2.7950000000000000e+02 1.5071600675582886e+00 2.2849301147460938e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.2947900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.2968000793457031e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.2947900390625000e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.2866200256347656e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.3942999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.3888101196289062e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.3868000793457031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.3888101196289062e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.3942999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.4147898864746094e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.4167999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.4147898864746094e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.4066198730468750e+02 -2.7950000000000000e+02 -1.2990200519561768e+00 2.3342999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.3288099670410156e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.3267999267578125e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.3288099670410156e+02 -2.7950000000000000e+02 1.2990200519561768e+00 2.3342999267578125e+02 -2.7950097656250000e+02 1.5071600675582886e+00 2.3449299621582031e+02 -2.7950000000000000e+02 7.5000000000000000e-01 2.3547900390625000e+02 -2.7950000000000000e+02 0.0000000000000000e+00 2.3567999267578125e+02 -2.7950000000000000e+02 -7.5000000000000000e-01 2.3547900390625000e+02 -2.7950000000000000e+02 -1.4617999792098999e+00 2.3466200256347656e+02 -2.7950000000000000e+02 -3.3638397216796875e+01 2.7381799316406250e+02 -2.7950000000000000e+02 -9.2807998657226562e+00 1.9352200317382812e+02 -2.7950601196289062e+02 -1.8257101058959961e+01 1.9571701049804688e+02 -2.7950000000000000e+02 -3.3638397216796875e+01 2.0654200744628906e+02 -2.7950000000000000e+02 -4.7114799499511719e+01 2.3554000854492188e+02 -2.7950000000000000e+02 -4.3950599670410156e+01 2.2197500610351562e+02 -2.7950000000000000e+02 -4.6657699584960938e+01 2.4946099853515625e+02 -2.7950000000000000e+02 -4.3950599670410156e+01 2.5838500976562500e+02 -2.7950900268554688e+02 -1.8005701065063477e+01 2.8483700561523438e+02 -2.7950000000000000e+02 -9.2807998657226562e+00 2.8683798217773438e+02 -2.7950000000000000e+02 9.2807998657226562e+00 2.8683798217773438e+02 -2.7950799560546875e+02 3.3912101745605469e+01 2.7431399536132812e+02 -2.7950601196289062e+02 3.9978900909423828e+01 2.6694100952148438e+02 -2.7950000000000000e+02 4.3950599670410156e+01 2.5838500976562500e+02 -2.7950000000000000e+02 4.7114799499511719e+01 2.4481999206542969e+02 -2.7950000000000000e+02 4.6657699584960938e+01 2.3089900207519531e+02 -2.7950601196289062e+02 2.6839698791503906e+01 2.0030699157714844e+02 -2.7950000000000000e+02 4.3950599670410156e+01 2.2197500610351562e+02 -2.7950000000000000e+02 9.2807998657226562e+00 1.9352200317382812e+02 -2.7951898193359375e+02 -2.1698299050331116e-01 1.9218699645996094e+02 -2.7951101684570312e+02 2.6748600006103516e+01 2.8020199584960938e+02 -2.7951898193359375e+02 2.1691900491714478e-01 2.8817300415039062e+02 -2.7971899414062500e+02 -4.4640701293945312e+01 2.5849499511718750e+02 -2.7971398925781250e+02 -4.7272399902343750e+01 2.4973001098632812e+02 -2.7979998779296875e+02 -4.0118900299072266e+01 2.6710900878906250e+02 -2.7979202270507812e+02 -3.3786201477050781e+01 2.7476300048828125e+02 -2.7988400268554688e+02 -2.6927801132202148e+01 2.8039498901367188e+02 -2.7966799926757812e+02 -9.3107805252075195e+00 2.8742901611328125e+02 -2.7967199707031250e+02 9.4774999618530273e+00 2.8739999389648438e+02 -2.7985998535156250e+02 1.8113899230957031e+01 2.8506198120117188e+02 -2.7975100708007812e+02 4.4566799163818359e+01 2.5876199340820312e+02 -2.7976800537109375e+02 4.7336002349853516e+01 2.4967900085449219e+02 -2.7972000122070312e+02 4.7333602905273438e+01 2.3082299804687500e+02 -2.7970999145507812e+02 4.8239700317382812e+01 2.4021199035644531e+02 -2.7970901489257812e+02 4.0158500671386719e+01 2.1344900512695312e+02 -2.7973397827148438e+02 4.4611598968505859e+01 2.2177400207519531e+02 -2.7972201538085938e+02 3.4166099548339844e+01 2.0610900878906250e+02 -2.7967199707031250e+02 9.3069105148315430e+00 1.9292601013183594e+02 -2.7972601318359375e+02 1.8522399902343750e+01 1.9562300109863281e+02 -2.7966799926757812e+02 -9.4862003326416016e+00 1.9296600341796875e+02 -2.7973300170898438e+02 -2.6756898880004883e+01 2.0001800537109375e+02 -2.7971600341796875e+02 -3.4061397552490234e+01 2.0601100158691406e+02 -2.7972998046875000e+02 -4.0083900451660156e+01 2.1331100463867188e+02 -2.7971200561523438e+02 -4.4537498474121094e+01 2.2163699340820312e+02 -2.7970401000976562e+02 -4.7297397613525391e+01 2.3070300292968750e+02 -2.8015802001953125e+02 -9.4640893936157227e+00 2.8775900268554688e+02 -2.8015802001953125e+02 0.0000000000000000e+00 2.8869100952148438e+02 -2.8015802001953125e+02 9.4640893936157227e+00 2.8775900268554688e+02 -2.8015802001953125e+02 9.4640893936157227e+00 1.9260099792480469e+02 -2.8015802001953125e+02 0.0000000000000000e+00 1.9166799926757812e+02 -2.8015802001953125e+02 -9.4640893936157227e+00 1.9260099792480469e+02 -2.7970999145507812e+02 -4.8226596832275391e+01 2.3989799499511719e+02 -2.8133599853515625e+02 2.2806900024414062e+01 2.8355099487304688e+02 -2.8150000000000000e+02 9.6276998519897461e+00 2.8858200073242188e+02 -2.8149798583984375e+02 2.3163299560546875e+01 2.8374401855468750e+02 -2.8117098999023438e+02 9.5360298156738281e+00 2.8812100219726562e+02 -2.8117098999023438e+02 0.0000000000000000e+00 2.8905999755859375e+02 -2.8150000000000000e+02 0.0000000000000000e+00 2.8952999877929688e+02 -2.8117098999023438e+02 -9.5360298156738281e+00 2.8812100219726562e+02 -2.8141799926757812e+02 -9.5363292694091797e+00 2.8830401611328125e+02 -2.8139498901367188e+02 -2.0226598739624023e+01 2.8494900512695312e+02 -2.8150000000000000e+02 -2.2243301391601562e+01 2.8423300170898438e+02 -2.8115600585937500e+02 -3.6367801666259766e+01 2.7289501953125000e+02 -2.8077700805664062e+02 -4.8170497894287109e+01 2.3059800720214844e+02 -2.8066302490234375e+02 -4.4998600006103516e+01 2.2148300170898438e+02 -2.8077700805664062e+02 -4.0837001800537109e+01 2.1289399719238281e+02 -2.8077700805664062e+02 -3.4729000091552734e+01 2.0545100402832031e+02 -2.8066500854492188e+02 -2.7022701263427734e+01 1.9962899780273438e+02 -2.8077700805664062e+02 -1.8795200347900391e+01 1.9480400085449219e+02 -2.8044900512695312e+02 -9.4847698211669922e+00 1.9249699401855469e+02 -2.8044900512695312e+02 0.0000000000000000e+00 1.9156199645996094e+02 -2.8044900512695312e+02 9.4847698211669922e+00 1.9249699401855469e+02 -2.8077700805664062e+02 1.8795200347900391e+01 1.9480400085449219e+02 -2.8077700805664062e+02 2.7286399841308594e+01 1.9934300231933594e+02 -2.8077700805664062e+02 3.4729000091552734e+01 2.0545100402832031e+02 -2.8077700805664062e+02 4.2348796844482422e+01 2.1572200012207031e+02 -2.8066302490234375e+02 4.5039299011230469e+01 2.2158200073242188e+02 -2.8077700805664062e+02 4.8170497894287109e+01 2.3059800720214844e+02 -2.8077700805664062e+02 4.9114200592041016e+01 2.4018000793457031e+02 -2.8095199584960938e+02 4.5644996643066406e+01 2.5846899414062500e+02 -2.8097799682617188e+02 4.1183200836181641e+01 2.6638497924804688e+02 -2.8112301635742188e+02 3.6668098449707031e+01 2.7250701904296875e+02 -2.8122601318359375e+02 3.0080699920654297e+01 2.7873297119140625e+02 -2.8092300415039062e+02 -4.2211902618408203e+01 2.6467599487304688e+02 -2.8095901489257812e+02 -4.5494796752929688e+01 2.5884500122070312e+02 -2.8077700805664062e+02 -4.9114200592041016e+01 2.4018000793457031e+02 -2.8071099853515625e+02 -4.7762901306152344e+01 2.4988499450683594e+02 -2.8129397583007812e+02 -3.0125499725341797e+01 2.7875997924804688e+02 -2.8143399047851562e+02 3.0355400085449219e+01 2.7906600952148438e+02 -2.8128399658203125e+02 3.6950302124023438e+01 2.7279000854492188e+02 -2.8112899780273438e+02 4.1498100280761719e+01 2.6666900634765625e+02 -2.8082299804687500e+02 4.8256401062011719e+01 2.4940100097656250e+02 -2.8128100585937500e+02 -3.7030902862548828e+01 2.7269799804687500e+02 -2.8109500122070312e+02 -4.2371799468994141e+01 2.6522500610351562e+02 -2.8144000244140625e+02 -2.9957799911499023e+01 2.7937500000000000e+02 -2.8150000000000000e+02 2.2243301391601562e+01 2.9293701171875000e+02 -2.8150000000000000e+02 -2.2243301391601562e+01 2.9293701171875000e+02 -2.8099398803710938e+02 2.2243301391601562e+01 3.1542398071289062e+02 -2.8099398803710938e+02 -2.2243301391601562e+01 3.1542398071289062e+02 -2.8077700805664062e+02 4.5375598907470703e+01 2.2138500976562500e+02 -2.8039898681640625e+02 4.7982799530029297e+01 2.1247700500488281e+02 -2.8077700805664062e+02 9.5816898345947266e+00 1.9200999450683594e+02 -2.8070599365234375e+02 9.4777908325195312e+00 1.9230000305175781e+02 -2.8077700805664062e+02 0.0000000000000000e+00 1.9106599426269531e+02 -2.8070501708984375e+02 -4.3487600982189178e-02 1.9137200927734375e+02 -2.8077700805664062e+02 -9.5816898345947266e+00 1.9200999450683594e+02 -2.8077700805664062e+02 -1.2650700569152832e+01 1.9294000244140625e+02 -2.8039898681640625e+02 -2.7702899932861328e+01 1.9219699096679688e+02 -2.8077700805664062e+02 -4.5375598907470703e+01 2.2138500976562500e+02 -2.8039898681640625e+02 5.5405799865722656e+01 2.9293701171875000e+02 -2.8039898681640625e+02 5.5405799865722656e+01 2.4018000793457031e+02 -2.6633599853515625e+02 -2.0874399185180664e+01 1.1893000030517578e+02 -2.6633599853515625e+02 2.0874399185180664e+01 1.1893000030517578e+02 -2.6633599853515625e+02 -2.0874399185180664e+01 1.0141999816894531e+02 -2.6633599853515625e+02 2.0874399185180664e+01 1.0141999816894531e+02 -2.6633599853515625e+02 1.8788000106811523e+01 1.2101699829101562e+02 -2.6640100097656250e+02 2.0244499206542969e+01 1.2050199890136719e+02 -2.6633599853515625e+02 -1.8788000106811523e+01 1.2101699829101562e+02 -2.6640100097656250e+02 -2.0359899520874023e+01 1.2038599395751953e+02 -2.6633599853515625e+02 -1.8788000106811523e+01 9.9333503723144531e+01 -2.6640100097656250e+02 -2.0244499206542969e+01 9.9847999572753906e+01 -2.6633599853515625e+02 1.8788000106811523e+01 9.9333503723144531e+01 -2.6640100097656250e+02 2.0359899520874023e+01 9.9963500976562500e+01 -2.8039898681640625e+02 -5.5405799865722656e+01 2.9293701171875000e+02 -2.8039898681640625e+02 -5.5405799865722656e+01 2.4018000793457031e+02 -2.8022500610351562e+02 3.3807502746582031e+01 3.3249899291992188e+02 -2.8022500610351562e+02 -3.3807502746582031e+01 3.3249899291992188e+02 -2.8039898681640625e+02 -5.3517898559570312e+01 2.2583999633789062e+02 -2.8039898681640625e+02 -4.7982799530029297e+01 2.1247700500488281e+02 -2.8039898681640625e+02 -3.9177803039550781e+01 2.0100199890136719e+02 -2.8039898681640625e+02 -1.4340000152587891e+01 1.8666200256347656e+02 -2.8039898681640625e+02 -9.5661296844482422e+00 1.8603399658203125e+02 -2.8039898681640625e+02 0.0000000000000000e+00 1.8477400207519531e+02 -2.8039898681640625e+02 9.5661296844482422e+00 1.8603399658203125e+02 -2.8039898681640625e+02 1.4340000152587891e+01 1.8666200256347656e+02 -2.8039898681640625e+02 2.7702899932861328e+01 1.9219699096679688e+02 -2.8039898681640625e+02 3.9177803039550781e+01 2.0100199890136719e+02 -2.8039898681640625e+02 5.3517898559570312e+01 2.2583999633789062e+02 -2.7948199462890625e+02 -3.3807502746582031e+01 3.3552499389648438e+02 -2.7948199462890625e+02 3.3807502746582031e+01 3.3552499389648438e+02 -2.7916699218750000e+02 6.1754699707031250e+01 3.3559201049804688e+02 -2.7951898193359375e+02 6.5778701782226562e+01 3.3342901611328125e+02 -2.8005902099609375e+02 4.9315696716308594e+01 3.3255300903320312e+02 -2.7944601440429688e+02 4.3945301055908203e+01 3.3551599121093750e+02 -2.7956100463867188e+02 6.8011100769042969e+01 3.1154998779296875e+02 -2.7954501342773438e+02 6.8004898071289062e+01 3.1883200073242188e+02 -2.7956100463867188e+02 6.8011100769042969e+01 2.4018000793457031e+02 -2.7633602905273438e+02 1.8788000106811523e+01 9.9682701110839844e+01 -2.7610998535156250e+02 1.9974599838256836e+01 1.0007900238037109e+02 -2.7633602905273438e+02 2.0525199890136719e+01 1.0141999816894531e+02 -2.7633602905273438e+02 -1.8788000106811523e+01 9.9682701110839844e+01 -2.7633602905273438e+02 -2.0525199890136719e+01 1.0141999816894531e+02 -2.7610998535156250e+02 -2.0129199981689453e+01 1.0023300170898438e+02 -2.7633602905273438e+02 -2.0525199890136719e+01 1.1893000030517578e+02 -2.7633602905273438e+02 -1.8788000106811523e+01 1.2066699981689453e+02 -2.7610998535156250e+02 -1.9974599838256836e+01 1.2027099609375000e+02 -2.7633602905273438e+02 1.8788000106811523e+01 1.2066699981689453e+02 -2.7633602905273438e+02 2.0525199890136719e+01 1.1893000030517578e+02 -2.7610998535156250e+02 2.0129199981689453e+01 1.2011700439453125e+02 -2.7956100463867188e+02 -6.8011100769042969e+01 3.1154998779296875e+02 -2.7956100463867188e+02 -6.8011100769042969e+01 2.4018000793457031e+02 -2.7954501342773438e+02 -6.8004898071289062e+01 3.1883200073242188e+02 -2.8005902099609375e+02 -4.9315696716308594e+01 3.3255300903320312e+02 -2.7950601196289062e+02 -6.6216300964355469e+01 3.3298098754882812e+02 -2.7940499877929688e+02 -4.8528900146484375e+01 3.3550598144531250e+02 -2.7917599487304688e+02 -6.2228900909423828e+01 3.3544097900390625e+02 -2.7956100463867188e+02 6.3909500122070312e+01 2.1691900634765625e+02 -2.7956100463867188e+02 6.6977905273437500e+01 2.2836999511718750e+02 -2.7956100463867188e+02 5.8899299621582031e+01 2.0617399597167969e+02 -2.7956100463867188e+02 5.2099498748779297e+01 1.9646299743652344e+02 -2.7956100463867188e+02 4.3716697692871094e+01 1.8808000183105469e+02 -2.7956100463867188e+02 3.4005500793457031e+01 1.8128100585937500e+02 -2.7956100463867188e+02 2.3261100769042969e+01 1.7626998901367188e+02 -2.7956100463867188e+02 1.1810000419616699e+01 1.7320199584960938e+02 -2.7956100463867188e+02 0.0000000000000000e+00 1.7216900634765625e+02 -2.7956100463867188e+02 -1.1810000419616699e+01 1.7320199584960938e+02 -2.7956100463867188e+02 -2.3261100769042969e+01 1.7626998901367188e+02 -2.7956100463867188e+02 -5.2099498748779297e+01 1.9646299743652344e+02 -2.7956100463867188e+02 -4.3716697692871094e+01 1.8808000183105469e+02 -2.7956100463867188e+02 -3.4005500793457031e+01 1.8128100585937500e+02 -2.7956100463867188e+02 -6.6977905273437500e+01 2.2836999511718750e+02 -2.7956100463867188e+02 -6.3909500122070312e+01 2.1691900634765625e+02 -2.7956100463867188e+02 -5.8899299621582031e+01 2.0617399597167969e+02 -2.7876098632812500e+02 -5.9254600524902344e+01 3.3608200073242188e+02 -2.7861099243164062e+02 -3.3807502746582031e+01 3.3610098266601562e+02 -2.7896600341796875e+02 -3.3807502746582031e+01 3.3602200317382812e+02 -2.7926998901367188e+02 -3.3807502746582031e+01 3.3582101440429688e+02 -2.7858999633789062e+02 3.8872798919677734e+01 3.3610202026367188e+02 -2.7896600341796875e+02 3.3807502746582031e+01 3.3602200317382812e+02 -2.7926998901367188e+02 3.3807502746582031e+01 3.3582101440429688e+02 -2.7876098632812500e+02 5.8920398712158203e+01 3.3607000732421875e+02 -2.7901901245117188e+02 6.8893592834472656e+01 3.2761199951171875e+02 -2.7898400878906250e+02 6.7545700073242188e+01 3.3116900634765625e+02 -2.7941302490234375e+02 6.8472702026367188e+01 3.1154998779296875e+02 -2.7906399536132812e+02 6.8810203552246094e+01 3.1154998779296875e+02 -2.7859802246093750e+02 6.8944099426269531e+01 2.4018000793457031e+02 -2.7906399536132812e+02 6.8810203552246094e+01 2.4018000793457031e+02 -2.7941302490234375e+02 6.8472702026367188e+01 2.4018000793457031e+02 -2.7633602905273438e+02 2.1425201416015625e+01 1.0141999816894531e+02 -2.7633602905273438e+02 1.8788000106811523e+01 9.8782699584960938e+01 -2.7633602905273438e+02 -1.8788000106811523e+01 9.8782699584960938e+01 -2.7633602905273438e+02 -2.1425201416015625e+01 1.0141999816894531e+02 -2.7633602905273438e+02 -2.1425201416015625e+01 1.1893000030517578e+02 -2.7633602905273438e+02 -1.8788000106811523e+01 1.2156700134277344e+02 -2.7633602905273438e+02 1.8788000106811523e+01 1.2156700134277344e+02 -2.7633602905273438e+02 2.1425201416015625e+01 1.1893000030517578e+02 -2.7859802246093750e+02 -6.8944099426269531e+01 2.4018000793457031e+02 -2.7906399536132812e+02 -6.8810203552246094e+01 3.1154998779296875e+02 -2.7906399536132812e+02 -6.8810203552246094e+01 2.4018000793457031e+02 -2.7941302490234375e+02 -6.8472702026367188e+01 3.1154998779296875e+02 -2.7941302490234375e+02 -6.8472702026367188e+01 2.4018000793457031e+02 -2.7922897338867188e+02 -6.8563995361328125e+01 3.2879498291015625e+02 -2.7883898925781250e+02 -6.8923194885253906e+01 3.2608602905273438e+02 -2.7927899169921875e+02 -6.7651100158691406e+01 2.2833399963378906e+02 -2.7913098144531250e+02 -6.4601600646972656e+01 2.1633300781250000e+02 -2.7927899169921875e+02 -5.9519802093505859e+01 2.0591099548339844e+02 -2.7927899169921875e+02 -4.4209400177001953e+01 1.8761999511718750e+02 -2.7927899169921875e+02 -2.3566799163818359e+01 1.7566999816894531e+02 -2.7927899169921875e+02 -1.2006799697875977e+01 1.7255699157714844e+02 -2.7927899169921875e+02 -8.1736698746681213e-02 1.7150000000000000e+02 -2.7927899169921875e+02 1.1845600128173828e+01 1.7252899169921875e+02 -2.7927899169921875e+02 2.3413200378417969e+01 1.7561399841308594e+02 -2.7927899169921875e+02 4.4084300994873047e+01 1.8751499938964844e+02 -2.7927899169921875e+02 5.9437999725341797e+01 2.0576899719238281e+02 -2.7913299560546875e+02 6.4612503051757812e+01 2.1636399841308594e+02 -2.7927899169921875e+02 6.7622695922851562e+01 2.2817300415039062e+02 -2.7888598632812500e+02 -5.2790000915527344e+01 1.9586799621582031e+02 -2.7888598632812500e+02 -3.4450798034667969e+01 1.8048500061035156e+02 -2.7888598632812500e+02 3.4471900939941406e+01 1.8049700927734375e+02 -2.7888598632812500e+02 5.2805698394775391e+01 1.9588699340820312e+02 -2.7859802246093750e+02 -6.7896697998046875e+01 2.2820800781250000e+02 -2.7859802246093750e+02 -5.9707401275634766e+01 2.0570799255371094e+02 -2.7859802246093750e+02 -4.4316501617431641e+01 1.8736599731445312e+02 -2.7859802246093750e+02 -2.3580198287963867e+01 1.7539399719238281e+02 -2.7859802246093750e+02 -1.1972000122070312e+01 1.7228298950195312e+02 -2.7859802246093750e+02 0.0000000000000000e+00 1.7123599243164062e+02 -2.7859802246093750e+02 1.1972000122070312e+01 1.7228298950195312e+02 -2.7859802246093750e+02 2.3580198287963867e+01 1.7539399719238281e+02 -2.7859802246093750e+02 4.4316501617431641e+01 1.8736599731445312e+02 -2.7859802246093750e+02 5.9707401275634766e+01 2.0570799255371094e+02 -2.7859802246093750e+02 6.7896697998046875e+01 2.2820800781250000e+02 -2.7695999145507812e+02 5.9007499694824219e+01 3.3615899658203125e+02 -2.7695999145507812e+02 -5.9007499694824219e+01 3.3615899658203125e+02 -2.7700000000000000e+02 6.7661499023437500e+01 3.3116098022460938e+02 -2.7698498535156250e+02 6.4137901306152344e+01 3.3488198852539062e+02 -2.7700000000000000e+02 6.9000000000000000e+01 3.2616299438476562e+02 -2.7700000000000000e+02 6.9000000000000000e+01 2.4018000793457031e+02 -2.7883599853515625e+02 2.5755298614501953e+01 1.1893000030517578e+02 -2.7883599853515625e+02 2.5755298614501953e+01 1.0141999816894531e+02 -2.7700100708007812e+02 2.3909099578857422e+01 1.0012800598144531e+02 -2.7700601196289062e+02 2.3925199508666992e+01 1.1893000030517578e+02 -2.7883599853515625e+02 1.8788000106811523e+01 9.4452598571777344e+01 -2.7700601196289062e+02 1.8788000106811523e+01 9.6282699584960938e+01 -2.7761199951171875e+02 2.1798500061035156e+01 9.6103698730468750e+01 -2.7883599853515625e+02 2.4821899414062500e+01 9.7936302185058594e+01 -2.7883599853515625e+02 -1.8788000106811523e+01 9.4452598571777344e+01 -2.7700601196289062e+02 -1.8788000106811523e+01 9.6282699584960938e+01 -2.7883599853515625e+02 -2.5755298614501953e+01 1.0141999816894531e+02 -2.7700601196289062e+02 -2.3925199508666992e+01 1.0141999816894531e+02 -2.7883599853515625e+02 -2.4821899414062500e+01 9.7936302185058594e+01 -2.7693099975585938e+02 -2.2173299789428711e+01 9.7509597778320312e+01 -2.7883599853515625e+02 -2.2271699905395508e+01 9.5386001586914062e+01 -2.7883599853515625e+02 -2.5755298614501953e+01 1.1893000030517578e+02 -2.7700100708007812e+02 -2.3909099578857422e+01 1.2022200012207031e+02 -2.7883599853515625e+02 -1.8788000106811523e+01 1.2589700317382812e+02 -2.7700601196289062e+02 -1.8788000106811523e+01 1.2406700134277344e+02 -2.7883599853515625e+02 -2.2271699905395508e+01 1.2496399688720703e+02 -2.7700601196289062e+02 -2.1356599807739258e+01 1.2337899780273438e+02 -2.7883599853515625e+02 -2.4821899414062500e+01 1.2241400146484375e+02 -2.7883599853515625e+02 1.8788000106811523e+01 1.2589700317382812e+02 -2.7700601196289062e+02 1.8788000106811523e+01 1.2406700134277344e+02 -2.7883599853515625e+02 2.4821899414062500e+01 1.2241400146484375e+02 -2.7693099975585938e+02 2.2173398971557617e+01 1.2284000396728516e+02 -2.7883599853515625e+02 2.2271699905395508e+01 1.2496399688720703e+02 -2.7700000000000000e+02 -3.4500000000000000e+01 1.8042401123046875e+02 -2.7700000000000000e+02 -4.0250598907470703e+01 1.7409100341796875e+02 -2.7700000000000000e+02 -4.8884899139404297e+01 1.8019599914550781e+02 -2.7700000000000000e+02 -5.2857002258300781e+01 1.9582800292968750e+02 -2.7700000000000000e+02 -1.1981699943542480e+01 1.7222799682617188e+02 -2.7700000000000000e+02 -1.0549699783325195e+01 1.6352101135253906e+02 -2.7700000000000000e+02 -2.0902299880981445e+01 1.6567500305175781e+02 -2.7700000000000000e+02 5.2857002258300781e+01 1.9582800292968750e+02 -2.7700000000000000e+02 5.7401500701904297e+01 1.8828700256347656e+02 -2.7700000000000000e+02 3.4500000000000000e+01 1.8042401123046875e+02 -2.7700000000000000e+02 4.8884899139404297e+01 1.8019599914550781e+02 -2.7700000000000000e+02 -5.7401500701904297e+01 1.8828700256347656e+02 -2.7700000000000000e+02 -6.4595298767089844e+01 1.9757400512695312e+02 -2.7700000000000000e+02 -6.5356300354003906e+01 2.1752400207519531e+02 -2.7700000000000000e+02 -7.0300300598144531e+01 2.0784201049804688e+02 -2.7700000000000000e+02 -7.3921897888183594e+01 2.1730200195312500e+02 -2.7700000000000000e+02 -3.0864599227905273e+01 1.6922099304199219e+02 -2.7700000000000000e+02 1.1981699943542480e+01 1.7222799682617188e+02 -2.7700000000000000e+02 1.0549699783325195e+01 1.6352101135253906e+02 -2.7700000000000000e+02 0.0000000000000000e+00 1.6279899597167969e+02 -2.7700000000000000e+02 4.0250598907470703e+01 1.7409100341796875e+02 -2.7700000000000000e+02 3.0864599227905273e+01 1.6922099304199219e+02 -2.7700000000000000e+02 2.0902299880981445e+01 1.6567500305175781e+02 -2.7700000000000000e+02 6.5355102539062500e+01 2.1752299499511719e+02 -2.7700000000000000e+02 7.3921897888183594e+01 2.1730200195312500e+02 -2.7700000000000000e+02 7.0300300598144531e+01 2.0784201049804688e+02 -2.7700000000000000e+02 6.4595298767089844e+01 1.9757400512695312e+02 -2.7748297119140625e+02 -7.2786193847656250e+01 2.0669900512695312e+02 -2.7748501586914062e+02 7.3077003479003906e+01 2.0738099670410156e+02 -2.7700000000000000e+02 -6.9000000000000000e+01 2.4018000793457031e+02 -2.7700000000000000e+02 -6.9000000000000000e+01 3.2616299438476562e+02 -2.7700000000000000e+02 -6.7661499023437500e+01 3.3116098022460938e+02 -2.7699200439453125e+02 -6.4175399780273438e+01 3.3492800903320312e+02 -2.7700000000000000e+02 6.5956100463867188e+01 2.1981900024414062e+02 -2.7501898193359375e+02 6.5958496093750000e+01 2.1966400146484375e+02 -2.7503500366210938e+02 6.5307800292968750e+01 2.1768600463867188e+02 -2.7700000000000000e+02 -6.5955993652343750e+01 2.1981900024414062e+02 -2.7503399658203125e+02 -6.5956298828125000e+01 2.1966500854492188e+02 -2.7502099609375000e+02 -6.5310401916503906e+01 2.1768699645996094e+02 -2.6716299438476562e+02 -7.5253097534179688e+01 3.5848901367187500e+02 -2.6822998046875000e+02 7.5252693176269531e+01 3.5825198364257812e+02 -2.6914700317382812e+02 -7.5252693176269531e+01 3.5764398193359375e+02 -2.7418899536132812e+02 7.5860000610351562e+01 3.4729702758789062e+02 -2.7418899536132812e+02 -7.5860000610351562e+01 3.4729702758789062e+02 -2.7700000000000000e+02 7.6206001281738281e+01 2.2005101013183594e+02 -2.7700000000000000e+02 -7.6206001281738281e+01 2.2005101013183594e+02 -2.7700000000000000e+02 7.6206001281738281e+01 3.3461801147460938e+02 -2.7628698730468750e+02 7.6118400573730469e+01 3.4112100219726562e+02 -2.7700000000000000e+02 -7.6206001281738281e+01 3.3461801147460938e+02 -2.8355398559570312e+02 2.8480300903320312e+01 1.0014999389648438e+02 -2.8402001953125000e+02 2.8751699447631836e+01 1.1893299865722656e+02 -2.8421899414062500e+02 1.8792299270629883e+01 9.1341896057128906e+01 -2.8383499145507812e+02 2.7262401580810547e+01 9.6366302490234375e+01 -2.8402502441406250e+02 2.5148900985717773e+01 9.3733398437500000e+01 -2.8385800170898438e+02 -1.8788000106811523e+01 9.1553199768066406e+01 -2.8447100830078125e+02 1.7882000207901001e+00 9.1199501037597656e+01 -2.8321701049804688e+02 -2.8284999847412109e+01 1.0141999816894531e+02 -2.8378601074218750e+02 -2.8082199096679688e+01 9.8189697265625000e+01 -2.8395700073242188e+02 -2.6388000488281250e+01 9.4970100402832031e+01 -2.8403500366210938e+02 -2.8756999969482422e+01 1.2029699707031250e+02 -2.8489801025390625e+02 -1.8788000106811523e+01 1.2939700317382812e+02 -2.8518798828125000e+02 -2.2377698898315430e+01 1.2895700073242188e+02 -2.8486999511718750e+02 -2.5379899978637695e+01 1.2705199432373047e+02 -2.8489801025390625e+02 1.8788000106811523e+01 1.2939700317382812e+02 -2.8552999877929688e+02 -1.5106799602508545e+00 1.2976199340820312e+02 -2.8415100097656250e+02 2.8267400741577148e+01 1.2225199890136719e+02 -2.8473300170898438e+02 2.4102399826049805e+01 1.2783999633789062e+02 -2.8468701171875000e+02 2.6757799148559570e+01 1.2554299926757812e+02 -2.8505599975585938e+02 2.0873300552368164e+01 1.2928800964355469e+02 -2.8100000000000000e+02 -2.2773700714111328e+01 1.5900500488281250e+02 -2.8100000000000000e+02 -1.1494199752807617e+01 1.5665798950195312e+02 -2.8559100341796875e+02 -1.1827199935913086e+01 1.5418901062011719e+02 -2.8100000000000000e+02 -3.3628002166748047e+01 1.6286698913574219e+02 -2.8420599365234375e+02 -3.4378398895263672e+01 1.6116499328613281e+02 -2.8100000000000000e+02 -4.3854301452636719e+01 1.6817399597167969e+02 -2.8292401123046875e+02 -4.3990001678466797e+01 1.6692001342773438e+02 -2.8100698852539062e+02 -5.2861602783203125e+01 1.7448100280761719e+02 -2.8590499877929688e+02 -1.7946500778198242e+01 1.5486900329589844e+02 -2.8471197509765625e+02 -2.9342399597167969e+01 1.5884600830078125e+02 -2.8100000000000000e+02 1.1494199752807617e+01 1.5665798950195312e+02 -2.8575997924804688e+02 8.3503103256225586e+00 1.5352400207519531e+02 -2.8100000000000000e+02 0.0000000000000000e+00 1.5587100219726562e+02 -2.8618301391601562e+02 -2.7565901279449463e+00 1.5291699218750000e+02 -2.8616397094726562e+02 -7.6162800788879395e+00 1.5320899963378906e+02 -2.8100000000000000e+02 2.2773700714111328e+01 1.5900500488281250e+02 -2.8524700927734375e+02 1.9091800689697266e+01 1.5554598999023438e+02 -2.8100000000000000e+02 3.3628002166748047e+01 1.6286698913574219e+02 -2.8404998779296875e+02 3.2379798889160156e+01 1.6043199157714844e+02 -2.8504400634765625e+02 2.1925600051879883e+01 1.5635600280761719e+02 -2.8100100708007812e+02 5.2727199554443359e+01 1.7439300537109375e+02 -2.8301400756835938e+02 4.3286201477050781e+01 1.6639100646972656e+02 -2.8100000000000000e+02 4.3854301452636719e+01 1.6817399597167969e+02 -2.7748297119140625e+02 -6.6879302978515625e+01 1.9606700134277344e+02 -2.7827398681640625e+02 -7.0865898132324219e+01 1.9915899658203125e+02 -2.7909201049804688e+02 -6.5646697998046875e+01 1.8966000366210938e+02 -2.7887200927734375e+02 -6.1216102600097656e+01 1.8483799743652344e+02 -2.8049298095703125e+02 -6.0334400177001953e+01 1.8134999084472656e+02 -2.7887200927734375e+02 4.2925399780273438e+01 1.6969900512695312e+02 -2.7887200927734375e+02 5.2133499145507812e+01 1.7621000671386719e+02 -2.7887200927734375e+02 6.1216102600097656e+01 1.8483799743652344e+02 -2.8010800170898438e+02 6.0573699951171875e+01 1.8229299926757812e+02 -2.7923797607421875e+02 6.6476203918457031e+01 1.9026799011230469e+02 -2.7748297119140625e+02 6.6879302978515625e+01 1.9606700134277344e+02 -2.7829598999023438e+02 7.0857505798339844e+01 1.9906900024414062e+02 -2.7748297119140625e+02 5.9431198120117188e+01 1.8645199584960938e+02 -2.7887200927734375e+02 3.2915699005126953e+01 1.6450500488281250e+02 -2.7887200927734375e+02 2.2291399002075195e+01 1.6072399902343750e+02 -2.7887200927734375e+02 1.1250699996948242e+01 1.5842700195312500e+02 -2.7887200927734375e+02 0.0000000000000000e+00 1.5765699768066406e+02 -2.7887200927734375e+02 -1.1250699996948242e+01 1.5842700195312500e+02 -2.7887200927734375e+02 -2.2291399002075195e+01 1.6072399902343750e+02 -2.7887200927734375e+02 -3.2915699005126953e+01 1.6450500488281250e+02 -2.7887200927734375e+02 -4.2925399780273438e+01 1.6969900512695312e+02 -2.7887200927734375e+02 -5.2133499145507812e+01 1.7621000671386719e+02 -2.7748297119140625e+02 5.0613498687744141e+01 1.7807499694824219e+02 -2.7748297119140625e+02 4.1673801422119141e+01 1.7175399780273438e+02 -2.7748297119140625e+02 3.1955902099609375e+01 1.6671200561523438e+02 -2.7748297119140625e+02 2.1641399383544922e+01 1.6304100036621094e+02 -2.7748297119140625e+02 1.0922699928283691e+01 1.6081100463867188e+02 -2.7748297119140625e+02 0.0000000000000000e+00 1.6006300354003906e+02 -2.7748297119140625e+02 -1.0922699928283691e+01 1.6081100463867188e+02 -2.7748297119140625e+02 -2.1641399383544922e+01 1.6304100036621094e+02 -2.7748297119140625e+02 -3.1955902099609375e+01 1.6671200561523438e+02 -2.7748297119140625e+02 -4.1673801422119141e+01 1.7175399780273438e+02 -2.7748297119140625e+02 -5.0613498687744141e+01 1.7807499694824219e+02 -2.7748297119140625e+02 -5.9431198120117188e+01 1.8645199584960938e+02 -2.5666299438476562e+02 7.2379501342773438e+01 3.5885598754882812e+02 -2.8410598754882812e+02 2.9441398620605469e+01 9.9966300964355469e+01 -2.8474798583984375e+02 1.8887899398803711e+01 9.0466796875000000e+01 -2.8536401367187500e+02 1.7977299690246582e+00 9.0112503051757812e+01 -2.8501599121093750e+02 1.7932599782943726e+00 9.0737098693847656e+01 -2.8440200805664062e+02 -1.8841400146484375e+01 9.1091300964355469e+01 -2.8413998413085938e+02 -2.9468498229980469e+01 1.0137799835205078e+02 -2.8566799926757812e+02 -1.8800699234008789e+01 1.3008500671386719e+02 -2.8625198364257812e+02 -1.5168800354003906e+00 1.3047698974609375e+02 -2.8184301757812500e+02 5.3419601440429688e+01 1.7381100463867188e+02 -2.8355700683593750e+02 4.3710197448730469e+01 1.6563198852539062e+02 -2.8483300781250000e+02 3.2758499145507812e+01 1.5974099731445312e+02 -2.8595599365234375e+02 2.0676700592041016e+01 1.5509100341796875e+02 -2.8653399658203125e+02 8.3569898605346680e+00 1.5276199340820312e+02 -2.8676998901367188e+02 -5.1830997467041016e+00 1.5197500610351562e+02 -2.8507098388671875e+02 -3.2218601226806641e+01 1.5889898681640625e+02 -2.8341299438476562e+02 -4.4683799743652344e+01 1.6629899597167969e+02 -2.8176501464843750e+02 -5.3474899291992188e+01 1.7399800109863281e+02 -2.1660099792480469e+02 1.4053698730468750e+02 2.7293098449707031e+01 -2.1696400451660156e+02 1.4055499267578125e+02 3.5564098358154297e+01 -2.0233599853515625e+02 1.4019699096679688e+02 2.7968799591064453e+01 -2.0273899841308594e+02 1.4020300292968750e+02 3.6213302612304688e+01 -2.0927398681640625e+02 1.4035800170898438e+02 2.3525598526000977e+01 -2.1006900024414062e+02 1.3977299499511719e+02 3.9989700317382812e+01 -2.0246400451660156e+02 1.3488299560546875e+02 2.7968000411987305e+01 -2.0285398864746094e+02 1.3489199829101562e+02 3.6207698822021484e+01 -2.1018299865722656e+02 1.3506999206542969e+02 3.9989700317382812e+01 -2.1712100219726562e+02 1.3523899841308594e+02 3.5531902313232422e+01 -2.1673100280761719e+02 1.3522900390625000e+02 2.7292200088500977e+01 -2.0940299987792969e+02 1.3505099487304688e+02 2.3510299682617188e+01 -2.0381799316406250e+02 1.3491598510742188e+02 2.8340600967407227e+01 -2.1095800781250000e+02 1.3508898925781250e+02 2.5140199661254883e+01 -2.1630599975585938e+02 1.3521899414062500e+02 3.3363700866699219e+01 -2.1122399902343750e+02 1.3477600097656250e+02 3.8257400512695312e+01 -2.0471900939941406e+02 1.3493699645996094e+02 3.6141700744628906e+01 -2.1593199157714844e+02 1.3467900085449219e+02 2.9138698577880859e+01 -2.0332499694824219e+02 1.3426800537109375e+02 3.0649700164794922e+01 -2.0852799987792969e+02 1.3439500427246094e+02 2.4785900115966797e+01 -2.1489801025390625e+02 1.3454901123046875e+02 3.6123600006103516e+01 -2.0509899902343750e+02 1.3431100463867188e+02 3.6530597686767578e+01 -2.1455599975585938e+02 9.4849700927734375e+01 3.0896099090576172e+01 -2.0866101074218750e+02 9.4714302062988281e+01 2.8427400588989258e+01 -2.1027299499511719e+02 9.4754302978515625e+01 3.5653900146484375e+01 -2.0683898925781250e+02 9.4678001403808594e+01 3.1909801483154297e+01 -2.0590400695800781e+02 1.3433100891113281e+02 3.1250499725341797e+01 -2.0596900939941406e+02 1.3433299255371094e+02 3.2616298675537109e+01 -2.0649699401855469e+02 1.3434500122070312e+02 3.3877601623535156e+01 -2.0742399597167969e+02 1.3436799621582031e+02 3.4882198333740234e+01 -2.0863800048828125e+02 1.3439700317382812e+02 3.5509098052978516e+01 -2.0999400329589844e+02 1.3443000793457031e+02 3.5682598114013672e+01 -2.1132800292968750e+02 1.3446299743652344e+02 3.5381702423095703e+01 -2.1247799682617188e+02 1.3449099731445312e+02 3.4642799377441406e+01 -2.1330599975585938e+02 1.3451098632812500e+02 3.3555000305175781e+01 -2.1311999511718750e+02 1.3450599670410156e+02 2.9622400283813477e+01 -2.1219299316406250e+02 1.3448399353027344e+02 2.8617700576782227e+01 -2.1097799682617188e+02 1.3445399475097656e+02 2.7990900039672852e+01 -2.0962199401855469e+02 1.3442100524902344e+02 2.7817399978637695e+01 -2.0828900146484375e+02 1.3438899230957031e+02 2.8118200302124023e+01 -2.1371200561523438e+02 1.3452099609375000e+02 3.2249500274658203e+01 -2.1364801025390625e+02 1.3451899719238281e+02 3.0883699417114258e+01 -2.0713900756835938e+02 1.3436099243164062e+02 2.8857101440429688e+01 -2.0630999755859375e+02 1.3434100341796875e+02 2.9944999694824219e+01 -2.1161199951171875e+02 9.5841896057128906e+01 3.5590499877929688e+01 -2.1287300109863281e+02 9.5872497558593750e+01 3.5062599182128906e+01 -2.1387701416015625e+02 9.5896896362304688e+01 3.4135200500488281e+01 -2.1450399780273438e+02 9.5912200927734375e+01 3.2919998168945312e+01 -2.1467700195312500e+02 9.5916297912597656e+01 3.1563798904418945e+01 -2.1437699890136719e+02 9.5909095764160156e+01 3.0230001449584961e+01 -2.1363798522949219e+02 9.5891105651855469e+01 2.9079500198364258e+01 -2.1255099487304688e+02 9.5864601135253906e+01 2.8251201629638672e+01 -2.1124499511718750e+02 9.5832901000976562e+01 2.7844799041748047e+01 -2.0987998962402344e+02 9.5799797058105469e+01 2.7909500122070312e+01 -2.0761500549316406e+02 9.5744697570800781e+01 2.9364799499511719e+01 -2.0724800109863281e+02 9.5735801696777344e+01 2.9944999694824219e+01 -2.0698800659179688e+02 9.5729499816894531e+01 3.0579900741577148e+01 -2.0711499023437500e+02 9.5732597351074219e+01 3.3270000457763672e+01 -2.0785400390625000e+02 9.5750602722167969e+01 3.4420402526855469e+01 -2.0894200134277344e+02 9.5777000427246094e+01 3.5248802185058594e+01 -2.0626899719238281e+02 9.5734100341796875e+01 2.6966600418090820e+01 -2.0880299377441406e+02 9.4338096618652344e+01 2.5833999633789062e+01 -2.1395100402832031e+02 9.6136894226074219e+01 2.6110500335693359e+01 -2.0443600463867188e+02 9.7533302307128906e+01 3.5364799499511719e+01 -2.0905200195312500e+02 9.4454994201660156e+01 3.7798801422119141e+01 -2.0465100097656250e+02 9.4232597351074219e+01 3.3004600524902344e+01 -2.1332200622558594e+02 9.6321296691894531e+01 3.7670097351074219e+01 -2.1425500488281250e+02 9.4453002929687500e+01 3.6538799285888672e+01 -2.1705900573730469e+02 9.5737899780273438e+01 3.2685199737548828e+01 -2.1561500549316406e+02 9.4506896972656250e+01 2.8056299209594727e+01 -2.1063200378417969e+02 1.0054899597167969e+02 2.4412900924682617e+01 -2.0427999877929688e+02 1.0038899993896484e+02 2.8080801010131836e+01 -2.1063000488281250e+02 1.0054899597167969e+02 3.9087001800537109e+01 -2.1698400878906250e+02 1.0070300292968750e+02 2.8082099914550781e+01 -2.1698300170898438e+02 1.0069799804687500e+02 3.5419097900390625e+01 -2.0764399719238281e+02 9.5060104370117188e+01 3.3953102111816406e+01 -2.1223999023437500e+02 9.5093299865722656e+01 3.5283100128173828e+01 -2.1138099670410156e+02 9.4519798278808594e+01 2.8017200469970703e+01 -2.0730400085449219e+02 9.4751403808593750e+01 3.1417100906372070e+01 -2.1423300170898438e+02 9.4589096069335938e+01 3.2300098419189453e+01 -2.0428300476074219e+02 1.0048100280761719e+02 3.5415702819824219e+01 -2.0909999084472656e+02 9.6602294921875000e+01 2.8049299240112305e+01 -2.1296299743652344e+02 9.6696098327636719e+01 2.8474699020385742e+01 -2.1467900085449219e+02 9.6737800598144531e+01 3.1427598953247070e+01 -2.0668199157714844e+02 9.6543495178222656e+01 3.1161100387573242e+01 -2.1406100463867188e+02 9.6722793579101562e+01 3.3940799713134766e+01 -2.0925199890136719e+02 9.6605895996093750e+01 3.5562900543212891e+01 -2.1210299682617188e+02 1.0069000244140625e+02 3.5562900543212891e+01 -2.1471301269531250e+02 1.0075299835205078e+02 3.2536102294921875e+01 -2.1237200927734375e+02 1.0069599914550781e+02 2.7767499923706055e+01 -2.0814900207519531e+02 1.0059300231933594e+02 3.5089599609375000e+01 -2.0664698791503906e+02 1.0055699920654297e+02 3.0006200790405273e+01 -1.9365699768066406e+02 1.1536000061035156e+02 8.0995498657226562e+01 -1.9482099914550781e+02 1.1014000701904297e+02 8.0995498657226562e+01 -1.9046899414062500e+02 1.1183000183105469e+02 8.0995498657226562e+01 -1.8854800415039062e+02 1.0725000000000000e+02 8.0995498657226562e+01 -1.8659199523925781e+02 1.2271899414062500e+02 8.0995498657226562e+01 -1.8441400146484375e+02 1.2598499298095703e+02 8.0995498657226562e+01 -1.9053100585937500e+02 1.2633700561523438e+02 8.0995498657226562e+01 -1.8577699279785156e+02 1.1154499816894531e+02 8.0995498657226562e+01 -1.8201200866699219e+02 1.0940200042724609e+02 8.0995498657226562e+01 -1.8263299560546875e+02 1.1919800567626953e+02 8.0995498657226562e+01 -1.7928199768066406e+02 1.2140000152587891e+02 8.0995498657226562e+01 -1.9774499511718750e+02 1.1636900329589844e+02 8.0995498657226562e+01 -1.9224899291992188e+02 1.2107899475097656e+02 8.0995498657226562e+01 -1.9563299560546875e+02 1.2294400024414062e+02 8.0995498657226562e+01 -1.8260000610351562e+02 1.1508499908447266e+02 8.0995498657226562e+01 -1.7864799499511719e+02 1.1452300262451172e+02 8.0995498657226562e+01 -1.8517300415039062e+02 1.2229100036621094e+02 7.7972892761230469e+01 -1.9215899658203125e+02 1.2132299804687500e+02 7.7972892761230469e+01 -1.9354100036621094e+02 1.1500199890136719e+02 7.7972892761230469e+01 -1.9019000244140625e+02 1.1170600128173828e+02 7.7972892761230469e+01 -1.8543400573730469e+02 1.1169799804687500e+02 7.7972892761230469e+01 -1.8212600708007812e+02 1.1657199859619141e+02 7.7972892761230469e+01 -1.8855599975585938e+02 1.2665798950195312e+02 7.7972892761230469e+01 -1.8336500549316406e+02 1.2541100311279297e+02 7.7972892761230469e+01 -1.7951300048828125e+02 1.2164299774169922e+02 7.7972892761230469e+01 -1.7842599487304688e+02 1.1561299896240234e+02 7.7972892761230469e+01 -1.8117900085449219e+02 1.1014000701904297e+02 7.7972892761230469e+01 -1.8745199584960938e+02 1.0725000000000000e+02 7.7972892761230469e+01 -1.9529299926757812e+02 1.1033999633789062e+02 7.7972892761230469e+01 -1.9766299438476562e+02 1.1841300201416016e+02 7.7972892761230469e+01 -1.9424700927734375e+02 1.2438700103759766e+02 7.7972892761230469e+01 -1.9069400024414062e+02 1.2364499664306641e+02 8.1051399230957031e+01 -1.9020700073242188e+02 1.2393299865722656e+02 8.2956405639648438e+01 -1.8684899902343750e+02 1.2407700347900391e+02 8.1051399230957031e+01 -1.8354701232910156e+02 1.2294100189208984e+02 8.2956405639648438e+01 -1.8251100158691406e+02 1.2177700042724609e+02 8.1051399230957031e+01 -1.8086000061035156e+02 1.1766600036621094e+02 8.2956405639648438e+01 -1.8083601379394531e+02 1.1731299591064453e+02 8.1051399230957031e+01 -1.8191200256347656e+02 1.1301500701904297e+02 8.2956405639648438e+01 -1.8171699523925781e+02 1.1354499816894531e+02 8.1051399230957031e+01 -1.8533700561523438e+02 1.1022900390625000e+02 8.1051399230957031e+01 -1.8675700378417969e+02 1.0983100128173828e+02 8.2956405639648438e+01 -1.9113099670410156e+02 1.1043199920654297e+02 8.1051399230957031e+01 -1.9322000122070312e+02 1.1172100067138672e+02 8.2956405639648438e+01 -1.9444599914550781e+02 1.1385900115966797e+02 8.1051399230957031e+01 -1.9516400146484375e+02 1.1731299591064453e+02 8.2956405639648438e+01 -1.9501901245117188e+02 1.1721900177001953e+02 8.1053199768066406e+01 -1.9426800537109375e+02 1.2053400421142578e+02 8.2937500000000000e+01 -1.9375399780273438e+02 1.2127799987792969e+02 8.1051399230957031e+01 -1.8475100708007812e+02 1.2836000061035156e+02 8.2974395751953125e+01 -1.9644898986816406e+02 1.2500000000000000e+02 8.2987304687500000e+01 -1.9351400756835938e+02 1.0687500000000000e+02 8.2984100341796875e+01 -1.8780000305175781e+02 1.0543999481201172e+02 8.2978302001953125e+01 -1.7723100280761719e+02 1.1180700683593750e+02 8.2979095458984375e+01 -1.7804400634765625e+02 1.2287099456787109e+02 8.2983001708984375e+01 -1.8980400085449219e+02 1.2252600097656250e+02 8.1050598144531250e+01 -1.8613800048828125e+02 1.2232700347900391e+02 8.1121398925781250e+01 -1.8325000000000000e+02 1.2039600372314453e+02 8.1050796508789062e+01 -1.8710899353027344e+02 1.1135900115966797e+02 8.1050201416015625e+01 -1.9139700317382812e+02 1.1227400207519531e+02 8.1052307128906250e+01 -1.9383299255371094e+02 1.1686100006103516e+02 8.1051902770996094e+01 -1.8270700073242188e+02 1.1424399566650391e+02 8.1048500061035156e+01 -1.9988299560546875e+02 1.1784400177001953e+02 8.3342498779296875e+01 -2.0110900878906250e+02 1.2201499938964844e+02 8.5996902465820312e+01 -2.0055900573730469e+02 1.1065200042724609e+02 8.6017799377441406e+01 -1.9811900329589844e+02 1.1054199981689453e+02 8.3441696166992188e+01 -1.7429701232910156e+02 1.1492600250244141e+02 8.6061798095703125e+01 -1.7653100585937500e+02 1.0869999694824219e+02 8.6263801574707031e+01 -1.7786599731445312e+02 1.2668399810791016e+02 8.5996795654296875e+01 -1.8209800720214844e+02 1.0447299957275391e+02 8.5985694885253906e+01 -1.7441600036621094e+02 1.1907699584960938e+02 8.5961402893066406e+01 -1.9412800598144531e+02 1.2940600585937500e+02 8.5950599670410156e+01 -1.9274499511718750e+02 1.2072100067138672e+02 8.4840301513671875e+01 -1.8823599243164062e+02 1.2275599670410156e+02 8.4827102661132812e+01 -1.9335299682617188e+02 1.1456199645996094e+02 8.4311401367187500e+01 -1.8878099060058594e+02 1.1118199920654297e+02 8.4830406188964844e+01 -1.8327200317382812e+02 1.1333300018310547e+02 8.4836494445800781e+01 -1.8252099609375000e+02 1.1931999969482422e+02 8.4828399658203125e+01 -1.7958200073242188e+02 1.3464500427246094e+02 8.4197296142578125e+01 -1.7445700073242188e+02 1.3103199768066406e+02 8.1033599853515625e+01 -1.7644799804687500e+02 1.3110700988769531e+02 8.6101501464843750e+01 -1.8641099548339844e+02 1.3072499084472656e+02 8.5978904724121094e+01 -1.9142399597167969e+02 1.0339300537109375e+02 8.5985496520996094e+01 -2.0359300231933594e+02 1.1033300018310547e+02 8.6712501525878906e+01 -2.0207501220703125e+02 1.2600199890136719e+02 8.6652702331542969e+01 -2.0576300048828125e+02 1.1784200286865234e+02 8.6273796081542969e+01 -2.0505599975585938e+02 1.2624800109863281e+02 8.4821594238281250e+01 -2.0720700073242188e+02 1.2019000244140625e+02 8.4162597656250000e+01 -1.9671499633789062e+02 1.3123300170898438e+02 8.6669105529785156e+01 -2.0091000366210938e+02 1.3149200439453125e+02 8.4548301696777344e+01 -1.9220800781250000e+02 1.3507800292968750e+02 8.5775398254394531e+01 -1.9608200073242188e+02 1.3469700622558594e+02 8.4211296081542969e+01 -1.8632000732421875e+02 1.3313299560546875e+02 8.6656097412109375e+01 -1.8486499023437500e+02 1.3507099914550781e+02 8.5867195129394531e+01 -1.8930499267578125e+02 1.3656799316406250e+02 8.3667396545410156e+01 -1.7439498901367188e+02 1.2658199310302734e+02 8.6648796081542969e+01 -1.7245001220703125e+02 1.2850900268554688e+02 8.4564094543457031e+01 -1.7193199157714844e+02 1.1431800079345703e+02 8.6646301269531250e+01 -1.7051400756835938e+02 1.2148300170898438e+02 8.6182296752929688e+01 -1.7456799316406250e+02 1.0560099792480469e+02 8.6343902587890625e+01 -1.7060600280761719e+02 1.1092700195312500e+02 8.5808502197265625e+01 -1.7147799682617188e+02 1.0652700042724609e+02 8.4008399963378906e+01 -1.8170599365234375e+02 1.0197200012207031e+02 8.6650398254394531e+01 -1.8063500976562500e+02 1.0003900146484375e+02 8.5752799987792969e+01 -1.8978199768066406e+02 9.9882797241210938e+01 8.6612205505371094e+01 -1.8898199462890625e+02 9.7604995727539062e+01 8.4569496154785156e+01 -1.8356500244140625e+02 9.8027099609375000e+01 8.3793495178222656e+01 -1.9428601074218750e+02 9.8683502197265625e+01 8.4624404907226562e+01 -2.0059199523925781e+02 1.0548899841308594e+02 8.6612899780273438e+01 -2.0005000305175781e+02 1.0166899871826172e+02 8.4346397399902344e+01 -1.6929699707031250e+02 1.2272900390625000e+02 8.4055297851562500e+01 -1.6883799743652344e+02 1.1409100341796875e+02 8.4584197998046875e+01 -1.6851300048828125e+02 1.1616999816894531e+02 8.1033699035644531e+01 -1.7724198913574219e+02 1.0078299713134766e+02 8.4125602722167969e+01 -1.7573100280761719e+02 1.0185000610351562e+02 8.1033897399902344e+01 -2.0507598876953125e+02 1.0775999450683594e+02 8.4532402038574219e+01 -2.0449900817871094e+02 1.0657999420166016e+02 8.1036399841308594e+01 -2.0703099060058594e+02 1.1320500183105469e+02 8.4152999877929688e+01 -2.0749800109863281e+02 1.1640699768066406e+02 8.1035102844238281e+01 -1.9778799438476562e+02 1.3404299926757812e+02 8.1028701782226562e+01 -1.8957600402832031e+02 1.3646200561523438e+02 8.1030395507812500e+01 -2.0260499572753906e+02 1.2985398864746094e+02 8.1030693054199219e+01 -2.0619200134277344e+02 1.2435299682617188e+02 8.1032997131347656e+01 -2.0660301208496094e+02 1.1130300140380859e+02 8.1030693054199219e+01 -2.0037899780273438e+02 1.0189399719238281e+02 8.1029800415039062e+01 -1.9439700317382812e+02 9.8547195434570312e+01 8.1031005859375000e+01 -1.8781599426269531e+02 9.7466201782226562e+01 8.1031600952148438e+01 -1.8145201110839844e+02 9.8624000549316406e+01 8.1029495239257812e+01 -1.7049600219726562e+02 1.0813699340820312e+02 8.1027999877929688e+01 -1.6977799987792969e+02 1.2427700042724609e+02 8.1027900695800781e+01 -1.8141398620605469e+02 1.3548500061035156e+02 8.1028198242187500e+01 -1.8792900085449219e+02 1.0552299499511719e+02 8.4854293823242188e+01 -1.7770401000976562e+02 1.1229000091552734e+02 8.4860305786132812e+01 -1.9434700012207031e+02 1.2623399353027344e+02 8.4860000610351562e+01 -1.9848999023437500e+02 1.1966499328613281e+02 8.4866302490234375e+01 -1.9824198913574219e+02 1.1202099609375000e+02 8.4858901977539062e+01 -1.7866200256347656e+02 1.2360900115966797e+02 8.4860694885253906e+01 -1.8691299438476562e+02 1.2795099639892578e+02 8.4858596801757812e+01 -2.0914300537109375e+02 1.1630999755859375e+02 8.1027297973632812e+01 -2.0712399291992188e+02 1.2602199554443359e+02 8.1032798767089844e+01 -2.0205000305175781e+02 1.3269999694824219e+02 8.1031303405761719e+01 -1.9608599853515625e+02 1.3644699096679688e+02 8.1031501770019531e+01 -1.8963000488281250e+02 1.3797200012207031e+02 8.1029495239257812e+01 -1.8463400268554688e+02 1.3771299743652344e+02 8.1030693054199219e+01 -1.7802600097656250e+02 1.3565600585937500e+02 8.1027595520019531e+01 -1.7159100341796875e+02 1.3019999694824219e+02 8.1031204223632812e+01 -1.6761199951171875e+02 1.2267400360107422e+02 8.1029602050781250e+01 -1.6710501098632812e+02 1.1446800231933594e+02 8.1031303405761719e+01 -1.6893800354003906e+02 1.0807499694824219e+02 8.1028900146484375e+01 -1.7410600280761719e+02 1.0101100158691406e+02 8.1028900146484375e+01 -1.8136500549316406e+02 9.7029296875000000e+01 8.1031303405761719e+01 -1.8794999694824219e+02 9.5957695007324219e+01 8.1031394958496094e+01 -1.9302200317382812e+02 9.6624702453613281e+01 8.1030693054199219e+01 -1.9778298950195312e+02 9.8392799377441406e+01 8.1033500671386719e+01 -2.0314100646972656e+02 1.0239200592041016e+02 8.1030899047851562e+01 -2.0700000000000000e+02 1.0788700103759766e+02 8.1031600952148438e+01 -1.7859899902343750e+02 1.0793499755859375e+02 8.7316993713378906e+01 -1.9809399414062500e+02 1.2536099243164062e+02 8.7261604309082031e+01 -1.8961000061035156e+02 1.3811099243164062e+02 8.4056495666503906e+01 -1.8153298950195312e+02 1.3696398925781250e+02 8.4081199645996094e+01 -1.7664100646972656e+02 1.3445199584960938e+02 8.5114204406738281e+01 -1.7206999206542969e+02 1.3083000183105469e+02 8.3636299133300781e+01 -1.6897499084472656e+02 1.2587800598144531e+02 8.3772193908691406e+01 -1.6727600097656250e+02 1.1999599456787109e+02 8.4837493896484375e+01 -1.6739700317382812e+02 1.1321700286865234e+02 8.4670799255371094e+01 -1.6869400024414062e+02 1.0905599975585938e+02 8.4795700073242188e+01 -1.7136299133300781e+02 1.0444899749755859e+02 8.5090103149414062e+01 -1.7518000793457031e+02 1.0038800048828125e+02 8.4710906982421875e+01 -1.8020201110839844e+02 9.7583602905273438e+01 8.4723701477050781e+01 -1.8544999694824219e+02 9.6250900268554688e+01 8.4744804382324219e+01 -1.9044900512695312e+02 9.6274101257324219e+01 8.5099800109863281e+01 -1.9526300048828125e+02 9.7531295776367188e+01 8.5476303100585938e+01 -2.0294700622558594e+02 1.0220700073242188e+02 8.4657806396484375e+01 -2.0686599731445312e+02 1.0799700164794922e+02 8.4838798522949219e+01 -2.0867900085449219e+02 1.1374399566650391e+02 8.4781196594238281e+01 -2.0880799865722656e+02 1.1945800018310547e+02 8.4697700500488281e+01 -2.0713500976562500e+02 1.2551100921630859e+02 8.4680702209472656e+01 -2.0331799316406250e+02 1.3140800476074219e+02 8.4776702880859375e+01 -1.9713699340820312e+02 1.3578700256347656e+02 8.5056495666503906e+01 -2.0624099731445312e+02 1.1794100189208984e+02 8.7690299987792969e+01 -2.0489199829101562e+02 1.2430500030517578e+02 8.7681503295898438e+01 -2.0301799011230469e+02 1.1479000091552734e+02 8.8097404479980469e+01 -2.0062400817871094e+02 1.1412599945068359e+02 8.7219398498535156e+01 -1.9949499511718750e+02 1.3134799194335938e+02 8.7693099975585938e+01 -1.9088099670410156e+02 1.3416000366210938e+02 8.8170799255371094e+01 -1.9245399475097656e+02 1.2917800903320312e+02 8.7279701232910156e+01 -1.8699200439453125e+02 1.3713999938964844e+02 8.6281097412109375e+01 -1.8623100280761719e+02 1.3101199340820312e+02 8.8016502380371094e+01 -1.7079100036621094e+02 1.2727199554443359e+02 8.6338806152343750e+01 -1.7073599243164062e+02 1.2329199981689453e+02 8.7767700195312500e+01 -1.7039300537109375e+02 1.1352399444580078e+02 8.7960899353027344e+01 -1.7441700744628906e+02 1.2101099395751953e+02 8.7954902648925781e+01 -1.7273199462890625e+02 1.0725600433349609e+02 8.7798202514648438e+01 -1.7937100219726562e+02 1.0297399902343750e+02 8.8209304809570312e+01 -1.8537899780273438e+02 1.0373699951171875e+02 8.7587699890136719e+01 -1.9451899719238281e+02 1.0151300048828125e+02 8.8257095336914062e+01 -2.0461300659179688e+02 1.1086799621582031e+02 8.7901901245117188e+01 -1.9997000122070312e+02 1.0528299713134766e+02 8.8090896606445312e+01 -2.0156799316406250e+02 1.2579800415039062e+02 8.8226799011230469e+01 -1.8174099731445312e+02 1.3415600585937500e+02 8.7764396667480469e+01 -1.7840299987792969e+02 1.2749299621582031e+02 8.8044898986816406e+01 -1.7602400207519531e+02 1.3082299804687500e+02 8.7668899536132812e+01 -1.7543399047851562e+02 1.1186800384521484e+02 8.7672195434570312e+01 -1.7742100524902344e+02 1.0151699829101562e+02 8.7452705383300781e+01 -1.8609599304199219e+02 9.8635192871093750e+01 8.7633903503417969e+01 -1.9601899719238281e+02 1.0589900207519531e+02 8.7567298889160156e+01 -2.0180299377441406e+02 1.0417900085449219e+02 8.7365203857421875e+01 -2.0691398620605469e+02 1.1121700286865234e+02 8.6564697265625000e+01 -1.9449299621582031e+02 1.2077500152587891e+02 8.3277999877929688e+01 -1.9372200012207031e+02 1.2682999420166016e+02 8.3161506652832031e+01 -1.9792999267578125e+02 1.2123500061035156e+02 8.3216400146484375e+01 -1.9491499328613281e+02 1.1441699981689453e+02 8.3278800964355469e+01 -1.9931599426269531e+02 1.1337000274658203e+02 8.2832702636718750e+01 -1.9196900939941406e+02 1.1088500213623047e+02 8.3279602050781250e+01 -1.9428500366210938e+02 1.0683800506591797e+02 8.2687805175781250e+01 -1.8499200439453125e+02 1.0570300292968750e+02 8.3145698547363281e+01 -1.7830699157714844e+02 1.2380000305175781e+02 8.2689598083496094e+01 -1.8218000793457031e+02 1.2589399719238281e+02 8.3254600524902344e+01 -1.8233700561523438e+02 1.2177299499511719e+02 8.3323204040527344e+01 -1.8215200805664062e+02 1.2924600219726562e+02 7.9937599182128906e+01 -1.8839999389648438e+02 1.2907699584960938e+02 8.2506599426269531e+01 -1.9838699340820312e+02 1.2572200775146484e+02 7.9823699951171875e+01 -2.0114999389648438e+02 1.2043800354003906e+02 7.9909805297851562e+01 -1.7846200561523438e+02 1.1074700164794922e+02 8.3165603637695312e+01 -1.7591600036621094e+02 1.1743900299072266e+02 8.2434494018554688e+01 -1.8203500366210938e+02 1.0481300354003906e+02 7.9597694396972656e+01 -1.8786099243164062e+02 1.0336799621582031e+02 7.9614601135253906e+01 -1.7769299316406250e+02 1.0815200042724609e+02 7.9572998046875000e+01 -1.7491799926757812e+02 1.1333000183105469e+02 7.9162200927734375e+01 -1.7449499511718750e+02 1.1882399749755859e+02 7.9597000122070312e+01 -1.7722299194335938e+02 1.2534299468994141e+02 7.9629898071289062e+01 -1.8755300903320312e+02 1.3055099487304688e+02 7.9626296997070312e+01 -1.9347499084472656e+02 1.2947900390625000e+02 7.9580902099609375e+01 -2.0132899475097656e+02 1.1450800323486328e+02 7.9598396301269531e+01 -1.9928300476074219e+02 1.0942299652099609e+02 7.9580101013183594e+01 -1.9466899108886719e+02 1.0511600494384766e+02 7.9558601379394531e+01 -1.8767898559570312e+02 1.0962599945068359e+02 8.3273902893066406e+01 -1.8340901184082031e+02 1.1133699798583984e+02 8.3273902893066406e+01 -1.8829399108886719e+02 1.2450399780273438e+02 8.3273902893066406e+01 -1.8057400512695312e+02 1.1588300323486328e+02 8.3273902893066406e+01 -1.8695700073242188e+02 1.2443699645996094e+02 8.0995498657226562e+01 -1.9295500183105469e+02 1.2247100067138672e+02 8.0995498657226562e+01 -1.9535699462890625e+02 1.1759600067138672e+02 8.0995498657226562e+01 -1.9377101135253906e+02 1.1239799499511719e+02 8.0995498657226562e+01 -1.8905700683593750e+02 1.0969499969482422e+02 8.0995498657226562e+01 -1.8376899719238281e+02 1.1095099639892578e+02 8.0995498657226562e+01 -1.8077500915527344e+02 1.1548699951171875e+02 8.0995498657226562e+01 -1.8169799804687500e+02 1.2084200286865234e+02 8.0995498657226562e+01 -1.7440000915527344e+02 1.1726599884033203e+02 7.4335098266601562e+01 -1.7552499389648438e+02 1.2255300140380859e+02 7.3965698242187500e+01 -1.7942900085449219e+02 1.2780999755859375e+02 7.3908905029296875e+01 -1.8627799987792969e+02 1.3052900695800781e+02 7.4340301513671875e+01 -1.7672300720214844e+02 1.0936400604248047e+02 7.4328498840332031e+01 -1.8915000915527344e+02 1.0335099792480469e+02 7.3868499755859375e+01 -1.8127999877929688e+02 1.0500000000000000e+02 7.4305603027343750e+01 -1.9754199218750000e+02 1.0729700469970703e+02 7.4380302429199219e+01 -1.9450500488281250e+02 1.0500700378417969e+02 7.3812202453613281e+01 -2.0103800964355469e+02 1.1268500518798828e+02 7.4274398803710938e+01 -1.9099800109863281e+02 1.3022500610351562e+02 7.4296302795410156e+01 -1.9575900268554688e+02 1.2825700378417969e+02 7.4314102172851562e+01 -1.9972000122070312e+02 1.2388999938964844e+02 7.4688499450683594e+01 -2.0139500427246094e+02 1.1937500000000000e+02 7.4346702575683594e+01 -1.8962899780273438e+02 1.0732099914550781e+02 8.0994895935058594e+01 -1.9672499084472656e+02 1.1149500274658203e+02 8.0958206176757812e+01 -1.7819400024414062e+02 1.2035700225830078e+02 8.0950401306152344e+01 -1.9002600097656250e+02 1.2735299682617188e+02 8.0960403442382812e+01 -1.8230599975585938e+02 1.2555999755859375e+02 8.0957099914550781e+01 -1.7978399658203125e+02 1.1101499938964844e+02 8.0981407165527344e+01 -1.9666198730468750e+02 1.2247299957275391e+02 8.0960304260253906e+01 -1.8446501159667969e+02 1.0062599945068359e+02 7.3618003845214844e+01 -1.7933799743652344e+02 1.0266199493408203e+02 7.3618598937988281e+01 -1.8474200439453125e+02 1.3352699279785156e+02 7.3619201660156250e+01 -1.7726998901367188e+02 1.2998500061035156e+02 7.3618499755859375e+01 -1.7126100158691406e+02 1.1511900329589844e+02 7.3617698669433594e+01 -1.7238299560546875e+02 1.2331400299072266e+02 7.3619400024414062e+01 -1.7417300415039062e+02 1.0737899780273438e+02 7.3617195129394531e+01 -1.9125599670410156e+02 1.0047299957275391e+02 7.3618896484375000e+01 -1.9764999389648438e+02 1.0330699920654297e+02 7.3620101928710938e+01 -2.0402699279785156e+02 1.1212500000000000e+02 7.3618003845214844e+01 -2.0466400146484375e+02 1.2023600006103516e+02 7.3617797851562500e+01 -2.0150900268554688e+02 1.2681800079345703e+02 7.3616104125976562e+01 -1.9795399475097656e+02 1.3058898925781250e+02 7.3617797851562500e+01 -1.9153698730468750e+02 1.3337400817871094e+02 7.3618499755859375e+01 -1.7806201171875000e+02 1.1411399841308594e+02 8.0705001831054688e+01 -1.8371499633789062e+02 1.0732699584960938e+02 8.0626396179199219e+01 -1.9978498840332031e+02 1.1673200225830078e+02 7.8686599731445312e+01 -1.9162699890136719e+02 1.0571700286865234e+02 7.8608001708984375e+01 -2.0157499694824219e+02 1.0718499755859375e+02 7.3621902465820312e+01 -1.8557099914550781e+02 1.0542099761962891e+02 7.8161796569824219e+01 -1.8057099914550781e+02 1.0773500061035156e+02 7.8212402343750000e+01 -1.7711799621582031e+02 1.1240399932861328e+02 7.8173599243164062e+01 -1.7613699340820312e+02 1.1783999633789062e+02 7.8188705444335938e+01 -1.7811700439453125e+02 1.2346400451660156e+02 7.8200302124023438e+01 -1.8211399841308594e+02 1.2732699584960938e+02 7.8205902099609375e+01 -1.8785000610351562e+02 1.2881100463867188e+02 7.8199897766113281e+01 -1.9331300354003906e+02 1.2762599945068359e+02 7.8182197570800781e+01 -1.9816400146484375e+02 1.2308399963378906e+02 7.8166900634765625e+01 -1.9739399719238281e+02 1.0958499908447266e+02 7.8123397827148438e+01 -1.8991899108886719e+02 1.3358900451660156e+02 7.1337402343750000e+01 -1.8554000854492188e+02 1.3357000732421875e+02 7.1339103698730469e+01 -1.8029199218750000e+02 1.3187300109863281e+02 7.1339195251464844e+01 -1.7387100219726562e+02 1.2641100311279297e+02 7.1341300964355469e+01 -1.7115600585937500e+02 1.1719699859619141e+02 7.1343498229980469e+01 -1.7309300231933594e+02 1.0915700531005859e+02 7.1339195251464844e+01 -1.7629499816894531e+02 1.0508900451660156e+02 7.1337097167968750e+01 -1.7976400756835938e+02 1.0241300201416016e+02 7.1339599609375000e+01 -1.8494799804687500e+02 1.0052799987792969e+02 7.1343498229980469e+01 -1.9046400451660156e+02 1.0043000030517578e+02 7.1339797973632812e+01 -1.9707901000976562e+02 1.0282500457763672e+02 7.1301902770996094e+01 -2.0185899353027344e+02 1.0758999633789062e+02 7.1339500427246094e+01 -2.0458200073242188e+02 1.1403299713134766e+02 7.1343498229980469e+01 -2.0430400085449219e+02 1.2081400299072266e+02 7.1304298400878906e+01 -2.0218499755859375e+02 1.2591099548339844e+02 7.1343498229980469e+01 -1.9621301269531250e+02 1.3185699462890625e+02 7.1338897705078125e+01 -1.7410301208496094e+02 1.1969800567626953e+02 7.1410697937011719e+01 -2.0220799255371094e+02 1.1673300170898438e+02 7.1382003784179688e+01 -1.9726300048828125e+02 1.2798300170898438e+02 7.1451301574707031e+01 -1.8713999938964844e+02 1.0338700103759766e+02 7.1480903625488281e+01 -1.9195700073242188e+02 1.2834799194335938e+02 7.3250900268554688e+01 -1.9650801086425781e+02 1.2516600036621094e+02 7.3576599121093750e+01 -1.9960099792480469e+02 1.2009300231933594e+02 7.3698997497558594e+01 -1.9901100158691406e+02 1.1253300476074219e+02 7.3517097473144531e+01 -1.8660800170898438e+02 1.0526000213623047e+02 7.3831901550292969e+01 -1.9180700683593750e+02 1.0576200103759766e+02 7.3530303955078125e+01 -1.8148599243164062e+02 1.0690100097656250e+02 7.2586898803710938e+01 -1.7690499877929688e+02 1.1216699981689453e+02 7.2676895141601562e+01 -1.7846200561523438e+02 1.2398899841308594e+02 7.3822296142578125e+01 -1.7640798950195312e+02 1.1949300384521484e+02 7.3647300720214844e+01 -1.8349400329589844e+02 1.2811599731445312e+02 7.3660202026367188e+01 -1.8238699340820312e+02 1.2941999816894531e+02 7.1836997985839844e+01 -1.9631799316406250e+02 1.0708699798583984e+02 7.2135299682617188e+01 -1.9046099853515625e+02 9.8268005371093750e+01 7.7010299682617188e+01 -1.8775500488281250e+02 1.0164900207519531e+02 7.3211997985839844e+01 -1.8901400756835938e+02 1.0392800140380859e+02 7.8126800537109375e+01 -1.8395901489257812e+02 1.0147100067138672e+02 8.4004798889160156e+01 -1.8787500000000000e+02 1.0262699890136719e+02 7.9661399841308594e+01 -1.8824000549316406e+02 1.0024800109863281e+02 8.7392898559570312e+01 -1.9174900817871094e+02 1.0005999755859375e+02 8.3025199890136719e+01 -2.3464700317382812e+02 1.1813300323486328e+02 2.7176599502563477e+01 -2.3507099914550781e+02 1.1814399719238281e+02 3.1744598388671875e+01 -2.3593600463867188e+02 1.0605799865722656e+02 3.0372400283813477e+01 -2.3464900207519531e+02 1.1813300323486328e+02 3.6312801361083984e+01 -2.3593600463867188e+02 1.0555500030517578e+02 3.3710300445556641e+01 -2.3339498901367188e+02 1.1810299682617188e+02 4.0725498199462891e+01 -2.3455200195312500e+02 1.0576499938964844e+02 4.0198097229003906e+01 -2.3542599487304688e+02 1.0604599761962891e+02 3.7001399993896484e+01 -2.3323699951171875e+02 1.0574800109863281e+02 4.3278297424316406e+01 -2.3135200500488281e+02 1.1805299377441406e+02 4.4832599639892578e+01 -2.3151100158691406e+02 1.0535099792480469e+02 4.6229499816894531e+01 -2.2858900451660156e+02 1.1798600006103516e+02 4.8494300842285156e+01 -2.2946398925781250e+02 1.0590100097656250e+02 4.8758399963378906e+01 -2.2519999694824219e+02 1.1790399932861328e+02 5.1585700988769531e+01 -2.2712500000000000e+02 1.0532200622558594e+02 5.1096698760986328e+01 -2.2130101013183594e+02 1.1780899810791016e+02 5.4001598358154297e+01 -2.2442900085449219e+02 1.0552700042724609e+02 5.3097499847412109e+01 -2.1519599914550781e+02 1.0555400085449219e+02 5.6783798217773438e+01 -2.1849699401855469e+02 1.0529100036621094e+02 5.5953102111816406e+01 -2.1702499389648438e+02 1.1770500183105469e+02 5.5659801483154297e+01 -2.2151400756835938e+02 1.0570800018310547e+02 5.4718200683593750e+01 -2.1251699829101562e+02 1.1759600067138672e+02 5.6503696441650391e+01 -2.1186700439453125e+02 1.0495600128173828e+02 5.7209400177001953e+01 -2.0793099975585938e+02 1.1748400115966797e+02 5.6504699707031250e+01 -2.0856599426269531e+02 1.0528299713134766e+02 5.7149398803710938e+01 -2.0342199707031250e+02 1.1737500000000000e+02 5.5662700653076172e+01 -2.0526200866699219e+02 1.0531300354003906e+02 5.6671199798583984e+01 -1.9914500427246094e+02 1.1727099609375000e+02 5.4006401062011719e+01 -2.0206800842285156e+02 1.0479100036621094e+02 5.5798900604248047e+01 -1.9350500488281250e+02 1.0479199981689453e+02 5.0714797973632812e+01 -1.9618399047851562e+02 1.0462599945068359e+02 5.2822196960449219e+01 -1.9524600219726562e+02 1.1717599487304688e+02 5.1592201232910156e+01 -1.9899299621582031e+02 1.0516099548339844e+02 5.4462898254394531e+01 -1.9185600280761719e+02 1.1709400177001953e+02 4.8502201080322266e+01 -1.8909100341796875e+02 1.1702700042724609e+02 4.4841800689697266e+01 -1.9109199523925781e+02 1.0443199920654297e+02 4.8238197326660156e+01 -1.8699299621582031e+02 1.1705899810791016e+02 4.0623798370361328e+01 -1.8754100036621094e+02 1.0454399871826172e+02 4.2757598876953125e+01 -1.8536500549316406e+02 1.1693599700927734e+02 3.1755298614501953e+01 -1.8508900451660156e+02 1.0482299804687500e+02 3.3127502441406250e+01 -1.8579000854492188e+02 1.1694599914550781e+02 3.6323303222656250e+01 -1.8547999572753906e+02 1.0457199859619141e+02 3.6437500000000000e+01 -1.8578800964355469e+02 1.1694599914550781e+02 2.7187200546264648e+01 -1.8511100769042969e+02 1.0427300262451172e+02 2.9792999267578125e+01 -1.8704199218750000e+02 1.1697699737548828e+02 2.2774400711059570e+01 -1.8648500061035156e+02 1.0459700012207031e+02 2.3301898956298828e+01 -1.8559899902343750e+02 1.0483500671386719e+02 2.6498600006103516e+01 -1.8780000305175781e+02 1.0464499664306641e+02 2.0221700668334961e+01 -1.8908500671386719e+02 1.1702600097656250e+02 1.8667299270629883e+01 -1.8952499389648438e+02 1.0441000366210938e+02 1.7301099777221680e+01 -1.9184799194335938e+02 1.1709400177001953e+02 1.5005599975585938e+01 -1.9156100463867188e+02 1.0497999572753906e+02 1.4741499900817871e+01 -1.9523699951171875e+02 1.1717599487304688e+02 1.1914199829101562e+01 -1.9393501281738281e+02 1.0479799652099609e+02 1.2408199310302734e+01 -1.9913600158691406e+02 1.1726999664306641e+02 9.4983596801757812e+00 -1.9660800170898438e+02 1.0485099792480469e+02 1.0402400016784668e+01 -2.0582899475097656e+02 1.0532700347900391e+02 6.7161297798156738e+00 -2.0258699035644531e+02 1.0504399871826172e+02 7.5374798774719238e+00 -2.0341200256347656e+02 1.1737400054931641e+02 7.8401603698730469e+00 -1.9953500366210938e+02 1.0463999938964844e+02 8.7465000152587891e+00 -2.0791999816894531e+02 1.1748400115966797e+02 6.9962100982666016e+00 -2.1250599670410156e+02 1.1759500122070312e+02 6.9952001571655273e+00 -2.0960499572753906e+02 1.0475199890136719e+02 6.2999701499938965e+00 -2.1701499938964844e+02 1.1770500183105469e+02 7.8372302055358887e+00 -2.1577299499511719e+02 1.0507199859619141e+02 6.8020200729370117e+00 -2.2129200744628906e+02 1.1780899810791016e+02 9.4935302734375000e+00 -2.1896900939941406e+02 1.0564599609375000e+02 7.7274398803710938e+00 -2.2519099426269531e+02 1.1790399932861328e+02 1.1907799720764160e+01 -2.2489399719238281e+02 1.0567499542236328e+02 1.0724299430847168e+01 -2.2206500244140625e+02 1.0528299713134766e+02 9.0236701965332031e+00 -2.2753300476074219e+02 1.0532599639892578e+02 1.2758700370788574e+01 -2.2858099365234375e+02 1.1798600006103516e+02 1.4997700691223145e+01 -2.3134599304199219e+02 1.1805299377441406e+02 1.8658201217651367e+01 -2.3085899353027344e+02 1.0580399322509766e+02 1.6513399124145508e+01 -2.3339100646972656e+02 1.1810299682617188e+02 2.2764400482177734e+01 -2.3351701354980469e+02 1.0546299743652344e+02 2.0742500305175781e+01 -2.3555799865722656e+02 1.0578800201416016e+02 2.7062299728393555e+01 -2.3471299743652344e+02 1.0602799987792969e+02 2.3837299346923828e+01 -1.8567800903320312e+02 1.2956500244140625e+02 3.9646301269531250e+01 -1.8696301269531250e+02 1.2908099365234375e+02 4.2754798889160156e+01 -1.9056600952148438e+02 1.2942799377441406e+02 4.8320301055908203e+01 -1.8859599304199219e+02 1.2912100219726562e+02 4.5658599853515625e+01 -1.9292100524902344e+02 1.2922599792480469e+02 5.0706600189208984e+01 -1.9555099487304688e+02 1.2974899291992188e+02 5.2808799743652344e+01 -1.9840499877929688e+02 1.2935900878906250e+02 5.4462898254394531e+01 -2.0141899108886719e+02 1.2994799804687500e+02 5.5788101196289062e+01 -2.0467500305175781e+02 1.2951199340820312e+02 5.6671199798583984e+01 -2.1460800170898438e+02 1.2975299072265625e+02 5.6783798217773438e+01 -2.1125199890136719e+02 1.3017900085449219e+02 5.7208900451660156e+01 -2.0797399902343750e+02 1.2979200744628906e+02 5.7154201507568359e+01 -2.2090699768066406e+02 1.3055799865722656e+02 5.4757900238037109e+01 -2.1785700988769531e+02 1.3009400939941406e+02 5.5962699890136719e+01 -2.2382899475097656e+02 1.2997700500488281e+02 5.3085300445556641e+01 -2.2649400329589844e+02 1.3004200744628906e+02 5.1087299346923828e+01 -2.3091400146484375e+02 1.3065699768066406e+02 4.6193901062011719e+01 -2.2888400268554688e+02 1.3034799194335938e+02 4.8761798858642578e+01 -2.3263700866699219e+02 1.3043299865722656e+02 4.3278198242187500e+01 -2.3395199584960938e+02 1.3048200988769531e+02 4.0198200225830078e+01 -2.3484500122070312e+02 1.3077500915527344e+02 3.7036300659179688e+01 -2.3532099914550781e+02 1.3057800292968750e+02 3.3698001861572266e+01 -2.3534800720214844e+02 1.3025698852539062e+02 3.0372400283813477e+01 -2.3412500000000000e+02 1.3022700500488281e+02 2.3837299346923828e+01 -2.3495700073242188e+02 1.3050801086425781e+02 2.7062299728393555e+01 -2.3288999938964844e+02 1.3070799255371094e+02 2.0716300964355469e+01 -2.2692399597167969e+02 1.3029399108886719e+02 1.2777600288391113e+01 -2.2932400512695312e+02 1.3065100097656250e+02 1.5233599662780762e+01 -2.3125100708007812e+02 1.3040800476074219e+02 1.7823299407958984e+01 -2.2427299499511719e+02 1.3047100830078125e+02 1.0688400268554688e+01 -2.2144400024414062e+02 1.2991900634765625e+02 9.0371398925781250e+00 -2.1839599609375000e+02 1.3018499755859375e+02 7.7172498703002930e+00 -2.1517401123046875e+02 1.2976699829101562e+02 6.8287796974182129e+00 -2.0857499694824219e+02 1.3005900573730469e+02 6.2936496734619141e+00 -2.1185000610351562e+02 1.3018600463867188e+02 6.3295998573303223e+00 -2.0522500610351562e+02 1.2996800231933594e+02 6.6925301551818848e+00 -2.0198400878906250e+02 1.2970800781250000e+02 7.5355801582336426e+00 -1.9891999816894531e+02 1.2983700561523438e+02 8.7516899108886719e+00 -1.9602000427246094e+02 1.2930099487304688e+02 1.0414699554443359e+01 -1.9333801269531250e+02 1.2948399353027344e+02 1.2404300689697266e+01 -1.8890998840332031e+02 1.2964999389648438e+02 1.7304201126098633e+01 -1.9097299194335938e+02 1.2917900085449219e+02 1.4741499900817871e+01 -1.8720098876953125e+02 1.2932899475097656e+02 2.0221700668334961e+01 -1.8588499450683594e+02 1.2931500244140625e+02 2.3301898956298828e+01 -1.8501100158691406e+02 1.2903399658203125e+02 2.6498600006103516e+01 -1.8449499511718750e+02 1.2956599426269531e+02 2.9808000564575195e+01 -1.8487899780273438e+02 1.2929100036621094e+02 3.6437702178955078e+01 -1.8450100708007812e+02 1.2902101135253906e+02 3.3127502441406250e+01 -2.0396299743652344e+02 1.0482600402832031e+02 5.7641201019287109e+01 -1.8840299987792969e+02 1.0456700134277344e+02 1.5661100387573242e+01 -1.8464599609375000e+02 1.0448600006103516e+02 2.2992700576782227e+01 -2.1554000854492188e+02 1.0510700225830078e+02 5.5148000717163086e+00 -1.9475000000000000e+02 1.0473500061035156e+02 5.4073402404785156e+01 -2.3747799682617188e+02 1.0563199615478516e+02 3.2897800445556641e+01 -2.2267100524902344e+02 1.0571800231933594e+02 6.2027602195739746e+00 -2.2519400024414062e+02 1.0534200286865234e+02 5.4071399688720703e+01 -2.1381401062011719e+02 1.0520999908447266e+02 5.8910999298095703e+01 -1.8699499511718750e+02 1.0441400146484375e+02 4.4390102386474609e+01 -2.3217100524902344e+02 1.0573600006103516e+02 1.4430000305175781e+01 -2.2291499328613281e+02 1.3041700744628906e+02 8.4498500823974609e+00 -2.3212899780273438e+02 1.3063398742675781e+02 1.6920101165771484e+01 -1.9852900695800781e+02 1.2981800842285156e+02 7.5899400711059570e+00 -1.8989799499511719e+02 1.2961199951171875e+02 1.4250800132751465e+01 -1.8760900878906250e+02 1.2918099975585938e+02 4.8956199645996094e+01 -1.9498999023437500e+02 1.2960200500488281e+02 5.4632801055908203e+01 -2.2850100708007812e+02 1.3041499328613281e+02 5.1784400939941406e+01 -2.3362199401855469e+02 1.3023500061035156e+02 4.7191898345947266e+01 -2.1078399658203125e+02 1.3012998962402344e+02 5.1063899993896484e+00 -2.1056599426269531e+02 1.3011900329589844e+02 5.8422302246093750e+01 -2.3644000244140625e+02 1.3073899841308594e+02 2.8699998855590820e+01 -2.0100000000000000e+02 1.2967201232910156e+02 5.7760002136230469e+01 -1.8383100891113281e+02 1.2928399658203125e+02 2.3280000686645508e+01 -1.8468699645996094e+02 1.2926300048828125e+02 4.2792701721191406e+01 -2.3672200012207031e+02 1.0889800262451172e+02 1.5041699409484863e+01 -2.3970199584960938e+02 1.1119200134277344e+02 1.9575700759887695e+01 -2.3604499816894531e+02 1.1111499786376953e+02 1.3056099891662598e+01 -2.4094599914550781e+02 1.1122599792480469e+02 2.3159700393676758e+01 -2.4148500061035156e+02 1.0907199859619141e+02 2.8636098861694336e+01 -2.4173100280761719e+02 1.1194100189208984e+02 2.6836599349975586e+01 -2.4209199523925781e+02 1.1195000457763672e+02 3.0580999374389648e+01 -2.4202400207519531e+02 1.1124400329589844e+02 3.4340499877929688e+01 -1.9825399780273438e+02 1.0799299621582031e+02 6.0397499084472656e+01 -1.9473500061035156e+02 1.1006800079345703e+02 5.9352600097656250e+01 -2.0133900451660156e+02 1.1026699829101562e+02 6.2181201934814453e+01 -1.7880700683593750e+02 1.0973600006103516e+02 3.4937400817871094e+01 -1.7893699645996094e+02 1.2432099914550781e+02 3.8205600738525391e+01 -1.8037399291992188e+02 1.0748300170898438e+02 3.9816299438476562e+01 -1.8039500427246094e+02 1.0974600219726562e+02 4.2131500244140625e+01 -1.8236700439453125e+02 1.0483399963378906e+02 3.5680099487304688e+01 -1.8211500549316406e+02 1.0489600372314453e+02 2.9081199645996094e+01 -1.9662500000000000e+02 1.0510200500488281e+02 7.0828800201416016e+00 -2.3756900024414062e+02 1.0624299621582031e+02 2.2742799758911133e+01 -2.3324699401855469e+02 1.0602100372314453e+02 4.8713298797607422e+01 -2.0706799316406250e+02 1.0568099975585938e+02 6.0327899932861328e+01 -1.9804200744628906e+02 1.0539299774169922e+02 5.7624702453613281e+01 -1.8763099670410156e+02 1.0512100219726562e+02 4.9044696807861328e+01 -1.8382600402832031e+02 1.0511700439453125e+02 4.2536499023437500e+01 -1.9048500061035156e+02 1.0527799987792969e+02 1.1073800086975098e+01 -2.0213299560546875e+02 1.0556100463867188e+02 4.2111301422119141e+00 -2.0883401489257812e+02 1.0572399902343750e+02 3.0145599842071533e+00 -2.1562799072265625e+02 1.0588899993896484e+02 3.4258401393890381e+00 -2.3934700012207031e+02 1.0646200561523438e+02 3.0938999176025391e+01 -2.3782398986816406e+02 1.0642500305175781e+02 4.1035598754882812e+01 -2.2655200195312500e+02 1.0615499877929688e+02 5.5642398834228516e+01 -2.2049299621582031e+02 1.0600800323486328e+02 5.8744400024414062e+01 -2.1405300903320312e+02 1.0630699920654297e+02 6.0902301788330078e+01 -2.0304200744628906e+02 1.0726200103759766e+02 6.1533802032470703e+01 -1.9139300537109375e+02 1.0575599670410156e+02 5.4054100036621094e+01 -1.8048300170898438e+02 1.0653799438476562e+02 2.5947999954223633e+01 -1.8395001220703125e+02 1.0557500457763672e+02 1.9198299407958984e+01 -1.8646099853515625e+02 1.0685399627685547e+02 1.2632800102233887e+01 -2.2824000549316406e+02 1.0665100097656250e+02 8.3531103134155273e+00 -2.3517300415039062e+02 1.0715299987792969e+02 1.4878699302673340e+01 -2.3070700073242188e+02 1.0792900085449219e+02 5.4812801361083984e+01 -2.1058699035644531e+02 1.0794699859619141e+02 6.2708698272705078e+01 -1.9327400207519531e+02 1.0752700042724609e+02 5.7502998352050781e+01 -1.8770700073242188e+02 1.0739099884033203e+02 5.2746501922607422e+01 -1.8341299438476562e+02 1.0728699493408203e+02 4.6815200805664062e+01 -1.7951998901367188e+02 1.0719300079345703e+02 3.2802700042724609e+01 -1.8169599914550781e+02 1.0740599822998047e+02 1.9858600616455078e+01 -1.9156399536132812e+02 1.0748499298095703e+02 7.2245001792907715e+00 -1.9785099792480469e+02 1.0763800048828125e+02 3.4728598594665527e+00 -2.0484399414062500e+02 1.0780799865722656e+02 1.3034299612045288e+00 -2.1214999389648438e+02 1.0798500061035156e+02 8.3761596679687500e-01 -2.1936100769042969e+02 1.0816100311279297e+02 2.1014800071716309e+00 -2.2607398986816406e+02 1.0832399749755859e+02 5.0243101119995117e+00 -2.3191200256347656e+02 1.0846500396728516e+02 9.4425096511840820e+00 -2.3972700500488281e+02 1.0865499877929688e+02 2.1706499099731445e+01 -2.4108200073242188e+02 1.0868799591064453e+02 3.6186901092529297e+01 -2.3918299865722656e+02 1.0864199829101562e+02 4.3259502410888672e+01 -2.3567700195312500e+02 1.0855699920654297e+02 4.9688201904296875e+01 -2.2470500183105469e+02 1.0829000091552734e+02 5.9230701446533203e+01 -2.1785299682617188e+02 1.0812400054931641e+02 6.1810699462890625e+01 -2.1226699829101562e+02 1.1025600433349609e+02 6.3438602447509766e+01 -2.0500401306152344e+02 1.1034799957275391e+02 6.3038700103759766e+01 -1.9131399536132812e+02 1.1001899719238281e+02 5.7125301361083984e+01 -1.8796800231933594e+02 1.0961599731445312e+02 5.4172000885009766e+01 -1.8367601013183594e+02 1.0983100128173828e+02 4.8894599914550781e+01 -1.8183399963378906e+02 1.0977700042724609e+02 4.5609001159667969e+01 -1.7867300415039062e+02 1.0943399810791016e+02 3.0889600753784180e+01 -1.7971199035644531e+02 1.0973600006103516e+02 2.3606498718261719e+01 -1.8089199829101562e+02 1.0975400543212891e+02 2.0028799057006836e+01 -1.8281799316406250e+02 1.0956300354003906e+02 1.6046600341796875e+01 -1.8681600952148438e+02 1.0990999603271484e+02 1.0490500450134277e+01 -1.8985598754882812e+02 1.0967399597167969e+02 7.5737199783325195e+00 -1.9568899536132812e+02 1.1012500000000000e+02 3.6118600368499756e+00 -1.9912500000000000e+02 1.1019599914550781e+02 2.0675101280212402e+00 -2.0327799987792969e+02 1.1005099487304688e+02 8.1694597005844116e-01 -2.1015899658203125e+02 1.1047699737548828e+02 1.4207300264388323e-03 -2.1392401123046875e+02 1.1054699707031250e+02 1.9820399582386017e-01 -2.1762500000000000e+02 1.1065299987792969e+02 8.3656996488571167e-01 -2.2122200012207031e+02 1.1072699737548828e+02 1.9071099758148193e+00 -2.2468000793457031e+02 1.1081700134277344e+02 3.4004998207092285e+00 -2.2833700561523438e+02 1.1065000152587891e+02 5.5679702758789062e+00 -2.3365299987792969e+02 1.1103399658203125e+02 1.0150300025939941e+01 -2.4149499511718750e+02 1.1123000335693359e+02 3.8068500518798828e+01 -2.4052500915527344e+02 1.1138299560546875e+02 4.1714702606201172e+01 -2.3914698791503906e+02 1.1116200256347656e+02 4.5187397003173828e+01 -2.3735099792480469e+02 1.1112400054931641e+02 4.8504901885986328e+01 -2.3499000549316406e+02 1.1081299591064453e+02 5.1810302734375000e+01 -2.2983200073242188e+02 1.1094900512695312e+02 5.6846099853515625e+01 -2.2672499084472656e+02 1.1087100219726562e+02 5.8971900939941406e+01 -2.2339099121093750e+02 1.1079199981689453e+02 6.0713600158691406e+01 -2.1989099121093750e+02 1.1069300079345703e+02 6.2042400360107422e+01 -2.1623001098632812e+02 1.1061100006103516e+02 6.2957397460937500e+01 -1.8323699951171875e+02 1.2944300842285156e+02 3.3221900939941406e+01 -2.3670800781250000e+02 1.3048799133300781e+02 3.8426601409912109e+01 -2.3880200195312500e+02 1.2531800842285156e+02 4.5190402984619141e+01 -2.3901300048828125e+02 1.2759700775146484e+02 4.2971599578857422e+01 -2.4115100097656250e+02 1.2535500335693359e+02 3.8070102691650391e+01 -2.1029501342773438e+02 1.2714299774169922e+02 6.2707401275634766e+01 -2.1214100646972656e+02 1.2466799926757812e+02 6.3429103851318359e+01 -2.0839700317382812e+02 1.2456400299072266e+02 6.3456401824951172e+01 -2.0478900146484375e+02 1.2700299835205078e+02 6.2218200683593750e+01 -2.0465899658203125e+02 1.2447500610351562e+02 6.3038600921630859e+01 -1.9968299865722656e+02 1.2755400085449219e+02 6.0564201354980469e+01 -2.0099400329589844e+02 1.2438300323486328e+02 6.2180500030517578e+01 -1.9432400512695312e+02 1.2479999542236328e+02 5.9329498291015625e+01 -1.9208300781250000e+02 1.2767800903320312e+02 5.6278797149658203e+01 -1.9096800231933594e+02 1.2414699554443359e+02 5.7123798370361328e+01 -1.8736000061035156e+02 1.2658600616455078e+02 5.2874301910400391e+01 -1.8809500122070312e+02 1.2408300018310547e+02 5.4680599212646484e+01 -1.8554598999023438e+02 1.2400800323486328e+02 5.1933502197265625e+01 -1.8303201293945312e+02 1.2648099517822266e+02 4.6967300415039062e+01 -1.8333299255371094e+02 1.2397100067138672e+02 4.8895500183105469e+01 -1.8149000549316406e+02 1.2389700317382812e+02 4.5608402252197266e+01 -1.7991400146484375e+02 1.2451600646972656e+02 4.1679100036621094e+01 -1.7895700073242188e+02 1.2639300537109375e+02 3.1156898498535156e+01 -1.7845300292968750e+02 1.2384100341796875e+02 3.4796901702880859e+01 -1.7831500244140625e+02 1.2384500122070312e+02 3.1028699874877930e+01 -1.7862098693847656e+02 1.2383999633789062e+02 2.7290599822998047e+01 -1.8087100219726562e+02 1.2709699249267578e+02 2.2319101333618164e+01 -1.7936801147460938e+02 1.2387400054931641e+02 2.3607099533081055e+01 -1.8054998779296875e+02 1.2388099670410156e+02 2.0026899337768555e+01 -1.8365000915527344e+02 1.2649600219726562e+02 1.5486100196838379e+01 -1.8384901428222656e+02 1.2422899627685547e+02 1.3829999923706055e+01 -1.8820600891113281e+02 1.2660600280761719e+02 9.7534599304199219e+00 -1.8647399902343750e+02 1.2403699493408203e+02 1.0488900184631348e+01 -1.8915901184082031e+02 1.2410800170898438e+02 7.8452200889587402e+00 -1.9398100280761719e+02 1.2674699401855469e+02 5.2517600059509277e+00 -1.9212500000000000e+02 1.2416699981689453e+02 5.5463299751281738e+00 -1.9534500122070312e+02 1.2426100158691406e+02 3.6118600368499756e+00 -2.0065000915527344e+02 1.2690900421142578e+02 2.2326700687408447e+00 -1.9878399658203125e+02 1.2432400512695312e+02 2.0667300224304199e+00 -2.0549299621582031e+02 1.2474600219726562e+02 3.3572900295257568e-01 -2.0784300231933594e+02 1.2708300018310547e+02 8.6526501178741455e-01 -2.0981800842285156e+02 1.2460400390625000e+02 1.4193699462339282e-03 -2.1515499877929688e+02 1.2726100158691406e+02 1.2258900403976440e+00 -2.1358000183105469e+02 1.2468299865722656e+02 1.9819100201129913e-01 -2.2044999694824219e+02 1.2515999603271484e+02 1.7789599895477295e+00 -2.2386399841308594e+02 1.2748399353027344e+02 3.9849300384521484e+00 -2.2433898925781250e+02 1.2494499969482422e+02 3.4015200138092041e+00 -2.2877299499511719e+02 1.2586000823974609e+02 6.1891698837280273e+00 -2.3166600036621094e+02 1.2783299255371094e+02 9.8253498077392578e+00 -2.3331199645996094e+02 1.2515999603271484e+02 1.0152399063110352e+01 -2.3599000549316406e+02 1.2776699829101562e+02 1.4962299346923828e+01 -2.3570401000976562e+02 1.2522200012207031e+02 1.3059900283813477e+01 -2.3930599975585938e+02 1.2558600616455078e+02 1.9471601486206055e+01 -2.3920401000976562e+02 1.2784500122070312e+02 2.1541898727416992e+01 -2.4060400390625000e+02 1.2535299682617188e+02 2.3162401199340820e+01 -2.4150801086425781e+02 1.2621000671386719e+02 2.8083000183105469e+01 -2.4077099609375000e+02 1.2772000122070312e+02 3.5704097747802734e+01 -2.4168099975585938e+02 1.2536199188232422e+02 3.4342399597167969e+01 -2.3531100463867188e+02 1.2775099182128906e+02 4.9545898437500000e+01 -2.3700599670410156e+02 1.2525199127197266e+02 4.8506999969482422e+01 -2.3412400817871094e+02 1.2604099273681641e+02 5.2350902557373047e+01 -2.2985998535156250e+02 1.2829699707031250e+02 5.4932098388671875e+01 -2.2948699951171875e+02 1.2506500244140625e+02 5.6847301483154297e+01 -2.2439299011230469e+02 1.2748600769042969e+02 5.9150100708007812e+01 -2.2638099670410156e+02 1.2499699401855469e+02 5.8972499847412109e+01 -2.2040699768066406e+02 1.2518100738525391e+02 6.1718898773193359e+01 -2.1755599975585938e+02 1.2731899261474609e+02 6.1768600463867188e+01 -2.1588400268554688e+02 1.2473799896240234e+02 6.2957897186279297e+01 -1.8150299072265625e+02 1.2771700286865234e+02 4.1274200439453125e+01 -2.3988899230957031e+02 1.2895999145507812e+02 2.8459999084472656e+01 -2.3861399841308594e+02 1.2922300720214844e+02 4.0262199401855469e+01 -2.1377999877929688e+02 1.2940800476074219e+02 6.0275497436523438e+01 -2.0697399902343750e+02 1.2924299621582031e+02 6.0381401062011719e+01 -1.8154199218750000e+02 1.2862500000000000e+02 3.6442001342773438e+01 -1.8123400878906250e+02 1.2861700439453125e+02 2.9640199661254883e+01 -1.8622499084472656e+02 1.2874299621582031e+02 1.5299400329589844e+01 -1.9211801147460938e+02 1.2888200378417969e+02 9.1453199386596680e+00 -1.9792399597167969e+02 1.2902299499511719e+02 5.5920500755310059e+00 -2.0440299987792969e+02 1.2917999267578125e+02 3.5024900436401367e+00 -2.1119000244140625e+02 1.2934500122070312e+02 2.9934599399566650e+00 -2.1790699768066406e+02 1.2950900268554688e+02 4.0934700965881348e+00 -2.2417900085449219e+02 1.2966099548339844e+02 6.7410502433776855e+00 -2.2965299987792969e+02 1.2979400634765625e+02 1.0788100242614746e+01 -2.3433599853515625e+02 1.2999501037597656e+02 1.6692699432373047e+01 -2.3722900390625000e+02 1.3004699707031250e+02 2.2845300674438477e+01 -2.3870500183105469e+02 1.3001400756835938e+02 3.2155597686767578e+01 -2.2662199401855469e+02 1.2926499938964844e+02 5.5919898986816406e+01 -2.2111299133300781e+02 1.2966799926757812e+02 5.8175399780273438e+01 -2.0905099487304688e+02 1.0572200012207031e+02 4.5381797790527344e+01 -2.1081500244140625e+02 1.0467299652099609e+02 4.5350299835205078e+01 -2.0330799865722656e+02 1.0448999786376953e+02 4.3400802612304688e+01 -2.0193000793457031e+02 1.0554900360107422e+02 4.2308200836181641e+01 -1.9871400451660156e+02 1.0437899780273438e+02 3.8146999359130859e+01 -1.9794000244140625e+02 1.0545200347900391e+02 3.6953201293945312e+01 -1.9683000183105469e+02 1.0433300018310547e+02 3.2073898315429688e+01 -1.9697799682617188e+02 1.0542900085449219e+02 3.0343999862670898e+01 -1.9871400451660156e+02 1.0437899780273438e+02 2.5352998733520508e+01 -2.0055900573730469e+02 1.0551599884033203e+02 2.2120698928833008e+01 -2.0381001281738281e+02 1.0450199890136719e+02 1.9923898696899414e+01 -2.0854699707031250e+02 1.0570999908447266e+02 1.8288400650024414e+01 -2.1246699523925781e+02 1.0471299743652344e+02 1.8040899276733398e+01 -2.1630500793457031e+02 1.0589900207519531e+02 1.9329101562500000e+01 -2.2114500427246094e+02 1.0492400360107422e+02 2.3076299667358398e+01 -2.2204199218750000e+02 1.0603799438476562e+02 2.4548999786376953e+01 -2.2378500366210938e+02 1.0498799896240234e+02 3.0094598770141602e+01 -2.2407800292968750e+02 1.0608699798583984e+02 3.0909801483154297e+01 -2.2273500061035156e+02 1.0496199798583984e+02 3.7988101959228516e+01 -2.2284199523925781e+02 1.0605700683593750e+02 3.7473102569580078e+01 -2.1772700500488281e+02 1.0593300628662109e+02 4.3400802612304688e+01 -2.1725199890136719e+02 1.0482899475097656e+02 4.3576000213623047e+01 -2.0480999755859375e+02 1.0452699279785156e+02 2.9579599380493164e+01 -2.0437399291992188e+02 1.0451599884033203e+02 3.1616199493408203e+01 -2.1576499938964844e+02 1.0479299926757812e+02 2.8369499206542969e+01 -2.1284001159667969e+02 1.0472200012207031e+02 2.6038799285888672e+01 -2.1033898925781250e+02 1.0466100311279297e+02 3.7979099273681641e+01 -2.1391900634765625e+02 1.0474800109863281e+02 3.6894599914550781e+01 -2.0692298889160156e+02 1.0457800292968750e+02 3.6742603302001953e+01 -2.0601100158691406e+02 1.0455599975585938e+02 2.7565698623657227e+01 -2.0992199707031250e+02 1.0465099334716797e+02 2.5619899749755859e+01 -2.0768800354003906e+02 1.0459700012207031e+02 2.6330501556396484e+01 -2.1668800354003906e+02 1.0481500244140625e+02 3.1883798599243164e+01 -2.0501699829101562e+02 1.0453200531005859e+02 3.4493598937988281e+01 -2.1592100524902344e+02 1.0479699707031250e+02 3.4730697631835938e+01 -2.1929701232910156e+02 1.0601200103759766e+02 3.9028800964355469e+01 -2.2090199279785156e+02 1.0600999450683594e+02 2.5757198333740234e+01 -2.0916900634765625e+02 1.0572499847412109e+02 2.0382499694824219e+01 -2.1180799865722656e+02 1.0578900146484375e+02 4.2989101409912109e+01 -2.0234799194335938e+02 1.0555899810791016e+02 4.0002700805664062e+01 -1.9928399658203125e+02 1.0548500061035156e+02 2.9507999420166016e+01 -2.0252000427246094e+02 1.0568299865722656e+02 2.3675001144409180e+01 -2.0969000244140625e+02 1.1417300415039062e+02 3.7880100250244141e+01 -2.1336399841308594e+02 1.1426200103759766e+02 3.7176399230957031e+01 -2.1581399536132812e+02 1.1432199859619141e+02 3.4493698120117188e+01 -2.1645700073242188e+02 1.1433800506591797e+02 3.1616199493408203e+01 -2.1568901062011719e+02 1.1431900024414062e+02 2.8769298553466797e+01 -2.1435700988769531e+02 1.1428699493408203e+02 2.7168600082397461e+01 -2.1235800170898438e+02 1.1423799896240234e+02 2.5943899154663086e+01 -2.0942500305175781e+02 1.1416699981689453e+02 2.5652200698852539e+01 -2.0602700805664062e+02 1.1408399963378906e+02 2.7214799880981445e+01 -2.0409500122070312e+02 1.1403700256347656e+02 3.1189800262451172e+01 -2.0457899475097656e+02 1.1404900360107422e+02 3.3920299530029297e+01 -2.0577999877929688e+02 1.1407800292968750e+02 3.5934200286865234e+01 -2.0745599365234375e+02 1.1411900329589844e+02 3.7169399261474609e+01 -2.1256199645996094e+02 1.0626499938964844e+02 4.3564201354980469e+01 -2.1033099365234375e+02 1.0621099853515625e+02 4.3750598907470703e+01 -2.0089698791503906e+02 1.0598100280761719e+02 3.7738300323486328e+01 -1.9850698852539062e+02 1.0592400360107422e+02 3.1823001861572266e+01 -2.0832901000976562e+02 1.0616199493408203e+02 1.9957099914550781e+01 -2.1815000915527344e+02 1.0640099334716797e+02 2.2526300430297852e+01 -2.2193400573730469e+02 1.0649300384521484e+02 3.1548198699951172e+01 -2.1894299316406250e+02 1.1439199829101562e+02 2.3373498916625977e+01 -2.2128599548339844e+02 1.1444999694824219e+02 2.6835700988769531e+01 -2.2230400085449219e+02 1.1447399902343750e+02 3.0890600204467773e+01 -2.2211000061035156e+02 1.1447200012207031e+02 3.3835498809814453e+01 -2.1555801391601562e+02 1.1431100463867188e+02 2.0921598434448242e+01 -2.0355000305175781e+02 1.1401899719238281e+02 2.1783500671386719e+01 -2.1030999755859375e+02 1.1418599700927734e+02 1.9754499435424805e+01 -2.1323100280761719e+02 1.1425399780273438e+02 4.3425601959228516e+01 -2.0906199645996094e+02 1.1415200042724609e+02 4.3724102020263672e+01 -2.2112699890136719e+02 1.1444599914550781e+02 3.7005100250244141e+01 -2.1787699890136719e+02 1.1436499786376953e+02 4.1198001861572266e+01 -2.0111499023437500e+02 1.1396100616455078e+02 2.4037199020385742e+01 -1.9832899475097656e+02 1.1389199829101562e+02 3.0511299133300781e+01 -1.9947500610351562e+02 1.1391899871826172e+02 2.6490600585937500e+01 -2.0231401062011719e+02 1.1398600006103516e+02 4.0855098724365234e+01 -1.9931399536132812e+02 1.1391600036621094e+02 3.6664199829101562e+01 -1.9848799133300781e+02 1.1389499664306641e+02 3.3824100494384766e+01 -2.0619599914550781e+02 1.1408499908447266e+02 4.3021701812744141e+01 -2.0523800659179688e+02 1.0608699798583984e+02 2.0918399810791016e+01 -2.0185099792480469e+02 1.0600499725341797e+02 2.3369699478149414e+01 -2.0010499572753906e+02 1.0596199798583984e+02 2.5750499725341797e+01 -1.9881999206542969e+02 1.0593099975585938e+02 2.8814998626708984e+01 -1.9891700744628906e+02 1.0593300628662109e+02 3.5046699523925781e+01 -2.0074200439453125e+02 1.0597799682617188e+02 3.8808403015136719e+01 -2.0374398803710938e+02 1.0605099487304688e+02 4.1718799591064453e+01 -2.0755900573730469e+02 1.0614299774169922e+02 4.3426902770996094e+01 -2.1574899291992188e+02 1.0634200286865234e+02 4.2581600189208984e+01 -2.1913600158691406e+02 1.0642500305175781e+02 4.0130203247070312e+01 -2.2147999572753906e+02 1.0648200225830078e+02 3.6667999267578125e+01 -2.2249899291992188e+02 1.0650599670410156e+02 3.2612701416015625e+01 -2.2206999206542969e+02 1.0649600219726562e+02 2.8453199386596680e+01 -2.2024501037597656e+02 1.0645200347900391e+02 2.4691499710083008e+01 -2.1540998840332031e+02 1.0633399963378906e+02 2.0760099411010742e+01 -2.1135600280761719e+02 1.0623600006103516e+02 1.9740798950195312e+01 -2.1239300537109375e+02 1.1383999633789062e+02 1.9933300018310547e+01 -2.0737500000000000e+02 1.1371900177001953e+02 2.0073101043701172e+01 -2.1506500244140625e+02 1.1703699493408203e+02 3.1008699417114258e+01 -2.1538000488281250e+02 1.0412000274658203e+02 3.2499397277832031e+01 -2.1497100830078125e+02 1.0435599517822266e+02 2.9828699111938477e+01 -2.1403099060058594e+02 1.1702700042724609e+02 2.8736499786376953e+01 -2.1380999755859375e+02 1.0432499694824219e+02 2.8184499740600586e+01 -2.1233500671386719e+02 1.1700700378417969e+02 2.7357200622558594e+01 -2.1116799926757812e+02 1.0425099945068359e+02 2.6830999374389648e+01 -2.0925900268554688e+02 1.1691200256347656e+02 2.6934501647949219e+01 -2.0724398803710938e+02 1.0419099426269531e+02 2.8038398742675781e+01 -2.0696400451660156e+02 1.1686499786376953e+02 2.8184499740600586e+01 -2.0580300903320312e+02 1.1683399963378906e+02 2.9828699111938477e+01 -2.0570700073242188e+02 1.0388700103759766e+02 3.1263399124145508e+01 -2.0539300537109375e+02 1.1682199859619141e+02 3.2220901489257812e+01 -2.0611199951171875e+02 1.0414099884033203e+02 3.3671298980712891e+01 -2.0641101074218750e+02 1.1683799743652344e+02 3.4738300323486328e+01 -2.0727198791503906e+02 1.0416600036621094e+02 3.5315498352050781e+01 -2.0879699707031250e+02 1.1691399383544922e+02 3.6497501373291016e+01 -2.0956700134277344e+02 1.0423100280761719e+02 3.6565502166748047e+01 -2.1177198791503906e+02 1.1698299407958984e+02 3.6346099853515625e+01 -2.1264399719238281e+02 1.0428500366210938e+02 3.6142799377441406e+01 -2.1350199890136719e+02 1.1702399444580078e+02 3.5315498352050781e+01 -2.1433900451660156e+02 1.0434700012207031e+02 3.4763401031494141e+01 -2.1466299438476562e+02 1.1704900360107422e+02 3.3671199798583984e+01 -2.0501998901367188e+02 1.1739700317382812e+02 3.4976200103759766e+01 -2.0749400329589844e+02 1.1746899414062500e+02 3.7227298736572266e+01 -2.0908099365234375e+02 1.1751899719238281e+02 3.7789100646972656e+01 -2.1440100097656250e+02 1.1762500000000000e+02 3.6256801605224609e+01 -2.1569400024414062e+02 1.1769599914550781e+02 3.4545398712158203e+01 -2.1616099548339844e+02 1.1768800354003906e+02 3.0237701416015625e+01 -2.1225799560546875e+02 1.1759500122070312e+02 2.5965299606323242e+01 -2.0799299621582031e+02 1.1747100067138672e+02 2.6021400451660156e+01 -2.0611700439453125e+02 1.1745400238037109e+02 2.7169900894165039e+01 -2.0465699768066406e+02 1.1743000030517578e+02 2.9162500381469727e+01 -2.1287300109863281e+02 1.0356099700927734e+02 3.7441398620605469e+01 -2.0843600463867188e+02 1.0344999694824219e+02 3.7514900207519531e+01 -2.0536599731445312e+02 1.0334899902343750e+02 3.4981300354003906e+01 -2.0767399597167969e+02 1.0342900085449219e+02 2.6277999877929688e+01 -2.1222500610351562e+02 1.0352700042724609e+02 2.5862001419067383e+01 -2.1539700317382812e+02 1.0362899780273438e+02 2.7965198516845703e+01 -2.1134500122070312e+02 1.1758200073242188e+02 3.7792198181152344e+01 -2.1065699768066406e+02 1.0365200042724609e+02 3.7894100189208984e+01 -2.1476901245117188e+02 1.0375199890136719e+02 3.6222301483154297e+01 -2.1609899902343750e+02 1.0378500366210938e+02 3.4397899627685547e+01 -2.1668099975585938e+02 1.0379900360107422e+02 3.2216098785400391e+01 -2.1643600463867188e+02 1.0379299926757812e+02 2.9971199035644531e+01 -2.1370300292968750e+02 1.0372699737548828e+02 2.6472900390625000e+01 -2.1045500183105469e+02 1.0364800262451172e+02 2.5605899810791016e+01 -2.0559300231933594e+02 1.0352899932861328e+02 2.8128101348876953e+01 -2.0485000610351562e+02 1.0351199340820312e+02 2.9538700103759766e+01 -2.0443099975585938e+02 1.0350099945068359e+02 3.1284000396728516e+01 -2.0467599487304688e+02 1.0350699615478516e+02 3.3528701782226562e+01 -2.0649301147460938e+02 1.0355100250244141e+02 3.6358798980712891e+01 -2.1519100952148438e+02 1.1725500488281250e+02 2.8128101348876953e+01 -2.1354800415039062e+02 1.1721499633789062e+02 2.6579498291015625e+01 -2.1022799682617188e+02 1.1713299560546875e+02 2.5654699325561523e+01 -2.0538800048828125e+02 1.1701699829101562e+02 2.7966499328613281e+01 -2.0416101074218750e+02 1.1698600006103516e+02 3.1187599182128906e+01 -2.0436700439453125e+02 1.1699099731445312e+02 3.3417999267578125e+01 -2.0601499938964844e+02 1.1703199768066406e+02 3.6222301483154297e+01 -2.1295599365234375e+02 1.1720000457763672e+02 3.7229602813720703e+01 -2.1608898925781250e+02 1.1727600097656250e+02 3.3417999267578125e+01 -2.1634800720214844e+02 1.1728200531005859e+02 3.1750001907348633e+01 -2.1621299743652344e+02 1.2947499084472656e+02 1.9412300109863281e+01 -2.1018899536132812e+02 1.3042100524902344e+02 1.8149599075317383e+01 -2.0625500488281250e+02 1.2923200988769531e+02 1.8543500900268555e+01 -2.0268299865722656e+02 1.3023799133300781e+02 2.0099100112915039e+01 -1.9892098999023438e+02 1.2905400085449219e+02 2.3587598800659180e+01 -1.9808801269531250e+02 1.3012699890136719e+02 2.5352998733520508e+01 -1.9635899353027344e+02 1.2899200439453125e+02 3.0909801483154297e+01 -1.9640699768066406e+02 1.3008599853515625e+02 3.4811401367187500e+01 -1.9803599548339844e+02 1.2903300476074219e+02 3.8557899475097656e+01 -2.0214100646972656e+02 1.3022500610351562e+02 4.3046501159667969e+01 -2.0576699829101562e+02 1.2922100830078125e+02 4.4953498840332031e+01 -2.0962199401855469e+02 1.3040701293945312e+02 4.5350299835205078e+01 -2.1573199462890625e+02 1.2946299743652344e+02 4.4170799255371094e+01 -2.1712901306152344e+02 1.3058898925781250e+02 4.3400802612304688e+01 -2.2274301147460938e+02 1.2963299560546875e+02 3.6992099761962891e+01 -2.2172300720214844e+02 1.3070100402832031e+02 3.8146999359130859e+01 -2.2334199523925781e+02 1.3074000549316406e+02 3.1750001907348633e+01 -2.2278599548339844e+02 1.2963398742675781e+02 2.6993398666381836e+01 -2.2172300720214844e+02 1.3070100402832031e+02 2.5352998733520508e+01 -2.1662600708007812e+02 1.3057699584960938e+02 1.9923898696899414e+01 -2.1562699890136719e+02 1.3055300903320312e+02 2.9579599380493164e+01 -2.1606298828125000e+02 1.3056300354003906e+02 3.1616199493408203e+01 -2.1541999816894531e+02 1.3054800415039062e+02 3.4493698120117188e+01 -2.1297000122070312e+02 1.3048799133300781e+02 3.7176399230957031e+01 -2.1442599487304688e+02 1.3052400207519531e+02 2.7565698623657227e+01 -2.1051501464843750e+02 1.3042900085449219e+02 2.5619899749755859e+01 -2.1274900817871094e+02 1.3048300170898438e+02 2.6330501556396484e+01 -2.0684201049804688e+02 1.3033898925781250e+02 2.6323598861694336e+01 -2.0401499938964844e+02 1.3027099609375000e+02 2.9720699310302734e+01 -2.0415100097656250e+02 1.3027400207519531e+02 3.4138500213623047e+01 -2.0929600524902344e+02 1.3039900207519531e+02 3.7880100250244141e+01 -2.0651799011230469e+02 1.3033200073242188e+02 3.6894599914550781e+01 -2.2026400756835938e+02 1.2954199218750000e+02 2.6379798889160156e+01 -2.1200299072265625e+02 1.2933000183105469e+02 2.0610900878906250e+01 -2.0487199401855469e+02 1.2913699340820312e+02 2.1486200332641602e+01 -2.0555200195312500e+02 1.2921600341796875e+02 4.2496200561523438e+01 -2.1548199462890625e+02 1.2945700073242188e+02 4.1608798980712891e+01 -2.2024400329589844e+02 1.2952000427246094e+02 3.6158302307128906e+01 -1.9915899658203125e+02 1.2900500488281250e+02 2.8248100280761719e+01 -2.0042799377441406e+02 1.2901901245117188e+02 3.8065196990966797e+01 -2.1032899475097656e+02 1.2089599609375000e+02 2.5520799636840820e+01 -2.1441000366210938e+02 1.2099500274658203e+02 2.7214799880981445e+01 -2.1634199523925781e+02 1.2104199981689453e+02 3.1189800262451172e+01 -2.1552699279785156e+02 1.2102300262451172e+02 3.4730598449707031e+01 -2.1352499389648438e+02 1.2097399902343750e+02 3.6894599914550781e+01 -2.0994499206542969e+02 1.2088699340820312e+02 3.7979099273681641e+01 -2.0652900695800781e+02 1.2080399322509766e+02 3.6742603302001953e+01 -2.0462300109863281e+02 1.2075799560546875e+02 3.4493698120117188e+01 -2.0406300354003906e+02 1.2074399566650391e+02 3.2487796783447266e+01 -2.0419099426269531e+02 1.2074700164794922e+02 3.0146200180053711e+01 -2.0510099792480469e+02 1.2076900482177734e+02 2.8273099899291992e+01 -2.0674900817871094e+02 1.2080900573730469e+02 2.6605300903320312e+01 -1.9813301086425781e+02 1.2857800292968750e+02 3.3812999725341797e+01 -2.0922900390625000e+02 1.2884700012207031e+02 4.3173397064208984e+01 -2.1914500427246094e+02 1.2908799743652344e+02 3.9441299438476562e+01 -2.2174699401855469e+02 1.2915199279785156e+02 2.9634300231933594e+01 -2.1222900390625000e+02 1.2094499969482422e+02 4.3561500549316406e+01 -2.1539099121093750e+02 1.2102399444580078e+02 4.2580699920654297e+01 -2.0149398803710938e+02 1.2068700408935547e+02 2.3373498916625977e+01 -1.9915100097656250e+02 1.2063000488281250e+02 2.6835700988769531e+01 -2.1306700134277344e+02 1.2096800231933594e+02 2.0074300765991211e+01 -2.0889799499511719e+02 1.2086699676513672e+02 1.9775899887084961e+01 -2.1877799987792969e+02 1.2110900115966797e+02 4.0129402160644531e+01 -2.2112300109863281e+02 1.2116400146484375e+02 3.6664199829101562e+01 -1.9813301086425781e+02 1.2060499572753906e+02 3.0890600204467773e+01 -1.9832800292968750e+02 1.2061000061035156e+02 3.3842300415039062e+01 -1.9931199645996094e+02 1.2063399505615234e+02 3.7009399414062500e+01 -2.0487899780273438e+02 1.2076900482177734e+02 2.0921699523925781e+01 -2.0522401428222656e+02 1.2077799987792969e+02 4.2739200592041016e+01 -2.0927799987792969e+02 1.2087800598144531e+02 4.3757801055908203e+01 -2.1771299743652344e+02 1.2108100128173828e+02 2.2301399230957031e+01 -2.0176300048828125e+02 1.2069300079345703e+02 4.0395698547363281e+01 -2.2214099121093750e+02 1.2118899536132812e+02 3.2609298706054688e+01 -2.2194599914550781e+02 1.2118399810791016e+02 2.9657800674438477e+01 -2.2096200561523438e+02 1.2116000366210938e+02 2.6490600585937500e+01 -2.1287699890136719e+02 1.2893598937988281e+02 4.3426902770996094e+01 -2.0870800781250000e+02 1.2883499145507812e+02 4.3726501464843750e+01 -2.0468699645996094e+02 1.2873699951171875e+02 4.2581600189208984e+01 -2.0130099487304688e+02 1.2865499877929688e+02 4.0130203247070312e+01 -1.9895700073242188e+02 1.2859800720214844e+02 3.6668098449707031e+01 -1.9794799804687500e+02 1.2857299804687500e+02 3.1750001907348633e+01 -1.9836700439453125e+02 1.2858399963378906e+02 2.8453399658203125e+01 -2.0019200134277344e+02 1.2862800598144531e+02 2.4691499710083008e+01 -2.0319400024414062e+02 1.2870100402832031e+02 2.1781099319458008e+01 -2.0700900268554688e+02 1.2879400634765625e+02 2.0073101043701172e+01 -2.1117900085449219e+02 1.2889500427246094e+02 1.9773399353027344e+01 -2.1519898986816406e+02 1.2899200439453125e+02 2.0918399810791016e+01 -2.1858599853515625e+02 1.2907501220703125e+02 2.3369699478149414e+01 -2.2092999267578125e+02 1.2913200378417969e+02 2.6831901550292969e+01 -2.2191600036621094e+02 1.2915599060058594e+02 3.2985698699951172e+01 -2.2077200317382812e+02 1.2912799072265625e+02 3.7007400512695312e+01 -2.1669299316406250e+02 1.2902900695800781e+02 4.1718898773193359e+01 -2.1472999572753906e+02 1.3119200134277344e+02 3.1263399124145508e+01 -2.1503500366210938e+02 1.1827700042724609e+02 3.2491298675537109e+01 -2.1463400268554688e+02 1.1824599456787109e+02 2.9828599929809570e+01 -2.1371800231933594e+02 1.3091400146484375e+02 2.8761598587036133e+01 -2.1347300720214844e+02 1.1821500396728516e+02 2.8184499740600586e+01 -2.1199800109863281e+02 1.3089700317382812e+02 2.7357200622558594e+01 -2.1130999755859375e+02 1.1815599822998047e+02 2.6983200073242188e+01 -2.0942300415039062e+02 1.3081599426269531e+02 2.6912199020385742e+01 -2.0880200195312500e+02 1.1810299682617188e+02 2.7104499816894531e+01 -2.0743901062011719e+02 1.3077500915527344e+02 2.7576400756835938e+01 -2.0705200195312500e+02 1.1807099914550781e+02 2.8058498382568359e+01 -2.0563299560546875e+02 1.3072900390625000e+02 2.9393301010131836e+01 -2.0537899780273438e+02 1.1802499389648438e+02 3.0808599472045898e+01 -2.0505300903320312e+02 1.3094999694824219e+02 3.2118598937988281e+01 -2.0577398681640625e+02 1.1802999877929688e+02 3.3671199798583984e+01 -2.0585400390625000e+02 1.3074700927734375e+02 3.4547000885009766e+01 -2.0762300109863281e+02 1.1806500244140625e+02 3.5969497680664062e+01 -2.0826100158691406e+02 1.3079200744628906e+02 3.6304298400878906e+01 -2.1086900329589844e+02 1.3084899902343750e+02 3.6565502166748047e+01 -2.1070500183105469e+02 1.1815499877929688e+02 3.6584102630615234e+01 -2.1359300231933594e+02 1.1820399475097656e+02 3.5313899993896484e+01 -2.1316400146484375e+02 1.3091300964355469e+02 3.5315498352050781e+01 -2.1432499694824219e+02 1.3093901062011719e+02 3.3671298980712891e+01 -2.1319699096679688e+02 1.3166398620605469e+02 2.6581098556518555e+01 -2.0821200561523438e+02 1.3155299377441406e+02 2.5862001419067383e+01 -2.0442500305175781e+02 1.3146099853515625e+02 2.8920200347900391e+01 -2.0756399536132812e+02 1.3151899719238281e+02 3.7441398620605469e+01 -2.1154199218750000e+02 1.3163299560546875e+02 3.7637901306152344e+01 -2.1471600341796875e+02 1.3168499755859375e+02 3.5534698486328125e+01 -2.0998199462890625e+02 1.3143199157714844e+02 2.5605899810791016e+01 -2.1155599975585938e+02 1.3147000122070312e+02 2.5862300872802734e+01 -2.1484400939941406e+02 1.3155000305175781e+02 2.8128198623657227e+01 -2.1558700561523438e+02 1.3156799316406250e+02 2.9538700103759766e+01 -2.1600599670410156e+02 1.3157800292968750e+02 3.1284000396728516e+01 -2.1576100158691406e+02 1.3157199096679688e+02 3.3528800964355469e+01 -2.1302799987792969e+02 1.3150599670410156e+02 3.7027099609375000e+01 -2.0977999877929688e+02 1.3142700195312500e+02 3.7894100189208984e+01 -2.0566799926757812e+02 1.3132699584960938e+02 3.6222301483154297e+01 -2.0467799377441406e+02 1.3130299377441406e+02 3.4972499847412109e+01 -2.0394599914550781e+02 1.3128500366210938e+02 3.3333900451660156e+01 -2.0377400207519531e+02 1.3128100585937500e+02 3.1082300186157227e+01 -2.0535899353027344e+02 1.3132000732421875e+02 2.7625999450683594e+01 -2.0673300170898438e+02 1.3135301208496094e+02 2.6472900390625000e+01 -2.1352799987792969e+02 1.1802600097656250e+02 3.6920497894287109e+01 -2.0614500427246094e+02 1.1784700012207031e+02 3.6358699798583984e+01 -2.0434799194335938e+02 1.1780400085449219e+02 3.3417999267578125e+01 -2.0414100646972656e+02 1.1779899597167969e+02 3.1187599182128906e+01 -2.1020899963378906e+02 1.1794599914550781e+02 2.5654699325561523e+01 -2.1427200317382812e+02 1.1804399871826172e+02 2.7141201019287109e+01 -2.1566200256347656e+02 1.1807800292968750e+02 2.8920600891113281e+01 -2.1627600097656250e+02 1.1809300231933594e+02 3.2312400817871094e+01 -2.2056900024414062e+02 1.2945500183105469e+02 1.6232601165771484e+01 -2.1869200134277344e+02 1.2940800476074219e+02 1.2277999877929688e+01 -2.1462200927734375e+02 1.2930999755859375e+02 1.3530699729919434e+01 -2.1048599243164062e+02 1.2920799255371094e+02 1.0517800331115723e+01 -2.0811000061035156e+02 1.2915199279785156e+02 1.3026099205017090e+01 -2.0196199035644531e+02 1.2900100708007812e+02 1.1943999290466309e+01 -2.0181800842285156e+02 1.2899899291992188e+02 1.4779900550842285e+01 -1.9650498962402344e+02 1.2886999511718750e+02 1.8580398559570312e+01 -1.9367399597167969e+02 1.2880000305175781e+02 1.7919101715087891e+01 -1.9281199645996094e+02 1.2878001403808594e+02 2.3969499588012695e+01 -1.8863700866699219e+02 1.2867799377441406e+02 2.8789098739624023e+01 -1.9118400573730469e+02 1.2874099731445312e+02 3.0296899795532227e+01 -2.1805299377441406e+02 1.2939399719238281e+02 4.8720401763916016e+01 -2.1802101135253906e+02 1.2939100646972656e+02 5.1680698394775391e+01 -2.2336601257324219e+02 1.2952299499511719e+02 4.4919403076171875e+01 -2.2836900329589844e+02 1.2964299011230469e+02 4.2824600219726562e+01 -2.2705900573730469e+02 1.2961299133300781e+02 3.9530399322509766e+01 -2.2868600463867188e+02 1.2965199279785156e+02 3.3202999114990234e+01 -2.3127600097656250e+02 1.2971299743652344e+02 3.1316198348999023e+01 -2.2805200195312500e+02 1.2963700866699219e+02 2.6700399398803711e+01 -2.2934800720214844e+02 1.2966699218750000e+02 2.3145599365234375e+01 -2.2523300170898438e+02 1.2956799316406250e+02 2.0806598663330078e+01 -2.2562500000000000e+02 1.2957600402832031e+02 1.7439401626586914e+01 -1.9181799316406250e+02 1.2875599670410156e+02 3.6799598693847656e+01 -1.9113000488281250e+02 1.2873800659179688e+02 4.2181598663330078e+01 -1.9463699340820312e+02 1.2882499694824219e+02 4.2693298339843750e+01 -1.9930200195312500e+02 1.2893800354003906e+02 4.7267002105712891e+01 -1.9812500000000000e+02 1.2890798950195312e+02 4.9400699615478516e+01 -2.0524899291992188e+02 1.2908299255371094e+02 4.9969100952148438e+01 -2.0609199523925781e+02 1.2910099792480469e+02 5.2752300262451172e+01 -2.1176100158691406e+02 1.2924099731445312e+02 5.0473701477050781e+01 -2.3125599670410156e+02 1.3052600097656250e+02 3.2183799743652344e+01 -2.2861000061035156e+02 1.3046200561523438e+02 4.2054599761962891e+01 -2.2310699462890625e+02 1.3032800292968750e+02 4.8392898559570312e+01 -2.1543598937988281e+02 1.3014199829101562e+02 5.2374797821044922e+01 -2.0705400085449219e+02 1.2993800354003906e+02 5.2795497894287109e+01 -1.9887001037597656e+02 1.2973899841308594e+02 5.0020000457763672e+01 -1.9276000976562500e+02 1.2959100341796875e+02 4.4264701843261719e+01 -1.8968099975585938e+02 1.2951600646972656e+02 3.8186401367187500e+01 -1.8877600097656250e+02 1.2949400329589844e+02 2.7812000274658203e+01 -1.9312599182128906e+02 1.2960000610351562e+02 1.8748600006103516e+01 -1.9962100219726562e+02 1.2975700378417969e+02 1.3046000480651855e+01 -2.0765798950195312e+02 1.2995300292968750e+02 1.0630999565124512e+01 -2.1800099182128906e+02 1.3020401000976562e+02 1.1819199562072754e+01 -2.2834899902343750e+02 1.3045500183105469e+02 2.0675300598144531e+01 -2.2344200134277344e+02 1.3175900268554688e+02 2.8115301132202148e+01 -2.2037998962402344e+02 1.3168600463867188e+02 2.1973899841308594e+01 -2.1385600280761719e+02 1.3152600097656250e+02 1.8180200576782227e+01 -2.0786100769042969e+02 1.3138101196289062e+02 1.7667999267578125e+01 -2.0109201049804688e+02 1.3121600341796875e+02 2.0564998626708984e+01 -1.9721199035644531e+02 1.3112199401855469e+02 2.5478099822998047e+01 -1.9566600036621094e+02 1.3108499145507812e+02 3.1294900894165039e+01 -1.9715699768066406e+02 1.3111999511718750e+02 3.7684997558593750e+01 -2.0123899841308594e+02 1.3122099304199219e+02 4.3201099395751953e+01 -2.0942599487304688e+02 1.3141900634765625e+02 4.5968902587890625e+01 -2.1659399414062500e+02 1.3159300231933594e+02 4.4291500091552734e+01 -2.2126899719238281e+02 1.3170599365234375e+02 4.0127399444580078e+01 -2.2380099487304688e+02 1.3176800537109375e+02 3.4667297363281250e+01 -2.1803300476074219e+02 1.3020600891113281e+02 1.4779600143432617e+01 -2.2457798767089844e+02 1.3036898803710938e+02 1.9796600341796875e+01 -2.2812899780273438e+02 1.3045201110839844e+02 2.7062000274658203e+01 -2.2863400268554688e+02 1.3046400451660156e+02 3.3576202392578125e+01 -2.2688000488281250e+02 1.3042100524902344e+02 3.9869800567626953e+01 -2.2308099365234375e+02 1.3032899475097656e+02 4.5184097290039062e+01 -2.1769400024414062e+02 1.3019799804687500e+02 4.8878700256347656e+01 -1.9116400146484375e+02 1.2955300903320312e+02 3.3202899932861328e+01 -1.9179899597167969e+02 1.2956900024414062e+02 2.6700201034545898e+01 -1.9461799621582031e+02 1.2963700866699219e+02 2.0806699752807617e+01 -1.9928201293945312e+02 1.2975099182128906e+02 1.6233001708984375e+01 -2.0522900390625000e+02 1.2989500427246094e+02 1.3530799865722656e+01 -2.1174099731445312e+02 1.3005400085449219e+02 1.3026299476623535e+01 -2.0964399719238281e+02 1.3000599670410156e+02 5.0669200897216797e+01 -2.0179800415039062e+02 1.2981199645996094e+02 4.8719997406005859e+01 -1.9648500061035156e+02 1.2968299865722656e+02 4.4919403076171875e+01 -1.9279199218750000e+02 1.2959300231933594e+02 3.9530399322509766e+01 -2.0889199829101562e+02 1.3140499877929688e+02 2.7304201126098633e+01 -2.1354199218750000e+02 1.3151800537109375e+02 3.1065500259399414e+01 -2.1084600830078125e+02 1.3145298767089844e+02 3.6019298553466797e+01 -2.0640901184082031e+02 1.3134500122070312e+02 3.3095596313476562e+01 -2.2263600158691406e+02 1.3255400085449219e+02 2.5224899291992188e+01 -2.1657499694824219e+02 1.3240599060058594e+02 1.9208398818969727e+01 -2.0940600585937500e+02 1.3223199462890625e+02 1.7531000137329102e+01 -2.0121900939941406e+02 1.3203300476074219e+02 2.0298799514770508e+01 -1.9713699340820312e+02 1.3193299865722656e+02 2.5815000534057617e+01 -1.9564599609375000e+02 1.3189700317382812e+02 3.2205001831054688e+01 -1.9719200134277344e+02 1.3193400573730469e+02 3.8021999359130859e+01 -2.0107301330566406e+02 1.3202899169921875e+02 4.2934997558593750e+01 -2.0784098815917969e+02 1.3219400024414062e+02 4.5832000732421875e+01 -2.1638398742675781e+02 1.3240200805664062e+02 4.4528301239013672e+01 -2.2162599182128906e+02 1.3252799987792969e+02 3.9589302062988281e+01 -2.2393899536132812e+02 1.3258399963378906e+02 3.3770900726318359e+01 -2.1352200317382812e+02 1.3233099365234375e+02 3.1065500259399414e+01 -2.0836199951171875e+02 1.3220599365234375e+02 2.7449300765991211e+01 -2.0638899230957031e+02 1.3215798950195312e+02 3.3095596313476562e+01 -2.1128800964355469e+02 1.3227699279785156e+02 3.5887699127197266e+01 -2.0272299194335938e+02 1.0569400024414062e+02 1.4621299743652344e+01 -2.0668600463867188e+02 1.0579199981689453e+02 1.0581900596618652e+01 -2.0904899597167969e+02 1.0584799957275391e+02 1.2993499755859375e+01 -2.1722500610351562e+02 1.0604300689697266e+02 1.4064499855041504e+01 -2.1670100402832031e+02 1.0603500366210938e+02 1.1435999870300293e+01 -2.2433399963378906e+02 1.0622100067138672e+02 1.5488900184631348e+01 -2.2393199157714844e+02 1.0620899963378906e+02 1.8580600738525391e+01 -2.2762500000000000e+02 1.0629899597167969e+02 2.3969499588012695e+01 -2.2944200134277344e+02 1.0634500122070312e+02 2.2150199890136719e+01 -2.2925299072265625e+02 1.0633899688720703e+02 3.0297000885009766e+01 -2.3199899291992188e+02 1.0640700531005859e+02 3.2244899749755859e+01 -2.0377799987792969e+02 1.0571599578857422e+02 4.9436302185058594e+01 -1.9962300109863281e+02 1.0561999511718750e+02 4.9989601135253906e+01 -1.9583900451660156e+02 1.0552299499511719e+02 4.3703300476074219e+01 -1.9440800476074219e+02 1.0549400329589844e+02 4.5604900360107422e+01 -1.9012199401855469e+02 1.0538899993896484e+02 3.8098300933837891e+01 -1.9228799438476562e+02 1.0544099426269531e+02 3.6437900543212891e+01 -1.9178298950195312e+02 1.0542800140380859e+02 2.9923700332641602e+01 -1.8936399841308594e+02 1.0537100219726562e+02 2.9737699508666992e+01 -1.9353700256347656e+02 1.0547100067138672e+02 2.3630001068115234e+01 -1.9180700683593750e+02 1.0543000030517578e+02 2.1445301055908203e+01 -1.9733599853515625e+02 1.0556300354003906e+02 1.8315799713134766e+01 -1.9730999755859375e+02 1.0556399536132812e+02 1.5107099533081055e+01 -2.2818200683593750e+02 1.0630899810791016e+02 3.8475700378417969e+01 -2.2830699157714844e+02 1.0631700134277344e+02 4.3525901794433594e+01 -2.2366699218750000e+02 1.0620299530029297e+02 4.5184299468994141e+01 -2.2079600524902344e+02 1.0613500213623047e+02 5.0453903198242188e+01 -2.1827999877929688e+02 1.0607199859619141e+02 4.8878299713134766e+01 -2.1195399475097656e+02 1.0591799926757812e+02 5.0506301879882812e+01 -2.0914199829101562e+02 1.0585199737548828e+02 5.3216300964355469e+01 -1.8913301086425781e+02 1.0455200195312500e+02 3.3973701477050781e+01 -1.9475900268554688e+02 1.0468900299072266e+02 4.6379997253417969e+01 -2.0327700805664062e+02 1.0489600372314453e+02 5.1714900970458984e+01 -2.0997099304199219e+02 1.0505899810791016e+02 5.2982097625732422e+01 -2.1849400329589844e+02 1.0526599884033203e+02 5.1555900573730469e+01 -2.2800500488281250e+02 1.0549700164794922e+02 4.4272399902343750e+01 -2.3201901245117188e+02 1.0559400177001953e+02 3.1254999160766602e+01 -2.2917900085449219e+02 1.0552500152587891e+02 2.1611099243164062e+01 -2.2232598876953125e+02 1.0535900115966797e+02 1.3771599769592285e+01 -2.1094700622558594e+02 1.0508200073242188e+02 1.0402799606323242e+01 -2.0098100280761719e+02 1.0484000396728516e+02 1.2649999618530273e+01 -1.9442799377441406e+02 1.0468099975585938e+02 1.7895000457763672e+01 -1.9086999511718750e+02 1.0459500122070312e+02 2.3705799102783203e+01 -1.9734799194335938e+02 1.0332799530029297e+02 2.6155399322509766e+01 -2.0305499267578125e+02 1.0346700286865234e+02 1.9663398742675781e+01 -2.1010099792480469e+02 1.0363800048828125e+02 1.7531000137329102e+01 -2.1835800170898438e+02 1.0383900451660156e+02 1.9710000991821289e+01 -2.2322499084472656e+02 1.0395800018310547e+02 2.5478099822998047e+01 -2.2477099609375000e+02 1.0399500274658203e+02 3.1294900894165039e+01 -2.2327999877929688e+02 1.0395899963378906e+02 3.7684997558593750e+01 -2.1919799804687500e+02 1.0385900115966797e+02 4.3201099395751953e+01 -2.1101100158691406e+02 1.0366100311279297e+02 4.5968902587890625e+01 -2.0384300231933594e+02 1.0348699951171875e+02 4.4291599273681641e+01 -1.9916799926757812e+02 1.0337300109863281e+02 4.0127300262451172e+01 -1.9663600158691406e+02 1.0331100463867188e+02 3.4667400360107422e+01 -2.2910200500488281e+02 1.0551899719238281e+02 2.8197401046752930e+01 -2.2581900024414062e+02 1.0544200134277344e+02 2.0806699752807617e+01 -2.2115499877929688e+02 1.0532900238037109e+02 1.6232900619506836e+01 -2.1520799255371094e+02 1.0518400573730469e+02 1.3530799865722656e+01 -2.0869599914550781e+02 1.0502600097656250e+02 1.3026299476623535e+01 -2.0240400695800781e+02 1.0487400054931641e+02 1.4779600143432617e+01 -1.9857099914550781e+02 1.0477700042724609e+02 4.6417999267578125e+01 -2.0750399780273438e+02 1.0499300384521484e+02 5.0428901672363281e+01 -2.1557000732421875e+02 1.0519299316406250e+02 4.9872200012207031e+01 -2.2146099853515625e+02 1.0533600616455078e+02 4.7052200317382812e+01 -2.2603399658203125e+02 1.0544699859619141e+02 4.2386497497558594e+01 -2.2873500061035156e+02 1.0551300048828125e+02 3.6437900543212891e+01 -1.9585800170898438e+02 1.0470999908447266e+02 1.9796699523925781e+01 -1.9230799865722656e+02 1.0462799835205078e+02 2.7062099456787109e+01 -1.9180299377441406e+02 1.0461600494384766e+02 3.3576202392578125e+01 -1.9355599975585938e+02 1.0465799713134766e+02 3.9869800567626953e+01 -2.0959100341796875e+02 1.0362699890136719e+02 3.6019298553466797e+01 -2.1154499816894531e+02 1.0367400360107422e+02 2.7304201126098633e+01 -2.1402799987792969e+02 1.0373400115966797e+02 3.3095596313476562e+01 -2.0689498901367188e+02 1.0356099700927734e+02 3.1065500259399414e+01 -1.9780099487304688e+02 1.0252600097656250e+02 2.5225000381469727e+01 -2.0386199951171875e+02 1.0267400360107422e+02 1.9208398818969727e+01 -2.1103100585937500e+02 1.0284799957275391e+02 1.7531000137329102e+01 -2.1921800231933594e+02 1.0304599761962891e+02 2.0298799514770508e+01 -2.2329998779296875e+02 1.0314700317382812e+02 2.5815000534057617e+01 -2.2479000854492188e+02 1.0318199920654297e+02 3.2205001831054688e+01 -2.2324499511718750e+02 1.0314500427246094e+02 3.8021800994873047e+01 -2.1837699890136719e+02 1.0302600097656250e+02 4.3790000915527344e+01 -2.1012100219726562e+02 1.0282599639892578e+02 4.5968902587890625e+01 -2.0307398986816406e+02 1.0265499877929688e+02 4.3836502075195312e+01 -1.9881098937988281e+02 1.0255199432373047e+02 3.9589302062988281e+01 -1.9649800109863281e+02 1.0249500274658203e+02 3.3770999908447266e+01 -2.0691500854492188e+02 1.0274900054931641e+02 3.1065500259399414e+01 -2.1207499694824219e+02 1.0287400054931641e+02 2.7449300765991211e+01 -2.1404800415039062e+02 1.0292199707031250e+02 3.3095596313476562e+01 -2.0914900207519531e+02 1.0280300140380859e+02 3.5887699127197266e+01 -2.1194499206542969e+02 1.2913999938964844e+02 2.0020698547363281e+01 -2.1250000000000000e+02 1.0641600036621094e+02 2.0021301269531250e+01 -2.1049900817871094e+02 1.0598800659179688e+02 1.9850099563598633e+01 -2.0792601013183594e+02 1.2904399108886719e+02 2.0021301269531250e+01 -2.0847900390625000e+02 1.0631799316406250e+02 2.0021301269531250e+01 -2.0652699279785156e+02 1.0627099609375000e+02 2.0529798507690430e+01 -2.0469699096679688e+02 1.0584600067138672e+02 2.1361200332641602e+01 -2.0416499328613281e+02 1.2895100402832031e+02 2.1341600418090820e+01 -2.0301499938964844e+02 1.0603500366210938e+02 2.2495100021362305e+01 -2.0101701354980469e+02 1.2849499511718750e+02 2.3887998580932617e+01 -2.0036000061035156e+02 1.0612100219726562e+02 2.5510799407958984e+01 -1.9981199645996094e+02 1.2861900329589844e+02 2.5513200759887695e+01 -1.9945100402832031e+02 1.0609899902343750e+02 2.7312999725341797e+01 -1.9887001037597656e+02 1.0570500183105469e+02 2.9243101119995117e+01 -1.9830799865722656e+02 1.2880900573730469e+02 2.9244701385498047e+01 -1.9860899353027344e+02 1.0586500549316406e+02 3.1245698928833008e+01 -1.9869000244140625e+02 1.0608000183105469e+02 3.3261501312255859e+01 -1.9857199096679688e+02 1.2843600463867188e+02 3.5234500885009766e+01 -1.9911499023437500e+02 1.0609100341796875e+02 3.5234500885009766e+01 -1.9986698913574219e+02 1.0610900115966797e+02 3.7107299804687500e+01 -1.9931500244140625e+02 1.2883399963378906e+02 3.7107200622558594e+01 -2.0104899597167969e+02 1.2857299804687500e+02 3.9585998535156250e+01 -2.0159199523925781e+02 1.0615100097656250e+02 3.9583602905273438e+01 -2.0327600097656250e+02 1.2893000793457031e+02 4.1609203338623047e+01 -2.0382800292968750e+02 1.0620500183105469e+02 4.1609203338623047e+01 -2.0564100646972656e+02 1.0587000274658203e+02 4.2611202239990234e+01 -2.0504699707031250e+02 1.2859399414062500e+02 4.2593502044677734e+01 -2.0892900085449219e+02 1.2906700134277344e+02 4.3606998443603516e+01 -2.1484700012207031e+02 1.2883200073242188e+02 4.2593502044677734e+01 -2.1149900817871094e+02 1.0639200592041016e+02 4.3606998443603516e+01 -2.1538999938964844e+02 1.0648600006103516e+02 4.2593502044677734e+01 -2.1716099548339844e+02 1.0614900207519531e+02 4.1609203338623047e+01 -2.1659899902343750e+02 1.2925498962402344e+02 4.1609203338623047e+01 -2.1817800903320312e+02 1.2905900573730469e+02 4.0337799072265625e+01 -2.1872200012207031e+02 1.0656700134277344e+02 4.0341197967529297e+01 -2.1951199340820312e+02 1.2894499206542969e+02 3.8826000213623047e+01 -2.2112199401855469e+02 1.0624500274658203e+02 3.7107200622558594e+01 -2.2055999755859375e+02 1.2935000610351562e+02 3.7107299804687500e+01 -2.2132200622558594e+02 1.2898899841308594e+02 3.5234500885009766e+01 -2.2186500549316406e+02 1.0664299774169922e+02 3.5234500885009766e+01 -2.2174699401855469e+02 1.2899899291992188e+02 3.3261501312255859e+01 -2.2182301330566406e+02 1.2938000488281250e+02 3.1244300842285156e+01 -2.2211900329589844e+02 1.0665000152587891e+02 2.9242898941040039e+01 -2.2152799987792969e+02 1.0663499450683594e+02 2.7312999725341797e+01 -2.2011999511718750e+02 1.2933699035644531e+02 2.5601800918579102e+01 -2.2062500000000000e+02 1.0646200561523438e+02 2.5513299942016602e+01 -2.1942999267578125e+02 1.0620400238037109e+02 2.3888299942016602e+01 -2.1742199707031250e+02 1.2904701232910156e+02 2.2495100021362305e+01 -2.1796299743652344e+02 1.0654900360107422e+02 2.2491399765014648e+01 -2.1629199218750000e+02 1.0650800323486328e+02 2.1361200332641602e+01 -2.1445300292968750e+02 1.0646299743652344e+02 2.0529798507690430e+01 -2.1391000366210938e+02 1.2880900573730469e+02 2.0529798507690430e+01 -2.0062200927734375e+02 1.0574700164794922e+02 4.3646099090576172e+01 -2.0875399780273438e+02 1.2906298828125000e+02 4.7164001464843750e+01 -2.1578300476074219e+02 1.2923300170898438e+02 4.6052600860595703e+01 -2.2448800659179688e+02 1.2944599914550781e+02 2.6531200408935547e+01 -1.9458599853515625e+02 1.2871800231933594e+02 3.3582798004150391e+01 -2.2297999572753906e+02 1.2940699768066406e+02 2.3390899658203125e+01 -2.0015800476074219e+02 1.2885198974609375e+02 1.9714899063110352e+01 -2.0875399780273438e+02 1.2906199645996094e+02 1.6303300857543945e+01 -1.9752200317382812e+02 1.2879000854492188e+02 4.1013099670410156e+01 -2.2403498840332031e+02 1.2943499755859375e+02 3.8088600158691406e+01 -1.9689401245117188e+02 1.2877400207519531e+02 2.3392599105834961e+01 -2.1669000244140625e+02 1.0613999938964844e+02 1.7551500320434570e+01 -2.1049598693847656e+02 1.0598699951171875e+02 1.6288700103759766e+01 -2.2495700073242188e+02 1.0634099578857422e+02 3.7338397979736328e+01 -2.1839100646972656e+02 1.0617900085449219e+02 4.5042102813720703e+01 -2.0697499084472656e+02 1.0590299987792969e+02 4.6803199768066406e+01 -1.9692199707031250e+02 1.0565699768066406e+02 2.4366498947143555e+01 -2.2550599670410156e+02 1.0635299682617188e+02 2.7780498504638672e+01 -1.9591299438476562e+02 1.0563899993896484e+02 3.7020698547363281e+01 -1.9548399353027344e+02 1.2848699951171875e+02 3.7337600708007812e+01 -2.0113999938964844e+02 1.2864300537109375e+02 4.4506500244140625e+01 -2.0521099853515625e+02 1.2874299621582031e+02 4.6530101776123047e+01 -2.1205299377441406e+02 1.2891101074218750e+02 4.7107299804687500e+01 -2.1894299316406250e+02 1.2900799560546875e+02 4.4378501892089844e+01 -2.2259298706054688e+02 1.2917199707031250e+02 4.0676002502441406e+01 -2.2521301269531250e+02 1.2923300170898438e+02 3.4432003021240234e+01 -2.2535699462890625e+02 1.2921301269531250e+02 3.0183900833129883e+01 -2.1956500244140625e+02 1.2909300231933594e+02 1.9573999404907227e+01 -2.1591999816894531e+02 1.2896501159667969e+02 1.7451801300048828e+01 -2.1228199768066406e+02 1.2891000366210938e+02 1.6466999053955078e+01 -2.0375399780273438e+02 1.2871800231933594e+02 1.7548700332641602e+01 -1.9530700683593750e+02 1.2850399780273438e+02 2.6743900299072266e+01 -1.9452500915527344e+02 1.2844799804687500e+02 3.0501001358032227e+01 -1.9499200439453125e+02 1.0582399749755859e+02 3.2205501556396484e+01 -1.9554800415039062e+02 1.0585000610351562e+02 2.7586700439453125e+01 -1.9883200073242188e+02 1.0588700103759766e+02 2.1541999816894531e+01 -2.0161401367187500e+02 1.0600800323486328e+02 1.9099000930786133e+01 -2.0442199707031250e+02 1.0603799438476562e+02 1.7499099731445312e+01 -2.0815499877929688e+02 1.0616999816894531e+02 1.6467800140380859e+01 -2.1283799743652344e+02 1.0628300476074219e+02 1.6468700408935547e+01 -2.2026998901367188e+02 1.0647100067138672e+02 1.9712099075317383e+01 -2.2374501037597656e+02 1.0655199432373047e+02 2.3686800003051758e+01 -2.2587699890136719e+02 1.0656599426269531e+02 3.3341400146484375e+01 -2.2347100830078125e+02 1.0654199981689453e+02 4.0147499084472656e+01 -2.2114700317382812e+02 1.0648799896240234e+02 4.3034099578857422e+01 -2.1522499084472656e+02 1.0633700561523438e+02 4.6529201507568359e+01 -2.1045700073242188e+02 1.0626499938964844e+02 4.7237998962402344e+01 -2.0355198669433594e+02 1.0607299804687500e+02 4.5599098205566406e+01 -1.9784500122070312e+02 1.0590699768066406e+02 4.0675498962402344e+01 -2.1846400451660156e+02 1.2138999938964844e+02 1.8598999023437500e+01 -2.2329199218750000e+02 1.2114799499511719e+02 2.3382099151611328e+01 -2.2527999877929688e+02 1.2121199798583984e+02 2.8405200958251953e+01 -2.2549900817871094e+02 1.2177000427246094e+02 3.4069999694824219e+01 -2.2355400085449219e+02 1.2123200225830078e+02 3.9512100219726562e+01 -2.2104699707031250e+02 1.2151099395751953e+02 4.2754898071289062e+01 -2.1775401306152344e+02 1.2137799835205078e+02 4.5241798400878906e+01 -2.1232299804687500e+02 1.2132199859619141e+02 4.7156200408935547e+01 -2.0558000183105469e+02 1.2111399841308594e+02 4.6645801544189453e+01 -2.0085499572753906e+02 1.2078599548339844e+02 4.4163497924804688e+01 -1.9749600219726562e+02 1.2094400024414062e+02 4.0728401184082031e+01 -1.9553099060058594e+02 1.2086199951171875e+02 3.7023498535156250e+01 -1.9465299987792969e+02 1.2065699768066406e+02 3.1939100265502930e+01 -1.9503900146484375e+02 1.2095300292968750e+02 2.8284999847412109e+01 -1.9638800048828125e+02 1.2018099975585938e+02 2.4513099670410156e+01 -1.9918600463867188e+02 1.2021200561523438e+02 2.0767200469970703e+01 -2.0400599670410156e+02 1.2131399536132812e+02 1.7464300155639648e+01 -2.0962699890136719e+02 1.2136299896240234e+02 1.6277101516723633e+01 -2.1339898681640625e+02 1.2124700164794922e+02 1.6580900192260742e+01 -2.2490899658203125e+02 1.1382800292968750e+02 2.6625299453735352e+01 -2.2579200744628906e+02 1.1456500244140625e+02 3.0774099349975586e+01 -2.0914599609375000e+02 1.1387799835205078e+02 4.7220302581787109e+01 -2.1363000488281250e+02 1.1419899749755859e+02 4.6887599945068359e+01 -2.1797401428222656e+02 1.1372800445556641e+02 4.5227500915527344e+01 -2.2133700561523438e+02 1.1411300659179688e+02 4.2665199279785156e+01 -2.2411000061035156e+02 1.1480899810791016e+02 3.8798896789550781e+01 -2.2548399353027344e+02 1.1385800170898438e+02 3.4823699951171875e+01 -2.0485499572753906e+02 1.1371900177001953e+02 4.6273700714111328e+01 -2.0081800842285156e+02 1.1393199920654297e+02 4.4009300231933594e+01 -1.9789401245117188e+02 1.1325500488281250e+02 4.1007797241210938e+01 -1.9585299682617188e+02 1.1351499938964844e+02 3.7383602142333984e+01 -1.9486700439453125e+02 1.1372100067138672e+02 3.3135002136230469e+01 -1.9515701293945312e+02 1.1386699676513672e+02 2.8405200958251953e+01 -1.9665899658203125e+02 1.1392399597167969e+02 2.4336500167846680e+01 -1.9955599975585938e+02 1.1336199951171875e+02 2.0610500335693359e+01 -2.0317399597167969e+02 1.1328399658203125e+02 1.8013399124145508e+01 -2.2195401000976562e+02 1.1393900299072266e+02 2.1441400527954102e+01 -2.1643099975585938e+02 1.1376499938964844e+02 1.7465099334716797e+01 -2.1081001281738281e+02 1.1371599578857422e+02 1.6277900695800781e+01 -2.0686399841308594e+02 1.1384500122070312e+02 1.6606901168823242e+01 -2.0583599853515625e+02 1.1967199707031250e+02 1.5580499649047852e+01 -2.1615199279785156e+02 1.1974099731445312e+02 1.6005798339843750e+01 -2.0374200439453125e+02 1.1894200134277344e+02 1.3112200736999512e+01 -2.2176599121093750e+02 1.1997100067138672e+02 1.9876399993896484e+01 -2.2937899780273438e+02 1.1944400024414062e+02 2.9195800781250000e+01 -2.2655400085449219e+02 1.2008000183105469e+02 3.4711200714111328e+01 -2.2270600891113281e+02 1.1956199645996094e+02 4.4073600769042969e+01 -2.1415899658203125e+02 1.1941899871826172e+02 4.8480998992919922e+01 -2.0747799682617188e+02 1.1950199890136719e+02 4.8410900115966797e+01 -1.9661199951171875e+02 1.1933200073242188e+02 4.1622001647949219e+01 -1.9319500732421875e+02 1.1902899932861328e+02 3.0598999023437500e+01 -1.9386000061035156e+02 1.1884899902343750e+02 3.8289600372314453e+01 -2.2566198730468750e+02 1.1950899505615234e+02 1.9041599273681641e+01 -2.2872099304199219e+02 1.1959500122070312e+02 3.8496799468994141e+01 -2.0454199218750000e+02 1.1904199981689453e+02 4.8934398651123047e+01 -1.9031199645996094e+02 1.1866399383544922e+02 2.9170398712158203e+01 -1.9526300048828125e+02 1.1872499847412109e+02 1.8826400756835938e+01 -2.2813700866699219e+02 1.1631800079345703e+02 3.2786102294921875e+01 -2.2874499511718750e+02 1.1634399414062500e+02 2.3909299850463867e+01 -2.2441400146484375e+02 1.1569800567626953e+02 2.2572898864746094e+01 -2.2167800903320312e+02 1.1625699615478516e+02 1.5649000167846680e+01 -2.0139299011230469e+02 1.1525800323486328e+02 1.7112400054931641e+01 -1.9333499145507812e+02 1.1551499938964844e+02 2.1589500427246094e+01 -1.9275199890136719e+02 1.1539099884033203e+02 2.7888498306274414e+01 -2.1976899719238281e+02 1.1566699981689453e+02 4.5711700439453125e+01 -2.0987500000000000e+02 1.1592800140380859e+02 5.1673801422119141e+01 -2.0749899291992188e+02 1.1527299499511719e+02 4.8264701843261719e+01 -2.0258999633789062e+02 1.1580599975585938e+02 4.9688400268554688e+01 -1.9753298950195312e+02 1.1556800079345703e+02 4.4316200256347656e+01 -1.9491999816894531e+02 1.1518199920654297e+02 3.8706199645996094e+01 -2.1460099792480469e+02 1.1540800476074219e+02 1.5581100463867188e+01 -2.2688999938964844e+02 1.1638999938964844e+02 4.2326099395751953e+01 -2.1025199890136719e+02 1.1590400695800781e+02 1.3853400230407715e+01 -1.9566099548339844e+02 1.1884100341796875e+02 4.5271697998046875e+01 -2.1584700012207031e+02 1.1936499786376953e+02 1.2526099205017090e+01 -2.1819999694824219e+02 1.1593399810791016e+02 5.0639301300048828e+01 -2.0446099853515625e+02 1.1564399719238281e+02 1.2329099655151367e+01 -1.9581399536132812e+02 1.1550000000000000e+02 1.7693799972534180e+01 -1.9185400390625000e+02 1.1541199493408203e+02 3.9564598083496094e+01 -2.2497299194335938e+02 1.1962500000000000e+02 4.5218299865722656e+01 -2.1795498657226562e+02 1.1950199890136719e+02 5.0360099792480469e+01 -1.9083499145507812e+02 1.1892499542236328e+02 3.8078800201416016e+01 -2.2222700500488281e+02 1.2112600708007812e+02 1.3840699195861816e+01 -2.2506900024414062e+02 1.2105300140380859e+02 1.6172901153564453e+01 -2.3043299865722656e+02 1.2129999542236328e+02 2.4295400619506836e+01 -2.3168798828125000e+02 1.2133699798583984e+02 3.0086599349975586e+01 -2.3162500000000000e+02 1.2122900390625000e+02 3.3679401397705078e+01 -2.2860200500488281e+02 1.2123300170898438e+02 4.2958698272705078e+01 -2.2488899230957031e+02 1.2117099761962891e+02 4.7557498931884766e+01 -2.2201100158691406e+02 1.2099900054931641e+02 4.9770599365234375e+01 -2.0504400634765625e+02 1.1922100067138672e+02 5.1625900268554688e+01 -2.1430799865722656e+02 1.2079199981689453e+02 5.2923400878906250e+01 -2.1014199829101562e+02 1.2081199645996094e+02 5.3386497497558594e+01 -2.0600199890136719e+02 1.2072399902343750e+02 5.2939601898193359e+01 -2.0218600463867188e+02 1.2095400238037109e+02 5.1914100646972656e+01 -1.9720199584960938e+02 1.2026000213623047e+02 4.9037399291992188e+01 -1.9325999450683594e+02 1.2042299652099609e+02 4.5303298950195312e+01 -1.9043000793457031e+02 1.2032599639892578e+02 4.0626899719238281e+01 -1.8875000000000000e+02 1.2016400146484375e+02 3.4979297637939453e+01 -1.8871499633789062e+02 1.2070299530029297e+02 2.8714298248291016e+01 -1.8991099548339844e+02 1.2038099670410156e+02 2.4103399276733398e+01 -1.9162500000000000e+02 1.2024199676513672e+02 2.0679599761962891e+01 -1.9411599731445312e+02 1.2044499969482422e+02 1.7198799133300781e+01 -1.9817799377441406e+02 1.2053600311279297e+02 1.3717300415039062e+01 -2.0354800415039062e+02 1.2069499969482422e+02 1.1158400535583496e+01 -2.0726499938964844e+02 1.2062100219726562e+02 1.0364299774169922e+01 -2.1152000427246094e+02 1.2061800384521484e+02 1.0177399635314941e+01 -2.1673899841308594e+02 1.2099199676513672e+02 1.1136799812316895e+01 -2.2799900817871094e+02 1.2133800506591797e+02 1.9518400192260742e+01 -2.3079499816894531e+02 1.2130499267578125e+02 3.8146701812744141e+01 -2.1816600036621094e+02 1.2109500122070312e+02 5.1858200073242188e+01 -2.1765998840332031e+02 1.1438299560546875e+02 1.1411600112915039e+01 -2.1214599609375000e+02 1.1571700286865234e+02 1.1466300010681152e+01 -2.1314599609375000e+02 1.1445999908447266e+02 1.0360100746154785e+01 -2.0648699951171875e+02 1.1406800079345703e+02 1.0428999900817871e+01 -2.0115501403808594e+02 1.1400300598144531e+02 1.2153600692749023e+01 -2.2455400085449219e+02 1.1451599884033203e+02 1.5449300765991211e+01 -2.2096000671386719e+02 1.1465200042724609e+02 1.2994100570678711e+01 -2.3192800903320312e+02 1.1469999694824219e+02 3.2681301116943359e+01 -2.3139399719238281e+02 1.1479399871826172e+02 2.7056499481201172e+01 -2.3054598999023438e+02 1.1619000244140625e+02 3.2951999664306641e+01 -2.2859799194335938e+02 1.1472000122070312e+02 4.3268299102783203e+01 -2.3103700256347656e+02 1.1476500701904297e+02 3.7869800567626953e+01 -2.2444300842285156e+02 1.1472699737548828e+02 4.8042800903320312e+01 -2.0893299865722656e+02 1.1340299987792969e+02 5.3378196716308594e+01 -2.1282800292968750e+02 1.1399600219726562e+02 5.3269100189208984e+01 -2.0622799682617188e+02 1.1435399627685547e+02 5.2936100006103516e+01 -1.9823400878906250e+02 1.1405000305175781e+02 4.9661499023437500e+01 -2.0210699462890625e+02 1.1397899627685547e+02 5.1776901245117188e+01 -1.9612300109863281e+02 1.1536399841308594e+02 4.6313201904296875e+01 -1.9194200134277344e+02 1.1381399536132812e+02 4.3190502166748047e+01 -1.9500599670410156e+02 1.1346800231933594e+02 4.7051502227783203e+01 -1.8988299560546875e+02 1.1373600006103516e+02 2.4628900527954102e+01 -1.8981399536132812e+02 1.1505900573730469e+02 2.8670299530029297e+01 -1.9186399841308594e+02 1.1380500030517578e+02 2.0517799377441406e+01 -1.9742100524902344e+02 1.1394599914550781e+02 1.4423500061035156e+01 -1.9392498779296875e+02 1.1385800170898438e+02 1.7658599853515625e+01 -2.2718499755859375e+02 1.1465899658203125e+02 1.8297500610351562e+01 -2.2952200317382812e+02 1.1463400268554688e+02 2.1769498825073242e+01 -2.2661300659179688e+02 1.0660199737548828e+02 4.7268497467041016e+01 -2.2210400390625000e+02 1.1418499755859375e+02 4.9876899719238281e+01 -2.1851499938964844e+02 1.1410699462890625e+02 5.1800003051757812e+01 -1.8931298828125000e+02 1.1381700134277344e+02 3.7060901641845703e+01 -1.8874398803710938e+02 1.1371300506591797e+02 2.9838298797607422e+01 -2.1030999755859375e+02 1.1389800262451172e+02 1.0119800567626953e+01 -2.1261599731445312e+02 1.2995899963378906e+02 5.3998600006103516e+01 -2.1548800659179688e+02 1.3010099792480469e+02 5.3488197326660156e+01 -2.1817399597167969e+02 1.3017199707031250e+02 5.2614601135253906e+01 -2.2067100524902344e+02 1.3015800476074219e+02 5.1425598144531250e+01 -2.2310200500488281e+02 1.3049000549316406e+02 4.9926799774169922e+01 -2.2527299499511719e+02 1.3033500671386719e+02 4.8109199523925781e+01 -2.2720300292968750e+02 1.3039199829101562e+02 4.6050601959228516e+01 -2.2961900329589844e+02 1.3064799499511719e+02 4.2717597961425781e+01 -2.3125999450683594e+02 1.3049200439453125e+02 3.8666801452636719e+01 -2.3192800903320312e+02 1.3047898864746094e+02 3.6033702850341797e+01 -2.3230999755859375e+02 1.3051899719238281e+02 3.3141502380371094e+01 -2.3232699584960938e+02 1.3071400451660156e+02 3.0403598785400391e+01 -2.3194999694824219e+02 1.3042601013183594e+02 2.7570100784301758e+01 -2.3126199340820312e+02 1.3068499755859375e+02 2.4792301177978516e+01 -2.3025999450683594e+02 1.3047698974609375e+02 2.2276500701904297e+01 -2.2886100769042969e+02 1.3063000488281250e+02 1.9701200485229492e+01 -2.2719599914550781e+02 1.3039498901367188e+02 1.7435699462890625e+01 -2.2532099914550781e+02 1.3034599304199219e+02 1.5428800582885742e+01 -2.2310000610351562e+02 1.3029499816894531e+02 1.3590799331665039e+01 -2.2074000549316406e+02 1.3043299865722656e+02 1.2075400352478027e+01 -2.1817199707031250e+02 1.3017599487304688e+02 1.0882300376892090e+01 -2.1550401306152344e+02 1.3010400390625000e+02 1.0014999389648438e+01 -2.1272799682617188e+02 1.3004299926757812e+02 9.4848299026489258e+00 -2.0990798950195312e+02 1.3016999816894531e+02 9.2892093658447266e+00 -2.0589500427246094e+02 1.2985000610351562e+02 9.6467695236206055e+00 -2.0164099121093750e+02 1.2996800231933594e+02 1.0868599891662598e+01 -1.9909800720214844e+02 1.2970300292968750e+02 1.2092100143432617e+01 -1.9673199462890625e+02 1.2965199279785156e+02 1.3592500686645508e+01 -1.9454400634765625e+02 1.2959199523925781e+02 1.5404000282287598e+01 -1.9261999511718750e+02 1.2975000000000000e+02 1.7421400070190430e+01 -1.9096800231933594e+02 1.2950498962402344e+02 1.9738100051879883e+01 -1.8961599731445312e+02 1.2947799682617188e+02 2.2195299148559570e+01 -1.8855999755859375e+02 1.2965100097656250e+02 2.4798900604248047e+01 -1.8787799072265625e+02 1.2943600463867188e+02 2.7565900802612305e+01 -1.8749900817871094e+02 1.2939100646972656e+02 3.2742500305175781e+01 -1.8788301086425781e+02 1.2942799377441406e+02 3.5961700439453125e+01 -1.8895399475097656e+02 1.2943499755859375e+02 3.9838100433349609e+01 -1.9096699523925781e+02 1.2950601196289062e+02 4.3763500213623047e+01 -1.9263699340820312e+02 1.2955599975585938e+02 4.6059700012207031e+01 -1.9454798889160156e+02 1.2979600524902344e+02 4.8128501892089844e+01 -1.9673300170898438e+02 1.2957200622558594e+02 4.9897903442382812e+01 -1.9911199951171875e+02 1.2970300292968750e+02 5.1414798736572266e+01 -2.0266799926757812e+02 1.2976300048828125e+02 5.3023300170898438e+01 -2.0710000610351562e+02 1.2990200805664062e+02 5.4013500213623047e+01 -2.0995100402832031e+02 1.3016799926757812e+02 5.4210399627685547e+01 -2.3016198730468750e+02 1.0555899810791016e+02 2.0753299713134766e+01 -2.3185600280761719e+02 1.0562599945068359e+02 2.4811399459838867e+01 -2.3281300354003906e+02 1.0562599945068359e+02 2.8732599258422852e+01 -2.3282400512695312e+02 1.0567399597167969e+02 3.4408302307128906e+01 -2.3185899353027344e+02 1.0563199615478516e+02 3.8678699493408203e+01 -2.3083599853515625e+02 1.0540299987792969e+02 4.1318401336669922e+01 -2.2946099853515625e+02 1.0557500457763672e+02 4.3774398803710938e+01 -2.2780500793457031e+02 1.0552600097656250e+02 4.6057800292968750e+01 -2.2372399902343750e+02 1.0523100280761719e+02 4.9918800354003906e+01 -2.2019799804687500e+02 1.0532200622558594e+02 5.2062500000000000e+01 -2.0495599365234375e+02 1.0503199768066406e+02 5.3479198455810547e+01 -2.0771099853515625e+02 1.0504000091552734e+02 5.4013698577880859e+01 -2.1052500915527344e+02 1.0491000366210938e+02 5.4210399627685547e+01 -2.1333000183105469e+02 1.0517700195312500e+02 5.4013698577880859e+01 -2.1609700012207031e+02 1.0524700164794922e+02 5.3484600067138672e+01 -2.0226599121093750e+02 1.0470999908447266e+02 5.2635101318359375e+01 -1.9972700500488281e+02 1.0485199737548828e+02 5.1424102783203125e+01 -1.9731600952148438e+02 1.0478600311279297e+02 4.9893100738525391e+01 -1.9513600158691406e+02 1.0473799896240234e+02 4.8087200164794922e+01 -1.9323100280761719e+02 1.0448999786376953e+02 4.6074901580810547e+01 -1.9158000183105469e+02 1.0465600585937500e+02 4.3774299621582031e+01 -1.9023999023437500e+02 1.0461899566650391e+02 4.1332099914550781e+01 -1.8915699768066406e+02 1.0439099884033203e+02 3.8655502319335938e+01 -1.8850399780273438e+02 1.0455200195312500e+02 3.6105701446533203e+01 -1.8800199890136719e+02 1.0454100036621094e+02 3.1930000305175781e+01 -1.8844599914550781e+02 1.0456600189208984e+02 2.7697900772094727e+01 -1.8917800903320312e+02 1.0439099884033203e+02 2.4785001754760742e+01 -1.9020399475097656e+02 1.0462000274658203e+02 2.2241399765014648e+01 -1.9158299255371094e+02 1.0465099334716797e+02 1.9716199874877930e+01 -1.9320001220703125e+02 1.0448999786376953e+02 1.7459999084472656e+01 -2.2778199768066406e+02 1.0578800201416016e+02 1.7460399627685547e+01 -2.2587500000000000e+02 1.0527899932861328e+02 1.5354000091552734e+01 -2.2375399780273438e+02 1.0551100158691406e+02 1.3635499954223633e+01 -2.2135099792480469e+02 1.0517399597167969e+02 1.2072100639343262e+01 -2.1878500366210938e+02 1.0530699920654297e+02 1.0887000083923340e+01 -2.1609700012207031e+02 1.0524700164794922e+02 1.0012900352478027e+01 -2.1333999633789062e+02 1.0517399597167969e+02 9.4853601455688477e+00 -2.1052700805664062e+02 1.0491000366210938e+02 9.2895603179931641e+00 -2.0769799804687500e+02 1.0503599548339844e+02 9.4853601455688477e+00 -2.0291799926757812e+02 1.0495700073242188e+02 1.0612500190734863e+01 -1.9968299865722656e+02 1.0484600067138672e+02 1.2097800254821777e+01 -1.9733900451660156e+02 1.0478399658203125e+02 1.3589400291442871e+01 -1.9515899658203125e+02 1.0473999786376953e+02 1.5396200180053711e+01 -1.8684700012207031e+02 1.2961100769042969e+02 4.2548801422119141e+01 -1.8469500732421875e+02 1.2955799865722656e+02 2.8018598556518555e+01 -1.9959199523925781e+02 1.2992100524902344e+02 5.5063400268554688e+01 -1.8514199829101562e+02 1.0429300689697266e+02 3.4052101135253906e+01 -2.0165100097656250e+02 1.0469199371337891e+02 7.8535704612731934e+00 -2.3124499511718750e+02 1.0541200256347656e+02 1.6902700424194336e+01 -2.3600100708007812e+02 1.0552700042724609e+02 3.0949798583984375e+01 -2.0835800170898438e+02 1.3013200378417969e+02 5.7198200225830078e+01 -2.2014399719238281e+02 1.3041700744628906e+02 5.5102699279785156e+01 -1.9566999816894531e+02 1.2982299804687500e+02 1.0604599952697754e+01 -2.0775698852539062e+02 1.3011599731445312e+02 6.3840699195861816e+00 -2.3264099121093750e+02 1.3072200012207031e+02 2.0301601409912109e+01 -2.3534100341796875e+02 1.3078599548339844e+02 3.3692699432373047e+01 -1.9391499328613281e+02 1.2978099060058594e+02 5.1556503295898438e+01 -2.2969000244140625e+02 1.3065100097656250e+02 4.7836399078369141e+01 -2.2413999938964844e+02 1.3051499938964844e+02 1.0596699714660645e+01 -1.8919000244140625e+02 1.2966600036621094e+02 1.6905500411987305e+01 -2.1587300109863281e+02 1.3030999755859375e+02 6.9621801376342773e+00 -2.1203100585937500e+02 1.0494699859619141e+02 5.7195899963378906e+01 -1.8981599426269531e+02 1.0440699768066406e+02 1.6886199951171875e+01 -2.3032901000976562e+02 1.0539199829101562e+02 4.7797401428222656e+01 -2.3546501159667969e+02 1.0552000427246094e+02 3.7006900787353516e+01 -2.0024800109863281e+02 1.0465999603271484e+02 5.5078102111816406e+01 -2.1354899597167969e+02 1.0498200225830078e+02 6.4365301132202148e+00 -1.9073800659179688e+02 1.0443299865722656e+02 4.7815597534179688e+01 -1.8558099365234375e+02 1.0430400085449219e+02 3.6985301971435547e+01 -2.2349800109863281e+02 1.0522499847412109e+02 5.3698398590087891e+01 -1.8711199951171875e+02 1.1707700347900391e+02 4.0941997528076172e+01 -1.8499000549316406e+02 1.2930900573730469e+02 3.7009700775146484e+01 -1.9466899108886719e+02 1.1725799560546875e+02 5.1138797760009766e+01 -1.9705499267578125e+02 1.2961299133300781e+02 5.3753299713134766e+01 -2.1763800048828125e+02 1.3018600463867188e+02 5.6052799224853516e+01 -2.1850100708007812e+02 1.1793799591064453e+02 5.5199298858642578e+01 -2.1140499877929688e+02 1.2984899902343750e+02 5.7166599273681641e+01 -2.3489999389648438e+02 1.1775199890136719e+02 2.8864801406860352e+01 -2.3511199951171875e+02 1.3052700805664062e+02 2.7974100112915039e+01 -2.3232400512695312e+02 1.1818700408935547e+02 2.0403999328613281e+01 -2.3058999633789062e+02 1.3042199707031250e+02 1.6852300643920898e+01 -2.0386799621582031e+02 1.2977400207519531e+02 6.9919199943542480e+00 -2.0795899963378906e+02 1.1756999969482422e+02 6.9988398551940918e+00 -1.8642500305175781e+02 1.1705099487304688e+02 2.4582300186157227e+01 -1.8591099548339844e+02 1.2930000305175781e+02 2.3176200866699219e+01 -1.8450999450683594e+02 1.2930799865722656e+02 3.3570201873779297e+01 -1.8532800292968750e+02 1.1693000030517578e+02 3.2014499664306641e+01 -1.8838200378417969e+02 1.2939100646972656e+02 4.5361598968505859e+01 -1.9029000854492188e+02 1.2945500183105469e+02 4.8015598297119141e+01 -2.0228500366210938e+02 1.2963600158691406e+02 5.6035198211669922e+01 -2.0543199157714844e+02 1.2980699157714844e+02 5.6836200714111328e+01 -2.2288499450683594e+02 1.3022999572753906e+02 5.3683998107910156e+01 -2.2548800659179688e+02 1.3030599975585938e+02 5.1928199768066406e+01 -2.2827499389648438e+02 1.3029600524902344e+02 4.9445098876953125e+01 -2.3147900390625000e+02 1.3044099426269531e+02 4.5325901031494141e+01 -2.3290798950195312e+02 1.3047300720214844e+02 4.2727897644042969e+01 -2.3398100280761719e+02 1.3040399169921875e+02 4.0044700622558594e+01 -2.3484799194335938e+02 1.3051899719238281e+02 3.6991298675537109e+01 -2.3445700073242188e+02 1.3052499389648438e+02 2.4872501373291016e+01 -2.2831599426269531e+02 1.3034300231933594e+02 1.4095200538635254e+01 -2.2656999206542969e+02 1.3031800842285156e+02 1.2463399887084961e+01 -2.2122700500488281e+02 1.3020199584960938e+02 8.8971204757690430e+00 -2.1273899841308594e+02 1.2999899291992188e+02 6.4136400222778320e+00 -2.0106700134277344e+02 1.2969900512695312e+02 7.8543395996093750e+00 -1.9296600341796875e+02 1.2951199340820312e+02 1.2704100608825684e+01 -1.9113899230957031e+02 1.2945799255371094e+02 1.4529299736022949e+01 -1.8748899841308594e+02 1.2938598632812500e+02 1.9639900207519531e+01 -1.9830000305175781e+02 1.2955799865722656e+02 9.0749893188476562e+00 -1.9216400146484375e+02 1.2940899658203125e+02 5.0018798828125000e+01 -2.3353100585937500e+02 1.3041400146484375e+02 2.2190099716186523e+01 -2.1880799865722656e+02 1.3005599975585938e+02 7.8717498779296875e+00 -2.0993200683593750e+02 1.2975401306152344e+02 6.2752399444580078e+00 -1.8532499694824219e+02 1.0448200225830078e+02 2.7966199874877930e+01 -1.8792900085449219e+02 1.0472399902343750e+02 1.9946699142456055e+01 -1.9169999694824219e+02 1.0470700073242188e+02 1.4573599815368652e+01 -1.9387100219726562e+02 1.0475099945068359e+02 1.2466600418090820e+01 -1.9891799926757812e+02 1.0483699798583984e+02 9.0664596557617188e+00 -2.0752200317382812e+02 1.0503900146484375e+02 6.4432597160339355e+00 -2.1649800109863281e+02 1.0531199645996094e+02 6.9787502288818359e+00 -2.1936799621582031e+02 1.0538099670410156e+02 7.8539299964904785e+00 -2.2212600708007812e+02 1.0543900299072266e+02 9.0700397491455078e+00 -2.2475300598144531e+02 1.0550999450683594e+02 1.0616499900817871e+01 -2.2717300415039062e+02 1.0556300354003906e+02 1.2472899436950684e+01 -2.2930400085449219e+02 1.0560900115966797e+02 1.4541800498962402e+01 -2.3412600708007812e+02 1.0573899841308594e+02 2.2174301147460938e+01 -2.3509700012207031e+02 1.0576100158691406e+02 2.5048999786376953e+01 -2.3571301269531250e+02 1.0578099822998047e+02 2.7961000442504883e+01 -2.3589299011230469e+02 1.0577500152587891e+02 3.3986400604248047e+01 -2.3352299499511719e+02 1.0571199798583984e+02 4.2691799163818359e+01 -2.2826300048828125e+02 1.0559199523925781e+02 5.0033100128173828e+01 -2.2596899414062500e+02 1.0554000091552734e+02 5.2010299682617188e+01 -2.1860800170898438e+02 1.0555799865722656e+02 5.5917697906494141e+01 -2.1502499389648438e+02 1.0527499389648438e+02 5.6830902099609375e+01 -2.0600500488281250e+02 1.0505400085449219e+02 5.6829200744628906e+01 -2.0304598999023438e+02 1.0497999572753906e+02 5.6107101440429688e+01 -1.9281600952148438e+02 1.0468000030517578e+02 5.0079200744628906e+01 -1.8897700500488281e+02 1.0464399719238281e+02 4.5353099822998047e+01 -1.8753300476074219e+02 1.0460600280761719e+02 4.2737598419189453e+01 -1.8639700317382812e+02 1.0456900024414062e+02 3.9933300018310547e+01 -2.0453800964355469e+02 1.0517700195312500e+02 6.9870300292968750e+00 -1.8595199584960938e+02 1.0484399414062500e+02 2.5036800384521484e+01 -1.9506298828125000e+02 1.0506500244140625e+02 5.1993701934814453e+01 -1.9755599975585938e+02 1.0492199707031250e+02 5.3683200836181641e+01 -2.0903498840332031e+02 1.0520999908447266e+02 5.7181198120117188e+01 -2.1050601196289062e+02 1.0532999420166016e+02 6.2755899429321289e+00 -1.9629000854492188e+02 1.0489199829101562e+02 1.0615900039672852e+01 -2.3205299377441406e+02 1.0576000213623047e+02 4.5356300354003906e+01 -2.3465399169921875e+02 1.0582399749755859e+02 3.9891101837158203e+01 -2.3281700134277344e+02 1.0577899932861328e+02 1.9436498641967773e+01 -2.2233801269531250e+02 1.1786199951171875e+02 5.3453399658203125e+01 -2.2582699584960938e+02 1.1794000244140625e+02 5.1096000671386719e+01 -2.2883898925781250e+02 1.1791799926757812e+02 4.8230201721191406e+01 -2.3138099670410156e+02 1.1808200073242188e+02 4.4784400939941406e+01 -2.3325900268554688e+02 1.1819499969482422e+02 4.1081398010253906e+01 -2.3451300048828125e+02 1.1815799713134766e+02 3.6987499237060547e+01 -2.3505101013183594e+02 1.1807700347900391e+02 3.2890201568603516e+01 -2.3399400329589844e+02 1.1828699493408203e+02 2.4545398712158203e+01 -2.3019999694824219e+02 1.1805299377441406e+02 1.6967199325561523e+01 -2.2747399902343750e+02 1.1803199768066406e+02 1.3851099967956543e+01 -2.2413499450683594e+02 1.1790599822998047e+02 1.1153000831604004e+01 -2.2044500732421875e+02 1.1798100280761719e+02 9.0858306884765625e+00 -2.1647999572753906e+02 1.1772000122070312e+02 7.6918601989746094e+00 -2.1235600280761719e+02 1.1758500671386719e+02 6.9796400070190430e+00 -2.1021800231933594e+02 1.1756800079345703e+02 6.9792299270629883e+00 -2.0395500183105469e+02 1.1741500091552734e+02 7.6918601989746094e+00 -1.9998500061035156e+02 1.1722899627685547e+02 9.0837497711181641e+00 -1.9630099487304688e+02 1.1722899627685547e+02 1.1153000831604004e+01 -1.9302000427246094e+02 1.1728900146484375e+02 1.3788900375366211e+01 -1.9023600769042969e+02 1.1708200073242188e+02 1.6967199325561523e+01 -1.8796400451660156e+02 1.1729899597167969e+02 2.0653400421142578e+01 -1.8556599426269531e+02 1.1696899414062500e+02 2.8592300415039062e+01 -1.8565499877929688e+02 1.1697100067138672e+02 3.4896297454833984e+01 -1.8592298889160156e+02 1.1697699737548828e+02 3.6987499237060547e+01 -1.8905499267578125e+02 1.1705300140380859e+02 4.4784400939941406e+01 -1.9160600280761719e+02 1.1736100006103516e+02 4.8241802215576172e+01 -1.9809700012207031e+02 1.1727300262451172e+02 5.3453399658203125e+01 -2.0189199829101562e+02 1.1726599884033203e+02 5.5183197021484375e+01 -2.0601800537109375e+02 1.1746600341796875e+02 5.6252700805664062e+01 -2.1016600036621094e+02 1.1765699768066406e+02 5.6617000579833984e+01 -2.1441799926757812e+02 1.1766999816894531e+02 5.6252700805664062e+01 -2.0877299499511719e+02 1.2853099060058594e+02 7.0446296691894531e+01 -2.1143899536132812e+02 1.1893299865722656e+02 7.0446899414062500e+01 -2.1457099914550781e+02 1.2819000244140625e+02 7.0446899414062500e+01 -2.1508300781250000e+02 1.0711399841308594e+02 7.0446899414062500e+01 -2.0935400390625000e+02 1.0726799774169922e+02 7.0461105346679688e+01 -2.0070399475097656e+02 1.0231799316406250e+02 3.9378898620605469e+01 -2.0811300659179688e+02 1.0249800109863281e+02 3.4847698211669922e+01 -2.0070399475097656e+02 1.0231799316406250e+02 6.6001899719238281e+01 -2.1554400634765625e+02 1.0267900085449219e+02 6.6001899719238281e+01 -2.1267700195312500e+02 1.0260900115966797e+02 3.5504299163818359e+01 -2.0633601379394531e+02 1.0245499420166016e+02 3.0123300552368164e+01 -2.0376899719238281e+02 1.0239299774169922e+02 2.7607400894165039e+01 -2.0864900207519531e+02 1.0251100158691406e+02 2.4256500244140625e+01 -2.1133399963378906e+02 1.0257600402832031e+02 2.7670299530029297e+01 -2.1822099304199219e+02 1.0274399566650391e+02 3.2358097076416016e+01 -2.1470800781250000e+02 1.0265900421142578e+02 3.0542900085449219e+01 -2.1787899780273438e+02 1.0273600006103516e+02 2.9176700592041016e+01 -2.1436199951171875e+02 1.0265000152587891e+02 2.4844699859619141e+01 -2.1267298889160156e+02 1.3258900451660156e+02 2.8319000244140625e+01 -2.0977999877929688e+02 1.3252000427246094e+02 2.4011400222778320e+01 -2.0666099548339844e+02 1.3244400024414062e+02 2.8872100830078125e+01 -1.9997599792480469e+02 1.3228100585937500e+02 3.9378898620605469e+01 -2.0604499816894531e+02 1.3242900085449219e+02 3.3390499114990234e+01 -2.0274899291992188e+02 1.3234899902343750e+02 2.8684999465942383e+01 -2.0546499633789062e+02 1.3241499328613281e+02 2.5377201080322266e+01 -2.1700199890136719e+02 1.3269500732421875e+02 2.8787401199340820e+01 -2.1412199401855469e+02 1.3262500000000000e+02 2.5294500350952148e+01 -2.1309399414062500e+02 1.3259999084472656e+02 3.4598297119140625e+01 -2.1481600952148438e+02 1.3264199829101562e+02 6.6001899719238281e+01 -2.1749299621582031e+02 1.3270700073242188e+02 3.2358097076416016e+01 -2.0897300720214844e+02 1.3250000000000000e+02 3.5612800598144531e+01 -1.9997599792480469e+02 1.3228100585937500e+02 6.6001899719238281e+01 -2.1143699645996094e+02 1.3446499633789062e+02 2.7771299362182617e+01 -2.0907899475097656e+02 1.3440798950195312e+02 2.3911199569702148e+01 -2.1441699218750000e+02 1.3453799438476562e+02 2.5533700942993164e+01 -2.0299400329589844e+02 1.3425999450683594e+02 2.7607400894165039e+01 -2.0563200378417969e+02 1.3432400512695312e+02 3.0078800201416016e+01 -1.9992999267578125e+02 1.3418600463867188e+02 3.9378597259521484e+01 -2.1477000427246094e+02 1.3454598999023438e+02 6.6001899719238281e+01 -2.1190199279785156e+02 1.3447700500488281e+02 3.5504299163818359e+01 -2.1744699096679688e+02 1.3461099243164062e+02 3.2358097076416016e+01 -2.0733900451660156e+02 1.3436601257324219e+02 3.4847698211669922e+01 -1.9977799987792969e+02 1.3418400573730469e+02 6.6231697082519531e+01 -2.1710499572753906e+02 1.3460299682617188e+02 2.9176700592041016e+01 -2.1404400634765625e+02 1.3452899169921875e+02 3.1641698837280273e+01 -2.0770800781250000e+02 1.2802400207519531e+02 7.2422302246093750e+01 -2.1439099121093750e+02 1.2936199951171875e+02 7.2344100952148438e+01 -2.1093699645996094e+02 1.2023799896240234e+02 7.2351905822753906e+01 -2.0949099731445312e+02 1.0666000366210938e+02 7.2352203369140625e+01 -2.1493099975585938e+02 1.0711000061035156e+02 7.2351905822753906e+01 -2.0075000000000000e+02 1.0041400146484375e+02 3.9378597259521484e+01 -2.0635899353027344e+02 1.0055000305175781e+02 3.2433101654052734e+01 -2.0377799987792969e+02 1.0048699951171875e+02 2.7817501068115234e+01 -2.0900000000000000e+02 1.0061399841308594e+02 2.7771299362182617e+01 -2.1414401245117188e+02 1.0073899841308594e+02 2.9276401519775391e+01 -2.1282101440429688e+02 1.0070700073242188e+02 2.4328199386596680e+01 -2.0829499816894531e+02 1.0059700012207031e+02 2.4371500015258789e+01 -2.1382200622558594e+02 1.0073100280761719e+02 3.4627899169921875e+01 -2.1559100341796875e+02 1.0077399444580078e+02 6.6001899719238281e+01 -2.1826699829101562e+02 1.0083899688720703e+02 3.2358097076416016e+01 -2.1732800292968750e+02 1.0081700134277344e+02 2.7617498397827148e+01 -2.0974699401855469e+02 1.0063199615478516e+02 3.5612800598144531e+01 -2.0075000000000000e+02 1.0041400146484375e+02 6.6001899719238281e+01 -1.7514300537109375e+02 1.0367900085449219e+02 6.8380996704101562e+01 -1.7530999755859375e+02 1.0101699829101562e+02 6.8303695678710938e+01 -1.7848500061035156e+02 1.0113099670410156e+02 6.5027099609375000e+01 -1.7883099365234375e+02 9.8795196533203125e+01 6.4728599548339844e+01 -1.8202799987792969e+02 9.9489303588867188e+01 6.1406898498535156e+01 -1.8194400024414062e+02 9.7514999389648438e+01 6.1542900085449219e+01 -1.8459799194335938e+02 9.8837303161621094e+01 5.8767398834228516e+01 -1.8450999450683594e+02 9.6917503356933594e+01 5.8906600952148438e+01 -1.8651499938964844e+02 9.8581199645996094e+01 5.6792598724365234e+01 -1.8649501037597656e+02 9.6672103881835938e+01 5.6861198425292969e+01 -1.8844898986816406e+02 9.8526901245117188e+01 5.4795997619628906e+01 -1.8849499511718750e+02 9.6622497558593750e+01 5.4795997619628906e+01 -1.9037699890136719e+02 9.8675102233886719e+01 5.2799301147460938e+01 -1.9049000549316406e+02 9.6769104003906250e+01 5.2730697631835938e+01 -1.9227999877929688e+02 9.9023902893066406e+01 5.0824600219726562e+01 -1.9246099853515625e+02 9.7110595703125000e+01 5.0685302734375000e+01 -1.9413499450683594e+02 9.9569702148437500e+01 4.8893299102783203e+01 -1.9438900756835938e+02 9.7643699645996094e+01 4.8679500579833984e+01 -1.9592399597167969e+02 1.0030699920654297e+02 4.7026702880859375e+01 -1.9625599670410156e+02 9.8363098144531250e+01 4.6732601165771484e+01 -1.9806100463867188e+02 1.0150099945068359e+02 4.4787899017333984e+01 -1.9977499389648438e+02 1.0026300048828125e+02 4.3057399749755859e+01 -1.9949699401855469e+02 1.0216899871826172e+02 4.3471599578857422e+01 -1.6967498779296875e+02 1.1462300109863281e+02 6.9113403320312500e+01 -1.6811099243164062e+02 1.1253900146484375e+02 6.9113403320312500e+01 -1.7057000732421875e+02 1.1086499786376953e+02 6.9113403320312500e+01 -1.6936300659179688e+02 1.0874500274658203e+02 6.9113403320312500e+01 -1.7249600219726562e+02 1.0684799957275391e+02 6.9117797851562500e+01 -1.7170199584960938e+02 1.0466500091552734e+02 6.9161300659179688e+01 -1.7180700683593750e+02 1.2591699981689453e+02 6.9114402770996094e+01 -1.7113900756835938e+02 1.2856199645996094e+02 6.9145698547363281e+01 -1.7029200744628906e+02 1.2228199768066406e+02 6.9113403320312500e+01 -1.6898399353027344e+02 1.2434100341796875e+02 6.9113403320312500e+01 -1.6958099365234375e+02 1.1848500061035156e+02 6.9113403320312500e+01 -1.6791699218750000e+02 1.2048999786376953e+02 6.9113403320312500e+01 -1.6762300109863281e+02 1.1650499725341797e+02 6.9113403320312500e+01 -1.7679899597167969e+02 1.3409899902343750e+02 6.6025894165039062e+01 -1.7415100097656250e+02 1.2933799743652344e+02 6.8681900024414062e+01 -1.7779299926757812e+02 1.3243099975585938e+02 6.4960601806640625e+01 -1.7974400329589844e+02 1.3563699340820312e+02 6.2859298706054688e+01 -1.8117601013183594e+02 1.3419898986816406e+02 6.1416000366210938e+01 -1.8161100769042969e+02 1.3635600280761719e+02 6.0912399291992188e+01 -1.8353900146484375e+02 1.3688899230957031e+02 5.8906600952148438e+01 -1.8371998596191406e+02 1.3497599792480469e+02 5.8767398834228516e+01 -1.8550999450683594e+02 1.3723100280761719e+02 5.6861198425292969e+01 -1.8562300109863281e+02 1.3532499694824219e+02 5.6792598724365234e+01 -1.8750500488281250e+02 1.3737800598144531e+02 5.4795997619628906e+01 -1.8755101013183594e+02 1.3547299194335938e+02 5.4795997619628906e+01 -1.8950498962402344e+02 1.3732800292968750e+02 5.2730697631835938e+01 -1.8948500061035156e+02 1.3541899108886719e+02 5.2799301147460938e+01 -1.9148999023437500e+02 1.3708299255371094e+02 5.0685302734375000e+01 -1.9140200805664062e+02 1.3516299438476562e+02 5.0824600219726562e+01 -1.9344100952148438e+02 1.3664401245117188e+02 4.8679500579833984e+01 -1.9328199768066406e+02 1.3470800781250000e+02 4.8893299102783203e+01 -1.9534300231933594e+02 1.3601499938964844e+02 4.6730499267578125e+01 -1.9510400390625000e+02 1.3405899047851562e+02 4.7026702880859375e+01 -1.9883399963378906e+02 1.3434300231933594e+02 4.3169799804687500e+01 -1.9729701232910156e+02 1.3297000122070312e+02 4.4787899017333984e+01 -1.9881199645996094e+02 1.3236199951171875e+02 4.3404197692871094e+01 -1.9929000854492188e+02 1.0000900268554688e+02 6.6001899719238281e+01 -1.7689900207519531e+02 9.9870101928710938e+01 7.8838897705078125e+01 -1.7297999572753906e+02 1.0323600006103516e+02 7.8970603942871094e+01 -1.8030500793457031e+02 9.8139503479003906e+01 7.8982192993164062e+01 -1.8565400695800781e+02 9.6751899719238281e+01 7.8003402709960938e+01 -1.8285900878906250e+02 9.7275398254394531e+01 7.8003402709960938e+01 -1.8849499511718750e+02 9.6622497558593750e+01 7.8003402709960938e+01 -1.9890499877929688e+02 9.9800300598144531e+01 7.9398605346679688e+01 -1.9996600341796875e+02 1.0045299530029297e+02 6.6992698669433594e+01 -1.9624499511718750e+02 9.8391304016113281e+01 7.8003402709960938e+01 -1.9409300231933594e+02 9.7548400878906250e+01 7.8003402709960938e+01 -1.9149099731445312e+02 9.6912895202636719e+01 7.8963195800781250e+01 -2.0232099914550781e+02 1.0245300292968750e+02 7.8797698974609375e+01 -2.0169999694824219e+02 1.0182700347900391e+02 7.0164802551269531e+01 -2.0583898925781250e+02 1.0707999420166016e+02 7.8534095764160156e+01 -2.0549600219726562e+02 1.0633499908447266e+02 7.4745201110839844e+01 -2.0601800537109375e+02 1.2635299682617188e+02 7.9329902648925781e+01 -2.0563099670410156e+02 1.2786699676513672e+02 7.4140098571777344e+01 -2.0835499572753906e+02 1.1968500518798828e+02 7.8506301879882812e+01 -2.0846900939941406e+02 1.1887100219726562e+02 7.4943901062011719e+01 -2.0795300292968750e+02 1.1278800201416016e+02 7.8602302551269531e+01 -2.0781199645996094e+02 1.1190499877929688e+02 7.4618598937988281e+01 -2.0186500549316406e+02 1.3194200134277344e+02 7.9011703491210938e+01 -1.9752799987792969e+02 1.3502799987792969e+02 7.8466598510742188e+01 -1.9871200561523438e+02 1.3434199523925781e+02 6.8486900329589844e+01 -2.0096600341796875e+02 1.3275199890136719e+02 7.0172798156738281e+01 -1.9532400512695312e+02 1.3597599792480469e+02 7.8003402709960938e+01 -1.9450399780273438e+02 1.3631799316406250e+02 7.8003402709960938e+01 -1.9178298950195312e+02 1.3702799987792969e+02 7.8985603332519531e+01 -1.8892799377441406e+02 1.3736199951171875e+02 7.8003402709960938e+01 -1.8608500671386719e+02 1.3729299926757812e+02 7.8003402709960938e+01 -1.8331800842285156e+02 1.3683099365234375e+02 7.8988998413085938e+01 -1.7362600708007812e+02 1.3145401000976562e+02 6.8737602233886719e+01 -1.7448100280761719e+02 1.3229299926757812e+02 7.8327095031738281e+01 -1.8052500915527344e+02 1.3596800231933594e+02 7.8499397277832031e+01 -1.7790399169921875e+02 1.3469999694824219e+02 7.8981498718261719e+01 -1.7068499755859375e+02 1.2788799285888672e+02 7.8750000000000000e+01 -1.6850199890136719e+02 1.2299900054931641e+02 7.8619400024414062e+01 -1.6756300354003906e+02 1.1698899841308594e+02 7.8769294738769531e+01 -1.6814100646972656e+02 1.1216699981689453e+02 7.8782897949218750e+01 -1.6991000366210938e+02 1.0760700225830078e+02 7.8461105346679688e+01 -1.9411100769042969e+02 1.2936399841308594e+02 8.0289398193359375e+01 -1.9733399963378906e+02 1.3370999145507812e+02 8.0280899047851562e+01 -1.9795599365234375e+02 1.2667399597167969e+02 8.0289398193359375e+01 -1.8696199035644531e+02 1.0315699768066406e+02 8.0289398193359375e+01 -1.9162500000000000e+02 1.0369300079345703e+02 8.0289398193359375e+01 -1.8767898559570312e+02 9.7613601684570312e+01 8.0271400451660156e+01 -2.0186700439453125e+02 1.1763800048828125e+02 8.0289398193359375e+01 -2.0700199890136719e+02 1.1483799743652344e+02 8.0274497985839844e+01 -2.0057499694824219e+02 1.1112100219726562e+02 8.0289398193359375e+01 -1.9640299987792969e+02 1.0594999694824219e+02 8.0289398193359375e+01 -2.0409899902343750e+02 1.0668999481201172e+02 8.0278701782226562e+01 -2.0077299499511719e+02 1.2220300292968750e+02 8.0289398193359375e+01 -2.0665200805664062e+02 1.2100099945068359e+02 8.0281303405761719e+01 -1.8903799438476562e+02 1.3084300231933594e+02 8.0289398193359375e+01 -1.8734201049804688e+02 1.3595600891113281e+02 8.0280799865722656e+01 -1.7542498779296875e+02 1.2287899780273438e+02 8.0289398193359375e+01 -1.7289300537109375e+02 1.2863500976562500e+02 8.0285301208496094e+01 -1.7860600280761719e+02 1.2709799194335938e+02 8.0289398193359375e+01 -1.7427200317382812e+02 1.1832900238037109e+02 8.0289398193359375e+01 -1.8188899230957031e+02 1.0463500213623047e+02 8.0289398193359375e+01 -1.7742399597167969e+02 1.0126399993896484e+02 8.0279899597167969e+01 -1.7804400634765625e+02 1.0732699584960938e+02 8.0289398193359375e+01 -1.8248599243164062e+02 1.2974000549316406e+02 8.0289398193359375e+01 -1.7966300964355469e+02 1.3402600097656250e+02 8.0281196594238281e+01 -1.7468899536132812e+02 1.1306100463867188e+02 8.0289398193359375e+01 -1.7191799926757812e+02 1.0691400146484375e+02 8.0273399353027344e+01 -1.7329600524902344e+02 1.0572000122070312e+02 7.8383499145507812e+01 -1.7680200195312500e+02 1.0228399658203125e+02 7.8384300231933594e+01 -1.7089700317382812e+02 1.0993400573730469e+02 7.8383903503417969e+01 -1.7002398681640625e+02 1.1272000122070312e+02 7.8003402709960938e+01 -1.6960099792480469e+02 1.1558899688720703e+02 7.8120002746582031e+01 -1.6970999145507812e+02 1.1944500732421875e+02 7.8120002746582031e+01 -1.7330400085449219e+02 1.2823899841308594e+02 7.8383903503417969e+01 -1.7177400207519531e+02 1.2584100341796875e+02 7.8236900329589844e+01 -1.7057299804687500e+02 1.2322600555419922e+02 7.8384201049804688e+01 -1.7620599365234375e+02 1.3125599670410156e+02 7.8296195983886719e+01 -1.8007600402832031e+02 1.3369299316406250e+02 7.8384201049804688e+01 -1.8371998596191406e+02 1.3497599792480469e+02 7.8003402709960938e+01 -1.8186601257324219e+02 1.3443099975585938e+02 7.8384201049804688e+01 -1.8562300109863281e+02 1.3532499694824219e+02 7.8003402709960938e+01 -1.8755101013183594e+02 1.3547299194335938e+02 7.8003402709960938e+01 -1.9885000610351562e+02 1.3197499084472656e+02 7.8383804321289062e+01 -1.9860200500488281e+02 1.3216101074218750e+02 6.9790901184082031e+01 -1.9525498962402344e+02 1.3399600219726562e+02 7.8383697509765625e+01 -1.9328199768066406e+02 1.3470800781250000e+02 7.8003402709960938e+01 -1.9140200805664062e+02 1.3516299438476562e+02 7.8003402709960938e+01 -1.8948500061035156e+02 1.3541899108886719e+02 7.8003402709960938e+01 -2.0157598876953125e+02 1.2961100769042969e+02 7.3346900939941406e+01 -2.0202000427246094e+02 1.2907299804687500e+02 7.8384201049804688e+01 -2.0407499694824219e+02 1.2638099670410156e+02 7.4416503906250000e+01 -2.0513699340820312e+02 1.2397599792480469e+02 7.8228698730468750e+01 -2.0645899963378906e+02 1.1912200164794922e+02 7.5144294738769531e+01 -2.0583898925781250e+02 1.1190399932861328e+02 7.8384506225585938e+01 -2.0630400085449219e+02 1.1302799987792969e+02 7.3453498840332031e+01 -2.0304800415039062e+02 1.0616000366210938e+02 7.8228500366210938e+01 -2.0427999877929688e+02 1.0772900390625000e+02 7.3554000854492188e+01 -2.0162800598144531e+02 1.0445500183105469e+02 7.3355598449707031e+01 -1.9986698913574219e+02 1.0268999481201172e+02 6.8037704467773438e+01 -1.9847300720214844e+02 1.0174299621582031e+02 7.8384201049804688e+01 -1.9592399597167969e+02 1.0030699920654297e+02 7.8003402709960938e+01 -1.7915100097656250e+02 1.0077799987792969e+02 7.8236602783203125e+01 -1.8089599609375000e+02 9.9941497802734375e+01 7.8003402709960938e+01 -1.8271798706054688e+02 9.9292396545410156e+01 7.8003402709960938e+01 -1.8459799194335938e+02 9.8837303161621094e+01 7.8003402709960938e+01 -1.8651499938964844e+02 9.8581199645996094e+01 7.8003402709960938e+01 -1.8844799804687500e+02 9.8526901245117188e+01 7.8384101867675781e+01 -1.9037699890136719e+02 9.8675102233886719e+01 7.8003402709960938e+01 -1.9227999877929688e+02 9.9023902893066406e+01 7.8003402709960938e+01 -1.9413499450683594e+02 9.9569702148437500e+01 7.8003402709960938e+01 -1.8963800048828125e+02 1.3078500366210938e+02 7.8384399414062500e+01 -1.8437500000000000e+02 1.3030700683593750e+02 7.8384399414062500e+01 -1.8008500671386719e+02 1.2840400695800781e+02 7.8384399414062500e+01 -1.7569200134277344e+02 1.2341999816894531e+02 7.8384399414062500e+01 -1.7411799621582031e+02 1.1696399688720703e+02 7.8384399414062500e+01 -1.7639001464843750e+02 1.0909799957275391e+02 7.8384399414062500e+01 -1.8188899230957031e+02 1.0463500213623047e+02 7.8384399414062500e+01 -1.8636199951171875e+02 1.0321500396728516e+02 7.8384399414062500e+01 -1.9162500000000000e+02 1.0369300079345703e+02 7.8384399414062500e+01 -1.9591499328613281e+02 1.0559600067138672e+02 7.8384399414062500e+01 -2.0030799865722656e+02 1.1057999420166016e+02 7.8384399414062500e+01 -2.0188200378417969e+02 1.1703600311279297e+02 7.8384399414062500e+01 -2.0077299499511719e+02 1.2220300292968750e+02 7.8384399414062500e+01 -1.9738101196289062e+02 1.2745100402832031e+02 7.8384399414062500e+01 -2.1526300048828125e+02 1.0397399902343750e+02 6.9145004272460938e+01 -2.1511801147460938e+02 1.0338099670410156e+02 7.1139099121093750e+01 -2.1515100097656250e+02 1.0541400146484375e+02 7.0108505249023438e+01 -2.1500399780273438e+02 1.0514900207519531e+02 7.2041099548339844e+01 -2.1455599975585938e+02 1.2989099121093750e+02 7.0108505249023438e+01 -2.1540100097656250e+02 1.0301399993896484e+02 6.7702896118164062e+01 -2.1542199707031250e+02 1.0108699798583984e+02 6.7968002319335938e+01 -2.1526400756835938e+02 1.0198000335693359e+02 6.9734298706054688e+01 -2.1442500305175781e+02 1.3191999816894531e+02 7.1139099121093750e+01 -2.1459800720214844e+02 1.3133399963378906e+02 6.9145004272460938e+01 -2.1450300598144531e+02 1.3332701110839844e+02 6.9734298706054688e+01 -2.1468899536132812e+02 1.3230000305175781e+02 6.7702896118164062e+01 -2.1458599853515625e+02 1.3422000122070312e+02 6.7965904235839844e+01 -2.0503500366210938e+02 1.0344599914550781e+02 7.1471801757812500e+01 -2.0471499633789062e+02 1.3147099304199219e+02 7.1317802429199219e+01 -1.6985000610351562e+02 1.2407099914550781e+02 7.9996101379394531e+01 -1.6884001159667969e+02 1.1417800140380859e+02 8.0035903930664062e+01 -2.0761099243164062e+02 1.0740999603271484e+02 7.2844200134277344e+01 -2.0991699218750000e+02 1.1649599456787109e+02 7.2836097717285156e+01 -2.0702600097656250e+02 1.0614699554443359e+02 7.0653404235839844e+01 -2.0323300170898438e+02 1.0394100189208984e+02 6.9508598327636719e+01 -1.9941200256347656e+02 1.3229299926757812e+02 6.6471298217773438e+01 -2.0272700500488281e+02 1.3199398803710938e+02 6.7865997314453125e+01 -2.0213299560546875e+02 1.3093598937988281e+02 6.9332099914550781e+01 -2.0545500183105469e+02 1.2802600097656250e+02 7.1244400024414062e+01 -2.0857398986816406e+02 1.2204500579833984e+02 7.0960098266601562e+01 -2.0942700195312500e+02 1.1457800292968750e+02 7.0887496948242188e+01 -2.0760600280761719e+02 1.1835700225830078e+02 7.2385902404785156e+01 -1.9399800109863281e+02 1.1928299713134766e+02 8.4716903686523438e+01 -1.9604399108886719e+02 1.2347100067138672e+02 8.4724800109863281e+01 -1.9151100158691406e+02 1.2237300109863281e+02 8.4716903686523438e+01 -1.9433000183105469e+02 1.1649900054931641e+02 8.4716903686523438e+01 -1.9337300109863281e+02 1.1348899841308594e+02 8.4716903686523438e+01 -1.9625900268554688e+02 1.1090899658203125e+02 8.4725700378417969e+01 -1.9131599426269531e+02 1.1158399963378906e+02 8.4716903686523438e+01 -1.8831799316406250e+02 1.1059000396728516e+02 8.4716903686523438e+01 -1.9202999877929688e+02 1.0758700561523438e+02 8.4730796813964844e+01 -1.8993400573730469e+02 1.2712399291992188e+02 8.4734497070312500e+01 -1.8830299377441406e+02 1.2337599945068359e+02 8.4716995239257812e+01 -1.8529400634765625e+02 1.2276399993896484e+02 8.4716903686523438e+01 -1.8044699096679688e+02 1.2381800079345703e+02 8.4723701477050781e+01 -1.8556800842285156e+02 1.1113400268554688e+02 8.4716903686523438e+01 -1.8009300231933594e+02 1.1057700347900391e+02 8.4721000671386719e+01 -1.8300099182128906e+02 1.1297499847412109e+02 8.4716903686523438e+01 -1.8159001159667969e+02 1.1668199920654297e+02 8.4716903686523438e+01 -1.7803099060058594e+02 1.1466299438476562e+02 8.4725296020507812e+01 -1.8262701416015625e+02 1.2051100158691406e+02 8.4716903686523438e+01 -1.9348399353027344e+02 9.6394897460937500e+01 8.9066101074218750e+01 -1.8330299377441406e+02 9.6308403015136719e+01 8.9005905151367188e+01 -1.8692700195312500e+02 9.7028999328613281e+01 8.9314102172851562e+01 -1.7775000000000000e+02 9.9724700927734375e+01 8.9445594787597656e+01 -1.7243899536132812e+02 1.0275099945068359e+02 8.9078598022460938e+01 -1.7029499816894531e+02 1.0751999664306641e+02 8.9501899719238281e+01 -1.7238800048828125e+02 1.2940501403808594e+02 8.9315895080566406e+01 -1.6901899719238281e+02 1.2311100006103516e+02 8.9316001892089844e+01 -1.7030699157714844e+02 1.2876799011230469e+02 8.9060203552246094e+01 -1.6602101135253906e+02 1.2007500457763672e+02 8.8439796447753906e+01 -1.6807800292968750e+02 1.1552199554443359e+02 8.9603103637695312e+01 -1.8442900085449219e+02 1.3661700439453125e+02 8.9315696716308594e+01 -1.7775599670410156e+02 1.3410900878906250e+02 8.9406402587890625e+01 -1.8518798828125000e+02 1.3819900512695312e+02 8.9006202697753906e+01 -2.0070899963378906e+02 1.3239399719238281e+02 8.9443305969238281e+01 -1.9330999755859375e+02 1.3635600280761719e+02 8.9386497497558594e+01 -1.9208300781250000e+02 1.3888500976562500e+02 8.8288002014160156e+01 -2.0481201171875000e+02 1.0626000213623047e+02 8.9316703796386719e+01 -2.0752301025390625e+02 1.1288899993896484e+02 8.9316802978515625e+01 -2.0783599853515625e+02 1.0709899902343750e+02 8.8444503784179688e+01 -2.0898899841308594e+02 1.1483100128173828e+02 8.9077194213867188e+01 -2.0766699218750000e+02 1.2059799957275391e+02 8.9599700927734375e+01 -2.0296701049804688e+02 1.0172100067138672e+02 8.8941101074218750e+01 -1.9352301025390625e+02 9.7833297729492188e+01 8.9316505432128906e+01 -1.9993600463867188e+02 1.0101699829101562e+02 8.9316703796386719e+01 -2.0720799255371094e+02 1.2828601074218750e+02 8.8005500793457031e+01 -2.0532398986816406e+02 1.2691299438476562e+02 8.9443603515625000e+01 -2.0432199096679688e+02 1.3206001281738281e+02 8.8100593566894531e+01 -2.0056500244140625e+02 1.3532299804687500e+02 8.8127906799316406e+01 -1.7469500732421875e+02 1.3487100219726562e+02 8.8244804382324219e+01 -1.7662799072265625e+02 9.7909500122070312e+01 8.8117500305175781e+01 -1.9612799072265625e+02 9.6233001708984375e+01 8.7712600708007812e+01 -2.0083999633789062e+02 9.8865303039550781e+01 8.7707496643066406e+01 -2.0917700195312500e+02 1.1007800292968750e+02 8.7679603576660156e+01 -2.1030099487304688e+02 1.1718700408935547e+02 8.7776802062988281e+01 -2.0910800170898438e+02 1.2404399871826172e+02 8.7733901977539062e+01 -1.9641999816894531e+02 1.3761100769042969e+02 8.7638099670410156e+01 -1.8656199645996094e+02 1.3917500305175781e+02 8.7962501525878906e+01 -1.6721800231933594e+02 1.2488300323486328e+02 8.7826103210449219e+01 -1.6579699707031250e+02 1.1515499877929688e+02 8.7687698364257812e+01 -1.6668400573730469e+02 1.1059899902343750e+02 8.7718498229980469e+01 -1.6851499938964844e+02 1.0632499694824219e+02 8.7810699462890625e+01 -1.7213999938964844e+02 1.0133300018310547e+02 8.7654396057128906e+01 -1.8244900512695312e+02 9.5370498657226562e+01 8.7859901428222656e+01 -1.8929800415039062e+02 9.4745895385742188e+01 8.7657897949218750e+01 -2.0551399230957031e+02 1.0320000457763672e+02 8.7302604675292969e+01 -1.8118501281738281e+02 1.3823199462890625e+02 8.7310798645019531e+01 -1.6960699462890625e+02 1.2959899902343750e+02 8.7540000915527344e+01 -1.7794898986816406e+02 1.2002999877929688e+02 8.4922798156738281e+01 -1.8382200622558594e+02 1.2669600677490234e+02 8.4976097106933594e+01 -1.9855900573730469e+02 1.1678399658203125e+02 8.4899703979492188e+01 -1.8514099121093750e+02 1.0683499908447266e+02 8.4799102783203125e+01 -1.8542399597167969e+02 9.4924705505371094e+01 8.1694297790527344e+01 -1.8172999572753906e+02 9.5677703857421875e+01 8.1694297790527344e+01 -1.7821699523925781e+02 9.7043899536132812e+01 8.1694297790527344e+01 -1.7498500061035156e+02 9.8984298706054688e+01 8.1694297790527344e+01 -1.7212800598144531e+02 1.0144300079345703e+02 8.1694297790527344e+01 -1.6972700500488281e+02 1.0434899902343750e+02 8.1694297790527344e+01 -1.6785200500488281e+02 1.0761900329589844e+02 8.1694297790527344e+01 -1.6655599975585938e+02 1.1115899658203125e+02 8.1694297790527344e+01 -1.6587799072265625e+02 1.1486700439453125e+02 8.1694297790527344e+01 -1.6583499145507812e+02 1.1863700103759766e+02 8.1694297790527344e+01 -1.6643099975585938e+02 1.2235900115966797e+02 8.1694297790527344e+01 -1.6764700317382812e+02 1.2592700195312500e+02 8.1694297790527344e+01 -1.6944799804687500e+02 1.2923899841308594e+02 8.1694297790527344e+01 -1.7178300476074219e+02 1.3219801330566406e+02 8.1694297790527344e+01 -1.7458500671386719e+02 1.3472000122070312e+02 8.1694297790527344e+01 -1.7777299499511719e+02 1.3673199462890625e+02 8.1694297790527344e+01 -1.8125500488281250e+02 1.3817700195312500e+02 8.1694297790527344e+01 -1.8492999267578125e+02 1.3901199340820312e+02 8.1694297790527344e+01 -1.8869499206542969e+02 1.3921398925781250e+02 8.1694297790527344e+01 -1.9243901062011719e+02 1.3877700805664062e+02 8.1694297790527344e+01 -1.9605499267578125e+02 1.3771400451660156e+02 8.1694297790527344e+01 -1.9944000244140625e+02 1.3605499267578125e+02 8.1694297790527344e+01 -2.0249600219726562e+02 1.3384700012207031e+02 8.1694297790527344e+01 -2.0513400268554688e+02 1.3115499877929688e+02 8.1694297790527344e+01 -2.0727999877929688e+02 1.2805500793457031e+02 8.1694297790527344e+01 -2.0887100219726562e+02 1.2463800048828125e+02 8.1694297790527344e+01 -2.0986199951171875e+02 1.2100099945068359e+02 8.1694297790527344e+01 -2.1022399902343750e+02 1.1724900054931641e+02 8.1694297790527344e+01 -2.0994599914550781e+02 1.1348899841308594e+02 8.1694297790527344e+01 -2.0903700256347656e+02 1.0983100128173828e+02 8.1694297790527344e+01 -2.0752301025390625e+02 1.0637900543212891e+02 8.1694297790527344e+01 -2.0544700622558594e+02 1.0323199462890625e+02 8.1694297790527344e+01 -2.0286900329589844e+02 1.0048200225830078e+02 8.1694297790527344e+01 -1.9986399841308594e+02 9.8206398010253906e+01 8.1694297790527344e+01 -1.9651699829101562e+02 9.6471694946289062e+01 8.1694297790527344e+01 -1.9292500305175781e+02 9.5327598571777344e+01 8.1694297790527344e+01 -1.8919200134277344e+02 9.4806999206542969e+01 8.1694297790527344e+01 -1.8745399475097656e+02 1.3097499084472656e+02 8.8288597106933594e+01 -1.8303599548339844e+02 1.3039599609375000e+02 8.8521400451660156e+01 -1.7913900756835938e+02 1.2763500213623047e+02 8.8095596313476562e+01 -1.7485600280761719e+02 1.2285599517822266e+02 8.8558898925781250e+01 -1.7378900146484375e+02 1.1794599914550781e+02 8.8524902343750000e+01 -1.7513699340820312e+02 1.1194100189208984e+02 8.8016098022460938e+01 -1.7973298645019531e+02 1.0519900512695312e+02 8.8522102355957031e+01 -1.8547700500488281e+02 1.0300499725341797e+02 8.8483001708984375e+01 -1.9272000122070312e+02 1.0332900238037109e+02 8.8479103088378906e+01 -2.0045599365234375e+02 1.1032900238037109e+02 8.8200706481933594e+01 -2.0223001098632812e+02 1.1980100250244141e+02 8.8520896911621094e+01 -1.9850599670410156e+02 1.2662500000000000e+02 8.8524002075195312e+01 -1.9393699645996094e+02 1.3006900024414062e+02 8.8510604858398438e+01 -1.9762899780273438e+02 1.3618199157714844e+02 8.1694297790527344e+01 -1.9415199279785156e+02 1.3756201171875000e+02 8.1694297790527344e+01 -1.9048799133300781e+02 1.3831800842285156e+02 8.1694297790527344e+01 -1.8674800109863281e+02 1.3842601013183594e+02 8.1694297790527344e+01 -1.8142601013183594e+02 1.3752700805664062e+02 8.1702598571777344e+01 -1.7474900817871094e+02 1.3399600219726562e+02 8.1698402404785156e+01 -1.6970899963378906e+02 1.2838299560546875e+02 8.1692596435546875e+01 -1.6743800354003906e+02 1.2315200042724609e+02 8.1694297790527344e+01 -1.6643800354003906e+02 1.1759600067138672e+02 8.1705101013183594e+01 -1.6711700439453125e+02 1.1204600524902344e+02 8.1694297790527344e+01 -1.6829399108886719e+02 1.0849499511718750e+02 8.1694297790527344e+01 -1.7007000732421875e+02 1.0520199584960938e+02 8.1694297790527344e+01 -1.7368099975585938e+02 1.0091099548339844e+02 8.1699806213378906e+01 -1.7990599060058594e+02 9.7026802062988281e+01 8.1698593139648438e+01 -1.8728799438476562e+02 9.5467796325683594e+01 8.1692504882812500e+01 -1.9295401000976562e+02 9.6116500854492188e+01 8.1694297790527344e+01 -1.9806900024414062e+02 9.7943794250488281e+01 8.1701499938964844e+01 -2.0273199462890625e+02 1.0139099884033203e+02 8.1694297790527344e+01 -2.0521800231933594e+02 1.0418599700927734e+02 8.1694297790527344e+01 -2.0718200683593750e+02 1.0737100219726562e+02 8.1694297790527344e+01 -2.0912100219726562e+02 1.1261299896240234e+02 8.1706001281738281e+01 -2.0930700683593750e+02 1.2013999938964844e+02 8.1700492858886719e+01 -2.0770600891113281e+02 1.2550499725341797e+02 8.1694297790527344e+01 -2.0490100097656250e+02 1.3034899902343750e+02 8.1700599670410156e+01 -2.0081399536132812e+02 1.3421800231933594e+02 8.1694297790527344e+01 -1.8686300659179688e+02 1.3566101074218750e+02 8.8559394836425781e+01 -2.0462899780273438e+02 1.1256299591064453e+02 8.8552307128906250e+01 -1.9510600280761719e+02 9.9530395507812500e+01 8.8542404174804688e+01 -1.8378399658203125e+02 9.8202499389648438e+01 8.8490798950195312e+01 -1.7425599670410156e+02 1.1120899963378906e+02 8.8552307128906250e+01 -1.9147900390625000e+02 9.5876403808593750e+01 8.6246803283691406e+01 -1.8544900512695312e+02 9.5665100097656250e+01 8.6125595092773438e+01 -1.9667999267578125e+02 9.7348098754882812e+01 8.6105895996093750e+01 -2.0263899230957031e+02 1.0124600219726562e+02 8.6103500366210938e+01 -2.0731700134277344e+02 1.0752899932861328e+02 8.5710800170898438e+01 -2.0945199584960938e+02 1.1515600585937500e+02 8.5683502197265625e+01 -2.0897898864746094e+02 1.2181900024414062e+02 8.5530899047851562e+01 -2.0641400146484375e+02 1.2825801086425781e+02 8.5238700866699219e+01 -2.0092100524902344e+02 1.3416300964355469e+02 8.6184005737304688e+01 -1.9614500427246094e+02 1.3682800292968750e+02 8.5522003173828125e+01 -1.9053800964355469e+02 1.3838800048828125e+02 8.5141799926757812e+01 -1.8354701232910156e+02 1.3807499694824219e+02 8.5638206481933594e+01 -1.7774899291992188e+02 1.3585198974609375e+02 8.5695899963378906e+01 -1.7253700256347656e+02 1.3204200744628906e+02 8.5271095275878906e+01 -1.6866099548339844e+02 1.2648099517822266e+02 8.5144203186035156e+01 -1.6713400268554688e+02 1.2174800109863281e+02 8.6350601196289062e+01 -1.6656098937988281e+02 1.1609700012207031e+02 8.6140403747558594e+01 -1.6762899780273438e+02 1.0972800445556641e+02 8.5544303894042969e+01 -1.7133900451660156e+02 1.0351599884033203e+02 8.5808502197265625e+01 -1.7462699890136719e+02 1.0018599700927734e+02 8.6201805114746094e+01 -1.7853199768066406e+02 9.7754203796386719e+01 8.6222496032714844e+01 -2.0379200744628906e+02 1.2728600311279297e+02 8.8531600952148438e+01 -1.7600099182128906e+02 1.3085099792480469e+02 8.8552200317382812e+01 -1.7393901062011719e+02 1.0440000152587891e+02 8.8530502319335938e+01 -1.7013899230957031e+02 1.2643299865722656e+02 8.7963600158691406e+01 -1.6855999755859375e+02 1.1435800170898438e+02 8.8128097534179688e+01 -2.0342999267578125e+02 1.0465000152587891e+02 8.8034797668457031e+01 -2.0737199401855469e+02 1.1108399963378906e+02 8.7832397460937500e+01 -2.0793699645996094e+02 1.1681900024414062e+02 8.8026901245117188e+01 -1.9574198913574219e+02 1.3594599914550781e+02 8.7716400146484375e+01 -2.0671199035644531e+02 1.2636100006103516e+02 8.7056900024414062e+01 -1.8735900878906250e+02 1.3741600036621094e+02 8.7574699401855469e+01 -1.7490998840332031e+02 1.3274900817871094e+02 8.7583900451660156e+01 -1.8079200744628906e+02 1.3565899658203125e+02 8.7817901611328125e+01 -1.7002900695800781e+02 1.0808300018310547e+02 8.7821296691894531e+01 -1.8182499694824219e+02 1.1552000427246094e+02 9.2074996948242188e+01 -1.6808099365234375e+02 1.1610499572753906e+02 9.2074996948242188e+01 -1.8166999816894531e+02 1.1750099945068359e+02 9.2074996948242188e+01 -1.6824198913574219e+02 1.1967700195312500e+02 9.2074996948242188e+01 -1.8213400268554688e+02 1.1943199920654297e+02 9.2074996948242188e+01 -1.9386599731445312e+02 1.1456800079345703e+02 9.2074996948242188e+01 -1.9433000183105469e+02 1.1649900054931641e+02 9.2074996948242188e+01 -2.0743901062011719e+02 1.1256299591064453e+02 9.2074996948242188e+01 -1.8770800781250000e+02 1.1062300109863281e+02 9.2074996948242188e+01 -1.8269599914550781e+02 9.7779495239257812e+01 9.2074996948242188e+01 -1.8556800842285156e+02 1.1113400268554688e+02 9.2074996948242188e+01 -1.7783099365234375e+02 9.9767402648925781e+01 9.2074996948242188e+01 -1.8387399291992188e+02 1.1217299652099609e+02 9.2074996948242188e+01 -1.8948001098632812e+02 1.1082500457763672e+02 9.2074996948242188e+01 -1.8791600036621094e+02 9.6910606384277344e+01 9.2074996948242188e+01 -2.0555900573730469e+02 1.0738800048828125e+02 9.2074996948242188e+01 -1.9282699584960938e+02 1.1287400054931641e+02 9.2074996948242188e+01 -2.0105799865722656e+02 1.0182800292968750e+02 9.2074996948242188e+01 -1.9131599426269531e+02 1.1158399963378906e+02 9.2074996948242188e+01 -1.9417500305175781e+02 1.1847999572753906e+02 9.2074996948242188e+01 -2.0775898742675781e+02 1.1967700195312500e+02 9.2074996948242188e+01 -2.0791900634765625e+02 1.1610499572753906e+02 9.2074996948242188e+01 -1.9212600708007812e+02 1.2182699584960938e+02 9.2074996948242188e+01 -2.0358900451660156e+02 1.2943199157714844e+02 9.2074996948242188e+01 -1.9341600036621094e+02 1.2031600189208984e+02 9.2074996948242188e+01 -2.0555799865722656e+02 1.2644800567626953e+02 9.2074996948242188e+01 -2.0696299743652344e+02 1.2316100311279297e+02 9.2074996948242188e+01 -1.8258399963378906e+02 1.1368399810791016e+02 9.2074996948242188e+01 -1.6911299133300781e+02 1.1086299896240234e+02 9.2074996948242188e+01 -1.7246800231933594e+02 1.0437599945068359e+02 9.2074996948242188e+01 -1.9488899230957031e+02 9.8205703735351562e+01 9.2074996948242188e+01 -1.9043199157714844e+02 1.2286599731445312e+02 9.2074996948242188e+01 -1.9822700500488281e+02 1.3411700439453125e+02 9.2074996948242188e+01 -2.0111900329589844e+02 1.3201499938964844e+02 9.2074996948242188e+01 -1.8850100708007812e+02 1.2332999420166016e+02 9.2074996948242188e+01 -1.9343499755859375e+02 1.3626599121093750e+02 9.2074996948242188e+01 -1.8468399047851562e+02 1.2241600036621094e+02 9.2074996948242188e+01 -1.8099400329589844e+02 1.3566799926757812e+02 9.2074996948242188e+01 -1.8651998901367188e+02 1.2317500305175781e+02 9.2074996948242188e+01 -1.8444000244140625e+02 1.3661900329589844e+02 9.2074996948242188e+01 -1.8800000000000000e+02 1.3693901062011719e+02 9.2074996948242188e+01 -1.8317300415039062e+02 1.2112600708007812e+02 9.2074996948242188e+01 -1.7488099670410156e+02 1.3201499938964844e+02 9.2074996948242188e+01 -1.7777299499511719e+02 1.3411700439453125e+02 9.2074996948242188e+01 -1.6903700256347656e+02 1.2316100311279297e+02 9.2074996948242188e+01 -1.7139999389648438e+02 1.2818400573730469e+02 9.2074996948242188e+01 -1.9433000183105469e+02 1.1649900054931641e+02 1.0518900299072266e+02 -1.9386599731445312e+02 1.1456800079345703e+02 1.0518900299072266e+02 -1.8651998901367188e+02 1.2317500305175781e+02 1.0518900299072266e+02 -1.9212600708007812e+02 1.2182699584960938e+02 1.0518900299072266e+02 -1.9341600036621094e+02 1.2031600189208984e+02 1.0518900299072266e+02 -1.9417500305175781e+02 1.1847999572753906e+02 1.0518900299072266e+02 -1.9282699584960938e+02 1.1287400054931641e+02 1.0518900299072266e+02 -1.9131599426269531e+02 1.1158399963378906e+02 1.0518900299072266e+02 -1.8948001098632812e+02 1.1082500457763672e+02 1.0518900299072266e+02 -1.8182499694824219e+02 1.1552000427246094e+02 1.0518900299072266e+02 -1.8771299743652344e+02 1.1062000274658203e+02 1.0518900299072266e+02 -1.8258399963378906e+02 1.1368399810791016e+02 1.0518900299072266e+02 -1.8556800842285156e+02 1.1113400268554688e+02 1.0518900299072266e+02 -1.8387399291992188e+02 1.1217299652099609e+02 1.0518900299072266e+02 -1.8166999816894531e+02 1.1750099945068359e+02 1.0518900299072266e+02 -1.8213400268554688e+02 1.1943199920654297e+02 1.0518900299072266e+02 -1.8317300415039062e+02 1.2112600708007812e+02 1.0518900299072266e+02 -1.8468399047851562e+02 1.2241600036621094e+02 1.0518900299072266e+02 -1.9043199157714844e+02 1.2286599731445312e+02 1.0518900299072266e+02 -1.8850100708007812e+02 1.2332999420166016e+02 1.0518900299072266e+02 -1.8651998901367188e+02 1.2317500305175781e+02 7.7972892761230469e+01 -1.8369599914550781e+02 1.2176100158691406e+02 7.7972892761230469e+01 -1.8215100097656250e+02 1.1949600219726562e+02 7.8163307189941406e+01 -1.8161801147460938e+02 1.1631600189208984e+02 7.7972892761230469e+01 -1.8323899841308594e+02 1.1269599914550781e+02 7.7972892761230469e+01 -1.8556800842285156e+02 1.1113400268554688e+02 7.7972892761230469e+01 -1.8868400573730469e+02 1.1061800384521484e+02 7.7972892761230469e+01 -1.9131599426269531e+02 1.1158399963378906e+02 7.7972892761230469e+01 -1.9356500244140625e+02 1.1380200195312500e+02 7.7972892761230469e+01 -1.9433000183105469e+02 1.1649900054931641e+02 7.7972892761230469e+01 -1.9385800170898438e+02 1.1962200164794922e+02 7.7972892761230469e+01 -1.9119801330566406e+02 1.2256500244140625e+02 7.7972892761230469e+01 -1.8850100708007812e+02 1.2332999420166016e+02 7.7972892761230469e+01 -1.8892799377441406e+02 1.2621399688720703e+02 7.4741104125976562e+01 -1.7992900085449219e+02 1.2090100097656250e+02 7.3910995483398438e+01 -1.9474198913574219e+02 1.2259600067138672e+02 7.4315399169921875e+01 -1.9675299072265625e+02 1.1430200195312500e+02 7.4429603576660156e+01 -1.9053800964355469e+02 1.0881099700927734e+02 7.4264801025390625e+01 -1.8148800659179688e+02 1.1028300476074219e+02 7.4594299316406250e+01 -1.9390399169921875e+02 1.0973100280761719e+02 7.6581405639648438e+01 -1.8768901062011719e+02 1.0759300231933594e+02 7.6467994689941406e+01 -1.8299099731445312e+02 1.2494100189208984e+02 7.6560501098632812e+01 -1.7929400634765625e+02 1.1467900085449219e+02 7.7438507080078125e+01 -1.7913099670410156e+02 1.1929599761962891e+02 7.6824096679687500e+01 -1.9425399780273438e+02 1.2385700225830078e+02 7.6675697326660156e+01 -1.9715798950195312e+02 1.1813800048828125e+02 7.6822601318359375e+01 -1.8422200012207031e+02 1.0946000671386719e+02 7.7811096191406250e+01 -1.8779499816894531e+02 1.2541100311279297e+02 7.7840698242187500e+01 -1.9509199523925781e+02 1.2120000457763672e+02 7.7840301513671875e+01 -1.9555500793457031e+02 1.1375199890136719e+02 7.7861900329589844e+01 -1.9137799072265625e+02 1.0991899871826172e+02 7.7938301086425781e+01 -1.8646299743652344e+02 1.2716099548339844e+02 8.5700401306152344e+01 -1.9303601074218750e+02 1.2571899414062500e+02 8.5489601135253906e+01 -1.8113200378417969e+02 1.2418500518798828e+02 8.5493293762207031e+01 -1.9499600219726562e+02 1.0965299987792969e+02 8.5677993774414062e+01 -1.8950801086425781e+02 1.0706300354003906e+02 8.5498100280761719e+01 -1.9757699584960938e+02 1.1440999603271484e+02 8.5487800598144531e+01 -1.8363699340820312e+02 1.0774300384521484e+02 8.5723403930664062e+01 -1.8028500366210938e+02 1.1083200073242188e+02 8.5492698669433594e+01 -1.7662799072265625e+02 1.2136500549316406e+02 8.7639999389648438e+01 -1.7807200622558594e+02 1.1536900329589844e+02 8.5494300842285156e+01 -1.9230400085449219e+02 1.1223900604248047e+02 8.5478904724121094e+01 -1.8779699707031250e+02 1.1040899658203125e+02 8.5478904724121094e+01 -1.9453700256347656e+02 1.1675000000000000e+02 8.5478904724121094e+01 -1.9756700134277344e+02 1.2021800231933594e+02 8.5499801635742188e+01 -1.9341600036621094e+02 1.2031600189208984e+02 8.5478904724121094e+01 -1.9025799560546875e+02 1.2313999938964844e+02 8.5478904724121094e+01 -1.8537800598144531e+02 1.2285800170898438e+02 8.5478904724121094e+01 -1.8146299743652344e+02 1.1725000000000000e+02 8.5478904724121094e+01 -1.8317300415039062e+02 1.2112600708007812e+02 8.5478904724121094e+01 -1.8258399963378906e+02 1.1368399810791016e+02 8.5478904724121094e+01 -1.8387399291992188e+02 1.1217299652099609e+02 8.5478904724121094e+01 -1.8565000915527344e+02 1.3086999511718750e+02 8.9309402465820312e+01 -1.7888600158691406e+02 1.2778900909423828e+02 8.9310897827148438e+01 -1.7409800720214844e+02 1.1872900390625000e+02 8.9309997558593750e+01 -1.7474200439453125e+02 1.1342299652099609e+02 8.9031501770019531e+01 -1.7712800598144531e+02 1.0816300201416016e+02 8.9305801391601562e+01 -1.8185000610351562e+02 1.0481900024414062e+02 8.8902198791503906e+01 -1.8723799133300781e+02 1.0304900360107422e+02 8.9311897277832031e+01 -1.9400500488281250e+02 1.0421500396728516e+02 8.9311103820800781e+01 -1.9857099914550781e+02 1.0787400054931641e+02 8.9310806274414062e+01 -2.0042900085449219e+02 1.1173400115966797e+02 8.8895797729492188e+01 -2.0172900390625000e+02 1.1632299804687500e+02 8.9036499023437500e+01 -2.0086500549316406e+02 1.2132500457763672e+02 8.8927200317382812e+01 -1.9778999328613281e+02 1.2730799865722656e+02 8.9307701110839844e+01 -1.9080899047851562e+02 1.3068699645996094e+02 8.9310806274414062e+01 -2.0193600463867188e+02 1.2127300262451172e+02 8.9314300537109375e+01 -1.9043199157714844e+02 1.2286599731445312e+02 8.9314300537109375e+01 -1.8850100708007812e+02 1.2332999420166016e+02 8.9314300537109375e+01 -1.9371299743652344e+02 1.2018600463867188e+02 8.9314300537109375e+01 -1.9433000183105469e+02 1.1649900054931641e+02 8.9314300537109375e+01 -1.9386599731445312e+02 1.1456800079345703e+02 8.9314300537109375e+01 -1.9282699584960938e+02 1.1287400054931641e+02 8.9314300537109375e+01 -1.8387399291992188e+02 1.1217299652099609e+02 8.9314300537109375e+01 -1.8258399963378906e+02 1.1368399810791016e+02 8.9314300537109375e+01 -1.8920199584960938e+02 1.1052499389648438e+02 8.9314300537109375e+01 -1.8556800842285156e+02 1.1113400268554688e+02 8.9314300537109375e+01 -1.8182499694824219e+02 1.1552000427246094e+02 8.9314300537109375e+01 -1.8166999816894531e+02 1.1750099945068359e+02 8.9314300537109375e+01 -1.8320399475097656e+02 1.2144899749755859e+02 8.9314300537109375e+01 -1.8651998901367188e+02 1.2317500305175781e+02 8.9314300537109375e+01 -2.1660099792480469e+02 -9.3463302612304688e+01 2.7293098449707031e+01 -2.1696299743652344e+02 -9.3445098876953125e+01 3.5564098358154297e+01 -2.0233599853515625e+02 -9.3802696228027344e+01 2.7968698501586914e+01 -2.0273899841308594e+02 -9.3797294616699219e+01 3.6213302612304688e+01 -2.0927398681640625e+02 -9.3641601562500000e+01 2.3525598526000977e+01 -2.1006900024414062e+02 -9.4226699829101562e+01 3.9989700317382812e+01 -2.0246400451660156e+02 -9.9117301940917969e+01 2.7968000411987305e+01 -2.0285398864746094e+02 -9.9107803344726562e+01 3.6207698822021484e+01 -2.1018299865722656e+02 -9.8929801940917969e+01 3.9989700317382812e+01 -2.1712100219726562e+02 -9.8761199951171875e+01 3.5531902313232422e+01 -2.1673100280761719e+02 -9.8770698547363281e+01 2.7292200088500977e+01 -2.0940299987792969e+02 -9.8948699951171875e+01 2.3510299682617188e+01 -2.0381799316406250e+02 -9.9084396362304688e+01 2.8340600967407227e+01 -2.1095800781250000e+02 -9.8910896301269531e+01 2.5140199661254883e+01 -2.1630599975585938e+02 -9.8780998229980469e+01 3.3363700866699219e+01 -2.1135699462890625e+02 -9.8901199340820312e+01 3.8276901245117188e+01 -2.0471900939941406e+02 -9.9062500000000000e+01 3.6141700744628906e+01 -2.1644100952148438e+02 -9.9308197021484375e+01 3.0348400115966797e+01 -2.0536099243164062e+02 -9.9682197570800781e+01 2.6723901748657227e+01 -2.1222399902343750e+02 -9.9515403747558594e+01 2.5488199234008789e+01 -2.1352900695800781e+02 -9.9483695983886719e+01 3.7334999084472656e+01 -2.0741200256347656e+02 -9.9632400512695312e+01 3.7875701904296875e+01 -2.0330099487304688e+02 -9.9732299804687500e+01 3.3387001037597656e+01 -2.1455599975585938e+02 -1.3914999389648438e+02 3.0896099090576172e+01 -2.0864399719238281e+02 -1.3928698730468750e+02 2.8438100814819336e+01 -2.1163700866699219e+02 -1.3921099853515625e+02 3.5589797973632812e+01 -2.0714900207519531e+02 -1.3931700134277344e+02 3.3288299560546875e+01 -2.0590400695800781e+02 -9.9668998718261719e+01 3.1250499725341797e+01 -2.0596900939941406e+02 -9.9667396545410156e+01 3.2616298675537109e+01 -2.0649699401855469e+02 -9.9654602050781250e+01 3.3877601623535156e+01 -2.0742399597167969e+02 -9.9632102966308594e+01 3.4882198333740234e+01 -2.0863800048828125e+02 -9.9602600097656250e+01 3.5509098052978516e+01 -2.0999400329589844e+02 -9.9569595336914062e+01 3.5682598114013672e+01 -2.1132800292968750e+02 -9.9537200927734375e+01 3.5381702423095703e+01 -2.1247799682617188e+02 -9.9509300231933594e+01 3.4642799377441406e+01 -2.1330599975585938e+02 -9.9489196777343750e+01 3.3555000305175781e+01 -2.1311999511718750e+02 -9.9493698120117188e+01 2.9622400283813477e+01 -2.1219299316406250e+02 -9.9516197204589844e+01 2.8617700576782227e+01 -2.1097799682617188e+02 -9.9545700073242188e+01 2.7990900039672852e+01 -2.0962199401855469e+02 -9.9578697204589844e+01 2.7817399978637695e+01 -2.0828900146484375e+02 -9.9611000061035156e+01 2.8118200302124023e+01 -2.1371200561523438e+02 -9.9479301452636719e+01 3.2249500274658203e+01 -2.1364801025390625e+02 -9.9480895996093750e+01 3.0883699417114258e+01 -2.0713900756835938e+02 -9.9638999938964844e+01 2.8857101440429688e+01 -2.0630999755859375e+02 -9.9659103393554688e+01 2.9944999694824219e+01 -2.1024699401855469e+02 -1.3819099426269531e+02 3.5655101776123047e+01 -2.1287300109863281e+02 -1.3812799072265625e+02 3.5062599182128906e+01 -2.1387701416015625e+02 -1.3810299682617188e+02 3.4135200500488281e+01 -2.1450399780273438e+02 -1.3808799743652344e+02 3.2919998168945312e+01 -2.1467700195312500e+02 -1.3808399963378906e+02 3.1563798904418945e+01 -2.1437699890136719e+02 -1.3809100341796875e+02 3.0230001449584961e+01 -2.1363798522949219e+02 -1.3810899353027344e+02 2.9079500198364258e+01 -2.1255099487304688e+02 -1.3813499450683594e+02 2.8251201629638672e+01 -2.1124499511718750e+02 -1.3816699218750000e+02 2.7844799041748047e+01 -2.0987998962402344e+02 -1.3819999694824219e+02 2.7909500122070312e+01 -2.0761500549316406e+02 -1.3825500488281250e+02 2.9364799499511719e+01 -2.0724800109863281e+02 -1.3826400756835938e+02 2.9944999694824219e+01 -2.0698800659179688e+02 -1.3827000427246094e+02 3.0579900741577148e+01 -2.0681500244140625e+02 -1.3827499389648438e+02 3.1936199188232422e+01 -2.0785400390625000e+02 -1.3824899291992188e+02 3.4420402526855469e+01 -2.0894200134277344e+02 -1.3822300720214844e+02 3.5248802185058594e+01 -2.1345600891113281e+02 -1.3775099182128906e+02 3.7612598419189453e+01 -2.1328399658203125e+02 -1.4001600646972656e+02 3.7113201141357422e+01 -2.0957798767089844e+02 -1.3960101318359375e+02 3.7605697631835938e+01 -2.0761999511718750e+02 -1.3955700683593750e+02 3.7051101684570312e+01 -2.1724798583984375e+02 -1.3808900451660156e+02 3.1992397308349609e+01 -2.1397499084472656e+02 -1.3934199523925781e+02 2.6385198593139648e+01 -2.1669400024414062e+02 -1.3942599487304688e+02 3.1376499176025391e+01 -2.1063200378417969e+02 -1.3344200134277344e+02 2.4412900924682617e+01 -2.0812599182128906e+02 -1.3957600402832031e+02 2.6105800628662109e+01 -2.0443800354003906e+02 -1.3937799072265625e+02 3.2271301269531250e+01 -2.0427999877929688e+02 -1.3362300109863281e+02 2.8080699920654297e+01 -2.0437200927734375e+02 -1.3726200866699219e+02 3.5416099548339844e+01 -2.1063099670410156e+02 -1.3346299743652344e+02 3.9087001800537109e+01 -2.1698300170898438e+02 -1.3328799438476562e+02 2.8081800460815430e+01 -2.1698400878906250e+02 -1.3331399536132812e+02 3.5418800354003906e+01 -2.0800900268554688e+02 -1.3956199645996094e+02 3.4021297454833984e+01 -2.1350599670410156e+02 -1.3942800903320312e+02 3.4367099761962891e+01 -2.1304299926757812e+02 -1.3900199890136719e+02 2.8767301559448242e+01 -2.0843699645996094e+02 -1.3937200927734375e+02 2.8975698471069336e+01 -2.0428300476074219e+02 -1.3351699829101562e+02 3.5415702819824219e+01 -2.1045399475097656e+02 -1.3736500549316406e+02 2.7790000915527344e+01 -2.1486399841308594e+02 -1.3725799560546875e+02 3.1376001358032227e+01 -2.1222700500488281e+02 -1.3732199096679688e+02 3.5519397735595703e+01 -2.0693199157714844e+02 -1.3744999694824219e+02 3.2465698242187500e+01 -2.0733801269531250e+02 -1.3744099426269531e+02 2.9464200973510742e+01 -2.0802299499511719e+02 -1.3742401123046875e+02 3.4911701202392578e+01 -2.1482899475097656e+02 -1.3324398803710938e+02 3.1125299453735352e+01 -2.1322999572753906e+02 -1.3328300476074219e+02 3.4828800201416016e+01 -2.1047200012207031e+02 -1.3335000610351562e+02 2.7405300140380859e+01 -2.0888499450683594e+02 -1.3338899230957031e+02 3.5732501983642578e+01 -2.0654499816894531e+02 -1.3344499206542969e+02 3.0963800430297852e+01 -1.9355799865722656e+02 -1.1925800323486328e+02 8.0995498657226562e+01 -1.9229798889160156e+02 -1.2566700744628906e+02 8.0995498657226562e+01 -1.8877999877929688e+02 -1.2274699401855469e+02 8.0995498657226562e+01 -1.8717700195312500e+02 -1.1105799865722656e+02 8.0995498657226562e+01 -1.8441400146484375e+02 -1.0801499938964844e+02 8.0995498657226562e+01 -1.9053100585937500e+02 -1.0766200256347656e+02 8.0995498657226562e+01 -1.8703300476074219e+02 -1.2655400085449219e+02 8.0995498657226562e+01 -1.8326600646972656e+02 -1.2068399810791016e+02 8.0995498657226562e+01 -1.8201200866699219e+02 -1.2459799957275391e+02 8.0995498657226562e+01 -1.8263299560546875e+02 -1.1480200195312500e+02 8.0995498657226562e+01 -1.7928199768066406e+02 -1.1259899902343750e+02 8.0995498657226562e+01 -1.9741400146484375e+02 -1.1998600006103516e+02 8.0995498657226562e+01 -1.9258700561523438e+02 -1.1345099639892578e+02 8.0995498657226562e+01 -1.9616999816894531e+02 -1.1164999389648438e+02 8.0995498657226562e+01 -1.7864799499511719e+02 -1.1947699737548828e+02 8.0995498657226562e+01 -1.8517300415039062e+02 -1.1170899963378906e+02 7.7972892761230469e+01 -1.9104998779296875e+02 -1.1206700134277344e+02 7.7972892761230469e+01 -1.9370700073242188e+02 -1.1596600341796875e+02 7.7972892761230469e+01 -1.9186499023437500e+02 -1.2158799743652344e+02 7.7972892761230469e+01 -1.8604199218750000e+02 -1.2245999908447266e+02 7.7972892761230469e+01 -1.8209399414062500e+02 -1.1805299377441406e+02 7.7972892761230469e+01 -1.8855599975585938e+02 -1.0734199523925781e+02 7.7972892761230469e+01 -1.8194499206542969e+02 -1.0933799743652344e+02 7.7972892761230469e+01 -1.7847900390625000e+02 -1.1528400421142578e+02 7.7972892761230469e+01 -1.7935700988769531e+02 -1.2134700012207031e+02 7.7972892761230469e+01 -1.8303300476074219e+02 -1.2521900177001953e+02 7.7972892761230469e+01 -1.8822300720214844e+02 -1.2667199707031250e+02 7.7972892761230469e+01 -1.9529299926757812e+02 -1.2365999603271484e+02 7.7972892761230469e+01 -1.9766299438476562e+02 -1.1558700561523438e+02 7.7972892761230469e+01 -1.9424700927734375e+02 -1.0961299896240234e+02 7.7972892761230469e+01 -1.9069300842285156e+02 -1.1035499572753906e+02 8.1051399230957031e+01 -1.9020700073242188e+02 -1.1006700134277344e+02 8.2956405639648438e+01 -1.8684899902343750e+02 -1.0992199707031250e+02 8.1051399230957031e+01 -1.8530599975585938e+02 -1.1035499572753906e+02 8.2956405639648438e+01 -1.8251100158691406e+02 -1.1222299957275391e+02 8.1051399230957031e+01 -1.8110899353027344e+02 -1.1423799896240234e+02 8.2956405639648438e+01 -1.8083601379394531e+02 -1.1668699645996094e+02 8.1051399230957031e+01 -1.8237699890136719e+02 -1.2184799957275391e+02 8.2956405639648438e+01 -1.8171699523925781e+02 -1.2045499420166016e+02 8.1051399230957031e+01 -1.8628199768066406e+02 -1.2422299957275391e+02 8.1051399230957031e+01 -1.8971798706054688e+02 -1.2422299957275391e+02 8.2956405639648438e+01 -1.9187599182128906e+02 -1.2303300476074219e+02 8.1051399230957031e+01 -1.9520300292968750e+02 -1.1879800415039062e+02 8.2956405639648438e+01 -1.9444599914550781e+02 -1.2014099884033203e+02 8.1051399230957031e+01 -1.9489100646972656e+02 -1.1423799896240234e+02 8.1051399230957031e+01 -1.9395799255371094e+02 -1.1301100158691406e+02 8.2956405639648438e+01 -1.9646101379394531e+02 -1.2546600341796875e+02 8.2997001647949219e+01 -1.9512901306152344e+02 -1.0740800476074219e+02 8.2989097595214844e+01 -1.8599900817871094e+02 -1.0561700439453125e+02 8.2971702575683594e+01 -1.9935299682617188e+02 -1.1531600189208984e+02 8.2980796813964844e+01 -1.8867599487304688e+02 -1.2846598815917969e+02 8.2977798461914062e+01 -1.8135600280761719e+02 -1.2633599090576172e+02 8.2961898803710938e+01 -1.7848899841308594e+02 -1.1026799774169922e+02 8.2985000610351562e+01 -1.9202999877929688e+02 -1.1292199707031250e+02 8.1052200317382812e+01 -1.8799200439453125e+02 -1.1124499511718750e+02 8.1074996948242188e+01 -1.8325000000000000e+02 -1.1360400390625000e+02 8.1050796508789062e+01 -1.8710899353027344e+02 -1.2264099884033203e+02 8.1050201416015625e+01 -1.9139700317382812e+02 -1.2172599792480469e+02 8.1052307128906250e+01 -1.9383299255371094e+02 -1.1713899993896484e+02 8.1051902770996094e+01 -1.8270700073242188e+02 -1.1975599670410156e+02 8.1048500061035156e+01 -1.9209500122070312e+02 -1.0372599792480469e+02 8.5998199462890625e+01 -1.9812400817871094e+02 -1.0749900054931641e+02 8.6079795837402344e+01 -2.0110200500488281e+02 -1.1174800109863281e+02 8.6323699951171875e+01 -1.8436399841308594e+02 -1.3071600341796875e+02 8.6280799865722656e+01 -1.9261700439453125e+02 -1.3012300109863281e+02 8.6055999755859375e+01 -1.7713500976562500e+02 -1.2566000366210938e+02 8.5966598510742188e+01 -1.7363899230957031e+02 -1.1824700164794922e+02 8.6129394531250000e+01 -1.7623800659179688e+02 -1.1776900482177734e+02 8.3247802734375000e+01 -1.8317399597167969e+02 -1.0402099609375000e+02 8.5886596679687500e+01 -2.0113800048828125e+02 -1.1807399749755859e+02 8.5241401672363281e+01 -1.9274499511718750e+02 -1.1327899932861328e+02 8.4840301513671875e+01 -1.9357299804687500e+02 -1.1843000030517578e+02 8.4338798522949219e+01 -1.8982499694824219e+02 -1.2275599670410156e+02 8.4830200195312500e+01 -1.8393800354003906e+02 -1.2117499542236328e+02 8.4356498718261719e+01 -1.8212998962402344e+02 -1.1637599945068359e+02 8.4825004577636719e+01 -1.8550099182128906e+02 -1.1165299987792969e+02 8.4830795288085938e+01 -1.7945899963378906e+02 -9.9508705139160156e+01 8.4815895080566406e+01 -1.7445700073242188e+02 -1.0296800231933594e+02 8.1033599853515625e+01 -1.7295700073242188e+02 -1.0479699707031250e+02 8.4544395446777344e+01 -1.7661698913574219e+02 -1.0900799560546875e+02 8.6074996948242188e+01 -1.9992199707031250e+02 -1.2439900207519531e+02 8.5960098266601562e+01 -2.0361399841308594e+02 -1.2255000305175781e+02 8.6686698913574219e+01 -2.0410600280761719e+02 -1.1080899810791016e+02 8.6540000915527344e+01 -2.0662799072265625e+02 -1.1599800109863281e+02 8.5603996276855469e+01 -2.0674000549316406e+02 -1.1170600128173828e+02 8.4216201782226562e+01 -1.9950599670410156e+02 -1.0458800506591797e+02 8.6630699157714844e+01 -1.9240798950195312e+02 -9.9444900512695312e+01 8.6150993347167969e+01 -1.9685000610351562e+02 -9.9715705871582031e+01 8.4519294738769531e+01 -1.8631399536132812e+02 -9.7712699890136719e+01 8.4631103515625000e+01 -1.9137799072265625e+02 -9.7789299011230469e+01 8.3553794860839844e+01 -1.8423300170898438e+02 -1.0067099761962891e+02 8.6634704589843750e+01 -1.7551100158691406e+02 -1.0588899993896484e+02 8.6631500244140625e+01 -1.7173400878906250e+02 -1.1031199645996094e+02 8.6367897033691406e+01 -1.7204299926757812e+02 -1.2206400299072266e+02 8.6650199890136719e+01 -1.7285800170898438e+02 -1.2899301147460938e+02 8.4991600036621094e+01 -1.7077299499511719e+02 -1.2588899993896484e+02 8.4588500976562500e+01 -1.7903100585937500e+02 -1.3128500366210938e+02 8.6624900817871094e+01 -1.8656698608398438e+02 -1.3497399902343750e+02 8.6154403686523438e+01 -1.7862400817871094e+02 -1.3405198669433594e+02 8.4660003662109375e+01 -1.9262899780273438e+02 -1.3297801208496094e+02 8.6646804809570312e+01 -1.8356500244140625e+02 -1.3597300720214844e+02 8.3793403625488281e+01 -1.9157699584960938e+02 -1.3622200012207031e+02 8.4273895263671875e+01 -1.9783000183105469e+02 -1.3100599670410156e+02 8.6611701965332031e+01 -1.9699501037597656e+02 -1.3412899780273438e+02 8.4592605590820312e+01 -2.0311898803710938e+02 -1.2926701354980469e+02 8.4162300109863281e+01 -2.0397700500488281e+02 -1.2623299407958984e+02 8.5788505554199219e+01 -2.0652299499511719e+02 -1.2307400512695312e+02 8.4527999877929688e+01 -2.0749800109863281e+02 -1.1759299468994141e+02 8.1035102844238281e+01 -2.0291900634765625e+02 -1.0426699829101562e+02 8.4310195922851562e+01 -1.6908200073242188e+02 -1.1200699615478516e+02 8.4361701965332031e+01 -1.6956199645996094e+02 -1.1864299774169922e+02 8.5708099365234375e+01 -1.6876499938964844e+02 -1.2088099670410156e+02 8.1116104125976562e+01 -2.0226100158691406e+02 -1.3038499450683594e+02 8.1035102844238281e+01 -1.9778799438476562e+02 -9.9956901550292969e+01 8.1028701782226562e+01 -1.8957600402832031e+02 -9.7537597656250000e+01 8.1030395507812500e+01 -2.0260499572753906e+02 -1.0414600372314453e+02 8.1030693054199219e+01 -2.0619200134277344e+02 -1.0964699554443359e+02 8.1032997131347656e+01 -2.0607598876953125e+02 -1.2439800262451172e+02 8.1031097412109375e+01 -1.9590100097656250e+02 -1.3499000549316406e+02 8.1032798767089844e+01 -1.8781599426269531e+02 -1.3653401184082031e+02 8.1031600952148438e+01 -1.7988899230957031e+02 -1.3486399841308594e+02 8.1031394958496094e+01 -1.7239601135253906e+02 -1.2893899536132812e+02 8.1033699035644531e+01 -1.6864599609375000e+02 -1.1435700225830078e+02 8.1031394958496094e+01 -1.7060501098632812e+02 -1.0816899871826172e+02 8.1029197692871094e+01 -1.8141398620605469e+02 -9.8514900207519531e+01 8.1028198242187500e+01 -1.7770401000976562e+02 -1.2170999908447266e+02 8.4860305786132812e+01 -1.8792900085449219e+02 -1.2847700500488281e+02 8.4854293823242188e+01 -1.9396499633789062e+02 -1.0782299804687500e+02 8.4889801025390625e+01 -1.9896299743652344e+02 -1.1552899932861328e+02 8.4853698730468750e+01 -1.7866200256347656e+02 -1.1039099884033203e+02 8.4860694885253906e+01 -1.8691299438476562e+02 -1.0604900360107422e+02 8.4858596801757812e+01 -2.0861299133300781e+02 -1.1276100158691406e+02 8.1031303405761719e+01 -2.0624800109863281e+02 -1.0652200317382812e+02 8.1031394958496094e+01 -2.0205000305175781e+02 -1.0130000305175781e+02 8.1031303405761719e+01 -1.9608599853515625e+02 -9.7553001403808594e+01 8.1031501770019531e+01 -1.8963000488281250e+02 -9.6028099060058594e+01 8.1029495239257812e+01 -1.8463400268554688e+02 -9.6286605834960938e+01 8.1030693054199219e+01 -1.7802600097656250e+02 -9.8344200134277344e+01 8.1027595520019531e+01 -1.7159100341796875e+02 -1.0379999542236328e+02 8.1031204223632812e+01 -1.6850799560546875e+02 -1.0884100341796875e+02 8.1104400634765625e+01 -1.6684600830078125e+02 -1.1771900177001953e+02 8.1031303405761719e+01 -1.6966299438476562e+02 -1.2761899566650391e+02 8.1029800415039062e+01 -1.7556799316406250e+02 -1.3398901367187500e+02 8.1028900146484375e+01 -1.8136500549316406e+02 -1.3697099304199219e+02 8.1031303405761719e+01 -1.8794999694824219e+02 -1.3804200744628906e+02 8.1031394958496094e+01 -1.9476600646972656e+02 -1.3706498718261719e+02 8.1170295715332031e+01 -1.9945100402832031e+02 -1.3482699584960938e+02 8.1030693054199219e+01 -2.0534298706054688e+02 -1.2890299987792969e+02 8.1029495239257812e+01 -2.0879399108886719e+02 -1.2103799438476562e+02 8.1028900146484375e+01 -1.9755000305175781e+02 -1.2309099578857422e+02 8.5212295532226562e+01 -1.8044200134277344e+02 -1.2751400756835938e+02 8.7263000488281250e+01 -1.9937899780273438e+02 -1.1049199676513672e+02 8.7190498352050781e+01 -1.8255000305175781e+02 -9.6725204467773438e+01 8.4087799072265625e+01 -1.8940899658203125e+02 -9.5941398620605469e+01 8.3571502685546875e+01 -1.7749400329589844e+02 -9.8781402587890625e+01 8.3845504760742188e+01 -1.7200900268554688e+02 -1.0325700378417969e+02 8.3662101745605469e+01 -1.6737100219726562e+02 -1.1381500244140625e+02 8.5209693908691406e+01 -1.6776399230957031e+02 -1.2272799682617188e+02 8.4771301269531250e+01 -1.7246800231933594e+02 -1.3113400268554688e+02 8.4827804565429688e+01 -1.7775900268554688e+02 -1.3527000427246094e+02 8.4697593688964844e+01 -1.8352200317382812e+02 -1.3740600585937500e+02 8.5051795959472656e+01 -1.8923500061035156e+02 -1.3791600036621094e+02 8.4700401306152344e+01 -2.0033599853515625e+02 -1.3411499023437500e+02 8.3607299804687500e+01 -2.0407398986816406e+02 -1.3036199951171875e+02 8.4855895996093750e+01 -2.0803601074218750e+02 -1.2348799896240234e+02 8.4490905761718750e+01 -2.0872799682617188e+02 -1.1453800201416016e+02 8.5165496826171875e+01 -2.0643099975585938e+02 -1.0672100067138672e+02 8.3991294860839844e+01 -2.0114801025390625e+02 -1.0071600341796875e+02 8.4940200805664062e+01 -1.9553900146484375e+02 -9.7558601379394531e+01 8.5069404602050781e+01 -2.0377099609375000e+02 -1.1165799713134766e+02 8.8251502990722656e+01 -2.0072900390625000e+02 -1.2144699859619141e+02 8.7341300964355469e+01 -1.9799000549316406e+02 -1.0501499938964844e+02 8.8162399291992188e+01 -1.8704699707031250e+02 -9.7032302856445312e+01 8.6541801452636719e+01 -1.9471701049804688e+02 -1.0014800262451172e+02 8.7925300598144531e+01 -1.8833999633789062e+02 -1.0339599609375000e+02 8.7701698303222656e+01 -1.7917199707031250e+02 -9.9454002380371094e+01 8.6822998046875000e+01 -1.8474600219726562e+02 -1.0067900085449219e+02 8.8153495788574219e+01 -1.7639300537109375e+02 -1.0488300323486328e+02 8.8218002319335938e+01 -1.8145401000976562e+02 -1.0575900268554688e+02 8.7271499633789062e+01 -1.7459799194335938e+02 -1.0209199523925781e+02 8.6296295166015625e+01 -1.7580300903320312e+02 -1.1231700134277344e+02 8.7151901245117188e+01 -1.7102200317382812e+02 -1.0705599975585938e+02 8.6755294799804688e+01 -1.6947300720214844e+02 -1.2041600036621094e+02 8.7365203857421875e+01 -1.7085299682617188e+02 -1.1209500122070312e+02 8.7869102478027344e+01 -1.7213999938964844e+02 -1.2004100036621094e+02 8.8219299316406250e+01 -1.7588099670410156e+02 -1.2169599914550781e+02 8.7201499938964844e+01 -1.7273199462890625e+02 -1.2674400329589844e+02 8.7798202514648438e+01 -1.7925000000000000e+02 -1.3018099975585938e+02 8.8170600891113281e+01 -1.7629400634765625e+02 -1.3134899902343750e+02 8.7598197937011719e+01 -1.8240701293945312e+02 -1.3372500610351562e+02 8.8065200805664062e+01 -1.8690000915527344e+02 -1.3043800354003906e+02 8.7615806579589844e+01 -1.9716200256347656e+02 -1.3507400512695312e+02 8.6028297424316406e+01 -1.8980099487304688e+02 -1.3532600402832031e+02 8.7687995910644531e+01 -1.9598999023437500e+02 -1.3211900329589844e+02 8.8174201965332031e+01 -1.9436299133300781e+02 -1.2896199035644531e+02 8.7678001403808594e+01 -2.0252999877929688e+02 -1.2922700500488281e+02 8.7315902709960938e+01 -2.0696600341796875e+02 -1.1959799957275391e+02 8.7347297668457031e+01 -2.0242900085449219e+02 -1.2535199737548828e+02 8.8252296447753906e+01 -2.0599000549316406e+02 -1.0830500030517578e+02 8.6323295593261719e+01 -2.0196699523925781e+02 -1.0526999664306641e+02 8.7731399536132812e+01 -1.9504299926757812e+02 -1.1511799621582031e+02 8.3278594970703125e+01 -1.9491699218750000e+02 -1.0890399932861328e+02 8.3252700805664062e+01 -1.9966700744628906e+02 -1.1454100036621094e+02 8.2683097839355469e+01 -1.9491499328613281e+02 -1.1958300018310547e+02 8.3278800964355469e+01 -1.9876399230957031e+02 -1.2217199707031250e+02 8.2702697753906250e+01 -1.9333200073242188e+02 -1.2713800048828125e+02 8.3144096374511719e+01 -1.8048399353027344e+02 -1.0786000061035156e+02 8.2689300537109375e+01 -1.8619898986816406e+02 -1.0578900146484375e+02 8.3201698303222656e+01 -1.7652999877929688e+02 -1.1636399841308594e+02 8.3190002441406250e+01 -1.7977999877929688e+02 -1.2499099731445312e+02 8.3180099487304688e+01 -1.7513600158691406e+02 -1.2125299835205078e+02 7.9944404602050781e+01 -1.7671299743652344e+02 -1.0948000335693359e+02 7.9887893676757812e+01 -1.9322698974609375e+02 -1.0609199523925781e+02 8.2449501037597656e+01 -1.9895201110839844e+02 -1.0888800048828125e+02 7.9784996032714844e+01 -1.8203500366210938e+02 -1.2918699645996094e+02 7.9597694396972656e+01 -1.8663301086425781e+02 -1.2840600585937500e+02 8.3168098449707031e+01 -1.8786099243164062e+02 -1.3063200378417969e+02 7.9614601135253906e+01 -1.7769299316406250e+02 -1.2584799194335938e+02 7.9572998046875000e+01 -1.7449499511718750e+02 -1.1517600250244141e+02 7.9597000122070312e+01 -1.8146400451660156e+02 -1.0502400207519531e+02 7.9558403015136719e+01 -1.8755300903320312e+02 -1.0344900512695312e+02 7.9626296997070312e+01 -1.9347499084472656e+02 -1.0452099609375000e+02 7.9580902099609375e+01 -2.0131900024414062e+02 -1.1438099670410156e+02 7.9596496582031250e+01 -2.0129800415039062e+02 -1.1965599822998047e+02 7.9195701599121094e+01 -1.9928300476074219e+02 -1.2457700347900391e+02 7.9580101013183594e+01 -1.9466899108886719e+02 -1.2888400268554688e+02 7.9558601379394531e+01 -1.8416600036621094e+02 -1.2330800628662109e+02 8.3273902893066406e+01 -1.9187300109863281e+02 -1.1056599426269531e+02 8.3273902893066406e+01 -1.8057400512695312e+02 -1.1811699676513672e+02 8.3273902893066406e+01 -1.9048899841308594e+02 -1.2408499908447266e+02 8.3273902893066406e+01 -1.8656300354003906e+02 -1.0985299682617188e+02 8.3273902893066406e+01 -1.8252200317382812e+02 -1.1205200195312500e+02 8.3273902893066406e+01 -1.8695700073242188e+02 -1.0956300354003906e+02 8.0995498657226562e+01 -1.9295500183105469e+02 -1.1152899932861328e+02 8.0995498657226562e+01 -1.9535699462890625e+02 -1.1640399932861328e+02 8.0995498657226562e+01 -1.9377101135253906e+02 -1.2160199737548828e+02 8.0995498657226562e+01 -1.8905700683593750e+02 -1.2430500030517578e+02 8.0995498657226562e+01 -1.8376899719238281e+02 -1.2304899597167969e+02 8.0995498657226562e+01 -1.8077500915527344e+02 -1.1851300048828125e+02 8.0995498657226562e+01 -1.8169799804687500e+02 -1.1315800476074219e+02 8.0995498657226562e+01 -1.7433799743652344e+02 -1.1862100219726562e+02 7.4263999938964844e+01 -1.7541799926757812e+02 -1.1181599426269531e+02 7.4327400207519531e+01 -1.7760400390625000e+02 -1.0829100036621094e+02 7.4287597656250000e+01 -1.8082901000976562e+02 -1.0545600128173828e+02 7.4499198913574219e+01 -1.8623001098632812e+02 -1.0347100067138672e+02 7.4312393188476562e+01 -1.7672300720214844e+02 -1.2463600158691406e+02 7.4328498840332031e+01 -1.8806399536132812e+02 -1.3062300109863281e+02 7.3837699890136719e+01 -1.8370700073242188e+02 -1.2987500000000000e+02 7.4312599182128906e+01 -1.8014599609375000e+02 -1.2812699890136719e+02 7.4649902343750000e+01 -1.9876199340820312e+02 -1.2559500122070312e+02 7.3852394104003906e+01 -1.9263200378417969e+02 -1.2989999389648438e+02 7.3871299743652344e+01 -1.9279499816894531e+02 -1.0419700622558594e+02 7.4290794372558594e+01 -1.9878900146484375e+02 -1.0849100494384766e+02 7.4297195434570312e+01 -2.0150401306152344e+02 -1.1515499877929688e+02 7.4405700683593750e+01 -1.8962899780273438e+02 -1.2667900085449219e+02 8.0994895935058594e+01 -1.9672499084472656e+02 -1.2250500488281250e+02 8.0958206176757812e+01 -1.7819400024414062e+02 -1.1364299774169922e+02 8.0950401306152344e+01 -1.9002600097656250e+02 -1.0664700317382812e+02 8.0960403442382812e+01 -1.8230599975585938e+02 -1.0843999481201172e+02 8.0957099914550781e+01 -1.7978399658203125e+02 -1.2298500061035156e+02 8.0981407165527344e+01 -1.9666198730468750e+02 -1.1152700042724609e+02 8.0960304260253906e+01 -1.8446501159667969e+02 -1.3337400817871094e+02 7.3618003845214844e+01 -1.7933799743652344e+02 -1.3133799743652344e+02 7.3618598937988281e+01 -1.7955200195312500e+02 -1.0243399810791016e+02 7.3602500915527344e+01 -1.8602700805664062e+02 -1.0036499786376953e+02 7.3618202209472656e+01 -1.7442601013183594e+02 -1.0718299865722656e+02 7.3618400573730469e+01 -1.7197399902343750e+02 -1.1212400054931641e+02 7.3618598937988281e+01 -1.7126100158691406e+02 -1.1888100433349609e+02 7.3617698669433594e+01 -1.7417300415039062e+02 -1.2662099456787109e+02 7.3617195129394531e+01 -1.9125599670410156e+02 -1.3352699279785156e+02 7.3618896484375000e+01 -2.0402699279785156e+02 -1.2187500000000000e+02 7.3618003845214844e+01 -2.0466400146484375e+02 -1.1376399993896484e+02 7.3617797851562500e+01 -2.0005400085449219e+02 -1.0523399353027344e+02 7.3617599487304688e+01 -1.9300199890136719e+02 -1.0091500091552734e+02 7.3617599487304688e+01 -1.7806201171875000e+02 -1.1988600158691406e+02 8.0705001831054688e+01 -1.8371499633789062e+02 -1.2667299652099609e+02 8.0626396179199219e+01 -1.9978498840332031e+02 -1.1726800537109375e+02 7.8686599731445312e+01 -1.9162699890136719e+02 -1.2828298950195312e+02 7.8608001708984375e+01 -1.9765299987792969e+02 -1.3069100952148438e+02 7.3621902465820312e+01 -2.0157499694824219e+02 -1.2681500244140625e+02 7.3621902465820312e+01 -1.8557099914550781e+02 -1.2857901000976562e+02 7.8161705017089844e+01 -1.8057099914550781e+02 -1.2626400756835938e+02 7.8212402343750000e+01 -1.7711799621582031e+02 -1.2159700012207031e+02 7.8173599243164062e+01 -1.7618200683593750e+02 -1.1619499969482422e+02 7.8115203857421875e+01 -1.7811700439453125e+02 -1.1053600311279297e+02 7.8200302124023438e+01 -1.8211399841308594e+02 -1.0667300415039062e+02 7.8205902099609375e+01 -1.8785000610351562e+02 -1.0518900299072266e+02 7.8199897766113281e+01 -1.9331399536132812e+02 -1.0637400054931641e+02 7.8182197570800781e+01 -1.9816400146484375e+02 -1.1091600036621094e+02 7.8166900634765625e+01 -1.9752700805664062e+02 -1.2425799560546875e+02 7.8221900939941406e+01 -1.9094300842285156e+02 -1.0028099822998047e+02 7.1338806152343750e+01 -1.8284599304199219e+02 -1.0106100463867188e+02 7.1338897705078125e+01 -1.7794799804687500e+02 -1.0359899902343750e+02 7.1343498229980469e+01 -1.7411399841308594e+02 -1.0762999725341797e+02 7.1342300415039062e+01 -1.7109500122070312e+02 -1.1544599914550781e+02 7.1341400146484375e+01 -1.7309199523925781e+02 -1.2484300231933594e+02 7.1338806152343750e+01 -1.7747700500488281e+02 -1.3003399658203125e+02 7.1339195251464844e+01 -1.8227999877929688e+02 -1.3274499511718750e+02 7.1339698791503906e+01 -1.8770100402832031e+02 -1.3374899291992188e+02 7.1343498229980469e+01 -1.9458599853515625e+02 -1.3250399780273438e+02 7.1338493347167969e+01 -2.0212799072265625e+02 -1.2641100311279297e+02 7.1339195251464844e+01 -2.0466700744628906e+02 -1.1868099975585938e+02 7.1343498229980469e+01 -2.0430999755859375e+02 -1.1317900085449219e+02 7.1338493347167969e+01 -2.0218600463867188e+02 -1.0808899688720703e+02 7.1343498229980469e+01 -1.9852200317382812e+02 -1.0396499633789062e+02 7.1339698791503906e+01 -2.0232800292968750e+02 -1.1881099700927734e+02 7.1363700866699219e+01 -1.9973100280761719e+02 -1.1019499969482422e+02 7.1608497619628906e+01 -1.8374499511718750e+02 -1.3045799255371094e+02 7.1421493530273438e+01 -1.9377299499511719e+02 -1.2743599700927734e+02 7.3594299316406250e+01 -1.9798800659179688e+02 -1.2330199432373047e+02 7.3865303039550781e+01 -1.8701800537109375e+02 -1.0506500244140625e+02 7.3471504211425781e+01 -1.9373300170898438e+02 -1.0647399902343750e+02 7.2591606140136719e+01 -1.9783499145507812e+02 -1.1035999298095703e+02 7.3789199829101562e+01 -2.0001600646972656e+02 -1.1730400085449219e+02 7.3279998779296875e+01 -1.8634700012207031e+02 -1.2889100646972656e+02 7.3472999572753906e+01 -1.7693099975585938e+02 -1.2123899841308594e+02 7.3164794921875000e+01 -1.7980000305175781e+02 -1.2562799072265625e+02 7.3344604492187500e+01 -1.8038700866699219e+02 -1.0782399749755859e+02 7.4001602172851562e+01 -1.7682200622558594e+02 -1.1299499511718750e+02 7.3200599670410156e+01 -1.8622900390625000e+02 -1.0344299316406250e+02 7.1667900085449219e+01 -1.7942500305175781e+02 -1.0724800109863281e+02 7.1917304992675781e+01 -1.7488999938964844e+02 -1.1564300537109375e+02 7.1985801696777344e+01 -1.7723800659179688e+02 -1.2548099517822266e+02 7.1602302551269531e+01 -1.9303199768066406e+02 -1.2947499084472656e+02 7.1805496215820312e+01 -1.9890499877929688e+02 -1.2454699707031250e+02 7.1767700195312500e+01 -1.8446000671386719e+02 -1.3325299072265625e+02 8.1800605773925781e+01 -1.9059500122070312e+02 -1.3162199401855469e+02 8.0464401245117188e+01 -1.8879400634765625e+02 -1.3085398864746094e+02 8.6959304809570312e+01 -1.8752400207519531e+02 -1.3698899841308594e+02 8.4457199096679688e+01 -2.3464700317382812e+02 -1.1586699676513672e+02 2.7176599502563477e+01 -2.3507099914550781e+02 -1.1585600280761719e+02 3.1744598388671875e+01 -2.3597300720214844e+02 -1.2845500183105469e+02 3.0339698791503906e+01 -2.3464900207519531e+02 -1.1586699676513672e+02 3.6312801361083984e+01 -2.3589801025390625e+02 -1.2794299316406250e+02 3.3703598022460938e+01 -2.3321899414062500e+02 -1.2800799560546875e+02 4.3272598266601562e+01 -2.3499000549316406e+02 -1.2809500122070312e+02 3.8596202850341797e+01 -2.3339498901367188e+02 -1.1589500427246094e+02 4.0724998474121094e+01 -2.3135200500488281e+02 -1.1594699859619141e+02 4.4832599639892578e+01 -2.3162800598144531e+02 -1.2873600769042969e+02 4.6078903198242188e+01 -2.2858900451660156e+02 -1.1601399993896484e+02 4.8494300842285156e+01 -2.2950599670410156e+02 -1.2860800170898438e+02 4.8764099121093750e+01 -2.2519999694824219e+02 -1.1609600067138672e+02 5.1585700988769531e+01 -2.2708200073242188e+02 -1.2815699768066406e+02 5.1087299346923828e+01 -2.2130101013183594e+02 -1.1619100189208984e+02 5.4001598358154297e+01 -2.2442500305175781e+02 -1.2854400634765625e+02 5.3105800628662109e+01 -2.1519599914550781e+02 -1.2844599914550781e+02 5.6783798217773438e+01 -2.1845700073242188e+02 -1.2862699890136719e+02 5.5962699890136719e+01 -2.1702499389648438e+02 -1.1629500579833984e+02 5.5659801483154297e+01 -2.2151400756835938e+02 -1.2829199218750000e+02 5.4718200683593750e+01 -2.1251699829101562e+02 -1.1640399932861328e+02 5.6503696441650391e+01 -2.1186099243164062e+02 -1.2904598999023438e+02 5.7194698333740234e+01 -2.0793099975585938e+02 -1.1651599884033203e+02 5.6504699707031250e+01 -2.0342199707031250e+02 -1.1662500000000000e+02 5.5662700653076172e+01 -2.0527899169921875e+02 -1.2912699890136719e+02 5.6695598602294922e+01 -1.9914500427246094e+02 -1.1672899627685547e+02 5.4006401062011719e+01 -2.0204399108886719e+02 -1.2908799743652344e+02 5.5783802032470703e+01 -1.9524600219726562e+02 -1.1682399749755859e+02 5.1592201232910156e+01 -1.9613600158691406e+02 -1.2902299499511719e+02 5.2775600433349609e+01 -1.9898100280761719e+02 -1.2933200073242188e+02 5.4478897094726562e+01 -1.9351300048828125e+02 -1.2921099853515625e+02 5.0722202301025391e+01 -1.9185600280761719e+02 -1.1690600585937500e+02 4.8502201080322266e+01 -1.8909100341796875e+02 -1.1697400665283203e+02 4.4841800689697266e+01 -1.8935600280761719e+02 -1.2959399414062500e+02 4.5935298919677734e+01 -1.8696699523925781e+02 -1.1702399444580078e+02 4.0558300018310547e+01 -1.8752600097656250e+02 -1.2975401306152344e+02 4.2749401092529297e+01 -1.8536500549316406e+02 -1.1706399536132812e+02 3.1755298614501953e+01 -1.8508900451660156e+02 -1.2917700195312500e+02 3.3127502441406250e+01 -1.8579000854492188e+02 -1.1705400085449219e+02 3.6323303222656250e+01 -1.8547299194335938e+02 -1.2968899536132812e+02 3.6439800262451172e+01 -1.8578800964355469e+02 -1.1705400085449219e+02 2.7187200546264648e+01 -1.8510598754882812e+02 -1.2979400634765625e+02 2.9814399719238281e+01 -1.8704199218750000e+02 -1.1702299499511719e+02 2.2774400711059570e+01 -1.8648500061035156e+02 -1.2940299987792969e+02 2.3301898956298828e+01 -1.8559899902343750e+02 -1.2916499328613281e+02 2.6498600006103516e+01 -1.8780000305175781e+02 -1.2935499572753906e+02 2.0221500396728516e+01 -1.8908500671386719e+02 -1.1697400665283203e+02 1.8667299270629883e+01 -1.8952499389648438e+02 -1.2959001159667969e+02 1.7301300048828125e+01 -1.9184799194335938e+02 -1.1690699768066406e+02 1.5005599975585938e+01 -1.9156100463867188e+02 -1.2902000427246094e+02 1.4741499900817871e+01 -1.9523699951171875e+02 -1.1682399749755859e+02 1.1914199829101562e+01 -1.9393501281738281e+02 -1.2920199584960938e+02 1.2408100128173828e+01 -1.9913600158691406e+02 -1.1672899627685547e+02 9.4983596801757812e+00 -1.9660800170898438e+02 -1.2914900207519531e+02 1.0402400016784668e+01 -2.0582899475097656e+02 -1.2867300415039062e+02 6.7161297798156738e+00 -2.0258699035644531e+02 -1.2895600891113281e+02 7.5374197959899902e+00 -2.0341200256347656e+02 -1.1662599945068359e+02 7.8401603698730469e+00 -1.9953500366210938e+02 -1.2936000061035156e+02 8.7465000152587891e+00 -2.0791999816894531e+02 -1.1651599884033203e+02 6.9962100982666016e+00 -2.1250599670410156e+02 -1.1640500640869141e+02 6.9952001571655273e+00 -2.1246301269531250e+02 -1.2895298767089844e+02 6.3328700065612793e+00 -2.0916600036621094e+02 -1.2885501098632812e+02 6.3041996955871582e+00 -2.1701499938964844e+02 -1.1629500579833984e+02 7.8372302055358887e+00 -2.1575898742675781e+02 -1.2893099975585938e+02 6.7986798286437988e+00 -2.2129200744628906e+02 -1.1619100189208984e+02 9.4935302734375000e+00 -2.1896900939941406e+02 -1.2835400390625000e+02 7.7274398803710938e+00 -2.2519099426269531e+02 -1.1609600067138672e+02 1.1907799720764160e+01 -2.2489399719238281e+02 -1.2832499694824219e+02 1.0724299430847168e+01 -2.2206500244140625e+02 -1.2871701049804688e+02 9.0236091613769531e+00 -2.2753100585937500e+02 -1.2838800048828125e+02 1.2783800125122070e+01 -2.2858099365234375e+02 -1.1601399993896484e+02 1.4997700691223145e+01 -2.2999299621582031e+02 -1.2861999511718750e+02 1.5306699752807617e+01 -2.3134599304199219e+02 -1.1594699859619141e+02 1.8658201217651367e+01 -2.3339100646972656e+02 -1.1589700317382812e+02 2.2764400482177734e+01 -2.3349699401855469e+02 -1.2833898925781250e+02 2.0735700607299805e+01 -2.3555799865722656e+02 -1.2821200561523438e+02 2.7062299728393555e+01 -2.3476100158691406e+02 -1.2849200439453125e+02 2.3859300613403320e+01 -1.8692800903320312e+02 -1.0435500335693359e+02 4.2779598236083984e+01 -1.9056600952148438e+02 -1.0457199859619141e+02 4.8320400238037109e+01 -1.8858599853515625e+02 -1.0462799835205078e+02 4.5676700592041016e+01 -1.9292100524902344e+02 -1.0477400207519531e+02 5.0706600189208984e+01 -1.9553099060058594e+02 -1.0405399322509766e+02 5.2813198089599609e+01 -1.9840499877929688e+02 -1.0464099884033203e+02 5.4462898254394531e+01 -2.0141500854492188e+02 -1.0406000518798828e+02 5.5786098480224609e+01 -2.0467500305175781e+02 -1.0448799896240234e+02 5.6671199798583984e+01 -2.1129000854492188e+02 -1.0421299743652344e+02 5.7187500000000000e+01 -2.0798300170898438e+02 -1.0388500213623047e+02 5.7171798706054688e+01 -2.1460800170898438e+02 -1.0424699401855469e+02 5.6783798217773438e+01 -2.2092599487304688e+02 -1.0409300231933594e+02 5.4718200683593750e+01 -2.1785700988769531e+02 -1.0390499877929688e+02 5.5962699890136719e+01 -2.2381600952148438e+02 -1.0347499847412109e+02 5.3118602752685547e+01 -2.2649400329589844e+02 -1.0395800018310547e+02 5.1087299346923828e+01 -2.3264401245117188e+02 -1.0328099822998047e+02 4.3281200408935547e+01 -2.3092199707031250e+02 -1.0359100341796875e+02 4.6169002532958984e+01 -2.2888400268554688e+02 -1.0365200042724609e+02 4.8761901855468750e+01 -2.3484199523925781e+02 -1.0340800476074219e+02 3.7029098510742188e+01 -2.3532299804687500e+02 -1.0321900177001953e+02 3.3731800079345703e+01 -2.3534800720214844e+02 -1.0374300384521484e+02 3.0372400283813477e+01 -2.3412500000000000e+02 -1.0377299499511719e+02 2.3837299346923828e+01 -2.3495700073242188e+02 -1.0349199676513672e+02 2.7062500000000000e+01 -2.3289500427246094e+02 -1.0327400207519531e+02 2.0727500915527344e+01 -2.2693200683593750e+02 -1.0371000671386719e+02 1.2785099983215332e+01 -2.3026399230957031e+02 -1.0373600006103516e+02 1.6513299942016602e+01 -2.2144400024414062e+02 -1.0408099365234375e+02 9.0371398925781250e+00 -2.2425599670410156e+02 -1.0348200225830078e+02 1.0676099777221680e+01 -2.1840800476074219e+02 -1.0370399475097656e+02 7.7159399986267090e+00 -2.1517401123046875e+02 -1.0423299407958984e+02 6.8287796974182129e+00 -2.0856800842285156e+02 -1.0390000152587891e+02 6.2915101051330566e+00 -2.1184800720214844e+02 -1.0386499786376953e+02 6.3322801589965820e+00 -2.0524099731445312e+02 -1.0447499847412109e+02 6.7161297798156738e+00 -2.0198400878906250e+02 -1.0429300689697266e+02 7.5355801582336426e+00 -1.9892300415039062e+02 -1.0462799835205078e+02 8.7817897796630859e+00 -1.9600900268554688e+02 -1.0423600006103516e+02 1.0386300086975098e+01 -1.9333801269531250e+02 -1.0451599884033203e+02 1.2404399871826172e+01 -1.8890998840332031e+02 -1.0434999847412109e+02 1.7304201126098633e+01 -1.9097299194335938e+02 -1.0482099914550781e+02 1.4741499900817871e+01 -1.8721800231933594e+02 -1.0491199493408203e+02 2.0227399826049805e+01 -1.8501100158691406e+02 -1.0496600341796875e+02 2.6498600006103516e+01 -1.8585499572753906e+02 -1.0459899902343750e+02 2.3380001068115234e+01 -1.8449301147460938e+02 -1.0432199859619141e+02 2.9716100692749023e+01 -1.8487899780273438e+02 -1.0470899963378906e+02 3.6437702178955078e+01 -1.8450100708007812e+02 -1.0497800445556641e+02 3.3127502441406250e+01 -2.1615100097656250e+02 -1.2849200439453125e+02 4.0546102523803711e+00 -2.0455999755859375e+02 -1.2917298889160156e+02 5.8737998008728027e+00 -2.0871199035644531e+02 -1.2905599975585938e+02 5.8303298950195312e+01 -1.9686900329589844e+02 -1.2927200317382812e+02 5.5327800750732422e+01 -2.1908200073242188e+02 -1.2867500305175781e+02 5.7951798439025879e+00 -1.8951399230957031e+02 -1.2939999389648438e+02 1.4288800239562988e+01 -1.8543699645996094e+02 -1.2952000427246094e+02 2.0928899765014648e+01 -2.3734899902343750e+02 -1.2836599731445312e+02 3.1287900924682617e+01 -2.2930101013183594e+02 -1.2856399536132812e+02 1.2783199310302734e+01 -2.2866000366210938e+02 -1.2823800659179688e+02 5.3299900054931641e+01 -2.1807600402832031e+02 -1.2883700561523438e+02 5.7237499237060547e+01 -2.3116500854492188e+02 -1.0339199829101562e+02 1.5736300468444824e+01 -1.9852900695800781e+02 -1.0418199920654297e+02 7.5899400711059570e+00 -1.8989799499511719e+02 -1.0438800048828125e+02 1.4250699996948242e+01 -2.3647700500488281e+02 -1.0340999603271484e+02 2.5151699066162109e+01 -2.3641900634765625e+02 -1.0326200103759766e+02 3.5023200988769531e+01 -1.8686399841308594e+02 -1.0445899963378906e+02 4.5194702148437500e+01 -2.3255300903320312e+02 -1.0348699951171875e+02 4.7062400817871094e+01 -2.2290701293945312e+02 -1.0358999633789062e+02 8.4097404479980469e+00 -2.1078399658203125e+02 -1.0386999511718750e+02 5.1063899993896484e+00 -2.1684700012207031e+02 -1.0373999786376953e+02 5.7558200836181641e+01 -2.0430599975585938e+02 -1.0404199981689453e+02 5.7864799499511719e+01 -1.8481098937988281e+02 -1.0472100067138672e+02 2.0555000305175781e+01 -2.4178601074218750e+02 -1.2279000091552734e+02 2.7111801147460938e+01 -2.4144400024414062e+02 -1.2505799865722656e+02 2.9052299499511719e+01 -2.4202400207519531e+02 -1.2275599670410156e+02 3.4340499877929688e+01 -1.7880700683593750e+02 -1.2426399993896484e+02 3.4937400817871094e+01 -1.7986900329589844e+02 -1.2356200408935547e+02 4.0323699951171875e+01 -1.8015399169921875e+02 -1.2565599060058594e+02 4.0303100585937500e+01 -1.8183399963378906e+02 -1.2420800018310547e+02 4.5610698699951172e+01 -1.8294000244140625e+02 -1.2944400024414062e+02 3.2680702209472656e+01 -1.9733900451660156e+02 -1.2883499145507812e+02 6.5306997299194336e+00 -2.3626600646972656e+02 -1.2786699676513672e+02 1.9781799316406250e+01 -1.8727799987792969e+02 -1.2905700683593750e+02 4.8086700439453125e+01 -2.1556500244140625e+02 -1.2811599731445312e+02 6.0164398193359375e+01 -2.0446499633789062e+02 -1.2847000122070312e+02 5.9788799285888672e+01 -1.9169400024414062e+02 -1.2869200134277344e+02 5.3532203674316406e+01 -1.8360699462890625e+02 -1.2897099304199219e+02 4.1721199035644531e+01 -1.8235301208496094e+02 -1.2891900634765625e+02 2.5788101196289062e+01 -2.0713600158691406e+02 -1.2832101440429688e+02 3.0854899883270264e+00 -2.2516700744628906e+02 -1.2787899017333984e+02 6.9828000068664551e+00 -2.3231799316406250e+02 -1.2779299926757812e+02 1.3130100250244141e+01 -2.3867001342773438e+02 -1.2755100250244141e+02 2.5854200363159180e+01 -2.3926599121093750e+02 -1.2753599548339844e+02 3.2636600494384766e+01 -2.3825399780273438e+02 -1.2756100463867188e+02 3.9369602203369141e+01 -2.3425000000000000e+02 -1.2772700500488281e+02 4.7901702880859375e+01 -2.2422898864746094e+02 -1.2798899078369141e+02 5.6934902191162109e+01 -2.0711599731445312e+02 -1.2664399719238281e+02 6.2257499694824219e+01 -1.9716400146484375e+02 -1.2810400390625000e+02 5.7917900085449219e+01 -1.8123500061035156e+02 -1.2803900146484375e+02 3.8443401336669922e+01 -1.7995899963378906e+02 -1.2747499084472656e+02 3.3155502319335938e+01 -1.8137899780273438e+02 -1.2744000244140625e+02 2.2441299438476562e+01 -1.8561999511718750e+02 -1.2838398742675781e+02 1.6146099090576172e+01 -1.9084100341796875e+02 -1.2750999450683594e+02 8.6036901473999023e+00 -2.2257299804687500e+02 -1.2626799774169922e+02 3.5505299568176270e+00 -2.2859999084472656e+02 -1.2629300689697266e+02 7.1665596961975098e+00 -2.3895399475097656e+02 -1.2604199218750000e+02 4.2766101837158203e+01 -2.1424600219726562e+02 -1.2596400451660156e+02 6.2475399017333984e+01 -1.9980200195312500e+02 -1.2631499481201172e+02 6.0818401336669922e+01 -1.9327400207519531e+02 -1.2647299194335938e+02 5.7502998352050781e+01 -1.8770700073242188e+02 -1.2660900115966797e+02 5.2746601104736328e+01 -1.8341299438476562e+02 -1.2671298980712891e+02 4.6815101623535156e+01 -1.7955300903320312e+02 -1.2664399719238281e+02 2.8805099487304688e+01 -1.8251199340820312e+02 -1.2657199859619141e+02 1.8228498458862305e+01 -1.8633300781250000e+02 -1.2664200592041016e+02 1.2348500251770020e+01 -1.9482899475097656e+02 -1.2627199554443359e+02 4.9241800308227539e+00 -2.0128298950195312e+02 -1.2627899932861328e+02 2.1805801391601562e+00 -2.0662799072265625e+02 -1.2614299011230469e+02 1.0791399478912354e+00 -2.1214999389648438e+02 -1.2601499176025391e+02 8.3761799335479736e-01 -2.1767799377441406e+02 -1.2452100372314453e+02 8.5155397653579712e-01 -2.3219999694824219e+02 -1.2536400604248047e+02 9.6080303192138672e+00 -2.3655000305175781e+02 -1.2542199707031250e+02 1.5108900070190430e+01 -2.3972700500488281e+02 -1.2534500885009766e+02 2.1706399917602539e+01 -2.4108200073242188e+02 -1.2531200408935547e+02 3.6186901092529297e+01 -2.3567700195312500e+02 -1.2544299316406250e+02 4.9688201904296875e+01 -2.3209600830078125e+02 -1.2552400207519531e+02 5.3807899475097656e+01 -2.2785400390625000e+02 -1.2563300323486328e+02 5.7351600646972656e+01 -2.2135501098632812e+02 -1.2579100036621094e+02 6.0724098205566406e+01 -2.3920401000976562e+02 -1.2342400360107422e+02 4.5069099426269531e+01 -2.1226699829101562e+02 -1.2374400329589844e+02 6.3438602447509766e+01 -2.0500401306152344e+02 -1.2365200042724609e+02 6.3038803100585938e+01 -2.0133799743652344e+02 -1.2374900054931641e+02 6.2180599212646484e+01 -1.9780200195312500e+02 -1.2383000183105469e+02 6.0895397186279297e+01 -1.9446299743652344e+02 -1.2392500305175781e+02 5.9210697174072266e+01 -1.9131399536132812e+02 -1.2398100280761719e+02 5.7125301361083984e+01 -1.8796800231933594e+02 -1.2438400268554688e+02 5.4172000885009766e+01 -1.8367601013183594e+02 -1.2416899871826172e+02 4.8894599914550781e+01 -1.7867300415039062e+02 -1.2456600189208984e+02 3.0889600753784180e+01 -1.7971199035644531e+02 -1.2426399993896484e+02 2.3606599807739258e+01 -1.8089199829101562e+02 -1.2424600219726562e+02 2.0028799057006836e+01 -1.8281799316406250e+02 -1.2443699645996094e+02 1.6046499252319336e+01 -1.8681600952148438e+02 -1.2409000396728516e+02 1.0490500450134277e+01 -1.8985598754882812e+02 -1.2432599639892578e+02 7.5736598968505859e+00 -1.9568899536132812e+02 -1.2387500000000000e+02 3.6118600368499756e+00 -1.9912500000000000e+02 -1.2380400085449219e+02 2.0675101280212402e+00 -2.0327799987792969e+02 -1.2394899749755859e+02 8.1694704294204712e-01 -2.1016000366210938e+02 -1.2353699493408203e+02 1.4264199417084455e-03 -2.1391999816894531e+02 -1.2343899536132812e+02 1.9762898981571198e-01 -2.2122200012207031e+02 -1.2327300262451172e+02 1.9071099758148193e+00 -2.2467898559570312e+02 -1.2316899871826172e+02 3.3997900485992432e+00 -2.2948298645019531e+02 -1.2344300079345703e+02 6.4398102760314941e+00 -2.3365199279785156e+02 -1.2295199584960938e+02 1.0149800300598145e+01 -2.3604800415039062e+02 -1.2291600036621094e+02 1.3060500144958496e+01 -2.3807600402832031e+02 -1.2285099792480469e+02 1.6224100112915039e+01 -2.3971299743652344e+02 -1.2282399749755859e+02 1.9599000930786133e+01 -2.4094699096679688e+02 -1.2278799438476562e+02 2.3161201477050781e+01 -2.4149499511718750e+02 -1.2276999664306641e+02 3.8068500518798828e+01 -2.4052500915527344e+02 -1.2261699676513672e+02 4.1714298248291016e+01 -2.3735099792480469e+02 -1.2287600708007812e+02 4.8504901885986328e+01 -2.3499000549316406e+02 -1.2318699645996094e+02 5.1810302734375000e+01 -2.2983200073242188e+02 -1.2303800201416016e+02 5.6845798492431641e+01 -2.2672300720214844e+02 -1.2314399719238281e+02 5.8973201751708984e+01 -2.2339099121093750e+02 -1.2320800018310547e+02 6.0713600158691406e+01 -2.1989099121093750e+02 -1.2330699920654297e+02 6.2042400360107422e+01 -2.1623001098632812e+02 -1.2338899993896484e+02 6.2957397460937500e+01 -1.8193299865722656e+02 -1.0511600494384766e+02 3.6614700317382812e+01 -2.2330300903320312e+02 -1.0375899505615234e+02 5.5733402252197266e+01 -1.8333099365234375e+02 -1.1005999755859375e+02 4.8891498565673828e+01 -1.8586199951171875e+02 -1.0779399871826172e+02 5.1413200378417969e+01 -1.8804200744628906e+02 -1.0993000030517578e+02 5.4625000000000000e+01 -2.3880200195312500e+02 -1.0868099975585938e+02 4.5190498352050781e+01 -2.3996600341796875e+02 -1.0644300079345703e+02 4.0271598815917969e+01 -2.4115100097656250e+02 -1.0864499664306641e+02 3.8070198059082031e+01 -2.4106800842285156e+02 -1.0629899597167969e+02 3.2110900878906250e+01 -2.4140599060058594e+02 -1.0862000274658203e+02 2.6859600067138672e+01 -2.4168099975585938e+02 -1.0863800048828125e+02 3.4342300415039062e+01 -2.1395300292968750e+02 -1.0676799774169922e+02 6.2453502655029297e+01 -2.1214100646972656e+02 -1.0933200073242188e+02 6.3429103851318359e+01 -2.0840699768066406e+02 -1.0826099395751953e+02 6.3448696136474609e+01 -2.0273600769042969e+02 -1.0636199951171875e+02 6.1430900573730469e+01 -2.0470300292968750e+02 -1.0893399810791016e+02 6.3041999816894531e+01 -2.0099400329589844e+02 -1.0963000488281250e+02 6.2180400848388672e+01 -1.9612899780273438e+02 -1.0720100402832031e+02 5.9432903289794922e+01 -1.9436399841308594e+02 -1.0951699829101562e+02 5.9349296569824219e+01 -1.9001600646972656e+02 -1.0734999847412109e+02 5.5402698516845703e+01 -1.9096800231933594e+02 -1.0985299682617188e+02 5.7123798370361328e+01 -1.8303201293945312e+02 -1.0751899719238281e+02 4.6967300415039062e+01 -1.8149000549316406e+02 -1.1009000396728516e+02 4.5609001159667969e+01 -1.7991400146484375e+02 -1.0948400115966797e+02 4.1679199218750000e+01 -1.7905999755859375e+02 -1.0761599731445312e+02 3.2976898193359375e+01 -1.7892999267578125e+02 -1.0963700103759766e+02 3.8171699523925781e+01 -1.7845300292968750e+02 -1.1015900421142578e+02 3.4796901702880859e+01 -1.7831500244140625e+02 -1.1015499877929688e+02 3.1028600692749023e+01 -1.7963699340820312e+02 -1.0760199737548828e+02 2.5676500320434570e+01 -1.7862200927734375e+02 -1.1016000366210938e+02 2.7290500640869141e+01 -1.7936801147460938e+02 -1.1012600708007812e+02 2.3607200622558594e+01 -1.8191200256347656e+02 -1.0754600524902344e+02 1.8715801239013672e+01 -1.8054998779296875e+02 -1.1011900329589844e+02 2.0026899337768555e+01 -1.8384901428222656e+02 -1.0977099609375000e+02 1.3829999923706055e+01 -1.8575799560546875e+02 -1.0745300292968750e+02 1.2484499931335449e+01 -1.8647399902343750e+02 -1.0996299743652344e+02 1.0488900184631348e+01 -1.9096000671386719e+02 -1.0732699584960938e+02 7.3311901092529297e+00 -1.8915901184082031e+02 -1.0989200592041016e+02 7.8452200889587402e+00 -1.9212500000000000e+02 -1.0983300018310547e+02 5.5463299751281738e+00 -1.9722599792480469e+02 -1.0717400360107422e+02 3.5442099571228027e+00 -1.9534500122070312e+02 -1.0973799896240234e+02 3.6118600368499756e+00 -1.9878399658203125e+02 -1.0967600250244141e+02 2.0667898654937744e+00 -2.0387500000000000e+02 -1.0717599487304688e+02 1.3145799636840820e+00 -2.0385398864746094e+02 -1.0914699554443359e+02 6.5558099746704102e-01 -2.0822100830078125e+02 -1.0622899627685547e+02 1.2499099969863892e+00 -2.0982000732421875e+02 -1.0941100311279297e+02 1.3950300635769963e-03 -2.1485200500488281e+02 -1.0690899658203125e+02 1.0896899700164795e+00 -2.1358000183105469e+02 -1.0931699371337891e+02 1.9819000363349915e-01 -2.2075698852539062e+02 -1.0886399841308594e+02 1.8690799474716187e+00 -2.2217799377441406e+02 -1.0656800079345703e+02 3.2945301532745361e+00 -2.2433799743652344e+02 -1.0904199981689453e+02 3.4010400772094727e+00 -2.2779199218750000e+02 -1.0834700012207031e+02 5.4597797393798828e+00 -2.2855000305175781e+02 -1.0573499298095703e+02 7.5043396949768066e+00 -2.3059199523925781e+02 -1.0889600372314453e+02 7.5491099357604980e+00 -2.3368299865722656e+02 -1.0645200347900391e+02 1.1700099945068359e+01 -2.3330999755859375e+02 -1.0882599639892578e+02 1.0151299476623535e+01 -2.3570401000976562e+02 -1.0877799987792969e+02 1.3059999465942383e+01 -2.3582699584960938e+02 -1.0555799865722656e+02 1.5493499755859375e+01 -2.3913099670410156e+02 -1.0838200378417969e+02 1.9115200042724609e+01 -2.3964199829101562e+02 -1.0579500579833984e+02 2.3271699905395508e+01 -2.4060400390625000e+02 -1.0865999603271484e+02 2.3163499832153320e+01 -2.3625401306152344e+02 -1.0587699890136719e+02 4.7921897888183594e+01 -2.3700599670410156e+02 -1.0874799346923828e+02 4.8506999969482422e+01 -2.3482400512695312e+02 -1.0877999877929688e+02 5.1590099334716797e+01 -2.3072599792480469e+02 -1.0652300262451172e+02 5.4846202850341797e+01 -2.3232099914550781e+02 -1.0885500335693359e+02 5.4368701934814453e+01 -2.2948800659179688e+02 -1.0891999816894531e+02 5.6846202850341797e+01 -2.2596600341796875e+02 -1.0549800109863281e+02 5.7541099548339844e+01 -2.2638099670410156e+02 -1.0900299835205078e+02 5.8972499847412109e+01 -2.2105200195312500e+02 -1.0659600067138672e+02 6.0662300109863281e+01 -2.2040699768066406e+02 -1.0881900024414062e+02 6.1718898773193359e+01 -2.1588400268554688e+02 -1.0926100158691406e+02 6.2957897186279297e+01 -1.8067100524902344e+02 -1.0694000244140625e+02 4.0072898864746094e+01 -2.1668200683593750e+02 -1.0548099517822266e+02 2.5572199821472168e+00 -2.0962100219726562e+02 -1.0462400054931641e+02 6.0470302581787109e+01 -2.0033299255371094e+02 -1.0491799926757812e+02 5.8885299682617188e+01 -1.9423001098632812e+02 -1.0506700134277344e+02 5.5870800018310547e+01 -1.8900500488281250e+02 -1.0519400024414062e+02 5.1506599426269531e+01 -1.8408399963378906e+02 -1.0530900573730469e+02 4.4575603485107422e+01 -1.8133099365234375e+02 -1.0537599945068359e+02 2.7943401336669922e+01 -1.8438200378417969e+02 -1.0539199829101562e+02 1.8044900894165039e+01 -1.8956999206542969e+02 -1.0518000030517578e+02 1.1411499977111816e+01 -1.9491600036621094e+02 -1.0504999542236328e+02 7.1963100433349609e+00 -2.0110099792480469e+02 -1.0490000152587891e+02 4.3549499511718750e+00 -2.1108900451660156e+02 -1.0449100494384766e+02 3.1797900199890137e+00 -2.2176300048828125e+02 -1.0430999755859375e+02 5.6232800483703613e+00 -2.2965299987792969e+02 -1.0420600128173828e+02 1.0788000106811523e+01 -2.3525099182128906e+02 -1.0398799896240234e+02 1.8261499404907227e+01 -2.3909899902343750e+02 -1.0413199615478516e+02 3.2192798614501953e+01 -2.3697000122070312e+02 -1.0394599914550781e+02 4.1333297729492188e+01 -2.3090599060058594e+02 -1.0410700225830078e+02 5.1364398956298828e+01 -2.1637399291992188e+02 -1.0444100189208984e+02 5.9699100494384766e+01 -2.1022099304199219e+02 -1.2824900817871094e+02 4.5350299835205078e+01 -2.1081500244140625e+02 -1.2932699584960938e+02 4.5350299835205078e+01 -2.0330799865722656e+02 -1.2950999450683594e+02 4.3400802612304688e+01 -2.0173199462890625e+02 -1.2845500183105469e+02 4.2459201812744141e+01 -1.9871400451660156e+02 -1.2962100219726562e+02 3.8146999359130859e+01 -1.9668699645996094e+02 -1.2857800292968750e+02 3.2547298431396484e+01 -1.9683000183105469e+02 -1.2966699218750000e+02 3.2073898315429688e+01 -1.9871400451660156e+02 -1.2962100219726562e+02 2.5352998733520508e+01 -1.9989100646972656e+02 -1.2850000000000000e+02 2.3076299667358398e+01 -2.0381001281738281e+02 -1.2949700927734375e+02 1.9923898696899414e+01 -2.0745500183105469e+02 -1.2831599426269531e+02 1.8384401321411133e+01 -2.1024798583984375e+02 -1.2934100341796875e+02 1.8149599075317383e+01 -2.1739498901367188e+02 -1.2807499694824219e+02 1.9742399215698242e+01 -2.1775401306152344e+02 -1.2915899658203125e+02 2.0099100112915039e+01 -2.2234800720214844e+02 -1.2904701232910156e+02 2.5352998733520508e+01 -2.2356900024414062e+02 -1.2792499542236328e+02 2.7606201171875000e+01 -2.2396800231933594e+02 -1.2900799560546875e+02 3.1750001907348633e+01 -2.2335800170898438e+02 -1.2793000030517578e+02 3.6506500244140625e+01 -2.2234800720214844e+02 -1.2904701232910156e+02 3.8146999359130859e+01 -2.1772700500488281e+02 -1.2806700134277344e+02 4.3400897979736328e+01 -2.1725199890136719e+02 -1.2917100524902344e+02 4.3576000213623047e+01 -2.0458500671386719e+02 -1.2947900390625000e+02 3.0146099090576172e+01 -2.0452099609375000e+02 -1.2948001098632812e+02 3.3094001770019531e+01 -2.1522801208496094e+02 -1.2922000122070312e+02 2.7766000747680664e+01 -2.1220800781250000e+02 -1.2929399108886719e+02 2.5747800827026367e+01 -2.1114100646972656e+02 -1.2931900024414062e+02 3.7880100250244141e+01 -2.1337500000000000e+02 -1.2926499938964844e+02 3.7169399261474609e+01 -2.1505099487304688e+02 -1.2922399902343750e+02 3.5934200286865234e+01 -2.0625799560546875e+02 -1.2943800354003906e+02 3.6285198211669922e+01 -2.0906700134277344e+02 -1.2937001037597656e+02 3.7692699432373047e+01 -2.0601100158691406e+02 -1.2944400024414062e+02 2.7565698623657227e+01 -2.0847299194335938e+02 -1.2938400268554688e+02 2.5943899154663086e+01 -2.1654100036621094e+02 -1.2918800354003906e+02 3.0405899047851562e+01 -2.1647700500488281e+02 -1.2919000244140625e+02 3.3353801727294922e+01 -2.2069300842285156e+02 -1.2793299865722656e+02 3.6560798645019531e+01 -2.2158700561523438e+02 -1.2797300720214844e+02 2.8899999618530273e+01 -2.1307598876953125e+02 -1.2815399169921875e+02 2.0289300918579102e+01 -2.1625498962402344e+02 -1.2804899597167969e+02 4.1378799438476562e+01 -2.0801701354980469e+02 -1.2826499938964844e+02 4.2984897613525391e+01 -2.0028900146484375e+02 -1.2844799804687500e+02 3.7201801300048828e+01 -2.0115299987792969e+02 -1.2842999267578125e+02 2.5046899795532227e+01 -2.1049200439453125e+02 -1.1980699920654297e+02 3.7979099273681641e+01 -2.1390699768066406e+02 -1.1972399902343750e+02 3.6742603302001953e+01 -2.1581399536132812e+02 -1.1967800140380859e+02 3.4493698120117188e+01 -2.1637399291992188e+02 -1.1966400146484375e+02 3.2487796783447266e+01 -2.1624598693847656e+02 -1.1966799926757812e+02 3.0146099090576172e+01 -2.1481999206542969e+02 -1.1970199584960938e+02 2.7565799713134766e+01 -2.1235800170898438e+02 -1.1976200103759766e+02 2.5943899154663086e+01 -2.1030000305175781e+02 -1.1981199645996094e+02 2.5629400253295898e+01 -2.0799099731445312e+02 -1.1986800384521484e+02 2.6038799285888672e+01 -2.0624198913574219e+02 -1.1991100311279297e+02 2.7168600082397461e+01 -2.0478599548339844e+02 -1.1994599914550781e+02 2.9006200790405273e+01 -2.0414300537109375e+02 -1.1996199798583984e+02 3.1883798599243164e+01 -2.0490998840332031e+02 -1.1994300079345703e+02 3.4730598449707031e+01 -2.0691200256347656e+02 -1.1989399719238281e+02 3.6894599914550781e+01 -1.9850500488281250e+02 -1.2807699584960938e+02 3.1729099273681641e+01 -2.0342298889160156e+02 -1.2795700073242188e+02 2.2009899139404297e+01 -2.1815000915527344e+02 -1.2759899902343750e+02 2.2526201248168945e+01 -2.2248399353027344e+02 -1.2749401092529297e+02 3.1780399322509766e+01 -2.1894299316406250e+02 -1.1960800170898438e+02 2.3373498916625977e+01 -2.2128599548339844e+02 -1.1954999542236328e+02 2.6835700988769531e+01 -2.2230400085449219e+02 -1.1952600097656250e+02 3.0890600204467773e+01 -2.2210900878906250e+02 -1.1952999877929688e+02 3.3842300415039062e+01 -2.2112500000000000e+02 -1.1955499267578125e+02 3.7009399414062500e+01 -2.1555801391601562e+02 -1.1968900299072266e+02 2.0921598434448242e+01 -2.0355000305175781e+02 -1.1998099517822266e+02 2.1783500671386719e+01 -2.1030999755859375e+02 -1.1981500244140625e+02 1.9754499435424805e+01 -2.1323100280761719e+02 -1.1974600219726562e+02 4.3425601959228516e+01 -2.0906199645996094e+02 -1.1984799957275391e+02 4.3724102020263672e+01 -2.1787600708007812e+02 -1.1963299560546875e+02 4.1198497772216797e+01 -2.0111499023437500e+02 -1.2003900146484375e+02 2.4037199020385742e+01 -1.9829598999023438e+02 -1.2010900115966797e+02 3.2609298706054688e+01 -1.9849101257324219e+02 -1.2010399627685547e+02 2.9657699584960938e+01 -1.9947500610351562e+02 -1.2008100128173828e+02 2.6490600585937500e+01 -2.0324600219726562e+02 -1.1998799896240234e+02 4.1503501892089844e+01 -1.9968199157714844e+02 -1.2007699584960938e+02 3.7573699951171875e+01 -2.0619599914550781e+02 -1.1991500091552734e+02 4.3021701812744141e+01 -2.1135600280761719e+02 -1.2776399993896484e+02 1.9740798950195312e+01 -2.0719799804687500e+02 -1.2786499786376953e+02 2.0170000076293945e+01 -2.0052799987792969e+02 -1.2802700805664062e+02 2.4998300552368164e+01 -1.9881999206542969e+02 -1.2806900024414062e+02 2.8814901351928711e+01 -1.9891700744628906e+02 -1.2806600952148438e+02 3.5046699523925781e+01 -2.0074200439453125e+02 -1.2802200317382812e+02 3.8808403015136719e+01 -2.0374398803710938e+02 -1.2794899749755859e+02 4.1718799591064453e+01 -2.0755900573730469e+02 -1.2785700225830078e+02 4.3426902770996094e+01 -2.1172900390625000e+02 -1.2775500488281250e+02 4.3726501464843750e+01 -2.1575000000000000e+02 -1.2765799713134766e+02 4.2581600189208984e+01 -2.1913600158691406e+02 -1.2757499694824219e+02 4.0130298614501953e+01 -2.2147999572753906e+02 -1.2751799774169922e+02 3.6667999267578125e+01 -2.2230699157714844e+02 -1.2749800109863281e+02 3.3833599090576172e+01 -2.2206999206542969e+02 -1.2750400543212891e+02 2.8453199386596680e+01 -2.2024501037597656e+02 -1.2754799652099609e+02 2.4691499710083008e+01 -2.1540998840332031e+02 -1.2766600036621094e+02 2.0760099411010742e+01 -2.1239300537109375e+02 -1.2015999603271484e+02 1.9933300018310547e+01 -2.0737500000000000e+02 -1.2028100585937500e+02 2.0073101043701172e+01 -2.1506900024414062e+02 -1.1695300292968750e+02 3.1417400360107422e+01 -2.1536399841308594e+02 -1.2963198852539062e+02 3.0789001464843750e+01 -2.1437199401855469e+02 -1.1696799468994141e+02 2.9149801254272461e+01 -2.1380999755859375e+02 -1.2967500305175781e+02 2.8184499740600586e+01 -2.1233500671386719e+02 -1.1699300384521484e+02 2.7357200622558594e+01 -2.1164700317382812e+02 -1.2973399353027344e+02 2.6983200073242188e+01 -2.0975999450683594e+02 -1.1707399749755859e+02 2.6912199020385742e+01 -2.0908599853515625e+02 -1.2978099060058594e+02 2.7114700317382812e+01 -2.0683300781250000e+02 -1.1713399505615234e+02 2.8168498992919922e+01 -2.0645500183105469e+02 -1.2984899902343750e+02 2.9002399444580078e+01 -2.0532000732421875e+02 -1.1718299865722656e+02 3.1742300033569336e+01 -2.0571800231933594e+02 -1.2986599731445312e+02 3.2710998535156250e+01 -2.0693699645996094e+02 -1.1716099548339844e+02 3.5461601257324219e+01 -2.0727198791503906e+02 -1.2983399963378906e+02 3.5315498352050781e+01 -2.0956700134277344e+02 -1.2976899719238281e+02 3.6565502166748047e+01 -2.1032499694824219e+02 -1.1704800415039062e+02 3.6645698547363281e+01 -2.1264399719238281e+02 -1.2971499633789062e+02 3.6142799377441406e+01 -2.1268899536132812e+02 -1.1699500274658203e+02 3.5923500061035156e+01 -2.1471600341796875e+02 -1.2963099670410156e+02 3.4304397583007812e+01 -2.1449600219726562e+02 -1.1695300292968750e+02 3.4106700897216797e+01 -2.0421400451660156e+02 -1.1658799743652344e+02 3.2916603088378906e+01 -2.0800300598144531e+02 -1.1652400207519531e+02 3.7481399536132812e+01 -2.1188400268554688e+02 -1.1641500091552734e+02 3.7636199951171875e+01 -2.1591600036621094e+02 -1.1633399963378906e+02 3.3973400115966797e+01 -2.1616099548339844e+02 -1.1631199645996094e+02 3.0237701416015625e+01 -2.1341600036621094e+02 -1.1640299987792969e+02 2.6497301101684570e+01 -2.0702299499511719e+02 -1.1652999877929688e+02 2.6495599746704102e+01 -2.0469200134277344e+02 -1.1661100006103516e+02 2.9057600021362305e+01 -2.1552200317382812e+02 -1.3039100646972656e+02 3.5370300292968750e+01 -2.1649299621582031e+02 -1.3034799194335938e+02 3.3339298248291016e+01 -2.1223699951171875e+02 -1.3049099731445312e+02 3.7635700225830078e+01 -2.0889500427246094e+02 -1.3055400085449219e+02 3.7637901306152344e+01 -2.0572100830078125e+02 -1.3060600280761719e+02 3.5534698486328125e+01 -2.0501600646972656e+02 -1.3062500000000000e+02 2.9103200912475586e+01 -2.0824598693847656e+02 -1.3055198669433594e+02 2.6058500289916992e+01 -2.1222500610351562e+02 -1.3047300720214844e+02 2.5862001419067383e+01 -2.1573999023437500e+02 -1.3037399291992188e+02 2.8370300292968750e+01 -2.1065699768066406e+02 -1.3034700012207031e+02 3.7894100189208984e+01 -2.1387500000000000e+02 -1.3026901245117188e+02 3.6920398712158203e+01 -2.1666300964355469e+02 -1.3020199584960938e+02 3.1082199096679688e+01 -2.1370300292968750e+02 -1.3027299499511719e+02 2.6472900390625000e+01 -2.1045500183105469e+02 -1.3035200500488281e+02 2.5605899810791016e+01 -2.0634300231933594e+02 -1.3045201110839844e+02 2.7277599334716797e+01 -2.0443099975585938e+02 -1.3049900817871094e+02 3.1284000396728516e+01 -2.0467599487304688e+02 -1.3049299621582031e+02 3.3528701782226562e+01 -2.0740899658203125e+02 -1.3042601013183594e+02 3.7027099609375000e+01 -2.1519100952148438e+02 -1.1674500274658203e+02 2.8128101348876953e+01 -2.0910899353027344e+02 -1.1689399719238281e+02 2.5758399963378906e+01 -2.1134799194335938e+02 -1.1642400360107422e+02 2.5708398818969727e+01 -2.0616499328613281e+02 -1.1696500396728516e+02 2.7141201019287109e+01 -2.0416101074218750e+02 -1.1701399993896484e+02 3.1187599182128906e+01 -2.0468499755859375e+02 -1.1700000000000000e+02 3.4397899627685547e+01 -2.0601499938964844e+02 -1.1696799468994141e+02 3.6222301483154297e+01 -2.1337600708007812e+02 -1.1678900146484375e+02 3.7027099609375000e+01 -2.1506900024414062e+02 -1.1674800109863281e+02 3.5533397674560547e+01 -2.1629600524902344e+02 -1.1671900177001953e+02 3.2312400817871094e+01 -2.1022000122070312e+02 -1.1646900177001953e+02 3.7896396636962891e+01 -2.1513900756835938e+02 -1.0455200195312500e+02 1.9068799972534180e+01 -2.0796998596191406e+02 -1.0363300323486328e+02 1.8040899276733398e+01 -2.0625500488281250e+02 -1.0476700592041016e+02 1.8543500900268555e+01 -1.9929200744628906e+02 -1.0384400177001953e+02 2.3076299667358398e+01 -1.9815899658203125e+02 -1.0496400451660156e+02 2.4470201492309570e+01 -1.9665199279785156e+02 -1.0390800476074219e+02 3.0094598770141602e+01 -1.9647100830078125e+02 -1.0500500488281250e+02 3.4325302124023438e+01 -1.9746200561523438e+02 -1.0388899993896484e+02 3.6603900909423828e+01 -2.0089100646972656e+02 -1.0489799499511719e+02 4.2052700042724609e+01 -2.0214100646972656e+02 -1.0377500152587891e+02 4.3046501159667969e+01 -2.0912300109863281e+02 -1.0469800567626953e+02 4.5435298919677734e+01 -2.0962199401855469e+02 -1.0359300231933594e+02 4.5350299835205078e+01 -2.1712901306152344e+02 -1.0341099548339844e+02 4.3400802612304688e+01 -2.1870500183105469e+02 -1.0446500396728516e+02 4.2459201812744141e+01 -2.2323399353027344e+02 -1.0326200103759766e+02 3.5483901977539062e+01 -2.2350000000000000e+02 -1.0434799957275391e+02 3.3686298370361328e+01 -2.2234899902343750e+02 -1.0328400421142578e+02 2.6896100997924805e+01 -2.2182800292968750e+02 -1.0438899993896484e+02 2.4941999435424805e+01 -2.1767100524902344e+02 -1.0339800262451172e+02 2.0453401565551758e+01 -2.1562699890136719e+02 -1.0344699859619141e+02 2.9579599380493164e+01 -2.1606298828125000e+02 -1.0343699645996094e+02 3.1616199493408203e+01 -2.1541999816894531e+02 -1.0345199584960938e+02 3.4493698120117188e+01 -2.1351300048828125e+02 -1.0349900054931641e+02 3.6742603302001953e+01 -2.1442599487304688e+02 -1.0347600555419922e+02 2.7565799713134766e+01 -2.1196398925781250e+02 -1.0353600311279297e+02 2.5943899154663086e+01 -2.0706201171875000e+02 -1.0365500640869141e+02 2.6330501556396484e+01 -2.0903100585937500e+02 -1.0360700225830078e+02 2.5652200698852539e+01 -2.0520800781250000e+02 -1.0369999694824219e+02 2.7766099929809570e+01 -2.0389599609375000e+02 -1.0373199462890625e+02 3.0405899047851562e+01 -2.0415100097656250e+02 -1.0372599792480469e+02 3.4138500213623047e+01 -2.0784700012207031e+02 -1.0363599395751953e+02 3.7555999755859375e+01 -2.0584799194335938e+02 -1.0368499755859375e+02 3.6331298828125000e+01 -2.1078099060058594e+02 -1.0356500244140625e+02 3.7847797393798828e+01 -2.2090699768066406e+02 -1.0441099548339844e+02 2.8510900497436523e+01 -2.1499499511718750e+02 -1.0459899902343750e+02 2.1486200332641602e+01 -2.0238999938964844e+02 -1.0488899993896484e+02 2.2440898895263672e+01 -2.0993399047851562e+02 -1.0473100280761719e+02 4.3069000244140625e+01 -2.1860900878906250e+02 -1.0449499511718750e+02 3.9355300903320312e+01 -1.9839599609375000e+02 -1.0495800018310547e+02 3.2983699798583984e+01 -2.0313999938964844e+02 -1.0484299468994141e+02 4.0668701171875000e+01 -2.0952799987792969e+02 -1.1312300109863281e+02 2.5619899749755859e+01 -2.1244500732421875e+02 -1.1305200195312500e+02 2.6038799285888672e+01 -2.1483399963378906e+02 -1.1299400329589844e+02 2.7766000747680664e+01 -2.1634199523925781e+02 -1.1295800018310547e+02 3.1189800262451172e+01 -2.1585800170898438e+02 -1.1296900177001953e+02 3.3920299530029297e+01 -2.1465699768066406e+02 -1.1299900054931641e+02 3.5934200286865234e+01 -2.1219499206542969e+02 -1.1305799865722656e+02 3.7555999755859375e+01 -2.0846000671386719e+02 -1.1314900207519531e+02 3.7752201080322266e+01 -2.0607901000976562e+02 -1.1320700073242188e+02 3.6331298828125000e+01 -2.0462300109863281e+02 -1.1324199676513672e+02 3.4493698120117188e+01 -2.0397999572753906e+02 -1.1325799560546875e+02 3.1616199493408203e+01 -2.0474700927734375e+02 -1.1323899841308594e+02 2.8769298553466797e+01 -2.0674900817871094e+02 -1.1319100189208984e+02 2.6605400085449219e+01 -2.0863999938964844e+02 -1.0516699981689453e+02 2.0510900497436523e+01 -2.0061199951171875e+02 -1.0536199951171875e+02 2.4200099945068359e+01 -1.9955299377441406e+02 -1.0538800048828125e+02 3.7738498687744141e+01 -2.0391101074218750e+02 -1.0528199768066406e+02 4.2112400054931641e+01 -2.2119100952148438e+02 -1.0486199951171875e+02 3.5892200469970703e+01 -2.2176300048828125e+02 -1.0484799957275391e+02 2.9751499176025391e+01 -2.1539500427246094e+02 -1.1297599792480469e+02 4.2578300476074219e+01 -2.0149398803710938e+02 -1.1331299591064453e+02 2.3373498916625977e+01 -1.9915100097656250e+02 -1.1337000274658203e+02 2.6835700988769531e+01 -2.1306700134277344e+02 -1.1303199768066406e+02 2.0074300765991211e+01 -2.0889799499511719e+02 -1.1313299560546875e+02 1.9775899887084961e+01 -2.1877999877929688e+02 -1.1289299774169922e+02 4.0126399993896484e+01 -2.2112300109863281e+02 -1.1283600616455078e+02 3.6664299011230469e+01 -1.9813301086425781e+02 -1.1339399719238281e+02 3.0890600204467773e+01 -1.9832800292968750e+02 -1.1338999938964844e+02 3.3842300415039062e+01 -1.9931199645996094e+02 -1.1336599731445312e+02 3.7009399414062500e+01 -2.0487899780273438e+02 -1.1323100280761719e+02 2.0921598434448242e+01 -2.0720599365234375e+02 -1.1317499542236328e+02 4.3425601959228516e+01 -2.1137500000000000e+02 -1.1307299804687500e+02 4.3724102020263672e+01 -2.1771299743652344e+02 -1.1291900634765625e+02 2.2301399230957031e+01 -2.0176300048828125e+02 -1.1330699920654297e+02 4.0395698547363281e+01 -2.0414799499511719e+02 -1.1324700164794922e+02 4.2143901824951172e+01 -2.2214099121093750e+02 -1.1281099700927734e+02 3.2609298706054688e+01 -2.2194599914550781e+02 -1.1281600189208984e+02 2.9657699584960938e+01 -2.2096200561523438e+02 -1.1283999633789062e+02 2.6490600585937500e+01 -2.1080599975585938e+02 -1.0511399841308594e+02 4.3759201049804688e+01 -2.0664801025390625e+02 -1.0521499633789062e+02 4.3329998016357422e+01 -2.0130099487304688e+02 -1.0534500122070312e+02 4.0130203247070312e+01 -1.9826998901367188e+02 -1.0541899871826172e+02 3.4685100555419922e+01 -1.9797000122070312e+02 -1.0542599487304688e+02 3.0514299392700195e+01 -1.9911499023437500e+02 -1.0539800262451172e+02 2.6492500305175781e+01 -2.0502699279785156e+02 -1.0525499725341797e+02 2.0760099411010742e+01 -2.0908099365234375e+02 -1.0515599822998047e+02 1.9740798950195312e+01 -2.1323899841308594e+02 -1.0505500030517578e+02 2.0170000076293945e+01 -2.1700000000000000e+02 -1.0496400451660156e+02 2.1995800018310547e+01 -2.1990899658203125e+02 -1.0489299774169922e+02 2.4998199462890625e+01 -2.2121499633789062e+02 -1.0486100006103516e+02 2.7646100997924805e+01 -2.2191600036621094e+02 -1.0484399414062500e+02 3.2985698699951172e+01 -2.1969500732421875e+02 -1.0489799499511719e+02 3.8808403015136719e+01 -2.1669299316406250e+02 -1.0497100067138672e+02 4.1718898773193359e+01 -2.1404600524902344e+02 -1.0503499603271484e+02 4.3025299072265625e+01 -2.1469700622558594e+02 -1.0304299926757812e+02 3.0742900848388672e+01 -2.1502700805664062e+02 -1.1574199676513672e+02 3.0789001464843750e+01 -2.1322000122070312e+02 -1.0308799743652344e+02 2.8244199752807617e+01 -2.1315200805664062e+02 -1.1579599761962891e+02 2.7858200073242188e+01 -2.1135101318359375e+02 -1.0313999938964844e+02 2.7114700317382812e+01 -2.1067700195312500e+02 -1.1584600067138672e+02 2.6912199020385742e+01 -2.0878900146484375e+02 -1.0318700408935547e+02 2.6983200073242188e+01 -2.0810200500488281e+02 -1.1592800140380859e+02 2.7357200622558594e+01 -2.0662699890136719e+02 -1.0324499511718750e+02 2.8184400558471680e+01 -2.0606500244140625e+02 -1.1595200347900391e+02 2.9149700164794922e+01 -2.0507299804687500e+02 -1.0328900146484375e+02 3.0789001464843750e+01 -2.0536799621582031e+02 -1.1596699523925781e+02 3.1417400360107422e+01 -2.0580899047851562e+02 -1.0327000427246094e+02 3.4497600555419922e+01 -2.0594100952148438e+02 -1.1596699523925781e+02 3.4106700897216797e+01 -2.0813099670410156e+02 -1.1591999816894531e+02 3.6176902770996094e+01 -2.0888299560546875e+02 -1.0320200347900391e+02 3.6554298400878906e+01 -2.1070500183105469e+02 -1.1584500122070312e+02 3.6584102630615234e+01 -2.1196800231933594e+02 -1.0311000061035156e+02 3.6176902770996094e+01 -2.1273800659179688e+02 -1.1580000305175781e+02 3.5867698669433594e+01 -2.1433099365234375e+02 -1.0279199981689453e+02 3.3819400787353516e+01 -2.1448298645019531e+02 -1.1575700378417969e+02 3.4068801879882812e+01 -2.1558299255371094e+02 -1.0225900268554688e+02 2.9545700073242188e+01 -2.1319699096679688e+02 -1.0233599853515625e+02 2.6581098556518555e+01 -2.0775399780273438e+02 -1.0247399902343750e+02 2.5985099792480469e+01 -2.0442500305175781e+02 -1.0253900146484375e+02 2.8920200347900391e+01 -2.0394200134277344e+02 -1.0254499816894531e+02 3.3333099365234375e+01 -2.0756399536132812e+02 -1.0248100280761719e+02 3.7441398620605469e+01 -2.1154199218750000e+02 -1.0236599731445312e+02 3.7637901306152344e+01 -2.0998199462890625e+02 -1.0256800079345703e+02 2.5605899810791016e+01 -2.1155599975585938e+02 -1.0252999877929688e+02 2.5862300872802734e+01 -2.1484400939941406e+02 -1.0244999694824219e+02 2.8128198623657227e+01 -2.1600599670410156e+02 -1.0242199707031250e+02 3.1283899307250977e+01 -2.1576100158691406e+02 -1.0242799377441406e+02 3.3528800964355469e+01 -2.1472200012207031e+02 -1.0245300292968750e+02 3.5533397674560547e+01 -2.1302799987792969e+02 -1.0249400329589844e+02 3.7027099609375000e+01 -2.0977999877929688e+02 -1.0257299804687500e+02 3.7894100189208984e+01 -2.0566799926757812e+02 -1.0267300415039062e+02 3.6222301483154297e+01 -2.0467799377441406e+02 -1.0269699859619141e+02 3.4972499847412109e+01 -2.0377400207519531e+02 -1.0271900177001953e+02 3.1082300186157227e+01 -2.0581799316406250e+02 -1.0266899871826172e+02 2.7141201019287109e+01 -2.1517098999023438e+02 -1.1593399810791016e+02 3.5371799468994141e+01 -2.1352799987792969e+02 -1.1597399902343750e+02 3.6920497894287109e+01 -2.0614500427246094e+02 -1.1615299987792969e+02 3.6358699798583984e+01 -2.0475498962402344e+02 -1.1618699645996094e+02 3.4579299926757812e+01 -2.0414100646972656e+02 -1.1620099639892578e+02 3.1187599182128906e+01 -2.0524600219726562e+02 -1.1617500305175781e+02 2.8128101348876953e+01 -2.0908898925781250e+02 -1.1608100128173828e+02 2.5758399963378906e+01 -2.1427200317382812e+02 -1.1595600128173828e+02 2.7141201019287109e+01 -2.1566200256347656e+02 -1.1592199707031250e+02 2.8920700073242188e+01 -2.1627600097656250e+02 -1.1590599822998047e+02 3.2312400817871094e+01 -2.2056900024414062e+02 -1.0454499816894531e+02 1.6232601165771484e+01 -2.1869200134277344e+02 -1.0459200286865234e+02 1.2277999877929688e+01 -2.1462200927734375e+02 -1.0469000244140625e+02 1.3530799865722656e+01 -2.1048599243164062e+02 -1.0479199981689453e+02 1.0517800331115723e+01 -2.0811000061035156e+02 -1.0484799957275391e+02 1.3026200294494629e+01 -2.0196199035644531e+02 -1.0499900054931641e+02 1.1943999290466309e+01 -2.0181800842285156e+02 -1.0500099945068359e+02 1.4779900550842285e+01 -1.9650498962402344e+02 -1.0513000488281250e+02 1.8580600738525391e+01 -1.9500898742675781e+02 -1.0516799926757812e+02 1.6644599914550781e+01 -1.9281199645996094e+02 -1.0521900177001953e+02 2.3969600677490234e+01 -1.9099499511718750e+02 -1.0526499938964844e+02 2.2150098800659180e+01 -1.9118400573730469e+02 -1.0525900268554688e+02 3.0296899795532227e+01 -1.8843800354003906e+02 -1.0532700347900391e+02 3.2244899749755859e+01 -2.1665899658203125e+02 -1.0463699340820312e+02 4.9436302185058594e+01 -2.1947599792480469e+02 -1.0457299804687500e+02 5.0849899291992188e+01 -2.2336601257324219e+02 -1.0447700500488281e+02 4.4919403076171875e+01 -2.2836900329589844e+02 -1.0435699462890625e+02 4.2824600219726562e+01 -2.2705900573730469e+02 -1.0438700103759766e+02 3.9530300140380859e+01 -2.2868600463867188e+02 -1.0434799957275391e+02 3.3202899932861328e+01 -2.3127600097656250e+02 -1.0428600311279297e+02 3.1316101074218750e+01 -2.2805200195312500e+02 -1.0436299896240234e+02 2.6700298309326172e+01 -2.2934800720214844e+02 -1.0433300018310547e+02 2.3145700454711914e+01 -2.2523300170898438e+02 -1.0443199920654297e+02 2.0806598663330078e+01 -2.2562500000000000e+02 -1.0442399597167969e+02 1.7439401626586914e+01 -1.9225500488281250e+02 -1.0522899627685547e+02 3.8475597381591797e+01 -1.9304699707031250e+02 -1.0521499633789062e+02 4.5063800811767578e+01 -1.9677000427246094e+02 -1.0512300109863281e+02 4.5184299468994141e+01 -2.0215701293945312e+02 -1.0499200439453125e+02 4.8878299713134766e+01 -2.0110900878906250e+02 -1.0502000427246094e+02 5.1067100524902344e+01 -2.0848300170898438e+02 -1.0483899688720703e+02 5.0506301879882812e+01 -2.0950900268554688e+02 -1.0481500244140625e+02 5.3097099304199219e+01 -2.3125599670410156e+02 -1.0347399902343750e+02 3.2183799743652344e+01 -2.2932800292968750e+02 -1.0352099609375000e+02 4.0354198455810547e+01 -2.2560499572753906e+02 -1.0361100006103516e+02 4.6060600280761719e+01 -2.1867201232910156e+02 -1.0377999877929688e+02 5.1221900939941406e+01 -2.0683300781250000e+02 -1.0406700134277344e+02 5.3037200927734375e+01 -1.9608299255371094e+02 -1.0432799530029297e+02 4.8011100769042969e+01 -1.8936799621582031e+02 -1.0449200439453125e+02 3.8090000152587891e+01 -1.8968099975585938e+02 -1.0448400115966797e+02 2.4471000671386719e+01 -1.9811099243164062e+02 -1.0427899932861328e+02 1.3771599769592285e+01 -2.0765798950195312e+02 -1.0404699707031250e+02 1.0630999565124512e+01 -2.1446000671386719e+02 -1.0388199615478516e+02 1.1002999305725098e+01 -2.2079400634765625e+02 -1.0372799682617188e+02 1.3510299682617188e+01 -2.2834899902343750e+02 -1.0354500579833984e+02 2.0675300598144531e+01 -2.2344200134277344e+02 -1.0224100494384766e+02 2.8115301132202148e+01 -2.2037998962402344e+02 -1.0231400299072266e+02 2.1973899841308594e+01 -2.1279699707031250e+02 -1.0249900054931641e+02 1.7826000213623047e+01 -2.0544700622558594e+02 -1.0267800140380859e+02 1.8232900619506836e+01 -1.9843299865722656e+02 -1.0284700012207031e+02 2.3105100631713867e+01 -1.9566600036621094e+02 -1.0291499328613281e+02 3.1294799804687500e+01 -1.9715699768066406e+02 -1.0288000488281250e+02 3.7684997558593750e+01 -2.0123899841308594e+02 -1.0277899932861328e+02 4.3201099395751953e+01 -2.0942599487304688e+02 -1.0258100128173828e+02 4.5968902587890625e+01 -2.1659399414062500e+02 -1.0240699768066406e+02 4.4291500091552734e+01 -2.2126899719238281e+02 -1.0229399871826172e+02 4.0127197265625000e+01 -2.2380099487304688e+02 -1.0223200225830078e+02 3.4667297363281250e+01 -2.1663899230957031e+02 -1.0382399749755859e+02 1.4063600540161133e+01 -2.2334599304199219e+02 -1.0366500091552734e+02 1.8580398559570312e+01 -2.2703900146484375e+02 -1.0357499694824219e+02 2.3969600677490234e+01 -2.2866598510742188e+02 -1.0353499603271484e+02 3.0297000885009766e+01 -2.2803199768066406e+02 -1.0355100250244141e+02 3.6799697875976562e+01 -2.2521301269531250e+02 -1.0361900329589844e+02 4.2693397521972656e+01 -2.1913800048828125e+02 -1.0376300048828125e+02 4.8270999908447266e+01 -1.9119699096679688e+02 -1.0444599914550781e+02 2.9923999786376953e+01 -1.9294999694824219e+02 -1.0440299987792969e+02 2.3630100250244141e+01 -1.9675000000000000e+02 -1.0431099700927734e+02 1.8315599441528320e+01 -2.0213699340820312e+02 -1.0418000030517578e+02 1.4621700286865234e+01 -2.0846299743652344e+02 -1.0402600097656250e+02 1.2993599891662598e+01 -2.1136799621582031e+02 -1.0395600128173828e+02 5.0506401062011719e+01 -2.0486700439453125e+02 -1.0411400604248047e+02 4.9872200012207031e+01 -1.9897499084472656e+02 -1.0425700378417969e+02 4.7052101135253906e+01 -1.9440299987792969e+02 -1.0436800384521484e+02 4.2386497497558594e+01 -1.9170199584960938e+02 -1.0443299865722656e+02 3.6437999725341797e+01 -2.1354199218750000e+02 -1.0248200225830078e+02 3.1065500259399414e+01 -2.0889199829101562e+02 -1.0259500122070312e+02 2.7304201126098633e+01 -2.1084600830078125e+02 -1.0254699707031250e+02 3.6019298553466797e+01 -2.0640901184082031e+02 -1.0265499877929688e+02 3.3095596313476562e+01 -2.2263600158691406e+02 -1.0144599914550781e+02 2.5225000381469727e+01 -2.1657499694824219e+02 -1.0159400177001953e+02 1.9208398818969727e+01 -2.1076600646972656e+02 -1.0173600006103516e+02 1.7638801574707031e+01 -2.0457200622558594e+02 -1.0188599395751953e+02 1.8544099807739258e+01 -1.9782499694824219e+02 -1.0204900360107422e+02 2.3946100234985352e+01 -1.9564599609375000e+02 -1.0210300445556641e+02 3.2205101013183594e+01 -1.9719200134277344e+02 -1.0206600189208984e+02 3.8021900177001953e+01 -2.0107301330566406e+02 -1.0197100067138672e+02 4.2934997558593750e+01 -2.0784098815917969e+02 -1.0180599975585938e+02 4.5832000732421875e+01 -2.1638398742675781e+02 -1.0159799957275391e+02 4.4528301239013672e+01 -2.2162599182128906e+02 -1.0147200012207031e+02 3.9589302062988281e+01 -2.2393899536132812e+02 -1.0141500091552734e+02 3.3770797729492188e+01 -2.1352200317382812e+02 -1.0166899871826172e+02 3.1065500259399414e+01 -2.0836199951171875e+02 -1.0179399871826172e+02 2.7449300765991211e+01 -2.0638899230957031e+02 -1.0184200286865234e+02 3.3095596313476562e+01 -2.1128800964355469e+02 -1.0172299957275391e+02 3.5887699127197266e+01 -2.0272299194335938e+02 -1.2830599975585938e+02 1.4621199607849121e+01 -2.0325799560546875e+02 -1.2829100036621094e+02 1.1784999847412109e+01 -2.0904899597167969e+02 -1.2815199279785156e+02 1.2993499755859375e+01 -2.0995100402832031e+02 -1.2812899780273438e+02 1.0517800331115723e+01 -2.1722500610351562e+02 -1.2795800018310547e+02 1.4064499855041504e+01 -2.1847500610351562e+02 -1.2792199707031250e+02 1.1943999290466309e+01 -2.2393199157714844e+02 -1.2779100036621094e+02 1.8580600738525391e+01 -2.2542799377441406e+02 -1.2775300598144531e+02 1.6644599914550781e+01 -2.2762500000000000e+02 -1.2770099639892578e+02 2.3969499588012695e+01 -2.2944200134277344e+02 -1.2765499877929688e+02 2.2150098800659180e+01 -2.2925299072265625e+02 -1.2766100311279297e+02 3.0296899795532227e+01 -2.3180801391601562e+02 -1.2759799957275391e+02 3.0464799880981445e+01 -2.0377799987792969e+02 -1.2828401184082031e+02 4.9436302185058594e+01 -2.0096099853515625e+02 -1.2834700012207031e+02 5.0849899291992188e+01 -1.9583900451660156e+02 -1.2847700500488281e+02 4.3703300476074219e+01 -1.9317999267578125e+02 -1.2853599548339844e+02 4.4227100372314453e+01 -1.9228799438476562e+02 -1.2855899047851562e+02 3.6437797546386719e+01 -1.8936799621582031e+02 -1.2862899780273438e+02 3.4745998382568359e+01 -1.9178298950195312e+02 -1.2857200622558594e+02 2.9923898696899414e+01 -1.9039698791503906e+02 -1.2860398864746094e+02 2.4578599929809570e+01 -1.9353700256347656e+02 -1.2852899169921875e+02 2.3630100250244141e+01 -1.9733599853515625e+02 -1.2843699645996094e+02 1.8315799713134766e+01 -1.9603100585937500e+02 -1.2846699523925781e+02 1.6054000854492188e+01 -2.2861898803710938e+02 -1.2767699432373047e+02 3.6799800872802734e+01 -2.2930699157714844e+02 -1.2765799713134766e+02 4.2181598663330078e+01 -2.2481599426269531e+02 -1.2777300262451172e+02 4.4118801116943359e+01 -2.1927000427246094e+02 -1.2790200042724609e+02 5.1389701843261719e+01 -2.1827999877929688e+02 -1.2792800140380859e+02 4.8878402709960938e+01 -2.1195399475097656e+02 -1.2808200073242188e+02 5.0506301879882812e+01 -2.0934300231933594e+02 -1.2814399719238281e+02 5.2957603454589844e+01 -1.8913301086425781e+02 -1.2944799804687500e+02 3.3973701477050781e+01 -1.9273999023437500e+02 -1.2936000061035156e+02 4.3357799530029297e+01 -2.0020100402832031e+02 -1.2917900085449219e+02 5.0620197296142578e+01 -2.0997099304199219e+02 -1.2894099426269531e+02 5.2982097625732422e+01 -2.2018400573730469e+02 -1.2869299316406250e+02 5.0965301513671875e+01 -2.2878999328613281e+02 -1.2848399353027344e+02 4.2792499542236328e+01 -2.3152600097656250e+02 -1.2841799926757812e+02 3.4856098175048828e+01 -2.3142900085449219e+02 -1.2841999816894531e+02 2.8042900085449219e+01 -2.2741000366210938e+02 -1.2851800537109375e+02 1.8436100006103516e+01 -2.1602700805664062e+02 -1.2879400634765625e+02 1.0957599639892578e+01 -2.0416699218750000e+02 -1.2908200073242188e+02 1.1366499900817871e+01 -1.9685800170898438e+02 -1.2926000976562500e+02 1.5492100715637207e+01 -1.9142399597167969e+02 -1.2939199829101562e+02 2.2213699340820312e+01 -1.9734799194335938e+02 -1.3067199707031250e+02 2.6155399322509766e+01 -2.0305400085449219e+02 -1.3053298950195312e+02 1.9663499832153320e+01 -2.1010099792480469e+02 -1.3036100769042969e+02 1.7531000137329102e+01 -2.1835800170898438e+02 -1.3016200256347656e+02 1.9710000991821289e+01 -2.2322499084472656e+02 -1.3004200744628906e+02 2.5478000640869141e+01 -2.2477099609375000e+02 -1.3000500488281250e+02 3.1294799804687500e+01 -2.2327999877929688e+02 -1.3004100036621094e+02 3.7684997558593750e+01 -2.1919799804687500e+02 -1.3014100646972656e+02 4.3201099395751953e+01 -2.1101100158691406e+02 -1.3033898925781250e+02 4.5968902587890625e+01 -2.0384300231933594e+02 -1.3051300048828125e+02 4.4291500091552734e+01 -1.9916799926757812e+02 -1.3062699890136719e+02 4.0127300262451172e+01 -1.9663600158691406e+02 -1.3068899536132812e+02 3.4667201995849609e+01 -2.2927301025390625e+02 -1.2847399902343750e+02 3.3202899932861328e+01 -2.2820199584960938e+02 -1.2850399780273438e+02 2.5024398803710938e+01 -2.2368699645996094e+02 -1.2861000061035156e+02 1.8315599441528320e+01 -2.1830000305175781e+02 -1.2874099731445312e+02 1.4621599197387695e+01 -2.1197399902343750e+02 -1.2889399719238281e+02 1.2993599891662598e+01 -2.0379798889160156e+02 -1.2909600830078125e+02 1.4063600540161133e+01 -1.9988800048828125e+02 -1.2918800354003906e+02 4.7267398834228516e+01 -2.0750399780273438e+02 -1.2900700378417969e+02 5.0428901672363281e+01 -2.1724499511718750e+02 -1.2876998901367188e+02 4.9435398101806641e+01 -2.2395199584960938e+02 -1.2860299682617188e+02 4.4919498443603516e+01 -2.2764498901367188e+02 -1.2851400756835938e+02 3.9530399322509766e+01 -1.9709100341796875e+02 -1.2925599670410156e+02 1.8580600738525391e+01 -1.9339799499511719e+02 -1.2934500122070312e+02 2.3969400405883789e+01 -1.9177099609375000e+02 -1.2938499450683594e+02 3.0296899795532227e+01 -1.9240499877929688e+02 -1.2937001037597656e+02 3.6799697875976562e+01 -1.9522399902343750e+02 -1.2930099487304688e+02 4.2693202972412109e+01 -2.0959100341796875e+02 -1.3037300109863281e+02 3.6019298553466797e+01 -2.1154499816894531e+02 -1.3032600402832031e+02 2.7304201126098633e+01 -2.1402799987792969e+02 -1.3026599121093750e+02 3.3095596313476562e+01 -2.0689498901367188e+02 -1.3043899536132812e+02 3.1065500259399414e+01 -1.9780099487304688e+02 -1.3147399902343750e+02 2.5225000381469727e+01 -2.0386199951171875e+02 -1.3132600402832031e+02 1.9208398818969727e+01 -2.1103100585937500e+02 -1.3115200805664062e+02 1.7531000137329102e+01 -2.1921800231933594e+02 -1.3095399475097656e+02 2.0298799514770508e+01 -2.2329998779296875e+02 -1.3085299682617188e+02 2.5815000534057617e+01 -2.2479000854492188e+02 -1.3081799316406250e+02 3.2205001831054688e+01 -2.2324499511718750e+02 -1.3085499572753906e+02 3.8021900177001953e+01 -2.1837699890136719e+02 -1.3097399902343750e+02 4.3790000915527344e+01 -2.1012100219726562e+02 -1.3117399597167969e+02 4.5968902587890625e+01 -2.0307398986816406e+02 -1.3134500122070312e+02 4.3836399078369141e+01 -1.9881098937988281e+02 -1.3144799804687500e+02 3.9589302062988281e+01 -1.9649800109863281e+02 -1.3150500488281250e+02 3.3770900726318359e+01 -2.0691500854492188e+02 -1.3125100708007812e+02 3.1065500259399414e+01 -2.1207499694824219e+02 -1.3112600708007812e+02 2.7449300765991211e+01 -2.1404800415039062e+02 -1.3107800292968750e+02 3.3095596313476562e+01 -2.0914900207519531e+02 -1.3119700622558594e+02 3.5887699127197266e+01 -2.1194499206542969e+02 -1.0486000061035156e+02 2.0020698547363281e+01 -2.1250000000000000e+02 -1.2758399200439453e+02 2.0021301269531250e+01 -2.1049900817871094e+02 -1.2801200866699219e+02 1.9850099563598633e+01 -2.0792601013183594e+02 -1.0495600128173828e+02 2.0021301269531250e+01 -2.0847900390625000e+02 -1.2768199920654297e+02 2.0021301269531250e+01 -2.0652699279785156e+02 -1.2772899627685547e+02 2.0529798507690430e+01 -2.0469699096679688e+02 -1.2815399169921875e+02 2.1361200332641602e+01 -2.0416499328613281e+02 -1.0504899597167969e+02 2.1341600418090820e+01 -2.0301499938964844e+02 -1.2796500396728516e+02 2.2495100021362305e+01 -2.0101701354980469e+02 -1.0550399780273438e+02 2.3887998580932617e+01 -2.0036000061035156e+02 -1.2787899017333984e+02 2.5510799407958984e+01 -1.9981199645996094e+02 -1.0538099670410156e+02 2.5513299942016602e+01 -1.9945100402832031e+02 -1.2790100097656250e+02 2.7312999725341797e+01 -1.9887001037597656e+02 -1.2829499816894531e+02 2.9243101119995117e+01 -1.9830799865722656e+02 -1.0519000244140625e+02 2.9243198394775391e+01 -1.9805300903320312e+02 -1.0552400207519531e+02 3.1514297485351562e+01 -1.9860899353027344e+02 -1.2813499450683594e+02 3.1245800018310547e+01 -1.9869000244140625e+02 -1.2791999816894531e+02 3.3261501312255859e+01 -1.9857199096679688e+02 -1.0556399536132812e+02 3.5234500885009766e+01 -1.9911499023437500e+02 -1.2790900421142578e+02 3.5234500885009766e+01 -1.9931500244140625e+02 -1.0516600036621094e+02 3.7107200622558594e+01 -1.9986698913574219e+02 -1.2789100646972656e+02 3.7107299804687500e+01 -2.0038299560546875e+02 -1.0536699676513672e+02 3.8830699920654297e+01 -2.0327600097656250e+02 -1.0506999969482422e+02 4.1609298706054688e+01 -2.0564599609375000e+02 -1.2812899780273438e+02 4.2613101959228516e+01 -2.0504699707031250e+02 -1.0540699768066406e+02 4.2593502044677734e+01 -2.0694898986816406e+02 -1.0536000061035156e+02 4.3265899658203125e+01 -2.0892900085449219e+02 -1.0493299865722656e+02 4.3606998443603516e+01 -2.1484700012207031e+02 -1.0516799926757812e+02 4.2593502044677734e+01 -2.1150698852539062e+02 -1.2798699951171875e+02 4.3606998443603516e+01 -2.1534599304199219e+02 -1.2789399719238281e+02 4.2613903045654297e+01 -2.1659899902343750e+02 -1.0474600219726562e+02 4.1609298706054688e+01 -2.1715199279785156e+02 -1.2747100067138672e+02 4.1609203338623047e+01 -2.1824600219726562e+02 -1.0471100616455078e+02 4.0261199951171875e+01 -2.2005499267578125e+02 -1.2740099334716797e+02 3.8826000213623047e+01 -2.2056999206542969e+02 -1.0502899932861328e+02 3.7107299804687500e+01 -2.2112199401855469e+02 -1.2775500488281250e+02 3.7107097625732422e+01 -2.2186500549316406e+02 -1.2735599517822266e+02 3.5234500885009766e+01 -2.2132200622558594e+02 -1.0501100158691406e+02 3.5234500885009766e+01 -2.2174699401855469e+02 -1.0500099945068359e+02 3.3261501312255859e+01 -2.2182301330566406e+02 -1.0462000274658203e+02 3.1244300842285156e+01 -2.2211900329589844e+02 -1.2735000610351562e+02 2.9242898941040039e+01 -2.2152799987792969e+02 -1.2736499023437500e+02 2.7312999725341797e+01 -2.2029100036621094e+02 -1.0465799713134766e+02 2.5941900253295898e+01 -2.2062500000000000e+02 -1.2753799438476562e+02 2.5513299942016602e+01 -2.1942900085449219e+02 -1.2779499816894531e+02 2.3888099670410156e+01 -2.1796299743652344e+02 -1.2745100402832031e+02 2.2491399765014648e+01 -2.1742199707031250e+02 -1.0495299530029297e+02 2.2495100021362305e+01 -2.1629199218750000e+02 -1.2749199676513672e+02 2.1361200332641602e+01 -2.1445300292968750e+02 -1.2753699493408203e+02 2.0529798507690430e+01 -2.1391000366210938e+02 -1.0519100189208984e+02 2.0529798507690430e+01 -2.0226701354980469e+02 -1.2798400115966797e+02 4.0347400665283203e+01 -2.2028199768066406e+02 -1.2777500152587891e+02 1.9718799591064453e+01 -2.1112200927734375e+02 -1.0487899780273438e+02 4.7164001464843750e+01 -2.2529299926757812e+02 -1.0453399658203125e+02 3.3518199920654297e+01 -2.2154299926757812e+02 -1.0462799835205078e+02 2.1450799942016602e+01 -2.1893200683593750e+02 -1.0469199371337891e+02 4.4379798889160156e+01 -2.0875500488281250e+02 -1.0493700408935547e+02 1.6303199768066406e+01 -1.9452799987792969e+02 -1.0528399658203125e+02 3.3187999725341797e+01 -1.9928599548339844e+02 -1.0516799926757812e+02 4.3035598754882812e+01 -1.9689401245117188e+02 -1.0522499847412109e+02 2.3392200469970703e+01 -2.0953799438476562e+02 -1.2803601074218750e+02 4.7177398681640625e+01 -2.1168299865722656e+02 -1.2798300170898438e+02 1.6304100036621094e+01 -2.0302999877929688e+02 -1.2819000244140625e+02 4.5288299560546875e+01 -1.9692100524902344e+02 -1.2834199523925781e+02 2.4368600845336914e+01 -2.2540600585937500e+02 -1.2764999389648438e+02 3.5837299346923828e+01 -2.2203199768066406e+02 -1.2773199462890625e+02 4.2042098999023438e+01 -1.9752400207519531e+02 -1.2832800292968750e+02 4.0151000976562500e+01 -2.0284800720214844e+02 -1.2819599914550781e+02 1.8266300201416016e+01 -1.9548300170898438e+02 -1.0551300048828125e+02 3.7337501525878906e+01 -1.9696499633789062e+02 -1.0546199798583984e+02 4.0148002624511719e+01 -2.0304399108886719e+02 -1.0531900024414062e+02 4.5625102996826172e+01 -2.0783399963378906e+02 -1.0519200134277344e+02 4.7107299804687500e+01 -2.1483099365234375e+02 -1.0502799987792969e+02 4.6487201690673828e+01 -2.2259298706054688e+02 -1.0482800292968750e+02 4.0676002502441406e+01 -2.2453099060058594e+02 -1.0480800628662109e+02 3.7022098541259766e+01 -2.2535699462890625e+02 -1.0478700256347656e+02 3.0183900833129883e+01 -2.2405299377441406e+02 -1.0480199432373047e+02 2.5331399917602539e+01 -2.1792599487304688e+02 -1.0491299438476562e+02 1.8496299743652344e+01 -2.1337899780273438e+02 -1.0508200073242188e+02 1.6596698760986328e+01 -2.0375399780273438e+02 -1.0528100585937500e+02 1.7548700332641602e+01 -2.0016600036621094e+02 -1.0539100646972656e+02 1.9711399078369141e+01 -1.9493299865722656e+02 -1.0549800109863281e+02 2.7786100387573242e+01 -1.9883200073242188e+02 -1.2811300659179688e+02 2.1541999816894531e+01 -2.0718400573730469e+02 -1.2782099914550781e+02 1.6583900451660156e+01 -2.1668200683593750e+02 -1.2761999511718750e+02 1.7549301147460938e+01 -2.2374400329589844e+02 -1.2743000793457031e+02 2.3686901092529297e+01 -2.2546699523925781e+02 -1.2734700775146484e+02 2.7699600219726562e+01 -2.2597200012207031e+02 -1.2734300231933594e+02 3.2545600891113281e+01 -2.2401000976562500e+02 -1.2745499420166016e+02 3.9309299468994141e+01 -2.1929598999023438e+02 -1.2756300354003906e+02 4.4505802154541016e+01 -2.1522499084472656e+02 -1.2763800048828125e+02 4.6529098510742188e+01 -2.0672700500488281e+02 -1.2785600280761719e+02 4.6755100250244141e+01 -1.9971499633789062e+02 -1.2803100585937500e+02 4.2931900024414062e+01 -1.9590600585937500e+02 -1.2811300659179688e+02 3.7021800994873047e+01 -1.9512399291992188e+02 -1.2813499450683594e+02 3.3416301727294922e+01 -1.9554699707031250e+02 -1.2823699951171875e+02 2.7597900390625000e+01 -1.9483700561523438e+02 -1.2054000091552734e+02 3.0823999404907227e+01 -2.1351300048828125e+02 -1.1979599761962891e+02 4.6917999267578125e+01 -2.1846400451660156e+02 -1.1261000061035156e+02 1.8598999023437500e+01 -2.2329199218750000e+02 -1.1285199737548828e+02 2.3382099151611328e+01 -2.2527999877929688e+02 -1.1278800201416016e+02 2.8405099868774414e+01 -2.2556500244140625e+02 -1.1232399749755859e+02 3.3013198852539062e+01 -2.2458499145507812e+02 -1.1243499755859375e+02 3.7383998870849609e+01 -2.2302200317382812e+02 -1.1285099792480469e+02 4.0327796936035156e+01 -2.2104699707031250e+02 -1.1248899841308594e+02 4.2754898071289062e+01 -2.1775401306152344e+02 -1.1262200164794922e+02 4.5241798400878906e+01 -2.1232299804687500e+02 -1.1267800140380859e+02 4.7156200408935547e+01 -2.0558000183105469e+02 -1.1288599395751953e+02 4.6645801544189453e+01 -2.0074899291992188e+02 -1.1295399475097656e+02 4.4078300476074219e+01 -1.9749600219726562e+02 -1.1305599975585938e+02 4.0728401184082031e+01 -1.9553099060058594e+02 -1.1313800048828125e+02 3.7023498535156250e+01 -1.9465299987792969e+02 -1.1334300231933594e+02 3.1939100265502930e+01 -1.9530599975585938e+02 -1.1286299896240234e+02 2.7114000320434570e+01 -1.9848200988769531e+02 -1.1286000061035156e+02 2.1440799713134766e+01 -2.0400599670410156e+02 -1.1268599700927734e+02 1.7464300155639648e+01 -2.0962699890136719e+02 -1.1263600158691406e+02 1.6277101516723633e+01 -2.1339898681640625e+02 -1.1275299835205078e+02 1.6580900192260742e+01 -2.2440600585937500e+02 -1.1997599792480469e+02 2.5179199218750000e+01 -2.2578201293945312e+02 -1.1936800384521484e+02 3.0670200347900391e+01 -2.1797401428222656e+02 -1.2027200317382812e+02 4.5227500915527344e+01 -2.2133700561523438e+02 -1.1988700103759766e+02 4.2665199279785156e+01 -2.2400399780273438e+02 -1.1989100646972656e+02 3.8982299804687500e+01 -2.2548399353027344e+02 -1.2014199829101562e+02 3.4823699951171875e+01 -2.0914599609375000e+02 -1.2012200164794922e+02 4.7220302581787109e+01 -2.0485900878906250e+02 -1.1963299560546875e+02 4.6300003051757812e+01 -2.0097599792480469e+02 -1.2044200134277344e+02 4.4105800628662109e+01 -1.9729399108886719e+02 -1.2063999938964844e+02 4.0231300354003906e+01 -1.9516999816894531e+02 -1.2080500030517578e+02 3.5033500671386719e+01 -1.9574299621582031e+02 -1.2023500061035156e+02 2.6414699554443359e+01 -1.9806399536132812e+02 -1.2079299926757812e+02 2.2268899917602539e+01 -2.0163301086425781e+02 -1.2029899597167969e+02 1.8799699783325195e+01 -2.2125000000000000e+02 -1.1913199615478516e+02 2.0767700195312500e+01 -2.1643099975585938e+02 -1.2023500061035156e+02 1.7465099334716797e+01 -2.1081001281738281e+02 -1.2028399658203125e+02 1.6277900695800781e+01 -2.0686399841308594e+02 -1.2015499877929688e+02 1.6606901168823242e+01 -1.9875900268554688e+02 -1.1517699432373047e+02 1.5649100303649902e+01 -2.1018699645996094e+02 -1.1482399749755859e+02 1.3853099822998047e+01 -2.0583599853515625e+02 -1.1432799530029297e+02 1.5580499649047852e+01 -2.1615199279785156e+02 -1.1425799560546875e+02 1.6005798339843750e+01 -2.2176599121093750e+02 -1.1402899932861328e+02 1.9876298904418945e+01 -2.2965499877929688e+02 -1.1443199920654297e+02 3.0115800857543945e+01 -2.2680300903320312e+02 -1.1385900115966797e+02 3.3375999450683594e+01 -2.2270600891113281e+02 -1.1443799591064453e+02 4.4073600769042969e+01 -2.1344999694824219e+02 -1.1417900085449219e+02 4.8111400604248047e+01 -2.0464299011230469e+02 -1.1446200561523438e+02 4.7653102874755859e+01 -1.9661199951171875e+02 -1.1466799926757812e+02 4.1622001647949219e+01 -1.9319500732421875e+02 -1.1497100067138672e+02 3.0598999023437500e+01 -1.9386000061035156e+02 -1.1515100097656250e+02 3.8289497375488281e+01 -1.9602200317382812e+02 -1.1461800384521484e+02 2.2572500228881836e+01 -2.2244200134277344e+02 -1.1460399627685547e+02 1.6909898757934570e+01 -2.1550900268554688e+02 -1.1478800201416016e+02 5.0506500244140625e+01 -2.0801399230957031e+02 -1.1495500183105469e+02 5.1357601165771484e+01 -1.9041000366210938e+02 -1.1534899902343750e+02 3.0386600494384766e+01 -2.2937899780273438e+02 -1.1758300018310547e+02 2.9349901199340820e+01 -2.2517399597167969e+02 -1.1764500427246094e+02 1.8826400756835938e+01 -2.2591499328613281e+02 -1.1825700378417969e+02 2.6012599945068359e+01 -2.1803100585937500e+02 -1.1783300018310547e+02 1.3778200149536133e+01 -2.2593901062011719e+02 -1.1832199859619141e+02 3.7242801666259766e+01 -2.1976899719238281e+02 -1.1833300018310547e+02 4.5711700439453125e+01 -2.1099400329589844e+02 -1.1815200042724609e+02 4.9343299865722656e+01 -2.0402600097656250e+02 -1.1815699768066406e+02 4.9808403015136719e+01 -1.9853900146484375e+02 -1.1858399963378906e+02 4.4179698944091797e+01 -1.9418199157714844e+02 -1.1896499633789062e+02 3.6791801452636719e+01 -1.9871099853515625e+02 -1.1872599792480469e+02 1.9561899185180664e+01 -1.9354699707031250e+02 -1.1854600524902344e+02 2.5527500152587891e+01 -2.1460099792480469e+02 -1.1859200286865234e+02 1.5581199645996094e+01 -2.2836399841308594e+02 -1.1759900665283203e+02 4.0394500732421875e+01 -1.9071200561523438e+02 -1.1847299957275391e+02 3.3122100830078125e+01 -2.0494599914550781e+02 -1.1863800048828125e+02 1.5680700302124023e+01 -2.2858299255371094e+02 -1.1433200073242188e+02 3.9564502716064453e+01 -1.9760400390625000e+02 -1.1506999969482422e+02 4.7572502136230469e+01 -2.1519200134277344e+02 -1.1456500244140625e+02 1.2076199531555176e+01 -2.2051499938964844e+02 -1.1788400268554688e+02 4.8816200256347656e+01 -2.0418499755859375e+02 -1.1829900360107422e+02 1.2378600120544434e+01 -1.9387699890136719e+02 -1.1852400207519531e+02 2.0293500900268555e+01 -1.9439500427246094e+02 -1.1850099945068359e+02 4.3936801910400391e+01 -2.2249501037597656e+02 -1.1438600158691406e+02 4.7727001190185547e+01 -2.2914401245117188e+02 -1.1417300415039062e+02 2.4543800354003906e+01 -2.0660200500488281e+02 -1.1474900054931641e+02 1.1798600196838379e+01 -1.9100500488281250e+02 -1.1498100280761719e+02 3.9092498779296875e+01 -1.9212399291992188e+02 -1.1502400207519531e+02 2.2338998794555664e+01 -2.2302799987792969e+02 -1.1330100250244141e+02 1.4478599548339844e+01 -2.1936100769042969e+02 -1.1294499969482422e+02 1.2156700134277344e+01 -2.3080499267578125e+02 -1.1266300201416016e+02 2.5527198791503906e+01 -2.2863499450683594e+02 -1.1316200256347656e+02 2.0672100067138672e+01 -2.3168798828125000e+02 -1.1266300201416016e+02 3.0086599349975586e+01 -2.3162500000000000e+02 -1.1277099609375000e+02 3.3679298400878906e+01 -2.2488899230957031e+02 -1.1282900238037109e+02 4.7557498931884766e+01 -2.2201100158691406e+02 -1.1300099945068359e+02 4.9770599365234375e+01 -2.1430799865722656e+02 -1.1320800018310547e+02 5.2923297882080078e+01 -2.1014199829101562e+02 -1.1318799591064453e+02 5.3386402130126953e+01 -2.0473001098632812e+02 -1.1324299621582031e+02 5.2695301055908203e+01 -2.0074200439453125e+02 -1.1360199737548828e+02 5.1165599822998047e+01 -1.9715000915527344e+02 -1.1313200378417969e+02 4.9090099334716797e+01 -1.9325999450683594e+02 -1.1357700347900391e+02 4.5303298950195312e+01 -1.9096000671386719e+02 -1.1329799652099609e+02 4.1746696472167969e+01 -1.8945098876953125e+02 -1.1336699676513672e+02 3.8203601837158203e+01 -1.8850000000000000e+02 -1.1367900085449219e+02 3.2392700195312500e+01 -1.8900599670410156e+02 -1.1367800140380859e+02 2.7059900283813477e+01 -1.9036300659179688e+02 -1.1330900573730469e+02 2.2988901138305664e+01 -1.9216999816894531e+02 -1.1354299926757812e+02 1.9688699722290039e+01 -1.9506999206542969e+02 -1.1368099975585938e+02 1.6314300537109375e+01 -1.9817799377441406e+02 -1.1346399688720703e+02 1.3717300415039062e+01 -2.0354800415039062e+02 -1.1330500030517578e+02 1.1158400535583496e+01 -2.0832699584960938e+02 -1.1323300170898438e+02 1.0189599990844727e+01 -2.1424398803710938e+02 -1.1331000518798828e+02 1.0542099952697754e+01 -2.2585499572753906e+02 -1.1252400207519531e+02 1.6844600677490234e+01 -2.3070199584960938e+02 -1.1267500305175781e+02 3.8494098663330078e+01 -2.2801100158691406e+02 -1.1284300231933594e+02 4.3826499938964844e+01 -2.1816600036621094e+02 -1.1290500640869141e+02 5.1858200073242188e+01 -2.0921101379394531e+02 -1.1981400299072266e+02 1.0142100334167480e+01 -2.0334300231933594e+02 -1.2022600555419922e+02 1.1241899490356445e+01 -2.1765998840332031e+02 -1.1961699676513672e+02 1.1411600112915039e+01 -2.1311900329589844e+02 -1.1923100280761719e+02 1.0395900726318359e+01 -2.2455400085449219e+02 -1.1948400115966797e+02 1.5449300765991211e+01 -2.2096000671386719e+02 -1.1934899902343750e+02 1.2994100570678711e+01 -2.3093701171875000e+02 -1.1878600311279297e+02 2.5634199142456055e+01 -2.2952200317382812e+02 -1.1936700439453125e+02 2.1769599914550781e+01 -2.3095298767089844e+02 -1.1808799743652344e+02 3.1919900894165039e+01 -2.2312899780273438e+02 -1.1950099945068359e+02 4.9191097259521484e+01 -2.2716600036621094e+02 -1.1931700134277344e+02 4.5269100189208984e+01 -2.1711100769042969e+02 -1.1992300415039062e+02 5.2278400421142578e+01 -2.1974299621582031e+02 -1.1938100433349609e+02 5.1147899627685547e+01 -2.1447299194335938e+02 -1.1817800140380859e+02 5.1635002136230469e+01 -2.0884600830078125e+02 -1.1929199981689453e+02 5.3238601684570312e+01 -2.1282499694824219e+02 -1.1967299652099609e+02 5.3234302520751953e+01 -2.0093399047851562e+02 -1.1944699859619141e+02 5.1142101287841797e+01 -1.8909700012207031e+02 -1.2022399902343750e+02 3.5890899658203125e+01 -1.9043299865722656e+02 -1.2000499725341797e+02 4.0317798614501953e+01 -1.8964700317382812e+02 -1.1980800628662109e+02 2.5571800231933594e+01 -1.8874398803710938e+02 -1.2028700256347656e+02 2.9838298797607422e+01 -1.9125599670410156e+02 -1.2022099304199219e+02 2.1457201004028320e+01 -1.9863400268554688e+02 -1.2005599975585938e+02 1.3502200126647949e+01 -1.9391700744628906e+02 -1.2009500122070312e+02 1.7675298690795898e+01 -2.2718499755859375e+02 -1.1934100341796875e+02 1.8297500610351562e+01 -2.3182901000976562e+02 -1.1929900360107422e+02 2.9566600799560547e+01 -2.3161700439453125e+02 -1.1929400634765625e+02 3.5410198211669922e+01 -2.3013800048828125e+02 -1.1961299896240234e+02 4.0514801025390625e+01 -2.0475000000000000e+02 -1.1994999694824219e+02 5.2682197570800781e+01 -1.9747599792480469e+02 -1.2004200744628906e+02 4.9173900604248047e+01 -1.9344299316406250e+02 -1.2014500427246094e+02 4.5288101196289062e+01 -2.1261599731445312e+02 -1.0404100036621094e+02 5.3998600006103516e+01 -2.1548800659179688e+02 -1.0389900207519531e+02 5.3488197326660156e+01 -2.1817399597167969e+02 -1.0382699584960938e+02 5.2614601135253906e+01 -2.2067100524902344e+02 -1.0384099578857422e+02 5.1425598144531250e+01 -2.2310099792480469e+02 -1.0351100158691406e+02 4.9927200317382812e+01 -2.2527299499511719e+02 -1.0366500091552734e+02 4.8109199523925781e+01 -2.2720399475097656e+02 -1.0360799407958984e+02 4.6050498962402344e+01 -2.2961900329589844e+02 -1.0335200500488281e+02 4.2717697143554688e+01 -2.3125999450683594e+02 -1.0350800323486328e+02 3.8666698455810547e+01 -2.3192800903320312e+02 -1.0352099609375000e+02 3.6033702850341797e+01 -2.3230999755859375e+02 -1.0348100280761719e+02 3.3141399383544922e+01 -2.3232699584960938e+02 -1.0328599548339844e+02 3.0403598785400391e+01 -2.3194999694824219e+02 -1.0357399749755859e+02 2.7570199966430664e+01 -2.3126199340820312e+02 -1.0331500244140625e+02 2.4792098999023438e+01 -2.3025999450683594e+02 -1.0352300262451172e+02 2.2276599884033203e+01 -2.2886100769042969e+02 -1.0337000274658203e+02 1.9701200485229492e+01 -2.2719599914550781e+02 -1.0360500335693359e+02 1.7435598373413086e+01 -2.2532099914550781e+02 -1.0365399932861328e+02 1.5428800582885742e+01 -2.2310000610351562e+02 -1.0370499420166016e+02 1.3590799331665039e+01 -2.2074000549316406e+02 -1.0356699371337891e+02 1.2075400352478027e+01 -2.1817199707031250e+02 -1.0382399749755859e+02 1.0882300376892090e+01 -2.1550401306152344e+02 -1.0389599609375000e+02 1.0014999389648438e+01 -2.1272799682617188e+02 -1.0395700073242188e+02 9.4848299026489258e+00 -2.0990798950195312e+02 -1.0383000183105469e+02 9.2892093658447266e+00 -2.0589500427246094e+02 -1.0414999389648438e+02 9.6467695236206055e+00 -2.0164099121093750e+02 -1.0403200531005859e+02 1.0868499755859375e+01 -1.9909800720214844e+02 -1.0429699707031250e+02 1.2092100143432617e+01 -1.9673199462890625e+02 -1.0434799957275391e+02 1.3592500686645508e+01 -1.9454400634765625e+02 -1.0440800476074219e+02 1.5404000282287598e+01 -1.9261999511718750e+02 -1.0425000000000000e+02 1.7421400070190430e+01 -1.9096900939941406e+02 -1.0449499511718750e+02 1.9737998962402344e+01 -1.8961599731445312e+02 -1.0452199554443359e+02 2.2195199966430664e+01 -1.8855999755859375e+02 -1.0434899902343750e+02 2.4798900604248047e+01 -1.8787799072265625e+02 -1.0456400299072266e+02 2.7565999984741211e+01 -1.8741500854492188e+02 -1.0454299926757812e+02 3.1437999725341797e+01 -1.8788301086425781e+02 -1.0457199859619141e+02 3.5961597442626953e+01 -1.8895399475097656e+02 -1.0456500244140625e+02 3.9838100433349609e+01 -1.9096699523925781e+02 -1.0449299621582031e+02 4.3763500213623047e+01 -1.9263699340820312e+02 -1.0444400024414062e+02 4.6059700012207031e+01 -1.9454798889160156e+02 -1.0420400238037109e+02 4.8128601074218750e+01 -1.9673300170898438e+02 -1.0442800140380859e+02 4.9897903442382812e+01 -1.9911199951171875e+02 -1.0429699707031250e+02 5.1414798736572266e+01 -2.0266799926757812e+02 -1.0423699951171875e+02 5.3023300170898438e+01 -2.0710000610351562e+02 -1.0409799957275391e+02 5.4013500213623047e+01 -2.0995100402832031e+02 -1.0383200073242188e+02 5.4210399627685547e+01 -2.2948100280761719e+02 -1.2862800598144531e+02 1.9711399078369141e+01 -2.3082398986816406e+02 -1.2839199829101562e+02 2.2210100173950195e+01 -2.3185600280761719e+02 -1.2837399291992188e+02 2.4811100006103516e+01 -2.3256201171875000e+02 -1.2835000610351562e+02 2.7563600540161133e+01 -2.3293299865722656e+02 -1.2854600524902344e+02 3.0317998886108398e+01 -2.3282400512695312e+02 -1.2832600402832031e+02 3.4408302307128906e+01 -2.3185899353027344e+02 -1.2836801147460938e+02 3.8678798675537109e+01 -2.3083599853515625e+02 -1.2859700012207031e+02 4.1318199157714844e+01 -2.2946099853515625e+02 -1.2842500305175781e+02 4.3774398803710938e+01 -2.2780500793457031e+02 -1.2847299194335938e+02 4.6057899475097656e+01 -2.2587800598144531e+02 -1.2851100158691406e+02 4.8106700897216797e+01 -2.2372399902343750e+02 -1.2876899719238281e+02 4.9918800354003906e+01 -2.2019799804687500e+02 -1.2867799377441406e+02 5.2062500000000000e+01 -2.0495599365234375e+02 -1.2896800231933594e+02 5.3479297637939453e+01 -2.0771099853515625e+02 -1.2895999145507812e+02 5.4013698577880859e+01 -2.1052500915527344e+02 -1.2908999633789062e+02 5.4210399627685547e+01 -2.1333000183105469e+02 -1.2882398986816406e+02 5.4013698577880859e+01 -2.1609700012207031e+02 -1.2875199890136719e+02 5.3484600067138672e+01 -2.0226599121093750e+02 -1.2928999328613281e+02 5.2635101318359375e+01 -1.9972799682617188e+02 -1.2914801025390625e+02 5.1424102783203125e+01 -1.9731600952148438e+02 -1.2921400451660156e+02 4.9892997741699219e+01 -1.9525900268554688e+02 -1.2921099853515625e+02 4.8172397613525391e+01 -1.9323100280761719e+02 -1.2950999450683594e+02 4.6074901580810547e+01 -1.9157899475097656e+02 -1.2934399414062500e+02 4.3774299621582031e+01 -1.9023999023437500e+02 -1.2938099670410156e+02 4.1332199096679688e+01 -1.8915699768066406e+02 -1.2960900878906250e+02 3.8655502319335938e+01 -1.8841799926757812e+02 -1.2937001037597656e+02 3.5689701080322266e+01 -1.8812899780273438e+02 -1.2943998718261719e+02 3.0324001312255859e+01 -1.8844599914550781e+02 -1.2943299865722656e+02 2.7697900772094727e+01 -1.8918800354003906e+02 -1.2940600585937500e+02 2.4801601409912109e+01 -1.9020399475097656e+02 -1.2938000488281250e+02 2.2241300582885742e+01 -1.9158299255371094e+02 -1.2934899902343750e+02 1.9716300964355469e+01 -1.9320901489257812e+02 -1.2931900024414062e+02 1.7471700668334961e+01 -2.2622000122070312e+02 -1.2840600585937500e+02 1.5745600700378418e+01 -2.2375399780273438e+02 -1.2848899841308594e+02 1.3635499954223633e+01 -2.2135099792480469e+02 -1.2882600402832031e+02 1.2072100639343262e+01 -2.1878500366210938e+02 -1.2869299316406250e+02 1.0887000083923340e+01 -2.1609700012207031e+02 -1.2875300598144531e+02 1.0012900352478027e+01 -2.1333999633789062e+02 -1.2882600402832031e+02 9.4853601455688477e+00 -2.1052700805664062e+02 -1.2908999633789062e+02 9.2895603179931641e+00 -2.0769799804687500e+02 -1.2896400451660156e+02 9.4853601455688477e+00 -2.0494900512695312e+02 -1.2922500610351562e+02 9.9925403594970703e+00 -2.0226300048828125e+02 -1.2909500122070312e+02 1.0883100509643555e+01 -1.9968299865722656e+02 -1.2915399169921875e+02 1.2097800254821777e+01 -1.9733900451660156e+02 -1.2921600341796875e+02 1.3589400291442871e+01 -1.9515899658203125e+02 -1.2926000976562500e+02 1.5396200180053711e+01 -1.8690000915527344e+02 -1.0438800048828125e+02 4.2671100616455078e+01 -1.8469500732421875e+02 -1.0444200134277344e+02 2.8018699645996094e+01 -2.0033299255371094e+02 -1.0406199645996094e+02 5.5399600982666016e+01 -2.3148399353027344e+02 -1.0330500030517578e+02 4.5334400177001953e+01 -1.8688800048828125e+02 -1.2966699218750000e+02 2.2209699630737305e+01 -1.8514199829101562e+02 -1.2970800781250000e+02 3.4052600860595703e+01 -1.9168099975585938e+02 -1.2954998779296875e+02 1.4581899642944336e+01 -2.3414500427246094e+02 -1.2851699829101562e+02 2.2172300338745117e+01 -2.1444000244140625e+02 -1.0372200012207031e+02 5.6839599609375000e+01 -2.0107800292968750e+02 -1.0404600524902344e+02 7.8342499732971191e+00 -2.0775698852539062e+02 -1.0388399505615234e+02 6.3840699195861816e+00 -2.2538200378417969e+02 -1.0345699310302734e+02 5.2022300720214844e+01 -2.3355099487304688e+02 -1.0325500488281250e+02 2.2213300704956055e+01 -2.2874600219726562e+02 -1.0337200164794922e+02 1.4571099281311035e+01 -1.8919000244140625e+02 -1.0433300018310547e+02 1.6905199050903320e+01 -2.3290499877929688e+02 -1.0327199554443359e+02 4.2752098083496094e+01 -2.1587300109863281e+02 -1.0368999481201172e+02 6.9621801376342773e+00 -2.1203100585937500e+02 -1.2905099487304688e+02 5.7195701599121094e+01 -2.0024800109863281e+02 -1.2933898925781250e+02 5.5078102111816406e+01 -2.2477099609375000e+02 -1.2874400329589844e+02 1.0608900070190430e+01 -2.1047900390625000e+02 -1.2909199523925781e+02 6.2534799575805664e+00 -1.8897099304199219e+02 -1.2961399841308594e+02 4.5357601165771484e+01 -2.3030599975585938e+02 -1.2861000061035156e+02 4.7821998596191406e+01 -2.0165100097656250e+02 -1.2930200195312500e+02 7.8535704612731934e+00 -2.3546501159667969e+02 -1.2848300170898438e+02 3.7007202148437500e+01 -2.2084201049804688e+02 -1.2883999633789062e+02 5.5064296722412109e+01 -1.8711199951171875e+02 -1.1692299652099609e+02 4.0941902160644531e+01 -1.8499000549316406e+02 -1.0469100189208984e+02 3.7009601593017578e+01 -1.9466899108886719e+02 -1.1674199676513672e+02 5.1138698577880859e+01 -1.9392900085449219e+02 -1.0441500091552734e+02 5.1551498413085938e+01 -1.9705499267578125e+02 -1.0438700103759766e+02 5.3753299713134766e+01 -2.0193299865722656e+02 -1.1670999908447266e+02 5.5197200775146484e+01 -2.0543199157714844e+02 -1.0419300079345703e+02 5.6836200714111328e+01 -2.3404299926757812e+02 -1.0350199890136719e+02 3.9938697814941406e+01 -2.3533700561523438e+02 -1.0338299560546875e+02 3.3689300537109375e+01 -2.3505599975585938e+02 -1.1568699645996094e+02 3.2824199676513672e+01 -2.2657099914550781e+02 -1.0368299865722656e+02 1.2464300155639648e+01 -2.2747200012207031e+02 -1.1587699890136719e+02 1.3856900215148926e+01 -2.1880799865722656e+02 -1.0394400024414062e+02 7.8717498779296875e+00 -2.2045800781250000e+02 -1.1590499877929688e+02 9.0979900360107422e+00 -2.2171199035644531e+02 -1.0374200439453125e+02 9.1812000274658203e+00 -2.0386799621582031e+02 -1.0422599792480469e+02 6.9919199943542480e+00 -2.0795899963378906e+02 -1.1643000030517578e+02 6.9988398551940918e+00 -1.8648100280761719e+02 -1.1733199310302734e+02 2.4436698913574219e+01 -1.8591099548339844e+02 -1.0469999694824219e+02 2.3176099777221680e+01 -1.8450999450683594e+02 -1.0469199371337891e+02 3.3570301055908203e+01 -1.8532800292968750e+02 -1.1706999969482422e+02 3.2014499664306641e+01 -1.9027999877929688e+02 -1.0449700164794922e+02 4.8004299163818359e+01 -2.0890901184082031e+02 -1.0411199951171875e+02 5.7232101440429688e+01 -2.1764401245117188e+02 -1.0388100433349609e+02 5.6047599792480469e+01 -2.2016300964355469e+02 -1.0383799743652344e+02 5.5081901550292969e+01 -2.2764599609375000e+02 -1.0365500640869141e+02 5.0050197601318359e+01 -2.2954499816894531e+02 -1.0369300079345703e+02 4.7961997985839844e+01 -2.3538301086425781e+02 -1.0346700286865234e+02 3.1020601272583008e+01 -2.3511199951171875e+02 -1.0347299957275391e+02 2.7974401473999023e+01 -2.3445700073242188e+02 -1.0347499847412109e+02 2.4872400283813477e+01 -2.3231799316406250e+02 -1.0361699676513672e+02 1.9654600143432617e+01 -2.3058999633789062e+02 -1.0357900238037109e+02 1.6852399826049805e+01 -2.1273899841308594e+02 -1.0400099945068359e+02 6.4136400222778320e+00 -1.9846800231933594e+02 -1.0447399902343750e+02 9.0195503234863281e+00 -1.9568299865722656e+02 -1.0443299865722656e+02 1.0615799903869629e+01 -1.9296600341796875e+02 -1.0448799896240234e+02 1.2704100608825684e+01 -1.9113899230957031e+02 -1.0454299926757812e+02 1.4529299736022949e+01 -1.8748899841308594e+02 -1.0461399841308594e+02 1.9639900207519531e+01 -1.9216400146484375e+02 -1.0459099578857422e+02 5.0018703460693359e+01 -2.1141799926757812e+02 -1.0420899963378906e+02 5.7180999755859375e+01 -2.0993200683593750e+02 -1.0424500274658203e+02 6.2752399444580078e+00 -1.8532499694824219e+02 -1.2944799804687500e+02 2.7975099563598633e+01 -1.8594900512695312e+02 -1.2942599487304688e+02 2.5023700714111328e+01 -1.8820401000976562e+02 -1.2938000488281250e+02 1.9461299896240234e+01 -1.8981900024414062e+02 -1.2933500671386719e+02 1.6895401000976562e+01 -1.9387100219726562e+02 -1.2924798583984375e+02 1.2466600418090820e+01 -1.9891799926757812e+02 -1.2916299438476562e+02 9.0664596557617188e+00 -2.0752200317382812e+02 -1.2896099853515625e+02 6.4432597160339355e+00 -2.1352400207519531e+02 -1.2876300048828125e+02 6.4470200538635254e+00 -2.1649800109863281e+02 -1.2868798828125000e+02 6.9787502288818359e+00 -2.1936799621582031e+02 -1.2861900329589844e+02 7.8539299964904785e+00 -2.2212600708007812e+02 -1.2856100463867188e+02 9.0699796676635742e+00 -2.2717300415039062e+02 -1.2843699645996094e+02 1.2472899436950684e+01 -2.2930499267578125e+02 -1.2839099121093750e+02 1.4541899681091309e+01 -2.3122300720214844e+02 -1.2833300781250000e+02 1.6902400970458984e+01 -2.3510499572753906e+02 -1.2830899047851562e+02 2.5057600021362305e+01 -2.3598300170898438e+02 -1.2821699523925781e+02 3.0958499908447266e+01 -2.3589299011230469e+02 -1.2822500610351562e+02 3.3986198425292969e+01 -2.3463800048828125e+02 -1.2825599670410156e+02 3.9938400268554688e+01 -2.3352299499511719e+02 -1.2828799438476562e+02 4.2691497802734375e+01 -2.2826300048828125e+02 -1.2840800476074219e+02 5.0033100128173828e+01 -2.2596899414062500e+02 -1.2846000671386719e+02 5.2010398864746094e+01 -2.2348300170898438e+02 -1.2851699829101562e+02 5.3687198638916016e+01 -2.1798100280761719e+02 -1.2865798950195312e+02 5.6111598968505859e+01 -2.1502499389648438e+02 -1.2872500610351562e+02 5.6830902099609375e+01 -2.0600500488281250e+02 -1.2894599914550781e+02 5.6829200744628906e+01 -2.0304598999023438e+02 -1.2902000427246094e+02 5.6107101440429688e+01 -1.9755200195312500e+02 -1.2915100097656250e+02 5.3684398651123047e+01 -1.9281600952148438e+02 -1.2931999206542969e+02 5.0079200744628906e+01 -1.9075199890136719e+02 -1.2931900024414062e+02 4.7820198059082031e+01 -1.8668099975585938e+02 -1.2926701354980469e+02 4.0777603149414062e+01 -1.8558900451660156e+02 -1.2943998718261719e+02 3.6991199493408203e+01 -2.0453800964355469e+02 -1.2882299804687500e+02 6.9870300292968750e+00 -1.9506298828125000e+02 -1.2893499755859375e+02 5.1993701934814453e+01 -2.0903498840332031e+02 -1.2879000854492188e+02 5.7181198120117188e+01 -2.3569400024414062e+02 -1.2794799804687500e+02 2.7989599227905273e+01 -1.9629100036621094e+02 -1.2910800170898438e+02 1.0615900039672852e+01 -2.3205200195312500e+02 -1.2824000549316406e+02 4.5356399536132812e+01 -2.3281700134277344e+02 -1.2822100830078125e+02 1.9436399459838867e+01 -2.1441799926757812e+02 -1.1632999420166016e+02 5.6252700805664062e+01 -2.1843400573730469e+02 -1.1631099700927734e+02 5.5217098236083984e+01 -2.2041799926757812e+02 -1.1618500518798828e+02 5.4321800231933594e+01 -2.2233801269531250e+02 -1.1613799285888672e+02 5.3453399658203125e+01 -2.2582699584960938e+02 -1.1606000518798828e+02 5.1096000671386719e+01 -2.2883898925781250e+02 -1.1608200073242188e+02 4.8230201721191406e+01 -2.3138099670410156e+02 -1.1591799926757812e+02 4.4784400939941406e+01 -2.3325900268554688e+02 -1.1580500030517578e+02 4.1081398010253906e+01 -2.3451300048828125e+02 -1.1584200286865234e+02 3.6987499237060547e+01 -2.3486900329589844e+02 -1.1583300018310547e+02 2.8592300415039062e+01 -2.3398800659179688e+02 -1.1587500000000000e+02 2.4486299514770508e+01 -2.3245700073242188e+02 -1.1599499511718750e+02 2.0628999710083008e+01 -2.3019999694824219e+02 -1.1594699859619141e+02 1.6967199325561523e+01 -2.2413499450683594e+02 -1.1609400177001953e+02 1.1153000831604004e+01 -2.1647999572753906e+02 -1.1627999877929688e+02 7.6918601989746094e+00 -2.1235600280761719e+02 -1.1641500091552734e+02 6.9796400070190430e+00 -2.1021800231933594e+02 -1.1643200683593750e+02 6.9792299270629883e+00 -2.0395500183105469e+02 -1.1658499908447266e+02 7.6918601989746094e+00 -1.9998500061035156e+02 -1.1677099609375000e+02 9.0837497711181641e+00 -1.9630099487304688e+02 -1.1676999664306641e+02 1.1153000831604004e+01 -1.9302099609375000e+02 -1.1671099853515625e+02 1.3788900375366211e+01 -1.9023600769042969e+02 -1.1691799926757812e+02 1.6967199325561523e+01 -1.8804399108886719e+02 -1.1702000427246094e+02 2.0518699645996094e+01 -1.8556599426269531e+02 -1.1703099822998047e+02 2.8592300415039062e+01 -1.8565499877929688e+02 -1.1702899932861328e+02 3.4896297454833984e+01 -1.8592298889160156e+02 -1.1702299499511719e+02 3.6987499237060547e+01 -1.8905499267578125e+02 -1.1694700622558594e+02 4.4784400939941406e+01 -1.9160600280761719e+02 -1.1663899993896484e+02 4.8241897583007812e+01 -1.9809700012207031e+02 -1.1672700500488281e+02 5.3453399658203125e+01 -2.0601800537109375e+02 -1.1653500366210938e+02 5.6252700805664062e+01 -2.1016600036621094e+02 -1.1634300231933594e+02 5.6617000579833984e+01 -2.0877299499511719e+02 -1.0546900177001953e+02 7.0446296691894531e+01 -2.1141600036621094e+02 -1.1574900054931641e+02 7.0446899414062500e+01 -2.1457099914550781e+02 -1.0581000518798828e+02 7.0446899414062500e+01 -2.1508300781250000e+02 -1.2688599395751953e+02 7.0446899414062500e+01 -2.0961601257324219e+02 -1.2703299713134766e+02 7.0447494506835938e+01 -2.0070399475097656e+02 -1.3168199157714844e+02 3.9378898620605469e+01 -2.0811300659179688e+02 -1.3150199890136719e+02 3.4847698211669922e+01 -2.0070399475097656e+02 -1.3168199157714844e+02 6.6001899719238281e+01 -2.1554400634765625e+02 -1.3132099914550781e+02 6.6001899719238281e+01 -2.1267700195312500e+02 -1.3139100646972656e+02 3.5504299163818359e+01 -2.0633601379394531e+02 -1.3154501342773438e+02 3.0123300552368164e+01 -2.0376899719238281e+02 -1.3160699462890625e+02 2.7607400894165039e+01 -2.0985299682617188e+02 -1.3145999145507812e+02 2.3911199569702148e+01 -2.1133399963378906e+02 -1.3142399597167969e+02 2.7670299530029297e+01 -2.1822099304199219e+02 -1.3125599670410156e+02 3.2358097076416016e+01 -2.1470800781250000e+02 -1.3134199523925781e+02 3.0542999267578125e+01 -2.1787899780273438e+02 -1.3126499938964844e+02 2.9176700592041016e+01 -2.1519100952148438e+02 -1.3133000183105469e+02 2.5533700942993164e+01 -2.1267298889160156e+02 -1.0141100311279297e+02 2.8319000244140625e+01 -2.0852799987792969e+02 -1.0151100158691406e+02 2.3989898681640625e+01 -2.0740798950195312e+02 -1.0153800201416016e+02 2.8400400161743164e+01 -1.9997599792480469e+02 -1.0171900177001953e+02 3.9378898620605469e+01 -2.0561399841308594e+02 -1.0158200073242188e+02 3.2452800750732422e+01 -2.0300399780273438e+02 -1.0164499664306641e+02 2.7817501068115234e+01 -2.1700199890136719e+02 -1.0130500030517578e+02 2.8787401199340820e+01 -2.1412199401855469e+02 -1.0137500000000000e+02 2.5294500350952148e+01 -2.1309399414062500e+02 -1.0140000152587891e+02 3.4598297119140625e+01 -2.1481600952148438e+02 -1.0135799407958984e+02 6.6001899719238281e+01 -2.1749299621582031e+02 -1.0129299926757812e+02 3.2358097076416016e+01 -2.0897300720214844e+02 -1.0150000000000000e+02 3.5612800598144531e+01 -1.9997599792480469e+02 -1.0171900177001953e+02 6.6001899719238281e+01 -2.0771400451660156e+02 -9.9625106811523438e+01 2.7995599746704102e+01 -2.0566500854492188e+02 -9.9674797058105469e+01 3.1925100326538086e+01 -2.0299400329589844e+02 -9.9739700317382812e+01 2.7607400894165039e+01 -2.0907899475097656e+02 -9.9591903686523438e+01 2.3911199569702148e+01 -2.1225500488281250e+02 -9.9514701843261719e+01 2.8400400161743164e+01 -2.1441699218750000e+02 -9.9462203979492188e+01 2.5533700942993164e+01 -1.9992999267578125e+02 -9.9814201354980469e+01 3.9378597259521484e+01 -2.1477000427246094e+02 -9.9453598022460938e+01 6.6001899719238281e+01 -2.1190199279785156e+02 -9.9523200988769531e+01 3.5504299163818359e+01 -2.1744699096679688e+02 -9.9388595581054688e+01 3.2358097076416016e+01 -2.0733900451660156e+02 -9.9634201049804688e+01 3.4847698211669922e+01 -1.9977799987792969e+02 -9.9815597534179688e+01 6.6231803894042969e+01 -2.1710499572753906e+02 -9.9396896362304688e+01 2.9176700592041016e+01 -2.1404400634765625e+02 -9.9470802307128906e+01 3.1641698837280273e+01 -2.0714900207519531e+02 -1.0492599487304688e+02 7.2365203857421875e+01 -2.1439099121093750e+02 -1.0463800048828125e+02 7.2344100952148438e+01 -2.1128199768066406e+02 -1.1508000183105469e+02 7.2351905822753906e+01 -2.0949099731445312e+02 -1.2733900451660156e+02 7.2352203369140625e+01 -2.1493099975585938e+02 -1.2689000701904297e+02 7.2351905822753906e+01 -2.0075000000000000e+02 -1.3358599853515625e+02 3.9378597259521484e+01 -2.0690299987792969e+02 -1.3343699645996094e+02 3.3511001586914062e+01 -2.0377799987792969e+02 -1.3351300048828125e+02 2.7817501068115234e+01 -2.0694999694824219e+02 -1.3343598937988281e+02 2.9817699432373047e+01 -2.0987699890136719e+02 -1.3336401367187500e+02 2.7670299530029297e+01 -2.1414401245117188e+02 -1.3326100158691406e+02 2.9276401519775391e+01 -2.1282101440429688e+02 -1.3329299926757812e+02 2.4328199386596680e+01 -2.0829499816894531e+02 -1.3340299987792969e+02 2.4371500015258789e+01 -2.1382200622558594e+02 -1.3326899719238281e+02 3.4627899169921875e+01 -2.1559100341796875e+02 -1.3322601318359375e+02 6.6001899719238281e+01 -2.1826699829101562e+02 -1.3316099548339844e+02 3.2358097076416016e+01 -2.1732800292968750e+02 -1.3318299865722656e+02 2.7617599487304688e+01 -2.0974699401855469e+02 -1.3336799621582031e+02 3.5612800598144531e+01 -2.0075000000000000e+02 -1.3358599853515625e+02 6.6001899719238281e+01 -1.7505699157714844e+02 -1.3024101257324219e+02 6.8443496704101562e+01 -1.7530999755859375e+02 -1.3298300170898438e+02 6.8303695678710938e+01 -1.7848500061035156e+02 -1.3286900329589844e+02 6.5027198791503906e+01 -1.7883099365234375e+02 -1.3520500183105469e+02 6.4728599548339844e+01 -1.8213999938964844e+02 -1.3454000854492188e+02 6.1297901153564453e+01 -1.8194400024414062e+02 -1.3648500061035156e+02 6.1542900085449219e+01 -1.8459799194335938e+02 -1.3516299438476562e+02 5.8767398834228516e+01 -1.8450999450683594e+02 -1.3708299255371094e+02 5.8906600952148438e+01 -1.8651499938964844e+02 -1.3541899108886719e+02 5.6792598724365234e+01 -1.8649501037597656e+02 -1.3732800292968750e+02 5.6861198425292969e+01 -1.8844898986816406e+02 -1.3547299194335938e+02 5.4795997619628906e+01 -1.8849499511718750e+02 -1.3737800598144531e+02 5.4795997619628906e+01 -1.9037699890136719e+02 -1.3532499694824219e+02 5.2799301147460938e+01 -1.9049000549316406e+02 -1.3723100280761719e+02 5.2730697631835938e+01 -1.9227999877929688e+02 -1.3497599792480469e+02 5.0824600219726562e+01 -1.9246099853515625e+02 -1.3688899230957031e+02 5.0685302734375000e+01 -1.9413499450683594e+02 -1.3443000793457031e+02 4.8893299102783203e+01 -1.9438900756835938e+02 -1.3635600280761719e+02 4.8679500579833984e+01 -1.9592399597167969e+02 -1.3369299316406250e+02 4.7026702880859375e+01 -1.9625599670410156e+02 -1.3563699340820312e+02 4.6732601165771484e+01 -1.9806100463867188e+02 -1.3249899291992188e+02 4.4787899017333984e+01 -1.9977499389648438e+02 -1.3373799133300781e+02 4.3057399749755859e+01 -1.9957800292968750e+02 -1.3181500244140625e+02 4.3330402374267578e+01 -1.6967498779296875e+02 -1.1937699890136719e+02 6.9113403320312500e+01 -1.6811099243164062e+02 -1.2146099853515625e+02 6.9113403320312500e+01 -1.7057000732421875e+02 -1.2313500213623047e+02 6.9113403320312500e+01 -1.6936300659179688e+02 -1.2525500488281250e+02 6.9113403320312500e+01 -1.7249600219726562e+02 -1.2715199279785156e+02 6.9117797851562500e+01 -1.7170199584960938e+02 -1.2933500671386719e+02 6.9161300659179688e+01 -1.7180700683593750e+02 -1.0808300018310547e+02 6.9114402770996094e+01 -1.7113900756835938e+02 -1.0543800354003906e+02 6.9145698547363281e+01 -1.7029200744628906e+02 -1.1171800231933594e+02 6.9113403320312500e+01 -1.6898399353027344e+02 -1.0965900421142578e+02 6.9113403320312500e+01 -1.6958099365234375e+02 -1.1551499938964844e+02 6.9113403320312500e+01 -1.6791699218750000e+02 -1.1350999450683594e+02 6.9113403320312500e+01 -1.6762300109863281e+02 -1.1749500274658203e+02 6.9113403320312500e+01 -1.7679899597167969e+02 -9.9901199340820312e+01 6.6025802612304688e+01 -1.7415100097656250e+02 -1.0466200256347656e+02 6.8681900024414062e+01 -1.7748500061035156e+02 -1.0177300262451172e+02 6.5290603637695312e+01 -1.7974400329589844e+02 -9.8363098144531250e+01 6.2859298706054688e+01 -1.8117601013183594e+02 -9.9801506042480469e+01 6.1415901184082031e+01 -1.8161100769042969e+02 -9.7643699645996094e+01 6.0912399291992188e+01 -1.8353900146484375e+02 -9.7110595703125000e+01 5.8906600952148438e+01 -1.8371998596191406e+02 -9.9023902893066406e+01 5.8767398834228516e+01 -1.8550999450683594e+02 -9.6769104003906250e+01 5.6861198425292969e+01 -1.8562300109863281e+02 -9.8675102233886719e+01 5.6792598724365234e+01 -1.8750500488281250e+02 -9.6622497558593750e+01 5.4795997619628906e+01 -1.8755101013183594e+02 -9.8526901245117188e+01 5.4795997619628906e+01 -1.8950498962402344e+02 -9.6672103881835938e+01 5.2730697631835938e+01 -1.8948500061035156e+02 -9.8581199645996094e+01 5.2799301147460938e+01 -1.9148999023437500e+02 -9.6917503356933594e+01 5.0685302734375000e+01 -1.9140200805664062e+02 -9.8837303161621094e+01 5.0824600219726562e+01 -1.9344100952148438e+02 -9.7356201171875000e+01 4.8679500579833984e+01 -1.9328199768066406e+02 -9.9292396545410156e+01 4.8893299102783203e+01 -1.9534201049804688e+02 -9.7984901428222656e+01 4.6730701446533203e+01 -1.9510400390625000e+02 -9.9941406250000000e+01 4.7026702880859375e+01 -1.9883399963378906e+02 -9.9656898498535156e+01 4.3169898986816406e+01 -1.9729701232910156e+02 -1.0102999877929688e+02 4.4787899017333984e+01 -1.9881199645996094e+02 -1.0163800048828125e+02 4.3404197692871094e+01 -1.9929000854492188e+02 -1.3399099731445312e+02 6.6001899719238281e+01 -1.7688999938964844e+02 -1.3412399291992188e+02 7.8878501892089844e+01 -1.7300799560546875e+02 -1.3079800415039062e+02 7.8867401123046875e+01 -1.8016400146484375e+02 -1.3581700134277344e+02 7.8003402709960938e+01 -1.8565400695800781e+02 -1.3724800109863281e+02 7.8003402709960938e+01 -1.8294200134277344e+02 -1.3674398803710938e+02 7.8978393554687500e+01 -1.8849598693847656e+02 -1.3737599182128906e+02 7.8853698730468750e+01 -1.9896000671386719e+02 -1.3417999267578125e+02 7.8957702636718750e+01 -1.9996600341796875e+02 -1.3354699707031250e+02 6.6992698669433594e+01 -1.9624499511718750e+02 -1.3560899353027344e+02 7.8003402709960938e+01 -1.9409300231933594e+02 -1.3645201110839844e+02 7.8003402709960938e+01 -1.9132600402832031e+02 -1.3711000061035156e+02 7.8003402709960938e+01 -2.0232099914550781e+02 -1.3154699707031250e+02 7.8797698974609375e+01 -2.0169999694824219e+02 -1.3217300415039062e+02 7.0164703369140625e+01 -2.0570899963378906e+02 -1.2687000274658203e+02 7.9493202209472656e+01 -2.0549600219726562e+02 -1.2766500091552734e+02 7.4745201110839844e+01 -2.0458500671386719e+02 -1.0507199859619141e+02 7.8535400390625000e+01 -2.0560699462890625e+02 -1.0613999938964844e+02 7.4543899536132812e+01 -2.0716099548339844e+02 -1.1032099914550781e+02 7.9426994323730469e+01 -2.0846900939941406e+02 -1.1512899780273438e+02 7.4943901062011719e+01 -2.0838299560546875e+02 -1.1598400115966797e+02 7.8564598083496094e+01 -2.0791499328613281e+02 -1.2120199584960938e+02 7.8964096069335938e+01 -2.0801399230957031e+02 -1.2163099670410156e+02 7.4080101013183594e+01 -2.0116600036621094e+02 -1.0148099517822266e+02 7.8956199645996094e+01 -1.9752799987792969e+02 -9.8971595764160156e+01 7.8466598510742188e+01 -1.9871200561523438e+02 -9.9658401489257812e+01 6.8486900329589844e+01 -2.0096600341796875e+02 -1.0124800109863281e+02 7.0172798156738281e+01 -1.9532400512695312e+02 -9.8023597717285156e+01 7.8003402709960938e+01 -1.9450399780273438e+02 -9.7682106018066406e+01 7.8003402709960938e+01 -1.9176899719238281e+02 -9.6969100952148438e+01 7.8854400634765625e+01 -1.8869000244140625e+02 -9.6620796203613281e+01 7.8957397460937500e+01 -1.8608500671386719e+02 -9.6706703186035156e+01 7.8003402709960938e+01 -1.8327899169921875e+02 -9.7170700073242188e+01 7.8003402709960938e+01 -1.7362600708007812e+02 -1.0254599761962891e+02 6.8737503051757812e+01 -1.7676800537109375e+02 -9.9954200744628906e+01 7.8883300781250000e+01 -1.7350000000000000e+02 -1.0268399810791016e+02 7.8863304138183594e+01 -1.8057699584960938e+02 -9.8012496948242188e+01 7.8983795166015625e+01 -1.7068899536132812e+02 -1.0610300445556641e+02 7.8445701599121094e+01 -1.6850199890136719e+02 -1.1100099945068359e+02 7.8619499206542969e+01 -1.6756300354003906e+02 -1.1701100158691406e+02 7.8769294738769531e+01 -1.6801100158691406e+02 -1.2098500061035156e+02 7.8498199462890625e+01 -1.6927899169921875e+02 -1.2528400421142578e+02 7.8278495788574219e+01 -1.9232000732421875e+02 -1.0380799865722656e+02 8.0289398193359375e+01 -1.9140400695800781e+02 -9.8587104797363281e+01 8.0287300109863281e+01 -1.9795599365234375e+02 -1.0732699584960938e+02 8.0289398193359375e+01 -2.0257400512695312e+02 -1.0664600372314453e+02 8.0289398193359375e+01 -1.8696199035644531e+02 -1.3084300231933594e+02 8.0289398193359375e+01 -1.9162500000000000e+02 -1.3030700683593750e+02 8.0289398193359375e+01 -1.8927400207519531e+02 -1.3569100952148438e+02 8.0287597656250000e+01 -2.0131100463867188e+02 -1.1306100463867188e+02 8.0289398193359375e+01 -2.0695401000976562e+02 -1.1701799774169922e+02 8.0283599853515625e+01 -2.0161700439453125e+02 -1.1969900512695312e+02 8.0289398193359375e+01 -1.9640299987792969e+02 -1.2805000305175781e+02 8.0289398193359375e+01 -1.9805200195312500e+02 -1.3298599243164062e+02 8.0286697387695312e+01 -1.9953800964355469e+02 -1.2455700683593750e+02 8.0289398193359375e+01 -1.7601800537109375e+02 -1.2400999450683594e+02 8.0289398193359375e+01 -1.8064799499511719e+02 -1.2877499389648438e+02 8.0289398193359375e+01 -1.7437300109863281e+02 -1.3031199645996094e+02 8.0285697937011719e+01 -1.7438299560546875e+02 -1.1430100250244141e+02 8.0289398193359375e+01 -1.7155799865722656e+02 -1.1079800415039062e+02 8.0289398193359375e+01 -1.7646199035644531e+02 -1.0944300079345703e+02 8.0289398193359375e+01 -1.7959700012207031e+02 -1.0594999694824219e+02 8.0289398193359375e+01 -1.8569500732421875e+02 -1.0331100463867188e+02 8.0289398193359375e+01 -1.8186999511718750e+02 -9.9189292907714844e+01 8.0285400390625000e+01 -1.7435299682617188e+02 -1.1899500274658203e+02 8.0289398193359375e+01 -1.6950100708007812e+02 -1.2264299774169922e+02 8.0264503479003906e+01 -1.7331900024414062e+02 -1.2822100830078125e+02 7.8236801147460938e+01 -1.7171099853515625e+02 -1.2578199768066406e+02 7.8384101867675781e+01 -1.7029600524902344e+02 -1.2220600128173828e+02 7.8120002746582031e+01 -1.6954800415039062e+02 -1.1839900207519531e+02 7.8383605957031250e+01 -1.6958099365234375e+02 -1.1551499938964844e+02 7.8196197509765625e+01 -1.7000999450683594e+02 -1.1266400146484375e+02 7.8383903503417969e+01 -1.7330400085449219e+02 -1.0576000213623047e+02 7.8383605957031250e+01 -1.7135900878906250e+02 -1.0902199554443359e+02 7.8115798950195312e+01 -1.7531999206542969e+02 -1.0355799865722656e+02 7.8235000610351562e+01 -1.8086900329589844e+02 -9.9930000305175781e+01 7.8384506225585938e+01 -1.7837500000000000e+02 -1.0122699737548828e+02 7.8384101867675781e+01 -1.8371998596191406e+02 -9.9023902893066406e+01 7.8003402709960938e+01 -1.8562300109863281e+02 -9.8675102233886719e+01 7.8003402709960938e+01 -1.8755101013183594e+02 -9.8526901245117188e+01 7.8003402709960938e+01 -1.9782899475097656e+02 -1.0131300354003906e+02 7.8383995056152344e+01 -1.9860200500488281e+02 -1.0183899688720703e+02 6.9791000366210938e+01 -1.9510400390625000e+02 -9.9941406250000000e+01 7.8003402709960938e+01 -1.9328199768066406e+02 -9.9292396545410156e+01 7.8003402709960938e+01 -1.9140200805664062e+02 -9.8837303161621094e+01 7.8003402709960938e+01 -1.8948500061035156e+02 -9.8581199645996094e+01 7.8003402709960938e+01 -2.0318399047851562e+02 -1.0593399810791016e+02 7.4267295837402344e+01 -2.0136499023437500e+02 -1.0414900207519531e+02 7.8084602355957031e+01 -2.0478999328613281e+02 -1.0913999938964844e+02 7.8384201049804688e+01 -2.0602600097656250e+02 -1.1286100006103516e+02 7.5353103637695312e+01 -2.0645600891113281e+02 -1.1876499938964844e+02 7.8384201049804688e+01 -2.0651699829101562e+02 -1.1952300262451172e+02 7.4579002380371094e+01 -2.0494599914550781e+02 -1.2449300384521484e+02 7.7422599792480469e+01 -2.0075898742675781e+02 -1.3041000366210938e+02 7.4685600280761719e+01 -2.0305099487304688e+02 -1.2783600616455078e+02 7.8197700500488281e+01 -1.9605400085449219e+02 -1.3363499450683594e+02 7.8384300231933594e+01 -1.9867298889160156e+02 -1.3215998840332031e+02 6.6001899719238281e+01 -1.9986399841308594e+02 -1.3130999755859375e+02 6.8038002014160156e+01 -1.7680099487304688e+02 -1.3171499633789062e+02 7.8384201049804688e+01 -1.7992900085449219e+02 -1.3364799499511719e+02 7.8383605957031250e+01 -1.8459799194335938e+02 -1.3516299438476562e+02 7.8003402709960938e+01 -1.8651499938964844e+02 -1.3541899108886719e+02 7.8003402709960938e+01 -1.8844898986816406e+02 -1.3547299194335938e+02 7.8003402709960938e+01 -1.9037699890136719e+02 -1.3532499694824219e+02 7.8384201049804688e+01 -1.9227999877929688e+02 -1.3497599792480469e+02 7.8003402709960938e+01 -1.9413499450683594e+02 -1.3443000793457031e+02 7.8003402709960938e+01 -1.8963800048828125e+02 -1.0321500396728516e+02 7.8384399414062500e+01 -1.8155500793457031e+02 -1.0452300262451172e+02 7.8384399414062500e+01 -1.7569200134277344e+02 -1.1057999420166016e+02 7.8384399414062500e+01 -1.7404800415039062e+02 -1.1860199737548828e+02 7.8384399414062500e+01 -1.7861900329589844e+02 -1.2745100402832031e+02 7.8384399414062500e+01 -1.8636199951171875e+02 -1.3078500366210938e+02 7.8384399414062500e+01 -1.9162500000000000e+02 -1.3030700683593750e+02 7.8384399414062500e+01 -1.9591499328613281e+02 -1.2840400695800781e+02 7.8384399414062500e+01 -2.0030799865722656e+02 -1.2341999816894531e+02 7.8384399414062500e+01 -2.0188200378417969e+02 -1.1696399688720703e+02 7.8384399414062500e+01 -1.9961000061035156e+02 -1.0909799957275391e+02 7.8384399414062500e+01 -1.9411100769042969e+02 -1.0463500213623047e+02 7.8384399414062500e+01 -2.1526300048828125e+02 -1.3002600097656250e+02 6.9145004272460938e+01 -2.1511801147460938e+02 -1.3061900329589844e+02 7.1139099121093750e+01 -2.1515100097656250e+02 -1.2858599853515625e+02 7.0108505249023438e+01 -2.1500399780273438e+02 -1.2885099792480469e+02 7.2041099548339844e+01 -2.1455599975585938e+02 -1.0410899353027344e+02 7.0108505249023438e+01 -2.1540100097656250e+02 -1.3098600769042969e+02 6.7702896118164062e+01 -2.1542199707031250e+02 -1.3291299438476562e+02 6.7968002319335938e+01 -2.1526400756835938e+02 -1.3202099609375000e+02 6.9734298706054688e+01 -2.1442500305175781e+02 -1.0208000183105469e+02 7.1139099121093750e+01 -2.1459800720214844e+02 -1.0266600036621094e+02 6.9145004272460938e+01 -2.1450300598144531e+02 -1.0067299652099609e+02 6.9734298706054688e+01 -2.1468899536132812e+02 -1.0169999694824219e+02 6.7702896118164062e+01 -2.1458599853515625e+02 -9.9779502868652344e+01 6.7965904235839844e+01 -2.0503500366210938e+02 -1.3055400085449219e+02 7.1471801757812500e+01 -2.0453298950195312e+02 -1.0257700347900391e+02 7.1375099182128906e+01 -1.9616999816894531e+02 -9.9061103820800781e+01 7.9887199401855469e+01 -2.0453498840332031e+02 -1.0662899780273438e+02 7.9936401367187500e+01 -1.7336100769042969e+02 -1.0434999847412109e+02 8.0023300170898438e+01 -1.6949099731445312e+02 -1.1090499877929688e+02 7.9994300842285156e+01 -1.9268899536132812e+02 -1.3633599853515625e+02 7.9599502563476562e+01 -1.8036599731445312e+02 -1.3513000488281250e+02 7.9844100952148438e+01 -2.0761099243164062e+02 -1.2658999633789062e+02 7.2844200134277344e+01 -2.0914100646972656e+02 -1.1320800018310547e+02 7.3207298278808594e+01 -2.0702600097656250e+02 -1.2785198974609375e+02 7.0653404235839844e+01 -2.0323300170898438e+02 -1.3005900573730469e+02 6.9508598327636719e+01 -1.9941200256347656e+02 -1.0170699310302734e+02 6.6471298217773438e+01 -2.0272700500488281e+02 -1.0200600433349609e+02 6.7865997314453125e+01 -2.0213299560546875e+02 -1.0306400299072266e+02 6.9332099914550781e+01 -2.0588800048828125e+02 -1.0613899993896484e+02 7.1145103454589844e+01 -2.0949000549316406e+02 -1.1362200164794922e+02 7.0763900756835938e+01 -2.0953700256347656e+02 -1.2013899993896484e+02 7.0779396057128906e+01 -2.0747500610351562e+02 -1.1980200195312500e+02 7.2373703002929688e+01 -2.0479998779296875e+02 -1.2635600280761719e+02 7.2847900390625000e+01 -2.0702000427246094e+02 -1.1230800628662109e+02 7.2377601623535156e+01 -1.9299900817871094e+02 -1.1297499847412109e+02 8.4716903686523438e+01 -1.9717399597167969e+02 -1.1223900604248047e+02 8.4728004455566406e+01 -1.8943800354003906e+02 -1.1070299530029297e+02 8.4715698242187500e+01 -1.9441000366210938e+02 -1.1668199920654297e+02 8.4716903686523438e+01 -1.9809100341796875e+02 -1.1860100555419922e+02 8.4721405029296875e+01 -1.9337300109863281e+02 -1.2051100158691406e+02 8.4716903686523438e+01 -1.9131599426269531e+02 -1.2241600036621094e+02 8.4716903686523438e+01 -1.8831799316406250e+02 -1.2341000366210938e+02 8.4716903686523438e+01 -1.9105300903320312e+02 -1.2687900543212891e+02 8.4726295471191406e+01 -1.8746099853515625e+02 -1.0676599884033203e+02 8.4725402832031250e+01 -1.8529400634765625e+02 -1.1123600006103516e+02 8.4716903686523438e+01 -1.8220999145507812e+02 -1.0856800079345703e+02 8.4724502563476562e+01 -1.8448899841308594e+02 -1.2237300109863281e+02 8.4716903686523438e+01 -1.8200199890136719e+02 -1.1928299713134766e+02 8.4716903686523438e+01 -1.8062199401855469e+02 -1.2410800170898438e+02 8.4726104736328125e+01 -1.8180499267578125e+02 -1.1532099914550781e+02 8.4716903686523438e+01 -1.7802900695800781e+02 -1.1934700012207031e+02 8.4729995727539062e+01 -1.8317300415039062e+02 -1.1287400054931641e+02 8.4716903686523438e+01 -1.8692700195312500e+02 -1.3697099304199219e+02 8.9314102172851562e+01 -1.8812500000000000e+02 -1.3837799072265625e+02 8.8973800659179688e+01 -1.7958299255371094e+02 -1.3508599853515625e+02 8.9444305419921875e+01 -1.6808200073242188e+02 -1.1796999359130859e+02 8.9316001892089844e+01 -1.7030900573730469e+02 -1.2680800628662109e+02 8.9491096496582031e+01 -1.6582099914550781e+02 -1.1895500183105469e+02 8.8357200622558594e+01 -1.6602101135253906e+02 -1.1392500305175781e+02 8.8439895629882812e+01 -1.7238800048828125e+02 -1.0459500122070312e+02 8.9315895080566406e+01 -1.6901899719238281e+02 -1.1088899993896484e+02 8.9316001892089844e+01 -1.7030699157714844e+02 -1.0523200225830078e+02 8.9060203552246094e+01 -1.8442900085449219e+02 -9.7383003234863281e+01 8.9315696716308594e+01 -1.7775599670410156e+02 -9.9890899658203125e+01 8.9406402587890625e+01 -1.8533801269531250e+02 -9.4965599060058594e+01 8.8426597595214844e+01 -1.9221099853515625e+02 -9.6372100830078125e+01 8.9124595642089844e+01 -2.0070899963378906e+02 -1.0160599517822266e+02 8.9443305969238281e+01 -1.9332400512695312e+02 -9.7649497985839844e+01 8.9314399719238281e+01 -2.0424899291992188e+02 -1.0187899780273438e+02 8.8381797790527344e+01 -2.0537400817871094e+02 -1.0718299865722656e+02 8.9371101379394531e+01 -2.0770700073242188e+02 -1.1384300231933594e+02 8.9444000244140625e+01 -2.0892601013183594e+02 -1.0961100006103516e+02 8.8346397399902344e+01 -2.0998899841308594e+02 -1.2056800079345703e+02 8.8326995849609375e+01 -2.0481201171875000e+02 -1.2773999786376953e+02 8.9316703796386719e+01 -2.0752301025390625e+02 -1.2111100006103516e+02 8.9316802978515625e+01 -2.0827899169921875e+02 -1.2606600189208984e+02 8.8330406188964844e+01 -2.0285099792480469e+02 -1.3247599792480469e+02 8.8956604003906250e+01 -1.9385499572753906e+02 -1.3613099670410156e+02 8.9711700439453125e+01 -1.9993600463867188e+02 -1.3298300170898438e+02 8.9316703796386719e+01 -1.9958000183105469e+02 -9.7951896667480469e+01 8.8092994689941406e+01 -1.7767300415039062e+02 -9.7348197937011719e+01 8.8139495849609375e+01 -1.7440399169921875e+02 -9.9346099853515625e+01 8.7999404907226562e+01 -1.7929800415039062e+02 -1.3695100402832031e+02 8.8675994873046875e+01 -1.7245700073242188e+02 -1.2972299194335938e+02 8.9558197021484375e+01 -1.8931399536132812e+02 -1.3925399780273438e+02 8.7594894409179688e+01 -1.9612799072265625e+02 -1.3776699829101562e+02 8.7712600708007812e+01 -2.0619400024414062e+02 -1.2977699279785156e+02 8.7812599182128906e+01 -1.9465998840332031e+02 -9.5798698425292969e+01 8.7795097351074219e+01 -1.8909600830078125e+02 -9.4752799987792969e+01 8.7633804321289062e+01 -1.6721800231933594e+02 -1.0911700439453125e+02 8.7826103210449219e+01 -1.6674899291992188e+02 -1.2360700225830078e+02 8.7870101928710938e+01 -1.6852499389648438e+02 -1.2769399261474609e+02 8.7805999755859375e+01 -1.7213999938964844e+02 -1.3266700744628906e+02 8.7654396057128906e+01 -2.0289500427246094e+02 -1.3359800720214844e+02 8.7561798095703125e+01 -2.0993800354003906e+02 -1.1300499725341797e+02 8.7303001403808594e+01 -2.0720100402832031e+02 -1.0569300079345703e+02 8.7327697753906250e+01 -1.8125300598144531e+02 -9.5750801086425781e+01 8.7309394836425781e+01 -1.6960800170898438e+02 -1.0440100097656250e+02 8.7540000915527344e+01 -1.7780200195312500e+02 -1.3682901000976562e+02 8.7543395996093750e+01 -1.8427499389648438e+02 -1.3893099975585938e+02 8.7515197753906250e+01 -1.7822900390625000e+02 -1.1308200073242188e+02 8.4858596801757812e+01 -1.8468600463867188e+02 -1.2693099975585938e+02 8.4941398620605469e+01 -1.9651699829101562e+02 -1.2327600097656250e+02 8.5010902404785156e+01 -1.9344200134277344e+02 -1.0613100433349609e+02 8.6479202270507812e+01 -1.8542399597167969e+02 -1.3907499694824219e+02 8.1694297790527344e+01 -1.8172999572753906e+02 -1.3832199096679688e+02 8.1694297790527344e+01 -1.7821699523925781e+02 -1.3695600891113281e+02 8.1694297790527344e+01 -1.7498500061035156e+02 -1.3501599121093750e+02 8.1694297790527344e+01 -1.7212800598144531e+02 -1.3255700683593750e+02 8.1694297790527344e+01 -1.6972700500488281e+02 -1.2965100097656250e+02 8.1694297790527344e+01 -1.6785200500488281e+02 -1.2638099670410156e+02 8.1694297790527344e+01 -1.6655599975585938e+02 -1.2284100341796875e+02 8.1694297790527344e+01 -1.6587799072265625e+02 -1.1913300323486328e+02 8.1694297790527344e+01 -1.6583499145507812e+02 -1.1536299896240234e+02 8.1694297790527344e+01 -1.6643099975585938e+02 -1.1164099884033203e+02 8.1694297790527344e+01 -1.6764700317382812e+02 -1.0807300567626953e+02 8.1694297790527344e+01 -1.6944799804687500e+02 -1.0476200103759766e+02 8.1694297790527344e+01 -1.7178300476074219e+02 -1.0180200195312500e+02 8.1694297790527344e+01 -1.7458500671386719e+02 -9.9280197143554688e+01 8.1694297790527344e+01 -1.7777299499511719e+02 -9.7267997741699219e+01 8.1694297790527344e+01 -1.8125500488281250e+02 -9.5823303222656250e+01 8.1694297790527344e+01 -1.8492999267578125e+02 -9.4988006591796875e+01 8.1694297790527344e+01 -1.8869499206542969e+02 -9.4785804748535156e+01 8.1694297790527344e+01 -1.9243901062011719e+02 -9.5222801208496094e+01 8.1694297790527344e+01 -1.9605499267578125e+02 -9.6286201477050781e+01 8.1694297790527344e+01 -1.9944000244140625e+02 -9.7945495605468750e+01 8.1694297790527344e+01 -2.0249600219726562e+02 -1.0015299987792969e+02 8.1694297790527344e+01 -2.0513400268554688e+02 -1.0284500122070312e+02 8.1694297790527344e+01 -2.0727999877929688e+02 -1.0594400024414062e+02 8.1694297790527344e+01 -2.0887100219726562e+02 -1.0936199951171875e+02 8.1694297790527344e+01 -2.0986199951171875e+02 -1.1299900054931641e+02 8.1694297790527344e+01 -2.1022399902343750e+02 -1.1675099945068359e+02 8.1694297790527344e+01 -2.0994599914550781e+02 -1.2051100158691406e+02 8.1694297790527344e+01 -2.0903700256347656e+02 -1.2416899871826172e+02 8.1694297790527344e+01 -2.0752301025390625e+02 -1.2762099456787109e+02 8.1694297790527344e+01 -2.0544700622558594e+02 -1.3076800537109375e+02 8.1694297790527344e+01 -2.0286900329589844e+02 -1.3351799011230469e+02 8.1694297790527344e+01 -1.9986399841308594e+02 -1.3579400634765625e+02 8.1694297790527344e+01 -1.9651699829101562e+02 -1.3752799987792969e+02 8.1694297790527344e+01 -1.9292500305175781e+02 -1.3867199707031250e+02 8.1694297790527344e+01 -1.8919200134277344e+02 -1.3919299316406250e+02 8.1694297790527344e+01 -1.8483599853515625e+02 -1.0294499969482422e+02 8.8517997741699219e+01 -1.7913900756835938e+02 -1.0636500549316406e+02 8.8095596313476562e+01 -1.7492898559570312e+02 -1.1110099792480469e+02 8.8520301818847656e+01 -1.7375700378417969e+02 -1.1867699432373047e+02 8.8506896972656250e+01 -1.7635899353027344e+02 -1.2546700286865234e+02 8.8504699707031250e+01 -1.8139299011230469e+02 -1.2964500427246094e+02 8.8527801513671875e+01 -1.8547700500488281e+02 -1.3099501037597656e+02 8.8483001708984375e+01 -1.9272000122070312e+02 -1.3067098999023438e+02 8.8479103088378906e+01 -2.0083000183105469e+02 -1.2385799407958984e+02 8.8563102722167969e+01 -2.0223001098632812e+02 -1.1419899749755859e+02 8.8520896911621094e+01 -1.9850599670410156e+02 -1.0737500000000000e+02 8.8524002075195312e+01 -1.9190501403808594e+02 -1.0329999542236328e+02 8.8520301818847656e+01 -1.9762899780273438e+02 -9.7818099975585938e+01 8.1694297790527344e+01 -1.9415199279785156e+02 -9.6437500000000000e+01 8.1694297790527344e+01 -1.9048799133300781e+02 -9.5681602478027344e+01 8.1694297790527344e+01 -1.8674800109863281e+02 -9.5573501586914062e+01 8.1694297790527344e+01 -1.8142601013183594e+02 -9.6472900390625000e+01 8.1702598571777344e+01 -1.7474900817871094e+02 -1.0000400543212891e+02 8.1698402404785156e+01 -1.6970899963378906e+02 -1.0561700439453125e+02 8.1692596435546875e+01 -1.6743800354003906e+02 -1.1084799957275391e+02 8.1694297790527344e+01 -1.6643800354003906e+02 -1.1640399932861328e+02 8.1705101013183594e+01 -1.6711700439453125e+02 -1.2195400238037109e+02 8.1694297790527344e+01 -1.6829399108886719e+02 -1.2550499725341797e+02 8.1694297790527344e+01 -1.7007000732421875e+02 -1.2879798889160156e+02 8.1694297790527344e+01 -1.7368099975585938e+02 -1.3308799743652344e+02 8.1699806213378906e+01 -1.7990599060058594e+02 -1.3697299194335938e+02 8.1698593139648438e+01 -1.8728799438476562e+02 -1.3853199768066406e+02 8.1692504882812500e+01 -1.9295401000976562e+02 -1.3788299560546875e+02 8.1694297790527344e+01 -1.9806900024414062e+02 -1.3605599975585938e+02 8.1701499938964844e+01 -2.0273199462890625e+02 -1.3260899353027344e+02 8.1694297790527344e+01 -2.0521800231933594e+02 -1.2981399536132812e+02 8.1694297790527344e+01 -2.0718200683593750e+02 -1.2662899780273438e+02 8.1694297790527344e+01 -2.0912100219726562e+02 -1.2138700103759766e+02 8.1706001281738281e+01 -2.0930700683593750e+02 -1.1386000061035156e+02 8.1700492858886719e+01 -2.0770600891113281e+02 -1.0849499511718750e+02 8.1694297790527344e+01 -2.0490100097656250e+02 -1.0365100097656250e+02 8.1700599670410156e+01 -2.0081399536132812e+02 -9.9781600952148438e+01 8.1694297790527344e+01 -1.9555500793457031e+02 -1.3450700378417969e+02 8.8532905578613281e+01 -1.7955101013183594e+02 -1.3374400329589844e+02 8.8532501220703125e+01 -1.8911399841308594e+02 -1.3846400451660156e+02 8.6222198486328125e+01 -1.9517399597167969e+02 -1.3715399169921875e+02 8.6243896484375000e+01 -1.9970700073242188e+02 -1.3501599121093750e+02 8.6105804443359375e+01 -2.0462701416015625e+02 -1.3070201110839844e+02 8.6072303771972656e+01 -2.0753100585937500e+02 -1.2581800079345703e+02 8.6293601989746094e+01 -2.0930599975585938e+02 -1.1993999481201172e+02 8.5219100952148438e+01 -2.0945300292968750e+02 -1.1562100219726562e+02 8.5820396423339844e+01 -2.0813800048828125e+02 -1.0956600189208984e+02 8.5738800048828125e+01 -2.0569500732421875e+02 -1.0475000000000000e+02 8.5789199829101562e+01 -2.0072099304199219e+02 -9.9754997253417969e+01 8.6433898925781250e+01 -1.9745899963378906e+02 -9.7680000305175781e+01 8.5834800720214844e+01 -1.8838000488281250e+02 -9.5333999633789062e+01 8.5689498901367188e+01 -1.7843901062011719e+02 -9.7743499755859375e+01 8.6281097412109375e+01 -1.7249800109863281e+02 -1.0201100158691406e+02 8.5630401611328125e+01 -1.6866099548339844e+02 -1.0751899719238281e+02 8.5144104003906250e+01 -1.6664500427246094e+02 -1.1461199951171875e+02 8.6110198974609375e+01 -1.6709999084472656e+02 -1.2170600128173828e+02 8.6420295715332031e+01 -1.6825700378417969e+02 -1.2560700225830078e+02 8.5136505126953125e+01 -1.7127000427246094e+02 -1.3030200195312500e+02 8.6624801635742188e+01 -1.7481900024414062e+02 -1.3394300842285156e+02 8.6355400085449219e+01 -1.8151300048828125e+02 -1.3763900756835938e+02 8.5635993957519531e+01 -1.9868899536132812e+02 -1.0147499847412109e+02 8.8537002563476562e+01 -1.8202400207519531e+02 -9.9089302062988281e+01 8.8525398254394531e+01 -1.7402101135253906e+02 -1.0470300292968750e+02 8.8541801452636719e+01 -1.6917199707031250e+02 -1.1526499938964844e+02 8.8490798950195312e+01 -1.7137399291992188e+02 -1.2652500152587891e+02 8.8495094299316406e+01 -2.0671800231933594e+02 -1.1221099853515625e+02 8.8418899536132812e+01 -2.0534400939941406e+02 -1.2578499603271484e+02 8.8264801025390625e+01 -2.0817098999023438e+02 -1.2073999786376953e+02 8.7560699462890625e+01 -1.7345799255371094e+02 -1.0285299682617188e+02 8.7676506042480469e+01 -1.6965701293945312e+02 -1.0784000396728516e+02 8.7504096984863281e+01 -2.0468499755859375e+02 -1.0596700286865234e+02 8.7817901611328125e+01 -1.9360700988769531e+02 -9.7800003051757812e+01 8.7847900390625000e+01 -1.8629400634765625e+02 -9.6937599182128906e+01 8.7861999511718750e+01 -1.8360699462890625e+02 -1.3649900817871094e+02 8.7908699035644531e+01 -1.8182499694824219e+02 -1.1847999572753906e+02 9.2074996948242188e+01 -1.6808099365234375e+02 -1.1789499664306641e+02 9.2074996948242188e+01 -1.8166999816894531e+02 -1.1649900054931641e+02 9.2074996948242188e+01 -1.6824198913574219e+02 -1.1432400512695312e+02 9.2074996948242188e+01 -1.8213400268554688e+02 -1.1456800079345703e+02 9.2074996948242188e+01 -1.9386599731445312e+02 -1.1943199920654297e+02 9.2074996948242188e+01 -1.9433000183105469e+02 -1.1750099945068359e+02 9.2074996948242188e+01 -2.0743901062011719e+02 -1.2143699645996094e+02 9.2074996948242188e+01 -1.8770800781250000e+02 -1.2337700653076172e+02 9.2074996948242188e+01 -1.8269599914550781e+02 -1.3621998596191406e+02 9.2074996948242188e+01 -1.8556800842285156e+02 -1.2286599731445312e+02 9.2074996948242188e+01 -1.7783099365234375e+02 -1.3423300170898438e+02 9.2074996948242188e+01 -1.8387399291992188e+02 -1.2182699584960938e+02 9.2074996948242188e+01 -1.8948001098632812e+02 -1.2317500305175781e+02 9.2074996948242188e+01 -1.8791600036621094e+02 -1.3708900451660156e+02 9.2074996948242188e+01 -2.0555900573730469e+02 -1.2661199188232422e+02 9.2074996948242188e+01 -1.9282699584960938e+02 -1.2112600708007812e+02 9.2074996948242188e+01 -2.0105799865722656e+02 -1.3217199707031250e+02 9.2074996948242188e+01 -1.9131599426269531e+02 -1.2241600036621094e+02 9.2074996948242188e+01 -1.9417500305175781e+02 -1.1552000427246094e+02 9.2074996948242188e+01 -2.0775898742675781e+02 -1.1432400512695312e+02 9.2074996948242188e+01 -2.0791900634765625e+02 -1.1789499664306641e+02 9.2074996948242188e+01 -1.9212600708007812e+02 -1.1217299652099609e+02 9.2074996948242188e+01 -2.0358900451660156e+02 -1.0456800079345703e+02 9.2074996948242188e+01 -1.9341600036621094e+02 -1.1368399810791016e+02 9.2074996948242188e+01 -2.0555799865722656e+02 -1.0755200195312500e+02 9.2074996948242188e+01 -2.0696299743652344e+02 -1.1083900451660156e+02 9.2074996948242188e+01 -1.8258399963378906e+02 -1.2031600189208984e+02 9.2074996948242188e+01 -1.6911299133300781e+02 -1.2313699340820312e+02 9.2074996948242188e+01 -1.7246800231933594e+02 -1.2962399291992188e+02 9.2074996948242188e+01 -1.9488899230957031e+02 -1.3579400634765625e+02 9.2074996948242188e+01 -1.9043199157714844e+02 -1.1113400268554688e+02 9.2074996948242188e+01 -1.9822700500488281e+02 -9.9883399963378906e+01 9.2074996948242188e+01 -2.0111900329589844e+02 -1.0198500061035156e+02 9.2074996948242188e+01 -1.8850100708007812e+02 -1.1066999816894531e+02 9.2074996948242188e+01 -1.9343499755859375e+02 -9.7734504699707031e+01 9.2074996948242188e+01 -1.8468399047851562e+02 -1.1158399963378906e+02 9.2074996948242188e+01 -1.8099400329589844e+02 -9.8332397460937500e+01 9.2074996948242188e+01 -1.8651998901367188e+02 -1.1082500457763672e+02 9.2074996948242188e+01 -1.8444000244140625e+02 -9.7381401062011719e+01 9.2074996948242188e+01 -1.8800000000000000e+02 -9.7060997009277344e+01 9.2074996948242188e+01 -1.8317300415039062e+02 -1.1287400054931641e+02 9.2074996948242188e+01 -1.7488099670410156e+02 -1.0198500061035156e+02 9.2074996948242188e+01 -1.7777299499511719e+02 -9.9883399963378906e+01 9.2074996948242188e+01 -1.6903700256347656e+02 -1.1083900451660156e+02 9.2074996948242188e+01 -1.7139999389648438e+02 -1.0581600189208984e+02 9.2074996948242188e+01 -1.9433000183105469e+02 -1.1750099945068359e+02 1.0518900299072266e+02 -1.9386599731445312e+02 -1.1943199920654297e+02 1.0518900299072266e+02 -1.8651998901367188e+02 -1.1082500457763672e+02 1.0518900299072266e+02 -1.9212600708007812e+02 -1.1217299652099609e+02 1.0518900299072266e+02 -1.9341600036621094e+02 -1.1368399810791016e+02 1.0518900299072266e+02 -1.9417500305175781e+02 -1.1552000427246094e+02 1.0518900299072266e+02 -1.9282699584960938e+02 -1.2112600708007812e+02 1.0518900299072266e+02 -1.9131599426269531e+02 -1.2241600036621094e+02 1.0518900299072266e+02 -1.8948001098632812e+02 -1.2317500305175781e+02 1.0518900299072266e+02 -1.8182499694824219e+02 -1.1847999572753906e+02 1.0518900299072266e+02 -1.8771299743652344e+02 -1.2337999725341797e+02 1.0518900299072266e+02 -1.8258399963378906e+02 -1.2031600189208984e+02 1.0518900299072266e+02 -1.8556800842285156e+02 -1.2286599731445312e+02 1.0518900299072266e+02 -1.8387399291992188e+02 -1.2182699584960938e+02 1.0518900299072266e+02 -1.8166999816894531e+02 -1.1649900054931641e+02 1.0518900299072266e+02 -1.8213400268554688e+02 -1.1456800079345703e+02 1.0518900299072266e+02 -1.8317300415039062e+02 -1.1287400054931641e+02 1.0518900299072266e+02 -1.8468399047851562e+02 -1.1158399963378906e+02 1.0518900299072266e+02 -1.9043199157714844e+02 -1.1113400268554688e+02 1.0518900299072266e+02 -1.8850100708007812e+02 -1.1066999816894531e+02 1.0518900299072266e+02 -1.8651998901367188e+02 -1.1082500457763672e+02 7.7972892761230469e+01 -1.8369599914550781e+02 -1.1223900604248047e+02 7.7972892761230469e+01 -1.8171900939941406e+02 -1.1567799377441406e+02 7.7972892761230469e+01 -1.8214199829101562e+02 -1.1962200164794922e+02 7.7972892761230469e+01 -1.8389099121093750e+02 -1.2184600067138672e+02 7.8166702270507812e+01 -1.8556800842285156e+02 -1.2286599731445312e+02 7.7972892761230469e+01 -1.8868400573730469e+02 -1.2338200378417969e+02 7.7972892761230469e+01 -1.9230400085449219e+02 -1.2176100158691406e+02 7.7972892761230469e+01 -1.9386300659179688e+02 -1.1944699859619141e+02 7.8114898681640625e+01 -1.9433000183105469e+02 -1.1750099945068359e+02 7.7972892761230469e+01 -1.9385800170898438e+02 -1.1437699890136719e+02 7.7972892761230469e+01 -1.9119801330566406e+02 -1.1143500518798828e+02 7.7972892761230469e+01 -1.8850100708007812e+02 -1.1066999816894531e+02 7.7972892761230469e+01 -1.8691099548339844e+02 -1.0761299896240234e+02 7.4908401489257812e+01 -1.8715899658203125e+02 -1.1868399810791016e+02 7.3908905029296875e+01 -1.9372500610351562e+02 -1.1079999542236328e+02 7.4193405151367188e+01 -1.9650999450683594e+02 -1.1910200500488281e+02 7.4148696899414062e+01 -1.8663200378417969e+02 -1.2600499725341797e+02 7.4176696777343750e+01 -1.7891099548339844e+02 -1.1957599639892578e+02 7.4911994934082031e+01 -1.8029800415039062e+02 -1.1177600097656250e+02 7.4644897460937500e+01 -1.9407800292968750e+02 -1.2425199890136719e+02 7.6419700622558594e+01 -1.9440299987792969e+02 -1.1000900268554688e+02 7.6345397949218750e+01 -1.9753399658203125e+02 -1.1684700012207031e+02 7.6594703674316406e+01 -1.8725498962402344e+02 -1.2640200805664062e+02 7.6535598754882812e+01 -1.8230099487304688e+02 -1.2414500427246094e+02 7.6871704101562500e+01 -1.7950500488281250e+02 -1.1785300445556641e+02 7.7778800964355469e+01 -1.8178599548339844e+02 -1.1127700042724609e+02 7.7772697448730469e+01 -1.8834100341796875e+02 -1.0850299835205078e+02 7.7835296630859375e+01 -1.9064498901367188e+02 -1.2501700592041016e+02 7.7848098754882812e+01 -1.9555899047851562e+02 -1.1453499603271484e+02 7.7947998046875000e+01 -1.8646299743652344e+02 -1.0683900451660156e+02 8.5700401306152344e+01 -1.9303601074218750e+02 -1.0828099822998047e+02 8.5489601135253906e+01 -1.8113200378417969e+02 -1.0981500244140625e+02 8.5493293762207031e+01 -1.9499600219726562e+02 -1.2434700012207031e+02 8.5677993774414062e+01 -1.8950801086425781e+02 -1.2693700408935547e+02 8.5498100280761719e+01 -1.9757699584960938e+02 -1.1958999633789062e+02 8.5487800598144531e+01 -1.8363699340820312e+02 -1.2625700378417969e+02 8.5723403930664062e+01 -1.8028500366210938e+02 -1.2316699981689453e+02 8.5492698669433594e+01 -1.7662799072265625e+02 -1.1263500213623047e+02 8.7639999389648438e+01 -1.7807200622558594e+02 -1.1863099670410156e+02 8.5494300842285156e+01 -1.9230400085449219e+02 -1.2176100158691406e+02 8.5478904724121094e+01 -1.8779699707031250e+02 -1.2359099578857422e+02 8.5478904724121094e+01 -1.9453700256347656e+02 -1.1725000000000000e+02 8.5478904724121094e+01 -1.9756700134277344e+02 -1.1378200531005859e+02 8.5499801635742188e+01 -1.9341600036621094e+02 -1.1368399810791016e+02 8.5478904724121094e+01 -1.9025799560546875e+02 -1.1086100006103516e+02 8.5478904724121094e+01 -1.8537800598144531e+02 -1.1114199829101562e+02 8.5478904724121094e+01 -1.8170599365234375e+02 -1.1878199768066406e+02 8.5478904724121094e+01 -1.8213400268554688e+02 -1.1456800079345703e+02 8.5478904724121094e+01 -1.8317300415039062e+02 -1.1287400054931641e+02 8.5478904724121094e+01 -1.8387399291992188e+02 -1.2182699584960938e+02 8.5478904724121094e+01 -1.8565000915527344e+02 -1.0312999725341797e+02 8.9309402465820312e+01 -1.7888600158691406e+02 -1.0621099853515625e+02 8.9310897827148438e+01 -1.7409800720214844e+02 -1.1527200317382812e+02 8.9309997558593750e+01 -1.7474200439453125e+02 -1.2057700347900391e+02 8.9031501770019531e+01 -1.7712800598144531e+02 -1.2583699798583984e+02 8.9305801391601562e+01 -1.8185000610351562e+02 -1.2918099975585938e+02 8.8902198791503906e+01 -1.8723799133300781e+02 -1.3095100402832031e+02 8.9311897277832031e+01 -1.9400500488281250e+02 -1.2978500366210938e+02 8.9311103820800781e+01 -1.9857099914550781e+02 -1.2612600708007812e+02 8.9310806274414062e+01 -2.0042900085449219e+02 -1.2226599884033203e+02 8.8895797729492188e+01 -2.0172900390625000e+02 -1.1767700195312500e+02 8.9036499023437500e+01 -2.0086500549316406e+02 -1.1267500305175781e+02 8.8927200317382812e+01 -1.9778999328613281e+02 -1.0669200134277344e+02 8.9307701110839844e+01 -1.9080899047851562e+02 -1.0331299591064453e+02 8.9310806274414062e+01 -2.0193600463867188e+02 -1.1272700500488281e+02 8.9314300537109375e+01 -1.9043199157714844e+02 -1.1113400268554688e+02 8.9314300537109375e+01 -1.8850100708007812e+02 -1.1066999816894531e+02 8.9314300537109375e+01 -1.9371299743652344e+02 -1.1381399536132812e+02 8.9314300537109375e+01 -1.9433000183105469e+02 -1.1750099945068359e+02 8.9314300537109375e+01 -1.9386599731445312e+02 -1.1943199920654297e+02 8.9314300537109375e+01 -1.9282699584960938e+02 -1.2112600708007812e+02 8.9314300537109375e+01 -1.8387399291992188e+02 -1.2182699584960938e+02 8.9314300537109375e+01 -1.8258399963378906e+02 -1.2031600189208984e+02 8.9314300537109375e+01 -1.8920199584960938e+02 -1.2347499847412109e+02 8.9314300537109375e+01 -1.8556800842285156e+02 -1.2286599731445312e+02 8.9314300537109375e+01 -1.8182499694824219e+02 -1.1847999572753906e+02 8.9314300537109375e+01 -1.8166999816894531e+02 -1.1649900054931641e+02 8.9314300537109375e+01 -1.8320399475097656e+02 -1.1255100250244141e+02 8.9314300537109375e+01 -1.8651998901367188e+02 -1.1082500457763672e+02 8.9314300537109375e+01 1.5939900207519531e+02 -9.3463302612304688e+01 2.7293098449707031e+01 1.5903599548339844e+02 -9.3445098876953125e+01 3.5564098358154297e+01 1.7366400146484375e+02 -9.3802696228027344e+01 2.7968799591064453e+01 1.7326100158691406e+02 -9.3797294616699219e+01 3.6213302612304688e+01 1.6672599792480469e+02 -9.3641601562500000e+01 2.3525598526000977e+01 1.6593200683593750e+02 -9.4226699829101562e+01 3.9989700317382812e+01 1.7353599548339844e+02 -9.9117301940917969e+01 2.7968000411987305e+01 1.7314599609375000e+02 -9.9107803344726562e+01 3.6207698822021484e+01 1.6581700134277344e+02 -9.8929801940917969e+01 3.9989700317382812e+01 1.5887899780273438e+02 -9.8761199951171875e+01 3.5531902313232422e+01 1.5926901245117188e+02 -9.8770698547363281e+01 2.7292200088500977e+01 1.6659700012207031e+02 -9.8948699951171875e+01 2.3510299682617188e+01 1.7218199157714844e+02 -9.9084396362304688e+01 2.8340600967407227e+01 1.6504199218750000e+02 -9.8910896301269531e+01 2.5140199661254883e+01 1.5969400024414062e+02 -9.8780998229980469e+01 3.3363700866699219e+01 1.6464300537109375e+02 -9.8901199340820312e+01 3.8276901245117188e+01 1.7128099060058594e+02 -9.9062500000000000e+01 3.6141700744628906e+01 1.6034300231933594e+02 -9.9346099853515625e+01 2.8371000289916992e+01 1.7302699279785156e+02 -9.9740196228027344e+01 3.2520397186279297e+01 1.6833700561523438e+02 -9.9626197814941406e+01 2.5212200164794922e+01 1.6110198974609375e+02 -9.9450500488281250e+01 3.6123600006103516e+01 1.6773199462890625e+02 -9.9611602783203125e+01 3.8282402038574219e+01 1.6407499694824219e+02 -1.3921099853515625e+02 2.8042800903320312e+01 1.6703199768066406e+02 -1.3927699279785156e+02 3.5248199462890625e+01 1.6209899902343750e+02 -1.3912400817871094e+02 3.4134399414062500e+01 1.6916101074218750e+02 -1.3931800842285156e+02 3.1915601730346680e+01 1.7009599304199219e+02 -9.9668998718261719e+01 3.1250499725341797e+01 1.7003099060058594e+02 -9.9667396545410156e+01 3.2616298675537109e+01 1.6950300598144531e+02 -9.9654602050781250e+01 3.3877601623535156e+01 1.6857600402832031e+02 -9.9632102966308594e+01 3.4882198333740234e+01 1.6736100769042969e+02 -9.9602600097656250e+01 3.5509098052978516e+01 1.6600599670410156e+02 -9.9569595336914062e+01 3.5682598114013672e+01 1.6467199707031250e+02 -9.9537200927734375e+01 3.5381702423095703e+01 1.6352200317382812e+02 -9.9509300231933594e+01 3.4642799377441406e+01 1.6269400024414062e+02 -9.9489196777343750e+01 3.3555000305175781e+01 1.6288000488281250e+02 -9.9493698120117188e+01 2.9622400283813477e+01 1.6380700683593750e+02 -9.9516197204589844e+01 2.8617700576782227e+01 1.6502200317382812e+02 -9.9545700073242188e+01 2.7990900039672852e+01 1.6637800598144531e+02 -9.9578697204589844e+01 2.7817399978637695e+01 1.6771099853515625e+02 -9.9611000061035156e+01 2.8118200302124023e+01 1.6228799438476562e+02 -9.9479301452636719e+01 3.2249500274658203e+01 1.6235198974609375e+02 -9.9480895996093750e+01 3.0883699417114258e+01 1.6886199951171875e+02 -9.9638999938964844e+01 2.8857101440429688e+01 1.6969000244140625e+02 -9.9659103393554688e+01 2.9944999694824219e+01 1.6575300598144531e+02 -1.3819099426269531e+02 3.5655101776123047e+01 1.6438800048828125e+02 -1.3815798950195312e+02 3.5590499877929688e+01 1.6312699890136719e+02 -1.3812799072265625e+02 3.5062599182128906e+01 1.6149600219726562e+02 -1.3808799743652344e+02 3.2919998168945312e+01 1.6132199096679688e+02 -1.3808399963378906e+02 3.1563798904418945e+01 1.6162300109863281e+02 -1.3809100341796875e+02 3.0230001449584961e+01 1.6236199951171875e+02 -1.3810899353027344e+02 2.9079500198364258e+01 1.6344900512695312e+02 -1.3813499450683594e+02 2.8251201629638672e+01 1.6475399780273438e+02 -1.3816699218750000e+02 2.7844799041748047e+01 1.6611999511718750e+02 -1.3819999694824219e+02 2.7909500122070312e+01 1.6738099670410156e+02 -1.3823098754882812e+02 2.8437400817871094e+01 1.6838499450683594e+02 -1.3825500488281250e+02 2.9364799499511719e+01 1.6875199890136719e+02 -1.3826400756835938e+02 2.9944999694824219e+01 1.6901199340820312e+02 -1.3827000427246094e+02 3.0579900741577148e+01 1.6888499450683594e+02 -1.3826699829101562e+02 3.3270000457763672e+01 1.6814599609375000e+02 -1.3824899291992188e+02 3.4420402526855469e+01 1.7174600219726562e+02 -1.3373098754882812e+02 2.8100399017333984e+01 1.7078700256347656e+02 -1.3978700256347656e+02 2.9380100250244141e+01 1.6803100585937500e+02 -1.3949699401855469e+02 2.6224498748779297e+01 1.7172099304199219e+02 -1.3365800476074219e+02 3.5413002014160156e+01 1.7072099304199219e+02 -1.3972200012207031e+02 3.4165699005126953e+01 1.6733300781250000e+02 -1.3953300476074219e+02 3.7611499786376953e+01 1.6212600708007812e+02 -1.3786799621582031e+02 2.6076101303100586e+01 1.6054501342773438e+02 -1.3956999206542969e+02 2.8085199356079102e+01 1.5902000427246094e+02 -1.3906001281738281e+02 3.2893199920654297e+01 1.6214199829101562e+02 -1.3927200317382812e+02 3.3535099029541016e+01 1.6261799621582031e+02 -1.3785200500488281e+02 3.7594097137451172e+01 1.6536801147460938e+02 -1.3344200134277344e+02 2.4412900924682617e+01 1.6527999877929688e+02 -1.3710800170898438e+02 3.9082298278808594e+01 1.5901599121093750e+02 -1.3329699707031250e+02 2.8082099914550781e+01 1.5901699829101562e+02 -1.3330200195312500e+02 3.5419200897216797e+01 1.6575399780273438e+02 -1.3950799560546875e+02 3.5138099670410156e+01 1.6840599060058594e+02 -1.3912199401855469e+02 3.3148300170898438e+01 1.6730700683593750e+02 -1.3916499328613281e+02 2.8453100204467773e+01 1.6280700683593750e+02 -1.3943600463867188e+02 2.9218500137329102e+01 1.6536999511718750e+02 -1.3336599731445312e+02 3.9080299377441406e+01 1.6422599792480469e+02 -1.3733300781250000e+02 2.7983098983764648e+01 1.6182998657226562e+02 -1.3727499389648438e+02 2.9782001495361328e+01 1.6491400146484375e+02 -1.3734899902343750e+02 3.5710300445556641e+01 1.6929400634765625e+02 -1.3745599365234375e+02 3.0685701370239258e+01 1.6159098815917969e+02 -1.3726901245117188e+02 3.3682498931884766e+01 1.6825599670410156e+02 -1.3743099975585938e+02 3.4545700073242188e+01 1.6132701110839844e+02 -1.3324800109863281e+02 3.1161100387573242e+01 1.6214999389648438e+02 -1.3326800537109375e+02 3.4172500610351562e+01 1.6331001281738281e+02 -1.3329600524902344e+02 2.8220100402832031e+01 1.6569699096679688e+02 -1.3335398864746094e+02 3.5984699249267578e+01 1.6939199829101562e+02 -1.3344400024414062e+02 3.2814201354980469e+01 1.6775601196289062e+02 -1.3340400695800781e+02 2.8236000061035156e+01 1.8399099731445312e+02 -1.2119100189208984e+02 8.0995498657226562e+01 1.8117900085449219e+02 -1.2386000061035156e+02 8.0995498657226562e+01 1.8666799926757812e+02 -1.2658199310302734e+02 8.0995498657226562e+01 1.8784800720214844e+02 -1.2272699737548828e+02 8.0995498657226562e+01 1.9104998779296875e+02 -1.1206700134277344e+02 8.0995498657226562e+01 1.9158599853515625e+02 -1.0801499938964844e+02 8.0995498657226562e+01 1.8577699279785156e+02 -1.1154499816894531e+02 8.0995498657226562e+01 1.8546899414062500e+02 -1.0766200256347656e+02 8.0995498657226562e+01 1.9341899108886719e+02 -1.2512399291992188e+02 8.0995498657226562e+01 1.9224899291992188e+02 -1.2107899475097656e+02 8.0995498657226562e+01 1.9370700073242188e+02 -1.1596600341796875e+02 8.0995498657226562e+01 1.9671800231933594e+02 -1.1259899902343750e+02 8.0995498657226562e+01 1.8216499328613281e+02 -1.1619800567626953e+02 8.0995498657226562e+01 1.7842599487304688e+02 -1.1838700103759766e+02 8.0995498657226562e+01 1.7983000183105469e+02 -1.1164999389648438e+02 8.0995498657226562e+01 1.9735200500488281e+02 -1.1947699737548828e+02 8.0995498657226562e+01 1.8843199157714844e+02 -1.1121600341796875e+02 7.7972892761230469e+01 1.8349899291992188e+02 -1.1320000457763672e+02 7.7972892761230469e+01 1.8231999206542969e+02 -1.1775000000000000e+02 7.7972892761230469e+01 1.8425099182128906e+02 -1.2142500305175781e+02 7.7972892761230469e+01 1.8877999877929688e+02 -1.2274699401855469e+02 7.7972892761230469e+01 1.9355799865722656e+02 -1.1925800323486328e+02 7.7972892761230469e+01 1.9258700561523438e+02 -1.1345099639892578e+02 7.7972892761230469e+01 1.8441400146484375e+02 -1.0801499938964844e+02 7.7972892761230469e+01 1.9131700134277344e+02 -1.0781499481201172e+02 7.7972892761230469e+01 1.9648699951171875e+02 -1.1235699462890625e+02 7.7972892761230469e+01 1.9757400512695312e+02 -1.1838700103759766e+02 7.7972892761230469e+01 1.9429499816894531e+02 -1.2446500396728516e+02 7.7972892761230469e+01 1.8777699279785156e+02 -1.2667199707031250e+02 7.7972892761230469e+01 1.8201200866699219e+02 -1.2459799957275391e+02 7.7972892761230469e+01 1.7864799499511719e+02 -1.1947699737548828e+02 7.7972892761230469e+01 1.7928199768066406e+02 -1.1259899902343750e+02 7.7972892761230469e+01 1.8530599975585938e+02 -1.1035499572753906e+02 8.1051399230957031e+01 1.8973899841308594e+02 -1.0992700195312500e+02 8.2947593688964844e+01 1.8915100097656250e+02 -1.0992199707031250e+02 8.1051399230957031e+01 1.9348899841308594e+02 -1.1222299957275391e+02 8.1051399230957031e+01 1.9489399719238281e+02 -1.1423200225830078e+02 8.2950195312500000e+01 1.9516400146484375e+02 -1.1668699645996094e+02 8.1051399230957031e+01 1.9362300109863281e+02 -1.2184799957275391e+02 8.2956405639648438e+01 1.9428298950195312e+02 -1.2045499420166016e+02 8.1051399230957031e+01 1.8971798706054688e+02 -1.2422299957275391e+02 8.1051399230957031e+01 1.8817700195312500e+02 -1.2416799926757812e+02 8.2956405639648438e+01 1.8360899353027344e+02 -1.2280199432373047e+02 8.2956405639648438e+01 1.8412399291992188e+02 -1.2303300476074219e+02 8.1051399230957031e+01 1.8155400085449219e+02 -1.2014099884033203e+02 8.1051399230957031e+01 1.8101799011230469e+02 -1.1863200378417969e+02 8.2956405639648438e+01 1.8110899353027344e+02 -1.1423799896240234e+02 8.1051399230957031e+01 1.8142601013183594e+02 -1.1388099670410156e+02 8.2956405639648438e+01 1.8498199462890625e+02 -1.1049600219726562e+02 8.2956405639648438e+01 1.8666299438476562e+02 -1.0565299987792969e+02 8.2980094909667969e+01 1.7908000183105469e+02 -1.2482900238037109e+02 8.2979598999023438e+01 1.7950700378417969e+02 -1.0925599670410156e+02 8.2969703674316406e+01 1.8999299621582031e+02 -1.2843998718261719e+02 8.2982101440429688e+01 1.9660200500488281e+02 -1.2464799499511719e+02 8.2965003967285156e+01 1.8451699829101562e+02 -1.1231700134277344e+02 8.1050201416015625e+01 1.8888500976562500e+02 -1.1135800170898438e+02 8.1049705505371094e+01 1.9275000000000000e+02 -1.1360400390625000e+02 8.1050796508789062e+01 1.8889099121093750e+02 -1.2264099884033203e+02 8.1050201416015625e+01 1.8460301208496094e+02 -1.2172599792480469e+02 8.1052307128906250e+01 1.8216699218750000e+02 -1.1713899993896484e+02 8.1051902770996094e+01 1.9329299926757812e+02 -1.1975599670410156e+02 8.1048500061035156e+01 1.7926501464843750e+02 -1.0626800537109375e+02 8.6025299072265625e+01 1.8463999938964844e+02 -1.0399700164794922e+02 8.5509796142578125e+01 1.7614799499511719e+02 -1.1542099761962891e+02 8.3282798767089844e+01 1.7431298828125000e+02 -1.1462400054931641e+02 8.5642799377441406e+01 1.9009100341796875e+02 -1.3083299255371094e+02 8.5936096191406250e+01 1.8296598815917969e+02 -1.2986199951171875e+02 8.5964004516601562e+01 1.9779199218750000e+02 -1.2683500671386719e+02 8.6059799194335938e+01 1.9281900024414062e+02 -1.0392399597167969e+02 8.6028297424316406e+01 1.9516799926757812e+02 -1.0705699920654297e+02 8.3413902282714844e+01 1.9927200317382812e+02 -1.2109799957275391e+02 8.3449806213378906e+01 1.9989999389648438e+02 -1.1418899536132812e+02 8.3926094055175781e+01 1.8986799621582031e+02 -1.1127799987792969e+02 8.4833396911621094e+01 1.8460400390625000e+02 -1.1233100128173828e+02 8.4825393676757812e+01 1.8219499206542969e+02 -1.1614699554443359e+02 8.4840606689453125e+01 1.8350100708007812e+02 -1.2052700042724609e+02 8.4336494445800781e+01 1.8721899414062500e+02 -1.2281800079345703e+02 8.4830406188964844e+01 1.9123500061035156e+02 -1.2170999908447266e+02 8.4340293884277344e+01 1.9404299926757812e+02 -1.1700200653076172e+02 8.4823600769042969e+01 1.9897100830078125e+02 -1.0850799560546875e+02 8.6054496765136719e+01 1.7668899536132812e+02 -1.2495700073242188e+02 8.5970901489257812e+01 1.7095899963378906e+02 -1.1019400024414062e+02 8.5888099670410156e+01 1.6860400390625000e+02 -1.1591799926757812e+02 8.4501106262207031e+01 1.7024198913574219e+02 -1.0900199890136719e+02 8.3650199890136719e+01 1.7667298889160156e+02 -1.0358899688720703e+02 8.6562301635742188e+01 1.7383200073242188e+02 -1.0383100128173828e+02 8.4588996887207031e+01 1.8496200561523438e+02 -1.0147800445556641e+02 8.6718704223632812e+01 1.8401199340820312e+02 -9.9004997253417969e+01 8.5803703308105469e+01 1.7788400268554688e+02 -1.0024599456787109e+02 8.3881301879882812e+01 1.9292399597167969e+02 -9.9984603881835938e+01 8.6512702941894531e+01 1.8670399475097656e+02 -9.7446296691894531e+01 8.3853103637695312e+01 2.0338700866699219e+02 -1.0832399749755859e+02 8.6483200073242188e+01 2.0315599060058594e+02 -1.1477100372314453e+02 8.6598205566406250e+01 2.0571499633789062e+02 -1.0912200164794922e+02 8.4133201599121094e+01 2.0725000000000000e+02 -1.1491699981689453e+02 8.4579803466796875e+01 2.0159498596191406e+02 -1.2041399383544922e+02 8.6086700439453125e+01 2.0487600708007812e+02 -1.1916100311279297e+02 8.6615501403808594e+01 2.0576399230957031e+02 -1.2249299621582031e+02 8.5676696777343750e+01 2.0232699584960938e+02 -1.2859500122070312e+02 8.5732902526855469e+01 2.0545700073242188e+02 -1.2560799407958984e+02 8.3680999755859375e+01 2.0299800109863281e+02 -1.2965800476074219e+02 8.1114501953125000e+01 1.9696900939941406e+02 -1.3128500366210938e+02 8.6624900817871094e+01 1.9060400390625000e+02 -1.3274099731445312e+02 8.6706306457519531e+01 1.9139199829101562e+02 -1.3528099060058594e+02 8.5676696777343750e+01 1.7955599975585938e+02 -1.3121800231933594e+02 8.6649406433105469e+01 1.8461300659179688e+02 -1.3617800903320312e+02 8.4743400573730469e+01 1.7859500122070312e+02 -1.3374299621582031e+02 8.5115097045898438e+01 1.7291699218750000e+02 -1.2867599487304688e+02 8.5325302124023438e+01 1.7147299194335938e+02 -1.2026999664306641e+02 8.6726501464843750e+01 1.7254100036621094e+02 -1.1381100463867188e+02 8.6683303833007812e+01 1.6926300048828125e+02 -1.1153900146484375e+02 8.1037002563476562e+01 1.7229600524902344e+02 -1.0544899749755859e+02 8.1032905578613281e+01 1.9631900024414062e+02 -9.9300399780273438e+01 8.4032501220703125e+01 2.0259899902343750e+02 -1.0417199707031250e+02 8.4516899108886719e+01 2.0569000244140625e+02 -1.0873200225830078e+02 8.1036705017089844e+01 2.0732299804687500e+02 -1.1949900054931641e+02 8.4038696289062500e+01 1.9862901306152344e+02 -1.3326499938964844e+02 8.4447395324707031e+01 1.9243499755859375e+02 -1.3597300720214844e+02 8.3793403625488281e+01 1.7555799865722656e+02 -1.3202400207519531e+02 8.1035896301269531e+01 1.7150799560546875e+02 -1.2742400360107422e+02 8.1037498474121094e+01 1.6936900329589844e+02 -1.2272399902343750e+02 8.3976593017578125e+01 1.7821200561523438e+02 -9.9956901550292969e+01 8.1028701782226562e+01 1.8825599670410156e+02 -9.7355003356933594e+01 8.1030799865722656e+01 1.6848899841308594e+02 -1.1925900268554688e+02 8.1030097961425781e+01 1.8160299682617188e+02 -1.3545300292968750e+02 8.1031005859375000e+01 1.8818399047851562e+02 -1.3653401184082031e+02 8.1031600952148438e+01 1.9611199951171875e+02 -1.3486399841308594e+02 8.1031394958496094e+01 2.0684201049804688e+02 -1.2253999328613281e+02 8.1030197143554688e+01 2.0735398864746094e+02 -1.1435700225830078e+02 8.1031394958496094e+01 2.0260499572753906e+02 -1.0414600372314453e+02 8.1030693054199219e+01 1.9760699462890625e+02 -9.9891502380371094e+01 8.1032905578613281e+01 1.9458801269531250e+02 -1.2610800933837891e+02 8.4862899780273438e+01 1.9928399658203125e+02 -1.1656999969482422e+02 8.4856697082519531e+01 1.7826199340820312e+02 -1.1140900421142578e+02 8.4854995727539062e+01 1.8569200134277344e+02 -1.2788100433349609e+02 8.4860504150390625e+01 1.7723800659179688e+02 -1.1945700073242188e+02 8.4857795715332031e+01 1.9555699157714844e+02 -1.0893700408935547e+02 8.4862800598144531e+01 1.8908700561523438e+02 -1.0604900360107422e+02 8.4858596801757812e+01 1.6714399719238281e+02 -1.1361399841308594e+02 8.1188400268554688e+01 1.6887600708007812e+02 -1.0797800445556641e+02 8.1032798767089844e+01 1.7394999694824219e+02 -1.0130000305175781e+02 8.1031303405761719e+01 1.8025498962402344e+02 -9.7317504882812500e+01 8.1110702514648438e+01 1.8636999511718750e+02 -9.6028099060058594e+01 8.1029495239257812e+01 1.9490000915527344e+02 -9.6972900390625000e+01 8.1028999328613281e+01 2.0136100769042969e+02 -1.0063099670410156e+02 8.1179702758789062e+01 2.0440899658203125e+02 -1.0379999542236328e+02 8.1031204223632812e+01 2.0768899536132812e+02 -1.0959400177001953e+02 8.1029197692871094e+01 2.0915399169921875e+02 -1.1771900177001953e+02 8.1031303405761719e+01 2.0633700561523438e+02 -1.2761899566650391e+02 8.1029800415039062e+01 2.0043200683593750e+02 -1.3398901367187500e+02 8.1028900146484375e+01 1.9463500976562500e+02 -1.3697099304199219e+02 8.1031303405761719e+01 1.8805000305175781e+02 -1.3804200744628906e+02 8.1031394958496094e+01 1.8155700683593750e+02 -1.3704699707031250e+02 8.1031997680664062e+01 1.7535800170898438e+02 -1.3386599731445312e+02 8.1031997680664062e+01 1.7065699768066406e+02 -1.2890299987792969e+02 8.1029495239257812e+01 1.6720600891113281e+02 -1.2103799438476562e+02 8.1028900146484375e+01 1.8326400756835938e+02 -1.0593199920654297e+02 8.6271896362304688e+01 1.7854598999023438e+02 -1.2536300659179688e+02 8.6910202026367188e+01 1.9718299865722656e+02 -1.2632000732421875e+02 8.7215400695800781e+01 1.9273300170898438e+02 -9.6616996765136719e+01 8.4858901977539062e+01 1.8659100341796875e+02 -9.5941398620605469e+01 8.3571502685546875e+01 1.9801199340820312e+02 -9.8714797973632812e+01 8.4956497192382812e+01 2.0611399841308594e+02 -1.0615699768066406e+02 8.3860893249511719e+01 2.0887899780273438e+02 -1.1443500518798828e+02 8.3841003417968750e+01 2.0868000793457031e+02 -1.2023799896240234e+02 8.4826606750488281e+01 2.0631599426269531e+02 -1.2752899169921875e+02 8.3836898803710938e+01 2.0027799987792969e+02 -1.3402200317382812e+02 8.4858901977539062e+01 1.9352699279785156e+02 -1.3728399658203125e+02 8.4932998657226562e+01 1.8458299255371094e+02 -1.3783900451660156e+02 8.3528305053710938e+01 1.7744799804687500e+02 -1.3521299743652344e+02 8.3798896789550781e+01 1.7206999206542969e+02 -1.3070201110839844e+02 8.3922698974609375e+01 1.6872100830078125e+02 -1.2531700897216797e+02 8.3775001525878906e+01 1.6714700317382812e+02 -1.1991699981689453e+02 8.4024803161621094e+01 1.6870201110839844e+02 -1.0909199523925781e+02 8.5229705810546875e+01 1.7154299926757812e+02 -1.0425499725341797e+02 8.5162200927734375e+01 1.7518000793457031e+02 -1.0033699798583984e+02 8.3866905212402344e+01 1.6821600341796875e+02 -1.1743400573730469e+02 8.6699096679687500e+01 1.7300300598144531e+02 -1.0656599426269531e+02 8.7717300415039062e+01 1.7257000732421875e+02 -1.1200199890136719e+02 8.8332305908203125e+01 1.7773599243164062e+02 -1.0718200683593750e+02 8.8059700012207031e+01 1.8513800048828125e+02 -1.0176399993896484e+02 8.8168899536132812e+01 1.8340100097656250e+02 -9.7264793395996094e+01 8.6028297424316406e+01 1.7806599426269531e+02 -1.0053499603271484e+02 8.7294494628906250e+01 1.8988198852539062e+02 -9.8739799499511719e+01 8.7723701477050781e+01 2.0305400085449219e+02 -1.0437400054931641e+02 8.6877197265625000e+01 2.0732699584960938e+02 -1.1131200408935547e+02 8.6237197875976562e+01 2.0473599243164062e+02 -1.1279100036621094e+02 8.8072502136230469e+01 1.9961099243164062e+02 -1.0530000305175781e+02 8.8196395874023438e+01 2.0402499389648438e+02 -1.1996799468994141e+02 8.8192100524902344e+01 2.0060198974609375e+02 -1.1375799560546875e+02 8.7295600891113281e+01 2.0611999511718750e+02 -1.1993999481201172e+02 8.7723701477050781e+01 2.0077999877929688e+02 -1.1931400299072266e+02 8.7293899536132812e+01 1.8378999328613281e+02 -1.3666699218750000e+02 8.6312500000000000e+01 1.9486399841308594e+02 -1.3410299682617188e+02 8.7730598449707031e+01 1.9617100524902344e+02 -1.3115798950195312e+02 8.8223701477050781e+01 1.8268099975585938e+02 -1.3360899353027344e+02 8.8075103759765625e+01 1.8804000854492188e+02 -1.3156799316406250e+02 8.7924194335937500e+01 1.8948901367187500e+02 -1.2942098999023438e+02 8.6776397705078125e+01 1.8305101013183594e+02 -1.2893598937988281e+02 8.7247299194335938e+01 1.7641900634765625e+02 -1.3336299133300781e+02 8.6296203613281250e+01 1.7228900146484375e+02 -1.2404000091552734e+02 8.8136505126953125e+01 1.7451199340820312e+02 -1.1751899719238281e+02 8.7476203918457031e+01 1.8799800109863281e+02 -1.0388399505615234e+02 8.7200904846191406e+01 1.9476998901367188e+02 -1.0341099548339844e+02 8.8132003784179688e+01 1.9646499633789062e+02 -1.0078700256347656e+02 8.7668899536132812e+01 1.9633500671386719e+02 -1.0718000030517578e+02 8.7116600036621094e+01 2.0551100158691406e+02 -1.2719799804687500e+02 8.6028297424316406e+01 2.0196699523925781e+02 -1.2872999572753906e+02 8.7731399536132812e+01 1.7461300659179688e+02 -1.2929199218750000e+02 8.7752197265625000e+01 1.7039201354980469e+02 -1.2689900207519531e+02 8.6144699096679688e+01 1.8211399841308594e+02 -1.1254399871826172e+02 8.3278701782226562e+01 1.8679000854492188e+02 -1.0970299530029297e+02 8.3310997009277344e+01 1.7900000000000000e+02 -1.0894499969482422e+02 8.2738899230957031e+01 1.7641699218750000e+02 -1.1787699890136719e+02 8.3054397583007812e+01 1.8068299865722656e+02 -1.1869599914550781e+02 8.3277801513671875e+01 1.7981399536132812e+02 -1.2513400268554688e+02 8.3119598388671875e+01 1.8167799377441406e+02 -1.2900000000000000e+02 8.0465499877929688e+01 1.8990299987792969e+02 -1.2827500915527344e+02 8.3173995971679688e+01 1.9377000427246094e+02 -1.0720200347900391e+02 8.3191398620605469e+01 1.9946199035644531e+02 -1.1655600738525391e+02 8.3178901672363281e+01 1.9775999450683594e+02 -1.0997100067138672e+02 8.2512603759765625e+01 1.8739700317382812e+02 -1.0495999908447266e+02 8.2523895263671875e+01 1.9396499633789062e+02 -1.2918699645996094e+02 7.9597694396972656e+01 1.8813900756835938e+02 -1.3063200378417969e+02 7.9614601135253906e+01 1.9830699157714844e+02 -1.2584799194335938e+02 7.9572998046875000e+01 1.9676199340820312e+02 -1.2461700439453125e+02 8.3142494201660156e+01 2.0095500183105469e+02 -1.2102200317382812e+02 7.9597900390625000e+01 2.0150500488281250e+02 -1.1517600250244141e+02 7.9597000122070312e+01 1.9874800109863281e+02 -1.0861699676513672e+02 7.9596397399902344e+01 1.9380700683593750e+02 -1.0471100616455078e+02 7.9548797607421875e+01 1.8844699096679688e+02 -1.0344900512695312e+02 7.9626296997070312e+01 1.8252499389648438e+02 -1.0452099609375000e+02 7.9580902099609375e+01 1.7703999328613281e+02 -1.0888099670410156e+02 7.9646804809570312e+01 1.7468099975585938e+02 -1.1438099670410156e+02 7.9596496582031250e+01 1.7467098999023438e+02 -1.1949200439453125e+02 7.9598396301269531e+01 1.7671699523925781e+02 -1.2457700347900391e+02 7.9580101013183594e+01 1.9183399963378906e+02 -1.2330800628662109e+02 8.3273902893066406e+01 1.9542599487304688e+02 -1.1811699676513672e+02 8.3273902893066406e+01 1.8551098632812500e+02 -1.2408499908447266e+02 8.3273902893066406e+01 1.9292298889160156e+02 -1.1132799530029297e+02 8.3273902893066406e+01 1.8904299926757812e+02 -1.0956300354003906e+02 8.0995498657226562e+01 1.8304499816894531e+02 -1.1152899932861328e+02 8.0995498657226562e+01 1.8064300537109375e+02 -1.1640399932861328e+02 8.0995498657226562e+01 1.8222900390625000e+02 -1.2160199737548828e+02 8.0995498657226562e+01 1.8694299316406250e+02 -1.2430500030517578e+02 8.0995498657226562e+01 1.9223100280761719e+02 -1.2304899597167969e+02 8.0995498657226562e+01 1.9522500610351562e+02 -1.1851300048828125e+02 8.0995498657226562e+01 1.9430198669433594e+02 -1.1315800476074219e+02 8.0995498657226562e+01 2.0049198913574219e+02 -1.2247800445556641e+02 7.4437400817871094e+01 2.0161299133300781e+02 -1.1695200347900391e+02 7.4329895019531250e+01 2.0026199340820312e+02 -1.1092600250244141e+02 7.4357101440429688e+01 1.9658300781250000e+02 -1.0642700195312500e+02 7.4638999938964844e+01 1.9242900085449219e+02 -1.0412400054931641e+02 7.4296798706054688e+01 1.8862699890136719e+02 -1.3057499694824219e+02 7.3777496337890625e+01 1.9358799743652344e+02 -1.2944599914550781e+02 7.4280899047851562e+01 1.9753999328613281e+02 -1.2665000915527344e+02 7.4315803527832031e+01 1.7849299621582031e+02 -1.2672799682617188e+02 7.4523902893066406e+01 1.8358898925781250e+02 -1.2993699645996094e+02 7.4432800292968750e+01 1.7528399658203125e+02 -1.2198100280761719e+02 7.4446502685546875e+01 1.8323298645019531e+02 -1.0419200134277344e+02 7.4338401794433594e+01 1.7725900268554688e+02 -1.0841500091552734e+02 7.4423904418945312e+01 1.7436000061035156e+02 -1.1584200286865234e+02 7.4318099975585938e+01 1.8835499572753906e+02 -1.0343199920654297e+02 7.4284393310546875e+01 1.8637100219726562e+02 -1.2667900085449219e+02 8.0994895935058594e+01 1.7926600646972656e+02 -1.2251399993896484e+02 8.0938697814941406e+01 1.9780599975585938e+02 -1.1364299774169922e+02 8.0950401306152344e+01 1.8736999511718750e+02 -1.0665599822998047e+02 8.0951698303222656e+01 1.9369400024414062e+02 -1.0843999481201172e+02 8.0957099914550781e+01 1.8167300415039062e+02 -1.0893900299072266e+02 8.0967704772949219e+01 1.9621600341796875e+02 -1.2298500061035156e+02 8.0981407165527344e+01 1.7786599731445312e+02 -1.1456300354003906e+02 8.0944503784179688e+01 1.9028500366210938e+02 -1.3368899536132812e+02 7.3619003295898438e+01 1.9666198730468750e+02 -1.3133799743652344e+02 7.3618598937988281e+01 1.9644799804687500e+02 -1.0242700195312500e+02 7.3618499755859375e+01 1.8997299194335938e+02 -1.0036499786376953e+02 7.3618202209472656e+01 1.9936500549316406e+02 -1.0786199951171875e+02 7.3645301818847656e+01 2.0157400512695312e+02 -1.0718299865722656e+02 7.3618400573730469e+01 2.0402600097656250e+02 -1.1212300109863281e+02 7.3618598937988281e+01 2.0473899841308594e+02 -1.1888100433349609e+02 7.3617698669433594e+01 2.0182701110839844e+02 -1.2662099456787109e+02 7.3617195129394531e+01 1.8331600952148438e+02 -1.3308399963378906e+02 7.3618003845214844e+01 1.7832499694824219e+02 -1.3065899658203125e+02 7.3571601867675781e+01 1.7447898864746094e+02 -1.2686499786376953e+02 7.3578903198242188e+01 1.7125900268554688e+02 -1.1640799713134766e+02 7.3616996765136719e+01 1.7197300720214844e+02 -1.2187500000000000e+02 7.3618003845214844e+01 1.7235800170898438e+02 -1.1100499725341797e+02 7.3618598937988281e+01 1.7594499206542969e+02 -1.0523399353027344e+02 7.3617599487304688e+01 1.8299800109863281e+02 -1.0091500091552734e+02 7.3617599487304688e+01 1.9793798828125000e+02 -1.1988600158691406e+02 8.0705001831054688e+01 1.9228500366210938e+02 -1.2667299652099609e+02 8.0626396179199219e+01 1.8437300109863281e+02 -1.2828298950195312e+02 7.8608001708984375e+01 1.9043000793457031e+02 -1.2857901000976562e+02 7.8161705017089844e+01 1.9542900085449219e+02 -1.2626400756835938e+02 7.8212402343750000e+01 1.9888200378417969e+02 -1.2159600067138672e+02 7.8173698425292969e+01 1.9986300659179688e+02 -1.1615999603271484e+02 7.8188598632812500e+01 1.9830000305175781e+02 -1.1109899902343750e+02 7.7686500549316406e+01 1.9388600158691406e+02 -1.0667300415039062e+02 7.8205902099609375e+01 1.8815000915527344e+02 -1.0518900299072266e+02 7.8199897766113281e+01 1.8268699645996094e+02 -1.0637400054931641e+02 7.8182197570800781e+01 1.7783599853515625e+02 -1.1091600036621094e+02 7.8166900634765625e+01 1.7847299194335938e+02 -1.2425799560546875e+02 7.8221801757812500e+01 1.7613099670410156e+02 -1.1728900146484375e+02 7.8183395385742188e+01 1.8770300292968750e+02 -1.0025099945068359e+02 7.1338996887207031e+01 1.9315600585937500e+02 -1.0106199645996094e+02 7.1338104248046875e+01 1.9805101013183594e+02 -1.0359899902343750e+02 7.1343498229980469e+01 2.0272000122070312e+02 -1.0880999755859375e+02 7.1339195251464844e+01 2.0492999267578125e+02 -1.1825100708007812e+02 7.1339195251464844e+01 2.0059199523925781e+02 -1.2838500976562500e+02 7.1339599609375000e+01 1.9372200012207031e+02 -1.3274400329589844e+02 7.1339195251464844e+01 1.8829899597167969e+02 -1.3374899291992188e+02 7.1343498229980469e+01 1.8141398620605469e+02 -1.3250399780273438e+02 7.1343498229980469e+01 1.7587800598144531e+02 -1.2856199645996094e+02 7.1338493347167969e+01 1.7278100585937500e+02 -1.2400000000000000e+02 7.1339797973632812e+01 1.7133299255371094e+02 -1.1868099975585938e+02 7.1343498229980469e+01 1.7200500488281250e+02 -1.1171800231933594e+02 7.1339401245117188e+01 1.7449200439453125e+02 -1.0718000030517578e+02 7.1338302612304688e+01 1.7978700256347656e+02 -1.0214299774169922e+02 7.1340599060058594e+01 1.7474800109863281e+02 -1.2296299743652344e+02 7.1384300231933594e+01 1.7933200073242188e+02 -1.0569300079345703e+02 7.1435600280761719e+01 1.9131300354003906e+02 -1.0347600555419922e+02 7.1491302490234375e+01 1.8288099670410156e+02 -1.3004399108886719e+02 7.1417900085449219e+01 1.9960198974609375e+02 -1.2505599975585938e+02 7.1435195922851562e+01 1.8899400329589844e+02 -1.0505300140380859e+02 7.3270904541015625e+01 1.8281799316406250e+02 -1.0633899688720703e+02 7.3516601562500000e+01 1.7747099304199219e+02 -1.1123100280761719e+02 7.3704696655273438e+01 1.8023300170898438e+02 -1.2593199157714844e+02 7.3925399780273438e+01 1.7733399963378906e+02 -1.2219499969482422e+02 7.3188903808593750e+01 1.7618699645996094e+02 -1.1774499511718750e+02 7.3507698059082031e+01 1.9051000976562500e+02 -1.2863198852539062e+02 7.3905601501464844e+01 1.8482899475097656e+02 -1.2838398742675781e+02 7.3577598571777344e+01 1.9987300109863281e+02 -1.1834500122070312e+02 7.3183700561523438e+01 1.9688600158691406e+02 -1.2498000335693359e+02 7.3531700134277344e+01 1.9561499023437500e+02 -1.0782700347900391e+02 7.4178504943847656e+01 1.9809399414062500e+02 -1.0898199462890625e+02 7.2005104064941406e+01 2.0097898864746094e+02 -1.1511599731445312e+02 7.1881301879882812e+01 1.9144299316406250e+02 -1.2980000305175781e+02 7.1876899719238281e+01 1.7464199829101562e+02 -1.1430200195312500e+02 7.1658798217773438e+01 1.8512500000000000e+02 -1.3586199951171875e+02 7.5904396057128906e+01 1.8728601074218750e+02 -1.3140699768066406e+02 7.3258499145507812e+01 1.8786500549316406e+02 -1.3132000732421875e+02 7.8943702697753906e+01 1.9141699218750000e+02 -1.3268199157714844e+02 8.5958503723144531e+01 1.8754998779296875e+02 -1.3214999389648438e+02 7.9236999511718750e+01 1.8474699401855469e+02 -1.3394999694824219e+02 8.5577697753906250e+01 1.4135299682617188e+02 -1.1586699676513672e+02 2.7176599502563477e+01 1.4092900085449219e+02 -1.1585600280761719e+02 3.1744598388671875e+01 1.4002700805664062e+02 -1.2845500183105469e+02 3.0339599609375000e+01 1.4135099792480469e+02 -1.1586699676513672e+02 3.6312801361083984e+01 1.4010200500488281e+02 -1.2794299316406250e+02 3.3703598022460938e+01 1.4278100585937500e+02 -1.2800799560546875e+02 4.3272598266601562e+01 1.4100999450683594e+02 -1.2809500122070312e+02 3.8596202850341797e+01 1.4260501098632812e+02 -1.1589500427246094e+02 4.0724998474121094e+01 1.4464799499511719e+02 -1.1594699859619141e+02 4.4832599639892578e+01 1.4437199401855469e+02 -1.2873600769042969e+02 4.6078903198242188e+01 1.4741101074218750e+02 -1.1601399993896484e+02 4.8494300842285156e+01 1.4649400329589844e+02 -1.2860800170898438e+02 4.8764099121093750e+01 1.5080000305175781e+02 -1.1609600067138672e+02 5.1585700988769531e+01 1.4891799926757812e+02 -1.2815699768066406e+02 5.1087299346923828e+01 1.5469900512695312e+02 -1.1619100189208984e+02 5.4001598358154297e+01 1.5157499694824219e+02 -1.2854400634765625e+02 5.3105800628662109e+01 1.6080400085449219e+02 -1.2844599914550781e+02 5.6783798217773438e+01 1.5754299926757812e+02 -1.2862699890136719e+02 5.5962699890136719e+01 1.5897500610351562e+02 -1.1629500579833984e+02 5.5659801483154297e+01 1.5448600769042969e+02 -1.2829199218750000e+02 5.4718200683593750e+01 1.6348298645019531e+02 -1.1640399932861328e+02 5.6503696441650391e+01 1.6413900756835938e+02 -1.2904598999023438e+02 5.7194698333740234e+01 1.6806900024414062e+02 -1.1651599884033203e+02 5.6504699707031250e+01 1.7257800292968750e+02 -1.1662500000000000e+02 5.5662700653076172e+01 1.7072099304199219e+02 -1.2912699890136719e+02 5.6695598602294922e+01 1.7685499572753906e+02 -1.1672899627685547e+02 5.4006401062011719e+01 1.7395600891113281e+02 -1.2908799743652344e+02 5.5783802032470703e+01 1.8075401306152344e+02 -1.1682399749755859e+02 5.1592201232910156e+01 1.7986399841308594e+02 -1.2902299499511719e+02 5.2775600433349609e+01 1.7701899719238281e+02 -1.2933200073242188e+02 5.4478897094726562e+01 1.8248699951171875e+02 -1.2921099853515625e+02 5.0722202301025391e+01 1.8414401245117188e+02 -1.1690600585937500e+02 4.8502201080322266e+01 1.8690901184082031e+02 -1.1697400665283203e+02 4.4841800689697266e+01 1.8664399719238281e+02 -1.2959399414062500e+02 4.5935298919677734e+01 1.8900700378417969e+02 -1.1694099426269531e+02 4.0623798370361328e+01 1.8845399475097656e+02 -1.2956799316406250e+02 4.2776901245117188e+01 1.9063499450683594e+02 -1.1706399536132812e+02 3.1755298614501953e+01 1.9091099548339844e+02 -1.2917700195312500e+02 3.3127502441406250e+01 1.9021000671386719e+02 -1.1705400085449219e+02 3.6323303222656250e+01 1.9052700805664062e+02 -1.2968899536132812e+02 3.6439800262451172e+01 1.9021199035644531e+02 -1.1705400085449219e+02 2.7187200546264648e+01 1.9089399719238281e+02 -1.2979400634765625e+02 2.9814500808715820e+01 1.8895800781250000e+02 -1.1702299499511719e+02 2.2774400711059570e+01 1.8951499938964844e+02 -1.2940299987792969e+02 2.3301898956298828e+01 1.9040100097656250e+02 -1.2916499328613281e+02 2.6498600006103516e+01 1.8819999694824219e+02 -1.2935499572753906e+02 2.0221700668334961e+01 1.8691499328613281e+02 -1.1697400665283203e+02 1.8667299270629883e+01 1.8647499084472656e+02 -1.2959001159667969e+02 1.7301300048828125e+01 1.8415200805664062e+02 -1.1690699768066406e+02 1.5005599975585938e+01 1.8443901062011719e+02 -1.2902000427246094e+02 1.4741499900817871e+01 1.8076300048828125e+02 -1.1682399749755859e+02 1.1914199829101562e+01 1.8206500244140625e+02 -1.2920199584960938e+02 1.2408100128173828e+01 1.7686399841308594e+02 -1.1672899627685547e+02 9.4983596801757812e+00 1.7939199829101562e+02 -1.2914900207519531e+02 1.0402400016784668e+01 1.7017098999023438e+02 -1.2867300415039062e+02 6.7161297798156738e+00 1.7341299438476562e+02 -1.2895600891113281e+02 7.5374798774719238e+00 1.7258801269531250e+02 -1.1662599945068359e+02 7.8401603698730469e+00 1.7646501159667969e+02 -1.2936000061035156e+02 8.7465000152587891e+00 1.6808000183105469e+02 -1.1651599884033203e+02 6.9962100982666016e+00 1.6349400329589844e+02 -1.1640500640869141e+02 6.9952001571655273e+00 1.6353700256347656e+02 -1.2895298767089844e+02 6.3328700065612793e+00 1.6683399963378906e+02 -1.2885501098632812e+02 6.3041996955871582e+00 1.5898500061035156e+02 -1.1629500579833984e+02 7.8372302055358887e+00 1.6024099731445312e+02 -1.2893099975585938e+02 6.7986798286437988e+00 1.5470799255371094e+02 -1.1619100189208984e+02 9.4935302734375000e+00 1.5703100585937500e+02 -1.2835400390625000e+02 7.7274398803710938e+00 1.5080900573730469e+02 -1.1609600067138672e+02 1.1907799720764160e+01 1.5110600280761719e+02 -1.2832499694824219e+02 1.0724400520324707e+01 1.5393499755859375e+02 -1.2871701049804688e+02 9.0236091613769531e+00 1.4846899414062500e+02 -1.2838800048828125e+02 1.2783599853515625e+01 1.4741900634765625e+02 -1.1601399993896484e+02 1.4997700691223145e+01 1.4615599060058594e+02 -1.2808999633789062e+02 1.5175499916076660e+01 1.4465400695800781e+02 -1.1594699859619141e+02 1.8658201217651367e+01 1.4260899353027344e+02 -1.1589700317382812e+02 2.2764400482177734e+01 1.4250401306152344e+02 -1.2854499816894531e+02 2.0699800491333008e+01 1.4044200134277344e+02 -1.2821200561523438e+02 2.7062398910522461e+01 1.4128700256347656e+02 -1.2797200775146484e+02 2.3837299346923828e+01 1.9031498718261719e+02 -1.0443499755859375e+02 3.9671100616455078e+01 1.8903700256347656e+02 -1.0491899871826172e+02 4.2754798889160156e+01 1.8543400573730469e+02 -1.0457199859619141e+02 4.8320499420166016e+01 1.8740400695800781e+02 -1.0487899780273438e+02 4.5658599853515625e+01 1.8307901000976562e+02 -1.0477400207519531e+02 5.0706600189208984e+01 1.8044799804687500e+02 -1.0425099945068359e+02 5.2808799743652344e+01 1.7759500122070312e+02 -1.0464099884033203e+02 5.4462898254394531e+01 1.7458500671386719e+02 -1.0406000518798828e+02 5.5786098480224609e+01 1.7132499694824219e+02 -1.0448799896240234e+02 5.6671199798583984e+01 1.6471000671386719e+02 -1.0421299743652344e+02 5.7187500000000000e+01 1.6801699829101562e+02 -1.0388500213623047e+02 5.7171798706054688e+01 1.6139199829101562e+02 -1.0424699401855469e+02 5.6783798217773438e+01 1.5507400512695312e+02 -1.0409300231933594e+02 5.4718200683593750e+01 1.5814300537109375e+02 -1.0390499877929688e+02 5.5962699890136719e+01 1.5218399047851562e+02 -1.0347499847412109e+02 5.3118602752685547e+01 1.4950599670410156e+02 -1.0395800018310547e+02 5.1087299346923828e+01 1.4335600280761719e+02 -1.0328099822998047e+02 4.3281303405761719e+01 1.4507800292968750e+02 -1.0359100341796875e+02 4.6169002532958984e+01 1.4711601257324219e+02 -1.0365200042724609e+02 4.8761798858642578e+01 1.4115600585937500e+02 -1.0330699920654297e+02 3.7033699035644531e+01 1.4069000244140625e+02 -1.0374400329589844e+02 3.3703598022460938e+01 1.4065200805664062e+02 -1.0374300384521484e+02 3.0372400283813477e+01 1.4187500000000000e+02 -1.0377299499511719e+02 2.3837299346923828e+01 1.4104301452636719e+02 -1.0349199676513672e+02 2.7062299728393555e+01 1.4310499572753906e+02 -1.0327400207519531e+02 2.0727500915527344e+01 1.4906799316406250e+02 -1.0371000671386719e+02 1.2785099983215332e+01 1.4573599243164062e+02 -1.0373600006103516e+02 1.6513299942016602e+01 1.5455599975585938e+02 -1.0408099365234375e+02 9.0371398925781250e+00 1.5178799438476562e+02 -1.0335900115966797e+02 1.0639200210571289e+01 1.5759199523925781e+02 -1.0370399475097656e+02 7.7158799171447754e+00 1.6082600402832031e+02 -1.0423299407958984e+02 6.8287796974182129e+00 1.6743199157714844e+02 -1.0390000152587891e+02 6.2915101051330566e+00 1.6405299377441406e+02 -1.0363099670410156e+02 6.3224997520446777e+00 1.7075900268554688e+02 -1.0447499847412109e+02 6.7161297798156738e+00 1.7401599121093750e+02 -1.0429300689697266e+02 7.5355801582336426e+00 1.7707699584960938e+02 -1.0462799835205078e+02 8.7817897796630859e+00 1.7999101257324219e+02 -1.0423600006103516e+02 1.0386300086975098e+01 1.8266200256347656e+02 -1.0451599884033203e+02 1.2404399871826172e+01 1.8708999633789062e+02 -1.0434999847412109e+02 1.7304100036621094e+01 1.8502700805664062e+02 -1.0482099914550781e+02 1.4741499900817871e+01 1.8878201293945312e+02 -1.0491199493408203e+02 2.0227399826049805e+01 1.9098899841308594e+02 -1.0496600341796875e+02 2.6498600006103516e+01 1.9014500427246094e+02 -1.0459899902343750e+02 2.3380001068115234e+01 1.9150700378417969e+02 -1.0432199859619141e+02 2.9716100692749023e+01 1.9113999938964844e+02 -1.0444799804687500e+02 3.6439601898193359e+01 1.9149899291992188e+02 -1.0497800445556641e+02 3.3127502441406250e+01 1.6355599975585938e+02 -1.2876098632812500e+02 4.3169798851013184e+00 1.7506100463867188e+02 -1.2917199707031250e+02 6.2382798194885254e+00 1.6871200561523438e+02 -1.2891600036621094e+02 5.8993896484375000e+01 1.7528599548339844e+02 -1.2908299255371094e+02 5.7352699279785156e+01 1.5691799926757812e+02 -1.2867500305175781e+02 5.7951798439025879e+00 1.8648600769042969e+02 -1.2939999389648438e+02 1.4288800239562988e+01 1.9056298828125000e+02 -1.2952000427246094e+02 2.0928899765014648e+01 1.8124899291992188e+02 -1.2926499938964844e+02 5.4073501586914062e+01 1.3756300354003906e+02 -1.2788699340820312e+02 3.6265701293945312e+01 1.4669898986816406e+02 -1.2856399536132812e+02 1.2782999992370605e+01 1.8900500488281250e+02 -1.2958599853515625e+02 4.4384799957275391e+01 1.3744898986816406e+02 -1.2796600341796875e+02 2.9069799423217773e+01 1.5205099487304688e+02 -1.2855899047851562e+02 5.5613399505615234e+01 1.5792399597167969e+02 -1.2883700561523438e+02 5.7237400054931641e+01 1.4227000427246094e+02 -1.0343699645996094e+02 1.8334199905395508e+01 1.7747099304199219e+02 -1.0418199920654297e+02 7.5899400711059570e+00 1.8753099060058594e+02 -1.0457299804687500e+02 1.4766799926757812e+01 1.9050799560546875e+02 -1.0460700225830078e+02 4.3996799468994141e+01 1.8125900268554688e+02 -1.0460700225830078e+02 5.5406398773193359e+01 1.4399899291992188e+02 -1.0336899566650391e+02 4.6762802124023438e+01 1.6543400573730469e+02 -1.0388100433349609e+02 5.8422302246093750e+01 1.6852099609375000e+02 -1.0413400268554688e+02 4.4434099197387695e+00 1.7500000000000000e+02 -1.0432700347900391e+02 5.7759899139404297e+01 1.3941900634765625e+02 -1.0340899658203125e+02 3.7930202484130859e+01 1.3948500061035156e+02 -1.0338199615478516e+02 2.5466499328613281e+01 1.9118901062011719e+02 -1.0472100067138672e+02 2.0555099487304688e+01 1.3421400451660156e+02 -1.2279000091552734e+02 2.7111598968505859e+01 1.3439500427246094e+02 -1.2499099731445312e+02 3.1908399581909180e+01 1.3397599792480469e+02 -1.2275599670410156e+02 3.4340698242187500e+01 1.9719299316406250e+02 -1.2426399993896484e+02 3.4937400817871094e+01 1.9612998962402344e+02 -1.2356200408935547e+02 4.0323699951171875e+01 1.9559700012207031e+02 -1.2639300537109375e+02 4.0226898193359375e+01 1.9416600036621094e+02 -1.2420800018310547e+02 4.5610698699951172e+01 1.9395999145507812e+02 -1.2912300109863281e+02 3.4195503234863281e+01 1.3867199707031250e+02 -1.2790399932861328e+02 2.2537300109863281e+01 1.8839399719238281e+02 -1.2886000061035156e+02 4.9076400756835938e+01 1.9178999328613281e+02 -1.2896199035644531e+02 4.3186100006103516e+01 1.9364700317382812e+02 -1.2891900634765625e+02 2.5788198471069336e+01 1.8480599975585938e+02 -1.2874099731445312e+02 1.0422499656677246e+01 1.7055200195312500e+02 -1.2835800170898438e+02 3.4139101505279541e+00 1.5066499328613281e+02 -1.2771900177001953e+02 6.6304202079772949e+00 1.4368200683593750e+02 -1.2779299926757812e+02 1.3130100250244141e+01 1.3946600341796875e+02 -1.2760700225830078e+02 4.4202400207519531e+01 1.4492599487304688e+02 -1.2781700134277344e+02 5.1753700256347656e+01 1.5960598754882812e+02 -1.2817401123046875e+02 5.9834701538085938e+01 1.6541899108886719e+02 -1.2777799224853516e+02 6.1118698120117188e+01 1.7231799316406250e+02 -1.2794500732421875e+02 6.0317596435546875e+01 1.7883500671386719e+02 -1.2810400390625000e+02 5.7917900085449219e+01 1.8460699462890625e+02 -1.2824400329589844e+02 5.4054199218750000e+01 1.9453500366210938e+02 -1.2726299285888672e+02 2.1710699081420898e+01 1.9038000488281250e+02 -1.2838398742675781e+02 1.6146200180053711e+01 1.7855101013183594e+02 -1.2776300048828125e+02 4.8350701332092285e+00 1.6784100341796875e+02 -1.2679000091552734e+02 1.2872799634933472e+00 1.6017300415039062e+02 -1.2659400939941406e+02 1.6270900964736938e+00 1.3997698974609375e+02 -1.2611299896240234e+02 1.5020500183105469e+01 1.5029299926757812e+02 -1.2666300201416016e+02 5.8005401611328125e+01 1.6354798889160156e+02 -1.2600099945068359e+02 6.2593601226806641e+01 1.6907400512695312e+02 -1.2614199829101562e+02 6.2507503509521484e+01 1.7619799804687500e+02 -1.2631499481201172e+02 6.0818401336669922e+01 1.8272599792480469e+02 -1.2647299194335938e+02 5.7502998352050781e+01 1.8829299926757812e+02 -1.2660900115966797e+02 5.2746501922607422e+01 1.9258700561523438e+02 -1.2671298980712891e+02 4.6815101623535156e+01 1.9648001098632812e+02 -1.2680700683593750e+02 3.2802700042724609e+01 1.9613400268554688e+02 -1.2679299926757812e+02 2.7355300903320312e+01 1.9229600524902344e+02 -1.2548999786376953e+02 1.4711799621582031e+01 1.8852600097656250e+02 -1.2662500000000000e+02 1.0884900093078613e+01 1.8140399169921875e+02 -1.2644100189208984e+02 5.1620597839355469e+00 1.7443499755859375e+02 -1.2610900115966797e+02 2.0049800872802734e+00 1.5494898986816406e+02 -1.2579299163818359e+02 2.7167799472808838e+00 1.4992601013183594e+02 -1.2567600250244141e+02 5.0242500305175781e+00 1.4408799743652344e+02 -1.2553499603271484e+02 9.4425096511840820e+00 1.3745300292968750e+02 -1.2520999908447266e+02 1.8570199966430664e+01 1.3528999328613281e+02 -1.2532099914550781e+02 2.5240600585937500e+01 1.3565798950195312e+02 -1.2533000183105469e+02 3.9779598236083984e+01 1.3837899780273438e+02 -1.2539599609375000e+02 4.6577899932861328e+01 1.4144699096679688e+02 -1.2546400451660156e+02 5.1092098236083984e+01 1.4524101257324219e+02 -1.2556299591064453e+02 5.5113098144531250e+01 1.5814700317382812e+02 -1.2587599182128906e+02 6.1810699462890625e+01 1.6586500549316406e+02 -1.2411199951171875e+02 5.7080099359154701e-03 1.5260299682617188e+02 -1.2378600311279297e+02 6.0714000701904297e+01 1.6373300170898438e+02 -1.2374400329589844e+02 6.3438602447509766e+01 1.7099600219726562e+02 -1.2365200042724609e+02 6.3038700103759766e+01 1.7466300964355469e+02 -1.2374900054931641e+02 6.2180599212646484e+01 1.7819898986816406e+02 -1.2383000183105469e+02 6.0895397186279297e+01 1.8153700256347656e+02 -1.2392500305175781e+02 5.9210800170898438e+01 1.8468600463867188e+02 -1.2398100280761719e+02 5.7125198364257812e+01 1.8803199768066406e+02 -1.2438400268554688e+02 5.4171901702880859e+01 1.9232400512695312e+02 -1.2416899871826172e+02 4.8894599914550781e+01 1.9732699584960938e+02 -1.2456600189208984e+02 3.0889699935913086e+01 1.9628800964355469e+02 -1.2426399993896484e+02 2.3606599807739258e+01 1.9510899353027344e+02 -1.2423100280761719e+02 2.0030399322509766e+01 1.8918399047851562e+02 -1.2409000396728516e+02 1.0490500450134277e+01 1.8614498901367188e+02 -1.2432599639892578e+02 7.5736598968505859e+00 1.8031199645996094e+02 -1.2387500000000000e+02 3.6119198799133301e+00 1.7687500000000000e+02 -1.2380400085449219e+02 2.0675601959228516e+00 1.7272200012207031e+02 -1.2394899749755859e+02 8.1694996356964111e-01 1.6208000183105469e+02 -1.2343899536132812e+02 1.9763000309467316e-01 1.5837399291992188e+02 -1.2334700012207031e+02 8.3656996488571167e-01 1.5477799987792969e+02 -1.2327300262451172e+02 1.9071099758148193e+00 1.5132099914550781e+02 -1.2316899871826172e+02 3.3997900485992432e+00 1.4651699829101562e+02 -1.2344300079345703e+02 6.4398102760314941e+00 1.4234800720214844e+02 -1.2295199584960938e+02 1.0149800300598145e+01 1.3995201110839844e+02 -1.2291600036621094e+02 1.3060400009155273e+01 1.3792399597167969e+02 -1.2285099792480469e+02 1.6224300384521484e+01 1.3628700256347656e+02 -1.2282399749755859e+02 1.9598800659179688e+01 1.3505299377441406e+02 -1.2278799438476562e+02 2.3161201477050781e+01 1.3450500488281250e+02 -1.2276999664306641e+02 3.8068500518798828e+01 1.3547499084472656e+02 -1.2261699676513672e+02 4.1714500427246094e+01 1.3685398864746094e+02 -1.2283799743652344e+02 4.5187599182128906e+01 1.3864900207519531e+02 -1.2287600708007812e+02 4.8504901885986328e+01 1.4100999450683594e+02 -1.2318699645996094e+02 5.1810398101806641e+01 1.4616799926757812e+02 -1.2303800201416016e+02 5.6845798492431641e+01 1.4927700805664062e+02 -1.2314399719238281e+02 5.8973201751708984e+01 1.5610900878906250e+02 -1.2330699920654297e+02 6.2042499542236328e+01 1.5977000427246094e+02 -1.2338899993896484e+02 6.2957397460937500e+01 1.9330200195312500e+02 -1.0483100128173828e+02 3.6437702178955078e+01 1.5825199890136719e+02 -1.0420200347900391e+02 5.9053100585937500e+01 1.4757398986816406e+02 -1.0387799835205078e+02 5.3113201141357422e+01 1.3719799804687500e+02 -1.0868099975585938e+02 4.5190402984619141e+01 1.3603399658203125e+02 -1.0644300079345703e+02 4.0271697998046875e+01 1.3484799194335938e+02 -1.0864499664306641e+02 3.8070297241210938e+01 1.3493199157714844e+02 -1.0629899597167969e+02 3.2110900878906250e+01 1.3459399414062500e+02 -1.0862000274658203e+02 2.6859498977661133e+01 1.3431900024414062e+02 -1.0863800048828125e+02 3.4342502593994141e+01 1.6204699707031250e+02 -1.0676799774169922e+02 6.2453502655029297e+01 1.6386000061035156e+02 -1.0933200073242188e+02 6.3429103851318359e+01 1.6759201049804688e+02 -1.0826099395751953e+02 6.3448696136474609e+01 1.7425900268554688e+02 -1.0608699798583984e+02 6.0970897674560547e+01 1.7129699707031250e+02 -1.0893399810791016e+02 6.3041999816894531e+01 1.7500599670410156e+02 -1.0963000488281250e+02 6.2180400848388672e+01 1.7987098693847656e+02 -1.0720100402832031e+02 5.9432903289794922e+01 1.8163600158691406e+02 -1.0951699829101562e+02 5.9349399566650391e+01 1.8598399353027344e+02 -1.0734999847412109e+02 5.5402801513671875e+01 1.8503199768066406e+02 -1.0985299682617188e+02 5.7123798370361328e+01 1.8795800781250000e+02 -1.0993000030517578e+02 5.4625000000000000e+01 1.9208100891113281e+02 -1.0748699951171875e+02 4.8596797943115234e+01 1.9261000061035156e+02 -1.0977199554443359e+02 4.8989097595214844e+01 1.9450999450683594e+02 -1.1009000396728516e+02 4.5609001159667969e+01 1.9608599853515625e+02 -1.0948400115966797e+02 4.1679100036621094e+01 1.9708700561523438e+02 -1.0773999786376953e+02 3.0806400299072266e+01 1.9707000732421875e+02 -1.0963700103759766e+02 3.8171802520751953e+01 1.9754699707031250e+02 -1.1015900421142578e+02 3.4796901702880859e+01 1.9768400573730469e+02 -1.1015499877929688e+02 3.1028600692749023e+01 1.9737899780273438e+02 -1.1016000366210938e+02 2.7290599822998047e+01 1.9543200683593750e+02 -1.0757900238037109e+02 2.2128601074218750e+01 1.9663099670410156e+02 -1.1014000701904297e+02 2.3604198455810547e+01 1.9545100402832031e+02 -1.1010599517822266e+02 2.0027599334716797e+01 1.9205500793457031e+02 -1.0699000549316406e+02 1.5500499725341797e+01 1.9215100097656250e+02 -1.0977099609375000e+02 1.3829999923706055e+01 1.8952700805664062e+02 -1.0879299926757812e+02 1.0474100112915039e+01 1.8503999328613281e+02 -1.0732699584960938e+02 7.3311901092529297e+00 1.8684100341796875e+02 -1.0989200592041016e+02 7.8452200889587402e+00 1.8387500000000000e+02 -1.0983300018310547e+02 5.5462698936462402e+00 1.7877400207519531e+02 -1.0717400360107422e+02 3.5442099571228027e+00 1.8065499877929688e+02 -1.0973799896240234e+02 3.6118600368499756e+00 1.7721598815917969e+02 -1.0967600250244141e+02 2.0667898654937744e+00 1.7161000061035156e+02 -1.0649400329589844e+02 1.5715399980545044e+00 1.7214601135253906e+02 -1.0914699554443359e+02 6.5557599067687988e-01 1.6298500061035156e+02 -1.0695199584960938e+02 7.7561104297637939e-01 1.6617999267578125e+02 -1.0941100311279297e+02 1.3945699902251363e-03 1.6241999816894531e+02 -1.0931699371337891e+02 1.9819000363349915e-01 1.5524299621582031e+02 -1.0886399841308594e+02 1.8690799474716187e+00 1.5705299377441406e+02 -1.0596800231933594e+02 2.5497701168060303e+00 1.5056100463867188e+02 -1.0598199462890625e+02 5.2437801361083984e+00 1.5166200256347656e+02 -1.0904199981689453e+02 3.4010400772094727e+00 1.4592500305175781e+02 -1.0866699981689453e+02 7.1331300735473633e+00 1.4467999267578125e+02 -1.0634600067138672e+02 9.3220500946044922e+00 1.4269000244140625e+02 -1.0882599639892578e+02 1.0151299476623535e+01 1.4000999450683594e+02 -1.0623300170898438e+02 1.4962400436401367e+01 1.4029598999023438e+02 -1.0877799987792969e+02 1.3059900283813477e+01 1.3686900329589844e+02 -1.0838200378417969e+02 1.9115400314331055e+01 1.3682000732421875e+02 -1.0631799316406250e+02 2.1207601547241211e+01 1.3539599609375000e+02 -1.0865999603271484e+02 2.3163400650024414e+01 1.3613000488281250e+02 -1.0516099548339844e+02 2.6607200622558594e+01 1.3876300048828125e+02 -1.0620199584960938e+02 4.6424797058105469e+01 1.3899398803710938e+02 -1.0874799346923828e+02 4.8506900787353516e+01 1.4297099304199219e+02 -1.0630500030517578e+02 5.2417301177978516e+01 1.4117599487304688e+02 -1.0877999877929688e+02 5.1590202331542969e+01 1.4367898559570312e+02 -1.0885500335693359e+02 5.4368701934814453e+01 1.4846899414062500e+02 -1.0643800354003906e+02 5.7253200531005859e+01 1.4651100158691406e+02 -1.0891899871826172e+02 5.6846099853515625e+01 1.4961900329589844e+02 -1.0900299835205078e+02 5.8972499847412109e+01 1.5494799804687500e+02 -1.0659600067138672e+02 6.0662300109863281e+01 1.5559298706054688e+02 -1.0881900024414062e+02 6.1718898773193359e+01 1.6011599731445312e+02 -1.0926100158691406e+02 6.2957897186279297e+01 1.9539498901367188e+02 -1.0634500122070312e+02 3.8317699432373047e+01 1.6553799438476562e+02 -1.0450600433349609e+02 6.0338699340820312e+01 1.8928498840332031e+02 -1.0531300354003906e+02 4.9222599029541016e+01 1.9466899108886719e+02 -1.0537599945068359e+02 2.7943401336669922e+01 1.9270500183105469e+02 -1.0578800201416016e+02 1.9422800064086914e+01 1.8387699890136719e+02 -1.0516600036621094e+02 8.8186302185058594e+00 1.7489900207519531e+02 -1.0490000152587891e+02 4.3549499511718750e+00 1.6405900573730469e+02 -1.0456800079345703e+02 3.0984301567077637e+00 1.5423699951171875e+02 -1.0430999755859375e+02 5.6232800483703613e+00 1.4509100341796875e+02 -1.0417199707031250e+02 1.1932199478149414e+01 1.3969599914550781e+02 -1.0450000000000000e+02 1.8817798614501953e+01 1.3744300842285156e+02 -1.0395299530029297e+02 3.4600196838378906e+01 1.3872499084472656e+02 -1.0447700500488281e+02 4.2476299285888672e+01 1.4203601074218750e+02 -1.0401999664306641e+02 4.7418300628662109e+01 1.5235299682617188e+02 -1.0480800628662109e+02 5.7723602294921875e+01 1.6244601440429688e+02 -1.2816799926757812e+02 4.5115501403808594e+01 1.6518499755859375e+02 -1.2932699584960938e+02 4.5350299835205078e+01 1.7238600158691406e+02 -1.2841000366210938e+02 4.3757499694824219e+01 1.7269200134277344e+02 -1.2950999450683594e+02 4.3400802612304688e+01 1.7728599548339844e+02 -1.2962100219726562e+02 3.8146999359130859e+01 1.7805999755859375e+02 -1.2854798889160156e+02 3.6953300476074219e+01 1.7916999816894531e+02 -1.2966699218750000e+02 3.2073898315429688e+01 1.7882299804687500e+02 -1.2856599426269531e+02 2.8015998840332031e+01 1.7728599548339844e+02 -1.2962100219726562e+02 2.5352998733520508e+01 1.7177600097656250e+02 -1.2839500427246094e+02 1.9412300109863281e+01 1.7218899536132812e+02 -1.2949700927734375e+02 1.9923898696899414e+01 1.6575300598144531e+02 -1.2934100341796875e+02 1.8149599075317383e+01 1.6297799682617188e+02 -1.2818099975585938e+02 1.8381799697875977e+01 1.5824600219726562e+02 -1.2915899658203125e+02 2.0099100112915039e+01 1.5508000183105469e+02 -1.2798899078369141e+02 2.2631000518798828e+01 1.5365199279785156e+02 -1.2904701232910156e+02 2.5352998733520508e+01 1.5182598876953125e+02 -1.2791000366210938e+02 3.2383598327636719e+01 1.5203199768066406e+02 -1.2900799560546875e+02 3.1750001907348633e+01 1.5365199279785156e+02 -1.2904701232910156e+02 3.8146999359130859e+01 1.5488200378417969e+02 -1.2798400115966797e+02 4.0423599243164062e+01 1.5874800109863281e+02 -1.2917100524902344e+02 4.3576099395751953e+01 1.7085800170898438e+02 -1.2946499633789062e+02 2.8769298553466797e+01 1.7162600708007812e+02 -1.2948399353027344e+02 3.1616199493408203e+01 1.5995500183105469e+02 -1.2919999694824219e+02 2.9006299972534180e+01 1.6141099548339844e+02 -1.2923599243164062e+02 2.7168600082397461e+01 1.6316000366210938e+02 -1.2927799987792969e+02 2.6038799285888672e+01 1.6485899353027344e+02 -1.2931900024414062e+02 3.7880100250244141e+01 1.6208100891113281e+02 -1.2925199890136719e+02 3.6894599914550781e+01 1.6777700805664062e+02 -1.2938999938964844e+02 3.7461200714111328e+01 1.6885598754882812e+02 -1.2941600036621094e+02 2.6605400085449219e+01 1.6607800292968750e+02 -1.2934899902343750e+02 2.5619899749755859e+01 1.5931199645996094e+02 -1.2918501281738281e+02 3.1883798599243164e+01 1.7070298767089844e+02 -1.2946099853515625e+02 3.5130401611328125e+01 1.6007901000976562e+02 -1.2920300292968750e+02 3.4730598449707031e+01 1.6275300598144531e+02 -1.2817601013183594e+02 2.0637800216674805e+01 1.5408299255371094e+02 -1.2796500396728516e+02 2.8797399520874023e+01 1.6413099670410156e+02 -1.2820899963378906e+02 4.3274600982666016e+01 1.7457998657226562e+02 -1.2843499755859375e+02 3.9083999633789062e+01 1.7613500976562500e+02 -1.2850099182128906e+02 2.7540000915527344e+01 1.7058599853515625e+02 -1.2836599731445312e+02 2.1761400222778320e+01 1.6775799560546875e+02 -1.1986199951171875e+02 3.7555999755859375e+01 1.6482501220703125e+02 -1.1979100036621094e+02 3.7847797393798828e+01 1.6209199523925781e+02 -1.1972399902343750e+02 3.6742603302001953e+01 1.6018598937988281e+02 -1.1967800140380859e+02 3.4493698120117188e+01 1.5962600708007812e+02 -1.1966400146484375e+02 3.2487796783447266e+01 1.5975399780273438e+02 -1.1966799926757812e+02 3.0146099090576172e+01 1.6118000793457031e+02 -1.1970199584960938e+02 2.7565799713134766e+01 1.6364199829101562e+02 -1.1976200103759766e+02 2.5943899154663086e+01 1.6569999694824219e+02 -1.1981199645996094e+02 2.5629400253295898e+01 1.6800900268554688e+02 -1.1986800384521484e+02 2.6038799285888672e+01 1.7093400573730469e+02 -1.1993900299072266e+02 2.8369499206542969e+01 1.7185699462890625e+02 -1.1996199798583984e+02 3.1883798599243164e+01 1.7109001159667969e+02 -1.1994300079345703e+02 3.4730598449707031e+01 1.6975801086425781e+02 -1.1991100311279297e+02 3.6331298828125000e+01 1.6377099609375000e+02 -1.2774300384521484e+02 4.3063301086425781e+01 1.7588600158691406e+02 -1.2803700256347656e+02 3.7752700805664062e+01 1.7695500183105469e+02 -1.2806298828125000e+02 2.9869199752807617e+01 1.7146099853515625e+02 -1.2793000030517578e+02 2.1340499877929688e+01 1.5949299621582031e+02 -1.2763899230957031e+02 2.1372200012207031e+01 1.5515400695800781e+02 -1.2753400421142578e+02 2.5707698822021484e+01 1.5425000000000000e+02 -1.2751199340820312e+02 3.5882598876953125e+01 1.5508399963378906e+02 -1.2753200531005859e+02 3.7673999786376953e+01 1.5705700683593750e+02 -1.1960800170898438e+02 2.3373498916625977e+01 1.5530900573730469e+02 -1.1956500244140625e+02 2.5759700775146484e+01 1.5402799987792969e+02 -1.1953400421142578e+02 2.8818498611450195e+01 1.5372900390625000e+02 -1.1952600097656250e+02 3.2988601684570312e+01 1.5487500000000000e+02 -1.1955499267578125e+02 3.7009399414062500e+01 1.6044200134277344e+02 -1.1968900299072266e+02 2.0921598434448242e+01 1.6863000488281250e+02 -1.1988800048828125e+02 2.0074300765991211e+01 1.6446200561523438e+02 -1.1978700256347656e+02 1.9775899887084961e+01 1.6276899719238281e+02 -1.1974600219726562e+02 4.3425601959228516e+01 1.6693800354003906e+02 -1.1984799957275391e+02 4.3724102020263672e+01 1.5651899719238281e+02 -1.1959400177001953e+02 3.9468299865722656e+01 1.5895399475097656e+02 -1.1965399932861328e+02 4.1718898773193359e+01 1.7544799804687500e+02 -1.2005400085449219e+02 2.4690101623535156e+01 1.7244599914550781e+02 -1.1998099517822266e+02 2.1781000137329102e+01 1.7757501220703125e+02 -1.2010599517822266e+02 2.9383399963378906e+01 1.7434300231933594e+02 -1.2002799987792969e+02 4.0126399993896484e+01 1.7609100341796875e+02 -1.2006999969482422e+02 3.7740303039550781e+01 1.7737199401855469e+02 -1.2010099792480469e+02 3.4681400299072266e+01 1.7095799255371094e+02 -1.1994499969482422e+02 4.2578300476074219e+01 1.6464399719238281e+02 -1.2776399993896484e+02 1.9740798950195312e+01 1.6880198669433594e+02 -1.2786499786376953e+02 2.0170000076293945e+01 1.7414900207519531e+02 -1.2799500274658203e+02 2.3369699478149414e+01 1.7649301147460938e+02 -1.2805200195312500e+02 2.6831901550292969e+01 1.7751200866699219e+02 -1.2807699584960938e+02 3.0887199401855469e+01 1.7708300781250000e+02 -1.2806600952148438e+02 3.5046699523925781e+01 1.7388400268554688e+02 -1.2798899078369141e+02 4.0395000457763672e+01 1.7042300415039062e+02 -1.2790499877929688e+02 4.2739799499511719e+01 1.6636900329589844e+02 -1.2780599212646484e+02 4.3759201049804688e+01 1.6221099853515625e+02 -1.2770499420166016e+02 4.3329998016357422e+01 1.5845001220703125e+02 -1.2761400604248047e+02 4.1504100799560547e+01 1.5631700134277344e+02 -1.2756200408935547e+02 3.9462699890136719e+01 1.5350100708007812e+02 -1.2749401092529297e+02 3.2612598419189453e+01 1.5392999267578125e+02 -1.2750400543212891e+02 2.8453300476074219e+01 1.5712899780273438e+02 -1.2758200073242188e+02 2.3104999542236328e+01 1.6140399169921875e+02 -1.2768599700927734e+02 2.0474700927734375e+01 1.6094200134277344e+02 -1.1694300079345703e+02 3.1753997802734375e+01 1.6061900329589844e+02 -1.2963198852539062e+02 3.1266998291015625e+01 1.6159098815917969e+02 -1.1697599792480469e+02 2.9195501327514648e+01 1.6152099609375000e+02 -1.2965699768066406e+02 2.8949100494384766e+01 1.6300299072265625e+02 -1.2969599914550781e+02 2.7576400756835938e+01 1.6345599365234375e+02 -1.1700399780273438e+02 2.7483999252319336e+01 1.6498599243164062e+02 -1.2973600769042969e+02 2.6912199020385742e+01 1.6585899353027344e+02 -1.1705300140380859e+02 2.6854301452636719e+01 1.6709298706054688e+02 -1.2979200744628906e+02 2.7195699691772461e+01 1.6822299194335938e+02 -1.1711399841308594e+02 2.7576400756835938e+01 1.6954499816894531e+02 -1.2984899902343750e+02 2.9002399444580078e+01 1.7002999877929688e+02 -1.1716000366210938e+02 2.9393301010131836e+01 1.7060301208496094e+02 -1.1718799591064453e+02 3.2082500457763672e+01 1.7028201293945312e+02 -1.2986599731445312e+02 3.2710998535156250e+01 1.6980799865722656e+02 -1.1714299774169922e+02 3.4547000885009766e+01 1.6872799682617188e+02 -1.2983399963378906e+02 3.5315498352050781e+01 1.6740199279785156e+02 -1.1709800720214844e+02 3.6304298400878906e+01 1.6656399536132812e+02 -1.2978700256347656e+02 3.6516700744628906e+01 1.6529400634765625e+02 -1.1705099487304688e+02 3.6587799072265625e+01 1.6400300598144531e+02 -1.2971000671386719e+02 3.6385200500488281e+01 1.6331100463867188e+02 -1.1699500274658203e+02 3.5923500061035156e+01 1.6137200927734375e+02 -1.2964999389648438e+02 3.4497600555419922e+01 1.6150500488281250e+02 -1.1695300292968750e+02 3.4106700897216797e+01 1.7078498840332031e+02 -1.1662200164794922e+02 3.5297698974609375e+01 1.6785398864746094e+02 -1.1651100158691406e+02 3.7523998260498047e+01 1.6355599975585938e+02 -1.1642099761962891e+02 3.7478599548339844e+01 1.6210099792480469e+02 -1.1636599731445312e+02 3.6635200500488281e+01 1.5993798828125000e+02 -1.1633999633789062e+02 3.3612602233886719e+01 1.6083799743652344e+02 -1.1634899902343750e+02 2.8091098785400391e+01 1.6263900756835938e+02 -1.1636299896240234e+02 2.6475799560546875e+01 1.6482099914550781e+02 -1.1639800262451172e+02 2.5690599441528320e+01 1.6906100463867188e+02 -1.1654399871826172e+02 2.6548599243164062e+01 1.7147200012207031e+02 -1.1659600067138672e+02 2.9507101058959961e+01 1.5950599670410156e+02 -1.3037500000000000e+02 3.3333099365234375e+01 1.6312699890136719e+02 -1.3043899536132812e+02 3.7441398620605469e+01 1.6710501098632812e+02 -1.3055400085449219e+02 3.7637901306152344e+01 1.7027899169921875e+02 -1.3060600280761719e+02 3.5534698486328125e+01 1.7114601135253906e+02 -1.3066198730468750e+02 2.9545598983764648e+01 1.6875999450683594e+02 -1.3058399963378906e+02 2.6581098556518555e+01 1.6331700134277344e+02 -1.3044599914550781e+02 2.5985099792480469e+01 1.5998899841308594e+02 -1.3038099670410156e+02 2.8920200347900391e+01 1.6534300231933594e+02 -1.3034700012207031e+02 3.7894100189208984e+01 1.6123100280761719e+02 -1.3024800109863281e+02 3.6222301483154297e+01 1.6024099731445312e+02 -1.3022300720214844e+02 3.4972499847412109e+01 1.5933700561523438e+02 -1.3020199584960938e+02 3.1082300186157227e+01 1.6138101196289062e+02 -1.3025100708007812e+02 2.7141201019287109e+01 1.6554499816894531e+02 -1.3035200500488281e+02 2.5605899810791016e+01 1.6711900329589844e+02 -1.3038999938964844e+02 2.5862300872802734e+01 1.7040699768066406e+02 -1.3046998596191406e+02 2.8128198623657227e+01 1.7156900024414062e+02 -1.3049900817871094e+02 3.1284000396728516e+01 1.7132400512695312e+02 -1.3049299621582031e+02 3.3528701782226562e+01 1.6859098815917969e+02 -1.3042601013183594e+02 3.7027099609375000e+01 1.5970399475097656e+02 -1.1671900177001953e+02 3.1187599182128906e+01 1.6006500244140625e+02 -1.1672799682617188e+02 2.9538700103759766e+01 1.6155900573730469e+02 -1.1676300048828125e+02 2.7277599334716797e+01 1.6345800781250000e+02 -1.1681000518798828e+02 2.6057399749755859e+01 1.6689099121093750e+02 -1.1689399719238281e+02 2.5758399963378906e+01 1.7061201477050781e+02 -1.1698299407958984e+02 2.7966499328613281e+01 1.7183900451660156e+02 -1.1701399993896484e+02 3.1187599182128906e+01 1.7163200378417969e+02 -1.1700900268554688e+02 3.3417999267578125e+01 1.6909100341796875e+02 -1.1694599914550781e+02 3.6920497894287109e+01 1.6577200317382812e+02 -1.1686599731445312e+02 3.7845298767089844e+01 1.6093099975585938e+02 -1.1674800109863281e+02 3.5533397674560547e+01 1.5978700256347656e+02 -1.0452500152587891e+02 1.9412300109863281e+01 1.6580999755859375e+02 -1.0357900238037109e+02 1.8149599075317383e+01 1.6974499511718750e+02 -1.0476700592041016e+02 1.8543500900268555e+01 1.7331700134277344e+02 -1.0376200103759766e+02 2.0099100112915039e+01 1.7626300048828125e+02 -1.0492599487304688e+02 2.2747499465942383e+01 1.7791099548339844e+02 -1.0387300109863281e+02 2.5352998733520508e+01 1.7988600158691406e+02 -1.0501399993896484e+02 3.0952600479125977e+01 1.7979598999023438e+02 -1.0391899871826172e+02 3.1426097869873047e+01 1.7791099548339844e+02 -1.0387300109863281e+02 3.8146999359130859e+01 1.7601300048828125e+02 -1.0491999816894531e+02 4.1379299163818359e+01 1.7281500244140625e+02 -1.0374900054931641e+02 4.3576000213623047e+01 1.6687600708007812e+02 -1.0469800567626953e+02 4.5435298919677734e+01 1.6637800598144531e+02 -1.0359300231933594e+02 4.5350299835205078e+01 1.5887199401855469e+02 -1.0341099548339844e+02 4.3400802612304688e+01 1.5729499816894531e+02 -1.0446500396728516e+02 4.2459201812744141e+01 1.5427699279785156e+02 -1.0329899597167969e+02 3.8146999359130859e+01 1.5250000000000000e+02 -1.0434799957275391e+02 3.3686298370361328e+01 1.5239300537109375e+02 -1.0325299835205078e+02 3.2073898315429688e+01 1.5373100280761719e+02 -1.0437799835205078e+02 2.6026800155639648e+01 1.5427699279785156e+02 -1.0329899597167969e+02 2.5352998733520508e+01 1.5937399291992188e+02 -1.0342299652099609e+02 1.9923898696899414e+01 1.6070500183105469e+02 -1.0345500183105469e+02 2.8769399642944336e+01 1.5993699645996094e+02 -1.0343699645996094e+02 3.1616199493408203e+01 1.6139698791503906e+02 -1.0347200012207031e+02 3.5733901977539062e+01 1.6325099182128906e+02 -1.0351700592041016e+02 3.7169399261474609e+01 1.6037300109863281e+02 -1.0344699859619141e+02 3.3920299530029297e+01 1.6336999511718750e+02 -1.0351999664306641e+02 2.6145000457763672e+01 1.6970199584960938e+02 -1.0367400360107422e+02 2.6757299423217773e+01 1.6696899414062500e+02 -1.0360700225830078e+02 2.5652200698852539e+01 1.7113000488281250e+02 -1.0370800018310547e+02 2.8273099899291992e+01 1.7210400390625000e+02 -1.0373199462890625e+02 3.0405899047851562e+01 1.7148399353027344e+02 -1.0371700286865234e+02 3.4730598449707031e+01 1.7216799926757812e+02 -1.0373400115966797e+02 3.2487796783447266e+01 1.6755899047851562e+02 -1.0362199401855469e+02 3.7692699432373047e+01 1.6948199462890625e+02 -1.0366900634765625e+02 3.6894599914550781e+01 1.6521899414062500e+02 -1.0356500244140625e+02 3.7847797393798828e+01 1.5714801025390625e+02 -1.0446099853515625e+02 2.4960100173950195e+01 1.6583299255371094e+02 -1.0470200347900391e+02 1.9769199371337891e+01 1.7556700134277344e+02 -1.0490900421142578e+02 2.5086700439453125e+01 1.6952900695800781e+02 -1.0476200103759766e+02 4.3022098541259766e+01 1.5884700012207031e+02 -1.0450299835205078e+02 4.0458999633789062e+01 1.5465499877929688e+02 -1.0440100097656250e+02 3.2574897766113281e+01 1.7690499877929688e+02 -1.0498400115966797e+02 3.4833301544189453e+01 1.6647200012207031e+02 -1.1312300109863281e+02 2.5619899749755859e+01 1.6355499267578125e+02 -1.1305200195312500e+02 2.6038799285888672e+01 1.6180500793457031e+02 -1.1300999450683594e+02 2.7168600082397461e+01 1.6034899902343750e+02 -1.1297400665283203e+02 2.9006299972534180e+01 1.5970599365234375e+02 -1.1295899963378906e+02 3.1883798599243164e+01 1.6047300720214844e+02 -1.1297699737548828e+02 3.4730598449707031e+01 1.6247500610351562e+02 -1.1302600097656250e+02 3.6894599914550781e+01 1.6525399780273438e+02 -1.1309400177001953e+02 3.7880100250244141e+01 1.6732699584960938e+02 -1.1314400482177734e+02 3.7692699432373047e+01 1.6947099304199219e+02 -1.1319599914550781e+02 3.6742603302001953e+01 1.7137699890136719e+02 -1.1324199676513672e+02 3.4493698120117188e+01 1.7202200317382812e+02 -1.1325799560546875e+02 3.0808401107788086e+01 1.7089900207519531e+02 -1.1323100280761719e+02 2.8273099899291992e+01 1.6925099182128906e+02 -1.1319100189208984e+02 2.6605400085449219e+01 1.6830999755859375e+02 -1.0519000244140625e+02 1.9961200714111328e+01 1.7656800842285156e+02 -1.0539100646972656e+02 2.7572000503540039e+01 1.7252799987792969e+02 -1.0529199981689453e+02 4.1189701080322266e+01 1.6198899841308594e+02 -1.0503599548339844e+02 4.3029300689697266e+01 1.5565499877929688e+02 -1.0488200378417969e+02 3.7723701477050781e+01 1.5480899047851562e+02 -1.0486199951171875e+02 3.5892200469970703e+01 1.5568899536132812e+02 -1.0488300323486328e+02 2.5724500656127930e+01 1.5694299316406250e+02 -1.0491400146484375e+02 2.3948301315307617e+01 1.6060499572753906e+02 -1.1297599792480469e+02 4.2578300476074219e+01 1.7450599670410156e+02 -1.1331299591064453e+02 2.3373498916625977e+01 1.7625399780273438e+02 -1.1335600280761719e+02 2.5759700775146484e+01 1.7753500366210938e+02 -1.1338599395751953e+02 2.8818498611450195e+01 1.6293301391601562e+02 -1.1303199768066406e+02 2.0074300765991211e+01 1.6710198974609375e+02 -1.1313299560546875e+02 1.9775899887084961e+01 1.5722000122070312e+02 -1.1289299774169922e+02 4.0126499176025391e+01 1.5547200012207031e+02 -1.1285099792480469e+02 3.7740303039550781e+01 1.5419100952148438e+02 -1.1281900024414062e+02 3.4681400299072266e+01 1.7785600280761719e+02 -1.1339499664306641e+02 3.1759098052978516e+01 1.7714700317382812e+02 -1.1337699890136719e+02 3.6143398284912109e+01 1.7112100219726562e+02 -1.1323100280761719e+02 2.0921598434448242e+01 1.6879400634765625e+02 -1.1317499542236328e+02 4.3425601959228516e+01 1.6462500000000000e+02 -1.1307299804687500e+02 4.3724102020263672e+01 1.5748899841308594e+02 -1.1289999389648438e+02 2.3104301452636719e+01 1.5987400817871094e+02 -1.1295700073242188e+02 2.1355998992919922e+01 1.7343998718261719e+02 -1.1328700256347656e+02 4.1198497772216797e+01 1.5386999511718750e+02 -1.1281199645996094e+02 3.1740699768066406e+01 1.5428900146484375e+02 -1.1282200622558594e+02 2.8450698852539062e+01 1.5548100280761719e+02 -1.1285000610351562e+02 2.5743700027465820e+01 1.6519400024414062e+02 -1.0511399841308594e+02 4.3759201049804688e+01 1.6935198974609375e+02 -1.0521499633789062e+02 4.3329998016357422e+01 1.7311300659179688e+02 -1.0530699920654297e+02 4.1504100799560547e+01 1.7602301025390625e+02 -1.0537700653076172e+02 3.8501800537109375e+01 1.7772999572753906e+02 -1.0541899871826172e+02 3.4685001373291016e+01 1.7802999877929688e+02 -1.0542599487304688e+02 3.0514299392700195e+01 1.7688499450683594e+02 -1.0539800262451172e+02 2.6492599487304688e+01 1.7443400573730469e+02 -1.0533899688720703e+02 2.3104999542236328e+01 1.7097300720214844e+02 -1.0525499725341797e+02 2.0760099411010742e+01 1.6276100158691406e+02 -1.0505500030517578e+02 2.0170000076293945e+01 1.5900000000000000e+02 -1.0496400451660156e+02 2.1995901107788086e+01 1.5438301086425781e+02 -1.0485099792480469e+02 2.8814901351928711e+01 1.5408399963378906e+02 -1.0484399414062500e+02 3.2985698699951172e+01 1.5767900085449219e+02 -1.0493199920654297e+02 4.0395000457763672e+01 1.6005900573730469e+02 -1.0498899841308594e+02 4.2141399383544922e+01 1.6128100585937500e+02 -1.0305500030517578e+02 3.2710998535156250e+01 1.6088299560546875e+02 -1.1573699951171875e+02 3.1742300033569336e+01 1.6201800537109375e+02 -1.0307200622558594e+02 2.9002399444580078e+01 1.6185800170898438e+02 -1.1576799774169922e+02 2.8949100494384766e+01 1.6430300903320312e+02 -1.1581700134277344e+02 2.6996700286865234e+01 1.6464900207519531e+02 -1.0313999938964844e+02 2.7114700317382812e+01 1.6721099853515625e+02 -1.0318700408935547e+02 2.6983200073242188e+01 1.6743099975585938e+02 -1.1590200042724609e+02 2.7195699691772461e+01 1.6937300109863281e+02 -1.0324499511718750e+02 2.8184499740600586e+01 1.6983700561523438e+02 -1.1597399902343750e+02 2.8953001022338867e+01 1.7053399658203125e+02 -1.0327600097656250e+02 2.9828699111938477e+01 1.7063200378417969e+02 -1.1596699523925781e+02 3.1417499542236328e+01 1.7128700256347656e+02 -1.0263800048828125e+02 3.5030101776123047e+01 1.7093499755859375e+02 -1.0328199768066406e+02 3.2263599395751953e+01 1.7022599792480469e+02 -1.1597000122070312e+02 3.3671199798583984e+01 1.6983000183105469e+02 -1.0326000213623047e+02 3.4886901855468750e+01 1.6874400329589844e+02 -1.1593999481201172e+02 3.5641700744628906e+01 1.6755999755859375e+02 -1.0320999908447266e+02 3.6385200500488281e+01 1.6626899719238281e+02 -1.1586900329589844e+02 3.6587799072265625e+01 1.6499899291992188e+02 -1.0313300323486328e+02 3.6516700744628906e+01 1.6369299316406250e+02 -1.1582499694824219e+02 3.6142799377441406e+01 1.6283599853515625e+02 -1.0308699798583984e+02 3.5315498352050781e+01 1.6197399902343750e+02 -1.1575900268554688e+02 3.4738300323486328e+01 1.6058000183105469e+02 -1.0229600524902344e+02 2.9103200912475586e+01 1.6381298828125000e+02 -1.0242799377441406e+02 2.6055900573730469e+01 1.6555101013183594e+02 -1.0239399719238281e+02 2.5657798767089844e+01 1.7129998779296875e+02 -1.0258300018310547e+02 2.8367401123046875e+01 1.6843000793457031e+02 -1.0254000091552734e+02 3.7444099426269531e+01 1.6669499206542969e+02 -1.0242199707031250e+02 3.7842197418212891e+01 1.6128500366210938e+02 -1.0233200073242188e+02 3.5536201477050781e+01 1.6190600585937500e+02 -1.0246800231933594e+02 2.7277599334716797e+01 1.5999400329589844e+02 -1.0242199707031250e+02 3.1283899307250977e+01 1.6023899841308594e+02 -1.0242799377441406e+02 3.3528800964355469e+01 1.6297200012207031e+02 -1.0249400329589844e+02 3.7027099609375000e+01 1.6508999633789062e+02 -1.0254499816894531e+02 3.7808101654052734e+01 1.7033200073242188e+02 -1.0267300415039062e+02 3.6222301483154297e+01 1.7205398559570312e+02 -1.0271500396728516e+02 3.3333900451660156e+01 1.7222599792480469e+02 -1.0271900177001953e+02 3.1082099914550781e+01 1.6926600646972656e+02 -1.0264699554443359e+02 2.6472900390625000e+01 1.6714799499511719e+02 -1.0259600067138672e+02 2.5691900253295898e+01 1.6082899475097656e+02 -1.1593399810791016e+02 3.5371799468994141e+01 1.6579100036621094e+02 -1.1605400085449219e+02 3.7845298767089844e+01 1.6985499572753906e+02 -1.1615299987792969e+02 3.6358699798583984e+01 1.7165200805664062e+02 -1.1619599914550781e+02 3.3417999267578125e+01 1.7185899353027344e+02 -1.1620099639892578e+02 3.1187599182128906e+01 1.7075399780273438e+02 -1.1617500305175781e+02 2.8128198623657227e+01 1.6810501098632812e+02 -1.1611100006103516e+02 2.6057399749755859e+01 1.6635600280761719e+02 -1.1606800079345703e+02 2.5654699325561523e+01 1.5993000793457031e+02 -1.1591100311279297e+02 3.0081899642944336e+01 1.5972399902343750e+02 -1.1590599822998047e+02 3.2312400817871094e+01 1.5828601074218750e+02 -1.0461500549316406e+02 1.4621100425720215e+01 1.5574499511718750e+02 -1.0455400085449219e+02 1.2879700660705566e+01 1.6461199951171875e+02 -1.0476799774169922e+02 1.2993499755859375e+01 1.6914700317382812e+02 -1.0487999725341797e+02 1.0462800025939941e+01 1.7111300659179688e+02 -1.0492599487304688e+02 1.3627799987792969e+01 1.7700498962402344e+02 -1.0506900024414062e+02 1.6447799682617188e+01 1.7989799499511719e+02 -1.0514099884033203e+02 1.5488900184631348e+01 1.8157699584960938e+02 -1.0518000030517578e+02 2.1113399505615234e+01 1.8500498962402344e+02 -1.0526499938964844e+02 2.2150098800659180e+01 1.8473899841308594e+02 -1.0525400543212891e+02 2.8731700897216797e+01 1.8706900024414062e+02 -1.0531500244140625e+02 2.8643800735473633e+01 1.5794700622558594e+02 -1.0460700225830078e+02 4.8720401763916016e+01 1.5652400207519531e+02 -1.0457299804687500e+02 5.0849899291992188e+01 1.5140199279785156e+02 -1.0444300079345703e+02 4.3703300476074219e+01 1.4997099304199219e+02 -1.0441400146484375e+02 4.5604900360107422e+01 1.4507398986816406e+02 -1.0429499816894531e+02 3.6415599822998047e+01 1.4785099792480469e+02 -1.0436100006103516e+02 3.6437900543212891e+01 1.4734600830078125e+02 -1.0434899902343750e+02 2.9923898696899414e+01 1.4552400207519531e+02 -1.0430599975585938e+02 2.6371999740600586e+01 1.4910000610351562e+02 -1.0439099884033203e+02 2.3630199432373047e+01 1.4828300476074219e+02 -1.0437300109863281e+02 2.0142198562622070e+01 1.5289900207519531e+02 -1.0448400115966797e+02 1.8315799713134766e+01 1.8668200683593750e+02 -1.0530599975585938e+02 3.7279899597167969e+01 1.8418200683593750e+02 -1.0524400329589844e+02 3.6799697875976562e+01 1.8136199951171875e+02 -1.0517500305175781e+02 4.2693298339843750e+01 1.8285499572753906e+02 -1.0521300506591797e+02 4.4751399993896484e+01 1.7669799804687500e+02 -1.0506200408935547e+02 4.7267002105712891e+01 1.7787500000000000e+02 -1.0509199523925781e+02 4.9400699615478516e+01 1.7075100708007812e+02 -1.0491699981689453e+02 4.9969100952148438e+01 1.7167900085449219e+02 -1.0494100189208984e+02 5.2233299255371094e+01 1.6423899841308594e+02 -1.0475900268554688e+02 5.0473701477050781e+01 1.6490599060058594e+02 -1.0477700042724609e+02 5.2957603454589844e+01 1.4611299133300781e+02 -1.0350699615478516e+02 2.3776700973510742e+01 1.4508999633789062e+02 -1.0348200225830078e+02 3.5602600097656250e+01 1.4830300903320312e+02 -1.0355999755859375e+02 4.3357799530029297e+01 1.5289300537109375e+02 -1.0367199707031250e+02 4.8392898559570312e+01 1.6226899719238281e+02 -1.0390000152587891e+02 5.2918098449707031e+01 1.7405700683593750e+02 -1.0418599700927734e+02 5.1555900573730469e+01 1.8234600830078125e+02 -1.0438700103759766e+02 4.5580902099609375e+01 1.8738299560546875e+02 -1.0451000213623047e+02 3.4710800170898438e+01 1.8612599182128906e+02 -1.0447899627685547e+02 2.4736101150512695e+01 1.8177099609375000e+02 -1.0437300109863281e+02 1.7269599914550781e+01 1.7158999633789062e+02 -1.0412599945068359e+02 1.0957599639892578e+01 1.6153900146484375e+02 -1.0388199615478516e+02 1.1002999305725098e+01 1.5360499572753906e+02 -1.0368900299072266e+02 1.4428199768066406e+01 1.5255799865722656e+02 -1.0224100494384766e+02 2.8115301132202148e+01 1.5561999511718750e+02 -1.0231400299072266e+02 2.1973999023437500e+01 1.6320300292968750e+02 -1.0249900054931641e+02 1.7826000213623047e+01 1.7055299377441406e+02 -1.0267800140380859e+02 1.8232900619506836e+01 1.7756700134277344e+02 -1.0284700012207031e+02 2.3105100631713867e+01 1.8033399963378906e+02 -1.0291499328613281e+02 3.1294900894165039e+01 1.7884300231933594e+02 -1.0288000488281250e+02 3.7684997558593750e+01 1.7476100158691406e+02 -1.0277899932861328e+02 4.3201099395751953e+01 1.6657400512695312e+02 -1.0258100128173828e+02 4.5968902587890625e+01 1.5940600585937500e+02 -1.0240699768066406e+02 4.4291500091552734e+01 1.5473100280761719e+02 -1.0229399871826172e+02 4.0127197265625000e+01 1.5219900512695312e+02 -1.0223200225830078e+02 3.4667297363281250e+01 1.5514401245117188e+02 -1.0372499847412109e+02 1.6447401046752930e+01 1.5057200622558594e+02 -1.0361400604248047e+02 2.1113399505615234e+01 1.4787100219726562e+02 -1.0354799652099609e+02 2.7062099456787109e+01 1.4736599731445312e+02 -1.0353600311279297e+02 3.3576202392578125e+01 1.4912001037597656e+02 -1.0357900238037109e+02 3.9869899749755859e+01 1.5291899108886719e+02 -1.0367099761962891e+02 4.5184097290039062e+01 1.5986999511718750e+02 -1.0383599853515625e+02 4.9622100830078125e+01 1.8483599853515625e+02 -1.0444699859619141e+02 3.3202899932861328e+01 1.8376499938964844e+02 -1.0441700744628906e+02 2.5024398803710938e+01 1.7925000000000000e+02 -1.0431099700927734e+02 1.8315700531005859e+01 1.7386299133300781e+02 -1.0418000030517578e+02 1.4621700286865234e+01 1.6753700256347656e+02 -1.0402600097656250e+02 1.2993599891662598e+01 1.6103599548339844e+02 -1.0386800384521484e+02 1.3627900123596191e+01 1.6790998840332031e+02 -1.0403499603271484e+02 5.0473800659179688e+01 1.7420199584960938e+02 -1.0418800354003906e+02 4.8719997406005859e+01 1.7951499938964844e+02 -1.0431700134277344e+02 4.4919403076171875e+01 1.8320800781250000e+02 -1.0440699768066406e+02 3.9530300140380859e+01 1.6552500915527344e+02 -1.0255599975585938e+02 2.7561700820922852e+01 1.6959098815917969e+02 -1.0265499877929688e+02 3.0404298782348633e+01 1.6245800781250000e+02 -1.0248200225830078e+02 3.1065500259399414e+01 1.6683999633789062e+02 -1.0258799743652344e+02 3.6440998077392578e+01 1.5221899414062500e+02 -1.0141899871826172e+02 2.8832700729370117e+01 1.5475000000000000e+02 -1.0148099517822266e+02 2.3372798919677734e+01 1.5942500305175781e+02 -1.0159400177001953e+02 1.9208398818969727e+01 1.6659399414062500e+02 -1.0176899719238281e+02 1.7531000137329102e+01 1.7478099060058594e+02 -1.0196700286865234e+02 2.0298799514770508e+01 1.7886300659179688e+02 -1.0206700134277344e+02 2.5815000534057617e+01 1.8035400390625000e+02 -1.0210300445556641e+02 3.2205101013183594e+01 1.7880799865722656e+02 -1.0206600189208984e+02 3.8021900177001953e+01 1.7492700195312500e+02 -1.0197100067138672e+02 4.2934997558593750e+01 1.6815899658203125e+02 -1.0180599975585938e+02 4.5832000732421875e+01 1.6216400146484375e+02 -1.0166099548339844e+02 4.5319698333740234e+01 1.5563999938964844e+02 -1.0150199890136719e+02 4.1526000976562500e+01 1.5257800292968750e+02 -1.0142900085449219e+02 3.5384700775146484e+01 1.6387500000000000e+02 -1.0170300292968750e+02 3.5701900482177734e+01 1.6351200866699219e+02 -1.0169400024414062e+02 2.7797500610351562e+01 1.6961100769042969e+02 -1.0184200286865234e+02 3.0404298782348633e+01 1.6908999633789062e+02 -1.0183000183105469e+02 3.4441200256347656e+01 1.7613198852539062e+02 -1.2837500000000000e+02 1.6232601165771484e+01 1.7425500488281250e+02 -1.2832800292968750e+02 1.2277999877929688e+01 1.6851499938964844e+02 -1.2819400024414062e+02 1.3071000099182129e+01 1.6420599365234375e+02 -1.2808399963378906e+02 1.0437799453735352e+01 1.5877500915527344e+02 -1.2795800018310547e+02 1.4064499855041504e+01 1.5287899780273438e+02 -1.2780900573730469e+02 1.4333999633789062e+01 1.5206800842285156e+02 -1.2779100036621094e+02 1.8580499649047852e+01 1.4837500000000000e+02 -1.2770099639892578e+02 2.3969499588012695e+01 1.4655799865722656e+02 -1.2765499877929688e+02 2.2150098800659180e+01 1.4674699401855469e+02 -1.2766100311279297e+02 3.0296899795532227e+01 1.4449400329589844e+02 -1.2760500335693359e+02 2.8643800735473633e+01 1.7361601257324219e+02 -1.2831401062011719e+02 4.8720298767089844e+01 1.7503898620605469e+02 -1.2834700012207031e+02 5.0849899291992188e+01 1.7892900085449219e+02 -1.2844300842285156e+02 4.4919403076171875e+01 1.8393200683593750e+02 -1.2856300354003906e+02 4.2824600219726562e+01 1.8262199401855469e+02 -1.2853300476074219e+02 3.9530502319335938e+01 1.8424899291992188e+02 -1.2857200622558594e+02 3.3202899932861328e+01 1.8683900451660156e+02 -1.2863400268554688e+02 3.1316198348999023e+01 1.8361500549316406e+02 -1.2855699157714844e+02 2.6700399398803711e+01 1.8340299987792969e+02 -1.2854998779296875e+02 1.9838600158691406e+01 1.8079598999023438e+02 -1.2848899841308594e+02 2.0806501388549805e+01 1.4459100341796875e+02 -1.2760700225830078e+02 3.5457099914550781e+01 1.4738099670410156e+02 -1.2767699432373047e+02 3.6799598693847656e+01 1.4769299316406250e+02 -1.2768299865722656e+02 4.3525901794433594e+01 1.5020098876953125e+02 -1.2774500274658203e+02 4.2693202972412109e+01 1.5486499023437500e+02 -1.2785899353027344e+02 4.7267002105712891e+01 1.5368800354003906e+02 -1.2782800292968750e+02 4.9400699615478516e+01 1.6081201171875000e+02 -1.2800300598144531e+02 4.9969100952148438e+01 1.5988400268554688e+02 -1.2797899627685547e+02 5.2233299255371094e+01 1.6732400512695312e+02 -1.2816099548339844e+02 5.0473701477050781e+01 1.6665699768066406e+02 -1.2814399719238281e+02 5.2957603454589844e+01 1.8661299133300781e+02 -1.2944099426269531e+02 2.8753999710083008e+01 1.8602000427246094e+02 -1.2942700195312500e+02 3.7128002166748047e+01 1.8325999450683594e+02 -1.2936000061035156e+02 4.3357700347900391e+01 1.7866999816894531e+02 -1.2924798583984375e+02 4.8392898559570312e+01 1.7272299194335938e+02 -1.2910400390625000e+02 5.1714900970458984e+01 1.6602900695800781e+02 -1.2894099426269531e+02 5.2982097625732422e+01 1.5581600952148438e+02 -1.2869299316406250e+02 5.0965301513671875e+01 1.4721000671386719e+02 -1.2848399353027344e+02 4.2792499542236328e+01 1.4447399902343750e+02 -1.2841799926757812e+02 3.4856201171875000e+01 1.4524400329589844e+02 -1.2843600463867188e+02 2.4470899581909180e+01 1.5231799316406250e+02 -1.2860800170898438e+02 1.4940099716186523e+01 1.6163499450683594e+02 -1.2883499145507812e+02 1.0747600555419922e+01 1.7183299255371094e+02 -1.2908200073242188e+02 1.1366499900817871e+01 1.8189799499511719e+02 -1.2932699584960938e+02 1.7860900878906250e+01 1.7952198791503906e+02 -1.3069200134277344e+02 2.9729099273681641e+01 1.7720899963378906e+02 -1.3063600158691406e+02 2.3910499572753906e+01 1.7294499206542969e+02 -1.3053298950195312e+02 1.9663499832153320e+01 1.6589898681640625e+02 -1.3036100769042969e+02 1.7531000137329102e+01 1.5764201354980469e+02 -1.3016200256347656e+02 1.9710000991821289e+01 1.5277500915527344e+02 -1.3004200744628906e+02 2.5478000640869141e+01 1.5122898864746094e+02 -1.3000500488281250e+02 3.1294900894165039e+01 1.5272000122070312e+02 -1.3004100036621094e+02 3.7684997558593750e+01 1.5680200195312500e+02 -1.3014100646972656e+02 4.3201099395751953e+01 1.6498899841308594e+02 -1.3033898925781250e+02 4.5968902587890625e+01 1.7215699768066406e+02 -1.3051300048828125e+02 4.4291500091552734e+01 1.7821900939941406e+02 -1.3066099548339844e+02 3.8275100708007812e+01 1.4672698974609375e+02 -1.2847399902343750e+02 3.3202899932861328e+01 1.4736199951171875e+02 -1.2848899841308594e+02 2.6700201034545898e+01 1.5018099975585938e+02 -1.2855799865722656e+02 2.0806699752807617e+01 1.5484500122070312e+02 -1.2867100524902344e+02 1.6233001708984375e+01 1.6079199218750000e+02 -1.2881599426269531e+02 1.3530799865722656e+01 1.6730400085449219e+02 -1.2897399902343750e+02 1.3026299476623535e+01 1.7359599304199219e+02 -1.2912599182128906e+02 1.4779600143432617e+01 1.7611199951171875e+02 -1.2918800354003906e+02 4.7267398834228516e+01 1.7016500854492188e+02 -1.2904299926757812e+02 4.9969100952148438e+01 1.6365299987792969e+02 -1.2888499450683594e+02 5.0473800659179688e+01 1.5736100769042969e+02 -1.2873199462890625e+02 4.8720100402832031e+01 1.5204800415039062e+02 -1.2860299682617188e+02 4.4919498443603516e+01 1.4835501098632812e+02 -1.2851400756835938e+02 3.9530399322509766e+01 1.7890899658203125e+02 -1.2925599670410156e+02 1.8580600738525391e+01 1.8260200500488281e+02 -1.2934500122070312e+02 2.3969400405883789e+01 1.8422900390625000e+02 -1.2938499450683594e+02 3.0297000885009766e+01 1.8359500122070312e+02 -1.2937001037597656e+02 3.6799697875976562e+01 1.8077600097656250e+02 -1.2930099487304688e+02 4.2693298339843750e+01 1.6687100219726562e+02 -1.3038499450683594e+02 2.7612300872802734e+01 1.6197200012207031e+02 -1.3026599121093750e+02 3.0404298782348633e+01 1.6394500732421875e+02 -1.3031401062011719e+02 3.6050701141357422e+01 1.6910499572753906e+02 -1.3043899536132812e+02 3.2434501647949219e+01 1.7934399414062500e+02 -1.3150100708007812e+02 2.8832700729370117e+01 1.7681199645996094e+02 -1.3143899536132812e+02 2.3372699737548828e+01 1.7213800048828125e+02 -1.3132600402832031e+02 1.9208398818969727e+01 1.6496899414062500e+02 -1.3115200805664062e+02 1.7531000137329102e+01 1.5678199768066406e+02 -1.3095399475097656e+02 2.0298799514770508e+01 1.5270001220703125e+02 -1.3085299682617188e+02 2.5815000534057617e+01 1.5120999145507812e+02 -1.3081799316406250e+02 3.2205001831054688e+01 1.5275500488281250e+02 -1.3085499572753906e+02 3.8021999359130859e+01 1.5762298583984375e+02 -1.3097399902343750e+02 4.3789901733398438e+01 1.6587899780273438e+02 -1.3117399597167969e+02 4.5968902587890625e+01 1.7292599487304688e+02 -1.3134500122070312e+02 4.3836502075195312e+01 1.7863301086425781e+02 -1.3148500061035156e+02 3.7344501495361328e+01 1.6908499145507812e+02 -1.3125100708007812e+02 3.2434501647949219e+01 1.6638900756835938e+02 -1.3118598937988281e+02 2.7480699539184570e+01 1.6195201110839844e+02 -1.3107800292968750e+02 3.0404298782348633e+01 1.6443499755859375e+02 -1.3113800048828125e+02 3.6195800781250000e+01 1.6405400085449219e+02 -1.0486000061035156e+02 2.0020698547363281e+01 1.6350000000000000e+02 -1.2758399200439453e+02 2.0021301269531250e+01 1.6550099182128906e+02 -1.2801200866699219e+02 1.9850099563598633e+01 1.6807398986816406e+02 -1.0495600128173828e+02 2.0021301269531250e+01 1.6752099609375000e+02 -1.2768199920654297e+02 2.0021301269531250e+01 1.6947300720214844e+02 -1.2772899627685547e+02 2.0529798507690430e+01 1.7130300903320312e+02 -1.2815399169921875e+02 2.1361200332641602e+01 1.7183500671386719e+02 -1.0504899597167969e+02 2.1341600418090820e+01 1.7298500061035156e+02 -1.2796500396728516e+02 2.2494998931884766e+01 1.7498300170898438e+02 -1.0550399780273438e+02 2.3887998580932617e+01 1.7563999938964844e+02 -1.2787899017333984e+02 2.5510799407958984e+01 1.7618800354003906e+02 -1.0538099670410156e+02 2.5513200759887695e+01 1.7654899597167969e+02 -1.2790100097656250e+02 2.7312999725341797e+01 1.7713000488281250e+02 -1.2829499816894531e+02 2.9243101119995117e+01 1.7769200134277344e+02 -1.0519000244140625e+02 2.9243198394775391e+01 1.7794700622558594e+02 -1.0552400207519531e+02 3.1514297485351562e+01 1.7739099121093750e+02 -1.2813499450683594e+02 3.1245901107788086e+01 1.7730999755859375e+02 -1.2791999816894531e+02 3.3261501312255859e+01 1.7743901062011719e+02 -1.0518400573730469e+02 3.5226699829101562e+01 1.7688499450683594e+02 -1.2790900421142578e+02 3.5234500885009766e+01 1.7613301086425781e+02 -1.2789100646972656e+02 3.7107299804687500e+01 1.7667601013183594e+02 -1.0554499816894531e+02 3.7107299804687500e+01 1.7506900024414062e+02 -1.0512799835205078e+02 3.9469902038574219e+01 1.7408999633789062e+02 -1.2822200012207031e+02 3.9944000244140625e+01 1.7217199707031250e+02 -1.2779499816894531e+02 4.1609203338623047e+01 1.7041000366210938e+02 -1.2775200653076172e+02 4.2593502044677734e+01 1.7095300292968750e+02 -1.0540699768066406e+02 4.2593502044677734e+01 1.6905101013183594e+02 -1.0536000061035156e+02 4.3265899658203125e+01 1.6651899719238281e+02 -1.2765699768066406e+02 4.3606998443603516e+01 1.6707099914550781e+02 -1.0493199920654297e+02 4.3606998443603516e+01 1.6449398803710938e+02 -1.2798799896240234e+02 4.3607398986816406e+01 1.6251200866699219e+02 -1.2756000518798828e+02 4.3265899658203125e+01 1.6115299987792969e+02 -1.0516799926757812e+02 4.2593502044677734e+01 1.6061000061035156e+02 -1.2751400756835938e+02 4.2593502044677734e+01 1.5884800720214844e+02 -1.2747100067138672e+02 4.1609203338623047e+01 1.5940100097656250e+02 -1.0474600219726562e+02 4.1609203338623047e+01 1.5782199096679688e+02 -1.0494100189208984e+02 4.0337902069091797e+01 1.5594599914550781e+02 -1.2754899597167969e+02 3.8830699920654297e+01 1.5487800598144531e+02 -1.2775500488281250e+02 3.7107299804687500e+01 1.5544000244140625e+02 -1.0464900207519531e+02 3.7107299804687500e+01 1.5467800903320312e+02 -1.0501100158691406e+02 3.5234500885009766e+01 1.5413500976562500e+02 -1.2735599517822266e+02 3.5234500885009766e+01 1.5425300598144531e+02 -1.0500099945068359e+02 3.3261501312255859e+01 1.5416699218750000e+02 -1.0499900054931641e+02 3.1244899749755859e+01 1.5388099670410156e+02 -1.2735000610351562e+02 2.9242898941040039e+01 1.5447200012207031e+02 -1.2736499023437500e+02 2.7312999725341797e+01 1.5572099304199219e+02 -1.0465700531005859e+02 2.5919300079345703e+01 1.5537500000000000e+02 -1.2753799438476562e+02 2.5513299942016602e+01 1.5657099914550781e+02 -1.2779599761962891e+02 2.3888200759887695e+01 1.5803700256347656e+02 -1.2745100402832031e+02 2.2491399765014648e+01 1.5857798767089844e+02 -1.0495299530029297e+02 2.2495100021362305e+01 1.5970799255371094e+02 -1.2749199676513672e+02 2.1361200332641602e+01 1.6154701232910156e+02 -1.2753699493408203e+02 2.0529798507690430e+01 1.6208999633789062e+02 -1.0519100189208984e+02 2.0529798507690430e+01 1.6724600219726562e+02 -1.0493700408935547e+02 4.7164001464843750e+01 1.5917199707031250e+02 -1.0474299621582031e+02 4.5612899780273438e+01 1.6007901000976562e+02 -1.0476499938964844e+02 1.7456001281738281e+01 1.7774499511718750e+02 -1.0519400024414062e+02 2.1550100326538086e+01 1.6372799682617188e+02 -1.0485199737548828e+02 1.6467399597167969e+01 1.8141398620605469e+02 -1.0528199768066406e+02 3.3582798004150391e+01 1.7847799682617188e+02 -1.0520999908447266e+02 4.1013000488281250e+01 1.5196501159667969e+02 -1.0456500244140625e+02 3.8088600158691406e+01 1.5151300048828125e+02 -1.0455400085449219e+02 2.6531000137329102e+01 1.7963999938964844e+02 -1.0523799896240234e+02 2.4365798950195312e+01 1.5012001037597656e+02 -1.2763800048828125e+02 3.3348003387451172e+01 1.5308900451660156e+02 -1.2771099853515625e+02 4.1018199920654297e+01 1.5860499572753906e+02 -1.2784300994873047e+02 4.5624698638916016e+01 1.7339399719238281e+02 -1.2820401000976562e+02 4.5041301727294922e+01 1.5572000122070312e+02 -1.2777400207519531e+02 1.9717199325561523e+01 1.6431700134277344e+02 -1.2798300170898438e+02 1.6304100036621094e+01 1.7907899475097656e+02 -1.2834199523925781e+02 2.4368600845336914e+01 1.7847601318359375e+02 -1.2832800292968750e+02 4.0151000976562500e+01 1.7715998840332031e+02 -1.2829499816894531e+02 2.1539199829101562e+01 1.8051699829101562e+02 -1.0551300048828125e+02 3.7337501525878906e+01 1.7486000061035156e+02 -1.0535700225830078e+02 4.4506500244140625e+01 1.7078800964355469e+02 -1.0525699615478516e+02 4.6530101776123047e+01 1.6394700622558594e+02 -1.0508900451660156e+02 4.7107299804687500e+01 1.5617799377441406e+02 -1.0491000366210938e+02 4.3647598266601562e+01 1.5340699768066406e+02 -1.0482800292968750e+02 4.0676097869873047e+01 1.5078700256347656e+02 -1.0476700592041016e+02 3.4432003021240234e+01 1.5064300537109375e+02 -1.0478700256347656e+02 3.0183700561523438e+01 1.5301100158691406e+02 -1.0483100128173828e+02 2.3392799377441406e+01 1.5643400573730469e+02 -1.0492599487304688e+02 1.9574100494384766e+01 1.6724200439453125e+02 -1.0518900299072266e+02 1.6302499771118164e+01 1.7224598693847656e+02 -1.0528100585937500e+02 1.7548700332641602e+01 1.7493901062011719e+02 -1.0536000061035156e+02 1.9098400115966797e+01 1.8069299316406250e+02 -1.0549599456787109e+02 2.6743900299072266e+01 1.8147500610351562e+02 -1.0555200195312500e+02 3.0500900268554688e+01 1.7232699584960938e+02 -1.2793900299072266e+02 1.7872200012207031e+01 1.6881599426269531e+02 -1.2782099914550781e+02 1.6583900451660156e+01 1.5931799316406250e+02 -1.2761999511718750e+02 1.7549301147460938e+01 1.5225599670410156e+02 -1.2743000793457031e+02 2.3686901092529297e+01 1.5049900817871094e+02 -1.2732399749755859e+02 2.7793298721313477e+01 1.5104701232910156e+02 -1.2740799713134766e+02 3.7337200164794922e+01 1.6336500549316406e+02 -1.2772700500488281e+02 4.7097103118896484e+01 1.6669100952148438e+02 -1.2780200195312500e+02 4.7164699554443359e+01 1.7021400451660156e+02 -1.2791000366210938e+02 4.6531299591064453e+01 1.7628500366210938e+02 -1.2803100585937500e+02 4.2931900024414062e+01 1.8009300231933594e+02 -1.2811300659179688e+02 3.7021800994873047e+01 1.8087600708007812e+02 -1.2813499450683594e+02 3.3416301727294922e+01 1.8045300292968750e+02 -1.2823699951171875e+02 2.7597700119018555e+01 1.8126599121093750e+02 -1.2016999816894531e+02 3.1822000503540039e+01 1.7341400146484375e+02 -1.2153700256347656e+02 1.8327899932861328e+01 1.5571800231933594e+02 -1.2007399749755859e+02 4.3580299377441406e+01 1.5753599548339844e+02 -1.1261000061035156e+02 1.8598999023437500e+01 1.5824600219726562e+02 -1.1262200164794922e+02 4.5241798400878906e+01 1.5270700073242188e+02 -1.1285199737548828e+02 2.3382099151611328e+01 1.5072000122070312e+02 -1.1278800201416016e+02 2.8405200958251953e+01 1.5050099182128906e+02 -1.1223000335693359e+02 3.4069999694824219e+01 1.5244599914550781e+02 -1.1276800537109375e+02 3.9512100219726562e+01 1.5495300292968750e+02 -1.1248899841308594e+02 4.2754898071289062e+01 1.6367700195312500e+02 -1.1267800140380859e+02 4.7156200408935547e+01 1.7042001342773438e+02 -1.1288599395751953e+02 4.6645801544189453e+01 1.7525100708007812e+02 -1.1295399475097656e+02 4.4078300476074219e+01 1.7850399780273438e+02 -1.1305599975585938e+02 4.0728401184082031e+01 1.8046900939941406e+02 -1.1313800048828125e+02 3.7023399353027344e+01 1.8134700012207031e+02 -1.1334300231933594e+02 3.1939100265502930e+01 1.8096099853515625e+02 -1.1304699707031250e+02 2.8284999847412109e+01 1.7961199951171875e+02 -1.1381900024414062e+02 2.4513099670410156e+01 1.7681401062011719e+02 -1.1378800201416016e+02 2.0767200469970703e+01 1.7199400329589844e+02 -1.1268599700927734e+02 1.7464300155639648e+01 1.6637300109863281e+02 -1.1263600158691406e+02 1.6277101516723633e+01 1.6260099792480469e+02 -1.1275299835205078e+02 1.6580900192260742e+01 1.5109098815917969e+02 -1.2017200469970703e+02 2.6625101089477539e+01 1.5021800231933594e+02 -1.1936800384521484e+02 3.0670200347900391e+01 1.6783100891113281e+02 -1.2019599914550781e+02 4.7166900634765625e+01 1.6238499450683594e+02 -1.1969800567626953e+02 4.6893001556396484e+01 1.5802600097656250e+02 -1.2027200317382812e+02 4.5227500915527344e+01 1.5305999755859375e+02 -1.1986399841308594e+02 4.0727897644042969e+01 1.5076400756835938e+02 -1.2005300140380859e+02 3.6179100036621094e+01 1.7324299621582031e+02 -1.2034600067138672e+02 4.5298000335693359e+01 1.7647900390625000e+02 -1.2007500457763672e+02 4.2910301208496094e+01 1.7973899841308594e+02 -1.2049700164794922e+02 3.8446098327636719e+01 1.8018800354003906e+02 -1.2019300079345703e+02 2.6236299514770508e+01 1.7786300659179688e+02 -1.1968099975585938e+02 2.2098199844360352e+01 1.7563200378417969e+02 -1.2046000671386719e+02 1.9900800704956055e+01 1.5403999328613281e+02 -1.1918299865722656e+02 2.1443799972534180e+01 1.5956900024414062e+02 -1.2023500061035156e+02 1.7465200424194336e+01 1.6519000244140625e+02 -1.2028399658203125e+02 1.6277900695800781e+01 1.6913600158691406e+02 -1.2015499877929688e+02 1.6606901168823242e+01 1.7463000488281250e+02 -1.1513899993896484e+02 1.4147300720214844e+01 1.6517700195312500e+02 -1.1501399993896484e+02 1.2399499893188477e+01 1.7016400146484375e+02 -1.1432799530029297e+02 1.5580499649047852e+01 1.5984800720214844e+02 -1.1425799560546875e+02 1.6005798339843750e+01 1.5427301025390625e+02 -1.1419400024414062e+02 1.9562099456787109e+01 1.4855599975585938e+02 -1.1465200042724609e+02 2.3546400070190430e+01 1.4944599914550781e+02 -1.1392000579833984e+02 3.4711200714111328e+01 1.5329399108886719e+02 -1.1443799591064453e+02 4.4073600769042969e+01 1.6255000305175781e+02 -1.1417900085449219e+02 4.8111400604248047e+01 1.7135598754882812e+02 -1.1446200561523438e+02 4.7653198242187500e+01 1.7938800048828125e+02 -1.1466799926757812e+02 4.1622001647949219e+01 1.8297599792480469e+02 -1.1493099975585938e+02 3.3571498870849609e+01 1.4613099670410156e+02 -1.1444599914550781e+02 3.2034198760986328e+01 1.6049099731445312e+02 -1.1478800201416016e+02 5.0506500244140625e+01 1.6820100402832031e+02 -1.1495800018310547e+02 5.1344100952148438e+01 1.8218598937988281e+02 -1.1531300354003906e+02 4.2365398406982422e+01 1.8541600036621094e+02 -1.1536100006103516e+02 2.9199798583984375e+01 1.8021499633789062e+02 -1.1527100372314453e+02 1.8578701019287109e+01 1.4585299682617188e+02 -1.1757399749755859e+02 3.1097299575805664e+01 1.4707400512695312e+02 -1.1762200164794922e+02 2.4457899093627930e+01 1.5008599853515625e+02 -1.1825700378417969e+02 2.6012699127197266e+01 1.5796899414062500e+02 -1.1783300018310547e+02 1.3778200149536133e+01 1.8266799926757812e+02 -1.1847999572753906e+02 2.1624200820922852e+01 1.8245300292968750e+02 -1.1854600524902344e+02 2.5527500152587891e+01 1.5006098937988281e+02 -1.1832199859619141e+02 3.7242698669433594e+01 1.5830299377441406e+02 -1.1839299774169922e+02 4.6615898132324219e+01 1.5412800598144531e+02 -1.1822399902343750e+02 4.3783500671386719e+01 1.6500599670410156e+02 -1.1815200042724609e+02 4.9343299865722656e+01 1.7166400146484375e+02 -1.1880599975585938e+02 4.7184200286865234e+01 1.7197300720214844e+02 -1.1815699768066406e+02 4.9808403015136719e+01 1.7846701049804688e+02 -1.1843199920654297e+02 4.4316200256347656e+01 1.8108099365234375e+02 -1.1933899688720703e+02 3.7596199035644531e+01 1.8319200134277344e+02 -1.1858799743652344e+02 3.5368301391601562e+01 1.6139900207519531e+02 -1.1859200286865234e+02 1.5581100463867188e+01 1.4786599731445312e+02 -1.1763700103759766e+02 4.0949501037597656e+01 1.7105400085449219e+02 -1.1863800048828125e+02 1.5680700302124023e+01 1.5397900390625000e+02 -1.1451100158691406e+02 1.5473199844360352e+01 1.4757600402832031e+02 -1.1436499786376953e+02 3.9410400390625000e+01 1.7753500366210938e+02 -1.1504799652099609e+02 4.8003498077392578e+01 1.5434100341796875e+02 -1.1786100006103516e+02 4.8210899353027344e+01 1.7036299133300781e+02 -1.1835099792480469e+02 1.1953899383544922e+01 1.7957901000976562e+02 -1.1849399566650391e+02 1.7009901046752930e+01 1.8544599914550781e+02 -1.1859400177001953e+02 3.5876598358154297e+01 1.5254499816894531e+02 -1.1427700042724609e+02 4.7313899993896484e+01 1.5926100158691406e+02 -1.1300800323486328e+02 1.1136799812316895e+01 1.5096899414062500e+02 -1.1319499969482422e+02 1.6171001434326172e+01 1.5377299499511719e+02 -1.1287400054931641e+02 1.3840699195861816e+01 1.4431199645996094e+02 -1.1266300201416016e+02 3.0086700439453125e+01 1.4437500000000000e+02 -1.1277099609375000e+02 3.3679298400878906e+01 1.4748400878906250e+02 -1.1294699859619141e+02 4.3076999664306641e+01 1.5111700439453125e+02 -1.1243099975585938e+02 4.7607196807861328e+01 1.5517201232910156e+02 -1.1285500335693359e+02 5.0573299407958984e+01 1.6047599792480469e+02 -1.1304399871826172e+02 5.2695198059082031e+01 1.6585800170898438e+02 -1.1318799591064453e+02 5.3386402130126953e+01 1.7127000427246094e+02 -1.1324299621582031e+02 5.2695301055908203e+01 1.7525799560546875e+02 -1.1360199737548828e+02 5.1165599822998047e+01 1.7881500244140625e+02 -1.1348400115966797e+02 4.9065799713134766e+01 1.8274000549316406e+02 -1.1357700347900391e+02 4.5303298950195312e+01 1.8500100708007812e+02 -1.1364099884033203e+02 4.1728897094726562e+01 1.8646099853515625e+02 -1.1413800048828125e+02 3.8151599884033203e+01 1.8739999389648438e+02 -1.1377099609375000e+02 3.3254398345947266e+01 1.8724099731445312e+02 -1.1367200469970703e+02 2.8728500366210938e+01 1.8602999877929688e+02 -1.1402799987792969e+02 2.4102800369262695e+01 1.8380400085449219e+02 -1.1386000061035156e+02 1.9724199295043945e+01 1.8078799438476562e+02 -1.1367700195312500e+02 1.6176799774169922e+01 1.7245199584960938e+02 -1.1330500030517578e+02 1.1158400535583496e+01 1.6873500061035156e+02 -1.1337899780273438e+02 1.0364299774169922e+01 1.6446701049804688e+02 -1.1313700103759766e+02 1.0151600837707520e+01 1.4800100708007812e+02 -1.1266200256347656e+02 1.9518301010131836e+01 1.4556700134277344e+02 -1.1269999694824219e+02 2.4295400619506836e+01 1.4520500183105469e+02 -1.1269499969482422e+02 3.8146598815917969e+01 1.7782199096679688e+02 -1.1340100097656250e+02 1.3708099365234375e+01 1.8095199584960938e+02 -1.2039800262451172e+02 4.7104198455810547e+01 1.8110800170898438e+02 -1.1883000183105469e+02 4.5576000213623047e+01 1.8407000732421875e+02 -1.2024800109863281e+02 4.3182102203369141e+01 1.6678900146484375e+02 -1.1981400299072266e+02 1.0142100334167480e+01 1.7265699768066406e+02 -1.2022600555419922e+02 1.1241899490356445e+01 1.5834001159667969e+02 -1.1961699676513672e+02 1.1411600112915039e+01 1.6288099670410156e+02 -1.1923100280761719e+02 1.0395900726318359e+01 1.5394900512695312e+02 -1.1904000091552734e+02 1.3651000022888184e+01 1.4591400146484375e+02 -1.1959799957275391e+02 2.3015499114990234e+01 1.4795300292968750e+02 -1.1937400054931641e+02 1.9386301040649414e+01 1.4408299255371094e+02 -1.1954800415039062e+02 3.1084600448608398e+01 1.4459300231933594e+02 -1.1928099822998047e+02 2.7069900512695312e+01 1.5288198852539062e+02 -1.1943800354003906e+02 4.9190200805664062e+01 1.4883599853515625e+02 -1.1939199829101562e+02 4.5286899566650391e+01 1.6152699279785156e+02 -1.1817800140380859e+02 5.1635002136230469e+01 1.5749501037597656e+02 -1.1962100219726562e+02 5.1771598815917969e+01 1.6715399169921875e+02 -1.1929199981689453e+02 5.3238601684570312e+01 1.6317500305175781e+02 -1.1967299652099609e+02 5.3234302520751953e+01 1.7506599426269531e+02 -1.1944699859619141e+02 5.1142200469970703e+01 1.8635299682617188e+02 -1.1980800628662109e+02 2.5571800231933594e+01 1.8725599670410156e+02 -1.2028700256347656e+02 2.9838201522827148e+01 1.8474400329589844e+02 -1.2022099304199219e+02 2.1457201004028320e+01 1.7736599731445312e+02 -1.2005599975585938e+02 1.3502200126647949e+01 1.8210501098632812e+02 -1.2019300079345703e+02 1.7687500000000000e+01 1.5061399841308594e+02 -1.1899600219726562e+02 1.6375699996948242e+01 1.4442098999023438e+02 -1.1897599792480469e+02 3.5381202697753906e+01 1.4586199951171875e+02 -1.1961299896240234e+02 4.0514801025390625e+01 1.7125000000000000e+02 -1.1994999694824219e+02 5.2682197570800781e+01 1.7772000122070312e+02 -1.2004700469970703e+02 4.9703502655029297e+01 1.8668699645996094e+02 -1.2018299865722656e+02 3.7060997009277344e+01 1.6338400268554688e+02 -1.0404100036621094e+02 5.3998600006103516e+01 1.6051199340820312e+02 -1.0389900207519531e+02 5.3488197326660156e+01 1.5782600402832031e+02 -1.0382699584960938e+02 5.2614601135253906e+01 1.5532901000976562e+02 -1.0384099578857422e+02 5.1425502777099609e+01 1.5289900207519531e+02 -1.0351100158691406e+02 4.9927398681640625e+01 1.5072700500488281e+02 -1.0366500091552734e+02 4.8109100341796875e+01 1.4879600524902344e+02 -1.0360799407958984e+02 4.6050601959228516e+01 1.4638101196289062e+02 -1.0335200500488281e+02 4.2717597961425781e+01 1.4474000549316406e+02 -1.0350800323486328e+02 3.8666698455810547e+01 1.4407199096679688e+02 -1.0352099609375000e+02 3.6033702850341797e+01 1.4369000244140625e+02 -1.0348100280761719e+02 3.3141399383544922e+01 1.4367300415039062e+02 -1.0328599548339844e+02 3.0403699874877930e+01 1.4405000305175781e+02 -1.0357399749755859e+02 2.7569898605346680e+01 1.4473800659179688e+02 -1.0331500244140625e+02 2.4792301177978516e+01 1.4574000549316406e+02 -1.0352300262451172e+02 2.2276500701904297e+01 1.4713899230957031e+02 -1.0337000274658203e+02 1.9701101303100586e+01 1.4880299377441406e+02 -1.0360500335693359e+02 1.7435699462890625e+01 1.5067900085449219e+02 -1.0365399932861328e+02 1.5428800582885742e+01 1.5289999389648438e+02 -1.0370499420166016e+02 1.3590799331665039e+01 1.5525999450683594e+02 -1.0356699371337891e+02 1.2075400352478027e+01 1.5782800292968750e+02 -1.0382399749755859e+02 1.0882300376892090e+01 1.6049600219726562e+02 -1.0389599609375000e+02 1.0014999389648438e+01 1.6327198791503906e+02 -1.0395700073242188e+02 9.4847698211669922e+00 1.6609199523925781e+02 -1.0383000183105469e+02 9.2892093658447266e+00 1.7010499572753906e+02 -1.0414999389648438e+02 9.6467695236206055e+00 1.7435899353027344e+02 -1.0403200531005859e+02 1.0868599891662598e+01 1.7690199279785156e+02 -1.0429699707031250e+02 1.2092100143432617e+01 1.7926800537109375e+02 -1.0434799957275391e+02 1.3592500686645508e+01 1.8145599365234375e+02 -1.0440800476074219e+02 1.5404000282287598e+01 1.8337998962402344e+02 -1.0425000000000000e+02 1.7421400070190430e+01 1.8503099060058594e+02 -1.0449499511718750e+02 1.9737899780273438e+01 1.8638400268554688e+02 -1.0452199554443359e+02 2.2195299148559570e+01 1.8743998718261719e+02 -1.0434899902343750e+02 2.4798900604248047e+01 1.8812200927734375e+02 -1.0456400299072266e+02 2.7565999984741211e+01 1.8847599792480469e+02 -1.0462799835205078e+02 3.3055202484130859e+01 1.8811700439453125e+02 -1.0457199859619141e+02 3.5961700439453125e+01 1.8744400024414062e+02 -1.0434899902343750e+02 3.8685001373291016e+01 1.8638000488281250e+02 -1.0452199554443359e+02 4.1312400817871094e+01 1.8503298950195312e+02 -1.0449299621582031e+02 4.3763298034667969e+01 1.8336300659179688e+02 -1.0444400024414062e+02 4.6059700012207031e+01 1.8145201110839844e+02 -1.0420400238037109e+02 4.8128501892089844e+01 1.7926699829101562e+02 -1.0442800140380859e+02 4.9897903442382812e+01 1.7688700866699219e+02 -1.0429699707031250e+02 5.1414798736572266e+01 1.7333200073242188e+02 -1.0423699951171875e+02 5.3023300170898438e+01 1.6889999389648438e+02 -1.0409799957275391e+02 5.4013500213623047e+01 1.6604800415039062e+02 -1.0383200073242188e+02 5.4210399627685547e+01 1.4578199768066406e+02 -1.2860900878906250e+02 2.0826900482177734e+01 1.4414399719238281e+02 -1.2837399291992188e+02 2.4811399459838867e+01 1.4318699645996094e+02 -1.2837399291992188e+02 2.8732599258422852e+01 1.4306900024414062e+02 -1.2854600524902344e+02 3.3167800903320312e+01 1.4344200134277344e+02 -1.2835598754882812e+02 3.5952301025390625e+01 1.4414100646972656e+02 -1.2836801147460938e+02 3.8678798675537109e+01 1.4516400146484375e+02 -1.2859700012207031e+02 4.1318302154541016e+01 1.4653900146484375e+02 -1.2842500305175781e+02 4.3774501800537109e+01 1.4819499206542969e+02 -1.2847299194335938e+02 4.6057800292968750e+01 1.5012200927734375e+02 -1.2851100158691406e+02 4.8106700897216797e+01 1.5227600097656250e+02 -1.2876899719238281e+02 4.9918800354003906e+01 1.5580200195312500e+02 -1.2867799377441406e+02 5.2062500000000000e+01 1.7104400634765625e+02 -1.2896800231933594e+02 5.3479198455810547e+01 1.6828900146484375e+02 -1.2895999145507812e+02 5.4013698577880859e+01 1.6547499084472656e+02 -1.2908999633789062e+02 5.4210399627685547e+01 1.6266999816894531e+02 -1.2882398986816406e+02 5.4013698577880859e+01 1.5990299987792969e+02 -1.2875199890136719e+02 5.3484600067138672e+01 1.7375099182128906e+02 -1.2928999328613281e+02 5.2629299163818359e+01 1.7628700256347656e+02 -1.2914599609375000e+02 5.1415100097656250e+01 1.7868399047851562e+02 -1.2921400451660156e+02 4.9892997741699219e+01 1.8074099731445312e+02 -1.2921099853515625e+02 4.8172298431396484e+01 1.8276899719238281e+02 -1.2950999450683594e+02 4.6075000762939453e+01 1.8441999816894531e+02 -1.2934399414062500e+02 4.3774200439453125e+01 1.8576000976562500e+02 -1.2938099670410156e+02 4.1332199096679688e+01 1.8684298706054688e+02 -1.2960900878906250e+02 3.8655399322509766e+01 1.8749600219726562e+02 -1.2944799804687500e+02 3.6105800628662109e+01 1.8799800109863281e+02 -1.2945899963378906e+02 3.1929899215698242e+01 1.8755400085449219e+02 -1.2943299865722656e+02 2.7697900772094727e+01 1.8681199645996094e+02 -1.2940600585937500e+02 2.4801601409912109e+01 1.8579598999023438e+02 -1.2938000488281250e+02 2.2241300582885742e+01 1.8441699218750000e+02 -1.2934899902343750e+02 1.9716300964355469e+01 1.8279100036621094e+02 -1.2931900024414062e+02 1.7471900939941406e+01 1.4819599914550781e+02 -1.2847100830078125e+02 1.7442300796508789e+01 1.5115499877929688e+02 -1.2851400756835938e+02 1.4413499832153320e+01 1.5464900207519531e+02 -1.2882600402832031e+02 1.2072100639343262e+01 1.5721499633789062e+02 -1.2869299316406250e+02 1.0887000083923340e+01 1.5990299987792969e+02 -1.2875300598144531e+02 1.0012900352478027e+01 1.6266000366210938e+02 -1.2882600402832031e+02 9.4853601455688477e+00 1.6547299194335938e+02 -1.2908999633789062e+02 9.2895603179931641e+00 1.6830200195312500e+02 -1.2896400451660156e+02 9.4854202270507812e+00 1.7105099487304688e+02 -1.2922500610351562e+02 9.9925403594970703e+00 1.7373699951171875e+02 -1.2909500122070312e+02 1.0883100509643555e+01 1.7631700134277344e+02 -1.2915399169921875e+02 1.2097800254821777e+01 1.7866101074218750e+02 -1.2921600341796875e+02 1.3589400291442871e+01 1.8084100341796875e+02 -1.2926000976562500e+02 1.5396099090576172e+01 1.9147900390625000e+02 -1.0444599914550781e+02 3.4001598358154297e+01 1.7566700744628906e+02 -1.0406199645996094e+02 5.5399600982666016e+01 1.4451600646972656e+02 -1.0330500030517578e+02 4.5334499359130859e+01 1.8911199951171875e+02 -1.2966699218750000e+02 2.2209800720214844e+01 1.9085800170898438e+02 -1.2970800781250000e+02 3.4052101135253906e+01 1.8431900024414062e+02 -1.2954998779296875e+02 1.4581999778747559e+01 1.4475399780273438e+02 -1.2858699035644531e+02 1.6903699874877930e+01 1.6462400817871094e+02 -1.0379599761962891e+02 5.7205497741699219e+01 1.7492199707031250e+02 -1.0404600524902344e+02 7.8342499732971191e+00 1.6824301147460938e+02 -1.0388399505615234e+02 6.3840699195861816e+00 1.8572999572753906e+02 -1.0430899810791016e+02 4.8017501831054688e+01 1.5061799621582031e+02 -1.0345699310302734e+02 5.2022098541259766e+01 1.4244900512695312e+02 -1.0325500488281250e+02 2.2213300704956055e+01 1.4725399780273438e+02 -1.0337200164794922e+02 1.4571099281311035e+01 1.8680999755859375e+02 -1.0433399963378906e+02 1.6905099868774414e+01 1.4309500122070312e+02 -1.0327199554443359e+02 4.2752098083496094e+01 1.9042300415039062e+02 -1.0442200469970703e+02 2.4287500381469727e+01 1.6012699890136719e+02 -1.0368999481201172e+02 6.9621801376342773e+00 1.6697599792480469e+02 -1.2912699890136719e+02 5.7196800231933594e+01 1.5122898864746094e+02 -1.2874400329589844e+02 1.0608799934387207e+01 1.6552099609375000e+02 -1.2909199523925781e+02 6.2534799575805664e+00 1.4393200683593750e+02 -1.2856300354003906e+02 4.5373996734619141e+01 1.4053500366210938e+02 -1.2848500061035156e+02 3.7007202148437500e+01 1.8094200134277344e+02 -1.2946600341796875e+02 5.2016002655029297e+01 1.8846299743652344e+02 -1.2964900207519531e+02 4.2762802124023438e+01 1.5002900695800781e+02 -1.2871499633789062e+02 5.2029598236083984e+01 1.7434899902343750e+02 -1.2930200195312500e+02 7.8535704612731934e+00 1.4088099670410156e+02 -1.2849000549316406e+02 2.5058099746704102e+01 1.8909400939941406e+02 -1.0464700317382812e+02 4.2684200286865234e+01 1.8443399047851562e+02 -1.1668899536132812e+02 4.8202297210693359e+01 1.8133099365234375e+02 -1.1674199676513672e+02 5.1138698577880859e+01 1.8207099914550781e+02 -1.0441500091552734e+02 5.1551498413085938e+01 1.7894500732421875e+02 -1.0438700103759766e+02 5.3753398895263672e+01 1.7406700134277344e+02 -1.1670999908447266e+02 5.5197200775146484e+01 1.7056800842285156e+02 -1.0419300079345703e+02 5.6836200714111328e+01 1.5835600280761719e+02 -1.0388100433349609e+02 5.6047500610351562e+01 1.5749899291992188e+02 -1.1606200408935547e+02 5.5199298858642578e+01 1.4195700073242188e+02 -1.0350199890136719e+02 3.9939002990722656e+01 1.4066299438476562e+02 -1.0338299560546875e+02 3.3689300537109375e+01 1.4094400024414062e+02 -1.1568699645996094e+02 3.2824199676513672e+01 1.4942900085449219e+02 -1.0368299865722656e+02 1.2464200019836426e+01 1.4852799987792969e+02 -1.1587699890136719e+02 1.3856999397277832e+01 1.5719200134277344e+02 -1.0394400024414062e+02 7.8717498779296875e+00 1.5554200744628906e+02 -1.1590499877929688e+02 9.0979900360107422e+00 1.5428799438476562e+02 -1.0374200439453125e+02 9.1812000274658203e+00 1.7213200378417969e+02 -1.0422599792480469e+02 6.9919199943542480e+00 1.6804100036621094e+02 -1.1643000030517578e+02 6.9988398551940918e+00 1.8951899719238281e+02 -1.1733199310302734e+02 2.4436800003051758e+01 1.9128700256347656e+02 -1.0469599914550781e+02 2.8027898788452148e+01 1.9100999450683594e+02 -1.0469100189208984e+02 3.7009601593017578e+01 1.9008399963378906e+02 -1.0466500091552734e+02 4.0347999572753906e+01 1.6708999633789062e+02 -1.0411199951171875e+02 5.7232101440429688e+01 1.5583700561523438e+02 -1.0383799743652344e+02 5.5081798553466797e+01 1.4835398864746094e+02 -1.0365500640869141e+02 5.0050300598144531e+01 1.4645500183105469e+02 -1.0369300079345703e+02 4.7961799621582031e+01 1.4061700439453125e+02 -1.0346700286865234e+02 3.1020500183105469e+01 1.4088800048828125e+02 -1.0347299957275391e+02 2.7974199295043945e+01 1.4154299926757812e+02 -1.0347499847412109e+02 2.4872598648071289e+01 1.4540899658203125e+02 -1.0353800201416016e+02 1.6851799011230469e+01 1.6326100158691406e+02 -1.0400099945068359e+02 6.4136400222778320e+00 1.7753300476074219e+02 -1.0447399902343750e+02 9.0196094512939453e+00 1.8031700134277344e+02 -1.0443299865722656e+02 1.0615799903869629e+01 1.8303500366210938e+02 -1.0448799896240234e+02 1.2704100608825684e+01 1.8486100769042969e+02 -1.0454299926757812e+02 1.4529299736022949e+01 1.8851100158691406e+02 -1.0461399841308594e+02 1.9639900207519531e+01 1.8968099975585938e+02 -1.0465899658203125e+02 2.2150098800659180e+01 1.9159899902343750e+02 -1.0473100280761719e+02 3.1837501525878906e+01 1.8383599853515625e+02 -1.0459099578857422e+02 5.0018703460693359e+01 1.4357000732421875e+02 -1.0371299743652344e+02 1.9882200241088867e+01 1.6606800842285156e+02 -1.0424500274658203e+02 6.2752399444580078e+00 1.9067500305175781e+02 -1.2944799804687500e+02 2.7975099563598633e+01 1.9005101013183594e+02 -1.2942599487304688e+02 2.5023700714111328e+01 1.8779499816894531e+02 -1.2938000488281250e+02 1.9461299896240234e+01 1.8618099975585938e+02 -1.2933500671386719e+02 1.6895401000976562e+01 1.8212899780273438e+02 -1.2924798583984375e+02 1.2466600418090820e+01 1.7708200073242188e+02 -1.2916299438476562e+02 9.0664596557617188e+00 1.6847799682617188e+02 -1.2896099853515625e+02 6.4432597160339355e+00 1.6247599792480469e+02 -1.2876300048828125e+02 6.4470200538635254e+00 1.5950199890136719e+02 -1.2868798828125000e+02 6.9787502288818359e+00 1.5663200378417969e+02 -1.2861900329589844e+02 7.8539800643920898e+00 1.5387399291992188e+02 -1.2856100463867188e+02 9.0700397491455078e+00 1.4882699584960938e+02 -1.2843699645996094e+02 1.2472899436950684e+01 1.4669599914550781e+02 -1.2839099121093750e+02 1.4541699409484863e+01 1.4187399291992188e+02 -1.2826100158691406e+02 2.2174301147460938e+01 1.4001699829101562e+02 -1.2821699523925781e+02 3.0958600997924805e+01 1.4010700988769531e+02 -1.2822500610351562e+02 3.3986301422119141e+01 1.4136199951171875e+02 -1.2825599670410156e+02 3.9938098907470703e+01 1.4247700500488281e+02 -1.2828799438476562e+02 4.2691600799560547e+01 1.4773799133300781e+02 -1.2840800476074219e+02 5.0033100128173828e+01 1.5251699829101562e+02 -1.2851699829101562e+02 5.3687198638916016e+01 1.5519000244140625e+02 -1.2858299255371094e+02 5.5061100006103516e+01 1.5801901245117188e+02 -1.2865798950195312e+02 5.6111598968505859e+01 1.6097499084472656e+02 -1.2872500610351562e+02 5.6830902099609375e+01 1.6999499511718750e+02 -1.2894599914550781e+02 5.6829200744628906e+01 1.7295399475097656e+02 -1.2902000427246094e+02 5.6107101440429688e+01 1.7574800109863281e+02 -1.2909199523925781e+02 5.5069202423095703e+01 1.8487199401855469e+02 -1.2918899536132812e+02 4.8293697357177734e+01 1.8702299499511719e+02 -1.2935600280761719e+02 4.5353099822998047e+01 1.8960299682617188e+02 -1.2943099975585938e+02 3.9933300018310547e+01 1.9041099548339844e+02 -1.2943998718261719e+02 3.6991100311279297e+01 1.9067199707031250e+02 -1.1706700134277344e+02 3.2027099609375000e+01 1.7146200561523438e+02 -1.2882299804687500e+02 6.9870901107788086e+00 1.6400900268554688e+02 -1.2868699645996094e+02 5.7179100036621094e+01 1.4030599975585938e+02 -1.2794799804687500e+02 2.7989599227905273e+01 1.7971000671386719e+02 -1.2910800170898438e+02 1.0615900039672852e+01 1.7844400024414062e+02 -1.2907800292968750e+02 5.3683200836181641e+01 1.4572900390625000e+02 -1.2828601074218750e+02 4.7830200195312500e+01 1.4318299865722656e+02 -1.2822100830078125e+02 1.9436399459838867e+01 1.5366200256347656e+02 -1.1613799285888672e+02 5.3453399658203125e+01 1.5017298889160156e+02 -1.1606000518798828e+02 5.1096000671386719e+01 1.4716101074218750e+02 -1.1608200073242188e+02 4.8230201721191406e+01 1.4461900329589844e+02 -1.1591799926757812e+02 4.4784400939941406e+01 1.4274099731445312e+02 -1.1580500030517578e+02 4.1081398010253906e+01 1.4148699951171875e+02 -1.1584200286865234e+02 3.6987499237060547e+01 1.4113099670410156e+02 -1.1583300018310547e+02 2.8592300415039062e+01 1.4201199340820312e+02 -1.1587500000000000e+02 2.4486501693725586e+01 1.4354299926757812e+02 -1.1599499511718750e+02 2.0628898620605469e+01 1.4580099487304688e+02 -1.1594699859619141e+02 1.6967199325561523e+01 1.5186500549316406e+02 -1.1609400177001953e+02 1.1153000831604004e+01 1.5952000427246094e+02 -1.1627999877929688e+02 7.6918601989746094e+00 1.6364399719238281e+02 -1.1641500091552734e+02 6.9796400070190430e+00 1.6578199768066406e+02 -1.1643200683593750e+02 6.9792299270629883e+00 1.7204501342773438e+02 -1.1658499908447266e+02 7.6918601989746094e+00 1.7601499938964844e+02 -1.1677099609375000e+02 9.0837497711181641e+00 1.7969900512695312e+02 -1.1676999664306641e+02 1.1153000831604004e+01 1.8297999572753906e+02 -1.1670999908447266e+02 1.3788900375366211e+01 1.8576399230957031e+02 -1.1691799926757812e+02 1.6967199325561523e+01 1.8795600891113281e+02 -1.1702000427246094e+02 2.0518598556518555e+01 1.9043399047851562e+02 -1.1703099822998047e+02 2.8592300415039062e+01 1.9034500122070312e+02 -1.1702899932861328e+02 3.4896297454833984e+01 1.9007701110839844e+02 -1.1702299499511719e+02 3.6987499237060547e+01 1.8886299133300781e+02 -1.1687599945068359e+02 4.0995800018310547e+01 1.8694500732421875e+02 -1.1694700622558594e+02 4.4784400939941406e+01 1.7790299987792969e+02 -1.1672700500488281e+02 5.3453399658203125e+01 1.6998199462890625e+02 -1.1653500366210938e+02 5.6252700805664062e+01 1.6583399963378906e+02 -1.1634300231933594e+02 5.6617000579833984e+01 1.6158200073242188e+02 -1.1632999420166016e+02 5.6252700805664062e+01 1.6722700500488281e+02 -1.0546900177001953e+02 7.0446296691894531e+01 1.6458399963378906e+02 -1.1574900054931641e+02 7.0446899414062500e+01 1.6142900085449219e+02 -1.0581000518798828e+02 7.0446899414062500e+01 1.6091699218750000e+02 -1.2688599395751953e+02 7.0446899414062500e+01 1.6638400268554688e+02 -1.2703299713134766e+02 7.0447494506835938e+01 1.7529598999023438e+02 -1.3168199157714844e+02 3.9378898620605469e+01 1.6788700866699219e+02 -1.3150199890136719e+02 3.4847698211669922e+01 1.7529598999023438e+02 -1.3168199157714844e+02 6.6001899719238281e+01 1.6045500183105469e+02 -1.3132099914550781e+02 6.6001899719238281e+01 1.6332299804687500e+02 -1.3139100646972656e+02 3.5504299163818359e+01 1.6966400146484375e+02 -1.3154501342773438e+02 3.0123300552368164e+01 1.7223100280761719e+02 -1.3160699462890625e+02 2.7607400894165039e+01 1.6735099792480469e+02 -1.3148899841308594e+02 2.4256500244140625e+01 1.6466600036621094e+02 -1.3142399597167969e+02 2.7670299530029297e+01 1.5777899169921875e+02 -1.3125599670410156e+02 3.2358097076416016e+01 1.6129200744628906e+02 -1.3134199523925781e+02 3.0542999267578125e+01 1.5842199707031250e+02 -1.3127200317382812e+02 2.8142000198364258e+01 1.6282899475097656e+02 -1.3137899780273438e+02 2.4457099914550781e+01 1.6332699584960938e+02 -1.0141100311279297e+02 2.8319000244140625e+01 1.6621899414062500e+02 -1.0148000335693359e+02 2.4011400222778320e+01 1.6933900451660156e+02 -1.0155599975585938e+02 2.8872100830078125e+01 1.7602400207519531e+02 -1.0171900177001953e+02 3.9378898620605469e+01 1.6995500183105469e+02 -1.0157099914550781e+02 3.3390499114990234e+01 1.7325100708007812e+02 -1.0165100097656250e+02 2.8684898376464844e+01 1.7053500366210938e+02 -1.0158499908447266e+02 2.5377201080322266e+01 1.5899800109863281e+02 -1.0130500030517578e+02 2.8787300109863281e+01 1.6187800598144531e+02 -1.0137500000000000e+02 2.5294500350952148e+01 1.6290600585937500e+02 -1.0140000152587891e+02 3.4598297119140625e+01 1.6118399047851562e+02 -1.0135799407958984e+02 6.6001899719238281e+01 1.5850700378417969e+02 -1.0129299926757812e+02 3.2358097076416016e+01 1.6702699279785156e+02 -1.0150000000000000e+02 3.5612800598144531e+01 1.7602400207519531e+02 -1.0171900177001953e+02 6.6001899719238281e+01 1.7300599670410156e+02 -9.9739700317382812e+01 2.7607400894165039e+01 1.7036799621582031e+02 -9.9675605773925781e+01 3.0078800201416016e+01 1.7607000732421875e+02 -9.9814201354980469e+01 3.9378597259521484e+01 1.6122999572753906e+02 -9.9453598022460938e+01 6.6001899719238281e+01 1.6409700012207031e+02 -9.9523200988769531e+01 3.5504299163818359e+01 1.5855300903320312e+02 -9.9388595581054688e+01 3.2358097076416016e+01 1.6570300292968750e+02 -9.9562301635742188e+01 2.3705699920654297e+01 1.6456300354003906e+02 -9.9534599304199219e+01 2.7771299362182617e+01 1.6866099548339844e+02 -9.9634201049804688e+01 3.4847698211669922e+01 1.7622200012207031e+02 -9.9815597534179688e+01 6.6231803894042969e+01 1.5919700622558594e+02 -9.9404197692871094e+01 2.8142000198364258e+01 1.6195500183105469e+02 -9.9470802307128906e+01 3.1641698837280273e+01 1.6707398986816406e+02 -1.0595200347900391e+02 7.2351905822753906e+01 1.6160899353027344e+02 -1.0463800048828125e+02 7.2344100952148438e+01 1.6609300231933594e+02 -1.1056900024414062e+02 7.2372100830078125e+01 1.6794400024414062e+02 -1.2843998718261719e+02 7.2340805053710938e+01 1.6449398803710938e+02 -1.1779199981689453e+02 7.2351905822753906e+01 1.6106900024414062e+02 -1.2689000701904297e+02 7.2351905822753906e+01 1.7525000000000000e+02 -1.3358599853515625e+02 3.9378597259521484e+01 1.6964100646972656e+02 -1.3344999694824219e+02 3.2433101654052734e+01 1.7222100830078125e+02 -1.3351300048828125e+02 2.7817501068115234e+01 1.6781799316406250e+02 -1.3340600585937500e+02 2.8400400161743164e+01 1.6233299255371094e+02 -1.3327200317382812e+02 2.8431699752807617e+01 1.6317900085449219e+02 -1.3329299926757812e+02 2.4328199386596680e+01 1.6770500183105469e+02 -1.3340299987792969e+02 2.4371500015258789e+01 1.6217799377441406e+02 -1.3326899719238281e+02 3.4627899169921875e+01 1.6040899658203125e+02 -1.3322601318359375e+02 6.6001899719238281e+01 1.5773298645019531e+02 -1.3316099548339844e+02 3.2358097076416016e+01 1.5867201232910156e+02 -1.3318299865722656e+02 2.7617599487304688e+01 1.6625300598144531e+02 -1.3336799621582031e+02 3.5612800598144531e+01 1.7525000000000000e+02 -1.3358599853515625e+02 6.6001899719238281e+01 2.0085699462890625e+02 -1.3032099914550781e+02 6.8380996704101562e+01 2.0069000244140625e+02 -1.3298300170898438e+02 6.8303695678710938e+01 1.9751499938964844e+02 -1.3286900329589844e+02 6.5027198791503906e+01 1.9716900634765625e+02 -1.3520500183105469e+02 6.4728599548339844e+01 1.9397200012207031e+02 -1.3451098632812500e+02 6.1406898498535156e+01 1.9405599975585938e+02 -1.3648500061035156e+02 6.1542900085449219e+01 1.9140200805664062e+02 -1.3516299438476562e+02 5.8767398834228516e+01 1.9148999023437500e+02 -1.3708299255371094e+02 5.8906600952148438e+01 1.8948500061035156e+02 -1.3541899108886719e+02 5.6792598724365234e+01 1.8950498962402344e+02 -1.3732800292968750e+02 5.6861198425292969e+01 1.8755101013183594e+02 -1.3547299194335938e+02 5.4795997619628906e+01 1.8750500488281250e+02 -1.3737800598144531e+02 5.4795997619628906e+01 1.8562300109863281e+02 -1.3532499694824219e+02 5.2799301147460938e+01 1.8550999450683594e+02 -1.3723100280761719e+02 5.2730697631835938e+01 1.8371998596191406e+02 -1.3497599792480469e+02 5.0824600219726562e+01 1.8353900146484375e+02 -1.3688899230957031e+02 5.0685302734375000e+01 1.8186500549316406e+02 -1.3443000793457031e+02 4.8893299102783203e+01 1.8161100769042969e+02 -1.3635600280761719e+02 4.8679500579833984e+01 1.8007600402832031e+02 -1.3369299316406250e+02 4.7026702880859375e+01 1.7974400329589844e+02 -1.3563699340820312e+02 4.6732601165771484e+01 1.7793899536132812e+02 -1.3249899291992188e+02 4.4787899017333984e+01 1.7622500610351562e+02 -1.3373699951171875e+02 4.3057399749755859e+01 1.7642199707031250e+02 -1.3181500244140625e+02 4.3330402374267578e+01 2.0632499694824219e+02 -1.1937699890136719e+02 6.9113403320312500e+01 2.0788900756835938e+02 -1.2146099853515625e+02 6.9113403320312500e+01 2.0543000793457031e+02 -1.2313500213623047e+02 6.9113403320312500e+01 2.0663699340820312e+02 -1.2525500488281250e+02 6.9113403320312500e+01 2.0350299072265625e+02 -1.2715199279785156e+02 6.9117797851562500e+01 2.0429800415039062e+02 -1.2933500671386719e+02 6.9161300659179688e+01 2.0419299316406250e+02 -1.0808300018310547e+02 6.9114402770996094e+01 2.0486100769042969e+02 -1.0543800354003906e+02 6.9145698547363281e+01 2.0570799255371094e+02 -1.1171800231933594e+02 6.9113403320312500e+01 2.0701600646972656e+02 -1.0965900421142578e+02 6.9113403320312500e+01 2.0641900634765625e+02 -1.1551499938964844e+02 6.9113403320312500e+01 2.0808200073242188e+02 -1.1350999450683594e+02 6.9113403320312500e+01 2.0837699890136719e+02 -1.1749500274658203e+02 6.9113403320312500e+01 1.9920100402832031e+02 -9.9901100158691406e+01 6.6025695800781250e+01 2.0184899902343750e+02 -1.0466200256347656e+02 6.8681900024414062e+01 1.9820599365234375e+02 -1.0156900024414062e+02 6.4960601806640625e+01 1.9625599670410156e+02 -9.8363098144531250e+01 6.2859298706054688e+01 1.9473800659179688e+02 -9.9771797180175781e+01 6.1331901550292969e+01 1.9438900756835938e+02 -9.7643699645996094e+01 6.0912399291992188e+01 1.9246099853515625e+02 -9.7110595703125000e+01 5.8906600952148438e+01 1.9227999877929688e+02 -9.9023902893066406e+01 5.8767398834228516e+01 1.9049000549316406e+02 -9.6769104003906250e+01 5.6861198425292969e+01 1.9037699890136719e+02 -9.8675102233886719e+01 5.6792598724365234e+01 1.8849499511718750e+02 -9.6622497558593750e+01 5.4795997619628906e+01 1.8844898986816406e+02 -9.8526901245117188e+01 5.4795997619628906e+01 1.8649501037597656e+02 -9.6672103881835938e+01 5.2730697631835938e+01 1.8651499938964844e+02 -9.8581199645996094e+01 5.2799301147460938e+01 1.8450999450683594e+02 -9.6917503356933594e+01 5.0685302734375000e+01 1.8459799194335938e+02 -9.8837303161621094e+01 5.0824600219726562e+01 1.8255900573730469e+02 -9.7356201171875000e+01 4.8679500579833984e+01 1.8271798706054688e+02 -9.9292396545410156e+01 4.8893299102783203e+01 1.8065800476074219e+02 -9.7984901428222656e+01 4.6730701446533203e+01 1.8089599609375000e+02 -9.9941406250000000e+01 4.7026702880859375e+01 1.7716600036621094e+02 -9.9656898498535156e+01 4.3169898986816406e+01 1.7870298767089844e+02 -1.0102999877929688e+02 4.4787899017333984e+01 1.7718798828125000e+02 -1.0163800048828125e+02 4.3404197692871094e+01 1.7670999145507812e+02 -1.3399099731445312e+02 6.6001899719238281e+01 1.9910099792480469e+02 -1.3413000488281250e+02 7.8838897705078125e+01 2.0302000427246094e+02 -1.3076399230957031e+02 7.8970603942871094e+01 1.9569499206542969e+02 -1.3586099243164062e+02 7.8982192993164062e+01 1.9034600830078125e+02 -1.3724800109863281e+02 7.8003402709960938e+01 1.9314099121093750e+02 -1.3672499084472656e+02 7.8003402709960938e+01 1.8751899719238281e+02 -1.3737599182128906e+02 7.8986900329589844e+01 1.7703999328613281e+02 -1.3417999267578125e+02 7.8957702636718750e+01 1.7603399658203125e+02 -1.3354699707031250e+02 6.6992698669433594e+01 1.7975599670410156e+02 -1.3560899353027344e+02 7.8003402709960938e+01 1.8190699768066406e+02 -1.3645201110839844e+02 7.8003402709960938e+01 1.8467399597167969e+02 -1.3711000061035156e+02 7.8003402709960938e+01 1.7367900085449219e+02 -1.3154699707031250e+02 7.8797698974609375e+01 1.7276600646972656e+02 -1.3075500488281250e+02 7.1406204223632812e+01 1.7472499084472656e+02 -1.3253900146484375e+02 6.9539199829101562e+01 1.7016099548339844e+02 -1.2691999816894531e+02 7.8534095764160156e+01 1.7034899902343750e+02 -1.2749099731445312e+02 7.4274505615234375e+01 1.6987599182128906e+02 -1.0761799621582031e+02 7.8554801940917969e+01 1.7039300537109375e+02 -1.0613999938964844e+02 7.4543899536132812e+01 1.6764500427246094e+02 -1.1431500244140625e+02 7.8506301879882812e+01 1.6793299865722656e+02 -1.1238800048828125e+02 7.4027503967285156e+01 1.6765899658203125e+02 -1.2002700042724609e+02 7.4976493835449219e+01 1.6804699707031250e+02 -1.2121199798583984e+02 7.8602302551269531e+01 1.7399899291992188e+02 -1.0217800140380859e+02 7.8939102172851562e+01 1.7847200012207031e+02 -9.8971702575683594e+01 7.8466598510742188e+01 1.7728799438476562e+02 -9.9658401489257812e+01 6.8486900329589844e+01 1.7503399658203125e+02 -1.0124800109863281e+02 7.0172798156738281e+01 1.8067599487304688e+02 -9.8023597717285156e+01 7.8003402709960938e+01 1.8149598693847656e+02 -9.7682106018066406e+01 7.8003402709960938e+01 1.8421701049804688e+02 -9.6971900939941406e+01 7.8985603332519531e+01 1.8730999755859375e+02 -9.6620796203613281e+01 7.8957397460937500e+01 1.8991500854492188e+02 -9.6706703186035156e+01 7.8003402709960938e+01 1.9270100402832031e+02 -9.7172798156738281e+01 7.8856300354003906e+01 2.0237399291992188e+02 -1.0254599761962891e+02 6.8737503051757812e+01 2.0017799377441406e+02 -1.0067900085449219e+02 7.8474800109863281e+01 2.0326800537109375e+02 -1.0345099639892578e+02 7.8883094787597656e+01 1.9543499755859375e+02 -9.8020706176757812e+01 7.8003402709960938e+01 1.9791999816894531e+02 -9.9198104858398438e+01 7.8992095947265625e+01 2.0749800109863281e+02 -1.1100099945068359e+02 7.8619499206542969e+01 2.0591198730468750e+02 -1.0727100372314453e+02 7.8492904663085938e+01 2.0843699645996094e+02 -1.1701100158691406e+02 7.8769294738769531e+01 2.0785899353027344e+02 -1.2183300018310547e+02 7.8782897949218750e+01 2.0608999633789062e+02 -1.2639300537109375e+02 7.8461196899414062e+01 1.8188899230957031e+02 -1.0463500213623047e+02 8.0289398193359375e+01 1.7783898925781250e+02 -1.0060800170898438e+02 8.0275604248046875e+01 1.7804400634765625e+02 -1.0732699584960938e+02 8.0289398193359375e+01 1.8903799438476562e+02 -1.3084300231933594e+02 8.0289398193359375e+01 1.8248599243164062e+02 -1.2974000549316406e+02 8.0289398193359375e+01 1.8915399169921875e+02 -1.3571299743652344e+02 8.0286804199218750e+01 1.7468899536132812e+02 -1.1306100463867188e+02 8.0289398193359375e+01 1.6882800292968750e+02 -1.1525900268554688e+02 8.0280899047851562e+01 1.7427200317382812e+02 -1.1832900238037109e+02 8.0289398193359375e+01 1.7542498779296875e+02 -1.2287899780273438e+02 8.0289398193359375e+01 1.7860600280761719e+02 -1.2709799194335938e+02 8.0289398193359375e+01 1.7278500366210938e+02 -1.2842599487304688e+02 8.0282699584960938e+01 1.8696199035644531e+02 -1.0315699768066406e+02 8.0289398193359375e+01 1.8376000976562500e+02 -9.8646400451660156e+01 8.0284904479980469e+01 2.0057499694824219e+02 -1.1112100219726562e+02 8.0289398193359375e+01 2.0665499877929688e+02 -1.2107700347900391e+02 8.0285400390625000e+01 2.0281500244140625e+02 -1.0466400146484375e+02 8.0260902404785156e+01 1.9640299987792969e+02 -1.0594999694824219e+02 8.0289398193359375e+01 2.0186700439453125e+02 -1.1763800048828125e+02 8.0289398193359375e+01 1.9411100769042969e+02 -1.2936399841308594e+02 8.0289398193359375e+01 1.9863499450683594e+02 -1.3271099853515625e+02 8.0276695251464844e+01 1.9795599365234375e+02 -1.2667399597167969e+02 8.0289398193359375e+01 1.9409899902343750e+02 -9.9170600891113281e+01 8.0285102844238281e+01 1.9162500000000000e+02 -1.0369300079345703e+02 8.0289398193359375e+01 2.0077299499511719e+02 -1.2220300292968750e+02 8.0289398193359375e+01 2.0213800048828125e+02 -1.2893399047851562e+02 7.8198295593261719e+01 1.9919900512695312e+02 -1.3171499633789062e+02 7.8383995056152344e+01 2.0428900146484375e+02 -1.2578099822998047e+02 7.8383995056152344e+01 2.0543099975585938e+02 -1.2313199615478516e+02 7.8236602783203125e+01 2.0614999389648438e+02 -1.2032800292968750e+02 7.8099700927734375e+01 2.0647299194335938e+02 -1.1744899749755859e+02 7.8003402709960938e+01 2.0633999633789062e+02 -1.1453399658203125e+02 7.8383903503417969e+01 2.0145500183105469e+02 -1.0429399871826172e+02 7.8383697509765625e+01 2.0470799255371094e+02 -1.0888800048828125e+02 7.8384506225585938e+01 1.9922000122070312e+02 -1.0231799316406250e+02 7.8231002807617188e+01 1.9592399597167969e+02 -1.0030699920654297e+02 7.8003402709960938e+01 1.9227999877929688e+02 -9.9024101257324219e+01 7.8384101867675781e+01 1.9037699890136719e+02 -9.8675102233886719e+01 7.8003402709960938e+01 1.8844898986816406e+02 -9.8526901245117188e+01 7.8383995056152344e+01 1.7816899108886719e+02 -1.0131400299072266e+02 7.8383804321289062e+01 1.7739799499511719e+02 -1.0183899688720703e+02 6.9791000366210938e+01 1.8089599609375000e+02 -9.9941406250000000e+01 7.8003402709960938e+01 1.8271798706054688e+02 -9.9292396545410156e+01 7.8003402709960938e+01 1.8459799194335938e+02 -9.8837303161621094e+01 7.8003402709960938e+01 1.8651499938964844e+02 -9.8581199645996094e+01 7.8003402709960938e+01 1.7418600463867188e+02 -1.0460499572753906e+02 7.3441802978515625e+01 1.7522599792480469e+02 -1.0360700225830078e+02 7.8384597778320312e+01 1.7223699951171875e+02 -1.0731299591064453e+02 7.7486000061035156e+01 1.6965299987792969e+02 -1.1390299987792969e+02 7.8181900024414062e+01 1.7016400146484375e+02 -1.1186299896240234e+02 7.4788894653320312e+01 1.7014299011230469e+02 -1.2241699981689453e+02 7.8383697509765625e+01 1.6948300170898438e+02 -1.1952300262451172e+02 7.4578903198242188e+01 1.7196499633789062e+02 -1.2625500488281250e+02 7.6804306030273438e+01 1.7613500976562500e+02 -1.3130999755859375e+02 6.8038002014160156e+01 1.7412300109863281e+02 -1.2926100158691406e+02 7.5183502197265625e+01 1.7752101135253906e+02 -1.3225300598144531e+02 7.8384101867675781e+01 1.8007600402832031e+02 -1.3369299316406250e+02 7.8003402709960938e+01 1.7732701110839844e+02 -1.3215998840332031e+02 6.6001899719238281e+01 1.9684700012207031e+02 -1.3322299194335938e+02 7.8236900329589844e+01 1.9510400390625000e+02 -1.3405899047851562e+02 7.8003402709960938e+01 1.9328199768066406e+02 -1.3470700073242188e+02 7.8384101867675781e+01 1.9140200805664062e+02 -1.3516299438476562e+02 7.8003402709960938e+01 1.8948500061035156e+02 -1.3541899108886719e+02 7.8003402709960938e+01 1.8755101013183594e+02 -1.3547299194335938e+02 7.8003402709960938e+01 1.8562300109863281e+02 -1.3532499694824219e+02 7.8003402709960938e+01 1.8371998596191406e+02 -1.3497599792480469e+02 7.8003402709960938e+01 1.8186500549316406e+02 -1.3443000793457031e+02 7.8383995056152344e+01 1.8636199951171875e+02 -1.0321500396728516e+02 7.8384399414062500e+01 1.9295599365234375e+02 -1.0403299713134766e+02 7.8384399414062500e+01 1.9950500488281250e+02 -1.0894699859619141e+02 7.8384399414062500e+01 2.0188200378417969e+02 -1.1703600311279297e+02 7.8384399414062500e+01 2.0077299499511719e+02 -1.2220300292968750e+02 7.8384399414062500e+01 1.9738101196289062e+02 -1.2745100402832031e+02 7.8384399414062500e+01 1.8809199523925781e+02 -1.3104299926757812e+02 7.8384399414062500e+01 1.8008500671386719e+02 -1.2840400695800781e+02 7.8384399414062500e+01 1.7569200134277344e+02 -1.2341999816894531e+02 7.8384399414062500e+01 1.7411799621582031e+02 -1.1696399688720703e+02 7.8384399414062500e+01 1.7522700500488281e+02 -1.1179699707031250e+02 7.8384399414062500e+01 1.7763299560546875e+02 -1.0776799774169922e+02 7.8384399414062500e+01 1.8188899230957031e+02 -1.0463500213623047e+02 7.8384399414062500e+01 1.6073699951171875e+02 -1.3002600097656250e+02 6.9145004272460938e+01 1.6088198852539062e+02 -1.3061900329589844e+02 7.1139099121093750e+01 1.6084899902343750e+02 -1.2858599853515625e+02 7.0108505249023438e+01 1.6099600219726562e+02 -1.2885099792480469e+02 7.2041099548339844e+01 1.6144400024414062e+02 -1.0410899353027344e+02 7.0108505249023438e+01 1.6059899902343750e+02 -1.3098600769042969e+02 6.7702896118164062e+01 1.6057800292968750e+02 -1.3291299438476562e+02 6.7968002319335938e+01 1.6073599243164062e+02 -1.3202099609375000e+02 6.9734298706054688e+01 1.6157499694824219e+02 -1.0208000183105469e+02 7.1139099121093750e+01 1.6140200805664062e+02 -1.0266600036621094e+02 6.9145004272460938e+01 1.6149699401855469e+02 -1.0067299652099609e+02 6.9734298706054688e+01 1.6131100463867188e+02 -1.0169999694824219e+02 6.7702896118164062e+01 1.6141400146484375e+02 -9.9779502868652344e+01 6.7965904235839844e+01 1.6961898803710938e+02 -1.0472500610351562e+02 7.2348403930664062e+01 1.7146701049804688e+02 -1.0257700347900391e+02 7.1375099182128906e+01 1.7830499267578125e+02 -1.3354699707031250e+02 8.0125900268554688e+01 1.6956399536132812e+02 -1.2305899810791016e+02 7.9987396240234375e+01 1.7114099121093750e+02 -1.0730599975585938e+02 7.9964599609375000e+01 2.0709599304199219e+02 -1.1336199951171875e+02 8.0026199340820312e+01 1.8331100463867188e+02 -1.3633599853515625e+02 7.9599502563476562e+01 2.0419099426269531e+02 -1.2762099456787109e+02 8.0020797729492188e+01 1.6680699157714844e+02 -1.2011799621582031e+02 7.3287399291992188e+01 1.6897399902343750e+02 -1.2785198974609375e+02 7.0653404235839844e+01 1.7276699829101562e+02 -1.3005900573730469e+02 6.9508598327636719e+01 1.7658799743652344e+02 -1.0170699310302734e+02 6.6471298217773438e+01 1.7327299499511719e+02 -1.0200600433349609e+02 6.7865997314453125e+01 1.7386799621582031e+02 -1.0306400299072266e+02 6.9332099914550781e+01 1.6994300842285156e+02 -1.0968499755859375e+02 7.2507499694824219e+01 1.7011199951171875e+02 -1.0613899993896484e+02 7.1145103454589844e+01 1.6650999450683594e+02 -1.1362200164794922e+02 7.0763900756835938e+01 1.6646299743652344e+02 -1.2013899993896484e+02 7.0779396057128906e+01 1.6910099792480469e+02 -1.2196599578857422e+02 7.2375701904296875e+01 1.7120001220703125e+02 -1.2635600280761719e+02 7.2847900390625000e+01 1.6839399719238281e+02 -1.1564300537109375e+02 7.2385902404785156e+01 1.8200199890136719e+02 -1.1471700286865234e+02 8.4716903686523438e+01 1.8054899597167969e+02 -1.0995700073242188e+02 8.4727302551269531e+01 1.8448899841308594e+02 -1.1162699890136719e+02 8.4716903686523438e+01 1.8166799926757812e+02 -1.1749600219726562e+02 8.4707405090332031e+01 1.8571699523925781e+02 -1.2299800109863281e+02 8.4716903686523438e+01 1.8093701171875000e+02 -1.2448500061035156e+02 8.4731201171875000e+01 1.8262701416015625e+02 -1.2051100158691406e+02 8.4716903686523438e+01 1.8580499267578125e+02 -1.2701800537109375e+02 8.4727401733398438e+01 1.8967900085449219e+02 -1.2319499969482422e+02 8.4716903686523438e+01 1.9098699951171875e+02 -1.0726599884033203e+02 8.4722900390625000e+01 1.8769699096679688e+02 -1.1062400054931641e+02 8.4716995239257812e+01 1.9070599365234375e+02 -1.1123600006103516e+02 8.4716903686523438e+01 1.9399800109863281e+02 -1.1928299713134766e+02 8.4716903686523438e+01 1.9696701049804688e+02 -1.2186899566650391e+02 8.4722496032714844e+01 1.9212600708007812e+02 -1.2182699584960938e+02 8.4716903686523438e+01 1.9433000183105469e+02 -1.1649900054931641e+02 8.4716903686523438e+01 1.9337300109863281e+02 -1.1348899841308594e+02 8.4716903686523438e+01 1.9736300659179688e+02 -1.1299700164794922e+02 8.4724395751953125e+01 1.8904800415039062e+02 -1.3697500610351562e+02 8.9373794555664062e+01 1.9033399963378906e+02 -1.3848400878906250e+02 8.8751396179199219e+01 1.9819299316406250e+02 -1.3432598876953125e+02 8.9548599243164062e+01 2.0356098937988281e+02 -1.3124899291992188e+02 8.9078598022460938e+01 2.0570500183105469e+02 -1.2647999572753906e+02 8.9501899719238281e+01 2.0361199951171875e+02 -1.0459500122070312e+02 8.9315895080566406e+01 2.0698100280761719e+02 -1.1088899993896484e+02 8.9316001892089844e+01 2.0526300048828125e+02 -1.0500399780273438e+02 8.9139900207519531e+01 2.0870399475097656e+02 -1.1159799957275391e+02 8.8937202453613281e+01 2.0792199707031250e+02 -1.1847799682617188e+02 8.9603103637695312e+01 1.9157099914550781e+02 -9.7383003234863281e+01 8.9315696716308594e+01 1.9824400329589844e+02 -9.9890899658203125e+01 8.9406402587890625e+01 1.9050900268554688e+02 -9.5776794433593750e+01 8.9041206359863281e+01 1.7529100036621094e+02 -1.0160599517822266e+02 8.9443305969238281e+01 1.8267599487304688e+02 -9.7649497985839844e+01 8.9314399719238281e+01 1.7899798583984375e+02 -9.7510704040527344e+01 8.8863998413085938e+01 1.6829299926757812e+02 -1.1384300231933594e+02 8.9444000244140625e+01 1.6688301086425781e+02 -1.1003199768066406e+02 8.8276100158691406e+01 1.6833099365234375e+02 -1.2057899475097656e+02 8.9600502014160156e+01 1.7118800354003906e+02 -1.2773999786376953e+02 8.9316703796386719e+01 1.6772100830078125e+02 -1.2606600189208984e+02 8.8330406188964844e+01 1.7197300720214844e+02 -1.3072999572753906e+02 8.9075401306152344e+01 1.7658700561523438e+02 -1.3340100097656250e+02 8.9636604309082031e+01 1.8247599792480469e+02 -1.3616700744628906e+02 8.9316505432128906e+01 1.8234700012207031e+02 -1.3844500732421875e+02 8.8384498596191406e+01 1.7067599487304688e+02 -1.0708699798583984e+02 8.9443603515625000e+01 1.7158601379394531e+02 -1.0204000091552734e+02 8.8155998229980469e+01 1.8392700195312500e+02 -9.5108802795410156e+01 8.8014297485351562e+01 2.0130500793457031e+02 -9.9129402160644531e+01 8.8244804382324219e+01 1.7918499755859375e+02 -1.3745899963378906e+02 8.7685195922851562e+01 1.7407899475097656e+02 -1.3434500122070312e+02 8.7762802124023438e+01 1.7045498657226562e+02 -1.3075299072265625e+02 8.7656600952148438e+01 1.6599499511718750e+02 -1.2055899810791016e+02 8.7790802001953125e+01 1.6594299316406250e+02 -1.1429199981689453e+02 8.7705101013183594e+01 1.7540701293945312e+02 -9.8689300537109375e+01 8.7704498291015625e+01 2.0639300537109375e+02 -1.0440499877929688e+02 8.7780105590820312e+01 2.1003698730468750e+02 -1.1416999816894531e+02 8.7742095947265625e+01 2.1020300292968750e+02 -1.1884500122070312e+02 8.7687698364257812e+01 2.0931599426269531e+02 -1.2340100097656250e+02 8.7718498229980469e+01 2.0689999389648438e+02 -1.2873399353027344e+02 8.7750099182128906e+01 2.0382299804687500e+02 -1.3269999694824219e+02 8.7660095214843750e+01 1.9940400695800781e+02 -1.3607600402832031e+02 8.7791900634765625e+01 1.9440899658203125e+02 -1.3835099792480469e+02 8.7602500915527344e+01 1.8766899108886719e+02 -1.3933000183105469e+02 8.7433700561523438e+01 1.6879899597167969e+02 -1.0569300079345703e+02 8.7327697753906250e+01 1.7956599426269531e+02 -9.6393798828125000e+01 8.7439697265625000e+01 1.8958898925781250e+02 -9.4832199096679688e+01 8.7607398986816406e+01 1.9481500244140625e+02 -9.5767601013183594e+01 8.7310699462890625e+01 2.0882398986816406e+02 -1.0923300170898438e+02 8.7393501281738281e+01 1.9497300720214844e+02 -1.0919200134277344e+02 8.4913200378417969e+01 1.8602400207519531e+02 -1.0668700408935547e+02 8.4907196044921875e+01 1.7809001159667969e+02 -1.1372200012207031e+02 8.4941299438476562e+01 1.7779399108886719e+02 -1.1940100097656250e+02 8.4902397155761719e+01 1.9272399902343750e+02 -1.2637299346923828e+02 8.4848701477050781e+01 1.9851901245117188e+02 -1.1735499572753906e+02 8.4965896606445312e+01 1.9057600402832031e+02 -1.3907499694824219e+02 8.1694297790527344e+01 1.9427000427246094e+02 -1.3832199096679688e+02 8.1694297790527344e+01 1.9778298950195312e+02 -1.3695600891113281e+02 8.1694297790527344e+01 2.0101499938964844e+02 -1.3501599121093750e+02 8.1694297790527344e+01 2.0387199401855469e+02 -1.3255700683593750e+02 8.1694297790527344e+01 2.0627301025390625e+02 -1.2965100097656250e+02 8.1694297790527344e+01 2.0814801025390625e+02 -1.2638099670410156e+02 8.1694297790527344e+01 2.0944400024414062e+02 -1.2284100341796875e+02 8.1694297790527344e+01 2.1012200927734375e+02 -1.1913300323486328e+02 8.1694297790527344e+01 2.1016499328613281e+02 -1.1536299896240234e+02 8.1694297790527344e+01 2.0956900024414062e+02 -1.1164099884033203e+02 8.1694297790527344e+01 2.0835299682617188e+02 -1.0807300567626953e+02 8.1694297790527344e+01 2.0655200195312500e+02 -1.0476200103759766e+02 8.1694297790527344e+01 2.0421699523925781e+02 -1.0180200195312500e+02 8.1694297790527344e+01 2.0141500854492188e+02 -9.9280197143554688e+01 8.1694297790527344e+01 1.9822700500488281e+02 -9.7267997741699219e+01 8.1694297790527344e+01 1.9474501037597656e+02 -9.5823303222656250e+01 8.1694297790527344e+01 1.9107000732421875e+02 -9.4988006591796875e+01 8.1694297790527344e+01 1.8730500793457031e+02 -9.4785804748535156e+01 8.1694297790527344e+01 1.8356100463867188e+02 -9.5222801208496094e+01 8.1694297790527344e+01 1.7994500732421875e+02 -9.6286201477050781e+01 8.1694297790527344e+01 1.7655999755859375e+02 -9.7945495605468750e+01 8.1694297790527344e+01 1.7350399780273438e+02 -1.0015299987792969e+02 8.1694297790527344e+01 1.7086599731445312e+02 -1.0284500122070312e+02 8.1694297790527344e+01 1.6872000122070312e+02 -1.0594400024414062e+02 8.1694297790527344e+01 1.6712899780273438e+02 -1.0936199951171875e+02 8.1694297790527344e+01 1.6613800048828125e+02 -1.1299900054931641e+02 8.1694297790527344e+01 1.6577600097656250e+02 -1.1675099945068359e+02 8.1694297790527344e+01 1.6605400085449219e+02 -1.2051100158691406e+02 8.1694297790527344e+01 1.6696299743652344e+02 -1.2416899871826172e+02 8.1694297790527344e+01 1.6847700500488281e+02 -1.2762099456787109e+02 8.1694297790527344e+01 1.7055299377441406e+02 -1.3076800537109375e+02 8.1694297790527344e+01 1.7313099670410156e+02 -1.3351799011230469e+02 8.1694297790527344e+01 1.7613600158691406e+02 -1.3579400634765625e+02 8.1694297790527344e+01 1.7948300170898438e+02 -1.3752799987792969e+02 8.1694297790527344e+01 1.8307499694824219e+02 -1.3867199707031250e+02 8.1694297790527344e+01 1.8680799865722656e+02 -1.3919299316406250e+02 8.1694297790527344e+01 1.9116400146484375e+02 -1.0294499969482422e+02 8.8517997741699219e+01 1.9686099243164062e+02 -1.0636500549316406e+02 8.8095596313476562e+01 2.0107099914550781e+02 -1.1110099792480469e+02 8.8520301818847656e+01 2.0224299621582031e+02 -1.1867699432373047e+02 8.8506896972656250e+01 1.9964100646972656e+02 -1.2546700286865234e+02 8.8504699707031250e+01 1.9459899902343750e+02 -1.2965699768066406e+02 8.8533401489257812e+01 1.9052200317382812e+02 -1.3099501037597656e+02 8.8483001708984375e+01 1.8327999877929688e+02 -1.3067098999023438e+02 8.8479103088378906e+01 1.7554399108886719e+02 -1.2367100524902344e+02 8.8200706481933594e+01 1.7376998901367188e+02 -1.1419899749755859e+02 8.8520896911621094e+01 1.7793199157714844e+02 -1.0687100219726562e+02 8.8521598815917969e+01 1.8326200866699219e+02 -1.0351800537109375e+02 8.8516799926757812e+01 1.7837100219726562e+02 -9.7818099975585938e+01 8.1694297790527344e+01 1.8184800720214844e+02 -9.6437500000000000e+01 8.1694297790527344e+01 1.8551200866699219e+02 -9.5681602478027344e+01 8.1694297790527344e+01 1.8925199890136719e+02 -9.5573501586914062e+01 8.1694297790527344e+01 1.9457400512695312e+02 -9.6472900390625000e+01 8.1702598571777344e+01 2.0125100708007812e+02 -1.0000400543212891e+02 8.1698402404785156e+01 2.0629100036621094e+02 -1.0561700439453125e+02 8.1692596435546875e+01 2.0856199645996094e+02 -1.1084799957275391e+02 8.1694297790527344e+01 2.0956199645996094e+02 -1.1640399932861328e+02 8.1705101013183594e+01 2.0888400268554688e+02 -1.2195400238037109e+02 8.1694297790527344e+01 2.0770600891113281e+02 -1.2550499725341797e+02 8.1694297790527344e+01 2.0592999267578125e+02 -1.2879798889160156e+02 8.1694297790527344e+01 2.0231900024414062e+02 -1.3308799743652344e+02 8.1699806213378906e+01 1.9609298706054688e+02 -1.3697299194335938e+02 8.1698593139648438e+01 1.8871299743652344e+02 -1.3853199768066406e+02 8.1692504882812500e+01 1.8304600524902344e+02 -1.3788299560546875e+02 8.1694297790527344e+01 1.7793099975585938e+02 -1.3605599975585938e+02 8.1701499938964844e+01 1.7326800537109375e+02 -1.3260899353027344e+02 8.1694297790527344e+01 1.7078199768066406e+02 -1.2981399536132812e+02 8.1694297790527344e+01 1.6881799316406250e+02 -1.2662899780273438e+02 8.1694297790527344e+01 1.6687899780273438e+02 -1.2138700103759766e+02 8.1706001281738281e+01 1.6669300842285156e+02 -1.1386000061035156e+02 8.1700492858886719e+01 1.6829399108886719e+02 -1.0849499511718750e+02 8.1694297790527344e+01 1.7109901428222656e+02 -1.0365100097656250e+02 8.1700599670410156e+01 1.7518598937988281e+02 -9.9781600952148438e+01 8.1694297790527344e+01 1.7084098815917969e+02 -1.2287600708007812e+02 8.8422904968261719e+01 1.7461900329589844e+02 -1.3021400451660156e+02 8.8532905578613281e+01 1.8506799316406250e+02 -1.3824899291992188e+02 8.5679504394531250e+01 1.9044900512695312e+02 -1.3838600158691406e+02 8.5758399963378906e+01 1.7939599609375000e+02 -1.3672601318359375e+02 8.5391601562500000e+01 1.7542498779296875e+02 -1.3433599853515625e+02 8.6278999328613281e+01 1.7077699279785156e+02 -1.2985198974609375e+02 8.6319602966308594e+01 1.6774700927734375e+02 -1.2391100311279297e+02 8.6269996643066406e+01 1.6654600524902344e+02 -1.1894599914550781e+02 8.5368202209472656e+01 1.6702899169921875e+02 -1.1211500549316406e+02 8.5147598266601562e+01 1.6952400207519531e+02 -1.0586400604248047e+02 8.5253501892089844e+01 1.7338900756835938e+02 -1.0142900085449219e+02 8.6711601257324219e+01 1.7855801391601562e+02 -9.7678199768066406e+01 8.5816001892089844e+01 1.8546800231933594e+02 -9.5650802612304688e+01 8.6086196899414062e+01 1.9075000000000000e+02 -9.5763900756835938e+01 8.6209999084472656e+01 1.9705400085449219e+02 -9.7449600219726562e+01 8.5356506347656250e+01 2.0271598815917969e+02 -1.0128100585937500e+02 8.5147697448730469e+01 2.0598500061035156e+02 -1.0527400207519531e+02 8.5671798706054688e+01 2.0919099426269531e+02 -1.1268799591064453e+02 8.5738502502441406e+01 2.0916500854492188e+02 -1.2050199890136719e+02 8.5712699890136719e+01 2.0776200866699219e+02 -1.2555299377441406e+02 8.5148002624511719e+01 2.0538999938964844e+02 -1.2953700256347656e+02 8.6283996582031250e+01 2.0140299987792969e+02 -1.3378599548339844e+02 8.6254402160644531e+01 1.9702699279785156e+02 -1.3650799560546875e+02 8.5285095214843750e+01 1.7198300170898438e+02 -1.0724700164794922e+02 8.8540504455566406e+01 1.8904800415039062e+02 -9.8059196472167969e+01 8.8529602050781250e+01 2.0197900390625000e+02 -1.0470300292968750e+02 8.8541801452636719e+01 2.0606900024414062e+02 -1.2216799926757812e+02 8.8523902893066406e+01 2.0314199829101562e+02 -1.2796400451660156e+02 8.8517196655273438e+01 1.8853401184082031e+02 -1.3623599243164062e+02 8.8474601745605469e+01 1.9695500183105469e+02 -1.3514498901367188e+02 8.7857406616210938e+01 1.8163500976562500e+02 -1.3621200561523438e+02 8.7790397644042969e+01 1.6770899963378906e+02 -1.1647499847412109e+02 8.7813499450683594e+01 1.7848699951171875e+02 -9.9410804748535156e+01 8.7950805664062500e+01 2.0709599304199219e+02 -1.1151800537109375e+02 8.7988693237304688e+01 1.6882499694824219e+02 -1.0883600616455078e+02 8.7044700622558594e+01 1.9780899047851562e+02 -9.8799499511718750e+01 8.7417800903320312e+01 2.0360400390625000e+02 -1.0380300140380859e+02 8.7591796875000000e+01 2.0822100830078125e+02 -1.2065000152587891e+02 8.7534103393554688e+01 1.9417500305175781e+02 -1.1847999572753906e+02 9.2074996948242188e+01 2.0791900634765625e+02 -1.1789499664306641e+02 9.2074996948242188e+01 1.9433000183105469e+02 -1.1649900054931641e+02 9.2074996948242188e+01 2.0775898742675781e+02 -1.1432400512695312e+02 9.2074996948242188e+01 1.9386599731445312e+02 -1.1456800079345703e+02 9.2074996948242188e+01 1.8213400268554688e+02 -1.1943199920654297e+02 9.2074996948242188e+01 1.8166999816894531e+02 -1.1750099945068359e+02 9.2074996948242188e+01 1.6856098937988281e+02 -1.2143699645996094e+02 9.2074996948242188e+01 1.8829199218750000e+02 -1.2337700653076172e+02 9.2074996948242188e+01 1.9330500793457031e+02 -1.3621998596191406e+02 9.2074996948242188e+01 1.9043199157714844e+02 -1.2286599731445312e+02 9.2074996948242188e+01 1.9816899108886719e+02 -1.3423300170898438e+02 9.2074996948242188e+01 1.9212600708007812e+02 -1.2182699584960938e+02 9.2074996948242188e+01 1.8651998901367188e+02 -1.2317500305175781e+02 9.2074996948242188e+01 1.8808399963378906e+02 -1.3708900451660156e+02 9.2074996948242188e+01 1.7044099426269531e+02 -1.2661199188232422e+02 9.2074996948242188e+01 1.8317300415039062e+02 -1.2112600708007812e+02 9.2074996948242188e+01 1.7494200134277344e+02 -1.3217199707031250e+02 9.2074996948242188e+01 1.8468399047851562e+02 -1.2241600036621094e+02 9.2074996948242188e+01 1.8182499694824219e+02 -1.1552000427246094e+02 9.2074996948242188e+01 1.6824198913574219e+02 -1.1432400512695312e+02 9.2074996948242188e+01 1.6808099365234375e+02 -1.1789499664306641e+02 9.2074996948242188e+01 1.8387399291992188e+02 -1.1217299652099609e+02 9.2074996948242188e+01 1.7241099548339844e+02 -1.0456800079345703e+02 9.2074996948242188e+01 1.8258399963378906e+02 -1.1368399810791016e+02 9.2074996948242188e+01 1.7044200134277344e+02 -1.0755200195312500e+02 9.2074996948242188e+01 1.6903700256347656e+02 -1.1083900451660156e+02 9.2074996948242188e+01 1.9341600036621094e+02 -1.2031600189208984e+02 9.2074996948242188e+01 2.0688700866699219e+02 -1.2313699340820312e+02 9.2074996948242188e+01 2.0353199768066406e+02 -1.2962399291992188e+02 9.2074996948242188e+01 1.8111099243164062e+02 -1.3579400634765625e+02 9.2074996948242188e+01 1.8556800842285156e+02 -1.1113400268554688e+02 9.2074996948242188e+01 1.7777299499511719e+02 -9.9883399963378906e+01 9.2074996948242188e+01 1.7488099670410156e+02 -1.0198500061035156e+02 9.2074996948242188e+01 1.8749900817871094e+02 -1.1066999816894531e+02 9.2074996948242188e+01 1.8256500244140625e+02 -9.7734504699707031e+01 9.2074996948242188e+01 1.9131599426269531e+02 -1.1158399963378906e+02 9.2074996948242188e+01 1.9500599670410156e+02 -9.8332397460937500e+01 9.2074996948242188e+01 1.8948001098632812e+02 -1.1082500457763672e+02 9.2074996948242188e+01 1.9155999755859375e+02 -9.7381401062011719e+01 9.2074996948242188e+01 1.8800000000000000e+02 -9.7060997009277344e+01 9.2074996948242188e+01 1.9282699584960938e+02 -1.1287400054931641e+02 9.2074996948242188e+01 2.0111900329589844e+02 -1.0198500061035156e+02 9.2074996948242188e+01 1.9822700500488281e+02 -9.9883399963378906e+01 9.2074996948242188e+01 2.0696299743652344e+02 -1.1083900451660156e+02 9.2074996948242188e+01 2.0460000610351562e+02 -1.0581600189208984e+02 9.2074996948242188e+01 1.8166999816894531e+02 -1.1750099945068359e+02 1.0518900299072266e+02 1.8213400268554688e+02 -1.1943199920654297e+02 1.0518900299072266e+02 1.8948001098632812e+02 -1.1082500457763672e+02 1.0518900299072266e+02 1.8387399291992188e+02 -1.1217299652099609e+02 1.0518900299072266e+02 1.8258399963378906e+02 -1.1368399810791016e+02 1.0518900299072266e+02 1.8182499694824219e+02 -1.1552000427246094e+02 1.0518900299072266e+02 1.8317300415039062e+02 -1.2112600708007812e+02 1.0518900299072266e+02 1.8468399047851562e+02 -1.2241600036621094e+02 1.0518900299072266e+02 1.8651998901367188e+02 -1.2317500305175781e+02 1.0518900299072266e+02 1.9417500305175781e+02 -1.1847999572753906e+02 1.0518900299072266e+02 1.8828700256347656e+02 -1.2337999725341797e+02 1.0518900299072266e+02 1.9341600036621094e+02 -1.2031600189208984e+02 1.0518900299072266e+02 1.9043199157714844e+02 -1.2286599731445312e+02 1.0518900299072266e+02 1.9212600708007812e+02 -1.2182699584960938e+02 1.0518900299072266e+02 1.9433000183105469e+02 -1.1649900054931641e+02 1.0518900299072266e+02 1.9386599731445312e+02 -1.1456800079345703e+02 1.0518900299072266e+02 1.9282699584960938e+02 -1.1287400054931641e+02 1.0518900299072266e+02 1.9131599426269531e+02 -1.1158399963378906e+02 1.0518900299072266e+02 1.8556800842285156e+02 -1.1113400268554688e+02 1.0518900299072266e+02 1.8749900817871094e+02 -1.1066999816894531e+02 1.0518900299072266e+02 1.8948001098632812e+02 -1.1082500457763672e+02 7.7972892761230469e+01 1.9230400085449219e+02 -1.1223900604248047e+02 7.7972892761230469e+01 1.9386599731445312e+02 -1.1456800079345703e+02 7.7972892761230469e+01 1.9438200378417969e+02 -1.1768399810791016e+02 7.7995201110839844e+01 1.9276100158691406e+02 -1.2130400085449219e+02 7.7972892761230469e+01 1.9043199157714844e+02 -1.2286599731445312e+02 7.7972892761230469e+01 1.8731599426269531e+02 -1.2338200378417969e+02 7.7972892761230469e+01 1.8468399047851562e+02 -1.2241600036621094e+02 7.7972892761230469e+01 1.8243501281738281e+02 -1.2019799804687500e+02 7.7972892761230469e+01 1.8166999816894531e+02 -1.1750099945068359e+02 7.7972892761230469e+01 1.8214199829101562e+02 -1.1437699890136719e+02 7.7972892761230469e+01 1.8480200195312500e+02 -1.1143500518798828e+02 7.7972892761230469e+01 1.8749900817871094e+02 -1.1066999816894531e+02 7.7972892761230469e+01 1.8036000061035156e+02 -1.1164299774169922e+02 7.4784706115722656e+01 1.8629800415039062e+02 -1.0820300292968750e+02 7.3911598205566406e+01 1.7883999633789062e+02 -1.1893299865722656e+02 7.4681198120117188e+01 1.8797200012207031e+02 -1.2580899810791016e+02 7.4183204650878906e+01 1.9503300476074219e+02 -1.2199700164794922e+02 7.4295898437500000e+01 1.9562199401855469e+02 -1.1209099578857422e+02 7.4401496887207031e+01 1.9748599243164062e+02 -1.1778800201416016e+02 7.5739097595214844e+01 1.8192199707031250e+02 -1.2425199890136719e+02 7.6419700622558594e+01 1.8947100830078125e+02 -1.2648799896240234e+02 7.6370201110839844e+01 1.9163400268554688e+02 -1.0851300048828125e+02 7.7296699523925781e+01 1.9377900695800781e+02 -1.2415900421142578e+02 7.6932998657226562e+01 1.9595600891113281e+02 -1.1947499847412109e+02 7.7846305847167969e+01 1.9512100219726562e+02 -1.1247900390625000e+02 7.7772300720214844e+01 1.8386698913574219e+02 -1.0968299865722656e+02 7.7821395874023438e+01 1.7991299438476562e+02 -1.1457900238037109e+02 7.7771797180175781e+01 1.8085899353027344e+02 -1.2194799804687500e+02 7.7834602355957031e+01 1.8897700500488281e+02 -1.2482499694824219e+02 7.7929199218750000e+01 1.8953700256347656e+02 -1.0683900451660156e+02 8.5700401306152344e+01 1.8296400451660156e+02 -1.0828099822998047e+02 8.5489601135253906e+01 1.9486799621582031e+02 -1.0981500244140625e+02 8.5493293762207031e+01 1.8100399780273438e+02 -1.2434700012207031e+02 8.5677993774414062e+01 1.8649198913574219e+02 -1.2693700408935547e+02 8.5498100280761719e+01 1.7842300415039062e+02 -1.1958999633789062e+02 8.5487800598144531e+01 1.9236299133300781e+02 -1.2625700378417969e+02 8.5723403930664062e+01 1.9571499633789062e+02 -1.2316699981689453e+02 8.5492698669433594e+01 1.9937199401855469e+02 -1.1263500213623047e+02 8.7639999389648438e+01 1.9792799377441406e+02 -1.1863099670410156e+02 8.5494300842285156e+01 1.8369599914550781e+02 -1.2176100158691406e+02 8.5478904724121094e+01 1.8820300292968750e+02 -1.2359099578857422e+02 8.5478904724121094e+01 1.8146299743652344e+02 -1.1725000000000000e+02 8.5478904724121094e+01 1.7843299865722656e+02 -1.1378200531005859e+02 8.5499801635742188e+01 1.8258399963378906e+02 -1.1368399810791016e+02 8.5478904724121094e+01 1.8574200439453125e+02 -1.1086100006103516e+02 8.5478904724121094e+01 1.9062200927734375e+02 -1.1114199829101562e+02 8.5478904724121094e+01 1.9429400634765625e+02 -1.1878199768066406e+02 8.5478904724121094e+01 1.9386599731445312e+02 -1.1456800079345703e+02 8.5478904724121094e+01 1.9282699584960938e+02 -1.1287400054931641e+02 8.5478904724121094e+01 1.9212600708007812e+02 -1.2182699584960938e+02 8.5478904724121094e+01 1.9034899902343750e+02 -1.0312999725341797e+02 8.9309402465820312e+01 1.9711399841308594e+02 -1.0621099853515625e+02 8.9310897827148438e+01 2.0190200805664062e+02 -1.1527200317382812e+02 8.9309997558593750e+01 2.0125801086425781e+02 -1.2057700347900391e+02 8.9031501770019531e+01 1.9887199401855469e+02 -1.2583699798583984e+02 8.9305801391601562e+01 1.9414999389648438e+02 -1.2918099975585938e+02 8.8902198791503906e+01 1.8876199340820312e+02 -1.3095100402832031e+02 8.9311897277832031e+01 1.8199501037597656e+02 -1.2978500366210938e+02 8.9311103820800781e+01 1.7742900085449219e+02 -1.2612600708007812e+02 8.9310806274414062e+01 1.7557099914550781e+02 -1.2226599884033203e+02 8.8895797729492188e+01 1.7427099609375000e+02 -1.1767700195312500e+02 8.9036499023437500e+01 1.7513499450683594e+02 -1.1267500305175781e+02 8.8927200317382812e+01 1.7821000671386719e+02 -1.0669200134277344e+02 8.9307701110839844e+01 1.8519100952148438e+02 -1.0331299591064453e+02 8.9310806274414062e+01 1.7406399536132812e+02 -1.1272700500488281e+02 8.9314300537109375e+01 1.8556800842285156e+02 -1.1113400268554688e+02 8.9314300537109375e+01 1.8749900817871094e+02 -1.1066999816894531e+02 8.9314300537109375e+01 1.8228698730468750e+02 -1.1381399536132812e+02 8.9314300537109375e+01 1.8166999816894531e+02 -1.1750099945068359e+02 8.9314300537109375e+01 1.8213400268554688e+02 -1.1943199920654297e+02 8.9314300537109375e+01 1.8317300415039062e+02 -1.2112600708007812e+02 8.9314300537109375e+01 1.9212600708007812e+02 -1.2182699584960938e+02 8.9314300537109375e+01 1.9341600036621094e+02 -1.2031600189208984e+02 8.9314300537109375e+01 1.8679800415039062e+02 -1.2347499847412109e+02 8.9314300537109375e+01 1.9043199157714844e+02 -1.2286599731445312e+02 8.9314300537109375e+01 1.9417500305175781e+02 -1.1847999572753906e+02 8.9314300537109375e+01 1.9433000183105469e+02 -1.1649900054931641e+02 8.9314300537109375e+01 1.9279600524902344e+02 -1.1255100250244141e+02 8.9314300537109375e+01 1.8948001098632812e+02 -1.1082500457763672e+02 8.9314300537109375e+01 1.5939900207519531e+02 1.4053698730468750e+02 2.7293098449707031e+01 1.5903698730468750e+02 1.4055499267578125e+02 3.5552799224853516e+01 1.7366400146484375e+02 1.4019699096679688e+02 2.7968799591064453e+01 1.7326100158691406e+02 1.4020300292968750e+02 3.6213302612304688e+01 1.6672599792480469e+02 1.4035800170898438e+02 2.3525598526000977e+01 1.6593200683593750e+02 1.3977099609375000e+02 3.9989601135253906e+01 1.7353599548339844e+02 1.3488299560546875e+02 2.7968000411987305e+01 1.7314599609375000e+02 1.3489199829101562e+02 3.6207698822021484e+01 1.6581700134277344e+02 1.3506999206542969e+02 3.9989700317382812e+01 1.5887899780273438e+02 1.3523899841308594e+02 3.5531902313232422e+01 1.5926901245117188e+02 1.3522900390625000e+02 2.7292200088500977e+01 1.6659700012207031e+02 1.3505099487304688e+02 2.3510299682617188e+01 1.7218199157714844e+02 1.3491598510742188e+02 2.8340600967407227e+01 1.6504199218750000e+02 1.3508898925781250e+02 2.5140199661254883e+01 1.5969400024414062e+02 1.3521899414062500e+02 3.3363700866699219e+01 1.6464300537109375e+02 1.3509899902343750e+02 3.8276901245117188e+01 1.7128099060058594e+02 1.3493699645996094e+02 3.6141700744628906e+01 1.6197599792480469e+02 1.3465499877929688e+02 2.6514499664306641e+01 1.7289898681640625e+02 1.3426300048828125e+02 3.1570098876953125e+01 1.6911799621582031e+02 1.3435499572753906e+02 2.5710201263427734e+01 1.5931500244140625e+02 1.3459300231933594e+02 3.1917798995971680e+01 1.6411499023437500e+02 1.3447601318359375e+02 3.8132102966308594e+01 1.7015100097656250e+02 1.3433000183105469e+02 3.7002002716064453e+01 1.6407499694824219e+02 9.4788795471191406e+01 2.8042800903320312e+01 1.6703199768066406e+02 9.4722900390625000e+01 3.5248199462890625e+01 1.6209899902343750e+02 9.4875999450683594e+01 3.4134399414062500e+01 1.6916101074218750e+02 9.4681594848632812e+01 3.1915601730346680e+01 1.7009599304199219e+02 1.3433100891113281e+02 3.1250499725341797e+01 1.7003099060058594e+02 1.3433299255371094e+02 3.2616298675537109e+01 1.6950300598144531e+02 1.3434500122070312e+02 3.3877601623535156e+01 1.6857600402832031e+02 1.3436799621582031e+02 3.4882198333740234e+01 1.6736100769042969e+02 1.3439700317382812e+02 3.5509098052978516e+01 1.6600599670410156e+02 1.3443000793457031e+02 3.5682598114013672e+01 1.6467199707031250e+02 1.3446299743652344e+02 3.5381702423095703e+01 1.6352200317382812e+02 1.3449099731445312e+02 3.4642799377441406e+01 1.6269400024414062e+02 1.3451098632812500e+02 3.3555000305175781e+01 1.6288000488281250e+02 1.3450599670410156e+02 2.9622400283813477e+01 1.6380700683593750e+02 1.3448399353027344e+02 2.8617700576782227e+01 1.6502200317382812e+02 1.3445399475097656e+02 2.7990900039672852e+01 1.6637800598144531e+02 1.3442100524902344e+02 2.7817399978637695e+01 1.6771099853515625e+02 1.3438899230957031e+02 2.8118200302124023e+01 1.6228799438476562e+02 1.3452099609375000e+02 3.2249500274658203e+01 1.6235198974609375e+02 1.3451899719238281e+02 3.0883699417114258e+01 1.6886199951171875e+02 1.3436099243164062e+02 2.8857101440429688e+01 1.6969000244140625e+02 1.3434100341796875e+02 2.9944999694824219e+01 1.6575300598144531e+02 9.5808700561523438e+01 3.5655101776123047e+01 1.6438800048828125e+02 9.5841896057128906e+01 3.5590499877929688e+01 1.6312699890136719e+02 9.5872497558593750e+01 3.5062599182128906e+01 1.6149600219726562e+02 9.5912200927734375e+01 3.2919998168945312e+01 1.6132199096679688e+02 9.5916297912597656e+01 3.1563798904418945e+01 1.6162300109863281e+02 9.5909095764160156e+01 3.0230001449584961e+01 1.6236199951171875e+02 9.5891105651855469e+01 2.9079500198364258e+01 1.6344900512695312e+02 9.5864601135253906e+01 2.8251201629638672e+01 1.6475399780273438e+02 9.5832901000976562e+01 2.7844799041748047e+01 1.6611999511718750e+02 9.5799797058105469e+01 2.7909500122070312e+01 1.6738099670410156e+02 9.5769195556640625e+01 2.8437400817871094e+01 1.6838499450683594e+02 9.5744697570800781e+01 2.9364799499511719e+01 1.6875199890136719e+02 9.5735801696777344e+01 2.9944999694824219e+01 1.6901199340820312e+02 9.5729499816894531e+01 3.0579900741577148e+01 1.6888499450683594e+02 9.5732597351074219e+01 3.3270000457763672e+01 1.6814599609375000e+02 9.5750602722167969e+01 3.4420402526855469e+01 1.7151100158691406e+02 9.5127799987792969e+01 3.1466999053955078e+01 1.7031300354003906e+02 9.4281097412109375e+01 2.8698099136352539e+01 1.6745500183105469e+02 9.4502601623535156e+01 2.5876001358032227e+01 1.7156399536132812e+02 9.7533302307128906e+01 3.5364799499511719e+01 1.6882299804687500e+02 9.4404899597167969e+01 3.6806598663330078e+01 1.5899499511718750e+02 9.5313400268554688e+01 3.2491798400878906e+01 1.5998500061035156e+02 9.4529098510742188e+01 3.4625999450683594e+01 1.6365400695800781e+02 9.4699394226074219e+01 3.7941299438476562e+01 1.6283799743652344e+02 9.6329895019531250e+01 2.5744098663330078e+01 1.6073599243164062e+02 9.4696296691894531e+01 2.7559900283813477e+01 1.6536801147460938e+02 1.0055799865722656e+02 2.4412900924682617e+01 1.7172000122070312e+02 1.0036199951171875e+02 2.8080999374389648e+01 1.6527999877929688e+02 9.6892196655273438e+01 3.9082298278808594e+01 1.5901599121093750e+02 1.0070300292968750e+02 2.8082099914550781e+01 1.5901599121093750e+02 1.0068499755859375e+02 3.5419200897216797e+01 1.6749000549316406e+02 9.4449996948242188e+01 3.4774700164794922e+01 1.6562899780273438e+02 9.5193397521972656e+01 2.7885299682617188e+01 1.6814399719238281e+02 9.5028900146484375e+01 2.9250699996948242e+01 1.6245199584960938e+02 9.4572502136230469e+01 2.9478700637817383e+01 1.6241900634765625e+02 9.4573295593261719e+01 3.3842998504638672e+01 1.7171701049804688e+02 1.0048400115966797e+02 3.5415401458740234e+01 1.6536999511718750e+02 1.0063500213623047e+02 3.9080299377441406e+01 1.6143899536132812e+02 9.6734893798828125e+01 3.1052200317382812e+01 1.6248500061035156e+02 9.6709495544433594e+01 3.4793498992919922e+01 1.6760499572753906e+02 9.6585105895996094e+01 3.5161701202392578e+01 1.6916699218750000e+02 9.6547203063964844e+01 3.1582601547241211e+01 1.6298899841308594e+02 9.6697303771972656e+01 2.8360700607299805e+01 1.6135099792480469e+02 1.0075200653076172e+02 3.0685701370239258e+01 1.6214999389648438e+02 1.0073200225830078e+02 3.4172500610351562e+01 1.6414700317382812e+02 1.0068400573730469e+02 2.7849700927734375e+01 1.6569699096679688e+02 1.0064599609375000e+02 3.5984699249267578e+01 1.6939199829101562e+02 1.0055599975585938e+02 3.2814201354980469e+01 1.6807398986816406e+02 1.0058800506591797e+02 2.8588199615478516e+01 1.8399099731445312e+02 1.1280900573730469e+02 8.0995498657226562e+01 1.8117900085449219e+02 1.1014000701904297e+02 8.0995498657226562e+01 1.8666799926757812e+02 1.0741799926757812e+02 8.0995498657226562e+01 1.8784800720214844e+02 1.1127299499511719e+02 8.0995498657226562e+01 1.9104998779296875e+02 1.2193299865722656e+02 8.0995498657226562e+01 1.9158599853515625e+02 1.2598499298095703e+02 8.0995498657226562e+01 1.8517300415039062e+02 1.2229100036621094e+02 8.0995498657226562e+01 1.8546899414062500e+02 1.2633700561523438e+02 8.0995498657226562e+01 1.9194300842285156e+02 1.0824300384521484e+02 8.0995498657226562e+01 1.9174900817871094e+02 1.1257500457763672e+02 8.0995498657226562e+01 1.9387500000000000e+02 1.1742799377441406e+02 8.0995498657226562e+01 1.9579100036621094e+02 1.2261500549316406e+02 8.0995498657226562e+01 1.8220298767089844e+02 1.1717499542236328e+02 8.0995498657226562e+01 1.7842599487304688e+02 1.1561299896240234e+02 8.0995498657226562e+01 1.7983000183105469e+02 1.2234999847412109e+02 8.0995498657226562e+01 1.9765501403808594e+02 1.1761199951171875e+02 8.0995498657226562e+01 1.9608599853515625e+02 1.1168900299072266e+02 8.0995498657226562e+01 1.8659199523925781e+02 1.2271899414062500e+02 7.7972892761230469e+01 1.8263299560546875e+02 1.1919800567626953e+02 7.7972892761230469e+01 1.8277500915527344e+02 1.1448200225830078e+02 7.7972892761230469e+01 1.8695999145507812e+02 1.1120200347900391e+02 7.7972892761230469e+01 1.9200900268554688e+02 1.1280900573730469e+02 7.7972892761230469e+01 1.9371199035644531e+02 1.1655300140380859e+02 7.7972892761230469e+01 1.9224899291992188e+02 1.2107899475097656e+02 7.7972892761230469e+01 1.8441400146484375e+02 1.2598499298095703e+02 7.7972892761230469e+01 1.9131700134277344e+02 1.2618499755859375e+02 7.7972892761230469e+01 1.9731999206542969e+02 1.2026899719238281e+02 7.7972892761230469e+01 1.9664299011230469e+02 1.1265299987792969e+02 7.7972892761230469e+01 1.9296699523925781e+02 1.0878100585937500e+02 7.7972892761230469e+01 1.8777699279785156e+02 1.0732799530029297e+02 7.7972892761230469e+01 1.8201200866699219e+02 1.0940200042724609e+02 7.7972892761230469e+01 1.7838700866699219e+02 1.1528099822998047e+02 7.7972892761230469e+01 1.7973500061035156e+02 1.2202899932861328e+02 7.7972892761230469e+01 1.8530599975585938e+02 1.2364499664306641e+02 8.1051399230957031e+01 1.8971600341796875e+02 1.2407099914550781e+02 8.2956405639648438e+01 1.8915100097656250e+02 1.2407700347900391e+02 8.1051399230957031e+01 1.9348899841308594e+02 1.2177700042724609e+02 8.1051399230957031e+01 1.9375399780273438e+02 1.2127799987792969e+02 8.2956405639648438e+01 1.9515499877929688e+02 1.1764099884033203e+02 8.2944297790527344e+01 1.9516400146484375e+02 1.1731299591064453e+02 8.1051399230957031e+01 1.9408799743652344e+02 1.1301500701904297e+02 8.2956405639648438e+01 1.9379399108886719e+02 1.1259799957275391e+02 8.1051399230957031e+01 1.8924299621582031e+02 1.0983100128173828e+02 8.2956405639648438e+01 1.8873800659179688e+02 1.0976100158691406e+02 8.1051399230957031e+01 1.8277999877929688e+02 1.1172100067138672e+02 8.2956405639648438e+01 1.8412399291992188e+02 1.1096700286865234e+02 8.1051399230957031e+01 1.8155400085449219e+02 1.1385900115966797e+02 8.1051399230957031e+01 1.8083601379394531e+02 1.1731299591064453e+02 8.2956405639648438e+01 1.8098100280761719e+02 1.1721900177001953e+02 8.1053199768066406e+01 1.8308999633789062e+02 1.2256900024414062e+02 8.2956405639648438e+01 1.8224600219726562e+02 1.2127799987792969e+02 8.1051399230957031e+01 1.8092800903320312e+02 1.2590500640869141e+02 8.2959503173828125e+01 1.9312199401855469e+02 1.2737000274658203e+02 8.2976699829101562e+01 1.7799600219726562e+02 1.1117600250244141e+02 8.2975997924804688e+01 1.8955000305175781e+02 1.0569100189208984e+02 8.2961097717285156e+01 1.8619599914550781e+02 1.2252600097656250e+02 8.1050598144531250e+01 1.9129598999023438e+02 1.2177500152587891e+02 8.1071502685546875e+01 1.8889099121093750e+02 1.1135900115966797e+02 8.1050201416015625e+01 1.8460301208496094e+02 1.1227400207519531e+02 8.1052307128906250e+01 1.8216699218750000e+02 1.1686100006103516e+02 8.1051902770996094e+01 1.9363899230957031e+02 1.1779800415039062e+02 8.1052803039550781e+01 1.9268701171875000e+02 1.1355099487304688e+02 8.1051902770996094e+01 1.7744799804687500e+02 1.2629499816894531e+02 8.6049804687500000e+01 1.8544900512695312e+02 1.2886700439453125e+02 8.3522697448730469e+01 1.7523799133300781e+02 1.1158999633789062e+02 8.5938293457031250e+01 1.7623199462890625e+02 1.1601599884033203e+02 8.3298896789550781e+01 1.8102000427246094e+02 1.0440200042724609e+02 8.6315605163574219e+01 1.8255000305175781e+02 1.0642900085449219e+02 8.3289802551269531e+01 1.9177299499511719e+02 1.0418399810791016e+02 8.5397399902343750e+01 1.9663700866699219e+02 1.0609199523925781e+02 8.6009803771972656e+01 1.9649400329589844e+02 1.0866699981689453e+02 8.3374496459960938e+01 1.9854701232910156e+02 1.2626099395751953e+02 8.6047302246093750e+01 1.9945800781250000e+02 1.2113700103759766e+02 8.3371604919433594e+01 1.8479100036621094e+02 1.3054299926757812e+02 8.6041000366210938e+01 1.9209300231933594e+02 1.3015499877929688e+02 8.5972396850585938e+01 1.7694400024414062e+02 1.2220399475097656e+02 8.3618003845214844e+01 1.9930299377441406e+02 1.1302999877929688e+02 8.3485198974609375e+01 1.8595098876953125e+02 1.2265200042724609e+02 8.4823303222656250e+01 1.8219499206542969e+02 1.1785300445556641e+02 8.4840606689453125e+01 1.8350100708007812e+02 1.1347299957275391e+02 8.4336494445800781e+01 1.8708599853515625e+02 1.1121700286865234e+02 8.4840499877929688e+01 1.9119999694824219e+02 1.1226000213623047e+02 8.4346694946289062e+01 1.9350199890136719e+02 1.1525900268554688e+02 8.4838600158691406e+01 1.9261799621582031e+02 1.2047699737548828e+02 8.4828102111816406e+01 2.0167900085449219e+02 1.1880300140380859e+02 8.5993103027343750e+01 1.7425000000000000e+02 1.1867299652099609e+02 8.6069801330566406e+01 1.7196301269531250e+02 1.1932999420166016e+02 8.6659996032714844e+01 1.7022000122070312e+02 1.1660200500488281e+02 8.6352897644042969e+01 1.7228900146484375e+02 1.2689701080322266e+02 8.5752395629882812e+01 1.6873799133300781e+02 1.2041200256347656e+02 8.4041999816894531e+01 1.7136399841308594e+02 1.2718500518798828e+02 8.3552894592285156e+01 1.7575601196289062e+02 1.3212400817871094e+02 8.4527099609375000e+01 1.7643399047851562e+02 1.2901599121093750e+02 8.6659294128417969e+01 1.8367601013183594e+02 1.3324000549316406e+02 8.6669303894042969e+01 1.8279299926757812e+02 1.3565699768066406e+02 8.4617195129394531e+01 1.8947898864746094e+02 1.3643499755859375e+02 8.4462501525878906e+01 1.9113301086425781e+02 1.3332701110839844e+02 8.6657699584960938e+01 1.9674099731445312e+02 1.3185499572753906e+02 8.6619804382324219e+01 1.9924501037597656e+02 1.3291099548339844e+02 8.4597404479980469e+01 2.0517799377441406e+02 1.2165699768066406e+02 8.6421806335449219e+01 2.0305000305175781e+02 1.2904701232910156e+02 8.5135604858398438e+01 2.0629200744628906e+02 1.2372299957275391e+02 8.3786399841308594e+01 2.0280799865722656e+02 1.1301200103759766e+02 8.6700096130371094e+01 1.9919299316406250e+02 1.0434199523925781e+02 8.6657798767089844e+01 2.0618798828125000e+02 1.1265100097656250e+02 8.5721099853515625e+01 2.0283499145507812e+02 1.0454199981689453e+02 8.4610404968261719e+01 2.0545700073242188e+02 1.0839199829101562e+02 8.3680999755859375e+01 1.8876298522949219e+02 1.0210099792480469e+02 8.6474800109863281e+01 1.9131599426269531e+02 9.9562698364257812e+01 8.6305496215820312e+01 1.9514399719238281e+02 9.8765701293945312e+01 8.3937805175781250e+01 1.8906700134277344e+02 9.7571998596191406e+01 8.4044906616210938e+01 1.8410900878906250e+02 1.0071299743652344e+02 8.6645904541015625e+01 1.7589900207519531e+02 1.0360199737548828e+02 8.6156501770019531e+01 1.7398298645019531e+02 1.0811799621582031e+02 8.6664398193359375e+01 1.7799099731445312e+02 1.0036399841308594e+02 8.4583793640136719e+01 1.7257200622558594e+02 1.0495500183105469e+02 8.3879394531250000e+01 1.7824200439453125e+02 1.3400199890136719e+02 8.1031097412109375e+01 1.9336999511718750e+02 1.3576699829101562e+02 8.1034698486328125e+01 2.0754800415039062e+02 1.1573999786376953e+02 8.3988304138183594e+01 1.9797100830078125e+02 1.0157500457763672e+02 8.5806694030761719e+01 2.0026899719238281e+02 1.0185000610351562e+02 8.1033897399902344e+01 1.8325201416015625e+02 9.8163597106933594e+01 8.4478401184082031e+01 1.7109500122070312e+02 1.0923500061035156e+02 8.5552902221679688e+01 1.6892799377441406e+02 1.1265599822998047e+02 8.3868896484375000e+01 1.8642399597167969e+02 1.3646200561523438e+02 8.1030395507812500e+01 1.7339498901367188e+02 1.2985398864746094e+02 8.1030693054199219e+01 1.6980799865722656e+02 1.2435299682617188e+02 8.1032997131347656e+01 1.6848100280761719e+02 1.1630900573730469e+02 8.1029899597167969e+01 1.6992401123046875e+02 1.0960199737548828e+02 8.1031097412109375e+01 1.7350700378417969e+02 1.0391699981689453e+02 8.1028900146484375e+01 1.8009899902343750e+02 9.9010498046875000e+01 8.1032798767089844e+01 1.8818399047851562e+02 9.7466201782226562e+01 8.1031600952148438e+01 1.9454798889160156e+02 9.8624000549316406e+01 8.1029495239257812e+01 2.0550399780273438e+02 1.0813699340820312e+02 8.1027999877929688e+01 2.0764300537109375e+02 1.1796099853515625e+02 8.1031600952148438e+01 2.0461300659179688e+02 1.2747299957275391e+02 8.1029800415039062e+01 1.9880999755859375e+02 1.3326899719238281e+02 8.1031394958496094e+01 1.8946400451660156e+02 1.0593599700927734e+02 8.4866798400878906e+01 1.9829598999023438e+02 1.1229000091552734e+02 8.4860305786132812e+01 1.8165299987792969e+02 1.2623399353027344e+02 8.4860000610351562e+01 1.7769099426269531e+02 1.2050399780273438e+02 8.4872604370117188e+01 1.8131600952148438e+02 1.0805500030517578e+02 8.4857704162597656e+01 1.7723800659179688e+02 1.1454299926757812e+02 8.4857795715332031e+01 1.9733799743652344e+02 1.2360900115966797e+02 8.4860694885253906e+01 1.8908700561523438e+02 1.2795099639892578e+02 8.4858596801757812e+01 1.6738699340820312e+02 1.2123899841308594e+02 8.1031303405761719e+01 1.6975199890136719e+02 1.2747800445556641e+02 8.1031394958496094e+01 1.7394999694824219e+02 1.3269999694824219e+02 8.1031303405761719e+01 1.7991400146484375e+02 1.3644699096679688e+02 8.1031501770019531e+01 1.8636999511718750e+02 1.3797200012207031e+02 8.1029495239257812e+01 1.9490000915527344e+02 1.3702699279785156e+02 8.1028999328613281e+01 2.0060699462890625e+02 1.3377600097656250e+02 8.1030693054199219e+01 2.0440899658203125e+02 1.3019999694824219e+02 8.1031204223632812e+01 2.0768899536132812e+02 1.2440600585937500e+02 8.1029197692871094e+01 2.0915399169921875e+02 1.1628100585937500e+02 8.1031303405761719e+01 2.0706201171875000e+02 1.0807499694824219e+02 8.1028900146484375e+01 2.0189399719238281e+02 1.0101100158691406e+02 8.1028900146484375e+01 1.9463500976562500e+02 9.7029296875000000e+01 8.1031303405761719e+01 1.8805000305175781e+02 9.5957695007324219e+01 8.1031394958496094e+01 1.8297799682617188e+02 9.6624702453613281e+01 8.1030693054199219e+01 1.7654899597167969e+02 9.9172401428222656e+01 8.1030693054199219e+01 1.7065699768066406e+02 1.0509700012207031e+02 8.1029495239257812e+01 1.6720600891113281e+02 1.1296199798583984e+02 8.1028900146484375e+01 1.9447200012207031e+02 1.0612899780273438e+02 8.6810295104980469e+01 1.9376300048828125e+02 1.3707000732421875e+02 8.5174301147460938e+01 1.8659100341796875e+02 1.3805900573730469e+02 8.3571502685546875e+01 2.0039300537109375e+02 1.3397599792480469e+02 8.3895698547363281e+01 2.0426699829101562e+02 1.3013499450683594e+02 8.4827102661132812e+01 2.0674600219726562e+02 1.2625299072265625e+02 8.4852195739746094e+01 2.0883999633789062e+02 1.1977100372314453e+02 8.3866905212402344e+01 2.0835400390625000e+02 1.1138100433349609e+02 8.3836395263671875e+01 2.0347100830078125e+02 1.0271500396728516e+02 8.4490997314453125e+01 1.9713400268554688e+02 9.8214599609375000e+01 8.5157798767089844e+01 1.8850801086425781e+02 9.5954406738281250e+01 8.4608695983886719e+01 1.8002699279785156e+02 9.7554000854492188e+01 8.3895401000976562e+01 1.7294700622558594e+02 1.0225599670410156e+02 8.4356399536132812e+01 1.6800599670410156e+02 1.1033599853515625e+02 8.3995002746582031e+01 1.6705299377441406e+02 1.1685199737548828e+02 8.4700706481933594e+01 1.6775498962402344e+02 1.2231600189208984e+02 8.4815505981445312e+01 1.7030400085449219e+02 1.2812300109863281e+02 8.5015106201171875e+01 1.7518000793457031e+02 1.3366299438476562e+02 8.3866905212402344e+01 1.8006100463867188e+02 1.3634799194335938e+02 8.4815704345703125e+01 1.6947300720214844e+02 1.2041600036621094e+02 8.7365203857421875e+01 1.7274198913574219e+02 1.1779700469970703e+02 8.8275405883789062e+01 1.7558399963378906e+02 1.1258599853515625e+02 8.7269302368164062e+01 1.7389700317382812e+02 1.3124600219726562e+02 8.6296203613281250e+01 1.7393699645996094e+02 1.2779599761962891e+02 8.7937103271484375e+01 1.7967599487304688e+02 1.3390100097656250e+02 8.7365203857421875e+01 1.8258300781250000e+02 1.3275900268554688e+02 8.8164001464843750e+01 1.7739900207519531e+02 1.2761500549316406e+02 8.8130195617675781e+01 1.8569400024414062e+02 1.3718000793457031e+02 8.5948699951171875e+01 1.8790100097656250e+02 1.3514801025390625e+02 8.7773597717285156e+01 1.8193598937988281e+02 1.2900000000000000e+02 8.7447898864746094e+01 1.9421899414062500e+02 1.3261599731445312e+02 8.8217697143554688e+01 1.9801699829101562e+02 1.3445399475097656e+02 8.6143302917480469e+01 2.0043200683593750e+02 1.2984399414062500e+02 8.7959495544433594e+01 1.9281800842285156e+02 1.2938700866699219e+02 8.7316993713378906e+01 2.0026300048828125e+02 1.2168800354003906e+02 8.7203598022460938e+01 2.0494799804687500e+02 1.2386199951171875e+02 8.7757102966308594e+01 2.0804800415039062e+02 1.1860800170898438e+02 8.6312500000000000e+01 2.0308399963378906e+02 1.2136199951171875e+02 8.8181694030761719e+01 2.0585400390625000e+02 1.1360199737548828e+02 8.7752197265625000e+01 2.0186700439453125e+02 1.0953799438476562e+02 8.8171104431152344e+01 2.0025399780273438e+02 1.1264199829101562e+02 8.7266998291015625e+01 2.0645500183105469e+02 1.0878700256347656e+02 8.6144699096679688e+01 1.9156100463867188e+02 9.8583000183105469e+01 8.7583702087402344e+01 2.0076599121093750e+02 1.0418499755859375e+02 8.7872497558593750e+01 1.8809500122070312e+02 1.0062999725341797e+02 8.8211502075195312e+01 1.8647499084472656e+02 1.0354000091552734e+02 8.7497200012207031e+01 1.8288700866699219e+02 9.7806198120117188e+01 8.6679603576660156e+01 1.7106700134277344e+02 1.0696599578857422e+02 8.6759300231933594e+01 1.6908599853515625e+02 1.1121700286865234e+02 8.6564697265625000e+01 1.7625399780273438e+02 1.0504700469970703e+02 8.8228004455566406e+01 1.8035798645019531e+02 1.0653700256347656e+02 8.7283203125000000e+01 1.7631300354003906e+02 1.0079299926757812e+02 8.6323295593261719e+01 1.7085299682617188e+02 1.1209500122070312e+02 8.7869102478027344e+01 1.8491200256347656e+02 1.2402500152587891e+02 8.3277702331542969e+01 1.9084799194335938e+02 1.2705699920654297e+02 8.3270401000976562e+01 1.8277400207519531e+02 1.2773300933837891e+02 8.2648902893066406e+01 1.7747799682617188e+02 1.2200900268554688e+02 8.3072196960449219e+01 1.8108399963378906e+02 1.1441699981689453e+02 8.3278800964355469e+01 1.7627301025390625e+02 1.1521700286865234e+02 8.2660507202148438e+01 1.7947299194335938e+02 1.0866300201416016e+02 8.2672904968261719e+01 1.8403099060058594e+02 1.1088500213623047e+02 8.3279602050781250e+01 1.8620899963378906e+02 1.0564699554443359e+02 8.3173797607421875e+01 1.9753601074218750e+02 1.1072900390625000e+02 8.3173797607421875e+01 1.9958999633789062e+02 1.1628800201416016e+02 8.2875099182128906e+01 1.9518400573730469e+02 1.1869899749755859e+02 8.3280601501464844e+01 1.9535200500488281e+02 1.2626199340820312e+02 8.2818199157714844e+01 2.0148199462890625e+02 1.1885099792480469e+02 7.9885398864746094e+01 1.9925500488281250e+02 1.2455700683593750e+02 7.9946197509765625e+01 1.8912899780273438e+02 1.2879499816894531e+02 8.2600700378417969e+01 1.9391900634765625e+02 1.0493800354003906e+02 8.0861206054687500e+01 1.9830699157714844e+02 1.0815200042724609e+02 7.9572998046875000e+01 2.0108200073242188e+02 1.1333000183105469e+02 7.9162200927734375e+01 1.9453599548339844e+02 1.2897599792480469e+02 7.9558403015136719e+01 1.8844699096679688e+02 1.3055099487304688e+02 7.9626296997070312e+01 1.8133099365234375e+02 1.0511600494384766e+02 7.9558601379394531e+01 1.8252499389648438e+02 1.2947900390625000e+02 7.9580902099609375e+01 1.7703999328613281e+02 1.2511900329589844e+02 7.9646804809570312e+01 1.7468099975585938e+02 1.1961899566650391e+02 7.9596496582031250e+01 1.7467098999023438e+02 1.1450800323486328e+02 7.9598396301269531e+01 1.7671699523925781e+02 1.0942299652099609e+02 7.9580101013183594e+01 1.8813900756835938e+02 1.0336799621582031e+02 7.9614601135253906e+01 1.9183399963378906e+02 1.1069200134277344e+02 8.3273902893066406e+01 1.9475099182128906e+02 1.1425000000000000e+02 8.3273902893066406e+01 1.8747000122070312e+02 1.0972899627685547e+02 8.3273902893066406e+01 1.8095800781250000e+02 1.1888299560546875e+02 8.3273902893066406e+01 1.9207499694824219e+02 1.2315399932861328e+02 8.3273902893066406e+01 1.8813299560546875e+02 1.2437999725341797e+02 8.0995498657226562e+01 1.8304499816894531e+02 1.2247100067138672e+02 8.0995498657226562e+01 1.8064300537109375e+02 1.1759600067138672e+02 8.0995498657226562e+01 1.8222900390625000e+02 1.1239799499511719e+02 8.0995498657226562e+01 1.8694299316406250e+02 1.0969499969482422e+02 8.0995498657226562e+01 1.9133499145507812e+02 1.1051799774169922e+02 8.0995498657226562e+01 1.9462100219726562e+02 1.1373799896240234e+02 8.0995498657226562e+01 1.9505999755859375e+02 1.1915399932861328e+02 8.0995498657226562e+01 1.9244499206542969e+02 1.2277700042724609e+02 8.0995498657226562e+01 2.0160000610351562e+02 1.1726499938964844e+02 7.4335098266601562e+01 2.0058200073242188e+02 1.2218399810791016e+02 7.4327400207519531e+01 1.9721501159667969e+02 1.2712399291992188e+02 7.4309501647949219e+01 1.9281900024414062e+02 1.2978700256347656e+02 7.3817405700683594e+01 1.9927699279785156e+02 1.0936400604248047e+02 7.4328498840332031e+01 1.8953601074218750e+02 1.0349600219726562e+02 7.4912895202636719e+01 1.9528100585937500e+02 1.0540599822998047e+02 7.4331596374511719e+01 1.7849299621582031e+02 1.0727199554443359e+02 7.4523902893066406e+01 1.8361799621582031e+02 1.0406199645996094e+02 7.4602401733398438e+01 1.7528399658203125e+02 1.1201900482177734e+02 7.4446502685546875e+01 1.8687799072265625e+02 1.3063900756835938e+02 7.4340202331542969e+01 1.8030999755859375e+02 1.2829600524902344e+02 7.4324501037597656e+01 1.7679199218750000e+02 1.2465399932861328e+02 7.4327499389648438e+01 1.7437200927734375e+02 1.1886399841308594e+02 7.4265701293945312e+01 1.8637100219726562e+02 1.0732099914550781e+02 8.0994895935058594e+01 1.7927500915527344e+02 1.1149500274658203e+02 8.0958206176757812e+01 1.9621600341796875e+02 1.1101499938964844e+02 8.0981407165527344e+01 1.8597399902343750e+02 1.2735299682617188e+02 8.0960403442382812e+01 1.9369400024414062e+02 1.2555999755859375e+02 8.0957099914550781e+01 1.9780599975585938e+02 1.2035700225830078e+02 8.0950401306152344e+01 1.7933799743652344e+02 1.2247299957275391e+02 8.0960304260253906e+01 1.9028500366210938e+02 1.0031100463867188e+02 7.3619003295898438e+01 1.9666198730468750e+02 1.0266199493408203e+02 7.3618598937988281e+01 1.8997299194335938e+02 1.3363499450683594e+02 7.3618202209472656e+01 1.9644500732421875e+02 1.3157499694824219e+02 7.3619400024414062e+01 2.0157400512695312e+02 1.2681700134277344e+02 7.3618400573730469e+01 2.0402600097656250e+02 1.2187699890136719e+02 7.3618598937988281e+01 2.0473899841308594e+02 1.1511900329589844e+02 7.3617698669433594e+01 2.0182701110839844e+02 1.0737899780273438e+02 7.3617195129394531e+01 1.8721101379394531e+02 1.0236299896240234e+02 7.3646202087402344e+01 1.7832499694824219e+02 1.0334099578857422e+02 7.3571601867675781e+01 1.8331600952148438e+02 1.0091699981689453e+02 7.3618003845214844e+01 1.7447898864746094e+02 1.0713499450683594e+02 7.3578903198242188e+01 1.7125900268554688e+02 1.1759200286865234e+02 7.3616996765136719e+01 1.7197300720214844e+02 1.1212500000000000e+02 7.3618003845214844e+01 1.7235800170898438e+02 1.2299499511718750e+02 7.3618598937988281e+01 1.7594499206542969e+02 1.2876600646972656e+02 7.3617599487304688e+01 1.8299800109863281e+02 1.3308499145507812e+02 7.3617599487304688e+01 1.9793798828125000e+02 1.1411399841308594e+02 8.0705001831054688e+01 1.9228500366210938e+02 1.0732699584960938e+02 8.0626396179199219e+01 1.7621499633789062e+02 1.1673200225830078e+02 7.8686599731445312e+01 1.8437300109863281e+02 1.0571700286865234e+02 7.8608001708984375e+01 1.9043000793457031e+02 1.0542099761962891e+02 7.8161796569824219e+01 1.9542900085449219e+02 1.0773500061035156e+02 7.8212402343750000e+01 1.9888200378417969e+02 1.1240399932861328e+02 7.8173599243164062e+01 1.9986300659179688e+02 1.1783999633789062e+02 7.8188705444335938e+01 1.9788299560546875e+02 1.2346400451660156e+02 7.8200302124023438e+01 1.9388600158691406e+02 1.2732699584960938e+02 7.8205902099609375e+01 1.8815000915527344e+02 1.2881100463867188e+02 7.8199897766113281e+01 1.8270100402832031e+02 1.2760199737548828e+02 7.8231101989746094e+01 1.7783599853515625e+02 1.2308399963378906e+02 7.8166801452636719e+01 1.7860600280761719e+02 1.0949500274658203e+02 7.8150596618652344e+01 1.8494999694824219e+02 1.3347200012207031e+02 7.1339599609375000e+01 1.9194400024414062e+02 1.3337699890136719e+02 7.1339897155761719e+01 1.9926300048828125e+02 1.2952600097656250e+02 7.1340301513671875e+01 2.0321800231933594e+02 1.2400199890136719e+02 7.1343498229980469e+01 2.0484399414062500e+02 1.1719699859619141e+02 7.1343498229980469e+01 2.0345799255371094e+02 1.1054599761962891e+02 7.1339195251464844e+01 2.0052600097656250e+02 1.0587599945068359e+02 7.1343498229980469e+01 1.9623599243164062e+02 1.0241300201416016e+02 7.1339599609375000e+01 1.9105200195312500e+02 1.0052899932861328e+02 7.1339195251464844e+01 1.8405599975585938e+02 1.0062400054931641e+02 7.1338493347167969e+01 1.7794898986816406e+02 1.0359899902343750e+02 7.1339195251464844e+01 1.7414100646972656e+02 1.0758999633789062e+02 7.1339500427246094e+01 1.7183700561523438e+02 1.1259799957275391e+02 7.1343498229980469e+01 1.7135398864746094e+02 1.1952500152587891e+02 7.1316505432128906e+01 1.7458599853515625e+02 1.2718899536132812e+02 7.1340797424316406e+01 1.7976499938964844e+02 1.3158799743652344e+02 7.1339195251464844e+01 2.0183500671386719e+02 1.1395099639892578e+02 7.1435600280761719e+01 1.9998200988769531e+02 1.2449300384521484e+02 7.1424499511718750e+01 1.7336900329589844e+02 1.1429999542236328e+02 7.1350997924804688e+01 1.9108100891113281e+02 1.3108799743652344e+02 7.1404899597167969e+01 1.9305700683593750e+02 1.0328400421142578e+02 7.1430603027343750e+01 1.8511700439453125e+02 1.2852899169921875e+02 7.3201499938964844e+01 1.7939401245117188e+02 1.2520100402832031e+02 7.3677200317382812e+01 1.7664199829101562e+02 1.2056999969482422e+02 7.2852699279785156e+01 1.7900000000000000e+02 1.0933300018310547e+02 7.3829399108886719e+01 1.7617100524902344e+02 1.1479000091552734e+02 7.2836097717285156e+01 1.8904901123046875e+02 1.0508499908447266e+02 7.3595703125000000e+01 1.8319099426269531e+02 1.0619799804687500e+02 7.3955200195312500e+01 1.9986399841308594e+02 1.1556299591064453e+02 7.3196502685546875e+01 1.9634599304199219e+02 1.0832199859619141e+02 7.3499595642089844e+01 1.9844700622558594e+02 1.2284600067138672e+02 7.3409400939941406e+01 1.8963600158691406e+02 1.2879000854492188e+02 7.3370704650878906e+01 1.9457499694824219e+02 1.2685400390625000e+02 7.3320899963378906e+01 1.8013000488281250e+02 1.0608399963378906e+02 7.1773094177246094e+01 1.7969400024414062e+02 1.2785700225830078e+02 7.1696495056152344e+01 1.9184100341796875e+02 1.0194499969482422e+02 8.2274101257324219e+01 1.8706999206542969e+02 1.0239800262451172e+02 7.9732902526855469e+01 1.8410900878906250e+02 1.0083699798583984e+02 8.4543197631835938e+01 1.8977500915527344e+02 9.9396400451660156e+01 8.6637901306152344e+01 1.4135299682617188e+02 1.1813300323486328e+02 2.7176599502563477e+01 1.4092900085449219e+02 1.1814399719238281e+02 3.1744598388671875e+01 1.4006399536132812e+02 1.0605799865722656e+02 3.0372400283813477e+01 1.4135099792480469e+02 1.1813300323486328e+02 3.6312801361083984e+01 1.4006399536132812e+02 1.0555500030517578e+02 3.3710201263427734e+01 1.4260501098632812e+02 1.1810299682617188e+02 4.0725498199462891e+01 1.4144801330566406e+02 1.0576499938964844e+02 4.0197902679443359e+01 1.4057398986816406e+02 1.0604599761962891e+02 3.7001399993896484e+01 1.4276300048828125e+02 1.0574800109863281e+02 4.3278297424316406e+01 1.4464799499511719e+02 1.1805299377441406e+02 4.4832599639892578e+01 1.4447200012207031e+02 1.0541799926757812e+02 4.6195400238037109e+01 1.4741101074218750e+02 1.1798600006103516e+02 4.8494300842285156e+01 1.4653599548339844e+02 1.0590100097656250e+02 4.8758399963378906e+01 1.5080000305175781e+02 1.1790399932861328e+02 5.1585700988769531e+01 1.4892399597167969e+02 1.0519100189208984e+02 5.1154201507568359e+01 1.5469900512695312e+02 1.1780899810791016e+02 5.4001598358154297e+01 1.5157099914550781e+02 1.0552700042724609e+02 5.3097499847412109e+01 1.6080400085449219e+02 1.0555400085449219e+02 5.6783798217773438e+01 1.5750299072265625e+02 1.0529100036621094e+02 5.5953102111816406e+01 1.5897500610351562e+02 1.1770500183105469e+02 5.5659801483154297e+01 1.5448600769042969e+02 1.0570800018310547e+02 5.4718200683593750e+01 1.6348298645019531e+02 1.1759600067138672e+02 5.6503696441650391e+01 1.6413299560546875e+02 1.0495600128173828e+02 5.7209400177001953e+01 1.6806900024414062e+02 1.1748400115966797e+02 5.6504699707031250e+01 1.6743400573730469e+02 1.0528299713134766e+02 5.7149398803710938e+01 1.7257800292968750e+02 1.1737500000000000e+02 5.5662700653076172e+01 1.7073799133300781e+02 1.0531300354003906e+02 5.6671199798583984e+01 1.7685499572753906e+02 1.1727099609375000e+02 5.4006401062011719e+01 1.7393200683593750e+02 1.0479100036621094e+02 5.5798900604248047e+01 1.8249499511718750e+02 1.0479199981689453e+02 5.0714702606201172e+01 1.8010400390625000e+02 1.0443000030517578e+02 5.2659500122070312e+01 1.8075401306152344e+02 1.1717599487304688e+02 5.1592201232910156e+01 1.7700700378417969e+02 1.0516099548339844e+02 5.4462898254394531e+01 1.8414401245117188e+02 1.1709400177001953e+02 4.8502201080322266e+01 1.8690901184082031e+02 1.1702700042724609e+02 4.4841800689697266e+01 1.8490800476074219e+02 1.0443199920654297e+02 4.8238098144531250e+01 1.8900700378417969e+02 1.1705899810791016e+02 4.0623798370361328e+01 1.8845899963378906e+02 1.0454399871826172e+02 4.2757598876953125e+01 1.9063499450683594e+02 1.1693599700927734e+02 3.1755298614501953e+01 1.9091099548339844e+02 1.0482299804687500e+02 3.3127502441406250e+01 1.9021000671386719e+02 1.1694599914550781e+02 3.6323303222656250e+01 1.9052000427246094e+02 1.0457199859619141e+02 3.6437702178955078e+01 1.9021199035644531e+02 1.1694599914550781e+02 2.7187200546264648e+01 1.9088900756835938e+02 1.0427300262451172e+02 2.9792999267578125e+01 1.8820098876953125e+02 1.0454999542236328e+02 2.0218700408935547e+01 1.8950300598144531e+02 1.0485699462890625e+02 2.3290599822998047e+01 1.8895800781250000e+02 1.1697699737548828e+02 2.2774400711059570e+01 1.9040100097656250e+02 1.0483500671386719e+02 2.6498600006103516e+01 1.8691499328613281e+02 1.1702600097656250e+02 1.8667299270629883e+01 1.8650199890136719e+02 1.0441199493408203e+02 1.7383699417114258e+01 1.8415200805664062e+02 1.1709400177001953e+02 1.5005599975585938e+01 1.8076300048828125e+02 1.1717599487304688e+02 1.1914199829101562e+01 1.8206500244140625e+02 1.0479799652099609e+02 1.2408100128173828e+01 1.7686399841308594e+02 1.1726999664306641e+02 9.4983596801757812e+00 1.7939199829101562e+02 1.0485099792480469e+02 1.0402400016784668e+01 1.7258801269531250e+02 1.1737400054931641e+02 7.8401603698730469e+00 1.7339801025390625e+02 1.0524799346923828e+02 7.5418300628662109e+00 1.7646501159667969e+02 1.0463999938964844e+02 8.7465000152587891e+00 1.7017098999023438e+02 1.0532700347900391e+02 6.7161297798156738e+00 1.6808000183105469e+02 1.1748400115966797e+02 6.9962100982666016e+00 1.6349400329589844e+02 1.1759500122070312e+02 6.9952001571655273e+00 1.6597099304199219e+02 1.0490599822998047e+02 6.3099899291992188e+00 1.5898500061035156e+02 1.1770500183105469e+02 7.8372302055358887e+00 1.6022700500488281e+02 1.0507199859619141e+02 6.8020200729370117e+00 1.5470799255371094e+02 1.1780899810791016e+02 9.4935302734375000e+00 1.5703100585937500e+02 1.0564599609375000e+02 7.7274398803710938e+00 1.5080900573730469e+02 1.1790399932861328e+02 1.1907799720764160e+01 1.5110600280761719e+02 1.0567499542236328e+02 1.0724400520324707e+01 1.5393499755859375e+02 1.0528299713134766e+02 9.0236701965332031e+00 1.4846701049804688e+02 1.0532599639892578e+02 1.2758799552917480e+01 1.4741900634765625e+02 1.1798600006103516e+02 1.4997700691223145e+01 1.4465400695800781e+02 1.1805299377441406e+02 1.8658201217651367e+01 1.4514100646972656e+02 1.0580399322509766e+02 1.6513399124145508e+01 1.4260899353027344e+02 1.1810299682617188e+02 2.2764400482177734e+01 1.4248300170898438e+02 1.0546299743652344e+02 2.0742500305175781e+01 1.4044200134277344e+02 1.0578800201416016e+02 2.7062299728393555e+01 1.4128700256347656e+02 1.0602799987792969e+02 2.3837299346923828e+01 1.9032199096679688e+02 1.2956500244140625e+02 3.9646099090576172e+01 1.8903700256347656e+02 1.2908099365234375e+02 4.2754798889160156e+01 1.8543400573730469e+02 1.2942799377441406e+02 4.8320499420166016e+01 1.8740400695800781e+02 1.2912100219726562e+02 4.5658599853515625e+01 1.8307901000976562e+02 1.2922599792480469e+02 5.0706600189208984e+01 1.8044799804687500e+02 1.2974899291992188e+02 5.2808799743652344e+01 1.7759500122070312e+02 1.2935900878906250e+02 5.4462898254394531e+01 1.7458100891113281e+02 1.2994799804687500e+02 5.5788101196289062e+01 1.7132499694824219e+02 1.2951199340820312e+02 5.6671199798583984e+01 1.6139199829101562e+02 1.2975299072265625e+02 5.6783798217773438e+01 1.6474800109863281e+02 1.3017900085449219e+02 5.7208900451660156e+01 1.6802600097656250e+02 1.2979200744628906e+02 5.7154201507568359e+01 1.5509300231933594e+02 1.3055799865722656e+02 5.4757900238037109e+01 1.5814300537109375e+02 1.3009400939941406e+02 5.5962699890136719e+01 1.5217100524902344e+02 1.2997700500488281e+02 5.3085300445556641e+01 1.4950599670410156e+02 1.3004200744628906e+02 5.1087299346923828e+01 1.4508599853515625e+02 1.3065699768066406e+02 4.6193901062011719e+01 1.4711601257324219e+02 1.3034799194335938e+02 4.8761798858642578e+01 1.4336300659179688e+02 1.3043299865722656e+02 4.3278297424316406e+01 1.4204800415039062e+02 1.3048200988769531e+02 4.0197998046875000e+01 1.4115499877929688e+02 1.3077500915527344e+02 3.7036602020263672e+01 1.4067900085449219e+02 1.3057800292968750e+02 3.3697696685791016e+01 1.4065200805664062e+02 1.3025698852539062e+02 3.0372400283813477e+01 1.4187500000000000e+02 1.3022700500488281e+02 2.3837299346923828e+01 1.4104301452636719e+02 1.3050801086425781e+02 2.7062398910522461e+01 1.4311000061035156e+02 1.3070799255371094e+02 2.0716300964355469e+01 1.4907600402832031e+02 1.3029399108886719e+02 1.2777600288391113e+01 1.4667601013183594e+02 1.3065100097656250e+02 1.5233499526977539e+01 1.4474900817871094e+02 1.3040800476074219e+02 1.7823200225830078e+01 1.5172700500488281e+02 1.3047100830078125e+02 1.0688400268554688e+01 1.5455599975585938e+02 1.2991900634765625e+02 9.0371398925781250e+00 1.5760398864746094e+02 1.3018499755859375e+02 7.7172498703002930e+00 1.6082600402832031e+02 1.2976699829101562e+02 6.8287796974182129e+00 1.6742500305175781e+02 1.3005900573730469e+02 6.2936496734619141e+00 1.6414999389648438e+02 1.3018600463867188e+02 6.3295998573303223e+00 1.7077499389648438e+02 1.2996800231933594e+02 6.6925301551818848e+00 1.7401599121093750e+02 1.2970800781250000e+02 7.5355801582336426e+00 1.7708000183105469e+02 1.2983700561523438e+02 8.7516899108886719e+00 1.7997999572753906e+02 1.2930099487304688e+02 1.0414699554443359e+01 1.8266200256347656e+02 1.2948399353027344e+02 1.2404300689697266e+01 1.8708999633789062e+02 1.2964999389648438e+02 1.7304201126098633e+01 1.8502700805664062e+02 1.2917900085449219e+02 1.4741499900817871e+01 1.8879899597167969e+02 1.2932899475097656e+02 2.0221700668334961e+01 1.9011500549316406e+02 1.2931500244140625e+02 2.3301799774169922e+01 1.9098899841308594e+02 1.2903399658203125e+02 2.6498600006103516e+01 1.9150500488281250e+02 1.2956599426269531e+02 2.9807899475097656e+01 1.9112100219726562e+02 1.2929100036621094e+02 3.6437599182128906e+01 1.9149899291992188e+02 1.2902101135253906e+02 3.3127502441406250e+01 1.6045999145507812e+02 1.0510700225830078e+02 5.5148000717163086e+00 1.6750698852539062e+02 1.0520800018310547e+02 3.7912700176239014e+00 1.6871200561523438e+02 1.0508399963378906e+02 5.8993896484375000e+01 1.7561799621582031e+02 1.0513700103759766e+02 5.8082801818847656e+01 1.8602499389648438e+02 1.0447700500488281e+02 1.4735300064086914e+01 1.9135400390625000e+02 1.0448600006103516e+02 2.2992700576782227e+01 1.3852200317382812e+02 1.0563199615478516e+02 3.2897800445556641e+01 1.5131900024414062e+02 1.0553400421142578e+02 8.1842508316040039e+00 1.8900500488281250e+02 1.0441400146484375e+02 4.4390102386474609e+01 1.4429199218750000e+02 1.0592199707031250e+02 1.2939199447631836e+01 1.5792399597167969e+02 1.0516300201416016e+02 5.7237400054931641e+01 1.8200799560546875e+02 1.2950700378417969e+02 9.2394905090332031e+00 1.7291101074218750e+02 1.2993499755859375e+02 6.0608401298522949e+00 1.4748500061035156e+02 1.3037799072265625e+02 1.1616499900817871e+01 1.8610200500488281e+02 1.2961199951171875e+02 1.4250899314880371e+01 1.4084700012207031e+02 1.3061199951171875e+02 2.1359800338745117e+01 1.3958099365234375e+02 1.3073800659179688e+02 3.5023101806640625e+01 1.8660299682617188e+02 1.2930200195312500e+02 5.0962299346923828e+01 1.8127700805664062e+02 1.2941500854492188e+02 5.5415100097656250e+01 1.5306199645996094e+02 1.3027900695800781e+02 7.7221398353576660e+00 1.4749899291992188e+02 1.3041499328613281e+02 5.1784400939941406e+01 1.4237600708007812e+02 1.3043400573730469e+02 4.5985301971435547e+01 1.6011599731445312e+02 1.3013299560546875e+02 5.0628199577331543e+00 1.6198800659179688e+02 1.2974398803710938e+02 5.9748703002929688e+01 1.7771301269531250e+02 1.2963600158691406e+02 5.6625000000000000e+01 1.6918200683593750e+02 1.2962600708007812e+02 5.9792499542236328e+01 1.9216899108886719e+02 1.2928399658203125e+02 2.3280000686645508e+01 1.9131300354003906e+02 1.2926300048828125e+02 4.2792800903320312e+01 1.3505400085449219e+02 1.1122599792480469e+02 2.3159799575805664e+01 1.3451499938964844e+02 1.0907199859619141e+02 2.8636199951171875e+01 1.3426899719238281e+02 1.1194100189208984e+02 2.6836599349975586e+01 1.3390800476074219e+02 1.1195000457763672e+02 3.0580999374389648e+01 1.3394898986816406e+02 1.1006499481201172e+02 3.4198200225830078e+01 1.7920399475097656e+02 1.0785300445556641e+02 5.9720596313476562e+01 1.8126499938964844e+02 1.1006800079345703e+02 5.9352600097656250e+01 1.7466099548339844e+02 1.1026699829101562e+02 6.2181201934814453e+01 1.9719299316406250e+02 1.0973600006103516e+02 3.4937400817871094e+01 1.9706300354003906e+02 1.2432099914550781e+02 3.8205703735351562e+01 1.9562600708007812e+02 1.0748300170898438e+02 3.9816398620605469e+01 1.9560499572753906e+02 1.0974600219726562e+02 4.2131401062011719e+01 1.9311399841308594e+02 1.0481999969482422e+02 3.8330600738525391e+01 1.9337800598144531e+02 1.0481999969482422e+02 2.6198400497436523e+01 1.7976300048828125e+02 1.0512900543212891e+02 7.2095398902893066e+00 1.3962399291992188e+02 1.0620999908447266e+02 1.9748401641845703e+01 1.4305599975585938e+02 1.0574299621582031e+02 4.7689502716064453e+01 1.8159899902343750e+02 1.0537400054931641e+02 5.5604698181152344e+01 1.8675000000000000e+02 1.0524799346923828e+02 5.1153800964355469e+01 1.9071101379394531e+02 1.0515200042724609e+02 4.5617099761962891e+01 1.8927400207519531e+02 1.0510499572753906e+02 1.5700999259948730e+01 1.6037200927734375e+02 1.0588899993896484e+02 3.4258401393890381e+00 1.5232899475097656e+02 1.0616999816894531e+02 5.9120702743530273e+00 1.3695199584960938e+02 1.0645400238037109e+02 2.7532600402832031e+01 1.3704000854492188e+02 1.0645599365234375e+02 3.6033199310302734e+01 1.3884199523925781e+02 1.0641200256347656e+02 4.2598999023437500e+01 1.4802200317382812e+02 1.0618499755859375e+02 5.4717800140380859e+01 1.5889599609375000e+02 1.0575900268554688e+02 5.9572200775146484e+01 1.6697599792480469e+02 1.0691100311279297e+02 6.2054897308349609e+01 1.9610400390625000e+02 1.0653299713134766e+02 3.2708599090576172e+01 1.9287399291992188e+02 1.0656599426269531e+02 1.8205499649047852e+01 1.8602000427246094e+02 1.0572200012207031e+02 1.0738399505615234e+01 1.7416499328613281e+02 1.0600999450683594e+02 3.6871399879455566e+00 1.3926200866699219e+02 1.0784199523925781e+02 4.7401302337646484e+01 1.5334098815917969e+02 1.0701999664306641e+02 5.9119899749755859e+01 1.7268598937988281e+02 1.0777100372314453e+02 6.1874401092529297e+01 1.8565000915527344e+02 1.0745600128173828e+02 5.5289997100830078e+01 1.9061599731445312e+02 1.0733499908447266e+02 4.9908298492431641e+01 1.9412800598144531e+02 1.0860700225830078e+02 4.5606597900390625e+01 1.9586199951171875e+02 1.0720700073242188e+02 2.5505699157714844e+01 1.8966700744628906e+02 1.0735800170898438e+02 1.2348400115966797e+01 1.8443598937988281e+02 1.0748499298095703e+02 7.2245001792907715e+00 1.7814900207519531e+02 1.0763800048828125e+02 3.4728000164031982e+00 1.7115600585937500e+02 1.0780799865722656e+02 1.3034299612045288e+00 1.6384999084472656e+02 1.0798500061035156e+02 8.3761900663375854e-01 1.5663899230957031e+02 1.0816100311279297e+02 2.1014800071716309e+00 1.4992601013183594e+02 1.0832399749755859e+02 5.0242500305175781e+00 1.4273100280761719e+02 1.0848699951171875e+02 1.0708700180053711e+01 1.3857200622558594e+02 1.0860499572753906e+02 1.6678501129150391e+01 1.3627200317382812e+02 1.0865499877929688e+02 2.1706499099731445e+01 1.3565798950195312e+02 1.0867000579833984e+02 3.9779598236083984e+01 1.4262100219726562e+02 1.0850099945068359e+02 5.2546600341796875e+01 1.4814599609375000e+02 1.0836700439453125e+02 5.7351600646972656e+01 1.5814700317382812e+02 1.0812400054931641e+02 6.1810699462890625e+01 1.9509400939941406e+02 1.0918000030517578e+02 2.0036899566650391e+01 1.5260299682617188e+02 1.1021500396728516e+02 6.0714000701904297e+01 1.6368800354003906e+02 1.0994499969482422e+02 6.3435398101806641e+01 1.7099600219726562e+02 1.1034799957275391e+02 6.3038700103759766e+01 1.8468600463867188e+02 1.1001899719238281e+02 5.7125301361083984e+01 1.8803199768066406e+02 1.0961599731445312e+02 5.4172000885009766e+01 1.9232400512695312e+02 1.0983100128173828e+02 4.8894599914550781e+01 1.9732699584960938e+02 1.0943399810791016e+02 3.0889600753784180e+01 1.9628800964355469e+02 1.0973600006103516e+02 2.3606399536132812e+01 1.9318200683593750e+02 1.0956300354003906e+02 1.6046699523925781e+01 1.8918399047851562e+02 1.0990999603271484e+02 1.0490500450134277e+01 1.8614498901367188e+02 1.0967399597167969e+02 7.5736598968505859e+00 1.8031098937988281e+02 1.1012500000000000e+02 3.6118600368499756e+00 1.7687500000000000e+02 1.1019599914550781e+02 2.0675101280212402e+00 1.7272200012207031e+02 1.1005099487304688e+02 8.1695199012756348e-01 1.6584100341796875e+02 1.1047699737548828e+02 1.4203599421307445e-03 1.6207598876953125e+02 1.1054699707031250e+02 1.9820499420166016e-01 1.5837399291992188e+02 1.1065299987792969e+02 8.3657300472259521e-01 1.5477799987792969e+02 1.1072699737548828e+02 1.9071099758148193e+00 1.5131999206542969e+02 1.1081700134277344e+02 3.4004998207092285e+00 1.4766299438476562e+02 1.1065000152587891e+02 5.5679702758789062e+00 1.4234700012207031e+02 1.1103399658203125e+02 1.0150300025939941e+01 1.3988000488281250e+02 1.1082900238037109e+02 1.3155500411987305e+01 1.3629800415039062e+02 1.1119200134277344e+02 1.9575799942016602e+01 1.3450500488281250e+02 1.1123000335693359e+02 3.8068500518798828e+01 1.3547000122070312e+02 1.1120800018310547e+02 4.1704200744628906e+01 1.3685398864746094e+02 1.1116200256347656e+02 4.5187500000000000e+01 1.3864900207519531e+02 1.1112400054931641e+02 4.8504901885986328e+01 1.4100999450683594e+02 1.1081299591064453e+02 5.1810302734375000e+01 1.4616799926757812e+02 1.1094900512695312e+02 5.6846099853515625e+01 1.4927500915527344e+02 1.1087100219726562e+02 5.8971900939941406e+01 1.5610900878906250e+02 1.1069300079345703e+02 6.2042499542236328e+01 1.5977000427246094e+02 1.1061100006103516e+02 6.2957397460937500e+01 1.9377499389648438e+02 1.2919400024414062e+02 3.3165500640869141e+01 1.3500000000000000e+02 1.2764799499511719e+02 2.9164199829101562e+01 1.3459399414062500e+02 1.2537999725341797e+02 2.6859498977661133e+01 1.3431900024414062e+02 1.2536199188232422e+02 3.4342502593994141e+01 1.3663600158691406e+02 1.2531000518798828e+02 1.9584199905395508e+01 1.3862599182128906e+02 1.2737899780273438e+02 1.6836000442504883e+01 1.4029598999023438e+02 1.2522200012207031e+02 1.3059999465942383e+01 1.6570500183105469e+02 1.2714299774169922e+02 6.2707401275634766e+01 1.6385899353027344e+02 1.2466799926757812e+02 6.3429103851318359e+01 1.6760299682617188e+02 1.2456400299072266e+02 6.3456401824951172e+01 1.7298300170898438e+02 1.2696600341796875e+02 6.1914100646972656e+01 1.7134100341796875e+02 1.2447500610351562e+02 6.3038600921630859e+01 1.7500599670410156e+02 1.2438300323486328e+02 6.2180500030517578e+01 1.7987098693847656e+02 1.2679900360107422e+02 5.9432903289794922e+01 1.8163600158691406e+02 1.2448299407958984e+02 5.9349399566650391e+01 1.8598399353027344e+02 1.2665000915527344e+02 5.5402698516845703e+01 1.8503199768066406e+02 1.2414699554443359e+02 5.7123798370361328e+01 1.8790499877929688e+02 1.2408300018310547e+02 5.4680599212646484e+01 1.9086299133300781e+02 1.2703900146484375e+02 4.9770198822021484e+01 1.9045401000976562e+02 1.2400800323486328e+02 5.1933502197265625e+01 1.9266700744628906e+02 1.2397100067138672e+02 4.8895500183105469e+01 1.9379200744628906e+02 1.2730200958251953e+02 4.4205101013183594e+01 1.9450999450683594e+02 1.2389700317382812e+02 4.5608497619628906e+01 1.9608599853515625e+02 1.2451600646972656e+02 4.1678997039794922e+01 1.9619900512695312e+02 1.2737999725341797e+02 3.5111400604248047e+01 1.9754699707031250e+02 1.2384100341796875e+02 3.4796901702880859e+01 1.9660099792480469e+02 1.2689900207519531e+02 2.9182399749755859e+01 1.9768400573730469e+02 1.2384500122070312e+02 3.1028799057006836e+01 1.9737899780273438e+02 1.2383999633789062e+02 2.7290800094604492e+01 1.9543200683593750e+02 1.2642100524902344e+02 2.2128601074218750e+01 1.9663200378417969e+02 1.2387400054931641e+02 2.3607000350952148e+01 1.9544999694824219e+02 1.2388099670410156e+02 2.0026899337768555e+01 1.9235000610351562e+02 1.2649600219726562e+02 1.5486100196838379e+01 1.9215100097656250e+02 1.2422899627685547e+02 1.3830100059509277e+01 1.8779400634765625e+02 1.2660600280761719e+02 9.7534093856811523e+00 1.8952600097656250e+02 1.2403699493408203e+02 1.0488900184631348e+01 1.8684100341796875e+02 1.2410800170898438e+02 7.8452200889587402e+00 1.8201899719238281e+02 1.2674699401855469e+02 5.2516999244689941e+00 1.8387500000000000e+02 1.2416699981689453e+02 5.5463299751281738e+00 1.8065499877929688e+02 1.2426100158691406e+02 3.6118600368499756e+00 1.7534899902343750e+02 1.2690900421142578e+02 2.2326700687408447e+00 1.7721598815917969e+02 1.2432400512695312e+02 2.0667898654937744e+00 1.7050700378417969e+02 1.2474600219726562e+02 3.3572298288345337e-01 1.6815699768066406e+02 1.2708300018310547e+02 8.6526602506637573e-01 1.6618199157714844e+02 1.2460400390625000e+02 1.4189201174303889e-03 1.6114799499511719e+02 1.2709100341796875e+02 1.0896899700164795e+00 1.6241999816894531e+02 1.2468299865722656e+02 1.9819100201129913e-01 1.5555000305175781e+02 1.2515999603271484e+02 1.7789599895477295e+00 1.5382200622558594e+02 1.2743200683593750e+02 3.2945301532745361e+00 1.5166099548339844e+02 1.2494499969482422e+02 3.4015200138092041e+00 1.4846701049804688e+02 1.2840400695800781e+02 6.9062700271606445e+00 1.4722700500488281e+02 1.2586000823974609e+02 6.1892299652099609e+00 1.4262100219726562e+02 1.2820599365234375e+02 1.1900099754333496e+01 1.4268800354003906e+02 1.2515899658203125e+02 1.0152500152587891e+01 1.3717601013183594e+02 1.2833898925781250e+02 2.1294599533081055e+01 1.3539599609375000e+02 1.2535299682617188e+02 2.3162401199340820e+01 1.3536000061035156e+02 1.2788000488281250e+02 3.6014400482177734e+01 1.3484799194335938e+02 1.2535500335693359e+02 3.8070297241210938e+01 1.3721899414062500e+02 1.2783500671386719e+02 4.3097702026367188e+01 1.3700399780273438e+02 1.2562100219726562e+02 4.4693298339843750e+01 1.4068899536132812e+02 1.2775099182128906e+02 4.9545898437500000e+01 1.3899398803710938e+02 1.2525199127197266e+02 4.8506900787353516e+01 1.4187599182128906e+02 1.2604199218750000e+02 5.2350902557373047e+01 1.4732099914550781e+02 1.2846200561523438e+02 5.5742801666259766e+01 1.4651300048828125e+02 1.2506500244140625e+02 5.6847301483154297e+01 1.5160700988769531e+02 1.2748600769042969e+02 5.9150100708007812e+01 1.4961900329589844e+02 1.2499699401855469e+02 5.8972499847412109e+01 1.5559298706054688e+02 1.2518100738525391e+02 6.1718898773193359e+01 1.5844400024414062e+02 1.2731899261474609e+02 6.1768600463867188e+01 1.6011599731445312e+02 1.2473799896240234e+02 6.2957897186279297e+01 1.5669299316406250e+02 1.2875399780273438e+02 3.3442399501800537e+00 1.7596499633789062e+02 1.2861900329589844e+02 5.9395801544189453e+01 1.9305899047851562e+02 1.2857299804687500e+02 2.1164199829101562e+01 1.8869200134277344e+02 1.2876499938964844e+02 1.3963299751281738e+01 1.8413800048828125e+02 1.2841999816894531e+02 8.6108398437500000e+00 1.7736000061035156e+02 1.2910899353027344e+02 5.3417100906372070e+00 1.7157901000976562e+02 1.2872500610351562e+02 2.9053699970245361e+00 1.6565400695800781e+02 1.2940699768066406e+02 3.0574200153350830e+00 1.4197698974609375e+02 1.2989999389648438e+02 1.6007799148559570e+01 1.3705299377441406e+02 1.2986401367187500e+02 2.8739500045776367e+01 1.3808599853515625e+02 1.3007600402832031e+02 3.8067001342773438e+01 1.4018499755859375e+02 1.2948800659179688e+02 4.5634799957275391e+01 1.4416900634765625e+02 1.2939100646972656e+02 5.1325099945068359e+01 1.5488700866699219e+02 1.2966799926757812e+02 5.8175399780273438e+01 1.6468699645996094e+02 1.0577700042724609e+02 4.5435298919677734e+01 1.6518499755859375e+02 1.0467299652099609e+02 4.5350299835205078e+01 1.7269200134277344e+02 1.0448999786376953e+02 4.3400802612304688e+01 1.7326000976562500e+02 1.0556900024414062e+02 4.3046501159667969e+01 1.7879701232910156e+02 1.0434199523925781e+02 3.5483901977539062e+01 1.7805999755859375e+02 1.0545200347900391e+02 3.6953300476074219e+01 1.7895700073242188e+02 1.0543099975585938e+02 2.9174600601196289e+01 1.7791200256347656e+02 1.0436399841308594e+02 2.6896100997924805e+01 1.7604400634765625e+02 1.0550100708007812e+02 2.3284700393676758e+01 1.7323399353027344e+02 1.0447700500488281e+02 2.0453401565551758e+01 1.7070298767089844e+02 1.0563100433349609e+02 1.9068799972534180e+01 1.6353300476074219e+02 1.0471299743652344e+02 1.8040899276733398e+01 1.6181799316406250e+02 1.0584700012207031e+02 1.8543500900268555e+01 1.5485499572753906e+02 1.0492400360107422e+02 2.3076299667358398e+01 1.5618998718261719e+02 1.0598400115966797e+02 2.1932899475097656e+01 1.5199699401855469e+02 1.0608599853515625e+02 2.8688499450683594e+01 1.5221499633789062e+02 1.0498799896240234e+02 3.0094598770141602e+01 1.5302499389648438e+02 1.0496799468994141e+02 3.6603900909423828e+01 1.5360000610351562e+02 1.0604699707031250e+02 3.8557899475097656e+01 1.5770399475097656e+02 1.0485400390625000e+02 4.3046501159667969e+01 1.5826599121093750e+02 1.0593300628662109e+02 4.3182998657226562e+01 1.7085800170898438e+02 1.0453499603271484e+02 2.8769298553466797e+01 1.7162600708007812e+02 1.0451599884033203e+02 3.1616199493408203e+01 1.5995500183105469e+02 1.0480000305175781e+02 2.9006299972534180e+01 1.6186100769042969e+02 1.0475300598144531e+02 2.6757400512695312e+01 1.6777700805664062e+02 1.0461000061035156e+02 3.7461200714111328e+01 1.6546900939941406e+02 1.0466600036621094e+02 3.7870498657226562e+01 1.6274499511718750e+02 1.0473200225830078e+02 3.7354900360107422e+01 1.6952600097656250e+02 1.0456700134277344e+02 2.7168600082397461e+01 1.6752700805664062e+02 1.0461600494384766e+02 2.5943899154663086e+01 1.6459399414062500e+02 1.0468699645996094e+02 2.5652200698852539e+01 1.5931199645996094e+02 1.0481500244140625e+02 3.1883798599243164e+01 1.7098300170898438e+02 1.0453200531005859e+02 3.4493698120117188e+01 1.6952600097656250e+02 1.0456700134277344e+02 3.6331298828125000e+01 1.6007901000976562e+02 1.0479699707031250e+02 3.4730598449707031e+01 1.5417599487304688e+02 1.0606400299072266e+02 3.5678302764892578e+01 1.6736300659179688e+02 1.0575500488281250e+02 2.0603500366210938e+01 1.5831700134277344e+02 1.0595899963378906e+02 2.2717199325561523e+01 1.6314601135253906e+02 1.0581500244140625e+02 4.2951900482177734e+01 1.7449699401855469e+02 1.0553900146484375e+02 3.9363399505615234e+01 1.7586199951171875e+02 1.0550600433349609e+02 2.6540300369262695e+01 1.6630999755859375e+02 1.1417300415039062e+02 3.7880100250244141e+01 1.6339201354980469e+02 1.1424399566650391e+02 3.7461200714111328e+01 1.6046600341796875e+02 1.1431500244140625e+02 3.5130401611328125e+01 1.5954299926757812e+02 1.1433800506591797e+02 3.1616199493408203e+01 1.6031100463867188e+02 1.1431900024414062e+02 2.8769298553466797e+01 1.6164300537109375e+02 1.1428699493408203e+02 2.7168600082397461e+01 1.6364199829101562e+02 1.1423799896240234e+02 2.5943899154663086e+01 1.6737699890136719e+02 1.1414700317382812e+02 2.5747800827026367e+01 1.7093400573730469e+02 1.1406099700927734e+02 2.8369499206542969e+01 1.7185899353027344e+02 1.1403799438476562e+02 3.2691501617431641e+01 1.7022000122070312e+02 1.1407800292968750e+02 3.5934200286865234e+01 1.6854399108886719e+02 1.1411900329589844e+02 3.7169399261474609e+01 1.6551800537109375e+02 1.0621499633789062e+02 4.3743801116943359e+01 1.7258700561523438e+02 1.0604300689697266e+02 4.0943202972412109e+01 1.7749198913574219e+02 1.0592400360107422e+02 3.1785398483276367e+01 1.7355799865722656e+02 1.0601899719238281e+02 2.3617700576782227e+01 1.5514799499511719e+02 1.0646600341796875e+02 2.5716999053955078e+01 1.5821600341796875e+02 1.0639200592041016e+02 4.0571498870849609e+01 1.5705700683593750e+02 1.1439199829101562e+02 2.3373498916625977e+01 1.5530900573730469e+02 1.1443500518798828e+02 2.5759599685668945e+01 1.5402799987792969e+02 1.1446599578857422e+02 2.8818498611450195e+01 1.5370700073242188e+02 1.1447399902343750e+02 3.1759300231933594e+01 1.5412600708007812e+02 1.1446399688720703e+02 3.5049201965332031e+01 1.6044200134277344e+02 1.1431100463867188e+02 2.0921598434448242e+01 1.6863000488281250e+02 1.1411199951171875e+02 2.0074300765991211e+01 1.6446200561523438e+02 1.1421199798583984e+02 1.9775899887084961e+01 1.6160101318359375e+02 1.1428400421142578e+02 4.3023399353027344e+01 1.6779200744628906e+02 1.1413399505615234e+02 4.3561500549316406e+01 1.5595201110839844e+02 1.1441899871826172e+02 3.8809799194335938e+01 1.5895399475097656e+02 1.1434600067138672e+02 4.1718898773193359e+01 1.7488099670410156e+02 1.1395999908447266e+02 2.4031599044799805e+01 1.7244599914550781e+02 1.1401799774169922e+02 2.1781000137329102e+01 1.7767100524902344e+02 1.1389199829101562e+02 3.0511299133300781e+01 1.7652499389648438e+02 1.1391899871826172e+02 2.6490600585937500e+01 1.7514500427246094e+02 1.1395200347900391e+02 3.9329498291015625e+01 1.7737199401855469e+02 1.1389900207519531e+02 3.4681400299072266e+01 1.7095401000976562e+02 1.1405500030517578e+02 4.2580699920654297e+01 1.6464399719238281e+02 1.0623600006103516e+02 1.9740798950195312e+01 1.6880198669433594e+02 1.0613500213623047e+02 2.0170000076293945e+01 1.7256300354003906e+02 1.0604300689697266e+02 2.1995800018310547e+01 1.7547200012207031e+02 1.0597299957275391e+02 2.4998199462890625e+01 1.7718000793457031e+02 1.0593099975585938e+02 2.8814901351928711e+01 1.7708300781250000e+02 1.0593300628662109e+02 3.5046699523925781e+01 1.7525799560546875e+02 1.0597799682617188e+02 3.8808403015136719e+01 1.7225599670410156e+02 1.0605099487304688e+02 4.1718799591064453e+01 1.6844099426269531e+02 1.0614299774169922e+02 4.3426902770996094e+01 1.6221099853515625e+02 1.0629499816894531e+02 4.3329998016357422e+01 1.5845001220703125e+02 1.0638600158691406e+02 4.1504100799560547e+01 1.5554000854492188e+02 1.0645700073242188e+02 3.8501697540283203e+01 1.5350100708007812e+02 1.0650599670410156e+02 3.2612701416015625e+01 1.5392999267578125e+02 1.0649600219726562e+02 2.8453199386596680e+01 1.5712899780273438e+02 1.0641799926757812e+02 2.3104999542236328e+01 1.6058999633789062e+02 1.0633399963378906e+02 2.0760099411010742e+01 1.6482800292968750e+02 1.1381100463867188e+02 4.3759201049804688e+01 1.6092799377441406e+02 1.1705700683593750e+02 3.2232898712158203e+01 1.6061900329589844e+02 1.0436800384521484e+02 3.1266998291015625e+01 1.6159098815917969e+02 1.1702399444580078e+02 2.9195501327514648e+01 1.6152099609375000e+02 1.0434299468994141e+02 2.8949100494384766e+01 1.6396499633789062e+02 1.0429300689697266e+02 2.6996700286865234e+01 1.6345599365234375e+02 1.1699599456787109e+02 2.7483999252319336e+01 1.6533599853515625e+02 1.1695499420166016e+02 2.6916900634765625e+01 1.6730700683593750e+02 1.1690799713134766e+02 2.7153799057006836e+01 1.6756098937988281e+02 1.0418300628662109e+02 2.7357200622558594e+01 1.6903599548339844e+02 1.1686499786376953e+02 2.8184499740600586e+01 1.6925700378417969e+02 1.0416300201416016e+02 2.8736499786376953e+01 1.7019699096679688e+02 1.1683399963378906e+02 2.9828699111938477e+01 1.7028500366210938e+02 1.0388500213623047e+02 3.1000499725341797e+01 1.7059800720214844e+02 1.1680200195312500e+02 3.2491298675537109e+01 1.6988800048828125e+02 1.0414099884033203e+02 3.3671199798583984e+01 1.6956500244140625e+02 1.1684300231933594e+02 3.4763401031494141e+01 1.6872799682617188e+02 1.0416600036621094e+02 3.5315498352050781e+01 1.6786999511718750e+02 1.1690499877929688e+02 3.6142799377441406e+01 1.6656399536132812e+02 1.0421299743652344e+02 3.6516700744628906e+01 1.6529400634765625e+02 1.1694899749755859e+02 3.6587799072265625e+01 1.6400300598144531e+02 1.0429000091552734e+02 3.6385200500488281e+01 1.6236700439453125e+02 1.1703099822998047e+02 3.5331497192382812e+01 1.6137200927734375e+02 1.0434999847412109e+02 3.4497600555419922e+01 1.7165499877929688e+02 1.1743099975585938e+02 3.3535900115966797e+01 1.6886000061035156e+02 1.1748299407958984e+02 3.7055599212646484e+01 1.6258500671386719e+02 1.1763800048828125e+02 3.7002700805664062e+01 1.5985200500488281e+02 1.1769300079345703e+02 3.3338100433349609e+01 1.6037799072265625e+02 1.1767900085449219e+02 2.8848199844360352e+01 1.6164199829101562e+02 1.1764000701904297e+02 2.7209400177001953e+01 1.6356300354003906e+02 1.1760400390625000e+02 2.6018699645996094e+01 1.6991900634765625e+02 1.1743099975585938e+02 2.7208099365234375e+01 1.7125900268554688e+02 1.1743000030517578e+02 2.8954500198364258e+01 1.5989799499511719e+02 1.0364399719238281e+02 3.4396800994873047e+01 1.6270700073242188e+02 1.0354699707031250e+02 3.7224502563476562e+01 1.6646798706054688e+02 1.0348399353027344e+02 3.7807201385498047e+01 1.7063400268554688e+02 1.0334899902343750e+02 3.4981300354003906e+01 1.6775399780273438e+02 1.0344800567626953e+02 2.6058500289916992e+01 1.6331700134277344e+02 1.0355400085449219e+02 2.5985099792480469e+01 1.6024499511718750e+02 1.0360099792480469e+02 2.8518600463867188e+01 1.6421600341796875e+02 1.0368000030517578e+02 3.7770801544189453e+01 1.6123100280761719e+02 1.0375199890136719e+02 3.6222301483154297e+01 1.5931900024414062e+02 1.0379900360107422e+02 3.2216098785400391e+01 1.5956401062011719e+02 1.0379299926757812e+02 2.9971199035644531e+01 1.6138101196289062e+02 1.0374900054931641e+02 2.7141201019287109e+01 1.6554499816894531e+02 1.0364800262451172e+02 2.5605899810791016e+01 1.6965701293945312e+02 1.0354799652099609e+02 2.7277599334716797e+01 1.7064698791503906e+02 1.0352400207519531e+02 2.8527500152587891e+01 1.7138000488281250e+02 1.0350599670410156e+02 3.0166000366210938e+01 1.7156399536132812e+02 1.0350099945068359e+02 3.1750001907348633e+01 1.7132400512695312e+02 1.0350699615478516e+02 3.3528701782226562e+01 1.6950700378417969e+02 1.0355100250244141e+02 3.6358798980712891e+01 1.6817199707031250e+02 1.0358399963378906e+02 3.7229602813720703e+01 1.6577200317382812e+02 1.1713299560546875e+02 2.5654699325561523e+01 1.6797299194335938e+02 1.1708000183105469e+02 2.6066299438476562e+01 1.7163200378417969e+02 1.1699099731445312e+02 3.0081899642944336e+01 1.7183900451660156e+02 1.1698600006103516e+02 3.2312400817871094e+01 1.7131500244140625e+02 1.1699900054931641e+02 3.4397899627685547e+01 1.6998500061035156e+02 1.1703199768066406e+02 3.6222301483154297e+01 1.6689099121093750e+02 1.1710599517822266e+02 3.7741500854492188e+01 1.6465100097656250e+02 1.1755799865722656e+02 3.7791599273681641e+01 1.6170899963378906e+02 1.1723300170898438e+02 3.6358798980712891e+01 1.6031800842285156e+02 1.1726699829101562e+02 3.4579299926757812e+01 1.5970399475097656e+02 1.1728099822998047e+02 3.2312400817871094e+01 1.5991101074218750e+02 1.1727600097656250e+02 3.0081899642944336e+01 1.6413200378417969e+02 1.2936900329589844e+02 1.8040899276733398e+01 1.6127400207519531e+02 1.3053099060058594e+02 1.8771799087524414e+01 1.7024099731445312e+02 1.3031298828125000e+02 1.8794401168823242e+01 1.7278900146484375e+02 1.2915899658203125e+02 1.9923898696899414e+01 1.7670799255371094e+02 1.3015599060058594e+02 2.3076299667358398e+01 1.7760499572753906e+02 1.2904199218750000e+02 2.4548898696899414e+01 1.7979598999023438e+02 1.3008099365234375e+02 3.1426097869873047e+01 1.7982899475097656e+02 1.2898799133300781e+02 3.3238601684570312e+01 1.7791099548339844e+02 1.3012699890136719e+02 3.8146999359130859e+01 1.7587899780273438e+02 1.2908299255371094e+02 4.1170101165771484e+01 1.7281500244140625e+02 1.3025000000000000e+02 4.3576000213623047e+01 1.6911700439453125e+02 1.2924798583984375e+02 4.5115501403808594e+01 1.6415899658203125e+02 1.3046101379394531e+02 4.5459098815917969e+01 1.6048699951171875e+02 1.2945799255371094e+02 4.4208999633789062e+01 1.5548100280761719e+02 1.3067199707031250e+02 4.0423599243164062e+01 1.5386399841308594e+02 1.2961801147460938e+02 3.7988101959228516e+01 1.5239300537109375e+02 1.3074700927734375e+02 3.2073898315429688e+01 1.5254100036621094e+02 1.2965100097656250e+02 3.0343898773193359e+01 1.5427699279785156e+02 1.3070100402832031e+02 2.5352998733520508e+01 1.5545399475097656e+02 1.2958000183105469e+02 2.3076299667358398e+01 1.6070500183105469e+02 1.3054499816894531e+02 2.8769399642944336e+01 1.5993699645996094e+02 1.3056300354003906e+02 3.1616199493408203e+01 1.6058000183105469e+02 1.3054800415039062e+02 3.4493598937988281e+01 1.6203700256347656e+02 1.3051199340820312e+02 3.6331298828125000e+01 1.6378599548339844e+02 1.3046998596191406e+02 3.7461200714111328e+01 1.6270700073242188e+02 1.3049600219726562e+02 2.6605400085449219e+01 1.6548500061035156e+02 1.3042900085449219e+02 2.5619899749755859e+01 1.6970199584960938e+02 1.3032600402832031e+02 2.6757299423217773e+01 1.6755899047851562e+02 1.3037799072265625e+02 2.5807300567626953e+01 1.7198500061035156e+02 1.3027099609375000e+02 2.9720699310302734e+01 1.7148399353027344e+02 1.3028300476074219e+02 3.4730598449707031e+01 1.7216799926757812e+02 1.3026599121093750e+02 3.2487796783447266e+01 1.6670399475097656e+02 1.3039900207519531e+02 3.7880100250244141e+01 1.6948199462890625e+02 1.3033200073242188e+02 3.6894599914550781e+01 1.5478601074218750e+02 1.2955500793457031e+02 3.0012899398803711e+01 1.5941500854492188e+02 1.2942999267578125e+02 2.2592699050903320e+01 1.6883898925781250e+02 1.2925498962402344e+02 2.0480501174926758e+01 1.7647200012207031e+02 1.2901799011230469e+02 2.7301300048828125e+01 1.6332499694824219e+02 1.2938800048828125e+02 4.2862197875976562e+01 1.7691198730468750e+02 1.2905799865722656e+02 3.4968700408935547e+01 1.7211698913574219e+02 1.2917500305175781e+02 4.1310501098632812e+01 1.6647200012207031e+02 1.2087699890136719e+02 2.5619899749755859e+01 1.6355499267578125e+02 1.2094799804687500e+02 2.6038799285888672e+01 1.6180500793457031e+02 1.2098999786376953e+02 2.7168600082397461e+01 1.6034899902343750e+02 1.2102600097656250e+02 2.9006299972534180e+01 1.5970599365234375e+02 1.2104100036621094e+02 3.1883798599243164e+01 1.6047300720214844e+02 1.2102300262451172e+02 3.4730598449707031e+01 1.6313900756835938e+02 1.2095800018310547e+02 3.7354900360107422e+01 1.6673800659179688e+02 1.2087000274658203e+02 3.7847797393798828e+01 1.6947099304199219e+02 1.2080399322509766e+02 3.6742603302001953e+01 1.7137699890136719e+02 1.2075799560546875e+02 3.4493698120117188e+01 1.7193699645996094e+02 1.2074399566650391e+02 3.2487796783447266e+01 1.7180900573730469e+02 1.2074700164794922e+02 3.0146200180053711e+01 1.6984899902343750e+02 1.2079499816894531e+02 2.6960000991821289e+01 1.6945700073242188e+02 1.2878199768066406e+02 2.0654300689697266e+01 1.7722099304199219e+02 1.2859399414062500e+02 3.6163299560546875e+01 1.6813600158691406e+02 1.2881399536132812e+02 4.3559997558593750e+01 1.6199800109863281e+02 1.2896400451660156e+02 4.3030998229980469e+01 1.5569900512695312e+02 1.2911700439453125e+02 3.7783000946044922e+01 1.6377099609375000e+02 1.2094499969482422e+02 4.3561500549316406e+01 1.6060900878906250e+02 1.2102399444580078e+02 4.2580699920654297e+01 1.7450599670410156e+02 1.2068700408935547e+02 2.3373498916625977e+01 1.7625399780273438e+02 1.2064400482177734e+02 2.5759599685668945e+01 1.7753500366210938e+02 1.2061399841308594e+02 2.8818498611450195e+01 1.6293301391601562e+02 1.2096800231933594e+02 2.0074300765991211e+01 1.6710198974609375e+02 1.2086699676513672e+02 1.9775899887084961e+01 1.5722300720214844e+02 1.2110599517822266e+02 4.0130203247070312e+01 1.5419100952148438e+02 1.2118099975585938e+02 3.4681400299072266e+01 1.7785600280761719e+02 1.2060499572753906e+02 3.1759199142456055e+01 1.7714700317382812e+02 1.2062300109863281e+02 3.6143398284912109e+01 1.7112100219726562e+02 1.2076900482177734e+02 2.0921598434448242e+01 1.7077699279785156e+02 1.2077600097656250e+02 4.2738502502441406e+01 1.5748899841308594e+02 1.2109999847412109e+02 2.3104301452636719e+01 1.5987500000000000e+02 1.2104399871826172e+02 2.1355998992919922e+01 1.7423699951171875e+02 1.2069300079345703e+02 4.0395698547363281e+01 1.5386999511718750e+02 1.2118800354003906e+02 3.1740699768066406e+01 1.5428900146484375e+02 1.2117800140380859e+02 2.8450698852539062e+01 1.5548199462890625e+02 1.2115000152587891e+02 2.5743700027465820e+01 1.7131201171875000e+02 1.2873699951171875e+02 4.2581600189208984e+01 1.7376699829101562e+02 1.2867799377441406e+02 4.0941699981689453e+01 1.7602301025390625e+02 1.2862300109863281e+02 3.8501697540283203e+01 1.7806201171875000e+02 1.2857299804687500e+02 3.2612701416015625e+01 1.7763299560546875e+02 1.2858399963378906e+02 2.8453199386596680e+01 1.7580799865722656e+02 1.2862800598144531e+02 2.4691499710083008e+01 1.7280699157714844e+02 1.2870100402832031e+02 2.1781099319458008e+01 1.6899099731445312e+02 1.2879400634765625e+02 2.0073101043701172e+01 1.6482099914550781e+02 1.2889500427246094e+02 1.9773399353027344e+01 1.6080099487304688e+02 1.2899200439453125e+02 2.0918399810791016e+01 1.5741400146484375e+02 1.2907501220703125e+02 2.3369699478149414e+01 1.5507000732421875e+02 1.2913200378417969e+02 2.6831901550292969e+01 1.5405101013183594e+02 1.2915701293945312e+02 3.0887199401855469e+01 1.5447999572753906e+02 1.2914599609375000e+02 3.5046699523925781e+01 1.5767900085449219e+02 1.2906800842285156e+02 4.0395000457763672e+01 1.6005900573730469e+02 1.2901100158691406e+02 4.2141399383544922e+01 1.6519400024414062e+02 1.2888600158691406e+02 4.3759201049804688e+01 1.5548400878906250e+02 1.2154299926757812e+02 3.7749500274658203e+01 1.6673500061035156e+02 1.2126799774169922e+02 4.3759201049804688e+01 1.6127799987792969e+02 1.3119400024414062e+02 3.1000499725341797e+01 1.6095599365234375e+02 1.1825799560546875e+02 3.2220901489257812e+01 1.6136599731445312e+02 1.1824599456787109e+02 2.9828699111938477e+01 1.6230599975585938e+02 1.3091699218750000e+02 2.8736499786376953e+01 1.6252699279785156e+02 1.1821500396728516e+02 2.8184499740600586e+01 1.6400199890136719e+02 1.3089700317382812e+02 2.7357200622558594e+01 1.6425601196289062e+02 1.1817099761962891e+02 2.7153799057006836e+01 1.6707800292968750e+02 1.3080101013183594e+02 2.6934501647949219e+01 1.6629699707031250e+02 1.1813099670410156e+02 2.6915800094604492e+01 1.6833000183105469e+02 1.1807599639892578e+02 2.7632198333740234e+01 1.6937300109863281e+02 1.3075500488281250e+02 2.8184499740600586e+01 1.7031399536132812e+02 1.1801700592041016e+02 2.9824800491333008e+01 1.7053399658203125e+02 1.3072399902343750e+02 2.9828699111938477e+01 1.7095098876953125e+02 1.3095700073242188e+02 3.2236598968505859e+01 1.7055400085449219e+02 1.1804299926757812e+02 3.2892700195312500e+01 1.6940100097656250e+02 1.3072900390625000e+02 3.5461601257324219e+01 1.6906500244140625e+02 1.1805599975585938e+02 3.5315498352050781e+01 1.6676998901367188e+02 1.1812000274658203e+02 3.6565502166748047e+01 1.6547801208496094e+02 1.3085900878906250e+02 3.6669002532958984e+01 1.6369299316406250e+02 1.1817500305175781e+02 3.6142799377441406e+01 1.6283599853515625e+02 1.3091300964355469e+02 3.5315498352050781e+01 1.6197399902343750e+02 1.1824099731445312e+02 3.4738300323486328e+01 1.6167500305175781e+02 1.3093901062011719e+02 3.3671401977539062e+01 1.6338999938964844e+02 1.3166500854492188e+02 2.6275501251220703e+01 1.6715000915527344e+02 1.3154501342773438e+02 2.5692800521850586e+01 1.7157499694824219e+02 1.3146099853515625e+02 2.8920299530029297e+01 1.6944299316406250e+02 1.3150199890136719e+02 3.6918800354003906e+01 1.6509500122070312e+02 1.3159500122070312e+02 3.7807201385498047e+01 1.6128399658203125e+02 1.3168499755859375e+02 3.5534698486328125e+01 1.6489100646972656e+02 1.3145899963378906e+02 2.5729099273681641e+01 1.6190600585937500e+02 1.3153199768066406e+02 2.7277700424194336e+01 1.6057600402832031e+02 1.3156401062011719e+02 2.9101900100708008e+01 1.5999400329589844e+02 1.3157800292968750e+02 3.1284000396728516e+01 1.6023899841308594e+02 1.3157199096679688e+02 3.3528701782226562e+01 1.6297200012207031e+02 1.3150599670410156e+02 3.7027099609375000e+01 1.6734700012207031e+02 1.3140000915527344e+02 3.7770801544189453e+01 1.7108200073242188e+02 1.3130900573730469e+02 3.5371799468994141e+01 1.7205398559570312e+02 1.3128500366210938e+02 3.3333900451660156e+01 1.7222599792480469e+02 1.3128100585937500e+02 3.1082199096679688e+01 1.7018200683593750e+02 1.3133099365234375e+02 2.7141201019287109e+01 1.6884700012207031e+02 1.3136300659179688e+02 2.6270299911499023e+01 1.6082899475097656e+02 1.1806599426269531e+02 3.5371799468994141e+01 1.6691101074218750e+02 1.1791899871826172e+02 3.7741500854492188e+01 1.7063200378417969e+02 1.1782799530029297e+02 3.5533397674560547e+01 1.7185899353027344e+02 1.1779899597167969e+02 3.1187599182128906e+01 1.6810501098632812e+02 1.1788899993896484e+02 2.6057399749755859e+01 1.6579100036621094e+02 1.1794599914550781e+02 2.5654699325561523e+01 1.5972399902343750e+02 1.1809300231933594e+02 3.1187599182128906e+01 1.5684199523925781e+02 1.2942401123046875e+02 1.5228899955749512e+01 1.6225000000000000e+02 1.2928800964355469e+02 1.0581900596618652e+01 1.6633599853515625e+02 1.2919400024414062e+02 1.2830699920654297e+01 1.7403799438476562e+02 1.2900100708007812e+02 1.1943999290466309e+01 1.7418199157714844e+02 1.2899899291992188e+02 1.4779900550842285e+01 1.7949501037597656e+02 1.2886999511718750e+02 1.8580499649047852e+01 1.8099099731445312e+02 1.2883200073242188e+02 1.6644599914550781e+01 1.8318800354003906e+02 1.2878100585937500e+02 2.3969499588012695e+01 1.8586799621582031e+02 1.2871398925781250e+02 2.3781801223754883e+01 1.8481600952148438e+02 1.2874099731445312e+02 3.0297000885009766e+01 1.5934098815917969e+02 1.2936300659179688e+02 4.9436302185058594e+01 1.5797900390625000e+02 1.2939100646972656e+02 5.1680698394775391e+01 1.5263398742675781e+02 1.2952299499511719e+02 4.4919403076171875e+01 1.4763101196289062e+02 1.2964299011230469e+02 4.2824600219726562e+01 1.4894198608398438e+02 1.2961299133300781e+02 3.9530399322509766e+01 1.4731399536132812e+02 1.2965199279785156e+02 3.3202899932861328e+01 1.4487800598144531e+02 1.2971000671386719e+02 3.3155399322509766e+01 1.4794799804687500e+02 1.2963700866699219e+02 2.6700399398803711e+01 1.4552400207519531e+02 1.2969400024414062e+02 2.6371999740600586e+01 1.5076699829101562e+02 1.2956799316406250e+02 2.0806699752807617e+01 1.5030198669433594e+02 1.2957798767089844e+02 1.7119899749755859e+01 1.8729600524902344e+02 1.2867900085449219e+02 3.2054397583007812e+01 1.8374499511718750e+02 1.2877101135253906e+02 3.8475700378417969e+01 1.8487001037597656e+02 1.2873800659179688e+02 4.2181598663330078e+01 1.7923001098632812e+02 1.2887699890136719e+02 4.5184398651123047e+01 1.7787500000000000e+02 1.2890798950195312e+02 4.9400699615478516e+01 1.7384300231933594e+02 1.2900799560546875e+02 4.8878299713134766e+01 1.6990800476074219e+02 1.2910200500488281e+02 5.2752300262451172e+01 1.6751701354980469e+02 1.2916099548339844e+02 5.0506301879882812e+01 1.4611299133300781e+02 1.3049299621582031e+02 2.3776700973510742e+01 1.4494700622558594e+02 1.3052099609375000e+02 3.3762298583984375e+01 1.4667199707031250e+02 1.3047898864746094e+02 4.0354198455810547e+01 1.5161399841308594e+02 1.3035899353027344e+02 4.7446002960205078e+01 1.5883999633789062e+02 1.3018399047851562e+02 5.1714900970458984e+01 1.6553401184082031e+02 1.3002101135253906e+02 5.2982097625732422e+01 1.7405700683593750e+02 1.2981399536132812e+02 5.1555900573730469e+01 1.8234600830078125e+02 1.2961199951171875e+02 4.5580902099609375e+01 1.8738299560546875e+02 1.2949000549316406e+02 3.4710800170898438e+01 1.8554699707031250e+02 1.2953500366210938e+02 2.2983501434326172e+01 1.8057200622558594e+02 1.2965499877929688e+02 1.6222799301147461e+01 1.7491101074218750e+02 1.2979299926757812e+02 1.2432799339294434e+01 1.6650999450683594e+02 1.2999699401855469e+02 1.0402799606323242e+01 1.5490699768066406e+02 1.3027900695800781e+02 1.3374700546264648e+01 1.5255799865722656e+02 1.3175900268554688e+02 2.8115301132202148e+01 1.5561999511718750e+02 1.3168600463867188e+02 2.1973899841308594e+01 1.6320300292968750e+02 1.3150100708007812e+02 1.7826000213623047e+01 1.7055299377441406e+02 1.3132199096679688e+02 1.8232900619506836e+01 1.7756700134277344e+02 1.3115200805664062e+02 2.3105199813842773e+01 1.8033399963378906e+02 1.3108499145507812e+02 3.1294900894165039e+01 1.7884300231933594e+02 1.3111999511718750e+02 3.7684997558593750e+01 1.7476100158691406e+02 1.3122099304199219e+02 4.3201099395751953e+01 1.6657400512695312e+02 1.3141900634765625e+02 4.5968902587890625e+01 1.5940600585937500e+02 1.3159300231933594e+02 4.4291500091552734e+01 1.5473100280761719e+02 1.3170599365234375e+02 4.0127300262451172e+01 1.5219900512695312e+02 1.3176800537109375e+02 3.4667201995849609e+01 1.5796699523925781e+02 1.3020600891113281e+02 1.4779600143432617e+01 1.5142199707031250e+02 1.3036898803710938e+02 1.9796699523925781e+01 1.4787100219726562e+02 1.3045201110839844e+02 2.7062200546264648e+01 1.4736599731445312e+02 1.3046400451660156e+02 3.3576202392578125e+01 1.4912001037597656e+02 1.3042100524902344e+02 3.9869899749755859e+01 1.5291899108886719e+02 1.3032899475097656e+02 4.5184097290039062e+01 1.5986999511718750e+02 1.3016299438476562e+02 4.9622100830078125e+01 1.8483599853515625e+02 1.2955300903320312e+02 3.3202899932861328e+01 1.8420100402832031e+02 1.2956900024414062e+02 2.6700201034545898e+01 1.8138200378417969e+02 1.2963700866699219e+02 2.0806598663330078e+01 1.7671800231933594e+02 1.2975099182128906e+02 1.6233001708984375e+01 1.7077099609375000e+02 1.2989500427246094e+02 1.3530799865722656e+01 1.6425900268554688e+02 1.3005400085449219e+02 1.3026299476623535e+01 1.6790998840332031e+02 1.2996501159667969e+02 5.0473701477050781e+01 1.7420199584960938e+02 1.2981199645996094e+02 4.8719997406005859e+01 1.7951499938964844e+02 1.2968299865722656e+02 4.4919498443603516e+01 1.8320800781250000e+02 1.2959300231933594e+02 3.9530300140380859e+01 1.6552500915527344e+02 1.3144400024414062e+02 2.7561700820922852e+01 1.6959098815917969e+02 1.3134500122070312e+02 3.0404298782348633e+01 1.6245800781250000e+02 1.3151800537109375e+02 3.1065500259399414e+01 1.6683999633789062e+02 1.3141200256347656e+02 3.6440998077392578e+01 1.5221899414062500e+02 1.3258099365234375e+02 2.8832700729370117e+01 1.5475100708007812e+02 1.3251901245117188e+02 2.3372699737548828e+01 1.5942500305175781e+02 1.3240599060058594e+02 1.9208398818969727e+01 1.6659399414062500e+02 1.3223199462890625e+02 1.7531000137329102e+01 1.7478099060058594e+02 1.3203300476074219e+02 2.0298799514770508e+01 1.7886300659179688e+02 1.3193299865722656e+02 2.5815000534057617e+01 1.8035400390625000e+02 1.3189700317382812e+02 3.2205001831054688e+01 1.7758599853515625e+02 1.3196499633789062e+02 4.0394802093505859e+01 1.7057299804687500e+02 1.3213500976562500e+02 4.5267002105712891e+01 1.6322200012207031e+02 1.3231300354003906e+02 4.5673900604248047e+01 1.5563999938964844e+02 1.3249800109863281e+02 4.1526000976562500e+01 1.5257800292968750e+02 1.3257199096679688e+02 3.5384700775146484e+01 1.6387500000000000e+02 1.3229699707031250e+02 3.5701900482177734e+01 1.6351200866699219e+02 1.3230599975585938e+02 2.7797500610351562e+01 1.6961100769042969e+02 1.3215798950195312e+02 3.0404298782348633e+01 1.6908999633789062e+02 1.3217001342773438e+02 3.4441200256347656e+01 1.7613198852539062e+02 1.0562500000000000e+02 1.6232500076293945e+01 1.7581900024414062e+02 1.0563399505615234e+02 1.2879700660705566e+01 1.7018499755859375e+02 1.0576899719238281e+02 1.3530699729919434e+01 1.6241600036621094e+02 1.0595999908447266e+02 1.0462800025939941e+01 1.6367300415039062e+02 1.0592699432373047e+02 1.3026200294494629e+01 1.5738099670410156e+02 1.0608000183105469e+02 1.4779900550842285e+01 1.5166600036621094e+02 1.0622100067138672e+02 1.5488900184631348e+01 1.5206800842285156e+02 1.0620899963378906e+02 1.8580600738525391e+01 1.4837500000000000e+02 1.0629899597167969e+02 2.3969499588012695e+01 1.4655799865722656e+02 1.0634500122070312e+02 2.2150098800659180e+01 1.4674699401855469e+02 1.0633899688720703e+02 3.0296899795532227e+01 1.4449400329589844e+02 1.0639499664306641e+02 2.8643800735473633e+01 1.7361601257324219e+02 1.0568600463867188e+02 4.8720401763916016e+01 1.8059399414062500e+02 1.0551799774169922e+02 4.6844898223876953e+01 1.7892900085449219e+02 1.0555699920654297e+02 4.4919403076171875e+01 1.8262199401855469e+02 1.0546700286865234e+02 3.9530399322509766e+01 1.8514999389648438e+02 1.0540699768066406e+02 3.9794097900390625e+01 1.8424899291992188e+02 1.0542800140380859e+02 3.3202999114990234e+01 1.8683900451660156e+02 1.0536599731445312e+02 3.1316101074218750e+01 1.8361500549316406e+02 1.0544300079345703e+02 2.6700298309326172e+01 1.8419299316406250e+02 1.0543000030517578e+02 2.1445301055908203e+01 1.8079598999023438e+02 1.0551100158691406e+02 2.0806699752807617e+01 1.4488198852539062e+02 1.0638500213623047e+02 3.7279899597167969e+01 1.4781799316406250e+02 1.0630899810791016e+02 3.8475597381591797e+01 1.4870800781250000e+02 1.0629299926757812e+02 4.4751300811767578e+01 1.5354899597167969e+02 1.0616899871826172e+02 4.6417198181152344e+01 1.5672999572753906e+02 1.0609800720214844e+02 5.1389701843261719e+01 1.6081201171875000e+02 1.0599700164794922e+02 4.9969100952148438e+01 1.6732400512695312e+02 1.0583899688720703e+02 5.0473701477050781e+01 1.7028300476074219e+02 1.0576800537109375e+02 5.2720100402832031e+01 1.8666499328613281e+02 1.0455699920654297e+02 3.0344499588012695e+01 1.8602000427246094e+02 1.0457299804687500e+02 3.7128002166748047e+01 1.8325999450683594e+02 1.0463999938964844e+02 4.3357799530029297e+01 1.7579899597167969e+02 1.0482099914550781e+02 5.0620197296142578e+01 1.6239599609375000e+02 1.0514699554443359e+02 5.3037200927734375e+01 1.5316799926757812e+02 1.0537100219726562e+02 4.9054897308349609e+01 1.4721000671386719e+02 1.0551599884033203e+02 4.2792499542236328e+01 1.4417199707031250e+02 1.0559000396728516e+02 3.3035198211669922e+01 1.4543699645996094e+02 1.0555899810791016e+02 2.4736000061035156e+01 1.4868899536132812e+02 1.0548000335693359e+02 1.8748600006103516e+01 1.5366900634765625e+02 1.0535900115966797e+02 1.4099200248718262e+01 1.6163499450683594e+02 1.0516500091552734e+02 1.0747600555419922e+01 1.7002398681640625e+02 1.0496199798583984e+02 1.1002999305725098e+01 1.7795799255371094e+02 1.0476899719238281e+02 1.4428199768066406e+01 1.8457600402832031e+02 1.0460800170898438e+02 2.2213699340820312e+01 1.7952198791503906e+02 1.0330799865722656e+02 2.9729000091552734e+01 1.7720899963378906e+02 1.0336399841308594e+02 2.3910499572753906e+01 1.7294499206542969e+02 1.0346700286865234e+02 1.9663398742675781e+01 1.6589898681640625e+02 1.0363800048828125e+02 1.7531000137329102e+01 1.5764201354980469e+02 1.0383900451660156e+02 1.9710000991821289e+01 1.5277500915527344e+02 1.0395800018310547e+02 2.5478199005126953e+01 1.5122898864746094e+02 1.0399500274658203e+02 3.1294799804687500e+01 1.5272000122070312e+02 1.0395899963378906e+02 3.7684997558593750e+01 1.5680200195312500e+02 1.0385900115966797e+02 4.3201099395751953e+01 1.6498899841308594e+02 1.0366100311279297e+02 4.5968902587890625e+01 1.7215699768066406e+02 1.0348699951171875e+02 4.4291599273681641e+01 1.7821900939941406e+02 1.0333900451660156e+02 3.8275001525878906e+01 1.4689799499511719e+02 1.0551899719238281e+02 2.8197401046752930e+01 1.5018099975585938e+02 1.0544200134277344e+02 2.0806699752807617e+01 1.5484500122070312e+02 1.0532900238037109e+02 1.6232900619506836e+01 1.6079199218750000e+02 1.0518400573730469e+02 1.3530799865722656e+01 1.6730400085449219e+02 1.0502600097656250e+02 1.3026299476623535e+01 1.7359599304199219e+02 1.0487400054931641e+02 1.4779600143432617e+01 1.7325698852539062e+02 1.0488200378417969e+02 4.8878700256347656e+01 1.6693099975585938e+02 1.0503499603271484e+02 5.0506500244140625e+01 1.6042999267578125e+02 1.0519299316406250e+02 4.9872200012207031e+01 1.5453800964355469e+02 1.0533600616455078e+02 4.7052200317382812e+01 1.4996600341796875e+02 1.0544699859619141e+02 4.2386402130126953e+01 1.4726499938964844e+02 1.0551300048828125e+02 3.6437900543212891e+01 1.8014199829101562e+02 1.0470999908447266e+02 1.9796699523925781e+01 1.8369198608398438e+02 1.0462799835205078e+02 2.7062099456787109e+01 1.8419699096679688e+02 1.0461600494384766e+02 3.3576099395751953e+01 1.8244299316406250e+02 1.0465799713134766e+02 3.9869800567626953e+01 1.7864399719238281e+02 1.0475099945068359e+02 4.5184200286865234e+01 1.6687100219726562e+02 1.0361499786376953e+02 2.7612300872802734e+01 1.6197200012207031e+02 1.0373400115966797e+02 3.0404298782348633e+01 1.6394500732421875e+02 1.0368700408935547e+02 3.6050701141357422e+01 1.6910499572753906e+02 1.0356099700927734e+02 3.2434501647949219e+01 1.7934399414062500e+02 1.0249900054931641e+02 2.8832700729370117e+01 1.7681199645996094e+02 1.0256099700927734e+02 2.3372699737548828e+01 1.7213800048828125e+02 1.0267400360107422e+02 1.9208398818969727e+01 1.6496899414062500e+02 1.0284799957275391e+02 1.7531000137329102e+01 1.5678199768066406e+02 1.0304599761962891e+02 2.0298799514770508e+01 1.5270001220703125e+02 1.0314700317382812e+02 2.5815000534057617e+01 1.5120999145507812e+02 1.0318199920654297e+02 3.2205101013183594e+01 1.5275500488281250e+02 1.0314500427246094e+02 3.8021900177001953e+01 1.5762298583984375e+02 1.0302600097656250e+02 4.3790000915527344e+01 1.6587899780273438e+02 1.0282599639892578e+02 4.5968902587890625e+01 1.7292599487304688e+02 1.0265499877929688e+02 4.3836502075195312e+01 1.7863301086425781e+02 1.0251499938964844e+02 3.7344600677490234e+01 1.6908499145507812e+02 1.0274900054931641e+02 3.2434501647949219e+01 1.6638900756835938e+02 1.0281399536132812e+02 2.7480699539184570e+01 1.6195201110839844e+02 1.0292199707031250e+02 3.0404298782348633e+01 1.6443499755859375e+02 1.0286199951171875e+02 3.6195800781250000e+01 1.6405400085449219e+02 1.2913999938964844e+02 2.0020698547363281e+01 1.6350000000000000e+02 1.0641600036621094e+02 2.0021301269531250e+01 1.6550099182128906e+02 1.0598800659179688e+02 1.9850099563598633e+01 1.6807398986816406e+02 1.2904399108886719e+02 2.0021301269531250e+01 1.6752099609375000e+02 1.0631799316406250e+02 2.0021301269531250e+01 1.6947300720214844e+02 1.0627099609375000e+02 2.0529798507690430e+01 1.7130200195312500e+02 1.0584700012207031e+02 2.1361000061035156e+01 1.7183500671386719e+02 1.2895100402832031e+02 2.1341600418090820e+01 1.7298500061035156e+02 1.0603500366210938e+02 2.2495100021362305e+01 1.7498300170898438e+02 1.2849499511718750e+02 2.3887998580932617e+01 1.7563099670410156e+02 1.0574100494384766e+02 2.5510499954223633e+01 1.7618800354003906e+02 1.2861900329589844e+02 2.5513299942016602e+01 1.7655900573730469e+02 1.0594400024414062e+02 2.7340700149536133e+01 1.7794700622558594e+02 1.2847599792480469e+02 3.1514297485351562e+01 1.7769200134277344e+02 1.2880900573730469e+02 2.9243000030517578e+01 1.7739099121093750e+02 1.0586500549316406e+02 3.1245800018310547e+01 1.7731199645996094e+02 1.0570000457763672e+02 3.3198596954345703e+01 1.7742800903320312e+02 1.2843600463867188e+02 3.5234500885009766e+01 1.7688499450683594e+02 1.0609100341796875e+02 3.5234500885009766e+01 1.7613301086425781e+02 1.0610900115966797e+02 3.7107299804687500e+01 1.7668501281738281e+02 1.2883399963378906e+02 3.7107097625732422e+01 1.7561698913574219e+02 1.2863301086425781e+02 3.8830802917480469e+01 1.7398999023437500e+02 1.0578499603271484e+02 4.0054401397705078e+01 1.7272399902343750e+02 1.2893000793457031e+02 4.1609298706054688e+01 1.7035398864746094e+02 1.0587400054931641e+02 4.2613399505615234e+01 1.7095300292968750e+02 1.2859399414062500e+02 4.2593502044677734e+01 1.6707099914550781e+02 1.2906700134277344e+02 4.3606998443603516e+01 1.6115299987792969e+02 1.2883200073242188e+02 4.2593502044677734e+01 1.6449198913574219e+02 1.0601300048828125e+02 4.3606998443603516e+01 1.6065399169921875e+02 1.0610599517822266e+02 4.2613903045654297e+01 1.5884800720214844e+02 1.0652899932861328e+02 4.1609203338623047e+01 1.5940100097656250e+02 1.2925498962402344e+02 4.1609298706054688e+01 1.5782199096679688e+02 1.2905900573730469e+02 4.0337902069091797e+01 1.5727900695800781e+02 1.0656700134277344e+02 4.0341197967529297e+01 1.5648800659179688e+02 1.2894499206542969e+02 3.8826000213623047e+01 1.5487800598144531e+02 1.0624500274658203e+02 3.7107200622558594e+01 1.5544000244140625e+02 1.2935000610351562e+02 3.7107299804687500e+01 1.5467800903320312e+02 1.2898899841308594e+02 3.5234500885009766e+01 1.5413500976562500e+02 1.0664299774169922e+02 3.5234500885009766e+01 1.5425300598144531e+02 1.2899899291992188e+02 3.3261501312255859e+01 1.5417700195312500e+02 1.2938000488281250e+02 3.1244400024414062e+01 1.5388099670410156e+02 1.0665000152587891e+02 2.9242898941040039e+01 1.5447200012207031e+02 1.0663499450683594e+02 2.7312999725341797e+01 1.5587901306152344e+02 1.2933699035644531e+02 2.5601800918579102e+01 1.5537500000000000e+02 1.0646200561523438e+02 2.5513200759887695e+01 1.5657000732421875e+02 1.0620400238037109e+02 2.3888399124145508e+01 1.5857798767089844e+02 1.2904701232910156e+02 2.2494998931884766e+01 1.5803700256347656e+02 1.0654900360107422e+02 2.2491399765014648e+01 1.5970799255371094e+02 1.0650800323486328e+02 2.1361200332641602e+01 1.6154701232910156e+02 1.0646299743652344e+02 2.0529798507690430e+01 1.6208999633789062e+02 1.2880900573730469e+02 2.0529798507690430e+01 1.6724600219726562e+02 1.2906298828125000e+02 4.7164001464843750e+01 1.5917199707031250e+02 1.2925698852539062e+02 4.5612899780273438e+01 1.5065098571777344e+02 1.2946400451660156e+02 3.0180299758911133e+01 1.5533999633789062e+02 1.2935299682617188e+02 2.0612199783325195e+01 1.7774499511718750e+02 1.2880599975585938e+02 2.1549999237060547e+01 1.6724600219726562e+02 1.2906199645996094e+02 1.6303300857543945e+01 1.8141398620605469e+02 1.2871800231933594e+02 3.3582798004150391e+01 1.7847799682617188e+02 1.2879000854492188e+02 4.1013000488281250e+01 1.5241799926757812e+02 1.2942300415039062e+02 3.9069801330566406e+01 1.7963999938964844e+02 1.2876200866699219e+02 2.4365900039672852e+01 1.6901600646972656e+02 1.0590299987792969e+02 4.6805000305175781e+01 1.7627899169921875e+02 1.0572600555419922e+02 4.2931499481201172e+01 1.5930999755859375e+02 1.0613999938964844e+02 1.7551500320434570e+01 1.6431700134277344e+02 1.0601699829101562e+02 1.6304100036621094e+01 1.8097000122070312e+02 1.0561299896240234e+02 3.1438201904296875e+01 1.7829600524902344e+02 1.0567700195312500e+02 2.2970499038696289e+01 1.5059500122070312e+02 1.0635100555419922e+02 3.5838397979736328e+01 1.5397000122070312e+02 1.0626800537109375e+02 4.2044799804687500e+01 1.5049398803710938e+02 1.0635399627685547e+02 2.7782098770141602e+01 1.8074000549316406e+02 1.0562300109863281e+02 3.4554897308349609e+01 1.8051699829101562e+02 1.2848699951171875e+02 3.7337501525878906e+01 1.7486000061035156e+02 1.2864300537109375e+02 4.4506500244140625e+01 1.7078800964355469e+02 1.2874299621582031e+02 4.6530101776123047e+01 1.6394700622558594e+02 1.2891101074218750e+02 4.7107299804687500e+01 1.5527699279785156e+02 1.2911100769042969e+02 4.2932498931884766e+01 1.5078700256347656e+02 1.2923300170898438e+02 3.4432003021240234e+01 1.5150498962402344e+02 1.2920300292968750e+02 2.6530799865722656e+01 1.5301100158691406e+02 1.2916900634765625e+02 2.3392900466918945e+01 1.5807400512695312e+02 1.2908700561523438e+02 1.8496299743652344e+01 1.6262100219726562e+02 1.2891801452636719e+02 1.6596698760986328e+01 1.7224598693847656e+02 1.2871900939941406e+02 1.7548700332641602e+01 1.7493901062011719e+02 1.2863999938964844e+02 1.9098400115966797e+01 1.8069299316406250e+02 1.2850399780273438e+02 2.6743900299072266e+01 1.8147500610351562e+02 1.2844799804687500e+02 3.0500900268554688e+01 1.8045201110839844e+02 1.0585000610351562e+02 2.7586599349975586e+01 1.7519700622558594e+02 1.0600900268554688e+02 1.9664098739624023e+01 1.7232699584960938e+02 1.0606099700927734e+02 1.7872200012207031e+01 1.6881599426269531e+02 1.0617900085449219e+02 1.6583900451660156e+01 1.5572999572753906e+02 1.0647100067138672e+02 1.9712099075317383e+01 1.5225500488281250e+02 1.0654900360107422e+02 2.3686901092529297e+01 1.5012300109863281e+02 1.0656599426269531e+02 3.3341400146484375e+01 1.5198999023437500e+02 1.0654499816894531e+02 3.9309200286865234e+01 1.5670399475097656e+02 1.0643699645996094e+02 4.4505802154541016e+01 1.5972599792480469e+02 1.0636699676513672e+02 4.6087898254394531e+01 1.6336399841308594e+02 1.0625699615478516e+02 4.7097000122070312e+01 1.7244799804687500e+02 1.0607299804687500e+02 4.5599098205566406e+01 1.7915100097656250e+02 1.0588500213623047e+02 3.9069499969482422e+01 1.6684500122070312e+02 1.1375199890136719e+02 4.7211799621582031e+01 1.5753599548339844e+02 1.2138999938964844e+02 1.8598999023437500e+01 1.5824600219726562e+02 1.2137799835205078e+02 4.5241798400878906e+01 1.5270700073242188e+02 1.2114799499511719e+02 2.3382099151611328e+01 1.5072000122070312e+02 1.2121199798583984e+02 2.8405200958251953e+01 1.5050099182128906e+02 1.2177000427246094e+02 3.4069999694824219e+01 1.5244599914550781e+02 1.2123200225830078e+02 3.9512100219726562e+01 1.5495300292968750e+02 1.2151099395751953e+02 4.2754898071289062e+01 1.6367700195312500e+02 1.2132199859619141e+02 4.7156200408935547e+01 1.7042001342773438e+02 1.2111399841308594e+02 4.6645801544189453e+01 1.7525100708007812e+02 1.2104599761962891e+02 4.4078300476074219e+01 1.7850399780273438e+02 1.2094400024414062e+02 4.0728401184082031e+01 1.8046900939941406e+02 1.2086199951171875e+02 3.7023399353027344e+01 1.8134700012207031e+02 1.2065699768066406e+02 3.1938999176025391e+01 1.8096099853515625e+02 1.2095300292968750e+02 2.8284999847412109e+01 1.7961199951171875e+02 1.2018099975585938e+02 2.4513099670410156e+01 1.7681401062011719e+02 1.2021200561523438e+02 2.0767200469970703e+01 1.7199400329589844e+02 1.2131399536132812e+02 1.7464300155639648e+01 1.6637300109863281e+02 1.2136299896240234e+02 1.6277101516723633e+01 1.6260099792480469e+02 1.2124700164794922e+02 1.6580900192260742e+01 1.5109098815917969e+02 1.1382800292968750e+02 2.6625101089477539e+01 1.5021800231933594e+02 1.1463200378417969e+02 3.0670200347900391e+01 1.6237199401855469e+02 1.1347799682617188e+02 4.6883197784423828e+01 1.5715100097656250e+02 1.1392700195312500e+02 4.4744201660156250e+01 1.5305999755859375e+02 1.1413600158691406e+02 4.0727897644042969e+01 1.5076400756835938e+02 1.1394699859619141e+02 3.6179100036621094e+01 1.7114500427246094e+02 1.1371900177001953e+02 4.6273700714111328e+01 1.7518200683593750e+02 1.1393199920654297e+02 4.4009300231933594e+01 1.7810598754882812e+02 1.1325500488281250e+02 4.1007701873779297e+01 1.8014700317382812e+02 1.1351499938964844e+02 3.7383499145507812e+01 1.8112799072265625e+02 1.1340100097656250e+02 3.2996799468994141e+01 1.8084300231933594e+02 1.1386699676513672e+02 2.8405300140380859e+01 1.7934100341796875e+02 1.1392399597167969e+02 2.4336500167846680e+01 1.7644400024414062e+02 1.1336199951171875e+02 2.0610601425170898e+01 1.7282600402832031e+02 1.1328399658203125e+02 1.8013399124145508e+01 1.5403999328613281e+02 1.1481700134277344e+02 2.1443799972534180e+01 1.5956900024414062e+02 1.1376499938964844e+02 1.7465200424194336e+01 1.6519000244140625e+02 1.1371599578857422e+02 1.6277900695800781e+01 1.6913600158691406e+02 1.1384500122070312e+02 1.6606901168823242e+01 1.7818099975585938e+02 1.1880000305175781e+02 1.6572599411010742e+01 1.7248800659179688e+02 1.1894799804687500e+02 1.2773099899291992e+01 1.7016400146484375e+02 1.1967199707031250e+02 1.5580499649047852e+01 1.5984800720214844e+02 1.1974099731445312e+02 1.6005798339843750e+01 1.5423400878906250e+02 1.1997100067138672e+02 1.9876298904418945e+01 1.4910900878906250e+02 1.1962599945068359e+02 2.5527198791503906e+01 1.4900900268554688e+02 1.1976399993896484e+02 3.4724899291992188e+01 1.5247599792480469e+02 1.1952500152587891e+02 4.3559200286865234e+01 1.5780900573730469e+02 1.1980800628662109e+02 4.6620101928710938e+01 1.6655500793457031e+02 1.1973799896240234e+02 4.8417602539062500e+01 1.7326100158691406e+02 1.1947299957275391e+02 4.6616302490234375e+01 1.7938800048828125e+02 1.1933200073242188e+02 4.1622001647949219e+01 1.8297599792480469e+02 1.1906900024414062e+02 3.3571498870849609e+01 1.4844799804687500e+02 1.1959500122070312e+02 2.2010400772094727e+01 1.6049099731445312e+02 1.1921199798583984e+02 5.0506500244140625e+01 1.6820100402832031e+02 1.1904199981689453e+02 5.1344100952148438e+01 1.8475698852539062e+02 1.1865500640869141e+02 3.8325801849365234e+01 1.8583200073242188e+02 1.1866399383544922e+02 3.1357299804687500e+01 1.4578700256347656e+02 1.1641600036621094e+02 3.2118999481201172e+01 1.5360299682617188e+02 1.1628100585937500e+02 1.6034099578857422e+01 1.5008599853515625e+02 1.1574299621582031e+02 2.6012699127197266e+01 1.5006098937988281e+02 1.1567799377441406e+02 3.7242698669433594e+01 1.5830299377441406e+02 1.1560700225830078e+02 4.6615898132324219e+01 1.5412800598144531e+02 1.1577600097656250e+02 4.3783500671386719e+01 1.6825099182128906e+02 1.1590299987792969e+02 5.1365497589111328e+01 1.6491200256347656e+02 1.1530400085449219e+02 4.8368499755859375e+01 1.7656199645996094e+02 1.1557299804687500e+02 4.6054401397705078e+01 1.8147200012207031e+02 1.1509899902343750e+02 3.7696903228759766e+01 1.8549400329589844e+02 1.1548500061035156e+02 3.1017501831054688e+01 1.8270100402832031e+02 1.1512300109863281e+02 3.0687299728393555e+01 1.7728900146484375e+02 1.1527399444580078e+02 1.9561899185180664e+01 1.6139900207519531e+02 1.1540800476074219e+02 1.5581100463867188e+01 1.4762300109863281e+02 1.1639299774169922e+02 4.0154502868652344e+01 1.7171398925781250e+02 1.1533900451660156e+02 1.6006198883056641e+01 1.6574800109863281e+02 1.1590400695800781e+02 1.3853400230407715e+01 1.5955599975585938e+02 1.1934799957275391e+02 1.2783300399780273e+01 1.7753500366210938e+02 1.1895199584960938e+02 4.8003498077392578e+01 1.5867799377441406e+02 1.1592499542236328e+02 5.0987998962402344e+01 1.7193399047851562e+02 1.1568400573730469e+02 1.2529399871826172e+01 1.8225399780273438e+02 1.1544499969482422e+02 1.9986900329589844e+01 1.8293699645996094e+02 1.1546900177001953e+02 4.1545497894287109e+01 1.5254499816894531e+02 1.1972299957275391e+02 4.7313899993896484e+01 1.4573899841308594e+02 1.1973100280761719e+02 3.5017898559570312e+01 1.8387599182128906e+02 1.1897599792480469e+02 2.2339200973510742e+01 1.5211199951171875e+02 1.2076100158691406e+02 1.5105100631713867e+01 1.5663899230957031e+02 1.2105500030517578e+02 1.2156700134277344e+01 1.4431199645996094e+02 1.2133699798583984e+02 3.0086599349975586e+01 1.4437500000000000e+02 1.2122900390625000e+02 3.3679401397705078e+01 1.4748400878906250e+02 1.2105300140380859e+02 4.3076999664306641e+01 1.5111700439453125e+02 1.2156900024414062e+02 4.7607196807861328e+01 1.5517201232910156e+02 1.2114500427246094e+02 5.0573299407958984e+01 1.6047599792480469e+02 1.2095600128173828e+02 5.2695198059082031e+01 1.6585800170898438e+02 1.2081199645996094e+02 5.3386497497558594e+01 1.7127000427246094e+02 1.2075699615478516e+02 5.2695301055908203e+01 1.7525799560546875e+02 1.2039800262451172e+02 5.1165599822998047e+01 1.8083799743652344e+02 1.2045899963378906e+02 4.7361400604248047e+01 1.8351499938964844e+02 1.2004299926757812e+02 4.4095901489257812e+01 1.8557299804687500e+02 1.2040299987792969e+02 4.0645099639892578e+01 1.8699400329589844e+02 1.2032199859619141e+02 2.7059999465942383e+01 1.8750700378417969e+02 1.2066699981689453e+02 3.1348102569580078e+01 1.8563699340820312e+02 1.2069100189208984e+02 2.2988998413085938e+01 1.8381300354003906e+02 1.2037400054931641e+02 1.9682600021362305e+01 1.7245199584960938e+02 1.2069499969482422e+02 1.1158400535583496e+01 1.6873500061035156e+02 1.2062100219726562e+02 1.0364299774169922e+01 1.6446701049804688e+02 1.2086299896240234e+02 1.0151600837707520e+01 1.6028100585937500e+02 1.2083200073242188e+02 1.0898799896240234e+01 1.4800100708007812e+02 1.2133800506591797e+02 1.9518400192260742e+01 1.4556700134277344e+02 1.2129999542236328e+02 2.4295400619506836e+01 1.4520500183105469e+02 1.2130499267578125e+02 3.8146499633789062e+01 1.7770298767089844e+02 1.2137599945068359e+02 4.9916301727294922e+01 1.8717298889160156e+02 1.2034799957275391e+02 3.5452198028564453e+01 1.8078799438476562e+02 1.2032300567626953e+02 1.6176898956298828e+01 1.7784700012207031e+02 1.2087000274658203e+02 1.3688400268554688e+01 1.6216600036621094e+02 1.1582899475097656e+02 1.1798299789428711e+01 1.5834001159667969e+02 1.1438299560546875e+02 1.1411600112915039e+01 1.6425000000000000e+02 1.1423600006103516e+02 1.0168800354003906e+01 1.6835400390625000e+02 1.1432400512695312e+02 1.0334599494934082e+01 1.7265699768066406e+02 1.1377400207519531e+02 1.1241899490356445e+01 1.4953399658203125e+02 1.1467199707031250e+02 1.7390699386596680e+01 1.5398399353027344e+02 1.1479100036621094e+02 1.3603799819946289e+01 1.4407199096679688e+02 1.1469999694824219e+02 3.2681400299072266e+01 1.4459300231933594e+02 1.1471900177001953e+02 2.7069900512695312e+01 1.4829899597167969e+02 1.1529699707031250e+02 4.4385898590087891e+01 1.6011300659179688e+02 1.1404900360107422e+02 5.2702598571777344e+01 1.5521900939941406e+02 1.1444000244140625e+02 5.0677097320556641e+01 1.6572000122070312e+02 1.1451000213623047e+02 5.3345798492431641e+01 1.7125601196289062e+02 1.1411399841308594e+02 5.2673801422119141e+01 1.7852400207519531e+02 1.1395800018310547e+02 4.9173900604248047e+01 1.7505299377441406e+02 1.1402400207519531e+02 5.1210601806640625e+01 1.7805899047851562e+02 1.1546500396728516e+02 4.7727302551269531e+01 1.8255700683593750e+02 1.1385499572753906e+02 4.5288101196289062e+01 1.8690299987792969e+02 1.1377600097656250e+02 3.5890899658203125e+01 1.8556700134277344e+02 1.1399500274658203e+02 4.0317798614501953e+01 1.8670498657226562e+02 1.1374100494384766e+02 2.6566099166870117e+01 1.8729800415039062e+02 1.1370800018310547e+02 3.1283100128173828e+01 1.8474400329589844e+02 1.1377899932861328e+02 2.1457300186157227e+01 1.7736599731445312e+02 1.1394400024414062e+02 1.3502200126647949e+01 1.8208299255371094e+02 1.1390499877929688e+02 1.7675298690795898e+01 1.4654699707031250e+02 1.1489500427246094e+02 2.1701000213623047e+01 1.4665499877929688e+02 1.1616799926757812e+02 2.4707698822021484e+01 1.4465800476074219e+02 1.1476100158691406e+02 3.6561401367187500e+01 1.4586199951171875e+02 1.1438700103759766e+02 4.0514801025390625e+01 1.5054998779296875e+02 1.1462300109863281e+02 4.7192100524902344e+01 1.6338400268554688e+02 1.2995899963378906e+02 5.3998600006103516e+01 1.6051199340820312e+02 1.3010099792480469e+02 5.3488197326660156e+01 1.5782600402832031e+02 1.3017199707031250e+02 5.2614601135253906e+01 1.5532901000976562e+02 1.3015901184082031e+02 5.1425502777099609e+01 1.5289900207519531e+02 1.3048901367187500e+02 4.9927398681640625e+01 1.5072700500488281e+02 1.3033500671386719e+02 4.8109100341796875e+01 1.4879600524902344e+02 1.3039199829101562e+02 4.6050701141357422e+01 1.4638000488281250e+02 1.3064799499511719e+02 4.2717597961425781e+01 1.4474000549316406e+02 1.3049200439453125e+02 3.8666599273681641e+01 1.4407199096679688e+02 1.3047898864746094e+02 3.6033802032470703e+01 1.4369000244140625e+02 1.3051899719238281e+02 3.3141399383544922e+01 1.4367300415039062e+02 1.3071400451660156e+02 3.0403598785400391e+01 1.4405000305175781e+02 1.3042601013183594e+02 2.7569999694824219e+01 1.4473800659179688e+02 1.3068499755859375e+02 2.4792301177978516e+01 1.4574000549316406e+02 1.3047698974609375e+02 2.2276500701904297e+01 1.4713899230957031e+02 1.3063000488281250e+02 1.9701101303100586e+01 1.4880400085449219e+02 1.3039498901367188e+02 1.7435699462890625e+01 1.5067900085449219e+02 1.3034599304199219e+02 1.5428699493408203e+01 1.5289999389648438e+02 1.3029499816894531e+02 1.3590900421142578e+01 1.5525999450683594e+02 1.3043299865722656e+02 1.2075400352478027e+01 1.5782800292968750e+02 1.3017599487304688e+02 1.0882300376892090e+01 1.6049499511718750e+02 1.3010400390625000e+02 1.0014999389648438e+01 1.6327198791503906e+02 1.3004299926757812e+02 9.4848299026489258e+00 1.6609199523925781e+02 1.3016999816894531e+02 9.2892093658447266e+00 1.7010499572753906e+02 1.2985000610351562e+02 9.6467695236206055e+00 1.7436000061035156e+02 1.2996800231933594e+02 1.0868599891662598e+01 1.7690199279785156e+02 1.2970300292968750e+02 1.2092100143432617e+01 1.7926800537109375e+02 1.2965199279785156e+02 1.3592500686645508e+01 1.8145599365234375e+02 1.2959199523925781e+02 1.5404000282287598e+01 1.8337998962402344e+02 1.2975000000000000e+02 1.7421400070190430e+01 1.8503099060058594e+02 1.2950498962402344e+02 1.9737899780273438e+01 1.8638400268554688e+02 1.2947799682617188e+02 2.2195400238037109e+01 1.8743998718261719e+02 1.2965100097656250e+02 2.4798700332641602e+01 1.8812200927734375e+02 1.2943600463867188e+02 2.7566099166870117e+01 1.8858499145507812e+02 1.2945700073242188e+02 3.1437999725341797e+01 1.8811700439453125e+02 1.2942799377441406e+02 3.5961502075195312e+01 1.8704600524902344e+02 1.2943499755859375e+02 3.9838100433349609e+01 1.8503298950195312e+02 1.2950601196289062e+02 4.3763500213623047e+01 1.8336300659179688e+02 1.2955599975585938e+02 4.6059700012207031e+01 1.8145201110839844e+02 1.2979600524902344e+02 4.8128601074218750e+01 1.7926699829101562e+02 1.2957200622558594e+02 4.9897903442382812e+01 1.7688800048828125e+02 1.2970300292968750e+02 5.1414798736572266e+01 1.7333200073242188e+02 1.2976300048828125e+02 5.3023300170898438e+01 1.6889999389648438e+02 1.2990200805664062e+02 5.4013500213623047e+01 1.6604800415039062e+02 1.3016799926757812e+02 5.4210399627685547e+01 1.4652000427246094e+02 1.0537199401855469e+02 1.9711299896240234e+01 1.4517599487304688e+02 1.0560800170898438e+02 2.2209899902343750e+01 1.4414399719238281e+02 1.0562599945068359e+02 2.4811300277709961e+01 1.4318699645996094e+02 1.0562599945068359e+02 2.8732498168945312e+01 1.4317601013183594e+02 1.0567399597167969e+02 3.4408302307128906e+01 1.4414100646972656e+02 1.0563199615478516e+02 3.8678798675537109e+01 1.4516400146484375e+02 1.0540299987792969e+02 4.1318401336669922e+01 1.4653900146484375e+02 1.0557500457763672e+02 4.3774501800537109e+01 1.4819499206542969e+02 1.0552700042724609e+02 4.6057701110839844e+01 1.5012200927734375e+02 1.0548899841308594e+02 4.8106700897216797e+01 1.5227600097656250e+02 1.0523100280761719e+02 4.9918800354003906e+01 1.5580200195312500e+02 1.0532200622558594e+02 5.2062500000000000e+01 1.7104400634765625e+02 1.0503199768066406e+02 5.3479198455810547e+01 1.6828900146484375e+02 1.0504000091552734e+02 5.4013698577880859e+01 1.6547499084472656e+02 1.0491000366210938e+02 5.4210399627685547e+01 1.6266999816894531e+02 1.0517700195312500e+02 5.4013698577880859e+01 1.5990299987792969e+02 1.0524799346923828e+02 5.3484699249267578e+01 1.7375000000000000e+02 1.0470999908447266e+02 5.2629299163818359e+01 1.7628700256347656e+02 1.0485400390625000e+02 5.1415100097656250e+01 1.7868399047851562e+02 1.0478600311279297e+02 4.9893100738525391e+01 1.8074099731445312e+02 1.0478899383544922e+02 4.8172298431396484e+01 1.8276899719238281e+02 1.0448999786376953e+02 4.6075000762939453e+01 1.8441999816894531e+02 1.0465600585937500e+02 4.3774398803710938e+01 1.8576000976562500e+02 1.0461899566650391e+02 4.1332099914550781e+01 1.8684298706054688e+02 1.0439099884033203e+02 3.8655399322509766e+01 1.8749600219726562e+02 1.0455200195312500e+02 3.6105701446533203e+01 1.8799800109863281e+02 1.0454100036621094e+02 3.1929899215698242e+01 1.8755400085449219e+02 1.0456600189208984e+02 2.7697999954223633e+01 1.8682199096679688e+02 1.0439099884033203e+02 2.4785001754760742e+01 1.8579598999023438e+02 1.0462000274658203e+02 2.2241399765014648e+01 1.8441699218750000e+02 1.0465099334716797e+02 1.9716300964355469e+01 1.8279998779296875e+02 1.0448999786376953e+02 1.7460100173950195e+01 1.4977999877929688e+02 1.0559400177001953e+02 1.5745698928833008e+01 1.5224600219726562e+02 1.0551100158691406e+02 1.3635399818420410e+01 1.5464900207519531e+02 1.0517399597167969e+02 1.2072100639343262e+01 1.5721499633789062e+02 1.0530699920654297e+02 1.0887000083923340e+01 1.5990299987792969e+02 1.0524700164794922e+02 1.0012900352478027e+01 1.6266000366210938e+02 1.0517399597167969e+02 9.4853601455688477e+00 1.6547299194335938e+02 1.0491000366210938e+02 9.2895603179931641e+00 1.6830200195312500e+02 1.0503599548339844e+02 9.4854202270507812e+00 1.7308099365234375e+02 1.0495700073242188e+02 1.0612400054931641e+01 1.7631700134277344e+02 1.0484600067138672e+02 1.2097800254821777e+01 1.7866101074218750e+02 1.0478399658203125e+02 1.3589400291442871e+01 1.8084100341796875e+02 1.0473999786376953e+02 1.5396200180053711e+01 1.8915299987792969e+02 1.2961100769042969e+02 4.2548702239990234e+01 1.9130499267578125e+02 1.2955799865722656e+02 2.8018598556518555e+01 1.7640798950195312e+02 1.2992100524902344e+02 5.5063400268554688e+01 1.4309599304199219e+02 1.3072900390625000e+02 4.2753799438476562e+01 1.9085800170898438e+02 1.0429300689697266e+02 3.4052101135253906e+01 1.7434799194335938e+02 1.0469199371337891e+02 7.8530302047729492e+00 1.4475500488281250e+02 1.0541200256347656e+02 1.6902700424194336e+01 1.3999900817871094e+02 1.0552700042724609e+02 3.0949899673461914e+01 1.6764199829101562e+02 1.3013200378417969e+02 5.7198200225830078e+01 1.5585400390625000e+02 1.3041900634765625e+02 5.5101997375488281e+01 1.7770799255371094e+02 1.2988699340820312e+02 9.0543603897094727e+00 1.6824301147460938e+02 1.3011599731445312e+02 6.3840699195861816e+00 1.4335900878906250e+02 1.3072200012207031e+02 2.0301500320434570e+01 1.4065901184082031e+02 1.3078401184082031e+02 3.3692501068115234e+01 1.8208500671386719e+02 1.2978099060058594e+02 5.1556503295898438e+01 1.5186000061035156e+02 1.3051499938964844e+02 1.0596699714660645e+01 1.8680999755859375e+02 1.2966600036621094e+02 1.6905401229858398e+01 1.6012699890136719e+02 1.3030999755859375e+02 6.9621801376342773e+00 1.6697900390625000e+02 1.0487400054931641e+02 5.7196598052978516e+01 1.8618400573730469e+02 1.0440599822998047e+02 1.6885999679565430e+01 1.5122799682617188e+02 1.0525499725341797e+02 1.0609400749206543e+01 1.6552099609375000e+02 1.0490799713134766e+02 6.2534799575805664e+00 1.8318200683593750e+02 1.0447899627685547e+02 5.0090801239013672e+01 1.9041900634765625e+02 1.0430400085449219e+02 3.6985198974609375e+01 1.5002900695800781e+02 1.0528800201416016e+02 5.2029300689697266e+01 1.4053599548339844e+02 1.0551499938964844e+02 3.7011100769042969e+01 1.5514099121093750e+02 1.0516099548339844e+02 5.5057800292968750e+01 1.8888800048828125e+02 1.1707700347900391e+02 4.0942100524902344e+01 1.9100999450683594e+02 1.2930900573730469e+02 3.7009700775146484e+01 1.8133099365234375e+02 1.1725799560546875e+02 5.1138797760009766e+01 1.7894500732421875e+02 1.2961299133300781e+02 5.3753398895263672e+01 1.5836199951171875e+02 1.3018600463867188e+02 5.6052799224853516e+01 1.5749899291992188e+02 1.1793799591064453e+02 5.5199298858642578e+01 1.6459498596191406e+02 1.2984899902343750e+02 5.7166599273681641e+01 1.4275000000000000e+02 1.1829000091552734e+02 4.1086700439453125e+01 1.4195600891113281e+02 1.3050000000000000e+02 3.9937599182128906e+01 1.4110000610351562e+02 1.1775199890136719e+02 2.8864801406860352e+01 1.4088800048828125e+02 1.3052700805664062e+02 2.7974100112915039e+01 1.4367599487304688e+02 1.1818700408935547e+02 2.0403900146484375e+01 1.4541000366210938e+02 1.3042199707031250e+02 1.6852300643920898e+01 1.7213200378417969e+02 1.2977400207519531e+02 6.9919199943542480e+00 1.6804100036621094e+02 1.1756999969482422e+02 6.9988398551940918e+00 1.8957499694824219e+02 1.1705099487304688e+02 2.4582199096679688e+01 1.9008900451660156e+02 1.2930000305175781e+02 2.3176099777221680e+01 1.9148999023437500e+02 1.2930799865722656e+02 3.3570098876953125e+01 1.9067199707031250e+02 1.1693000030517578e+02 3.2014499664306641e+01 1.8761799621582031e+02 1.2939100646972656e+02 4.5361900329589844e+01 1.8570999145507812e+02 1.2945500183105469e+02 4.8015697479248047e+01 1.7371499633789062e+02 1.2963600158691406e+02 5.6035198211669922e+01 1.7056800842285156e+02 1.2980699157714844e+02 5.6836200714111328e+01 1.5311500549316406e+02 1.3022999572753906e+02 5.3683998107910156e+01 1.5051199340820312e+02 1.3030599975585938e+02 5.1928199768066406e+01 1.4835299682617188e+02 1.3034500122070312e+02 5.0050197601318359e+01 1.4645500183105469e+02 1.3030700683593750e+02 4.7961898803710938e+01 1.4452099609375000e+02 1.3044099426269531e+02 4.5325901031494141e+01 1.4115199279785156e+02 1.3051899719238281e+02 3.6991397857666016e+01 1.4154299926757812e+02 1.3052499389648438e+02 2.4872501373291016e+01 1.4768399047851562e+02 1.3034300231933594e+02 1.4095200538635254e+01 1.4943000793457031e+02 1.3031800842285156e+02 1.2463399887084961e+01 1.5477299499511719e+02 1.3020199584960938e+02 8.8971204757690430e+00 1.6326100158691406e+02 1.2999899291992188e+02 6.4136400222778320e+00 1.7557400512695312e+02 1.2965499877929688e+02 8.0811996459960938e+00 1.8031700134277344e+02 1.2956700134277344e+02 1.0615799903869629e+01 1.8303500366210938e+02 1.2951199340820312e+02 1.2704100608825684e+01 1.8486100769042969e+02 1.2945700073242188e+02 1.4529299736022949e+01 1.8851100158691406e+02 1.2938598632812500e+02 1.9640001296997070e+01 1.8383599853515625e+02 1.2940899658203125e+02 5.0018703460693359e+01 1.4246900939941406e+02 1.3041400146484375e+02 2.2190299987792969e+01 1.5719200134277344e+02 1.3005599975585938e+02 7.8717498779296875e+00 1.6606800842285156e+02 1.2975401306152344e+02 6.2752399444580078e+00 1.9067500305175781e+02 1.0448200225830078e+02 2.7966199874877930e+01 1.8807099914550781e+02 1.0472399902343750e+02 1.9946800231933594e+01 1.8430000305175781e+02 1.0470700073242188e+02 1.4573599815368652e+01 1.8212899780273438e+02 1.0475099945068359e+02 1.2466600418090820e+01 1.7708200073242188e+02 1.0483699798583984e+02 9.0664596557617188e+00 1.6847799682617188e+02 1.0503900146484375e+02 6.4432597160339355e+00 1.6247599792480469e+02 1.0523600006103516e+02 6.4470200538635254e+00 1.5950199890136719e+02 1.0531199645996094e+02 6.9787502288818359e+00 1.5663200378417969e+02 1.0538099670410156e+02 7.8539299964904785e+00 1.5387399291992188e+02 1.0543900299072266e+02 9.0700397491455078e+00 1.4882699584960938e+02 1.0556300354003906e+02 1.2472899436950684e+01 1.4669599914550781e+02 1.0560900115966797e+02 1.4541699409484863e+01 1.4187399291992188e+02 1.0573899841308594e+02 2.2174398422241211e+01 1.4090800476074219e+02 1.0576100158691406e+02 2.5033599853515625e+01 1.4028599548339844e+02 1.0577899932861328e+02 2.7980199813842773e+01 1.4010700988769531e+02 1.0577500152587891e+02 3.3986301422119141e+01 1.4247700500488281e+02 1.0571199798583984e+02 4.2691497802734375e+01 1.4394200134277344e+02 1.0562899780273438e+02 4.5365402221679688e+01 1.4773799133300781e+02 1.0559199523925781e+02 5.0033199310302734e+01 1.5251800537109375e+02 1.0548500061035156e+02 5.3687801361083984e+01 1.5801901245117188e+02 1.0534200286865234e+02 5.6111598968505859e+01 1.6097499084472656e+02 1.0527499389648438e+02 5.6830902099609375e+01 1.6999499511718750e+02 1.0505400085449219e+02 5.6829200744628906e+01 1.7295399475097656e+02 1.0497999572753906e+02 5.6107101440429688e+01 1.7574800109863281e+02 1.0490799713134766e+02 5.5069202423095703e+01 1.7844801330566406e+02 1.0484900665283203e+02 5.3684398651123047e+01 1.8094099426269531e+02 1.0479699707031250e+02 5.2003303527832031e+01 1.8524800109863281e+02 1.0468099975585938e+02 4.7820198059082031e+01 1.8702299499511719e+02 1.0464399719238281e+02 4.5353199005126953e+01 1.8846699523925781e+02 1.0460600280761719e+02 4.2737701416015625e+01 1.8960299682617188e+02 1.0456900024414062e+02 3.9933399200439453e+01 1.7146200561523438e+02 1.0517700195312500e+02 6.9870300292968750e+00 1.9004798889160156e+02 1.0484399414062500e+02 2.5036800384521484e+01 1.6400900268554688e+02 1.0531300354003906e+02 5.7179100036621094e+01 1.7970899963378906e+02 1.0489199829101562e+02 1.0615900039672852e+01 1.4572900390625000e+02 1.0571400451660156e+02 4.7830200195312500e+01 1.4134599304199219e+02 1.0582399749755859e+02 3.9890899658203125e+01 1.4318299865722656e+02 1.0577899932861328e+02 1.9436199188232422e+01 1.5366200256347656e+02 1.1786199951171875e+02 5.3453399658203125e+01 1.5017298889160156e+02 1.1794000244140625e+02 5.1096000671386719e+01 1.4716101074218750e+02 1.1791799926757812e+02 4.8230201721191406e+01 1.4461900329589844e+02 1.1808200073242188e+02 4.4784400939941406e+01 1.4148699951171875e+02 1.1815799713134766e+02 3.6987499237060547e+01 1.4094898986816406e+02 1.1807700347900391e+02 3.2890098571777344e+01 1.4200599670410156e+02 1.1828699493408203e+02 2.4545398712158203e+01 1.4580099487304688e+02 1.1805299377441406e+02 1.6967199325561523e+01 1.4852600097656250e+02 1.1803199768066406e+02 1.3851099967956543e+01 1.5186500549316406e+02 1.1790599822998047e+02 1.1153000831604004e+01 1.5555499267578125e+02 1.1798100280761719e+02 9.0858306884765625e+00 1.5952000427246094e+02 1.1772000122070312e+02 7.6918601989746094e+00 1.6364399719238281e+02 1.1758500671386719e+02 6.9796400070190430e+00 1.6578199768066406e+02 1.1756800079345703e+02 6.9792299270629883e+00 1.7204501342773438e+02 1.1741500091552734e+02 7.6918601989746094e+00 1.7601499938964844e+02 1.1722899627685547e+02 9.0837497711181641e+00 1.7969900512695312e+02 1.1722899627685547e+02 1.1153000831604004e+01 1.8297999572753906e+02 1.1728900146484375e+02 1.3788900375366211e+01 1.8576399230957031e+02 1.1708200073242188e+02 1.6967199325561523e+01 1.8803599548339844e+02 1.1729899597167969e+02 2.0653400421142578e+01 1.9043399047851562e+02 1.1696899414062500e+02 2.8592300415039062e+01 1.9034500122070312e+02 1.1697100067138672e+02 3.4896297454833984e+01 1.9007701110839844e+02 1.1697699737548828e+02 3.6987499237060547e+01 1.8694500732421875e+02 1.1705300140380859e+02 4.4784400939941406e+01 1.8439399719238281e+02 1.1736100006103516e+02 4.8241897583007812e+01 1.7790299987792969e+02 1.1727300262451172e+02 5.3453399658203125e+01 1.7410800170898438e+02 1.1726599884033203e+02 5.5183197021484375e+01 1.6998199462890625e+02 1.1746600341796875e+02 5.6252700805664062e+01 1.6583399963378906e+02 1.1765699768066406e+02 5.6617000579833984e+01 1.6158200073242188e+02 1.1766999816894531e+02 5.6252700805664062e+01 1.6722700500488281e+02 1.2853099060058594e+02 7.0446296691894531e+01 1.6456100463867188e+02 1.1893299865722656e+02 7.0446899414062500e+01 1.6142900085449219e+02 1.2819000244140625e+02 7.0446899414062500e+01 1.6091699218750000e+02 1.0711399841308594e+02 7.0446899414062500e+01 1.6638400268554688e+02 1.0696800231933594e+02 7.0447494506835938e+01 1.7529598999023438e+02 1.0231799316406250e+02 3.9378898620605469e+01 1.6788700866699219e+02 1.0249800109863281e+02 3.4847698211669922e+01 1.7529598999023438e+02 1.0231799316406250e+02 6.6001899719238281e+01 1.6045500183105469e+02 1.0267900085449219e+02 6.6001899719238281e+01 1.6332299804687500e+02 1.0260900115966797e+02 3.5504299163818359e+01 1.6966400146484375e+02 1.0245499420166016e+02 3.0123399734497070e+01 1.7223100280761719e+02 1.0239299774169922e+02 2.7607400894165039e+01 1.6735099792480469e+02 1.0251100158691406e+02 2.4256500244140625e+01 1.6378900146484375e+02 1.0259799957275391e+02 2.7771299362182617e+01 1.5777899169921875e+02 1.0274399566650391e+02 3.2358097076416016e+01 1.6127400207519531e+02 1.0265900421142578e+02 3.1574800491333008e+01 1.5842199707031250e+02 1.0272800445556641e+02 2.8142000198364258e+01 1.6282899475097656e+02 1.0262099456787109e+02 2.4457099914550781e+01 1.6278900146484375e+02 1.3260200500488281e+02 2.9137800216674805e+01 1.6514399719238281e+02 1.3254598999023438e+02 2.3941301345825195e+01 1.6777400207519531e+02 1.3248200988769531e+02 2.7771299362182617e+01 1.7602400207519531e+02 1.3228100585937500e+02 3.9378898620605469e+01 1.7038600158691406e+02 1.3241799926757812e+02 3.2452800750732422e+01 1.7325100708007812e+02 1.3234899902343750e+02 2.8684898376464844e+01 1.7053500366210938e+02 1.3241499328613281e+02 2.5377201080322266e+01 1.5944700622558594e+02 1.3268400573730469e+02 2.7617498397827148e+01 1.6290600585937500e+02 1.3259999084472656e+02 3.4598297119140625e+01 1.6118399047851562e+02 1.3264199829101562e+02 6.6001899719238281e+01 1.5850700378417969e+02 1.3270700073242188e+02 3.2358097076416016e+01 1.6702699279785156e+02 1.3250000000000000e+02 3.5612800598144531e+01 1.7602400207519531e+02 1.3228100585937500e+02 6.6001899719238281e+01 1.6828599548339844e+02 1.3437500000000000e+02 2.7995599746704102e+01 1.7033499145507812e+02 1.3432499694824219e+02 3.1925001144409180e+01 1.7300599670410156e+02 1.3425999450683594e+02 2.7607400894165039e+01 1.6692100524902344e+02 1.3440798950195312e+02 2.3911199569702148e+01 1.6224700927734375e+02 1.3452099609375000e+02 2.9552499771118164e+01 1.6055799865722656e+02 1.3456300354003906e+02 2.6252899169921875e+01 1.7607000732421875e+02 1.3418600463867188e+02 3.9378597259521484e+01 1.6122999572753906e+02 1.3454598999023438e+02 6.6001899719238281e+01 1.6409700012207031e+02 1.3447700500488281e+02 3.5504299163818359e+01 1.5855300903320312e+02 1.3461099243164062e+02 3.2358097076416016e+01 1.6866099548339844e+02 1.3436601257324219e+02 3.4847698211669922e+01 1.7622200012207031e+02 1.3418400573730469e+02 6.6231803894042969e+01 1.6830799865722656e+02 1.2815600585937500e+02 7.2396003723144531e+01 1.6160899353027344e+02 1.2936199951171875e+02 7.2344100952148438e+01 1.6506298828125000e+02 1.2023799896240234e+02 7.2351905822753906e+01 1.6670799255371094e+02 1.0704199981689453e+02 7.2367805480957031e+01 1.6106900024414062e+02 1.0711000061035156e+02 7.2351905822753906e+01 1.7525000000000000e+02 1.0041400146484375e+02 3.9378597259521484e+01 1.6964100646972656e+02 1.0055000305175781e+02 3.2433101654052734e+01 1.7222200012207031e+02 1.0048699951171875e+02 2.7817501068115234e+01 1.6700000000000000e+02 1.0061399841308594e+02 2.7771299362182617e+01 1.6185600280761719e+02 1.0073899841308594e+02 2.9276401519775391e+01 1.6317900085449219e+02 1.0070700073242188e+02 2.4328199386596680e+01 1.6770500183105469e+02 1.0059700012207031e+02 2.4371500015258789e+01 1.6217799377441406e+02 1.0073100280761719e+02 3.4627899169921875e+01 1.6040899658203125e+02 1.0077399444580078e+02 6.6001899719238281e+01 1.5773298645019531e+02 1.0083899688720703e+02 3.2358097076416016e+01 1.5867201232910156e+02 1.0081700134277344e+02 2.7617498397827148e+01 1.6625300598144531e+02 1.0063199615478516e+02 3.5612800598144531e+01 1.7525000000000000e+02 1.0041400146484375e+02 6.6001899719238281e+01 2.0121600341796875e+02 1.0400400543212891e+02 6.8669799804687500e+01 2.0069000244140625e+02 1.0101699829101562e+02 6.8303695678710938e+01 1.9751499938964844e+02 1.0113099670410156e+02 6.5027198791503906e+01 1.9716900634765625e+02 9.8795196533203125e+01 6.4728599548339844e+01 1.9397200012207031e+02 9.9489303588867188e+01 6.1406898498535156e+01 1.9405599975585938e+02 9.7514999389648438e+01 6.1542900085449219e+01 1.9140200805664062e+02 9.8837303161621094e+01 5.8767398834228516e+01 1.9148999023437500e+02 9.6917503356933594e+01 5.8906600952148438e+01 1.8948500061035156e+02 9.8581199645996094e+01 5.6792598724365234e+01 1.8950498962402344e+02 9.6672103881835938e+01 5.6861198425292969e+01 1.8755101013183594e+02 9.8526901245117188e+01 5.4795997619628906e+01 1.8750500488281250e+02 9.6622497558593750e+01 5.4795997619628906e+01 1.8562300109863281e+02 9.8675102233886719e+01 5.2799301147460938e+01 1.8550999450683594e+02 9.6769104003906250e+01 5.2730697631835938e+01 1.8371998596191406e+02 9.9023902893066406e+01 5.0824600219726562e+01 1.8353900146484375e+02 9.7110595703125000e+01 5.0685302734375000e+01 1.8186500549316406e+02 9.9569702148437500e+01 4.8893299102783203e+01 1.8161100769042969e+02 9.7643699645996094e+01 4.8679500579833984e+01 1.8007600402832031e+02 1.0030699920654297e+02 4.7026702880859375e+01 1.7974400329589844e+02 9.8363098144531250e+01 4.6732601165771484e+01 1.7793899536132812e+02 1.0150099945068359e+02 4.4787899017333984e+01 1.7622500610351562e+02 1.0026300048828125e+02 4.3057399749755859e+01 1.7650300598144531e+02 1.0216899871826172e+02 4.3471599578857422e+01 2.0632499694824219e+02 1.1462300109863281e+02 6.9113403320312500e+01 2.0788900756835938e+02 1.1253900146484375e+02 6.9113403320312500e+01 2.0543000793457031e+02 1.1086499786376953e+02 6.9113403320312500e+01 2.0663699340820312e+02 1.0874500274658203e+02 6.9113403320312500e+01 2.0374099731445312e+02 1.0730699920654297e+02 6.9113899230957031e+01 2.0429800415039062e+02 1.0466500091552734e+02 6.9161300659179688e+01 2.0419299316406250e+02 1.2591699981689453e+02 6.9114402770996094e+01 2.0486100769042969e+02 1.2856199645996094e+02 6.9145698547363281e+01 2.0570799255371094e+02 1.2228199768066406e+02 6.9113403320312500e+01 2.0701600646972656e+02 1.2434100341796875e+02 6.9113403320312500e+01 2.0641900634765625e+02 1.1848500061035156e+02 6.9113403320312500e+01 2.0808200073242188e+02 1.2048999786376953e+02 6.9113403320312500e+01 2.0837699890136719e+02 1.1650499725341797e+02 6.9113403320312500e+01 1.9920100402832031e+02 1.3409899902343750e+02 6.6025802612304688e+01 2.0182600402832031e+02 1.2934100341796875e+02 6.8673294067382812e+01 1.9828300476074219e+02 1.3238499450683594e+02 6.5036499023437500e+01 1.9625599670410156e+02 1.3563699340820312e+02 6.2859298706054688e+01 1.9482398986816406e+02 1.3419898986816406e+02 6.1415901184082031e+01 1.9438900756835938e+02 1.3635600280761719e+02 6.0912399291992188e+01 1.9246099853515625e+02 1.3688899230957031e+02 5.8906600952148438e+01 1.9227999877929688e+02 1.3497599792480469e+02 5.8767398834228516e+01 1.9049000549316406e+02 1.3723100280761719e+02 5.6861198425292969e+01 1.9037699890136719e+02 1.3532499694824219e+02 5.6792598724365234e+01 1.8849499511718750e+02 1.3737800598144531e+02 5.4795997619628906e+01 1.8844898986816406e+02 1.3547299194335938e+02 5.4795997619628906e+01 1.8649501037597656e+02 1.3732800292968750e+02 5.2730697631835938e+01 1.8651499938964844e+02 1.3541899108886719e+02 5.2799301147460938e+01 1.8450999450683594e+02 1.3708299255371094e+02 5.0685302734375000e+01 1.8459799194335938e+02 1.3516299438476562e+02 5.0824600219726562e+01 1.8255900573730469e+02 1.3664401245117188e+02 4.8679500579833984e+01 1.8271798706054688e+02 1.3470800781250000e+02 4.8893299102783203e+01 1.8065800476074219e+02 1.3601499938964844e+02 4.6730701446533203e+01 1.8089599609375000e+02 1.3405899047851562e+02 4.7026702880859375e+01 1.7716600036621094e+02 1.3434300231933594e+02 4.3169898986816406e+01 1.7870298767089844e+02 1.3297000122070312e+02 4.4787899017333984e+01 1.7718798828125000e+02 1.3236199951171875e+02 4.3404197692871094e+01 1.7670999145507812e+02 1.0000900268554688e+02 6.6001899719238281e+01 1.9847399902343750e+02 9.9512596130371094e+01 7.8516403198242188e+01 2.0054598999023438e+02 1.0097000122070312e+02 7.9336502075195312e+01 2.0281199645996094e+02 1.0299699401855469e+02 7.8003402709960938e+01 1.9573199462890625e+02 9.8153701782226562e+01 7.8874900817871094e+01 1.9034600830078125e+02 9.6751899719238281e+01 7.8003402709960938e+01 1.9305799865722656e+02 9.7255599975585938e+01 7.8978393554687500e+01 1.8750399780273438e+02 9.6624099731445312e+01 7.8853599548339844e+01 1.7678199768066406e+02 9.9981201171875000e+01 7.8003402709960938e+01 1.7603399658203125e+02 1.0045299530029297e+02 6.6992599487304688e+01 1.7975599670410156e+02 9.8391304016113281e+01 7.8003402709960938e+01 1.8190699768066406e+02 9.7548400878906250e+01 7.8003402709960938e+01 1.8467399597167969e+02 9.6889694213867188e+01 7.8003402709960938e+01 1.7367900085449219e+02 1.0245300292968750e+02 7.8797698974609375e+01 1.7430000305175781e+02 1.0182700347900391e+02 7.0164802551269531e+01 1.7016099548339844e+02 1.0707900238037109e+02 7.8534095764160156e+01 1.7034899902343750e+02 1.0650900268554688e+02 7.4274505615234375e+01 1.7010400390625000e+02 1.2658100128173828e+02 7.9373901367187500e+01 1.7039300537109375e+02 1.2785999298095703e+02 7.4543899536132812e+01 1.6764500427246094e+02 1.1968500518798828e+02 7.8506301879882812e+01 1.6793299865722656e+02 1.2161199951171875e+02 7.4027503967285156e+01 1.6765899658203125e+02 1.1397299957275391e+02 7.4976493835449219e+01 1.6809899902343750e+02 1.1309099578857422e+02 7.9360404968261719e+01 1.7399899291992188e+02 1.3182200622558594e+02 7.8939102172851562e+01 1.7847200012207031e+02 1.3502799987792969e+02 7.8466598510742188e+01 1.7728799438476562e+02 1.3434199523925781e+02 6.8486900329589844e+01 1.7503399658203125e+02 1.3275199890136719e+02 7.0172798156738281e+01 1.8067599487304688e+02 1.3597599792480469e+02 7.8003402709960938e+01 1.8149598693847656e+02 1.3631799316406250e+02 7.8003402709960938e+01 1.8421800231933594e+02 1.3702799987792969e+02 7.8978698730468750e+01 1.8730999755859375e+02 1.3737901306152344e+02 7.8957397460937500e+01 1.8991500854492188e+02 1.3729299926757812e+02 7.8003402709960938e+01 1.9270401000976562e+02 1.3682701110839844e+02 7.8498298645019531e+01 2.0237399291992188e+02 1.3145401000976562e+02 6.8737503051757812e+01 2.0015899658203125e+02 1.3333099365234375e+02 7.8862396240234375e+01 2.0326699829101562e+02 1.3054899597167969e+02 7.8883094787597656e+01 1.9543499755859375e+02 1.3597900390625000e+02 7.8003402709960938e+01 1.9791999816894531e+02 1.3480200195312500e+02 7.8992095947265625e+01 2.0663499450683594e+02 1.2534299468994141e+02 7.8566604614257812e+01 2.0818998718261719e+02 1.2031999969482422e+02 7.8328903198242188e+01 2.0834399414062500e+02 1.1575700378417969e+02 7.8501205444335938e+01 2.0785998535156250e+02 1.1217199707031250e+02 7.8455703735351562e+01 2.0602400207519531e+02 1.0750599670410156e+02 7.9346900939941406e+01 1.8064799499511719e+02 1.2877499389648438e+02 8.0289398193359375e+01 1.7737400817871094e+02 1.3306100463867188e+02 8.0278800964355469e+01 1.7601800537109375e+02 1.2400999450683594e+02 8.0289398193359375e+01 1.8903799438476562e+02 1.0315699768066406e+02 8.0289398193359375e+01 1.8437500000000000e+02 1.0369300079345703e+02 8.0289398193359375e+01 1.8672599792480469e+02 9.8308799743652344e+01 8.0287597656250000e+01 1.7435299682617188e+02 1.1899500274658203e+02 8.0289398193359375e+01 1.7000498962402344e+02 1.1554999542236328e+02 8.0289398193359375e+01 1.7438299560546875e+02 1.1430100250244141e+02 8.0289398193359375e+01 1.7959700012207031e+02 1.0594999694824219e+02 8.0289398193359375e+01 1.7235299682617188e+02 1.0591799926757812e+02 8.0278396606445312e+01 1.7646199035644531e+02 1.0944300079345703e+02 8.0289398193359375e+01 1.8696199035644531e+02 1.3084300231933594e+02 8.0289398193359375e+01 2.0161700439453125e+02 1.1969900512695312e+02 8.0289398193359375e+01 2.0732299804687500e+02 1.1724700164794922e+02 8.0275695800781250e+01 1.9953800964355469e+02 1.2455700683593750e+02 8.0289398193359375e+01 1.9932299804687500e+02 1.3162100219726562e+02 8.0207603454589844e+01 1.9640299987792969e+02 1.2805000305175781e+02 8.0289398193359375e+01 1.9411100769042969e+02 1.0463500213623047e+02 8.0289398193359375e+01 1.9744200134277344e+02 1.0048500061035156e+02 8.0286598205566406e+01 1.9795599365234375e+02 1.0732699584960938e+02 8.0289398193359375e+01 1.8876499938964844e+02 1.3622898864746094e+02 8.0276695251464844e+01 1.9162500000000000e+02 1.3030700683593750e+02 8.0289398193359375e+01 2.0131100463867188e+02 1.1306100463867188e+02 8.0289398193359375e+01 2.0326399230957031e+02 1.0655300140380859e+02 7.8383804321289062e+01 2.0510299682617188e+02 1.0993400573730469e+02 7.8383903503417969e+01 2.0597599792480469e+02 1.1272000122070312e+02 7.8003402709960938e+01 2.0639898681640625e+02 1.1558899688720703e+02 7.8120002746582031e+01 2.0633999633789062e+02 1.1946800231933594e+02 7.8383995056152344e+01 2.0375299072265625e+02 1.2669399261474609e+02 7.8384101867675781e+01 2.0542700195312500e+02 1.2322299957275391e+02 7.8240798950195312e+01 1.9860200500488281e+02 1.3216400146484375e+02 7.8384201049804688e+01 2.0068000793457031e+02 1.3044300842285156e+02 7.8235000610351562e+01 1.9592399597167969e+02 1.3369299316406250e+02 7.8003402709960938e+01 1.9227999877929688e+02 1.3497599792480469e+02 7.8003402709960938e+01 1.9413499450683594e+02 1.3443000793457031e+02 7.8003402709960938e+01 1.9037699890136719e+02 1.3532499694824219e+02 7.8384201049804688e+01 1.8844898986816406e+02 1.3547299194335938e+02 7.8003402709960938e+01 1.7758999633789062e+02 1.3226699829101562e+02 7.0106498718261719e+01 1.8089599609375000e+02 1.3405899047851562e+02 7.8003402709960938e+01 1.8271798706054688e+02 1.3470800781250000e+02 7.8003402709960938e+01 1.8459799194335938e+02 1.3516299438476562e+02 7.8003402709960938e+01 1.8651499938964844e+02 1.3541899108886719e+02 7.8003402709960938e+01 1.7385600280761719e+02 1.2902699279785156e+02 7.5597602844238281e+01 1.7751799011230469e+02 1.3221701049804688e+02 7.8384300231933594e+01 1.7044599914550781e+02 1.2300099945068359e+02 7.8383995056152344e+01 1.7191499328613281e+02 1.2642799377441406e+02 7.4328804016113281e+01 1.6945298767089844e+02 1.1855100250244141e+02 7.5175704956054688e+01 1.7354299926757812e+02 1.0532299804687500e+02 7.8383995056152344e+01 1.7058599853515625e+02 1.1018999481201172e+02 7.4097099304199219e+01 1.6995700073242188e+02 1.1250299835205078e+02 7.8212097167968750e+01 1.7409199523925781e+02 1.0469999694824219e+02 7.3208694458007812e+01 1.7613301086425781e+02 1.0268999481201172e+02 6.8037704467773438e+01 1.7752499389648438e+02 1.0174400329589844e+02 7.8383903503417969e+01 1.8007600402832031e+02 1.0030699920654297e+02 7.8003402709960938e+01 1.9920100402832031e+02 1.0228700256347656e+02 7.8300399780273438e+01 1.9607099914550781e+02 1.0035199737548828e+02 7.8383903503417969e+01 1.9328199768066406e+02 9.9292396545410156e+01 7.8003402709960938e+01 1.9140200805664062e+02 9.8837303161621094e+01 7.8003402709960938e+01 1.8948500061035156e+02 9.8581199645996094e+01 7.8003402709960938e+01 1.8755101013183594e+02 9.8526901245117188e+01 7.8003402709960938e+01 1.8562300109863281e+02 9.8674995422363281e+01 7.8384201049804688e+01 1.8371998596191406e+02 9.9023902893066406e+01 7.8003402709960938e+01 1.8186500549316406e+02 9.9569702148437500e+01 7.8003402709960938e+01 1.8636199951171875e+02 1.3078500366210938e+02 7.8384399414062500e+01 1.9162500000000000e+02 1.3030700683593750e+02 7.8384399414062500e+01 1.9591499328613281e+02 1.2840400695800781e+02 7.8384399414062500e+01 2.0030799865722656e+02 1.2341999816894531e+02 7.8384399414062500e+01 2.0188200378417969e+02 1.1696399688720703e+02 7.8384399414062500e+01 1.9961000061035156e+02 1.0909799957275391e+02 7.8384399414062500e+01 1.9411100769042969e+02 1.0463500213623047e+02 7.8384399414062500e+01 1.8809199523925781e+02 1.0295700073242188e+02 7.8384399414062500e+01 1.8008500671386719e+02 1.0559600067138672e+02 7.8384399414062500e+01 1.7569200134277344e+02 1.1058100128173828e+02 7.8384399414062500e+01 1.7411799621582031e+02 1.1703600311279297e+02 7.8384399414062500e+01 1.7522700500488281e+02 1.2220300292968750e+02 7.8384399414062500e+01 1.7861900329589844e+02 1.2745100402832031e+02 7.8384399414062500e+01 1.6073699951171875e+02 1.0397399902343750e+02 6.9145004272460938e+01 1.6088198852539062e+02 1.0338099670410156e+02 7.1139099121093750e+01 1.6088398742675781e+02 1.0539499664306641e+02 7.0078399658203125e+01 1.6099600219726562e+02 1.0514900207519531e+02 7.2041099548339844e+01 1.6144400024414062e+02 1.2989099121093750e+02 7.0108505249023438e+01 1.6059899902343750e+02 1.0301399993896484e+02 6.7702896118164062e+01 1.6057800292968750e+02 1.0108699798583984e+02 6.7968002319335938e+01 1.6073599243164062e+02 1.0198000335693359e+02 6.9734298706054688e+01 1.6157499694824219e+02 1.3191999816894531e+02 7.1139099121093750e+01 1.6140200805664062e+02 1.3133399963378906e+02 6.9145004272460938e+01 1.6149699401855469e+02 1.3332701110839844e+02 6.9734298706054688e+01 1.6131100463867188e+02 1.3230000305175781e+02 6.7702896118164062e+01 1.6141400146484375e+02 1.3422000122070312e+02 6.7965904235839844e+01 1.7096499633789062e+02 1.0344599914550781e+02 7.1471801757812500e+01 1.7128500366210938e+02 1.3147099304199219e+02 7.1317802429199219e+01 2.0553300476074219e+02 1.2529599761962891e+02 7.9990203857421875e+01 1.6908399963378906e+02 1.2115200042724609e+02 8.0035903930664062e+01 1.7841699218750000e+02 9.9645004272460938e+01 7.9729400634765625e+01 1.8331100463867188e+02 9.7663902282714844e+01 7.9599502563476562e+01 1.6680699157714844e+02 1.1388099670410156e+02 7.3287399291992188e+01 1.7276699829101562e+02 1.0394100189208984e+02 6.9508598327636719e+01 1.7658799743652344e+02 1.3229299926757812e+02 6.6471298217773438e+01 1.7327299499511719e+02 1.3199398803710938e+02 6.7865997314453125e+01 1.7386799621582031e+02 1.3093598937988281e+02 6.9332099914550781e+01 1.7054499816894531e+02 1.2802600097656250e+02 7.1244400024414062e+01 1.6625698852539062e+02 1.1383599853515625e+02 7.0722404479980469e+01 1.6983999633789062e+02 1.0728599548339844e+02 7.1346199035644531e+01 1.6857800292968750e+02 1.2195999908447266e+02 7.1784500122070312e+01 1.6822200012207031e+02 1.1437900543212891e+02 7.1963302612304688e+01 1.8200199890136719e+02 1.1928299713134766e+02 8.4716903686523438e+01 1.7995401000976562e+02 1.2347399902343750e+02 8.4727897644042969e+01 1.8448899841308594e+02 1.2237300109863281e+02 8.4716903686523438e+01 1.8180499267578125e+02 1.1532099914550781e+02 8.4716903686523438e+01 1.7758999633789062e+02 1.1595800018310547e+02 8.4726600646972656e+01 1.8397499084472656e+02 1.1200099945068359e+02 8.4716903686523438e+01 1.8094099426269531e+02 1.0951599884033203e+02 8.4728797912597656e+01 1.8768200683593750e+02 1.1059000396728516e+02 8.4716903686523438e+01 1.8479100036621094e+02 1.0734199523925781e+02 8.4725700378417969e+01 1.9205899047851562e+02 1.2644400024414062e+02 8.4726402282714844e+01 1.8769699096679688e+02 1.2337599945068359e+02 8.4716995239257812e+01 1.9070599365234375e+02 1.2276399993896484e+02 8.4716903686523438e+01 1.9151100158691406e+02 1.1162699890136719e+02 8.4716903686523438e+01 1.9399800109863281e+02 1.1471700286865234e+02 8.4716903686523438e+01 1.9618701171875000e+02 1.1063400268554688e+02 8.4726295471191406e+01 1.9433000183105469e+02 1.1750099945068359e+02 8.4716903686523438e+01 1.9629199218750000e+02 1.2301000213623047e+02 8.4718696594238281e+01 1.9337300109863281e+02 1.2051100158691406e+02 8.4716903686523438e+01 1.8517201232910156e+02 9.5595703125000000e+01 8.8777702331542969e+01 1.9282199096679688e+02 9.5952102661132812e+01 8.8776100158691406e+01 1.8907299804687500e+02 9.7028999328613281e+01 8.9314102172851562e+01 1.9825700378417969e+02 9.9718597412109375e+01 8.9509399414062500e+01 2.0356098937988281e+02 1.0275099945068359e+02 8.9078598022460938e+01 2.0567700195312500e+02 1.0749199676513672e+02 8.9313400268554688e+01 2.0792199707031250e+02 1.1552099609375000e+02 8.9603103637695312e+01 2.0743800354003906e+02 1.0626999664306641e+02 8.8352905273437500e+01 2.0361199951171875e+02 1.2940501403808594e+02 8.9315895080566406e+01 2.0698100280761719e+02 1.2311100006103516e+02 8.9316001892089844e+01 2.0569300842285156e+02 1.2876799011230469e+02 8.9060203552246094e+01 2.0997900390625000e+02 1.2007500457763672e+02 8.8439796447753906e+01 1.9157099914550781e+02 1.3661700439453125e+02 8.9315696716308594e+01 1.9824400329589844e+02 1.3410900878906250e+02 8.9406402587890625e+01 1.9457099914550781e+02 1.3718199157714844e+02 8.9049194335937500e+01 1.8441000366210938e+02 1.3802799987792969e+02 8.9019798278808594e+01 1.7521199035644531e+02 1.3232199096679688e+02 8.9370399475097656e+01 1.8268998718261719e+02 1.3635600280761719e+02 8.9386497497558594e+01 1.7519299316406250e+02 1.3513700866699219e+02 8.8400398254394531e+01 1.6829299926757812e+02 1.2015700531005859e+02 8.9444000244140625e+01 1.6688301086425781e+02 1.2396700286865234e+02 8.8276100158691406e+01 1.6833099365234375e+02 1.1342099761962891e+02 8.9600502014160156e+01 1.7118800354003906e+02 1.0626000213623047e+02 8.9316703796386719e+01 1.6772100830078125e+02 1.0793399810791016e+02 8.8330406188964844e+01 1.7053199768066406e+02 1.0316500091552734e+02 8.8339096069335938e+01 1.7658700561523438e+02 1.0059899902343750e+02 8.9636604309082031e+01 1.8251000976562500e+02 9.7821304321289062e+01 8.9409202575683594e+01 1.7067599487304688e+02 1.2691299438476562e+02 8.9443603515625000e+01 1.7158601379394531e+02 1.3196000671386719e+02 8.8155998229980469e+01 2.0060198974609375e+02 1.3529400634765625e+02 8.8110603332519531e+01 1.7987200927734375e+02 9.6233001708984375e+01 8.7712600708007812e+01 1.7503898620605469e+02 9.8956199645996094e+01 8.7812202453613281e+01 1.6599499511718750e+02 1.1344099426269531e+02 8.7790802001953125e+01 1.6594299316406250e+02 1.1970800018310547e+02 8.7705101013183594e+01 1.8019799804687500e+02 1.3787500000000000e+02 8.7653099060058594e+01 1.8691499328613281e+02 1.3924699401855469e+02 8.7688903808593750e+01 1.9068499755859375e+02 1.3905900573730469e+02 8.7714202880859375e+01 1.9480999755859375e+02 1.3823300170898438e+02 8.7650901794433594e+01 2.0806300354003906e+02 1.2687000274658203e+02 8.7595794677734375e+01 2.1020300292968750e+02 1.1515499877929688e+02 8.7687698364257812e+01 2.0932699584960938e+02 1.1063099670410156e+02 8.7640899658203125e+01 2.0480099487304688e+02 1.0246700286865234e+02 8.7832504272460938e+01 2.0069400024414062e+02 9.8666496276855469e+01 8.7770797729492188e+01 1.8766899108886719e+02 9.4670104980468750e+01 8.7433700561523438e+01 1.6879899597167969e+02 1.2830700683593750e+02 8.7327697753906250e+01 2.0407398986816406e+02 1.3243299865722656e+02 8.7355499267578125e+01 1.9439999389648438e+02 9.5645500183105469e+01 8.7319099426269531e+01 1.8602400207519531e+02 1.2731300354003906e+02 8.4907196044921875e+01 1.9007499694824219e+02 1.0662599945068359e+02 8.4905899047851562e+01 1.9849899291992188e+02 1.1722000122070312e+02 8.4894302368164062e+01 1.9057600402832031e+02 9.4924705505371094e+01 8.1694297790527344e+01 1.9427000427246094e+02 9.5677703857421875e+01 8.1694297790527344e+01 1.9778298950195312e+02 9.7043899536132812e+01 8.1694297790527344e+01 2.0101499938964844e+02 9.8984298706054688e+01 8.1694297790527344e+01 2.0387199401855469e+02 1.0144300079345703e+02 8.1694297790527344e+01 2.0627301025390625e+02 1.0434899902343750e+02 8.1694297790527344e+01 2.0814801025390625e+02 1.0761900329589844e+02 8.1694297790527344e+01 2.0944400024414062e+02 1.1115899658203125e+02 8.1694297790527344e+01 2.1012200927734375e+02 1.1486700439453125e+02 8.1694297790527344e+01 2.1016499328613281e+02 1.1863700103759766e+02 8.1694297790527344e+01 2.0956900024414062e+02 1.2235900115966797e+02 8.1694297790527344e+01 2.0835299682617188e+02 1.2592700195312500e+02 8.1694297790527344e+01 2.0655200195312500e+02 1.2923899841308594e+02 8.1694297790527344e+01 2.0421699523925781e+02 1.3219801330566406e+02 8.1694297790527344e+01 2.0141500854492188e+02 1.3472000122070312e+02 8.1694297790527344e+01 1.9822700500488281e+02 1.3673199462890625e+02 8.1694297790527344e+01 1.9474501037597656e+02 1.3817700195312500e+02 8.1694297790527344e+01 1.9107000732421875e+02 1.3901199340820312e+02 8.1694297790527344e+01 1.8730500793457031e+02 1.3921398925781250e+02 8.1694297790527344e+01 1.8356100463867188e+02 1.3877700805664062e+02 8.1694297790527344e+01 1.7994500732421875e+02 1.3771400451660156e+02 8.1694297790527344e+01 1.7655999755859375e+02 1.3605499267578125e+02 8.1694297790527344e+01 1.7350399780273438e+02 1.3384700012207031e+02 8.1694297790527344e+01 1.7086599731445312e+02 1.3115499877929688e+02 8.1694297790527344e+01 1.6872000122070312e+02 1.2805500793457031e+02 8.1694297790527344e+01 1.6712899780273438e+02 1.2463800048828125e+02 8.1694297790527344e+01 1.6613800048828125e+02 1.2100099945068359e+02 8.1694297790527344e+01 1.6577600097656250e+02 1.1724900054931641e+02 8.1694297790527344e+01 1.6605400085449219e+02 1.1348899841308594e+02 8.1694297790527344e+01 1.6696299743652344e+02 1.0983100128173828e+02 8.1694297790527344e+01 1.6847700500488281e+02 1.0637900543212891e+02 8.1694297790527344e+01 1.7055299377441406e+02 1.0323199462890625e+02 8.1694297790527344e+01 1.7313099670410156e+02 1.0048200225830078e+02 8.1694297790527344e+01 1.7613600158691406e+02 9.8206398010253906e+01 8.1694297790527344e+01 1.7948300170898438e+02 9.6471694946289062e+01 8.1694297790527344e+01 1.8307499694824219e+02 9.5327598571777344e+01 8.1694297790527344e+01 1.8680799865722656e+02 9.4806999206542969e+01 8.1694297790527344e+01 1.8854600524902344e+02 1.3097499084472656e+02 8.8288597106933594e+01 1.9551899719238281e+02 1.2938700866699219e+02 8.8513206481933594e+01 2.0107099914550781e+02 1.2289900207519531e+02 8.8520301818847656e+01 2.0221099853515625e+02 1.1794599914550781e+02 8.8524902343750000e+01 2.0086300659179688e+02 1.1194100189208984e+02 8.8016098022460938e+01 1.9626699829101562e+02 1.0518900299072266e+02 8.8528701782226562e+01 1.9052299499511719e+02 1.0300499725341797e+02 8.8483001708984375e+01 1.8327999877929688e+02 1.0332900238037109e+02 8.8479103088378906e+01 1.7554399108886719e+02 1.1032900238037109e+02 8.8200706481933594e+01 1.7376998901367188e+02 1.1980100250244141e+02 8.8520896911621094e+01 1.7749400329589844e+02 1.2662500000000000e+02 8.8524002075195312e+01 1.8206300354003906e+02 1.3006900024414062e+02 8.8510604858398438e+01 1.7837100219726562e+02 1.3618199157714844e+02 8.1694297790527344e+01 1.8184800720214844e+02 1.3756201171875000e+02 8.1694297790527344e+01 1.8551200866699219e+02 1.3831800842285156e+02 8.1694297790527344e+01 1.8925199890136719e+02 1.3842601013183594e+02 8.1694297790527344e+01 1.9457400512695312e+02 1.3752700805664062e+02 8.1702598571777344e+01 2.0125000000000000e+02 1.3399600219726562e+02 8.1698402404785156e+01 2.0629100036621094e+02 1.2838299560546875e+02 8.1692596435546875e+01 2.0856199645996094e+02 1.2315200042724609e+02 8.1694297790527344e+01 2.0956199645996094e+02 1.1759600067138672e+02 8.1705101013183594e+01 2.0888400268554688e+02 1.1204600524902344e+02 8.1694297790527344e+01 2.0770600891113281e+02 1.0849499511718750e+02 8.1694297790527344e+01 2.0592999267578125e+02 1.0520199584960938e+02 8.1694297790527344e+01 2.0231900024414062e+02 1.0091099548339844e+02 8.1699806213378906e+01 1.9609400939941406e+02 9.7026802062988281e+01 8.1698593139648438e+01 1.8871299743652344e+02 9.5467796325683594e+01 8.1692504882812500e+01 1.8304600524902344e+02 9.6116500854492188e+01 8.1694297790527344e+01 1.7793099975585938e+02 9.7943794250488281e+01 8.1701499938964844e+01 1.7326800537109375e+02 1.0139099884033203e+02 8.1694297790527344e+01 1.7078199768066406e+02 1.0418599700927734e+02 8.1694297790527344e+01 1.6881799316406250e+02 1.0737100219726562e+02 8.1694297790527344e+01 1.6687899780273438e+02 1.1261299896240234e+02 8.1706001281738281e+01 1.6669300842285156e+02 1.2013999938964844e+02 8.1700492858886719e+01 1.6829399108886719e+02 1.2550499725341797e+02 8.1694297790527344e+01 1.7109901428222656e+02 1.3034899902343750e+02 8.1700599670410156e+01 1.7518598937988281e+02 1.3421800231933594e+02 8.1694297790527344e+01 1.8913699340820312e+02 1.3566101074218750e+02 8.8559394836425781e+01 1.6956999206542969e+02 1.1390499877929688e+02 8.8542602539062500e+01 1.7554699707031250e+02 1.0273099517822266e+02 8.8529304504394531e+01 2.0174400329589844e+02 1.1120899963378906e+02 8.8552307128906250e+01 1.8261599731445312e+02 9.6165100097656250e+01 8.5769401550292969e+01 1.9203401184082031e+02 9.5735099792480469e+01 8.5713104248046875e+01 1.7596400451660156e+02 9.9210899353027344e+01 8.6222702026367188e+01 1.7072700500488281e+02 1.0418900299072266e+02 8.6076293945312500e+01 1.6744500732421875e+02 1.1065799713134766e+02 8.5764801025390625e+01 1.6655200195312500e+02 1.1645700073242188e+02 8.5705902099609375e+01 1.6702899169921875e+02 1.2188500213623047e+02 8.5147598266601562e+01 1.6849800109863281e+02 1.2595799255371094e+02 8.5890396118164062e+01 1.7144599914550781e+02 1.3057400512695312e+02 8.6246803283691406e+01 1.7521899414062500e+02 1.3431500244140625e+02 8.5391601562500000e+01 1.8068000793457031e+02 1.3701699829101562e+02 8.6731399536132812e+01 1.8546200561523438e+02 1.3838800048828125e+02 8.5141799926757812e+01 1.9078999328613281e+02 1.3826901245117188e+02 8.5721702575683594e+01 1.9831900024414062e+02 1.3600000000000000e+02 8.5747505187988281e+01 2.0444000244140625e+02 1.3081201171875000e+02 8.5662696838378906e+01 2.0733900451660156e+02 1.2648099517822266e+02 8.5144203186035156e+01 2.0916398620605469e+02 1.2052399444580078e+02 8.5419197082519531e+01 2.0943499755859375e+02 1.1490599822998047e+02 8.5670097351074219e+01 2.0772799682617188e+02 1.0838600158691406e+02 8.5611000061035156e+01 2.0459300231933594e+02 1.0349099731445312e+02 8.6239601135253906e+01 2.0038699340820312e+02 9.9388801574707031e+01 8.5747100830078125e+01 1.7135800170898438e+02 1.2647500610351562e+02 8.8502494812011719e+01 2.0197900390625000e+02 1.2929699707031250e+02 8.8541801452636719e+01 2.0661199951171875e+02 1.1933799743652344e+02 8.8529899597167969e+01 2.0349099731445312e+02 1.0648699951171875e+02 8.8517799377441406e+01 1.9098300170898438e+02 9.8081199645996094e+01 8.8490798950195312e+01 1.9857800292968750e+02 1.0003200531005859e+02 8.7951896667480469e+01 1.7650500488281250e+02 1.3365800476074219e+02 8.7789497375488281e+01 1.6854600524902344e+02 1.1077600097656250e+02 8.7565597534179688e+01 1.6766299438476562e+02 1.1901499938964844e+02 8.7591796875000000e+01 1.8981799316406250e+02 1.3737399291992188e+02 8.7620300292968750e+01 2.0646299743652344e+02 1.2630699920654297e+02 8.7422401428222656e+01 2.0843699645996094e+02 1.1815399932861328e+02 8.7523101806640625e+01 1.8433099365234375e+02 9.7195899963378906e+01 8.7828300476074219e+01 1.9961000061035156e+02 1.3345800781250000e+02 8.7828300476074219e+01 2.0693099975585938e+02 1.1035900115966797e+02 8.7821296691894531e+01 1.9417500305175781e+02 1.1552000427246094e+02 9.2074996948242188e+01 2.0791900634765625e+02 1.1610499572753906e+02 9.2074996948242188e+01 1.9433000183105469e+02 1.1750099945068359e+02 9.2074996948242188e+01 2.0775898742675781e+02 1.1967700195312500e+02 9.2074996948242188e+01 1.9386599731445312e+02 1.1943199920654297e+02 9.2074996948242188e+01 1.8213400268554688e+02 1.1456800079345703e+02 9.2074996948242188e+01 1.8166999816894531e+02 1.1649900054931641e+02 9.2074996948242188e+01 1.6856098937988281e+02 1.1256299591064453e+02 9.2074996948242188e+01 1.8829199218750000e+02 1.1062300109863281e+02 9.2074996948242188e+01 1.9330500793457031e+02 9.7779495239257812e+01 9.2074996948242188e+01 1.9043199157714844e+02 1.1113400268554688e+02 9.2074996948242188e+01 1.9816899108886719e+02 9.9767402648925781e+01 9.2074996948242188e+01 1.9212600708007812e+02 1.1217299652099609e+02 9.2074996948242188e+01 1.8651998901367188e+02 1.1082500457763672e+02 9.2074996948242188e+01 1.8808399963378906e+02 9.6910606384277344e+01 9.2074996948242188e+01 1.7044099426269531e+02 1.0738800048828125e+02 9.2074996948242188e+01 1.8317300415039062e+02 1.1287400054931641e+02 9.2074996948242188e+01 1.7494200134277344e+02 1.0182800292968750e+02 9.2074996948242188e+01 1.8468399047851562e+02 1.1158399963378906e+02 9.2074996948242188e+01 1.8182499694824219e+02 1.1847999572753906e+02 9.2074996948242188e+01 1.6824198913574219e+02 1.1967700195312500e+02 9.2074996948242188e+01 1.6808099365234375e+02 1.1610499572753906e+02 9.2074996948242188e+01 1.8387399291992188e+02 1.2182699584960938e+02 9.2074996948242188e+01 1.7241099548339844e+02 1.2943199157714844e+02 9.2074996948242188e+01 1.8258399963378906e+02 1.2031600189208984e+02 9.2074996948242188e+01 1.7044200134277344e+02 1.2644800567626953e+02 9.2074996948242188e+01 1.6903700256347656e+02 1.2316100311279297e+02 9.2074996948242188e+01 1.9341600036621094e+02 1.1368399810791016e+02 9.2074996948242188e+01 2.0688700866699219e+02 1.1086299896240234e+02 9.2074996948242188e+01 2.0353199768066406e+02 1.0437599945068359e+02 9.2074996948242188e+01 1.8111099243164062e+02 9.8205703735351562e+01 9.2074996948242188e+01 1.8556800842285156e+02 1.2286599731445312e+02 9.2074996948242188e+01 1.7777299499511719e+02 1.3411700439453125e+02 9.2074996948242188e+01 1.7488099670410156e+02 1.3201499938964844e+02 9.2074996948242188e+01 1.8749900817871094e+02 1.2332999420166016e+02 9.2074996948242188e+01 1.8256500244140625e+02 1.3626599121093750e+02 9.2074996948242188e+01 1.9131599426269531e+02 1.2241600036621094e+02 9.2074996948242188e+01 1.9500599670410156e+02 1.3566799926757812e+02 9.2074996948242188e+01 1.8948001098632812e+02 1.2317500305175781e+02 9.2074996948242188e+01 1.9155999755859375e+02 1.3661900329589844e+02 9.2074996948242188e+01 1.8800000000000000e+02 1.3693901062011719e+02 9.2074996948242188e+01 1.9282699584960938e+02 1.2112600708007812e+02 9.2074996948242188e+01 2.0111900329589844e+02 1.3201499938964844e+02 9.2074996948242188e+01 1.9822700500488281e+02 1.3411700439453125e+02 9.2074996948242188e+01 2.0696299743652344e+02 1.2316100311279297e+02 9.2074996948242188e+01 2.0460000610351562e+02 1.2818400573730469e+02 9.2074996948242188e+01 1.8166999816894531e+02 1.1649900054931641e+02 1.0518900299072266e+02 1.8213400268554688e+02 1.1456800079345703e+02 1.0518900299072266e+02 1.8948001098632812e+02 1.2317500305175781e+02 1.0518900299072266e+02 1.8387399291992188e+02 1.2182699584960938e+02 1.0518900299072266e+02 1.8258399963378906e+02 1.2031600189208984e+02 1.0518900299072266e+02 1.8182499694824219e+02 1.1847999572753906e+02 1.0518900299072266e+02 1.8317300415039062e+02 1.1287400054931641e+02 1.0518900299072266e+02 1.8468399047851562e+02 1.1158399963378906e+02 1.0518900299072266e+02 1.8651998901367188e+02 1.1082500457763672e+02 1.0518900299072266e+02 1.9417500305175781e+02 1.1552000427246094e+02 1.0518900299072266e+02 1.8828700256347656e+02 1.1062000274658203e+02 1.0518900299072266e+02 1.9341600036621094e+02 1.1368399810791016e+02 1.0518900299072266e+02 1.9043199157714844e+02 1.1113400268554688e+02 1.0518900299072266e+02 1.9212600708007812e+02 1.1217299652099609e+02 1.0518900299072266e+02 1.9433000183105469e+02 1.1750099945068359e+02 1.0518900299072266e+02 1.9386599731445312e+02 1.1943199920654297e+02 1.0518900299072266e+02 1.9282699584960938e+02 1.2112600708007812e+02 1.0518900299072266e+02 1.9131599426269531e+02 1.2241600036621094e+02 1.0518900299072266e+02 1.8556800842285156e+02 1.2286599731445312e+02 1.0518900299072266e+02 1.8749900817871094e+02 1.2332999420166016e+02 1.0518900299072266e+02 1.8948001098632812e+02 1.2317500305175781e+02 7.7972892761230469e+01 1.9230400085449219e+02 1.2176100158691406e+02 7.7972892761230469e+01 1.9428099060058594e+02 1.1832199859619141e+02 7.7972892761230469e+01 1.9417500305175781e+02 1.1552000427246094e+02 7.7972892761230469e+01 1.9276100158691406e+02 1.1269599914550781e+02 7.7972892761230469e+01 1.9053498840332031e+02 1.1115799713134766e+02 7.8243095397949219e+01 1.8731599426269531e+02 1.1061800384521484e+02 7.7972892761230469e+01 1.8468399047851562e+02 1.1158399963378906e+02 7.7972892761230469e+01 1.8243501281738281e+02 1.1380200195312500e+02 7.7972892761230469e+01 1.8166999816894531e+02 1.1649900054931641e+02 7.7972892761230469e+01 1.8214199829101562e+02 1.1962200164794922e+02 7.7997695922851562e+01 1.8480200195312500e+02 1.2256500244140625e+02 7.7972892761230469e+01 1.8749900817871094e+02 1.2332999420166016e+02 7.7972892761230469e+01 1.8544999694824219e+02 1.2594499969482422e+02 7.4567901611328125e+01 1.8881399536132812e+02 1.1603900146484375e+02 7.3908905029296875e+01 1.8050999450683594e+02 1.2221099853515625e+02 7.4637702941894531e+01 1.8132600402832031e+02 1.1153099822998047e+02 7.4070793151855469e+01 1.8939300537109375e+02 1.0851399993896484e+02 7.4256004333496094e+01 1.9679699707031250e+02 1.1459700012207031e+02 7.4519203186035156e+01 1.9370899963378906e+02 1.2374500274658203e+02 7.4234001159667969e+01 1.9483399963378906e+02 1.1032799530029297e+02 7.6153900146484375e+01 1.7851899719238281e+02 1.1800199890136719e+02 7.6052803039550781e+01 1.8065800476074219e+02 1.1106999969482422e+02 7.6413497924804688e+01 1.8758000183105469e+02 1.0744499969482422e+02 7.6441200256347656e+01 1.9689300537109375e+02 1.1989700317382812e+02 7.5939903259277344e+01 1.9450601196289062e+02 1.2307599639892578e+02 7.7499397277832031e+01 1.9038999938964844e+02 1.2560700225830078e+02 7.7473701477050781e+01 1.8484700012207031e+02 1.0917100524902344e+02 7.7809295654296875e+01 1.9640600585937500e+02 1.1684499359130859e+02 7.7809898376464844e+01 1.8317799377441406e+02 1.2402999877929688e+02 7.7804794311523438e+01 1.7980999755859375e+02 1.1634600067138672e+02 7.7870506286621094e+01 1.8953700256347656e+02 1.2716099548339844e+02 8.5700401306152344e+01 1.8296400451660156e+02 1.2571899414062500e+02 8.5489601135253906e+01 1.9486799621582031e+02 1.2418500518798828e+02 8.5493293762207031e+01 1.8100399780273438e+02 1.0965299987792969e+02 8.5677993774414062e+01 1.8649198913574219e+02 1.0706300354003906e+02 8.5498100280761719e+01 1.7842300415039062e+02 1.1440999603271484e+02 8.5487800598144531e+01 1.9236299133300781e+02 1.0774300384521484e+02 8.5723403930664062e+01 1.9571499633789062e+02 1.1083200073242188e+02 8.5492698669433594e+01 1.9937199401855469e+02 1.2136500549316406e+02 8.7639999389648438e+01 1.9792799377441406e+02 1.1536900329589844e+02 8.5494300842285156e+01 1.8369599914550781e+02 1.1223900604248047e+02 8.5478904724121094e+01 1.8820300292968750e+02 1.1040899658203125e+02 8.5478904724121094e+01 1.8146299743652344e+02 1.1675000000000000e+02 8.5478904724121094e+01 1.7843299865722656e+02 1.2021800231933594e+02 8.5499801635742188e+01 1.8258399963378906e+02 1.2031600189208984e+02 8.5478904724121094e+01 1.8574200439453125e+02 1.2313999938964844e+02 8.5478904724121094e+01 1.9062200927734375e+02 1.2285800170898438e+02 8.5478904724121094e+01 1.9429400634765625e+02 1.1521800231933594e+02 8.5478904724121094e+01 1.9386599731445312e+02 1.1943199920654297e+02 8.5478904724121094e+01 1.9282699584960938e+02 1.2112600708007812e+02 8.5478904724121094e+01 1.9212600708007812e+02 1.1217299652099609e+02 8.5478904724121094e+01 1.9034899902343750e+02 1.3086999511718750e+02 8.9309402465820312e+01 1.9711399841308594e+02 1.2778900909423828e+02 8.9310897827148438e+01 2.0190100097656250e+02 1.1872799682617188e+02 8.9309997558593750e+01 2.0125801086425781e+02 1.1342299652099609e+02 8.9031501770019531e+01 1.9887199401855469e+02 1.0816300201416016e+02 8.9305801391601562e+01 1.9414999389648438e+02 1.0481900024414062e+02 8.8902198791503906e+01 1.8876199340820312e+02 1.0304900360107422e+02 8.9311897277832031e+01 1.8199501037597656e+02 1.0421500396728516e+02 8.9311103820800781e+01 1.7742900085449219e+02 1.0787400054931641e+02 8.9310806274414062e+01 1.7557099914550781e+02 1.1173400115966797e+02 8.8895797729492188e+01 1.7427099609375000e+02 1.1632299804687500e+02 8.9036499023437500e+01 1.7513499450683594e+02 1.2132500457763672e+02 8.8927200317382812e+01 1.7821000671386719e+02 1.2730799865722656e+02 8.9307701110839844e+01 1.8519100952148438e+02 1.3068699645996094e+02 8.9310806274414062e+01 1.7406399536132812e+02 1.2127300262451172e+02 8.9314300537109375e+01 1.8556800842285156e+02 1.2286599731445312e+02 8.9314300537109375e+01 1.8749900817871094e+02 1.2332999420166016e+02 8.9314300537109375e+01 1.8387399291992188e+02 1.2182699584960938e+02 8.9314300537109375e+01 1.8200199890136719e+02 1.1928299713134766e+02 8.9314300537109375e+01 1.8166999816894531e+02 1.1649900054931641e+02 8.9314300537109375e+01 1.8213400268554688e+02 1.1456800079345703e+02 8.9314300537109375e+01 1.8317300415039062e+02 1.1287400054931641e+02 8.9314300537109375e+01 1.9212600708007812e+02 1.1217299652099609e+02 8.9314300537109375e+01 1.9341600036621094e+02 1.1368399810791016e+02 8.9314300537109375e+01 1.8679800415039062e+02 1.1052499389648438e+02 8.9314300537109375e+01 1.9043199157714844e+02 1.1113400268554688e+02 8.9314300537109375e+01 1.9417500305175781e+02 1.1552000427246094e+02 8.9314300537109375e+01 1.9433000183105469e+02 1.1750099945068359e+02 8.9314300537109375e+01 1.9279600524902344e+02 1.2144899749755859e+02 8.9314300537109375e+01 1.8948001098632812e+02 1.2317500305175781e+02 8.9314300537109375e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 89967 -> 161 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7951899170875549e+02 6.5778702497482300e+01 3.3342900872230530e+02) (float-vector -2.7917599678039551e+02 -6.2228899449110031e+01 3.3544099330902100e+02) (float-vector -2.8686898946762085e+02 -2.6740999892354012e+00 1.5133599936962128e+02) (float-vector -2.8350999951362610e+02 4.4929001480340958e+01 1.6554899513721466e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8427299857139587e+02 2.7591500431299210e+01 9.4353497028350830e+01) (float-vector -2.8350999951362610e+02 4.4929001480340958e+01 1.6554899513721466e+02) (float-vector -2.8686898946762085e+02 -2.6740999892354012e+00 1.5133599936962128e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7769500017166138e+02 2.1708400920033455e+01 3.5764899849891663e+02) (float-vector 2.8269499540328979e+02 -2.2507999092340469e+01 3.4729701280593872e+02) (float-vector 2.7328500151634216e+02 -4.8941701650619507e+01 3.5825198888778687e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8269499540328979e+02 -2.2507999092340469e+01 3.4729701280593872e+02) (float-vector 2.7769500017166138e+02 2.1708400920033455e+01 3.5764899849891663e+02) (float-vector 2.8301900625228882e+02 4.3893199414014816e+01 3.3461999893188477e+02) (float-vector 2.8639900684356689e+02 -5.8955798158422112e-01 3.3461800217628479e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5886600315570831e+02 -2.3964299261569977e+02 2.4626800417900085e+02) (float-vector -1.7353500425815582e+02 -2.2392499446868896e+02 2.7576398849487305e+02) (float-vector -1.2381199747323990e+02 -2.5540700554847717e+02 2.4706999957561493e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4432999491691589e+02 -2.4461999535560608e+02 6.4475201070308685e+01) (float-vector -1.5886600315570831e+02 -2.3964299261569977e+02 2.4626800417900085e+02) (float-vector -1.2381199747323990e+02 -2.5540700554847717e+02 2.4706999957561493e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2859999537467957e+02 -1.2629300355911255e+02 7.1665598079562187e+00) (float-vector -2.8183001279830933e+02 -1.8743700638879091e-01 3.8100000470876694e+01) (float-vector -2.7370399236679077e+02 -6.7310899496078491e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7917599678039551e+02 -6.2228899449110031e+01 3.3544099330902100e+02) (float-vector -2.7951899170875549e+02 6.5778702497482300e+01 3.3342900872230530e+02) (float-vector -2.7617898583412170e+02 7.6903901994228363e+01 3.4112098813056946e+02) (float-vector -2.6914200186729431e+02 7.6003201305866241e+01 3.5764899849891663e+02) (float-vector -2.6822400093078613e+02 -7.5252696871757507e+01 3.5825499892234802e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 9.2162802815437317e+01 2.5416800379753113e+02 3.5677200555801392e+02) (float-vector 3.2605599611997604e+01 2.6285400986671448e+02 3.4131899476051331e+02) (float-vector 1.1314199864864349e+02 2.5854501128196716e+02 3.3502599596977234e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3404200375080109e+02 -1.6032099723815918e+02 3.4727999567985535e+02) (float-vector 2.4947400391101837e+02 -1.3497599959373474e+02 3.4728801250457764e+02) (float-vector 2.5195598602294922e+02 -1.3630799949169159e+02 3.3466601371765137e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5412899851799011e+02 -2.3235699534416199e+02 3.5765200853347778e+02) (float-vector 1.3735699653625488e+02 -2.4747000634670258e+02 3.4724301099777222e+02) (float-vector 1.0920000076293945e+02 -2.5187999010086060e+02 3.5677200555801392e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5886600315570831e+02 -2.3964299261569977e+02 2.4626800417900085e+02) (float-vector -1.9538499414920807e+02 -2.1096499264240265e+02 2.7405500411987305e+02) (float-vector -1.7353500425815582e+02 -2.2392499446868896e+02 2.7576398849487305e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2523899376392365e+02 -1.7869900166988373e+02 3.1273001432418823e+02) (float-vector -1.9538499414920807e+02 -2.1096499264240265e+02 2.7405500411987305e+02) (float-vector -2.0038799941539764e+02 -2.0187099277973175e+02 6.4468100666999817e+01) (float-vector -2.3201799392700195e+02 -1.6429999470710754e+02 6.4391702413558960e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0626999796368182e-01 -2.6336699724197388e+02 1.3745899498462677e+02) (float-vector -8.6151398718357086e+01 -2.6221498847007751e+02 2.5336399674415588e+02) (float-vector -5.4024998098611832e+00 -2.6300498843193054e+02 3.1765300035476685e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6151398718357086e+01 -2.6221498847007751e+02 2.5336399674415588e+02) (float-vector -1.0516600310802460e+02 -2.5745001435279846e+02 6.4388200640678406e+01) (float-vector -1.2381199747323990e+02 -2.5540700554847717e+02 2.4706999957561493e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9870800673961639e+01 -2.6282501220703125e+02 3.4141799807548523e+02) (float-vector -5.4024998098611832e+00 -2.6300498843193054e+02 3.1765300035476685e+02) (float-vector -8.6151398718357086e+01 -2.6221498847007751e+02 2.5336399674415588e+02) (float-vector -1.2381199747323990e+02 -2.5540700554847717e+02 2.4706999957561493e+02) (float-vector 1.8142599612474442e+01 -2.5349798798561096e+02 3.5675901174545288e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2605599611997604e+01 2.6285400986671448e+02 3.4131899476051331e+02) (float-vector 9.2162802815437317e+01 2.5416800379753113e+02 3.5677200555801392e+02) (float-vector 1.8214600160717964e+01 2.5352400541305542e+02 3.5675901174545288e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8124600648880005e+02 -5.5127799510955811e+01 1.3745899498462677e+02) (float-vector -2.7118998765945435e+02 -9.5153801143169403e+01 2.1730099618434906e+02) (float-vector -2.5580599904060364e+02 -1.2448599934577942e+02 6.4389303326606750e+01) (float-vector -2.7370399236679077e+02 -6.7310899496078491e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7370399236679077e+02 -6.7310899496078491e+01 3.8100000470876694e+01) (float-vector -2.8270399570465088e+02 -3.2720599323511124e+01 6.4510501921176910e+01) (float-vector -2.8124600648880005e+02 -5.5127799510955811e+01 1.3745899498462677e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8183001279830933e+02 -1.8743700638879091e-01 3.8100000470876694e+01) (float-vector -2.8270399570465088e+02 -3.2720599323511124e+01 6.4510501921176910e+01) (float-vector -2.7370399236679077e+02 -6.7310899496078491e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8686898946762085e+02 -2.6740999892354012e+00 1.5133599936962128e+02) (float-vector -2.8270399570465088e+02 -3.2720599323511124e+01 6.4510501921176910e+01) (float-vector -2.8183001279830933e+02 -1.8743700638879091e-01 3.8100000470876694e+01) (float-vector -2.8427299857139587e+02 2.7591500431299210e+01 9.4353497028350830e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8124600648880005e+02 -5.5127799510955811e+01 1.3745899498462677e+02) (float-vector -2.8270399570465088e+02 -3.2720599323511124e+01 6.4510501921176910e+01) (float-vector -2.8686898946762085e+02 -2.6740999892354012e+00 1.5133599936962128e+02) (float-vector -2.7917599678039551e+02 -6.2228899449110031e+01 3.3544099330902100e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7780199050903320e+02 4.7758601605892181e+01 3.8100000470876694e+01) (float-vector -2.7753299474716187e+02 6.2877297401428223e+01 6.4512796700000763e+01) (float-vector -2.8427299857139587e+02 2.7591500431299210e+01 9.4353497028350830e+01) (float-vector -2.8183001279830933e+02 -1.8743700638879091e-01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7961900830268860e+02 -6.0485400259494781e+01 1.2046200037002563e+02) (float-vector 2.6486700773239136e+02 -1.0797599703073502e+02 1.0121099650859833e+02) (float-vector 2.5301200151443481e+02 -1.3308200240135193e+02 1.0089600086212158e+02) (float-vector 2.5195598602294922e+02 -1.3630799949169159e+02 3.3466601371765137e+02) (float-vector 2.6729398965835571e+02 -9.4801500439643860e+01 3.4729799628257751e+02) (float-vector 2.8153198957443237e+02 -5.2600301802158356e+01 3.3462101221084595e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4188100397586823e+02 -2.4278399348258972e+02 3.8100000470876694e+01) (float-vector 1.1189900338649750e+02 -2.5341299176216125e+02 3.8100000470876694e+01) (float-vector 1.2186300009489059e+02 -2.5360500812530518e+02 6.4391098916530609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1189900338649750e+02 -2.5341299176216125e+02 3.8100000470876694e+01) (float-vector 7.7815599739551544e+01 -2.5707599520683289e+02 3.8100000470876694e+01) (float-vector 8.5850402712821960e+01 -2.5936299562454224e+02 6.4459003508090973e+01) (float-vector 1.0654000192880630e+02 -2.6003101468086243e+02 2.1977999806404114e+02) (float-vector 1.2186300009489059e+02 -2.5360500812530518e+02 6.4391098916530609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1565900743007660e+02 -1.8132199347019196e+02 3.8100000470876694e+01) (float-vector 1.7517399787902832e+02 -2.2417399287223816e+02 6.4476497471332550e+01) (float-vector 1.9344399869441986e+02 -2.1120800077915192e+02 2.2004799544811249e+02) (float-vector 2.1778799593448639e+02 -1.8312799930572510e+02 6.4384602010250092e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0038799941539764e+02 -2.0187099277973175e+02 6.4468100666999817e+01) (float-vector -2.1922099590301514e+02 -1.7666800320148468e+02 3.8100000470876694e+01) (float-vector -2.3201799392700195e+02 -1.6429999470710754e+02 6.4391702413558960e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0516600310802460e+02 -2.5745001435279846e+02 6.4388200640678406e+01) (float-vector -1.1560700088739395e+02 -2.5255399942398071e+02 3.8100000470876694e+01) (float-vector -1.4432999491691589e+02 -2.4461999535560608e+02 6.4475201070308685e+01) (float-vector -1.2381199747323990e+02 -2.5540700554847717e+02 2.4706999957561493e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6768898963928223e+02 9.3681901693344116e+01 3.4729400277137756e+02) (float-vector 2.7262398600578308e+02 6.0152400285005569e+01 3.5675901174545288e+02) (float-vector 2.5843301415443420e+02 1.0150299966335297e+02 3.5825300216674805e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7262398600578308e+02 6.0152400285005569e+01 3.5675901174545288e+02) (float-vector 2.6768898963928223e+02 9.3681901693344116e+01 3.4729400277137756e+02) (float-vector 2.7684399485588074e+02 7.3402799665927887e+01 3.3462500572204590e+02) (float-vector 2.8301900625228882e+02 4.3893199414014816e+01 3.3461999893188477e+02) (float-vector 2.7769500017166138e+02 2.1708400920033455e+01 3.5764899849891663e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1314199864864349e+02 2.5854501128196716e+02 3.3502599596977234e+02) (float-vector 1.3533000648021698e+02 2.4833700060844421e+02 3.4724599123001099e+02) (float-vector 1.2584100663661957e+02 2.4671199917793274e+02 3.5766199231147766e+02) (float-vector 9.2162802815437317e+01 2.5416800379753113e+02 3.5677200555801392e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5440000593662262e+02 2.4159899353981018e+02 3.3483099937438965e+02) (float-vector 1.3533000648021698e+02 2.4833700060844421e+02 3.4724599123001099e+02) (float-vector 1.1314199864864349e+02 2.5854501128196716e+02 3.3502599596977234e+02) (float-vector 1.4443700015544891e+02 2.4689100682735443e+02 2.1730199456214905e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0020100325345993e+02 2.5543498992919922e+02 3.8100000470876694e+01) (float-vector 1.0053700208663940e+02 2.5811600685119629e+02 6.4517199993133545e+01) (float-vector 3.3288799226284027e+01 2.5835400819778442e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2605599611997604e+01 2.6285400986671448e+02 3.4131899476051331e+02) (float-vector 8.5407197475433350e+01 2.6228299736976624e+02 3.1314200162887573e+02) (float-vector 1.1314199864864349e+02 2.5854501128196716e+02 3.3502599596977234e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1314199864864349e+02 2.5854501128196716e+02 3.3502599596977234e+02) (float-vector 8.5407197475433350e+01 2.6228299736976624e+02 3.1314200162887573e+02) (float-vector 5.5121801793575287e+01 2.6267498731613159e+02 1.3758699595928192e+02) (float-vector 1.0053700208663940e+02 2.5811600685119629e+02 6.4517199993133545e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5248500704765320e+02 -1.1770900338888168e+02 3.5765001177787781e+02) (float-vector 2.4947400391101837e+02 -1.3497599959373474e+02 3.4728801250457764e+02) (float-vector 2.3404200375080109e+02 -1.6032099723815918e+02 3.4727999567985535e+02) (float-vector 2.1736699342727661e+02 -1.7289100587368011e+02 3.5825300216674805e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4947400391101837e+02 -1.3497599959373474e+02 3.4728801250457764e+02) (float-vector 2.5248500704765320e+02 -1.1770900338888168e+02 3.5765001177787781e+02) (float-vector 2.6729398965835571e+02 -9.4801500439643860e+01 3.4729799628257751e+02) (float-vector 2.5195598602294922e+02 -1.3630799949169159e+02 3.3466601371765137e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9274599850177765e+02 -2.1217499673366547e+02 3.3478501439094543e+02) (float-vector 1.9344399869441986e+02 -2.1120800077915192e+02 2.2004799544811249e+02) (float-vector 1.7517399787902832e+02 -2.2417399287223816e+02 6.4476497471332550e+01) (float-vector 1.6097700595855713e+02 -2.3556800186634064e+02 9.9016301333904266e+01) (float-vector 1.5853899717330933e+02 -2.3895999789237976e+02 3.3484500646591187e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9344399869441986e+02 -2.1120800077915192e+02 2.2004799544811249e+02) (float-vector 1.9274599850177765e+02 -2.1217499673366547e+02 3.3478501439094543e+02) (float-vector 2.2311200201511383e+02 -1.7981000244617462e+02 3.3472400903701782e+02) (float-vector 2.3888200521469116e+02 -1.5729099512100220e+02 1.3951300084590912e+02) (float-vector 2.1778799593448639e+02 -1.8312799930572510e+02 6.4384602010250092e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5853899717330933e+02 -2.3895999789237976e+02 3.3484500646591187e+02) (float-vector 1.3735699653625488e+02 -2.4747000634670258e+02 3.4724301099777222e+02) (float-vector 1.5412899851799011e+02 -2.3235699534416199e+02 3.5765200853347778e+02) (float-vector 1.8850199878215790e+02 -2.0532500743865967e+02 3.5765200853347778e+02) (float-vector 1.9274599850177765e+02 -2.1217499673366547e+02 3.3478501439094543e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9274599850177765e+02 -2.1217499673366547e+02 3.3478501439094543e+02) (float-vector 1.8850199878215790e+02 -2.0532500743865967e+02 3.5765200853347778e+02) (float-vector 2.1736699342727661e+02 -1.7289100587368011e+02 3.5825300216674805e+02) (float-vector 2.3404200375080109e+02 -1.6032099723815918e+02 3.4727999567985535e+02) (float-vector 2.2311200201511383e+02 -1.7981000244617462e+02 3.3472400903701782e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3692100346088409e+02 -2.4987199902534485e+02 1.3815499842166901e+02) (float-vector 1.5853899717330933e+02 -2.3895999789237976e+02 3.3484500646591187e+02) (float-vector 1.6097700595855713e+02 -2.3556800186634064e+02 9.9016301333904266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3692100346088409e+02 -2.4987199902534485e+02 1.3815499842166901e+02) (float-vector 1.6097700595855713e+02 -2.3556800186634064e+02 9.9016301333904266e+01) (float-vector 1.7517399787902832e+02 -2.2417399287223816e+02 6.4476497471332550e+01) (float-vector 1.4188100397586823e+02 -2.4278399348258972e+02 3.8100000470876694e+01) (float-vector 1.2186300009489059e+02 -2.5360500812530518e+02 6.4391098916530609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3692100346088409e+02 -2.4987199902534485e+02 1.3815499842166901e+02) (float-vector 1.2186300009489059e+02 -2.5360500812530518e+02 6.4391098916530609e+01) (float-vector 1.0654000192880630e+02 -2.6003101468086243e+02 2.1977999806404114e+02) (float-vector 1.2023799866437912e+02 -2.5676199793815613e+02 3.3504799008369446e+02) (float-vector 1.3735699653625488e+02 -2.4747000634670258e+02 3.4724301099777222e+02) (float-vector 1.5853899717330933e+02 -2.3895999789237976e+02 3.3484500646591187e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.3504098206758499e+01 -2.5586700439453125e+02 3.5677498579025269e+02) (float-vector 2.9870800673961639e+01 -2.6282501220703125e+02 3.4141799807548523e+02) (float-vector 1.8142599612474442e+01 -2.5349798798561096e+02 3.5675901174545288e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1736699342727661e+02 -1.7289100587368011e+02 3.5825300216674805e+02) (float-vector 1.8850199878215790e+02 -2.0532500743865967e+02 3.5765200853347778e+02) (float-vector 1.5412899851799011e+02 -2.3235699534416199e+02 3.5765200853347778e+02) (float-vector 1.0920000076293945e+02 -2.5187999010086060e+02 3.5677200555801392e+02) (float-vector 5.3504098206758499e+01 -2.5586700439453125e+02 3.5677498579025269e+02) (float-vector 1.8142599612474442e+01 -2.5349798798561096e+02 3.5675901174545288e+02) (float-vector -2.1241199970245361e+02 -1.6680100560188293e+02 3.5848900675773621e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6614499092102051e+02 1.0848200321197510e+02 3.3462101221084595e+02) (float-vector -2.5424200296401978e+02 1.1622700095176697e+02 3.5764899849891663e+02) (float-vector -2.6914200186729431e+02 7.6003201305866241e+01 3.5764899849891663e+02) (float-vector -2.7617898583412170e+02 7.6903901994228363e+01 3.4112098813056946e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8427299857139587e+02 2.7591500431299210e+01 9.4353497028350830e+01) (float-vector -2.7753299474716187e+02 6.2877297401428223e+01 6.4512796700000763e+01) (float-vector -2.6441898941993713e+02 1.0502000153064728e+02 6.4388796687126160e+01) (float-vector -2.6614499092102051e+02 1.0848200321197510e+02 3.3462101221084595e+02) (float-vector -2.7617898583412170e+02 7.6903901994228363e+01 3.4112098813056946e+02) (float-vector -2.7951899170875549e+02 6.5778702497482300e+01 3.3342900872230530e+02) (float-vector -2.8350999951362610e+02 4.4929001480340958e+01 1.6554899513721466e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5424200296401978e+02 1.1622700095176697e+02 3.5764899849891663e+02) (float-vector -2.3875300586223602e+02 1.5494799613952637e+02 3.4729099273681641e+02) (float-vector -2.2624699771404266e+02 1.6219300031661987e+02 3.5640600323677063e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2624699771404266e+02 1.6219300031661987e+02 3.5640600323677063e+02) (float-vector -2.3875300586223602e+02 1.5494799613952637e+02 3.4729099273681641e+02) (float-vector -2.2817300260066986e+02 1.7204999923706055e+02 3.3512300252914429e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3875300586223602e+02 1.5494799613952637e+02 3.4729099273681641e+02) (float-vector -2.5251600146293640e+02 1.3728199899196625e+02 3.3463299274444580e+02) (float-vector -2.2817300260066986e+02 1.7204999923706055e+02 3.3512300252914429e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3875300586223602e+02 1.5494799613952637e+02 3.4729099273681641e+02) (float-vector -2.5424200296401978e+02 1.1622700095176697e+02 3.5764899849891663e+02) (float-vector -2.6614499092102051e+02 1.0848200321197510e+02 3.3462101221084595e+02) (float-vector -2.5251600146293640e+02 1.3728199899196625e+02 3.3463299274444580e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1451100707054138e+02 1.8678699433803558e+02 6.4392402768135071e+01) (float-vector -1.7443999648094177e+02 2.2468400001525879e+02 6.4470700919628143e+01) (float-vector -1.8075199425220490e+02 2.2348099946975708e+02 2.6108399033546448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1451100707054138e+02 1.8678699433803558e+02 6.4392402768135071e+01) (float-vector -1.8075199425220490e+02 2.2348099946975708e+02 2.6108399033546448e+02) (float-vector -2.2350099682807922e+02 1.8086299300193787e+02 3.0995699763298035e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3754899799823761e+02 2.4780699610710144e+02 6.4461901783943176e+01) (float-vector 1.6204699873924255e+02 2.3379500210285187e+02 6.4531296491622925e+01) (float-vector 1.4443700015544891e+02 2.4689100682735443e+02 2.1730199456214905e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0053700208663940e+02 2.5811600685119629e+02 6.4517199993133545e+01) (float-vector 1.0020100325345993e+02 2.5543498992919922e+02 3.8100000470876694e+01) (float-vector 1.3042700290679932e+02 2.4783399701118469e+02 3.8100000470876694e+01) (float-vector 1.3754899799823761e+02 2.4780699610710144e+02 6.4461901783943176e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3754899799823761e+02 2.4780699610710144e+02 6.4461901783943176e+01) (float-vector 1.4443700015544891e+02 2.4689100682735443e+02 2.1730199456214905e+02) (float-vector 1.1314199864864349e+02 2.5854501128196716e+02 3.3502599596977234e+02) (float-vector 1.0053700208663940e+02 2.5811600685119629e+02 6.4517199993133545e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1565900743007660e+02 -1.8132199347019196e+02 3.8100000470876694e+01) (float-vector 1.7516699433326721e+02 -2.2074699401855469e+02 3.8100000470876694e+01) (float-vector 1.7517399787902832e+02 -2.2417399287223816e+02 6.4476497471332550e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7517399787902832e+02 -2.2417399287223816e+02 6.4476497471332550e+01) (float-vector 1.7516699433326721e+02 -2.2074699401855469e+02 3.8100000470876694e+01) (float-vector 1.4188100397586823e+02 -2.4278399348258972e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4142299592494965e+02 -1.5119099617004395e+02 6.4376600086688995e+01) (float-vector 2.1565900743007660e+02 -1.8132199347019196e+02 3.8100000470876694e+01) (float-vector 2.1778799593448639e+02 -1.8312799930572510e+02 6.4384602010250092e+01) (float-vector 2.3888200521469116e+02 -1.5729099512100220e+02 1.3951300084590912e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5301200151443481e+02 -1.3308200240135193e+02 1.0089600086212158e+02) (float-vector 2.4142299592494965e+02 -1.5119099617004395e+02 6.4376600086688995e+01) (float-vector 2.3888200521469116e+02 -1.5729099512100220e+02 1.3951300084590912e+02) (float-vector 2.2311200201511383e+02 -1.7981000244617462e+02 3.3472400903701782e+02) (float-vector 2.3404200375080109e+02 -1.6032099723815918e+02 3.4727999567985535e+02) (float-vector 2.5195598602294922e+02 -1.3630799949169159e+02 3.3466601371765137e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5580599904060364e+02 -1.2448599934577942e+02 6.4389303326606750e+01) (float-vector -2.4868799746036530e+02 -1.3250100612640381e+02 3.8100000470876694e+01) (float-vector -2.7370399236679077e+02 -6.7310899496078491e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4868799746036530e+02 -1.3250100612640381e+02 3.8100000470876694e+01) (float-vector -2.2859999537467957e+02 -1.2629300355911255e+02 7.1665598079562187e+00) (float-vector -2.7370399236679077e+02 -6.7310899496078491e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.4868799746036530e+02 -1.3250100612640381e+02 3.8100000470876694e+01) (float-vector -2.1922099590301514e+02 -1.7666800320148468e+02 3.8100000470876694e+01) (float-vector -2.2859999537467957e+02 -1.2629300355911255e+02 7.1665598079562187e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1922099590301514e+02 -1.7666800320148468e+02 3.8100000470876694e+01) (float-vector -2.4868799746036530e+02 -1.3250100612640381e+02 3.8100000470876694e+01) (float-vector -2.5580599904060364e+02 -1.2448599934577942e+02 6.4389303326606750e+01) (float-vector -2.3201799392700195e+02 -1.6429999470710754e+02 6.4391702413558960e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1451100707054138e+02 1.8678699433803558e+02 6.4392402768135071e+01) (float-vector -1.8990500271320343e+02 2.0812200009822845e+02 3.8100000470876694e+01) (float-vector -1.7443999648094177e+02 2.2468400001525879e+02 6.4470700919628143e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3217098563909531e+01 -2.5835499167442322e+02 3.8100000470876694e+01) (float-vector -1.1560700088739395e+02 -2.5255399942398071e+02 3.8100000470876694e+01) (float-vector -1.0516600310802460e+02 -2.5745001435279846e+02 6.4388200640678406e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9279000591486692e+00 -2.6122900843620300e+02 6.4384199678897858e+01) (float-vector 8.5850402712821960e+01 -2.5936299562454224e+02 6.4459003508090973e+01) (float-vector 7.7815599739551544e+01 -2.5707599520683289e+02 3.8100000470876694e+01) (float-vector -3.3217098563909531e+01 -2.5835499167442322e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9279000591486692e+00 -2.6122900843620300e+02 6.4384199678897858e+01) (float-vector -3.3217098563909531e+01 -2.5835499167442322e+02 3.8100000470876694e+01) (float-vector -1.0516600310802460e+02 -2.5745001435279846e+02 6.4388200640678406e+01) (float-vector -8.6151398718357086e+01 -2.6221498847007751e+02 2.5336399674415588e+02) (float-vector -3.0626999796368182e-01 -2.6336699724197388e+02 1.3745899498462677e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1922099590301514e+02 -1.7666800320148468e+02 3.8100000470876694e+01) (float-vector -1.7456899583339691e+02 -2.2115099430084229e+02 3.8100000470876694e+01) (float-vector -2.2859999537467957e+02 -1.2629300355911255e+02 7.1665598079562187e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1922099590301514e+02 -1.7666800320148468e+02 3.8100000470876694e+01) (float-vector -2.0038799941539764e+02 -2.0187099277973175e+02 6.4468100666999817e+01) (float-vector -1.7456899583339691e+02 -2.2115099430084229e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9538499414920807e+02 -2.1096499264240265e+02 2.7405500411987305e+02) (float-vector -1.5886600315570831e+02 -2.3964299261569977e+02 2.4626800417900085e+02) (float-vector -1.4432999491691589e+02 -2.4461999535560608e+02 6.4475201070308685e+01) (float-vector -1.7456899583339691e+02 -2.2115099430084229e+02 3.8100000470876694e+01) (float-vector -2.0038799941539764e+02 -2.0187099277973175e+02 6.4468100666999817e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5396800041198730e+02 -1.1682499945163727e+02 3.5764899849891663e+02) (float-vector -2.6871201395988464e+02 -9.3642696738243103e+01 3.4735399484634399e+02) (float-vector -2.6822400093078613e+02 -7.5252696871757507e+01 3.5825499892234802e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7917599678039551e+02 -6.2228899449110031e+01 3.3544099330902100e+02) (float-vector -2.7143800258636475e+02 -9.4449996948242188e+01 3.3461898565292358e+02) (float-vector -2.7118998765945435e+02 -9.5153801143169403e+01 2.1730099618434906e+02) (float-vector -2.8124600648880005e+02 -5.5127799510955811e+01 1.3745899498462677e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7118998765945435e+02 -9.5153801143169403e+01 2.1730099618434906e+02) (float-vector -2.7143800258636475e+02 -9.4449996948242188e+01 3.3461898565292358e+02) (float-vector -2.5251299142837524e+02 -1.3729000091552734e+02 3.3463498950004578e+02) (float-vector -2.5580599904060364e+02 -1.2448599934577942e+02 6.4389303326606750e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6871201395988464e+02 -9.3642696738243103e+01 3.4735399484634399e+02) (float-vector -2.7143800258636475e+02 -9.4449996948242188e+01 3.3461898565292358e+02) (float-vector -2.7917599678039551e+02 -6.2228899449110031e+01 3.3544099330902100e+02) (float-vector -2.6822400093078613e+02 -7.5252696871757507e+01 3.5825499892234802e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0425499975681305e+02 1.8843500316143036e+02 3.5825398564338684e+02) (float-vector 1.7055200040340424e+02 2.2131599485874176e+02 3.5676398873329163e+02) (float-vector 2.0873799920082092e+02 1.9221000373363495e+02 3.4727498888969421e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6822400093078613e+02 -7.5252696871757507e+01 3.5825499892234802e+02) (float-vector -2.6914200186729431e+02 7.6003201305866241e+01 3.5764899849891663e+02) (float-vector -2.5424200296401978e+02 1.1622700095176697e+02 3.5764899849891663e+02) (float-vector -2.2624699771404266e+02 1.6219300031661987e+02 3.5640600323677063e+02) (float-vector 1.8214600160717964e+01 2.5352400541305542e+02 3.5675901174545288e+02) (float-vector 9.2162802815437317e+01 2.5416800379753113e+02 3.5677200555801392e+02) (float-vector 1.2584100663661957e+02 2.4671199917793274e+02 3.5766199231147766e+02) (float-vector 1.7055200040340424e+02 2.2131599485874176e+02 3.5676398873329163e+02) (float-vector 2.0425499975681305e+02 1.8843500316143036e+02 3.5825398564338684e+02) (float-vector 2.3413600027561188e+02 1.5218099951744080e+02 3.5676100850105286e+02) (float-vector 2.5843301415443420e+02 1.0150299966335297e+02 3.5825300216674805e+02) (float-vector 2.1736699342727661e+02 -1.7289100587368011e+02 3.5825300216674805e+02) (float-vector -2.1241199970245361e+02 -1.6680100560188293e+02 3.5848900675773621e+02) (float-vector -2.3545700311660767e+02 -1.5073199570178986e+02 3.5765001177787781e+02) (float-vector -2.5396800041198730e+02 -1.1682499945163727e+02 3.5764899849891663e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0873799920082092e+02 1.9221000373363495e+02 3.4727498888969421e+02) (float-vector 1.7055200040340424e+02 2.2131599485874176e+02 3.5676398873329163e+02) (float-vector 1.5440000593662262e+02 2.4159899353981018e+02 3.3483099937438965e+02) (float-vector 1.9964900612831116e+02 2.0538899302482605e+02 3.3475500345230103e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7055200040340424e+02 2.2131599485874176e+02 3.5676398873329163e+02) (float-vector 1.2584100663661957e+02 2.4671199917793274e+02 3.5766199231147766e+02) (float-vector 1.3533000648021698e+02 2.4833700060844421e+02 3.4724599123001099e+02) (float-vector 1.5440000593662262e+02 2.4159899353981018e+02 3.3483099937438965e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5248500704765320e+02 -1.1770900338888168e+02 3.5765001177787781e+02) (float-vector 2.6874101161956787e+02 -7.3734000325202942e+01 3.5765498876571655e+02) (float-vector 2.6729398965835571e+02 -9.4801500439643860e+01 3.4729799628257751e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6729398965835571e+02 -9.4801500439643860e+01 3.4729799628257751e+02) (float-vector 2.6874101161956787e+02 -7.3734000325202942e+01 3.5765498876571655e+02) (float-vector 2.7328500151634216e+02 -4.8941701650619507e+01 3.5825198888778687e+02) (float-vector 2.8269499540328979e+02 -2.2507999092340469e+01 3.4729701280593872e+02) (float-vector 2.8153198957443237e+02 -5.2600301802158356e+01 3.3462101221084595e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7262398600578308e+02 6.0152400285005569e+01 3.5675901174545288e+02) (float-vector 2.7769500017166138e+02 2.1708400920033455e+01 3.5764899849891663e+02) (float-vector 2.7328500151634216e+02 -4.8941701650619507e+01 3.5825198888778687e+02) (float-vector 2.6874101161956787e+02 -7.3734000325202942e+01 3.5765498876571655e+02) (float-vector 2.5248500704765320e+02 -1.1770900338888168e+02 3.5765001177787781e+02) (float-vector 2.1736699342727661e+02 -1.7289100587368011e+02 3.5825300216674805e+02) (float-vector 2.5843301415443420e+02 1.0150299966335297e+02 3.5825300216674805e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2116400301456451e+02 -1.6547399759292603e+02 3.5683399438858032e+02) (float-vector -2.3545700311660767e+02 -1.5073199570178986e+02 3.5765001177787781e+02) (float-vector -2.1241199970245361e+02 -1.6680100560188293e+02 3.5848900675773621e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2381199747323990e+02 -2.5540700554847717e+02 2.4706999957561493e+02) (float-vector -1.7353500425815582e+02 -2.2392499446868896e+02 2.7576398849487305e+02) (float-vector -2.2432500123977661e+02 -1.7103399336338043e+02 3.4370198845863342e+02) (float-vector -2.2116400301456451e+02 -1.6547399759292603e+02 3.5683399438858032e+02) (float-vector -2.1241199970245361e+02 -1.6680100560188293e+02 3.5848900675773621e+02) (float-vector 1.8142599612474442e+01 -2.5349798798561096e+02 3.5675901174545288e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5580599904060364e+02 -1.2448599934577942e+02 6.4389303326606750e+01) (float-vector -2.5251299142837524e+02 -1.3729000091552734e+02 3.3463498950004578e+02) (float-vector -2.3681199550628662e+02 -1.6140399873256683e+02 3.4079200029373169e+02) (float-vector -2.2523899376392365e+02 -1.7869900166988373e+02 3.1273001432418823e+02) (float-vector -2.3201799392700195e+02 -1.6429999470710754e+02 6.4391702413558960e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3681199550628662e+02 -1.6140399873256683e+02 3.4079200029373169e+02) (float-vector -2.3545700311660767e+02 -1.5073199570178986e+02 3.5765001177787781e+02) (float-vector -2.2116400301456451e+02 -1.6547399759292603e+02 3.5683399438858032e+02) (float-vector -2.2432500123977661e+02 -1.7103399336338043e+02 3.4370198845863342e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3681199550628662e+02 -1.6140399873256683e+02 3.4079200029373169e+02) (float-vector -2.2432500123977661e+02 -1.7103399336338043e+02 3.4370198845863342e+02) (float-vector -1.7353500425815582e+02 -2.2392499446868896e+02 2.7576398849487305e+02) (float-vector -1.9538499414920807e+02 -2.1096499264240265e+02 2.7405500411987305e+02) (float-vector -2.2523899376392365e+02 -1.7869900166988373e+02 3.1273001432418823e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5251299142837524e+02 -1.3729000091552734e+02 3.3463498950004578e+02) (float-vector -2.7143800258636475e+02 -9.4449996948242188e+01 3.3461898565292358e+02) (float-vector -2.6871201395988464e+02 -9.3642696738243103e+01 3.4735399484634399e+02) (float-vector -2.5396800041198730e+02 -1.1682499945163727e+02 3.5764899849891663e+02) (float-vector -2.3545700311660767e+02 -1.5073199570178986e+02 3.5765001177787781e+02) (float-vector -2.3681199550628662e+02 -1.6140399873256683e+02 3.4079200029373169e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0034699738025665e+02 -2.5792300701141357e+02 3.4721401333808899e+02) (float-vector 1.0920000076293945e+02 -2.5187999010086060e+02 3.5677200555801392e+02) (float-vector 1.3735699653625488e+02 -2.4747000634670258e+02 3.4724301099777222e+02) (float-vector 1.2023799866437912e+02 -2.5676199793815613e+02 3.3504799008369446e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2350099682807922e+02 1.8086299300193787e+02 3.0995699763298035e+02) (float-vector -1.8075199425220490e+02 2.2348099946975708e+02 2.6108399033546448e+02) (float-vector -1.5021100640296936e+02 2.4489000439643860e+02 2.4304699897766113e+02) (float-vector -1.6667699813842773e+02 2.2938999533653259e+02 2.6978200674057007e+02) (float-vector -2.2817300260066986e+02 1.7204999923706055e+02 3.3512300252914429e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5021100640296936e+02 2.4489000439643860e+02 2.4304699897766113e+02) (float-vector -1.4001600444316864e+02 2.4673199653625488e+02 6.4521603286266327e+01) (float-vector -1.1520200222730637e+02 2.5543698668479919e+02 6.4518496394157410e+01) (float-vector -1.1289799958467484e+02 2.5895300507545471e+02 2.4237699806690216e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2605599611997604e+01 2.6285400986671448e+02 3.4131899476051331e+02) (float-vector -6.8859599530696869e+01 2.6302999258041382e+02 2.6398399472236633e+02) (float-vector -5.5776998400688171e+01 2.6264798641204834e+02 1.3745899498462677e+02) (float-vector 5.5121801793575287e+01 2.6267498731613159e+02 1.3758699595928192e+02) (float-vector 8.5407197475433350e+01 2.6228299736976624e+02 3.1314200162887573e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7687499523162842e+02 -1.2380400300025940e+02 2.0675600972026587e+00) (float-vector 1.7516699433326721e+02 -2.2074699401855469e+02 3.8100000470876694e+01) (float-vector 2.1565900743007660e+02 -1.8132199347019196e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.8859599530696869e+01 2.6302999258041382e+02 2.6398399472236633e+02) (float-vector -1.1289799958467484e+02 2.5895300507545471e+02 2.4237699806690216e+02) (float-vector -1.1520200222730637e+02 2.5543698668479919e+02 6.4518496394157410e+01) (float-vector -1.1244200170040131e+02 2.5330600142478943e+02 3.8100000470876694e+01) (float-vector -6.3647203147411346e+01 2.6035600900650024e+02 6.4386099576950073e+01) (float-vector -5.5776998400688171e+01 2.6264798641204834e+02 1.3745899498462677e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2350099682807922e+02 1.8086299300193787e+02 3.0995699763298035e+02) (float-vector -2.2817300260066986e+02 1.7204999923706055e+02 3.3512300252914429e+02) (float-vector -2.5251600146293640e+02 1.3728199899196625e+02 3.3463299274444580e+02) (float-vector -2.5346601009368896e+02 1.3343599438667297e+02 1.3745899498462677e+02) (float-vector -2.4089999496936798e+02 1.5127700567245483e+02 6.4391098916530609e+01) (float-vector -2.1451100707054138e+02 1.8678699433803558e+02 6.4392402768135071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5346601009368896e+02 1.3343599438667297e+02 1.3745899498462677e+02) (float-vector -2.5251600146293640e+02 1.3728199899196625e+02 3.3463299274444580e+02) (float-vector -2.6614499092102051e+02 1.0848200321197510e+02 3.3462101221084595e+02) (float-vector -2.6441898941993713e+02 1.0502000153064728e+02 6.4388796687126160e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2161300480365753e+02 1.7398299276828766e+02 3.8100000470876694e+01) (float-vector -1.8990500271320343e+02 2.0812200009822845e+02 3.8100000470876694e+01) (float-vector -2.1451100707054138e+02 1.8678699433803558e+02 6.4392402768135071e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2161300480365753e+02 1.7398299276828766e+02 3.8100000470876694e+01) (float-vector -2.1451100707054138e+02 1.8678699433803558e+02 6.4392402768135071e+01) (float-vector -2.4089999496936798e+02 1.5127700567245483e+02 6.4391098916530609e+01) (float-vector -2.4725900590419769e+02 1.3514399528503418e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6613798737525940e+02 9.2731498181819916e+01 3.8100000470876694e+01) (float-vector -2.6441898941993713e+02 1.0502000153064728e+02 6.4388796687126160e+01) (float-vector -2.7753299474716187e+02 6.2877297401428223e+01 6.4512796700000763e+01) (float-vector -2.7780199050903320e+02 4.7758601605892181e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5346601009368896e+02 1.3343599438667297e+02 1.3745899498462677e+02) (float-vector -2.6441898941993713e+02 1.0502000153064728e+02 6.4388796687126160e+01) (float-vector -2.6613798737525940e+02 9.2731498181819916e+01 3.8100000470876694e+01) (float-vector -2.4725900590419769e+02 1.3514399528503418e+02 3.8100000470876694e+01) (float-vector -2.4089999496936798e+02 1.5127700567245483e+02 6.4391098916530609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1560700088739395e+02 -2.5255399942398071e+02 3.8100000470876694e+01) (float-vector -1.4497399330139160e+02 -2.4123400449752808e+02 3.8100000470876694e+01) (float-vector -1.4432999491691589e+02 -2.4461999535560608e+02 6.4475201070308685e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4497399330139160e+02 -2.4123400449752808e+02 3.8100000470876694e+01) (float-vector -1.7456899583339691e+02 -2.2115099430084229e+02 3.8100000470876694e+01) (float-vector -1.4432999491691589e+02 -2.4461999535560608e+02 6.4475201070308685e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4990800023078918e+02 1.3416400551795959e+02 3.4728899598121643e+02) (float-vector 2.3413600027561188e+02 1.5218099951744080e+02 3.5676100850105286e+02) (float-vector 2.0425499975681305e+02 1.8843500316143036e+02 3.5825398564338684e+02) (float-vector 2.0873799920082092e+02 1.9221000373363495e+02 3.4727498888969421e+02) (float-vector 2.3823499679565430e+02 1.5913799405097961e+02 3.3468601107597351e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4990800023078918e+02 1.3416400551795959e+02 3.4728899598121643e+02) (float-vector 2.6768898963928223e+02 9.3681901693344116e+01 3.4729400277137756e+02) (float-vector 2.5843301415443420e+02 1.0150299966335297e+02 3.5825300216674805e+02) (float-vector 2.3413600027561188e+02 1.5218099951744080e+02 3.5676100850105286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2974098622798920e+01 -2.6219400763511658e+02 3.3513200283050537e+02) (float-vector 1.0034699738025665e+02 -2.5792300701141357e+02 3.4721401333808899e+02) (float-vector 1.2023799866437912e+02 -2.5676199793815613e+02 3.3504799008369446e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0626999796368182e-01 -2.6336699724197388e+02 1.3745899498462677e+02) (float-vector -5.4024998098611832e+00 -2.6300498843193054e+02 3.1765300035476685e+02) (float-vector 2.9870800673961639e+01 -2.6282501220703125e+02 3.4141799807548523e+02) (float-vector 8.2974098622798920e+01 -2.6219400763511658e+02 3.3513200283050537e+02) (float-vector 1.2023799866437912e+02 -2.5676199793815613e+02 3.3504799008369446e+02) (float-vector 1.0654000192880630e+02 -2.6003101468086243e+02 2.1977999806404114e+02) (float-vector 8.5850402712821960e+01 -2.5936299562454224e+02 6.4459003508090973e+01) (float-vector 2.9279000591486692e+00 -2.6122900843620300e+02 6.4384199678897858e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.2974098622798920e+01 -2.6219400763511658e+02 3.3513200283050537e+02) (float-vector 2.9870800673961639e+01 -2.6282501220703125e+02 3.4141799807548523e+02) (float-vector 5.3504098206758499e+01 -2.5586700439453125e+02 3.5677498579025269e+02) (float-vector 1.0920000076293945e+02 -2.5187999010086060e+02 3.5677200555801392e+02) (float-vector 1.0034699738025665e+02 -2.5792300701141357e+02 3.4721401333808899e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0847900062799454e+02 2.5650700926780701e+02 2.5782200694084167e+02) (float-vector 1.8214600160717964e+01 2.5352400541305542e+02 3.5675901174545288e+02) (float-vector -2.2624699771404266e+02 1.6219300031661987e+02 3.5640600323677063e+02) (float-vector -2.2817300260066986e+02 1.7204999923706055e+02 3.3512300252914429e+02) (float-vector -1.6667699813842773e+02 2.2938999533653259e+02 2.6978200674057007e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1289799958467484e+02 2.5895300507545471e+02 2.4237699806690216e+02) (float-vector -1.0847900062799454e+02 2.5650700926780701e+02 2.5782200694084167e+02) (float-vector -1.6667699813842773e+02 2.2938999533653259e+02 2.6978200674057007e+02) (float-vector -1.5021100640296936e+02 2.4489000439643860e+02 2.4304699897766113e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0847900062799454e+02 2.5650700926780701e+02 2.5782200694084167e+02) (float-vector -1.1289799958467484e+02 2.5895300507545471e+02 2.4237699806690216e+02) (float-vector -6.8859599530696869e+01 2.6302999258041382e+02 2.6398399472236633e+02) (float-vector 3.2605599611997604e+01 2.6285400986671448e+02 3.4131899476051331e+02) (float-vector 1.8214600160717964e+01 2.5352400541305542e+02 3.5675901174545288e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7684399485588074e+02 7.3402799665927887e+01 3.3462500572204590e+02) (float-vector 2.7421298623085022e+02 8.1861898303031921e+01 1.0147699713706970e+02) (float-vector 2.8268501162528992e+02 4.5559201389551163e+01 1.1637400090694427e+02) (float-vector 2.8301900625228882e+02 4.3893199414014816e+01 3.3461999893188477e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9964900612831116e+02 2.0538899302482605e+02 3.3475500345230103e+02) (float-vector 2.0368300378322601e+02 2.0001600682735443e+02 9.9780000746250153e+01) (float-vector 2.0694600045681000e+02 1.9147999584674835e+02 3.8100000470876694e+01) (float-vector 2.3350100219249725e+02 1.6275300085544586e+02 6.4379602670669556e+01) (float-vector 2.3823499679565430e+02 1.5913799405097961e+02 3.3468601107597351e+02) (float-vector 2.0873799920082092e+02 1.9221000373363495e+02 3.4727498888969421e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1016000211238861e+02 -1.2353699654340744e+02 1.4264199990066118e-03) (float-vector -1.4497399330139160e+02 -2.4123400449752808e+02 3.8100000470876694e+01) (float-vector -1.1560700088739395e+02 -2.5255399942398071e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4142299592494965e+02 -1.5119099617004395e+02 6.4376600086688995e+01) (float-vector 2.4946700036525726e+02 -1.3204300403594971e+02 3.8100000470876694e+01) (float-vector 2.1565900743007660e+02 -1.8132199347019196e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4946700036525726e+02 -1.3204300403594971e+02 3.8100000470876694e+01) (float-vector 2.7443900704383850e+02 -6.7175298929214478e+01 3.8100000470876694e+01) (float-vector 1.7687499523162842e+02 -1.2380400300025940e+02 2.0675600972026587e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4946700036525726e+02 -1.3204300403594971e+02 3.8100000470876694e+01) (float-vector 1.7687499523162842e+02 -1.2380400300025940e+02 2.0675600972026587e+00) (float-vector 2.1565900743007660e+02 -1.8132199347019196e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1244200170040131e+02 2.5330600142478943e+02 3.8100000470876694e+01) (float-vector -7.8690499067306519e+01 2.5705400109291077e+02 3.8100000470876694e+01) (float-vector -6.3647203147411346e+01 2.6035600900650024e+02 6.4386099576950073e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5776998400688171e+01 2.6264798641204834e+02 1.3745899498462677e+02) (float-vector -6.3647203147411346e+01 2.6035600900650024e+02 6.4386099576950073e+01) (float-vector -7.8690499067306519e+01 2.5705400109291077e+02 3.8100000470876694e+01) (float-vector 3.3288799226284027e+01 2.5835400819778442e+02 3.8100000470876694e+01) (float-vector 1.0053700208663940e+02 2.5811600685119629e+02 6.4517199993133545e+01) (float-vector 5.5121801793575287e+01 2.6267498731613159e+02 1.3758699595928192e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8990500271320343e+02 2.0812200009822845e+02 3.8100000470876694e+01) (float-vector -1.5574799478054047e+02 2.3480199277400970e+02 3.8100000470876694e+01) (float-vector -1.7443999648094177e+02 2.2468400001525879e+02 6.4470700919628143e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7443999648094177e+02 2.2468400001525879e+02 6.4470700919628143e+01) (float-vector -1.5574799478054047e+02 2.3480199277400970e+02 3.8100000470876694e+01) (float-vector -1.4001600444316864e+02 2.4673199653625488e+02 6.4521603286266327e+01) (float-vector -1.5021100640296936e+02 2.4489000439643860e+02 2.4304699897766113e+02) (float-vector -1.8075199425220490e+02 2.2348099946975708e+02 2.6108399033546448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1244200170040131e+02 2.5330600142478943e+02 3.8100000470876694e+01) (float-vector -1.1520200222730637e+02 2.5543698668479919e+02 6.4518496394157410e+01) (float-vector -1.4001600444316864e+02 2.4673199653625488e+02 6.4521603286266327e+01) (float-vector -1.5574799478054047e+02 2.3480199277400970e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3166599869728088e+02 1.2783299386501312e+02 9.8253497853875160e+00) (float-vector -2.2161300480365753e+02 1.7398299276828766e+02 3.8100000470876694e+01) (float-vector -2.4725900590419769e+02 1.3514399528503418e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6613798737525940e+02 9.2731498181819916e+01 3.8100000470876694e+01) (float-vector -2.3166599869728088e+02 1.2783299386501312e+02 9.8253497853875160e+00) (float-vector -2.4725900590419769e+02 1.3514399528503418e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3166599869728088e+02 1.2783299386501312e+02 9.8253497853875160e+00) (float-vector -2.6613798737525940e+02 9.2731498181819916e+01 3.8100000470876694e+01) (float-vector -2.7780199050903320e+02 4.7758601605892181e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6486700773239136e+02 1.0797599703073502e+02 1.0121099650859833e+02) (float-vector 2.6381799578666687e+02 1.1151000112295151e+02 2.4812799692153931e+02) (float-vector 2.3823499679565430e+02 1.5913799405097961e+02 3.3468601107597351e+02) (float-vector 2.3350100219249725e+02 1.6275300085544586e+02 6.4379602670669556e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.3823499679565430e+02 1.5913799405097961e+02 3.3468601107597351e+02) (float-vector 2.6381799578666687e+02 1.1151000112295151e+02 2.4812799692153931e+02) (float-vector 2.7684399485588074e+02 7.3402799665927887e+01 3.3462500572204590e+02) (float-vector 2.6768898963928223e+02 9.3681901693344116e+01 3.4729400277137756e+02) (float-vector 2.4990800023078918e+02 1.3416400551795959e+02 3.4728899598121643e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7266599833965302e+02 2.2269800305366516e+02 3.8100000470876694e+01) (float-vector 1.8201899528503418e+02 1.2674699723720551e+02 5.2517000585794449e+00) (float-vector 2.0694600045681000e+02 1.9147999584674835e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7266599833965302e+02 2.2269800305366516e+02 3.8100000470876694e+01) (float-vector 1.6204699873924255e+02 2.3379500210285187e+02 6.4531296491622925e+01) (float-vector 1.3754899799823761e+02 2.4780699610710144e+02 6.4461901783943176e+01) (float-vector 1.3042700290679932e+02 2.4783399701118469e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4443700015544891e+02 2.4689100682735443e+02 2.1730199456214905e+02) (float-vector 1.6204699873924255e+02 2.3379500210285187e+02 6.4531296491622925e+01) (float-vector 1.7266599833965302e+02 2.2269800305366516e+02 3.8100000470876694e+01) (float-vector 2.0368300378322601e+02 2.0001600682735443e+02 9.9780000746250153e+01) (float-vector 1.9964900612831116e+02 2.0538899302482605e+02 3.3475500345230103e+02) (float-vector 1.5440000593662262e+02 2.4159899353981018e+02 3.3483099937438965e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.7266599833965302e+02 2.2269800305366516e+02 3.8100000470876694e+01) (float-vector 2.0694600045681000e+02 1.9147999584674835e+02 3.8100000470876694e+01) (float-vector 2.0368300378322601e+02 2.0001600682735443e+02 9.9780000746250153e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4791699647903442e+02 1.3489900529384613e+02 3.8100000470876694e+01) (float-vector 2.3350100219249725e+02 1.6275300085544586e+02 6.4379602670669556e+01) (float-vector 2.0694600045681000e+02 1.9147999584674835e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4791699647903442e+02 1.3489900529384613e+02 3.8100000470876694e+01) (float-vector 1.8201899528503418e+02 1.2674699723720551e+02 5.2517000585794449e+00) (float-vector 2.7370300889015198e+02 7.0075400173664093e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.8201899528503418e+02 1.2674699723720551e+02 5.2517000585794449e+00) (float-vector 2.4791699647903442e+02 1.3489900529384613e+02 3.8100000470876694e+01) (float-vector 2.0694600045681000e+02 1.9147999584674835e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6618199646472931e+02 1.2460400164127350e+02 1.4189200783221168e-03) (float-vector 1.8201899528503418e+02 1.2674699723720551e+02 5.2517000585794449e+00) (float-vector 1.7266599833965302e+02 2.2269800305366516e+02 3.8100000470876694e+01) (float-vector 1.3042700290679932e+02 2.4783399701118469e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1244200170040131e+02 2.5330600142478943e+02 3.8100000470876694e+01) (float-vector -2.1357999742031097e+02 1.2468300014734268e+02 1.9819100270979106e-01) (float-vector 1.6618199646472931e+02 1.2460400164127350e+02 1.4189200783221168e-03) (float-vector 1.3042700290679932e+02 2.4783399701118469e+02 3.8100000470876694e+01) (float-vector 1.0020100325345993e+02 2.5543498992919922e+02 3.8100000470876694e+01) (float-vector 3.3288799226284027e+01 2.5835400819778442e+02 3.8100000470876694e+01) (float-vector -7.8690499067306519e+01 2.5705400109291077e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8183001279830933e+02 -1.8743700638879091e-01 3.8100000470876694e+01) (float-vector -2.2859999537467957e+02 -1.2629300355911255e+02 7.1665598079562187e+00) (float-vector -2.2122199833393097e+02 -1.2327300012111664e+02 1.9071099814027548e+00) (float-vector -2.2468000650405884e+02 1.1081700026988983e+02 3.4004999324679375e+00) (float-vector -2.7780199050903320e+02 4.7758601605892181e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1016000211238861e+02 -1.2353699654340744e+02 1.4264199990066118e-03) (float-vector -2.2122199833393097e+02 -1.2327300012111664e+02 1.9071099814027548e+00) (float-vector -2.2859999537467957e+02 -1.2629300355911255e+02 7.1665598079562187e+00) (float-vector -1.7456899583339691e+02 -2.2115099430084229e+02 3.8100000470876694e+01) (float-vector -1.4497399330139160e+02 -2.4123400449752808e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6586500406265259e+02 -1.2411200255155563e+02 5.7080101214523893e-03) (float-vector 1.1189900338649750e+02 -2.5341299176216125e+02 3.8100000470876694e+01) (float-vector 1.4188100397586823e+02 -2.4278399348258972e+02 3.8100000470876694e+01) (float-vector 1.7516699433326721e+02 -2.2074699401855469e+02 3.8100000470876694e+01) (float-vector 1.7687499523162842e+02 -1.2380400300025940e+02 2.0675600972026587e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8265801072120667e+02 1.4392100274562836e+00 3.8100000470876694e+01) (float-vector 2.7370300889015198e+02 7.0075400173664093e+01 3.8100000470876694e+01) (float-vector 1.8201899528503418e+02 1.2674699723720551e+02 5.2517000585794449e+00) (float-vector 1.6618199646472931e+02 1.2460400164127350e+02 1.4189200783221168e-03) (float-vector 1.6586500406265259e+02 -1.2411200255155563e+02 5.7080101214523893e-03) (float-vector 1.7687499523162842e+02 -1.2380400300025940e+02 2.0675600972026587e+00) (float-vector 2.7443900704383850e+02 -6.7175298929214478e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7815599739551544e+01 -2.5707599520683289e+02 3.8100000470876694e+01) (float-vector 1.1189900338649750e+02 -2.5341299176216125e+02 3.8100000470876694e+01) (float-vector 1.6586500406265259e+02 -1.2411200255155563e+02 5.7080101214523893e-03) (float-vector -2.1016000211238861e+02 -1.2353699654340744e+02 1.4264199990066118e-03) (float-vector -1.1560700088739395e+02 -2.5255399942398071e+02 3.8100000470876694e+01) (float-vector -3.3217098563909531e+01 -2.5835499167442322e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2468000650405884e+02 1.1081700026988983e+02 3.4004999324679375e+00) (float-vector -2.2122199833393097e+02 -1.2327300012111664e+02 1.9071099814027548e+00) (float-vector -2.1016000211238861e+02 -1.2353699654340744e+02 1.4264199990066118e-03) (float-vector 1.6586500406265259e+02 -1.2411200255155563e+02 5.7080101214523893e-03) (float-vector 1.6618199646472931e+02 1.2460400164127350e+02 1.4189200783221168e-03) (float-vector -2.1357999742031097e+02 1.2468300014734268e+02 1.9819100270979106e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4946700036525726e+02 -1.3204300403594971e+02 3.8100000470876694e+01) (float-vector 2.6511898636817932e+02 -1.0481999814510345e+02 6.4365498721599579e+01) (float-vector 2.7443900704383850e+02 -6.7175298929214478e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6486700773239136e+02 -1.0797599703073502e+02 1.0121099650859833e+02) (float-vector 2.6511898636817932e+02 -1.0481999814510345e+02 6.4365498721599579e+01) (float-vector 2.4946700036525726e+02 -1.3204300403594971e+02 3.8100000470876694e+01) (float-vector 2.4142299592494965e+02 -1.5119099617004395e+02 6.4376600086688995e+01) (float-vector 2.5301200151443481e+02 -1.3308200240135193e+02 1.0089600086212158e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8265801072120667e+02 1.4392100274562836e+00 3.8100000470876694e+01) (float-vector 2.8343299031257629e+02 3.2855398952960968e+01 6.4442202448844910e+01) (float-vector 2.7370300889015198e+02 7.0075400173664093e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2386400401592255e+02 1.2748399376869202e+02 3.9849299937486649e+00) (float-vector -1.5574799478054047e+02 2.3480199277400970e+02 3.8100000470876694e+01) (float-vector -1.8990500271320343e+02 2.0812200009822845e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2386400401592255e+02 1.2748399376869202e+02 3.9849299937486649e+00) (float-vector -2.2468000650405884e+02 1.1081700026988983e+02 3.4004999324679375e+00) (float-vector -2.1357999742031097e+02 1.2468300014734268e+02 1.9819100270979106e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5574799478054047e+02 2.3480199277400970e+02 3.8100000470876694e+01) (float-vector -2.2386400401592255e+02 1.2748399376869202e+02 3.9849299937486649e+00) (float-vector -2.1357999742031097e+02 1.2468300014734268e+02 1.9819100270979106e-01) (float-vector -1.1244200170040131e+02 2.5330600142478943e+02 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2386400401592255e+02 1.2748399376869202e+02 3.9849299937486649e+00) (float-vector -1.8990500271320343e+02 2.0812200009822845e+02 3.8100000470876694e+01) (float-vector -2.2161300480365753e+02 1.7398299276828766e+02 3.8100000470876694e+01) (float-vector -2.3166599869728088e+02 1.2783299386501312e+02 9.8253497853875160e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2386400401592255e+02 1.2748399376869202e+02 3.9849299937486649e+00) (float-vector -2.3166599869728088e+02 1.2783299386501312e+02 9.8253497853875160e+00) (float-vector -2.7780199050903320e+02 4.7758601605892181e+01 3.8100000470876694e+01) (float-vector -2.2468000650405884e+02 1.1081700026988983e+02 3.4004999324679375e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6539701223373413e+02 1.0412299633026123e+02 6.4365297555923462e+01) (float-vector 2.4791699647903442e+02 1.3489900529384613e+02 3.8100000470876694e+01) (float-vector 2.7370300889015198e+02 7.0075400173664093e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4791699647903442e+02 1.3489900529384613e+02 3.8100000470876694e+01) (float-vector 2.6539701223373413e+02 1.0412299633026123e+02 6.4365297555923462e+01) (float-vector 2.6486700773239136e+02 1.0797599703073502e+02 1.0121099650859833e+02) (float-vector 2.3350100219249725e+02 1.6275300085544586e+02 6.4379602670669556e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6381799578666687e+02 1.1151000112295151e+02 2.4812799692153931e+02) (float-vector 2.6486700773239136e+02 1.0797599703073502e+02 1.0121099650859833e+02) (float-vector 2.6539701223373413e+02 1.0412299633026123e+02 6.4365297555923462e+01) (float-vector 2.7421298623085022e+02 8.1861898303031921e+01 1.0147699713706970e+02) (float-vector 2.7684399485588074e+02 7.3402799665927887e+01 3.3462500572204590e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.6539701223373413e+02 1.0412299633026123e+02 6.4365297555923462e+01) (float-vector 2.7370300889015198e+02 7.0075400173664093e+01 3.8100000470876694e+01) (float-vector 2.8343299031257629e+02 3.2855398952960968e+01 6.4442202448844910e+01) (float-vector 2.8268501162528992e+02 4.5559201389551163e+01 1.1637400090694427e+02) (float-vector 2.7421298623085022e+02 8.1861898303031921e+01 1.0147699713706970e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8301900625228882e+02 4.3893199414014816e+01 3.3461999893188477e+02) (float-vector 2.8268501162528992e+02 4.5559201389551163e+01 1.1637400090694427e+02) (float-vector 2.8343299031257629e+02 3.2855398952960968e+01 6.4442202448844910e+01) (float-vector 2.8265801072120667e+02 1.4392100274562836e+00 3.8100000470876694e+01) (float-vector 2.8639999032020569e+02 0.0000000000000000e+00 1.0186100006103516e+02) (float-vector 2.8639900684356689e+02 -5.8955798158422112e-01 3.3461800217628479e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8639900684356689e+02 -5.8955798158422112e-01 3.3461800217628479e+02) (float-vector 2.8639999032020569e+02 0.0000000000000000e+00 1.0186100006103516e+02) (float-vector 2.8503599762916565e+02 -2.7614800259470940e+01 1.0181400179862976e+02) (float-vector 2.8153198957443237e+02 -5.2600301802158356e+01 3.3462101221084595e+02) (float-vector 2.8269499540328979e+02 -2.2507999092340469e+01 3.4729701280593872e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8338900208473206e+02 -3.3171601593494415e+01 6.4353600144386292e+01) (float-vector 2.8265801072120667e+02 1.4392100274562836e+00 3.8100000470876694e+01) (float-vector 2.7443900704383850e+02 -6.7175298929214478e+01 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8503599762916565e+02 -2.7614800259470940e+01 1.0181400179862976e+02) (float-vector 2.8338900208473206e+02 -3.3171601593494415e+01 6.4353600144386292e+01) (float-vector 2.7961900830268860e+02 -6.0485400259494781e+01 1.2046200037002563e+02) (float-vector 2.8153198957443237e+02 -5.2600301802158356e+01 3.3462101221084595e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8338900208473206e+02 -3.3171601593494415e+01 6.4353600144386292e+01) (float-vector 2.8503599762916565e+02 -2.7614800259470940e+01 1.0181400179862976e+02) (float-vector 2.8639999032020569e+02 0.0000000000000000e+00 1.0186100006103516e+02) (float-vector 2.8265801072120667e+02 1.4392100274562836e+00 3.8100000470876694e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8338900208473206e+02 -3.3171601593494415e+01 6.4353600144386292e+01) (float-vector 2.7443900704383850e+02 -6.7175298929214478e+01 3.8100000470876694e+01) (float-vector 2.6511898636817932e+02 -1.0481999814510345e+02 6.4365498721599579e+01) (float-vector 2.6486700773239136e+02 -1.0797599703073502e+02 1.0121099650859833e+02) (float-vector 2.7961900830268860e+02 -6.0485400259494781e+01 1.2046200037002563e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_base_link_WubG3f.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_laser_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 2.3500000000000000e+02 0.0000000000000000e+00 2.8780000000000001e+02)
                                    :rot (quaternion2matrix (float-vector -1.0286788442024686e-13 1.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00)))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.396078 0.409804 0.466667 1.000000))
                    (list :diffuse (float-vector 0.792157 0.819608 0.933333 1.000000))))
                   (list :indices #i( 0 1 2 2 7 0 0 7 1 2 1 3 6 5 1 1 5 3 1 7 6 4 2 5 5 2 3 4 7 2 4 6 7 5 6 4 8 9 10 22 9 8 22 8 23 23 8 10 10 9 11 21 11 9 21 9 22 10 11 12 23 10 24 24 10 12 24 40 23 23 40 41 23 41 22 22 41 42 22 42 21 20 11 21 21 42 43 21 43 20 117 43 42 117 42 118 118 42 41 118 41 119 119 41 40 106 117 118 106 118 107 107 118 119 105 116 117 105 117 106 116 43 117 20 43 32 116 32 43 104 116 105 104 127 116 127 32 116 93 104 105 93 105 94 94 105 106 92 104 93 92 115 104 115 127 104 115 126 127 126 33 127 127 33 32 103 114 115 103 115 92 114 126 115 80 92 81 81 92 93 80 103 92 91 102 103 91 103 80 102 114 103 102 113 114 113 125 114 114 125 126 90 101 102 90 102 91 101 113 102 79 90 91 79 91 68 68 91 80 78 89 90 78 90 79 89 101 90 89 100 101 100 112 101 101 112 113 77 88 89 77 89 78 88 100 89 65 77 78 65 78 67 67 78 79 63 76 77 63 77 65 76 88 77 76 87 88 87 99 88 88 99 100 61 75 76 61 76 63 75 87 76 62 61 63 62 63 64 64 63 65 60 59 61 60 61 62 59 75 61 59 74 75 74 86 75 75 86 87 58 57 59 58 59 60 57 74 59 62 131 60 60 131 132 60 132 58 56 57 58 58 132 133 58 133 56 56 55 57 55 73 57 57 73 74 54 55 56 56 133 134 56 134 54 132 197 133 133 197 198 133 198 134 54 134 135 134 198 199 134 199 135 52 53 54 54 53 55 54 135 52 52 135 136 135 188 136 135 199 188 265 199 266 266 199 198 265 188 199 136 188 189 276 189 188 276 188 265 52 136 50 50 136 137 136 189 137 137 189 190 275 190 189 275 189 276 50 137 48 48 137 138 137 190 138 48 49 50 50 49 51 50 51 52 46 47 48 48 47 49 48 138 46 46 138 139 138 190 191 138 191 139 44 45 46 46 45 47 46 139 44 45 68 47 47 68 69 47 69 49 44 67 45 67 79 45 45 79 68 66 67 44 44 128 66 44 139 128 66 65 67 64 65 66 66 128 129 66 129 64 139 192 128 128 192 193 128 193 129 64 129 130 129 193 194 129 194 130 64 130 62 62 130 131 130 194 195 130 195 131 270 195 194 270 194 271 271 194 193 271 193 272 272 193 192 272 192 273 330 271 272 330 272 331 331 272 273 328 271 330 331 736 330 330 736 737 330 737 328 331 273 332 332 735 331 331 735 736 735 824 736 736 824 823 736 823 737 328 737 732 737 823 822 737 822 732 566 822 823 566 823 564 564 823 824 564 824 562 562 824 825 735 825 824 562 563 564 564 563 565 564 565 566 566 565 567 566 567 568 568 822 566 563 582 565 565 582 583 565 583 567 562 561 563 561 581 563 563 581 582 581 593 582 582 593 594 582 594 583 567 583 584 583 594 595 583 595 584 593 605 594 594 605 606 594 606 595 581 592 593 592 604 593 593 604 605 604 616 605 605 616 617 605 617 606 595 606 607 606 617 618 606 618 607 616 628 617 617 628 629 617 629 618 604 615 616 615 627 616 616 627 628 627 311 628 628 311 310 628 310 629 618 629 630 629 310 309 629 309 630 227 309 310 227 310 226 226 310 311 226 311 225 225 311 312 627 312 311 225 171 226 226 171 166 226 166 227 227 166 173 227 173 228 228 309 227 172 173 174 174 173 166 228 173 172 228 172 229 229 308 228 228 308 309 229 172 174 174 166 175 229 174 230 230 174 175 230 307 229 229 307 308 630 309 308 630 308 631 631 308 307 230 306 307 631 307 632 632 307 306 230 175 231 231 306 230 175 166 167 231 175 167 231 167 232 232 305 231 231 305 306 632 306 633 633 306 305 232 304 305 633 305 634 634 305 304 232 167 165 232 165 233 233 304 232 166 165 167 164 165 166 233 165 164 233 164 234 234 303 233 233 303 304 634 304 635 635 304 303 234 302 303 635 303 636 636 303 302 234 164 168 234 168 235 235 302 234 168 164 169 169 164 166 235 168 169 235 169 224 224 301 235 235 301 302 636 302 637 637 302 301 224 312 301 637 301 626 626 301 312 224 170 225 224 169 170 225 312 224 169 166 170 170 166 171 225 170 171 626 312 627 614 626 615 615 626 627 614 637 626 602 614 603 603 614 615 602 625 614 625 637 614 603 615 604 591 602 603 591 603 592 592 603 604 590 602 591 590 613 602 613 625 602 613 624 625 624 636 625 625 636 637 601 612 613 601 613 590 612 624 613 612 623 624 623 635 624 624 635 636 600 611 612 600 612 601 611 623 612 589 600 601 589 601 578 578 601 590 588 599 600 588 600 589 599 611 600 599 610 611 610 622 611 611 622 623 587 598 599 587 599 588 598 610 599 575 587 588 575 588 577 577 588 589 573 586 587 573 587 575 586 598 587 586 597 598 597 609 598 598 609 610 571 585 586 571 586 573 585 597 586 572 571 573 572 573 574 574 573 575 570 569 571 570 571 572 569 585 571 569 584 585 584 596 585 585 596 597 568 567 569 568 569 570 567 584 569 572 820 570 570 820 821 570 821 568 568 821 822 732 822 821 732 821 249 249 821 250 250 821 820 732 249 329 328 732 329 248 249 250 329 249 248 248 250 251 251 250 252 250 820 252 329 248 271 271 248 251 271 328 329 271 251 253 253 255 271 271 255 260 271 260 270 251 252 253 253 252 254 252 820 848 252 848 254 253 254 255 255 254 256 255 256 257 255 257 260 254 848 847 254 847 256 729 847 848 729 848 730 730 848 842 848 820 842 572 819 820 842 820 819 842 843 722 730 842 727 727 842 722 842 819 843 860 843 861 861 843 819 843 860 722 722 860 884 884 860 861 861 819 862 862 969 861 861 969 887 861 887 884 722 884 885 884 887 885 881 885 887 969 990 887 887 990 991 887 991 881 862 968 969 968 989 969 969 989 990 989 893 990 990 893 895 990 895 991 881 991 882 991 895 890 991 890 882 893 894 895 895 894 896 895 896 890 889 883 890 890 896 897 890 897 889 882 890 883 881 882 883 722 881 883 722 883 880 880 883 886 889 886 883 885 881 722 722 723 724 724 725 722 722 725 726 722 726 727 880 723 722 880 886 889 889 723 880 723 992 724 889 992 723 897 992 889 724 992 993 897 1003 992 1003 1019 992 992 1019 1020 992 1020 993 896 1003 897 896 894 1003 893 892 894 1003 894 892 891 892 893 891 893 898 898 893 899 989 899 893 1003 892 1002 1002 892 891 1002 891 898 898 899 900 1002 898 1001 1001 898 900 900 899 901 988 901 899 988 899 989 968 988 989 967 987 988 967 988 968 987 901 988 900 901 902 902 901 903 987 903 901 1001 900 902 902 903 904 904 1001 902 907 908 903 903 908 909 903 909 904 986 907 903 986 903 987 966 986 987 966 987 967 965 985 986 965 986 966 985 907 986 871 965 966 871 966 858 858 966 967 872 964 965 872 965 871 964 985 965 964 984 985 984 905 985 985 905 907 859 963 964 859 964 872 963 984 964 871 744 872 872 744 859 748 853 859 748 859 743 743 859 744 853 963 859 853 962 963 962 983 963 963 983 984 853 839 854 747 839 853 747 853 748 854 962 853 854 961 962 961 982 962 962 982 983 982 912 983 983 912 914 983 914 984 961 981 982 981 918 982 982 918 912 960 980 981 960 981 961 980 920 981 981 920 918 917 912 918 917 918 919 919 918 920 919 920 921 921 920 922 980 922 920 959 979 980 959 980 960 979 922 980 868 958 959 868 959 867 867 959 960 958 979 959 958 978 979 978 926 979 979 926 922 865 957 958 865 958 868 957 978 958 867 763 868 868 763 865 863 758 867 867 758 763 867 960 863 348 762 763 348 763 347 347 763 758 762 865 763 346 758 759 347 758 346 863 759 758 346 276 347 347 276 265 347 265 348 346 358 276 276 358 359 276 359 275 346 357 358 357 751 358 358 751 752 358 752 359 275 359 360 359 752 753 359 753 360 274 190 275 275 360 274 274 360 361 360 753 754 360 754 361 832 754 753 832 753 833 833 753 752 361 754 755 755 754 832 274 361 344 361 755 344 344 755 756 832 831 755 755 831 830 830 756 755 274 344 345 344 756 345 345 756 749 830 749 756 660 829 830 660 830 658 658 830 831 829 749 830 658 831 656 656 831 832 656 657 658 658 657 659 658 659 660 654 655 656 656 655 657 656 832 654 654 832 833 652 653 654 654 653 655 654 833 652 653 669 655 655 669 670 655 670 657 652 651 653 651 668 653 653 668 669 650 651 652 652 833 834 652 834 650 833 752 834 650 834 835 834 752 751 834 751 835 648 649 650 650 649 651 650 835 648 648 835 836 835 751 750 835 750 836 357 750 751 757 750 356 356 750 357 836 750 757 648 836 646 646 836 837 836 757 837 383 761 757 383 757 356 837 757 761 356 357 346 346 383 356 346 382 383 382 761 383 382 760 761 837 761 854 854 761 760 381 382 346 381 760 382 346 759 381 381 759 760 854 760 863 760 759 863 854 839 838 854 838 837 863 961 854 863 960 961 646 837 644 644 837 838 644 838 642 642 838 839 642 643 644 644 643 645 644 645 646 646 645 647 646 647 648 643 664 645 645 664 665 645 665 647 642 641 643 641 663 643 643 663 664 663 675 664 664 675 676 664 676 665 647 665 666 665 676 677 665 677 666 675 687 676 676 687 688 676 688 677 663 674 675 674 686 675 675 686 687 686 698 687 687 698 699 687 699 688 677 688 689 688 699 700 688 700 689 698 710 699 699 710 711 699 711 700 686 709 698 709 721 698 698 721 710 710 324 711 721 313 710 710 313 324 700 711 712 711 324 323 711 323 712 237 323 324 237 324 236 236 324 313 236 313 247 247 313 314 721 314 313 236 184 237 247 182 236 236 182 184 237 184 186 237 186 238 238 323 237 182 183 184 184 183 185 186 184 187 187 184 185 247 183 182 246 185 183 246 183 247 247 314 246 245 185 246 246 314 315 246 315 245 187 185 178 178 185 179 245 179 185 238 186 187 238 187 239 239 187 178 176 177 178 178 179 176 239 178 240 240 178 177 240 321 239 239 321 322 239 322 238 240 177 241 241 320 240 240 320 321 241 177 176 241 176 242 242 319 241 241 319 320 714 321 320 714 320 715 715 320 319 242 318 319 715 319 716 716 319 318 242 176 181 242 181 243 243 318 242 243 317 318 716 318 717 717 318 317 704 715 716 704 716 705 705 716 717 705 717 706 706 717 718 717 317 718 244 316 317 244 317 243 718 317 316 706 718 707 707 718 719 718 316 719 694 705 706 694 706 695 695 706 707 695 707 696 696 707 708 707 719 708 708 719 720 719 316 315 719 315 720 696 708 697 697 708 709 708 720 709 684 695 696 684 696 685 685 696 697 685 697 674 674 697 686 697 709 686 709 720 721 720 314 721 720 315 314 245 315 316 244 179 245 245 316 244 243 180 244 244 180 179 179 180 181 176 179 181 243 181 180 662 674 663 662 685 674 639 662 641 641 662 663 639 673 662 673 685 662 673 684 685 661 672 673 661 673 639 672 684 673 638 639 640 640 639 641 638 661 639 640 641 642 642 839 640 640 839 840 640 840 638 660 661 638 638 829 660 638 840 829 747 746 840 840 746 745 840 745 829 840 839 747 829 745 749 378 745 746 749 745 384 384 745 378 378 746 379 379 746 747 379 747 380 380 747 748 378 379 380 369 384 378 369 378 385 385 378 380 345 384 369 345 749 384 369 274 345 368 274 369 369 743 744 369 744 368 385 743 369 380 748 385 385 748 743 366 273 368 368 273 274 368 744 739 368 739 366 273 191 274 274 191 190 273 192 191 366 332 273 139 191 192 367 332 366 367 734 332 332 734 735 366 365 367 367 733 734 365 733 367 733 826 734 734 826 825 734 825 735 738 733 365 738 828 733 733 828 827 733 827 826 560 825 826 560 826 558 558 826 827 562 825 560 558 559 560 560 559 561 560 561 562 556 557 558 558 557 559 558 827 556 556 827 828 554 555 556 556 555 557 556 828 554 555 578 557 557 578 579 557 579 559 559 579 580 559 580 561 561 580 581 579 591 580 580 591 592 580 592 581 578 590 579 579 590 591 555 589 578 577 589 555 554 577 555 576 575 577 576 577 554 574 575 576 554 817 576 576 817 818 576 818 574 554 828 817 855 818 817 855 817 828 574 818 819 862 819 818 862 818 855 574 819 572 742 741 855 855 741 858 742 855 738 738 855 828 858 967 855 855 967 968 855 968 862 362 741 742 362 742 363 363 742 738 363 738 365 362 363 364 364 363 365 364 741 362 364 365 366 366 740 364 364 740 741 366 739 740 741 740 858 858 740 739 858 739 871 871 739 744 660 659 661 657 671 659 659 671 672 659 672 661 657 670 671 670 682 671 671 682 683 671 683 672 672 683 684 682 694 683 683 694 695 683 695 684 670 681 682 681 693 682 682 693 694 669 681 670 669 680 681 680 692 681 681 692 693 692 704 693 693 704 705 693 705 694 680 691 692 691 703 692 692 703 704 668 679 680 668 680 669 679 691 680 679 690 691 690 702 691 691 702 703 702 714 703 703 714 715 703 715 704 690 701 702 701 713 702 702 713 714 678 689 690 678 690 679 689 701 690 689 700 701 700 712 701 701 712 713 712 322 713 713 322 321 713 321 714 712 323 322 238 322 323 677 689 678 666 677 678 647 666 649 649 666 667 666 678 667 648 647 649 649 667 651 651 667 668 667 678 679 667 679 668 348 265 335 348 335 349 372 371 348 372 348 373 373 348 349 371 762 348 768 764 349 349 764 373 335 768 349 373 764 765 373 765 372 768 814 764 764 814 813 813 765 764 335 775 768 775 815 768 768 815 814 476 813 814 476 814 474 474 814 815 474 815 472 472 815 816 775 816 815 472 473 474 474 473 475 474 475 476 476 475 477 476 477 478 478 813 476 473 495 475 475 495 496 475 496 477 472 471 473 471 494 473 473 494 495 494 506 495 495 506 507 495 507 496 477 496 497 496 507 508 496 508 497 506 518 507 507 518 519 507 519 508 494 517 506 517 529 506 506 529 518 518 530 519 529 541 518 518 541 530 508 519 520 519 530 531 519 531 520 530 542 531 541 553 530 530 553 542 529 540 541 540 552 541 541 552 553 552 290 553 553 290 289 553 289 542 531 542 543 542 300 543 542 289 300 212 289 223 223 289 290 212 300 289 223 290 222 222 290 291 552 291 290 222 157 223 223 157 156 223 156 212 212 155 213 212 156 155 213 300 212 155 156 157 157 152 155 222 152 157 221 152 222 222 291 221 152 153 154 155 152 154 221 153 152 155 154 158 213 155 158 213 158 214 214 299 213 213 299 300 214 158 163 214 163 215 215 298 214 214 298 299 543 300 299 543 299 544 544 299 298 215 297 298 544 298 545 545 298 297 215 163 162 215 162 216 216 297 215 158 162 163 158 161 162 216 162 161 216 161 217 217 296 216 216 296 297 545 297 546 546 297 296 217 295 296 546 296 547 547 296 295 217 161 160 217 160 218 218 295 217 160 161 158 158 159 160 218 160 159 158 154 159 218 159 219 219 159 154 219 294 218 218 294 295 547 295 548 548 295 294 219 293 294 548 294 549 549 294 293 219 154 220 220 293 219 220 154 153 220 153 221 221 292 220 220 292 293 549 293 550 550 293 292 537 548 549 537 549 538 538 549 550 538 550 539 539 550 551 550 292 551 221 291 292 551 292 291 539 551 540 540 551 552 551 291 552 527 538 539 527 539 528 528 539 540 526 537 538 526 538 527 515 526 527 515 527 516 516 527 528 516 528 517 517 528 529 528 540 529 504 515 516 504 516 505 505 516 517 503 514 515 503 515 504 514 526 515 491 503 504 491 504 493 493 504 505 493 505 471 471 505 494 505 517 494 492 491 493 492 493 470 470 493 471 490 489 491 490 491 492 489 503 491 470 805 492 492 805 806 492 806 490 470 471 472 472 816 470 470 816 805 805 816 775 334 774 775 334 775 335 805 775 774 333 334 265 265 334 335 333 774 334 333 773 774 774 773 805 333 265 336 336 773 333 336 265 266 336 266 337 337 772 336 336 772 773 805 773 772 337 771 772 805 772 806 806 772 771 337 266 267 337 267 338 338 771 337 266 198 267 267 198 197 267 197 268 327 338 267 327 267 353 353 267 268 326 338 327 326 770 338 338 770 771 325 326 327 326 769 770 325 769 326 807 771 770 807 770 808 808 770 809 770 769 809 776 769 325 809 769 776 486 808 809 486 809 484 484 809 810 809 776 810 488 807 808 488 808 486 484 485 486 486 485 487 486 487 488 482 483 484 484 483 485 484 810 482 482 810 811 810 776 856 810 856 811 480 481 482 482 481 483 482 811 480 481 499 483 483 499 500 483 500 485 480 479 481 479 498 481 481 498 499 478 479 480 480 811 812 480 812 478 478 477 479 477 497 479 479 497 498 497 509 498 498 509 510 498 510 499 497 508 509 508 520 509 509 520 521 509 521 510 499 510 511 510 521 522 510 522 511 520 532 521 521 532 533 521 533 522 520 531 532 531 543 532 532 543 544 532 544 533 522 533 534 533 544 545 533 545 534 511 522 523 522 534 523 523 534 535 534 545 546 534 546 535 511 523 512 512 523 524 523 535 524 524 535 536 535 546 547 535 547 536 512 524 513 513 524 525 524 536 525 500 511 512 500 512 501 501 512 513 501 513 502 502 513 514 513 525 514 514 525 526 525 536 537 525 537 526 502 514 503 487 501 502 487 502 489 489 502 503 485 500 501 485 501 487 488 487 489 488 489 490 490 807 488 490 806 807 806 771 807 499 511 500 536 548 537 536 547 548 478 812 813 811 864 812 812 864 766 812 766 813 813 766 765 372 765 766 372 766 370 370 766 767 766 864 767 370 371 372 370 767 371 371 767 762 767 864 865 767 865 762 864 957 865 864 956 957 956 977 957 957 977 978 856 955 956 856 956 864 955 976 956 956 976 977 976 933 977 977 933 924 977 924 978 978 924 926 924 925 926 933 934 924 924 934 935 924 935 925 931 932 933 933 932 934 976 931 933 1008 935 934 1008 934 932 995 925 935 995 935 1008 926 925 927 927 925 995 926 927 922 922 927 928 928 927 994 994 927 995 921 922 923 922 928 923 994 923 928 994 921 923 996 921 994 995 1009 994 994 1009 1010 994 1010 996 996 919 921 997 917 996 996 917 919 996 1010 1011 996 1011 997 1035 1011 1010 1035 1010 1036 1036 1010 1009 997 1011 1012 1034 1012 1011 1034 1011 1035 1057 1034 1035 1057 1035 1058 1058 1035 1036 1036 1009 1037 1058 1036 1059 1059 1036 1037 1084 1057 1058 1084 1058 1066 1066 1058 1059 1056 1034 1057 1083 1056 1057 1083 1057 1084 1066 1100 1084 1084 1100 1101 1084 1101 1083 1066 1059 1067 1067 1099 1066 1066 1099 1100 1113 1101 1100 1113 1100 1114 1114 1100 1099 1083 1101 1102 1112 1102 1101 1112 1101 1113 1144 1112 1113 1144 1113 1125 1125 1113 1114 1114 1099 1115 1125 1114 1126 1126 1114 1115 1125 1145 1144 1126 1164 1125 1125 1164 1145 1143 1112 1144 1144 1145 1146 1144 1146 1143 1176 1146 1145 1176 1145 1177 1177 1145 1164 1126 1163 1164 1177 1164 1178 1178 1164 1163 1184 1177 1185 1185 1177 1178 1184 1176 1177 1175 1146 1176 1202 1175 1176 1202 1176 1184 1207 1202 1184 1207 1184 1208 1208 1184 1185 1185 1178 1186 1208 1185 1209 1209 1185 1186 1186 1178 1179 1186 1179 1187 1209 1186 1210 1210 1186 1187 1178 1163 1179 1179 1163 1162 1179 1162 1180 1187 1179 1180 1187 1180 1188 1210 1187 1211 1211 1187 1188 1180 1162 1161 1180 1161 1181 1188 1180 1181 1128 1161 1162 1128 1162 1127 1127 1162 1163 1127 1163 1126 1126 1115 1127 1127 1115 1116 1127 1116 1128 1128 1116 1117 1128 1117 1129 1129 1161 1128 1115 1098 1116 1116 1098 1097 1116 1097 1117 1115 1099 1098 1068 1097 1098 1068 1098 1067 1067 1098 1099 1069 1096 1097 1069 1097 1068 1117 1097 1096 1067 1060 1068 1068 1060 1061 1068 1061 1069 1067 1059 1060 1059 1037 1060 1060 1037 1038 1060 1038 1061 1061 1038 1039 1061 1039 1062 1069 1061 1062 1037 1027 1038 1038 1027 1026 1038 1026 1039 1037 1009 1027 995 1026 1027 995 1027 1009 1008 1025 1026 1008 1026 995 1039 1026 1025 1039 1025 1040 1062 1039 1040 1007 1024 1025 1007 1025 1008 1040 1025 1024 1008 932 1007 931 930 932 1007 932 930 929 930 931 929 931 936 936 931 937 975 937 931 975 931 976 1007 930 929 936 1007 929 936 937 938 938 1006 936 936 1006 1007 938 937 939 974 939 937 974 937 975 954 974 975 954 975 955 955 975 976 953 973 974 953 974 954 973 939 974 938 939 940 940 939 941 973 941 939 940 1006 938 940 941 942 942 1005 940 940 1005 1006 941 949 942 942 949 1005 947 948 941 941 948 949 972 947 941 972 941 973 1005 949 948 947 946 948 1005 948 1004 1004 948 946 943 946 947 971 943 947 971 947 972 951 971 972 951 972 952 952 972 973 950 970 971 950 971 951 970 943 971 852 950 951 852 951 866 866 951 952 866 952 870 870 952 953 952 973 953 786 852 866 786 866 781 781 866 782 870 782 866 869 782 870 870 953 869 869 953 954 857 777 869 869 777 782 869 954 857 354 781 782 354 782 353 353 782 777 375 786 781 375 781 354 374 375 376 376 375 354 374 786 375 376 785 374 374 785 786 376 354 377 377 784 376 376 784 785 798 785 784 798 797 785 785 797 852 785 852 786 377 783 784 783 800 784 784 800 799 784 799 798 377 354 355 355 783 377 787 783 355 783 787 800 354 343 355 343 787 355 353 268 354 354 268 343 268 342 343 342 792 343 343 792 787 800 787 792 342 791 792 800 792 801 801 792 791 268 341 342 341 791 342 268 197 196 268 196 269 269 341 268 269 340 341 340 790 341 341 790 791 801 791 802 802 791 790 340 789 790 802 790 803 803 790 789 270 339 340 270 340 269 339 789 340 269 196 195 269 195 270 264 339 270 270 260 262 270 262 264 339 788 789 264 788 339 262 263 264 263 788 264 260 261 262 262 261 263 257 259 260 260 259 261 263 261 793 793 261 259 793 804 263 804 788 263 804 789 788 388 803 804 388 804 386 386 804 793 803 789 804 386 387 388 388 387 389 388 389 390 390 803 388 390 802 803 390 389 391 390 391 392 392 802 390 387 410 389 389 410 411 389 411 391 392 391 393 391 411 412 391 412 393 392 393 394 394 801 392 392 801 802 394 393 395 393 412 413 393 413 395 411 423 412 412 423 424 412 424 413 395 413 414 413 424 425 413 425 414 394 395 396 396 395 397 395 414 397 397 414 415 414 425 426 414 426 415 424 436 425 425 436 437 425 437 426 415 426 427 426 437 438 426 438 427 397 415 399 399 415 416 415 427 416 416 427 428 427 438 439 427 439 428 437 449 438 438 449 450 438 450 439 428 439 440 439 450 451 439 451 440 416 428 417 417 428 429 428 440 429 429 440 441 440 451 452 440 452 441 450 462 451 451 462 463 451 463 452 441 452 453 452 463 464 452 464 453 429 441 430 430 441 442 441 453 442 442 453 454 453 464 465 453 465 454 463 283 464 464 283 282 464 282 465 454 465 466 465 282 281 465 281 466 442 454 443 443 454 455 454 466 455 455 466 467 466 281 280 466 280 467 208 280 281 208 281 207 207 281 282 209 279 280 209 280 208 467 280 279 455 467 456 456 467 468 467 279 468 210 278 279 210 279 209 468 279 278 208 144 209 209 144 143 209 143 210 210 143 146 210 146 211 211 278 210 211 277 278 468 278 469 469 278 277 211 146 145 211 145 200 200 277 211 145 146 143 143 144 140 143 140 145 208 140 144 140 141 142 145 140 142 207 141 140 207 140 208 145 142 150 200 145 150 150 142 149 150 149 151 200 150 201 201 150 151 142 148 149 202 151 149 202 149 203 203 149 148 201 151 202 202 287 201 201 287 288 201 288 200 203 286 202 202 286 287 203 148 204 204 285 203 203 285 286 460 287 286 460 286 461 461 286 285 459 288 287 459 287 460 448 459 460 448 460 449 449 460 461 449 461 450 450 461 462 461 285 462 204 284 285 462 285 284 462 284 463 205 283 284 205 284 204 463 284 283 204 147 205 205 147 142 205 142 206 206 283 205 206 282 283 206 142 141 206 141 207 207 282 206 147 148 142 204 148 147 437 448 449 436 448 437 436 447 448 447 459 448 424 435 436 435 447 436 435 446 447 446 458 447 447 458 459 458 288 459 446 469 458 469 277 458 458 277 288 434 446 435 434 457 446 457 469 446 423 434 435 423 435 424 422 434 423 422 445 434 445 457 434 445 456 457 456 468 457 457 468 469 433 444 445 433 445 422 444 456 445 410 422 411 411 422 423 410 433 422 421 432 433 421 433 410 432 444 433 432 443 444 443 455 444 444 455 456 420 431 432 420 432 421 431 443 432 409 420 421 409 421 387 387 421 410 407 419 420 407 420 409 419 431 420 419 430 431 430 442 431 431 442 443 405 418 419 405 419 407 418 430 419 406 405 407 406 407 408 408 407 409 404 403 405 404 405 406 403 418 405 403 417 418 417 429 418 418 429 430 402 401 403 402 403 404 401 417 403 406 795 404 404 795 796 404 796 402 400 401 402 402 796 797 402 797 400 400 399 401 399 416 401 401 416 417 398 399 400 400 797 798 400 798 398 796 852 797 795 851 796 796 851 852 851 950 852 795 850 851 850 888 851 851 888 950 888 970 950 877 878 888 850 877 888 878 879 888 888 879 970 879 876 970 970 876 943 878 841 879 879 841 876 877 849 878 878 849 841 849 877 850 841 849 850 726 725 841 841 844 726 841 850 844 725 724 841 841 724 873 873 874 841 841 874 875 841 875 876 726 844 845 845 844 794 794 844 850 794 850 795 408 793 794 408 794 406 406 794 795 794 793 845 408 409 386 386 793 408 793 259 845 257 258 259 845 259 258 256 258 257 845 258 846 846 258 256 728 846 256 728 256 729 256 847 729 731 845 846 731 846 728 728 729 730 730 731 728 730 726 731 726 845 731 727 726 730 386 409 387 876 875 943 943 875 874 874 945 943 943 945 946 873 944 874 874 944 945 944 993 945 945 993 1004 1004 946 945 873 724 944 944 724 993 993 1020 1021 993 1021 1004 1004 1021 1022 1004 1022 1005 1043 1022 1021 1043 1021 1044 1044 1021 1020 1044 1020 1045 1045 1020 1019 1047 1044 1048 1048 1044 1045 1047 1043 1044 1042 1022 1043 1065 1042 1043 1065 1043 1047 1073 1065 1047 1073 1047 1074 1074 1047 1048 1048 1045 1049 1074 1048 1075 1075 1048 1049 1075 1091 1074 1074 1091 1092 1074 1092 1073 1072 1065 1073 1073 1092 1093 1073 1093 1072 1121 1093 1092 1121 1092 1122 1122 1092 1091 1075 1090 1091 1122 1091 1123 1123 1091 1090 1133 1121 1122 1133 1122 1134 1134 1122 1123 1120 1093 1121 1132 1120 1121 1132 1121 1133 1134 1156 1133 1133 1156 1157 1133 1157 1132 1134 1123 1135 1135 1155 1134 1134 1155 1156 1165 1157 1156 1165 1156 1166 1166 1156 1155 1132 1157 1158 1158 1157 1165 1131 1120 1132 1132 1158 1131 1131 1158 1159 1183 1159 1158 1183 1158 1165 1191 1183 1165 1191 1165 1192 1192 1165 1166 1182 1159 1183 1190 1182 1183 1190 1183 1191 1131 1159 1130 1130 1159 1160 1182 1160 1159 1181 1160 1182 1189 1181 1182 1189 1182 1190 1130 1160 1129 1129 1160 1161 1181 1161 1160 1129 1118 1130 1130 1118 1119 1130 1119 1131 1129 1117 1118 1117 1096 1118 1118 1096 1095 1118 1095 1119 1119 1095 1094 1119 1094 1120 1131 1119 1120 1071 1094 1095 1071 1095 1070 1070 1095 1096 1070 1096 1069 1069 1062 1070 1070 1062 1063 1070 1063 1071 1071 1063 1064 1071 1064 1072 1072 1094 1071 1062 1040 1063 1063 1040 1041 1063 1041 1064 1064 1041 1042 1064 1042 1065 1072 1064 1065 1072 1093 1094 1120 1094 1093 1041 1023 1042 1042 1023 1022 1040 1024 1041 1041 1024 1023 1005 1022 1023 1005 1023 1006 1006 1023 1024 1006 1024 1007 1188 1181 1189 1211 1188 1212 1212 1188 1189 1212 1189 1213 1213 1189 1190 1213 1383 1212 1383 1384 1212 1212 1384 1385 1212 1385 1211 1213 1382 1383 1384 1383 1746 1746 1383 1382 1744 1385 1384 1744 1384 1746 1211 1385 1386 1386 1385 1744 1744 1745 1386 1746 1775 1744 1744 1775 1776 1744 1776 1745 1746 1382 1747 1747 1774 1746 1746 1774 1775 1774 1733 1775 1775 1733 1717 1775 1717 1776 1745 1776 1777 1776 1717 1725 1776 1725 1777 1777 1725 1724 1724 1792 1777 1777 1792 1743 1777 1743 1745 1719 1724 1720 1720 1724 1725 1719 1791 1724 1724 1791 1792 1714 1743 1792 1714 1792 1761 1761 1792 1791 1719 1718 1791 1761 1791 1778 1778 1791 1718 1443 1442 1718 1443 1718 1719 1778 1718 1790 1790 1718 1442 1778 1369 1761 1790 1356 1778 1778 1356 1355 1778 1355 1369 1367 1368 1369 1335 1367 1369 1335 1369 1355 1761 1369 1368 1355 1356 1335 1335 1356 1357 1790 1357 1356 1335 1336 1337 1335 1357 1336 1337 1367 1335 1366 1365 1367 1367 1365 1368 1337 1366 1367 1761 1368 1365 1364 1365 1366 1364 1761 1365 1363 1364 1366 1363 1366 1337 1362 1364 1363 1362 1714 1364 1364 1714 1761 1361 1362 1363 1361 1388 1362 1362 1388 1714 1388 1389 1714 1389 1743 1714 1388 1210 1389 1388 1361 1210 1363 1372 1361 1210 1361 1372 1389 1210 1211 1210 1372 1209 1389 1211 1390 1389 1390 1743 1743 1390 1387 1745 1743 1387 1390 1211 1387 1211 1386 1387 1745 1387 1386 1209 1372 1371 1209 1371 1370 1374 1208 1209 1374 1209 1375 1375 1209 1370 1370 1371 1363 1363 1371 1372 1363 1375 1370 1373 1374 1375 1363 1373 1375 1373 1330 1374 1330 1208 1374 1330 1329 1208 1208 1329 1379 1208 1379 1207 1329 1330 1331 1331 1330 1373 1337 1331 1373 1337 1373 1363 1378 1379 1331 1331 1379 1329 1359 1378 1331 1359 1331 1337 1378 1377 1379 1379 1377 1207 1346 1377 1378 1358 1346 1378 1358 1378 1359 1358 1359 1360 1336 1360 1359 1336 1359 1337 1351 1358 1349 1349 1358 1360 1351 1346 1358 1357 1334 1360 1357 1360 1336 1349 1360 1278 1278 1360 1334 1349 1350 1351 1278 1277 1349 1349 1277 1276 1349 1276 1350 1351 1350 1353 1353 1350 1352 1350 1276 1328 1350 1328 1352 1275 1276 1273 1273 1276 1277 1275 1328 1276 1273 1277 1278 1272 1259 1273 1273 1259 1274 1273 1274 1275 1271 1273 1270 1270 1273 1278 1271 1507 1273 1273 1507 1509 1273 1509 1272 1274 1259 1227 1274 1227 1275 1226 1227 1228 1227 1259 1228 1227 1226 1328 1275 1227 1328 1228 1258 1226 1352 1328 1226 1352 1226 1258 1231 1257 1258 1228 1231 1258 1352 1258 1257 1353 1352 1354 1354 1352 1257 1231 1256 1257 1354 1257 1256 1256 1255 1354 1354 1255 1348 1354 1348 1353 1353 1348 1347 1353 1347 1351 1340 1347 1348 1244 1340 1348 1244 1348 1247 1247 1348 1255 1247 1255 1230 1230 1255 1256 1230 1256 1231 1229 1230 1231 1238 1247 1230 1238 1230 1234 1234 1230 1229 1244 1247 1238 1244 1238 1245 1245 1340 1244 1234 1237 1238 1238 1237 1239 1238 1239 1240 1245 1238 1240 1245 1240 1246 1246 1338 1245 1245 1338 1340 1246 1240 1206 1206 1240 1239 1206 1239 1205 1205 1239 1237 1234 1236 1237 1205 1237 1236 1233 1235 1236 1233 1236 1234 1236 1235 1205 1232 1233 1234 1235 1233 1484 1233 1232 1484 1205 1235 1391 1484 1391 1235 1205 1391 1204 1204 1391 1392 1484 1392 1391 1204 1392 1393 1393 1392 1484 1393 1394 1204 1484 1394 1393 1204 1394 1395 1394 1487 1395 1484 1487 1394 1204 1395 1203 1395 1396 1203 1395 1487 1488 1395 1488 1396 1449 1488 1487 1449 1487 1484 1489 1398 1488 1488 1398 1397 1488 1397 1396 1483 1489 1488 1483 1488 1449 1203 1396 1397 1203 1397 1215 1215 1397 1398 1215 1398 1216 1216 1398 1399 1489 1399 1398 1203 1215 1199 1199 1215 1216 1203 1199 1204 1198 1172 1199 1199 1172 1173 1199 1173 1200 1204 1199 1200 1199 1216 1198 1204 1200 1205 1200 1173 1174 1200 1174 1201 1205 1200 1201 1172 1149 1173 1173 1149 1148 1173 1148 1174 1174 1148 1147 1174 1147 1175 1201 1174 1175 1201 1175 1202 1205 1201 1206 1206 1201 1202 1175 1147 1146 1143 1146 1147 1143 1147 1142 1142 1147 1148 1142 1148 1141 1141 1148 1149 1141 1110 1142 1142 1110 1111 1142 1111 1143 1143 1111 1112 1110 1103 1111 1111 1103 1102 1111 1102 1112 1109 1104 1110 1110 1104 1103 1141 1109 1110 1140 1109 1141 1141 1149 1140 1108 1085 1109 1109 1085 1104 1140 1108 1109 1081 1103 1104 1081 1104 1080 1080 1104 1085 1085 1086 1079 1080 1085 1079 1108 1086 1085 1107 1086 1108 1139 1107 1108 1139 1108 1140 1079 1086 1087 1107 1087 1086 1078 1052 1079 1079 1052 1053 1079 1053 1080 1079 1087 1078 1078 1087 1088 1106 1088 1087 1106 1087 1107 1138 1106 1107 1138 1107 1139 1105 1088 1106 1137 1105 1106 1137 1106 1138 1078 1088 1077 1077 1088 1089 1105 1089 1088 1124 1089 1105 1136 1124 1105 1136 1105 1137 1138 1152 1137 1137 1152 1153 1137 1153 1136 1135 1124 1136 1136 1153 1154 1136 1154 1135 1123 1090 1124 1124 1090 1089 1135 1123 1124 1135 1154 1155 1167 1155 1154 1167 1154 1168 1168 1154 1153 1168 1153 1169 1169 1153 1152 1194 1167 1168 1194 1168 1195 1195 1168 1169 1166 1155 1167 1193 1166 1167 1193 1167 1194 1195 1220 1194 1194 1220 1221 1194 1221 1193 1195 1169 1196 1196 1219 1195 1195 1219 1220 1196 1169 1170 1196 1170 1197 1197 1218 1196 1196 1218 1219 1218 1409 1219 1409 1410 1219 1219 1410 1411 1219 1411 1220 1197 1217 1218 1217 1407 1218 1407 1408 1218 1218 1408 1409 1408 1759 1409 1409 1759 1410 1758 1411 1410 1758 1410 1759 1220 1411 1412 1412 1411 1758 1757 1412 1758 1759 1762 1758 1758 1762 1763 1758 1763 1757 1220 1412 1413 1757 1413 1412 1413 1414 1220 1220 1414 1415 1220 1415 1221 1414 1413 1757 1756 1415 1414 1756 1414 1757 1757 1763 1764 1757 1764 1756 1755 1415 1756 1756 1764 1765 1756 1765 1755 1418 1221 1415 1755 1418 1415 1193 1221 1222 1417 1222 1221 1417 1221 1418 1754 1417 1418 1754 1418 1755 1755 1765 1766 1755 1766 1754 1753 1416 1754 1416 1417 1754 1754 1766 1767 1754 1767 1753 1416 1222 1417 1416 1419 1222 1753 1419 1416 1752 1420 1753 1420 1419 1753 1753 1767 1768 1753 1768 1752 1766 1783 1767 1767 1783 1784 1767 1784 1768 1752 1768 1769 1768 1784 1785 1768 1785 1769 1783 1797 1784 1784 1797 1798 1784 1798 1785 1766 1782 1783 1782 1796 1783 1783 1796 1797 1796 1805 1797 1797 1805 1806 1797 1806 1798 1785 1798 1799 1798 1806 1807 1798 1807 1799 1950 1807 1806 1950 1806 1951 1951 1806 1805 1796 1804 1805 1951 1805 1942 1942 1805 1804 2191 1950 1951 2191 1951 2192 2192 1951 1942 1943 1807 1950 2190 1943 1950 2190 1950 2191 2175 2190 2191 2175 2191 2174 2174 2191 2192 2174 2192 2173 2173 2192 2193 2192 1942 2193 2173 2159 2174 2174 2159 2160 2174 2160 2175 2175 2160 2161 2175 2161 2176 2176 2190 2175 2159 2122 2160 2160 2122 2125 2160 2125 2161 2158 2119 2159 2159 2119 2122 2173 2158 2159 2119 2121 2122 2121 2123 2122 2122 2123 2124 2122 2124 2125 2102 2118 2119 2118 2120 2119 2119 2120 2121 2158 2102 2119 2218 2123 2121 2218 2121 2219 2219 2121 2120 2217 2123 2218 2217 2124 2123 2124 2126 2125 2217 2126 2124 2223 2126 2217 2291 2223 2217 2291 2217 2256 2256 2217 2218 2256 2218 2296 2296 2218 2219 2254 2255 2256 2256 2255 2291 2254 2256 2295 2295 2256 2296 2295 2296 2297 2297 2296 2298 2296 2219 2298 2410 2254 2295 2410 2295 2409 2409 2295 2297 2255 2254 2410 2255 2410 2411 2411 2410 2456 2456 2410 2409 2299 2408 2409 2409 2297 2299 2456 2409 2459 2459 2409 2408 2297 2298 2299 2299 2298 2300 2299 2300 2408 2408 2300 2302 2408 2302 2407 2459 2408 2407 2407 2458 2459 2493 2456 2459 2493 2459 2494 2494 2459 2458 2305 2406 2407 2407 2302 2303 2407 2303 2305 2407 2406 2458 2300 2301 2302 2302 2301 2303 2300 2298 2301 2303 2301 2304 2298 2220 2301 2301 2220 2216 2301 2216 2304 2303 2304 2305 2305 2304 2306 2305 2306 2406 2306 2304 2307 2304 2216 2215 2304 2215 2307 2215 2216 2003 2220 2118 2216 2216 2118 2004 2216 2004 2003 2003 2001 2215 2215 2001 1999 2215 1999 2214 2307 2215 2214 2002 2001 2003 2002 2003 2004 2002 2004 2102 2102 2004 2118 2220 2120 2118 2219 2120 2220 2298 2219 2220 2005 2002 2102 2157 2005 2102 2157 2102 2158 2005 2006 2007 2002 2005 2000 2000 2005 2007 2006 2005 2157 2007 2006 2008 2008 2006 2009 2157 2009 2006 2000 2007 1958 1958 2007 2008 2008 2009 2010 1958 2008 1956 1956 2008 2010 2010 2009 2157 1956 2010 1961 1961 2010 2098 2098 2010 2157 1959 1956 1961 1959 1961 2098 1956 1957 1958 1956 1959 1960 1957 1956 1989 1989 1956 1960 2098 2185 1959 1959 2185 1960 2098 2157 2172 2172 2194 2098 2098 2194 2185 2172 2157 2158 2172 2158 2173 2173 2193 2172 2172 2193 2194 2193 1941 2194 2194 1941 1949 2194 1949 2185 2193 1942 1941 1941 1942 1803 1710 1949 1941 1710 1941 1802 1802 1941 1803 1446 1948 1949 1446 1949 1710 2185 1949 1948 1860 1948 1446 2185 1948 1955 1955 1948 1860 1955 1991 2185 2185 1991 1960 1955 1860 1859 1990 1991 1955 1955 1859 1990 1445 1859 1860 1445 1860 1446 1466 1858 1859 1466 1859 1445 1990 1859 1858 1989 1960 1990 1990 1960 1991 1990 1858 1989 1470 1857 1858 1470 1858 1466 1989 1858 1992 1858 1857 1992 1445 1444 1466 1444 1470 1466 1444 1445 1446 1446 1490 1444 1490 1446 1710 1444 1490 1491 1491 1490 1711 1711 1490 1710 1711 1710 1793 1793 1710 1802 1779 1711 1793 1779 1793 1780 1780 1793 1794 1793 1802 1794 1794 1802 1803 1780 1794 1781 1781 1794 1795 1794 1803 1795 1763 1779 1780 1763 1780 1764 1764 1780 1781 1764 1781 1765 1765 1781 1782 1781 1795 1782 1782 1795 1796 1795 1803 1804 1795 1804 1796 1942 1804 1803 1765 1782 1766 1762 1779 1763 1759 1713 1762 1713 1712 1762 1762 1712 1779 1712 1711 1779 1465 1464 1712 1713 1465 1712 1464 1493 1712 1712 1493 1711 1492 1491 1711 1492 1711 1493 1462 1492 1493 1462 1493 1464 1463 1462 1464 1463 1464 1465 1465 1457 1463 1457 1465 1713 1461 1462 1463 1463 1457 1456 1463 1456 1461 1450 1462 1451 1451 1462 1461 1450 1492 1462 1450 1491 1492 1444 1491 1450 1444 1450 1451 1467 1468 1451 1451 1468 1469 1451 1469 1444 1451 1461 1467 1444 1469 1470 1470 1469 1855 1855 1469 1468 1467 1497 1468 1855 1468 1497 1467 1496 1497 1497 1496 1855 1481 1495 1496 1481 1496 1467 1855 1496 1495 1467 1480 1481 1481 1480 1482 1481 1482 1478 1478 1495 1481 1478 1494 1495 1855 1495 1510 1510 1495 1494 1477 1494 1478 1510 1494 1477 1475 1476 1477 1475 1477 1478 1477 1476 1510 1471 1476 1475 1471 1475 1448 1448 1475 1478 1472 1479 1476 1472 1476 1471 1510 1476 1479 1448 1447 1471 1471 1447 1254 1471 1254 1472 1447 1448 1449 1448 1478 1449 1478 1483 1449 1484 1485 1449 1449 1485 1486 1449 1486 1447 1478 1482 1483 1482 1489 1483 1480 1454 1482 1482 1454 1489 1454 1399 1489 1401 1454 1453 1453 1454 1455 1401 1400 1454 1454 1400 1399 1480 1455 1454 1467 1461 1480 1461 1455 1480 1453 1455 1452 1452 1455 1456 1461 1456 1455 1457 1458 1456 1456 1458 1459 1456 1459 1452 1458 1457 1713 1459 1458 1760 1760 1458 1713 1452 1459 1460 1459 1760 1460 1407 1760 1408 1408 1760 1759 1460 1760 1407 1760 1713 1759 1460 1406 1452 1460 1407 1406 1217 1406 1407 1403 1406 1217 1452 1406 1403 1198 1216 1217 1198 1217 1197 1403 1217 1404 1404 1217 1216 1452 1403 1404 1452 1404 1405 1452 1405 1453 1404 1216 1405 1405 1216 1402 1453 1405 1402 1399 1400 1216 1216 1400 1401 1216 1401 1402 1453 1402 1401 1197 1170 1171 1197 1171 1198 1169 1152 1170 1170 1152 1151 1170 1151 1171 1171 1151 1150 1171 1150 1172 1198 1171 1172 1139 1150 1151 1139 1151 1138 1138 1151 1152 1140 1149 1150 1140 1150 1139 1172 1150 1149 1447 1248 1254 1248 1447 1249 1447 1486 1241 1447 1241 1249 1248 1249 1250 1254 1248 1253 1253 1248 1250 1253 1252 1254 1472 1254 1252 1251 1252 1253 1472 1252 1251 1253 1250 1228 1228 1260 1253 1253 1260 1261 1253 1261 1251 1251 1261 1262 1251 1262 1472 1472 1262 1473 1472 1473 1474 1474 1479 1472 1262 1261 1272 1509 1473 1262 1509 1262 1272 1272 1261 1260 1228 1259 1260 1272 1260 1259 1250 1231 1228 1250 1249 1241 1241 1229 1250 1250 1229 1231 1241 1242 1229 1486 1242 1241 1229 1242 1243 1234 1229 1232 1232 1229 1243 1486 1243 1242 1485 1243 1486 1232 1243 1485 1484 1232 1485 1507 1511 1509 1509 1479 1474 1474 1473 1509 1511 1479 1509 1507 1510 1511 1510 1479 1511 1271 1269 1507 1507 1269 1505 1507 1505 1508 1508 1510 1507 1270 1269 1271 1267 1268 1269 1267 1269 1270 1269 1268 1505 1505 1268 1504 1505 1504 1506 1508 1505 1506 1508 1506 1500 1500 1499 1508 1508 1499 1510 1503 1500 1506 1503 1506 1501 1501 1506 1504 1264 1504 1266 1266 1504 1268 1501 1504 1264 1266 1268 1267 1265 1264 1266 1265 1266 1267 1263 1264 1265 1831 1263 1265 1831 1265 1267 1264 1263 1427 1830 1427 1263 1830 1263 1831 1441 1830 1831 1441 1831 1279 1279 1831 1267 1279 1267 1270 1270 1278 1279 1279 1278 1280 1279 1280 1281 1279 1281 1440 1279 1440 1441 1278 1334 1280 1280 1334 1333 1280 1333 1281 1333 1440 1281 1441 1440 1442 1333 1790 1440 1790 1442 1440 1332 1333 1334 1332 1790 1333 1332 1334 1357 1332 1357 1790 1441 1442 1443 1443 1830 1441 1719 1723 1443 1443 1723 1830 1719 1720 1721 1721 1722 1719 1719 1722 1723 1830 1723 1722 1830 1722 1829 1829 1722 1721 1829 1721 1720 1720 1725 1726 1829 1720 1726 1827 1830 1829 1827 1829 1727 1727 1829 1726 1726 1725 1727 1717 1716 1725 1725 1716 1728 1725 1728 1727 1727 1728 1827 1728 1716 1827 1715 1716 1717 1827 1716 1715 1733 1734 1717 1717 1734 1735 1717 1735 1715 1827 1715 1828 1828 1715 1735 1828 1735 1734 1733 1732 1734 1732 1828 1734 1731 1732 1733 1774 1731 1733 1731 1730 1732 1732 1730 1826 1826 1828 1732 1729 1730 1731 1826 1730 1729 1731 1736 1729 1826 1729 1736 1736 1737 1738 1731 1737 1736 1736 1738 1826 1738 1737 1739 1826 1738 1739 1737 1742 1739 1826 1739 1819 1819 1739 1742 1737 1741 1742 1819 1742 1741 1740 1741 1737 1789 1740 1737 1789 1737 1731 1740 1811 1741 1741 1818 1819 1818 1741 1811 1740 1810 1811 1810 1824 1811 1811 1824 1825 1811 1825 1818 1825 1560 1818 1560 1559 1818 1818 1559 1558 1818 1558 1819 1824 1561 1825 1825 1561 1560 1559 1560 1315 1315 1560 1561 1315 1558 1559 1315 1565 1558 1819 1558 1565 1819 1565 1826 1315 1564 1565 1826 1565 1564 1306 1314 1315 1315 1561 1306 1314 1564 1315 1306 1561 1562 1824 1562 1561 1306 1562 1554 1554 1562 1824 1823 1554 1824 1824 1944 1823 1810 1944 1824 1553 1306 1554 1823 1553 1554 1822 1553 1823 1823 1944 1822 1552 1306 1553 1822 1552 1553 1821 1551 1822 1551 1552 1822 1944 1821 1822 1551 1303 1552 1552 1303 1306 1551 1555 1303 1821 1555 1551 1820 1555 1821 1944 1820 1821 1303 1555 1556 1820 1556 1555 1932 1557 1820 1820 1557 1556 1945 1932 1820 1945 1820 1944 1303 1556 1557 1557 1665 1303 1932 1665 1557 1931 1665 1932 1931 1932 1945 1303 1665 1666 1931 1666 1665 1930 1667 1931 1667 1666 1931 1931 1945 1930 1303 1666 1298 1298 1666 1667 1298 1667 1537 1930 1537 1667 1537 1538 1298 1538 1537 1930 1929 1538 1930 1930 1945 1946 1930 1946 1929 1538 1662 1298 1929 1662 1538 1928 1663 1929 1663 1662 1929 1946 1928 1929 1298 1662 1663 1298 1663 1295 1295 1663 1664 1928 1664 1663 1927 1664 1928 1946 1927 1928 1295 1664 1539 1927 1539 1664 1927 1924 1540 1540 1539 1927 1947 1924 1927 1947 1927 1946 1539 1540 1295 1540 1659 1295 1924 1659 1540 1924 1925 1918 1918 1660 1924 1924 1660 1659 1925 1924 1947 1295 1659 1660 1295 1660 1296 1296 1660 1661 1918 1661 1660 1918 1919 1915 1918 1925 1926 1918 1926 1919 1915 1661 1918 1926 1925 1947 1919 1926 2111 2111 1926 1947 1915 1919 1920 2111 2112 1919 2112 1920 1919 2181 2112 2111 2181 2111 2180 2180 2111 2186 2111 1947 2186 2180 2166 2181 2181 2166 2167 2181 2167 2182 2182 2112 2181 2179 2165 2180 2180 2165 2166 2180 2186 2179 2165 2138 2166 2166 2138 2141 2166 2141 2167 2167 2141 2143 2167 2143 2168 2182 2167 2168 2138 2140 2141 2141 2140 2142 2141 2142 2143 2142 2144 2143 2143 2144 2145 2143 2145 2146 2168 2143 2146 2168 2146 2169 2182 2168 2113 2113 2168 2169 2146 2145 2147 2146 2147 2148 2169 2146 2148 2169 2148 2170 2113 2169 2114 2114 2169 2170 2147 2149 2148 2148 2149 2150 2148 2150 2151 2170 2148 2151 2170 2151 2171 2114 2170 2115 2115 2170 2171 2150 2152 2151 2151 2152 2154 2151 2154 2171 2230 2152 2150 2230 2150 2149 2230 2149 2231 2231 2149 2147 2235 2152 2230 2260 2235 2230 2260 2230 2257 2257 2230 2231 2152 2153 2154 2235 2153 2152 2234 2153 2235 2374 2234 2235 2374 2235 2260 2153 2108 2154 2234 2108 2153 2233 2108 2234 2371 2233 2234 2371 2234 2374 2374 2375 2371 2260 2378 2374 2374 2378 2379 2374 2379 2375 2371 2372 2368 2371 2375 2376 2371 2376 2372 2368 2233 2371 2384 2376 2375 2384 2375 2379 2378 2383 2379 2379 2383 2384 2385 2376 2384 2385 2384 2449 2449 2384 2383 2385 2372 2376 2368 2372 2373 2385 2373 2372 2386 2373 2385 2448 2386 2385 2448 2385 2449 2449 2383 2451 2499 2448 2449 2499 2449 2500 2500 2449 2451 2447 2387 2448 2387 2386 2448 2498 2447 2448 2498 2448 2499 2646 2498 2499 2646 2499 2647 2647 2499 2500 2500 2451 2501 2647 2500 2648 2648 2500 2501 2730 2646 2647 2730 2647 2731 2731 2647 2648 2645 2498 2646 2729 2645 2646 2729 2646 2730 2731 2872 2730 2872 2873 2730 2730 2873 2874 2730 2874 2729 2728 2645 2729 2874 2875 2729 2729 2875 2876 2729 2876 2728 2727 2644 2728 2728 2644 2645 2876 2877 2728 2728 2877 2878 2728 2878 2727 2643 2496 2644 2644 2496 2497 2644 2497 2645 2727 2643 2644 2642 2495 2643 2643 2495 2496 2726 2642 2643 2726 2643 2727 2495 2445 2496 2496 2445 2446 2496 2446 2497 2508 2443 2495 2495 2443 2444 2495 2444 2445 2642 2508 2495 2507 2442 2508 2508 2442 2443 2641 2507 2508 2641 2508 2642 2506 2441 2507 2507 2441 2442 2640 2506 2507 2640 2507 2641 2744 2640 2641 2744 2641 2725 2725 2641 2642 2639 2506 2640 2743 2639 2640 2743 2640 2744 2638 2505 2639 2639 2505 2506 2742 2638 2639 2742 2639 2743 2744 2885 2743 2885 2886 2743 2743 2886 2887 2743 2887 2742 2741 2638 2742 2887 2888 2742 2742 2888 2889 2742 2889 2741 2886 3274 2887 2887 3274 3275 2887 3275 2888 2885 3273 2886 2886 3273 3274 3274 3273 3287 3275 3274 3291 3274 3287 3291 2888 3275 3276 3291 3276 3275 2888 3276 3267 3291 3267 3276 2888 3267 3268 3268 3267 3291 3291 3287 3351 3291 3351 3355 3268 3291 3292 3292 3291 3355 3268 3269 2888 3292 3269 3268 2888 3269 3270 3292 3270 3269 2888 3262 2889 2888 3270 3262 3262 3270 3292 2889 3262 3263 3292 3263 3262 2889 2890 2741 3263 3264 2889 2889 3264 3265 2889 3265 2890 3293 3264 3263 3292 3293 3263 3293 3265 3264 2890 3265 3266 3266 3265 3293 3266 3293 3294 3294 3293 3322 3359 3322 3293 3359 3293 3292 2890 3266 3257 3294 3257 3266 3257 3258 2890 3294 3258 3257 2890 3258 2891 3258 3259 2891 3259 3258 3294 2741 2890 2891 2741 2891 2740 2891 2892 2740 2891 3259 3260 2891 3260 2892 3260 3259 3294 2892 3260 3261 3261 3260 3286 3260 3294 3286 3294 3322 3323 3286 3294 3323 3261 3286 3249 3286 3323 3330 3249 3286 3295 3295 3286 3330 2892 3261 3249 2892 3249 3250 3295 3250 3249 2892 3250 2893 3253 2893 3250 3295 3253 3250 2740 2892 2893 2740 2893 2739 2893 2894 2739 3252 2894 2893 3252 2893 3253 3252 3253 3295 3251 2894 3252 3295 3251 3252 2739 2894 2895 3251 3254 2894 2894 3254 3255 2894 3255 2895 3296 3254 3251 3295 3296 3251 3296 3255 3254 2895 3255 3256 3256 3255 3296 3256 3296 3297 3297 3296 3334 3362 3334 3296 3362 3296 3295 3295 3330 3362 3362 3330 3331 3362 3331 3363 3363 3334 3362 3297 3334 3335 3335 3334 3336 3363 3336 3334 3363 3331 3332 3363 3332 3364 3364 3336 3363 3330 3325 3331 3331 3325 3327 3331 3327 3332 3330 3323 3325 3323 3324 3325 3325 3324 3326 3325 3326 3327 3327 3326 3328 3327 3328 3329 3332 3327 3329 3278 3328 3326 3278 3326 3361 3361 3326 3324 3323 3322 3324 3361 3324 3360 3360 3324 3322 3360 3357 3361 3361 3357 3358 3361 3358 3278 3359 3356 3360 3360 3356 3357 3360 3322 3359 3356 3353 3357 3357 3353 3354 3357 3354 3358 3358 3354 2913 3358 2913 2915 3278 3358 2915 3353 3347 3354 3354 3347 2911 3354 2911 2913 3352 3316 3353 3353 3316 3347 3356 3352 3353 3351 3311 3352 3352 3311 3316 3355 3351 3352 3355 3352 3356 3287 3304 3351 3351 3304 3311 3273 3290 3287 3287 3290 3304 2885 3272 3273 3273 3272 3290 2744 2884 2885 2884 3272 2885 2884 3271 3272 3290 3272 3271 2883 2884 2744 2883 3171 2884 2884 3171 3172 2884 3172 3173 3173 3271 2884 2725 2883 2744 2725 2642 2726 2726 2882 2725 2725 2882 2883 2727 2880 2726 2880 2881 2726 2726 2881 2882 2883 2882 3169 2881 3177 2882 2882 3177 3178 2882 3178 3169 2880 3175 2881 3175 3176 2881 2881 3176 3177 3459 3177 3176 3459 3178 3177 3459 3169 3178 3169 3170 2883 3170 3169 3459 2883 3170 3171 3171 3170 3288 3459 3288 3170 3171 3288 3172 3289 3290 3288 3288 3290 3173 3288 3173 3172 3459 3289 3288 3306 3290 3289 3306 3289 3459 3290 3271 3173 3305 3304 3290 3305 3290 3306 3459 3305 3306 3303 3304 3305 3303 3305 3424 3459 3424 3305 3312 3311 3304 3312 3304 3313 3313 3304 3303 3424 3313 3303 3460 3529 3424 3460 3424 3459 3529 3461 3424 3424 3461 3313 3459 3176 3460 3176 3175 3460 3460 3175 3174 3460 3174 3457 3457 3529 3460 3457 3528 3529 3528 3520 3529 3529 3520 3461 3458 3527 3528 3458 3528 3457 3527 3515 3528 3528 3515 3520 3462 3461 3520 3462 3520 3521 3521 3520 3515 3515 3511 3516 3521 3515 3522 3522 3515 3516 3527 3511 3515 3456 3527 3458 3456 3511 3527 3511 3455 3512 3516 3511 3512 3456 3455 3511 3516 3512 3517 3522 3516 3523 3523 3516 3517 3523 3538 3522 3522 3538 3540 3522 3540 3521 3523 3517 3524 3524 3536 3523 3523 3536 3538 3517 3512 3513 3517 3513 3518 3524 3517 3518 3524 3518 3525 3525 3534 3524 3524 3534 3536 3534 3535 3536 3536 3535 3537 3536 3537 3538 3532 3533 3534 3534 3533 3535 3525 3532 3534 3525 3518 3519 3525 3519 3526 3526 3532 3525 3530 3531 3532 3532 3531 3533 3526 3530 3532 3531 3430 3533 3533 3430 3433 3533 3433 3535 3530 3542 3531 3531 3542 3430 3507 3542 3530 3507 3530 3526 3506 3430 3542 3506 3542 3507 3505 3506 3507 3526 3510 3507 3507 3510 3487 3507 3487 3505 3505 3504 3506 3504 3434 3506 3434 3430 3506 3503 3502 3504 3503 3504 3505 3502 3435 3504 3504 3435 3434 3402 3434 3167 3167 3434 3435 3402 3403 3434 3434 3403 3430 3167 2985 3402 3402 2985 2977 3402 2977 3403 3165 2985 3167 3165 3167 3168 3167 3435 3168 2977 2985 2978 2978 2985 2986 2986 2985 3165 2976 2977 2978 3403 2977 2976 2978 2986 2987 2996 2976 2978 2996 2978 2981 2981 2978 2987 2986 3165 2987 2981 2987 2979 2987 3165 2980 2987 2980 2979 2979 2980 2981 2981 2980 2982 2996 2981 2997 2997 2981 2982 2982 2980 2983 3165 2983 2980 2982 2983 2984 3165 2984 2983 2984 2993 2982 2993 2984 3165 2982 2993 2994 3165 3166 2993 3166 3079 2993 2993 3079 3078 2993 3078 2994 2982 2994 2995 3076 2995 2994 3076 2994 3077 3077 2994 3078 2784 3077 3078 2784 3078 2773 2773 3078 3079 2783 3076 3077 2783 3077 2784 2782 3075 3076 2782 3076 2783 3075 2995 3076 2685 2782 2783 2685 2783 2686 2686 2783 2784 2686 2784 2687 2687 2784 2773 2522 2685 2686 2522 2686 2523 2523 2686 2687 2530 2684 2685 2530 2685 2522 2684 2782 2685 2521 2522 2523 2530 2522 2531 2531 2522 2521 2531 2684 2530 2531 2683 2684 2683 2781 2684 2684 2781 2782 2531 2521 2532 2532 2683 2531 2532 2682 2683 2682 2780 2683 2683 2780 2781 2780 3074 2781 2781 3074 3075 2781 3075 2782 2682 2779 2780 2779 3073 2780 2780 3073 3074 2525 2681 2682 2525 2682 2532 2681 2779 2682 2532 2521 2525 2521 2524 2525 2524 2681 2525 2524 2680 2681 2680 2778 2681 2681 2778 2779 2778 3072 2779 2779 3072 3073 2680 2777 2778 2777 3071 2778 2778 3071 3072 2521 2679 2680 2521 2680 2524 2679 2777 2680 2679 2776 2777 2776 3070 2777 2777 3070 3071 3070 3155 3071 3155 3154 3071 3071 3154 3153 3071 3153 3072 2776 3069 3070 3069 3147 3070 3070 3147 3155 2818 3154 3155 2818 3155 2834 2834 3155 3147 2817 3153 3154 2817 3154 2818 2816 3152 3153 2816 3153 2817 3072 3153 3152 2816 2817 2721 2721 2817 2818 2721 2720 2816 2816 2720 2719 2816 2719 2827 2827 3152 2816 2827 3151 3152 3072 3152 3073 3073 3152 3151 2827 2719 2596 2827 2596 2828 2828 3151 2827 2613 2596 2719 2613 2719 2612 2612 2719 2720 2595 2594 2596 2595 2596 2613 2828 2596 2594 2828 2594 2829 2829 3159 2828 2828 3159 3151 3073 3151 3159 2829 3158 3159 3159 3158 3073 2829 2594 2592 2592 2838 2829 2838 3158 2829 2593 2592 2594 2593 2594 2595 2591 2590 2592 2591 2592 2593 2590 2837 2592 2592 2837 2838 2837 3157 2838 2838 3157 3158 3158 3157 2992 3073 3158 2992 2837 3156 3157 2992 3157 3156 2590 2836 2837 2836 3156 2837 3156 2836 3160 2992 3156 3160 2488 2832 2836 2488 2836 2590 3160 2836 2832 3160 2832 3161 2759 2757 3160 3160 2757 2992 3160 3161 2759 2832 3164 3161 2759 3161 3164 2831 3163 3164 2831 3164 2832 2759 3164 3089 3089 3164 3163 2631 2830 2831 2631 2831 2632 2632 2831 2832 2830 3163 2831 2830 3162 3163 3089 3163 3090 3090 3163 3162 2825 2830 2631 2825 3162 2830 2825 3109 3162 3090 3162 3109 2796 3089 3090 2796 3090 2785 2785 3090 3091 3090 3109 3091 2824 3108 3109 2824 3109 2825 3091 3109 3108 2630 2824 2825 2630 2825 2631 2823 2824 2630 2823 3108 2824 2823 3107 3108 3091 3108 3080 3080 3108 3107 2785 3091 2786 2786 3091 3080 2786 3080 2787 2787 3080 3081 3080 3107 3081 2841 3106 3107 2841 3107 2823 3081 3107 3106 2787 3081 2788 2788 3081 3082 3081 3106 3082 2689 2786 2787 2689 2787 2690 2690 2787 2788 2690 2788 2691 2691 2788 2789 2788 3082 2789 2789 3082 3083 3082 3106 3105 3082 3105 3083 2691 2789 2692 2692 2789 2790 2789 3083 2790 2542 2690 2691 2542 2691 2535 2535 2691 2692 2535 2692 2537 2537 2692 2693 2692 2790 2693 2693 2790 2791 2790 3083 3084 2790 3084 2791 2537 2693 2538 2538 2693 2694 2693 2791 2694 2537 2538 2535 2535 2538 2539 2538 2694 2539 2539 2694 2695 2694 2791 2792 2694 2792 2695 2791 3084 3085 2791 3085 2792 2695 2792 2793 2792 3085 3086 2792 3086 2793 2539 2695 2543 2543 2695 2696 2695 2793 2696 2539 2543 2535 2535 2543 2544 2543 2696 2544 2544 2696 2697 2696 2793 2794 2696 2794 2697 2793 3086 3087 2793 3087 2794 2697 2794 2795 2794 3087 3088 2794 3088 2795 2544 2697 2533 2533 2697 2698 2697 2795 2698 2535 2544 2533 2533 2534 2535 2533 2698 2534 2534 2698 2699 2698 2795 2796 2698 2796 2699 2795 3088 3089 2795 3089 2796 2699 2796 2785 2534 2699 2536 2536 2699 2700 2699 2785 2700 2535 2534 2536 2536 2540 2535 2536 2700 2540 2540 2700 2689 2700 2785 2786 2700 2786 2689 2535 2540 2541 2540 2689 2541 2535 2541 2542 2541 2689 2690 2541 2690 2542 2663 2759 3089 2663 3089 2654 3088 2657 3089 3089 2657 2655 3089 2655 2654 2758 2757 2759 2758 2759 2760 2760 2759 2663 2755 2757 2758 2755 2758 2760 2755 2756 2757 2992 2757 2756 2960 2756 2755 2960 2755 2961 2653 2961 2755 2653 2755 2664 2664 2755 2760 2760 2663 2664 2663 2653 2664 2654 2653 2663 2653 2654 2655 2653 2655 2656 2656 2655 2657 2656 2657 2658 2658 2660 2656 2656 2660 2662 2656 2662 2653 2658 2657 2659 3088 2659 2657 2658 2659 2660 2660 2659 2661 2660 2661 2662 2747 2662 2748 2748 2662 2661 2662 2747 3408 2653 2662 3408 2748 3431 2747 2747 3431 3408 2748 2661 2749 2748 2749 2904 2904 3464 2748 2748 3464 3431 2749 2661 2746 2904 2749 2905 2746 2905 2749 2904 2905 2906 2906 3350 2904 2904 3350 3464 3539 3431 3464 3539 3464 3463 3463 3464 3350 2906 2907 3350 3350 2907 3349 3463 3350 3349 2906 2905 2907 2907 2905 2908 2907 2908 2909 3349 2907 3347 3347 2907 2909 3347 3348 3349 3349 3348 3463 3316 3346 3347 3347 3346 3348 3347 2909 2911 2909 2908 2910 2909 2910 2911 2911 2910 2912 2911 2912 2913 2910 2908 3031 3031 2912 2910 2913 2912 2914 3051 2914 2912 3031 3051 2912 2913 2914 2915 2915 2914 2916 3051 2916 2914 3032 3052 3051 3032 3051 3031 3052 3002 3051 3051 3002 2916 2915 2916 2917 2917 2916 2918 2918 2916 3002 3278 2915 2917 2917 2918 2919 2917 2919 3278 2919 2918 2920 2920 2918 2921 3002 2921 2918 2919 3328 3278 2919 2920 3328 2920 2921 2922 3328 2920 2922 2922 2921 2923 3002 3055 2921 3055 2923 2921 2922 2923 2924 3328 2922 3329 3329 2922 2924 2924 2923 2925 3055 3040 2923 3040 2925 2923 3053 3054 3055 3053 3055 3002 3054 3040 3055 3039 3040 3041 3054 3041 3040 3039 2927 3040 3040 2927 2925 2924 2925 2926 2926 2925 2927 2926 2927 2928 2928 2927 2932 2932 2927 2933 3039 2933 2927 3333 2924 2926 3333 2926 2928 3365 3333 2928 3365 2928 2932 3332 3329 3333 3329 2924 3333 3364 3332 3333 3364 3333 3365 2932 3340 3365 3365 3340 3338 3365 3338 3364 3364 3338 3336 3337 3336 3338 3337 3338 3339 3339 3338 3340 3335 3336 3337 3366 3335 3337 3366 3337 3367 3367 3337 3339 3339 3340 3341 3367 3339 3368 3368 3339 3341 3370 3366 3367 3370 3367 3371 3371 3367 3368 3298 3335 3366 3285 3298 3366 3285 3366 3370 3298 3297 3335 3297 3248 3256 3242 3241 3297 3297 3241 3247 3297 3247 3248 3242 3297 3298 3247 2895 3248 2895 3256 3248 3241 2896 3247 3247 2896 2895 3241 3242 2896 2896 3242 3243 3298 3243 3242 2738 2895 2896 2896 2897 2738 2896 3243 2897 2739 2895 2738 2738 2635 2739 2739 2635 2636 2739 2636 2740 2634 2493 2635 2635 2493 2494 2635 2494 2636 2738 2634 2635 2636 2494 2490 2636 2490 2637 2740 2636 2637 2740 2637 2741 2637 2490 2489 2637 2489 2638 2741 2637 2638 2437 2489 2490 2437 2436 2489 2489 2436 2435 2489 2435 2505 2638 2489 2505 2253 2436 2437 2253 2437 2250 2250 2437 2438 2437 2490 2438 2252 2435 2436 2252 2436 2253 2244 2252 2253 2244 2253 2246 2246 2253 2250 2249 2252 2244 2249 2435 2252 2243 2244 2245 2245 2244 2246 2244 2243 2249 2245 2246 2247 2247 2246 2248 2246 2250 2248 2317 2243 2245 2317 2245 2315 2245 2247 2315 2403 2249 2243 2318 2403 2243 2318 2243 2317 2435 2249 2403 2320 2402 2403 2320 2403 2318 2435 2403 2440 2403 2402 2440 2317 2316 2318 2318 2316 2319 2318 2319 2320 2315 2316 2317 2315 2313 2316 2313 2211 2316 2316 2211 2212 2316 2212 2319 2320 2319 2321 2321 2319 2322 2319 2212 2208 2319 2208 2322 2211 2210 2212 2210 2014 2212 2212 2014 1969 2212 1969 2208 2016 2210 2211 2016 2015 2210 2210 2015 2014 1969 2014 1976 1976 2014 2015 1968 1969 1970 1969 1976 1970 2208 1969 1968 1970 1975 1968 2208 1968 1975 1973 1974 1970 1970 1974 1975 1970 1976 1977 1970 1977 1973 1975 1974 2208 1973 1972 1974 2208 1974 1972 2208 1972 2209 2322 2208 2209 1971 1972 1973 2209 1972 1971 2209 1971 2206 2322 2209 2325 2325 2209 2206 2321 2322 2323 2323 2322 2324 2324 2322 2325 2324 2325 2326 2326 2325 2327 2327 2325 2328 2325 2206 2328 2400 2324 2326 2324 2400 2323 2323 2400 2402 2323 2402 2321 2321 2402 2320 2440 2402 2400 2400 2326 2401 2440 2400 2441 2400 2401 2441 2326 2327 2401 2327 2328 2329 2401 2327 2329 2401 2329 2399 2441 2401 2399 2441 2399 2442 2506 2440 2441 2505 2435 2440 2505 2440 2506 2399 2398 2442 2442 2398 2397 2442 2397 2443 2398 2399 2332 2332 2333 2398 2398 2333 2335 2398 2335 2397 2330 2331 2332 2332 2331 2333 2399 2330 2332 2333 2331 2334 2333 2334 2335 2335 2334 2336 2397 2335 2336 2336 2334 2337 2331 2205 2334 2334 2205 2204 2334 2204 2337 2336 2337 2338 2397 2336 2338 2338 2337 2339 2396 2397 2338 2338 2339 2396 2397 2396 2443 2396 2339 2341 2396 2341 2395 2443 2396 2395 2339 2337 2340 2339 2340 2341 2341 2340 2342 2395 2341 2342 2395 2344 2394 2395 2342 2344 2443 2395 2444 2395 2394 2444 2342 2340 2343 2342 2343 2344 2337 2203 2340 2340 2203 2242 2340 2242 2343 2344 2343 2345 2345 2343 2346 2343 2242 2241 2343 2241 2346 2394 2344 2345 2345 2346 2347 2394 2345 2347 2346 2350 2347 2394 2347 2393 2393 2347 2350 2346 2349 2350 2393 2350 2349 2348 2349 2346 2346 2241 2200 2346 2200 2348 2348 2356 2349 2393 2349 2392 2392 2349 2356 2444 2394 2393 2444 2393 2445 2393 2392 2445 2392 2355 2391 2392 2356 2355 2445 2392 2391 2348 2355 2356 2351 2354 2355 2351 2355 2348 2391 2355 2354 2391 2353 2390 2391 2354 2353 2445 2391 2446 2391 2390 2446 2353 2354 2351 2351 2352 2353 2352 2361 2353 2390 2353 2361 2390 2360 2389 2390 2361 2360 2446 2390 2389 2446 2389 2447 2497 2446 2447 2389 2364 2388 2389 2360 2358 2389 2358 2364 2389 2388 2447 2447 2388 2387 2497 2447 2498 2645 2497 2498 2387 2370 2386 2388 2367 2387 2387 2367 2366 2387 2366 2370 2365 2369 2370 2365 2370 2366 2386 2370 2369 2386 2369 2373 2368 2369 2365 2368 2373 2369 2365 2366 2362 2362 2237 2365 2365 2237 2238 2365 2238 2368 2362 2366 2367 2362 2363 2357 2362 2367 2363 2357 2236 2362 2362 2236 2237 2236 2103 2237 2237 2103 2106 2237 2106 2238 2238 2106 2105 2238 2105 2233 2368 2238 2233 2105 2106 2107 2106 2103 2107 2103 2104 2099 2107 2103 2099 2236 2104 2103 2201 2104 2236 2357 2201 2236 2099 2104 2100 2100 2104 2155 2201 2155 2104 2099 2100 2101 2107 2099 2183 2183 2099 2101 2100 2155 2067 2067 2068 2100 2100 2068 2069 2100 2069 2101 2067 2155 2156 2156 2155 2201 2066 2058 2067 2067 2058 2060 2067 2060 2068 2067 2156 2066 2068 2060 2065 2068 2065 2069 2069 2065 2070 2101 2069 2070 2060 2064 2065 2078 2070 2065 2078 2065 2077 2077 2065 2064 2079 2070 2078 2101 2070 2079 2077 2074 2078 2078 2074 2076 2078 2076 2079 2073 2072 2077 2077 2072 2074 2077 2064 2073 2074 2075 2076 2072 2047 2074 2074 2047 2046 2074 2046 2075 2079 2076 2184 2184 2076 2075 2184 2101 2079 2183 2101 2184 2184 2075 2046 2199 2183 2184 2199 2184 2097 2097 2184 2046 2045 2046 2047 2097 2046 2045 2097 2045 1869 2197 2199 2097 2197 2097 1882 1882 2097 1869 2198 2183 2199 2196 2198 2199 2196 2199 2197 2198 2107 2183 2110 2107 2198 2195 2110 2198 2195 2198 2196 2116 2195 2196 2116 2196 2117 2117 2196 2197 2171 2154 2195 2171 2195 2116 2154 2110 2195 2115 2171 2116 1893 2114 2115 1893 2115 1910 2116 1913 2115 2115 1913 1912 2115 1912 1910 1917 2113 2114 1917 2114 1892 1892 2114 1893 1894 1916 1917 1894 1917 1892 1916 2113 1917 1916 1923 2113 2113 1923 1922 2113 1922 2182 1915 1916 1894 1915 1923 1916 1915 1922 1923 1921 1922 1915 1922 1921 2112 2182 1922 2112 1915 1920 1921 1894 1657 1915 1915 1657 1656 1915 1656 1661 2112 1921 1920 1296 1661 1656 1656 1657 1296 1296 1657 1658 1894 1658 1657 1296 1658 1652 1652 1658 1894 1892 1893 1894 1893 1911 1894 1894 1911 1653 1894 1653 1652 1652 1653 1296 1296 1653 1654 1911 1654 1653 1296 1654 1309 1309 1654 1655 1911 1655 1654 1309 1655 1646 1933 1655 1911 1933 1646 1655 1646 1647 1309 1933 1647 1646 1934 1647 1933 1911 1907 1933 1933 1907 1903 1933 1903 1934 1309 1647 1648 1934 1648 1647 1648 1649 1309 1649 1648 1934 1309 1649 1650 1934 1650 1649 1309 1650 1310 1310 1650 1651 1934 1651 1650 1310 1651 1641 1641 1651 1891 1891 1651 1934 1310 1641 1642 1891 1642 1641 1936 1643 1891 1891 1643 1642 1934 1902 1891 1891 1902 1901 1891 1901 1936 1642 1643 1310 1310 1643 1644 1936 1644 1643 1935 1644 1936 1936 1901 1900 1936 1900 1935 1680 1900 1901 1680 1901 1681 1681 1901 1902 1676 1899 1900 1676 1900 1677 1677 1900 1680 1935 1900 1899 1677 1680 1320 1320 1680 1681 1320 1681 1668 1681 1902 1668 1668 1669 1320 1902 1669 1668 1519 1320 1669 1669 1877 1519 1902 1877 1669 1519 1520 1521 1521 1320 1519 1519 1877 1878 1519 1878 1520 1878 1877 1902 1520 1878 1536 1878 1879 1536 1902 1879 1878 1535 1521 1520 1535 1520 1536 1527 1535 1536 1527 1536 1529 1536 1879 1880 1536 1880 1529 1902 1880 1879 1529 1880 1881 1881 1880 1902 1527 1529 1530 1529 1870 1530 1529 1881 1870 1902 1870 1881 1868 1870 1902 1868 1902 1883 1883 1902 1903 1934 1903 1902 1867 1868 1869 1869 1868 1882 1882 1868 1883 1867 1870 1868 1882 1883 1884 1884 1883 1885 1883 1903 1885 1882 1884 2197 2197 1884 1885 1885 1903 1904 2197 1885 2117 2117 1885 1904 1903 1909 1904 2117 1904 1909 1909 1908 2117 1908 1906 2117 2117 1906 1905 2117 1905 2116 1903 1908 1909 1907 1906 1908 1907 1908 1903 1905 1906 1907 1914 1905 1911 1911 1905 1907 2116 1905 1914 2116 1914 1913 1911 1913 1914 1893 1910 1911 1910 1912 1911 1911 1912 1913 1867 1869 1870 1870 1869 1871 1870 1871 1872 1872 1873 1870 1870 1873 1874 1870 1874 1875 1530 1870 1875 1871 1869 2045 1871 2045 1872 1872 2045 2047 1872 2047 1873 2071 1874 1873 2071 1873 2072 2072 1873 2047 1875 1874 2071 2071 2072 2073 2073 2080 2071 2071 2080 2082 2071 2082 1875 2073 2064 2063 2073 2063 2080 2080 2081 2082 2080 2063 2094 2080 2094 2081 2053 2082 2081 2053 2081 2054 2081 2094 2050 2081 2050 2054 2063 2093 2094 2094 2093 2095 2094 2095 2050 2063 2092 2093 2095 2093 2200 2093 2092 2200 2050 2095 2096 2095 2200 2096 2200 2092 2056 2200 2056 2240 2096 2200 2241 2348 2200 2240 2056 2092 2063 2055 2056 2057 2056 2063 2057 2240 2056 2055 2057 2063 2064 2060 2061 2057 2057 2061 2062 2057 2062 2055 2057 2064 2060 2240 2055 2062 2061 2239 2062 2062 2239 2240 2060 2059 2061 2061 2059 2239 2058 2059 2060 2239 2059 2058 2239 2058 2202 2351 2240 2239 2351 2239 2352 2352 2239 2202 2202 2058 2066 2202 2066 2156 2201 2202 2156 2352 2202 2359 2359 2202 2201 2359 2360 2352 2352 2360 2361 2357 2358 2359 2359 2358 2360 2359 2201 2357 2357 2363 2364 2357 2364 2358 2388 2364 2363 2388 2363 2367 2348 2240 2351 2096 2241 2048 2242 2091 2241 2241 2091 2049 2241 2049 2048 2050 2096 2048 2048 2049 2050 2050 2049 2088 2088 2049 2091 2088 2091 2089 2242 2089 2091 2203 2090 2242 2242 2090 2089 2088 2089 2090 2054 2050 2088 2054 2088 2084 2084 2088 2090 2084 2090 2085 2203 2085 2090 2083 2027 2084 2083 2084 2085 2027 2036 2084 2084 2036 2086 2084 2086 2054 2083 2085 2203 2028 2027 2083 2083 2203 2028 2027 2028 2029 2029 2036 2027 2029 2035 2036 2036 2035 2086 2086 2035 2087 2054 2086 2087 2034 2035 2029 2034 2040 2035 2087 2035 2040 2087 2040 2039 2054 2087 2052 2052 2087 2039 2034 2039 2040 2038 2039 2034 2038 2044 2039 2052 2039 2044 2052 2053 2054 2044 2043 2052 2052 2043 2042 2052 2042 2053 2038 2043 2044 2042 2043 2038 2038 2025 2042 2042 2025 2024 2024 2051 2042 2042 2051 2082 2042 2082 2053 2023 2024 2025 2024 2023 2051 1875 2082 2051 1875 2051 1876 1876 2051 2023 2025 1865 2023 2023 1865 1864 1876 2023 1864 1531 1875 1876 1531 1876 1864 1530 1875 1531 1530 1531 1527 1526 1525 1527 1526 1527 1528 1527 1531 1532 1527 1532 1528 1525 1535 1527 1524 1518 1525 1524 1525 1526 1518 1534 1525 1525 1534 1535 1534 1521 1535 1518 1533 1534 1533 1523 1534 1534 1523 1521 1517 1326 1518 1517 1518 1524 1326 1533 1518 1326 1522 1533 1533 1522 1523 1522 1323 1523 1523 1323 1322 1523 1322 1521 1521 1322 1320 1321 1320 1322 1321 1322 1318 1318 1322 1323 1318 1323 1316 1316 1323 1324 1522 1324 1323 1326 1324 1522 1316 1324 1325 1325 1324 1326 1316 1317 1318 1316 1325 1327 1317 1316 1688 1688 1316 1327 1325 1326 1327 1512 1327 1326 1688 1327 1689 1689 1327 1512 1689 1886 1688 1317 1688 1318 1318 1688 1886 1689 1512 1690 1690 1886 1689 1690 1512 1691 1889 1690 1940 1940 1690 1691 1889 1886 1690 1512 1709 1691 1940 1691 1888 1888 1691 1709 1888 1629 1940 1629 1628 1940 1940 1628 1627 1940 1627 1889 1305 1628 1629 1629 1630 1305 1630 1629 1888 1305 1627 1628 1626 1627 1304 1304 1627 1305 1889 1627 1626 1304 1634 1626 1889 1626 1634 1304 1633 1634 1634 1633 1889 1632 1633 1304 1889 1633 1939 1633 1632 1939 1939 1896 1889 1889 1896 1886 1939 1632 1637 1939 1637 1938 1938 1895 1939 1939 1895 1896 1304 1637 1632 1304 1636 1637 1938 1637 1636 1294 1635 1636 1294 1636 1304 1938 1636 1635 1544 1635 1294 1544 1938 1635 1543 1544 1294 1543 1890 1544 1544 1890 1938 1294 1640 1543 1543 1640 1890 1890 1640 1937 1937 1898 1890 1890 1898 1897 1890 1897 1938 1294 1639 1640 1937 1640 1639 1297 1638 1639 1297 1639 1294 1937 1639 1638 1542 1638 1297 1542 1937 1638 1541 1542 1297 1541 1935 1542 1542 1935 1937 1297 1645 1541 1541 1645 1935 1935 1645 1644 1935 1899 1937 1297 1644 1645 1310 1644 1297 1293 1309 1310 1293 1310 1297 1296 1309 1293 1295 1296 1293 1295 1293 1298 1298 1293 1299 1298 1299 1300 1300 1301 1298 1298 1301 1302 1298 1302 1303 1303 1302 1306 1306 1302 1307 1306 1307 1308 1308 1313 1306 1306 1313 1314 1547 1548 1302 1548 1584 1302 1302 1584 1585 1302 1585 1307 1301 1591 1302 1302 1591 1592 1302 1592 1547 1548 1547 1815 1815 1584 1548 1815 1547 1845 1845 1547 1592 1845 1592 1591 1301 1590 1591 1590 1845 1591 1590 1844 1845 1844 1840 1845 1845 1840 1839 1845 1839 1815 1589 1590 1301 1589 1844 1590 1301 1588 1589 1589 1588 1844 1587 1588 1301 1844 1588 1587 1844 1587 1843 1843 1817 1844 1844 1817 1840 1301 1595 1587 1843 1587 1595 1301 1594 1595 1843 1595 1594 1816 1692 1843 1816 1843 1594 1692 1687 1843 1843 1687 1817 1300 1593 1594 1300 1594 1301 1594 1593 1816 1300 1602 1593 1593 1602 1816 1300 1601 1602 1816 1602 1601 1816 1601 1841 1841 1692 1816 1600 1601 1300 1841 1601 1600 1841 1599 1842 1841 1600 1599 1842 1693 1841 1841 1693 1692 1300 1599 1600 1300 1598 1599 1842 1599 1598 1842 1598 1695 1695 1694 1842 1842 1694 1693 1513 1692 1693 1513 1693 1514 1514 1693 1694 1694 1695 1514 1514 1695 1696 1695 1598 1597 1695 1597 1696 1299 1597 1598 1299 1598 1300 1596 1597 1299 1696 1597 1596 1514 1696 1697 1696 1596 1697 1299 1607 1596 1697 1596 1607 1293 1606 1299 1299 1606 1607 1697 1607 1606 1697 1698 1514 1606 1698 1697 1293 1605 1606 1605 1698 1606 1514 1698 1699 1605 1604 1698 1698 1604 1603 1698 1603 1699 1604 1605 1293 1293 1603 1604 1293 1613 1603 1603 1613 1699 1514 1699 1515 1515 1699 1700 1699 1613 1612 1699 1612 1700 1293 1612 1613 1292 1611 1612 1292 1612 1293 1611 1700 1612 1515 1700 1682 1610 1682 1700 1610 1700 1611 1610 1611 1292 1292 1609 1610 1609 1682 1610 1682 1683 1515 1682 1609 1683 1608 1609 1292 1683 1609 1608 1703 1515 1683 1683 1608 1703 1292 1619 1608 1703 1608 1619 1702 1515 1703 1703 1618 1702 1703 1619 1618 1292 1618 1619 1312 1617 1618 1312 1618 1292 1702 1618 1617 1292 1293 1294 1294 1312 1292 1294 1293 1297 1294 1304 1305 1305 1311 1294 1294 1311 1312 1305 1623 1624 1305 1624 1311 1305 1630 1631 1305 1631 1623 1631 1887 1623 1887 1624 1623 1311 1624 1625 1887 1625 1624 1708 1887 1888 1887 1708 1707 1631 1888 1887 1707 1625 1887 1630 1888 1631 1888 1709 1708 1516 1707 1708 1516 1708 1512 1512 1708 1709 1706 1707 1516 1706 1545 1707 1707 1545 1625 1311 1625 1545 1545 1546 1311 1706 1546 1545 1516 1705 1706 1705 1546 1706 1546 1620 1311 1705 1620 1546 1311 1620 1621 1311 1621 1312 1704 1621 1620 1704 1620 1705 1516 1704 1705 1701 1704 1516 1701 1622 1704 1622 1621 1704 1312 1621 1622 1614 1615 1312 1312 1615 1616 1616 1617 1312 1312 1622 1614 1614 1622 1701 1701 1516 1702 1614 1701 1615 1615 1701 1702 1615 1702 1616 1702 1617 1616 1702 1516 1515 1326 1515 1516 1326 1516 1512 1283 1514 1515 1283 1515 1326 1517 1498 1326 1326 1498 1283 1282 1283 1284 1283 1498 1284 1283 1282 1513 1513 1514 1283 1498 1499 1500 1284 1498 1500 1517 1499 1498 1524 1499 1517 1524 1510 1499 1526 1510 1524 1854 1855 1510 1854 1510 1856 1526 1856 1510 1993 1855 1854 1993 1854 1995 1995 1854 1856 1855 1857 1470 1992 1857 1855 1992 1855 1993 1989 1992 1957 1957 1992 1993 1957 1993 1958 1993 1997 1958 1997 2012 1958 1958 2012 1954 1958 1954 2000 1993 1996 1997 1996 2013 1997 1997 2013 2012 1995 1994 1996 1995 1996 1993 1994 1976 1996 1996 1976 2013 1988 1994 1995 1995 1856 1988 1988 1967 1994 1967 1977 1994 1994 1977 1976 1976 2015 2013 2013 2015 2016 2013 2016 2011 2211 2011 2016 2011 2012 2013 2011 2017 2012 2211 2017 2011 2213 2017 2211 2313 2213 2211 2012 2017 2018 2213 2018 2017 2012 2018 1954 1954 2018 2019 2213 2019 2018 2214 2019 2213 2310 2214 2213 2310 2213 2313 2312 2310 2313 2312 2313 2314 2314 2313 2315 2309 2307 2310 2309 2310 2311 2311 2310 2312 2307 2214 2310 2314 2404 2312 2312 2404 2311 2315 2380 2314 2314 2380 2404 2315 2247 2380 2247 2251 2380 2439 2404 2380 2439 2380 2251 2311 2404 2405 2460 2405 2404 2460 2404 2439 2405 2309 2311 2406 2308 2405 2405 2308 2309 2458 2406 2405 2458 2405 2460 2490 2458 2460 2490 2460 2438 2438 2460 2439 2251 2438 2439 2250 2438 2251 2250 2251 2247 2248 2250 2247 2494 2458 2490 2406 2306 2308 2306 2307 2308 2308 2307 2309 1953 1952 2214 2214 1952 2019 2214 1999 1998 2214 1998 1953 1952 1953 1954 2000 1954 1953 2000 1953 1998 1954 2019 1952 1998 1999 2000 2000 1999 2001 2000 2001 2002 1973 1977 1978 1967 1978 1977 1979 1971 1973 1979 1973 1982 1982 1973 1978 1981 1971 1979 2206 1971 1981 1979 1980 1981 2206 1981 1980 1980 1979 2032 2032 1979 2033 1979 1982 2033 1982 1978 1983 2033 1982 1983 2032 2033 2031 2033 1983 2037 2031 2033 2029 2029 2033 2037 2207 1980 2032 2207 2032 2205 2205 2032 2031 2206 1980 2207 2328 2206 2207 2328 2207 2331 2331 2207 2205 2030 2204 2205 2205 2031 2030 2029 2030 2031 2029 2028 2030 2029 2037 2034 2028 2204 2030 2028 2203 2204 2337 2204 2203 2034 2037 2041 2034 2041 2038 2041 2026 2038 2038 2026 2025 2020 2021 2026 2041 2020 2026 2021 2022 2026 2026 2022 1866 2026 1866 2025 2025 1866 1865 1531 1865 1866 1531 1866 1862 2022 1862 1866 2021 1962 2022 2022 1962 1861 2022 1861 1862 2020 1963 2021 2021 1963 1962 1962 1963 1964 1963 1965 1964 2020 1965 1963 1988 1852 1964 1964 1852 1851 1964 1851 1962 1964 1965 1967 1964 1967 1988 1988 1856 1853 1988 1853 1852 1526 1851 1852 1526 1852 1853 1850 1851 1526 1851 1850 1962 1526 1528 1850 1853 1856 1526 1850 1528 1532 1850 1532 1863 1962 1850 1863 1962 1863 1861 1863 1532 1861 1861 1532 1862 1862 1532 1531 1864 1865 1531 1965 1966 1967 1966 1978 1967 1986 1966 1965 1986 1965 1987 1987 1965 2020 1985 1966 1986 1985 1984 1966 1966 1984 1978 1983 1978 1984 1983 1984 2037 2037 1984 1985 2037 1985 2041 2041 1985 1986 2041 1986 1987 1987 2020 2041 2330 2328 2331 2329 2328 2330 2399 2329 2330 1284 1500 1503 1282 1284 1285 1285 1284 1286 1284 1503 1286 1501 1502 1503 1286 1503 1502 1285 1286 1287 1287 1286 1288 1286 1290 1288 1286 1502 1290 1287 1684 1285 1285 1684 1282 1287 1288 1289 1287 1289 1684 1288 1290 1264 1288 1264 1291 1291 1840 1288 1840 1289 1288 1290 1502 1264 1502 1501 1264 1428 1429 1264 1429 1430 1264 1264 1430 1431 1264 1431 1432 1432 1433 1264 1264 1433 1434 1264 1434 1291 1427 1435 1264 1264 1435 1436 1264 1436 1437 1437 1438 1264 1264 1438 1439 1264 1439 1428 1832 1435 1427 1832 1427 1830 1436 1435 1832 1834 1436 1832 1812 1834 1832 1812 1832 1849 1849 1832 1830 1849 1830 1827 1849 1827 1569 1569 1566 1849 1849 1566 1567 1849 1567 1812 1828 1571 1827 1827 1571 1570 1827 1570 1569 1566 1569 1313 1313 1569 1570 1566 1313 1567 1567 1313 1568 1812 1567 1568 1313 1570 1314 1308 1575 1313 1313 1575 1576 1313 1576 1568 1314 1570 1571 1314 1571 1549 1828 1549 1571 1549 1550 1314 1550 1563 1314 1314 1563 1564 1550 1549 1828 1563 1550 1826 1826 1550 1828 1826 1564 1563 1812 1568 1576 1576 1575 1812 1812 1575 1848 1848 1834 1812 1833 1436 1834 1848 1833 1834 1833 1437 1436 1438 1437 1833 1438 1833 1439 1439 1833 1835 1813 1835 1833 1813 1833 1848 1439 1835 1428 1428 1835 1836 1847 1836 1835 1847 1835 1813 1580 1579 1813 1813 1579 1847 1580 1813 1572 1572 1813 1848 1308 1579 1580 1308 1580 1572 1307 1578 1579 1307 1579 1308 1847 1579 1578 1308 1572 1573 1573 1574 1308 1308 1574 1575 1572 1848 1573 1848 1575 1574 1848 1574 1573 1577 1578 1307 1847 1578 1577 1307 1583 1577 1583 1847 1577 1307 1582 1583 1582 1814 1583 1583 1814 1847 1814 1836 1847 1582 1581 1814 1814 1581 1846 1846 1837 1814 1814 1837 1836 1581 1582 1307 1307 1586 1581 1581 1586 1846 1846 1586 1585 1846 1585 1815 1815 1838 1846 1846 1838 1837 1430 1836 1837 1430 1837 1431 1431 1837 1838 1431 1838 1432 1432 1838 1433 1433 1838 1839 1815 1839 1838 1815 1585 1584 1307 1585 1586 1433 1839 1434 1434 1839 1291 1291 1839 1840 1817 1684 1840 1840 1684 1289 1687 1686 1817 1686 1685 1817 1817 1685 1684 1282 1684 1685 1282 1685 1513 1513 1685 1686 1513 1686 1687 1687 1692 1513 1429 1836 1430 1428 1836 1429 1937 1899 1898 1674 1898 1899 1674 1899 1675 1675 1899 1676 1673 1897 1898 1673 1898 1674 1320 1673 1674 1674 1675 1320 1320 1675 1676 1320 1676 1677 1319 1320 1321 1320 1670 1671 1671 1672 1320 1320 1672 1673 1319 1678 1320 1320 1678 1679 1320 1679 1670 1886 1678 1319 1321 1886 1319 1318 1886 1321 1679 1678 1886 1896 1679 1886 1895 1670 1679 1895 1679 1896 1671 1670 1895 1671 1895 1672 1672 1895 1897 1672 1897 1673 1938 1897 1895 2108 2109 2110 2109 2105 2110 2110 2105 2107 2154 2108 2110 2233 2109 2108 2233 2105 2109 2633 2492 2634 2634 2492 2493 2737 2633 2634 2737 2634 2738 2492 2456 2493 2491 2457 2492 2492 2457 2456 2633 2491 2492 2411 2456 2457 2454 2413 2457 2457 2413 2412 2457 2412 2411 2491 2454 2457 2412 2293 2411 2411 2293 2292 2411 2292 2255 2290 2412 2413 2290 2294 2412 2412 2294 2293 2291 2292 2293 2291 2293 2289 2289 2293 2294 2255 2292 2291 2289 2223 2291 2288 2286 2289 2288 2289 2290 2289 2294 2290 2286 2222 2289 2289 2222 2223 2413 2288 2290 2287 2286 2288 2413 2287 2288 2285 2283 2286 2285 2286 2287 2283 2221 2286 2286 2221 2222 2221 2129 2222 2222 2129 2127 2222 2127 2223 2226 2132 2221 2221 2132 2131 2221 2131 2129 2283 2226 2221 2128 2127 2129 2128 2129 2130 2129 2131 2130 2125 2126 2127 2125 2127 2128 2223 2127 2126 2161 2125 2128 2161 2128 2162 2162 2128 2130 2176 2161 2162 2162 2130 2163 2176 2162 2177 2177 2162 2163 2177 2189 2176 2176 2189 2190 2177 2163 2178 2178 2188 2177 2177 2188 2189 2163 2130 2133 2163 2133 2164 2178 2163 2164 2178 2164 2179 2179 2187 2178 2178 2187 2188 2187 1945 2188 2188 1945 1944 2188 1944 2189 2179 2186 2187 2186 1946 2187 2187 1946 1945 2179 2164 2165 2164 2133 2135 2164 2135 2165 2165 2135 2138 2133 2134 2135 2134 2136 2135 2135 2136 2137 2135 2137 2138 2137 2139 2138 2138 2139 2140 2224 2139 2137 2224 2137 2136 2224 2136 2225 2225 2136 2134 2229 2139 2224 2274 2229 2224 2274 2224 2277 2277 2224 2225 2229 2140 2139 2228 2142 2140 2228 2140 2229 2271 2228 2229 2271 2229 2274 2227 2142 2228 2268 2227 2228 2268 2228 2271 2227 2144 2142 2232 2145 2227 2227 2145 2144 2265 2232 2227 2265 2227 2268 2231 2147 2232 2232 2147 2145 2262 2231 2232 2262 2232 2265 2264 2262 2265 2264 2265 2266 2266 2265 2267 2267 2265 2268 2261 2257 2262 2261 2262 2263 2263 2262 2264 2257 2231 2262 2421 2263 2264 2421 2264 2266 2267 2421 2266 2267 2268 2269 2269 2420 2267 2267 2420 2421 2422 2263 2421 2450 2422 2421 2450 2421 2453 2453 2421 2420 2422 2261 2263 2381 2261 2422 2381 2422 2450 2381 2450 2451 2501 2451 2450 2501 2450 2502 2502 2450 2453 2451 2383 2382 2451 2382 2381 2378 2382 2383 2377 2381 2382 2377 2382 2378 2260 2377 2378 2259 2377 2260 2259 2381 2377 2257 2259 2260 2257 2258 2259 2259 2258 2381 2258 2257 2261 2381 2258 2261 2418 2452 2453 2453 2420 2418 2502 2453 2503 2503 2453 2452 2269 2418 2420 2269 2268 2270 2270 2418 2269 2270 2268 2271 2270 2271 2272 2270 2272 2418 2272 2271 2273 2273 2271 2274 2418 2272 2273 2273 2274 2275 2418 2273 2419 2419 2273 2275 2275 2274 2276 2276 2274 2277 2419 2275 2417 2417 2275 2276 2418 2419 2452 2452 2419 2417 2416 2417 2278 2417 2276 2278 2452 2417 2455 2455 2417 2416 2276 2277 2278 2278 2277 2279 2279 2277 2280 2277 2225 2280 2278 2279 2416 2416 2279 2281 2416 2281 2415 2455 2416 2415 2279 2280 2281 2281 2280 2282 2282 2280 2283 2280 2225 2226 2280 2226 2283 2225 2134 2226 2226 2134 2132 2133 2132 2134 2130 2131 2132 2130 2132 2133 2282 2283 2284 2284 2283 2285 2414 2415 2284 2284 2285 2414 2415 2282 2284 2414 2285 2287 2414 2287 2413 2415 2414 2454 2454 2414 2413 2415 2281 2282 2415 2454 2455 2491 2455 2454 2504 2452 2455 2504 2455 2491 2652 2504 2491 2652 2491 2633 2503 2452 2504 2651 2503 2504 2651 2504 2652 2735 2651 2652 2735 2652 2736 2736 2652 2633 2736 2633 2737 2737 2900 2736 2736 2900 2901 2736 2901 2735 2734 2651 2735 2735 2901 2902 2735 2902 2734 2650 2503 2651 2734 2650 2651 2650 2502 2503 2649 2502 2650 2733 2649 2650 2733 2650 2734 2733 2734 2866 2734 2902 2903 2734 2903 2866 2732 2649 2733 2866 2867 2733 2733 2867 2868 2733 2868 2732 2866 3216 2867 3216 3217 2867 2867 3217 3218 2867 3218 2868 3215 3216 2866 3449 3216 3448 3448 3216 3215 3449 3217 3216 3449 3218 3217 2868 3218 3219 3450 3219 3218 3450 3218 3449 3470 3450 3449 3470 3449 3471 3471 3449 3448 3469 3450 3470 3477 3469 3470 3477 3470 3479 3479 3470 3471 3471 3448 3472 3479 3471 3481 3481 3471 3472 3478 3477 3479 3478 3479 3480 3480 3479 3481 3476 3475 3477 3476 3477 3478 3475 3469 3477 3480 3501 3478 3478 3501 3503 3478 3503 3476 3480 3481 3482 3482 3499 3480 3480 3499 3501 3499 3500 3501 3501 3500 3502 3501 3502 3503 3476 3503 3505 3476 3505 3474 3505 3487 3486 3505 3486 3474 3474 3475 3476 3474 3486 3492 3474 3492 3475 3486 3487 3488 3486 3488 3492 3488 3487 3489 3510 3489 3487 3488 3489 3490 3490 3485 3488 3492 3488 3485 3492 3485 3493 3475 3492 3493 3428 3452 3485 3490 3428 3485 3493 3485 3452 3490 3489 3491 3490 3491 3427 3427 3428 3490 3201 3200 3428 3200 3199 3428 3428 3199 3452 3427 3201 3428 3203 3202 3427 3427 3491 3426 3427 3426 3203 3202 3201 3427 2872 3200 3201 2872 3201 2873 2873 3201 3202 3199 3200 2872 2872 3208 3199 3199 3208 3452 2731 2871 2872 2871 3207 2872 2872 3207 3208 3208 3207 3452 2871 3206 3207 3452 3207 3206 2870 2871 2731 3204 2871 3205 3205 2871 2870 3204 3206 2871 2731 2648 2732 2732 2870 2731 2648 2501 2649 2732 2648 2649 2868 2869 2732 2732 2869 2870 3211 3212 2868 2868 3212 3213 2868 3213 2869 2868 3219 3211 2869 3209 2870 2869 3213 3214 2869 3214 3209 3213 3212 3450 3450 3214 3213 3450 3212 3211 3211 3219 3450 3469 3451 3450 3450 3451 3214 3451 3209 3214 2870 3209 3210 3451 3210 3209 2870 3210 3205 3205 3210 3451 3493 3452 3451 3451 3452 3204 3451 3204 3205 3469 3493 3451 3475 3493 3469 3452 3206 3204 2649 2501 2502 2873 3202 2874 2874 3202 3203 2874 3196 3197 2874 3197 2875 2874 3203 3196 3203 3426 3196 3197 3196 3426 2875 3197 3198 3198 3197 3425 3425 3197 3426 3192 3193 2875 2875 3193 3194 2875 3194 2876 2875 3198 3192 3192 3198 3425 3192 3425 3193 3194 3193 3454 3454 3193 3425 3425 3426 3508 3454 3425 3514 3514 3425 3508 3508 3426 3491 3508 3491 3509 3514 3508 3519 3519 3508 3509 3513 3454 3514 3518 3513 3514 3518 3514 3519 3519 3509 3526 3509 3491 3489 3509 3489 3510 3526 3509 3510 3512 3453 3513 3513 3453 3454 3512 3455 3453 3453 3188 3454 3455 3186 3453 3453 3186 3187 3453 3187 3188 3454 3188 3195 3454 3195 3194 3187 2876 3188 2876 3195 3188 3186 2877 3187 3187 2877 2876 3186 3189 2877 3455 3189 3186 2877 3189 3190 2877 3190 2878 3455 3190 3189 2878 3190 3191 3191 3190 3455 2878 2879 2727 3180 2879 2878 3180 2878 3181 3181 2878 3182 2878 3191 3182 3456 3182 3191 3191 3455 3456 3456 3181 3182 3456 3180 3181 3179 2879 3180 3458 3179 3180 3458 3180 3456 3179 3183 2879 3457 3183 3179 3457 3179 3458 2879 3183 3184 3184 3183 3457 3457 3174 3185 3457 3185 3184 2879 3184 2880 2880 3184 3185 2880 3185 3174 3174 3175 2880 2727 2879 2880 2876 3194 3195 3500 3438 3502 3502 3438 3435 3499 3498 3500 3498 3436 3500 3500 3436 3438 3497 3498 3499 3482 3497 3499 3497 3496 3498 3496 3439 3498 3498 3439 3436 3495 3496 3497 3483 3495 3497 3483 3497 3482 3482 3481 3468 3482 3468 3483 3483 3468 3465 3483 3465 3484 3484 3495 3483 3421 3494 3495 3495 3494 3496 3484 3421 3495 3321 3344 3421 3344 3466 3421 3421 3466 3494 3321 3421 3484 3466 3445 3494 3494 3445 3442 3494 3442 3496 3496 3442 3439 3439 3440 3436 3442 3443 3439 3439 3443 3444 3439 3444 3440 3436 3440 3441 3444 3550 3440 3440 3550 3441 3436 3437 3438 3436 3441 3437 3441 3550 3557 3441 3557 3437 3550 3548 3551 3551 3556 3550 3550 3556 3557 3444 3548 3550 3443 3548 3444 3443 3391 3548 3391 3545 3548 3548 3545 3549 3551 3548 3549 3543 3544 3545 3391 3543 3545 3549 3545 3551 3551 3545 3544 3547 3543 3391 3544 3543 3559 3559 3543 3547 3551 3544 3554 3554 3544 3559 3558 3559 3560 3560 3559 3414 3559 3547 3414 3554 3559 3552 3552 3559 3558 3391 3546 3547 3414 3547 3546 3391 3415 3546 3414 3546 3415 3390 3389 3391 3390 3391 3392 3389 3413 3391 3443 3392 3391 3413 3415 3391 3415 3413 3414 3389 3412 3413 3414 3413 3412 3386 3388 3389 3386 3389 3390 3388 3412 3389 3390 3392 3442 3442 3386 3390 3442 3392 3443 3445 3387 3442 3442 3387 3386 3385 3386 2973 2973 3386 3387 3385 3388 3386 3385 3411 3388 3388 3411 3412 3414 3412 3411 3385 3410 3411 3065 3414 3411 3065 3411 3066 3066 3411 3410 2973 3410 3385 2973 2970 3410 3066 3410 2970 2764 3065 3066 2764 3066 2765 2765 3066 3067 2970 3067 3066 2763 3064 3065 2763 3065 2764 3064 3414 3065 2674 2763 2764 2674 2764 2675 2675 2764 2765 2675 2765 2676 2676 2765 2766 2765 3067 2766 2515 2674 2675 2515 2675 2520 2520 2675 2676 2514 2673 2674 2514 2674 2515 2673 2763 2674 2513 2514 2515 2520 2513 2515 2511 2513 2520 2520 2676 2511 2511 2676 2665 2676 2766 2665 2511 2665 2509 2509 2665 2666 2665 2766 2767 2665 2767 2666 2509 2510 2511 2509 2666 2510 2510 2666 2667 2666 2767 2768 2666 2768 2667 2766 3056 2767 2767 3056 3057 2767 3057 2768 2667 2768 2769 2768 3057 3058 2768 3058 2769 3058 3057 3012 3012 3057 3056 2766 3067 3056 3012 3056 2972 2972 3056 3067 2972 3067 2970 2970 2971 2972 2972 2971 2968 2968 3012 2972 2945 2969 2970 2970 2969 2971 2945 2970 2943 2943 2970 2973 2968 2971 2975 2969 3009 2971 3009 2975 2971 2945 2947 2969 2969 2947 3009 3038 3010 3009 3009 3010 2975 3048 3038 3009 3048 3009 2949 2949 3009 2947 2968 2975 2966 3010 2966 2975 3014 3011 3010 3010 3011 2967 3010 2967 2966 3038 3014 3010 2966 2967 2968 2967 3011 2968 2968 3011 3012 3014 3012 3011 3013 3012 3014 3006 3013 3014 3006 3014 3038 3012 3013 3058 3005 3013 3006 3135 3058 3013 3135 3013 3131 3131 3013 3005 2769 3058 3059 3059 3058 3135 2840 3134 3135 2840 3135 2839 2839 3135 3131 3059 3135 3134 3130 2839 3131 3131 3005 3130 2839 2588 2840 2865 2464 2839 2839 2464 2462 2839 2462 2588 3130 2865 2839 3126 2865 3130 3130 3005 3004 3130 3004 3126 2864 2558 2865 2865 2558 2464 2865 3126 2864 2864 3126 3127 3004 3127 3126 2860 2560 2864 2864 2560 2558 2864 3127 2860 2557 2464 2558 2557 2558 2559 2559 2558 2560 2559 2560 2561 2561 2560 2562 2859 2562 2560 2859 2560 2860 2860 3127 3128 2860 3128 2859 2858 2562 2859 2859 3128 3129 2859 3129 2858 2561 2562 2563 2563 2562 2564 2858 2564 2562 2559 2561 2557 2557 2561 2563 2463 2464 2557 2557 2563 2463 2461 2462 2463 2463 2462 2464 2463 2563 2461 2461 2588 2462 2587 2586 2588 2587 2588 2461 2840 2588 2586 2585 2586 2587 2585 2587 2461 2585 2584 2586 2840 2586 2813 2813 2586 2584 2813 3134 2840 2812 2813 2814 2814 2813 2815 2813 2584 2815 2812 3133 2813 2813 3133 3134 3134 3133 3059 2812 3132 3133 3059 3133 3132 2814 3132 2812 2815 3140 2814 2814 3140 3132 2815 2584 2809 2809 3139 2815 2815 3139 3140 3060 3132 3140 3060 3140 3061 3061 3140 3139 3059 3132 3060 2769 3059 2770 2770 3059 3060 2770 3060 2771 2771 3060 3061 2771 3061 2772 2772 3061 3062 3061 3139 3062 2809 3138 3139 3062 3139 3138 2772 3062 2761 2761 3062 3063 3062 3138 3063 2670 2771 2772 2670 2772 2671 2671 2772 2761 2669 2770 2771 2669 2771 2670 2517 2669 2670 2517 2670 2518 2518 2670 2671 2518 2671 2519 2519 2671 2672 2671 2761 2672 2511 2517 2518 2518 2519 2511 2511 2516 2517 2516 2669 2517 2516 2668 2669 2668 2770 2669 2512 2516 2511 2512 2668 2516 2511 2510 2512 2511 2519 2513 2519 2672 2513 2513 2672 2673 2513 2673 2514 2672 2762 2673 2673 2762 2763 2672 2761 2762 2761 3063 2762 2762 3063 3064 2762 3064 2763 3063 3138 3137 3063 3137 3064 3144 3143 3064 3064 3143 3414 3064 3137 3136 3064 3136 3144 2811 3136 3137 2811 3137 2810 2810 3137 3138 2810 3138 2809 2809 2718 2810 2810 2718 2717 2810 2717 2811 2584 2582 2809 2809 2582 2718 2608 2717 2718 2608 2718 2581 2581 2718 2582 2609 2716 2717 2609 2717 2608 2717 2716 2811 2608 2469 2609 2605 2469 2608 2605 2608 2563 2563 2608 2581 2581 2582 2583 2563 2581 2461 2461 2581 2583 2583 2582 2584 2583 2584 2585 2461 2583 2585 2563 2564 2605 2605 2564 2713 2857 2713 2564 2857 2564 2858 2605 2713 2606 2606 2713 2714 2856 2714 2713 2856 2713 2857 2858 3120 2857 2857 3120 3121 2857 3121 2856 2858 3129 3120 3092 3121 3120 3092 3120 3129 2856 3121 3122 3103 3122 3121 3103 3121 3092 2855 2714 2856 2856 3122 2855 2855 3122 3123 3102 3123 3122 3102 3122 3103 2799 3102 3103 2799 3103 2800 2800 3103 3092 2798 3101 3102 2798 3102 2799 3101 3123 3102 2855 3123 2854 2854 3123 3124 3101 3124 3123 2797 3100 3101 2797 3101 2798 3100 3124 3101 2710 2797 2798 2710 2798 2711 2711 2798 2799 2709 2797 2710 2709 2808 2797 2808 3100 2797 2808 3099 3100 3099 3125 3100 3100 3125 3124 2708 2807 2808 2708 2808 2709 2807 3099 2808 2548 2708 2709 2548 2709 2549 2549 2709 2710 2550 2707 2708 2550 2708 2548 2707 2807 2708 2707 2806 2807 2806 3098 2807 2807 3098 3099 2551 2706 2707 2551 2707 2550 2706 2806 2707 2550 2548 2551 2548 2549 2547 2551 2548 2547 2549 2710 2547 2547 2710 2711 2547 2711 2556 2556 2711 2712 2711 2799 2712 2555 2545 2556 2556 2545 2547 2556 2712 2555 2555 2712 2701 2712 2799 2800 2712 2800 2701 2553 2554 2555 2555 2554 2545 2555 2701 2553 2553 2701 2702 2701 2800 2801 2701 2801 2702 2800 3092 2801 2702 2801 2802 2801 3092 3093 2801 3093 2802 2553 2702 2554 2554 2702 2703 2702 2802 2703 2554 2703 2545 2545 2703 2704 2703 2802 2803 2703 2803 2704 2802 3093 3094 2802 3094 2803 3017 3094 3093 3017 3093 3037 3037 3093 3092 2803 3094 3095 3016 3095 3094 3016 3094 3017 2704 2803 2804 2803 3095 2804 2804 3095 3096 3018 3096 3095 3018 3095 3016 3015 3016 3017 3018 3016 3019 3019 3016 3015 3024 3018 3044 3044 3018 3019 3097 3096 3018 3018 3024 3097 2804 3096 2805 2805 3096 3097 2805 3097 2806 2806 3097 3098 3097 3024 3119 3097 3119 3098 2705 2804 2805 2705 2805 2706 2706 2805 2806 2546 2704 2705 2546 2705 2552 2552 2705 2706 2704 2804 2705 2552 2706 2551 2551 2547 2552 2552 2547 2546 2545 2546 2547 2545 2704 2546 3098 3119 3118 3118 3117 3098 3098 3117 3116 3098 3116 3099 2821 3117 3118 2821 3118 2820 2820 3118 3119 2822 3116 3117 2822 3117 2821 2852 3116 2822 2852 3125 3116 3099 3116 3125 2821 2570 2822 2822 2570 2852 2820 2570 2821 2819 2572 2820 2820 2572 2570 2820 3119 2819 2819 3119 3115 3024 3115 3119 3114 2819 3115 3022 3114 3115 3022 3115 3024 3023 3022 3024 3024 3044 3023 3021 3022 3023 3021 3114 3022 3110 2835 3114 3114 2835 2819 3021 3110 3114 2835 3110 2826 2826 3110 3111 3111 3110 3021 2826 2625 2835 2835 2625 2484 2835 2484 2819 2826 2626 2625 2846 2626 2826 2826 3111 2846 2846 3111 3112 3112 3111 3083 3083 3111 3021 2845 2626 2846 2846 3112 2845 2845 3112 3113 3083 3113 3112 3083 3026 3084 3083 3105 3104 3083 3104 3113 3083 3021 3026 2845 3113 2844 2844 3113 3104 2844 2627 2845 2845 2627 2626 2843 2628 2844 2844 2628 2627 2844 3104 2843 2843 3104 3105 2843 3105 2842 2842 3105 3106 2842 2722 2843 2843 2722 2628 2616 2627 2628 2616 2628 2618 2618 2628 2722 2618 2722 2617 2617 2722 2723 2842 2723 2722 2841 2723 2842 2842 3106 2841 2617 2723 2614 2614 2723 2724 2841 2724 2723 2614 2475 2617 2617 2475 2474 2617 2474 2618 2614 2615 2595 2595 2613 2614 2614 2613 2475 2614 2724 2615 2615 2724 2629 2823 2629 2724 2823 2724 2841 2615 2629 2619 2619 2629 2630 2630 2629 2823 2615 2619 2620 2619 2630 2620 2620 2630 2631 2620 2624 2615 2620 2631 2624 2624 2631 2632 2615 2624 2485 2624 2632 2485 2485 2632 2486 2632 2832 2486 2485 2486 2487 2615 2485 2595 2595 2485 2487 2487 2486 2488 2486 2832 2488 2487 2488 2589 2487 2589 2591 2595 2487 2593 2593 2487 2591 2589 2488 2590 2589 2590 2591 2430 2474 2475 2430 2475 2429 2429 2475 2476 2613 2476 2475 2431 2473 2474 2431 2474 2430 2618 2474 2473 2430 2423 2431 2431 2423 2425 2425 2473 2431 2425 2472 2473 2473 2472 2618 2618 2472 2607 2618 2607 2616 2424 2471 2472 2424 2472 2425 2471 2606 2472 2472 2606 2607 2423 2424 2425 2423 2471 2424 2423 2470 2471 2470 2605 2471 2471 2605 2606 2606 2714 2607 2607 2714 2715 2855 2715 2714 2607 2715 2565 2565 2715 2566 2854 2566 2715 2854 2715 2855 2565 2566 2567 2616 2607 2565 2616 2565 2481 2481 2565 2567 2567 2566 2568 2853 2568 2566 2853 2566 2854 2854 3124 2853 2852 2568 2853 2853 3124 3125 2853 3125 2852 2567 2568 2569 2569 2568 2570 2852 2570 2568 2569 2570 2571 2569 2571 2481 2481 2567 2569 2571 2570 2572 2571 2572 2481 2481 2572 2482 2819 2482 2572 2481 2482 2483 2483 2482 2484 2819 2484 2482 2481 2483 2616 2621 2622 2483 2483 2622 2623 2483 2623 2616 2483 2484 2621 2621 2484 2625 2621 2625 2622 2622 2625 2626 2622 2626 2623 2623 2626 2627 2623 2627 2616 2470 2469 2605 2432 2469 2470 2432 2470 2423 2433 2469 2432 2433 2480 2469 2609 2469 2480 2432 2423 2433 2430 2426 2423 2433 2423 2426 2433 2426 2434 2434 2480 2433 2434 2479 2480 2609 2480 2610 2610 2480 2479 2610 2716 2609 2610 2479 2478 2579 2610 2611 2611 2610 2478 2579 2580 2610 2610 2580 2716 2428 2478 2479 2428 2479 2434 2434 2426 2428 2426 2427 2428 2427 2478 2428 2427 2477 2478 2611 2478 2612 2612 2478 2477 2426 2477 2427 2426 2476 2477 2612 2477 2613 2613 2477 2476 2612 2720 2611 2611 2720 2721 2611 2721 2597 2597 2721 2598 2721 2818 2598 2597 2598 2599 2599 2598 2600 2598 2818 2600 2600 2818 2834 2599 2600 2601 2601 2600 2602 2602 2600 2833 2600 2834 2833 2599 2601 2597 2601 2602 2603 2597 2601 2603 2603 2602 2604 2833 2849 2602 2602 2849 2850 2602 2850 2604 2834 3147 2833 2833 3147 3148 2833 3148 2849 2849 3148 3149 2849 3149 2850 2604 2850 2851 2850 3149 3150 2850 3150 2851 3068 3150 3149 3068 3149 3069 3069 3149 3148 3069 3148 3147 2775 3068 3069 2775 3069 2776 2774 3068 2775 2774 3079 3068 3068 3079 3414 3414 3150 3068 2851 3150 3146 3414 3146 3150 3145 2851 3146 3145 3146 3414 3141 2861 3145 3145 2861 2851 3141 3145 3414 2861 3141 2862 2862 3141 3142 3414 3142 3141 2468 2851 2861 2468 2861 2574 2574 2861 2862 2604 2851 2466 2466 2851 2468 2467 2466 2468 2467 2468 2573 2573 2468 2574 2573 2574 2575 2575 2574 2576 2574 2862 2576 2575 2577 2573 2573 2577 2579 2573 2579 2467 2465 2466 2467 2467 2579 2465 2465 2604 2466 2603 2604 2465 2579 2597 2465 2597 2603 2465 2577 2578 2579 2579 2578 2580 2611 2597 2579 2575 2576 2577 2577 2576 2578 2847 2580 2578 2847 2578 2848 2848 2578 2576 2811 2716 2580 2811 2580 2847 2847 3136 2811 2848 3144 2847 2847 3144 3136 2576 2863 2848 2863 3143 2848 2848 3143 3144 2576 2862 2863 2862 3142 2863 2863 3142 3143 3414 3143 3142 3416 3417 3414 3079 3419 3414 3414 3419 3420 3414 3420 3416 3560 3414 3417 3398 3416 3420 3398 3417 3416 3398 3560 3417 3558 3560 3398 3398 3552 3558 3552 3553 3554 3398 3553 3552 3554 3553 3555 3555 3553 3398 3554 3555 3551 3551 3555 3556 3556 3555 3557 3557 3555 3398 3557 3398 3437 3438 3437 3397 3437 3398 3397 3397 3396 3438 3438 3396 3395 3438 3395 3435 3396 3397 3398 3165 3395 3396 3400 3165 3396 3400 3396 3401 3401 3396 3398 3165 3394 3395 3435 3395 3394 3168 3435 3393 3435 3394 3393 3393 3394 3165 3165 3168 3393 3399 3165 3400 3399 3166 3165 3400 3418 3399 3399 3418 3166 3401 3419 3400 3400 3419 3418 3398 3420 3401 3401 3420 3419 3079 3418 3419 3166 3418 3079 2773 3079 2774 2687 2773 2688 2688 2773 2774 2688 2774 2677 2677 2774 2775 2529 2687 2688 2529 2688 2528 2528 2688 2677 2523 2687 2529 2528 2523 2529 2527 2523 2528 2528 2677 2527 2527 2677 2678 2677 2775 2678 2678 2775 2776 2527 2678 2526 2526 2678 2679 2678 2776 2679 2526 2521 2527 2527 2521 2523 2526 2679 2521 2429 2476 2426 2429 2426 2430 3025 3026 3021 3027 3028 3026 3026 3025 3027 3084 3026 3028 3021 3023 3025 3025 3023 3054 3023 3044 3041 3023 3041 3054 3025 3054 3053 3027 3025 3053 3027 3053 3052 3052 3053 3002 3033 3027 3052 3033 3052 3032 3032 3007 3033 3033 3007 3029 3033 3029 3028 3028 3027 3033 3031 3008 3032 3032 3008 3007 3031 2908 3003 3031 3003 3008 2752 3007 3008 2752 3008 2751 3008 3003 2750 3008 2750 2751 2908 2905 3003 3003 2745 2750 2745 3003 2746 2746 3003 2905 2750 2745 2751 2751 2745 2661 2751 2661 2752 2661 2745 2746 2752 2661 2753 3030 2753 2661 3030 2661 3087 3087 2661 2659 2752 2753 2754 3030 2754 2753 3029 3007 3030 3030 3007 2754 3086 3029 3030 3086 3030 3087 3087 2659 3088 3085 3029 3086 3085 3028 3029 3084 3028 3085 2754 3007 2752 3043 3039 3041 3043 3041 3044 3042 3039 3043 3044 3019 3043 3043 3019 3020 3043 3020 3042 3042 2931 3039 2931 2933 3039 2929 2931 3042 3042 3020 3034 3042 3034 2929 3019 3015 3020 3034 3020 3035 3035 3020 3015 2929 3034 2940 3035 3046 3034 3034 3046 2938 3034 2938 2940 3035 3015 3036 3036 3047 3035 3035 3047 3046 3036 3015 3017 3036 3017 3037 3037 3050 3036 3036 3050 3047 3045 3046 3047 3049 3045 3047 3049 3047 3050 3037 3004 3050 3050 3004 3006 3050 3006 3049 3037 3092 3004 3004 3005 3006 3004 3092 3127 3049 3006 3038 3048 3045 3049 3049 3038 3048 2949 2951 3048 3048 2951 3045 2947 2948 2949 2949 2948 2950 2949 2950 2951 2951 2950 2952 2951 2952 2953 2951 2953 3045 2948 3342 2950 2950 3342 2952 2947 2946 2948 2946 3381 2948 2948 3381 3342 2945 2946 2947 2945 2944 2946 2944 3381 2946 3381 3382 3342 3382 3381 3422 2944 3422 3381 2943 2944 2945 2943 3422 2944 2943 3445 3422 3382 3422 3466 3466 3422 3445 3342 3382 3383 3466 3383 3382 3344 3343 3466 3466 3343 3383 3342 3383 3343 3342 3343 3320 3320 3343 3344 3320 3344 3321 3319 3281 3320 3319 3320 3321 3380 3342 3320 3380 3320 3379 3379 3320 3281 2952 3342 3380 3379 3277 3380 3380 3277 2954 3380 2954 2952 3378 3376 3379 3379 3376 3277 3379 3281 3378 2955 2954 3277 3376 3373 3277 3277 3373 2935 3277 2935 2955 2953 2952 2954 2953 2954 2934 2934 2954 2955 2934 2955 2935 2934 2935 2936 2936 2935 2937 3373 2937 2935 3372 3369 3373 3373 3369 2937 3376 3372 3373 2936 2937 2938 2938 2937 2939 3369 2939 2937 3046 2934 2936 3046 2936 2938 3045 2953 2934 3045 2934 3046 2938 2939 2940 2940 2939 2941 3341 2941 2939 3369 3341 2939 3368 3341 3369 3372 3368 3369 3340 2942 3341 3341 2942 2941 2940 2941 2929 2929 2941 2942 2929 2942 2930 3340 2930 2942 2932 2930 3340 2929 2930 2931 2931 2930 2932 2932 2933 2931 3371 3368 3372 3374 3370 3371 3374 3371 3375 3375 3371 3372 3375 3372 3376 3377 3374 3375 3377 3375 3378 3378 3375 3376 3299 3370 3374 3300 3299 3374 3300 3374 3377 3299 3285 3370 3237 3246 3285 3237 3285 3236 3246 3298 3285 3236 3285 3299 3236 2898 3237 2898 3246 3237 2898 3245 3246 3246 3245 3298 3245 3244 3298 3298 3244 3243 2897 3244 3245 2897 3245 2898 3243 3244 2897 2738 2897 2898 2738 2898 2737 2898 2899 2737 2737 2899 2900 3234 2899 3235 3235 2899 2898 3234 3238 2899 2899 3238 3239 2899 3239 2900 3299 3238 3234 3299 3234 3235 3235 2898 3236 3235 3236 3299 3239 3238 3299 3239 3299 3300 2900 3239 3240 3300 3240 3239 3229 3240 3300 3377 3301 3300 3300 3301 3230 3300 3230 3229 2900 3240 3229 3229 3230 2900 2900 3230 2901 3230 3231 2901 3301 3231 3230 2901 3231 3232 2901 3232 2902 3301 3232 3231 2902 3232 3233 3301 3233 3232 3220 3221 2902 3221 3226 2902 2902 3226 3227 2902 3227 2903 2902 3233 3220 3302 3220 3233 3302 3233 3301 3221 3220 3429 3429 3220 3302 3226 3221 3429 3226 3429 3227 2903 3227 3228 3429 3228 3227 2903 3228 3222 3228 3446 3222 3429 3446 3228 3222 3223 2903 3222 3446 3447 3222 3447 3223 3473 3447 3446 3467 3473 3446 3467 3446 3429 3472 3447 3473 3468 3472 3473 3468 3473 3467 3429 3423 3467 3467 3423 3465 3467 3465 3468 3481 3472 3468 3472 3448 3447 3448 3225 3447 3448 3215 3225 2866 3224 3225 2866 3225 3215 3447 3225 3224 2903 3224 2866 2903 3223 3224 3447 3224 3223 3314 3465 3282 3282 3465 3423 3484 3465 3314 3284 3280 3314 3284 3314 3282 3484 3314 3280 3282 3283 3284 3282 3423 3283 3308 3307 3423 3283 3423 3307 3429 3308 3423 3283 3307 3284 3284 3307 3308 3284 3308 3301 3301 3308 3309 3309 3308 3429 3429 3302 3309 3301 3309 3302 3377 3284 3301 3378 3284 3377 3378 3281 3284 3279 3280 3281 3281 3280 3284 3279 3281 3319 3280 3279 3484 3484 3279 3319 3484 3319 3321 2974 3445 2943 2974 3384 3445 3445 3384 3387 2943 2973 2974 3384 2974 2973 2973 3387 3384 3092 3128 3127 3129 3128 3092 2510 2667 2512 2512 2667 2668 2667 2769 2668 2668 2769 2770 2186 1947 1946 2189 1944 1943 2189 1943 2190 1809 1943 1944 1809 1944 1810 1943 1808 1807 1808 1943 1809 1800 1808 1809 1800 1809 1801 1801 1809 1810 1801 1810 1740 1787 1800 1801 1787 1801 1788 1788 1801 1740 1786 1799 1800 1786 1800 1787 1799 1808 1800 1799 1807 1808 1785 1799 1786 1769 1785 1786 1769 1786 1770 1770 1786 1787 1770 1787 1771 1771 1787 1788 1751 1769 1770 1751 1770 1750 1750 1770 1771 1752 1769 1751 1750 1421 1751 1751 1421 1422 1751 1422 1752 1749 1425 1750 1425 1424 1750 1750 1424 1421 1750 1771 1749 1421 1224 1422 1421 1424 1224 1422 1224 1223 1422 1223 1423 1422 1423 1752 1752 1423 1420 1423 1223 1420 1192 1222 1223 1192 1223 1191 1191 1223 1224 1222 1420 1223 1222 1419 1420 1193 1222 1192 1192 1166 1193 1191 1224 1190 1190 1224 1225 1224 1424 1425 1224 1425 1225 1213 1190 1214 1190 1225 1214 1225 1380 1214 1225 1425 1426 1225 1426 1380 1749 1426 1425 1748 1380 1426 1748 1426 1749 1214 1380 1381 1381 1380 1748 1214 1381 1213 1381 1382 1213 1747 1382 1381 1747 1381 1748 1749 1772 1748 1748 1772 1773 1748 1773 1747 1749 1771 1772 1771 1788 1772 1772 1788 1789 1772 1789 1773 1747 1773 1774 1773 1789 1731 1773 1731 1774 1788 1740 1789 3463 3348 3346 3463 3346 3345 3540 3539 3463 3540 3463 3541 3541 3463 3345 3316 3345 3346 3315 3345 3316 3541 3345 3315 3521 3540 3541 3521 3541 3462 3462 3541 3315 3538 3539 3540 3538 3537 3539 3537 3431 3539 3535 3432 3537 3537 3432 3431 3409 3408 3431 3409 3431 2961 2961 3431 2960 2960 3431 3432 2960 3432 3407 3407 3432 3433 3535 3433 3432 2956 2756 2960 3407 2956 2960 3406 3001 3407 3407 3001 2956 3407 3433 3406 3430 3404 3433 3433 3404 3405 3433 3405 3406 3405 3000 3406 3406 3000 3001 3000 2988 3001 3001 2988 2957 3001 2957 2956 2956 2957 2756 2756 2957 2958 2988 2958 2957 2756 2958 2959 2958 2988 2959 2959 2988 2989 2997 2989 2988 2997 2988 2996 2996 2988 3000 2996 3000 2999 3405 2999 3000 3404 2999 3405 2999 2976 2996 3404 2976 2999 3403 2976 3404 3403 3404 3430 2997 2982 2998 2998 2989 2997 2998 2982 2995 2998 2995 2991 2991 2990 2998 2998 2990 2989 3075 2991 2995 2990 2991 2992 3074 2992 2991 3074 2991 3075 2962 2990 2992 2962 2992 2963 3073 2992 3074 2992 2756 2963 2962 2963 2964 2964 2990 2962 2964 2963 2756 2964 2756 2965 2965 2756 2959 2965 2990 2964 2959 2989 2965 2965 2989 2990 3409 2961 2653 2653 3408 3409 3315 3316 3317 3462 3315 3317 3317 3316 3311 3317 3311 3318 3462 3317 3318 3318 3461 3462 3318 3311 3310 3318 3310 3461 3310 3311 3312 3461 3310 3312 3461 3312 3313 3359 3355 3356 3292 3355 3359 1077 1089 1076 1076 1089 1090 1076 1050 1077 1077 1050 1051 1077 1051 1078 1075 1049 1076 1076 1049 1050 1076 1090 1075 1049 1046 1050 1050 1046 1028 1050 1028 1051 1051 1028 1029 1051 1029 1052 1078 1051 1052 1028 1017 1029 1046 1018 1028 1028 1018 1017 1045 1019 1046 1046 1019 1018 1049 1045 1046 1002 1017 1018 1002 1018 1003 1003 1018 1019 1016 1017 1002 1029 1017 1016 1001 1016 1002 1001 1015 1016 1029 1016 1030 1030 1016 1015 904 1000 1001 1000 1015 1001 1000 1014 1015 1030 1015 1031 1031 1015 1014 1052 1029 1030 1052 1030 1053 1053 1030 1031 1031 1014 1032 1053 1031 1054 1054 1031 1032 1080 1053 1054 1054 1032 1055 1080 1054 1081 1081 1054 1055 1032 1014 1013 1032 1013 1033 1055 1032 1033 1055 1033 1056 1081 1055 1082 1082 1055 1056 1082 1103 1081 1082 1056 1083 1083 1102 1082 1082 1102 1103 1056 1033 1034 1033 1013 1012 1033 1012 1034 997 1012 998 998 1012 1013 998 911 997 997 911 910 997 910 917 910 911 912 912 911 913 998 913 911 910 912 917 912 913 914 914 913 915 915 913 998 914 915 905 984 914 905 905 915 916 915 998 916 905 906 907 905 916 906 916 998 999 916 999 906 907 906 908 906 999 908 908 999 1000 998 1013 999 999 1013 1014 999 1014 1000 908 1000 909 909 1000 904 1206 1202 1207 1207 1338 1206 1206 1338 1246 1338 1339 1340 1207 1339 1338 1339 1341 1340 1341 1339 1207 1340 1341 1342 1340 1342 1343 1343 1347 1340 1207 1342 1341 1343 1342 1344 1207 1344 1342 1343 1344 1345 1345 1346 1343 1343 1346 1347 1351 1347 1346 1345 1376 1346 1346 1376 1377 1207 1376 1345 1345 1344 1207 1207 1377 1376 396 397 398 398 397 399 398 798 799 398 799 396 396 799 800 396 800 394 394 800 801 200 288 277 131 195 196 131 196 132 132 196 197 353 777 327 327 777 778 857 778 777 351 325 327 351 327 352 327 778 352 352 778 779 779 778 857 856 779 857 857 954 955 857 955 856 352 779 351 351 779 780 856 780 779 350 325 351 351 780 350 350 776 325 350 780 776 776 780 856 811 856 864 584 595 596 595 607 596 596 607 608 596 608 597 607 618 619 607 619 608 597 608 609 608 619 620 608 620 609 618 630 619 619 630 631 619 631 620 609 620 621 620 631 632 620 632 621 609 621 610 610 621 622 621 632 633 621 633 622 622 633 634 622 634 623 623 634 635 68 80 69 69 80 81 49 69 70 69 81 70 70 81 82 81 93 82 49 70 51 51 70 71 70 82 71 71 82 83 82 93 94 82 94 83 51 71 53 53 71 72 71 83 72 52 51 53 53 72 55 55 72 73 72 83 84 72 84 73 83 94 95 83 95 84 94 106 95 84 95 96 95 106 107 95 107 96 73 84 85 84 96 85 73 85 74 74 85 86 85 96 97 85 97 86 96 107 108 96 108 97 107 119 108 97 108 109 108 119 120 108 120 109 86 97 98 97 109 98 86 98 87 87 98 99 98 109 110 98 110 99 109 120 121 109 121 110 119 40 120 120 40 39 120 39 121 110 121 122 121 39 38 121 38 122 99 110 111 110 122 111 99 111 100 100 111 112 111 122 123 111 123 112 122 38 37 122 37 123 26 37 38 26 38 25 25 38 39 27 36 37 27 37 26 123 37 36 112 123 124 123 36 124 112 124 113 113 124 125 124 36 35 124 35 125 28 35 36 28 36 27 29 34 35 29 35 28 125 35 34 125 34 126 30 33 34 30 34 29 126 34 33 28 13 29 29 13 15 29 15 30 27 14 28 28 14 13 13 14 15 15 14 16 15 16 17 30 15 17 30 17 31 31 33 30 31 32 33 31 17 18 31 18 20 20 32 31 17 16 18 18 16 11 20 18 11 11 16 19 11 19 12 25 12 19 25 19 26 26 19 16 24 12 25 25 39 24 24 39 40 26 16 27 27 16 14))
                   (list :vertices (let ((mat (make-matrix 3561 3))) (fvector-replace (array-entity mat) #f(-2.0693400573730469e+02 -1.1799900054931641e+01 2.5130900573730469e+02 -2.0693400573730469e+02 -1.1799900054931641e+01 2.5290901184082031e+02 -2.0690899658203125e+02 -1.1803899765014648e+01 2.5130900573730469e+02 -2.0690899658203125e+02 -1.1803899765014648e+01 2.5290901184082031e+02 -2.0697399902343750e+02 -1.2203999519348145e+01 2.5130900573730469e+02 -2.0697399902343750e+02 -1.2203999519348145e+01 2.5290901184082031e+02 -2.0699900817871094e+02 -1.2199899673461914e+01 2.5290901184082031e+02 -2.0699900817871094e+02 -1.2199899673461914e+01 2.5130900573730469e+02 -2.7966601562500000e+02 1.0300000190734863e+01 2.3365699768066406e+02 -2.7966601562500000e+02 1.0157199859619141e+01 2.3369599914550781e+02 -2.7966601562500000e+02 1.0442799568176270e+01 2.3369599914550781e+02 -2.7966601562500000e+02 1.0052599906921387e+01 2.3379998779296875e+02 -2.7966601562500000e+02 1.0547400474548340e+01 2.3379998779296875e+02 -2.7966601562500000e+02 1.0300000190734863e+01 2.3422900390625000e+02 -2.7966601562500000e+02 1.0442799568176270e+01 2.3419099426269531e+02 -2.7966601562500000e+02 1.0157199859619141e+01 2.3419000244140625e+02 -2.7966601562500000e+02 1.0547400474548340e+01 2.3408601379394531e+02 -2.7966601562500000e+02 1.0052599906921387e+01 2.3408601379394531e+02 -2.7966601562500000e+02 1.0014399528503418e+01 2.3394299316406250e+02 -2.7966601562500000e+02 1.0585599899291992e+01 2.3394299316406250e+02 -2.7886599731445312e+02 9.8670101165771484e+00 2.3369300842285156e+02 -2.7886599731445312e+02 1.0049999237060547e+01 2.3351000976562500e+02 -2.7886599731445312e+02 1.0300000190734863e+01 2.3344300842285156e+02 -2.7886599731445312e+02 1.0550000190734863e+01 2.3351000976562500e+02 -2.7886599731445312e+02 1.0732999801635742e+01 2.3369300842285156e+02 -2.7886599731445312e+02 1.0800000190734863e+01 2.3394299316406250e+02 -2.7886599731445312e+02 1.0732999801635742e+01 2.3419299316406250e+02 -2.7886599731445312e+02 1.0550000190734863e+01 2.3437599182128906e+02 -2.7886599731445312e+02 1.0300000190734863e+01 2.3444299316406250e+02 -2.7886599731445312e+02 1.0049999237060547e+01 2.3437599182128906e+02 -2.7886599731445312e+02 9.8669605255126953e+00 2.3419299316406250e+02 -2.7886599731445312e+02 9.8000001907348633e+00 2.3394299316406250e+02 -2.7326599121093750e+02 9.8000001907348633e+00 2.3394299316406250e+02 -2.7326599121093750e+02 9.8669605255126953e+00 2.3419299316406250e+02 -2.7326599121093750e+02 1.0049999237060547e+01 2.3437599182128906e+02 -2.7326599121093750e+02 1.0300000190734863e+01 2.3444299316406250e+02 -2.7326599121093750e+02 1.0550000190734863e+01 2.3437599182128906e+02 -2.7326599121093750e+02 1.0732999801635742e+01 2.3419299316406250e+02 -2.7326599121093750e+02 1.0800000190734863e+01 2.3394299316406250e+02 -2.7326599121093750e+02 1.0732999801635742e+01 2.3369300842285156e+02 -2.7326599121093750e+02 1.0550000190734863e+01 2.3351000976562500e+02 -2.7326599121093750e+02 1.0300000190734863e+01 2.3344300842285156e+02 -2.7326599121093750e+02 1.0049999237060547e+01 2.3351000976562500e+02 -2.7326599121093750e+02 9.8670101165771484e+00 2.3369300842285156e+02 -2.7306600952148438e+02 9.8670101165771484e+00 2.3369300842285156e+02 -2.7307598876953125e+02 9.8294401168823242e+00 2.3367098999023438e+02 -2.7306600952148438e+02 1.0049999237060547e+01 2.3351000976562500e+02 -2.7307598876953125e+02 1.0028400421142578e+01 2.3347300720214844e+02 -2.7306600952148438e+02 1.0300000190734863e+01 2.3344300842285156e+02 -2.7307598876953125e+02 1.0300100326538086e+01 2.3340000915527344e+02 -2.7306600952148438e+02 1.0550000190734863e+01 2.3351000976562500e+02 -2.7307598876953125e+02 1.0571699142456055e+01 2.3347300720214844e+02 -2.7306600952148438e+02 1.0732999801635742e+01 2.3369300842285156e+02 -2.7307598876953125e+02 1.0770600318908691e+01 2.3367098999023438e+02 -2.7306600952148438e+02 1.0800000190734863e+01 2.3394299316406250e+02 -2.7307598876953125e+02 1.0843400001525879e+01 2.3394299316406250e+02 -2.7306600952148438e+02 1.0732999801635742e+01 2.3419299316406250e+02 -2.7307598876953125e+02 1.0770600318908691e+01 2.3421501159667969e+02 -2.7306600952148438e+02 1.0550000190734863e+01 2.3437599182128906e+02 -2.7307598876953125e+02 1.0571599960327148e+01 2.3441400146484375e+02 -2.7306600952148438e+02 1.0300000190734863e+01 2.3444299316406250e+02 -2.7307598876953125e+02 1.0299900054931641e+01 2.3448699951171875e+02 -2.7306600952148438e+02 1.0049999237060547e+01 2.3437599182128906e+02 -2.7307598876953125e+02 1.0028300285339355e+01 2.3441400146484375e+02 -2.7306600952148438e+02 9.8669605255126953e+00 2.3419299316406250e+02 -2.7307598876953125e+02 9.8293895721435547e+00 2.3421501159667969e+02 -2.7306600952148438e+02 9.8000001907348633e+00 2.3394299316406250e+02 -2.7307598876953125e+02 9.7566099166870117e+00 2.3394299316406250e+02 -2.7310400390625000e+02 9.7993097305297852e+00 2.3365400695800781e+02 -2.7310400390625000e+02 1.0010999679565430e+01 2.3344198608398438e+02 -2.7310400390625000e+02 1.0300100326538086e+01 2.3336500549316406e+02 -2.7310400390625000e+02 1.0589100837707520e+01 2.3344198608398438e+02 -2.7310400390625000e+02 1.0800699234008789e+01 2.3365400695800781e+02 -2.7310400390625000e+02 1.0878199577331543e+01 2.3394299316406250e+02 -2.7310400390625000e+02 1.0800699234008789e+01 2.3423199462890625e+02 -2.7310400390625000e+02 1.0588999748229980e+01 2.3444400024414062e+02 -2.7310400390625000e+02 1.0299900054931641e+01 2.3452099609375000e+02 -2.7310400390625000e+02 1.0010899543762207e+01 2.3444400024414062e+02 -2.7310400390625000e+02 9.7992506027221680e+00 2.3423199462890625e+02 -2.7310400390625000e+02 9.7218198776245117e+00 2.3394299316406250e+02 -2.7314401245117188e+02 9.7825899124145508e+00 2.3364399719238281e+02 -2.7314401245117188e+02 1.0001299858093262e+01 2.3342601013183594e+02 -2.7314401245117188e+02 1.0300100326538086e+01 2.3334599304199219e+02 -2.7314401245117188e+02 1.0598799705505371e+01 2.3342601013183594e+02 -2.7314401245117188e+02 1.0817500114440918e+01 2.3364399719238281e+02 -2.7314401245117188e+02 1.0897500038146973e+01 2.3394299316406250e+02 -2.7314401245117188e+02 1.0817399978637695e+01 2.3424200439453125e+02 -2.7314401245117188e+02 1.0598699569702148e+01 2.3446099853515625e+02 -2.7314401245117188e+02 1.0299900054931641e+01 2.3454100036621094e+02 -2.7314401245117188e+02 1.0001200675964355e+01 2.3446099853515625e+02 -2.7314401245117188e+02 9.7825307846069336e+00 2.3424200439453125e+02 -2.7314401245117188e+02 9.7025098800659180e+00 2.3394299316406250e+02 -2.7318899536132812e+02 9.7825899124145508e+00 2.3364399719238281e+02 -2.7318899536132812e+02 1.0001299858093262e+01 2.3342601013183594e+02 -2.7318899536132812e+02 1.0300100326538086e+01 2.3334599304199219e+02 -2.7318899536132812e+02 1.0598799705505371e+01 2.3342601013183594e+02 -2.7318899536132812e+02 1.0817500114440918e+01 2.3364399719238281e+02 -2.7318899536132812e+02 1.0897500038146973e+01 2.3394299316406250e+02 -2.7318899536132812e+02 1.0817399978637695e+01 2.3424200439453125e+02 -2.7318899536132812e+02 1.0598699569702148e+01 2.3446099853515625e+02 -2.7318899536132812e+02 1.0299900054931641e+01 2.3454100036621094e+02 -2.7318899536132812e+02 1.0001200675964355e+01 2.3446099853515625e+02 -2.7318899536132812e+02 9.7825307846069336e+00 2.3424200439453125e+02 -2.7318899536132812e+02 9.7025098800659180e+00 2.3394299316406250e+02 -2.7322900390625000e+02 9.7993097305297852e+00 2.3365400695800781e+02 -2.7322900390625000e+02 1.0010999679565430e+01 2.3344198608398438e+02 -2.7322900390625000e+02 1.0300100326538086e+01 2.3336500549316406e+02 -2.7322900390625000e+02 1.0589100837707520e+01 2.3344198608398438e+02 -2.7322900390625000e+02 1.0800699234008789e+01 2.3365400695800781e+02 -2.7322900390625000e+02 1.0878199577331543e+01 2.3394299316406250e+02 -2.7322900390625000e+02 1.0800699234008789e+01 2.3423199462890625e+02 -2.7322900390625000e+02 1.0588999748229980e+01 2.3444400024414062e+02 -2.7322900390625000e+02 1.0299900054931641e+01 2.3452099609375000e+02 -2.7322900390625000e+02 1.0010899543762207e+01 2.3444400024414062e+02 -2.7322900390625000e+02 9.7992506027221680e+00 2.3423199462890625e+02 -2.7322900390625000e+02 9.7218198776245117e+00 2.3394299316406250e+02 -2.7325698852539062e+02 9.8294401168823242e+00 2.3367098999023438e+02 -2.7325698852539062e+02 1.0028400421142578e+01 2.3347300720214844e+02 -2.7325698852539062e+02 1.0300100326538086e+01 2.3340000915527344e+02 -2.7325698852539062e+02 1.0571699142456055e+01 2.3347300720214844e+02 -2.7325698852539062e+02 1.0770600318908691e+01 2.3367098999023438e+02 -2.7325698852539062e+02 1.0843400001525879e+01 2.3394299316406250e+02 -2.7325698852539062e+02 1.0770600318908691e+01 2.3421501159667969e+02 -2.7325698852539062e+02 1.0571599960327148e+01 2.3441400146484375e+02 -2.7325698852539062e+02 1.0299900054931641e+01 2.3448699951171875e+02 -2.7325698852539062e+02 1.0028300285339355e+01 2.3441400146484375e+02 -2.7325698852539062e+02 9.8293895721435547e+00 2.3421501159667969e+02 -2.7325698852539062e+02 9.7566099166870117e+00 2.3394299316406250e+02 -2.7281600952148438e+02 9.8000001907348633e+00 2.3394299316406250e+02 -2.7281600952148438e+02 9.8669605255126953e+00 2.3419299316406250e+02 -2.7281600952148438e+02 1.0049999237060547e+01 2.3437599182128906e+02 -2.7281600952148438e+02 1.0300000190734863e+01 2.3444299316406250e+02 -2.7281600952148438e+02 1.0550000190734863e+01 2.3437599182128906e+02 -2.7281600952148438e+02 1.0732999801635742e+01 2.3419299316406250e+02 -2.7281600952148438e+02 1.0800000190734863e+01 2.3394299316406250e+02 -2.7281600952148438e+02 1.0732999801635742e+01 2.3369300842285156e+02 -2.7281600952148438e+02 1.0550000190734863e+01 2.3351000976562500e+02 -2.7281600952148438e+02 1.0300000190734863e+01 2.3344300842285156e+02 -2.7281600952148438e+02 1.0049999237060547e+01 2.3351000976562500e+02 -2.7281600952148438e+02 9.8670101165771484e+00 2.3369300842285156e+02 -2.7966601562500000e+02 1.0442799568176270e+01 2.3669099426269531e+02 -2.7966601562500000e+02 1.0547400474548340e+01 2.3658599853515625e+02 -2.7966601562500000e+02 1.0585599899291992e+01 2.3644299316406250e+02 -2.7966601562500000e+02 1.0157199859619141e+01 2.3669000244140625e+02 -2.7966601562500000e+02 1.0300000190734863e+01 2.3672898864746094e+02 -2.7966601562500000e+02 1.0014399528503418e+01 2.3644299316406250e+02 -2.7966601562500000e+02 1.0052599906921387e+01 2.3658599853515625e+02 -2.7966601562500000e+02 1.0547400474548340e+01 2.3630000305175781e+02 -2.7966601562500000e+02 1.0442799568176270e+01 2.3619599914550781e+02 -2.7966601562500000e+02 1.0300000190734863e+01 2.3615699768066406e+02 -2.7966601562500000e+02 1.0052599906921387e+01 2.3630000305175781e+02 -2.7966601562500000e+02 1.0157199859619141e+01 2.3619599914550781e+02 -2.7966601562500000e+02 1.2657199859619141e+01 2.3419000244140625e+02 -2.7966601562500000e+02 1.2799999237060547e+01 2.3422900390625000e+02 -2.7966601562500000e+02 1.2942800521850586e+01 2.3419099426269531e+02 -2.7966601562500000e+02 1.2552599906921387e+01 2.3379998779296875e+02 -2.7966601562500000e+02 1.2514400482177734e+01 2.3394299316406250e+02 -2.7966601562500000e+02 1.2552599906921387e+01 2.3408601379394531e+02 -2.7966601562500000e+02 1.2657199859619141e+01 2.3369599914550781e+02 -2.7966601562500000e+02 1.3047399520874023e+01 2.3408601379394531e+02 -2.7966601562500000e+02 1.3085599899291992e+01 2.3394299316406250e+02 -2.7966601562500000e+02 1.3047399520874023e+01 2.3379998779296875e+02 -2.7966601562500000e+02 1.2942800521850586e+01 2.3369599914550781e+02 -2.7966601562500000e+02 1.2799999237060547e+01 2.3365699768066406e+02 -2.7966601562500000e+02 7.6571602821350098e+00 2.3419000244140625e+02 -2.7966601562500000e+02 7.7999701499938965e+00 2.3422900390625000e+02 -2.7966601562500000e+02 7.8000302314758301e+00 2.3365699768066406e+02 -2.7966601562500000e+02 7.9428005218505859e+00 2.3419099426269531e+02 -2.7966601562500000e+02 7.5526099205017090e+00 2.3408601379394531e+02 -2.7966601562500000e+02 7.5143599510192871e+00 2.3394299316406250e+02 -2.7966601562500000e+02 7.5526399612426758e+00 2.3379998779296875e+02 -2.7966601562500000e+02 7.6571998596191406e+00 2.3369599914550781e+02 -2.7966601562500000e+02 8.0473899841308594e+00 2.3379998779296875e+02 -2.7966601562500000e+02 7.9428496360778809e+00 2.3369599914550781e+02 -2.7966601562500000e+02 8.0856399536132812e+00 2.3394299316406250e+02 -2.7966601562500000e+02 8.0473604202270508e+00 2.3408601379394531e+02 -2.7966601562500000e+02 1.0585599899291992e+01 2.3144300842285156e+02 -2.7966601562500000e+02 1.0547400474548340e+01 2.3130000305175781e+02 -2.7966601562500000e+02 1.0442799568176270e+01 2.3119599914550781e+02 -2.7966601562500000e+02 1.0300000190734863e+01 2.3172900390625000e+02 -2.7966601562500000e+02 1.0442799568176270e+01 2.3169100952148438e+02 -2.7966601562500000e+02 1.0547400474548340e+01 2.3158599853515625e+02 -2.7966601562500000e+02 1.0014399528503418e+01 2.3144300842285156e+02 -2.7966601562500000e+02 1.0052599906921387e+01 2.3158599853515625e+02 -2.7966601562500000e+02 1.0052599906921387e+01 2.3130000305175781e+02 -2.7966601562500000e+02 1.0157199859619141e+01 2.3169000244140625e+02 -2.7966601562500000e+02 1.0157199859619141e+01 2.3119599914550781e+02 -2.7966601562500000e+02 1.0300000190734863e+01 2.3115699768066406e+02 -2.7281600952148438e+02 1.1166100502014160e+01 2.3344300842285156e+02 -2.7281600952148438e+02 1.0800100326538086e+01 2.3307701110839844e+02 -2.7281600952148438e+02 1.0300100326538086e+01 2.3294299316406250e+02 -2.7281600952148438e+02 9.8000907897949219e+00 2.3307701110839844e+02 -2.7281600952148438e+02 9.4340200424194336e+00 2.3344300842285156e+02 -2.7281600952148438e+02 9.3000001907348633e+00 2.3394299316406250e+02 -2.7281600952148438e+02 9.4339294433593750e+00 2.3444299316406250e+02 -2.7281600952148438e+02 9.7999200820922852e+00 2.3480899047851562e+02 -2.7281600952148438e+02 1.0299900054931641e+01 2.3494300842285156e+02 -2.7281600952148438e+02 1.0799900054931641e+01 2.3480899047851562e+02 -2.7281600952148438e+02 1.1165999412536621e+01 2.3444299316406250e+02 -2.7281600952148438e+02 1.1300000190734863e+01 2.3394299316406250e+02 -2.7886599731445312e+02 9.8670101165771484e+00 2.3619300842285156e+02 -2.7886599731445312e+02 1.0049999237060547e+01 2.3600999450683594e+02 -2.7886599731445312e+02 1.0300000190734863e+01 2.3594300842285156e+02 -2.7886599731445312e+02 1.0550000190734863e+01 2.3600999450683594e+02 -2.7886599731445312e+02 1.0732999801635742e+01 2.3619300842285156e+02 -2.7886599731445312e+02 1.0800000190734863e+01 2.3644299316406250e+02 -2.7886599731445312e+02 1.0732999801635742e+01 2.3669299316406250e+02 -2.7886599731445312e+02 1.0550000190734863e+01 2.3687599182128906e+02 -2.7886599731445312e+02 1.0300000190734863e+01 2.3694300842285156e+02 -2.7886599731445312e+02 1.0049999237060547e+01 2.3687599182128906e+02 -2.7886599731445312e+02 9.8669605255126953e+00 2.3669299316406250e+02 -2.7886599731445312e+02 9.8000001907348633e+00 2.3644299316406250e+02 -2.7886599731445312e+02 1.2366999626159668e+01 2.3369300842285156e+02 -2.7886599731445312e+02 1.2550000190734863e+01 2.3351000976562500e+02 -2.7886599731445312e+02 1.2799999237060547e+01 2.3344300842285156e+02 -2.7886599731445312e+02 1.3050000190734863e+01 2.3351000976562500e+02 -2.7886599731445312e+02 1.3233000755310059e+01 2.3369300842285156e+02 -2.7886599731445312e+02 1.3300000190734863e+01 2.3394299316406250e+02 -2.7886599731445312e+02 1.3233000755310059e+01 2.3419299316406250e+02 -2.7886599731445312e+02 1.3050000190734863e+01 2.3437599182128906e+02 -2.7886599731445312e+02 1.2799999237060547e+01 2.3444299316406250e+02 -2.7886599731445312e+02 1.2550000190734863e+01 2.3437599182128906e+02 -2.7886599731445312e+02 1.2366999626159668e+01 2.3419299316406250e+02 -2.7886599731445312e+02 1.2299999237060547e+01 2.3394299316406250e+02 -2.7886599731445312e+02 7.3670101165771484e+00 2.3369300842285156e+02 -2.7886599731445312e+02 7.5500397682189941e+00 2.3351000976562500e+02 -2.7886599731445312e+02 7.8000502586364746e+00 2.3344300842285156e+02 -2.7886599731445312e+02 8.0500402450561523e+00 2.3351000976562500e+02 -2.7886599731445312e+02 8.2330398559570312e+00 2.3369300842285156e+02 -2.7886599731445312e+02 8.3000001907348633e+00 2.3394299316406250e+02 -2.7886599731445312e+02 8.2329902648925781e+00 2.3419299316406250e+02 -2.7886599731445312e+02 8.0499601364135742e+00 2.3437599182128906e+02 -2.7886599731445312e+02 7.7999501228332520e+00 2.3444299316406250e+02 -2.7886599731445312e+02 7.5499601364135742e+00 2.3437599182128906e+02 -2.7886599731445312e+02 7.3669600486755371e+00 2.3419299316406250e+02 -2.7886599731445312e+02 7.3000001907348633e+00 2.3394299316406250e+02 -2.7886599731445312e+02 9.8670101165771484e+00 2.3119300842285156e+02 -2.7886599731445312e+02 1.0049999237060547e+01 2.3101000976562500e+02 -2.7886599731445312e+02 1.0300000190734863e+01 2.3094299316406250e+02 -2.7886599731445312e+02 1.0550000190734863e+01 2.3101000976562500e+02 -2.7886599731445312e+02 1.0732999801635742e+01 2.3119300842285156e+02 -2.7886599731445312e+02 1.0800000190734863e+01 2.3144300842285156e+02 -2.7886599731445312e+02 1.0732999801635742e+01 2.3169299316406250e+02 -2.7886599731445312e+02 1.0550000190734863e+01 2.3187600708007812e+02 -2.7886599731445312e+02 1.0300000190734863e+01 2.3194299316406250e+02 -2.7886599731445312e+02 1.0049999237060547e+01 2.3187600708007812e+02 -2.7886599731445312e+02 9.8669605255126953e+00 2.3169299316406250e+02 -2.7886599731445312e+02 9.8000001907348633e+00 2.3144300842285156e+02 -2.7201599121093750e+02 8.1891002655029297e+00 2.3496800231933594e+02 -2.7281600952148438e+02 8.1891002655029297e+00 2.3496800231933594e+02 -2.7281600952148438e+02 8.0064096450805664e+00 2.3525900268554688e+02 -2.7201599121093750e+02 8.0064096450805664e+00 2.3525900268554688e+02 -2.7281600952148438e+02 7.9686603546142578e+00 2.3560099792480469e+02 -2.7201599121093750e+02 7.9686603546142578e+00 2.3560099792480469e+02 -2.7281600952148438e+02 8.0833797454833984e+00 2.3592500305175781e+02 -2.7201599121093750e+02 8.0833797454833984e+00 2.3592500305175781e+02 -2.7281600952148438e+02 8.1881895065307617e+00 2.3605599975585938e+02 -2.7201599121093750e+02 8.3276901245117188e+00 2.3616699218750000e+02 -2.7281600952148438e+02 8.3276901245117188e+00 2.3616699218750000e+02 -2.7281600952148438e+02 8.6529006958007812e+00 2.3627799987792969e+02 -2.7201599121093750e+02 8.6529006958007812e+00 2.3627799987792969e+02 -2.7281600952148438e+02 8.9941902160644531e+00 2.3623699951171875e+02 -2.7201599121093750e+02 8.9941902160644531e+00 2.3623699951171875e+02 -2.7281600952148438e+02 9.2835292816162109e+00 2.3605200195312500e+02 -2.7201599121093750e+02 9.2835292816162109e+00 2.3605200195312500e+02 -2.7201599121093750e+02 1.1166100502014160e+01 2.3344300842285156e+02 -2.7201599121093750e+02 1.1300000190734863e+01 2.3394299316406250e+02 -2.7201599121093750e+02 1.1165999412536621e+01 2.3444299316406250e+02 -2.7201599121093750e+02 1.0799900054931641e+01 2.3480899047851562e+02 -2.7201599121093750e+02 1.0299900054931641e+01 2.3494300842285156e+02 -2.7201599121093750e+02 9.7999200820922852e+00 2.3480899047851562e+02 -2.7201599121093750e+02 9.4339294433593750e+00 2.3444299316406250e+02 -2.7201599121093750e+02 9.3000001907348633e+00 2.3394299316406250e+02 -2.7201599121093750e+02 9.4340200424194336e+00 2.3344300842285156e+02 -2.7201599121093750e+02 9.8000907897949219e+00 2.3307701110839844e+02 -2.7201599121093750e+02 1.0300100326538086e+01 2.3294299316406250e+02 -2.7201599121093750e+02 1.0800100326538086e+01 2.3307701110839844e+02 -2.7326599121093750e+02 9.8000001907348633e+00 2.3644299316406250e+02 -2.7326599121093750e+02 9.8669605255126953e+00 2.3669299316406250e+02 -2.7326599121093750e+02 1.0049999237060547e+01 2.3687599182128906e+02 -2.7326599121093750e+02 1.0300000190734863e+01 2.3694300842285156e+02 -2.7326599121093750e+02 1.0550000190734863e+01 2.3687599182128906e+02 -2.7326599121093750e+02 1.0732999801635742e+01 2.3669299316406250e+02 -2.7326599121093750e+02 1.0800000190734863e+01 2.3644299316406250e+02 -2.7326599121093750e+02 1.0732999801635742e+01 2.3619300842285156e+02 -2.7326599121093750e+02 1.0550000190734863e+01 2.3600999450683594e+02 -2.7326599121093750e+02 1.0300000190734863e+01 2.3594300842285156e+02 -2.7326599121093750e+02 1.0049999237060547e+01 2.3600999450683594e+02 -2.7326599121093750e+02 9.8670101165771484e+00 2.3619300842285156e+02 -2.7326599121093750e+02 1.2299999237060547e+01 2.3394299316406250e+02 -2.7326599121093750e+02 1.2366999626159668e+01 2.3419299316406250e+02 -2.7326599121093750e+02 1.2550000190734863e+01 2.3437599182128906e+02 -2.7326599121093750e+02 1.2799999237060547e+01 2.3444299316406250e+02 -2.7326599121093750e+02 1.3050000190734863e+01 2.3437599182128906e+02 -2.7326599121093750e+02 1.3233000755310059e+01 2.3419299316406250e+02 -2.7326599121093750e+02 1.3300000190734863e+01 2.3394299316406250e+02 -2.7326599121093750e+02 1.3233000755310059e+01 2.3369300842285156e+02 -2.7326599121093750e+02 1.3050000190734863e+01 2.3351000976562500e+02 -2.7326599121093750e+02 1.2799999237060547e+01 2.3344300842285156e+02 -2.7326599121093750e+02 1.2550000190734863e+01 2.3351000976562500e+02 -2.7326599121093750e+02 1.2366999626159668e+01 2.3369300842285156e+02 -2.7326599121093750e+02 7.3000001907348633e+00 2.3394299316406250e+02 -2.7326599121093750e+02 7.3669600486755371e+00 2.3419299316406250e+02 -2.7326599121093750e+02 7.5499601364135742e+00 2.3437599182128906e+02 -2.7326599121093750e+02 7.7999501228332520e+00 2.3444299316406250e+02 -2.7326599121093750e+02 8.0499601364135742e+00 2.3437599182128906e+02 -2.7326599121093750e+02 8.2329902648925781e+00 2.3419299316406250e+02 -2.7326599121093750e+02 8.3000001907348633e+00 2.3394299316406250e+02 -2.7326599121093750e+02 8.2330398559570312e+00 2.3369300842285156e+02 -2.7326599121093750e+02 8.0500402450561523e+00 2.3351000976562500e+02 -2.7326599121093750e+02 7.8000502586364746e+00 2.3344300842285156e+02 -2.7326599121093750e+02 7.5500397682189941e+00 2.3351000976562500e+02 -2.7326599121093750e+02 7.3670101165771484e+00 2.3369300842285156e+02 -2.7326599121093750e+02 9.8000001907348633e+00 2.3144300842285156e+02 -2.7326599121093750e+02 9.8669605255126953e+00 2.3169299316406250e+02 -2.7326599121093750e+02 1.0049999237060547e+01 2.3187600708007812e+02 -2.7326599121093750e+02 1.0300000190734863e+01 2.3194299316406250e+02 -2.7326599121093750e+02 1.0550000190734863e+01 2.3187600708007812e+02 -2.7326599121093750e+02 1.0732999801635742e+01 2.3169299316406250e+02 -2.7326599121093750e+02 1.0800000190734863e+01 2.3144300842285156e+02 -2.7326599121093750e+02 1.0732999801635742e+01 2.3119300842285156e+02 -2.7326599121093750e+02 1.0550000190734863e+01 2.3101000976562500e+02 -2.7326599121093750e+02 1.0300000190734863e+01 2.3094299316406250e+02 -2.7326599121093750e+02 1.0049999237060547e+01 2.3101000976562500e+02 -2.7326599121093750e+02 9.8670101165771484e+00 2.3119300842285156e+02 -2.7201599121093750e+02 1.3223999977111816e+01 2.3494300842285156e+02 -2.7201599121093750e+02 1.2799999237060547e+01 2.3494300842285156e+02 -2.7201599121093750e+02 1.3498200416564941e+01 2.3536500549316406e+02 -2.7201599121093750e+02 8.7510595321655273e+00 2.3425199890136719e+02 -2.7201599121093750e+02 8.5071105957031250e+00 2.3464999389648438e+02 -2.7201599121093750e+02 8.7876901626586914e+00 2.3378700256347656e+02 -2.7201599121093750e+02 8.6090202331542969e+00 2.3335499572753906e+02 -2.7201599121093750e+02 8.2539901733398438e+00 2.3305200195312500e+02 -2.7201599121093750e+02 1.1825099945068359e+01 2.3372100830078125e+02 -2.7201599121093750e+02 1.2018199920654297e+01 2.3331999206542969e+02 -2.7201599121093750e+02 1.2366100311279297e+01 2.3304200744628906e+02 -2.7201599121093750e+02 1.1825099945068359e+01 2.3416600036621094e+02 -2.7201599121093750e+02 1.2018199920654297e+01 2.3456700134277344e+02 -2.7201599121093750e+02 1.2366100311279297e+01 2.3484399414062500e+02 -2.7201599121093750e+02 9.5857591629028320e+00 2.3574299621582031e+02 -2.7201599121093750e+02 9.9832801818847656e+00 2.3549499511718750e+02 -2.7201599121093750e+02 1.0450400352478027e+01 2.3545500183105469e+02 -2.7201599121093750e+02 1.0884500503540039e+01 2.3563200378417969e+02 -2.7201599121093750e+02 1.1190099716186523e+01 2.3598699951171875e+02 -2.7201599121093750e+02 9.6765098571777344e+00 2.3222500610351562e+02 -2.7201599121093750e+02 9.3990306854248047e+00 2.3187699890136719e+02 -2.7201599121093750e+02 1.1721899986267090e+01 2.3074499511718750e+02 -2.7201599121093750e+02 1.2774899482727051e+01 2.3146800231933594e+02 -2.7201599121093750e+02 1.3498200416564941e+01 2.3252099609375000e+02 -2.7201599121093750e+02 1.2799999237060547e+01 2.3294299316406250e+02 -2.7201599121093750e+02 1.3367199897766113e+01 2.3497900390625000e+02 -2.7201599121093750e+02 1.3475599288940430e+01 2.3508000183105469e+02 -2.7201599121093750e+02 1.3523099899291992e+01 2.3521899414062500e+02 -2.7201599121093750e+02 1.2774899482727051e+01 2.3641799926757812e+02 -2.7201599121093750e+02 1.1721899986267090e+01 2.3714099121093750e+02 -2.7201599121093750e+02 1.1300000190734863e+01 2.3644299316406250e+02 -2.7201599121093750e+02 1.1300000190734863e+01 2.3101901245117188e+02 -2.7201599121093750e+02 1.1300000190734863e+01 2.3144300842285156e+02 -2.7201599121093750e+02 1.1201000213623047e+01 2.3187699890136719e+02 -2.7201599121093750e+02 1.0923500061035156e+01 2.3222500610351562e+02 -2.7201599121093750e+02 1.0522500038146973e+01 2.3241799926757812e+02 -2.7201599121093750e+02 1.0077499389648438e+01 2.3241799926757812e+02 -2.7201599121093750e+02 7.1244001388549805e+00 2.3280699157714844e+02 -2.7201599121093750e+02 7.2328500747680664e+00 2.3290699768066406e+02 -2.7201599121093750e+02 7.0769000053405762e+00 2.3266699218750000e+02 -2.7201599121093750e+02 7.3759598731994629e+00 2.3294299316406250e+02 -2.7201599121093750e+02 7.1018300056457520e+00 2.3252099609375000e+02 -2.7201599121093750e+02 7.7999997138977051e+00 2.3294299316406250e+02 -2.7201599121093750e+02 7.8251295089721680e+00 2.3146800231933594e+02 -2.7201599121093750e+02 8.8781204223632812e+00 2.3074499511718750e+02 -2.7201599121093750e+02 1.3475599288940430e+01 2.3280699157714844e+02 -2.7201599121093750e+02 1.3523099899291992e+01 2.3266699218750000e+02 -2.7201599121093750e+02 1.3367199897766113e+01 2.3290699768066406e+02 -2.7201599121093750e+02 1.3223999977111816e+01 2.3294299316406250e+02 -2.7201599121093750e+02 1.1436499595642090e+01 2.3711900329589844e+02 -2.7201599121093750e+02 1.1576299667358398e+01 2.3716600036621094e+02 -2.7201599121093750e+02 1.1336299896240234e+01 2.3701000976562500e+02 -2.7201599121093750e+02 1.1300000190734863e+01 2.3686698913574219e+02 -2.7201599121093750e+02 9.3000001907348633e+00 2.3101901245117188e+02 -2.7201599121093750e+02 9.2636594772338867e+00 2.3087599182128906e+02 -2.7201599121093750e+02 9.1634597778320312e+00 2.3076799011230469e+02 -2.7201599121093750e+02 1.1576299667358398e+01 2.3072000122070312e+02 -2.7201599121093750e+02 1.1436499595642090e+01 2.3076799011230469e+02 -2.7201599121093750e+02 1.1336299896240234e+01 2.3087599182128906e+02 -2.7201599121093750e+02 9.3000001907348633e+00 2.3144300842285156e+02 -2.7201599121093750e+02 9.0236597061157227e+00 2.3072000122070312e+02 -2.7306600952148438e+02 9.8670101165771484e+00 2.3619300842285156e+02 -2.7307598876953125e+02 9.8294401168823242e+00 2.3617100524902344e+02 -2.7306600952148438e+02 1.0049999237060547e+01 2.3600999450683594e+02 -2.7307598876953125e+02 1.0028400421142578e+01 2.3597300720214844e+02 -2.7306600952148438e+02 1.0300000190734863e+01 2.3594300842285156e+02 -2.7307598876953125e+02 1.0300100326538086e+01 2.3589999389648438e+02 -2.7306600952148438e+02 1.0550000190734863e+01 2.3600999450683594e+02 -2.7307598876953125e+02 1.0571699142456055e+01 2.3597300720214844e+02 -2.7306600952148438e+02 1.0732999801635742e+01 2.3619300842285156e+02 -2.7307598876953125e+02 1.0770600318908691e+01 2.3617100524902344e+02 -2.7306600952148438e+02 1.0800000190734863e+01 2.3644299316406250e+02 -2.7307598876953125e+02 1.0843400001525879e+01 2.3644299316406250e+02 -2.7306600952148438e+02 1.0732999801635742e+01 2.3669299316406250e+02 -2.7307598876953125e+02 1.0770600318908691e+01 2.3671499633789062e+02 -2.7306600952148438e+02 1.0550000190734863e+01 2.3687599182128906e+02 -2.7307598876953125e+02 1.0571599960327148e+01 2.3691400146484375e+02 -2.7306600952148438e+02 1.0300000190734863e+01 2.3694300842285156e+02 -2.7307598876953125e+02 1.0299900054931641e+01 2.3698699951171875e+02 -2.7306600952148438e+02 1.0049999237060547e+01 2.3687599182128906e+02 -2.7307598876953125e+02 1.0028300285339355e+01 2.3691400146484375e+02 -2.7306600952148438e+02 9.8669605255126953e+00 2.3669299316406250e+02 -2.7307598876953125e+02 9.8293895721435547e+00 2.3671499633789062e+02 -2.7306600952148438e+02 9.8000001907348633e+00 2.3644299316406250e+02 -2.7307598876953125e+02 9.7566099166870117e+00 2.3644299316406250e+02 -2.7310400390625000e+02 9.7993097305297852e+00 2.3615400695800781e+02 -2.7310400390625000e+02 1.0010999679565430e+01 2.3594200134277344e+02 -2.7310400390625000e+02 1.0300100326538086e+01 2.3586499023437500e+02 -2.7310400390625000e+02 1.0589100837707520e+01 2.3594200134277344e+02 -2.7310400390625000e+02 1.0800699234008789e+01 2.3615400695800781e+02 -2.7310400390625000e+02 1.0878199577331543e+01 2.3644299316406250e+02 -2.7310400390625000e+02 1.0800699234008789e+01 2.3673200988769531e+02 -2.7310400390625000e+02 1.0588999748229980e+01 2.3694400024414062e+02 -2.7310400390625000e+02 1.0299900054931641e+01 2.3702099609375000e+02 -2.7310400390625000e+02 1.0010899543762207e+01 2.3694400024414062e+02 -2.7310400390625000e+02 9.7992506027221680e+00 2.3673200988769531e+02 -2.7310400390625000e+02 9.7218198776245117e+00 2.3644299316406250e+02 -2.7314401245117188e+02 9.7825899124145508e+00 2.3614401245117188e+02 -2.7314401245117188e+02 1.0001299858093262e+01 2.3592599487304688e+02 -2.7314401245117188e+02 1.0300100326538086e+01 2.3584599304199219e+02 -2.7314401245117188e+02 1.0598799705505371e+01 2.3592599487304688e+02 -2.7314401245117188e+02 1.0817500114440918e+01 2.3614401245117188e+02 -2.7314401245117188e+02 1.0897500038146973e+01 2.3644299316406250e+02 -2.7314401245117188e+02 1.0817399978637695e+01 2.3674200439453125e+02 -2.7314401245117188e+02 1.0598699569702148e+01 2.3696101379394531e+02 -2.7314401245117188e+02 1.0299900054931641e+01 2.3704100036621094e+02 -2.7314401245117188e+02 1.0001200675964355e+01 2.3696101379394531e+02 -2.7314401245117188e+02 9.7825307846069336e+00 2.3674200439453125e+02 -2.7314401245117188e+02 9.7025098800659180e+00 2.3644299316406250e+02 -2.7318899536132812e+02 9.7825899124145508e+00 2.3614401245117188e+02 -2.7318899536132812e+02 1.0001299858093262e+01 2.3592599487304688e+02 -2.7318899536132812e+02 1.0300100326538086e+01 2.3584599304199219e+02 -2.7318899536132812e+02 1.0598799705505371e+01 2.3592599487304688e+02 -2.7318899536132812e+02 1.0817500114440918e+01 2.3614401245117188e+02 -2.7318899536132812e+02 1.0897500038146973e+01 2.3644299316406250e+02 -2.7318899536132812e+02 1.0817399978637695e+01 2.3674200439453125e+02 -2.7318899536132812e+02 1.0598699569702148e+01 2.3696101379394531e+02 -2.7318899536132812e+02 1.0299900054931641e+01 2.3704100036621094e+02 -2.7318899536132812e+02 1.0001200675964355e+01 2.3696101379394531e+02 -2.7318899536132812e+02 9.7825307846069336e+00 2.3674200439453125e+02 -2.7318899536132812e+02 9.7025098800659180e+00 2.3644299316406250e+02 -2.7322900390625000e+02 9.7993097305297852e+00 2.3615400695800781e+02 -2.7322900390625000e+02 1.0010999679565430e+01 2.3594200134277344e+02 -2.7322900390625000e+02 1.0300100326538086e+01 2.3586499023437500e+02 -2.7322900390625000e+02 1.0589100837707520e+01 2.3594200134277344e+02 -2.7322900390625000e+02 1.0800699234008789e+01 2.3615400695800781e+02 -2.7322900390625000e+02 1.0878199577331543e+01 2.3644299316406250e+02 -2.7322900390625000e+02 1.0800699234008789e+01 2.3673200988769531e+02 -2.7322900390625000e+02 1.0588999748229980e+01 2.3694400024414062e+02 -2.7322900390625000e+02 1.0299900054931641e+01 2.3702099609375000e+02 -2.7322900390625000e+02 1.0010899543762207e+01 2.3694400024414062e+02 -2.7322900390625000e+02 9.7992506027221680e+00 2.3673200988769531e+02 -2.7322900390625000e+02 9.7218198776245117e+00 2.3644299316406250e+02 -2.7325698852539062e+02 9.8294401168823242e+00 2.3617100524902344e+02 -2.7325698852539062e+02 1.0028400421142578e+01 2.3597300720214844e+02 -2.7325698852539062e+02 1.0300100326538086e+01 2.3589999389648438e+02 -2.7325698852539062e+02 1.0571699142456055e+01 2.3597300720214844e+02 -2.7325698852539062e+02 1.0770600318908691e+01 2.3617100524902344e+02 -2.7325698852539062e+02 1.0843400001525879e+01 2.3644299316406250e+02 -2.7325698852539062e+02 1.0770600318908691e+01 2.3671499633789062e+02 -2.7325698852539062e+02 1.0571599960327148e+01 2.3691400146484375e+02 -2.7325698852539062e+02 1.0299900054931641e+01 2.3698699951171875e+02 -2.7325698852539062e+02 1.0028300285339355e+01 2.3691400146484375e+02 -2.7325698852539062e+02 9.8293895721435547e+00 2.3671499633789062e+02 -2.7325698852539062e+02 9.7566099166870117e+00 2.3644299316406250e+02 -2.7306600952148438e+02 1.2366999626159668e+01 2.3369300842285156e+02 -2.7307598876953125e+02 1.2329399108886719e+01 2.3367098999023438e+02 -2.7306600952148438e+02 1.2550000190734863e+01 2.3351000976562500e+02 -2.7307598876953125e+02 1.2528399467468262e+01 2.3347300720214844e+02 -2.7306600952148438e+02 1.2799999237060547e+01 2.3344300842285156e+02 -2.7307598876953125e+02 1.2800100326538086e+01 2.3340000915527344e+02 -2.7306600952148438e+02 1.3050000190734863e+01 2.3351000976562500e+02 -2.7307598876953125e+02 1.3071700096130371e+01 2.3347300720214844e+02 -2.7306600952148438e+02 1.3233000755310059e+01 2.3369300842285156e+02 -2.7307598876953125e+02 1.3270599365234375e+01 2.3367098999023438e+02 -2.7306600952148438e+02 1.3300000190734863e+01 2.3394299316406250e+02 -2.7307598876953125e+02 1.3343400001525879e+01 2.3394299316406250e+02 -2.7306600952148438e+02 1.3233000755310059e+01 2.3419299316406250e+02 -2.7307598876953125e+02 1.3270599365234375e+01 2.3421501159667969e+02 -2.7306600952148438e+02 1.3050000190734863e+01 2.3437599182128906e+02 -2.7307598876953125e+02 1.3071599960327148e+01 2.3441400146484375e+02 -2.7306600952148438e+02 1.2799999237060547e+01 2.3444299316406250e+02 -2.7307598876953125e+02 1.2799900054931641e+01 2.3448699951171875e+02 -2.7306600952148438e+02 1.2550000190734863e+01 2.3437599182128906e+02 -2.7307598876953125e+02 1.2528300285339355e+01 2.3441400146484375e+02 -2.7306600952148438e+02 1.2366999626159668e+01 2.3419299316406250e+02 -2.7307598876953125e+02 1.2329399108886719e+01 2.3421501159667969e+02 -2.7306600952148438e+02 1.2299999237060547e+01 2.3394299316406250e+02 -2.7307598876953125e+02 1.2256600379943848e+01 2.3394299316406250e+02 -2.7310400390625000e+02 1.2299300193786621e+01 2.3365400695800781e+02 -2.7310400390625000e+02 1.2510999679565430e+01 2.3344198608398438e+02 -2.7310400390625000e+02 1.2800100326538086e+01 2.3336500549316406e+02 -2.7310400390625000e+02 1.3089099884033203e+01 2.3344198608398438e+02 -2.7310400390625000e+02 1.3300799369812012e+01 2.3365400695800781e+02 -2.7310400390625000e+02 1.3378200531005859e+01 2.3394299316406250e+02 -2.7310400390625000e+02 1.3300700187683105e+01 2.3423199462890625e+02 -2.7310400390625000e+02 1.3089000701904297e+01 2.3444400024414062e+02 -2.7310400390625000e+02 1.2799900054931641e+01 2.3452099609375000e+02 -2.7310400390625000e+02 1.2510900497436523e+01 2.3444400024414062e+02 -2.7310400390625000e+02 1.2299300193786621e+01 2.3423199462890625e+02 -2.7310400390625000e+02 1.2221799850463867e+01 2.3394299316406250e+02 -2.7314401245117188e+02 1.2282599449157715e+01 2.3364399719238281e+02 -2.7314401245117188e+02 1.2501299858093262e+01 2.3342601013183594e+02 -2.7314401245117188e+02 1.2800100326538086e+01 2.3334599304199219e+02 -2.7314401245117188e+02 1.3098799705505371e+01 2.3342601013183594e+02 -2.7314401245117188e+02 1.3317500114440918e+01 2.3364399719238281e+02 -2.7314401245117188e+02 1.3397500038146973e+01 2.3394299316406250e+02 -2.7314401245117188e+02 1.3317399978637695e+01 2.3424200439453125e+02 -2.7314401245117188e+02 1.3098699569702148e+01 2.3446099853515625e+02 -2.7314401245117188e+02 1.2799900054931641e+01 2.3454100036621094e+02 -2.7314401245117188e+02 1.2501199722290039e+01 2.3446099853515625e+02 -2.7314401245117188e+02 1.2282500267028809e+01 2.3424200439453125e+02 -2.7314401245117188e+02 1.2202500343322754e+01 2.3394299316406250e+02 -2.7318899536132812e+02 1.2282599449157715e+01 2.3364399719238281e+02 -2.7318899536132812e+02 1.2501299858093262e+01 2.3342601013183594e+02 -2.7318899536132812e+02 1.2800100326538086e+01 2.3334599304199219e+02 -2.7318899536132812e+02 1.3098799705505371e+01 2.3342601013183594e+02 -2.7318899536132812e+02 1.3317500114440918e+01 2.3364399719238281e+02 -2.7318899536132812e+02 1.3397500038146973e+01 2.3394299316406250e+02 -2.7318899536132812e+02 1.3317399978637695e+01 2.3424200439453125e+02 -2.7318899536132812e+02 1.3098699569702148e+01 2.3446099853515625e+02 -2.7318899536132812e+02 1.2799900054931641e+01 2.3454100036621094e+02 -2.7318899536132812e+02 1.2501199722290039e+01 2.3446099853515625e+02 -2.7318899536132812e+02 1.2282500267028809e+01 2.3424200439453125e+02 -2.7318899536132812e+02 1.2202500343322754e+01 2.3394299316406250e+02 -2.7322900390625000e+02 1.2299300193786621e+01 2.3365400695800781e+02 -2.7322900390625000e+02 1.2510999679565430e+01 2.3344198608398438e+02 -2.7322900390625000e+02 1.2800100326538086e+01 2.3336500549316406e+02 -2.7322900390625000e+02 1.3089099884033203e+01 2.3344198608398438e+02 -2.7322900390625000e+02 1.3300799369812012e+01 2.3365400695800781e+02 -2.7322900390625000e+02 1.3378200531005859e+01 2.3394299316406250e+02 -2.7322900390625000e+02 1.3300700187683105e+01 2.3423199462890625e+02 -2.7322900390625000e+02 1.3089000701904297e+01 2.3444400024414062e+02 -2.7322900390625000e+02 1.2799900054931641e+01 2.3452099609375000e+02 -2.7322900390625000e+02 1.2510900497436523e+01 2.3444400024414062e+02 -2.7322900390625000e+02 1.2299300193786621e+01 2.3423199462890625e+02 -2.7322900390625000e+02 1.2221799850463867e+01 2.3394299316406250e+02 -2.7325698852539062e+02 1.2329399108886719e+01 2.3367098999023438e+02 -2.7325698852539062e+02 1.2528399467468262e+01 2.3347300720214844e+02 -2.7325698852539062e+02 1.2800100326538086e+01 2.3340000915527344e+02 -2.7325698852539062e+02 1.3071700096130371e+01 2.3347300720214844e+02 -2.7325698852539062e+02 1.3270599365234375e+01 2.3367098999023438e+02 -2.7325698852539062e+02 1.3343400001525879e+01 2.3394299316406250e+02 -2.7325698852539062e+02 1.3270599365234375e+01 2.3421501159667969e+02 -2.7325698852539062e+02 1.3071599960327148e+01 2.3441400146484375e+02 -2.7325698852539062e+02 1.2799900054931641e+01 2.3448699951171875e+02 -2.7325698852539062e+02 1.2528300285339355e+01 2.3441400146484375e+02 -2.7325698852539062e+02 1.2329399108886719e+01 2.3421501159667969e+02 -2.7325698852539062e+02 1.2256600379943848e+01 2.3394299316406250e+02 -2.7306600952148438e+02 7.3670101165771484e+00 2.3369300842285156e+02 -2.7307598876953125e+02 7.3294401168823242e+00 2.3367098999023438e+02 -2.7306600952148438e+02 7.5500397682189941e+00 2.3351000976562500e+02 -2.7307598876953125e+02 7.5283503532409668e+00 2.3347300720214844e+02 -2.7306600952148438e+02 7.8000502586364746e+00 2.3344300842285156e+02 -2.7307598876953125e+02 7.8000502586364746e+00 2.3340000915527344e+02 -2.7306600952148438e+02 8.0500402450561523e+00 2.3351000976562500e+02 -2.7307598876953125e+02 8.0717401504516602e+00 2.3347300720214844e+02 -2.7306600952148438e+02 8.2330398559570312e+00 2.3369300842285156e+02 -2.7307598876953125e+02 8.2706098556518555e+00 2.3367098999023438e+02 -2.7306600952148438e+02 8.3000001907348633e+00 2.3394299316406250e+02 -2.7307598876953125e+02 8.3433904647827148e+00 2.3394299316406250e+02 -2.7306600952148438e+02 8.2329902648925781e+00 2.3419299316406250e+02 -2.7307598876953125e+02 8.2705602645874023e+00 2.3421501159667969e+02 -2.7306600952148438e+02 8.0499601364135742e+00 2.3437599182128906e+02 -2.7307598876953125e+02 8.0716495513916016e+00 2.3441400146484375e+02 -2.7306600952148438e+02 7.7999501228332520e+00 2.3444299316406250e+02 -2.7307598876953125e+02 7.7999501228332520e+00 2.3448699951171875e+02 -2.7306600952148438e+02 7.5499601364135742e+00 2.3437599182128906e+02 -2.7307598876953125e+02 7.5282597541809082e+00 2.3441400146484375e+02 -2.7306600952148438e+02 7.3669600486755371e+00 2.3419299316406250e+02 -2.7307598876953125e+02 7.3293900489807129e+00 2.3421501159667969e+02 -2.7306600952148438e+02 7.3000001907348633e+00 2.3394299316406250e+02 -2.7307598876953125e+02 7.2566099166870117e+00 2.3394299316406250e+02 -2.7310400390625000e+02 7.2993102073669434e+00 2.3365400695800781e+02 -2.7310400390625000e+02 7.5109601020812988e+00 2.3344198608398438e+02 -2.7310400390625000e+02 7.8000597953796387e+00 2.3336500549316406e+02 -2.7310400390625000e+02 8.0891399383544922e+00 2.3344198608398438e+02 -2.7310400390625000e+02 8.3007497787475586e+00 2.3365400695800781e+02 -2.7310400390625000e+02 8.3781795501708984e+00 2.3394299316406250e+02 -2.7310400390625000e+02 8.3006896972656250e+00 2.3423199462890625e+02 -2.7310400390625000e+02 8.0890407562255859e+00 2.3444400024414062e+02 -2.7310400390625000e+02 7.7999401092529297e+00 2.3452099609375000e+02 -2.7310400390625000e+02 7.5108599662780762e+00 2.3444400024414062e+02 -2.7310400390625000e+02 7.2992501258850098e+00 2.3423199462890625e+02 -2.7310400390625000e+02 7.2218198776245117e+00 2.3394299316406250e+02 -2.7314401245117188e+02 7.2825899124145508e+00 2.3364399719238281e+02 -2.7314401245117188e+02 7.5012998580932617e+00 2.3342601013183594e+02 -2.7314401245117188e+02 7.8000597953796387e+00 2.3334599304199219e+02 -2.7314401245117188e+02 8.0987997055053711e+00 2.3342601013183594e+02 -2.7314401245117188e+02 8.3174695968627930e+00 2.3364399719238281e+02 -2.7314401245117188e+02 8.3974895477294922e+00 2.3394299316406250e+02 -2.7314401245117188e+02 8.3174104690551758e+00 2.3424200439453125e+02 -2.7314401245117188e+02 8.0987005233764648e+00 2.3446099853515625e+02 -2.7314401245117188e+02 7.7999401092529297e+00 2.3454100036621094e+02 -2.7314401245117188e+02 7.5011997222900391e+00 2.3446099853515625e+02 -2.7314401245117188e+02 7.2825298309326172e+00 2.3424200439453125e+02 -2.7314401245117188e+02 7.2025098800659180e+00 2.3394299316406250e+02 -2.7318899536132812e+02 7.2825899124145508e+00 2.3364399719238281e+02 -2.7318899536132812e+02 7.5012998580932617e+00 2.3342601013183594e+02 -2.7318899536132812e+02 7.8000597953796387e+00 2.3334599304199219e+02 -2.7318899536132812e+02 8.0987997055053711e+00 2.3342601013183594e+02 -2.7318899536132812e+02 8.3174695968627930e+00 2.3364399719238281e+02 -2.7318899536132812e+02 8.3974895477294922e+00 2.3394299316406250e+02 -2.7318899536132812e+02 8.3174104690551758e+00 2.3424200439453125e+02 -2.7318899536132812e+02 8.0987005233764648e+00 2.3446099853515625e+02 -2.7318899536132812e+02 7.7999401092529297e+00 2.3454100036621094e+02 -2.7318899536132812e+02 7.5011997222900391e+00 2.3446099853515625e+02 -2.7318899536132812e+02 7.2825298309326172e+00 2.3424200439453125e+02 -2.7318899536132812e+02 7.2025098800659180e+00 2.3394299316406250e+02 -2.7322900390625000e+02 7.2993102073669434e+00 2.3365400695800781e+02 -2.7322900390625000e+02 7.5109601020812988e+00 2.3344198608398438e+02 -2.7322900390625000e+02 7.8000597953796387e+00 2.3336500549316406e+02 -2.7322900390625000e+02 8.0891399383544922e+00 2.3344198608398438e+02 -2.7322900390625000e+02 8.3007497787475586e+00 2.3365400695800781e+02 -2.7322900390625000e+02 8.3781795501708984e+00 2.3394299316406250e+02 -2.7322900390625000e+02 8.3006896972656250e+00 2.3423199462890625e+02 -2.7322900390625000e+02 8.0890407562255859e+00 2.3444400024414062e+02 -2.7322900390625000e+02 7.7999401092529297e+00 2.3452099609375000e+02 -2.7322900390625000e+02 7.5108599662780762e+00 2.3444400024414062e+02 -2.7322900390625000e+02 7.2992501258850098e+00 2.3423199462890625e+02 -2.7322900390625000e+02 7.2218198776245117e+00 2.3394299316406250e+02 -2.7325698852539062e+02 7.3294401168823242e+00 2.3367098999023438e+02 -2.7325698852539062e+02 7.5283503532409668e+00 2.3347300720214844e+02 -2.7325698852539062e+02 7.8000502586364746e+00 2.3340000915527344e+02 -2.7325698852539062e+02 8.0717401504516602e+00 2.3347300720214844e+02 -2.7325698852539062e+02 8.2706098556518555e+00 2.3367098999023438e+02 -2.7325698852539062e+02 8.3433904647827148e+00 2.3394299316406250e+02 -2.7325698852539062e+02 8.2705602645874023e+00 2.3421501159667969e+02 -2.7325698852539062e+02 8.0716495513916016e+00 2.3441400146484375e+02 -2.7325698852539062e+02 7.7999501228332520e+00 2.3448699951171875e+02 -2.7325698852539062e+02 7.5282597541809082e+00 2.3441400146484375e+02 -2.7325698852539062e+02 7.3293900489807129e+00 2.3421501159667969e+02 -2.7325698852539062e+02 7.2566099166870117e+00 2.3394299316406250e+02 -2.7306600952148438e+02 9.8670101165771484e+00 2.3119300842285156e+02 -2.7307598876953125e+02 9.8294401168823242e+00 2.3117098999023438e+02 -2.7306600952148438e+02 1.0049999237060547e+01 2.3101000976562500e+02 -2.7307598876953125e+02 1.0028400421142578e+01 2.3097300720214844e+02 -2.7306600952148438e+02 1.0300000190734863e+01 2.3094299316406250e+02 -2.7307598876953125e+02 1.0300100326538086e+01 2.3090000915527344e+02 -2.7306600952148438e+02 1.0550000190734863e+01 2.3101000976562500e+02 -2.7307598876953125e+02 1.0571699142456055e+01 2.3097300720214844e+02 -2.7306600952148438e+02 1.0732999801635742e+01 2.3119300842285156e+02 -2.7307598876953125e+02 1.0770600318908691e+01 2.3117098999023438e+02 -2.7306600952148438e+02 1.0800000190734863e+01 2.3144300842285156e+02 -2.7307598876953125e+02 1.0843400001525879e+01 2.3144300842285156e+02 -2.7306600952148438e+02 1.0732999801635742e+01 2.3169299316406250e+02 -2.7307598876953125e+02 1.0770600318908691e+01 2.3171499633789062e+02 -2.7306600952148438e+02 1.0550000190734863e+01 2.3187600708007812e+02 -2.7307598876953125e+02 1.0571599960327148e+01 2.3191400146484375e+02 -2.7306600952148438e+02 1.0300000190734863e+01 2.3194299316406250e+02 -2.7307598876953125e+02 1.0299900054931641e+01 2.3198699951171875e+02 -2.7306600952148438e+02 1.0049999237060547e+01 2.3187600708007812e+02 -2.7307598876953125e+02 1.0028300285339355e+01 2.3191400146484375e+02 -2.7306600952148438e+02 9.8669605255126953e+00 2.3169299316406250e+02 -2.7307598876953125e+02 9.8293895721435547e+00 2.3171499633789062e+02 -2.7306600952148438e+02 9.8000001907348633e+00 2.3144300842285156e+02 -2.7307598876953125e+02 9.7566099166870117e+00 2.3144300842285156e+02 -2.7310400390625000e+02 9.7993097305297852e+00 2.3115399169921875e+02 -2.7310400390625000e+02 1.0010999679565430e+01 2.3094200134277344e+02 -2.7310400390625000e+02 1.0300100326538086e+01 2.3086500549316406e+02 -2.7310400390625000e+02 1.0589100837707520e+01 2.3094200134277344e+02 -2.7310400390625000e+02 1.0800699234008789e+01 2.3115399169921875e+02 -2.7310400390625000e+02 1.0878199577331543e+01 2.3144300842285156e+02 -2.7310400390625000e+02 1.0800699234008789e+01 2.3173199462890625e+02 -2.7310400390625000e+02 1.0588999748229980e+01 2.3194400024414062e+02 -2.7310400390625000e+02 1.0299900054931641e+01 2.3202101135253906e+02 -2.7310400390625000e+02 1.0010899543762207e+01 2.3194400024414062e+02 -2.7310400390625000e+02 9.7992506027221680e+00 2.3173199462890625e+02 -2.7310400390625000e+02 9.7218198776245117e+00 2.3144300842285156e+02 -2.7314401245117188e+02 9.7825899124145508e+00 2.3114399719238281e+02 -2.7314401245117188e+02 1.0001299858093262e+01 2.3092601013183594e+02 -2.7314401245117188e+02 1.0300100326538086e+01 2.3084600830078125e+02 -2.7314401245117188e+02 1.0598799705505371e+01 2.3092601013183594e+02 -2.7314401245117188e+02 1.0817500114440918e+01 2.3114399719238281e+02 -2.7314401245117188e+02 1.0897500038146973e+01 2.3144300842285156e+02 -2.7314401245117188e+02 1.0817399978637695e+01 2.3174198913574219e+02 -2.7314401245117188e+02 1.0598699569702148e+01 2.3196099853515625e+02 -2.7314401245117188e+02 1.0299900054931641e+01 2.3204100036621094e+02 -2.7314401245117188e+02 1.0001200675964355e+01 2.3196099853515625e+02 -2.7314401245117188e+02 9.7825307846069336e+00 2.3174198913574219e+02 -2.7314401245117188e+02 9.7025098800659180e+00 2.3144300842285156e+02 -2.7318899536132812e+02 9.7825899124145508e+00 2.3114399719238281e+02 -2.7318899536132812e+02 1.0001299858093262e+01 2.3092601013183594e+02 -2.7318899536132812e+02 1.0300100326538086e+01 2.3084600830078125e+02 -2.7318899536132812e+02 1.0598799705505371e+01 2.3092601013183594e+02 -2.7318899536132812e+02 1.0817500114440918e+01 2.3114399719238281e+02 -2.7318899536132812e+02 1.0897500038146973e+01 2.3144300842285156e+02 -2.7318899536132812e+02 1.0817399978637695e+01 2.3174198913574219e+02 -2.7318899536132812e+02 1.0598699569702148e+01 2.3196099853515625e+02 -2.7318899536132812e+02 1.0299900054931641e+01 2.3204100036621094e+02 -2.7318899536132812e+02 1.0001200675964355e+01 2.3196099853515625e+02 -2.7318899536132812e+02 9.7825307846069336e+00 2.3174198913574219e+02 -2.7318899536132812e+02 9.7025098800659180e+00 2.3144300842285156e+02 -2.7322900390625000e+02 9.7993097305297852e+00 2.3115399169921875e+02 -2.7322900390625000e+02 1.0010999679565430e+01 2.3094200134277344e+02 -2.7322900390625000e+02 1.0300100326538086e+01 2.3086500549316406e+02 -2.7322900390625000e+02 1.0589100837707520e+01 2.3094200134277344e+02 -2.7322900390625000e+02 1.0800699234008789e+01 2.3115399169921875e+02 -2.7322900390625000e+02 1.0878199577331543e+01 2.3144300842285156e+02 -2.7322900390625000e+02 1.0800699234008789e+01 2.3173199462890625e+02 -2.7322900390625000e+02 1.0588999748229980e+01 2.3194400024414062e+02 -2.7322900390625000e+02 1.0299900054931641e+01 2.3202101135253906e+02 -2.7322900390625000e+02 1.0010899543762207e+01 2.3194400024414062e+02 -2.7322900390625000e+02 9.7992506027221680e+00 2.3173199462890625e+02 -2.7322900390625000e+02 9.7218198776245117e+00 2.3144300842285156e+02 -2.7325698852539062e+02 9.8294401168823242e+00 2.3117098999023438e+02 -2.7325698852539062e+02 1.0028400421142578e+01 2.3097300720214844e+02 -2.7325698852539062e+02 1.0300100326538086e+01 2.3090000915527344e+02 -2.7325698852539062e+02 1.0571699142456055e+01 2.3097300720214844e+02 -2.7325698852539062e+02 1.0770600318908691e+01 2.3117098999023438e+02 -2.7325698852539062e+02 1.0843400001525879e+01 2.3144300842285156e+02 -2.7325698852539062e+02 1.0770600318908691e+01 2.3171499633789062e+02 -2.7325698852539062e+02 1.0571599960327148e+01 2.3191400146484375e+02 -2.7325698852539062e+02 1.0299900054931641e+01 2.3198699951171875e+02 -2.7325698852539062e+02 1.0028300285339355e+01 2.3191400146484375e+02 -2.7325698852539062e+02 9.8293895721435547e+00 2.3171499633789062e+02 -2.7325698852539062e+02 9.7566099166870117e+00 2.3144300842285156e+02 -2.8136599731445312e+02 7.3743500709533691e+00 2.3605599975585938e+02 -2.8136599731445312e+02 6.9604501724243164e+00 2.3647000122070312e+02 -2.8136599731445312e+02 7.7736201286315918e+00 2.3728300476074219e+02 -2.8136599731445312e+02 8.1875200271606445e+00 2.3686900329589844e+02 -2.8136599731445312e+02 8.3210601806640625e+00 2.3665901184082031e+02 -2.8136599731445312e+02 7.5837297439575195e+00 2.3592199707031250e+02 -2.8136599731445312e+02 8.2686195373535156e+00 2.3615800476074219e+02 -2.8136599731445312e+02 8.0855398178100586e+00 2.3597499084472656e+02 -2.8136599731445312e+02 7.8406901359558105e+00 2.3588999938964844e+02 -2.8136599731445312e+02 8.3528194427490234e+00 2.3640200805664062e+02 -2.7281600952148438e+02 8.5071105957031250e+00 2.3464999389648438e+02 -2.7281600952148438e+02 7.7999997138977051e+00 2.3294299316406250e+02 -2.7281600952148438e+02 8.2539901733398438e+00 2.3305200195312500e+02 -2.7281600952148438e+02 8.6090202331542969e+00 2.3335499572753906e+02 -2.7281600952148438e+02 8.7876901626586914e+00 2.3378700256347656e+02 -2.7281600952148438e+02 8.7510595321655273e+00 2.3425199890136719e+02 -2.7281600952148438e+02 7.3759598731994629e+00 2.3294299316406250e+02 -2.7281600952148438e+02 7.1018300056457520e+00 2.3252099609375000e+02 -2.7281600952148438e+02 7.0769000053405762e+00 2.3266699218750000e+02 -2.7281600952148438e+02 7.1244001388549805e+00 2.3280699157714844e+02 -2.7281600952148438e+02 7.2328500747680664e+00 2.3290699768066406e+02 -2.7281600952148438e+02 8.8781204223632812e+00 2.3074499511718750e+02 -2.7281600952148438e+02 7.8251295089721680e+00 2.3146800231933594e+02 -2.7281600952148438e+02 9.3000001907348633e+00 2.3101901245117188e+02 -2.7281600952148438e+02 9.2636594772338867e+00 2.3087599182128906e+02 -2.7281600952148438e+02 9.1634597778320312e+00 2.3076799011230469e+02 -2.7281600952148438e+02 9.0236597061157227e+00 2.3072000122070312e+02 -2.7281600952148438e+02 9.3000001907348633e+00 2.3144300842285156e+02 -2.7281600952148438e+02 1.1300000190734863e+01 2.3144300842285156e+02 -2.7281600952148438e+02 1.1201000213623047e+01 2.3187699890136719e+02 -2.7281600952148438e+02 1.0923500061035156e+01 2.3222500610351562e+02 -2.7281600952148438e+02 1.0522500038146973e+01 2.3241799926757812e+02 -2.7281600952148438e+02 1.0077499389648438e+01 2.3241799926757812e+02 -2.7281600952148438e+02 9.6765098571777344e+00 2.3222500610351562e+02 -2.7281600952148438e+02 9.3990306854248047e+00 2.3187699890136719e+02 -2.7281600952148438e+02 1.1300000190734863e+01 2.3101901245117188e+02 -2.7281600952148438e+02 1.1721899986267090e+01 2.3074499511718750e+02 -2.7281600952148438e+02 1.1576299667358398e+01 2.3072000122070312e+02 -2.7281600952148438e+02 1.1436499595642090e+01 2.3076799011230469e+02 -2.7281600952148438e+02 1.1336299896240234e+01 2.3087599182128906e+02 -2.7281600952148438e+02 1.3498200416564941e+01 2.3252099609375000e+02 -2.7281600952148438e+02 1.2774899482727051e+01 2.3146800231933594e+02 -2.7281600952148438e+02 1.3223999977111816e+01 2.3294299316406250e+02 -2.7281600952148438e+02 1.3367199897766113e+01 2.3290699768066406e+02 -2.7281600952148438e+02 1.3475599288940430e+01 2.3280699157714844e+02 -2.7281600952148438e+02 1.3523099899291992e+01 2.3266699218750000e+02 -2.7281600952148438e+02 1.2799999237060547e+01 2.3294299316406250e+02 -2.7281600952148438e+02 1.2799999237060547e+01 2.3494300842285156e+02 -2.7281600952148438e+02 1.2366100311279297e+01 2.3484399414062500e+02 -2.7281600952148438e+02 1.2018199920654297e+01 2.3456700134277344e+02 -2.7281600952148438e+02 1.1825099945068359e+01 2.3416600036621094e+02 -2.7281600952148438e+02 1.1825099945068359e+01 2.3372100830078125e+02 -2.7281600952148438e+02 1.2018199920654297e+01 2.3331999206542969e+02 -2.7281600952148438e+02 1.2366100311279297e+01 2.3304200744628906e+02 -2.7281600952148438e+02 1.3223999977111816e+01 2.3494300842285156e+02 -2.7281600952148438e+02 1.3498200416564941e+01 2.3536500549316406e+02 -2.7281600952148438e+02 1.3523099899291992e+01 2.3521899414062500e+02 -2.7281600952148438e+02 1.3475599288940430e+01 2.3508000183105469e+02 -2.7281600952148438e+02 1.3367199897766113e+01 2.3497900390625000e+02 -2.7281600952148438e+02 1.1721899986267090e+01 2.3714099121093750e+02 -2.7281600952148438e+02 1.2774899482727051e+01 2.3641799926757812e+02 -2.7281600952148438e+02 1.1300000190734863e+01 2.3686698913574219e+02 -2.7281600952148438e+02 1.1336299896240234e+01 2.3701000976562500e+02 -2.7281600952148438e+02 1.1436499595642090e+01 2.3711900329589844e+02 -2.7281600952148438e+02 1.1576299667358398e+01 2.3716600036621094e+02 -2.7281600952148438e+02 1.1300000190734863e+01 2.3644299316406250e+02 -2.7281600952148438e+02 9.5857591629028320e+00 2.3574299621582031e+02 -2.7281600952148438e+02 9.9832801818847656e+00 2.3549499511718750e+02 -2.7281600952148438e+02 1.0450400352478027e+01 2.3545500183105469e+02 -2.7281600952148438e+02 1.0884500503540039e+01 2.3563200378417969e+02 -2.7281600952148438e+02 1.1190099716186523e+01 2.3598699951171875e+02 -2.7281600952148438e+02 9.8000001907348633e+00 2.3644299316406250e+02 -2.7281600952148438e+02 9.8669605255126953e+00 2.3669299316406250e+02 -2.7281600952148438e+02 1.0049999237060547e+01 2.3687599182128906e+02 -2.7281600952148438e+02 1.0300000190734863e+01 2.3694300842285156e+02 -2.7281600952148438e+02 1.0550000190734863e+01 2.3687599182128906e+02 -2.7281600952148438e+02 1.0732999801635742e+01 2.3669299316406250e+02 -2.7281600952148438e+02 1.0800000190734863e+01 2.3644299316406250e+02 -2.7281600952148438e+02 1.0732999801635742e+01 2.3619300842285156e+02 -2.7281600952148438e+02 1.0550000190734863e+01 2.3600999450683594e+02 -2.7281600952148438e+02 1.0300000190734863e+01 2.3594300842285156e+02 -2.7281600952148438e+02 1.0049999237060547e+01 2.3600999450683594e+02 -2.7281600952148438e+02 9.8670101165771484e+00 2.3619300842285156e+02 -2.7281600952148438e+02 1.2299999237060547e+01 2.3394299316406250e+02 -2.7281600952148438e+02 1.2366999626159668e+01 2.3419299316406250e+02 -2.7281600952148438e+02 1.2550000190734863e+01 2.3437599182128906e+02 -2.7281600952148438e+02 1.2799999237060547e+01 2.3444299316406250e+02 -2.7281600952148438e+02 1.3050000190734863e+01 2.3437599182128906e+02 -2.7281600952148438e+02 1.3233000755310059e+01 2.3419299316406250e+02 -2.7281600952148438e+02 1.3300000190734863e+01 2.3394299316406250e+02 -2.7281600952148438e+02 1.3233000755310059e+01 2.3369300842285156e+02 -2.7281600952148438e+02 1.3050000190734863e+01 2.3351000976562500e+02 -2.7281600952148438e+02 1.2799999237060547e+01 2.3344300842285156e+02 -2.7281600952148438e+02 1.2550000190734863e+01 2.3351000976562500e+02 -2.7281600952148438e+02 1.2366999626159668e+01 2.3369300842285156e+02 -2.7281600952148438e+02 7.3000001907348633e+00 2.3394299316406250e+02 -2.7281600952148438e+02 7.3669600486755371e+00 2.3419299316406250e+02 -2.7281600952148438e+02 7.5499601364135742e+00 2.3437599182128906e+02 -2.7281600952148438e+02 7.7999501228332520e+00 2.3444299316406250e+02 -2.7281600952148438e+02 8.0499601364135742e+00 2.3437599182128906e+02 -2.7281600952148438e+02 8.2329902648925781e+00 2.3419299316406250e+02 -2.7281600952148438e+02 8.3000001907348633e+00 2.3394299316406250e+02 -2.7281600952148438e+02 8.2330398559570312e+00 2.3369300842285156e+02 -2.7281600952148438e+02 8.0500402450561523e+00 2.3351000976562500e+02 -2.7281600952148438e+02 7.8000502586364746e+00 2.3344300842285156e+02 -2.7281600952148438e+02 7.5500397682189941e+00 2.3351000976562500e+02 -2.7281600952148438e+02 7.3670101165771484e+00 2.3369300842285156e+02 -2.7281600952148438e+02 9.8000001907348633e+00 2.3144300842285156e+02 -2.7281600952148438e+02 9.8669605255126953e+00 2.3169299316406250e+02 -2.7281600952148438e+02 1.0049999237060547e+01 2.3187600708007812e+02 -2.7281600952148438e+02 1.0300000190734863e+01 2.3194299316406250e+02 -2.7281600952148438e+02 1.0550000190734863e+01 2.3187600708007812e+02 -2.7281600952148438e+02 1.0732999801635742e+01 2.3169299316406250e+02 -2.7281600952148438e+02 1.0800000190734863e+01 2.3144300842285156e+02 -2.7281600952148438e+02 1.0732999801635742e+01 2.3119300842285156e+02 -2.7281600952148438e+02 1.0550000190734863e+01 2.3101000976562500e+02 -2.7281600952148438e+02 1.0300000190734863e+01 2.3094299316406250e+02 -2.7281600952148438e+02 1.0049999237060547e+01 2.3101000976562500e+02 -2.7281600952148438e+02 9.8670101165771484e+00 2.3119300842285156e+02 -2.7281600952148438e+02 8.1875200271606445e+00 2.3686900329589844e+02 -2.7281600952148438e+02 7.5837297439575195e+00 2.3592199707031250e+02 -2.7281600952148438e+02 7.3743500709533691e+00 2.3605599975585938e+02 -2.7281600952148438e+02 8.3210601806640625e+00 2.3665901184082031e+02 -2.7281600952148438e+02 8.3528194427490234e+00 2.3640200805664062e+02 -2.7281600952148438e+02 8.2686195373535156e+00 2.3615800476074219e+02 -2.7281600952148438e+02 8.0855398178100586e+00 2.3597499084472656e+02 -2.7281600952148438e+02 7.8406901359558105e+00 2.3588999938964844e+02 -2.7281600952148438e+02 7.9879398345947266e+00 2.3706799316406250e+02 -2.7281600952148438e+02 8.7171106338500977e+00 2.3749400329589844e+02 -2.7281600952148438e+02 9.6997699737548828e+00 2.3778399658203125e+02 -2.7281600952148438e+02 1.0724100112915039e+01 2.3780700683593750e+02 -2.7281600952148438e+02 9.7583503723144531e+00 2.3009399414062500e+02 -2.7281600952148438e+02 1.0782899856567383e+01 2.3008599853515625e+02 -2.7281600952148438e+02 6.4357099533081055e+00 2.3351899719238281e+02 -2.7281600952148438e+02 1.4149600028991699e+01 2.3448500061035156e+02 -2.7281600952148438e+02 1.3874400138854980e+01 2.3547200012207031e+02 -2.7281600952148438e+02 6.6807398796081543e+00 2.3252398681640625e+02 -2.7281600952148438e+02 8.7713804244995117e+00 2.3036900329589844e+02 -2.7281600952148438e+02 7.1747698783874512e+00 2.3625500488281250e+02 -2.7281600952148438e+02 6.7493500709533691e+00 2.3552600097656250e+02 -2.7281600952148438e+02 6.4591202735900879e+00 2.3454299926757812e+02 -2.7281600952148438e+02 1.1774000167846680e+01 2.3034599304199219e+02 -2.7281600952148438e+02 1.4157399177551270e+01 2.3345999145507812e+02 -2.7281600952148438e+02 1.3897200584411621e+01 2.3246900939941406e+02 -2.7281600952148438e+02 1.1718999862670898e+01 2.3756199645996094e+02 -2.7281600952148438e+02 1.2662599563598633e+01 2.3085600280761719e+02 -2.7281600952148438e+02 1.3387200355529785e+01 2.3158000183105469e+02 -2.7281600952148438e+02 1.3350799560546875e+01 2.3635299682617188e+02 -2.7281600952148438e+02 1.2615300178527832e+01 2.3706599426269531e+02 -2.7281600952148438e+02 7.1772098541259766e+00 2.3162800598144531e+02 -2.7281600952148438e+02 7.8906102180480957e+00 2.3089199829101562e+02 -2.7311599731445312e+02 7.7736201286315918e+00 2.3728300476074219e+02 -2.7305297851562500e+02 7.7783999443054199e+00 2.3727799987792969e+02 -2.7300500488281250e+02 7.7921800613403320e+00 2.3726400756835938e+02 -2.7296002197265625e+02 7.8051500320434570e+00 2.3725099182128906e+02 -2.7283401489257812e+02 7.9164199829101562e+00 2.3713999938964844e+02 -2.7284197998046875e+02 7.9062495231628418e+00 2.3714999389648438e+02 -2.7288299560546875e+02 7.8529605865478516e+00 2.3720300292968750e+02 -2.7311599731445312e+02 6.9604501724243164e+00 2.3647000122070312e+02 -2.7286300659179688e+02 7.0595297813415527e+00 2.3636999511718750e+02 -2.7292999267578125e+02 7.0066199302673340e+00 2.3642300415039062e+02 -2.7300500488281250e+02 6.9775300025939941e+00 2.3645199584960938e+02 -2.7282397460937500e+02 7.1256399154663086e+00 2.3630400085449219e+02 -2.7284301757812500e+02 7.0934300422668457e+00 2.3633700561523438e+02 -2.7301800537109375e+02 6.9723501205444336e+00 2.3645800781250000e+02 -2.7283999633789062e+02 6.6439003944396973e+00 2.3557299804687500e+02 -2.7283999633789062e+02 8.6701002120971680e+00 2.3759899902343750e+02 -2.7311599731445312e+02 6.7621798515319824e+00 2.3613398742675781e+02 -2.7300399780273438e+02 6.4954700469970703e+00 2.3563900756835938e+02 -2.7311599731445312e+02 6.2128300666809082e+00 2.3318000793457031e+02 -2.7311599731445312e+02 6.1375002861022949e+00 2.3348599243164062e+02 -2.7300399780273438e+02 6.1593999862670898e+00 2.3348901367187500e+02 -2.7311599731445312e+02 6.1627101898193359e+00 2.3458999633789062e+02 -2.7300399780273438e+02 6.1844801902770996e+00 2.3458599853515625e+02 -2.7311599731445312e+02 6.1976799964904785e+00 2.3470799255371094e+02 -2.7311599731445312e+02 6.4753398895263672e+00 2.3564801025390625e+02 -2.7311599731445312e+02 6.4014401435852051e+00 2.3241500854492188e+02 -2.7300399780273438e+02 6.4219598770141602e+00 2.3242298889160156e+02 -2.7311599731445312e+02 6.7675399780273438e+00 2.3175399780273438e+02 -2.7300399780273438e+02 6.9539198875427246e+00 2.3146200561523438e+02 -2.7311599731445312e+02 6.9362201690673828e+00 2.3144898986816406e+02 -2.7300399780273438e+02 7.7183299064636230e+00 2.3067399597167969e+02 -2.7311599731445312e+02 7.7046699523925781e+00 2.3065699768066406e+02 -2.7300399780273438e+02 9.7196207046508789e+00 2.2981800842285156e+02 -2.7311599731445312e+02 9.1642303466796875e+00 2.2995098876953125e+02 -2.7300399780273438e+02 8.6620807647705078e+00 2.3011300659179688e+02 -2.7311599731445312e+02 8.6534204483032227e+00 2.3009300231933594e+02 -2.7311599731445312e+02 7.7824296951293945e+00 2.3061099243164062e+02 -2.7311599731445312e+02 1.2152299880981445e+01 2.3022000122070312e+02 -2.7311599731445312e+02 1.1887700080871582e+01 2.3006799316406250e+02 -2.7300399780273438e+02 1.1879400253295898e+01 2.3008898925781250e+02 -2.7311599731445312e+02 1.0820199966430664e+01 2.2978800964355469e+02 -2.7300399780273438e+02 1.0817500114440918e+01 2.2980999755859375e+02 -2.7311599731445312e+02 1.0686899185180664e+01 2.2978900146484375e+02 -2.7311599731445312e+02 9.7165498733520508e+00 2.2979600524902344e+02 -2.7311599731445312e+02 1.2845000267028809e+01 2.3061799621582031e+02 -2.7300399780273438e+02 1.2831600189208984e+01 2.3063500976562500e+02 -2.7311599731445312e+02 1.3372200012207031e+01 2.3114498901367188e+02 -2.7300399780273438e+02 1.3607899665832520e+01 2.3141198730468750e+02 -2.7311599731445312e+02 1.3625400543212891e+01 2.3139799499511719e+02 -2.7300399780273438e+02 1.4154399871826172e+01 2.3236399841308594e+02 -2.7311599731445312e+02 1.4174799919128418e+01 2.3235499572753906e+02 -2.7300399780273438e+02 1.4424799919128418e+01 2.3452400207519531e+02 -2.7311599731445312e+02 1.4451099395751953e+01 2.3394299316406250e+02 -2.7300399780273438e+02 1.4433199882507324e+01 2.3342601013183594e+02 -2.7311599731445312e+02 1.4455100059509277e+01 2.3342298889160156e+02 -2.7311599731445312e+02 1.4195300102233887e+01 2.3243299865722656e+02 -2.7311599731445312e+02 1.3374400138854980e+01 2.3674400329589844e+02 -2.7311599731445312e+02 1.3586199760437012e+01 2.3653799438476562e+02 -2.7300399780273438e+02 1.3569000244140625e+01 2.3652499389648438e+02 -2.7311599731445312e+02 1.4150200843811035e+01 2.3558999633789062e+02 -2.7300399780273438e+02 1.4129899978637695e+01 2.3558099365234375e+02 -2.7311599731445312e+02 1.4188700675964355e+01 2.3545199584960938e+02 -2.7311599731445312e+02 1.4446700096130371e+01 2.3452700805664062e+02 -2.7311599731445312e+02 1.2793999671936035e+01 2.3730699157714844e+02 -2.7300399780273438e+02 1.2780900001525879e+01 2.3728900146484375e+02 -2.7311599731445312e+02 1.2150400161743164e+01 2.3766299438476562e+02 -2.7300399780273438e+02 1.1820499420166016e+01 2.3782099914550781e+02 -2.7311599731445312e+02 1.1828499794006348e+01 2.3784199523925781e+02 -2.7300399780273438e+02 1.0754499435424805e+01 2.3808399963378906e+02 -2.7311599731445312e+02 1.0756899833679199e+01 2.3810600280761719e+02 -2.7300399780273438e+02 8.6039295196533203e+00 2.3774800109863281e+02 -2.7311599731445312e+02 7.7763199806213379e+00 2.3728401184082031e+02 -2.7311599731445312e+02 8.5949602127075195e+00 2.3776799011230469e+02 -2.7311599731445312e+02 9.1639299392700195e+00 2.3793600463867188e+02 -2.7300399780273438e+02 9.6568593978881836e+00 2.3805900573730469e+02 -2.7311599731445312e+02 9.6534500122070312e+00 2.3808000183105469e+02 -2.7311599731445312e+02 1.0686200141906738e+01 2.3810400390625000e+02 -2.7283999633789062e+02 9.6819505691528320e+00 2.3789801025390625e+02 -2.7283999633789062e+02 1.0736700057983398e+01 2.3792199707031250e+02 -2.7283999633789062e+02 1.1761199951171875e+01 2.3766999816894531e+02 -2.7283999633789062e+02 1.2684100151062012e+01 2.3715899658203125e+02 -2.7283999633789062e+02 1.3441399574279785e+01 2.3642399597167969e+02 -2.7283999633789062e+02 1.3980500221252441e+01 2.3551699829101562e+02 -2.7283999633789062e+02 1.4263899803161621e+01 2.3450100708007812e+02 -2.7283999633789062e+02 1.4271900177001953e+01 2.3344599914550781e+02 -2.7283999633789062e+02 1.4004099845886230e+01 2.3242500305175781e+02 -2.7283999633789062e+02 1.3478899955749512e+01 2.3150999450683594e+02 -2.7283999633789062e+02 1.2732800483703613e+01 2.3076400756835938e+02 -2.7283999633789062e+02 1.1817799568176270e+01 2.3023899841308594e+02 -2.7283999633789062e+02 1.0797300338745117e+01 2.2997100830078125e+02 -2.7283999633789062e+02 9.7422599792480469e+00 2.2997898864746094e+02 -2.7283999633789062e+02 8.7259807586669922e+00 2.3026300048828125e+02 -2.7283999633789062e+02 7.8190498352050781e+00 2.3080200195312500e+02 -2.7283999633789062e+02 7.0844597816467285e+00 2.3155899047851562e+02 -2.7283999633789062e+02 6.5732498168945312e+00 2.3248199462890625e+02 -2.7283999633789062e+02 6.3209400177001953e+00 2.3350599670410156e+02 -2.7283999633789062e+02 6.3450403213500977e+00 2.3456098937988281e+02 -2.7290499877929688e+02 8.6303300857543945e+00 2.3768800354003906e+02 -2.7290499877929688e+02 9.6668701171875000e+00 2.3799499511718750e+02 -2.7290499877929688e+02 1.0747400283813477e+01 2.3801899719238281e+02 -2.7290499877929688e+02 1.1796800613403320e+01 2.3776100158691406e+02 -2.7290499877929688e+02 1.2742300033569336e+01 2.3723699951171875e+02 -2.7290499877929688e+02 1.3518099784851074e+01 2.3648500061035156e+02 -2.7290499877929688e+02 1.4070300102233887e+01 2.3555599975585938e+02 -2.7290499877929688e+02 1.4360600471496582e+01 2.3451399230957031e+02 -2.7290499877929688e+02 1.4368900299072266e+01 2.3343400573730469e+02 -2.7290499877929688e+02 1.4094400405883789e+01 2.3238800048828125e+02 -2.7290499877929688e+02 1.3556400299072266e+01 2.3145100402832031e+02 -2.7290499877929688e+02 1.2792200088500977e+01 2.3068701171875000e+02 -2.7290499877929688e+02 1.1854800224304199e+01 2.3014900207519531e+02 -2.7290499877929688e+02 1.0809400558471680e+01 2.2987399291992188e+02 -2.7290499877929688e+02 9.7286596298217773e+00 2.2988299560546875e+02 -2.7290499877929688e+02 8.6875801086425781e+00 2.3017300415039062e+02 -2.7290499877929688e+02 7.7585096359252930e+00 2.3072500610351562e+02 -2.7290499877929688e+02 7.0059995651245117e+00 2.3150099182128906e+02 -2.7290499877929688e+02 6.4823198318481445e+00 2.3244599914550781e+02 -2.7290499877929688e+02 6.2238497734069824e+00 2.3349600219726562e+02 -2.7290499877929688e+02 6.2485399246215820e+00 2.3457600402832031e+02 -2.7290499877929688e+02 6.5546903610229492e+00 2.3561300659179688e+02 -2.8161599731445312e+02 6.7395000457763672e+00 2.3614700317382812e+02 -2.8161599731445312e+02 7.7761397361755371e+00 2.3728500366210938e+02 -2.8161599731445312e+02 1.4204899787902832e+01 2.3243099975585938e+02 -2.8161599731445312e+02 1.4487500190734863e+01 2.3394400024414062e+02 -2.8161599731445312e+02 1.3394899368286133e+01 2.3112200927734375e+02 -2.8161599731445312e+02 1.2166899681091309e+01 2.3019500732421875e+02 -2.8161599731445312e+02 1.0686800003051758e+01 2.2977400207519531e+02 -2.8161599731445312e+02 9.1544294357299805e+00 2.2991499328613281e+02 -2.8161599731445312e+02 7.7768001556396484e+00 2.3060099792480469e+02 -2.8161599731445312e+02 6.7399296760559082e+00 2.3173800659179688e+02 -2.8161599731445312e+02 6.1838798522949219e+00 2.3317300415039062e+02 -2.8161599731445312e+02 6.1837201118469238e+00 2.3471200561523438e+02 -2.8161599731445312e+02 9.1536397933959961e+00 2.3797099304199219e+02 -2.8161599731445312e+02 1.0685999870300293e+01 2.3811300659179688e+02 -2.8161599731445312e+02 1.2166200637817383e+01 2.3769200134277344e+02 -2.8161599731445312e+02 1.3394299507141113e+01 2.3676499938964844e+02 -2.8161599731445312e+02 1.4204600334167480e+01 2.3545600891113281e+02 -2.8161599731445312e+02 1.5244199752807617e+01 2.3311900329589844e+02 -2.8161599731445312e+02 1.4708600044250488e+01 2.3155799865722656e+02 -2.8161599731445312e+02 1.3695199966430664e+01 2.3025601196289062e+02 -2.8161599731445312e+02 1.2313899993896484e+01 2.2935299682617188e+02 -2.8161599731445312e+02 1.0714399337768555e+01 2.2894799804687500e+02 -2.8161599731445312e+02 9.0699796676635742e+00 2.2908399963378906e+02 -2.8161599731445312e+02 7.5588397979736328e+00 2.2974699401855469e+02 -2.8161599731445312e+02 6.3447399139404297e+00 2.3086399841308594e+02 -2.8161599731445312e+02 5.5592498779296875e+00 2.3231500244140625e+02 -2.8161599731445312e+02 5.2874999046325684e+00 2.3394299316406250e+02 -2.8161599731445312e+02 5.5589299201965332e+00 2.3556999206542969e+02 -2.8161599731445312e+02 6.3441295623779297e+00 2.3702099609375000e+02 -2.8161599731445312e+02 7.5580101013183594e+00 2.3813900756835938e+02 -2.8161599731445312e+02 9.0690298080444336e+00 2.3880200195312500e+02 -2.8161599731445312e+02 1.0713399887084961e+01 2.3893899536132812e+02 -2.8161599731445312e+02 1.2312999725341797e+01 2.3853399658203125e+02 -2.8161599731445312e+02 1.3694499969482422e+01 2.3763099670410156e+02 -2.8161599731445312e+02 1.4708100318908691e+01 2.3632901000976562e+02 -2.8161599731445312e+02 1.5244100570678711e+01 2.3476899719238281e+02 -2.8064099121093750e+02 5.3966503143310547e+00 2.3225900268554688e+02 -2.8064099121093750e+02 6.2090802192687988e+00 2.3075799560546875e+02 -2.8064099121093750e+02 7.4648199081420898e+00 2.2960301208496094e+02 -2.8064099121093750e+02 9.0277900695800781e+00 2.2891700744628906e+02 -2.8064099121093750e+02 1.0728600502014160e+01 2.2877598571777344e+02 -2.8064099121093750e+02 1.2383000373840332e+01 2.2919599914550781e+02 -2.8064099121093750e+02 1.3811699867248535e+01 2.3012899780273438e+02 -2.8064099121093750e+02 1.4859800338745117e+01 2.3147599792480469e+02 -2.8064099121093750e+02 1.5413800239562988e+01 2.3308999633789062e+02 -2.8064099121093750e+02 1.5413599967956543e+01 2.3479699707031250e+02 -2.8064099121093750e+02 1.4859299659729004e+01 2.3641101074218750e+02 -2.8064099121093750e+02 1.3810899734497070e+01 2.3775799560546875e+02 -2.8064099121093750e+02 1.2382100105285645e+01 2.3869100952148438e+02 -2.8064099121093750e+02 1.0727600097656250e+01 2.3910998535156250e+02 -2.8064099121093750e+02 9.0268096923828125e+00 2.3896899414062500e+02 -2.8064099121093750e+02 7.4639701843261719e+00 2.3828298950195312e+02 -2.8064099121093750e+02 6.2084498405456543e+00 2.3712699890136719e+02 -2.8064099121093750e+02 5.3963198661804199e+00 2.3562599182128906e+02 -2.8064099121093750e+02 5.1155796051025391e+00 2.3394299316406250e+02 -2.8064099121093750e+02 6.6558403968811035e+00 2.3790100097656250e+02 -2.8064099121093750e+02 5.5681796073913574e+00 2.3650300598144531e+02 -2.8064099121093750e+02 4.9932899475097656e+00 2.3482800292968750e+02 -2.8064099121093750e+02 4.9934601783752441e+00 2.3305700683593750e+02 -2.8064099121093750e+02 5.5686798095703125e+00 2.3138200378417969e+02 -2.8064099121093750e+02 6.6566200256347656e+00 2.2998500061035156e+02 -2.8064099121093750e+02 8.1393594741821289e+00 2.2901600646972656e+02 -2.8064099121093750e+02 9.8562498092651367e+00 2.2858099365234375e+02 -2.8064099121093750e+02 1.1621199607849121e+01 2.2872799682617188e+02 -2.8064099121093750e+02 1.3243000030517578e+01 2.2943901062011719e+02 -2.8064099121093750e+02 1.4545899391174316e+01 2.3063899230957031e+02 -2.8064099121093750e+02 1.5388700485229492e+01 2.3219700622558594e+02 -2.8064099121093750e+02 1.5680000305175781e+01 2.3394400024414062e+02 -2.8064099121093750e+02 1.5388299942016602e+01 2.3569099426269531e+02 -2.8064099121093750e+02 1.4545300483703613e+01 2.3724800109863281e+02 -2.8064099121093750e+02 1.3242100715637207e+01 2.3844699096679688e+02 -2.8064099121093750e+02 1.1620200157165527e+01 2.3915899658203125e+02 -2.8064099121093750e+02 9.8551998138427734e+00 2.3930500793457031e+02 -2.8064099121093750e+02 8.1383905410766602e+00 2.3886999511718750e+02 -2.7909100341796875e+02 1.5388700485229492e+01 2.3219700622558594e+02 -2.7909100341796875e+02 1.5680000305175781e+01 2.3394400024414062e+02 -2.7909100341796875e+02 1.5388299942016602e+01 2.3569099426269531e+02 -2.7909100341796875e+02 1.4545300483703613e+01 2.3724800109863281e+02 -2.7909100341796875e+02 1.3242100715637207e+01 2.3844699096679688e+02 -2.7909100341796875e+02 1.1620200157165527e+01 2.3915899658203125e+02 -2.7909100341796875e+02 9.8551998138427734e+00 2.3930500793457031e+02 -2.7909100341796875e+02 8.1383905410766602e+00 2.3886999511718750e+02 -2.7909100341796875e+02 6.6558403968811035e+00 2.3790100097656250e+02 -2.7909100341796875e+02 5.5681796073913574e+00 2.3650300598144531e+02 -2.7909100341796875e+02 4.9932899475097656e+00 2.3482800292968750e+02 -2.7909100341796875e+02 4.9934601783752441e+00 2.3305700683593750e+02 -2.7909100341796875e+02 5.5686798095703125e+00 2.3138200378417969e+02 -2.7909100341796875e+02 6.6566200256347656e+00 2.2998500061035156e+02 -2.7909100341796875e+02 8.1393594741821289e+00 2.2901600646972656e+02 -2.7909100341796875e+02 9.8562498092651367e+00 2.2858099365234375e+02 -2.7909100341796875e+02 1.1621199607849121e+01 2.2872799682617188e+02 -2.7909100341796875e+02 1.3243000030517578e+01 2.2943901062011719e+02 -2.7909100341796875e+02 1.4545899391174316e+01 2.3063899230957031e+02 -2.7909100341796875e+02 8.5236892700195312e+00 2.2847399902343750e+02 -2.7909100341796875e+02 6.9206900596618652e+00 2.2929100036621094e+02 -2.7909100341796875e+02 5.6484899520874023e+00 2.3056300354003906e+02 -2.7909100341796875e+02 4.8316001892089844e+00 2.3216600036621094e+02 -2.7909100341796875e+02 4.5500001907348633e+00 2.3394299316406250e+02 -2.7909100341796875e+02 4.8312497138977051e+00 2.3571899414062500e+02 -2.7909100341796875e+02 5.6478199958801270e+00 2.3732200622558594e+02 -2.7909100341796875e+02 6.9197797775268555e+00 2.3859500122070312e+02 -2.7909100341796875e+02 8.5226097106933594e+00 2.3941198730468750e+02 -2.7909100341796875e+02 1.0299400329589844e+01 2.3969300842285156e+02 -2.7909100341796875e+02 1.2076299667358398e+01 2.3941198730468750e+02 -2.7909100341796875e+02 1.3679300308227539e+01 2.3859500122070312e+02 -2.7909100341796875e+02 1.4951499938964844e+01 2.3732299804687500e+02 -2.7909100341796875e+02 1.5768399238586426e+01 2.3572100830078125e+02 -2.7909100341796875e+02 1.6049999237060547e+01 2.3394400024414062e+02 -2.7909100341796875e+02 1.5768699645996094e+01 2.3216700744628906e+02 -2.7909100341796875e+02 1.4952200889587402e+01 2.3056399536132812e+02 -2.7909100341796875e+02 1.3680199623107910e+01 2.2929200744628906e+02 -2.7909100341796875e+02 1.2077400207519531e+01 2.2847500610351562e+02 -2.7909100341796875e+02 1.0300600051879883e+01 2.2819299316406250e+02 -2.7879101562500000e+02 4.5462899208068848e+00 2.3207299804687500e+02 -2.7879101562500000e+02 5.4057998657226562e+00 2.3038700866699219e+02 -2.7879101562500000e+02 6.7443799972534180e+00 2.2904800415039062e+02 -2.7879101562500000e+02 8.4310102462768555e+00 2.2818901062011719e+02 -2.7879101562500000e+02 1.0300600051879883e+01 2.2789299011230469e+02 -2.7879101562500000e+02 1.2170099258422852e+01 2.2818901062011719e+02 -2.7879101562500000e+02 1.3856599807739258e+01 2.2904899597167969e+02 -2.7879101562500000e+02 1.5194900512695312e+01 2.3038800048828125e+02 -2.7879101562500000e+02 1.6054100036621094e+01 2.3207400512695312e+02 -2.7879101562500000e+02 1.6349998474121094e+01 2.3394400024414062e+02 -2.7879101562500000e+02 1.6053701400756836e+01 2.3581300354003906e+02 -2.7879101562500000e+02 1.5194199562072754e+01 2.3750000000000000e+02 -2.7879101562500000e+02 1.3855599403381348e+01 2.3883799743652344e+02 -2.7879101562500000e+02 1.2168999671936035e+01 2.3969699096679688e+02 -2.7879101562500000e+02 1.0299400329589844e+01 2.3999301147460938e+02 -2.7879101562500000e+02 8.4298801422119141e+00 2.3969699096679688e+02 -2.7879101562500000e+02 6.7434201240539551e+00 2.3883700561523438e+02 -2.7879101562500000e+02 5.4050998687744141e+00 2.3749899291992188e+02 -2.7879101562500000e+02 4.5459198951721191e+00 2.3581199645996094e+02 -2.7879101562500000e+02 4.2500000000000000e+00 2.3394299316406250e+02 -2.7279098510742188e+02 1.6054100036621094e+01 2.3207400512695312e+02 -2.7279098510742188e+02 1.6349998474121094e+01 2.3394400024414062e+02 -2.7279098510742188e+02 1.6053701400756836e+01 2.3581300354003906e+02 -2.7279098510742188e+02 1.5194199562072754e+01 2.3750000000000000e+02 -2.7279098510742188e+02 1.3855599403381348e+01 2.3883799743652344e+02 -2.7279098510742188e+02 1.2168999671936035e+01 2.3969699096679688e+02 -2.7279098510742188e+02 1.0299400329589844e+01 2.3999301147460938e+02 -2.7279098510742188e+02 8.4298801422119141e+00 2.3969699096679688e+02 -2.7279098510742188e+02 6.7434201240539551e+00 2.3883700561523438e+02 -2.7279098510742188e+02 5.4050998687744141e+00 2.3749899291992188e+02 -2.7279098510742188e+02 4.5459198951721191e+00 2.3581199645996094e+02 -2.7279098510742188e+02 4.2500000000000000e+00 2.3394299316406250e+02 -2.7279098510742188e+02 4.5462899208068848e+00 2.3207299804687500e+02 -2.7279098510742188e+02 5.4057998657226562e+00 2.3038700866699219e+02 -2.7279098510742188e+02 6.7443799972534180e+00 2.2904800415039062e+02 -2.7279098510742188e+02 8.4310102462768555e+00 2.2818901062011719e+02 -2.7279098510742188e+02 1.0300600051879883e+01 2.2789299011230469e+02 -2.7279098510742188e+02 1.2170099258422852e+01 2.2818901062011719e+02 -2.7279098510742188e+02 1.3856599807739258e+01 2.2904899597167969e+02 -2.7279098510742188e+02 1.5194900512695312e+01 2.3038800048828125e+02 -2.7249099731445312e+02 1.5768699645996094e+01 2.3216700744628906e+02 -2.7249099731445312e+02 1.4952200889587402e+01 2.3056399536132812e+02 -2.7249099731445312e+02 1.3680199623107910e+01 2.2929200744628906e+02 -2.7249099731445312e+02 1.2077400207519531e+01 2.2847500610351562e+02 -2.7249099731445312e+02 1.0300600051879883e+01 2.2819299316406250e+02 -2.7249099731445312e+02 8.5236892700195312e+00 2.2847399902343750e+02 -2.7249099731445312e+02 6.9206900596618652e+00 2.2929100036621094e+02 -2.7249099731445312e+02 5.6484899520874023e+00 2.3056300354003906e+02 -2.7249099731445312e+02 4.8316001892089844e+00 2.3216600036621094e+02 -2.7249099731445312e+02 4.5500001907348633e+00 2.3394299316406250e+02 -2.7249099731445312e+02 4.8312497138977051e+00 2.3571899414062500e+02 -2.7249099731445312e+02 5.6478199958801270e+00 2.3732200622558594e+02 -2.7249099731445312e+02 6.9197797775268555e+00 2.3859500122070312e+02 -2.7249099731445312e+02 8.5226097106933594e+00 2.3941198730468750e+02 -2.7249099731445312e+02 1.0299400329589844e+01 2.3969300842285156e+02 -2.7249099731445312e+02 1.2076299667358398e+01 2.3941198730468750e+02 -2.7249099731445312e+02 1.3679300308227539e+01 2.3859500122070312e+02 -2.7249099731445312e+02 1.4951499938964844e+01 2.3732299804687500e+02 -2.7249099731445312e+02 1.5768399238586426e+01 2.3572100830078125e+02 -2.7249099731445312e+02 1.6049999237060547e+01 2.3394400024414062e+02 -2.7249099731445312e+02 6.6558403968811035e+00 2.3790100097656250e+02 -2.7249099731445312e+02 5.5681796073913574e+00 2.3650300598144531e+02 -2.7249099731445312e+02 4.9932899475097656e+00 2.3482800292968750e+02 -2.7249099731445312e+02 4.9934601783752441e+00 2.3305700683593750e+02 -2.7249099731445312e+02 5.5686798095703125e+00 2.3138200378417969e+02 -2.7249099731445312e+02 6.6566200256347656e+00 2.2998500061035156e+02 -2.7249099731445312e+02 8.1393594741821289e+00 2.2901600646972656e+02 -2.7249099731445312e+02 9.8562498092651367e+00 2.2858099365234375e+02 -2.7249099731445312e+02 1.1621199607849121e+01 2.2872799682617188e+02 -2.7249099731445312e+02 1.3243000030517578e+01 2.2943901062011719e+02 -2.7249099731445312e+02 1.4545899391174316e+01 2.3063899230957031e+02 -2.7249099731445312e+02 1.5388700485229492e+01 2.3219700622558594e+02 -2.7249099731445312e+02 1.5680000305175781e+01 2.3394400024414062e+02 -2.7249099731445312e+02 1.5388299942016602e+01 2.3569099426269531e+02 -2.7249099731445312e+02 1.4545300483703613e+01 2.3724800109863281e+02 -2.7249099731445312e+02 1.3242100715637207e+01 2.3844699096679688e+02 -2.7249099731445312e+02 1.1620200157165527e+01 2.3915899658203125e+02 -2.7249099731445312e+02 9.8551998138427734e+00 2.3930500793457031e+02 -2.7249099731445312e+02 8.1383905410766602e+00 2.3886999511718750e+02 -2.7099099731445312e+02 1.5388700485229492e+01 2.3219700622558594e+02 -2.7099099731445312e+02 1.5680000305175781e+01 2.3394400024414062e+02 -2.7099099731445312e+02 1.5388299942016602e+01 2.3569099426269531e+02 -2.7099099731445312e+02 1.4545300483703613e+01 2.3724800109863281e+02 -2.7099099731445312e+02 1.3242100715637207e+01 2.3844699096679688e+02 -2.7099099731445312e+02 1.1620200157165527e+01 2.3915899658203125e+02 -2.7099099731445312e+02 9.8551998138427734e+00 2.3930500793457031e+02 -2.7099099731445312e+02 8.1383905410766602e+00 2.3886999511718750e+02 -2.7099099731445312e+02 6.6558403968811035e+00 2.3790100097656250e+02 -2.7099099731445312e+02 5.5681796073913574e+00 2.3650300598144531e+02 -2.7099099731445312e+02 4.9932899475097656e+00 2.3482800292968750e+02 -2.7099099731445312e+02 4.9934601783752441e+00 2.3305700683593750e+02 -2.7099099731445312e+02 5.5686798095703125e+00 2.3138200378417969e+02 -2.7099099731445312e+02 6.6566200256347656e+00 2.2998500061035156e+02 -2.7099099731445312e+02 8.1393594741821289e+00 2.2901600646972656e+02 -2.7099099731445312e+02 9.8562498092651367e+00 2.2858099365234375e+02 -2.7099099731445312e+02 1.1621199607849121e+01 2.2872799682617188e+02 -2.7099099731445312e+02 1.3243000030517578e+01 2.2943901062011719e+02 -2.7099099731445312e+02 1.4545899391174316e+01 2.3063899230957031e+02 -2.7099099731445312e+02 1.0803899765014648e+01 2.2721800231933594e+02 -2.7099099731445312e+02 1.2765500068664551e+01 2.2766600036621094e+02 -2.7099099731445312e+02 1.4507900238037109e+01 2.2867199707031250e+02 -2.7099099731445312e+02 1.5876300811767578e+01 2.3014700317382812e+02 -2.7099099731445312e+02 1.6749198913574219e+01 2.3195999145507812e+02 -2.7099099731445312e+02 1.7048799514770508e+01 2.3394999694824219e+02 -2.7099099731445312e+02 1.6748800277709961e+01 2.3593899536132812e+02 -2.7099099731445312e+02 1.5875599861145020e+01 2.3775199890136719e+02 -2.7099099731445312e+02 1.4506899833679199e+01 2.3922698974609375e+02 -2.7099099731445312e+02 1.2764300346374512e+01 2.4023300170898438e+02 -2.7099099731445312e+02 1.0802599906921387e+01 2.4067999267578125e+02 -2.7099099731445312e+02 1.0298199653625488e+01 2.4069898986816406e+02 -2.7099099731445312e+02 1.0299500465393066e+01 2.2719900512695312e+02 -2.7099099731445312e+02 8.7974691390991211e+00 2.2736799621582031e+02 -2.7099099731445312e+02 6.9244203567504883e+00 2.2810299682617188e+02 -2.7099099731445312e+02 5.3511900901794434e+00 2.2935700988769531e+02 -2.7099099731445312e+02 4.2175903320312500e+00 2.3102000427246094e+02 -2.7099099731445312e+02 3.6243300437927246e+00 2.3294200134277344e+02 -2.7099099731445312e+02 3.6241300106048584e+00 2.3495399475097656e+02 -2.7099099731445312e+02 4.2170100212097168e+00 2.3687699890136719e+02 -2.7099099731445312e+02 5.3502898216247559e+00 2.3853999328613281e+02 -2.7099099731445312e+02 6.9232602119445801e+00 2.3979400634765625e+02 -2.7099099731445312e+02 8.7961797714233398e+00 2.4052900695800781e+02 -2.6715002441406250e+02 1.7495500564575195e+01 2.3040600585937500e+02 -2.6709301757812500e+02 1.7595098495483398e+01 2.3035700988769531e+02 -2.6709301757812500e+02 1.6915500640869141e+01 2.2922100830078125e+02 -2.6782000732421875e+02 1.5351900100708008e+01 2.2891600036621094e+02 -2.6782000732421875e+02 1.6101799011230469e+01 2.2980200195312500e+02 -2.6737698364257812e+02 1.6461801528930664e+01 2.2954499816894531e+02 -2.6826599121093750e+02 1.4335000038146973e+01 2.2834700012207031e+02 -2.6837701416015625e+02 1.4301899909973145e+01 2.2839300537109375e+02 -2.6837701416015625e+02 1.5150600433349609e+01 2.2911599731445312e+02 -2.6899499511718750e+02 1.4244600296020508e+01 2.2847200012207031e+02 -2.6899499511718750e+02 1.4495900154113770e+01 2.2868600463867188e+02 -2.6899499511718750e+02 1.5081199645996094e+01 2.2918499755859375e+02 -2.6837701416015625e+02 1.5870598793029785e+01 2.2996699523925781e+02 -2.6899499511718750e+02 1.5790900230407715e+01 2.3002400207519531e+02 -2.6899499511718750e+02 1.5867499351501465e+01 2.3015199279785156e+02 -2.6759799194335938e+02 1.4597300529479980e+01 2.2798300170898438e+02 -2.6782000732421875e+02 1.4468000411987305e+01 2.2816200256347656e+02 -2.6790698242187500e+02 1.4442100524902344e+01 2.2819801330566406e+02 -2.6826599121093750e+02 1.6493700027465820e+01 2.3089900207519531e+02 -2.6837701416015625e+02 1.6442899703979492e+01 2.3092399597167969e+02 -2.6899499511718750e+02 1.6354999542236328e+01 2.3096800231933594e+02 -2.6790698242187500e+02 1.6658000946044922e+01 2.3081900024414062e+02 -2.6733300781250000e+02 1.4777600288391113e+01 2.2773300170898438e+02 -2.6737698364257812e+02 1.4726699829101562e+01 2.2780300903320312e+02 -2.6737698364257812e+02 1.5665400505065918e+01 2.2860301208496094e+02 -2.6705200195312500e+02 1.5203299522399902e+01 2.2714201354980469e+02 -2.6709301757812500e+02 1.5052599906921387e+01 2.2735099792480469e+02 -2.6709301757812500e+02 1.6060400009155273e+01 2.2821000671386719e+02 -2.6715002441406250e+02 1.4987699508666992e+01 2.2744099426269531e+02 -2.6782000732421875e+02 1.6697900772094727e+01 2.3079901123046875e+02 -2.6759899902343750e+02 1.6896400451660156e+01 2.3070100402832031e+02 -2.6737698364257812e+02 1.7094900131225586e+01 2.3060398864746094e+02 -2.6733300781250000e+02 1.7173000335693359e+01 2.3056500244140625e+02 -2.6699600219726562e+02 1.8149599075317383e+01 2.3008399963378906e+02 -2.6699502563476562e+02 1.7418300628662109e+01 2.2886199951171875e+02 -2.6699502563476562e+02 1.6498298645019531e+01 2.2777398681640625e+02 -2.6699502563476562e+02 1.5413900375366211e+01 2.2684899902343750e+02 -2.6629598999023438e+02 1.8848798751831055e+01 2.3953599548339844e+02 -2.6629598999023438e+02 1.8850000381469727e+01 2.2685000610351562e+02 -2.6653799438476562e+02 1.8805398941040039e+01 2.3974800109863281e+02 -2.6653701782226562e+02 1.8802000045776367e+01 2.2685000610351562e+02 -2.6679098510742188e+02 1.8643600463867188e+01 2.3999600219726562e+02 -2.6656298828125000e+02 1.8796699523925781e+01 2.2685000610351562e+02 -2.6679098510742188e+02 1.8644899368286133e+01 2.2685000610351562e+02 -2.6695199584960938e+02 1.8390899658203125e+01 2.4019000244140625e+02 -2.6694198608398438e+02 1.8417798995971680e+01 2.2685000610351562e+02 -2.6699600219726562e+02 1.8149898529052734e+01 2.2685000610351562e+02 -2.6694802856445312e+02 1.8391300201416016e+01 2.2685000610351562e+02 -2.6699002075195312e+02 1.8239299774169922e+01 2.3088900756835938e+02 -2.6698800659179688e+02 1.8245000839233398e+01 2.3102799987792969e+02 -2.6697900390625000e+02 1.8284099578857422e+01 2.3199099731445312e+02 -2.6695999145507812e+02 1.8363800048828125e+01 2.3394999694824219e+02 -2.6695599365234375e+02 1.8380100250244141e+01 2.3435198974609375e+02 -2.6699600219726562e+02 1.8148599624633789e+01 2.4028300476074219e+02 -2.6697399902343750e+02 1.8276300430297852e+01 2.3590699768066406e+02 -2.6699600219726562e+02 1.8148899078369141e+01 2.3781498718261719e+02 -2.5327900695800781e+02 1.8151401519775391e+01 2.2615000915527344e+02 -2.6629598999023438e+02 1.8150100708007812e+01 2.2615000915527344e+02 -2.6629598999023438e+02 1.8417900085449219e+01 2.2620298767089844e+02 -2.5331800842285156e+02 1.8419200897216797e+01 2.2620298767089844e+02 -2.6629598999023438e+02 1.8645000457763672e+01 2.2635499572753906e+02 -2.5329801940917969e+02 1.8646299362182617e+01 2.2635499572753906e+02 -2.5338000488281250e+02 1.8772899627685547e+01 2.2658999633789062e+02 -2.5326600646972656e+02 1.8734600067138672e+01 2.2646299743652344e+02 -2.6629598999023438e+02 1.8796699523925781e+01 2.2658200073242188e+02 -2.5361499023437500e+02 1.8851200103759766e+01 2.2685000610351562e+02 -2.5124200439453125e+02 1.1968000326305628e-03 2.2973899841308594e+02 -2.5144999694824219e+02 2.2269999980926514e+00 2.2994700622558594e+02 -2.5574899291992188e+02 -8.3066501617431641e+00 2.3424600219726562e+02 -2.6258901977539062e+02 -4.3010401725769043e+00 2.4108599853515625e+02 -2.6162298583984375e+02 -6.0819602012634277e+00 2.4011999511718750e+02 -2.5732299804687500e+02 -8.6000003814697266e+00 2.3581999206542969e+02 -2.6319699096679688e+02 -2.2269999980926514e+00 2.4169400024414062e+02 -2.5205699157714844e+02 4.3010401725769043e+00 2.3055400085449219e+02 -2.5302401733398438e+02 6.0819602012634277e+00 2.3152099609375000e+02 -2.5428399658203125e+02 7.4484200477600098e+00 2.3278099060058594e+02 -2.5575000000000000e+02 8.3072700500488281e+00 2.3424699401855469e+02 -2.6340402221679688e+02 -1.1968000326305628e-03 2.4190199279785156e+02 -2.5428199768066406e+02 -7.4472198486328125e+00 2.3277899169921875e+02 -2.5302299499511719e+02 -6.0802698135375977e+00 2.3152000427246094e+02 -2.6319699096679688e+02 2.2246899604797363e+00 2.4169500732421875e+02 -2.5732400512695312e+02 8.6000003814697266e+00 2.3582099914550781e+02 -2.5889797973632812e+02 8.3066501617431641e+00 2.3739500427246094e+02 -2.6036300659179688e+02 -7.4484200477600098e+00 2.3886000061035156e+02 -2.5889599609375000e+02 -8.3072700500488281e+00 2.3739300537109375e+02 -2.5205699157714844e+02 -4.2989597320556641e+00 2.3055400085449219e+02 -2.5144898986816406e+02 -2.2246899604797363e+00 2.2994599914550781e+02 -2.6036502075195312e+02 7.4472198486328125e+00 2.3886199951171875e+02 -2.6162402343750000e+02 6.0802698135375977e+00 2.4012100219726562e+02 -2.6258999633789062e+02 4.2989597320556641e+00 2.4108700561523438e+02 -2.5330001831054688e+02 -1.8643600463867188e+01 2.2635099792480469e+02 -2.5326898193359375e+02 -1.8732000350952148e+01 2.2645899963378906e+02 -2.5338398742675781e+02 -1.8783399581909180e+01 2.2658300781250000e+02 -2.5361799621582031e+02 -1.8848798751831055e+01 2.2684599304199219e+02 -2.6629199218750000e+02 -1.8850000381469727e+01 2.2684599304199219e+02 -2.5349900817871094e+02 -1.8834798812866211e+01 2.2670700073242188e+02 -2.6629199218750000e+02 -1.8796699523925781e+01 2.2657800292968750e+02 -2.6629199218750000e+02 -1.8644899368286133e+01 2.2635099792480469e+02 -2.6629199218750000e+02 -1.8417798995971680e+01 2.2619900512695312e+02 -2.5332000732421875e+02 -1.8416500091552734e+01 2.2619900512695312e+02 -2.6629199218750000e+02 -1.8149898529052734e+01 2.2614599609375000e+02 -2.5328201293945312e+02 -1.8148700714111328e+01 2.2614599609375000e+02 -2.6719900512695312e+02 1.7638599395751953e+01 2.3125700378417969e+02 -2.6884899902343750e+02 1.7031200408935547e+01 2.3443899536132812e+02 -2.6886401367187500e+02 1.6994598388671875e+01 2.3470700073242188e+02 -2.6825799560546875e+02 1.7095899581909180e+01 2.3474099731445312e+02 -2.6709301757812500e+02 1.7594400405883789e+01 2.3754200744628906e+02 -2.6705300903320312e+02 1.7825700759887695e+01 2.3765599060058594e+02 -2.6707397460937500e+02 1.8035499572753906e+01 2.3583799743652344e+02 -2.6739801025390625e+02 1.7352399826049805e+01 2.3652999877929688e+02 -2.6743099975585938e+02 1.7496601104736328e+01 2.3569200134277344e+02 -2.6768197631835938e+02 1.7272998809814453e+01 2.3562599182128906e+02 -2.6898501586914062e+02 1.6528299331665039e+01 2.3134899902343750e+02 -2.6896499633789062e+02 1.6660099029541016e+01 2.3169499206542969e+02 -2.6828799438476562e+02 1.6762399673461914e+01 2.3162400817871094e+02 -2.6896301269531250e+02 1.6676799774169922e+01 2.3173800659179688e+02 -2.6894500732421875e+02 1.6738800048828125e+01 2.3196299743652344e+02 -2.6827801513671875e+02 1.6969400405883789e+01 2.3237800598144531e+02 -2.6890899658203125e+02 1.6870300292968750e+01 2.3243899536132812e+02 -2.6889898681640625e+02 1.6907300949096680e+01 2.3257299804687500e+02 -2.6825799560546875e+02 1.7096000671386719e+01 2.3315800476074219e+02 -2.6796798706054688e+02 1.7095298767089844e+01 2.3233099365234375e+02 -2.6795700073242188e+02 1.6903299331665039e+01 2.3155699157714844e+02 -2.6723699951171875e+02 1.7854598999023438e+01 2.3394999694824219e+02 -2.6722698974609375e+02 1.7755399703979492e+01 2.3213499450683594e+02 -2.6768698120117188e+02 1.7379999160766602e+01 2.3310400390625000e+02 -2.6739801025390625e+02 1.7352800369262695e+01 2.3136900329589844e+02 -2.6768197631835938e+02 1.7273300170898438e+01 2.3227299499511719e+02 -2.6765499877929688e+02 1.7102998733520508e+01 2.3147100830078125e+02 -2.6737698364257812e+02 1.7094200134277344e+01 2.3729499816894531e+02 -2.6733300781250000e+02 1.7172298431396484e+01 2.3733399963378906e+02 -2.6715002441406250e+02 1.7494798660278320e+01 2.3749299621582031e+02 -2.6768600463867188e+02 1.7416198730468750e+01 2.3394999694824219e+02 -2.6768698120117188e+02 1.7379800796508789e+01 2.3479499816894531e+02 -2.6722698974609375e+02 1.7754999160766602e+01 2.3576399230957031e+02 -2.6899499511718750e+02 1.6354499816894531e+01 2.3693099975585938e+02 -2.6837701416015625e+02 1.6442300796508789e+01 2.3697399902343750e+02 -2.6828799438476562e+02 1.6761999130249023e+01 2.3627500915527344e+02 -2.6826599121093750e+02 1.6493101119995117e+01 2.3699900817871094e+02 -2.6790698242187500e+02 1.6657400131225586e+01 2.3707998657226562e+02 -2.6795700073242188e+02 1.6902898788452148e+01 2.3634100341796875e+02 -2.6765499877929688e+02 1.7102600097656250e+01 2.3642799377441406e+02 -2.6782000732421875e+02 1.6697200775146484e+01 2.3710000610351562e+02 -2.6759899902343750e+02 1.6895700454711914e+01 2.3719799804687500e+02 -2.6894500732421875e+02 1.6737300872802734e+01 2.3593600463867188e+02 -2.6896301269531250e+02 1.6673500061035156e+01 2.3616899108886719e+02 -2.6896499633789062e+02 1.6658800125122070e+01 2.3620399475097656e+02 -2.6827801513671875e+02 1.6969099044799805e+01 2.3552000427246094e+02 -2.6889602661132812e+02 1.6915800094604492e+01 2.3528300476074219e+02 -2.6890899658203125e+02 1.6867698669433594e+01 2.3545899963378906e+02 -2.6886499023437500e+02 1.6992399215698242e+01 2.3319299316406250e+02 -2.6884799194335938e+02 1.7033599853515625e+01 2.3349299621582031e+02 -2.6824899291992188e+02 1.7138599395751953e+01 2.3394900512695312e+02 -2.6884899902343750e+02 1.7032501220703125e+01 2.3394900512695312e+02 -2.6899499511718750e+02 9.2398595809936523e+00 2.4061499023437500e+02 -2.6899499511718750e+02 1.0460799217224121e+01 2.4069699096679688e+02 -2.6899499511718750e+02 1.0800199508666992e+01 2.4065800476074219e+02 -2.6899499511718750e+02 1.1676400184631348e+01 2.4055700683593750e+02 -2.6899499511718750e+02 1.2762299537658691e+01 2.4022500610351562e+02 -2.6899499511718750e+02 1.2846799850463867e+01 2.4019999694824219e+02 -2.6899499511718750e+02 1.3933400154113770e+01 2.3963700866699219e+02 -2.6899499511718750e+02 1.4490400314331055e+01 2.3920500183105469e+02 -2.6899499511718750e+02 1.5859300613403320e+01 2.3774200439453125e+02 -2.6899499511718750e+02 1.5716500282287598e+01 2.3797500610351562e+02 -2.6899499511718750e+02 1.4900599479675293e+01 2.3888699340820312e+02 -2.6888497924804688e+02 1.3299900054931641e+01 2.2791300964355469e+02 -2.6887301635742188e+02 1.3197299957275391e+01 2.2785299682617188e+02 -2.6878198242187500e+02 1.2753399848937988e+01 2.2770201110839844e+02 -2.6869100952148438e+02 1.2312100410461426e+01 2.2755200195312500e+02 -2.6856802368164062e+02 1.1710800170898438e+01 2.2734800720214844e+02 -2.6852999877929688e+02 1.1317199707031250e+01 2.2730599975585938e+02 -2.6848001098632812e+02 1.0800600051879883e+01 2.2725201416015625e+02 -2.6843197631835938e+02 1.0299799919128418e+01 2.2719900512695312e+02 -2.6851498413085938e+02 9.2779102325439453e+00 2.2728698730468750e+02 -2.6852600097656250e+02 9.1404895782470703e+00 2.2729901123046875e+02 -2.6859301757812500e+02 8.8073396682739258e+00 2.2740000915527344e+02 -2.6869601440429688e+02 8.2879199981689453e+00 2.2755700683593750e+02 -2.6891900634765625e+02 6.9427900314331055e+00 2.2813500976562500e+02 -2.6887301635742188e+02 7.3053302764892578e+00 2.2792700195312500e+02 -2.6883898925781250e+02 7.5732102394104004e+00 2.2777398681640625e+02 -2.6899401855468750e+02 6.3545298576354980e+00 2.2847099304199219e+02 -2.6899401855468750e+02 5.4304499626159668e+00 2.2927301025390625e+02 -2.6899401855468750e+02 5.3587799072265625e+00 2.2936299133300781e+02 -2.6899401855468750e+02 4.6663599014282227e+00 2.3022900390625000e+02 -2.6899401855468750e+02 4.2365198135375977e+00 2.3102999877929688e+02 -2.6899401855468750e+02 4.0873899459838867e+00 2.3130700683593750e+02 -2.6899401855468750e+02 3.7125599384307861e+00 2.3247200012207031e+02 -2.6899401855468750e+02 3.6507499217987061e+00 2.3294599914550781e+02 -2.6899401855468750e+02 3.5541801452636719e+00 2.3368499755859375e+02 -2.6899401855468750e+02 3.6174600124359131e+00 2.3490800476074219e+02 -2.6899401855468750e+02 4.2390899658203125e+00 2.3686698913574219e+02 -2.6899401855468750e+02 3.9003200531005859e+00 2.3609800720214844e+02 -2.6899401855468750e+02 3.6283299922943115e+00 2.3495300292968750e+02 -2.6899401855468750e+02 4.3934602737426758e+00 2.3721800231933594e+02 -2.6899401855468750e+02 5.0806899070739746e+00 2.3823001098632812e+02 -2.6899401855468750e+02 6.9245200157165527e+00 2.3979299926757812e+02 -2.6899401855468750e+02 5.9394102096557617e+00 2.3910200500488281e+02 -2.6899401855468750e+02 5.3681201934814453e+00 2.3852198791503906e+02 -2.6899401855468750e+02 6.9414000511169434e+00 2.3980499267578125e+02 -2.6899499511718750e+02 8.0537300109863281e+00 2.4031401062011719e+02 -2.6899499511718750e+02 8.8027296066284180e+00 2.4050399780273438e+02 -2.6568600463867188e+02 1.8848899841308594e+01 2.3901300048828125e+02 -2.5966500854492188e+02 1.8850000381469727e+01 2.3348300170898438e+02 -2.5891500854492188e+02 1.8850099563598633e+01 2.3270899963378906e+02 -2.5758099365234375e+02 1.8850399017333984e+01 2.3133399963378906e+02 -2.5737301635742188e+02 1.8850500106811523e+01 2.3110400390625000e+02 -2.5580599975585938e+02 1.8850799560546875e+01 2.2938800048828125e+02 -2.5556401062011719e+02 1.8850799560546875e+01 2.2912199401855469e+02 -2.5416699218750000e+02 1.8851099014282227e+01 2.2749299621582031e+02 -2.6402398681640625e+02 1.8849199295043945e+01 2.3758601379394531e+02 -2.6379098510742188e+02 1.8849199295043945e+01 2.3737300109863281e+02 -2.6207598876953125e+02 1.8849498748779297e+01 2.3580700683593750e+02 -2.6181399536132812e+02 1.8849599838256836e+01 2.3556800842285156e+02 -2.6047097778320312e+02 1.8849800109863281e+01 2.3426499938964844e+02 -2.6699502563476562e+02 1.7321899414062500e+01 2.3916799926757812e+02 -2.6699502563476562e+02 1.7502199172973633e+01 2.4042601013183594e+02 -2.6699502563476562e+02 1.6264200210571289e+01 2.4035101318359375e+02 -2.6699502563476562e+02 1.5716099739074707e+01 2.4082099914550781e+02 -2.6706698608398438e+02 6.5527496337890625e+00 2.2691899108886719e+02 -2.6696301269531250e+02 6.4089899063110352e+00 2.2666799926757812e+02 -2.6699398803710938e+02 5.1859798431396484e+00 2.2684800720214844e+02 -2.6742300415039062e+02 1.3757499694824219e+01 2.2739799499511719e+02 -2.6741702270507812e+02 1.2657600402832031e+01 2.2712100219726562e+02 -2.6764498901367188e+02 1.2573100090026855e+01 2.2727101135253906e+02 -2.6721899414062500e+02 6.6998000144958496e+00 2.2716900634765625e+02 -2.6721600341796875e+02 7.8527603149414062e+00 2.2694200134277344e+02 -2.6826400756835938e+02 7.1817102432250977e+00 2.2784599304199219e+02 -2.6815701293945312e+02 8.1710205078125000e+00 2.2746400451660156e+02 -2.6803698730468750e+02 9.2185401916503906e+00 2.2722799682617188e+02 -2.6789401245117188e+02 8.1033401489257812e+00 2.2738600158691406e+02 -2.6795599365234375e+02 7.0887503623962402e+00 2.2774299621582031e+02 -2.6781900024414062e+02 6.1314301490783691e+00 2.2816101074218750e+02 -2.6790600585937500e+02 6.1573495864868164e+00 2.2819699096679688e+02 -2.6826501464843750e+02 6.2643399238586426e+00 2.2834600830078125e+02 -2.6837600708007812e+02 6.2973899841308594e+00 2.2839199829101562e+02 -2.6764398193359375e+02 8.0261898040771484e+00 2.2727000427246094e+02 -2.6742300415039062e+02 6.8424696922302246e+00 2.2739698791503906e+02 -2.6767199707031250e+02 6.9741501808166504e+00 2.2759201049804688e+02 -2.6737600708007812e+02 5.8729100227355957e+00 2.2780198669433594e+02 -2.6759799194335938e+02 6.0021700859069824e+00 2.2798199462890625e+02 -2.6695300292968750e+02 6.7964696884155273e+00 2.2661100769042969e+02 -2.6718099975585938e+02 9.0602407455444336e+00 2.2679499816894531e+02 -2.6688000488281250e+02 8.5852203369140625e+00 2.2646499633789062e+02 -2.6691699218750000e+02 7.6732301712036133e+00 2.2653900146484375e+02 -2.6695098876953125e+02 6.8495302200317383e+00 2.2660600280761719e+02 -2.6722000122070312e+02 1.3900100708007812e+01 2.2716999816894531e+02 -2.6706799316406250e+02 1.4047100067138672e+01 2.2691899108886719e+02 -2.6697799682617188e+02 1.4461800575256348e+01 2.2669599914550781e+02 -2.6696701049804688e+02 1.4191299438476562e+01 2.2666799926757812e+02 -2.6721701049804688e+02 1.2746600151062012e+01 2.2694300842285156e+02 -2.6691601562500000e+02 1.2926200866699219e+01 2.2653700256347656e+02 -2.6689999389648438e+02 1.2531599998474121e+01 2.2649600219726562e+02 -2.6718099975585938e+02 1.1538900375366211e+01 2.2679499816894531e+02 -2.6694400024414062e+02 1.3631200790405273e+01 2.2661000061035156e+02 -2.6758099365234375e+02 9.1445398330688477e+00 2.2706500244140625e+02 -2.6716198730468750e+02 1.0299599647521973e+01 2.2674400329589844e+02 -2.6754998779296875e+02 1.0299500465393066e+01 2.2699398803710938e+02 -2.6758099365234375e+02 1.1454500198364258e+01 2.2706500244140625e+02 -2.6826501464843750e+02 1.3417799949645996e+01 2.2784700012207031e+02 -2.6795700073242188e+02 1.3511000633239746e+01 2.2774400329589844e+02 -2.6767199707031250e+02 1.3625699996948242e+01 2.2759300231933594e+02 -2.6815701293945312e+02 1.2428199768066406e+01 2.2746499633789062e+02 -2.6803698730468750e+02 1.1380399703979492e+01 2.2722900390625000e+02 -2.6798498535156250e+02 1.0299500465393066e+01 2.2714799499511719e+02 -2.6705102539062500e+02 5.3964500427246094e+00 2.2714099121093750e+02 -2.6709197998046875e+02 5.5471301078796387e+00 2.2734999084472656e+02 -2.6714898681640625e+02 5.6119999885559082e+00 2.2744000244140625e+02 -2.6733200073242188e+02 5.8220400810241699e+00 2.2773200988769531e+02 -2.6687698364257812e+02 1.1625100135803223e+01 2.2646200561523438e+02 -2.6685000610351562e+02 1.0557199478149414e+01 2.2642199707031250e+02 -2.6685397338867188e+02 1.0299799919128418e+01 2.2642800903320312e+02 -2.6687399291992188e+02 8.9736299514770508e+00 2.2645700073242188e+02 -2.6653701782226562e+02 1.8149999618530273e+01 2.2619799804687500e+02 -2.6656298828125000e+02 1.8149999618530273e+01 2.2620298767089844e+02 -2.6654299926757812e+02 1.8417900085449219e+01 2.2625199890136719e+02 -2.6648501586914062e+02 1.8796699523925781e+01 2.2666000366210938e+02 -2.6639801025390625e+02 1.8796699523925781e+01 2.2660200500488281e+02 -2.6648501586914062e+02 1.8645000457763672e+01 2.2639199829101562e+02 -2.6654299926757812e+02 1.8796699523925781e+01 2.2674700927734375e+02 -2.6675299072265625e+02 1.8644899368286133e+01 2.2666000366210938e+02 -2.6664599609375000e+02 1.8645000457763672e+01 2.2650000000000000e+02 -2.6689300537109375e+02 1.8417798995971680e+01 2.2660200500488281e+02 -2.6675299072265625e+02 1.8417900085449219e+01 2.2639199829101562e+02 -2.6694802856445312e+02 1.8149999618530273e+01 2.2660798645019531e+02 -2.6679098510742188e+02 1.8149999618530273e+01 2.2635499572753906e+02 -2.6694198608398438e+02 1.8149999618530273e+01 2.2658200073242188e+02 -2.5217900085449219e+02 -1.2680500030517578e+01 2.2614700317382812e+02 -2.5217700195312500e+02 1.2683000564575195e+01 2.2614898681640625e+02 -2.5140100097656250e+02 6.3632402420043945e+00 2.2614799499511719e+02 -2.5114100646972656e+02 1.1930400505661964e-03 2.2614799499511719e+02 -2.5140100097656250e+02 -6.3608198165893555e+00 2.2614700317382812e+02 -2.6653298950195312e+02 -1.8149999618530273e+01 2.2619400024414062e+02 -2.6653900146484375e+02 -1.8253099441528320e+01 2.2619900512695312e+02 -2.6652801513671875e+02 -1.8803798675537109e+01 2.2684599304199219e+02 -2.6655502319335938e+02 -1.8798601150512695e+01 2.2684599304199219e+02 -2.6653500366210938e+02 -1.8749198913574219e+01 2.2657800292968750e+02 -2.6639300537109375e+02 -1.8398199081420898e+01 2.2619900512695312e+02 -2.6647799682617188e+02 -1.8608600616455078e+01 2.2635099792480469e+02 -2.6655999755859375e+02 -1.8149999618530273e+01 2.2619900512695312e+02 -2.6674899291992188e+02 -1.8340499877929688e+01 2.2635099792480469e+02 -2.6678698730468750e+02 -1.8149999618530273e+01 2.2635099792480469e+02 -2.6688900756835938e+02 -1.8398899078369141e+01 2.2657800292968750e+02 -2.6693902587890625e+02 -1.8149999618530273e+01 2.2657800292968750e+02 -2.6693798828125000e+02 -1.8419500350952148e+01 2.2684599304199219e+02 -2.6694299316406250e+02 -1.8392799377441406e+01 2.2684599304199219e+02 -2.6699200439453125e+02 -1.8150100708007812e+01 2.2684599304199219e+02 -2.6694400024414062e+02 -1.8149999618530273e+01 2.2660499572753906e+02 -2.6648001098632812e+02 -1.8340301513671875e+01 2.2619900512695312e+02 -2.6664001464843750e+02 -1.8501600265502930e+01 2.2635099792480469e+02 -2.6674700927734375e+02 -1.8609498977661133e+01 2.2657800292968750e+02 -2.6678500366210938e+02 -1.8647399902343750e+01 2.2684599304199219e+02 -2.6457101440429688e+02 -1.9639900922775269e+00 2.4039700317382812e+02 -2.6452197265625000e+02 -2.2229900360107422e+00 2.4034799194335938e+02 -2.6409597778320312e+02 -3.8379900455474854e+00 2.3992100524902344e+02 -2.6392199707031250e+02 -4.2985100746154785e+00 2.3974700927734375e+02 -2.5877999877929688e+02 -8.5983600616455078e+00 2.3460101318359375e+02 -2.5866101074218750e+02 -8.5915193557739258e+00 2.3448200988769531e+02 -2.5732601928710938e+02 -8.3899698257446289e+00 2.3314698791503906e+02 -2.5708898925781250e+02 -8.2972698211669922e+00 2.3290899658203125e+02 -2.5356900024414062e+02 -4.7001700401306152e+00 2.2938899230957031e+02 -2.5340499877929688e+02 -4.2913498878479004e+00 2.2922399902343750e+02 -2.5693701171875000e+02 8.2320194244384766e+00 2.3276100158691406e+02 -2.5708898925781250e+02 8.2980194091796875e+00 2.3291300964355469e+02 -2.6290802001953125e+02 6.1517200469970703e+00 2.3873400878906250e+02 -2.6295599365234375e+02 6.0765500068664551e+00 2.3878300476074219e+02 -2.6469400024414062e+02 1.0494899749755859e+00 2.4052099609375000e+02 -2.6457199096679688e+02 1.9886500835418701e+00 2.4039801025390625e+02 -2.6456201171875000e+02 2.0640499591827393e+00 2.4038800048828125e+02 -2.6452899169921875e+02 2.2228600978851318e+00 2.4035499572753906e+02 -2.6469601440429688e+02 1.0073601007461548e+00 2.4052200317382812e+02 -2.6473999023437500e+02 1.1914599686861038e-02 2.4056599426269531e+02 -2.6473999023437500e+02 -1.1968000326305628e-03 2.4056599426269531e+02 -2.6391598510742188e+02 4.2913002967834473e+00 2.3974198913574219e+02 -2.6409100341796875e+02 3.8585200309753418e+00 2.3991799926757812e+02 -2.6410800170898438e+02 3.8157000541687012e+00 2.3993499755859375e+02 -2.6436901855468750e+02 2.9425199031829834e+00 2.4019500732421875e+02 -2.6439398193359375e+02 2.8578898906707764e+00 2.4022099304199219e+02 -2.6331500244140625e+02 5.5173797607421875e+00 2.3914100646972656e+02 -2.6340197753906250e+02 5.3816599845886230e+00 2.3922799682617188e+02 -2.6374600219726562e+02 4.7111401557922363e+00 2.3957299804687500e+02 -2.6187500000000000e+02 7.2986798286437988e+00 2.3770100402832031e+02 -2.6170401000976562e+02 7.4298496246337891e+00 2.3752999877929688e+02 -2.6169601440429688e+02 7.4361400604248047e+00 2.3752200317382812e+02 -2.6229501342773438e+02 6.8876099586486816e+00 2.3812100219726562e+02 -2.6235699462890625e+02 6.8270897865295410e+00 2.3818301391601562e+02 -2.6283300781250000e+02 6.2438597679138184e+00 2.3865899658203125e+02 -2.6023199462890625e+02 8.2971801757812500e+00 2.3605699157714844e+02 -2.6041497802734375e+02 8.2261199951171875e+00 2.3624000549316406e+02 -2.6055099487304688e+02 8.1733293533325195e+00 2.3637600708007812e+02 -2.6107598876953125e+02 7.8798503875732422e+00 2.3690199279785156e+02 -2.6122900390625000e+02 7.7941799163818359e+00 2.3705500793457031e+02 -2.5902899169921875e+02 8.5706596374511719e+00 2.3485400390625000e+02 -2.5926000976562500e+02 8.5579099655151367e+00 2.3508499145507812e+02 -2.5972900390625000e+02 8.4513902664184570e+00 2.3555400085449219e+02 -2.5998602294921875e+02 8.3928394317626953e+00 2.3581098937988281e+02 -2.5832400512695312e+02 8.5777292251586914e+00 2.3414898681640625e+02 -2.5853198242187500e+02 8.5980901718139648e+00 2.3435600280761719e+02 -2.5866000366210938e+02 8.5909996032714844e+00 2.3448500061035156e+02 -2.5722399902343750e+02 8.3567895889282227e+00 2.3304800415039062e+02 -2.5762399291992188e+02 8.4585103988647461e+00 2.3344799804687500e+02 -2.5794699096679688e+02 8.5407695770263672e+00 2.3377198791503906e+02 -2.5534901428222656e+02 7.2135200500488281e+00 2.3117199707031250e+02 -2.5562599182128906e+02 7.4349899291992188e+00 2.3144898986816406e+02 -2.5564199829101562e+02 7.4479498863220215e+00 2.3146499633789062e+02 -2.5598898315429688e+02 7.7257900238037109e+00 2.3181199645996094e+02 -2.5627200317382812e+02 7.8983001708984375e+00 2.3209600830078125e+02 -2.5652700805664062e+02 8.0534896850585938e+00 2.3235000610351562e+02 -2.5450599670410156e+02 6.2666897773742676e+00 2.3032798767089844e+02 -2.5476300048828125e+02 6.6009097099304199e+00 2.3058499145507812e+02 -2.5505097961425781e+02 6.9020895957946777e+00 2.3087400817871094e+02 -2.5339799499511719e+02 4.2987198829650879e+00 2.2922000122070312e+02 -2.5343798828125000e+02 4.4041299819946289e+00 2.2925900268554688e+02 -2.5359898376464844e+02 4.7380800247192383e+00 2.2942001342773438e+02 -2.5384799194335938e+02 5.2569699287414551e+00 2.2966999816894531e+02 -2.5402200317382812e+02 5.5382599830627441e+00 2.2984400939941406e+02 -2.5433200073242188e+02 6.0397801399230957e+00 2.3015399169921875e+02 -2.5436300659179688e+02 6.0800099372863770e+00 2.3018499755859375e+02 -2.5279798889160156e+02 2.2230198383331299e+00 2.2861898803710938e+02 -2.5288998413085938e+02 2.7077400684356689e+00 2.2871099853515625e+02 -2.5295999145507812e+02 2.9569201469421387e+00 2.2878100585937500e+02 -2.5316300964355469e+02 3.6728401184082031e+00 2.2898399353027344e+02 -2.5323899841308594e+02 3.8765699863433838e+00 2.2906098937988281e+02 -2.5258099365234375e+02 1.1968000326305628e-03 2.2840100097656250e+02 -2.5258099365234375e+02 1.4308199286460876e-02 2.2840100097656250e+02 -2.5261300659179688e+02 8.9181196689605713e-01 2.2843399047851562e+02 -2.5262698364257812e+02 1.0143799781799316e+00 2.2844700622558594e+02 -2.5270199584960938e+02 1.7108199596405029e+00 2.2852299499511719e+02 -2.5275599670410156e+02 1.9987200498580933e+00 2.2857699584960938e+02 -2.5292300415039062e+02 -2.8455200195312500e+00 2.2874299621582031e+02 -2.5279200744628906e+02 -2.2227602005004883e+00 2.2861199951171875e+02 -2.5275599670410156e+02 -2.0513198375701904e+00 2.2857600402832031e+02 -2.5274598693847656e+02 -1.9740499258041382e+00 2.2856600952148438e+02 -2.5262498474121094e+02 -1.0364700555801392e+00 2.2844499206542969e+02 -2.5262298583984375e+02 -9.8673105239868164e-01 2.2844299316406250e+02 -2.5322898864746094e+02 -3.8556101322174072e+00 2.2904899597167969e+02 -2.5320800781250000e+02 -3.8039400577545166e+00 2.2902799987792969e+02 -2.5295001220703125e+02 -2.9339599609375000e+00 2.2877000427246094e+02 -2.5400999450683594e+02 -5.5239000320434570e+00 2.2983000183105469e+02 -2.5391297912597656e+02 -5.3714203834533691e+00 2.2973300170898438e+02 -2.5358200073242188e+02 -4.7252602577209473e+00 2.2940200805664062e+02 -2.5543800354003906e+02 -7.2917399406433105e+00 2.3125801086425781e+02 -2.5503799438476562e+02 -6.8991799354553223e+00 2.3085800170898438e+02 -2.5495600891113281e+02 -6.8191099166870117e+00 2.3077699279785156e+02 -2.5449600219726562e+02 -6.2533903121948242e+00 2.3031599426269531e+02 -2.5440600585937500e+02 -6.1425499916076660e+00 2.3022599792480469e+02 -2.5436401367187500e+02 -6.0769901275634766e+00 2.3018400573730469e+02 -2.5608300781250000e+02 -7.7886300086975098e+00 2.3190400695800781e+02 -2.5563299560546875e+02 -7.4421496391296387e+00 2.3145300292968750e+02 -2.5562501525878906e+02 -7.4358401298522949e+00 2.3144499206542969e+02 -2.5692999267578125e+02 -8.2354602813720703e+00 2.3275099182128906e+02 -2.5676101684570312e+02 -8.1692399978637695e+00 2.3258200073242188e+02 -2.5626599121093750e+02 -7.8910894393920898e+00 2.3208599853515625e+02 -2.5832302856445312e+02 -8.5721693038940430e+00 2.3414399719238281e+02 -2.5805099487304688e+02 -8.5565996170043945e+00 2.3387199401855469e+02 -2.5761999511718750e+02 -8.4576501846313477e+00 2.3344099426269531e+02 -2.6023199462890625e+02 -8.2975702285766602e+00 2.3605400085449219e+02 -2.6008798217773438e+02 -8.3598804473876953e+00 2.3591000366210938e+02 -2.5973098754882812e+02 -8.4497499465942383e+00 2.3555299377441406e+02 -2.5936401367187500e+02 -8.5422897338867188e+00 2.3518598937988281e+02 -2.5903002929687500e+02 -8.5743703842163086e+00 2.3485200500488281e+02 -2.6171099853515625e+02 -7.4221501350402832e+00 2.3753399658203125e+02 -2.6169500732421875e+02 -7.4350800514221191e+00 2.3751799011230469e+02 -2.6132299804687500e+02 -7.7315402030944824e+00 2.3714601135253906e+02 -2.6108300781250000e+02 -7.8776702880859375e+00 2.3690499877929688e+02 -2.6078500366210938e+02 -8.0580806732177734e+00 2.3660800170898438e+02 -2.6041799926757812e+02 -8.2169103622436523e+00 2.3624099731445312e+02 -2.6284097290039062e+02 -6.2321701049804688e+00 2.3866499328613281e+02 -2.6255099487304688e+02 -6.6093101501464844e+00 2.3837500000000000e+02 -2.6229901123046875e+02 -6.8711299896240234e+00 2.3812300109863281e+02 -2.6196301269531250e+02 -7.2206501960754395e+00 2.3778698730468750e+02 -2.6332199096679688e+02 -5.5012497901916504e+00 2.3914599609375000e+02 -2.6298202514648438e+02 -6.0491099357604980e+00 2.3880599975585938e+02 -2.6295797729492188e+02 -6.0804100036621094e+00 2.3878199768066406e+02 -2.6387799072265625e+02 -4.4153900146484375e+00 2.3970300292968750e+02 -2.6374099731445312e+02 -4.6993699073791504e+00 2.3956500244140625e+02 -2.6346701049804688e+02 -5.2673401832580566e+00 2.3929100036621094e+02 -2.6442797851562500e+02 -2.7201800346374512e+00 2.4025300598144531e+02 -2.6437100219726562e+02 -2.9197299480438232e+00 2.4019700622558594e+02 -2.6415399169921875e+02 -3.6846899986267090e+00 2.3997900390625000e+02 -2.6470599365234375e+02 -9.0485197305679321e-01 2.4053199768066406e+02 -2.6469799804687500e+02 -9.8349004983901978e-01 2.4052398681640625e+02 -2.6461700439453125e+02 -1.7236700057983398e+00 2.4044198608398438e+02 -2.6569598388671875e+02 -1.8851099014282227e+01 2.3901200866699219e+02 -2.6629199218750000e+02 -1.8851200103759766e+01 2.3952600097656250e+02 -2.5579899597167969e+02 -1.8849199295043945e+01 2.2936599731445312e+02 -2.5621701049804688e+02 -1.8849300384521484e+01 2.2984600830078125e+02 -2.5736999511718750e+02 -1.8849498748779297e+01 2.3107800292968750e+02 -2.5860198974609375e+02 -1.8849800109863281e+01 2.3239498901367188e+02 -2.5891198730468750e+02 -1.8849800109863281e+01 2.3270399475097656e+02 -2.6047302246093750e+02 -1.8850200653076172e+01 2.3425799560546875e+02 -2.6107598876953125e+02 -1.8850299835205078e+01 2.3485900878906250e+02 -2.6209197998046875e+02 -1.8850500106811523e+01 2.3580200195312500e+02 -2.5392300415039062e+02 -1.8848798751831055e+01 2.2721099853515625e+02 -2.5416201782226562e+02 -1.8848899841308594e+01 2.2748500061035156e+02 -2.6363998413085938e+02 -1.8850799560546875e+01 2.3723699951171875e+02 -2.6379498291015625e+02 -1.8850799560546875e+01 2.3736999511718750e+02 -2.5099000549316406e+02 1.4655599370598793e-02 2.2646099853515625e+02 -2.5099000549316406e+02 1.1510300682857633e-03 2.2646099853515625e+02 -2.5294798278808594e+02 1.7184900283813477e+01 2.2646299743652344e+02 -2.5227900695800781e+02 1.3929699897766113e+01 2.2646200561523438e+02 -2.5215699768066406e+02 1.3335800170898438e+01 2.2646200561523438e+02 -2.5202900695800781e+02 1.2707499504089355e+01 2.2646200561523438e+02 -2.5294500732421875e+02 -1.7159299850463867e+01 2.2645899963378906e+02 -2.5231701660156250e+02 -1.4102299690246582e+01 2.2645899963378906e+02 -2.5227600097656250e+02 -1.3900199890136719e+01 2.2645899963378906e+02 -2.5202998352050781e+02 -1.2704999923706055e+01 2.2645999145507812e+02 -2.5186601257324219e+02 1.1386099815368652e+01 2.2646200561523438e+02 -2.5160598754882812e+02 9.2671995162963867e+00 2.2646200561523438e+02 -2.5136000061035156e+02 7.2664504051208496e+00 2.2646200561523438e+02 -2.5126200866699219e+02 6.4717402458190918e+00 2.2646099853515625e+02 -2.5125000000000000e+02 6.3755097389221191e+00 2.2646099853515625e+02 -2.5121900939941406e+02 5.6070098876953125e+00 2.2646099853515625e+02 -2.5115901184082031e+02 4.1533098220825195e+00 2.2646099853515625e+02 -2.5110098266601562e+02 2.7224600315093994e+00 2.2646099853515625e+02 -2.5104400634765625e+02 1.3362100124359131e+00 2.2646099853515625e+02 -2.5115998840332031e+02 -4.1363997459411621e+00 2.2645999145507812e+02 -2.5110098266601562e+02 -2.7019901275634766e+00 2.2646099853515625e+02 -2.5104400634765625e+02 -1.3095999956130981e+00 2.2646099853515625e+02 -2.5121900939941406e+02 -5.5867199897766113e+00 2.2645999145507812e+02 -2.5125100708007812e+02 -6.3731698989868164e+00 2.2645999145507812e+02 -2.5131898498535156e+02 -6.9270401000976562e+00 2.2645999145507812e+02 -2.5135800170898438e+02 -7.2425398826599121e+00 2.2645999145507812e+02 -2.5160598754882812e+02 -9.2541904449462891e+00 2.2645999145507812e+02 -2.5186601257324219e+02 -1.1370200157165527e+01 2.2645999145507812e+02 -2.6699398803710938e+02 3.9881002902984619e+00 2.2788800048828125e+02 -2.6709197998046875e+02 4.4338603019714355e+00 2.2831599426269531e+02 -2.6737600708007812e+02 4.8359699249267578e+00 2.2870199584960938e+02 -2.6781900024414062e+02 5.1550598144531250e+00 2.2900900268554688e+02 -2.6837701416015625e+02 1.5795199394226074e+01 2.3803399658203125e+02 -2.6719702148437500e+02 1.1808499336242676e+01 2.4167799377441406e+02 -2.6719299316406250e+02 1.1906599998474121e+01 2.4166000366210938e+02 -2.6737698364257812e+02 1.1844799995422363e+01 2.4136399841308594e+02 -2.6709301757812500e+02 1.5842899322509766e+01 2.3989799499511719e+02 -2.6709301757812500e+02 1.4677599906921387e+01 2.4080101013183594e+02 -2.6709899902343750e+02 1.3739299774169922e+01 2.4127799987792969e+02 -2.6706201171875000e+02 1.4293299674987793e+01 2.4115100097656250e+02 -2.6705999755859375e+02 1.4326399803161621e+01 2.4114399719238281e+02 -2.6703598022460938e+02 1.4832699775695801e+01 2.4102600097656250e+02 -2.6737698364257812e+02 1.4377400398254395e+01 2.4033200073242188e+02 -2.6737698364257812e+02 1.3158100128173828e+01 2.4096299743652344e+02 -2.6712600708007812e+02 1.3331199645996094e+01 2.4137100219726562e+02 -2.6715402221679688e+02 1.2913200378417969e+01 2.4146600341796875e+02 -2.6716598510742188e+02 1.2741399765014648e+01 2.4150599670410156e+02 -2.6709899902343750e+02 9.1448602676391602e+00 2.4195300292968750e+02 -2.6711898803710938e+02 9.4552297592163086e+00 2.4193099975585938e+02 -2.6737698364257812e+02 9.1106500625610352e+00 2.4142900085449219e+02 -2.6717599487304688e+02 1.0365400314331055e+01 2.4186700439453125e+02 -2.6737698364257812e+02 1.0480700492858887e+01 2.4152099609375000e+02 -2.6717800903320312e+02 1.0487499237060547e+01 2.4185099792480469e+02 -2.6719601440429688e+02 1.1779399871826172e+01 2.4168099975585938e+02 -2.6709100341796875e+02 9.0164194107055664e+00 2.4196200561523438e+02 -2.6709197998046875e+02 7.5942301750183105e+00 2.4161801147460938e+02 -2.6705999755859375e+02 8.5218296051025391e+00 2.4199700927734375e+02 -2.6701000976562500e+02 7.4262399673461914e+00 2.4206700134277344e+02 -2.6709197998046875e+02 6.2541599273681641e+00 2.4100300598144531e+02 -2.6699398803710938e+02 7.0878596305847168e+00 2.4208799743652344e+02 -2.6700900268554688e+02 7.4152998924255371e+00 2.4206799316406250e+02 -2.6837701416015625e+02 1.4967399597167969e+01 2.3895899963378906e+02 -2.6837701416015625e+02 1.2883800506591797e+01 2.4029000854492188e+02 -2.6837701416015625e+02 1.3986100196838379e+01 2.3971900939941406e+02 -2.6837701416015625e+02 1.1696399688720703e+01 2.4065299987792969e+02 -2.6837701416015625e+02 1.0463199615478516e+01 2.4079499816894531e+02 -2.6837701416015625e+02 9.2245597839355469e+00 2.4071200561523438e+02 -2.6837701416015625e+02 8.0212297439575195e+00 2.4040699768066406e+02 -2.6837600708007812e+02 6.8927702903747559e+00 2.3988899230957031e+02 -2.6837600708007812e+02 5.8762502670288086e+00 2.3917700195312500e+02 -2.6837600708007812e+02 5.0050702095031738e+00 2.3829199218750000e+02 -2.6837600708007812e+02 4.3078799247741699e+00 2.3726499938964844e+02 -2.6837600708007812e+02 3.8075900077819824e+00 2.3612899780273438e+02 -2.6837600708007812e+02 3.5206201076507568e+00 2.3492098999023438e+02 -2.6837600708007812e+02 3.4564199447631836e+00 2.3368200683593750e+02 -2.6837600708007812e+02 3.6171000003814697e+00 2.3245100402832031e+02 -2.6837600708007812e+02 3.9973702430725098e+00 2.3126899719238281e+02 -2.6837600708007812e+02 4.5847396850585938e+00 2.3017500305175781e+02 -2.6837600708007812e+02 5.3598999977111816e+00 2.2920599365234375e+02 -2.6782000732421875e+02 1.6023199081420898e+01 2.3820300292968750e+02 -2.6781900024414062e+02 4.3477401733398438e+00 2.3001899719238281e+02 -2.6781900024414062e+02 3.7360100746154785e+00 2.3115800476074219e+02 -2.6781900024414062e+02 3.3399600982666016e+00 2.3238900756835938e+02 -2.6781799316406250e+02 3.1726200580596924e+00 2.3367098999023438e+02 -2.6781900024414062e+02 3.2394800186157227e+00 2.3496200561523438e+02 -2.6781900024414062e+02 3.5383501052856445e+00 2.3622000122070312e+02 -2.6781900024414062e+02 4.0594000816345215e+00 2.3740299987792969e+02 -2.6781900024414062e+02 4.7855095863342285e+00 2.3847299194335938e+02 -2.6781900024414062e+02 5.6928200721740723e+00 2.3939399719238281e+02 -2.6781900024414062e+02 6.7515096664428711e+00 2.4013600158691406e+02 -2.6781900024414062e+02 7.9267902374267578e+00 2.4067500305175781e+02 -2.6781900024414062e+02 9.1800403594970703e+00 2.4099198913574219e+02 -2.6781900024414062e+02 1.0470099449157715e+01 2.4107901000976562e+02 -2.6781900024414062e+02 1.1754499435424805e+01 2.4093099975585938e+02 -2.6781900024414062e+02 1.2991000175476074e+01 2.4055300903320312e+02 -2.6782000732421875e+02 1.4139199256896973e+01 2.3995899963378906e+02 -2.6737698364257812e+02 1.6378400802612305e+01 2.3846699523925781e+02 -2.6737600708007812e+02 3.9785602092742920e+00 2.2977499389648438e+02 -2.6737600708007812e+02 3.3288700580596924e+00 2.3098500061035156e+02 -2.6737600708007812e+02 2.9082601070404053e+00 2.3229199218750000e+02 -2.6737600708007812e+02 2.7305300235748291e+00 2.3365299987792969e+02 -2.6737600708007812e+02 2.8015401363372803e+00 2.3502500915527344e+02 -2.6737600708007812e+02 3.1189498901367188e+00 2.3636099243164062e+02 -2.6737600708007812e+02 3.6723299026489258e+00 2.3761700439453125e+02 -2.6737600708007812e+02 4.4434900283813477e+00 2.3875300598144531e+02 -2.6737600708007812e+02 5.4070897102355957e+00 2.3973199462890625e+02 -2.6737600708007812e+02 6.5314602851867676e+00 2.4052000427246094e+02 -2.6737600708007812e+02 7.7796602249145508e+00 2.4109199523925781e+02 -2.6709301757812500e+02 1.6825899124145508e+01 2.3880000305175781e+02 -2.6737698364257812e+02 1.5462699890136719e+01 2.3949000549316406e+02 -2.6782000732421875e+02 1.5161099433898926e+01 2.3916700744628906e+02 -2.6709197998046875e+02 3.5133399963378906e+00 2.2946800231933594e+02 -2.6709197998046875e+02 2.8158299922943115e+00 2.3076599121093750e+02 -2.6709197998046875e+02 2.3642599582672119e+00 2.3216999816894531e+02 -2.6709197998046875e+02 2.1734499931335449e+00 2.3363200378417969e+02 -2.6709197998046875e+02 2.2496900558471680e+00 2.3510398864746094e+02 -2.6709197998046875e+02 2.5904600620269775e+00 2.3653799438476562e+02 -2.6709197998046875e+02 3.1845700740814209e+00 2.3788699340820312e+02 -2.6709197998046875e+02 4.0124902725219727e+00 2.3910699462890625e+02 -2.6709197998046875e+02 5.0470199584960938e+00 2.4015699768066406e+02 -2.6699398803710938e+02 2.9976201057434082e+00 2.2912699890136719e+02 -2.6699398803710938e+02 2.2471001148223877e+00 2.3052500915527344e+02 -2.6699398803710938e+02 1.7612000703811646e+00 2.3203500366210938e+02 -2.6699398803710938e+02 1.5558999776840210e+00 2.3360699462890625e+02 -2.6699398803710938e+02 1.6379300355911255e+00 2.3519200134277344e+02 -2.6699398803710938e+02 2.0045998096466064e+00 2.3673500061035156e+02 -2.6699398803710938e+02 2.6438598632812500e+00 2.3818699645996094e+02 -2.6699398803710938e+02 3.5347099304199219e+00 2.3949900817871094e+02 -2.6699398803710938e+02 4.6478600502014160e+00 2.4062899780273438e+02 -2.6699398803710938e+02 5.9467401504516602e+00 2.4153999328613281e+02 -2.6254998779296875e+02 1.1687399864196777e+01 2.3775000000000000e+02 -2.6055099487304688e+02 1.2534399986267090e+01 2.3575000000000000e+02 -2.5846697998046875e+02 1.2706499099731445e+01 2.3366600036621094e+02 -2.5641098022460938e+02 1.2194299697875977e+01 2.3161099243164062e+02 -2.5281900024414062e+02 9.2627401351928711e+00 2.2801899719238281e+02 -2.5229298400878906e+02 1.3577099800109863e+01 2.2660600280761719e+02 -2.6699398803710938e+02 5.7483000755310059e+00 2.4217900085449219e+02 -2.6650000000000000e+02 6.9985399246215820e+00 2.4169999694824219e+02 -2.6699398803710938e+02 1.1511599645018578e-02 2.4240699768066406e+02 -2.6699398803710938e+02 1.3629499673843384e+00 2.4237699890136719e+02 -2.6699398803710938e+02 2.7415001392364502e+00 2.4234600830078125e+02 -2.6699398803710938e+02 3.5532898902893066e+00 2.4232800292968750e+02 -2.6699398803710938e+02 4.1804800033569336e+00 2.4228500366210938e+02 -2.6699398803710938e+02 5.5312700271606445e+00 2.4219400024414062e+02 -2.6587600708007812e+02 8.1846799850463867e+00 2.4107598876953125e+02 -2.6435800170898438e+02 1.0210899353027344e+01 2.3955799865722656e+02 -2.6515899658203125e+02 9.2603197097778320e+00 2.4035899353027344e+02 -2.6657299804687500e+02 1.3574300765991211e+01 2.4088500976562500e+02 -2.6541098022460938e+02 1.4655099868774414e+01 2.3972399902343750e+02 -2.6664999389648438e+02 1.8505699157714844e+01 2.3991400146484375e+02 -2.6416900634765625e+02 1.5537799835205078e+01 2.3848100280761719e+02 -2.6151000976562500e+02 1.6664199829101562e+01 2.3582200622558594e+02 -2.6286199951171875e+02 1.6210500717163086e+01 2.3717500305175781e+02 -2.6012899780273438e+02 1.6892799377441406e+01 2.3444099426269531e+02 -2.5873800659179688e+02 1.6893100738525391e+01 2.3305099487304688e+02 -2.5735699462890625e+02 1.6665100097656250e+01 2.3167001342773438e+02 -2.5600399780273438e+02 1.6211900711059570e+01 2.3031700134277344e+02 -2.5469801330566406e+02 1.5539599418640137e+01 2.2900999450683594e+02 -2.5345501708984375e+02 1.4657399177551270e+01 2.2776800537109375e+02 -2.5210198974609375e+02 8.1873903274536133e+00 2.2730099487304688e+02 -2.5147700500488281e+02 7.0014896392822266e+00 2.2667700195312500e+02 -2.5361999511718750e+02 1.0212999343872070e+01 2.2881999206542969e+02 -2.5449401855468750e+02 1.1025300025939941e+01 2.2969400024414062e+02 -2.5542799377441406e+02 1.1688799858093262e+01 2.3062800598144531e+02 -2.5742797851562500e+02 1.2535099983215332e+01 2.3262800598144531e+02 -2.5951199340820312e+02 1.2706299781799316e+01 2.3471200561523438e+02 -2.6156802368164062e+02 1.2193300247192383e+01 2.3676800537109375e+02 -2.6348501586914062e+02 1.1023599624633789e+01 2.3868400573730469e+02 -2.6694500732421875e+02 -1.3690299987792969e+01 2.2660600280761719e+02 -2.6691299438476562e+02 -1.2927900314331055e+01 2.2652499389648438e+02 -2.6691101074218750e+02 -1.2870600700378418e+01 2.2651899719238281e+02 -2.6688000488281250e+02 -1.1625399589538574e+01 2.2647100830078125e+02 -2.6687698364257812e+02 -8.9750499725341797e+00 2.2646400451660156e+02 -2.6689801025390625e+02 -8.0562000274658203e+00 2.2649499511718750e+02 -2.6684701538085938e+02 -1.0284800529479980e+01 2.2641900634765625e+02 -2.6691101074218750e+02 -7.6748600006103516e+00 2.2654199218750000e+02 -2.6692898559570312e+02 -7.1118502616882324e+00 2.2661100769042969e+02 -2.6695300292968750e+02 -6.4123997688293457e+00 2.2669699096679688e+02 -2.6699298095703125e+02 -5.1861200332641602e+00 2.2684700012207031e+02 -2.6697000122070312e+02 -1.4309100151062012e+01 2.2667098999023438e+02 -2.6699200439453125e+02 -1.5413999557495117e+01 2.2684599304199219e+02 -2.6696499633789062e+02 -1.4192700386047363e+01 2.2665899658203125e+02 -2.6699200439453125e+02 -1.8150400161743164e+01 2.3008100891113281e+02 -2.6699200439453125e+02 -1.7418901443481445e+01 2.2885800170898438e+02 -2.6699200439453125e+02 -1.6498600006103516e+01 2.2777000427246094e+02 -2.6695901489257812e+02 -1.8364900588989258e+01 2.4019500732421875e+02 -2.6699200439453125e+02 -1.8151401519775391e+01 2.4027299499511719e+02 -2.6699200439453125e+02 -1.8151100158691406e+01 2.3781100463867188e+02 -2.6694500732421875e+02 -1.8393398284912109e+01 2.4017700195312500e+02 -2.6698602294921875e+02 -1.8240900039672852e+01 2.3700599670410156e+02 -2.6698498535156250e+02 -1.8246500015258789e+01 2.3686799621582031e+02 -2.6697601318359375e+02 -1.8285699844360352e+01 2.3590501403808594e+02 -2.6695700073242188e+02 -1.8365299224853516e+01 2.3394499206542969e+02 -2.6695300292968750e+02 -1.8381700515747070e+01 2.3354400634765625e+02 -2.6697000122070312e+02 -1.8277799606323242e+01 2.3198899841308594e+02 -2.6643698120117188e+02 -1.8835998535156250e+01 2.3965100097656250e+02 -2.6652499389648438e+02 -1.8799100875854492e+01 2.3973199462890625e+02 -2.6667898559570312e+02 -1.8734300613403320e+01 2.3987600708007812e+02 -2.6677502441406250e+02 -1.8639200210571289e+01 2.3997799682617188e+02 -2.6687197875976562e+02 -1.8542999267578125e+01 2.4008099365234375e+02 -2.6699200439453125e+02 -1.7324499130249023e+01 2.3916499328613281e+02 -2.6699200439453125e+02 -1.7476400375366211e+01 2.4042298889160156e+02 -2.6699200439453125e+02 -1.6267000198364258e+01 2.4034700012207031e+02 -2.6699200439453125e+02 -1.5728098869323730e+01 2.4081001281738281e+02 -2.5330702209472656e+02 -1.5175000190734863e+01 2.2746400451660156e+02 -2.5195700073242188e+02 -8.3632802963256836e+00 2.2709800720214844e+02 -2.5269201660156250e+02 -9.4658794403076172e+00 2.2783300781250000e+02 -2.5440800476074219e+02 -1.1273300170898438e+01 2.2955000305175781e+02 -2.5741601562500000e+02 -1.2822099685668945e+01 2.3255699157714844e+02 -2.6165899658203125e+02 -1.2473400115966797e+01 2.3680099487304688e+02 -2.6717697143554688e+02 -1.0490699768066406e+01 2.4184599304199219e+02 -2.6719497680664062e+02 -1.1757999420166016e+01 2.4167900085449219e+02 -2.6534100341796875e+02 -9.4683704376220703e+00 2.4048200988769531e+02 -2.5595098876953125e+02 -1.6788400650024414e+01 2.3010798645019531e+02 -2.5459599304199219e+02 -1.6090599060058594e+01 2.2875300598144531e+02 -2.5735400390625000e+02 -1.7259099960327148e+01 2.3151100158691406e+02 -2.5878701782226562e+02 -1.7496200561523438e+01 2.3294299316406250e+02 -2.6022900390625000e+02 -1.7496398925781250e+01 2.3438600158691406e+02 -2.6166201782226562e+02 -1.7259899139404297e+01 2.3581799316406250e+02 -2.6306500244140625e+02 -1.6789798736572266e+01 2.3722200012207031e+02 -2.6442001342773438e+02 -1.6092498779296875e+01 2.3857699584960938e+02 -2.6570901489257812e+02 -1.5177399635314941e+01 2.3986599731445312e+02 -2.6703399658203125e+02 -1.4832900047302246e+01 2.4101899719238281e+02 -2.6709600830078125e+02 -1.3758500099182129e+01 2.4126699829101562e+02 -2.6708999633789062e+02 -1.3855099678039551e+01 2.4124499511718750e+02 -2.6691400146484375e+02 -1.4056900024414062e+01 2.4107099914550781e+02 -2.6706201171875000e+02 -1.4274299621582031e+01 2.4114898681640625e+02 -2.6705700683593750e+02 -1.4341799736022949e+01 2.4113400268554688e+02 -2.6719601440429688e+02 -1.1821400642395020e+01 2.4167098999023438e+02 -2.6451998901367188e+02 -1.0442500114440918e+01 2.3966099548339844e+02 -2.6719299316406250e+02 -1.1909100532531738e+01 2.4165501403808594e+02 -2.6716400146484375e+02 -1.2757400512695312e+01 2.4149699401855469e+02 -2.6712500000000000e+02 -1.3332900047302246e+01 2.4136500549316406e+02 -2.6607598876953125e+02 -8.3660602569580078e+00 2.4121800231933594e+02 -2.6711599731445312e+02 -9.4278602600097656e+00 2.4192900085449219e+02 -2.6717599487304688e+02 -1.0380700111389160e+01 2.4186100769042969e+02 -2.6671697998046875e+02 -7.1504402160644531e+00 2.4185800170898438e+02 -2.6700100708007812e+02 -7.3821802139282227e+00 2.4206300354003906e+02 -2.6700402832031250e+02 -7.4353899955749512e+00 2.4206001281738281e+02 -2.6705999755859375e+02 -8.5359697341918945e+00 2.4199299621582031e+02 -2.6708999633789062e+02 -9.0200300216674805e+00 2.4195800781250000e+02 -2.6709698486328125e+02 -9.1324596405029297e+00 2.4195001220703125e+02 -2.6699298095703125e+02 -6.4033498764038086e+00 2.4213301086425781e+02 -2.6699298095703125e+02 -7.0861001014709473e+00 2.4208499145507812e+02 -2.6699398803710938e+02 -7.2396497726440430e+00 2.4207200622558594e+02 -2.6699298095703125e+02 -5.7127399444580078e+00 2.4218200683593750e+02 -2.6699298095703125e+02 -4.1414003372192383e+00 2.4229399108886719e+02 -2.6699298095703125e+02 -3.9719598293304443e+00 2.4230599975585938e+02 -2.6699298095703125e+02 -2.7184901237487793e+00 2.4234500122070312e+02 -2.6699398803710938e+02 -1.3330301046371460e+00 2.4238800048828125e+02 -2.6699398803710938e+02 -8.5280102491378784e-01 2.4240299987792969e+02 -2.6362402343750000e+02 -1.1275199890136719e+01 2.3876600646972656e+02 -2.6266598510742188e+02 -1.1955200195312500e+01 2.3780799865722656e+02 -2.5955200195312500e+02 -1.2998499870300293e+01 2.3469300842285156e+02 -2.6061599731445312e+02 -1.2822699546813965e+01 2.3575801086425781e+02 -2.5848001098632812e+02 -1.2998200416564941e+01 2.3362199401855469e+02 -2.5637298583984375e+02 -1.2472299575805664e+01 2.3151400756835938e+02 -2.5536599731445312e+02 -1.1953800201416016e+01 2.3050700378417969e+02 -2.5351301574707031e+02 -1.0440299987792969e+01 2.2865399169921875e+02 -2.6699398803710938e+02 -2.2479600906372070e+00 2.3052400207519531e+02 -2.6699398803710938e+02 -1.7623599767684937e+00 2.3203399658203125e+02 -2.6699398803710938e+02 -2.0066800117492676e+00 2.3673400878906250e+02 -2.6699398803710938e+02 -2.6462299823760986e+00 2.3818600463867188e+02 -2.6699298095703125e+02 -3.5373401641845703e+00 2.3949800109863281e+02 -2.6699298095703125e+02 -4.6507101058959961e+00 2.4062800598144531e+02 -2.6699298095703125e+02 -5.9497699737548828e+00 2.4153800964355469e+02 -2.6699298095703125e+02 -3.9884400367736816e+00 2.2788700866699219e+02 -2.6699298095703125e+02 -2.9982099533081055e+00 2.2912699890136719e+02 -2.6699398803710938e+02 -1.6397100687026978e+00 2.3519100952148438e+02 -2.6699398803710938e+02 -1.5573600530624390e+00 2.3360699462890625e+02 -2.6868200683593750e+02 -8.3161392211914062e+00 2.2751399230957031e+02 -2.6869000244140625e+02 -8.2794208526611328e+00 2.2752600097656250e+02 -2.6815499877929688e+02 -8.1719598770141602e+00 2.2746301269531250e+02 -2.6704998779296875e+02 -5.3966598510742188e+00 2.2713999938964844e+02 -2.6742102050781250e+02 -6.8426499366760254e+00 2.2739599609375000e+02 -2.6741497802734375e+02 -7.9425396919250488e+00 2.2711900329589844e+02 -2.6764300537109375e+02 -8.0269899368286133e+00 2.2726899719238281e+02 -2.6733099365234375e+02 -5.8224201202392578e+00 2.2773100280761719e+02 -2.6714797973632812e+02 -5.6122803688049316e+00 2.2743899536132812e+02 -2.6737500000000000e+02 -5.8733100891113281e+00 2.2780099487304688e+02 -2.6706600952148438e+02 -1.4048199653625488e+01 2.2691699218750000e+02 -2.6721798706054688e+02 -1.3901499748229980e+01 2.2716799926757812e+02 -2.6721398925781250e+02 -1.2747300148010254e+01 2.2694000244140625e+02 -2.6742102050781250e+02 -1.3758899688720703e+01 2.2739599609375000e+02 -2.6767001342773438e+02 -1.3627300262451172e+01 2.2759098815917969e+02 -2.6764199829101562e+02 -1.2573899269104004e+01 2.2726799011230469e+02 -2.6868200683593750e+02 -1.2284999847412109e+01 2.2751200866699219e+02 -2.6860299682617188e+02 -1.1905499458312988e+01 2.2738999938964844e+02 -2.6815499877929688e+02 -1.2429100036621094e+01 2.2746199035644531e+02 -2.6893600463867188e+02 -1.3594299316406250e+01 2.2805499267578125e+02 -2.6888201904296875e+02 -1.3300399780273438e+01 2.2791500854492188e+02 -2.6826199340820312e+02 -1.3419099807739258e+01 2.2784399414062500e+02 -2.6879000854492188e+02 -1.2805799484252930e+01 2.2767900085449219e+02 -2.6868899536132812e+02 -1.2322299957275391e+01 2.2752400207519531e+02 -2.6803500366210938e+02 -1.1381500244140625e+01 2.2722599792480469e+02 -2.6789199829101562e+02 -1.2496800422668457e+01 2.2738400268554688e+02 -2.6795501708984375e+02 -1.3512399673461914e+01 2.2774200439453125e+02 -2.6837399291992188e+02 -1.4302599906921387e+01 2.2838999938964844e+02 -2.6899200439453125e+02 -1.4245499610900879e+01 2.2846899414062500e+02 -2.6898001098632812e+02 -1.4098700523376465e+01 2.2837600708007812e+02 -2.6826300048828125e+02 -1.4335700035095215e+01 2.2834399414062500e+02 -2.6790402221679688e+02 -1.4442700386047363e+01 2.2819499206542969e+02 -2.6781698608398438e+02 -1.4468600273132324e+01 2.2815899658203125e+02 -2.6759600830078125e+02 -1.4597799301147461e+01 2.2797999572753906e+02 -2.6737402343750000e+02 -1.4727099418640137e+01 2.2780000305175781e+02 -2.6732998657226562e+02 -1.4777999877929688e+01 2.2773001098632812e+02 -2.6717901611328125e+02 -1.1539799690246582e+01 2.2679299926757812e+02 -2.6721798706054688e+02 -6.6999697685241699e+00 2.2716799926757812e+02 -2.6706600952148438e+02 -6.5529599189758301e+00 2.2691699218750000e+02 -2.6709100341796875e+02 -5.5473899841308594e+00 2.2734899902343750e+02 -2.6721398925781250e+02 -7.8534903526306152e+00 2.2694100952148438e+02 -2.6717901611328125e+02 -9.0612201690673828e+00 2.2679299926757812e+02 -2.6757897949218750e+02 -1.1455399513244629e+01 2.2706300354003906e+02 -2.6716000366210938e+02 -1.0300499916076660e+01 2.2674200439453125e+02 -2.6754800415039062e+02 -1.0300499916076660e+01 2.2699198913574219e+02 -2.6757897949218750e+02 -9.1456298828125000e+00 2.2706300354003906e+02 -2.6879098510742188e+02 -7.7943902015686035e+00 2.2767900085449219e+02 -2.6888400268554688e+02 -7.2993102073669434e+00 2.2791300964355469e+02 -2.6826300048828125e+02 -7.1822700500488281e+00 2.2784500122070312e+02 -2.6892797851562500e+02 -7.0650496482849121e+00 2.2802299499511719e+02 -2.6837500000000000e+02 -6.2980999946594238e+00 2.2839100646972656e+02 -2.6898001098632812e+02 -6.5025796890258789e+00 2.2837699890136719e+02 -2.6899298095703125e+02 -6.3553800582885742e+00 2.2847000122070312e+02 -2.6826400756835938e+02 -6.2650198936462402e+00 2.2834500122070312e+02 -2.6790499877929688e+02 -6.1579298973083496e+00 2.2819599914550781e+02 -2.6795501708984375e+02 -7.0891199111938477e+00 2.2774200439453125e+02 -2.6767001342773438e+02 -6.9743895530700684e+00 2.2759098815917969e+02 -2.6781799316406250e+02 -6.1319899559020996e+00 2.2815998840332031e+02 -2.6759600830078125e+02 -6.0026502609252930e+00 2.2798100280761719e+02 -2.6842999267578125e+02 -1.0300200462341309e+01 2.2719700622558594e+02 -2.6803500366210938e+02 -9.2196903228759766e+00 2.2722700500488281e+02 -2.6798300170898438e+02 -1.0300600051879883e+01 2.2714599609375000e+02 -2.6851000976562500e+02 -1.1321299552917480e+01 2.2728300476074219e+02 -2.6848001098632812e+02 -1.1130700111389160e+01 2.2724800109863281e+02 -2.6842999267578125e+02 -1.0300600051879883e+01 2.2719700622558594e+02 -2.6847299194335938e+02 -9.5352001190185547e+00 2.2723999023437500e+02 -2.6851202392578125e+02 -9.2803697586059570e+00 2.2728500366210938e+02 -2.6859500122070312e+02 -8.7385196685791016e+00 2.2737998962402344e+02 -2.6714700317382812e+02 -1.4987999916076660e+01 2.2743800354003906e+02 -2.6708999633789062e+02 -1.5052899360656738e+01 2.2734800720214844e+02 -2.6704901123046875e+02 -1.5203499794006348e+01 2.2713899230957031e+02 -2.6704901123046875e+02 -1.7827301025390625e+01 2.3024000549316406e+02 -2.6708999633789062e+02 -1.7596000671386719e+01 2.3035398864746094e+02 -2.6708999633789062e+02 -1.6916099548339844e+01 2.2921800231933594e+02 -2.6708999633789062e+02 -1.6060899734497070e+01 2.2820700073242188e+02 -2.6837399291992188e+02 -1.6444099426269531e+01 2.3092100524902344e+02 -2.6899200439453125e+02 -1.6356399536132812e+01 2.3096400451660156e+02 -2.6837399291992188e+02 -1.5871599197387695e+01 2.2996400451660156e+02 -2.6899200439453125e+02 -1.5792099952697754e+01 2.3002099609375000e+02 -2.6899200439453125e+02 -1.5562900543212891e+01 2.2975000000000000e+02 -2.6899200439453125e+02 -1.5082200050354004e+01 2.2918200683593750e+02 -2.6837399291992188e+02 -1.5151400566101074e+01 2.2911299133300781e+02 -2.6781698608398438e+02 -1.6102699279785156e+01 2.2979899597167969e+02 -2.6790402221679688e+02 -1.6659099578857422e+01 2.3081498718261719e+02 -2.6826300048828125e+02 -1.6494899749755859e+01 2.3089599609375000e+02 -2.6781698608398438e+02 -1.5352600097656250e+01 2.2891200256347656e+02 -2.6737402343750000e+02 -1.6462600708007812e+01 2.2954200744628906e+02 -2.6759500122070312e+02 -1.6897399902343750e+01 2.3069799804687500e+02 -2.6781698608398438e+02 -1.6698900222778320e+01 2.3079598999023438e+02 -2.6737402343750000e+02 -1.5666000366210938e+01 2.2859999084472656e+02 -2.6714599609375000e+02 -1.7496398925781250e+01 2.3040299987792969e+02 -2.6732998657226562e+02 -1.7173898696899414e+01 2.3056199645996094e+02 -2.6737402343750000e+02 -1.7095800399780273e+01 2.3060000610351562e+02 -2.6708999633789062e+02 -1.7596698760986328e+01 2.3753799438476562e+02 -2.6714599609375000e+02 -1.7497100830078125e+01 2.3748899841308594e+02 -2.6719601440429688e+02 -1.7640100479125977e+01 2.3663899230957031e+02 -2.6884698486328125e+02 -1.7031099319458008e+01 2.3344198608398438e+02 -2.6886099243164062e+02 -1.6996500015258789e+01 2.3318899536132812e+02 -2.6825500488281250e+02 -1.7097700119018555e+01 2.3315499877929688e+02 -2.6707000732421875e+02 -1.8037099838256836e+01 2.3205799865722656e+02 -2.6739498901367188e+02 -1.7354000091552734e+01 2.3136599731445312e+02 -2.6742800903320312e+02 -1.7498201370239258e+01 2.3220401000976562e+02 -2.6767901611328125e+02 -1.7274700164794922e+01 2.3227000427246094e+02 -2.6890499877929688e+02 -1.6875099182128906e+01 2.3544599914550781e+02 -2.6889498901367188e+02 -1.6909200668334961e+01 2.3532299804687500e+02 -2.6827499389648438e+02 -1.6971200942993164e+01 2.3551699829101562e+02 -2.6898199462890625e+02 -1.6530200958251953e+01 2.3654699707031250e+02 -2.6896200561523438e+02 -1.6662000656127930e+01 2.3620100402832031e+02 -2.6828500366210938e+02 -1.6764200210571289e+01 2.3627099609375000e+02 -2.6895898437500000e+02 -1.6678699493408203e+01 2.3615800476074219e+02 -2.6890600585937500e+02 -1.6872299194335938e+01 2.3545700073242188e+02 -2.6825500488281250e+02 -1.7097799301147461e+01 2.3473800659179688e+02 -2.6796499633789062e+02 -1.7097000122070312e+01 2.3556500244140625e+02 -2.6795397949218750e+02 -1.6905000686645508e+01 2.3633799743652344e+02 -2.6899200439453125e+02 -1.6357000350952148e+01 2.3692799377441406e+02 -2.6837399291992188e+02 -1.6444700241088867e+01 2.3697100830078125e+02 -2.6826300048828125e+02 -1.6495500564575195e+01 2.3699600219726562e+02 -2.6790402221679688e+02 -1.6659799575805664e+01 2.3707699584960938e+02 -2.6781698608398438e+02 -1.6699598312377930e+01 2.3709700012207031e+02 -2.6723400878906250e+02 -1.7856199264526367e+01 2.3394599914550781e+02 -2.6722299194335938e+02 -1.7756999969482422e+01 2.3576000976562500e+02 -2.6768301391601562e+02 -1.7381700515747070e+01 2.3479100036621094e+02 -2.6739498901367188e+02 -1.7354400634765625e+01 2.3652699279785156e+02 -2.6732998657226562e+02 -1.7174600601196289e+01 2.3733100891113281e+02 -2.6737402343750000e+02 -1.7096500396728516e+01 2.3729200744628906e+02 -2.6767901611328125e+02 -1.7274999618530273e+01 2.3562300109863281e+02 -2.6765200805664062e+02 -1.7104700088500977e+01 2.3642500305175781e+02 -2.6759500122070312e+02 -1.6898000717163086e+01 2.3719400024414062e+02 -2.6768301391601562e+02 -1.7417798995971680e+01 2.3394599914550781e+02 -2.6768301391601562e+02 -1.7381500244140625e+01 2.3310099792480469e+02 -2.6722299194335938e+02 -1.7756599426269531e+01 2.3213200378417969e+02 -2.6897000122070312e+02 -1.6573999404907227e+01 2.3148399353027344e+02 -2.6828500366210938e+02 -1.6763801574707031e+01 2.3162100219726562e+02 -2.6896099853515625e+02 -1.6660699844360352e+01 2.3169200134277344e+02 -2.6795397949218750e+02 -1.6904600143432617e+01 2.3155400085449219e+02 -2.6765200805664062e+02 -1.7104299545288086e+01 2.3146800231933594e+02 -2.6827499389648438e+02 -1.6970901489257812e+01 2.3237500000000000e+02 -2.6890600585937500e+02 -1.6869600296020508e+01 2.3243699645996094e+02 -2.6895999145507812e+02 -1.6675500869750977e+01 2.3172700500488281e+02 -2.6889199829101562e+02 -1.6917699813842773e+01 2.3261199951171875e+02 -2.6886099243164062e+02 -1.6994298934936523e+01 2.3470300292968750e+02 -2.6884500122070312e+02 -1.7035499572753906e+01 2.3440299987792969e+02 -2.6824600219726562e+02 -1.7140399932861328e+01 2.3394599914550781e+02 -2.6884500122070312e+02 -1.7034400939941406e+01 2.3394599914550781e+02 -2.6884600830078125e+02 -1.7033100128173828e+01 2.3345700073242188e+02 -2.6708999633789062e+02 -1.6828399658203125e+01 2.3879699707031250e+02 -2.6737500000000000e+02 -4.8365402221679688e+00 2.2870098876953125e+02 -2.6837399291992188e+02 -1.4970200538635254e+01 2.3895600891113281e+02 -2.6837399291992188e+02 -1.5797799110412598e+01 2.3803100585937500e+02 -2.6781698608398438e+02 -1.6025699615478516e+01 2.3819999694824219e+02 -2.6837500000000000e+02 -5.3607797622680664e+00 2.2920500183105469e+02 -2.6899200439453125e+02 -1.4891799926757812e+01 2.3889300537109375e+02 -2.6899200439453125e+02 -1.4903499603271484e+01 2.3888400268554688e+02 -2.6899200439453125e+02 -1.3218799591064453e+01 2.4000599670410156e+02 -2.6899200439453125e+02 -1.3936400413513184e+01 2.3963400268554688e+02 -2.6837399291992188e+02 -1.3989100456237793e+01 2.3971701049804688e+02 -2.6899298095703125e+02 -1.1679599761962891e+01 2.4055500793457031e+02 -2.6899200439453125e+02 -1.2849900245666504e+01 2.4019700622558594e+02 -2.6837399291992188e+02 -1.2886799812316895e+01 2.4028800964355469e+02 -2.6709100341796875e+02 -6.2571001052856445e+00 2.4100199890136719e+02 -2.6709100341796875e+02 -7.5972900390625000e+00 2.4161599731445312e+02 -2.6737500000000000e+02 -9.1137294769287109e+00 2.4142800903320312e+02 -2.6737500000000000e+02 -1.0483800888061523e+01 2.4151899719238281e+02 -2.6737500000000000e+02 -1.1847900390625000e+01 2.4136199951171875e+02 -2.6737402343750000e+02 -1.3161100387573242e+01 2.4096000671386719e+02 -2.6708999633789062e+02 -1.4680600166320801e+01 2.4079899597167969e+02 -2.6899298095703125e+02 -5.4314498901367188e+00 2.2927198791503906e+02 -2.6837500000000000e+02 -4.5858001708984375e+00 2.3017401123046875e+02 -2.6899298095703125e+02 -5.0448899269104004e+00 2.2975599670410156e+02 -2.6899298095703125e+02 -4.6675601005554199e+00 2.3022801208496094e+02 -2.6837500000000000e+02 -3.9986498355865479e+00 2.3126800537109375e+02 -2.6899298095703125e+02 -4.0887999534606934e+00 2.3130599975585938e+02 -2.6899298095703125e+02 -4.0311198234558105e+00 2.3148599243164062e+02 -2.6837500000000000e+02 -3.6186101436614990e+00 2.3244999694824219e+02 -2.6899298095703125e+02 -3.7141900062561035e+00 2.3247100830078125e+02 -2.6899298095703125e+02 -3.5872600078582764e+00 2.3344500732421875e+02 -2.6837500000000000e+02 -3.4581799507141113e+00 2.3368099975585938e+02 -2.6899298095703125e+02 -3.5560498237609863e+00 2.3368499755859375e+02 -2.6837500000000000e+02 -3.5226199626922607e+00 2.3492098999023438e+02 -2.6899298095703125e+02 -3.6195700168609619e+00 2.3490699768066406e+02 -2.6899298095703125e+02 -3.7471201419830322e+00 2.3544299316406250e+02 -2.6837500000000000e+02 -3.8098199367523193e+00 2.3612800598144531e+02 -2.6899298095703125e+02 -3.9026699066162109e+00 2.3609700012207031e+02 -2.6837500000000000e+02 -4.3103399276733398e+00 2.3726400756835938e+02 -2.6899298095703125e+02 -4.3960399627685547e+00 2.3721699523925781e+02 -2.6899298095703125e+02 -4.4638099670410156e+00 2.3731700134277344e+02 -2.6837500000000000e+02 -5.0077400207519531e+00 2.3829100036621094e+02 -2.6899298095703125e+02 -5.0834598541259766e+00 2.3822900390625000e+02 -2.6899298095703125e+02 -5.7252397537231445e+00 2.3888101196289062e+02 -2.6837500000000000e+02 -5.8790798187255859e+00 2.3917601013183594e+02 -2.6899298095703125e+02 -5.9423499107360840e+00 2.3910099792480469e+02 -2.6837500000000000e+02 -6.8957400321960449e+00 2.3988800048828125e+02 -2.6899298095703125e+02 -6.9444799423217773e+00 2.3980299377441406e+02 -2.6899298095703125e+02 -7.3839101791381836e+00 2.4000500488281250e+02 -2.6837500000000000e+02 -8.0243101119995117e+00 2.4040499877929688e+02 -2.6899298095703125e+02 -8.0569200515747070e+00 2.4031298828125000e+02 -2.6837500000000000e+02 -9.2276992797851562e+00 2.4071000671386719e+02 -2.6899298095703125e+02 -9.2431001663208008e+00 2.4061299133300781e+02 -2.6899298095703125e+02 -9.2958898544311523e+00 2.4061700439453125e+02 -2.6837500000000000e+02 -1.0466399192810059e+01 2.4079299926757812e+02 -2.6899298095703125e+02 -1.0463999748229980e+01 2.4069500732421875e+02 -2.6899298095703125e+02 -1.1304900169372559e+01 2.4059799194335938e+02 -2.6837500000000000e+02 -1.1699600219726562e+01 2.4064999389648438e+02 -2.6899200439453125e+02 -1.5719300270080566e+01 2.3797200012207031e+02 -2.6899200439453125e+02 -1.6125000000000000e+01 2.3730799865722656e+02 -2.6781799316406250e+02 -5.1557798385620117e+00 2.2900801086425781e+02 -2.6781799316406250e+02 -4.3486599922180176e+00 2.3001800537109375e+02 -2.6781799316406250e+02 -3.7371499538421631e+00 2.3115699768066406e+02 -2.6781799316406250e+02 -3.3413500785827637e+00 2.3238800048828125e+02 -2.6781799316406250e+02 -3.1742601394653320e+00 2.3366999816894531e+02 -2.6781799316406250e+02 -3.2413699626922607e+00 2.3496099853515625e+02 -2.6781799316406250e+02 -3.5404901504516602e+00 2.3621900939941406e+02 -2.6781799316406250e+02 -4.0617699623107910e+00 2.3740200805664062e+02 -2.6781799316406250e+02 -4.7880997657775879e+00 2.3847200012207031e+02 -2.6781799316406250e+02 -5.6955900192260742e+00 2.3939299011230469e+02 -2.6781799316406250e+02 -6.7544298171997070e+00 2.4013499450683594e+02 -2.6781698608398438e+02 -7.9298105239868164e+00 2.4067300415039062e+02 -2.6781698608398438e+02 -9.1831197738647461e+00 2.4099099731445312e+02 -2.6781698608398438e+02 -1.0473199844360352e+01 2.4107701110839844e+02 -2.6781698608398438e+02 -1.1757499694824219e+01 2.4092799377441406e+02 -2.6737500000000000e+02 -3.9793500900268555e+00 2.2977400207519531e+02 -2.6737500000000000e+02 -3.3299000263214111e+00 2.3098400878906250e+02 -2.6737500000000000e+02 -2.9095399379730225e+00 2.3229100036621094e+02 -2.6737500000000000e+02 -2.7320899963378906e+00 2.3365299987792969e+02 -2.6737500000000000e+02 -2.8033602237701416e+00 2.3502400207519531e+02 -2.6737500000000000e+02 -3.1210401058197021e+00 2.3636000061035156e+02 -2.6737500000000000e+02 -3.6746602058410645e+00 2.3761599731445312e+02 -2.6737500000000000e+02 -4.4460501670837402e+00 2.3875199890136719e+02 -2.6737500000000000e+02 -5.4098401069641113e+00 2.3972999572753906e+02 -2.6737500000000000e+02 -6.5343699455261230e+00 2.4051800537109375e+02 -2.6737500000000000e+02 -7.7826700210571289e+00 2.4108999633789062e+02 -2.6781698608398438e+02 -1.5163799285888672e+01 2.3916400146484375e+02 -2.6737402343750000e+02 -1.6380901336669922e+01 2.3846400451660156e+02 -2.6709100341796875e+02 -4.4342999458312988e+00 2.2831500244140625e+02 -2.6709100341796875e+02 -5.0497999191284180e+00 2.4015599060058594e+02 -2.6709100341796875e+02 -4.0150599479675293e+00 2.3910600280761719e+02 -2.6709100341796875e+02 -3.1868999004364014e+00 2.3788699340820312e+02 -2.6709100341796875e+02 -2.5925199985504150e+00 2.3653799438476562e+02 -2.6709100341796875e+02 -2.2514700889587402e+00 2.3510299682617188e+02 -2.6709100341796875e+02 -2.1749398708343506e+00 2.3363099670410156e+02 -2.6709100341796875e+02 -2.3654599189758301e+00 2.3216900634765625e+02 -2.6709100341796875e+02 -2.8167600631713867e+00 2.3076599121093750e+02 -2.6709100341796875e+02 -3.5140099525451660e+00 2.2946701049804688e+02 -2.6781698608398438e+02 -1.2993999481201172e+01 2.4055099487304688e+02 -2.6737402343750000e+02 -1.4380300521850586e+01 2.4032899475097656e+02 -2.6708999633789062e+02 -1.5845600128173828e+01 2.3989500427246094e+02 -2.6781698608398438e+02 -1.4142000198364258e+01 2.3995600891113281e+02 -2.6737402343750000e+02 -1.5465399742126465e+01 2.3948701477050781e+02 -2.7035498046875000e+02 -1.7032299041748047e+01 2.3445098876953125e+02 -2.7035498046875000e+02 -1.5578900337219238e+01 2.3815501403808594e+02 -2.7035498046875000e+02 -1.6147098541259766e+01 2.3732099914550781e+02 -2.7035498046875000e+02 -1.6584299087524414e+01 2.3147999572753906e+02 -2.7035498046875000e+02 -1.6146398544311523e+01 2.3057099914550781e+02 -2.7035498046875000e+02 -1.5578000068664551e+01 2.2973799133300781e+02 -2.7035498046875000e+02 -1.4102999687194824e+01 2.2836900329589844e+02 -2.7035498046875000e+02 -1.4891799926757812e+01 2.2899800109863281e+02 -2.7035498046875000e+02 -1.2290100097656250e+01 2.2749699401855469e+02 -2.7035498046875000e+02 -1.3229199409484863e+01 2.2786499023437500e+02 -2.6847000122070312e+02 -1.0813099861145020e+01 2.2721600341796875e+02 -2.7035498046875000e+02 -1.0300399780273438e+01 2.2719700622558594e+02 -2.7035498046875000e+02 -1.1306500434875488e+01 2.2727200317382812e+02 -2.7035598754882812e+02 -9.2944107055664062e+00 2.2727200317382812e+02 -2.7035598754882812e+02 -8.3108701705932617e+00 2.2749699401855469e+02 -2.7035598754882812e+02 -7.3717799186706543e+00 2.2786599731445312e+02 -2.7035598754882812e+02 -6.4981398582458496e+00 2.2836999511718750e+02 -2.7035598754882812e+02 -4.0174603462219238e+00 2.3148100280761719e+02 -2.7035598754882812e+02 -4.4550900459289551e+00 2.3057200622558594e+02 -2.7035598754882812e+02 -5.0233201980590820e+00 2.2973899841308594e+02 -2.7035598754882812e+02 -5.7094502449035645e+00 2.2899900817871094e+02 -2.7035598754882812e+02 -3.5700199604034424e+00 2.3445199584960938e+02 -2.7035598754882812e+02 -3.5699200630187988e+00 2.3344300842285156e+02 -2.7035598754882812e+02 -3.7201898097991943e+00 2.3244500732421875e+02 -2.7035598754882812e+02 -4.4557600021362305e+00 2.3732200622558594e+02 -2.7035598754882812e+02 -4.0179395675659180e+00 2.3641400146484375e+02 -2.7035598754882812e+02 -3.7204799652099609e+00 2.3544999694824219e+02 -2.7035598754882812e+02 -6.4992403984069824e+00 2.3952400207519531e+02 -2.7035598754882812e+02 -5.7104201316833496e+00 2.3889500427246094e+02 -2.7035598754882812e+02 -5.0241498947143555e+00 2.3815600585937500e+02 -2.7035598754882812e+02 -9.2957201004028320e+00 2.4062199401855469e+02 -2.7035598754882812e+02 -8.3121395111083984e+00 2.4039700317382812e+02 -2.7035598754882812e+02 -7.3729801177978516e+00 2.4002900695800781e+02 -2.7035498046875000e+02 -1.2291299819946289e+01 2.4039700317382812e+02 -2.7035498046875000e+02 -1.1307800292968750e+01 2.4062100219726562e+02 -2.7035498046875000e+02 -1.0301800727844238e+01 2.4069699096679688e+02 -2.7035498046875000e+02 -1.4892799377441406e+01 2.3889399719238281e+02 -2.7035498046875000e+02 -1.4104100227355957e+01 2.3952400207519531e+02 -2.7035498046875000e+02 -1.3230400085449219e+01 2.4002799987792969e+02 -2.7035498046875000e+02 -1.6584699630737305e+01 2.3641200256347656e+02 -2.7035498046875000e+02 -1.6881999969482422e+01 2.3544799804687500e+02 -2.7035498046875000e+02 -1.7032199859619141e+01 2.3344198608398438e+02 -2.7035498046875000e+02 -1.6881700515747070e+01 2.3244400024414062e+02 -2.7739099121093750e+02 -1.0580300331115723e+01 2.2684899902343750e+02 -2.7739099121093750e+02 -1.0453200340270996e+01 2.2693299865722656e+02 -2.7739099121093750e+02 -1.0300000190734863e+01 2.2684300231933594e+02 -2.7739099121093750e+02 -1.0300000190734863e+01 2.2696299743652344e+02 -2.7739099121093750e+02 -1.0019700050354004e+01 2.2684899902343750e+02 -2.7739099121093750e+02 -1.0146800041198730e+01 2.2693299865722656e+02 -2.8019100952148438e+02 -1.0580300331115723e+01 2.2684899902343750e+02 -2.8019100952148438e+02 -1.0146800041198730e+01 2.2693299865722656e+02 -2.8019100952148438e+02 -1.0019700050354004e+01 2.2684899902343750e+02 -2.8019100952148438e+02 -1.0453200340270996e+01 2.2693299865722656e+02 -2.8019100952148438e+02 -1.0300000190734863e+01 2.2696299743652344e+02 -2.7149002075195312e+02 -3.8421001434326172e+00 2.3099299621582031e+02 -2.7149002075195312e+02 -3.7055599689483643e+00 2.3135900878906250e+02 -2.7095401000976562e+02 -3.9322400093078613e+00 2.3144799804687500e+02 -2.7095401000976562e+02 -9.2821302413940430e+00 2.4071200561523438e+02 -2.7148101806640625e+02 -9.2448902130126953e+00 2.4096099853515625e+02 -2.7148101806640625e+02 -9.2902603149414062e+00 2.4097099304199219e+02 -2.7095401000976562e+02 -1.0301800727844238e+01 2.4078799438476562e+02 -2.7148101806640625e+02 -8.2994298934936523e+00 2.4075500488281250e+02 -2.7095401000976562e+02 -8.2852001190185547e+00 2.4048500061035156e+02 -2.7148101806640625e+02 -8.2121601104736328e+00 2.4072299194335938e+02 -2.7148199462890625e+02 -7.3511896133422852e+00 2.4040199279785156e+02 -2.7095401000976562e+02 -7.3333001136779785e+00 2.4011099243164062e+02 -2.7148199462890625e+02 -7.2266397476196289e+00 2.4033399963378906e+02 -2.7148199462890625e+02 -6.4649896621704102e+00 2.3991799926757812e+02 -2.7095401000976562e+02 -6.4477000236511230e+00 2.3960000610351562e+02 -2.7148300170898438e+02 -6.3102798461914062e+00 2.3980299377441406e+02 -2.7148300170898438e+02 -5.6510200500488281e+00 2.3930899047851562e+02 -2.7095401000976562e+02 -5.6481800079345703e+00 2.3896299743652344e+02 -2.7148300170898438e+02 -5.4829201698303223e+00 2.3914100646972656e+02 -2.7148397827148438e+02 -4.9371199607849121e+00 2.3859600830078125e+02 -2.7095401000976562e+02 -4.9525899887084961e+00 2.3821299743652344e+02 -2.7148397827148438e+02 -4.7635903358459473e+00 2.3836399841308594e+02 -2.7148501586914062e+02 -4.3274803161621094e+00 2.3778199768066406e+02 -2.7095401000976562e+02 -4.3764901161193848e+00 2.3736799621582031e+02 -2.7148501586914062e+02 -4.1674900054931641e+00 2.3748899841308594e+02 -2.7148602294921875e+02 -3.8423099517822266e+00 2.3689399719238281e+02 -2.7095401000976562e+02 -3.9327297210693359e+00 2.3644700622558594e+02 -2.7148602294921875e+02 -3.7084400653839111e+00 2.3653500366210938e+02 -2.7148699951171875e+02 -3.4878001213073730e+00 2.3594400024414062e+02 -2.7095401000976562e+02 -3.6312298774719238e+00 2.3547000122070312e+02 -2.7148699951171875e+02 -3.3963198661804199e+00 2.3552400207519531e+02 -2.7148699951171875e+02 -3.2723097801208496e+00 2.3495399475097656e+02 -2.7095401000976562e+02 -3.4787302017211914e+00 2.3445899963378906e+02 -2.7148800659179688e+02 -3.2381598949432373e+00 2.3447700500488281e+02 -2.7148800659179688e+02 -3.1999998092651367e+00 2.3394400024414062e+02 -2.7095401000976562e+02 -3.4786300659179688e+00 2.3343600463867188e+02 -2.7148898315429688e+02 -3.2375500202178955e+00 2.3341799926757812e+02 -2.7095401000976562e+02 -3.6309301853179932e+00 2.3242500305175781e+02 -2.7149002075195312e+02 -3.4874000549316406e+00 2.3194400024414062e+02 -2.7148898315429688e+02 -3.3944599628448486e+00 2.3237100219726562e+02 -2.7148898315429688e+02 -3.2721700668334961e+00 2.3293299865722656e+02 -2.7149099731445312e+02 -4.1637001037597656e+00 2.3040400695800781e+02 -2.7095401000976562e+02 -4.3758096694946289e+00 2.3052699279785156e+02 -2.7149099731445312e+02 -4.3267197608947754e+00 2.3010499572753906e+02 -2.7095401000976562e+02 -4.9517498016357422e+00 2.2968199157714844e+02 -2.7149099731445312e+02 -4.7592601776123047e+00 2.2952799987792969e+02 -2.7149099731445312e+02 -4.9363498687744141e+00 2.2929100036621094e+02 -2.7095401000976562e+02 -5.6471900939941406e+00 2.2893199157714844e+02 -2.7149099731445312e+02 -5.4783401489257812e+00 2.2874900817871094e+02 -2.7149099731445312e+02 -5.6499600410461426e+00 2.2857800292968750e+02 -2.7095401000976562e+02 -6.4465899467468262e+00 2.2829400634765625e+02 -2.7149200439453125e+02 -6.3057699203491211e+00 2.2808699035644531e+02 -2.7149200439453125e+02 -6.4633598327636719e+00 2.2796900939941406e+02 -2.7095401000976562e+02 -7.3320899009704590e+00 2.2778298950195312e+02 -2.7149200439453125e+02 -7.2225699424743652e+00 2.2755500793457031e+02 -2.7149200439453125e+02 -7.3499197959899902e+00 2.2748500061035156e+02 -2.7095401000976562e+02 -8.2839107513427734e+00 2.2740901184082031e+02 -2.7149200439453125e+02 -8.2087602615356445e+00 2.2716400146484375e+02 -2.7149200439453125e+02 -8.2969703674316406e+00 2.2713198852539062e+02 -2.7095401000976562e+02 -9.2807998657226562e+00 2.2718200683593750e+02 -2.7149099731445312e+02 -9.2424392700195312e+00 2.2692599487304688e+02 -2.7149099731445312e+02 -9.2888698577880859e+00 2.2691600036621094e+02 -2.7095401000976562e+02 -1.0300499916076660e+01 2.2710501098632812e+02 -2.7149099731445312e+02 -1.0299500465393066e+01 2.2684300231933594e+02 -2.7149099731445312e+02 -1.1309700012207031e+01 2.2691500854492188e+02 -2.7095401000976562e+02 -1.1320199966430664e+01 2.2718200683593750e+02 -2.7149099731445312e+02 -1.1358500480651855e+01 2.2692599487304688e+02 -2.7149002075195312e+02 -1.2300499916076660e+01 2.2713099670410156e+02 -2.7095401000976562e+02 -1.2317099571228027e+01 2.2740901184082031e+02 -2.7149002075195312e+02 -1.2392000198364258e+01 2.2716499328613281e+02 -2.7149002075195312e+02 -1.3248800277709961e+01 2.2748400878906250e+02 -2.7095401000976562e+02 -1.3269000053405762e+01 2.2778199768066406e+02 -2.7148898315429688e+02 -1.3378099441528320e+01 2.2755500793457031e+02 -2.7148898315429688e+02 -1.4135000228881836e+01 2.2796800231933594e+02 -2.7095300292968750e+02 -1.4154600143432617e+01 2.2829400634765625e+02 -2.7148898315429688e+02 -1.4294699668884277e+01 2.2808699035644531e+02 -2.7148800659179688e+02 -1.4949000358581543e+01 2.2857699584960938e+02 -2.7095300292968750e+02 -1.4954100608825684e+01 2.2893099975585938e+02 -2.7148800659179688e+02 -1.5121899604797363e+01 2.2875000000000000e+02 -2.7148699951171875e+02 -1.5662899017333984e+01 2.2928999328613281e+02 -2.7095300292968750e+02 -1.5649700164794922e+01 2.2968099975585938e+02 -2.7148699951171875e+02 -1.5840800285339355e+01 2.2952799987792969e+02 -2.7148699951171875e+02 -1.6272500991821289e+01 2.3010400390625000e+02 -2.7095300292968750e+02 -1.6225799560546875e+01 2.3052500915527344e+02 -2.7148602294921875e+02 -1.6436201095581055e+01 2.3040400695800781e+02 -2.7148602294921875e+02 -1.6757699966430664e+01 2.3099200439453125e+02 -2.7095300292968750e+02 -1.6669599533081055e+01 2.3144699096679688e+02 -2.7148501586914062e+02 -1.6894300460815430e+01 2.3135800170898438e+02 -2.7148501586914062e+02 -1.7112199783325195e+01 2.3194200134277344e+02 -2.7095300292968750e+02 -1.6971099853515625e+01 2.3242401123046875e+02 -2.7148501586914062e+02 -1.7205299377441406e+01 2.3237001037597656e+02 -2.7148397827148438e+02 -1.7327699661254883e+01 2.3293200683593750e+02 -2.7095300292968750e+02 -1.7123600006103516e+01 2.3343499755859375e+02 -2.7148397827148438e+02 -1.7362400054931641e+01 2.3341700744628906e+02 -2.7095300292968750e+02 -1.7123699188232422e+01 2.3445700073242188e+02 -2.7148300170898438e+02 -1.7361900329589844e+01 2.3447500610351562e+02 -2.7148300170898438e+02 -1.7399999618530273e+01 2.3394200134277344e+02 -2.7095300292968750e+02 -1.6971399307250977e+01 2.3546899414062500e+02 -2.7095300292968750e+02 -1.6670101165771484e+01 2.3644599914550781e+02 -2.7148101806640625e+02 -1.6892301559448242e+01 2.3653300476074219e+02 -2.7148199462890625e+02 -1.7112600326538086e+01 2.3594300842285156e+02 -2.7148199462890625e+02 -1.7204099655151367e+01 2.3552200317382812e+02 -2.7148199462890625e+02 -1.7327800750732422e+01 2.3495300292968750e+02 -2.7095300292968750e+02 -1.5650600433349609e+01 2.3821200561523438e+02 -2.7148101806640625e+02 -1.6273300170898438e+01 2.3778100585937500e+02 -2.7095300292968750e+02 -1.6226499557495117e+01 2.3736700439453125e+02 -2.7148101806640625e+02 -1.6433799743652344e+01 2.3748699951171875e+02 -2.7148101806640625e+02 -1.6757900238037109e+01 2.3689399719238281e+02 -2.7095300292968750e+02 -1.4955100059509277e+01 2.3896199035644531e+02 -2.7147998046875000e+02 -1.5663599967956543e+01 2.3859500122070312e+02 -2.7147998046875000e+02 -1.5838200569152832e+01 2.3836199951171875e+02 -2.7095300292968750e+02 -1.4155699729919434e+01 2.3959899902343750e+02 -2.7147998046875000e+02 -1.4949999809265137e+01 2.3930799865722656e+02 -2.7147998046875000e+02 -1.5119400024414062e+01 2.3913900756835938e+02 -2.7095401000976562e+02 -1.3270199775695801e+01 2.4011099243164062e+02 -2.7147998046875000e+02 -1.4136600494384766e+01 2.3991699218750000e+02 -2.7147998046875000e+02 -1.4292499542236328e+01 2.3980101013183594e+02 -2.7095401000976562e+02 -1.2318399429321289e+01 2.4048399353027344e+02 -2.7147998046875000e+02 -1.3250100135803223e+01 2.4040100097656250e+02 -2.7147998046875000e+02 -1.3376500129699707e+01 2.4033200073242188e+02 -2.7095401000976562e+02 -1.1321499824523926e+01 2.4071200561523438e+02 -2.7147998046875000e+02 -1.2303000450134277e+01 2.4075500488281250e+02 -2.7147998046875000e+02 -1.2391399383544922e+01 2.4072200012207031e+02 -2.7147998046875000e+02 -1.0301899909973145e+01 2.4104299926757812e+02 -2.7147998046875000e+02 -1.1311100006103516e+01 2.4097099304199219e+02 -2.7147998046875000e+02 -1.1358799934387207e+01 2.4096000671386719e+02 -2.8019100952148438e+02 -9.2975196838378906e+00 2.2696800231933594e+02 -2.8019100952148438e+02 -9.3005199432373047e+00 2.4089999389648438e+02 -2.8019100952148438e+02 -1.0300000190734863e+01 2.4104299926757812e+02 -2.8019100952148438e+02 -1.1300900459289551e+01 2.4089900207519531e+02 -2.8019100952148438e+02 -1.2298899650573730e+01 2.4075601196289062e+02 -2.8019100952148438e+02 -1.3220099449157715e+01 2.4033599853515625e+02 -2.8019100952148438e+02 -1.4136099815368652e+01 2.3991799926757812e+02 -2.8019100952148438e+02 -1.4902800559997559e+01 2.3925399780273438e+02 -2.8019100952148438e+02 -1.5662899017333984e+01 2.3859600830078125e+02 -2.8019100952148438e+02 -1.6212598800659180e+01 2.3774200439453125e+02 -2.8019100952148438e+02 -1.6756000518798828e+01 2.3689801025390625e+02 -2.8019100952148438e+02 -1.7043399810791016e+01 2.3592199707031250e+02 -2.8019100952148438e+02 -1.7326700210571289e+01 2.3496099853515625e+02 -2.8019100952148438e+02 -1.7327800750732422e+01 2.3394200134277344e+02 -2.8019100952148438e+02 -1.7329000473022461e+01 2.3294099426269531e+02 -2.8019100952148438e+02 -1.7042900085449219e+01 2.3196199035644531e+02 -2.8019100952148438e+02 -1.6762599945068359e+01 2.3100300598144531e+02 -2.8019100952148438e+02 -1.6211799621582031e+01 2.3014299011230469e+02 -2.8019100952148438e+02 -1.5673499107360840e+01 2.2930200195312500e+02 -2.8019100952148438e+02 -1.4901599884033203e+01 2.2863101196289062e+02 -2.8019100952148438e+02 -1.3218700408935547e+01 2.2755000305175781e+02 -2.8019100952148438e+02 -1.4149600028991699e+01 2.2797698974609375e+02 -2.8019100952148438e+02 -1.2314299583435059e+01 2.2713500976562500e+02 -2.8019100952148438e+02 -1.1301099777221680e+01 2.2696800231933594e+02 -2.8019100952148438e+02 -8.2856607437133789e+00 2.2713500976562500e+02 -2.8019100952148438e+02 -7.3800196647644043e+00 2.2755099487304688e+02 -2.8019100952148438e+02 -6.4503803253173828e+00 2.2797698974609375e+02 -2.8019100952148438e+02 -5.6973099708557129e+00 2.2863200378417969e+02 -2.8019100952148438e+02 -4.9265198707580566e+00 2.2930200195312500e+02 -2.8019100952148438e+02 -4.3874802589416504e+00 2.3014399719238281e+02 -2.8019100952148438e+02 -3.8373601436614990e+00 2.3100300598144531e+02 -2.8019100952148438e+02 -3.5566699504852295e+00 2.3196400451660156e+02 -2.8019100952148438e+02 -3.2710199356079102e+00 2.3294099426269531e+02 -2.8019100952148438e+02 -3.2721600532531738e+00 2.3394400024414062e+02 -2.8019100952148438e+02 -3.2733099460601807e+00 2.3496099853515625e+02 -2.8019100952148438e+02 -3.5570201873779297e+00 2.3592401123046875e+02 -2.8019100952148438e+02 -3.8440499305725098e+00 2.3689801025390625e+02 -2.8019100952148438e+02 -4.3881602287292480e+00 2.3774301147460938e+02 -2.8019100952148438e+02 -5.6982502937316895e+00 2.3925498962402344e+02 -2.8019100952148438e+02 -4.9370498657226562e+00 2.3859600830078125e+02 -2.8019100952148438e+02 -6.4639101028442383e+00 2.3991799926757812e+02 -2.8019100952148438e+02 -7.3811502456665039e+00 2.4033599853515625e+02 -2.8019100952148438e+02 -8.3010997772216797e+00 2.4075601196289062e+02 -2.7479101562500000e+02 -1.0301400184631348e+01 2.3333799743652344e+02 -2.7479101562500000e+02 -1.0604299545288086e+01 2.3341900634765625e+02 -2.7479101562500000e+02 -1.0826000213623047e+01 2.3364099121093750e+02 -2.7479101562500000e+02 -1.0301499366760254e+01 2.3454899597167969e+02 -2.7479101562500000e+02 -9.9986591339111328e+00 2.3446800231933594e+02 -2.7479101562500000e+02 -9.7769298553466797e+00 2.3424699401855469e+02 -2.7479101562500000e+02 -1.0604400634765625e+01 2.3446800231933594e+02 -2.7479101562500000e+02 -1.0826099395751953e+01 2.3424600219726562e+02 -2.7479101562500000e+02 -1.0907199859619141e+01 2.3394400024414062e+02 -2.7479101562500000e+02 -9.9985599517822266e+00 2.3341900634765625e+02 -2.7479101562500000e+02 -9.7768697738647461e+00 2.3364099121093750e+02 -2.7479101562500000e+02 -9.6957492828369141e+00 2.3394400024414062e+02 -2.8039102172851562e+02 -1.0648200035095215e+01 2.2705200195312500e+02 -2.8039102172851562e+02 -1.0529699325561523e+01 2.2711799621582031e+02 -2.8039102172851562e+02 -1.0300000190734863e+01 2.2716299438476562e+02 -2.8039102172851562e+02 -1.0070300102233887e+01 2.2711799621582031e+02 -2.8039102172851562e+02 -9.9517602920532227e+00 2.2705200195312500e+02 -2.8039102172851562e+02 -1.2257599830627441e+01 2.2732701110839844e+02 -2.8039102172851562e+02 -1.4041200637817383e+01 2.2814500427246094e+02 -2.8039102172851562e+02 -1.5522100448608398e+01 2.2943299865722656e+02 -2.8039102172851562e+02 -1.6580600738525391e+01 2.3108599853515625e+02 -2.8039102172851562e+02 -1.7131000518798828e+01 2.3297000122070312e+02 -2.8039102172851562e+02 -1.7128799438476562e+01 2.3493200683593750e+02 -2.8039102172851562e+02 -1.6574100494384766e+01 2.3681500244140625e+02 -2.8039102172851562e+02 -1.5511899948120117e+01 2.3846499633789062e+02 -2.8039102172851562e+02 -1.4027999877929688e+01 2.3974899291992188e+02 -2.8039102172851562e+02 -1.2242600440979004e+01 2.4056401062011719e+02 -2.8039102172851562e+02 -8.3574104309082031e+00 2.4056401062011719e+02 -2.8039102172851562e+02 -1.0300000190734863e+01 2.4084300231933594e+02 -2.8039102172851562e+02 -5.0881199836730957e+00 2.3846499633789062e+02 -2.8039102172851562e+02 -6.5719699859619141e+00 2.3974899291992188e+02 -2.8039102172851562e+02 -3.4712500572204590e+00 2.3493200683593750e+02 -2.8039102172851562e+02 -4.0258998870849609e+00 2.3681500244140625e+02 -2.8039102172851562e+02 -4.0194096565246582e+00 2.3108599853515625e+02 -2.8039102172851562e+02 -3.4690198898315430e+00 2.3297000122070312e+02 -2.8039102172851562e+02 -6.5588202476501465e+00 2.2814500427246094e+02 -2.8039102172851562e+02 -5.0778799057006836e+00 2.2943299865722656e+02 -2.8039102172851562e+02 -8.3424005508422852e+00 2.2732701110839844e+02 -2.7729098510742188e+02 -8.4639101028442383e+00 2.3234700012207031e+02 -2.8109100341796875e+02 -8.4138593673706055e+00 2.3230299377441406e+02 -2.7729098510742188e+02 -8.6951799392700195e+00 2.3211399841308594e+02 -2.8109100341796875e+02 -8.6514301300048828e+00 2.3206500244140625e+02 -2.7729098510742188e+02 -8.7036094665527344e+00 2.3577999877929688e+02 -2.8109100341796875e+02 -8.6600904464721680e+00 2.3582998657226562e+02 -2.7729098510742188e+02 -8.4712800979614258e+00 2.3554899597167969e+02 -2.8109100341796875e+02 -8.4214305877685547e+00 2.3559300231933594e+02 -2.7729098510742188e+02 -9.7397098541259766e+00 2.3361900329589844e+02 -2.7729098510742188e+02 -9.9771003723144531e+00 2.3338200378417969e+02 -2.7729098510742188e+02 -1.0301400184631348e+01 2.3329499816894531e+02 -2.7729098510742188e+02 -1.0625699996948242e+01 2.3338200378417969e+02 -2.7729098510742188e+02 -1.0863200187683105e+01 2.3361900329589844e+02 -2.7729098510742188e+02 -1.0950099945068359e+01 2.3394400024414062e+02 -2.7729098510742188e+02 -1.0863200187683105e+01 2.3426799011230469e+02 -2.7729098510742188e+02 -1.0625800132751465e+01 2.3450500488281250e+02 -2.7729098510742188e+02 -1.0301499366760254e+01 2.3459201049804688e+02 -2.7729098510742188e+02 -9.9772100448608398e+00 2.3450500488281250e+02 -2.7729098510742188e+02 -9.7397699356079102e+00 2.3426799011230469e+02 -2.7729098510742188e+02 -9.6528396606445312e+00 2.3394400024414062e+02 -2.7729098510742188e+02 -1.1897300720214844e+01 2.3210699462890625e+02 -2.8109100341796875e+02 -1.1940799713134766e+01 2.3205700683593750e+02 -2.7729098510742188e+02 -1.2129600524902344e+01 2.3233799743652344e+02 -2.8109100341796875e+02 -1.2179500579833984e+01 2.3229501342773438e+02 -2.7729098510742188e+02 -1.2137000083923340e+01 2.3554000854492188e+02 -2.8109100341796875e+02 -1.2187000274658203e+01 2.3558399963378906e+02 -2.7729098510742188e+02 -1.1905699729919434e+01 2.3577299499511719e+02 -2.8109100341796875e+02 -1.1949500083923340e+01 2.3582299804687500e+02 -2.8039102172851562e+02 -1.0299400329589844e+01 2.2774299621582031e+02 -2.8039102172851562e+02 -8.3835096359252930e+00 2.2804699707031250e+02 -2.8039102172851562e+02 -4.0999999046325684e+00 2.3394400024414062e+02 -2.8039102172851562e+02 -4.4032602310180664e+00 2.3202799987792969e+02 -2.8039102172851562e+02 -5.2837400436401367e+00 2.3029899597167969e+02 -2.8039102172851562e+02 -6.6552400588989258e+00 2.2892799377441406e+02 -2.8039102172851562e+02 -1.6500000000000000e+01 2.3394299316406250e+02 -2.8039102172851562e+02 -1.6196699142456055e+01 2.3585798645019531e+02 -2.8039102172851562e+02 -1.5316300392150879e+01 2.3758700561523438e+02 -2.8039102172851562e+02 -1.3944800376892090e+01 2.3895899963378906e+02 -2.8039102172851562e+02 -1.2216500282287598e+01 2.3983900451660156e+02 -2.8039102172851562e+02 -1.0300600051879883e+01 2.4014300537109375e+02 -2.8039102172851562e+02 -8.3846702575683594e+00 2.3983999633789062e+02 -2.8039102172851562e+02 -6.6562199592590332e+00 2.3895899963378906e+02 -2.8039102172851562e+02 -5.2844500541687012e+00 2.3758799743652344e+02 -2.8039102172851562e+02 -4.4036402702331543e+00 2.3586000061035156e+02 -2.8039102172851562e+02 -1.2215300559997559e+01 2.2804600524902344e+02 -2.8039102172851562e+02 -1.3943799972534180e+01 2.2892700195312500e+02 -2.8039102172851562e+02 -1.5315500259399414e+01 2.3029800415039062e+02 -2.8039102172851562e+02 -1.6196399688720703e+01 2.3202699279785156e+02 -2.7959100341796875e+02 -7.2254600524902344e+00 2.3394900512695312e+02 -2.7959100341796875e+02 -7.3024597167968750e+00 2.3366198730468750e+02 -2.7959100341796875e+02 -7.3025197982788086e+00 2.3423699951171875e+02 -2.7959100341796875e+02 -7.5129098892211914e+00 2.3345098876953125e+02 -2.7959100341796875e+02 -8.2984504699707031e+00 2.3423699951171875e+02 -2.7959100341796875e+02 -8.0880107879638672e+00 2.3444700622558594e+02 -2.7959100341796875e+02 -7.8005099296569824e+00 2.3452400207519531e+02 -2.7959100341796875e+02 -7.8003997802734375e+00 2.3337399291992188e+02 -2.7959100341796875e+02 -8.0879096984863281e+00 2.3345098876953125e+02 -2.7959100341796875e+02 -8.2983894348144531e+00 2.3366198730468750e+02 -2.7959100341796875e+02 -8.3754606246948242e+00 2.3394900512695312e+02 -2.7959100341796875e+02 -7.5130100250244141e+00 2.3444700622558594e+02 -2.7959100341796875e+02 -1.0018699645996094e+01 2.3594599914550781e+02 -2.7959100341796875e+02 -1.0593700408935547e+01 2.3694198608398438e+02 -2.7959100341796875e+02 -1.0306299209594727e+01 2.3701899719238281e+02 -2.7959100341796875e+02 -1.0306099891662598e+01 2.3586900329589844e+02 -2.7959100341796875e+02 -1.0593700408935547e+01 2.3594599914550781e+02 -2.7959100341796875e+02 -9.8082094192504883e+00 2.3615600585937500e+02 -2.7959100341796875e+02 -9.7311992645263672e+00 2.3644400024414062e+02 -2.7959100341796875e+02 -9.8082599639892578e+00 2.3673098754882812e+02 -2.7959100341796875e+02 -1.0018699645996094e+01 2.3694198608398438e+02 -2.7959100341796875e+02 -1.0804199218750000e+01 2.3673098754882812e+02 -2.7959100341796875e+02 -1.0881200790405273e+01 2.3644400024414062e+02 -2.7959100341796875e+02 -1.0804100036621094e+01 2.3615600585937500e+02 -2.7959100341796875e+02 -1.3088000297546387e+01 2.3443600463867188e+02 -2.7959100341796875e+02 -1.2800499916076660e+01 2.3451300048828125e+02 -2.7959100341796875e+02 -1.2512900352478027e+01 2.3344000244140625e+02 -2.7959100341796875e+02 -1.2512999534606934e+01 2.3443600463867188e+02 -2.7959100341796875e+02 -1.2800399780273438e+01 2.3336300659179688e+02 -2.7959100341796875e+02 -1.3087900161743164e+01 2.3344000244140625e+02 -2.7959100341796875e+02 -1.3298399925231934e+01 2.3364999389648438e+02 -2.7959100341796875e+02 -1.2302499771118164e+01 2.3422500610351562e+02 -2.7959100341796875e+02 -1.2225399971008301e+01 2.3393798828125000e+02 -2.7959100341796875e+02 -1.2302399635314941e+01 2.3364999389648438e+02 -2.7959100341796875e+02 -1.3375399589538574e+01 2.3393798828125000e+02 -2.7959100341796875e+02 -1.3298399925231934e+01 2.3422500610351562e+02 -2.8064099121093750e+02 -1.0007200241088867e+01 2.3094599914550781e+02 -2.8064099121093750e+02 -1.0294600486755371e+01 2.3086898803710938e+02 -2.8064099121093750e+02 -1.0294799804687500e+01 2.3201901245117188e+02 -2.8064099121093750e+02 -1.0792699813842773e+01 2.3173100280761719e+02 -2.8064099121093750e+02 -1.0582200050354004e+01 2.3194200134277344e+02 -2.8064099121093750e+02 -1.0869700431823730e+01 2.3144400024414062e+02 -2.8064099121093750e+02 -1.0792599678039551e+01 2.3115600585937500e+02 -2.8064099121093750e+02 -1.0582099914550781e+01 2.3094599914550781e+02 -2.8064099121093750e+02 -9.7196998596191406e+00 2.3144400024414062e+02 -2.8064099121093750e+02 -9.7967100143432617e+00 2.3115600585937500e+02 -2.8064099121093750e+02 -9.7967596054077148e+00 2.3173100280761719e+02 -2.8064099121093750e+02 -1.0007200241088867e+01 2.3194200134277344e+02 -2.7729098510742188e+02 -8.7847404479980469e+00 2.3206500244140625e+02 -2.8109100341796875e+02 -8.7664098739624023e+00 2.3200199890136719e+02 -2.7729098510742188e+02 -8.8866205215454102e+00 2.3205900573730469e+02 -2.8109100341796875e+02 -8.8972091674804688e+00 2.3199400329589844e+02 -2.7729098510742188e+02 -8.9813899993896484e+00 2.3209700012207031e+02 -2.8109100341796875e+02 -9.0188703536987305e+00 2.3204299926757812e+02 -2.7729098510742188e+02 -9.0509500503540039e+00 2.3217199707031250e+02 -2.8109100341796875e+02 -9.1081905364990234e+00 2.3213800048828125e+02 -2.7729098510742188e+02 -1.1541799545288086e+01 2.3216600036621094e+02 -2.8109100341796875e+02 -1.1484400749206543e+01 2.3213299560546875e+02 -2.7729098510742188e+02 -1.1611000061035156e+01 2.3209098815917969e+02 -2.8109100341796875e+02 -1.1573299407958984e+01 2.3203698730468750e+02 -2.7729098510742188e+02 -1.1705599784851074e+01 2.3205299377441406e+02 -2.8109100341796875e+02 -1.1694700241088867e+01 2.3198699951171875e+02 -2.7729098510742188e+02 -1.1807500839233398e+01 2.3205900573730469e+02 -2.8109100341796875e+02 -1.1825500488281250e+01 2.3199499511718750e+02 -2.7729098510742188e+02 -8.4223403930664062e+00 2.3545899963378906e+02 -2.8109100341796875e+02 -8.3585901260375977e+00 2.3547799682617188e+02 -2.7729098510742188e+02 -8.4162397384643555e+00 2.3535699462890625e+02 -2.8109100341796875e+02 -8.3507595062255859e+00 2.3534700012207031e+02 -2.7729098510742188e+02 -8.4541406631469727e+00 2.3526300048828125e+02 -2.8109100341796875e+02 -8.3994207382202148e+00 2.3522500610351562e+02 -2.7729098510742188e+02 -8.5288200378417969e+00 2.3519299316406250e+02 -2.8109100341796875e+02 -8.4953002929687500e+00 2.3513600158691406e+02 -2.7729098510742188e+02 -8.5230894088745117e+00 2.3270199584960938e+02 -2.8109100341796875e+02 -8.4898395538330078e+00 2.3275999450683594e+02 -2.7729098510742188e+02 -8.4480905532836914e+00 2.3263299560546875e+02 -2.8109100341796875e+02 -8.3935499191284180e+00 2.3267098999023438e+02 -2.7729098510742188e+02 -8.4097499847412109e+00 2.3253799438476562e+02 -2.8109100341796875e+02 -8.3443193435668945e+00 2.3254899597167969e+02 -2.7729098510742188e+02 -8.4153795242309570e+00 2.3243699645996094e+02 -2.8109100341796875e+02 -8.3515501022338867e+00 2.3241799926757812e+02 -2.7729098510742188e+02 -1.1816200256347656e+01 2.3582200622558594e+02 -2.8109100341796875e+02 -1.1834500312805176e+01 2.3588499450683594e+02 -2.7729098510742188e+02 -1.1714300155639648e+01 2.3582800292968750e+02 -2.8109100341796875e+02 -1.1703700065612793e+01 2.3589299011230469e+02 -2.7729098510742188e+02 -1.1619500160217285e+01 2.3578999328613281e+02 -2.8109100341796875e+02 -1.1581999778747559e+01 2.3584500122070312e+02 -2.7729098510742188e+02 -1.1549900054931641e+01 2.3571499633789062e+02 -2.8109100341796875e+02 -1.1492700576782227e+01 2.3574900817871094e+02 -2.7729098510742188e+02 -9.0591096878051758e+00 2.3572100830078125e+02 -2.8109100341796875e+02 -9.1164999008178711e+00 2.3575399780273438e+02 -2.7729098510742188e+02 -8.9898900985717773e+00 2.3579600524902344e+02 -2.8109100341796875e+02 -9.0276298522949219e+00 2.3585000610351562e+02 -2.7729098510742188e+02 -8.8953094482421875e+00 2.3583399963378906e+02 -2.8109100341796875e+02 -8.9061994552612305e+00 2.3589999389648438e+02 -2.7729098510742188e+02 -8.7933998107910156e+00 2.3582899475097656e+02 -2.8109100341796875e+02 -8.7753601074218750e+00 2.3589199829101562e+02 -2.7729098510742188e+02 -9.5793399810791016e+00 2.3269499206542969e+02 -2.7729098510742188e+02 -1.0297999382019043e+01 2.3288500976562500e+02 -2.7729098510742188e+02 -1.1015799522399902e+01 2.3269200134277344e+02 -2.7729098510742188e+02 -9.0484304428100586e+00 2.3322799682617188e+02 -2.7729098510742188e+02 -9.2417802810668945e+00 2.3394599914550781e+02 -2.7729098510742188e+02 -9.0517301559448242e+00 2.3466500854492188e+02 -2.7729098510742188e+02 -9.5850896835327148e+00 2.3519599914550781e+02 -2.7729098510742188e+02 -1.0302900314331055e+01 2.3500199890136719e+02 -2.7729098510742188e+02 -1.1021599769592285e+01 2.3519200134277344e+02 -2.7729098510742188e+02 -1.1552499771118164e+01 2.3465899658203125e+02 -2.7729098510742188e+02 -1.2077799797058105e+01 2.3518499755859375e+02 -2.7729098510742188e+02 -1.2072100639343262e+01 2.3269400024414062e+02 -2.7729098510742188e+02 -1.1359100341796875e+01 2.3394100952148438e+02 -2.7729098510742188e+02 -1.1549200057983398e+01 2.3322200012207031e+02 -2.7729098510742188e+02 -1.2152800559997559e+01 2.3525399780273438e+02 -2.7729098510742188e+02 -1.2191100120544434e+01 2.3534899902343750e+02 -2.7729098510742188e+02 -1.2178600311279297e+01 2.3242799377441406e+02 -2.7729098510742188e+02 -1.2184700012207031e+01 2.3252999877929688e+02 -2.7729098510742188e+02 -1.2146800041198730e+01 2.3262500000000000e+02 -2.7729098510742188e+02 -1.2185500144958496e+01 2.3545100402832031e+02 -2.8109100341796875e+02 -1.2242300033569336e+01 2.3241000366210938e+02 -2.8109100341796875e+02 -1.2250100135803223e+01 2.3253999328613281e+02 -2.8109100341796875e+02 -1.2201499938964844e+01 2.3266200256347656e+02 -2.8109100341796875e+02 -1.2105600357055664e+01 2.3275099182128906e+02 -2.8109100341796875e+02 -1.2111100196838379e+01 2.3512800598144531e+02 -2.8109100341796875e+02 -1.2207400321960449e+01 2.3521600341796875e+02 -2.8109100341796875e+02 -1.2256600379943848e+01 2.3533799743652344e+02 -2.8109100341796875e+02 -1.2249300003051758e+01 2.3546899414062500e+02 -2.8019100952148438e+02 -4.5934801101684570e+00 2.3208999633789062e+02 -2.8019100952148438e+02 -5.4455499649047852e+00 2.3041699218750000e+02 -2.8019100952148438e+02 -6.7728099822998047e+00 2.2908900451660156e+02 -2.8019100952148438e+02 -8.4453401565551758e+00 2.2823699951171875e+02 -2.8019100952148438e+02 -1.0299400329589844e+01 2.2794300842285156e+02 -2.8019100952148438e+02 -1.2153499603271484e+01 2.2823699951171875e+02 -2.8019100952148438e+02 -1.3826199531555176e+01 2.2908900451660156e+02 -2.8019100952148438e+02 -1.5153800010681152e+01 2.3041600036621094e+02 -2.8019100952148438e+02 -1.6006198883056641e+01 2.3208799743652344e+02 -2.8019100952148438e+02 -1.6300001144409180e+01 2.3394299316406250e+02 -2.8019100952148438e+02 -1.6006500244140625e+01 2.3579699707031250e+02 -2.8019100952148438e+02 -1.5154399871826172e+01 2.3746900939941406e+02 -2.8019100952148438e+02 -1.3827199935913086e+01 2.3879699707031250e+02 -2.8019100952148438e+02 -1.2154700279235840e+01 2.3964900207519531e+02 -2.8019100952148438e+02 -1.0300600051879883e+01 2.3994299316406250e+02 -2.8019100952148438e+02 -8.4464597702026367e+00 2.3964999389648438e+02 -2.8019100952148438e+02 -6.7737698554992676e+00 2.3879800415039062e+02 -2.8019100952148438e+02 -5.4462399482727051e+00 2.3747000122070312e+02 -2.8019100952148438e+02 -4.5938396453857422e+00 2.3579800415039062e+02 -2.8019100952148438e+02 -4.3000001907348633e+00 2.3394400024414062e+02 -2.7331600952148438e+02 -1.3294300079345703e+01 2.3513400268554688e+02 -2.8229098510742188e+02 -1.3294300079345703e+01 2.3513400268554688e+02 -2.8229098510742188e+02 -1.3344099998474121e+01 2.3507400512695312e+02 -2.7331600952148438e+02 -1.3344099998474121e+01 2.3507400512695312e+02 -2.8229098510742188e+02 -1.3413099288940430e+01 2.3503700256347656e+02 -2.7331600952148438e+02 -1.3413099288940430e+01 2.3503700256347656e+02 -2.8229098510742188e+02 -1.3490799903869629e+01 2.3502999877929688e+02 -2.7331600952148438e+02 -1.3490799903869629e+01 2.3502999877929688e+02 -2.8229098510742188e+02 -1.3565400123596191e+01 2.3505300903320312e+02 -2.7331600952148438e+02 -1.3565400123596191e+01 2.3505300903320312e+02 -2.8229098510742188e+02 -1.2938000679016113e+01 2.3579399108886719e+02 -2.7331600952148438e+02 -1.2938000679016113e+01 2.3579399108886719e+02 -2.8149099731445312e+02 -7.2254600524902344e+00 2.3394900512695312e+02 -2.8149099731445312e+02 -7.3024597167968750e+00 2.3366198730468750e+02 -2.8149099731445312e+02 -7.5129098892211914e+00 2.3345098876953125e+02 -2.8149099731445312e+02 -7.8003997802734375e+00 2.3337399291992188e+02 -2.8149099731445312e+02 -8.0879096984863281e+00 2.3345098876953125e+02 -2.8149099731445312e+02 -8.2983894348144531e+00 2.3366198730468750e+02 -2.8149099731445312e+02 -8.3754606246948242e+00 2.3394900512695312e+02 -2.8149099731445312e+02 -8.2984504699707031e+00 2.3423699951171875e+02 -2.8149099731445312e+02 -8.0880107879638672e+00 2.3444700622558594e+02 -2.8149099731445312e+02 -7.8005099296569824e+00 2.3452400207519531e+02 -2.8149099731445312e+02 -7.5130100250244141e+00 2.3444700622558594e+02 -2.8149099731445312e+02 -7.3025197982788086e+00 2.3423699951171875e+02 -2.8149099731445312e+02 -9.7311992645263672e+00 2.3644400024414062e+02 -2.8149099731445312e+02 -9.8082094192504883e+00 2.3615600585937500e+02 -2.8149099731445312e+02 -1.0018699645996094e+01 2.3594599914550781e+02 -2.8149099731445312e+02 -1.0306099891662598e+01 2.3586900329589844e+02 -2.8149099731445312e+02 -1.0593700408935547e+01 2.3594599914550781e+02 -2.8149099731445312e+02 -1.0804100036621094e+01 2.3615600585937500e+02 -2.8149099731445312e+02 -1.0881200790405273e+01 2.3644400024414062e+02 -2.8149099731445312e+02 -1.0804199218750000e+01 2.3673098754882812e+02 -2.8149099731445312e+02 -1.0593700408935547e+01 2.3694198608398438e+02 -2.8149099731445312e+02 -1.0306299209594727e+01 2.3701899719238281e+02 -2.8149099731445312e+02 -1.0018699645996094e+01 2.3694198608398438e+02 -2.8149099731445312e+02 -9.8082599639892578e+00 2.3673098754882812e+02 -2.8149099731445312e+02 -1.2225399971008301e+01 2.3393798828125000e+02 -2.8149099731445312e+02 -1.2302399635314941e+01 2.3364999389648438e+02 -2.8149099731445312e+02 -1.2512900352478027e+01 2.3344000244140625e+02 -2.8149099731445312e+02 -1.2800399780273438e+01 2.3336300659179688e+02 -2.8149099731445312e+02 -1.3087900161743164e+01 2.3344000244140625e+02 -2.8149099731445312e+02 -1.3298399925231934e+01 2.3364999389648438e+02 -2.8149099731445312e+02 -1.3375399589538574e+01 2.3393798828125000e+02 -2.8149099731445312e+02 -1.3298399925231934e+01 2.3422500610351562e+02 -2.8149099731445312e+02 -1.3088000297546387e+01 2.3443600463867188e+02 -2.8149099731445312e+02 -1.2800499916076660e+01 2.3451300048828125e+02 -2.8149099731445312e+02 -1.2512999534606934e+01 2.3443600463867188e+02 -2.8149099731445312e+02 -1.2302499771118164e+01 2.3422500610351562e+02 -2.8149099731445312e+02 -9.7196998596191406e+00 2.3144400024414062e+02 -2.8149099731445312e+02 -9.7967100143432617e+00 2.3115600585937500e+02 -2.8149099731445312e+02 -1.0007200241088867e+01 2.3094599914550781e+02 -2.8149099731445312e+02 -1.0294600486755371e+01 2.3086898803710938e+02 -2.8149099731445312e+02 -1.0582099914550781e+01 2.3094599914550781e+02 -2.8149099731445312e+02 -1.0792599678039551e+01 2.3115600585937500e+02 -2.8149099731445312e+02 -1.0869700431823730e+01 2.3144400024414062e+02 -2.8149099731445312e+02 -1.0792699813842773e+01 2.3173100280761719e+02 -2.8149099731445312e+02 -1.0582200050354004e+01 2.3194200134277344e+02 -2.8149099731445312e+02 -1.0294799804687500e+01 2.3201901245117188e+02 -2.8149099731445312e+02 -1.0007200241088867e+01 2.3194200134277344e+02 -2.8149099731445312e+02 -9.7967596054077148e+00 2.3173100280761719e+02 -2.8109100341796875e+02 -9.6122608184814453e+00 2.3263700866699219e+02 -2.8109100341796875e+02 -1.0297900199890137e+01 2.3281900024414062e+02 -2.8109100341796875e+02 -1.0982600212097168e+01 2.3263398742675781e+02 -2.8109100341796875e+02 -8.9941501617431641e+00 2.3463200378417969e+02 -2.8109100341796875e+02 -9.1754493713378906e+00 2.3394599914550781e+02 -2.8109100341796875e+02 -8.9909896850585938e+00 2.3326100158691406e+02 -2.8109100341796875e+02 -1.0988599777221680e+01 2.3525000000000000e+02 -2.8109100341796875e+02 -1.0303000450134277e+01 2.3506900024414062e+02 -2.8109100341796875e+02 -9.6182699203491211e+00 2.3525300598144531e+02 -2.8109100341796875e+02 -1.1606800079345703e+01 2.3325500488281250e+02 -2.8109100341796875e+02 -1.1425399780273438e+01 2.3394100952148438e+02 -2.8109100341796875e+02 -1.1609899520874023e+01 2.3462599182128906e+02 -2.8019100952148438e+02 -1.6000000000000000e+01 2.3394299316406250e+02 -2.8019100952148438e+02 -1.5721199989318848e+01 2.3570500183105469e+02 -2.8019100952148438e+02 -1.4911700248718262e+01 2.3729400634765625e+02 -2.8019100952148438e+02 -1.3650799751281738e+01 2.3855499267578125e+02 -2.8019100952148438e+02 -1.2061900138854980e+01 2.3936499023437500e+02 -2.8019100952148438e+02 -1.0300600051879883e+01 2.3964401245117188e+02 -2.8019100952148438e+02 -8.5391407012939453e+00 2.3936499023437500e+02 -2.8019100952148438e+02 -6.9500799179077148e+00 2.3855499267578125e+02 -2.8019100952148438e+02 -5.6889300346374512e+00 2.3729499816894531e+02 -2.8019100952148438e+02 -4.8791499137878418e+00 2.3570600891113281e+02 -2.8019100952148438e+02 -4.5999999046325684e+00 2.3394400024414062e+02 -2.8019100952148438e+02 -4.8787999153137207e+00 2.3218299865722656e+02 -2.8019100952148438e+02 -5.6882700920104980e+00 2.3059399414062500e+02 -2.8019100952148438e+02 -6.9491701126098633e+00 2.2933299255371094e+02 -2.8019100952148438e+02 -8.5380697250366211e+00 2.2852299499511719e+02 -2.8019100952148438e+02 -1.0299400329589844e+01 2.2824400329589844e+02 -2.8019100952148438e+02 -1.2060900688171387e+01 2.2852299499511719e+02 -2.8019100952148438e+02 -1.3649900436401367e+01 2.2933200073242188e+02 -2.8019100952148438e+02 -1.4911100387573242e+01 2.3059300231933594e+02 -2.8019100952148438e+02 -1.5720799446105957e+01 2.3218199157714844e+02 -2.8216699218750000e+02 -1.4062900543212891e+01 2.3532199096679688e+02 -2.8213302612304688e+02 -1.4074999809265137e+01 2.3532800292968750e+02 -2.7331600952148438e+02 -1.4062000274658203e+01 2.3532099914550781e+02 -2.7343402099609375e+02 -1.4078999519348145e+01 2.3533000183105469e+02 -2.8209100341796875e+02 -1.4078999519348145e+01 2.3533000183105469e+02 -2.8219598388671875e+02 -1.4052899360656738e+01 2.3531599426269531e+02 -2.8224700927734375e+02 -1.4013199806213379e+01 2.3529499816894531e+02 -2.8227600097656250e+02 -1.3967400550842285e+01 2.3526998901367188e+02 -2.8229098510742188e+02 -1.3901099205017090e+01 2.3523400878906250e+02 -2.8227999877929688e+02 -1.3960500717163086e+01 2.3526600646972656e+02 -2.7331600952148438e+02 -1.3018899917602539e+01 2.3606500244140625e+02 -2.8229098510742188e+02 -1.3018899917602539e+01 2.3606500244140625e+02 -2.8229098510742188e+02 -1.2943699836730957e+01 2.3599400329589844e+02 -2.7331600952148438e+02 -1.2943699836730957e+01 2.3599400329589844e+02 -2.8229098510742188e+02 -1.2914099693298340e+01 2.3589498901367188e+02 -2.7331600952148438e+02 -1.2914099693298340e+01 2.3589498901367188e+02 -2.8149099731445312e+02 -8.5504608154296875e+00 2.3394900512695312e+02 -2.8149099731445312e+02 -8.4500102996826172e+00 2.3432398986816406e+02 -2.8149099731445312e+02 -8.1755199432373047e+00 2.3459899902343750e+02 -2.8149099731445312e+02 -7.8005299568176270e+00 2.3469898986816406e+02 -2.8149099731445312e+02 -7.4255199432373047e+00 2.3459899902343750e+02 -2.8149099731445312e+02 -7.1509699821472168e+00 2.3432398986816406e+02 -2.8149099731445312e+02 -7.0504603385925293e+00 2.3394900512695312e+02 -2.8149099731445312e+02 -7.1508998870849609e+00 2.3357400512695312e+02 -2.8149099731445312e+02 -7.4253902435302734e+00 2.3330000305175781e+02 -2.8149099731445312e+02 -7.8003797531127930e+00 2.3319900512695312e+02 -2.8149099731445312e+02 -8.1753902435302734e+00 2.3330000305175781e+02 -2.8149099731445312e+02 -8.4499397277832031e+00 2.3357400512695312e+02 -2.8149099731445312e+02 -9.9312601089477539e+00 2.3709300231933594e+02 -2.8149099731445312e+02 -9.6567201614379883e+00 2.3681900024414062e+02 -2.8149099731445312e+02 -9.5562000274658203e+00 2.3644400024414062e+02 -2.8149099731445312e+02 -9.6566400527954102e+00 2.3606900024414062e+02 -2.8149099731445312e+02 -9.9311399459838867e+00 2.3579399108886719e+02 -2.8149099731445312e+02 -1.0306099891662598e+01 2.3569400024414062e+02 -2.8149099731445312e+02 -1.0681099891662598e+01 2.3579399108886719e+02 -2.8149099731445312e+02 -1.0955699920654297e+01 2.3606900024414062e+02 -2.8149099731445312e+02 -1.1056200027465820e+01 2.3644400024414062e+02 -2.8149099731445312e+02 -1.0955800056457520e+01 2.3681900024414062e+02 -2.8149099731445312e+02 -1.0681300163269043e+01 2.3709300231933594e+02 -2.8149099731445312e+02 -1.0306299209594727e+01 2.3719400024414062e+02 -2.8149099731445312e+02 -1.2425499916076660e+01 2.3458700561523438e+02 -2.8149099731445312e+02 -1.2151000022888184e+01 2.3431300354003906e+02 -2.8149099731445312e+02 -1.2050399780273438e+01 2.3393798828125000e+02 -2.8149099731445312e+02 -1.2150900840759277e+01 2.3356300354003906e+02 -2.8149099731445312e+02 -1.2425400733947754e+01 2.3328800964355469e+02 -2.8149099731445312e+02 -1.2800399780273438e+01 2.3318800354003906e+02 -2.8149099731445312e+02 -1.3175399780273438e+01 2.3328800964355469e+02 -2.8149099731445312e+02 -1.3449899673461914e+01 2.3356300354003906e+02 -2.8149099731445312e+02 -1.3550399780273438e+01 2.3393798828125000e+02 -2.8149099731445312e+02 -1.3450000762939453e+01 2.3431300354003906e+02 -2.8149099731445312e+02 -1.3175499916076660e+01 2.3458700561523438e+02 -2.8149099731445312e+02 -1.2800499916076660e+01 2.3468800354003906e+02 -2.8149099731445312e+02 -1.0669800758361816e+01 2.3209300231933594e+02 -2.8149099731445312e+02 -1.0294799804687500e+01 2.3219400024414062e+02 -2.8149099731445312e+02 -9.9197597503662109e+00 2.3209300231933594e+02 -2.8149099731445312e+02 -9.6452198028564453e+00 2.3181900024414062e+02 -2.8149099731445312e+02 -9.5447006225585938e+00 2.3144400024414062e+02 -2.8149099731445312e+02 -9.6451396942138672e+00 2.3106900024414062e+02 -2.8149099731445312e+02 -9.9196395874023438e+00 2.3079399108886719e+02 -2.8149099731445312e+02 -1.0294600486755371e+01 2.3069400024414062e+02 -2.8149099731445312e+02 -1.0669600486755371e+01 2.3079399108886719e+02 -2.8149099731445312e+02 -1.0944199562072754e+01 2.3106900024414062e+02 -2.8149099731445312e+02 -1.1044699668884277e+01 2.3144400024414062e+02 -2.8149099731445312e+02 -1.0944300651550293e+01 2.3181900024414062e+02 -2.8109100341796875e+02 -8.9392900466918945e+00 2.3350900268554688e+02 -2.8109100341796875e+02 -9.0072708129882812e+00 2.3413499450683594e+02 -2.8109100341796875e+02 -8.7548799514770508e+00 2.3471101379394531e+02 -2.8109100341796875e+02 -7.8686194419860840e+00 2.3268899536132812e+02 -2.8109100341796875e+02 -7.7838602066040039e+00 2.3258100891113281e+02 -2.8109100341796875e+02 -7.9946603775024414e+00 2.3274398803710938e+02 -2.8109100341796875e+02 -8.5689897537231445e+00 2.3300099182128906e+02 -2.8109100341796875e+02 -1.0592900276184082e+01 2.3525700378417969e+02 -2.8109100341796875e+02 -1.0013999938964844e+01 2.3525799560546875e+02 -2.8109100341796875e+02 -9.5007801055908203e+00 2.3552600097656250e+02 -2.8109100341796875e+02 -1.1928100585937500e+01 2.3144799804687500e+02 -2.8109100341796875e+02 -1.1798099517822266e+01 2.3140400695800781e+02 -2.8109100341796875e+02 -1.1662700653076172e+01 2.3142700195312500e+02 -2.8109100341796875e+02 -1.1554599761962891e+01 2.3151199340820312e+02 -2.8109100341796875e+02 -1.1849500656127930e+01 2.3470401000976562e+02 -2.8109100341796875e+02 -1.2357000350952148e+01 2.3507499694824219e+02 -2.8109100341796875e+02 -1.2460800170898438e+01 2.3514599609375000e+02 -2.8109100341796875e+02 -1.2833099365234375e+01 2.3243400573730469e+02 -2.8109100341796875e+02 -1.1107399940490723e+01 2.3552200317382812e+02 -2.8109100341796875e+02 -1.1441699981689453e+01 2.3599499511718750e+02 -2.8109100341796875e+02 -1.1513099670410156e+01 2.3609800720214844e+02 -2.8109100341796875e+02 -1.2522999763488770e+01 2.3525599670410156e+02 -2.8109100341796875e+02 -1.2531000137329102e+01 2.3538101196289062e+02 -2.8109100341796875e+02 -1.2482999801635742e+01 2.3549699401855469e+02 -2.8109100341796875e+02 -9.0977506637573242e+00 2.3610400390625000e+02 -2.8109100341796875e+02 -9.1686296463012695e+00 2.3600000000000000e+02 -2.8109100341796875e+02 -1.2788100242614746e+01 2.3230500793457031e+02 -2.8109100341796875e+02 -1.1864099502563477e+01 2.3611900329589844e+02 -2.8109100341796875e+02 -1.1748099327087402e+01 2.3616699218750000e+02 -2.8109100341796875e+02 -1.1622600555419922e+01 2.3615998840332031e+02 -2.8109100341796875e+02 -7.8053302764892578e+00 2.3231600952148438e+02 -2.8109100341796875e+02 -7.7609100341796875e+00 2.3244599914550781e+02 -2.8109100341796875e+02 -1.1594500541687012e+01 2.3412899780273438e+02 -2.8109100341796875e+02 -1.1659600257873535e+01 2.3350300598144531e+02 -2.8109100341796875e+02 -1.2027600288391113e+01 2.3299301147460938e+02 -2.8109100341796875e+02 -1.2600700378417969e+01 2.3273300170898438e+02 -2.8109100341796875e+02 -1.2726499557495117e+01 2.3267799377441406e+02 -2.8109100341796875e+02 -1.2810699462890625e+01 2.3257000732421875e+02 -2.8109100341796875e+02 -8.2491197586059570e+00 2.3508499145507812e+02 -2.8109100341796875e+02 -8.1456098556518555e+00 2.3515600585937500e+02 -2.8109100341796875e+02 -8.9884901046752930e+00 2.3616600036621094e+02 -2.8109100341796875e+02 -8.8630104064941406e+00 2.3617399597167969e+02 -2.8109100341796875e+02 -8.7468004226684570e+00 2.3612600708007812e+02 -2.8109100341796875e+02 -1.1500100135803223e+01 2.3163800048828125e+02 -2.8109100341796875e+02 -1.1281700134277344e+01 2.3216200256347656e+02 -2.8109100341796875e+02 -1.0849699974060059e+01 2.3253099060058594e+02 -2.8109100341796875e+02 -1.0297499656677246e+01 2.3266500854492188e+02 -2.8109100341796875e+02 -9.7447099685668945e+00 2.3253401184082031e+02 -2.8109100341796875e+02 -9.3109703063964844e+00 2.3216700744628906e+02 -2.8109100341796875e+02 -9.0902004241943359e+00 2.3164300537109375e+02 -2.8109100341796875e+02 -9.0350904464721680e+00 2.3151800537109375e+02 -2.8109100341796875e+02 -8.9266405105590820e+00 2.3143299865722656e+02 -2.8109100341796875e+02 -8.1250801086425781e+00 2.3550700378417969e+02 -2.8109100341796875e+02 -8.0765800476074219e+00 2.3539100646972656e+02 -2.8109100341796875e+02 -8.0839195251464844e+00 2.3526600646972656e+02 -2.8109100341796875e+02 -8.7911195755004883e+00 2.3141099548339844e+02 -2.8109100341796875e+02 -8.6613693237304688e+00 2.3145599365234375e+02 -2.7989102172851562e+02 -5.2045497894287109e+00 2.3569200134277344e+02 -2.7989102172851562e+02 -5.9316201210021973e+00 2.3711801147460938e+02 -2.7989102172851562e+02 -6.0566501617431641e+00 2.3724299621582031e+02 -2.7989102172851562e+02 -7.1263899803161621e+00 2.3831300354003906e+02 -2.7989102172851562e+02 -7.3629598617553711e+00 2.3843299865722656e+02 -2.7989102172851562e+02 -8.6318092346191406e+00 2.3908000183105469e+02 -2.7989102172851562e+02 -8.9818000793457031e+00 2.3913499450683594e+02 -2.7989102172851562e+02 -1.0300499916076660e+01 2.3934399414062500e+02 -2.7989102172851562e+02 -1.0738399505615234e+01 2.3927400207519531e+02 -2.7989102172851562e+02 -1.1969200134277344e+01 2.3907899475097656e+02 -2.7989102172851562e+02 -1.2443600654602051e+01 2.3883799743652344e+02 -2.7989102172851562e+02 -1.3474499702453613e+01 2.3831201171875000e+02 -2.7989102172851562e+02 -1.3914000511169434e+01 2.3787300109863281e+02 -2.7989102172851562e+02 -1.4669000625610352e+01 2.3711700439453125e+02 -2.7989102172851562e+02 -1.4991700172424316e+01 2.3648400878906250e+02 -2.7989102172851562e+02 -1.5435899734497070e+01 2.3561199951171875e+02 -2.7989102172851562e+02 -1.5561000823974609e+01 2.3482200622558594e+02 -2.7989102172851562e+02 -1.5699999809265137e+01 2.3394299316406250e+02 -2.7989102172851562e+02 -1.5560800552368164e+01 2.3306498718261719e+02 -2.7989102172851562e+02 -1.5435500144958496e+01 2.3227499389648438e+02 -2.7989102172851562e+02 -1.4991199493408203e+01 2.3140299987792969e+02 -2.7989102172851562e+02 -1.4668400764465332e+01 2.3076899719238281e+02 -2.7989102172851562e+02 -1.3913200378417969e+01 2.3001399230957031e+02 -2.7989102172851562e+02 -1.3473600387573242e+01 2.2957499694824219e+02 -2.7989102172851562e+02 -1.2442600250244141e+01 2.2905000305175781e+02 -2.7989102172851562e+02 -1.1968199729919434e+01 2.2880799865722656e+02 -2.7989102172851562e+02 -1.0737299919128418e+01 2.2861300659179688e+02 -2.7989102172851562e+02 -1.0299500465393066e+01 2.2854399108886719e+02 -2.7989102172851562e+02 -8.9807796478271484e+00 2.2875300598144531e+02 -2.7989102172851562e+02 -8.6308002471923828e+00 2.2880799865722656e+02 -2.7989102172851562e+02 -7.3620796203613281e+00 2.2945498657226562e+02 -2.7989102172851562e+02 -7.1255297660827637e+00 2.2957499694824219e+02 -2.7989102172851562e+02 -6.0560002326965332e+00 2.3064500427246094e+02 -2.7989102172851562e+02 -5.9310002326965332e+00 2.3077000427246094e+02 -2.7989102172851562e+02 -5.2042102813720703e+00 2.3219700622558594e+02 -2.7989102172851562e+02 -5.1641302108764648e+00 2.3227598571777344e+02 -2.7989102172851562e+02 -4.9000000953674316e+00 2.3394400024414062e+02 -2.7989102172851562e+02 -5.1644597053527832e+00 2.3561300659179688e+02 -2.7343402099609375e+02 -1.4189000129699707e+01 2.3471101379394531e+02 -2.8209100341796875e+02 -1.4300700187683105e+01 2.3438900756835938e+02 -2.7343402099609375e+02 -1.4325400352478027e+01 2.3394200134277344e+02 -2.7343402099609375e+02 -1.4323499679565430e+01 2.3392300415039062e+02 -2.8209100341796875e+02 -1.4291199684143066e+01 2.3392300415039062e+02 -2.7343402099609375e+02 -1.4247900009155273e+01 2.3315699768066406e+02 -2.8209100341796875e+02 -1.4279199600219727e+01 2.3333500671386719e+02 -2.7343402099609375e+02 -1.4054399490356445e+01 2.3252000427246094e+02 -2.8209100341796875e+02 -1.4043100357055664e+01 2.3252299499511719e+02 -2.7343402099609375e+02 -1.4018599510192871e+01 2.3240199279785156e+02 -2.8209100341796875e+02 -1.3984899520874023e+01 2.3232301330566406e+02 -2.7343402099609375e+02 -1.3646500587463379e+01 2.3170599365234375e+02 -2.8209100341796875e+02 -1.3437899589538574e+01 2.3142201232910156e+02 -2.7343402099609375e+02 -1.3314999580383301e+01 2.3130300903320312e+02 -2.8209100341796875e+02 -1.3315499305725098e+01 2.3130500793457031e+02 -2.7343402099609375e+02 -1.3145700454711914e+01 2.3109700012207031e+02 -2.7343402099609375e+02 -1.2535699844360352e+01 2.3059600830078125e+02 -2.8209100341796875e+02 -1.2675700187683105e+01 2.3069400024414062e+02 -2.7343402099609375e+02 -1.2201600074768066e+01 2.3041799926757812e+02 -2.8209100341796875e+02 -1.2194099426269531e+01 2.3043099975585938e+02 -2.7343402099609375e+02 -1.1839699745178223e+01 2.3022499084472656e+02 -2.8209100341796875e+02 -1.1750699996948242e+01 2.3018899536132812e+02 -2.7343402099609375e+02 -1.1084600448608398e+01 2.2999600219726562e+02 -2.8209100341796875e+02 -1.0848700523376465e+01 2.2997100830078125e+02 -2.7343402099609375e+02 -1.0850500106811523e+01 2.2997300720214844e+02 -2.8209100341796875e+02 -9.4311304092407227e+00 2.3003900146484375e+02 -2.7343402099609375e+02 -9.5140895843505859e+00 2.2999600219726562e+02 -2.8209100341796875e+02 -9.6724300384521484e+00 2.2996800231933594e+02 -2.7343402099609375e+02 -1.0299300193786621e+01 2.2991900634765625e+02 -2.8209100341796875e+02 -1.0726099967956543e+01 2.2994099426269531e+02 -2.8209100341796875e+02 -7.0694499015808105e+00 2.3155300903320312e+02 -2.7343402099609375e+02 -7.4535398483276367e+00 2.3109799194335938e+02 -2.8209100341796875e+02 -7.7635197639465332e+00 2.3081900024414062e+02 -2.7343402099609375e+02 -8.0633306503295898e+00 2.3059800720214844e+02 -2.8209100341796875e+02 -8.1237602233886719e+00 2.3059800720214844e+02 -2.7343402099609375e+02 -8.1085596084594727e+00 2.3057299804687500e+02 -2.8209100341796875e+02 -8.6617898941040039e+00 2.3026699829101562e+02 -2.7343402099609375e+02 -8.7590894699096680e+00 2.3022499084472656e+02 -2.7343402099609375e+02 -9.4262800216674805e+00 2.3002299499511719e+02 -2.7343402099609375e+02 -6.2873096466064453e+00 2.3425199890136719e+02 -2.7343402099609375e+02 -6.2808499336242676e+00 2.3408499145507812e+02 -2.8209100341796875e+02 -6.2873096466064453e+00 2.3425199890136719e+02 -2.7343402099609375e+02 -6.2754497528076172e+00 2.3394499206542969e+02 -2.8209100341796875e+02 -6.2959499359130859e+00 2.3353799438476562e+02 -2.7343402099609375e+02 -6.3525700569152832e+00 2.3315901184082031e+02 -2.8209100341796875e+02 -6.4616799354553223e+00 2.3283700561523438e+02 -2.7343402099609375e+02 -6.4506297111511230e+00 2.3283599853515625e+02 -2.8209100341796875e+02 -6.5385999679565430e+00 2.3251199340820312e+02 -2.7343402099609375e+02 -6.5813999176025391e+00 2.3240399169921875e+02 -2.8209100341796875e+02 -7.0392398834228516e+00 2.3158499145507812e+02 -2.7343402099609375e+02 -6.9531497955322266e+00 2.3170800781250000e+02 -2.7343402099609375e+02 -7.0765500068664551e+00 2.3155799865722656e+02 -2.8209100341796875e+02 -1.3532600402832031e+01 2.3634199523925781e+02 -2.8213302612304688e+02 -1.3528600692749023e+01 2.3633999633789062e+02 -2.8216699218750000e+02 -1.3516499519348145e+01 2.3633399963378906e+02 -2.8219598388671875e+02 -1.3506400108337402e+01 2.3632800292968750e+02 -2.7343402099609375e+02 -1.3532600402832031e+01 2.3634199523925781e+02 -2.7331600952148438e+02 -1.3515600204467773e+01 2.3633299255371094e+02 -2.8227999877929688e+02 -1.3414099693298340e+01 2.3627799987792969e+02 -2.8229098510742188e+02 -1.3354700088500977e+01 2.3624600219726562e+02 -2.8227600097656250e+02 -1.3420999526977539e+01 2.3628201293945312e+02 -2.8224700927734375e+02 -1.3466799736022949e+01 2.3630699157714844e+02 -2.8222201538085938e+02 -6.3405299186706543e+00 2.3430499267578125e+02 -2.8226199340820312e+02 -6.3926296234130859e+00 2.3435699462890625e+02 -2.8227099609375000e+02 -6.4287300109863281e+00 2.3439300537109375e+02 -2.8212899780273438e+02 -6.2911901473999023e+00 2.3425599670410156e+02 -2.8229098510742188e+02 -7.3868503570556641e+00 2.3534700012207031e+02 -2.8216799926757812e+02 -6.3047599792480469e+00 2.3427000427246094e+02 -2.8229098510742188e+02 -6.5127902030944824e+00 2.3447700500488281e+02 -2.7331600952148438e+02 -7.3868503570556641e+00 2.3534700012207031e+02 -2.7331600952148438e+02 -6.3080801963806152e+00 2.3427299499511719e+02 -2.8217398071289062e+02 -6.3068199157714844e+00 2.3427200317382812e+02 -2.8209100341796875e+02 -1.1335999488830566e+01 2.3779499816894531e+02 -2.8209100341796875e+02 -1.0815999984741211e+01 2.3793501281738281e+02 -2.8216799926757812e+02 -1.0814000129699707e+01 2.3791999816894531e+02 -2.8217398071289062e+02 -9.9906702041625977e+00 2.3793899536132812e+02 -2.8222201538085938e+02 -9.9569501876831055e+00 2.3790499877929688e+02 -2.8223400878906250e+02 -1.0808400154113770e+01 2.3787699890136719e+02 -2.8227697753906250e+02 -1.0800000190734863e+01 2.3781199645996094e+02 -2.8226199340820312e+02 -9.9048500061035156e+00 2.3785301208496094e+02 -2.8227099609375000e+02 -9.8687505722045898e+00 2.3781700134277344e+02 -2.8209100341796875e+02 -1.0010199546813965e+01 2.3795799255371094e+02 -2.8212899780273438e+02 -1.0006299972534180e+01 2.3795401000976562e+02 -2.8216799926757812e+02 -9.9927196502685547e+00 2.3794099426269531e+02 -2.8216799926757812e+02 -1.2786099433898926e+01 2.3709001159667969e+02 -2.8223400878906250e+02 -1.2758900642395020e+01 2.3705500793457031e+02 -2.8227697753906250e+02 -1.2718299865722656e+01 2.3700399780273438e+02 -2.8229098510742188e+02 -1.2671600341796875e+01 2.3694500732421875e+02 -2.8229098510742188e+02 -1.2989300727844238e+01 2.3661999511718750e+02 -2.8229098510742188e+02 -9.7846899032592773e+00 2.3773400878906250e+02 -2.8229098510742188e+02 -1.0790400505065918e+01 2.3773699951171875e+02 -2.8229098510742188e+02 -1.1784800529479980e+01 2.3746900939941406e+02 -2.8216799926757812e+02 -1.1856499671936035e+01 2.3763899230957031e+02 -2.8223400878906250e+02 -1.1839400291442871e+01 2.3759899902343750e+02 -2.8227697753906250e+02 -1.1814000129699707e+01 2.3753799438476562e+02 -2.8209100341796875e+02 -1.1862400054931641e+01 2.3765299987792969e+02 -2.8209100341796875e+02 -1.2550299644470215e+01 2.3724700927734375e+02 -2.8209100341796875e+02 -1.2795599937438965e+01 2.3710200500488281e+02 -2.8216799926757812e+02 -1.3425899505615234e+01 2.3143200683593750e+02 -2.8216799926757812e+02 -1.4285399436950684e+01 2.3438699340820312e+02 -2.8229098510742188e+02 -7.6120100021362305e+00 2.3126699829101562e+02 -2.8229098510742188e+02 -7.2012901306152344e+00 2.3170199584960938e+02 -2.8227697753906250e+02 -7.1403298377990723e+00 2.3165798950195312e+02 -2.8227697753906250e+02 -1.4176700592041016e+01 2.3437500000000000e+02 -2.8223400878906250e+02 -1.4241799354553223e+01 2.3438299560546875e+02 -2.8216799926757812e+02 -6.3112802505493164e+00 2.3353900146484375e+02 -2.8223400878906250e+02 -6.3548998832702637e+00 2.3354400634765625e+02 -2.8227697753906250e+02 -6.4200897216796875e+00 2.3355000305175781e+02 -2.8229098510742188e+02 -6.4949297904968262e+00 2.3355799865722656e+02 -2.8229098510742188e+02 -6.7255301475524902e+00 2.3258300781250000e+02 -2.8227697753906250e+02 -6.6552200317382812e+00 2.3255599975585938e+02 -2.8227697753906250e+02 -9.6918992996215820e+00 2.3009100341796875e+02 -2.8229098510742188e+02 -9.7036294937133789e+00 2.3016500854492188e+02 -2.8229098510742188e+02 -8.7432098388671875e+00 2.3044999694824219e+02 -2.8229098510742188e+02 -1.0704999923706055e+01 2.3013999938964844e+02 -2.8227697753906250e+02 -1.0712900161743164e+01 2.3006500244140625e+02 -2.8223400878906250e+02 -9.6816701889038086e+00 2.3002600097656250e+02 -2.8229098510742188e+02 -1.2976200103759766e+01 2.3125498962402344e+02 -2.8229098510742188e+02 -1.2557700157165527e+01 2.3085600280761719e+02 -2.8227697753906250e+02 -1.2602100372314453e+01 2.3079499816894531e+02 -2.8229098510742188e+02 -1.1678599357604980e+01 2.3037500000000000e+02 -2.8227697753906250e+02 -1.3340600013732910e+01 2.3150000000000000e+02 -2.8229098510742188e+02 -1.3282000541687012e+01 2.3154798889160156e+02 -2.8227697753906250e+02 -1.3870699882507324e+01 2.3237300109863281e+02 -2.8229098510742188e+02 -1.3801799774169922e+01 2.3240399169921875e+02 -2.8229098510742188e+02 -1.4081499099731445e+01 2.3336599731445312e+02 -2.8229098510742188e+02 -1.4101900100708008e+01 2.3436700439453125e+02 -2.8216799926757812e+02 -1.4263999938964844e+01 2.3333799743652344e+02 -2.8223400878906250e+02 -1.4220699310302734e+01 2.3334400939941406e+02 -2.8227697753906250e+02 -1.4155900001525879e+01 2.3335400390625000e+02 -2.8216799926757812e+02 -8.6680603027343750e+00 2.3028099060058594e+02 -2.8223400878906250e+02 -8.6859102249145508e+00 2.3032099914550781e+02 -2.8227697753906250e+02 -8.7125806808471680e+00 2.3038099670410156e+02 -2.8229098510742188e+02 -7.8895797729492188e+00 2.3097399902343750e+02 -2.8223400878906250e+02 -6.5939798355102539e+00 2.3253298950195312e+02 -2.8216799926757812e+02 -1.0724499702453613e+01 2.2995599365234375e+02 -2.8216799926757812e+02 -1.1745100021362305e+01 2.3020300292968750e+02 -2.8223400878906250e+02 -1.1729299545288086e+01 2.3024400329589844e+02 -2.8216799926757812e+02 -9.6748304367065430e+00 2.2998300170898438e+02 -2.8223400878906250e+02 -1.0719900131225586e+01 2.3000000000000000e+02 -2.8227697753906250e+02 -1.1705699920654297e+01 2.3030500793457031e+02 -2.8216799926757812e+02 -7.0517196655273438e+00 2.3159399414062500e+02 -2.8216799926757812e+02 -7.7732300758361816e+00 2.3083099365234375e+02 -2.8223400878906250e+02 -7.8008699417114258e+00 2.3086500549316406e+02 -2.8216799926757812e+02 -6.5529999732971191e+00 2.3251800537109375e+02 -2.8223400878906250e+02 -7.0872402191162109e+00 2.3161900329589844e+02 -2.8227697753906250e+02 -7.8421702384948730e+00 2.3091600036621094e+02 -2.8216799926757812e+02 -1.3970799446105957e+01 2.3232899475097656e+02 -2.8223400878906250e+02 -1.3930699348449707e+01 2.3234700012207031e+02 -2.8223400878906250e+02 -1.3391699790954590e+01 2.3145899963378906e+02 -2.8223400878906250e+02 -1.2640800476074219e+01 2.3074198913574219e+02 -2.8216799926757812e+02 -1.2666600227355957e+01 2.3070700073242188e+02 -2.8229098510742188e+02 -7.0504603385925293e+00 2.3394900512695312e+02 -2.8229098510742188e+02 -7.1508998870849609e+00 2.3357400512695312e+02 -2.8229098510742188e+02 -7.4253902435302734e+00 2.3330000305175781e+02 -2.8229098510742188e+02 -7.8003797531127930e+00 2.3319900512695312e+02 -2.8229098510742188e+02 -8.1753902435302734e+00 2.3330000305175781e+02 -2.8229098510742188e+02 -8.4499397277832031e+00 2.3357400512695312e+02 -2.8229098510742188e+02 -8.5504608154296875e+00 2.3394900512695312e+02 -2.8229098510742188e+02 -8.4500102996826172e+00 2.3432398986816406e+02 -2.8229098510742188e+02 -8.1755199432373047e+00 2.3459899902343750e+02 -2.8229098510742188e+02 -7.8005299568176270e+00 2.3469898986816406e+02 -2.8229098510742188e+02 -7.4255199432373047e+00 2.3459899902343750e+02 -2.8229098510742188e+02 -7.1509699821472168e+00 2.3432398986816406e+02 -2.8229098510742188e+02 -9.5562000274658203e+00 2.3644400024414062e+02 -2.8229098510742188e+02 -9.6566400527954102e+00 2.3606900024414062e+02 -2.8229098510742188e+02 -9.9311399459838867e+00 2.3579399108886719e+02 -2.8229098510742188e+02 -1.0306099891662598e+01 2.3569400024414062e+02 -2.8229098510742188e+02 -1.0681099891662598e+01 2.3579399108886719e+02 -2.8229098510742188e+02 -1.0955699920654297e+01 2.3606900024414062e+02 -2.8229098510742188e+02 -1.1056200027465820e+01 2.3644400024414062e+02 -2.8229098510742188e+02 -1.0955800056457520e+01 2.3681900024414062e+02 -2.8229098510742188e+02 -1.0681300163269043e+01 2.3709300231933594e+02 -2.8229098510742188e+02 -1.0306299209594727e+01 2.3719400024414062e+02 -2.8229098510742188e+02 -9.9312601089477539e+00 2.3709300231933594e+02 -2.8229098510742188e+02 -9.6567201614379883e+00 2.3681900024414062e+02 -2.8229098510742188e+02 -1.2050399780273438e+01 2.3393798828125000e+02 -2.8229098510742188e+02 -1.2150900840759277e+01 2.3356300354003906e+02 -2.8229098510742188e+02 -1.2425400733947754e+01 2.3328800964355469e+02 -2.8229098510742188e+02 -1.2800399780273438e+01 2.3318800354003906e+02 -2.8229098510742188e+02 -1.3175399780273438e+01 2.3328800964355469e+02 -2.8229098510742188e+02 -1.3449899673461914e+01 2.3356300354003906e+02 -2.8229098510742188e+02 -1.3550399780273438e+01 2.3393798828125000e+02 -2.8229098510742188e+02 -1.3450000762939453e+01 2.3431300354003906e+02 -2.8229098510742188e+02 -1.3175499916076660e+01 2.3458700561523438e+02 -2.8229098510742188e+02 -1.2800499916076660e+01 2.3468800354003906e+02 -2.8229098510742188e+02 -1.2425499916076660e+01 2.3458700561523438e+02 -2.8229098510742188e+02 -1.2151000022888184e+01 2.3431300354003906e+02 -2.8229098510742188e+02 -9.5447006225585938e+00 2.3144400024414062e+02 -2.8229098510742188e+02 -9.6451396942138672e+00 2.3106900024414062e+02 -2.8229098510742188e+02 -9.9196395874023438e+00 2.3079399108886719e+02 -2.8229098510742188e+02 -1.0294600486755371e+01 2.3069400024414062e+02 -2.8229098510742188e+02 -1.0669600486755371e+01 2.3079399108886719e+02 -2.8229098510742188e+02 -1.0944199562072754e+01 2.3106900024414062e+02 -2.8229098510742188e+02 -1.1044699668884277e+01 2.3144400024414062e+02 -2.8229098510742188e+02 -1.0944300651550293e+01 2.3181900024414062e+02 -2.8229098510742188e+02 -1.0669800758361816e+01 2.3209300231933594e+02 -2.8229098510742188e+02 -1.0294799804687500e+01 2.3219400024414062e+02 -2.8229098510742188e+02 -9.9197597503662109e+00 2.3209300231933594e+02 -2.8229098510742188e+02 -9.6452198028564453e+00 2.3181900024414062e+02 -2.8229098510742188e+02 -1.2604099273681641e+01 2.3275401306152344e+02 -2.8229098510742188e+02 -1.2040800094604492e+01 2.3300900268554688e+02 -2.8229098510742188e+02 -1.1679200172424316e+01 2.3351000976562500e+02 -2.8229098510742188e+02 -1.1615200042724609e+01 2.3412500000000000e+02 -2.8229098510742188e+02 -1.1865799903869629e+01 2.3469099426269531e+02 -2.8229098510742188e+02 -1.2364600181579590e+01 2.3505599975585938e+02 -2.8229098510742188e+02 -1.2805500030517578e+01 2.3229299926757812e+02 -2.8229098510742188e+02 -1.2853899955749512e+01 2.3243199157714844e+02 -2.8229098510742188e+02 -1.2829899787902832e+01 2.3257798767089844e+02 -2.8229098510742188e+02 -1.2739399909973145e+01 2.3269499206542969e+02 -2.8229098510742188e+02 -1.2372500419616699e+01 2.3186199951171875e+02 -2.8229098510742188e+02 -1.1939500808715820e+01 2.3143099975585938e+02 -2.8229098510742188e+02 -1.1479399681091309e+01 2.3163400268554688e+02 -2.8229098510742188e+02 -1.1538100242614746e+01 2.3149900817871094e+02 -2.8229098510742188e+02 -1.1654199600219727e+01 2.3140800476074219e+02 -2.8229098510742188e+02 -1.1799799919128418e+01 2.3138299560546875e+02 -2.8229098510742188e+02 -9.1108694076538086e+00 2.3163999938964844e+02 -2.8229098510742188e+02 -9.3278503417968750e+00 2.3215399169921875e+02 -2.8229098510742188e+02 -9.7541399002075195e+00 2.3251501464843750e+02 -2.8229098510742188e+02 -1.0297499656677246e+01 2.3264401245117188e+02 -2.8229098510742188e+02 -1.0840199470520020e+01 2.3251199340820312e+02 -2.8229098510742188e+02 -1.1264800071716309e+01 2.3215000915527344e+02 -2.8229098510742188e+02 -8.6498498916625977e+00 2.3143800354003906e+02 -2.8229098510742188e+02 -8.7893400192260742e+00 2.3138999938964844e+02 -2.8229098510742188e+02 -8.9350204467773438e+00 2.3141400146484375e+02 -2.8229098510742188e+02 -9.0516099929809570e+00 2.3150500488281250e+02 -2.8229098510742188e+02 -8.2188205718994141e+00 2.3187200927734375e+02 -2.8229098510742188e+02 -7.7877798080444336e+00 2.3230500793457031e+02 -2.8229098510742188e+02 -7.9913296699523926e+00 2.3276499938964844e+02 -2.8229098510742188e+02 -7.8558297157287598e+00 2.3270599365234375e+02 -2.8229098510742188e+02 -7.7646999359130859e+00 2.3259001159667969e+02 -2.8229098510742188e+02 -7.7400302886962891e+00 2.3244400024414062e+02 -2.8229098510742188e+02 -8.2414197921752930e+00 2.3506500244140625e+02 -2.8229098510742188e+02 -8.7385101318359375e+00 2.3469799804687500e+02 -2.8229098510742188e+02 -8.9865703582763672e+00 2.3413099670410156e+02 -2.8229098510742188e+02 -8.9197597503662109e+00 2.3351701354980469e+02 -2.8229098510742188e+02 -8.5557994842529297e+00 2.3301699829101562e+02 -2.8229098510742188e+02 -8.1080703735351562e+00 2.3551901245117188e+02 -2.8229098510742188e+02 -8.0559301376342773e+00 2.3539500427246094e+02 -2.8229098510742188e+02 -8.0638198852539062e+00 2.3525999450683594e+02 -2.8229098510742188e+02 -8.1301393508911133e+00 2.3514199829101562e+02 -2.8229098510742188e+02 -8.4213600158691406e+00 2.3583100891113281e+02 -2.8229098510742188e+02 -8.7346496582031250e+00 2.3614299011230469e+02 -2.8229098510742188e+02 -9.1881399154663086e+00 2.3600801086425781e+02 -2.8229098510742188e+02 -9.1119499206542969e+00 2.3611900329589844e+02 -2.8229098510742188e+02 -8.9944801330566406e+00 2.3618600463867188e+02 -2.8229098510742188e+02 -8.8595895767211914e+00 2.3619499206542969e+02 -2.8229098510742188e+02 -1.1422200202941895e+01 2.3600299072265625e+02 -2.8229098510742188e+02 -1.1093700408935547e+01 2.3553800964355469e+02 -2.8229098510742188e+02 -1.0587999343872070e+01 2.3527699279785156e+02 -2.8229098510742188e+02 -1.0019000053405762e+01 2.3527799987792969e+02 -2.8229098510742188e+02 -9.5145902633666992e+00 2.3554199218750000e+02 -2.8229098510742188e+02 -1.1876399993896484e+01 2.3613600158691406e+02 -2.8229098510742188e+02 -1.1751700401306152e+01 2.3618798828125000e+02 -2.8229098510742188e+02 -1.1616700172424316e+01 2.3617999267578125e+02 -2.8229098510742188e+02 -1.1498900413513184e+01 2.3611399841308594e+02 -2.8229098510742188e+02 -1.2188199996948242e+01 2.3582299804687500e+02 -2.8229098510742188e+02 -1.2500100135803223e+01 2.3550898742675781e+02 -2.8229098510742188e+02 -1.2476200103759766e+01 2.3513198852539062e+02 -2.8229098510742188e+02 -1.2543100357055664e+01 2.3525000000000000e+02 -2.8229098510742188e+02 -1.2551600456237793e+01 2.3538400268554688e+02 -2.7331600952148438e+02 -8.9106302261352539e+00 2.3686399841308594e+02 -2.8229098510742188e+02 -8.9106302261352539e+00 2.3686399841308594e+02 -2.7343402099609375e+02 -1.0010199546813965e+01 2.3795799255371094e+02 -2.7331600952148438e+02 -9.9894008636474609e+00 2.3793699645996094e+02 -2.7338201904296875e+02 -1.5637999534606934e+01 2.3475999450683594e+02 -2.7338201904296875e+02 -1.5699999809265137e+01 2.3394200134277344e+02 -2.7338201904296875e+02 -1.5692500114440918e+01 2.3365899658203125e+02 -2.7338201904296875e+02 -1.5680000305175781e+01 2.3348001098632812e+02 -2.7338201904296875e+02 -1.5611000061035156e+01 2.3305700683593750e+02 -2.7338201904296875e+02 -1.5199700355529785e+01 2.3620001220703125e+02 -2.7338201904296875e+02 -1.5241299629211426e+01 2.3612199401855469e+02 -2.7338201904296875e+02 -1.5514699935913086e+01 2.3534600830078125e+02 -2.7338201904296875e+02 -1.5590499877929688e+01 2.3498600769042969e+02 -2.7338201904296875e+02 -1.5623000144958496e+01 2.3483100891113281e+02 -2.7338098144531250e+02 -1.4756600379943848e+01 2.3699299621582031e+02 -2.7338098144531250e+02 -1.4514500617980957e+01 2.3729499816894531e+02 -2.7338098144531250e+02 -1.4241799354553223e+01 2.3763499450683594e+02 -2.7338098144531250e+02 -1.4054399490356445e+01 2.3780700683593750e+02 -2.7338098144531250e+02 -1.4855600357055664e+01 2.3684300231933594e+02 -2.7338098144531250e+02 -1.4898699760437012e+01 2.3676300048828125e+02 -2.7338098144531250e+02 -1.5035799980163574e+01 2.3650599670410156e+02 -2.7338000488281250e+02 -1.3495900154113770e+01 2.3829600524902344e+02 -2.7338000488281250e+02 -1.2934399604797363e+01 2.3864599609375000e+02 -2.7338000488281250e+02 -1.2797899246215820e+01 2.3873100280761719e+02 -2.7338000488281250e+02 -1.3529299736022949e+01 2.3827099609375000e+02 -2.7338000488281250e+02 -1.3638999938964844e+01 2.3818800354003906e+02 -2.7338098144531250e+02 -1.3947199821472168e+01 2.3790499877929688e+02 -2.7337899780273438e+02 -1.1875000000000000e+01 2.3910899353027344e+02 -2.7338000488281250e+02 -1.2046099662780762e+01 2.3905400085449219e+02 -2.7338000488281250e+02 -1.2299999237060547e+01 2.3894500732421875e+02 -2.7338000488281250e+02 -1.2463600158691406e+01 2.3887500000000000e+02 -2.7337899780273438e+02 -1.0981100082397461e+01 2.3929400634765625e+02 -2.7337899780273438e+02 -1.1072299957275391e+01 2.3928800964355469e+02 -2.7337899780273438e+02 -1.1645800590515137e+01 2.3916000366210938e+02 -2.7337802124023438e+02 -9.2597599029541016e+00 2.3924299621582031e+02 -2.7337802124023438e+02 -9.6196699142456055e+00 2.3928500366210938e+02 -2.7337802124023438e+02 -1.0076499938964844e+01 2.3933898925781250e+02 -2.7337899780273438e+02 -1.0256199836730957e+01 2.3934399414062500e+02 -2.7337899780273438e+02 -1.0745399475097656e+01 2.3930999755859375e+02 -2.7337802124023438e+02 -8.3032207489013672e+00 2.3896099853515625e+02 -2.7337701416015625e+02 -7.5644397735595703e+00 2.3860000610351562e+02 -2.7337802124023438e+02 -8.3926496505737305e+00 2.3899499511718750e+02 -2.7337802124023438e+02 -8.4713096618652344e+00 2.3902499389648438e+02 -2.7337802124023438e+02 -8.9786901473999023e+00 2.3916499328613281e+02 -2.7337701416015625e+02 -7.3043098449707031e+00 2.3841899108886719e+02 -2.7337701416015625e+02 -7.3545298576354980e+00 2.3845399475097656e+02 -2.7337701416015625e+02 -6.1796603202819824e+00 2.3743400573730469e+02 -2.7337701416015625e+02 -6.3915200233459473e+00 2.3764898681640625e+02 -2.7337701416015625e+02 -6.7550401687622070e+00 2.3801699829101562e+02 -2.7337701416015625e+02 -6.8925800323486328e+00 2.3813299560546875e+02 -2.7337701416015625e+02 -5.3312201499938965e+00 2.3605099487304688e+02 -2.7337701416015625e+02 -5.5640001296997070e+00 2.3653799438476562e+02 -2.7337701416015625e+02 -5.6203103065490723e+00 2.3662500000000000e+02 -2.7337701416015625e+02 -6.0115299224853516e+00 2.3722499084472656e+02 -2.7337701416015625e+02 -6.0396900177001953e+00 2.3725999450683594e+02 -2.7337701416015625e+02 -4.9000000953674316e+00 2.3394499206542969e+02 -2.7337701416015625e+02 -4.9049797058105469e+00 2.3413301086425781e+02 -2.7337701416015625e+02 -5.0518097877502441e+00 2.3521499633789062e+02 -2.7337701416015625e+02 -5.1204600334167480e+00 2.3542700195312500e+02 -2.7337701416015625e+02 -5.2069401741027832e+00 2.3569299316406250e+02 -2.7337701416015625e+02 -5.3057699203491211e+00 2.3599700927734375e+02 -2.7337701416015625e+02 -4.9075198173522949e+00 2.3422900390625000e+02 -2.7337701416015625e+02 -4.9199800491333008e+00 2.3440800476074219e+02 -2.7337701416015625e+02 -4.9821701049804688e+00 2.3478900146484375e+02 -2.7337802124023438e+02 -5.2070198059082031e+00 2.3219599914550781e+02 -2.7337701416015625e+02 -5.0853796005249023e+00 2.3254100036621094e+02 -2.7337701416015625e+02 -5.0113201141357422e+00 2.3289300537109375e+02 -2.7337701416015625e+02 -4.9620900154113770e+00 2.3312699890136719e+02 -2.7337701416015625e+02 -4.9000601768493652e+00 2.3394400024414062e+02 -2.7337802124023438e+02 -5.8099999427795410e+00 2.3094500732421875e+02 -2.7337802124023438e+02 -5.8436598777770996e+00 2.3089399719238281e+02 -2.7337802124023438e+02 -6.0500602722167969e+00 2.3063699340820312e+02 -2.7337899780273438e+02 -6.3584899902343750e+00 2.3025299072265625e+02 -2.7337802124023438e+02 -5.7446298599243164e+00 2.3104399108886719e+02 -2.7337802124023438e+02 -5.3588900566101074e+00 2.3176499938964844e+02 -2.7337802124023438e+02 -5.3181099891662598e+00 2.3188099670410156e+02 -2.7337899780273438e+02 -7.8024702072143555e+00 2.2915600585937500e+02 -2.7337899780273438e+02 -7.3536500930786133e+00 2.2943598937988281e+02 -2.7337899780273438e+02 -7.3058500289916992e+00 2.2946499633789062e+02 -2.7337899780273438e+02 -7.1043601036071777e+00 2.2959100341796875e+02 -2.7337899780273438e+02 -6.9612598419189453e+00 2.2969999694824219e+02 -2.7337899780273438e+02 -6.4879398345947266e+00 2.3013400268554688e+02 -2.7338000488281250e+02 -8.2384996414184570e+00 2.2896899414062500e+02 -2.7338000488281250e+02 -8.5543003082275391e+00 2.2883399963378906e+02 -2.7338098144531250e+02 -1.0743900299072266e+01 2.2857398986816406e+02 -2.7338098144531250e+02 -1.0523900032043457e+01 2.2854800415039062e+02 -2.7338000488281250e+02 -9.5280208587646484e+00 2.2859899902343750e+02 -2.7338098144531250e+02 -1.0299099922180176e+01 2.2854701232910156e+02 -2.7338098144531250e+02 -1.0344200134277344e+01 2.2854399108886719e+02 -2.7338000488281250e+02 -9.2485799789428711e+00 2.2866200256347656e+02 -2.7338000488281250e+02 -8.9767999649047852e+00 2.2872200012207031e+02 -2.7338000488281250e+02 -8.7253398895263672e+00 2.2877799987792969e+02 -2.7338201904296875e+02 -1.2363100051879883e+01 2.2895899963378906e+02 -2.7338201904296875e+02 -1.2297100067138672e+01 2.2892700195312500e+02 -2.7338201904296875e+02 -1.2129000663757324e+01 2.2886300659179688e+02 -2.7338098144531250e+02 -1.1352100372314453e+01 2.2864801025390625e+02 -2.7338098144531250e+02 -1.1340600013732910e+01 2.2864500427246094e+02 -2.7338201904296875e+02 -1.3845199584960938e+01 2.2987100219726562e+02 -2.7338201904296875e+02 -1.3707699775695801e+01 2.2975500488281250e+02 -2.7338201904296875e+02 -1.3290699958801270e+01 2.2946499633789062e+02 -2.7338201904296875e+02 -1.3035900115966797e+01 2.2928799438476562e+02 -2.7338201904296875e+02 -1.2463799476623535e+01 2.2900801086425781e+02 -2.7338201904296875e+02 -1.4588500022888184e+01 2.3066200256347656e+02 -2.7338201904296875e+02 -1.4420599937438965e+01 2.3045399475097656e+02 -2.7338201904296875e+02 -1.4106400489807129e+01 2.3013499450683594e+02 -2.7338201904296875e+02 -1.3950300216674805e+01 2.2997698974609375e+02 -2.7338201904296875e+02 -1.5583800315856934e+01 2.3289099121093750e+02 -2.7338299560546875e+02 -1.5548200607299805e+01 2.3267201232910156e+02 -2.7338299560546875e+02 -1.5294199943542480e+01 2.3188999938964844e+02 -2.7338299560546875e+02 -1.5047599792480469e+01 2.3137399291992188e+02 -2.7338299560546875e+02 -1.5036000251770020e+01 2.3134899902343750e+02 -2.7338201904296875e+02 -1.4776400566101074e+01 2.3095098876953125e+02 -2.7373098754882812e+02 -6.8219799995422363e+00 2.3162100219726562e+02 -2.7373098754882812e+02 -1.3257200241088867e+01 2.3098500061035156e+02 -2.7396499633789062e+02 -5.5647702217102051e+00 2.3394499206542969e+02 -2.7394900512695312e+02 -5.5079197883605957e+00 2.3394499206542969e+02 -2.7395999145507812e+02 -5.5968899726867676e+00 2.3300900268554688e+02 -2.7388098144531250e+02 -5.2595601081848145e+00 2.3394499206542969e+02 -2.7382299804687500e+02 -5.1945099830627441e+00 2.3394499206542969e+02 -2.7383398437500000e+02 -5.2828698158264160e+00 2.3294700622558594e+02 -2.7366098022460938e+02 -6.5617499351501465e+00 2.3020700073242188e+02 -2.7366098022460938e+02 -1.1330200195312500e+01 2.2875900268554688e+02 -2.7366098022460938e+02 -1.5183300018310547e+01 2.3191900634765625e+02 -2.7361398315429688e+02 -1.5611900329589844e+01 2.3394200134277344e+02 -2.7363299560546875e+02 -1.5604700088500977e+01 2.3394200134277344e+02 -2.7366098022460938e+02 -1.5484399795532227e+01 2.3291101074218750e+02 -2.7366098022460938e+02 -1.4694600105285645e+01 2.3100599670410156e+02 -2.7366098022460938e+02 -1.4036999702453613e+01 2.3020500183105469e+02 -2.7366098022460938e+02 -1.3235799789428711e+01 2.2954800415039062e+02 -2.7366098022460938e+02 -1.2321899414062500e+01 2.2905999755859375e+02 -2.7366098022460938e+02 -1.0298999786376953e+01 2.2865800476074219e+02 -2.7366098022460938e+02 -9.2677698135375977e+00 2.2876000976562500e+02 -2.7366098022460938e+02 -8.2762699127197266e+00 2.2906098937988281e+02 -2.7366098022460938e+02 -7.3625597953796387e+00 2.2954901123046875e+02 -2.7366098022460938e+02 -5.9046201705932617e+00 2.3100799560546875e+02 -2.7366098022460938e+02 -5.4164199829101562e+00 2.3192199707031250e+02 -2.7366098022460938e+02 -5.1159100532531738e+00 2.3291400146484375e+02 -2.7361102294921875e+02 -4.9963798522949219e+00 2.3394499206542969e+02 -2.7382498168945312e+02 -1.5407199859619141e+01 2.3394200134277344e+02 -2.7383398437500000e+02 -1.5317499160766602e+01 2.3294400024414062e+02 -2.7379501342773438e+02 -1.5438099861145020e+01 2.3394200134277344e+02 -2.7365600585937500e+02 -1.5581199645996094e+01 2.3394200134277344e+02 -2.7379501342773438e+02 -5.1621198654174805e+00 2.3394499206542969e+02 -2.7366998291015625e+02 -5.0205602645874023e+00 2.3394499206542969e+02 -2.7366000366210938e+02 -5.0167198181152344e+00 2.3394499206542969e+02 -2.7394802856445312e+02 -1.5092399597167969e+01 2.3394200134277344e+02 -2.7395999145507812e+02 -1.5003499984741211e+01 2.3300700378417969e+02 -2.7390997314453125e+02 -1.5222299575805664e+01 2.3394200134277344e+02 -2.7386901855468750e+02 -1.5362099647521973e+01 2.3394200134277344e+02 -2.7391299438476562e+02 -5.3773403167724609e+00 2.3394499206542969e+02 -2.7391299438476562e+02 -1.4761500358581543e+01 2.3394200134277344e+02 -2.7392001342773438e+02 -1.4674099922180176e+01 2.3307199096679688e+02 -2.7395401000976562e+02 -1.4978899955749512e+01 2.3394200134277344e+02 -2.7396499633789062e+02 -1.5033399581909180e+01 2.3394200134277344e+02 -2.7395300292968750e+02 -5.6215000152587891e+00 2.3394499206542969e+02 -2.7392001342773438e+02 -5.9263100624084473e+00 2.3307499694824219e+02 -2.7390798950195312e+02 -5.8382802009582520e+00 2.3394499206542969e+02 -2.7383398437500000e+02 -1.3141299247741699e+01 2.2968899536132812e+02 -2.7383398437500000e+02 -1.2256800651550293e+01 2.2921699523925781e+02 -2.7395999145507812e+02 -1.2963500022888184e+01 2.2995599365234375e+02 -2.7395999145507812e+02 -1.2134299278259277e+01 2.2951300048828125e+02 -2.7392001342773438e+02 -1.2776999473571777e+01 2.3023500061035156e+02 -2.7392001342773438e+02 -1.2005900382995605e+01 2.2982299804687500e+02 -2.7373098754882812e+02 -1.2623299598693848e+01 2.3046499633789062e+02 -2.7373098754882812e+02 -1.1900000572204590e+01 2.3007899475097656e+02 -2.7383398437500000e+02 -1.1296999931335449e+01 2.2892601013183594e+02 -2.7395999145507812e+02 -1.1234700202941895e+01 2.2924000549316406e+02 -2.7392001342773438e+02 -1.1169199943542480e+01 2.2956900024414062e+02 -2.7373098754882812e+02 -1.1115299224853516e+01 2.2984098815917969e+02 -2.7383398437500000e+02 -9.3010196685791016e+00 2.2892700195312500e+02 -2.7383398437500000e+02 -8.3414592742919922e+00 2.2921800231933594e+02 -2.7395999145507812e+02 -9.3635702133178711e+00 2.2924099731445312e+02 -2.7395999145507812e+02 -8.4640598297119141e+00 2.2951400756835938e+02 -2.7392001342773438e+02 -9.4291906356811523e+00 2.2957000732421875e+02 -2.7392001342773438e+02 -8.5926694869995117e+00 2.2982400512695312e+02 -2.7373098754882812e+02 -9.4832792282104492e+00 2.2984098815917969e+02 -2.7373098754882812e+02 -8.6986894607543945e+00 2.3007998657226562e+02 -2.7373098754882812e+02 -6.1978597640991211e+00 2.3312899780273438e+02 -2.7375299072265625e+02 -6.0702300071716309e+00 2.3394499206542969e+02 -2.7389498901367188e+02 -5.8997597694396973e+00 2.3394499206542969e+02 -2.7390499877929688e+02 -1.4723099708557129e+01 2.3394200134277344e+02 -2.7375799560546875e+02 -1.4526300430297852e+01 2.3394200134277344e+02 -2.7373098754882812e+02 -1.4402600288391113e+01 2.3312600708007812e+02 -2.7372698974609375e+02 -1.4485899925231934e+01 2.3394200134277344e+02 -2.7371499633789062e+02 -1.4469300270080566e+01 2.3394200134277344e+02 -2.7355398559570312e+02 -1.4386799812316895e+01 2.3394200134277344e+02 -2.7383398437500000e+02 -1.5026100158691406e+01 2.3198500061035156e+02 -2.7395999145507812e+02 -1.4730299949645996e+01 2.3210699462890625e+02 -2.7392001342773438e+02 -1.4420099258422852e+01 2.3223599243164062e+02 -2.7373098754882812e+02 -1.4164299964904785e+01 2.3234201049804688e+02 -2.7383398437500000e+02 -1.4553099632263184e+01 2.3109999084472656e+02 -2.7395999145507812e+02 -1.4286999702453613e+01 2.3127799987792969e+02 -2.7392001342773438e+02 -1.4007800102233887e+01 2.3146499633789062e+02 -2.7373098754882812e+02 -1.3777599334716797e+01 2.3161900329589844e+02 -2.7383398437500000e+02 -1.3916700363159180e+01 2.3032499694824219e+02 -2.7395999145507812e+02 -1.3690400123596191e+01 2.3055200195312500e+02 -2.7392001342773438e+02 -1.3453000068664551e+01 2.3078900146484375e+02 -2.7383398437500000e+02 -1.0298999786376953e+01 2.2882800292968750e+02 -2.7395999145507812e+02 -1.0299099922180176e+01 2.2914799499511719e+02 -2.7392001342773438e+02 -1.0299200057983398e+01 2.2948400878906250e+02 -2.7373098754882812e+02 -1.0299300193786621e+01 2.2976100158691406e+02 -2.7383398437500000e+02 -7.4571700096130371e+00 2.2969099426269531e+02 -2.7395999145507812e+02 -7.6351099014282227e+00 2.2995700073242188e+02 -2.7392001342773438e+02 -7.8217897415161133e+00 2.3023599243164062e+02 -2.7373098754882812e+02 -7.9756603240966797e+00 2.3046598815917969e+02 -2.7383398437500000e+02 -6.6821498870849609e+00 2.3032699584960938e+02 -2.7395999145507812e+02 -6.9086003303527832e+00 2.3055400085449219e+02 -2.7392001342773438e+02 -7.1461496353149414e+00 2.3079100036621094e+02 -2.7373098754882812e+02 -7.3419704437255859e+00 2.3098699951171875e+02 -2.7383398437500000e+02 -6.0461802482604980e+00 2.3110299682617188e+02 -2.7395999145507812e+02 -6.3124299049377441e+00 2.3128099060058594e+02 -2.7392001342773438e+02 -6.5917401313781738e+00 2.3146699523925781e+02 -2.7383398437500000e+02 -5.5736999511718750e+00 2.3198699951171875e+02 -2.7395999145507812e+02 -5.8695197105407715e+00 2.3211000061035156e+02 -2.7392001342773438e+02 -6.1798501014709473e+00 2.3223799133300781e+02 -2.7373098754882812e+02 -6.4356603622436523e+00 2.3234399414062500e+02 -2.7355599975585938e+02 -6.2178697586059570e+00 2.3394499206542969e+02 -2.7367898559570312e+02 -6.1602296829223633e+00 2.3394499206542969e+02 -2.7372100830078125e+02 -6.1093401908874512e+00 2.3394499206542969e+02 -2.7331600952148438e+02 -6.4283399581909180e+00 2.3497000122070312e+02 -2.7331600952148438e+02 -7.4303603172302246e+00 2.3541200256347656e+02 -2.7331600952148438e+02 -6.6421799659729004e+00 2.3557600402832031e+02 -2.7331600952148438e+02 -6.4545898437500000e+00 2.3504499816894531e+02 -2.7331600952148438e+02 -7.4457602500915527e+00 2.3548799133300781e+02 -2.7331600952148438e+02 -7.4307098388671875e+00 2.3556500244140625e+02 -2.7331600952148438e+02 -6.8329496383666992e+00 2.3593099975585938e+02 -2.7331600952148438e+02 -7.3874998092651367e+00 2.3563000488281250e+02 -2.7331600952148438e+02 -6.9224500656127930e+00 2.3609700012207031e+02 -2.7331600952148438e+02 -9.7955598831176758e+00 2.3790800476074219e+02 -2.7331600952148438e+02 -9.4046392440795898e+00 2.3784799194335938e+02 -2.7331600952148438e+02 -8.8870897293090820e+00 2.3768499755859375e+02 -2.7331600952148438e+02 -8.7921895980834961e+00 2.3765499877929688e+02 -2.7331600952148438e+02 -8.1627302169799805e+00 2.3733100891113281e+02 -2.7331600952148438e+02 -8.6277799606323242e+00 2.3686399841308594e+02 -2.7331600952148438e+02 -8.8456401824951172e+00 2.3681999206542969e+02 -2.7331600952148438e+02 -8.7690696716308594e+00 2.3680500793457031e+02 -2.7331600952148438e+02 -8.6925697326660156e+00 2.3682099914550781e+02 -2.7343402099609375e+02 -1.0802900314331055e+01 2.3788200378417969e+02 -2.7343402099609375e+02 -1.1345499992370605e+01 2.3783099365234375e+02 -2.7343402099609375e+02 -1.1773499488830566e+01 2.3763400268554688e+02 -2.7343402099609375e+02 -1.2564799308776855e+01 2.3727099609375000e+02 -2.7343402099609375e+02 -1.2689800262451172e+01 2.3715100097656250e+02 -2.7343402099609375e+02 -1.3436699867248535e+01 2.3643399047851562e+02 -2.7331600952148438e+02 -1.3934399604797363e+01 2.3561700439453125e+02 -2.7331600952148438e+02 -1.3885399818420410e+01 2.3573100280761719e+02 -2.8229098510742188e+02 -7.4303603172302246e+00 2.3541200256347656e+02 -2.8229098510742188e+02 -7.4457602500915527e+00 2.3548799133300781e+02 -2.8229098510742188e+02 -7.4307098388671875e+00 2.3556500244140625e+02 -2.8229098510742188e+02 -7.3874998092651367e+00 2.3563000488281250e+02 -2.8229098510742188e+02 -7.6019897460937500e+00 2.3665399169921875e+02 -2.8229098510742188e+02 -7.0534100532531738e+00 2.3596499633789062e+02 -2.8229098510742188e+02 -8.6277799606323242e+00 2.3686399841308594e+02 -2.8229098510742188e+02 -8.2936897277832031e+00 2.3720001220703125e+02 -2.8229098510742188e+02 -8.8456401824951172e+00 2.3681999206542969e+02 -2.8229098510742188e+02 -8.7690696716308594e+00 2.3680500793457031e+02 -2.8229098510742188e+02 -8.6925697326660156e+00 2.3682099914550781e+02 -2.7390798950195312e+02 -5.8738799095153809e+00 2.3409899902343750e+02 -2.7356201171875000e+02 -6.2322797775268555e+00 2.3408601379394531e+02 -2.7380801391601562e+02 -5.1535601615905762e+00 2.3412400817871094e+02 -2.7380801391601562e+02 -1.5353400230407715e+01 2.3493899536132812e+02 -2.7361499023437500e+02 -1.1627299308776855e+01 2.3908999633789062e+02 -2.7361499023437500e+02 -1.0970699310302734e+01 2.3921600341796875e+02 -2.7361499023437500e+02 -1.0288200378417969e+01 2.3925801086425781e+02 -2.7361499023437500e+02 -9.6286497116088867e+00 2.3921600341796875e+02 -2.7361499023437500e+02 -4.9888997077941895e+00 2.3412998962402344e+02 -2.7356201171875000e+02 -1.1811900138854980e+01 2.3772299194335938e+02 -2.7356201171875000e+02 -1.3997799873352051e+01 2.3564599609375000e+02 -2.7356201171875000e+02 -1.3486499786376953e+01 2.3647700500488281e+02 -2.7356201171875000e+02 -1.2734799385070801e+01 2.3720599365234375e+02 -2.7356201171875000e+02 -1.0813799858093262e+01 2.3798200988769531e+02 -2.7356201171875000e+02 -9.7859106063842773e+00 2.3798200988769531e+02 -2.7356201171875000e+02 -8.0357103347778320e+00 2.3732598876953125e+02 -2.7343402099609375e+02 -8.1489496231079102e+00 2.3734500122070312e+02 -2.7356201171875000e+02 -8.8621797561645508e+00 2.3775199890136719e+02 -2.7356201171875000e+02 -7.3462700843811035e+00 2.3674400329589844e+02 -2.7343402099609375e+02 -7.4609003067016602e+00 2.3679600524902344e+02 -2.7343402099609375e+02 -8.0674295425415039e+00 2.3727999877929688e+02 -2.7356201171875000e+02 -6.7683997154235840e+00 2.3596699523925781e+02 -2.7343402099609375e+02 -6.9086699485778809e+00 2.3611100769042969e+02 -2.7343402099609375e+02 -7.3880400657653809e+00 2.3670600891113281e+02 -2.7356201171875000e+02 -6.3871002197265625e+00 2.3506399536132812e+02 -2.7361499023437500e+02 -5.0515003204345703e+00 2.3477799987792969e+02 -2.7361499023437500e+02 -5.1910400390625000e+00 2.3540699768066406e+02 -2.7361499023437500e+02 -5.4074201583862305e+00 2.3601899719238281e+02 -2.7361499023437500e+02 -5.6888899803161621e+00 2.3658599853515625e+02 -2.7361499023437500e+02 -6.4433598518371582e+00 2.3760000610351562e+02 -2.7361499023437500e+02 -7.3435301780700684e+00 2.3836000061035156e+02 -2.7361499023437500e+02 -8.4225997924804688e+00 2.3891600036621094e+02 -2.7361499023437500e+02 -1.2898099899291992e+01 2.3858000183105469e+02 -2.7361499023437500e+02 -1.2273799896240234e+01 2.3887799072265625e+02 -2.7361499023437500e+02 -1.3478799819946289e+01 2.3820300292968750e+02 -2.7361499023437500e+02 -1.4004099845886230e+01 2.3775500488281250e+02 -2.7361499023437500e+02 -1.4831700325012207e+01 2.3672099304199219e+02 -2.7361499023437500e+02 -1.4460200309753418e+01 2.3725199890136719e+02 -2.7361499023437500e+02 -1.5514999389648438e+01 2.3497100830078125e+02 -2.7361499023437500e+02 -1.5127900123596191e+01 2.3616699218750000e+02 -2.7393002319335938e+02 -1.5135199546813965e+01 2.3489601135253906e+02 -2.7396499633789062e+02 -1.4888799667358398e+01 2.3484799194335938e+02 -2.7376800537109375e+02 -1.4439100265502930e+01 2.3475900268554688e+02 -2.7356201171875000e+02 -1.4294400215148926e+01 2.3473001098632812e+02 -2.7393002319335938e+02 -5.3758397102355957e+00 2.3411700439453125e+02 -2.7376800537109375e+02 -6.0848398208618164e+00 2.3409199523925781e+02 -2.7380801391601562e+02 -5.2142200469970703e+00 2.3475199890136719e+02 -2.7393002319335938e+02 -5.5632600784301758e+00 2.3530000305175781e+02 -2.7380801391601562e+02 -7.4351902008056641e+00 2.3822300720214844e+02 -2.7380801391601562e+02 -6.5629301071166992e+00 2.3748699951171875e+02 -2.7380801391601562e+02 -5.8318400382995605e+00 2.3650399780273438e+02 -2.7380801391601562e+02 -5.5590996742248535e+00 2.3595399475097656e+02 -2.7380801391601562e+02 -5.3494400978088379e+00 2.3536199951171875e+02 -2.7396499633789062e+02 -9.7093391418457031e+00 2.3858299255371094e+02 -2.7393002319335938e+02 -8.5594005584716797e+00 2.3855300903320312e+02 -2.7396499633789062e+02 -8.6481304168701172e+00 2.3831799316406250e+02 -2.7393002319335938e+02 -7.5589303970336914e+00 2.3803800964355469e+02 -2.7396499633789062e+02 -7.6986498832702637e+00 2.3783000183105469e+02 -2.7393002319335938e+02 -6.7243399620056152e+00 2.3733399963378906e+02 -2.7396499633789062e+02 -6.9065899848937988e+00 2.3716099548339844e+02 -2.7393002319335938e+02 -6.0248298645019531e+00 2.3639300537109375e+02 -2.7396499633789062e+02 -6.2427301406860352e+00 2.3626800537109375e+02 -2.7396499633789062e+02 -5.8046798706054688e+00 2.3523100280761719e+02 -2.7396499633789062e+02 -5.6268095970153809e+00 2.3410800170898438e+02 -2.7380801391601562e+02 -9.6494798660278320e+00 2.3905200195312500e+02 -2.7396499633789062e+02 -1.0289699554443359e+01 2.3861999511718750e+02 -2.7396499633789062e+02 -1.0890199661254883e+01 2.3858299255371094e+02 -2.7393002319335938e+02 -1.0289099693298340e+01 2.3887098693847656e+02 -2.7393002319335938e+02 -1.0921899795532227e+01 2.3883200073242188e+02 -2.7380801391601562e+02 -1.0288599967956543e+01 2.3909400939941406e+02 -2.7380801391601562e+02 -1.0949900627136230e+01 2.3905299377441406e+02 -2.7393002319335938e+02 -9.6775894165039062e+00 2.3883200073242188e+02 -2.7380801391601562e+02 -8.4808092117309570e+00 2.3876098632812500e+02 -2.7376800537109375e+02 -6.2452697753906250e+00 2.3510499572753906e+02 -2.7390798950195312e+02 -6.0423398017883301e+00 2.3516300964355469e+02 -2.7376800537109375e+02 -6.6403899192810059e+00 2.3604100036621094e+02 -2.7390798950195312e+02 -6.4572300910949707e+00 2.3614500427246094e+02 -2.7376800537109375e+02 -7.2392001152038574e+00 2.3684599304199219e+02 -2.7390798950195312e+02 -7.0859999656677246e+00 2.3699099731445312e+02 -2.7376800537109375e+02 -7.9536299705505371e+00 2.3744900512695312e+02 -2.7390798950195312e+02 -7.8361902236938477e+00 2.3762400817871094e+02 -2.7376800537109375e+02 -8.8100605010986328e+00 2.3788999938964844e+02 -2.7390798950195312e+02 -8.7354698181152344e+00 2.3808700561523438e+02 -2.7376800537109375e+02 -9.7672700881958008e+00 2.3812800598144531e+02 -2.7390798950195312e+02 -9.7405796051025391e+00 2.3833699035644531e+02 -2.7376800537109375e+02 -1.0832400321960449e+01 2.3812800598144531e+02 -2.7390798950195312e+02 -1.0858999252319336e+01 2.3833799743652344e+02 -2.7380801391601562e+02 -1.1586200714111328e+01 2.3893099975585938e+02 -2.7393002319335938e+02 -1.1530699729919434e+01 2.3871499633789062e+02 -2.7396499633789062e+02 -1.1467999458312988e+01 2.3847200012207031e+02 -2.7380801391601562e+02 -1.3889299392700195e+01 2.3763699340820312e+02 -2.7380801391601562e+02 -1.3380199432373047e+01 2.3807099914550781e+02 -2.7380801391601562e+02 -1.2817500114440918e+01 2.3843699645996094e+02 -2.7380801391601562e+02 -1.2212699890136719e+01 2.3872500610351562e+02 -2.7393002319335938e+02 -1.4157199859619141e+01 2.3701100158691406e+02 -2.7393002319335938e+02 -1.3734299659729004e+01 2.3747799682617188e+02 -2.7393002319335938e+02 -1.3247200012207031e+01 2.3789300537109375e+02 -2.7393002319335938e+02 -1.2708800315856934e+01 2.3824299621582031e+02 -2.7393002319335938e+02 -1.2130100250244141e+01 2.3851899719238281e+02 -2.7393002319335938e+02 -1.4776200294494629e+01 2.3600498962402344e+02 -2.7396499633789062e+02 -1.4548099517822266e+01 2.3589999389648438e+02 -2.7396499633789062e+02 -1.3960599899291992e+01 2.3685400390625000e+02 -2.7396499633789062e+02 -1.3559300422668457e+01 2.3729800415039062e+02 -2.7396499633789062e+02 -1.3097100257873535e+01 2.3769200134277344e+02 -2.7396499633789062e+02 -1.2586099624633789e+01 2.3802299499511719e+02 -2.7396499633789062e+02 -1.2036800384521484e+01 2.3828601074218750e+02 -2.7380801391601562e+02 -1.4331299781799316e+01 2.3714900207519531e+02 -2.7380801391601562e+02 -1.4691299438476562e+01 2.3663499450683594e+02 -2.7380801391601562e+02 -1.4978199958801270e+01 2.3609800720214844e+02 -2.7390798950195312e+02 -1.1944999694824219e+01 2.3805599975585938e+02 -2.7376800537109375e+02 -1.2362100601196289e+01 2.3762400817871094e+02 -2.7390798950195312e+02 -1.2465299606323242e+01 2.3780799865722656e+02 -2.7376800537109375e+02 -1.2822999954223633e+01 2.3732400512695312e+02 -2.7390798950195312e+02 -1.2949200630187988e+01 2.3749400329589844e+02 -2.7376800537109375e+02 -1.3239999771118164e+01 2.3696899414062500e+02 -2.7390798950195312e+02 -1.3387100219726562e+01 2.3711999511718750e+02 -2.7376800537109375e+02 -1.3601900100708008e+01 2.3656900024414062e+02 -2.7390798950195312e+02 -1.3767100334167480e+01 2.3670100402832031e+02 -2.7376800537109375e+02 -1.4131800651550293e+01 2.3570799255371094e+02 -2.7390798950195312e+02 -1.4323599815368652e+01 2.3579699707031250e+02 -2.7390798950195312e+02 -1.4646200180053711e+01 2.3480000305175781e+02 -2.7376800537109375e+02 -1.1866700172424316e+01 2.3786000061035156e+02 -2.8225897216796875e+02 -6.9739704132080078e+00 2.3604499816894531e+02 -2.8221398925781250e+02 -6.9390602111816406e+00 2.3608000183105469e+02 -2.8216601562500000e+02 -6.9202399253845215e+00 2.3609899902343750e+02 -2.8228500366210938e+02 -7.0181598663330078e+00 2.3600100708007812e+02 -2.8227401733398438e+02 -6.9984698295593262e+00 2.3602000427246094e+02 -2.8209100341796875e+02 -6.9086699485778809e+00 2.3611100769042969e+02 -2.8215600585937500e+02 -6.9165201187133789e+00 2.3610299682617188e+02 -2.8209100341796875e+02 -7.4609003067016602e+00 2.3679600524902344e+02 -2.8216699218750000e+02 -7.4712600708007812e+00 2.3678599548339844e+02 -2.8225897216796875e+02 -8.2142505645751953e+00 2.3727999877929688e+02 -2.8221398925781250e+02 -8.1793394088745117e+00 2.3731500244140625e+02 -2.8223199462890625e+02 -7.5017600059509277e+00 2.3675500488281250e+02 -2.8216601562500000e+02 -8.1605205535888672e+00 2.3733399963378906e+02 -2.8215600585937500e+02 -8.1567993164062500e+00 2.3733699035644531e+02 -2.8209100341796875e+02 -8.1489496231079102e+00 2.3734500122070312e+02 -2.8227401733398438e+02 -8.2387495040893555e+00 2.3725500488281250e+02 -2.8227600097656250e+02 -7.5476899147033691e+00 2.3670899963378906e+02 -2.8228500366210938e+02 -8.2584495544433594e+00 2.3723500061035156e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 21342 -> 13 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6695200800895691e+02 1.8390899524092674e+01 2.4018999934196472e+02) (float-vector -2.5361499190330505e+02 1.8851200118660927e+01 2.2685000300407410e+02) (float-vector -2.0690900087356567e+02 -1.1803899891674519e+01 2.5130900740623474e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5361499190330505e+02 1.8851200118660927e+01 2.2685000300407410e+02) (float-vector -2.5328201055526733e+02 -1.8148699775338173e+01 2.2614599764347076e+02) (float-vector -2.0690900087356567e+02 -1.1803899891674519e+01 2.5130900740623474e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5328201055526733e+02 -1.8148699775338173e+01 2.2614599764347076e+02) (float-vector -2.6629200577735901e+02 -1.8149899318814278e+01 2.2614599764347076e+02) (float-vector -2.6667898893356323e+02 -1.8734300509095192e+01 2.3987600207328796e+02) (float-vector -2.0690900087356567e+02 -1.1803899891674519e+01 2.5130900740623474e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8019100427627563e+02 -1.2314300052821636e+01 2.2713500261306763e+02) (float-vector -2.8019100427627563e+02 -1.7328999936580658e+01 2.3294100165367126e+02) (float-vector -2.6629200577735901e+02 -1.8149899318814278e+01 2.2614599764347076e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5328201055526733e+02 -1.8148699775338173e+01 2.2614599764347076e+02) (float-vector -2.5361499190330505e+02 1.8851200118660927e+01 2.2685000300407410e+02) (float-vector -2.6648500561714172e+02 1.8796699121594429e+01 2.2665999829769135e+02) (float-vector -2.8161600232124329e+02 1.0714399628341198e+01 2.2894799709320068e+02) (float-vector -2.8019100427627563e+02 -1.2314300052821636e+01 2.2713500261306763e+02) (float-vector -2.6629200577735901e+02 -1.8149899318814278e+01 2.2614599764347076e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8161600232124329e+02 1.2312999926507473e+01 2.3853400349617004e+02) (float-vector -2.6695200800895691e+02 1.8390899524092674e+01 2.4018999934196472e+02) (float-vector -2.0690900087356567e+02 -1.1803899891674519e+01 2.5130900740623474e+02) (float-vector -2.8019100427627563e+02 -1.0300000198185444e+01 2.4104300141334534e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8019100427627563e+02 -1.5662899240851402e+01 2.3859600722789764e+02) (float-vector -2.8019100427627563e+02 -1.0300000198185444e+01 2.4104300141334534e+02) (float-vector -2.0690900087356567e+02 -1.1803899891674519e+01 2.5130900740623474e+02) (float-vector -2.6667898893356323e+02 -1.8734300509095192e+01 2.3987600207328796e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8019100427627563e+02 -1.0300000198185444e+01 2.4104300141334534e+02) (float-vector -2.8019100427627563e+02 -1.5662899240851402e+01 2.3859600722789764e+02) (float-vector -2.8161600232124329e+02 1.2312999926507473e+01 2.3853400349617004e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8019100427627563e+02 -1.7328999936580658e+01 2.3294100165367126e+02) (float-vector -2.8019100427627563e+02 -1.5662899240851402e+01 2.3859600722789764e+02) (float-vector -2.6667898893356323e+02 -1.8734300509095192e+01 2.3987600207328796e+02) (float-vector -2.6629200577735901e+02 -1.8149899318814278e+01 2.2614599764347076e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8161600232124329e+02 1.0714399628341198e+01 2.2894799709320068e+02) (float-vector -2.8161600232124329e+02 1.2312999926507473e+01 2.3853400349617004e+02) (float-vector -2.8019100427627563e+02 -1.5662899240851402e+01 2.3859600722789764e+02) (float-vector -2.8019100427627563e+02 -1.7328999936580658e+01 2.3294100165367126e+02) (float-vector -2.8019100427627563e+02 -1.2314300052821636e+01 2.2713500261306763e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8064098954200745e+02 1.5680000185966492e+01 2.3394399881362915e+02) (float-vector -2.8161600232124329e+02 1.2312999926507473e+01 2.3853400349617004e+02) (float-vector -2.8161600232124329e+02 1.0714399628341198e+01 2.2894799709320068e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6648500561714172e+02 1.8796699121594429e+01 2.2665999829769135e+02) (float-vector -2.8064098954200745e+02 1.5680000185966492e+01 2.3394399881362915e+02) (float-vector -2.8161600232124329e+02 1.0714399628341198e+01 2.2894799709320068e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8161600232124329e+02 1.2312999926507473e+01 2.3853400349617004e+02) (float-vector -2.8064098954200745e+02 1.5680000185966492e+01 2.3394399881362915e+02) (float-vector -2.6648500561714172e+02 1.8796699121594429e+01 2.2665999829769135e+02) (float-vector -2.5361499190330505e+02 1.8851200118660927e+01 2.2685000300407410e+02) (float-vector -2.6695200800895691e+02 1.8390899524092674e+01 2.4018999934196472e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_laser_link_8dGirm.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_wheel_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.2914000000000001e+00 -1.8738000000000000e+02 5.5324999999999996e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 7 8 0 0 8 9 0 9 1 481 7 0 481 0 482 482 0 2 7 6 8 6 465 8 8 465 454 8 454 9 9 454 455 9 455 1 454 417 455 465 419 454 454 419 418 454 418 417 464 420 465 465 420 419 6 464 465 411 418 419 411 419 410 410 419 420 412 417 418 412 418 411 410 58 411 411 58 60 411 60 412 409 56 410 410 56 58 410 420 409 409 420 421 464 421 420 408 54 409 409 54 56 409 421 408 54 55 56 56 55 57 56 57 58 52 53 54 54 53 55 408 52 54 407 52 408 408 421 422 408 422 407 422 421 464 407 422 423 463 423 422 463 422 464 406 50 407 407 50 52 407 423 406 406 423 424 462 424 423 462 423 463 18 462 463 18 463 19 19 463 464 19 464 6 5 18 19 5 19 6 17 16 18 17 18 5 16 462 18 458 424 462 16 458 462 15 16 17 15 22 16 22 458 16 478 15 17 478 17 479 479 17 5 20 21 15 15 21 22 477 20 15 477 15 478 21 457 22 22 457 458 20 32 21 32 456 21 21 456 457 456 427 457 457 427 426 457 426 458 467 429 456 456 429 428 456 428 427 32 467 456 20 31 32 31 467 32 466 430 467 467 430 429 31 466 467 390 428 429 390 429 389 389 429 430 391 427 428 391 428 390 389 108 390 390 108 38 390 38 391 388 106 389 389 106 108 389 430 388 388 430 431 466 431 430 387 104 388 388 104 106 388 431 387 104 105 106 106 105 107 106 107 108 102 103 104 104 103 105 387 102 104 386 102 387 387 431 432 387 432 386 466 432 431 386 432 433 468 433 432 468 432 466 385 100 386 386 100 102 386 433 385 385 433 434 461 434 433 461 433 468 28 461 468 28 468 29 29 468 466 29 466 31 14 28 29 14 29 30 30 29 31 13 28 14 13 461 28 12 13 14 474 12 14 474 14 475 475 14 30 30 31 20 475 30 476 476 30 20 469 474 475 469 475 476 473 12 474 471 473 474 471 474 469 472 10 473 473 10 12 472 473 471 469 23 471 471 23 25 471 25 472 472 25 10 10 11 12 25 26 10 10 26 27 10 27 11 23 24 25 25 24 26 24 452 26 26 452 453 26 453 27 27 453 459 27 459 11 452 439 453 439 438 453 453 438 437 453 437 459 451 440 452 452 440 439 24 451 452 380 438 439 380 439 402 402 439 440 381 437 438 381 438 380 382 436 437 382 437 381 459 437 436 380 90 381 381 90 92 381 92 382 382 92 94 382 94 383 383 436 382 383 435 436 459 436 460 460 436 435 383 94 96 383 96 384 384 435 383 384 434 435 460 435 461 435 434 461 11 459 460 11 460 13 13 460 461 12 11 13 385 434 384 384 96 98 384 98 385 385 98 100 96 97 98 98 97 99 98 99 100 100 99 101 100 101 102 115 101 99 115 99 116 116 99 97 96 95 97 116 97 117 117 97 95 169 115 116 169 116 170 170 116 117 117 95 118 170 117 171 171 117 118 94 93 95 94 95 96 118 95 93 118 93 119 171 118 172 172 118 119 172 209 171 171 209 210 171 210 170 172 119 173 173 208 172 172 208 209 119 93 91 119 91 120 173 119 120 173 120 174 174 207 173 173 207 208 207 242 208 208 242 243 208 243 209 174 206 207 206 241 207 207 241 242 174 120 121 174 121 175 175 206 174 175 205 206 205 240 206 206 240 241 265 242 241 265 241 240 205 239 240 265 240 266 266 240 239 176 204 205 176 205 175 204 239 205 175 121 122 175 122 176 176 122 123 176 123 177 177 204 176 177 203 204 203 238 204 204 238 239 177 123 124 177 124 178 178 203 177 122 85 123 123 85 83 123 83 124 124 83 81 124 81 125 178 124 125 178 125 179 179 202 178 178 202 203 125 81 79 125 79 126 179 125 126 80 79 81 80 81 82 82 81 83 78 77 79 78 79 80 126 79 77 126 77 127 179 126 145 145 126 127 76 75 77 76 77 78 127 77 75 398 76 78 398 78 399 399 78 80 74 75 76 397 74 76 397 76 398 74 73 75 127 75 128 128 75 73 72 73 74 396 72 74 396 74 397 398 444 397 397 444 445 397 445 396 395 72 396 396 413 395 396 445 413 70 71 72 72 71 73 395 70 72 394 70 395 395 413 414 395 414 394 447 414 413 447 413 448 448 413 445 394 414 415 446 414 447 446 415 414 393 68 394 394 68 70 394 415 393 393 415 416 446 416 415 455 416 446 1 455 446 1 446 3 3 446 447 393 416 392 392 416 417 455 417 416 392 66 393 393 66 68 412 62 392 392 62 64 392 64 66 392 417 412 64 65 66 66 65 67 66 67 68 62 63 64 64 63 65 60 61 62 62 61 63 412 60 62 133 65 63 133 63 134 134 63 61 132 67 65 132 65 133 151 132 133 151 133 152 152 133 134 134 61 135 152 134 153 153 134 135 60 59 61 135 61 59 58 59 60 58 57 59 135 59 136 136 59 57 153 135 154 154 135 136 154 192 153 153 192 193 153 193 152 154 136 155 155 191 154 154 191 192 136 57 137 155 136 137 137 57 55 137 55 138 155 137 156 156 137 138 156 190 155 155 190 191 190 225 191 191 225 226 191 226 192 156 189 190 189 224 190 190 224 225 156 138 157 157 189 156 157 188 189 188 223 189 189 223 224 257 225 224 257 224 258 258 224 223 188 222 223 258 223 259 259 223 222 158 187 188 158 188 157 187 222 188 187 221 222 259 222 260 260 222 221 260 305 259 259 305 306 259 306 258 260 221 261 261 304 260 260 304 305 186 220 221 186 221 187 261 221 220 261 220 262 262 303 261 261 303 304 328 305 304 328 304 318 318 304 303 262 302 303 318 303 302 262 220 219 262 219 263 263 302 262 185 219 220 185 220 186 184 218 219 184 219 185 263 219 218 263 218 264 264 301 263 263 301 302 318 302 319 319 302 301 264 300 301 319 301 320 301 300 320 264 218 217 264 217 252 252 300 264 183 217 218 183 218 184 182 216 217 182 217 183 252 217 216 163 182 183 163 183 162 162 183 184 164 181 182 164 182 163 181 216 182 181 251 216 252 216 251 180 181 164 180 251 181 163 110 164 164 110 111 164 111 165 165 180 164 165 215 180 215 250 180 180 250 251 252 251 250 215 249 250 252 250 253 253 250 277 277 250 249 166 214 215 166 215 165 214 249 215 214 248 249 277 249 278 278 249 248 278 297 277 277 297 298 277 298 253 253 298 299 253 299 252 333 299 298 333 298 334 298 297 334 278 296 297 334 297 296 278 248 279 279 296 278 279 295 296 334 296 337 337 296 295 355 333 334 355 334 356 356 334 337 337 295 338 356 337 357 357 337 338 280 294 295 280 295 279 338 295 294 338 294 339 357 338 358 358 338 339 377 356 357 377 357 358 379 355 356 379 356 377 377 358 378 486 379 377 486 377 487 487 377 378 358 339 359 378 358 359 378 359 375 487 378 488 488 378 375 487 488 486 485 379 486 486 488 489 486 489 485 488 375 489 375 361 376 375 359 360 375 360 361 489 375 376 359 339 340 359 340 360 360 340 335 360 335 361 361 335 336 361 336 362 376 361 362 335 289 336 340 291 335 335 291 290 335 290 289 339 292 340 340 292 291 284 290 291 284 291 283 283 291 292 265 289 290 265 290 284 283 243 284 284 243 242 284 242 265 282 244 283 283 244 243 283 292 282 282 292 293 339 293 292 281 245 282 282 245 244 282 293 281 209 243 244 209 244 210 210 244 245 210 245 211 211 245 246 281 246 245 280 246 281 281 293 294 281 294 280 294 293 339 279 247 280 280 247 246 211 246 212 212 246 247 212 247 213 213 247 248 279 248 247 169 211 212 169 212 168 168 212 213 168 213 167 167 213 214 213 248 214 167 114 168 168 114 115 168 115 169 170 211 169 170 210 211 114 101 115 113 103 114 114 103 101 167 113 114 102 101 103 113 105 103 112 105 113 166 112 113 166 113 167 112 107 105 111 107 112 165 111 112 165 112 166 167 214 166 110 109 111 111 109 107 108 107 109 108 109 38 38 109 39 110 39 109 41 39 110 144 41 110 163 144 110 38 39 40 40 39 41 38 40 391 40 41 42 391 40 42 42 41 43 144 43 41 143 43 144 162 143 144 162 144 163 42 43 44 44 43 45 143 45 43 391 42 403 403 42 44 403 427 391 403 44 404 404 426 403 403 426 427 44 45 46 404 44 46 46 45 47 142 47 45 142 45 143 46 47 48 404 46 405 405 46 48 405 425 404 404 425 426 426 425 458 405 424 425 458 425 424 405 48 406 406 424 405 48 47 49 48 49 50 406 48 50 50 49 51 140 51 49 140 49 141 141 49 47 50 51 52 52 51 53 139 53 51 139 51 140 158 139 140 158 140 159 159 140 141 138 53 139 157 138 139 157 139 158 138 55 53 159 187 158 159 141 160 160 186 159 159 186 187 160 141 142 160 142 161 161 185 160 160 185 186 141 47 142 161 142 143 161 143 162 162 184 161 161 184 185 266 289 265 266 239 267 267 288 266 266 288 289 336 289 288 267 287 288 336 288 330 330 288 287 267 239 238 267 238 268 268 287 267 268 286 287 330 287 286 330 286 331 362 336 330 362 330 363 363 330 331 269 285 286 269 286 268 331 286 285 268 238 237 268 237 269 203 237 238 202 236 237 202 237 203 269 237 236 269 236 270 270 285 269 270 317 285 331 285 332 332 285 317 270 236 235 270 235 271 271 317 270 201 235 236 201 236 202 179 201 202 145 200 201 145 201 179 200 235 201 200 234 235 271 235 234 271 234 272 272 316 271 271 316 317 199 233 234 199 234 200 272 234 233 146 199 200 146 200 145 145 127 146 146 127 128 146 128 147 147 199 146 147 198 199 198 233 199 198 232 233 272 233 273 273 233 232 148 197 198 148 198 147 197 232 198 147 128 129 147 129 148 128 73 129 129 73 71 129 71 130 148 129 130 148 130 149 149 197 148 149 196 197 196 231 197 197 231 232 149 130 131 149 131 150 150 196 149 130 71 69 130 69 131 70 69 71 68 67 69 68 69 70 131 69 67 131 67 132 150 131 132 150 132 151 151 195 150 150 195 196 152 194 151 151 194 195 194 229 195 195 229 230 195 230 196 152 193 194 193 228 194 194 228 229 276 230 229 276 229 254 254 229 228 196 230 231 275 231 230 275 230 276 254 311 276 276 311 312 276 312 275 274 231 275 275 312 313 275 313 274 274 232 231 273 232 274 274 313 314 274 314 273 314 313 327 327 313 312 327 312 329 329 312 311 326 314 327 344 326 327 344 327 345 345 327 329 273 314 315 326 315 314 273 315 272 272 315 316 325 315 326 325 316 315 343 325 326 343 326 344 332 317 325 325 317 316 342 332 325 342 325 343 370 343 371 371 343 344 370 342 343 341 332 342 370 341 342 341 331 332 363 331 341 374 341 370 374 363 341 491 374 370 491 370 492 492 370 371 376 362 374 374 362 363 490 376 374 490 374 491 489 376 490 489 490 499 491 497 490 490 497 498 490 498 499 485 489 499 498 366 499 499 366 365 499 365 485 497 367 498 498 367 366 353 365 366 353 366 352 352 366 367 364 365 353 365 364 485 485 364 379 353 354 364 364 354 355 364 355 379 352 319 353 353 319 320 353 320 354 354 320 333 354 333 355 320 300 299 320 299 333 252 299 300 352 318 319 351 328 318 351 318 352 350 328 351 367 350 351 367 351 352 324 305 328 350 324 328 349 324 350 369 349 350 369 350 367 497 369 367 368 349 369 496 368 369 496 369 497 348 323 349 349 323 324 368 348 349 373 347 368 368 347 348 495 373 368 495 368 496 495 496 497 491 495 497 494 373 495 494 495 491 372 346 373 373 346 347 494 372 373 346 321 347 347 321 322 347 322 348 345 329 346 346 329 321 372 345 346 321 309 322 329 311 321 321 311 310 321 310 309 322 309 308 322 308 323 348 322 323 256 308 309 256 309 255 255 309 310 255 310 254 254 310 311 254 227 255 255 227 226 255 226 256 256 226 225 256 225 257 257 308 256 192 226 227 192 227 193 193 227 228 254 228 227 257 307 308 323 308 307 258 307 257 258 306 307 323 307 324 307 306 324 324 306 305 344 345 372 371 344 372 493 371 372 493 372 494 492 371 493 492 493 491 491 493 494 3 447 33 33 447 448 2 1 3 2 3 4 3 33 4 4 33 34 33 448 34 448 445 449 34 448 449 4 34 35 35 34 36 34 449 36 445 444 449 449 444 443 449 443 450 36 449 450 35 36 23 23 36 37 36 450 37 4 35 469 469 35 23 23 37 24 37 450 451 37 451 24 450 443 442 450 442 451 442 441 451 451 441 440 400 441 442 400 442 399 399 442 443 401 440 441 401 441 400 402 440 401 400 82 401 401 82 84 401 84 402 399 80 400 400 80 82 399 443 398 398 443 444 82 83 84 84 83 85 84 85 86 402 84 86 402 86 380 86 85 87 86 87 88 380 86 88 122 87 85 88 87 89 121 89 87 121 87 122 88 89 90 380 88 90 90 89 91 120 91 89 120 89 121 90 91 92 92 91 93 92 93 94 469 470 4 476 477 469 469 477 470 484 4 470 470 477 484 483 2 4 483 4 484 484 477 482 484 482 483 476 20 477 478 482 477 482 2 483 479 481 482 479 482 478 479 5 480 480 481 479 480 7 481 480 5 7 5 6 7 500 501 502 566 567 500 500 567 501 502 1043 500 500 1043 1042 500 1042 566 564 565 566 566 565 567 566 1042 1041 566 1041 564 989 1041 1042 989 1042 990 990 1042 1043 988 1040 1041 988 1041 989 564 1041 1040 936 988 989 936 989 937 937 989 990 937 990 938 938 990 991 990 1043 991 884 936 937 884 937 885 885 937 938 885 938 833 833 938 886 938 991 886 886 991 939 991 1043 1044 991 1044 939 502 1044 1043 939 1044 992 502 992 1044 886 939 887 887 939 940 939 992 940 833 886 834 834 886 887 834 887 835 835 887 888 887 940 888 888 940 941 940 992 993 940 993 941 504 992 502 504 993 992 941 993 994 504 994 993 888 941 889 889 941 942 941 994 942 835 888 836 836 888 889 836 889 837 837 889 890 889 942 890 890 942 943 942 994 995 942 995 943 506 995 994 506 994 504 943 995 996 508 996 995 508 995 506 890 943 891 891 943 944 943 996 944 837 890 838 838 890 891 838 891 839 839 891 892 891 944 892 892 944 945 944 996 997 944 997 945 997 996 508 945 997 998 508 510 997 510 998 997 892 945 893 893 945 946 945 998 946 839 892 840 840 892 893 840 893 841 841 893 894 893 946 894 894 946 947 946 998 999 946 999 947 510 999 998 947 999 1000 512 1000 999 512 999 510 894 947 895 895 947 948 947 1000 948 841 894 842 842 894 895 842 895 843 843 895 896 895 948 896 896 948 949 948 1000 1001 948 1001 949 843 896 844 844 896 897 896 949 897 790 842 843 790 843 791 791 843 844 791 844 792 792 844 845 844 897 845 845 897 898 897 949 950 897 950 898 792 845 793 793 845 846 845 898 846 739 791 792 739 792 740 740 792 793 740 793 741 741 793 794 793 846 794 794 846 847 846 898 899 846 899 847 741 794 742 742 794 795 794 847 795 688 740 741 688 741 689 689 741 742 689 742 690 690 742 743 742 795 743 743 795 796 795 847 848 795 848 796 690 743 691 691 743 744 743 796 744 637 689 690 637 690 638 638 690 691 638 691 639 639 691 692 691 744 692 692 744 745 744 796 797 744 797 745 639 692 640 640 692 693 692 745 693 577 638 639 577 639 605 605 639 640 605 640 606 606 640 641 640 693 641 641 693 694 693 745 746 693 746 694 606 641 607 607 641 642 641 694 642 527 605 606 527 606 529 529 606 607 577 605 527 526 525 527 526 527 528 528 527 529 527 525 577 528 529 530 530 529 531 529 607 531 528 1011 526 530 1013 528 528 1013 1012 528 1012 1011 530 531 532 532 1014 530 530 1014 1013 960 1012 1013 960 1013 961 961 1013 1014 959 1011 1012 959 1012 960 907 959 960 907 960 908 908 960 961 908 961 909 909 961 962 961 1014 962 962 1014 1015 532 1015 1014 909 962 910 910 962 963 962 1015 963 856 908 909 856 909 857 857 909 910 855 907 908 855 908 856 803 855 856 803 856 804 804 856 857 804 857 805 805 857 858 857 910 858 751 803 804 751 804 752 752 804 805 750 802 803 750 803 751 802 855 803 698 750 751 698 751 699 699 751 752 699 752 700 700 752 753 752 805 753 646 698 699 646 699 647 647 699 700 645 697 698 645 698 646 697 750 698 575 645 646 575 646 576 576 646 647 576 647 582 582 647 648 647 700 648 535 575 576 535 576 537 576 582 537 533 575 535 533 598 575 598 645 575 534 533 535 534 535 536 536 535 537 532 531 533 532 533 534 531 597 533 533 597 598 597 644 598 598 644 645 531 608 597 608 643 597 597 643 644 531 607 608 607 642 608 608 642 643 642 695 643 643 695 696 643 696 644 644 696 697 644 697 645 695 748 696 696 748 749 696 749 697 642 694 695 694 747 695 695 747 748 747 800 748 748 800 801 748 801 749 697 749 750 749 801 802 749 802 750 800 853 801 801 853 854 801 854 802 747 799 800 799 852 800 800 852 853 852 905 853 853 905 906 853 906 854 802 854 855 854 906 907 854 907 855 905 958 906 906 958 959 906 959 907 852 904 905 904 957 905 905 957 958 957 1010 958 958 1010 1011 958 1011 959 904 956 957 956 1009 957 957 1009 1010 851 903 904 851 904 852 903 956 904 903 955 956 955 1008 956 956 1008 1009 526 1009 524 524 1009 1008 526 1010 1009 955 1007 1008 524 1008 522 522 1008 1007 902 954 955 902 955 903 954 1007 955 954 1006 1007 522 1007 1006 520 521 522 522 521 523 522 523 524 520 522 1006 953 1005 1006 953 1006 954 1006 1005 520 901 953 954 901 954 902 900 952 953 900 953 901 952 1005 953 952 1004 1005 520 1005 1004 899 951 952 899 952 900 951 1004 952 847 899 900 847 900 848 848 900 901 848 901 849 849 901 902 796 848 849 796 849 797 797 849 850 849 902 850 850 902 903 797 850 798 798 850 851 850 903 851 745 797 798 745 798 746 746 798 799 798 851 799 799 851 852 746 799 747 694 746 747 898 951 899 898 950 951 950 1003 951 951 1003 1004 949 1002 950 950 1002 1003 518 1004 1003 518 1003 516 516 1003 1002 520 1004 518 516 517 518 518 517 519 518 519 520 514 515 516 516 515 517 516 1002 514 949 1001 1002 514 1002 1001 512 513 514 514 513 515 514 1000 512 514 1001 1000 513 599 515 515 599 600 515 600 517 512 511 513 511 603 513 513 603 604 513 604 599 510 511 512 510 509 511 509 602 511 511 602 603 602 627 603 603 627 628 603 628 604 604 628 629 604 629 599 627 680 628 628 680 681 628 681 629 602 626 627 626 679 627 627 679 680 509 601 602 601 626 602 601 625 626 625 678 626 626 678 679 678 731 679 679 731 732 679 732 680 625 677 678 677 730 678 678 730 731 587 624 625 587 625 601 624 677 625 587 601 509 509 507 587 507 613 587 613 624 587 613 623 624 623 676 624 624 676 677 507 612 613 612 623 613 612 622 623 622 675 623 623 675 676 675 728 676 676 728 729 676 729 677 622 674 675 674 727 675 675 727 728 727 780 728 728 780 781 728 781 729 677 729 730 729 781 782 729 782 730 780 833 781 781 833 834 781 834 782 727 832 780 832 885 780 780 885 833 779 831 832 779 832 727 831 884 832 832 884 885 726 778 779 726 779 674 674 779 727 778 831 779 778 830 831 830 883 831 831 883 884 883 936 884 830 882 883 882 935 883 883 935 936 777 829 830 777 830 778 829 882 830 829 881 882 881 934 882 882 934 935 934 987 935 935 987 988 935 988 936 881 933 934 933 986 934 934 986 987 828 880 881 828 881 829 880 933 881 880 932 933 932 985 933 933 985 986 985 1038 986 986 1038 1039 986 1039 987 932 984 985 984 1037 985 985 1037 1038 879 931 932 879 932 880 931 984 932 931 983 984 983 1036 984 984 1036 1037 562 1038 1037 562 1037 560 560 1037 1036 1039 1038 562 560 561 562 562 561 563 562 563 564 562 564 1039 558 559 560 560 559 561 560 1036 558 983 1035 1036 558 1036 1035 556 557 558 558 557 559 558 1034 556 558 1035 1034 557 578 559 559 578 579 559 579 561 556 555 557 555 591 557 557 591 592 557 592 578 592 663 578 578 663 664 578 664 579 561 579 580 579 664 665 579 665 580 663 716 664 664 716 717 664 717 665 580 665 666 665 717 718 665 718 666 561 580 572 580 666 572 561 572 563 563 572 573 572 666 667 572 667 573 666 718 719 666 719 667 717 770 718 718 770 771 718 771 719 667 719 720 719 771 772 719 772 720 573 667 668 667 720 668 563 573 569 573 668 569 569 668 669 668 720 721 668 721 669 720 772 773 720 773 721 771 824 772 772 824 825 772 825 773 721 773 774 773 825 826 773 826 774 669 721 722 721 774 722 722 774 775 774 826 827 774 827 775 825 878 826 826 878 879 826 879 827 824 877 825 825 877 878 877 930 878 878 930 931 878 931 879 827 879 880 775 827 828 827 880 828 775 828 776 776 828 829 723 775 776 723 776 724 724 776 777 776 829 777 670 722 723 670 723 671 671 723 724 722 775 723 671 724 672 672 724 725 724 777 725 725 777 778 672 725 673 673 725 726 725 778 726 568 671 672 568 672 609 609 672 673 609 673 610 610 673 621 673 726 621 621 726 674 610 621 611 611 621 622 621 674 622 501 609 610 501 610 503 503 610 611 568 609 501 502 501 503 501 567 568 502 503 504 504 503 505 503 611 505 505 611 612 611 622 612 504 505 506 506 505 507 505 612 507 506 507 508 508 507 509 508 509 510 567 571 568 571 671 568 567 570 571 570 670 571 571 670 671 565 569 570 565 570 567 569 669 570 570 669 670 669 722 670 563 569 565 564 563 565 564 1040 1039 987 1039 1040 987 1040 988 930 983 931 877 929 930 929 982 930 930 982 983 982 1035 983 929 981 982 981 1034 982 982 1034 1035 876 928 929 876 929 877 928 981 929 824 876 877 823 875 876 823 876 824 875 928 876 875 927 928 927 980 928 928 980 981 822 874 875 822 875 823 874 927 875 770 822 823 770 823 771 771 823 824 769 821 822 769 822 770 821 874 822 821 873 874 873 926 874 874 926 927 768 820 821 768 821 769 820 873 821 716 768 769 716 769 717 717 769 770 715 767 768 715 768 716 767 820 768 767 819 820 819 872 820 820 872 873 714 766 767 714 767 715 766 819 767 662 714 715 662 715 663 663 715 716 661 713 714 661 714 662 713 766 714 713 765 766 765 818 766 766 818 819 660 712 713 660 713 661 712 765 713 590 660 661 590 661 591 591 661 662 589 659 660 589 660 590 659 712 660 659 711 712 711 764 712 712 764 765 588 658 659 588 659 589 658 711 659 551 588 589 551 589 553 553 589 590 581 588 551 581 658 588 581 657 658 657 710 658 658 710 711 551 549 581 549 596 581 596 657 581 596 656 657 656 709 657 657 709 710 709 762 710 710 762 763 710 763 711 656 708 709 708 761 709 709 761 762 761 814 762 762 814 815 762 815 763 711 763 764 763 815 816 763 816 764 814 867 815 815 867 868 815 868 816 761 813 814 813 866 814 814 866 867 866 919 867 867 919 920 867 920 868 816 868 869 868 920 921 868 921 869 919 972 920 920 972 973 920 973 921 866 918 919 918 971 919 919 971 972 971 1024 972 972 1024 1025 972 1025 973 921 973 974 973 1025 1026 973 1026 974 546 1025 544 544 1025 1024 546 1026 1025 971 1023 1024 544 1024 1023 918 970 971 970 1023 971 970 1022 1023 544 1023 542 542 1023 1022 542 543 544 544 543 545 544 545 546 540 541 542 542 541 543 542 1022 540 969 1021 1022 969 1022 970 540 1022 1021 538 539 540 540 539 541 540 1020 538 540 1021 1020 539 584 541 541 584 585 541 585 543 538 537 539 537 583 539 539 583 584 583 649 584 584 649 650 584 650 585 543 585 586 585 650 651 585 651 586 649 702 650 650 702 703 650 703 651 586 651 652 651 703 704 651 704 652 543 586 574 586 652 574 545 543 574 574 593 545 574 652 653 574 653 593 652 704 705 652 705 653 703 756 704 704 756 757 704 757 705 653 705 706 705 757 758 705 758 706 593 653 654 653 706 654 545 593 594 593 654 594 594 654 655 654 706 707 654 707 655 706 758 759 706 759 707 757 810 758 758 810 811 758 811 759 707 759 760 759 811 812 759 812 760 655 707 708 707 760 708 708 760 761 760 812 813 760 813 761 811 864 812 812 864 865 812 865 813 810 863 811 811 863 864 863 916 864 864 916 917 864 917 865 813 865 866 865 917 918 865 918 866 916 969 917 917 969 970 917 970 918 863 915 916 915 968 916 916 968 969 968 1021 969 915 967 968 967 1020 968 968 1020 1021 862 914 915 862 915 863 914 967 915 914 966 967 966 1019 967 967 1019 1020 538 1020 1019 966 1018 1019 538 1019 536 536 1019 1018 913 965 966 913 966 914 965 1018 966 965 1017 1018 536 1018 1017 536 537 538 534 536 1017 964 1016 1017 964 1017 965 1017 1016 534 912 964 965 912 965 913 911 963 964 911 964 912 963 1016 964 963 1015 1016 534 1016 1015 534 1015 532 910 963 911 858 910 911 858 911 859 859 911 912 859 912 860 860 912 913 806 858 859 806 859 807 807 859 860 805 858 806 753 805 806 753 806 754 754 806 807 754 807 755 755 807 808 807 860 808 701 753 754 701 754 702 702 754 755 700 753 701 648 700 701 648 701 649 649 701 702 702 755 703 703 755 756 755 808 756 756 808 809 756 809 757 757 809 810 808 861 809 809 861 862 809 862 810 810 862 863 861 914 862 808 860 861 860 913 861 861 913 914 583 648 649 537 582 583 582 648 583 655 708 656 594 655 595 595 655 656 595 656 596 547 594 595 547 595 549 549 595 596 545 594 547 546 545 547 546 547 548 548 547 549 548 549 550 550 549 551 550 1028 548 548 1028 1027 548 1027 546 546 1027 1026 974 1026 1027 974 1027 975 975 1027 1028 975 1028 976 976 1028 1029 550 1029 1028 922 974 975 922 975 923 923 975 976 921 974 922 869 921 922 869 922 870 870 922 923 870 923 871 871 923 924 923 976 924 817 869 870 817 870 818 818 870 871 816 869 817 764 816 817 764 817 765 765 817 818 818 871 819 819 871 872 871 924 872 872 924 925 872 925 873 873 925 926 924 977 925 925 977 978 925 978 926 926 978 979 926 979 927 977 1030 978 978 1030 1031 978 1031 979 924 976 977 976 1029 977 977 1029 1030 1031 1030 552 552 1030 1029 979 1031 1032 552 554 1031 554 1032 1031 550 551 552 552 551 553 552 553 554 552 1029 550 554 553 555 554 555 556 556 1033 554 554 1033 1032 979 1032 980 980 1032 1033 980 1033 981 981 1033 1034 556 1034 1033 927 979 980 553 590 555 555 590 591 591 662 592 592 662 663 730 782 783 782 834 835 782 835 783 730 783 731 731 783 784 783 835 836 783 836 784 731 784 732 732 784 785 784 836 837 784 837 785 680 732 733 732 785 733 733 785 786 785 837 838 785 838 786 680 733 681 681 733 734 733 786 734 734 786 787 786 838 839 786 839 787 681 734 682 682 734 735 734 787 735 629 681 682 629 682 630 630 682 683 682 735 683 683 735 736 735 787 788 735 788 736 630 683 631 631 683 684 683 736 684 599 629 630 599 630 600 600 630 631 600 631 618 618 631 632 631 684 632 632 684 685 684 736 737 684 737 685 618 632 619 619 632 633 632 685 633 600 618 517 517 618 619 517 619 519 519 619 620 619 633 620 620 633 634 633 685 686 633 686 634 519 620 614 620 634 614 520 519 521 519 614 521 521 614 615 614 634 635 614 635 615 634 686 687 634 687 635 615 635 636 635 687 688 635 688 636 521 615 523 523 615 616 615 636 616 616 636 637 636 688 689 636 689 637 687 740 688 686 739 687 687 739 740 685 738 686 686 738 739 738 791 739 685 737 738 737 790 738 738 790 791 736 789 737 737 789 790 789 842 790 736 788 789 788 841 789 789 841 842 787 840 788 788 840 841 787 839 840 616 637 617 617 637 638 523 616 525 525 616 617 525 617 577 617 638 577 524 523 525 524 525 526 526 1011 1010))
                   (list :vertices (let ((mat (make-matrix 1045 3))) (fvector-replace (array-entity mat) #f(5.9832100868225098e+00 1.4487998962402344e+02 -5.1125000000000000e+01 1.4056200027465820e+01 1.4487998962402344e+02 -4.0991397857666016e+01 3.6460001468658447e+00 1.4487998962402344e+02 -4.8529300689697266e+01 9.6198596954345703e+00 1.4487998962402344e+02 -3.7382202148437500e+01 4.5505800843238831e-01 1.4487998962402344e+02 -4.7108600616455078e+01 6.6974697113037109e+00 1.4487998962402344e+02 -5.7920700073242188e+01 1.9659599304199219e+01 1.4487998962402344e+02 -5.6758098602294922e+01 7.0625801086425781e+00 1.4487998962402344e+02 -5.4446998596191406e+01 1.9269399642944336e+01 1.4487998962402344e+02 -5.1052398681640625e+01 1.7354200363159180e+01 1.4487998962402344e+02 -4.5663597106933594e+01 -9.6453800201416016e+00 1.4487998962402344e+02 -5.4446998596191406e+01 -2.2242401123046875e+01 1.4487998962402344e+02 -5.6758098602294922e+01 -9.2802696228027344e+00 1.4487998962402344e+02 -5.7920700073242188e+01 -2.1078899383544922e+01 1.4487998962402344e+02 -6.2357501983642578e+01 -7.5338196754455566e+00 1.4487998962402344e+02 -6.0945701599121094e+01 2.1251900196075439e+00 1.4487998962402344e+02 -6.2998802185058594e+01 1.1961400032043457e+01 1.4487998962402344e+02 -7.1614898681640625e+01 4.9510197639465332e+00 1.4487998962402344e+02 -6.0945701599121094e+01 1.5864999771118164e+01 1.4487998962402344e+02 -6.7435302734375000e+01 1.8496099472045898e+01 1.4487998962402344e+02 -6.2357501983642578e+01 -1.2914000749588013e+00 1.4487998962402344e+02 -6.3725002288818359e+01 1.5680999755859375e+00 1.4487998962402344e+02 -7.6129402160644531e+01 7.0750203132629395e+00 1.4487998962402344e+02 -7.4586395263671875e+01 -6.2287998199462891e+00 1.4487998962402344e+02 -4.8529300689697266e+01 -1.6638999938964844e+01 1.4487998962402344e+02 -4.0991397857666016e+01 -8.5660095214843750e+00 1.4487998962402344e+02 -5.1125000000000000e+01 -1.9936998367309570e+01 1.4487998962402344e+02 -4.5663597106933594e+01 -2.1852201461791992e+01 1.4487998962402344e+02 -5.1052398681640625e+01 -1.8447799682617188e+01 1.4487998962402344e+02 -6.7435302734375000e+01 -1.4544199943542480e+01 1.4487998962402344e+02 -7.1614898681640625e+01 -4.7079901695251465e+00 1.4487998962402344e+02 -6.2998802185058594e+01 -9.6578197479248047e+00 1.4487998962402344e+02 -7.4586395263671875e+01 -4.1508998870849609e+00 1.4487998962402344e+02 -7.6129402160644531e+01 4.3743300437927246e+00 1.4487998962402344e+02 -3.5103702545166016e+01 -1.2914000749588013e+00 1.4487998962402344e+02 -3.4325000762939453e+01 -3.0378599166870117e+00 1.4487998962402344e+02 -4.7108600616455078e+01 -6.9571299552917480e+00 1.4487998962402344e+02 -3.5103702545166016e+01 -1.2202699661254883e+01 1.4487998962402344e+02 -3.7382202148437500e+01 -1.0147500038146973e+01 1.5863000488281250e+02 -1.0554999542236328e+02 -1.2914000749588013e+00 1.6188000488281250e+02 -1.0632499694824219e+02 -1.2914000749588013e+00 1.5863000488281250e+02 -1.0632499694824219e+02 7.5646600723266602e+00 1.6188000488281250e+02 -1.0554999542236328e+02 7.5646600723266602e+00 1.5863000488281250e+02 -1.0554999542236328e+02 1.6151599884033203e+01 1.6188000488281250e+02 -1.0324900054931641e+02 1.6151599884033203e+01 1.5863000488281250e+02 -1.0324900054931641e+02 2.4208599090576172e+01 1.6188000488281250e+02 -9.9492294311523438e+01 2.4208599090576172e+01 1.5863000488281250e+02 -9.9492294311523438e+01 3.1490798950195312e+01 1.6188000488281250e+02 -9.4393295288085938e+01 3.1490798950195312e+01 1.5863000488281250e+02 -9.4393295288085938e+01 3.7776897430419922e+01 1.6188000488281250e+02 -8.8107200622558594e+01 3.7776897430419922e+01 1.5863000488281250e+02 -8.8107200622558594e+01 4.2875900268554688e+01 1.6188000488281250e+02 -8.0825004577636719e+01 4.2875900268554688e+01 1.5863000488281250e+02 -8.0825004577636719e+01 4.6632900238037109e+01 1.6188000488281250e+02 -7.2768005371093750e+01 4.6632900238037109e+01 1.5863000488281250e+02 -7.2768005371093750e+01 4.8933799743652344e+01 1.6188000488281250e+02 -6.4181098937988281e+01 4.8933799743652344e+01 1.5863000488281250e+02 -6.4181098937988281e+01 4.9708602905273438e+01 1.6188000488281250e+02 -5.5325000762939453e+01 4.9708602905273438e+01 1.5863000488281250e+02 -5.5325000762939453e+01 4.8933799743652344e+01 1.6188000488281250e+02 -4.6468898773193359e+01 4.8933799743652344e+01 1.5863000488281250e+02 -4.6468898773193359e+01 4.6632900238037109e+01 1.6188000488281250e+02 -3.7881999969482422e+01 4.6632900238037109e+01 1.5863000488281250e+02 -3.7881999969482422e+01 4.2875900268554688e+01 1.6188000488281250e+02 -2.9825000762939453e+01 4.2875900268554688e+01 1.5863000488281250e+02 -2.9825000762939453e+01 3.7776897430419922e+01 1.6188000488281250e+02 -2.2542800903320312e+01 3.7776897430419922e+01 1.5863000488281250e+02 -2.2542800903320312e+01 3.1490798950195312e+01 1.6188000488281250e+02 -1.6256698608398438e+01 3.1490798950195312e+01 1.5863000488281250e+02 -1.6256698608398438e+01 2.4208599090576172e+01 1.6188000488281250e+02 -1.1157699584960938e+01 2.4208599090576172e+01 1.5863000488281250e+02 -1.1157699584960938e+01 1.6151599884033203e+01 1.6188000488281250e+02 -7.4006800651550293e+00 1.6151599884033203e+01 1.5863000488281250e+02 -7.4006800651550293e+00 7.5646600723266602e+00 1.6188000488281250e+02 -5.0998101234436035e+00 7.5646600723266602e+00 1.5863000488281250e+02 -5.0998101234436035e+00 -1.2914000749588013e+00 1.6188000488281250e+02 -4.3250002861022949e+00 -1.2914000749588013e+00 1.5863000488281250e+02 -4.3250002861022949e+00 -1.0147500038146973e+01 1.6188000488281250e+02 -5.0998101234436035e+00 -1.0147500038146973e+01 1.5863000488281250e+02 -5.0998101234436035e+00 -1.8734399795532227e+01 1.6188000488281250e+02 -7.4006800651550293e+00 -1.8734399795532227e+01 1.5863000488281250e+02 -7.4006800651550293e+00 -2.6791399002075195e+01 1.6188000488281250e+02 -1.1157699584960938e+01 -2.6791399002075195e+01 1.5863000488281250e+02 -1.1157699584960938e+01 -3.4073596954345703e+01 1.6188000488281250e+02 -1.6256698608398438e+01 -3.4073596954345703e+01 1.5863000488281250e+02 -1.6256698608398438e+01 -4.0359699249267578e+01 1.6188000488281250e+02 -2.2542800903320312e+01 -4.0359699249267578e+01 1.5863000488281250e+02 -2.2542800903320312e+01 -4.5458702087402344e+01 1.6188000488281250e+02 -2.9825000762939453e+01 -4.5458702087402344e+01 1.5863000488281250e+02 -2.9825000762939453e+01 -4.9215702056884766e+01 1.6188000488281250e+02 -3.7881999969482422e+01 -4.9215702056884766e+01 1.5863000488281250e+02 -3.7881999969482422e+01 -5.1516601562500000e+01 1.6188000488281250e+02 -4.6468898773193359e+01 -5.1516601562500000e+01 1.5863000488281250e+02 -4.6468898773193359e+01 -5.2291400909423828e+01 1.6188000488281250e+02 -5.5325000762939453e+01 -5.2291400909423828e+01 1.5863000488281250e+02 -5.5325000762939453e+01 -5.1516601562500000e+01 1.6188000488281250e+02 -6.4181098937988281e+01 -5.1516601562500000e+01 1.5863000488281250e+02 -6.4181098937988281e+01 -4.9215702056884766e+01 1.6188000488281250e+02 -7.2768005371093750e+01 -4.9215702056884766e+01 1.5863000488281250e+02 -7.2768005371093750e+01 -4.5458702087402344e+01 1.6188000488281250e+02 -8.0825004577636719e+01 -4.5458702087402344e+01 1.5863000488281250e+02 -8.0825004577636719e+01 -4.0359699249267578e+01 1.6188000488281250e+02 -8.8107200622558594e+01 -4.0359699249267578e+01 1.5863000488281250e+02 -8.8107200622558594e+01 -3.4073596954345703e+01 1.6188000488281250e+02 -9.4393295288085938e+01 -3.4073596954345703e+01 1.5863000488281250e+02 -9.4393295288085938e+01 -2.6791399002075195e+01 1.6188000488281250e+02 -9.9492294311523438e+01 -2.6791399002075195e+01 1.5863000488281250e+02 -9.9492294311523438e+01 -1.8734399795532227e+01 1.6188000488281250e+02 -1.0324900054931641e+02 -1.8734399795532227e+01 1.5863000488281250e+02 -1.0324900054931641e+02 -1.0147500038146973e+01 1.6188000488281250e+02 -1.0554999542236328e+02 -5.6389098167419434e+00 1.6188000488281250e+02 -1.0362999725341797e+02 -1.4194199562072754e+01 1.6188000488281250e+02 -1.0207700347900391e+02 -2.2334798812866211e+01 1.6188000488281250e+02 -9.9022003173828125e+01 -2.9798999786376953e+01 1.6188000488281250e+02 -9.4562301635742188e+01 -3.6347000122070312e+01 1.6188000488281250e+02 -8.8841499328613281e+01 -4.1768199920654297e+01 1.6188000488281250e+02 -8.2043495178222656e+01 -4.5888500213623047e+01 1.6188000488281250e+02 -7.4386703491210938e+01 -4.8575401306152344e+01 1.6188000488281250e+02 -6.6117301940917969e+01 -4.9742603302001953e+01 1.6188000488281250e+02 -5.7500900268554688e+01 -4.9352500915527344e+01 1.6188000488281250e+02 -4.8814697265625000e+01 -4.7417598724365234e+01 1.6188000488281250e+02 -4.0337699890136719e+01 -4.4000301361083984e+01 1.6188000488281250e+02 -3.2342399597167969e+01 -3.9210201263427734e+01 1.6188000488281250e+02 -2.5085700988769531e+01 -3.3201400756835938e+01 1.6188000488281250e+02 -1.8801000595092773e+01 -2.6166999816894531e+01 1.6188000488281250e+02 -1.3690199851989746e+01 -1.8333099365234375e+01 1.6188000488281250e+02 -9.9176101684570312e+00 -9.9514102935791016e+00 1.6188000488281250e+02 -7.6044101715087891e+00 -1.2914000749588013e+00 1.6188000488281250e+02 -6.8249998092651367e+00 7.3686099052429199e+00 1.6188000488281250e+02 -7.6044101715087891e+00 1.5750300407409668e+01 1.6188000488281250e+02 -9.9176101684570312e+00 2.3584199905395508e+01 1.6188000488281250e+02 -1.3690199851989746e+01 3.0618600845336914e+01 1.6188000488281250e+02 -1.8801000595092773e+01 3.6627399444580078e+01 1.6188000488281250e+02 -2.5085700988769531e+01 4.1417499542236328e+01 1.6188000488281250e+02 -3.2342399597167969e+01 4.4834800720214844e+01 1.6188000488281250e+02 -4.0337699890136719e+01 4.6769699096679688e+01 1.6188000488281250e+02 -4.8814697265625000e+01 4.7159797668457031e+01 1.6188000488281250e+02 -5.7500900268554688e+01 4.5992603302001953e+01 1.6188000488281250e+02 -6.6117301940917969e+01 4.3305698394775391e+01 1.6188000488281250e+02 -7.4386703491210938e+01 3.9185401916503906e+01 1.6188000488281250e+02 -8.2043495178222656e+01 3.3764198303222656e+01 1.6188000488281250e+02 -8.8841499328613281e+01 2.7216199874877930e+01 1.6188000488281250e+02 -9.4562301635742188e+01 1.9751998901367188e+01 1.6188000488281250e+02 -9.9022003173828125e+01 1.1611400604248047e+01 1.6188000488281250e+02 -1.0207700347900391e+02 3.0561101436614990e+00 1.6188000488281250e+02 -1.0362999725341797e+02 -9.9514102935791016e+00 2.1288000488281250e+02 -7.6044101715087891e+00 -1.2914000749588013e+00 2.1288000488281250e+02 -6.8249998092651367e+00 7.3686099052429199e+00 2.1288000488281250e+02 -7.6044101715087891e+00 1.5750300407409668e+01 2.1288000488281250e+02 -9.9176101684570312e+00 2.3584199905395508e+01 2.1288000488281250e+02 -1.3690199851989746e+01 3.0618600845336914e+01 2.1288000488281250e+02 -1.8801000595092773e+01 3.6627399444580078e+01 2.1288000488281250e+02 -2.5085700988769531e+01 4.1417499542236328e+01 2.1288000488281250e+02 -3.2342399597167969e+01 4.4834800720214844e+01 2.1288000488281250e+02 -4.0337699890136719e+01 4.6769699096679688e+01 2.1288000488281250e+02 -4.8814697265625000e+01 4.7159797668457031e+01 2.1288000488281250e+02 -5.7500900268554688e+01 4.5992603302001953e+01 2.1288000488281250e+02 -6.6117301940917969e+01 4.3305698394775391e+01 2.1288000488281250e+02 -7.4386703491210938e+01 3.9185401916503906e+01 2.1288000488281250e+02 -8.2043495178222656e+01 3.3764198303222656e+01 2.1288000488281250e+02 -8.8841499328613281e+01 2.7216199874877930e+01 2.1288000488281250e+02 -9.4562301635742188e+01 1.9751998901367188e+01 2.1288000488281250e+02 -9.9022003173828125e+01 1.1611400604248047e+01 2.1288000488281250e+02 -1.0207700347900391e+02 3.0561101436614990e+00 2.1288000488281250e+02 -1.0362999725341797e+02 -5.6389098167419434e+00 2.1288000488281250e+02 -1.0362999725341797e+02 -1.4194199562072754e+01 2.1288000488281250e+02 -1.0207700347900391e+02 -2.2334798812866211e+01 2.1288000488281250e+02 -9.9022003173828125e+01 -2.9798999786376953e+01 2.1288000488281250e+02 -9.4562301635742188e+01 -3.6347000122070312e+01 2.1288000488281250e+02 -8.8841499328613281e+01 -4.1768199920654297e+01 2.1288000488281250e+02 -8.2043495178222656e+01 -4.5888500213623047e+01 2.1288000488281250e+02 -7.4386703491210938e+01 -4.8575401306152344e+01 2.1288000488281250e+02 -6.6117301940917969e+01 -4.9742603302001953e+01 2.1288000488281250e+02 -5.7500900268554688e+01 -4.9352500915527344e+01 2.1288000488281250e+02 -4.8814697265625000e+01 -4.7417598724365234e+01 2.1288000488281250e+02 -4.0337699890136719e+01 -4.4000301361083984e+01 2.1288000488281250e+02 -3.2342399597167969e+01 -3.9210201263427734e+01 2.1288000488281250e+02 -2.5085700988769531e+01 -3.3201400756835938e+01 2.1288000488281250e+02 -1.8801000595092773e+01 -2.6166999816894531e+01 2.1288000488281250e+02 -1.3690199851989746e+01 -1.8333099365234375e+01 2.1288000488281250e+02 -9.9176101684570312e+00 -1.8734399795532227e+01 2.1288000488281250e+02 -1.0324900054931641e+02 -1.0147500038146973e+01 2.1288000488281250e+02 -1.0554999542236328e+02 -1.2914000749588013e+00 2.1288000488281250e+02 -1.0632499694824219e+02 7.5646600723266602e+00 2.1288000488281250e+02 -1.0554999542236328e+02 1.6151599884033203e+01 2.1288000488281250e+02 -1.0324900054931641e+02 2.4208599090576172e+01 2.1288000488281250e+02 -9.9492294311523438e+01 3.1490798950195312e+01 2.1288000488281250e+02 -9.4393295288085938e+01 3.7776897430419922e+01 2.1288000488281250e+02 -8.8107200622558594e+01 4.2875900268554688e+01 2.1288000488281250e+02 -8.0825004577636719e+01 4.6632900238037109e+01 2.1288000488281250e+02 -7.2768005371093750e+01 4.8933799743652344e+01 2.1288000488281250e+02 -6.4181098937988281e+01 4.9708602905273438e+01 2.1288000488281250e+02 -5.5325000762939453e+01 4.8933799743652344e+01 2.1288000488281250e+02 -4.6468898773193359e+01 4.6632900238037109e+01 2.1288000488281250e+02 -3.7881999969482422e+01 4.2875900268554688e+01 2.1288000488281250e+02 -2.9825000762939453e+01 3.7776897430419922e+01 2.1288000488281250e+02 -2.2542800903320312e+01 3.1490798950195312e+01 2.1288000488281250e+02 -1.6256698608398438e+01 2.4208599090576172e+01 2.1288000488281250e+02 -1.1157699584960938e+01 1.6151599884033203e+01 2.1288000488281250e+02 -7.4006800651550293e+00 7.5646600723266602e+00 2.1288000488281250e+02 -5.0998101234436035e+00 -1.2914000749588013e+00 2.1288000488281250e+02 -4.3250002861022949e+00 -1.0147500038146973e+01 2.1288000488281250e+02 -5.0998101234436035e+00 -1.8734399795532227e+01 2.1288000488281250e+02 -7.4006800651550293e+00 -2.6791399002075195e+01 2.1288000488281250e+02 -1.1157699584960938e+01 -3.4073596954345703e+01 2.1288000488281250e+02 -1.6256698608398438e+01 -4.0359699249267578e+01 2.1288000488281250e+02 -2.2542800903320312e+01 -4.5458702087402344e+01 2.1288000488281250e+02 -2.9825000762939453e+01 -4.9215702056884766e+01 2.1288000488281250e+02 -3.7881999969482422e+01 -5.1516601562500000e+01 2.1288000488281250e+02 -4.6468898773193359e+01 -5.2291400909423828e+01 2.1288000488281250e+02 -5.5325000762939453e+01 -5.1516601562500000e+01 2.1288000488281250e+02 -6.4181098937988281e+01 -4.9215702056884766e+01 2.1288000488281250e+02 -7.2768005371093750e+01 -4.5458702087402344e+01 2.1288000488281250e+02 -8.0825004577636719e+01 -4.0359699249267578e+01 2.1288000488281250e+02 -8.8107200622558594e+01 -3.4073596954345703e+01 2.1288000488281250e+02 -9.4393295288085938e+01 -2.6791399002075195e+01 2.1288000488281250e+02 -9.9492294311523438e+01 -1.2914000749588013e+00 2.1613000488281250e+02 -1.0632499694824219e+02 7.5646600723266602e+00 2.1613000488281250e+02 -1.0554999542236328e+02 1.6151599884033203e+01 2.1613000488281250e+02 -1.0324900054931641e+02 2.4208599090576172e+01 2.1613000488281250e+02 -9.9492294311523438e+01 3.1490798950195312e+01 2.1613000488281250e+02 -9.4393295288085938e+01 3.7776897430419922e+01 2.1613000488281250e+02 -8.8107200622558594e+01 4.2875900268554688e+01 2.1613000488281250e+02 -8.0825004577636719e+01 4.6632900238037109e+01 2.1613000488281250e+02 -7.2768005371093750e+01 4.8933799743652344e+01 2.1613000488281250e+02 -6.4181098937988281e+01 4.9708602905273438e+01 2.1613000488281250e+02 -5.5325000762939453e+01 4.8933799743652344e+01 2.1613000488281250e+02 -4.6468898773193359e+01 4.6632900238037109e+01 2.1613000488281250e+02 -3.7881999969482422e+01 4.2875900268554688e+01 2.1613000488281250e+02 -2.9825000762939453e+01 3.7776897430419922e+01 2.1613000488281250e+02 -2.2542800903320312e+01 3.1490798950195312e+01 2.1613000488281250e+02 -1.6256698608398438e+01 2.4208599090576172e+01 2.1613000488281250e+02 -1.1157699584960938e+01 1.6151599884033203e+01 2.1613000488281250e+02 -7.4006800651550293e+00 7.5646600723266602e+00 2.1613000488281250e+02 -5.0998101234436035e+00 -1.2914000749588013e+00 2.1613000488281250e+02 -4.3250002861022949e+00 -1.0147500038146973e+01 2.1613000488281250e+02 -5.0998101234436035e+00 -1.8734399795532227e+01 2.1613000488281250e+02 -7.4006800651550293e+00 -2.6791399002075195e+01 2.1613000488281250e+02 -1.1157699584960938e+01 -3.4073596954345703e+01 2.1613000488281250e+02 -1.6256698608398438e+01 -4.0359699249267578e+01 2.1613000488281250e+02 -2.2542800903320312e+01 -4.5458702087402344e+01 2.1613000488281250e+02 -2.9825000762939453e+01 -4.9215702056884766e+01 2.1613000488281250e+02 -3.7881999969482422e+01 -5.1516601562500000e+01 2.1613000488281250e+02 -4.6468898773193359e+01 -5.2291400909423828e+01 2.1613000488281250e+02 -5.5325000762939453e+01 -5.1516601562500000e+01 2.1613000488281250e+02 -6.4181098937988281e+01 -4.9215702056884766e+01 2.1613000488281250e+02 -7.2768005371093750e+01 -4.5458702087402344e+01 2.1613000488281250e+02 -8.0825004577636719e+01 -4.0359699249267578e+01 2.1613000488281250e+02 -8.8107200622558594e+01 -3.4073596954345703e+01 2.1613000488281250e+02 -9.4393295288085938e+01 -2.6791399002075195e+01 2.1613000488281250e+02 -9.9492294311523438e+01 -1.8734399795532227e+01 2.1613000488281250e+02 -1.0324900054931641e+02 -1.0147500038146973e+01 2.1613000488281250e+02 -1.0554999542236328e+02 -5.4738698005676270e+00 2.1613000488281250e+02 -9.9125801086425781e+01 -1.3687600135803223e+01 2.1613000488281250e+02 -9.7542701721191406e+01 3.8732398986816406e+01 2.1613000488281250e+02 -3.7046699523925781e+01 4.1468299865722656e+01 2.1613000488281250e+02 -4.4951599121093750e+01 4.2658798217773438e+01 2.1613000488281250e+02 -5.3231399536132812e+01 4.2260700225830078e+01 2.1613000488281250e+02 -6.1586902618408203e+01 4.0288600921630859e+01 2.1613000488281250e+02 -6.9715995788574219e+01 3.6813697814941406e+01 2.1613000488281250e+02 -7.7325004577636719e+01 3.1961601257324219e+01 2.1613000488281250e+02 -8.4138900756835938e+01 2.5907600402832031e+01 2.1613000488281250e+02 -8.9911300659179688e+01 1.8870599746704102e+01 2.1613000488281250e+02 -9.4433799743652344e+01 1.1104800224304199e+01 2.1613000488281250e+02 -9.7542701721191406e+01 2.8910698890686035e+00 2.1613000488281250e+02 -9.9125801086425781e+01 -4.1315200805664062e+01 2.1613000488281250e+02 -3.7046699523925781e+01 -3.7132698059082031e+01 2.1613000488281250e+02 -2.9802499771118164e+01 -3.1654901504516602e+01 2.1613000488281250e+02 -2.3480699539184570e+01 -2.5079601287841797e+01 2.1613000488281250e+02 -1.8309799194335938e+01 -1.7644500732421875e+01 2.1613000488281250e+02 -1.4476799964904785e+01 -9.6184501647949219e+00 2.1613000488281250e+02 -1.2120100021362305e+01 -1.2914000749588013e+00 2.1613000488281250e+02 -1.1324999809265137e+01 7.0356497764587402e+00 2.1613000488281250e+02 -1.2120100021362305e+01 1.5061699867248535e+01 2.1613000488281250e+02 -1.4476799964904785e+01 2.2496801376342773e+01 2.1613000488281250e+02 -1.8309799194335938e+01 2.9072099685668945e+01 2.1613000488281250e+02 -2.3480699539184570e+01 3.4549900054931641e+01 2.1613000488281250e+02 -2.9802499771118164e+01 -2.1453399658203125e+01 2.1613000488281250e+02 -9.4433799743652344e+01 -2.8490400314331055e+01 2.1613000488281250e+02 -8.9911300659179688e+01 -3.4544399261474609e+01 2.1613000488281250e+02 -8.4138900756835938e+01 -3.9396499633789062e+01 2.1613000488281250e+02 -7.7325004577636719e+01 -4.2871398925781250e+01 2.1613000488281250e+02 -6.9715995788574219e+01 -4.4843498229980469e+01 2.1613000488281250e+02 -6.1586902618408203e+01 -4.5241600036621094e+01 2.1613000488281250e+02 -5.3231399536132812e+01 -4.4051097869873047e+01 2.1613000488281250e+02 -4.4951599121093750e+01 -7.3947501182556152e+00 2.2788000488281250e+02 -2.3657800674438477e+01 -1.3277500152587891e+01 2.2788000488281250e+02 -2.5385101318359375e+01 -1.8727100372314453e+01 2.2788000488281250e+02 -2.8194601058959961e+01 -2.3546400070190430e+01 2.2788000488281250e+02 -3.1984601974487305e+01 -2.7561500549316406e+01 2.2788000488281250e+02 -3.6618198394775391e+01 -3.0626998901367188e+01 2.2788000488281250e+02 -4.1927898406982422e+01 -3.2632297515869141e+01 2.2788000488281250e+02 -4.7721797943115234e+01 -3.3504898071289062e+01 2.2788000488281250e+02 -5.3790496826171875e+01 -3.3213100433349609e+01 2.2788000488281250e+02 -5.9914699554443359e+01 -3.1767700195312500e+01 2.2788000488281250e+02 -6.5872901916503906e+01 -2.9220699310302734e+01 2.2788000488281250e+02 -7.1450004577636719e+01 -2.5664299011230469e+01 2.2788000488281250e+02 -7.6444297790527344e+01 -2.1227001190185547e+01 2.2788000488281250e+02 -8.0675201416015625e+01 -1.6069200515747070e+01 2.2788000488281250e+02 -8.3989906311035156e+01 -1.0377300262451172e+01 2.2788000488281250e+02 -8.6268592834472656e+01 -4.3569598197937012e+00 2.2788000488281250e+02 -8.7429000854492188e+01 1.7741599082946777e+00 2.2788000488281250e+02 -8.7429000854492188e+01 7.7944798469543457e+00 2.2788000488281250e+02 -8.6268592834472656e+01 1.3486400604248047e+01 2.2788000488281250e+02 -8.3989906311035156e+01 1.8644201278686523e+01 2.2788000488281250e+02 -8.0675201416015625e+01 2.3081501007080078e+01 2.2788000488281250e+02 -7.6444297790527344e+01 2.6637901306152344e+01 2.2788000488281250e+02 -7.1450004577636719e+01 2.9184900283813477e+01 2.2788000488281250e+02 -6.5872901916503906e+01 3.0630300521850586e+01 2.2788000488281250e+02 -5.9914699554443359e+01 3.0922100067138672e+01 2.2788000488281250e+02 -5.3790496826171875e+01 3.0049499511718750e+01 2.2788000488281250e+02 -4.7721797943115234e+01 2.8044198989868164e+01 2.2788000488281250e+02 -4.1927898406982422e+01 2.4978698730468750e+01 2.2788000488281250e+02 -3.6618198394775391e+01 2.0963600158691406e+01 2.2788000488281250e+02 -3.1984601974487305e+01 1.6144300460815430e+01 2.2788000488281250e+02 -2.8194601058959961e+01 1.0694700241088867e+01 2.2788000488281250e+02 -2.5385101318359375e+01 4.8119502067565918e+00 2.2788000488281250e+02 -2.3657800674438477e+01 -1.2914000749588013e+00 2.2788000488281250e+02 -2.3074998855590820e+01 7.0750203132629395e+00 2.2788000488281250e+02 -7.4586395263671875e+01 1.5680999755859375e+00 2.2788000488281250e+02 -7.6129402160644531e+01 -4.1508998870849609e+00 2.2788000488281250e+02 -7.6129402160644531e+01 1.9269399642944336e+01 2.2788000488281250e+02 -5.1052398681640625e+01 1.9659599304199219e+01 2.2788000488281250e+02 -5.6758098602294922e+01 1.8496099472045898e+01 2.2788000488281250e+02 -6.2357501983642578e+01 1.5864999771118164e+01 2.2788000488281250e+02 -6.7435302734375000e+01 4.3743300437927246e+00 2.2788000488281250e+02 -3.5103702545166016e+01 9.6198596954345703e+00 2.2788000488281250e+02 -3.7382202148437500e+01 1.4056200027465820e+01 2.2788000488281250e+02 -4.0991397857666016e+01 1.1961400032043457e+01 2.2788000488281250e+02 -7.1614898681640625e+01 1.7354200363159180e+01 2.2788000488281250e+02 -4.5663597106933594e+01 -1.2202699661254883e+01 2.2788000488281250e+02 -3.7382202148437500e+01 -6.9571299552917480e+00 2.2788000488281250e+02 -3.5103702545166016e+01 -1.2914000749588013e+00 2.2788000488281250e+02 -3.4325000762939453e+01 -9.6578197479248047e+00 2.2788000488281250e+02 -7.4586395263671875e+01 -1.4544199943542480e+01 2.2788000488281250e+02 -7.1614898681640625e+01 -1.9936998367309570e+01 2.2788000488281250e+02 -4.5663597106933594e+01 -1.6638999938964844e+01 2.2788000488281250e+02 -4.0991397857666016e+01 -1.8447799682617188e+01 2.2788000488281250e+02 -6.7435302734375000e+01 -2.1078899383544922e+01 2.2788000488281250e+02 -6.2357501983642578e+01 -2.2242401123046875e+01 2.2788000488281250e+02 -5.6758098602294922e+01 -2.1852201461791992e+01 2.2788000488281250e+02 -5.1052398681640625e+01 -6.9571299552917480e+00 2.2988000488281250e+02 -3.5103702545166016e+01 -1.2914000749588013e+00 2.2988000488281250e+02 -3.4325000762939453e+01 4.3743300437927246e+00 2.2988000488281250e+02 -3.5103702545166016e+01 9.6198596954345703e+00 2.2988000488281250e+02 -3.7382202148437500e+01 1.4056200027465820e+01 2.2988000488281250e+02 -4.0991397857666016e+01 1.7354200363159180e+01 2.2988000488281250e+02 -4.5663597106933594e+01 1.9269399642944336e+01 2.2988000488281250e+02 -5.1052398681640625e+01 1.9659599304199219e+01 2.2988000488281250e+02 -5.6758098602294922e+01 1.8496099472045898e+01 2.2988000488281250e+02 -6.2357501983642578e+01 1.5864999771118164e+01 2.2988000488281250e+02 -6.7435302734375000e+01 1.1961400032043457e+01 2.2988000488281250e+02 -7.1614898681640625e+01 7.0750203132629395e+00 2.2988000488281250e+02 -7.4586395263671875e+01 1.5680999755859375e+00 2.2988000488281250e+02 -7.6129402160644531e+01 -4.1508998870849609e+00 2.2988000488281250e+02 -7.6129402160644531e+01 -9.6578197479248047e+00 2.2988000488281250e+02 -7.4586395263671875e+01 -1.4544199943542480e+01 2.2988000488281250e+02 -7.1614898681640625e+01 -1.8447799682617188e+01 2.2988000488281250e+02 -6.7435302734375000e+01 -2.1078899383544922e+01 2.2988000488281250e+02 -6.2357501983642578e+01 -2.2242401123046875e+01 2.2988000488281250e+02 -5.6758098602294922e+01 -2.1852201461791992e+01 2.2988000488281250e+02 -5.1052398681640625e+01 -1.9936998367309570e+01 2.2988000488281250e+02 -4.5663597106933594e+01 -1.6638999938964844e+01 2.2988000488281250e+02 -4.0991397857666016e+01 -1.2202699661254883e+01 2.2988000488281250e+02 -3.7382202148437500e+01 -3.0378599166870117e+00 2.2988000488281250e+02 -6.3541397094726562e+01 -1.2914000749588013e+00 2.2988000488281250e+02 -6.3725002288818359e+01 4.5505800843238831e-01 2.2988000488281250e+02 -6.3541397094726562e+01 3.6460001468658447e+00 2.2988000488281250e+02 -6.2120697021484375e+01 7.0625801086425781e+00 2.2988000488281250e+02 -5.6202999114990234e+01 5.9832100868225098e+00 2.2988000488281250e+02 -5.9525001525878906e+01 -1.2914000749588013e+00 2.2988000488281250e+02 -4.6924999237060547e+01 2.1251900196075439e+00 2.2988000488281250e+02 -4.7651203155517578e+01 4.9510197639465332e+00 2.2988000488281250e+02 -4.9704299926757812e+01 6.6974697113037109e+00 2.2988000488281250e+02 -5.2729301452636719e+01 -4.7079901695251465e+00 2.2988000488281250e+02 -4.7651203155517578e+01 -9.2802696228027344e+00 2.2988000488281250e+02 -5.2729301452636719e+01 -7.5338196754455566e+00 2.2988000488281250e+02 -4.9704299926757812e+01 -8.5660095214843750e+00 2.2988000488281250e+02 -5.9525001525878906e+01 -9.6453800201416016e+00 2.2988000488281250e+02 -5.6202999114990234e+01 -6.2287998199462891e+00 2.2988000488281250e+02 -6.2120697021484375e+01 -4.1315200805664062e+01 1.5863000488281250e+02 -3.7046699523925781e+01 -4.4051097869873047e+01 1.5863000488281250e+02 -4.4951599121093750e+01 -4.5241600036621094e+01 1.5863000488281250e+02 -5.3231399536132812e+01 -4.4843498229980469e+01 1.5863000488281250e+02 -6.1586902618408203e+01 -4.2871398925781250e+01 1.5863000488281250e+02 -6.9715995788574219e+01 -3.9396499633789062e+01 1.5863000488281250e+02 -7.7325004577636719e+01 -3.4544399261474609e+01 1.5863000488281250e+02 -8.4138900756835938e+01 -2.8490400314331055e+01 1.5863000488281250e+02 -8.9911300659179688e+01 -2.1453399658203125e+01 1.5863000488281250e+02 -9.4433799743652344e+01 -1.3687600135803223e+01 1.5863000488281250e+02 -9.7542701721191406e+01 -5.4738698005676270e+00 1.5863000488281250e+02 -9.9125801086425781e+01 2.8910698890686035e+00 1.5863000488281250e+02 -9.9125801086425781e+01 3.4549900054931641e+01 1.5863000488281250e+02 -2.9802499771118164e+01 2.9072099685668945e+01 1.5863000488281250e+02 -2.3480699539184570e+01 2.2496801376342773e+01 1.5863000488281250e+02 -1.8309799194335938e+01 1.5061699867248535e+01 1.5863000488281250e+02 -1.4476799964904785e+01 7.0356497764587402e+00 1.5863000488281250e+02 -1.2120100021362305e+01 -1.2914000749588013e+00 1.5863000488281250e+02 -1.1324999809265137e+01 -9.6184501647949219e+00 1.5863000488281250e+02 -1.2120100021362305e+01 -1.7644500732421875e+01 1.5863000488281250e+02 -1.4476799964904785e+01 -2.5079601287841797e+01 1.5863000488281250e+02 -1.8309799194335938e+01 -3.1654901504516602e+01 1.5863000488281250e+02 -2.3480699539184570e+01 -3.7132698059082031e+01 1.5863000488281250e+02 -2.9802499771118164e+01 1.1104800224304199e+01 1.5863000488281250e+02 -9.7542701721191406e+01 1.8870599746704102e+01 1.5863000488281250e+02 -9.4433799743652344e+01 2.5907600402832031e+01 1.5863000488281250e+02 -8.9911300659179688e+01 3.1961601257324219e+01 1.5863000488281250e+02 -8.4138900756835938e+01 3.6813697814941406e+01 1.5863000488281250e+02 -7.7325004577636719e+01 4.0288600921630859e+01 1.5863000488281250e+02 -6.9715995788574219e+01 4.2260700225830078e+01 1.5863000488281250e+02 -6.1586902618408203e+01 4.2658798217773438e+01 1.5863000488281250e+02 -5.3231399536132812e+01 4.1468299865722656e+01 1.5863000488281250e+02 -4.4951599121093750e+01 3.8732398986816406e+01 1.5863000488281250e+02 -3.7046699523925781e+01 4.8119502067565918e+00 1.4688000488281250e+02 -2.3657800674438477e+01 1.0694700241088867e+01 1.4688000488281250e+02 -2.5385101318359375e+01 1.6144300460815430e+01 1.4688000488281250e+02 -2.8194601058959961e+01 2.0963600158691406e+01 1.4688000488281250e+02 -3.1984601974487305e+01 2.4978698730468750e+01 1.4688000488281250e+02 -3.6618198394775391e+01 2.8044198989868164e+01 1.4688000488281250e+02 -4.1927898406982422e+01 3.0049499511718750e+01 1.4688000488281250e+02 -4.7721797943115234e+01 3.0922100067138672e+01 1.4688000488281250e+02 -5.3790496826171875e+01 3.0630300521850586e+01 1.4688000488281250e+02 -5.9914699554443359e+01 2.9184900283813477e+01 1.4688000488281250e+02 -6.5872901916503906e+01 2.6637901306152344e+01 1.4688000488281250e+02 -7.1450004577636719e+01 2.3081501007080078e+01 1.4688000488281250e+02 -7.6444297790527344e+01 1.8644201278686523e+01 1.4688000488281250e+02 -8.0675201416015625e+01 1.3486400604248047e+01 1.4688000488281250e+02 -8.3989906311035156e+01 7.7944798469543457e+00 1.4688000488281250e+02 -8.6268592834472656e+01 1.7741599082946777e+00 1.4688000488281250e+02 -8.7429000854492188e+01 -4.3569598197937012e+00 1.4688000488281250e+02 -8.7429000854492188e+01 -1.0377300262451172e+01 1.4688000488281250e+02 -8.6268592834472656e+01 -1.6069200515747070e+01 1.4688000488281250e+02 -8.3989906311035156e+01 -2.1227001190185547e+01 1.4688000488281250e+02 -8.0675201416015625e+01 -2.5664299011230469e+01 1.4688000488281250e+02 -7.6444297790527344e+01 -2.9220699310302734e+01 1.4688000488281250e+02 -7.1450004577636719e+01 -3.1767700195312500e+01 1.4688000488281250e+02 -6.5872901916503906e+01 -3.3213100433349609e+01 1.4688000488281250e+02 -5.9914699554443359e+01 -3.3504898071289062e+01 1.4688000488281250e+02 -5.3790496826171875e+01 -3.2632297515869141e+01 1.4688000488281250e+02 -4.7721797943115234e+01 -3.0626998901367188e+01 1.4688000488281250e+02 -4.1927898406982422e+01 -2.7561500549316406e+01 1.4688000488281250e+02 -3.6618198394775391e+01 -2.3546400070190430e+01 1.4688000488281250e+02 -3.1984601974487305e+01 -1.8727100372314453e+01 1.4688000488281250e+02 -2.8194601058959961e+01 -1.3277500152587891e+01 1.4688000488281250e+02 -2.5385101318359375e+01 -7.3947501182556152e+00 1.4688000488281250e+02 -2.3657800674438477e+01 -1.2914000749588013e+00 1.4688000488281250e+02 -2.3074998855590820e+01 9.6198596954345703e+00 1.4688000488281250e+02 -3.7382202148437500e+01 4.3743300437927246e+00 1.4688000488281250e+02 -3.5103702545166016e+01 -1.2914000749588013e+00 1.4688000488281250e+02 -3.4325000762939453e+01 -6.9571299552917480e+00 1.4688000488281250e+02 -3.5103702545166016e+01 -1.2202699661254883e+01 1.4688000488281250e+02 -3.7382202148437500e+01 -1.6638999938964844e+01 1.4688000488281250e+02 -4.0991397857666016e+01 -1.9936998367309570e+01 1.4688000488281250e+02 -4.5663597106933594e+01 -2.1852201461791992e+01 1.4688000488281250e+02 -5.1052398681640625e+01 1.7354200363159180e+01 1.4688000488281250e+02 -4.5663597106933594e+01 1.4056200027465820e+01 1.4688000488281250e+02 -4.0991397857666016e+01 1.5680999755859375e+00 1.4688000488281250e+02 -7.6129402160644531e+01 7.0750203132629395e+00 1.4688000488281250e+02 -7.4586395263671875e+01 1.1961400032043457e+01 1.4688000488281250e+02 -7.1614898681640625e+01 -2.2242401123046875e+01 1.4688000488281250e+02 -5.6758098602294922e+01 -2.1078899383544922e+01 1.4688000488281250e+02 -6.2357501983642578e+01 -1.8447799682617188e+01 1.4688000488281250e+02 -6.7435302734375000e+01 1.5864999771118164e+01 1.4688000488281250e+02 -6.7435302734375000e+01 1.8496099472045898e+01 1.4688000488281250e+02 -6.2357501983642578e+01 1.9659599304199219e+01 1.4688000488281250e+02 -5.6758098602294922e+01 1.9269399642944336e+01 1.4688000488281250e+02 -5.1052398681640625e+01 -9.6578197479248047e+00 1.4688000488281250e+02 -7.4586395263671875e+01 -4.1508998870849609e+00 1.4688000488281250e+02 -7.6129402160644531e+01 -1.4544199943542480e+01 1.4688000488281250e+02 -7.1614898681640625e+01 -3.0378599166870117e+00 1.4262998962402344e+02 -4.7108600616455078e+01 -1.2914000749588013e+00 1.4262998962402344e+02 -4.6924999237060547e+01 -6.2287998199462891e+00 1.4262998962402344e+02 -4.8529300689697266e+01 -8.5660095214843750e+00 1.4262998962402344e+02 -5.1125000000000000e+01 -9.6453800201416016e+00 1.4262998962402344e+02 -5.4446998596191406e+01 -9.2802696228027344e+00 1.4262998962402344e+02 -5.7920700073242188e+01 -7.5338196754455566e+00 1.4262998962402344e+02 -6.0945701599121094e+01 -4.7079901695251465e+00 1.4262998962402344e+02 -6.2998802185058594e+01 -1.2914000749588013e+00 1.4262998962402344e+02 -6.3725002288818359e+01 2.1251900196075439e+00 1.4262998962402344e+02 -6.2998802185058594e+01 4.9510197639465332e+00 1.4262998962402344e+02 -6.0945701599121094e+01 6.6974697113037109e+00 1.4262998962402344e+02 -5.7920700073242188e+01 7.0625801086425781e+00 1.4262998962402344e+02 -5.4446998596191406e+01 5.9832100868225098e+00 1.4262998962402344e+02 -5.1125000000000000e+01 3.6460001468658447e+00 1.4262998962402344e+02 -4.8529300689697266e+01 4.5505800843238831e-01 1.4262998962402344e+02 -4.7108600616455078e+01 -3.0378599166870117e+00 2.3213000488281250e+02 -6.3541397094726562e+01 -6.2287998199462891e+00 2.3213000488281250e+02 -6.2120697021484375e+01 -8.5660095214843750e+00 2.3213000488281250e+02 -5.9525001525878906e+01 -9.6453800201416016e+00 2.3213000488281250e+02 -5.6202999114990234e+01 -9.2802696228027344e+00 2.3213000488281250e+02 -5.2729301452636719e+01 -7.5338196754455566e+00 2.3213000488281250e+02 -4.9704299926757812e+01 -4.7079901695251465e+00 2.3213000488281250e+02 -4.7651203155517578e+01 -1.2914000749588013e+00 2.3213000488281250e+02 -4.6924999237060547e+01 2.1251900196075439e+00 2.3213000488281250e+02 -4.7651203155517578e+01 4.9510197639465332e+00 2.3213000488281250e+02 -4.9704299926757812e+01 6.6974697113037109e+00 2.3213000488281250e+02 -5.2729301452636719e+01 7.0625801086425781e+00 2.3213000488281250e+02 -5.6202999114990234e+01 5.9832100868225098e+00 2.3213000488281250e+02 -5.9525001525878906e+01 3.6460001468658447e+00 2.3213000488281250e+02 -6.2120697021484375e+01 4.5505800843238831e-01 2.3213000488281250e+02 -6.3541397094726562e+01 -2.0768399238586426e+00 1.6188000488281250e+02 -1.0381900024414062e+02 -1.0974200248718262e+01 2.1288000488281250e+02 -1.0284899902343750e+02 -1.0974200248718262e+01 1.6188000488281250e+02 -1.0284899902343750e+02 -1.9541700363159180e+01 2.1288000488281250e+02 -1.0025999450683594e+02 -1.9541700363159180e+01 1.6188000488281250e+02 -1.0025999450683594e+02 -2.7487798690795898e+01 2.1288000488281250e+02 -9.6141601562500000e+01 -2.7487798690795898e+01 1.6188000488281250e+02 -9.6141601562500000e+01 -3.4541801452636719e+01 2.1288000488281250e+02 -9.0633102416992188e+01 -3.4541801452636719e+01 1.6188000488281250e+02 -9.0633102416992188e+01 -4.0463500976562500e+01 2.1288000488281250e+02 -8.3922103881835938e+01 -4.0463500976562500e+01 1.6188000488281250e+02 -8.3922103881835938e+01 -4.5051197052001953e+01 2.1288000488281250e+02 -7.6237403869628906e+01 -4.5051197052001953e+01 1.6188000488281250e+02 -7.6237403869628906e+01 -4.8148799896240234e+01 2.1288000488281250e+02 -6.7840499877929688e+01 -4.8148799896240234e+01 1.6188000488281250e+02 -6.7840499877929688e+01 -4.9650596618652344e+01 2.1288000488281250e+02 -5.9017299652099609e+01 -4.9650596618652344e+01 1.6188000488281250e+02 -5.9017299652099609e+01 -4.9505699157714844e+01 2.1288000488281250e+02 -5.0068500518798828e+01 -4.9505699157714844e+01 1.6188000488281250e+02 -5.0068500518798828e+01 -4.7718902587890625e+01 2.1288000488281250e+02 -4.1298603057861328e+01 -4.7718902587890625e+01 1.6188000488281250e+02 -4.1298603057861328e+01 -4.4351001739501953e+01 2.1288000488281250e+02 -3.3006401062011719e+01 -4.4351001739501953e+01 1.6188000488281250e+02 -3.3006401062011719e+01 -3.9516799926757812e+01 2.1288000488281250e+02 -2.5474300384521484e+01 -3.9516799926757812e+01 1.6188000488281250e+02 -2.5474300384521484e+01 -3.3380901336669922e+01 2.1288000488281250e+02 -1.8958600997924805e+01 -3.3380901336669922e+01 1.6188000488281250e+02 -1.8958600997924805e+01 -2.6152198791503906e+01 2.1288000488281250e+02 -1.3681399345397949e+01 -2.6152198791503906e+01 1.6188000488281250e+02 -1.3681399345397949e+01 -1.8076900482177734e+01 2.1288000488281250e+02 -9.8222904205322266e+00 -1.8076900482177734e+01 1.6188000488281250e+02 -9.8222904205322266e+00 -9.4300203323364258e+00 2.1288000488281250e+02 -7.5127396583557129e+00 -9.4300203323364258e+00 1.6188000488281250e+02 -7.5127396583557129e+00 -5.0595897436141968e-01 2.1288000488281250e+02 -6.8313598632812500e+00 -5.0595897436141968e-01 1.6188000488281250e+02 -6.8313598632812500e+00 8.3913497924804688e+00 2.1288000488281250e+02 -7.8013801574707031e+00 8.3913497924804688e+00 1.6188000488281250e+02 -7.8013801574707031e+00 1.6958900451660156e+01 2.1288000488281250e+02 -1.0389800071716309e+01 1.6958900451660156e+01 1.6188000488281250e+02 -1.0389800071716309e+01 2.4905000686645508e+01 2.1288000488281250e+02 -1.4508399963378906e+01 2.4905000686645508e+01 1.6188000488281250e+02 -1.4508399963378906e+01 3.1959001541137695e+01 2.1288000488281250e+02 -2.0016899108886719e+01 3.1959001541137695e+01 1.6188000488281250e+02 -2.0016899108886719e+01 3.7880699157714844e+01 2.1288000488281250e+02 -2.6727899551391602e+01 3.7880699157714844e+01 1.6188000488281250e+02 -2.6727899551391602e+01 4.2468399047851562e+01 2.1288000488281250e+02 -3.4412601470947266e+01 4.2468399047851562e+01 1.6188000488281250e+02 -3.4412601470947266e+01 4.5566001892089844e+01 2.1288000488281250e+02 -4.2809501647949219e+01 4.5566001892089844e+01 1.6188000488281250e+02 -4.2809501647949219e+01 4.7067798614501953e+01 2.1288000488281250e+02 -5.1632698059082031e+01 4.7067798614501953e+01 1.6188000488281250e+02 -5.1632698059082031e+01 4.6922901153564453e+01 2.1288000488281250e+02 -6.0581501007080078e+01 4.6922901153564453e+01 1.6188000488281250e+02 -6.0581501007080078e+01 4.5136100769042969e+01 2.1288000488281250e+02 -6.9351394653320312e+01 4.5136100769042969e+01 1.6188000488281250e+02 -6.9351394653320312e+01 4.1768199920654297e+01 2.1288000488281250e+02 -7.7643600463867188e+01 4.1768199920654297e+01 1.6188000488281250e+02 -7.7643600463867188e+01 3.6933998107910156e+01 2.1288000488281250e+02 -8.5175697326660156e+01 3.6933998107910156e+01 1.6188000488281250e+02 -8.5175697326660156e+01 3.0798099517822266e+01 2.1288000488281250e+02 -9.1691398620605469e+01 3.0798099517822266e+01 1.6188000488281250e+02 -9.1691398620605469e+01 2.3569398880004883e+01 2.1288000488281250e+02 -9.6968597412109375e+01 2.3569398880004883e+01 1.6188000488281250e+02 -9.6968597412109375e+01 1.5494099617004395e+01 2.1288000488281250e+02 -1.0082800292968750e+02 1.5494099617004395e+01 1.6188000488281250e+02 -1.0082800292968750e+02 6.8472199440002441e+00 2.1288000488281250e+02 -1.0313700103759766e+02 6.8472199440002441e+00 1.6188000488281250e+02 -1.0313700103759766e+02 -2.0768399238586426e+00 2.1288000488281250e+02 -1.0381900024414062e+02 -5.7242898941040039e+00 2.1288000488281250e+02 -1.0897100067138672e+02 1.3232899665832520e+01 2.1288000488281250e+02 -1.0715799713134766e+02 7.0005302429199219e+00 2.1288000488281250e+02 -1.0851200103759766e+02 6.5175896883010864e-01 2.1288000488281250e+02 -1.0911899566650391e+02 2.5001300811767578e+01 2.1288000488281250e+02 -1.0229600524902344e+02 1.9261400222778320e+01 2.1288000488281250e+02 -1.0507599639892578e+02 4.3159400939941406e+01 2.1288000488281250e+02 -2.4965299606323242e+01 6.3117499351501465e+00 2.1288000488281250e+02 -2.0353899002075195e+00 1.2561100006103516e+01 2.1288000488281250e+02 -3.3086698055267334e+00 -3.5478302001953125e+01 2.1288000488281250e+02 -1.3745600700378418e+01 3.9711299896240234e+01 2.1288000488281250e+02 -9.0201400756835938e+01 3.5298599243164062e+01 2.1288000488281250e+02 -9.4806198120117188e+01 3.0372200012207031e+01 2.1288000488281250e+02 -9.8856704711914062e+01 5.2536800384521484e+01 2.1288000488281250e+02 -5.4976799011230469e+01 1.8616001129150391e+01 2.1288000488281250e+02 -5.3121500015258789e+00 2.4391500473022461e+01 2.1288000488281250e+02 -8.0177001953125000e+00 2.9806400299072266e+01 2.1288000488281250e+02 -1.1387299537658691e+01 3.4784801483154297e+01 2.1288000488281250e+02 -1.5373800277709961e+01 3.9256698608398438e+01 2.1288000488281250e+02 -1.9920999526977539e+01 -3.9670898437500000e+01 2.1288000488281250e+02 -9.3068901062011719e+01 5.2200099945068359e+01 2.1288000488281250e+02 -6.1345699310302734e+01 5.1112598419189453e+01 2.1288000488281250e+02 -6.7629997253417969e+01 4.9289402008056641e+01 2.1288000488281250e+02 -7.3741600036621094e+01 4.6756198883056641e+01 2.1288000488281250e+02 -7.9594703674316406e+01 4.3548500061035156e+01 2.1288000488281250e+02 -8.5107101440429688e+01 4.6438198089599609e+01 2.1288000488281250e+02 -3.0435699462890625e+01 4.9046901702880859e+01 2.1288000488281250e+02 -3.6255500793457031e+01 5.0949001312255859e+01 2.1288000488281250e+02 -4.2343097686767578e+01 5.2117702484130859e+01 2.1288000488281250e+02 -4.8612800598144531e+01 -6.4179501533508301e+00 2.1288000488281250e+02 -1.7403999567031860e+00 -4.4343903660774231e-02 2.1288000488281250e+02 -1.5101799964904785e+00 -5.4209098815917969e+01 2.1288000488281250e+02 -6.5189399719238281e+01 -5.5004398345947266e+01 2.1288000488281250e+02 -5.8861400604248047e+01 -4.3865600585937500e+01 2.1288000488281250e+02 -8.8264694213867188e+01 -4.7462699890136719e+01 2.1288000488281250e+02 -8.2998100280761719e+01 -5.0411602020263672e+01 2.1288000488281250e+02 -7.7343002319335938e+01 -5.2671001434326172e+01 2.1288000488281250e+02 -7.1378898620605469e+01 -3.0320600509643555e+01 2.1288000488281250e+02 -9.9940099716186523e+00 -2.4755399703979492e+01 2.1288000488281250e+02 -6.8788099288940430e+00 -1.8860799789428711e+01 2.1288000488281250e+02 -4.4436998367309570e+00 -1.2719600677490234e+01 2.1288000488281250e+02 -2.7228400707244873e+00 -1.2038099288940430e+01 2.1288000488281250e+02 -1.0807099914550781e+02 -1.8201099395751953e+01 2.1288000488281250e+02 -1.0642900085449219e+02 -2.4126699447631836e+01 2.1288000488281250e+02 -1.0407099914550781e+02 -2.9731700897216797e+01 2.1288000488281250e+02 -1.0102799987792969e+02 -3.4937500000000000e+01 2.1288000488281250e+02 -9.7343200683593750e+01 -5.0692401885986328e+01 2.1288000488281250e+02 -3.3944301605224609e+01 -4.7816898345947266e+01 2.1288000488281250e+02 -2.8251501083374023e+01 -4.4288200378417969e+01 2.1288000488281250e+02 -2.2938798904418945e+01 -4.0155998229980469e+01 2.1288000488281250e+02 -1.8080801010131836e+01 -5.5045600891113281e+01 2.1288000488281250e+02 -5.2483798980712891e+01 -5.4332302093505859e+01 2.1288000488281250e+02 -4.6145999908447266e+01 -5.2874401092529297e+01 2.1288000488281250e+02 -3.9937099456787109e+01 -1.9083301544189453e+01 2.0686000061035156e+02 -1.0909600067138672e+02 -2.5318099975585938e+01 2.0686000061035156e+02 -1.0661399841308594e+02 -3.1215499877929688e+01 2.0686000061035156e+02 -1.0341200256347656e+02 -3.6692897796630859e+01 2.0686000061035156e+02 -9.9535499572753906e+01 -4.1673297882080078e+01 2.0686000061035156e+02 -9.5038101196289062e+01 -4.6086898803710938e+01 2.0686000061035156e+02 -8.9983299255371094e+01 -4.9871601104736328e+01 2.0686000061035156e+02 -8.4441902160644531e+01 -5.2974399566650391e+01 2.0686000061035156e+02 -7.8491798400878906e+01 -5.5351699829101562e+01 2.0686000061035156e+02 -7.2216506958007812e+01 -5.6970001220703125e+01 2.0686000061035156e+02 -6.5704002380371094e+01 -5.7806800842285156e+01 2.0686000061035156e+02 -5.9045898437500000e+01 -5.7850200653076172e+01 2.0686000061035156e+02 -5.2335502624511719e+01 -5.7099597930908203e+01 2.0686000061035156e+02 -4.5667098999023438e+01 -5.5565700531005859e+01 2.0686000061035156e+02 -3.9134300231933594e+01 -5.3269798278808594e+01 2.0686000061035156e+02 -3.2828800201416016e+01 -5.0244300842285156e+01 2.0686000061035156e+02 -2.6838998794555664e+01 -4.6531497955322266e+01 2.0686000061035156e+02 -2.1249099731445312e+01 -4.2183700561523438e+01 2.0686000061035156e+02 -1.6137599945068359e+01 -3.7261898040771484e+01 2.0686000061035156e+02 -1.1576199531555176e+01 -3.1835102081298828e+01 2.0686000061035156e+02 -7.6289296150207520e+00 -2.5979600906372070e+01 2.0686000061035156e+02 -4.3512001037597656e+00 -1.9777498245239258e+01 2.0686000061035156e+02 -1.7890400886535645e+00 -1.3315799713134766e+01 2.0686000061035156e+02 2.1608199924230576e-02 -6.6854200363159180e+00 2.0686000061035156e+02 1.0552999973297119e+00 2.0719299092888832e-02 2.0686000061035156e+02 1.2975400686264038e+00 6.7084398269653320e+00 2.0686000061035156e+02 7.4492502212524414e-01 1.3283900260925293e+01 2.0686000061035156e+02 -5.9478998184204102e-01 1.9654701232910156e+01 2.0686000061035156e+02 -2.7028000354766846e+00 2.5731399536132812e+01 2.0686000061035156e+02 -5.5495100021362305e+00 3.1428899765014648e+01 2.0686000061035156e+02 -9.0949497222900391e+00 3.6666999816894531e+01 2.0686000061035156e+02 -1.3289400100708008e+01 4.1372299194335938e+01 2.0686000061035156e+02 -1.8073900222778320e+01 4.5478599548339844e+01 2.0686000061035156e+02 -2.3381299972534180e+01 4.8928398132324219e+01 2.0686000061035156e+02 -2.9137098312377930e+01 5.1673301696777344e+01 2.0686000061035156e+02 -3.5260597229003906e+01 5.3674602508544922e+01 2.0686000061035156e+02 -4.1665699005126953e+01 5.4904300689697266e+01 2.0686000061035156e+02 -4.8262599945068359e+01 5.5345199584960938e+01 2.0686000061035156e+02 -5.4958599090576172e+01 5.4991001129150391e+01 2.0686000061035156e+02 -6.1659801483154297e+01 5.3846698760986328e+01 2.0686000061035156e+02 -6.8272003173828125e+01 5.1928401947021484e+01 2.0686000061035156e+02 -7.4702499389648438e+01 4.9263000488281250e+01 2.0686000061035156e+02 -8.0861000061035156e+01 4.5888000488281250e+01 2.0686000061035156e+02 -8.6661003112792969e+01 4.1850601196289062e+01 2.0686000061035156e+02 -9.2021102905273438e+01 3.7207599639892578e+01 2.0686000061035156e+02 -9.6865997314453125e+01 3.2024200439453125e+01 2.0686000061035156e+02 -1.0112799835205078e+02 2.6373100280761719e+01 2.0686000061035156e+02 -1.0474699401855469e+02 2.0333700180053711e+01 2.0686000061035156e+02 -1.0767199707031250e+02 1.3990699768066406e+01 2.0686000061035156e+02 -1.0986199951171875e+02 7.4331498146057129e+00 2.0686000061035156e+02 -1.1128699493408203e+02 7.5314003229141235e-01 2.0686000061035156e+02 -1.1192599487304688e+02 -5.9555697441101074e+00 2.0686000061035156e+02 -1.1176999664306641e+02 -1.2598799705505371e+01 2.0686000061035156e+02 -1.1082299804687500e+02 -1.9723499298095703e+01 2.0053700256347656e+02 -1.1102999877929688e+02 -2.6182500839233398e+01 2.0053700256347656e+02 -1.0845899963378906e+02 -3.2292198181152344e+01 2.0053700256347656e+02 -1.0514199829101562e+02 -3.7966602325439453e+01 2.0053700256347656e+02 -1.0112599945068359e+02 -4.3126300811767578e+01 2.0053700256347656e+02 -9.6467002868652344e+01 -4.7698596954345703e+01 2.0053700256347656e+02 -9.1230300903320312e+01 -5.1619499206542969e+01 2.0053700256347656e+02 -8.5489494323730469e+01 -5.4833900451660156e+01 2.0053700256347656e+02 -7.9325302124023438e+01 -5.7296699523925781e+01 2.0053700256347656e+02 -7.2824203491210938e+01 -5.8973300933837891e+01 2.0053700256347656e+02 -6.6077499389648438e+01 -5.9840198516845703e+01 2.0053700256347656e+02 -5.9179801940917969e+01 -5.9885200500488281e+01 2.0053700256347656e+02 -5.2228000640869141e+01 -5.9107601165771484e+01 2.0053700256347656e+02 -4.5319698333740234e+01 -5.7518402099609375e+01 2.0053700256347656e+02 -3.8551799774169922e+01 -5.5139999389648438e+01 2.0053700256347656e+02 -3.2019397735595703e+01 -5.2005599975585938e+01 2.0053700256347656e+02 -2.5814098358154297e+01 -4.8159301757812500e+01 2.0053700256347656e+02 -2.0023099899291992e+01 -4.3654998779296875e+01 2.0053700256347656e+02 -1.4727699279785156e+01 -3.8556098937988281e+01 2.0053700256347656e+02 -1.0002099990844727e+01 -3.2934101104736328e+01 2.0053700256347656e+02 -5.9128398895263672e+00 -2.6867799758911133e+01 2.0053700256347656e+02 -2.5171799659729004e+00 -2.0442600250244141e+01 2.0053700256347656e+02 1.3717000186443329e-01 -1.3748499870300293e+01 2.0053700256347656e+02 2.0129499435424805e+00 -6.8794898986816406e+00 2.0053700256347656e+02 3.0838398933410645e+00 6.7928604781627655e-02 2.0053700256347656e+02 3.3348000049591064e+00 6.9962697029113770e+00 2.0053700256347656e+02 2.7623000144958496e+00 1.3808300018310547e+01 2.0053700256347656e+02 1.3743799924850464e+00 2.0408300399780273e+01 2.0053700256347656e+02 -8.0947399139404297e-01 2.6703701019287109e+01 2.0053700256347656e+02 -3.7585999965667725e+00 3.2606098175048828e+01 2.0053700256347656e+02 -7.4316101074218750e+00 3.8032699584960938e+01 2.0053700256347656e+02 -1.1776900291442871e+01 4.2907302856445312e+01 2.0053700256347656e+02 -1.6733600616455078e+01 4.7161399841308594e+01 2.0053700256347656e+02 -2.2232000350952148e+01 5.0735298156738281e+01 2.0053700256347656e+02 -2.8194900512695312e+01 5.3578899383544922e+01 2.0053700256347656e+02 -3.4538700103759766e+01 5.5652202606201172e+01 2.0053700256347656e+02 -4.1174301147460938e+01 5.6926197052001953e+01 2.0053700256347656e+02 -4.8008502960205078e+01 5.7382900238037109e+01 2.0053700256347656e+02 -5.4945400238037109e+01 5.7015998840332031e+01 2.0053700256347656e+02 -6.1887699127197266e+01 5.5830501556396484e+01 2.0053700256347656e+02 -6.8737800598144531e+01 5.3843200683593750e+01 2.0053700256347656e+02 -7.5399696350097656e+01 5.1081897735595703e+01 2.0053700256347656e+02 -8.1779701232910156e+01 4.7585403442382812e+01 2.0053700256347656e+02 -8.7788406372070312e+01 4.3402797698974609e+01 2.0053700256347656e+02 -9.3341400146484375e+01 3.8592800140380859e+01 2.0053700256347656e+02 -9.8360702514648438e+01 3.3222900390625000e+01 2.0053700256347656e+02 -1.0277600097656250e+02 2.7368501663208008e+01 2.0053700256347656e+02 -1.0652499389648438e+02 2.1111799240112305e+01 2.0053700256347656e+02 -1.0955500030517578e+02 1.4540499687194824e+01 2.0053700256347656e+02 -1.1182399749755859e+02 7.7470498085021973e+00 2.0053700256347656e+02 -1.1330000305175781e+02 8.2670199871063232e-01 2.0053700256347656e+02 -1.1396200561523438e+02 -6.1233901977539062e+00 2.0053700256347656e+02 -1.1380100250244141e+02 -1.3005599975585938e+01 2.0053700256347656e+02 -1.1281900024414062e+02 -2.0111600875854492e+01 1.9401000976562500e+02 -1.1220300292968750e+02 -2.6706600189208984e+01 1.9401000976562500e+02 -1.0957799530029297e+02 -3.2944900512695312e+01 1.9401000976562500e+02 -1.0619100189208984e+02 -3.8738899230957031e+01 1.9401000976562500e+02 -1.0209099578857422e+02 -4.4007202148437500e+01 1.9401000976562500e+02 -9.7333297729492188e+01 -4.8675800323486328e+01 1.9401000976562500e+02 -9.1986297607421875e+01 -5.2679298400878906e+01 1.9401000976562500e+02 -8.6124702453613281e+01 -5.5961299896240234e+01 1.9401000976562500e+02 -7.9830696105957031e+01 -5.8476001739501953e+01 1.9401000976562500e+02 -7.3192703247070312e+01 -6.0187896728515625e+01 1.9401000976562500e+02 -6.6303901672363281e+01 -6.1073001861572266e+01 1.9401000976562500e+02 -5.9261001586914062e+01 -6.1118900299072266e+01 1.9401000976562500e+02 -5.2162799835205078e+01 -6.0325000762939453e+01 1.9401000976562500e+02 -4.5109001159667969e+01 -5.8702400207519531e+01 1.9401000976562500e+02 -3.8198600769042969e+01 -5.6273799896240234e+01 1.9401000976562500e+02 -3.1528598785400391e+01 -5.3073398590087891e+01 1.9401000976562500e+02 -2.5192699432373047e+01 -4.9146099090576172e+01 1.9401000976562500e+02 -1.9279800415039062e+01 -4.4547000885009766e+01 1.9401000976562500e+02 -1.3872800827026367e+01 -3.9340801239013672e+01 1.9401000976562500e+02 -9.0478200912475586e+00 -3.3600299835205078e+01 1.9401000976562500e+02 -4.8724102973937988e+00 -2.7406400680541992e+01 1.9401000976562500e+02 -1.4052599668502808e+00 -2.0845800399780273e+01 1.9401000976562500e+02 1.3049900531768799e+00 -1.4010800361633301e+01 1.9401000976562500e+02 3.2202699184417725e+00 -6.9971599578857422e+00 1.9401000976562500e+02 4.3137102127075195e+00 9.6551105380058289e-02 1.9401000976562500e+02 4.5699501037597656e+00 7.1707696914672852e+00 1.9401000976562500e+02 3.9853999614715576e+00 1.4126200675964355e+01 1.9401000976562500e+02 2.5682499408721924e+00 2.0865200042724609e+01 1.9401000976562500e+02 3.3841800689697266e-01 2.7293199539184570e+01 1.9401000976562500e+02 -2.6728100776672363e+00 3.3319900512695312e+01 1.9401000976562500e+02 -6.4231600761413574e+00 3.8860702514648438e+01 1.9401000976562500e+02 -1.0859999656677246e+01 4.3837902069091797e+01 1.9401000976562500e+02 -1.5921000480651855e+01 4.8181602478027344e+01 1.9401000976562500e+02 -2.1535198211669922e+01 5.1830799102783203e+01 1.9401000976562500e+02 -2.7623699188232422e+01 5.4734302520751953e+01 1.9401000976562500e+02 -3.4100997924804688e+01 5.6851200103759766e+01 1.9401000976562500e+02 -4.0876300811767578e+01 5.8152000427246094e+01 1.9401000976562500e+02 -4.7854503631591797e+01 5.8618400573730469e+01 1.9401000976562500e+02 -5.4937500000000000e+01 5.8243698120117188e+01 1.9401000976562500e+02 -6.2025901794433594e+01 5.7033302307128906e+01 1.9401000976562500e+02 -6.9020301818847656e+01 5.5004100799560547e+01 1.9401000976562500e+02 -7.5822395324707031e+01 5.2184700012207031e+01 1.9401000976562500e+02 -8.2336799621582031e+01 4.8614597320556641e+01 1.9401000976562500e+02 -8.8472000122070312e+01 4.4343898773193359e+01 1.9401000976562500e+02 -9.4141899108886719e+01 3.9432601928710938e+01 1.9401000976562500e+02 -9.9266799926757812e+01 3.3949600219726562e+01 1.9401000976562500e+02 -1.0377500152587891e+02 2.7972000122070312e+01 1.9401000976562500e+02 -1.0760299682617188e+02 2.1583499908447266e+01 1.9401000976562500e+02 -1.1069699859619141e+02 1.4873900413513184e+01 1.9401000976562500e+02 -1.1301399993896484e+02 7.9373698234558105e+00 1.9401000976562500e+02 -1.1452099609375000e+02 8.7130099534988403e-01 1.9401000976562500e+02 -1.1519700622558594e+02 -6.2251300811767578e+00 1.9401000976562500e+02 -1.1503299713134766e+02 -1.3252300262451172e+01 1.9401000976562500e+02 -1.1403000640869141e+02 -2.0241600036621094e+01 1.8738000488281250e+02 -1.1259600067138672e+02 -2.6882200241088867e+01 1.8738000488281250e+02 -1.0995300292968750e+02 -3.3163700103759766e+01 1.8738000488281250e+02 -1.0654299926757812e+02 -3.8997600555419922e+01 1.8738000488281250e+02 -1.0241399383544922e+02 -4.4302299499511719e+01 1.8738000488281250e+02 -9.7623497009277344e+01 -4.9003200531005859e+01 1.8738000488281250e+02 -9.2239601135253906e+01 -5.3034301757812500e+01 1.8738000488281250e+02 -8.6337501525878906e+01 -5.6339099884033203e+01 1.8738000488281250e+02 -8.0000000000000000e+01 -5.8871101379394531e+01 1.8738000488281250e+02 -7.3316200256347656e+01 -6.0594799041748047e+01 1.8738000488281250e+02 -6.6379798889160156e+01 -6.1486099243164062e+01 1.8738000488281250e+02 -5.9288200378417969e+01 -6.1532299041748047e+01 1.8738000488281250e+02 -5.2140899658203125e+01 -6.0732902526855469e+01 1.8738000488281250e+02 -4.5038398742675781e+01 -5.9099102020263672e+01 1.8738000488281250e+02 -3.8080299377441406e+01 -5.6653701782226562e+01 1.8738000488281250e+02 -3.1364198684692383e+01 -5.3431201934814453e+01 1.8738000488281250e+02 -2.4984498977661133e+01 -4.9476799011230469e+01 1.8738000488281250e+02 -1.9030698776245117e+01 -4.4845901489257812e+01 1.8738000488281250e+02 -1.3586400032043457e+01 -3.9603698730468750e+01 1.8738000488281250e+02 -8.7280492782592773e+00 -3.3823596954345703e+01 1.8738000488281250e+02 -4.5238003730773926e+00 -2.7586799621582031e+01 1.8738000488281250e+02 -1.0326800346374512e+00 -2.0980899810791016e+01 1.8738000488281250e+02 1.6962900161743164e+00 -1.4098700523376465e+01 1.8738000488281250e+02 3.6248099803924561e+00 -7.0365796089172363e+00 1.8738000488281250e+02 4.7258000373840332e+00 1.0614199936389923e-01 1.8738000488281250e+02 4.9838099479675293e+00 7.2292499542236328e+00 1.8738000488281250e+02 4.3952102661132812e+00 1.4232699394226074e+01 1.8738000488281250e+02 2.9682800769805908e+00 2.1018301010131836e+01 1.8738000488281250e+02 7.2303897142410278e-01 2.7490699768066406e+01 1.8738000488281250e+02 -2.3089997768402100e+00 3.3559097290039062e+01 1.8738000488281250e+02 -6.0852599143981934e+00 3.9138202667236328e+01 1.8738000488281250e+02 -1.0552700042724609e+01 4.4149799346923828e+01 1.8738000488281250e+02 -1.5648700714111328e+01 4.8523502349853516e+01 1.8738000488281250e+02 -2.1301700592041016e+01 5.2197898864746094e+01 1.8738000488281250e+02 -2.7432300567626953e+01 5.5121398925781250e+01 1.8738000488281250e+02 -3.3954399108886719e+01 5.7252998352050781e+01 1.8738000488281250e+02 -4.0776496887207031e+01 5.8562801361083984e+01 1.8738000488281250e+02 -4.7802799224853516e+01 5.9032299041748047e+01 1.8738000488281250e+02 -5.4934799194335938e+01 5.8655101776123047e+01 1.8738000488281250e+02 -6.2072196960449219e+01 5.7436298370361328e+01 1.8738000488281250e+02 -6.9114898681640625e+01 5.5393100738525391e+01 1.8738000488281250e+02 -7.5963996887207031e+01 5.2554203033447266e+01 1.8738000488281250e+02 -8.2523399353027344e+01 4.8959499359130859e+01 1.8738000488281250e+02 -8.8701004028320312e+01 4.4659301757812500e+01 1.8738000488281250e+02 -9.4410102844238281e+01 3.9714000701904297e+01 1.8738000488281250e+02 -9.9570495605468750e+01 3.4193099975585938e+01 1.8738000488281250e+02 -1.0411000061035156e+02 2.8174200057983398e+01 1.8738000488281250e+02 -1.0796400451660156e+02 2.1741500854492188e+01 1.8738000488281250e+02 -1.1108000183105469e+02 1.4985599517822266e+01 1.8738000488281250e+02 -1.1341300201416016e+02 8.0011405944824219e+00 1.8738000488281250e+02 -1.1492999267578125e+02 8.8624501228332520e-01 1.8738000488281250e+02 -1.1561100006103516e+02 -6.2592201232910156e+00 1.8738000488281250e+02 -1.1544499969482422e+02 -1.3334899902343750e+01 1.8738000488281250e+02 -1.1443599700927734e+02 -2.0111600875854492e+01 1.8075000000000000e+02 -1.1220300292968750e+02 -2.6706600189208984e+01 1.8075000000000000e+02 -1.0957799530029297e+02 -3.2944900512695312e+01 1.8075000000000000e+02 -1.0619100189208984e+02 -3.8738899230957031e+01 1.8075000000000000e+02 -1.0209099578857422e+02 -4.4007202148437500e+01 1.8075000000000000e+02 -9.7333297729492188e+01 -4.8675800323486328e+01 1.8075000000000000e+02 -9.1986297607421875e+01 -5.2679298400878906e+01 1.8075000000000000e+02 -8.6124702453613281e+01 -5.5961299896240234e+01 1.8075000000000000e+02 -7.9830696105957031e+01 -5.8476001739501953e+01 1.8075000000000000e+02 -7.3192703247070312e+01 -6.0187896728515625e+01 1.8075000000000000e+02 -6.6303901672363281e+01 -6.1073001861572266e+01 1.8075000000000000e+02 -5.9261001586914062e+01 -6.1118900299072266e+01 1.8075000000000000e+02 -5.2162799835205078e+01 -6.0325000762939453e+01 1.8075000000000000e+02 -4.5109001159667969e+01 -5.8702400207519531e+01 1.8075000000000000e+02 -3.8198600769042969e+01 -5.6273799896240234e+01 1.8075000000000000e+02 -3.1528598785400391e+01 -5.3073398590087891e+01 1.8075000000000000e+02 -2.5192699432373047e+01 -4.9146099090576172e+01 1.8075000000000000e+02 -1.9279800415039062e+01 -4.4547000885009766e+01 1.8075000000000000e+02 -1.3872800827026367e+01 -3.9340801239013672e+01 1.8075000000000000e+02 -9.0478200912475586e+00 -3.3600299835205078e+01 1.8075000000000000e+02 -4.8724102973937988e+00 -2.7406400680541992e+01 1.8075000000000000e+02 -1.4052599668502808e+00 -2.0845800399780273e+01 1.8075000000000000e+02 1.3049900531768799e+00 -1.4010800361633301e+01 1.8075000000000000e+02 3.2202699184417725e+00 -6.9971599578857422e+00 1.8075000000000000e+02 4.3137102127075195e+00 9.6551105380058289e-02 1.8075000000000000e+02 4.5699501037597656e+00 7.1707696914672852e+00 1.8075000000000000e+02 3.9853999614715576e+00 1.4126200675964355e+01 1.8075000000000000e+02 2.5682499408721924e+00 2.0865200042724609e+01 1.8075000000000000e+02 3.3841800689697266e-01 2.7293199539184570e+01 1.8075000000000000e+02 -2.6728100776672363e+00 3.3319900512695312e+01 1.8075000000000000e+02 -6.4231600761413574e+00 3.8860702514648438e+01 1.8075000000000000e+02 -1.0859999656677246e+01 4.3837902069091797e+01 1.8075000000000000e+02 -1.5921000480651855e+01 4.8181602478027344e+01 1.8075000000000000e+02 -2.1535198211669922e+01 5.1830799102783203e+01 1.8075000000000000e+02 -2.7623699188232422e+01 5.4734302520751953e+01 1.8075000000000000e+02 -3.4100997924804688e+01 5.6851200103759766e+01 1.8075000000000000e+02 -4.0876300811767578e+01 5.8152000427246094e+01 1.8075000000000000e+02 -4.7854503631591797e+01 5.8618400573730469e+01 1.8075000000000000e+02 -5.4937500000000000e+01 5.8243698120117188e+01 1.8075000000000000e+02 -6.2025901794433594e+01 5.7033302307128906e+01 1.8075000000000000e+02 -6.9020301818847656e+01 5.5004100799560547e+01 1.8075000000000000e+02 -7.5822395324707031e+01 5.2184700012207031e+01 1.8075000000000000e+02 -8.2336799621582031e+01 4.8614597320556641e+01 1.8075000000000000e+02 -8.8472000122070312e+01 4.4343898773193359e+01 1.8075000000000000e+02 -9.4141899108886719e+01 3.9432601928710938e+01 1.8075000000000000e+02 -9.9266799926757812e+01 3.3949600219726562e+01 1.8075000000000000e+02 -1.0377500152587891e+02 2.7972000122070312e+01 1.8075000000000000e+02 -1.0760299682617188e+02 2.1583499908447266e+01 1.8075000000000000e+02 -1.1069699859619141e+02 1.4873900413513184e+01 1.8075000000000000e+02 -1.1301399993896484e+02 7.9373698234558105e+00 1.8075000000000000e+02 -1.1452099609375000e+02 8.7130099534988403e-01 1.8075000000000000e+02 -1.1519700622558594e+02 -6.2251300811767578e+00 1.8075000000000000e+02 -1.1503299713134766e+02 -1.3252300262451172e+01 1.8075000000000000e+02 -1.1403000640869141e+02 -1.9723499298095703e+01 1.7422300720214844e+02 -1.1102999877929688e+02 -2.6182500839233398e+01 1.7422300720214844e+02 -1.0845899963378906e+02 -3.2292198181152344e+01 1.7422300720214844e+02 -1.0514199829101562e+02 -3.7966602325439453e+01 1.7422300720214844e+02 -1.0112599945068359e+02 -4.3126300811767578e+01 1.7422300720214844e+02 -9.6467002868652344e+01 -4.7698596954345703e+01 1.7422300720214844e+02 -9.1230300903320312e+01 -5.1619499206542969e+01 1.7422300720214844e+02 -8.5489494323730469e+01 -5.4833900451660156e+01 1.7422300720214844e+02 -7.9325302124023438e+01 -5.7296699523925781e+01 1.7422300720214844e+02 -7.2824203491210938e+01 -5.8973300933837891e+01 1.7422300720214844e+02 -6.6077499389648438e+01 -5.9840198516845703e+01 1.7422300720214844e+02 -5.9179801940917969e+01 -5.9885200500488281e+01 1.7422300720214844e+02 -5.2228000640869141e+01 -5.9107601165771484e+01 1.7422300720214844e+02 -4.5319698333740234e+01 -5.7518402099609375e+01 1.7422300720214844e+02 -3.8551799774169922e+01 -5.5139999389648438e+01 1.7422300720214844e+02 -3.2019397735595703e+01 -5.2005599975585938e+01 1.7422300720214844e+02 -2.5814098358154297e+01 -4.8159301757812500e+01 1.7422300720214844e+02 -2.0023099899291992e+01 -4.3654998779296875e+01 1.7422300720214844e+02 -1.4727699279785156e+01 -3.8556098937988281e+01 1.7422300720214844e+02 -1.0002099990844727e+01 -3.2934101104736328e+01 1.7422300720214844e+02 -5.9128398895263672e+00 -2.6867799758911133e+01 1.7422300720214844e+02 -2.5171799659729004e+00 -2.0442600250244141e+01 1.7422300720214844e+02 1.3717000186443329e-01 -1.3748499870300293e+01 1.7422300720214844e+02 2.0129499435424805e+00 -6.8794898986816406e+00 1.7422300720214844e+02 3.0838398933410645e+00 6.7928604781627655e-02 1.7422300720214844e+02 3.3348000049591064e+00 6.9962697029113770e+00 1.7422300720214844e+02 2.7623000144958496e+00 1.3808300018310547e+01 1.7422300720214844e+02 1.3743799924850464e+00 2.0408300399780273e+01 1.7422300720214844e+02 -8.0947399139404297e-01 2.6703701019287109e+01 1.7422300720214844e+02 -3.7585999965667725e+00 3.2606098175048828e+01 1.7422300720214844e+02 -7.4316101074218750e+00 3.8032699584960938e+01 1.7422300720214844e+02 -1.1776900291442871e+01 4.2907302856445312e+01 1.7422300720214844e+02 -1.6733600616455078e+01 4.7161399841308594e+01 1.7422300720214844e+02 -2.2232000350952148e+01 5.0735298156738281e+01 1.7422300720214844e+02 -2.8194900512695312e+01 5.3578899383544922e+01 1.7422300720214844e+02 -3.4538700103759766e+01 5.5652202606201172e+01 1.7422300720214844e+02 -4.1174301147460938e+01 5.6926197052001953e+01 1.7422300720214844e+02 -4.8008502960205078e+01 5.7382900238037109e+01 1.7422300720214844e+02 -5.4945400238037109e+01 5.7015998840332031e+01 1.7422300720214844e+02 -6.1887699127197266e+01 5.5830501556396484e+01 1.7422300720214844e+02 -6.8737800598144531e+01 5.3843200683593750e+01 1.7422300720214844e+02 -7.5399696350097656e+01 5.1081897735595703e+01 1.7422300720214844e+02 -8.1779701232910156e+01 4.7585403442382812e+01 1.7422300720214844e+02 -8.7788406372070312e+01 4.3402797698974609e+01 1.7422300720214844e+02 -9.3341400146484375e+01 3.8592800140380859e+01 1.7422300720214844e+02 -9.8360702514648438e+01 3.3222900390625000e+01 1.7422300720214844e+02 -1.0277600097656250e+02 2.7368501663208008e+01 1.7422300720214844e+02 -1.0652499389648438e+02 2.1111799240112305e+01 1.7422300720214844e+02 -1.0955500030517578e+02 1.4540499687194824e+01 1.7422300720214844e+02 -1.1182399749755859e+02 7.7470498085021973e+00 1.7422300720214844e+02 -1.1330000305175781e+02 8.2670199871063232e-01 1.7422300720214844e+02 -1.1396200561523438e+02 -6.1233901977539062e+00 1.7422300720214844e+02 -1.1380100250244141e+02 -1.3005599975585938e+01 1.7422300720214844e+02 -1.1281900024414062e+02 -1.9083301544189453e+01 1.6789999389648438e+02 -1.0909600067138672e+02 -2.5318099975585938e+01 1.6789999389648438e+02 -1.0661399841308594e+02 -3.1215499877929688e+01 1.6789999389648438e+02 -1.0341200256347656e+02 -3.6692897796630859e+01 1.6789999389648438e+02 -9.9535499572753906e+01 -4.1673297882080078e+01 1.6789999389648438e+02 -9.5038101196289062e+01 -4.6086898803710938e+01 1.6789999389648438e+02 -8.9983299255371094e+01 -4.9871601104736328e+01 1.6789999389648438e+02 -8.4441902160644531e+01 -5.2974399566650391e+01 1.6789999389648438e+02 -7.8491798400878906e+01 -5.5351699829101562e+01 1.6789999389648438e+02 -7.2216506958007812e+01 -5.6970001220703125e+01 1.6789999389648438e+02 -6.5704002380371094e+01 -5.7806800842285156e+01 1.6789999389648438e+02 -5.9045898437500000e+01 -5.7850200653076172e+01 1.6789999389648438e+02 -5.2335502624511719e+01 -5.7099597930908203e+01 1.6789999389648438e+02 -4.5667098999023438e+01 -5.5565700531005859e+01 1.6789999389648438e+02 -3.9134300231933594e+01 -5.3269798278808594e+01 1.6789999389648438e+02 -3.2828800201416016e+01 -5.0244300842285156e+01 1.6789999389648438e+02 -2.6838998794555664e+01 -4.6531497955322266e+01 1.6789999389648438e+02 -2.1249099731445312e+01 -4.2183700561523438e+01 1.6789999389648438e+02 -1.6137599945068359e+01 -3.7261898040771484e+01 1.6789999389648438e+02 -1.1576199531555176e+01 -3.1835102081298828e+01 1.6789999389648438e+02 -7.6289296150207520e+00 -2.5979600906372070e+01 1.6789999389648438e+02 -4.3512001037597656e+00 -1.9777498245239258e+01 1.6789999389648438e+02 -1.7890400886535645e+00 -1.3315799713134766e+01 1.6789999389648438e+02 2.1608199924230576e-02 -6.6854200363159180e+00 1.6789999389648438e+02 1.0552999973297119e+00 2.0719299092888832e-02 1.6789999389648438e+02 1.2975400686264038e+00 6.7084398269653320e+00 1.6789999389648438e+02 7.4492502212524414e-01 1.3283900260925293e+01 1.6789999389648438e+02 -5.9478998184204102e-01 1.9654701232910156e+01 1.6789999389648438e+02 -2.7028000354766846e+00 2.5731399536132812e+01 1.6789999389648438e+02 -5.5495100021362305e+00 3.1428899765014648e+01 1.6789999389648438e+02 -9.0949497222900391e+00 3.6666999816894531e+01 1.6789999389648438e+02 -1.3289400100708008e+01 4.1372299194335938e+01 1.6789999389648438e+02 -1.8073900222778320e+01 4.5478599548339844e+01 1.6789999389648438e+02 -2.3381299972534180e+01 4.8928398132324219e+01 1.6789999389648438e+02 -2.9137098312377930e+01 5.1673301696777344e+01 1.6789999389648438e+02 -3.5260597229003906e+01 5.3674602508544922e+01 1.6789999389648438e+02 -4.1665699005126953e+01 5.4904300689697266e+01 1.6789999389648438e+02 -4.8262599945068359e+01 5.5345199584960938e+01 1.6789999389648438e+02 -5.4958599090576172e+01 5.4991001129150391e+01 1.6789999389648438e+02 -6.1659801483154297e+01 5.3846698760986328e+01 1.6789999389648438e+02 -6.8272003173828125e+01 5.1928401947021484e+01 1.6789999389648438e+02 -7.4702499389648438e+01 4.9263000488281250e+01 1.6789999389648438e+02 -8.0861000061035156e+01 4.5888000488281250e+01 1.6789999389648438e+02 -8.6661003112792969e+01 4.1850601196289062e+01 1.6789999389648438e+02 -9.2021102905273438e+01 3.7207599639892578e+01 1.6789999389648438e+02 -9.6865997314453125e+01 3.2024200439453125e+01 1.6789999389648438e+02 -1.0112799835205078e+02 2.6373100280761719e+01 1.6789999389648438e+02 -1.0474699401855469e+02 2.0333700180053711e+01 1.6789999389648438e+02 -1.0767199707031250e+02 1.3990699768066406e+01 1.6789999389648438e+02 -1.0986199951171875e+02 7.4331498146057129e+00 1.6789999389648438e+02 -1.1128699493408203e+02 7.5314003229141235e-01 1.6789999389648438e+02 -1.1192599487304688e+02 -5.9555697441101074e+00 1.6789999389648438e+02 -1.1176999664306641e+02 -1.2598799705505371e+01 1.6789999389648438e+02 -1.1082299804687500e+02 -1.8201099395751953e+01 1.6188000488281250e+02 -1.0642900085449219e+02 -2.4126699447631836e+01 1.6188000488281250e+02 -1.0407099914550781e+02 -2.9731700897216797e+01 1.6188000488281250e+02 -1.0102799987792969e+02 -3.4937500000000000e+01 1.6188000488281250e+02 -9.7343200683593750e+01 -3.9670898437500000e+01 1.6188000488281250e+02 -9.3068901062011719e+01 -4.3865600585937500e+01 1.6188000488281250e+02 -8.8264694213867188e+01 -4.7462699890136719e+01 1.6188000488281250e+02 -8.2998100280761719e+01 -5.0411602020263672e+01 1.6188000488281250e+02 -7.7343002319335938e+01 -5.2671001434326172e+01 1.6188000488281250e+02 -7.1378898620605469e+01 -5.4209098815917969e+01 1.6188000488281250e+02 -6.5189399719238281e+01 -5.5004398345947266e+01 1.6188000488281250e+02 -5.8861400604248047e+01 -5.5045600891113281e+01 1.6188000488281250e+02 -5.2483798980712891e+01 -5.4332302093505859e+01 1.6188000488281250e+02 -4.6145999908447266e+01 -5.2874401092529297e+01 1.6188000488281250e+02 -3.9937099456787109e+01 -5.0692401885986328e+01 1.6188000488281250e+02 -3.3944301605224609e+01 -4.7816898345947266e+01 1.6188000488281250e+02 -2.8251501083374023e+01 -4.4288200378417969e+01 1.6188000488281250e+02 -2.2938798904418945e+01 -4.0155998229980469e+01 1.6188000488281250e+02 -1.8080801010131836e+01 -3.5478302001953125e+01 1.6188000488281250e+02 -1.3745600700378418e+01 -3.0320600509643555e+01 1.6188000488281250e+02 -9.9940099716186523e+00 -2.4755399703979492e+01 1.6188000488281250e+02 -6.8788099288940430e+00 -1.8860799789428711e+01 1.6188000488281250e+02 -4.4436998367309570e+00 -1.2719600677490234e+01 1.6188000488281250e+02 -2.7228400707244873e+00 -6.4179501533508301e+00 1.6188000488281250e+02 -1.7403999567031860e+00 -4.4343903660774231e-02 1.6188000488281250e+02 -1.5101799964904785e+00 6.3117499351501465e+00 1.6188000488281250e+02 -2.0353899002075195e+00 1.2561100006103516e+01 1.6188000488281250e+02 -3.3086698055267334e+00 1.8616001129150391e+01 1.6188000488281250e+02 -5.3121500015258789e+00 2.4391500473022461e+01 1.6188000488281250e+02 -8.0177001953125000e+00 2.9806400299072266e+01 1.6188000488281250e+02 -1.1387299537658691e+01 3.4784801483154297e+01 1.6188000488281250e+02 -1.5373800277709961e+01 3.9256698608398438e+01 1.6188000488281250e+02 -1.9920999526977539e+01 4.3159400939941406e+01 1.6188000488281250e+02 -2.4965299606323242e+01 4.6438198089599609e+01 1.6188000488281250e+02 -3.0435699462890625e+01 4.9046901702880859e+01 1.6188000488281250e+02 -3.6255500793457031e+01 5.0949001312255859e+01 1.6188000488281250e+02 -4.2343097686767578e+01 5.2117702484130859e+01 1.6188000488281250e+02 -4.8612800598144531e+01 5.2536800384521484e+01 1.6188000488281250e+02 -5.4976799011230469e+01 5.2200099945068359e+01 1.6188000488281250e+02 -6.1345699310302734e+01 5.1112598419189453e+01 1.6188000488281250e+02 -6.7629997253417969e+01 4.9289402008056641e+01 1.6188000488281250e+02 -7.3741600036621094e+01 4.6756198883056641e+01 1.6188000488281250e+02 -7.9594703674316406e+01 4.3548500061035156e+01 1.6188000488281250e+02 -8.5107101440429688e+01 3.9711299896240234e+01 1.6188000488281250e+02 -9.0201400756835938e+01 3.5298599243164062e+01 1.6188000488281250e+02 -9.4806198120117188e+01 3.0372200012207031e+01 1.6188000488281250e+02 -9.8856704711914062e+01 2.5001300811767578e+01 1.6188000488281250e+02 -1.0229600524902344e+02 1.9261400222778320e+01 1.6188000488281250e+02 -1.0507599639892578e+02 1.3232899665832520e+01 1.6188000488281250e+02 -1.0715799713134766e+02 7.0005302429199219e+00 1.6188000488281250e+02 -1.0851200103759766e+02 6.5175896883010864e-01 1.6188000488281250e+02 -1.0911899566650391e+02 -5.7242898941040039e+00 1.6188000488281250e+02 -1.0897100067138672e+02 -1.2038099288940430e+01 1.6188000488281250e+02 -1.0807099914550781e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 6258 -> 102 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1227000281214714e+01 2.2788000106811523e+02 -8.0675199627876282e+01) (float-vector 7.7944798395037651e+00 2.2788000106811523e+02 -8.6268596351146698e+01) (float-vector -6.2287999317049980e+00 2.3213000595569611e+02 -6.2120698392391205e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.9032298624515533e+01 1.8738000094890594e+02 -5.4934799671173096e+01) (float-vector 5.6851200759410858e+01 1.9401000440120697e+02 -4.0876299142837524e+01) (float-vector 5.0948999822139740e+01 2.1288000047206879e+02 -4.2343098670244217e+01) (float-vector 5.2200101315975189e+01 2.1288000047206879e+02 -6.1345700174570084e+01) (float-vector 5.7033300399780273e+01 1.9401000440120697e+02 -6.9020301103591919e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2875900864601135e+01 2.1613000333309174e+02 -2.9825000092387199e+01) (float-vector 3.0922099947929382e+01 2.2788000106811523e+02 -5.3790498524904251e+01) (float-vector 5.2200101315975189e+01 2.1288000047206879e+02 -6.1345700174570084e+01) (float-vector 5.0948999822139740e+01 2.1288000047206879e+02 -4.2343098670244217e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7585401684045792e+01 1.7422300577163696e+02 -8.7788403034210205e+01) (float-vector 5.1928400993347168e+01 1.6789999604225159e+02 -7.4702501296997070e+01) (float-vector 5.9032298624515533e+01 1.8738000094890594e+02 -5.4934799671173096e+01) (float-vector 5.7033300399780273e+01 1.9401000440120697e+02 -6.9020301103591919e+01) (float-vector 4.8959501087665558e+01 1.8738000094890594e+02 -8.8701002299785614e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9184900224208832e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector 7.7944798395037651e+00 1.4688000082969666e+02 -8.6268596351146698e+01) (float-vector 7.0625799708068371e+00 1.4262999594211578e+02 -5.4446998983621597e+01) (float-vector 3.0049499124288559e+01 1.4688000082969666e+02 -4.7721799463033676e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0187898576259613e+01 1.9401000440120697e+02 -6.6303901374340057e+01) (float-vector -5.5004399269819260e+01 2.1288000047206879e+02 -5.8861400932073593e+01) (float-vector -5.9107601642608643e+01 2.0053699612617493e+02 -4.5319698750972748e+01) (float-vector -6.1532299965620041e+01 1.8738000094890594e+02 -5.2140899002552032e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3213101327419281e+01 2.2788000106811523e+02 -5.9914700686931610e+01) (float-vector -2.1227000281214714e+01 2.2788000106811523e+02 -8.0675199627876282e+01) (float-vector -6.2287999317049980e+00 2.3213000595569611e+02 -6.2120698392391205e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3213101327419281e+01 2.2788000106811523e+02 -5.9914700686931610e+01) (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -7.2768002748489380e+01) (float-vector -3.9670899510383606e+01 2.1288000047206879e+02 -9.3068897724151611e+01) (float-vector -2.1227000281214714e+01 2.2788000106811523e+02 -8.0675199627876282e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0922099947929382e+01 2.2788000106811523e+02 -5.3790498524904251e+01) (float-vector 2.3081500083208084e+01 2.2788000106811523e+02 -7.6444298028945923e+01) (float-vector 3.7776898592710495e+01 2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector 5.2200101315975189e+01 2.1288000047206879e+02 -6.1345700174570084e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7776898592710495e+01 2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector 2.3081500083208084e+01 2.2788000106811523e+02 -7.6444298028945923e+01) (float-vector 7.7944798395037651e+00 2.2788000106811523e+02 -8.6268596351146698e+01) (float-vector 2.4208599701523781e+01 2.1613000333309174e+02 -9.9492296576499939e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7944798395037651e+00 2.2788000106811523e+02 -8.6268596351146698e+01) (float-vector 2.3081500083208084e+01 2.2788000106811523e+02 -7.6444298028945923e+01) (float-vector 3.0922099947929382e+01 2.2788000106811523e+02 -5.3790498524904251e+01) (float-vector 4.9510197713971138e+00 2.3213000595569611e+02 -4.9704298377037048e+01) (float-vector -6.2287999317049980e+00 2.3213000595569611e+02 -6.2120698392391205e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5351700633764267e+01 1.6789999604225159e+02 -7.2216503322124481e+01) (float-vector -4.6086899936199188e+01 1.6789999604225159e+02 -8.9983299374580383e+01) (float-vector -5.3034301847219467e+01 1.8738000094890594e+02 -8.6337499320507050e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -6.4181096851825714e+01) (float-vector -3.1767699867486954e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector -4.0359698235988617e+01 1.5862999856472015e+02 -8.8107198476791382e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -6.4181096851825714e+01) (float-vector -4.0359698235988617e+01 1.5862999856472015e+02 -8.8107198476791382e+01) (float-vector -4.6086899936199188e+01 1.6789999604225159e+02 -8.9983299374580383e+01) (float-vector -5.5351700633764267e+01 1.6789999604225159e+02 -7.2216503322124481e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -7.2768002748489380e+01) (float-vector -4.9871601164340973e+01 2.0686000585556030e+02 -8.4441900253295898e+01) (float-vector -3.9670899510383606e+01 2.1288000047206879e+02 -9.3068897724151611e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9871601164340973e+01 2.0686000585556030e+02 -8.4441900253295898e+01) (float-vector -4.3126299977302551e+01 2.0053699612617493e+02 -9.6467003226280212e+01) (float-vector -3.1215500086545944e+01 2.0686000585556030e+02 -1.0341200232505798e+02) (float-vector -3.9670899510383606e+01 2.1288000047206879e+02 -9.3068897724151611e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3126299977302551e+01 2.0053699612617493e+02 -9.6467003226280212e+01) (float-vector -4.9871601164340973e+01 2.0686000585556030e+02 -8.4441900253295898e+01) (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -7.2768002748489380e+01) (float-vector -5.5004399269819260e+01 2.1288000047206879e+02 -5.8861400932073593e+01) (float-vector -6.0187898576259613e+01 1.9401000440120697e+02 -6.6303901374340057e+01) (float-vector -5.3034301847219467e+01 1.8738000094890594e+02 -8.6337499320507050e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1227000281214714e+01 2.2788000106811523e+02 -8.0675199627876282e+01) (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -1.0554999858140945e+02) (float-vector 7.7944798395037651e+00 2.2788000106811523e+02 -8.6268596351146698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1215500086545944e+01 2.0686000585556030e+02 -1.0341200232505798e+02) (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -1.0554999858140945e+02) (float-vector -2.1227000281214714e+01 2.2788000106811523e+02 -8.0675199627876282e+01) (float-vector -3.9670899510383606e+01 2.1288000047206879e+02 -9.3068897724151611e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6632900834083557e+01 1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 5.1928400993347168e+01 1.6789999604225159e+02 -7.4702501296997070e+01) (float-vector 4.7585401684045792e+01 1.7422300577163696e+02 -8.7788403034210205e+01) (float-vector 3.5298600792884827e+01 1.6188000142574310e+02 -9.4806201756000519e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0333699882030487e+01 1.6789999604225159e+02 -1.0767199844121933e+02) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -1.0324899852275848e+02) (float-vector 3.5298600792884827e+01 1.6188000142574310e+02 -9.4806201756000519e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6632900834083557e+01 1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 3.5298600792884827e+01 1.6188000142574310e+02 -9.4806201756000519e+01) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -1.0324899852275848e+02) (float-vector 7.7944798395037651e+00 1.4688000082969666e+02 -8.6268596351146698e+01) (float-vector 2.9184900224208832e+01 1.4688000082969666e+02 -6.5872900187969208e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7242899201810360e+00 1.6188000142574310e+02 -1.0897099971771240e+02) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -1.0324899852275848e+02) (float-vector 2.0333699882030487e+01 1.6789999604225159e+02 -1.0767199844121933e+02) (float-vector 7.7470499090850353e+00 1.7422300577163696e+02 -1.1330000311136246e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9107601642608643e+01 2.0053699612617493e+02 -4.5319698750972748e+01) (float-vector -5.9099100530147552e+01 1.8738000094890594e+02 -3.8080301135778427e+01) (float-vector -6.1532299965620041e+01 1.8738000094890594e+02 -5.2140899002552032e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5139999836683273e+01 1.7422300577163696e+02 -3.2019399106502533e+01) (float-vector -5.9099100530147552e+01 1.8738000094890594e+02 -3.8080301135778427e+01) (float-vector -5.9107601642608643e+01 2.0053699612617493e+02 -4.5319698750972748e+01) (float-vector -5.3269799798727036e+01 2.0686000585556030e+02 -3.2828800380229950e+01) (float-vector -4.3655000627040863e+01 2.0053699612617493e+02 -1.4727699570357800e+01) (float-vector -4.9476798623800278e+01 1.8738000094890594e+02 -1.9030699506402016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3600300550460815e+01 1.8074999749660492e+02 -4.8724100925028324e+00) (float-vector -4.3655000627040863e+01 1.7422300577163696e+02 -1.4727699570357800e+01) (float-vector -4.9476798623800278e+01 1.8738000094890594e+02 -1.9030699506402016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7816898673772812e+01 1.6188000142574310e+02 -2.8251500800251961e+01) (float-vector -4.3655000627040863e+01 1.7422300577163696e+02 -1.4727699570357800e+01) (float-vector -3.0320599675178528e+01 1.6188000142574310e+02 -9.9940104410052299e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0320599675178528e+01 1.6188000142574310e+02 -9.9940104410052299e+00) (float-vector -4.3655000627040863e+01 1.7422300577163696e+02 -1.4727699570357800e+01) (float-vector -3.3600300550460815e+01 1.8074999749660492e+02 -4.8724100925028324e+00) (float-vector -2.0442599430680275e+01 1.7422300577163696e+02 1.3717000547330827e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3655000627040863e+01 1.7422300577163696e+02 -1.4727699570357800e+01) (float-vector -4.7816898673772812e+01 1.6188000142574310e+02 -2.8251500800251961e+01) (float-vector -5.5139999836683273e+01 1.7422300577163696e+02 -3.2019399106502533e+01) (float-vector -4.9476798623800278e+01 1.8738000094890594e+02 -1.9030699506402016e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9263000488281250e+01 2.0686000585556030e+02 -8.0861002206802368e+01) (float-vector 5.2200101315975189e+01 2.1288000047206879e+02 -6.1345700174570084e+01) (float-vector 3.7776898592710495e+01 2.1613000333309174e+02 -8.8107198476791382e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.7033300399780273e+01 1.9401000440120697e+02 -6.9020301103591919e+01) (float-vector 4.9263000488281250e+01 2.0686000585556030e+02 -8.0861002206802368e+01) (float-vector 4.8959501087665558e+01 1.8738000094890594e+02 -8.8701002299785614e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9263000488281250e+01 2.0686000585556030e+02 -8.0861002206802368e+01) (float-vector 5.7033300399780273e+01 1.9401000440120697e+02 -6.9020301103591919e+01) (float-vector 5.2200101315975189e+01 2.1288000047206879e+02 -6.1345700174570084e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9263000488281250e+01 2.0686000585556030e+02 -8.0861002206802368e+01) (float-vector 3.8592800498008728e+01 2.0053699612617493e+02 -9.8360702395439148e+01) (float-vector 4.8959501087665558e+01 1.8738000094890594e+02 -8.8701002299785614e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0333699882030487e+01 2.0686000585556030e+02 -1.0767199844121933e+02) (float-vector 3.8592800498008728e+01 2.0053699612617493e+02 -9.8360702395439148e+01) (float-vector 4.9263000488281250e+01 2.0686000585556030e+02 -8.0861002206802368e+01) (float-vector 3.7776898592710495e+01 2.1613000333309174e+02 -8.8107198476791382e+01) (float-vector 2.4208599701523781e+01 2.1613000333309174e+02 -9.9492296576499939e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7470499090850353e+00 1.7422300577163696e+02 -1.1330000311136246e+02) (float-vector 2.0333699882030487e+01 1.6789999604225159e+02 -1.0767199844121933e+02) (float-vector 2.1741500124335289e+01 1.8738000094890594e+02 -1.1107999831438065e+02) (float-vector 8.8624499039724469e-01 1.8738000094890594e+02 -1.1561100184917450e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.3117500394582748e+00 2.1288000047206879e+02 -2.0353898871690035e+00) (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -5.0998101942241192e+00) (float-vector -1.2914000544697046e+00 2.2788000106811523e+02 -2.3074999451637268e+01) (float-vector 1.6151599586009979e+01 2.1613000333309174e+02 -7.4006798677146435e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5004399269819260e+01 2.1288000047206879e+02 -5.8861400932073593e+01) (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector -5.3269799798727036e+01 2.0686000585556030e+02 -3.2828800380229950e+01) (float-vector -5.9107601642608643e+01 2.0053699612617493e+02 -4.5319698750972748e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -7.2768002748489380e+01) (float-vector -3.3213101327419281e+01 2.2788000106811523e+02 -5.9914700686931610e+01) (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector -5.5004399269819260e+01 2.1288000047206879e+02 -5.8861400932073593e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0359698235988617e+01 2.1613000333309174e+02 -2.2542800754308701e+01) (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector -3.3213101327419281e+01 2.2788000106811523e+02 -5.9914700686931610e+01) (float-vector -2.7561500668525696e+01 2.2788000106811523e+02 -3.6618199199438095e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0963599905371666e+01 2.2788000106811523e+02 -3.1984601169824600e+01) (float-vector 1.6151599586009979e+01 2.1613000333309174e+02 -7.4006798677146435e+00) (float-vector -1.2914000544697046e+00 2.2788000106811523e+02 -2.3074999451637268e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0963599905371666e+01 2.2788000106811523e+02 -3.1984601169824600e+01) (float-vector 3.0922099947929382e+01 2.2788000106811523e+02 -5.3790498524904251e+01) (float-vector 4.2875900864601135e+01 2.1613000333309174e+02 -2.9825000092387199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0963599905371666e+01 2.2788000106811523e+02 -3.1984601169824600e+01) (float-vector 4.9510197713971138e+00 2.3213000595569611e+02 -4.9704298377037048e+01) (float-vector 3.0922099947929382e+01 2.2788000106811523e+02 -5.3790498524904251e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3213101327419281e+01 2.2788000106811523e+02 -5.9914700686931610e+01) (float-vector -6.2287999317049980e+00 2.3213000595569611e+02 -6.2120698392391205e+01) (float-vector 4.9510197713971138e+00 2.3213000595569611e+02 -4.9704298377037048e+01) (float-vector 2.0963599905371666e+01 2.2788000106811523e+02 -3.1984601169824600e+01) (float-vector -1.2914000544697046e+00 2.2788000106811523e+02 -2.3074999451637268e+01) (float-vector -2.7561500668525696e+01 2.2788000106811523e+02 -3.6618199199438095e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7242899201810360e+00 1.6188000142574310e+02 -1.0897099971771240e+02) (float-vector -2.9731700196862221e+01 1.6188000142574310e+02 -1.0102800279855728e+02) (float-vector -1.6069199889898300e+01 1.4688000082969666e+02 -8.3989903330802917e+01) (float-vector 7.7944798395037651e+00 1.4688000082969666e+02 -8.6268596351146698e+01) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -1.0324899852275848e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9731700196862221e+01 1.6188000142574310e+02 -1.0102800279855728e+02) (float-vector -4.0359698235988617e+01 1.5862999856472015e+02 -8.8107198476791382e+01) (float-vector -3.1767699867486954e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector -1.6069199889898300e+01 1.4688000082969666e+02 -8.3989903330802917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -4.6468898653984070e+01) (float-vector -5.7850200682878494e+01 1.6789999604225159e+02 -5.2335500717163086e+01) (float-vector -5.5139999836683273e+01 1.7422300577163696e+02 -3.2019399106502533e+01) (float-vector -4.7816898673772812e+01 1.6188000142574310e+02 -2.8251500800251961e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7850200682878494e+01 1.6789999604225159e+02 -5.2335500717163086e+01) (float-vector -6.1532299965620041e+01 1.8738000094890594e+02 -5.2140899002552032e+01) (float-vector -5.9099100530147552e+01 1.8738000094890594e+02 -3.8080301135778427e+01) (float-vector -5.5139999836683273e+01 1.7422300577163696e+02 -3.2019399106502533e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.7850200682878494e+01 1.6789999604225159e+02 -5.2335500717163086e+01) (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -4.6468898653984070e+01) (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -6.4181096851825714e+01) (float-vector -5.5351700633764267e+01 1.6789999604225159e+02 -7.2216503322124481e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1532299965620041e+01 1.8738000094890594e+02 -5.2140899002552032e+01) (float-vector -5.7850200682878494e+01 1.6789999604225159e+02 -5.2335500717163086e+01) (float-vector -5.5351700633764267e+01 1.6789999604225159e+02 -7.2216503322124481e+01) (float-vector -5.3034301847219467e+01 1.8738000094890594e+02 -8.6337499320507050e+01) (float-vector -6.0187898576259613e+01 1.9401000440120697e+02 -6.6303901374340057e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.0005301386117935e+00 2.1288000047206879e+02 -1.0851199924945831e+02) (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -1.0554999858140945e+02) (float-vector -6.1233900487422943e+00 2.0053699612617493e+02 -1.1380100250244141e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1741500124335289e+01 1.8738000094890594e+02 -1.1107999831438065e+02) (float-vector 2.0333699882030487e+01 2.0686000585556030e+02 -1.0767199844121933e+02) (float-vector 7.0005301386117935e+00 2.1288000047206879e+02 -1.0851199924945831e+02) (float-vector -6.1233900487422943e+00 2.0053699612617493e+02 -1.1380100250244141e+02) (float-vector 8.8624499039724469e-01 1.8738000094890594e+02 -1.1561100184917450e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -1.0554999858140945e+02) (float-vector 7.0005301386117935e+00 2.1288000047206879e+02 -1.0851199924945831e+02) (float-vector 2.0333699882030487e+01 2.0686000585556030e+02 -1.0767199844121933e+02) (float-vector 2.4208599701523781e+01 2.1613000333309174e+02 -9.9492296576499939e+01) (float-vector 7.7944798395037651e+00 2.2788000106811523e+02 -8.6268596351146698e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6632900834083557e+01 1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 5.2200101315975189e+01 1.6188000142574310e+02 -6.1345700174570084e+01) (float-vector 5.1928400993347168e+01 1.6789999604225159e+02 -7.4702501296997070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2200101315975189e+01 1.6188000142574310e+02 -6.1345700174570084e+01) (float-vector 5.6926198303699493e+01 1.7422300577163696e+02 -4.8008501529693604e+01) (float-vector 5.9032298624515533e+01 1.8738000094890594e+02 -5.4934799671173096e+01) (float-vector 5.1928400993347168e+01 1.6789999604225159e+02 -7.4702501296997070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8933800309896469e+01 1.5862999856472015e+02 -4.6468898653984070e+01) (float-vector 5.2200101315975189e+01 1.6188000142574310e+02 -6.1345700174570084e+01) (float-vector 4.6632900834083557e+01 1.5862999856472015e+02 -7.2768002748489380e+01) (float-vector 2.9184900224208832e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector 3.0049499124288559e+01 1.4688000082969666e+02 -4.7721799463033676e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0442599430680275e+01 1.7422300577163696e+02 1.3717000547330827e-01) (float-vector -1.4098700135946274e+01 1.8738000094890594e+02 3.6248099058866501e+00) (float-vector 6.7928602220490575e-02 1.7422300577163696e+02 3.3348000142723322e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4098700135946274e+01 1.8738000094890594e+02 3.6248099058866501e+00) (float-vector -2.0442599430680275e+01 1.7422300577163696e+02 1.3717000547330827e-01) (float-vector -3.3600300550460815e+01 1.8074999749660492e+02 -4.8724100925028324e+00) (float-vector -2.6867799460887909e+01 2.0053699612617493e+02 -2.5171800516545773e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4098700135946274e+01 1.8738000094890594e+02 3.6248099058866501e+00) (float-vector -2.6867799460887909e+01 2.0053699612617493e+02 -2.5171800516545773e+00) (float-vector -3.0320599675178528e+01 2.1288000047206879e+02 -9.9940104410052299e+00) (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -5.0998101942241192e+00) (float-vector 6.3117500394582748e+00 2.1288000047206879e+02 -2.0353898871690035e+00) (float-vector 6.7928602220490575e-02 2.0053699612617493e+02 3.3348000142723322e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9215700477361679e+01 2.1613000333309174e+02 -3.7882000207901001e+01) (float-vector -4.0359698235988617e+01 2.1613000333309174e+02 -2.2542800754308701e+01) (float-vector -3.0320599675178528e+01 2.1288000047206879e+02 -9.9940104410052299e+00) (float-vector -4.3655000627040863e+01 2.0053699612617493e+02 -1.4727699570357800e+01) (float-vector -5.3269799798727036e+01 2.0686000585556030e+02 -3.2828800380229950e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9476798623800278e+01 1.8738000094890594e+02 -1.9030699506402016e+01) (float-vector -4.3655000627040863e+01 2.0053699612617493e+02 -1.4727699570357800e+01) (float-vector -3.0320599675178528e+01 2.1288000047206879e+02 -9.9940104410052299e+00) (float-vector -2.6867799460887909e+01 2.0053699612617493e+02 -2.5171800516545773e+00) (float-vector -3.3600300550460815e+01 1.8074999749660492e+02 -4.8724100925028324e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1767699867486954e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector -8.5660098120570183e+00 1.4262999594211578e+02 -5.1125001162290573e+01) (float-vector 7.0625799708068371e+00 1.4262999594211578e+02 -5.4446998983621597e+01) (float-vector 7.7944798395037651e+00 1.4688000082969666e+02 -8.6268596351146698e+01) (float-vector -1.6069199889898300e+01 1.4688000082969666e+02 -8.3989903330802917e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1767699867486954e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -6.4181096851825714e+01) (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -4.6468898653984070e+01) (float-vector -3.2632298767566681e+01 1.4688000082969666e+02 -4.7721799463033676e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1767699867486954e+01 1.4688000082969666e+02 -6.5872900187969208e+01) (float-vector -3.2632298767566681e+01 1.4688000082969666e+02 -4.7721799463033676e+01) (float-vector -1.8727099522948265e+01 1.4688000082969666e+02 -2.8194600716233253e+01) (float-vector -8.5660098120570183e+00 1.4262999594211578e+02 -5.1125001162290573e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7816898673772812e+01 1.6188000142574310e+02 -2.8251500800251961e+01) (float-vector -3.0320599675178528e+01 1.6188000142574310e+02 -9.9940104410052299e+00) (float-vector -1.8727099522948265e+01 1.4688000082969666e+02 -2.8194600716233253e+01) (float-vector -3.2632298767566681e+01 1.4688000082969666e+02 -4.7721799463033676e+01) (float-vector -5.1516599953174591e+01 1.5862999856472015e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3949598670005798e+01 1.8074999749660492e+02 -1.0377500206232071e+02) (float-vector 2.1741500124335289e+01 1.8738000094890594e+02 -1.1107999831438065e+02) (float-vector 2.0333699882030487e+01 1.6789999604225159e+02 -1.0767199844121933e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.1741500124335289e+01 1.8738000094890594e+02 -1.1107999831438065e+02) (float-vector 3.3949598670005798e+01 1.8074999749660492e+02 -1.0377500206232071e+02) (float-vector 3.8592800498008728e+01 2.0053699612617493e+02 -9.8360702395439148e+01) (float-vector 2.0333699882030487e+01 2.0686000585556030e+02 -1.0767199844121933e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.7585401684045792e+01 1.7422300577163696e+02 -8.7788403034210205e+01) (float-vector 4.8959501087665558e+01 1.8738000094890594e+02 -8.8701002299785614e+01) (float-vector 3.8592800498008728e+01 2.0053699612617493e+02 -9.8360702395439148e+01) (float-vector 3.3949598670005798e+01 1.8074999749660492e+02 -1.0377500206232071e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3949598670005798e+01 1.8074999749660492e+02 -1.0377500206232071e+02) (float-vector 2.0333699882030487e+01 1.6789999604225159e+02 -1.0767199844121933e+02) (float-vector 3.5298600792884827e+01 1.6188000142574310e+02 -9.4806201756000519e+01) (float-vector 4.7585401684045792e+01 1.7422300577163696e+02 -8.7788403034210205e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6151599586009979e+01 2.1613000333309174e+02 -7.4006798677146435e+00) (float-vector 2.0963599905371666e+01 2.2788000106811523e+02 -3.1984601169824600e+01) (float-vector 4.2875900864601135e+01 2.1613000333309174e+02 -2.9825000092387199e+01) (float-vector 3.4784801304340363e+01 2.1288000047206879e+02 -1.5373799949884415e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.6086899936199188e+01 1.6789999604225159e+02 -8.9983299374580383e+01) (float-vector -4.0359698235988617e+01 1.5862999856472015e+02 -8.8107198476791382e+01) (float-vector -2.9731700196862221e+01 1.6188000142574310e+02 -1.0102800279855728e+02) (float-vector -3.8738898932933807e+01 1.8074999749660492e+02 -1.0209099948406219e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -5.0998101942241192e+00) (float-vector -3.0320599675178528e+01 2.1288000047206879e+02 -9.9940104410052299e+00) (float-vector -4.0359698235988617e+01 2.1613000333309174e+02 -2.2542800754308701e+01) (float-vector -2.7561500668525696e+01 2.2788000106811523e+02 -3.6618199199438095e+01) (float-vector -1.2914000544697046e+00 2.2788000106811523e+02 -2.3074999451637268e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.4784801304340363e+01 1.6188000142574310e+02 -1.5373799949884415e+01) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector 3.2606098800897598e+01 1.7422300577163696e+02 -7.4316100217401981e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8734399229288101e+01 1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector -1.8727099522948265e+01 1.4688000082969666e+02 -2.8194600716233253e+01) (float-vector -3.0320599675178528e+01 1.6188000142574310e+02 -9.9940104410052299e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0694700293242931e+01 1.4688000082969666e+02 -2.5385100394487381e+01) (float-vector 3.0049499124288559e+01 1.4688000082969666e+02 -4.7721799463033676e+01) (float-vector 7.0625799708068371e+00 1.4262999594211578e+02 -5.4446998983621597e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0694700293242931e+01 1.4688000082969666e+02 -2.5385100394487381e+01) (float-vector 7.0625799708068371e+00 1.4262999594211578e+02 -5.4446998983621597e+01) (float-vector -8.5660098120570183e+00 1.4262999594211578e+02 -5.1125001162290573e+01) (float-vector -1.8727099522948265e+01 1.4688000082969666e+02 -2.8194600716233253e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9654700532555580e+01 2.0686000585556030e+02 -2.7028000913560390e+00) (float-vector 3.4784801304340363e+01 2.1288000047206879e+02 -1.5373799949884415e+01) (float-vector 3.8032699376344681e+01 2.0053699612617493e+02 -1.1776899918913841e+01) (float-vector 2.0865200087428093e+01 1.9401000440120697e+02 3.3841800177469850e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9654700532555580e+01 2.0686000585556030e+02 -2.7028000913560390e+00) (float-vector 6.3117500394582748e+00 2.1288000047206879e+02 -2.0353898871690035e+00) (float-vector 1.6151599586009979e+01 2.1613000333309174e+02 -7.4006798677146435e+00) (float-vector 3.4784801304340363e+01 2.1288000047206879e+02 -1.5373799949884415e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9654700532555580e+01 2.0686000585556030e+02 -2.7028000913560390e+00) (float-vector 2.0865200087428093e+01 1.9401000440120697e+02 3.3841800177469850e-01) (float-vector 7.2292499244213104e+00 1.8738000094890594e+02 4.3952101841568947e+00) (float-vector 6.7928602220490575e-02 2.0053699612617493e+02 3.3348000142723322e+00) (float-vector 6.3117500394582748e+00 2.1288000047206879e+02 -2.0353898871690035e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.2292499244213104e+00 1.8738000094890594e+02 4.3952101841568947e+00) (float-vector 6.7928602220490575e-02 1.7422300577163696e+02 3.3348000142723322e+00) (float-vector -1.4098700135946274e+01 1.8738000094890594e+02 3.6248099058866501e+00) (float-vector 6.7928602220490575e-02 2.0053699612617493e+02 3.3348000142723322e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0735298544168472e+01 2.0053699612617493e+02 -2.8194900602102280e+01) (float-vector 5.0948999822139740e+01 2.1288000047206879e+02 -4.2343098670244217e+01) (float-vector 5.6851200759410858e+01 1.9401000440120697e+02 -4.0876299142837524e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0735298544168472e+01 2.0053699612617493e+02 -2.8194900602102280e+01) (float-vector 4.8523500561714172e+01 1.8738000094890594e+02 -2.1301699802279472e+01) (float-vector 3.8032699376344681e+01 2.0053699612617493e+02 -1.1776899918913841e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.0948999822139740e+01 2.1288000047206879e+02 -4.2343098670244217e+01) (float-vector 5.0735298544168472e+01 2.0053699612617493e+02 -2.8194900602102280e+01) (float-vector 3.8032699376344681e+01 2.0053699612617493e+02 -1.1776899918913841e+01) (float-vector 3.4784801304340363e+01 2.1288000047206879e+02 -1.5373799949884415e+01) (float-vector 4.2875900864601135e+01 2.1613000333309174e+02 -2.9825000092387199e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0111599937081337e+01 1.8074999749660492e+02 -1.1220300197601318e+02) (float-vector -2.9731700196862221e+01 1.6188000142574310e+02 -1.0102800279855728e+02) (float-vector -5.7242899201810360e+00 1.6188000142574310e+02 -1.0897099971771240e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.8624499039724469e-01 1.8738000094890594e+02 -1.1561100184917450e+02) (float-vector -2.0111599937081337e+01 1.8074999749660492e+02 -1.1220300197601318e+02) (float-vector -5.7242899201810360e+00 1.6188000142574310e+02 -1.0897099971771240e+02) (float-vector 7.7470499090850353e+00 1.7422300577163696e+02 -1.1330000311136246e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3126299977302551e+01 2.0053699612617493e+02 -9.6467003226280212e+01) (float-vector -5.3034301847219467e+01 1.8738000094890594e+02 -8.6337499320507050e+01) (float-vector -4.6086899936199188e+01 1.6789999604225159e+02 -8.9983299374580383e+01) (float-vector -3.8738898932933807e+01 1.8074999749660492e+02 -1.0209099948406219e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4343902118271217e-02 1.6188000142574310e+02 -1.5101799508556724e+00) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector 1.0694700293242931e+01 1.4688000082969666e+02 -2.5385100394487381e+01) (float-vector -1.8727099522948265e+01 1.4688000082969666e+02 -2.8194600716233253e+01) (float-vector -1.8734399229288101e+01 1.5862999856472015e+02 -7.4006798677146435e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.7928602220490575e-02 1.7422300577163696e+02 3.3348000142723322e+00) (float-vector -4.4343902118271217e-02 1.6188000142574310e+02 -1.5101799508556724e+00) (float-vector -1.8734399229288101e+01 1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector -3.0320599675178528e+01 1.6188000142574310e+02 -9.9940104410052299e+00) (float-vector -2.0442599430680275e+01 1.7422300577163696e+02 1.3717000547330827e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0049499124288559e+01 1.4688000082969666e+02 -4.7721799463033676e+01) (float-vector 4.2875900864601135e+01 1.5862999856472015e+02 -2.9825000092387199e+01) (float-vector 4.8933800309896469e+01 1.5862999856472015e+02 -4.6468898653984070e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.2875900864601135e+01 1.5862999856472015e+02 -2.9825000092387199e+01) (float-vector 3.4784801304340363e+01 1.6188000142574310e+02 -1.5373799949884415e+01) (float-vector 4.8928398638963699e+01 1.6789999604225159e+02 -2.9137099161744118e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0694700293242931e+01 1.4688000082969666e+02 -2.5385100394487381e+01) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector 3.4784801304340363e+01 1.6188000142574310e+02 -1.5373799949884415e+01) (float-vector 4.2875900864601135e+01 1.5862999856472015e+02 -2.9825000092387199e+01) (float-vector 3.0049499124288559e+01 1.4688000082969666e+02 -4.7721799463033676e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0865200087428093e+01 1.8074999749660492e+02 3.3841800177469850e-01) (float-vector 7.2292499244213104e+00 1.8738000094890594e+02 4.3952101841568947e+00) (float-vector 2.0865200087428093e+01 1.9401000440120697e+02 3.3841800177469850e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0865200087428093e+01 1.8074999749660492e+02 3.3841800177469850e-01) (float-vector 2.0865200087428093e+01 1.9401000440120697e+02 3.3841800177469850e-01) (float-vector 3.8032699376344681e+01 2.0053699612617493e+02 -1.1776899918913841e+01) (float-vector 4.8523500561714172e+01 1.8738000094890594e+02 -2.1301699802279472e+01) (float-vector 3.2606098800897598e+01 1.7422300577163696e+02 -7.4316100217401981e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.2292499244213104e+00 1.8738000094890594e+02 4.3952101841568947e+00) (float-vector 2.0865200087428093e+01 1.8074999749660492e+02 3.3841800177469850e-01) (float-vector 3.2606098800897598e+01 1.7422300577163696e+02 -7.4316100217401981e+00) (float-vector 1.6151599586009979e+01 1.5862999856472015e+02 -7.4006798677146435e+00) (float-vector -4.4343902118271217e-02 1.6188000142574310e+02 -1.5101799508556724e+00) (float-vector 6.7928602220490575e-02 1.7422300577163696e+02 3.3348000142723322e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8523500561714172e+01 1.8738000094890594e+02 -2.1301699802279472e+01) (float-vector 5.0735298544168472e+01 2.0053699612617493e+02 -2.8194900602102280e+01) (float-vector 5.6851200759410858e+01 1.9401000440120697e+02 -4.0876299142837524e+01) (float-vector 5.4734300822019577e+01 1.8074999749660492e+02 -3.4100998193025589e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6926198303699493e+01 1.7422300577163696e+02 -4.8008501529693604e+01) (float-vector 5.4734300822019577e+01 1.8074999749660492e+02 -3.4100998193025589e+01) (float-vector 5.6851200759410858e+01 1.9401000440120697e+02 -4.0876299142837524e+01) (float-vector 5.9032298624515533e+01 1.8738000094890594e+02 -5.4934799671173096e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.4734300822019577e+01 1.8074999749660492e+02 -3.4100998193025589e+01) (float-vector 5.6926198303699493e+01 1.7422300577163696e+02 -4.8008501529693604e+01) (float-vector 5.2200101315975189e+01 1.6188000142574310e+02 -6.1345700174570084e+01) (float-vector 4.8933800309896469e+01 1.5862999856472015e+02 -4.6468898653984070e+01) (float-vector 4.2875900864601135e+01 1.5862999856472015e+02 -2.9825000092387199e+01) (float-vector 4.8928398638963699e+01 1.6789999604225159e+02 -2.9137099161744118e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.2606098800897598e+01 1.7422300577163696e+02 -7.4316100217401981e+00) (float-vector 4.8523500561714172e+01 1.8738000094890594e+02 -2.1301699802279472e+01) (float-vector 5.4734300822019577e+01 1.8074999749660492e+02 -3.4100998193025589e+01) (float-vector 4.8928398638963699e+01 1.6789999604225159e+02 -2.9137099161744118e+01) (float-vector 3.4784801304340363e+01 1.6188000142574310e+02 -1.5373799949884415e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0111599937081337e+01 1.8074999749660492e+02 -1.1220300197601318e+02) (float-vector -3.3163700252771378e+01 1.8738000094890594e+02 -1.0654299706220627e+02) (float-vector -3.8738898932933807e+01 1.8074999749660492e+02 -1.0209099948406219e+02) (float-vector -2.9731700196862221e+01 1.6188000142574310e+02 -1.0102800279855728e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0111599937081337e+01 1.9401000440120697e+02 -1.1220300197601318e+02) (float-vector -3.3163700252771378e+01 1.8738000094890594e+02 -1.0654299706220627e+02) (float-vector -2.0111599937081337e+01 1.8074999749660492e+02 -1.1220300197601318e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0111599937081337e+01 1.9401000440120697e+02 -1.1220300197601318e+02) (float-vector -6.1233900487422943e+00 2.0053699612617493e+02 -1.1380100250244141e+02) (float-vector -1.0147499851882458e+01 2.1613000333309174e+02 -1.0554999858140945e+02) (float-vector -3.1215500086545944e+01 2.0686000585556030e+02 -1.0341200232505798e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1233900487422943e+00 2.0053699612617493e+02 -1.1380100250244141e+02) (float-vector -2.0111599937081337e+01 1.9401000440120697e+02 -1.1220300197601318e+02) (float-vector -2.0111599937081337e+01 1.8074999749660492e+02 -1.1220300197601318e+02) (float-vector 8.8624499039724469e-01 1.8738000094890594e+02 -1.1561100184917450e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8738898932933807e+01 1.8074999749660492e+02 -1.0209099948406219e+02) (float-vector -3.3163700252771378e+01 1.8738000094890594e+02 -1.0654299706220627e+02) (float-vector -2.0111599937081337e+01 1.9401000440120697e+02 -1.1220300197601318e+02) (float-vector -3.1215500086545944e+01 2.0686000585556030e+02 -1.0341200232505798e+02) (float-vector -4.3126299977302551e+01 2.0053699612617493e+02 -9.6467003226280212e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_r_wheel_link_7rWD0T.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_torso_fixed_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -8.6875000000000000e+01 0.0000000000000000e+00 3.7742500000000001e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 2 11 0 11 12 0 12 20 0 0 20 1 1 11 2 1 27 11 11 40 12 27 40 11 14 38 12 38 20 12 14 12 40 28 15 40 40 27 28 14 40 15 28 27 1 28 1 32 28 43 16 32 43 28 28 42 53 16 42 28 28 56 15 56 28 53 13 14 15 13 15 56 8 38 13 14 13 38 8 13 9 13 56 59 59 39 13 13 39 9 9 10 5 10 9 39 8 9 5 22 10 39 57 39 59 22 39 57 57 59 56 57 56 58 58 46 57 57 46 22 10 22 23 46 47 22 22 47 23 10 23 50 10 50 5 47 50 23 31 47 46 30 47 31 50 47 30 56 46 58 46 56 31 29 30 31 29 31 56 30 29 50 48 29 49 48 50 29 54 29 55 54 49 29 29 56 55 54 55 56 54 56 53 42 54 53 54 42 49 42 48 49 41 48 42 48 41 50 16 41 42 41 16 50 6 16 17 3 16 6 16 33 17 33 16 43 16 3 50 3 5 50 3 4 5 6 4 3 4 6 44 17 44 6 33 25 17 25 44 17 36 4 44 25 24 44 18 44 24 36 44 18 4 36 5 7 8 5 36 7 5 36 18 7 7 18 19 24 33 18 18 34 19 33 34 18 24 25 26 26 33 24 25 33 26 35 34 33 43 45 33 33 45 35 52 34 35 52 19 34 52 21 19 7 19 21 51 21 52 52 45 51 35 45 52 21 20 8 20 21 37 21 8 7 21 51 45 37 21 45 20 37 1 20 38 8 37 45 1 32 1 45 45 43 32))
                   (list :vertices (let ((mat (make-matrix 60 3))) (fvector-replace (array-entity mat) #f(-6.1441101074218750e+01 1.2330500030517578e+02 -3.9599401855468750e+02 -7.2454200744628906e+01 9.9518600463867188e+01 6.5880798339843750e+01 -6.1440700531005859e+01 1.2330500030517578e+02 6.5880798339843750e+01 -3.0590499877929688e+01 -1.5535000610351562e+02 -3.9599401855468750e+02 -3.9073898315429688e+01 -1.5008399963378906e+02 -3.9599401855468750e+02 5.1809501647949219e+01 -1.5535000610351562e+02 -3.9599401855468750e+02 -4.0557102203369141e+01 -1.5283399963378906e+02 -3.9599401855468750e+02 -7.8070198059082031e+01 -7.3882102966308594e+01 -3.9599401855468750e+02 -7.8070198059082031e+01 7.3881904602050781e+01 -3.9599401855468750e+02 5.1809501647949219e+01 1.5222500610351562e+02 -3.9599401855468750e+02 5.3309501647949219e+01 -1.5535000610351562e+02 -3.9559201049804688e+02 -4.8135299682617188e+01 1.4588999938964844e+02 6.5880798339843750e+01 -4.8135601043701172e+01 1.4588999938964844e+02 -3.9599401855468750e+02 5.1809501647949219e+01 1.5535000610351562e+02 -3.9599401855468750e+02 -3.9073898315429688e+01 1.5008399963378906e+02 -3.9599401855468750e+02 -3.0590400695800781e+01 1.5535000610351562e+02 -3.9599401855468750e+02 -3.0590099334716797e+01 -1.5535000610351562e+02 6.5880798339843750e+01 -4.0556697845458984e+01 -1.5283399963378906e+02 6.5880798339843750e+01 -7.2454605102539062e+01 -9.9518699645996094e+01 -3.9599401855468750e+02 -8.1412704467773438e+01 -7.2368499755859375e+01 -3.9599401855468750e+02 -7.2454605102539062e+01 9.9518600463867188e+01 -3.9599401855468750e+02 -8.1412704467773438e+01 7.2368400573730469e+01 -3.9599401855468750e+02 5.4407600402832031e+01 1.5222500610351562e+02 -3.9449398803710938e+02 5.4407600402832031e+01 -1.5535000610351562e+02 -3.9449398803710938e+02 -6.1441101074218750e+01 -1.2330500030517578e+02 -3.9599401855468750e+02 -4.8135299682617188e+01 -1.4588999938964844e+02 6.5880798339843750e+01 -6.1440700531005859e+01 -1.2330500030517578e+02 6.5880798339843750e+01 -4.0556598663330078e+01 1.5283399963378906e+02 6.5880798339843750e+01 -3.0590099334716797e+01 1.5535000610351562e+02 6.5880798339843750e+01 5.4407997131347656e+01 1.5222500610351562e+02 6.4380699157714844e+01 5.4809898376464844e+01 -1.5535000610351562e+02 6.2880702972412109e+01 5.4809898376464844e+01 1.5222500610351562e+02 6.2880702972412109e+01 -6.9557006835937500e+01 9.8347198486328125e+01 6.5880798339843750e+01 -7.2454200744628906e+01 -9.9518699645996094e+01 6.5880798339843750e+01 -8.1068702697753906e+01 -7.4762100219726562e+01 -3.9599401855468750e+02 -8.1068397521972656e+01 -7.4762100219726562e+01 6.5880798339843750e+01 -5.8673603057861328e+01 -1.2185399627685547e+02 -3.9599401855468750e+02 -8.1068702697753906e+01 7.4761894226074219e+01 -3.9599401855468750e+02 -5.8673603057861328e+01 1.2185399627685547e+02 -3.9599401855468750e+02 5.3309501647949219e+01 1.5222500610351562e+02 -3.9559201049804688e+02 -4.0556999206542969e+01 1.5283399963378906e+02 -3.9599401855468750e+02 5.1809898376464844e+01 -1.5535000610351562e+02 6.5880699157714844e+01 5.1809898376464844e+01 1.5222500610351562e+02 6.5880699157714844e+01 -6.9557006835937500e+01 -9.8347297668457031e+01 6.5880798339843750e+01 -4.8135700225830078e+01 -1.4588999938964844e+02 -3.9599401855468750e+02 -8.1068397521972656e+01 7.4761894226074219e+01 6.5880798339843750e+01 5.4809497833251953e+01 1.5222500610351562e+02 -3.9299398803710938e+02 5.4809497833251953e+01 -1.5535000610351562e+02 -3.9299398803710938e+02 5.3309799194335938e+01 -1.5535000610351562e+02 6.5478805541992188e+01 5.3309898376464844e+01 1.5222500610351562e+02 6.5478805541992188e+01 5.4407897949218750e+01 -1.5535000610351562e+02 6.4380699157714844e+01 -8.1412300109863281e+01 7.2368400573730469e+01 6.5880798339843750e+01 -8.1412300109863281e+01 -7.2368499755859375e+01 6.5880798339843750e+01 5.1809898376464844e+01 1.5535000610351562e+02 6.5880699157714844e+01 5.3309898376464844e+01 1.5535000610351562e+02 6.5478805541992188e+01 5.4407997131347656e+01 1.5535000610351562e+02 6.4380699157714844e+01 5.4809898376464844e+01 1.5535000610351562e+02 6.2880702972412109e+01 5.4407600402832031e+01 1.5535000610351562e+02 -3.9449398803710938e+02 5.4809497833251953e+01 1.5535000610351562e+02 -3.9299398803710938e+02 5.3309501647949219e+01 1.5535000610351562e+02 -3.9559201049804688e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 348 -> 13 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.4809499531984329e+01 1.5534999966621399e+02 -3.9299398660659790e+02) (float-vector 5.4809499531984329e+01 -1.5534999966621399e+02 -3.9299398660659790e+02) (float-vector 5.4809898138046265e+01 -1.5534999966621399e+02 6.2880702316761017e+01) (float-vector 5.4809898138046265e+01 1.5534999966621399e+02 6.2880702316761017e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.1412300467491150e+01 7.2368398308753967e+01 6.5880797803401947e+01) (float-vector -8.1068396568298340e+01 -7.4762098491191864e+01 6.5880797803401947e+01) (float-vector -8.1412702798843384e+01 -7.2368502616882324e+01 -3.9599400758743286e+02) (float-vector -8.1068702042102814e+01 7.4761897325515747e+01 -3.9599400758743286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.2454199194908142e+01 9.9518597126007080e+01 6.5880797803401947e+01) (float-vector -8.1412300467491150e+01 7.2368398308753967e+01 6.5880797803401947e+01) (float-vector -8.1068702042102814e+01 7.4761897325515747e+01 -3.9599400758743286e+02) (float-vector -6.1441101133823395e+01 1.2330500036478043e+02 -3.9599400758743286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1441101133823395e+01 1.2330500036478043e+02 -3.9599400758743286e+02) (float-vector -4.8135299235582352e+01 1.4588999748229980e+02 6.5880797803401947e+01) (float-vector -7.2454199194908142e+01 9.9518597126007080e+01 6.5880797803401947e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0556598454713821e+01 1.5283399820327759e+02 6.5880797803401947e+01) (float-vector -4.8135299235582352e+01 1.4588999748229980e+02 6.5880797803401947e+01) (float-vector -6.1441101133823395e+01 1.2330500036478043e+02 -3.9599400758743286e+02) (float-vector -4.0557000786066055e+01 1.5283399820327759e+02 -3.9599400758743286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.1068396568298340e+01 -7.4762098491191864e+01 6.5880797803401947e+01) (float-vector -6.1441101133823395e+01 -1.2330500036478043e+02 -3.9599400758743286e+02) (float-vector -8.1412702798843384e+01 -7.2368502616882324e+01 -3.9599400758743286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0556699037551880e+01 -1.5283399820327759e+02 6.5880797803401947e+01) (float-vector -3.0590100213885307e+01 -1.5534999966621399e+02 6.5880797803401947e+01) (float-vector -3.0590500682592392e+01 -1.5534999966621399e+02 -3.9599400758743286e+02) (float-vector -4.0557101368904114e+01 -1.5283399820327759e+02 -3.9599400758743286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0557000786066055e+01 1.5283399820327759e+02 -3.9599400758743286e+02) (float-vector 5.4809499531984329e+01 1.5534999966621399e+02 -3.9299398660659790e+02) (float-vector 5.4809898138046265e+01 1.5534999966621399e+02 6.2880702316761017e+01) (float-vector -4.0556598454713821e+01 1.5283399820327759e+02 6.5880797803401947e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.2454199194908142e+01 9.9518597126007080e+01 6.5880797803401947e+01) (float-vector -4.8135299235582352e+01 1.4588999748229980e+02 6.5880797803401947e+01) (float-vector -4.0556598454713821e+01 1.5283399820327759e+02 6.5880797803401947e+01) (float-vector 5.4809898138046265e+01 1.5534999966621399e+02 6.2880702316761017e+01) (float-vector 5.4809898138046265e+01 -1.5534999966621399e+02 6.2880702316761017e+01) (float-vector -3.0590100213885307e+01 -1.5534999966621399e+02 6.5880797803401947e+01) (float-vector -4.0556699037551880e+01 -1.5283399820327759e+02 6.5880797803401947e+01) (float-vector -4.8135299235582352e+01 -1.4588999748229980e+02 6.5880797803401947e+01) (float-vector -8.1068396568298340e+01 -7.4762098491191864e+01 6.5880797803401947e+01) (float-vector -8.1412300467491150e+01 7.2368398308753967e+01 6.5880797803401947e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.8135701566934586e+01 -1.4588999748229980e+02 -3.9599400758743286e+02) (float-vector -4.8135299235582352e+01 -1.4588999748229980e+02 6.5880797803401947e+01) (float-vector -4.0556699037551880e+01 -1.5283399820327759e+02 6.5880797803401947e+01) (float-vector -4.0557101368904114e+01 -1.5283399820327759e+02 -3.9599400758743286e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.8135701566934586e+01 -1.4588999748229980e+02 -3.9599400758743286e+02) (float-vector -6.1441101133823395e+01 -1.2330500036478043e+02 -3.9599400758743286e+02) (float-vector -8.1068396568298340e+01 -7.4762098491191864e+01 6.5880797803401947e+01) (float-vector -4.8135299235582352e+01 -1.4588999748229980e+02 6.5880797803401947e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.4809499531984329e+01 -1.5534999966621399e+02 -3.9299398660659790e+02) (float-vector -3.0590500682592392e+01 -1.5534999966621399e+02 -3.9599400758743286e+02) (float-vector -3.0590100213885307e+01 -1.5534999966621399e+02 6.5880797803401947e+01) (float-vector 5.4809898138046265e+01 -1.5534999966621399e+02 6.2880702316761017e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0557101368904114e+01 -1.5283399820327759e+02 -3.9599400758743286e+02) (float-vector -3.0590500682592392e+01 -1.5534999966621399e+02 -3.9599400758743286e+02) (float-vector 5.4809499531984329e+01 -1.5534999966621399e+02 -3.9299398660659790e+02) (float-vector 5.4809499531984329e+01 1.5534999966621399e+02 -3.9299398660659790e+02) (float-vector -4.0557000786066055e+01 1.5283399820327759e+02 -3.9599400758743286e+02) (float-vector -6.1441101133823395e+01 1.2330500036478043e+02 -3.9599400758743286e+02) (float-vector -8.1068702042102814e+01 7.4761897325515747e+01 -3.9599400758743286e+02) (float-vector -8.1412702798843384e+01 -7.2368502616882324e+01 -3.9599400758743286e+02) (float-vector -6.1441101133823395e+01 -1.2330500036478043e+02 -3.9599400758743286e+02) (float-vector -4.8135701566934586e+01 -1.4588999748229980e+02 -3.9599400758743286e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_torso_fixed_link_koGfAr.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_torso_lift_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector -8.6875000000000000e+01 0.0000000000000000e+00 3.7743000000000001e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 0 3 5300 1 0 5293 5293 0 5300 5300 3 5301 5300 5301 5302 5293 5300 5292 5292 5300 5302 5292 5288 5293 5293 5288 5291 5293 5291 1 3853 3848 5292 5292 3848 5288 3854 3853 5292 5292 5302 3854 3852 3848 3853 3852 3853 3850 3850 3853 3854 3846 3847 3848 3851 3846 3848 3851 3848 3852 3848 3847 5288 3850 3858 3852 3852 3858 3859 3852 3859 3851 3851 1408 1407 1407 3846 3851 3851 3859 1408 1407 1408 1409 1409 1408 1410 1410 1408 3377 3859 3377 1408 1407 1409 5271 1407 5271 5280 3846 1407 5289 5289 1407 5280 1409 1410 3863 1409 3863 5271 1410 3377 3378 3863 1410 3864 3864 1410 3378 3378 3377 3379 3859 3379 3377 3378 3379 3380 3864 3378 3875 3875 3378 3380 3380 3379 3381 3381 3379 3859 3858 3857 3859 3859 3857 3861 3859 3861 3381 3380 3381 3382 3381 3861 3860 3381 3860 3382 3860 3861 3862 3862 3861 3857 3382 3860 3387 3855 3387 3860 3855 3860 3856 3856 3860 3862 3862 3857 3405 3856 3862 3407 3407 3862 3405 1551 3855 3856 3407 3408 3856 3856 3408 1551 3386 3855 1551 3386 3387 3855 3382 3387 3383 3383 3387 3386 3386 1551 1550 3383 3386 3388 3388 3386 1550 3383 3384 3382 3878 3384 3383 3878 3383 3879 3383 3388 3879 3879 3388 1550 3873 3878 3879 3873 3879 3872 3879 1550 3872 3876 3384 3878 3877 3876 3878 3877 3878 3873 3382 3384 3385 3876 3385 3384 3382 3385 3380 3380 3385 3876 3875 3380 3876 3874 3875 3876 3874 3876 3877 3361 3874 3877 3361 3877 3873 3360 3365 3874 3874 3365 3869 3360 3874 3361 3869 3875 3874 3869 3864 3875 3863 3864 3865 3867 3865 3864 3867 3864 3868 3868 3864 3869 3863 3865 5269 5271 3863 5269 3866 3865 3867 3865 3866 5267 5269 3865 5267 3868 5259 3867 3866 3867 5267 5267 3867 5259 3868 3869 3870 5258 5259 3868 3870 5258 3868 5258 5257 5259 5267 5259 5268 5268 5259 5257 5269 5267 5270 5270 5267 5268 5268 5257 366 5270 5268 368 368 5268 366 5256 92 5257 5256 5257 5258 366 5257 92 5255 5256 5258 5255 5258 3870 93 92 5256 5260 93 5256 5260 5256 5255 91 92 93 92 91 366 366 91 367 366 367 368 91 400 367 367 432 368 5375 432 367 5375 367 5376 400 5376 367 91 399 400 5380 5376 400 399 5380 400 5377 5375 5376 5377 5376 5378 5380 5378 5376 5373 432 5375 5374 5373 5375 5374 5375 5377 5378 3817 5377 5377 3817 3818 5377 3818 5374 1500 5372 5374 5372 5373 5374 5374 3818 3819 5374 3819 1500 3817 3813 3818 3818 3813 3815 3818 3815 3819 3819 3815 1500 3815 1501 1500 3813 3822 3815 3823 1501 3815 3815 3822 3823 3813 3312 3822 3312 3311 3822 3822 3311 3309 3822 3309 3824 3823 3822 3824 1498 3311 3312 1498 3312 1499 1499 3312 3813 3310 3309 3311 3310 3311 1498 3308 3309 3310 3309 3308 3824 3315 3308 3310 3315 3310 1496 1496 3310 1498 1497 1496 1498 1497 1498 1499 1497 1499 3812 3812 1499 3813 1495 1496 1497 5355 1495 1497 5355 1497 5356 1497 3812 5356 1495 1494 1496 1494 3315 1496 1493 1494 1495 5354 1493 1495 5354 1495 5355 5357 5354 5355 5357 5355 5358 5358 5355 5356 5358 5356 5359 5356 3812 5379 5356 5379 5359 397 5357 5358 397 5358 398 398 5358 5359 5352 5354 5357 421 5352 5357 421 5357 397 397 398 327 327 421 397 327 398 399 398 5359 399 5359 5379 5380 5359 5380 399 327 399 91 93 159 91 91 159 160 91 160 161 327 91 5545 161 5545 91 159 93 5260 160 159 5247 5247 159 5260 160 162 161 5247 5245 160 160 5245 162 5246 5244 5247 5247 5244 5245 5247 5260 5246 5246 5260 5255 1418 1416 5246 5246 1416 5244 5246 5255 1418 1416 1414 5244 5244 1414 5243 5244 5243 5245 5245 5243 5242 5245 5242 162 5229 5242 5243 5229 5243 5233 5233 5243 1414 165 163 5242 165 5242 5229 162 5242 163 166 165 5229 5232 166 5229 5232 5229 5233 164 163 165 165 166 164 161 162 163 161 163 164 164 166 167 164 167 168 5563 5561 164 164 5561 161 164 168 5563 5231 167 166 5231 166 5232 5232 5233 5234 5232 5234 5231 5230 167 5231 5231 5234 5235 5231 5235 5230 5233 1425 5234 5234 1425 1423 5234 1423 5235 5233 1412 1425 5233 1414 1412 1424 1423 1425 1424 1425 1411 1411 1425 1412 1422 1421 1423 1422 1423 1424 5235 1423 1421 3342 3341 1424 3342 1424 1411 1422 1424 3343 3343 1424 3341 1411 1412 1413 1411 1413 3342 1413 1412 1414 1413 1414 1415 1413 1415 3367 3342 1413 3367 3340 3341 3342 3342 3367 3340 3340 3339 3341 3343 3341 3344 3344 3341 3339 1567 3339 3340 3340 3367 3368 3340 3368 1567 3367 1415 3362 3367 3362 3368 3368 3362 3359 3368 3359 1552 1567 3368 1552 1551 1566 1567 1551 1567 1552 1567 1566 3339 1549 1551 1552 1552 3359 1549 1549 1550 1551 1565 1566 1551 3408 1565 1551 1565 1564 1566 1564 3339 1566 1563 1564 1565 3408 3406 1565 1563 1565 3400 3400 1565 3406 3407 3406 3408 3405 3403 3406 3405 3406 3407 3400 3406 3397 3397 3406 3403 3397 3399 3400 3400 3399 1570 3400 1570 1563 1405 1391 3397 1391 3398 3397 3397 3398 3399 3397 3403 1405 3398 3422 3399 3399 3422 3430 3399 3430 1570 1391 1400 3398 3398 1400 3422 1391 1392 1393 1393 1400 1391 1405 1392 1391 1393 1399 1400 1400 1399 3422 1399 1397 3422 3422 1397 3426 3422 3426 3430 1398 1397 1399 1398 1399 1393 5311 1398 1393 5311 1393 1392 1405 1406 1392 5311 1392 1406 1403 1404 1405 1404 1406 1405 1405 3403 1403 1406 1404 5310 1406 5310 5311 1403 1402 1404 1404 1402 5310 1401 1402 1403 3403 3404 1403 1403 3404 1401 3401 3402 3403 3403 3402 3404 3401 3403 3405 1401 3404 3850 3850 3404 3858 3404 3402 3858 1402 1401 3849 3849 1401 3850 3850 3854 3849 5302 5303 3849 3849 5303 1402 3854 5302 3849 5302 5301 5303 5310 1402 5303 5310 5303 5312 5312 5303 5301 5312 5301 20 20 5301 3 5311 5310 5312 5311 5312 5313 5313 5312 20 3 10 20 20 10 18 5313 20 18 2 19 3 3 19 10 10 19 5381 2 5381 19 10 5381 5360 5360 5381 5382 5384 5382 5381 5384 5381 2 4 10 5360 5366 4 5360 5366 5360 5367 5360 5382 5367 5367 5382 1369 5383 1369 5382 5383 5382 5384 2 382 5384 5384 382 5389 5384 5389 5383 1368 1369 5383 5383 5389 5387 5383 5387 1368 1367 1369 1365 1365 1369 1368 5367 1369 1367 1368 1363 1364 1365 1368 1370 1370 1368 1364 1368 5387 1363 1363 5387 5388 5388 5387 5389 1361 1362 1363 1363 1362 1364 5388 1361 1363 3464 1370 1364 1364 1362 3464 3464 3463 1370 1365 1370 3465 3465 1370 3463 3462 3463 3464 3464 1362 3483 3464 3483 3462 1361 1360 1362 1362 1360 3483 3483 1360 3479 3483 3479 3484 3462 3483 3484 1645 3461 3462 3462 3461 3463 3462 3484 1645 3484 3479 3476 3484 3476 1647 1645 3484 1647 1644 1643 1645 1644 1645 1646 1646 1645 1647 1645 1643 3461 3466 3463 3461 3466 3461 1641 1641 3461 1643 1642 1641 1643 1642 1643 1644 1640 1587 1641 1640 1641 1642 1587 3466 1641 3465 3463 3466 3450 3465 3466 3450 3466 1587 3452 1365 3465 3452 3465 3450 1587 3449 3450 3450 3449 3451 3450 3451 3452 3452 3451 1375 3452 1375 1366 1366 1365 3452 1365 1366 1367 1367 1366 1374 1374 1366 1375 1374 1375 1376 1376 1375 1377 1377 1375 3453 3453 1375 3451 3453 3451 3454 3454 3451 3449 3440 1377 3453 3440 3453 3439 3439 3453 3454 1376 1377 1373 1373 1377 1378 1378 1377 3440 3439 3437 3440 3440 3437 1390 3440 1390 1378 1558 3438 3439 3439 3438 3437 3439 3454 1558 1387 1390 3437 3438 3442 3437 3437 3442 3441 3437 3441 1387 1389 1378 1390 1389 1390 1387 1385 1386 1387 1387 1386 1388 1387 1388 1389 1387 3441 1385 1379 1378 1389 1388 5348 1389 1379 1389 5339 5339 1389 5348 1386 5348 1388 5348 5349 5350 1386 5349 5348 5339 5348 5342 5342 5348 5350 5338 1379 5339 5338 5339 5340 5340 5339 5341 5341 5339 5342 1372 1379 5338 1373 1372 5338 5363 1373 5338 5363 5338 5340 5363 5340 5341 5341 5342 5343 5361 5363 5341 5361 5341 5362 5364 5370 5363 5364 5363 5361 5370 1373 5363 5361 5362 5344 5344 11 5361 5361 11 7 5361 7 5364 5364 7 5 5364 5 5365 5365 5370 5364 5365 5369 5370 5369 1376 5370 5370 1376 1373 5365 5 4 5365 4 5366 5366 5369 5365 4 5 6 6 5 7 7 11 6 6 11 12 5344 12 11 6 12 13 13 12 5342 5342 12 5344 13 14 6 5342 5350 13 13 5350 14 5342 5344 5343 6 14 15 5350 5351 14 14 5351 15 5350 5349 5351 5345 15 5351 5345 5351 5346 5346 5351 5349 6 15 8 8 15 5345 5325 8 5345 5346 5324 5345 5345 5324 5323 5345 5323 5325 8 9 6 9 8 5325 6 9 10 6 10 4 9 16 10 16 9 5325 5322 16 5325 5322 5325 5323 5322 5323 5324 5328 5330 5322 5328 5322 5327 5327 5322 5324 5330 16 5322 10 16 17 5330 17 16 10 17 18 5329 18 17 5329 17 5330 5311 5329 5330 5311 5330 5328 5313 5329 5311 5313 18 5329 5328 1398 5311 1396 1397 1398 5328 1396 1398 1394 1395 1396 1396 1395 1397 1394 1396 5328 1397 1395 3426 1394 1380 1395 3426 1395 1380 1380 3427 3426 3426 3427 3428 3426 3428 3423 3430 3426 3423 3441 3428 3427 3427 1380 3441 3423 3428 3429 3428 3441 3429 3423 3424 1555 3423 3429 3424 3430 3423 1554 1554 3423 1555 1570 3430 1554 1553 1554 1555 1553 1568 1554 1554 1568 1569 1554 1569 1570 1570 1569 1571 1570 1571 1563 3325 1571 1569 3325 1569 3326 3326 1569 1568 3290 3291 1568 1568 1553 3290 3326 1568 3291 3305 3292 3290 3290 3292 3294 3290 3294 3291 3290 1553 1581 3290 1581 3305 3294 3326 3291 3292 3293 3294 3293 3326 3294 3293 3292 3297 3297 3321 3293 3293 3321 3326 3297 3292 3296 3297 3296 3298 3298 3322 3297 3297 3322 3321 3321 3322 3319 3319 3326 3321 3319 3322 3323 3322 3298 5197 5197 5210 3322 3322 5210 3323 5197 3298 3296 5198 5197 5199 5197 3296 5199 5197 5198 5211 5211 5212 5197 5197 5212 5210 5198 5199 5201 5201 177 5198 5211 5198 177 5199 3296 3295 5199 3295 5200 5201 5199 5200 5201 5200 5202 5202 178 5201 5201 178 177 3295 3299 5200 5200 3299 3301 5200 3301 5196 5202 5200 5196 3292 3295 3296 3295 3292 3299 3299 3292 3300 3299 3300 3301 3300 3303 3301 5196 3301 3303 3302 3289 3300 3300 3289 3303 3304 3302 3300 3304 3300 3305 3305 3300 3292 5196 3303 3289 3271 3275 3289 3302 3271 3289 5186 5196 3289 5186 3289 3275 3271 3272 3273 3275 3271 3276 3276 3271 3273 3272 3271 3302 5185 5186 3275 3276 5185 3275 5187 5188 5186 5186 5185 5187 5188 5196 5186 3277 5189 5185 3277 5185 3276 5187 5185 5189 3276 3273 3277 3277 3273 3278 3277 3278 3279 3279 5189 3277 3278 3280 3279 3279 3280 5189 5189 3280 3264 5189 3264 5184 5187 5189 5190 5190 5189 5184 3278 3264 3280 3263 3264 3265 3265 3264 3278 5184 3264 3263 3250 5183 5184 5184 3263 3250 5190 5184 5191 5191 5184 5183 129 5187 5190 129 5190 130 130 5190 5191 5191 5183 5192 130 5191 141 141 5191 5192 5192 5183 5193 5193 5183 3250 141 5192 138 5194 138 5192 5194 5192 5195 5195 5192 5193 140 130 141 140 141 138 129 130 131 131 130 140 129 131 96 96 131 179 140 5091 131 131 5091 5092 131 5092 179 96 179 180 179 5092 5093 179 5093 180 5091 5090 5092 5092 5090 5086 5092 5086 5093 5088 5089 5091 5091 5089 5090 140 5088 5091 5089 4033 5090 4033 4032 5090 5090 4032 4037 5090 4037 5086 5087 4035 5089 5089 4035 4033 5088 5087 5089 4032 4033 4034 4034 4033 4035 4038 4037 4032 4032 4034 4038 4036 4037 4038 5086 4037 4036 3525 4036 4038 3525 4038 3526 3526 4038 4040 4038 4034 4039 4038 4039 4040 3529 4036 3525 5086 4036 3529 3525 3526 3527 3529 3525 3530 3530 3525 3527 3527 3526 3528 3526 4040 3528 3527 3528 3522 3528 4040 4041 3528 4041 3522 3522 3523 3524 3522 3524 3527 4041 3523 3522 3524 3523 3521 4041 3521 3523 4040 4042 4041 4041 4042 4043 4041 4043 4030 4030 3521 4041 3521 1796 1798 3521 1798 3524 1796 3521 4030 4043 1796 4030 4042 3545 4043 3545 3543 4043 4043 3543 1796 3544 3543 3545 3544 3545 3546 3546 3545 3547 4042 3547 3545 3542 1796 3543 3542 3543 3544 4019 3542 3544 4019 3544 3546 3546 3547 3548 4019 3546 3548 3548 3547 3549 3547 3554 3549 4039 3554 3547 4039 3547 4042 3549 4024 3548 3548 4024 4025 3548 4025 4019 3549 3554 3550 3549 3550 3555 3549 3555 4024 3550 3554 4039 4034 3550 4039 4040 4039 4042 1723 3550 3551 3551 3550 3552 3555 3550 1723 4034 3552 3550 3555 1723 1721 4024 3555 1721 1722 1721 1723 1722 1723 5064 5064 1723 5065 3551 5065 1723 3551 3552 3553 5080 5065 3551 3553 5080 3551 4031 3553 3552 4031 3552 4034 5082 5080 3553 5082 3553 4031 5079 5067 5080 5080 5067 5065 5082 5079 5080 5064 5065 5066 5066 5065 5067 5066 5067 149 149 5067 150 5079 150 5067 151 150 5079 5081 151 5079 5081 5079 5082 5081 5082 5087 5082 4031 5087 152 151 5081 152 5081 5088 5081 5087 5088 150 151 144 144 151 152 144 149 150 144 148 149 148 5066 149 147 146 148 147 148 144 146 5058 148 5058 5066 148 145 146 147 5220 5217 147 147 5217 145 144 5220 147 145 44 146 44 5057 146 146 5057 5058 45 44 145 5217 5218 145 145 5218 45 5215 5216 5217 5217 5216 5218 5220 5215 5217 5216 5226 5218 5218 5226 43 5218 43 45 43 44 45 38 42 43 43 42 44 5226 5228 43 43 5228 38 5216 5225 5226 5225 5227 5226 5226 5227 5228 5215 1436 5216 1436 5225 5216 1436 1446 5225 5225 1446 5227 5227 1446 1444 5228 5227 5237 5227 1444 5237 5237 5236 5228 5228 5236 38 5237 1444 1442 5237 1442 5238 5238 5239 5237 5237 5239 5236 1443 1442 1444 1443 1444 1445 1445 1444 1446 1441 1442 1443 1442 1441 1447 5238 1442 1447 1447 5251 5238 5238 5251 5252 5238 5252 5239 1447 1441 1448 1448 1454 1447 1447 1454 5251 1448 1441 3197 3197 1441 3211 1441 1443 3211 1453 1454 1448 3197 1453 1448 1453 1452 1454 5251 1454 5261 1452 5261 1454 5251 5261 5252 5239 5252 5253 5252 5261 5253 5253 5261 5262 5264 5262 5261 5264 5261 1452 1451 1450 1452 1451 1452 1453 1450 5264 1452 5263 5262 5264 5266 5263 5264 5266 5264 1450 1449 1450 1451 1449 1460 1450 1450 1460 5273 1450 5273 5266 5265 5263 5266 5266 5273 5274 5266 5274 5275 5277 5274 5273 5277 5273 1458 1458 5273 1460 1459 1458 1460 1459 1460 1449 1457 1456 1458 1457 1458 1459 1456 5277 1458 5276 5274 5277 5279 5276 5277 5279 5277 1456 1455 1456 1457 1455 1466 1456 1456 1466 5282 1456 5282 5279 5278 5276 5279 5279 5282 5283 5279 5283 5278 5285 5283 5282 5285 5282 1464 1464 5282 1466 1465 1464 1466 1465 1466 1455 1463 1462 1464 1463 1464 1465 1462 5285 1464 5284 5283 5285 5287 5284 5285 5287 5285 1462 5278 5283 405 5284 405 5283 406 405 5284 5286 406 5284 5286 5284 5287 5287 1462 1474 5286 5287 5296 5287 1474 5296 1461 1462 1463 1461 1474 1462 1473 1472 1474 1473 1474 1461 5296 1474 1472 5296 1472 5295 5286 5296 5297 5297 5296 5295 1471 1470 1472 1471 1472 1473 5295 1472 1470 1471 1473 3225 3225 1473 1461 1463 3218 1461 1461 3218 3225 1465 3217 1463 1463 3217 3218 3217 3215 3218 3225 3218 3215 3216 3214 3217 3217 3214 3215 1465 3216 3217 1455 3216 1465 3209 3213 3216 3216 3213 3214 1455 3209 3216 3213 1608 3214 3214 1608 1606 3214 1606 3215 3225 3215 3226 3226 3215 1606 1605 1604 1606 1605 1606 1607 1607 1606 1608 3226 1606 1604 3228 3225 3226 3228 3226 1602 1602 3226 1604 3227 1471 3225 3227 3225 3228 3230 3227 3228 3230 3228 1600 1600 3228 1602 1601 1600 1602 1601 1602 1603 1603 1602 1604 1603 1604 1605 1601 1603 3432 3432 1603 3433 1605 3433 1603 3432 3433 3431 3431 3433 3434 3436 3434 3433 3436 3433 1605 1605 1607 3443 1605 3443 3436 3435 3434 3436 3436 3443 3444 3436 3444 3435 3431 3434 1534 1534 3434 1536 3435 1536 3434 1538 1536 3435 3435 3444 1540 3435 1540 1538 3445 1540 3444 3445 3444 3446 3446 3444 3443 1539 1538 1540 1539 1540 1541 1541 1540 1542 1542 1540 3445 1537 1536 1538 1537 1538 1539 5458 1537 1539 5458 1539 5459 5459 1539 1541 1541 1542 1543 5459 1541 5460 5460 1541 1543 1543 1542 1544 1544 1542 3447 3447 1542 3445 1543 1544 1545 5437 1543 1545 5460 1543 5461 5461 1543 5437 5463 5459 5460 5463 5460 5464 5464 5460 5461 5461 5437 5438 5464 5461 5465 5465 5461 5438 5438 5437 5439 5437 1545 5439 5438 5439 5442 5442 389 5438 5465 5438 389 389 441 5465 5465 441 440 5465 440 5464 5464 440 417 5464 417 5463 417 440 376 376 440 441 376 441 389 376 389 390 5442 390 389 390 401 376 5443 401 390 5443 390 5442 376 401 402 5444 402 401 5444 401 5443 5442 5440 5443 5443 5440 5441 5443 5441 5444 5444 5441 5430 5444 5430 377 377 402 5444 376 402 377 375 376 377 5430 5428 377 377 5428 375 5429 5427 5430 5430 5427 5428 5441 5429 5430 5440 1349 5441 5441 1349 5429 1349 1351 5429 5429 1351 5427 1351 1353 5427 5427 1353 5426 5427 5426 5428 5428 5426 5425 5428 5425 375 5416 5425 5426 5416 5426 5417 5417 5426 5418 5418 5426 1353 5414 370 5425 5414 5425 5415 5415 5425 5416 375 5425 370 5408 371 5414 5408 5414 5407 5407 5414 5415 371 370 5414 369 370 371 370 369 375 375 369 376 369 371 372 376 369 5391 5391 369 5392 369 372 5392 372 371 373 373 371 5408 372 373 374 5408 374 373 374 380 372 5408 5406 374 380 374 5401 5401 374 5406 372 380 381 381 380 5401 381 5401 5390 5390 5401 5409 5401 5406 5409 372 381 364 364 381 382 5390 382 381 5388 5389 5390 5390 5389 382 5390 5409 5388 5388 5409 1361 5409 5406 5403 5409 5403 1361 1359 1360 1361 1361 5403 1359 5402 1359 5403 5402 5403 5404 5404 5403 5405 5405 5403 5406 1357 1358 1359 1359 1358 1360 1357 1359 5402 3479 1360 1358 1357 1356 1358 1358 3480 3479 1358 1356 3480 1355 1356 1357 5402 5418 1357 1357 5418 1355 1355 1354 1356 1356 1354 3468 3480 1356 3468 3479 3480 3481 3480 3468 3481 3479 3481 3476 3476 3481 3482 3481 3468 3470 3481 3470 3482 3468 1354 3469 3468 3469 3470 3470 3469 3471 3482 3470 3471 3476 3482 3477 3482 3471 3477 3476 3477 1649 1647 3476 1649 1649 3477 3478 3477 3471 3473 3477 3473 3478 3471 3469 3472 3471 3472 3473 3473 3472 3474 3478 3473 3474 1649 3478 1650 3478 3474 1650 1647 1649 1648 1648 1649 1650 1646 1647 1648 1648 1650 1639 1648 1639 3191 1646 1648 3191 1639 1650 1651 1650 3474 1651 3474 3472 1638 3474 1638 1651 1639 1651 1638 1638 1637 1639 3191 1639 3192 1637 3192 1639 3191 3192 3193 1646 3191 3210 3191 3193 3210 3193 3192 3194 3194 3192 3195 3199 3195 3192 3199 3192 1637 3210 3193 3194 3210 3194 3211 3211 3223 3210 3210 3223 3224 3210 3224 1646 3194 3195 3196 3196 3211 3194 3197 3211 3196 3211 1443 3223 1443 1445 3223 3223 1445 3221 3223 3221 3224 1445 1446 1435 3222 3221 1445 3222 1445 1435 3220 3219 3221 3220 3221 3222 3224 3221 3219 1435 1437 3222 3222 1437 3235 3222 3235 3220 1435 1436 1437 1435 1446 1436 1437 1436 1438 1437 1438 1439 1437 1439 3235 3235 1439 3231 3235 3231 3236 3220 3235 3236 1439 1438 1440 1439 1440 1433 1439 1433 3231 1438 1436 5215 1440 1438 5219 5219 1438 5215 1433 1440 1434 1434 1440 5209 5209 1440 5219 5219 5215 5220 5209 5219 5208 5208 5219 5220 5208 5206 5209 5209 5206 5207 5209 5207 1434 1432 1433 1434 1434 5207 1432 5206 5204 5207 5207 5204 5205 5207 5205 1432 143 142 5206 5206 142 5204 5208 143 5206 144 143 5208 5208 5220 144 140 142 143 140 143 144 139 142 140 142 139 5204 5204 139 5194 5204 5194 5205 138 139 140 139 138 5194 144 152 140 152 5088 140 5205 5194 5195 5195 5193 1428 5205 5195 1430 1430 5195 1428 5193 3250 3249 1428 5193 3249 3249 3250 3251 3251 3250 3252 3250 3263 3252 3249 3251 1428 3251 3252 3245 3245 3247 3251 3251 3247 3253 3251 3253 3255 1428 3251 3255 3252 3263 3265 3252 3265 3245 3245 3246 3247 3245 3265 3246 3278 3282 3265 3265 3282 3248 3265 3248 3246 3247 3246 3248 3248 1559 1557 3248 1557 3247 3282 1559 3248 3281 1561 3282 3282 1561 1559 3278 3281 3282 3273 3281 3278 3269 1573 3281 3281 1573 1561 3273 3269 3281 1560 1559 1561 1560 1561 1562 1561 1573 1562 1562 1573 1574 3269 1574 1573 1562 1574 1575 3425 3442 1562 3425 1562 1575 1560 1562 3438 3438 1562 3442 1558 1559 1560 1558 1560 3438 1556 1557 1558 1558 1557 1559 1556 1558 1582 1582 1558 1583 1558 3454 1583 3247 1557 1556 3247 1556 3253 3253 1556 1582 1582 1583 1584 3253 1582 3254 3254 1582 1584 1584 1583 1585 3454 3449 1583 1583 3449 1585 1584 1585 1586 1586 3234 1584 3254 1584 3234 3255 3253 3254 3255 3254 3256 3256 3254 3234 3233 3232 3234 3233 3234 1586 3256 3234 3232 1586 1585 1587 1586 1587 1588 1588 3233 1586 1587 1585 3449 1588 1587 1640 3236 3233 1588 1640 3236 1588 3231 3232 3233 3236 3231 3233 3231 1433 3232 1431 3256 3232 1431 3232 1433 1432 1431 1433 1430 1429 1431 1430 1431 1432 1429 3256 1431 1432 5205 1430 1428 1429 1430 1428 3255 1429 1429 3255 3256 3220 3236 1640 1640 3219 3220 1640 1642 3219 3224 3219 1644 1644 3219 1642 1646 3224 1644 3429 3441 3442 3429 3442 3424 3424 3442 3425 3441 1380 1383 3441 1383 1385 1380 1381 1382 1380 1382 1383 1381 1380 1394 1383 1382 1384 1383 1384 1385 1385 1384 1386 1386 1384 5346 5346 1384 1382 5346 1382 1381 5321 1381 1394 1381 5321 5346 5327 5321 1394 5327 1394 5328 5326 5321 5327 5346 5321 5347 5346 5347 5324 5346 5349 1386 5327 5324 5326 1555 3424 3425 1555 3425 1575 1575 1580 1555 1555 1580 1581 1555 1581 1553 1574 1579 1575 1575 1579 1580 3266 1579 1574 3266 1574 3269 1580 1579 3266 3269 3270 3266 3304 1580 3266 3304 3266 3270 3267 3268 3269 3269 3268 3270 3267 3269 3273 3270 3268 3304 3304 3268 3267 3267 3302 3304 3305 1580 3304 3273 3274 3267 3267 3274 3302 3273 3272 3274 3302 3274 3272 3305 1581 1580 3196 3195 3197 3197 3195 1453 3198 1453 3195 3198 3195 3199 1451 1453 3198 3200 1451 3198 3200 3198 3201 3201 3198 3199 3201 3199 1635 1635 3199 1637 3202 3201 1635 3203 3200 3201 3201 3202 3203 1449 1451 3200 3200 3203 1449 3203 3202 3204 3203 3204 3207 1449 3203 3207 1635 1633 3202 3202 1633 1632 3202 1632 3204 3204 1632 1630 3204 1630 3205 3207 3204 3205 3207 3205 3208 1449 3207 1459 1459 3207 3208 3205 1630 1628 3205 1628 3206 3208 3205 3206 1629 1628 1630 1629 1630 1631 1630 1632 1631 1631 1632 1633 1631 1633 1634 3458 3455 1631 1631 3455 1629 1634 3458 1631 1627 1628 1629 1627 1629 3455 1627 3455 3448 3448 3455 3456 3458 3456 3455 3457 3456 3458 3460 3457 3458 3460 3458 1634 3448 3456 3447 3447 3456 1546 3457 1546 3456 3447 3445 3448 3448 3445 3446 3448 3446 1627 3447 1546 1544 1545 1544 1546 1545 1546 1547 1547 1546 1548 1548 1546 3457 5439 1545 1547 1547 1548 1349 5439 1547 5440 5440 1547 1349 1349 1548 1350 1350 1548 3459 3459 1548 3457 1349 1350 1351 1351 1350 1352 3459 1352 1350 3459 3457 3460 3460 3475 3459 3459 3475 1352 1351 1352 1353 1353 1352 1354 3475 3469 1352 1352 3469 1354 3460 3467 3475 3467 3472 3475 3475 3472 3469 1634 3467 3460 1634 1636 3467 1636 1638 3467 3467 1638 3472 1634 1633 1635 1634 1635 1636 1636 1635 1637 1636 1637 1638 1353 1354 1355 5418 1353 1355 5402 5417 5418 5404 5417 5402 5404 5416 5417 5405 5416 5404 5405 5415 5416 5405 5406 5407 5407 5415 5405 5407 5406 5408 5442 5439 5440 1609 1626 1627 1627 1626 1628 1627 3446 1609 1609 1625 1626 1628 1626 3212 3212 1626 1625 3212 3206 1628 3212 1625 3213 3206 3212 3209 3209 3212 3213 1608 1625 1609 3213 1625 1608 1607 1608 1609 1609 3443 1607 3446 3443 1609 3208 3206 3209 1457 3208 3209 1457 3209 1455 1459 3208 1457 364 382 2 364 2 365 5397 5398 364 364 5398 372 365 5397 364 365 2 1 439 365 1 1 5291 439 438 365 439 5291 5290 439 439 5290 438 5288 5289 5291 5291 5289 5290 5289 5280 5290 5290 5280 5281 5290 5281 438 436 437 438 438 437 365 438 5281 436 5280 5272 5281 5281 5272 434 5281 434 436 5280 5271 5272 5271 5269 5272 5272 5269 5270 5272 5270 434 368 433 434 434 433 435 434 435 436 434 5270 368 368 432 433 5371 435 433 5371 433 5373 5373 433 432 436 435 437 5371 437 435 5372 5371 5373 5372 5386 5371 5371 5386 437 5386 5400 437 437 5400 365 5372 5385 5386 5385 5399 5386 5386 5399 5400 1500 5385 5372 1500 1502 5385 1502 3828 5385 5385 3828 5399 3828 3830 5399 5399 3830 5395 5399 5395 5400 1502 1503 3828 3828 1503 3829 3828 3829 3830 1500 1501 1502 1502 1501 1503 1503 1501 3327 3327 3841 1503 3327 1501 3328 3823 3328 1501 3327 3328 3329 3329 3840 3327 3327 3840 3841 3840 3837 3841 3329 3839 3840 3839 3836 3840 3840 3836 3837 3836 1510 3837 3354 1510 3836 3843 3351 3836 3836 3351 3353 3836 3353 3354 3839 3843 3836 1508 1509 1510 3354 1508 1510 3831 1510 1509 3353 3352 3354 3354 3352 1508 3351 3352 3353 3349 3348 3351 3351 3348 3352 3843 3349 3351 3355 1508 3352 3355 3352 3346 3346 3352 3348 3348 3349 3350 3346 3348 3347 3347 3348 3350 3842 3349 3843 3842 3350 3349 3842 3347 3350 3345 3346 3347 3844 3345 3347 3844 3347 3842 3845 3844 3842 3845 3842 3838 3838 3842 3843 3838 3843 3839 3337 3838 3335 3335 3838 3839 3337 3338 3838 3838 3338 3331 3838 3331 3845 1589 3844 3845 3845 3331 1589 1589 3345 3844 1589 1590 1591 1590 1589 3330 3330 1589 3331 1589 1591 3345 3330 3331 3332 3338 3332 3331 3337 3332 3338 3337 3336 3332 3821 3330 3332 3821 3332 3336 1590 3330 3820 3820 3330 3821 3821 3336 3334 3334 3825 3821 3825 3826 3821 3821 3826 3827 3821 3827 3820 3335 3334 3336 3335 3336 3337 3329 3334 3335 3335 3839 3329 3328 3333 3329 3329 3333 3334 3333 3328 3823 3333 3823 3334 3334 3823 3825 3823 3824 3825 3824 3308 3314 3824 3314 3826 3825 3824 3826 3314 3308 3315 3314 3315 3316 3826 3314 3316 3826 3316 3827 3316 3315 3313 3316 3313 3317 3316 3317 3827 3307 3313 3315 3307 3315 1494 3313 1592 1590 3317 3313 1590 3306 1592 3313 3306 3313 3307 3827 3317 1590 3827 1590 3820 1591 1590 1592 1592 1624 1591 3345 1591 3346 1624 3346 1591 1592 1623 1624 3357 3346 1624 3369 3357 1624 1624 1623 3369 3357 3355 3346 3356 3355 3357 3370 3356 3357 3357 3369 3370 3369 1623 1621 3369 1621 3371 3370 3369 3371 1622 1621 1623 1622 1623 1592 1620 1619 1621 1620 1621 1622 3371 1621 1619 3371 1619 3372 3370 3371 3374 3374 3371 3372 1618 1617 1619 1618 1619 1620 3372 1619 1617 3372 1617 3373 3374 3372 3375 3375 3372 3373 1504 3370 3374 1504 3374 1512 1512 3374 3375 3375 3373 3376 1512 3375 1514 1514 3375 3376 1511 1504 1512 1511 1512 1513 1513 1512 1514 1513 1514 1515 1515 1514 1516 1514 3376 1516 3390 3376 3373 3376 3390 1516 1515 1516 1517 1517 1516 1518 1516 3390 3394 1516 3394 1518 5422 1513 1515 1517 5422 1515 1517 1518 1519 5436 5422 1517 1519 5436 1517 1519 1518 1520 1518 3394 3395 1518 3395 1520 3390 3391 3394 3394 3391 3392 3394 3392 3395 3395 3392 3393 3395 3393 3396 1520 3395 3396 1519 1520 1521 1521 1520 1522 1520 3396 1522 3418 1522 3396 3418 3396 3393 3392 1610 3393 3421 3418 3393 3421 3393 1610 3391 1611 3392 3392 1611 1610 1578 1610 1576 1576 1610 1611 1610 1578 3421 3420 3418 3421 3421 1578 1593 3421 1593 3420 3417 1522 3418 3420 3417 3418 3419 3417 3420 3420 1593 1595 3420 1595 3419 1578 1577 1593 1593 1577 1594 1593 1594 1595 1576 1577 1578 3240 1594 1577 3240 1577 3241 1577 1576 3257 1577 3257 3241 1595 1594 1596 3239 1596 1594 3239 1594 3240 1595 1596 1597 3419 1595 1597 1597 1596 1598 3237 1598 1596 3237 1596 3239 3238 3237 3239 3238 3239 3242 3242 3239 3240 3237 3230 1600 1600 1598 3237 3230 3237 3238 1597 1598 1599 1599 1598 1600 1599 1600 1601 1597 1599 3415 1601 3415 1599 3432 3414 1601 1601 3414 3415 3413 1597 3415 3413 3415 3414 3413 3414 3410 3432 3410 3414 3431 3411 3432 3411 3410 3432 3410 3411 3412 3410 3412 3413 3413 3412 3416 3413 3416 3419 3419 1597 3413 3412 3411 3409 3409 1528 3412 3412 1528 1526 3412 1526 3416 3409 3411 3431 3409 1530 1528 3431 1530 3409 1527 1526 1528 1527 1528 1529 1529 1528 1530 1525 1524 1526 1525 1526 1527 3416 1526 1524 1527 1529 5449 5449 5451 1527 1527 5451 5454 1527 5454 1525 1529 1530 1531 1529 1531 5449 5449 5450 5451 5449 1531 5468 5449 5468 5450 1531 1530 1532 1531 1532 1533 1533 5468 1531 5450 5468 5446 5446 5468 5469 5466 5469 5468 5466 5468 1533 5451 5450 5446 5446 5447 5448 5446 5448 5451 5446 5469 5447 5447 5469 5445 5445 5469 415 5467 415 5469 5467 5469 5466 5448 5447 5445 5445 413 5448 5448 413 446 5448 446 5452 5451 5448 5452 5445 414 413 5445 415 414 376 413 414 376 414 415 415 442 376 442 415 5467 376 442 443 443 442 5467 376 443 416 416 443 5456 443 5467 5456 376 416 417 5463 417 416 5463 416 5462 5462 416 5456 5462 5456 5457 5456 5467 5466 5456 5466 5457 5457 5458 5462 5462 5458 5459 5462 5459 5463 5457 1537 5458 5457 5466 1535 5457 1535 1537 1533 1535 5466 1533 1534 1535 1535 1534 1536 1535 1536 1537 1533 1532 1534 1534 1532 3431 3431 1532 1530 412 413 376 412 376 5410 5410 376 5391 412 444 413 444 412 5410 413 444 445 413 445 446 444 5410 5411 445 444 5423 5423 444 5411 5411 5410 5412 5410 5391 5412 5391 5392 5393 5412 5391 5393 5411 5412 5413 5413 5412 1507 5412 5393 1507 5423 5411 5424 5424 5411 5413 5413 1507 1505 5424 5413 1511 1511 5413 1505 1506 1505 1507 1506 1507 1508 1508 1507 1509 1507 5393 1509 1504 1505 1506 1505 1504 1511 1513 5424 1511 5421 5423 5424 5421 5424 1513 5422 5421 1513 5420 5419 5421 5420 5421 5422 5419 5423 5421 5419 445 5423 449 447 5419 449 5419 5420 447 445 5419 5435 449 5420 5435 5420 5436 5436 5420 5422 448 447 449 449 450 448 450 449 5435 446 445 447 446 447 448 5452 446 448 448 450 451 448 451 452 5452 448 5453 5453 448 452 451 450 5431 5431 450 5435 452 451 5431 452 5431 5432 5453 452 5432 5454 5452 5453 5454 5453 5455 5455 5453 5432 5451 5452 5454 1525 5454 5455 5455 5432 5434 1525 5455 1523 1523 5455 5434 5432 5431 5433 5432 5433 5434 5431 5435 5433 5434 5433 1519 5433 5435 5436 5433 5436 1519 5434 1519 1521 1523 5434 1521 1521 1522 1523 1523 1522 1524 1523 1524 1525 3417 1524 1522 3416 1524 3417 3419 3416 3417 1504 1506 3356 3356 3370 1504 1506 1508 3355 3356 1506 3355 3835 3831 1509 5393 5394 1509 5394 3835 1509 3834 3831 3835 5394 3834 3835 3834 3829 3831 3833 3829 3834 3833 3834 5394 5393 5392 5394 5392 5398 5394 5394 5398 5396 5394 5396 3833 3832 3830 3833 3833 3830 3829 3833 5396 5395 3833 5395 3832 5395 5396 5397 5397 5396 5398 5392 372 5398 5400 5395 5397 5400 5397 365 3832 5395 3830 3238 3229 3230 3229 3238 1467 1467 3238 3242 1467 1469 3229 3229 1469 3227 3229 3227 3230 1467 1468 1469 1479 1480 1467 1467 1480 1468 1467 3242 1479 3242 3240 3243 1479 3242 3243 1477 1478 1479 1479 1478 1480 1479 3243 1477 1468 1480 5304 1478 5304 1480 1477 1476 1478 5307 5304 1478 1476 5307 1478 1475 1476 1477 1477 3243 3244 1477 3244 1475 3243 3240 3241 3243 3241 3244 3241 3258 3244 3244 3258 1485 3244 1485 1475 1485 1486 1475 1475 1486 1476 5309 5307 1476 5309 1476 1486 1485 1484 1486 5309 1486 5315 5315 1486 1484 1483 1484 1485 1483 1485 3259 3259 1485 3258 1483 1482 1484 5315 1484 5316 5316 1484 1482 5314 5309 5315 5314 5315 5318 5318 5315 5316 5316 1482 5317 5318 5316 5319 5319 5316 5317 1481 1482 1483 1481 1492 1482 5317 1482 1492 5319 5317 5320 5331 5320 5317 5317 1492 5332 5331 5317 5332 383 5318 5319 383 5319 384 384 5319 5320 384 5320 403 404 403 5320 5320 5331 404 5331 5332 5335 404 5331 5335 5332 1492 1490 5332 1490 5333 5335 5332 5333 5335 5333 5336 404 5335 395 395 5335 5336 327 403 404 327 404 395 384 403 327 327 383 384 325 326 327 328 277 327 327 277 332 327 332 325 361 327 362 362 327 326 391 392 327 327 392 393 327 393 394 327 395 396 394 418 327 327 418 419 327 419 383 396 420 327 327 420 421 361 422 327 327 422 423 327 423 391 5540 5538 327 327 5538 328 327 5545 5540 5539 5537 5540 5540 5537 5538 5540 5545 5546 5540 5546 5539 5537 5518 5538 5538 5518 5516 5538 5516 328 328 329 277 328 5516 329 5515 329 5516 5515 5516 5517 5517 5516 5518 5517 5518 3000 3000 5518 2348 5537 2348 5518 5509 5515 5517 5509 5517 2999 2999 5517 3000 330 329 5515 5507 330 5515 5507 5515 5509 277 329 330 277 330 331 331 330 5507 5506 331 5507 5506 5507 5508 5508 5507 5509 5508 5509 3731 3731 5509 2999 2998 2999 3000 2999 2998 3731 3731 2998 3730 3731 3730 3729 3729 5508 3731 5501 5506 5508 5501 5508 3729 3728 3727 3729 3729 3730 3728 3727 5501 3729 5500 5499 5501 5500 5501 3727 5499 5506 5501 3726 3727 3728 3726 5500 3727 3728 3730 3726 3726 3730 3732 3726 3732 3733 3733 5493 3726 5493 5500 3726 5498 5499 5500 5493 5498 5500 5498 334 5499 334 333 5499 5499 333 5506 335 334 5498 5492 335 5498 5492 5498 5493 5490 5492 5493 5490 5493 3733 5491 336 5492 5491 5492 5490 336 335 5492 277 334 335 335 336 277 277 333 334 331 333 277 333 331 5506 276 277 278 277 336 337 277 337 278 276 5003 277 277 5003 4978 277 4978 332 337 336 5491 278 337 5486 5486 337 5491 307 278 5486 307 5486 5471 5471 5486 5487 5486 5491 5487 283 278 307 283 307 281 281 307 5470 5470 307 5471 5470 5471 5472 5472 5471 5473 5471 5487 5473 5470 5472 5476 281 5470 5477 5470 5476 5477 281 282 283 281 5477 282 5477 5476 5478 5477 5478 5481 282 5477 5481 5472 3737 5476 5476 3737 3740 5476 3740 5478 5478 3740 3742 5478 3742 5479 5481 5478 5479 5481 5479 5482 282 5481 312 312 5481 5482 282 312 283 283 312 313 312 5482 313 5482 5479 5480 5482 5480 5483 313 5482 5483 283 313 314 313 5483 314 5483 5480 5475 5483 5475 5484 314 5483 5484 5479 3745 5480 5480 3745 3747 5480 3747 5475 3750 5474 5475 5475 3747 3748 5475 3748 3750 5484 5475 5474 5484 5474 5485 314 5484 320 320 5484 5485 314 320 283 283 320 321 320 5485 321 5488 321 5485 5488 5485 5489 5489 5485 5474 5489 5474 3031 3031 5474 3750 5495 5488 5489 5495 5489 3030 3030 5489 3031 322 321 5488 5494 322 5488 5494 5488 5495 283 321 317 317 321 322 317 322 315 315 322 5494 5496 315 5494 5496 5494 5497 5497 5494 5495 5497 5495 2354 2354 5495 3030 3030 3031 3032 3032 2354 3030 2352 2353 2354 3032 2352 2354 2354 2353 5497 5497 2353 5502 5497 5502 5496 2352 2351 2353 2353 2351 5502 5502 2351 5503 5502 5503 5504 5496 5502 5504 2350 2351 2352 5514 5503 2351 5514 2351 2350 5504 5503 5505 5512 5505 5503 5512 5503 5513 5513 5503 5514 5504 5505 318 5496 5504 316 316 5504 318 317 316 318 317 318 319 318 5505 319 315 316 317 316 315 5496 317 453 454 317 455 456 454 462 317 317 462 463 317 463 455 456 466 317 317 466 467 317 467 468 319 474 317 317 474 475 317 475 453 283 317 708 708 317 468 474 5569 475 475 5569 5570 475 5570 453 5565 5566 5569 5569 5566 5567 5569 5567 5570 474 5565 5569 5570 5567 5568 5570 5568 5571 453 5570 5571 453 5571 454 5576 5571 5568 462 454 5571 5571 5576 462 5567 2370 5568 5568 2370 5577 5568 5577 5576 5566 2372 5567 5567 2372 2370 2369 2370 2371 2371 2370 2372 2369 2382 2370 5577 2370 2382 5577 2382 5578 5576 5577 5578 2381 2380 2382 2381 2382 2369 5578 2382 2380 2371 3109 2369 3109 2381 2369 2371 2372 2373 2373 3108 2371 2371 3108 3109 3108 3106 3109 3106 3121 3109 3109 3121 2381 3107 3105 3108 3108 3105 3106 2373 3107 3108 2373 2372 2374 2373 2374 2375 2375 3107 2373 3103 3104 3107 3107 3104 3105 2375 3103 3107 3104 2423 3105 3105 2423 2424 3105 2424 3106 3102 2413 3104 3104 2413 2423 3103 3102 3104 2413 2422 2423 2423 2422 2402 2423 2402 2424 2424 2402 2401 2424 2401 3120 2424 3120 3106 2399 2401 2402 2402 2422 3126 2399 2402 3128 3128 2402 3126 2399 2400 2401 2401 2400 3120 3106 3120 3121 3120 2400 3122 3120 3122 3121 2400 2399 2416 2400 2416 3122 3122 2416 3123 3122 3123 3124 3121 3122 3124 3121 3124 2381 3124 3123 3125 3124 3125 2379 2381 3124 2379 2416 3132 3123 3123 3132 3133 3123 3133 3125 2379 3125 2377 3125 3133 2387 3125 2387 2377 2377 2378 2379 2379 2378 2380 2379 2380 2381 2387 2388 2377 2377 2388 2378 2385 2386 2387 2387 2386 2388 3133 3136 2387 2387 3136 2385 5587 2378 2388 5587 2388 5588 5588 2388 2386 2385 2384 2386 5588 2386 5589 5589 2386 2384 5586 5587 5588 5586 5588 5591 5591 5588 5589 5580 2378 5587 5580 5587 5586 5586 5583 5580 5583 5586 466 466 5586 5591 5591 5589 5592 466 5591 467 467 5591 5592 466 456 5583 5582 5580 5583 455 5582 5583 455 5583 456 5581 5579 5582 5582 5579 5580 463 5581 5582 463 5582 455 5576 5578 5581 5581 5578 5579 462 5576 5581 462 5581 463 5578 2380 5579 5579 2380 2378 5579 2378 5580 5592 5589 5590 5592 5590 5593 467 5592 469 469 5592 5593 5589 2384 5590 5614 5593 5590 5616 5614 5590 5616 5590 2384 469 5593 470 480 470 5593 5614 480 5593 5613 480 5614 5615 5613 5614 5615 5614 5616 2384 2389 5616 5616 2389 2391 5616 2391 5615 5608 5613 5615 5615 2391 2393 5615 2393 5608 5611 478 5613 5613 478 480 5608 5611 5613 5606 5607 5608 5607 5611 5608 5608 2393 2293 5608 2293 5606 2391 2392 2393 2393 2392 2394 2393 2394 2293 2291 2292 2293 2293 2394 2291 5606 2293 2292 5606 2292 5607 5609 5611 5607 5607 2292 5619 5607 5619 5609 2291 2290 2292 2292 2290 5619 2289 2290 2291 3144 2291 2394 3144 2289 2291 3144 2394 3147 3147 2394 2392 3147 3146 3144 3146 2289 3144 3145 3146 3147 3147 2392 3152 3145 3147 3148 3148 3147 3152 3145 3173 3146 3146 3173 2289 3148 3149 3145 3170 3145 3169 3169 3145 3149 3170 3174 3145 3145 3174 3173 3148 3151 3149 3169 3149 3151 3150 2440 3169 3150 3169 3151 3170 3169 3725 3725 3169 2440 3174 3170 3719 3719 3170 3725 3173 3174 3719 3171 3172 3173 3173 3172 2289 3171 3173 3720 3720 3173 3719 5634 5632 3171 3171 5632 3172 3720 5634 3171 5632 5624 3172 3172 5624 2289 2290 2289 5623 5623 2289 5624 5623 5624 5625 5625 5624 5626 5632 5626 5624 5631 5626 5632 5634 5631 5632 5625 5626 97 97 5626 98 5631 98 5626 5620 5623 5625 5620 5625 95 95 5625 97 5619 2290 5623 5619 5623 5620 5609 5619 5620 5609 5620 5610 95 476 5620 5620 476 5612 5620 5612 5610 94 95 96 96 95 97 95 94 476 476 94 477 477 94 96 477 487 476 96 671 477 477 671 673 477 673 487 476 487 488 673 666 487 487 666 668 487 668 488 671 672 673 673 672 674 673 674 666 96 665 671 671 665 672 674 672 822 822 672 665 666 674 675 821 675 674 821 674 822 666 667 668 666 675 667 820 667 675 820 675 821 841 820 821 841 821 842 842 821 822 819 669 820 669 667 820 840 819 820 840 820 841 668 667 669 668 669 670 669 676 670 819 676 669 818 676 819 839 818 819 839 819 840 616 839 840 616 840 625 625 840 841 838 818 839 615 838 839 615 839 616 615 616 617 625 626 616 616 626 627 616 627 617 623 624 625 625 624 626 625 841 623 623 622 624 624 622 865 624 865 626 621 622 623 865 622 621 865 621 866 626 865 868 866 1229 865 865 1229 1231 865 1231 868 621 623 628 621 628 866 866 628 630 866 630 858 1229 866 858 628 623 629 628 629 630 630 629 631 630 631 632 858 630 632 623 842 629 629 842 843 629 843 631 623 841 842 842 822 843 843 822 823 843 823 844 631 843 844 822 665 823 823 665 664 823 664 824 844 823 824 844 824 845 631 844 568 568 844 845 664 848 824 824 848 849 824 849 845 96 664 665 664 96 716 664 716 848 716 746 848 848 746 846 848 846 849 849 846 847 849 847 643 845 849 643 746 748 846 846 748 801 846 801 847 847 801 792 847 792 637 643 847 637 800 792 801 750 800 801 750 801 748 746 747 748 748 747 749 748 749 750 749 800 750 799 793 800 800 793 792 749 799 800 638 792 793 637 792 638 637 638 639 637 639 643 744 745 638 638 745 639 793 744 638 797 742 793 793 742 744 799 797 793 742 743 744 744 743 745 852 639 745 852 745 743 742 741 743 743 741 852 740 741 742 797 740 742 796 740 797 798 796 797 798 797 799 738 739 740 740 739 741 796 738 740 852 741 739 738 737 739 852 739 737 736 737 738 736 738 796 736 735 737 737 735 852 734 735 736 796 734 736 734 646 735 852 735 646 647 646 734 789 647 734 795 789 734 795 734 796 646 647 648 789 787 647 647 787 648 788 786 789 789 786 787 788 789 795 788 795 794 794 795 796 794 796 798 753 788 794 753 794 752 752 794 798 753 754 788 788 754 786 754 718 786 786 718 780 786 780 787 753 746 754 754 746 225 754 225 718 752 747 753 753 747 746 746 716 225 716 96 225 96 97 98 98 99 96 96 99 100 96 100 101 101 102 96 96 102 103 96 103 104 104 109 96 96 109 110 96 110 108 108 107 96 96 107 127 96 127 128 132 133 96 96 133 129 128 134 96 96 134 135 96 135 132 180 199 96 96 199 200 96 200 201 201 214 96 96 214 215 96 215 216 216 220 96 96 220 221 96 221 222 222 226 96 96 226 227 96 227 225 221 220 4438 222 221 4425 4425 221 4438 226 222 4424 4424 222 4425 227 226 4416 4416 226 4424 225 227 228 228 227 4416 228 4416 4410 4410 4416 4417 4416 4424 4417 4424 4425 4423 4417 4424 4423 4423 4425 4426 4425 4438 4426 4167 4168 4423 4423 4426 4167 4417 4423 2635 2635 4423 4168 4410 4417 4411 4411 4417 2635 2633 2634 2635 4168 2633 2635 4411 2635 2634 4167 4166 4168 4168 4166 2633 4166 4167 4159 4167 4426 4159 4159 4160 4161 4165 4166 4159 4165 4159 4161 4426 4440 4159 4159 4440 4160 4161 4160 4162 4440 4441 4160 4160 4441 4162 4162 4165 4161 4164 4165 4162 4441 4450 4162 4162 4450 4164 4440 4439 4441 4439 4448 4441 4441 4448 4450 4438 4439 4440 4426 4438 4440 4438 220 4439 220 183 4439 4439 183 4448 183 194 4448 4448 194 4449 4448 4449 4450 190 193 194 190 194 183 194 193 4449 4450 4449 4451 4449 193 4456 4449 4456 4451 192 193 190 193 192 4456 4456 192 4457 4456 4457 4458 4451 4456 4458 4450 4451 4164 4164 4451 2647 4451 4458 2647 4458 4457 4459 4458 4459 2645 2647 4458 2645 2645 2646 2647 4164 2647 2646 4164 2646 4165 2645 2644 2646 4165 2646 2644 2158 2644 2645 2645 4459 2158 4464 2158 4459 4464 4459 4465 4465 4459 4457 2158 2159 2160 2649 2644 2158 2649 2158 2160 2159 2158 4464 4466 2159 4464 4466 4464 4467 4467 4464 4465 2160 2159 2161 2161 2159 4466 4474 2161 4466 4474 4466 4475 4475 4466 4476 4476 4466 4467 2160 2161 2162 2162 2161 4474 4475 4485 4474 4474 4485 4176 4474 4176 2162 4481 4485 4475 4481 4475 4476 4476 4467 4477 4477 4481 4476 4481 4482 4483 4483 4485 4481 4488 4482 4481 4488 4481 4477 4177 4176 4485 4483 4177 4485 4171 4176 4177 4171 4177 4170 4170 4177 2156 2156 4177 4483 2160 4171 4172 4171 4170 4173 4171 4173 4172 2160 4176 4171 4170 2157 2660 4173 4170 2660 4170 2156 2157 4173 2660 4174 4172 4173 4174 2659 2660 2661 2661 2660 2157 2659 2666 2660 4174 2660 2666 2156 2155 2157 2661 2157 2155 2661 2155 4187 4187 2659 2661 2664 2665 2659 2659 2665 2666 4187 2664 2659 2666 2665 4174 2664 2663 2665 4174 2665 2663 2662 2663 2664 4189 2662 2664 4189 2664 4187 2662 2249 2663 4174 2663 2249 2252 2249 2662 2252 2662 4189 2252 4189 4186 4186 4189 4187 2252 2253 2249 2253 2252 2667 2667 2252 2668 2252 4186 2668 4188 2673 4186 4186 2673 2669 4186 2669 2668 4186 4187 4188 2667 2668 2669 2669 2675 2667 2667 4202 2253 2667 2675 4202 2673 2674 2669 2669 2674 2675 2671 2672 2673 2673 2672 2674 4188 2671 2673 2675 2674 4203 2674 2672 4203 4202 2675 4203 4202 4200 2253 4202 4203 4200 4203 2672 4204 4203 4204 4208 4200 4203 4208 2671 2670 2672 2672 2670 4204 2670 2151 4204 4204 2151 4199 4204 4199 4205 4208 4204 4205 4208 4205 4207 4200 4208 4201 4201 4208 4207 2253 4200 4201 2658 2652 4201 4201 2652 2651 4201 2651 2253 4201 4207 2658 2657 2654 2658 2658 2654 2652 2658 4207 2657 2650 2651 2652 2650 2652 2653 2653 2652 2654 2253 2651 2650 2650 2254 2253 2254 2650 4270 4270 2650 2653 4270 2653 2654 2657 2656 2654 4270 2654 4267 4267 2654 2656 4267 4271 4270 4270 4271 2254 2147 4261 4267 4267 2656 2147 4261 4266 4267 4267 4266 4271 2655 2147 2656 2655 2656 2657 2149 2147 2655 2655 2657 4207 4207 4206 2655 2655 4206 4190 2655 4190 2149 2148 2147 2149 2148 2149 4190 4193 4194 4190 4190 4194 4195 4190 4195 2148 4206 4193 4190 4205 4193 4206 4207 4205 4206 4205 4199 4193 4193 4199 4196 4196 4199 2151 4196 4197 4193 4196 2151 2150 4196 2150 4524 4196 4524 4197 2150 2151 2152 2152 2151 2153 2153 2151 2670 2150 2152 4510 2150 4510 4524 2152 2153 4178 2152 4178 4510 2153 2670 2671 4178 2153 4179 4179 2153 2671 4179 4184 4178 4178 4184 4508 4510 4178 4508 4510 4508 4511 4524 4510 4511 4508 4184 4507 4508 4507 4509 4511 4508 4509 4179 4183 4184 4184 4183 4507 4506 4505 4507 4507 4183 4181 4507 4181 4506 4509 4507 4505 4509 4505 541 4511 4509 565 565 4509 541 4504 539 4505 4506 4504 4505 541 4505 539 539 540 541 541 540 565 565 540 566 565 566 558 4525 4511 565 4525 565 558 558 566 567 566 540 4701 567 566 4703 4703 566 4701 558 567 556 4703 556 567 4703 4701 4704 4704 4710 4703 4703 4710 556 4701 540 4700 4701 4700 4702 4704 4701 4702 4704 4702 2017 2017 4709 4704 4704 4709 4710 4711 556 4710 4711 4710 4712 4712 4710 4709 2017 2027 4709 4712 4709 2025 2025 4709 2027 4714 4711 4712 4714 4712 2023 2023 4712 2025 557 556 4711 4713 557 4711 4713 4711 4714 2023 2028 4714 4714 2028 4731 4714 4731 4713 2022 2023 2024 2024 2023 2025 2023 2022 2028 2028 2022 2029 2028 2029 2030 2028 2030 4731 4731 2030 4727 4731 4727 4732 4713 4731 4732 2030 2029 2031 2030 2031 2032 2030 2032 4727 2031 2029 2916 2022 2916 2029 2032 2031 2033 2031 2916 2033 2032 2033 2034 4727 2032 2034 2034 2033 2035 2916 2917 2033 2033 2917 2919 2033 2919 2035 2044 2043 2034 2044 2034 2035 2034 4728 4727 2034 2043 4728 2932 2044 2035 2035 2919 2932 2917 2918 2919 2932 2919 2918 2932 2918 2931 2931 2933 2932 2932 2933 2934 2932 2934 2044 2918 2917 2920 2931 2918 2920 2920 2917 2921 2920 2921 2922 2931 2920 2922 2922 2921 2923 2923 2921 1872 2924 1872 2921 2924 2921 2916 2916 2921 2917 2923 2931 2922 2923 1872 1874 1874 1876 2923 2923 1876 2931 1872 1873 1874 1874 1873 1875 1874 1875 1876 1876 1875 1877 1876 1877 1878 1876 1878 2931 2931 1878 2933 1877 1879 1878 1878 1879 1880 1878 1880 1881 1878 1881 2933 2933 1881 2938 2933 2938 2934 1881 1880 1882 1881 1882 1883 1883 2938 1881 2704 1882 1880 2704 1880 2703 2703 1880 1879 1883 1882 1884 1884 1882 2704 1883 1884 1885 2937 2938 1883 1883 1885 2945 1883 2945 2937 1885 1884 1886 1886 1884 2676 2676 1884 2677 2704 2677 1884 1885 1886 1887 1885 1887 2945 2937 2945 2946 2945 1887 2947 2945 2947 2946 1887 1886 1888 1887 1888 1889 1887 1889 2947 1888 1886 2680 2680 1886 2676 1889 1888 1890 1890 1888 2682 2682 1888 2680 1889 1890 1891 2947 1889 2948 1889 1891 2948 2947 2948 2949 2946 2947 2949 2949 2948 2950 2948 1891 2961 2948 2961 2950 1891 1890 1892 1891 1892 1893 1891 1893 2961 2961 1893 2957 2961 2957 2962 2950 2961 2962 2949 2950 2047 2047 2950 2049 2950 2962 2049 2962 2957 2959 2962 2959 2053 2049 2962 2053 1893 1895 2957 2957 1895 2958 2957 2958 2959 2959 2958 2960 2959 2960 2051 2053 2959 2051 2051 2052 2053 2053 2052 2054 2053 2054 2049 1917 1916 2051 2051 1916 2052 2051 2960 1917 2958 2982 2960 2960 2982 1918 2960 1918 1917 1916 1917 1918 1916 1918 1919 1919 1918 1920 2982 2976 1918 1918 2976 1920 2958 2974 2982 2974 2979 2982 2982 2979 2976 2975 1920 2976 2975 2976 2977 2977 2976 2978 2978 2976 2979 2978 2979 2980 2980 2979 2981 2981 2979 1901 2974 1901 2979 2980 2995 2978 2978 2995 2996 2978 2996 2977 2977 2996 2997 2977 2997 2975 2995 4104 2996 4104 2997 2996 2980 2994 2995 2994 4102 2995 2995 4102 4104 2981 2994 2980 2981 1908 2994 2994 1908 4102 1908 4103 4102 4102 4103 4105 4102 4105 4104 4103 1908 2985 2989 4105 4103 2989 4103 2987 2987 4103 2985 2991 4098 4105 2991 4105 2989 4104 4105 4098 2987 2988 2989 2989 2988 2991 2985 2986 2987 2987 2986 2988 1908 2984 2985 2985 2984 2986 2986 4086 2988 2986 2984 4086 2991 2988 2992 2988 4086 4087 2988 4087 2992 2991 2992 1927 1927 4098 2991 1927 2992 2993 2992 4087 4088 2992 4088 2993 4086 4093 4087 4087 4093 4085 4087 4085 4088 2993 4088 4089 4088 4085 4084 4088 4084 4089 1927 2993 2990 2993 4089 2990 2990 4089 4082 4089 4084 4080 4089 4080 4082 1937 4080 4084 1937 4084 2971 2971 4084 4085 1937 1936 4080 4080 1936 4081 4080 4081 4082 4082 4081 4083 4082 4083 1929 2990 4082 1929 2990 1929 1927 1928 1927 1929 1929 4083 1928 4827 1928 4083 4827 4083 4828 4828 4083 4081 4828 4081 4829 4829 4081 1936 4830 4827 4828 4830 4828 4831 4831 4828 4829 4809 1928 4827 4823 4809 4827 4823 4827 4830 1926 1927 1928 1928 4809 1926 1927 1926 4098 4098 1926 4101 1926 4793 4795 4795 4101 1926 1926 4809 4810 1926 4810 4793 4810 4809 4823 4793 4810 4811 4811 4810 4823 4793 4792 4794 4793 4794 4795 4793 4807 4792 4793 4811 4807 4807 4811 4820 4820 4811 4823 4792 4807 4808 4808 4807 4820 4820 4823 4826 4818 4808 4820 4818 4820 4819 4819 4820 4826 4792 4808 4806 4806 4808 4818 512 4818 4819 4806 4818 512 4821 4822 4819 4819 4822 512 4819 4826 4821 511 512 513 512 511 4806 4822 513 512 4806 511 4792 513 48 511 511 48 70 511 70 517 4792 511 517 4822 4841 513 48 513 4842 4842 513 4841 4821 4841 4822 4825 4840 4841 4825 4841 4821 4842 4841 4843 4843 4841 4840 4843 4849 4842 4842 4849 4851 4842 4851 48 4843 4840 1932 1932 1931 4843 4843 1931 4849 1931 4848 4849 4849 4848 4850 4849 4850 4851 4851 4850 51 4851 51 50 48 4851 50 4848 4868 4850 4850 4868 4869 4850 4869 51 1931 1938 4848 4848 1938 4868 1938 1940 4868 4868 1940 4864 4868 4864 4869 4869 4864 4866 4869 4866 53 51 4869 53 1940 1942 4864 4864 1942 4865 4864 4865 4866 1938 1939 1940 1940 1939 1941 1940 1941 1942 1942 1941 1943 1942 1943 1944 1944 4865 1942 4866 4865 4867 4885 4867 4865 1944 4885 4865 1944 1943 1945 1944 1945 1946 1946 4885 1944 2944 2942 1943 1943 2942 1945 1941 2944 1943 1946 1945 1947 2942 2940 1945 1945 2940 1947 1946 1947 1948 1948 4884 1946 1946 4884 4885 1948 1947 1949 2940 2928 1947 1947 2928 1949 2939 2926 2940 2940 2926 2928 2942 2939 2940 2926 2927 2928 2928 2927 1951 2928 1951 1949 1948 1949 1950 1950 1949 1951 1950 1951 1952 1952 1951 1953 2927 2929 1951 1951 2929 1953 2926 2925 2927 2925 2930 2927 2927 2930 2929 2905 1953 2929 2905 2929 2906 2906 2929 2908 2908 2929 2930 2908 2930 2909 2909 2930 2911 2911 2930 1862 2925 1862 2930 2908 2909 2910 2908 2910 2906 2905 2906 2907 2906 2910 2907 2905 2907 1955 1955 1953 2905 2907 2910 2912 2907 2912 2914 1955 2907 1963 1963 2907 2914 2910 1823 2912 2912 1823 1821 2912 1821 2913 2914 2912 2913 2914 2913 2915 1963 2914 1961 1961 2914 2915 1961 1962 1963 1963 1962 1964 1963 1964 1955 1959 1960 1961 1961 1960 1962 1961 2915 1959 2915 2913 2885 2915 2885 2887 1959 2915 2887 1957 1958 1959 1959 1958 1960 1959 2887 1957 2885 2886 2887 2887 2886 1966 2887 1966 1957 1820 2884 2885 2885 2884 2886 2913 1820 2885 2884 2893 2886 2886 2893 2890 2886 2890 1966 1820 1846 2884 1846 1853 2884 2884 1853 2893 2893 1853 1851 1851 2894 2893 2893 2894 2895 2893 2895 2890 1852 1851 1853 1852 1853 1854 1854 1853 1846 1850 1851 1852 1850 1852 2849 2849 1852 2850 1854 2850 1852 1854 1846 1855 2841 2842 1854 1854 1855 2841 2842 2850 1854 2848 2851 2850 2850 2851 2852 2850 2852 2849 2842 2848 2850 1850 2849 4057 4057 2849 2852 4057 2852 4058 4058 2852 2851 2848 2857 2851 4058 2851 4054 4054 2851 2857 4056 4057 4058 4056 4058 4055 4055 4058 4054 1850 4057 4056 4055 2864 4056 4056 2864 2867 4056 2867 1850 4053 2869 4055 4055 2869 2864 4055 4054 4053 2864 2865 2866 2866 2867 2864 2865 2864 2868 2868 2864 2869 2866 1850 2867 1851 1850 2866 1851 2866 4072 4072 2866 4073 4073 2866 2865 4073 2865 2868 2868 2869 2870 4073 2868 2870 2870 2869 2871 4053 2871 2869 2870 2871 2872 2872 2875 2870 2875 4074 2870 2870 4074 4077 2870 4077 4073 2872 2871 4053 4052 2872 4053 4053 4054 4051 4053 4051 4052 4045 2873 4052 4052 2873 2872 4052 4051 4048 4052 4048 4045 1975 1973 2873 2873 1973 2874 2873 2874 2872 4045 1975 2873 1974 1973 1975 1974 1975 1976 1976 1975 4044 4044 1975 4045 1972 1973 1974 1974 1976 4844 1972 1974 4846 4846 1974 4844 4833 1976 4044 4844 1976 4833 4044 4045 4046 4833 4044 4835 4835 4044 4046 4834 4833 4835 4844 4833 4845 4845 4833 4834 4846 4844 4847 4847 4844 4845 4845 4834 74 4847 4845 73 73 4845 74 75 4834 4836 4834 4835 4836 74 4834 75 4835 4046 4837 4836 4835 4837 4836 4837 4838 75 4836 85 85 4836 4838 4046 4047 4837 4837 4047 4049 4837 4049 4832 4838 4837 4832 4838 4832 4839 85 4838 78 78 4838 4839 1984 4817 4832 4832 4049 4050 4832 4050 1984 4839 4832 4817 4047 4048 4049 4048 4050 4049 4048 1984 4050 1983 1982 1984 1983 1984 1985 1985 1984 4048 1982 4817 1984 4816 4814 4817 1982 4816 4817 4839 4817 4814 1977 1981 1982 1977 1982 1983 1981 4816 1982 4815 4813 4816 4816 4813 4814 1981 4815 4816 4813 206 4814 205 4839 4814 205 4814 206 4812 207 4813 4813 207 206 4815 4812 4813 76 205 206 76 206 204 204 206 207 78 205 76 78 4839 205 76 77 78 78 77 79 78 79 80 80 81 78 78 81 82 78 82 83 86 85 78 86 78 87 87 78 83 5159 81 80 80 79 5159 5157 5158 5159 5159 5158 81 5159 79 5142 5159 5142 5157 5167 81 5158 5169 5167 5158 5169 5158 5157 5166 82 5167 5167 82 81 5168 5166 5167 5168 5167 5169 1730 5168 5169 1730 5169 1728 1728 5169 5157 5164 5166 5168 1732 5164 5168 1732 5168 1730 1728 1729 1730 1730 1729 1731 1730 1731 1732 1725 1727 1728 1728 1727 1729 1728 5157 1725 3560 3561 1729 1729 3561 1731 1727 3560 1729 1737 1738 1731 1731 1738 1732 3561 1737 1731 3560 3559 3561 3559 3583 3561 3561 3583 1737 3558 3559 3560 3557 3558 3560 3557 3560 1727 3558 1775 3559 1775 3574 3559 3559 3574 3583 3574 3577 3583 3583 3577 3576 3583 3576 1737 1775 1777 3574 1777 1786 3574 3574 1786 3577 3577 3578 3576 1786 3581 3577 3577 3581 3582 3577 3582 3578 3576 3578 3579 3582 3597 3578 3578 3597 3598 3578 3598 3579 3581 3595 3582 3595 3596 3582 3582 3596 3597 1786 3580 3581 3580 3595 3581 3580 1771 3595 3596 3595 3954 3954 3595 1771 3597 3596 3956 3956 3596 3954 3956 3598 3597 3956 3954 3957 3951 3956 3949 3949 3956 3957 3951 1742 3956 3956 1742 3598 3953 3954 1771 3957 3954 3953 3957 3953 3952 3949 3957 3947 3947 3957 3952 3947 3948 3949 3949 3948 3950 3949 3950 3951 3951 3950 1743 3951 1743 1742 5152 1743 3950 5152 3950 5153 5153 3950 3948 3947 3946 3948 5153 3948 5154 5154 3948 3946 5156 5152 5153 5156 5153 5155 5155 5153 5154 5155 5154 5134 5134 5154 3946 1745 1744 3946 1745 3946 3947 5134 3946 1744 1744 1746 5134 5134 1746 5126 5134 5126 5135 5134 5135 5155 1744 1745 1746 1746 1745 1747 3612 1747 1745 3612 1745 3947 3947 3952 3612 3611 3612 3610 3610 3612 3613 3611 3614 3612 3612 3614 1747 3612 3952 3613 3608 3613 3952 3952 3953 3955 3952 3955 3608 3610 3613 3608 3608 3609 3610 3941 3611 3610 3941 3610 3609 3607 1764 3608 3608 1764 3609 3608 3955 3607 3953 1771 3955 3607 3955 1771 3607 1771 1764 1770 1762 1771 1771 1762 1764 1765 1770 1771 1765 1771 1792 1792 1771 1788 1788 1771 3580 1792 1788 1793 1793 3618 1792 3635 1765 1792 1792 3618 3635 1786 1787 1788 1793 1788 1787 1788 3580 1786 1777 1776 1786 1786 1776 1787 1793 1787 3615 3615 1787 3623 1787 1776 3623 1775 1772 1776 1775 1776 1777 1772 3626 1776 3623 1776 3626 3615 3623 3619 3619 3623 3624 3623 3626 3624 3600 3625 3626 3600 3626 1772 3624 3626 3625 3600 3601 3602 3606 3601 3600 3606 3600 1772 3602 3625 3600 3624 3625 1682 1682 3625 3602 3602 3601 1697 3602 1697 1680 1682 3602 1680 1680 1681 1682 1682 1681 1683 1682 1683 3624 1681 1680 1696 1696 1680 1697 1696 1697 1698 1698 1697 1699 3601 1699 1697 1698 1699 1700 1700 5013 1698 1698 5013 5015 1698 5015 1696 1700 1699 1701 3601 1701 1699 1700 1701 1702 1702 5013 1700 1702 1701 1703 3604 1703 1701 3604 1701 3601 3605 3604 3601 3605 3601 3606 3603 3604 3605 3606 1780 3605 3605 1780 1782 3605 1782 3603 1772 1784 3606 3606 1784 1780 1772 1773 1774 1773 1772 1775 1774 1789 1772 1772 1789 1790 1772 1790 1784 1773 1775 3558 1774 1773 3556 3556 1773 3558 1789 1774 3556 1790 1789 3539 3539 1789 3540 1789 3556 3540 1784 1790 1791 1791 1790 3535 3535 1790 3539 3539 3540 3534 3535 3539 3536 3536 3539 3534 3534 3540 3541 3540 3556 3557 3540 3557 3541 3556 3558 3557 3541 3557 1727 3534 3541 1726 1726 3541 1724 3541 1727 1724 1725 1724 1727 1724 1725 1726 1726 3533 3534 3533 1726 5139 1725 5139 1726 5157 5139 1725 5142 5140 5139 5139 5140 5141 5139 5141 3533 5157 5142 5139 3537 3534 3533 3533 5141 3537 5140 5131 5141 5141 5131 5130 3537 5141 3538 3538 5141 5130 3536 3537 3538 3536 3534 3537 3511 3536 3538 3511 3538 3515 3538 5130 3515 3515 5130 5128 5128 5130 5131 3514 3511 3515 3514 3515 5128 3509 3510 3511 3514 3509 3511 3510 3536 3511 3510 3535 3536 3509 3518 3510 3518 3535 3510 3513 3508 3509 3513 3509 3514 3508 3516 3509 3509 3516 3518 5128 5129 3514 3514 5129 3513 3512 3508 3513 3512 3513 5129 5111 3512 5129 5111 5129 5112 5112 5129 5115 5115 5129 5133 5128 5133 5129 3501 3497 3512 3512 3497 3508 3501 3512 5111 3500 3497 3501 5111 3500 3501 3495 3496 3497 3500 3495 3497 3497 3496 3508 3499 3495 3500 5111 3499 3500 3491 3498 3499 3499 3498 3495 5113 3491 3499 5113 3499 5111 3491 3492 3487 3487 3489 3491 3491 3489 3498 3492 3491 5113 3504 3495 3498 3504 3498 3506 3506 3498 3489 3487 3488 3489 3489 3488 3490 3506 3489 3485 3485 3489 3490 3485 1805 3506 3506 1805 1781 3506 1781 3504 3485 3486 1802 3485 3490 3486 1802 1804 3485 3485 1804 1805 1804 1782 1805 1805 1782 1781 1802 1803 1804 1804 1803 1782 1800 1801 1802 1802 1801 1803 3520 1800 1802 3520 1802 3486 3486 3490 3520 3524 1800 3520 3527 3524 3520 3527 3520 3519 3519 3520 3490 3524 1798 1800 1798 1799 1800 1800 1799 1801 1796 1797 1798 1798 1797 1799 3587 1801 1799 3587 1799 3591 3591 1799 1797 1796 1795 1797 3591 1797 3592 3592 1797 1795 1794 1795 1796 1794 1796 3542 1795 1794 3562 3592 1795 3562 3593 3591 3592 3593 3592 3594 3594 3592 3562 3590 3587 3591 3590 3591 3593 1713 3590 3593 1713 3593 1711 1711 3593 3594 3594 3562 3566 1711 3594 1709 1709 3594 3566 1709 1710 1711 1711 1710 1712 1711 1712 1713 1707 1708 1709 1709 1708 1710 1709 3566 1707 3562 3565 3566 1716 1707 3566 3566 3565 1716 1708 1707 1715 1715 1707 1716 5021 1710 1708 5021 1708 5022 5022 1708 5023 1708 1715 5023 1715 1716 1717 1715 1717 5037 5023 1715 5037 5022 5023 5024 5023 5037 5024 5026 5021 5022 5026 5022 5024 5024 23 36 5024 36 5026 5024 5037 5039 5024 5039 23 5037 1717 5038 5037 5038 5039 5039 5038 5040 5039 5040 21 23 5039 21 21 22 23 23 22 24 24 36 23 35 36 24 5026 36 35 24 34 35 5026 35 5025 5025 35 34 24 28 34 34 28 5004 5025 34 5018 5018 34 5004 5018 5020 5025 5025 5020 5021 5025 5021 5026 5018 5007 5006 5006 5019 5018 5018 5019 5020 5018 5004 5007 5019 1712 5020 5020 1712 1710 5020 1710 5021 1713 1712 1714 5019 1714 1712 1713 1714 1695 1713 1695 3588 3588 3590 1713 1695 1714 1692 1693 1692 1714 1693 1714 5009 5009 1714 5019 1692 1694 1695 1694 1706 1695 3588 1695 1706 1692 1693 1694 1693 5009 1694 5009 5010 5011 1694 5009 5011 5019 5010 5009 1704 1705 1694 1694 1705 1706 1694 5011 1704 3599 3588 1706 3599 1706 3604 3604 1706 1705 1704 1703 1705 1705 1703 3604 1702 1703 1704 1704 5011 5013 1704 5013 1702 5011 5014 5013 5013 5014 5005 5013 5005 5015 5008 31 5014 5014 31 30 5014 30 5005 5011 5008 5014 30 31 32 32 31 26 5008 26 31 30 32 4979 5005 30 4979 32 26 33 4979 32 33 4984 4983 4979 4979 33 4984 5005 4979 4983 33 26 25 4984 33 25 4982 4983 4984 4984 25 4988 4982 4984 4987 4987 4984 4988 5005 4983 4982 4987 4986 4982 5015 5005 4982 5015 4982 4986 4985 4986 4987 1696 5015 4986 1696 4986 4985 1690 4985 1689 1689 4985 4987 1690 1696 4985 1681 1696 1690 1689 1681 1690 1688 1683 1689 1689 1683 1681 1689 4987 1688 1686 1687 1688 1688 1687 1683 1688 4987 4989 1688 4989 1686 3624 1683 1687 1686 1685 1687 3624 1687 1685 1684 1685 1686 1686 4989 4980 1686 4980 1684 4987 4988 4989 4989 4988 4981 4989 4981 4980 4988 25 27 4988 27 4981 25 26 27 27 26 28 27 28 29 27 29 4966 4981 27 4966 5004 28 26 5004 26 5008 29 28 24 29 24 4966 4966 24 4967 4966 4967 4968 4981 4966 4968 22 4967 24 39 38 22 39 22 40 40 22 21 359 360 22 22 38 359 4947 4963 22 4947 22 360 4963 4967 22 21 5040 40 40 5040 5048 40 5048 39 5040 5038 5047 5040 5047 5048 5048 5047 5049 5048 5049 5053 39 5048 5053 5038 4006 5047 5047 4006 4008 5047 4008 5049 5038 1717 4006 1717 1719 4006 4006 1719 4007 4006 4007 4008 4007 4013 4008 5049 4008 4013 4011 4012 4007 4007 4012 4013 1719 3570 4007 4007 3570 4022 4007 4022 4011 1717 1718 1719 1718 3570 1719 1717 1716 1718 1716 3569 1718 1718 3569 3570 3570 3569 4022 4022 3569 3568 4022 3568 4021 4011 4022 4023 4023 4022 4021 3565 3568 3569 1716 3565 3569 3567 3568 3565 4021 3568 3567 3573 4020 4021 4021 3567 3573 4023 4021 4027 4027 4021 4020 4014 4011 4023 4014 4023 4024 4024 4023 4027 4024 4027 4025 4025 4027 4028 4027 4020 4028 4024 1721 4014 1720 1721 1722 4014 1721 1720 1720 4015 4014 1720 5045 5046 5046 4015 1720 1720 1722 5045 5045 1722 5064 5057 5046 5045 5057 5045 5058 5045 5064 5058 5052 4016 5046 5046 4016 4015 5056 5052 5046 5056 5046 5057 4014 4015 4016 4014 4016 4011 4011 4016 4017 5052 4017 4016 5051 4017 5052 5055 5051 5052 5055 5052 5056 42 5055 5056 42 5056 44 44 5056 5057 5054 5051 5055 41 5054 5055 41 5055 42 38 41 42 37 41 38 37 5054 41 5053 5050 5054 5054 5050 5051 37 5053 5054 37 38 39 39 5053 37 359 38 378 5236 378 38 359 378 379 379 378 5240 5240 378 5236 5240 5236 5241 5241 5236 5239 5241 5248 5240 5240 5248 5249 5240 5249 379 388 359 379 379 5249 5250 379 5250 388 387 5250 5249 387 5249 5262 5262 5249 5248 5241 5254 5248 5262 5248 5254 5253 5262 5254 5263 387 5262 5241 5253 5254 5239 5253 5241 385 386 387 387 386 359 387 359 388 388 5250 387 385 387 5263 5265 385 5263 429 430 385 385 430 431 385 431 386 429 385 5265 4907 359 386 4907 386 4909 4909 386 431 360 359 4927 4927 359 4907 4908 4907 4909 4927 4907 4928 4928 4907 4929 4929 4907 4908 4909 431 4911 4908 4909 4910 4910 4909 4911 4911 431 430 4911 430 4912 4910 4911 4913 4913 4911 4912 1670 4908 4910 4913 3968 4910 4910 3968 3973 4910 3973 1670 4913 4912 4914 4914 3969 4913 4913 3969 3968 3968 3969 3970 3970 3973 3968 3970 1670 3973 3970 3969 3971 3970 3971 3967 1671 1670 3970 1671 3970 3654 3654 3970 3977 3976 3977 3970 3976 3970 3967 4914 3971 3969 3967 3971 3972 3972 3971 4914 3966 1669 3967 3967 3972 3966 3967 1669 3976 3966 3972 4915 4915 3972 4914 1668 1669 3966 1668 3966 4903 4903 3966 4915 4915 4914 4916 4903 4915 4905 4905 4915 4916 4916 4914 4912 4916 4912 428 4905 4916 427 427 4916 428 4904 4903 4905 4904 4905 4906 4906 4905 427 1666 1668 4903 1666 4903 4904 1666 1667 1668 3984 1667 1666 3984 1666 4904 1668 1667 1669 3666 1669 1667 3984 3987 1667 3666 1667 3987 3984 3985 3981 3981 3987 3984 3984 4904 3985 3988 3666 3987 3988 3987 3993 3993 3987 3981 3669 3668 3988 3993 3990 3988 3988 3990 3991 3988 3991 3669 3668 3666 3988 3992 3989 3993 3993 3989 3990 3993 3981 3992 3989 1767 3990 3991 3990 1767 3663 3991 1767 3669 3991 3663 3664 3668 3669 3664 3669 3663 3667 3666 3668 3667 3668 3664 3663 1766 3664 3664 1766 3974 3664 3974 3667 1767 1766 3663 1765 1766 1767 1766 1765 3647 1766 3647 3648 3975 1766 3648 1766 3975 3974 3667 3974 3976 3974 3975 3977 3974 3977 3976 3653 3977 3975 3653 3975 3651 3651 3975 3648 3647 3649 3648 3648 3649 3650 3648 3650 3651 3651 3650 3652 3651 3652 3653 3653 3652 3654 3654 3977 3653 3654 3652 1673 3965 1673 3652 3965 3652 3650 3649 3965 3650 3647 3962 3649 3649 3962 3965 3962 3964 3965 3965 3964 3959 3965 3959 3961 3961 1673 3965 3962 3647 1765 1765 3963 3962 3962 3963 3964 1767 1770 1765 1765 3635 3963 3963 3635 3636 3963 3636 3964 3635 3618 3617 3635 3617 3636 3636 3617 3616 3636 3616 3637 3637 3964 3636 3616 3617 1793 1793 3617 3618 1793 3615 3616 3615 3622 3616 3637 3616 3622 3637 3622 3638 3638 3964 3637 3638 3959 3964 3638 3622 3621 3638 3621 1675 1675 3959 3638 3615 3621 3622 3619 3621 3615 3619 3620 3621 1675 3621 3620 3619 1685 1677 1677 3620 3619 3619 3624 1685 1675 3620 1677 1676 1675 1677 1676 1677 1678 1678 1677 1679 1685 1679 1677 1684 1691 1685 1685 1691 1679 1678 1679 4971 4971 1679 1691 1676 1678 4962 4962 1678 4971 4942 1676 4962 4942 4962 4941 4941 4962 4943 4943 4962 4963 4962 4971 4963 4941 4940 4942 4942 4940 3958 4942 3958 1674 1674 1676 4942 4937 4940 4941 4937 4941 4943 4946 4937 4943 4943 4963 4946 4946 4963 4947 4963 4971 4967 4945 4937 4946 4946 4947 4945 4937 4938 4939 4939 4940 4937 4945 4938 4937 4944 4938 4945 4945 360 4944 4945 4947 360 4944 4927 4938 4927 4928 4938 4938 4928 4929 4938 4929 4939 360 4927 4944 4939 4931 1672 1672 3960 4939 4939 3960 4940 4939 4929 4930 4939 4930 4931 4929 4908 4930 4930 4908 4931 4931 4908 1670 4931 1670 1672 1670 1671 1672 1672 1671 1673 3654 1673 1671 3961 1672 1673 3961 3960 1672 3959 3960 3961 1675 3958 3959 3959 3958 3960 1674 1675 1676 1675 1674 3958 3960 3958 4940 4968 4967 4969 4969 4967 4970 4970 4967 4971 4968 4969 4981 4981 4969 4970 4970 4971 4972 4980 4981 4970 4980 4970 4972 1691 4973 4971 4971 4973 4974 4971 4974 4972 4972 4974 4980 4980 4974 4973 1684 4980 4973 1684 4973 1691 1768 1769 1770 1770 1769 1762 3679 1770 1767 1768 1770 3692 3692 1770 3693 4001 4002 1770 4001 1770 4003 4002 3693 1770 3679 4003 1770 3679 1767 3680 3680 4003 3679 3680 1767 3681 3989 3681 1767 3680 3681 3682 3682 3685 3680 3680 3685 4000 4000 4003 3680 4000 4001 4003 4005 4001 4000 3995 4005 4000 3995 4000 3684 3684 4000 3685 3682 3684 3685 3683 3684 3682 3989 3683 3682 3989 3682 3681 3992 3683 3989 3683 3686 3684 3992 3686 3683 3684 3686 1665 3684 1665 1663 3684 1663 3995 1665 3686 3992 3992 3981 3978 3992 3978 1665 1664 1663 1665 1664 1665 3978 1662 1663 1664 1663 1662 3994 1663 3994 3995 3978 3983 1664 1664 3983 4925 1662 1664 4932 4932 1664 4925 3981 3982 3978 3978 3982 3983 3983 3982 4924 4925 3983 4924 4925 4924 4926 4932 4925 4933 4933 4925 4934 4934 4925 4926 4923 4922 4924 4924 3982 3980 4924 3980 4923 4926 4924 4922 3981 3980 3982 3979 3980 3981 4923 3980 3979 4919 4921 4923 4923 4921 4922 4923 3979 4919 4921 361 4922 4926 4922 362 362 4922 361 4920 422 4921 4921 422 361 4919 4920 4921 4917 423 4920 4920 423 422 4918 4917 4920 4918 4920 4919 4904 4906 4917 4906 424 4917 4917 424 423 4904 4917 4918 391 423 424 391 424 425 425 424 407 4906 407 424 4906 427 407 407 427 409 409 427 428 409 428 429 429 428 430 428 4912 430 5275 409 429 5275 5274 409 5276 409 5274 409 410 407 410 409 5276 5278 410 5276 407 410 411 411 410 5278 5278 405 411 407 411 405 405 406 407 407 406 408 425 407 426 426 407 408 408 406 5286 408 5286 426 426 5286 5297 426 5297 425 425 5297 5298 425 5298 391 5297 5295 5298 5298 5295 5294 5298 5294 5299 391 5298 5299 391 5299 392 5294 5305 5299 5299 5305 393 5299 393 392 1468 5294 5295 1468 5304 5294 5294 5304 5305 5295 1470 1468 1469 1468 1470 1469 1470 1471 1469 1471 3227 5306 393 5305 5306 5305 5307 5307 5305 5304 394 393 5306 5308 394 5306 5308 5306 5309 5309 5306 5307 418 394 5308 5314 5308 5309 419 418 5308 5308 5314 419 419 5314 5318 419 5318 383 3985 4904 4918 3985 4918 4919 3981 3985 3986 4919 3986 3985 4919 3979 3986 3981 3986 3979 362 326 363 362 363 4926 363 326 4951 4951 326 4964 325 4964 326 4951 4950 363 4951 4952 4950 4951 4964 4952 4952 4964 4953 4953 4964 4965 4976 4965 4964 4976 4964 325 332 4976 325 4975 4965 4976 4978 4975 4976 4978 4976 332 1659 1657 4975 4975 1657 4965 4977 1659 4975 4977 4975 4978 5003 4977 4978 1661 1659 4977 1661 4977 4990 5003 4990 4977 1658 1657 1659 1658 1659 1660 1660 1659 1661 1660 1661 3889 3889 1661 3891 4990 3891 1661 3691 1658 1660 3691 1660 3889 3689 3690 3691 3691 3690 1658 3689 3691 3892 3892 3691 3889 3687 3688 3689 3689 3688 3690 3687 3689 3892 4004 1658 3690 4004 3690 3688 3687 3694 3688 3688 3694 4004 3692 3693 3687 3687 3693 3694 3892 3895 3687 3687 3895 3692 3694 3693 4002 4004 3694 4002 4004 4002 4005 4005 4002 4001 3997 4004 4005 3997 4005 3995 3995 3996 3997 3997 3996 3998 3997 3998 3999 3999 4004 3997 3995 3994 3996 4958 3998 3996 4958 3996 4959 4959 3996 3994 3999 3998 1656 4957 1656 3998 4957 3998 4958 3999 1656 1658 3999 1658 4004 1656 1657 1658 4956 1656 4957 4956 1657 1656 4955 4956 4957 4954 4955 4957 4954 4957 4961 4961 4957 4958 4955 4965 4956 4956 4965 1657 4953 4955 4954 4953 4965 4955 4952 4953 4954 4950 4952 4954 4950 4954 4948 4948 4954 4961 4961 4958 4960 4948 4961 4949 4949 4961 4960 363 4948 4949 4950 4948 363 4934 4935 4949 4949 4935 4936 4949 4936 363 4949 4960 4934 4926 363 4936 4926 4936 4935 4934 4926 4935 4934 4960 4933 4932 4933 4960 4960 4959 4932 4932 4959 3994 4932 3994 1662 4960 4958 4959 3692 3895 1768 3895 3894 1768 3892 3894 3895 3671 1769 1768 1768 3675 3671 3893 3675 1768 3893 1768 3894 3897 3893 3894 3897 3894 3892 3892 3889 3897 3896 3893 3897 3897 3889 3885 3897 3885 3896 3896 3677 3893 3893 3677 3676 3893 3676 3675 3671 3675 3676 3671 3676 3673 3673 3676 3677 3673 3677 3674 3896 3674 3677 3896 3885 3881 3896 3881 1655 1655 3674 3896 3672 3673 3674 3672 3674 3678 3678 3674 1655 3672 3907 3673 3673 3907 3671 3678 3909 3672 3672 3909 3907 3678 1655 1653 1653 3903 3678 3678 3903 3909 3906 3907 3909 3906 3909 3908 3908 3909 3903 3907 1769 3671 1769 3907 3906 3657 1769 3906 3657 3906 3660 3660 3906 3908 3657 3656 1769 1769 3656 3658 1769 3658 1762 3655 3656 3657 3655 3657 3659 3659 3657 3660 3659 3660 3661 3660 3908 3661 3661 3662 3659 3908 3662 3661 3659 3662 1760 3908 1760 3662 3659 1760 1758 1758 3923 3659 3659 3923 3928 3659 3928 3655 3655 3928 3656 3927 3656 3928 3926 3927 3928 3926 3928 3929 3929 3928 3923 1762 3658 3927 3927 3658 3656 1762 3927 3926 3926 3646 1762 3646 3926 3645 3645 3926 3929 1762 1763 1764 3646 1763 1762 3645 3644 3646 3646 3644 1763 3643 3644 3645 3645 3929 3643 3643 3642 3644 3919 1763 3644 3642 3919 3644 3640 3642 3643 3929 3640 3643 3640 3641 3642 3641 3919 3642 3641 3921 3919 1763 3919 3918 3918 3919 3921 3639 3641 3640 3639 3921 3641 1755 3639 3640 3929 1755 3640 3929 3923 3925 3925 1755 3929 1754 1753 1755 1753 3639 1755 3925 1754 1755 1753 3914 3639 3639 3914 3921 1752 1753 1754 1753 1752 3914 3925 3924 1754 5070 5071 1754 1754 3924 5070 5071 1752 1754 3923 3924 3925 3923 3922 3924 3924 3922 5072 5070 3924 5072 1758 1757 3922 1758 3922 3923 5059 5072 3922 5059 3922 1757 5060 5072 5059 5070 5072 5068 5068 5072 5060 1757 1756 5059 5059 1756 5043 5059 5043 5060 1756 1757 1758 1756 1758 1759 1759 1758 1760 1756 1759 5043 5043 1759 5041 5043 5041 5044 5060 5043 5061 5061 5043 5044 5068 5060 5061 5061 5044 5062 5062 5068 5061 5044 5041 5042 5044 5042 251 5062 5044 5063 5063 5044 251 5075 5068 5062 5062 5063 5075 5063 251 523 5075 5063 523 5074 5069 5075 5075 5069 5068 5075 523 5074 5068 5069 5070 5074 5073 5069 5073 5076 5069 5069 5076 5077 5069 5077 5070 523 5073 5074 522 523 251 523 522 5073 5073 522 5083 5073 5083 5076 5076 5083 5077 5070 5077 5078 5077 5083 5084 5077 5084 5078 5070 5078 5071 5078 5084 5071 5071 5084 1752 5084 5083 5095 1752 5084 5096 5084 5095 5096 5083 522 530 5083 530 5095 522 251 530 520 554 530 520 530 555 555 530 251 5095 530 554 5095 554 5097 5096 5095 5097 519 554 520 5097 554 519 5097 519 5098 5096 5097 5099 5099 5097 5098 518 519 520 518 5098 519 5099 5098 5100 5102 5100 5098 5102 5098 518 5100 3913 5099 5099 3913 3912 5099 3912 5096 3912 3913 3914 3914 3913 3915 5100 3915 3913 3914 3917 3912 5096 3912 3917 5096 3917 1752 3914 1752 3917 3914 3915 3911 3920 3921 3914 3920 3914 3911 3911 3915 3916 3916 3915 5100 3910 1751 3911 3911 3916 3910 3911 1751 3920 3910 3916 5101 5101 3916 5100 5101 5100 5102 5103 3910 5101 5103 5101 5104 5104 5101 5102 1750 1751 3910 1750 3910 5103 1748 1750 5103 1748 5103 5109 5109 5103 5104 5104 5102 563 5109 5104 5110 5110 5104 563 563 5102 518 518 562 563 563 562 525 563 525 564 5110 563 564 5110 564 527 5109 5110 5118 5110 527 5118 564 525 527 525 526 527 525 562 4743 4743 4747 525 525 4747 4751 525 4751 526 527 526 528 526 4751 4752 526 4752 528 4747 4748 4751 4751 4748 4749 4751 4749 4752 4747 4743 4744 4747 4744 4748 4744 2046 4748 4748 2046 2048 4748 2048 4749 4749 2048 2050 4749 2050 4750 4752 4749 4750 4752 4750 4753 528 4752 4753 4761 4753 4750 4761 4750 2054 2054 4750 2050 2048 2049 2050 2049 2054 2050 2046 2047 2048 2048 2047 2049 2046 2045 2047 2045 2949 2047 2037 2036 2045 2037 2045 2046 2935 2946 2045 2935 2045 2036 2946 2949 2045 2036 2037 2038 2038 2935 2036 2935 2936 2937 2038 2936 2935 2937 2946 2935 2038 2037 2039 2038 2039 2040 2038 2040 2934 2934 2936 2038 2937 2936 2938 2934 2938 2936 2934 2040 2042 2934 2042 2044 2040 2039 2041 2040 2041 2042 2041 2039 4739 2037 4739 2039 2042 2041 2043 4739 4740 2041 2041 4740 2043 2042 2043 2044 4728 2043 4740 4728 4740 4729 4729 4740 4730 4730 4740 4741 4739 4741 4740 4727 4728 4729 4727 4729 4724 4724 4729 4730 4724 4730 4725 4730 4741 4725 4725 4741 4726 4726 4741 520 4742 520 4741 4742 4741 4739 4724 4725 510 510 4725 4726 510 4726 555 4726 520 555 520 561 518 561 520 4742 4743 561 4742 4743 4742 4744 4744 4742 4739 4744 4739 2037 4744 2037 2046 562 561 4743 518 561 562 555 251 510 249 250 251 251 250 252 251 252 253 254 255 251 251 255 256 251 256 249 253 257 251 251 257 258 251 258 259 259 260 251 251 260 261 251 261 262 503 251 504 504 251 262 510 251 503 251 5042 254 504 262 505 4539 4535 504 504 4535 503 504 505 4539 4534 503 4535 4536 4534 4535 4536 4535 4537 4539 4537 4535 4533 521 4534 4534 521 503 4532 4533 4534 4532 4534 4536 4537 4192 4536 4536 4192 4191 4536 4191 4532 4197 4531 4532 4531 4533 4532 4532 4191 4198 4532 4198 4197 4191 4192 4193 4193 4198 4191 4193 4192 4194 4537 4194 4192 4193 4197 4198 4197 4524 4531 4524 4530 4531 4531 4530 4533 4524 4511 4525 4524 4525 4530 4525 509 4530 4530 509 508 4530 508 4533 4533 508 521 508 509 510 508 510 521 558 559 509 509 559 560 509 560 510 4525 558 509 510 503 521 560 4724 510 4732 4724 560 559 4732 560 558 557 559 559 557 4713 4713 4732 559 556 557 558 4732 4727 4724 4195 4194 4537 2148 4195 4538 4538 4195 4537 4538 4537 4539 4551 2148 4538 4551 4538 4552 4552 4538 4553 4553 4538 4539 2146 2147 2148 2146 2148 4551 2147 2146 4260 4551 4260 2146 4551 4552 4574 4574 4573 4551 4551 4573 4260 4553 4574 4552 4553 4539 4554 4553 4554 4563 4563 4574 4553 4575 4572 4574 4574 4572 4573 4563 4575 4574 4572 4262 4573 4573 4262 4260 2147 4260 4261 4261 4260 4262 4261 4262 4263 4263 4262 4264 4572 4264 4262 4571 4264 4572 4575 4571 4572 4263 4264 4265 4265 4264 2240 4571 2240 4264 4261 4263 4266 4263 4265 4268 4263 4268 4266 4265 2240 2239 4265 2239 2638 4268 4265 2638 4268 2638 4269 4266 4268 4269 4266 4269 4271 4269 2638 2639 2639 2637 4269 4269 2637 2636 4269 2636 2254 4271 4269 2254 2637 2639 2617 2617 2639 2638 2621 2636 2637 2621 2637 2616 2616 2637 2617 2254 2636 2621 2620 2621 2616 2620 2622 2621 2622 2254 2621 2616 2617 2618 2616 2618 2620 2618 2617 2619 2617 2638 2619 2233 2623 2618 2233 2618 2232 2232 2618 2619 2620 2618 2623 2232 2619 2231 2619 2638 2231 2638 2239 2231 2231 2228 2232 2239 2240 2231 2231 2240 2241 2231 2241 2228 2232 2228 2230 2232 2230 2233 2228 2229 2230 2229 2228 2241 4570 4586 2241 4570 2241 2240 2229 2241 4582 4582 2241 4586 4570 2240 4571 4569 4570 4571 4569 4586 4570 4568 4569 4571 4568 4571 4575 4567 4569 4568 4567 4586 4569 4566 4567 4568 4564 4566 4568 4564 4568 4562 4562 4568 4575 4562 4575 4563 505 4562 4563 4564 4562 505 4565 4564 505 4565 4566 4564 4565 4585 4566 4566 4585 4567 4567 4585 4586 4565 262 4585 4585 4578 4577 4585 4577 4586 4578 4585 4576 4576 4585 262 505 262 4565 4539 505 4555 4563 4555 505 4539 4555 4554 4563 4554 4555 262 261 263 262 263 264 264 265 262 262 265 266 262 266 267 267 271 262 262 271 272 262 272 273 4576 262 273 4543 271 267 4543 267 4547 4547 267 266 4540 272 271 4540 271 4543 273 272 274 4540 274 272 273 274 270 4576 273 270 4579 4578 4576 4576 270 4579 268 269 270 270 274 275 270 275 268 4579 270 269 268 275 4556 268 4556 4559 4583 269 268 4583 268 4559 4579 269 4583 4580 4579 4583 4580 4583 4584 4584 4583 4559 4559 4556 4560 4559 4560 4561 4584 4559 4561 2237 4580 4584 2237 4584 2236 2236 4584 4561 4561 4560 2222 2236 4561 2222 2236 2222 2221 2235 2237 2236 2235 2236 2238 2238 2236 2221 2234 2237 2235 2234 4580 2237 2233 2234 2235 2235 2623 2233 2235 2238 2623 2623 2238 2221 2623 2221 2624 2620 2623 2625 2625 2623 2624 2624 2221 2604 2624 2604 2602 2625 2624 2602 2602 2263 2625 2625 2263 2256 2625 2256 2620 2620 2256 2622 2256 2255 2622 2622 2255 2254 2251 2254 2255 2251 2255 2256 2249 2253 2254 2249 2254 2251 2248 2249 2250 2250 2249 2251 2249 2248 2641 2249 2641 4175 4175 4174 2249 2640 2641 2642 2641 2248 2643 2641 2643 2642 4175 2641 2640 4175 2648 4172 4175 2640 2648 4172 4174 4175 2640 2642 2648 2648 2642 2644 4163 2644 2642 4163 2642 2643 2248 4163 2643 4165 2644 4163 2248 4169 4163 4163 4169 4166 4163 4166 4165 2648 2644 2649 4172 2648 2649 4172 2649 2160 2160 2162 4176 4169 2628 4166 4166 2628 2630 4166 2630 2633 2626 2627 2628 2628 2627 2629 2628 2629 2630 4169 2626 2628 2629 2631 2630 2630 2631 2632 2630 2632 2633 2633 2632 2634 4158 4153 2632 2632 4153 2634 2631 4158 2632 2631 2629 4150 4150 4158 2631 4150 2629 2627 2626 2250 2627 4150 2627 2250 2250 4149 4150 4149 4157 4150 4150 4157 4158 4157 4156 4158 4158 4156 4153 4152 4155 4157 4157 4155 4156 4149 4152 4157 4151 4149 2250 4151 4152 4149 2611 2613 4152 2613 2605 4152 4152 2605 4155 4151 2611 4152 2609 4151 2250 2609 2611 4151 2609 2610 2611 2611 2610 2612 2611 2612 2613 2613 2612 2614 2613 2614 2605 2614 2612 4215 4215 2612 2610 2609 2251 2610 4215 2610 2251 2250 2251 2609 2248 2250 2626 2248 2626 4169 2244 2251 2242 2242 2251 2256 2590 2251 2244 2251 2590 4216 4216 4217 2251 4217 4215 2251 2244 2591 2590 2590 2591 2592 2590 2592 2593 4216 2590 2593 4216 2594 4213 4216 2593 2594 4213 4217 4216 4213 4212 4217 4212 4215 4217 2169 4210 4213 4213 2594 2596 4213 2596 2169 4210 4212 4213 4210 4211 4212 4211 4214 4212 4212 4214 4215 4214 2615 4215 4215 2615 2614 4211 4209 4214 4214 4209 2615 4210 4219 4211 4211 4219 4220 4211 4220 4209 4209 2165 2615 4209 4220 2163 4209 2163 2165 2605 2614 2615 2605 2615 2165 2163 2164 2165 2165 2164 2166 2165 2166 2167 2165 2167 2605 4343 2163 4344 4344 2163 4220 4343 2164 2163 4343 4355 2164 2166 2164 4367 4367 2164 4355 2167 2166 4369 4369 2166 4367 2605 2167 2606 4369 4375 2167 2167 4375 2606 4369 4367 4370 4370 4373 4369 4369 4373 4375 4367 4355 4368 4370 4367 4368 4370 4368 233 233 232 4370 4370 232 4373 232 239 4373 4373 239 4374 4373 4374 4375 4375 4374 4376 4375 4376 2606 239 238 4374 4374 238 4382 4374 4382 4376 234 238 239 234 239 232 232 233 234 234 233 235 233 4368 235 234 235 236 4368 4354 235 235 4354 236 489 490 236 236 490 491 236 491 234 489 236 4338 4338 236 4354 4317 4313 490 490 4313 491 490 489 4317 234 491 492 4312 492 491 4312 491 4313 4314 4312 4313 4314 4313 4315 4317 4315 4313 4311 492 4312 4310 4311 4312 4310 4312 4314 492 500 234 4311 500 492 4308 500 4311 4309 4308 4311 4309 4311 4310 234 500 501 4308 501 500 4306 4307 4308 4307 501 4308 4306 4308 4309 4228 4306 4309 4228 4309 4310 4227 4228 4224 4224 4228 4229 4227 4306 4228 4310 4229 4228 4224 4230 4227 4227 4230 2173 4227 2173 2172 4227 2172 4306 4235 2173 4230 4235 4230 4236 4236 4230 4224 2172 2173 2174 2174 2173 2175 2175 2173 2568 2568 2173 4235 2172 2174 4318 2172 4318 4306 2174 2175 4240 2174 4240 4318 2175 2568 2569 4240 2175 4241 2569 4241 2175 2569 2568 2570 2570 2568 4235 2569 2570 2571 2571 4250 2569 2569 4250 4241 4244 4245 4241 4241 4245 4246 4241 4246 4240 4250 4244 4241 2571 4248 4250 4248 4249 4250 4250 4249 4244 2243 4248 2576 2576 4248 2573 2573 4248 2571 2243 4251 4248 4248 4251 4249 2573 2574 2576 2576 2574 2243 2571 2572 2573 2572 2575 2573 2573 2575 2574 2574 2244 2243 2574 4233 2244 2574 2575 4233 2575 2572 4234 4233 2575 4234 2571 2570 2572 2572 2570 4234 4234 2570 4235 4234 4235 4239 4233 4234 4231 4231 4234 4239 4233 4231 2244 2244 4231 4232 4231 4239 4232 4239 4235 4236 4239 4236 4238 4232 4239 4238 2598 2592 4232 4232 2592 2591 4232 2591 2244 4232 4238 2598 2597 2594 2598 2598 2594 2592 2598 4238 2597 2593 2592 2594 2597 2596 2594 2595 2596 2597 2595 2597 4238 2595 2169 2596 2171 2169 2595 4238 4237 2595 2595 4237 4221 2595 4221 2171 2168 2169 2170 2170 2169 2171 2169 2168 4218 2169 4218 4210 2170 2171 4221 4221 4226 2170 2170 4226 4316 2168 2170 4320 4320 2170 4316 4320 4218 2168 4210 4218 4219 4346 4219 4218 4320 4346 4218 4320 4316 4321 4320 4321 4347 4347 4346 4320 4345 4219 4346 4347 4345 4346 4345 4220 4219 4344 4220 4345 4348 4344 4345 4348 4345 4347 4336 4348 4347 4336 4347 4322 4322 4347 4321 4321 4316 4322 4322 4316 4317 4322 4317 4323 4322 4323 4336 489 4335 4336 4336 4323 4324 4336 4324 489 4335 4348 4336 4341 4344 4348 4335 4341 4348 4337 4335 489 4337 4341 4335 4317 489 4324 4338 4337 489 4316 4315 4317 4317 4324 4323 4316 4226 4315 4226 4225 4315 4315 4225 4223 4315 4223 4314 4221 4225 4226 4224 4223 4225 4224 4225 4221 4222 4223 4224 4314 4223 4222 4314 4222 4310 4224 4229 4222 4310 4222 4229 4236 4224 4237 4237 4224 4221 4238 4236 4237 4338 4339 4337 4337 4339 4341 4338 4354 4339 4339 4340 4341 4339 4354 4340 4340 4342 4341 4341 4342 4344 4340 4354 4355 4340 4355 4342 4368 4355 4354 4342 4355 4343 4342 4343 4344 2242 2243 2244 2243 2242 2551 2243 2551 4251 2551 2242 2552 2551 2552 2553 4251 2551 2553 4251 2553 4249 2553 2552 2554 2553 2554 2548 4249 2553 2548 4258 2554 2552 4258 2552 2242 2548 2554 2555 2555 2554 4258 2548 2549 2550 2548 2555 2549 4249 2548 2550 2550 2177 4249 4249 2177 4244 2550 2549 2179 2550 2179 2177 2176 2177 2178 2178 2177 2179 2177 2176 4244 4242 4243 4244 4244 4243 4245 4244 2176 4247 4244 4247 4242 4331 4243 4242 4331 4242 4328 4328 4242 4247 4332 4245 4243 4332 4243 4331 4246 4245 4332 4331 4330 4332 4333 4246 4332 4333 4332 4334 4334 4332 4330 4328 4329 4331 4331 4329 4330 4329 499 4330 4334 4330 498 498 4330 499 4319 4333 4334 4319 4334 497 497 4334 498 497 498 289 289 498 499 289 499 493 4329 493 499 4327 493 4329 4328 4327 4329 493 494 289 4327 494 493 4326 4325 4327 4325 494 4327 4326 4327 4328 2176 4326 4328 4328 4247 2176 4351 4325 4326 4351 4326 4352 4352 4326 4353 4353 4326 2176 4353 2176 2178 4358 4353 2178 4358 4352 4353 4358 4351 4352 4350 4325 4351 4357 4350 4351 4357 4351 4358 4356 4357 4358 2178 4254 4358 4358 4254 4359 4358 4359 4356 4255 4254 2178 4255 2178 2179 4253 4252 4254 4253 4254 4255 4254 4252 4359 4360 4359 4361 4361 4359 4252 4356 4359 4360 2181 2180 4252 2181 4252 4253 4361 4252 2180 2181 4253 4256 4253 4255 4257 4253 4257 4256 4259 2531 4256 4256 2531 2530 4256 2530 2181 4256 4257 4258 4256 4258 4259 4257 4255 2549 4257 2549 4258 4258 2549 2555 4259 4258 2242 4255 2179 2549 2242 2256 2257 2505 2533 2242 2505 2242 2257 2242 2533 4259 2257 2256 2258 2505 2257 2258 2508 2507 2505 2505 2258 2508 2507 2533 2505 2507 2532 2533 4259 2533 2532 4259 2532 2531 2506 2531 2532 2506 2532 2507 2506 2507 2508 2511 2510 2506 2506 2508 2511 2510 2531 2506 2510 2530 2531 2509 2510 2511 2509 2530 2510 2511 2508 2512 2511 2512 2514 2509 2511 2185 2185 2511 2514 2185 2183 2509 2183 2181 2509 2509 2181 2530 2182 2181 2183 2182 2183 2184 2184 2183 2185 2180 2181 2182 2180 2182 4361 4361 2182 4371 2182 2184 4371 2186 2184 2185 2184 4380 4371 4380 2184 2186 2186 2185 2187 4380 2186 4384 4384 2186 2187 4371 4380 4381 4384 4381 4380 4378 4381 4384 4384 2187 4387 4378 4384 4385 4385 4384 4387 2187 2185 2188 2187 2188 2189 4387 2187 2189 4387 2189 4388 4385 4387 4390 4390 4387 4388 2189 2188 2190 2189 2190 2191 2191 4386 2189 4388 2189 4386 4388 4386 4389 4390 4388 4391 4391 4388 4389 4391 291 4390 4390 291 290 4390 290 4385 4391 4389 285 285 284 4391 4391 284 291 286 290 291 286 291 284 284 285 286 285 292 286 4389 4409 285 285 4409 292 286 292 293 4409 4406 292 292 4406 293 4408 4404 4409 4409 4404 4406 4389 4408 4409 4404 4405 4406 4406 4405 4407 4406 4407 293 286 293 294 293 4407 294 4405 4412 4407 4407 4412 4414 4407 4414 294 4404 2194 4405 2194 2199 4405 4405 2199 4412 2199 2200 4412 4412 2200 4413 4412 4413 4414 4414 4413 4415 4414 4415 295 294 4414 295 294 295 286 286 295 296 295 4415 296 4422 296 4415 4422 4415 4419 4419 4415 4413 4419 4413 2200 2450 2453 4419 2450 4419 2200 4418 4422 4419 4418 4419 2452 2452 4419 2453 297 296 4422 4421 297 4422 4421 4422 4418 286 296 297 297 298 286 298 297 4421 4418 4420 4421 4421 299 298 4421 4420 4434 299 4421 4435 4421 4434 4435 286 298 299 286 299 300 299 4435 300 4435 4434 4436 4435 4436 4437 300 4435 4437 4420 2467 4434 4434 2467 2472 4434 2472 4436 2472 2471 4436 4436 2471 2469 4436 2469 4429 4437 4436 4429 4437 4429 4432 300 4437 301 301 4437 4432 300 301 286 286 301 302 301 4432 302 4430 4431 4432 4432 4429 4428 4432 4428 4430 302 4432 4431 286 302 303 4433 303 302 302 4431 4433 4430 4447 4431 4431 4447 4433 4428 4446 4430 4430 4446 4447 4427 4428 4429 4427 4446 4428 4427 2491 4446 4444 4447 4446 4444 4446 2492 2492 4446 2491 2463 2462 2491 2491 2462 2489 2491 2489 2492 2463 2491 4427 2492 2489 2493 2492 2493 2494 2492 2494 4444 2494 2493 2495 2495 2493 2496 2489 2498 2493 2493 2498 2499 2493 2499 2496 4444 2494 2495 2495 2496 2497 4444 2495 2497 2501 2497 2502 2502 2497 2496 4445 4444 2497 4445 2497 2501 2501 2502 2518 2518 4453 2501 4453 4445 2501 2502 2496 2503 2503 2517 2502 2518 2502 2517 2518 2517 2519 2518 2519 4453 2503 2516 2517 2519 2517 2520 2516 2525 2517 2517 2525 2521 2517 2521 2520 2503 2496 2504 2504 2516 2503 2496 2499 2500 2496 2500 2504 2500 2516 2504 2499 2277 2500 2277 2280 2500 2500 2280 2516 2498 2275 2499 2499 2275 2277 2275 2276 2277 2276 2278 2277 2277 2278 2279 2277 2279 2280 2280 2279 2281 2280 2281 2282 2280 2282 2516 2588 2281 2279 2588 2279 2587 2587 2279 2278 2282 2281 2283 2589 2283 2281 2589 2281 2588 2587 2585 2588 2588 2585 2586 2588 2586 2589 2581 2584 2587 2587 2584 2585 2587 2278 2581 2584 2213 2585 2585 2213 2205 2585 2205 2586 2586 2205 2567 2586 2567 2560 2589 2586 2560 2205 2206 2207 2206 2205 2212 2212 2205 2213 2205 2207 2567 2567 2207 2558 2567 2558 2560 2207 2206 2208 2207 2208 2209 2558 2207 2556 2556 2207 2209 4529 2208 2206 2212 4529 2206 2212 2213 2214 2214 4550 2212 2212 4550 4529 4527 4528 4529 4529 4528 2208 4550 4527 4529 4549 4548 4550 4550 4548 4527 2214 4549 4550 2214 2213 2215 2214 2215 2216 2216 4549 2214 4546 4547 4549 4549 4547 4548 2216 4546 4549 4547 266 4548 4548 266 265 4548 265 4527 4546 4543 4547 4541 4542 4543 4543 4542 4540 4541 4543 4546 4546 4545 4541 4545 4557 4541 4541 4557 4558 4541 4558 4542 4542 4558 4540 4540 4558 274 4556 274 4558 4556 4558 4560 4560 4558 4557 4557 4545 4544 4560 4557 2220 2220 4557 4544 4544 4545 4546 2216 2218 4544 4544 4546 2216 2220 4544 2218 2216 2215 2217 2216 2217 2218 2218 2217 2219 2220 2218 2219 2577 2219 2217 2577 2217 2580 2580 2217 2215 2580 2215 2584 2584 2215 2213 2578 2579 2580 2580 2579 2577 2578 2580 2581 2581 2580 2584 2581 2582 2578 2578 2582 2600 2578 2600 2579 2577 2579 2599 2579 2600 2599 2582 2274 2600 2600 2274 2259 2600 2259 2601 2599 2600 2601 2581 2583 2582 2583 2274 2582 2581 2278 2583 2278 2276 2583 2583 2276 2274 2273 2259 2274 2273 2274 2275 2275 2274 2276 2260 2259 2273 2490 2260 2273 2490 2273 2498 2498 2273 2275 2259 2260 2261 2480 2261 2260 2480 2260 2490 2261 2266 2259 2266 2261 2480 2479 2266 2480 2479 2480 2477 2490 2477 2480 2259 2266 2267 2481 2267 2266 2481 2266 2479 2259 2267 2247 2601 2259 2247 2247 2267 2268 2465 2268 2267 2465 2267 2481 2479 2470 2481 2481 2470 2466 2481 2466 2465 2465 2457 2245 2465 2466 2461 2465 2461 2457 2245 2268 2465 2247 2268 2245 2245 2246 2247 2456 2246 2245 2456 2245 2457 2461 2456 2457 2460 2456 2461 2466 2460 2461 2449 2455 2456 2449 2456 2451 2455 2246 2456 2460 2451 2456 2247 2246 2264 2264 2246 2265 2455 2265 2246 2448 2454 2455 2448 2455 2449 2454 2265 2455 2264 2265 2262 2454 2262 2265 2262 2263 2264 2247 2264 2602 2602 2264 2263 2601 2247 2602 2603 2601 2602 2603 2602 2604 2599 2601 2603 2225 2599 2603 2225 2603 2223 2223 2603 2604 2223 2604 2221 2221 2222 2223 2223 2222 2224 2223 2224 2225 4560 2224 2222 2224 2226 2225 4560 2226 2224 2220 2226 4560 2225 2226 2220 2225 2220 2227 2227 2599 2225 2227 2577 2599 2227 2220 2219 2219 2577 2227 2262 2269 2263 2263 2269 2270 2263 2270 2256 2485 2269 2262 2485 2262 2454 2484 2270 2269 2484 2269 2485 2256 2270 2271 2482 2271 2270 2482 2270 2484 2486 2482 2484 2486 2484 2487 2487 2484 2485 2487 2485 2488 2488 2485 2454 2488 2454 2448 2197 2487 2488 2197 2488 2195 2195 2488 2448 2192 2486 2487 2192 2487 2197 2195 2196 2197 2197 2196 2198 2197 2198 2192 2193 2194 2195 2195 2194 2196 2195 2448 2193 2193 2448 2200 2200 2448 2449 2194 2193 2199 2199 2193 2200 2196 2194 4404 2198 2196 4408 4408 2196 4404 4386 2198 4408 4386 4408 4389 2191 2198 4386 2191 2190 2192 2192 2198 2191 2188 2515 2190 2190 2515 2486 2190 2486 2192 2185 2514 2188 2188 2514 2515 2514 2513 2515 2515 2513 2483 2515 2483 2486 2483 2482 2486 2482 2483 2272 2513 2272 2483 2512 2287 2513 2513 2287 2272 2514 2512 2513 2256 2271 2272 2272 2287 2256 2272 2271 2482 2256 2287 2288 2512 2288 2287 2508 2288 2512 2256 2288 2258 2508 2258 2288 2200 2449 2450 2451 2452 2449 2449 2452 2453 2449 2453 2450 2459 2452 2451 2459 2451 2460 2458 2452 2459 2452 2458 4418 2460 2466 2459 2459 2466 2467 2459 2467 2458 2458 4420 4418 4420 2458 2467 2466 2472 2467 2470 2471 2466 2466 2471 2472 2468 2469 2470 2470 2469 2471 2468 2470 2464 2464 2470 2473 2479 2473 2470 4429 2469 2468 4429 2468 4427 4427 2468 2464 2462 2463 2464 2464 2473 2462 4427 2464 2463 2473 2476 2462 2476 2489 2462 2473 2475 2476 2476 2475 2489 2475 2490 2489 2489 2490 2498 2474 2475 2473 2475 2474 2490 2490 2474 2478 2490 2478 2477 2479 2478 2474 2474 2473 2479 2477 2478 2479 275 274 4556 265 4526 4527 4527 4526 4528 265 264 4526 4523 4528 4526 4523 4526 263 263 4526 264 4512 2208 4528 4512 4528 4523 4522 4512 4523 261 4522 4523 261 4523 263 2210 4512 4513 4522 4513 4512 2210 2208 4512 2209 2208 2210 2209 2210 2211 2211 2210 4274 4274 2210 4280 4513 4280 2210 2556 2209 2566 2566 2209 2211 2211 4274 4282 4282 2566 2211 4282 2556 2566 2556 2557 2558 2557 2556 4282 2565 2558 2557 2557 4282 2565 2565 4282 4285 4284 4285 4282 4284 4282 4283 4283 4282 4274 2564 2558 2565 4281 2564 2565 2565 4285 4281 2564 2563 2558 2560 2558 2563 2562 2563 2564 4281 2562 2564 2560 2563 2561 2561 2563 2562 2559 2285 2560 2559 2560 2561 2589 2560 2285 4288 2559 2561 4288 2561 4281 4281 2561 2562 2286 2285 2559 2286 2559 4288 2284 2283 2285 2284 2285 2286 2285 2283 2589 2545 2284 2286 2547 2545 2286 4287 2547 2286 2286 4288 4287 4287 4288 4281 4286 2540 4287 4287 2540 2547 4287 4281 4286 2540 2545 2547 2540 2546 2545 2284 2545 4303 4303 2545 2546 2538 2539 2540 2540 2541 2538 2539 2546 2540 4286 2541 2540 4303 2546 4304 4304 2546 2539 2284 4303 4296 4296 4303 4304 4296 4304 4297 4297 4304 4305 4304 2539 4305 4305 2539 2538 4297 4305 4302 4302 4305 4301 4305 2538 4301 2527 4296 4297 4302 2526 4297 4297 2526 2528 4297 2528 2527 2284 4296 2527 2282 2284 2527 2282 2527 2525 2525 2527 2528 2525 2528 2526 2524 2525 2526 4302 2524 2526 2524 2521 2525 2516 2282 2525 2282 2283 2284 2521 2522 2523 2522 2521 2524 2520 2521 2523 2522 2524 4302 4299 2523 2522 4299 2522 4302 2520 2523 2529 4298 2529 2523 4298 2523 4299 2520 2529 4452 4452 4453 2520 2520 4453 2519 4298 4452 2529 4299 4300 4298 4462 4452 4298 4300 4462 4298 4455 4454 4452 4452 4454 4453 4462 4455 4452 4454 4443 4453 4453 4443 4445 240 306 4454 4454 306 4443 4455 240 4454 241 240 4455 4461 241 4455 4461 4455 4462 240 241 242 242 308 240 240 308 309 240 309 306 242 241 243 243 241 4461 4463 243 4461 4463 4461 4460 4460 4461 4462 242 243 244 244 243 4463 4460 4472 4463 4463 4472 4473 4463 4473 244 244 245 242 244 4473 245 4472 4468 4473 4473 4468 4470 4473 4470 245 4289 4291 4472 4472 4291 4468 4460 4289 4472 4291 4293 4468 4293 4295 4468 4468 4295 4469 4468 4469 4470 4470 4469 4471 4470 4471 246 245 4470 246 242 245 246 242 246 247 247 246 248 248 246 254 254 246 255 246 4471 255 247 5034 242 242 5034 5035 242 5035 308 248 5031 247 247 5031 5034 248 5029 5031 254 5029 248 5042 5029 254 5029 5028 5030 5029 5030 5031 5042 5028 5029 5031 5030 5032 5031 5032 5034 5028 3898 5030 5030 3898 3900 5030 3900 5032 5028 1761 3898 5041 1761 5028 5041 5028 5042 1761 1760 3898 3898 1760 3899 3898 3899 3900 3900 3899 3901 5032 3900 3901 5032 3901 5033 5034 5032 5033 3901 3899 3902 3901 3902 5033 3902 3899 3903 3908 3903 3899 3899 1760 3908 1759 1760 1761 1759 1761 5041 3902 3903 3904 1653 1652 3903 3903 1652 3905 3903 3905 3904 5033 3902 3904 5033 3904 5027 5027 3904 3905 5027 3905 1652 1652 1653 1654 1652 1654 4991 1652 4991 5016 1652 5016 5027 1654 1653 1655 1654 1655 3880 4991 1654 3880 4992 4991 4993 4991 3880 4993 5016 4991 4992 5016 4992 5017 5036 5027 5016 5036 5016 5017 311 4992 4994 4992 4993 4994 5017 4992 311 4993 3880 3882 4993 3882 4995 4994 4993 4995 4994 4995 4999 311 4994 279 279 4994 4999 278 310 311 278 311 279 5017 311 310 279 280 278 279 4999 280 4999 4995 4996 4999 4996 5000 280 4999 5000 4995 3882 3887 4995 3887 4996 3887 3886 4996 4996 3886 3884 4996 3884 4997 5000 4996 4997 5000 4997 5001 280 5000 323 323 5000 5001 280 323 278 278 323 324 323 5001 324 5001 4997 4998 5001 4998 5002 324 5001 5002 3884 3883 4997 4997 3883 3888 4997 3888 4998 4998 3888 3890 4998 3890 4990 5002 4998 4990 5002 4990 5003 324 5002 276 276 5002 5003 278 324 276 304 305 278 278 305 306 286 304 278 286 278 283 306 310 278 306 305 4442 305 304 4442 306 309 310 306 4442 4443 309 5017 310 308 5036 309 309 5036 5017 308 5035 5036 5035 5027 5036 5034 5033 5035 5035 5033 5027 4443 4442 4444 4443 4444 4445 4442 4447 4444 4433 4447 304 4442 304 4447 4433 304 303 303 304 286 289 290 286 717 286 706 706 286 283 717 721 286 721 289 286 289 288 290 290 288 4377 4385 290 4377 287 288 289 288 287 4377 4377 287 4372 4372 4379 4377 4385 4377 4379 4385 4379 4378 4372 4378 4379 4371 4378 4372 4371 4381 4378 4361 4371 4360 4360 4371 4362 4362 4371 4372 4356 4360 4362 4365 4356 4362 4362 4372 4365 4364 4357 4356 4364 4356 4365 4365 4366 4364 4365 4372 4366 4363 4357 4364 4364 496 4363 4364 4366 496 4363 4349 4357 4349 4350 4357 496 4349 4363 287 495 496 496 495 4349 4366 287 496 4366 4372 287 289 495 287 289 494 495 4325 495 494 4349 495 4325 4349 4325 4350 234 501 289 289 501 502 289 502 497 721 234 289 225 238 234 225 234 719 719 234 721 720 719 721 755 720 721 763 755 721 763 721 717 718 719 720 718 225 719 720 755 768 718 720 768 718 768 780 768 755 764 768 764 769 780 768 769 780 769 781 787 780 781 769 764 766 769 766 650 781 769 650 755 757 764 764 757 765 764 765 766 766 765 767 766 767 652 650 766 652 779 767 765 759 779 765 759 765 757 755 756 757 757 756 758 757 758 759 758 779 759 778 770 779 779 770 767 758 778 779 760 758 761 761 758 756 760 778 758 761 756 762 762 756 755 762 755 763 762 772 773 762 773 761 762 763 772 761 773 777 761 777 760 760 777 778 773 775 777 777 775 776 777 776 778 772 774 773 773 774 775 772 771 774 772 763 782 772 782 771 763 717 782 782 717 783 782 783 784 771 782 784 771 658 722 774 771 722 771 784 658 774 722 775 658 660 722 722 660 723 722 723 724 775 722 724 658 659 660 658 784 659 784 783 785 784 785 659 660 659 661 659 785 661 783 791 785 785 791 572 785 572 661 660 661 662 662 661 572 853 723 660 853 660 854 854 660 662 854 662 855 1058 1057 854 854 1057 853 1058 854 1059 1059 854 855 662 883 855 1059 855 883 1059 1060 1058 1059 1053 1060 1053 1059 883 1056 1057 1058 1058 1060 1061 1058 1061 1056 853 1057 1056 1061 1220 1056 1056 1220 852 1056 852 853 1218 1219 1220 1220 1221 1218 1220 1219 852 1061 1221 1220 852 1219 1218 851 639 852 852 646 853 1218 851 852 644 639 851 851 856 644 1218 856 851 643 639 644 643 644 569 569 644 645 644 856 857 644 857 645 1223 857 856 1223 856 1218 857 860 645 1225 860 857 1225 857 1223 569 645 640 645 860 861 645 861 640 861 860 1225 1223 1224 1225 1224 1228 1225 1228 861 1225 1218 1222 1223 1223 1222 1224 1218 1221 1222 1222 1177 1224 1061 1177 1222 1222 1221 1061 1177 1178 1179 1224 1177 1179 1061 1178 1177 1178 1314 1179 1314 1178 1061 1179 1314 1299 1179 1299 1279 1224 1179 1259 1259 1179 1279 1314 1316 1299 1061 1316 1314 1299 1284 1300 1279 1299 1300 1299 1316 1317 1299 1317 1284 1061 1317 1316 1284 1317 1318 1318 1317 1061 1284 1280 1285 1300 1284 1285 1284 1318 1280 1300 1285 1301 1279 1300 1278 1278 1300 1301 1285 1280 1182 1285 1182 1286 1301 1285 1286 1280 1281 1182 1280 1318 1319 1280 1319 1281 1061 1319 1318 1281 1319 1320 1061 1320 1319 1060 1113 1061 1113 1303 1061 1061 1303 1315 1315 1320 1061 1281 1320 1315 1315 1303 1281 1303 1304 1305 1281 1303 1305 1119 1304 1303 1119 1303 1118 1109 1303 1114 1114 1303 1115 1109 1104 1303 1303 1104 1103 1303 1103 1125 1125 1124 1303 1303 1124 1123 1303 1123 1118 1113 1112 1303 1303 1112 1111 1303 1111 1110 1110 1117 1303 1303 1117 1116 1303 1116 1115 1060 1112 1113 1077 1111 1112 1077 1112 1060 1110 1111 1077 1117 1110 992 992 1110 1077 992 1116 1117 992 1115 1116 991 1114 1115 991 1115 992 991 992 993 993 992 1078 992 1077 1078 1060 1050 1077 1078 1077 1050 1060 1053 1050 1053 1054 1050 883 882 1053 1053 882 881 1053 881 1054 662 882 883 657 881 882 657 882 663 663 882 662 656 880 881 656 881 657 1054 881 880 572 656 657 663 572 657 662 572 663 571 572 573 573 572 574 572 571 654 654 655 572 572 655 656 572 791 803 572 803 574 655 880 656 878 655 877 877 655 654 878 879 655 655 879 880 877 654 571 877 571 850 1054 878 877 1054 877 1055 1055 877 850 879 878 1054 1054 880 879 1050 1054 1055 1050 1055 1051 1055 850 1051 1050 1051 1047 1078 1050 1079 1079 1050 1047 1047 1051 1052 850 874 1051 1051 874 875 1051 875 1052 1047 1052 1048 1052 875 876 1052 876 1048 1047 1048 1044 1044 1048 1049 1048 876 872 1048 872 1049 875 579 876 876 579 586 876 586 872 579 580 581 579 581 586 875 580 579 586 581 587 586 587 588 872 586 588 588 587 589 581 828 587 587 828 829 587 829 589 588 589 590 872 588 590 589 595 590 590 595 872 589 594 595 872 595 594 593 592 594 593 594 589 872 594 592 592 598 872 872 598 597 872 597 873 1049 872 873 591 592 593 591 598 592 591 597 598 596 597 591 873 597 596 873 596 869 1049 873 1045 1045 873 869 1044 1049 1045 1044 1045 1041 1041 1045 1046 1045 869 1046 1080 1047 1044 1080 1044 1091 1091 1044 1041 1079 1080 1081 1090 1081 1080 1090 1080 1091 1079 1047 1080 1101 1090 1091 1101 1091 1102 1102 1091 1041 1089 1081 1090 1100 1089 1090 1100 1090 1101 1089 988 1081 1079 1081 1106 1106 1081 988 1106 1078 1079 1106 988 1107 1107 993 1106 1106 993 1078 988 989 990 989 988 1089 1107 988 990 1107 990 1105 1105 991 1107 1107 991 993 1105 990 1108 1075 1108 990 1075 990 1098 1098 990 989 1098 989 1099 1099 989 1089 1097 1075 1098 1097 1098 1096 1096 1098 1099 1096 1099 1095 1095 1099 1100 1099 1089 1100 1095 1086 1096 1096 1086 1087 1096 1087 1097 1097 1087 1088 1097 1088 1076 1076 1075 1097 1086 987 1087 1087 987 1069 1087 1069 1088 1085 985 1086 1086 985 987 1095 1085 1086 985 986 987 1069 987 1070 1070 987 986 1064 1088 1069 1064 1069 1063 1063 1069 1070 1070 986 1071 1063 1070 1062 1062 1070 1071 1082 1071 986 1082 986 1083 1083 986 985 1009 1071 1082 1062 1071 1005 1005 1071 1009 1005 996 1062 1062 996 1002 1062 1002 1063 932 1001 1002 932 1002 933 933 1002 914 914 1002 996 1063 1002 1001 929 932 911 911 932 933 929 1001 932 911 933 914 914 915 911 914 996 915 915 916 911 915 996 916 911 916 917 916 996 995 916 995 917 994 995 996 918 917 995 918 995 934 934 995 1159 1159 995 994 1005 994 996 1004 994 1005 1159 994 1176 1176 994 1004 1003 1004 1005 1003 1005 1006 1005 1009 1006 1176 1004 1003 1006 1176 1003 1006 1175 1176 1175 1147 1176 1176 1147 1146 1176 1146 1159 1006 1009 1008 1006 1008 1007 1007 1175 1006 1007 1008 1009 1082 1015 1009 1009 1015 1017 1009 1017 1007 1017 1175 1007 1015 1016 1017 1016 1174 1017 1017 1174 1175 1012 1014 1015 1015 1014 1016 1082 1012 1015 1083 1012 1082 983 1011 1012 1011 1013 1012 1012 1013 1014 1083 983 1012 1013 1173 1014 1014 1173 1174 1014 1174 1016 1011 1173 1013 983 1010 1011 1010 1172 1011 1011 1172 1173 1172 1154 1173 1173 1154 1153 1173 1153 1174 1010 1171 1172 1171 1155 1172 1172 1155 1154 983 1021 1010 1021 1171 1010 1020 1170 1171 1020 1171 1021 1170 1156 1171 1171 1156 1155 1129 1154 1155 1155 1156 1129 1129 1153 1154 1148 1153 1129 1174 1153 1148 1129 1147 1148 1174 1148 1175 1175 1148 1147 1129 1146 1147 910 1146 1129 910 909 1146 1146 909 938 1146 938 937 1159 1146 937 934 1159 935 935 1159 936 1159 937 936 911 934 935 911 935 936 936 937 911 911 937 938 7427 7435 937 7435 9763 937 937 9763 9764 937 9764 7427 7427 938 7435 7435 938 9761 9761 9762 7435 7435 9762 9763 9764 9763 9787 9787 9763 9762 7427 9764 9765 9787 9765 9764 7427 9765 7426 7426 9765 9766 9787 9766 9765 7426 7424 7427 7426 934 7424 7426 9757 934 7426 9766 9757 9757 9766 9787 934 9757 7439 9760 7439 9757 9787 9760 9757 918 934 911 7424 934 7439 7424 7439 7407 7407 7439 7440 9759 7440 7439 9759 7439 9760 9787 9759 9760 9758 7440 9759 9758 9759 9787 7407 7440 7436 9758 7436 7440 9756 7436 9758 9787 9756 9758 7436 7437 7407 9756 7437 7436 9755 7438 9756 7438 7437 9756 9787 9755 9756 7407 7437 7438 7407 7438 7432 9755 7432 7438 9754 7432 9755 9754 9755 9787 7432 7433 7407 9754 7433 7432 9753 7433 9754 9787 9753 9754 7407 7433 7434 9753 7434 7433 9752 7434 9753 9787 9752 9753 7407 7434 7406 9752 7406 7434 9751 7406 9752 9751 9752 9787 7406 917 7407 9751 917 7406 9751 9773 917 9787 9773 9751 911 917 918 7407 917 7421 7421 917 7431 917 9773 9772 7421 7431 7423 7420 7419 7421 7420 7421 7422 7422 7421 7423 7421 7762 7763 7304 7301 7421 7421 7301 7324 7421 7324 7069 7069 7068 7421 7421 7068 7764 7421 7764 7765 7765 7766 7421 7421 7766 7767 7421 7767 7762 7763 7768 7421 7421 7768 7769 7421 7769 7770 7772 7407 7421 7772 7421 7773 7773 7421 7770 7419 7313 7421 7421 7313 7311 7421 7311 7304 7774 7772 7773 7774 7773 7770 7770 7769 7774 8289 7769 8290 8290 7769 7768 8289 8292 7769 7769 8292 8293 7769 8293 8294 8294 8295 7769 7769 8295 8296 7769 8296 8297 8297 8298 7769 7769 8298 8299 7769 8299 7774 9776 8295 8294 9776 8294 8293 9779 8296 8295 9779 8295 9776 9774 8297 8296 9774 8296 9779 8298 8297 9774 8324 8299 8298 8324 8298 9774 8299 8300 7774 8300 8299 8324 8325 8300 8324 9774 8325 8324 7774 8300 8301 8316 8301 8300 8321 8316 8300 8321 8300 8325 8325 8326 8321 9774 8326 8325 8321 8326 8327 8327 8326 9774 8321 8327 8319 8319 8327 8317 8317 8327 9777 9777 8327 9774 8317 8318 8319 8319 8318 8320 8319 8320 8321 8317 9783 8318 8310 9783 8317 8310 8317 9787 9787 8317 9777 9777 9774 9778 9787 9777 9778 9787 9762 8310 9787 9778 9780 9787 9780 9773 9778 9774 9779 9778 9779 9780 9780 9779 9776 9780 9776 9781 9773 9780 9781 9776 8293 9775 9781 9776 9775 9781 9775 9782 9773 9781 9782 9775 8328 8990 9775 8293 8329 9775 8329 8328 9782 9775 8990 8293 8292 8329 8328 8329 8330 8289 8330 8329 8289 8329 8292 8330 8990 8328 8988 8989 8990 8330 8988 8990 9782 8990 8989 9782 8989 9773 8988 8987 8989 9773 8989 8987 8986 8987 8988 8999 8986 8988 8999 8988 8330 8290 8999 8330 8290 8330 8289 8998 8986 8999 8291 8998 8999 8291 8999 8290 8984 8985 8986 8986 8985 8987 8998 8984 8986 8987 8985 9773 8984 8983 8985 9773 8985 8983 8982 8983 8984 8997 8982 8984 8997 8984 8998 8282 8997 8998 8282 8998 8291 8290 7768 8291 8291 7768 8282 8281 8282 7768 8281 8997 8282 8996 8982 8997 8281 8996 8997 8980 8981 8982 8982 8981 8983 8996 8980 8982 9773 8983 8981 8980 8979 8981 8981 8979 9773 8978 8979 8980 8995 8978 8980 8995 8980 8996 8283 8995 8996 8283 8996 8281 8281 7768 8283 7768 8288 8283 8288 8995 8283 8994 8978 8995 8288 8994 8995 8976 8977 8978 8978 8977 8979 8994 8976 8978 8979 8977 9773 8976 8975 8977 9773 8977 8975 9773 8975 9772 8974 8973 8975 8974 8975 8976 9772 8975 8973 8993 8974 8976 8993 8976 8994 8287 8993 8994 8287 8994 8288 7768 8287 8288 8286 8287 7768 8286 8993 8287 8992 8974 8993 8286 8992 8993 8972 8973 8974 8992 8972 8974 8972 8971 8973 9772 8973 8971 8970 8971 8972 8991 8970 8972 8991 8972 8992 8285 8991 8992 8285 8992 8286 7768 8285 8286 7768 8284 8285 8284 8991 8285 8915 8970 8991 8284 8915 8991 8968 8969 8970 8970 8969 8971 8915 8968 8970 8971 8969 9772 8968 8967 8969 9772 8969 8967 8966 8967 8968 8914 8966 8968 8914 8968 8915 8966 8965 8967 9772 8967 8965 8964 8965 8966 8913 8964 8966 8913 8966 8914 8215 8913 8914 8215 8914 8216 8216 8914 8915 8214 8912 8913 8214 8913 8215 8912 8964 8913 8962 8963 8964 8964 8963 8965 8912 8962 8964 8963 9772 8965 8962 8961 8963 8963 8961 9772 8960 8961 8962 8911 8960 8962 8911 8962 8912 8227 8911 8912 8227 8912 8214 8226 8910 8911 8226 8911 8227 8910 8960 8911 8958 8959 8960 8960 8959 8961 8910 8958 8960 8961 8959 9772 8958 8957 8959 9772 8959 8957 8956 8957 8958 8909 8956 8958 8909 8958 8910 8225 8909 8910 8225 8910 8226 8224 8908 8909 8224 8909 8225 8908 8956 8909 8954 8955 8956 8956 8955 8957 8908 8954 8956 9772 8957 8955 8954 8953 8955 8953 9772 8955 8952 8953 8954 8907 8952 8954 8907 8954 8908 8223 8907 8908 8223 8908 8224 8222 8906 8907 8222 8907 8223 8906 8952 8907 8950 8951 8952 8952 8951 8953 8906 8950 8952 8953 8951 9772 8950 8949 8951 8951 8949 9772 8948 8949 8950 8905 8948 8950 8905 8950 8906 8221 8905 8906 8221 8906 8222 8220 8221 8222 8222 8223 8220 8220 8223 8224 8220 8224 7763 8224 8225 7763 7763 8225 8226 7763 8226 7768 7763 7762 8220 7768 8226 8227 7768 8227 8214 8214 8215 7768 7768 8215 8216 7768 8216 8217 8217 8284 7768 8216 8915 8217 8217 8915 8284 8218 8219 8220 8220 8219 8221 8230 8232 8220 8220 8232 8233 8220 8233 8218 8220 7762 7767 8220 7767 8230 8219 8905 8221 8219 8904 8905 8904 8948 8905 8218 8903 8904 8218 8904 8219 8903 8946 8904 8904 8946 8948 8946 8947 8948 8948 8947 8949 8944 8945 8946 8946 8945 8947 8903 8944 8946 9772 8949 8947 9772 8947 8945 8944 8943 8945 8943 9772 8945 8942 8943 8944 8902 8942 8944 8902 8944 8903 8942 8941 8943 8943 8941 9772 8940 8941 8942 8901 8940 8942 8901 8942 8902 8232 8901 8902 8232 8902 8233 8233 8902 8903 8231 8900 8901 8231 8901 8232 8900 8940 8901 8230 8231 8232 8229 8231 8230 8229 8900 8231 8229 8899 8900 8899 8938 8900 8900 8938 8940 8228 8229 8230 8228 8899 8229 8228 8898 8899 8898 8936 8899 8899 8936 8938 8936 8937 8938 8938 8937 8939 8938 8939 8940 8934 8935 8936 8936 8935 8937 8898 8934 8936 9772 8939 8937 9772 8937 8935 8940 8939 8941 8941 8939 9772 8916 8856 9772 9772 8856 8854 8854 8852 9772 9772 8852 8850 9772 8850 8848 8848 8846 9772 9772 8846 8844 9772 8844 8842 8842 8840 9772 9772 8840 8838 9772 8838 7423 8923 8921 9772 8923 9772 8925 8933 8931 9772 8933 9772 8935 8931 8929 9772 9772 8929 8927 9772 8927 8925 8921 8919 9772 9772 8919 8917 9772 8917 8916 8934 8933 8935 8932 8933 8934 8897 8932 8934 8897 8934 8898 8930 8931 8932 8932 8931 8933 8896 8930 8932 8896 8932 8897 8243 8896 8897 8243 8897 8244 8244 8897 8898 8244 8898 8228 8230 8243 8244 8230 8244 8228 8236 8242 8243 8236 8243 8230 8242 8896 8243 8242 8895 8896 8895 8930 8896 8235 8242 8236 8235 8895 8242 8235 8894 8895 8894 8928 8895 8895 8928 8930 8234 8235 8236 8234 8894 8235 8234 8893 8894 8893 8926 8894 8894 8926 8928 8926 8927 8928 8928 8927 8929 8928 8929 8930 8930 8929 8931 8926 8925 8927 8924 8925 8926 8893 8924 8926 8924 8923 8925 8922 8923 8924 8892 8922 8924 8892 8924 8893 8922 8921 8923 8920 8921 8922 8891 8920 8922 8891 8922 8892 8240 8891 8892 8240 8892 8241 8241 8892 8893 8238 8890 8891 8238 8891 8240 8890 8920 8891 8238 8240 8236 8236 8240 8241 8236 8241 8234 8241 8893 8234 8237 8238 8236 8237 8236 8239 8247 8250 8236 8236 8250 8251 8236 8251 8239 8236 7764 8247 7767 7766 8236 8236 7766 7765 8236 7765 7764 8230 7767 8236 8250 8887 8251 8251 8887 8888 8251 8888 8239 8250 8886 8887 8886 8853 8887 8887 8853 8855 8887 8855 8888 8239 8888 8889 8888 8855 8857 8888 8857 8889 8853 8854 8855 8855 8854 8856 8855 8856 8857 8856 8916 8857 8857 8916 8917 8857 8917 8918 8889 8857 8918 8918 8917 8919 8918 8919 8920 8889 8918 8890 8890 8918 8920 8920 8919 8921 8237 8889 8890 8237 8890 8238 8239 8889 8237 8853 8852 8854 8851 8852 8853 8886 8851 8853 8851 8850 8852 8849 8850 8851 8885 8849 8851 8885 8851 8886 8249 8885 8886 8249 8886 8250 8246 8884 8885 8246 8885 8249 8884 8849 8885 8847 8848 8849 8849 8848 8850 8884 8847 8849 8245 8883 8884 8245 8884 8246 8883 8847 8884 8245 8246 8247 8246 8249 8247 8247 8249 8250 8245 8247 8248 8254 8261 8247 8247 8261 8262 8247 8262 8248 8247 7764 7068 8247 7068 8254 8248 8883 8245 8262 8882 8248 8248 8882 8883 8261 8881 8262 8262 8881 8882 8254 8260 8261 8260 8880 8261 8261 8880 8881 8880 8841 8881 8881 8841 8843 8881 8843 8882 8882 8843 8845 8882 8845 8883 8841 8842 8843 8843 8842 8844 8843 8844 8845 8839 8840 8841 8841 8840 8842 8880 8839 8841 8837 8838 8839 8839 8838 8840 8879 8837 8839 8879 8839 8880 8835 8836 8837 8837 8836 8838 8878 8835 8837 8878 8837 8879 7423 8838 8836 8835 8834 8836 7423 8836 8834 8833 8834 8835 8877 8833 8835 8877 8835 8878 8258 8877 8878 8258 8878 8259 8259 8878 8879 8257 8876 8877 8257 8877 8258 8876 8833 8877 8831 8832 8833 8833 8832 8834 8876 8831 8833 8834 8832 7423 8831 8830 8832 7423 8832 8830 8829 8830 8831 8875 8829 8831 8875 8831 8876 8256 8875 8876 8256 8876 8257 8256 8257 8254 8254 8257 8258 8254 8255 8256 8255 8875 8256 8255 8874 8875 8874 8829 8875 8827 8828 8829 8829 8828 8830 8874 8827 8829 7423 8830 8828 8827 8826 8828 8828 8826 7423 8825 8826 8827 8873 8825 8827 8873 8827 8874 8253 8873 8874 8253 8874 8255 8254 8253 8255 8252 8253 8254 8252 8873 8253 8252 8872 8873 8872 8825 8873 8823 8824 8825 8825 8824 8826 8872 8823 8825 8826 8824 7423 8823 8822 8824 7423 8824 8822 8821 8822 8823 8871 8821 8823 8871 8823 8872 8269 8871 8872 8269 8872 8252 8254 8269 8252 8254 8268 8269 8268 8871 8269 8268 8870 8871 8870 8821 8871 8819 8820 8821 8821 8820 8822 8870 8819 8821 7423 8822 8820 8819 8818 8820 8820 8818 7423 8817 8818 8819 8869 8817 8819 8869 8819 8870 8267 8869 8870 8267 8870 8268 8263 8868 8869 8263 8869 8267 8868 8817 8869 8815 8816 8817 8817 8816 8818 8868 8815 8817 7423 8818 8816 8815 8814 8816 7423 8816 8814 8813 8814 8815 8867 8813 8815 8867 8815 8868 8265 8867 8868 8265 8868 8263 8263 8264 8265 8263 8267 8264 8264 8267 8268 8264 8268 8254 8254 8258 8259 8259 8260 8254 7068 7067 8254 8254 7067 7334 8254 7334 8264 8259 8879 8260 8260 8879 8880 8265 8264 8266 8272 8279 8264 8264 8279 8280 8264 8280 8266 8264 7334 7333 8264 7333 8272 8280 8866 8266 8266 8866 8867 8266 8867 8265 8279 8865 8280 8280 8865 8866 8865 8811 8866 8866 8811 8813 8866 8813 8867 8279 8864 8865 8864 8809 8865 8865 8809 8811 8809 8810 8811 8811 8810 8812 8811 8812 8813 8813 8812 8814 8814 8812 7423 7423 8812 8810 8809 8808 8810 7423 8810 8808 8807 8808 8809 8864 8807 8809 8807 8806 8808 8808 8806 7423 8805 8806 8807 8863 8805 8807 8863 8807 8864 8805 8804 8806 7423 8806 8804 8803 8804 8805 8862 8803 8805 8862 8805 8863 8277 8862 8863 8277 8863 8278 8278 8863 8864 8276 8861 8862 8276 8862 8277 8861 8803 8862 8272 8276 8277 8277 8278 8272 8272 8278 8279 8278 8864 8279 8153 8271 8272 8272 8271 8273 8272 8273 8274 8274 8275 8272 8272 8275 8276 8272 7333 8153 8275 8861 8276 8274 8860 8275 8275 8860 8861 8273 8859 8274 8274 8859 8860 8271 8858 8273 8273 8858 8859 8858 8797 8859 8859 8797 8799 8859 8799 8860 8860 8799 8801 8860 8801 8861 8797 8798 8799 8799 8798 8800 8799 8800 8801 8795 8796 8797 8797 8796 8798 8858 8795 8797 7423 8800 8798 7423 8798 8796 8801 8800 8802 8802 8800 7423 8801 8802 8803 8861 8801 8803 8803 8802 8804 7423 8804 8802 8796 8794 7423 7423 8794 8792 7423 8792 9771 8795 8794 8796 8793 8792 8794 8793 8794 8795 8791 8790 8792 8791 8792 8793 9771 8792 8790 8767 8791 8793 8767 8793 8768 8768 8793 8795 8789 8790 8791 8766 8789 8791 8766 8791 8767 8789 8788 8790 9771 8790 8788 8787 8788 8789 8765 8787 8789 8765 8789 8766 8150 8765 8766 8150 8766 8151 8151 8766 8767 8149 8764 8765 8149 8765 8150 8764 8787 8765 8785 8786 8787 8787 8786 8788 8764 8785 8787 8788 8786 9771 8785 8784 8786 8786 8784 9771 8783 8784 8785 8763 8783 8785 8763 8785 8764 8147 8763 8764 8147 8764 8149 8146 8762 8763 8146 8763 8147 8762 8783 8763 8781 8782 8783 8783 8782 8784 8762 8781 8783 9771 8784 8782 8781 8780 8782 9771 8782 8780 8779 8780 8781 8761 8779 8781 8761 8781 8762 8159 8761 8762 8159 8762 8146 8146 8147 8148 8148 8159 8146 8148 8147 8149 8148 8149 8150 8150 8151 8148 8148 8151 8152 8151 8767 8152 8148 8152 8153 8152 8270 8153 8152 8767 8768 8152 8768 8270 8153 8270 8271 8153 7333 7328 8153 7328 8148 8270 8768 8271 8271 8768 8858 8768 8795 8858 8154 8158 8148 8148 8158 8159 8148 7328 7327 8148 7327 8154 7327 7328 7069 7328 7333 7069 7069 7333 7334 7069 7334 7067 7067 7068 7069 7327 7069 7329 7324 7331 7069 7069 7331 7332 7069 7332 7329 8154 7327 7329 8154 7329 8162 8162 7329 7332 8162 7332 8173 7332 7331 8173 7324 7330 7331 8173 7331 7330 7326 7330 7324 8173 7330 8180 8180 7330 7326 7324 7325 7326 8180 7326 8191 8191 7326 7325 7324 7323 7325 8191 7325 8199 8199 7325 8208 8208 7325 7323 7301 7322 7323 7301 7323 7324 8208 7323 8114 8114 7323 7322 7300 7322 7301 8114 7322 8119 8119 7322 7300 7299 7300 7301 8119 7300 8129 8129 7300 7299 7299 7301 7302 8129 7299 7302 7302 7301 7303 7302 8136 8129 8136 7302 8083 8083 7302 7303 7303 7301 7304 7303 7304 7305 8083 7303 8079 8079 7303 7305 7306 7307 7304 7304 7307 7308 7304 7308 7305 7311 7306 7304 8079 7305 8088 8088 7305 7308 8088 7308 8098 8098 7308 8106 8106 7308 7307 8106 7307 7964 7964 7307 7306 8104 8105 8106 8104 8106 8107 7964 8109 8106 8106 8109 8110 8106 8110 8107 8105 8111 8106 8106 8111 8112 8106 8112 8098 8104 8450 8105 8105 8450 8451 8105 8451 8111 8111 8451 8452 8111 8452 8112 8098 8112 8113 8112 8452 8453 8112 8453 8113 8451 8486 8452 8452 8486 8488 8452 8488 8453 8450 8484 8451 8451 8484 8486 8484 8485 8486 8486 8485 8487 8486 8487 8488 8488 8487 8489 8488 8489 8490 8453 8488 8490 8113 8453 8454 8453 8490 8454 8490 8489 8491 8490 8491 8492 8454 8490 8492 8491 8489 9768 9768 8489 8487 9768 8487 8485 8484 8483 8485 8485 8483 9768 8482 8481 8483 8482 8483 8484 9768 8483 8481 8480 8481 8482 8449 8480 8482 8449 8482 8450 8450 8482 8484 8480 8479 8481 9768 8481 8479 8478 8479 8480 8448 8478 8480 8448 8480 8449 8107 8448 8449 8107 8449 8104 8104 8449 8450 8110 8447 8448 8110 8448 8107 8447 8478 8448 8411 8477 8478 8478 8477 8479 8447 8411 8478 8479 8477 9768 8411 8476 8477 8477 8476 9768 8409 8410 8411 8410 8476 8411 8446 8409 8411 8446 8411 8447 9768 8476 8410 8409 8408 8410 9768 8410 8408 8407 8408 8409 8445 8407 8409 8445 8409 8446 7963 8445 8446 7963 8446 8108 8108 8446 8447 7965 8444 8445 7965 8445 7963 8444 8407 8445 7963 7964 7965 7963 8108 7964 7964 8108 8109 8108 8447 8109 8109 8447 8110 7965 7964 7960 7964 7306 7960 7965 7960 7966 7966 8444 7965 7966 7960 7962 7962 8443 7966 7966 8443 8444 7960 7961 7962 7961 8442 7962 7962 8442 8443 8442 8403 8443 8443 8403 8405 8443 8405 8444 7961 8441 8442 8441 8401 8442 8442 8401 8403 7960 7988 7961 7988 8441 7961 7988 8440 8441 8440 8399 8441 8441 8399 8401 8399 8400 8401 8401 8400 8402 8401 8402 8403 8397 8398 8399 8399 8398 8400 8440 8397 8399 7987 8439 8440 7987 8440 7988 8439 8397 8440 7960 7987 7988 7968 7987 7960 7968 8439 7987 7968 8438 8439 8438 8395 8439 8439 8395 8397 8395 8396 8397 8397 8396 8398 8400 8398 9768 9768 8398 8396 8395 8394 8396 9768 8396 8394 8393 8394 8395 8438 8393 8395 7967 8437 8438 7967 8438 7968 8437 8393 8438 7967 7968 7960 7960 7986 7967 7986 8437 7967 7986 8436 8437 8436 8391 8437 8437 8391 8393 8391 8392 8393 8393 8392 8394 8394 8392 9768 8391 8390 8392 9768 8392 8390 8389 8390 8391 8436 8389 8391 7985 8435 8436 7985 8436 7986 8435 8389 8436 7960 7985 7986 7984 7985 7960 7984 8435 7985 7984 8434 8435 8434 8387 8435 8435 8387 8389 8387 8388 8389 8389 8388 8390 9768 8390 8388 8387 8386 8388 8388 8386 9768 8385 8386 8387 8434 8385 8387 7983 8433 8434 7983 8434 7984 8433 8385 8434 7960 7983 7984 7960 7982 7983 7982 8433 7983 7982 8432 8433 8432 8383 8433 8433 8383 8385 8383 8384 8385 8385 8384 8386 9768 8386 8384 8383 8382 8384 9768 8384 7430 7430 8384 8382 8381 8382 8383 8432 8381 8383 7981 8431 8432 7981 8432 7982 8431 8381 8432 8379 8380 8381 8381 8380 8382 8431 8379 8381 7430 8382 8380 8379 8378 8380 8380 8378 7430 8377 8378 8379 8430 8377 8379 8430 8379 8431 7980 8430 8431 7980 8431 7981 7980 7981 7969 7969 7981 7982 7969 7979 7980 7979 8430 7980 7979 8429 8430 8429 8377 8430 7969 7978 7979 7978 8429 7979 7978 8428 8429 8428 8375 8429 8429 8375 8377 7977 7978 7969 7977 8428 7978 7977 8427 8428 8427 8373 8428 8428 8373 8375 8373 8374 8375 8375 8374 8376 8375 8376 8377 8371 8372 8373 8373 8372 8374 8427 8371 8373 8374 8372 7430 7430 8376 8374 8377 8376 8378 7430 8378 8376 7401 7429 7430 7401 7430 7408 8354 8352 7430 7430 8352 8350 7430 8350 8348 8372 8370 7430 7430 8370 8368 7430 8368 8366 8366 8364 7430 7430 8364 8362 7430 8362 8360 8360 8358 7430 7430 8358 8356 7430 8356 8354 8348 8346 7430 7430 8346 8344 7430 8344 8342 8342 8340 7430 7430 8340 8333 7430 8333 9767 8345 8344 8346 8345 8346 8347 8347 8346 8348 8343 8342 8344 8343 8344 8345 8341 8340 8342 8341 8342 8343 8338 8333 8340 8338 8340 8341 8334 8338 8341 8334 8341 8412 8412 8341 8343 8412 8343 8413 8413 8343 8345 7997 8334 8412 7997 8412 7998 7998 8412 8413 8334 8335 8336 8335 8334 7997 8336 8338 8334 7997 8077 8335 8335 8077 8076 8336 8335 9001 9001 8335 8076 8336 8337 8338 9001 8337 8336 9000 8332 9001 8332 8339 9001 9001 8339 8337 9001 8076 9000 7997 8075 8076 7997 8076 8077 9000 8076 8075 8074 8075 7997 9000 8075 9005 9005 8075 8074 7997 8073 8074 8073 9005 8074 7503 7997 7994 7994 7997 7998 7503 8072 7997 7997 8072 8073 8072 9750 8073 8073 9750 9005 7503 8071 8072 8071 9749 8072 8072 9749 9750 9749 9745 9750 9750 9745 9006 9750 9006 9005 9748 9743 9749 9749 9743 9745 8071 9748 9749 8070 8071 7503 8070 9748 8071 9747 9741 9748 9748 9741 9743 8070 9747 9748 9741 9742 9743 9743 9742 9744 9743 9744 9745 9739 9740 9741 9741 9740 9742 9747 9739 9741 9746 9739 9747 8069 9746 9747 8069 9747 8070 7503 8069 8070 7503 8068 8069 8068 9746 8069 9695 9736 9746 9746 9736 9739 8068 9695 9746 9736 9738 9739 9739 9738 9740 9767 9742 9740 9767 9740 9738 9736 9737 9738 9738 9737 9767 9734 9735 9736 9735 9737 9736 9695 9734 9736 9767 9737 9735 9734 9733 9735 9767 9735 9733 9732 9733 9734 9694 9732 9734 9694 9734 9695 9732 9731 9733 9731 9767 9733 9730 9731 9732 9693 9730 9732 9693 9732 9694 8065 9693 9694 8065 9694 8066 8066 9694 9695 8064 9692 9693 8064 9693 8065 9692 9730 9693 7753 8064 8065 7753 8065 7754 7754 8065 8066 7754 8066 7506 7506 8066 8067 8066 9695 8067 8067 9695 8068 7506 8067 7505 7505 8067 8068 7505 7504 7506 7316 7754 7506 7316 7506 7317 7317 7506 7504 7315 7753 7754 7315 7754 7316 7315 7316 7313 7313 7316 7317 7313 7317 7311 7311 7317 7318 7502 7318 7317 7317 7504 7502 7313 7314 7315 7314 7313 7319 7319 7313 7320 7419 7320 7313 7314 7753 7315 7319 7751 7314 7751 7752 7314 7314 7752 7753 7319 7320 7269 7269 7750 7319 7319 7750 7751 7269 7320 7321 7321 7320 7419 7269 7270 7271 7269 7321 7270 7271 7749 7269 7269 7749 7750 7749 8061 7750 7750 8061 8062 7750 8062 7751 7272 7748 7749 7272 7749 7271 7748 8060 7749 7749 8060 8061 7271 7270 7260 7271 7260 7272 7272 7260 7268 7268 7748 7272 7268 7747 7748 7747 8059 7748 7748 8059 8060 8059 9689 8060 8060 9689 9690 8060 9690 8061 7747 8058 8059 8058 9688 8059 8059 9688 9689 7267 7746 7747 7267 7747 7268 7746 8058 7747 7260 7267 7268 7260 7266 7267 7266 7746 7267 7266 7745 7746 7745 8057 7746 7746 8057 8058 8057 9687 8058 8058 9687 9688 7745 8056 8057 8056 9686 8057 8057 9686 9687 7265 7744 7745 7265 7745 7266 7744 8056 7745 7265 7266 7260 7260 7264 7265 7264 7744 7265 7264 7743 7744 7743 8055 7744 7744 8055 8056 8055 9685 8056 8056 9685 9686 7743 8054 8055 8054 9684 8055 8055 9684 9685 7263 7742 7743 7263 7743 7264 7742 8054 7743 7260 7263 7264 7262 7263 7260 7262 7742 7263 7262 7741 7742 7741 8053 7742 7742 8053 8054 8053 9683 8054 8054 9683 9684 7741 8052 8053 8052 9682 8053 8053 9682 9683 7261 7740 7741 7261 7741 7262 7740 8052 7741 7260 7261 7262 7260 7259 7261 7259 7740 7261 7259 7739 7740 7739 8051 7740 7740 8051 8052 8051 9681 8052 8052 9681 9682 7739 8050 8051 8050 9680 8051 8051 9680 9681 7258 7738 7739 7258 7739 7259 7738 8050 7739 7258 7259 7260 7258 7260 7273 7273 7738 7258 7273 7737 7738 7737 8049 7738 7738 8049 8050 8049 9679 8050 8050 9679 9680 7737 8048 8049 8048 9678 8049 8049 9678 9679 7275 7736 7737 7275 7737 7273 7736 8048 7737 7273 7260 7274 7273 7274 7275 7274 7280 7275 7280 7736 7275 7280 7735 7736 7735 8047 7736 7736 8047 8048 7274 7279 7280 7279 7735 7280 7278 7279 7274 7400 7278 7274 7260 7400 7274 7270 7400 7260 7321 7419 7270 7270 7419 7400 7400 7419 7420 7400 7401 7402 7400 7420 7401 7402 7283 7400 7400 7283 7278 7402 7401 7395 7408 7409 7401 7401 7409 7410 7401 7410 7411 7417 7418 7401 7401 7420 7428 7401 7428 7417 7418 7429 7401 7401 7411 7090 7090 7089 7401 7401 7089 7087 7401 7087 7395 7088 7089 7090 7088 7090 7091 7411 7091 7090 7087 7089 7088 7086 7087 7088 7395 7087 7086 7084 7085 7086 7086 7088 7084 7395 7086 7085 7084 7083 7085 7083 7395 7085 7082 7083 7084 7082 7395 7083 7364 7082 7254 7254 7082 7084 7364 7396 7082 7082 7396 7395 7396 7364 7254 7252 7253 7254 7254 7084 7252 7396 7254 7392 7392 7254 7253 7395 7396 7392 7256 7391 7392 7256 7392 7257 7391 7395 7392 7255 7257 7392 7392 7253 7255 7253 7252 7255 7255 7252 7256 7255 7256 7257 7252 7298 7256 7298 7391 7256 7298 7297 7391 7402 7395 7391 7296 7402 7391 7296 7391 7297 7252 7297 7298 7296 7297 7252 7295 7296 7252 7295 7402 7296 7295 7292 7402 7402 7292 7283 7292 7295 7293 7293 7295 7252 7292 7293 7283 7283 7293 7294 7293 7252 7390 7390 7719 7293 7293 7719 7720 7293 7720 7294 7283 7294 7281 7294 7720 7721 7294 7721 7281 7719 8031 7720 7720 8031 8032 7720 8032 7721 7281 7721 7722 7721 8032 8033 7721 8033 7722 7281 7282 7283 7281 7722 7282 7282 7722 7723 7722 8033 8034 7722 8034 7723 8032 9546 8033 8033 9546 9547 8033 9547 8034 7723 8034 8035 8034 9547 9548 8034 9548 8035 7282 7723 7284 7284 7723 7724 7723 8035 7724 7283 7282 7284 7283 7284 7285 7284 7724 7285 7285 7724 7725 7724 8035 8036 7724 8036 7725 8035 9548 9549 8035 9549 8036 7725 8036 8037 8036 9549 9550 8036 9550 8037 7285 7725 7286 7286 7725 7726 7725 8037 7726 7285 7286 7283 7283 7286 7287 7286 7726 7287 7287 7726 7727 7726 8037 8038 7726 8038 7727 8037 9550 9551 8037 9551 8038 7727 8038 8039 8038 9551 9552 8038 9552 8039 7287 7727 7288 7288 7727 7728 7727 8039 7728 7283 7287 7288 7288 7289 7283 7288 7728 7289 7289 7728 7729 7728 8039 8040 7728 8040 7729 8039 9552 9553 8039 9553 8040 7729 8040 8041 8040 9553 9554 8040 9554 8041 7289 7729 7290 7290 7729 7730 7729 8041 7730 7283 7289 7290 7283 7290 7278 7278 7290 7291 7290 7730 7291 7291 7730 7731 7730 8041 8042 7730 8042 7731 7278 7291 7276 7291 7731 7276 7276 7277 7278 7278 7277 7279 7731 7732 7276 7276 7732 7733 7276 7733 7277 7731 8042 8043 7731 8043 7732 8041 9555 8042 8042 9555 8043 7732 8043 8044 8043 9555 9673 8043 9673 8044 7732 8044 7733 7277 7733 7734 7733 8044 8045 7733 8045 7734 8044 9673 9674 8044 9674 8045 9555 9666 9673 9673 9666 9668 9673 9668 9674 8045 9674 9675 9674 9668 9670 9674 9670 9675 7734 8045 8046 8045 9675 8046 8046 9675 9676 9675 9670 9672 9675 9672 9676 9668 9669 9670 9670 9669 9671 9670 9671 9672 9666 9667 9668 9668 9667 9669 7410 9671 9669 7410 9669 9667 9671 9696 9672 9696 9671 7410 9672 9696 9697 9672 9697 9698 9676 9672 9698 7410 9697 9696 7411 7410 7412 9667 7412 7410 7409 9699 7410 7410 9699 9697 9698 9697 9699 9698 9699 9700 9676 9698 9677 9677 9698 9700 9700 9699 9701 7409 9701 9699 9700 9701 9702 9677 9700 9678 9678 9700 9702 8047 9676 9677 8047 9677 8048 8048 9677 9678 8046 9676 8047 7735 8046 8047 7734 8046 7735 7279 7734 7735 7277 7734 7279 9678 9702 9679 9679 9702 9704 9679 9704 9680 9702 9703 9704 9704 9703 9705 9704 9705 9706 9680 9704 9706 9680 9706 9681 9706 9705 9707 9706 9707 9708 9681 9706 9708 7409 9707 9705 7409 9705 9703 9702 9701 9703 9703 9701 7409 9709 9707 7409 9721 9719 7409 7409 9719 9717 7409 9717 9715 9767 9725 7409 7409 9725 9723 7409 9723 9721 9715 9713 7409 7409 9713 9711 7409 9711 9709 9722 9721 9723 9722 9723 9724 9724 9723 9725 9720 9721 9722 9688 9720 9722 9688 9722 9689 9689 9722 9724 9724 9725 9726 9689 9724 9690 9690 9724 9726 9726 9725 9727 9726 9727 9728 9690 9726 9691 9691 9726 9728 8061 9690 9691 8061 9691 8062 8062 9691 8063 8063 9691 9692 9691 9728 9692 9728 9727 9729 9728 9729 9730 9692 9728 9730 8063 9692 8064 7751 8062 8063 7751 8063 7752 7752 8063 8064 7752 8064 7753 9730 9729 9731 9731 9729 9767 9729 9727 9767 9767 9727 9725 9767 8333 8332 9767 8332 9744 9744 9742 9767 8331 8332 8333 8331 8333 8338 8338 8339 8331 8332 8331 8339 9000 9003 8332 9745 9744 8332 9745 8332 9003 9002 9003 9000 9002 9000 9004 9004 9000 9005 9003 9002 9745 9745 9002 9004 9745 9004 9006 9004 9005 9006 8338 8337 8339 9687 9720 9688 9686 9718 9687 9687 9718 9720 9718 9719 9720 9720 9719 9721 9716 9717 9718 9718 9717 9719 9686 9716 9718 9685 9716 9686 9714 9715 9716 9716 9715 9717 9685 9714 9716 9684 9714 9685 9712 9713 9714 9714 9713 9715 9684 9712 9714 9683 9712 9684 9710 9711 9712 9712 9711 9713 9683 9710 9712 9682 9710 9683 9708 9709 9710 9710 9709 9711 9682 9708 9710 9681 9708 9682 9708 9707 9709 7411 7412 7413 7413 7412 7414 9627 9625 7412 9633 9631 7412 7412 9631 9629 7412 9629 9627 9639 9637 7412 7412 9637 9635 7412 9635 9633 9645 9643 7412 7412 9643 9641 7412 9641 9639 9653 9651 7412 9659 9657 7412 7412 9657 9655 7412 9655 9653 9665 7412 9667 9665 9663 7412 7412 9663 9661 7412 9661 9659 9651 9649 7412 7412 9649 9647 7412 9647 9645 9625 9623 7412 7412 9623 9621 7412 9621 9619 9619 9617 7412 7412 9617 9615 7412 9615 9613 9613 9611 7412 7412 9611 9609 7412 9609 7414 9616 9615 9617 9616 9617 9618 9618 9617 9619 9614 9613 9615 9614 9615 9616 9612 9611 9613 9612 9613 9614 9610 9609 9611 9610 9611 9612 9528 9610 9612 9528 9612 9529 9529 9612 9614 9529 9614 9530 9530 9614 9616 9530 9616 9531 9531 9616 9618 8016 9529 9530 8016 9530 8017 8017 9530 9531 8015 9528 9529 8015 9529 8016 7704 8015 8016 7704 8016 7705 7705 8016 8017 7705 8017 7706 7706 8017 8018 8017 9531 8018 8018 9531 9532 9531 9618 9532 7706 8018 7707 7707 8018 8019 8018 9532 8019 7376 7705 7706 7376 7706 7377 7377 7706 7707 7377 7707 7378 7378 7707 7708 7707 8019 7708 7708 8019 8020 8019 9532 9533 8019 9533 8020 7378 7708 7379 7379 7708 7709 7708 8020 7709 7252 7377 7378 7252 7378 7379 7376 7377 7252 7252 7375 7376 7375 7705 7376 7252 7374 7375 7374 7704 7375 7375 7704 7705 7373 7374 7252 7373 7703 7374 7374 7703 7704 7703 8015 7704 7373 7702 7703 7702 8014 7703 7703 8014 8015 7252 7372 7373 7372 7702 7373 7372 7701 7702 7701 8013 7702 7702 8013 8014 8013 9527 8014 8014 9527 9528 8014 9528 8015 7701 8012 8013 8012 9526 8013 8013 9526 9527 7371 7700 7701 7371 7701 7372 7700 8012 7701 7252 7371 7372 7370 7371 7252 7370 7700 7371 7370 7699 7700 7699 8011 7700 7700 8011 8012 8011 9525 8012 8012 9525 9526 7699 8010 8011 8010 9524 8011 8011 9524 9525 7369 7698 7699 7369 7699 7370 7698 8010 7699 7252 7369 7370 7252 7368 7369 7368 7698 7369 7368 7697 7698 7697 8009 7698 7698 8009 8010 8009 9523 8010 8010 9523 9524 7697 8008 8009 8008 9522 8009 8009 9522 9523 7367 7696 7697 7367 7697 7368 7696 8008 7697 7367 7368 7252 7252 7366 7367 7366 7696 7367 7366 7695 7696 7695 8007 7696 7696 8007 8008 8007 9521 8008 8008 9521 9522 7695 8006 8007 8006 9520 8007 8007 9520 9521 7365 7694 7695 7365 7695 7366 7694 8006 7695 7252 7365 7366 7338 7365 7252 7338 7694 7365 7338 7693 7694 7693 8005 7694 7694 8005 8006 8005 9519 8006 8006 9519 9520 7693 8004 8005 8004 9518 8005 8005 9518 9519 7337 7692 7693 7337 7693 7338 7692 8004 7693 7084 7337 7338 7252 7084 7338 7084 7336 7337 7336 7692 7337 7336 7691 7692 7691 8003 7692 7692 8003 8004 7335 7336 7084 7335 7691 7336 7335 7690 7691 7690 8002 7691 7691 8002 8003 8002 9516 8003 8003 9516 9517 8003 9517 8004 7690 8001 8002 8001 9515 8002 8002 9515 9516 9515 9586 9516 9516 9586 9588 9516 9588 9517 8004 9517 9518 9517 9588 9590 9517 9590 9518 9586 9587 9588 9588 9587 9589 9588 9589 9590 9584 9585 9586 9586 9585 9587 9515 9584 9586 7414 9589 9587 9587 9585 7414 9590 9589 9591 7414 9591 9589 9590 9591 9592 9518 9590 9592 9518 9592 9519 9592 9591 9593 9592 9593 9594 9519 9592 9594 9593 9591 7414 9594 9593 9595 7414 9595 9593 9594 9595 9596 9519 9594 9520 9520 9594 9596 9596 9595 9597 7414 9597 9595 9596 9597 9598 9520 9596 9521 9521 9596 9598 9598 9597 9599 9599 9597 7414 9598 9599 9600 9521 9598 9522 9522 9598 9600 9600 9599 9601 7414 9601 9599 9600 9601 9602 9522 9600 9523 9523 9600 9602 9602 9601 9603 7414 9603 9601 9602 9603 9604 9523 9602 9524 9524 9602 9604 9604 9603 9605 9605 9603 7414 9604 9605 9606 9524 9604 9525 9525 9604 9606 9606 9605 9607 7414 9607 9605 9606 9607 9608 9525 9606 9526 9526 9606 9608 9608 9607 9609 7414 9609 9607 9608 9609 9610 9526 9608 9527 9527 9608 9610 9527 9610 9528 7413 7414 7415 7415 7414 7399 9242 9240 7414 7414 9240 9238 7414 9238 7399 7414 9585 9583 7414 9583 9581 9581 9579 7414 7414 9579 9577 7414 9577 9575 9575 9573 7414 7414 9573 9571 7414 9571 9569 9569 9567 7414 7414 9567 9565 7414 9565 9563 9563 9561 7414 7414 9561 9559 7414 9559 9557 9557 9556 7414 7414 9556 9244 7414 9244 9242 9558 9557 9559 9558 9559 9560 9560 9559 9561 9245 9556 9557 9245 9557 9558 9244 9556 9245 9243 9242 9244 9243 9244 9245 9241 9240 9242 9241 9242 9243 9499 9241 9243 9499 9243 9500 9500 9243 9245 9500 9245 9501 9501 9245 9558 7959 9499 9500 7959 9500 7949 7949 9500 9501 7776 9043 9499 7776 9499 7959 9043 9241 9499 7949 7673 7959 7959 7673 7672 7959 7672 7776 7354 7672 7673 7354 7673 7355 7355 7673 7674 7949 7674 7673 7671 7672 7354 7776 7672 7671 7348 7354 7084 7084 7354 7355 7348 7671 7354 7084 7355 7356 7355 7674 7356 7356 7674 7675 7675 7674 7949 7356 7357 7084 7356 7675 7357 7357 7675 7676 7675 7949 7676 7676 7949 7950 7949 9501 7950 7357 7676 7358 7358 7676 7677 7676 7950 7677 7084 7357 7358 7084 7358 7359 7358 7677 7359 7359 7677 7678 7677 7950 7951 7677 7951 7678 7950 9501 9502 7950 9502 7951 9501 9558 9502 7951 9502 9503 9502 9558 9560 9502 9560 9503 7678 7951 7952 7951 9503 7952 7952 9503 9504 9503 9560 9562 9503 9562 9504 9560 9561 9562 9562 9561 9563 9562 9563 9564 9504 9562 9564 7952 9504 7953 7953 9504 9505 9504 9564 9505 7678 7952 7679 7679 7952 7953 7679 7953 7680 7680 7953 7954 7953 9505 7954 7954 9505 9506 9505 9564 9566 9505 9566 9506 7680 7954 7681 7681 7954 7955 7954 9506 7955 7361 7679 7680 7361 7680 7344 7344 7680 7681 7344 7681 7345 7345 7681 7682 7681 7955 7682 7682 7955 7956 7955 9506 9507 7955 9507 7956 7345 7682 7346 7346 7682 7683 7682 7956 7683 7344 7345 7084 7084 7345 7346 7084 7361 7344 7339 7340 7084 7341 7342 7084 7084 7342 7343 7084 7343 7339 7084 7346 7341 7347 7348 7084 7347 7084 7349 7350 7351 7084 7084 7351 7352 7084 7352 7349 7084 7088 7353 7084 7353 7350 7359 7360 7084 7084 7360 7361 7340 7362 7084 7084 7362 7363 7084 7363 7335 7359 7678 7360 7360 7678 7679 7360 7679 7361 7363 7690 7335 7362 7689 7363 7363 7689 7690 7340 7688 7362 7362 7688 7689 7688 8000 7689 7689 8000 8001 7689 8001 7690 7340 7687 7688 7687 7999 7688 7688 7999 8000 7999 9513 8000 8000 9513 9514 8000 9514 8001 8001 9514 9515 9513 9582 9514 9514 9582 9584 9514 9584 9515 7999 9512 9513 9512 9580 9513 9513 9580 9582 7687 7948 7999 7948 9512 7999 7948 9511 9512 9511 9578 9512 9512 9578 9580 9578 9579 9580 9580 9579 9581 9580 9581 9582 9576 9577 9578 9578 9577 9579 9511 9576 9578 7947 9510 9511 7947 9511 7948 9510 9576 9511 9574 9575 9576 9576 9575 9577 9510 9574 9576 7958 9509 9510 7958 9510 7947 9509 9574 9510 7684 7947 7685 7685 7947 7948 7684 7958 7947 7684 7957 7958 7957 9509 7958 7957 9508 9509 9508 9572 9509 9509 9572 9574 7683 7956 7957 7683 7957 7684 7956 9508 7957 7956 9507 9508 9507 9570 9508 9508 9570 9572 9570 9571 9572 9572 9571 9573 9572 9573 9574 9568 9569 9570 9570 9569 9571 9507 9568 9570 9506 9568 9507 9566 9567 9568 9568 9567 9569 9506 9566 9568 9564 9565 9566 9566 9565 9567 9564 9563 9565 9574 9573 9575 7341 7683 7684 7341 7684 7342 7342 7684 7685 7346 7683 7341 7342 7685 7343 7343 7685 7686 7685 7948 7686 7343 7686 7339 7339 7686 7687 7686 7948 7687 7339 7687 7340 9582 9581 9583 9582 9583 9584 9584 9583 9585 7353 7665 7350 7350 7665 7666 7350 7666 7351 7088 7664 7353 7353 7664 7665 7666 7665 7776 7776 7665 7664 7351 7666 7667 7776 7667 7666 7351 7667 7352 7352 7667 7668 7776 7668 7667 7352 7668 7349 7349 7668 7669 7669 7668 7776 7349 7669 7347 7347 7669 7670 7776 7670 7669 7347 7670 7348 7348 7670 7671 7776 7671 7670 7651 7650 7776 7776 7664 7536 7536 7535 7776 7776 7535 7534 7776 7534 7533 7533 7532 7776 7776 7532 7531 7776 7531 7530 7655 7654 7776 7655 7776 7656 7530 7529 7776 7776 7529 7528 7776 7528 7527 7659 7658 7776 7776 7658 7657 7776 7657 7656 7662 7661 7776 7776 7661 7660 7776 7660 7659 7527 7526 7776 7776 7526 7525 7776 7525 7524 7515 7514 7776 7776 7514 7663 7776 7663 7662 7518 7517 7776 7776 7517 7516 7776 7516 7515 7524 7523 7776 7776 7523 7522 7776 7522 7521 7521 7520 7776 7776 7520 7519 7776 7519 7518 7654 7653 7776 7776 7653 7652 7776 7652 7651 7589 7588 7776 7776 7588 7587 7776 7587 7586 7592 7591 7776 7776 7591 7590 7776 7590 7589 7595 7594 7776 7776 7594 7593 7776 7593 7592 7598 7597 7776 7776 7597 7596 7776 7596 7595 7601 7600 7776 7776 7600 7599 7776 7599 7598 7604 7603 7776 7776 7603 7602 7776 7602 7601 7607 7606 7776 7776 7606 7605 7776 7605 7604 7611 7610 7776 7614 7613 7776 7776 7613 7612 7776 7612 7611 7617 7616 7776 7776 7616 7615 7776 7615 7614 7620 7619 7776 7776 7619 7618 7776 7618 7617 7623 7622 7776 7776 7622 7621 7776 7621 7620 7626 7625 7776 7776 7625 7624 7776 7624 7623 7629 7628 7776 7776 7628 7627 7776 7627 7626 7632 7631 7776 7776 7631 7630 7776 7630 7629 7650 7649 7776 7776 7649 7648 7776 7648 7647 7635 7634 7776 7776 7634 7633 7776 7633 7632 7638 7637 7776 7776 7637 7636 7776 7636 7635 7641 7640 7776 7776 7640 7639 7776 7639 7638 7644 7643 7776 7776 7643 7642 7776 7642 7641 7647 7646 7776 7776 7646 7645 7776 7645 7644 7610 7609 7776 7776 7609 7608 7776 7608 7607 7586 7585 7776 7776 7585 7584 7776 7584 7583 7583 7582 7776 7776 7582 7775 7776 7775 7901 7901 9043 7776 7233 7582 7583 7233 7583 7234 7234 7583 7584 7207 7233 7073 7073 7233 7234 7207 7582 7233 7073 7234 7235 7234 7584 7235 7235 7247 7073 7235 7584 7585 7235 7585 7247 7073 7247 7248 7247 7585 7586 7247 7586 7248 7073 7248 7244 7248 7586 7587 7248 7587 7244 7244 7245 7073 7244 7587 7588 7244 7588 7245 7073 7245 7246 7245 7588 7589 7245 7589 7246 7073 7246 7241 7246 7589 7590 7246 7590 7241 7241 7242 7073 7241 7590 7591 7241 7591 7242 7073 7242 7243 7242 7591 7592 7242 7592 7243 7073 7243 7238 7243 7592 7593 7243 7593 7238 7238 7239 7073 7238 7593 7594 7238 7594 7239 7073 7239 7240 7239 7594 7595 7239 7595 7240 7073 7240 7236 7240 7595 7596 7240 7596 7236 7236 7237 7073 7236 7596 7597 7236 7597 7237 7237 7249 7073 7237 7597 7598 7237 7598 7249 7073 7249 7250 7249 7598 7599 7249 7599 7250 7073 7250 7176 7176 7250 7251 7250 7599 7600 7250 7600 7251 7176 7251 7179 7251 7600 7601 7251 7601 7179 7179 7180 7176 7179 7601 7602 7179 7602 7180 7176 7180 7181 7180 7602 7603 7180 7603 7181 7176 7181 7174 7181 7603 7604 7181 7604 7174 7174 7175 7176 7174 7604 7605 7174 7605 7175 7176 7175 7177 7175 7605 7606 7175 7606 7177 7176 7177 7178 7177 7606 7607 7177 7607 7178 7178 7182 7176 7178 7607 7608 7178 7608 7182 7176 7182 7183 7182 7608 7609 7182 7609 7183 7176 7183 7169 7169 7183 7184 7183 7609 7610 7183 7610 7184 7169 7184 7170 7184 7610 7611 7184 7611 7170 7167 7169 7170 7170 7611 7612 7170 7612 7167 7167 7168 7169 7167 7612 7613 7167 7613 7168 7168 7171 7169 7168 7613 7614 7168 7614 7171 7169 7171 7172 7171 7614 7615 7171 7615 7172 7169 7172 7163 7163 7172 7173 7172 7615 7616 7172 7616 7173 7398 7176 7169 7398 7169 7416 7416 7169 7163 7176 7398 7073 920 7397 7398 920 7398 7399 7416 7399 7398 7073 7398 7397 7394 7397 920 7073 7397 7072 7072 7397 7070 7070 7397 7394 7393 7394 920 7070 7394 7074 7074 7394 7075 7075 7394 7393 7070 7071 7072 7070 7074 7071 7072 7071 7073 7071 7074 7075 7071 7075 7076 7076 7077 7071 7071 7077 7078 7071 7078 7079 7187 7186 7071 7186 7188 7071 7071 7188 7189 7071 7189 7190 7190 7191 7071 7071 7191 7192 7071 7192 7193 7193 7194 7071 7071 7194 7195 7071 7195 7196 7196 7197 7071 7071 7197 7198 7071 7198 7199 7199 7200 7071 7071 7200 7201 7071 7201 7202 7202 7203 7071 7071 7203 7204 7071 7204 7205 7205 7208 7071 7071 7208 7209 7071 7209 7210 7210 7214 7071 7071 7214 7215 7071 7215 7216 7216 7220 7071 7071 7220 7221 7071 7221 7222 7222 7223 7071 7071 7223 7224 7071 7224 7073 7495 7187 7071 7495 7071 7492 7492 7071 7079 7185 7186 7187 7185 7187 7495 7495 7494 7185 7185 7510 7186 7510 7185 7494 7186 7510 7507 7507 7509 7186 7186 7509 7537 7186 7537 7188 9863 7507 7510 9863 7510 9864 9864 7510 7494 7493 7494 7495 9864 7494 7493 9865 9863 9864 9865 9864 9866 9866 9864 7493 9861 7507 9863 9859 9861 9863 9859 9863 9865 9809 9859 9865 9809 9865 9807 9807 9865 9866 9866 7493 7497 9807 9866 9805 9805 9866 7497 9805 9806 9807 9807 9806 9808 9807 9808 9809 7468 7467 9805 9805 7467 9806 7496 7468 9805 9805 7497 7496 7496 7497 7498 7498 7497 7493 7498 7470 7496 7496 7470 7469 7496 7469 7468 7467 7468 7469 7470 7471 7469 7469 7471 7472 7469 7472 7467 7477 7478 7470 7470 7478 7479 7470 7479 7471 7498 7477 7470 7479 7489 7471 7472 7471 7489 7489 9827 7472 7472 9827 7467 7488 7487 7489 7488 7489 7479 7487 9825 7489 7489 9825 9827 7479 7478 7488 7480 7487 7488 7488 7478 7481 7488 7481 7480 7480 7466 7487 7466 9803 7487 7487 9803 9825 9803 9802 9825 9825 9802 9826 9825 9826 9827 7447 9802 9803 7447 9803 7466 7465 7447 7466 7465 7466 7480 7464 7448 7465 7465 7448 7447 7464 7465 7480 7463 7448 7464 7480 7483 7464 7464 7483 7463 7404 7447 7448 7404 7448 7449 7463 7449 7448 7462 7449 7463 7462 7463 7482 7482 7463 7483 7404 7449 7462 7462 7482 7484 7462 7484 7404 7482 7483 7484 7484 7483 7485 7485 7483 7481 7480 7481 7483 7404 7484 7485 7485 7481 7486 7404 7485 7486 7478 7476 7481 7486 7481 7476 7486 7476 7474 7486 7474 7404 7475 7474 7476 7475 7476 7477 7477 7476 7478 7473 7474 7475 7404 7474 7473 7473 7475 7501 7501 7475 7477 7501 7477 7498 7499 7500 7501 7501 7500 7473 7498 7492 7501 7501 7492 7491 7501 7491 7499 7404 7473 7500 7500 7499 7404 7404 7499 7491 7490 7491 7492 7490 7404 7491 7490 7492 7081 7492 7079 7081 7498 7495 7492 7493 7495 7498 7079 7080 7081 7080 7405 7081 7081 7405 7404 7081 7404 7490 7079 7078 7080 7080 7078 7405 7403 7404 7405 7405 7078 7403 7077 7403 7078 7393 920 7403 7403 920 7404 7077 7393 7403 7076 7393 7077 7075 7393 7076 7404 7441 7442 7442 7443 7404 7404 7443 7444 7404 7444 7445 7446 7447 7404 7458 7441 7404 7458 7404 920 7445 7459 7404 7404 7459 7460 7404 7460 7446 7946 7445 7444 7946 7444 7443 7946 7944 7445 7445 7944 7459 7459 7944 9887 7459 9887 7460 7446 7460 7461 7460 9887 7461 7461 9887 9888 9886 9888 9887 9886 9887 7941 7941 9887 7944 7943 7941 7944 7943 7944 7945 7945 7944 7946 7940 7939 7941 7940 7941 7942 7942 7941 7943 7939 9886 7941 7945 9045 7943 7943 9045 9046 7943 9046 7942 7946 9044 7945 7945 9044 9045 9044 9249 9045 9045 9249 9251 9045 9251 9046 7942 9046 9047 9046 9251 9253 9046 9253 9047 7942 9047 7940 7940 9047 9048 9047 9253 9255 9047 9255 9048 9251 9252 9253 9253 9252 9254 9253 9254 9255 9249 9250 9251 9251 9250 9252 9254 9252 920 920 9252 9250 9255 9254 9256 920 9256 9254 9255 9256 9257 9048 9255 9257 9257 9256 9258 920 9258 9256 9257 9258 9259 9048 9257 9049 9049 9257 9259 9259 9258 9260 9260 9258 920 9259 9260 9261 9049 9259 9050 9050 9259 9261 7938 9048 9049 7938 9049 7933 7933 9049 9050 7933 9050 7934 7934 9050 9051 9050 9261 9051 7932 7933 7934 7933 7932 7938 7938 7932 7939 7938 7939 7940 7940 9048 7938 7932 9885 7939 7939 9885 9886 9884 9878 9885 9885 9878 9877 9885 9877 9886 7932 9884 9885 9877 9888 9886 9796 9877 9878 9796 9795 9877 9877 9795 9888 7461 9888 7450 7450 9888 7451 7451 9888 9795 7446 7461 7450 7450 7451 7446 7454 7455 7451 7451 7455 7456 7451 7456 7446 7451 9795 7454 7452 7453 7454 7454 7453 7455 9795 7452 7454 9789 7456 7455 9789 7455 9790 9790 7455 9791 9791 7455 7453 9788 7456 9789 9804 7446 7456 9804 7456 9788 9789 9790 9847 9788 9789 9838 9838 9789 9847 9790 9791 9841 9847 9790 9841 9791 7453 9792 9791 9792 9841 9841 9792 9842 9841 9842 9846 9847 9841 9848 9848 9841 9846 9838 9847 9840 9840 9847 9848 9848 9846 9824 9840 9848 9823 9823 9848 9824 9846 9842 9844 9846 9844 9816 9824 9846 9816 9818 9823 9824 9818 9824 9816 9812 9822 9823 9812 9823 9818 9822 9840 9823 9839 9838 9840 9839 9840 9822 9814 9822 9812 9814 9839 9822 9837 9838 9839 9835 9837 9839 9835 9839 9814 9837 9788 9838 9804 9788 9837 9836 9804 9837 9836 9837 9835 9835 9814 9810 9810 9829 9835 9835 9829 9836 9812 9813 9814 9814 9813 9810 9810 9813 9815 9872 9869 9813 9813 9869 9815 9812 9872 9813 9810 9815 9811 9811 9815 9867 9867 9815 9869 9867 9869 9868 9868 9869 9870 9872 9870 9869 9811 9867 9857 9857 9867 9858 9858 9867 9860 9860 9867 9868 9809 9810 9811 9809 9811 9857 9857 9858 9859 9857 9859 9809 9858 9860 9861 9858 9861 9859 9861 9860 9862 9860 9868 9862 9861 9862 7511 7511 7508 9861 9861 7508 7507 7511 9862 7512 7512 9862 9868 7508 7511 7509 7509 7511 7512 7507 7508 7509 7509 7512 7513 7775 7537 7509 7513 7777 7509 7509 7777 7778 7509 7778 7775 7512 9868 7513 9868 9870 7513 7777 7513 9871 9871 7513 9870 7778 7777 9873 9873 7777 9871 7775 7778 9875 9875 7778 9873 9873 9871 9874 9875 9873 9876 9876 9873 9874 9871 9870 9872 9874 9871 9872 9874 9872 9812 9876 9874 9821 9821 9874 9812 9876 9821 9849 9875 9876 9879 9876 9849 9879 7775 9875 9880 9875 9879 9880 9879 9849 9851 9879 9851 9881 9880 9879 9881 9821 9820 9849 9849 9820 9850 9849 9850 9851 9812 9820 9821 9812 9819 9820 9819 9850 9820 9851 9850 9852 9852 9850 9853 9853 9850 9854 9845 9854 9850 9845 9850 9819 9851 9852 9881 9881 9852 9853 9853 9854 9855 9881 9853 9882 9882 9853 9855 9855 9854 9856 9856 9854 9797 9843 9797 9854 9843 9854 9845 9844 9843 9845 9844 9845 9817 9817 9845 9819 9842 9794 9843 9842 9843 9844 9794 9797 9843 9795 9796 9797 9797 9794 9795 9856 9797 9796 9793 7452 9794 9795 9794 7452 9793 9794 9842 9792 9793 9842 9792 7453 9793 9793 7453 7452 9878 9856 9796 9882 9855 9878 9878 9855 9856 9884 9882 9878 9883 9881 9882 9883 9882 9884 7926 9883 9884 7926 9884 7932 9880 9881 9883 7904 9880 9883 7904 9883 7926 7775 9880 7904 7570 7569 7775 7573 7572 7775 7775 7572 7571 7775 7571 7570 7576 7575 7775 7775 7575 7574 7775 7574 7573 7579 7578 7775 7775 7578 7577 7775 7577 7576 7582 7581 7775 7775 7581 7580 7775 7580 7579 7569 7568 7775 7775 7568 7567 7775 7567 7566 7566 7565 7775 7775 7565 7564 7775 7564 7563 7563 7562 7775 7775 7562 7561 7775 7561 7560 7560 7559 7775 7775 7559 7558 7775 7558 7557 7557 7556 7775 7775 7556 7555 7775 7555 7554 7554 7553 7775 7775 7553 7552 7775 7552 7551 7551 7550 7775 7775 7550 7549 7775 7549 7548 7548 7547 7775 7775 7547 7546 7775 7546 7545 7545 7544 7775 7775 7544 7543 7775 7543 7542 7542 7541 7775 7775 7541 7540 7775 7540 7539 7539 7538 7775 7775 7538 7537 7779 7780 7775 7781 7782 7775 7783 7784 7775 7783 7775 7785 7786 7787 7775 7775 7787 7788 7775 7788 7785 7789 7790 7775 7775 7790 7791 7775 7791 7792 7793 7794 7775 7775 7794 7795 7775 7795 7789 7792 7796 7775 7775 7796 7797 7775 7797 7786 7798 7799 7775 7775 7799 7800 7775 7800 7801 7784 7802 7775 7775 7802 7803 7775 7803 7798 7804 7805 7775 7775 7805 7806 7775 7806 7781 7801 7807 7775 7775 7807 7808 7775 7808 7804 7809 7810 7775 7775 7810 7811 7775 7811 7812 7782 7813 7775 7775 7813 7814 7775 7814 7809 7815 7816 7775 7775 7816 7817 7775 7817 7818 7812 7819 7775 7775 7819 7820 7775 7820 7815 7821 7822 7775 7775 7822 7823 7775 7823 7824 7818 7825 7775 7775 7825 7826 7775 7826 7821 7827 7828 7775 7775 7828 7829 7775 7829 7830 7824 7831 7775 7775 7831 7832 7775 7832 7827 7833 7834 7775 7775 7834 7835 7775 7835 7836 7830 7837 7775 7775 7837 7838 7775 7838 7833 7839 7840 7775 7775 7840 7841 7775 7841 7842 7836 7843 7775 7775 7843 7844 7775 7844 7839 7845 7846 7775 7775 7846 7847 7775 7847 7779 7842 7848 7775 7775 7848 7849 7775 7849 7845 7850 7851 7775 7775 7851 7852 7775 7852 7853 7780 7854 7775 7775 7854 7855 7775 7855 7850 7853 7856 7775 7775 7856 7857 7775 7857 7858 7858 7859 7775 7775 7859 7860 7775 7860 7861 7861 7862 7775 7775 7862 7863 7775 7863 7864 7864 7865 7775 7775 7865 7866 7775 7866 7867 7867 7868 7775 7775 7868 7869 7775 7869 7870 7870 7871 7775 7775 7871 7872 7775 7872 7873 7873 7874 7775 7775 7874 7875 7775 7875 7876 7876 7877 7775 7775 7877 7878 7775 7878 7879 7879 7880 7775 7775 7880 7881 7775 7881 7882 7882 7883 7775 7775 7883 7884 7775 7884 7885 7885 7886 7775 7775 7886 7887 7775 7887 7888 7888 7889 7775 7775 7889 7890 7775 7890 7891 7891 7892 7775 7775 7892 7893 7775 7893 7894 7894 7895 7775 7775 7895 7896 7775 7896 7897 7897 7898 7775 7775 7898 7899 7775 7899 7900 7901 7775 7900 7904 7905 7775 7775 7905 7906 7775 7906 7793 7899 9042 7900 7900 9042 9043 7900 9043 7901 7899 9041 9042 9041 9237 9042 9042 9237 9239 9042 9239 9043 9043 9239 9241 9237 9238 9239 9239 9238 9240 9239 9240 9241 9235 9236 9237 9237 9236 9238 9041 9235 9237 9238 9236 7399 9235 9234 9236 7399 9236 9234 9233 9234 9235 9040 9233 9235 9040 9235 9041 9233 9232 9234 7399 9234 9232 9231 9232 9233 9039 9231 9233 9039 9233 9040 7897 9039 9040 7897 9040 7898 7898 9040 9041 7896 9038 9039 7896 9039 7897 9038 9231 9039 7895 9038 7896 7895 9037 9038 9037 9229 9038 9038 9229 9231 7894 9037 7895 7894 9036 9037 9036 9227 9037 9037 9227 9229 9227 9228 9229 9229 9228 9230 9229 9230 9231 9225 9226 9227 9227 9226 9228 9036 9225 9227 7399 9230 9228 7399 9228 9226 9231 9230 9232 9232 9230 7399 7415 7399 7416 9372 9370 7399 7399 9370 9368 7399 9368 9366 9384 9382 7399 7399 9382 9380 7399 9380 9378 9396 9394 7399 7399 9394 9392 7399 9392 9390 9226 9224 7399 7399 9224 9222 7399 9222 9220 9408 9406 7399 7399 9406 9404 7399 9404 9402 9420 9418 7399 7399 9418 9416 7399 9416 9414 9432 9430 7399 7399 9430 9428 7399 9428 9426 9444 9442 7399 7399 9442 9440 7399 9440 9438 9452 9450 7399 9458 9456 7399 7399 9456 9454 7399 9454 9452 9470 9468 7399 7399 9468 9466 7399 9466 9464 9220 9218 7399 7399 9218 9216 7399 9216 9214 9214 9212 7399 7399 9212 9210 7399 9210 9208 9208 9206 7399 7399 9206 9204 7399 9204 9202 9202 9200 7399 7399 9200 9198 7399 9198 9196 9196 9194 7399 7399 9194 9192 7399 9192 9190 9190 9188 7399 7399 9188 9186 7399 9186 9184 9184 9182 7399 7399 9182 9180 7399 9180 9178 9178 9176 7399 7399 9176 9174 7399 9174 9172 9172 9498 7399 7399 9498 9496 7399 9496 9494 9494 9492 7399 7399 9492 9490 7399 9490 9488 9488 9486 7399 7399 9486 9484 7399 9484 9482 9482 9480 7399 7399 9480 9478 7399 9478 9476 9476 9474 7399 7399 9474 9472 7399 9472 9470 9464 9462 7399 7399 9462 9460 7399 9460 9458 9450 9448 7399 7399 9448 9446 7399 9446 9444 9438 9436 7399 7399 9436 9434 7399 9434 9432 9426 9424 7399 7399 9424 9422 7399 9422 9420 9414 9412 7399 7399 9412 9410 7399 9410 9408 9402 9400 7399 7399 9400 9398 7399 9398 9396 9390 9388 7399 7399 9388 9386 7399 9386 9384 9378 9376 7399 7399 9376 9374 7399 9374 9372 9366 9364 7399 7399 9364 9362 7399 9362 9360 9360 9358 7399 7399 9358 9356 7399 9356 920 9361 9360 9362 9361 9362 9363 9363 9362 9364 9359 9358 9360 9359 9360 9361 9357 9356 9358 9357 9358 9359 9099 9357 9359 9099 9359 9100 9100 9359 9361 9100 9361 9101 9101 9361 9363 9363 9364 9365 9101 9363 9102 9102 9363 9365 7799 9100 9101 7799 9101 7800 7800 9101 9102 7798 9099 9100 7798 9100 7799 7803 9099 7798 7802 9098 7803 7803 9098 9099 7784 9097 7802 7802 9097 9098 9097 9355 9098 9098 9355 9357 9098 9357 9099 7784 9096 9097 9096 9353 9097 9097 9353 9355 7783 9096 7784 7783 9095 9096 9095 9351 9096 9096 9351 9353 9351 9352 9353 9353 9352 9354 9353 9354 9355 9349 9350 9351 9351 9350 9352 9095 9349 9351 7785 9094 9095 7785 9095 7783 9094 9349 9095 9347 9348 9349 9349 9348 9350 9094 9347 9349 9352 9350 920 920 9350 9348 920 9354 9352 9355 9354 9356 920 9356 9354 9355 9356 9357 919 920 921 921 920 922 1122 922 920 1122 920 919 9312 9310 920 9338 9336 920 9338 920 9340 9346 9344 920 920 9344 9342 920 9342 9340 920 9348 9346 9330 9328 920 920 9328 9326 920 9326 9324 9336 9334 920 920 9334 9332 920 9332 9330 9318 9316 920 920 9316 9314 920 9314 9312 9324 9322 920 920 9322 9320 920 9320 9318 9304 9302 920 920 9302 9300 920 9300 9298 9310 9308 920 920 9308 9306 920 9306 9304 9292 9290 920 9298 9296 920 920 9296 9294 920 9294 9292 9290 9288 920 920 9288 9286 920 9286 9284 9284 9282 920 920 9282 9280 920 9280 9278 9278 9276 920 920 9276 9274 920 9274 9272 9272 9270 920 920 9270 9268 920 9268 9266 9266 9264 920 920 9264 9262 920 9262 9260 920 9250 9248 9248 9246 920 920 9246 9007 920 9007 7458 9261 9260 9262 9261 9262 9263 9263 9262 9264 9051 9261 9263 9263 9264 9265 9051 9263 9052 9052 9263 9265 7934 9051 7935 7935 9051 9052 7935 9052 7936 7936 9052 9053 9052 9265 9053 9265 9264 9266 9265 9266 9267 9053 9265 9267 7936 9053 7937 7937 9053 9054 9053 9267 9054 9267 9266 9268 9267 9268 9269 9054 9267 9269 7937 9054 7924 7924 9054 9055 9054 9269 9055 7926 7936 7937 7926 7937 7924 7924 7925 7926 7924 9055 7925 7925 9055 9056 9055 9269 9271 9055 9271 9056 9269 9268 9270 9269 9270 9271 9271 9270 9272 9271 9272 9273 9056 9271 9273 7925 9056 7927 7927 9056 9057 9056 9273 9057 7926 7925 7927 7926 7927 7928 7927 9057 7928 7928 9057 9058 9057 9273 9275 9057 9275 9058 9273 9272 9274 9273 9274 9275 9275 9274 9276 9275 9276 9277 9058 9275 9277 7928 9058 7929 7929 9058 9059 9058 9277 9059 7928 7929 7926 7926 7929 7930 7929 9059 7930 7930 9059 9060 9059 9277 9279 9059 9279 9060 9277 9276 9278 9277 9278 9279 9279 9278 9280 9279 9280 9281 9060 9279 9281 7930 9060 7931 7931 9060 9061 9060 9281 9061 7926 7930 7904 7904 7930 7931 7932 7936 7926 7934 7935 7932 7932 7935 7936 7904 7931 7911 7931 9061 7911 7911 7912 7904 7911 9061 9062 7911 9062 7912 7904 7912 7913 7912 9062 9063 7912 9063 7913 9061 9283 9062 9062 9283 9285 9062 9285 9063 7913 9063 9064 9063 9285 9287 9063 9287 9064 7913 7918 7904 7913 9064 7918 7918 9064 9065 9064 9287 9289 9064 9289 9065 9285 9286 9287 9287 9286 9288 9287 9288 9289 9289 9288 9290 9289 9290 9291 9065 9289 9291 7918 9065 7919 7919 9065 9066 9065 9291 9066 7904 7918 7919 7904 7919 7914 7919 9066 7914 7914 9066 9067 9066 9291 9293 9066 9293 9067 9291 9290 9292 9291 9292 9293 9293 9292 9294 9293 9294 9295 9067 9293 9295 7914 9067 7915 7915 9067 9068 9067 9295 9068 7914 7915 7904 7904 7915 7916 7915 9068 7916 7916 9068 9069 9068 9295 9297 9068 9297 9069 9295 9294 9296 9295 9296 9297 9297 9296 9298 9297 9298 9299 9069 9297 9299 7916 9069 7917 7917 9069 9070 9069 9299 9070 7904 7916 7917 7917 7920 7904 7917 9070 7920 7920 9070 9071 9070 9299 9301 9070 9301 9071 9299 9298 9300 9299 9300 9301 9301 9300 9302 9301 9302 9303 9071 9301 9303 7920 9071 7921 7921 9071 9072 9071 9303 9072 7904 7920 7921 7904 7921 7907 7921 9072 7907 7907 9072 9073 9072 9303 9305 9072 9305 9073 9303 9302 9304 9303 9304 9305 9305 9304 9306 9305 9306 9307 9073 9305 9307 7907 9073 7908 7908 9073 9074 9073 9307 9074 7907 7908 7904 7904 7908 7909 7908 9074 7909 7909 9074 9075 9074 9307 9309 9074 9309 9075 9307 9306 9308 9307 9308 9309 9309 9308 9310 9309 9310 9311 9075 9309 9311 7909 9075 7910 7910 9075 9076 9075 9311 9076 7904 7909 7910 7910 7922 7904 7910 9076 7922 7922 9076 9077 9076 9311 9313 9076 9313 9077 9311 9310 9312 9311 9312 9313 9313 9312 9314 9313 9314 9315 9077 9313 9315 7922 9077 7923 7923 9077 9078 9077 9315 9078 7904 7922 7923 7904 7923 7902 7923 9078 7902 7902 9078 9079 9078 9315 9317 9078 9317 9079 9315 9314 9316 9315 9316 9317 9317 9316 9318 9317 9318 9319 9079 9317 9319 7902 9079 7903 7903 9079 9080 9079 9319 9080 7902 7903 7904 7904 7903 7905 7903 9080 7905 7905 9080 9081 9080 9319 9321 9080 9321 9081 9319 9318 9320 9319 9320 9321 9321 9320 9322 9321 9322 9323 9081 9321 9323 7905 9081 7906 7906 9081 9082 9081 9323 9082 9323 9322 9324 9323 9324 9325 9082 9323 9325 7906 9082 7793 7793 9082 9083 9082 9325 9083 9325 9324 9326 9325 9326 9327 9083 9325 9327 7793 9083 7794 7794 9083 9084 9083 9327 9084 9327 9326 9328 9327 9328 9329 9084 9327 9329 7794 9084 7795 7795 9084 9085 9084 9329 9085 9329 9328 9330 9329 9330 9331 9085 9329 9331 7795 9085 7789 7789 9085 9086 9085 9331 9086 9331 9330 9332 9331 9332 9333 9086 9331 9333 7789 9086 7790 7790 9086 9087 9086 9333 9087 9333 9332 9334 9333 9334 9335 9087 9333 9335 7790 9087 7791 7791 9087 9088 9087 9335 9088 9335 9334 9336 9335 9336 9337 9088 9335 9337 7791 9088 7792 7792 9088 9089 9088 9337 9089 9337 9336 9338 9337 9338 9339 9089 9337 9339 7792 9089 7796 7796 9089 9090 9089 9339 9090 9339 9338 9340 9339 9340 9341 9090 9339 9341 7796 9090 7797 7797 9090 9091 9090 9341 9091 9341 9340 9342 9341 9342 9343 9091 9341 9343 7797 9091 7786 7786 9091 9092 9091 9343 9092 9343 9342 9344 9343 9344 9345 9092 9343 9345 7786 9092 7787 7787 9092 9093 9092 9345 9093 9345 9344 9346 9345 9346 9347 9093 9345 9347 7787 9093 7788 7788 9093 9094 9093 9347 9094 9347 9346 9348 7788 9094 7785 9285 9284 9286 9283 9284 9285 9283 9282 9284 9281 9282 9283 9061 9281 9283 9281 9280 9282 7457 7441 7458 7457 7458 9007 9008 7441 7457 7457 9007 9008 7442 7441 9008 9008 9007 9246 9008 9246 9247 7442 9008 9009 9009 9008 9247 9009 7443 7442 7443 9009 7946 7946 9009 9044 9009 9247 9044 9247 9246 9248 9247 9248 9249 9044 9247 9249 9249 9248 9250 919 921 1311 919 1311 1122 6860 6859 919 6860 919 6861 6955 6861 919 6955 919 6954 6954 919 7044 6859 6814 919 919 6814 6812 919 6812 6810 6810 7001 919 919 7001 6996 919 6996 7044 6812 6814 6815 6814 6818 6815 6859 6818 6814 6815 6818 6819 6819 6818 6984 6984 6818 6985 6859 6985 6818 6858 6857 6859 6858 6859 6860 6857 6985 6859 6984 6985 6986 6986 6985 6987 6987 6985 6988 6857 6988 6985 6764 6819 6984 6984 6986 6764 6764 6815 6819 6815 6816 6812 6717 6816 6815 6717 6815 6764 6812 6816 6817 6817 6816 6717 6811 6810 6812 6811 6812 6813 6812 6817 6813 6813 6817 6717 6813 6717 6811 6809 6810 6811 6717 7019 6811 6811 7019 7017 6811 7017 6809 7001 6810 6809 6809 7002 7001 6809 7017 7002 7001 7002 7003 7001 7003 6996 7017 7003 7002 6996 7003 7004 7017 7004 7003 6996 6997 6998 6996 7004 6997 7044 6996 6998 6997 7004 7017 6998 6997 6999 7017 6999 6997 6998 6999 7000 7045 6998 7046 7046 6998 7000 7044 6998 7045 7017 7000 6999 7016 7046 7000 7016 7000 7017 7011 7046 7016 7045 7046 7044 7044 7046 7011 7011 7016 7009 7009 7016 7017 7009 7017 7018 7017 7019 7018 7018 7019 7006 7018 7006 7020 7014 7009 7018 7014 7018 7021 7021 7018 7020 6717 7006 7019 7006 6721 6979 7020 7006 6979 6721 7006 6717 7020 6979 6977 7021 7020 7005 7005 7020 6977 7022 7014 7021 7022 7021 7023 7023 7021 7005 7005 6975 6974 7005 6977 6975 7023 7005 7024 7024 7005 6974 6975 6977 6978 6978 6977 6979 6978 6979 6721 6721 6720 6978 6978 6720 6719 6978 6719 6980 6975 6978 6976 6976 6978 6980 6974 6975 6976 6976 6980 6982 6974 6976 6965 6965 6976 6982 6980 6719 6718 6980 6718 6981 6982 6980 6981 6718 6719 6717 6717 6719 6720 6717 6720 6721 6716 6622 6717 6717 6622 6705 6717 6705 6718 6716 6717 6763 6763 6717 6764 6981 6718 6705 6705 6622 6620 6705 6620 6706 6981 6705 6706 6621 6620 6622 6716 6621 6622 6763 6621 6716 6619 6620 6621 6626 6619 6621 6763 6626 6621 6619 6618 6620 6706 6620 6618 6706 6618 6707 6983 6981 6706 6983 6706 6707 6617 6616 6618 6617 6618 6619 6707 6618 6616 6625 6617 6619 6625 6619 6626 6615 6616 6617 6624 6615 6617 6624 6617 6625 6614 6624 6625 6614 6625 6612 6612 6625 6626 6623 6615 6624 6628 6623 6624 6628 6624 6614 6654 6616 6615 6654 6615 6623 6627 6623 6628 6623 6627 6654 6641 6627 6628 6646 6641 6628 6646 6628 6614 6641 6643 6627 6643 6654 6627 6640 6643 6641 6640 6653 6643 6643 6653 6654 6640 6641 6639 6639 6653 6640 6639 6641 6642 6645 6642 6641 6645 6641 6646 6637 6638 6639 6639 6642 6637 6638 6652 6639 6639 6652 6653 6644 6637 6642 6644 6642 6645 6648 6644 6645 6648 6645 6649 6649 6645 6646 6635 6637 6644 6647 6635 6644 6647 6644 6648 6647 6648 6868 6868 6648 6649 6649 6646 6650 6868 6649 6876 6649 6650 6876 6650 6646 6614 6650 6614 6613 6876 6650 6613 6875 6868 6876 6875 6876 6877 6877 6876 6878 6876 6613 6878 6612 6613 6614 6878 6613 6933 6613 6612 6933 6877 6878 6879 6878 6884 6879 6878 6933 6884 6879 6874 6877 6877 6874 6870 6877 6870 6875 6879 6884 6885 6879 6885 6883 6883 6880 6879 6879 6880 6874 6884 6933 6934 6884 6934 6885 6883 6885 6886 6885 6934 6886 6881 6882 6883 6883 6886 6881 6882 6888 6883 6883 6888 6880 6935 6881 6886 6886 6934 6935 6881 6889 6882 6889 6881 6935 6882 6889 6890 6882 6890 6891 6891 6887 6882 6882 6887 6888 6887 6851 6888 6888 6851 6852 6888 6852 6880 6849 6850 6851 6851 6850 6852 6887 6849 6851 6852 6850 6853 6852 6853 6854 6880 6852 6854 6880 6856 6874 6880 6854 6856 6854 6853 6855 6854 6855 6856 6853 6850 6991 6853 6991 6855 6849 6841 6850 6991 6850 7052 6839 6840 6841 6841 6840 6842 6841 6842 6843 6839 6841 6849 6840 6839 6887 6887 6839 6849 6887 6905 6840 6840 6905 6906 6840 6906 6842 6843 6842 6844 6842 6906 6907 6842 6907 6844 6896 6907 6906 6896 6906 6894 6894 6906 6905 6894 6905 6891 6891 6905 6887 6891 6893 6894 6894 6893 6895 6894 6895 6896 6896 6895 6897 6896 6897 6898 6898 6907 6896 6844 6907 6908 6898 6908 6907 6898 6897 6899 6898 6899 6900 6900 6908 6898 6897 6895 6936 6936 6899 6897 6895 6893 6936 6891 6892 6893 6936 6893 6892 6890 6892 6891 6936 6892 6890 6890 6889 6936 6936 6889 6935 6936 6935 6754 6754 6935 6757 6935 6934 6759 6935 6759 6757 6756 6754 6757 6756 6757 6758 6758 6757 6759 6758 6759 6709 6709 6759 6760 6934 6760 6759 6933 6710 6934 6934 6710 6760 6709 6760 6710 6708 6709 6710 6708 6710 6761 6761 6710 6762 6933 6762 6710 6763 6762 6933 6933 6612 6626 6933 6626 6763 6761 6762 6763 6763 6764 6761 7064 6708 6761 7064 6761 6764 6764 6986 6987 6764 6987 6989 6989 6990 6764 6764 6990 6992 6764 6992 7064 6987 6988 6989 6989 6988 6990 6990 6988 6991 6990 6991 6992 6992 6991 6993 7064 6992 6993 6993 6991 6994 6993 6994 6995 7064 6993 6995 7047 6995 6994 6995 7047 7064 7047 6994 7048 7064 7047 7048 7048 6994 7049 7048 7049 7050 7066 7064 7048 7066 7048 7050 7063 6708 7064 7065 7063 7064 7065 7064 7066 7049 7065 7066 7049 7066 7050 7061 7063 7065 7061 7065 7049 7061 7062 7063 7061 7049 7062 7059 7063 7062 7059 7062 7060 7062 7049 7051 7062 7051 7060 7058 7059 7060 7058 7063 7059 7060 7051 7058 7051 7049 6782 7058 7051 6782 7058 6782 6784 7063 7058 6784 6778 6781 6782 6782 6781 6783 6782 6783 6784 6782 7049 6994 6782 6994 6778 6784 6783 7063 6783 6781 6708 7063 6783 6708 6778 6780 6781 6781 6780 6708 6708 6780 6779 6708 6779 6709 6779 6780 6778 6778 6777 6779 6709 6779 6777 6758 6709 6772 6772 6709 6776 6709 6777 6776 6773 6776 6777 6773 6777 6778 6772 6776 6773 6772 6773 6774 6758 6772 6756 6756 6772 6774 6774 6773 6769 6991 6769 6773 6991 6773 6778 6778 6994 6991 6855 6991 6988 6826 6769 6991 7052 6843 6991 6991 6843 7055 6991 7055 6836 6836 7056 6991 6991 7056 7057 6991 7057 6826 6855 6988 6857 6856 6855 6857 6856 6857 6858 6874 6856 6858 6874 6858 6860 6874 6860 6870 6860 6861 6873 6870 6860 6873 6870 6871 6872 6870 6873 6871 6875 6870 6872 6931 6871 6873 6931 6873 6955 6873 6861 6955 6872 6871 6931 6875 6872 6869 6931 6869 6872 6869 6868 6875 6866 6868 6869 6931 6866 6869 6867 6931 6932 6955 6932 6931 6867 6866 6931 6954 6953 6955 6955 6953 6932 6932 6634 6867 6634 6932 6632 6632 6932 6953 6866 6867 6868 6867 6634 6647 6867 6647 6868 6634 6632 6635 6634 6635 6647 6632 6629 6633 6632 6633 6635 6632 6953 6629 6635 6633 6637 6629 6631 6633 6633 6631 6636 6633 6636 6637 6629 6630 6631 6629 6953 6950 6629 6950 6630 6630 6651 6631 6631 6651 6652 6631 6652 6636 6637 6636 6638 6636 6652 6638 6657 6653 6652 6657 6652 6658 6658 6652 6651 6948 6658 6651 6948 6651 6630 6630 6950 6948 6947 6948 6949 6949 6948 6950 6948 6947 6956 6956 6658 6948 6658 6673 6657 6658 6956 6673 6673 6956 6957 6956 6947 7044 6957 6956 6958 6958 6956 7044 7044 6947 6949 6949 6950 6951 7044 6949 6951 6951 6950 6952 6952 6950 6953 6952 7044 6951 6952 6953 6954 6954 7044 6952 7043 7042 7044 7044 7042 6963 7044 6963 6960 6958 7044 6959 6959 7044 6960 7011 7010 7044 7044 7010 7008 7044 7008 7007 7007 7015 7044 7044 7015 7013 7044 7013 7043 7009 7010 7011 7009 7008 7010 7007 7008 7009 7014 7015 7007 7007 7009 7014 7014 7013 7015 7012 7013 7014 7012 7014 7022 7022 7028 7012 7012 7028 7027 7012 7027 7013 7023 7035 7022 7022 7035 7028 7026 7027 7028 7026 7028 7031 7031 7028 7035 7027 7026 7013 7031 7030 7026 7013 7026 7030 7029 7030 7031 7031 7035 7025 7029 7031 7034 7034 7031 7025 7025 7035 7036 7023 7036 7035 7024 7036 7023 7025 7036 6973 7024 6973 7036 6973 6971 7025 7034 7025 7037 7037 7025 6971 6972 6971 6973 6972 6973 7024 7024 6974 6964 6964 6972 7024 6970 6971 6972 6696 6970 6972 6964 6696 6972 6970 6969 6971 7037 6971 6969 6968 6969 6970 6695 6968 6970 6695 6970 6696 6695 6696 6697 6697 6696 6964 6964 6965 6697 6965 6964 6974 6695 6697 6698 6698 6697 6694 6697 6965 6966 6697 6966 6694 6692 6695 6693 6693 6695 6698 6692 6968 6695 6698 6694 6699 6693 6698 6700 6700 6698 6699 6691 6692 6693 6691 6693 6702 6702 6693 6700 6691 6962 6692 6692 6962 6968 6963 6962 6691 6963 6691 6960 6960 6691 6702 6702 6700 6703 6960 6702 6703 6700 6699 6701 6703 6700 6701 6703 6701 6704 6703 6704 6960 6677 6959 6960 6677 6960 6678 6960 6704 6688 6960 6688 6678 6704 6701 6687 6704 6687 6688 6701 6699 6686 6701 6686 6687 6686 6680 6687 6687 6680 6678 6687 6678 6688 6677 6678 6679 6679 6678 6680 6679 6680 6681 6681 6680 6682 6686 6682 6680 6666 6677 6679 6666 6679 6668 6668 6679 6681 6681 6682 6683 6668 6681 6670 6670 6681 6683 6683 6682 6684 6686 6684 6682 6654 6670 6683 6684 6616 6683 6683 6616 6654 6669 6668 6670 6689 6669 6670 6689 6670 6654 6667 6666 6668 6667 6668 6669 6672 6667 6669 6672 6669 6689 6654 6655 6689 6689 6655 6676 6689 6676 6672 6655 6654 6656 6656 6654 6653 6656 6675 6655 6655 6675 6676 6675 6671 6676 6676 6671 6672 6671 6667 6672 6664 6666 6667 6671 6664 6667 6661 6664 6671 6675 6661 6671 6674 6661 6675 6656 6674 6675 6656 6653 6657 6657 6674 6656 6673 6659 6674 6674 6659 6661 6657 6673 6674 6659 6660 6661 6660 6662 6661 6661 6662 6664 6673 6957 6659 6659 6957 6660 6660 6957 6958 6660 6958 6662 6662 6663 6664 6662 6958 6663 6663 6958 6959 6663 6665 6664 6663 6959 6665 6665 6959 6677 6664 6665 6666 6665 6677 6666 6684 6690 6616 6707 6616 6690 6685 6684 6686 6685 6690 6684 6685 6967 6690 6967 6707 6690 6967 6983 6707 6694 6966 6967 6694 6967 6685 6966 6983 6967 6694 6685 6686 6699 6694 6686 6982 6981 6983 6966 6982 6983 6965 6982 6966 6961 6962 6963 6961 6963 7041 7041 6963 7042 6962 6961 6968 6968 6961 6969 7041 6969 6961 7040 7037 7041 7041 7037 6969 7041 7042 7040 7040 7042 7039 7039 7042 7043 7039 7034 7040 7040 7034 7037 7038 7032 7039 7039 7032 7034 7039 7043 7038 7043 7013 7038 7013 7032 7038 7032 7033 7034 7013 7033 7032 7034 7033 7029 7029 7033 7013 7013 7030 7029 6824 6825 6826 6826 6825 6827 6826 6827 6828 7053 6767 6826 6826 6767 6769 6822 6823 6824 6824 6823 6825 6836 6837 6822 6822 6837 6838 6822 6838 6823 6923 6825 6823 6923 6823 6865 6865 6823 6838 6865 6838 6837 6836 6835 6837 6865 6837 6835 6833 6835 6836 6833 6834 6835 6834 6911 6835 6835 6911 6912 6835 6912 6865 6919 6923 6865 6919 6865 6917 6917 6865 6912 6917 6912 6915 6915 6912 6911 6915 6916 6917 6917 6916 6918 6917 6918 6919 6919 6918 6920 6919 6920 6921 6921 6923 6919 6916 6938 6918 6918 6938 6939 6918 6939 6920 6915 6914 6916 6914 6938 6916 6903 6913 6914 6903 6914 6915 6913 6937 6914 6914 6937 6938 6902 6913 6903 6913 6902 6937 6902 6903 6901 6937 6902 6901 6900 6899 6901 6901 6903 6904 6901 6904 6900 6937 6901 6936 6936 6901 6899 6904 6909 6900 6900 6909 6908 6903 6910 6904 6904 6910 6909 6845 6908 6909 6845 6909 6846 6846 6909 6910 6844 6908 6845 6843 6844 6845 6845 6846 6843 6843 6846 6847 6846 6910 6847 6847 6910 6911 6903 6911 6910 6843 6847 6833 6833 6847 6848 6847 6911 6848 6848 6911 6834 6915 6911 6903 6833 6848 6834 6754 6752 6936 6936 6752 6750 6750 6748 6936 6936 6748 6746 6936 6746 6744 6744 6742 6936 6936 6742 6740 6936 6740 6937 6747 6746 6748 6747 6748 6749 6749 6748 6750 6745 6744 6746 6745 6746 6747 6743 6742 6744 6743 6744 6745 6741 6740 6742 6741 6742 6743 6741 6743 6768 6743 6745 6768 6768 6745 6747 6768 6747 6749 6749 6750 6751 6749 6751 6768 6751 6750 6752 6751 6752 6753 6768 6751 6753 6753 6752 6754 6753 6754 6755 6768 6753 6755 6755 6754 6756 6756 6770 6755 6755 6770 6768 6756 6774 6775 6775 6771 6756 6756 6771 6770 6769 6768 6770 6769 6770 6771 6775 6769 6771 6774 6769 6775 6767 6768 6769 6767 6766 6768 6741 6768 6738 6738 6768 6766 6765 6766 6767 6738 6766 6736 6736 6766 6765 6736 6737 6738 6737 6739 6738 6738 6739 6740 6738 6740 6741 6734 6735 6736 6736 6735 6737 6736 6765 6734 6767 6787 6765 6734 6765 6787 6732 6733 6734 6734 6733 6735 6734 6787 6732 6733 6938 6735 6735 6938 6937 6735 6937 6737 6937 6739 6737 6937 6740 6739 6731 6939 6938 6731 6938 6733 6732 6731 6733 6730 6731 6732 6787 6730 6732 6730 6729 6731 6729 6939 6731 6920 6939 6924 6924 6939 6940 6728 6940 6939 6728 6939 6729 6727 6728 6729 6727 6729 6730 6787 6727 6730 6724 6726 6727 6726 6728 6727 6786 6724 6727 6786 6727 6787 6726 6940 6728 6724 6725 6726 6725 6940 6726 6722 6723 6724 6723 6725 6724 6785 6724 6786 6785 6722 6724 6785 6786 6767 6767 6786 6787 6712 6785 6767 6712 6711 6785 6785 6711 6722 6711 6713 6722 6722 6713 6723 6723 6713 6941 6723 6941 6725 6725 6941 6940 6924 6940 6925 6925 6940 6941 6920 6924 6921 6921 6924 6925 6921 6925 6926 6925 6927 6926 6925 6941 6927 6926 6922 6921 6921 6922 6923 6829 6827 6922 6922 6827 6825 6922 6825 6923 6829 6922 6864 6864 6922 6926 6828 6827 6829 6828 6829 6830 6830 6829 6831 6864 6831 6829 6862 6863 6864 6831 6864 6832 6832 6864 6863 6864 6926 6862 6830 6831 6821 6821 6831 6832 7053 6830 6767 6767 6830 7054 6767 7054 6790 6790 7054 952 6789 6767 6790 6789 6790 6791 6796 6791 6790 6790 952 6796 6788 6767 6789 6791 6944 6789 6944 6946 6789 6789 6946 6788 6795 6791 6796 6791 6795 6944 6610 6795 6796 6606 6944 6795 6606 6795 6610 6609 6606 6610 6796 6609 6610 6605 6604 6606 6608 6605 6606 6608 6606 6609 6604 6944 6606 6796 6608 6609 6607 6605 6608 6568 6607 6608 6568 6608 6796 6568 6567 6607 6607 6567 6605 6567 6568 6569 6796 6569 6568 6570 6567 6571 6571 6567 6569 6567 6570 6605 6571 6569 6572 6569 950 6572 6796 950 6569 6571 6572 6797 6797 6572 950 6602 6570 6571 6797 6596 6571 6571 6596 6595 6571 6595 6602 6602 6574 6570 6605 6570 6574 6595 6575 6602 6602 6575 6574 6595 6596 6588 6588 6593 6595 6595 6593 6575 6588 6596 6597 6597 6596 6797 6588 6589 6586 6588 6597 6589 6586 6591 6588 6588 6591 6593 6797 6589 6597 6586 6589 6590 6797 6590 6589 6586 6590 6587 6587 6590 6579 6799 6579 6590 6799 6590 6797 6582 6586 6587 6582 6587 6576 6587 6579 6576 6579 6580 6581 6576 6579 6581 6580 6579 6799 6576 6577 6578 6582 6576 6583 6583 6576 6578 6576 6581 6577 6580 6820 6581 6581 6820 6863 6581 6863 6577 6820 6580 6799 6799 6821 6820 6821 6832 6820 6832 6863 6820 6577 6863 6862 6577 6862 6578 6862 6926 6929 6862 6929 6930 6578 6862 6930 6926 6927 6928 6926 6928 6929 6928 6942 6929 6942 6930 6929 6578 6930 6584 6942 6584 6930 6583 6578 6584 6943 6583 6584 6943 6584 6942 6582 6583 6943 6585 6586 6582 6943 6585 6582 6585 6601 6586 6943 6601 6585 6586 6601 6591 6591 6601 6943 6591 6592 6593 6943 6592 6591 6593 6592 6594 6943 6594 6592 6594 6598 6593 6593 6598 6599 6593 6599 6575 6599 6598 6594 6599 6594 6943 6575 6599 6600 6943 6600 6599 6573 6574 6575 6575 6600 6573 6943 6573 6600 6574 6573 6611 6611 6573 6943 6605 6574 6603 6603 6574 6611 6603 6611 6945 6945 6611 6943 6603 6604 6605 6603 6945 6604 6604 6945 6944 6945 6943 6944 6944 6943 6946 6943 6793 6946 6946 6793 6792 6946 6792 6788 6767 6792 6793 6767 6793 6794 6943 6794 6793 6788 6792 6767 6794 6715 6767 6767 6715 6714 6767 6714 6712 6942 6715 6794 6942 6794 6943 6713 6714 6715 6941 6713 6715 6941 6715 6942 6713 6712 6714 6711 6712 6713 6928 6941 6942 6927 6941 6928 6799 952 6821 6803 6799 6804 6804 6799 6797 6803 952 6799 952 6803 6807 6807 6803 6804 6804 6797 6805 6807 6804 6805 6807 6805 961 6796 952 6807 6796 6807 961 6805 6797 6802 961 6805 6802 6797 6801 6802 961 6802 6808 6808 6802 6801 6797 6800 6801 6808 6801 6806 6806 6801 6800 961 6808 6796 6796 6808 950 6808 6806 950 6798 959 6806 6806 6800 6798 950 6806 959 6798 6800 6797 6797 1321 6798 1321 959 6798 950 958 6797 6797 958 1321 958 1135 1321 1322 959 1321 1321 1135 1322 958 959 1321 958 959 950 950 959 960 960 959 1322 958 950 1135 950 908 1135 1135 908 1136 1135 1136 1137 1322 1135 1137 907 906 908 949 908 950 908 949 907 1136 908 906 950 960 949 907 949 961 1322 961 949 1322 949 960 907 961 951 951 961 1322 951 952 907 952 951 1322 907 952 953 1211 953 952 1322 1211 952 907 953 939 1210 953 1211 1210 939 953 1322 1210 1211 1331 1210 1322 1322 1137 1331 1186 1188 1210 1188 1212 1210 1210 1212 939 1331 1186 1210 939 940 907 939 1212 940 940 1212 1213 1188 1213 1212 907 940 941 940 1213 941 941 1213 942 942 1213 954 954 1213 1214 1296 1214 1213 1296 1213 1188 907 941 942 942 954 907 907 954 955 954 1214 955 955 1214 943 943 1214 1215 1297 1215 1214 1297 1214 1296 1188 1206 1296 1296 1206 1295 1296 1295 1297 1297 1295 1293 1297 1293 1298 1298 1215 1297 1294 1293 1295 1294 1295 1191 1191 1295 1206 1292 1291 1293 1292 1293 1294 1298 1293 1291 1291 1289 1298 1298 1289 1216 1298 1216 1215 1290 1291 1292 1290 1288 1291 1291 1288 1289 1288 1283 1289 1289 1283 1217 1289 1217 1216 1287 1180 1288 1288 1180 1283 1290 1287 1288 1180 1282 1283 1282 1310 1283 1283 1310 1185 1283 1185 1217 1180 1181 1182 1182 1282 1180 1287 1181 1180 1182 1281 1282 1281 1305 1282 1282 1305 1310 1305 1183 1310 1310 1183 1185 1304 1306 1305 1305 1306 1307 1305 1307 1308 1308 1309 1305 1305 1309 1183 1306 1304 1119 1119 1307 1306 1119 1308 1307 1309 1308 1119 1313 1183 1309 1313 1309 1119 1118 1073 1119 1119 1073 1072 1119 1072 1120 1120 1313 1119 1312 1183 1313 1121 1312 1313 1121 1313 1120 1121 1120 1068 1068 1120 1072 1072 1073 1074 1068 1072 1067 1067 1072 1074 1074 1073 1075 1074 1075 1076 1067 1074 1066 1066 1074 1076 1066 998 1067 1067 998 997 1067 997 1068 1065 999 1066 1066 999 998 1066 1076 1065 1065 1076 1088 1064 1000 1065 1065 1000 999 1065 1088 1064 928 998 999 928 999 947 947 999 948 948 999 1000 948 1000 931 931 1000 930 930 1000 1001 1064 1001 1000 1063 1001 1064 930 1001 929 929 911 930 930 911 931 911 948 931 911 947 948 928 947 911 911 927 928 927 998 928 911 926 927 926 998 927 926 997 998 925 926 911 925 997 926 997 925 924 1068 997 924 911 924 925 923 922 924 923 924 911 1068 924 922 1121 1068 1122 1122 1068 922 921 922 923 921 923 1184 1184 923 911 1311 921 1184 1183 1184 1185 1184 911 1185 1311 1184 1312 1312 1184 1183 1122 1311 1312 1122 1312 1121 1185 911 912 1185 912 913 1217 1185 913 911 907 912 912 907 913 907 957 913 1217 913 957 1217 957 956 1216 1217 956 907 956 957 946 956 907 1216 956 946 1216 946 945 1215 1216 945 907 945 946 907 944 945 1215 945 944 943 1215 944 943 944 907 907 955 943 905 906 907 911 910 907 1129 907 910 1129 905 907 909 910 911 911 938 909 7427 910 909 909 938 7427 938 909 8310 8310 909 910 8310 9761 938 7425 8309 8310 7425 8310 8311 8310 910 8311 8310 9762 9761 8309 9783 8310 8308 8309 7425 8309 8308 8315 8315 9784 8309 8309 9784 9783 8318 9783 9784 8318 9784 8320 8320 9784 8322 8322 9784 8323 8323 9784 9785 8315 9785 9784 8321 8320 8322 8321 8322 8323 8323 8316 8321 8323 9785 8316 8316 9785 8303 8312 8303 9785 8312 9785 8315 8302 8301 8316 8316 8303 8302 8302 8303 7774 7774 8303 8304 8304 8303 8312 7774 8301 8302 7774 8304 8305 7758 7759 7774 7774 7759 7771 7771 7772 7774 8305 8306 7774 7774 8306 8307 7774 8307 7758 8305 8304 8312 8312 8313 8305 8305 8313 8306 8307 8306 8313 7757 7758 8307 7757 8307 7755 7755 8307 8313 7755 8313 7756 7756 8313 8314 8312 8314 8313 7424 7755 7756 7757 7755 7758 7758 7755 7424 7756 7760 7424 7756 8314 7760 7760 8314 8308 8315 8308 8314 8315 8314 8312 7424 7760 7761 7760 8308 7761 7425 7761 8308 7424 7761 7425 7424 7425 910 8311 910 7425 7427 7424 910 7758 7424 7759 7407 7759 7424 7771 7759 7407 7771 7407 7772 1129 1348 905 1342 906 905 905 1348 1342 5963 905 906 6545 906 905 905 6546 6545 6546 905 5962 5962 905 5963 906 1342 1136 906 5904 5963 6545 5904 906 5904 5905 5906 5963 5904 5906 5905 5904 6545 5906 5905 5907 5896 5905 6548 6548 5905 6545 5896 5907 5905 5910 5909 5906 5910 5906 5911 5911 5906 5907 5963 5906 5909 5901 5911 5907 5901 5907 5896 5891 5910 5911 5891 5911 5901 5908 5909 5910 5893 5908 5910 5893 5910 5891 5891 5892 5893 5901 5902 5891 5891 5902 5903 5891 5903 5892 5896 5900 5901 5901 5900 5902 6181 5903 5902 6181 5902 6178 6178 5902 5900 6183 5892 5903 6183 5903 6181 6178 6047 6181 6181 6047 6182 6181 6182 6183 6178 6179 6180 6180 6045 6178 6178 6045 6047 6178 5900 6179 6179 6297 6180 5899 6297 6179 5899 6179 5900 6180 6297 6298 5898 6298 6297 5898 6297 5899 5898 5899 5896 5896 5899 5900 5896 5897 5898 6528 5898 6536 6536 5898 5897 6528 6298 5898 6180 6298 6296 6528 6296 6298 6527 6296 6528 6535 6527 6528 6535 6528 6536 6544 6535 6536 6544 6536 5897 6554 6544 5897 5897 5896 6554 6554 5896 6548 6545 6547 6548 6548 6547 6549 6548 6549 6550 6554 6548 6550 6545 6546 6547 6551 6549 6547 6547 5798 6551 6546 5798 6547 6551 6550 6549 6554 6550 6551 6553 6445 6554 6554 6445 6513 6554 6513 6516 6516 6537 6554 6554 6537 6538 6554 6538 6539 6539 6540 6554 6554 6540 6541 6554 6541 6542 6542 6543 6554 6554 6543 6544 6554 6551 6553 6540 6532 6541 6541 6532 6533 6541 6533 6542 6542 6533 6534 6542 6534 6543 6543 6534 6535 6543 6535 6544 6533 6526 6534 6534 6526 6527 6534 6527 6535 6532 6525 6533 6533 6525 6526 6525 6295 6526 6526 6295 6294 6526 6294 6527 6527 6294 6296 6294 6295 6180 6294 6180 6296 6295 6299 6180 6525 6299 6295 6524 6299 6525 6532 6524 6525 6180 6299 6300 6524 6300 6299 6523 6291 6524 6291 6300 6524 6531 6523 6524 6531 6524 6532 6540 6531 6532 6530 6523 6531 6539 6530 6531 6539 6531 6540 6522 6292 6523 6523 6292 6291 6530 6522 6523 6529 6522 6530 6538 6529 6530 6538 6530 6539 6521 6289 6522 6289 6293 6522 6522 6293 6292 6529 6521 6522 6291 6292 6288 6288 6292 6293 6288 6293 6289 6288 6289 6287 6287 6289 6290 6521 6290 6289 6519 6290 6521 6520 6519 6521 6520 6521 6529 6287 6290 6285 6519 6285 6290 6518 6286 6519 6518 6519 6517 6286 6285 6519 6517 6519 6520 6516 6517 6520 6516 6520 6537 6537 6520 6529 6516 6513 6517 6517 6513 6514 6517 6514 6518 6513 6445 6514 6514 6445 6444 6514 6444 6515 6518 6514 6515 6444 6445 6446 6446 6445 6553 6447 6444 6448 6444 6446 6448 6515 6444 6447 6515 6447 5979 6518 6515 5987 5987 6515 5979 5976 6447 6449 6447 6448 6449 5979 6447 5976 6448 6446 6450 6448 6450 6451 6449 6448 6451 5976 6449 5977 5977 6449 6469 6449 6451 6469 5976 5977 5973 5976 5973 5979 5973 5977 5978 5977 6469 5978 5978 6469 6470 6469 6451 6453 6469 6453 6470 6451 6450 6452 6451 6452 6453 6452 6454 6453 6453 6454 6455 6453 6455 6456 6470 6453 6456 5978 6470 5974 5974 6470 6471 6470 6456 6471 5973 5978 5974 5973 5974 5968 5968 5974 5975 5974 6471 5975 5975 6471 6472 6471 6456 6458 6471 6458 6472 6456 6455 6457 6456 6457 6458 6457 6459 6458 6458 6459 6460 6458 6460 6461 6472 6458 6461 5975 6472 5970 5970 6472 6473 6472 6461 6473 5968 5975 5970 5970 5971 5968 5970 6473 5971 5971 6473 6474 6473 6461 6463 6473 6463 6474 6461 6460 6462 6461 6462 6463 6462 6460 6557 6557 6460 6459 6462 6464 6463 6462 6557 6464 6463 6464 6465 6463 6465 6466 6474 6463 6466 6464 6557 6558 6464 6558 6465 6466 6465 6467 6558 6467 6465 6466 6467 6468 6474 6466 6475 6475 6466 6468 6467 6478 6468 6558 6478 6467 6559 6478 6558 6557 6559 6558 6468 6478 6479 6559 6479 6478 6468 6479 6480 6475 6468 6476 6476 6468 6480 5972 6474 6475 5972 6475 5966 5966 6475 6476 5966 6476 5967 5967 6476 6477 6476 6480 6477 5966 5967 5968 5968 5972 5966 5968 5971 5972 5971 6474 5972 5968 5967 5969 6318 6314 5968 5968 6314 5973 5968 5969 6318 5967 5988 5969 5967 6477 5988 5969 5988 5989 5988 6477 5989 5969 5989 5990 6318 5969 6319 5969 5990 6319 5990 5989 5991 5989 6477 6485 5989 6485 5991 5990 5991 5992 5991 6485 6486 5991 6486 5992 6477 6482 6485 6485 6482 6443 6485 6443 6486 6486 6443 6419 6486 6419 6422 5992 6486 6422 5992 5993 5990 5992 6422 5993 6422 6419 6423 5993 6422 6424 6422 6423 6424 6419 6420 6421 6419 6421 6423 6420 6419 6443 6423 6421 6429 6423 6429 6430 6424 6423 6430 6421 6420 6560 6421 6560 6429 6443 6484 6420 6484 6560 6420 6443 6483 6484 6483 6559 6484 6484 6559 6560 6482 6481 6483 6482 6483 6443 6559 6483 6481 6481 6479 6559 6557 6560 6559 6480 6479 6481 6480 6481 6482 6477 6480 6482 6563 6433 6560 6560 6433 6431 6560 6431 6429 6556 6555 6560 6560 6555 6553 6560 6553 6563 6556 6560 6557 6430 6429 6431 6430 6431 6432 6432 6431 6433 6424 6430 6425 6425 6430 6432 6432 6433 6434 6425 6432 6426 6426 6432 6434 6434 6433 6435 6434 6435 6436 6426 6434 6427 6427 6434 6436 6563 6435 6433 6436 6435 6367 6367 6435 6563 6436 6367 6366 6427 6436 6428 6428 6436 6366 6366 6367 6368 6368 6367 6563 6369 6366 6370 6366 6368 6370 6428 6366 6369 6370 6368 6373 6563 6373 6368 6370 6373 6374 6369 6370 6371 6371 6370 6374 6016 6369 6371 6369 6016 6428 6016 6371 6017 6017 6371 6372 6371 6374 6372 6374 6373 6375 6374 6375 6376 6372 6374 6376 6563 6375 6373 6375 6377 6376 6377 6375 6562 6562 6375 6563 6376 6377 6378 6376 6378 6379 6372 6376 6406 6406 6376 6379 6562 6378 6377 6564 6380 6562 6562 6380 6378 6563 6565 6562 6562 6565 6564 6379 6378 6380 6379 6380 6381 6406 6379 6407 6407 6379 6381 6042 6372 6406 6042 6406 6043 6043 6406 6407 6407 6381 6408 6043 6407 6044 6044 6407 6408 6019 6042 6043 6019 6043 6039 6039 6043 6044 6018 6042 6019 6018 6372 6042 6017 6372 6018 6015 6017 6018 6015 6018 6019 6326 6015 6019 6326 6019 6039 6039 6040 6030 6039 6044 6040 6326 6039 6030 6044 6408 6040 6030 6040 6041 6040 6408 6409 6040 6409 6041 6030 6041 6031 6041 6409 6410 6041 6410 6031 6408 6384 6409 6409 6384 6386 6409 6386 6410 6410 6386 6388 6410 6388 6411 6031 6410 6411 6030 6031 6032 6031 6411 6032 6411 6388 6391 6411 6391 6412 6032 6411 6412 6032 6033 6030 6032 6412 6033 6412 6391 6393 6412 6393 6413 6033 6412 6413 6388 6390 6391 6391 6390 6392 6391 6392 6393 6393 6392 6394 6393 6394 6395 6413 6393 6395 6413 6395 6414 6033 6413 6034 6034 6413 6414 6030 6033 6034 6030 6034 6035 6034 6414 6035 6414 6395 6398 6414 6398 6415 6035 6414 6415 6394 6396 6395 6395 6396 6397 6395 6397 6398 6398 6397 6399 6398 6399 6400 6415 6398 6400 6415 6400 6416 6035 6415 6036 6036 6415 6416 6035 6036 6030 6030 6036 6037 6036 6416 6037 6416 6400 6403 6416 6403 6417 6037 6416 6417 6030 6037 6029 6029 6037 6038 6037 6417 6038 6326 6030 6334 6334 6030 6029 6028 6027 6029 6029 6038 6028 6334 6029 6339 6339 6029 6027 6038 6417 6418 6038 6418 6028 6020 6027 6028 6020 6028 6437 6437 6028 6418 6020 6026 6027 6339 6027 6340 6340 6027 6026 6337 6334 6339 6337 6339 6336 6336 6339 6340 6340 6026 6341 6336 6340 6335 6335 6340 6341 6025 6026 6020 6341 6026 6025 6341 6025 6342 6335 6341 6338 6338 6341 6342 6020 6024 6025 6342 6025 6024 6342 6024 6343 6338 6342 6333 6333 6342 6343 6210 6335 6338 6210 6338 6333 6333 6212 6210 6333 6343 6347 6212 6333 6206 6206 6333 6347 6343 6024 6023 6343 6023 6344 6347 6343 6344 6020 6023 6024 6022 6023 6020 6023 6022 6344 6344 6022 6345 6344 6345 6346 6347 6344 6348 6348 6344 6346 6020 6021 6022 6345 6022 6363 6363 6022 6021 6021 6020 6440 6440 6020 6437 6363 6021 6361 6021 6440 6361 6440 6437 6441 6361 6440 6496 6504 6496 6440 6504 6440 6441 6437 6418 6438 6441 6437 6438 6441 6438 6442 6512 6504 6441 6512 6441 6442 6503 6496 6504 6511 6503 6504 6511 6504 6512 6511 6512 6551 6551 6512 6442 6442 6438 6439 6551 6442 6552 6552 6442 6439 6438 6418 6405 6438 6405 6439 6417 6405 6418 6403 6404 6405 6417 6403 6405 6439 6405 6404 6552 6439 6404 6403 6402 6404 6552 6404 6402 6400 6402 6403 6400 6401 6402 6552 6402 6566 6566 6402 6401 6399 6401 6400 6566 6401 6399 6397 6561 6566 6397 6566 6399 6563 6552 6566 6566 6561 6563 6396 6561 6397 6396 6394 6561 6561 6394 6565 6563 6561 6565 6563 6553 6552 6553 6551 6552 6446 6553 6450 6450 6553 6555 6450 6555 6452 6556 6455 6555 6555 6455 6454 6555 6454 6452 6557 6459 6556 6556 6459 6457 6556 6457 6455 6551 5798 5797 6551 5797 6505 6505 6506 6551 6551 6506 6507 6551 6507 6508 6508 6509 6551 6551 6509 6510 6551 6510 6511 6505 6498 6506 6506 6498 6499 6506 6499 6507 6507 6499 6500 6507 6500 6508 6508 6500 6501 6508 6501 6509 6509 6501 6502 6509 6502 6510 6510 6502 6503 6510 6503 6511 6501 6495 6502 6502 6495 6497 6502 6497 6503 6500 6494 6501 6501 6494 6495 6499 6493 6500 6500 6493 6494 6493 6350 6494 6350 6359 6494 6494 6359 6360 6494 6360 6495 6492 6351 6493 6493 6351 6350 6499 6492 6493 6350 6351 6055 6350 6358 6359 6350 6055 6358 6359 6358 6360 6358 6365 6360 6365 6495 6360 6363 6364 6358 6358 6364 6365 6358 6055 6054 6358 6054 6363 6364 6495 6365 6364 6497 6495 6363 6362 6364 6362 6497 6364 6362 6496 6497 6503 6497 6496 6361 6362 6363 6361 6496 6362 6349 6346 6363 6363 6346 6345 6363 6054 6053 6363 6053 6349 6348 6346 6349 6208 6348 6349 6208 6349 6053 6051 6052 6053 6053 6054 6051 6052 6208 6053 6052 6207 6208 6207 6348 6208 6207 6347 6348 6206 6207 6052 6206 6347 6207 6052 6051 6057 6206 6052 6211 6211 6052 6057 6211 6212 6206 6209 6210 6211 6211 6210 6212 6211 6057 6218 6209 6211 6217 6217 6211 6218 6209 6217 6335 6209 6335 6210 6215 6216 6217 6217 6218 6215 6335 6217 6216 6335 6214 6336 6335 6216 6214 6215 6214 6216 6213 6214 6215 6336 6214 6213 6336 6213 6337 6215 5780 6213 6337 6213 5780 6337 5780 6332 6332 6334 6337 5780 5781 5769 6215 5781 5780 5769 6332 5780 6331 6326 6332 5769 6331 6332 6332 6326 6334 6330 6325 6331 6331 6325 6326 5764 6330 6331 5764 6331 5769 6325 6015 6326 6324 6011 6325 6011 6013 6325 6325 6013 6015 6330 6324 6325 6013 6014 6015 6015 6014 6016 6016 6017 6015 6011 6012 6013 6013 6012 6014 6009 6010 6011 6011 6010 6012 6324 6009 6011 6010 6428 6012 6428 6014 6012 6428 6016 6014 6010 6427 6428 6009 6008 6010 6008 6427 6010 6007 6008 6009 6007 6009 6324 6007 6006 6008 6006 6427 6008 6006 6426 6427 6005 6004 6006 6005 6006 6007 6004 6426 6006 6323 6005 6007 6323 6007 6324 6329 6323 6324 6329 6324 6330 6322 6005 6323 6328 6322 6323 6328 6323 6329 6003 6004 6005 6322 6003 6005 6003 6002 6004 6002 6426 6004 6002 6425 6426 6001 6000 6002 6001 6002 6003 6000 6425 6002 6001 6003 6322 5999 6000 6001 6001 6322 5999 5999 5998 6000 6000 5998 6425 6425 5998 5996 6425 5996 6424 5997 5996 5998 5997 5998 5999 5999 6322 6321 5999 6321 5997 5995 5996 5997 5997 6321 5995 5995 5994 5996 6424 5996 5994 6424 5994 5993 5990 5993 5994 5990 5994 5995 6319 5990 5995 6319 5995 6321 6320 6319 6321 6320 6321 6327 6327 6321 6322 6318 6319 6317 6317 6319 6320 5755 6317 6320 5755 6320 5756 5756 6320 6327 6327 6322 6328 5756 6327 5774 5774 6327 6328 5774 6328 5757 5757 6328 6329 5757 6329 5753 5753 6329 6330 5753 6330 5764 5751 5752 5753 5760 5757 5753 5760 5753 5761 5752 5762 5753 5753 5762 5763 5753 5763 5761 5764 5765 5753 5753 5765 5766 5766 5767 5753 5753 5767 5768 5753 5768 5751 6266 5761 5763 6266 5763 6267 6267 5763 5762 6265 5761 6266 6267 6235 6266 6266 6235 6236 6266 6236 6265 6267 5762 6268 6268 6234 6267 6267 6234 6235 6234 6131 6235 6235 6131 6129 6235 6129 6236 6233 6118 6234 6234 6118 6116 6234 6116 6131 6268 6233 6234 6130 6129 6131 6130 6131 6115 6115 6131 6116 6128 6127 6129 6128 6129 6130 6129 6127 6236 5852 6128 6130 5852 6130 5853 5853 6130 6115 6115 6116 6117 5853 6115 5838 5838 6115 6117 6117 6116 6118 6118 6125 6117 5838 6117 6125 5837 5838 5839 5839 5838 5840 5837 5853 5838 5838 6125 5840 5837 5852 5853 5851 5852 5837 5839 5937 5837 5837 5937 5938 5837 5938 5851 5839 5840 5841 5841 5935 5839 5839 5935 5937 5840 5842 5841 5840 6125 6124 5840 6124 5842 5841 5842 5843 5841 5843 5844 5844 5939 5841 5841 5939 5935 5935 5936 5937 5935 5939 5936 5936 5939 5940 5844 5940 5939 5844 5843 5845 5844 5845 5846 5846 5940 5844 5936 5940 5941 5941 5940 5942 5846 5942 5940 5937 5936 5933 5963 5933 5936 5963 5936 5941 5941 5942 5943 5941 5943 5963 5943 5942 5944 5832 5944 5942 5832 5942 5846 5943 5944 5945 5834 5945 5944 5834 5944 5832 5832 5833 5834 5846 5847 5832 5832 5847 5848 5832 5848 5833 5834 5833 5835 5834 5835 5820 5820 5945 5834 5945 5946 5943 5820 5946 5945 5820 5821 5822 5820 5822 5823 5820 5835 5836 5820 5836 5821 5823 5946 5820 5943 5946 5947 5823 5947 5946 5823 5822 5824 5823 5824 5825 5825 5947 5823 5821 6099 5822 5822 6099 5824 6097 6098 6099 6097 6099 6100 6100 6099 6101 6099 6098 5824 5821 6101 6099 6096 6098 6097 5824 6098 6096 6095 6094 6096 6095 6096 6097 5824 6096 6094 6093 6094 6095 6093 6095 6227 6227 6095 6097 6093 6092 6094 5824 6094 5826 5826 6094 6092 6091 6092 6093 6226 6091 6093 6226 6093 6227 6091 6084 6092 5826 6092 5828 5828 6092 6084 5825 5824 5826 5825 5826 5827 5827 5826 5828 5827 5828 5829 5829 5828 5830 5828 6084 5830 5829 5951 5827 5827 5951 5949 5827 5949 5825 5825 5949 5947 5948 5947 5949 5948 5949 5950 5950 5949 5951 5955 5950 5951 5829 5955 5951 5829 5830 5818 5818 5955 5829 5954 5950 5955 5818 5954 5955 5954 5953 5950 5963 5948 5950 5950 5953 5963 5943 5947 5948 5963 5943 5948 5962 5963 5964 5964 5963 5960 5909 5914 5963 5963 5914 5916 5963 5916 5919 5919 5924 5963 5963 5924 5926 5963 5926 5931 5931 5933 5963 5963 5953 5958 5963 5958 5960 5926 5930 5931 5931 5930 5932 5931 5932 5933 5933 5932 5934 5937 5933 5938 5938 5933 5934 5849 5934 5932 5849 5932 5858 5858 5932 5930 5851 5938 5934 5851 5934 5849 5849 5850 5851 5858 5859 5849 5849 5859 5860 5849 5860 5850 5856 5857 5858 5858 5857 5859 5858 5930 5856 5857 6135 5859 5859 6135 6133 5859 6133 5860 5860 6133 6132 5860 6132 5850 6126 6132 6133 6126 6133 6134 6133 6135 6134 6134 6135 6136 5857 6136 6135 6134 6136 6137 6237 6126 6134 6237 6134 6238 6134 6137 6238 6137 6136 6138 5857 6138 6136 6137 6138 6139 6238 6137 6139 6238 6139 6239 6264 6237 6238 6264 6238 6263 6263 6238 6239 6139 6138 6140 6139 6140 6141 6139 6141 6239 6140 6138 5857 6141 6140 6142 5857 5855 6140 6140 5855 5867 6140 5867 6142 6141 6142 6143 6239 6141 6143 6143 6142 6144 6144 6142 6145 6142 5867 5866 5866 6145 6142 5854 5866 5867 5854 5867 5855 5854 5855 5856 5856 5855 5857 5865 5866 5854 5856 5929 5854 5854 5929 5925 5854 5925 5865 5865 5864 5866 5864 6152 5866 5866 6152 6145 5863 5864 5865 5865 5925 5927 5865 5927 5863 5925 5926 5927 5925 5929 5926 5926 5929 5930 5856 5930 5929 5927 5926 5924 5927 5924 5928 5863 5927 5928 5919 5923 5924 5928 5924 5923 5863 5928 5869 5869 5928 5923 5919 5922 5923 5869 5923 5871 5871 5923 5922 5918 5919 5920 5920 5919 5916 5918 5922 5919 5871 5922 5873 5873 5922 5918 5870 5869 5871 5870 5871 5872 5872 5871 5873 5872 5873 5874 5874 5873 5875 5873 5918 5875 5875 5918 5920 5874 5875 5876 5876 5875 5877 5875 5920 5877 5876 6150 5874 5874 6150 6148 5874 6148 5872 5872 6148 6162 5872 6162 5870 6147 6148 6149 6149 6148 6150 6147 6162 6148 6147 6161 6162 5870 6162 6161 6160 6161 6147 6243 6160 6147 6243 6147 6244 6244 6147 6149 6149 6150 6151 6149 6151 6244 6244 6151 6049 6244 6049 6245 6258 6243 6244 6258 6244 6257 6257 6244 6245 6151 6150 6049 6049 6150 6164 5876 6164 6150 6049 6164 6163 5878 6164 5876 5878 6163 6164 5876 5877 5878 5877 5883 5878 5883 6050 5878 5878 6050 6163 6050 6049 6163 6048 6049 6050 6048 6050 6165 6165 6050 6166 5883 6166 6050 5877 5882 5883 5882 6166 5883 6165 6166 6167 6167 6166 6168 5882 6168 6166 5881 5880 5882 5881 5882 5877 5880 6168 5882 6167 6168 6169 6169 6168 6170 5880 6170 6168 6165 6167 6247 6247 6167 6169 6169 6170 6171 6247 6169 6248 6169 6171 6248 6171 6170 6172 5880 6172 6170 6171 6172 6173 6248 6171 6173 6248 6173 6249 6254 6247 6248 6254 6248 6253 6253 6248 6249 6173 6172 6174 6173 6174 6175 6249 6173 6175 5890 6174 6172 5890 6172 5880 6175 6174 6176 5889 6176 6174 5889 6174 5890 6175 6176 6177 6175 6177 6249 6192 6177 6176 5887 6192 6176 5887 6176 5889 5888 5887 5889 5888 5889 5879 5879 5889 5890 5879 5890 5880 5879 5880 5881 5881 5917 5879 5879 5917 5915 5879 5915 5888 5886 5887 5888 5888 5915 5913 5888 5913 5886 5886 5885 5887 5885 6192 5887 5884 5885 5886 5886 5913 5912 5886 5912 5884 5909 5912 5913 5909 5913 5914 5914 5913 5915 5914 5915 5916 5916 5915 5917 5920 5916 5921 5921 5916 5917 5877 5920 5921 5877 5921 5881 5881 5921 5917 5908 5912 5909 5884 5912 5908 5884 5908 5893 5893 5892 5894 5893 5894 5884 6185 5894 5892 6185 5892 6183 5884 5894 5895 5894 6187 6189 5894 6189 5895 6187 5894 6185 5884 5895 5885 5895 6189 6191 5895 6191 5885 6187 6188 6189 6189 6188 6190 6189 6190 6191 6185 6186 6187 6187 6186 6188 6190 6188 6250 6250 6188 6186 6191 6190 6177 6249 6177 6190 6249 6190 6250 6191 6177 6192 5885 6191 6192 6250 6186 6283 6252 6249 6250 6252 6250 6251 6251 6250 6283 6185 6184 6186 6283 6186 6184 6283 6184 6201 6251 6283 6193 6193 6283 6201 6193 5785 6251 6251 5785 5784 6251 5784 6252 6193 6194 5755 5755 5754 6193 6193 5754 5785 6193 6201 6194 5756 5784 5785 5756 5785 5754 5777 5784 5756 6252 5784 5777 5754 5755 5756 5774 5775 5756 5756 5775 5776 5756 5776 5777 6194 6198 5755 5755 6198 6317 6194 6197 6198 6198 6197 6316 6317 6198 6316 6317 6316 6318 6315 6314 6316 6316 6197 6196 6316 6196 6315 6318 6316 6314 6196 6197 6194 6194 6195 6196 6315 6196 6195 6306 6313 6315 6315 6313 6314 6315 6195 6306 6313 5973 6314 6312 5980 6313 6313 5980 5973 6306 6312 6313 5979 5973 5980 5979 5980 5981 6312 5981 5980 6311 5981 6312 6307 6311 6312 6307 6312 6306 5981 5982 5979 6311 5982 5981 6310 5982 6311 6308 6310 6311 6308 6311 6307 6306 6199 6307 6307 6199 6202 6307 6202 6308 6308 6202 6205 6308 6205 6304 6304 6310 6308 6309 5983 6310 6310 5983 5982 6304 6309 6310 5979 5982 5983 5979 5983 5984 6309 5984 5983 6303 5984 6309 6305 6303 6309 6305 6309 6304 5984 5985 5979 6303 5985 5984 5979 5985 5986 5979 5986 5987 6284 5986 5985 6284 5985 6303 6301 6284 6303 6301 6303 6302 6302 6303 6305 5987 5986 6284 5987 6284 6287 6287 6284 6301 6287 6286 5987 5987 6286 6518 6285 6286 6287 6287 6301 6302 6180 6288 6287 6180 6287 6045 6045 6287 6302 6045 6302 6046 6305 6046 6302 6045 6046 6047 6046 6203 6047 6305 6203 6046 6304 6203 6305 6047 6203 6204 6304 6204 6203 6047 6204 6201 6201 6182 6047 6201 6204 6205 6304 6205 6204 6201 6205 6202 6199 6200 6201 6199 6201 6202 6201 6184 6182 6194 6201 6200 6183 6182 6184 6183 6184 6185 6194 6200 6195 6306 6195 6200 6306 6200 6199 6180 6300 6291 6291 6288 6180 6252 5777 6253 6253 5777 5776 6253 6249 6252 6253 5776 6254 6254 5776 5775 6254 5775 6255 6255 6247 6254 5774 5790 5775 6255 5775 5790 6255 5790 6256 6256 6246 6255 6255 6246 6247 6246 6165 6247 6245 6165 6246 6256 6245 6246 6256 5790 5789 6256 5789 6257 6257 6245 6256 5774 5789 5790 5779 5789 5774 6257 5789 5779 6257 5779 6258 5778 5779 5774 6258 5779 5778 6258 5778 6259 6259 6243 6258 5774 5788 5778 6259 5778 5788 6259 5788 6260 6260 6242 6259 6259 6242 6243 6242 6158 6243 6158 6160 6243 6241 6154 6242 6154 6156 6242 6242 6156 6158 6260 6241 6242 6156 6157 6158 6158 6157 6159 6158 6159 6160 6160 6159 6161 5868 6161 6159 5868 6159 6157 6156 6155 6157 5868 6157 5861 5861 6157 6155 6154 6155 6156 6154 6153 6155 5861 6155 5862 5862 6155 6153 5861 5862 5863 5861 5863 5868 5868 5863 5869 5868 5869 5870 5870 6161 5868 5863 5862 5864 5862 6153 5864 6146 6152 6153 6146 6153 6154 5864 6153 6152 6145 6152 6146 6144 6145 6146 6240 6144 6146 6240 6146 6241 6241 6146 6154 6143 6144 6240 6239 6143 6240 6262 6239 6240 6262 6240 6261 6261 6240 6241 6261 6241 6260 6260 5787 6261 6261 5787 5786 6261 5786 6262 6262 5786 5759 6262 5759 6263 6263 6239 6262 5759 5786 5757 5757 5786 5787 5757 5787 5774 5774 5787 5788 6260 5788 5787 5757 5758 5759 5758 5757 5760 6263 5759 5758 6263 5758 6264 6264 5758 5760 6264 5760 6265 6265 5760 5761 6265 6237 6264 6265 6236 6237 6236 6126 6237 6236 6127 6126 6126 6127 6128 6128 6132 6126 5850 6132 6128 5850 6128 5852 5851 5850 5852 6049 6048 6245 6245 6048 6165 5958 5959 5960 5960 5959 5961 5964 5960 5965 5965 5960 5961 5953 5957 5958 5958 5957 5959 5952 5953 5954 5952 5956 5953 5953 5956 5957 5812 5959 5957 5812 5957 5810 5810 5957 5956 5810 5956 5795 5795 5956 5952 5795 5952 5816 5816 5952 5954 5816 5954 5818 5815 5795 5816 5815 5816 5817 5817 5816 5818 5793 5794 5795 5795 5794 5810 5793 5795 5815 5810 5794 5811 5810 5811 5812 6075 5811 5794 6075 5794 6077 6077 5794 5793 6077 5793 6079 6079 5793 5815 6079 5815 6086 6086 5815 5817 6078 6077 6079 6078 6079 6080 6079 6086 6080 6076 6075 6077 6076 6077 6078 6223 6076 6078 6078 6080 6223 6080 6086 6087 6080 6087 6088 6223 6080 6088 6086 5817 6087 6088 6087 6089 6087 5817 6089 6088 6089 6081 6223 6088 6224 6088 6081 6224 6081 6089 6090 6089 5817 5819 6089 5819 6090 5817 5818 5819 5818 5831 5819 6090 5819 5831 6081 6090 6082 6090 5831 5830 5830 6082 6090 6081 6082 6083 6224 6081 6083 6083 6082 6084 5830 6084 6082 5818 5830 5831 6083 6084 6085 6085 6084 6091 6224 6083 6225 6083 6085 6225 6225 6085 6091 6225 6091 6226 6277 6224 6225 6277 6225 6276 6276 6225 6226 6276 6226 6275 6275 6226 6227 6275 5772 6276 6276 5772 5771 6276 5771 6277 6274 5773 6275 6275 5773 5772 6275 6227 6274 6227 6097 6228 6274 6227 6228 6273 5765 6274 6274 5765 5773 6274 6228 6273 5764 5772 5773 5764 5773 5765 5771 5772 5764 5764 5770 5771 6277 5771 5770 5769 5770 5764 5769 5792 5770 6277 5770 6278 6278 5770 5792 6278 6224 6277 6278 5792 6279 6279 6223 6278 6278 6223 6224 5769 5791 5792 6279 5792 5791 6279 5791 6280 6280 6222 6279 6279 6222 6223 6222 6076 6223 6221 6072 6222 6072 6074 6222 6222 6074 6076 6280 6221 6222 6280 5791 5783 6280 5783 6281 6281 6221 6280 5783 5791 5769 5769 5782 5783 6281 5783 5782 6281 5782 6282 6282 6220 6281 6281 6220 6221 5769 5781 5782 6282 5782 5781 6282 5781 6215 6215 6219 6282 6282 6219 6220 6219 6065 6220 6065 6068 6220 6220 6068 6070 6220 6070 6221 6065 6067 6068 6068 6067 6069 6068 6069 6070 6070 6069 6071 6070 6071 6072 6221 6070 6072 6067 5813 6069 6069 5813 6071 6072 6071 6073 6071 5813 6073 6072 6073 6074 6074 6073 6075 6073 5813 5811 6073 5811 6075 6074 6075 6076 5812 5811 5813 5812 5813 5800 5800 5959 5812 5800 5801 5802 5800 5813 5814 5800 5814 5801 5802 5961 5800 5800 5961 5959 5802 5801 5803 5801 6067 5803 5801 5814 6067 5802 5803 5804 5804 5965 5802 5802 5965 5961 5803 5805 5804 5804 5805 5806 5804 5806 5807 5807 5964 5804 5804 5964 5965 6060 5806 5805 6060 5805 6062 6062 5805 5803 5807 5806 5808 6058 5808 5806 6058 5806 6060 5807 5808 5798 5798 5962 5807 5807 5962 5964 5798 5808 5809 6051 6056 5808 5808 6056 5809 6051 5808 6058 6057 6051 6058 6057 6058 6059 6059 6058 6060 6051 6054 6055 6051 6055 6056 6355 6056 6356 6356 6056 6055 6355 5809 6056 6356 5799 6355 6355 5799 5809 5798 5809 5799 5796 5798 5799 6356 5796 5799 6356 6055 6357 6357 5796 6356 5796 5797 5798 6357 6487 5796 5796 6487 6488 5796 6488 5797 5962 5798 6546 5797 6488 6490 5797 6490 6505 6488 6487 6489 6488 6489 6490 6487 6357 6354 6487 6354 6489 6357 6055 6354 6055 6353 6354 6489 6354 6353 6489 6353 6491 6490 6489 6491 6490 6491 6498 6505 6490 6498 6491 6353 6352 6491 6352 6492 6498 6491 6492 6055 6352 6353 6351 6352 6055 6492 6352 6351 6498 6492 6499 6059 6060 6061 6061 6060 6062 6057 6059 6218 6218 6059 6061 6061 6062 6063 6218 6061 6219 6061 6063 6219 6063 6062 6064 6062 5803 6064 6063 6064 6065 6219 6063 6065 6215 6218 6219 6064 6066 6065 6065 6066 6067 5803 6066 6064 5803 6067 6066 6067 5814 5813 6273 5766 5765 6272 5766 6273 6273 6228 6229 6273 6229 6272 6272 5767 5766 6271 5767 6272 6272 6229 6230 6272 6230 6271 6228 6102 6229 6102 6104 6229 6229 6104 6106 6229 6106 6230 6097 6100 6228 6228 6100 6102 6100 6101 6102 6102 6101 6103 6102 6103 6104 6104 6103 6105 6104 6105 6106 6106 6105 6107 6106 6107 6108 6230 6106 6108 5835 6107 6105 5835 6105 5836 5836 6105 6103 5836 6103 6101 5836 6101 5821 5833 6107 5835 6108 6107 6109 5833 6109 6107 6108 6109 6110 6230 6108 6231 6108 6110 6231 6110 6109 6111 5848 6111 6109 5848 6109 5833 6110 6111 6112 6231 6110 6112 6231 6112 6232 6271 6230 6231 6271 6231 6270 6270 6231 6232 6112 6111 6113 6112 6113 6114 6232 6112 6114 5847 6111 5848 5847 6113 6111 6113 6119 6114 5847 6119 6113 6114 6119 6120 6114 6120 6121 6114 6121 6232 5845 6120 6119 5845 6119 5847 5846 5845 5847 5843 6120 5845 6121 6120 6122 5843 6122 6120 6121 6122 6123 6232 6121 6123 6123 6122 6124 5842 6124 6122 5842 6122 5843 6123 6124 6118 6232 6123 6233 6233 6123 6118 6270 6232 6269 6269 6232 6233 6269 6233 6268 6268 5752 6269 6269 5752 5751 6269 5751 6270 6270 5751 5768 6270 5768 6271 6271 5768 5767 6268 5762 5752 6118 6124 6125 6390 6389 6565 6565 6389 6387 6565 6387 6564 6565 6394 6392 6565 6392 6390 6388 6389 6390 6387 6389 6388 6386 6385 6387 6386 6387 6388 6564 6387 6385 6383 6382 6564 6564 6382 6380 6564 6385 6383 6384 6383 6385 6384 6385 6386 6381 6382 6383 6381 6383 6384 6380 6382 6381 6408 6381 6384 6537 6529 6538 1127 1139 1136 1136 1139 1140 1136 1140 1141 1136 1144 1145 1141 1149 1136 1136 1149 1150 1136 1150 1144 1145 1151 1136 1136 1151 1152 1136 1152 1137 1136 1342 1343 1136 1343 1127 1332 1152 1151 1332 1151 1333 1333 1151 1145 1331 1137 1152 1331 1152 1332 1207 1331 1332 1207 1332 1208 1208 1332 1209 1209 1332 1333 1187 1186 1331 1187 1331 1207 1206 1207 1208 1187 1207 1188 1188 1207 1206 1209 1206 1208 1189 1191 1209 1191 1206 1209 1209 1333 1189 1189 1190 1191 1189 1333 1190 1194 1294 1191 1194 1191 1192 1192 1191 1190 1190 1333 1334 1190 1334 1192 1192 1193 1194 1192 1334 1193 1193 1334 1335 1333 1145 1334 1334 1145 1144 1334 1144 1335 1193 1267 1194 1193 1335 1267 1267 1335 1336 1335 1144 1150 1335 1150 1336 1267 1205 1268 1194 1267 1268 1267 1336 1205 1205 1336 1337 1336 1150 1149 1336 1149 1337 1195 1197 1205 1268 1205 1197 1205 1337 1195 1268 1197 1269 1194 1268 1274 1274 1268 1269 1274 1294 1194 1274 1269 1275 1275 1292 1274 1274 1292 1294 1269 1197 1260 1269 1260 1270 1275 1269 1270 1275 1270 1276 1276 1290 1275 1275 1290 1292 1270 1260 1262 1270 1262 1271 1276 1270 1271 1197 1198 1260 1260 1198 1261 1260 1261 1262 1262 1261 1263 1262 1263 1264 1271 1262 1264 1271 1264 1272 1276 1271 1277 1277 1271 1272 1264 1263 1265 1264 1265 1266 1272 1264 1266 1255 1265 1263 1255 1263 1254 1254 1263 1261 1256 1266 1265 1256 1265 1255 1272 1266 1273 1257 1273 1266 1257 1266 1256 1255 1238 1256 1256 1238 1236 1256 1236 1257 1254 1241 1255 1255 1241 1238 1238 1239 1236 1241 1242 1238 1238 1242 1243 1238 1243 1239 1246 1247 1241 1241 1247 1248 1241 1248 1242 1254 1246 1241 900 1243 1242 900 1242 902 1248 902 1242 898 1239 1243 898 1243 900 899 898 900 899 900 901 901 900 902 901 902 891 891 902 903 1247 903 902 1247 902 1248 1037 899 901 1037 901 1033 1033 901 891 897 898 899 1040 897 899 1040 899 1037 1036 1037 1033 1036 1040 1037 1033 1034 1030 1033 1030 1036 1033 891 1034 1036 1030 1022 1036 1022 1092 1092 1038 1036 1036 1038 1040 1038 1039 1040 1039 897 1040 1092 1102 1038 1102 1041 1038 1038 1041 1043 1038 1043 1039 1092 1022 1025 1092 1025 1093 1093 1102 1092 1093 1101 1102 1093 1025 1084 1093 1084 1094 1094 1101 1093 1094 1100 1101 1094 1084 1085 1094 1085 1095 1095 1100 1094 1025 982 1084 1084 982 984 1084 984 1085 1085 984 985 982 983 984 1083 985 984 984 983 1083 982 1020 983 983 1020 1021 982 1019 1020 1019 1170 1020 1018 1019 982 1018 1167 1019 1019 1167 1170 1167 1157 1170 1170 1157 1156 1129 1156 1157 1129 1157 1142 1167 1142 1157 1129 1142 1132 1132 1348 1129 1132 1142 1143 1168 1143 1142 1168 1142 1167 1132 1143 1130 1169 1130 1143 1169 1143 1168 1167 1024 1168 1168 1024 1023 1168 1023 1169 1169 1023 1032 1169 1032 1161 1161 1130 1169 1130 1131 1132 1161 1131 1130 1132 1131 974 1158 974 1131 1158 1131 1160 1160 1131 1161 973 974 975 1132 974 1133 1133 974 973 974 1158 975 975 1158 1160 1160 1161 1162 975 1160 976 976 1160 1162 975 976 977 975 977 973 976 978 977 976 1162 978 1162 1161 1163 978 1162 979 979 1162 1163 977 978 979 977 979 972 979 1163 972 1161 1166 1163 1163 1166 972 962 887 972 972 887 977 972 1166 1165 972 1165 962 1161 1165 1166 1029 1164 1165 1029 1165 1161 962 1165 1164 962 888 887 962 1164 888 1028 1164 1029 1164 1028 888 1028 1029 1030 1030 1029 1031 1161 1031 1029 1030 1035 1028 1035 889 1028 888 1028 889 887 888 889 892 887 889 1035 892 889 1030 1034 1035 1034 892 1035 1030 1031 1022 1022 1031 1032 1161 1032 1031 1022 1023 1024 1022 1024 1025 1022 1032 1023 1025 1024 1026 1167 1026 1024 1025 1026 1027 1027 1018 1025 1025 1018 982 1167 1027 1026 1018 1027 1167 891 887 892 1034 891 892 886 890 891 891 890 887 891 903 886 977 887 890 977 890 980 980 890 886 973 977 980 980 886 967 973 980 981 981 980 967 1133 973 1134 1134 973 981 981 967 965 1134 981 1128 1128 981 965 1128 1345 1134 1134 1345 1346 1134 1346 1133 1133 1346 1347 1133 1347 1132 1345 1347 1346 1128 1344 1345 1344 1347 1345 964 1127 1128 1128 965 964 1127 1344 1128 1127 1343 1344 1343 1347 1344 1132 1347 1348 1342 1348 1347 1342 1347 1343 1126 1127 964 1126 1138 1127 1127 1138 1139 1126 964 1325 1341 1138 1126 1341 1126 1328 1328 1126 1325 1339 1139 1138 1339 1138 1341 1340 1140 1139 1340 1139 1339 1339 1201 1340 1341 1249 1339 1339 1249 1202 1339 1202 1201 1328 1250 1341 1341 1250 1249 1249 1250 1246 1202 1249 1203 1203 1249 1246 1201 1202 1203 1201 1203 1204 1340 1201 1204 1203 1246 1254 1254 1261 1203 1203 1261 1198 1203 1198 1204 1204 1198 1200 1340 1204 1338 1338 1204 1200 1198 1199 1200 1197 1199 1198 1338 1200 1199 1338 1199 1337 1337 1141 1338 1338 1141 1140 1338 1140 1340 1196 1199 1197 1337 1199 1196 1195 1196 1197 1337 1196 1195 1337 1149 1141 1244 1245 1246 1246 1245 1247 1252 1244 1246 1252 1246 1253 1253 1246 1250 1244 904 1245 1245 904 903 1245 903 1247 886 903 904 886 904 884 1244 884 904 884 885 886 885 970 886 886 970 971 967 886 971 1251 884 1244 1251 1323 884 884 1323 885 1324 970 885 1324 885 1323 1330 971 970 1330 970 1324 967 971 969 969 971 1330 1252 1329 1330 1252 1330 1324 1329 969 1330 1323 1252 1324 1323 1251 1252 1251 1244 1252 1328 1329 1252 1252 1253 1328 1328 1327 1329 1327 968 1329 1329 968 969 968 967 969 966 967 968 1326 966 968 1326 968 1327 1326 1327 1328 1328 1325 1326 1328 1253 1250 1325 966 1326 965 967 966 965 966 963 1325 963 966 964 963 1325 963 964 965 1043 895 1039 1039 895 897 1041 1042 1043 1042 893 1043 1043 893 895 893 894 895 895 894 896 895 896 897 897 896 898 894 1240 896 896 1240 1239 896 1239 898 893 870 894 870 1237 894 894 1237 1240 1236 1239 1240 1236 1240 1237 1235 1236 1237 870 1235 1237 1235 1233 1236 1257 1236 1233 1234 1233 1235 871 1234 1235 871 1235 870 1232 1230 1233 1232 1233 1234 1257 1233 1258 1258 1233 1230 1258 1273 1257 1258 1230 1259 1259 1279 1258 1258 1279 1273 1278 1272 1273 1278 1273 1279 1277 1272 1278 1278 1301 1277 1277 1301 1302 1277 1302 1276 1301 1286 1302 1302 1286 1287 1302 1287 1290 1276 1302 1290 1286 1182 1181 1286 1181 1287 1259 1230 1226 1259 1226 1224 1229 1226 1230 1229 1230 1231 1231 1230 1232 1226 1227 1228 1227 1226 1229 1224 1226 1228 1229 858 1227 1227 858 859 1227 859 1228 863 862 1228 1228 862 861 1228 859 864 1228 864 863 641 862 863 641 863 642 642 863 864 640 861 862 640 862 641 640 641 569 569 641 642 569 642 636 642 864 636 636 864 859 636 570 569 636 859 570 568 569 570 568 845 569 845 643 569 570 633 568 570 859 633 568 633 634 568 634 631 858 634 633 858 633 859 631 634 635 635 634 858 631 635 632 858 632 635 868 1231 1232 868 1232 867 867 1232 1234 626 868 867 867 627 626 867 617 627 617 618 615 618 617 867 615 618 619 867 619 618 615 619 613 613 838 615 613 619 620 867 620 619 613 620 614 614 620 867 612 610 613 612 613 614 610 837 613 613 837 838 837 817 838 838 817 818 836 816 837 837 816 817 610 836 837 816 681 817 817 681 679 817 679 818 679 677 818 818 677 676 678 677 679 678 679 680 680 679 681 680 681 682 681 688 682 816 688 681 483 678 680 483 680 485 680 682 485 670 677 678 488 670 678 488 678 483 670 676 677 668 670 488 476 488 483 476 483 484 484 483 485 5612 476 484 484 485 478 5612 484 5610 5610 484 5611 5611 484 478 478 479 480 478 485 486 478 486 479 480 479 481 480 481 470 470 481 482 479 685 481 481 685 687 481 687 482 470 471 469 470 482 471 687 699 482 482 699 701 482 701 471 469 471 472 701 703 471 471 703 705 471 705 472 468 467 469 469 472 468 713 468 472 713 472 711 711 472 705 708 468 713 711 712 713 713 712 714 713 714 708 705 710 711 711 710 712 714 712 805 805 712 710 708 714 715 804 715 714 804 714 805 707 283 708 708 715 707 802 707 715 802 715 804 803 802 804 803 804 825 825 804 805 791 790 802 790 707 802 791 802 803 706 283 707 790 706 707 717 706 790 717 790 783 783 790 791 574 803 825 573 574 575 575 574 576 576 574 577 574 825 577 850 571 573 850 573 575 575 576 850 576 577 578 576 578 850 850 578 585 850 585 874 577 585 578 577 584 585 874 585 584 874 584 875 583 582 584 583 584 577 875 584 582 582 580 875 581 580 582 581 582 583 577 826 583 583 826 827 583 827 581 581 827 828 826 806 827 827 806 807 827 807 828 825 805 826 826 805 806 577 825 826 805 710 806 806 710 709 806 709 807 705 709 710 704 709 705 709 704 807 703 704 705 703 702 704 807 704 702 701 702 703 701 700 702 807 702 808 808 702 700 699 700 701 699 698 700 808 700 809 700 698 809 828 807 808 828 808 829 829 808 809 809 698 697 809 697 810 829 809 830 830 809 810 687 697 698 687 698 699 686 697 687 810 697 686 810 686 811 830 810 831 831 810 811 589 829 830 589 830 593 593 830 831 831 811 832 593 831 591 591 831 832 832 811 812 832 812 833 591 832 600 600 832 833 596 591 599 599 591 600 599 600 601 601 600 602 600 833 602 833 812 813 833 813 834 602 833 834 601 602 603 603 602 604 604 602 605 602 834 605 601 603 869 869 599 601 869 596 599 603 604 869 869 604 870 869 870 893 1046 869 893 604 605 606 604 606 870 606 605 607 605 834 835 605 835 607 606 607 608 870 606 608 608 607 609 609 607 610 607 835 836 607 836 610 834 814 835 835 814 815 835 815 836 836 815 816 814 691 815 815 691 689 815 689 816 813 693 814 814 693 691 834 813 814 690 689 691 690 691 692 692 691 693 682 688 689 682 689 690 689 688 816 485 682 690 485 690 486 690 692 486 692 693 694 486 692 694 694 693 695 813 695 693 812 695 813 694 695 683 683 695 696 812 696 695 486 694 479 694 683 479 683 684 685 683 696 684 479 683 685 811 684 696 811 696 812 685 684 686 686 684 811 685 686 687 609 610 611 611 610 612 608 609 870 870 609 611 870 611 612 614 867 612 612 867 871 612 871 870 867 1234 871 1046 893 1042 1041 1046 1042 5609 5610 5611 1186 1187 1188 1073 1108 1075 1118 1123 1073 1073 1123 1108 1105 1108 1103 1123 1124 1108 1108 1124 1125 1108 1125 1103 1103 1104 1105 1104 1109 1105 1105 1109 991 1109 1114 991 7800 9102 7801 7801 9102 9103 9102 9365 9103 7801 9103 7807 7807 9103 9104 9103 9365 9367 9103 9367 9104 9365 9364 9366 9365 9366 9367 9367 9366 9368 9367 9368 9369 9104 9367 9369 7807 9104 7808 7808 9104 9105 9104 9369 9105 9369 9368 9370 9369 9370 9371 9105 9369 9371 7808 9105 7804 7804 9105 9106 9105 9371 9106 9371 9370 9372 9371 9372 9373 9106 9371 9373 7804 9106 7805 7805 9106 9107 9106 9373 9107 9373 9372 9374 9373 9374 9375 9107 9373 9375 7805 9107 7806 7806 9107 9108 9107 9375 9108 9375 9374 9376 9375 9376 9377 9108 9375 9377 7806 9108 7781 7781 9108 9109 9108 9377 9109 9377 9376 9378 9377 9378 9379 9109 9377 9379 7781 9109 7782 7782 9109 9110 9109 9379 9110 9379 9378 9380 9379 9380 9381 9110 9379 9381 7782 9110 7813 7813 9110 9111 9110 9381 9111 9381 9380 9382 9381 9382 9383 9111 9381 9383 7813 9111 7814 7814 9111 9112 9111 9383 9112 9383 9382 9384 9383 9384 9385 9112 9383 9385 7814 9112 7809 7809 9112 9113 9112 9385 9113 9385 9384 9386 9385 9386 9387 9113 9385 9387 7809 9113 7810 7810 9113 9114 9113 9387 9114 9387 9386 9388 9387 9388 9389 9114 9387 9389 7810 9114 7811 7811 9114 9115 9114 9389 9115 9389 9388 9390 9389 9390 9391 9115 9389 9391 7811 9115 7812 7812 9115 9116 9115 9391 9116 9391 9390 9392 9391 9392 9393 9116 9391 9393 7812 9116 7819 7819 9116 9117 9116 9393 9117 9393 9392 9394 9393 9394 9395 9117 9393 9395 7819 9117 7820 7820 9117 9118 9117 9395 9118 9395 9394 9396 9395 9396 9397 9118 9395 9397 7820 9118 7815 7815 9118 9119 9118 9397 9119 9397 9396 9398 9397 9398 9399 9119 9397 9399 7815 9119 7816 7816 9119 9120 9119 9399 9120 9399 9398 9400 9399 9400 9401 9120 9399 9401 7816 9120 7817 7817 9120 9121 9120 9401 9121 9401 9400 9402 9401 9402 9403 9121 9401 9403 7817 9121 7818 7818 9121 9122 9121 9403 9122 9403 9402 9404 9403 9404 9405 9122 9403 9405 7818 9122 7825 7825 9122 9123 9122 9405 9123 9405 9404 9406 9405 9406 9407 9123 9405 9407 7825 9123 7826 7826 9123 9124 9123 9407 9124 9407 9406 9408 9407 9408 9409 9124 9407 9409 7826 9124 7821 7821 9124 9125 9124 9409 9125 9409 9408 9410 9409 9410 9411 9125 9409 9411 7821 9125 7822 7822 9125 9126 9125 9411 9126 9411 9410 9412 9411 9412 9413 9126 9411 9413 7822 9126 7823 7823 9126 9127 9126 9413 9127 9413 9412 9414 9413 9414 9415 9127 9413 9415 7823 9127 7824 7824 9127 9128 9127 9415 9128 9415 9414 9416 9415 9416 9417 9128 9415 9417 7824 9128 7831 7831 9128 9129 9128 9417 9129 9417 9416 9418 9417 9418 9419 9129 9417 9419 7831 9129 7832 7832 9129 9130 9129 9419 9130 9419 9418 9420 9419 9420 9421 9130 9419 9421 7832 9130 7827 7827 9130 9131 9130 9421 9131 9421 9420 9422 9421 9422 9423 9131 9421 9423 7827 9131 7828 7828 9131 9132 9131 9423 9132 9423 9422 9424 9423 9424 9425 9132 9423 9425 7828 9132 7829 7829 9132 9133 9132 9425 9133 9425 9424 9426 9425 9426 9427 9133 9425 9427 7829 9133 7830 7830 9133 9134 9133 9427 9134 9427 9426 9428 9427 9428 9429 9134 9427 9429 7830 9134 7837 7837 9134 9135 9134 9429 9135 9429 9428 9430 9429 9430 9431 9135 9429 9431 7837 9135 7838 7838 9135 9136 9135 9431 9136 9431 9430 9432 9431 9432 9433 9136 9431 9433 7838 9136 7833 7833 9136 9137 9136 9433 9137 9433 9432 9434 9433 9434 9435 9137 9433 9435 7833 9137 7834 7834 9137 9138 9137 9435 9138 9435 9434 9436 9435 9436 9437 9138 9435 9437 7834 9138 7835 7835 9138 9139 9138 9437 9139 9437 9436 9438 9437 9438 9439 9139 9437 9439 7835 9139 7836 7836 9139 9140 9139 9439 9140 9439 9438 9440 9439 9440 9441 9140 9439 9441 7836 9140 7843 7843 9140 9141 9140 9441 9141 9441 9440 9442 9441 9442 9443 9141 9441 9443 7843 9141 7844 7844 9141 9142 9141 9443 9142 9443 9442 9444 9443 9444 9445 9142 9443 9445 7844 9142 7839 7839 9142 9143 9142 9445 9143 9445 9444 9446 9445 9446 9447 9143 9445 9447 7839 9143 7840 7840 9143 9144 9143 9447 9144 9447 9446 9448 9447 9448 9449 9144 9447 9449 7840 9144 7841 7841 9144 9145 9144 9449 9145 9449 9448 9450 9449 9450 9451 9145 9449 9451 7841 9145 7842 7842 9145 9146 9145 9451 9146 9451 9450 9452 9451 9452 9453 9146 9451 9453 7842 9146 7848 7848 9146 9147 9146 9453 9147 9453 9452 9454 9453 9454 9455 9147 9453 9455 7848 9147 7849 7849 9147 9148 9147 9455 9148 9455 9454 9456 9455 9456 9457 9148 9455 9457 7849 9148 7845 7845 9148 9149 9148 9457 9149 9457 9456 9458 9457 9458 9459 9149 9457 9459 7845 9149 7846 7846 9149 9150 9149 9459 9150 9459 9458 9460 9459 9460 9461 9150 9459 9461 7846 9150 7847 7847 9150 9151 9150 9461 9151 9461 9460 9462 9461 9462 9463 9151 9461 9463 7847 9151 7779 7779 9151 9152 9151 9463 9152 9463 9462 9464 9463 9464 9465 9152 9463 9465 7779 9152 7780 7780 9152 9153 9152 9465 9153 9465 9464 9466 9465 9466 9467 9153 9465 9467 7780 9153 7854 7854 9153 9154 9153 9467 9154 9467 9466 9468 9467 9468 9469 9154 9467 9469 7854 9154 7855 7855 9154 9155 9154 9469 9155 9469 9468 9470 9469 9470 9471 9155 9469 9471 7855 9155 7850 7850 9155 9156 9155 9471 9156 9471 9470 9472 9471 9472 9473 9156 9471 9473 7850 9156 7851 7851 9156 9157 9156 9473 9157 9473 9472 9474 9473 9474 9475 9157 9473 9475 7851 9157 7852 7852 9157 9158 9157 9475 9158 9475 9474 9476 9475 9476 9477 9158 9475 9477 7852 9158 7853 7853 9158 9159 9158 9477 9159 9477 9476 9478 9477 9478 9479 9159 9477 9479 7853 9159 7856 7856 9159 9160 9159 9479 9160 9479 9478 9480 9479 9480 9481 9160 9479 9481 7856 9160 7857 7857 9160 9161 9160 9481 9161 9481 9480 9482 9481 9482 9483 9161 9481 9483 7857 9161 7858 7858 9161 9162 9161 9483 9162 9483 9482 9484 9483 9484 9485 9162 9483 9485 7858 9162 7859 7859 9162 9163 9162 9485 9163 9485 9484 9486 9485 9486 9487 9163 9485 9487 7859 9163 7860 7860 9163 9164 9163 9487 9164 9487 9486 9488 9487 9488 9489 9164 9487 9489 7860 9164 7861 7861 9164 9165 9164 9489 9165 9489 9488 9490 9489 9490 9491 9165 9489 9491 7861 9165 7862 7862 9165 9166 9165 9491 9166 9491 9490 9492 9491 9492 9493 9166 9491 9493 7862 9166 7863 7863 9166 9167 9166 9493 9167 9493 9492 9494 9493 9494 9495 9167 9493 9495 7863 9167 7864 7864 9167 9168 9167 9495 9168 9495 9494 9496 9495 9496 9497 9168 9495 9497 7864 9168 7865 7865 9168 9169 9168 9497 9169 9497 9496 9498 9497 9498 9171 9169 9497 9171 7865 9169 7866 7866 9169 9170 9169 9171 9170 9171 9172 9173 9171 9498 9172 9170 9171 9173 7866 9170 7867 7867 9170 9010 9170 9173 9010 9173 9172 9174 9173 9174 9175 9010 9173 9175 7867 9010 7868 7868 9010 9011 9010 9175 9011 9175 9174 9176 9175 9176 9177 9011 9175 9177 7868 9011 7869 7869 9011 9012 9011 9177 9012 9177 9176 9178 9177 9178 9179 9012 9177 9179 7869 9012 7870 7870 9012 9013 9012 9179 9013 9179 9178 9180 9179 9180 9181 9013 9179 9181 7870 9013 7871 7871 9013 9014 9013 9181 9014 9181 9180 9182 9181 9182 9183 9014 9181 9183 7871 9014 7872 7872 9014 9015 9014 9183 9015 9183 9182 9184 9183 9184 9185 9015 9183 9185 7872 9015 7873 7873 9015 9016 9015 9185 9016 9185 9184 9186 9185 9186 9187 9016 9185 9187 7873 9016 7874 7874 9016 9017 9016 9187 9017 9187 9186 9188 9187 9188 9189 9017 9187 9189 7874 9017 7875 7875 9017 9018 9017 9189 9018 9189 9188 9190 9189 9190 9191 9018 9189 9191 7875 9018 7876 7876 9018 9019 9018 9191 9019 9191 9190 9192 9191 9192 9193 9019 9191 9193 7876 9019 7877 7877 9019 9020 9019 9193 9020 9193 9192 9194 9193 9194 9195 9020 9193 9195 7877 9020 7878 7878 9020 9021 9020 9195 9021 9195 9194 9196 9195 9196 9197 9021 9195 9197 7878 9021 7879 7879 9021 9022 9021 9197 9022 9197 9196 9198 9197 9198 9199 9022 9197 9199 7879 9022 7880 7880 9022 9023 9022 9199 9023 9199 9198 9200 9199 9200 9201 9023 9199 9201 7880 9023 7881 7881 9023 9024 9023 9201 9024 9201 9200 9202 9201 9202 9203 9024 9201 9203 7881 9024 7882 7882 9024 9025 9024 9203 9025 9203 9202 9204 9203 9204 9205 9025 9203 9205 7882 9025 7883 7883 9025 9026 9025 9205 9026 9205 9204 9206 9205 9206 9207 9026 9205 9207 7883 9026 7884 7884 9026 9027 9026 9207 9027 9207 9206 9208 9207 9208 9209 9027 9207 9209 7884 9027 7885 7885 9027 9028 9027 9209 9028 9209 9208 9210 9209 9210 9211 9028 9209 9211 7885 9028 7886 7886 9028 9029 9028 9211 9029 9211 9210 9212 9211 9212 9213 9029 9211 9213 7886 9029 7887 7887 9029 9030 9029 9213 9030 9213 9212 9214 9213 9214 9215 9030 9213 9215 7887 9030 7888 7888 9030 9031 9030 9215 9031 9215 9214 9216 9215 9216 9217 9031 9215 9217 7888 9031 7889 7889 9031 9032 9031 9217 9032 9217 9216 9218 9217 9218 9219 9032 9217 9219 7889 9032 7890 7890 9032 9033 9032 9219 9033 9219 9218 9220 9219 9220 9221 9033 9219 9221 7890 9033 7891 7891 9033 9034 9033 9221 9034 9221 9220 9222 9221 9222 9223 9034 9221 9223 7891 9034 7892 7892 9034 9035 9034 9223 9035 9223 9222 9224 9223 9224 9225 9035 9223 9225 7892 9035 7893 7893 9035 9036 9035 9225 9036 9225 9224 9226 7893 9036 7894 7415 7416 7096 7096 7416 7100 7416 7163 7100 7413 7415 7096 7096 7093 7413 7413 7093 7092 7413 7092 7411 7088 7092 7093 7088 7093 7094 7094 7093 7095 7095 7093 7096 7091 7092 7088 7411 7092 7091 7094 7536 7088 7088 7536 7664 7095 7536 7094 7095 7096 7097 7097 7535 7095 7095 7535 7536 7096 7125 7097 7125 7534 7097 7097 7534 7535 7096 7124 7125 7124 7533 7125 7125 7533 7534 7123 7124 7096 7123 7532 7124 7124 7532 7533 7096 7160 7123 7160 7531 7123 7123 7531 7532 7096 7159 7160 7159 7530 7160 7160 7530 7531 7158 7159 7096 7158 7529 7159 7159 7529 7530 7096 7157 7158 7157 7528 7158 7158 7528 7529 7096 7156 7157 7156 7527 7157 7157 7527 7528 7155 7156 7096 7155 7526 7156 7156 7526 7527 7096 7154 7155 7154 7525 7155 7155 7525 7526 7096 7153 7154 7153 7524 7154 7154 7524 7525 7152 7153 7096 7152 7523 7153 7153 7523 7524 7096 7151 7152 7151 7522 7152 7152 7522 7523 7096 7150 7151 7150 7521 7151 7151 7521 7522 7127 7150 7096 7127 7520 7150 7150 7520 7521 7126 7127 7096 7126 7519 7127 7127 7519 7520 7096 7130 7126 7130 7518 7126 7126 7518 7519 7096 7129 7130 7129 7517 7130 7130 7517 7518 7128 7129 7096 7128 7516 7129 7129 7516 7517 7096 7133 7128 7133 7515 7128 7128 7515 7516 7096 7132 7133 7132 7514 7133 7133 7514 7515 7131 7132 7096 7131 7663 7132 7132 7663 7514 7096 7136 7131 7136 7662 7131 7131 7662 7663 7096 7135 7136 7135 7661 7136 7136 7661 7662 7134 7135 7096 7134 7660 7135 7135 7660 7661 7096 7146 7134 7146 7659 7134 7134 7659 7660 7096 7145 7146 7145 7658 7146 7146 7658 7659 7144 7145 7096 7144 7657 7145 7145 7657 7658 7096 7149 7144 7149 7656 7144 7144 7656 7657 7096 7148 7149 7148 7655 7149 7149 7655 7656 7100 7147 7148 7100 7148 7096 7147 7654 7148 7148 7654 7655 7141 7147 7100 7141 7653 7147 7147 7653 7654 7140 7141 7100 7140 7652 7141 7141 7652 7653 7100 7143 7140 7143 7651 7140 7140 7651 7652 7100 7142 7143 7142 7650 7143 7143 7650 7651 7139 7142 7100 7139 7649 7142 7142 7649 7650 7100 7138 7139 7138 7648 7139 7139 7648 7649 7100 7137 7138 7137 7647 7138 7138 7647 7648 7099 7137 7100 7099 7646 7137 7137 7646 7647 7098 7099 7100 7098 7645 7099 7099 7645 7646 7098 7100 7101 7101 7644 7098 7098 7644 7645 7100 7104 7101 7104 7643 7101 7101 7643 7644 7100 7103 7104 7103 7642 7104 7104 7642 7643 7102 7103 7100 7102 7641 7103 7103 7641 7642 7100 7107 7102 7107 7640 7102 7102 7640 7641 7100 7106 7107 7106 7639 7107 7107 7639 7640 7105 7106 7100 7105 7638 7106 7106 7638 7639 7100 7110 7105 7110 7637 7105 7105 7637 7638 7100 7109 7110 7109 7636 7110 7110 7636 7637 7108 7109 7100 7108 7635 7109 7109 7635 7636 7100 7113 7108 7113 7634 7108 7108 7634 7635 7100 7112 7113 7112 7633 7113 7113 7633 7634 7111 7112 7100 7111 7632 7112 7112 7632 7633 7100 7116 7111 7116 7631 7111 7111 7631 7632 7100 7115 7116 7115 7630 7116 7116 7630 7631 7114 7115 7100 7114 7629 7115 7115 7629 7630 7100 7119 7114 7119 7628 7114 7114 7628 7629 7100 7118 7119 7118 7627 7119 7119 7627 7628 7117 7118 7100 7117 7626 7118 7118 7626 7627 7100 7122 7117 7122 7625 7117 7117 7625 7626 7100 7121 7122 7121 7624 7122 7122 7624 7625 7120 7121 7100 7163 7165 7100 7100 7165 7166 7100 7166 7120 7120 7623 7121 7121 7623 7624 7166 7622 7120 7120 7622 7623 7165 7621 7166 7166 7621 7622 7163 7164 7165 7164 7620 7165 7165 7620 7621 7162 7164 7163 7162 7619 7164 7164 7619 7620 7161 7162 7163 7161 7618 7162 7162 7618 7619 7163 7173 7161 7173 7617 7161 7161 7617 7618 7173 7616 7617 7898 9041 7899 7188 7537 7538 7188 7538 7189 7189 7538 7539 7189 7539 7190 7190 7539 7540 7190 7540 7191 7191 7540 7541 7191 7541 7192 7192 7541 7542 7192 7542 7193 7193 7542 7543 7193 7543 7194 7194 7543 7544 7194 7544 7195 7195 7544 7545 7195 7545 7196 7196 7545 7546 7196 7546 7197 7197 7546 7547 7197 7547 7198 7198 7547 7548 7198 7548 7199 7199 7548 7549 7199 7549 7200 7200 7549 7550 7200 7550 7201 7201 7550 7551 7201 7551 7202 7202 7551 7552 7202 7552 7203 7203 7552 7553 7203 7553 7204 7204 7553 7554 7204 7554 7205 7205 7554 7555 7205 7555 7208 7208 7555 7556 7208 7556 7209 7209 7556 7557 7209 7557 7210 7210 7557 7558 7210 7558 7214 7214 7558 7559 7214 7559 7215 7215 7559 7560 7215 7560 7216 7216 7560 7561 7216 7561 7220 7220 7561 7562 7220 7562 7221 7221 7562 7563 7221 7563 7222 7222 7563 7564 7222 7564 7223 7223 7564 7565 7223 7565 7224 7224 7565 7566 7224 7228 7073 7224 7566 7228 7228 7566 7567 7073 7228 7229 7228 7567 7229 7229 7567 7568 7073 7229 7230 7229 7568 7230 7230 7568 7569 7230 7231 7073 7230 7569 7231 7231 7569 7570 7073 7231 7232 7231 7570 7232 7232 7570 7571 7073 7232 7225 7232 7571 7225 7225 7571 7572 7225 7226 7073 7225 7572 7226 7226 7572 7573 7073 7226 7227 7226 7573 7227 7227 7573 7574 7073 7227 7217 7227 7574 7217 7217 7574 7575 7217 7218 7073 7217 7575 7218 7218 7575 7576 7073 7218 7219 7218 7576 7219 7219 7576 7577 7073 7219 7211 7219 7577 7211 7211 7577 7578 7211 7212 7073 7211 7578 7212 7212 7578 7579 7073 7212 7213 7212 7579 7213 7206 7207 7073 7073 7213 7206 7213 7579 7580 7213 7580 7206 7206 7580 7581 7206 7581 7207 7207 7581 7582 9816 9844 9817 9816 9817 9818 9818 9817 9819 9818 9819 9812 9809 9808 9810 9810 9808 9829 9829 9808 9830 9806 9830 9808 9829 9830 9831 9831 9836 9829 9831 9830 9832 9834 9832 9830 9834 9830 9806 7467 9834 9806 9833 9832 9834 9828 9833 9834 9828 9834 7467 9831 9832 9799 9833 9799 9832 9798 9799 9833 9826 9798 9833 9826 9833 9828 9827 9826 9828 9827 9828 7467 9802 9798 9826 9798 7447 9799 9798 9802 7447 9799 7447 7446 9799 7446 9800 9831 9799 9800 9800 7446 9801 9801 7446 9804 9800 9801 9831 9831 9801 9836 9801 9804 9836 7380 7381 7252 7379 7382 7252 7252 7382 7383 7252 7383 7384 7384 7385 7252 7252 7385 7386 7252 7386 7380 7381 7387 7252 7252 7387 7388 7252 7388 7389 7390 7252 7389 7379 7709 7382 7382 7709 7710 7709 8020 8021 7709 8021 7710 7382 7710 7383 7383 7710 7711 7710 8021 8022 7710 8022 7711 8020 9534 8021 8021 9534 9535 8021 9535 8022 8020 9533 9534 9533 9622 9534 9534 9622 9624 9534 9624 9535 8022 9535 9536 9535 9624 9626 9535 9626 9536 7711 8022 8023 8022 9536 8023 8023 9536 9537 9536 9626 9628 9536 9628 9537 9624 9625 9626 9626 9625 9627 9626 9627 9628 9622 9623 9624 9624 9623 9625 9622 9621 9623 9620 9619 9621 9620 9621 9622 9618 9619 9620 9532 9618 9620 9532 9620 9533 9533 9620 9622 9628 9627 9629 9628 9629 9630 9537 9628 9630 9630 9629 9631 9630 9631 9632 9537 9630 9538 9538 9630 9632 8023 9537 8024 8024 9537 9538 8024 9538 8025 8025 9538 9539 9538 9632 9539 9632 9631 9633 9632 9633 9634 9539 9632 9634 8025 9539 8026 8026 9539 9540 9539 9634 9540 7713 8024 8025 7713 8025 7714 7714 8025 8026 7714 8026 7715 7715 8026 8027 8026 9540 8027 8027 9540 9541 9540 9634 9636 9540 9636 9541 7715 8027 7716 7716 8027 8028 8027 9541 8028 7380 7714 7715 7380 7715 7381 7381 7715 7716 7381 7716 7387 7387 7716 7717 7716 8028 7717 7717 8028 8029 8028 9541 9542 8028 9542 8029 7387 7717 7388 7388 7717 7718 7717 8029 7718 7718 8029 8030 8029 9542 9543 8029 9543 8030 9541 9638 9542 9542 9638 9640 9542 9640 9543 8030 9543 9544 9543 9640 9642 9543 9642 9544 9638 9639 9640 9640 9639 9641 9640 9641 9642 9636 9637 9638 9638 9637 9639 9541 9636 9638 9634 9635 9636 9636 9635 9637 9634 9633 9635 9642 9641 9643 9642 9643 9644 9544 9642 9644 9644 9643 9645 9644 9645 9646 9544 9644 9545 9545 9644 9646 9646 9645 9647 9646 9647 9648 9545 9646 9546 9546 9646 9648 8031 9544 9545 8031 9545 8032 8032 9545 9546 8030 9544 8031 7719 8030 8031 7718 8030 7719 7389 7718 7719 7389 7719 7390 7388 7718 7389 9546 9648 9547 9547 9648 9650 9547 9650 9548 9648 9649 9650 9650 9649 9651 9650 9651 9652 9548 9650 9652 9548 9652 9549 9652 9651 9653 9652 9653 9654 9549 9652 9654 9549 9654 9550 9654 9653 9655 9654 9655 9656 9550 9654 9656 9550 9656 9551 9656 9655 9657 9656 9657 9658 9551 9656 9658 9551 9658 9552 9658 9657 9659 9658 9659 9660 9552 9658 9660 9552 9660 9553 9660 9659 9661 9660 9661 9662 9553 9660 9662 9553 9662 9554 9662 9661 9663 9662 9663 9664 9554 9662 9664 8041 9554 9555 9554 9664 9555 9664 9663 9665 9664 9665 9666 9555 9664 9666 9666 9665 9667 9648 9647 9649 7386 7714 7380 7385 7713 7386 7386 7713 7714 7384 7712 7385 7385 7712 7713 7712 8024 7713 7384 7711 7712 7711 8023 7712 7712 8023 8024 7383 7711 7384 8513 8511 7418 8519 8517 7418 7418 8517 8515 7418 8515 8513 9769 8523 7418 7418 8523 8521 7418 8521 8519 8511 8509 7418 7418 8509 8507 7418 8507 8505 8505 8503 7418 7418 8503 8501 7418 8501 8499 8499 8497 7418 7418 8497 8495 7418 8495 9768 8500 8499 8501 8500 8501 8502 8502 8501 8503 8498 8497 8499 8498 8499 8500 8496 8495 8497 8496 8497 8498 8494 8493 8495 8494 8495 8496 9768 8495 8493 8456 8494 8496 8456 8496 8457 8457 8496 8498 8457 8498 8458 8458 8498 8500 8099 8456 8457 8099 8457 8100 8100 8457 8458 8097 8455 8456 8097 8456 8099 8455 8494 8456 8098 8097 8099 8098 8099 8100 8100 8101 8098 8100 8458 8101 8101 8458 8459 8458 8500 8459 8098 8101 8102 8101 8459 8102 8096 8097 8098 8098 8102 8088 8098 8113 8096 8096 8455 8097 8113 8454 8096 8096 8454 8455 8454 8492 8455 8492 8491 8493 8492 8493 8494 8455 8492 8494 9768 8493 8491 8408 8406 9768 8406 8404 9768 9768 8404 8402 9768 8402 8400 8407 8406 8408 8405 8404 8406 8405 8406 8407 8403 8402 8404 8403 8404 8405 8444 8405 8407 8086 8087 8088 8086 8088 8089 8087 8090 8088 8088 8090 8091 8088 8091 8079 8093 8094 8088 8088 8094 8095 8088 8095 8089 8088 8102 8103 8088 8103 8093 8103 8461 8093 8093 8461 8462 8093 8462 8094 8094 8462 8463 8094 8463 8095 8095 8463 8464 8095 8464 8089 8462 8508 8463 8463 8508 8510 8463 8510 8464 8461 8506 8462 8462 8506 8508 8506 8507 8508 8508 8507 8509 8508 8509 8510 8510 8509 8511 8510 8511 8512 8464 8510 8512 8512 8511 8513 8512 8513 8514 8464 8512 8465 8465 8512 8514 8514 8513 8515 8514 8515 8516 8465 8514 8466 8466 8514 8516 8089 8464 8465 8089 8465 8086 8086 8465 8466 8086 8466 8087 8087 8466 8467 8466 8516 8467 8087 8467 8090 8090 8467 8468 8467 8516 8518 8467 8518 8468 8090 8468 8091 8091 8468 8469 8468 8518 8520 8468 8520 8469 8516 8517 8518 8518 8517 8519 8518 8519 8520 8520 8519 8521 8520 8521 8522 8469 8520 8522 8522 8521 8523 8522 8523 8524 8469 8522 8470 8470 8522 8524 8524 8523 8525 9769 8525 8523 8524 8525 8526 8470 8524 8471 8471 8524 8526 8092 8469 8470 8092 8470 8081 8081 8470 8471 8081 8471 8080 8080 8471 8472 8471 8526 8472 8080 8079 8081 8079 8092 8081 8079 8091 8092 8091 8469 8092 8078 8079 8080 8084 8083 8079 8084 8079 8085 8085 8079 8078 8080 8472 8078 8078 8472 8473 8078 8473 8085 8472 8526 8528 8472 8528 8473 8085 8473 8474 8473 8528 8530 8473 8530 8474 8085 8474 8084 8084 8474 8475 8474 8530 8532 8474 8532 8475 8528 8529 8530 8530 8529 8531 8530 8531 8532 8526 8527 8528 8528 8527 8529 8526 8525 8527 9769 8529 8527 8527 8525 9769 9769 8531 8529 8532 8531 8533 8533 8531 9769 8532 8533 8534 8475 8532 8534 8534 8533 8535 9769 8535 8533 8534 8535 8536 8475 8534 8537 8537 8534 8536 8535 8566 8536 9769 8566 8535 8536 8566 8567 8536 8567 8568 8537 8536 8538 8538 8536 8568 8140 8475 8537 8140 8537 8141 8141 8537 8538 8141 8538 8142 8142 8538 8539 8538 8568 8539 8083 8140 8141 8083 8141 8142 8082 8140 8083 8082 8475 8140 8084 8475 8082 8082 8083 8084 8142 8143 8083 8083 8143 8144 8083 8144 8136 8142 8539 8143 8143 8539 8540 8143 8540 8144 8539 8568 8570 8539 8570 8540 8144 8540 8541 8540 8570 8572 8540 8572 8541 8136 8144 8145 8144 8541 8145 8145 8541 8542 8541 8572 8574 8541 8574 8542 8570 8571 8572 8572 8571 8573 8572 8573 8574 8568 8569 8570 8570 8569 8571 8568 8567 8569 8569 8567 9769 9769 8571 8569 9769 8573 8571 8574 8573 8575 8575 8573 9769 8574 8575 8576 8542 8574 8576 8576 8575 8577 8577 8575 9769 8576 8577 8578 8542 8576 8543 8543 8576 8578 8578 8577 8579 9769 8579 8577 8578 8579 8580 8543 8578 8544 8544 8578 8580 8134 8542 8543 8134 8543 8135 8135 8543 8544 8135 8544 8137 8137 8544 8545 8544 8580 8545 8134 8135 8136 8135 8137 8136 8136 8145 8134 8145 8542 8134 8136 8137 8138 8136 8138 8129 8137 8545 8138 8138 8545 8546 8545 8580 8582 8545 8582 8546 8129 8138 8139 8138 8546 8139 8139 8546 8547 8546 8582 8584 8546 8584 8547 8580 8581 8582 8582 8581 8583 8582 8583 8584 8584 8583 8585 8584 8585 8586 8547 8584 8586 8583 8581 9769 9769 8585 8583 8580 8579 8581 9769 8581 8579 9769 8567 8566 8589 8587 9769 9769 8587 8585 8595 8593 9769 9769 8593 8591 9769 8591 8589 9770 8599 9769 9769 8599 8597 9769 8597 8595 8594 8593 8595 8594 8595 8596 8596 8595 8597 8592 8591 8593 8592 8593 8594 8590 8589 8591 8590 8591 8592 8550 8590 8592 8550 8592 8551 8551 8592 8594 8551 8594 8552 8552 8594 8596 8596 8597 8598 8552 8596 8553 8553 8596 8598 8598 8597 8599 8598 8599 8600 8553 8598 8554 8554 8598 8600 8133 8552 8553 8133 8553 8121 8121 8553 8554 8132 8551 8552 8132 8552 8133 8119 8132 8133 8119 8133 8121 8121 8122 8119 8121 8554 8122 8122 8554 8555 8554 8600 8555 8119 8122 8123 8122 8555 8123 8123 8555 8556 8555 8600 8602 8555 8602 8556 8119 8123 8120 8123 8556 8120 8120 8556 8557 8556 8602 8604 8556 8604 8557 8600 8601 8602 8602 8601 8603 8602 8603 8604 8604 8603 8605 8604 8605 8606 8557 8604 8606 9770 8605 8603 8603 8601 9770 8600 8599 8601 9770 8601 8599 8609 8607 9770 9770 8607 8605 8615 8613 9770 9770 8613 8611 9770 8611 8609 8621 8619 9770 9770 8619 8617 9770 8617 8615 8627 8625 9770 9770 8625 8623 9770 8623 8621 8633 8631 9770 9770 8631 8629 9770 8629 8627 7420 8636 9770 9770 8636 8635 9770 8635 8633 8632 8631 8633 8632 8633 8634 8633 8635 8634 8630 8629 8631 8630 8631 8632 8628 8627 8629 8628 8629 8630 8715 8628 8630 8715 8630 8716 8716 8630 8632 8716 8632 8717 8717 8632 8634 8213 8715 8716 8213 8716 8200 8200 8716 8717 8212 8714 8715 8212 8715 8213 8714 8628 8715 8199 8212 8213 8199 8213 8200 8200 8201 8199 8200 8717 8201 8201 8717 8718 8717 8634 8718 8199 8201 8202 8201 8718 8202 8202 8718 8719 8718 8634 8637 8718 8637 8719 8634 8635 8636 8634 8636 8637 8637 8636 8638 8637 8638 8639 8719 8637 8639 8202 8719 8197 8197 8719 8720 8719 8639 8720 8199 8202 8197 8197 8198 8199 8197 8720 8198 8198 8720 8721 8720 8639 8641 8720 8641 8721 8639 8638 8640 8639 8640 8641 8641 8640 8642 8641 8642 8643 8721 8641 8643 8198 8721 8203 8203 8721 8722 8721 8643 8722 8198 8203 8199 8199 8203 8204 8203 8722 8204 8204 8722 8723 8722 8643 8645 8722 8645 8723 8643 8642 8644 8643 8644 8645 8642 8640 7420 8642 7420 8644 8640 8638 7420 7420 8638 8636 8652 8650 7420 8652 7420 8654 8672 8670 7420 7420 8670 8668 7420 8668 8666 9771 8676 7420 7420 8676 8674 7420 8674 8672 8660 8658 7420 7420 8658 8656 7420 8656 8654 8666 8664 7420 7420 8664 8662 7420 8662 8660 8650 8648 7420 7420 8648 8646 7420 8646 8644 8663 8662 8664 8663 8664 8665 8665 8664 8666 8661 8660 8662 8661 8662 8663 8731 8661 8663 8731 8663 8732 8732 8663 8665 8665 8666 8667 8732 8665 8733 8733 8665 8667 8667 8666 8668 8667 8668 8669 8733 8667 8734 8734 8667 8669 8179 8732 8733 8179 8733 8181 8181 8733 8734 8178 8731 8732 8178 8732 8179 8178 8179 8180 8180 8179 8181 8180 8181 8182 8181 8734 8182 8182 8734 8735 8734 8669 8735 8182 8183 8180 8182 8735 8183 8183 8735 8736 8735 8669 8671 8735 8671 8736 8180 8183 8184 8183 8736 8184 8184 8736 8737 8736 8671 8673 8736 8673 8737 8669 8670 8671 8671 8670 8672 8671 8672 8673 8673 8672 8674 8673 8674 8675 8737 8673 8675 8675 8674 8676 8675 8676 8677 8737 8675 8738 8738 8675 8677 8677 8676 8678 9771 8678 8676 8677 8678 8679 8738 8677 8739 8739 8677 8679 8185 8737 8738 8185 8738 8186 8186 8738 8739 8186 8739 8187 8187 8739 8740 8739 8679 8740 8185 8186 8180 8180 8186 8187 8180 8184 8185 8184 8737 8185 8180 8187 8173 8191 8195 8180 8180 8195 8196 8180 8196 8178 8191 8194 8195 8194 8729 8195 8195 8729 8730 8195 8730 8196 8196 8730 8731 8196 8731 8178 8729 8659 8730 8730 8659 8661 8730 8661 8731 8194 8728 8729 8728 8657 8729 8729 8657 8659 8193 8194 8191 8193 8728 8194 8193 8727 8728 8727 8655 8728 8728 8655 8657 8655 8656 8657 8657 8656 8658 8657 8658 8659 8653 8654 8655 8655 8654 8656 8727 8653 8655 8192 8726 8727 8192 8727 8193 8726 8653 8727 8191 8192 8193 8191 8190 8192 8190 8726 8192 8190 8725 8726 8725 8651 8726 8726 8651 8653 8651 8652 8653 8653 8652 8654 8649 8650 8651 8651 8650 8652 8725 8649 8651 8189 8724 8725 8189 8725 8190 8724 8649 8725 8189 8190 8191 8191 8205 8189 8205 8724 8189 8205 8723 8724 8723 8647 8724 8724 8647 8649 8647 8648 8649 8649 8648 8650 8645 8646 8647 8647 8646 8648 8723 8645 8647 8204 8723 8205 8191 8204 8205 8199 8204 8191 8208 8212 8199 8114 8207 8208 8208 8207 8209 8208 8209 8210 8210 8211 8208 8208 8211 8212 8211 8714 8212 8210 8713 8211 8211 8713 8714 8209 8712 8210 8210 8712 8713 8207 8565 8209 8209 8565 8712 8114 8206 8207 8206 8565 8207 8206 8564 8565 8564 8620 8565 8565 8620 8622 8565 8622 8712 8712 8622 8624 8712 8624 8713 8713 8624 8626 8713 8626 8714 8714 8626 8628 8624 8625 8626 8626 8625 8627 8626 8627 8628 8622 8623 8624 8624 8623 8625 8620 8621 8622 8622 8621 8623 8620 8619 8621 8618 8617 8619 8618 8619 8620 8616 8617 8618 8563 8616 8618 8563 8618 8564 8564 8618 8620 8616 8615 8617 8614 8615 8616 8562 8614 8616 8562 8616 8563 8115 8562 8563 8115 8563 8116 8116 8563 8564 8116 8564 8206 8114 8115 8116 8116 8206 8114 8114 8126 8115 8126 8562 8115 8126 8561 8562 8561 8614 8562 8114 8125 8126 8125 8561 8126 8119 8125 8114 8119 8124 8125 8124 8560 8125 8125 8560 8561 8560 8612 8561 8561 8612 8614 8124 8559 8560 8559 8610 8560 8560 8610 8612 8118 8124 8119 8118 8559 8124 8118 8558 8559 8558 8608 8559 8559 8608 8610 8608 8609 8610 8610 8609 8611 8610 8611 8612 8606 8607 8608 8608 8607 8609 8558 8606 8608 8117 8557 8558 8117 8558 8118 8557 8606 8558 8117 8118 8119 8117 8119 8120 8120 8557 8117 8129 8132 8119 8127 8128 8129 8127 8129 8130 8128 8131 8129 8129 8131 8132 8129 8139 8130 8131 8551 8132 8128 8550 8131 8131 8550 8551 8127 8549 8128 8128 8549 8550 8130 8548 8127 8127 8548 8549 8139 8547 8130 8130 8547 8548 8547 8586 8548 8548 8586 8588 8548 8588 8549 8549 8588 8590 8549 8590 8550 8586 8587 8588 8588 8587 8589 8588 8589 8590 8586 8585 8587 8606 8605 8607 8612 8611 8613 8612 8613 8614 8614 8613 8615 8645 8644 8646 8659 8658 8660 8659 8660 8661 8171 8172 8173 8173 8172 8174 8174 8175 8173 8173 8175 8176 8173 8176 8162 8173 8187 8188 8173 8188 8171 8172 8743 8174 8174 8743 8744 8174 8744 8175 8175 8744 8745 8175 8745 8176 8743 8687 8744 8744 8687 8689 8744 8689 8745 8172 8742 8743 8742 8685 8743 8743 8685 8687 8685 8686 8687 8687 8686 8688 8687 8688 8689 8689 8688 8690 8689 8690 8691 8745 8689 8691 9771 8690 8688 9771 8688 8686 8685 8684 8686 8686 8684 9771 8683 8684 8685 8742 8683 8685 8683 8682 8684 9771 8684 8682 8681 8682 8683 8741 8681 8683 8741 8683 8742 8681 8680 8682 9771 8682 8680 8679 8680 8681 8740 8679 8681 8740 8681 8741 8188 8740 8741 8188 8741 8171 8171 8741 8742 8187 8740 8188 8171 8742 8172 8679 8678 8680 8680 8678 9771 8694 8692 9771 8694 9771 8696 8704 8702 9771 8710 8708 9771 9771 8708 8706 9771 8706 8704 8702 8700 9771 9771 8700 8698 9771 8698 8696 8692 8690 9771 8772 8770 9771 9771 8770 8769 9771 8769 8710 8780 8778 9771 8778 8776 9771 9771 8776 8774 9771 8774 8772 8691 8690 8692 8691 8692 8693 8745 8691 8746 8746 8691 8693 8693 8692 8694 8693 8694 8695 8746 8693 8747 8747 8693 8695 8176 8745 8746 8176 8746 8177 8177 8746 8747 8177 8747 8164 8164 8747 8748 8747 8695 8748 8695 8694 8696 8695 8696 8697 8748 8695 8697 8164 8748 8165 8165 8748 8749 8748 8697 8749 8164 8165 8162 8162 8177 8164 8162 8176 8177 8160 8161 8162 8160 8162 8163 8165 8166 8162 8162 8166 8167 8162 8167 8163 8161 8168 8162 8162 8168 8169 8162 8169 8154 8167 8751 8163 8163 8751 8752 8163 8752 8160 8166 8750 8167 8167 8750 8751 8165 8749 8166 8166 8749 8750 8749 8699 8750 8750 8699 8701 8750 8701 8751 8751 8701 8703 8751 8703 8752 8699 8700 8701 8701 8700 8702 8701 8702 8703 8697 8698 8699 8699 8698 8700 8749 8697 8699 8697 8696 8698 8703 8702 8704 8703 8704 8705 8752 8703 8705 8705 8704 8706 8705 8706 8707 8752 8705 8753 8753 8705 8707 8160 8752 8753 8160 8753 8161 8161 8753 8754 8753 8707 8754 8707 8706 8708 8707 8708 8709 8754 8707 8709 8161 8754 8168 8168 8754 8755 8754 8709 8755 8709 8708 8710 8709 8710 8711 8755 8709 8711 8168 8755 8169 8169 8755 8756 8755 8711 8756 8710 8769 8711 8711 8769 8770 8711 8770 8771 8756 8711 8771 8169 8756 8170 8170 8756 8757 8756 8771 8757 8154 8169 8170 8154 8170 8155 8170 8757 8155 8155 8757 8758 8757 8771 8773 8757 8773 8758 8771 8770 8772 8771 8772 8773 8773 8772 8774 8773 8774 8775 8758 8773 8775 8155 8758 8156 8156 8758 8759 8758 8775 8759 8154 8155 8156 8156 8157 8154 8156 8759 8157 8154 8157 8158 8157 8759 8760 8157 8760 8158 8759 8775 8777 8759 8777 8760 8775 8774 8776 8775 8776 8777 8777 8776 8778 8777 8778 8779 8760 8777 8779 8158 8760 8761 8760 8779 8761 8158 8761 8159 8779 8778 8780 8669 8668 8670 8516 8515 8517 8506 8505 8507 8504 8505 8506 8461 8504 8506 8504 8503 8505 8502 8503 8504 8460 8502 8504 8460 8504 8461 8103 8460 8461 8102 8459 8460 8102 8460 8103 8459 8502 8460 8459 8500 8502 7504 7318 7502 7503 7504 7505 7503 9786 7504 7504 9786 7318 7311 7318 7309 7309 7318 9786 7994 7309 9786 7994 9786 7503 7505 8068 7503 7992 7993 7994 7994 7993 7995 7994 7995 7969 7994 7998 7992 7969 7309 7994 7998 8413 7992 7992 8413 8414 7992 8414 7993 7993 8414 8415 7993 8415 7995 7969 7995 7996 7995 8415 8416 7995 8416 7996 8414 8347 8415 8415 8347 8349 8415 8349 8416 8413 8345 8414 8414 8345 8347 8347 8348 8349 8349 8348 8350 8349 8350 8351 8416 8349 8351 7996 8416 8417 8416 8351 8417 8351 8350 8352 8351 8352 8353 8417 8351 8353 7996 8417 7989 7989 8417 8418 8417 8353 8418 8353 8352 8354 8353 8354 8355 8418 8353 8355 7989 8418 7990 7990 8418 8419 8418 8355 8419 7989 7990 7969 7969 7996 7989 7969 7990 7991 7990 8419 7991 7991 8419 8420 8419 8355 8357 8419 8357 8420 8355 8354 8356 8355 8356 8357 8357 8356 8358 8357 8358 8359 8420 8357 8359 7991 8420 7970 7970 8420 8421 8420 8359 8421 7969 7991 7970 7969 7970 7971 7970 8421 7971 7971 8421 8422 8421 8359 8361 8421 8361 8422 8359 8358 8360 8359 8360 8361 8361 8360 8362 8361 8362 8363 8422 8361 8363 7971 8422 7972 7972 8422 8423 8422 8363 8423 7971 7972 7969 7969 7972 7973 7972 8423 7973 7973 8423 8424 8423 8363 8365 8423 8365 8424 8363 8362 8364 8363 8364 8365 8365 8364 8366 8365 8366 8367 8424 8365 8367 7973 8424 7974 7974 8424 8425 8424 8367 8425 7969 7973 7974 7974 7975 7969 7974 8425 7975 7975 8425 8426 8425 8367 8369 8425 8369 8426 8367 8366 8368 8367 8368 8369 8369 8368 8370 8369 8370 8371 8426 8369 8371 7975 8426 7976 7976 8426 8427 8426 8371 8427 7969 7975 7976 7969 7976 7977 7976 8427 7977 7969 7982 7960 7960 7312 7969 7969 7312 7309 7960 7306 7312 7309 7312 7310 7310 7312 7306 7309 7310 7311 7310 7306 7311 8371 8370 8372 8845 8844 8846 8845 8846 8847 8883 8845 8847 8847 8846 8848 8233 8903 8218 646 651 853 853 651 733 853 733 731 731 729 853 853 729 727 853 727 725 725 723 853 732 731 733 732 733 653 653 733 651 730 729 731 730 731 732 728 727 729 728 729 730 726 725 727 726 727 728 724 723 725 724 725 726 724 726 775 775 726 728 775 728 776 776 728 730 776 730 770 770 730 732 770 732 653 653 767 770 778 776 770 652 767 653 651 650 652 651 652 653 646 650 651 646 649 650 781 650 649 648 649 646 648 781 649 787 781 648 223 224 225 225 228 223 224 229 225 225 229 230 225 230 231 231 237 225 225 237 238 223 228 4394 4394 228 4410 4394 4393 4395 223 4394 4396 4394 4395 4396 4394 4410 4393 4393 4410 4411 4393 4411 4154 4154 4411 2634 4153 4154 2634 4135 4154 4136 4136 4154 4153 4154 4135 4393 4136 4153 4140 4140 4153 4156 4135 4136 4137 4137 4136 4138 4138 4136 4139 4139 4136 4140 4393 4135 4137 4393 4137 4395 4395 4137 4138 4395 4138 4397 4397 4138 4139 4139 4140 4141 4397 4139 4398 4139 4141 4398 4396 4395 4397 4396 4397 4400 4400 4397 4398 4398 4141 4143 4398 4143 4399 4400 4398 4401 4401 4398 4399 4141 4140 4142 4141 4142 4143 4143 4142 4144 4143 4144 4145 4399 4143 4145 4399 4145 4392 4401 4399 4402 4402 4399 4392 4145 4144 4146 4392 4145 4146 4148 4383 4392 4392 4146 4148 4402 4392 4403 4403 4392 4383 230 4401 4402 230 4402 231 231 4402 4403 4403 4383 4382 231 4403 237 237 4403 4382 4376 4382 4383 4376 4383 2608 2608 4383 4148 237 4382 238 4146 4147 4148 2608 4148 2607 2607 4148 4155 4148 4147 4155 2607 2606 2608 2606 4376 2608 2605 2606 2607 2607 4155 2605 4155 4147 4144 4155 4144 4156 4146 4144 4147 4156 4144 4142 4156 4142 4140 229 4401 230 224 4400 229 229 4400 4401 223 4396 224 224 4396 4400 4307 4319 497 4307 497 502 4307 502 501 4306 4319 4307 4306 4318 4319 4318 4333 4319 4318 4240 4333 4240 4246 4333 4990 3890 3891 3888 3889 3890 3889 3891 3890 3883 3885 3888 3888 3885 3889 3883 3884 3885 3885 3884 3886 3885 3886 3881 3881 3886 3887 3880 1655 3881 3880 3881 3882 3881 3887 3882 256 255 4479 4479 255 4471 249 256 4492 4492 256 4479 4479 4471 4480 4492 4479 4493 4493 4479 4480 4480 4471 4469 4480 4469 2534 4493 4480 2536 2536 4480 2534 4495 4492 4493 4495 4493 2201 2201 4493 2536 4494 249 4492 4494 4492 4495 250 249 4494 4495 4498 4494 4494 4498 4500 4494 4500 250 2201 2203 4495 4495 2203 4498 2203 2204 4498 4498 2204 4499 4498 4499 4500 4500 4499 4501 4500 4501 252 250 4500 252 4499 2204 4272 4501 4499 4514 4499 4272 4514 2203 2202 2204 2204 2202 4272 2201 2202 2203 2201 2544 2202 4272 2202 4273 4273 2202 2544 4273 4279 4272 4514 4272 4279 4514 4279 4516 4501 4514 4515 4515 4514 4516 4273 4278 4279 4279 4278 4516 4274 4278 4273 4273 2544 4283 4283 4274 4273 2201 2543 2544 4283 2544 2543 4283 2543 4284 2537 2542 2543 2537 2543 2201 2543 2542 4284 4284 2542 2541 4284 2541 4286 4286 4285 4284 2538 2541 2542 2538 2542 2537 4301 2538 2537 4294 4292 4301 4301 4292 4290 4294 4301 4295 4295 4301 2535 4302 4301 4299 4299 4301 4290 4301 2537 2535 4293 4292 4294 4293 4294 4295 4291 4290 4292 4291 4292 4293 4289 4290 4291 4290 4289 4460 4300 4290 4460 4460 4462 4300 4299 4290 4300 4295 2535 2534 2534 4469 4295 2534 2535 2536 2536 2535 2537 2536 2537 2201 4286 4281 4285 4274 4275 4276 4276 4277 4274 4274 4277 4278 4274 4280 4275 4518 4276 4275 4518 4275 4513 4513 4275 4280 4517 4277 4276 4517 4276 4518 4516 4278 4277 4516 4277 4517 4519 4516 4517 4519 4517 4520 4520 4517 4518 4520 4518 4521 4521 4518 4513 4521 4513 4522 259 4520 4521 259 4521 260 260 4521 4522 258 4519 4520 258 4520 259 257 4519 258 4515 4516 4519 257 4515 4519 253 4515 257 253 4501 4515 252 4501 253 260 4522 261 2233 2230 2234 2230 2229 4582 4582 4581 2230 2230 4581 2234 2234 4581 4580 4580 4581 4577 4582 4586 4581 4586 4577 4581 4577 4579 4580 4577 4578 4579 2052 4761 2054 4763 4761 2052 1916 4763 2052 4760 4753 4761 4763 4760 4761 4762 4760 4763 4765 4762 4763 4765 4763 1916 4765 1916 4781 4781 1916 1919 4764 4762 4765 4780 4764 4765 4765 4781 4780 543 542 4762 4762 542 4760 4764 543 4762 545 543 4764 547 545 4764 4780 547 4764 4779 547 4780 4780 4781 4782 4780 4782 4779 4781 1919 4782 4779 4782 4774 4782 1919 1921 4782 1921 4774 4777 551 4779 4779 551 547 4779 4774 4777 4772 4773 4774 4777 4774 4773 4774 1921 1923 4774 1923 4772 1919 1920 1921 1921 1920 1922 1921 1922 1923 1923 1922 1924 1923 1924 4772 4772 1924 4787 4772 4787 4773 4777 4773 4775 4773 4787 4775 4775 4787 4788 1924 4094 4787 4787 4094 4800 4787 4800 4788 1924 1922 1925 1924 1925 4094 1922 1920 2975 2975 1925 1922 2975 2997 1925 4094 1925 4095 4095 1925 4104 4104 1925 2997 4095 4100 4094 4094 4100 4800 4098 4099 4095 4095 4099 4100 4104 4098 4095 4100 4099 4799 4800 4100 4799 4098 4097 4099 4799 4099 4097 4096 4097 4098 4098 4101 4096 4799 4097 4798 4798 4097 4096 4798 4797 4799 4800 4799 4801 4801 4799 4797 4795 4796 4798 4798 4796 4797 4798 4096 4795 4795 4096 4101 4795 4794 4796 4794 507 4796 4796 507 506 4796 506 4797 4801 4797 515 515 4797 506 506 507 70 506 70 515 517 70 507 4794 517 507 4792 517 4794 48 69 70 70 69 71 70 71 72 72 73 70 70 73 74 70 74 75 75 90 70 515 70 524 524 70 5146 5146 70 5160 90 5160 70 72 4847 73 4863 4846 4847 72 4863 4847 4862 4852 4863 4863 4852 4846 71 4862 4863 71 4863 72 1972 4846 4852 4859 4067 4852 4852 4067 4068 4852 4068 1972 4862 4859 4852 1973 1972 4066 4066 1972 4068 4066 4068 4067 4065 4066 4067 4859 4065 4067 4858 4065 4859 4861 4858 4859 4861 4859 4862 4064 4063 4065 4065 4063 4066 4858 4064 4065 4857 4064 4858 4860 4857 4858 4860 4858 4861 68 4860 4861 68 4861 69 69 4861 4862 69 4862 71 48 68 69 47 68 48 47 4860 68 4856 4857 4860 47 4856 4860 46 47 48 46 4856 47 46 4854 4856 4854 4855 4856 4856 4855 4857 48 67 46 4854 46 67 4854 4853 4855 4854 67 4871 4871 4853 4854 4853 4059 4855 4855 4059 4061 4855 4061 4857 4853 1969 4059 4871 4877 4853 4877 1969 4853 4871 67 66 4871 66 4872 4872 4877 4871 48 66 67 65 66 48 4872 66 65 4872 65 4873 4873 4876 4872 4872 4876 4877 4876 1967 4877 4877 1967 1969 4873 4875 4876 4875 1965 4876 4876 1965 1967 4873 65 4870 4873 4870 4874 4874 4875 4873 48 64 65 65 64 4870 4894 4874 4870 4896 4894 4870 4896 4870 64 4874 1958 4875 1960 1958 4874 4894 1960 4874 4875 1958 1965 1958 1957 1965 1965 1957 1966 1965 1966 1967 1967 1966 1968 1966 2890 1968 1967 1968 1969 1969 1968 1970 1970 1968 2889 2889 1968 2890 1969 1970 1971 1969 1971 4059 1971 1970 2888 2888 1970 2889 2889 2890 2891 2888 2889 4075 4075 2889 2891 1971 2888 4071 4071 2888 4075 4059 1971 4060 1971 4071 4060 4059 4060 4061 4061 4060 4062 4062 4060 4063 4060 4071 4070 4060 4070 4063 4071 4075 4070 4069 4066 4070 4063 4070 4066 4074 4069 4070 4070 4075 4074 4062 4063 4064 4061 4062 4857 4857 4062 4064 2875 2874 4074 2874 1973 4074 4074 1973 4069 4074 4075 4076 4074 4076 4077 2872 2874 2875 4077 4076 4078 4077 4078 4073 4076 2896 4078 4078 2896 2895 4078 2895 4079 4073 4078 4079 4073 4079 4072 4079 1851 4072 2895 2894 4079 4079 2894 1851 2890 2895 2896 2890 2896 2892 4076 2892 2896 2891 2890 2892 2891 2892 4076 4075 2891 4076 4069 1973 4066 4893 1962 1960 4893 1960 4894 4889 1962 4893 4890 4889 4893 4890 4893 4895 4895 4893 4894 4889 1964 1962 4887 4888 4889 4889 4888 4886 4886 1964 4889 4887 4889 4890 1955 1964 1956 4886 1956 1964 4886 4888 4898 1954 1956 4886 4886 4898 1954 4898 4888 4887 4887 4897 4898 4898 4897 4899 4898 4899 4901 1954 4898 4901 1952 1953 1954 1954 1953 1955 1954 1955 1956 1954 4901 1952 4901 4899 4900 4901 4900 4902 1952 4901 4902 4897 59 4899 4899 59 58 4899 58 4900 4900 58 52 4900 52 4879 4902 4900 4879 4902 4879 4881 1952 4902 1950 1950 4902 4881 4878 4879 52 4880 4881 4879 4879 4878 4880 4881 4880 1948 1950 4881 1948 4880 4878 4882 4880 4882 4884 1948 4880 4884 4878 52 55 4878 55 4882 4882 55 57 4882 57 4883 4884 4882 4883 4884 4883 4885 4883 57 56 4883 56 4867 4885 4883 4867 55 56 57 52 54 55 55 54 56 54 4867 56 4866 4867 54 52 53 54 53 4866 54 53 52 51 51 52 58 49 50 51 58 59 51 51 59 60 51 60 49 50 49 48 48 49 61 61 49 4892 4892 49 60 4892 60 4897 4897 60 59 4890 61 4892 4890 4892 4891 4897 4891 4892 48 61 62 4895 62 61 4895 61 4890 62 63 48 48 63 64 4896 63 62 4896 62 4895 4895 4894 4896 64 63 4896 4890 4891 4887 4887 4891 4897 5146 5160 5147 5147 5160 5148 5148 5160 5161 5175 5161 5160 5175 5160 90 5146 5145 524 5146 5147 5145 5147 5148 5149 5145 5147 5149 5148 5150 5149 5148 5161 5150 5149 5150 5152 5149 5152 5156 5145 5149 5143 5143 5149 5156 5145 5143 524 524 5143 5144 5143 5156 5144 5144 5156 5155 5136 5137 5144 5144 5137 5138 5144 5138 524 5144 5155 5136 5136 5155 5135 5135 5126 5136 5136 5126 5127 5136 5127 5137 5127 5138 5137 5127 524 5138 5126 5125 5127 5127 5125 5123 5127 5123 516 516 524 5127 1746 3935 5126 5126 3935 5125 1746 1747 3930 3930 3935 1746 3930 3934 3935 3935 3934 5125 3933 3934 3930 3944 3933 3930 3944 3930 1747 1747 3614 3944 3944 3941 3945 3945 3933 3944 3944 3614 3611 3944 3611 3941 3941 3609 1764 3941 1764 3942 3945 3941 3942 3945 3942 3940 3940 3939 3945 3945 3939 3933 3943 3942 1764 3940 3942 3943 1764 1763 3627 3627 3943 1764 3940 3943 3633 3633 3943 3627 3633 3632 3940 3632 3630 3940 3940 3630 3939 3628 3632 3633 3628 3633 3627 3627 1763 3628 3628 1763 3918 3631 3632 3628 3628 3918 3631 3631 3630 3632 3629 3630 3631 3631 3918 3920 3631 3920 3629 3918 3921 3920 3920 1751 3634 3920 3634 3629 3629 3634 3630 3630 3634 1751 1750 1749 1751 3630 1751 1749 1748 1749 1750 3936 3939 1749 3936 1749 1748 3630 1749 3939 3936 1748 5109 3936 3937 3933 3933 3939 3936 3936 5109 3937 3937 5109 5119 5109 5118 5119 3933 3937 3938 3937 5119 5120 5120 3938 3937 3931 3932 3933 3933 3932 3934 3933 3938 3931 5120 3931 3938 5119 5121 5120 5120 5121 5122 5120 5122 5124 5124 3931 5120 5119 5118 5121 5118 544 5121 5121 544 546 5121 546 5122 5122 546 548 5122 548 5123 5124 5122 5123 5124 5123 5125 5125 3932 5124 5124 3932 3931 5125 3934 3932 516 5123 548 546 547 548 547 551 548 548 551 552 548 552 516 544 545 546 546 545 547 544 543 545 527 542 543 527 543 544 527 528 529 529 542 527 5118 527 544 542 529 4760 528 4753 529 4760 529 4753 514 515 516 515 524 516 516 552 553 516 553 514 514 553 4788 4788 4801 514 514 4801 515 4778 553 552 4788 553 4778 4778 552 4776 4776 552 4777 4777 552 551 4788 4778 4776 4775 4788 4776 4788 4800 4801 4775 4776 4777 5150 5151 5152 5151 1743 5152 5150 5161 5151 5151 5161 1741 5151 1741 1743 1741 1742 1743 1740 1733 1741 1741 1733 1742 1740 1741 5171 5171 1741 5161 5171 5161 5175 5170 1740 5171 5170 5171 5172 5175 5176 5171 5171 5176 5177 5171 5177 5172 1739 1740 5170 5170 5172 5180 5180 1739 5170 5180 5172 5177 5180 5177 5179 5179 5177 5176 5175 5174 5176 5179 5176 5174 5173 88 5179 5173 5179 5174 5182 5180 5179 5182 5179 84 84 5179 88 5173 5174 5175 5173 5175 5178 5178 88 5173 84 88 85 85 88 89 5178 89 88 84 85 86 86 5182 84 85 89 75 75 89 90 5178 90 89 5178 5175 90 5181 5180 5182 5163 5181 5182 5163 5182 86 5162 5163 86 86 87 5162 5164 5165 5163 5163 5162 5164 5165 5181 5163 5162 87 83 5162 83 5166 5164 5162 5166 5165 5164 1732 1732 1738 5165 5165 1738 5181 1737 1736 1738 1738 1736 5181 1735 1736 1737 1737 3576 1735 1735 1734 1736 1736 1734 5180 5181 1736 5180 1733 1734 1735 1733 1735 3575 3575 1735 3576 3576 3579 3575 3579 3598 3575 3575 3598 1742 3575 1742 1733 1740 1734 1733 1739 1734 1740 5180 1734 1739 5166 83 82 3667 3976 3665 3976 1669 3670 3976 3670 3665 3665 3666 3667 3665 3670 3666 3666 3670 1669 5053 5049 5050 5049 4013 5050 4013 4012 5050 5050 4012 4010 5050 4010 5051 4011 4010 4012 4009 4010 4011 4010 4009 5051 5051 4009 4017 4011 4017 4009 5058 5064 5066 4025 4028 4019 4019 4028 4029 4028 4020 4026 4028 4026 4029 4019 4029 4018 4018 3542 4019 4029 1794 4018 4029 4026 1794 4020 3571 4026 4026 3571 3563 4026 3563 1794 3573 3572 4020 4020 3572 3571 3563 3571 3564 3564 3571 3572 3562 1794 3563 3563 3564 3562 1794 3542 4018 3562 3564 3565 3564 3572 3565 3565 3572 3573 3565 3573 3567 5006 5007 5008 5008 5007 5004 5006 5008 5011 5011 5012 5006 5006 5012 5019 5011 5010 5012 5019 5012 5010 3603 3599 3604 3603 3586 3585 3585 3599 3603 3603 1782 3584 3603 3584 3586 3585 3589 3599 3589 3588 3599 3585 3586 3587 3590 3589 3585 3585 3587 3590 3587 3586 3584 3584 1803 1801 3584 1801 3587 1782 1803 3584 1780 1781 1782 1778 1779 1780 1780 1779 1781 1778 1780 1783 1783 1780 1784 1781 1779 3505 3504 1781 3505 3505 1779 1778 3505 1778 3507 3507 1778 1783 1783 1784 1785 3507 1783 3516 1783 1785 3516 1784 1791 1785 3516 1785 3517 1785 1791 3517 3516 3517 3518 3508 3507 3516 3517 1791 3535 3517 3535 3518 3493 3503 3507 3507 3503 3502 3507 3502 3505 3493 3507 3508 3508 3496 3494 3508 3494 3493 3493 3494 3495 3504 3503 3493 3493 3495 3504 3502 3503 3504 3504 3505 3502 3495 3494 3496 3588 3589 3590 3519 3490 3488 3488 3487 3519 3531 3527 3519 3531 3519 3532 3532 3519 3487 3532 3487 3492 5108 5107 3532 5108 3532 3492 5107 3531 3532 3530 3527 3531 5107 3530 3531 3529 3530 5107 3529 5085 5086 5107 5085 3529 5093 5086 5085 5093 5085 5094 5107 5094 5085 180 5093 5094 180 5094 199 5105 199 5094 5105 5094 5107 200 199 5105 201 200 5105 201 5105 5106 5106 5105 5107 214 201 5114 5114 201 5106 5106 5107 5108 5114 5106 5113 5113 5106 5108 5113 5112 5114 5112 5115 5114 5114 5115 5116 5114 5116 214 214 5116 5117 214 5117 215 5115 5133 5116 5116 5133 5117 5117 5133 217 5117 217 215 216 215 217 216 217 218 218 217 204 204 217 5132 5132 217 5133 5132 5133 5128 5128 5131 5132 5132 5131 76 5132 76 204 5140 76 5131 77 76 5140 5142 77 5140 79 77 5142 202 203 204 204 207 202 203 208 204 204 208 209 204 209 210 210 211 204 204 211 212 204 212 213 218 204 219 219 204 213 4812 202 207 4805 202 4812 4803 4805 4812 4803 4812 4815 4805 203 202 4803 4804 4805 4805 4804 208 4805 208 203 4803 4802 4804 4802 4790 4804 4804 4790 4791 4804 4791 208 208 4791 209 4789 209 4791 4789 4791 4785 4785 4791 4790 210 209 4789 4785 4786 4789 4789 4786 211 4789 211 210 4785 4784 4786 4786 4784 4783 4786 4783 211 211 4783 212 213 212 4783 213 4783 4770 4770 4783 4784 4770 219 213 4768 4769 4770 4770 4769 219 4770 4784 4768 218 219 4766 4766 219 4769 4768 4767 4769 4766 4769 4771 4771 4769 4767 2797 4767 4768 4784 2822 4768 4768 2822 2797 2797 2799 4767 4771 4767 2801 2801 4767 2799 2797 2798 2799 2799 2798 2801 2793 2795 2797 2797 2795 2798 2797 2822 2793 2793 2822 2823 2818 2823 2822 4784 2818 2822 2793 2794 2795 2793 2823 2794 2795 2794 2796 2804 2798 2795 2804 2795 2791 2791 2795 2796 2794 2823 2824 2794 2824 2796 2816 2824 2823 2816 2823 2818 2816 2818 2819 2819 2818 4784 2820 2816 2819 2820 2819 2821 2821 2819 4785 4785 2819 4784 2817 2816 2820 2821 2839 2820 2820 2839 2838 2820 2838 2817 2839 2821 4785 4785 4790 2839 2837 2838 2839 2839 4790 2837 2837 2836 2838 2817 2838 2815 2815 2838 2834 2834 2838 2836 2815 2816 2817 2814 2813 2815 2815 2813 2816 2814 2815 2834 2834 2836 2840 2840 1844 2834 2834 1844 1822 2834 1822 2814 1822 2813 2814 1825 2813 1822 1825 1824 2813 2813 1824 2824 2813 2824 2816 1820 1821 1822 1821 1825 1822 1822 1844 1820 1820 1844 1845 2840 1845 1844 1820 1845 1846 2913 1821 1820 1823 1824 1821 1821 1824 1825 1823 1828 1824 1824 1828 2824 2824 1828 2792 2824 2792 2796 1823 1827 1828 2791 2792 1828 1828 1827 2791 1826 1827 1823 2910 1826 1823 1826 1866 1827 2791 1827 1866 2791 2796 2792 2791 1866 2804 1826 1865 1866 2804 1866 1865 2803 2798 2804 2804 1865 2803 1864 1863 1865 1864 1865 1826 2803 1865 1863 2803 2763 2765 2765 2800 2803 2803 2800 2798 2803 1863 2763 2801 2798 2800 2765 2769 2800 2800 2769 2770 2801 2800 2802 2802 2800 2770 2763 2764 2765 2765 2764 2769 1863 1861 2763 2763 1861 2764 2769 2764 2766 1861 1859 2764 2764 1859 2778 2764 2778 2766 2769 2766 2770 2766 2767 2768 2770 2766 2768 2766 2778 2772 2766 2772 2767 1859 1857 2778 2778 1857 2779 2778 2779 2772 1813 1856 1857 1813 1857 1858 1858 1857 1859 1856 2779 1857 2772 2779 2780 2781 2780 2779 1856 2781 2779 1812 1856 1813 1812 2781 1856 2790 2782 2781 2781 2782 2773 2781 2773 2780 1812 2790 2781 2772 2780 2773 2772 2773 2774 2782 2774 2773 2775 2774 2782 2775 2782 2783 2783 2782 2784 2790 2784 2782 2774 2775 2772 2772 2775 2776 2783 4746 2775 4746 2776 2775 2783 2784 2785 2785 4737 2783 4737 4746 2783 4737 4745 4746 4745 4754 4746 4746 4754 2776 2772 2776 2777 2777 2776 4754 2767 2772 2777 4754 4757 2777 2777 4757 2767 4745 4755 4754 4755 4758 4754 4754 4758 4757 4756 4757 4758 4756 2771 4757 4757 2771 2768 4757 2768 2767 4756 4758 4759 4759 4758 181 4755 181 4758 4759 4771 4756 4756 4771 2802 4756 2802 2771 2770 2768 2771 2802 2770 2771 4771 2801 2802 4759 4766 4771 4759 181 216 216 4766 4759 216 218 4766 181 183 216 216 183 220 181 182 183 182 181 4755 183 182 184 184 182 4755 184 4755 4745 184 185 183 185 184 4738 4738 184 4745 4738 4745 4737 4737 4735 4738 4738 4735 4736 4738 4736 185 183 185 186 185 4736 186 4735 4734 4736 4736 4734 4733 4736 4733 186 1988 1991 4735 4735 1991 4734 4737 1988 4735 1989 1988 4737 2785 1989 4737 1988 1989 1990 1988 1990 1991 1991 1990 1992 4734 1991 1992 1992 1990 1993 2786 1993 1990 2788 2786 1990 2788 1990 2784 2784 1990 1989 2784 1989 2785 2789 2788 2784 2789 2784 2790 2787 2786 2788 2787 2788 2789 2809 1993 2786 2809 2786 2787 1816 2787 2789 2812 2809 2787 2812 2787 1816 1816 2789 1814 1814 2789 2790 1814 2790 1812 1812 1813 1814 1814 1813 1815 1814 1815 1816 1816 1815 1817 1816 1817 1818 1816 1818 2812 1815 1813 2941 1817 1815 2943 2943 1815 2941 1813 1858 2939 2941 1813 2939 2941 2939 2942 2943 2941 2944 2944 2941 2942 2955 1817 2943 2955 2943 2956 2956 2943 2944 2956 2944 1941 2953 2955 2956 2953 2956 1939 1939 2956 1941 1819 1817 2955 2951 1819 2955 2951 2955 2953 2952 2951 2953 2952 2953 2954 2954 2953 1939 1938 1930 1939 2954 1939 1930 1930 1933 2954 2954 1933 2972 2954 2972 2952 1829 2951 2952 2952 2972 2973 2952 2973 1829 1933 1935 2972 2972 1935 2965 2972 2965 2973 1930 1932 1933 1933 1932 1934 1933 1934 1935 1935 1934 1936 1935 1936 1937 1935 1937 2965 4829 1936 1934 4829 1934 4831 4831 1934 4840 1932 4840 1934 1930 1931 1932 1931 1930 1938 4831 4840 4824 4824 4840 4825 4824 4830 4831 4824 4825 4826 4826 4830 4824 4821 4826 4825 4826 4823 4830 2963 2964 2965 2965 2964 2967 2965 1937 2971 2965 2971 2963 2973 2965 2967 2971 4085 2963 4085 2964 2963 2964 2968 2967 4085 2968 2964 4093 2968 4085 2967 2968 2969 4093 2969 2968 4086 4092 4093 4092 2969 4093 2967 2969 1810 1810 2969 2970 4092 2970 2969 4090 4091 4092 4090 4092 4086 4091 2970 4092 4086 2984 2983 4086 2983 4090 4090 2983 1808 1808 4091 4090 1808 2966 4091 4091 2966 2970 1810 2970 2966 2966 1808 1810 1806 1807 1808 1808 1807 1809 1808 1809 1810 1908 1806 1808 1808 2983 1908 1908 2983 2984 1907 1806 1908 1907 1908 2981 1901 1906 1907 1907 1906 1806 2981 1901 1907 1897 1900 1901 1900 1905 1901 1901 1905 1906 1897 1901 2974 2711 1906 1905 2711 1806 1906 2711 1905 2709 2709 1905 2710 2710 1905 1900 2709 2727 2711 2711 2727 1806 2708 2709 2710 2708 2726 2709 2709 2726 2727 2708 2710 2706 2710 1900 2712 2706 2710 2707 2707 2710 2712 2706 2725 2708 2708 2725 2726 4113 2727 2726 4113 2726 2725 1806 2727 4113 4113 2725 4110 4110 4112 4113 4113 4112 1806 2706 2724 2725 4110 2725 2724 2111 4107 4110 4110 2724 2111 4107 4111 4110 4110 4111 4112 2705 2111 2724 2705 2724 2706 2705 2706 2707 2705 2707 2103 2103 2111 2705 2102 2103 2104 2104 2103 2105 2102 2111 2103 2103 2707 2105 2110 2111 2102 4626 2110 2102 2104 4626 2102 2104 2105 2106 2106 4635 2104 2104 4635 4626 2106 2105 2107 2105 2707 2714 2105 2714 2107 2707 2712 2714 2714 2712 2713 2714 2713 2715 2107 2714 2715 2106 2107 2108 2108 2107 2109 2107 2715 2109 2715 2713 2688 2715 2688 2687 2109 2715 2687 2712 1899 2713 2713 1899 1898 2713 1898 2688 2712 1900 1899 1898 1899 1897 1897 1899 1900 1897 1896 1898 2691 2688 1898 1898 1896 2691 2686 2687 2688 2691 2686 2688 2686 2097 2687 2109 2687 2097 2685 2097 2686 2690 2685 2686 2690 2686 2691 2691 1896 1894 2691 1894 2690 1895 1894 1896 1895 1896 1897 1895 1897 2974 1893 1894 1895 1895 2974 2958 1893 1892 1894 2690 1894 1892 2689 2685 2690 2690 1892 2689 2689 1892 1890 2682 2684 2689 2689 2684 2685 2689 1890 2682 2682 2680 2683 2682 2683 2684 2683 2101 2684 2684 2101 2099 2684 2099 2685 2683 2680 2681 2683 2681 2091 2683 2091 2101 2680 2676 2681 2681 2676 2678 2681 2678 2093 2091 2681 2093 2090 2091 2092 2092 2091 2093 2090 2101 2091 2092 2093 2094 2094 2093 2095 2093 2678 2095 2676 2677 2678 2678 2677 2679 2678 2679 2095 2094 2095 2082 2082 2095 2083 2095 2679 2083 2701 2083 2679 2701 2679 2677 2704 2701 2677 2700 2083 2701 2703 2700 2701 2703 2701 2704 2082 2083 2084 2084 2083 2085 2700 2085 2083 4670 2094 2082 2084 4670 2082 2084 2085 2086 2086 4678 2084 2084 4678 4670 2086 2085 2087 2699 2087 2085 2699 2085 2700 2086 2087 2088 2088 4677 2086 2086 4677 4678 4677 4676 4678 4678 4676 4668 4678 4668 4670 4674 4675 4677 4677 4675 4676 2088 4674 4677 4675 2144 4676 4676 2144 2145 4676 2145 4668 2145 4667 4668 4668 4667 4669 4668 4669 4670 2144 2141 2145 2145 2141 2139 2145 2139 4667 2139 2138 4667 4667 2138 4671 4667 4671 4669 4670 4669 2094 4669 4671 4672 4669 4672 2094 2138 2140 4671 4671 2140 4653 4671 4653 4672 2138 2139 2140 2140 2139 2141 2140 2141 4653 4653 2141 4651 4653 4651 4654 4672 4653 4654 4672 4654 2092 2094 4672 2092 4654 4651 4652 4654 4652 2090 2092 4654 2090 2141 2143 4651 4651 2143 4650 4651 4650 4652 4652 4650 4649 4652 4649 2100 2090 4652 2100 2100 2101 2090 2098 2099 2100 2100 2099 2101 2100 4649 2098 2096 2098 4649 2096 4649 4637 4637 4649 4650 4637 4650 4642 4642 4650 2143 2096 4637 4638 4641 4638 4637 4641 4637 4642 2129 4641 4642 2129 4642 2142 4642 2143 2142 4640 4638 4641 2128 4640 4641 2128 4641 2129 2126 2128 2129 2126 2129 2130 2129 2142 2130 2130 2142 2143 2130 2143 2144 2144 2143 2141 4673 2126 2130 4673 2130 4675 4675 2130 2144 4660 4659 4673 4673 4659 4661 4661 2126 4673 4660 4673 4674 4674 4673 4675 4658 4659 4660 4656 4658 4660 4656 4660 4657 4674 4657 4660 4658 4661 4659 2133 2127 4661 4658 2133 4661 4661 2127 2126 4662 4666 4658 4662 4658 4656 4666 2133 4658 2127 2133 2117 2117 2133 2134 4666 2134 2133 2117 2126 2127 2117 2128 2126 2117 4640 2128 4636 4639 4640 4640 4639 4638 2117 4636 4640 2108 4638 4639 2108 4639 2106 2106 4639 4635 4636 4635 4639 2096 4638 2108 2108 2109 2096 2096 2097 2098 2096 2109 2097 2098 2097 2099 2685 2099 2097 4624 4625 4635 4635 4625 4626 4624 4635 4636 4623 4613 4624 4624 4613 4615 4624 4615 4625 4636 4623 4624 4625 4615 4617 4625 4617 4626 4626 4617 2110 4614 2110 4617 4614 4617 4615 4613 4614 4615 4610 4611 4613 4613 4611 4614 4623 4610 4613 4622 4610 4623 4622 4623 4636 4622 4636 2117 2119 2121 4622 4622 2121 4610 2117 2119 4622 4610 2121 4611 2121 4612 4611 4611 4612 4616 4611 4616 4614 2119 2120 2121 2121 2120 2122 4587 2121 2122 4612 2121 4587 2117 2118 2119 2119 2118 2120 2120 2118 4621 4621 4620 2120 2120 4620 4596 2120 4596 2122 2117 2132 2118 2132 4621 2118 4619 4620 4621 4634 4619 4621 2132 4634 4621 2117 2131 2132 2131 4634 2132 4633 4632 4634 4634 4632 4619 2131 4633 4634 2058 4618 4619 4619 4618 4620 4632 2058 4619 4631 2067 4632 4632 2067 2058 4633 4631 4632 4627 4631 4633 2125 4627 4633 2125 4633 2131 2125 2131 2117 2117 2124 2125 2125 2124 4628 4628 4627 2125 4627 4628 4629 4629 4630 4627 4627 4630 4631 4630 2065 4631 4631 2065 2067 4629 2063 4630 4630 2063 2065 4628 4648 4629 4629 4648 2073 4629 2073 2063 2124 4643 4628 4628 4643 4648 4643 4646 4648 4648 4646 4644 4648 4644 2073 2068 2072 2073 2073 2072 2064 2073 2064 2063 2073 4644 2068 2063 2064 2065 2065 2064 2066 2728 2064 2072 2728 2066 2064 2068 2071 2072 2728 2072 2730 2730 2072 2071 2729 2728 2730 2729 2751 2728 2728 2751 2066 2730 2071 2731 2729 2730 2733 2733 2730 2731 2070 2071 2068 2731 2071 2070 2731 2070 2732 2733 2731 2734 2734 2731 2732 2734 1867 2733 2733 1867 1841 2733 1841 2729 2734 2732 2735 2735 1868 2734 2734 1868 1867 2732 2070 2723 2732 2723 2720 2735 2732 2720 2735 2720 1849 1849 1869 2735 2735 1869 1868 1839 1867 1868 1839 1868 1848 1848 1868 1869 1841 1867 1839 1839 1840 1841 2903 1840 1839 2903 1839 2902 2902 1839 1848 1847 1848 1849 1848 1869 1849 2902 1848 2898 1848 1847 2898 2898 2899 2902 2902 2899 2900 2902 2900 2903 2903 2900 2901 2903 2901 2904 2904 1840 2903 2899 2026 2900 2900 2026 2016 2900 2016 2901 2898 2897 2899 2897 2024 2899 2899 2024 2026 2024 2025 2026 2026 2025 2027 2026 2027 2016 2897 2022 2024 2898 2924 2897 2897 2924 2916 2897 2916 2022 1847 1872 2924 2898 1847 2924 1849 1870 1847 1847 1870 1871 1847 1871 1872 1872 1871 1873 2717 1873 1871 2717 1871 2718 2718 1871 1870 2718 1870 2719 2719 1870 1849 2719 1849 2720 2721 2718 2719 2721 2719 2722 2722 2719 2720 2716 2717 2718 2716 2718 2721 2077 2716 2721 2077 2721 2079 2079 2721 2722 2722 2720 2723 2079 2722 2081 2081 2722 2723 2078 2077 2079 2078 2079 2080 2080 2079 2081 2076 2075 2077 2076 2077 2078 2075 2716 2077 4656 2076 2078 4656 2078 4662 4662 2078 2080 2080 2081 2069 4662 2080 4663 4663 2080 2069 4663 4666 4662 4663 2069 4664 4664 4665 4663 4663 4665 4666 4665 2134 4666 4664 4647 4665 4647 2135 4665 4665 2135 2134 4664 2069 4645 4664 4645 4647 4645 4646 4647 4647 4646 2137 4647 2137 2136 4647 2136 2135 2117 2134 2135 2135 2136 2117 2117 2136 2137 2117 2137 2123 2123 2137 4643 4643 2137 4646 4645 4644 4646 2069 4644 4645 2069 2068 4644 2068 2069 2070 2069 2081 2070 2081 2723 2070 2124 2123 4643 2123 2124 2117 4656 4657 4655 4655 2076 4656 4655 4657 4674 4655 2074 2076 2088 2074 4655 4655 4674 2088 2074 2075 2076 2088 2089 2074 2074 2089 2075 2088 2087 2089 2692 2075 2089 2692 2089 2695 2695 2089 2087 2692 2716 2075 2695 2694 2692 2692 2694 2716 2693 2694 2695 2695 2087 2699 2693 2695 2696 2696 2695 2699 2693 2717 2694 2694 2717 2716 2696 2697 2693 2693 2697 2717 2696 2699 2702 2702 1877 2696 2696 1877 2698 2696 2698 2697 2702 2699 2700 2702 2700 2703 2703 1879 2702 2702 1879 1877 1877 1875 2698 2698 1875 1873 2698 1873 2697 2697 1873 2717 2016 2017 2018 2016 2027 2017 2876 2016 2018 2901 2016 2876 2018 2017 2019 2017 4702 2019 2018 2019 2020 2876 2018 2878 2878 2018 2020 2877 2876 2878 2901 2876 2877 2904 2901 2877 2877 2878 2881 2881 1843 2877 2904 2877 1843 2878 2020 2879 2881 2878 2879 2881 2879 2882 2882 1835 2881 2881 1835 1843 1834 1842 1843 1834 1843 1835 1843 1842 2904 2904 1842 1840 1841 1840 1842 1841 1842 1834 1834 1835 1836 1841 1834 2746 1834 1836 2746 1836 1835 1837 2882 1837 1835 1836 1837 1838 2750 2749 1836 2750 1836 1838 2746 1836 2749 1841 2746 2729 2729 2746 2751 2746 2749 2751 2748 2747 2749 2748 2749 2750 2751 2749 2747 1838 2752 2750 2750 2752 2753 2750 2753 2748 2059 2747 2748 2748 2753 2060 2748 2060 2059 2751 2747 2066 2066 2747 2059 2058 2059 2057 2057 2059 2060 2067 2066 2059 2067 2059 2058 2065 2066 2067 2058 2057 4618 2055 2056 2057 2057 2060 2055 4600 4618 2057 4600 2057 2056 4605 4620 4618 4605 4618 4603 4603 4618 4600 4600 2056 4601 4600 4601 4603 2055 4119 2056 4601 2056 4119 4603 4601 4604 4119 4599 4601 4601 4599 4607 4601 4607 4604 4603 4604 4605 4604 4609 4605 4609 4620 4605 4620 4609 4596 4604 4596 4609 4604 4607 4608 4604 4608 4597 4597 4596 4604 4599 4602 4607 4607 4602 4606 4607 4606 4608 4608 2122 4597 4608 4606 2122 2122 4596 4597 2122 4588 4587 4606 4588 2122 4602 4589 4606 4606 4589 4588 4587 4588 4589 4587 4589 4590 4590 4612 4587 4590 4589 4591 4602 4591 4589 4590 4591 4592 4592 4595 4590 4595 4612 4590 4595 4616 4612 4592 4594 4595 4594 4616 4595 4593 4594 4592 4598 4593 4592 4598 4592 4602 4592 4591 4602 4593 2115 4594 2115 4108 4594 4594 4108 4616 4614 4616 4108 4107 4106 4108 4107 4108 4109 4109 4108 2115 4614 4108 4106 4106 2110 4614 2111 2110 4106 2111 4106 4107 4107 4109 4111 4109 2115 2113 4109 2113 2740 4111 4109 2740 4111 2740 4112 2740 2113 2112 2112 2741 2740 2740 2741 2742 2740 2742 2743 4112 2740 2743 2112 2113 2114 2114 2113 2115 2112 2114 4120 2112 4120 4125 2112 4125 2741 2741 4125 4126 2741 4126 2742 2743 2742 2744 4126 2744 2742 2743 2744 2739 2743 2739 4112 2739 2744 2745 4126 2745 2744 4125 4129 4126 4126 4129 4130 4126 4130 4131 4131 2745 4126 4120 4124 4125 4125 4124 4129 4124 4128 4129 4129 4128 4127 4129 4127 4130 4134 4131 4130 4130 4127 4132 4130 4132 4134 4133 4131 4134 4134 1807 4133 4134 4132 1807 4127 2758 4132 4132 2758 2757 4132 2757 1807 1913 2757 2758 1913 2758 1911 1911 2758 2759 4127 2759 2758 1807 2757 1913 1911 1912 1913 1913 1912 1914 1913 1914 1807 1911 1910 1912 2863 2861 1912 1912 2861 1914 2883 2863 1912 1912 1910 2883 1807 1914 1915 2861 2858 1914 1914 2858 1915 2860 2859 2861 2861 2859 2858 2863 2860 2861 2847 1915 2858 2847 2858 2846 2846 2858 2845 2845 2858 2859 1807 1915 1902 1902 1915 2847 2846 2830 2847 2847 2830 2831 2847 2831 1902 2845 2828 2846 2846 2828 2830 2844 2827 2845 2845 2827 2828 2845 2859 2844 2827 2826 2828 2828 2826 2829 2828 2829 2830 2830 2829 2831 2831 2829 1904 2831 1904 1903 1902 2831 1903 1902 1903 1807 1807 1903 1904 1807 1904 1809 1809 1904 2832 2832 1904 2829 2832 2829 2833 2833 2829 2826 2806 1809 2832 2806 2832 2805 2805 2832 2833 2833 2826 2002 2805 2833 1995 1995 2833 2002 2805 1995 1997 2806 2805 2807 2805 1997 2807 2806 2807 2810 2810 1830 2806 1830 1809 2806 2807 1997 1999 2807 1999 2808 2810 2807 2808 1995 1996 1997 1997 1996 1998 1997 1998 1999 1999 1998 2000 1999 2000 1993 2808 1999 1993 2808 1993 2809 2810 2808 2811 2811 2808 2809 1992 1993 1994 1993 2000 1994 2000 4715 1994 1998 4715 2000 4723 4715 1998 1996 4723 1998 4715 4716 4717 1994 4715 4717 4716 4715 4718 4718 4715 4719 4723 4719 4715 1994 4717 1992 1992 4717 4734 4734 4717 4716 4734 4716 4733 4733 4716 4718 4718 4719 4720 4733 4718 4720 4720 4719 4721 4721 4719 189 4722 189 4719 4722 4719 4723 4721 4733 4720 4721 187 4733 186 4733 187 4721 189 188 188 187 4721 183 188 189 183 189 190 190 189 4722 4708 190 4722 4708 4722 4707 4707 4722 4723 191 192 190 198 191 190 198 190 4708 4707 4705 4708 4708 4705 4706 4708 4706 198 197 191 198 198 4706 197 4705 4697 4706 4706 4697 4698 4706 4698 197 2001 2003 4705 4705 2003 4697 4707 2001 4705 2003 2005 4697 4697 2005 4696 4697 4696 4698 4698 4696 4695 4698 4695 195 197 4698 195 4696 2005 2007 2007 4679 4696 4696 4679 4681 4696 4681 4695 2005 2006 2007 2007 2006 2008 2007 2008 4679 4679 2008 4680 4679 4680 4681 4681 4680 4682 4681 4682 4683 4695 4681 4683 2008 2015 4680 4680 2015 4689 4680 4689 4682 2008 2006 2009 2009 2015 2008 2014 2013 2015 2014 2015 2009 2013 4689 2015 4682 4689 4684 4684 4689 4690 4692 4690 4689 4692 4689 2013 4683 4682 4684 4683 4684 4685 4685 4684 4686 4684 4690 4686 4686 4690 4688 4688 4690 534 4691 534 4690 4691 4690 4692 4694 4691 4692 4694 4692 2011 2011 4692 2013 536 534 4691 4693 536 4691 4693 4691 4694 2011 4699 4694 4694 4699 4700 4694 4700 4693 538 536 4693 4693 4700 540 4693 540 538 535 534 536 535 536 537 537 536 538 537 538 539 539 538 540 4502 535 537 4502 537 4504 4504 537 539 533 534 535 4496 533 535 4496 535 4502 4497 4496 4502 4497 4502 4503 4503 4502 4504 4503 4504 4506 2154 4497 4503 4506 4180 4503 4503 4180 4185 4503 4185 2154 4506 4181 4180 4180 4181 4182 4182 4185 4180 4182 2154 4185 4182 4181 4183 4182 4183 4179 2155 2154 4182 4187 2155 4182 4188 4187 4182 4188 4182 4179 4179 2671 4188 2154 2155 2156 4483 4484 2156 4484 2154 2156 4482 4490 4483 4483 4490 4491 4483 4491 4484 4491 4497 4484 4484 4497 2154 4490 4497 4491 4482 4489 4490 4489 4496 4490 4490 4496 4497 4487 4486 4482 4487 4482 4488 4486 4489 4482 4486 4496 4489 4486 533 4496 549 4486 4487 549 533 4486 4488 549 4487 4477 4478 4488 4488 4478 549 533 549 531 531 549 196 4478 196 549 531 532 533 533 532 534 531 196 550 4687 4688 531 531 4688 532 550 4687 531 4688 534 532 4687 4686 4688 4685 4686 4687 550 4685 4687 550 196 195 4695 4685 550 195 4695 550 4695 4683 4685 195 196 197 197 196 191 4465 4457 191 191 4457 192 196 4465 191 4467 4465 196 4478 4467 196 4477 4467 4478 4702 4700 4699 4702 4699 2019 2011 2021 4699 2019 4699 2021 2020 2019 2021 2020 2021 2010 2010 2021 2011 2010 2011 2012 2012 2011 2013 2010 2012 2862 2879 2020 2010 2879 2010 2880 2880 2010 2862 2012 2013 2014 2012 2014 2860 2862 2012 2860 2862 2860 2863 2880 2862 2863 2882 2879 2880 2882 2880 2883 2883 2880 2863 2883 1837 2882 2883 1910 1837 1838 1837 1909 1909 1837 1910 1909 1910 1911 1838 1909 2752 1909 1911 2752 1911 2759 2760 2752 1911 2760 2752 2760 2753 2760 2759 2761 2760 2761 2755 2753 2760 2755 2761 2759 4127 2755 2761 2762 2761 4127 2762 2762 4127 4128 2755 2762 2756 2762 4128 2756 2756 4128 4123 4124 4123 4128 2754 2755 2756 2756 4123 2754 4121 4122 4123 2754 4123 4122 4121 4123 4124 4120 4121 4124 4120 4114 4121 4121 4114 4116 4121 4116 4122 4122 4116 4118 4122 4118 2062 2754 4122 2062 2062 2061 2754 2754 2061 2755 2055 2061 2062 2062 4118 2055 4116 4117 4118 4118 4117 4119 4118 4119 2055 4114 4115 4116 4116 4115 4117 4117 4115 4598 4119 4117 4599 4117 4598 4599 4114 2116 4115 4115 2116 4593 4115 4593 4598 4599 4598 4602 2116 2115 4593 2114 2115 2116 2114 2116 4114 4120 2114 4114 2055 2060 2061 2753 2755 2060 2060 2755 2061 2860 2014 2859 2843 2859 2014 2843 2014 2009 2844 2859 2843 2009 2006 2843 2843 2006 2825 2843 2825 2844 2844 2825 2827 2006 2004 2825 2825 2004 2826 2825 2826 2827 2005 2004 2006 2003 2002 2004 2003 2004 2005 2002 2826 2004 2001 2002 2003 2001 1995 2002 1996 1995 2001 1996 2001 4707 4707 4723 1996 183 186 187 187 188 183 2811 2809 2812 2812 1833 2811 2811 1833 1832 2811 1832 2810 2812 1818 1833 1819 1832 1833 1819 1833 1818 1831 1830 1832 1831 1832 1819 2810 1832 1830 1818 1817 1819 1831 1819 2951 1829 1830 1831 1829 1831 2951 1829 1809 1830 1811 1809 1829 1829 2973 1811 1810 1809 1811 2973 2967 1811 1811 2967 1810 2736 1807 1806 1807 2736 4133 2736 1806 2737 4133 2736 4131 2736 2737 4131 2737 1806 2738 4112 2738 1806 2737 2738 2739 2739 2745 2737 4131 2737 2745 4112 2739 2738 2939 1858 2926 1858 1859 1860 1858 1860 2925 1858 2925 2926 1860 1859 1861 1860 1861 1862 1860 1862 2925 1862 1861 1863 1862 1863 1864 2911 1862 1864 2911 1864 1826 2911 1826 2909 2909 1826 2910 1855 1846 1845 2841 1855 1845 2841 1845 2840 2840 2835 2841 2841 2835 2842 2840 2836 2835 1987 2835 2836 1987 2836 2837 1986 1978 1987 1978 2835 1987 4790 1987 2837 1986 1987 4802 4802 1987 4790 1980 1978 1986 1980 1986 4802 1977 1978 1979 1979 1978 1980 1978 1977 2835 1980 4802 4803 1980 4803 1979 1979 1981 1977 1979 4803 4815 1979 4815 1981 2848 1977 1983 2835 1977 2848 1983 2855 2848 2848 2855 2857 2835 2848 2842 1985 2853 1983 1983 2853 2855 2853 2854 2855 2855 2854 2856 2855 2856 2857 4054 2857 2856 4054 2856 4051 4051 2856 2854 4051 2854 2853 2853 1985 4051 4051 1985 4048 4047 4045 4048 4046 4045 4047 5111 5112 5113 5113 5108 3492 132 135 136 132 136 137 137 153 132 132 153 154 132 154 155 155 156 132 132 156 157 132 157 158 133 132 5203 5203 132 158 154 5603 155 155 5603 5604 155 5604 156 156 5604 5605 156 5605 157 5603 5601 5604 5604 5601 5594 5604 5594 5605 5602 5600 5603 5603 5600 5601 154 5602 5603 5600 3800 5601 5601 3800 3802 5601 3802 5594 5599 3796 5600 3796 3798 5600 5600 3798 3800 5602 5599 5600 3798 3799 3800 3800 3799 3801 3800 3801 3802 3802 3801 3803 5594 3802 3803 3803 3801 3804 3806 3804 3801 3806 3801 3810 3810 3801 3799 3798 3797 3799 3810 3799 3797 3796 3797 3798 3796 3793 3797 3809 3810 3797 3809 3797 3793 3810 3808 3806 3811 3808 3810 3811 3810 3809 3807 3808 2398 3806 3808 3807 2398 3808 3811 3809 3025 3811 3811 3025 3024 3811 3024 2398 3020 3024 3025 3020 3025 3022 3022 3025 3026 3809 3026 3025 2398 3024 3020 3020 2407 2398 3022 3790 3020 3020 3790 2407 3021 3022 3023 3022 3026 3023 3021 3790 3022 3023 3026 3809 3021 3023 3027 3027 3023 3028 3028 3023 3792 3792 3023 3809 3787 3021 3027 3787 3790 3021 3791 2407 3790 3787 3791 3790 3046 3042 3791 3791 3042 2407 3785 3046 3791 3785 3791 3787 3046 3047 3042 3046 3052 3047 3052 3046 3785 2407 3042 3043 3042 3047 3048 3042 3048 3043 2406 2398 2407 3043 3044 2407 2407 3044 3045 2407 3045 2406 3048 3067 3043 3043 3067 3071 3043 3071 3044 3047 3068 3048 3048 3068 3067 3067 3068 3069 3070 3071 3067 3067 3069 3070 3070 3072 3071 3044 3071 3072 3073 3045 3044 3044 3072 3073 2406 3045 3073 3072 2405 3073 3073 2405 2406 3070 2405 3072 3070 3069 3074 3070 3074 3078 3078 2405 3070 2403 2404 2405 2405 2404 2397 2405 2397 2406 3078 2403 2405 3078 3074 3075 3078 3075 3079 3079 2403 3078 2403 2408 2404 3079 2408 2403 3079 3075 3077 3079 3077 2409 2409 2408 3079 3074 2332 3075 3075 2332 3076 3075 3076 3077 3099 2409 3077 3101 3099 3077 3101 3077 3076 2330 3101 3076 2330 3076 2332 3100 3099 3101 2328 3100 3101 2328 3101 2330 3098 2411 3099 3099 2411 2409 3100 3098 3099 3093 3098 3100 2326 3093 3100 2326 3100 2328 2327 2326 2328 2327 2328 2329 2329 2328 2330 2325 2324 2326 2325 2326 2327 2324 3093 2326 5700 2325 2327 5700 2327 5706 5706 2327 2329 2329 2330 2331 5706 2329 5707 5707 2329 2331 5707 5711 5706 5706 5711 5702 5706 5702 5700 5707 2331 5708 5708 5710 5707 5707 5710 5711 5710 355 5711 5711 355 354 5711 354 5702 5708 5709 5710 5709 356 5710 5710 356 355 5708 2331 5692 5708 5692 5694 5694 5709 5708 5694 357 5709 5709 357 356 341 355 356 356 357 341 341 354 355 340 339 341 340 341 342 345 346 341 345 341 347 348 350 341 341 350 353 341 353 347 346 354 341 341 357 358 341 358 342 341 339 5740 5740 5739 341 341 5739 5745 341 5745 348 354 346 5705 5702 354 5705 5702 5705 5703 346 345 5705 5705 345 5720 5705 5720 5703 5702 5703 5704 5700 5702 5704 5703 5720 5704 5704 5720 5721 5718 5721 5720 5718 5720 347 347 5720 345 5700 5704 5701 5704 5721 5701 5700 5701 5699 5699 2325 5700 5701 5721 5699 5699 5721 2320 5716 2320 5721 5716 5721 5718 5699 2322 2325 5699 2320 2322 2322 2324 2325 2320 2321 2322 2322 2321 2323 2322 2323 2324 2318 2319 2320 2320 2319 2321 2318 2320 5716 3110 2323 2321 3110 2321 3112 3112 2321 2319 3091 2324 2323 3091 2323 3110 3091 3093 2324 3091 3092 3093 3110 3092 3091 3094 3092 3110 3094 3110 3111 3111 3110 3112 3112 2319 3113 3111 3112 3117 3117 3112 3113 3111 3095 3094 3117 2438 3111 3111 2438 3097 3111 3097 3095 3094 3095 3096 3094 3096 3092 3092 3096 3093 3093 3096 3098 3095 2435 3096 3096 2435 2434 3096 2434 3098 3097 2435 3095 3097 2437 2435 2438 2437 3097 2412 2434 2435 2412 2435 2436 2436 2435 2437 2411 2434 2412 3098 2434 2411 2410 2409 2411 2410 2411 2412 2404 2409 2410 3055 2404 2410 3055 2410 3059 2412 3059 2410 2404 2408 2409 3054 3057 2404 2404 3057 3058 2404 3058 2397 3054 2404 3055 3054 3055 3056 3777 3057 3054 3056 3777 3054 3058 3057 3767 3767 3057 3777 3058 3767 2397 3767 3765 2397 3767 3777 3765 3774 3779 3777 3774 3777 3056 3765 3777 3779 3056 3055 3061 3056 3061 3774 3055 3059 3060 3061 3055 3060 3061 3060 3062 3774 3061 3062 3060 3063 3062 3774 3062 3063 3060 2359 3063 3063 2359 3769 3769 3774 3063 2357 2358 2359 2359 2358 2360 2357 2359 3060 2359 2360 3757 3769 2359 3757 3769 3757 3770 3770 3773 3769 3769 3773 3774 3757 2360 3758 3757 3758 3759 3770 3757 3759 5534 3758 2360 2358 5534 2360 3759 3758 3760 5533 3760 3758 5533 3758 5534 3759 3760 3761 3770 3759 3771 3771 3759 3761 3761 3760 3762 5532 5531 3760 5532 3760 5533 5528 5532 5533 5528 5533 5526 5526 5533 5534 2358 5526 5534 5526 5527 5528 5541 5526 2358 5541 5527 5526 2357 2356 2358 2356 5541 2358 5542 5524 5541 5541 5524 5527 5544 5542 5541 5544 5541 2356 5527 5524 5528 5524 5525 5522 5528 5524 5522 5542 5525 5524 5522 5525 457 457 5525 5542 5542 458 457 5543 458 5542 5543 5542 5544 5556 5543 5544 5544 5557 5556 5544 2356 5557 459 458 5543 464 459 5543 5556 464 5543 457 458 319 319 458 459 459 464 319 319 464 465 5555 465 464 5555 464 5556 5556 5557 5558 5556 5558 5555 5557 2356 2361 5557 2361 5558 5555 5558 5559 5558 2361 2363 5558 2363 5559 5554 465 5555 5555 5559 5554 319 465 460 5554 460 465 5552 460 5554 5554 5559 5549 5554 5549 5552 5559 2363 2365 5559 2365 5549 2361 2362 2363 2363 2362 2364 2363 2364 2365 2365 2364 2366 2365 2366 2367 5549 2365 2367 5547 5548 5549 5552 5549 5548 5549 2367 5547 2367 2366 2368 2368 2376 2367 5547 2367 2376 3080 2368 2366 3080 2366 3083 3083 2366 2364 2375 2376 2368 2375 2368 3080 2375 2374 2376 5547 2376 5564 5564 2376 2374 5564 5548 5547 5552 5548 5550 5550 5548 5564 5564 2374 5566 5550 5564 5565 5565 5564 5566 5566 2374 2372 5553 5551 5565 5565 5551 5550 5553 5565 474 5550 5551 5552 5551 461 5552 5552 461 460 5553 461 5551 5553 473 461 474 473 5553 319 473 474 461 473 319 319 460 461 457 319 5510 5510 319 5505 457 5519 5520 5510 5519 457 457 5521 5522 5520 5521 457 5510 5505 5511 5511 5519 5510 5511 5505 5512 5511 5512 5523 5523 5519 5511 5523 5520 5519 5535 5521 5520 5535 5520 5523 5536 5522 5521 5536 5521 5535 5528 5522 5536 5535 5530 5536 5536 5530 5532 5536 5532 5528 5523 5529 5535 5535 5529 5530 5523 5512 5529 5529 5512 5513 5514 2350 5529 5529 2350 3764 5529 3764 5530 5529 5513 5514 5530 3764 5531 5530 5531 5532 3763 3762 3764 3763 3764 2352 2352 3764 2350 3761 3762 3763 3761 3763 3768 3035 3768 3763 3035 3763 2352 3035 2352 3032 3032 3034 3035 3034 3768 3035 3034 3776 3768 3761 3768 3771 3771 3768 3776 3033 3034 3032 3033 3776 3034 3032 3036 3033 3036 3032 3751 3751 3032 3031 3033 3036 3037 3033 3037 3038 3038 3775 3033 3033 3775 3776 3037 3036 3751 3041 3038 3037 3751 3753 3037 3037 3753 3041 2395 3040 3038 2395 3038 3041 3038 3040 3775 3041 3753 2395 3753 3754 2395 3751 3754 3753 3756 3754 3751 2395 3754 3752 3752 3754 3756 3751 3746 3756 3756 3746 3744 3756 3744 3741 3752 3756 3755 3755 3756 3741 3743 3741 3744 3743 3744 3745 3745 3744 3746 3740 3739 3741 3740 3741 3742 3742 3741 3743 3755 3741 3739 3742 3743 5479 5479 3743 3745 3745 3746 3747 3747 3746 3748 3748 3746 3749 3748 3749 3750 3750 3749 3751 3751 3749 3746 3751 3031 3750 3737 3738 3739 3737 3739 3740 3755 3739 3738 5472 3738 3737 5472 5473 3738 3738 3018 3013 3738 3013 3755 3738 5473 3018 3755 3013 3016 3755 3016 3752 3011 3012 3013 3012 3016 3013 3011 3013 3017 3017 3013 3018 3017 3018 3019 5473 3019 3018 5473 5487 3019 3017 3019 3732 3732 3019 3734 5487 5490 3019 3019 5490 3734 3732 3011 3017 3732 3735 3011 3011 3735 3012 3732 3734 3733 3730 3736 3732 3732 3736 3735 3733 3734 5490 5487 5491 5490 3012 3735 3010 3010 3735 2396 3736 2396 3735 3004 3006 3736 3736 3006 2396 3730 3004 3736 2998 3007 3730 3007 3004 3730 3004 3001 3005 3004 3005 3006 3007 3001 3004 3008 2396 3006 3008 3006 3009 3009 3006 3005 3009 3005 3806 3005 3001 3806 3806 3807 3009 3009 3807 3008 2398 2396 3008 3008 3807 2398 2397 2396 2398 2406 2397 2398 2395 2396 2397 3010 2396 2395 2395 3014 3010 2395 2397 3039 3039 3040 2395 3752 3014 2395 3010 3014 3015 3010 3015 3012 3752 3015 3014 3752 3016 3015 3012 3015 3016 3775 3040 3039 3775 3039 3780 3780 3039 2397 3772 3776 3775 3772 3775 3778 3778 3775 3780 3778 3780 3766 3766 3780 2397 2397 3765 3766 3765 3779 3766 3766 3779 3778 3772 3778 3773 3773 3778 3779 3773 3779 3774 3770 3772 3773 3771 3772 3770 3771 3776 3772 3806 3001 3003 3806 3003 3805 3805 3804 3806 3001 3002 3003 3002 5575 3003 5575 5585 3003 3003 5585 3805 3803 3804 3805 3805 5585 5594 5594 3803 3805 5575 5584 5585 5605 5594 5585 5605 5585 5584 5574 5573 5575 5574 5575 3002 5573 5584 5575 5573 173 5584 157 5605 5584 157 5584 173 5572 170 5573 5572 5573 5574 170 173 5573 5562 5572 5574 5562 5574 2346 2346 5574 3002 168 170 5572 5563 168 5572 5563 5572 5562 168 169 170 170 169 173 168 167 169 173 169 175 5224 175 169 5224 169 5230 5230 169 167 173 175 174 5224 5222 175 175 5222 174 5223 5221 5224 5224 5221 5222 5230 5223 5224 5230 5235 5223 1421 1426 5223 5223 1426 5221 5235 1421 5223 1426 1427 5221 5221 1427 5214 5221 5214 5222 5222 5214 5213 5222 5213 174 5210 5213 5214 5210 5214 1427 5212 171 5213 5212 5213 5210 174 5213 171 3320 3323 5210 3320 5210 1427 1427 3319 3320 3319 3323 3320 1427 3318 3319 3318 3325 3319 3319 3325 3326 3318 3324 3325 3324 1571 3325 3324 1572 1571 3318 3343 3324 3324 3343 3344 3324 3344 1572 1563 1571 1572 1563 1572 1564 1572 3344 1564 3344 3339 1564 3318 1422 3343 1420 1421 1422 1420 1422 3318 1421 1420 1426 1426 1420 1427 1420 3318 1427 171 172 173 171 173 174 172 171 5212 172 176 173 176 172 5211 5211 172 5212 173 176 177 173 177 157 5211 177 176 157 177 178 157 178 158 5202 158 178 5203 158 5202 5202 5196 5203 5203 5196 5188 5203 5188 133 129 133 5188 5188 5187 129 2346 2345 5562 5562 2345 5560 5562 5560 5563 2344 2345 2346 2345 2344 5560 5560 2344 5546 5560 5546 5561 5563 5560 5561 2344 2346 2347 5539 5546 2344 5539 2344 2347 5561 5546 5545 5561 5545 161 2347 2346 2348 2347 2348 2349 2347 2349 5539 5539 2349 5537 2349 2348 5537 2348 2346 3001 3000 2348 2998 2998 2348 3001 3001 2346 3002 2998 3001 3007 3080 3103 2375 3083 3082 3080 3080 3082 3103 3103 3082 3081 3081 3102 3103 3081 3082 3083 3083 2364 3087 3081 3083 3084 3084 3083 3087 3084 3085 3081 3081 3085 3102 3102 3085 3086 3086 2414 3102 3102 2414 2413 3084 3086 3085 3084 3087 3089 3089 2432 3084 3084 2432 3086 2432 2433 3086 3086 2433 2414 2413 2414 2415 2433 2415 2414 2415 2421 2413 2413 2421 2422 2422 2421 3119 3119 2421 2415 2432 2431 2415 2432 2415 2433 3119 2415 3118 3118 2415 2431 2430 2431 2432 3089 2430 2432 2430 2438 2431 3118 2431 3117 3117 2431 2438 3117 3113 3118 3118 3113 3114 3118 3114 3119 3119 3114 3116 3119 3116 2422 3126 2422 3116 3114 3115 3116 3126 3116 3127 3127 3116 3115 3113 2313 3114 3114 2313 3115 3113 2319 2313 2312 2313 2314 2314 2313 2318 2318 2313 2319 2312 3115 2313 3127 3115 2312 3129 3126 3127 3129 3127 2317 2317 3127 2312 3128 3126 3129 3131 3128 3129 3131 3129 2311 2311 3129 2317 2312 2315 2317 2317 2315 2311 2310 2309 2311 2315 2310 2311 2309 3131 2311 3130 3128 3131 3143 3130 3131 3143 3131 2309 3130 2399 3128 2417 2399 3130 3142 2417 3130 3142 3130 3143 3140 3142 3143 3140 3143 2307 2307 3143 2309 2308 2307 2309 2308 2309 2310 2306 2299 2307 2306 2307 2308 3141 3140 2307 3141 2307 2299 3139 3138 3140 3139 3140 3141 3138 3142 3140 3168 3139 3141 2301 3168 3141 2301 3141 2299 2299 2300 2301 2300 2299 2306 2301 2300 2302 2301 2302 2303 2303 3168 2301 3167 3166 3168 3168 3166 3139 2303 3167 3168 2303 2302 2304 2303 2304 2305 2305 3167 2303 3160 3165 3167 3167 3165 3166 2305 3160 3167 3165 2444 3166 3166 2444 2428 3166 2428 3139 3163 2446 3165 3165 2446 2444 3160 3163 3165 2443 2428 2444 2443 2444 2445 2445 2444 2446 2445 2446 2442 2442 2446 2447 3163 2447 2446 2441 2440 2442 2442 2447 2441 2442 3150 2445 2442 2440 3150 3164 2441 2447 3164 2447 3162 3162 2447 3163 2439 2440 2441 2439 2441 3180 3180 2441 3164 3181 2440 2439 3181 3724 2440 3725 2440 3724 2439 3185 3181 3181 3185 3186 3181 3186 3183 3183 3724 3181 3721 3725 3724 3721 3724 3182 3182 3724 3183 3719 3725 3721 3720 3719 3718 3718 3719 3717 3717 3719 3715 3715 3719 3721 5640 5634 3720 3718 5640 3720 3717 3716 3718 5642 5640 3718 3716 5642 3718 3715 3716 3717 5648 5642 3716 3715 5648 3716 3715 3721 3722 5650 5648 3715 3722 5650 3715 5647 5641 5648 5648 5641 5642 5650 5647 5648 5641 5639 5642 5642 5639 5640 102 101 5641 5641 101 5639 5647 102 5641 103 102 5647 5649 103 5647 5649 5647 5650 5655 5649 5650 5655 5650 3722 104 103 5649 5656 104 5649 5656 5649 5655 3722 3723 5655 5658 5656 5655 5658 5655 3190 3190 5655 3723 109 104 5656 5657 109 5656 5657 5656 5658 5663 5657 5658 5663 5658 5664 5664 5658 3190 110 109 5657 108 110 5657 108 5657 5663 5671 108 5663 5671 5663 5672 5672 5663 5664 5664 3190 3189 5672 5664 3701 3701 5664 3189 5672 3701 3700 5671 5672 5681 5672 3700 5681 105 108 5671 105 5671 5682 5671 5681 5682 105 107 108 105 106 107 105 5682 106 5682 5681 5683 5682 5683 5686 106 5682 5686 5681 3700 3698 5681 3698 5683 3698 3696 5683 5683 3696 3708 5683 3708 5684 5686 5683 5684 5686 5684 5687 106 5686 111 111 5686 5687 106 111 107 107 111 112 111 5687 112 5687 5684 5685 5687 5685 5688 112 5687 5688 5684 3708 3707 5684 3707 5685 3695 3707 3708 3695 3708 3696 3706 3705 3707 3706 3707 3695 5685 3707 3705 5685 3705 5680 5688 5685 5680 5688 5680 5689 112 5688 113 113 5688 5689 107 112 113 113 114 107 113 5689 114 5689 5680 5679 5689 5679 5690 114 5689 5690 107 114 115 114 5690 115 5697 115 5690 5697 5690 5698 5698 5690 5679 3702 5679 5680 5698 5679 3176 3176 5679 3702 5713 5697 5698 5713 5698 3175 3175 5698 3176 118 115 5697 5712 118 5697 5712 5697 5713 5715 5712 5713 5715 5713 2298 2298 5713 3175 3175 3176 3177 3175 3177 2298 3709 3177 3176 3709 3176 3702 3179 3159 3177 3177 3159 3158 3177 3158 2298 3179 3177 3709 2296 2297 2298 2298 3158 2296 2298 2297 5715 3158 3159 3160 3158 3160 2296 3161 3163 3159 3159 3163 3160 3179 3161 3159 3178 3161 3179 3178 3179 3709 3161 3162 3163 3178 3162 3161 3180 3164 3178 3178 3164 3162 3709 3710 3178 3178 3710 3180 3180 3710 2439 3710 3711 2439 3709 3711 3710 3713 3711 3709 3702 3704 3709 3709 3704 3706 3709 3706 3713 2439 3711 3714 3714 3711 3713 3714 3185 2439 3712 3186 3714 3714 3186 3185 3714 3713 3712 3183 3186 3187 3712 3187 3186 3182 3183 3184 3183 3187 3184 3184 3187 3712 3182 3184 3188 3188 3184 3189 3189 3184 3701 3701 3184 3712 3721 3182 3188 3188 3189 3190 3188 3190 3721 3721 3190 3723 3721 3723 3722 3701 3712 3699 3712 3713 3697 3712 3697 3699 3699 3700 3701 3697 3698 3699 3699 3698 3700 3695 3696 3697 3697 3696 3698 3713 3695 3697 3713 3706 3695 3704 3705 3706 3702 3703 3704 3704 3703 3705 5680 3705 3703 5680 3703 3702 2296 3160 2305 2294 2295 2296 2296 2295 2297 2305 2294 2296 2305 2304 2294 5738 2295 2294 2294 2304 5738 2297 2295 5722 5722 2295 5723 5738 5723 2295 5715 2297 5722 5722 5723 5724 5715 5722 5714 5714 5722 5724 5724 5723 5725 5736 5725 5723 5736 5723 5737 5737 5723 5738 5724 5725 123 5714 5724 125 125 5724 123 125 126 5714 5714 126 5712 5714 5712 5715 123 124 125 125 124 119 125 119 126 121 122 123 123 122 124 123 5725 121 5660 5652 124 124 5652 119 122 5660 124 122 121 343 122 343 340 5662 5660 122 122 340 5662 343 121 5734 5734 121 5725 340 343 344 5734 344 343 5734 5725 5735 5735 5750 5734 5734 5750 344 5735 5725 5736 5736 5750 5735 5736 5749 5750 5747 344 5750 5747 5750 5748 5748 5750 5749 340 344 338 338 344 5747 339 338 5747 339 5747 5740 5740 5747 5748 5740 5748 5741 5741 5748 2302 5748 5749 2302 5739 5740 5741 5741 2300 5742 5741 5742 5739 5741 2302 2300 2302 5749 2304 5738 2304 5749 5738 5749 5737 5737 5749 5736 5742 2300 2306 5742 2306 5743 5739 5742 5743 5739 5743 5745 5743 2306 2308 5743 2308 5744 5745 5743 5744 5745 5744 5746 348 5745 5746 5744 2308 2310 5744 2310 5726 5746 5744 5726 5746 5726 5733 348 5746 349 349 5746 5733 348 349 350 350 349 351 349 5733 351 5727 5732 5733 5727 5733 5726 5732 351 5733 5726 2310 2315 5726 2315 5727 5727 2315 2316 5727 2316 5728 5728 5732 5727 5728 5731 5732 5731 352 5732 5732 352 351 350 351 352 5731 350 352 5729 5730 5731 5729 5731 5728 5730 350 5731 5728 2316 2314 5728 2314 5729 2314 2316 2312 2312 2316 2315 2314 2318 5716 2314 5716 5717 5729 2314 5717 5729 5717 5719 5719 5730 5729 5719 353 5730 5730 353 350 5717 5718 5719 5719 5718 347 5719 347 353 5717 5716 5718 338 339 340 5662 340 5668 340 5673 5668 5673 340 342 5668 5669 5662 5668 5673 5674 5674 5669 5668 5673 342 5674 5674 342 5695 358 5695 342 5678 5670 5674 5674 5670 5669 5674 5695 5678 5662 5669 5670 5662 5670 5666 5678 5666 5670 5677 5666 5678 5678 5695 5677 5677 5695 5696 5693 5696 5695 5693 5695 358 5694 5693 358 5694 358 357 5692 5691 5693 5692 5693 5694 5691 5696 5693 2331 5691 5692 2331 2333 5691 2333 2335 5691 5691 2335 5696 2331 2330 2332 2331 2332 2333 2333 2332 2334 2333 2334 2335 2335 2334 2336 2335 2336 2337 5675 5696 2335 5675 2335 2337 3069 2336 2334 3069 2334 3074 3074 2334 2332 2337 2336 2338 3066 2338 2336 3066 2336 3069 3069 3068 3066 3053 2341 3066 3066 2341 2338 3053 3066 3047 3047 3066 3068 2337 2338 2343 2343 2338 2341 2339 2340 2341 2341 2340 2342 2341 2342 2343 3053 2339 2341 3047 3051 3053 3053 3051 2339 3047 3052 3051 3049 3050 3051 3051 3050 2339 3051 3052 3785 3049 3051 3786 3786 3051 3785 3786 5646 3049 5646 5653 3049 3049 5653 3050 5653 5654 3050 3050 5654 2339 5651 5652 5653 5653 5652 5654 5646 5651 5653 5645 5644 5646 5645 5646 3786 5644 5651 5646 3786 3785 3784 3784 5645 3786 5643 5644 5645 5638 5643 5645 5638 5645 3784 5643 117 5644 117 120 5644 5644 120 5651 116 117 5643 5636 116 5643 5636 5643 5638 5637 5636 5638 5637 5638 3782 3782 5638 3784 5635 107 5636 5635 5636 5637 107 116 5636 107 115 116 116 115 117 115 120 117 115 119 120 120 119 5651 118 119 115 126 119 118 5651 119 5652 126 118 5712 5660 5654 5652 5659 5654 5660 5662 5659 5660 5659 2339 5654 2340 2339 5659 5661 2340 5659 5661 5659 5662 5662 5666 5661 2342 2340 5661 5665 2342 5661 5661 5666 5667 5661 5667 5665 5677 5667 5666 5676 5665 5667 5676 5667 5677 2343 2342 5665 5675 2337 5665 5665 2337 2343 5675 5665 5676 5677 5696 5676 5676 5696 5675 127 107 5635 128 127 5629 5629 127 5635 5629 5635 5630 5630 5635 5637 5628 128 5629 5628 5629 5627 5627 5629 5630 134 128 5628 5621 134 5628 5621 5628 5622 5622 5628 5627 3788 3789 5627 5627 5630 3788 5622 5627 3029 3029 5627 3789 5617 5621 5622 5617 5622 5618 5618 5622 3029 3027 3028 3029 3027 3029 3787 3787 3029 3789 5618 3029 3028 3787 3789 3788 3781 3787 3788 3788 5630 3781 3781 3785 3787 3781 3782 3783 3783 3785 3781 5630 5637 3781 3781 5637 3782 3784 3785 3783 3783 3782 3784 3792 5618 3028 3792 3793 3794 3792 3809 3793 5595 3792 3794 5595 5618 3792 3794 3793 3795 3795 3793 3796 5595 3794 5597 5597 3794 3795 5596 5595 5597 5596 5617 5595 5595 5617 5618 5597 3795 5599 5596 5597 5598 5598 5597 5599 5599 3795 3796 5598 5599 5602 137 5596 5598 137 5598 153 153 5598 5602 137 136 5596 5596 136 5617 136 5621 5617 136 135 5621 135 134 5621 153 5602 154 101 100 5639 5639 100 5633 5639 5633 5640 100 99 5633 5633 99 5631 5633 5631 5634 5640 5633 5634 99 98 5631 2445 3150 3151 3155 2443 2445 3155 2445 3148 3148 2445 3151 3148 3152 3155 3155 3152 3153 3155 3153 3156 3156 2443 3155 2429 2428 2443 3156 2429 2443 3156 3153 3154 3156 3154 3157 3157 2429 3156 3152 2390 3153 3153 2390 2383 3153 2383 3154 3152 2392 2390 2389 2383 2390 2389 2390 2391 2391 2390 2392 2383 2384 2385 2384 2383 2389 2385 3137 2383 3154 2383 3137 3136 3137 2385 3136 3135 3137 3154 3137 3135 3134 3135 3136 3133 3134 3136 3134 2425 3135 3157 3154 3135 3157 3135 2425 2420 2425 3134 3132 2420 3134 3132 3134 3133 2418 2419 2420 2420 2419 2425 2418 2420 3132 2416 2418 3132 2416 2417 2418 2418 2417 2419 2425 2419 2426 2419 2417 3142 2426 2419 3138 3138 2419 3142 2416 2399 2417 2428 2426 3138 2428 3138 3139 2425 2426 2427 2427 2426 2428 2427 2428 2429 2425 2427 3157 3157 2427 2429 2430 2437 2438 2436 2437 2430 3090 2436 2430 3090 2430 3089 2412 2436 3090 3089 3088 3090 3090 3088 3065 3090 3065 2412 3089 3087 3088 3087 2362 3088 3088 2362 3064 3088 3064 3065 3064 3060 3065 3065 3060 3059 3065 3059 2412 2355 2357 3064 3064 2357 3060 2362 2355 3064 2361 2355 2362 3087 2364 2362 2355 2356 2357 2356 2355 2361 752 749 747 751 749 752 752 798 751 751 799 749 751 798 799 421 420 5337 5337 5352 421 396 5337 420 5336 5334 5337 396 5336 5337 5352 5337 5334 5334 5353 5352 5352 5353 5354 5333 1488 5334 5336 5333 5334 5334 1488 5353 395 5336 396 5353 1488 1493 5353 1493 5354 1487 1488 1489 1489 1488 1490 1488 1487 1493 5333 1490 1488 1493 1487 1494 1487 1489 3287 3287 1494 1487 1489 1490 1491 1489 1491 3285 3287 1489 3285 1491 1490 1492 1491 1492 1481 3261 3284 1491 3261 1491 1481 3285 1491 3284 3285 3284 3286 3287 3285 3288 3288 3285 3286 3262 3283 3284 3262 3284 3261 3286 3284 3283 1481 1483 3261 3261 1483 3259 3261 3259 3262 3262 3259 3260 3262 3260 1614 1614 3283 3262 1614 1616 3283 3286 3283 1618 1618 3283 1616 1612 1613 1614 1614 1613 1615 1614 1615 1616 1614 3260 1612 1616 1615 1617 1616 1617 1618 1620 3286 1618 3288 3286 1620 1620 1622 3306 1620 3306 3288 3288 3306 3307 3288 3307 3287 1622 1592 3306 3287 3307 1494 3389 3373 1617 1617 1615 3389 3389 1615 1613 3389 1613 3391 3373 3389 3390 3390 3389 3391 1612 1611 1613 3391 1613 1611 1576 1611 1612 3260 3257 1612 1612 3257 1576 3259 3258 3260 3260 3258 3257 3241 3257 3258 5288 3846 5289 3847 3846 5288 5087 4031 4035 4034 4035 4031 5366 5368 5369 5368 1374 5369 5369 1374 1376 5367 5368 5366 5367 1367 5368 5368 1367 1374 1371 1372 1373 1373 1378 1371 1379 1371 1378 1372 1371 1379 3858 3402 3857 3402 3401 3857 3405 3857 3401 1550 1549 3358 1550 3358 3872 3358 1549 3359 3359 3364 3358 3872 3358 3873 3873 3358 3364 3362 3363 3359 3359 3363 3364 3873 3364 3363 3873 3363 3361 3362 3361 3363 3360 3361 3362 3360 3362 3365 3365 3362 1415 3365 1415 3366 3869 3365 3366 1415 1414 1416 1415 1416 1417 3366 1415 1417 3366 1417 1419 3869 3366 1419 1419 1418 3869 3869 1418 3871 3869 3871 3870 1417 1418 1419 1417 1416 1418 1418 5255 3871 3870 3871 5255 5379 5378 5380 3812 3814 5379 5379 3814 5378 3814 3816 5378 5378 3816 3817 3812 3813 3814 3816 3814 3817 3817 3814 3813 9889 9890 9891 9889 9891 9892 9890 9889 9900 9900 9889 9901 10352 9901 9889 10352 9889 10353 10353 9889 9892 9900 9901 9902 9890 9900 10316 10316 9900 9902 9902 9901 9903 10316 9902 10315 10315 9902 9903 10315 10294 10316 10317 9890 10316 10317 10316 10318 10318 10316 10294 10314 10293 10315 10315 10293 10294 10315 9903 10314 10293 10053 10294 10318 10294 10052 10052 10294 10053 10318 10337 10317 10334 10337 10318 10334 10318 10052 10052 10053 10002 10052 10002 10334 10002 10053 10054 10293 10054 10053 10292 10054 10293 10314 10292 10293 10002 10054 10055 10292 10055 10054 10291 10055 10292 10313 10291 10292 10313 10292 10314 10055 10056 10002 10291 10056 10055 10290 10056 10291 10312 10290 10291 10312 10291 10313 10314 9905 10313 10313 9905 9906 10313 9906 10312 10311 10290 10312 10312 9906 9908 10312 9908 10311 9905 9904 9906 9906 9904 9907 9906 9907 9908 9903 9904 9905 10314 9903 9905 9903 9901 9904 10350 9907 9904 10350 9904 10351 10351 9904 9901 10351 9901 10352 10352 10380 10351 10351 10380 10379 10351 10379 10350 10349 9907 10350 10350 10379 10378 10350 10378 10349 10370 10378 10379 10370 10379 10380 10377 10378 10370 10349 10378 10377 10348 9910 10349 10349 9910 9907 10349 10377 10348 10370 10376 10377 10348 10377 10376 10347 9913 10348 10348 9913 9910 10348 10376 10347 10370 10375 10376 10347 10376 10375 10346 9916 10347 10347 9916 9913 10347 10375 10346 9912 9910 9913 9912 9913 9914 9914 9913 9915 9915 9913 9916 9915 9916 9917 9917 9916 9918 9918 9916 9919 10346 9919 9916 10307 9914 9915 10307 9915 10306 10306 9915 9917 10308 9912 9914 10308 9914 10307 10306 10285 10307 10307 10285 10286 10307 10286 10308 10305 10284 10306 10306 10284 10285 10306 9917 10305 10305 9917 9918 10304 10283 10305 10305 10283 10284 10305 9918 10304 10283 10063 10284 10284 10063 10062 10284 10062 10285 10285 10062 10061 10285 10061 10286 10061 10062 10002 10002 10062 10063 10002 10063 10011 10011 10063 10064 10283 10064 10063 10282 10064 10283 10304 10282 10283 10064 10065 10011 10282 10065 10064 10281 10065 10282 10303 10281 10282 10303 10282 10304 10011 10065 10066 10281 10066 10065 10280 10066 10281 10302 10280 10281 10302 10281 10303 10304 9920 10303 10303 9920 9921 10303 9921 10302 10301 10280 10302 10302 9921 9923 10302 9923 10301 9920 9919 9921 9921 9919 9922 9921 9922 9923 9918 9919 9920 10304 9918 9920 10345 9922 9919 10345 9919 10346 9923 9922 9924 9924 9922 9925 10344 9925 9922 10344 9922 10345 10301 9923 9924 9924 9925 9926 10301 9924 10300 10300 9924 9926 9926 9925 9927 9927 9925 9928 10343 9928 9925 10343 9925 10344 10345 10386 10344 10344 10386 10385 10344 10385 10343 10342 9928 10343 10343 10385 10384 10343 10384 10342 10384 10385 10386 10369 10394 10386 10386 10394 10395 10386 10395 10384 10345 10369 10386 10342 10384 10395 10341 9931 10342 10342 9931 9928 10342 10395 10341 10341 10395 10394 10369 10393 10394 10341 10394 10340 10340 10394 10393 10340 9934 10341 10341 9934 9931 9930 9928 9931 9930 9931 9932 9932 9931 9933 9933 9931 9934 9929 9928 9930 10297 9929 9930 10297 9930 10296 10296 9930 9932 9927 9928 9929 10298 9927 9929 10298 9929 10297 10296 10275 10297 10297 10275 10276 10297 10276 10298 10295 10274 10296 10296 10274 10275 10296 9932 10295 10274 10072 10275 10275 10072 10071 10275 10071 10276 10276 10071 10070 10276 10070 10277 10298 10276 10277 10070 10071 10011 10011 10071 10072 10011 10072 10051 10274 10051 10072 10273 10051 10274 10295 10273 10274 10049 10011 10051 10273 10049 10051 10271 10272 10273 10272 10049 10273 10271 10273 10295 10049 10050 10011 10272 10050 10049 10271 10270 10272 10272 10270 10259 10272 10259 10050 9933 9935 10271 10271 9935 10270 10295 9933 10271 9935 9940 10270 10270 9940 10269 10270 10269 10259 9933 9934 9935 9934 9940 9935 10295 9932 9933 9934 9939 9940 9940 9939 10269 10268 10266 10269 10269 9939 9937 10269 9937 10268 10259 10269 10266 9938 9937 9939 9938 9939 9934 10340 9938 9934 10339 9938 10340 10340 10393 10339 10368 9949 10339 10339 9949 9943 10339 9943 9938 10339 10393 10389 10339 10389 10368 10389 10393 10369 10369 10388 10389 10368 10389 10388 10367 9952 10368 10368 9952 9949 10368 10388 10367 10369 10387 10388 10367 10388 10387 10366 9955 10367 10367 9955 9952 10367 10387 10366 9951 9949 9952 9951 9952 9953 9953 9952 9954 9954 9952 9955 9954 9955 9956 9956 9955 9957 9957 9955 9958 10366 9958 9955 9956 10180 9954 9954 10180 10181 9954 10181 9953 9953 10181 10182 9953 10182 9951 10180 10090 10181 10090 10088 10181 10181 10088 10086 10181 10086 10182 10179 10091 10180 10180 10091 10090 9956 10179 10180 10088 10090 10089 10089 10090 10091 10087 10086 10088 10087 10088 10089 10084 10085 10086 10084 10086 10087 10182 10086 10085 10193 10084 10087 10193 10087 10194 10194 10087 10089 10089 10091 10092 10194 10089 10195 10195 10089 10092 10223 10193 10194 10223 10194 10224 10224 10194 10195 10192 10084 10193 10222 10192 10193 10222 10193 10223 10024 10222 10223 10024 10223 10025 10025 10223 10224 10224 10195 10225 10025 10224 10026 10026 10224 10225 10016 10024 10025 10016 10025 10026 10023 10024 10016 10023 10222 10024 10221 10192 10222 10023 10221 10222 10016 10022 10023 10022 10221 10023 10190 10191 10221 10221 10191 10192 10022 10190 10221 10016 10021 10022 10021 10190 10022 10021 10188 10190 10188 10189 10190 10190 10189 10191 10189 10079 10191 10191 10079 10082 10191 10082 10192 10188 10187 10189 10187 10077 10189 10189 10077 10079 10187 10075 10077 10188 10015 10187 10187 10015 10005 10187 10005 10075 10075 10076 10077 10077 10076 10078 10077 10078 10079 10005 10004 10075 10075 10004 10076 9994 10004 10005 10013 9994 10005 10013 10005 10014 10014 10005 10015 10188 10014 10015 10021 10013 10014 10021 10014 10188 10006 9994 10013 10016 10006 10013 10013 10021 10016 10006 10007 10008 10008 10012 10006 10006 10012 9994 10006 10016 10185 10006 10185 10007 10007 10185 10186 10007 10186 10008 10008 10186 10073 10008 10073 10012 10073 10074 10012 10012 10074 9994 10151 10152 10073 10073 10152 10074 10220 10151 10073 10220 10073 10186 10250 10220 10186 10250 10186 10185 10219 10151 10220 10249 10219 10220 10249 10220 10250 10149 10150 10151 10151 10150 10152 10219 10149 10151 10218 10149 10219 10248 10218 10219 10248 10219 10249 10037 10248 10249 10037 10249 10038 10038 10249 10250 10247 10218 10248 10036 10247 10248 10036 10248 10037 10217 10141 10218 10218 10141 10149 10247 10217 10218 10246 10217 10247 10035 10246 10247 10035 10247 10036 10035 10036 10019 10019 10036 10037 10019 10037 10038 10038 10047 10019 10038 10250 10047 10019 10047 10016 10047 10250 10185 10047 10185 10016 10017 10018 10019 10019 10018 10020 10020 10033 10019 10019 10033 10034 10019 10034 10035 10042 10019 10043 10043 10019 10044 10042 10045 10019 10019 10045 10046 10019 10046 10017 10019 10016 10048 10048 10235 10019 10019 10235 10236 10019 10236 10044 10044 10236 10237 10044 10237 10043 10235 10206 10236 10236 10206 10207 10236 10207 10237 10234 10205 10235 10235 10205 10206 10048 10234 10235 10048 10016 10041 10041 10234 10048 10233 10204 10234 10234 10204 10205 10041 10233 10234 10204 10114 10205 10205 10114 10116 10205 10116 10206 10203 10112 10204 10204 10112 10114 10233 10203 10204 10232 10203 10233 10040 10232 10233 10040 10233 10041 10016 10040 10041 10016 10039 10040 10039 10232 10040 10231 10202 10232 10232 10202 10203 10039 10231 10232 10202 10109 10203 10203 10109 10112 10201 10107 10202 10202 10107 10109 10231 10201 10202 10230 10201 10231 10032 10230 10231 10032 10231 10039 10032 10039 10016 10016 10031 10032 10031 10230 10032 10229 10200 10230 10230 10200 10201 10031 10229 10230 10200 10104 10201 10201 10104 10107 10199 10102 10200 10200 10102 10104 10229 10199 10200 10228 10199 10229 10030 10228 10229 10030 10229 10031 10016 10030 10031 10029 10030 10016 10029 10228 10030 10227 10198 10228 10228 10198 10199 10029 10227 10228 10198 10099 10199 10199 10099 10102 10197 10097 10198 10198 10097 10099 10227 10197 10198 10226 10197 10227 10028 10226 10227 10028 10227 10029 10016 10028 10029 10016 10027 10028 10027 10226 10028 10026 10027 10016 10026 10225 10027 10027 10225 10226 10225 10196 10226 10226 10196 10197 10196 10094 10197 10197 10094 10097 10195 10092 10196 10196 10092 10094 10225 10195 10196 10092 10093 10094 10093 10095 10094 10094 10095 10096 10094 10096 10097 10092 10091 10093 10095 10093 10179 10179 10093 10091 10178 10096 10095 10178 10095 10179 10097 10096 10098 10177 10098 10096 10177 10096 10178 10097 10098 10099 10098 10100 10099 10100 10098 10177 10176 10100 10177 9960 10176 10177 9960 10177 9959 9959 10177 10178 9959 10178 9957 9957 10178 10179 9957 10179 9956 9957 9958 9959 9959 9958 9960 9960 9958 9961 9960 9961 9962 9962 10176 9960 10365 9961 9958 10365 9958 10366 9962 9961 9963 9963 9961 9964 10364 9964 9961 10364 9961 10365 9963 10175 9962 9962 10175 10176 9963 9964 9965 9965 10174 9963 9963 10174 10175 10174 10105 10175 10105 10103 10175 10175 10103 10101 10175 10101 10176 10176 10101 10100 10099 10100 10101 10099 10101 10102 10102 10101 10103 10102 10103 10104 10103 10105 10104 10104 10105 10106 10174 10106 10105 10104 10106 10107 10107 10106 10108 10173 10108 10106 10173 10106 10174 10107 10108 10109 10108 10110 10109 10110 10108 10173 10172 10110 10173 9966 10172 10173 9966 10173 9965 9965 10173 10174 10109 10110 10111 10172 10111 10110 10109 10111 10112 10112 10111 10113 10170 10113 10111 10170 10111 10172 9968 10170 10172 9968 10172 9966 10115 10170 10122 10122 10170 10171 10115 10113 10170 9969 10171 10170 9969 10170 9968 10112 10113 10114 10114 10113 10115 10114 10115 10116 10115 10122 10116 10116 10122 10123 10169 10123 10122 10122 10171 10169 9971 10169 10171 9971 10171 9969 9968 9967 9969 9969 9967 9970 9969 9970 9971 9971 9970 9972 9972 10169 9971 10168 10125 10169 10169 10125 10123 9972 10168 10169 10116 10123 10124 10124 10123 10125 10206 10116 10124 10124 10125 10117 10206 10124 10207 10207 10124 10117 10117 10125 10126 10168 10126 10125 10117 10118 10119 10117 10126 10118 10207 10117 10208 10208 10117 10119 10237 10207 10208 10208 10119 10209 10237 10208 10238 10238 10208 10209 10119 10118 10120 10119 10120 10121 10209 10119 10121 10120 10118 10167 10167 10118 10126 10167 10126 10168 10166 10120 10167 9975 10166 10167 9975 10167 9974 9974 10167 10168 10120 10132 10121 10166 10132 10120 10165 10132 10166 9977 10165 10166 9977 10166 9975 9974 9973 9975 9975 9973 9976 9975 9976 9977 9972 9973 9974 9974 10168 9972 9972 9970 9973 10360 9976 9973 10360 9973 10361 10361 9973 9970 10361 9970 10362 10362 9970 9967 10362 10373 10361 10361 10373 10372 10361 10372 10360 10359 9976 10360 10360 10372 10371 10360 10371 10359 10371 10372 10369 10369 10372 10373 10369 10373 10374 10362 10374 10373 10362 9967 10363 10363 10374 10362 10374 10381 10369 10363 10381 10374 10363 9967 9964 10363 9964 10364 10364 10381 10363 10369 10381 10382 10364 10382 10381 10365 10382 10364 10369 10382 10383 10365 10383 10382 10366 10383 10365 10383 10387 10369 10366 10387 10383 10369 10370 10371 10369 10375 10370 10346 10375 10369 10346 10369 10345 10359 10371 10370 10358 9979 10359 10359 9979 9976 10359 10370 10358 10357 9982 10358 10358 9982 9979 10358 10370 10398 10358 10398 10357 10356 9985 10357 10357 9985 9982 10357 10398 10397 10357 10397 10356 10380 10397 10398 10380 10398 10370 10390 10396 10397 10390 10397 10380 10356 10397 10396 10352 10390 10380 10390 10391 10392 10392 10396 10390 10353 10391 10390 10353 10390 10352 10356 10396 10355 10355 10396 10392 10355 10392 10354 10354 10392 10391 10354 10391 10353 10353 9892 10354 10354 9892 9897 10354 9897 10355 10355 9897 9988 10355 9988 10356 10356 9988 9985 9984 9982 9985 9984 9985 9986 9986 9985 9987 9987 9985 9988 9983 9982 9984 9986 10160 9984 9984 10160 10161 9984 10161 9983 9981 9979 9982 9981 9982 9983 9983 10161 10162 9983 10162 9981 10160 10145 10161 10145 10143 10161 10161 10143 10142 10161 10142 10162 10162 10142 10130 10162 10130 10163 9981 10162 10163 9980 9979 9981 9981 10163 9980 9978 9976 9979 9978 9979 9980 9980 10163 10164 9980 10164 9978 10130 10128 10163 10163 10128 10136 10163 10136 10164 10164 10136 10135 10164 10135 10165 9978 10164 10165 9977 9976 9978 9978 10165 9977 10135 10133 10165 10165 10133 10132 10134 10133 10135 10134 10135 10127 10127 10135 10136 10127 10136 10128 10127 10128 10129 10211 10134 10127 10211 10127 10212 10212 10127 10129 10121 10133 10134 10210 10121 10134 10210 10134 10211 10121 10132 10133 10209 10121 10210 10239 10209 10210 10239 10210 10240 10240 10210 10211 10240 10211 10241 10241 10211 10212 10045 10239 10240 10045 10240 10046 10046 10240 10241 10238 10209 10239 10042 10238 10239 10042 10239 10045 10043 10237 10238 10043 10238 10042 10241 10212 10242 10046 10241 10017 10017 10241 10242 10212 10129 10213 10242 10212 10213 10242 10213 10243 10017 10242 10018 10018 10242 10243 10213 10129 10131 10213 10131 10214 10243 10213 10214 10129 10128 10130 10129 10130 10131 10130 10142 10131 10131 10142 10143 10131 10143 10144 10214 10131 10144 10214 10144 10215 10243 10214 10244 10244 10214 10215 10144 10143 10145 10144 10145 10137 10215 10144 10137 10215 10137 10216 10244 10215 10245 10245 10215 10216 10020 10243 10244 10020 10244 10033 10033 10244 10245 10245 10216 10246 10033 10245 10034 10034 10245 10246 10246 10216 10217 10034 10246 10035 10216 10139 10217 10217 10139 10141 10137 10138 10139 10139 10138 10140 10139 10140 10141 10216 10137 10139 10140 10147 10141 10141 10147 10148 10141 10148 10149 10158 10147 10140 10158 10140 10159 10140 10138 10159 10157 10148 10147 10157 10147 10158 10149 10148 10150 10150 10148 10157 10156 10150 10157 9992 10156 10157 9992 10157 9989 9989 10157 10158 9989 10158 9987 9987 10158 10159 9987 9988 9989 9988 9992 9989 9990 9991 9992 9988 9990 9992 9991 10156 9992 9897 9990 9988 9892 9896 9897 9897 9896 9898 9897 9898 9899 9899 9993 9897 9897 9993 9990 9892 9895 9896 10326 9898 9896 10326 9896 10320 10320 9896 9895 10325 9899 9898 10325 9898 10326 10324 9993 9899 10324 9899 10325 9990 9993 10324 9990 10324 10321 10321 10324 10325 10321 10325 10323 10323 10325 10326 10323 10326 10327 10327 10326 10320 10322 10321 10323 10327 10332 10323 10323 10332 10333 10323 10333 10322 9990 10321 10322 10001 9990 10322 10001 10322 9999 9999 10322 10333 9999 10333 10332 10327 10331 10332 9999 10332 10331 10327 10320 10328 10328 10331 10327 10328 10330 10331 9999 10331 10000 10000 10331 10330 9999 10000 10001 10001 10000 10002 10334 10002 10000 10334 10000 10335 10335 10000 10336 10000 10330 10336 10329 10330 10328 10329 10336 10330 10328 10320 10319 10328 10319 10329 10334 10335 10329 10329 10335 10336 10319 10338 10329 10329 10338 10337 10329 10337 10334 9894 10319 10320 9894 9893 10319 10319 9893 10338 10317 10337 10338 10317 10338 9891 9891 10338 9893 9892 9891 9893 9892 9893 9894 9894 9895 9892 10320 9895 9894 9891 9890 10317 10011 9998 10002 10002 9998 9997 10002 9997 10001 10002 10056 10057 10002 10057 10058 10058 10059 10002 10002 10059 10060 10002 10060 10061 9997 9990 10001 9991 9990 9997 9995 10153 9991 9995 9991 9997 9991 10153 10156 9994 9995 9996 9996 9995 9997 9994 10153 9995 9994 10074 10153 10153 10074 10152 10153 10152 10156 10156 10152 10150 9996 10003 9994 9994 10003 10004 10076 10004 10003 10076 10003 10154 10154 10003 9996 10076 10154 10155 10155 10078 10076 9941 10155 10154 9941 10154 9942 10154 9996 9942 9941 9942 9943 9941 9943 9948 9948 10155 9941 9943 9942 9944 9944 9942 9998 9998 9942 9996 9996 9997 9998 10011 10010 9998 10251 9944 9998 10010 10254 9998 9998 10254 10255 9998 10255 10251 9944 10251 10260 10260 10251 10255 10254 10263 10255 10255 10263 10264 10255 10264 10260 10010 10253 10254 10254 10253 10263 10252 10253 10010 10263 10253 10252 10263 10252 10265 10262 10264 10263 10262 10263 10267 10267 10263 10265 10261 10260 10264 10261 10264 10262 9944 10260 10261 9944 10261 9945 9945 10261 10262 10267 9947 10262 10262 9947 9946 10262 9946 9945 10267 10265 10268 10268 9936 10267 10267 9936 9947 9938 9946 9947 9938 9947 9936 9943 9945 9946 9943 9946 9938 9944 9945 9943 9948 9943 9949 9948 9949 9950 9950 10184 9948 9948 10184 10155 9950 9949 9951 9951 10183 9950 9950 10183 10184 10183 10081 10184 10184 10081 10080 10184 10080 10155 10155 10080 10078 10078 10080 10079 10079 10080 10081 10079 10081 10082 10082 10081 10083 10183 10083 10081 10082 10083 10084 10192 10082 10084 10083 10085 10084 10085 10083 10183 10182 10085 10183 9951 10182 10183 9936 9937 9938 10268 9937 9936 10268 10265 10266 10265 10252 10257 10265 10257 10266 10259 10266 10256 10256 10266 10257 10010 10256 10257 10010 10257 10252 10009 10256 10010 10009 10258 10256 10256 10258 10259 10050 10259 10258 10009 10050 10258 10009 10010 10011 10011 10050 10009 10011 10066 10067 10067 10068 10011 10011 10068 10069 10011 10069 10070 10280 10067 10066 10279 10068 10067 10279 10067 10280 10278 10069 10068 10278 10068 10279 10277 10070 10069 10277 10069 10278 10299 10277 10278 10299 10278 10300 10300 10278 10279 10300 10279 10301 10301 10279 10280 10300 9926 10299 10298 10277 10299 10299 9926 9927 10299 9927 10298 10286 10061 10060 10286 10060 10287 10308 10286 10287 10287 10060 10059 10287 10059 10288 10308 10287 10309 10309 10287 10288 10309 9912 10308 10309 10288 10310 10310 9911 10309 10309 9911 9912 10288 10059 10058 10288 10058 10289 10310 10288 10289 10310 10289 10311 10311 9909 10310 10310 9909 9911 9909 9910 9911 9911 9910 9912 9908 9907 9909 9909 9907 9910 10311 9908 9909 10311 10289 10290 10289 10058 10057 10289 10057 10290 10290 10057 10056 9987 10159 9986 10159 10138 10146 10159 10146 10160 9986 10159 10160 10137 10146 10138 10137 10145 10146 10160 10146 10145 10018 10243 10020 9965 9964 9966 9966 9964 9967 9966 9967 9968 10399 10400 10401 10421 10422 10399 10399 10422 10400 10423 10421 10399 10399 10401 10423 10401 10400 10402 10422 10416 10400 10416 10402 10400 10401 10402 10403 10401 10403 10423 10403 10402 10404 10416 10404 10402 10403 10404 10405 10423 10403 10405 10405 10404 10406 10410 10406 10404 10410 10404 10412 10412 10404 10414 10414 10404 10416 10405 10406 10407 10405 10407 10423 10407 10406 10408 10408 10406 10410 10409 10408 10410 10409 10410 10411 10411 10410 10412 10411 10412 10413 10413 10412 10414 10413 10414 10415 10415 10414 10416 10413 10415 10423 10411 10413 10423 10423 10409 10411 10407 10408 10409 10407 10409 10423 10423 10415 10417 10419 10421 10423 10417 10419 10423 10415 10416 10417 10417 10416 10418 10422 10418 10416 10417 10418 10419 10419 10418 10420 10419 10420 10421 10421 10420 10422 10420 10418 10422 10424 10425 10426 10446 10447 10424 10424 10447 10425 10448 10446 10424 10424 10426 10448 10426 10425 10427 10447 10439 10425 10425 10439 10427 10426 10427 10428 10426 10428 10448 10428 10427 10429 10428 10429 10430 10448 10428 10430 10430 10429 10431 10431 10429 10433 10433 10429 10427 10430 10431 10432 10430 10432 10448 10432 10431 10433 10432 10433 10434 10434 10433 10435 10433 10427 10435 10432 10434 10448 10434 10435 10436 10448 10434 10436 10436 10435 10437 10427 10437 10435 10436 10437 10438 10436 10438 10448 10438 10437 10439 10427 10439 10437 10438 10439 10440 10438 10440 10448 10448 10440 10442 10444 10446 10448 10442 10444 10448 10440 10439 10441 10440 10441 10442 10445 10441 10439 10445 10439 10447 10442 10441 10443 10443 10441 10445 10442 10443 10444 10444 10443 10445 10444 10445 10446 10446 10445 10447 10449 10450 10451 10471 10472 10449 10449 10472 10450 10473 10471 10449 10449 10451 10473 10451 10450 10452 10454 10452 10450 10472 10454 10450 10451 10452 10453 10451 10453 10473 10453 10452 10454 10453 10454 10455 10473 10453 10455 10455 10454 10456 10455 10456 10457 10455 10457 10473 10457 10456 10458 10456 10454 10458 10458 10454 10466 10470 10466 10454 10470 10454 10472 10457 10458 10459 10459 10458 10460 10458 10466 10460 10457 10459 10473 10459 10460 10461 10473 10459 10461 10461 10460 10462 10460 10466 10462 10461 10462 10463 10461 10463 10473 10473 10465 10467 10463 10465 10473 10469 10471 10473 10467 10469 10473 10463 10462 10464 10463 10464 10465 10466 10464 10462 10465 10464 10466 10465 10466 10467 10467 10466 10468 10467 10468 10469 10469 10468 10470 10469 10470 10471 10471 10470 10472 10468 10466 10470 10474 10475 10476 10496 10497 10474 10474 10497 10475 10498 10496 10474 10474 10476 10498 10476 10475 10477 10477 10475 10497 10476 10477 10478 10476 10478 10498 10478 10477 10479 10497 10485 10477 10477 10485 10481 10477 10481 10479 10496 10495 10497 10497 10495 10485 10494 10493 10495 10494 10495 10496 10485 10495 10493 10492 10493 10494 10494 10496 10498 10492 10494 10498 10492 10491 10493 10493 10491 10485 10490 10491 10492 10498 10490 10492 10490 10489 10491 10485 10491 10489 10488 10489 10490 10488 10490 10498 10488 10487 10489 10485 10489 10487 10486 10487 10488 10486 10488 10498 10498 10478 10480 10498 10484 10486 10482 10484 10498 10480 10482 10498 10484 10485 10486 10486 10485 10487 10482 10483 10484 10484 10483 10485 10480 10481 10482 10482 10481 10483 10478 10479 10480 10480 10479 10481 10485 10483 10481 10499 10500 10501 10521 10522 10499 10499 10522 10500 10523 10521 10499 10499 10501 10523 10501 10500 10502 10500 10522 10502 10501 10502 10503 10501 10503 10523 10503 10502 10504 10502 10522 10520 10502 10520 10504 10521 10520 10522 10519 10520 10521 10519 10521 10523 10519 10518 10520 10518 10508 10520 10520 10508 10506 10520 10506 10504 10503 10504 10505 10505 10504 10506 10523 10503 10505 10505 10506 10507 10505 10507 10523 10507 10506 10508 10507 10508 10509 10507 10509 10523 10509 10508 10510 10509 10510 10511 10523 10509 10511 10511 10510 10512 10508 10512 10510 10511 10512 10513 10511 10513 10523 10523 10515 10517 10513 10515 10523 10517 10519 10523 10513 10512 10514 10513 10514 10515 10508 10514 10512 10515 10514 10516 10516 10514 10508 10515 10516 10517 10517 10516 10518 10517 10518 10519 10518 10516 10508 10524 10525 10526 10546 10547 10524 10524 10547 10525 10548 10546 10524 10524 10526 10548 10526 10525 10527 10527 10525 10543 10543 10525 10547 10526 10527 10528 10526 10528 10548 10528 10527 10529 10543 10529 10527 10528 10529 10530 10548 10528 10530 10530 10529 10531 10543 10531 10529 10530 10531 10532 10530 10532 10548 10532 10531 10533 10532 10533 10534 10532 10534 10548 10534 10533 10535 10531 10535 10533 10534 10535 10536 10548 10534 10536 10536 10535 10537 10531 10537 10535 10536 10537 10538 10536 10538 10548 10538 10537 10539 10539 10537 10531 10538 10539 10540 10538 10540 10548 10548 10540 10542 10544 10546 10548 10542 10544 10548 10540 10539 10541 10540 10541 10542 10541 10539 10531 10542 10541 10543 10541 10531 10543 10542 10543 10544 10544 10543 10545 10544 10545 10546 10546 10545 10547 10543 10547 10545 10549 10550 10551 10571 10572 10549 10549 10572 10550 10573 10571 10549 10549 10551 10573 10551 10550 10552 10551 10552 10553 10551 10553 10573 10553 10552 10554 10550 10566 10552 10552 10566 10554 10553 10554 10555 10573 10553 10555 10555 10554 10556 10566 10558 10554 10554 10558 10556 10555 10556 10557 10555 10557 10573 10557 10556 10558 10557 10558 10559 10559 10558 10560 10562 10560 10558 10566 10562 10558 10557 10559 10573 10559 10560 10561 10573 10559 10561 10561 10560 10562 10561 10562 10563 10563 10562 10564 10564 10562 10566 10561 10563 10573 10573 10565 10567 10563 10565 10573 10569 10571 10573 10567 10569 10573 10563 10564 10565 10565 10564 10566 10565 10566 10567 10567 10566 10568 10567 10568 10569 10569 10568 10570 10569 10570 10571 10571 10570 10572 10570 10568 10566 10572 10570 10550 10550 10570 10566 10574 10575 10576 10596 10597 10574 10574 10597 10575 10598 10596 10574 10574 10576 10598 10576 10575 10577 10576 10577 10578 10576 10578 10598 10578 10577 10579 10579 10577 10575 10595 10579 10575 10595 10575 10597 10596 10595 10597 10594 10595 10596 10594 10596 10598 10594 10593 10595 10593 10579 10595 10592 10593 10594 10592 10594 10598 10592 10591 10593 10593 10591 10579 10590 10591 10592 10598 10590 10592 10590 10589 10591 10579 10591 10589 10588 10589 10590 10588 10590 10598 10588 10587 10589 10583 10579 10589 10583 10589 10585 10585 10589 10587 10586 10587 10588 10586 10588 10598 10586 10585 10587 10584 10583 10585 10584 10585 10586 10582 10581 10583 10582 10583 10584 10581 10579 10583 10598 10584 10586 10582 10584 10598 10598 10578 10580 10580 10582 10598 10580 10581 10582 10580 10579 10581 10578 10579 10580 10599 10600 10601 10621 10622 10599 10599 10622 10600 10623 10621 10599 10599 10601 10623 10601 10600 10602 10614 10602 10600 10614 10600 10622 10601 10602 10603 10601 10603 10623 10603 10602 10604 10603 10604 10605 10623 10603 10605 10605 10604 10606 10606 10604 10608 10608 10604 10602 10605 10606 10607 10605 10607 10623 10607 10606 10608 10607 10608 10609 10609 10608 10610 10608 10602 10610 10607 10609 10623 10609 10610 10611 10623 10609 10611 10611 10610 10612 10610 10602 10612 10611 10612 10613 10611 10613 10623 10613 10612 10614 10612 10602 10614 10613 10614 10615 10613 10615 10623 10623 10615 10617 10619 10621 10623 10617 10619 10623 10615 10614 10616 10615 10616 10617 10620 10616 10614 10620 10614 10622 10617 10616 10618 10618 10616 10620 10617 10618 10619 10619 10618 10620 10619 10620 10621 10621 10620 10622 10624 10625 10626 10646 10647 10624 10624 10647 10625 10648 10646 10624 10624 10626 10648 10626 10625 10627 10626 10627 10628 10626 10628 10648 10628 10627 10629 10628 10629 10630 10648 10628 10630 10630 10629 10631 10629 10627 10631 10630 10631 10632 10630 10632 10648 10632 10631 10633 10631 10627 10637 10631 10637 10633 10632 10633 10634 10632 10634 10648 10634 10633 10635 10633 10637 10635 10636 10635 10637 10636 10637 10638 10638 10637 10639 10627 10639 10637 10634 10635 10636 10648 10634 10636 10636 10638 10648 10638 10639 10640 10638 10640 10648 10640 10639 10641 10643 10641 10639 10627 10643 10639 10625 10643 10627 10642 10641 10643 10642 10643 10644 10644 10643 10645 10625 10645 10643 10640 10641 10642 10648 10640 10642 10644 10646 10648 10642 10644 10648 10644 10645 10646 10646 10645 10647 10647 10645 10625 10649 10650 10651 10653 10654 10649 10677 10653 10649 10677 10649 10678 10678 10649 10651 10764 10650 10649 10764 10649 10722 10722 10649 10654 10722 10654 10721 10721 10654 10653 10721 10709 10722 10722 10709 10706 10706 10705 10722 10722 10705 10764 10705 10763 10764 10763 10650 10764 10704 10703 10705 10704 10705 10706 10703 10763 10705 10704 10706 10707 10707 10706 10708 10708 10706 10709 10702 10703 10704 10707 10702 10704 10702 10701 10703 10701 10762 10703 10703 10762 10763 10700 10701 10702 10707 10700 10702 10700 10699 10701 10699 10761 10701 10701 10761 10762 10761 10666 10762 10762 10666 10665 10762 10665 10763 10699 10760 10761 10760 10667 10761 10761 10667 10666 10655 10665 10666 10655 10666 10667 10650 10665 10655 10763 10665 10650 10651 10650 10652 10655 10656 10650 10650 10656 10657 10650 10657 10658 10658 10663 10650 10650 10663 10664 10650 10664 10652 10743 10652 10664 10708 10651 10652 10708 10652 10743 10743 10664 10744 10744 10664 10663 10744 10663 10745 10745 10663 10658 10745 10658 10746 10746 10658 10657 10734 10744 10745 10734 10745 10735 10735 10745 10746 10733 10743 10744 10733 10744 10734 10723 10733 10734 10723 10734 10711 10711 10734 10735 10711 10735 10712 10712 10735 10736 10735 10746 10736 10736 10746 10747 10746 10657 10747 10712 10736 10713 10713 10736 10737 10736 10747 10737 10711 10712 10694 10694 10712 10713 10694 10723 10711 10692 10693 10694 10694 10693 10695 10694 10695 10696 10694 10713 10714 10714 10715 10694 10694 10715 10716 10694 10716 10717 10696 10707 10694 10694 10707 10723 10717 10727 10694 10694 10727 10718 10694 10718 10692 10707 10733 10723 10707 10732 10733 10732 10743 10733 10732 10707 10743 10743 10707 10708 10708 10709 10710 10710 10651 10708 10721 10720 10709 10720 10677 10709 10709 10677 10678 10709 10678 10710 10710 10678 10651 10676 10653 10677 10720 10676 10677 10719 10720 10721 10719 10676 10720 10721 10653 10719 10719 10653 10676 10696 10698 10707 10698 10700 10707 10696 10695 10697 10696 10697 10698 10698 10697 10699 10698 10699 10700 10695 10759 10697 10697 10759 10760 10697 10760 10699 10693 10758 10695 10695 10758 10759 10758 10674 10759 10759 10674 10673 10759 10673 10760 10760 10673 10667 10667 10673 10655 10655 10673 10674 10655 10674 10675 10758 10675 10674 10693 10757 10758 10757 10675 10758 10692 10691 10693 10691 10757 10693 10691 10756 10757 10756 10679 10757 10757 10679 10675 10675 10679 10655 10655 10679 10680 10756 10680 10679 10689 10755 10756 10689 10756 10691 10755 10680 10756 10690 10689 10691 10690 10691 10692 10692 10718 10690 10688 10689 10690 10718 10688 10690 10688 10687 10689 10687 10755 10689 10687 10754 10755 10754 10672 10755 10755 10672 10680 10655 10680 10672 10661 10655 10672 10754 10661 10672 10686 10754 10687 10686 10685 10754 10754 10685 10728 10728 10661 10754 10685 10686 10687 10685 10687 10688 10685 10688 10718 10718 10724 10685 10685 10724 10725 10685 10725 10726 10728 10685 10729 10729 10685 10726 10729 10669 10728 10728 10669 10661 10729 10726 10730 10730 10670 10729 10729 10670 10669 10668 10661 10669 10668 10669 10670 10682 10668 10670 10682 10670 10683 10683 10670 10684 10730 10684 10670 10730 10726 10731 10731 10684 10730 10731 10683 10684 10726 10682 10683 10726 10683 10731 10725 10682 10726 10681 10668 10682 10725 10681 10682 10724 10668 10681 10724 10681 10725 10718 10742 10724 10724 10742 10753 10753 10668 10724 10727 10742 10718 10727 10741 10742 10741 10752 10742 10742 10752 10753 10752 10659 10753 10753 10659 10668 10741 10751 10752 10751 10660 10752 10752 10660 10659 10717 10740 10741 10717 10741 10727 10740 10751 10741 10740 10750 10751 10750 10662 10751 10751 10662 10660 10659 10660 10661 10661 10660 10662 10659 10661 10668 10662 10671 10661 10661 10671 10655 10750 10671 10662 10739 10749 10750 10739 10750 10740 10749 10671 10750 10716 10739 10740 10716 10740 10717 10715 10738 10739 10715 10739 10716 10738 10749 10739 10738 10748 10749 10748 10655 10749 10749 10655 10671 10748 10656 10655 10737 10747 10748 10737 10748 10738 10747 10656 10748 10714 10737 10738 10714 10738 10715 10713 10737 10714 10747 10657 10656))
                   (list :vertices (let ((mat (make-matrix 10765 3))) (fvector-replace (array-entity mat) #f(-9.8338600158691406e+01 -2.2526700973510742e+01 -5.8502902984619141e+01 -9.8338699340820312e+01 -2.2243301391601562e+01 -5.8275699615478516e+01 -9.8338699340820312e+01 -2.2243301391601562e+01 -7.6879997253417969e+01 -9.8338294982910156e+01 -2.2924400329589844e+01 -5.8668697357177734e+01 -9.8330101013183594e+01 -2.5174999237060547e+01 -7.6412796020507812e+01 -9.8320404052734375e+01 -2.6520900726318359e+01 -7.5985298156738281e+01 -9.8274604797363281e+01 -3.0249399185180664e+01 -7.1710700988769531e+01 -9.8307899475097656e+01 -2.7789300918579102e+01 -7.5362899780273438e+01 -9.8260093688964844e+01 -3.1109500885009766e+01 -6.9307899475097656e+01 -9.8260093688964844e+01 -3.1109899520874023e+01 -6.9277397155761719e+01 -9.8330101013183594e+01 -2.5174299240112305e+01 -7.6412902832031250e+01 -9.8293899536132812e+01 -2.8941900253295898e+01 -7.4545799255371094e+01 -9.8287704467773438e+01 -2.9388900756835938e+01 -7.4144104003906250e+01 -9.8285697937011719e+01 -2.9524000167846680e+01 -7.4009002685546875e+01 -9.8270599365234375e+01 -3.0496900558471680e+01 -7.2527404785156250e+01 -9.8266998291015625e+01 -3.0709499359130859e+01 -7.1963600158691406e+01 -9.8261001586914062e+01 -3.1060800552368164e+01 -6.7721900939941406e+01 -9.8273597717285156e+01 -3.0310298919677734e+01 -6.4657096862792969e+01 -9.8295394897460938e+01 -2.8824600219726562e+01 -6.2247501373291016e+01 -9.8336502075195312e+01 -2.3713600158691406e+01 -7.6705497741699219e+01 -9.8323898315429688e+01 -2.6097801208496094e+01 -5.9948501586914062e+01 -9.8270599365234375e+01 -3.0493600845336914e+01 -1.0506999969482422e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -1.1122200012207031e+02 -9.8269401550292969e+01 -3.0567298889160156e+01 -1.0570500183105469e+02 -9.8336395263671875e+01 -2.3754600524902344e+01 -1.1147899627685547e+02 -9.8313499450683594e+01 -2.7269300460815430e+01 -1.1182199859619141e+02 -9.8270401000976562e+01 -3.0505800247192383e+01 -1.0905200195312500e+02 -9.8326805114746094e+01 -2.5691999435424805e+01 -1.1178000640869141e+02 -9.8268997192382812e+01 -3.0592100143432617e+01 -1.0803800201416016e+02 -9.8329704284667969e+01 -2.5242099761962891e+01 -1.1173299407958984e+02 -9.8283905029296875e+01 -2.9651399612426758e+01 -1.1110799407958984e+02 -9.8276199340820312e+01 -3.0152299880981445e+01 -1.1037200164794922e+02 -9.8289001464843750e+01 -2.9292301177978516e+01 -1.1136100006103516e+02 -9.8295303344726562e+01 -2.8829900741577148e+01 -1.1155500030517578e+02 -9.8268699645996094e+01 -3.0613500595092773e+01 -1.0777900695800781e+02 -9.8268203735351562e+01 -3.0641901016235352e+01 -1.0708699798583984e+02 -9.8268394470214844e+01 -3.0627099990844727e+01 -1.0639499664306641e+02 -9.8271499633789062e+01 -3.0444101333618164e+01 -1.0353700256347656e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -9.4076095581054688e+01 -9.8272399902343750e+01 -3.0384401321411133e+01 -1.0398400115966797e+02 -9.8272300720214844e+01 -3.0392400741577148e+01 -1.0411900329589844e+02 -9.8268302917480469e+01 -3.0633300781250000e+01 -1.0314500427246094e+02 -9.8265800476074219e+01 -3.0783800125122070e+01 -1.0296700286865234e+02 -9.8326103210449219e+01 -2.5794399261474609e+01 -9.3539901733398438e+01 -9.8262603759765625e+01 -3.0963499069213867e+01 -1.0281999969482422e+02 -9.8326103210449219e+01 -2.5794700622558594e+01 -9.3539901733398438e+01 -9.8331504821777344e+01 -2.4917600631713867e+01 -1.5237200927734375e+02 -9.8333000183105469e+01 -2.4641300201416016e+01 -1.5198800659179688e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -1.7710700988769531e+02 -9.8262100219726562e+01 -3.0994899749755859e+01 -1.6684800720214844e+02 -9.8337600708007812e+01 -2.3303300857543945e+01 -1.7687300109863281e+02 -9.8337600708007812e+01 -2.3304199218750000e+01 -1.7687300109863281e+02 -9.8279403686523438e+01 -2.9940999984741211e+01 -1.7165499877929688e+02 -9.8333000183105469e+01 -2.4632598876953125e+01 -1.7644700622558594e+02 -9.8324699401855469e+01 -2.5988800048828125e+01 -1.7581500244140625e+02 -9.8290199279785156e+01 -2.9205299377441406e+01 -1.7291900634765625e+02 -9.8313499450683594e+01 -2.7264999389648438e+01 -1.7497700500488281e+02 -9.8301902770996094e+01 -2.8309301376342773e+01 -1.7403199768066406e+02 -9.8271202087402344e+01 -3.0463300704956055e+01 -1.7034498596191406e+02 -9.8265602111816406e+01 -3.0795799255371094e+01 -1.6897499084472656e+02 -9.8262603759765625e+01 -3.0963600158691406e+01 -1.6757699584960938e+02 -9.8261901855468750e+01 -3.1004400253295898e+01 -1.6652700805664062e+02 -9.8264205932617188e+01 -3.0873199462890625e+01 -1.6382699584960938e+02 -9.8273300170898438e+01 -3.0331399917602539e+01 -1.6117599487304688e+02 -9.8288002014160156e+01 -2.9362600326538086e+01 -1.5864900207519531e+02 -9.8288002014160156e+01 -2.9362300872802734e+01 -1.5864900207519531e+02 -9.8304801940917969e+01 -2.8067100524902344e+01 -1.5632000732421875e+02 -9.8319702148437500e+01 -2.6605199813842773e+01 -1.5427499389648438e+02 -9.8333595275878906e+01 -2.4508699417114258e+01 -1.5156599426269531e+02 -9.8333595275878906e+01 -2.4496400833129883e+01 -1.5133500671386719e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -1.2855899047851562e+02 -9.8333503723144531e+01 -2.4524801254272461e+01 -1.5110499572753906e+02 -9.8332595825195312e+01 -2.4715600967407227e+01 -1.5064799499511719e+02 -9.8330802917480469e+01 -2.5049301147460938e+01 -1.5028401184082031e+02 -9.8291206359863281e+01 -2.9138299942016602e+01 -1.4705799865722656e+02 -9.8218101501464844e+01 -3.3226898193359375e+01 -1.4384800720214844e+02 -9.7863998413085938e+01 -4.4026100158691406e+01 -1.2089200592041016e+02 -9.7881698608398438e+01 -4.3616500854492188e+01 -1.2175099945068359e+02 -9.8200302124023438e+01 -3.4008598327636719e+01 -1.4354899597167969e+02 -9.7983001708984375e+01 -4.1099800109863281e+01 -1.2517000579833984e+02 -9.8017799377441406e+01 -4.0155197143554688e+01 -1.2599599456787109e+02 -9.8017799377441406e+01 -4.0155002593994141e+01 -1.2599599456787109e+02 -9.8084098815917969e+01 -3.8197498321533203e+01 -1.2728899383544922e+02 -9.8141296386718750e+01 -3.6291099548339844e+01 -1.2816398620605469e+02 -9.8251403808593750e+01 -3.1585201263427734e+01 -1.2925100708007812e+02 -9.8210700988769531e+01 -3.3556301116943359e+01 -1.4365400695800781e+02 -9.8194595336914062e+01 -3.4249397277832031e+01 -1.2879299926757812e+02 -9.8194595336914062e+01 -3.4249702453613281e+01 -1.2879299926757812e+02 -9.8294601440429688e+01 -2.8886501312255859e+01 -1.2937899780273438e+02 -9.8318702697753906e+01 -2.6717201232910156e+01 -1.2927900695800781e+02 -9.8333595275878906e+01 -2.4493801116943359e+01 -1.2892300415039062e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -3.3749301910400391e+01 -9.8338699340820312e+01 -2.2243301391601562e+01 -4.2406497955322266e+01 -9.8338699340820312e+01 -2.2354999542236328e+01 -4.2322399139404297e+01 -9.8338699340820312e+01 -2.2243301391601562e+01 6.5145004272460938e+01 -9.8338699340820312e+01 -2.2243301391601562e+01 1.9471399307250977e+01 -9.7237701416015625e+01 -5.5405799865722656e+01 6.5145004272460938e+01 -9.8249801635742188e+01 -3.1674098968505859e+01 1.7865100860595703e+01 -9.7983001708984375e+01 -4.1101600646972656e+01 1.6193799972534180e+01 -9.7940399169921875e+01 -4.2197998046875000e+01 1.5994800567626953e+01 -9.7895401000976562e+01 -4.3294002532958984e+01 1.5793899536132812e+01 -9.7891502380371094e+01 -4.3385902404785156e+01 1.5773798942565918e+01 -9.7872894287109375e+01 -4.3820499420166016e+01 1.5580699920654297e+01 -9.7861297607421875e+01 -4.4088401794433594e+01 1.5346400260925293e+01 -9.7855201721191406e+01 -4.4227397918701172e+01 1.5158599853515625e+01 -9.7848899841308594e+01 -4.4369300842285156e+01 -3.8669300079345703e-01 -9.7851097106933594e+01 -4.4320098876953125e+01 -5.2029699087142944e-01 -9.7871604919433594e+01 -4.3850299835205078e+01 -2.0253200531005859e+01 -9.7845893859863281e+01 -4.4435798645019531e+01 5.2205599844455719e-02 -9.7849502563476562e+01 -4.4357398986816406e+01 1.4884699821472168e+01 -9.7845893859863281e+01 -4.4435798645019531e+01 1.4416599273681641e+01 -9.7862495422363281e+01 -4.4060600280761719e+01 -9.2250901460647583e-01 -9.7869003295898438e+01 -4.3910800933837891e+01 -1.0607000589370728e+00 -9.7877899169921875e+01 -4.3705097198486328e+01 -1.1943100690841675e+00 -9.7887596130371094e+01 -4.3478401184082031e+01 -1.2881799936294556e+00 -9.7904693603515625e+01 -4.3072799682617188e+01 -1.3521099090576172e+00 -9.7889999389648438e+01 -4.3421901702880859e+01 -2.0049200057983398e+01 -9.7894897460937500e+01 -4.3306499481201172e+01 -2.0021799087524414e+01 -9.7914505004882812e+01 -4.2836200714111328e+01 -1.3359000682830811e+00 -9.7983001708984375e+01 -4.1101600646972656e+01 -1.9598699569702148e+01 -9.7940101623535156e+01 -4.2204299926757812e+01 -1.9809299468994141e+01 -9.8338699340820312e+01 -2.2243301391601562e+01 1.9571099281311035e+00 -9.8338699340820312e+01 -2.2243301391601562e+01 -1.6143100738525391e+01 -9.8249801635742188e+01 -3.1674098968505859e+01 4.0971401333808899e-01 -9.8249801635742188e+01 -3.1674098968505859e+01 -1.7838399887084961e+01 -9.7983001708984375e+01 -4.1101600646972656e+01 -1.0716999769210815e+00 -9.7949501037597656e+01 -4.1968902587890625e+01 -1.2042899131774902e+00 -9.7861000061035156e+01 -4.4095798492431641e+01 -2.0475500106811523e+01 -9.7855705261230469e+01 -4.4215000152587891e+01 -2.0635000228881836e+01 -9.7792495727539062e+01 -4.5607299804687500e+01 -6.9992897033691406e+01 -9.7817199707031250e+01 -4.5074798583984375e+01 -7.4981895446777344e+01 -9.7883300781250000e+01 -4.3578399658203125e+01 -1.0385400390625000e+02 -9.7798103332519531e+01 -4.5487998962402344e+01 -6.6158195495605469e+01 -9.7792198181152344e+01 -4.5613899230957031e+01 -6.9758399963378906e+01 -9.7849502563476562e+01 -4.4357501983642578e+01 -2.0928899765014648e+01 -9.7845893859863281e+01 -4.4435798645019531e+01 -2.1396699905395508e+01 -9.7845893859863281e+01 -4.4435798645019531e+01 -3.5762599945068359e+01 -9.7848899841308594e+01 -4.4370201110839844e+01 -3.6198799133300781e+01 -9.7913803100585938e+01 -4.2852302551269531e+01 -8.1433898925781250e+01 -9.7983001708984375e+01 -4.1100402832031250e+01 -8.4237503051757812e+01 -9.7902198791503906e+01 -4.3130901336669922e+01 -1.0372399902343750e+02 -9.7897003173828125e+01 -4.3254699707031250e+01 -8.0637596130371094e+01 -9.8028396606445312e+01 -3.9856399536132812e+01 -8.5794502258300781e+01 -9.8091293334960938e+01 -3.7969001770019531e+01 -8.7697700500488281e+01 -9.8153297424316406e+01 -3.5860500335693359e+01 -8.9353096008300781e+01 -9.8299194335937500e+01 -2.8529800415039062e+01 -9.2852104187011719e+01 -9.8254302978515625e+01 -3.1430299758911133e+01 -1.0261700439453125e+02 -9.8259201049804688e+01 -3.1159099578857422e+01 -9.1911598205566406e+01 -9.8244804382324219e+01 -3.1936199188232422e+01 -1.0258599853515625e+02 -9.8134803771972656e+01 -3.6519500732421875e+01 -1.0304000091552734e+02 -9.7983001708984375e+01 -4.1101600646972656e+01 -1.0350900268554688e+02 -9.7943901062011719e+01 -4.2109798431396484e+01 -1.0361499786376953e+02 -9.7902793884277344e+01 -4.3117698669433594e+01 -1.0372200012207031e+02 -9.7850006103515625e+01 -4.4344802856445312e+01 -3.6273200988769531e+01 -9.7859893798828125e+01 -4.4120700836181641e+01 -3.6668300628662109e+01 -9.7866699218750000e+01 -4.3962501525878906e+01 -3.6832798004150391e+01 -9.7874702453613281e+01 -4.3778400421142578e+01 -3.6967899322509766e+01 -9.7884994506835938e+01 -4.3540100097656250e+01 -3.7082401275634766e+01 -9.7804801940917969e+01 -4.5343200683593750e+01 -6.4892700195312500e+01 -9.8338401794433594e+01 -2.2809799194335938e+01 -4.2125099182128906e+01 -9.8337600708007812e+01 -2.3302999496459961e+01 -4.2093502044677734e+01 -9.8249801635742188e+01 -3.1674098968505859e+01 -3.5346401214599609e+01 -9.8324905395507812e+01 -2.5956998825073242e+01 -4.2493598937988281e+01 -9.8298896789550781e+01 -2.8548200607299805e+01 -4.3194499969482422e+01 -9.7983001708984375e+01 -4.1101600646972656e+01 -3.6877399444580078e+01 -9.8237998962402344e+01 -3.2278999328613281e+01 -4.4861202239990234e+01 -9.8237998962402344e+01 -3.2279098510742188e+01 -4.4861301422119141e+01 -9.8187797546386719e+01 -3.4526798248291016e+01 -4.6294101715087891e+01 -9.7949600219726562e+01 -4.1965400695800781e+01 -3.7013999938964844e+01 -9.8132202148437500e+01 -3.6611797332763672e+01 -4.7954399108886719e+01 -9.7914703369140625e+01 -4.2829200744628906e+01 -3.7149600982666016e+01 -9.7983100891113281e+01 -4.1097900390625000e+01 -5.3212402343750000e+01 -9.7938697814941406e+01 -4.2240600585937500e+01 -5.5161098480224609e+01 -9.7905097961425781e+01 -4.3062999725341797e+01 -3.7167098999023438e+01 -9.8009399414062500e+01 -4.0388000488281250e+01 -5.2166999816894531e+01 -9.8036399841308594e+01 -3.9629100799560547e+01 -5.1156402587890625e+01 -9.7856994628906250e+01 -4.4185798645019531e+01 -5.9788600921630859e+01 -9.7856994628906250e+01 -4.4185798645019531e+01 -5.9788700103759766e+01 -9.7854103088378906e+01 -4.4251300811767578e+01 -5.9994998931884766e+01 -9.7866996765136719e+01 -4.3957698822021484e+01 -1.0412500000000000e+02 -9.7856903076171875e+01 -4.4189201354980469e+01 -1.0443399810791016e+02 -9.7817504882812500e+01 -4.5068000793457031e+01 -1.7352200317382812e+02 -9.7876197814941406e+01 -4.3744899749755859e+01 -1.7836601257324219e+02 -9.7890502929687500e+01 -4.3409900665283203e+01 -2.1565699768066406e+02 -9.7903900146484375e+01 -4.3092102050781250e+01 -1.7992199707031250e+02 -9.7983001708984375e+01 -4.1101200103759766e+01 -1.8350500488281250e+02 -9.8008399963378906e+01 -4.0415298461914062e+01 -1.8448600769042969e+02 -9.8127204895019531e+01 -3.6784099578857422e+01 -1.8842500305175781e+02 -9.8131095886230469e+01 -3.6650600433349609e+01 -1.8853999328613281e+02 -9.8164398193359375e+01 -3.5443897247314453e+01 -1.8950801086425781e+02 -9.8243499755859375e+01 -3.2001399993896484e+01 -1.9166799926757812e+02 -9.8249801635742188e+01 -3.1674098968505859e+01 -2.1348500061035156e+02 -9.7983001708984375e+01 -4.1101600646972656e+01 -2.1521600341796875e+02 -9.7940200805664062e+01 -4.2202201843261719e+01 -2.1542300415039062e+02 -9.7895103454589844e+01 -4.3302398681640625e+01 -2.1563200378417969e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -1.9459300231933594e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -2.1181900024414062e+02 -9.8332893371582031e+01 -2.4652500152587891e+01 -1.9421600341796875e+02 -9.8315902709960938e+01 -2.7021600723266602e+01 -1.9364100646972656e+02 -9.7851699829101562e+01 -4.4305599212646484e+01 -1.0470999908447266e+02 -9.7828796386718750e+01 -4.4818302154541016e+01 -1.0667800140380859e+02 -9.7811897277832031e+01 -4.5189102172851562e+01 -1.0878600311279297e+02 -9.8079200744628906e+01 -3.8350196838378906e+01 -1.4687800598144531e+02 -9.8038002014160156e+01 -3.9580200195312500e+01 -1.4837100219726562e+02 -9.7863998413085938e+01 -4.4026298522949219e+01 -1.2089200592041016e+02 -9.8188697814941406e+01 -3.4488800048828125e+01 -1.4360499572753906e+02 -9.8177902221679688e+01 -3.4921298980712891e+01 -1.4381900024414062e+02 -9.8120803833007812e+01 -3.7001800537109375e+01 -1.4551399230957031e+02 -9.7984100341796875e+01 -4.1071002960205078e+01 -1.5056300354003906e+02 -9.7983001708984375e+01 -4.1099899291992188e+01 -1.5061000061035156e+02 -9.7904602050781250e+01 -4.3073699951171875e+01 -1.5451901245117188e+02 -9.7904602050781250e+01 -4.3073799133300781e+01 -1.5452000427246094e+02 -9.7866699218750000e+01 -4.3963699340820312e+01 -1.5697799682617188e+02 -9.7819801330566406e+01 -4.5017498016357422e+01 -1.6135501098632812e+02 -9.7801200866699219e+01 -4.5420501708984375e+01 -1.1138899993896484e+02 -9.7800094604492188e+01 -4.5445301055908203e+01 -1.1357499694824219e+02 -9.7794898986816406e+01 -4.5557300567626953e+01 -1.6830299377441406e+02 -9.7806999206542969e+01 -4.5295398712158203e+01 -1.1598799896240234e+02 -9.7796600341796875e+01 -4.5520000457763672e+01 -1.6595999145507812e+02 -9.7803695678710938e+01 -4.5367500305175781e+01 -1.6393199157714844e+02 -9.7871994018554688e+01 -4.3840400695800781e+01 -2.1585699462890625e+02 -9.7861106872558594e+01 -4.4093399047851562e+01 -2.1608399963378906e+02 -9.7855499267578125e+01 -4.4219200134277344e+01 -2.1625299072265625e+02 -9.7848899841308594e+01 -4.4370201110839844e+01 -2.3192199707031250e+02 -9.7850006103515625e+01 -4.4344699859619141e+01 -2.3199699401855469e+02 -9.7237701416015625e+01 -5.5405799865722656e+01 -2.8717300415039062e+02 -9.7849502563476562e+01 -4.4357501983642578e+01 -2.1653999328613281e+02 -9.7845893859863281e+01 -4.4435798645019531e+01 -2.1700799560546875e+02 -9.7845893859863281e+01 -4.4435798645019531e+01 -2.3148599243164062e+02 -9.7859893798828125e+01 -4.4120597839355469e+01 -2.3239199829101562e+02 -9.7866699218750000e+01 -4.3962398529052734e+01 -2.3255599975585938e+02 -9.7874702453613281e+01 -4.3778301239013672e+01 -2.3269100952148438e+02 -9.7949600219726562e+01 -4.1965099334716797e+01 -2.3273699951171875e+02 -9.7983001708984375e+01 -4.1101600646972656e+01 -2.3260000610351562e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -2.8717300415039062e+02 -9.8249801635742188e+01 -3.1674098968505859e+01 -2.3106500244140625e+02 -9.8338699340820312e+01 -2.2243301391601562e+01 -2.2946499633789062e+02 -9.7884994506835938e+01 -4.3540100097656250e+01 -2.3280599975585938e+02 -9.7905097961425781e+01 -4.3062297821044922e+01 -2.3288999938964844e+02 -9.7914802551269531e+01 -4.2828701019287109e+01 -2.3287298583984375e+02 -9.7819999694824219e+01 4.5012199401855469e+01 -1.8979699707031250e+02 -9.7834403991699219e+01 4.4695297241210938e+01 -1.8810699462890625e+02 -9.8219902038574219e+01 3.3143199920654297e+01 -1.1910899353027344e+02 -9.7836997985839844e+01 4.4637100219726562e+01 -1.8789599609375000e+02 -9.7847404479980469e+01 4.4402301788330078e+01 -1.8748100280761719e+02 -9.7857299804687500e+01 4.4179599761962891e+01 -1.8726399230957031e+02 -9.7875106811523438e+01 4.3769699096679688e+01 -1.8704699707031250e+02 -9.8228996276855469e+01 3.2715599060058594e+01 -1.1928099822998047e+02 -9.8230506896972656e+01 3.2647098541259766e+01 -1.1929499816894531e+02 -9.7942298889160156e+01 4.2151000976562500e+01 -1.8708300781250000e+02 -9.7983001708984375e+01 4.1101600646972656e+01 -1.8718400573730469e+02 -9.8338699340820312e+01 2.2243301391601562e+01 -1.2112999725341797e+02 -9.8135200500488281e+01 3.6508399963378906e+01 -1.8763800048828125e+02 -9.8245201110839844e+01 3.1914100646972656e+01 -1.8810699462890625e+02 -9.8311599731445312e+01 2.7445501327514648e+01 -1.2022299957275391e+02 -9.7880401611328125e+01 4.3646099090576172e+01 -1.8701300048828125e+02 -9.7899299621582031e+01 4.3200500488281250e+01 -1.8698400878906250e+02 -9.8254196166992188e+01 3.1435400009155273e+01 -1.8823500061035156e+02 -9.8260902404785156e+01 3.1068099975585938e+01 -1.8847900390625000e+02 -9.8263504028320312e+01 3.0914100646972656e+01 -1.8864900207519531e+02 -9.8265602111816406e+01 3.0792100906372070e+01 -1.8884300231933594e+02 -9.8268005371093750e+01 3.0652200698852539e+01 -1.8931500244140625e+02 -9.8338699340820312e+01 2.2243301391601562e+01 -2.0415798950195312e+02 -9.8267501831054688e+01 3.0680799484252930e+01 -1.8980400085449219e+02 -9.8265296936035156e+01 3.0814599990844727e+01 -1.9044099426269531e+02 -9.8262496948242188e+01 3.0975301742553711e+01 -1.9131399536132812e+02 -9.8260795593261719e+01 3.1071701049804688e+01 -1.9198800659179688e+02 -9.8259704589843750e+01 3.1135101318359375e+01 -1.9266499328613281e+02 -9.8290802001953125e+01 2.9166299819946289e+01 -2.0046099853515625e+02 -9.8314399719238281e+01 2.7169198989868164e+01 -2.0241799926757812e+02 -9.8332801818847656e+01 2.4678100585937500e+01 -2.0362300109863281e+02 -9.8259101867675781e+01 3.1164899826049805e+01 -1.9334500122070312e+02 -9.8259101867675781e+01 3.1167398452758789e+01 -1.9360800170898438e+02 -9.8337799072265625e+01 2.3186599731445312e+01 -2.0399800109863281e+02 -9.8259498596191406e+01 3.1145698547363281e+01 -1.9463699340820312e+02 -9.8270896911621094e+01 3.0480699539184570e+01 -1.9798100280761719e+02 -9.8220306396484375e+01 3.3125198364257812e+01 -1.0202999877929688e+02 -9.8230201721191406e+01 3.2658000946044922e+01 -1.0186599731445312e+02 -9.7845893859863281e+01 4.4435798645019531e+01 -2.0864601135253906e+01 -9.8205001831054688e+01 3.3805500030517578e+01 -1.0315699768066406e+02 -9.8207305908203125e+01 3.3704200744628906e+01 -1.0270600128173828e+02 -9.7848701477050781e+01 4.4373600006103516e+01 -6.0401897430419922e+00 -9.7850097656250000e+01 4.4342201232910156e+01 -5.9475097656250000e+00 -9.7237701416015625e+01 5.5405799865722656e+01 6.5145004272460938e+01 -9.8271896362304688e+01 3.0413101196289062e+01 -2.2008700561523438e+02 -9.8226196289062500e+01 3.2849300384521484e+01 -2.1901699829101562e+02 -9.7237701416015625e+01 5.5405799865722656e+01 -2.8717300415039062e+02 -9.8338699340820312e+01 2.2243301391601562e+01 -2.2192601013183594e+02 -9.8337394714355469e+01 2.3398000717163086e+01 -2.2177700805664062e+02 -9.8338699340820312e+01 2.2243301391601562e+01 -2.8717300415039062e+02 -9.8329498291015625e+01 2.5285600662231445e+01 -2.2149099731445312e+02 -9.8306900024414062e+01 2.7881500244140625e+01 -2.2090699768066406e+02 -9.8171394348144531e+01 3.5175598144531250e+01 -2.1768600463867188e+02 -9.8110801696777344e+01 3.7338600158691406e+01 -2.1610400390625000e+02 -9.8026100158691406e+01 3.9922698974609375e+01 -2.1358799743652344e+02 -9.8004295349121094e+01 4.0526500701904297e+01 -2.1286299133300781e+02 -9.7983100891113281e+01 4.1097900390625000e+01 -2.1211299133300781e+02 -9.7940498352050781e+01 4.2195701599121094e+01 -2.1045300292968750e+02 -9.7852203369140625e+01 4.4295299530029297e+01 -2.0588499450683594e+02 -9.7852203369140625e+01 4.4295398712158203e+01 -2.0588499450683594e+02 -9.7848899841308594e+01 4.4368900299072266e+01 -2.0566500854492188e+02 -9.7799102783203125e+01 4.5466697692871094e+01 -2.0076599121093750e+02 -9.7792198181152344e+01 4.5614398956298828e+01 -1.9937100219726562e+02 -9.7787002563476562e+01 4.5726001739501953e+01 -1.9616499328613281e+02 -9.7787094116210938e+01 4.5723098754882812e+01 -1.9605700683593750e+02 -9.7794601440429688e+01 4.5564498901367188e+01 -1.9356100463867188e+02 -9.7805496215820312e+01 4.5327999114990234e+01 -1.9169799804687500e+02 -9.7845893859863281e+01 4.4435798645019531e+01 -6.4656801223754883e+00 -9.8212097167968750e+01 3.3494899749755859e+01 -1.1880300140380859e+02 -9.8206695556640625e+01 3.3730701446533203e+01 -1.1837699890136719e+02 -9.8204902648925781e+01 3.3809597015380859e+01 -1.1789800262451172e+02 -9.8204902648925781e+01 3.3809597015380859e+01 -1.0327299499511719e+02 -9.7860000610351562e+01 4.4117000579833984e+01 -5.5539999008178711e+00 -9.7866897583007812e+01 4.3958499908447266e+01 -5.3902902603149414e+00 -9.7874900817871094e+01 4.3774200439453125e+01 -5.2560896873474121e+00 -9.7950195312500000e+01 4.1950798034667969e+01 -5.2349896430969238e+00 -9.7983001708984375e+01 4.1101600646972656e+01 -5.3880000114440918e+00 -9.8338699340820312e+01 2.2243301391601562e+01 6.5145004272460938e+01 -9.8249801635742188e+01 3.1674098968505859e+01 -7.1250000000000000e+00 -9.8338699340820312e+01 2.2243301391601562e+01 -8.9286098480224609e+00 -9.7884994506835938e+01 4.3539299011230469e+01 -5.1441001892089844e+00 -9.7906700134277344e+01 4.3023002624511719e+01 -5.0608901977539062e+00 -9.7916000366210938e+01 4.2800197601318359e+01 -5.0831799507141113e+00 -9.8212501525878906e+01 3.3478099822998047e+01 -1.0232499694824219e+02 -9.8216102600097656e+01 3.3314601898193359e+01 -1.0216200256347656e+02 -9.8314102172851562e+01 2.7204099655151367e+01 -1.0271699523925781e+02 -9.8338699340820312e+01 2.2243301391601562e+01 -1.0358200073242188e+02 -9.8338699340820312e+01 2.2243301391601562e+01 -2.6045400619506836e+01 -9.8249801635742188e+01 3.1674098968505859e+01 -2.4382600784301758e+01 -9.7983001708984375e+01 4.1101600646972656e+01 -2.2654899597167969e+01 -9.7940200805664062e+01 4.2201999664306641e+01 -2.2448598861694336e+01 -9.7895103454589844e+01 4.3301898956298828e+01 -2.2240400314331055e+01 -9.8240303039550781e+01 3.2164398193359375e+01 -1.0186900329589844e+02 -9.7890502929687500e+01 4.3408401489257812e+01 -2.2215898513793945e+01 -9.7872100830078125e+01 4.3839099884033203e+01 -2.2016000747680664e+01 -9.7861106872558594e+01 4.4093097686767578e+01 -2.1788900375366211e+01 -9.7855499267578125e+01 4.4219699859619141e+01 -2.1618801116943359e+01 -9.7849502563476562e+01 4.4357501983642578e+01 -2.1332500457763672e+01 -9.8338699340820312e+01 -2.0438399314880371e+00 5.0834903717041016e+00 -9.8338699340820312e+01 -6.9221401214599609e-01 5.0223999023437500e+00 -9.8338699340820312e+01 -1.9651399552822113e-01 -1.2248899459838867e+01 -9.8338699340820312e+01 -6.9212502241134644e-01 5.0223999023437500e+00 -9.8338699340820312e+01 4.7595798969268799e-01 -1.1639599800109863e+01 -9.8338699340820312e+01 -4.6392698287963867e+00 4.9127001762390137e+00 -9.8338699340820312e+01 -3.3955600261688232e+00 5.0362000465393066e+00 -9.8338699340820312e+01 4.8321499824523926e+00 3.3279401063919067e-01 -9.8338699340820312e+01 5.0129299163818359e+00 -1.4984999895095825e+00 -9.8338699340820312e+01 4.5936698913574219e+00 1.2670099735260010e+00 -9.8338699340820312e+01 5.0284898281097412e-01 4.8366999626159668e+00 -9.8338699340820312e+01 1.6288199424743652e+00 4.4836001396179199e+00 -9.8338699340820312e+01 3.8114199638366699e+00 2.7919900417327881e+00 -9.8338699340820312e+01 2.2845900058746338e+00 4.1662998199462891e+00 -9.8338699340820312e+01 3.3253400325775146e+00 3.3683099746704102e+00 -9.8338699340820312e+01 4.2132697105407715e+00 2.1548199653625488e+00 -9.8338699340820312e+01 5.0114998817443848e+00 -2.4927000999450684e+00 -9.8338699340820312e+01 4.8332800865173340e+00 -4.2264800071716309e+00 -9.8338699340820312e+01 4.4016799926757812e+00 -5.9166002273559570e+00 -9.8338699340820312e+01 3.6988801956176758e+00 -7.5138001441955566e+00 -9.8338699340820312e+01 2.2486398220062256e+00 -9.7037000656127930e+00 -9.8338699340820312e+01 5.1268897056579590e+00 -9.7480903625488281e+01 -9.8338699340820312e+01 5.1268897056579590e+00 -1.0657600402832031e+02 -9.8338699340820312e+01 1.8446100234985352e+01 -9.4870094299316406e+01 -9.8338699340820312e+01 1.8639101028442383e+01 -9.5614997863769531e+01 -9.8338699340820312e+01 1.8639101028442383e+01 -1.0421899414062500e+02 -9.8338699340820312e+01 -5.5283298492431641e+00 -5.4245399475097656e+01 -9.8338699340820312e+01 -5.7640099525451660e+00 -5.3819400787353516e+01 -9.8338699340820312e+01 -2.2068698883056641e+01 -4.2584300994873047e+01 -9.8338699340820312e+01 -5.3315200805664062e+00 -3.8619400024414062e+01 -9.8338699340820312e+01 -2.1832000732421875e+01 -4.3019100189208984e+01 -9.8338699340820312e+01 -4.7606797218322754e+00 -5.4713302612304688e+01 -9.8338699340820312e+01 -1.1251799583435059e+01 -7.6197799682617188e+01 -9.8338699340820312e+01 -1.2421500205993652e+01 -7.6365905761718750e+01 -9.8338699340820312e+01 -5.1798801422119141e+00 -5.4546596527099609e+01 -9.8338699340820312e+01 -1.4015800476074219e+01 -7.6536003112792969e+01 -9.8338699340820312e+01 -1.4439900398254395e+01 -7.6581901550292969e+01 -9.8338699340820312e+01 -8.6870794296264648e+00 -7.5716697692871094e+01 -9.8338699340820312e+01 -4.4800000190734863e+00 -5.4748901367187500e+01 -9.8338699340820312e+01 -6.1519098281860352e+00 -7.5099494934082031e+01 -9.8338699340820312e+01 -1.9179899215698242e+01 -9.4261001586914062e+01 -9.8338699340820312e+01 -1.3924699783325195e+01 -9.4039497375488281e+01 -9.8338699340820312e+01 -1.7027198791503906e+01 -7.6800895690917969e+01 -9.8338699340820312e+01 -1.9620300292968750e+01 -7.6932601928710938e+01 -9.8338699340820312e+01 -1.9620899200439453e+01 -7.6932701110839844e+01 -9.8338699340820312e+01 1.6046800613403320e+01 -4.8278202056884766e+01 -9.8338699340820312e+01 1.4435900688171387e+01 -4.6121002197265625e+01 -9.8338699340820312e+01 -4.7709298133850098e+00 -9.2372406005859375e+01 -9.8338699340820312e+01 5.2154102325439453e+00 -9.6977096557617188e+01 -9.8338699340820312e+01 -9.8751192092895508e+00 -9.3531196594238281e+01 -9.8338699340820312e+01 -1.2263399124145508e+01 -9.3866996765136719e+01 -9.8338699340820312e+01 -3.9908200502395630e-01 -7.2639602661132812e+01 -9.8338699340820312e+01 -1.9726198911666870e+00 -7.3522796630859375e+01 -9.8338699340820312e+01 1.9505300521850586e+01 -6.6711593627929688e+01 -9.8338699340820312e+01 1.9780900955200195e+01 -6.1389099121093750e+01 -9.8338699340820312e+01 1.9313299179077148e+01 -5.6644802093505859e+01 -9.8338699340820312e+01 1.8692501068115234e+01 -5.4045402526855469e+01 -9.8338699340820312e+01 9.5423498153686523e+00 -4.1984100341796875e+01 -9.8338699340820312e+01 7.1730599403381348e+00 -4.0726200103759766e+01 -9.8338699340820312e+01 8.6476999521255493e-01 -3.8788799285888672e+01 -9.8338699340820312e+01 -1.7675700187683105e+00 -3.8440700531005859e+01 -9.8338699340820312e+01 -4.4193301200866699e+00 -3.8312900543212891e+01 -9.8338699340820312e+01 -4.9014101028442383e+00 -3.8386596679687500e+01 -9.8338699340820312e+01 -3.6059598922729492e+00 -7.4256195068359375e+01 -9.8338699340820312e+01 -6.1515603065490723e+00 -7.5099403381347656e+01 -9.8338699340820312e+01 1.2546999931335449e+01 -4.4202301025390625e+01 -9.8338699340820312e+01 1.2546799659729004e+01 -4.4202098846435547e+01 -9.8338699340820312e+01 1.2842900276184082e+01 -8.1492401123046875e+01 -9.8338699340820312e+01 1.4882599830627441e+01 -7.8794097900390625e+01 -9.8338699340820312e+01 1.6987298965454102e+01 -9.4226394653320312e+01 -9.8338699340820312e+01 1.7436300277709961e+01 -7.4146102905273438e+01 -9.8338699340820312e+01 3.3510899543762207e+00 -8.9080398559570312e+01 -9.8338699340820312e+01 6.3501000404357910e+00 -8.7260902404785156e+01 -9.8338699340820312e+01 1.0475699424743652e+01 -8.3971199035644531e+01 -9.8338699340820312e+01 -2.5599000453948975e+00 -5.4913101196289062e+01 -9.8338699340820312e+01 5.0371298789978027e+00 -6.2084499359130859e+01 -9.8338699340820312e+01 5.0702700614929199e+00 -6.2577800750732422e+01 -9.8338699340820312e+01 5.0479202270507812e+00 -6.3975700378417969e+01 -9.8338699340820312e+01 3.6628799438476562e+00 -6.8605499267578125e+01 -9.8338699340820312e+01 2.5854699611663818e+00 -7.0079696655273438e+01 -9.8338699340820312e+01 1.7781600952148438e+01 -5.1532199859619141e+01 -9.8338699340820312e+01 1.7781398773193359e+01 -5.1531898498535156e+01 -9.8338699340820312e+01 4.6762800216674805e+00 -3.9747699737548828e+01 -9.8338699340820312e+01 4.6758599281311035e+00 -3.9747600555419922e+01 -9.8338699340820312e+01 1.8236200332641602e+01 -9.4595603942871094e+01 -9.8338699340820312e+01 1.7962099075317383e+01 -9.4385307312011719e+01 -9.8338699340820312e+01 1.7626499176025391e+01 -9.4248695373535156e+01 -9.8338699340820312e+01 1.8745700836181641e+01 -7.0465896606445312e+01 -9.8338699340820312e+01 1.7436300277709961e+01 -7.4146003723144531e+01 -9.8338699340820312e+01 6.2941298484802246e+00 -9.6092399597167969e+01 -9.8338699340820312e+01 5.9335799217224121e+00 -9.6203796386718750e+01 -9.8338699340820312e+01 1.6016399860382080e-01 -9.0616096496582031e+01 -9.8338699340820312e+01 5.6278100013732910e+00 -9.6394897460937500e+01 -9.8338699340820312e+01 5.3852200508117676e+00 -9.6655097961425781e+01 -9.8338699340820312e+01 -5.6353201866149902e+00 -3.8965698242187500e+01 -9.8338699340820312e+01 -5.8038797378540039e+00 -3.9381900787353516e+01 -9.8338699340820312e+01 -2.1756900787353516e+01 -4.3506900787353516e+01 -9.8338699340820312e+01 -5.8420901298522949e+00 -3.9722400665283203e+01 -9.8338699340820312e+01 -2.1861101150512695e+01 -5.7313503265380859e+01 -9.8338699340820312e+01 -5.8420901298522949e+00 -5.3340198516845703e+01 -9.8338699340820312e+01 -2.1867500305175781e+01 -5.7440097808837891e+01 -9.8338699340820312e+01 -2.1984500885009766e+01 -5.7889499664306641e+01 -9.8338699340820312e+01 1.3324599266052246e+00 -7.1354499816894531e+01 -9.8338699340820312e+01 -3.9865300059318542e-01 -7.2639305114746094e+01 -9.8338699340820312e+01 4.7435798645019531e+00 -6.6007896423339844e+01 -9.8338699340820312e+01 3.6631200313568115e+00 -6.8605201721191406e+01 -9.8338699340820312e+01 -1.2366799116134644e+00 -5.5149997711181641e+01 -9.8338699340820312e+01 -2.2058200836181641e-01 -5.5426300048828125e+01 -9.8338699340820312e+01 4.8846597671508789e+00 -6.0973999023437500e+01 -9.8338699340820312e+01 7.5093400478363037e-01 -5.5801498413085938e+01 -9.8338699340820312e+01 4.6014199256896973e+00 -5.9888198852539062e+01 -9.8338699340820312e+01 1.9843001365661621e+00 -5.6478401184082031e+01 -9.8338699340820312e+01 2.8282999992370605e+00 -5.7139698028564453e+01 -9.8338699340820312e+01 3.5347299575805664e+00 -5.7908298492431641e+01 -9.8338699340820312e+01 4.1550998687744141e+00 -5.8856800079345703e+01 -9.8338699340820312e+01 1.8599100112915039e+01 1.1736200332641602e+01 -9.8338699340820312e+01 1.7573600769042969e+01 1.3924900054931641e+01 -9.8338699340820312e+01 1.4051099777221680e+01 1.8132801055908203e+01 -9.8338699340820312e+01 1.1978099822998047e+01 1.9578098297119141e+01 -9.8338699340820312e+01 1.3267000198364258e+01 -1.0679900169372559e+01 -9.8338699340820312e+01 1.4649299621582031e+01 -9.1134996414184570e+00 -9.8338699340820312e+01 1.7588499069213867e+01 -4.6590900421142578e+00 -9.8338699340820312e+01 1.9373500823974609e+01 4.1940000653266907e-01 -9.8338699340820312e+01 1.9729299545288086e+01 3.0931198596954346e+00 -9.8338699340820312e+01 1.7573499679565430e+01 1.3925000190734863e+01 -9.8338699340820312e+01 1.5971299171447754e+01 1.6220500946044922e+01 -9.8338699340820312e+01 1.7588600158691406e+01 -4.6590099334716797e+00 -9.8338699340820312e+01 1.8661100387573242e+01 -2.1830000877380371e+00 -9.8338699340820312e+01 1.1977600097656250e+01 1.9578399658203125e+01 -9.8338699340820312e+01 9.4085302352905273e+00 2.0826999664306641e+01 -9.8338699340820312e+01 2.1597000122070312e+01 7.0468200683593750e+01 -9.8338699340820312e+01 6.7417597770690918e+00 2.1691799163818359e+01 -9.8338699340820312e+01 4.0959100723266602e+00 2.2208400726318359e+01 -9.8338699340820312e+01 1.6649400711059570e+01 7.9895103454589844e+01 -9.8338699340820312e+01 1.9695499420166016e+01 7.5482002258300781e+01 -9.8338699340820312e+01 1.9781000137329102e+01 4.9306097030639648e+00 -9.8338699340820312e+01 1.9770900726318359e+01 5.2910099029541016e+00 -9.8338699340820312e+01 1.9274999618530273e+01 9.4185094833374023e+00 -9.8338699340820312e+01 -5.0055999755859375e+00 2.2353200912475586e+01 -9.8338699340820312e+01 -2.1597000122070312e+01 7.0468200683593750e+01 -9.8338699340820312e+01 -1.1456599235534668e+00 2.2555601119995117e+01 -9.8338699340820312e+01 2.6811401844024658e+00 8.7226097106933594e+01 -9.8338699340820312e+01 1.4814699888229370e+00 2.2476200103759766e+01 -9.8338699340820312e+01 7.8875403404235840e+00 8.5942794799804688e+01 -9.8338699340820312e+01 1.2635600090026855e+01 8.3450897216796875e+01 -9.8338699340820312e+01 -1.2635600090026855e+01 8.3450897216796875e+01 -9.8338699340820312e+01 -3.7720201015472412e+00 2.2457300186157227e+01 -9.8338699340820312e+01 -7.8875403404235840e+00 8.5942794799804688e+01 -9.8338699340820312e+01 -2.6811401844024658e+00 8.7226097106933594e+01 -9.8338699340820312e+01 -1.9695499420166016e+01 7.5482002258300781e+01 -9.8338699340820312e+01 -1.6649400711059570e+01 7.9895103454589844e+01 -9.8338699340820312e+01 5.1268897056579590e+00 -2.2471398925781250e+02 -9.8338699340820312e+01 5.1268897056579590e+00 -2.3194999694824219e+02 -9.8338699340820312e+01 5.3198900222778320e+00 -2.3269499206542969e+02 -9.8338699340820312e+01 5.5297598838806152e+00 -2.3297000122070312e+02 -9.8338699340820312e+01 1.8384401321411133e+01 -2.3090901184082031e+02 -9.8338699340820312e+01 1.8554401397705078e+01 -2.3058700561523438e+02 -9.8338699340820312e+01 1.8642799377441406e+01 -2.3009300231933594e+02 -9.8338699340820312e+01 1.8692199707031250e+01 -2.2238400268554688e+02 -9.8338699340820312e+01 1.7475700378417969e+01 -2.3147200012207031e+02 -9.8338699340820312e+01 1.7836000442504883e+01 -2.3136100769042969e+02 -9.8338699340820312e+01 1.8141700744628906e+01 -2.3116999816894531e+02 -9.8338699340820312e+01 5.8038797378540039e+00 -2.3318000793457031e+02 -9.8338699340820312e+01 6.1395201683044434e+00 -2.3331600952148438e+02 -9.8338699340820312e+01 6.7787199020385742e+00 -2.3333898925781250e+02 -9.8338699340820312e+01 1.8446100234985352e+01 -1.9375898742675781e+02 -9.8338699340820312e+01 1.8639101028442383e+01 -1.9450399780273438e+02 -9.8338699340820312e+01 1.8639101028442383e+01 -2.0477099609375000e+02 -9.8338699340820312e+01 -1.8517200469970703e+01 -1.3969300842285156e+02 -9.8338699340820312e+01 -1.8764499664306641e+01 -1.3994799804687500e+02 -9.8338699340820312e+01 1.7962099075317383e+01 -1.9327500915527344e+02 -9.8338699340820312e+01 1.7626499176025391e+01 -1.9313800048828125e+02 -9.8338699340820312e+01 1.9731401443481445e+01 -1.6438000488281250e+02 -9.8338699340820312e+01 -1.9038799285888672e+01 -1.4079699707031250e+02 -9.8338699340820312e+01 -1.9038799285888672e+01 -1.7733799743652344e+02 -9.8338699340820312e+01 -1.9687799453735352e+01 -1.7734300231933594e+02 -9.8338699340820312e+01 -1.7844499588012695e+01 -1.3940399169921875e+02 -9.8338699340820312e+01 -1.8207700729370117e+01 -1.3950799560546875e+02 -9.8338699340820312e+01 5.1268897056579590e+00 -1.3117500305175781e+02 -9.8338699340820312e+01 -1.8940299987792969e+01 -1.4026600646972656e+02 -9.8338699340820312e+01 1.7832500457763672e+01 -1.3058500671386719e+02 -9.8338699340820312e+01 1.8138200759887695e+01 -1.3039399719238281e+02 -9.8338699340820312e+01 1.9700401306152344e+01 -1.5967201232910156e+02 -9.8338699340820312e+01 1.8236200332641602e+01 -1.9348500061035156e+02 -9.8338699340820312e+01 1.8639101028442383e+01 -1.2930799865722656e+02 -9.8338699340820312e+01 1.8639101028442383e+01 -1.2175299835205078e+02 -9.8338699340820312e+01 5.1268897056579590e+00 -1.2410099792480469e+02 -9.8338699340820312e+01 1.7036499023437500e+01 -1.5007400512695312e+02 -9.8338699340820312e+01 1.4139199256896973e+01 -1.4599800109863281e+02 -9.8338699340820312e+01 6.1395201683044434e+00 -1.3254100036621094e+02 -9.8338699340820312e+01 1.2215700149536133e+01 -1.4412400817871094e+02 -9.8338699340820312e+01 1.0065999984741211e+01 -1.4251600646972656e+02 -9.8338699340820312e+01 1.8550600051879883e+01 -1.2981199645996094e+02 -9.8338699340820312e+01 -1.5186600685119629e+01 -1.9464399719238281e+02 -9.8338699340820312e+01 -1.2896499633789062e+01 -1.9441500854492188e+02 -9.8338699340820312e+01 5.1268897056579590e+00 -1.9637100219726562e+02 -9.8338699340820312e+01 -1.0391099929809570e+01 -1.9407699584960938e+02 -9.8338699340820312e+01 5.2154102325439453e+00 -1.9586700439453125e+02 -9.8338699340820312e+01 -5.2837100028991699e+00 -1.9292500305175781e+02 -9.8338699340820312e+01 5.3851599693298340e+00 -1.9554499816894531e+02 -9.8338699340820312e+01 -3.5356199741363525e-01 -1.9116200256347656e+02 -9.8338699340820312e+01 5.6278100013732910e+00 -1.9528500366210938e+02 -9.8338699340820312e+01 2.9479300975799561e+00 -1.8956500244140625e+02 -9.8338699340820312e+01 5.9335198402404785e+00 -1.9509400939941406e+02 -9.8338699340820312e+01 7.7399601936340332e+00 -1.4117599487304688e+02 -9.8338699340820312e+01 5.3109498023986816e+00 -1.4010700988769531e+02 -9.8338699340820312e+01 5.8038797378540039e+00 -1.3240499877929688e+02 -9.8338699340820312e+01 1.5117199718952179e-01 -1.3869898986816406e+02 -9.8338699340820312e+01 5.5297598838806152e+00 -1.3219400024414062e+02 -9.8338699340820312e+01 1.5083798766136169e-01 -1.3869898986816406e+02 -9.8338699340820312e+01 5.3198900222778320e+00 -1.3191999816894531e+02 -9.8338699340820312e+01 5.1268897056579590e+00 -2.0706799316406250e+02 -9.8338699340820312e+01 -1.6940500259399414e+01 -1.9476499938964844e+02 -9.8338699340820312e+01 -5.0796298980712891e+00 -1.3814500427246094e+02 -9.8338699340820312e+01 -1.0335300445556641e+01 -1.3829701232910156e+02 -9.8338699340820312e+01 -1.1405600547790527e+01 -1.3840899658203125e+02 -9.8338699340820312e+01 1.8380800247192383e+01 -1.3013400268554688e+02 -9.8338699340820312e+01 1.9781000137329102e+01 -1.6148200988769531e+02 -9.8338699340820312e+01 1.2624699592590332e+01 -1.8179200744628906e+02 -9.8338699340820312e+01 1.4748100280761719e+01 -1.7898200988769531e+02 -9.8338699340820312e+01 1.6987201690673828e+01 -1.9311599731445312e+02 -9.8338699340820312e+01 1.7319400787353516e+01 -1.7435499572753906e+02 -9.8338699340820312e+01 1.9026599884033203e+01 -1.6930801391601562e+02 -9.8338699340820312e+01 1.8998500823974609e+01 -1.5513500976562500e+02 -9.8338699340820312e+01 1.7036701202392578e+01 -1.5007400512695312e+02 -9.8338699340820312e+01 1.7471900939941406e+01 -1.3069699096679688e+02 -9.8338699340820312e+01 6.7788400650024414e+00 -1.3256298828125000e+02 -9.8338699340820312e+01 6.2940697669982910e+00 -1.9498200988769531e+02 -9.8338699340820312e+01 6.0467100143432617e+00 -1.8767100524902344e+02 -9.8338699340820312e+01 1.0161600112915039e+01 -1.8437400817871094e+02 -9.5436996459960938e+01 -6.8242401123046875e+01 7.4956703186035156e+01 -9.5436996459960938e+01 -6.8944099426269531e+01 6.5145004272460938e+01 -9.3838699340820312e+01 -6.9000000000000000e+01 6.5145004272460938e+01 -9.3838699340820312e+01 6.9000000000000000e+01 6.5145004272460938e+01 -9.5436996459960938e+01 6.8944099426269531e+01 6.5145004272460938e+01 -9.3838699340820312e+01 6.8571998596191406e+01 7.2818504333496094e+01 -9.5436996459960938e+01 6.8242401123046875e+01 7.4956703186035156e+01 -9.3838699340820312e+01 6.8033599853515625e+01 7.6652496337890625e+01 -9.3838699340820312e+01 6.6170097351074219e+01 8.4345802307128906e+01 -9.5436996459960938e+01 6.6151405334472656e+01 8.4568801879882812e+01 -9.3838699340820312e+01 6.6117500305175781e+01 8.4563301086425781e+01 -9.3838699340820312e+01 5.5309799194335938e+01 1.0636500549316406e+02 -9.3838699340820312e+01 5.7904602050781250e+01 1.0235700225830078e+02 -9.5436996459960938e+01 5.7999500274658203e+01 1.0241899871826172e+02 -9.3838699340820312e+01 6.0404399871826172e+01 9.8496299743652344e+01 -9.5436996459960938e+01 6.2713802337646484e+01 9.3785400390625000e+01 -9.3838699340820312e+01 6.2166400909423828e+01 9.5083702087402344e+01 -9.3838699340820312e+01 6.5758499145507812e+01 8.6044998168945312e+01 -9.3838699340820312e+01 5.5152198791503906e+01 1.0660900115966797e+02 -9.5436996459960938e+01 5.2104499816894531e+01 1.1029399871826172e+02 -9.3838699340820312e+01 4.8774200439453125e+01 1.1395099639892578e+02 -9.5436996459960938e+01 4.5148799896240234e+01 1.1725000000000000e+02 -9.3838699340820312e+01 4.5984397888183594e+01 1.1658799743652344e+02 -9.5436996459960938e+01 2.8640399932861328e+01 1.2785899353027344e+02 -9.3445297241210938e+01 2.9945098876953125e+01 1.2732399749755859e+02 -9.5436996459960938e+01 3.7273998260498047e+01 1.2314499664306641e+02 -9.3737602233886719e+01 3.8374698638916016e+01 1.2249399566650391e+02 -9.3827598571777344e+01 4.5145103454589844e+01 1.1723999786376953e+02 -9.3316802978515625e+01 2.6628000259399414e+01 1.2882000732421875e+02 -9.3391403198242188e+01 2.8553298950195312e+01 1.2795099639892578e+02 -9.3395599365234375e+01 2.8660598754882812e+01 1.2790299987792969e+02 -9.2993400573730469e+01 1.7486600875854492e+01 1.3192300415039062e+02 -9.5436996459960938e+01 1.9423799514770508e+01 1.3129598999023438e+02 -9.2814399719238281e+01 9.8050203323364258e+00 1.3337300109863281e+02 -9.5436996459960938e+01 9.8117599487304688e+00 1.3338699340820312e+02 -9.2771301269531250e+01 7.9590697288513184e+00 1.3372200012207031e+02 -9.2725402832031250e+01 3.9592399597167969e+00 1.3406999206542969e+02 -9.5436996459960938e+01 0.0000000000000000e+00 1.3408898925781250e+02 -9.2740997314453125e+01 -5.6424698829650879e+00 1.3395201110839844e+02 -9.5436996459960938e+01 -9.8117599487304688e+00 1.3338699340820312e+02 -9.2821907043457031e+01 -9.7994203567504883e+00 1.3331300354003906e+02 -9.2927001953125000e+01 -1.5198100090026855e+01 1.3248300170898438e+02 -9.5436996459960938e+01 -1.9423799514770508e+01 1.3129598999023438e+02 -9.3039199829101562e+01 -1.8938199996948242e+01 1.3152400207519531e+02 -9.3369995117187500e+01 -2.8001998901367188e+01 1.2822599792480469e+02 -9.5436996459960938e+01 -2.8640399932861328e+01 1.2785899353027344e+02 -9.3388801574707031e+01 -2.8516599655151367e+01 1.2795099639892578e+02 -9.5436996459960938e+01 -3.7273998260498047e+01 1.2314499664306641e+02 -9.5436996459960938e+01 -4.5148799896240234e+01 1.1725000000000000e+02 -9.3819793701171875e+01 -4.5097198486328125e+01 1.1718399810791016e+02 -9.3774604797363281e+01 -3.9836700439453125e+01 1.2148600006103516e+02 -9.3684501647949219e+01 -3.6579601287841797e+01 1.2365700531005859e+02 -9.3393699645996094e+01 -2.8647701263427734e+01 1.2788200378417969e+02 -9.3838699340820312e+01 -5.7917098999023438e+01 1.0237000274658203e+02 -9.3838699340820312e+01 -5.6212802886962891e+01 1.0515899658203125e+02 -9.5436996459960938e+01 -5.7999500274658203e+01 1.0241899871826172e+02 -9.3838699340820312e+01 -5.5302200317382812e+01 1.0636500549316406e+02 -9.5436996459960938e+01 -5.2104499816894531e+01 1.1029399871826172e+02 -9.3838699340820312e+01 -5.3879997253417969e+01 1.0824900054931641e+02 -9.3838699340820312e+01 -4.7293399810791016e+01 1.1538800048828125e+02 -9.3838699340820312e+01 -6.1252098083496094e+01 9.6912696838378906e+01 -9.5436996459960938e+01 -6.2713802337646484e+01 9.3785400390625000e+01 -9.3838699340820312e+01 -6.5110397338867188e+01 8.7984397888183594e+01 -9.5436996459960938e+01 -6.6151405334472656e+01 8.4568801879882812e+01 -9.3838699340820312e+01 -6.6197593688964844e+01 8.4582199096679688e+01 -9.3838699340820312e+01 -6.8314498901367188e+01 7.4847099304199219e+01 -9.3838699340820312e+01 -6.6288902282714844e+01 8.4296600341796875e+01 -9.3838699340820312e+01 -6.6273200988769531e+01 8.4345802307128906e+01 -9.3838699340820312e+01 -6.9000000000000000e+01 6.1560398101806641e+01 -9.5363800048828125e+01 -6.8946693420410156e+01 -3.1182901000976562e+02 -9.5144401550292969e+01 -6.8954399108886719e+01 -3.2389102172851562e+02 -9.3838699340820312e+01 -6.9000000000000000e+01 -3.2393597412109375e+02 -9.3838699340820312e+01 -6.9000000000000000e+01 -1.2560900688171387e+01 -9.3838699340820312e+01 -6.9000000000000000e+01 1.3171999931335449e+01 -9.3838699340820312e+01 -6.9000000000000000e+01 3.7862697601318359e+01 -9.5436996459960938e+01 -6.8944099426269531e+01 -2.9977899169921875e+02 -9.3838699340820312e+01 -6.9000000000000000e+01 -6.7268501281738281e+01 -9.3838699340820312e+01 -6.9000000000000000e+01 -3.9367298126220703e+01 -9.3838699340820312e+01 -5.9006099700927734e+01 -3.3392999267578125e+02 -9.5144401550292969e+01 -5.8960502624511719e+01 -3.3388400268554688e+02 -9.5363800048828125e+01 -4.6898902893066406e+01 -3.3387698364257812e+02 -9.5436996459960938e+01 -3.4848602294921875e+01 -3.3387399291992188e+02 -9.5436996459960938e+01 3.4848602294921875e+01 -3.3387399291992188e+02 -9.3838699340820312e+01 5.9006099700927734e+01 -3.3392999267578125e+02 -9.5363800048828125e+01 4.6898902893066406e+01 -3.3387698364257812e+02 -9.5144401550292969e+01 5.8960502624511719e+01 -3.3388400268554688e+02 -9.3838699340820312e+01 6.9000000000000000e+01 6.1560398101806641e+01 -9.3838699340820312e+01 6.9000000000000000e+01 3.7862697601318359e+01 -9.3838699340820312e+01 6.9000000000000000e+01 1.3171999931335449e+01 -9.3838699340820312e+01 6.9000000000000000e+01 -1.2560900688171387e+01 -9.5144401550292969e+01 6.8954399108886719e+01 -3.2389102172851562e+02 -9.5363800048828125e+01 6.8946693420410156e+01 -3.1182901000976562e+02 -9.3838699340820312e+01 6.9000000000000000e+01 -3.2393597412109375e+02 -9.5436996459960938e+01 6.8944099426269531e+01 -2.9977899169921875e+02 -9.3838699340820312e+01 6.9000000000000000e+01 -6.7268501281738281e+01 -9.3838699340820312e+01 6.9000000000000000e+01 -3.9367298126220703e+01 -9.6399902343750000e+01 -6.8011100769042969e+01 6.5145004272460938e+01 -9.6399902343750000e+01 -6.7318794250488281e+01 7.4823997497558594e+01 -9.7237701416015625e+01 -4.9059398651123047e+01 9.0893402099609375e+01 -9.6399902343750000e+01 -5.7214599609375000e+01 1.0191500091552734e+02 -9.7237701416015625e+01 -4.4505100250244141e+01 9.7491401672363281e+01 -9.6399902343750000e+01 -5.4888999938964844e+01 1.0502099609375000e+02 -9.7237701416015625e+01 -4.1471801757812500e+01 1.0188599395751953e+02 -9.7237701416015625e+01 -5.3795799255371094e+01 7.8404502868652344e+01 -9.6399902343750000e+01 -6.5256202697753906e+01 8.4305900573730469e+01 -9.7237701416015625e+01 -5.2376899719238281e+01 8.2145996093750000e+01 -9.6399902343750000e+01 -6.4578506469726562e+01 8.6122802734375000e+01 -9.6399902343750000e+01 -6.1865097045898438e+01 9.3397804260253906e+01 -9.6399902343750000e+01 -5.1399398803710938e+01 1.0968299865722656e+02 -9.6399902343750000e+01 -4.4537799835205078e+01 1.1654399871826172e+02 -9.7237701416015625e+01 -3.2470302581787109e+01 1.0986100006103516e+02 -9.6399902343750000e+01 -3.9876201629638672e+01 1.2003400421142578e+02 -9.7237701416015625e+01 -3.1474098205566406e+01 1.1074300384521484e+02 -9.6399902343750000e+01 -3.6769599914550781e+01 1.2236000061035156e+02 -9.7237701416015625e+01 -1.9647199630737305e+01 1.1694999694824219e+02 -9.7237701416015625e+01 6.6784000396728516e+00 1.2014699554443359e+02 -9.6399902343750000e+01 1.9160900115966797e+01 1.3040100097656250e+02 -9.7237701416015625e+01 1.7059499740600586e+01 1.1758799743652344e+02 -9.6399902343750000e+01 2.0977800369262695e+01 1.2972399902343750e+02 -9.7237701416015625e+01 1.9647199630737305e+01 1.1694999694824219e+02 -9.6399902343750000e+01 -2.8252799987792969e+01 1.2701000213623047e+02 -9.6399902343750000e+01 -2.0977800369262695e+01 1.2972399902343750e+02 -9.7237701416015625e+01 -1.7059499740600586e+01 1.1758799743652344e+02 -9.6399902343750000e+01 -1.9160900115966797e+01 1.3040100097656250e+02 -9.7237701416015625e+01 -6.6784000396728516e+00 1.2014699554443359e+02 -9.6399902343750000e+01 -9.6789598464965820e+00 1.3246400451660156e+02 -9.7237701416015625e+01 0.0000000000000000e+00 1.2014699554443359e+02 -9.6399902343750000e+01 0.0000000000000000e+00 1.3315600585937500e+02 -9.6399902343750000e+01 9.6789598464965820e+00 1.3246400451660156e+02 -9.6399902343750000e+01 2.8252799987792969e+01 1.2701000213623047e+02 -9.6399902343750000e+01 3.6769599914550781e+01 1.2236000061035156e+02 -9.7237701416015625e+01 3.1474098205566406e+01 1.1074300384521484e+02 -9.6399902343750000e+01 3.9876201629638672e+01 1.2003400421142578e+02 -9.7237701416015625e+01 3.2470302581787109e+01 1.0986100006103516e+02 -9.6399902343750000e+01 4.4537799835205078e+01 1.1654399871826172e+02 -9.7237701416015625e+01 4.1471801757812500e+01 1.0188599395751953e+02 -9.6399902343750000e+01 5.1399398803710938e+01 1.0968299865722656e+02 -9.7237701416015625e+01 4.4505100250244141e+01 9.7491401672363281e+01 -9.6399902343750000e+01 6.8011100769042969e+01 6.5145004272460938e+01 -9.6399902343750000e+01 6.7318794250488281e+01 7.4823997497558594e+01 -9.7237701416015625e+01 5.3795799255371094e+01 7.8404502868652344e+01 -9.6399902343750000e+01 5.4888999938964844e+01 1.0502099609375000e+02 -9.6399902343750000e+01 5.7214599609375000e+01 1.0191500091552734e+02 -9.7237701416015625e+01 4.9059398651123047e+01 9.0893402099609375e+01 -9.6399902343750000e+01 6.1865097045898438e+01 9.3397804260253906e+01 -9.7237701416015625e+01 5.2376899719238281e+01 8.2145996093750000e+01 -9.6399902343750000e+01 6.4578506469726562e+01 8.6122802734375000e+01 -9.6399902343750000e+01 6.5256202697753906e+01 8.4305900573730469e+01 -9.6399902343750000e+01 -6.8011100769042969e+01 -2.9977899169921875e+02 -9.6399902343750000e+01 6.8011100769042969e+01 -2.9977899169921875e+02 -9.6399902343750000e+01 -3.4848602294921875e+01 -3.3294100952148438e+02 -9.7237701416015625e+01 -2.2243301391601562e+01 -3.2033602905273438e+02 -9.6399902343750000e+01 3.4848602294921875e+01 -3.3294100952148438e+02 -9.7237701416015625e+01 2.2243301391601562e+01 -3.2033602905273438e+02 -9.5109901428222656e+01 6.8707305908203125e+01 -3.2610601806640625e+02 -9.3838699340820312e+01 6.8756202697753906e+01 -3.2613098144531250e+02 -9.5083801269531250e+01 6.7567901611328125e+01 -3.2886999511718750e+02 -9.3838699340820312e+01 6.7612800598144531e+01 -3.2891400146484375e+02 -9.5080703735351562e+01 6.7431396484375000e+01 -3.2920101928710938e+02 -9.3838699340820312e+01 6.7481597900390625e+01 -3.2923300170898438e+02 -9.5076599121093750e+01 6.5202301025390625e+01 -3.3170101928710938e+02 -9.3838699340820312e+01 6.5251502990722656e+01 -3.3173999023437500e+02 -9.5085700988769531e+01 6.3892498016357422e+01 -3.3242498779296875e+02 -9.3838699340820312e+01 6.3935802459716797e+01 -3.3246899414062500e+02 -9.5097000122070312e+01 6.2266799926757812e+01 -3.3332397460937500e+02 -9.3838699340820312e+01 6.2315299987792969e+01 -3.3336700439453125e+02 -9.5109901428222656e+01 -6.1176399230957031e+01 -3.3363699340820312e+02 -9.3838699340820312e+01 -6.1201198577880859e+01 -3.3368600463867188e+02 -9.5083801269531250e+01 -6.3939804077148438e+01 -3.3249801635742188e+02 -9.3838699340820312e+01 -6.3983901977539062e+01 -3.3254299926757812e+02 -9.5080703735351562e+01 -6.4270896911621094e+01 -3.3236102294921875e+02 -9.3838699340820312e+01 -6.4303298950195312e+01 -3.3241201782226562e+02 -9.5076599121093750e+01 -6.6771003723144531e+01 -3.3013201904296875e+02 -9.3838699340820312e+01 -6.6809494018554688e+01 -3.3018197631835938e+02 -9.5085700988769531e+01 -6.7495300292968750e+01 -3.2882299804687500e+02 -9.3838699340820312e+01 -6.7538597106933594e+01 -3.2886599731445312e+02 -9.5097000122070312e+01 -6.8394401550292969e+01 -3.2719699096679688e+02 -9.3838699340820312e+01 -6.8436698913574219e+01 -3.2724499511718750e+02 -9.6327301025390625e+01 -6.8001594543457031e+01 -3.1184100341796875e+02 -9.6148796081542969e+01 -6.3492298126220703e+01 -3.2842199707031250e+02 -9.6108299255371094e+01 -6.7997200012207031e+01 -3.2391500854492188e+02 -9.6026504516601562e+01 -6.6025299072265625e+01 -3.2954098510742188e+02 -9.6051498413085938e+01 -6.7490196228027344e+01 -3.2689398193359375e+02 -9.6031501770019531e+01 -6.3770896911621094e+01 -3.3155099487304688e+02 -9.6066902160644531e+01 -6.0981601715087891e+01 -3.3270300292968750e+02 -9.6108299255371094e+01 -5.8984600067138672e+01 -3.3292700195312500e+02 -9.6327301025390625e+01 -4.6911003112792969e+01 -3.3293200683593750e+02 -9.6327301025390625e+01 4.6911003112792969e+01 -3.3293200683593750e+02 -9.6148796081542969e+01 6.3492298126220703e+01 -3.2842199707031250e+02 -9.6108299255371094e+01 5.8984600067138672e+01 -3.3292700195312500e+02 -9.6026504516601562e+01 6.4610603332519531e+01 -3.3095498657226562e+02 -9.6051498413085938e+01 6.1964298248291016e+01 -3.3241998291015625e+02 -9.6031501770019531e+01 6.6620994567871094e+01 -3.2870098876953125e+02 -9.6066902160644531e+01 6.7773002624511719e+01 -3.2591198730468750e+02 -9.6108299255371094e+01 6.7997200012207031e+01 -3.2391500854492188e+02 -9.6327301025390625e+01 6.8001594543457031e+01 -3.1184100341796875e+02 -9.6182304382324219e+01 4.6909000396728516e+01 -3.3339801025390625e+02 -9.5966804504394531e+01 5.8980800628662109e+01 -3.3339898681640625e+02 -9.5833297729492188e+01 4.6904701232910156e+01 -3.3374099731445312e+02 -9.5617301940917969e+01 5.8972103118896484e+01 -3.3374597167968750e+02 -9.6251304626464844e+01 3.4848602294921875e+01 -3.3340298461914062e+02 -9.5903099060058594e+01 3.4848602294921875e+01 -3.3373999023437500e+02 -9.5565002441406250e+01 6.2226398468017578e+01 -3.3319000244140625e+02 -9.5617301940917969e+01 6.8816398620605469e+01 -3.2390200805664062e+02 -9.5966804504394531e+01 6.8469200134277344e+01 -3.2391101074218750e+02 -9.5925895690917969e+01 6.8230895996093750e+01 -3.2601300048828125e+02 -9.5579101562500000e+01 6.8569396972656250e+01 -3.2608300781250000e+02 -9.5546897888183594e+01 6.7310104370117188e+01 -3.2912899780273438e+02 -9.5542297363281250e+01 6.5115196228027344e+01 -3.3158999633789062e+02 -9.5890998840332031e+01 6.7016799926757812e+01 -3.2894799804687500e+02 -9.5886001586914062e+01 6.4901000976562500e+01 -3.3131997680664062e+02 -9.5910598754882812e+01 6.2116897583007812e+01 -3.3286199951171875e+02 -9.6251304626464844e+01 -3.4848602294921875e+01 -3.3340298461914062e+02 -9.5903099060058594e+01 -3.4848602294921875e+01 -3.3373999023437500e+02 -9.6182304382324219e+01 6.8468505859375000e+01 -3.1183901977539062e+02 -9.6251304626464844e+01 6.8472702026367188e+01 -2.9977899169921875e+02 -9.5833297729492188e+01 6.8810798645019531e+01 -3.1183499145507812e+02 -9.5903099060058594e+01 6.8810203552246094e+01 -2.9977899169921875e+02 -9.6182304382324219e+01 -4.6909000396728516e+01 -3.3339801025390625e+02 -9.5833297729492188e+01 -4.6904701232910156e+01 -3.3374099731445312e+02 -9.5966804504394531e+01 -5.8980800628662109e+01 -3.3339898681640625e+02 -9.5617301940917969e+01 -5.8972103118896484e+01 -3.3374597167968750e+02 -9.6251304626464844e+01 6.8472702026367188e+01 6.5145004272460938e+01 -9.5903099060058594e+01 6.8810203552246094e+01 6.5145004272460938e+01 -9.5617301940917969e+01 -6.8816398620605469e+01 -3.2390200805664062e+02 -9.5565002441406250e+01 -6.8259796142578125e+01 -3.2715600585937500e+02 -9.5925895690917969e+01 -6.1082798004150391e+01 -3.3316101074218750e+02 -9.5579101562500000e+01 -6.1153301239013672e+01 -3.3349902343750000e+02 -9.5546897888183594e+01 -6.4198501586914062e+01 -3.3223999023437500e+02 -9.5542297363281250e+01 -6.6659599304199219e+01 -3.3004501342773438e+02 -9.5890998840332031e+01 -6.4017601013183594e+01 -3.3194699096679688e+02 -9.5886001586914062e+01 -6.6389701843261719e+01 -3.2983099365234375e+02 -9.5910598754882812e+01 -6.7932395935058594e+01 -3.2704699707031250e+02 -9.5966804504394531e+01 -6.8469200134277344e+01 -3.2391101074218750e+02 -9.6251304626464844e+01 6.7775802612304688e+01 7.4889694213867188e+01 -9.5903099060058594e+01 6.8109901428222656e+01 7.4937698364257812e+01 -9.6251304626464844e+01 6.5699096679687500e+01 8.4435997009277344e+01 -9.6251304626464844e+01 6.2284999847412109e+01 9.3589599609375000e+01 -9.6251304626464844e+01 5.7602901458740234e+01 1.0216400146484375e+02 -9.6251304626464844e+01 5.1748199462890625e+01 1.0998500061035156e+02 -9.6251304626464844e+01 4.4840099334716797e+01 1.1689299774169922e+02 -9.6251304626464844e+01 3.7019100189208984e+01 1.2274800109863281e+02 -9.6251304626464844e+01 2.8444599151611328e+01 1.2743000793457031e+02 -9.6251304626464844e+01 1.9291000366210938e+01 1.3084399414062500e+02 -9.6251304626464844e+01 9.7446403503417969e+00 1.3292098999023438e+02 -9.6251304626464844e+01 0.0000000000000000e+00 1.3361799621582031e+02 -9.6251304626464844e+01 -9.7446403503417969e+00 1.3292098999023438e+02 -9.6251304626464844e+01 -1.9291000366210938e+01 1.3084399414062500e+02 -9.6251304626464844e+01 -2.8444599151611328e+01 1.2743000793457031e+02 -9.6251304626464844e+01 -3.7019100189208984e+01 1.2274800109863281e+02 -9.6251304626464844e+01 -4.4840099334716797e+01 1.1689299774169922e+02 -9.6251304626464844e+01 -5.1748199462890625e+01 1.0998500061035156e+02 -9.6251304626464844e+01 -5.7602901458740234e+01 1.0216400146484375e+02 -9.6251304626464844e+01 -6.2284999847412109e+01 9.3589599609375000e+01 -9.6251304626464844e+01 -6.5699096679687500e+01 8.4435997009277344e+01 -9.6251304626464844e+01 -6.7775802612304688e+01 7.4889694213867188e+01 -9.6251304626464844e+01 -6.8472702026367188e+01 6.5145004272460938e+01 -9.5903099060058594e+01 6.6022903442382812e+01 8.4531097412109375e+01 -9.5903099060058594e+01 6.2591999053955078e+01 9.3729804992675781e+01 -9.5903099060058594e+01 5.7886802673339844e+01 1.0234700012207031e+02 -9.5903099060058594e+01 5.2003303527832031e+01 1.1020600128173828e+02 -9.5903099060058594e+01 4.5061100006103516e+01 1.1714799499511719e+02 -9.5903099060058594e+01 3.7201599121093750e+01 1.2303200531005859e+02 -9.5903099060058594e+01 2.8584800720214844e+01 1.2773699951171875e+02 -9.5903099060058594e+01 1.9386001586914062e+01 1.3116799926757812e+02 -9.5903099060058594e+01 9.7926797866821289e+00 1.3325500488281250e+02 -9.5903099060058594e+01 0.0000000000000000e+00 1.3395500183105469e+02 -9.5903099060058594e+01 -9.7926797866821289e+00 1.3325500488281250e+02 -9.5903099060058594e+01 -1.9386001586914062e+01 1.3116799926757812e+02 -9.5903099060058594e+01 -2.8584800720214844e+01 1.2773699951171875e+02 -9.5903099060058594e+01 -3.7201599121093750e+01 1.2303200531005859e+02 -9.5903099060058594e+01 -4.5061100006103516e+01 1.1714799499511719e+02 -9.5903099060058594e+01 -5.2003303527832031e+01 1.1020600128173828e+02 -9.5903099060058594e+01 -5.7886802673339844e+01 1.0234700012207031e+02 -9.5903099060058594e+01 -6.2591999053955078e+01 9.3729804992675781e+01 -9.5903099060058594e+01 -6.6022903442382812e+01 8.4531097412109375e+01 -9.5903099060058594e+01 -6.8109901428222656e+01 7.4937698364257812e+01 -9.5903099060058594e+01 -6.8810203552246094e+01 6.5145004272460938e+01 -9.6182304382324219e+01 -6.8468505859375000e+01 -3.1183901977539062e+02 -9.5833297729492188e+01 -6.8810798645019531e+01 -3.1183499145507812e+02 -9.6251304626464844e+01 -6.8472702026367188e+01 -2.9977899169921875e+02 -9.5903099060058594e+01 -6.8810203552246094e+01 -2.9977899169921875e+02 -9.3838699340820312e+01 7.4911399841308594e+01 8.4345802307128906e+01 -9.3838699340820312e+01 -7.4910499572753906e+01 -2.9128900146484375e+02 -9.3838699340820312e+01 -7.4910499572753906e+01 -3.4892999267578125e+02 -9.3838699340820312e+01 7.4910400390625000e+01 -3.4892999267578125e+02 -9.3838699340820312e+01 7.4910400390625000e+01 -2.9128997802734375e+02 -9.3838699340820312e+01 7.4909904479980469e+01 -6.7268501281738281e+01 -9.3838699340820312e+01 -7.4910095214843750e+01 -6.7268501281738281e+01 -9.3838699340820312e+01 -7.4910003662109375e+01 -6.5139602661132812e+01 -9.3838699340820312e+01 -7.4911499023437500e+01 8.4345802307128906e+01 -9.3838699340820312e+01 -7.4911499023437500e+01 6.1560398101806641e+01 -9.3838699340820312e+01 -7.4910400390625000e+01 -3.9367298126220703e+01 -9.3838699340820312e+01 -7.4910697937011719e+01 -1.2560900688171387e+01 -9.3838699340820312e+01 -7.4910995483398438e+01 1.3171999931335449e+01 -9.3838699340820312e+01 -7.4911293029785156e+01 3.7862697601318359e+01 -9.3838699340820312e+01 -7.4911399841308594e+01 4.7935199737548828e+01 -9.3832000732421875e+01 -7.4910499572753906e+01 1.0636500549316406e+02 -9.3838699340820312e+01 -7.4911598205566406e+01 1.0447299957275391e+02 -9.3229499816894531e+01 -7.4824302673339844e+01 1.2793700408935547e+02 -9.3778495788574219e+01 -7.4901794433593750e+01 1.2136600494384766e+02 -9.0128105163574219e+01 7.4386497497558594e+01 1.4797499084472656e+02 -9.0128105163574219e+01 -7.4386596679687500e+01 1.4797499084472656e+02 -9.2703201293945312e+01 -7.4749900817871094e+01 1.3423599243164062e+02 -9.3229499816894531e+01 7.4824104309082031e+01 1.2793700408935547e+02 -9.2703201293945312e+01 7.4749794006347656e+01 1.3423599243164062e+02 -9.3838699340820312e+01 7.4911499023437500e+01 1.0447299957275391e+02 -9.3832000732421875e+01 7.4910301208496094e+01 1.0636500549316406e+02 -9.3778495788574219e+01 7.4901702880859375e+01 1.2136600494384766e+02 -9.3838699340820312e+01 7.4911293029785156e+01 6.1560398101806641e+01 -9.3838699340820312e+01 7.4911293029785156e+01 4.7935199737548828e+01 -9.3838699340820312e+01 7.4911201477050781e+01 3.7862697601318359e+01 -9.3838699340820312e+01 7.4910903930664062e+01 1.3171999931335449e+01 -9.3838699340820312e+01 7.4910606384277344e+01 -1.2560900688171387e+01 -9.3838699340820312e+01 7.4910202026367188e+01 -3.9367298126220703e+01 -9.3838699340820312e+01 7.4909904479980469e+01 -6.5139701843261719e+01 -5.9126296997070312e+01 -6.9972404479980469e+01 2.1220899963378906e+02 -5.9105197906494141e+01 -6.9969200134277344e+01 2.1223699951171875e+02 -5.9105197906494141e+01 -5.9022697448730469e+01 2.1223699951171875e+02 -5.9105197906494141e+01 5.9022697448730469e+01 2.1223699951171875e+02 -5.9105197906494141e+01 6.9969200134277344e+01 2.1223699951171875e+02 -5.9126296997070312e+01 6.9972404479980469e+01 2.1220899963378906e+02 -5.9105197906494141e+01 0.0000000000000000e+00 2.1223699951171875e+02 -7.3293998718261719e+01 7.1996696472167969e+01 1.9010700988769531e+02 -6.7901298522949219e+01 7.1227699279785156e+01 1.9943299865722656e+02 -9.0113998413085938e+01 7.4384506225585938e+01 1.4804998779296875e+02 -9.0113998413085938e+01 -7.4384597778320312e+01 1.4804998779296875e+02 -8.6114402770996094e+01 7.3818901062011719e+01 1.6180000305175781e+02 -8.6114402770996094e+01 -7.3819000244140625e+01 1.6180000305175781e+02 -8.3424301147460938e+01 7.3437500000000000e+01 1.6883599853515625e+02 -8.3424301147460938e+01 -7.3437599182128906e+01 1.6883599853515625e+02 -8.1947402954101562e+01 7.3228096008300781e+01 1.7269999694824219e+02 -8.1947402954101562e+01 -7.3228202819824219e+01 1.7269999694824219e+02 -7.5521301269531250e+01 7.2314399719238281e+01 1.8625601196289062e+02 -7.5521301269531250e+01 -7.2314498901367188e+01 1.8625601196289062e+02 -7.3293998718261719e+01 -7.1996803283691406e+01 1.9010700988769531e+02 -6.7901298522949219e+01 -7.1227699279785156e+01 1.9943299865722656e+02 6.8196403503417969e+01 8.2310997009277344e+01 2.2556999206542969e+02 6.8196403503417969e+01 -8.2310997009277344e+01 2.2556999206542969e+02 6.8196403503417969e+01 8.2310997009277344e+01 2.2382000732421875e+02 6.8196403503417969e+01 -8.2310997009277344e+01 2.2382000732421875e+02 6.8196403503417969e+01 1.2283000183105469e+02 2.2381900024414062e+02 6.8196403503417969e+01 1.2259400177001953e+02 2.2382000732421875e+02 6.8196403503417969e+01 -1.7083799743652344e+02 -4.0114398956298828e+01 6.8196403503417969e+01 -1.7083799743652344e+02 7.8968101501464844e+01 6.8196403503417969e+01 -1.7083799743652344e+02 1.1462599945068359e+02 6.8196403503417969e+01 1.5448899841308594e+02 1.8624499511718750e+02 6.8196403503417969e+01 1.4713700866699219e+02 2.0068499755859375e+02 6.8196403503417969e+01 1.4673399353027344e+02 2.0136299133300781e+02 6.8196403503417969e+01 1.3862399291992188e+02 2.1501000976562500e+02 6.8196403503417969e+01 1.3796299743652344e+02 2.1598300170898438e+02 6.8196403503417969e+01 -1.7083799743652344e+02 -3.4892999267578125e+02 6.8196403503417969e+01 1.7083799743652344e+02 -3.4892999267578125e+02 6.8196403503417969e+01 -1.7083799743652344e+02 -2.8716702270507812e+02 6.8196403503417969e+01 1.7083799743652344e+02 -1.7612500000000000e+02 6.8196403503417969e+01 -1.7083799743652344e+02 -6.3664600372314453e+01 6.8196403503417969e+01 1.7083799743652344e+02 -6.3664600372314453e+01 6.8196403503417969e+01 1.7083799743652344e+02 7.8968101501464844e+01 6.8196403503417969e+01 1.7083799743652344e+02 9.9754699707031250e+01 6.8196403503417969e+01 1.7083500671386719e+02 1.1462599945068359e+02 6.8196403503417969e+01 1.7083399963378906e+02 1.1859200286865234e+02 6.8196403503417969e+01 1.6211499023437500e+02 1.6721899414062500e+02 6.8196403503417969e+01 1.6381399536132812e+02 1.6224400329589844e+02 6.8196403503417969e+01 1.6703799438476562e+02 1.4988400268554688e+02 6.8196403503417969e+01 1.6060200500488281e+02 1.7165100097656250e+02 6.8196403503417969e+01 1.5527699279785156e+02 1.8436399841308594e+02 6.8196403503417969e+01 1.3445599365234375e+02 2.1965899658203125e+02 6.8196403503417969e+01 1.3340499877929688e+02 2.2044200134277344e+02 6.8196403503417969e+01 1.3166600036621094e+02 2.2132901000976562e+02 6.8196403503417969e+01 1.2887899780273438e+02 2.2275000000000000e+02 6.8196403503417969e+01 1.2345700073242188e+02 2.2380000305175781e+02 6.8196403503417969e+01 -1.4660800170898438e+02 2.0129400634765625e+02 6.8196403503417969e+01 -1.5074400329589844e+02 1.9391000366210938e+02 6.8196403503417969e+01 -1.5518499755859375e+02 1.8431900024414062e+02 6.8196403503417969e+01 -1.5810600280761719e+02 1.7800900268554688e+02 6.8196403503417969e+01 -1.6451100158691406e+02 1.5994100952148438e+02 6.8196403503417969e+01 -1.6698800659179688e+02 1.4987400817871094e+02 6.8196403503417969e+01 -1.6808000183105469e+02 1.4543501281738281e+02 6.8196403503417969e+01 -1.6999400329589844e+02 1.3236700439453125e+02 6.8196403503417969e+01 1.7004100036621094e+02 1.3250300598144531e+02 6.8196403503417969e+01 1.6765800476074219e+02 1.4750700378417969e+02 6.8196403503417969e+01 -1.3165699768066406e+02 2.2133299255371094e+02 6.8196403503417969e+01 -1.2259400177001953e+02 2.2382000732421875e+02 6.8196403503417969e+01 -1.3535099792480469e+02 2.1889599609375000e+02 6.8196403503417969e+01 -1.3862399291992188e+02 2.1501000976562500e+02 6.8196403503417969e+01 -1.4169299316406250e+02 2.1006900024414062e+02 6.8196403503417969e+01 -1.5946299743652344e+02 1.7463398742675781e+02 6.8196403503417969e+01 -1.6202198791503906e+02 1.6718701171875000e+02 6.8196403503417969e+01 -1.7019000244140625e+02 1.3102400207519531e+02 6.8196403503417969e+01 -1.7083799743652344e+02 1.1630200195312500e+02 6.8196403503417969e+01 -1.2261500549316406e+02 2.2382000732421875e+02 6.8196403503417969e+01 -1.2875000000000000e+02 2.2279399108886719e+02 6.8196403503417969e+01 -1.2997599792480469e+02 2.2232598876953125e+02 6.8196403503417969e+01 -1.3435000610351562e+02 2.1974299621582031e+02 -5.5565700531005859e+01 6.9496200561523438e+01 2.1586300659179688e+02 -4.4578498840332031e+01 -6.8037399291992188e+01 2.1988200378417969e+02 -4.4525100708007812e+01 -6.8030296325683594e+01 2.1988398742675781e+02 -4.4525100708007812e+01 -5.9022697448730469e+01 2.1988398742675781e+02 -4.8669403076171875e+01 -6.8580703735351562e+01 2.1927699279785156e+02 -5.2686298370361328e+01 -5.9022697448730469e+01 2.1772200012207031e+02 -4.9922203063964844e+01 -6.8746902465820312e+01 2.1890299987792969e+02 -5.2613300323486328e+01 -6.9104095458984375e+01 2.1757400512695312e+02 -5.5565700531005859e+01 -6.9496299743652344e+01 2.1586300659179688e+02 -5.4476501464843750e+01 -6.9351394653320312e+01 2.1665400695800781e+02 -5.4476501464843750e+01 6.9351394653320312e+01 2.1665400695800781e+02 -4.4525100708007812e+01 5.9022697448730469e+01 2.1988398742675781e+02 -4.4525100708007812e+01 6.8030296325683594e+01 2.1988398742675781e+02 -4.4578498840332031e+01 6.8037399291992188e+01 2.1988200378417969e+02 -4.8669403076171875e+01 6.8580596923828125e+01 2.1927699279785156e+02 -5.2686298370361328e+01 5.9022697448730469e+01 2.1772200012207031e+02 -4.9922203063964844e+01 6.8746902465820312e+01 2.1890299987792969e+02 -5.2613300323486328e+01 6.9104095458984375e+01 2.1757400512695312e+02 -5.2686298370361328e+01 0.0000000000000000e+00 2.1772200012207031e+02 -4.4525100708007812e+01 0.0000000000000000e+00 2.1988398742675781e+02 -3.8903602600097656e+01 1.2935900878906250e+02 2.0309799194335938e+02 -3.3548900604248047e+01 1.3481399536132812e+02 2.0311300659179688e+02 -3.9544601440429688e+01 1.4385099792480469e+02 1.8630300903320312e+02 -3.8672203063964844e+01 1.5476199340820312e+02 1.6875000000000000e+02 -3.2450099945068359e+01 1.5691000366210938e+02 1.6876399230957031e+02 -3.6547000885009766e+01 1.6216500854492188e+02 1.5073800659179688e+02 -5.4408302307128906e+01 1.5769999694824219e+02 1.1462599945068359e+02 -4.9922897338867188e+01 1.6143299865722656e+02 1.1462599945068359e+02 -4.9829402923583984e+01 1.6139698791503906e+02 7.8968101501464844e+01 -5.4468502044677734e+01 1.5769299316406250e+02 -6.3664600372314453e+01 -5.8450302124023438e+01 1.5283900451660156e+02 -6.3664600372314453e+01 -5.8440799713134766e+01 1.5284500122070312e+02 7.8968101501464844e+01 2.5328599929809570e+01 1.3814500427246094e+02 2.1332299804687500e+02 3.0540599822998047e+01 1.3820399475097656e+02 2.1352799987792969e+02 2.6908599853515625e+01 1.4464099121093750e+02 2.0235699462890625e+02 1.3713000297546387e+01 1.6893600463867188e+02 7.8968101501464844e+01 1.3834300041198730e+01 1.6893998718261719e+02 1.1462599945068359e+02 1.4384200096130371e+01 1.6809498596191406e+02 1.3249301147460938e+02 1.6007799148559570e+01 1.6499499511718750e+02 1.5036801147460938e+02 1.8669300079345703e+01 1.5987400817871094e+02 1.6808499145507812e+02 2.2319400787353516e+01 1.5300000000000000e+02 1.8547200012207031e+02 -2.1493599414825439e+00 1.3782699584960938e+02 2.1222799682617188e+02 9.1380891799926758e+00 1.3795800781250000e+02 2.1267799377441406e+02 4.4546604156494141e+00 1.4342799377441406e+02 2.0298500061035156e+02 -2.1615798473358154e+00 1.3782699584960938e+02 2.1222700500488281e+02 -9.2393894195556641e+00 1.3737300109863281e+02 2.1243099975585938e+02 -6.8286800384521484e+00 1.3777301025390625e+02 2.1204699707031250e+02 -6.9971199035644531e+00 1.4292199707031250e+02 2.0314100646972656e+02 -2.8789499282836914e+01 1.2802099609375000e+02 2.1373300170898438e+02 -2.5698200225830078e+01 1.3042601013183594e+02 2.1382299804687500e+02 -2.6847200393676758e+01 1.3910800170898438e+02 2.0313200378417969e+02 -2.2131898880004883e+01 1.3259899902343750e+02 2.1374798583984375e+02 -2.1666500091552734e+01 1.3281401062011719e+02 2.1371600341796875e+02 -1.9406499862670898e+01 1.4174499511718750e+02 2.0314801025390625e+02 -1.6054100036621094e+01 1.3540800476074219e+02 2.1332200622558594e+02 -1.4053099632263184e+01 1.3598500061035156e+02 2.1306001281738281e+02 -3.8317100524902344e+01 1.1779399871826172e+02 2.1277900695800781e+02 -3.5102298736572266e+01 1.2209300231933594e+02 2.1327499389648438e+02 -3.4694797515869141e+01 1.2251000213623047e+02 2.1331399536132812e+02 -3.0938699722290039e+01 1.2634999847412109e+02 2.1366999816894531e+02 -5.1706798553466797e+01 1.0670700073242188e+02 2.0295100402832031e+02 -4.6748001098632812e+01 1.0172399902343750e+02 2.1249800109863281e+02 -4.5931098937988281e+01 1.0347499847412109e+02 2.1251901245117188e+02 -4.2324497222900391e+01 1.2432800292968750e+02 2.0309098815917969e+02 -3.8949600219726562e+01 1.1676699829101562e+02 2.1273199462890625e+02 -3.8530300140380859e+01 1.1750900268554688e+02 2.1274598693847656e+02 -5.9022998809814453e+01 7.0672805786132812e+01 2.1220800781250000e+02 -5.6043300628662109e+01 7.9566902160644531e+01 2.1228500366210938e+02 -5.9519897460937500e+01 8.9353302001953125e+01 2.0268598937988281e+02 -5.3276798248291016e+01 8.6449401855468750e+01 2.1234600830078125e+02 -4.9557601928710938e+01 9.5702095031738281e+01 2.1242700195312500e+02 -7.5413002014160156e+01 7.3064697265625000e+01 1.8625601196289062e+02 -6.7795402526855469e+01 7.1953804016113281e+01 1.9943299865722656e+02 -6.5702499389648438e+01 7.1648200988769531e+01 2.0248100280761719e+02 -6.8436401367187500e+01 9.3657905578613281e+01 1.8583300781250000e+02 -7.5693504333496094e+01 7.3105606079101562e+01 1.8566400146484375e+02 -7.5570594787597656e+01 9.7256599426269531e+01 1.6836700439453125e+02 -8.3554100036621094e+01 7.4250305175781250e+01 1.6820800781250000e+02 -8.1836997985839844e+01 7.4000404357910156e+01 1.7270100402832031e+02 -8.0761299133300781e+01 1.0001199340820312e+02 1.5052198791503906e+02 -8.9309997558593750e+01 7.5087501525878906e+01 1.5042700195312500e+02 -8.6002700805664062e+01 7.4606597900390625e+01 1.6180000305175781e+02 -8.3847900390625000e+01 1.0178600311279297e+02 1.3253199768066406e+02 -9.2589500427246094e+01 7.5563903808593750e+01 1.3423599243164062e+02 -9.0000999450683594e+01 7.5188003540039062e+01 1.4805099487304688e+02 -8.4701698303222656e+01 1.0245600128173828e+02 1.1462599945068359e+02 -9.3664901733398438e+01 7.5719299316406250e+01 1.2136600494384766e+02 -9.2733894348144531e+01 7.5584800720214844e+01 1.3250799560546875e+02 -8.4724395751953125e+01 1.0264600372314453e+02 7.8968101501464844e+01 -9.3725799560546875e+01 7.5726600646972656e+01 1.0447299957275391e+02 -9.3689201354980469e+01 7.5722206115722656e+01 1.1462599945068359e+02 -9.3724899291992188e+01 7.5728294372558594e+01 -6.3664600372314453e+01 -9.3725700378417969e+01 7.5726898193359375e+01 4.7935199737548828e+01 -9.3725799560546875e+01 7.5726699829101562e+01 7.8968101501464844e+01 -8.7768600463867188e+01 9.4256805419921875e+01 -3.4892999267578125e+02 -9.3725196838378906e+01 7.5727798461914062e+01 -3.4892999267578125e+02 -9.3725196838378906e+01 7.5727798461914062e+01 -2.9128997802734375e+02 -9.3724899291992188e+01 7.5728294372558594e+01 -6.5139701843261719e+01 -8.4675903320312500e+01 1.0233000183105469e+02 -6.3664600372314453e+01 -8.4530700683593750e+01 1.0233899688720703e+02 -3.4892999267578125e+02 -2.1267700195312500e+00 1.5167500305175781e+02 1.8616198730468750e+02 -7.2511000633239746e+00 1.5860099792480469e+02 1.6862399291992188e+02 -1.0872200012207031e+01 1.6385600280761719e+02 1.5066200256347656e+02 -1.2943900108337402e+01 1.6708999633789062e+02 1.3256700134277344e+02 -1.3443200111389160e+01 1.6798699951171875e+02 1.1462599945068359e+02 -1.3393699645996094e+01 1.6798899841308594e+02 7.8968101501464844e+01 1.3910300254821777e+01 1.6894200134277344e+02 -6.3664600372314453e+01 -2.3990400314331055e+01 1.6334800720214844e+02 1.5073500061035156e+02 -1.9965600967407227e+01 1.5806500244140625e+02 1.6875801086425781e+02 -1.4283499717712402e+01 1.5113299560546875e+02 1.8633399963378906e+02 -1.3474200248718262e+01 1.6798600769042969e+02 -6.3664600372314453e+01 -2.6903800964355469e+01 1.6751701354980469e+02 -6.3664600372314453e+01 -2.6843900680541992e+01 1.6751899719238281e+02 7.8968101501464844e+01 -3.9594799041748047e+01 1.6619200134277344e+02 7.8968101501464844e+01 -2.6880701065063477e+01 1.6751800537109375e+02 1.1462599945068359e+02 -7.2572097778320312e+01 1.2874800109863281e+02 -6.3664600372314453e+01 -7.2801300048828125e+01 1.2874099731445312e+02 7.8968101501464844e+01 -7.2674499511718750e+01 1.2875500488281250e+02 1.1462599945068359e+02 -7.1835998535156250e+01 1.2798300170898438e+02 1.3256298828125000e+02 -5.7923297882080078e+01 1.5181900024414062e+02 1.3258000183105469e+02 -2.6714500427246094e+01 1.4998200988769531e+02 1.8634199523925781e+02 -3.3476402282714844e+01 1.4763101196289062e+02 1.8632400512695312e+02 -4.4533199310302734e+01 1.3895899963378906e+02 1.8628599548339844e+02 -4.4253597259521484e+01 1.5138598632812500e+02 1.6873399353027344e+02 -4.2366100311279297e+01 1.6014399719238281e+02 1.5073100280761719e+02 -3.8938602447509766e+01 1.6538299560546875e+02 1.3258700561523438e+02 -2.6304800033569336e+01 1.6661100769042969e+02 1.3258599853515625e+02 -5.3999500274658203e+01 1.5666400146484375e+02 1.3258099365234375e+02 -5.5958801269531250e+01 1.4812399291992188e+02 1.5071099853515625e+02 -6.9194999694824219e+01 1.2514199066162109e+02 1.5064599609375000e+02 -5.8990299224853516e+01 1.1423400115966797e+02 1.8612500000000000e+02 -4.8055702209472656e+01 1.3402099609375000e+02 1.8627899169921875e+02 -4.8984600067138672e+01 1.4695199584960938e+02 1.6872100830078125e+02 -4.7599800109863281e+01 1.5705999755859375e+02 1.5072200012207031e+02 -4.4489799499511719e+01 1.6341699218750000e+02 1.3258500671386719e+02 -3.9583400726318359e+01 1.6623400878906250e+02 1.1462599945068359e+02 -4.4998600006103516e+01 1.6426199340820312e+02 1.1462599945068359e+02 -4.9507301330566406e+01 1.6051499938964844e+02 1.3258300781250000e+02 -5.2169403076171875e+01 1.5297399902343750e+02 1.5071499633789062e+02 -5.2634998321533203e+01 1.4207200622558594e+02 1.6871499633789062e+02 -6.4866401672363281e+01 1.2046899414062500e+02 1.6859500122070312e+02 -4.3732501983642578e+01 1.6484600830078125e+02 -3.4892999267578125e+02 -4.7677402496337891e+01 1.6289700317382812e+02 -3.4892999267578125e+02 -4.9991500854492188e+01 1.6146199035644531e+02 -6.3664600372314453e+01 -5.8446002960205078e+01 1.5284100341796875e+02 1.1462599945068359e+02 -5.4326297760009766e+01 1.5772200012207031e+02 7.8968101501464844e+01 -3.9578998565673828e+01 1.6626300048828125e+02 -6.3664600372314453e+01 -4.9858699798583984e+01 1.6131498718261719e+02 -3.4892999267578125e+02 -6.3212795257568359e+01 1.4534500122070312e+02 -3.4892999267578125e+02 -7.2565803527832031e+01 1.2871299743652344e+02 -3.4892999267578125e+02 -7.3498298645019531e+01 1.2705400848388672e+02 -3.4892999267578125e+02 -8.0544395446777344e+01 1.1229000091552734e+02 -3.4892999267578125e+02 -5.3102298736572266e+01 1.5896199035644531e+02 -3.4892999267578125e+02 -5.5055397033691406e+01 1.5706500244140625e+02 -3.4892999267578125e+02 -5.8369800567626953e+01 1.5277999877929688e+02 -3.4892999267578125e+02 -5.9159500122070312e+01 1.5175900268554688e+02 -3.4892999267578125e+02 -2.6889799118041992e+01 1.6751199340820312e+02 -3.4892999267578125e+02 -1.3455599784851074e+01 1.6798300170898438e+02 -3.4892999267578125e+02 5.3706603050231934e+00 1.6864399719238281e+02 -3.4892999267578125e+02 1.0737599372863770e+01 1.6883200073242188e+02 -3.4892999267578125e+02 1.3864999771118164e+01 1.6894100952148438e+02 -3.4892999267578125e+02 -3.2944198608398438e+01 1.6729899597167969e+02 -3.4892999267578125e+02 -3.7304401397705078e+01 1.6676499938964844e+02 -3.4892999267578125e+02 -3.9538497924804688e+01 1.6609799194335938e+02 -3.4892999267578125e+02 -3.9737899780273438e+01 -8.1221794128417969e+01 2.2005101013183594e+02 4.2865997314453125e+01 -4.9958499908447266e+01 2.2293501281738281e+02 3.3838199615478516e+01 -2.5700799942016602e+01 2.2261999511718750e+02 5.7348098754882812e+01 7.1410903930664062e+01 2.2344100952148438e+02 -3.6184700012207031e+01 8.9567001342773438e+01 2.2017500305175781e+02 -4.2308403015136719e+01 7.4495193481445312e+01 2.1996099853515625e+02 4.2865997314453125e+01 4.9958499908447266e+01 2.2293501281738281e+02 3.3838199615478516e+01 2.5700799942016602e+01 2.2261999511718750e+02 3.0771499633789062e+01 0.0000000000000000e+00 2.2251300048828125e+02 5.6924999237060547e+01 -1.2244599914550781e+02 2.2342599487304688e+02 5.7348098754882812e+01 -7.1410903930664062e+01 2.2344100952148438e+02 1.1871000289916992e+01 -1.2179700469970703e+02 2.2185299682617188e+02 -3.8979000091552734e+01 -8.3085594177246094e+01 2.2007699584960938e+02 -3.1912401199340820e+01 -9.8559295654296875e+01 2.2032398986816406e+02 -2.9334501266479492e+01 -1.0356300354003906e+02 2.2041400146484375e+02 -2.6023099899291992e+01 -1.0961399841308594e+02 2.2052999877929688e+02 -2.6147600173950195e+01 1.0939399719238281e+02 2.2052499389648438e+02 -3.2750301361083984e+01 9.6869300842285156e+01 2.2029499816894531e+02 -1.7660400390625000e+01 -1.1850400543212891e+02 2.2082200622558594e+02 -1.4115099906921387e+01 -1.2020400238037109e+02 2.2094599914550781e+02 2.5252700805664062e+01 1.2199500274658203e+02 2.2232000732421875e+02 -2.2394800186157227e+00 1.2159399414062500e+02 2.2136000061035156e+02 -8.3350696563720703e+00 1.2146700286865234e+02 2.2114700317382812e+02 -2.3200099945068359e+01 -1.1378399658203125e+02 2.2062799072265625e+02 -2.0213600158691406e+01 -1.1672099304199219e+02 2.2073300170898438e+02 -1.0978099822998047e+01 -1.2110099792480469e+02 2.2105500793457031e+02 -6.6735301017761230e+00 -1.2153199768066406e+02 2.2120500183105469e+02 -1.2322999954223633e+01 1.2077999877929688e+02 2.2100799560546875e+02 -1.5993499755859375e+01 1.1940200042724609e+02 2.2088000488281250e+02 -1.8170700073242188e+01 1.1818999481201172e+02 2.2080400085449219e+02 -2.1331901550292969e+01 1.1574900054931641e+02 2.2069400024414062e+02 -2.3762500762939453e+01 1.1308799743652344e+02 2.2060899353027344e+02 -4.4578102111816406e+01 6.8039901733398438e+01 2.1988200378417969e+02 2.5200300216674805e+01 1.3123799133300781e+02 2.1991699218750000e+02 -4.8638103485107422e+01 6.8781196594238281e+01 2.1927799987792969e+02 -5.0008697509765625e+01 7.7311500549316406e+01 2.1779899597167969e+02 -4.9881500244140625e+01 6.9007705688476562e+01 2.1890400695800781e+02 -5.2571899414062500e+01 6.9496994018554688e+01 2.1756700134277344e+02 -5.8998397827148438e+01 7.0668502807617188e+01 2.1224099731445312e+02 -5.5484100341796875e+01 7.0026702880859375e+01 2.1586599731445312e+02 -5.4402702331542969e+01 6.9830001831054688e+01 2.1665600585937500e+02 -3.3349102020263672e+01 1.1349800109863281e+02 2.1833898925781250e+02 -4.0158599853515625e+01 1.0054499816894531e+02 2.1811000061035156e+02 -4.3695201873779297e+01 9.2978500366210938e+01 2.1799600219726562e+02 -3.0103498458862305e+01 1.1806800079345703e+02 2.1856599426269531e+02 -2.6690500259399414e+01 1.2158799743652344e+02 2.1875399780273438e+02 -2.2386299133300781e+01 1.2493199920654297e+02 2.1889599609375000e+02 -1.9456901550292969e+01 1.2669700622558594e+02 2.1894299316406250e+02 -1.4484800338745117e+01 1.2895100402832031e+02 2.1893901062011719e+02 -8.9416103363037109e+00 1.3052099609375000e+02 2.1881500244140625e+02 -2.2854399681091309e+00 1.3090600585937500e+02 2.1891799926757812e+02 -7.8850097656250000e+01 -1.1605100250244141e+02 -3.4892999267578125e+02 -7.2561500549316406e+01 -1.2886199951171875e+02 -3.4892999267578125e+02 -7.2572097778320312e+01 -1.2874800109863281e+02 -6.3664600372314453e+01 -2.6880701065063477e+01 -1.6751800537109375e+02 1.1462599945068359e+02 -3.9583400726318359e+01 -1.6623400878906250e+02 1.1462599945068359e+02 -3.9594898223876953e+01 -1.6619200134277344e+02 7.8968101501464844e+01 -1.3474200248718262e+01 -1.6798600769042969e+02 -6.3664600372314453e+01 1.3910300254821777e+01 -1.6894200134277344e+02 -6.3664600372314453e+01 1.3712900161743164e+01 -1.6893600463867188e+02 7.8968101501464844e+01 1.1949599266052246e+01 -1.3799099731445312e+02 2.1278500366210938e+02 9.1223592758178711e+00 -1.3795800781250000e+02 2.1267401123046875e+02 4.4546604156494141e+00 -1.4342799377441406e+02 2.0298500061035156e+02 -1.3772199630737305e+01 -1.3620300292968750e+02 2.1306599426269531e+02 -1.4072899818420410e+01 -1.3608599853515625e+02 2.1309500122070312e+02 -1.9406499862670898e+01 -1.4174600219726562e+02 2.0314801025390625e+02 -1.9042400360107422e+01 -1.3415699768066406e+02 2.1357800292968750e+02 -2.1629699707031250e+01 -1.3274200439453125e+02 2.1368399047851562e+02 -2.6847099304199219e+01 -1.3910800170898438e+02 2.0313200378417969e+02 -3.4130199432373047e+01 -1.2319100189208984e+02 2.1339199829101562e+02 -3.4669498443603516e+01 -1.2249500274658203e+02 2.1331300354003906e+02 -3.8903602600097656e+01 -1.2935900878906250e+02 2.0309799194335938e+02 -4.2324497222900391e+01 -1.2432800292968750e+02 2.0309098815917969e+02 -3.8312500000000000e+01 -1.1779000091552734e+02 2.1277799987792969e+02 -3.8530300140380859e+01 -1.1750900268554688e+02 2.1274598693847656e+02 -4.2321601867675781e+01 -1.1058399963378906e+02 2.1262300109863281e+02 -4.5045299530029297e+01 -1.0527200317382812e+02 2.1254299926757812e+02 -5.1706798553466797e+01 -1.0670700073242188e+02 2.0295100402832031e+02 -3.8818099975585938e+01 -1.1700000000000000e+02 2.1273699951171875e+02 -2.9068599700927734e+01 -1.2794299316406250e+02 2.1376399230957031e+02 -6.9971199035644531e+00 -1.4292199707031250e+02 2.0314100646972656e+02 -2.1460800170898438e+00 -1.3782699584960938e+02 2.1223100280761719e+02 -6.5780396461486816e+00 -1.3777600097656250e+02 2.1205599975585938e+02 -6.8286800384521484e+00 -1.3777301025390625e+02 2.1204699707031250e+02 3.0531499862670898e+01 -1.3820100402832031e+02 2.1352699279785156e+02 5.7017402648925781e+01 -1.3850000000000000e+02 2.1458399963378906e+02 2.6908599853515625e+01 -1.4464099121093750e+02 2.0235699462890625e+02 2.2319400787353516e+01 -1.5300000000000000e+02 1.8547200012207031e+02 1.8669300079345703e+01 -1.5987400817871094e+02 1.6808499145507812e+02 1.6007699966430664e+01 -1.6499499511718750e+02 1.5036801147460938e+02 1.4384200096130371e+01 -1.6809498596191406e+02 1.3249301147460938e+02 1.3834199905395508e+01 -1.6893998718261719e+02 1.1462599945068359e+02 -9.3725196838378906e+01 -7.5727905273437500e+01 -2.9128900146484375e+02 -9.3725196838378906e+01 -7.5727905273437500e+01 -3.4892999267578125e+02 -9.2556701660156250e+01 -7.9738105773925781e+01 -3.4892999267578125e+02 -8.6344200134277344e+01 -9.8116706848144531e+01 -3.4892999267578125e+02 -8.4573402404785156e+01 -1.0235500335693359e+02 -3.4892999267578125e+02 -9.3724899291992188e+01 -7.5728500366210938e+01 -6.5139602661132812e+01 -8.4675903320312500e+01 -1.0233000183105469e+02 -6.3664600372314453e+01 -9.3724899291992188e+01 -7.5728401184082031e+01 -6.3664600372314453e+01 -8.4724395751953125e+01 -1.0264600372314453e+02 7.8968101501464844e+01 -9.3725799560546875e+01 -7.5726898193359375e+01 7.8968101501464844e+01 -9.3725700378417969e+01 -7.5726997375488281e+01 4.7935199737548828e+01 -9.3725799560546875e+01 -7.5726799011230469e+01 1.0447299957275391e+02 -8.4701698303222656e+01 -1.0245600128173828e+02 1.1462599945068359e+02 -9.3689201354980469e+01 -7.5722396850585938e+01 1.1462599945068359e+02 -9.3664901733398438e+01 -7.5719497680664062e+01 1.2136600494384766e+02 -8.3847900390625000e+01 -1.0178600311279297e+02 1.3253199768066406e+02 -9.2733894348144531e+01 -7.5584899902343750e+01 1.3250799560546875e+02 -9.2589500427246094e+01 -7.5564102172851562e+01 1.3423599243164062e+02 -8.0761299133300781e+01 -1.0001199340820312e+02 1.5052198791503906e+02 -9.0000999450683594e+01 -7.5188194274902344e+01 1.4805099487304688e+02 -7.5570594787597656e+01 -9.7256698608398438e+01 1.6836700439453125e+02 -8.6002700805664062e+01 -7.4606796264648438e+01 1.6180000305175781e+02 -8.9309898376464844e+01 -7.5087699890136719e+01 1.5042700195312500e+02 -6.8436401367187500e+01 -9.3657997131347656e+01 1.8583300781250000e+02 -8.1836997985839844e+01 -7.4000503540039062e+01 1.7270100402832031e+02 -8.3554100036621094e+01 -7.4250396728515625e+01 1.6820800781250000e+02 -6.5702499389648438e+01 -7.1648300170898438e+01 2.0248100280761719e+02 -6.7795402526855469e+01 -7.1953903198242188e+01 1.9943299865722656e+02 -5.9519897460937500e+01 -8.9353302001953125e+01 2.0268598937988281e+02 -7.5413002014160156e+01 -7.3064796447753906e+01 1.8625601196289062e+02 -7.5693504333496094e+01 -7.3105606079101562e+01 1.8566400146484375e+02 -4.6668899536132812e+01 -1.0168600463867188e+02 2.1250399780273438e+02 -5.2511798858642578e+01 -8.8779800415039062e+01 2.1236099243164062e+02 -5.9022998809814453e+01 -7.0672805786132812e+01 2.1220800781250000e+02 -5.3414299011230469e+01 -8.6505195617675781e+01 2.1234098815917969e+02 -5.3314701080322266e+01 -8.6786201477050781e+01 2.1234400939941406e+02 -5.8990299224853516e+01 -1.1423400115966797e+02 1.8612500000000000e+02 -6.4866401672363281e+01 -1.2046899414062500e+02 1.6859500122070312e+02 -6.9194999694824219e+01 -1.2514199066162109e+02 1.5064599609375000e+02 -7.1835998535156250e+01 -1.2798300170898438e+02 1.3256298828125000e+02 -7.2674499511718750e+01 -1.2875500488281250e+02 1.1462599945068359e+02 -7.2801300048828125e+01 -1.2874099731445312e+02 7.8968101501464844e+01 -4.4533199310302734e+01 -1.3895899963378906e+02 1.8628599548339844e+02 -4.8055702209472656e+01 -1.3402099609375000e+02 1.8627899169921875e+02 -4.8984600067138672e+01 -1.4695199584960938e+02 1.6872100830078125e+02 -5.2634998321533203e+01 -1.4207200622558594e+02 1.6871499633789062e+02 -5.2169403076171875e+01 -1.5297399902343750e+02 1.5071499633789062e+02 -5.5958801269531250e+01 -1.4812399291992188e+02 1.5071099853515625e+02 -5.7923297882080078e+01 -1.5181900024414062e+02 1.3258000183105469e+02 -2.4858999252319336e+01 -1.3097700500488281e+02 2.1381799316406250e+02 -3.3548900604248047e+01 -1.3481399536132812e+02 2.0311300659179688e+02 -3.9544601440429688e+01 -1.4385198974609375e+02 1.8630300903320312e+02 -4.4253597259521484e+01 -1.5138598632812500e+02 1.6873399353027344e+02 -4.7599800109863281e+01 -1.5705999755859375e+02 1.5072200012207031e+02 -5.3999500274658203e+01 -1.5666400146484375e+02 1.3258099365234375e+02 -5.8446102142333984e+01 -1.5284100341796875e+02 1.1462599945068359e+02 -3.3476402282714844e+01 -1.4763101196289062e+02 1.8632400512695312e+02 -3.8672203063964844e+01 -1.5476199340820312e+02 1.6875000000000000e+02 -4.2366100311279297e+01 -1.6014399719238281e+02 1.5073100280761719e+02 -4.9507301330566406e+01 -1.6051499938964844e+02 1.3258300781250000e+02 -5.4408302307128906e+01 -1.5769999694824219e+02 1.1462599945068359e+02 -5.8440799713134766e+01 -1.5284500122070312e+02 7.8968101501464844e+01 -4.9991500854492188e+01 -1.6146199035644531e+02 -6.3664600372314453e+01 -3.9578998565673828e+01 -1.6626300048828125e+02 -6.3664600372314453e+01 -2.6843900680541992e+01 -1.6751899719238281e+02 7.8968101501464844e+01 -1.3443200111389160e+01 -1.6798699951171875e+02 1.1462599945068359e+02 -5.4468502044677734e+01 -1.5769299316406250e+02 -6.3664600372314453e+01 -4.9829402923583984e+01 -1.6139698791503906e+02 7.8968101501464844e+01 -4.4998600006103516e+01 -1.6426199340820312e+02 1.1462599945068359e+02 -3.8938602447509766e+01 -1.6538299560546875e+02 1.3258700561523438e+02 -2.6304800033569336e+01 -1.6661100769042969e+02 1.3258599853515625e+02 -1.2944000244140625e+01 -1.6708999633789062e+02 1.3256700134277344e+02 -3.6547000885009766e+01 -1.6216500854492188e+02 1.5073800659179688e+02 -2.3990400314331055e+01 -1.6334800720214844e+02 1.5073500061035156e+02 -3.2450099945068359e+01 -1.5691000366210938e+02 1.6876399230957031e+02 -1.9965600967407227e+01 -1.5806500244140625e+02 1.6875801086425781e+02 -2.6714500427246094e+01 -1.4998200988769531e+02 1.8634199523925781e+02 -1.4283499717712402e+01 -1.5113299560546875e+02 1.8633399963378906e+02 -2.1267700195312500e+00 -1.5167500305175781e+02 1.8616198730468750e+02 -7.2511000633239746e+00 -1.5860099792480469e+02 1.6862399291992188e+02 -1.0872200012207031e+01 -1.6385600280761719e+02 1.5066200256347656e+02 -5.8450302124023438e+01 -1.5283900451660156e+02 -6.3664600372314453e+01 -5.4326297760009766e+01 -1.5772200012207031e+02 7.8968101501464844e+01 -4.9922897338867188e+01 -1.6143299865722656e+02 1.1462599945068359e+02 -4.4489799499511719e+01 -1.6341699218750000e+02 1.3258500671386719e+02 -3.9561698913574219e+01 -1.6618699645996094e+02 -3.4892999267578125e+02 -3.8904399871826172e+01 -1.6641900634765625e+02 -3.4892999267578125e+02 -2.6903800964355469e+01 -1.6751701354980469e+02 -6.3664600372314453e+01 -3.7831199645996094e+01 -1.6665998840332031e+02 -3.4892999267578125e+02 -3.1097398757934570e+01 -1.6737100219726562e+02 -3.4892999267578125e+02 -2.6890100479125977e+01 -1.6751800537109375e+02 -3.4892999267578125e+02 -2.2828800201416016e+01 -1.6765899658203125e+02 -3.4892999267578125e+02 -1.3393699645996094e+01 -1.6798899841308594e+02 7.8968101501464844e+01 1.3864999771118164e+01 -1.6894100952148438e+02 -3.4892999267578125e+02 6.4709000587463379e+00 -1.6868301391601562e+02 -3.4892999267578125e+02 -1.3455699920654297e+01 -1.6798699951171875e+02 -3.4892999267578125e+02 -6.2954097747802734e+01 -1.4576600646972656e+02 -3.4892999267578125e+02 -4.5223701477050781e+01 -1.6418600463867188e+02 -3.4892999267578125e+02 -5.8364601135253906e+01 -1.5278599548339844e+02 -3.4892999267578125e+02 -5.7210800170898438e+01 -1.5455000305175781e+02 -3.4892999267578125e+02 -5.4294700622558594e+01 -1.5784100341796875e+02 -3.4892999267578125e+02 -4.9897903442382812e+01 -1.6137600708007812e+02 -3.4892999267578125e+02 -4.9068298339843750e+01 -1.6204299926757812e+02 -3.4892999267578125e+02 6.8196403503417969e+01 -1.2752700042724609e+02 2.2316799926757812e+02 5.6883899688720703e+01 -1.3160899353027344e+02 2.2106799316406250e+02 -5.8998397827148438e+01 -7.0668502807617188e+01 2.1224099731445312e+02 -5.5484100341796875e+01 -7.0026702880859375e+01 2.1586599731445312e+02 -4.4578102111816406e+01 -6.8040000915527344e+01 2.1988200378417969e+02 -4.8638103485107422e+01 -6.8781196594238281e+01 2.1927799987792969e+02 -4.9881500244140625e+01 -6.9007705688476562e+01 2.1890400695800781e+02 -4.7355400085449219e+01 -8.4313598632812500e+01 2.1788099670410156e+02 -5.2571899414062500e+01 -6.9496994018554688e+01 2.1756700134277344e+02 -5.4402702331542969e+01 -6.9830001831054688e+01 2.1665600585937500e+02 1.1819199562072754e+01 -1.3107701110839844e+02 2.1942900085449219e+02 -6.7166299819946289e+00 -1.3085299682617188e+02 2.1875900268554688e+02 -1.2629199981689453e+01 -1.2958300781250000e+02 2.1890998840332031e+02 -1.6924598693847656e+01 -1.2795199584960938e+02 2.1895399475097656e+02 -2.1697401046752930e+01 -1.2538099670410156e+02 2.1890998840332031e+02 -2.5155500411987305e+01 -1.2289900207519531e+02 2.1881500244140625e+02 -2.9305599212646484e+01 -1.1897899627685547e+02 2.1861599731445312e+02 -3.3220699310302734e+01 -1.1372599792480469e+02 2.1834300231933594e+02 -3.9294898986816406e+01 -1.0229399871826172e+02 2.1813800048828125e+02 -3.6637897491455078e+01 -1.0747099304199219e+02 2.1822700500488281e+02 -4.6573501586914062e+01 -8.6250099182128906e+01 2.1790499877929688e+02 5.7348098754882812e+01 -7.1410903930664062e+01 2.2556999206542969e+02 4.2865997314453125e+01 -4.9958499908447266e+01 2.2556999206542969e+02 3.3838199615478516e+01 -2.5700799942016602e+01 2.2556999206542969e+02 3.0771499633789062e+01 0.0000000000000000e+00 2.2556999206542969e+02 3.3838199615478516e+01 2.5700799942016602e+01 2.2556999206542969e+02 4.2865997314453125e+01 4.9958499908447266e+01 2.2556999206542969e+02 5.7348098754882812e+01 7.1410903930664062e+01 2.2556999206542969e+02 -9.7680702209472656e+01 -5.9071798324584961e+00 -7.6006797790527344e+01 -9.7325698852539062e+01 -5.8734998703002930e+00 -7.6131599426269531e+01 -9.7680702209472656e+01 -8.4883003234863281e+00 -7.6635200500488281e+01 -9.7325698852539062e+01 -8.3679504394531250e+00 -7.6741203308105469e+01 -9.7680702209472656e+01 -1.1105299949645996e+01 -7.7125900268554688e+01 -9.7325698852539062e+01 -1.0882999420166016e+01 -7.7221199035644531e+01 -9.7680702209472656e+01 -1.2311399459838867e+01 -7.7299201965332031e+01 -9.7325698852539062e+01 -1.2296299934387207e+01 -7.7427497863769531e+01 -9.7680702209472656e+01 -1.3913599967956543e+01 -7.7470100402832031e+01 -9.7325698852539062e+01 -1.3899600028991699e+01 -7.7598495483398438e+01 -9.7680702209472656e+01 -1.4342100143432617e+01 -7.7516502380371094e+01 -9.7325698852539062e+01 -1.4451099395751953e+01 -7.7657699584960938e+01 -9.7680702209472656e+01 -1.6965101242065430e+01 -7.7738502502441406e+01 -9.7325698852539062e+01 -1.7007900238037109e+01 -7.7870803833007812e+01 -9.7680702209472656e+01 -1.9586000442504883e+01 -7.7871704101562500e+01 -9.7325698852539062e+01 -1.9581100463867188e+01 -7.8000900268554688e+01 -9.7325698852539062e+01 -2.2896200180053711e+01 -7.7891700744628906e+01 -9.7325698852539062e+01 -2.5424299240112305e+01 -7.7447601318359375e+01 -9.7672096252441406e+01 -2.5394100189208984e+01 -7.7325096130371094e+01 -9.7680702209472656e+01 -2.2319400787353516e+01 -7.7816596984863281e+01 -9.7678604125976562e+01 -2.3858501434326172e+01 -7.7633499145507812e+01 -9.7325698852539062e+01 -2.1250400543212891e+01 -7.8006202697753906e+01 -9.7629798889160156e+01 -3.0028600692749023e+01 -7.4818901062011719e+01 -9.7629798889160156e+01 -3.0028701782226562e+01 -7.4818794250488281e+01 -9.7636001586914062e+01 -2.9535800933837891e+01 -7.5262893676757812e+01 -9.7662399291992188e+01 -2.6863201141357422e+01 -7.6857002258300781e+01 -9.7325698852539062e+01 -2.7440999984741211e+01 -7.6738998413085938e+01 -9.7650001525878906e+01 -2.8261100769042969e+01 -7.6168998718261719e+01 -9.7325698852539062e+01 -2.8850500106811523e+01 -7.5929702758789062e+01 -9.7325698852539062e+01 -3.0105701446533203e+01 -7.4898300170898438e+01 -9.7627799987792969e+01 -3.0190299987792969e+01 -7.4656700134277344e+01 -9.7325698852539062e+01 -3.2132396697998047e+01 -6.9299102783203125e+01 -9.7602302551269531e+01 -3.2031700134277344e+01 -6.9296997070312500e+01 -9.7602302551269531e+01 -3.2031200408935547e+01 -6.9324798583984375e+01 -9.7325698852539062e+01 -3.2061698913574219e+01 -7.0208900451660156e+01 -9.7604293823242188e+01 -3.1900100708007812e+01 -7.0189102172851562e+01 -9.7325599670410156e+01 -3.2011699676513672e+01 -7.0852897644042969e+01 -9.7609199523925781e+01 -3.1587198257446289e+01 -7.2250999450683594e+01 -9.7325698852539062e+01 -3.1312200546264648e+01 -7.3151496887207031e+01 -9.7612701416015625e+01 -3.1343299865722656e+01 -7.2899497985839844e+01 -9.7614402770996094e+01 -3.1214900970458984e+01 -7.3095100402832031e+01 -9.7325698852539062e+01 -3.1260099411010742e+01 -7.3322898864746094e+01 -9.7325698852539062e+01 -2.9618301391601562e+01 -6.1570598602294922e+01 -9.7637496948242188e+01 -2.9531299591064453e+01 -6.1643501281738281e+01 -9.7634498596191406e+01 -2.9760099411010742e+01 -6.2015602111816406e+01 -9.7603096008300781e+01 -3.1978801727294922e+01 -6.7635299682617188e+01 -9.7325698852539062e+01 -3.2114799499511719e+01 -6.8101799011230469e+01 -9.7611900329589844e+01 -3.1406297683715820e+01 -6.5296501159667969e+01 -9.7325698852539062e+01 -3.1532802581787109e+01 -6.5255996704101562e+01 -9.7615699768066406e+01 -3.1160799026489258e+01 -6.4293701171875000e+01 -9.7325698852539062e+01 -3.1401197433471680e+01 -6.4612701416015625e+01 -9.7325698852539062e+01 -2.9840900421142578e+01 -6.1950401306152344e+01 -9.7325698852539062e+01 -2.3280300140380859e+01 -5.7657100677490234e+01 -9.7680206298828125e+01 -2.3154800415039062e+01 -5.7757999420166016e+01 -9.7325698852539062e+01 -2.6630201339721680e+01 -5.9032299041748047e+01 -9.7665901184082031e+01 -2.6568799972534180e+01 -5.9139900207519531e+01 -9.7325698852539062e+01 -2.6743000030517578e+01 -5.9128097534179688e+01 -9.7664901733398438e+01 -2.6679199218750000e+01 -5.9233200073242188e+01 -9.7680702209472656e+01 -2.2800800323486328e+01 -5.7306400299072266e+01 -9.7325698852539062e+01 -2.2929201126098633e+01 -5.7206100463867188e+01 -9.7680702209472656e+01 -2.2696599960327148e+01 -4.3499801635742188e+01 -9.7325698852539062e+01 -2.2826999664306641e+01 -4.3642498016357422e+01 -9.7325698852539062e+01 -3.1753900527954102e+01 -4.5761600494384766e+01 -9.7580200195312500e+01 -3.1799200057983398e+01 -4.5680797576904297e+01 -9.7325698852539062e+01 -2.9086299896240234e+01 -4.4510902404785156e+01 -9.7641105651855469e+01 -2.8239299774169922e+01 -4.4086299896240234e+01 -9.7325698852539062e+01 -2.6277900695800781e+01 -4.3654399871826172e+01 -9.7666999816894531e+01 -2.5760099411010742e+01 -4.3414001464843750e+01 -9.7325698852539062e+01 -2.3401500701904297e+01 -4.3177299499511719e+01 -9.7679603576660156e+01 -2.3211500167846680e+01 -4.3028999328613281e+01 -9.7325698852539062e+01 -2.3344099044799805e+01 -4.3171497344970703e+01 -9.7325698852539062e+01 -3.8845401763916016e+01 -5.1755500793457031e+01 -9.7378997802734375e+01 -3.8860500335693359e+01 -5.1743297576904297e+01 -9.7325805664062500e+01 -3.6912601470947266e+01 -4.9614700317382812e+01 -9.7474502563476562e+01 -3.5963901519775391e+01 -4.8661300659179688e+01 -9.7325805664062500e+01 -3.4480998992919922e+01 -4.7531002044677734e+01 -9.7529998779296875e+01 -3.3961601257324219e+01 -4.7062797546386719e+01 -9.7352104187011719e+01 -3.9590797424316406e+01 -5.2718399047851562e+01 -9.7325805664062500e+01 -4.0273799896240234e+01 -5.3726799011230469e+01 -9.7325698852539062e+01 -4.0307201385498047e+01 -8.3678794860839844e+01 -9.7325698852539062e+01 -3.9604499816894531e+01 -8.4577903747558594e+01 -9.7370994567871094e+01 -3.9118900299072266e+01 -8.5170097351074219e+01 -9.7325698852539062e+01 -3.7577499389648438e+01 -8.6706497192382812e+01 -9.7433799743652344e+01 -3.7318099975585938e+01 -8.6990997314453125e+01 -9.7325698852539062e+01 -3.5270000457763672e+01 -8.8524993896484375e+01 -9.7495597839355469e+01 -3.5304798126220703e+01 -8.8576103210449219e+01 -9.7325698852539062e+01 -2.5577800750732422e+01 -9.2496398925781250e+01 -9.7668098449707031e+01 -2.5602300643920898e+01 -9.2618598937988281e+01 -9.7325805664062500e+01 -2.8338499069213867e+01 -9.1804695129394531e+01 -9.7641197204589844e+01 -2.8248699188232422e+01 -9.1951599121093750e+01 -9.7325805664062500e+01 -3.1029998779296875e+01 -9.0831298828125000e+01 -9.7601303100585938e+01 -3.0784599304199219e+01 -9.1042198181152344e+01 -9.7325698852539062e+01 -1.4034200668334961e+01 -9.2976196289062500e+01 -9.7680702209472656e+01 -1.4020899772644043e+01 -9.3104698181152344e+01 -9.7325698852539062e+01 -1.9549499511718750e+01 -9.3182098388671875e+01 -9.7680702209472656e+01 -1.9160099029541016e+01 -9.3321502685546875e+01 -9.7325698852539062e+01 -2.2564500808715820e+01 -9.2966896057128906e+01 -9.7680702209472656e+01 -2.2149200439453125e+01 -9.3141098022460938e+01 -9.7680702209472656e+01 -1.2365500450134277e+01 -9.2932899475097656e+01 -9.7325698852539062e+01 -1.2379599571228027e+01 -9.2804496765136719e+01 -9.7325698852539062e+01 -2.5854599475860596e-01 -8.9632598876953125e+01 -9.7680702209472656e+01 -2.0795699954032898e-01 -8.9751495361328125e+01 -9.7325805664062500e+01 -5.4240798950195312e+00 -9.1447097778320312e+01 -9.7680702209472656e+01 -5.0324802398681641e+00 -9.1469802856445312e+01 -9.7325698852539062e+01 -1.0770100593566895e+01 -9.2591003417968750e+01 -9.7680702209472656e+01 -1.0029899597167969e+01 -9.2604194641113281e+01 -9.7325698852539062e+01 9.7458906173706055e+00 -8.3190101623535156e+01 -9.7680702209472656e+01 9.8341102600097656e+00 -8.3284500122070312e+01 -9.7325805664062500e+01 5.3465399742126465e+00 -8.6645500183105469e+01 -9.7680702209472656e+01 5.8230199813842773e+00 -8.6482894897460938e+01 -9.7325805664062500e+01 2.6185500621795654e+00 -8.8260398864746094e+01 -9.7680702209472656e+01 2.9037599563598633e+00 -8.8253997802734375e+01 -9.7325698852539062e+01 1.6459100723266602e+01 -7.3712898254394531e+01 -9.7680702209472656e+01 1.6577199935913086e+01 -7.3765205383300781e+01 -9.7325897216796875e+01 1.3685899734497070e+01 -7.8651100158691406e+01 -9.7680595397949219e+01 1.4101699829101562e+01 -7.8271392822265625e+01 -9.7325805664062500e+01 1.1845899581909180e+01 -8.1012802124023438e+01 -9.7680702209472656e+01 1.2127099990844727e+01 -8.0883697509765625e+01 -9.7325698852539062e+01 1.8712301254272461e+01 -6.1415100097656250e+01 -9.7680702209472656e+01 1.8841499328613281e+01 -6.1412403106689453e+01 -9.7325897216796875e+01 1.8371799468994141e+01 -6.7086097717285156e+01 -9.7680595397949219e+01 1.8573999404907227e+01 -6.6586196899414062e+01 -9.7325897216796875e+01 1.8202400207519531e+01 -6.7866302490234375e+01 -9.7680595397949219e+01 1.8310998916625977e+01 -6.7886299133300781e+01 -9.7325805664062500e+01 1.7646699905395508e+01 -7.0426795959472656e+01 -9.7680702209472656e+01 1.7839500427246094e+01 -7.0217102050781250e+01 -9.7325698852539062e+01 1.6800399780273438e+01 -5.1956401824951172e+01 -9.7680702209472656e+01 1.6919000625610352e+01 -5.1905097961425781e+01 -9.7325698852539062e+01 1.7772199630737305e+01 -5.4711299896240234e+01 -9.7680702209472656e+01 1.7791900634765625e+01 -5.4313400268554688e+01 -9.7325805664062500e+01 1.8381299972534180e+01 -5.7542499542236328e+01 -9.7680702209472656e+01 1.8388999938964844e+01 -5.6814598083496094e+01 -9.7325698852539062e+01 1.1838500022888184e+01 -4.5002799987792969e+01 -9.7680702209472656e+01 1.1924200057983398e+01 -4.4906002044677734e+01 -9.7325698852539062e+01 1.3909000396728516e+01 -4.7156700134277344e+01 -9.7680702209472656e+01 1.3722599983215332e+01 -4.6732799530029297e+01 -9.7325698852539062e+01 1.5512499809265137e+01 -4.9440902709960938e+01 -9.7680702209472656e+01 1.5258199691772461e+01 -4.8789402008056641e+01 -9.7325698852539062e+01 4.3401699066162109e+00 -4.0762397766113281e+01 -9.7680702209472656e+01 4.3807597160339355e+00 -4.0639698028564453e+01 -9.7325805664062500e+01 7.0503296852111816e+00 -4.1848598480224609e+01 -9.7680702209472656e+01 6.7821097373962402e+00 -4.1580799102783203e+01 -9.7325805664062500e+01 9.5278606414794922e+00 -4.3239601135253906e+01 -9.7680595397949219e+01 9.0523395538330078e+00 -4.2785999298095703e+01 -9.7680702209472656e+01 7.0031696557998657e-01 -3.9713901519775391e+01 -9.7325698852539062e+01 1.5785100460052490e+00 -4.0016799926757812e+01 -9.7680702209472656e+01 -1.8505400419235229e+00 -3.9376800537109375e+01 -9.7325698852539062e+01 -1.2314900159835815e+00 -3.9567897796630859e+01 -9.7680702209472656e+01 -4.4281501770019531e+00 -3.9252502441406250e+01 -9.7325698852539062e+01 -4.0548400878906250e+00 -3.9387302398681641e+01 -9.7325698852539062e+01 -4.2971401214599609e+00 -3.9383300781250000e+01 -9.7680702209472656e+01 -4.9024200439453125e+00 -3.9722400665283203e+01 -9.7325698852539062e+01 -4.7731399536132812e+00 -3.9853099822998047e+01 -9.7680702209472656e+01 -4.9024200439453125e+00 -5.3340198516845703e+01 -9.7325698852539062e+01 -4.7731399536132812e+00 -5.3215702056884766e+01 -9.7325698852539062e+01 -1.0060698986053467e+00 -5.4106197357177734e+01 -9.7680702209472656e+01 -1.0338999032974243e+00 -5.4232398986816406e+01 -9.7325698852539062e+01 -2.2648000717163086e+00 -5.3875598907470703e+01 -9.7680702209472656e+01 -2.4302599430084229e+00 -5.3982299804687500e+01 -9.7325698852539062e+01 -3.5401599407196045e+00 -5.3731502532958984e+01 -9.7680702209472656e+01 -4.4483499526977539e+00 -5.3809799194335938e+01 -9.7325698852539062e+01 -4.3219900131225586e+00 -5.3685100555419922e+01 -9.7680702209472656e+01 7.1002401411533356e-02 -5.4533000946044922e+01 -9.7325805664062500e+01 2.6555198431015015e-01 -5.4461898803710938e+01 -9.7680702209472656e+01 1.1370199918746948e+00 -5.4944797515869141e+01 -9.7325805664062500e+01 1.4553699493408203e+00 -5.4951198577880859e+01 -9.7680702209472656e+01 2.5029201507568359e+00 -5.5694801330566406e+01 -9.7325698852539062e+01 2.5742001533508301e+00 -5.5587001800537109e+01 -9.7680702209472656e+01 3.4663701057434082e+00 -5.6449901580810547e+01 -9.7325698852539062e+01 3.5590498447418213e+00 -5.6359600067138672e+01 -9.7680702209472656e+01 4.2754998207092285e+00 -5.7330101013183594e+01 -9.7325698852539062e+01 4.3802800178527832e+00 -5.7254299163818359e+01 -9.7680702209472656e+01 4.9808001518249512e+00 -5.8408199310302734e+01 -9.7325698852539062e+01 5.0943498611450195e+00 -5.8346500396728516e+01 -9.7680801391601562e+01 5.4917297363281250e+00 -5.9587699890136719e+01 -9.7325599670410156e+01 5.5997400283813477e+00 -5.9503700256347656e+01 -9.7680801391601562e+01 5.8073401451110840e+00 -6.0795799255371094e+01 -9.7325599670410156e+01 5.9322099685668945e+00 -6.0760501861572266e+01 -9.7680702209472656e+01 5.9733400344848633e+00 -6.2003200531005859e+01 -9.7325698852539062e+01 6.1098299026489258e+00 -6.2085399627685547e+01 -9.7680702209472656e+01 6.0093398094177246e+00 -6.2541297912597656e+01 -9.7325698852539062e+01 6.1384401321411133e+00 -6.2536300659179688e+01 -9.7680702209472656e+01 5.9856801033020020e+00 -6.4036201477050781e+01 -9.7325698852539062e+01 6.1246700286865234e+00 -6.3873401641845703e+01 -9.7680702209472656e+01 5.6754899024963379e+00 -6.6103195190429688e+01 -9.7325698852539062e+01 5.8123502731323242e+00 -6.6134292602539062e+01 -9.7680702209472656e+01 5.6561198234558105e+00 -6.6232200622558594e+01 -9.7325698852539062e+01 5.8121700286865234e+00 -6.6135398864746094e+01 -9.7680702209472656e+01 4.4594397544860840e+00 -6.9104003906250000e+01 -9.7325698852539062e+01 4.5689897537231445e+00 -6.9172599792480469e+01 -9.7680702209472656e+01 3.3015599250793457e+00 -7.0688201904296875e+01 -9.7325698852539062e+01 3.4041399955749512e+00 -7.0766998291015625e+01 -9.7680702209472656e+01 1.9535398483276367e+00 -7.2059799194335938e+01 -9.7325698852539062e+01 2.0521299839019775e+00 -7.2145095825195312e+01 -9.7680702209472656e+01 9.8628401756286621e-02 -7.3436599731445312e+01 -9.7325698852539062e+01 1.6707399487495422e-01 -7.3546295166015625e+01 -9.7680702209472656e+01 -1.5506700277328491e+00 -7.4362503051757812e+01 -9.7325698852539062e+01 -1.5836900472640991e+00 -7.4523399353027344e+01 -9.7680702209472656e+01 -3.2579300403594971e+00 -7.5129096984863281e+01 -9.7325698852539062e+01 -3.4100399017333984e+00 -7.5327705383300781e+01 -9.6338699340820312e+01 -2.5959499359130859e+01 -4.5027496337890625e+01 -9.6338699340820312e+01 -2.4244501113891602e+01 -4.4703403472900391e+01 -9.6338699340820312e+01 -2.4333499908447266e+01 -5.6492500305175781e+01 -9.6338699340820312e+01 -2.8581800460815430e+01 -4.5827098846435547e+01 -9.6338699340820312e+01 -4.2664199829101562e+01 -6.3095703125000000e+01 -9.6338699340820312e+01 -3.2720302581787109e+01 -6.4115898132324219e+01 -9.6338699340820312e+01 -3.3522098541259766e+01 -6.8021995544433594e+01 -9.6338699340820312e+01 -3.8517601013183594e+01 -8.3680503845214844e+01 -9.6338699340820312e+01 -4.0769100189208984e+01 -8.0326400756835938e+01 -9.6338699340820312e+01 -3.1087299346923828e+01 -7.5909797668457031e+01 -9.6338699340820312e+01 -4.0769302368164062e+01 -8.0326202392578125e+01 -9.6338699340820312e+01 -3.2516502380371094e+01 -7.3961700439453125e+01 -9.6338699340820312e+01 -4.1891300201416016e+01 -7.7819496154785156e+01 -9.6338699340820312e+01 -3.3406299591064453e+01 -7.1057601928710938e+01 -9.6338699340820312e+01 -3.0697799682617188e+01 -6.0664199829101562e+01 -9.6338699340820312e+01 -3.5925300598144531e+01 -5.0620800018310547e+01 -9.6338699340820312e+01 -2.7348001480102539e+01 -5.7819297790527344e+01 -9.6338699340820312e+01 -3.3637599945068359e+01 -4.8660400390625000e+01 -9.6338699340820312e+01 -3.1064498901367188e+01 -4.6991001129150391e+01 -9.6338699340820312e+01 -4.1956302642822266e+01 -6.0503700256347656e+01 -9.6338699340820312e+01 -4.0987899780273438e+01 -5.7981098175048828e+01 -9.6338699340820312e+01 -3.0698101043701172e+01 -6.0664600372314453e+01 -9.6338699340820312e+01 -3.9758499145507812e+01 -5.5574302673339844e+01 -9.6338699340820312e+01 -3.7744602203369141e+01 -5.2635799407958984e+01 -9.6338699340820312e+01 -4.2881896972656250e+01 -7.4042900085449219e+01 -9.6338699340820312e+01 -4.3281997680664062e+01 -7.0166000366210938e+01 -9.6338699340820312e+01 -3.3541599273681641e+01 -6.9328498840332031e+01 -9.6338699340820312e+01 1.4303999900817871e+01 -5.0166500091552734e+01 -9.6338699340820312e+01 1.5506600379943848e+01 -5.2515800476074219e+01 -9.6338699340820312e+01 6.3328700065612793e+00 -5.7673599243164062e+01 -9.6338699340820312e+01 -4.3296897888183594e+01 -6.9705703735351562e+01 -9.6338699340820312e+01 -4.3297298431396484e+01 -6.8425903320312500e+01 -9.6338699340820312e+01 -4.3111099243164062e+01 -6.5745399475097656e+01 -9.6338699340820312e+01 -3.6628601074218750e+01 -8.5664199829101562e+01 -9.6338699340820312e+01 -2.9651601791381836e+01 -7.7089500427246094e+01 -9.6338699340820312e+01 -3.4477302551269531e+01 -8.7359504699707031e+01 -9.6338699340820312e+01 -2.8040100097656250e+01 -7.8014900207519531e+01 -9.6338699340820312e+01 -3.0479600906372070e+01 -8.9533699035644531e+01 -9.6338699340820312e+01 -2.5762699127197266e+01 -7.8815902709960938e+01 -9.6338699340820312e+01 -2.7929500579833984e+01 -9.0455703735351562e+01 -9.6338699340820312e+01 -3.3636100292205811e+00 -5.2331699371337891e+01 -9.6338699340820312e+01 -3.3636100292205811e+00 -4.0819297790527344e+01 -9.6338699340820312e+01 -2.0591599941253662e+00 -5.2481098175048828e+01 -9.6338699340820312e+01 -1.3850901126861572e+00 -4.0968997955322266e+01 -9.6338699340820312e+01 6.9327898025512695e+00 -5.9045799255371094e+01 -9.6338699340820312e+01 1.6414699554443359e+01 -5.5090801239013672e+01 -9.6338699340820312e+01 7.3158698081970215e+00 -6.0491901397705078e+01 -9.6338699340820312e+01 1.6988498687744141e+01 -5.7758701324462891e+01 -9.6338699340820312e+01 7.5148897171020508e+00 -6.1973300933837891e+01 -9.6338699340820312e+01 1.7303100585937500e+01 -6.1445301055908203e+01 -9.6338699340820312e+01 7.5470199584960938e+00 -6.2481700897216797e+01 -9.6338699340820312e+01 1.7303199768066406e+01 -6.1450000762939453e+01 -9.6338699340820312e+01 7.5322399139404297e+00 -6.3947902679443359e+01 -9.6338699340820312e+01 1.6978300094604492e+01 -6.6872901916503906e+01 -9.6338699340820312e+01 7.1848001480102539e+00 -6.6456001281738281e+01 -9.6338699340820312e+01 1.6291101455688477e+01 -7.0040397644042969e+01 -9.6338699340820312e+01 5.7635297775268555e+00 -6.9920898437500000e+01 -9.6338699340820312e+01 1.5170499801635742e+01 -7.3141700744628906e+01 -9.6338699340820312e+01 4.4787497520446777e+00 -7.1679100036621094e+01 -9.6338699340820312e+01 1.2529799461364746e+01 -7.7844596862792969e+01 -9.6338699340820312e+01 2.9850599765777588e+00 -7.3201698303222656e+01 -9.6338699340820312e+01 6.3322801589965820e+00 -5.7672401428222656e+01 -9.6338699340820312e+01 5.4919700622558594e+00 -5.6387802124023438e+01 -9.6338699340820312e+01 1.2817600250244141e+01 -4.8048599243164062e+01 -9.6338699340820312e+01 4.5170798301696777e+00 -5.5325599670410156e+01 -9.6338699340820312e+01 1.0904399871826172e+01 -4.6058300018310547e+01 -9.6338699340820312e+01 3.3521001338958740e+00 -5.4411602020263672e+01 -9.6338699340820312e+01 8.7556200027465820e+00 -4.4418800354003906e+01 -9.6338699340820312e+01 3.3495399951934814e+00 -5.4409900665283203e+01 -9.6338699340820312e+01 6.4434399604797363e+00 -4.3120800018310547e+01 -9.6338699340820312e+01 2.0710198879241943e+00 -5.3683200836181641e+01 -9.6338699340820312e+01 3.8968899250030518e+00 -4.2100399017333984e+01 -9.6338699340820312e+01 7.2250300645828247e-01 -5.3128398895263672e+01 -9.6338699340820312e+01 1.2856100797653198e+00 -4.1395599365234375e+01 -9.6338699340820312e+01 -7.0196002721786499e-01 -5.2729900360107422e+01 -9.6338699340820312e+01 -7.0332103967666626e-01 -5.2729598999023438e+01 -9.6338699340820312e+01 1.0781199455261230e+01 -8.0089096069335938e+01 -9.6338699340820312e+01 8.7837591171264648e+00 -8.2160003662109375e+01 -9.6338699340820312e+01 9.1300201416015625e-01 -7.4742195129394531e+01 -9.6338699340820312e+01 8.7836399078369141e+00 -8.2160102844238281e+01 -9.6338699340820312e+01 -9.5691198110580444e-01 -7.5786003112792969e+01 -9.6338699340820312e+01 4.5728702545166016e+00 -8.5467193603515625e+01 -9.6338699340820312e+01 -2.9004199504852295e+00 -7.6641899108886719e+01 -9.6338699340820312e+01 1.9565199613571167e+00 -8.7015998840332031e+01 -9.6338699340820312e+01 -8.1034398078918457e-01 -8.8335502624511719e+01 -9.6338699340820312e+01 -5.5069298744201660e+00 -7.7492599487304688e+01 -9.6338699340820312e+01 -8.1072801351547241e-01 -8.8335700988769531e+01 -9.6338699340820312e+01 -8.0671901702880859e+00 -7.8118301391601562e+01 -9.6338699340820312e+01 -5.8047199249267578e+00 -9.0089904785156250e+01 -9.6338699340820312e+01 -1.0656899452209473e+01 -7.8612495422363281e+01 -9.6338699340820312e+01 -1.0980100631713867e+01 -9.1197196960449219e+01 -9.6338699340820312e+01 -2.5299900054931641e+01 -9.1114501953125000e+01 -9.6338699340820312e+01 -2.3048599243164062e+01 -7.9292900085449219e+01 -9.6338699340820312e+01 -2.2406799316406250e+01 -9.1566200256347656e+01 -9.6338699340820312e+01 -2.1295598983764648e+01 -7.9415100097656250e+01 -9.6338699340820312e+01 -1.9505599975585938e+01 -9.1773193359375000e+01 -9.6338699340820312e+01 -1.9529600143432617e+01 -7.9409400939941406e+01 -9.6338699340820312e+01 -1.4178400039672852e+01 -9.1573997497558594e+01 -9.6338699340820312e+01 -1.6915599822998047e+01 -7.9277297973632812e+01 -9.6338699340820312e+01 -1.2532899856567383e+01 -9.1403297424316406e+01 -9.6338699340820312e+01 -1.4307100296020508e+01 -7.9059898376464844e+01 -9.6338699340820312e+01 -1.3746400833129883e+01 -7.8999694824218750e+01 -9.6338699340820312e+01 -1.2131099700927734e+01 -7.8827499389648438e+01 -9.7547203063964844e+01 3.2846698760986328e+01 -1.1789800262451172e+02 -9.7325698852539062e+01 3.2766201019287109e+01 -1.1783000183105469e+02 -9.7547203063964844e+01 3.2846698760986328e+01 -1.0327299499511719e+02 -9.7325698852539062e+01 3.2766201019287109e+01 -1.0336899566650391e+02 -9.7680702209472656e+01 1.8250999450683594e+01 -1.0524199676513672e+02 -9.7680702209472656e+01 2.2406698226928711e+01 -1.0450799560546875e+02 -9.7325698852539062e+01 1.8121799468994141e+01 -1.0539600372314453e+02 -9.7656196594238281e+01 2.7357601165771484e+01 -1.0364199829101562e+02 -9.7325698852539062e+01 3.2214599609375000e+01 -1.0290600585937500e+02 -9.7582496643066406e+01 3.2308002471923828e+01 -1.0279499816894531e+02 -9.7680702209472656e+01 1.7699399948120117e+01 -1.0477899932861328e+02 -9.7325698852539062e+01 1.7570199966430664e+01 -1.0493299865722656e+02 -9.7680702209472656e+01 1.7699399948120117e+01 -9.5614997863769531e+01 -9.7325698852539062e+01 1.7570199966430664e+01 -9.5768699645996094e+01 -9.7680702209472656e+01 1.7148799896240234e+01 -9.5152198791503906e+01 -9.7325698852539062e+01 1.7019599914550781e+01 -9.5305900573730469e+01 -9.7680702209472656e+01 6.4556598663330078e+00 -9.7018096923828125e+01 -9.7325698852539062e+01 6.5848798751831055e+00 -9.7126701354980469e+01 -9.7680702209472656e+01 6.0666198730468750e+00 -9.7480903625488281e+01 -9.7325698852539062e+01 6.1958398818969727e+00 -9.7589599609375000e+01 -9.7680702209472656e+01 6.0666198730468750e+00 -1.0697299957275391e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -1.0708200073242188e+02 -9.7680702209472656e+01 5.6753697395324707e+00 -1.0743600463867188e+02 -9.7325698852539062e+01 5.8046002388000488e+00 -1.0754600524902344e+02 -9.7680702209472656e+01 -2.2086101531982422e+01 -1.1214800262451172e+02 -9.7325698852539062e+01 -2.5084699630737305e+01 -1.1278800201416016e+02 -9.7678497314453125e+01 -2.3594400405883789e+01 -1.1240499877929688e+02 -9.7671600341796875e+01 -2.5102600097656250e+01 -1.1266400146484375e+02 -9.7325698852539062e+01 -2.9762100219726562e+01 -1.1229400634765625e+02 -9.7631095886230469e+01 -2.9711000442504883e+01 -1.1219499969482422e+02 -9.7325698852539062e+01 -2.8464799880981445e+01 -1.1273899841308594e+02 -9.7325698852539062e+01 -2.7723999023437500e+01 -1.1281900024414062e+02 -9.7668899536132812e+01 -2.5602899551391602e+01 -1.1271599578857422e+02 -9.7325698852539062e+01 -2.5568698883056641e+01 -1.1283899688720703e+02 -9.7655601501464844e+01 -2.7309398651123047e+01 -1.1276100158691406e+02 -9.7325599670410156e+01 -2.7059700012207031e+01 -1.1289100646972656e+02 -9.7651603698730469e+01 -2.7708299636840820e+01 -1.1269100189208984e+02 -9.7637397766113281e+01 -2.9122499465942383e+01 -1.1244300079345703e+02 -9.7631095886230469e+01 -2.9711099624633789e+01 -1.1219499969482422e+02 -9.7671905517578125e+01 -2.5102600097656250e+01 -1.1266300201416016e+02 -9.7611099243164062e+01 -3.1513500213623047e+01 -1.0809799957275391e+02 -9.7611198425292969e+01 -3.1513500213623047e+01 -1.0809799957275391e+02 -9.7612594604492188e+01 -3.1419601440429688e+01 -1.0918399810791016e+02 -9.7325698852539062e+01 -3.1617198944091797e+01 -1.0810499572753906e+02 -9.7625892639160156e+01 -3.0281501770019531e+01 -1.1179100036621094e+02 -9.7325698852539062e+01 -3.0437101364135742e+01 -1.1177500152587891e+02 -9.7625205993652344e+01 -3.0347301483154297e+01 -1.1169599914550781e+02 -9.7325698852539062e+01 -3.0494199752807617e+01 -1.1173100280761719e+02 -9.7619201660156250e+01 -3.0911199569702148e+01 -1.1087599945068359e+02 -9.7325698852539062e+01 -3.1023799896240234e+01 -1.1093399810791016e+02 -9.7618293762207031e+01 -3.0995401382446289e+01 -1.1075299835205078e+02 -9.7325698852539062e+01 -3.1041700363159180e+01 -1.1090700531005859e+02 -9.7615699768066406e+01 -3.1184900283813477e+01 -1.1005199432373047e+02 -9.7325698852539062e+01 -3.1273498535156250e+01 -1.1007600402832031e+02 -9.7325698852539062e+01 -3.1527797698974609e+01 -1.0916500091552734e+02 -9.7325698852539062e+01 -3.1587001800537109e+01 -1.0558200073242188e+02 -9.7611595153808594e+01 -3.1483697891235352e+01 -1.0559400177001953e+02 -9.7325698852539062e+01 -3.1645200729370117e+01 -1.0622000122070312e+02 -9.7610603332519531e+01 -3.1548700332641602e+01 -1.0634500122070312e+02 -9.7325698852539062e+01 -3.1668498992919922e+01 -1.0686199951171875e+02 -9.7610305786132812e+01 -3.1564798355102539e+01 -1.0709700012207031e+02 -9.7325698852539062e+01 -3.1657402038574219e+01 -1.0750699615478516e+02 -9.7610801696777344e+01 -3.1534101486206055e+01 -1.0784500122070312e+02 -9.7612800598144531e+01 -3.1410999298095703e+01 -1.0496600341796875e+02 -9.7325698852539062e+01 -3.1512300491333008e+01 -1.0493099975585938e+02 -9.7614402770996094e+01 -3.1311098098754883e+01 -1.0402600097656250e+02 -9.7325698852539062e+01 -3.1442701339721680e+01 -1.0428099822998047e+02 -9.7325698852539062e+01 -3.1428501129150391e+01 -1.0414200592041016e+02 -9.7586997985839844e+01 -3.1832199096679688e+01 -1.0352200317382812e+02 -9.7325698852539062e+01 -3.1938299179077148e+01 -1.0362699890136719e+02 -9.7477302551269531e+01 -3.6406200408935547e+01 -1.0397599792480469e+02 -9.7325698852539062e+01 -4.0979099273681641e+01 -1.0444499969482422e+02 -9.7325698852539062e+01 -3.9536499023437500e+01 -1.2524299621582031e+02 -9.7360496520996094e+01 -3.9544197082519531e+01 -1.2525300598144531e+02 -9.7325698852539062e+01 -4.0414699554443359e+01 -1.2448899841308594e+02 -9.7325805664062500e+01 -3.8214000701904297e+01 -1.2614099884033203e+02 -9.7426498413085938e+01 -3.7722301483154297e+01 -1.2645999908447266e+02 -9.7325897216796875e+01 -3.6802501678466797e+01 -1.2686899566650391e+02 -9.7483703613281250e+01 -3.5937500000000000e+01 -1.2728199005126953e+02 -9.7325698852539062e+01 -3.3993099212646484e+01 -1.2780399322509766e+02 -9.7536804199218750e+01 -3.4010700225830078e+01 -1.2787899017333984e+02 -9.7325698852539062e+01 -2.6839298248291016e+01 -1.2822500610351562e+02 -9.7660499572753906e+01 -2.6824199676513672e+01 -1.2834500122070312e+02 -9.7325698852539062e+01 -2.8111700057983398e+01 -1.2830500793457031e+02 -9.7636703491210938e+01 -2.8884399414062500e+01 -1.2843899536132812e+02 -9.7325698852539062e+01 -3.1045900344848633e+01 -1.2825599670410156e+02 -9.7593597412109375e+01 -3.1474098205566406e+01 -1.2831599426269531e+02 -9.7661003112792969e+01 -2.6824199676513672e+01 -1.2834599304199219e+02 -9.7675704956054688e+01 -2.4640298843383789e+01 -1.2799500274658203e+02 -9.7680702209472656e+01 -2.2394298553466797e+01 -1.2763099670410156e+02 -9.7325698852539062e+01 5.6504597663879395e+00 -1.2293299865722656e+02 -9.7680702209472656e+01 5.5212402343750000e+00 -1.2308499908447266e+02 -9.7680702209472656e+01 6.0666198730468750e+00 -1.2354899597167969e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -1.2339700317382812e+02 -9.7680702209472656e+01 6.0666198730468750e+00 -1.3117500305175781e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -1.3102099609375000e+02 -9.7680702209472656e+01 6.6172499656677246e+00 -1.3163800048828125e+02 -9.7325698852539062e+01 6.7464699745178223e+00 -1.3148400878906250e+02 -9.7680702209472656e+01 1.7310300827026367e+01 -1.2977099609375000e+02 -9.7325698852539062e+01 1.7181100845336914e+01 -1.2966300964355469e+02 -9.7680702209472656e+01 1.7699399948120117e+01 -1.2930799865722656e+02 -9.7325698852539062e+01 1.7570199966430664e+01 -1.2919999694824219e+02 -9.7680702209472656e+01 1.7699399948120117e+01 -1.2135800170898438e+02 -9.7325698852539062e+01 1.7570199966430664e+01 -1.2124900054931641e+02 -9.7680702209472656e+01 2.2083200454711914e+01 -1.2020400238037109e+02 -9.7680702209472656e+01 1.8089199066162109e+01 -1.2089499664306641e+02 -9.7325698852539062e+01 1.7960000991821289e+01 -1.2078599548339844e+02 -9.7653701782226562e+01 2.7274999618530273e+01 -1.1929699707031250e+02 -9.7325698852539062e+01 3.2376300811767578e+01 -1.1829399871826172e+02 -9.7572700500488281e+01 3.2466197967529297e+01 -1.1836899566650391e+02 -9.6338699340820312e+01 1.6160600662231445e+01 -1.1966699981689453e+02 -9.6338699340820312e+01 1.6160600662231445e+01 -1.2841000366210938e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -1.2990299987792969e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -1.0867000579833984e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -9.8379501342773438e+01 -9.6338699340820312e+01 1.6160600662231445e+01 -9.6886596679687500e+01 -9.6338699340820312e+01 3.1356599807739258e+01 -1.0448899841308594e+02 -9.6338699340820312e+01 3.1356599807739258e+01 -1.1703900146484375e+02 -9.6338699340820312e+01 1.6160600662231445e+01 -1.0717400360107422e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -1.2118700408935547e+02 -9.6338699340820312e+01 -3.0411899566650391e+01 -1.1354499816894531e+02 -9.6338699340820312e+01 -3.6229400634765625e+01 -1.2558099365234375e+02 -9.6338699340820312e+01 -3.7495300292968750e+01 -1.2492799377441406e+02 -9.6338699340820312e+01 -3.3670700073242188e+01 -1.2643199920654297e+02 -9.6338699340820312e+01 -2.8748798370361328e+01 -1.1411900329589844e+02 -9.6338699340820312e+01 -3.0934499740600586e+01 -1.2685100555419922e+02 -9.6338699340820312e+01 -4.2990600585937500e+01 -1.1569300079345703e+02 -9.6338699340820312e+01 -4.3124702453613281e+01 -1.1353299713134766e+02 -9.6338699340820312e+01 -3.2312999725341797e+01 -1.1151599884033203e+02 -9.6338699340820312e+01 -4.3131797790527344e+01 -1.1310199737548828e+02 -9.6338699340820312e+01 -3.2923999786376953e+01 -1.0935799407958984e+02 -9.6338699340820312e+01 -4.2598400115966797e+01 -1.1786299896240234e+02 -9.6338699340820312e+01 -3.1531299591064453e+01 -1.1268599700927734e+02 -9.6338699340820312e+01 -4.1880500793457031e+01 -1.1995299530029297e+02 -9.6338699340820312e+01 -2.8169399261474609e+01 -1.2689701080322266e+02 -9.6338699340820312e+01 -2.7098400115966797e+01 -1.1429999542236328e+02 -9.6338699340820312e+01 -2.7012199401855469e+01 -1.2682500457763672e+02 -9.6338699340820312e+01 -3.8673797607421875e+01 -1.2412799835205078e+02 -9.6338699340820312e+01 -4.0400299072265625e+01 -1.2241999816894531e+02 -9.6338699340820312e+01 -4.1218002319335938e+01 -1.2123200225830078e+02 -9.6338699340820312e+01 -2.4884300231933594e+01 -1.1418399810791016e+02 -9.6338699340820312e+01 -2.5443300247192383e+01 -1.1424300384521484e+02 -9.6338699340820312e+01 -3.2953697204589844e+01 -1.0513400268554688e+02 -9.6338699340820312e+01 -3.2986598968505859e+01 -1.0541500091552734e+02 -9.6338699340820312e+01 -4.2238700866699219e+01 -1.0597499847412109e+02 -9.6338699340820312e+01 -3.3052001953125000e+01 -1.0613100433349609e+02 -9.6338699340820312e+01 -4.2363498687744141e+01 -1.0643900299072266e+02 -9.6338699340820312e+01 -3.3077999114990234e+01 -1.0684899902343750e+02 -9.6338699340820312e+01 -4.2662597656250000e+01 -1.0775800323486328e+02 -9.6338699340820312e+01 -3.3065597534179688e+01 -1.0756800079345703e+02 -9.6338699340820312e+01 -4.2883899688720703e+01 -1.0909199523925781e+02 -9.6338699340820312e+01 -3.3024299621582031e+01 -1.0819499969482422e+02 -9.6338699340820312e+01 -4.3030601501464844e+01 -1.1042299652099609e+02 -9.6338699340820312e+01 -4.3112899780273438e+01 -1.1176200103759766e+02 -9.6338699340820312e+01 -8.9194192886352539e+00 -1.5315901184082031e+02 -9.6338699340820312e+01 -8.9194192886352539e+00 -1.7944499206542969e+02 -9.6338699340820312e+01 -1.6560400009155273e+01 -1.7967799377441406e+02 -9.6338699340820312e+01 -2.3711898803710938e+01 -1.9187300109863281e+02 -9.6338699340820312e+01 -1.8398401260375977e+01 -1.7979299926757812e+02 -9.6338699340820312e+01 -2.1183698654174805e+01 -1.7974800109863281e+02 -9.6338699340820312e+01 -3.9666297912597656e+01 -1.8133300781250000e+02 -9.6338699340820312e+01 -3.0834300994873047e+01 -1.7484599304199219e+02 -9.6338699340820312e+01 -3.8113998413085938e+01 -1.8356401062011719e+02 -9.6338699340820312e+01 -2.9869598388671875e+01 -1.7595300292968750e+02 -9.6338699340820312e+01 -3.5073001861572266e+01 -1.8670300292968750e+02 -9.6338699340820312e+01 -2.8770898818969727e+01 -1.7692700195312500e+02 -9.6338699340820312e+01 -3.5072402954101562e+01 -1.8670300292968750e+02 -9.6338699340820312e+01 -2.6640298843383789e+01 -1.7826300048828125e+02 -9.6338699340820312e+01 -3.1567699432373047e+01 -1.5758801269531250e+02 -9.6338699340820312e+01 -3.2577297210693359e+01 -1.6017199707031250e+02 -9.6338699340820312e+01 -4.0890701293945312e+01 -1.5541000366210938e+02 -9.6338699340820312e+01 -3.3198699951171875e+01 -1.6287599182128906e+02 -9.6338699340820312e+01 -4.2325000762939453e+01 -1.5981399536132812e+02 -9.6338699340820312e+01 -4.1804000854492188e+01 -1.5792498779296875e+02 -9.6338699340820312e+01 -3.3437599182128906e+01 -1.6563899230957031e+02 -9.6338699340820312e+01 -4.2721599578857422e+01 -1.6174200439453125e+02 -9.6338699340820312e+01 -4.2721500396728516e+01 -1.6174099731445312e+02 -9.6338699340820312e+01 -2.3930400848388672e+01 -1.7927000427246094e+02 -9.6338699340820312e+01 -2.6333398818969727e+01 -1.9126600646972656e+02 -9.6338699340820312e+01 -2.5310499191284180e+01 -1.7883700561523438e+02 -9.6338699340820312e+01 -3.0525300979614258e+01 -1.8966500854492188e+02 -9.6338699340820312e+01 -3.2889701843261719e+01 -1.8832400512695312e+02 -9.6338699340820312e+01 8.9934998750686646e-01 -1.7465299987792969e+02 -9.6338699340820312e+01 6.0266799926757812e+00 -1.8462899780273438e+02 -9.6338699340820312e+01 -1.5370800495147705e+00 -1.7615100097656250e+02 -9.6338699340820312e+01 3.4185597896575928e+00 -1.8642599487304688e+02 -9.6338699340820312e+01 -1.5371400117874146e+00 -1.7615100097656250e+02 -9.6338699340820312e+01 1.3674500465393066e+01 -1.7602400207519531e+02 -9.6338699340820312e+01 1.2036100387573242e+01 -1.7853599548339844e+02 -9.6338699340820312e+01 3.0739300251007080e+00 -1.7287699890136719e+02 -9.6338699340820312e+01 8.4684495925903320e+00 -1.8256401062011719e+02 -9.6338699340820312e+01 8.4683303833007812e+00 -1.8256500244140625e+02 -9.6338699340820312e+01 -4.0096599578857422e+01 -1.5368600463867188e+02 -9.6338699340820312e+01 -3.9180301666259766e+01 -1.5203500366210938e+02 -9.6338699340820312e+01 -3.0267499923706055e+01 -1.5520599365234375e+02 -9.6338699340820312e+01 1.6740400314331055e+01 -1.6816299438476562e+02 -9.6338699340820312e+01 1.5062999725341797e+01 -1.7332998657226562e+02 -9.6338699340820312e+01 6.4019598960876465e+00 -1.6835198974609375e+02 -9.6338699340820312e+01 -3.4106498718261719e+01 -1.4624198913574219e+02 -9.6338699340820312e+01 -2.7488998413085938e+01 -1.5150299072265625e+02 -9.6338699340820312e+01 -3.5846698760986328e+01 -1.4775100708007812e+02 -9.6338699340820312e+01 -2.8719200134277344e+01 -1.5297601318359375e+02 -9.6338699340820312e+01 -3.7661399841308594e+01 -1.4980700683593750e+02 -9.6338699340820312e+01 -3.7661499023437500e+01 -1.4980700683593750e+02 -9.6338699340820312e+01 -4.0950397491455078e+01 -1.7893800354003906e+02 -9.6338699340820312e+01 -4.0950500488281250e+01 -1.7893800354003906e+02 -9.6338699340820312e+01 -3.2134201049804688e+01 -1.7273100280761719e+02 -9.6338699340820312e+01 -4.1973098754882812e+01 -1.7633799743652344e+02 -9.6338699340820312e+01 -3.2693500518798828e+01 -1.7136999511718750e+02 -9.6338699340820312e+01 -4.2669696807861328e+01 -1.7367201232910156e+02 -9.6338699340820312e+01 -3.3234996795654297e+01 -1.6915098571777344e+02 -9.6338699340820312e+01 -4.3238899230957031e+01 -1.6826499938964844e+02 -9.6338699340820312e+01 -3.3427101135253906e+01 -1.6691799926757812e+02 -9.6338699340820312e+01 -4.3214298248291016e+01 -1.6631600952148438e+02 -9.6338699340820312e+01 -4.3078601837158203e+01 -1.6437800598144531e+02 -9.6338699340820312e+01 4.9439702033996582e+00 -1.7077600097656250e+02 -9.6338699340820312e+01 5.7295002937316895e+00 -1.6959799194335938e+02 -9.6338699340820312e+01 6.4015998840332031e+00 -1.6835301208496094e+02 -9.6338699340820312e+01 7.0993900299072266e+00 -1.6650700378417969e+02 -9.6338699340820312e+01 7.4903402328491211e+00 -1.6457499694824219e+02 -9.6338699340820312e+01 1.7293399810791016e+01 -1.6348298645019531e+02 -9.6338699340820312e+01 7.6081099510192871e+00 -1.6260899353027344e+02 -9.6338699340820312e+01 1.7302999496459961e+01 -1.6153498840332031e+02 -9.6338699340820312e+01 7.6045999526977539e+00 -1.6229699707031250e+02 -9.6338699340820312e+01 1.7296699523925781e+01 -1.6124400329589844e+02 -9.6338699340820312e+01 7.5591797828674316e+00 -1.6160299682617188e+02 -9.6338699340820312e+01 1.6757900238037109e+01 -1.5645100402832031e+02 -9.6338699340820312e+01 7.3503799438476562e+00 -1.6011399841308594e+02 -9.6338699340820312e+01 6.9649801254272461e+00 -1.5865899658203125e+02 -9.6338699340820312e+01 1.6008699417114258e+01 -1.5379499816894531e+02 -9.6338699340820312e+01 6.3745398521423340e+00 -1.5727299499511719e+02 -9.6338699340820312e+01 1.4870500564575195e+01 -1.5127900695800781e+02 -9.6338699340820312e+01 6.3738198280334473e+00 -1.5727200317382812e+02 -9.6338699340820312e+01 1.3378600120544434e+01 -1.4897200012207031e+02 -9.6338699340820312e+01 5.5050196647644043e+00 -1.5590299987792969e+02 -9.6338699340820312e+01 1.1573400497436523e+01 -1.4689799499511719e+02 -9.6338699340820312e+01 4.4459099769592285e+00 -1.5474200439453125e+02 -9.6338699340820312e+01 8.7109804153442383e+00 -1.4459100341796875e+02 -9.6338699340820312e+01 3.3094899654388428e+00 -1.5386399841308594e+02 -9.6338699340820312e+01 6.3427100181579590e+00 -1.4324900817871094e+02 -9.6338699340820312e+01 1.9167100191116333e+00 -1.5311999511718750e+02 -9.6338699340820312e+01 3.8297200202941895e+00 -1.4220500183105469e+02 -9.6338699340820312e+01 4.6005499362945557e-01 -1.5262100219726562e+02 -9.6338699340820312e+01 -2.8370100259780884e-01 -1.4113900756835938e+02 -9.6338699340820312e+01 -1.0356299877166748e+00 -1.5233500671386719e+02 -9.6338699340820312e+01 -2.9172298908233643e+00 -1.4077499389648438e+02 -9.6338699340820312e+01 -1.0358099937438965e+00 -1.5233500671386719e+02 -9.6338699340820312e+01 -2.4470100402832031e+00 -1.5222700500488281e+02 -9.6338699340820312e+01 -3.8618998527526855e+00 -1.5224899291992188e+02 -9.6338699340820312e+01 -8.2441596984863281e+00 -1.4063699340820312e+02 -9.6338699340820312e+01 -1.3150700569152832e+01 -1.9194898986816406e+02 -9.6338699340820312e+01 -1.5424099922180176e+01 -1.9217700195312500e+02 -9.6338699340820312e+01 -1.8854801177978516e+01 -1.9232099914550781e+02 -9.6338699340820312e+01 -5.2697596549987793e+00 -1.5238999938964844e+02 -9.6338699340820312e+01 -5.9449701309204102e+00 -1.5249699401855469e+02 -9.6338699340820312e+01 -1.1073299407958984e+01 -1.4086500549316406e+02 -9.6338699340820312e+01 -1.6560400009155273e+01 -1.4171299743652344e+02 -9.6338699340820312e+01 -3.8879499435424805e+00 -1.7732598876953125e+02 -9.6338699340820312e+01 -1.3272799253463745e+00 -1.8888301086425781e+02 -9.6338699340820312e+01 -6.2943701744079590e+00 -1.7838299560546875e+02 -9.6338699340820312e+01 -1.3275699615478516e+00 -1.8888301086425781e+02 -9.6338699340820312e+01 -8.7302303314208984e+00 -1.7936900329589844e+02 -9.6338699340820312e+01 -6.3213100433349609e+00 -1.9064399719238281e+02 -9.6338699340820312e+01 -1.1501099586486816e+01 -1.9174099731445312e+02 -9.7680702209472656e+01 -1.3724100776016712e-02 -1.3962399291992188e+02 -9.7325698852539062e+01 -3.6354899406433105e-02 -1.3975100708007812e+02 -9.7325698852539062e+01 -2.7774000167846680e+00 -1.3937200927734375e+02 -9.7680702209472656e+01 -5.1137800216674805e+00 -1.3908399963378906e+02 -9.7325698852539062e+01 -8.3077507019042969e+00 -1.3922900390625000e+02 -9.7680702209472656e+01 -1.0249099731445312e+01 -1.3923298645019531e+02 -9.7325698852539062e+01 -1.1262199401855469e+01 -1.3946800231933594e+02 -9.7680702209472656e+01 -1.1279500007629395e+01 -1.3933999633789062e+02 -9.7680702209472656e+01 -1.7701000213623047e+01 -1.4033200073242188e+02 -9.7325698852539062e+01 -1.7571701049804688e+01 -1.4044299316406250e+02 -9.7680702209472656e+01 -1.8099100112915039e+01 -1.4079699707031250e+02 -9.7325698852539062e+01 -1.7969900131225586e+01 -1.4090699768066406e+02 -9.7680702209472656e+01 -1.8099100112915039e+01 -1.7779000854492188e+02 -9.7325698852539062e+01 -1.7969900131225586e+01 -1.7791200256347656e+02 -9.7325698852539062e+01 -2.3572401046752930e+01 -1.7790699768066406e+02 -9.7679603576660156e+01 -2.3539800643920898e+01 -1.7778199768066406e+02 -9.7680702209472656e+01 -2.2409999847412109e+01 -1.7803099060058594e+02 -9.7325698852539062e+01 -2.1056400299072266e+01 -1.7834399414062500e+02 -9.7680702209472656e+01 -1.9698200225830078e+01 -1.7828300476074219e+02 -9.7325698852539062e+01 -1.8474899291992188e+01 -1.7838500976562500e+02 -9.7680702209472656e+01 -1.8545000076293945e+01 -1.7825900268554688e+02 -9.7325698852539062e+01 -1.8412700653076172e+01 -1.7838198852539062e+02 -9.7674896240234375e+01 -2.4968299865722656e+01 -1.7732299804687500e+02 -9.7325805664062500e+01 -2.4821498870849609e+01 -1.7751499938964844e+02 -9.7666702270507812e+01 -2.6439399719238281e+01 -1.7663600158691406e+02 -9.7325897216796875e+01 -2.6012699127197266e+01 -1.7700100708007812e+02 -9.7655601501464844e+01 -2.7831901550292969e+01 -1.7571899414062500e+02 -9.7325698852539062e+01 -2.7905599594116211e+01 -1.7581399536132812e+02 -9.7644004821777344e+01 -2.8983200073242188e+01 -1.7467401123046875e+02 -9.7325698852539062e+01 -2.8868600845336914e+01 -1.7496000671386719e+02 -9.7632293701171875e+01 -2.9968601226806641e+01 -1.7344699096679688e+02 -9.7325698852539062e+01 -2.9715101242065430e+01 -1.7398899841308594e+02 -9.7621597290039062e+01 -3.0770299911499023e+01 -1.7206700134277344e+02 -9.7325698852539062e+01 -3.0867099761962891e+01 -1.7211399841308594e+02 -9.7613197326660156e+01 -3.1343799591064453e+01 -1.7062500000000000e+02 -9.7325698852539062e+01 -3.1358901977539062e+01 -1.7091600036621094e+02 -9.7607704162597656e+01 -3.1704198837280273e+01 -1.6913800048828125e+02 -9.7325698852539062e+01 -3.1842599868774414e+01 -1.6893099975585938e+02 -9.7604797363281250e+01 -3.1883798599243164e+01 -1.6763999938964844e+02 -9.7325698852539062e+01 -3.2018100738525391e+01 -1.6687800598144531e+02 -9.7604293823242188e+01 -3.1916700363159180e+01 -1.6687500000000000e+02 -9.7325698852539062e+01 -3.0295999526977539e+01 -1.5819599914550781e+02 -9.7630203247070312e+01 -3.0196100234985352e+01 -1.5824400329589844e+02 -9.7325698852539062e+01 -3.1230098724365234e+01 -1.6058699035644531e+02 -9.7615501403808594e+01 -3.1218200683593750e+01 -1.6091600036621094e+02 -9.7325698852539062e+01 -3.1805898666381836e+01 -1.6309300231933594e+02 -9.7606399536132812e+01 -3.1788799285888672e+01 -1.6371299743652344e+02 -9.7325698852539062e+01 -3.2028400421142578e+01 -1.6566799926757812e+02 -9.7604103088378906e+01 -3.1926401138305664e+01 -1.6654800415039062e+02 -9.7646804809570312e+01 -2.8850000381469727e+01 -1.5581799316406250e+02 -9.7325805664062500e+01 -2.9068500518798828e+01 -1.5594700622558594e+02 -9.7661598205566406e+01 -2.7332500457763672e+01 -1.5369000244140625e+02 -9.7325805664062500e+01 -2.7605199813842773e+01 -1.5384001159667969e+02 -9.7673599243164062e+01 -2.5584400177001953e+01 -1.5171598815917969e+02 -9.7325698852539062e+01 -2.5927700042724609e+01 -1.5188899230957031e+02 -9.7325698852539062e+01 -2.5770999908447266e+01 -1.5172599792480469e+02 -9.7672904968261719e+01 -2.5628398895263672e+01 -1.5102000427246094e+02 -9.7325698852539062e+01 -2.5816400527954102e+01 -1.5103199768066406e+02 -9.7633300781250000e+01 -2.9709299087524414e+01 -1.4779399108886719e+02 -9.7325698852539062e+01 -3.3792701721191406e+01 -1.4469100952148438e+02 -9.7560302734375000e+01 -3.3789703369140625e+01 -1.4458399963378906e+02 -9.7325805664062500e+01 -3.6833202362060547e+01 -1.4674400329589844e+02 -9.7325698852539062e+01 -3.8782398223876953e+01 -1.4895300292968750e+02 -9.7380699157714844e+01 -3.8798202514648438e+01 -1.4894000244140625e+02 -9.7380699157714844e+01 -3.8798297882080078e+01 -1.4894000244140625e+02 -9.7421699523925781e+01 -3.7624797821044922e+01 -1.4751300048828125e+02 -9.7463195800781250e+01 -3.6339099884033203e+01 -1.4620800781250000e+02 -9.7325698852539062e+01 -3.4585300445556641e+01 -1.4483999633789062e+02 -9.7520301818847656e+01 -3.4353698730468750e+01 -1.4458599853515625e+02 -9.7325698852539062e+01 -3.4357200622558594e+01 -1.4467500305175781e+02 -9.7326797485351562e+01 -4.0235000610351562e+01 -1.5105799865722656e+02 -9.7325698852539062e+01 -4.0262798309326172e+01 -1.5110400390625000e+02 -9.7350997924804688e+01 -3.9625701904296875e+01 -1.8392500305175781e+02 -9.7325698852539062e+01 -4.0284000396728516e+01 -1.8297999572753906e+02 -9.7325698852539062e+01 -3.9220001220703125e+01 -1.8443800354003906e+02 -9.7469703674316406e+01 -3.6144302368164062e+01 -1.8771099853515625e+02 -9.7473503112792969e+01 -3.6016098022460938e+01 -1.8782200622558594e+02 -9.7325698852539062e+01 -3.5981300354003906e+01 -1.8778100585937500e+02 -9.7473503112792969e+01 -3.6015998840332031e+01 -1.8782200622558594e+02 -9.7325698852539062e+01 -2.6720701217651367e+01 -1.9262098693847656e+02 -9.7657897949218750e+01 -2.6753999710083008e+01 -1.9273699951171875e+02 -9.7325897216796875e+01 -3.1146400451660156e+01 -1.9092999267578125e+02 -9.7585502624511719e+01 -3.1553901672363281e+01 -1.9083200073242188e+02 -9.7325805664062500e+01 -3.3658298492431641e+01 -1.8950498962402344e+02 -9.7506698608398438e+01 -3.4858398437500000e+01 -1.8875199890136719e+02 -9.7674896240234375e+01 -2.4465700149536133e+01 -1.9329499816894531e+02 -9.7325805664062500e+01 -2.3961198806762695e+01 -1.9325999450683594e+02 -9.7680702209472656e+01 -2.2136098861694336e+01 -1.9365899658203125e+02 -9.7325805664062500e+01 -1.8869201660156250e+01 -1.9373098754882812e+02 -9.7680702209472656e+01 -1.6982999801635742e+01 -1.9382600402832031e+02 -9.7325698852539062e+01 -1.5289099693298340e+01 -1.9358000183105469e+02 -9.7680702209472656e+01 -1.5276700019836426e+01 -1.9370800781250000e+02 -9.7680702209472656e+01 -1.2992799758911133e+01 -1.9347999572753906e+02 -9.7325698852539062e+01 -1.3006100654602051e+01 -1.9335200500488281e+02 -9.7325698852539062e+01 -7.7362799644470215e-01 -1.9018000793457031e+02 -9.7680702209472656e+01 -7.2286802530288696e-01 -1.9029800415039062e+02 -9.7325805664062500e+01 -5.9405002593994141e+00 -1.9200100708007812e+02 -9.7680702209472656e+01 -5.5456700325012207e+00 -1.9202200317382812e+02 -9.7325698852539062e+01 -1.1297499656677246e+01 -1.9313600158691406e+02 -9.7680702209472656e+01 -1.0542699813842773e+01 -1.9314999389648438e+02 -9.7325698852539062e+01 9.4313602447509766e+00 -1.8359400939941406e+02 -9.7680702209472656e+01 9.5196399688720703e+00 -1.8368800354003906e+02 -9.7325805664062500e+01 6.8818898200988770e+00 -1.8575000000000000e+02 -9.7680702209472656e+01 5.5165300369262695e+00 -1.8689500427246094e+02 -9.7325805664062500e+01 4.1613602638244629e+00 -1.8762399291992188e+02 -9.7680702209472656e+01 2.4984500408172607e+00 -1.8874000549316406e+02 -9.7325698852539062e+01 1.6346300125122070e+01 -1.7391299438476562e+02 -9.7680702209472656e+01 1.6463899612426758e+01 -1.7396701049804688e+02 -9.7325805664062500e+01 1.4893399238586426e+01 -1.7673200988769531e+02 -9.7680595397949219e+01 1.3967400550842285e+01 -1.7845899963378906e+02 -9.7325897216796875e+01 1.3175000190734863e+01 -1.7936700439453125e+02 -9.7680702209472656e+01 1.1908500671386719e+01 -1.8118399047851562e+02 -9.7680702209472656e+01 1.8111198425292969e+01 -1.6909500122070312e+02 -9.7325698852539062e+01 1.8120599746704102e+01 -1.6844900512695312e+02 -9.7680702209472656e+01 1.8267400741577148e+01 -1.6800299072265625e+02 -9.7325698852539062e+01 1.8175600051879883e+01 -1.6798399353027344e+02 -9.7680702209472656e+01 1.8793399810791016e+01 -1.6432400512695312e+02 -9.7325698852539062e+01 1.8702098846435547e+01 -1.6353300476074219e+02 -9.7680702209472656e+01 1.8841499328613281e+01 -1.6150199890136719e+02 -9.7325698852539062e+01 1.8712301254272461e+01 -1.6150500488281250e+02 -9.7325698852539062e+01 1.6102399826049805e+01 -1.5059399414062500e+02 -9.7680702209472656e+01 1.6215400695800781e+01 -1.5053099060058594e+02 -9.7325698852539062e+01 1.7334800720214844e+01 -1.5331800842285156e+02 -9.7680702209472656e+01 1.8086399078369141e+01 -1.5536099243164062e+02 -9.7325805664062500e+01 1.7978599548339844e+01 -1.5559800720214844e+02 -9.7680702209472656e+01 1.8117399215698242e+01 -1.5556199645996094e+02 -9.7325805664062500e+01 1.8136899948120117e+01 -1.5615899658203125e+02 -9.7680702209472656e+01 1.8763198852539062e+01 -1.5974000549316406e+02 -9.7325698852539062e+01 1.8705699920654297e+01 -1.6120700073242188e+02 -9.7325698852539062e+01 1.4506599426269531e+01 -1.4812600708007812e+02 -9.7680702209472656e+01 1.3441300392150879e+01 -1.4662699890136719e+02 -9.7325698852539062e+01 1.2564400672912598e+01 -1.4589599609375000e+02 -9.7680702209472656e+01 1.1605299949645996e+01 -1.4483900451660156e+02 -9.7325698852539062e+01 9.4816093444824219e+00 -1.4341099548339844e+02 -9.7680702209472656e+01 9.5522403717041016e+00 -1.4330300903320312e+02 -9.7325805664062500e+01 4.2944602966308594e+00 -1.4087399291992188e+02 -9.7680595397949219e+01 4.9775800704956055e+00 -1.4098599243164062e+02 -9.7325805664062500e+01 6.9600300788879395e+00 -1.4198200988769531e+02 -9.7680702209472656e+01 7.3165898323059082e+00 -1.4201499938964844e+02 -9.7567604064941406e+01 -6.7732901573181152e+00 -1.7696099853515625e+02 -9.7680702209472656e+01 -6.7315702438354492e+00 -1.7689900207519531e+02 -9.7680702209472656e+01 -4.6300902366638184e+00 -1.7597499084472656e+02 -9.7680702209472656e+01 -2.2578799724578857e+00 -1.7479100036621094e+02 -9.7325698852539062e+01 -2.1973202228546143e+00 -1.7490499877929688e+02 -9.7325698852539062e+01 -4.4873900413513184e+00 -1.7605000305175781e+02 -9.7325698852539062e+01 -6.8277697563171387e+00 -1.7707901000976562e+02 -9.7325698852539062e+01 -6.8625197410583496e+00 -1.7709300231933594e+02 -9.7680702209472656e+01 2.0207800865173340e+00 -1.7175500488281250e+02 -9.7325698852539062e+01 2.1092300415039062e+00 -1.7184899902343750e+02 -9.7680702209472656e+01 1.3348498940467834e-01 -1.7330900573730469e+02 -9.7325698852539062e+01 8.3953797817230225e-02 -1.7350299072265625e+02 -9.7680702209472656e+01 -1.0383700132369995e+00 -1.7409199523925781e+02 -9.7680702209472656e+01 3.9400398731231689e+00 -1.6953399658203125e+02 -9.7680702209472656e+01 5.0150699615478516e+00 -1.6768499755859375e+02 -9.7325698852539062e+01 5.1314797401428223e+00 -1.6774099731445312e+02 -9.7325805664062500e+01 4.5215501785278320e+00 -1.6887199401855469e+02 -9.7325805664062500e+01 3.8093898296356201e+00 -1.6993899536132812e+02 -9.7680702209472656e+01 3.0379300117492676e+00 -1.7069700622558594e+02 -9.7680702209472656e+01 6.0665001869201660e+00 -1.6234700012207031e+02 -9.7325698852539062e+01 6.1956601142883301e+00 -1.6234199523925781e+02 -9.7680702209472656e+01 6.0577402114868164e+00 -1.6323699951171875e+02 -9.7325698852539062e+01 6.1985902786254883e+00 -1.6261199951171875e+02 -9.7680595397949219e+01 5.9127798080444336e+00 -1.6474301147460938e+02 -9.7325805664062500e+01 6.0918297767639160e+00 -1.6439799499511719e+02 -9.7680702209472656e+01 5.5748200416564941e+00 -1.6623799133300781e+02 -9.7325805664062500e+01 5.7436199188232422e+00 -1.6612100219726562e+02 -9.7680702209472656e+01 5.0114398002624512e+00 -1.5798699951171875e+02 -9.7325698852539062e+01 5.1258797645568848e+00 -1.5792700195312500e+02 -9.7680801391601562e+01 5.5465102195739746e+00 -1.5927099609375000e+02 -9.7325599670410156e+01 5.6301403045654297e+00 -1.5911199951171875e+02 -9.7680801391601562e+01 5.8736801147460938e+00 -1.6058599853515625e+02 -9.7325599670410156e+01 5.9676198959350586e+00 -1.6038699340820312e+02 -9.7680702209472656e+01 6.0396199226379395e+00 -1.6190100097656250e+02 -9.7325698852539062e+01 6.1550097465515137e+00 -1.6172599792480469e+02 -9.7680702209472656e+01 2.4727599620819092e+00 -1.5515499877929688e+02 -9.7325698852539062e+01 2.5430300235748291e+00 -1.5504699707031250e+02 -9.7680702209472656e+01 3.4780499935150146e+00 -1.5594300842285156e+02 -9.7325698852539062e+01 3.4941999912261963e+00 -1.5578199768066406e+02 -9.7680702209472656e+01 4.3011298179626465e+00 -1.5686199951171875e+02 -9.7325698852539062e+01 4.3838000297546387e+00 -1.5675700378417969e+02 -9.7680702209472656e+01 -1.2265399694442749e+00 -1.5386199951171875e+02 -9.7325698852539062e+01 -1.2105100154876709e+00 -1.5373300170898438e+02 -9.7680595397949219e+01 6.5430298447608948e-02 -1.5410800170898438e+02 -9.7325897216796875e+01 1.0278899967670441e-01 -1.5398399353027344e+02 -9.7680595397949219e+01 1.3037899732589722e+00 -1.5453199768066406e+02 -9.7325897216796875e+01 1.3582699298858643e+00 -1.5441400146484375e+02 -9.7680702209472656e+01 -5.6453299522399902e+00 -1.5400700378417969e+02 -9.7325698852539062e+01 -5.6704902648925781e+00 -1.5388000488281250e+02 -9.7680702209472656e+01 -5.5974698066711426e+00 -1.5399900817871094e+02 -9.7325698852539062e+01 -5.0742597579956055e+00 -1.5378601074218750e+02 -9.7680702209472656e+01 -4.1583800315856934e+00 -1.5381300354003906e+02 -9.7325698852539062e+01 -3.7788100242614746e+00 -1.5365600585937500e+02 -9.7680702209472656e+01 -2.6967499256134033e+00 -1.5376100158691406e+02 -9.7325698852539062e+01 -2.4880201816558838e+00 -1.5363598632812500e+02 -9.7680702209472656e+01 -7.0128397941589355e+00 -1.5431100463867188e+02 -9.7325698852539062e+01 -7.1420702934265137e+00 -1.5420700073242188e+02 -9.7325698852539062e+01 -7.5098299980163574e+00 -1.7665800476074219e+02 -9.7325698852539062e+01 -7.5098299980163574e+00 -1.5466600036621094e+02 -9.7567604064941406e+01 -7.4217901229858398e+00 -1.7652600097656250e+02 -9.7680702209472656e+01 -7.3805999755859375e+00 -1.5477000427246094e+02 -9.7680702209472656e+01 -7.3805999755859375e+00 -1.7646501159667969e+02 -9.8338699340820312e+01 -5.4380898475646973e+00 -1.5492401123046875e+02 -9.8338699340820312e+01 -2.6980597972869873e+00 -1.7396099853515625e+02 -9.8338699340820312e+01 -5.4625301361083984e+00 -1.5492900085449219e+02 -9.8338699340820312e+01 -5.0281300544738770e+00 -1.7512300109863281e+02 -9.8338699340820312e+01 -6.4409399032592773e+00 -1.5514700317382812e+02 -9.8338699340820312e+01 -6.4409399032592773e+00 -1.7575700378417969e+02 -9.8338699340820312e+01 2.3273799419403076e+00 -1.7008200073242188e+02 -9.8338699340820312e+01 1.3776398897171021e+00 -1.7106999206542969e+02 -9.8338699340820312e+01 1.3774600028991699e+00 -1.7106999206542969e+02 -9.8338699340820312e+01 5.1026296615600586e+00 -1.6197200012207031e+02 -9.8338699340820312e+01 5.1271901130676270e+00 -1.6237699890136719e+02 -9.8338699340820312e+01 -4.0795798301696777e+00 -1.5474900817871094e+02 -9.8338699340820312e+01 -2.7102799415588379e+00 -1.5469999694824219e+02 -9.8338699340820312e+01 4.9490900039672852e+00 -1.6075299072265625e+02 -9.8338699340820312e+01 -4.1608300805091858e-01 -1.7254699707031250e+02 -9.8338699340820312e+01 -1.5328500270843506e+00 -1.7329299926757812e+02 -9.8338699340820312e+01 5.1187901496887207e+00 -1.6320001220703125e+02 -9.8338699340820312e+01 4.9843802452087402e+00 -1.6459700012207031e+02 -9.8338699340820312e+01 4.6749100685119629e+00 -1.6596699523925781e+02 -9.8338699340820312e+01 4.1680898666381836e+00 -1.6727799987792969e+02 -9.8338699340820312e+01 3.1673898696899414e+00 -1.6899900817871094e+02 -9.8338699340820312e+01 2.8341999053955078e+00 -1.5662699890136719e+02 -9.8338699340820312e+01 3.5511801242828369e+00 -1.5742799377441406e+02 -9.8338699340820312e+01 1.9617700576782227e+00 -1.5594400024414062e+02 -9.8338699340820312e+01 9.3188601732254028e-01 -1.5539500427246094e+02 -9.8338699340820312e+01 -1.3429499864578247e+00 -1.5479399108886719e+02 -9.8338699340820312e+01 -1.7223599553108215e-01 -1.5501699829101562e+02 -9.8338699340820312e+01 4.6525602340698242e+00 -1.5955999755859375e+02 -9.8338699340820312e+01 4.1789398193359375e+00 -1.5842300415039062e+02 -9.7680702209472656e+01 1.7699399948120117e+01 -2.0532800292968750e+02 -9.7325698852539062e+01 1.7570199966430664e+01 -2.0547999572753906e+02 -9.7680702209472656e+01 1.7699399948120117e+01 -1.9450399780273438e+02 -9.7325698852539062e+01 1.7570199966430664e+01 -1.9465798950195312e+02 -9.7680702209472656e+01 1.7148698806762695e+01 -1.9404199218750000e+02 -9.7325698852539062e+01 1.7019498825073242e+01 -1.9419500732421875e+02 -9.7680702209472656e+01 6.4556598663330078e+00 -1.9590798950195312e+02 -9.7325698852539062e+01 6.5848798751831055e+00 -1.9601699829101562e+02 -9.7680702209472656e+01 6.0666198730468750e+00 -1.9637100219726562e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -1.9647898864746094e+02 -9.7680702209472656e+01 6.0666198730468750e+00 -2.0746299743652344e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -2.0757199096679688e+02 -9.7325698852539062e+01 -4.0903198242187500e+01 -2.1614199829101562e+02 -9.7592002868652344e+01 -3.1494598388671875e+01 -2.1441101074218750e+02 -9.7325698852539062e+01 5.8063302040100098e+00 -2.0803500366210938e+02 -9.7680702209472656e+01 -2.2082601547241211e+01 -2.1274499511718750e+02 -9.7680702209472656e+01 5.6770997047424316e+00 -2.0792700195312500e+02 -9.7680702209472656e+01 5.5164098739624023e+00 -2.2369299316406250e+02 -9.7680702209472656e+01 -2.2403999328613281e+01 -2.2853900146484375e+02 -9.7325698852539062e+01 5.6456298828125000e+00 -2.2353900146484375e+02 -9.7592002868652344e+01 -3.1815900802612305e+01 -2.3013999938964844e+02 -9.7325698852539062e+01 -4.1224597930908203e+01 -2.3167399597167969e+02 -9.7680702209472656e+01 6.0666198730468750e+00 -2.2415600585937500e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -2.2400199890136719e+02 -9.7680702209472656e+01 6.0666198730468750e+00 -2.3194999694824219e+02 -9.7325698852539062e+01 6.1958398818969727e+00 -2.3179598999023438e+02 -9.7680702209472656e+01 6.6171898841857910e+00 -2.3241299438476562e+02 -9.7325698852539062e+01 6.7464098930358887e+00 -2.3225900268554688e+02 -9.7680702209472656e+01 1.7314100265502930e+01 -2.3054598999023438e+02 -9.7325698852539062e+01 1.7185600280761719e+01 -2.3043798828125000e+02 -9.7680702209472656e+01 1.7703199386596680e+01 -2.3008599853515625e+02 -9.7325698852539062e+01 1.7574699401855469e+01 -2.2997799682617188e+02 -9.7680702209472656e+01 1.7755199432373047e+01 -2.2196699523925781e+02 -9.7325698852539062e+01 1.7626701354980469e+01 -2.2185400390625000e+02 -9.7680702209472656e+01 1.8164899826049805e+01 -2.2150500488281250e+02 -9.7325698852539062e+01 1.8036401748657227e+01 -2.2139100646972656e+02 -9.7680702209472656e+01 2.2123100280761719e+01 -2.2099398803710938e+02 -9.7325698852539062e+01 2.3262599945068359e+01 -2.2071699523925781e+02 -9.7679397583007812e+01 2.3278598785400391e+01 -2.2084399414062500e+02 -9.7325698852539062e+01 2.4218700408935547e+01 -2.2058599853515625e+02 -9.7671501159667969e+01 2.5114198684692383e+01 -2.2056600952148438e+02 -9.7648895263671875e+01 2.7626600265502930e+01 -2.2000000000000000e+02 -9.7325698852539062e+01 2.6998498916625977e+01 -2.2003900146484375e+02 -9.7614105224609375e+01 3.0068099975585938e+01 -2.1920700073242188e+02 -9.7325698852539062e+01 2.9729999542236328e+01 -2.1921899414062500e+02 -9.7568496704101562e+01 3.2410301208496094e+01 -2.1817498779296875e+02 -9.7325698852539062e+01 3.2370998382568359e+01 -2.1809600830078125e+02 -9.7325698852539062e+01 3.9171401977539062e+01 -2.1295500183105469e+02 -9.7368705749511719e+01 3.9183097839355469e+01 -2.1296499633789062e+02 -9.7325805664062500e+01 3.7078102111816406e+01 -2.1501199340820312e+02 -9.7453102111816406e+01 3.6715400695800781e+01 -2.1537500000000000e+02 -9.7325805664062500e+01 3.4831199645996094e+01 -2.1669200134277344e+02 -9.7513694763183594e+01 3.4644901275634766e+01 -2.1689399719238281e+02 -9.7347000122070312e+01 3.9759399414062500e+01 -2.1227200317382812e+02 -9.7325805664062500e+01 4.0304702758789062e+01 -2.1155400085449219e+02 -9.7325698852539062e+01 4.1167697906494141e+01 -1.8811799621582031e+02 -9.7325698852539062e+01 3.2113998413085938e+01 -1.8912400817871094e+02 -9.7477600097656250e+01 3.6583698272705078e+01 -1.8857200622558594e+02 -9.7587402343750000e+01 3.1998500823974609e+01 -1.8904100036621094e+02 -9.7325698852539062e+01 3.1985000610351562e+01 -1.9114300537109375e+02 -9.7604598999023438e+01 3.1884799957275391e+01 -1.9115998840332031e+02 -9.7325698852539062e+01 3.1873901367187500e+01 -1.9051901245117188e+02 -9.7607398986816406e+01 3.1719402313232422e+01 -1.9025898742675781e+02 -9.7325698852539062e+01 3.1750898361206055e+01 -1.8989799499511719e+02 -9.7609695434570312e+01 3.1581600189208984e+01 -1.8960200500488281e+02 -9.7325698852539062e+01 3.1706697463989258e+01 -1.8968998718261719e+02 -9.7602897644042969e+01 3.1987298965454102e+01 -1.9187800598144531e+02 -9.7325698852539062e+01 3.2076999664306641e+01 -1.9177900695800781e+02 -9.7601799011230469e+01 3.2054801940917969e+01 -1.9260099792480469e+02 -9.7325698852539062e+01 3.2141902923583984e+01 -1.9241600036621094e+02 -9.7601303100585938e+01 3.2086601257324219e+01 -1.9332699584960938e+02 -9.7325698852539062e+01 3.2179298400878906e+01 -1.9305599975585938e+02 -9.7601303100585938e+01 3.2089199066162109e+01 -1.9360198974609375e+02 -9.7325698852539062e+01 3.2189498901367188e+01 -1.9360099792480469e+02 -9.7601600646972656e+01 3.2066200256347656e+01 -1.9469000244140625e+02 -9.7325698852539062e+01 3.0006999969482422e+01 -2.0107400512695312e+02 -9.7632896423339844e+01 2.9916099548339844e+01 -2.0100801086425781e+02 -9.7325698852539062e+01 3.1661302566528320e+01 -1.9768099975585938e+02 -9.7612899780273438e+01 3.1348102569580078e+01 -1.9830000305175781e+02 -9.7325698852539062e+01 3.1664598464965820e+01 -1.9765600585937500e+02 -9.7610801696777344e+01 3.1485198974609375e+01 -1.9761100769042969e+02 -9.7325698852539062e+01 3.2190898895263672e+01 -1.9385301208496094e+02 -9.7679801940917969e+01 2.3350999832153320e+01 -2.0492300415039062e+02 -9.7679901123046875e+01 2.3350999832153320e+01 -2.0492300415039062e+02 -9.7678497314453125e+01 2.3804100036621094e+01 -2.0480899047851562e+02 -9.7325698852539062e+01 2.3373701095581055e+01 -2.0505000305175781e+02 -9.7325698852539062e+01 2.3829198837280273e+01 -2.0492500305175781e+02 -9.7325805664062500e+01 2.5455501556396484e+01 -2.0448100280761719e+02 -9.7674804687500000e+01 2.4962499618530273e+01 -2.0451701354980469e+02 -9.7325698852539062e+01 2.7522800445556641e+01 -2.0333799743652344e+02 -9.7656501770019531e+01 2.7696300506591797e+01 -2.0319000244140625e+02 -9.7657897949218750e+01 2.7488000869750977e+01 -2.0329100036621094e+02 -9.7325698852539062e+01 2.8212999343872070e+01 -2.0295600891113281e+02 -9.7325698852539062e+01 1.8118801116943359e+01 -2.0594400024414062e+02 -9.7680702209472656e+01 1.8248100280761719e+01 -2.0579100036621094e+02 -9.7680702209472656e+01 2.2400899887084961e+01 -2.0508399963378906e+02 -9.6338699340820312e+01 1.6227699279785156e+01 -2.2020300292968750e+02 -9.6338699340820312e+01 1.6170200347900391e+01 -2.2918400573730469e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -2.3067800903320312e+02 -9.6338699340820312e+01 4.2080497741699219e+01 -2.0513198852539062e+02 -9.6338699340820312e+01 4.1028701782226562e+01 -2.0765901184082031e+02 -9.6338699340820312e+01 3.1152500152587891e+01 -2.0189500427246094e+02 -9.6338699340820312e+01 -4.2096599578857422e+01 -2.1777999877929688e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -2.0915399169921875e+02 -9.6338699340820312e+01 -4.2096599578857422e+01 -2.3039500427246094e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -2.2176800537109375e+02 -9.6338699340820312e+01 7.6053700447082520e+00 -1.9726899719238281e+02 -9.6338699340820312e+01 1.6160600662231445e+01 -1.9577600097656250e+02 -9.6338699340820312e+01 1.6160600662231445e+01 -2.0770700073242188e+02 -9.6338699340820312e+01 2.3623001098632812e+01 -2.0643701171875000e+02 -9.6338699340820312e+01 2.5943599700927734e+01 -2.0580300903320312e+02 -9.6338699340820312e+01 2.3086999893188477e+01 -2.1931800842285156e+02 -9.6338699340820312e+01 2.4008399963378906e+01 -2.1919299316406250e+02 -9.6338699340820312e+01 3.3012901306152344e+01 -1.9808100891113281e+02 -9.6338699340820312e+01 4.3405700683593750e+01 -1.9602999877929688e+02 -9.6338699340820312e+01 4.3410800933837891e+01 -1.9620700073242188e+02 -9.6338699340820312e+01 3.8115299224853516e+01 -2.1202099609375000e+02 -9.6338699340820312e+01 2.9086099624633789e+01 -2.0406300354003906e+02 -9.6338699340820312e+01 3.1152399063110352e+01 -2.0189500427246094e+02 -9.6338699340820312e+01 3.9730998992919922e+01 -2.0991801452636719e+02 -9.6338699340820312e+01 4.3408100128173828e+01 -1.9711099243164062e+02 -9.6338699340820312e+01 4.3242698669433594e+01 -1.9982499694824219e+02 -9.6338699340820312e+01 4.2812198638916016e+01 -2.0251100158691406e+02 -9.6338699340820312e+01 3.6162700653076172e+01 -2.1393998718261719e+02 -9.6338699340820312e+01 3.4060199737548828e+01 -2.1551199340820312e+02 -9.6338699340820312e+01 3.1744201660156250e+01 -2.1683299255371094e+02 -9.6338699340820312e+01 3.1744100570678711e+01 -2.1683299255371094e+02 -9.6338699340820312e+01 4.3336498260498047e+01 -1.9469900512695312e+02 -9.6338699340820312e+01 3.3600402832031250e+01 -1.9385600280761719e+02 -9.6338699340820312e+01 4.3212398529052734e+01 -1.9337300109863281e+02 -9.6338699340820312e+01 3.3599102020263672e+01 -1.9359199523925781e+02 -9.6338699340820312e+01 4.3032600402832031e+01 -1.9205300903320312e+02 -9.6338699340820312e+01 3.3587898254394531e+01 -1.9300300598144531e+02 -9.6338699340820312e+01 3.3546897888183594e+01 -1.9230400085449219e+02 -9.6338699340820312e+01 4.2820301055908203e+01 -1.9077200317382812e+02 -9.6338699340820312e+01 3.3475898742675781e+01 -1.9160600280761719e+02 -9.6338699340820312e+01 4.2588199615478516e+01 -1.8949400329589844e+02 -9.6338699340820312e+01 3.3375503540039062e+01 -1.9091198730468750e+02 -9.6338699340820312e+01 4.2566600799560547e+01 -1.8938099670410156e+02 -9.6338699340820312e+01 3.3375099182128906e+01 -1.9091000366210938e+02 -9.6338699340820312e+01 3.3287700653076172e+01 -1.9041200256347656e+02 -9.6338699340820312e+01 2.9253499984741211e+01 -2.1789201354980469e+02 -9.6338699340820312e+01 2.6662300109863281e+01 -2.1867098999023438e+02 -9.7325698852539062e+01 -4.0908897399902344e+01 1.5266999244689941e+01 -9.7592002868652344e+01 -3.1500299453735352e+01 1.6938199996948242e+01 -9.7325698852539062e+01 -4.8649897575378418e+00 2.1292999267578125e+01 -9.7680702209472656e+01 -2.2088300704956055e+01 1.8544500350952148e+01 -9.7680702209472656e+01 -4.8819799423217773e+00 2.1421199798583984e+01 -9.7680702209472656e+01 -4.7764801979064941e+00 5.8424997329711914e+00 -9.7680702209472656e+01 -2.2398900985717773e+01 2.8838100433349609e+00 -9.7325698852539062e+01 -4.7953701019287109e+00 5.9702897071838379e+00 -9.7592002868652344e+01 -3.1810897827148438e+01 1.3364199399948120e+00 -9.7325698852539062e+01 -4.1219497680664062e+01 -1.4490699768066406e-01 -9.7325698852539062e+01 -5.9545195102691650e-01 6.0869102478027344e+00 -9.7680702209472656e+01 -6.0714000463485718e-01 5.9581899642944336e+00 -9.7325698852539062e+01 -1.8727200031280518e+00 6.1511898040771484e+00 -9.7680801391601562e+01 -2.0414600372314453e+00 6.0231900215148926e+00 -9.7325698852539062e+01 -3.1664400100708008e+00 6.1217203140258789e+00 -9.7680801391601562e+01 -3.4614200592041016e+00 5.9735999107360840e+00 -9.7325698852539062e+01 -4.4688601493835449e+00 6.0099000930786133e+00 -9.7680702209472656e+01 7.1121895313262939e-01 5.7529997825622559e+00 -9.7325805664062500e+01 7.4504101276397705e-01 5.8778100013732910e+00 -9.7680702209472656e+01 1.9867398738861084e+00 5.3525199890136719e+00 -9.7325698852539062e+01 1.8066799640655518e+00 5.5619997978210449e+00 -9.7680702209472656e+01 2.7455101013183594e+00 4.9852099418640137e+00 -9.7325698852539062e+01 2.8088700771331787e+00 5.0977997779846191e+00 -9.7325698852539062e+01 4.2839598655700684e+00 3.9077899456024170e+00 -9.7325698852539062e+01 5.1510300636291504e+00 2.6678998470306396e+00 -9.7680702209472656e+01 5.0376000404357910e+00 2.6059100627899170e+00 -9.7680702209472656e+01 3.9958899021148682e+00 4.0267000198364258e+00 -9.7680702209472656e+01 4.5716800689697266e+00 3.3443200588226318e+00 -9.7325805664062500e+01 3.5943999290466309e+00 4.5652899742126465e+00 -9.7680801391601562e+01 5.4859499931335449e+00 1.5616899728775024e+00 -9.7325698852539062e+01 5.5831699371337891e+00 1.6780999898910522e+00 -9.7680702209472656e+01 5.7553000450134277e+00 5.0830000638961792e-01 -9.7325698852539062e+01 5.8713498115539551e+00 5.8909398317337036e-01 -9.7680702209472656e+01 5.9523000717163086e+00 -1.4725999832153320e+00 -9.7325698852539062e+01 6.0322899818420410e+00 -5.6690800189971924e-01 -9.7325698852539062e+01 6.0814599990844727e+00 -1.4689899682998657e+00 -9.7680702209472656e+01 5.9505701065063477e+00 -2.5264999866485596e+00 -9.7325698852539062e+01 6.0809798240661621e+00 -2.4941899776458740e+00 -9.7680702209472656e+01 5.7589998245239258e+00 -4.3880100250244141e+00 -9.7325698852539062e+01 5.8836297988891602e+00 -4.4254999160766602e+00 -9.7680702209472656e+01 5.2905702590942383e+00 -6.2213897705078125e+00 -9.7325698852539062e+01 5.4060201644897461e+00 -6.2827796936035156e+00 -9.7680702209472656e+01 4.5236897468566895e+00 -7.9639897346496582e+00 -9.7325698852539062e+01 4.6371197700500488e+00 -8.0260105133056641e+00 -9.7680702209472656e+01 2.9870901107788086e+00 -1.0284899711608887e+01 -9.7325805664062500e+01 3.2290198802947998e+00 -1.0183899879455566e+01 -9.7680702209472656e+01 1.1224099397659302e+00 -1.2321499824523926e+01 -9.7325698852539062e+01 1.5077600479125977e+00 -1.2128600120544434e+01 -9.7680702209472656e+01 3.1794402003288269e-01 -1.3046000480651855e+01 -9.7325698852539062e+01 3.7455201148986816e-01 -1.3167599678039551e+01 -9.7325698852539062e+01 -4.0900402069091797e+01 -2.0524099349975586e+01 -9.7592002868652344e+01 -3.1491800308227539e+01 -1.8763799667358398e+01 -9.7325698852539062e+01 1.5125499665737152e-01 -1.3272999763488770e+01 -9.7680702209472656e+01 -2.2079799652099609e+01 -1.7068500518798828e+01 -9.7680702209472656e+01 9.4069793820381165e-02 -1.3151900291442871e+01 -9.7680702209472656e+01 -2.2403598785400391e+01 -3.2823398590087891e+01 -9.7592002868652344e+01 -3.1815599441528320e+01 -3.4420501708984375e+01 -9.7325698852539062e+01 -4.1224201202392578e+01 -3.5951499938964844e+01 -9.7680702209472656e+01 2.2083000183105469e+01 -2.5119400024414062e+01 -9.7325698852539062e+01 4.0903499603271484e+01 -2.1729000091552734e+01 -9.7592002868652344e+01 3.1494899749755859e+01 -2.3456699371337891e+01 -9.7680702209472656e+01 1.1930800437927246e+01 -1.1898099899291992e+01 -9.7680702209472656e+01 2.2423301696777344e+01 -9.8508100509643555e+00 -9.7325698852539062e+01 1.1510999679565430e+01 -1.2111599922180176e+01 -9.7592002868652344e+01 3.1835197448730469e+01 -8.0472898483276367e+00 -9.7325698852539062e+01 4.1243900299072266e+01 -6.3102903366088867e+00 -9.7325698852539062e+01 1.6640399932861328e+01 -4.1653900146484375e+00 -9.7680702209472656e+01 1.6754999160766602e+01 -4.2250800132751465e+00 -9.7325805664062500e+01 1.3403199195861816e+01 -8.9366798400878906e+00 -9.7680702209472656e+01 1.3921500205993652e+01 -8.5190896987915039e+00 -9.7325698852539062e+01 1.1103899955749512e+01 -1.1303800582885742e+01 -9.7680702209472656e+01 1.1518299102783203e+01 -1.1095199584960938e+01 -9.7680702209472656e+01 1.7774499893188477e+01 -1.8718900680541992e+00 -9.7325698852539062e+01 1.7789098739624023e+01 -1.4247100353240967e+00 -9.7680702209472656e+01 1.8452100753784180e+01 6.0420399904251099e-01 -9.7325698852539062e+01 1.8472600936889648e+01 1.4571199417114258e+00 -9.7680702209472656e+01 1.8791898727416992e+01 3.1576101779937744e+00 -9.7325698852539062e+01 1.8711900711059570e+01 4.3822097778320312e+00 -9.7680702209472656e+01 1.8841400146484375e+01 4.9149899482727051e+00 -9.7325698852539062e+01 1.8712301254272461e+01 4.9128203392028809e+00 -9.7325698852539062e+01 1.6648401260375977e+01 1.3389699935913086e+01 -9.7680702209472656e+01 1.6760200500488281e+01 1.3454400062561035e+01 -9.7325599670410156e+01 1.7620698928833008e+01 1.1300000190734863e+01 -9.7680801391601562e+01 1.7718400955200195e+01 1.1408500671386719e+01 -9.7325599670410156e+01 1.8243101119995117e+01 9.1333904266357422e+00 -9.7680801391601562e+01 1.8357099533081055e+01 9.2171897888183594e+00 -9.7325698852539062e+01 1.8700498580932617e+01 5.3107099533081055e+00 -9.7680702209472656e+01 1.8831699371337891e+01 5.2584900856018066e+00 -9.7325698852539062e+01 1.1440899848937988e+01 1.8653999328613281e+01 -9.7680702209472656e+01 1.1505800247192383e+01 1.8765800476074219e+01 -9.7325698852539062e+01 1.3513400077819824e+01 1.7188299179077148e+01 -9.7680702209472656e+01 1.3451100349426270e+01 1.7409601211547852e+01 -9.7325698852539062e+01 1.5236799240112305e+01 1.5431700706481934e+01 -9.7680702209472656e+01 1.5251100540161133e+01 1.5616799354553223e+01 -9.7325698852539062e+01 3.9479699134826660e+00 2.1149799346923828e+01 -9.7680702209472656e+01 3.9659099578857422e+00 2.1277799606323242e+01 -9.7325805664062500e+01 6.3820500373840332e+00 2.0680200576782227e+01 -9.7680702209472656e+01 6.5097799301147461e+00 2.0781200408935547e+01 -9.7325805664062500e+01 8.7366695404052734e+00 1.9942001342773438e+01 -9.7680702209472656e+01 9.0597896575927734e+00 1.9954401016235352e+01 -9.7680702209472656e+01 1.4200199842453003e+00 2.1538499832153320e+01 -9.7325698852539062e+01 1.1836299896240234e+00 2.1423799514770508e+01 -9.7680702209472656e+01 -1.1416100263595581e+00 2.1615798950195312e+01 -9.7325698852539062e+01 -1.5860199928283691e+00 2.1482101440429688e+01 -9.7680702209472656e+01 -3.7066898345947266e+00 2.1519899368286133e+01 -9.7325698852539062e+01 -4.3443398475646973e+00 2.1340801239013672e+01 -9.6338699340820312e+01 4.2096599578857422e+01 -7.5801100730895996e+00 -9.6338699340820312e+01 4.2096599578857422e+01 -2.0091899871826172e+01 -9.6338699340820312e+01 5.0675301551818848e+00 -1.4805000305175781e+01 -9.6338699340820312e+01 -4.2096599578857422e+01 -3.4672000885009766e+01 -9.6338699340820312e+01 4.4797101020812988e+00 5.6621899604797363e+00 -9.6338699340820312e+01 1.2598600387573242e+01 1.6116001129150391e+01 -9.6338699340820312e+01 1.4148299217224121e+01 1.4536299705505371e+01 -9.6338699340820312e+01 5.3361597061157227e+00 4.8457002639770508e+00 -9.6338699340820312e+01 4.3478598594665527e+00 -1.1041300773620605e+01 -9.6338699340820312e+01 8.4373302459716797e+00 -1.1797400474548340e+01 -9.6338699340820312e+01 2.4978499412536621e+00 -1.3131799697875977e+01 -9.6338699340820312e+01 8.9916700124740601e-01 -1.4572200775146484e+01 -9.6338699340820312e+01 -4.2096599578857422e+01 -2.2166698455810547e+01 -9.6338699340820312e+01 5.8739800453186035e+00 -8.7019901275634766e+00 -9.6338699340820312e+01 5.8743300437927246e+00 -8.7013006210327148e+00 -9.6338699340820312e+01 1.2334000587463379e+01 -8.0179996490478516e+00 -9.6338699340820312e+01 6.7385997772216797e+00 -6.7423095703125000e+00 -9.6338699340820312e+01 1.5390299797058105e+01 -3.5143899917602539e+00 -9.6338699340820312e+01 1.6865299224853516e+01 8.8357000350952148e+00 -9.6338699340820312e+01 1.7291999816894531e+01 5.2587900161743164e+00 -9.6338699340820312e+01 6.9166998863220215e+00 2.1347000598907471e+00 -9.6338699340820312e+01 1.0732399940490723e+01 1.7435501098632812e+01 -9.6338699340820312e+01 3.5002198219299316e+00 6.3261899948120117e+00 -9.6338699340820312e+01 8.2334899902343750e+00 1.8625299453735352e+01 -9.6338699340820312e+01 2.3004999160766602e+00 6.8822097778320312e+00 -9.6338699340820312e+01 6.0402698516845703e+00 1.9312700271606445e+01 -9.6338699340820312e+01 6.3878297805786133e+00 3.3439900875091553e+00 -9.6338699340820312e+01 6.3874697685241699e+00 3.3446202278137207e+00 -9.6338699340820312e+01 1.6297399520874023e+01 1.0814599990844727e+01 -9.6338699340820312e+01 1.5428200721740723e+01 1.2683899879455566e+01 -9.6338699340820312e+01 3.7529501914978027e+00 1.9753801345825195e+01 -9.6338699340820312e+01 1.0584000349044800e+00 7.2521200180053711e+00 -9.6338699340820312e+01 3.7522299289703369e+00 1.9753898620605469e+01 -9.6338699340820312e+01 -4.6784201264381409e-01 7.4907202720642090e+00 -9.6338699340820312e+01 1.1004799604415894e+00 2.0016700744628906e+01 -9.6338699340820312e+01 1.7079700469970703e+01 1.6735099554061890e+00 -9.6338699340820312e+01 7.2544798851013184e+00 8.6071300506591797e-01 -9.6338699340820312e+01 1.7302499771118164e+01 4.3997097015380859e+00 -9.6338699340820312e+01 1.7302900314331055e+01 4.8895101547241211e+00 -9.6338699340820312e+01 7.2718796730041504e+00 -4.6694102287292480e+00 -9.6338699340820312e+01 7.4897398948669434e+00 -2.5413999557495117e+00 -9.6338699340820312e+01 1.6448299407958984e+01 -9.8980301618576050e-01 -9.6338699340820312e+01 7.4905099868774414e+00 -1.4302800893783569e+00 -9.6338699340820312e+01 7.4363899230957031e+00 -4.4340702891349792e-01 -9.6338699340820312e+01 -4.2096599578857422e+01 1.1370100975036621e+00 -9.6338699340820312e+01 -4.2096599578857422e+01 1.3639399528503418e+01 -9.6338699340820312e+01 -5.0013699531555176e+00 7.3650102615356445e+00 -9.6338699340820312e+01 -4.6800999641418457e+00 1.9894798278808594e+01 -9.6338699340820312e+01 -1.5634299516677856e+00 2.0072700500488281e+01 -9.6338699340820312e+01 -1.8557900190353394e+00 7.5606002807617188e+00 -9.6338699340820312e+01 -4.2241797447204590e+00 1.9936399459838867e+01 -9.6338699340820312e+01 -3.2449400424957275e+00 7.5290999412536621e+00 -9.6338699340820312e+01 -4.6291298866271973e+00 7.4103102684020996e+00 -9.6809402465820312e+01 3.8932800292968750e+01 -2.1274400329589844e+02 -9.6809402465820312e+01 4.0639602661132812e+01 -2.1052299499511719e+02 -9.7311805725097656e+01 4.0882598876953125e+01 -2.1068400573730469e+02 -9.6809402465820312e+01 4.2007698059082031e+01 -2.0814100646972656e+02 -9.7279197692871094e+01 4.2164699554443359e+01 -2.0822200012207031e+02 -9.7300300598144531e+01 4.1358200073242188e+01 -2.0996800231933594e+02 -9.6461402893066406e+01 3.8560401916503906e+01 -2.1241499328613281e+02 -9.6461402893066406e+01 4.0225799560546875e+01 -2.1024699401855469e+02 -9.6461402893066406e+01 4.1561801910400391e+01 -2.0792100524902344e+02 -9.6456497192382812e+01 4.2619499206542969e+01 -2.0531900024414062e+02 -9.7247398376464844e+01 4.3382900238037109e+01 -2.0558399963378906e+02 -9.6809402465820312e+01 4.3111297607421875e+01 -2.0548899841308594e+02 -9.6781593322753906e+01 4.3073898315429688e+01 -2.0547599792480469e+02 -9.6461402893066406e+01 4.2641899108886719e+01 -2.0532600402832031e+02 -9.6888000488281250e+01 4.4570899963378906e+01 -1.9618600463867188e+02 -9.7208404541015625e+01 4.4771701812744141e+01 -1.9618199157714844e+02 -9.7209297180175781e+01 4.4738399505615234e+01 -1.9713301086425781e+02 -9.6451904296875000e+01 4.3370700836181641e+01 -2.0263198852539062e+02 -9.6774200439453125e+01 4.3845001220703125e+01 -2.0273399353027344e+02 -9.7245399475097656e+01 4.3453899383544922e+01 -2.0537300109863281e+02 -9.7211502075195312e+01 4.4662502288818359e+01 -1.9929499816894531e+02 -9.7213500976562500e+01 4.4590499877929688e+01 -1.9997000122070312e+02 -9.6774200439453125e+01 4.4293399810791016e+01 -1.9993800354003906e+02 -9.7215599060058594e+01 4.4518398284912109e+01 -2.0064700317382812e+02 -9.7228996276855469e+01 4.4039001464843750e+01 -2.0277499389648438e+02 -9.6774101257324219e+01 4.4464599609375000e+01 -1.9712899780273438e+02 -9.6557601928710938e+01 4.4190898895263672e+01 -1.9619299316406250e+02 -9.6774299621582031e+01 4.4440196990966797e+01 -1.9618800354003906e+02 -9.6787803649902344e+01 4.4455600738525391e+01 -1.9618800354003906e+02 -9.6487899780273438e+01 4.3960700988769531e+01 -1.9619700622558594e+02 -9.6490798950195312e+01 4.3970397949218750e+01 -1.9619700622558594e+02 -9.6451904296875000e+01 4.3979499816894531e+01 -1.9712098693847656e+02 -9.6340003967285156e+01 4.3472400665283203e+01 -1.9620600891113281e+02 -9.6451904296875000e+01 4.3810901641845703e+01 -1.9988600158691406e+02 -9.6461402893066406e+01 3.2008399963378906e+01 -2.1736599731445312e+02 -9.6461402893066406e+01 3.2008300781250000e+01 -2.1736599731445312e+02 -9.6461402893066406e+01 3.4385200500488281e+01 -2.1600900268554688e+02 -9.6461402893066406e+01 3.6548599243164062e+01 -2.1439201354980469e+02 -9.6809402465820312e+01 3.2229400634765625e+01 -2.1781100463867188e+02 -9.6809402465820312e+01 3.4657001495361328e+01 -2.1642500305175781e+02 -9.6809402465820312e+01 3.6871299743652344e+01 -2.1477000427246094e+02 -9.6759803771972656e+01 4.4447299957275391e+01 -1.9599699401855469e+02 -9.6447998046875000e+01 4.3967399597167969e+01 -1.9601200866699219e+02 -9.7208404541015625e+01 4.4769100189208984e+01 -1.9608399963378906e+02 -9.7208595275878906e+01 4.4763000488281250e+01 -1.9598699951171875e+02 -9.6759803771972656e+01 4.4375900268554688e+01 -1.9462400817871094e+02 -9.7211196899414062e+01 4.4674400329589844e+01 -1.9460200500488281e+02 -9.7212905883789062e+01 4.4613700866699219e+01 -1.9365299987792969e+02 -9.6759803771972656e+01 4.4247703552246094e+01 -1.9325399780273438e+02 -9.7214401245117188e+01 4.4558200836181641e+01 -1.9321900939941406e+02 -9.6447998046875000e+01 4.3896999359130859e+01 -1.9465899658203125e+02 -9.6447998046875000e+01 4.3770702362060547e+01 -1.9330899047851562e+02 -9.6447998046875000e+01 4.3587699890136719e+01 -1.9196499633789062e+02 -9.7219398498535156e+01 4.4382099151611328e+01 -1.9183999633789062e+02 -9.6770004272460938e+01 4.4069099426269531e+01 -1.9188900756835938e+02 -9.6759803771972656e+01 4.4062000274658203e+01 -1.9188999938964844e+02 -9.6451400756835938e+01 4.3592899322509766e+01 -1.9196400451660156e+02 -9.6341606140136719e+01 2.3098800659179688e+01 -2.1941099548339844e+02 -9.6557601928710938e+01 2.3184200286865234e+01 -2.2009199523925781e+02 -9.6495704650878906e+01 2.3159700393676758e+01 -2.1989700317382812e+02 -9.6461402893066406e+01 2.4097099304199219e+01 -2.1977999877929688e+02 -9.6888000488281250e+01 2.3231599807739258e+01 -2.2046899414062500e+02 -9.6819900512695312e+01 2.3221799850463867e+01 -2.2039199829101562e+02 -9.6809402465820312e+01 2.4171199798583984e+01 -2.2027101135253906e+02 -9.6461402893066406e+01 2.6804000854492188e+01 -2.1924800109863281e+02 -9.6461402893066406e+01 2.9454401016235352e+01 -2.1845098876953125e+02 -9.6809402465820312e+01 2.6922500610351562e+01 -2.1973001098632812e+02 -9.6809402465820312e+01 2.9622299194335938e+01 -2.1891899108886719e+02 -9.6450401306152344e+01 4.3379703521728516e+01 -1.9067500305175781e+02 -9.6768600463867188e+01 4.3855903625488281e+01 -1.9059201049804688e+02 -9.7225502014160156e+01 4.4164501190185547e+01 -1.9053800964355469e+02 -9.7228103637695312e+01 4.4067798614501953e+01 -1.8996000671386719e+02 -9.7231796264648438e+01 4.3931999206542969e+01 -1.8923999023437500e+02 -9.6768600463867188e+01 4.3621101379394531e+01 -1.8929899597167969e+02 -9.6781593322753906e+01 4.3462898254394531e+01 -1.8855599975585938e+02 -9.7002799987792969e+01 4.3641998291015625e+01 -1.8838999938964844e+02 -9.6647102355957031e+01 4.3354000091552734e+01 -1.8865699768066406e+02 -9.6450401306152344e+01 4.3146099090576172e+01 -1.8938900756835938e+02 -9.6451599121093750e+01 4.3057300567626953e+01 -1.8893099975585938e+02 -9.6338699340820312e+01 4.2572700500488281e+01 -1.8937500000000000e+02 -9.6446296691894531e+01 4.3049297332763672e+01 -1.8893800354003906e+02 -9.7236701965332031e+01 4.3752399444580078e+01 -1.8828700256347656e+02 -9.7240600585937500e+01 1.7992900848388672e+01 -2.2136199951171875e+02 -9.6835205078125000e+01 1.7586299896240234e+01 -2.2109500122070312e+02 -9.6648300170898438e+01 1.7398799896240234e+01 -2.2097200012207031e+02 -9.6531799316406250e+01 1.6958000183105469e+01 -2.2068199157714844e+02 -9.7275596618652344e+01 4.3260997772216797e+01 -1.8790499877929688e+02 -9.7002799987792969e+01 4.3188999176025391e+01 -1.8805900573730469e+02 -9.7301300048828125e+01 4.2214302062988281e+01 -1.8801100158691406e+02 -9.6823097229003906e+01 4.3104896545410156e+01 -1.8823799133300781e+02 -9.6647102355957031e+01 4.3022598266601562e+01 -1.8841400146484375e+02 -9.6465599060058594e+01 4.2863201141357422e+01 -1.8875299072265625e+02 -9.6487098693847656e+01 3.2802200317382812e+01 -1.8987500000000000e+02 -9.6519401550292969e+01 3.2697399139404297e+01 -1.8975999450683594e+02 -9.6659194946289062e+01 3.2519699096679688e+01 -1.8956500244140625e+02 -9.6823204040527344e+01 3.2394599914550781e+01 -1.8942900085449219e+02 -9.7027801513671875e+01 3.2238498687744141e+01 -1.8925898742675781e+02 -9.6338699340820312e+01 4.2570198059082031e+01 -1.8937399291992188e+02 -9.6446296691894531e+01 4.2846298217773438e+01 -1.8878900146484375e+02 -9.6338699340820312e+01 3.3282299041748047e+01 -1.9040599060058594e+02 -9.6836402893066406e+01 1.7237899780273438e+01 -2.2978700256347656e+02 -9.7240600585937500e+01 1.7593000411987305e+01 -2.2181401062011719e+02 -9.6913101196289062e+01 1.7346300125122070e+01 -2.2984899902343750e+02 -9.6416000366210938e+01 1.6643800735473633e+01 -2.2945199584960938e+02 -9.6531799316406250e+01 1.6792499542236328e+01 -2.2086900329589844e+02 -9.6487297058105469e+01 1.6744499206542969e+01 -2.2950799560546875e+02 -9.6648300170898438e+01 1.7133501052856445e+01 -2.2127200317382812e+02 -9.6835205078125000e+01 1.7278499603271484e+01 -2.2144299316406250e+02 -9.6866195678710938e+01 3.2039096832275391e+01 -1.8983900451660156e+02 -9.6823295593261719e+01 3.2083000183105469e+01 -1.8985800170898438e+02 -9.6809402465820312e+01 3.2187000274658203e+01 -1.9045999145507812e+02 -9.6338699340820312e+01 3.3280498504638672e+01 -1.9040901184082031e+02 -9.6461402893066406e+01 3.2789199829101562e+01 -1.9100799560546875e+02 -9.6391799926757812e+01 3.3048099517822266e+01 -1.9030099487304688e+02 -9.6487098693847656e+01 3.2631401062011719e+01 -1.9010800170898438e+02 -9.6461402893066406e+01 3.2675300598144531e+01 -1.9036799621582031e+02 -9.6519401550292969e+01 3.2490398406982422e+01 -1.9004200744628906e+02 -9.6659194946289062e+01 3.2251201629638672e+01 -1.8993400573730469e+02 -9.7027801513671875e+01 3.1873598098754883e+01 -1.8976399230957031e+02 -9.6809402465820312e+01 3.2299102783203125e+01 -1.9109100341796875e+02 -9.7263298034667969e+01 6.7612500190734863e+00 -2.3223200988769531e+02 -9.6913101196289062e+01 1.7020500183105469e+01 -2.3023399353027344e+02 -9.6832496643066406e+01 6.9590201377868652e+00 -2.3186799621582031e+02 -9.6836402893066406e+01 1.6942100524902344e+01 -2.3013700866699219e+02 -9.6665802001953125e+01 7.0355501174926758e+00 -2.3172700500488281e+02 -9.6487297058105469e+01 1.6585399627685547e+01 -2.2969700622558594e+02 -9.6437904357910156e+01 7.2785601615905762e+00 -2.3127999877929688e+02 -9.6468597412109375e+01 7.2457799911499023e+00 -2.3134001159667969e+02 -9.6416000366210938e+01 1.6512599945068359e+01 -2.2960699462890625e+02 -9.6888000488281250e+01 3.2438800811767578e+01 -1.9359899902343750e+02 -9.6557601928710938e+01 3.2818897247314453e+01 -1.9359700012207031e+02 -9.6819900512695312e+01 3.2517196655273438e+01 -1.9359899902343750e+02 -9.6809402465820312e+01 3.2497600555419922e+01 -1.9304400634765625e+02 -9.6461402893066406e+01 3.2994300842285156e+01 -1.9302499389648438e+02 -9.6497299194335938e+01 3.3015899658203125e+01 -1.9359500122070312e+02 -9.6340400695800781e+01 3.3528202056884766e+01 -1.9359199523925781e+02 -9.6809402465820312e+01 3.2459300994873047e+01 -1.9239099121093750e+02 -9.6809402465820312e+01 3.2393001556396484e+01 -1.9173899841308594e+02 -9.6809402465820312e+01 3.2299198150634766e+01 -1.9109100341796875e+02 -9.6461402893066406e+01 3.2954700469970703e+01 -1.9235099792480469e+02 -9.6461402893066406e+01 3.2886299133300781e+01 -1.9167900085449219e+02 -9.6461402893066406e+01 3.2789402008056641e+01 -1.9100999450683594e+02 -9.6552398681640625e+01 7.0470600128173828e+00 -2.2265299987792969e+02 -9.6437904357910156e+01 7.0690498352050781e+00 -2.3110400390625000e+02 -9.6468597412109375e+01 7.0152301788330078e+00 -2.3114599609375000e+02 -9.6722000122070312e+01 6.6038999557495117e+00 -2.2335499572753906e+02 -9.6823799133300781e+01 6.5345201492309570e+00 -2.2346499633789062e+02 -9.7263298034667969e+01 6.2200999259948730e+00 -2.3177699279785156e+02 -9.7316101074218750e+01 6.1993598937988281e+00 -2.2399600219726562e+02 -9.6832496643066406e+01 6.5446500778198242e+00 -2.3152000427246094e+02 -9.6665802001953125e+01 6.6703000068664551e+00 -2.3141999816894531e+02 -9.6809402465820312e+01 3.2509403228759766e+01 -1.9385400390625000e+02 -9.6461402893066406e+01 3.3006401062011719e+01 -1.9385499572753906e+02 -9.6461402893066406e+01 3.2443199157714844e+01 -1.9791198730468750e+02 -9.6461402893066406e+01 3.0669599533081055e+01 -2.0154899597167969e+02 -9.6809402465820312e+01 3.1966600418090820e+01 -1.9777099609375000e+02 -9.6809402465820312e+01 3.0265800476074219e+01 -2.0125900268554688e+02 -9.6832603454589844e+01 -4.2743198394775391e+01 -2.3158399963378906e+02 -9.7305702209472656e+01 -4.2085498809814453e+01 -2.3181599426269531e+02 -9.7263099670410156e+01 -4.2941001892089844e+01 -2.3194700622558594e+02 -9.7284896850585938e+01 -4.2946498870849609e+01 -2.3195700073242188e+02 -9.6437797546386719e+01 -4.2423400878906250e+01 -2.3099600219726562e+02 -9.6552398681640625e+01 6.8291397094726562e+00 -2.2247000122070312e+02 -9.6468704223632812e+01 -4.2456298828125000e+01 -2.3105599975585938e+02 -9.6722000122070312e+01 6.2130098342895508e+00 -2.2302600097656250e+02 -9.6665702819824219e+01 -4.2666500091552734e+01 -2.3144300842285156e+02 -9.6823799133300781e+01 6.1165699958801270e+00 -2.2311399841308594e+02 -9.7316101074218750e+01 5.6505198478698730e+00 -2.2353500366210938e+02 -9.6557601928710938e+01 2.3485099792480469e+01 -2.0566900634765625e+02 -9.6819900512695312e+01 2.3431699752807617e+01 -2.0537200927734375e+02 -9.6809402465820312e+01 2.5565799713134766e+01 -2.0477899169921875e+02 -9.6888000488281250e+01 2.3417800903320312e+01 -2.0529499816894531e+02 -9.6461402893066406e+01 2.5737899780273438e+01 -2.0524600219726562e+02 -9.6498199462890625e+01 2.3519899368286133e+01 -2.0586300659179688e+02 -9.6339797973632812e+01 2.3613000869750977e+01 -2.0638099670410156e+02 -9.6809402465820312e+01 2.8410301208496094e+01 -2.0320600891113281e+02 -9.6809402465820312e+01 3.0265699386596680e+01 -2.0125900268554688e+02 -9.6461402893066406e+01 2.8718101501464844e+01 -2.0359700012207031e+02 -9.6416397094726562e+01 -4.2573001861572266e+01 -2.1751300048828125e+02 -9.6437797546386719e+01 -4.2632698059082031e+01 -2.3082000732421875e+02 -9.6470397949218750e+01 -4.2649501800537109e+01 -2.1747000122070312e+02 -9.6454101562500000e+01 -4.2661201477050781e+01 -2.3084199523925781e+02 -9.6803298950195312e+01 -4.3120498657226562e+01 -2.1720599365234375e+02 -9.6665702819824219e+01 -4.3031398773193359e+01 -2.3113600158691406e+02 -9.6785499572753906e+01 -4.3123100280761719e+01 -2.3120799255371094e+02 -9.6914703369140625e+01 -4.3278198242187500e+01 -2.1711698913574219e+02 -9.7243598937988281e+01 -4.3473499298095703e+01 -2.3148599243164062e+02 -9.7243598937988281e+01 -4.3473499298095703e+01 -2.1700799560546875e+02 -9.6552093505859375e+01 1.6936401367187500e+01 -2.0700801086425781e+02 -9.6721000671386719e+01 1.7550300598144531e+01 -2.0645500183105469e+02 -9.7315200805664062e+01 1.8113401412963867e+01 -2.0594898986816406e+02 -9.6823997497558594e+01 1.7648000717163086e+01 -2.0636799621582031e+02 -9.6641304016113281e+01 6.4522600173950195e+00 -2.0843699645996094e+02 -9.6529701232910156e+01 6.8777198791503906e+00 -2.0870100402832031e+02 -9.6487098693847656e+01 -4.2513698577880859e+01 -2.1726701354980469e+02 -9.6416397094726562e+01 -4.2441299438476562e+01 -2.1735600280761719e+02 -9.6836700439453125e+01 -4.2871799468994141e+01 -2.1682701110839844e+02 -9.7300094604492188e+01 -4.2002700805664062e+01 -2.1634300231933594e+02 -9.6914703369140625e+01 -4.2951599121093750e+01 -2.1672900390625000e+02 -9.7273002624511719e+01 -4.3101898193359375e+01 -2.1654499816894531e+02 -9.6836204528808594e+01 6.2551498413085938e+00 -2.0831399536132812e+02 -9.7232604980468750e+01 5.8541297912597656e+00 -2.0806500244140625e+02 -9.6552093505859375e+01 1.6718999862670898e+01 -2.0682499694824219e+02 -9.6437904357910156e+01 1.6697000503540039e+01 -1.9535099792480469e+02 -9.6468597412109375e+01 1.6750699996948242e+01 -1.9530799865722656e+02 -9.6721000671386719e+01 1.7161001205444336e+01 -2.0612699890136719e+02 -9.6823997497558594e+01 1.7231199264526367e+01 -2.0601600646972656e+02 -9.7263298034667969e+01 1.7545898437500000e+01 -1.9467700195312500e+02 -9.7315200805664062e+01 1.7566301345825195e+01 -2.0548699951171875e+02 -9.6832496643066406e+01 1.7221300125122070e+01 -1.9493499755859375e+02 -9.6665802001953125e+01 1.7095699310302734e+01 -1.9503399658203125e+02 -9.6836700439453125e+01 6.5340399742126465e+00 -1.9666899108886719e+02 -9.7232604980468750e+01 6.2332696914672852e+00 -2.0761399841308594e+02 -9.6914405822753906e+01 6.4239501953125000e+00 -1.9660699462890625e+02 -9.6416305541992188e+01 7.1290698051452637e+00 -1.9700300598144531e+02 -9.6529701232910156e+01 7.0352497100830078e+00 -2.0851400756835938e+02 -9.6487098693847656e+01 7.0289402008056641e+00 -1.9694599914550781e+02 -9.6641304016113281e+01 6.7018899917602539e+00 -2.0813999938964844e+02 -9.6836204528808594e+01 6.5474500656127930e+00 -2.0796699523925781e+02 -9.6437904357910156e+01 1.6487400054931641e+01 -1.9517500305175781e+02 -9.6416305541992188e+01 7.2605600357055664e+00 -1.9684599304199219e+02 -9.6487098693847656e+01 7.1880197525024414e+00 -1.9675700378417969e+02 -9.7263298034667969e+01 1.7004699707031250e+01 -1.9422300720214844e+02 -9.6914405822753906e+01 6.7500500679016113e+00 -1.9621899414062500e+02 -9.6832496643066406e+01 1.6806999206542969e+01 -1.9458599853515625e+02 -9.6836700439453125e+01 6.8297400474548340e+00 -1.9631700134277344e+02 -9.6665802001953125e+01 1.6730400085449219e+01 -1.9472700500488281e+02 -9.6468597412109375e+01 1.6520200729370117e+01 -1.9511399841308594e+02 -9.6461402893066406e+01 5.0324201583862305e+00 -1.5626300048828125e+02 -9.6461402893066406e+01 5.8478097915649414e+00 -1.5754798889160156e+02 -9.6809402465820312e+01 4.6371197700500488e+00 -1.5656399536132812e+02 -9.6809402465820312e+01 5.4078698158264160e+00 -1.5777899169921875e+02 -9.6461402893066406e+01 4.0447697639465332e+00 -1.5518000793457031e+02 -9.6809402465820312e+01 3.7092599868774414e+00 -1.5554699707031250e+02 -9.6461402893066406e+01 2.9864299297332764e+00 -1.5436199951171875e+02 -9.6809402465820312e+01 2.7161798477172852e+00 -1.5477999877929688e+02 -9.6809501647949219e+01 1.4844499826431274e+00 -1.5412199401855469e+02 -9.6809501647949219e+01 1.8350198864936829e-01 -1.5367601013183594e+02 -9.6809402465820312e+01 -1.1709901094436646e+00 -1.5341700744628906e+02 -9.6809402465820312e+01 -1.1710499525070190e+00 -1.5341700744628906e+02 -9.6461402893066406e+01 -1.1094199419021606e+00 -1.5292399597167969e+02 -9.6461402893066406e+01 1.6813300848007202e+00 -1.5366600036621094e+02 -9.6461402893066406e+01 3.0945900082588196e-01 -1.5319499206542969e+02 -9.6461402893066406e+01 -1.1093599796295166e+00 -1.5292399597167969e+02 -9.6888000488281250e+01 6.4448099136352539e+00 -1.6233399963378906e+02 -9.6557601928710938e+01 6.8247299194335938e+00 -1.6232200622558594e+02 -9.6819900512695312e+01 6.5231900215148926e+00 -1.6233200073242188e+02 -9.6809402465820312e+01 6.4722299575805664e+00 -1.6169799804687500e+02 -9.6461402893066406e+01 6.9673099517822266e+00 -1.6165499877929688e+02 -9.6498901367187500e+01 7.0218997001647949e+00 -1.6231599426269531e+02 -9.6339393615722656e+01 7.5572099685668945e+00 -1.6229798889160156e+02 -9.6809295654296875e+01 6.2800598144531250e+00 -1.6032501220703125e+02 -9.6809295654296875e+01 5.9317402839660645e+00 -1.5900898742675781e+02 -9.6809402465820312e+01 5.4080500602722168e+00 -1.5778001403808594e+02 -9.6461402893066406e+01 6.7675700187683105e+00 -1.6022900390625000e+02 -9.6461402893066406e+01 6.4023699760437012e+00 -1.5885000610351562e+02 -9.6461402893066406e+01 5.8482298851013184e+00 -1.5754899597167969e+02 -9.6888000488281250e+01 -5.7190098762512207e+00 -1.5363499450683594e+02 -9.6819900512695312e+01 -5.7343196868896484e+00 -1.5355900573730469e+02 -9.6809402465820312e+01 -5.1184301376342773e+00 -1.5347000122070312e+02 -9.6557601928710938e+01 -5.7930402755737305e+00 -1.5326300048828125e+02 -9.6499694824218750e+01 -5.8314800262451172e+00 -1.5306900024414062e+02 -9.6461402893066406e+01 -5.1873297691345215e+00 -1.5297799682617188e+02 -9.6339096069335938e+01 -5.9379301071166992e+00 -1.5253199768066406e+02 -9.6461402893066406e+01 -3.8269200325012207e+00 -1.5284199523925781e+02 -9.6461402893066406e+01 -2.4642899036407471e+00 -1.5282099914550781e+02 -9.6809402465820312e+01 -3.7975900173187256e+00 -1.5333799743652344e+02 -9.6809402465820312e+01 -2.4787800312042236e+00 -1.5331800842285156e+02 -9.6809402465820312e+01 6.5170497894287109e+00 -1.6261099243164062e+02 -9.6461402893066406e+01 7.0139799118041992e+00 -1.6261000061035156e+02 -9.6461402893066406e+01 6.9008502960205078e+00 -1.6450000000000000e+02 -9.6461402893066406e+01 6.5279002189636230e+00 -1.6634400939941406e+02 -9.6461402893066406e+01 5.8664698600769043e+00 -1.6809498596191406e+02 -9.6809402465820312e+01 6.4078001976013184e+00 -1.6443798828125000e+02 -9.6809402465820312e+01 6.0499300956726074e+00 -1.6620799255371094e+02 -9.6809402465820312e+01 5.4185400009155273e+00 -1.6787899780273438e+02 -9.7222702026367188e+01 -7.1948800086975098e+00 -1.5417599487304688e+02 -9.6837295532226562e+01 -7.5865998268127441e+00 -1.5394499206542969e+02 -9.6633003234863281e+01 -7.7942600250244141e+00 -1.5382299804687500e+02 -9.6527099609375000e+01 -8.1989803314208984e+00 -1.5358399963378906e+02 -9.6809402465820312e+01 2.3271999359130859e+00 -1.7208200073242188e+02 -9.6461402893066406e+01 2.6673099994659424e+00 -1.7244400024414062e+02 -9.6809402465820312e+01 4.0656900405883789e+00 -1.7012800598144531e+02 -9.6809402465820312e+01 4.7944798469543457e+00 -1.6903599548339844e+02 -9.6809402465820312e+01 5.4184799194335938e+00 -1.6788000488281250e+02 -9.6461402893066406e+01 4.4657001495361328e+00 -1.7042300415039062e+02 -9.6461402893066406e+01 5.2203497886657715e+00 -1.6929200744628906e+02 -9.6461402893066406e+01 5.8662900924682617e+00 -1.6809498596191406e+02 -9.6338699340820312e+01 -8.9154806137084961e+00 -1.7943699645996094e+02 -9.6470100402832031e+01 -8.3276605606079102e+00 -1.7827500915527344e+02 -9.6527099609375000e+01 -8.3480491638183594e+00 -1.5377000427246094e+02 -9.6633003234863281e+01 -8.0270805358886719e+00 -1.5411299133300781e+02 -9.7222702026367188e+01 -7.5517301559448242e+00 -1.5462100219726562e+02 -9.7212905883789062e+01 -7.5561399459838867e+00 -1.7674900817871094e+02 -9.6936302185058594e+01 -7.7211799621582031e+00 -1.7707600402832031e+02 -9.6837295532226562e+01 -7.8623900413513184e+00 -1.5428900146484375e+02 -9.6833000183105469e+01 -7.8486800193786621e+00 -1.7732800292968750e+02 -9.6479804992675781e+01 -8.2842102050781250e+00 -1.7818899536132812e+02 -9.6461402893066406e+01 5.5565702915191650e-01 -1.7416799926757812e+02 -9.6809402465820312e+01 -2.0481297969818115e+00 -1.7518701171875000e+02 -9.6809402465820312e+01 -2.0481898784637451e+00 -1.7518701171875000e+02 -9.6461402893066406e+01 -1.8153799772262573e+00 -1.7562599182128906e+02 -9.6461402893066406e+01 -1.8154400587081909e+00 -1.7562599182128906e+02 -9.6809402465820312e+01 2.6818400621414185e-01 -1.7376300048828125e+02 -9.6461402893066406e+01 -4.1406097412109375e+00 -1.7678800964355469e+02 -9.6809402465820312e+01 -4.3519697189331055e+00 -1.7633900451660156e+02 -9.7212905883789062e+01 -6.9308900833129883e+00 -1.7716999816894531e+02 -9.6809402465820312e+01 -6.7072501182556152e+00 -1.7737300109863281e+02 -9.6936302185058594e+01 -7.1721100807189941e+00 -1.7744599914550781e+02 -9.6338699340820312e+01 -8.9136905670166016e+00 -1.7943798828125000e+02 -9.6360900878906250e+01 -8.7692108154296875e+00 -1.7927299499511719e+02 -9.6470100402832031e+01 -8.0565195083618164e+00 -1.7845800781250000e+02 -9.6461402893066406e+01 -6.5191998481750488e+00 -1.7783300781250000e+02 -9.6479804992675781e+01 -7.9931597709655762e+00 -1.7838500976562500e+02 -9.6833000183105469e+01 -7.3580098152160645e+00 -1.7765901184082031e+02 -9.6449195861816406e+01 -4.3803699493408203e+01 -1.6827499389648438e+02 -9.6456199645996094e+01 -4.3239997863769531e+01 -1.7378799438476562e+02 -9.6458999633789062e+01 -4.3818801879882812e+01 -1.6827499389648438e+02 -9.6790199279785156e+01 -4.3720802307128906e+01 -1.7388500976562500e+02 -9.7230895996093750e+01 -4.3966800689697266e+01 -1.7393200683593750e+02 -9.7226600646972656e+01 -4.4124000549316406e+01 -1.7336000061035156e+02 -9.6764198303222656e+01 -4.4285301208496094e+01 -1.6828300476074219e+02 -9.6793693542480469e+01 -4.4306198120117188e+01 -1.6828300476074219e+02 -9.7213096618652344e+01 -4.4601997375488281e+01 -1.6828800964355469e+02 -9.6790199279785156e+01 -4.2993602752685547e+01 -1.7666799926757812e+02 -9.6790100097656250e+01 -4.1921699523925781e+01 -1.7939299011230469e+02 -9.6812004089355469e+01 -4.1934700012207031e+01 -1.7939900207519531e+02 -9.7278297424316406e+01 -4.2210399627685547e+01 -1.7952799987792969e+02 -9.7261802673339844e+01 -4.2840801239013672e+01 -1.7803298950195312e+02 -9.7251998901367188e+01 -4.3196399688720703e+01 -1.7673799133300781e+02 -9.6456100463867188e+01 -4.2526699066162109e+01 -1.7651699829101562e+02 -9.6456100463867188e+01 -4.1477401733398438e+01 -1.7918499755859375e+02 -9.6463500976562500e+01 -4.1487102508544922e+01 -1.7919000244140625e+02 -9.6464500427246094e+01 -4.1485599517822266e+01 -1.7919200134277344e+02 -9.6813301086425781e+01 -4.1931301116943359e+01 -1.7940299987792969e+02 -9.7278297424316406e+01 -4.2210399627685547e+01 -1.7952899169921875e+02 -9.6809402465820312e+01 -4.0597400665283203e+01 -1.8190200805664062e+02 -9.7312698364257812e+01 -4.0811302185058594e+01 -1.8203500366210938e+02 -9.6809402465820312e+01 -3.5776100158691406e+01 -1.8753700256347656e+02 -9.6461402893066406e+01 -3.5455902099609375e+01 -1.8715699768066406e+02 -9.6809402465820312e+01 -3.8970100402832031e+01 -1.8424000549316406e+02 -9.6461402893066406e+01 -3.8580200195312500e+01 -1.8393200683593750e+02 -9.6461402893066406e+01 -4.0173297882080078e+01 -1.8164299011230469e+02 -9.6453895568847656e+01 -4.3277500152587891e+01 -1.6164900207519531e+02 -9.6452598571777344e+01 -4.3277599334716797e+01 -1.6164599609375000e+02 -9.6790298461914062e+01 -4.3778800964355469e+01 -1.6155999755859375e+02 -9.6769897460937500e+01 -4.3749198913574219e+01 -1.6156500244140625e+02 -9.6771598815917969e+01 -4.3748401641845703e+01 -1.6157199096679688e+02 -9.6456199645996094e+01 -4.3295101165771484e+01 -1.6164300537109375e+02 -9.7227996826171875e+01 -4.4071800231933594e+01 -1.6150900268554688e+02 -9.6764198303222656e+01 -4.4120201110839844e+01 -1.6427600097656250e+02 -9.7218399047851562e+01 -4.4415702819824219e+01 -1.6402600097656250e+02 -9.6764198303222656e+01 -4.4259998321533203e+01 -1.6627299499511719e+02 -9.7214103698730469e+01 -4.4565399169921875e+01 -1.6600500488281250e+02 -9.7213996887207031e+01 -4.4569400787353516e+01 -1.6626000976562500e+02 -9.6449195861816406e+01 -4.3778697967529297e+01 -1.6629299926757812e+02 -9.6449195861816406e+01 -4.3640800476074219e+01 -1.6432299804687500e+02 -9.6809402465820312e+01 -2.6633199691772461e+01 -1.9231500244140625e+02 -9.6461402893066406e+01 -2.6496601104736328e+01 -1.9183699035644531e+02 -9.6809501647949219e+01 -3.1006099700927734e+01 -1.9064399719238281e+02 -9.6809402465820312e+01 -3.3484600067138672e+01 -1.8923899841308594e+02 -9.6809402465820312e+01 -3.5775901794433594e+01 -1.8753700256347656e+02 -9.6461402893066406e+01 -3.0787099838256836e+01 -1.9019799804687500e+02 -9.6461402893066406e+01 -3.3213699340820312e+01 -1.8882200622558594e+02 -9.6461402893066406e+01 -3.5455497741699219e+01 -1.8715699768066406e+02 -9.6456199645996094e+01 -4.2359500885009766e+01 -1.5775201416015625e+02 -9.6458801269531250e+01 -4.1427501678466797e+01 -1.5518699645996094e+02 -9.6461402893066406e+01 -4.1439201354980469e+01 -1.5518200683593750e+02 -9.6790298461914062e+01 -4.2828102111816406e+01 -1.5760600280761719e+02 -9.6794502258300781e+01 -4.1878498077392578e+01 -1.5499900817871094e+02 -9.7254402160644531e+01 -4.3105503082275391e+01 -1.5751800537109375e+02 -9.7256103515625000e+01 -4.3043098449707031e+01 -1.5725999450683594e+02 -9.6809402465820312e+01 -4.1898101806640625e+01 -1.5499099731445312e+02 -9.7278800964355469e+01 -4.2175502777099609e+01 -1.5487599182128906e+02 -9.7241203308105469e+01 -4.3587902069091797e+01 -1.5950999450683594e+02 -9.6790298461914062e+01 -4.3368103027343750e+01 -1.5956300354003906e+02 -9.6456199645996094e+01 -4.2890899658203125e+01 -1.5967799377441406e+02 -9.6888000488281250e+01 -1.5312899589538574e+01 -1.9333200073242188e+02 -9.6809402465820312e+01 -1.8866001129150391e+01 -1.9341200256347656e+02 -9.6819900512695312e+01 -1.5320400238037109e+01 -1.9325399780273438e+02 -9.6557601928710938e+01 -1.5349299430847168e+01 -1.9295300292968750e+02 -9.6461402893066406e+01 -1.8860900878906250e+01 -1.9291499328613281e+02 -9.6496002197265625e+01 -1.5368200302124023e+01 -1.9275698852539062e+02 -9.6341400146484375e+01 -1.5415499687194824e+01 -1.9226600646972656e+02 -9.6461402893066406e+01 -2.3817001342773438e+01 -1.9245800781250000e+02 -9.6809402465820312e+01 -2.3904899597167969e+01 -1.9294700622558594e+02 -9.6461402893066406e+01 -4.0626602172851562e+01 -1.5341700744628906e+02 -9.6809402465820312e+01 -3.8529102325439453e+01 -1.4914601135253906e+02 -9.6809402465820312e+01 -4.0113601684570312e+01 -1.5147000122070312e+02 -9.7323097229003906e+01 -4.0369201660156250e+01 -1.5131401062011719e+02 -9.6809402465820312e+01 -4.1069900512695312e+01 -1.5319299316406250e+02 -9.7301002502441406e+01 -4.1270401000976562e+01 -1.5309100341796875e+02 -9.6461402893066406e+01 -3.9688503265380859e+01 -1.5172799682617188e+02 -9.6461402893066406e+01 -3.8134002685546875e+01 -1.4944699096679688e+02 -9.6461402893066406e+01 -3.8133899688720703e+01 -1.4944699096679688e+02 -9.6888000488281250e+01 -1.3031700134277344e+01 -1.9310400390625000e+02 -9.6819900512695312e+01 -1.3039699554443359e+01 -1.9302600097656250e+02 -9.6557601928710938e+01 -1.3070699691772461e+01 -1.9272599792480469e+02 -9.6495498657226562e+01 -1.3090799331665039e+01 -1.9252999877929688e+02 -9.6341804504394531e+01 -1.3140800476074219e+01 -1.9204600524902344e+02 -9.6809402465820312e+01 -3.6610301971435547e+01 -1.4697100830078125e+02 -9.6338699340820312e+01 -3.4107902526855469e+01 -1.4623300170898438e+02 -9.6461402893066406e+01 -3.6262500762939453e+01 -1.4732598876953125e+02 -9.6464096069335938e+01 -3.4219100952148438e+01 -1.4557499694824219e+02 -9.6462699890136719e+01 -3.4217903137207031e+01 -1.4558200073242188e+02 -9.7032501220703125e+01 -3.4333602905273438e+01 -1.4483599853515625e+02 -9.6821502685546875e+01 -3.4302101135253906e+01 -1.4504499816894531e+02 -9.6809402465820312e+01 -3.4397399902343750e+01 -1.4509700012207031e+02 -9.6676902770996094e+01 -3.4280502319335938e+01 -1.4518800354003906e+02 -9.6628997802734375e+01 -3.4266700744628906e+01 -1.4527499389648438e+02 -9.6461402893066406e+01 -1.1415200233459473e+01 -1.9232901000976562e+02 -9.6809402465820312e+01 -1.1343499183654785e+01 -1.9282099914550781e+02 -9.6809402465820312e+01 -6.0265102386474609e+00 -1.9169400024414062e+02 -9.6461402893066406e+01 -6.1607899665832520e+00 -1.9121600341796875e+02 -9.6809402465820312e+01 -8.9879298210144043e-01 -1.8988700866699219e+02 -9.6461402893066406e+01 -1.0940400362014771e+00 -1.8942999267578125e+02 -9.6462699890136719e+01 -3.3976799011230469e+01 -1.4558599853515625e+02 -9.6486297607421875e+01 -2.6795101165771484e+01 -1.5130400085449219e+02 -9.6338699340820312e+01 -2.7481399536132812e+01 -1.5150000000000000e+02 -9.6338699340820312e+01 -3.4104801177978516e+01 -1.4623300170898438e+02 -9.6517501831054688e+01 -2.6649900436401367e+01 -1.5126199340820312e+02 -9.6464096069335938e+01 -3.3975399017333984e+01 -1.4557899475097656e+02 -9.6657699584960938e+01 -2.6395099639892578e+01 -1.5119099426269531e+02 -9.6676902770996094e+01 -3.3897602081298828e+01 -1.4519599914550781e+02 -9.6821502685546875e+01 -3.3868396759033203e+01 -1.4505499267578125e+02 -9.7032501220703125e+01 -3.3825798034667969e+01 -1.4484899902343750e+02 -9.7026199340820312e+01 -2.5994199752807617e+01 -1.5108000183105469e+02 -9.6823295593261719e+01 -2.6214899063110352e+01 -1.5114100646972656e+02 -9.6809402465820312e+01 9.2137403488159180e+00 -1.8336099243164062e+02 -9.6461402893066406e+01 8.8742399215698242e+00 -1.8299800109863281e+02 -9.6809402465820312e+01 6.6886501312255859e+00 -1.8549699401855469e+02 -9.6809402465820312e+01 3.9935698509216309e+00 -1.8735299682617188e+02 -9.6809402465820312e+01 -8.9872598648071289e-01 -1.8988700866699219e+02 -9.6461402893066406e+01 6.3871097564697266e+00 -1.8510200500488281e+02 -9.6461402893066406e+01 3.7316701412200928e+00 -1.8693099975585938e+02 -9.6461402893066406e+01 -1.0938600301742554e+00 -1.8942999267578125e+02 -9.6461402893066406e+01 -2.9762100219726562e+01 -1.5551799011230469e+02 -9.6461402893066406e+01 -3.1031700134277344e+01 -1.5784400939941406e+02 -9.6809402465820312e+01 -2.9339399337768555e+01 -1.5577999877929688e+02 -9.6809402465820312e+01 -3.0583400726318359e+01 -1.5805900573730469e+02 -9.7026199340820312e+01 -2.5952400207519531e+01 -1.5170001220703125e+02 -9.6841903686523438e+01 -2.6157499313354492e+01 -1.5167201232910156e+02 -9.6809402465820312e+01 -2.7856899261474609e+01 -1.5364498901367188e+02 -9.6823402404785156e+01 -2.6178098678588867e+01 -1.5166899108886719e+02 -9.6657699584960938e+01 -2.6362499237060547e+01 -1.5164401245117188e+02 -9.6461402893066406e+01 -2.8249700546264648e+01 -1.5333999633789062e+02 -9.6338699340820312e+01 -2.7481100082397461e+01 -1.5150399780273438e+02 -9.6486396789550781e+01 -2.6773199081420898e+01 -1.5159100341796875e+02 -9.6517501831054688e+01 -2.6624000549316406e+01 -1.5160900878906250e+02 -9.6809402465820312e+01 1.6056299209594727e+01 -1.7378099060058594e+02 -9.6461402893066406e+01 1.5603999137878418e+01 -1.7357600402832031e+02 -9.6809402465820312e+01 1.4618000030517578e+01 -1.7657199096679688e+02 -9.6809501647949219e+01 1.2917699813842773e+01 -1.7917900085449219e+02 -9.6809402465820312e+01 9.2138099670410156e+00 -1.8336099243164062e+02 -9.6461402893066406e+01 1.4188199996948242e+01 -1.7632299804687500e+02 -9.6461402893066406e+01 1.2516200065612793e+01 -1.7888699340820312e+02 -9.6461402893066406e+01 8.8743000030517578e+00 -1.8299800109863281e+02 -9.6888000488281250e+01 -3.2267299652099609e+01 -1.6688500976562500e+02 -9.6819900512695312e+01 -3.2345600128173828e+01 -1.6688699340820312e+02 -9.6809402465820312e+01 -3.2346801757812500e+01 -1.6566101074218750e+02 -9.6557601928710938e+01 -3.2647201538085938e+01 -1.6689599609375000e+02 -9.6497901916503906e+01 -3.2844200134277344e+01 -1.6690100097656250e+02 -9.6461402893066406e+01 -3.2843601226806641e+01 -1.6565100097656250e+02 -9.6340003967285156e+01 -3.3366100311279297e+01 -1.6691600036621094e+02 -9.6461402893066406e+01 -3.2611602783203125e+01 -1.6296699523925781e+02 -9.6461402893066406e+01 -3.2009502410888672e+01 -1.6034700012207031e+02 -9.6809402465820312e+01 -3.2120601654052734e+01 -1.6304400634765625e+02 -9.6809402465820312e+01 -3.1534500122070312e+01 -1.6049299621582031e+02 -9.6809402465820312e+01 1.7808799743652344e+01 -1.6838499450683594e+02 -9.6809402465820312e+01 1.8383798599243164e+01 -1.6352200317382812e+02 -9.6819900512695312e+01 1.8384700775146484e+01 -1.6151200866699219e+02 -9.6888000488281250e+01 1.8463098526000977e+01 -1.6151000976562500e+02 -9.6557601928710938e+01 1.8083099365234375e+01 -1.6151799011230469e+02 -9.6461402893066406e+01 1.7887199401855469e+01 -1.6350399780273438e+02 -9.6495796203613281e+01 1.7886299133300781e+01 -1.6152200317382812e+02 -9.6341499328613281e+01 1.7394699096679688e+01 -1.6153300476074219e+02 -9.6461402893066406e+01 1.7322198867797852e+01 -1.6828399658203125e+02 -9.6461402893066406e+01 -3.2130901336669922e+01 -1.7117799377441406e+02 -9.6461402893066406e+01 -3.1600198745727539e+01 -1.7247100830078125e+02 -9.6809402465820312e+01 -3.1660501480102539e+01 -1.7101800537109375e+02 -9.6809402465820312e+01 -3.1153400421142578e+01 -1.7225299072265625e+02 -9.6809402465820312e+01 -3.2157199859619141e+01 -1.6898100280761719e+02 -9.6461402893066406e+01 -3.2648101806640625e+01 -1.6905899047851562e+02 -9.6461402893066406e+01 1.7890600204467773e+01 -1.6122799682617188e+02 -9.6809402465820312e+01 1.8387399673461914e+01 -1.6121501159667969e+02 -9.6461402893066406e+01 1.7339199066162109e+01 -1.5632798767089844e+02 -9.6809402465820312e+01 1.7825401306152344e+01 -1.5622499084472656e+02 -9.6809402465820312e+01 1.5824099540710449e+01 -1.5074800109863281e+02 -9.6809402465820312e+01 1.7035200119018555e+01 -1.5342498779296875e+02 -9.6461402893066406e+01 1.5389800071716309e+01 -1.5098999023437500e+02 -9.6461402893066406e+01 1.6567600250244141e+01 -1.5359400939941406e+02 -9.6461402893066406e+01 -3.0362600326538086e+01 -1.7448500061035156e+02 -9.6809402465820312e+01 -2.9967998504638672e+01 -1.7418299865722656e+02 -9.6461402893066406e+01 -2.9447700500488281e+01 -1.7553399658203125e+02 -9.6809402465820312e+01 -2.9094800949096680e+01 -1.7518399047851562e+02 -9.6461402893066406e+01 -2.8406101226806641e+01 -1.7645800781250000e+02 -9.6809402465820312e+01 -2.8101099014282227e+01 -1.7606500244140625e+02 -9.6461402893066406e+01 1.3854000091552734e+01 -1.4861500549316406e+02 -9.6809402465820312e+01 1.4251699447631836e+01 -1.4831700134277344e+02 -9.6461402893066406e+01 1.1991100311279297e+01 -1.4647599792480469e+02 -9.6461402893066406e+01 9.0357694625854492e+00 -1.4409300231933594e+02 -9.6809402465820312e+01 1.2340499877929688e+01 -1.4612199401855469e+02 -9.6809402465820312e+01 9.3074998855590820e+00 -1.4367700195312500e+02 -9.6461402893066406e+01 -2.5104400634765625e+01 -1.7827899169921875e+02 -9.6461402893066406e+01 -2.3779600143432617e+01 -1.7869599914550781e+02 -9.6809402465820312e+01 -2.4932001113891602e+01 -1.7781298828125000e+02 -9.6809402465820312e+01 -2.3653301239013672e+01 -1.7821499633789062e+02 -9.6461402893066406e+01 -2.6375801086425781e+01 -1.7773100280761719e+02 -9.6809501647949219e+01 -2.6154499053955078e+01 -1.7728599548339844e+02 -9.6461402893066406e+01 4.0255799293518066e+00 -1.4164399719238281e+02 -9.6461402893066406e+01 -1.7944501340389252e-01 -1.4055400085449219e+02 -9.6809402465820312e+01 4.1894297599792480e+00 -1.4117500305175781e+02 -9.6809402465820312e+01 -9.2241600155830383e-02 -1.4006500244140625e+02 -9.6461402893066406e+01 6.6029400825500488e+00 -1.4271501159667969e+02 -9.6809402465820312e+01 6.8205599784851074e+00 -1.4226800537109375e+02 -9.6905593872070312e+01 -1.8101900100708008e+01 -1.7859800720214844e+02 -9.6825195312500000e+01 -1.7974498748779297e+01 -1.7868701171875000e+02 -9.6809402465820312e+01 -1.8457601547241211e+01 -1.7870298767089844e+02 -9.6338699340820312e+01 -1.6566699981689453e+01 -1.7967399597167969e+02 -9.6461402893066406e+01 -1.8430700302124023e+01 -1.7919898986816406e+02 -9.6511604309082031e+01 -1.7478000640869141e+01 -1.7903498840332031e+02 -9.6463096618652344e+01 -1.7339199066162109e+01 -1.7913200378417969e+02 -9.6443695068359375e+01 -1.7284000396728516e+01 -1.7917098999023438e+02 -9.7271102905273438e+01 -1.8384401321411133e+01 -1.7840100097656250e+02 -9.6809402465820312e+01 -2.1085100173950195e+01 -1.7866101074218750e+02 -9.6461402893066406e+01 -2.1129999160766602e+01 -1.7915600585937500e+02 -9.6461402893066406e+01 -2.8582799434661865e+00 -1.4018299865722656e+02 -9.6888000488281250e+01 -1.1228700637817383e+01 -1.3971499633789062e+02 -9.6809402465820312e+01 -8.2933902740478516e+00 -1.3954701232910156e+02 -9.6819900512695312e+01 -1.1218200683593750e+01 -1.3979299926757812e+02 -9.6557601928710938e+01 -1.1177799224853516e+01 -1.4009199523925781e+02 -9.6461402893066406e+01 -8.2709798812866211e+00 -1.4004299926757812e+02 -9.6499397277832031e+01 -1.1151299476623535e+01 -1.4028799438476562e+02 -9.6339302062988281e+01 -1.1078599929809570e+01 -1.4082600402832031e+02 -9.6809402465820312e+01 -2.8089900016784668e+00 -1.3968899536132812e+02 -9.6338699340820312e+01 -1.6565299987792969e+01 -1.7967199707031250e+02 -9.6443695068359375e+01 -1.7111598968505859e+01 -1.7898799133300781e+02 -9.6464302062988281e+01 -1.7153799057006836e+01 -1.4137400817871094e+02 -9.6463096618652344e+01 -1.7153699874877930e+01 -1.7893501281738281e+02 -9.6467300415039062e+01 -1.7168001174926758e+01 -1.4136599731445312e+02 -9.6511604309082031e+01 -1.7259500503540039e+01 -1.7880200195312500e+02 -9.6724502563476562e+01 -1.7564701080322266e+01 -1.4113900756835938e+02 -9.7271102905273438e+01 -1.7948801040649414e+01 -1.7793899536132812e+02 -9.6823204040527344e+01 -1.7631099700927734e+01 -1.4110099792480469e+02 -9.6825195312500000e+01 -1.7637699127197266e+01 -1.7832901000976562e+02 -9.6905593872070312e+01 -1.7734800338745117e+01 -1.7820700073242188e+02 -9.6464302062988281e+01 -1.6986200332641602e+01 -1.4117799377441406e+02 -9.6467300415039062e+01 -1.6996400833129883e+01 -1.4116600036621094e+02 -9.6724502563476562e+01 -1.7281000137329102e+01 -1.4080799865722656e+02 -9.6823204040527344e+01 -1.7328699111938477e+01 -1.4074800109863281e+02 -9.6822402954101562e+01 4.2872699737548828e+01 -2.1046201705932617e+01 -9.7273002624511719e+01 4.3101699829101562e+01 -2.1327798843383789e+01 -9.7300094604492188e+01 4.2002799987792969e+01 -2.1528900146484375e+01 -9.6821197509765625e+01 -4.2751598358154297e+01 -3.5875598907470703e+01 -9.7305702209472656e+01 -4.2085403442382812e+01 -3.6092998504638672e+01 -9.7284797668457031e+01 -4.2946598052978516e+01 -3.6233898162841797e+01 -9.6468101501464844e+01 4.2537498474121094e+01 -2.0634099960327148e+01 -9.6732398986816406e+01 -4.2714199066162109e+01 -3.5806999206542969e+01 -9.6464698791503906e+01 4.2525897979736328e+01 -2.0619800567626953e+01 -9.6723899841308594e+01 4.2822700500488281e+01 -2.0984699249267578e+01 -9.6444503784179688e+01 -4.2433998107910156e+01 -3.5291900634765625e+01 -9.6467704772949219e+01 -4.2456501007080078e+01 -3.5333396911621094e+01 -9.6458595275878906e+01 4.2661598205566406e+01 -2.0408998489379883e+01 -9.6723899841308594e+01 4.3100200653076172e+01 -2.0655099868774414e+01 -9.6468101501464844e+01 4.2706001281738281e+01 -2.0433900833129883e+01 -9.6773101806640625e+01 4.3138500213623047e+01 -6.7367897033691406e+00 -9.6442199707031250e+01 4.2644100189208984e+01 -7.1370100975036621e+00 -9.6453193664550781e+01 4.2661701202392578e+01 -7.1227002143859863e+00 -9.6732498168945312e+01 4.3109600067138672e+01 -6.7600998878479004e+00 -9.6774505615234375e+01 4.3136501312255859e+01 -2.0675399780273438e+01 -9.7243598937988281e+01 4.3473499298095703e+01 -6.4656801223754883e+00 -9.7243598937988281e+01 4.3473499298095703e+01 -2.0864601135253906e+01 -9.6458702087402344e+01 -4.2661499023437500e+01 -2.1850700378417969e+01 -9.6723800659179688e+01 -4.3100101470947266e+01 -2.1605499267578125e+01 -9.6468200683593750e+01 -4.2706298828125000e+01 -2.1825799942016602e+01 -9.6773101806640625e+01 -4.3138500213623047e+01 -3.5497200012207031e+01 -9.6444503784179688e+01 -4.2649898529052734e+01 -3.5110202789306641e+01 -9.6452201843261719e+01 -4.2662200927734375e+01 -3.5119998931884766e+01 -9.6732398986816406e+01 -4.3109497070312500e+01 -3.5474300384521484e+01 -9.6774505615234375e+01 -4.3136501312255859e+01 -2.1585100173950195e+01 -9.7243598937988281e+01 -4.3473499298095703e+01 -3.5762599945068359e+01 -9.7243598937988281e+01 -4.3473499298095703e+01 -2.1396699905395508e+01 -9.7305999755859375e+01 4.2090400695800781e+01 -6.1524901390075684e+00 -9.7285499572753906e+01 4.2937099456787109e+01 -5.9954900741577148e+00 -9.6821197509765625e+01 4.2744098663330078e+01 -6.3592000007629395e+00 -9.6839797973632812e+01 9.9391899108886719e+00 -1.2769400596618652e+01 -9.6952102661132812e+01 1.0602299690246582e+01 -1.2492300033569336e+01 -9.7154495239257812e+01 1.1173799514770508e+01 -1.2253499984741211e+01 -9.6732498168945312e+01 4.2707302093505859e+01 -6.4286999702453613e+00 -9.6468597412109375e+01 4.2452098846435547e+01 -6.9098000526428223e+00 -9.6470497131347656e+01 7.7579598426818848e+00 -1.3680799484252930e+01 -9.6338699340820312e+01 5.0789098739624023e+00 -1.4800200462341309e+01 -9.6445503234863281e+01 7.6106200218200684e+00 -1.3742400169372559e+01 -9.6442199707031250e+01 4.2426601409912109e+01 -6.9578995704650879e+00 -9.6464797973632812e+01 -4.2526496887207031e+01 -2.1640199661254883e+01 -9.6466499328613281e+01 5.8525198698043823e-01 -1.4026800155639648e+01 -9.6430999755859375e+01 6.2420803308486938e-01 -1.4094600677490234e+01 -9.6338699340820312e+01 8.9433801174163818e-01 -1.4563799858093262e+01 -9.6468200683593750e+01 -4.2538402557373047e+01 -2.1625600814819336e+01 -9.6819702148437500e+01 3.2506600022315979e-01 -1.3574899673461914e+01 -9.6557701110839844e+01 4.8507902026176453e-01 -1.3852800369262695e+01 -9.7273002624511719e+01 -4.3103298187255859e+01 -2.0933799743652344e+01 -9.7300003051757812e+01 -4.2001998901367188e+01 -2.0728399276733398e+01 -9.6822402954101562e+01 -4.2873901367187500e+01 -2.1214698791503906e+01 -9.6723800659179688e+01 -4.2823699951171875e+01 -2.1276100158691406e+01 -9.6886795043945312e+01 2.8407800197601318e-01 -1.3503600120544434e+01 -9.6470497131347656e+01 7.5898799896240234e+00 -1.3342100143432617e+01 -9.6461402893066406e+01 8.8329296112060547e+00 -1.2240700721740723e+01 -9.6735404968261719e+01 9.0568695068359375e+00 -1.2491299629211426e+01 -9.6445503234863281e+01 7.4517097473144531e+00 -1.3422300338745117e+01 -9.6338699340820312e+01 5.0781998634338379e+00 -1.4798800468444824e+01 -9.6461402893066406e+01 1.2784699440002441e+01 -8.4051895141601562e+00 -9.6809402465820312e+01 1.3161600112915039e+01 -8.7291097640991211e+00 -9.6839797973632812e+01 9.6347904205322266e+00 -1.2156199455261230e+01 -9.6952102661132812e+01 1.0256500244140625e+01 -1.1795500755310059e+01 -9.7154495239257812e+01 1.0792200088500977e+01 -1.1484899520874023e+01 -9.6809402465820312e+01 1.6357900619506836e+01 -4.0182800292968750e+00 -9.6461402893066406e+01 1.5917201042175293e+01 -3.7888100147247314e+00 -9.6886795043945312e+01 4.6735998988151550e-01 -1.3417300224304199e+01 -9.6557701110839844e+01 6.0846698284149170e-01 -1.3794699668884277e+01 -9.6819702148437500e+01 4.9613398313522339e-01 -1.3494299888610840e+01 -9.6809402465820312e+01 1.7314499616622925e+00 -1.2355199813842773e+01 -9.6461402893066406e+01 2.0805599689483643e+00 -1.2708899497985840e+01 -9.6466499328613281e+01 6.7879104614257812e-01 -1.3982799530029297e+01 -9.6430999755859375e+01 7.0613902807235718e-01 -1.4055900573730469e+01 -9.6338699340820312e+01 8.9577704668045044e-01 -1.4563100814819336e+01 -9.6809402465820312e+01 3.4818000793457031e+00 -1.0377599716186523e+01 -9.6809402465820312e+01 4.9165501594543457e+00 -8.1786909103393555e+00 -9.6809402465820312e+01 4.9166698455810547e+00 -8.1786003112792969e+00 -9.6461402893066406e+01 5.3528499603271484e+00 -8.4166898727416992e+00 -9.6461402893066406e+01 3.8762700557708740e+00 -1.0679900169372559e+01 -9.6461402893066406e+01 5.3526201248168945e+00 -8.4169902801513672e+00 -9.6888000488281250e+01 1.8463001251220703e+01 4.9086999893188477e+00 -9.6557601928710938e+01 1.8083000183105469e+01 4.9024100303649902e+00 -9.6819900512695312e+01 1.8384599685668945e+01 4.9073901176452637e+00 -9.6809402465820312e+01 1.8393398284912109e+01 4.3862099647521973e+00 -9.6461402893066406e+01 1.7896600723266602e+01 4.3924102783203125e+00 -9.6497200012207031e+01 1.7885999679565430e+01 4.8991103172302246e+00 -9.6340400695800781e+01 1.7374099731445312e+01 4.8906998634338379e+00 -9.6809402465820312e+01 1.8157800674438477e+01 1.5059000253677368e+00 -9.6809402465820312e+01 1.7486099243164062e+01 -1.3265099525451660e+00 -9.6461402893066406e+01 1.7666799545288086e+01 1.5822000503540039e+00 -9.6461402893066406e+01 1.7013401031494141e+01 -1.1730899810791016e+00 -9.6888000488281250e+01 6.3306698799133301e+00 -1.4621999263763428e+00 -9.6819900512695312e+01 6.4089899063110352e+00 -1.4600199460983276e+00 -9.6809402465820312e+01 6.3992700576782227e+00 -2.5048902034759521e+00 -9.6557601928710938e+01 6.7105898857116699e+00 -1.4517999887466431e+00 -9.6495895385742188e+01 6.9074001312255859e+00 -1.4462800025939941e+00 -9.6461402893066406e+01 6.8959598541259766e+00 -2.5214900970458984e+00 -9.6341400146484375e+01 7.4005699157714844e+00 -1.4327799081802368e+00 -9.6461402893066406e+01 6.6867499351501465e+00 -4.5665898323059082e+00 -9.6461402893066406e+01 6.1769499778747559e+00 -6.5486798286437988e+00 -9.6809402465820312e+01 6.1972699165344238e+00 -4.4806103706359863e+00 -9.6809402465820312e+01 5.7071399688720703e+00 -6.3867096900939941e+00 -9.6461402893066406e+01 1.7885700225830078e+01 5.2807002067565918e+00 -9.6809402465820312e+01 1.8382299423217773e+01 5.2989001274108887e+00 -9.6461402893066406e+01 1.7446001052856445e+01 8.9611892700195312e+00 -9.6461402893066406e+01 1.6855199813842773e+01 1.1019200325012207e+01 -9.6461402893066406e+01 1.5942501068115234e+01 1.2981399536132812e+01 -9.6809295654296875e+01 1.7931800842285156e+01 9.0661001205444336e+00 -9.6809295654296875e+01 1.7321701049804688e+01 1.1190299987792969e+01 -9.6809402465820312e+01 1.6372699737548828e+01 1.3230199813842773e+01 -9.6809402465820312e+01 6.3495597839355469e+00 -5.3901302814483643e-01 -9.6461402893066406e+01 6.8445801734924316e+00 -4.9550098180770874e-01 -9.6809402465820312e+01 6.1838598251342773e+00 6.5039801597595215e-01 -9.6809402465820312e+01 5.8844699859619141e+00 1.7813099622726440e+00 -9.6809402465820312e+01 5.4304599761962891e+00 2.8206899166107178e+00 -9.6809402465820312e+01 5.4303998947143555e+00 2.8208100795745850e+00 -9.6461402893066406e+01 5.8663501739501953e+00 3.0594100952148438e+00 -9.6461402893066406e+01 6.6714901924133301e+00 7.4621200561523438e-01 -9.6461402893066406e+01 6.3546299934387207e+00 1.9422099590301514e+00 -9.6461402893066406e+01 5.8665299415588379e+00 3.0591099262237549e+00 -9.6461402893066406e+01 1.4607099533081055e+01 1.4913699150085449e+01 -9.6809402465820312e+01 1.4990900039672852e+01 1.5229400634765625e+01 -9.6461402893066406e+01 1.2984200477600098e+01 1.6567998886108398e+01 -9.6461402893066406e+01 1.1031000137329102e+01 1.7949100494384766e+01 -9.6809402465820312e+01 1.3306699752807617e+01 1.6945999145507812e+01 -9.6809402465820312e+01 1.1280799865722656e+01 1.8378698348999023e+01 -9.6461402893066406e+01 4.8926501274108887e+00 4.4503998756408691e+00 -9.6809402465820312e+01 4.5217299461364746e+00 4.1197199821472168e+00 -9.6461402893066406e+01 4.1065201759338379e+00 5.1998996734619141e+00 -9.6809402465820312e+01 3.7944300174713135e+00 4.8132200241088867e+00 -9.6461402893066406e+01 3.2088201045989990e+00 5.8084001541137695e+00 -9.6809402465820312e+01 2.9650900363922119e+00 5.3754100799560547e+00 -9.6461402893066406e+01 8.4456195831298828e+00 1.9180299758911133e+01 -9.6809402465820312e+01 8.6230001449584961e+00 1.9644500732421875e+01 -9.6461402893066406e+01 6.1843400001525879e+00 1.9889099121093750e+01 -9.6461402893066406e+01 3.8351399898529053e+00 2.0342199325561523e+01 -9.6809402465820312e+01 6.3048601150512695e+00 2.0371299743652344e+01 -9.6809402465820312e+01 3.9039201736450195e+00 2.0834400177001953e+01 -9.6461402893066406e+01 9.2632603645324707e-01 6.6727895736694336e+00 -9.6461402893066406e+01 -5.2162998914718628e-01 6.8989896774291992e+00 -9.6809402465820312e+01 8.1584399938583374e-01 6.1883001327514648e+00 -9.6809402465820312e+01 -5.6661999225616455e-01 6.4040904045104980e+00 -9.6461402893066406e+01 2.0923600196838379e+00 6.3257102966308594e+00 -9.6809402465820312e+01 1.9182599782943726e+00 5.8601999282836914e+00 -9.6888099670410156e+01 -4.8322701454162598e+00 2.1045801162719727e+01 -9.6557701110839844e+01 -4.7823801040649414e+00 2.0668899536132812e+01 -9.6819900512695312e+01 -4.8219599723815918e+00 2.0968000411987305e+01 -9.6809402465820312e+01 -4.3171601295471191e+00 2.1023500442504883e+01 -9.6461402893066406e+01 -4.2748398780822754e+00 2.0528299331665039e+01 -9.6480598449707031e+01 -4.7569298744201660e+00 2.0476600646972656e+01 -9.6339004516601562e+01 -4.6839699745178223e+00 1.9923999786376953e+01 -9.6371597290039062e+01 -4.7210502624511719e+00 2.0204799652099609e+01 -9.6809402465820312e+01 -1.5808900594711304e+00 2.1163700103759766e+01 -9.6809402465820312e+01 1.1648499965667725e+00 2.1105899810791016e+01 -9.6809402465820312e+01 3.9037501811981201e+00 2.0834400177001953e+01 -9.6461402893066406e+01 -1.5729699134826660e+00 2.0666700363159180e+01 -9.6461402893066406e+01 1.1355299949645996e+00 2.0609800338745117e+01 -9.6461402893066406e+01 3.8347198963165283e+00 2.0342300415039062e+01 -9.6888000488281250e+01 -4.8317899703979492e+00 6.2169899940490723e+00 -9.6819900512695312e+01 -4.8432402610778809e+00 6.2945098876953125e+00 -9.6809402465820312e+01 -4.5050401687622070e+00 6.3263096809387207e+00 -9.6557601928710938e+01 -4.8873400688171387e+00 6.5930099487304688e+00 -9.6499504089355469e+01 -4.9161901473999023e+00 6.7883100509643555e+00 -9.6461402893066406e+01 -4.5615401268005371e+00 6.8200998306274414e+00 -9.6339202880859375e+01 -4.9956398010253906e+00 7.3265099525451660e+00 -9.6461402893066406e+01 -3.2118501663208008e+00 6.9359202384948730e+00 -9.6461402893066406e+01 -1.8629400730133057e+00 6.9666099548339844e+00 -9.6809402465820312e+01 -3.1841399669647217e+00 6.4397101402282715e+00 -9.6809402465820312e+01 -1.8689000606536865e+00 6.4695997238159180e+00 -9.6464500427246094e+01 -4.2524799346923828e+01 1.4169399261474609e+01 -9.6467895507812500e+01 -4.2536003112792969e+01 1.4183300018310547e+01 -9.7273300170898438e+01 -4.3099197387695312e+01 1.4880299568176270e+01 -9.7300201416015625e+01 -4.2004199981689453e+01 1.5074199676513672e+01 -9.6822296142578125e+01 -4.2870700836181641e+01 1.4597599983215332e+01 -9.6724098205566406e+01 -4.2821002960205078e+01 1.4536100387573242e+01 -9.7305603027343750e+01 -4.2084197998046875e+01 -2.8259399533271790e-01 -9.7284599304199219e+01 -4.2948902130126953e+01 -4.1950598359107971e-01 -9.6821197509765625e+01 -4.2753398895263672e+01 -6.2384299933910370e-02 -9.6467498779296875e+01 -4.2457599639892578e+01 4.7781300544738770e-01 -9.6732299804687500e+01 -4.2715999603271484e+01 6.0120299458503723e-03 -9.6445098876953125e+01 -4.2435699462890625e+01 5.1771801710128784e-01 -9.6458595275878906e+01 -4.2661598205566406e+01 1.3958300590515137e+01 -9.6724098205566406e+01 -4.3100402832031250e+01 1.4205999374389648e+01 -9.6467895507812500e+01 -4.2705497741699219e+01 1.3982999801635742e+01 -9.6773101806640625e+01 -4.3138500213623047e+01 3.1610500812530518e-01 -9.6445098876953125e+01 -4.2651199340820312e+01 6.9998896121978760e-01 -9.6451995849609375e+01 -4.2662300109863281e+01 6.9131594896316528e-01 -9.6732299804687500e+01 -4.3109497070312500e+01 3.3890399336814880e-01 -9.6774505615234375e+01 -4.3136600494384766e+01 1.4226400375366211e+01 -9.7243598937988281e+01 -4.3473499298095703e+01 5.2205599844455719e-02 -9.7243598937988281e+01 -4.3473499298095703e+01 1.4416599273681641e+01 -9.6340499877929688e+01 -1.2524900436401367e+01 -9.1476097106933594e+01 -9.6461402893066406e+01 -1.0891599655151367e+01 -9.1784599304199219e+01 -9.6497100830078125e+01 -1.2469399452209473e+01 -9.1982902526855469e+01 -9.6557601928710938e+01 -1.2447999954223633e+01 -9.2178802490234375e+01 -9.6809402465820312e+01 -1.0817600250244141e+01 -9.2276092529296875e+01 -9.6819900512695312e+01 -1.2415199279785156e+01 -9.2478698730468750e+01 -9.6888000488281250e+01 -1.2406599998474121e+01 -9.2556602478027344e+01 -9.6809402465820312e+01 -5.5100898742675781e+00 -9.1140502929687500e+01 -9.6461402893066406e+01 -5.6442599296569824e+00 -9.0662002563476562e+01 -9.6809402465820312e+01 -3.8330900669097900e-01 -8.9339599609375000e+01 -9.6461402893066406e+01 -5.7798403501510620e-01 -8.8882400512695312e+01 -9.6461402893066406e+01 -5.7776200771331787e-01 -8.8882293701171875e+01 -9.6809402465820312e+01 -3.8322299718856812e-01 -8.9339500427246094e+01 -9.6461402893066406e+01 2.2355899810791016e+00 -8.7540596008300781e+01 -9.6461402893066406e+01 4.8989596366882324e+00 -8.5963897705078125e+01 -9.6461402893066406e+01 9.1892499923706055e+00 -8.2594200134277344e+01 -9.6809402465820312e+01 2.4689998626708984e+00 -8.7979301452636719e+01 -9.6809402465820312e+01 5.1717200279235840e+00 -8.6379295349121094e+01 -9.6809402465820312e+01 9.5285196304321289e+00 -8.2957405090332031e+01 -9.6461402893066406e+01 -1.4117600440979004e+01 -9.2165100097656250e+01 -9.6809402465820312e+01 -1.4066799163818359e+01 -9.2659400939941406e+01 -9.6461402893066406e+01 9.1893091201782227e+00 -8.2594200134277344e+01 -9.6461402893066406e+01 1.1230000495910645e+01 -8.0478500366210938e+01 -9.6461402893066406e+01 1.3017100334167480e+01 -7.8184600830078125e+01 -9.6461402893066406e+01 1.5713600158691406e+01 -7.3382400512695312e+01 -9.6809402465820312e+01 1.1605400085449219e+01 -8.0804100036621094e+01 -9.6809501647949219e+01 1.3424699783325195e+01 -7.8468894958496094e+01 -9.6809402465820312e+01 1.6167900085449219e+01 -7.3583793640136719e+01 -9.6461402893066406e+01 -2.2473299026489258e+01 -9.2156593322753906e+01 -9.6461402893066406e+01 -2.5416999816894531e+01 -9.1696998596191406e+01 -9.6809402465820312e+01 -2.2528900146484375e+01 -9.2650398254394531e+01 -9.6809402465820312e+01 -2.5514999389648438e+01 -9.2184204101562500e+01 -9.6809402465820312e+01 -1.9539701461791992e+01 -9.2863800048828125e+01 -9.6461402893066406e+01 -1.9524099349975586e+01 -9.2367004394531250e+01 -9.6809402465820312e+01 1.7340499877929688e+01 -7.0339599609375000e+01 -9.6461402893066406e+01 1.6862598419189453e+01 -7.0203300476074219e+01 -9.6809501647949219e+01 1.8056900024414062e+01 -6.7037902832031250e+01 -9.6461402893066406e+01 1.7565698623657227e+01 -6.6962699890136719e+01 -9.6809402465820312e+01 1.8393899917602539e+01 -6.1423000335693359e+01 -9.6461402893066406e+01 1.7897098541259766e+01 -6.1435302734375000e+01 -9.6809402465820312e+01 -3.0905698776245117e+01 -9.0538101196289062e+01 -9.6809402465820312e+01 -3.5090900421142578e+01 -8.8261596679687500e+01 -9.6461402893066406e+01 -3.0711601257324219e+01 -9.0080596923828125e+01 -9.6461402893066406e+01 -3.4811401367187500e+01 -8.7850700378417969e+01 -9.6809402465820312e+01 -2.8246200561523438e+01 -9.1499900817871094e+01 -9.6461402893066406e+01 -2.8101900100708008e+01 -9.1024299621582031e+01 -9.6461402893066406e+01 1.7897098541259766e+01 -6.1432601928710938e+01 -9.6809402465820312e+01 1.8393899917602539e+01 -6.1422000885009766e+01 -9.6461402893066406e+01 1.7575599670410156e+01 -5.7667602539062500e+01 -9.6461402893066406e+01 1.6986898422241211e+01 -5.4930797576904297e+01 -9.6461402893066406e+01 1.6051898956298828e+01 -5.2280002593994141e+01 -9.6809402465820312e+01 1.8066600799560547e+01 -5.7591300964355469e+01 -9.6809402465820312e+01 1.7465499877929688e+01 -5.4797000885009766e+01 -9.6809402465820312e+01 1.6507999420166016e+01 -5.2082798004150391e+01 -9.6793197631835938e+01 -4.1714702606201172e+01 -8.0839096069335938e+01 -9.6463203430175781e+01 -4.1290500640869141e+01 -8.0608894348144531e+01 -9.6463996887207031e+01 -4.1288902282714844e+01 -8.0610496520996094e+01 -9.6457000732421875e+01 -4.1282501220703125e+01 -8.0604598999023438e+01 -9.7284301757812500e+01 -4.1994300842285156e+01 -8.0990905761718750e+01 -9.7284301757812500e+01 -4.1994400024414062e+01 -8.0990798950195312e+01 -9.6812705993652344e+01 -4.1721900939941406e+01 -8.0847595214843750e+01 -9.6811599731445312e+01 -4.1725200653076172e+01 -8.0844795227050781e+01 -9.6461402893066406e+01 -3.8975700378417969e+01 -8.4058799743652344e+01 -9.6461402893066406e+01 -3.7028598785400391e+01 -8.6103599548339844e+01 -9.6809402465820312e+01 -3.9358898162841797e+01 -8.4375205993652344e+01 -9.6809402465820312e+01 -3.7363101959228516e+01 -8.6471000671386719e+01 -9.6461402893066406e+01 1.4813400268554688e+01 -4.9860702514648438e+01 -9.6809402465820312e+01 1.5239500045776367e+01 -4.9604900360107422e+01 -9.6809402465820312e+01 1.3662399291992188e+01 -4.7358200073242188e+01 -9.6461402893066406e+01 1.3277599334716797e+01 -4.7672698974609375e+01 -9.6809402465820312e+01 1.1627499580383301e+01 -4.5241298675537109e+01 -9.6461402893066406e+01 1.1298100471496582e+01 -4.5613399505615234e+01 -9.7274200439453125e+01 -4.2379402160644531e+01 -8.0232597351074219e+01 -9.7256599426269531e+01 -4.3024497985839844e+01 -7.8236999511718750e+01 -9.6793197631835938e+01 -4.2902397155761719e+01 -7.8186103820800781e+01 -9.6344299316406250e+01 -4.3425796508789062e+01 -6.9708801269531250e+01 -9.6557601928710938e+01 -4.4076801300048828e+01 -6.9724296569824219e+01 -9.6489799499511719e+01 -4.3869800567626953e+01 -6.9719398498535156e+01 -9.6457000732421875e+01 -4.3865402221679688e+01 -7.0188796997070312e+01 -9.6485900878906250e+01 -4.3858200073242188e+01 -6.9719100952148438e+01 -9.6888000488281250e+01 -4.4456798553466797e+01 -6.9733497619628906e+01 -9.6805198669433594e+01 -4.4361698150634766e+01 -6.9731101989746094e+01 -9.6793197631835938e+01 -4.4356700897216797e+01 -7.0208000183105469e+01 -9.6789199829101562e+01 -4.4343097686767578e+01 -6.9730697631835938e+01 -9.7211502075195312e+01 -4.4659099578857422e+01 -6.9738296508789062e+01 -9.7211700439453125e+01 -4.4652599334716797e+01 -6.9963905334472656e+01 -9.7212501525878906e+01 -4.4625499725341797e+01 -7.0217292785644531e+01 -9.6793197631835938e+01 -4.3941501617431641e+01 -7.4227699279785156e+01 -9.7224800109863281e+01 -4.4190299987792969e+01 -7.4273803710937500e+01 -9.7226402282714844e+01 -4.4133201599121094e+01 -7.4806800842285156e+01 -9.6457000732421875e+01 -4.3457099914550781e+01 -7.4143203735351562e+01 -9.6457000732421875e+01 -4.2440101623535156e+01 -7.8018501281738281e+01 -9.6461402893066406e+01 9.0811195373535156e+00 -4.3921703338623047e+01 -9.6809402465820312e+01 9.3534002304077148e+00 -4.3505901336669922e+01 -9.6809402465820312e+01 6.9132399559020996e+00 -4.2135997772216797e+01 -9.6461402893066406e+01 6.6992597579956055e+00 -4.2584499359130859e+01 -9.6809402465820312e+01 4.2400403022766113e+00 -4.1064697265625000e+01 -9.6461402893066406e+01 4.0837497711181641e+00 -4.1536399841308594e+01 -9.7212799072265625e+01 -4.4611900329589844e+01 -6.8397994995117188e+01 -9.6452301025390625e+01 -4.3223197937011719e+01 -6.2972599029541016e+01 -9.6456695556640625e+01 -4.2499500274658203e+01 -6.0326000213623047e+01 -9.6775703430175781e+01 -4.3697700500488281e+01 -6.2868103027343750e+01 -9.6782806396484375e+01 -4.2957298278808594e+01 -6.0176200866699219e+01 -9.6461402893066406e+01 -4.2520999908447266e+01 -6.0319000244140625e+01 -9.7232696533203125e+01 -4.3902900695800781e+01 -6.2823303222656250e+01 -9.7248504638671875e+01 -4.3331398010253906e+01 -6.0274299621582031e+01 -9.6809402465820312e+01 -4.2993198394775391e+01 -6.0164398193359375e+01 -9.7250297546386719e+01 -4.3267700195312500e+01 -6.0074699401855469e+01 -9.7218994140625000e+01 -4.4394897460937500e+01 -6.5017700195312500e+01 -9.6775703430175781e+01 -4.4162197113037109e+01 -6.5621200561523438e+01 -9.7217201232910156e+01 -4.4460300445556641e+01 -6.5585899353027344e+01 -9.6775596618652344e+01 -4.4355300903320312e+01 -6.8402900695800781e+01 -9.7214996337890625e+01 -4.4536197662353516e+01 -6.6244201660156250e+01 -9.6452301025390625e+01 -4.3869598388671875e+01 -6.8413505554199219e+01 -9.6452301025390625e+01 -4.3679698944091797e+01 -6.5678199768066406e+01 -9.6461402893066406e+01 1.4090499877929688e+00 -4.0814399719238281e+01 -9.6809402465820312e+01 1.5123500823974609e+00 -4.0328300476074219e+01 -9.6663307189941406e+01 -3.9777202606201172e+00 -3.9866802215576172e+01 -9.6802696228027344e+01 -4.0623497962951660e+00 -3.9738403320312500e+01 -9.6825500488281250e+01 -4.0556797981262207e+00 -3.9720901489257812e+01 -9.6822402954101562e+01 -4.0743403434753418e+00 -3.9720100402832031e+01 -9.7022102355957031e+01 -4.1956300735473633e+00 -3.9535999298095703e+01 -9.6461402893066406e+01 -1.3203599452972412e+00 -4.0378498077392578e+01 -9.6510406494140625e+01 -3.8216700553894043e+00 -4.0105899810791016e+01 -9.6809402465820312e+01 -1.2661799192428589e+00 -3.9884498596191406e+01 -9.6483299255371094e+01 -3.7501401901245117e+00 -4.0217300415039062e+01 -9.6338699340820312e+01 -3.3678998947143555e+00 -4.0812599182128906e+01 -9.6809402465820312e+01 -3.8596599578857422e+01 -5.1954399108886719e+01 -9.6809402465820312e+01 -4.0701602935791016e+01 -5.5025398254394531e+01 -9.7309402465820312e+01 -4.0952602386474609e+01 -5.4879402160644531e+01 -9.6809402465820312e+01 -4.1985000610351562e+01 -5.7537899017333984e+01 -9.7278900146484375e+01 -4.2162101745605469e+01 -5.7457099914550781e+01 -9.7299201965332031e+01 -4.1379398345947266e+01 -5.5603900909423828e+01 -9.6461402893066406e+01 -3.8208499908447266e+01 -5.2264701843261719e+01 -9.6461402893066406e+01 -4.0271999359130859e+01 -5.5275398254394531e+01 -9.6461402893066406e+01 -4.1530799865722656e+01 -5.7739803314208984e+01 -9.7002700805664062e+01 -4.6090502738952637e+00 -5.3110698699951172e+01 -9.7022102355957031e+01 -4.6219201087951660e+00 -3.9955398559570312e+01 -9.6823501586914062e+01 -4.4396500587463379e+00 -5.3003299713134766e+01 -9.6338699340820312e+01 -3.3701601028442383e+00 -4.0814701080322266e+01 -9.6338699340820312e+01 -3.3706400394439697e+00 -5.2335899353027344e+01 -9.6483398437500000e+01 -3.9519100189208984e+00 -4.0413101196289062e+01 -9.6822502136230469e+01 -4.4403100013732910e+00 -4.0078899383544922e+01 -9.6663307189941406e+01 -4.2954702377319336e+00 -4.0177402496337891e+01 -9.6642204284667969e+01 -4.2681698799133301e+00 -5.2894599914550781e+01 -9.6510406494140625e+01 -4.0603899955749512e+00 -4.0338100433349609e+01 -9.6465698242187500e+01 -3.9553599357604980e+00 -5.2698299407958984e+01 -9.6445701599121094e+01 -3.9198999404907227e+00 -5.2676101684570312e+01 -9.6461402893066406e+01 -3.3993099212646484e+01 -4.8184303283691406e+01 -9.6461402893066406e+01 -3.1355102539062500e+01 -4.6472797393798828e+01 -9.6809402465820312e+01 -3.4290500640869141e+01 -4.7786102294921875e+01 -9.6809402465820312e+01 -3.1598199844360352e+01 -4.6039398193359375e+01 -9.6809402465820312e+01 -3.6689502716064453e+01 -4.9841999053955078e+01 -9.6461402893066406e+01 -3.6341400146484375e+01 -5.0196701049804688e+01 -9.6338699340820312e+01 -3.3684999942779541e+00 -5.2338298797607422e+01 -9.6461402893066406e+01 -2.1458301544189453e+00 -5.3068801879882812e+01 -9.6357704162597656e+01 -3.4356698989868164e+00 -5.2431098937988281e+01 -9.6461402893066406e+01 -3.4757201671600342e+00 -5.2918601989746094e+01 -9.6465698242187500e+01 -3.7707700729370117e+00 -5.2895198822021484e+01 -9.6445701599121094e+01 -3.7466299533843994e+00 -5.2861099243164062e+01 -9.6642204284667969e+01 -3.9832601547241211e+00 -5.3195598602294922e+01 -9.6809402465820312e+01 -3.5149400234222412e+00 -5.3413997650146484e+01 -9.6823699951171875e+01 -4.0986499786376953e+00 -5.3361698150634766e+01 -9.7002700805664062e+01 -4.2125000953674316e+00 -5.3525501251220703e+01 -9.6809402465820312e+01 -2.2183101177215576e+00 -5.3560497283935547e+01 -9.6809402465820312e+01 -9.3766403198242188e-01 -5.3795200347900391e+01 -9.6461402893066406e+01 -8.3092904090881348e-01 -5.3309799194335938e+01 -9.6338699340820312e+01 -2.4240699768066406e+01 -4.4696498870849609e+01 -9.6461402893066406e+01 -2.6093700408935547e+01 -4.4448699951171875e+01 -9.6821601867675781e+01 -2.3560001373291016e+01 -4.3529201507568359e+01 -9.6678894042968750e+01 -2.3641300201416016e+01 -4.3664699554443359e+01 -9.6809402465820312e+01 -2.6205898284912109e+01 -4.3964599609375000e+01 -9.6533203125000000e+01 -2.3777799606323242e+01 -4.3895000457763672e+01 -9.6492294311523438e+01 -2.3875101089477539e+01 -4.4063602447509766e+01 -9.7041198730468750e+01 -2.3434799194335938e+01 -4.3320701599121094e+01 -9.7170600891113281e+01 -2.3393598556518555e+01 -4.3252899169921875e+01 -9.6809402465820312e+01 -2.8972299575805664e+01 -4.4808300018310547e+01 -9.6461402893066406e+01 -2.8794401168823242e+01 -4.5272296905517578e+01 -9.6461402893066406e+01 -8.3014100790023804e-01 -5.3309997558593750e+01 -9.6809402465820312e+01 -9.3735700845718384e-01 -5.3795200347900391e+01 -9.6461402893066406e+01 5.2989298105239868e-01 -5.3690502166748047e+01 -9.6461402893066406e+01 1.8115000724792480e+00 -5.4217700958251953e+01 -9.6461402893066406e+01 3.0227298736572266e+00 -5.4905998229980469e+01 -9.6809402465820312e+01 3.6879199743270874e-01 -5.4160598754882812e+01 -9.6809402465820312e+01 1.5944200754165649e+00 -5.4664802551269531e+01 -9.6809402465820312e+01 2.7493798732757568e+00 -5.5321102142333984e+01 -9.7031898498535156e+01 -2.3073699951171875e+01 -5.7131099700927734e+01 -9.7041198730468750e+01 -2.2966800689697266e+01 -4.3744998931884766e+01 -9.6821899414062500e+01 -2.3260499954223633e+01 -5.7034896850585938e+01 -9.6821800231933594e+01 -2.3161298751831055e+01 -4.3888698577880859e+01 -9.6672996520996094e+01 -2.3392999649047852e+01 -5.6966701507568359e+01 -9.6468704223632812e+01 -2.3724901199340820e+01 -5.6797599792480469e+01 -9.6492500305175781e+01 -2.3655900955200195e+01 -4.4257999420166016e+01 -9.6533203125000000e+01 -2.3501598358154297e+01 -4.4141300201416016e+01 -9.6678894042968750e+01 -2.3287799835205078e+01 -4.3982101440429688e+01 -9.6338699340820312e+01 -2.4325700759887695e+01 -5.6496398925781250e+01 -9.6464996337890625e+01 -2.3742399215698242e+01 -5.6788898468017578e+01 -9.6338699340820312e+01 -2.4238300323486328e+01 -4.4698600769042969e+01 -9.6461402893066406e+01 3.0242199897766113e+00 -5.4907001495361328e+01 -9.6809402465820312e+01 2.7499799728393555e+00 -5.5321399688720703e+01 -9.6461402893066406e+01 4.1132602691650391e+00 -5.5761402130126953e+01 -9.6461402893066406e+01 5.0234198570251465e+00 -5.6753097534179688e+01 -9.6461402893066406e+01 5.8105001449584961e+00 -5.7956501007080078e+01 -9.6809402465820312e+01 3.7754800319671631e+00 -5.6125999450683594e+01 -9.6809402465820312e+01 4.6314601898193359e+00 -5.7058498382568359e+01 -9.6809402465820312e+01 5.3740696907043457e+00 -5.8194202423095703e+01 -9.6809402465820312e+01 -2.9862201690673828e+01 -6.1365802764892578e+01 -9.6809402465820312e+01 -2.9862201690673828e+01 -6.1365898132324219e+01 -9.6461402893066406e+01 -3.0242898941040039e+01 -6.1046398162841797e+01 -9.6461402893066406e+01 -3.0242700576782227e+01 -6.1046203613281250e+01 -9.6672996520996094e+01 -2.3623399734497070e+01 -5.7267498016357422e+01 -9.6822097778320312e+01 -2.3525100708007812e+01 -5.7378601074218750e+01 -9.6809402465820312e+01 -2.6792400360107422e+01 -5.8758197784423828e+01 -9.7031898498535156e+01 -2.3386598587036133e+01 -5.7535202026367188e+01 -9.6468704223632812e+01 -2.3871900558471680e+01 -5.6991699218750000e+01 -9.6461402893066406e+01 -2.7045499801635742e+01 -5.8330600738525391e+01 -9.6464996337890625e+01 -2.3885099411010742e+01 -5.6977397918701172e+01 -9.6338699340820312e+01 -2.4327499389648438e+01 -5.6498798370361328e+01 -9.6888000488281250e+01 6.3875298500061035e+00 -6.2526702880859375e+01 -9.6557601928710938e+01 6.7673301696777344e+00 -6.2511898040771484e+01 -9.6819900512695312e+01 6.4658498764038086e+00 -6.2523605346679688e+01 -9.6809402465820312e+01 6.4272899627685547e+00 -6.2059997558593750e+01 -9.6461402893066406e+01 6.9226598739624023e+00 -6.2020500183105469e+01 -9.6498199462890625e+01 6.9643797874450684e+00 -6.2504299163818359e+01 -9.6339797973632812e+01 7.4894399642944336e+00 -6.2483898162841797e+01 -9.6809295654296875e+01 6.2448401451110840e+00 -6.0699798583984375e+01 -9.6809295654296875e+01 5.9009799957275391e+00 -5.9400199890136719e+01 -9.6809402465820312e+01 5.3741898536682129e+00 -5.8194499969482422e+01 -9.6461402893066406e+01 6.7326397895812988e+00 -6.0605102539062500e+01 -9.6461402893066406e+01 6.3709001541137695e+00 -5.9238800048828125e+01 -9.6461402893066406e+01 5.8108601570129395e+00 -5.7957298278808594e+01 -9.6809402465820312e+01 -3.1699199676513672e+01 -6.4500503540039062e+01 -9.6461402893066406e+01 -3.2928897857666016e+01 -6.8055694580078125e+01 -9.6496406555175781e+01 -3.2958499908447266e+01 -6.9316398620605469e+01 -9.6340995788574219e+01 -3.3458900451660156e+01 -6.9326805114746094e+01 -9.6809402465820312e+01 -3.2432701110839844e+01 -6.8083801269531250e+01 -9.6888000488281250e+01 -3.2381603240966797e+01 -6.9304306030273438e+01 -9.6819900512695312e+01 -3.2459899902343750e+01 -6.9305892944335938e+01 -9.6557601928710938e+01 -3.2761600494384766e+01 -6.9312202453613281e+01 -9.6461402893066406e+01 -3.2164302825927734e+01 -6.4325302124023438e+01 -9.6809402465820312e+01 6.4427199363708496e+00 -6.3890197753906250e+01 -9.6461402893066406e+01 6.9389300346374512e+00 -6.3916496276855469e+01 -9.6461402893066406e+01 6.6062197685241699e+00 -6.6320899963378906e+01 -9.6809402465820312e+01 6.1223502159118652e+00 -6.6207901000976562e+01 -9.6809402465820312e+01 4.8388800621032715e+00 -6.9341697692871094e+01 -9.6461402893066406e+01 5.2600498199462891e+00 -6.9605499267578125e+01 -9.6809402465820312e+01 -3.1544000625610352e+01 -7.3467201232910156e+01 -9.6461402893066406e+01 -3.1986900329589844e+01 -7.3692398071289062e+01 -9.6461402893066406e+01 -3.0673601150512695e+01 -7.5483497619628906e+01 -9.6809402465820312e+01 -3.0327400207519531e+01 -7.5126899719238281e+01 -9.6809295654296875e+01 -3.2326797485351562e+01 -7.0899200439453125e+01 -9.6461402893066406e+01 -3.2818500518798828e+01 -7.0971305847167969e+01 -9.6461402893066406e+01 4.0257601737976074e+00 -7.1294700622558594e+01 -9.6809402465820312e+01 3.6469099521636963e+00 -7.0973098754882812e+01 -9.6809402465820312e+01 2.2629499435424805e+00 -7.2383796691894531e+01 -9.6461402893066406e+01 2.5918500423431396e+00 -7.2756294250488281e+01 -9.6809402465820312e+01 3.3561301231384277e-01 -7.3816398620605469e+01 -9.6461402893066406e+01 5.9859400987625122e-01 -7.4238098144531250e+01 -9.6461402893066406e+01 -2.7787599563598633e+01 -7.7477096557617188e+01 -9.6461402893066406e+01 -2.5620000839233398e+01 -7.8239097595214844e+01 -9.6809402465820312e+01 -2.7576299667358398e+01 -7.7027297973632812e+01 -9.6809402465820312e+01 -2.5500699996948242e+01 -7.7756706237792969e+01 -9.6809402465820312e+01 -2.9031600952148438e+01 -7.6191795349121094e+01 -9.6461402893066406e+01 -2.9314001083374023e+01 -7.6600700378417969e+01 -9.6461402893066406e+01 -1.2210600376129150e+00 -7.5253799438476562e+01 -9.6809402465820312e+01 -1.4420700073242188e+00 -7.4808700561523438e+01 -9.6809402465820312e+01 -3.2948801517486572e+00 -7.5624603271484375e+01 -9.6461402893066406e+01 -3.1152400970458984e+00 -7.6087898254394531e+01 -9.6809402465820312e+01 -5.7906498908996582e+00 -7.6439094543457031e+01 -9.6461402893066406e+01 -5.6614298820495605e+00 -7.6918899536132812e+01 -9.6461402893066406e+01 -2.1276599884033203e+01 -7.8821304321289062e+01 -9.6461402893066406e+01 -1.9551300048828125e+01 -7.8815696716308594e+01 -9.6809402465820312e+01 -2.1260698318481445e+01 -7.8324600219726562e+01 -9.6809402465820312e+01 -1.9569499969482422e+01 -7.8319099426269531e+01 -9.6809402465820312e+01 -2.2930599212646484e+01 -7.8208297729492188e+01 -9.6461402893066406e+01 -2.2984399795532227e+01 -7.8702301025390625e+01 -9.6461402893066406e+01 -8.1939697265625000e+00 -7.7537902832031250e+01 -9.6888000488281250e+01 -1.2267099380493164e+01 -7.7675094604492188e+01 -9.6809402465820312e+01 -1.0831899642944336e+01 -7.7535499572753906e+01 -9.6819900512695312e+01 -1.2257900238037109e+01 -7.7752998352050781e+01 -9.6557601928710938e+01 -1.2222499847412109e+01 -7.8052604675292969e+01 -9.6461402893066406e+01 -1.0752200126647949e+01 -7.8026100158691406e+01 -9.6498603820800781e+01 -1.2199500083923340e+01 -7.8248504638671875e+01 -9.6339599609375000e+01 -1.2137199401855469e+01 -7.8776100158691406e+01 -9.6809402465820312e+01 -8.3000097274780273e+00 -7.7052398681640625e+01 -9.6461402893066406e+01 -1.4367799758911133e+01 -7.8468894958496094e+01 -9.6494804382324219e+01 -1.3809800148010254e+01 -7.8419700622558594e+01 -9.6342399597167969e+01 -1.3757800102233887e+01 -7.8894699096679688e+01 -9.6809402465820312e+01 -1.4418600082397461e+01 -7.7974601745605469e+01 -9.6888000488281250e+01 -1.3872499465942383e+01 -7.7846305847167969e+01 -9.6819900512695312e+01 -1.3864000320434570e+01 -7.7924201965332031e+01 -9.6557601928710938e+01 -1.3831199645996094e+01 -7.8224197387695312e+01 -9.6809402465820312e+01 -1.6986999511718750e+01 -7.8188598632812500e+01 -9.6461402893066406e+01 -1.6954500198364258e+01 -7.8684501647949219e+01 -9.6448501586914062e+01 -4.3591800689697266e+01 -1.1037500000000000e+02 -9.6450096130371094e+01 -4.3441799163818359e+01 -1.0901599884033203e+02 -9.6773994445800781e+01 -4.3930900573730469e+01 -1.0894899749755859e+02 -9.6764495849609375e+01 -4.3916797637939453e+01 -1.0895100402832031e+02 -9.6761802673339844e+01 -4.4070899963378906e+01 -1.1033399963378906e+02 -9.6451797485351562e+01 -4.3450099945068359e+01 -1.0901499938964844e+02 -9.7219696044921875e+01 -4.4364799499511719e+01 -1.1030899810791016e+02 -9.7223297119140625e+01 -4.4239402770996094e+01 -1.0890799713134766e+02 -9.6557601928710938e+01 -4.3904800415039062e+01 -1.1354699707031250e+02 -9.6776199340820312e+01 -4.4156101226806641e+01 -1.1355199432373047e+02 -9.6761802673339844e+01 -4.4175899505615234e+01 -1.1311199951171875e+02 -9.6791107177734375e+01 -4.4173301696777344e+01 -1.1355199432373047e+02 -9.6888000488281250e+01 -4.4284797668457031e+01 -1.1355400085449219e+02 -9.6761802673339844e+01 -4.4156303405761719e+01 -1.1172200012207031e+02 -9.7216896057128906e+01 -4.4465198516845703e+01 -1.1143199920654297e+02 -9.7216300964355469e+01 -4.4484203338623047e+01 -1.1311499786376953e+02 -9.7216194152832031e+01 -4.4489200592041016e+01 -1.1355799865722656e+02 -9.6486892700195312e+01 -4.3675998687744141e+01 -1.1354299926757812e+02 -9.6490303039550781e+01 -4.3686901092529297e+01 -1.1354299926757812e+02 -9.6448501586914062e+01 -4.3695098876953125e+01 -1.1310700225830078e+02 -9.6340698242187500e+01 -4.3202899932861328e+01 -1.1353400421142578e+02 -9.6448501586914062e+01 -4.3675800323486328e+01 -1.1174099731445312e+02 -9.6452804565429688e+01 -4.3560600280761719e+01 -1.1575900268554688e+02 -9.6777793884277344e+01 -4.4043998718261719e+01 -1.1581500244140625e+02 -9.6777793884277344e+01 -4.3626201629638672e+01 -1.1812400054931641e+02 -9.6777793884277344e+01 -4.2848598480224609e+01 -1.2038500213623047e+02 -9.6813697814941406e+01 -4.2870700836181641e+01 -1.2039499664306641e+02 -9.7220298767089844e+01 -4.4346401214599609e+01 -1.1584999847412109e+02 -9.7220298767089844e+01 -4.4344398498535156e+01 -1.1588200378417969e+02 -9.7237106323242188e+01 -4.3754497528076172e+01 -1.1815599822998047e+02 -9.7254402160644531e+01 -4.3141799926757812e+01 -1.2051599884033203e+02 -9.6452804565429688e+01 -4.3154602050781250e+01 -1.1800499725341797e+02 -9.6452804565429688e+01 -4.2404499053955078e+01 -1.2018699645996094e+02 -9.6464797973632812e+01 -4.2420902252197266e+01 -1.2019400024414062e+02 -9.6773994445800781e+01 -4.3699398040771484e+01 -1.0755400085449219e+02 -9.6451797485351562e+01 -4.3223300933837891e+01 -1.0764800262451172e+02 -9.6338699340820312e+01 -4.2245498657226562e+01 -1.0596899414062500e+02 -9.6475700378417969e+01 -4.2761699676513672e+01 -1.0552600097656250e+02 -9.6462898254394531e+01 -4.2713600158691406e+01 -1.0556700134277344e+02 -9.6451797485351562e+01 -4.2916801452636719e+01 -1.0629700469970703e+02 -9.7008598327636719e+01 -4.3277099609375000e+01 -1.0507500457763672e+02 -9.6786399841308594e+01 -4.3106899261474609e+01 -1.0522399902343750e+02 -9.6773994445800781e+01 -4.3386699676513672e+01 -1.0617499542236328e+02 -9.6654800415039062e+01 -4.3006198883056641e+01 -1.0531300354003906e+02 -9.7247100830078125e+01 -4.3383201599121094e+01 -1.0498099517822266e+02 -9.7239006042480469e+01 -4.3676700592041016e+01 -1.0610099792480469e+02 -9.7233398437500000e+01 -4.3880199432373047e+01 -1.0687699890136719e+02 -9.7230300903320312e+01 -4.3989799499511719e+01 -1.0749700164794922e+02 -9.7301002502441406e+01 -4.1370601654052734e+01 -1.2319599914550781e+02 -9.6809402465820312e+01 -4.1255298614501953e+01 -1.2309799957275391e+02 -9.6461402893066406e+01 -4.1728298187255859e+01 -1.2153600311279297e+02 -9.6809402465820312e+01 -4.2155097961425781e+01 -1.2179100036621094e+02 -9.7275894165039062e+01 -4.2336898803710938e+01 -1.2188800048828125e+02 -9.7264999389648438e+01 -4.2755802154541016e+01 -1.2132199859619141e+02 -9.6461402893066406e+01 -4.0865901947021484e+01 -1.2278900146484375e+02 -9.6461402893066406e+01 -3.9037399291992188e+01 -1.2459799957275391e+02 -9.6809402465820312e+01 -3.9341598510742188e+01 -1.2499099731445312e+02 -9.6338699340820312e+01 -3.2949298858642578e+01 -1.0512799835205078e+02 -9.6338699340820312e+01 -4.2243202209472656e+01 -1.0596700286865234e+02 -9.6498497009277344e+01 -3.2532100677490234e+01 -1.0451000213623047e+02 -9.6468200683593750e+01 -4.2561798095703125e+01 -1.0540899658203125e+02 -9.6549102783203125e+01 -3.2399898529052734e+01 -1.0431499481201172e+02 -9.6475700378417969e+01 -4.2580200195312500e+01 -1.0537700653076172e+02 -9.6681106567382812e+01 -3.2264797210693359e+01 -1.0411400604248047e+02 -9.6821998596191406e+01 -3.2176799774169922e+01 -1.0398300170898438e+02 -9.6822593688964844e+01 -4.2823398590087891e+01 -1.0494599914550781e+02 -9.7302299499511719e+01 -4.1985900878906250e+01 -1.0454499816894531e+02 -9.7008598327636719e+01 -4.2916301727294922e+01 -1.0478099822998047e+02 -9.7277702331542969e+01 -4.2992301940917969e+01 -1.0464599609375000e+02 -9.6654800415039062e+01 -4.2739700317382812e+01 -1.0509500122070312e+02 -9.7052001953125000e+01 -3.2033000946044922e+01 -1.0376899719238281e+02 -9.6461402893066406e+01 -3.7798198699951172e+01 -1.2544000244140625e+02 -9.6809402465820312e+01 -3.8051601409912109e+01 -1.2586699676513672e+02 -9.6461402893066406e+01 -3.6471000671386719e+01 -1.2612399291992188e+02 -9.6461402893066406e+01 -3.3806598663330078e+01 -1.2701000213623047e+02 -9.6809501647949219e+01 -3.6673099517822266e+01 -1.2657800292968750e+02 -9.6809402465820312e+01 -3.3920299530029297e+01 -1.2749401092529297e+02 -9.6461402893066406e+01 -3.2396701812744141e+01 -1.0548500061035156e+02 -9.6338699340820312e+01 -3.2947200775146484e+01 -1.0513000488281250e+02 -9.6461402893066406e+01 -3.2322700500488281e+01 -1.0484100341796875e+02 -9.6809402465820312e+01 -3.1828798294067383e+01 -1.0489600372314453e+02 -9.6809402465820312e+01 -3.1903301239013672e+01 -1.0554399871826172e+02 -9.6681106567382812e+01 -3.1919900894165039e+01 -1.0446400451660156e+02 -9.6821899414062500e+01 -3.1787500381469727e+01 -1.0437699890136719e+02 -9.7007995605468750e+01 -3.1612600326538086e+01 -1.0426300048828125e+02 -9.7052001953125000e+01 -3.1571197509765625e+01 -1.0423600006103516e+02 -9.6459701538085938e+01 -3.2473098754882812e+01 -1.0482299804687500e+02 -9.6498397827148438e+01 -3.2321598052978516e+01 -1.0472500610351562e+02 -9.6549102783203125e+01 -3.2123001098632812e+01 -1.0459700012207031e+02 -9.6461402893066406e+01 -3.0981399536132812e+01 -1.2744300079345703e+02 -9.6888099670410156e+01 -2.6869899749755859e+01 -1.2797699737548828e+02 -9.6809402465820312e+01 -2.8124698638916016e+01 -1.2798699951171875e+02 -9.6461402893066406e+01 -2.8145101547241211e+01 -1.2749099731445312e+02 -9.6557800292968750e+01 -2.6916601181030273e+01 -1.2759999847412109e+02 -9.6819900512695312e+01 -2.6879501342773438e+01 -1.2789900970458984e+02 -9.6339004516601562e+01 -2.7008800506591797e+01 -1.2685200500488281e+02 -9.6371597290039062e+01 -2.6973899841308594e+01 -1.2713499450683594e+02 -9.6480598449707031e+01 -2.6940299987792969e+01 -1.2740699768066406e+02 -9.6809402465820312e+01 -3.1020698547363281e+01 -1.2793800354003906e+02 -9.6339096069335938e+01 -3.2988998413085938e+01 -1.0819300079345703e+02 -9.6557601928710938e+01 -3.2245399475097656e+01 -1.0814499664306641e+02 -9.6499694824218750e+01 -3.2442497253417969e+01 -1.0815799713134766e+02 -9.6461402893066406e+01 -3.2472099304199219e+01 -1.0754199981689453e+02 -9.6888000488281250e+01 -3.1866100311279297e+01 -1.0812100219726562e+02 -9.6819900512695312e+01 -3.1944301605224609e+01 -1.0812599945068359e+02 -9.6809402465820312e+01 -3.1975601196289062e+01 -1.0751999664306641e+02 -9.6461402893066406e+01 -3.2483901977539062e+01 -1.0685399627685547e+02 -9.6461402893066406e+01 -3.2458999633789062e+01 -1.0616799926757812e+02 -9.6809402465820312e+01 -3.1986900329589844e+01 -1.0685900115966797e+02 -9.6809402465820312e+01 -3.1963098526000977e+01 -1.0620000457763672e+02 -9.6339004516601562e+01 7.5678200721740723e+00 -1.2122000122070312e+02 -9.6550704956054688e+01 6.8316998481750488e+00 -1.2187799835205078e+02 -9.6732299804687500e+01 6.2006101608276367e+00 -1.2244200134277344e+02 -9.6822097778320312e+01 6.1173400878906250e+00 -1.2251599884033203e+02 -9.6809402465820312e+01 -3.1843301773071289e+01 -1.0920899963378906e+02 -9.6461402893066406e+01 -3.0138099670410156e+01 -1.1301699829101562e+02 -9.6809402465820312e+01 -3.0728500366210938e+01 -1.1194699859619141e+02 -9.6809402465820312e+01 -2.9908899307250977e+01 -1.1257600402832031e+02 -9.6461402893066406e+01 -3.2335502624511719e+01 -1.0927700042724609e+02 -9.6809402465820312e+01 -3.1328901290893555e+01 -1.1104500579833984e+02 -9.6461402893066406e+01 -3.1777099609375000e+01 -1.1125899505615234e+02 -9.6461402893066406e+01 -3.1094100952148438e+01 -1.1228399658203125e+02 -9.6339004516601562e+01 7.5783100128173828e+00 -1.2122900390625000e+02 -9.6550704956054688e+01 7.0475296974182129e+00 -1.2206099700927734e+02 -9.6444297790527344e+01 7.0524201393127441e+00 -1.3034201049804688e+02 -9.6467704772949219e+01 7.0150499343872070e+00 -1.3037100219726562e+02 -9.6732398986816406e+01 6.5923900604248047e+00 -1.3070700073242188e+02 -9.6822097778320312e+01 6.5324301719665527e+00 -1.2286900329589844e+02 -9.6732299804687500e+01 6.5924501419067383e+00 -1.2277500152587891e+02 -9.6821800231933594e+01 6.5326099395751953e+00 -1.3075399780273438e+02 -9.6461402893066406e+01 -2.5496099472045898e+01 -1.1365100097656250e+02 -9.6480598449707031e+01 -2.4967700958251953e+01 -1.1360300445556641e+02 -9.6371597290039062e+01 -2.4928699493408203e+01 -1.1387500000000000e+02 -9.6339096069335938e+01 -2.4889200210571289e+01 -1.1415000152587891e+02 -9.6809402465820312e+01 -2.5540399551391602e+01 -1.1315599822998047e+02 -9.6888099670410156e+01 -2.5049301147460938e+01 -1.1303500366210938e+02 -9.6819900512695312e+01 -2.5038101196289062e+01 -1.1311299896240234e+02 -9.6557601928710938e+01 -2.4995300292968750e+01 -1.1341100311279297e+02 -9.6461402893066406e+01 -2.7082000732421875e+01 -1.1370600128173828e+02 -9.6809295654296875e+01 -2.7068401336669922e+01 -1.1320899963378906e+02 -9.6809402465820312e+01 -2.8528999328613281e+01 -1.1304999542236328e+02 -9.6461402893066406e+01 -2.8629100799560547e+01 -1.1353699493408203e+02 -9.6444297790527344e+01 7.2684302330017090e+00 -1.3052299499511719e+02 -9.6464698791503906e+01 1.6590200424194336e+01 -1.2893701171875000e+02 -9.6723899841308594e+01 1.6887199401855469e+01 -1.2930200195312500e+02 -9.6821800231933594e+01 6.9516901969909668e+00 -1.3110600280761719e+02 -9.6468200683593750e+01 1.6601900100708008e+01 -1.2895199584960938e+02 -9.6732398986816406e+01 6.9881100654602051e+00 -1.3103898620605469e+02 -9.6467704772949219e+01 7.2456598281860352e+00 -1.3056500244140625e+02 -9.6823295593261719e+01 1.6935798645019531e+01 -1.2936100769042969e+02 -9.6346694946289062e+01 7.4078397750854492e+00 -1.0854600524902344e+02 -9.6528800964355469e+01 6.8843998908996582e+00 -1.0822000122070312e+02 -9.6724098205566406e+01 6.3230400085449219e+00 -1.0786899566650391e+02 -9.6823501586914062e+01 6.2373299598693848e+00 -1.0781600189208984e+02 -9.6823295593261719e+01 1.7231199264526367e+01 -1.2901000976562500e+02 -9.6823501586914062e+01 1.7231399536132812e+01 -1.2086900329589844e+02 -9.6723899841308594e+01 1.7164199829101562e+01 -1.2897200012207031e+02 -9.6468200683593750e+01 1.6770200729370117e+01 -1.2875099182128906e+02 -9.6723899841308594e+01 1.7164199829101562e+01 -1.2079299926757812e+02 -9.6464698791503906e+01 1.6753999710083008e+01 -1.2874198913574219e+02 -9.6528594970703125e+01 1.6725000381469727e+01 -1.2030000305175781e+02 -9.6346801757812500e+01 1.6315999984741211e+01 -1.1984100341796875e+02 -9.6346694946289062e+01 7.4507598876953125e+00 -1.0849600219726562e+02 -9.6464698791503906e+01 7.0120100975036621e+00 -9.8046897888183594e+01 -9.6528800964355469e+01 7.0410399436950684e+00 -1.0803399658203125e+02 -9.6724098205566406e+01 6.6016297340393066e+00 -1.0753900146484375e+02 -9.6468200683593750e+01 6.9958000183105469e+00 -9.8037895202636719e+01 -9.6823501586914062e+01 6.5345802307128906e+00 -1.0746399688720703e+02 -9.6723899841308594e+01 6.6018099784851074e+00 -9.7817100524902344e+01 -9.6823295593261719e+01 6.5347499847412109e+00 -9.7779495239257812e+01 -9.6723899841308594e+01 1.7441799163818359e+01 -1.2046399688720703e+02 -9.6528594970703125e+01 1.6881101608276367e+01 -1.2011499786376953e+02 -9.6464698791503906e+01 3.1785902023315430e+01 -1.1756700134277344e+02 -9.6346801757812500e+01 1.6358999252319336e+01 -1.1979000091552734e+02 -9.6823501586914062e+01 1.7527500152587891e+01 -1.2051699829101562e+02 -9.6468101501464844e+01 3.1797498703002930e+01 -1.1758200073242188e+02 -9.6723899841308594e+01 3.2082698822021484e+01 -1.1793199920654297e+02 -9.6823204040527344e+01 3.2131099700927734e+01 -1.1799199676513672e+02 -9.6444297790527344e+01 1.6497600555419922e+01 -9.6266502380371094e+01 -9.6464698791503906e+01 7.1757998466491699e+00 -9.7852104187011719e+01 -9.6723899841308594e+01 6.8787899017333984e+00 -9.7487503051757812e+01 -9.6821800231933594e+01 1.6814300537109375e+01 -9.5683593750000000e+01 -9.6468200683593750e+01 7.1640601158142090e+00 -9.7837699890136719e+01 -9.6732398986816406e+01 1.6777898788452148e+01 -9.5750602722167969e+01 -9.6467704772949219e+01 1.6520301818847656e+01 -9.6224601745605469e+01 -9.6823295593261719e+01 6.8302698135375977e+00 -9.7427894592285156e+01 -9.6464698791503906e+01 3.1950000762939453e+01 -1.1737200164794922e+02 -9.6723899841308594e+01 3.2360198974609375e+01 -1.1760299682617188e+02 -9.6468101501464844e+01 3.1966001510620117e+01 -1.1738099670410156e+02 -9.6821800231933594e+01 3.2429298400878906e+01 -1.0363700103759766e+02 -9.6444198608398438e+01 3.1909000396728516e+01 -1.0405000305175781e+02 -9.6467803955078125e+01 3.1946800231933594e+01 -1.0401999664306641e+02 -9.6732398986816406e+01 3.2369598388671875e+01 -1.0368399810791016e+02 -9.6823204040527344e+01 3.2427299499511719e+01 -1.1764000701904297e+02 -9.6338798522949219e+01 1.6179998397827148e+01 -1.0714299774169922e+02 -9.6552001953125000e+01 1.6718101501464844e+01 -1.0628700256347656e+02 -9.6444297790527344e+01 1.6713600158691406e+01 -9.6448104858398438e+01 -9.6467704772949219e+01 1.6750900268554688e+01 -9.6418502807617188e+01 -9.6732398986816406e+01 1.7173599243164062e+01 -9.6083297729492188e+01 -9.6822097778320312e+01 1.7233600616455078e+01 -1.0546799468994141e+02 -9.6732398986816406e+01 1.7173599243164062e+01 -1.0556300354003906e+02 -9.6821800231933594e+01 1.7233400344848633e+01 -9.6035896301269531e+01 -9.6467803955078125e+01 3.1715900421142578e+01 -1.0382600402832031e+02 -9.6732398986816406e+01 1.7569999694824219e+01 -1.0589600372314453e+02 -9.6732398986816406e+01 3.1973201751708984e+01 -1.0335200500488281e+02 -9.6822097778320312e+01 1.7653400421142578e+01 -1.0581999969482422e+02 -9.6821800231933594e+01 3.2009502410888672e+01 -1.0328400421142578e+02 -9.6444198608398438e+01 3.1692899703979492e+01 -1.0386899566650391e+02 -9.6338798522949219e+01 1.6187500000000000e+01 -1.0714899444580078e+02 -9.6552001953125000e+01 1.6936300277709961e+01 -1.0647000122070312e+02 -9.7251197814941406e+01 -4.3317600250244141e+01 -3.0610799789428711e-01 -9.7352401733398438e+01 -4.3387401580810547e+01 -3.1859499216079712e-01 -9.7257102966308594e+01 -4.3355899810791016e+01 -2.6000300049781799e-01 -9.7347496032714844e+01 -4.3394302368164062e+01 -3.0348500609397888e-01 -9.7270599365234375e+01 -4.3444000244140625e+01 -1.5399698913097382e-01 -9.7302902221679688e+01 -4.3457199096679688e+01 -1.6490401327610016e-01 -9.7281097412109375e+01 -4.3465801239013672e+01 -1.1129000037908554e-01 -9.7299705505371094e+01 -4.3034500122070312e+01 -4.3309500813484192e-01 -9.7346000671386719e+01 -4.3188400268554688e+01 -4.3410900235176086e-01 -9.7270599365234375e+01 -4.3146800994873047e+01 -4.0558800101280212e-01 -9.7354797363281250e+01 -4.3243099212646484e+01 -4.1789600253105164e-01 -9.7263999938964844e+01 -4.3205497741699219e+01 -3.7140500545501709e-01 -9.7359100341796875e+01 -4.3269702911376953e+01 -4.0990900993347168e-01 -9.7360298156738281e+01 -4.3339698791503906e+01 -3.6708301305770874e-01 -9.6686500549316406e+01 -4.2828102111816406e+01 6.5408103168010712e-02 -9.6430297851562500e+01 -4.2491500854492188e+01 5.5997800827026367e-01 -9.6425300598144531e+01 -4.2546699523925781e+01 6.0500895977020264e-01 -9.6686500549316406e+01 -4.3032299041748047e+01 2.3820200562477112e-01 -9.6670799255371094e+01 -4.2936298370361328e+01 1.4471200108528137e-01 -9.6430297851562500e+01 -4.2600299835205078e+01 6.5200698375701904e-01 -9.7283203125000000e+01 -4.3418601989746094e+01 1.4676199913024902e+01 -9.7292495727539062e+01 -4.3375099182128906e+01 1.4741000175476074e+01 -9.7286598205566406e+01 -4.3302799224853516e+01 1.4802100181579590e+01 -9.7289100646972656e+01 -4.3283298492431641e+01 1.4816900253295898e+01 -9.6688201904296875e+01 -4.2931499481201172e+01 1.4443699836730957e+01 -9.7277702331542969e+01 -4.3131999969482422e+01 1.4875599861145020e+01 -9.6688201904296875e+01 -4.3027500152587891e+01 1.4330299377441406e+01 -9.7278297424316406e+01 -4.3436698913574219e+01 1.4633700370788574e+01 -9.7272499084472656e+01 -4.3458599090576172e+01 1.4582099914550781e+01 -9.6453193664550781e+01 -4.2653099060058594e+01 1.4052700042724609e+01 -9.6453193664550781e+01 -4.2596000671386719e+01 1.4120100021362305e+01 -9.7283294677734375e+01 4.3416103363037109e+01 -2.1128099441528320e+01 -9.7291496276855469e+01 4.3376300811767578e+01 -2.1186800003051758e+01 -9.7286903381347656e+01 4.3304397583007812e+01 -2.1249000549316406e+01 -9.7288803100585938e+01 4.3289501190185547e+01 -2.1260499954223633e+01 -9.6688301086425781e+01 4.2932598114013672e+01 -2.0892299652099609e+01 -9.7277999877929688e+01 4.3139698028564453e+01 -2.1321800231933594e+01 -9.6688301086425781e+01 4.3027900695800781e+01 -2.0779098510742188e+01 -9.7277999877929688e+01 4.3436603546142578e+01 -2.1080600738525391e+01 -9.7272300720214844e+01 4.3458599090576172e+01 -2.1029901504516602e+01 -9.6453506469726562e+01 4.2653999328613281e+01 -2.0503499984741211e+01 -9.6453506469726562e+01 4.2597202301025391e+01 -2.0570899963378906e+01 -9.7296997070312500e+01 4.3462501525878906e+01 -6.2685103416442871e+00 -9.7280998229980469e+01 4.3467296600341797e+01 -6.3063001632690430e+00 -9.7268402099609375e+01 4.3442100524902344e+01 -6.2570099830627441e+00 -9.7351501464843750e+01 4.3406200408935547e+01 -6.1146998405456543e+00 -9.7254699707031250e+01 4.3353199005126953e+01 -6.1526999473571777e+00 -9.7354095458984375e+01 4.3396499633789062e+01 -6.1029000282287598e+00 -9.7364700317382812e+01 4.3357398986816406e+01 -6.0553002357482910e+00 -9.7248298645019531e+01 4.3312099456787109e+01 -6.1043901443481445e+00 -9.7367500305175781e+01 4.3296199798583984e+01 -6.0106000900268555e+00 -9.7261596679687500e+01 4.3196296691894531e+01 -6.0392103195190430e+00 -9.7360603332519531e+01 4.3236598968505859e+01 -5.9878001213073730e+00 -9.7357902526855469e+01 4.3213401794433594e+01 -5.9788904190063477e+00 -9.7268402099609375e+01 4.3137401580810547e+01 -6.0061001777648926e+00 -9.7300300598144531e+01 4.3017997741699219e+01 -5.9797801971435547e+00 -9.6685295104980469e+01 4.2821399688720703e+01 -6.4872002601623535e+00 -9.6427497863769531e+01 4.2592601776123047e+01 -7.0898003578186035e+00 -9.6427497863769531e+01 4.2482700347900391e+01 -6.9992899894714355e+00 -9.6422500610351562e+01 4.2538501739501953e+01 -7.0436100959777832e+00 -9.6685295104980469e+01 4.3030399322509766e+01 -6.6593098640441895e+00 -9.6669197082519531e+01 4.2931900024414062e+01 -6.5659999847412109e+00 -9.7467102050781250e+01 1.1072400093078613e+01 -1.1474900245666504e+01 -9.7819801330566406e+01 1.1487199783325195e+01 -1.1267100334167480e+01 -9.7545700073242188e+01 1.1110899925231934e+01 -1.1681299209594727e+01 -9.7897003173828125e+01 1.1526499748229980e+01 -1.1472800254821777e+01 -9.7545700073242188e+01 1.1211800575256348e+01 -1.1881400108337402e+01 -9.7897003173828125e+01 1.1628499984741211e+01 -1.1671500205993652e+01 -9.7467102050781250e+01 1.1354700088500977e+01 -1.2035200119018555e+01 -9.7819801330566406e+01 1.1772899627685547e+01 -1.1823300361633301e+01 -9.6338699340820312e+01 5.0784897804260254e+00 -1.4799400329589844e+01 -9.6338699340820312e+01 5.0786099433898926e+00 -1.4799699783325195e+01 -9.6338699340820312e+01 5.0783700942993164e+00 -1.4799099922180176e+01 -9.7288299560546875e+01 1.1050100326538086e+01 -1.2159800529479980e+01 -9.7288299560546875e+01 1.0792099952697754e+01 -1.1640099525451660e+01 -9.7361198425292969e+01 1.0841799736022949e+01 -1.1824900627136230e+01 -9.7361198425292969e+01 1.0932900428771973e+01 -1.2008500099182129e+01 -9.7119400024414062e+01 1.0414600372314453e+01 -1.2250200271606445e+01 -9.7119400024414062e+01 1.0335900306701660e+01 -1.2091400146484375e+01 -9.7061203002929688e+01 1.0280799865722656e+01 -1.1933199882507324e+01 -9.6466499328613281e+01 7.5775399208068848e+00 -1.3680700302124023e+01 -9.7061203002929688e+01 1.0507299423217773e+01 -1.2389699935913086e+01 -9.6466499328613281e+01 7.4808001518249512e+00 -1.3485899925231934e+01 -9.6477096557617188e+01 7.5444002151489258e+00 -1.3616500854492188e+01 -9.6477096557617188e+01 7.5119099617004395e+00 -1.3551099777221680e+01 -9.6338699340820312e+01 5.0787897109985352e+00 -1.4800000190734863e+01 -9.7283294677734375e+01 -4.3414501190185547e+01 -2.1130599975585938e+01 -9.7290901184082031e+01 -4.3377002716064453e+01 -2.1075698852539062e+01 -9.7287101745605469e+01 -4.3305301666259766e+01 -2.1012800216674805e+01 -9.7288604736328125e+01 -4.3293201446533203e+01 -2.1003299713134766e+01 -9.6688301086425781e+01 -4.2933200836181641e+01 -2.1368600845336914e+01 -9.7278297424316406e+01 -4.3144401550292969e+01 -2.0940599441528320e+01 -9.6688301086425781e+01 -4.3027999877929688e+01 -2.1481700897216797e+01 -9.7277702331542969e+01 -4.3436603546142578e+01 -2.1181301116943359e+01 -9.7272201538085938e+01 -4.3458599090576172e+01 -2.1231399536132812e+01 -9.6453598022460938e+01 -4.2654499053955078e+01 -2.1756099700927734e+01 -9.6453598022460938e+01 -4.2597900390625000e+01 -2.1688699722290039e+01 -9.7281097412109375e+01 -4.3466197967529297e+01 -3.5925197601318359e+01 -9.7270195007324219e+01 -4.3443698883056641e+01 -3.5969299316406250e+01 -9.7293601989746094e+01 -4.3462100982666016e+01 -3.5955299377441406e+01 -9.7347099304199219e+01 -4.3405799865722656e+01 -3.6108600616455078e+01 -9.7349601745605469e+01 -4.3395999908447266e+01 -3.6120601654052734e+01 -9.7256599426269531e+01 -4.3355400085449219e+01 -3.6074897766113281e+01 -9.7359703063964844e+01 -4.3356998443603516e+01 -3.6168003082275391e+01 -9.7250701904296875e+01 -4.3316497802734375e+01 -3.6121398925781250e+01 -9.7362197875976562e+01 -4.3295700073242188e+01 -3.6212898254394531e+01 -9.7263496398925781e+01 -4.3203701019287109e+01 -3.6186698913574219e+01 -9.7355598449707031e+01 -4.3241500854492188e+01 -3.6233699798583984e+01 -9.7351997375488281e+01 -4.3211502075195312e+01 -3.6245201110839844e+01 -9.7270195007324219e+01 -4.3144901275634766e+01 -3.6220699310302734e+01 -9.7299797058105469e+01 -4.3031299591064453e+01 -3.6247901916503906e+01 -9.6686203002929688e+01 -4.2826801300048828e+01 -3.5747798919677734e+01 -9.6429695129394531e+01 -4.2489799499511719e+01 -3.5249900817871094e+01 -9.6424804687500000e+01 -4.2545097351074219e+01 -3.5204998016357422e+01 -9.6686203002929688e+01 -4.3032001495361328e+01 -3.5575099945068359e+01 -9.6670501708984375e+01 -4.2935401916503906e+01 -3.5668601989746094e+01 -9.6429695129394531e+01 -4.2598899841308594e+01 -3.5158100128173828e+01 -9.7758399963378906e+01 -4.6171498298645020e+00 -3.9248600006103516e+01 -9.7273498535156250e+01 -4.5198202133178711e+00 -3.9461601257324219e+01 -9.7778495788574219e+01 -4.7012000083923340e+00 -3.9282798767089844e+01 -9.7273498535156250e+01 -4.6919598579406738e+00 -3.9631401062011719e+01 -9.7795799255371094e+01 -4.7740297317504883e+00 -3.9312500000000000e+01 -9.7787200927734375e+01 -4.8722000122070312e+00 -3.9431098937988281e+01 -9.7782600402832031e+01 -4.8758401870727539e+00 -3.9445796966552734e+01 -9.7739196777343750e+01 -4.9109396934509277e+00 -3.9587501525878906e+01 -9.6338699340820312e+01 -3.3694500923156738e+00 -4.0814002990722656e+01 -9.6486503601074219e+01 -3.9875497817993164e+00 -4.0255199432373047e+01 -9.6962493896484375e+01 -4.3784399032592773e+00 -3.9625400543212891e+01 -9.6962493896484375e+01 -4.5295896530151367e+00 -3.9774101257324219e+01 -9.6622901916503906e+01 -4.0975799560546875e+00 -3.9952697753906250e+01 -9.6622901916503906e+01 -4.2068896293640137e+00 -4.0059497833251953e+01 -9.6486503601074219e+01 -3.9066100120544434e+00 -4.0176399230957031e+01 -9.6338699340820312e+01 -3.3686800003051758e+00 -4.0813301086425781e+01 -9.7755294799804688e+01 -4.9034900665283203e+00 -5.3526199340820312e+01 -9.7277595520019531e+01 -4.6973199844360352e+00 -5.3431900024414062e+01 -9.7772399902343750e+01 -4.8705897331237793e+00 -5.3603000640869141e+01 -9.7277595520019531e+01 -4.5350799560546875e+00 -5.3600799560546875e+01 -9.7789604187011719e+01 -4.8374500274658203e+00 -5.3680301666259766e+01 -9.7778602600097656e+01 -4.7172899246215820e+00 -5.3776802062988281e+01 -9.7777801513671875e+01 -4.7147898674011230e+00 -5.3777400970458984e+01 -9.7728599548339844e+01 -4.5593400001525879e+00 -5.3814800262451172e+01 -9.6948104858398438e+01 -4.3833198547363281e+00 -5.3431800842285156e+01 -9.7277702331542969e+01 -4.5350799560546875e+00 -5.3600799560546875e+01 -9.6431800842285156e+01 -3.8654198646545410e+00 -5.2740200042724609e+01 -9.6607200622558594e+01 -4.1884799003601074e+00 -5.3006702423095703e+01 -9.6948104858398438e+01 -4.5230998992919922e+00 -5.3285598754882812e+01 -9.7277702331542969e+01 -4.6973199844360352e+00 -5.3431900024414062e+01 -9.6431800842285156e+01 -3.8070700168609619e+00 -5.2802497863769531e+01 -9.6607200622558594e+01 -4.0908999443054199e+00 -5.3109897613525391e+01 -9.6338699340820312e+01 -3.3692100048065186e+00 -5.2337501525878906e+01 -9.6338699340820312e+01 -3.3699300289154053e+00 -5.2336700439453125e+01 -9.7699302673339844e+01 -2.2796199798583984e+01 -5.7353797912597656e+01 -9.7746200561523438e+01 -2.2818201065063477e+01 -5.7516998291015625e+01 -9.7746795654296875e+01 -2.2823400497436523e+01 -5.7525096893310547e+01 -9.7734100341796875e+01 -2.3003200531005859e+01 -5.7718002319335938e+01 -9.7292602539062500e+01 -2.3109600067138672e+01 -5.7555400848388672e+01 -9.7292602539062500e+01 -2.2985898971557617e+01 -5.7396499633789062e+01 -9.7292602539062500e+01 -2.3047700881958008e+01 -5.7475997924804688e+01 -9.7754997253417969e+01 -2.2901300430297852e+01 -5.7648200988769531e+01 -9.7744895935058594e+01 -2.2950500488281250e+01 -5.7681900024414062e+01 -9.6338699340820312e+01 -2.4326299667358398e+01 -5.6497200012207031e+01 -9.6338699340820312e+01 -2.4326900482177734e+01 -5.6497997283935547e+01 -9.6645195007324219e+01 -2.3533201217651367e+01 -5.7179298400878906e+01 -9.6992904663085938e+01 -2.3246200561523438e+01 -5.7433200836181641e+01 -9.6992904663085938e+01 -2.3137298583984375e+01 -5.7292499542236328e+01 -9.6456100463867188e+01 -2.3770099639892578e+01 -5.6864700317382812e+01 -9.6645195007324219e+01 -2.3454700469970703e+01 -5.7076698303222656e+01 -9.6456100463867188e+01 -2.3819599151611328e+01 -5.6930000305175781e+01 -9.7767005920410156e+01 -2.2690000534057617e+01 -4.3302700042724609e+01 -9.7265304565429688e+01 -2.2916500091552734e+01 -4.3411003112792969e+01 -9.7794097900390625e+01 -2.2727899551391602e+01 -4.3203903198242188e+01 -9.7811599731445312e+01 -2.2752498626708984e+01 -4.3139900207519531e+01 -9.7815093994140625e+01 -2.2809398651123047e+01 -4.3079200744628906e+01 -9.7811401367187500e+01 -2.2848001480102539e+01 -4.3052700042724609e+01 -9.7265304565429688e+01 -2.3105400085449219e+01 -4.3239101409912109e+01 -9.7793998718261719e+01 -2.2912399291992188e+01 -4.3034301757812500e+01 -9.7766197204589844e+01 -2.3015800476074219e+01 -4.3005001068115234e+01 -9.6338699340820312e+01 -2.4239801406860352e+01 -4.4697299957275391e+01 -9.6503700256347656e+01 -2.3679399490356445e+01 -4.3967998504638672e+01 -9.6972999572753906e+01 -2.3235900878906250e+01 -4.3403396606445312e+01 -9.6972999572753906e+01 -2.3068500518798828e+01 -4.3555099487304688e+01 -9.6632102966308594e+01 -2.3386501312255859e+01 -4.3859401702880859e+01 -9.6632102966308594e+01 -2.3508699417114258e+01 -4.3749702453613281e+01 -9.6503700256347656e+01 -2.3585300445556641e+01 -4.4051898956298828e+01 -9.6338699340820312e+01 -2.4239101409912109e+01 -4.4697998046875000e+01 -9.7571899414062500e+01 3.2854400634765625e+01 -1.0322300720214844e+02 -9.7269897460937500e+01 3.2703399658203125e+01 -1.0318800354003906e+02 -9.7654098510742188e+01 3.2850299835205078e+01 -1.0303799438476562e+02 -9.7709197998046875e+01 3.2739700317382812e+01 -1.0283399963378906e+02 -9.7708702087402344e+01 3.2742500305175781e+01 -1.0283699798583984e+02 -9.7250297546386719e+01 3.2575901031494141e+01 -1.0303500366210938e+02 -9.7700294494628906e+01 3.2791301727294922e+01 -1.0289099884033203e+02 -9.7659698486328125e+01 3.2843196868896484e+01 -1.0301999664306641e+02 -9.7706802368164062e+01 3.2675300598144531e+01 -1.0279099273681641e+02 -9.7269897460937500e+01 3.2403800964355469e+01 -1.0293599700927734e+02 -9.7676498413085938e+01 3.2549400329589844e+01 -1.0276499938964844e+02 -9.7665504455566406e+01 3.2503700256347656e+01 -1.0275600433349609e+02 -9.6686103820800781e+01 3.2085998535156250e+01 -1.0341099548339844e+02 -9.6429397583007812e+01 3.1857900619506836e+01 -1.0400199890136719e+02 -9.6424400329589844e+01 3.1804100036621094e+01 -1.0395600128173828e+02 -9.6429397583007812e+01 3.1748701095581055e+01 -1.0391099548339844e+02 -9.6686103820800781e+01 3.2291801452636719e+01 -1.0358300018310547e+02 -9.6670204162597656e+01 3.2194900512695312e+01 -1.0349000549316406e+02 -9.7582603454589844e+01 3.2492801666259766e+01 -1.1836799621582031e+02 -9.7286903381347656e+01 3.2564300537109375e+01 -1.1819699859619141e+02 -9.7630302429199219e+01 3.2653499603271484e+01 -1.1832600402832031e+02 -9.7633506774902344e+01 3.2686901092529297e+01 -1.1829900360107422e+02 -9.7641998291015625e+01 3.2775699615478516e+01 -1.1822800445556641e+02 -9.7286903381347656e+01 3.2702899932861328e+01 -1.1803199768066406e+02 -9.7623397827148438e+01 3.2819599151611328e+01 -1.1813200378417969e+02 -9.7612998962402344e+01 3.2844200134277344e+01 -1.1807800292968750e+02 -9.6453506469726562e+01 3.1857200622558594e+01 -1.1751799774169922e+02 -9.6453506469726562e+01 3.1913898468017578e+01 -1.1745099639892578e+02 -9.6688201904296875e+01 3.2192600250244141e+01 -1.1783999633789062e+02 -9.6688201904296875e+01 3.2287899017333984e+01 -1.1772699737548828e+02 -9.7733497619628906e+01 1.7449699401855469e+01 -1.2975000000000000e+02 -9.7287002563476562e+01 1.7368799209594727e+01 -1.2956599426269531e+02 -9.7755096435546875e+01 1.7673999786376953e+01 -1.2954299926757812e+02 -9.7767005920410156e+01 1.7644699096679688e+01 -1.2961000061035156e+02 -9.7287002563476562e+01 1.7506999969482422e+01 -1.2940100097656250e+02 -9.7762298583984375e+01 1.7562101364135742e+01 -1.2969499206542969e+02 -9.7756103515625000e+01 1.7538101196289062e+01 -1.2970700073242188e+02 -9.7747001647949219e+01 1.7694101333618164e+01 -1.2949700927734375e+02 -9.6453506469726562e+01 1.6661500930786133e+01 -1.2888800048828125e+02 -9.6453506469726562e+01 1.6718198776245117e+01 -1.2882099914550781e+02 -9.6688301086425781e+01 1.6996900558471680e+01 -1.2920899963378906e+02 -9.6688301086425781e+01 1.7092000961303711e+01 -1.2909600830078125e+02 -9.7719497680664062e+01 1.7901201248168945e+01 -1.2099199676513672e+02 -9.7364501953125000e+01 1.7771900177001953e+01 -1.2088300323486328e+02 -9.7719497680664062e+01 1.7762701034545898e+01 -1.2115599822998047e+02 -9.7364501953125000e+01 1.7633499145507812e+01 -1.2104699707031250e+02 -9.6347801208496094e+01 1.6330200195312500e+01 -1.1982399749755859e+02 -9.6347801208496094e+01 1.6344598770141602e+01 -1.1980699920654297e+02 -9.6759605407714844e+01 1.7331899642944336e+01 -1.2055599975585938e+02 -9.6759605407714844e+01 1.7236598968505859e+01 -1.2066899871826172e+02 -9.7270103454589844e+01 6.2583699226379395e+00 -1.3120199584960938e+02 -9.7828201293945312e+01 6.1774797439575195e+00 -1.3160200500488281e+02 -9.7829605102539062e+01 6.1466698646545410e+00 -1.3157899475097656e+02 -9.7250495910644531e+01 6.3856201171875000e+00 -1.3135400390625000e+02 -9.7808197021484375e+01 6.0844998359680176e+00 -1.3147799682617188e+02 -9.7783798217773438e+01 6.0810999870300293e+00 -1.3142100524902344e+02 -9.7791297912597656e+01 6.3679199218750000e+00 -1.3167799377441406e+02 -9.7793403625488281e+01 6.3630900382995605e+00 -1.3167900085449219e+02 -9.7825202941894531e+01 6.2396497726440430e+00 -1.3164700317382812e+02 -9.7270103454589844e+01 6.5574598312377930e+00 -1.3145298767089844e+02 -9.6686203002929688e+01 6.8753900527954102e+00 -1.3097999572753906e+02 -9.6429603576660156e+01 7.1034398078918457e+00 -1.3038999938964844e+02 -9.6424697875976562e+01 7.1572098731994629e+00 -1.3043600463867188e+02 -9.6429603576660156e+01 7.2125802040100098e+00 -1.3048100280761719e+02 -9.6686203002929688e+01 6.6700601577758789e+00 -1.3080699157714844e+02 -9.6670394897460938e+01 6.7667403221130371e+00 -1.3090100097656250e+02 -9.7735397338867188e+01 6.0049300193786621e+00 -1.2336900329589844e+02 -9.7380401611328125e+01 6.1341500282287598e+00 -1.2321700286865234e+02 -9.7754600524902344e+01 5.8790998458862305e+00 -1.2321700286865234e+02 -9.7399597167968750e+01 6.0083298683166504e+00 -1.2306500244140625e+02 -9.7735397338867188e+01 5.7089900970458984e+00 -1.2311699676513672e+02 -9.7380401611328125e+01 5.8382101058959961e+00 -1.2296500396728516e+02 -9.6777999877929688e+01 6.5157399177551270e+00 -1.2267400360107422e+02 -9.6339004516601562e+01 7.5730700492858887e+00 -1.2122499847412109e+02 -9.6339004516601562e+01 7.5704398155212402e+00 -1.2122299957275391e+02 -9.6339004516601562e+01 7.5756897926330566e+00 -1.2122700500488281e+02 -9.6777999877929688e+01 6.3124299049377441e+00 -1.2250099945068359e+02 -9.6793601989746094e+01 6.4200696945190430e+00 -1.2258100128173828e+02 -9.7719696044921875e+01 5.8640198707580566e+00 -1.0734000396728516e+02 -9.7364700317382812e+01 5.9932498931884766e+00 -1.0744900512695312e+02 -9.7719696044921875e+01 6.0030198097229004e+00 -1.0717500305175781e+02 -9.7364700317382812e+01 6.1322398185729980e+00 -1.0728400421142578e+02 -9.6347694396972656e+01 7.4365100860595703e+00 -1.0851200103759766e+02 -9.6347694396972656e+01 7.4222102165222168e+00 -1.0852899932861328e+02 -9.6759902954101562e+01 6.4333100318908691e+00 -1.0777700042724609e+02 -9.6759902954101562e+01 6.5289697647094727e+00 -1.0766299438476562e+02 -9.7733497619628906e+01 6.3162398338317871e+00 -9.7039100646972656e+01 -9.7287002563476562e+01 6.3971900939941406e+00 -9.7223602294921875e+01 -9.7755096435546875e+01 6.0919499397277832e+00 -9.7246696472167969e+01 -9.7767005920410156e+01 6.1212801933288574e+00 -9.7179298400878906e+01 -9.7287002563476562e+01 6.2589597702026367e+00 -9.7388000488281250e+01 -9.7762298583984375e+01 6.2038898468017578e+00 -9.7094001770019531e+01 -9.7756103515625000e+01 6.2279701232910156e+00 -9.7082199096679688e+01 -9.7747100830078125e+01 6.0719799995422363e+00 -9.7292701721191406e+01 -9.6453506469726562e+01 7.1044602394104004e+00 -9.7900894165039062e+01 -9.6453506469726562e+01 7.0477700233459473e+00 -9.7968299865722656e+01 -9.6688301086425781e+01 6.7690601348876953e+00 -9.7579895019531250e+01 -9.6688301086425781e+01 6.6739897727966309e+00 -9.7693099975585938e+01 -9.7270103454589844e+01 1.7507598876953125e+01 -9.5587799072265625e+01 -9.7828201293945312e+01 1.7588499069213867e+01 -9.5188201904296875e+01 -9.7829605102539062e+01 1.7619300842285156e+01 -9.5210800170898438e+01 -9.7250602722167969e+01 1.7380300521850586e+01 -9.5435600280761719e+01 -9.7808197021484375e+01 1.7681499481201172e+01 -9.5311500549316406e+01 -9.7783798217773438e+01 1.7684898376464844e+01 -9.5369400024414062e+01 -9.7791297912597656e+01 1.7398099899291992e+01 -9.5111602783203125e+01 -9.7793403625488281e+01 1.7402900695800781e+01 -9.5110794067382812e+01 -9.7825202941894531e+01 1.7526300430297852e+01 -9.5142601013183594e+01 -9.7270103454589844e+01 1.7208600997924805e+01 -9.5336402893066406e+01 -9.6686203002929688e+01 1.6890600204467773e+01 -9.5809799194335938e+01 -9.6429603576660156e+01 1.6662599563598633e+01 -9.6400299072265625e+01 -9.6424697875976562e+01 1.6608800888061523e+01 -9.6353393554687500e+01 -9.6429603576660156e+01 1.6553501129150391e+01 -9.6308593750000000e+01 -9.6686203002929688e+01 1.7096000671386719e+01 -9.5982398986816406e+01 -9.6670394897460938e+01 1.6999200820922852e+01 -9.5888900756835938e+01 -9.7736503601074219e+01 1.7762100219726562e+01 -1.0495999908447266e+02 -9.7381401062011719e+01 1.7632799148559570e+01 -1.0511399841308594e+02 -9.7756103515625000e+01 1.7889600753784180e+01 -1.0511199951171875e+02 -9.7401100158691406e+01 1.7760398864746094e+01 -1.0526599884033203e+02 -9.7736503601074219e+01 1.8061698913574219e+01 -1.0521200561523438e+02 -9.7381401062011719e+01 1.7932500839233398e+01 -1.0536499786376953e+02 -9.6778800964355469e+01 1.7251399993896484e+01 -1.0566400146484375e+02 -9.6338798522949219e+01 1.6183799743652344e+01 -1.0714600372314453e+02 -9.6338798522949219e+01 1.6185600280761719e+01 -1.0714800262451172e+02 -9.6338798522949219e+01 1.6181900024414062e+01 -1.0714399719238281e+02 -9.6778800964355469e+01 1.7457201004028320e+01 -1.0583700561523438e+02 -9.6794601440429688e+01 1.7348300933837891e+01 -1.0575799560546875e+02 -9.7643501281738281e+01 -3.1296699523925781e+01 -1.0396900177001953e+02 -9.7268592834472656e+01 -3.1473699569702148e+01 -1.0395500183105469e+02 -9.7720695495605469e+01 -3.1285099029541016e+01 -1.0378900146484375e+02 -9.7761901855468750e+01 -3.1380601882934570e+01 -1.0358099365234375e+02 -9.7761802673339844e+01 -3.1379301071166992e+01 -1.0358300018310547e+02 -9.7248397827148438e+01 -3.1587400436401367e+01 -1.0379000091552734e+02 -9.7758796691894531e+01 -3.1332101821899414e+01 -1.0364199829101562e+02 -9.7725097656250000e+01 -3.1290597915649414e+01 -1.0377200317382812e+02 -9.7268592834472656e+01 -3.1751100540161133e+01 -1.0367400360107422e+02 -9.7691604614257812e+01 -3.1622600555419922e+01 -1.0349099731445312e+02 -9.7707504272460938e+01 -3.1575899124145508e+01 -1.0350300598144531e+02 -9.7752601623535156e+01 -3.1443700790405273e+01 -1.0353600311279297e+02 -9.6338699340820312e+01 -3.2948799133300781e+01 -1.0512799835205078e+02 -9.6520599365234375e+01 -3.2324501037597656e+01 -1.0437599945068359e+02 -9.6520599365234375e+01 -3.2183097839355469e+01 -1.0452000427246094e+02 -9.6638504028320312e+01 -3.1987298965454102e+01 -1.0436399841308594e+02 -9.6988502502441406e+01 -3.1632099151611328e+01 -1.0408099365234375e+02 -9.6966400146484375e+01 -3.1739200592041016e+01 -1.0394000244140625e+02 -9.6988502502441406e+01 -3.1878799438476562e+01 -1.0383100128173828e+02 -9.6638504028320312e+01 -3.2165603637695312e+01 -1.0418300628662109e+02 -9.6338699340820312e+01 -3.2947700500488281e+01 -1.0512900543212891e+02 -9.6623901367187500e+01 -3.2071098327636719e+01 -1.0426799774169922e+02 -9.6511001586914062e+01 -3.2251201629638672e+01 -1.0444599914550781e+02 -9.6338699340820312e+01 -3.2948200225830078e+01 -1.0512900543212891e+02 -9.6338699340820312e+01 -4.2244697570800781e+01 -1.0596800231933594e+02 -9.7278106689453125e+01 -4.2996898651123047e+01 -1.0464599609375000e+02 -9.7279800415039062e+01 -4.3275901794433594e+01 -1.0477499389648438e+02 -9.7285202026367188e+01 -4.3166896820068359e+01 -1.0469699859619141e+02 -9.6976799011230469e+01 -4.3059501647949219e+01 -1.0484700012207031e+02 -9.7286094665527344e+01 -4.3150001525878906e+01 -1.0468499755859375e+02 -9.7265098571777344e+01 -4.3349601745605469e+01 -1.0488200378417969e+02 -9.7274307250976562e+01 -4.3303401947021484e+01 -1.0481500244140625e+02 -9.6976799011230469e+01 -4.3184001922607422e+01 -1.0494799804687500e+02 -9.6631996154785156e+01 -4.2837001800537109e+01 -1.0515599822998047e+02 -9.6631996154785156e+01 -4.2927398681640625e+01 -1.0523000335693359e+02 -9.6464096069335938e+01 -4.2704196929931641e+01 -1.0547299957275391e+02 -9.6464096069335938e+01 -4.2643199920654297e+01 -1.0542300415039062e+02 -9.6338699340820312e+01 -4.2243999481201172e+01 -1.0596800231933594e+02 -9.7600196838378906e+01 -3.3898799896240234e+01 -1.4450000000000000e+02 -9.7293601989746094e+01 -3.3973701477050781e+01 -1.4461499023437500e+02 -9.7606803894042969e+01 -3.3970500946044922e+01 -1.4447900390625000e+02 -9.7614105224609375e+01 -3.4048999786376953e+01 -1.4445700073242188e+02 -9.7293601989746094e+01 -3.4172298431396484e+01 -1.4461000061035156e+02 -9.7593597412109375e+01 -3.4166896820068359e+01 -1.4447900390625000e+02 -9.7586402893066406e+01 -3.4209098815917969e+01 -1.4448599243164062e+02 -9.6994201660156250e+01 -3.4166801452636719e+01 -1.4479200744628906e+02 -9.6994201660156250e+01 -3.3990200042724609e+01 -1.4479699707031250e+02 -9.6648498535156250e+01 -3.4023300170898438e+01 -1.4517498779296875e+02 -9.6648498535156250e+01 -3.4153900146484375e+01 -1.4517199707031250e+02 -9.6451400756835938e+01 -3.4056201934814453e+01 -1.4557299804687500e+02 -9.6338699340820312e+01 -3.4105899810791016e+01 -1.4623300170898438e+02 -9.6338699340820312e+01 -3.4106899261474609e+01 -1.4623300170898438e+02 -9.6451400756835938e+01 -3.4138198852539062e+01 -1.4557200622558594e+02 -9.7759002685546875e+01 -2.5446399688720703e+01 -1.5158499145507812e+02 -9.7266395568847656e+01 -2.5676099777221680e+01 -1.5149800109863281e+02 -9.7791595458984375e+01 -2.5396799087524414e+01 -1.5148199462890625e+02 -9.7804000854492188e+01 -2.5378000259399414e+01 -1.5144200134277344e+02 -9.7266395568847656e+01 -2.5684398651123047e+01 -1.5137199401855469e+02 -9.7811401367187500e+01 -2.5369899749755859e+01 -1.5136499023437500e+02 -9.7807304382324219e+01 -2.5381500244140625e+01 -1.5128900146484375e+02 -9.7266395568847656e+01 -2.5692699432373047e+01 -1.5124499511718750e+02 -9.7789398193359375e+01 -2.5415800094604492e+01 -1.5123001098632812e+02 -9.7761100769042969e+01 -2.5469898223876953e+01 -1.5113798522949219e+02 -9.7266304016113281e+01 -2.5692699432373047e+01 -1.5124499511718750e+02 -9.7266304016113281e+01 -2.5684398651123047e+01 -1.5137199401855469e+02 -9.7266304016113281e+01 -2.5676099777221680e+01 -1.5149800109863281e+02 -9.6338699340820312e+01 -2.7481300354003906e+01 -1.5150100708007812e+02 -9.6491500854492188e+01 -2.6631898880004883e+01 -1.5137599182128906e+02 -9.6959899902343750e+01 -2.5911699295043945e+01 -1.5127499389648438e+02 -9.6959899902343750e+01 -2.5896800994873047e+01 -1.5149598693847656e+02 -9.6614997863769531e+01 -2.6350601196289062e+01 -1.5149400329589844e+02 -9.6614997863769531e+01 -2.6361900329589844e+01 -1.5133799743652344e+02 -9.6491500854492188e+01 -2.6623100280761719e+01 -1.5149400329589844e+02 -9.6338699340820312e+01 -2.7481199264526367e+01 -1.5150199890136719e+02 -9.7372398376464844e+01 -1.8202999114990234e+01 -1.7829499816894531e+02 -9.7727905273437500e+01 -1.8333999633789062e+01 -1.7817401123046875e+02 -9.7372398376464844e+01 -1.8043899536132812e+01 -1.7812699890136719e+02 -9.7727905273437500e+01 -1.8173801422119141e+01 -1.7800498962402344e+02 -9.7320396423339844e+01 -1.8180700302124023e+01 -1.7831300354003906e+02 -9.6956497192382812e+01 -1.7948501586914062e+01 -1.7850300598144531e+02 -9.6457496643066406e+01 -1.7165899276733398e+01 -1.7905099487304688e+02 -9.6533294677734375e+01 -1.7325698852539062e+01 -1.7888499450683594e+02 -9.6956497192382812e+01 -1.7820098876953125e+01 -1.7836601257324219e+02 -9.7320396423339844e+01 -1.8024801254272461e+01 -1.7814799499511719e+02 -9.6338699340820312e+01 -1.6565698623657227e+01 -1.7967300415039062e+02 -9.6338699340820312e+01 -1.6566301345825195e+01 -1.7967300415039062e+02 -9.6457496643066406e+01 -1.7224000930786133e+01 -1.7911300659179688e+02 -9.6533294677734375e+01 -1.7399700164794922e+01 -1.7896400451660156e+02 -9.7734695434570312e+01 -1.7841798782348633e+01 -1.4035000610351562e+02 -9.7285705566406250e+01 -1.7763299942016602e+01 -1.4053800964355469e+02 -9.7757804870605469e+01 -1.8073598861694336e+01 -1.4055799865722656e+02 -9.7770202636718750e+01 -1.8040201187133789e+01 -1.4048600769042969e+02 -9.7285705566406250e+01 -1.7904899597167969e+01 -1.4070401000976562e+02 -9.7764495849609375e+01 -1.7955699920654297e+01 -1.4040299987792969e+02 -9.7758895874023438e+01 -1.7934101104736328e+01 -1.4039300537109375e+02 -9.7751106262207031e+01 -1.8091798782348633e+01 -1.4059799194335938e+02 -9.6452400207519531e+01 -1.7057100296020508e+01 -1.4122900390625000e+02 -9.6452400207519531e+01 -1.7114900588989258e+01 -1.4129600524902344e+02 -9.6688003540039062e+01 -1.7393098831176758e+01 -1.4090100097656250e+02 -9.6688003540039062e+01 -1.7490598678588867e+01 -1.4101399230957031e+02 -9.7716499328613281e+01 -7.1914801597595215e+00 -1.5441099548339844e+02 -9.7361495971679688e+01 -7.3207001686096191e+00 -1.5430799865722656e+02 -9.7716499328613281e+01 -7.3215999603271484e+00 -1.5457400512695312e+02 -9.7361495971679688e+01 -7.4508199691772461e+00 -1.5447000122070312e+02 -9.7262207031250000e+01 -7.3639097213745117e+00 -1.5427799987792969e+02 -9.7262207031250000e+01 -7.4896197319030762e+00 -1.5443399047851562e+02 -9.6660598754882812e+01 -7.9627594947814941e+00 -1.5400700378417969e+02 -9.6660598754882812e+01 -7.8834304809570312e+00 -1.5390800476074219e+02 -9.7643196105957031e+01 -7.3417997360229492e+00 -1.7671899414062500e+02 -9.7756500244140625e+01 -7.3004999160766602e+00 -1.7665800476074219e+02 -9.7670196533203125e+01 -7.1849198341369629e+00 -1.7687399291992188e+02 -9.7783500671386719e+01 -7.1434402465820312e+00 -1.7681300354003906e+02 -9.7643196105957031e+01 -6.9820899963378906e+00 -1.7696000671386719e+02 -9.7756500244140625e+01 -6.9404196739196777e+00 -1.7689900207519531e+02 -9.7401100158691406e+01 -7.4300799369812012e+00 -1.7685000610351562e+02 -9.7427894592285156e+01 -7.2735500335693359e+00 -1.7700498962402344e+02 -9.7401100158691406e+01 -7.0711402893066406e+00 -1.7709199523925781e+02 -9.7293304443359375e+01 -7.1264500617980957e+00 -1.7715699768066406e+02 -9.7321800231933594e+01 -7.3175396919250488e+00 -1.7707000732421875e+02 -9.7293304443359375e+01 -7.4698901176452637e+00 -1.7692599487304688e+02 -9.7011001586914062e+01 -7.6243901252746582e+00 -1.7720800781250000e+02 -9.6502899169921875e+01 -8.0680799484252930e+00 -1.7834199523925781e+02 -9.7011001586914062e+01 -7.3308300971984863e+00 -1.7740599060058594e+02 -9.7037002563476562e+01 -7.4884300231933594e+00 -1.7732299804687500e+02 -9.6510597229003906e+01 -8.1431903839111328e+00 -1.7829400634765625e+02 -9.6502899169921875e+01 -8.2160196304321289e+00 -1.7824200439453125e+02 -9.6338699340820312e+01 -8.9141702651977539e+00 -1.7943798828125000e+02 -9.6338699340820312e+01 -8.9150705337524414e+00 -1.7943699645996094e+02 -9.6338699340820312e+01 -8.9145898818969727e+00 -1.7943798828125000e+02 -9.7281097412109375e+01 -4.3466197967529297e+01 -2.3164799499511719e+02 -9.7270195007324219e+01 -4.3443599700927734e+01 -2.3169299316406250e+02 -9.7293693542480469e+01 -4.3462100982666016e+01 -2.3167900085449219e+02 -9.7347198486328125e+01 -4.3405799865722656e+01 -2.3183200073242188e+02 -9.7349700927734375e+01 -4.3395999908447266e+01 -2.3184399414062500e+02 -9.7256599426269531e+01 -4.3355300903320312e+01 -2.3179798889160156e+02 -9.7359901428222656e+01 -4.3356998443603516e+01 -2.3189100646972656e+02 -9.7250602722167969e+01 -4.3316497802734375e+01 -2.3184500122070312e+02 -9.7362304687500000e+01 -4.3295700073242188e+01 -2.3193598937988281e+02 -9.7263496398925781e+01 -4.3203598022460938e+01 -2.3191000366210938e+02 -9.7355697631835938e+01 -4.3241401672363281e+01 -2.3195700073242188e+02 -9.7352104187011719e+01 -4.3211502075195312e+01 -2.3196899414062500e+02 -9.7270195007324219e+01 -4.3144798278808594e+01 -2.3194400024414062e+02 -9.7299797058105469e+01 -4.3031101226806641e+01 -2.3197099304199219e+02 -9.6419296264648438e+01 -4.2530998229980469e+01 -2.3091099548339844e+02 -9.6423995971679688e+01 -4.2583099365234375e+01 -2.3086599731445312e+02 -9.6423995971679688e+01 -4.2477397918701172e+01 -2.3095500183105469e+02 -9.6625495910644531e+01 -4.2768096923828125e+01 -2.3138398742675781e+02 -9.7204498291015625e+01 -4.3416198730468750e+01 -2.3166600036621094e+02 -9.7252304077148438e+01 -4.3471702575683594e+01 -2.3152400207519531e+02 -9.7204498291015625e+01 -4.3123699188232422e+01 -2.3191299438476562e+02 -9.7183898925781250e+01 -4.3290500640869141e+01 -2.3181399536132812e+02 -9.6611801147460938e+01 -4.2866798400878906e+01 -2.3130999755859375e+02 -9.6625495910644531e+01 -4.2956298828125000e+01 -2.3122599792480469e+02 -9.7283294677734375e+01 -4.3415901184082031e+01 -2.1674400329589844e+02 -9.7291404724121094e+01 -4.3376300811767578e+01 -2.1668598937988281e+02 -9.7286903381347656e+01 -4.3304500579833984e+01 -2.1662298583984375e+02 -9.7288803100585938e+01 -4.3289901733398438e+01 -2.1661199951171875e+02 -9.6407302856445312e+01 -4.2486801147460938e+01 -2.1740699768066406e+02 -9.7278106689453125e+01 -4.3140300750732422e+01 -2.1655101013183594e+02 -9.6870895385742188e+01 -4.3090900421142578e+01 -2.1682800292968750e+02 -9.6870895385742188e+01 -4.3204399108886719e+01 -2.1696299743652344e+02 -9.7277999877929688e+01 -4.3436603546142578e+01 -2.1679200744628906e+02 -9.7272300720214844e+01 -4.3458599090576172e+01 -2.1684199523925781e+02 -9.6407302856445312e+01 -4.2530998229980469e+01 -2.1745899963378906e+02 -9.7364501953125000e+01 6.1325998306274414e+00 -2.0777400207519531e+02 -9.7364501953125000e+01 5.9941997528076172e+00 -2.0793800354003906e+02 -9.7274993896484375e+01 6.0329399108886719e+00 -2.0796699523925781e+02 -9.7274993896484375e+01 6.1670498847961426e+00 -2.0780700683593750e+02 -9.6671401977539062e+01 6.6329798698425293e+00 -2.0824900817871094e+02 -9.6671401977539062e+01 6.5477499961853027e+00 -2.0835000610351562e+02 -9.7719497680664062e+01 5.8649802207946777e+00 -2.0783000183105469e+02 -9.7719497680664062e+01 6.0033202171325684e+00 -2.0766499328613281e+02 -9.7733497619628906e+01 6.3162398338317871e+00 -1.9592900085449219e+02 -9.7287002563476562e+01 6.3971900939941406e+00 -1.9611399841308594e+02 -9.7755096435546875e+01 6.0919499397277832e+00 -1.9613699340820312e+02 -9.7767005920410156e+01 6.1212801933288574e+00 -1.9606900024414062e+02 -9.7287002563476562e+01 6.2589597702026367e+00 -1.9627799987792969e+02 -9.7762298583984375e+01 6.2038898468017578e+00 -1.9598400878906250e+02 -9.7756103515625000e+01 6.2279100418090820e+00 -1.9597200012207031e+02 -9.7747001647949219e+01 6.0719799995422363e+00 -1.9618299865722656e+02 -9.6407302856445312e+01 7.2150797843933105e+00 -1.9689700317382812e+02 -9.6870803833007812e+01 6.4975600242614746e+00 -1.9645300292968750e+02 -9.6870803833007812e+01 6.6109900474548340e+00 -1.9631900024414062e+02 -9.6407302856445312e+01 7.1709699630737305e+00 -1.9694900512695312e+02 -9.7270103454589844e+01 1.7507598876953125e+01 -1.9447700500488281e+02 -9.7828201293945312e+01 1.7588499069213867e+01 -1.9407800292968750e+02 -9.7829605102539062e+01 1.7619300842285156e+01 -1.9410000610351562e+02 -9.7250495910644531e+01 1.7380300521850586e+01 -1.9432499694824219e+02 -9.7808197021484375e+01 1.7681499481201172e+01 -1.9420098876953125e+02 -9.7783798217773438e+01 1.7684898376464844e+01 -1.9425900268554688e+02 -9.7791297912597656e+01 1.7398099899291992e+01 -1.9400100708007812e+02 -9.7793403625488281e+01 1.7402900695800781e+01 -1.9400000000000000e+02 -9.7825202941894531e+01 1.7526300430297852e+01 -1.9403199768066406e+02 -9.7270103454589844e+01 1.7208499908447266e+01 -1.9422599792480469e+02 -9.6419403076171875e+01 1.6595098495483398e+01 -1.9525900268554688e+02 -9.6423995971679688e+01 1.6647298812866211e+01 -1.9530400085449219e+02 -9.6423995971679688e+01 1.6541500091552734e+01 -1.9521600341796875e+02 -9.6625595092773438e+01 1.6832099914550781e+01 -1.9478599548339844e+02 -9.7204605102539062e+01 1.7187398910522461e+01 -1.9425700378417969e+02 -9.7184005737304688e+01 1.7354400634765625e+01 -1.9435598754882812e+02 -9.7204605102539062e+01 1.7480300903320312e+01 -1.9450299072265625e+02 -9.6625595092773438e+01 1.7020500183105469e+01 -1.9494400024414062e+02 -9.6611900329589844e+01 1.6930900573730469e+01 -1.9486000061035156e+02 -9.7381195068359375e+01 5.8345198631286621e+00 -2.2357000732421875e+02 -9.7381195068359375e+01 6.1333799362182617e+00 -2.2382099914550781e+02 -9.7400802612304688e+01 6.0061798095703125e+00 -2.2366900634765625e+02 -9.7391906738281250e+01 6.0094599723815918e+00 -2.2366499328613281e+02 -9.7372100830078125e+01 6.1364202499389648e+00 -2.2381700134277344e+02 -9.7372100830078125e+01 5.8385100364685059e+00 -2.2356599426269531e+02 -9.6767295837402344e+01 6.3239297866821289e+00 -2.2308599853515625e+02 -9.6767295837402344e+01 6.5266499519348145e+00 -2.2325601196289062e+02 -9.6782806396484375e+01 6.4310398101806641e+00 -2.2316400146484375e+02 -9.7736297607421875e+01 6.0041499137878418e+00 -2.2397500610351562e+02 -9.7755798339843750e+01 5.8769598007202148e+00 -2.2382299804687500e+02 -9.7736297607421875e+01 5.7052998542785645e+00 -2.2372299194335938e+02 -9.7270103454589844e+01 6.2583699226379395e+00 -2.3197700500488281e+02 -9.7828201293945312e+01 6.1774797439575195e+00 -2.3237699890136719e+02 -9.7829605102539062e+01 6.1467299461364746e+00 -2.3235400390625000e+02 -9.7250602722167969e+01 6.3856201171875000e+00 -2.3212899780273438e+02 -9.7808197021484375e+01 6.0845599174499512e+00 -2.3225399780273438e+02 -9.7783798217773438e+01 6.0810999870300293e+00 -2.3219599914550781e+02 -9.7791297912597656e+01 6.3679199218750000e+00 -2.3245399475097656e+02 -9.7793403625488281e+01 6.3631501197814941e+00 -2.3245399475097656e+02 -9.7825202941894531e+01 6.2396497726440430e+00 -2.3242199707031250e+02 -9.7270103454589844e+01 6.5573997497558594e+00 -2.3222898864746094e+02 -9.6419403076171875e+01 7.1708498001098633e+00 -2.3119500732421875e+02 -9.6423995971679688e+01 7.1187000274658203e+00 -2.3114999389648438e+02 -9.6423995971679688e+01 7.2244400978088379e+00 -2.3123899841308594e+02 -9.6625595092773438e+01 6.9338698387145996e+00 -2.3166899108886719e+02 -9.7204605102539062e+01 6.5785102844238281e+00 -2.3219700622558594e+02 -9.7184005737304688e+01 6.4115500450134277e+00 -2.3209899902343750e+02 -9.7204605102539062e+01 6.2856702804565430e+00 -2.3195100402832031e+02 -9.6625595092773438e+01 6.7454600334167480e+00 -2.3150999450683594e+02 -9.6611900329589844e+01 6.8351597785949707e+00 -2.3159500122070312e+02 -9.7733200073242188e+01 1.7453199386596680e+01 -2.3052500915527344e+02 -9.7287399291992188e+01 1.7372699737548828e+01 -2.3034100341796875e+02 -9.7754302978515625e+01 1.7676300048828125e+01 -2.3031900024414062e+02 -9.7765998840332031e+01 1.7647899627685547e+01 -2.3038500976562500e+02 -9.7287399291992188e+01 1.7510799407958984e+01 -2.3017799377441406e+02 -9.7761497497558594e+01 1.7565399169921875e+01 -2.3047000122070312e+02 -9.7755203247070312e+01 1.7540498733520508e+01 -2.3048199462890625e+02 -9.7745704650878906e+01 1.7697200775146484e+01 -2.3027099609375000e+02 -9.6407005310058594e+01 1.6558000564575195e+01 -2.2955699157714844e+02 -9.6869796752929688e+01 1.7272298812866211e+01 -2.3000199890136719e+02 -9.6869796752929688e+01 1.7159000396728516e+01 -2.3013499450683594e+02 -9.6407005310058594e+01 1.6601999282836914e+01 -2.2950500488281250e+02 -9.7722000122070312e+01 1.7969299316406250e+01 -2.2159700012207031e+02 -9.7366897583007812e+01 1.7840700149536133e+01 -2.2148300170898438e+02 -9.7722000122070312e+01 1.7823200225830078e+01 -2.2176200866699219e+02 -9.7366897583007812e+01 1.7694700241088867e+01 -2.2164799499511719e+02 -9.7285400390625000e+01 1.7805799484252930e+01 -2.2145600891113281e+02 -9.7285400390625000e+01 1.7663799285888672e+01 -2.2161700439453125e+02 -9.6680404663085938e+01 1.7206899642944336e+01 -2.2116099548339844e+02 -9.6680404663085938e+01 1.7297599792480469e+01 -2.2105799865722656e+02 -9.7736000061035156e+01 1.7761598587036133e+01 -2.0550799560546875e+02 -9.7380897521972656e+01 1.7632400512695312e+01 -2.0566099548339844e+02 -9.7755401611328125e+01 1.7888299942016602e+01 -2.0566000366210938e+02 -9.7400398254394531e+01 1.7759099960327148e+01 -2.0581300354003906e+02 -9.7736000061035156e+01 1.8059499740600586e+01 -2.0576000976562500e+02 -9.7380897521972656e+01 1.7930301666259766e+01 -2.0591300964355469e+02 -9.7390693664550781e+01 1.7755498886108398e+01 -2.0581700134277344e+02 -9.7370994567871094e+01 1.7628999710083008e+01 -2.0566600036621094e+02 -9.7370994567871094e+01 1.7925899505615234e+01 -2.0591700744628906e+02 -9.6766098022460938e+01 1.7439800262451172e+01 -2.0639599609375000e+02 -9.6766098022460938e+01 1.7238000869750977e+01 -2.0622601318359375e+02 -9.6781501770019531e+01 1.7333099365234375e+01 -2.0631800842285156e+02 -9.7682899475097656e+01 3.1798299789428711e+01 -1.8905499267578125e+02 -9.7265899658203125e+01 3.1895298004150391e+01 -1.8923999023437500e+02 -9.7265899658203125e+01 3.1746700286865234e+01 -1.8944599914550781e+02 -9.7723602294921875e+01 3.1550298690795898e+01 -1.8930499267578125e+02 -9.7740097045898438e+01 3.1560600280761719e+01 -1.8923999023437500e+02 -9.7742202758789062e+01 3.1599901199340820e+01 -1.8917498779296875e+02 -9.7732498168945312e+01 3.1655099868774414e+01 -1.8912098693847656e+02 -9.7717704772949219e+01 3.1697999954223633e+01 -1.8910099792480469e+02 -9.7696800231933594e+01 3.1533599853515625e+01 -1.8941099548339844e+02 -9.6492904663085938e+01 3.2550899505615234e+01 -1.8994299316406250e+02 -9.6960998535156250e+01 3.1934398651123047e+01 -1.8956098937988281e+02 -9.6960998535156250e+01 3.2064697265625000e+01 -1.8938099670410156e+02 -9.6616096496582031e+01 3.2413200378417969e+01 -1.8967199707031250e+02 -9.6616096496582031e+01 3.2320701599121094e+01 -1.8979899597167969e+02 -9.6492904663085938e+01 3.2621303558349609e+01 -1.8984700012207031e+02 -9.6338699340820312e+01 3.3281700134277344e+01 -1.9040699768066406e+02 -9.6338699340820312e+01 3.3281097412109375e+01 -1.9040800476074219e+02 -9.7300697326660156e+01 4.3598400115966797e+01 -1.8798199462890625e+02 -9.7280601501464844e+01 4.3667598724365234e+01 -1.8806100463867188e+02 -9.7300201416015625e+01 4.3556400299072266e+01 -1.8796099853515625e+02 -9.7276206970214844e+01 4.3552200317382812e+01 -1.8796600341796875e+02 -9.7298896789550781e+01 4.3459800720214844e+01 -1.8791299438476562e+02 -9.7283599853515625e+01 4.3486301422119141e+01 -1.8793701171875000e+02 -9.7291603088378906e+01 4.3416000366210938e+01 -1.8790499877929688e+02 -9.6338699340820312e+01 4.2571800231933594e+01 -1.8937500000000000e+02 -9.6432502746582031e+01 4.2984298706054688e+01 -1.8888500976562500e+02 -9.7254402160644531e+01 4.3738700866699219e+01 -1.8820899963378906e+02 -9.6951499938964844e+01 4.3528400421142578e+01 -1.8823699951171875e+02 -9.7279602050781250e+01 4.3670299530029297e+01 -1.8806700134277344e+02 -9.6951499938964844e+01 4.3369201660156250e+01 -1.8811999511718750e+02 -9.6612899780273438e+01 4.3256397247314453e+01 -1.8856100463867188e+02 -9.6338699340820312e+01 4.2570999145507812e+01 -1.8937399291992188e+02 -9.6432502746582031e+01 4.2916000366210938e+01 -1.8883499145507812e+02 -9.6612899780273438e+01 4.3142898559570312e+01 -1.8847799682617188e+02 -9.8024894714355469e+01 6.6537299156188965e+00 -2.3262199401855469e+02 -9.8256904602050781e+01 6.7106499671936035e+00 -2.3294900512695312e+02 -9.8272399902343750e+01 6.2294001579284668e+00 -2.3297000122070312e+02 -9.8082199096679688e+01 6.3074197769165039e+00 -2.3266899108886719e+02 -9.8098098754882812e+01 6.1284298896789551e+00 -2.3261601257324219e+02 -9.8276603698730469e+01 5.9769096374511719e+00 -2.3287899780273438e+02 -9.8277198791503906e+01 5.7743201255798340e+00 -2.3272599792480469e+02 -9.8274398803710938e+01 5.6255502700805664e+00 -2.3251899719238281e+02 -9.8100296020507812e+01 5.9887199401855469e+00 -2.3251199340820312e+02 -9.8089599609375000e+01 5.8918600082397461e+00 -2.3236499023437500e+02 -9.8024894714355469e+01 5.8542499542236328e+00 -2.3194999694824219e+02 -9.8256904602050781e+01 5.5229701995849609e+00 -2.3194999694824219e+02 -9.8024894714355469e+01 1.7350599288940430e+01 -2.3075599670410156e+02 -9.8256904602050781e+01 1.7407600402832031e+01 -2.3108200073242188e+02 -9.7722404479980469e+01 6.0503501892089844e+00 -2.2416499328613281e+02 -9.8009498596191406e+01 5.8339800834655762e+00 -2.2429400634765625e+02 -9.8120803833007812e+01 5.7501201629638672e+00 -2.2434399414062500e+02 -9.8252105712890625e+01 5.5202798843383789e+00 -2.2447999572753906e+02 -9.8272705078125000e+01 5.4843397140502930e+00 -2.2450199890136719e+02 -9.8256904602050781e+01 1.8246799468994141e+01 -2.3009001159667969e+02 -9.8024894714355469e+01 1.7915500640869141e+01 -2.3008799743652344e+02 -9.8265899658203125e+01 1.8202999114990234e+01 -2.3045698547363281e+02 -9.8058204650878906e+01 1.7902599334716797e+01 -2.3034700012207031e+02 -9.8268699645996094e+01 1.8084999084472656e+01 -2.3069599914550781e+02 -9.8268096923828125e+01 1.7906999588012695e+01 -2.3088499450683594e+02 -9.8068397521972656e+01 1.7827398300170898e+01 -2.3051300048828125e+02 -9.8066200256347656e+01 1.7705400466918945e+01 -2.3063999938964844e+02 -9.8051803588867188e+01 1.7543998718261719e+01 -2.3072299194335938e+02 -9.8264205932617188e+01 1.7678300857543945e+01 -2.3101599121093750e+02 -9.8291206359863281e+01 5.3826599121093750e+00 -2.2441000366210938e+02 -9.8286499023437500e+01 5.4346899986267090e+00 -2.2445500183105469e+02 -9.8286499023437500e+01 5.3290700912475586e+00 -2.2436698913574219e+02 -9.8272705078125000e+01 5.2750701904296875e+00 -2.2432600402832031e+02 -9.8252105712890625e+01 5.2899699211120605e+00 -2.2428700256347656e+02 -9.8120803833007812e+01 5.3852200508117676e+00 -2.2403700256347656e+02 -9.8160995483398438e+01 5.4868502616882324e+00 -2.2409500122070312e+02 -9.8009498596191406e+01 5.4199700355529785e+00 -2.2394599914550781e+02 -9.7722404479980469e+01 5.5096697807312012e+00 -2.2371000671386719e+02 -9.7781097412109375e+01 5.6922397613525391e+00 -2.2374501037597656e+02 -9.7801696777343750e+01 5.8590798377990723e+00 -2.2384400939941406e+02 -9.7781097412109375e+01 5.9848399162292480e+00 -2.2399101257324219e+02 -9.8160995483398438e+01 5.6750802993774414e+00 -2.2425399780273438e+02 -9.8174598693847656e+01 5.5854897499084473e+00 -2.2416900634765625e+02 -9.8285697937011719e+01 1.8371900558471680e+01 -2.2224099731445312e+02 -9.8249298095703125e+01 1.8301099777221680e+01 -2.2221000671386719e+02 -9.8152305603027344e+01 1.8112400054931641e+01 -2.2212600708007812e+02 -9.8005104064941406e+01 1.7990600585937500e+01 -2.2207200622558594e+02 -9.7760604858398438e+01 1.7788200378417969e+01 -2.2198199462890625e+02 -9.8256904602050781e+01 -2.2311000823974609e+01 -2.2907400512695312e+02 -9.8024894714355469e+01 -2.2367698669433594e+01 -2.2874800109863281e+02 -9.8181999206542969e+01 1.8270399093627930e+01 -2.2192298889160156e+02 -9.8181999206542969e+01 1.8183900833129883e+01 -2.2202099609375000e+02 -9.7806495666503906e+01 1.7859998703002930e+01 -2.2178900146484375e+02 -9.7806495666503906e+01 1.8000200271606445e+01 -2.2163000488281250e+02 -9.8005104064941406e+01 1.8297399520874023e+01 -2.2172500610351562e+02 -9.7760604858398438e+01 1.8183500289916992e+01 -2.2153500366210938e+02 -9.8152305603027344e+01 1.8365999221801758e+01 -2.2183999633789062e+02 -9.8295394897460938e+01 1.8416601181030273e+01 -2.2218699645996094e+02 -9.8295394897460938e+01 1.8463600158691406e+01 -2.2213398742675781e+02 -9.8249298095703125e+01 1.8472200393676758e+01 -2.2201699829101562e+02 -9.8285697937011719e+01 1.8511999130249023e+01 -2.2208300781250000e+02 -9.7935401916503906e+01 -3.1787500381469727e+01 -2.3034899902343750e+02 -9.8167205810546875e+01 -3.1737499237060547e+01 -2.3067599487304688e+02 -9.7668098449707031e+01 -4.1203899383544922e+01 -2.3188499450683594e+02 -9.7899696350097656e+01 -4.1160598754882812e+01 -2.3221099853515625e+02 -9.8024894714355469e+01 2.2150300979614258e+01 -2.2120399475097656e+02 -9.8256904602050781e+01 2.2192598342895508e+01 -2.2153300476074219e+02 -9.7868194580078125e+01 -4.2022796630859375e+01 -2.3235200500488281e+02 -9.7835304260253906e+01 -4.2885097503662109e+01 -2.3249200439453125e+02 -9.7641601562500000e+01 -4.2065200805664062e+01 -2.3202799987792969e+02 -9.7613899230957031e+01 -4.2926502227783203e+01 -2.3217100524902344e+02 -9.8334403991699219e+01 2.3388299942016602e+01 -2.2169999694824219e+02 -9.8191497802734375e+01 2.3332399368286133e+01 -2.2125999450683594e+02 -9.8233795166015625e+01 2.3349000930786133e+01 -2.2139100646972656e+02 -9.7971199035644531e+01 2.3300100326538086e+01 -2.2100900268554688e+02 -9.8016700744628906e+01 2.3306800842285156e+01 -2.2106100463867188e+02 -9.7830696105957031e+01 -4.3056701660156250e+01 -2.3251100158691406e+02 -9.7618400573730469e+01 -4.3045700073242188e+01 -2.3218899536132812e+02 -9.8015998840332031e+01 2.5154100418090820e+01 -2.2077499389648438e+02 -9.8248001098632812e+01 2.5214500427246094e+01 -2.2110099792480469e+02 -9.7914894104003906e+01 3.2512798309326172e+01 -2.1836399841308594e+02 -9.7993904113769531e+01 2.7686199188232422e+01 -2.2020399475097656e+02 -9.7959693908691406e+01 3.0148899078369141e+01 -2.1940499877929688e+02 -9.8146995544433594e+01 3.2667701721191406e+01 -2.1866099548339844e+02 -9.8225898742675781e+01 2.7776201248168945e+01 -2.2052400207519531e+02 -9.8191703796386719e+01 3.0270601272583008e+01 -2.1971499633789062e+02 -9.7637901306152344e+01 -4.3299800872802734e+01 -2.3217700195312500e+02 -9.7591102600097656e+01 -4.3687900543212891e+01 -2.3171299743652344e+02 -9.7790199279785156e+01 -4.4005100250244141e+01 -2.3180900573730469e+02 -9.7597702026367188e+01 -4.3680900573730469e+01 -2.3175500488281250e+02 -9.7792602539062500e+01 -4.3990100860595703e+01 -2.3186599731445312e+02 -9.7627296447753906e+01 -4.3590797424316406e+01 -2.3197200012207031e+02 -9.7635704040527344e+01 -4.3515701293945312e+01 -2.3205900573730469e+02 -9.7639503479003906e+01 -4.3423500061035156e+01 -2.3212599182128906e+02 -9.7805999755859375e+01 -4.3840099334716797e+01 -2.3216700744628906e+02 -9.7812301635742188e+01 -4.3726600646972656e+01 -2.3228999328613281e+02 -9.7818099975585938e+01 -4.3591598510742188e+01 -2.3238900756835938e+02 -9.7823799133300781e+01 -4.3414398193359375e+01 -2.3246900939941406e+02 -9.7802001953125000e+01 3.6859798431396484e+01 -2.1553599548339844e+02 -9.7719200134277344e+01 3.9353401184082031e+01 -2.1310200500488281e+02 -9.8034202575683594e+01 3.7079898834228516e+01 -2.1579399108886719e+02 -9.7951599121093750e+01 3.9614700317382812e+01 -2.1332200622558594e+02 -9.7861297607421875e+01 3.4768501281738281e+01 -2.1706999206542969e+02 -9.8093505859375000e+01 3.4955799102783203e+01 -2.1735000610351562e+02 -9.7783500671386719e+01 -4.4041000366210938e+01 -2.3148599243164062e+02 -9.7571502685546875e+01 -4.3702201843261719e+01 -2.3148599243164062e+02 -9.7698005676269531e+01 3.9935699462890625e+01 -2.1240200805664062e+02 -9.7677299499511719e+01 4.0486701965332031e+01 -2.1167700195312500e+02 -9.7930297851562500e+01 4.0206901550292969e+01 -2.1261100769042969e+02 -9.7909698486328125e+01 4.0767200469970703e+01 -2.1187500000000000e+02 -9.7783500671386719e+01 -4.4041000366210938e+01 -2.1700799560546875e+02 -9.7571502685546875e+01 -4.3702201843261719e+01 -2.1700799560546875e+02 -9.7575798034667969e+01 4.3600101470947266e+01 -2.0565299987792969e+02 -9.7644302368164062e+01 4.1552700042724609e+01 -2.1007600402832031e+02 -9.7575798034667969e+01 4.3600101470947266e+01 -2.0565199279785156e+02 -9.7788696289062500e+01 4.3921398162841797e+01 -2.0575900268554688e+02 -9.7870300292968750e+01 4.1848400115966797e+01 -2.1024699401855469e+02 -9.7586799621582031e+01 -4.3677597045898438e+01 -2.1677101135253906e+02 -9.7789505004882812e+01 -4.3993202209472656e+01 -2.1666499328613281e+02 -9.7795005798339844e+01 -4.3895698547363281e+01 -2.1645500183105469e+02 -9.7594200134277344e+01 -4.3613899230957031e+01 -2.1662800598144531e+02 -9.7485000610351562e+01 4.4962001800537109e+01 -1.9617900085449219e+02 -9.7518501281738281e+01 4.5007797241210938e+01 -1.9617800903320312e+02 -9.7528999328613281e+01 4.4892898559570312e+01 -1.9931199645996094e+02 -9.7683105468750000e+01 4.5233100891113281e+01 -1.9617399597167969e+02 -9.7709197998046875e+01 4.5342899322509766e+01 -1.9617199707031250e+02 -9.7733100891113281e+01 4.5227401733398438e+01 -1.9933900451660156e+02 -9.7788101196289062e+01 4.5673900604248047e+01 -1.9616600036621094e+02 -9.7573303222656250e+01 4.3671897888183594e+01 -2.0544000244140625e+02 -9.7785697937011719e+01 4.3993999481201172e+01 -2.0554299926757812e+02 -9.7534400939941406e+01 4.4747501373291016e+01 -2.0067399597167969e+02 -9.7739501953125000e+01 4.5080799102783203e+01 -2.0071600341796875e+02 -9.7799705505371094e+01 -4.3805999755859375e+01 -2.1633100891113281e+02 -9.7806793212890625e+01 -4.3620998382568359e+01 -2.1616799926757812e+02 -9.7600105285644531e+01 -4.3554702758789062e+01 -2.1654200744628906e+02 -9.7602203369140625e+01 -4.3427898406982422e+01 -2.1643299865722656e+02 -9.7735298156738281e+01 4.5177799224853516e+01 -1.9359899902343750e+02 -9.7745498657226562e+01 4.4942699432373047e+01 -1.9175698852539062e+02 -9.7530899047851562e+01 4.4843700408935547e+01 -1.9363099670410156e+02 -9.7539497375488281e+01 4.4610198974609375e+01 -1.9180700683593750e+02 -9.7525001525878906e+01 4.5000400543212891e+01 -1.9607800292968750e+02 -9.7728294372558594e+01 4.5335597991943359e+01 -1.9606800842285156e+02 -9.7817901611328125e+01 -4.3305599212646484e+01 -2.1602799987792969e+02 -9.7820297241210938e+01 -4.3226699829101562e+01 -2.1601199340820312e+02 -9.7602699279785156e+01 -4.3210903167724609e+01 -2.1634199523925781e+02 -9.7601600646972656e+01 -4.3156200408935547e+01 -2.1633300781250000e+02 -9.7562095642089844e+01 4.3977699279785156e+01 -1.8824600219726562e+02 -9.7550804138183594e+01 4.4294498443603516e+01 -1.8992201232910156e+02 -9.7759002685546875e+01 4.4626602172851562e+01 -1.8986499023437500e+02 -9.7772499084472656e+01 4.4309501647949219e+01 -1.8818199157714844e+02 -9.7862899780273438e+01 -4.2126201629638672e+01 -2.1580900573730469e+02 -9.7903099060058594e+01 -4.1025199890136719e+01 -2.1560800170898438e+02 -9.7637397766113281e+01 -4.2055900573730469e+01 -2.1613299560546875e+02 -9.7671203613281250e+01 -4.0955200195312500e+01 -2.1593399047851562e+02 -9.7588195800781250e+01 4.3850399017333984e+01 -1.8792300415039062e+02 -9.7776397705078125e+01 4.4272300720214844e+01 -1.8802600097656250e+02 -9.7571800231933594e+01 4.3956699371337891e+01 -1.8813600158691406e+02 -9.7786903381347656e+01 4.4107997894287109e+01 -1.8772000122070312e+02 -9.7936897277832031e+01 -3.1538698196411133e+01 -2.1420199584960938e+02 -9.8168899536132812e+01 -3.1601999282836914e+01 -2.1387599182128906e+02 -9.8024894714355469e+01 -2.2118900299072266e+01 -2.1253498840332031e+02 -9.8256904602050781e+01 -2.2175600051879883e+01 -2.1220899963378906e+02 -9.7606193542480469e+01 4.3541599273681641e+01 -1.8770500183105469e+02 -9.7604202270507812e+01 4.3478298187255859e+01 -1.8769200134277344e+02 -9.7808006286621094e+01 4.3650096893310547e+01 -1.8740199279785156e+02 -9.7810600280761719e+01 4.3558998107910156e+01 -1.8738000488281250e+02 -9.7601303100585938e+01 4.3746299743652344e+01 -1.8780900573730469e+02 -9.7796096801757812e+01 4.3949699401855469e+01 -1.8755699157714844e+02 -9.7764595031738281e+01 5.6566600799560547e+00 -2.0789498901367188e+02 -9.8004806518554688e+01 5.5387601852416992e+00 -2.0771099853515625e+02 -9.8155403137207031e+01 5.4647898674011230e+00 -2.0759500122070312e+02 -9.8249198913574219e+01 5.3564901351928711e+00 -2.0742599487304688e+02 -9.8287002563476562e+01 5.3128600120544434e+00 -2.0735800170898438e+02 -9.7821304321289062e+01 4.3233100891113281e+01 -1.8736599731445312e+02 -9.7602203369140625e+01 4.3254402160644531e+01 -1.8768901062011719e+02 -9.8183403015136719e+01 5.5552101135253906e+00 -2.0751098632812500e+02 -9.8183403015136719e+01 5.6366901397705078e+00 -2.0741499328613281e+02 -9.7808097839355469e+01 5.9643998146057129e+00 -2.0763800048828125e+02 -9.7764595031738281e+01 6.0316300392150879e+00 -2.0744900512695312e+02 -9.7808097839355469e+01 5.8319001197814941e+00 -2.0779600524902344e+02 -9.8287002563476562e+01 5.4445300102233887e+00 -2.0720199584960938e+02 -9.8296005249023438e+01 5.4025702476501465e+00 -2.0725500488281250e+02 -9.8296005249023438e+01 5.3583998680114746e+00 -2.0730799865722656e+02 -9.8249198913574219e+01 5.5190300941467285e+00 -2.0723300170898438e+02 -9.8155403137207031e+01 5.7039799690246582e+00 -2.0731100463867188e+02 -9.8004806518554688e+01 5.8302898406982422e+00 -2.0736399841308594e+02 -9.7861900329589844e+01 4.2184902191162109e+01 -1.8747100830078125e+02 -9.7636299133300781e+01 4.2207199096679688e+01 -1.8779699707031250e+02 -9.7900299072265625e+01 4.1136699676513672e+01 -1.8757699584960938e+02 -9.7668701171875000e+01 4.1159999847412109e+01 -1.8790599060058594e+02 -9.8256904602050781e+01 5.5229701995849609e+00 -1.9637100219726562e+02 -9.8024894714355469e+01 5.8542499542236328e+00 -1.9637100219726562e+02 -9.7820899963378906e+01 3.6572200775146484e+01 -1.8836000061035156e+02 -9.7931098937988281e+01 3.1983098983764648e+01 -1.8883000183105469e+02 -9.8052703857421875e+01 3.6545600891113281e+01 -1.8803100585937500e+02 -9.8162895202636719e+01 3.1953397750854492e+01 -1.8850100708007812e+02 -9.8266105651855469e+01 5.5664200782775879e+00 -1.9599699401855469e+02 -9.8058898925781250e+01 5.8664698600769043e+00 -1.9610699462890625e+02 -9.8268798828125000e+01 5.6843700408935547e+00 -1.9575799560546875e+02 -9.8268203735351562e+01 5.8623499870300293e+00 -1.9556900024414062e+02 -9.8068901062011719e+01 5.9417500495910645e+00 -1.9594099426269531e+02 -9.8066497802734375e+01 6.0638799667358398e+00 -1.9581399536132812e+02 -9.8052001953125000e+01 6.2254700660705566e+00 -1.9573100280761719e+02 -9.8264205932617188e+01 6.0912399291992188e+00 -1.9543800354003906e+02 -9.8024894714355469e+01 6.4191198348999023e+00 -1.9569900512695312e+02 -9.8256904602050781e+01 6.3621997833251953e+00 -1.9537300109863281e+02 -9.7949897766113281e+01 3.1378299713134766e+01 -1.8964799499511719e+02 -9.7994796752929688e+01 3.1318500518798828e+01 -1.8938699340820312e+02 -9.7983001708984375e+01 3.1712200164794922e+01 -1.8885398864746094e+02 -9.8182502746582031e+01 3.1585399627685547e+01 -1.8856700134277344e+02 -9.8010200500488281e+01 3.1508300781250000e+01 -1.8895700073242188e+02 -9.8015998840332031e+01 3.1426797866821289e+01 -1.8904000854492188e+02 -9.8015701293945312e+01 3.1366699218750000e+01 -1.8913899230957031e+02 -9.8194000244140625e+01 3.1304098129272461e+01 -1.8873399353027344e+02 -9.8197196960449219e+01 3.1188400268554688e+01 -1.8885700988769531e+02 -9.8198402404785156e+01 3.1099500656127930e+01 -1.8900099182128906e+02 -9.8194198608398438e+01 3.1010799407958984e+01 -1.8935400390625000e+02 -9.8181503295898438e+01 3.1061100006103516e+01 -1.8971900939941406e+02 -9.8024894714355469e+01 1.7112199783325195e+01 -1.9383200073242188e+02 -9.8256904602050781e+01 1.7055299758911133e+01 -1.9350599670410156e+02 -9.8179100036621094e+01 3.1196701049804688e+01 -1.9036500549316406e+02 -9.8176200866699219e+01 3.1359399795532227e+01 -1.9125000000000000e+02 -9.7947601318359375e+01 3.1515199661254883e+01 -1.9030099487304688e+02 -9.7944602966308594e+01 3.1679500579833984e+01 -1.9119499206542969e+02 -9.8272399902343750e+01 1.7536600112915039e+01 -1.9348500061035156e+02 -9.8082199096679688e+01 1.7458600997924805e+01 -1.9378500366210938e+02 -9.8098098754882812e+01 1.7637500762939453e+01 -1.9383900451660156e+02 -9.8276603698730469e+01 1.7789098739624023e+01 -1.9357499694824219e+02 -9.8277198791503906e+01 1.7991699218750000e+01 -1.9372900390625000e+02 -9.8274398803710938e+01 1.8140501022338867e+01 -1.9393600463867188e+02 -9.8100296020507812e+01 1.7777299880981445e+01 -1.9394299316406250e+02 -9.8089599609375000e+01 1.7874200820922852e+01 -1.9408999633789062e+02 -9.8024894714355469e+01 1.7911701202392578e+01 -1.9450399780273438e+02 -9.8256904602050781e+01 1.8243000030517578e+01 -1.9450399780273438e+02 -9.8256599426269531e+01 3.1221900939941406e+01 -1.9360800170898438e+02 -9.8113296508789062e+01 3.1669698715209961e+01 -1.9360501098632812e+02 -9.8151695251464844e+01 3.1549800872802734e+01 -1.9360501098632812e+02 -9.8172698974609375e+01 3.1553998947143555e+01 -1.9333699035644531e+02 -9.7892997741699219e+01 3.1923000335693359e+01 -1.9360299682617188e+02 -9.7934600830078125e+01 3.1875200271606445e+01 -1.9360299682617188e+02 -9.7941200256347656e+01 3.1878400802612305e+01 -1.9333100891113281e+02 -9.8173301696777344e+01 3.1523298263549805e+01 -1.9263800048828125e+02 -9.8174400329589844e+01 3.1458299636840820e+01 -1.9194200134277344e+02 -9.7941696166992188e+01 3.1847000122070312e+01 -1.9261599731445312e+02 -9.7942901611328125e+01 3.1780500411987305e+01 -1.9190299987792969e+02 -9.7722900390625000e+01 1.7715801239013672e+01 -2.0531800842285156e+02 -9.8009399414062500e+01 1.7931999206542969e+01 -2.0519000244140625e+02 -9.8121101379394531e+01 1.8016298294067383e+01 -2.0513999938964844e+02 -9.8252105712890625e+01 1.8245700836181641e+01 -2.0500401306152344e+02 -9.8272796630859375e+01 1.8282100677490234e+01 -2.0498199462890625e+02 -9.8185005187988281e+01 3.0847198486328125e+01 -1.9811500549316406e+02 -9.7941505432128906e+01 3.1858198165893555e+01 -1.9467799377441406e+02 -9.8173095703125000e+01 3.1534299850463867e+01 -1.9465899658203125e+02 -9.8206100463867188e+01 2.9483598709106445e+01 -2.0069099426269531e+02 -9.7953498840332031e+01 3.1152500152587891e+01 -1.9822700500488281e+02 -9.7974395751953125e+01 2.9747699737548828e+01 -2.0088400268554688e+02 -9.8291206359863281e+01 1.8383399963378906e+01 -2.0507398986816406e+02 -9.8286598205566406e+01 1.8331499099731445e+01 -2.0502799987792969e+02 -9.8286598205566406e+01 1.8436700820922852e+01 -2.0511700439453125e+02 -9.8272796630859375e+01 1.8490501403808594e+01 -2.0515798950195312e+02 -9.8252105712890625e+01 1.8475400924682617e+01 -2.0519799804687500e+02 -9.8121101379394531e+01 1.8379899978637695e+01 -2.0544700622558594e+02 -9.8161102294921875e+01 1.8278600692749023e+01 -2.0538800048828125e+02 -9.8009399414062500e+01 1.8344900131225586e+01 -2.0553800964355469e+02 -9.7722900390625000e+01 1.8254899978637695e+01 -2.0577299499511719e+02 -9.7781303405761719e+01 1.8072700500488281e+01 -2.0573799133300781e+02 -9.7801795959472656e+01 1.7906398773193359e+01 -2.0563900756835938e+02 -9.7781303405761719e+01 1.7781099319458008e+01 -2.0549101257324219e+02 -9.8161102294921875e+01 1.8091098785400391e+01 -2.0522999572753906e+02 -9.8174697875976562e+01 1.8180400848388672e+01 -2.0531399536132812e+02 -9.8336700439453125e+01 2.3194700241088867e+01 -2.0404299926757812e+02 -9.8191902160644531e+01 2.3277898788452148e+01 -2.0451000976562500e+02 -9.8232002258300781e+01 2.3254899978637695e+01 -2.0438000488281250e+02 -9.8250595092773438e+01 2.4798900604248047e+01 -2.0399899291992188e+02 -9.8018600463867188e+01 2.4899101257324219e+01 -2.0431500244140625e+02 -9.8016899108886719e+01 2.3313098907470703e+01 -2.0470799255371094e+02 -9.7971603393554688e+01 2.3322200775146484e+01 -2.0475900268554688e+02 -9.8231193542480469e+01 2.7392700195312500e+01 -2.0274299621582031e+02 -9.7999404907226562e+01 2.7578498840332031e+01 -2.0301499938964844e+02 -9.8256904602050781e+01 2.2309700012207031e+01 -2.0454800415039062e+02 -9.8024894714355469e+01 2.2365299224853516e+01 -2.0487500000000000e+02 -9.8254196166992188e+01 -6.8364100456237793e+00 -1.5498800659179688e+02 -9.8338699340820312e+01 -6.4460597038269043e+00 -1.7576100158691406e+02 -9.8222099304199219e+01 -6.8258600234985352e+00 -1.7604798889160156e+02 -9.8251296997070312e+01 -6.8498797416687012e+00 -1.5498300170898438e+02 -9.8169403076171875e+01 -6.9976396560668945e+00 -1.7617799377441406e+02 -9.8017997741699219e+01 -7.1617999076843262e+00 -1.7630099487304688e+02 -9.7960700988769531e+01 -7.2239599227905273e+00 -1.7634800720214844e+02 -9.8015502929687500e+01 -7.1543998718261719e+00 -1.5486100769042969e+02 -9.8083099365234375e+01 -7.1087498664855957e+00 -1.5487899780273438e+02 -9.8338699340820312e+01 -6.4424901008605957e+00 -1.7576300048828125e+02 -9.8338699340820312e+01 -6.4433798789978027e+00 -1.7576300048828125e+02 -9.8034004211425781e+01 -7.1259698867797852e+00 -1.7647500610351562e+02 -9.8059494018554688e+01 -6.9914503097534180e+00 -1.7658599853515625e+02 -9.7960700988769531e+01 -6.6822199821472168e+00 -1.7670899963378906e+02 -9.8034004211425781e+01 -6.8371300697326660e+00 -1.7666799926757812e+02 -9.8209297180175781e+01 -6.9122300148010254e+00 -1.7625199890136719e+02 -9.8017997741699219e+01 -6.6628398895263672e+00 -1.7663400268554688e+02 -9.8209297180175781e+01 -6.7134499549865723e+00 -1.7638499450683594e+02 -9.8169403076171875e+01 -6.6115798950195312e+00 -1.7643499755859375e+02 -9.8338699340820312e+01 -6.4451699256896973e+00 -1.7576199340820312e+02 -9.8222801208496094e+01 -6.8156099319458008e+00 -1.7632299804687500e+02 -9.8338699340820312e+01 -6.4442696571350098e+00 -1.7576199340820312e+02 -9.8222206115722656e+01 -6.5588402748107910e+00 -1.7622500610351562e+02 -9.8254196166992188e+01 -6.6816201210021973e+00 -1.5479501342773438e+02 -9.8265197753906250e+01 -6.7467699050903320e+00 -1.5484599304199219e+02 -9.8265197753906250e+01 -6.8006501197814941e+00 -1.5491299438476562e+02 -9.8251296997070312e+01 -6.6898498535156250e+00 -1.5478298950195312e+02 -9.8116302490234375e+01 -6.9513897895812988e+00 -1.5464498901367188e+02 -9.8083099365234375e+01 -6.8473801612854004e+00 -1.5455299377441406e+02 -9.8116302490234375e+01 -7.0409798622131348e+00 -1.5475698852539062e+02 -9.8015502929687500e+01 -6.8751602172851562e+00 -1.5451200866699219e+02 -9.8024894714355469e+01 -4.7200298309326172e+00 -1.7578199768066406e+02 -9.8024894714355469e+01 -2.3573598861694336e+00 -1.7460400390625000e+02 -9.8256904602050781e+01 -4.8603401184082031e+00 -1.7548200988769531e+02 -9.8256904602050781e+01 -2.5125098228454590e+00 -1.7431100463867188e+02 -9.8338294982910156e+01 -5.4681901931762695e+00 -1.5489999389648438e+02 -9.8231796264648438e+01 -5.5380501747131348e+00 -1.5454701232910156e+02 -9.8192802429199219e+01 -5.5636801719665527e+00 -1.5441799926757812e+02 -9.8017898559570312e+01 -5.6027798652648926e+00 -1.5422099304199219e+02 -9.7972496032714844e+01 -5.6129698753356934e+00 -1.5417001342773438e+02 -9.8256904602050781e+01 1.6485999822616577e+00 -1.7135900878906250e+02 -9.8256904602050781e+01 1.6487200260162354e+00 -1.7135900878906250e+02 -9.8024894714355469e+01 1.8754600286483765e+00 -1.7160000610351562e+02 -9.8024894714355469e+01 1.8753999471664429e+00 -1.7160000610351562e+02 -9.8024894714355469e+01 9.3158399686217308e-03 -1.7313699340820312e+02 -9.8024894714355469e+01 -1.1500699520111084e+00 -1.7391200256347656e+02 -9.8256904602050781e+01 -1.8443800508975983e-01 -1.7286799621582031e+02 -9.8256904602050781e+01 -1.3244099617004395e+00 -1.7363000488281250e+02 -9.8024894714355469e+01 -5.5614700317382812e+00 -1.5420800781250000e+02 -9.8256904602050781e+01 -5.5052599906921387e+00 -1.5453399658203125e+02 -9.8024894714355469e+01 -1.2528300285339355e+00 -1.5407200622558594e+02 -9.8024894714355469e+01 -2.6997900009155273e+00 -1.5397299194335938e+02 -9.8024894714355469e+01 -4.1406097412109375e+00 -1.5402500915527344e+02 -9.8256904602050781e+01 -4.1127800941467285e+00 -1.5435501098632812e+02 -9.8256904602050781e+01 -2.7045600414276123e+00 -1.5430400085449219e+02 -9.8256904602050781e+01 -1.2939000129699707e+00 -1.5440100097656250e+02 -9.8256904602050781e+01 2.6268901824951172e+00 -1.7034100341796875e+02 -9.8024894714355469e+01 3.7654600143432617e+00 -1.6941299438476562e+02 -9.8024894714355469e+01 4.8236303329467773e+00 -1.6759399414062500e+02 -9.8256904602050781e+01 3.4930698871612549e+00 -1.6922500610351562e+02 -9.8256904602050781e+01 4.5250597000122070e+00 -1.6744999694824219e+02 -9.8024894714355469e+01 2.8774099349975586e+00 -1.7055799865722656e+02 -9.8024894714355469e+01 1.1737200431525707e-02 -1.5431300354003906e+02 -9.8256904602050781e+01 -7.2054401040077209e-02 -1.5463400268554688e+02 -9.8256904602050781e+01 1.0886200666427612e+00 -1.5503099060058594e+02 -9.8024894714355469e+01 1.2197500467300415e+00 -1.5472599792480469e+02 -9.8256904602050781e+01 2.1771199703216553e+00 -1.5561099243164062e+02 -9.8024894714355469e+01 2.3572998046875000e+00 -1.5533299255371094e+02 -9.7972496032714844e+01 5.9003801345825195e+00 -1.6235198974609375e+02 -9.8024894714355469e+01 5.8456101417541504e+00 -1.6322900390625000e+02 -9.8017898559570312e+01 5.8481698036193848e+00 -1.6235400390625000e+02 -9.8256904602050781e+01 5.5145597457885742e+00 -1.6321598815917969e+02 -9.8232406616210938e+01 5.5156898498535156e+00 -1.6236401367187500e+02 -9.8192802429199219e+01 5.6471199989318848e+00 -1.6236000061035156e+02 -9.8337997436523438e+01 5.1649799346923828e+00 -1.6237600708007812e+02 -9.8024894714355469e+01 5.7030301094055176e+00 -1.6471000671386719e+02 -9.8024894714355469e+01 5.3715100288391113e+00 -1.6617700195312500e+02 -9.8024894714355469e+01 4.8236799240112305e+00 -1.6759300231933594e+02 -9.8256904602050781e+01 5.0542297363281250e+00 -1.6608099365234375e+02 -9.8256904602050781e+01 5.3756799697875977e+00 -1.6465798950195312e+02 -9.8256904602050781e+01 3.8673300743103027e+00 -1.5719000244140625e+02 -9.8256904602050781e+01 4.5298299789428711e+00 -1.5824000549316406e+02 -9.8024894714355469e+01 4.1317300796508789e+00 -1.5699000549316406e+02 -9.8024894714355469e+01 4.8233299255371094e+00 -1.5808599853515625e+02 -9.8256904602050781e+01 3.1055800914764404e+00 -1.5633900451660156e+02 -9.8024894714355469e+01 3.3326098918914795e+00 -1.5609799194335938e+02 -9.8256904602050781e+01 5.4975700378417969e+00 -1.6194200134277344e+02 -9.8024894714355469e+01 5.8278999328613281e+00 -1.6191700744628906e+02 -9.8256904602050781e+01 5.3387899398803711e+00 -1.6068299865722656e+02 -9.8256904602050781e+01 5.0293798446655273e+00 -1.5943800354003906e+02 -9.8025001525878906e+01 5.6647596359252930e+00 -1.6062399291992188e+02 -9.8025001525878906e+01 5.3445100784301758e+00 -1.5933599853515625e+02 -9.7972496032714844e+01 -1.5260700225830078e+01 -1.9387400817871094e+02 -9.7972496032714844e+01 -1.2975799560546875e+01 -1.9364500427246094e+02 -9.8017898559570312e+01 -1.5255700111389160e+01 -1.9392601013183594e+02 -9.8017898559570312e+01 -1.2970399856567383e+01 -1.9369700622558594e+02 -9.8192802429199219e+01 -1.5236399650573730e+01 -1.9412599182128906e+02 -9.8192802429199219e+01 -1.2949800491333008e+01 -1.9389698791503906e+02 -9.8234901428222656e+01 -1.5223899841308594e+01 -1.9425599670410156e+02 -9.8235298156738281e+01 -1.2936299324035645e+01 -1.9402799987792969e+02 -9.8336006164550781e+01 -1.5193799972534180e+01 -1.9457000732421875e+02 -9.8335494995117188e+01 -1.2904600143432617e+01 -1.9433499145507812e+02 -9.8024894714355469e+01 -1.0508399963378906e+01 -1.9336000061035156e+02 -9.8256904602050781e+01 -1.0454899787902832e+01 -1.9368701171875000e+02 -9.8256904602050781e+01 -5.3941597938537598e+00 -1.9254399108886719e+02 -9.8024894714355469e+01 -5.4864902496337891e+00 -1.9222599792480469e+02 -9.8256904602050781e+01 -5.0922399759292603e-01 -1.9079800415039062e+02 -9.8024894714355469e+01 -6.3942497968673706e-01 -1.9049400329589844e+02 -9.8256904602050781e+01 -1.6958400726318359e+01 -1.9436900329589844e+02 -9.8024894714355469e+01 -1.6973400115966797e+01 -1.9403800964355469e+02 -9.8024894714355469e+01 -2.2160299301147461e+01 -1.9386999511718750e+02 -9.8256904602050781e+01 -2.2198099136352539e+01 -1.9419898986816406e+02 -9.8024894714355469e+01 2.6000099182128906e+00 -1.8892599487304688e+02 -9.8256904602050781e+01 2.7584400177001953e+00 -1.8921800231933594e+02 -9.8256904602050781e+01 5.8232498168945312e+00 -1.8734399414062500e+02 -9.8024894714355469e+01 5.6363301277160645e+00 -1.8707099914550781e+02 -9.8256904602050781e+01 9.8910303115844727e+00 -1.8408499145507812e+02 -9.8024894714355469e+01 9.6646499633789062e+00 -1.8384300231933594e+02 -9.8019401550292969e+01 -2.4508800506591797e+01 -1.9350300598144531e+02 -9.8251403808593750e+01 -2.4574701309204102e+01 -1.9382800292968750e+02 -9.8002799987792969e+01 -2.6816099166870117e+01 -1.9294099426269531e+02 -9.8234802246093750e+01 -2.6910501480102539e+01 -1.9325900268554688e+02 -9.8024894714355469e+01 1.2070300102233887e+01 -1.8132099914550781e+02 -9.8256904602050781e+01 1.2322800636291504e+01 -1.8153500366210938e+02 -9.8256904602050781e+01 1.4419099807739258e+01 -1.7876100158691406e+02 -9.8024894714355469e+01 1.4143800735473633e+01 -1.7857701110839844e+02 -9.8256904602050781e+01 1.6958799362182617e+01 -1.7419099426269531e+02 -9.8024894714355469e+01 1.6657199859619141e+01 -1.7405400085449219e+02 -9.7854705810546875e+01 -3.4994098663330078e+01 -1.8892100524902344e+02 -9.7814704895019531e+01 -3.6166900634765625e+01 -1.8798600769042969e+02 -9.7765197753906250e+01 -3.6129001617431641e+01 -1.8794400024414062e+02 -9.7985496520996094e+01 -3.6297599792480469e+01 -1.8813299560546875e+02 -9.8086898803710938e+01 -3.5200801849365234e+01 -1.8918701171875000e+02 -9.8043395996093750e+01 -3.6389701843261719e+01 -1.8823899841308594e+02 -9.8103202819824219e+01 -3.6484798431396484e+01 -1.8834700012207031e+02 -9.8164093017578125e+01 -3.1815900802612305e+01 -1.9131399536132812e+02 -9.7932006835937500e+01 -3.1658000946044922e+01 -1.9101899719238281e+02 -9.8256904602050781e+01 1.9336000442504883e+01 -1.6435598754882812e+02 -9.8235000610351562e+01 1.9392099380493164e+01 -1.6148999023437500e+02 -9.8335800170898438e+01 1.9705299377441406e+01 -1.6148400878906250e+02 -9.8024894714355469e+01 1.9005300521850586e+01 -1.6433599853515625e+02 -9.7972496032714844e+01 1.9007600784301758e+01 -1.6149899291992188e+02 -9.8017898559570312e+01 1.9059900283813477e+01 -1.6149800109863281e+02 -9.8192802429199219e+01 1.9261001586914062e+01 -1.6149299621582031e+02 -9.8024894714355469e+01 1.8317998886108398e+01 -1.6914300537109375e+02 -9.8256904602050781e+01 1.8640701293945312e+01 -1.6921800231933594e+02 -9.8050598144531250e+01 -3.6518199920654297e+01 -1.8812200927734375e+02 -9.7818397521972656e+01 -3.6292301177978516e+01 -1.8786999511718750e+02 -9.7702194213867188e+01 -3.9806800842285156e+01 -1.8404800415039062e+02 -9.7934600830078125e+01 -4.0086002349853516e+01 -1.8424700927734375e+02 -9.7677398681640625e+01 -4.0471099853515625e+01 -1.8309498596191406e+02 -9.7909797668457031e+01 -4.0759998321533203e+01 -1.8328100585937500e+02 -9.8024894714355469e+01 1.8292398452758789e+01 -1.5530999755859375e+02 -9.8024894714355469e+01 1.8975000381469727e+01 -1.5972499084472656e+02 -9.8256904602050781e+01 1.9305400848388672e+01 -1.5970100402832031e+02 -9.8256904602050781e+01 1.8614099502563477e+01 -1.5523100280761719e+02 -9.8256904602050781e+01 1.6690500259399414e+01 -1.5026699829101562e+02 -9.8024894714355469e+01 1.6400899887084961e+01 -1.5042799377441406e+02 -9.7836601257324219e+01 -4.2728099822998047e+01 -1.7975599670410156e+02 -9.7616004943847656e+01 -4.2417102813720703e+01 -1.7961700439453125e+02 -9.8256904602050781e+01 1.6690399169921875e+01 -1.5026699829101562e+02 -9.8024894714355469e+01 1.3598899841308594e+01 -1.4648500061035156e+02 -9.8024894714355469e+01 1.1743200302124023e+01 -1.4467700195312500e+02 -9.8024894714355469e+01 9.6683502197265625e+00 -1.4312500000000000e+02 -9.8256904602050781e+01 1.3845000267028809e+01 -1.4626300048828125e+02 -9.8256904602050781e+01 1.1958399772644043e+01 -1.4442601013183594e+02 -9.8256904602050781e+01 9.8494892120361328e+00 -1.4284700012207031e+02 -9.7594497680664062e+01 -4.3054500579833984e+01 -1.7810900878906250e+02 -9.7811103820800781e+01 -4.3373001098632812e+01 -1.7822599792480469e+02 -9.7531196594238281e+01 -4.4832901000976562e+01 -1.6829200744628906e+02 -9.7548797607421875e+01 -4.4350799560546875e+01 -1.7339700317382812e+02 -9.7756698608398438e+01 -4.4682800292968750e+01 -1.7345399475097656e+02 -9.7735702514648438e+01 -4.5168701171875000e+01 -1.6829699707031250e+02 -9.8256904602050781e+01 7.5615000724792480e+00 -1.4152899169921875e+02 -9.8024894714355469e+01 7.4121899604797363e+00 -1.4182501220703125e+02 -9.8256904602050781e+01 5.1703996658325195e+00 -1.4047700500488281e+02 -9.8024894714355469e+01 5.0528597831726074e+00 -1.4078700256347656e+02 -9.8256904602050781e+01 8.1668302416801453e-02 -1.3908900451660156e+02 -9.8024894714355469e+01 2.3533299565315247e-02 -1.3941499328613281e+02 -9.7737297058105469e+01 -4.5131603240966797e+01 -1.6597900390625000e+02 -9.7538101196289062e+01 -4.4645202636718750e+01 -1.6400399780273438e+02 -9.7550697326660156e+01 -4.4298801422119141e+01 -1.6147399902343750e+02 -9.7743804931640625e+01 -4.4979900360107422e+01 -1.6397100830078125e+02 -9.7758895874023438e+01 -4.4631401062011719e+01 -1.6141900634765625e+02 -9.7532501220703125e+01 -4.4796001434326172e+01 -1.6599400329589844e+02 -9.7972496032714844e+01 -1.1301799774169922e+01 -1.3917500305175781e+02 -9.8017898559570312e+01 -1.1308800697326660e+01 -1.3912400817871094e+02 -9.8024894714355469e+01 -1.0268500328063965e+01 -1.3902099609375000e+02 -9.8192802429199219e+01 -1.1335800170898438e+01 -1.3892399597167969e+02 -9.8232002258300781e+01 -1.1353399276733398e+01 -1.3879400634765625e+02 -9.8256904602050781e+01 -1.0298900604248047e+01 -1.3869099426269531e+02 -9.8338203430175781e+01 -1.1401199340820312e+01 -1.3844099426269531e+02 -9.8256904602050781e+01 -5.0939898490905762e+00 -1.3854100036621094e+02 -9.8256904602050781e+01 8.1475198268890381e-02 -1.3908900451660156e+02 -9.8024894714355469e+01 2.3457897827029228e-02 -1.3941499328613281e+02 -9.8024894714355469e+01 -5.1060299873352051e+00 -1.3887199401855469e+02 -9.7802398681640625e+01 -4.3585399627685547e+01 -1.5709599304199219e+02 -9.7587303161621094e+01 -4.3260997772216797e+01 -1.5719599914550781e+02 -9.7616798400878906e+01 -4.2385700225830078e+01 -1.5479600524902344e+02 -9.7837600708007812e+01 -4.2702598571777344e+01 -1.5466999816894531e+02 -9.8024894714355469e+01 -1.7733400344848633e+01 -1.4012199401855469e+02 -9.8256904602050781e+01 -1.7784000396728516e+01 -1.3979499816894531e+02 -9.7837600708007812e+01 -4.2702499389648438e+01 -1.5466999816894531e+02 -9.7677604675292969e+01 -4.0454101562500000e+01 -1.5099600219726562e+02 -9.7910095214843750e+01 -4.0750202178955078e+01 -1.5082099914550781e+02 -9.8256904602050781e+01 -1.8642700195312500e+01 -1.4079699707031250e+02 -9.8024894714355469e+01 -1.8311399459838867e+01 -1.4079699707031250e+02 -9.8266700744628906e+01 -1.8593198776245117e+01 -1.4040200805664062e+02 -9.8060897827148438e+01 -1.8296100616455078e+01 -1.4051799011230469e+02 -9.8269302368164062e+01 -1.8470499038696289e+01 -1.4016600036621094e+02 -9.8268501281738281e+01 -1.8288801193237305e+01 -1.3998199462890625e+02 -9.8070503234863281e+01 -1.8217399597167969e+01 -1.4035398864746094e+02 -9.8067703247070312e+01 -1.8092399597167969e+01 -1.4022999572753906e+02 -9.8052597045898438e+01 -1.7928701400756836e+01 -1.4014999389648438e+02 -9.8264404296875000e+01 -1.8056999206542969e+01 -1.3985499572753906e+02 -9.7678695678710938e+01 -4.0426101684570312e+01 -1.5094999694824219e+02 -9.7731498718261719e+01 -3.8977600097656250e+01 -1.4881500244140625e+02 -9.7911201477050781e+01 -4.0721698760986328e+01 -1.5077400207519531e+02 -9.7963806152343750e+01 -3.9253997802734375e+01 -1.4861399841308594e+02 -9.8338699340820312e+01 -1.9032400131225586e+01 -1.7734100341796875e+02 -9.8231300354003906e+01 -1.8588100433349609e+01 -1.7755599975585938e+02 -9.8245300292968750e+01 -1.8645599365234375e+01 -1.7752799987792969e+02 -9.7772003173828125e+01 -1.8137498855590820e+01 -1.7777200317382812e+02 -9.8018104553222656e+01 -1.8305000305175781e+01 -1.7769200134277344e+02 -9.8023696899414062e+01 -1.8312400817871094e+01 -1.7768899536132812e+02 -9.8003997802734375e+01 -3.8048000335693359e+01 -1.4714799499511719e+02 -9.8044502258300781e+01 -3.6726200103759766e+01 -1.4580899047851562e+02 -9.8100196838378906e+01 -3.4685802459716797e+01 -1.4414399719238281e+02 -9.7771598815917969e+01 -3.7791698455810547e+01 -1.4737300109863281e+02 -9.7812194824218750e+01 -3.6492000579833984e+01 -1.4605400085449219e+02 -9.7868003845214844e+01 -3.4485401153564453e+01 -1.4441500854492188e+02 -9.8338699340820312e+01 -1.9033399581909180e+01 -1.7734199523925781e+02 -9.8338699340820312e+01 -1.9034500122070312e+01 -1.7734300231933594e+02 -9.8252296447753906e+01 -1.8654199600219727e+01 -1.7763600158691406e+02 -9.8245300292968750e+01 -1.8834701538085938e+01 -1.7772500610351562e+02 -9.8338699340820312e+01 -1.9035499572753906e+01 -1.7734399414062500e+02 -9.8066299438476562e+01 -1.8392000198364258e+01 -1.7783799743652344e+02 -9.8023696899414062e+01 -1.8658998489379883e+01 -1.7805099487304688e+02 -9.8231300354003906e+01 -1.8804698944091797e+01 -1.7778199768066406e+02 -9.8252296447753906e+01 -1.8727600097656250e+01 -1.7771199035644531e+02 -9.7824897766113281e+01 -1.8217399597167969e+01 -1.7797200012207031e+02 -9.7824897766113281e+01 -1.8370100021362305e+01 -1.7813200378417969e+02 -9.7772003173828125e+01 -1.8565601348876953e+01 -1.7822200012207031e+02 -9.8066299438476562e+01 -1.8513700485229492e+01 -1.7796499633789062e+02 -9.8018104553222656e+01 -1.8655101776123047e+01 -1.7805899047851562e+02 -9.7905097961425781e+01 -3.4279499053955078e+01 -1.4427799987792969e+02 -9.7901199340820312e+01 -3.3665199279785156e+01 -1.4441600036621094e+02 -9.8132797241210938e+01 -3.3466999053955078e+01 -1.4415701293945312e+02 -9.7919204711914062e+01 -3.3821300506591797e+01 -1.4429899597167969e+02 -9.8133300781250000e+01 -3.3701198577880859e+01 -1.4400199890136719e+02 -9.7922897338867188e+01 -3.4043098449707031e+01 -1.4423799133300781e+02 -9.8128105163574219e+01 -3.4028999328613281e+01 -1.4391999816894531e+02 -9.8116394042968750e+01 -3.4377601623535156e+01 -1.4396899414062500e+02 -9.8024894714355469e+01 -1.9695899963378906e+01 -1.7807101440429688e+02 -9.8256904602050781e+01 -1.9692199707031250e+01 -1.7773899841308594e+02 -9.8256904602050781e+01 -2.2313600540161133e+01 -1.7749600219726562e+02 -9.8024894714355469e+01 -2.2372400283813477e+01 -1.7782199096679688e+02 -9.7975402832031250e+01 -2.9581998825073242e+01 -1.4762599182128906e+02 -9.8207099914550781e+01 -2.9380901336669922e+01 -1.4736700439453125e+02 -9.8016204833984375e+01 -2.5498300552368164e+01 -1.5085299682617188e+02 -9.8248199462890625e+01 -2.5294198989868164e+01 -1.5059399414062500e+02 -9.8023696899414062e+01 -2.3486999511718750e+01 -1.7757701110839844e+02 -9.8023696899414062e+01 -2.3486801147460938e+01 -1.7757701110839844e+02 -9.8255699157714844e+01 -2.3403900146484375e+01 -1.7725599670410156e+02 -9.8255699157714844e+01 -2.3403400421142578e+01 -1.7725700378417969e+02 -9.8062004089355469e+01 -2.5286100387573242e+01 -1.5101799011230469e+02 -9.8016899108886719e+01 -2.5434299468994141e+01 -1.5186500549316406e+02 -9.8248802185058594e+01 -2.5199199676513672e+01 -1.5209600830078125e+02 -9.8061096191406250e+01 -2.5250600814819336e+01 -1.5168299865722656e+02 -9.8261695861816406e+01 -2.4969099044799805e+01 -1.5182400512695312e+02 -9.8083900451660156e+01 -2.5158800125122070e+01 -1.5147399902343750e+02 -9.8087699890136719e+01 -2.5148399353027344e+01 -1.5135699462890625e+02 -9.8085594177246094e+01 -2.5164899826049805e+01 -1.5124200439453125e+02 -9.8268302917480469e+01 -2.4856201171875000e+01 -1.5151600646972656e+02 -9.8269401550292969e+01 -2.4844499588012695e+01 -1.5134700012207031e+02 -9.8268699645996094e+01 -2.4866800308227539e+01 -1.5117900085449219e+02 -9.8261695861816406e+01 -2.5022499084472656e+01 -1.5084700012207031e+02 -9.8010002136230469e+01 -2.6338800430297852e+01 -1.7644999694824219e+02 -9.7998298645019531e+01 -2.7704999923706055e+01 -1.7555000305175781e+02 -9.8241996765136719e+01 -2.6179901123046875e+01 -1.7616101074218750e+02 -9.8230102539062500e+01 -2.7505298614501953e+01 -1.7528900146484375e+02 -9.8018806457519531e+01 -2.4893301010131836e+01 -1.7712500000000000e+02 -9.8250801086425781e+01 -2.4774999618530273e+01 -1.7681599426269531e+02 -9.8202896118164062e+01 -2.9714799880981445e+01 -1.5848001098632812e+02 -9.8236099243164062e+01 -2.6912599563598633e+01 -1.5402899169921875e+02 -9.8220397949218750e+01 -2.8397998809814453e+01 -1.5610900878906250e+02 -9.8202896118164062e+01 -2.9714599609375000e+01 -1.5847900390625000e+02 -9.7971199035644531e+01 -3.0008298873901367e+01 -1.5833699035644531e+02 -9.7971199035644531e+01 -3.0008199691772461e+01 -1.5833599853515625e+02 -9.7988700866699219e+01 -2.8673799514770508e+01 -1.5593199157714844e+02 -9.8004295349121094e+01 -2.7168899536132812e+01 -1.5382299804687500e+02 -9.8194099426269531e+01 -3.0291500091552734e+01 -1.7182800292968750e+02 -9.8194099426269531e+01 -3.0291500091552734e+01 -1.7182699584960938e+02 -9.7962501525878906e+01 -3.0583499908447266e+01 -1.7197200012207031e+02 -9.7962501525878906e+01 -3.0583599090576172e+01 -1.7197200012207031e+02 -9.8205497741699219e+01 -2.9528200149536133e+01 -1.7314100646972656e+02 -9.8217803955078125e+01 -2.8594600677490234e+01 -1.7430200195312500e+02 -9.7973800659179688e+01 -2.9797000885009766e+01 -1.7332699584960938e+02 -9.7986099243164062e+01 -2.8831998825073242e+01 -1.7452799987792969e+02 -9.7896102905273438e+01 -3.1750600814819336e+01 -1.6686999511718750e+02 -9.8116394042968750e+01 -3.1497299194335938e+01 -1.6686299133300781e+02 -9.7937705993652344e+01 -3.1702701568603516e+01 -1.6686900329589844e+02 -9.7944099426269531e+01 -3.1718101501464844e+01 -1.6654299926757812e+02 -9.8175598144531250e+01 -3.1393598556518555e+01 -1.6653601074218750e+02 -9.8154296875000000e+01 -3.1377199172973633e+01 -1.6685899353027344e+02 -9.8260093688964844e+01 -3.1042299270629883e+01 -1.6685000610351562e+02 -9.7946395874023438e+01 -3.1582000732421875e+01 -1.6373899841308594e+02 -9.7955894470214844e+01 -3.1018100738525391e+01 -1.6097499084472656e+02 -9.8178001403808594e+01 -3.1259700775146484e+01 -1.6377900695800781e+02 -9.8187500000000000e+01 -3.0705900192260742e+01 -1.6106700134277344e+02 -9.8176399230957031e+01 -3.1351999282836914e+01 -1.6760299682617188e+02 -9.7944801330566406e+01 -3.1675901412963867e+01 -1.6762500000000000e+02 -9.8179397583007812e+01 -3.1179399490356445e+01 -1.6904299926757812e+02 -9.8185302734375000e+01 -3.0835199356079102e+01 -1.7046199035644531e+02 -9.7947799682617188e+01 -3.1499099731445312e+01 -1.6910000610351562e+02 -9.7953697204589844e+01 -3.1145099639892578e+01 -1.7056100463867188e+02 -9.8024894714355469e+01 6.4191799163818359e+00 -9.6808906555175781e+01 -9.8024894714355469e+01 1.7112298965454102e+01 -9.4943000793457031e+01 -9.8256904602050781e+01 6.3621997833251953e+00 -9.6482498168945312e+01 -9.8256904602050781e+01 1.7055299758911133e+01 -9.4616600036621094e+01 -9.8256904602050781e+01 5.5229701995849609e+00 -9.7480903625488281e+01 -9.8024894714355469e+01 5.8542499542236328e+00 -9.7480903625488281e+01 -9.8266105651855469e+01 5.5664200782775879e+00 -9.7106498718261719e+01 -9.8058898925781250e+01 5.8664698600769043e+00 -9.7217002868652344e+01 -9.8268798828125000e+01 5.6843700408935547e+00 -9.6868095397949219e+01 -9.8268203735351562e+01 5.8624100685119629e+00 -9.6679504394531250e+01 -9.8068901062011719e+01 5.9417500495910645e+00 -9.7051399230957031e+01 -9.8066497802734375e+01 6.0638799667358398e+00 -9.6923995971679688e+01 -9.8052001953125000e+01 6.2255301475524902e+00 -9.6840904235839844e+01 -9.8264205932617188e+01 6.0913000106811523e+00 -9.6547996520996094e+01 -9.8272399902343750e+01 1.7536600112915039e+01 -9.4595298767089844e+01 -9.8082199096679688e+01 1.7458600997924805e+01 -9.4896003723144531e+01 -9.8098098754882812e+01 1.7637500762939453e+01 -9.4949295043945312e+01 -9.8276603698730469e+01 1.7789098739624023e+01 -9.4685897827148438e+01 -9.8277198791503906e+01 1.7991699218750000e+01 -9.4839401245117188e+01 -9.8274398803710938e+01 1.8140501022338867e+01 -9.5046501159667969e+01 -9.8100296020507812e+01 1.7777299880981445e+01 -9.5053199768066406e+01 -9.8089599609375000e+01 1.7874200820922852e+01 -9.5200302124023438e+01 -9.8024894714355469e+01 1.7911701202392578e+01 -9.5614997863769531e+01 -9.8256904602050781e+01 1.8243000030517578e+01 -9.5614997863769531e+01 -9.8286796569824219e+01 5.4448800086975098e+00 -1.0671099853515625e+02 -9.8249198913574219e+01 5.5190901756286621e+00 -1.0674200439453125e+02 -9.8155105590820312e+01 5.7044000625610352e+00 -1.0681999969482422e+02 -9.8004806518554688e+01 5.8302898406982422e+00 -1.0687300109863281e+02 -9.7764198303222656e+01 6.0318698883056641e+00 -1.0695899963378906e+02 -9.7722000122070312e+01 1.7715499877929688e+01 -1.0476899719238281e+02 -9.8009597778320312e+01 1.7931999206542969e+01 -1.0463999938964844e+02 -9.8120399475097656e+01 1.8015399932861328e+01 -1.0459099578857422e+02 -9.8252105712890625e+01 1.8245700836181641e+01 -1.0445299530029297e+02 -9.8272499084472656e+01 1.8281200408935547e+01 -1.0443199920654297e+02 -9.8183197021484375e+01 5.5548501014709473e+00 -1.0702099609375000e+02 -9.8183197021484375e+01 5.6367497444152832e+00 -1.0692399597167969e+02 -9.7807899475097656e+01 5.9642801284790039e+00 -1.0714899444580078e+02 -9.7807899475097656e+01 5.8311200141906738e+00 -1.0730599975585938e+02 -9.8004806518554688e+01 5.5374498367309570e+00 -1.0722000122070312e+02 -9.7764198303222656e+01 5.6551098823547363e+00 -1.0740499877929688e+02 -9.8155105590820312e+01 5.4639601707458496e+00 -1.0710500335693359e+02 -9.8296005249023438e+01 5.4026799201965332e+00 -1.0676399993896484e+02 -9.8296005249023438e+01 5.3582801818847656e+00 -1.0681700134277344e+02 -9.8249198913574219e+01 5.3557696342468262e+00 -1.0693500518798828e+02 -9.8286796569824219e+01 5.3125000000000000e+00 -1.0686699676513672e+02 -9.8291099548339844e+01 1.8383300781250000e+01 -1.0452400207519531e+02 -9.8286399841308594e+01 1.8331001281738281e+01 -1.0447800445556641e+02 -9.8286399841308594e+01 1.8437101364135742e+01 -1.0456700134277344e+02 -9.8272499084472656e+01 1.8491300582885742e+01 -1.0460800170898438e+02 -9.8252105712890625e+01 1.8476600646972656e+01 -1.0464700317382812e+02 -9.8120399475097656e+01 1.8381500244140625e+01 -1.0489799499511719e+02 -9.8160697937011719e+01 1.8279600143432617e+01 -1.0483899688720703e+02 -9.8009597778320312e+01 1.8347000122070312e+01 -1.0498899841308594e+02 -9.7722000122070312e+01 1.8257598876953125e+01 -1.0522399902343750e+02 -9.7780899047851562e+01 1.8074600219726562e+01 -1.0519000244140625e+02 -9.7801605224609375e+01 1.7907299041748047e+01 -1.0509099578857422e+02 -9.7780899047851562e+01 1.7781200408935547e+01 -1.0494400024414062e+02 -9.8160697937011719e+01 1.8090700149536133e+01 -1.0468099975585938e+02 -9.8174499511718750e+01 1.8180599212646484e+01 -1.0476499938964844e+02 -9.8024894714355469e+01 -2.2121601104736328e+01 -1.1193899536132812e+02 -9.8256904602050781e+01 -2.2177000045776367e+01 -1.1161199951171875e+02 -9.8256904602050781e+01 2.2312200546264648e+01 -1.0397200012207031e+02 -9.8024894714355469e+01 2.2369901657104492e+01 -1.0429900360107422e+02 -9.8329299926757812e+01 -2.5238100051879883e+01 -1.1176099395751953e+02 -9.8254798889160156e+01 -2.3687700271606445e+01 -1.1186900329589844e+02 -9.8222801208496094e+01 -2.5185499191284180e+01 -1.1211799621582031e+02 -9.8222801208496094e+01 -2.5185400009155273e+01 -1.1211799621582031e+02 -9.8183799743652344e+01 -2.5166200637817383e+01 -1.1224900054931641e+02 -9.8022804260253906e+01 -2.3631099700927734e+01 -1.1219599914550781e+02 -9.8009201049804688e+01 -2.5136199951171875e+01 -1.1244699859619141e+02 -9.7963600158691406e+01 -2.5128400802612305e+01 -1.1249900054931641e+02 -9.8009101867675781e+01 -2.5136199951171875e+01 -1.1244799804687500e+02 -9.8000000000000000e+01 2.7324798583984375e+01 -1.0343299865722656e+02 -9.8231895446777344e+01 2.7270700454711914e+01 -1.0310699462890625e+02 -9.7925796508789062e+01 3.2279300689697266e+01 -1.0258499908447266e+02 -9.8157699584960938e+01 3.2228702545166016e+01 -1.0225900268554688e+02 -9.8268096923828125e+01 -2.9382101058959961e+01 -1.1153600311279297e+02 -9.8013298034667969e+01 -2.5624399185180664e+01 -1.1250499725341797e+02 -9.8245201110839844e+01 -2.5655799865722656e+01 -1.1217500305175781e+02 -9.8143196105957031e+01 -2.9525300979614258e+01 -1.1181900024414062e+02 -9.8192604064941406e+01 -2.9468599319458008e+01 -1.1170700073242188e+02 -9.8212501525878906e+01 -2.8955598831176758e+01 -1.1192900085449219e+02 -9.7922897338867188e+01 -2.9638500213623047e+01 -1.1204600524902344e+02 -9.7966903686523438e+01 -2.9615900039672852e+01 -1.1200000000000000e+02 -9.7980606079101562e+01 -2.9058700561523438e+01 -1.1224199676513672e+02 -9.8231498718261719e+01 -2.7288099288940430e+01 -1.1221800231933594e+02 -9.7999603271484375e+01 -2.7302301406860352e+01 -1.1254899597167969e+02 -9.7964698791503906e+01 3.2544799804687500e+01 -1.0253799438476562e+02 -9.7897003173828125e+01 3.3064399719238281e+01 -1.0327299499511719e+02 -9.8129402160644531e+01 3.3404598236083984e+01 -1.0327299499511719e+02 -9.7909698486328125e+01 3.3074401855468750e+01 -1.0320800018310547e+02 -9.8132797241210938e+01 3.3409698486328125e+01 -1.0318499755859375e+02 -9.7951705932617188e+01 3.3062202453613281e+01 -1.0295700073242188e+02 -9.7976295471191406e+01 3.2968101501464844e+01 -1.0274800109863281e+02 -9.7981803894042969e+01 3.2888999938964844e+01 -1.0266300201416016e+02 -9.7981994628906250e+01 3.2792499542236328e+01 -1.0259799957275391e+02 -9.8145202636718750e+01 3.3360702514648438e+01 -1.0284099578857422e+02 -9.8154594421386719e+01 3.3207199096679688e+01 -1.0255099487304688e+02 -9.8158203125000000e+01 3.3089000701904297e+01 -1.0242900085449219e+02 -9.8160697937011719e+01 3.2949100494384766e+01 -1.0233300018310547e+02 -9.8162101745605469e+01 3.2598701477050781e+01 -1.0222700500488281e+02 -9.8268203735351562e+01 -3.0618999481201172e+01 -1.0804000091552734e+02 -9.8199394226074219e+01 -2.9918701171875000e+01 -1.1139500427246094e+02 -9.8123199462890625e+01 -3.1094699859619141e+01 -1.0807099914550781e+02 -9.8159996032714844e+01 -3.0974000930786133e+01 -1.0806299591064453e+02 -9.8184402465820312e+01 -3.0891599655151367e+01 -1.0910700225830078e+02 -9.7902900695800781e+01 -3.1347599029541016e+01 -1.0808700561523438e+02 -9.7944702148437500e+01 -3.1299699783325195e+01 -1.0808399963378906e+02 -9.7952903747558594e+01 -3.1213300704956055e+01 -1.0915399932861328e+02 -9.7944801330566406e+01 -3.1299598693847656e+01 -1.0808399963378906e+02 -9.7958999633789062e+01 -3.0805500030517578e+01 -1.1066600036621094e+02 -9.8190597534179688e+01 -3.0508600234985352e+01 -1.1053199768066406e+02 -9.7967697143554688e+01 -3.0140699386596680e+01 -1.1163500213623047e+02 -9.7897003173828125e+01 3.3064399719238281e+01 -1.1789800262451172e+02 -9.8129402160644531e+01 3.3404598236083984e+01 -1.1789800262451172e+02 -9.8182502746582031e+01 -3.1002099990844727e+01 -1.0780699920654297e+02 -9.7951004028320312e+01 -3.1326099395751953e+01 -1.0783000183105469e+02 -9.7950500488281250e+01 -3.1356300354003906e+01 -1.0709500122070312e+02 -9.7950698852539062e+01 -3.1340497970581055e+01 -1.0635700225830078e+02 -9.7951797485351562e+01 -3.1276699066162109e+01 -1.0561999511718750e+02 -9.7951797485351562e+01 -3.1276699066162109e+01 -1.0561899566650391e+02 -9.8183403015136719e+01 -3.0954099655151367e+01 -1.0565900421142578e+02 -9.8182098388671875e+01 -3.1031400680541992e+01 -1.0709100341796875e+02 -9.8182296752929688e+01 -3.1015998840332031e+01 -1.0637400054931641e+02 -9.7930900573730469e+01 3.3056999206542969e+01 -1.1814800262451172e+02 -9.7917701721191406e+01 3.2511100769042969e+01 -1.1857800292968750e+02 -9.8149703979492188e+01 3.2574897766113281e+01 -1.1890399932861328e+02 -9.7922401428222656e+01 3.2547500610351562e+01 -1.1857499694824219e+02 -9.8150093078613281e+01 3.2625999450683594e+01 -1.1889699554443359e+02 -9.7943794250488281e+01 3.2773899078369141e+01 -1.1851199340820312e+02 -9.7947204589843750e+01 3.2952800750732422e+01 -1.1836700439453125e+02 -9.8150405883789062e+01 3.2945598602294922e+01 -1.1878699493408203e+02 -9.8146804809570312e+01 3.3204700469970703e+01 -1.1856800079345703e+02 -9.8139396667480469e+01 3.3368198394775391e+01 -1.1825299835205078e+02 -9.7953102111816406e+01 -3.1203800201416016e+01 -1.0498999786376953e+02 -9.7954696655273438e+01 -3.1103599548339844e+01 -1.0404699707031250e+02 -9.8184600830078125e+01 -3.0880899429321289e+01 -1.0502700042724609e+02 -9.8186302185058594e+01 -3.0780199050903320e+01 -1.0408000183105469e+02 -9.7998405456542969e+01 2.7315498352050781e+01 -1.1950600433349609e+02 -9.8230300903320312e+01 2.7375598907470703e+01 -1.1983200073242188e+02 -9.8024894714355469e+01 2.2119400024414062e+01 -1.2041399383544922e+02 -9.8256904602050781e+01 2.2175800323486328e+01 -1.2073999786376953e+02 -9.7931495666503906e+01 -3.1859401702880859e+01 -1.0331100463867188e+02 -9.7988204956054688e+01 -3.1578102111816406e+01 -1.0327600097656250e+02 -9.7969802856445312e+01 -3.1084899902343750e+01 -1.0397200012207031e+02 -9.8190597534179688e+01 -3.0764600753784180e+01 -1.0397799682617188e+02 -9.8008697509765625e+01 -3.1076700210571289e+01 -1.0372599792480469e+02 -9.8026702880859375e+01 -3.1153999328613281e+01 -1.0351399993896484e+02 -9.8027397155761719e+01 -3.1228300094604492e+01 -1.0342200469970703e+02 -9.8021598815917969e+01 -3.1322502136230469e+01 -1.0335099792480469e+02 -9.8200698852539062e+01 -3.0783599853515625e+01 -1.0363800048828125e+02 -9.8203598022460938e+01 -3.0911300659179688e+01 -1.0334099578857422e+02 -9.8202301025390625e+01 -3.1021200180053711e+01 -1.0320899963378906e+02 -9.8198799133300781e+01 -3.1155700683593750e+01 -1.0310299682617188e+02 -9.8184600830078125e+01 -3.1510900497436523e+01 -1.0297100067138672e+02 -9.8163497924804688e+01 -3.1896099090576172e+01 -1.0298100280761719e+02 -9.7764595031738281e+01 1.8109600067138672e+01 -1.2092700195312500e+02 -9.8004806518554688e+01 1.8227500915527344e+01 -1.2111100006103516e+02 -9.8155403137207031e+01 1.8301399230957031e+01 -1.2122599792480469e+02 -9.8249198913574219e+01 1.8409601211547852e+01 -1.2139499664306641e+02 -9.8286895751953125e+01 1.8453199386596680e+01 -1.2146299743652344e+02 -9.7822006225585938e+01 -3.6437400817871094e+01 -1.0376500701904297e+02 -9.7670501708984375e+01 -4.1014102935791016e+01 -1.0423500061035156e+02 -9.8053901672363281e+01 -3.6477302551269531e+01 -1.0343500518798828e+02 -9.7902297973632812e+01 -4.1057300567626953e+01 -1.0390399932861328e+02 -9.8183296203613281e+01 1.8210800170898438e+01 -1.2131000518798828e+02 -9.8183296203613281e+01 1.8129301071166992e+01 -1.2140700531005859e+02 -9.7808006286621094e+01 1.7801599502563477e+01 -1.2118299865722656e+02 -9.7764595031738281e+01 1.7734300613403320e+01 -1.2137300109863281e+02 -9.7808006286621094e+01 1.7934200286865234e+01 -1.2102600097656250e+02 -9.8286895751953125e+01 1.8321498870849609e+01 -1.2162000274658203e+02 -9.8296005249023438e+01 1.8363399505615234e+01 -1.2156599426269531e+02 -9.8296005249023438e+01 1.8407600402832031e+01 -1.2151399993896484e+02 -9.8249198913574219e+01 1.8246900558471680e+01 -1.2158799743652344e+02 -9.8155403137207031e+01 1.8061901092529297e+01 -1.2151000213623047e+02 -9.8004806518554688e+01 1.7935701370239258e+01 -1.2145700073242188e+02 -9.7865501403808594e+01 -4.2065399169921875e+01 -1.0400500488281250e+02 -9.7639503479003906e+01 -4.2021800994873047e+01 -1.0433300018310547e+02 -9.7826797485351562e+01 -4.3073200225830078e+01 -1.0410700225830078e+02 -9.7606895446777344e+01 -4.3029098510742188e+01 -1.0443199920654297e+02 -9.8256904602050781e+01 1.8243000030517578e+01 -1.2930799865722656e+02 -9.8024894714355469e+01 1.7911701202392578e+01 -1.2930799865722656e+02 -9.7575500488281250e+01 -4.3602600097656250e+01 -1.0491899871826172e+02 -9.7586105346679688e+01 -4.3552700042724609e+01 -1.0477799987792969e+02 -9.7607002258300781e+01 -4.3035701751708984e+01 -1.0443199920654297e+02 -9.7826400756835938e+01 -4.3082798004150391e+01 -1.0410800170898438e+02 -9.7604995727539062e+01 -4.3258399963378906e+01 -1.0448899841308594e+02 -9.7596694946289062e+01 -4.3443901062011719e+01 -1.0462200164794922e+02 -9.7814704895019531e+01 -4.3408798217773438e+01 -1.0419799804687500e+02 -9.7802803039550781e+01 -4.3683200836181641e+01 -1.0439399719238281e+02 -9.7794097900390625e+01 -4.3847900390625000e+01 -1.0462000274658203e+02 -9.7788398742675781e+01 -4.3927402496337891e+01 -1.0482399749755859e+02 -9.8266105651855469e+01 1.8199600219726562e+01 -1.2968299865722656e+02 -9.8058898925781250e+01 1.7899499893188477e+01 -1.2957200622558594e+02 -9.8268798828125000e+01 1.8081600189208984e+01 -1.2992100524902344e+02 -9.8268203735351562e+01 1.7903600692749023e+01 -1.3011000061035156e+02 -9.8068901062011719e+01 1.7824298858642578e+01 -1.2973800659179688e+02 -9.8066497802734375e+01 1.7702100753784180e+01 -1.2986500549316406e+02 -9.8052001953125000e+01 1.7540498733520508e+01 -1.2994799804687500e+02 -9.8264205932617188e+01 1.7674699783325195e+01 -1.3024101257324219e+02 -9.8024894714355469e+01 1.7346799850463867e+01 -1.2997999572753906e+02 -9.8256904602050781e+01 1.7403800964355469e+01 -1.3030700683593750e+02 -9.7767196655273438e+01 -4.4434799194335938e+01 -1.0676100158691406e+02 -9.7751495361328125e+01 -4.4801799774169922e+01 -1.0883600616455078e+02 -9.7557701110839844e+01 -4.4104801177978516e+01 -1.0683100128173828e+02 -9.7544502258300781e+01 -4.4467899322509766e+01 -1.0887899780273438e+02 -9.8024894714355469e+01 6.6537299156188965e+00 -1.3184700012207031e+02 -9.8256904602050781e+01 6.7107100486755371e+00 -1.3217300415039062e+02 -9.7493904113769531e+01 -4.4677803039550781e+01 -1.1356099700927734e+02 -9.7528701782226562e+01 -4.4724800109863281e+01 -1.1356200408935547e+02 -9.7536201477050781e+01 -4.4695701599121094e+01 -1.1142200469970703e+02 -9.7741600036621094e+01 -4.5031497955322266e+01 -1.1140699768066406e+02 -9.7693603515625000e+01 -4.4947700500488281e+01 -1.1356599426269531e+02 -9.7721702575683594e+01 -4.5060703277587891e+01 -1.1356800079345703e+02 -9.7801002502441406e+01 -4.5380199432373047e+01 -1.1357399749755859e+02 -9.8272399902343750e+01 6.2294001579284668e+00 -1.3219499206542969e+02 -9.8082199096679688e+01 6.3074197769165039e+00 -1.3189401245117188e+02 -9.8098098754882812e+01 6.1284298896789551e+00 -1.3184100341796875e+02 -9.8276603698730469e+01 5.9769096374511719e+00 -1.3210398864746094e+02 -9.8277198791503906e+01 5.7743201255798340e+00 -1.3195001220703125e+02 -9.8274398803710938e+01 5.6255502700805664e+00 -1.3174299621582031e+02 -9.8100296020507812e+01 5.9887199401855469e+00 -1.3173699951171875e+02 -9.8089599609375000e+01 5.8918600082397461e+00 -1.3158999633789062e+02 -9.8024894714355469e+01 5.8542499542236328e+00 -1.3117500305175781e+02 -9.8256904602050781e+01 5.5229701995849609e+00 -1.3117500305175781e+02 -9.7584800720214844e+01 -4.3352100372314453e+01 -1.2060199737548828e+02 -9.7540695190429688e+01 -4.4573501586914062e+01 -1.1590699768066406e+02 -9.7584800720214844e+01 -4.3352001190185547e+01 -1.2060199737548828e+02 -9.7799499511718750e+01 -4.3663402557373047e+01 -1.2073400115966797e+02 -9.7799400329589844e+01 -4.3663597106933594e+01 -1.2073400115966797e+02 -9.7747001647949219e+01 -4.4907802581787109e+01 -1.1594400024414062e+02 -9.7723899841308594e+01 6.0497498512268066e+00 -1.2355899810791016e+02 -9.8009300231933594e+01 5.8337998390197754e+00 -1.2368599700927734e+02 -9.8122001647949219e+01 5.7485699653625488e+00 -1.2373600006103516e+02 -9.8251998901367188e+01 5.5202198028564453e+00 -1.2387000274658203e+02 -9.8273200988769531e+01 5.4829101562500000e+00 -1.2389199829101562e+02 -9.7676101684570312e+01 -4.0573501586914062e+01 -1.2463899993896484e+02 -9.7815696716308594e+01 -4.3262798309326172e+01 -1.2157099914550781e+02 -9.7598403930664062e+01 -4.2959499359130859e+01 -1.2141899871826172e+02 -9.7908401489257812e+01 -4.0815700531005859e+01 -1.2487999725341797e+02 -9.8291397094726562e+01 5.3824801445007324e+00 -1.2380100250244141e+02 -9.8286796569824219e+01 5.4339199066162109e+00 -1.2384600067138672e+02 -9.8286796569824219e+01 5.3296098709106445e+00 -1.2375699615478516e+02 -9.8273200988769531e+01 5.2762598991394043e+00 -1.2371700286865234e+02 -9.8251998901367188e+01 5.2919402122497559e+00 -1.2367600250244141e+02 -9.8122001647949219e+01 5.3877797126770020e+00 -1.2342900085449219e+02 -9.8161506652832031e+01 5.4883399009704590e+00 -1.2348799896240234e+02 -9.8009300231933594e+01 5.4235396385192871e+00 -1.2333699798583984e+02 -9.7723899841308594e+01 5.5141396522521973e+00 -1.2310399627685547e+02 -9.7781700134277344e+01 5.6953997611999512e+00 -1.2313999938964844e+02 -9.7802101135253906e+01 5.8606300354003906e+00 -1.2323900604248047e+02 -9.7781700134277344e+01 5.9849600791931152e+00 -1.2338600158691406e+02 -9.8161506652832031e+01 5.6743597984313965e+00 -1.2364599609375000e+02 -9.8174995422363281e+01 5.5857901573181152e+00 -1.2356200408935547e+02 -9.7709800720214844e+01 -3.9686698913574219e+01 -1.2541800689697266e+02 -9.7942100524902344e+01 -3.9902603149414062e+01 -1.2568000030517578e+02 -9.7942001342773438e+01 -3.9902603149414062e+01 -1.2568000030517578e+02 -9.8256904602050781e+01 -2.2306999206542969e+01 -1.2816799926757812e+02 -9.8024894714355469e+01 -2.2360200881958008e+01 -1.2784099578857422e+02 -9.8114295959472656e+01 -3.4153499603271484e+01 -1.2840699768066406e+02 -9.8114295959472656e+01 -3.4153301239013672e+01 -1.2840699768066406e+02 -9.7882301330566406e+01 -3.4069198608398438e+01 -1.2808399963378906e+02 -9.7882301330566406e+01 -3.4069099426269531e+01 -1.2808399963378906e+02 -9.8062202453613281e+01 -3.6147098541259766e+01 -1.2779100036621094e+02 -9.8006500244140625e+01 -3.8002403259277344e+01 -1.2693700408935547e+02 -9.7830101013183594e+01 -3.6022300720214844e+01 -1.2748000335693359e+02 -9.7774299621582031e+01 -3.7834598541259766e+01 -1.2664499664306641e+02 -9.7952697753906250e+01 -2.6806798934936523e+01 -1.2851100158691406e+02 -9.8019798278808594e+01 -2.4607999801635742e+01 -1.2820500183105469e+02 -9.7997596740722656e+01 -2.6800998687744141e+01 -1.2856300354003906e+02 -9.8211303710937500e+01 -2.6763000488281250e+01 -1.2889300537109375e+02 -9.8211196899414062e+01 -2.6763000488281250e+01 -1.2889300537109375e+02 -9.8251701354980469e+01 -2.4556299209594727e+01 -1.2853201293945312e+02 -9.8172904968261719e+01 -2.6778299331665039e+01 -1.2876300048828125e+02 -9.7997894287109375e+01 -2.6800998687744141e+01 -1.2856300354003906e+02 -9.8318397521972656e+01 -2.6720001220703125e+01 -1.2925599670410156e+02 -9.8212799072265625e+01 -2.8888198852539062e+01 -1.2898300170898438e+02 -9.7980796813964844e+01 -2.8887498855590820e+01 -1.2865098571777344e+02 -9.7938301086425781e+01 -3.1502798080444336e+01 -1.2852700805664062e+02 -9.8170196533203125e+01 -3.1541999816894531e+01 -1.2885600280761719e+02 -9.7623603820800781e+01 -4.2195201873779297e+01 -8.1090301513671875e+01 -9.7610603332519531e+01 -4.2585201263427734e+01 -8.0324005126953125e+01 -9.7529296875000000e+01 -4.4883697509765625e+01 -6.9970603942871094e+01 -9.7529098510742188e+01 -4.4890197753906250e+01 -6.9742393493652344e+01 -9.7733497619628906e+01 -4.5219200134277344e+01 -6.9980796813964844e+01 -9.7733200073242188e+01 -4.5225700378417969e+01 -6.9749496459960938e+01 -9.7548599243164062e+01 -4.4359401702880859e+01 -7.4847305297851562e+01 -9.7756401062011719e+01 -4.4690601348876953e+01 -7.4908897399902344e+01 -9.7830200195312500e+01 -4.2893802642822266e+01 -8.0466796875000000e+01 -9.7845596313476562e+01 -4.2497898101806641e+01 -8.1246597290039062e+01 -9.7623603820800781e+01 -4.2195098876953125e+01 -8.1090400695800781e+01 -9.7909500122070312e+01 -4.0769599914550781e+01 -8.3999000549316406e+01 -9.7677200317382812e+01 -4.0489200592041016e+01 -8.3801498413085938e+01 -9.7533706665039062e+01 -4.4766098022460938e+01 -6.6224205017089844e+01 -9.7579597473144531e+01 -4.3485801696777344e+01 -6.0009300231933594e+01 -9.7793304443359375e+01 -4.3809101104736328e+01 -5.9908699035644531e+01 -9.7577400207519531e+01 -4.3550098419189453e+01 -6.0210399627685547e+01 -9.7538902282714844e+01 -4.4623600006103516e+01 -6.4988601684570312e+01 -9.7790596008300781e+01 -4.3874000549316406e+01 -6.0112098693847656e+01 -9.7744895935058594e+01 -4.4956901550292969e+01 -6.4944702148437500e+01 -9.7738700866699219e+01 -4.5100700378417969e+01 -6.6194000244140625e+01 -9.7953903198242188e+01 -3.9549400329589844e+01 -8.5528404235839844e+01 -9.7721504211425781e+01 -3.9288700103759766e+01 -8.5307701110839844e+01 -9.8015304565429688e+01 -3.7698699951171875e+01 -8.7397201538085938e+01 -9.7782997131347656e+01 -3.7468700408935547e+01 -8.7147598266601562e+01 -9.8075706481933594e+01 -3.5630302429199219e+01 -8.9023597717285156e+01 -9.7843498229980469e+01 -3.5434101104736328e+01 -8.8749198913574219e+01 -9.7643096923828125e+01 -4.1579101562500000e+01 -5.5505397796630859e+01 -9.7793304443359375e+01 -4.3809101104736328e+01 -5.9908599853515625e+01 -9.7869003295898438e+01 -4.1883201599121094e+01 -5.5348999023437500e+01 -9.7910003662109375e+01 -4.0753799438476562e+01 -5.3432098388671875e+01 -9.7677604675292969e+01 -4.0462402343750000e+01 -5.3614002227783203e+01 -9.7986305236816406e+01 -2.8314498901367188e+01 -9.2154396057128906e+01 -9.8012702941894531e+01 -2.5647201538085938e+01 -9.2826499938964844e+01 -9.8218399047851562e+01 -2.8413599014282227e+01 -9.2471900939941406e+01 -9.8244697570800781e+01 -2.5715000152587891e+01 -9.3151397705078125e+01 -9.7947204589843750e+01 -3.0872200012207031e+01 -9.1237503051757812e+01 -9.8179306030273438e+01 -3.1004400253295898e+01 -9.1544204711914062e+01 -9.7703300476074219e+01 -3.9773502349853516e+01 -5.2597297668457031e+01 -9.7935699462890625e+01 -4.0055301666259766e+01 -5.2402297973632812e+01 -9.7729698181152344e+01 -3.9036899566650391e+01 -5.1614097595214844e+01 -9.7962097167968750e+01 -3.9308601379394531e+01 -5.1406600952148438e+01 -9.8012702941894531e+01 -2.5647100448608398e+01 -9.2826499938964844e+01 -9.8244697570800781e+01 -2.5714799880981445e+01 -9.3151397705078125e+01 -9.8024894714355469e+01 -2.2170400619506836e+01 -9.3352302551269531e+01 -9.8256904602050781e+01 -2.2203599929809570e+01 -9.3681999206542969e+01 -9.8158905029296875e+01 -3.2079902648925781e+01 -4.5208099365234375e+01 -9.8055603027343750e+01 -3.6342399597167969e+01 -4.8254699707031250e+01 -9.8109901428222656e+01 -3.4292198181152344e+01 -4.6619998931884766e+01 -9.8158905029296875e+01 -3.2080097198486328e+01 -4.5208099365234375e+01 -9.7926803588867188e+01 -3.1910697937011719e+01 -4.5497299194335938e+01 -9.7877700805664062e+01 -3.4092601776123047e+01 -4.6891399383544922e+01 -9.7823303222656250e+01 -3.6113601684570312e+01 -4.8504402160644531e+01 -9.8256904602050781e+01 -1.9171598434448242e+01 -9.3864906311035156e+01 -9.8024894714355469e+01 -1.9164600372314453e+01 -9.3533699035644531e+01 -9.8024894714355469e+01 -1.3999099731445312e+01 -9.3315902709960938e+01 -9.8026298522949219e+01 -1.3998899459838867e+01 -9.3317901611328125e+01 -9.8257896423339844e+01 -1.3964799880981445e+01 -9.3650199890136719e+01 -9.8256904602050781e+01 -1.3965199470520020e+01 -9.3645500183105469e+01 -9.8218200683593750e+01 -2.8420299530029297e+01 -4.3570999145507812e+01 -9.7986198425292969e+01 -2.8311298370361328e+01 -4.3885498046875000e+01 -9.8011497497558594e+01 -2.5805999755859375e+01 -4.3206199645996094e+01 -9.8243598937988281e+01 -2.5875400543212891e+01 -4.2881801605224609e+01 -9.8023895263671875e+01 -2.3232599258422852e+01 -4.2817699432373047e+01 -9.8255798339843750e+01 -2.3264900207519531e+01 -4.2487899780273438e+01 -9.8234001159667969e+01 -1.2305599212646484e+01 -9.3480499267578125e+01 -9.8235397338867188e+01 -1.2305100440979004e+01 -9.3485099792480469e+01 -9.8336898803710938e+01 -1.2269900321960449e+01 -9.3806999206542969e+01 -9.7972496032714844e+01 -1.2347400665283203e+01 -9.3098098754882812e+01 -9.8017898559570312e+01 -1.2341799736022949e+01 -9.3149993896484375e+01 -9.8019500732421875e+01 -1.2341500282287598e+01 -9.3151893615722656e+01 -9.8192802429199219e+01 -1.2319900512695312e+01 -9.3349998474121094e+01 -9.8068298339843750e+01 -2.2965700149536133e+01 -4.2790401458740234e+01 -9.8274703979492188e+01 -2.2551799774169922e+01 -4.2614002227783203e+01 -9.8275299072265625e+01 -2.2469001770019531e+01 -4.2674701690673828e+01 -9.8091201782226562e+01 -2.2723398208618164e+01 -4.2868202209472656e+01 -9.8093101501464844e+01 -2.2666000366210938e+01 -4.2908798217773438e+01 -9.8268394470214844e+01 -2.2893701553344727e+01 -4.2482799530029297e+01 -9.8024894714355469e+01 -9.9949207305908203e+00 -9.2813697814941406e+01 -9.8256904602050781e+01 -9.9403800964355469e+00 -9.3140495300292969e+01 -9.8256904602050781e+01 -4.8811397552490234e+00 -9.1991897583007812e+01 -9.8024894714355469e+01 -4.9733500480651855e+00 -9.1673797607421875e+01 -9.8256904602050781e+01 5.0011398270726204e-03 -9.0251701354980469e+01 -9.8024894714355469e+01 -1.2478200346231461e-01 -8.9946907043457031e+01 -9.8091293334960938e+01 -2.2579700469970703e+01 -4.2999500274658203e+01 -9.8274795532226562e+01 -2.2341699600219727e+01 -4.2806098937988281e+01 -9.8068901062011719e+01 -2.2480699539184570e+01 -4.3233497619628906e+01 -9.8268798828125000e+01 -2.2180700302124023e+01 -4.3134399414062500e+01 -9.8024894714355469e+01 -2.2484300613403320e+01 -4.3501399993896484e+01 -9.8256904602050781e+01 -2.2152999877929688e+01 -4.3503898620605469e+01 -9.8024894714355469e+01 3.0048499107360840e+00 -8.8440704345703125e+01 -9.8256904602050781e+01 3.1625599861145020e+00 -8.8732101440429688e+01 -9.8256904602050781e+01 5.0011500716209412e-03 -9.0251701354980469e+01 -9.8256904602050781e+01 6.1278901100158691e+00 -8.6932998657226562e+01 -9.8024894714355469e+01 5.9421100616455078e+00 -8.6658699035644531e+01 -9.8256904602050781e+01 1.0205299377441406e+01 -8.3681701660156250e+01 -9.8024894714355469e+01 9.9790697097778320e+00 -8.3439697265625000e+01 -9.8024894714355469e+01 -2.2588500976562500e+01 -5.7307998657226562e+01 -9.8256904602050781e+01 -2.2257200241088867e+01 -5.7310501098632812e+01 -9.8024894714355469e+01 1.2288800239562988e+01 -8.1021194458007812e+01 -9.8256904602050781e+01 1.2541199684143066e+01 -8.1235801696777344e+01 -9.8256904602050781e+01 1.4553400039672852e+01 -7.8573799133300781e+01 -9.8024894714355469e+01 1.4278100013732910e+01 -7.8389396667480469e+01 -9.8256904602050781e+01 1.7074199676513672e+01 -7.3985504150390625e+01 -9.8024894714355469e+01 1.6771299362182617e+01 -7.3851303100585938e+01 -9.8058403015136719e+01 -2.2618299484252930e+01 -5.7606300354003906e+01 -9.8034500122070312e+01 -2.2582700729370117e+01 -5.7373699188232422e+01 -9.8259498596191406e+01 -2.2255800247192383e+01 -5.7403999328613281e+01 -9.8265998840332031e+01 -2.2326198577880859e+01 -5.7736797332763672e+01 -9.8062904357910156e+01 -2.2742399215698242e+01 -5.7799701690673828e+01 -9.8267196655273438e+01 -2.2512100219726562e+01 -5.8019401550292969e+01 -9.8024894714355469e+01 1.9053699493408203e+01 -6.1407100677490234e+01 -9.8024894714355469e+01 1.8784400939941406e+01 -6.6614501953125000e+01 -9.8024894714355469e+01 1.8044198989868164e+01 -7.0273300170898438e+01 -9.8256904602050781e+01 1.8363698959350586e+01 -7.0361000061035156e+01 -9.8256904602050781e+01 1.9112798690795898e+01 -6.6658805847167969e+01 -9.8256904602050781e+01 1.9384901046752930e+01 -6.1398902893066406e+01 -9.8264205932617188e+01 -2.2723098754882812e+01 -5.8179599761962891e+01 -9.8256401062011719e+01 -2.3021800994873047e+01 -5.8284900665283203e+01 -9.8052200317382812e+01 -2.2890201568603516e+01 -5.7904300689697266e+01 -9.8024398803710938e+01 -2.3103000640869141e+01 -5.7963798522949219e+01 -9.8024894714355469e+01 1.8597801208496094e+01 -5.6776199340820312e+01 -9.8256904602050781e+01 1.8923700332641602e+01 -5.6716400146484375e+01 -9.8256904602050781e+01 1.8312898635864258e+01 -5.4158401489257812e+01 -9.8024894714355469e+01 1.7995399475097656e+01 -5.4252799987792969e+01 -9.8256904602050781e+01 1.7418001174926758e+01 -5.1689399719238281e+01 -9.8024894714355469e+01 1.7113899230957031e+01 -5.1820800781250000e+01 -9.8009101867675781e+01 -2.6463499069213867e+01 -5.9323299407958984e+01 -9.7979301452636719e+01 -2.9372699737548828e+01 -6.1781200408935547e+01 -9.8241096496582031e+01 -2.6297599792480469e+01 -5.9608200073242188e+01 -9.8210998535156250e+01 -2.9123800277709961e+01 -6.1993900299072266e+01 -9.8256904602050781e+01 1.7417900085449219e+01 -5.1689201354980469e+01 -9.8024894714355469e+01 1.5436399459838867e+01 -4.8673900604248047e+01 -9.8024894714355469e+01 1.3883800506591797e+01 -4.6594501495361328e+01 -9.8024894714355469e+01 1.2064900398254395e+01 -4.4746997833251953e+01 -9.8256904602050781e+01 1.5714399337768555e+01 -4.8493698120117188e+01 -9.8256904602050781e+01 1.4135199546813965e+01 -4.6378898620605469e+01 -9.8256904602050781e+01 1.2284499168395996e+01 -4.4498901367187500e+01 -9.7893997192382812e+01 -3.1865499496459961e+01 -6.9293403625488281e+01 -9.8174598693847656e+01 -3.1448402404785156e+01 -6.7685699462890625e+01 -9.8153297424316406e+01 -3.1492401123046875e+01 -6.9285499572753906e+01 -9.8114295959472656e+01 -3.1612197875976562e+01 -6.9288002014160156e+01 -9.8256904602050781e+01 -3.1173400878906250e+01 -6.9278701782226562e+01 -9.7935600280761719e+01 -3.1817800521850586e+01 -6.9292396545410156e+01 -9.7943000793457031e+01 -3.1771499633789062e+01 -6.7655197143554688e+01 -9.7956298828125000e+01 -3.0969100952148438e+01 -6.4376899719238281e+01 -9.8210998535156250e+01 -2.9123800277709961e+01 -6.1993999481201172e+01 -9.8187995910644531e+01 -3.0669700622558594e+01 -6.4504798889160156e+01 -9.8256904602050781e+01 1.2284299850463867e+01 -4.4498802185058594e+01 -9.8024894714355469e+01 9.1630201339721680e+00 -4.2604801177978516e+01 -9.8024894714355469e+01 6.8704500198364258e+00 -4.1387699127197266e+01 -9.8024894714355469e+01 4.4475197792053223e+00 -4.0438098907470703e+01 -9.8256904602050781e+01 9.3358106613159180e+00 -4.2322097778320312e+01 -9.8256904602050781e+01 7.0082497596740723e+00 -4.1086402893066406e+01 -9.8256904602050781e+01 4.5517101287841797e+00 -4.0123703002929688e+01 -9.7921501159667969e+01 -2.9915599822998047e+01 -7.4696899414062500e+01 -9.7969398498535156e+01 -3.0041198730468750e+01 -7.4509002685546875e+01 -9.7964797973632812e+01 -2.9881500244140625e+01 -7.4660705566406250e+01 -9.8141799926757812e+01 -2.9741600036621094e+01 -7.4512695312500000e+01 -9.8201202392578125e+01 -2.9806499481201172e+01 -7.4280899047851562e+01 -9.8190299987792969e+01 -2.9656600952148438e+01 -7.4423797607421875e+01 -9.8267196655273438e+01 -2.9521598815917969e+01 -7.4282402038574219e+01 -9.8173698425292969e+01 -3.1498600006103516e+01 -6.9315002441406250e+01 -9.7942199707031250e+01 -3.1823001861572266e+01 -6.9320899963378906e+01 -9.7935600280761719e+01 -3.1817701339721680e+01 -6.9292396545410156e+01 -9.7953300476074219e+01 -3.1152500152587891e+01 -7.2814300537109375e+01 -9.7949501037597656e+01 -3.1389198303222656e+01 -7.2185096740722656e+01 -9.8184898376464844e+01 -3.0854598999023438e+01 -7.2683296203613281e+01 -9.8181098937988281e+01 -3.1080200195312500e+01 -7.2083999633789062e+01 -9.8256904602050781e+01 4.5514698028564453e+00 -4.0123600006103516e+01 -9.8024894714355469e+01 4.4474601745605469e+00 -4.0438098907470703e+01 -9.8024894714355469e+01 7.3747301101684570e-01 -3.9504901885986328e+01 -9.8024894714355469e+01 -1.8317699432373047e+00 -3.9165298461914062e+01 -9.8024894714355469e+01 -4.4261798858642578e+00 -3.9040199279785156e+01 -9.8256904602050781e+01 7.9545199871063232e-01 -3.9178798675537109e+01 -9.8256904602050781e+01 -1.8025599718093872e+00 -3.8835296630859375e+01 -9.8256904602050781e+01 -4.4230198860168457e+00 -3.8708999633789062e+01 -9.8248001098632812e+01 -2.5267900466918945e+01 -7.6797203063964844e+01 -9.8209800720214844e+01 -2.9193901062011719e+01 -7.4847000122070312e+01 -9.8190299987792969e+01 -2.9656600952148438e+01 -7.4423698425292969e+01 -9.7978004455566406e+01 -2.9403099060058594e+01 -7.5099601745605469e+01 -9.8224700927734375e+01 -2.7989799499511719e+01 -7.5701896667480469e+01 -9.8237800598144531e+01 -2.6666700363159180e+01 -7.6352203369140625e+01 -9.8248001098632812e+01 -2.5268400192260742e+01 -7.6797096252441406e+01 -9.8016098022460938e+01 -2.5345399856567383e+01 -7.7118797302246094e+01 -9.8016098022460938e+01 -2.5345699310302734e+01 -7.7118705749511719e+01 -9.8005897521972656e+01 -2.6787300109863281e+01 -7.6659500122070312e+01 -9.7992897033691406e+01 -2.8156099319458008e+01 -7.5985900878906250e+01 -9.8256904602050781e+01 -5.4460201263427734e+00 -3.9722400665283203e+01 -9.8024894714355469e+01 -5.1147298812866211e+00 -3.9722400665283203e+01 -9.8264999389648438e+01 -5.4367799758911133e+00 -3.9466400146484375e+01 -9.8054901123046875e+01 -5.1237297058105469e+00 -3.9538497924804688e+01 -9.8271499633789062e+01 -5.3277001380920410e+00 -3.9153301239013672e+01 -9.8272705078125000e+01 -5.1075801849365234e+00 -3.8897800445556641e+01 -9.8079101562500000e+01 -5.0613899230957031e+00 -3.9315700531005859e+01 -9.8083396911621094e+01 -4.9132099151611328e+00 -3.9139503479003906e+01 -9.8064598083496094e+01 -4.6859998703002930e+00 -3.9039802551269531e+01 -9.8267601013183594e+01 -4.7854800224304199e+00 -3.8738197326660156e+01 -9.8254699707031250e+01 -2.3775199890136719e+01 -7.7096595764160156e+01 -9.8022697448730469e+01 -2.3826299667358398e+01 -7.7423698425292969e+01 -9.8024894714355469e+01 -2.2302299499511719e+01 -7.7605003356933594e+01 -9.8256904602050781e+01 -2.2275400161743164e+01 -7.7274795532226562e+01 -9.8024894714355469e+01 -5.1147298812866211e+00 -5.3340198516845703e+01 -9.8256904602050781e+01 -5.4460201263427734e+00 -5.3340198516845703e+01 -9.8024894714355469e+01 -1.9593799591064453e+01 -7.7659500122070312e+01 -9.8024894714355469e+01 -1.9593599319458008e+01 -7.7659500122070312e+01 -9.8256904602050781e+01 -1.9606199264526367e+01 -7.7328506469726562e+01 -9.8256904602050781e+01 -1.9605699539184570e+01 -7.7328506469726562e+01 -9.8256904602050781e+01 -4.4666500091552734e+00 -5.4353099822998047e+01 -9.8263595581054688e+01 -4.6775298118591309e+00 -5.4342300415039062e+01 -9.8024894714355469e+01 -4.4555101394653320e+00 -5.4021999359130859e+01 -9.8049499511718750e+01 -4.6068997383117676e+00 -5.4027000427246094e+01 -9.8080299377441406e+01 -5.0090498924255371e+00 -5.3820697784423828e+01 -9.8074798583984375e+01 -4.8311901092529297e+00 -5.3966400146484375e+01 -9.8271896362304688e+01 -5.2501001358032227e+00 -5.4017902374267578e+01 -9.8270401000976562e+01 -4.9927201271057129e+00 -5.4235202789306641e+01 -9.8062995910644531e+01 -5.1114001274108887e+00 -5.3597099304199219e+01 -9.8267196655273438e+01 -5.4125800132751465e+00 -5.3699699401855469e+01 -9.8256904602050781e+01 -1.7001100540161133e+01 -7.7195999145507812e+01 -9.7972496032714844e+01 -1.3931799888610840e+01 -7.7304901123046875e+01 -9.8024894714355469e+01 -1.4364199638366699e+01 -7.7305305480957031e+01 -9.8017898559570312e+01 -1.3937399864196777e+01 -7.7252998352050781e+01 -9.8192802429199219e+01 -1.3959300041198730e+01 -7.7053001403808594e+01 -9.8256904602050781e+01 -1.4398699760437012e+01 -7.6975898742675781e+01 -9.8235694885253906e+01 -1.3973499298095703e+01 -7.6922698974609375e+01 -9.8335105895996094e+01 -1.4006500244140625e+01 -7.6621002197265625e+01 -9.8024894714355469e+01 -1.6979200363159180e+01 -7.7526596069335938e+01 -9.8256904602050781e+01 -2.5052399635314941e+00 -5.4520801544189453e+01 -9.8256904602050781e+01 -1.1512000560760498e+00 -5.4763202667236328e+01 -9.8024894714355469e+01 -2.4595301151275635e+00 -5.4192699432373047e+01 -9.8024894714355469e+01 -1.0797400474548340e+00 -5.4439800262451172e+01 -9.8337799072265625e+01 -1.2416600227355957e+01 -7.6407798767089844e+01 -9.8232704162597656e+01 -1.2376000404357910e+01 -7.6751998901367188e+01 -9.8192802429199219e+01 -1.2360599517822266e+01 -7.6882499694824219e+01 -9.8017898559570312e+01 -1.2336999893188477e+01 -7.7082298278808594e+01 -9.7972496032714844e+01 -1.2330900192260742e+01 -7.7134201049804688e+01 -9.8256904602050781e+01 9.1367900371551514e-01 -5.5440399169921875e+01 -9.8256904602050781e+01 2.2028701305389404e+00 -5.6148101806640625e+01 -9.8024894714355469e+01 1.0497599840164185e+00 -5.5138401031494141e+01 -9.8024894714355469e+01 2.3857400417327881e+00 -5.5871799468994141e+01 -9.8256904602050781e+01 -9.7676090896129608e-02 -5.5049697875976562e+01 -9.8024894714355469e+01 5.1239598542451859e-03 -5.4734798431396484e+01 -9.8256904602050781e+01 -1.1190099716186523e+01 -7.6589004516601562e+01 -9.8024894714355469e+01 -1.1138400077819824e+01 -7.6916206359863281e+01 -9.8024894714355469e+01 -8.5332403182983398e+00 -7.6427696228027344e+01 -9.8256904602050781e+01 -8.6033296585083008e+00 -7.6103797912597656e+01 -9.8024894714355469e+01 -5.9624300003051758e+00 -7.5801795959472656e+01 -9.8256904602050781e+01 -6.0487399101257324e+00 -7.5481895446777344e+01 -9.8256904602050781e+01 3.8469398021697998e+00 -5.7664600372314453e+01 -9.8256904602050781e+01 4.5031299591064453e+00 -5.8667701721191406e+01 -9.8024894714355469e+01 4.1081299781799316e+00 -5.7460800170898438e+01 -9.8024894714355469e+01 4.7942399978637695e+00 -5.8509597778320312e+01 -9.8256904602050781e+01 3.0972402095794678e+00 -5.6848899841308594e+01 -9.8024894714355469e+01 3.3221797943115234e+00 -5.6605701446533203e+01 -9.8024894714355469e+01 -1.3826799578964710e-02 -7.3256500244140625e+01 -9.8256904602050781e+01 -1.8929700553417206e-01 -7.2975502014160156e+01 -9.8024894714355469e+01 -1.6460399627685547e+00 -7.4172805786132812e+01 -9.8024894714355469e+01 -3.3365499973297119e+00 -7.4931800842285156e+01 -9.8024894714355469e+01 -5.9623699188232422e+00 -7.5801795959472656e+01 -9.8256904602050781e+01 -1.7947499752044678e+00 -7.3876800537109375e+01 -9.8256904602050781e+01 -3.4592700004577637e+00 -7.4624099731445312e+01 -9.8256904602050781e+01 -6.0485000610351562e+00 -7.5481895446777344e+01 -9.8337699890136719e+01 5.1162199974060059e+00 -6.2576004028320312e+01 -9.8192802429199219e+01 5.5900797843933105e+00 -6.2557601928710938e+01 -9.8233001708984375e+01 5.4587697982788086e+00 -6.2562698364257812e+01 -9.8256904602050781e+01 5.4317698478698730e+00 -6.2050300598144531e+01 -9.7972496032714844e+01 5.8432798385620117e+00 -6.2547801971435547e+01 -9.8017898559570312e+01 5.7910699844360352e+00 -6.2549800872802734e+01 -9.8024894714355469e+01 5.7617998123168945e+00 -6.2021598815917969e+01 -9.8256904602050781e+01 5.2735800743103027e+00 -6.0898899078369141e+01 -9.8256904602050781e+01 4.9766898155212402e+00 -5.9761600494384766e+01 -9.8025001525878906e+01 5.5988397598266602e+00 -6.0836097717285156e+01 -9.8025001525878906e+01 5.2905702590942383e+00 -5.9655597686767578e+01 -9.8256904602050781e+01 3.9988203048706055e+00 -6.8815399169921875e+01 -9.8024894714355469e+01 4.2795500755310059e+00 -6.8991302490234375e+01 -9.8024894714355469e+01 4.2794899940490723e+00 -6.8991401672363281e+01 -9.8024894714355469e+01 3.1397898197174072e+00 -7.0550598144531250e+01 -9.8024894714355469e+01 1.8132300376892090e+00 -7.1900505065917969e+01 -9.8024894714355469e+01 -1.3730000704526901e-02 -7.3256500244140625e+01 -9.8256904602050781e+01 3.9986400604248047e+00 -6.8815704345703125e+01 -9.8256904602050781e+01 2.8873100280761719e+00 -7.0336105346679688e+01 -9.8256904602050781e+01 1.5942399501800537e+00 -7.1651802062988281e+01 -9.8256904602050781e+01 -1.8904899060726166e-01 -7.2975395202636719e+01 -9.8024894714355469e+01 5.4499502182006836e+00 -6.6181503295898438e+01 -9.8256904602050781e+01 5.1282000541687012e+00 -6.6102500915527344e+01 -9.8024894714355469e+01 5.7737798690795898e+00 -6.4022598266601562e+01 -9.8256904602050781e+01 5.4431500434875488e+00 -6.4001205444335938e+01 -9.7790199279785156e+01 4.4007598876953125e+01 -6.1498999595642090e+00 -9.7783500671386719e+01 4.4041000366210938e+01 -6.4656801223754883e+00 -9.7590995788574219e+01 4.3689601898193359e+01 -6.2432999610900879e+00 -9.7571502685546875e+01 4.3702201843261719e+01 -6.4656801223754883e+00 -9.7619102478027344e+01 4.3026397705078125e+01 -5.7621102333068848e+00 -9.7640800476074219e+01 4.3301300048828125e+01 -5.7701797485351562e+00 -9.7599403381347656e+01 4.3681098937988281e+01 -6.1915001869201660e+00 -9.7793106079101562e+01 4.3989200592041016e+01 -6.0789999961853027e+00 -9.7629394531250000e+01 4.3590797424316406e+01 -5.9743003845214844e+00 -9.7638198852539062e+01 4.3515602111816406e+01 -5.8873996734619141e+00 -9.7642196655273438e+01 4.3423198699951172e+01 -5.8200097084045410e+00 -9.7806701660156250e+01 4.3838600158691406e+01 -5.7788901329040527e+00 -9.7813003540039062e+01 4.3724800109863281e+01 -5.6558899879455566e+00 -9.7818901062011719e+01 4.3589698791503906e+01 -5.5574002265930176e+00 -9.7824501037597656e+01 4.3414997100830078e+01 -5.4791097640991211e+00 -9.7831893920898438e+01 4.3028198242187500e+01 -5.4397096633911133e+00 -9.7783500671386719e+01 4.4041000366210938e+01 -2.0864601135253906e+01 -9.7571502685546875e+01 4.3702201843261719e+01 -2.0864601135253906e+01 -9.7836196899414062e+01 4.2864597320556641e+01 -5.4620900154113770e+00 -9.7614700317382812e+01 4.2912700653076172e+01 -5.7827901840209961e+00 -9.7586799621582031e+01 4.3677597045898438e+01 -2.1100999832153320e+01 -9.7789505004882812e+01 4.3993202209472656e+01 -2.1207201004028320e+01 -9.7795005798339844e+01 4.3895999908447266e+01 -2.1416500091552734e+01 -9.7594200134277344e+01 4.3614101409912109e+01 -2.1244300842285156e+01 -9.7868499755859375e+01 4.2016597747802734e+01 -5.6184897422790527e+00 -9.7641899108886719e+01 4.2065700531005859e+01 -5.9413099288940430e+00 -9.7899497985839844e+01 4.1168601989746094e+01 -5.7757000923156738e+00 -9.7667900085449219e+01 4.1218799591064453e+01 -6.1006002426147461e+00 -9.7799705505371094e+01 4.3805801391601562e+01 -2.1541299819946289e+01 -9.7806900024414062e+01 4.3620098114013672e+01 -2.1704500198364258e+01 -9.7600105285644531e+01 4.3554500579833984e+01 -2.1330200195312500e+01 -9.7602302551269531e+01 4.3427299499511719e+01 -2.1439500808715820e+01 -9.7935195922851562e+01 3.1802299499511719e+01 -7.8382902145385742e+00 -9.8024894714355469e+01 2.2382600784301758e+01 -9.6424903869628906e+00 -9.8167098999023438e+01 3.1745601654052734e+01 -7.5131998062133789e+00 -9.8256904602050781e+01 2.2319101333618164e+01 -9.3172903060913086e+00 -9.7817901611328125e+01 4.3304599761962891e+01 -2.1844598770141602e+01 -9.7820297241210938e+01 4.3226303100585938e+01 -2.1860300064086914e+01 -9.7602798461914062e+01 4.3210102081298828e+01 -2.1530399322509766e+01 -9.7601600646972656e+01 4.3156002044677734e+01 -2.1539499282836914e+01 -9.8338699340820312e+01 1.3262200355529785e+01 -1.0684500694274902e+01 -9.8213500976562500e+01 1.2736699104309082e+01 -1.1171299934387207e+01 -9.8142402648925781e+01 1.2437899589538574e+01 -1.1448100090026855e+01 -9.8011199951171875e+01 1.2266400337219238e+01 -1.1600799560546875e+01 -9.7839401245117188e+01 1.2041600227355957e+01 -1.1800999641418457e+01 -9.7862899780273438e+01 4.2125999450683594e+01 -2.2062700271606445e+01 -9.7903099060058594e+01 4.1025299072265625e+01 -2.2263599395751953e+01 -9.7637397766113281e+01 4.2055900573730469e+01 -2.1738800048828125e+01 -9.7671203613281250e+01 4.0955497741699219e+01 -2.1937000274658203e+01 -9.8338699340820312e+01 1.3261799812316895e+01 -1.0683899879455566e+01 -9.8338699340820312e+01 1.3261600494384766e+01 -1.0683300018310547e+01 -9.8338699340820312e+01 1.3261199951171875e+01 -1.0682700157165527e+01 -9.8338699340820312e+01 1.3260900497436523e+01 -1.0682100296020508e+01 -9.8197601318359375e+01 1.2377699851989746e+01 -1.1358799934387207e+01 -9.8213203430175781e+01 1.2565099716186523e+01 -1.0849099159240723e+01 -9.8338699340820312e+01 1.3260499954223633e+01 -1.0681499481201172e+01 -9.8011001586914062e+01 1.1950399398803711e+01 -1.0995299339294434e+01 -9.8142402648925781e+01 1.2172499656677246e+01 -1.0943699836730957e+01 -9.8197601318359375e+01 1.2211899757385254e+01 -1.1043899536132812e+01 -9.7963302612304688e+01 1.1924900054931641e+01 -1.1706000328063965e+01 -9.8030403137207031e+01 1.1813400268554688e+01 -1.1560899734497070e+01 -9.7897003173828125e+01 1.1628600120544434e+01 -1.1671500205993652e+01 -9.8030403137207031e+01 1.1723999977111816e+01 -1.1387700080871582e+01 -9.7963302612304688e+01 1.1670200347900391e+01 -1.1212800025939941e+01 -9.7839401245117188e+01 1.1660300254821777e+01 -1.1062700271606445e+01 -9.8226005554199219e+01 1.2317599296569824e+01 -1.1257699966430664e+01 -9.8226005554199219e+01 1.2261300086975098e+01 -1.1150699615478516e+01 -9.7936897277832031e+01 3.1539001464843750e+01 -2.3665300369262695e+01 -9.8168899536132812e+01 3.1602199554443359e+01 -2.3991899490356445e+01 -9.8024894714355469e+01 2.2119199752807617e+01 -2.5328599929809570e+01 -9.8256904602050781e+01 2.2175699234008789e+01 -2.5655099868774414e+01 -9.8024894714355469e+01 1.4085900306701660e+01 -8.6534099578857422e+00 -9.8256904602050781e+01 1.4342499732971191e+01 -8.8628902435302734e+00 -9.8256904602050781e+01 1.7237199783325195e+01 -4.4761996269226074e+00 -9.8024894714355469e+01 1.6943300247192383e+01 -4.3231902122497559e+00 -9.8256904602050781e+01 -2.2310899734497070e+01 -3.3358997344970703e+01 -9.8024894714355469e+01 -2.2367399215698242e+01 -3.3032600402832031e+01 -9.7972496032714844e+01 1.9007600784301758e+01 4.9176998138427734e+00 -9.8017898559570312e+01 1.9059900283813477e+01 4.9186000823974609e+00 -9.8024894714355469e+01 1.9003599166870117e+01 3.1429998874664307e+00 -9.8192802429199219e+01 1.9261001586914062e+01 4.9219098091125488e+00 -9.8233901977539062e+01 1.9392299652099609e+01 4.9241099357604980e+00 -9.8256904602050781e+01 1.9334199905395508e+01 3.1202998161315918e+00 -9.8336898803710938e+01 1.9720699310302734e+01 4.9295902252197266e+00 -9.8256904602050781e+01 1.8985099792480469e+01 4.9730297923088074e-01 -9.8256904602050781e+01 1.8287399291992188e+01 -2.0518999099731445e+00 -9.8256904602050781e+01 1.7237199783325195e+01 -4.4761099815368652e+00 -9.8024894714355469e+01 1.6943401336669922e+01 -4.3231902122497559e+00 -9.8024894714355469e+01 1.7974800109863281e+01 -1.9421999454498291e+00 -9.8024894714355469e+01 1.8660299301147461e+01 5.6251096725463867e-01 -9.7935401916503906e+01 -3.1787200927734375e+01 -3.4630298614501953e+01 -9.8167205810546875e+01 -3.1737300872802734e+01 -3.4956600189208984e+01 -9.7668098449707031e+01 -4.1203598022460938e+01 -3.6161800384521484e+01 -9.7899696350097656e+01 -4.1160503387451172e+01 -3.6488101959228516e+01 -9.8024894714355469e+01 1.9043899536132812e+01 5.2657899856567383e+00 -9.8256904602050781e+01 1.9375000000000000e+01 5.2772998809814453e+00 -9.8025001525878906e+01 1.8564500808715820e+01 9.2627000808715820e+00 -9.8025001525878906e+01 1.7917400360107422e+01 1.1482600212097168e+01 -9.8024894714355469e+01 1.6944000244140625e+01 1.3560700416564941e+01 -9.8256904602050781e+01 1.8888099670410156e+01 9.3336000442504883e+00 -9.8256904602050781e+01 1.8227899551391602e+01 1.1598099708557129e+01 -9.8256904602050781e+01 1.7230701446533203e+01 1.3726600646972656e+01 -9.7868194580078125e+01 -4.2022899627685547e+01 -3.6628997802734375e+01 -9.7835304260253906e+01 -4.2885501861572266e+01 -3.6769199371337891e+01 -9.7641601562500000e+01 -4.2065200805664062e+01 -3.6305000305175781e+01 -9.7613899230957031e+01 -4.2926700592041016e+01 -3.6447399139404297e+01 -9.8256904602050781e+01 1.7230701446533203e+01 1.3726699829101562e+01 -9.8024894714355469e+01 1.6943899154663086e+01 1.3560700416564941e+01 -9.8024894714355469e+01 1.5413800239562988e+01 1.5753200531005859e+01 -9.8024894714355469e+01 1.3586700439453125e+01 1.7572999954223633e+01 -9.8024894714355469e+01 1.1612500190734863e+01 1.8949300765991211e+01 -9.8256904602050781e+01 1.5667698860168457e+01 1.5965999603271484e+01 -9.8256904602050781e+01 1.3798199653625488e+01 1.7828001022338867e+01 -9.8256904602050781e+01 1.1779000282287598e+01 1.9235700607299805e+01 -9.7830696105957031e+01 -4.3057300567626953e+01 -3.6788200378417969e+01 -9.7618400573730469e+01 -4.3046096801757812e+01 -3.6465702056884766e+01 -9.8256904602050781e+01 1.1778800010681152e+01 1.9235898971557617e+01 -9.8024894714355469e+01 1.1612400054931641e+01 1.8949399948120117e+01 -9.8024894714355469e+01 9.1385803222656250e+00 2.0151498794555664e+01 -9.8024894714355469e+01 6.5621700286865234e+00 2.0986900329589844e+01 -9.8024894714355469e+01 3.9952998161315918e+00 2.1487998962402344e+01 -9.8256904602050781e+01 9.2615499496459961e+00 2.0459100723266602e+01 -9.8256904602050781e+01 6.6439499855041504e+00 2.1307998657226562e+01 -9.8256904602050781e+01 4.0411300659179688e+00 2.1816200256347656e+01 -9.7637901306152344e+01 -4.3299800872802734e+01 -3.6453601837158203e+01 -9.7591102600097656e+01 -4.3687900543212891e+01 -3.5989997863769531e+01 -9.7790298461914062e+01 -4.4005100250244141e+01 -3.6085899353027344e+01 -9.7597595214843750e+01 -4.3680900573730469e+01 -3.6031299591064453e+01 -9.7792602539062500e+01 -4.3990100860595703e+01 -3.6142700195312500e+01 -9.7627197265625000e+01 -4.3590797424316406e+01 -3.6248199462890625e+01 -9.7635704040527344e+01 -4.3515701293945312e+01 -3.6335300445556641e+01 -9.7639503479003906e+01 -4.3423500061035156e+01 -3.6402797698974609e+01 -9.7805999755859375e+01 -4.3840099334716797e+01 -3.6443401336669922e+01 -9.7812301635742188e+01 -4.3726699829101562e+01 -3.6566802978515625e+01 -9.7818000793457031e+01 -4.3591701507568359e+01 -3.6665802001953125e+01 -9.7823799133300781e+01 -4.3414398193359375e+01 -3.6745601654052734e+01 -9.7972496032714844e+01 -4.9037899971008301e+00 2.1586000442504883e+01 -9.8017898559570312e+01 -4.9107098579406738e+00 2.1637798309326172e+01 -9.8024894714355469e+01 -3.7214701175689697e+00 2.1731800079345703e+01 -9.8192695617675781e+01 -4.9371700286865234e+00 2.1837198257446289e+01 -9.8231399536132812e+01 -4.9544601440429688e+00 2.1967800140380859e+01 -9.8256904602050781e+01 -3.7444798946380615e+00 2.2062198638916016e+01 -9.8338401794433594e+01 -5.0023798942565918e+00 2.2329099655151367e+01 -9.8256904602050781e+01 -1.1439299583435059e+00 2.2159399032592773e+01 -9.8256904602050781e+01 1.4555399417877197e+00 2.2081001281738281e+01 -9.8024894714355469e+01 -1.1424999237060547e+00 2.1828100204467773e+01 -9.8024894714355469e+01 1.4339100122451782e+00 2.1750400543212891e+01 -9.7783500671386719e+01 -4.4041000366210938e+01 -3.5762599945068359e+01 -9.7571502685546875e+01 -4.3702201843261719e+01 -3.5762599945068359e+01 -9.8024894714355469e+01 -2.2123298645019531e+01 1.8753898620605469e+01 -9.8256904602050781e+01 -2.2177999496459961e+01 1.9080699920654297e+01 -9.7783500671386719e+01 -4.4041000366210938e+01 -2.1396699905395508e+01 -9.7571502685546875e+01 -4.3702201843261719e+01 -2.1396699905395508e+01 -9.7936897277832031e+01 -3.1543199539184570e+01 1.7147001266479492e+01 -9.7671203613281250e+01 -4.0959598541259766e+01 1.5475199699401855e+01 -9.8168899536132812e+01 -3.1604497909545898e+01 1.7473899841308594e+01 -9.7902999877929688e+01 -4.1027698516845703e+01 1.5802201271057129e+01 -9.7586799621582031e+01 -4.3677597045898438e+01 -2.1160400390625000e+01 -9.7789505004882812e+01 -4.3993202209472656e+01 -2.1054201126098633e+01 -9.7795204162597656e+01 -4.3892601013183594e+01 -2.0839401245117188e+01 -9.7594406127929688e+01 -4.3611797332763672e+01 -2.1013299942016602e+01 -9.7862899780273438e+01 -4.2124301910400391e+01 1.5608499526977539e+01 -9.7637496948242188e+01 -4.2056098937988281e+01 1.5284299850463867e+01 -9.7820602416992188e+01 -4.3220600128173828e+01 1.5413500785827637e+01 -9.7601898193359375e+01 -4.3152099609375000e+01 1.5092300415039062e+01 -9.7799598693847656e+01 -4.3807598114013672e+01 -2.0722400665283203e+01 -9.7806495666503906e+01 -4.3628101348876953e+01 -2.0562500000000000e+01 -9.7599800109863281e+01 -4.3555599212646484e+01 -2.0932899475097656e+01 -9.7602005004882812e+01 -4.3432701110839844e+01 -2.0825700759887695e+01 -9.7818504333496094e+01 -4.3288200378417969e+01 1.5400700569152832e+01 -9.7602798461914062e+01 -4.3198898315429688e+01 1.5085100173950195e+01 -9.7807403564453125e+01 -4.3606601715087891e+01 1.5265800476074219e+01 -9.7602600097656250e+01 -4.3418098449707031e+01 1.4997900009155273e+01 -9.7817596435546875e+01 -4.3314300537109375e+01 -2.0419300079345703e+01 -9.7820198059082031e+01 -4.3229598999023438e+01 -2.0401599884033203e+01 -9.7602600097656250e+01 -4.3216899871826172e+01 -2.0732500076293945e+01 -9.7601501464843750e+01 -4.3158199310302734e+01 -2.0722198486328125e+01 -9.7800003051757812e+01 -4.3802700042724609e+01 1.5097499847412109e+01 -9.7600700378417969e+01 -4.3552600860595703e+01 1.4885299682617188e+01 -9.7794692993164062e+01 -4.3901599884033203e+01 1.4959700584411621e+01 -9.7594100952148438e+01 -4.3617801666259766e+01 1.4790399551391602e+01 -9.7862800598144531e+01 -4.2126998901367188e+01 -2.0194999694824219e+01 -9.7903198242187500e+01 -4.1023998260498047e+01 -1.9989900588989258e+01 -9.7637397766113281e+01 -4.2055801391601562e+01 -2.0518699645996094e+01 -9.7671203613281250e+01 -4.0952999114990234e+01 -2.0316301345825195e+01 -9.7586997985839844e+01 -4.3677700042724609e+01 1.4653200149536133e+01 -9.7789604187011719e+01 -4.3993202209472656e+01 1.4759499549865723e+01 -9.7783500671386719e+01 -4.4041000366210938e+01 1.4416599273681641e+01 -9.7571502685546875e+01 -4.3702201843261719e+01 1.4416599273681641e+01 -9.7936897277832031e+01 -3.1536602020263672e+01 -1.8555299758911133e+01 -9.8168899536132812e+01 -3.1600900650024414e+01 -1.8229000091552734e+01 -9.8024894714355469e+01 -2.2116800308227539e+01 -1.6859399795532227e+01 -9.8256904602050781e+01 -2.2174398422241211e+01 -1.6533199310302734e+01 -9.7783500671386719e+01 -4.4041000366210938e+01 5.2205599844455719e-02 -9.7571502685546875e+01 -4.3702201843261719e+01 5.2205599844455719e-02 -9.7829696655273438e+01 7.2922900319099426e-02 -1.3085900306701660e+01 -9.8097396850585938e+01 5.1181502640247345e-03 -1.2874900817871094e+01 -9.8016899108886719e+01 2.5502599775791168e-02 -1.2938300132751465e+01 -9.8338600158691406e+01 -1.9278499484062195e-01 -1.2260499954223633e+01 -9.8274902343750000e+01 -8.7622098624706268e-02 -1.2586699485778809e+01 -9.8250701904296875e+01 -7.4996903538703918e-02 -1.2625900268554688e+01 -9.7790298461914062e+01 -4.4004398345947266e+01 -2.7308699488639832e-01 -9.7591102600097656e+01 -4.3687500000000000e+01 -1.7649699747562408e-01 -9.8338600158691406e+01 -1.8989200890064240e-01 -1.2259099960327148e+01 -9.8274902343750000e+01 -3.3648100215941668e-03 -1.2546700477600098e+01 -9.7829696655273438e+01 2.8060901165008545e-01 -1.2987799644470215e+01 -9.8016899108886719e+01 1.9680999219417572e-01 -1.2857199668884277e+01 -9.8097396850585938e+01 1.6078899800777435e-01 -1.2801099777221680e+01 -9.8250701904296875e+01 1.8980501219630241e-02 -1.2581299781799316e+01 -9.7618103027343750e+01 -4.3050899505615234e+01 -6.5089100599288940e-01 -9.7635795593261719e+01 -4.3266799926757812e+01 -6.4549702405929565e-01 -9.7602600097656250e+01 -4.3672698974609375e+01 -2.5049698352813721e-01 -9.7794502258300781e+01 -4.3974700927734375e+01 -3.7501099705696106e-01 -9.7630699157714844e+01 -4.3562500000000000e+01 -4.6978202462196350e-01 -9.7636703491210938e+01 -4.3489799499511719e+01 -5.4160600900650024e-01 -9.7639099121093750e+01 -4.3385402679443359e+01 -6.0660505294799805e-01 -9.7808502197265625e+01 -4.3797199249267578e+01 -6.8018603324890137e-01 -9.7813896179199219e+01 -4.3688800811767578e+01 -7.8318297863006592e-01 -9.7819801330566406e+01 -4.3537097930908203e+01 -8.7989199161529541e-01 -9.7824798583984375e+01 -4.3368000030517578e+01 -9.4360899925231934e-01 -9.7830398559570312e+01 -4.3064300537109375e+01 -9.7329199314117432e-01 -9.8024894714355469e+01 2.8202500343322754e+00 -1.0153599739074707e+01 -9.8024894714355469e+01 4.3373098373413086e+00 -7.8624000549316406e+00 -9.8256904602050781e+01 2.5599000453948975e+00 -9.9485902786254883e+00 -9.8256904602050781e+01 4.0465002059936523e+00 -7.7036104202270508e+00 -9.8256904602050781e+01 7.4846100807189941e-01 -1.1927000045776367e+01 -9.8024894714355469e+01 9.7638994455337524e-01 -1.2167399406433105e+01 -9.7834999084472656e+01 -4.2890499114990234e+01 -9.5508301258087158e-01 -9.7613700866699219e+01 -4.2930202484130859e+01 -6.3309901952743530e-01 -9.7972496032714844e+01 5.7861800193786621e+00 -1.4771898984909058e+00 -9.8024894714355469e+01 5.7383799552917480e+00 -2.5188999176025391e+00 -9.8017898559570312e+01 5.7339701652526855e+00 -1.4785900115966797e+00 -9.8256904602050781e+01 5.4073300361633301e+00 -2.5068900585174561e+00 -9.8234603881835938e+01 5.4017901420593262e+00 -1.4878000020980835e+00 -9.8192802429199219e+01 5.5328598022460938e+00 -1.4841899871826172e+00 -9.8336303710937500e+01 5.0825500488281250e+00 -1.4965000152587891e+00 -9.8024894714355469e+01 5.5498499870300293e+00 -4.3515000343322754e+00 -9.8024894714355469e+01 5.0897598266601562e+00 -6.1524901390075684e+00 -9.8024894714355469e+01 4.3373098373413086e+00 -7.8623099327087402e+00 -9.8256904602050781e+01 4.0465598106384277e+00 -7.7036104202270508e+00 -9.8256904602050781e+01 4.7763600349426270e+00 -6.0450797080993652e+00 -9.8256904602050781e+01 5.2234497070312500e+00 -4.2945799827575684e+00 -9.7868103027343750e+01 -4.2024501800537109e+01 -8.1909501552581787e-01 -9.7641601562500000e+01 -4.2065097808837891e+01 -4.9460703134536743e-01 -9.7899803161621094e+01 -4.1158401489257812e+01 -6.8200403451919556e-01 -9.7668098449707031e+01 -4.1200000762939453e+01 -3.5548999905586243e-01 -9.8025001525878906e+01 5.2843098640441895e+00 1.4951999187469482e+00 -9.8024894714355469e+01 4.8513998985290527e+00 2.5040099620819092e+00 -9.8256904602050781e+01 4.9697198867797852e+00 1.3913099765777588e+00 -9.8256904602050781e+01 4.5607700347900391e+00 2.3449001312255859e+00 -9.8256904602050781e+01 5.2213101387023926e+00 4.0679398179054260e-01 -9.8024894714355469e+01 5.5467500686645508e+00 4.6869301795959473e-01 -9.7935401916503906e+01 -3.1783498764038086e+01 1.1263999938964844e+00 -9.8024894714355469e+01 -2.2363700866699219e+01 2.6743900775909424e+00 -9.8167205810546875e+01 -3.1735401153564453e+01 7.9979699850082397e-01 -9.8256904602050781e+01 -2.2308898925781250e+01 2.3477001190185547e+00 -9.8024894714355469e+01 2.6413800716400146e+00 4.8001904487609863e+00 -9.8024894714355469e+01 3.8443799018859863e+00 3.8779001235961914e+00 -9.8024894714355469e+01 4.3998899459838867e+00 3.2195100784301758e+00 -9.8024894714355469e+01 4.8513398170471191e+00 2.5040099620819092e+00 -9.8256904602050781e+01 4.5607700347900391e+00 2.3449900150299072e+00 -9.8256904602050781e+01 4.1318497657775879e+00 3.0248100757598877e+00 -9.8256904602050781e+01 3.6079900264739990e+00 3.6458001136779785e+00 -9.8256904602050781e+01 2.4788401126861572e+00 4.5114998817443848e+00 -9.8338203430175781e+01 -4.6438598632812500e+00 4.9439902305603027e+00 -9.8231895446777344e+01 -4.6960101127624512e+00 5.2972102165222168e+00 -9.8192802429199219e+01 -4.7151999473571777e+00 5.4274101257324219e+00 -9.8017898559570312e+01 -4.7445898056030273e+00 5.6263999938964844e+00 -9.7972496032714844e+01 -4.7522201538085938e+00 5.6781096458435059e+00 -9.8256904602050781e+01 -6.5630400180816650e-01 5.4168000221252441e+00 -9.8256904602050781e+01 -6.5637296438217163e-01 5.4168000221252441e+00 -9.8024894714355469e+01 -6.2637901306152344e-01 5.7467999458312988e+00 -9.8024894714355469e+01 -6.2634199857711792e-01 5.7467999458312988e+00 -9.8024894714355469e+01 6.6413998603820801e-01 5.5460000038146973e+00 -9.8024894714355469e+01 1.9058600664138794e+00 5.1560897827148438e+00 -9.8256904602050781e+01 5.9067803621292114e-01 5.2229099273681641e+00 -9.8256904602050781e+01 1.7796700000762939e+00 4.8498101234436035e+00 -9.8256904602050781e+01 -2.0428299903869629e+00 5.4795098304748535e+00 -9.8025001525878906e+01 -2.0419900417327881e+00 5.8108201026916504e+00 -9.8025001525878906e+01 -3.4465200901031494e+00 5.7617902755737305e+00 -9.8256904602050781e+01 -3.4233298301696777e+00 5.4313201904296875e+00 2.0537200927734375e+02 1.6597398757934570e+01 1.8544299316406250e+02 2.0654000854492188e+02 1.1156699180603027e+01 1.8550399780273438e+02 1.6733700561523438e+02 9.4067401885986328e+00 1.8344999694824219e+02 1.5790399169921875e+02 -6.4062599182128906e+01 1.8295500183105469e+02 1.5312400817871094e+02 -6.5113899230957031e+01 1.8270500183105469e+02 1.6004901123046875e+02 -4.7620597839355469e+01 1.8306800842285156e+02 1.6730900573730469e+02 -9.8581905364990234e+00 1.8344799804687500e+02 2.0629798889160156e+02 -1.2491000175476074e+01 1.8549198913574219e+02 2.0502301025390625e+02 -1.7891300201416016e+01 1.8542500305175781e+02 2.0711999511718750e+02 -6.9630098342895508e+00 1.8553500366210938e+02 2.0747299194335938e+02 -1.3971300125122070e+00 1.8555299377441406e+02 2.0724800109863281e+02 5.6202397346496582e+00 1.8554100036621094e+02 2.0748699951171875e+02 0.0000000000000000e+00 1.8555400085449219e+02 1.6495100402832031e+02 2.8523498535156250e+01 1.8332499694824219e+02 1.9628199768066406e+02 3.6843799591064453e+01 1.8496699523925781e+02 1.9918400573730469e+02 3.2093498229980469e+01 1.8511900329589844e+02 2.0168299865722656e+02 2.7101200103759766e+01 1.8525000000000000e+02 2.0376699829101562e+02 2.1875101089477539e+01 1.8535900878906250e+02 1.6018800354003906e+02 4.7190700531005859e+01 1.8307499694824219e+02 1.8100999450683594e+02 5.2945800781250000e+01 1.8416600036621094e+02 1.8532000732421875e+02 4.9421298980712891e+01 1.8439199829101562e+02 1.8932899475097656e+02 4.5535900115966797e+01 1.8460200500488281e+02 1.9302499389648438e+02 4.1290500640869141e+01 1.8479600524902344e+02 1.6486700439453125e+02 -2.8967700958251953e+01 1.8332000732421875e+02 1.8216999816894531e+02 -5.2055999755859375e+01 1.8422700500488281e+02 1.7764900207519531e+02 -5.5306697845458984e+01 1.8399000549316406e+02 1.7287300109863281e+02 -5.8164100646972656e+01 1.8374000549316406e+02 1.9549299621582031e+02 -3.7994400024414062e+01 1.8492500305175781e+02 1.9210900878906250e+02 -4.2412200927734375e+01 1.8474800109863281e+02 1.5312400817871094e+02 6.5113899230957031e+01 1.8270500183105469e+02 1.5593899536132812e+02 6.4539794921875000e+01 1.8285200500488281e+02 1.6126998901367188e+02 6.3094600677490234e+01 1.8313198852539062e+02 1.6650601196289062e+02 6.1192501068115234e+01 1.8340599060058594e+02 1.6785299682617188e+02 -6.0620399475097656e+01 1.8347700500488281e+02 1.6259098815917969e+02 -6.2661499023437500e+01 1.8320100402832031e+02 2.0329399108886719e+02 -2.3181699752807617e+01 1.8533399963378906e+02 2.0112001037597656e+02 -2.8321599960327148e+01 1.8522000122070312e+02 1.9849899291992188e+02 -3.3298500061035156e+01 1.8508300781250000e+02 1.8835499572753906e+02 -4.6541698455810547e+01 1.8455099487304688e+02 1.8423199462890625e+02 -5.0369098663330078e+01 1.8433499145507812e+02 1.7157499694824219e+02 5.8850097656250000e+01 1.8367199707031250e+02 1.7646899414062500e+02 5.6064300537109375e+01 1.8392799377441406e+02 1.8175000000000000e+02 6.7540199279785156e+01 2.0746899414062500e+02 1.8127999877929688e+02 6.7804199218750000e+01 2.0744900512695312e+02 1.8139599609375000e+02 6.8001701354980469e+01 2.1582600402832031e+02 1.4375300598144531e+02 7.9248001098632812e+01 2.0559400939941406e+02 1.4276799011230469e+02 7.9273597717285156e+01 2.0516799926757812e+02 1.4278100585937500e+02 7.9645500183105469e+01 2.1582600402832031e+02 1.4454400634765625e+02 7.9213905334472656e+01 2.0580300903320312e+02 1.6924501037597656e+02 7.4022499084472656e+01 2.1582600402832031e+02 1.6916499328613281e+02 7.3828506469726562e+01 2.0692900085449219e+02 1.6207400512695312e+02 7.6576095581054688e+01 2.1582600402832031e+02 1.6321299743652344e+02 7.5904396057128906e+01 2.0667399597167969e+02 1.5623599243164062e+02 7.7876701354980469e+01 2.1582600402832031e+02 1.5707699584960938e+02 7.7506103515625000e+01 2.0641000366210938e+02 1.5619400024414062e+02 7.7662803649902344e+01 2.0637199401855469e+02 1.5252200317382812e+02 7.8704200744628906e+01 2.1582600402832031e+02 1.5084600830078125e+02 7.8611206054687500e+01 2.0614300537109375e+02 1.4546200561523438e+02 7.9159599304199219e+01 2.0591099548339844e+02 1.8004000854492188e+02 6.8905502319335938e+01 2.1582600402832031e+02 1.7623800659179688e+02 7.0641197204589844e+01 2.0723300170898438e+02 1.7129299926757812e+02 7.3293403625488281e+01 2.1582600402832031e+02 1.7048699951171875e+02 7.3297996520996094e+01 2.0698599243164062e+02 1.6923999023437500e+02 7.3802001953125000e+01 2.0693199157714844e+02 1.8701200866699219e+02 6.3998497009277344e+01 2.0769500732421875e+02 1.8818299865722656e+02 6.3478702545166016e+01 2.1582600402832031e+02 1.9201300048828125e+02 6.0015102386474609e+01 2.0791000366210938e+02 1.9230400085449219e+02 5.9931800842285156e+01 2.1582600402832031e+02 1.9221800231933594e+02 5.9834899902343750e+01 2.0791900634765625e+02 2.0935800170898438e+02 3.8978199005126953e+01 2.1582600402832031e+02 2.0925498962402344e+02 3.8917198181152344e+01 2.0864999389648438e+02 2.0893399047851562e+02 3.9488700866699219e+01 2.0863600158691406e+02 2.0781900024414062e+02 4.1853302001953125e+01 2.1582600402832031e+02 2.0553199768066406e+02 4.4899700164794922e+01 2.0849000549316406e+02 2.0217800903320312e+02 4.9849800109863281e+01 2.1582600402832031e+02 2.0173699951171875e+02 4.9980098724365234e+01 2.0832798767089844e+02 2.0181300354003906e+02 5.0251899719238281e+01 2.1582600402832031e+02 2.0162800598144531e+02 5.0103599548339844e+01 2.0832299804687500e+02 1.9560000610351562e+02 5.7094699859619141e+01 2.1582600402832031e+02 1.9756199645996094e+02 5.4727497100830078e+01 2.0814801025390625e+02 1.9301399230957031e+02 5.9134799957275391e+01 2.0795300292968750e+02 2.1498399353027344e+02 2.6631799697875977e+01 2.1582600402832031e+02 2.1479399108886719e+02 2.6803899765014648e+01 2.0888800048828125e+02 2.1243800354003906e+02 3.3225601196289062e+01 2.1582600402832031e+02 2.1242399597167969e+02 3.2662700653076172e+01 2.0878599548339844e+02 2.0958900451660156e+02 3.8323497772216797e+01 2.0866499328613281e+02 2.1954399108886719e+02 0.0000000000000000e+00 2.1582600402832031e+02 2.1945700073242188e+02 5.9985297918319702e-01 2.0908700561523438e+02 2.1954399108886719e+02 4.8929400444030762e+00 2.1582600402832031e+02 2.1915699768066406e+02 6.9119300842285156e+00 2.0907499694824219e+02 2.1847698974609375e+02 1.3526899337768555e+01 2.1582600402832031e+02 2.1835499572753906e+02 1.3190299987792969e+01 2.0904000854492188e+02 2.1830099487304688e+02 1.3493599891662598e+01 2.0903800964355469e+02 2.1834400939941406e+02 1.4605100631713867e+01 2.1582600402832031e+02 2.1811700439453125e+02 1.4526700019836426e+01 2.0902999877929688e+02 2.1596400451660156e+02 2.4097099304199219e+01 2.1582600402832031e+02 2.1669499206542969e+02 2.0756500244140625e+01 2.0896899414062500e+02 2.1486100769042969e+02 2.6591600418090820e+01 2.0889100646972656e+02 2.1847698974609375e+02 -1.3526899337768555e+01 2.1582600402832031e+02 2.1853298950195312e+02 -1.2083900451660156e+01 2.0904800415039062e+02 2.1954399108886719e+02 -4.8929400444030762e+00 2.1582600402832031e+02 2.1925100708007812e+02 -5.7354602813720703e+00 2.0907899475097656e+02 2.1943699645996094e+02 7.0162699557840824e-04 2.0908700561523438e+02 2.1498399353027344e+02 -2.6631799697875977e+01 2.1582600402832031e+02 2.1518400573730469e+02 -2.5692199707031250e+01 2.0890499877929688e+02 2.1596400451660156e+02 -2.4097099304199219e+01 2.1582600402832031e+02 2.1698999023437500e+02 -1.9636598587036133e+01 2.0898200988769531e+02 2.1834400939941406e+02 -1.4605100631713867e+01 2.1582600402832031e+02 2.1830099487304688e+02 -1.3493499755859375e+01 2.0903800964355469e+02 2.1831098937988281e+02 -1.3444999694824219e+01 2.0903800964355469e+02 2.0924499511718750e+02 -3.8910999298095703e+01 2.0864999389648438e+02 2.0944500732421875e+02 -3.8583099365234375e+01 2.0865798950195312e+02 2.0935800170898438e+02 -3.8978199005126953e+01 2.1582600402832031e+02 2.1011399841308594e+02 -3.7356101989746094e+01 2.0868701171875000e+02 2.1243800354003906e+02 -3.3225601196289062e+01 2.1582600402832031e+02 2.1289299011230469e+02 -3.1602800369262695e+01 2.0880599975585938e+02 2.1483898925781250e+02 -2.6582500457763672e+01 2.0888999938964844e+02 2.0614799499511719e+02 -4.3987998962402344e+01 2.0851600646972656e+02 2.0781900024414062e+02 -4.1853302001953125e+01 2.1582600402832031e+02 2.0243699645996094e+02 -4.9104499816894531e+01 2.0835800170898438e+02 2.0217800903320312e+02 -4.9849800109863281e+01 2.1582600402832031e+02 2.0160198974609375e+02 -5.0081199645996094e+01 2.0832200622558594e+02 2.0181300354003906e+02 -5.0251899719238281e+01 2.1582600402832031e+02 1.9831700134277344e+02 -5.3923599243164062e+01 2.0817999267578125e+02 1.9560000610351562e+02 -5.7094699859619141e+01 2.1582600402832031e+02 1.9378900146484375e+02 -5.8432399749755859e+01 2.0798599243164062e+02 1.9230400085449219e+02 -5.9931800842285156e+01 2.1582600402832031e+02 1.9274699401855469e+02 -5.9372699737548828e+01 2.0794200134277344e+02 1.8139599609375000e+02 -6.8001701354980469e+01 2.1582600402832031e+02 1.8264601135253906e+02 -6.6979598999023438e+01 2.0750799560546875e+02 1.8818299865722656e+02 -6.3478702545166016e+01 2.1582600402832031e+02 1.8784399414062500e+02 -6.3380897521972656e+01 2.0773098754882812e+02 1.9220300292968750e+02 -5.9817001342773438e+01 2.0791799926757812e+02 1.6924501037597656e+02 -7.4022499084472656e+01 2.1582600402832031e+02 1.7010800170898438e+02 -7.3454002380371094e+01 2.0696899414062500e+02 1.7129299926757812e+02 -7.3293403625488281e+01 2.1582600402832031e+02 1.7139199829101562e+02 -7.2916404724121094e+01 2.0702398681640625e+02 1.8004000854492188e+02 -6.8905502319335938e+01 2.1582600402832031e+02 1.7715998840332031e+02 -7.0162200927734375e+01 2.0727301025390625e+02 1.8126599121093750e+02 -6.7780097961425781e+01 2.0744900512695312e+02 1.5623599243164062e+02 -7.7876701354980469e+01 2.1582600402832031e+02 1.5805200195312500e+02 -7.7286399841308594e+01 2.0645199584960938e+02 1.6207400512695312e+02 -7.6576095581054688e+01 2.1582600402832031e+02 1.6415100097656250e+02 -7.5612503051757812e+01 2.0671400451660156e+02 1.6915400695800781e+02 -7.3799499511718750e+01 2.0692900085449219e+02 1.4278100585937500e+02 -7.9645500183105469e+01 2.1582600402832031e+02 1.4276799011230469e+02 -7.9273597717285156e+01 2.0516799926757812e+02 1.4359599304199219e+02 -7.9253303527832031e+01 2.0553900146484375e+02 1.4445300292968750e+02 -7.9218399047851562e+01 2.0578399658203125e+02 1.4546200561523438e+02 -7.9159599304199219e+01 2.0591099548339844e+02 1.5252200317382812e+02 -7.8704200744628906e+01 2.1582600402832031e+02 1.5182000732421875e+02 -7.8472099304199219e+01 2.0618400573730469e+02 1.5618998718261719e+02 -7.7640800476074219e+01 2.0637199401855469e+02 1.4278300476074219e+02 -7.9706398010253906e+01 2.2556999206542969e+02 1.4278300476074219e+02 -7.9706398010253906e+01 2.1931500244140625e+02 1.5627899169921875e+02 -7.8075897216796875e+01 2.2556999206542969e+02 1.5253099060058594e+02 -7.8764297485351562e+01 2.1931500244140625e+02 1.6926699829101562e+02 -7.4079093933105469e+01 2.1931500244140625e+02 1.6930200195312500e+02 -7.4177101135253906e+01 2.2556999206542969e+02 1.6208999633789062e+02 -7.6634597778320312e+01 2.1931500244140625e+02 1.5624800109863281e+02 -7.7936203002929688e+01 2.1931500244140625e+02 1.7131599426269531e+02 -7.3349403381347656e+01 2.1931500244140625e+02 1.8006999206542969e+02 -6.8958198547363281e+01 2.1931500244140625e+02 1.8147399902343750e+02 -6.8123199462890625e+01 2.2556999206542969e+02 1.8142799377441406e+02 -6.8053703308105469e+01 2.1931500244140625e+02 1.9244099426269531e+02 -6.0090198516845703e+01 2.2556999206542969e+02 1.8822000122070312e+02 -6.3527194976806641e+01 2.1931500244140625e+02 2.0186000061035156e+02 -5.0290302276611328e+01 2.1931500244140625e+02 2.0188400268554688e+02 -5.0311496734619141e+01 2.2556999206542969e+02 1.9564199829101562e+02 -5.7138301849365234e+01 2.1931500244140625e+02 1.9234399414062500e+02 -5.9977699279785156e+01 2.1931500244140625e+02 2.0222599792480469e+02 -4.9888000488281250e+01 2.1931500244140625e+02 2.0787100219726562e+02 -4.1885200500488281e+01 2.1931500244140625e+02 2.0952899169921875e+02 -3.9071102142333984e+01 2.2556999206542969e+02 2.1504199218750000e+02 -2.6652099609375000e+01 2.1931500244140625e+02 2.1515499877929688e+02 -2.6695600509643555e+01 2.2556999206542969e+02 2.1249299621582031e+02 -3.3250999450683594e+01 2.1931500244140625e+02 2.0941099548339844e+02 -3.9007999420166016e+01 2.1931500244140625e+02 2.1602200317382812e+02 -2.4115499496459961e+01 2.1931500244140625e+02 2.1840399169921875e+02 -1.4616300582885742e+01 2.1931500244140625e+02 2.1859599304199219e+02 -1.3544600486755371e+01 2.2556999206542969e+02 2.1853700256347656e+02 -1.3537300109863281e+01 2.1931500244140625e+02 2.1975498962402344e+02 0.0000000000000000e+00 2.2556999206542969e+02 2.1960499572753906e+02 -4.8966999053955078e+00 2.1931500244140625e+02 2.1853700256347656e+02 1.3537300109863281e+01 2.1931500244140625e+02 2.1859599304199219e+02 1.3544600486755371e+01 2.2556999206542969e+02 2.1960499572753906e+02 4.8966999053955078e+00 2.1931500244140625e+02 2.1960499572753906e+02 0.0000000000000000e+00 2.1931500244140625e+02 2.1840399169921875e+02 1.4616300582885742e+01 2.1931500244140625e+02 2.1602200317382812e+02 2.4115499496459961e+01 2.1931500244140625e+02 2.1515499877929688e+02 2.6695600509643555e+01 2.2556999206542969e+02 2.1504199218750000e+02 2.6652099609375000e+01 2.1931500244140625e+02 2.0952899169921875e+02 3.9071102142333984e+01 2.2556999206542969e+02 2.1249299621582031e+02 3.3250999450683594e+01 2.1931500244140625e+02 2.0941099548339844e+02 3.9007999420166016e+01 2.1931500244140625e+02 2.0787100219726562e+02 4.1885200500488281e+01 2.1931500244140625e+02 2.0222599792480469e+02 4.9888000488281250e+01 2.1931500244140625e+02 2.0188400268554688e+02 5.0311496734619141e+01 2.2556999206542969e+02 2.0186000061035156e+02 5.0290302276611328e+01 2.1931500244140625e+02 1.9244099426269531e+02 6.0090198516845703e+01 2.2556999206542969e+02 1.9564199829101562e+02 5.7138301849365234e+01 2.1931500244140625e+02 1.8142799377441406e+02 6.8053703308105469e+01 2.1931500244140625e+02 1.8147399902343750e+02 6.8123199462890625e+01 2.2556999206542969e+02 1.8822000122070312e+02 6.3527194976806641e+01 2.1931500244140625e+02 1.9234399414062500e+02 5.9977699279785156e+01 2.1931500244140625e+02 1.8006999206542969e+02 6.8958198547363281e+01 2.1931500244140625e+02 1.7131599426269531e+02 7.3349403381347656e+01 2.1931500244140625e+02 1.6930200195312500e+02 7.4177101135253906e+01 2.2556999206542969e+02 1.6926699829101562e+02 7.4079093933105469e+01 2.1931500244140625e+02 1.5627899169921875e+02 7.8075897216796875e+01 2.2556999206542969e+02 1.6208999633789062e+02 7.6634597778320312e+01 2.1931500244140625e+02 1.4278300476074219e+02 7.9706398010253906e+01 2.1931500244140625e+02 1.4278300476074219e+02 7.9706398010253906e+01 2.2556999206542969e+02 1.5253099060058594e+02 7.8764297485351562e+01 2.1931500244140625e+02 1.5624800109863281e+02 7.7936203002929688e+01 2.1931500244140625e+02 1.4239500427246094e+02 -6.2877998352050781e+01 1.1070500183105469e+02 1.4340100097656250e+02 -6.0511699676513672e+01 1.0941900634765625e+02 1.4887100219726562e+02 -6.3008800506591797e+01 1.7814700317382812e+02 1.5031700134277344e+02 -5.9356700897216797e+01 1.7822599792480469e+02 1.4012500000000000e+02 -6.8235000610351562e+01 1.1561799621582031e+02 1.4078999328613281e+02 -6.6636596679687500e+01 1.1374399566650391e+02 1.4158500671386719e+02 -6.4769401550292969e+01 1.1204899597167969e+02 1.4794099426269531e+02 -6.4992301940917969e+01 1.7827198791503906e+02 1.3924899291992188e+02 -7.0573204040527344e+01 1.1974900054931641e+02 1.3961199951171875e+02 -6.9537605285644531e+01 1.1761000061035156e+02 1.3912500000000000e+02 -7.1914100646972656e+01 1.2608499908447266e+02 1.3901600646972656e+02 -7.1675796508789062e+01 1.2365100097656250e+02 1.3905200195312500e+02 -7.1313903808593750e+01 1.2196399688720703e+02 1.4163699340820312e+02 -7.2860397338867188e+01 1.5638400268554688e+02 1.4705400085449219e+02 -6.6883598327636719e+01 1.7874200439453125e+02 1.4680999755859375e+02 -6.7406402587890625e+01 1.7894200134277344e+02 1.4607499694824219e+02 -6.8995994567871094e+01 1.7977400207519531e+02 1.4552000427246094e+02 -7.0224700927734375e+01 1.8071701049804688e+02 1.4503001403808594e+02 -7.1363296508789062e+01 1.8194801330566406e+02 1.4475000000000000e+02 -7.2065299987792969e+01 1.8299600219726562e+02 1.4460800170898438e+02 -7.2462097167968750e+01 1.8376199340820312e+02 1.4414801025390625e+02 -7.3807594299316406e+01 1.8668399047851562e+02 1.4447000122070312e+02 -5.7951202392578125e+01 1.0841799926757812e+02 1.4486599731445312e+02 -5.6981101989746094e+01 1.0815399932861328e+02 1.5557299804687500e+02 -4.6081401824951172e+01 1.7850999450683594e+02 1.4527499389648438e+02 -5.5979801177978516e+01 1.0788100433349609e+02 1.4639900207519531e+02 -5.3155700683593750e+01 1.0742800140380859e+02 1.4751400756835938e+02 -5.0258098602294922e+01 1.0732199859619141e+02 1.5030099487304688e+02 -4.2152599334716797e+01 1.0750400543212891e+02 1.5636799621582031e+02 -4.3003398895263672e+01 1.7855299377441406e+02 1.5052099609375000e+02 -4.1236999511718750e+01 1.0751800537109375e+02 1.6023600769042969e+02 -2.8031600952148438e+01 1.7876300048828125e+02 1.5441400146484375e+02 -2.4963001251220703e+01 1.0777100372314453e+02 1.6048899841308594e+02 -2.6051000595092773e+01 1.7877699279785156e+02 1.5468099975585938e+02 -2.3850000381469727e+01 1.0778799438476562e+02 1.6259999084472656e+02 -9.5396003723144531e+00 1.7889100646972656e+02 1.5627301025390625e+02 -8.3420896530151367e+00 1.0789199829101562e+02 1.6260099792480469e+02 -8.7233200073242188e+00 1.7889100646972656e+02 1.5660299682617188e+02 -5.1294598579406738e+00 1.0791400146484375e+02 1.6262699890136719e+02 8.7397098541259766e+00 1.7889199829101562e+02 1.5619599914550781e+02 8.3680706024169922e+00 1.0788700103759766e+02 1.6262699890136719e+02 9.1027603149414062e+00 1.7889199829101562e+02 1.5603601074218750e+02 1.3680999755859375e+01 1.0787699890136719e+02 1.6050900268554688e+02 2.6070301055908203e+01 1.7877799987792969e+02 1.5418699645996094e+02 2.4946701049804688e+01 1.0775599670410156e+02 1.6031800842285156e+02 2.7601699829101562e+01 1.7876699829101562e+02 1.5298800659179688e+02 3.2252098083496094e+01 1.0767800140380859e+02 1.5638198852539062e+02 4.3024200439453125e+01 1.7855400085449219e+02 1.5027500915527344e+02 4.1175102233886719e+01 1.0750199890136719e+02 1.5570799255371094e+02 4.5665397644042969e+01 1.7851799011230469e+02 1.4751400756835938e+02 5.0258098602294922e+01 1.0732199859619141e+02 1.4676100158691406e+02 5.2226902008056641e+01 1.0735499572753906e+02 1.4563600158691406e+02 5.5081699371337891e+01 1.0769799804687500e+02 1.5030599975585938e+02 5.9369998931884766e+01 1.7822499084472656e+02 1.4163699340820312e+02 7.2860397338867188e+01 1.5638400268554688e+02 1.4414801025390625e+02 7.3807594299316406e+01 1.8668399047851562e+02 1.4460800170898438e+02 7.2462097167968750e+01 1.8376199340820312e+02 1.4491101074218750e+02 7.1653205871582031e+01 1.8234400939941406e+02 1.4529199218750000e+02 7.0746696472167969e+01 1.8122700500488281e+02 1.4586499023437500e+02 6.9457000732421875e+01 1.8009201049804688e+02 1.4632701110839844e+02 6.8447402954101562e+01 1.7944499206542969e+02 1.4711999511718750e+02 6.6743301391601562e+01 1.7869400024414062e+02 1.3912500000000000e+02 7.1914100646972656e+01 1.2608499908447266e+02 1.4770899963378906e+02 6.5485900878906250e+01 1.7835900878906250e+02 1.4864599609375000e+02 6.3489101409912109e+01 1.7814500427246094e+02 1.4174099731445312e+02 6.4405296325683594e+01 1.1176399993896484e+02 1.4091600036621094e+02 6.6338798522949219e+01 1.1344300079345703e+02 1.4021499633789062e+02 6.8012794494628906e+01 1.1532600402832031e+02 1.3996299743652344e+02 6.8634803771972656e+01 1.1617299652099609e+02 1.3948999023437500e+02 6.9866600036621094e+01 1.1821699523925781e+02 1.3917399597167969e+02 7.0820899963378906e+01 1.2039200592041016e+02 1.3908099365234375e+02 7.1177696228027344e+01 1.2147699737548828e+02 1.3901600646972656e+02 7.1691902160644531e+01 1.2374900054931641e+02 1.4887100219726562e+02 6.3008800506591797e+01 1.7814700317382812e+02 1.4301399230957031e+02 6.1427196502685547e+01 1.0987100219726562e+02 1.4202400207519531e+02 6.3745098114013672e+01 1.1128199768066406e+02 1.4485899353027344e+02 5.6995101928710938e+01 1.0817400360107422e+02 1.4450601196289062e+02 5.7863399505615234e+01 1.0839000701904297e+02 1.4407099914550781e+02 5.8914100646972656e+01 1.0875099945068359e+02 1.4750000000000000e+02 -7.3029396057128906e+01 1.9103900146484375e+02 1.4839201354980469e+02 -7.0352394104003906e+01 1.8537998962402344e+02 1.5135600280761719e+02 -6.9946403503417969e+01 1.8553399658203125e+02 1.8701699829101562e+02 -5.3824501037597656e+01 1.8738398742675781e+02 1.8750500488281250e+02 -5.3370700836181641e+01 1.8741000366210938e+02 1.9169900512695312e+02 -5.9216701507568359e+01 2.0437799072265625e+02 1.5090901184082031e+02 7.7721702575683594e+01 2.0239700317382812e+02 1.5089799499511719e+02 7.0048599243164062e+01 1.8550999450683594e+02 1.4839201354980469e+02 7.0352394104003906e+01 1.8537998962402344e+02 1.4750000000000000e+02 7.3029396057128906e+01 1.9103900146484375e+02 1.4655299377441406e+02 7.5698699951171875e+01 1.9669300842285156e+02 1.4558799743652344e+02 7.8263900756835938e+01 2.0213800048828125e+02 1.5135699462890625e+02 6.9964797973632812e+01 1.8553399658203125e+02 1.5158900451660156e+02 7.7601097106933594e+01 2.0242999267578125e+02 1.5678800964355469e+02 6.8972106933593750e+01 1.8581600952148438e+02 1.5706799316406250e+02 7.6629196166992188e+01 2.0269499206542969e+02 1.5794500732421875e+02 6.8658203125000000e+01 1.8587599182128906e+02 1.5889500427246094e+02 7.6152099609375000e+01 2.0278399658203125e+02 1.6248500061035156e+02 6.7426597595214844e+01 1.8611100769042969e+02 1.6313299560546875e+02 7.5045501708984375e+01 2.0298999023437500e+02 1.6437899780273438e+02 6.6737693786621094e+01 1.8620899963378906e+02 1.6603599548339844e+02 7.4032997131347656e+01 2.0313101196289062e+02 1.6908999633789062e+02 7.2967597961425781e+01 2.0327900695800781e+02 1.6807800292968750e+02 6.5392997741699219e+01 1.8640100097656250e+02 1.7032200622558594e+02 7.2469299316406250e+01 2.0333898925781250e+02 1.7060600280761719e+02 6.4224601745605469e+01 1.8653300476074219e+02 1.7294599914550781e+02 7.1257003784179688e+01 2.0346699523925781e+02 1.7349499511718750e+02 6.2888896942138672e+01 1.8668200683593750e+02 1.7600900268554688e+02 6.9842597961425781e+01 2.0361599731445312e+02 1.7656800842285156e+02 6.1138298034667969e+01 1.8684199523925781e+02 1.7956599426269531e+02 6.7840705871582031e+01 2.0378799438476562e+02 1.7872200012207031e+02 5.9911499023437500e+01 1.8695401000976562e+02 1.8145500183105469e+02 6.6777603149414062e+01 2.0387998962402344e+02 1.8221800231933594e+02 5.7509799957275391e+01 1.8713499450683594e+02 1.8584201049804688e+02 6.3825199127197266e+01 2.0409298706054688e+02 1.8357499694824219e+02 5.6578300476074219e+01 1.8720599365234375e+02 1.8817900085449219e+02 5.2811702728271484e+01 1.8744500732421875e+02 1.9708799743652344e+02 5.4110797882080078e+01 2.0463900756835938e+02 1.9237699890136719e+02 4.8742500305175781e+01 1.8766200256347656e+02 1.9710699462890625e+02 5.4088100433349609e+01 2.0463999938964844e+02 1.9246199035644531e+02 4.8659297943115234e+01 1.8766699218750000e+02 1.8665899658203125e+02 6.3275901794433594e+01 2.0413200378417969e+02 1.9160099792480469e+02 5.9338397979736328e+01 2.0437300109863281e+02 1.8750299072265625e+02 5.3364898681640625e+01 1.8740899658203125e+02 1.9171600341796875e+02 5.9237800598144531e+01 2.0437901306152344e+02 1.9259100341796875e+02 5.8468299865722656e+01 2.0442100524902344e+02 1.9641099548339844e+02 4.4122497558593750e+01 1.8787199401855469e+02 2.0121499633789062e+02 4.9417400360107422e+01 2.0484001159667969e+02 1.9675700378417969e+02 4.3649597167968750e+01 1.8788999938964844e+02 2.0195500183105469e+02 4.8426399230957031e+01 2.0487600708007812e+02 1.9988999938964844e+02 3.9370800018310547e+01 1.8805200195312500e+02 2.0496598815917969e+02 4.4395099639892578e+01 2.0502200317382812e+02 2.0062899780273438e+02 3.8161300659179688e+01 1.8809098815917969e+02 2.0625700378417969e+02 4.2341300964355469e+01 2.0508399963378906e+02 2.0833000183105469e+02 3.9044498443603516e+01 2.0518499755859375e+02 2.0299099731445312e+02 3.4294300079345703e+01 1.8821301269531250e+02 2.0897799682617188e+02 3.7892597198486328e+01 2.0521701049804688e+02 2.0397099304199219e+02 3.2336200714111328e+01 1.8826399230957031e+02 2.0998199462890625e+02 3.5887599945068359e+01 2.0526599121093750e+02 2.0566099548339844e+02 2.8960000991821289e+01 1.8835200500488281e+02 2.1177999877929688e+02 3.2296501159667969e+01 2.0535301208496094e+02 2.0675100708007812e+02 2.6224098205566406e+01 1.8840899658203125e+02 2.1307099914550781e+02 2.9105300903320312e+01 2.0541600036621094e+02 2.0788699340820312e+02 2.3375000000000000e+01 1.8846798706054688e+02 2.1412399291992188e+02 2.6502599716186523e+01 2.0546699523925781e+02 2.0894999694824219e+02 1.9879199981689453e+01 1.8852299499511719e+02 2.1551998901367188e+02 2.2065698623657227e+01 2.0553498840332031e+02 2.0960200500488281e+02 1.7735799789428711e+01 1.8855699157714844e+02 2.1600399780273438e+02 2.0524099349975586e+01 2.0555799865722656e+02 2.1054199218750000e+02 1.3354900360107422e+01 1.8860499572753906e+02 2.1871499633789062e+02 6.9686595816165209e-04 2.0568899536132812e+02 2.1186199951171875e+02 0.0000000000000000e+00 1.8867399597167969e+02 2.1873399353027344e+02 5.9334099292755127e-01 2.0569000244140625e+02 2.1160600280761719e+02 6.0057597160339355e+00 1.8866099548339844e+02 2.1730500793457031e+02 1.4828000068664551e+01 2.0562100219726562e+02 2.1741099548339844e+02 1.4363599777221680e+01 2.0562599182128906e+02 2.1085000610351562e+02 1.1921600341796875e+01 1.8862100219726562e+02 2.1764500427246094e+02 1.3041999816894531e+01 2.0563800048828125e+02 2.1151599121093750e+02 6.7092800140380859e+00 1.8865600585937500e+02 2.1836000061035156e+02 7.4468798637390137e+00 2.0567298889160156e+02 2.1843800354003906e+02 6.8346300125122070e+00 2.0567700195312500e+02 2.1059100341796875e+02 -1.3347499847412109e+01 1.8860800170898438e+02 2.1146899414062500e+02 -7.4404501914978027e+00 1.8865400695800781e+02 2.1833099365234375e+02 -7.4439001083374023e+00 2.0567098999023438e+02 2.1151499938964844e+02 -6.7109498977661133e+00 1.8865600585937500e+02 2.1853099060058594e+02 -5.6715598106384277e+00 2.0568099975585938e+02 2.1184599304199219e+02 -1.4931499958038330e+00 1.8867300415039062e+02 2.1782200622558594e+02 -1.1947899818420410e+01 2.0564599609375000e+02 2.1760200500488281e+02 -1.3293800354003906e+01 2.0563499450683594e+02 2.1058699035644531e+02 -1.3364600181579590e+01 1.8860800170898438e+02 2.1727600097656250e+02 -1.4822199821472168e+01 2.0562001037597656e+02 2.1629600524902344e+02 -1.9416900634765625e+01 2.0557199096679688e+02 2.0922799682617188e+02 -1.9118299484252930e+01 1.8853700256347656e+02 2.1550700378417969e+02 -2.2062500000000000e+01 2.0553399658203125e+02 2.0897700500488281e+02 -1.9887001037597656e+01 1.8852398681640625e+02 2.1450999450683594e+02 -2.5403400421142578e+01 2.0548500061035156e+02 2.0738198852539062e+02 -2.4771200180053711e+01 1.8844099426269531e+02 2.1307400512695312e+02 -2.9107398986816406e+01 2.0541600036621094e+02 2.0676599121093750e+02 -2.6228700637817383e+01 1.8840899658203125e+02 2.0505900573730469e+02 -3.0263999938964844e+01 1.8832099914550781e+02 2.1224400329589844e+02 -3.1248500823974609e+01 2.0537500000000000e+02 2.0396899414062500e+02 -3.2334098815917969e+01 1.8826399230957031e+02 1.9543200683593750e+02 -4.5321201324462891e+01 1.8782099914550781e+02 1.9783399963378906e+02 -5.3315898895263672e+01 2.0467500305175781e+02 1.9234700012207031e+02 -4.8715999603271484e+01 1.8766101074218750e+02 1.9708299255371094e+02 -5.4063701629638672e+01 2.0463900756835938e+02 1.9142199707031250e+02 -4.9734298706054688e+01 1.8761299133300781e+02 2.0999899291992188e+02 -3.5896800994873047e+01 2.0526599121093750e+02 2.0949700927734375e+02 -3.6936302185058594e+01 2.0524198913574219e+02 2.0225900268554688e+02 -3.5581901550292969e+01 1.8817498779296875e+02 2.0883599853515625e+02 -3.8149200439453125e+01 2.0521000671386719e+02 2.0061500549316406e+02 -3.8151100158691406e+01 1.8808999633789062e+02 2.0627200317382812e+02 -4.2351497650146484e+01 2.0508499145507812e+02 1.9904699707031250e+02 -4.0600399017333984e+01 1.8800898742675781e+02 2.0557600402832031e+02 -4.3493598937988281e+01 2.0505101013183594e+02 1.9672900390625000e+02 -4.3627601623535156e+01 1.8788800048828125e+02 2.0198300170898438e+02 -4.8447299957275391e+01 2.0487699890136719e+02 2.0190699768066406e+02 -4.8551898956298828e+01 2.0487399291992188e+02 1.9232699584960938e+02 -5.8703399658203125e+01 2.0440800476074219e+02 1.9335700988769531e+02 -5.7773899078369141e+01 2.0445799255371094e+02 1.8481298828125000e+02 -5.5627300262451172e+01 1.8727000427246094e+02 1.8748100280761719e+02 -6.2665298461914062e+01 2.0417199707031250e+02 1.8220999145507812e+02 -5.7500000000000000e+01 1.8713499450683594e+02 1.8583000183105469e+02 -6.3808097839355469e+01 2.0409199523925781e+02 1.7998300170898438e+02 -5.9101699829101562e+01 1.8701901245117188e+02 1.8234098815917969e+02 -6.6223396301269531e+01 2.0392300415039062e+02 1.7657099914550781e+02 -6.1144599914550781e+01 1.8684199523925781e+02 1.7956199645996094e+02 -6.7835700988769531e+01 2.0378799438476562e+02 1.7488198852539062e+02 -6.2155700683593750e+01 1.8675399780273438e+02 1.7691999816894531e+02 -6.9369102478027344e+01 2.0366000366210938e+02 1.7061399841308594e+02 -6.4244705200195312e+01 1.8653300476074219e+02 1.7294900512695312e+02 -7.1264900207519531e+01 2.0346699523925781e+02 1.6951699829101562e+02 -6.4781394958496094e+01 1.8647601318359375e+02 1.5159199523925781e+02 -7.7614395141601562e+01 2.0242999267578125e+02 1.4558799743652344e+02 -7.8263900756835938e+01 2.0213800048828125e+02 1.4655299377441406e+02 -7.5698699951171875e+01 1.9669300842285156e+02 1.5187199401855469e+02 -7.7584197998046875e+01 2.0244300842285156e+02 1.5307099914550781e+02 -6.9711402893066406e+01 1.8562300109863281e+02 1.5803199768066406e+02 -7.6411796569824219e+01 2.0274198913574219e+02 1.5794799804687500e+02 -6.8663497924804688e+01 1.8587599182128906e+02 1.5889999389648438e+02 -7.6173500061035156e+01 2.0278399658203125e+02 1.5888800048828125e+02 -6.8461700439453125e+01 1.8592399597167969e+02 1.6406098937988281e+02 -7.4757003784179688e+01 2.0303500366210938e+02 1.6389498901367188e+02 -6.6963500976562500e+01 1.8618400573730469e+02 1.6603698730468750e+02 -7.4040504455566406e+01 2.0313101196289062e+02 1.6439099121093750e+02 -6.6771095275878906e+01 1.8621000671386719e+02 1.6994699096679688e+02 -7.2623497009277344e+01 2.0332099914550781e+02 1.7121699523925781e+02 -7.2091995239257812e+01 2.0338200378417969e+02 1.5834901428222656e+02 -6.5858695983886719e+01 1.8333599853515625e+02 1.5275299072265625e+02 -6.7060600280761719e+01 1.8304299926757812e+02 1.5097099304199219e+02 -6.7340904235839844e+01 1.8295100402832031e+02 1.5100199890136719e+02 -6.7307998657226562e+01 1.8294000244140625e+02 1.5201799011230469e+02 -6.6245803833007812e+01 1.8273399353027344e+02 1.5253700256347656e+02 -6.5714996337890625e+01 1.8272000122070312e+02 1.4991999816894531e+02 -6.8476600646972656e+01 1.8342599487304688e+02 1.5072900390625000e+02 -6.7598999023437500e+01 1.8303201293945312e+02 1.5296701049804688e+02 -6.8628799438476562e+01 1.8407699584960938e+02 1.4932699584960938e+02 -6.9147994995117188e+01 1.8388200378417969e+02 1.4853300476074219e+02 -7.0141098022460938e+01 1.8500000000000000e+02 1.4881600952148438e+02 -6.9764396667480469e+01 1.8448400878906250e+02 1.4932299804687500e+02 -6.9153602600097656e+01 1.8388700866699219e+02 1.4933999633789062e+02 6.9138801574707031e+01 1.8389999389648438e+02 1.4908699035644531e+02 6.9431404113769531e+01 1.8413000488281250e+02 1.4869500732421875e+02 6.9920394897460938e+01 1.8467900085449219e+02 1.5069000244140625e+02 6.7644203186035156e+01 1.8307200622558594e+02 1.5019500732421875e+02 6.8174804687500000e+01 1.8326899719238281e+02 1.5082800292968750e+02 6.8960899353027344e+01 1.8396499633789062e+02 1.4969400024414062e+02 6.8729202270507812e+01 1.8357899475097656e+02 1.5285299682617188e+02 6.5389793395996094e+01 1.8269599914550781e+02 1.5174899291992188e+02 6.6524604797363281e+01 1.8277000427246094e+02 1.5632901000976562e+02 6.6349601745605469e+01 1.8322999572753906e+02 1.5107600402832031e+02 6.7229797363281250e+01 1.8291799926757812e+02 1.5097700500488281e+02 6.7335800170898438e+01 1.8295800781250000e+02 1.5662699890136719e+02 6.7900802612304688e+01 1.8426699829101562e+02 1.6223399353027344e+02 6.6379096984863281e+01 1.8455999755859375e+02 1.6774099731445312e+02 6.4376800537109375e+01 1.8484700012207031e+02 1.7307400512695312e+02 6.1911300659179688e+01 1.8512500000000000e+02 1.7822000122070312e+02 5.8979900360107422e+01 1.8539300537109375e+02 1.8299700927734375e+02 5.5698303222656250e+01 1.8564199829101562e+02 1.8752899169921875e+02 5.1989997863769531e+01 1.8587901306152344e+02 1.9174600219726562e+02 4.7902099609375000e+01 1.8609899902343750e+02 1.9563299560546875e+02 4.3435699462890625e+01 1.8630099487304688e+02 1.9905799865722656e+02 3.8757801055908203e+01 1.8647999572753906e+02 2.0211000061035156e+02 3.3760303497314453e+01 1.8663899230957031e+02 2.0473800659179688e+02 2.8508798599243164e+01 1.8677600097656250e+02 2.0692999267578125e+02 2.3010799407958984e+01 1.8689100646972656e+02 2.0861799621582031e+02 1.7459501266479492e+01 1.8697898864746094e+02 2.0984600830078125e+02 1.1735899925231934e+01 1.8704299926757812e+02 2.1059100341796875e+02 5.9121198654174805e+00 1.8708099365234375e+02 2.1084199523925781e+02 0.0000000000000000e+00 1.8709500122070312e+02 2.1082699584960938e+02 -1.4698499441146851e+00 1.8709400939941406e+02 2.1045599365234375e+02 -7.3245201110839844e+00 1.8707499694824219e+02 2.0959199523925781e+02 -1.3139500617980957e+01 1.8702900695800781e+02 2.0825100708007812e+02 -1.8820400238037109e+01 1.8695999145507812e+02 2.0643299865722656e+02 -2.4385299682617188e+01 1.8686500549316406e+02 2.0414599609375000e+02 -2.9792598724365234e+01 1.8674501037597656e+02 2.0138999938964844e+02 -3.5027900695800781e+01 1.8660198974609375e+02 1.9822799682617188e+02 -3.9968299865722656e+01 1.8643699645996094e+02 1.9467001342773438e+02 -4.4615802764892578e+01 1.8625100708007812e+02 1.9072100830078125e+02 -4.8960399627685547e+01 1.8604501342773438e+02 1.8638500976562500e+02 -5.2987197875976562e+01 1.8581900024414062e+02 1.8421598815917969e+02 -5.4762100219726562e+01 1.8570600891113281e+02 1.7946099853515625e+02 -5.8182601928710938e+01 1.8545800781250000e+02 1.7443899536132812e+02 -6.1189498901367188e+01 1.8519599914550781e+02 1.6915798950195312e+02 -6.3774600982666016e+01 1.8492098999023438e+02 1.6362300109863281e+02 -6.5923103332519531e+01 1.8463200378417969e+02 1.6316699218750000e+02 -6.4417495727539062e+01 1.8358799743652344e+02 1.6857600402832031e+02 -6.2318500518798828e+01 1.8387100219726562e+02 1.7373600769042969e+02 -5.9792701721191406e+01 1.8414099121093750e+02 1.7864500427246094e+02 -5.6854698181152344e+01 1.8439799499511719e+02 1.8329100036621094e+02 -5.3512496948242188e+01 1.8464100646972656e+02 1.8541101074218750e+02 -5.1778202056884766e+01 1.8475199890136719e+02 1.8964900207519531e+02 -4.7843299865722656e+01 1.8497399902343750e+02 1.9350700378417969e+02 -4.3597999572753906e+01 1.8517599487304688e+02 1.9698500061035156e+02 -3.9056499481201172e+01 1.8535800170898438e+02 2.0007499694824219e+02 -3.4229099273681641e+01 1.8551998901367188e+02 2.0276800537109375e+02 -2.9113100051879883e+01 1.8566099548339844e+02 2.0500299072265625e+02 -2.3829299926757812e+01 1.8577799987792969e+02 2.0677900695800781e+02 -1.8391199111938477e+01 1.8587100219726562e+02 2.0809001159667969e+02 -1.2839900016784668e+01 1.8593899536132812e+02 2.0893499755859375e+02 -7.1574997901916504e+00 1.8598399353027344e+02 2.0929699707031250e+02 -1.4362300634384155e+00 1.8600199890136719e+02 2.0931201171875000e+02 0.0000000000000000e+00 1.8600300598144531e+02 2.0906600952148438e+02 5.7772998809814453e+00 1.8599000549316406e+02 2.0833900451660156e+02 1.1468299865722656e+01 1.8595199584960938e+02 2.0713800048828125e+02 1.7061199188232422e+01 1.8588900756835938e+02 2.0548899841308594e+02 2.2486200332641602e+01 1.8580299377441406e+02 2.0334700012207031e+02 2.7858600616455078e+01 1.8569099426269531e+02 2.0077799987792969e+02 3.2990398406982422e+01 1.8555699157714844e+02 1.9779600524902344e+02 3.7873699188232422e+01 1.8540098571777344e+02 1.9444799804687500e+02 4.2444900512695312e+01 1.8522499084472656e+02 1.9064999389648438e+02 4.6809299468994141e+01 1.8502600097656250e+02 1.8652899169921875e+02 5.0803798675537109e+01 1.8481098937988281e+02 1.8209899902343750e+02 5.4427299499511719e+01 1.8457899475097656e+02 1.7743099975585938e+02 5.7633701324462891e+01 1.8433499145507812e+02 1.7240199279785156e+02 6.0498001098632812e+01 1.8407200622558594e+02 1.6719099426269531e+02 6.2906803131103516e+01 1.8379899597167969e+02 1.6180899047851562e+02 6.4862998962402344e+01 1.8351699829101562e+02 1.5869299316406250e+02 -6.7398300170898438e+01 1.8437500000000000e+02 1.4566198730468750e+02 -7.1461097717285156e+01 1.8440901184082031e+02 1.4390901184082031e+02 -7.5030197143554688e+01 1.9069999694824219e+02 1.4397200012207031e+02 -7.4706398010253906e+01 1.8963600158691406e+02 1.4529701232910156e+02 -7.3604103088378906e+01 1.9038600158691406e+02 1.4435400390625000e+02 -7.6236999511718750e+01 1.9603698730468750e+02 1.4384399414062500e+02 -7.6554100036621094e+01 1.9579499816894531e+02 1.4381698608398438e+02 -7.6064498901367188e+01 1.9414100646972656e+02 1.4397299194335938e+02 -7.7270698547363281e+01 1.9824699401855469e+02 1.4387998962402344e+02 -7.6952499389648438e+01 1.9714599609375000e+02 1.4385800170898438e+02 -7.6816299438476562e+01 1.9668099975585938e+02 1.4454400634765625e+02 -7.8097900390625000e+01 2.0121200561523438e+02 1.4430200195312500e+02 -7.7892303466796875e+01 2.0044400024414062e+02 1.4482800292968750e+02 -7.8234397888183594e+01 2.0175999450683594e+02 1.4528700256347656e+02 -7.8297698974609375e+01 2.0213099670410156e+02 1.4504598999023438e+02 -7.8285301208496094e+01 2.0200199890136719e+02 1.4424299621582031e+02 -7.7822998046875000e+01 2.0019200134277344e+02 1.4402499389648438e+02 -7.7449005126953125e+01 1.9886300659179688e+02 1.4618499755859375e+02 -7.0963897705078125e+01 1.8472999572753906e+02 1.4691799926757812e+02 -7.0760894775390625e+01 1.8494599914550781e+02 1.4569799804687500e+02 -7.1040504455566406e+01 1.8382099914550781e+02 1.4726600646972656e+02 -6.9886901855468750e+01 1.8386900329589844e+02 1.4700399780273438e+02 -7.0375801086425781e+01 1.8451300048828125e+02 1.4898901367187500e+02 -6.7128501892089844e+01 1.8217700195312500e+02 1.4826800537109375e+02 -6.8232795715332031e+01 1.8260299682617188e+02 1.4773200988769531e+02 -6.9090904235839844e+01 1.8313600158691406e+02 1.4595500183105469e+02 -7.0440498352050781e+01 1.8299099731445312e+02 1.4640901184082031e+02 -6.9465301513671875e+01 1.8203500366210938e+02 1.4692401123046875e+02 -6.8414299011230469e+01 1.8132600402832031e+02 1.4760899353027344e+02 -6.7060798645019531e+01 1.8073699951171875e+02 1.4783700561523438e+02 -6.6617492675781250e+01 1.8060598754882812e+02 1.4866600036621094e+02 -6.5025001525878906e+01 1.8034799194335938e+02 1.4923001098632812e+02 -6.6767295837402344e+01 1.8208799743652344e+02 1.5011900329589844e+02 -6.5471702575683594e+01 1.8193798828125000e+02 1.5107099914550781e+02 -6.4135398864746094e+01 1.8203399658203125e+02 1.4953900146484375e+02 -6.3376800537109375e+01 1.8039199829101562e+02 1.5628300476074219e+02 -4.6351501464843750e+01 1.8075199890136719e+02 1.5789500427246094e+02 -4.6905998229980469e+01 1.8239399719238281e+02 1.6097499084472656e+02 -2.8196298599243164e+01 1.8100300598144531e+02 1.6335398864746094e+02 -9.5956907272338867e+00 1.8112899780273438e+02 1.6338198852539062e+02 9.1563501358032227e+00 1.8113101196289062e+02 1.6105799865722656e+02 2.7763898849487305e+01 1.8100700378417969e+02 1.5641899108886719e+02 4.5933002471923828e+01 1.8075900268554688e+02 1.4953900146484375e+02 6.3376800537109375e+01 1.8039199829101562e+02 1.6264300537109375e+02 -2.8533399581909180e+01 1.8264399719238281e+02 1.6505000305175781e+02 -9.7104301452636719e+00 1.8277099609375000e+02 1.6507800292968750e+02 9.2657804489135742e+00 1.8277200317382812e+02 1.6272700500488281e+02 2.8095899581909180e+01 1.8264801025390625e+02 1.5803300476074219e+02 4.6482498168945312e+01 1.8240100097656250e+02 1.5107099914550781e+02 6.4135398864746094e+01 1.8203399658203125e+02 1.4806399536132812e+02 6.8554397583007812e+01 1.8277799987792969e+02 1.4932798767089844e+02 6.3773601531982422e+01 1.8035400390625000e+02 1.4929499816894531e+02 6.6670593261718750e+01 1.8206800842285156e+02 1.4988499450683594e+02 6.5808105468750000e+01 1.8195300292968750e+02 1.5083900451660156e+02 6.4456497192382812e+01 1.8198899841308594e+02 1.4851400756835938e+02 6.7850700378417969e+01 1.8242700195312500e+02 1.4844900512695312e+02 6.5439002990722656e+01 1.8038499450683594e+02 1.4789801025390625e+02 6.6498901367187500e+01 1.8057600402832031e+02 1.4715899658203125e+02 6.7946205139160156e+01 1.8108700561523438e+02 1.4672900390625000e+02 6.8808303833007812e+01 1.8156201171875000e+02 1.4619700622558594e+02 6.9912399291992188e+01 1.8242800903320312e+02 1.4584599304199219e+02 7.0688499450683594e+01 1.8330400085449219e+02 1.4556799316406250e+02 7.1377906799316406e+01 1.8443299865722656e+02 1.4622099304199219e+02 7.1013999938964844e+01 1.8471199035644531e+02 1.4751400756835938e+02 6.9455902099609375e+01 1.8343600463867188e+02 1.4715400695800781e+02 7.0089103698730469e+01 1.8411099243164062e+02 1.4687300109863281e+02 7.0649993896484375e+01 1.8499099731445312e+02 1.4396398925781250e+02 7.7282699584960938e+01 1.9828399658203125e+02 1.4397000122070312e+02 7.7302001953125000e+01 1.9835099792480469e+02 1.4415399169921875e+02 7.7698402404785156e+01 1.9974400329589844e+02 1.4437100219726562e+02 7.7962501525878906e+01 2.0070199584960938e+02 1.4463999938964844e+02 7.8153900146484375e+01 2.0142999267578125e+02 1.4531298828125000e+02 7.8296699523925781e+01 2.0213800048828125e+02 1.4508900451660156e+02 7.8290596008300781e+01 2.0203498840332031e+02 1.4482800292968750e+02 7.8234397888183594e+01 2.0175999450683594e+02 1.4435400390625000e+02 7.6236999511718750e+01 1.9603698730468750e+02 1.4390901184082031e+02 7.7087501525878906e+01 1.9760900878906250e+02 1.4383900451660156e+02 7.6554199218750000e+01 1.9579400634765625e+02 1.4396299743652344e+02 7.4706893920898438e+01 1.8963400268554688e+02 1.4394999694824219e+02 7.4769699096679688e+01 1.8983999633789062e+02 1.4529701232910156e+02 7.3604103088378906e+01 1.9038600158691406e+02 1.4383799743652344e+02 7.5645500183105469e+01 1.9274101257324219e+02 1.4382099914550781e+02 7.6421295166015625e+01 1.9534100341796875e+02 1.4305700683593750e+02 4.8368400573730469e+01 9.9609100341796875e+01 1.3888600158691406e+02 4.6754299163818359e+01 9.8218101501464844e+01 1.3821199035644531e+02 4.9489597320556641e+01 9.8294097900390625e+01 1.4615899658203125e+02 4.9628398895263672e+01 1.0288300323486328e+02 1.4227400207519531e+02 5.0967601776123047e+01 9.9775703430175781e+01 1.4533700561523438e+02 5.1948303222656250e+01 1.0302200317382812e+02 1.4411099243164062e+02 5.5283599853515625e+01 1.0358099365234375e+02 1.3719599914550781e+02 5.3456600189208984e+01 9.8847000122070312e+01 1.4110299682617188e+02 5.4704597473144531e+01 1.0042700195312500e+02 1.3694700622558594e+02 5.4389499664306641e+01 9.9106300354003906e+01 1.3992401123046875e+02 5.8310901641845703e+01 1.0155200195312500e+02 1.3616299438476562e+02 5.7323299407958984e+01 9.9922004699707031e+01 1.3576200866699219e+02 5.8784297943115234e+01 1.0047899627685547e+02 1.3946899414062500e+02 5.9664699554443359e+01 1.0211299896240234e+02 1.3498899841308594e+02 6.1536598205566406e+01 1.0182800292968750e+02 1.3836300659179688e+02 6.2884799957275391e+01 1.0379800415039062e+02 1.3478100585937500e+02 6.2280097961425781e+01 1.0219200134277344e+02 1.3385101318359375e+02 6.5506301879882812e+01 1.0433799743652344e+02 1.3732499694824219e+02 6.5834594726562500e+01 1.0585800170898438e+02 1.3358299255371094e+02 6.6425796508789062e+01 1.0507099914550781e+02 1.3702799987792969e+02 6.6671806335449219e+01 1.0655300140380859e+02 1.3320700073242188e+02 6.7704696655273438e+01 1.0627799987792969e+02 1.3615599060058594e+02 6.9117202758789062e+01 1.0894300079345703e+02 1.3279199218750000e+02 6.9120201110839844e+01 1.0761400604248047e+02 1.3210800170898438e+02 7.1455795288085938e+01 1.1045800018310547e+02 1.3541099548339844e+02 7.1229896545410156e+01 1.1158599853515625e+02 1.3185699462890625e+02 7.2324798583984375e+01 1.1173400115966797e+02 1.3513999938964844e+02 7.2014999389648438e+01 1.1276399993896484e+02 1.3179600524902344e+02 7.2545204162597656e+01 1.1212799835205078e+02 1.3462400817871094e+02 7.3573402404785156e+01 1.1559400177001953e+02 1.3137400817871094e+02 7.4048103332519531e+01 1.1481200408935547e+02 1.3102899169921875e+02 7.5387496948242188e+01 1.1807900238037109e+02 1.3426600646972656e+02 7.4789894104003906e+01 1.1858200073242188e+02 1.3096099853515625e+02 7.5690002441406250e+01 1.1905899810791016e+02 1.3415299987792969e+02 7.5250297546386719e+01 1.2006900024414062e+02 1.3091600036621094e+02 7.5890396118164062e+01 1.1970800018310547e+02 1.3079699707031250e+02 7.6620101928710938e+01 1.2311299896240234e+02 1.3404800415039062e+02 7.5929595947265625e+01 1.2317299652099609e+02 1.3083200073242188e+02 7.6945404052734375e+01 1.2660800170898438e+02 1.3411599731445312e+02 7.6255203247070312e+01 1.2635900115966797e+02 1.4287998962402344e+02 5.8502300262451172e+01 1.0455200195312500e+02 1.4240699768066406e+02 5.9710597991943359e+01 1.0503800201416016e+02 1.4125999450683594e+02 6.2584697723388672e+01 1.0650000000000000e+02 1.4018798828125000e+02 6.5217704772949219e+01 1.0829000091552734e+02 1.3988200378417969e+02 6.5964996337890625e+01 1.0889499664306641e+02 1.3898800659179688e+02 6.8147804260253906e+01 1.1097499847412109e+02 1.3822799682617188e+02 7.0033500671386719e+01 1.1327700042724609e+02 1.3795399475097656e+02 7.0734100341796875e+01 1.1430500030517578e+02 1.3743699645996094e+02 7.2124397277832031e+01 1.1677400207519531e+02 1.3708500671386719e+02 7.3209297180175781e+01 1.1938300323486328e+02 1.3697799682617188e+02 7.3619499206542969e+01 1.2068099975585938e+02 1.3689199829101562e+02 7.4223999023437500e+01 1.2339399719238281e+02 1.3698899841308594e+02 7.4512397766113281e+01 1.2617799377441406e+02 1.4305700683593750e+02 -4.8368400573730469e+01 9.9609100341796875e+01 1.3888600158691406e+02 -4.6754299163818359e+01 9.8218101501464844e+01 1.4147999572753906e+02 -3.9214202880859375e+01 9.8399497985839844e+01 1.4615899658203125e+02 -4.9628398895263672e+01 1.0288300323486328e+02 1.4573701477050781e+02 -4.0566898345947266e+01 9.9794502258300781e+01 1.4890899658203125e+02 -4.1623500823974609e+01 1.0306800079345703e+02 1.5322700500488281e+02 -2.3549699783325195e+01 1.0335800170898438e+02 1.5512300109863281e+02 -5.0647902488708496e+00 1.0348600006103516e+02 1.5456399536132812e+02 1.3508600234985352e+01 1.0344800567626953e+02 1.5155799865722656e+02 3.1846500396728516e+01 1.0324600219726562e+02 1.4555599975585938e+02 -2.2187700271606445e+01 9.8684494018554688e+01 1.4994700622558594e+02 -2.2952100753784180e+01 1.0008600616455078e+02 1.4734500122070312e+02 -4.7719502449035645e+00 9.8809600830078125e+01 1.5179499816894531e+02 -4.9362802505493164e+00 1.0021299743652344e+02 1.4681700134277344e+02 1.2727599143981934e+01 9.8772697448730469e+01 1.5125000000000000e+02 1.3165899276733398e+01 1.0017600250244141e+02 1.4398098754882812e+02 3.0004100799560547e+01 9.8574302673339844e+01 1.4832000732421875e+02 3.1038299560546875e+01 9.9973098754882812e+01 1.3950100708007812e+02 7.5471199035644531e+01 1.5647700500488281e+02 1.3662300109863281e+02 7.7223098754882812e+01 1.5665798950195312e+02 1.3333000183105469e+02 7.7916801452636719e+01 1.5690701293945312e+02 1.4201199340820312e+02 7.6430404663085938e+01 1.8677499389648438e+02 1.3912800598144531e+02 7.8191200256347656e+01 1.8695600891113281e+02 1.3582701110839844e+02 7.8888298034667969e+01 1.8720599365234375e+02 1.4189801025390625e+02 -5.2187400817871094e+01 9.9933799743652344e+01 1.3411599731445312e+02 -7.6255203247070312e+01 1.2635900115966797e+02 1.3083200073242188e+02 -7.6945404052734375e+01 1.2660800170898438e+02 1.3079899597167969e+02 -7.6597099304199219e+01 1.2296599578857422e+02 1.3698899841308594e+02 -7.4512397766113281e+01 1.2617799377441406e+02 1.3404899597167969e+02 -7.5907798767089844e+01 1.2303900146484375e+02 1.3689199829101562e+02 -7.4204605102539062e+01 1.2327600097656250e+02 1.3087699890136719e+02 -7.6082801818847656e+01 1.2043900299072266e+02 1.3411499023437500e+02 -7.5427505493164062e+01 1.2073500061035156e+02 1.3097499084472656e+02 -7.5653701782226562e+01 1.1907099914550781e+02 1.3435299682617188e+02 -7.4472702026367188e+01 1.1770000457763672e+02 1.3111401367187500e+02 -7.5039299011230469e+01 1.1711399841308594e+02 1.3150100708007812e+02 -7.3587402343750000e+01 1.1389900207519531e+02 1.3475799560546875e+02 -7.3156402587890625e+01 1.1475600433349609e+02 1.3180300903320312e+02 -7.2522003173828125e+01 1.1214300537109375e+02 1.3531399536132812e+02 -7.1510299682617188e+01 1.1199200439453125e+02 1.3201800537109375e+02 -7.1766098022460938e+01 1.1089699554443359e+02 1.3266999816894531e+02 -6.9535400390625000e+01 1.0806900024414062e+02 1.3602299499511719e+02 -6.9493194580078125e+01 1.0936699676513672e+02 1.3320599365234375e+02 -6.7711395263671875e+01 1.0626999664306641e+02 1.3686401367187500e+02 -6.7132896423339844e+01 1.0696099853515625e+02 1.3343399047851562e+02 -6.6932998657226562e+01 1.0550299835205078e+02 1.3420100402832031e+02 -6.4299102783203125e+01 1.0346300506591797e+02 1.3771499633789062e+02 -6.4733100891113281e+01 1.0502299499511719e+02 1.3498899841308594e+02 -6.1538497924804688e+01 1.0181800079345703e+02 1.3876899719238281e+02 -6.1714500427246094e+01 1.0312400054931641e+02 1.3694400024414062e+02 -7.3777397155761719e+01 1.2126300048828125e+02 1.3716900634765625e+02 -7.2926498413085938e+01 1.1861299896240234e+02 1.3756999206542969e+02 -7.1752502441406250e+01 1.1604299926757812e+02 1.3812899780273438e+02 -7.0283706665039062e+01 1.1363100433349609e+02 1.3885099792480469e+02 -6.8483398437500000e+01 1.1134400177001953e+02 1.3971299743652344e+02 -6.6376701354980469e+01 1.0924900054931641e+02 1.4058999633789062e+02 -6.4234504699707031e+01 1.0756400299072266e+02 1.4168000793457031e+02 -6.1540203094482422e+01 1.0591500091552734e+02 1.4284100341796875e+02 -5.8603500366210938e+01 1.0458999633789062e+02 1.3514100646972656e+02 -6.1006401062011719e+01 1.0150099945068359e+02 1.3612901306152344e+02 -5.7445499420166016e+01 9.9965202331542969e+01 1.3988600158691406e+02 -5.8424301147460938e+01 1.0159600067138672e+02 1.3686700439453125e+02 -5.4704902648925781e+01 9.9133697509765625e+01 1.4072700500488281e+02 -5.5872699737548828e+01 1.0073500061035156e+02 1.3694599914550781e+02 -5.4399700164794922e+01 9.9077903747558594e+01 1.3788600158691406e+02 -5.0779998779296875e+01 9.8415504455566406e+01 1.4371701049804688e+02 -5.6326198577880859e+01 1.0384700012207031e+02 1.4494200134277344e+02 -5.3036998748779297e+01 1.0315699768066406e+02 1.4416999816894531e+02 7.8763702392578125e+01 2.0285198974609375e+02 1.4347900390625000e+02 7.9112403869628906e+01 2.0399600219726562e+02 1.4383099365234375e+02 7.8728302001953125e+01 2.0247698974609375e+02 1.4297898864746094e+02 7.9106597900390625e+01 2.0357699584960938e+02 1.4332400512695312e+02 7.8638206481933594e+01 2.0166499328613281e+02 1.4288400268554688e+02 7.8508499145507812e+01 2.0061500549316406e+02 1.4246299743652344e+02 7.8308403015136719e+01 1.9910598754882812e+02 1.4230300903320312e+02 7.8198402404785156e+01 1.9830799865722656e+02 1.4198799133300781e+02 7.7850997924804688e+01 1.9588500976562500e+02 1.4184899902343750e+02 7.6962905883789062e+01 1.9007598876953125e+02 1.4183900451660156e+02 7.7438194274902344e+01 1.9312899780273438e+02 1.4221200561523438e+02 7.9082199096679688e+01 2.0268798828125000e+02 1.4151799011230469e+02 7.9039299011230469e+01 2.0155400085449219e+02 1.4081298828125000e+02 7.8966300964355469e+01 1.9994000244140625e+02 1.4052600097656250e+02 7.8924301147460938e+01 1.9909100341796875e+02 1.3988600158691406e+02 7.8786796569824219e+01 1.9652499389648438e+02 1.3944500732421875e+02 7.8617599487304688e+01 1.9361999511718750e+02 1.3919400024414062e+02 7.8418205261230469e+01 1.9041400146484375e+02 1.4210200500488281e+02 7.9280693054199219e+01 2.0470799255371094e+02 1.4106300354003906e+02 7.9283401489257812e+01 2.0374600219726562e+02 1.4009899902343750e+02 7.9274696350097656e+01 2.0253401184082031e+02 1.3908200073242188e+02 7.9250404357910156e+01 2.0082099914550781e+02 1.3865299987792969e+02 7.9234100341796875e+01 1.9992500305175781e+02 1.3763700866699219e+02 7.9175193786621094e+01 1.9722399902343750e+02 1.3683299255371094e+02 7.9096801757812500e+01 1.9417900085449219e+02 1.3623100280761719e+02 7.9000602722167969e+01 1.9082299804687500e+02 1.3333000183105469e+02 -7.7916801452636719e+01 1.5690701293945312e+02 1.3662300109863281e+02 -7.7223098754882812e+01 1.5665798950195312e+02 1.3950100708007812e+02 -7.5471199035644531e+01 1.5647700500488281e+02 1.3582701110839844e+02 -7.8888298034667969e+01 1.8720599365234375e+02 1.3912800598144531e+02 -7.8191200256347656e+01 1.8695600891113281e+02 1.4201199340820312e+02 -7.6430404663085938e+01 1.8677499389648438e+02 1.4183000183105469e+02 -7.7105201721191406e+01 1.9097900390625000e+02 1.3924600219726562e+02 -7.8478302001953125e+01 1.9136199951171875e+02 1.4189599609375000e+02 -7.7662200927734375e+01 1.9461000061035156e+02 1.4214700317382812e+02 -7.8057899475097656e+01 1.9731298828125000e+02 1.4222000122070312e+02 -7.8128601074218750e+01 1.9781098937988281e+02 1.4259600830078125e+02 -7.8383102416992188e+01 1.9965901184082031e+02 1.4306799316406250e+02 -7.8570205688476562e+01 2.0110400390625000e+02 1.4318699645996094e+02 -7.8604202270507812e+01 2.0138000488281250e+02 1.4365400695800781e+02 -7.8702598571777344e+01 2.0223200988769531e+02 1.4416999816894531e+02 -7.8763702392578125e+01 2.0285198974609375e+02 1.3965199279785156e+02 -7.8709999084472656e+01 1.9517999267578125e+02 1.4022700500488281e+02 -7.8869400024414062e+01 1.9803599548339844e+02 1.4036900329589844e+02 -7.8897201538085938e+01 1.9856399536132812e+02 1.4104301452636719e+02 -7.8994201660156250e+01 2.0052999877929688e+02 1.4181298828125000e+02 -7.9060394287109375e+01 2.0208099365234375e+02 1.4200000000000000e+02 -7.9071502685546875e+01 2.0237899780273438e+02 1.4271501159667969e+02 -7.9100402832031250e+01 2.0330700683593750e+02 1.4347900390625000e+02 -7.9112403869628906e+01 2.0399600219726562e+02 1.3638299560546875e+02 -7.9029899597167969e+01 1.9181401062011719e+02 1.3722799682617188e+02 -7.9140197753906250e+01 1.9581300354003906e+02 1.3819099426269531e+02 -7.9211303710937500e+01 1.9881300354003906e+02 1.3841299438476562e+02 -7.9222999572753906e+01 1.9936900329589844e+02 1.3941900634765625e+02 -7.9260498046875000e+01 2.0144599914550781e+02 1.4051200866699219e+02 -7.9279998779296875e+01 2.0309600830078125e+02 1.4077099609375000e+02 -7.9281997680664062e+01 2.0341500854492188e+02 1.4174600219726562e+02 -7.9282905578613281e+01 2.0441400146484375e+02 6.8196403503417969e+01 -8.2310997009277344e+01 2.1931500244140625e+02 6.8196403503417969e+01 8.2310997009277344e+01 2.1931500244140625e+02 6.8196403503417969e+01 8.2250106811523438e+01 2.1582600402832031e+02 6.8196403503417969e+01 -8.2250106811523438e+01 2.1582600402832031e+02 6.8196403503417969e+01 8.2241203308105469e+01 2.1557000732421875e+02 6.8196403503417969e+01 -8.2241203308105469e+01 2.1557000732421875e+02 8.6875000000000000e+01 8.1588905334472656e+01 2.1557000732421875e+02 8.6875000000000000e+01 7.8372901916503906e+01 1.2353400421142578e+02 8.6875000000000000e+01 -7.8372901916503906e+01 1.2353400421142578e+02 8.6875000000000000e+01 -8.1588905334472656e+01 2.1557000732421875e+02 8.6875000000000000e+01 -7.7133003234863281e+01 1.1597299957275391e+02 8.6875000000000000e+01 -7.4024604797363281e+01 1.0897599792480469e+02 8.6875000000000000e+01 -6.9249694824218750e+01 1.0299699401855469e+02 8.6875000000000000e+01 -6.3118701934814453e+01 9.8425399780273438e+01 8.6875000000000000e+01 -5.6029701232910156e+01 9.5558006286621094e+01 8.6875000000000000e+01 -4.8443500518798828e+01 9.4581100463867188e+01 8.6875000000000000e+01 7.4024604797363281e+01 1.0897599792480469e+02 8.6875000000000000e+01 5.6029701232910156e+01 9.5558006286621094e+01 8.6875000000000000e+01 4.8443500518798828e+01 9.4581100463867188e+01 8.6875000000000000e+01 6.3118701934814453e+01 9.8425399780273438e+01 8.6875000000000000e+01 6.9249694824218750e+01 1.0299699401855469e+02 8.6875000000000000e+01 7.7133003234863281e+01 1.1597299957275391e+02 8.5273399353027344e+01 -1.0184300231933594e+02 2.2322399902343750e+02 9.1661804199218750e+01 -8.3492797851562500e+01 2.2300100708007812e+02 6.8196403503417969e+01 -8.4312294006347656e+01 2.2382000732421875e+02 7.8817001342773438e+01 -1.2216699981689453e+02 2.2344900512695312e+02 7.2607704162597656e+01 -1.2241799926757812e+02 2.2366600036621094e+02 6.8196403503417969e+01 -1.2259099578857422e+02 2.2382000732421875e+02 8.1208305358886719e+01 -1.2290900421142578e+02 2.2194099426269531e+02 8.0201301574707031e+01 -1.2259200286865234e+02 2.2302099609375000e+02 7.9365501403808594e+01 -1.2650099182128906e+02 2.2257499694824219e+02 7.9614997863769531e+01 -1.3630599975585938e+02 2.1650799560546875e+02 8.0133995056152344e+01 -1.3780400085449219e+02 2.1439201354980469e+02 8.0467903137207031e+01 -1.3743400573730469e+02 2.1426800537109375e+02 7.8207901000976562e+01 -1.3682000732421875e+02 2.1659399414062500e+02 7.8702400207519531e+01 -1.3839599609375000e+02 2.1433700561523438e+02 7.9659301757812500e+01 -1.3800099182128906e+02 2.1437400817871094e+02 8.0450103759765625e+01 -1.3466101074218750e+02 2.1675999450683594e+02 8.0629699707031250e+01 -1.3534300231933594e+02 2.1596499633789062e+02 8.1140899658203125e+01 -1.3668699645996094e+02 2.1401699829101562e+02 8.0209503173828125e+01 -1.3288499450683594e+02 2.1829699707031250e+02 7.9045303344726562e+01 -1.3243701171875000e+02 2.2001100158691406e+02 7.9432601928710938e+01 -1.3554899597167969e+02 2.1737001037597656e+02 7.9015800476074219e+01 -1.3136199951171875e+02 2.2067500305175781e+02 7.7671897888183594e+01 -1.3270999145507812e+02 2.2032800292968750e+02 7.8034896850585938e+01 -1.3602000427246094e+02 2.1751399230957031e+02 8.0039901733398438e+01 -1.3087300109863281e+02 2.1980699157714844e+02 8.0210205078125000e+01 -1.2788400268554688e+02 2.2114500427246094e+02 7.9218299865722656e+01 -1.2765200805664062e+02 2.2227198791503906e+02 8.0244598388671875e+01 -1.2762899780273438e+02 2.2122000122070312e+02 7.7866500854492188e+01 -1.2761400604248047e+02 2.2269700622558594e+02 7.7650199890136719e+01 -1.3150500488281250e+02 2.2105699157714844e+02 7.7646903991699219e+01 -1.3156298828125000e+02 2.2103199768066406e+02 8.0238197326660156e+01 -1.2749199676513672e+02 2.2130101013183594e+02 8.0244804382324219e+01 -1.2745200347900391e+02 2.2130999755859375e+02 8.0383895874023438e+01 -1.2644900512695312e+02 2.2157099914550781e+02 8.0068702697753906e+01 -1.3184700012207031e+02 2.1919599914550781e+02 7.8009201049804688e+01 -1.2637500762939453e+02 2.2301399230957031e+02 8.4213699340820312e+01 -1.1343800354003906e+02 2.2184098815917969e+02 8.7637794494628906e+01 -1.0264699554443359e+02 2.2172799682617188e+02 8.6640502929687500e+01 -1.0230300140380859e+02 2.2279899597167969e+02 9.0442001342773438e+01 -9.4612899780273438e+01 2.2163000488281250e+02 9.2734001159667969e+01 -8.3455398559570312e+01 2.2279100036621094e+02 9.3194702148437500e+01 -8.3439300537109375e+01 2.2253399658203125e+02 9.3652297973632812e+01 -8.3423301696777344e+01 2.2227799987792969e+02 9.4356094360351562e+01 -8.3398796081542969e+01 2.2149200439453125e+02 8.2789596557617188e+01 -1.1792600250244141e+02 2.2188900756835938e+02 1.0319699859619141e+02 -1.3439500427246094e+02 -3.3821600341796875e+02 9.6261398315429688e+01 -1.4893099975585938e+02 -3.3809500122070312e+02 9.6322296142578125e+01 -1.4896299743652344e+02 -3.3845999145507812e+02 1.1591300201416016e+02 -1.0905099487304688e+02 -3.3932901000976562e+02 1.1953800201416016e+02 -1.0145399475097656e+02 -3.3939199829101562e+02 1.1564499664306641e+02 -1.0892199707031250e+02 -3.3910800170898438e+02 1.1926999664306641e+02 -1.0132399749755859e+02 -3.3917098999023438e+02 1.1546900177001953e+02 -1.0883499908447266e+02 -3.3879400634765625e+02 1.1909400177001953e+02 -1.0123699951171875e+02 -3.3885699462890625e+02 1.1540800476074219e+02 -1.0880299377441406e+02 -3.3842999267578125e+02 1.1903300476074219e+02 -1.0120500183105469e+02 -3.3849298095703125e+02 1.0633999633789062e+02 -1.2911599731445312e+02 -3.3916198730468750e+02 1.0607199859619141e+02 -1.2898600769042969e+02 -3.3894100952148438e+02 1.0589499664306641e+02 -1.2889898681640625e+02 -3.3862701416015625e+02 1.0583499908447266e+02 -1.2886700439453125e+02 -3.3826199340820312e+02 9.6766700744628906e+01 -1.4917999267578125e+02 -3.3899499511718750e+02 9.6498802185058594e+01 -1.4905000305175781e+02 -3.3877398681640625e+02 9.5214302062988281e+01 -1.5171299743652344e+02 -3.4164398193359375e+02 9.5567398071289062e+01 -1.5163600158691406e+02 -3.4164398193359375e+02 9.5527702331542969e+01 -1.5157798767089844e+02 -3.4098300170898438e+02 9.4911903381347656e+01 -1.5191200256347656e+02 -3.4164398193359375e+02 9.5203895568847656e+01 -1.5166600036621094e+02 -3.4093600463867188e+02 9.4699798583984375e+01 -1.5220401000976562e+02 -3.4164398193359375e+02 9.4930099487304688e+01 -1.5185501098632812e+02 -3.4087301635742188e+02 9.5597404479980469e+01 -1.5132200622558594e+02 -3.4021801757812500e+02 9.5309898376464844e+01 -1.5138700866699219e+02 -3.4007901000976562e+02 9.5599800109863281e+01 -1.5131300354003906e+02 -3.4019100952148438e+02 9.5834205627441406e+01 -1.5080599975585938e+02 -3.3952600097656250e+02 9.6043304443359375e+01 -1.5042300415039062e+02 -3.3930798339843750e+02 9.5997100830078125e+01 -1.4999299621582031e+02 -3.3887799072265625e+02 9.5569496154785156e+01 -1.5083500671386719e+02 -3.3935400390625000e+02 9.6252799987792969e+01 -1.5003900146484375e+02 -3.3908999633789062e+02 9.5071098327636719e+01 -1.5154499816894531e+02 -3.3993597412109375e+02 9.5361297607421875e+01 -1.5093399047851562e+02 -3.3913699340820312e+02 9.5811500549316406e+01 -1.5000500488281250e+02 -3.3859802246093750e+02 9.4737800598144531e+01 -1.5212500000000000e+02 -3.4080300903320312e+02 9.4907600402832031e+01 -1.5176899719238281e+02 -3.3977801513671875e+02 9.5230598449707031e+01 -1.5109199523925781e+02 -3.3889599609375000e+02 9.5716903686523438e+01 -1.5007199096679688e+02 -3.3828298950195312e+02 9.7309799194335938e+01 -1.5157499694824219e+02 -3.4240100097656250e+02 9.7826896667480469e+01 -1.5124798583984375e+02 -3.4118499755859375e+02 9.8215995788574219e+01 -1.5036999511718750e+02 -3.4021899414062500e+02 9.8396598815917969e+01 -1.4912300109863281e+02 -3.3970300292968750e+02 1.0349199676513672e+02 -1.4894500732421875e+02 -3.4191702270507812e+02 1.0331100463867188e+02 -1.5019200134277344e+02 -3.4243301391601562e+02 1.0292199707031250e+02 -1.5106999206542969e+02 -3.4339898681640625e+02 1.0240499877929688e+02 -1.5139700317382812e+02 -3.4461502075195312e+02 1.0417299652099609e+02 -1.5098500061035156e+02 -3.4489398193359375e+02 1.0557399749755859e+02 -1.5011799621582031e+02 -3.4507098388671875e+02 1.0558499908447266e+02 -1.4980999755859375e+02 -3.4396200561523438e+02 1.0568299865722656e+02 -1.4997999572753906e+02 -3.4507901000976562e+02 1.0661199951171875e+02 -1.4880700683593750e+02 -3.4514901733398438e+02 1.0644999694824219e+02 -1.4867399597167969e+02 -3.4405499267578125e+02 1.0676200103759766e+02 -1.4851300048828125e+02 -3.4515100097656250e+02 1.0657600402832031e+02 -1.4842300415039062e+02 -3.4405801391601562e+02 1.0594799804687500e+02 -1.4836000061035156e+02 -3.4311300659179688e+02 1.0604300689697266e+02 -1.4817098999023438e+02 -3.4311599731445312e+02 1.0517500305175781e+02 -1.4790899658203125e+02 -3.4244998168945312e+02 1.0523399353027344e+02 -1.4779100036621094e+02 -3.4245300292968750e+02 1.0530000305175781e+02 -1.4922000122070312e+02 -3.4301599121093750e+02 1.0475900268554688e+02 -1.4843299865722656e+02 -3.4237301635742188e+02 1.0406999969482422e+02 -1.5104899597167969e+02 -3.4488101196289062e+02 1.0433499908447266e+02 -1.5066799926757812e+02 -3.4373001098632812e+02 1.0436599731445312e+02 -1.4987500000000000e+02 -3.4277600097656250e+02 1.0415799713134766e+02 -1.4880599975585938e+02 -3.4218298339843750e+02 1.1615700531005859e+02 -1.2836499023437500e+02 -3.4522302246093750e+02 1.2700299835205078e+02 -1.0510499572753906e+02 -3.4530499267578125e+02 1.1597200012207031e+02 -1.2827398681640625e+02 -3.4413000488281250e+02 1.2681800079345703e+02 -1.0501399993896484e+02 -3.4421301269531250e+02 1.1543799591064453e+02 -1.2802200317382812e+02 -3.4318701171875000e+02 1.2628500366210938e+02 -1.0476200103759766e+02 -3.4326998901367188e+02 1.1462999725341797e+02 -1.2764300537109375e+02 -3.4252398681640625e+02 1.2547600555419922e+02 -1.0438299560546875e+02 -3.4260699462890625e+02 1.2550400543212891e+02 -1.0432199859619141e+02 -3.4260699462890625e+02 1.2631400299072266e+02 -1.0469999694824219e+02 -3.4326998901367188e+02 1.2684799957275391e+02 -1.0495100402832031e+02 -3.4421301269531250e+02 1.2703299713134766e+02 -1.0504000091552734e+02 -3.4530599975585938e+02 1.0436299896240234e+02 -1.4836799621582031e+02 -3.4218499755859375e+02 1.1954000091552734e+02 -1.0145000457763672e+02 -3.3939199829101562e+02 1.2995800781250000e+02 -9.4695999145507812e+01 -3.4544699096679688e+02 1.2975599670410156e+02 -9.4644500732421875e+01 -3.4435400390625000e+02 1.2975599670410156e+02 -9.4644599914550781e+01 -3.4435400390625000e+02 1.2667299652099609e+02 -1.0144699859619141e+02 -3.4262600708007812e+02 1.2917199707031250e+02 -9.4552101135253906e+01 -3.4341201782226562e+02 1.2828700256347656e+02 -9.4431304931640625e+01 -3.4274899291992188e+02 1.2755900573730469e+02 -9.8472602844238281e+01 -3.4266598510742188e+02 1.2842401123046875e+02 -9.8698493957519531e+01 -3.4332901000976562e+02 1.2751300811767578e+02 -1.0175000000000000e+02 -3.4328900146484375e+02 1.2899301147460938e+02 -9.8855895996093750e+01 -3.4427197265625000e+02 1.2806600952148438e+02 -1.0195399475097656e+02 -3.4423199462890625e+02 1.2995800781250000e+02 -9.4696098327636719e+01 -3.4544699096679688e+02 1.2918800354003906e+02 -9.8923301696777344e+01 -3.4536401367187500e+02 1.2825700378417969e+02 -1.0203299713134766e+02 -3.4532498168945312e+02 1.1903599548339844e+02 -1.0119800567626953e+02 -3.3849298095703125e+02 1.1909600067138672e+02 -1.0123200225830078e+02 -3.3885699462890625e+02 1.1927200317382812e+02 -1.0131900024414062e+02 -3.3917098999023438e+02 1.2104599761962891e+02 -9.3980995178222656e+01 4.3443798065185547e+01 1.2107399749755859e+02 -9.3993400573730469e+01 6.2836601257324219e+01 1.1917000579833984e+02 -1.0124199676513672e+02 6.2837497711181641e+01 1.1785600280761719e+02 -8.0910400390625000e+01 1.6750300598144531e+02 1.1783499908447266e+02 -8.0836303710937500e+01 1.6766700744628906e+02 1.1604100036621094e+02 -8.6701896667480469e+01 1.7002500915527344e+02 1.1688999938964844e+02 -8.1042900085449219e+01 1.7263500976562500e+02 1.1445800018310547e+02 -8.1412895202636719e+01 1.8079299926757812e+02 1.1904600524902344e+02 -1.0120899963378906e+02 -2.2987799072265625e+02 1.2095099639892578e+02 -9.3939102172851562e+01 -2.2987699890136719e+02 1.1929199981689453e+02 -1.0063999938964844e+02 -3.3850000000000000e+02 1.2033799743652344e+02 -9.7625503540039062e+01 -3.3852700805664062e+02 1.2072599792480469e+02 -9.5784500122070312e+01 -3.3853701782226562e+02 1.2093699645996094e+02 -9.3933403015136719e+01 -3.3854299926757812e+02 1.1918400573730469e+02 -8.6010002136230469e+01 1.5510900878906250e+02 1.1677400207519531e+02 -8.9677299499511719e+01 1.6313299560546875e+02 1.1926300048828125e+02 -8.6311302185058594e+01 1.5437699890136719e+02 1.1746600341796875e+02 -9.2489196777343750e+01 1.5661900329589844e+02 1.1767300415039062e+02 -9.3501205444335938e+01 1.5387899780273438e+02 1.1981300354003906e+02 -8.8702003479003906e+01 1.4745800781250000e+02 1.1800499725341797e+02 -9.5124496459960938e+01 1.4948300170898438e+02 1.1827799987792969e+02 -9.6694099426269531e+01 1.4424000549316406e+02 1.2027500152587891e+02 -9.0905700683593750e+01 1.3947200012207031e+02 1.1858000183105469e+02 -9.8430595397949219e+01 1.3843899536132812e+02 1.2042400360107422e+02 -9.1614997863769531e+01 1.3690100097656250e+02 1.1869799804687500e+02 -9.9213600158691406e+01 1.3445399475097656e+02 1.2076999664306641e+02 -9.3341400146484375e+01 1.2718400573730469e+02 1.1888700103759766e+02 -1.0047399902343750e+02 1.2803900146484375e+02 1.2084200286865234e+02 -9.3622398376464844e+01 1.2364900207519531e+02 1.1894300079345703e+02 -1.0079100036621094e+02 1.2450000000000000e+02 1.2090999603271484e+02 -9.3892204284667969e+01 1.2025599670410156e+02 1.1900799560546875e+02 -1.0115200042724609e+02 1.2047200012207031e+02 1.1902899932861328e+02 -1.0120099639892578e+02 1.1856299591064453e+02 1.2093300628662109e+02 -9.3930603027343750e+01 1.1852300262451172e+02 1.1903399658203125e+02 -1.0120500183105469e+02 1.1808399963378906e+02 1.2093800354003906e+02 -9.3933700561523438e+01 1.1808999633789062e+02 1.1903499603271484e+02 -1.0120599365234375e+02 1.1797399902343750e+02 1.2093900299072266e+02 -9.3934097290039062e+01 1.1798200225830078e+02 1.1903499603271484e+02 -1.0120599365234375e+02 1.1795199584960938e+02 1.2094000244140625e+02 -9.3934204101562500e+01 1.1795500183105469e+02 1.1903599548339844e+02 -1.0120599365234375e+02 1.1789800262451172e+02 1.2094000244140625e+02 -9.3934402465820312e+01 1.1790100097656250e+02 1.1904000091552734e+02 -1.0120700073242188e+02 1.1747000122070312e+02 1.2094400024414062e+02 -9.3936302185058594e+01 1.1747200012207031e+02 1.1904799652099609e+02 -1.0120899963378906e+02 1.1663999938964844e+02 1.2095200347900391e+02 -9.3939804077148438e+01 1.1664199829101562e+02 1.1906299591064453e+02 -1.0121299743652344e+02 1.1497999572753906e+02 1.2096800231933594e+02 -9.3946395874023438e+01 1.1498300170898438e+02 1.2101799774169922e+02 -9.3968299865722656e+01 1.0762500000000000e+02 1.1912400054931641e+02 -1.0123000335693359e+02 1.0594700622558594e+02 1.2105799865722656e+02 -9.3985801696777344e+01 1.0171399688720703e+02 1.1915299987792969e+02 -1.0123699951171875e+02 1.0171300506591797e+02 1.1916600036621094e+02 -1.0124099731445312e+02 7.0684501647949219e+01 1.2088899993896484e+02 -9.3912200927734375e+01 -6.4106704711914062e+01 1.1898500061035156e+02 -1.0119200134277344e+02 -6.4107002258300781e+01 1.1898699951171875e+02 -1.0119300079345703e+02 -6.9104301452636719e+01 1.2089700317382812e+02 -9.3915596008300781e+01 -8.4918403625488281e+01 1.2167500305175781e+02 -7.9242599487304688e+01 1.2589299774169922e+02 1.2174600219726562e+02 -7.8945396423339844e+01 1.2365399932861328e+02 6.8196403503417969e+01 -8.0979400634765625e+01 1.2215299987792969e+02 1.2186799621582031e+02 -7.8436500549316406e+01 1.1981999969482422e+02 6.8196403503417969e+01 -7.8237495422363281e+01 1.1024900054931641e+02 1.2200000000000000e+02 -7.7063499450683594e+01 1.1538800048828125e+02 1.2205000305175781e+02 -7.6392204284667969e+01 1.1406400299072266e+02 1.2238000488281250e+02 -7.1525604248046875e+01 1.0619899749755859e+02 6.8196403503417969e+01 -7.1248001098632812e+01 1.0024700164794922e+02 1.2231300354003906e+02 -7.2584098815917969e+01 1.0762500000000000e+02 1.2220399475097656e+02 -7.4298095703125000e+01 1.0993400573730469e+02 1.2250199890136719e+02 -6.9382698059082031e+01 1.0414999389648438e+02 1.2263099670410156e+02 -6.7105400085449219e+01 1.0197299957275391e+02 6.8196403503417969e+01 -6.1025600433349609e+01 9.3598800659179688e+01 1.2282700347900391e+02 -6.3282199859619141e+01 9.9389701843261719e+01 1.2301699829101562e+02 -5.9197196960449219e+01 9.7537200927734375e+01 1.2308599853515625e+02 -5.7705303192138672e+01 9.6860702514648438e+01 6.8196403503417969e+01 -4.9054599761962891e+01 9.1270095825195312e+01 1.2327100372314453e+02 -5.3240501403808594e+01 9.5684997558593750e+01 1.2349300384521484e+02 -4.7258701324462891e+01 9.5136802673339844e+01 1.1939500427246094e+02 -8.0343093872070312e+01 1.5510900878906250e+02 1.2027700042724609e+02 -8.0064201354980469e+01 1.4800999450683594e+02 1.2081600189208984e+02 -7.9747497558593750e+01 1.3948500061035156e+02 1.0290799713134766e+02 -8.2717498779296875e+01 2.0658599853515625e+02 1.0095999908447266e+02 -8.2908103942871094e+01 2.1009199523925781e+02 6.8196403503417969e+01 -8.4250099182128906e+01 2.1575599670410156e+02 9.7813003540039062e+01 -8.3215805053710938e+01 2.1575599670410156e+02 1.0437500000000000e+02 -8.2562400817871094e+01 2.0361499023437500e+02 1.0786299896240234e+02 -8.2194000244140625e+01 1.9655599975585938e+02 1.1433200073242188e+02 -8.1427795410156250e+01 1.8109400939941406e+02 9.5690803527832031e+01 -8.3352096557617188e+01 2.1931500244140625e+02 6.8196403503417969e+01 -8.4312294006347656e+01 2.1931500244140625e+02 7.2889495849609375e+01 -1.3162699890136719e+02 2.2126998901367188e+02 6.8198394775390625e+01 -1.2887998962402344e+02 2.2274899291992188e+02 7.2934097290039062e+01 -1.3852400207519531e+02 2.1470800781250000e+02 6.8201202392578125e+01 -1.3044000244140625e+02 2.2212300109863281e+02 6.8202896118164062e+01 -1.3167298889160156e+02 2.2136700439453125e+02 6.8205802917480469e+01 -1.3376300048828125e+02 2.2008399963378906e+02 6.8196403503417969e+01 -1.3862100219726562e+02 2.1501499938964844e+02 6.8206695556640625e+01 -1.3561900329589844e+02 2.1864900207519531e+02 6.8206695556640625e+01 -1.3445800781250000e+02 2.1965800476074219e+02 6.8196403503417969e+01 -1.3031401062011719e+02 2.2217999267578125e+02 6.8196403503417969e+01 -1.3562199401855469e+02 2.1864601135253906e+02 6.8196403503417969e+01 -1.3376901245117188e+02 2.2009399414062500e+02 1.2334500122070312e+02 -4.6631000518798828e+01 -1.9496800231933594e+02 6.8196403503417969e+01 -4.7285301208496094e+01 -1.9527299499511719e+02 1.2332700347900391e+02 -4.7173500061035156e+01 -1.9380499267578125e+02 6.8196403503417969e+01 -5.2603801727294922e+01 -1.8386801147460938e+02 1.2315999603271484e+02 -5.1951599121093750e+01 -1.8356401062011719e+02 6.8196403503417969e+01 -5.4733699798583984e+01 -1.7426000976562500e+02 1.2308300018310547e+02 -5.4015300750732422e+01 -1.7426000976562500e+02 1.2310499572753906e+02 -5.3429801940917969e+01 -1.7930200195312500e+02 1.2313000488281250e+02 -5.2776298522949219e+01 -1.8153999328613281e+02 6.8196403503417969e+01 -5.4733699798583984e+01 -9.3849998474121094e+01 1.2302799987792969e+02 -5.4016002655029297e+01 -9.3849998474121094e+01 8.1512199401855469e+01 -1.4524301147460938e+02 2.0215000915527344e+02 6.8196403503417969e+01 -1.4646301269531250e+02 2.0121798706054688e+02 6.8196403503417969e+01 -1.6684300231933594e+02 1.4983599853515625e+02 8.4735397338867188e+01 -1.6285299682617188e+02 1.6089401245117188e+02 6.8196403503417969e+01 -1.6213198852539062e+02 1.6723500061035156e+02 8.4557800292968750e+01 -1.6066400146484375e+02 1.6708500671386719e+02 6.8196403503417969e+01 -1.6195100402832031e+02 1.6790499877929688e+02 8.4307197570800781e+01 -1.5757400512695312e+02 1.7582499694824219e+02 6.8196403503417969e+01 -1.5500799560546875e+02 1.8425599670410156e+02 8.3688201904296875e+01 -1.5392399597167969e+02 1.8421398925781250e+02 6.8196403503417969e+01 -1.5177400207519531e+02 1.9187500000000000e+02 8.3324798583984375e+01 -1.5178099060058594e+02 1.8914100646972656e+02 8.1637397766113281e+01 -1.4569500732421875e+02 2.0125100708007812e+02 6.8196403503417969e+01 -1.6954598999023438e+02 1.3232600402832031e+02 8.4694801330566406e+01 -1.6885699462890625e+02 1.3236500549316406e+02 8.4712196350097656e+01 -1.6849899291992188e+02 1.3540299987792969e+02 6.8196403503417969e+01 -1.6819700622558594e+02 1.4483299255371094e+02 8.4781402587890625e+01 -1.6623200988769531e+02 1.4815499877929688e+02 8.4775299072265625e+01 -1.6578500366210938e+02 1.4984199523925781e+02 8.4703498840332031e+01 -1.6968399047851562e+02 1.1463099670410156e+02 8.4685195922851562e+01 -1.6968501281738281e+02 1.1666699981689453e+02 6.8196403503417969e+01 -1.7081199645996094e+02 1.1463099670410156e+02 8.4676101684570312e+01 -1.6968600463867188e+02 1.1758500671386719e+02 6.8196403503417969e+01 -1.7080400085449219e+02 1.2065800476074219e+02 8.4675102233886719e+01 -1.6968600463867188e+02 1.1781999969482422e+02 8.4673095703125000e+01 -1.6968399047851562e+02 1.1829000091552734e+02 8.4667304992675781e+01 -1.6966099548339844e+02 1.2016899871826172e+02 8.4665000915527344e+01 -1.6953500366210938e+02 1.2392400360107422e+02 8.4689399719238281e+01 -1.6896800231933594e+02 1.3141700744628906e+02 8.4718299865722656e+01 -1.6968299865722656e+02 1.1299300384521484e+02 6.8196403503417969e+01 -1.7083799743652344e+02 9.5225196838378906e+01 8.4806701660156250e+01 -1.6967700195312500e+02 9.8300201416015625e+01 8.4781105041503906e+01 -1.6967800903320312e+02 7.8972801208496094e+01 6.8196403503417969e+01 -1.7083799743652344e+02 7.8972801208496094e+01 8.4728897094726562e+01 -1.6968199157714844e+02 3.9525798797607422e+01 6.8196403503417969e+01 -1.7083799743652344e+02 6.9038696289062500e+01 8.4650001525878906e+01 -1.6968800354003906e+02 -6.3661396026611328e+01 6.8196403503417969e+01 -1.7083799743652344e+02 -6.3661396026611328e+01 8.4639099121093750e+01 -1.6968800354003906e+02 -7.8022003173828125e+01 6.8196403503417969e+01 -1.7083799743652344e+02 -8.0120597839355469e+01 8.4671493530273438e+01 -1.6968600463867188e+02 -3.1311700439453125e+02 8.4672500610351562e+01 -1.6968600463867188e+02 -3.4892999267578125e+02 8.3359001159667969e+01 -1.4436799621582031e+02 2.0201499938964844e+02 8.2508102416992188e+01 -1.4494599914550781e+02 2.0216999816894531e+02 8.4328300476074219e+01 -1.5150498962402344e+02 1.8911399841308594e+02 8.5796806335449219e+01 -1.6597799682617188e+02 1.4809700012207031e+02 8.6590606689453125e+01 -1.6880899047851562e+02 -3.4892999267578125e+02 8.7170799255371094e+01 -1.6798500061035156e+02 -3.4893099975585938e+02 8.7169807434082031e+01 -1.6798500061035156e+02 -3.1311700439453125e+02 8.6555503845214844e+01 -1.6883399963378906e+02 -3.4892999267578125e+02 8.5690299987792969e+01 -1.6943099975585938e+02 -3.1311700439453125e+02 8.5687599182128906e+01 -1.6941801452636719e+02 -3.4892999267578125e+02 8.5770500183105469e+01 -1.6939300537109375e+02 -3.4892999267578125e+02 8.4803100585937500e+01 -1.6967399597167969e+02 -3.4892999267578125e+02 8.5657905578613281e+01 -1.6943299865722656e+02 -7.8020805358886719e+01 8.6558502197265625e+01 -1.6883898925781250e+02 -3.1311700439453125e+02 8.7137397766113281e+01 -1.6798699951171875e+02 -7.8018997192382812e+01 8.6526199340820312e+01 -1.6884199523925781e+02 -7.8019798278808594e+01 8.7144203186035156e+01 -1.6798699951171875e+02 -6.9142501831054688e+01 8.6615699768066406e+01 -1.6883599853515625e+02 3.9518402099609375e+01 8.5747596740722656e+01 -1.6942700195312500e+02 3.9521900177001953e+01 8.7260093688964844e+01 -1.6797900390625000e+02 1.0572899627685547e+02 8.6605102539062500e+01 -1.6883599853515625e+02 1.1300999450683594e+02 8.6693298339843750e+01 -1.6883000183105469e+02 9.8307701110839844e+01 8.7227005004882812e+01 -1.6798199462890625e+02 3.9515899658203125e+01 8.7268203735351562e+01 -1.6797900390625000e+02 7.0748901367187500e+01 8.7304595947265625e+01 -1.6797601318359375e+02 9.8310302734375000e+01 8.5736900329589844e+01 -1.6942700195312500e+02 1.1300199890136719e+02 8.5825195312500000e+01 -1.6942100524902344e+02 9.8304199218750000e+01 8.7216300964355469e+01 -1.6798199462890625e+02 1.1301500701904297e+02 8.7203193664550781e+01 -1.6798300170898438e+02 1.1447399902343750e+02 8.6572105407714844e+01 -1.6883898925781250e+02 1.1668500518798828e+02 8.7183296203613281e+01 -1.6798399353027344e+02 1.1669200134277344e+02 8.7174400329589844e+01 -1.6798500061035156e+02 1.1759600067138672e+02 8.6563102722167969e+01 -1.6883898925781250e+02 1.1759400177001953e+02 8.7173301696777344e+01 -1.6798500061035156e+02 1.1782900238037109e+02 8.6562095642089844e+01 -1.6883898925781250e+02 1.1782699584960938e+02 8.7171302795410156e+01 -1.6798300170898438e+02 1.1829199981689453e+02 8.6560096740722656e+01 -1.6883699035644531e+02 1.1829299926757812e+02 8.7165496826171875e+01 -1.6796000671386719e+02 1.2014199829101562e+02 8.6554199218750000e+01 -1.6881401062011719e+02 1.2015700531005859e+02 8.7162597656250000e+01 -1.6783499145507812e+02 1.2384200286865234e+02 8.7180999755859375e+01 -1.6736500549316406e+02 1.3004100036621094e+02 8.6574501037597656e+01 -1.6812500000000000e+02 1.3132099914550781e+02 8.6551597595214844e+01 -1.6868899536132812e+02 1.2388300323486328e+02 8.5703903198242188e+01 -1.6943000793457031e+02 1.1667700195312500e+02 8.5694900512695312e+01 -1.6943000793457031e+02 1.1759000396728516e+02 8.5693801879882812e+01 -1.6943000793457031e+02 1.1782400512695312e+02 8.5691802978515625e+01 -1.6942800903320312e+02 1.1829299926757812e+02 8.5686103820800781e+01 -1.6940499877929688e+02 1.2016600036621094e+02 8.5683601379394531e+01 -1.6927899169921875e+02 1.2391200256347656e+02 8.5707298278808594e+01 -1.6871299743652344e+02 1.3138600158691406e+02 8.5729797363281250e+01 -1.6824400329589844e+02 1.3536399841308594e+02 8.7184501647949219e+01 -1.6727499389648438e+02 1.3122999572753906e+02 8.7205497741699219e+01 -1.6681001281738281e+02 1.3516600036621094e+02 8.6596199035644531e+01 -1.6765699768066406e+02 1.3528099060058594e+02 8.7266998291015625e+01 -1.6456399536132812e+02 1.4777900695800781e+02 8.6660499572753906e+01 -1.6539900207519531e+02 1.4796600341796875e+02 8.7212097167968750e+01 -1.6120600891113281e+02 1.6042100524902344e+02 8.6608406066894531e+01 -1.6202500915527344e+02 1.6066400146484375e+02 8.7142601013183594e+01 -1.6037100219726562e+02 1.6278100585937500e+02 8.6172500610351562e+01 -1.5674400329589844e+02 1.7558700561523438e+02 8.5315597534179688e+01 -1.5731100463867188e+02 1.7577000427246094e+02 8.5747894287109375e+01 -1.6259700012207031e+02 1.6082899475097656e+02 8.6774002075195312e+01 -1.5594198608398438e+02 1.7529800415039062e+02 8.6700904846191406e+01 -1.5551400756835938e+02 1.7628199768066406e+02 8.5182197570800781e+01 -1.5093598937988281e+02 1.8893400573730469e+02 8.5813003540039062e+01 -1.5031700134277344e+02 1.8822999572753906e+02 8.5783599853515625e+01 -1.5014498901367188e+02 1.8862399291992188e+02 8.3962699890136719e+01 -1.4358100891113281e+02 2.0170399475097656e+02 8.2266197204589844e+01 -1.3943600463867188e+02 2.0910699462890625e+02 9.4700302124023438e+01 -1.5220401000976562e+02 -3.4892999267578125e+02 9.4700004577636719e+01 -1.5220401000976562e+02 -3.4530999755859375e+02 1.0315499877929688e+02 -1.3438899230957031e+02 -6.9123298645019531e+01 1.0334899902343750e+02 -1.3441600036621094e+02 7.0716400146484375e+01 1.0329299926757812e+02 -1.3440798950195312e+02 1.0583799743652344e+02 1.0322900390625000e+02 -1.3439900207519531e+02 1.1463599395751953e+02 1.0315699768066406e+02 -1.3394700622558594e+02 1.2726000213623047e+02 1.0306800079345703e+02 -1.3182798767089844e+02 1.4097300720214844e+02 1.0279700469970703e+02 -1.2852301025390625e+02 1.5351199340820312e+02 1.0223699951171875e+02 -1.2447599792480469e+02 1.6507199096679688e+02 1.0134399414062500e+02 -1.2002799987792969e+02 1.7569898986816406e+02 9.8405197143554688e+01 -1.1040200042724609e+02 1.9510301208496094e+02 9.6242401123046875e+01 -1.0526499938964844e+02 2.0423200988769531e+02 9.3641700744628906e+01 -1.0016200256347656e+02 2.1270401000976562e+02 8.4855697631835938e+01 -1.1450000000000000e+02 2.2009100341796875e+02 1.0242799377441406e+02 -8.5824806213378906e+01 2.0531700134277344e+02 9.5567893981933594e+01 -1.5163600158691406e+02 -3.4892999267578125e+02 9.5567596435546875e+01 -1.5163600158691406e+02 -3.4530899047851562e+02 9.5238998413085938e+01 -1.5170399475097656e+02 -3.4892999267578125e+02 9.5214500427246094e+01 -1.5171299743652344e+02 -3.4530899047851562e+02 9.5216804504394531e+01 -1.5171701049804688e+02 -3.4892999267578125e+02 9.4951194763183594e+01 -1.5187699890136719e+02 -3.4892999267578125e+02 9.4912094116210938e+01 -1.5191200256347656e+02 -3.4530999755859375e+02 9.4918098449707031e+01 -1.5191600036621094e+02 -3.4892999267578125e+02 9.4736892700195312e+01 -1.5213499450683594e+02 -3.4892999267578125e+02 1.0240499877929688e+02 -1.5139700317382812e+02 -3.4892999267578125e+02 1.0418399810791016e+02 -1.5100199890136719e+02 -3.4892999267578125e+02 1.0570400238037109e+02 -1.4999699401855469e+02 -3.4892999267578125e+02 1.0676200103759766e+02 -1.4851300048828125e+02 -3.4892999267578125e+02 1.2700299835205078e+02 -1.0510499572753906e+02 -3.4892999267578125e+02 1.3011500549316406e+02 -9.2977203369140625e+01 -3.4546801757812500e+02 1.3004699707031250e+02 -9.3837699890136719e+01 -3.4546200561523438e+02 1.3011500549316406e+02 -9.2977203369140625e+01 -3.4892999267578125e+02 1.2149900054931641e+02 -9.3971405029296875e+01 -3.3944201660156250e+02 1.2128099822998047e+02 -9.5877899169921875e+01 -3.3943701171875000e+02 1.2088199615478516e+02 -9.7772705078125000e+01 -3.3942700195312500e+02 1.1980299377441406e+02 -1.0087500000000000e+02 -3.3939901733398438e+02 1.2984300231933594e+02 -9.3804504394531250e+01 -3.4436999511718750e+02 1.2990899658203125e+02 -9.2962303161621094e+01 -3.4437500000000000e+02 1.2925698852539062e+02 -9.3738197326660156e+01 -3.4342700195312500e+02 1.2932099914550781e+02 -9.2922302246093750e+01 -3.4343298339843750e+02 1.2836801147460938e+02 -9.3648002624511719e+01 -3.4276397705078125e+02 1.2842999267578125e+02 -9.2862701416015625e+01 -3.4277001953125000e+02 1.2132800292968750e+02 -9.3959999084472656e+01 -3.3933700561523438e+02 1.2121900177001953e+02 -9.3952606201171875e+01 -3.3920700073242188e+02 1.2098699951171875e+02 -9.5829498291015625e+01 -3.3921600341796875e+02 1.2105000305175781e+02 -9.3941200256347656e+01 -3.3900601196289062e+02 1.2079299926757812e+02 -9.5796897888183594e+01 -3.3890200805664062e+02 1.2102500152587891e+02 -9.3939498901367188e+01 -3.3890301513671875e+02 1.2040399932861328e+02 -9.7644996643066406e+01 -3.3889199829101562e+02 1.1935299682617188e+02 -1.0067099761962891e+02 -3.3886401367187500e+02 1.2059400177001953e+02 -9.7696403503417969e+01 -3.3920602416992188e+02 1.1953199768066406e+02 -1.0075299835205078e+02 -3.3917800903320312e+02 1.2302999877929688e+02 -5.3918201446533203e+01 -9.2969497680664062e+01 6.8196403503417969e+01 -5.4373397827148438e+01 -9.2038497924804688e+01 1.2303900146484375e+02 -5.3657497406005859e+01 -9.2334800720214844e+01 1.2304799652099609e+02 -5.3405899047851562e+01 -9.1722602844238281e+01 6.8196403503417969e+01 -5.3347301483154297e+01 -9.0502700805664062e+01 1.2306900024414062e+02 -5.2801799774169922e+01 -9.1043998718261719e+01 1.2308000183105469e+02 -5.2509201049804688e+01 -9.0715293884277344e+01 6.8196403503417969e+01 -5.1811500549316406e+01 -8.9476600646972656e+01 1.2311600494384766e+02 -5.1521301269531250e+01 -9.0167999267578125e+01 1.2312300109863281e+02 -5.1329399108886719e+01 -9.0061798095703125e+01 6.8196403503417969e+01 -4.9999900817871094e+01 -8.9116203308105469e+01 1.2317000579833984e+02 -4.9999900817871094e+01 -8.9835899353027344e+01 6.8196403503417969e+01 -4.4205699920654297e+01 -1.9817900085449219e+02 1.2343199920654297e+02 -4.3923698425292969e+01 -1.9745700073242188e+02 6.8196403503417969e+01 -4.2088699340820312e+01 -1.9858399963378906e+02 1.2347000122070312e+02 -4.2701698303222656e+01 -1.9782299804687500e+02 1.2348899841308594e+02 -4.2088699340820312e+01 -1.9786000061035156e+02 6.8196403503417969e+01 -4.6023498535156250e+01 -1.9702099609375000e+02 1.2337700653076172e+02 -4.5673999786376953e+01 -1.9635101318359375e+02 1.2338200378417969e+02 -4.5510002136230469e+01 -1.9647100830078125e+02 1.2341999816894531e+02 -4.4313301086425781e+01 -1.9733999633789062e+02 1.2153500366210938e+02 -8.8852195739746094e+01 -3.3922698974609375e+02 1.2127000427246094e+02 -8.8834602355957031e+01 -3.3854898071289062e+02 1.2435899353027344e+02 -2.5000000000000000e-01 -3.3927398681640625e+02 1.2418600463867188e+02 -2.5000000000000000e-01 -3.3902801513671875e+02 1.2413500213623047e+02 -8.0273199081420898e+00 -3.3896301269531250e+02 1.2416999816894531e+02 -2.5000000000000000e-01 -3.3895999145507812e+02 1.2408900451660156e+02 -2.5000000000000000e-01 -3.3859899902343750e+02 1.2462899780273438e+02 -8.0301799774169922e+00 -3.3949801635742188e+02 1.2465200042724609e+02 -2.5000000000000000e-01 -3.3949801635742188e+02 1.2433099365234375e+02 -8.0284500122070312e+00 -3.3927700805664062e+02 1.2437899780273438e+02 -2.5000000000000000e-01 -3.3930297851562500e+02 1.2406600189208984e+02 -8.0268993377685547e+00 -3.3859802246093750e+02 1.2327700042724609e+02 -4.7172798156738281e+01 -3.3858401489257812e+02 1.2331999969482422e+02 -4.8449798583984375e+01 -3.3894799804687500e+02 1.2325099945068359e+02 -4.8447200775146484e+01 -3.3858401489257812e+02 1.2133900451660156e+02 -8.8839393615722656e+01 -3.3891299438476562e+02 1.2351599884033203e+02 -4.8456798553466797e+01 -3.3926202392578125e+02 1.2384600067138672e+02 -4.6856399536132812e+01 -3.3948400878906250e+02 1.2381400299072266e+02 -4.8467201232910156e+01 -3.3948300170898438e+02 1.2183200073242188e+02 -8.8871299743652344e+01 -3.3944799804687500e+02 1.3061399841308594e+02 -7.0687004089355469e+01 -3.4345599365234375e+02 1.3231399536132812e+02 -2.5000000000000000e-01 -3.4340997314453125e+02 1.3149499511718750e+02 -2.5000000000000000e-01 -3.4282400512695312e+02 1.3117199707031250e+02 -3.0124500274658203e+01 -3.4281799316406250e+02 1.3289299011230469e+02 -2.5000000000000000e-01 -3.4423397827148438e+02 1.3237400817871094e+02 -2.5000000000000000e-01 -3.4349600219726562e+02 1.3206500244140625e+02 -3.0143798828125000e+01 -3.4348101806640625e+02 1.3316600036621094e+02 -2.5000000000000000e-01 -3.4520401000976562e+02 1.3294999694824219e+02 -2.5000000000000000e-01 -3.4443701171875000e+02 1.3265499877929688e+02 -3.0156801223754883e+01 -3.4442401123046875e+02 1.3056500244140625e+02 -4.7082401275634766e+01 -3.4280700683593750e+02 1.2972200012207031e+02 -7.0641693115234375e+01 -3.4279299926757812e+02 1.3120300292968750e+02 -7.0717498779296875e+01 -3.4439797973632812e+02 1.3318299865722656e+02 -2.5000000000000000e-01 -3.4552197265625000e+02 1.3286100769042969e+02 -3.0161600112915039e+01 -3.4551599121093750e+02 1.3227101135253906e+02 -4.6633800506591797e+01 -3.4550601196289062e+02 1.3140901184082031e+02 -7.0728797912597656e+01 -3.4549099731445312e+02 1.3241200256347656e+02 -4.6638801574707031e+01 -3.4892999267578125e+02 1.3318299865722656e+02 -2.5000000000000000e-01 -3.4892999267578125e+02 6.8196403503417969e+01 -2.5000000000000000e-01 -3.4892999267578125e+02 6.8196403503417969e+01 -2.5000000000000000e-01 -1.9858399963378906e+02 1.2412300109863281e+02 -2.5000000000000000e-01 -1.9785200500488281e+02 1.2326099395751953e+02 -4.7172698974609375e+01 -8.9836997985839844e+01 1.2346900177001953e+02 -4.0761501312255859e+01 -8.9839797973632812e+01 6.8196403503417969e+01 -2.5000000000000000e-01 -8.9116203308105469e+01 1.2405999755859375e+02 -2.5000000000000000e-01 -8.9847496032714844e+01 6.8196403503417969e+01 -2.5000000000000000e-01 9.1270095825195312e+01 6.8196403503417969e+01 -1.7083799743652344e+02 1.1463099670410156e+02 6.8196403503417969e+01 -1.5533799743652344e+02 1.8439599609375000e+02 6.8196403503417969e+01 -1.4675100708007812e+02 2.0138099670410156e+02 6.8196403503417969e+01 -1.7005400085449219e+02 1.3238101196289062e+02 6.8196403503417969e+01 -1.6713101196289062e+02 1.4991400146484375e+02 6.8196403503417969e+01 -1.6217799377441406e+02 1.6724699401855469e+02 1.2349600219726562e+02 -4.7175498962402344e+01 9.5137001037597656e+01 1.2371700286865234e+02 -4.0232898712158203e+01 9.5152496337890625e+01 1.2430699920654297e+02 -2.5000000000000000e-01 9.5193702697753906e+01 1.2401399993896484e+02 -2.5000000000000000e-01 -1.4581399969756603e-02 1.2414799499511719e+02 -2.5000000000000000e-01 4.3444099426269531e+01 1.2339399719238281e+02 -4.7174301147460938e+01 4.3443901062011719e+01 1.2326000213623047e+02 -4.7172798156738281e+01 -8.4918403625488281e+01 1.2399900054931641e+02 -2.5000000000000000e-01 -5.0106201171875000e+01 1.2405200195312500e+02 -2.5000000000000000e-01 -8.4918403625488281e+01 1.1825700378417969e+02 8.0909294128417969e+01 1.6686399841308594e+02 1.1822900390625000e+02 8.0802703857421875e+01 1.6709800720214844e+02 1.1963500213623047e+02 8.0313102722167969e+01 1.5449301147460938e+02 1.2335500335693359e+02 4.6339199066162109e+01 -1.9550498962402344e+02 1.2315799713134766e+02 4.7141399383544922e+01 -3.3858200073242188e+02 1.2334500122070312e+02 4.6631000518798828e+01 -1.9496800231933594e+02 1.2332800292968750e+02 4.7145999908447266e+01 -1.9386399841308594e+02 1.2338300323486328e+02 4.5488903045654297e+01 -1.9645999145507812e+02 1.2339099884033203e+02 4.5220100402832031e+01 -1.9676199340820312e+02 1.2343199920654297e+02 4.3924098968505859e+01 -1.9747999572753906e+02 1.2343800354003906e+02 4.3747898101806641e+01 -1.9757800292968750e+02 1.2348899841308594e+02 4.2088699340820312e+01 -1.9786000061035156e+02 1.2391299438476562e+02 2.2208499908447266e+01 -3.3859597778320312e+02 1.2412300109863281e+02 2.5000000000000000e-01 -1.9785200500488281e+02 1.2408900451660156e+02 2.5000000000000000e-01 -3.3859899902343750e+02 1.2402799987792969e+02 9.4828596115112305e+00 -8.9847099304199219e+01 1.2323100280761719e+02 4.7144496917724609e+01 -8.9836700439453125e+01 1.2326200103759766e+02 4.7145198822021484e+01 -8.5306098937988281e+01 1.2317000579833984e+02 4.9999900817871094e+01 -8.9835899353027344e+01 1.2313800048828125e+02 5.0886001586914062e+01 -8.9934402465820312e+01 1.2311600494384766e+02 5.1514701843261719e+01 -9.0193397521972656e+01 1.2091300201416016e+02 9.3922500610351562e+01 -8.5306098937988281e+01 1.2309400177001953e+02 5.2132099151611328e+01 -9.0447700500488281e+01 1.2306900024414062e+02 5.2805801391601562e+01 -9.1048202514648438e+01 1.2305699920654297e+02 5.3137599945068359e+01 -9.1343902587890625e+01 1.2303800201416016e+02 5.3682701110839844e+01 -9.2328399658203125e+01 1.2303399658203125e+02 5.3790000915527344e+01 -9.2522102355957031e+01 1.2091500091552734e+02 9.3923706054687500e+01 -8.7615196228027344e+01 1.2091699981689453e+02 9.3924499511718750e+01 -8.9263603210449219e+01 1.2302799987792969e+02 5.4016002655029297e+01 -9.3849998474121094e+01 1.2092099761962891e+02 9.3926101684570312e+01 -9.2560501098632812e+01 1.2096100616455078e+02 9.3943298339843750e+01 -1.4614900207519531e+02 1.2096100616455078e+02 9.3943298339843750e+01 -1.4532400512695312e+02 1.2308300018310547e+02 5.4015300750732422e+01 -1.7426000976562500e+02 1.2096100616455078e+02 9.3943405151367188e+01 -1.4779800415039062e+02 1.2096199798583984e+02 9.3943496704101562e+01 -1.5109500122070312e+02 1.2096199798583984e+02 9.3943496704101562e+01 -1.5027099609375000e+02 1.2096100616455078e+02 9.3943405151367188e+01 -1.4862200927734375e+02 1.2096299743652344e+02 9.3943702697753906e+01 -1.5521701049804688e+02 1.2096299743652344e+02 9.3943603515625000e+01 -1.5356900024414062e+02 1.2096199798583984e+02 9.3943603515625000e+01 -1.5274398803710938e+02 1.2096299743652344e+02 9.3943794250488281e+01 -1.5851499938964844e+02 1.2096299743652344e+02 9.3943794250488281e+01 -1.5769100952148438e+02 1.2096299743652344e+02 9.3943702697753906e+01 -1.5604199218750000e+02 1.2096399688720703e+02 9.3943901062011719e+01 -1.6263699340820312e+02 1.2096399688720703e+02 9.3943901062011719e+01 -1.6098800659179688e+02 1.2096299743652344e+02 9.3943901062011719e+01 -1.6016400146484375e+02 1.2096399688720703e+02 9.3944000244140625e+01 -1.6593399047851562e+02 1.2096399688720703e+02 9.3944000244140625e+01 -1.6511000061035156e+02 1.2096399688720703e+02 9.3943901062011719e+01 -1.6346099853515625e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.7005599975585938e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.6840699768066406e+02 1.2096399688720703e+02 9.3944000244140625e+01 -1.6758300781250000e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.7335400390625000e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.7252899169921875e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.7088099670410156e+02 1.2092799377441406e+02 9.3929405212402344e+01 -9.9154899597167969e+01 1.2092600250244141e+02 9.3928596496582031e+01 -9.7506301879882812e+01 1.2092299652099609e+02 9.3927001953125000e+01 -9.4208999633789062e+01 1.2094499969482422e+02 9.3937004089355469e+01 -1.1729299926757812e+02 1.2094400024414062e+02 9.3936401367187500e+01 -1.1564399719238281e+02 1.2094799804687500e+02 9.3938201904296875e+01 -1.2059100341796875e+02 1.2094700622558594e+02 9.3937904357910156e+01 -1.1976599884033203e+02 1.2094599914550781e+02 9.3937301635742188e+01 -1.1811699676513672e+02 1.2095099639892578e+02 9.3939605712890625e+01 -1.2471300506591797e+02 1.2094999694824219e+02 9.3939102172851562e+01 -1.2306399536132812e+02 1.2094899749755859e+02 9.3938796997070312e+01 -1.2223999786376953e+02 1.2095300292968750e+02 9.3940597534179688e+01 -1.2801100158691406e+02 1.2095200347900391e+02 9.3940399169921875e+01 -1.2718599700927734e+02 1.2095099639892578e+02 9.3939804077148438e+01 -1.2553699493408203e+02 1.2095999908447266e+02 9.3943199157714844e+01 -1.4367599487304688e+02 1.2095999908447266e+02 9.3943199157714844e+01 -1.4285099792480469e+02 1.2095899963378906e+02 9.3943099975585938e+01 -1.4120199584960938e+02 1.2095800018310547e+02 9.3942703247070312e+01 -1.3790499877929688e+02 1.2095700073242188e+02 9.3942497253417969e+01 -1.3625599670410156e+02 1.2095899963378906e+02 9.3943000793457031e+01 -1.4037799072265625e+02 1.2095800018310547e+02 9.3942802429199219e+01 -1.3872900390625000e+02 1.2095499420166016e+02 9.3941703796386719e+01 -1.3213301086425781e+02 1.2095400238037109e+02 9.3941299438476562e+01 -1.3048399353027344e+02 1.2095400238037109e+02 9.3941001892089844e+01 -1.2965998840332031e+02 1.2095700073242188e+02 9.3942298889160156e+01 -1.3543099975585938e+02 1.2095600128173828e+02 9.3942199707031250e+01 -1.3460699462890625e+02 1.2095600128173828e+02 9.3941894531250000e+01 -1.3295799255371094e+02 1.2094300079345703e+02 9.3936103820800781e+01 -1.1481900024414062e+02 1.2094199371337891e+02 9.3935493469238281e+01 -1.1316999816894531e+02 1.2094100189208984e+02 9.3935195922851562e+01 -1.1234500122070312e+02 1.2094000244140625e+02 9.3934600830078125e+01 -1.1069699859619141e+02 1.2093900299072266e+02 9.3934204101562500e+01 -1.0987200164794922e+02 1.2093699645996094e+02 9.3933593750000000e+01 -1.0822299957275391e+02 1.2093699645996094e+02 9.3933204650878906e+01 -1.0739900207519531e+02 1.2093499755859375e+02 9.3932601928710938e+01 -1.0575000000000000e+02 1.2093400573730469e+02 9.3932197570800781e+01 -1.0492499542236328e+02 1.2093199920654297e+02 9.3931396484375000e+01 -1.0327700042724609e+02 1.2093199920654297e+02 9.3930999755859375e+01 -1.0245200347900391e+02 1.2096299743652344e+02 9.3944099426269531e+01 -1.7994799804687500e+02 1.2096299743652344e+02 9.3944099426269531e+01 -1.7829899597167969e+02 1.2308699798583984e+02 5.3906700134277344e+01 -1.7644299316406250e+02 1.2096299743652344e+02 9.3944099426269531e+01 -1.7747500610351562e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.7582600402832031e+02 1.2096399688720703e+02 9.3944099426269531e+01 -1.7500199890136719e+02 1.2096199798583984e+02 9.3943901062011719e+01 -1.8571800231933594e+02 1.2096299743652344e+02 9.3943901062011719e+01 -1.8489399719238281e+02 1.2309999847412109e+02 5.3553001403808594e+01 -1.7874699401855469e+02 1.2096199798583984e+02 9.3943901062011719e+01 -1.8736700439453125e+02 1.2096299743652344e+02 9.3944000244140625e+01 -1.8324501037597656e+02 1.2096299743652344e+02 9.3944000244140625e+01 -1.8242100524902344e+02 1.2096299743652344e+02 9.3944000244140625e+01 -1.8077200317382812e+02 1.2096100616455078e+02 9.3943496704101562e+01 -1.9561000061035156e+02 1.2096100616455078e+02 9.3943496704101562e+01 -1.9396099853515625e+02 1.2315999603271484e+02 5.1951599121093750e+01 -1.8356401062011719e+02 1.2096100616455078e+02 9.3943603515625000e+01 -1.9313700866699219e+02 1.2096100616455078e+02 9.3943702697753906e+01 -1.9148799133300781e+02 1.2095999908447266e+02 9.3943199157714844e+01 -1.9890699768066406e+02 1.2095999908447266e+02 9.3943298339843750e+01 -1.9808200073242188e+02 1.2095999908447266e+02 9.3943405151367188e+01 -1.9643400573730469e+02 1.2096199798583984e+02 9.3943702697753906e+01 -1.9066398620605469e+02 1.2096199798583984e+02 9.3943794250488281e+01 -1.8901600646972656e+02 1.2096199798583984e+02 9.3943794250488281e+01 -1.8819099426269531e+02 1.2093699645996094e+02 9.3933593750000000e+01 -3.3854299926757812e+02 1.2093699645996094e+02 9.3933593750000000e+01 -3.3736199951171875e+02 1.2268900299072266e+02 6.2627597808837891e+01 -3.3857400512695312e+02 1.2093699645996094e+02 9.3933593750000000e+01 -3.3571301269531250e+02 1.2093699645996094e+02 9.3933502197265625e+01 -3.3241702270507812e+02 1.2093699645996094e+02 9.3933502197265625e+01 -3.3076901245117188e+02 1.2093699645996094e+02 9.3933502197265625e+01 -3.2747201538085938e+02 1.2093699645996094e+02 9.3933502197265625e+01 -3.2582400512695312e+02 1.2093599700927734e+02 9.3933502197265625e+01 -3.2252697753906250e+02 1.2093599700927734e+02 9.3933403015136719e+01 -3.2087899780273438e+02 1.2093599700927734e+02 9.3933403015136719e+01 -3.1758300781250000e+02 1.2093599700927734e+02 9.3933403015136719e+01 -3.1593399047851562e+02 1.2093599700927734e+02 9.3933403015136719e+01 -3.1263800048828125e+02 1.2093599700927734e+02 9.3933403015136719e+01 -3.1099002075195312e+02 1.2093699645996094e+02 9.3933296203613281e+01 -3.0769299316406250e+02 1.2093699645996094e+02 9.3933296203613281e+01 -3.0604498291015625e+02 1.2093699645996094e+02 9.3933296203613281e+01 -3.0274798583984375e+02 1.2093699645996094e+02 9.3933296203613281e+01 -3.0109997558593750e+02 1.2093699645996094e+02 9.3933296203613281e+01 -2.9780398559570312e+02 1.2093699645996094e+02 9.3933403015136719e+01 -2.9615597534179688e+02 1.2093699645996094e+02 9.3933502197265625e+01 -2.9285897827148438e+02 1.2095099639892578e+02 9.3939201354980469e+01 -2.3022698974609375e+02 1.2095200347900391e+02 9.3939697265625000e+01 -2.2693000793457031e+02 1.2093800354003906e+02 9.3933502197265625e+01 -2.9121099853515625e+02 1.2093800354003906e+02 9.3933700561523438e+01 -2.8791497802734375e+02 1.2093800354003906e+02 9.3933799743652344e+01 -2.8626599121093750e+02 1.2094899749755859e+02 9.3938598632812500e+01 -2.3681999206542969e+02 1.2094899749755859e+02 9.3938697814941406e+01 -2.3517199707031250e+02 1.2094999694824219e+02 9.3939102172851562e+01 -2.3187500000000000e+02 1.2093800354003906e+02 9.3934097290039062e+01 -2.8297000122070312e+02 1.2093900299072266e+02 9.3934204101562500e+01 -2.8132199096679688e+02 1.2093900299072266e+02 9.3934501647949219e+01 -2.7802499389648438e+02 1.2094700622558594e+02 9.3938003540039062e+01 -2.4341299438476562e+02 1.2094700622558594e+02 9.3938201904296875e+01 -2.4176501464843750e+02 1.2094799804687500e+02 9.3938301086425781e+01 -2.4011700439453125e+02 1.2093900299072266e+02 9.3934700012207031e+01 -2.7637698364257812e+02 1.2094000244140625e+02 9.3935104370117188e+01 -2.7308099365234375e+02 1.2094000244140625e+02 9.3935302734375000e+01 -2.7143200683593750e+02 1.2094100189208984e+02 9.3935600280761719e+01 -2.6813598632812500e+02 1.2094100189208984e+02 9.3935806274414062e+01 -2.6648797607421875e+02 1.2094400024414062e+02 9.3937301635742188e+01 -2.5165399169921875e+02 1.2094499969482422e+02 9.3937599182128906e+01 -2.4835800170898438e+02 1.2094599914550781e+02 9.3937705993652344e+01 -2.4671000671386719e+02 1.2094199371337891e+02 9.3936103820800781e+01 -2.6319100952148438e+02 1.2094199371337891e+02 9.3936302185058594e+01 -2.6154299926757812e+02 1.2094300079345703e+02 9.3936698913574219e+01 -2.5824697875976562e+02 1.2094300079345703e+02 9.3936897277832031e+01 -2.5659899902343750e+02 1.2094400024414062e+02 9.3937202453613281e+01 -2.5330200195312500e+02 1.2095200347900391e+02 9.3939903259277344e+01 -2.2528199768066406e+02 1.2095300292968750e+02 9.3940399169921875e+01 -2.2198500061035156e+02 1.2095400238037109e+02 9.3940597534179688e+01 -2.2033700561523438e+02 1.2095800018310547e+02 9.3942596435546875e+01 -2.0550100708007812e+02 1.2095899963378906e+02 9.3942802429199219e+01 -2.0385200500488281e+02 1.2095700073242188e+02 9.3942298889160156e+01 -2.0879800415039062e+02 1.2095700073242188e+02 9.3942398071289062e+01 -2.0797399902343750e+02 1.2095800018310547e+02 9.3942596435546875e+01 -2.0632499694824219e+02 1.2095600128173828e+02 9.3941703796386719e+01 -2.1291899108886719e+02 1.2095600128173828e+02 9.3942001342773438e+01 -2.1127000427246094e+02 1.2095700073242188e+02 9.3942100524902344e+01 -2.1044599914550781e+02 1.2095499420166016e+02 9.3941299438476562e+01 -2.1621600341796875e+02 1.2095499420166016e+02 9.3941398620605469e+01 -2.1539099121093750e+02 1.2095600128173828e+02 9.3941596984863281e+01 -2.1374299621582031e+02 1.2095400238037109e+02 9.3940895080566406e+01 -2.1868800354003906e+02 1.2095400238037109e+02 9.3941001892089844e+01 -2.1786401367187500e+02 1.2095899963378906e+02 9.3942901611328125e+01 -2.0302799987792969e+02 1.2095899963378906e+02 9.3943000793457031e+01 -2.0138000488281250e+02 1.2095899963378906e+02 9.3943099975585938e+01 -2.0055499267578125e+02 1.2339199829101562e+02 4.7146701812744141e+01 4.2859901428222656e+01 1.2420800018310547e+02 2.5000000000000000e-01 4.2859901428222656e+01 1.2406499481201172e+02 2.5000000000000000e-01 -8.5306098937988281e+01 1.2421199798583984e+02 2.5000000000000000e-01 4.6276901245117188e+01 1.2428800201416016e+02 7.2702798843383789e+00 9.5192298889160156e+01 1.2430699920654297e+02 2.5000000000000000e-01 9.5193702697753906e+01 1.2109899902343750e+02 9.4003997802734375e+01 8.7127204895019531e+01 1.2109700012207031e+02 9.4003105163574219e+01 8.8783004760742188e+01 1.2237200164794922e+02 7.1662002563476562e+01 1.0635800170898438e+02 1.2109100341796875e+02 9.4000305175781250e+01 9.2095298767089844e+01 1.2108699798583984e+02 9.3998603820800781e+01 9.3751899719238281e+01 1.2108200073242188e+02 9.3996505737304688e+01 9.5408798217773438e+01 1.2107899475097656e+02 9.3995399475097656e+01 9.6237304687500000e+01 1.2107399749755859e+02 9.3992797851562500e+01 9.7894500732421875e+01 1.2107100677490234e+02 9.3991500854492188e+01 9.8723205566406250e+01 1.2106400299072266e+02 9.3988502502441406e+01 1.0038100433349609e+02 1.2105999755859375e+02 9.3986801147460938e+01 1.0120999908447266e+02 1.2102899932861328e+02 9.3973197937011719e+01 1.0694299316406250e+02 1.2234500122070312e+02 7.2090202331542969e+01 1.0694299316406250e+02 1.2104800415039062e+02 9.3981399536132812e+01 1.0369699859619141e+02 1.2105199432373047e+02 9.3983299255371094e+01 1.0286799621582031e+02 1.2110199737548828e+02 9.4005104064941406e+01 8.3816497802734375e+01 1.2250199890136719e+02 6.9382102966308594e+01 1.0414999389648438e+02 1.2110199737548828e+02 9.4005302429199219e+01 8.2161499023437500e+01 1.2109500122070312e+02 9.4001998901367188e+01 7.2237297058105469e+01 1.2109700012207031e+02 9.4003105163574219e+01 7.3890701293945312e+01 1.2262200164794922e+02 6.7270500183105469e+01 1.0210400390625000e+02 1.2110099792480469e+02 9.4004600524902344e+01 7.7198196411132812e+01 1.2110199737548828e+02 9.4005004882812500e+01 7.8852401733398438e+01 1.2102399444580078e+02 9.3971298217773438e+01 4.7468402862548828e+01 1.2103600311279297e+02 9.3976402282714844e+01 5.0767501831054688e+01 1.2282100677490234e+02 6.3420200347900391e+01 9.9469604492187500e+01 1.2104199981689453e+02 9.3978897094726562e+01 5.2417400360107422e+01 1.2105300140380859e+02 9.3983802795410156e+01 5.5718101501464844e+01 1.2105799865722656e+02 9.3986099243164062e+01 5.7368801116943359e+01 1.2106800079345703e+02 9.3990493774414062e+01 6.0671096801757812e+01 1.2107299804687500e+02 9.3992500305175781e+01 6.2322601318359375e+01 1.2107700347900391e+02 9.3994499206542969e+01 6.3974403381347656e+01 1.2108500671386719e+02 9.3997901916503906e+01 6.7278701782226562e+01 1.2108899688720703e+02 9.3999397277832031e+01 6.8931297302246094e+01 1.2301699829101562e+02 5.9199897766113281e+01 9.7529998779296875e+01 1.2100700378417969e+02 9.3963798522949219e+01 4.2859901428222656e+01 1.2101799774169922e+02 9.3968597412109375e+01 4.5819301605224609e+01 1.2307900238037109e+02 5.7859100341796875e+01 9.6913703918457031e+01 1.2326599884033203e+02 5.3363700866699219e+01 9.5708305358886719e+01 1.2349300384521484e+02 4.7258701324462891e+01 9.5136802673339844e+01 1.2349499511718750e+02 4.7147899627685547e+01 9.5136901855468750e+01 1.2046799468994141e+02 9.1357604980468750e+01 1.3769300842285156e+02 1.2042099761962891e+02 9.1075897216796875e+01 1.3881700134277344e+02 1.2098100280761719e+02 7.9718299865722656e+01 1.3881399536132812e+02 1.2053600311279297e+02 9.1771102905273438e+01 1.3592100524902344e+02 1.2065599822998047e+02 9.2504997253417969e+01 1.3236000061035156e+02 1.2168700408935547e+02 7.9242202758789062e+01 1.2589399719238281e+02 1.2070800018310547e+02 9.2821800231933594e+01 1.3057099914550781e+02 1.2086500549316406e+02 9.3712303161621094e+01 1.2337700653076172e+02 1.2083300018310547e+02 9.3549995422363281e+01 1.2518000793457031e+02 1.2079600524902344e+02 9.3346199035644531e+01 1.2698100280761719e+02 1.2094000244140625e+02 9.3934097290039062e+01 1.1796099853515625e+02 1.2090899658203125e+02 9.3838203430175781e+01 1.2067200469970703e+02 1.2186299896240234e+02 7.8478004455566406e+01 1.2000099945068359e+02 1.2091799926757812e+02 9.3905906677246094e+01 1.1976599884033203e+02 1.2199400329589844e+02 7.7138107299804688e+01 1.1558000183105469e+02 1.2101699829101562e+02 9.3968200683593750e+01 1.0867299652099609e+02 1.2100599670410156e+02 9.3962997436523438e+01 1.1033200073242188e+02 1.2099900054931641e+02 9.3960296630859375e+01 1.1116200256347656e+02 1.2098600006103516e+02 9.3954597473144531e+01 1.1282099914550781e+02 1.2094000244140625e+02 9.3934097290039062e+01 1.1795999908447266e+02 1.2102799987792969e+02 9.3972999572753906e+01 1.0701399993896484e+02 1.2205000305175781e+02 7.6383399963378906e+01 1.1406800079345703e+02 1.2219699859619141e+02 7.4406898498535156e+01 1.1010699462890625e+02 1.2039399719238281e+02 9.0915000915527344e+01 1.3945899963378906e+02 1.2022600555419922e+02 8.9948806762695312e+01 1.4297300720214844e+02 1.2059299468994141e+02 7.9979896545410156e+01 1.4591200256347656e+02 1.2013299560546875e+02 8.9428298950195312e+01 1.4472100830078125e+02 1.1992599487304688e+02 8.8318603515625000e+01 1.4819599914550781e+02 1.1913199615478516e+02 8.4516799926757812e+01 1.5847100830078125e+02 1.1897299957275391e+02 8.3823799133300781e+01 1.6016200256347656e+02 1.1942599487304688e+02 8.5855094909667969e+01 1.5507099914550781e+02 1.1981199645996094e+02 8.7731697082519531e+01 1.4992498779296875e+02 1.1956199645996094e+02 8.6498901367187500e+01 1.5336199951171875e+02 1.1947100067138672e+02 8.6068199157714844e+01 1.5450599670410156e+02 1.1880599975585938e+02 8.3115898132324219e+01 1.6184599304199219e+02 1.1844799804687500e+02 8.1657997131347656e+01 1.6519700622558594e+02 1.2086900329589844e+02 9.3903701782226562e+01 -2.8279399871826172e+01 1.2086900329589844e+02 9.3903701782226562e+01 -2.6632400512695312e+01 1.2086900329589844e+02 9.3903900146484375e+01 -2.3338598251342773e+01 1.2087000274658203e+02 9.3904098510742188e+01 -2.1691699981689453e+01 1.2087100219726562e+02 9.3904502868652344e+01 -3.8161998748779297e+01 1.2087000274658203e+02 9.3904098510742188e+01 -3.4867599487304688e+01 1.2087400054931641e+02 9.3905906677246094e+01 -4.4751201629638672e+01 1.2087299346923828e+02 9.3905502319335938e+01 -4.3103797912597656e+01 1.2087100219726562e+02 9.3904800415039062e+01 -3.9809303283691406e+01 1.2087900543212891e+02 9.3908302307128906e+01 -5.2988601684570312e+01 1.2087699890136719e+02 9.3907196044921875e+01 -4.9693599700927734e+01 1.2087599945068359e+02 9.3906799316406250e+01 -4.8046100616455078e+01 1.2089800262451172e+02 9.3916496276855469e+01 -7.2781196594238281e+01 1.2089499664306641e+02 9.3915000915527344e+01 -6.9485198974609375e+01 1.2089999389648438e+02 9.3917304992675781e+01 -7.4429199218750000e+01 1.2090899658203125e+02 9.3921195983886719e+01 -8.2670196533203125e+01 1.2090600585937500e+02 9.3919593811035156e+01 -7.9373703002929688e+01 1.2090399932861328e+02 9.3918899536132812e+01 -7.7725502014160156e+01 1.2091100311279297e+02 9.3921997070312500e+01 -8.4318397521972656e+01 1.2089300537109375e+02 9.3914299011230469e+01 -6.7837295532226562e+01 1.2088999938964844e+02 9.3912803649902344e+01 -6.4541496276855469e+01 1.2088899993896484e+02 9.3912399291992188e+01 -6.3717605590820312e+01 1.2088899993896484e+02 9.3912399291992188e+01 -6.3511604309082031e+01 1.2088899993896484e+02 9.3912399291992188e+01 -6.3460098266601562e+01 1.2088500213623047e+02 9.3910697937011719e+01 -5.9579200744628906e+01 1.2088300323486328e+02 9.3910095214843750e+01 -5.7931503295898438e+01 1.2088099670410156e+02 9.3908897399902344e+01 -5.4636199951171875e+01 1.2086900329589844e+02 9.3903900146484375e+01 -3.3220500946044922e+01 1.2086900329589844e+02 9.3903800964355469e+01 -3.1573400497436523e+01 1.2405999755859375e+02 2.5000000000000000e-01 -8.9847496032714844e+01 1.2087100219726562e+02 9.3904693603515625e+01 -1.8398099899291992e+01 1.2087200164794922e+02 9.3905097961425781e+01 -1.6751399993896484e+01 1.2087299346923828e+02 9.3906097412109375e+01 -1.3457999229431152e+01 1.2087500000000000e+02 9.3906593322753906e+01 -1.1811399459838867e+01 1.2087699890136719e+02 9.3907997131347656e+01 -8.5182895660400391e+00 1.2087900543212891e+02 9.3908798217773438e+01 -6.8717999458312988e+00 1.2088300323486328e+02 9.3910499572753906e+01 -3.5789098739624023e+00 1.2088500213623047e+02 9.3911399841308594e+01 -1.9325098991394043e+00 1.2088899993896484e+02 9.3913505554199219e+01 1.3601100444793701e+00 1.2089200592041016e+02 9.3914596557617188e+01 3.0063900947570801e+00 1.2089700317382812e+02 9.3916900634765625e+01 6.2987999916076660e+00 1.2089999389648438e+02 9.3918098449707031e+01 7.9449901580810547e+00 1.2090699768066406e+02 9.3920799255371094e+01 1.1237099647521973e+01 1.2091100311279297e+02 9.3922103881835938e+01 1.2883200645446777e+01 1.2091799926757812e+02 9.3925102233886719e+01 1.6175100326538086e+01 1.2096299743652344e+02 9.3944602966308594e+01 3.0988800048828125e+01 1.2096899414062500e+02 9.3947097778320312e+01 3.2635601043701172e+01 1.2092299652099609e+02 9.3926803588867188e+01 1.7821001052856445e+01 1.2093099975585938e+02 9.3930801391601562e+01 2.1112701416015625e+01 1.2093599700927734e+02 9.3932998657226562e+01 2.2758501052856445e+01 1.2094599914550781e+02 9.3937500000000000e+01 2.6050100326538086e+01 1.2095200347900391e+02 9.3939804077148438e+01 2.7696001052856445e+01 1.2098100280761719e+02 9.3952400207519531e+01 3.5929901123046875e+01 1.2098699951171875e+02 9.3955101013183594e+01 3.7577499389648438e+01 1.2099900054931641e+02 9.3960502624511719e+01 4.0873401641845703e+01 1.2100499725341797e+02 9.3963302612304688e+01 4.2521701812744141e+01 6.8196403503417969e+01 4.9054599761962891e+01 9.1270095825195312e+01 6.8196403503417969e+01 2.5000000000000000e-01 9.1270095825195312e+01 6.8196403503417969e+01 4.4205699920654297e+01 -1.9817900085449219e+02 6.8196403503417969e+01 4.6023498535156250e+01 -1.9702099609375000e+02 6.8196403503417969e+01 4.9999900817871094e+01 -8.9116203308105469e+01 6.8196403503417969e+01 2.5000000000000000e-01 -8.9116203308105469e+01 6.8196403503417969e+01 4.7285301208496094e+01 -1.9527299499511719e+02 6.8196403503417969e+01 5.2603801727294922e+01 -1.8386801147460938e+02 6.8196403503417969e+01 1.7083799743652344e+02 -8.0120597839355469e+01 6.8196403503417969e+01 7.1248001098632812e+01 1.0024700164794922e+02 6.8196403503417969e+01 5.1811500549316406e+01 -8.9476600646972656e+01 6.8196403503417969e+01 6.1025600433349609e+01 9.3598800659179688e+01 6.8196403503417969e+01 4.2088699340820312e+01 -1.9858399963378906e+02 6.8196403503417969e+01 2.5000000000000000e-01 -3.4892999267578125e+02 6.8196403503417969e+01 2.5000000000000000e-01 -1.9858399963378906e+02 6.8196403503417969e+01 1.3861801147460938e+02 2.1502000427246094e+02 6.8196403503417969e+01 8.4250099182128906e+01 2.1575599670410156e+02 6.8196403503417969e+01 1.7083799743652344e+02 1.1462999725341797e+02 6.8196403503417969e+01 1.7083799743652344e+02 9.5228904724121094e+01 6.8196403503417969e+01 1.7083799743652344e+02 7.8971496582031250e+01 6.8196403503417969e+01 5.3347301483154297e+01 -9.0502700805664062e+01 6.8196403503417969e+01 1.7083799743652344e+02 6.9038696289062500e+01 6.8196403503417969e+01 5.4373397827148438e+01 -9.2038497924804688e+01 6.8196403503417969e+01 1.7083799743652344e+02 -6.3662403106689453e+01 6.8196403503417969e+01 5.4733699798583984e+01 -9.3849998474121094e+01 6.8196403503417969e+01 5.4733699798583984e+01 -1.7426000976562500e+02 6.8196403503417969e+01 1.6713101196289062e+02 1.4991299438476562e+02 6.8196403503417969e+01 1.6819999694824219e+02 1.4482000732421875e+02 6.8196403503417969e+01 7.8237495422363281e+01 1.1024900054931641e+02 6.8196403503417969e+01 1.6195399475097656e+02 1.6789500427246094e+02 6.8196403503417969e+01 8.0979400634765625e+01 1.2215299987792969e+02 6.8196403503417969e+01 1.5533900451660156e+02 1.8439500427246094e+02 6.8196403503417969e+01 1.5177799987792969e+02 1.9186698913574219e+02 6.8196403503417969e+01 8.4312294006347656e+01 2.1931500244140625e+02 6.8196403503417969e+01 8.4312294006347656e+01 2.2382000732421875e+02 6.8196403503417969e+01 1.3310000610351562e+02 2.2064900207519531e+02 6.8196403503417969e+01 1.3201800537109375e+02 2.2118699645996094e+02 6.8196403503417969e+01 1.6217898559570312e+02 1.6724499511718750e+02 6.8196403503417969e+01 1.7005400085449219e+02 1.3237899780273438e+02 6.8196403503417969e+01 1.7080400085449219e+02 1.2066500091552734e+02 6.8196403503417969e+01 1.4675199890136719e+02 2.0137899780273438e+02 6.8196403503417969e+01 1.3857200622558594e+02 2.1509100341796875e+02 6.8196403503417969e+01 1.3859799194335938e+02 2.1505000305175781e+02 6.8196403503417969e+01 1.3861100769042969e+02 2.1502999877929688e+02 6.8196403503417969e+01 1.2809899902343750e+02 2.2300498962402344e+02 6.8196403503417969e+01 1.3819599914550781e+02 2.1565499877929688e+02 6.8196403503417969e+01 1.3841299438476562e+02 2.1533499145507812e+02 6.8196403503417969e+01 1.3851899719238281e+02 2.1517300415039062e+02 6.8196403503417969e+01 1.3620899963378906e+02 2.1806700134277344e+02 6.8196403503417969e+01 1.3774299621582031e+02 2.1627900695800781e+02 8.5687698364257812e+01 1.6942500305175781e+02 -3.4892999267578125e+02 8.6496299743652344e+01 1.6889900207519531e+02 -3.4892999267578125e+02 8.6547393798828125e+01 1.6883000183105469e+02 -3.4892999267578125e+02 8.7171005249023438e+01 1.6798500061035156e+02 -3.4893099975585938e+02 9.4700401306152344e+01 1.5220401000976562e+02 -3.4892999267578125e+02 1.2700299835205078e+02 1.0510499572753906e+02 -3.4892999267578125e+02 1.3011500549316406e+02 9.2977005004882812e+01 -3.4892999267578125e+02 1.3241200256347656e+02 4.6638702392578125e+01 -3.4892999267578125e+02 1.3318299865722656e+02 2.5000000000000000e-01 -3.4892999267578125e+02 9.5216995239257812e+01 1.5172100830078125e+02 -3.4892999267578125e+02 9.5489700317382812e+01 1.5164199829101562e+02 -3.4892999267578125e+02 1.0240499877929688e+02 1.5139700317382812e+02 -3.4892999267578125e+02 1.0418399810791016e+02 1.5100199890136719e+02 -3.4892999267578125e+02 9.5568000793457031e+01 1.5163600158691406e+02 -3.4892999267578125e+02 1.0570400238037109e+02 1.4999699401855469e+02 -3.4892999267578125e+02 1.0676200103759766e+02 1.4851300048828125e+02 -3.4892999267578125e+02 8.5651504516601562e+01 1.6944799804687500e+02 -3.4892999267578125e+02 8.4672698974609375e+01 1.6968600463867188e+02 -3.4892999267578125e+02 9.4893798828125000e+01 1.5193000793457031e+02 -3.4892999267578125e+02 9.4914901733398438e+01 1.5191499328613281e+02 -3.4892999267578125e+02 9.5167098999023438e+01 1.5173498535156250e+02 -3.4892999267578125e+02 1.3318299865722656e+02 2.5000000000000000e-01 -3.4552197265625000e+02 1.3306300354003906e+02 1.8441398620605469e+01 -3.4551998901367188e+02 1.3228799438476562e+02 4.6635299682617188e+01 -3.4550601196289062e+02 1.3194799804687500e+02 5.9022602081298828e+01 -3.4550000000000000e+02 1.3011500549316406e+02 9.2977005004882812e+01 -3.4546801757812500e+02 1.2828700256347656e+02 9.4431602478027344e+01 -3.4274899291992188e+02 1.2149900054931641e+02 9.3971702575683594e+01 -3.3944201660156250e+02 1.2154000091552734e+02 9.3225700378417969e+01 -3.3944299316406250e+02 1.2325099945068359e+02 6.2653495788574219e+01 -3.3947302246093750e+02 1.2842999267578125e+02 9.2862602233886719e+01 -3.4277001953125000e+02 1.2835499572753906e+02 9.3683700561523438e+01 -3.4275900268554688e+02 1.2465200042724609e+02 2.5000000000000000e-01 -3.3949801635742188e+02 1.3149499511718750e+02 2.5000000000000000e-01 -3.4282400512695312e+02 1.2447599792480469e+02 2.2217599868774414e+01 -3.3949499511718750e+02 1.3137400817871094e+02 1.8418699264526367e+01 -3.4282199096679688e+02 1.2375199890136719e+02 4.6101997375488281e+01 -3.3948199462890625e+02 1.3060699462890625e+02 4.6329799652099609e+01 -3.4280801391601562e+02 1.3026100158691406e+02 5.8949897766113281e+01 -3.4280200195312500e+02 1.3174200439453125e+02 5.9013198852539062e+01 -3.4440802001953125e+02 1.3226699829101562e+02 1.8430500030517578e+01 -3.4348498535156250e+02 1.3301399230957031e+02 2.5000000000000000e-01 -3.4452899169921875e+02 1.3285699462890625e+02 1.8438400268554688e+01 -3.4442700195312500e+02 1.3296299743652344e+02 2.5000000000000000e-01 -3.4443701171875000e+02 1.3252600097656250e+02 2.5000000000000000e-01 -3.4364797973632812e+02 1.3236300659179688e+02 2.5000000000000000e-01 -3.4351699829101562e+02 1.2990899658203125e+02 9.2962196350097656e+01 -3.4437500000000000e+02 1.3115200805664062e+02 5.8987800598144531e+01 -3.4346499633789062e+02 1.2932099914550781e+02 9.2922203063964844e+01 -3.4343298339843750e+02 1.2414500427246094e+02 2.5000000000000000e-01 -3.3893002319335938e+02 1.2416200256347656e+02 2.5000000000000000e-01 -3.3895999145507812e+02 1.2398199462890625e+02 2.2209600448608398e+01 -3.3895999145507812e+02 1.2105000305175781e+02 9.3941505432128906e+01 -3.3900601196289062e+02 1.2102500152587891e+02 9.3939804077148438e+01 -3.3890301513671875e+02 1.2275700378417969e+02 6.2631004333496094e+01 -3.3893798828125000e+02 1.2132800292968750e+02 9.3960296630859375e+01 -3.3933700561523438e+02 1.2121900177001953e+02 9.3952903747558594e+01 -3.3920700073242188e+02 1.2295400238037109e+02 6.2639995574951172e+01 -3.3925198364257812e+02 1.2430799865722656e+02 2.5000000000000000e-01 -3.3922299194335938e+02 1.2436199951171875e+02 2.5000000000000000e-01 -3.3926699829101562e+02 1.2417800140380859e+02 2.2212799072265625e+01 -3.3927398681640625e+02 1.2062500000000000e+02 9.6367202758789062e+01 1.1796200561523438e+02 1.1903499603271484e+02 1.0120599365234375e+02 1.1795899963378906e+02 1.1949900054931641e+02 9.9793701171875000e+01 1.1795999908447266e+02 1.1905100250244141e+02 1.0120999908447266e+02 1.1623799896240234e+02 1.1908199310302734e+02 1.0121800231933594e+02 1.1281999969482422e+02 1.2033799743652344e+02 9.7625892639160156e+01 -3.3852700805664062e+02 1.1923900604248047e+02 1.0075900268554688e+02 -3.3849798583984375e+02 1.1903300476074219e+02 1.0120500183105469e+02 -3.3736199951171875e+02 1.2077300262451172e+02 9.5475502014160156e+01 -3.3853900146484375e+02 1.1903599548339844e+02 1.0119899749755859e+02 -3.3849298095703125e+02 1.1903499603271484e+02 1.0120099639892578e+02 -3.3849298095703125e+02 1.1903300476074219e+02 1.0120500183105469e+02 -3.3849298095703125e+02 1.1904499816894531e+02 1.0120899963378906e+02 -1.2223999786376953e+02 1.1904399871826172e+02 1.0120800018310547e+02 -1.2059000396728516e+02 1.1904299926757812e+02 1.0120800018310547e+02 -1.1976599884033203e+02 1.1904199981689453e+02 1.0120800018310547e+02 -1.1811699676513672e+02 1.1904100036621094e+02 1.0120700073242188e+02 -1.1729299926757812e+02 1.1904000091552734e+02 1.0120700073242188e+02 -1.1564399719238281e+02 1.1903900146484375e+02 1.0120700073242188e+02 -1.1481900024414062e+02 1.1903800201416016e+02 1.0120700073242188e+02 -1.1316999816894531e+02 1.1903700256347656e+02 1.0120599365234375e+02 -1.1234600067138672e+02 1.1903499603271484e+02 1.0120599365234375e+02 -1.1069699859619141e+02 1.1903499603271484e+02 1.0120599365234375e+02 -1.0987200164794922e+02 1.1903300476074219e+02 1.0120500183105469e+02 -1.0822399902343750e+02 1.1903200531005859e+02 1.0120500183105469e+02 -1.0739900207519531e+02 1.1903099822998047e+02 1.0120500183105469e+02 -1.0575000000000000e+02 1.1902999877929688e+02 1.0120400238037109e+02 -1.0492599487304688e+02 1.1902799987792969e+02 1.0120400238037109e+02 -1.0327700042724609e+02 1.1902700042724609e+02 1.0120400238037109e+02 -1.0245200347900391e+02 1.1902400207519531e+02 1.0120300292968750e+02 -9.9154998779296875e+01 1.1902199554443359e+02 1.0120200347900391e+02 -9.7506393432617188e+01 1.1901800537109375e+02 1.0120099639892578e+02 -9.4209297180175781e+01 1.1901599884033203e+02 1.0120099639892578e+02 -9.2560699462890625e+01 1.1901299285888672e+02 1.0119999694824219e+02 -8.9263900756835938e+01 1.1901100158691406e+02 1.0119899749755859e+02 -8.7615493774414062e+01 1.1903300476074219e+02 1.0120500183105469e+02 -3.3571301269531250e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.3241702270507812e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.3076901245117188e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.2747201538085938e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.2582400512695312e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.2252697753906250e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.2087899780273438e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.1758300781250000e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.1593399047851562e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.1263800048828125e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.1099002075195312e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.0769299316406250e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.0604498291015625e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.0274798583984375e+02 1.1903200531005859e+02 1.0120500183105469e+02 -3.0109997558593750e+02 1.1903300476074219e+02 1.0120500183105469e+02 -2.9780398559570312e+02 1.1903300476074219e+02 1.0120500183105469e+02 -2.9615499877929688e+02 1.1903300476074219e+02 1.0120500183105469e+02 -2.9285897827148438e+02 1.1903300476074219e+02 1.0120500183105469e+02 -2.9121099853515625e+02 1.1903300476074219e+02 1.0120500183105469e+02 -2.8791497802734375e+02 1.1903399658203125e+02 1.0120500183105469e+02 -2.8626599121093750e+02 1.1903399658203125e+02 1.0120599365234375e+02 -2.8297000122070312e+02 1.1903399658203125e+02 1.0120599365234375e+02 -2.8132199096679688e+02 1.1903499603271484e+02 1.0120599365234375e+02 -2.7802499389648438e+02 1.1903499603271484e+02 1.0120599365234375e+02 -2.7637698364257812e+02 1.1903499603271484e+02 1.0120599365234375e+02 -2.7308099365234375e+02 1.1903599548339844e+02 1.0120700073242188e+02 -2.7143298339843750e+02 1.1903599548339844e+02 1.0120700073242188e+02 -2.6813598632812500e+02 1.1903700256347656e+02 1.0120700073242188e+02 -2.6648797607421875e+02 1.1903700256347656e+02 1.0120700073242188e+02 -2.6319198608398438e+02 1.1903700256347656e+02 1.0120700073242188e+02 -2.6154299926757812e+02 1.1903800201416016e+02 1.0120800018310547e+02 -2.5824697875976562e+02 1.1903900146484375e+02 1.0120800018310547e+02 -2.5659899902343750e+02 1.1903900146484375e+02 1.0120800018310547e+02 -2.5330200195312500e+02 1.1904000091552734e+02 1.0120800018310547e+02 -2.5165399169921875e+02 1.1904100036621094e+02 1.0120800018310547e+02 -2.4835699462890625e+02 1.1904100036621094e+02 1.0120800018310547e+02 -2.4670899963378906e+02 1.1904199981689453e+02 1.0120800018310547e+02 -2.4341299438476562e+02 1.1904299926757812e+02 1.0120800018310547e+02 -2.4176399230957031e+02 1.1904299926757812e+02 1.0120800018310547e+02 -2.4011599731445312e+02 1.1904399871826172e+02 1.0120899963378906e+02 -2.3681999206542969e+02 1.1904499816894531e+02 1.0120899963378906e+02 -2.3517100524902344e+02 1.1904600524902344e+02 1.0120899963378906e+02 -2.3187500000000000e+02 1.1904600524902344e+02 1.0120899963378906e+02 -2.3022698974609375e+02 1.1904700469970703e+02 1.0120899963378906e+02 -2.2693000793457031e+02 1.1904799652099609e+02 1.0120899963378906e+02 -2.2528199768066406e+02 1.1904899597167969e+02 1.0120899963378906e+02 -2.2198500061035156e+02 1.1904899597167969e+02 1.0120999908447266e+02 -2.2033700561523438e+02 1.1905000305175781e+02 1.0120999908447266e+02 -2.1868800354003906e+02 1.1905000305175781e+02 1.0120999908447266e+02 -2.1786401367187500e+02 1.1905100250244141e+02 1.0120999908447266e+02 -2.1621600341796875e+02 1.1905100250244141e+02 1.0120999908447266e+02 -2.1539099121093750e+02 1.1905100250244141e+02 1.0120999908447266e+02 -2.1374299621582031e+02 1.1905200195312500e+02 1.0120999908447266e+02 -2.1291899108886719e+02 1.1905200195312500e+02 1.0121099853515625e+02 -2.1127000427246094e+02 1.1905200195312500e+02 1.0121099853515625e+02 -2.1044599914550781e+02 1.1905300140380859e+02 1.0121099853515625e+02 -2.0879800415039062e+02 1.1905300140380859e+02 1.0121099853515625e+02 -2.0797300720214844e+02 1.1905300140380859e+02 1.0121099853515625e+02 -2.0632499694824219e+02 1.1905400085449219e+02 1.0121099853515625e+02 -2.0550100708007812e+02 1.1905400085449219e+02 1.0121099853515625e+02 -2.0385200500488281e+02 1.1905400085449219e+02 1.0121099853515625e+02 -2.0302799987792969e+02 1.1905500030517578e+02 1.0121099853515625e+02 -2.0137899780273438e+02 1.1905500030517578e+02 1.0121099853515625e+02 -2.0055499267578125e+02 1.1905500030517578e+02 1.0121099853515625e+02 -1.9890699768066406e+02 1.1905599975585938e+02 1.0121099853515625e+02 -1.9808200073242188e+02 1.1905599975585938e+02 1.0121099853515625e+02 -1.9643400573730469e+02 1.1905599975585938e+02 1.0121099853515625e+02 -1.9561000061035156e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.9396099853515625e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.9313700866699219e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.9148799133300781e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.9066398620605469e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.8901499938964844e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.8819099426269531e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.8736700439453125e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.8571800231933594e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.8489399719238281e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.8324501037597656e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.8242100524902344e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.8077200317382812e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7994799804687500e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7829899597167969e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7747500610351562e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7582600402832031e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7500199890136719e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7335299682617188e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7252899169921875e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7088000488281250e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.7005599975585938e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6840699768066406e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6758300781250000e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6593399047851562e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6511000061035156e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6346099853515625e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6263699340820312e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6098800659179688e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.6016400146484375e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.5851499938964844e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.5769100952148438e+02 1.1905899810791016e+02 1.0121099853515625e+02 -1.5604199218750000e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.5521800231933594e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.5356900024414062e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.5274499511718750e+02 1.1905799865722656e+02 1.0121099853515625e+02 -1.5109600830078125e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.5027099609375000e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.4862300109863281e+02 1.1905699920654297e+02 1.0121099853515625e+02 -1.4779800415039062e+02 1.1905599975585938e+02 1.0121099853515625e+02 -1.4614999389648438e+02 1.1905599975585938e+02 1.0121099853515625e+02 -1.4532501220703125e+02 1.1905599975585938e+02 1.0121099853515625e+02 -1.4367599487304688e+02 1.1905500030517578e+02 1.0121099853515625e+02 -1.4285198974609375e+02 1.1905500030517578e+02 1.0121099853515625e+02 -1.4120300292968750e+02 1.1905400085449219e+02 1.0121099853515625e+02 -1.4037899780273438e+02 1.1905400085449219e+02 1.0121099853515625e+02 -1.3872900390625000e+02 1.1905300140380859e+02 1.0121099853515625e+02 -1.3790499877929688e+02 1.1905300140380859e+02 1.0121099853515625e+02 -1.3625599670410156e+02 1.1905200195312500e+02 1.0121099853515625e+02 -1.3543099975585938e+02 1.1905200195312500e+02 1.0121099853515625e+02 -1.3460699462890625e+02 1.1905100250244141e+02 1.0121099853515625e+02 -1.3295799255371094e+02 1.1905100250244141e+02 1.0120999908447266e+02 -1.3213301086425781e+02 1.1905000305175781e+02 1.0120999908447266e+02 -1.3048399353027344e+02 1.1904899597167969e+02 1.0120999908447266e+02 -1.2965998840332031e+02 1.1904799652099609e+02 1.0120999908447266e+02 -1.2801100158691406e+02 1.1904799652099609e+02 1.0120999908447266e+02 -1.2718599700927734e+02 1.1904700469970703e+02 1.0120899963378906e+02 -1.2553699493408203e+02 1.1904600524902344e+02 1.0120899963378906e+02 -1.2471300506591797e+02 1.1904499816894531e+02 1.0120899963378906e+02 -1.2306399536132812e+02 1.1900699615478516e+02 1.0119800567626953e+02 -8.4318801879882812e+01 1.1900500488281250e+02 1.0119800567626953e+02 -8.2670501708984375e+01 1.1900099945068359e+02 1.0119699859619141e+02 -7.9374000549316406e+01 1.1900000000000000e+02 1.0119599914550781e+02 -7.7725898742675781e+01 1.1899600219726562e+02 1.0119499969482422e+02 -7.4429603576660156e+01 1.1899399566650391e+02 1.0119499969482422e+02 -7.2781501770019531e+01 1.1899100494384766e+02 1.0119400024414062e+02 -6.9485504150390625e+01 1.1898899841308594e+02 1.0119400024414062e+02 -6.8246299743652344e+01 1.1898899841308594e+02 1.0119400024414062e+02 -6.7837600708007812e+01 1.1898600006103516e+02 1.0119300079345703e+02 -6.4541694641113281e+01 1.1898500061035156e+02 1.0119200134277344e+02 -6.3717796325683594e+01 1.1898400115966797e+02 1.0119200134277344e+02 -6.3511795043945312e+01 1.1898400115966797e+02 1.0119200134277344e+02 -6.3460296630859375e+01 1.1898099517822266e+02 1.0119100189208984e+02 -5.9579498291015625e+01 1.1897899627685547e+02 1.0119100189208984e+02 -5.7931697845458984e+01 1.1897700500488281e+02 1.0119000244140625e+02 -5.4636398315429688e+01 1.1897499847412109e+02 1.0119000244140625e+02 -5.2988800048828125e+01 1.1897299957275391e+02 1.0118900299072266e+02 -4.9693698883056641e+01 1.1897200012207031e+02 1.0118900299072266e+02 -4.8046199798583984e+01 1.1897000122070312e+02 1.0118799591064453e+02 -4.4751399993896484e+01 1.1896900177001953e+02 1.0118799591064453e+02 -4.3104000091552734e+01 1.1896699523925781e+02 1.0118799591064453e+02 -3.9809398651123047e+01 1.1896699523925781e+02 1.0118799591064453e+02 -3.8162101745605469e+01 1.1896599578857422e+02 1.0118699645996094e+02 -3.4867698669433594e+01 1.1896499633789062e+02 1.0118699645996094e+02 -3.3220600128173828e+01 1.1896499633789062e+02 1.0118699645996094e+02 -3.1573400497436523e+01 1.1896499633789062e+02 1.0118699645996094e+02 -2.8279399871826172e+01 1.1896499633789062e+02 1.0118699645996094e+02 -2.6632400512695312e+01 1.1896499633789062e+02 1.0118699645996094e+02 -2.3338598251342773e+01 1.1896599578857422e+02 1.0118699645996094e+02 -2.1691799163818359e+01 1.1896699523925781e+02 1.0118799591064453e+02 -1.8398300170898438e+01 1.1896699523925781e+02 1.0118799591064453e+02 -1.6751600265502930e+01 1.1896900177001953e+02 1.0118900299072266e+02 -1.3458199501037598e+01 1.1897000122070312e+02 1.0118900299072266e+02 -1.1811599731445312e+01 1.1897299957275391e+02 1.0119000244140625e+02 -8.5184097290039062e+00 1.1897499847412109e+02 1.0119000244140625e+02 -6.8717999458312988e+00 1.1897800445556641e+02 1.0119100189208984e+02 -3.5789098739624023e+00 1.1897999572753906e+02 1.0119200134277344e+02 -1.9323899745941162e+00 1.1898500061035156e+02 1.0119300079345703e+02 1.3604099750518799e+00 1.1898799896240234e+02 1.0119400024414062e+02 3.0068101882934570e+00 1.1899299621582031e+02 1.0119499969482422e+02 6.2995200157165527e+00 1.1899600219726562e+02 1.0119599914550781e+02 7.9459204673767090e+00 1.1900299835205078e+02 1.0119800567626953e+02 1.1238399505615234e+01 1.1900599670410156e+02 1.0119800567626953e+02 1.2884599685668945e+01 1.1901399993896484e+02 1.0119999694824219e+02 1.6176300048828125e+01 1.1901800537109375e+02 1.0120099639892578e+02 1.7821800231933594e+01 1.1902700042724609e+02 1.0120400238037109e+02 2.1113000869750977e+01 1.1903200531005859e+02 1.0120500183105469e+02 2.2758899688720703e+01 1.1904199981689453e+02 1.0120800018310547e+02 2.6050899505615234e+01 1.1904700469970703e+02 1.0120899963378906e+02 2.7697099685668945e+01 1.1905799865722656e+02 1.0121200561523438e+02 3.0989900588989258e+01 1.1906400299072266e+02 1.0121299743652344e+02 3.2636501312255859e+01 1.1907599639892578e+02 1.0121700286865234e+02 3.5930599212646484e+01 1.1908199310302734e+02 1.0121800231933594e+02 3.7578300476074219e+01 1.1909500122070312e+02 1.0122200012207031e+02 4.0874401092529297e+01 1.1910100555419922e+02 1.0122299957275391e+02 4.2522800445556641e+01 1.1911299896240234e+02 1.0122699737548828e+02 4.5820301055908203e+01 1.1911900329589844e+02 1.0122799682617188e+02 4.7469501495361328e+01 1.1913099670410156e+02 1.0123200225830078e+02 5.0768497467041016e+01 1.1913699340820312e+02 1.0123300170898438e+02 5.2418399810791016e+01 1.1914800262451172e+02 1.0123600006103516e+02 5.5718898773193359e+01 1.1915399932861328e+02 1.0123699951171875e+02 5.7369602203369141e+01 1.1916399383544922e+02 1.0123999786376953e+02 6.0671798706054688e+01 1.1916799926757812e+02 1.0124099731445312e+02 6.2323200225830078e+01 1.1917299652099609e+02 1.0124199676513672e+02 6.3974998474121094e+01 1.1918099975585938e+02 1.0124500274658203e+02 6.7279304504394531e+01 1.1918400573730469e+02 1.0124600219726562e+02 6.8931800842285156e+01 1.1918900299072266e+02 1.0124699401855469e+02 7.1978797912597656e+01 1.1919000244140625e+02 1.0124699401855469e+02 7.2237602233886719e+01 1.1919199371337891e+02 1.0124800109863281e+02 7.3890998840332031e+01 1.1919599914550781e+02 1.0124900054931641e+02 7.7198402404785156e+01 1.1919700622558594e+02 1.0124900054931641e+02 7.8852493286132812e+01 1.1919700622558594e+02 1.0124900054931641e+02 8.2161499023437500e+01 1.1919700622558594e+02 1.0124900054931641e+02 8.3816398620605469e+01 1.1919400024414062e+02 1.0124800109863281e+02 8.7126998901367188e+01 1.1919199371337891e+02 1.0124800109863281e+02 8.8782600402832031e+01 1.1918599700927734e+02 1.0124600219726562e+02 9.2094802856445312e+01 1.1918199920654297e+02 1.0124500274658203e+02 9.3751296997070312e+01 1.1917700195312500e+02 1.0124400329589844e+02 9.5408096313476562e+01 1.1917500305175781e+02 1.0124299621582031e+02 9.6236495971679688e+01 1.1916899871826172e+02 1.0124099731445312e+02 9.7893600463867188e+01 1.1916600036621094e+02 1.0124099731445312e+02 9.8722297668457031e+01 1.1915899658203125e+02 1.0123900604248047e+02 1.0038000488281250e+02 1.1915499877929688e+02 1.0123799896240234e+02 1.0120899963378906e+02 1.1914700317382812e+02 1.0123600006103516e+02 1.0286699676513672e+02 1.1914300537109375e+02 1.0123500061035156e+02 1.0369600677490234e+02 1.1912400054931641e+02 1.0122899627685547e+02 1.0701300048828125e+02 1.1912100219726562e+02 1.0122899627685547e+02 1.0735800170898438e+02 1.1911299896240234e+02 1.0122600555419922e+02 1.0867100524902344e+02 1.1910100555419922e+02 1.0122299957275391e+02 1.1033100128173828e+02 1.1909500122070312e+02 1.0122200012207031e+02 1.1116000366210938e+02 9.4681800842285156e+01 8.3387397766113281e+01 2.2218400573730469e+02 9.3769203186035156e+01 8.3419197082519531e+01 2.2273600769042969e+02 9.4752899169921875e+01 8.3384902954101562e+01 2.2214099121093750e+02 9.5381698608398438e+01 8.3362899780273438e+01 2.2137400817871094e+02 9.6553802490234375e+01 8.3322006225585938e+01 2.1931500244140625e+02 9.3737998962402344e+01 8.3420295715332031e+01 2.2274301147460938e+02 9.2644294738769531e+01 8.3458496093750000e+01 2.2296600341796875e+02 1.1526399993896484e+02 8.1331092834472656e+01 1.7925601196289062e+02 1.1476699829101562e+02 8.1401901245117188e+01 1.8078700256347656e+02 1.1743900299072266e+02 8.0964599609375000e+01 1.7094099426269531e+02 1.1701200103759766e+02 8.1051902770996094e+01 1.7301400756835938e+02 1.1653199768066406e+02 8.1150299072265625e+01 1.7534899902343750e+02 1.1594100189208984e+02 8.1234596252441406e+01 1.7716999816894531e+02 1.1449000549316406e+02 8.1434799194335938e+01 1.8145201110839844e+02 1.0976800537109375e+02 8.1996101379394531e+01 1.9279701232910156e+02 1.0834999847412109e+02 8.2164604187011719e+01 1.9620298767089844e+02 9.8540100097656250e+01 8.3190399169921875e+01 2.1575599670410156e+02 1.0363099670410156e+02 8.2674896240234375e+01 2.0608801269531250e+02 1.0465299987792969e+02 8.2564300537109375e+01 2.0394699096679688e+02 9.4147506713867188e+01 9.9897697448730469e+01 2.1300000000000000e+02 9.6261505126953125e+01 1.4893099975585938e+02 -3.3809500122070312e+02 8.7126899719238281e+01 1.6798800659179688e+02 -6.8284194946289062e+01 1.1540800476074219e+02 1.0880299377441406e+02 -3.3842999267578125e+02 1.0583499908447266e+02 1.2886700439453125e+02 -3.3826199340820312e+02 8.7194999694824219e+01 1.6798399353027344e+02 -1.5179100036621094e+02 8.7194602966308594e+01 1.6798399353027344e+02 -1.4968099975585938e+02 8.7191497802734375e+01 1.6798399353027344e+02 -2.0453298950195312e+02 8.7192001342773438e+01 1.6798399353027344e+02 -2.0242300415039062e+02 8.7186904907226562e+01 1.6798399353027344e+02 -2.2035600280761719e+02 8.7187500000000000e+01 1.6798399353027344e+02 -2.1824600219726562e+02 8.7186203002929688e+01 1.6798399353027344e+02 -2.2246499633789062e+02 8.7184196472167969e+01 1.6798399353027344e+02 -2.2879399108886719e+02 8.7184799194335938e+01 1.6798399353027344e+02 -2.2668499755859375e+02 8.7185501098632812e+01 1.6798399353027344e+02 -2.2457499694824219e+02 8.7179901123046875e+01 1.6798500061035156e+02 -2.4356199645996094e+02 8.7180503845214844e+01 1.6798500061035156e+02 -2.4145199584960938e+02 8.7180999755859375e+01 1.6798500061035156e+02 -2.3934300231933594e+02 8.7181701660156250e+01 1.6798399353027344e+02 -2.3723300170898438e+02 8.7177597045898438e+01 1.6798500061035156e+02 -2.5200000000000000e+02 8.7178199768066406e+01 1.6798500061035156e+02 -2.4989099121093750e+02 8.7179306030273438e+01 1.6798500061035156e+02 -2.4567199707031250e+02 8.7182296752929688e+01 1.6798399353027344e+02 -2.3512300109863281e+02 8.7183494567871094e+01 1.6798399353027344e+02 -2.3090399169921875e+02 8.7188499450683594e+01 1.6798399353027344e+02 -2.1508200073242188e+02 8.7188804626464844e+01 1.6798399353027344e+02 -2.1402700805664062e+02 8.7189102172851562e+01 1.6798399353027344e+02 -2.1297200012207031e+02 8.7189804077148438e+01 1.6798399353027344e+02 -2.1086199951171875e+02 8.7187904357910156e+01 1.6798399353027344e+02 -2.1719099426269531e+02 8.7188201904296875e+01 1.6798399353027344e+02 -2.1613598632812500e+02 8.7190704345703125e+01 1.6798399353027344e+02 -2.0769799804687500e+02 8.7190902709960938e+01 1.6798399353027344e+02 -2.0664300537109375e+02 8.7191200256347656e+01 1.6798399353027344e+02 -2.0558799743652344e+02 8.7190101623535156e+01 1.6798399353027344e+02 -2.0980699157714844e+02 8.7190399169921875e+01 1.6798399353027344e+02 -2.0875300598144531e+02 8.7192802429199219e+01 1.6798399353027344e+02 -1.9925900268554688e+02 8.7193000793457031e+01 1.6798399353027344e+02 -1.9820399475097656e+02 8.7193305969238281e+01 1.6798399353027344e+02 -1.9714898681640625e+02 8.7193695068359375e+01 1.6798399353027344e+02 -1.9504000854492188e+02 8.7192298889160156e+01 1.6798399353027344e+02 -2.0136900329589844e+02 8.7192604064941406e+01 1.6798399353027344e+02 -2.0031399536132812e+02 8.7194297790527344e+01 1.6798399353027344e+02 -1.9187500000000000e+02 8.7194503784179688e+01 1.6798399353027344e+02 -1.9081999206542969e+02 8.7194702148437500e+01 1.6798399353027344e+02 -1.8976499938964844e+02 8.7195098876953125e+01 1.6798399353027344e+02 -1.8765600585937500e+02 8.7193901062011719e+01 1.6798399353027344e+02 -1.9398500061035156e+02 8.7194099426269531e+01 1.6798399353027344e+02 -1.9292999267578125e+02 8.7195503234863281e+01 1.6798399353027344e+02 -1.8449099731445312e+02 8.7195701599121094e+01 1.6798399353027344e+02 -1.8343600463867188e+02 8.7195800781250000e+01 1.6798399353027344e+02 -1.8238200378417969e+02 8.7195999145507812e+01 1.6798399353027344e+02 -1.8027200317382812e+02 8.7195205688476562e+01 1.6798399353027344e+02 -1.8660099792480469e+02 8.7195396423339844e+01 1.6798399353027344e+02 -1.8554598999023438e+02 8.7196296691894531e+01 1.6798399353027344e+02 -1.7710700988769531e+02 8.7196403503417969e+01 1.6798399353027344e+02 -1.7605200195312500e+02 8.7196403503417969e+01 1.6798399353027344e+02 -1.7499800109863281e+02 8.7196502685546875e+01 1.6798399353027344e+02 -1.7288800048828125e+02 8.7196098327636719e+01 1.6798399353027344e+02 -1.7921699523925781e+02 8.7196197509765625e+01 1.6798399353027344e+02 -1.7816198730468750e+02 8.7196601867675781e+01 1.6798399353027344e+02 -1.6972300720214844e+02 8.7196601867675781e+01 1.6798399353027344e+02 -1.6866900634765625e+02 8.7196601867675781e+01 1.6798399353027344e+02 -1.6761399841308594e+02 8.7196502685546875e+01 1.6798399353027344e+02 -1.6550399780273438e+02 8.7196601867675781e+01 1.6798399353027344e+02 -1.7183299255371094e+02 8.7196601867675781e+01 1.6798399353027344e+02 -1.7077799987792969e+02 8.7196403503417969e+01 1.6798399353027344e+02 -1.6233900451660156e+02 8.7196296691894531e+01 1.6798399353027344e+02 -1.6128399658203125e+02 8.7196197509765625e+01 1.6798399353027344e+02 -1.6022999572753906e+02 8.7195999145507812e+01 1.6798399353027344e+02 -1.5812001037597656e+02 8.7196502685546875e+01 1.6798399353027344e+02 -1.6444900512695312e+02 8.7196403503417969e+01 1.6798399353027344e+02 -1.6339399719238281e+02 8.7195503234863281e+01 1.6798399353027344e+02 -1.5495500183105469e+02 8.7195396423339844e+01 1.6798399353027344e+02 -1.5389999389648438e+02 8.7195205688476562e+01 1.6798399353027344e+02 -1.5284599304199219e+02 8.7195800781250000e+01 1.6798399353027344e+02 -1.5706500244140625e+02 8.7195701599121094e+01 1.6798399353027344e+02 -1.5600999450683594e+02 8.7193801879882812e+01 1.6798399353027344e+02 -1.4651599121093750e+02 8.7193496704101562e+01 1.6798399353027344e+02 -1.4546200561523438e+02 8.7193199157714844e+01 1.6798399353027344e+02 -1.4440699768066406e+02 8.7192604064941406e+01 1.6798399353027344e+02 -1.4229699707031250e+02 8.7194297790527344e+01 1.6798399353027344e+02 -1.4862600708007812e+02 8.7194099426269531e+01 1.6798399353027344e+02 -1.4757099914550781e+02 8.7192298889160156e+01 1.6798399353027344e+02 -1.4124200439453125e+02 8.7191902160644531e+01 1.6798399353027344e+02 -1.4018699645996094e+02 8.7191497802734375e+01 1.6798399353027344e+02 -1.3913198852539062e+02 8.7191101074218750e+01 1.6798399353027344e+02 -1.3807701110839844e+02 8.7190704345703125e+01 1.6798399353027344e+02 -1.3702299499511719e+02 8.7189804077148438e+01 1.6798399353027344e+02 -1.3491299438476562e+02 8.7189300537109375e+01 1.6798399353027344e+02 -1.3385800170898438e+02 8.7188804626464844e+01 1.6798399353027344e+02 -1.3280299377441406e+02 8.7188201904296875e+01 1.6798399353027344e+02 -1.3174800109863281e+02 8.7187606811523438e+01 1.6798399353027344e+02 -1.3069300842285156e+02 8.7187095642089844e+01 1.6798399353027344e+02 -1.2963899230957031e+02 8.7185798645019531e+01 1.6798399353027344e+02 -1.2752899169921875e+02 8.7185195922851562e+01 1.6798399353027344e+02 -1.2647399139404297e+02 8.7184501647949219e+01 1.6798399353027344e+02 -1.2541900634765625e+02 8.7183799743652344e+01 1.6798399353027344e+02 -1.2436400604248047e+02 8.7183105468750000e+01 1.6798399353027344e+02 -1.2330899810791016e+02 8.7182403564453125e+01 1.6798399353027344e+02 -1.2225399780273438e+02 8.7180801391601562e+01 1.6798500061035156e+02 -1.2014400482177734e+02 8.7180000305175781e+01 1.6798500061035156e+02 -1.1908999633789062e+02 8.7179199218750000e+01 1.6798500061035156e+02 -1.1803500366210938e+02 8.7178398132324219e+01 1.6798500061035156e+02 -1.1698000335693359e+02 8.7177497863769531e+01 1.6798500061035156e+02 -1.1592499542236328e+02 8.7176597595214844e+01 1.6798500061035156e+02 -1.1486999511718750e+02 8.7174804687500000e+01 1.6798500061035156e+02 -1.1276000213623047e+02 8.7173904418945312e+01 1.6798500061035156e+02 -1.1170499420166016e+02 8.7172904968261719e+01 1.6798500061035156e+02 -1.1065100097656250e+02 8.7171897888183594e+01 1.6798500061035156e+02 -1.0959600067138672e+02 8.7170898437500000e+01 1.6798500061035156e+02 -1.0854100036621094e+02 8.7169898986816406e+01 1.6798500061035156e+02 -1.0748600006103516e+02 8.7167800903320312e+01 1.6798500061035156e+02 -1.0537599945068359e+02 8.7166801452636719e+01 1.6798500061035156e+02 -1.0432099914550781e+02 8.7165695190429688e+01 1.6798500061035156e+02 -1.0326699829101562e+02 8.7164604187011719e+01 1.6798600769042969e+02 -1.0221199798583984e+02 8.7162300109863281e+01 1.6798600769042969e+02 -1.0010199737548828e+02 8.7157699584960938e+01 1.6798600769042969e+02 -9.5882598876953125e+01 8.7155296325683594e+01 1.6798600769042969e+02 -9.3772903442382812e+01 8.7152999877929688e+01 1.6798600769042969e+02 -9.1663200378417969e+01 8.7150604248046875e+01 1.6798600769042969e+02 -8.9553604125976562e+01 8.7148193359375000e+01 1.6798699951171875e+02 -8.7443901062011719e+01 8.7145698547363281e+01 1.6798699951171875e+02 -8.5334304809570312e+01 8.7140899658203125e+01 1.6798699951171875e+02 -8.1114997863769531e+01 8.7138603210449219e+01 1.6798699951171875e+02 -7.9005302429199219e+01 8.7136199951171875e+01 1.6798699951171875e+02 -7.6895698547363281e+01 8.7133895874023438e+01 1.6798699951171875e+02 -7.4786094665527344e+01 8.7131599426269531e+01 1.6798800659179688e+02 -7.2676498413085938e+01 8.7129302978515625e+01 1.6798800659179688e+02 -7.0566902160644531e+01 8.7175598144531250e+01 1.6798500061035156e+02 -2.6043899536132812e+02 8.7176101684570312e+01 1.6798500061035156e+02 -2.5832901000976562e+02 9.5852096557617188e+01 1.4978900146484375e+02 -3.3819699096679688e+02 8.7176597595214844e+01 1.6798500061035156e+02 -2.5622000122070312e+02 8.7177101135253906e+01 1.6798500061035156e+02 -2.5411001586914062e+02 8.7172798156738281e+01 1.6798500061035156e+02 -2.7520599365234375e+02 8.7173095703125000e+01 1.6798500061035156e+02 -2.7309701538085938e+02 8.7173500061035156e+01 1.6798500061035156e+02 -2.7098699951171875e+02 8.7173904418945312e+01 1.6798500061035156e+02 -2.6887701416015625e+02 8.7169998168945312e+01 1.6798500061035156e+02 -3.0263098144531250e+02 8.7170104980468750e+01 1.6798500061035156e+02 -3.0052200317382812e+02 8.7170196533203125e+01 1.6798500061035156e+02 -2.9841198730468750e+02 8.7170799255371094e+01 1.6798500061035156e+02 -2.8997399902343750e+02 8.7171005249023438e+01 1.6798500061035156e+02 -2.8786401367187500e+02 8.7171302795410156e+01 1.6798500061035156e+02 -2.8575399780273438e+02 8.7171501159667969e+01 1.6798500061035156e+02 -2.8364498901367188e+02 8.7170303344726562e+01 1.6798500061035156e+02 -2.9630300903320312e+02 8.7170600891113281e+01 1.6798500061035156e+02 -2.9208300781250000e+02 8.7171798706054688e+01 1.6798500061035156e+02 -2.8153500366210938e+02 8.7172393798828125e+01 1.6798500061035156e+02 -2.7731600952148438e+02 8.7174293518066406e+01 1.6798500061035156e+02 -2.6676800537109375e+02 8.7175201416015625e+01 1.6798500061035156e+02 -2.6254800415039062e+02 8.7169807434082031e+01 1.6798500061035156e+02 -3.1950900268554688e+02 8.7169807434082031e+01 1.6798500061035156e+02 -3.1739898681640625e+02 9.5410697937011719e+01 1.5071398925781250e+02 -3.3860299682617188e+02 8.7169807434082031e+01 1.6798500061035156e+02 -3.1528900146484375e+02 8.7169807434082031e+01 1.6798500061035156e+02 -3.1317999267578125e+02 8.7169807434082031e+01 1.6798500061035156e+02 -3.1107000732421875e+02 8.7169898986816406e+01 1.6798500061035156e+02 -3.0685101318359375e+02 8.7169898986816406e+01 1.6798500061035156e+02 -3.0474099731445312e+02 9.5038894653320312e+01 1.5149400329589844e+02 -3.3933999633789062e+02 8.7170104980468750e+01 1.6798500061035156e+02 -3.3216598510742188e+02 8.7169998168945312e+01 1.6798500061035156e+02 -3.3005700683593750e+02 8.7169898986816406e+01 1.6798500061035156e+02 -3.2794699096679688e+02 8.7169898986816406e+01 1.6798500061035156e+02 -3.2583697509765625e+02 8.7169807434082031e+01 1.6798500061035156e+02 -3.2161798095703125e+02 8.7170104980468750e+01 1.6798500061035156e+02 -3.3427600097656250e+02 9.4782203674316406e+01 1.5203199768066406e+02 -3.4042599487304688e+02 8.7170196533203125e+01 1.6798500061035156e+02 -3.3638598632812500e+02 9.4699897766113281e+01 1.5220401000976562e+02 -3.4164498901367188e+02 8.7170494079589844e+01 1.6798500061035156e+02 -3.4060498046875000e+02 8.7170600891113281e+01 1.6798500061035156e+02 -3.4271499633789062e+02 9.4700096130371094e+01 1.5220401000976562e+02 -3.4530899047851562e+02 8.7170700073242188e+01 1.6798500061035156e+02 -3.4482397460937500e+02 8.7170799255371094e+01 1.6798500061035156e+02 -3.4693399047851562e+02 8.7105293273925781e+01 1.6798899841308594e+02 -4.1033397674560547e+01 8.7104400634765625e+01 1.6798899841308594e+02 -3.8923900604248047e+01 8.7122795104980469e+01 1.6798800659179688e+02 -6.4238197326660156e+01 8.7120697021484375e+01 1.6798800659179688e+02 -6.2128601074218750e+01 8.7118797302246094e+01 1.6798899841308594e+02 -6.0019001007080078e+01 8.7116897583007812e+01 1.6798899841308594e+02 -5.7909500122070312e+01 8.7115104675292969e+01 1.6798899841308594e+02 -5.5799900054931641e+01 8.7111694335937500e+01 1.6798899841308594e+02 -5.1580898284912109e+01 8.7110198974609375e+01 1.6798899841308594e+02 -4.9471401214599609e+01 8.7108795166015625e+01 1.6798899841308594e+02 -4.7361900329589844e+01 8.7107498168945312e+01 1.6798899841308594e+02 -4.5252403259277344e+01 8.7106300354003906e+01 1.6798899841308594e+02 -4.3142898559570312e+01 8.7124900817871094e+01 1.6798800659179688e+02 -6.6347702026367188e+01 1.1896400451660156e+02 1.0094400024414062e+02 1.2391299438476562e+02 8.7127502441406250e+01 1.6751000976562500e+02 1.2894000244140625e+02 8.7125305175781250e+01 1.6746600341796875e+02 1.2944699096679688e+02 8.7115898132324219e+01 1.6727499389648438e+02 1.3147500610351562e+02 1.1893299865722656e+02 1.0075599670410156e+02 1.2588499450683594e+02 8.7120697021484375e+01 1.6737399291992188e+02 1.3046101379394531e+02 8.7123001098632812e+01 1.6742100524902344e+02 1.2995399475097656e+02 8.7132797241210938e+01 1.6761000061035156e+02 1.2767100524902344e+02 8.7131797790527344e+01 1.6759100341796875e+02 1.2792499542236328e+02 1.1901499938964844e+02 1.0117199707031250e+02 1.1993999481201172e+02 8.7154899597167969e+01 1.6791099548339844e+02 1.2208099365234375e+02 8.7153900146484375e+01 1.6790199279785156e+02 1.2233499908447266e+02 8.7152900695800781e+01 1.6789300537109375e+02 1.2258999633789062e+02 8.7150901794433594e+01 1.6787300109863281e+02 1.2309799957275391e+02 8.7149902343750000e+01 1.6786199951171875e+02 1.2335199737548828e+02 8.7148895263671875e+01 1.6785099792480469e+02 1.2360700225830078e+02 8.7146903991699219e+01 1.6782798767089844e+02 1.2411499786376953e+02 8.7145904541015625e+01 1.6781500244140625e+02 1.2436900329589844e+02 8.7144897460937500e+01 1.6780200195312500e+02 1.2462300109863281e+02 8.7142898559570312e+01 1.6777500915527344e+02 1.2513199615478516e+02 8.7141899108886719e+01 1.6775999450683594e+02 1.2538600158691406e+02 8.7140899658203125e+01 1.6774600219726562e+02 1.2564000701904297e+02 8.7139900207519531e+01 1.6773001098632812e+02 1.2589399719238281e+02 8.7137901306152344e+01 1.6769799804687500e+02 1.2640200805664062e+02 8.7136901855468750e+01 1.6768099975585938e+02 1.2665599822998047e+02 8.7135902404785156e+01 1.6766400146484375e+02 1.2691000366210938e+02 8.7133804321289062e+01 1.6762800598144531e+02 1.2741799926757812e+02 8.7130706787109375e+01 1.6757099914550781e+02 1.2817900085449219e+02 8.7128601074218750e+01 1.6753100585937500e+02 1.2868598937988281e+02 8.7160102844238281e+01 1.6794699096679688e+02 1.2080900573730469e+02 8.7158004760742188e+01 1.6793400573730469e+02 1.2131800079345703e+02 8.7155899047851562e+01 1.6791899108886719e+02 1.2182699584960938e+02 8.7167800903320312e+01 1.6797700500488281e+02 1.1902899932861328e+02 8.7166694641113281e+01 1.6797499084472656e+02 1.1928299713134766e+02 1.1903499603271484e+02 1.0120599365234375e+02 1.1795999908447266e+02 8.7164398193359375e+01 1.6796701049804688e+02 1.1979199981689453e+02 8.7162300109863281e+01 1.6795800781250000e+02 1.2030100250244141e+02 8.7171302795410156e+01 1.6798300170898438e+02 1.1826599884033203e+02 8.7168998718261719e+01 1.6797999572753906e+02 1.1877500152587891e+02 8.7103096008300781e+01 1.6799000549316406e+02 -3.4705001831054688e+01 8.7102600097656250e+01 1.6799000549316406e+02 -3.2595500946044922e+01 8.7102401733398438e+01 1.6799000549316406e+02 -3.0486099243164062e+01 8.7102302551269531e+01 1.6799000549316406e+02 -2.8376699447631836e+01 8.7102302551269531e+01 1.6799000549316406e+02 -2.6267299652099609e+01 8.7102600097656250e+01 1.6799000549316406e+02 -2.4157800674438477e+01 8.7103698730468750e+01 1.6799000549316406e+02 -1.9938999176025391e+01 8.7104606628417969e+01 1.6798899841308594e+02 -1.7829601287841797e+01 8.7105598449707031e+01 1.6798899841308594e+02 -1.5720300674438477e+01 8.7107002258300781e+01 1.6798899841308594e+02 -1.3610899925231934e+01 8.7108497619628906e+01 1.6798899841308594e+02 -1.1501500129699707e+01 8.7110198974609375e+01 1.6798899841308594e+02 -9.3922100067138672e+00 8.7114494323730469e+01 1.6798899841308594e+02 -5.1734800338745117e+00 8.7116897583007812e+01 1.6798899841308594e+02 -3.0641000270843506e+00 8.7119697570800781e+01 1.6798899841308594e+02 -9.5478498935699463e-01 8.7122596740722656e+01 1.6798800659179688e+02 1.1545900106430054e+00 8.7125900268554688e+01 1.6798800659179688e+02 3.2639100551605225e+00 8.7129302978515625e+01 1.6798800659179688e+02 5.3731999397277832e+00 8.7137100219726562e+01 1.6798699951171875e+02 9.5918102264404297e+00 8.7141403198242188e+01 1.6798699951171875e+02 1.1701099395751953e+01 8.7145996093750000e+01 1.6798699951171875e+02 1.3810400009155273e+01 8.7150901794433594e+01 1.6798600769042969e+02 1.5919700622558594e+01 8.7156105041503906e+01 1.6798600769042969e+02 1.8028799057006836e+01 8.7161804199218750e+01 1.6798600769042969e+02 2.0138099670410156e+01 8.7174102783203125e+01 1.6798500061035156e+02 2.4356498718261719e+01 8.7180694580078125e+01 1.6798500061035156e+02 2.6465698242187500e+01 8.7187606811523438e+01 1.6798399353027344e+02 2.8574998855590820e+01 8.7194702148437500e+01 1.6798399353027344e+02 3.0684400558471680e+01 8.7202201843261719e+01 1.6798300170898438e+02 3.2793701171875000e+01 8.7209800720214844e+01 1.6798300170898438e+02 3.4903102874755859e+01 8.7225402832031250e+01 1.6798199462890625e+02 3.9122200012207031e+01 8.7233398437500000e+01 1.6798100280761719e+02 4.1231800079345703e+01 8.7241302490234375e+01 1.6798100280761719e+02 4.3341400146484375e+01 8.7249099731445312e+01 1.6797999572753906e+02 4.5451202392578125e+01 8.7256904602050781e+01 1.6797999572753906e+02 4.7561000823974609e+01 8.7264595031738281e+01 1.6797900390625000e+02 4.9670700073242188e+01 8.7279403686523438e+01 1.6797799682617188e+02 5.3890602111816406e+01 8.7286499023437500e+01 1.6797799682617188e+02 5.6000499725341797e+01 8.7293197631835938e+01 1.6797700500488281e+02 5.8110599517822266e+01 8.7299598693847656e+01 1.6797700500488281e+02 6.0220699310302734e+01 8.7305595397949219e+01 1.6797601318359375e+02 6.2330802917480469e+01 8.7311203002929688e+01 1.6797601318359375e+02 6.4441001892089844e+01 8.7316299438476562e+01 1.6797601318359375e+02 6.6551300048828125e+01 8.7324905395507812e+01 1.6797499084472656e+02 7.0772003173828125e+01 8.7327003479003906e+01 1.6797499084472656e+02 7.2036598205566406e+01 8.7328300476074219e+01 1.6797499084472656e+02 7.2882400512695312e+01 8.7331100463867188e+01 1.6797499084472656e+02 7.4992904663085938e+01 8.7333099365234375e+01 1.6797499084472656e+02 7.7103500366210938e+01 8.7334403991699219e+01 1.6797499084472656e+02 7.9214103698730469e+01 8.7334899902343750e+01 1.6797499084472656e+02 8.1324699401855469e+01 8.7333404541015625e+01 1.6797499084472656e+02 8.5546203613281250e+01 8.7331199645996094e+01 1.6797499084472656e+02 8.7657104492187500e+01 8.7328102111816406e+01 1.6797499084472656e+02 8.9767997741699219e+01 8.7323997497558594e+01 1.6797499084472656e+02 9.1878898620605469e+01 8.7318801879882812e+01 1.6797601318359375e+02 9.3989898681640625e+01 8.7315795898437500e+01 1.6797601318359375e+02 9.5045402526855469e+01 8.7312500000000000e+01 1.6797601318359375e+02 9.6100997924804688e+01 8.7305000305175781e+01 1.6797601318359375e+02 9.8212005615234375e+01 8.7300796508789062e+01 1.6797700500488281e+02 9.9267601013183594e+01 8.7296302795410156e+01 1.6797700500488281e+02 1.0032299804687500e+02 8.7291503906250000e+01 1.6797700500488281e+02 1.0137899780273438e+02 8.7286399841308594e+01 1.6797799682617188e+02 1.0243399810791016e+02 8.7275199890136719e+01 1.6797799682617188e+02 1.0454600524902344e+02 8.7262695312500000e+01 1.6797900390625000e+02 1.0665699768066406e+02 8.7259597778320312e+01 1.6797900390625000e+02 1.0712400054931641e+02 8.7248802185058594e+01 1.6797999572753906e+02 1.0876799774169922e+02 8.7241302490234375e+01 1.6798100280761719e+02 1.0982400512695312e+02 8.7225196838378906e+01 1.6798199462890625e+02 1.1193600463867188e+02 8.7207603454589844e+01 1.6798300170898438e+02 1.1404699707031250e+02 8.7190795898437500e+01 1.6798399353027344e+02 1.1589700317382812e+02 8.7188400268554688e+01 1.6798399353027344e+02 1.1615899658203125e+02 8.7178298950195312e+01 1.6798500061035156e+02 1.1721400451660156e+02 8.7175598144531250e+01 1.6798500061035156e+02 1.1747899627685547e+02 8.7174896240234375e+01 1.6798500061035156e+02 1.1754599761962891e+02 8.7174697875976562e+01 1.6798500061035156e+02 1.1756400299072266e+02 8.7174697875976562e+01 1.6798500061035156e+02 1.1756900024414062e+02 8.7174598693847656e+01 1.6798500061035156e+02 1.1756999969482422e+02 8.7174598693847656e+01 1.6798500061035156e+02 1.1757199859619141e+02 8.7174598693847656e+01 1.6798500061035156e+02 1.1757299804687500e+02 8.6972099304199219e+01 1.6472099304199219e+02 1.4756600952148438e+02 1.1876200103759766e+02 9.9563003540039062e+01 1.3365599060058594e+02 8.6979393005371094e+01 1.6482701110839844e+02 1.4706799316406250e+02 8.6993301391601562e+01 1.6503498840332031e+02 1.4607000732421875e+02 8.6948699951171875e+01 1.6439299011230469e+02 1.4905899047851562e+02 1.1869599914550781e+02 9.9099998474121094e+01 1.3579400634765625e+02 8.6956802368164062e+01 1.6450401306152344e+02 1.4856199645996094e+02 8.6964500427246094e+01 1.6461299133300781e+02 1.4806399536132812e+02 8.7024200439453125e+01 1.6552400207519531e+02 1.4357000732421875e+02 8.7018493652343750e+01 1.6542900085449219e+02 1.4406999206542969e+02 1.1881200408935547e+02 9.9921798706054688e+01 1.3173199462890625e+02 8.7029800415039062e+01 1.6561700439453125e+02 1.4306900024414062e+02 8.7012496948242188e+01 1.6533300781250000e+02 1.4457099914550781e+02 8.7006301879882812e+01 1.6523500061035156e+02 1.4507099914550781e+02 8.6999900817871094e+01 1.6513600158691406e+02 1.4556999206542969e+02 8.7050201416015625e+01 1.6597099304199219e+02 1.4106201171875000e+02 8.7045402526855469e+01 1.6588499450683594e+02 1.4156399536132812e+02 8.7040405273437500e+01 1.6579798889160156e+02 1.4206600952148438e+02 8.7083305358886719e+01 1.6659800720214844e+02 1.3703599548339844e+02 8.7079696655273438e+01 1.6652600097656250e+02 1.3753999328613281e+02 1.1889699554443359e+02 1.0052099609375000e+02 1.2784600067138672e+02 8.7075897216796875e+01 1.6645201110839844e+02 1.3804400634765625e+02 8.7071998596191406e+01 1.6637599182128906e+02 1.3854699707031250e+02 8.7068000793457031e+01 1.6629899597167969e+02 1.3905101013183594e+02 8.7059402465820312e+01 1.6613800048828125e+02 1.4005699157714844e+02 8.7054901123046875e+01 1.6605599975585938e+02 1.4055999755859375e+02 8.7102600097656250e+01 1.6699400329589844e+02 1.3400599670410156e+02 8.7099594116210938e+01 1.6693299865722656e+02 1.3451098632812500e+02 1.1893000030517578e+02 1.0073600006103516e+02 1.2604799652099609e+02 8.7108200073242188e+01 1.6711199951171875e+02 1.3299400329589844e+02 8.7113403320312500e+01 1.6722200012207031e+02 1.3198199462890625e+02 8.7110801696777344e+01 1.6716799926757812e+02 1.3248799133300781e+02 8.7109603881835938e+01 1.6714199829101562e+02 1.3271800231933594e+02 8.7096603393554688e+01 1.6686900329589844e+02 1.3501599121093750e+02 8.7093505859375000e+01 1.6680400085449219e+02 1.3552099609375000e+02 8.7086799621582031e+01 1.6666899108886719e+02 1.3653099060058594e+02 1.1833499908447266e+02 9.6721900939941406e+01 1.4491300964355469e+02 8.6619895935058594e+01 1.6082099914550781e+02 1.6234399414062500e+02 8.6602798461914062e+01 1.6066900634765625e+02 1.6283000183105469e+02 8.6699501037597656e+01 1.6156401062011719e+02 1.5990600585937500e+02 8.6684303283691406e+01 1.6141799926757812e+02 1.6039399719238281e+02 1.1850299835205078e+02 9.7786796569824219e+01 1.4121400451660156e+02 8.6714294433593750e+01 1.6170799255371094e+02 1.5941700744628906e+02 8.6756500244140625e+01 1.6213198852539062e+02 1.5794799804687500e+02 8.6742805480957031e+01 1.6199200439453125e+02 1.5843800354003906e+02 8.6728698730468750e+01 1.6185000610351562e+02 1.5892800903320312e+02 8.6668800354003906e+01 1.6127101135253906e+02 1.6088198852539062e+02 8.6652801513671875e+01 1.6112298583984375e+02 1.6136999511718750e+02 8.6636497497558594e+01 1.6097299194335938e+02 1.6185699462890625e+02 8.6819900512695312e+01 1.6280900573730469e+02 1.5549099731445312e+02 8.6807899475097656e+01 1.6267700195312500e+02 1.5598300170898438e+02 1.1857700347900391e+02 9.8277999877929688e+01 1.3934400939941406e+02 8.6831596374511719e+01 1.6294000244140625e+02 1.5499900817871094e+02 8.6795501708984375e+01 1.6254299926757812e+02 1.5647499084472656e+02 8.6782905578613281e+01 1.6240699768066406e+02 1.5696600341796875e+02 8.6769798278808594e+01 1.6226998901367188e+02 1.5745700073242188e+02 8.6885398864746094e+01 1.6357299804687500e+02 1.5252999877929688e+02 8.6875198364257812e+01 1.6344900512695312e+02 1.5302499389648438e+02 1.1864499664306641e+02 9.8738998413085938e+01 1.3746101379394531e+02 8.6864799499511719e+01 1.6332400512695312e+02 1.5351899719238281e+02 8.6854003906250000e+01 1.6319799804687500e+02 1.5401300048828125e+02 8.6843002319335938e+01 1.6306999206542969e+02 1.5450599670410156e+02 8.6941802978515625e+01 1.6429899597167969e+02 1.4947700500488281e+02 8.6940498352050781e+01 1.6428099060058594e+02 1.4955599975585938e+02 8.6932006835937500e+01 1.6416700744628906e+02 1.5005299377441406e+02 8.6923194885253906e+01 1.6405099487304688e+02 1.5054899597167969e+02 8.6914100646972656e+01 1.6393400573730469e+02 1.5104499816894531e+02 8.6904800415039062e+01 1.6381500244140625e+02 1.5153999328613281e+02 8.5161796569824219e+01 1.5156300354003906e+02 1.8632000732421875e+02 8.5118301391601562e+01 1.5135099792480469e+02 1.8678300476074219e+02 1.1705799865722656e+02 9.0109802246093750e+01 1.6271301269531250e+02 8.5074096679687500e+01 1.5113798522949219e+02 1.8724400329589844e+02 8.5029197692871094e+01 1.5092399597167969e+02 1.8770599365234375e+02 8.5006599426269531e+01 1.5081599426269531e+02 1.8793701171875000e+02 8.4960700988769531e+01 1.5060099792480469e+02 1.8839700317382812e+02 1.1696700286865234e+02 8.9712600708007812e+01 1.6362098693847656e+02 1.1722000122070312e+02 9.0849304199218750e+01 1.6097999572753906e+02 8.5349502563476562e+01 1.5250399780273438e+02 1.8423300170898438e+02 8.5308898925781250e+01 1.5229701232910156e+02 1.8469799804687500e+02 8.5267700195312500e+01 1.5208799743652344e+02 1.8516198730468750e+02 8.5225799560546875e+01 1.5187899780273438e+02 1.8562600708007812e+02 8.5183303833007812e+01 1.5166799926757812e+02 1.8608898925781250e+02 8.5505500793457031e+01 1.5332398986816406e+02 1.8237001037597656e+02 8.5486503601074219e+01 1.5322200012207031e+02 1.8260299682617188e+02 1.1752200317382812e+02 9.2282798767089844e+01 1.5748399353027344e+02 8.5542900085449219e+01 1.5352598571777344e+02 1.8190299987792969e+02 8.5669197082519531e+01 1.5422599792480469e+02 1.8026399230957031e+02 8.5651596069335938e+01 1.5412699890136719e+02 1.8049900817871094e+02 8.5615997314453125e+01 1.5392799377441406e+02 1.8096701049804688e+02 8.5579704284667969e+01 1.5372698974609375e+02 1.8143499755859375e+02 8.5448104858398438e+01 1.5301800537109375e+02 1.8307000732421875e+02 8.5409095764160156e+01 1.5281399536132812e+02 1.8353498840332031e+02 8.5369499206542969e+01 1.5260800170898438e+02 1.8400099182128906e+02 8.5853401184082031e+01 1.5529798889160156e+02 1.7767800903320312e+02 8.5837402343750000e+01 1.5520199584960938e+02 1.7791398620605469e+02 1.1766099548339844e+02 9.2974899291992188e+01 1.5572200012207031e+02 8.5804901123046875e+01 1.5500900268554688e+02 1.7838500976562500e+02 8.5771797180175781e+01 1.5481500244140625e+02 1.7885499572753906e+02 8.5738197326660156e+01 1.5462001037597656e+02 1.7932499694824219e+02 8.5704002380371094e+01 1.5442300415039062e+02 1.7979499816894531e+02 8.6132896423339844e+01 1.5706999206542969e+02 1.7317500305175781e+02 8.6105697631835938e+01 1.5688800048828125e+02 1.7365100097656250e+02 1.1791499328613281e+02 9.4305702209472656e+01 1.5216400146484375e+02 8.6078002929687500e+01 1.5670600891113281e+02 1.7412699890136719e+02 8.6049804687500000e+01 1.5652200317382812e+02 1.7460200500488281e+02 8.6035499572753906e+01 1.5642898559570312e+02 1.7483900451660156e+02 8.6006500244140625e+01 1.5624398803710938e+02 1.7531298828125000e+02 8.5977005004882812e+01 1.5605700683593750e+02 1.7578700256347656e+02 8.5946899414062500e+01 1.5586900329589844e+02 1.7626098632812500e+02 8.5916305541992188e+01 1.5568000793457031e+02 1.7673399353027344e+02 8.5885101318359375e+01 1.5548999023437500e+02 1.7720599365234375e+02 8.6297302246093750e+01 1.5821998596191406e+02 1.7007000732421875e+02 8.6273399353027344e+01 1.5804701232910156e+02 1.7054901123046875e+02 1.1803100585937500e+02 9.4942298889160156e+01 1.5036900329589844e+02 8.6248893737792969e+01 1.5787200927734375e+02 1.7102700805664062e+02 8.6236495971679688e+01 1.5778399658203125e+02 1.7126600646972656e+02 8.6211395263671875e+01 1.5760700988769531e+02 1.7174400329589844e+02 8.6185699462890625e+01 1.5742900085449219e+02 1.7222200012207031e+02 8.6159599304199219e+01 1.5725000000000000e+02 1.7269900512695312e+02 8.6410003662109375e+01 1.5906900024414062e+02 1.6766799926757812e+02 8.6388404846191406e+01 1.5890200805664062e+02 1.6814898681640625e+02 1.1824099731445312e+02 9.6151901245117188e+01 1.4674299621582031e+02 8.6472198486328125e+01 1.5956300354003906e+02 1.6622099304199219e+02 8.6451904296875000e+01 1.5939999389648438e+02 1.6670300292968750e+02 8.6431198120117188e+01 1.5923500061035156e+02 1.6718600463867188e+02 8.6366302490234375e+01 1.5873300170898438e+02 1.6863000488281250e+02 8.6343803405761719e+01 1.5856300354003906e+02 1.6911000061035156e+02 8.6320800781250000e+01 1.5839199829101562e+02 1.6958999633789062e+02 8.6585403442382812e+01 1.6051499938964844e+02 1.6331500244140625e+02 8.6567497253417969e+01 1.6036000061035156e+02 1.6380099487304688e+02 1.1831700134277344e+02 9.6612800598144531e+01 1.4526399230957031e+02 8.6554298400878906e+01 1.6024600219726562e+02 1.6415299987792969e+02 8.6549293518066406e+01 1.6020298767089844e+02 1.6428599548339844e+02 8.6530601501464844e+01 1.6004499816894531e+02 1.6477000427246094e+02 8.6511596679687500e+01 1.5988600158691406e+02 1.6525399780273438e+02 8.6492095947265625e+01 1.5972499084472656e+02 1.6573800659179688e+02 8.1960098266601562e+01 1.3964399719238281e+02 2.0925700378417969e+02 8.1917198181152344e+01 1.3951799011230469e+02 2.0947499084472656e+02 8.1830703735351562e+01 1.3926400756835938e+02 2.0991101074218750e+02 8.1787101745605469e+01 1.3913699340820312e+02 2.1012899780273438e+02 8.2572700500488281e+01 1.4152400207519531e+02 2.0596800231933594e+02 8.2494201660156250e+01 1.4127500915527344e+02 2.0640798950195312e+02 1.1495600128173828e+02 8.2035202026367188e+01 1.7957901000976562e+02 8.2454696655273438e+01 1.4115100097656250e+02 2.0662799072265625e+02 8.2374702453613281e+01 1.4090199279785156e+02 2.0706799316406250e+02 8.2293693542480469e+01 1.4065100097656250e+02 2.0750700378417969e+02 8.2252899169921875e+01 1.4052600097656250e+02 2.0772599792480469e+02 8.2170501708984375e+01 1.4027499389648438e+02 2.0816400146484375e+02 8.2128898620605469e+01 1.4014900207519531e+02 2.0838299560546875e+02 8.2044998168945312e+01 1.3989700317382812e+02 2.0882000732421875e+02 8.2877197265625000e+01 1.4250999450683594e+02 2.0420199584960938e+02 8.2802497863769531e+01 1.4226499938964844e+02 2.0464399719238281e+02 1.1520700073242188e+02 8.2890304565429688e+01 1.7792700195312500e+02 8.2764793395996094e+01 1.4214199829101562e+02 2.0486499023437500e+02 8.2688697814941406e+01 1.4189498901367188e+02 2.0530700683593750e+02 8.2611595153808594e+01 1.4164799499511719e+02 2.0574800109863281e+02 8.3166900634765625e+01 1.4348500061035156e+02 2.0242700195312500e+02 8.3095794677734375e+01 1.4324200439453125e+02 2.0287199401855469e+02 1.1568000030517578e+02 8.4571693420410156e+01 1.7460200500488281e+02 8.3374801635742188e+01 1.4420799255371094e+02 2.0109100341796875e+02 8.3340698242187500e+01 1.4408799743652344e+02 2.0131399536132812e+02 8.3442398071289062e+01 1.4444700622558594e+02 2.0064399719238281e+02 8.3271804809570312e+01 1.4384700012207031e+02 2.0175999450683594e+02 8.3202102661132812e+01 1.4360600280761719e+02 2.0220500183105469e+02 8.3059898376464844e+01 1.4312001037597656e+02 2.0309400939941406e+02 8.2987503051757812e+01 1.4287699890136719e+02 2.0353700256347656e+02 8.2914199829101562e+01 1.4263198852539062e+02 2.0397999572753906e+02 8.3703895568847656e+01 1.4539801025390625e+02 1.9885299682617188e+02 8.3672004699707031e+01 1.4527999877929688e+02 1.9907798767089844e+02 1.1590299987792969e+02 8.5397499084472656e+01 1.7292800903320312e+02 8.3767196655273438e+01 1.4563299560546875e+02 1.9840399169921875e+02 8.3607398986816406e+01 1.4504299926757812e+02 1.9952600097656250e+02 8.3541999816894531e+01 1.4480499267578125e+02 1.9997399902343750e+02 8.3508995056152344e+01 1.4468600463867188e+02 2.0019699096679688e+02 8.4271804809570312e+01 1.4760301208496094e+02 1.9456700134277344e+02 8.4215400695800781e+01 1.4737400817871094e+02 1.9502000427246094e+02 1.1632200622558594e+02 8.7016799926757812e+01 1.6955599975585938e+02 8.4158302307128906e+01 1.4714500427246094e+02 1.9547300720214844e+02 8.4129402160644531e+01 1.4702999877929688e+02 1.9569900512695312e+02 8.4071098327636719e+01 1.4679899597167969e+02 1.9615100097656250e+02 8.4011894226074219e+01 1.4656799316406250e+02 1.9660299682617188e+02 8.3951896667480469e+01 1.4633500671386719e+02 1.9705400085449219e+02 8.3921592712402344e+01 1.4621899414062500e+02 1.9727900695800781e+02 8.3860504150390625e+01 1.4598500061035156e+02 1.9772900390625000e+02 8.3829597473144531e+01 1.4586799621582031e+02 1.9795399475097656e+02 8.4436401367187500e+01 1.4828300476074219e+02 1.9320300292968750e+02 1.1651899719238281e+02 8.7809097290039062e+01 1.6785800170898438e+02 8.4489700317382812e+01 1.4850799560546875e+02 1.9274800109863281e+02 8.4542404174804688e+01 1.4873300170898438e+02 1.9229200744628906e+02 8.4409500122070312e+01 1.4817098999023438e+02 1.9343099975585938e+02 8.4354995727539062e+01 1.4794400024414062e+02 1.9388600158691406e+02 8.4299697875976562e+01 1.4771699523925781e+02 1.9434001159667969e+02 8.4914100646972656e+01 1.5038500976562500e+02 1.8885700988769531e+02 8.4887802124023438e+01 1.5026399230957031e+02 1.8911199951171875e+02 1.1688700103759766e+02 8.9356101989746094e+01 1.6443699645996094e+02 8.4866798400878906e+01 1.5016700744628906e+02 1.8931700134277344e+02 8.4842895507812500e+01 1.5005799865722656e+02 1.8954600524902344e+02 8.4794601440429688e+01 1.4983999633789062e+02 1.9000500488281250e+02 8.4745597839355469e+01 1.4961999511718750e+02 1.9046400451660156e+02 8.4720794677734375e+01 1.4950999450683594e+02 1.9069300842285156e+02 8.4670700073242188e+01 1.4928900146484375e+02 1.9114999389648438e+02 8.4619903564453125e+01 1.4906700134277344e+02 1.9160699462890625e+02 8.4568405151367188e+01 1.4884400939941406e+02 1.9206399536132812e+02 8.1336402893066406e+01 1.3785700988769531e+02 2.1229901123046875e+02 8.1289794921875000e+01 1.3772801208496094e+02 2.1251599121093750e+02 8.1428604125976562e+01 1.3811399841308594e+02 2.1186601257324219e+02 8.1776199340820312e+01 1.3910501098632812e+02 2.1018299865722656e+02 8.1699104309082031e+01 1.3888200378417969e+02 2.1056399536132812e+02 8.1654602050781250e+01 1.3875399780273438e+02 2.1078099060058594e+02 8.1565093994140625e+01 1.3849900817871094e+02 2.1121600341796875e+02 8.1474403381347656e+01 1.3824200439453125e+02 2.1164999389648438e+02 8.1004699707031250e+01 1.3695100402832031e+02 2.1380999755859375e+02 8.1100906372070312e+01 1.3721099853515625e+02 2.1337899780273438e+02 8.1195899963378906e+01 1.3747000122070312e+02 2.1294799804687500e+02 8.0956298828125000e+01 1.3682099914550781e+02 2.1402600097656250e+02 8.0525100708007812e+01 1.3519700622558594e+02 2.1626100158691406e+02 8.0418403625488281e+01 1.3448500061035156e+02 2.1702900695800781e+02 8.0325500488281250e+01 1.3198800659179688e+02 2.1902999877929688e+02 8.0310600280761719e+01 1.3158599853515625e+02 2.1935099792480469e+02 8.0631095886230469e+01 1.2837100219726562e+02 2.2088900756835938e+02 8.0746894836425781e+01 1.2768700408935547e+02 2.2111000061035156e+02 8.0768898010253906e+01 1.2752200317382812e+02 2.2117500305175781e+02 8.0761405944824219e+01 1.2751199340820312e+02 2.2119400024414062e+02 8.0753997802734375e+01 1.2750299072265625e+02 2.2121398925781250e+02 8.0799499511718750e+01 1.2727600097656250e+02 2.2126600646972656e+02 8.1176597595214844e+01 1.2547799682617188e+02 2.2163499450683594e+02 8.1857101440429688e+01 1.2308100128173828e+02 2.2179600524902344e+02 8.3997398376464844e+01 1.1658900451660156e+02 2.2173300170898438e+02 8.6011703491210938e+01 1.1048000335693359e+02 2.2167300415039062e+02 9.1451698303222656e+01 9.4736297607421875e+01 2.2150000000000000e+02 8.3590003967285156e+01 1.0965000152587891e+02 2.2328199768066406e+02 7.9418395996093750e+01 1.2226599884033203e+02 2.2342799377441406e+02 7.2875198364257812e+01 1.2245899963378906e+02 2.2365699768066406e+02 6.8196403503417969e+01 1.2259300231933594e+02 2.2382000732421875e+02 8.1250305175781250e+01 1.2287400054931641e+02 2.2263899230957031e+02 8.5405700683593750e+01 1.1026699829101562e+02 2.2250500488281250e+02 8.4564094543457031e+01 1.0997799682617188e+02 2.2306401062011719e+02 8.0402206420898438e+01 1.2258999633789062e+02 2.2320700073242188e+02 8.0073501586914062e+01 1.2758399200439453e+02 2.2192401123046875e+02 7.8332000732421875e+01 1.2750999450683594e+02 2.2273699951171875e+02 7.8428497314453125e+01 1.2752400207519531e+02 2.2272700500488281e+02 7.9058700561523438e+01 1.2759700775146484e+02 2.2258399963378906e+02 7.9262702941894531e+01 1.2758399200439453e+02 2.2242399597167969e+02 7.9722206115722656e+01 1.2761600494384766e+02 2.2224299621582031e+02 7.9723503112792969e+01 1.2761600494384766e+02 2.2225700378417969e+02 7.9769996643066406e+01 1.2761899566650391e+02 2.2224000549316406e+02 7.9889793395996094e+01 1.2763200378417969e+02 2.2215199279785156e+02 7.9728294372558594e+01 1.2762300872802734e+02 2.2222299194335938e+02 7.9727996826171875e+01 1.2762300872802734e+02 2.2222399902343750e+02 7.8687500000000000e+01 1.2756100463867188e+02 2.2268499755859375e+02 7.9902900695800781e+01 1.3787300109863281e+02 2.1442599487304688e+02 8.0334098815917969e+01 1.3759100341796875e+02 2.1435198974609375e+02 8.0382698059082031e+01 1.3772100830078125e+02 2.1413700866699219e+02 8.4944297790527344e+01 1.6965499877929688e+02 1.1754199981689453e+02 8.4676498413085938e+01 1.6968600463867188e+02 1.1753900146484375e+02 8.4673004150390625e+01 1.6968399047851562e+02 1.1826200103759766e+02 8.6560005187988281e+01 1.6883799743652344e+02 1.1826699829101562e+02 8.6511100769042969e+01 1.6879600524902344e+02 1.1756400299072266e+02 8.6270805358886719e+01 1.6908999633789062e+02 1.1756099700927734e+02 8.6142395019531250e+01 1.6914500427246094e+02 1.1755899810791016e+02 8.5691802978515625e+01 1.6942900085449219e+02 1.1826599884033203e+02 8.5661003112792969e+01 1.6934999084472656e+02 1.1755199432373047e+02 8.4670700073242188e+01 1.6968099975585938e+02 1.1877799987792969e+02 8.5689498901367188e+01 1.6942500305175781e+02 1.1877999877929688e+02 8.4669593811035156e+01 1.6967800903320312e+02 1.1903499603271484e+02 8.5688301086425781e+01 1.6942300415039062e+02 1.1903700256347656e+02 8.4668395996093750e+01 1.6967498779296875e+02 1.1929299926757812e+02 8.5687194824218750e+01 1.6941999816894531e+02 1.1929499816894531e+02 8.4666198730468750e+01 1.6966799926757812e+02 1.1980899810791016e+02 8.5684997558593750e+01 1.6941200256347656e+02 1.1980899810791016e+02 8.4664001464843750e+01 1.6965899658203125e+02 1.2032399749755859e+02 8.5682800292968750e+01 1.6940299987792969e+02 1.2032300567626953e+02 8.4661903381347656e+01 1.6964698791503906e+02 1.2083899688720703e+02 8.5680702209472656e+01 1.6939199829101562e+02 1.2083700561523438e+02 8.4659896850585938e+01 1.6963400268554688e+02 1.2135499572753906e+02 8.5678596496582031e+01 1.6937899780273438e+02 1.2135200500488281e+02 8.4657806396484375e+01 1.6961898803710938e+02 1.2187000274658203e+02 8.5676498413085938e+01 1.6936300659179688e+02 1.2186600494384766e+02 8.4656799316406250e+01 1.6961100769042969e+02 1.2212699890136719e+02 8.5675498962402344e+01 1.6935501098632812e+02 1.2212300109863281e+02 8.4655799865722656e+01 1.6960200500488281e+02 1.2238500213623047e+02 8.5674499511718750e+01 1.6934600830078125e+02 1.2238000488281250e+02 8.4654800415039062e+01 1.6959300231933594e+02 1.2264200592041016e+02 8.5673500061035156e+01 1.6933700561523438e+02 1.2263700103759766e+02 8.4652793884277344e+01 1.6957299804687500e+02 1.2315700531005859e+02 8.5671501159667969e+01 1.6931700134277344e+02 1.2315099334716797e+02 8.4651901245117188e+01 1.6956199645996094e+02 1.2341500091552734e+02 8.5670600891113281e+01 1.6930699157714844e+02 1.2340799713134766e+02 8.4650894165039062e+01 1.6955099487304688e+02 1.2367200469970703e+02 8.5669601440429688e+01 1.6929499816894531e+02 1.2366500091552734e+02 8.4648902893066406e+01 1.6952699279785156e+02 1.2418699645996094e+02 8.5667602539062500e+01 1.6927101135253906e+02 1.2417900085449219e+02 8.4647903442382812e+01 1.6951499938964844e+02 1.2444400024414062e+02 8.5666595458984375e+01 1.6925900268554688e+02 1.2443599700927734e+02 8.4647003173828125e+01 1.6950100708007812e+02 1.2470199584960938e+02 8.5665702819824219e+01 1.6924600219726562e+02 1.2469200134277344e+02 8.4645004272460938e+01 1.6947399902343750e+02 1.2521600341796875e+02 8.5663696289062500e+01 1.6921800231933594e+02 1.2520599365234375e+02 8.4644104003906250e+01 1.6945899963378906e+02 1.2547299194335938e+02 8.5662696838378906e+01 1.6920399475097656e+02 1.2546299743652344e+02 8.4643104553222656e+01 1.6944400024414062e+02 1.2572999572753906e+02 8.5661705017089844e+01 1.6918901062011719e+02 1.2571899414062500e+02 8.4642097473144531e+01 1.6942900085449219e+02 1.2598800659179688e+02 8.5660705566406250e+01 1.6917300415039062e+02 1.2597599792480469e+02 8.4640197753906250e+01 1.6939599609375000e+02 1.2650200653076172e+02 8.5658805847167969e+01 1.6914099121093750e+02 1.2648899841308594e+02 8.4639198303222656e+01 1.6937899780273438e+02 1.2675899505615234e+02 8.5657798767089844e+01 1.6912400817871094e+02 1.2674600219726562e+02 8.4638198852539062e+01 1.6936199951171875e+02 1.2701599121093750e+02 8.5656799316406250e+01 1.6910600280761719e+02 1.2700299835205078e+02 8.4636199951171875e+01 1.6932600402832031e+02 1.2752999114990234e+02 8.5654800415039062e+01 1.6907000732421875e+02 1.2751599884033203e+02 8.4635200500488281e+01 1.6930699157714844e+02 1.2778699493408203e+02 8.5653793334960938e+01 1.6905101013183594e+02 1.2777200317382812e+02 8.4634201049804688e+01 1.6928799438476562e+02 1.2804399108886719e+02 8.5652702331542969e+01 1.6903199768066406e+02 1.2802900695800781e+02 8.4633201599121094e+01 1.6926799011230469e+02 1.2830000305175781e+02 8.5651702880859375e+01 1.6901300048828125e+02 1.2828500366210938e+02 8.4631103515625000e+01 1.6922700500488281e+02 1.2881399536132812e+02 8.5649604797363281e+01 1.6897200012207031e+02 1.2879699707031250e+02 8.4629997253417969e+01 1.6920599365234375e+02 1.2907099914550781e+02 8.5648597717285156e+01 1.6895001220703125e+02 1.2905400085449219e+02 8.4627899169921875e+01 1.6916200256347656e+02 1.2958399963378906e+02 8.5646400451660156e+01 1.6890699768066406e+02 1.2956599426269531e+02 8.4625701904296875e+01 1.6911601257324219e+02 1.3009700012207031e+02 8.5644203186035156e+01 1.6886100769042969e+02 1.3007800292968750e+02 8.4623397827148438e+01 1.6906900024414062e+02 1.3061000061035156e+02 8.5641899108886719e+01 1.6881401062011719e+02 1.3059001159667969e+02 8.4618797302246094e+01 1.6896800231933594e+02 1.3163499450683594e+02 8.5637199401855469e+01 1.6871299743652344e+02 1.3161399841308594e+02 8.4616302490234375e+01 1.6891500854492188e+02 1.3214700317382812e+02 8.5634704589843750e+01 1.6866000366210938e+02 1.3212500000000000e+02 8.4615203857421875e+01 1.6888999938964844e+02 1.3238301086425781e+02 8.5632194519042969e+01 1.6860600280761719e+02 1.3263699340820312e+02 8.6557701110839844e+01 1.6883399963378906e+02 1.1877900695800781e+02 8.6556503295898438e+01 1.6883200073242188e+02 1.1903499603271484e+02 8.6555397033691406e+01 1.6882899475097656e+02 1.1929100036621094e+02 8.6553199768066406e+01 1.6882101440429688e+02 1.1980299377441406e+02 8.6551002502441406e+01 1.6881201171875000e+02 1.2031500244140625e+02 8.6548904418945312e+01 1.6880099487304688e+02 1.2082699584960938e+02 8.6546798706054688e+01 1.6878799438476562e+02 1.2133900451660156e+02 8.6544700622558594e+01 1.6877299499511719e+02 1.2185099792480469e+02 8.6543701171875000e+01 1.6876399230957031e+02 1.2210700225830078e+02 8.6542701721191406e+01 1.6875599670410156e+02 1.2236299896240234e+02 8.6541694641113281e+01 1.6874600219726562e+02 1.2261900329589844e+02 8.6539703369140625e+01 1.6872698974609375e+02 1.2313000488281250e+02 8.6538703918457031e+01 1.6871600341796875e+02 1.2338600158691406e+02 8.6537696838378906e+01 1.6870500183105469e+02 1.2364199829101562e+02 8.6535697937011719e+01 1.6868099975585938e+02 1.2415399932861328e+02 8.6534698486328125e+01 1.6866799926757812e+02 1.2440899658203125e+02 8.6533706665039062e+01 1.6865499877929688e+02 1.2466500091552734e+02 8.6531799316406250e+01 1.6862800598144531e+02 1.2517699432373047e+02 8.6530799865722656e+01 1.6861300659179688e+02 1.2543199920654297e+02 8.6529800415039062e+01 1.6859799194335938e+02 1.2568800354003906e+02 8.6528800964355469e+01 1.6858300781250000e+02 1.2594400024414062e+02 8.6526802062988281e+01 1.6855099487304688e+02 1.2645499420166016e+02 8.6525794982910156e+01 1.6853399658203125e+02 1.2670999908447266e+02 8.6524803161621094e+01 1.6851699829101562e+02 1.2696600341796875e+02 8.6522804260253906e+01 1.6847999572753906e+02 1.2747700500488281e+02 8.6521697998046875e+01 1.6846199035644531e+02 1.2773199462890625e+02 8.6520698547363281e+01 1.6844299316406250e+02 1.2798699951171875e+02 8.6519706726074219e+01 1.6842300415039062e+02 1.2824299621582031e+02 8.6517494201660156e+01 1.6838200378417969e+02 1.2875300598144531e+02 8.6516502380371094e+01 1.6836099243164062e+02 1.2900799560546875e+02 8.6514305114746094e+01 1.6831700134277344e+02 1.2951899719238281e+02 8.6512001037597656e+01 1.6827200317382812e+02 1.3002899169921875e+02 8.6509803771972656e+01 1.6822500610351562e+02 1.3053900146484375e+02 8.6505004882812500e+01 1.6812500000000000e+02 1.3155799865722656e+02 8.6502502441406250e+01 1.6807200622558594e+02 1.3206799316406250e+02 8.6500000000000000e+01 1.6801699829101562e+02 1.3257699584960938e+02 8.6497299194335938e+01 1.6796099853515625e+02 1.3308599853515625e+02 8.6491798400878906e+01 1.6784300231933594e+02 1.3410400390625000e+02 8.6488899230957031e+01 1.6778099060058594e+02 1.3461199951171875e+02 8.6485900878906250e+01 1.6771699523925781e+02 1.3512001037597656e+02 8.6482704162597656e+01 1.6765100097656250e+02 1.3562800598144531e+02 8.6476104736328125e+01 1.6751499938964844e+02 1.3664300537109375e+02 8.6472694396972656e+01 1.6744400024414062e+02 1.3715100097656250e+02 8.6469001770019531e+01 1.6737200927734375e+02 1.3765800476074219e+02 8.6465301513671875e+01 1.6729701232910156e+02 1.3816400146484375e+02 8.6461402893066406e+01 1.6722099304199219e+02 1.3867098999023438e+02 8.6457405090332031e+01 1.6714300537109375e+02 1.3917700195312500e+02 8.6448898315429688e+01 1.6698199462890625e+02 1.4018901062011719e+02 8.6444396972656250e+01 1.6689900207519531e+02 1.4069400024414062e+02 8.6439697265625000e+01 1.6681399536132812e+02 1.4119898986816406e+02 8.6434898376464844e+01 1.6672801208496094e+02 1.4170399475097656e+02 8.6429901123046875e+01 1.6663900756835938e+02 1.4220799255371094e+02 8.6419403076171875e+01 1.6645799255371094e+02 1.4321600341796875e+02 8.6413803100585938e+01 1.6636399841308594e+02 1.4372000122070312e+02 8.6408103942871094e+01 1.6626899719238281e+02 1.4422300720214844e+02 8.6402099609375000e+01 1.6617298889160156e+02 1.4472599792480469e+02 8.6395896911621094e+01 1.6607398986816406e+02 1.4522900390625000e+02 8.6389602661132812e+01 1.6597399902343750e+02 1.4573100280761719e+02 8.6383003234863281e+01 1.6587199401855469e+02 1.4623300170898438e+02 8.6369094848632812e+01 1.6566400146484375e+02 1.4723500061035156e+02 8.6361801147460938e+01 1.6555799865722656e+02 1.4773599243164062e+02 8.6354202270507812e+01 1.6544898986816406e+02 1.4823699951171875e+02 8.6346496582031250e+01 1.6533898925781250e+02 1.4873699951171875e+02 8.6338500976562500e+01 1.6522799682617188e+02 1.4923699951171875e+02 8.4613800048828125e+01 1.6886100769042969e+02 1.3265899658203125e+02 8.4611297607421875e+01 1.6880400085449219e+02 1.3317100524902344e+02 8.5629600524902344e+01 1.6854899597167969e+02 1.3314799499511719e+02 8.4605903625488281e+01 1.6868499755859375e+02 1.3419400024414062e+02 8.5624099731445312e+01 1.6843000793457031e+02 1.3416899108886719e+02 8.4602996826171875e+01 1.6862300109863281e+02 1.3470500183105469e+02 8.5621200561523438e+01 1.6836799621582031e+02 1.3467900085449219e+02 8.4599998474121094e+01 1.6855900573730469e+02 1.3521600341796875e+02 8.5618194580078125e+01 1.6830400085449219e+02 1.3518899536132812e+02 8.4597000122070312e+01 1.6849299621582031e+02 1.3572599792480469e+02 8.5615097045898438e+01 1.6823899841308594e+02 1.3569900512695312e+02 8.4590499877929688e+01 1.6835600280761719e+02 1.3674600219726562e+02 8.5608604431152344e+01 1.6810198974609375e+02 1.3671800231933594e+02 8.4587097167968750e+01 1.6828500366210938e+02 1.3725599670410156e+02 8.5605194091796875e+01 1.6803100585937500e+02 1.3722700500488281e+02 8.4583496093750000e+01 1.6821199035644531e+02 1.3776600646972656e+02 8.5601600646972656e+01 1.6795800781250000e+02 1.3773599243164062e+02 8.4579902648925781e+01 1.6813800048828125e+02 1.3827499389648438e+02 8.5597900390625000e+01 1.6788299560546875e+02 1.3824499511718750e+02 8.4576004028320312e+01 1.6806100463867188e+02 1.3878401184082031e+02 8.5594001770019531e+01 1.6780699157714844e+02 1.3875299072265625e+02 8.4572097778320312e+01 1.6798300170898438e+02 1.3929200744628906e+02 8.5589996337890625e+01 1.6772801208496094e+02 1.3926100158691406e+02 8.4563705444335938e+01 1.6782099914550781e+02 1.4030799865722656e+02 8.5581604003906250e+01 1.6756700134277344e+02 1.4027600097656250e+02 8.4559295654296875e+01 1.6773800659179688e+02 1.4081600952148438e+02 8.5577194213867188e+01 1.6748399353027344e+02 1.4078298950195312e+02 8.4554702758789062e+01 1.6765299987792969e+02 1.4132299804687500e+02 8.5572502136230469e+01 1.6739801025390625e+02 1.4128999328613281e+02 8.4549896240234375e+01 1.6756599426269531e+02 1.4183000183105469e+02 8.5567802429199219e+01 1.6731199645996094e+02 1.4179598999023438e+02 8.4544998168945312e+01 1.6747698974609375e+02 1.4233699035644531e+02 8.5562698364257812e+01 1.6722300720214844e+02 1.4230300903320312e+02 8.4534599304199219e+01 1.6729499816894531e+02 1.4334901428222656e+02 8.5552299499511719e+01 1.6704100036621094e+02 1.4331401062011719e+02 8.4529098510742188e+01 1.6720100402832031e+02 1.4385501098632812e+02 8.5546798706054688e+01 1.6694700622558594e+02 1.4381900024414062e+02 8.4523399353027344e+01 1.6710600280761719e+02 1.4436000061035156e+02 8.5541000366210938e+01 1.6685198974609375e+02 1.4432400512695312e+02 8.4517501831054688e+01 1.6700900268554688e+02 1.4486500549316406e+02 8.5535102844238281e+01 1.6675500488281250e+02 1.4482800292968750e+02 8.4511398315429688e+01 1.6690998840332031e+02 1.4537001037597656e+02 8.5528900146484375e+01 1.6665600585937500e+02 1.4533200073242188e+02 8.4505104064941406e+01 1.6681001281738281e+02 1.4587399291992188e+02 8.5522598266601562e+01 1.6655599975585938e+02 1.4583599853515625e+02 8.4498596191406250e+01 1.6670799255371094e+02 1.4637799072265625e+02 8.5516105651855469e+01 1.6645399475097656e+02 1.4633999633789062e+02 8.4484893798828125e+01 1.6649900817871094e+02 1.4738400268554688e+02 8.5502197265625000e+01 1.6624499511718750e+02 1.4734500122070312e+02 8.4477600097656250e+01 1.6639199829101562e+02 1.4788700866699219e+02 8.5495002746582031e+01 1.6613800048828125e+02 1.4784799194335938e+02 8.4470199584960938e+01 1.6628298950195312e+02 1.4838899230957031e+02 8.5487503051757812e+01 1.6602999877929688e+02 1.4835000610351562e+02 8.4462501525878906e+01 1.6617298889160156e+02 1.4889100646972656e+02 8.5479698181152344e+01 1.6591900634765625e+02 1.4885101318359375e+02 8.4454605102539062e+01 1.6606100463867188e+02 1.4939300537109375e+02 8.5471694946289062e+01 1.6580801391601562e+02 1.4935200500488281e+02 8.4446403503417969e+01 1.6594799804687500e+02 1.4989399719238281e+02 8.5463500976562500e+01 1.6569400024414062e+02 1.4985301208496094e+02 8.4445793151855469e+01 1.6594099426269531e+02 1.4992601013183594e+02 8.5455001831054688e+01 1.6557901000976562e+02 1.5035400390625000e+02 8.6330200195312500e+01 1.6511500549316406e+02 1.4973600769042969e+02 8.6321693420410156e+01 1.6500000000000000e+02 1.5023500061035156e+02 8.6312896728515625e+01 1.6488400268554688e+02 1.5073300170898438e+02 8.6303894042968750e+01 1.6476599121093750e+02 1.5123200988769531e+02 8.6294601440429688e+01 1.6464700317382812e+02 1.5172900390625000e+02 8.6275199890136719e+01 1.6440299987792969e+02 1.5272399902343750e+02 8.6264999389648438e+01 1.6427999877929688e+02 1.5322099304199219e+02 8.6254501342773438e+01 1.6415399169921875e+02 1.5371699523925781e+02 8.6243797302246094e+01 1.6402700805664062e+02 1.5421299743652344e+02 8.6232696533203125e+01 1.6389801025390625e+02 1.5470799255371094e+02 8.6221397399902344e+01 1.6376799011230469e+02 1.5520300292968750e+02 8.6209701538085938e+01 1.6363699340820312e+02 1.5569799804687500e+02 8.6197601318359375e+01 1.6350300598144531e+02 1.5619200134277344e+02 8.6185295104980469e+01 1.6336900329589844e+02 1.5668598937988281e+02 8.6172599792480469e+01 1.6323300170898438e+02 1.5717900085449219e+02 8.6159599304199219e+01 1.6309500122070312e+02 1.5767199707031250e+02 8.6146194458007812e+01 1.6295599365234375e+02 1.5816499328613281e+02 8.6132499694824219e+01 1.6281600952148438e+02 1.5865699768066406e+02 8.6118400573730469e+01 1.6267399597167969e+02 1.5914900207519531e+02 8.6103904724121094e+01 1.6252999877929688e+02 1.5963999938964844e+02 8.6089096069335938e+01 1.6238600158691406e+02 1.6013101196289062e+02 8.6073898315429688e+01 1.6223899841308594e+02 1.6062100219726562e+02 8.6058403015136719e+01 1.6209199523925781e+02 1.6111099243164062e+02 8.6042503356933594e+01 1.6194300842285156e+02 1.6159999084472656e+02 8.6026100158691406e+01 1.6179199218750000e+02 1.6208900451660156e+02 8.6009399414062500e+01 1.6163999938964844e+02 1.6257800292968750e+02 8.5992401123046875e+01 1.6148699951171875e+02 1.6306599426269531e+02 8.5974899291992188e+01 1.6133299255371094e+02 1.6355400085449219e+02 8.5957000732421875e+01 1.6117700195312500e+02 1.6404100036621094e+02 8.4437896728515625e+01 1.6583299255371094e+02 1.5039399719238281e+02 8.4429199218750000e+01 1.6571600341796875e+02 1.5089500427246094e+02 8.5446296691894531e+01 1.6546299743652344e+02 1.5085299682617188e+02 8.4420303344726562e+01 1.6559800720214844e+02 1.5139498901367188e+02 8.5437301635742188e+01 1.6534500122070312e+02 1.5135299682617188e+02 8.4411102294921875e+01 1.6547900390625000e+02 1.5189399719238281e+02 8.5428001403808594e+01 1.6522500610351562e+02 1.5185198974609375e+02 8.4391799926757812e+01 1.6523500061035156e+02 1.5289199829101562e+02 8.5408699035644531e+01 1.6498098754882812e+02 1.5285000610351562e+02 8.4381698608398438e+01 1.6511000061035156e+02 1.5338999938964844e+02 8.5398506164550781e+01 1.6485699462890625e+02 1.5334799194335938e+02 8.4371299743652344e+01 1.6498400878906250e+02 1.5388800048828125e+02 8.5388099670410156e+01 1.6473100280761719e+02 1.5384500122070312e+02 8.4360595703125000e+01 1.6485699462890625e+02 1.5438499450683594e+02 8.5377403259277344e+01 1.6460299682617188e+02 1.5434199523925781e+02 8.4349700927734375e+01 1.6472799682617188e+02 1.5488200378417969e+02 8.5366302490234375e+01 1.6447499084472656e+02 1.5483898925781250e+02 8.4338302612304688e+01 1.6459800720214844e+02 1.5537800598144531e+02 8.5354995727539062e+01 1.6434399414062500e+02 1.5533499145507812e+02 8.4326805114746094e+01 1.6446598815917969e+02 1.5587399291992188e+02 8.5343299865722656e+01 1.6421200561523438e+02 1.5583099365234375e+02 8.4314804077148438e+01 1.6433200073242188e+02 1.5636999511718750e+02 8.5331405639648438e+01 1.6407899475097656e+02 1.5632598876953125e+02 8.4302497863769531e+01 1.6419699096679688e+02 1.5686500549316406e+02 8.5319000244140625e+01 1.6394400024414062e+02 1.5682199096679688e+02 8.4289901733398438e+01 1.6406098937988281e+02 1.5736000061035156e+02 8.5306396484375000e+01 1.6380700683593750e+02 1.5731599426269531e+02 8.4276992797851562e+01 1.6392298889160156e+02 1.5785400390625000e+02 8.5293395996093750e+01 1.6366900634765625e+02 1.5780999755859375e+02 8.4263694763183594e+01 1.6378399658203125e+02 1.5834799194335938e+02 8.5279998779296875e+01 1.6353001403808594e+02 1.5830400085449219e+02 8.4250099182128906e+01 1.6364300537109375e+02 1.5884100341796875e+02 8.5266296386718750e+01 1.6338899230957031e+02 1.5879699707031250e+02 8.4236099243164062e+01 1.6350099182128906e+02 1.5933399963378906e+02 8.5252296447753906e+01 1.6324700927734375e+02 1.5928999328613281e+02 8.4221694946289062e+01 1.6335700988769531e+02 1.5982598876953125e+02 8.5237800598144531e+01 1.6310400390625000e+02 1.5978201293945312e+02 8.4207000732421875e+01 1.6321200561523438e+02 1.6031800842285156e+02 8.5223098754882812e+01 1.6295799255371094e+02 1.6027400207519531e+02 8.4191802978515625e+01 1.6306599426269531e+02 1.6080899047851562e+02 8.5207901000976562e+01 1.6281199645996094e+02 1.6076501464843750e+02 8.4176399230957031e+01 1.6291799926757812e+02 1.6130000305175781e+02 8.5192398071289062e+01 1.6266400146484375e+02 1.6125599670410156e+02 8.4160499572753906e+01 1.6276899719238281e+02 1.6179100036621094e+02 8.5176399230957031e+01 1.6251499938964844e+02 1.6174699401855469e+02 8.4144302368164062e+01 1.6261799621582031e+02 1.6228100585937500e+02 8.5160202026367188e+01 1.6236401367187500e+02 1.6223699951171875e+02 8.4127700805664062e+01 1.6246600341796875e+02 1.6277000427246094e+02 8.5143501281738281e+01 1.6221200561523438e+02 1.6272599792480469e+02 8.4110702514648438e+01 1.6231199645996094e+02 1.6325900268554688e+02 8.5126403808593750e+01 1.6205799865722656e+02 1.6321499633789062e+02 8.4093299865722656e+01 1.6215800476074219e+02 1.6374800109863281e+02 8.5109001159667969e+01 1.6190400695800781e+02 1.6370399475097656e+02 8.4075500488281250e+01 1.6200099182128906e+02 1.6423599243164062e+02 8.5091201782226562e+01 1.6174699401855469e+02 1.6419200134277344e+02 8.4057304382324219e+01 1.6184399414062500e+02 1.6472299194335938e+02 8.5072898864746094e+01 1.6158999633789062e+02 1.6468000793457031e+02 8.4038696289062500e+01 1.6168499755859375e+02 1.6521101379394531e+02 8.5054298400878906e+01 1.6143099975585938e+02 1.6516700744628906e+02 8.4019805908203125e+01 1.6152499389648438e+02 1.6569699096679688e+02 8.5035194396972656e+01 1.6126998901367188e+02 1.6565299987792969e+02 8.4000297546386719e+01 1.6136300659179688e+02 1.6618299865722656e+02 8.5015800476074219e+01 1.6110899353027344e+02 1.6613999938964844e+02 8.3980499267578125e+01 1.6120100402832031e+02 1.6666899108886719e+02 8.4995796203613281e+01 1.6094599914550781e+02 1.6662500000000000e+02 8.3960304260253906e+01 1.6103599548339844e+02 1.6715399169921875e+02 8.4975502014160156e+01 1.6078199768066406e+02 1.6711099243164062e+02 8.3955398559570312e+01 1.6099700927734375e+02 1.6726901245117188e+02 8.4954795837402344e+01 1.6061599731445312e+02 1.6759500122070312e+02 8.3939598083496094e+01 1.6087100219726562e+02 1.6763800048828125e+02 8.3918495178222656e+01 1.6070399475097656e+02 1.6812199401855469e+02 8.4933601379394531e+01 1.6044999694824219e+02 1.6807901000976562e+02 8.3896896362304688e+01 1.6053601074218750e+02 1.6860600280761719e+02 8.4911895751953125e+01 1.6028100585937500e+02 1.6856298828125000e+02 8.3874900817871094e+01 1.6036700439453125e+02 1.6908900451660156e+02 8.4889900207519531e+01 1.6011199951171875e+02 1.6904600524902344e+02 8.3852401733398438e+01 1.6019599914550781e+02 1.6957199096679688e+02 8.4867301940917969e+01 1.5994100952148438e+02 1.6952900695800781e+02 8.3829406738281250e+01 1.6002499389648438e+02 1.7005400085449219e+02 8.4844299316406250e+01 1.5976899719238281e+02 1.7001100158691406e+02 8.3805999755859375e+01 1.5985099792480469e+02 1.7053500366210938e+02 8.4820800781250000e+01 1.5959599304199219e+02 1.7049301147460938e+02 8.3782096862792969e+01 1.5967700195312500e+02 1.7101599121093750e+02 8.4796798706054688e+01 1.5942199707031250e+02 1.7097500610351562e+02 8.3757698059082031e+01 1.5950199890136719e+02 1.7149700927734375e+02 8.4772399902343750e+01 1.5924600219726562e+02 1.7145500183105469e+02 8.3745399475097656e+01 1.5941299438476562e+02 1.7173699951171875e+02 8.4759895324707031e+01 1.5915800476074219e+02 1.7169499206542969e+02 8.3720199584960938e+01 1.5923599243164062e+02 1.7221600341796875e+02 8.4734794616699219e+01 1.5897999572753906e+02 1.7217500305175781e+02 8.3694602966308594e+01 1.5905700683593750e+02 1.7269599914550781e+02 8.4709098815917969e+01 1.5880101013183594e+02 1.7265499877929688e+02 8.3668502807617188e+01 1.5887800598144531e+02 1.7317399597167969e+02 8.4682899475097656e+01 1.5862199401855469e+02 1.7313400268554688e+02 8.3641899108886719e+01 1.5869699096679688e+02 1.7365199279785156e+02 8.4656204223632812e+01 1.5843998718261719e+02 1.7361199951171875e+02 8.3614700317382812e+01 1.5851399230957031e+02 1.7412998962402344e+02 8.4628997802734375e+01 1.5825801086425781e+02 1.7409100341796875e+02 8.3587104797363281e+01 1.5833100891113281e+02 1.7460699462890625e+02 8.4601203918457031e+01 1.5807400512695312e+02 1.7456799316406250e+02 8.3558998107910156e+01 1.5814700317382812e+02 1.7508399963378906e+02 8.4572998046875000e+01 1.5788999938964844e+02 1.7504499816894531e+02 8.3544700622558594e+01 1.5805400085449219e+02 1.7532199096679688e+02 8.4558601379394531e+01 1.5779699707031250e+02 1.7528300476074219e+02 8.3515701293945312e+01 1.5786700439453125e+02 1.7579800415039062e+02 8.4529602050781250e+01 1.5761099243164062e+02 1.7575900268554688e+02 8.3486198425292969e+01 1.5768000793457031e+02 1.7627301025390625e+02 8.4500099182128906e+01 1.5742300415039062e+02 1.7623500061035156e+02 8.3456199645996094e+01 1.5749099731445312e+02 1.7674798583984375e+02 8.4469902038574219e+01 1.5723399353027344e+02 1.7670999145507812e+02 8.3425598144531250e+01 1.5730200195312500e+02 1.7722200012207031e+02 8.4439300537109375e+01 1.5704399108886719e+02 1.7718499755859375e+02 8.3394500732421875e+01 1.5711100769042969e+02 1.7769599914550781e+02 8.4408096313476562e+01 1.5685301208496094e+02 1.7765901184082031e+02 8.3362899780273438e+01 1.5691900634765625e+02 1.7816899108886719e+02 8.4376296997070312e+01 1.5666101074218750e+02 1.7813299560546875e+02 8.3346801757812500e+01 1.5682299804687500e+02 1.7840499877929688e+02 8.4360198974609375e+01 1.5656500244140625e+02 1.7836900329589844e+02 8.3314300537109375e+01 1.5662899780273438e+02 1.7887799072265625e+02 8.4327697753906250e+01 1.5637100219726562e+02 1.7884199523925781e+02 8.3281303405761719e+01 1.5643400573730469e+02 1.7935000610351562e+02 8.4294494628906250e+01 1.5617599487304688e+02 1.7931399536132812e+02 8.3247695922851562e+01 1.5623800659179688e+02 1.7982099914550781e+02 8.4260902404785156e+01 1.5598001098632812e+02 1.7978599548339844e+02 8.3213500976562500e+01 1.5604100036621094e+02 1.8029199218750000e+02 8.4226600646972656e+01 1.5578300476074219e+02 1.8025698852539062e+02 8.3178802490234375e+01 1.5584300231933594e+02 1.8076199340820312e+02 8.4191802978515625e+01 1.5558399963378906e+02 1.8072799682617188e+02 8.3161193847656250e+01 1.5574400329589844e+02 1.8099699401855469e+02 8.4174095153808594e+01 1.5548500061035156e+02 1.8096299743652344e+02 8.3125595092773438e+01 1.5554399108886719e+02 1.8146600341796875e+02 8.4138397216796875e+01 1.5528500366210938e+02 1.8143301391601562e+02 8.3089500427246094e+01 1.5534399414062500e+02 1.8193499755859375e+02 8.4102104187011719e+01 1.5508399963378906e+02 1.8190299987792969e+02 8.3052597045898438e+01 1.5514199829101562e+02 1.8240299987792969e+02 8.4065200805664062e+01 1.5488200378417969e+02 1.8237200927734375e+02 8.3015205383300781e+01 1.5493899536132812e+02 1.8287100219726562e+02 8.4027702331542969e+01 1.5467900085449219e+02 1.8284001159667969e+02 8.2996299743652344e+01 1.5483699035644531e+02 1.8310501098632812e+02 8.4008697509765625e+01 1.5457699584960938e+02 1.8307400512695312e+02 8.2958000183105469e+01 1.5463299560546875e+02 1.8357199096679688e+02 8.3970298767089844e+01 1.5437300109863281e+02 1.8354199218750000e+02 8.2918998718261719e+01 1.5442800903320312e+02 1.8403799438476562e+02 8.3931198120117188e+01 1.5416699218750000e+02 1.8400900268554688e+02 8.2886199951171875e+01 1.5425700378417969e+02 1.8442500305175781e+02 8.3891601562500000e+01 1.5396000671386719e+02 1.8447500610351562e+02 8.5938697814941406e+01 1.6101998901367188e+02 1.6452699279785156e+02 8.5920104980468750e+01 1.6086100769042969e+02 1.6501399230957031e+02 8.5901000976562500e+01 1.6070100402832031e+02 1.6550000000000000e+02 8.5881500244140625e+01 1.6053999328613281e+02 1.6598500061035156e+02 8.5861602783203125e+01 1.6037699890136719e+02 1.6647000122070312e+02 8.5841300964355469e+01 1.6021299743652344e+02 1.6695399475097656e+02 8.5820503234863281e+01 1.6004798889160156e+02 1.6743800354003906e+02 8.5799301147460938e+01 1.5988099670410156e+02 1.6792100524902344e+02 8.5777603149414062e+01 1.5971400451660156e+02 1.6840399169921875e+02 8.5755500793457031e+01 1.5954400634765625e+02 1.6888700866699219e+02 8.5732994079589844e+01 1.5937399291992188e+02 1.6936900329589844e+02 8.5709899902343750e+01 1.5920199584960938e+02 1.6985000610351562e+02 8.5686401367187500e+01 1.5902900695800781e+02 1.7033099365234375e+02 8.5662399291992188e+01 1.5885501098632812e+02 1.7081199645996094e+02 8.5637893676757812e+01 1.5868000793457031e+02 1.7129200744628906e+02 8.5625495910644531e+01 1.5859199523925781e+02 1.7153199768066406e+02 8.5600303649902344e+01 1.5841400146484375e+02 1.7201100158691406e+02 8.5574600219726562e+01 1.5823599243164062e+02 1.7249000549316406e+02 8.5548400878906250e+01 1.5805599975585938e+02 1.7296899414062500e+02 8.5521598815917969e+01 1.5787500000000000e+02 1.7344699096679688e+02 8.5494400024414062e+01 1.5769299316406250e+02 1.7392399597167969e+02 8.5466697692871094e+01 1.5750999450683594e+02 1.7440100097656250e+02 8.5438400268554688e+01 1.5732499694824219e+02 1.7487699890136719e+02 8.5423995971679688e+01 1.5723300170898438e+02 1.7511500549316406e+02 8.5395004272460938e+01 1.5704600524902344e+02 1.7559100341796875e+02 8.5365402221679688e+01 1.5685899353027344e+02 1.7606599426269531e+02 8.5335205078125000e+01 1.5666999816894531e+02 1.7654100036621094e+02 8.5304603576660156e+01 1.5648100280761719e+02 1.7701499938964844e+02 8.5273399353027344e+01 1.5628999328613281e+02 1.7748899841308594e+02 8.5241600036621094e+01 1.5609799194335938e+02 1.7796200561523438e+02 8.5225502014160156e+01 1.5600199890136719e+02 1.7819799804687500e+02 8.5192893981933594e+01 1.5580799865722656e+02 1.7867100524902344e+02 8.5159797668457031e+01 1.5561300659179688e+02 1.7914299011230469e+02 8.5126098632812500e+01 1.5541799926757812e+02 1.7961399841308594e+02 8.5091796875000000e+01 1.5522099304199219e+02 1.8008500671386719e+02 8.5056900024414062e+01 1.5502299499511719e+02 1.8055500793457031e+02 8.5039299011230469e+01 1.5492300415039062e+02 1.8079000854492188e+02 8.5003601074218750e+01 1.5472300720214844e+02 1.8126000976562500e+02 8.4967300415039062e+01 1.5452299499511719e+02 1.8172900390625000e+02 8.4930297851562500e+01 1.5432099914550781e+02 1.8219799804687500e+02 8.4892799377441406e+01 1.5411799621582031e+02 1.8266600036621094e+02 8.4873802185058594e+01 1.5401600646972656e+02 1.8289999389648438e+02 8.4835403442382812e+01 1.5381201171875000e+02 1.8336700439453125e+02 8.4796302795410156e+01 1.5360600280761719e+02 1.8383399963378906e+02 8.4756599426269531e+01 1.5340000915527344e+02 1.8430000305175781e+02 8.4736503601074219e+01 1.5329598999023438e+02 1.8453300476074219e+02 8.4695899963378906e+01 1.5308799743652344e+02 1.8499900817871094e+02 8.4654502868652344e+01 1.5287899780273438e+02 1.8546398925781250e+02 8.4612602233886719e+01 1.5266899108886719e+02 1.8592900085449219e+02 8.4569999694824219e+01 1.5245799255371094e+02 1.8639299011230469e+02 8.4548400878906250e+01 1.5235200500488281e+02 1.8662400817871094e+02 8.4504798889160156e+01 1.5213999938964844e+02 1.8708799743652344e+02 8.4460494995117188e+01 1.5192599487304688e+02 1.8755101013183594e+02 8.4415504455566406e+01 1.5171200561523438e+02 1.8801300048828125e+02 8.4392799377441406e+01 1.5160400390625000e+02 1.8824400329589844e+02 8.4346801757812500e+01 1.5138900756835938e+02 1.8870500183105469e+02 8.4300102233886719e+01 1.5117199707031250e+02 1.8916600036621094e+02 8.2879402160644531e+01 1.5422099304199219e+02 1.8450399780273438e+02 8.2859397888183594e+01 1.5411799621582031e+02 1.8473699951171875e+02 8.3871498107910156e+01 1.5385699462890625e+02 1.8470799255371094e+02 8.2818801879882812e+01 1.5391000366210938e+02 1.8520199584960938e+02 8.3830802917480469e+01 1.5364900207519531e+02 1.8517399597167969e+02 8.2777702331542969e+01 1.5370100402832031e+02 1.8566699218750000e+02 8.3789497375488281e+01 1.5344000244140625e+02 1.8563899230957031e+02 8.2735900878906250e+01 1.5349101257324219e+02 1.8613099670410156e+02 8.3747604370117188e+01 1.5322900390625000e+02 1.8610400390625000e+02 8.2693397521972656e+01 1.5327999877929688e+02 1.8659399414062500e+02 8.3705001831054688e+01 1.5301800537109375e+02 1.8656800842285156e+02 8.2671905517578125e+01 1.5317500305175781e+02 1.8682600402832031e+02 8.3683403015136719e+01 1.5291200256347656e+02 1.8680000305175781e+02 8.2628402709960938e+01 1.5296200561523438e+02 1.8728799438476562e+02 8.3639801025390625e+01 1.5270001220703125e+02 1.8726399230957031e+02 8.2584297180175781e+01 1.5274900817871094e+02 1.8775000000000000e+02 8.3595603942871094e+01 1.5248599243164062e+02 1.8772601318359375e+02 8.2539497375488281e+01 1.5253500366210938e+02 1.8821200561523438e+02 8.3550605773925781e+01 1.5227200317382812e+02 1.8818899536132812e+02 8.2516799926757812e+01 1.5242700195312500e+02 1.8844300842285156e+02 8.3527900695800781e+01 1.5216400146484375e+02 1.8841999816894531e+02 8.2471000671386719e+01 1.5221199035644531e+02 1.8890400695800781e+02 8.3481903076171875e+01 1.5194799804687500e+02 1.8888099670410156e+02 8.2424400329589844e+01 1.5199501037597656e+02 1.8936399841308594e+02 8.3435295104980469e+01 1.5173100280761719e+02 1.8934201049804688e+02 8.2377204895019531e+01 1.5177799987792969e+02 1.8982299804687500e+02 8.3387893676757812e+01 1.5151300048828125e+02 1.8980300903320312e+02 8.2353401184082031e+01 1.5166899108886719e+02 1.9005299377441406e+02 8.3364006042480469e+01 1.5140399169921875e+02 1.9003300476074219e+02 8.2305107116699219e+01 1.5144999694824219e+02 1.9051200866699219e+02 8.3315605163574219e+01 1.5118501281738281e+02 1.9049200439453125e+02 8.2256103515625000e+01 1.5123001098632812e+02 1.9097000122070312e+02 8.3266494750976562e+01 1.5096501159667969e+02 1.9095100402832031e+02 8.2231399536132812e+01 1.5112001037597656e+02 1.9119900512695312e+02 8.3241699218750000e+01 1.5085400390625000e+02 1.9118099975585938e+02 8.2181297302246094e+01 1.5089799499511719e+02 1.9165599060058594e+02 8.3191497802734375e+01 1.5063301086425781e+02 1.9163900756835938e+02 8.2130599975585938e+01 1.5067599487304688e+02 1.9211299133300781e+02 8.3140594482421875e+01 1.5041000366210938e+02 1.9209700012207031e+02 8.2079093933105469e+01 1.5045300292968750e+02 1.9257000732421875e+02 8.3089004516601562e+01 1.5018699645996094e+02 1.9255400085449219e+02 8.2053100585937500e+01 1.5034100341796875e+02 1.9279800415039062e+02 8.3062904357910156e+01 1.5007499694824219e+02 1.9278199768066406e+02 8.2000503540039062e+01 1.5011698913574219e+02 1.9325299072265625e+02 8.3010192871093750e+01 1.4984999084472656e+02 1.9323899841308594e+02 8.1947196960449219e+01 1.4989199829101562e+02 1.9370800781250000e+02 8.2956703186035156e+01 1.4962500000000000e+02 1.9369499206542969e+02 8.1920303344726562e+01 1.4977900695800781e+02 1.9393600463867188e+02 8.2929702758789062e+01 1.4951199340820312e+02 1.9392199707031250e+02 8.1865898132324219e+01 1.4955299377441406e+02 1.9438999938964844e+02 8.2875099182128906e+01 1.4928500366210938e+02 1.9437800598144531e+02 8.1810699462890625e+01 1.4932600402832031e+02 1.9484298706054688e+02 8.2819793701171875e+01 1.4905700683593750e+02 1.9483200073242188e+02 8.1782806396484375e+01 1.4921099853515625e+02 1.9506999206542969e+02 8.2791801452636719e+01 1.4894300842285156e+02 1.9505900573730469e+02 8.1726501464843750e+01 1.4898300170898438e+02 1.9552299499511719e+02 8.2735397338867188e+01 1.4871400451660156e+02 1.9551300048828125e+02 8.1669395446777344e+01 1.4875399780273438e+02 1.9597500610351562e+02 8.2678100585937500e+01 1.4848400878906250e+02 1.9596600341796875e+02 8.1640495300292969e+01 1.4863899230957031e+02 1.9620100402832031e+02 8.2649200439453125e+01 1.4836900329589844e+02 1.9619200134277344e+02 8.1582298278808594e+01 1.4840798950195312e+02 1.9665199279785156e+02 8.2590698242187500e+01 1.4813800048828125e+02 1.9664500427246094e+02 8.1523200988769531e+01 1.4817700195312500e+02 1.9710299682617188e+02 8.2531494140625000e+01 1.4790600585937500e+02 1.9709700012207031e+02 8.1463302612304688e+01 1.4794400024414062e+02 1.9755299377441406e+02 8.2471397399902344e+01 1.4767399597167969e+02 1.9754800415039062e+02 8.1432998657226562e+01 1.4782800292968750e+02 1.9777799987792969e+02 8.2441101074218750e+01 1.4755700683593750e+02 1.9777299499511719e+02 8.1371902465820312e+01 1.4759400939941406e+02 1.9822799682617188e+02 8.2379806518554688e+01 1.4732299804687500e+02 1.9822399902343750e+02 8.1341102600097656e+01 1.4747700500488281e+02 1.9845199584960938e+02 8.2348899841308594e+01 1.4720599365234375e+02 1.9844900512695312e+02 8.1278800964355469e+01 1.4724299621582031e+02 1.9890100097656250e+02 8.2286300659179688e+01 1.4697000122070312e+02 1.9889900207519531e+02 8.1215599060058594e+01 1.4700700378417969e+02 1.9934899902343750e+02 8.2222999572753906e+01 1.4673500061035156e+02 1.9934800720214844e+02 8.1183700561523438e+01 1.4688900756835938e+02 1.9957299804687500e+02 8.2190994262695312e+01 1.4661599731445312e+02 1.9957199096679688e+02 8.1119201660156250e+01 1.4665299987792969e+02 2.0002000427246094e+02 8.2126403808593750e+01 1.4637899780273438e+02 2.0002000427246094e+02 8.1054000854492188e+01 1.4641499328613281e+02 2.0046600341796875e+02 8.2060905456542969e+01 1.4614099121093750e+02 2.0046800231933594e+02 8.1021003723144531e+01 1.4629598999023438e+02 2.0069000244140625e+02 8.2027801513671875e+01 1.4602200317382812e+02 2.0069200134277344e+02 8.0954399108886719e+01 1.4605799865722656e+02 2.0113499450683594e+02 8.1960998535156250e+01 1.4578300476074219e+02 2.0113900756835938e+02 8.0913604736328125e+01 1.4591300964355469e+02 2.0140499877929688e+02 8.1893402099609375e+01 1.4554299926757812e+02 2.0158499145507812e+02 8.4252799987792969e+01 1.5095399475097656e+02 1.8962701416015625e+02 8.4228797912597656e+01 1.5084500122070312e+02 1.8985700988769531e+02 8.4180397033691406e+01 1.5062600708007812e+02 1.9031600952148438e+02 8.4131301879882812e+01 1.5040499877929688e+02 1.9077500915527344e+02 8.4106399536132812e+01 1.5029499816894531e+02 1.9100500488281250e+02 8.4056198120117188e+01 1.5007400512695312e+02 1.9146299743652344e+02 8.4005302429199219e+01 1.4985099792480469e+02 1.9192098999023438e+02 8.3953697204589844e+01 1.4962800598144531e+02 1.9237800598144531e+02 8.3927604675292969e+01 1.4951600646972656e+02 1.9260699462890625e+02 8.3874900817871094e+01 1.4929200744628906e+02 1.9306300354003906e+02 8.3821403503417969e+01 1.4906599426269531e+02 1.9351899719238281e+02 8.3794303894042969e+01 1.4895300292968750e+02 1.9374699401855469e+02 8.3739700317382812e+01 1.4872599792480469e+02 1.9420201110839844e+02 8.3684402465820312e+01 1.4849899291992188e+02 1.9465699768066406e+02 8.3656494140625000e+01 1.4838400268554688e+02 1.9488400268554688e+02 8.3599899291992188e+01 1.4815499877929688e+02 1.9533799743652344e+02 8.3542602539062500e+01 1.4792601013183594e+02 1.9579200744628906e+02 8.3513702392578125e+01 1.4780999755859375e+02 1.9601799011230469e+02 8.3455200195312500e+01 1.4757899475097656e+02 1.9647100830078125e+02 8.3395896911621094e+01 1.4734700012207031e+02 1.9692300415039062e+02 8.3335899353027344e+01 1.4711500549316406e+02 1.9737400817871094e+02 8.3305503845214844e+01 1.4699800109863281e+02 1.9760000610351562e+02 8.3244194030761719e+01 1.4676399230957031e+02 1.9805101013183594e+02 8.3213203430175781e+01 1.4664700317382812e+02 1.9827600097656250e+02 8.3150703430175781e+01 1.4641200256347656e+02 1.9872599792480469e+02 8.3087303161621094e+01 1.4617599487304688e+02 1.9917599487304688e+02 8.3055198669433594e+01 1.4605699157714844e+02 1.9939999389648438e+02 8.2990600585937500e+01 1.4582000732421875e+02 1.9984899902343750e+02 8.2925102233886719e+01 1.4558200073242188e+02 2.0029699707031250e+02 8.2891998291015625e+01 1.4546299743652344e+02 2.0052101135253906e+02 8.2825195312500000e+01 1.4522399902343750e+02 2.0096800231933594e+02 8.2757499694824219e+01 1.4498400878906250e+02 2.0141500854492188e+02 8.2723297119140625e+01 1.4486399841308594e+02 2.0163800048828125e+02 8.2654296875000000e+01 1.4462300109863281e+02 2.0208399963378906e+02 8.2584403991699219e+01 1.4438099670410156e+02 2.0252999877929688e+02 8.2549102783203125e+01 1.4426000976562500e+02 2.0275199890136719e+02 8.2477897644042969e+01 1.4401699829101562e+02 2.0319700622558594e+02 8.2442001342773438e+01 1.4389500427246094e+02 2.0341900634765625e+02 8.2369400024414062e+01 1.4365100097656250e+02 2.0386299133300781e+02 8.2295898437500000e+01 1.4340600585937500e+02 2.0430599975585938e+02 8.2258796691894531e+01 1.4328399658203125e+02 2.0452799987792969e+02 8.2183898925781250e+01 1.4303800964355469e+02 2.0497000122070312e+02 8.2146194458007812e+01 1.4291499328613281e+02 2.0519200134277344e+02 8.2069900512695312e+01 1.4266799926757812e+02 2.0563299560546875e+02 8.1992698669433594e+01 1.4242100524902344e+02 2.0607400512695312e+02 8.1953697204589844e+01 1.4229699707031250e+02 2.0629499816894531e+02 8.1875099182128906e+01 1.4204800415039062e+02 2.0673500061035156e+02 8.1835395812988281e+01 1.4192298889160156e+02 2.0695500183105469e+02 8.1755302429199219e+01 1.4167399597167969e+02 2.0739500427246094e+02 8.1674201965332031e+01 1.4142300415039062e+02 2.0783399963378906e+02 8.1633201599121094e+01 1.4129798889160156e+02 2.0805299377441406e+02 8.1550704956054688e+01 1.4104699707031250e+02 2.0849099731445312e+02 8.1509002685546875e+01 1.4092098999023438e+02 2.0871000671386719e+02 8.1424896240234375e+01 1.4066799926757812e+02 2.0914700317382812e+02 8.1339797973632812e+01 1.4041499328613281e+02 2.0958399963378906e+02 8.1296897888183594e+01 1.4028898620605469e+02 2.0980200195312500e+02 8.1210205078125000e+01 1.4003500366210938e+02 2.1023799133300781e+02 8.1166496276855469e+01 1.3990699768066406e+02 2.1045599365234375e+02 8.0886901855468750e+01 1.4581799316406250e+02 2.0158000183105469e+02 8.0852905273437500e+01 1.4569799804687500e+02 2.0180299377441406e+02 8.1859199523925781e+01 1.4542298889160156e+02 2.0180799865722656e+02 8.0784095764160156e+01 1.4545799255371094e+02 2.0224699401855469e+02 8.1790199279785156e+01 1.4518199157714844e+02 2.0225399780273438e+02 8.0714500427246094e+01 1.4521699523925781e+02 2.0269100952148438e+02 8.1720397949218750e+01 1.4494100952148438e+02 2.0269900512695312e+02 8.0679298400878906e+01 1.4509600830078125e+02 2.0291299438476562e+02 8.1685104370117188e+01 1.4481900024414062e+02 2.0292100524902344e+02 8.0608299255371094e+01 1.4485398864746094e+02 2.0335600280761719e+02 8.1613899230957031e+01 1.4457699584960938e+02 2.0336500549316406e+02 8.0572502136230469e+01 1.4473199462890625e+02 2.0357699584960938e+02 8.1578002929687500e+01 1.4445500183105469e+02 2.0358699035644531e+02 8.0500198364257812e+01 1.4448899841308594e+02 2.0401899719238281e+02 8.1505500793457031e+01 1.4421099853515625e+02 2.0403001403808594e+02 8.0427001953125000e+01 1.4424499511718750e+02 2.0445999145507812e+02 8.1431999206542969e+01 1.4396699523925781e+02 2.0447300720214844e+02 8.0390106201171875e+01 1.4412300109863281e+02 2.0468099975585938e+02 8.1394905090332031e+01 1.4384399414062500e+02 2.0469400024414062e+02 8.0315498352050781e+01 1.4387799072265625e+02 2.0512100219726562e+02 8.1320098876953125e+01 1.4359800720214844e+02 2.0513600158691406e+02 8.0277801513671875e+01 1.4375500488281250e+02 2.0534199523925781e+02 8.1282402038574219e+01 1.4347499084472656e+02 2.0535699462890625e+02 8.0201797485351562e+01 1.4350900268554688e+02 2.0578099060058594e+02 8.1206199645996094e+01 1.4322898864746094e+02 2.0579800415039062e+02 8.0125000000000000e+01 1.4326199340820312e+02 2.0622099304199219e+02 8.1128997802734375e+01 1.4298098754882812e+02 2.0623899841308594e+02 8.0086204528808594e+01 1.4313800048828125e+02 2.0644000244140625e+02 8.1090103149414062e+01 1.4285699462890625e+02 2.0645899963378906e+02 8.0007797241210938e+01 1.4288999938964844e+02 2.0687800598144531e+02 8.1011497497558594e+01 1.4260899353027344e+02 2.0689801025390625e+02 7.9968299865722656e+01 1.4276599121093750e+02 2.0709700012207031e+02 8.0971801757812500e+01 1.4248399353027344e+02 2.0711801147460938e+02 7.9888404846191406e+01 1.4251699829101562e+02 2.0753500366210938e+02 8.0891799926757812e+01 1.4223500061035156e+02 2.0755699157714844e+02 7.9807601928710938e+01 1.4226800537109375e+02 2.0797200012207031e+02 8.0810707092285156e+01 1.4198500061035156e+02 2.0799499511718750e+02 7.9766899108886719e+01 1.4214299011230469e+02 2.0818998718261719e+02 8.0769798278808594e+01 1.4186000061035156e+02 2.0821400451660156e+02 7.9684700012207031e+01 1.4189199829101562e+02 2.0862600708007812e+02 8.0687301635742188e+01 1.4160800170898438e+02 2.0865200805664062e+02 7.9643096923828125e+01 1.4176699829101562e+02 2.0884400939941406e+02 8.0645706176757812e+01 1.4148298645019531e+02 2.0886999511718750e+02 7.9559402465820312e+01 1.4151499938964844e+02 2.0927900695800781e+02 8.0561599731445312e+01 1.4122999572753906e+02 2.0930700683593750e+02 7.9474601745605469e+01 1.4126300048828125e+02 2.0971299743652344e+02 8.0476600646972656e+01 1.4097799682617188e+02 2.0974299621582031e+02 7.9431800842285156e+01 1.4113700866699219e+02 2.0993000793457031e+02 8.0433692932128906e+01 1.4085101318359375e+02 2.0995999145507812e+02 7.9345596313476562e+01 1.4088400268554688e+02 2.1036399841308594e+02 8.0347099304199219e+01 1.4059700012207031e+02 2.1039601135253906e+02 7.9301994323730469e+01 1.4075698852539062e+02 2.1058000183105469e+02 8.0303398132324219e+01 1.4047000122070312e+02 2.1061299133300781e+02 7.9214202880859375e+01 1.4050300598144531e+02 2.1101300048828125e+02 8.0215293884277344e+01 1.4021598815917969e+02 2.1104699707031250e+02 7.9169799804687500e+01 1.4037600708007812e+02 2.1122900390625000e+02 8.0170799255371094e+01 1.4008801269531250e+02 2.1126399230957031e+02 7.9080406188964844e+01 1.4012100219726562e+02 2.1166099548339844e+02 8.0081100463867188e+01 1.3983200073242188e+02 2.1169799804687500e+02 7.8989997863769531e+01 1.3986599731445312e+02 2.1209199523925781e+02 7.9990402221679688e+01 1.3957600402832031e+02 2.1212998962402344e+02 7.8944396972656250e+01 1.3973699951171875e+02 2.1230799865722656e+02 7.9944602966308594e+01 1.3944799804687500e+02 2.1234700012207031e+02 7.8852302551269531e+01 1.3948098754882812e+02 2.1273800659179688e+02 7.9852203369140625e+01 1.3919099426269531e+02 2.1277900695800781e+02 7.8805793762207031e+01 1.3935301208496094e+02 2.1295300292968750e+02 7.9805595397949219e+01 1.3906199645996094e+02 2.1299398803710938e+02 7.8712097167968750e+01 1.3909498596191406e+02 2.1338200378417969e+02 7.9711601257324219e+01 1.3880400085449219e+02 2.1342500305175781e+02 7.8617401123046875e+01 1.3883699035644531e+02 2.1381098937988281e+02 7.9616500854492188e+01 1.3854501342773438e+02 2.1385600280761719e+02 7.8521499633789062e+01 1.3857899475097656e+02 2.1423899841308594e+02 7.9520301818847656e+01 1.3828599548339844e+02 2.1428599548339844e+02 7.8473098754882812e+01 1.3844900512695312e+02 2.1445300292968750e+02 7.9471702575683594e+01 1.3815599060058594e+02 2.1450000000000000e+02 8.1078300476074219e+01 1.3965299987792969e+02 2.1089099121093750e+02 8.1033805847167969e+01 1.3952499389648438e+02 2.1110899353027344e+02 8.0944000244140625e+01 1.3926899719238281e+02 2.1154299926757812e+02 8.0853202819824219e+01 1.3901199340820312e+02 2.1197700500488281e+02 8.0807403564453125e+01 1.3888398742675781e+02 2.1219299316406250e+02 8.0714897155761719e+01 1.3862699890136719e+02 2.1262599182128906e+02 8.0668296813964844e+01 1.3849798583984375e+02 2.1284199523925781e+02 8.0574195861816406e+01 1.3823899841308594e+02 2.1327400207519531e+02 8.0479003906250000e+01 1.3797999572753906e+02 2.1370600891113281e+02 8.6153099060058594e+01 1.6916899108886719e+02 1.1755699920654297e+02 8.6154296875000000e+01 1.6917100524902344e+02 1.1755699920654297e+02 8.5810501098632812e+01 1.6937600708007812e+02 1.1755199432373047e+02 8.5689300537109375e+01 1.6940901184082031e+02 1.1755100250244141e+02 8.6150695800781250e+01 1.6916499328613281e+02 1.1755599975585938e+02 8.6510101318359375e+01 1.6879499816894531e+02 1.1755999755859375e+02 8.6263999938964844e+01 1.6909500122070312e+02 1.1755699920654297e+02 8.4672500610351562e+01 1.6968600463867188e+02 -3.4693399047851562e+02 8.5691398620605469e+01 1.6943000793457031e+02 -3.4693399047851562e+02 8.6559600830078125e+01 1.6883898925781250e+02 -3.4693399047851562e+02 8.6573898315429688e+01 1.6883799743652344e+02 -1.2647399139404297e+02 8.6573196411132812e+01 1.6883799743652344e+02 -1.2541900634765625e+02 8.6572494506835938e+01 1.6883898925781250e+02 -1.2436500549316406e+02 8.6571800231933594e+01 1.6883898925781250e+02 -1.2330999755859375e+02 8.6571098327636719e+01 1.6883898925781250e+02 -1.2225499725341797e+02 8.6569503784179688e+01 1.6883898925781250e+02 -1.2014500427246094e+02 8.6568695068359375e+01 1.6883898925781250e+02 -1.1908999633789062e+02 8.6567901611328125e+01 1.6883898925781250e+02 -1.1803500366210938e+02 8.6567092895507812e+01 1.6883898925781250e+02 -1.1698100280761719e+02 8.6566200256347656e+01 1.6883898925781250e+02 -1.1592599487304688e+02 8.6565399169921875e+01 1.6883898925781250e+02 -1.1487100219726562e+02 8.6563499450683594e+01 1.6883898925781250e+02 -1.1276100158691406e+02 8.6562606811523438e+01 1.6883898925781250e+02 -1.1170600128173828e+02 8.6561599731445312e+01 1.6883898925781250e+02 -1.1065100097656250e+02 8.6560699462890625e+01 1.6883898925781250e+02 -1.0959600067138672e+02 8.6559700012207031e+01 1.6883898925781250e+02 -1.0854199981689453e+02 8.6558601379394531e+01 1.6883898925781250e+02 -1.0748699951171875e+02 8.6556594848632812e+01 1.6883898925781250e+02 -1.0537700653076172e+02 8.6555503845214844e+01 1.6884001159667969e+02 -1.0432199859619141e+02 8.6554397583007812e+01 1.6884001159667969e+02 -1.0326699829101562e+02 8.6553298950195312e+01 1.6884001159667969e+02 -1.0221199798583984e+02 8.6551002502441406e+01 1.6884001159667969e+02 -1.0010299682617188e+02 8.6546401977539062e+01 1.6884001159667969e+02 -9.5883300781250000e+01 8.6544097900390625e+01 1.6884001159667969e+02 -9.3773696899414062e+01 8.6541694641113281e+01 1.6884001159667969e+02 -9.1664001464843750e+01 8.6539299011230469e+01 1.6884100341796875e+02 -8.9554306030273438e+01 8.6536895751953125e+01 1.6884100341796875e+02 -8.7444702148437500e+01 8.6534500122070312e+01 1.6884100341796875e+02 -8.5334999084472656e+01 8.6529701232910156e+01 1.6884100341796875e+02 -8.1115798950195312e+01 8.6527305603027344e+01 1.6884100341796875e+02 -7.9006095886230469e+01 8.6524894714355469e+01 1.6884199523925781e+02 -7.6896507263183594e+01 8.6522598266601562e+01 1.6884199523925781e+02 -7.4786903381347656e+01 8.6520301818847656e+01 1.6884199523925781e+02 -7.2677200317382812e+01 8.6517997741699219e+01 1.6884199523925781e+02 -7.0567604064941406e+01 8.6559402465820312e+01 1.6883898925781250e+02 -3.4482397460937500e+02 8.6559303283691406e+01 1.6883898925781250e+02 -3.4271499633789062e+02 8.6559196472167969e+01 1.6883898925781250e+02 -3.4060498046875000e+02 8.6558998107910156e+01 1.6883898925781250e+02 -3.3638598632812500e+02 8.6558898925781250e+01 1.6883898925781250e+02 -3.3427600097656250e+02 8.6558799743652344e+01 1.6883898925781250e+02 -3.3216598510742188e+02 8.6558700561523438e+01 1.6883898925781250e+02 -3.3005700683593750e+02 8.6558601379394531e+01 1.6883898925781250e+02 -3.2794699096679688e+02 8.6558601379394531e+01 1.6883898925781250e+02 -3.2583697509765625e+02 8.6558502197265625e+01 1.6883898925781250e+02 -3.2161798095703125e+02 8.6558502197265625e+01 1.6883898925781250e+02 -3.1950900268554688e+02 8.6558502197265625e+01 1.6883898925781250e+02 -3.1739898681640625e+02 8.6558502197265625e+01 1.6883898925781250e+02 -3.1528900146484375e+02 8.6558502197265625e+01 1.6883898925781250e+02 -3.1317999267578125e+02 8.6558502197265625e+01 1.6883898925781250e+02 -3.1107000732421875e+02 8.6558601379394531e+01 1.6883898925781250e+02 -3.0685101318359375e+02 8.6558700561523438e+01 1.6883898925781250e+02 -3.0474099731445312e+02 8.6558700561523438e+01 1.6883898925781250e+02 -3.0263098144531250e+02 8.6558799743652344e+01 1.6883898925781250e+02 -3.0052200317382812e+02 8.6558898925781250e+01 1.6883898925781250e+02 -2.9841198730468750e+02 8.6558998107910156e+01 1.6883898925781250e+02 -2.9630300903320312e+02 8.6559402465820312e+01 1.6883898925781250e+02 -2.9208300781250000e+02 8.6559600830078125e+01 1.6883898925781250e+02 -2.8997399902343750e+02 8.6559799194335938e+01 1.6883898925781250e+02 -2.8786401367187500e+02 8.6560005187988281e+01 1.6883898925781250e+02 -2.8575399780273438e+02 8.6560302734375000e+01 1.6883898925781250e+02 -2.8364498901367188e+02 8.6560501098632812e+01 1.6883898925781250e+02 -2.8153500366210938e+02 8.6561203002929688e+01 1.6883898925781250e+02 -2.7731600952148438e+02 8.6561500549316406e+01 1.6883898925781250e+02 -2.7520599365234375e+02 8.6561904907226562e+01 1.6883898925781250e+02 -2.7309701538085938e+02 8.6562202453613281e+01 1.6883898925781250e+02 -2.7098699951171875e+02 8.6562606811523438e+01 1.6883898925781250e+02 -2.6887701416015625e+02 8.6562995910644531e+01 1.6883898925781250e+02 -2.6676800537109375e+02 8.6563903808593750e+01 1.6883898925781250e+02 -2.6254800415039062e+02 8.6564399719238281e+01 1.6883898925781250e+02 -2.6043899536132812e+02 8.6564804077148438e+01 1.6883898925781250e+02 -2.5832901000976562e+02 8.6565299987792969e+01 1.6883898925781250e+02 -2.5621899414062500e+02 8.6565803527832031e+01 1.6883898925781250e+02 -2.5411001586914062e+02 8.6566406250000000e+01 1.6883898925781250e+02 -2.5200000000000000e+02 8.6566902160644531e+01 1.6883898925781250e+02 -2.4988999938964844e+02 8.6568000793457031e+01 1.6883898925781250e+02 -2.4567100524902344e+02 8.6568603515625000e+01 1.6883898925781250e+02 -2.4356199645996094e+02 8.6569198608398438e+01 1.6883898925781250e+02 -2.4145199584960938e+02 8.6569801330566406e+01 1.6883898925781250e+02 -2.3934201049804688e+02 8.6570396423339844e+01 1.6883898925781250e+02 -2.3723300170898438e+02 8.6570999145507812e+01 1.6883898925781250e+02 -2.3512300109863281e+02 8.6572296142578125e+01 1.6883898925781250e+02 -2.3090399169921875e+02 8.6572898864746094e+01 1.6883898925781250e+02 -2.2879399108886719e+02 8.6573600769042969e+01 1.6883799743652344e+02 -2.2668499755859375e+02 8.6574195861816406e+01 1.6883799743652344e+02 -2.2457499694824219e+02 8.6574897766113281e+01 1.6883799743652344e+02 -2.2246499633789062e+02 8.6575599670410156e+01 1.6883799743652344e+02 -2.2035600280761719e+02 8.6576202392578125e+01 1.6883799743652344e+02 -2.1824600219726562e+02 8.6576606750488281e+01 1.6883799743652344e+02 -2.1719099426269531e+02 8.6576904296875000e+01 1.6883799743652344e+02 -2.1613598632812500e+02 8.6577201843261719e+01 1.6883799743652344e+02 -2.1508100891113281e+02 8.6577499389648438e+01 1.6883799743652344e+02 -2.1402700805664062e+02 8.6577896118164062e+01 1.6883799743652344e+02 -2.1297200012207031e+02 8.6578506469726562e+01 1.6883799743652344e+02 -2.1086199951171875e+02 8.6578804016113281e+01 1.6883799743652344e+02 -2.0980699157714844e+02 8.6579101562500000e+01 1.6883799743652344e+02 -2.0875199890136719e+02 8.6579399108886719e+01 1.6883799743652344e+02 -2.0769799804687500e+02 8.6579704284667969e+01 1.6883799743652344e+02 -2.0664300537109375e+02 8.6579895019531250e+01 1.6883799743652344e+02 -2.0558799743652344e+02 8.6580200195312500e+01 1.6883799743652344e+02 -2.0453298950195312e+02 8.6580795288085938e+01 1.6883799743652344e+02 -2.0242300415039062e+02 8.6581001281738281e+01 1.6883799743652344e+02 -2.0136900329589844e+02 8.6581298828125000e+01 1.6883799743652344e+02 -2.0031399536132812e+02 8.6581497192382812e+01 1.6883799743652344e+02 -1.9925900268554688e+02 8.6581794738769531e+01 1.6883799743652344e+02 -1.9820399475097656e+02 8.6582000732421875e+01 1.6883799743652344e+02 -1.9714898681640625e+02 8.6582397460937500e+01 1.6883799743652344e+02 -1.9504000854492188e+02 8.6582695007324219e+01 1.6883799743652344e+02 -1.9398500061035156e+02 8.6582901000976562e+01 1.6883799743652344e+02 -1.9292999267578125e+02 8.6583099365234375e+01 1.6883799743652344e+02 -1.9187500000000000e+02 8.6583297729492188e+01 1.6883799743652344e+02 -1.9081999206542969e+02 8.6583396911621094e+01 1.6883799743652344e+02 -1.8976499938964844e+02 8.6583801269531250e+01 1.6883799743652344e+02 -1.8765600585937500e+02 8.6583900451660156e+01 1.6883799743652344e+02 -1.8660099792480469e+02 8.6584098815917969e+01 1.6883799743652344e+02 -1.8554598999023438e+02 8.6584205627441406e+01 1.6883799743652344e+02 -1.8449099731445312e+02 8.6584396362304688e+01 1.6883799743652344e+02 -1.8343600463867188e+02 8.6584503173828125e+01 1.6883799743652344e+02 -1.8238099670410156e+02 8.6584701538085938e+01 1.6883799743652344e+02 -1.8027200317382812e+02 8.6584800720214844e+01 1.6883799743652344e+02 -1.7921699523925781e+02 8.6584899902343750e+01 1.6883799743652344e+02 -1.7816198730468750e+02 8.6584999084472656e+01 1.6883799743652344e+02 -1.7710700988769531e+02 8.6585098266601562e+01 1.6883799743652344e+02 -1.7605200195312500e+02 8.6585098266601562e+01 1.6883799743652344e+02 -1.7499800109863281e+02 8.6585205078125000e+01 1.6883799743652344e+02 -1.7288800048828125e+02 8.6585296630859375e+01 1.6883799743652344e+02 -1.7183299255371094e+02 8.6585296630859375e+01 1.6883799743652344e+02 -1.7077799987792969e+02 8.6585296630859375e+01 1.6883799743652344e+02 -1.6972300720214844e+02 8.6585296630859375e+01 1.6883799743652344e+02 -1.6866900634765625e+02 8.6585296630859375e+01 1.6883799743652344e+02 -1.6761399841308594e+02 8.6585205078125000e+01 1.6883799743652344e+02 -1.6550399780273438e+02 8.6585205078125000e+01 1.6883799743652344e+02 -1.6444900512695312e+02 8.6585098266601562e+01 1.6883799743652344e+02 -1.6339399719238281e+02 8.6585098266601562e+01 1.6883799743652344e+02 -1.6233900451660156e+02 8.6584999084472656e+01 1.6883799743652344e+02 -1.6128399658203125e+02 8.6584899902343750e+01 1.6883799743652344e+02 -1.6022999572753906e+02 8.6584701538085938e+01 1.6883799743652344e+02 -1.5812001037597656e+02 8.6584503173828125e+01 1.6883799743652344e+02 -1.5706500244140625e+02 8.6584396362304688e+01 1.6883799743652344e+02 -1.5600999450683594e+02 8.6584205627441406e+01 1.6883799743652344e+02 -1.5495500183105469e+02 8.6584098815917969e+01 1.6883799743652344e+02 -1.5390100097656250e+02 8.6583900451660156e+01 1.6883799743652344e+02 -1.5284599304199219e+02 8.6583694458007812e+01 1.6883799743652344e+02 -1.5179100036621094e+02 8.6583297729492188e+01 1.6883799743652344e+02 -1.4968099975585938e+02 8.6583000183105469e+01 1.6883799743652344e+02 -1.4862600708007812e+02 8.6582801818847656e+01 1.6883799743652344e+02 -1.4757099914550781e+02 8.6582496643066406e+01 1.6883799743652344e+02 -1.4651699829101562e+02 8.6582305908203125e+01 1.6883799743652344e+02 -1.4546200561523438e+02 8.6582000732421875e+01 1.6883799743652344e+02 -1.4440699768066406e+02 8.6581298828125000e+01 1.6883799743652344e+02 -1.4229699707031250e+02 8.6581001281738281e+01 1.6883799743652344e+02 -1.4124200439453125e+02 8.6580596923828125e+01 1.6883799743652344e+02 -1.4018699645996094e+02 8.6580299377441406e+01 1.6883799743652344e+02 -1.3913301086425781e+02 8.6579803466796875e+01 1.6883799743652344e+02 -1.3807800292968750e+02 8.6579399108886719e+01 1.6883799743652344e+02 -1.3702299499511719e+02 8.6578506469726562e+01 1.6883799743652344e+02 -1.3491299438476562e+02 8.6577995300292969e+01 1.6883799743652344e+02 -1.3385800170898438e+02 8.6577499389648438e+01 1.6883799743652344e+02 -1.3280299377441406e+02 8.6576904296875000e+01 1.6883799743652344e+02 -1.3174800109863281e+02 8.6576400756835938e+01 1.6883799743652344e+02 -1.3069400024414062e+02 8.6575798034667969e+01 1.6883799743652344e+02 -1.2963899230957031e+02 8.6574501037597656e+01 1.6883799743652344e+02 -1.2752899169921875e+02 8.5706298828125000e+01 1.6942900085449219e+02 -1.2752999114990234e+02 8.4686897277832031e+01 1.6968501281738281e+02 -1.2647500610351562e+02 8.5705696105957031e+01 1.6942900085449219e+02 -1.2647500610351562e+02 8.4686302185058594e+01 1.6968501281738281e+02 -1.2542100524902344e+02 8.5704994201660156e+01 1.6942900085449219e+02 -1.2542000579833984e+02 8.4685493469238281e+01 1.6968501281738281e+02 -1.2436599731445312e+02 8.5704299926757812e+01 1.6942900085449219e+02 -1.2436500549316406e+02 8.4684799194335938e+01 1.6968501281738281e+02 -1.2331099700927734e+02 8.5703598022460938e+01 1.6943000793457031e+02 -1.2330999755859375e+02 8.4684097290039062e+01 1.6968501281738281e+02 -1.2225600433349609e+02 8.5702903747558594e+01 1.6943000793457031e+02 -1.2225499725341797e+02 8.4682601928710938e+01 1.6968501281738281e+02 -1.2014599609375000e+02 8.5701301574707031e+01 1.6943000793457031e+02 -1.2014599609375000e+02 8.4681694030761719e+01 1.6968501281738281e+02 -1.1909200286865234e+02 8.5700599670410156e+01 1.6943000793457031e+02 -1.1909099578857422e+02 8.4680999755859375e+01 1.6968501281738281e+02 -1.1803700256347656e+02 8.5699699401855469e+01 1.6943000793457031e+02 -1.1803600311279297e+02 8.4680099487304688e+01 1.6968501281738281e+02 -1.1698199462890625e+02 8.5698905944824219e+01 1.6943000793457031e+02 -1.1698100280761719e+02 8.4679199218750000e+01 1.6968501281738281e+02 -1.1592700195312500e+02 8.5697998046875000e+01 1.6943000793457031e+02 -1.1592599487304688e+02 8.4678298950195312e+01 1.6968600463867188e+02 -1.1487200164794922e+02 8.5697196960449219e+01 1.6943000793457031e+02 -1.1487200164794922e+02 8.4676498413085938e+01 1.6968600463867188e+02 -1.1276300048828125e+02 8.5695297241210938e+01 1.6943000793457031e+02 -1.1276199340820312e+02 8.4675605773925781e+01 1.6968600463867188e+02 -1.1170800018310547e+02 8.5694404602050781e+01 1.6943000793457031e+02 -1.1170700073242188e+02 8.4674598693847656e+01 1.6968600463867188e+02 -1.1065299987792969e+02 8.5693397521972656e+01 1.6943000793457031e+02 -1.1065200042724609e+02 8.4673599243164062e+01 1.6968600463867188e+02 -1.0959799957275391e+02 8.5692398071289062e+01 1.6943000793457031e+02 -1.0959700012207031e+02 8.4672698974609375e+01 1.6968600463867188e+02 -1.0854299926757812e+02 8.5691398620605469e+01 1.6943000793457031e+02 -1.0854199981689453e+02 8.4671699523925781e+01 1.6968600463867188e+02 -1.0748899841308594e+02 8.5690399169921875e+01 1.6943099975585938e+02 -1.0748799896240234e+02 8.4669502258300781e+01 1.6968600463867188e+02 -1.0537899780273438e+02 8.5688301086425781e+01 1.6943099975585938e+02 -1.0537799835205078e+02 8.4668395996093750e+01 1.6968600463867188e+02 -1.0432399749755859e+02 8.5687301635742188e+01 1.6943099975585938e+02 -1.0432299804687500e+02 8.4667396545410156e+01 1.6968600463867188e+02 -1.0326900482177734e+02 8.5686203002929688e+01 1.6943099975585938e+02 -1.0326799774169922e+02 8.4666198730468750e+01 1.6968600463867188e+02 -1.0221400451660156e+02 8.5685096740722656e+01 1.6943099975585938e+02 -1.0221300506591797e+02 8.4664001464843750e+01 1.6968699645996094e+02 -1.0010500335693359e+02 8.5682800292968750e+01 1.6943099975585938e+02 -1.0010399627685547e+02 8.4659400939941406e+01 1.6968699645996094e+02 -9.5885498046875000e+01 8.5678199768066406e+01 1.6943099975585938e+02 -9.5884399414062500e+01 8.4656997680664062e+01 1.6968699645996094e+02 -9.3775802612304688e+01 8.5675796508789062e+01 1.6943200683593750e+02 -9.3774696350097656e+01 8.4654602050781250e+01 1.6968699645996094e+02 -9.1666198730468750e+01 8.5673400878906250e+01 1.6943200683593750e+02 -9.1665100097656250e+01 8.4652198791503906e+01 1.6968699645996094e+02 -8.9556503295898438e+01 8.5670997619628906e+01 1.6943200683593750e+02 -8.9555397033691406e+01 8.4649803161621094e+01 1.6968800354003906e+02 -8.7446899414062500e+01 8.5668701171875000e+01 1.6943200683593750e+02 -8.7445701599121094e+01 8.4647399902343750e+01 1.6968800354003906e+02 -8.5337196350097656e+01 8.5666198730468750e+01 1.6943200683593750e+02 -8.5336097717285156e+01 8.4642593383789062e+01 1.6968800354003906e+02 -8.1118003845214844e+01 8.5661499023437500e+01 1.6943299865722656e+02 -8.1116806030273438e+01 8.4640197753906250e+01 1.6968800354003906e+02 -7.9008300781250000e+01 8.5658996582031250e+01 1.6943299865722656e+02 -7.9007095336914062e+01 8.4637802124023438e+01 1.6968800354003906e+02 -7.6898704528808594e+01 8.5656700134277344e+01 1.6943299865722656e+02 -7.6897499084472656e+01 8.4635505676269531e+01 1.6968899536132812e+02 -7.4789001464843750e+01 8.5654403686523438e+01 1.6943299865722656e+02 -7.4787902832031250e+01 8.4633201599121094e+01 1.6968899536132812e+02 -7.2679397583007812e+01 8.5652000427246094e+01 1.6943299865722656e+02 -7.2678199768066406e+01 8.4630897521972656e+01 1.6968899536132812e+02 -7.0569702148437500e+01 8.5649803161621094e+01 1.6943299865722656e+02 -7.0568595886230469e+01 8.4626502990722656e+01 1.6968899536132812e+02 -6.6350402832031250e+01 8.5645401000976562e+01 1.6943399047851562e+02 -6.6349403381347656e+01 8.4624404907226562e+01 1.6968899536132812e+02 -6.4240798950195312e+01 8.5643295288085938e+01 1.6943399047851562e+02 -6.4239700317382812e+01 8.4623802185058594e+01 1.6968899536132812e+02 -6.3662403106689453e+01 8.5641197204589844e+01 1.6943399047851562e+02 -6.2130100250244141e+01 8.4672401428222656e+01 1.6968600463867188e+02 -3.4482397460937500e+02 8.5691200256347656e+01 1.6943000793457031e+02 -3.4482397460937500e+02 8.4672302246093750e+01 1.6968600463867188e+02 -3.4271499633789062e+02 8.5691101074218750e+01 1.6943000793457031e+02 -3.4271499633789062e+02 8.4672195434570312e+01 1.6968600463867188e+02 -3.4060498046875000e+02 8.5690994262695312e+01 1.6943000793457031e+02 -3.4060498046875000e+02 8.4671997070312500e+01 1.6968600463867188e+02 -3.3638598632812500e+02 8.5690696716308594e+01 1.6943000793457031e+02 -3.3638598632812500e+02 8.4671806335449219e+01 1.6968600463867188e+02 -3.3427600097656250e+02 8.5690696716308594e+01 1.6943000793457031e+02 -3.3427600097656250e+02 8.4671806335449219e+01 1.6968600463867188e+02 -3.3216598510742188e+02 8.5690498352050781e+01 1.6943000793457031e+02 -3.3216598510742188e+02 8.4671699523925781e+01 1.6968600463867188e+02 -3.3005700683593750e+02 8.5690498352050781e+01 1.6943099975585938e+02 -3.3005700683593750e+02 8.4671699523925781e+01 1.6968600463867188e+02 -3.2794699096679688e+02 8.5690399169921875e+01 1.6943099975585938e+02 -3.2794699096679688e+02 8.4671600341796875e+01 1.6968600463867188e+02 -3.2583801269531250e+02 8.5690399169921875e+01 1.6943099975585938e+02 -3.2583801269531250e+02 8.4671493530273438e+01 1.6968600463867188e+02 -3.2161798095703125e+02 8.5690299987792969e+01 1.6943099975585938e+02 -3.2161798095703125e+02 8.4671493530273438e+01 1.6968600463867188e+02 -3.1950900268554688e+02 8.5690299987792969e+01 1.6943099975585938e+02 -3.1950900268554688e+02 8.4671493530273438e+01 1.6968600463867188e+02 -3.1739898681640625e+02 8.5690200805664062e+01 1.6943099975585938e+02 -3.1739898681640625e+02 8.4671493530273438e+01 1.6968600463867188e+02 -3.1528900146484375e+02 8.5690200805664062e+01 1.6943099975585938e+02 -3.1528900146484375e+02 8.4671493530273438e+01 1.6968600463867188e+02 -3.1317999267578125e+02 8.5690299987792969e+01 1.6943099975585938e+02 -3.1317999267578125e+02 8.4671493530273438e+01 1.6968600463867188e+02 -3.1107000732421875e+02 8.5690299987792969e+01 1.6943099975585938e+02 -3.1107000732421875e+02 8.4671600341796875e+01 1.6968600463867188e+02 -3.0685101318359375e+02 8.5690399169921875e+01 1.6943099975585938e+02 -3.0685101318359375e+02 8.4671699523925781e+01 1.6968600463867188e+02 -3.0474099731445312e+02 8.5690399169921875e+01 1.6943099975585938e+02 -3.0474099731445312e+02 8.4671699523925781e+01 1.6968600463867188e+02 -3.0263098144531250e+02 8.5690498352050781e+01 1.6943000793457031e+02 -3.0263098144531250e+02 8.4671806335449219e+01 1.6968600463867188e+02 -3.0052200317382812e+02 8.5690605163574219e+01 1.6943000793457031e+02 -3.0052200317382812e+02 8.4671897888183594e+01 1.6968600463867188e+02 -2.9841198730468750e+02 8.5690696716308594e+01 1.6943000793457031e+02 -2.9841198730468750e+02 8.4671997070312500e+01 1.6968600463867188e+02 -2.9630200195312500e+02 8.5690795898437500e+01 1.6943000793457031e+02 -2.9630200195312500e+02 8.4672401428222656e+01 1.6968600463867188e+02 -2.9208300781250000e+02 8.5691101074218750e+01 1.6943000793457031e+02 -2.9208300781250000e+02 8.4672500610351562e+01 1.6968600463867188e+02 -2.8997299194335938e+02 8.5691299438476562e+01 1.6943000793457031e+02 -2.8997399902343750e+02 8.4672698974609375e+01 1.6968600463867188e+02 -2.8786401367187500e+02 8.5691604614257812e+01 1.6943000793457031e+02 -2.8786401367187500e+02 8.4673004150390625e+01 1.6968600463867188e+02 -2.8575399780273438e+02 8.5691802978515625e+01 1.6943000793457031e+02 -2.8575399780273438e+02 8.4673301696777344e+01 1.6968600463867188e+02 -2.8364498901367188e+02 8.5692001342773438e+01 1.6943000793457031e+02 -2.8364498901367188e+02 8.4673500061035156e+01 1.6968600463867188e+02 -2.8153500366210938e+02 8.5692298889160156e+01 1.6943000793457031e+02 -2.8153500366210938e+02 8.4674201965332031e+01 1.6968600463867188e+02 -2.7731500244140625e+02 8.5692893981933594e+01 1.6943000793457031e+02 -2.7731600952148438e+02 8.4674499511718750e+01 1.6968600463867188e+02 -2.7520599365234375e+02 8.5693298339843750e+01 1.6943000793457031e+02 -2.7520599365234375e+02 8.4674797058105469e+01 1.6968600463867188e+02 -2.7309600830078125e+02 8.5693595886230469e+01 1.6943000793457031e+02 -2.7309600830078125e+02 8.4675201416015625e+01 1.6968600463867188e+02 -2.7098699951171875e+02 8.5694000244140625e+01 1.6943000793457031e+02 -2.7098699951171875e+02 8.4675605773925781e+01 1.6968600463867188e+02 -2.6887701416015625e+02 8.5694404602050781e+01 1.6943000793457031e+02 -2.6887701416015625e+02 8.4675994873046875e+01 1.6968600463867188e+02 -2.6676699829101562e+02 8.5694793701171875e+01 1.6943000793457031e+02 -2.6676800537109375e+02 8.4676902770996094e+01 1.6968600463867188e+02 -2.6254800415039062e+02 8.5695701599121094e+01 1.6943000793457031e+02 -2.6254800415039062e+02 8.4677398681640625e+01 1.6968600463867188e+02 -2.6043798828125000e+02 8.5696098327636719e+01 1.6943000793457031e+02 -2.6043899536132812e+02 8.4677894592285156e+01 1.6968600463867188e+02 -2.5832901000976562e+02 8.5696601867675781e+01 1.6943000793457031e+02 -2.5832901000976562e+02 8.4678298950195312e+01 1.6968600463867188e+02 -2.5621899414062500e+02 8.5697196960449219e+01 1.6943000793457031e+02 -2.5621899414062500e+02 8.4678901672363281e+01 1.6968600463867188e+02 -2.5410899353027344e+02 8.5697601318359375e+01 1.6943000793457031e+02 -2.5411001586914062e+02 8.4679298400878906e+01 1.6968501281738281e+02 -2.5200000000000000e+02 8.5698204040527344e+01 1.6943000793457031e+02 -2.5200000000000000e+02 8.4679901123046875e+01 1.6968501281738281e+02 -2.4988999938964844e+02 8.5698699951171875e+01 1.6943000793457031e+02 -2.4988999938964844e+02 8.4680999755859375e+01 1.6968501281738281e+02 -2.4567100524902344e+02 8.5699798583984375e+01 1.6943000793457031e+02 -2.4567100524902344e+02 8.4681602478027344e+01 1.6968501281738281e+02 -2.4356100463867188e+02 8.5700401306152344e+01 1.6943000793457031e+02 -2.4356100463867188e+02 8.4682197570800781e+01 1.6968501281738281e+02 -2.4145098876953125e+02 8.5701004028320312e+01 1.6943000793457031e+02 -2.4145199584960938e+02 8.4682800292968750e+01 1.6968501281738281e+02 -2.3934201049804688e+02 8.5701599121093750e+01 1.6943000793457031e+02 -2.3934201049804688e+02 8.4683403015136719e+01 1.6968501281738281e+02 -2.3723199462890625e+02 8.5702201843261719e+01 1.6943000793457031e+02 -2.3723199462890625e+02 8.4683998107910156e+01 1.6968501281738281e+02 -2.3512199401855469e+02 8.5702796936035156e+01 1.6943000793457031e+02 -2.3512300109863281e+02 8.4685302734375000e+01 1.6968501281738281e+02 -2.3090299987792969e+02 8.5704101562500000e+01 1.6943000793457031e+02 -2.3090299987792969e+02 8.4685897827148438e+01 1.6968501281738281e+02 -2.2879299926757812e+02 8.5704696655273438e+01 1.6942900085449219e+02 -2.2879399108886719e+02 8.4686599731445312e+01 1.6968501281738281e+02 -2.2668400573730469e+02 8.5705398559570312e+01 1.6942900085449219e+02 -2.2668400573730469e+02 8.4687301635742188e+01 1.6968501281738281e+02 -2.2457400512695312e+02 8.5706001281738281e+01 1.6942900085449219e+02 -2.2457499694824219e+02 8.4687904357910156e+01 1.6968501281738281e+02 -2.2246499633789062e+02 8.5706703186035156e+01 1.6942900085449219e+02 -2.2246499633789062e+02 8.4688598632812500e+01 1.6968501281738281e+02 -2.2035501098632812e+02 8.5707298278808594e+01 1.6942900085449219e+02 -2.2035501098632812e+02 8.4689300537109375e+01 1.6968501281738281e+02 -2.1824499511718750e+02 8.5708099365234375e+01 1.6942900085449219e+02 -2.1824600219726562e+02 8.4689605712890625e+01 1.6968501281738281e+02 -2.1719000244140625e+02 8.5708404541015625e+01 1.6942900085449219e+02 -2.1719099426269531e+02 8.4689994812011719e+01 1.6968501281738281e+02 -2.1613598632812500e+02 8.5708702087402344e+01 1.6942900085449219e+02 -2.1613598632812500e+02 8.4690299987792969e+01 1.6968501281738281e+02 -2.1508100891113281e+02 8.5708999633789062e+01 1.6942900085449219e+02 -2.1508100891113281e+02 8.4690597534179688e+01 1.6968501281738281e+02 -2.1402600097656250e+02 8.5709304809570312e+01 1.6942900085449219e+02 -2.1402600097656250e+02 8.4690895080566406e+01 1.6968501281738281e+02 -2.1297100830078125e+02 8.5709701538085938e+01 1.6942900085449219e+02 -2.1297200012207031e+02 8.4691505432128906e+01 1.6968501281738281e+02 -2.1086099243164062e+02 8.5710304260253906e+01 1.6942900085449219e+02 -2.1086199951171875e+02 8.4691802978515625e+01 1.6968501281738281e+02 -2.0980699157714844e+02 8.5710601806640625e+01 1.6942900085449219e+02 -2.0980699157714844e+02 8.4692100524902344e+01 1.6968501281738281e+02 -2.0875199890136719e+02 8.5710899353027344e+01 1.6942900085449219e+02 -2.0875199890136719e+02 8.4692405700683594e+01 1.6968501281738281e+02 -2.0769700622558594e+02 8.5711204528808594e+01 1.6942900085449219e+02 -2.0769700622558594e+02 8.4692703247070312e+01 1.6968501281738281e+02 -2.0664199829101562e+02 8.5711502075195312e+01 1.6942900085449219e+02 -2.0664300537109375e+02 8.4693000793457031e+01 1.6968399047851562e+02 -2.0558700561523438e+02 8.5711799621582031e+01 1.6942900085449219e+02 -2.0558799743652344e+02 8.4693199157714844e+01 1.6968399047851562e+02 -2.0453199768066406e+02 8.5711997985839844e+01 1.6942900085449219e+02 -2.0453298950195312e+02 8.4693794250488281e+01 1.6968399047851562e+02 -2.0242300415039062e+02 8.5712501525878906e+01 1.6942900085449219e+02 -2.0242300415039062e+02 8.4694099426269531e+01 1.6968399047851562e+02 -2.0136801147460938e+02 8.5712799072265625e+01 1.6942900085449219e+02 -2.0136801147460938e+02 8.4694305419921875e+01 1.6968399047851562e+02 -2.0031300354003906e+02 8.5713104248046875e+01 1.6942900085449219e+02 -2.0031399536132812e+02 8.4694496154785156e+01 1.6968399047851562e+02 -1.9925799560546875e+02 8.5713294982910156e+01 1.6942900085449219e+02 -1.9925900268554688e+02 8.4694801330566406e+01 1.6968399047851562e+02 -1.9820399475097656e+02 8.5713500976562500e+01 1.6942900085449219e+02 -1.9820399475097656e+02 8.4694999694824219e+01 1.6968399047851562e+02 -1.9714898681640625e+02 8.5713798522949219e+01 1.6942900085449219e+02 -1.9714898681640625e+02 8.4695503234863281e+01 1.6968399047851562e+02 -1.9503900146484375e+02 8.5714302062988281e+01 1.6942900085449219e+02 -1.9503900146484375e+02 8.4695693969726562e+01 1.6968399047851562e+02 -1.9398400878906250e+02 8.5714401245117188e+01 1.6942900085449219e+02 -1.9398500061035156e+02 8.4695899963378906e+01 1.6968399047851562e+02 -1.9292900085449219e+02 8.5714698791503906e+01 1.6942900085449219e+02 -1.9292999267578125e+02 8.4696098327636719e+01 1.6968399047851562e+02 -1.9187500000000000e+02 8.5714897155761719e+01 1.6942900085449219e+02 -1.9187500000000000e+02 8.4696296691894531e+01 1.6968399047851562e+02 -1.9081999206542969e+02 8.5715003967285156e+01 1.6942900085449219e+02 -1.9081999206542969e+02 8.4696502685546875e+01 1.6968399047851562e+02 -1.8976499938964844e+02 8.5715194702148438e+01 1.6942900085449219e+02 -1.8976499938964844e+02 8.4696800231933594e+01 1.6968399047851562e+02 -1.8765499877929688e+02 8.5715599060058594e+01 1.6942900085449219e+02 -1.8765600585937500e+02 8.4696998596191406e+01 1.6968399047851562e+02 -1.8660000610351562e+02 8.5715705871582031e+01 1.6942900085449219e+02 -1.8660099792480469e+02 8.4697204589843750e+01 1.6968399047851562e+02 -1.8554598999023438e+02 8.5715896606445312e+01 1.6942900085449219e+02 -1.8554598999023438e+02 8.4697296142578125e+01 1.6968399047851562e+02 -1.8449099731445312e+02 8.5716003417968750e+01 1.6942900085449219e+02 -1.8449099731445312e+02 8.4697402954101562e+01 1.6968399047851562e+02 -1.8343600463867188e+02 8.5716201782226562e+01 1.6942900085449219e+02 -1.8343600463867188e+02 8.4697593688964844e+01 1.6968399047851562e+02 -1.8238099670410156e+02 8.5716300964355469e+01 1.6942900085449219e+02 -1.8238099670410156e+02 8.4697799682617188e+01 1.6968399047851562e+02 -1.8027099609375000e+02 8.5716499328613281e+01 1.6942900085449219e+02 -1.8027200317382812e+02 8.4697898864746094e+01 1.6968399047851562e+02 -1.7921699523925781e+02 8.5716598510742188e+01 1.6942900085449219e+02 -1.7921699523925781e+02 8.4697998046875000e+01 1.6968399047851562e+02 -1.7816198730468750e+02 8.5716705322265625e+01 1.6942900085449219e+02 -1.7816198730468750e+02 8.4698104858398438e+01 1.6968399047851562e+02 -1.7710700988769531e+02 8.5716796875000000e+01 1.6942900085449219e+02 -1.7710700988769531e+02 8.4698104858398438e+01 1.6968399047851562e+02 -1.7605200195312500e+02 8.5716903686523438e+01 1.6942900085449219e+02 -1.7605200195312500e+02 8.4698196411132812e+01 1.6968399047851562e+02 -1.7499700927734375e+02 8.5716903686523438e+01 1.6942900085449219e+02 -1.7499800109863281e+02 8.4698295593261719e+01 1.6968399047851562e+02 -1.7288800048828125e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.7288800048828125e+02 8.4698295593261719e+01 1.6968399047851562e+02 -1.7183299255371094e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.7183299255371094e+02 8.4698402404785156e+01 1.6968399047851562e+02 -1.7077799987792969e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.7077799987792969e+02 8.4698402404785156e+01 1.6968399047851562e+02 -1.6972300720214844e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.6972300720214844e+02 8.4698402404785156e+01 1.6968399047851562e+02 -1.6866900634765625e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.6866900634765625e+02 8.4698402404785156e+01 1.6968399047851562e+02 -1.6761399841308594e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.6761399841308594e+02 8.4698295593261719e+01 1.6968399047851562e+02 -1.6550399780273438e+02 8.5717094421386719e+01 1.6942900085449219e+02 -1.6550399780273438e+02 8.4698196411132812e+01 1.6968399047851562e+02 -1.6444900512695312e+02 8.5717002868652344e+01 1.6942900085449219e+02 -1.6444900512695312e+02 8.4698196411132812e+01 1.6968399047851562e+02 -1.6339399719238281e+02 8.5716903686523438e+01 1.6942900085449219e+02 -1.6339399719238281e+02 8.4698104858398438e+01 1.6968399047851562e+02 -1.6233999633789062e+02 8.5716903686523438e+01 1.6942900085449219e+02 -1.6233999633789062e+02 8.4698104858398438e+01 1.6968399047851562e+02 -1.6128500366210938e+02 8.5716796875000000e+01 1.6942900085449219e+02 -1.6128500366210938e+02 8.4697898864746094e+01 1.6968399047851562e+02 -1.6022999572753906e+02 8.5716705322265625e+01 1.6942900085449219e+02 -1.6022999572753906e+02 8.4697700500488281e+01 1.6968399047851562e+02 -1.5812001037597656e+02 8.5716499328613281e+01 1.6942900085449219e+02 -1.5812001037597656e+02 8.4697593688964844e+01 1.6968399047851562e+02 -1.5706500244140625e+02 8.5716300964355469e+01 1.6942900085449219e+02 -1.5706500244140625e+02 8.4697502136230469e+01 1.6968399047851562e+02 -1.5601100158691406e+02 8.5716201782226562e+01 1.6942900085449219e+02 -1.5600999450683594e+02 8.4697296142578125e+01 1.6968399047851562e+02 -1.5495599365234375e+02 8.5716003417968750e+01 1.6942900085449219e+02 -1.5495599365234375e+02 8.4697097778320312e+01 1.6968399047851562e+02 -1.5390100097656250e+02 8.5715896606445312e+01 1.6942900085449219e+02 -1.5390100097656250e+02 8.4696899414062500e+01 1.6968399047851562e+02 -1.5284599304199219e+02 8.5715705871582031e+01 1.6942900085449219e+02 -1.5284599304199219e+02 8.4696701049804688e+01 1.6968399047851562e+02 -1.5179100036621094e+02 8.5715499877929688e+01 1.6942900085449219e+02 -1.5179100036621094e+02 8.4696296691894531e+01 1.6968399047851562e+02 -1.4968200683593750e+02 8.5715103149414062e+01 1.6942900085449219e+02 -1.4968099975585938e+02 8.4696098327636719e+01 1.6968399047851562e+02 -1.4862699890136719e+02 8.5714897155761719e+01 1.6942900085449219e+02 -1.4862600708007812e+02 8.4695899963378906e+01 1.6968399047851562e+02 -1.4757199096679688e+02 8.5714599609375000e+01 1.6942900085449219e+02 -1.4757199096679688e+02 8.4695602416992188e+01 1.6968399047851562e+02 -1.4651699829101562e+02 8.5714302062988281e+01 1.6942900085449219e+02 -1.4651699829101562e+02 8.4695304870605469e+01 1.6968399047851562e+02 -1.4546200561523438e+02 8.5714103698730469e+01 1.6942900085449219e+02 -1.4546200561523438e+02 8.4694999694824219e+01 1.6968399047851562e+02 -1.4440800476074219e+02 8.5713798522949219e+01 1.6942900085449219e+02 -1.4440699768066406e+02 8.4694396972656250e+01 1.6968399047851562e+02 -1.4229800415039062e+02 8.5713104248046875e+01 1.6942900085449219e+02 -1.4229699707031250e+02 8.4694099426269531e+01 1.6968399047851562e+02 -1.4124299621582031e+02 8.5712799072265625e+01 1.6942900085449219e+02 -1.4124299621582031e+02 8.4693702697753906e+01 1.6968399047851562e+02 -1.4018798828125000e+02 8.5712402343750000e+01 1.6942900085449219e+02 -1.4018798828125000e+02 8.4693298339843750e+01 1.6968399047851562e+02 -1.3913301086425781e+02 8.5712097167968750e+01 1.6942900085449219e+02 -1.3913301086425781e+02 8.4692901611328125e+01 1.6968399047851562e+02 -1.3807901000976562e+02 8.5711601257324219e+01 1.6942900085449219e+02 -1.3807800292968750e+02 8.4692497253417969e+01 1.6968501281738281e+02 -1.3702400207519531e+02 8.5711204528808594e+01 1.6942900085449219e+02 -1.3702299499511719e+02 8.4691505432128906e+01 1.6968501281738281e+02 -1.3491400146484375e+02 8.5710304260253906e+01 1.6942900085449219e+02 -1.3491400146484375e+02 8.4691001892089844e+01 1.6968501281738281e+02 -1.3385899353027344e+02 8.5709800720214844e+01 1.6942900085449219e+02 -1.3385899353027344e+02 8.4690498352050781e+01 1.6968501281738281e+02 -1.3280400085449219e+02 8.5709304809570312e+01 1.6942900085449219e+02 -1.3280400085449219e+02 8.4689994812011719e+01 1.6968501281738281e+02 -1.3175000000000000e+02 8.5708702087402344e+01 1.6942900085449219e+02 -1.3174900817871094e+02 8.4689399719238281e+01 1.6968501281738281e+02 -1.3069500732421875e+02 8.5708198547363281e+01 1.6942900085449219e+02 -1.3069400024414062e+02 8.4688796997070312e+01 1.6968501281738281e+02 -1.2963999938964844e+02 8.5707595825195312e+01 1.6942900085449219e+02 -1.2963899230957031e+02 8.4687599182128906e+01 1.6968501281738281e+02 -1.2752999114990234e+02 8.6513603210449219e+01 1.6884199523925781e+02 -6.6348403930664062e+01 8.6511497497558594e+01 1.6884300231933594e+02 -6.4238800048828125e+01 8.6509506225585938e+01 1.6884300231933594e+02 -6.2129199981689453e+01 8.6507499694824219e+01 1.6884300231933594e+02 -6.0019599914550781e+01 8.6505599975585938e+01 1.6884300231933594e+02 -5.7910099029541016e+01 8.6503799438476562e+01 1.6884300231933594e+02 -5.5800502777099609e+01 8.6500503540039062e+01 1.6884300231933594e+02 -5.1581401824951172e+01 8.6498901367187500e+01 1.6884300231933594e+02 -4.9471797943115234e+01 8.6497497558593750e+01 1.6884399414062500e+02 -4.7362300872802734e+01 8.6496299743652344e+01 1.6884399414062500e+02 -4.5252799987792969e+01 8.6495101928710938e+01 1.6884399414062500e+02 -4.3143199920654297e+01 8.6494102478027344e+01 1.6884399414062500e+02 -4.1033699035644531e+01 8.6493202209472656e+01 1.6884399414062500e+02 -3.8924198150634766e+01 8.6491798400878906e+01 1.6884399414062500e+02 -3.4705097198486328e+01 8.6491401672363281e+01 1.6884399414062500e+02 -3.2595703125000000e+01 8.6491104125976562e+01 1.6884399414062500e+02 -3.0486099243164062e+01 8.6491004943847656e+01 1.6884399414062500e+02 -2.8376699447631836e+01 8.6491104125976562e+01 1.6884399414062500e+02 -2.6267200469970703e+01 8.6491302490234375e+01 1.6884399414062500e+02 -2.4157699584960938e+01 8.6492393493652344e+01 1.6884399414062500e+02 -1.9938800811767578e+01 8.6493301391601562e+01 1.6884399414062500e+02 -1.7829299926757812e+01 8.6494400024414062e+01 1.6884399414062500e+02 -1.5719900131225586e+01 8.6495697021484375e+01 1.6884399414062500e+02 -1.3610500335693359e+01 8.6497200012207031e+01 1.6884399414062500e+02 -1.1501000404357910e+01 8.6499000549316406e+01 1.6884300231933594e+02 -9.3915796279907227e+00 8.6503196716308594e+01 1.6884300231933594e+02 -5.1727099418640137e+00 8.6505706787109375e+01 1.6884300231933594e+02 -3.0632998943328857e+00 8.6508399963378906e+01 1.6884300231933594e+02 -9.5389103889465332e-01 8.6511405944824219e+01 1.6884300231933594e+02 1.1556099653244019e+00 8.6514602661132812e+01 1.6884199523925781e+02 3.2649898529052734e+00 8.6518104553222656e+01 1.6884199523925781e+02 5.3743901252746582e+00 8.6525901794433594e+01 1.6884199523925781e+02 9.5932102203369141e+00 8.6530204772949219e+01 1.6884100341796875e+02 1.1702599525451660e+01 8.6534698486328125e+01 1.6884100341796875e+02 1.3812000274658203e+01 8.6539596557617188e+01 1.6884100341796875e+02 1.5921299934387207e+01 8.6544898986816406e+01 1.6884001159667969e+02 1.8030601501464844e+01 8.6550498962402344e+01 1.6884001159667969e+02 2.0139898300170898e+01 8.6562797546386719e+01 1.6883898925781250e+02 2.4358499526977539e+01 8.6569396972656250e+01 1.6883898925781250e+02 2.6467901229858398e+01 8.6576301574707031e+01 1.6883799743652344e+02 2.8577299118041992e+01 8.6583503723144531e+01 1.6883799743652344e+02 3.0686700820922852e+01 8.6590904235839844e+01 1.6883699035644531e+02 3.2796100616455078e+01 8.6598503112792969e+01 1.6883699035644531e+02 3.4905601501464844e+01 8.6614105224609375e+01 1.6883599853515625e+02 3.9124702453613281e+01 8.6622093200683594e+01 1.6883500671386719e+02 4.1234298706054688e+01 8.6630004882812500e+01 1.6883500671386719e+02 4.3343997955322266e+01 8.6637802124023438e+01 1.6883399963378906e+02 4.5453601837158203e+01 8.6645599365234375e+01 1.6883399963378906e+02 4.7563400268554688e+01 8.6653297424316406e+01 1.6883300781250000e+02 4.9673198699951172e+01 8.6668098449707031e+01 1.6883200073242188e+02 5.3892799377441406e+01 8.6675102233886719e+01 1.6883100891113281e+02 5.6002696990966797e+01 8.6681900024414062e+01 1.6883100891113281e+02 5.8112701416015625e+01 8.6688301086425781e+01 1.6883100891113281e+02 6.0222702026367188e+01 8.6694297790527344e+01 1.6883000183105469e+02 6.2332702636718750e+01 8.6699905395507812e+01 1.6883000183105469e+02 6.4442703247070312e+01 8.6705001831054688e+01 1.6883000183105469e+02 6.6552803039550781e+01 8.6713600158691406e+01 1.6882899475097656e+02 7.0773200988769531e+01 8.4622299194335938e+01 1.6969000244140625e+02 -6.2131099700927734e+01 8.4620300292968750e+01 1.6969000244140625e+02 -6.0021400451660156e+01 8.5639198303222656e+01 1.6943399047851562e+02 -6.0020500183105469e+01 8.4618400573730469e+01 1.6969000244140625e+02 -5.7911796569824219e+01 8.5637298583984375e+01 1.6943399047851562e+02 -5.7910900115966797e+01 8.4616600036621094e+01 1.6969000244140625e+02 -5.5802101135253906e+01 8.5635498046875000e+01 1.6943399047851562e+02 -5.5801300048828125e+01 8.4613304138183594e+01 1.6969000244140625e+02 -5.1582798004150391e+01 8.5632194519042969e+01 1.6943499755859375e+02 -5.1582099914550781e+01 8.4611801147460938e+01 1.6969000244140625e+02 -4.9473201751708984e+01 8.5630599975585938e+01 1.6943499755859375e+02 -4.9472499847412109e+01 8.4610298156738281e+01 1.6969000244140625e+02 -4.7363502502441406e+01 8.5629302978515625e+01 1.6943499755859375e+02 -4.7362899780273438e+01 8.4609100341796875e+01 1.6969000244140625e+02 -4.5253898620605469e+01 8.5628005981445312e+01 1.6943499755859375e+02 -4.5253299713134766e+01 8.4607902526855469e+01 1.6969099426269531e+02 -4.3144302368164062e+01 8.5626800537109375e+01 1.6943499755859375e+02 -4.3143699645996094e+01 8.4606903076171875e+01 1.6969099426269531e+02 -4.1034603118896484e+01 8.5625701904296875e+01 1.6943499755859375e+02 -4.1034099578857422e+01 8.4606002807617188e+01 1.6969099426269531e+02 -3.8924999237060547e+01 8.5624900817871094e+01 1.6943499755859375e+02 -3.8924499511718750e+01 8.4604598999023438e+01 1.6969099426269531e+02 -3.4705699920654297e+01 8.5623504638671875e+01 1.6943499755859375e+02 -3.4705398559570312e+01 8.4604202270507812e+01 1.6969099426269531e+02 -3.2596000671386719e+01 8.5623100280761719e+01 1.6943499755859375e+02 -3.2595798492431641e+01 8.4603897094726562e+01 1.6969099426269531e+02 -3.0486301422119141e+01 8.5622802734375000e+01 1.6943499755859375e+02 -3.0486301422119141e+01 8.4603797912597656e+01 1.6969099426269531e+02 -2.8376699447631836e+01 8.5622695922851562e+01 1.6943499755859375e+02 -2.8376699447631836e+01 8.4603897094726562e+01 1.6969099426269531e+02 -2.6267000198364258e+01 8.5622802734375000e+01 1.6943499755859375e+02 -2.6267099380493164e+01 8.4604103088378906e+01 1.6969099426269531e+02 -2.4157400131225586e+01 8.5623100280761719e+01 1.6943499755859375e+02 -2.4157600402832031e+01 8.4605300903320312e+01 1.6969099426269531e+02 -1.9938100814819336e+01 8.5624099731445312e+01 1.6943499755859375e+02 -1.9938400268554688e+01 8.4606101989746094e+01 1.6969099426269531e+02 -1.7828399658203125e+01 8.5625000000000000e+01 1.6943499755859375e+02 -1.7828901290893555e+01 8.4607200622558594e+01 1.6969099426269531e+02 -1.5718798637390137e+01 8.5626106262207031e+01 1.6943499755859375e+02 -1.5719400405883789e+01 8.4608505249023438e+01 1.6969000244140625e+02 -1.3609100341796875e+01 8.5627395629882812e+01 1.6943499755859375e+02 -1.3609799385070801e+01 8.4610000610351562e+01 1.6969000244140625e+02 -1.1499500274658203e+01 8.5628898620605469e+01 1.6943499755859375e+02 -1.1500299453735352e+01 8.4611801147460938e+01 1.6969000244140625e+02 -9.3898000717163086e+00 8.5630699157714844e+01 1.6943499755859375e+02 -9.3906908035278320e+00 8.4615997314453125e+01 1.6969000244140625e+02 -5.1704998016357422e+00 8.5634902954101562e+01 1.6943399047851562e+02 -5.1716899871826172e+00 8.4618499755859375e+01 1.6969000244140625e+02 -3.0608000755310059e+00 8.5637397766113281e+01 1.6943399047851562e+02 -3.0622000694274902e+00 8.4621200561523438e+01 1.6969000244140625e+02 -9.5120900869369507e-01 8.5640106201171875e+01 1.6943399047851562e+02 -9.5260900259017944e-01 8.4624198913574219e+01 1.6968899536132812e+02 1.1584099531173706e+00 8.5643096923828125e+01 1.6943399047851562e+02 1.1569199562072754e+00 8.4627395629882812e+01 1.6968899536132812e+02 3.2681100368499756e+00 8.5646301269531250e+01 1.6943399047851562e+02 3.2664198875427246e+00 8.4630897521972656e+01 1.6968899536132812e+02 5.3776998519897461e+00 8.5649803161621094e+01 1.6943299865722656e+02 5.3759999275207520e+00 8.4638793945312500e+01 1.6968800354003906e+02 9.5970001220703125e+00 8.5657592773437500e+01 1.6943299865722656e+02 9.5949096679687500e+00 8.4642997741699219e+01 1.6968800354003906e+02 1.1706699371337891e+01 8.5661903381347656e+01 1.6943299865722656e+02 1.1704500198364258e+01 8.4647605895996094e+01 1.6968800354003906e+02 1.3816299438476562e+01 8.5666496276855469e+01 1.6943200683593750e+02 1.3814000129699707e+01 8.4652496337890625e+01 1.6968699645996094e+02 1.5925999641418457e+01 8.5671401977539062e+01 1.6943200683593750e+02 1.5923500061035156e+01 8.4657806396484375e+01 1.6968699645996094e+02 1.8035600662231445e+01 8.5676605224609375e+01 1.6943200683593750e+02 1.8032899856567383e+01 8.4663398742675781e+01 1.6968699645996094e+02 2.0145299911499023e+01 8.5682304382324219e+01 1.6943099975585938e+02 2.0142400741577148e+01 8.4675796508789062e+01 1.6968600463867188e+02 2.4364599227905273e+01 8.5694602966308594e+01 1.6943000793457031e+02 2.4361299514770508e+01 8.4682395935058594e+01 1.6968501281738281e+02 2.6474100112915039e+01 8.5701194763183594e+01 1.6943000793457031e+02 2.6470899581909180e+01 8.4689399719238281e+01 1.6968501281738281e+02 2.8583801269531250e+01 8.5708099365234375e+01 1.6942900085449219e+02 2.8580301284790039e+01 8.4696502685546875e+01 1.6968399047851562e+02 3.0693401336669922e+01 8.5715301513671875e+01 1.6942900085449219e+02 3.0689901351928711e+01 8.4703994750976562e+01 1.6968399047851562e+02 3.2803100585937500e+01 8.5722702026367188e+01 1.6942800903320312e+02 3.2799400329589844e+01 8.4711593627929688e+01 1.6968299865722656e+02 3.4912700653076172e+01 8.5730400085449219e+01 1.6942800903320312e+02 3.4908897399902344e+01 8.4727302551269531e+01 1.6968199157714844e+02 3.9131999969482422e+01 8.5745994567871094e+01 1.6942700195312500e+02 3.9128097534179688e+01 8.4735298156738281e+01 1.6968199157714844e+02 4.1241600036621094e+01 8.5753906250000000e+01 1.6942599487304688e+02 4.1237701416015625e+01 8.4743202209472656e+01 1.6968099975585938e+02 4.3351299285888672e+01 8.5761802673339844e+01 1.6942599487304688e+02 4.3347400665283203e+01 8.4750999450683594e+01 1.6968099975585938e+02 4.5460899353027344e+01 8.5769699096679688e+01 1.6942500305175781e+02 4.5457000732421875e+01 8.4758903503417969e+01 1.6967999267578125e+02 4.7570602416992188e+01 8.5777496337890625e+01 1.6942399597167969e+02 4.7566699981689453e+01 8.4766502380371094e+01 1.6967900085449219e+02 4.9680198669433594e+01 8.5785202026367188e+01 1.6942399597167969e+02 4.9676399230957031e+01 8.4781402587890625e+01 1.6967800903320312e+02 5.3899501800537109e+01 8.5800003051757812e+01 1.6942300415039062e+02 5.3895896911621094e+01 8.4788497924804688e+01 1.6967800903320312e+02 5.6009098052978516e+01 8.5807098388671875e+01 1.6942199707031250e+02 5.6005702972412109e+01 8.4795196533203125e+01 1.6967700195312500e+02 5.8118701934814453e+01 8.5813796997070312e+01 1.6942199707031250e+02 5.8115501403808594e+01 8.4801704406738281e+01 1.6967700195312500e+02 6.0228401184082031e+01 8.5820198059082031e+01 1.6942199707031250e+02 6.0225299835205078e+01 8.4807701110839844e+01 1.6967700195312500e+02 6.2337997436523438e+01 8.5826301574707031e+01 1.6942100524902344e+02 6.2335201263427734e+01 8.4813293457031250e+01 1.6967601013183594e+02 6.4447700500488281e+01 8.5831802368164062e+01 1.6942100524902344e+02 6.4445098876953125e+01 8.4818397521972656e+01 1.6967601013183594e+02 6.6557304382324219e+01 8.5836898803710938e+01 1.6941999816894531e+02 6.6554893493652344e+01 8.4826995849609375e+01 1.6967498779296875e+02 7.0776596069335938e+01 8.5845497131347656e+01 1.6941999816894531e+02 7.0774803161621094e+01 8.4830406188964844e+01 1.6967498779296875e+02 7.2886306762695312e+01 8.5848899841308594e+01 1.6941900634765625e+02 7.2884796142578125e+01 8.4833198547363281e+01 1.6967498779296875e+02 7.4995895385742188e+01 8.5851699829101562e+01 1.6941900634765625e+02 7.4994697570800781e+01 8.4835205078125000e+01 1.6967498779296875e+02 7.7105598449707031e+01 8.5853706359863281e+01 1.6941900634765625e+02 7.7104705810546875e+01 8.4836296081542969e+01 1.6967498779296875e+02 7.8971496582031250e+01 8.5855003356933594e+01 1.6941900634765625e+02 7.9214797973632812e+01 8.6717002868652344e+01 1.6882899475097656e+02 7.2883399963378906e+01 8.6719696044921875e+01 1.6882899475097656e+02 7.4993698120117188e+01 8.6721801757812500e+01 1.6882800292968750e+02 7.7104003906250000e+01 8.6723098754882812e+01 1.6882800292968750e+02 7.9214401245117188e+01 8.6723602294921875e+01 1.6882800292968750e+02 8.1324798583984375e+01 8.6722000122070312e+01 1.6882800292968750e+02 8.5545700073242188e+01 8.6719902038574219e+01 1.6882899475097656e+02 8.7656196594238281e+01 8.6716804504394531e+01 1.6882899475097656e+02 8.9766799926757812e+01 8.6712600708007812e+01 1.6882899475097656e+02 9.1877403259277344e+01 8.6707504272460938e+01 1.6882899475097656e+02 9.3988098144531250e+01 8.6704406738281250e+01 1.6883000183105469e+02 9.5043395996093750e+01 8.6701103210449219e+01 1.6883000183105469e+02 9.6098800659179688e+01 8.6693695068359375e+01 1.6883000183105469e+02 9.8209503173828125e+01 8.6689498901367188e+01 1.6883100891113281e+02 9.9264900207519531e+01 8.6685005187988281e+01 1.6883100891113281e+02 1.0031999969482422e+02 8.6680206298828125e+01 1.6883100891113281e+02 1.0137599945068359e+02 8.6675102233886719e+01 1.6883100891113281e+02 1.0243099975585938e+02 8.6663902282714844e+01 1.6883200073242188e+02 1.0454199981689453e+02 8.6651397705078125e+01 1.6883300781250000e+02 1.0665299987792969e+02 8.6637496948242188e+01 1.6883399963378906e+02 1.0876399993896484e+02 8.6630004882812500e+01 1.6883500671386719e+02 1.0981900024414062e+02 8.6613899230957031e+01 1.6883599853515625e+02 1.1193000030517578e+02 8.6596305847167969e+01 1.6883699035644531e+02 1.1404100036621094e+02 8.4836494445800781e+01 1.6967498779296875e+02 7.9215202331542969e+01 8.4836997985839844e+01 1.6967498779296875e+02 8.1324798583984375e+01 8.5855499267578125e+01 1.6941900634765625e+02 8.1324798583984375e+01 8.4835403442382812e+01 1.6967498779296875e+02 8.5544197082519531e+01 8.5854003906250000e+01 1.6941900634765625e+02 8.5545005798339844e+01 8.4833305358886719e+01 1.6967498779296875e+02 8.7653800964355469e+01 8.5851806640625000e+01 1.6941900634765625e+02 8.7655097961425781e+01 8.4830200195312500e+01 1.6967498779296875e+02 8.9763496398925781e+01 8.5848693847656250e+01 1.6941900634765625e+02 8.9765304565429688e+01 8.4825996398925781e+01 1.6967498779296875e+02 9.1873100280761719e+01 8.5844596862792969e+01 1.6941999816894531e+02 9.1875396728515625e+01 8.4820800781250000e+01 1.6967601013183594e+02 9.3982803344726562e+01 8.5839401245117188e+01 1.6941999816894531e+02 9.3985603332519531e+01 8.4817794799804688e+01 1.6967601013183594e+02 9.5037605285644531e+01 8.5836402893066406e+01 1.6941999816894531e+02 9.5040702819824219e+01 8.4814498901367188e+01 1.6967601013183594e+02 9.6092399597167969e+01 8.5833099365234375e+01 1.6942100524902344e+02 9.6095802307128906e+01 8.4807098388671875e+01 1.6967700195312500e+02 9.8201995849609375e+01 8.5825599670410156e+01 1.6942100524902344e+02 9.8206001281738281e+01 8.4802795410156250e+01 1.6967700195312500e+02 9.9256797790527344e+01 8.5821395874023438e+01 1.6942100524902344e+02 9.9261100769042969e+01 8.4798400878906250e+01 1.6967700195312500e+02 1.0031200408935547e+02 8.5817001342773438e+01 1.6942199707031250e+02 1.0031600189208984e+02 8.4793502807617188e+01 1.6967700195312500e+02 1.0136699676513672e+02 8.5812095642089844e+01 1.6942199707031250e+02 1.0137099456787109e+02 8.4788398742675781e+01 1.6967800903320312e+02 1.0242099761962891e+02 8.5807006835937500e+01 1.6942199707031250e+02 1.0242600250244141e+02 8.4777198791503906e+01 1.6967900085449219e+02 1.0453099822998047e+02 8.5795799255371094e+01 1.6942300415039062e+02 1.0453700256347656e+02 8.4764602661132812e+01 1.6967999267578125e+02 1.0664099884033203e+02 8.5783302307128906e+01 1.6942399597167969e+02 1.0664700317382812e+02 8.4750694274902344e+01 1.6968099975585938e+02 1.0875000000000000e+02 8.5769302368164062e+01 1.6942500305175781e+02 1.0875699615478516e+02 8.4743202209472656e+01 1.6968099975585938e+02 1.0980500030517578e+02 8.5761802673339844e+01 1.6942599487304688e+02 1.0981299591064453e+02 8.4727104187011719e+01 1.6968199157714844e+02 1.1191500091552734e+02 8.5745697021484375e+01 1.6942700195312500e+02 1.1192300415039062e+02 8.4709396362304688e+01 1.6968299865722656e+02 1.1402400207519531e+02 8.5728103637695312e+01 1.6942800903320312e+02 1.1403299713134766e+02 8.4703994750976562e+01 1.6968399047851562e+02 1.1462999725341797e+02 8.5708999633789062e+01 1.6942900085449219e+02 1.1614400482177734e+02 8.4690299987792969e+01 1.6968501281738281e+02 1.1613400268554688e+02 8.4680099487304688e+01 1.6968501281738281e+02 1.1718899536132812e+02 8.5698905944824219e+01 1.6943000793457031e+02 1.1719900512695312e+02 8.4677398681640625e+01 1.6968600463867188e+02 1.1745200347900391e+02 8.5696197509765625e+01 1.6943000793457031e+02 1.1746299743652344e+02 8.4676803588867188e+01 1.6968600463867188e+02 1.1751799774169922e+02 8.5695495605468750e+01 1.6943000793457031e+02 1.1752899932861328e+02 8.4676597595214844e+01 1.6968600463867188e+02 1.1753500366210938e+02 8.5691604614257812e+01 1.6941801452636719e+02 1.1753799438476562e+02 8.6577201843261719e+01 1.6883799743652344e+02 1.1615200042724609e+02 8.6567001342773438e+01 1.6883898925781250e+02 1.1720800018310547e+02 8.6564300537109375e+01 1.6883898925781250e+02 1.1747200012207031e+02 8.6563697814941406e+01 1.6883898925781250e+02 1.1753900146484375e+02 8.6549598693847656e+01 1.6882699584960938e+02 1.1754299926757812e+02 6.8196403503417969e+01 1.3862199401855469e+02 2.1501399230957031e+02 6.8196495056152344e+01 1.3861199951171875e+02 2.1502900695800781e+02 6.8196495056152344e+01 1.3860200500488281e+02 2.1504499816894531e+02 6.8196601867675781e+01 1.3858200073242188e+02 2.1507699584960938e+02 6.8196899414062500e+01 1.3854100036621094e+02 2.1513900756835938e+02 6.8197402954101562e+01 1.3845999145507812e+02 2.1526400756835938e+02 6.8205200195312500e+01 1.3561900329589844e+02 2.1864900207519531e+02 6.8198303222656250e+01 1.3829499816894531e+02 2.1551100158691406e+02 6.8199905395507812e+01 1.3795300292968750e+02 2.1599600219726562e+02 6.8202499389648438e+01 1.3722999572753906e+02 2.1692900085449219e+02 6.8196601867675781e+01 1.2427199554443359e+02 2.2374600219726562e+02 6.8200904846191406e+01 1.2887899780273438e+02 2.2275000000000000e+02 6.8202804565429688e+01 1.3043800354003906e+02 2.2212399291992188e+02 6.8203704833984375e+01 1.3167298889160156e+02 2.2136700439453125e+02 6.8204002380371094e+01 1.3199501037597656e+02 2.2116899108886719e+02 6.8205696105957031e+01 1.3445700073242188e+02 2.1965899658203125e+02 6.8196403503417969e+01 1.7081199645996094e+02 1.1462999725341797e+02 6.8196403503417969e+01 1.6954701232910156e+02 1.3232398986816406e+02 6.8196403503417969e+01 1.6684199523925781e+02 1.4983500671386719e+02 6.8196403503417969e+01 1.6213299560546875e+02 1.6723300170898438e+02 6.8196403503417969e+01 1.5500900268554688e+02 1.8425500488281250e+02 6.8196403503417969e+01 1.4646400451660156e+02 2.0121600341796875e+02 7.3030899047851562e+01 1.3854299926757812e+02 2.1474899291992188e+02 7.9600601196289062e+01 1.2856100463867188e+02 2.2195300292968750e+02 7.9489700317382812e+01 1.3609600830078125e+02 2.1688899230957031e+02 7.9381698608398438e+01 1.3530799865722656e+02 2.1772700500488281e+02 7.8188102722167969e+01 1.2849299621582031e+02 2.2243400573730469e+02 7.7927795410156250e+01 1.3152299499511719e+02 2.2101199340820312e+02 7.9273399353027344e+01 1.3210499572753906e+02 2.2026400756835938e+02 7.7862098693847656e+01 1.3228700256347656e+02 2.2065299987792969e+02 7.7956298828125000e+01 1.3570300292968750e+02 2.1795300292968750e+02 7.8057800292968750e+01 1.3653999328613281e+02 2.1705799865722656e+02 7.8745605468750000e+01 1.2511000061035156e+02 2.2324099731445312e+02 7.9713096618652344e+01 1.2531200408935547e+02 2.2299798583984375e+02 8.0555702209472656e+01 1.2543900299072266e+02 2.2244100952148438e+02 1.2033300018310547e+02 9.7654602050781250e+01 1.1796399688720703e+02 7.3058799743652344e+01 1.3164801025390625e+02 2.2127699279785156e+02 1.0676200103759766e+02 1.4851300048828125e+02 -3.4515100097656250e+02 1.0589499664306641e+02 1.4980099487304688e+02 -3.4510202026367188e+02 1.0568199920654297e+02 1.4997000122070312e+02 -3.4507901000976562e+02 1.0470599365234375e+02 1.5074400329589844e+02 -3.4496899414062500e+02 1.0416399383544922e+02 1.5095100402832031e+02 -3.4488998413085938e+02 1.0327400207519531e+02 1.5128999328613281e+02 -3.4476000976562500e+02 1.0240499877929688e+02 1.5139700317382812e+02 -3.4461502075195312e+02 9.5567703247070312e+01 1.5163600158691406e+02 -3.4530899047851562e+02 9.5567504882812500e+01 1.5163600158691406e+02 -3.4164398193359375e+02 9.7309799194335938e+01 1.5157499694824219e+02 -3.4240100097656250e+02 1.2942599487304688e+02 9.7898399353027344e+01 -3.4538098144531250e+02 1.2859100341796875e+02 1.0103499603271484e+02 -3.4533502197265625e+02 1.2703399658203125e+02 1.0503800201416016e+02 -3.4530599975585938e+02 1.2700299835205078e+02 1.0510499572753906e+02 -3.4530499267578125e+02 1.2995800781250000e+02 9.4696403503417969e+01 -3.4544699096679688e+02 1.2995800781250000e+02 9.4696296691894531e+01 -3.4544699096679688e+02 1.1760800170898438e+02 1.2525300598144531e+02 -3.4523400878906250e+02 1.2133000183105469e+02 9.5559906005859375e+01 -3.3943798828125000e+02 1.2778499603271484e+02 9.7492500305175781e+01 -3.4268298339843750e+02 1.2088199615478516e+02 9.7773002624511719e+01 -3.3942700195312500e+02 1.2699100494384766e+02 1.0049200439453125e+02 -3.4263699340820312e+02 1.1974900054931641e+02 1.0099800109863281e+02 -3.3939801025390625e+02 1.2550400543212891e+02 1.0432199859619141e+02 -3.4260699462890625e+02 1.1954000091552734e+02 1.0145000457763672e+02 -3.3939199829101562e+02 1.0633999633789062e+02 1.2911599731445312e+02 -3.3916198730468750e+02 1.1591300201416016e+02 1.0905099487304688e+02 -3.3932901000976562e+02 1.2547600555419922e+02 1.0438299560546875e+02 -3.4260699462890625e+02 1.1953800201416016e+02 1.0145399475097656e+02 -3.3939199829101562e+02 1.0441199493408203e+02 1.4868399047851562e+02 -3.4226998901367188e+02 1.0383900451660156e+02 1.4890199279785156e+02 -3.4206100463867188e+02 1.0436299896240234e+02 1.4836799621582031e+02 -3.4218499755859375e+02 1.0349199676513672e+02 1.4894500732421875e+02 -3.4191702270507812e+02 9.8396598815917969e+01 1.4912300109863281e+02 -3.3970300292968750e+02 9.6766899108886719e+01 1.4917999267578125e+02 -3.3899499511718750e+02 1.1608100128173828e+02 1.2453099822998047e+02 -3.4253500366210938e+02 1.0523399353027344e+02 1.4779100036621094e+02 -3.4245300292968750e+02 1.0488800048828125e+02 1.4830599975585938e+02 -3.4240402221679688e+02 1.2975599670410156e+02 9.4644798278808594e+01 -3.4435400390625000e+02 1.2975599670410156e+02 9.4644897460937500e+01 -3.4435400390625000e+02 1.2917199707031250e+02 9.4552299499511719e+01 -3.4341201782226562e+02 1.2917199707031250e+02 9.4552398681640625e+01 -3.4341201782226562e+02 1.2631400299072266e+02 1.0469899749755859e+02 -3.4326998901367188e+02 1.2783999633789062e+02 1.0077100372314453e+02 -3.4330001831054688e+02 1.2684799957275391e+02 1.0494899749755859e+02 -3.4421301269531250e+02 1.2839900207519531e+02 1.0095999908447266e+02 -3.4424298095703125e+02 1.2922898864746094e+02 9.7834800720214844e+01 -3.4428900146484375e+02 1.2865499877929688e+02 9.7693000793457031e+01 -3.4334600830078125e+02 1.2628500366210938e+02 1.0476200103759766e+02 -3.4326998901367188e+02 1.2681800079345703e+02 1.0501399993896484e+02 -3.4421301269531250e+02 1.1742299652099609e+02 1.2516300201416016e+02 -3.4414099121093750e+02 1.0657600402832031e+02 1.4842300415039062e+02 -3.4405801391601562e+02 1.1688899993896484e+02 1.2491100311279297e+02 -3.4319799804687500e+02 1.0604300689697266e+02 1.4817098999023438e+02 -3.4311599731445312e+02 1.0486599731445312e+02 1.5037699890136719e+02 -3.4383801269531250e+02 1.0366500091552734e+02 1.5091999816894531e+02 -3.4358001708984375e+02 1.0292199707031250e+02 1.5106999206542969e+02 -3.4339898681640625e+02 1.0386600494384766e+02 1.5007099914550781e+02 -3.4262100219726562e+02 1.0331100463867188e+02 1.5019200134277344e+02 -3.4243301391601562e+02 1.0476200103759766e+02 1.4965100097656250e+02 -3.4288702392578125e+02 1.0585199737548828e+02 1.4953199768066406e+02 -3.4400000000000000e+02 1.0549900054931641e+02 1.4900801086425781e+02 -3.4305502319335938e+02 9.6376800537109375e+01 1.4982600402832031e+02 -3.3903500366210938e+02 9.8215896606445312e+01 1.5036999511718750e+02 -3.4021899414062500e+02 9.6029602050781250e+01 1.5044000244140625e+02 -3.3927999877929688e+02 9.5983200073242188e+01 1.5052198791503906e+02 -3.3931198120117188e+02 9.5687797546386719e+01 1.5110699462890625e+02 -3.3985800170898438e+02 9.7826896667480469e+01 1.5124798583984375e+02 -3.4118499755859375e+02 9.5618003845214844e+01 1.5129299926757812e+02 -3.4024200439453125e+02 9.5536598205566406e+01 1.5150900268554688e+02 -3.4068997192382812e+02 1.1941400146484375e+02 1.0138800048828125e+02 -3.3930902099609375e+02 1.1929400634765625e+02 1.0132900238037109e+02 -3.3915100097656250e+02 1.1947800445556641e+02 1.0087400054931641e+02 -3.3917700195312500e+02 1.1912299346923828e+02 1.0124500274658203e+02 -3.3892599487304688e+02 1.1930000305175781e+02 1.0079100036621094e+02 -3.3886297607421875e+02 1.1910899353027344e+02 1.0123699951171875e+02 -3.3885400390625000e+02 1.2040399932861328e+02 9.7645294189453125e+01 -3.3889199829101562e+02 1.2084099578857422e+02 9.5486801147460938e+01 -3.3890301513671875e+02 1.2059400177001953e+02 9.7696800231933594e+01 -3.3920602416992188e+02 1.2103500366210938e+02 9.5516197204589844e+01 -3.3921701049804688e+02 1.1927399444580078e+02 1.0132499694824219e+02 -3.3916799926757812e+02 1.1909799957275391e+02 1.0123799896240234e+02 -3.3885601806640625e+02 1.1926999664306641e+02 1.0132399749755859e+02 -3.3917098999023438e+02 1.1909400177001953e+02 1.0123699951171875e+02 -3.3885699462890625e+02 1.1546900177001953e+02 1.0883499908447266e+02 -3.3879400634765625e+02 1.1564499664306641e+02 1.0892199707031250e+02 -3.3910800170898438e+02 1.0589600372314453e+02 1.2889898681640625e+02 -3.3862701416015625e+02 1.0607199859619141e+02 1.2898600769042969e+02 -3.3894100952148438e+02 9.6322402954101562e+01 1.4896299743652344e+02 -3.3845999145507812e+02 9.6498901367187500e+01 1.4905000305175781e+02 -3.3877398681640625e+02 9.5214393615722656e+01 1.5171299743652344e+02 -3.4164398193359375e+02 9.5225601196289062e+01 1.5159599304199219e+02 -3.4062002563476562e+02 9.6119903564453125e+01 1.4975898742675781e+02 -3.3881698608398438e+02 9.5937896728515625e+01 1.4974600219726562e+02 -3.3852700805664062e+02 9.5724700927734375e+01 1.5052400207519531e+02 -3.3912100219726562e+02 9.5411193847656250e+01 1.5116499328613281e+02 -3.3971701049804688e+02 9.5527000427246094e+01 1.5059100341796875e+02 -3.3887600708007812e+02 9.5187500000000000e+01 1.5129800415039062e+02 -3.3953900146484375e+02 9.4964599609375000e+01 1.5177600097656250e+02 -3.4052899169921875e+02 9.4912002563476562e+01 1.5191200256347656e+02 -3.4164498901367188e+02 9.4912300109863281e+01 1.5191200256347656e+02 -3.4530899047851562e+02 9.5214599609375000e+01 1.5171299743652344e+02 -3.4530899047851562e+02 1.8589300537109375e+02 -4.7785800933837891e+01 -7.7849998474121094e+01 1.8591400146484375e+02 -4.7742900848388672e+01 -8.9849998474121094e+01 1.8675900268554688e+02 -4.8148097991943359e+01 -8.9849998474121094e+01 1.9593200683593750e+02 -5.0935501098632812e+01 -7.7849998474121094e+01 1.8997499084472656e+02 -4.9337699890136719e+01 -9.0045494079589844e+01 1.9355900573730469e+02 -5.0389598846435547e+01 -9.0597099304199219e+01 1.9410899353027344e+02 -5.0526500701904297e+01 -9.0703598022460938e+01 1.9594099426269531e+02 -5.0892902374267578e+01 -9.1117599487304688e+01 2.0640000915527344e+02 -5.2000000000000000e+01 -7.7849998474121094e+01 1.9831399536132812e+02 -5.1367500305175781e+01 -9.1653694152832031e+01 2.0276499938964844e+02 -5.1872802734375000e+01 -9.2830497741699219e+01 1.8116400146484375e+02 -4.5465999603271484e+01 -8.9849998474121094e+01 1.7669400024414062e+02 -4.2679702758789062e+01 -7.7849998474121094e+01 1.7669400024414062e+02 -4.2679702758789062e+01 -8.9849998474121094e+01 1.7252899169921875e+02 -3.9455398559570312e+01 -8.9849998474121094e+01 1.6871101379394531e+02 -3.5826297760009766e+01 -7.7849998474121094e+01 1.6871101379394531e+02 -3.5826297760009766e+01 -8.9849998474121094e+01 1.6527999877929688e+02 -3.1829498291015625e+01 -8.9849998474121094e+01 1.6226998901367188e+02 -2.7506099700927734e+01 -7.7849998474121094e+01 1.6226998901367188e+02 -2.7506099700927734e+01 -8.9849998474121094e+01 1.5971400451660156e+02 -2.2900499343872070e+01 -8.9849998474121094e+01 1.5763699340820312e+02 -1.8059799194335938e+01 -7.7849998474121094e+01 1.5763699340820312e+02 -1.8059799194335938e+01 -8.9849998474121094e+01 1.5605999755859375e+02 -1.3033900260925293e+01 -8.9849998474121094e+01 1.5500000000000000e+02 -7.8741898536682129e+00 -7.7849998474121094e+01 1.5500000000000000e+02 -7.8741898536682129e+00 -8.9849998474121094e+01 1.5446699523925781e+02 -2.6337499618530273e+00 -8.9849998474121094e+01 1.5446699523925781e+02 2.6337499618530273e+00 -7.7849998474121094e+01 1.5446699523925781e+02 2.6337499618530273e+00 -8.9849998474121094e+01 1.5500000000000000e+02 7.8741898536682129e+00 -8.9849998474121094e+01 1.5605999755859375e+02 1.3033900260925293e+01 -7.7849998474121094e+01 1.5605999755859375e+02 1.3033900260925293e+01 -8.9849998474121094e+01 1.5763699340820312e+02 1.8059799194335938e+01 -8.9849998474121094e+01 1.5971400451660156e+02 2.2900499343872070e+01 -7.7849998474121094e+01 1.5971400451660156e+02 2.2900499343872070e+01 -8.9849998474121094e+01 1.6226998901367188e+02 2.7506099700927734e+01 -8.9849998474121094e+01 1.6527999877929688e+02 3.1829498291015625e+01 -7.7849998474121094e+01 1.6527999877929688e+02 3.1829498291015625e+01 -8.9849998474121094e+01 1.6871101379394531e+02 3.5826297760009766e+01 -8.9849998474121094e+01 1.7252899169921875e+02 3.9455398559570312e+01 -7.7849998474121094e+01 1.7252899169921875e+02 3.9455398559570312e+01 -8.9849998474121094e+01 1.7669400024414062e+02 4.2679702758789062e+01 -8.9849998474121094e+01 1.8116400146484375e+02 4.5465999603271484e+01 -7.7849998474121094e+01 1.8116400146484375e+02 4.5465999603271484e+01 -8.9849998474121094e+01 1.8675900268554688e+02 4.8148097991943359e+01 -8.9849998474121094e+01 1.9083300781250000e+02 4.9615200042724609e+01 -7.7849998474121094e+01 1.8997499084472656e+02 4.9337699890136719e+01 -9.0045494079589844e+01 1.9831399536132812e+02 5.1367500305175781e+01 -9.1653694152832031e+01 1.9410899353027344e+02 5.0526500701904297e+01 -9.0703598022460938e+01 2.0113900756835938e+02 5.1733200073242188e+01 -7.7849998474121094e+01 1.9355900573730469e+02 5.0389598846435547e+01 -9.0597099304199219e+01 1.9084001159667969e+02 4.9591602325439453e+01 -9.0178695678710938e+01 2.1166099548339844e+02 5.1733200073242188e+01 -1.7426000976562500e+02 2.0640000915527344e+02 5.2000000000000000e+01 -1.7426000976562500e+02 2.1166099548339844e+02 5.1733200073242188e+01 -7.7849998474121094e+01 2.0640000915527344e+02 5.2000000000000000e+01 -9.3849998474121094e+01 2.0635699462890625e+02 5.2000000000000000e+01 -9.3837799072265625e+01 2.0276499938964844e+02 5.1872802734375000e+01 -9.2830497741699219e+01 2.0114399719238281e+02 5.1688800811767578e+01 -9.2402099609375000e+01 2.1686700439453125e+02 5.0935501098632812e+01 -1.7426000976562500e+02 2.2196699523925781e+02 4.9615200042724609e+01 -7.7849998474121094e+01 2.2196699523925781e+02 4.9615200042724609e+01 -1.7426000976562500e+02 2.2690699768066406e+02 4.7785800933837891e+01 -1.7426000976562500e+02 2.3163600158691406e+02 4.5465999603271484e+01 -7.7849998474121094e+01 2.3163600158691406e+02 4.5465999603271484e+01 -1.7426000976562500e+02 2.3610598754882812e+02 4.2679702758789062e+01 -1.7426000976562500e+02 2.4027099609375000e+02 3.9455398559570312e+01 -7.7849998474121094e+01 2.4027099609375000e+02 3.9455398559570312e+01 -1.7426000976562500e+02 2.4408900451660156e+02 3.5826297760009766e+01 -1.7426000976562500e+02 2.4752000427246094e+02 3.1829498291015625e+01 -7.7849998474121094e+01 2.4752000427246094e+02 3.1829498291015625e+01 -1.7426000976562500e+02 2.5052999877929688e+02 2.7506099700927734e+01 -1.7426000976562500e+02 2.5308599853515625e+02 2.2900499343872070e+01 -7.7849998474121094e+01 2.5308599853515625e+02 2.2900499343872070e+01 -1.7426000976562500e+02 2.5516300964355469e+02 1.8059799194335938e+01 -1.7426000976562500e+02 2.5673999023437500e+02 1.3033900260925293e+01 -7.7849998474121094e+01 2.5673999023437500e+02 1.3033900260925293e+01 -1.7426000976562500e+02 2.5780001831054688e+02 7.8741898536682129e+00 -1.7426000976562500e+02 2.5833300781250000e+02 2.6337499618530273e+00 -7.7849998474121094e+01 2.5833300781250000e+02 2.6337499618530273e+00 -1.7426000976562500e+02 2.5833300781250000e+02 -2.6337499618530273e+00 -1.7426000976562500e+02 2.5780001831054688e+02 -7.8741898536682129e+00 -7.7849998474121094e+01 2.5780001831054688e+02 -7.8741898536682129e+00 -1.7426000976562500e+02 2.5673999023437500e+02 -1.3033900260925293e+01 -1.7426000976562500e+02 2.5516300964355469e+02 -1.8059799194335938e+01 -7.7849998474121094e+01 2.5516300964355469e+02 -1.8059799194335938e+01 -1.7426000976562500e+02 2.5308599853515625e+02 -2.2900499343872070e+01 -1.7426000976562500e+02 2.5052999877929688e+02 -2.7506099700927734e+01 -7.7849998474121094e+01 2.5052999877929688e+02 -2.7506099700927734e+01 -1.7426000976562500e+02 2.4752000427246094e+02 -3.1829498291015625e+01 -1.7426000976562500e+02 2.4408900451660156e+02 -3.5826297760009766e+01 -7.7849998474121094e+01 2.4408900451660156e+02 -3.5826297760009766e+01 -1.7426000976562500e+02 2.4027099609375000e+02 -3.9455398559570312e+01 -1.7426000976562500e+02 2.3610598754882812e+02 -4.2679702758789062e+01 -7.7849998474121094e+01 2.3610598754882812e+02 -4.2679702758789062e+01 -1.7426000976562500e+02 2.3163600158691406e+02 -4.5465999603271484e+01 -1.7426000976562500e+02 2.2690699768066406e+02 -4.7785800933837891e+01 -7.7849998474121094e+01 2.2690699768066406e+02 -4.7785800933837891e+01 -1.7426000976562500e+02 2.2196699523925781e+02 -4.9615200042724609e+01 -1.7426000976562500e+02 2.1686700439453125e+02 -5.0935501098632812e+01 -7.7849998474121094e+01 2.1686700439453125e+02 -5.0935501098632812e+01 -1.7426000976562500e+02 2.0640000915527344e+02 -5.2000000000000000e+01 -9.3849998474121094e+01 2.0640000915527344e+02 -5.2000000000000000e+01 -1.7426000976562500e+02 2.1166099548339844e+02 -5.1733200073242188e+01 -1.7426000976562500e+02 2.0635699462890625e+02 -5.2000000000000000e+01 -9.3837799072265625e+01 9.6400001525878906e+01 -5.0126102447509766e+01 -1.8271299743652344e+02 9.6400001525878906e+01 -5.1525897979736328e+01 -1.7858900451660156e+02 9.6400001525878906e+01 5.2000000000000000e+01 -1.7426000976562500e+02 9.6400001525878906e+01 -5.2000000000000000e+01 -1.7426000976562500e+02 9.6400001525878906e+01 5.2000000000000000e+01 -9.3849998474121094e+01 9.6400001525878906e+01 -5.1731998443603516e+01 -9.2849998474121094e+01 9.6400001525878906e+01 -5.1000000000000000e+01 -9.2117897033691406e+01 9.6400001525878906e+01 -5.2000000000000000e+01 -9.3849998474121094e+01 9.6400001525878906e+01 -4.9999900817871094e+01 -9.1849998474121094e+01 9.6400001525878906e+01 5.1525897979736328e+01 -1.7858900451660156e+02 9.6400001525878906e+01 5.0126102447509766e+01 -1.8271299743652344e+02 9.6400001525878906e+01 4.4807697296142578e+01 -1.9411799621582031e+02 9.6400001525878906e+01 -4.2088699340820312e+01 -1.9585000610351562e+02 9.6400001525878906e+01 -4.3196399688720703e+01 -1.9563800048828125e+02 9.6400001525878906e+01 -4.4147499084472656e+01 -1.9503199768066406e+02 9.6400001525878906e+01 5.1000000000000000e+01 -9.2117897033691406e+01 9.6400001525878906e+01 5.1731998443603516e+01 -9.2849998474121094e+01 9.6400001525878906e+01 4.9999900817871094e+01 -9.1849998474121094e+01 9.6400001525878906e+01 -4.4807697296142578e+01 -1.9411799621582031e+02 9.6400001525878906e+01 4.2088699340820312e+01 -1.9585000610351562e+02 9.6400001525878906e+01 4.3196399688720703e+01 -1.9563800048828125e+02 9.6400001525878906e+01 4.4147499084472656e+01 -1.9503199768066406e+02 2.0640000915527344e+02 -4.2088699340820312e+01 -1.9585000610351562e+02 2.4139498901367188e+02 -2.3383300781250000e+01 -1.9585000610351562e+02 2.3893499755859375e+02 -2.6700799942016602e+01 -1.9585000610351562e+02 2.4848901367187500e+02 0.0000000000000000e+00 -1.9585000610351562e+02 2.3616099548339844e+02 -2.9761199951171875e+01 -1.9585000610351562e+02 2.0640000915527344e+02 4.2088699340820312e+01 -1.9585000610351562e+02 2.1052500915527344e+02 4.1886096954345703e+01 -1.9585000610351562e+02 2.1461099243164062e+02 4.1280002593994141e+01 -1.9585000610351562e+02 2.1861801147460938e+02 4.0276401519775391e+01 -1.9585000610351562e+02 2.2250700378417969e+02 3.8884899139404297e+01 -1.9585000610351562e+02 2.2623999023437500e+02 3.7118999481201172e+01 -1.9585000610351562e+02 2.2978300476074219e+02 3.4995498657226562e+01 -1.9585000610351562e+02 2.3310099792480469e+02 3.2535099029541016e+01 -1.9585000610351562e+02 2.3616099548339844e+02 2.9761199951171875e+01 -1.9585000610351562e+02 2.3893499755859375e+02 2.6700799942016602e+01 -1.9585000610351562e+02 2.4139498901367188e+02 2.3383300781250000e+01 -1.9585000610351562e+02 2.4351899719238281e+02 1.9840499877929688e+01 -1.9585000610351562e+02 2.3310099792480469e+02 -3.2535099029541016e+01 -1.9585000610351562e+02 2.2978300476074219e+02 -3.4995498657226562e+01 -1.9585000610351562e+02 2.2623999023437500e+02 -3.7118999481201172e+01 -1.9585000610351562e+02 2.2250700378417969e+02 -3.8884899139404297e+01 -1.9585000610351562e+02 2.1861801147460938e+02 -4.0276401519775391e+01 -1.9585000610351562e+02 2.1461099243164062e+02 -4.1280002593994141e+01 -1.9585000610351562e+02 2.4528500366210938e+02 1.6106700897216797e+01 -1.9585000610351562e+02 2.4667599487304688e+02 1.2217700004577637e+01 -1.9585000610351562e+02 2.4767999267578125e+02 8.2110795974731445e+00 -1.9585000610351562e+02 2.4667599487304688e+02 -1.2217700004577637e+01 -1.9585000610351562e+02 2.4767999267578125e+02 -8.2110795974731445e+00 -1.9585000610351562e+02 2.4828599548339844e+02 -4.1254200935363770e+00 -1.9585000610351562e+02 2.4528500366210938e+02 -1.6106700897216797e+01 -1.9585000610351562e+02 2.4351899719238281e+02 -1.9840499877929688e+01 -1.9585000610351562e+02 2.1052500915527344e+02 -4.1886096954345703e+01 -1.9585000610351562e+02 2.4828599548339844e+02 4.1254200935363770e+00 -1.9585000610351562e+02 1.8019400024414062e+02 4.7214702606201172e+01 -9.1849998474121094e+01 1.8600399780273438e+02 4.9999900817871094e+01 -9.1849998474121094e+01 1.7555200195312500e+02 4.4321201324462891e+01 -9.1849998474121094e+01 1.8600399780273438e+02 -4.9999900817871094e+01 -9.1849998474121094e+01 1.8019400024414062e+02 -4.7214702606201172e+01 -9.1849998474121094e+01 1.7555200195312500e+02 -4.4321201324462891e+01 -9.1849998474121094e+01 1.7122599792480469e+02 -4.0972900390625000e+01 -9.1849998474121094e+01 1.6726100158691406e+02 -3.7204196929931641e+01 -9.1849998474121094e+01 1.6369799804687500e+02 -3.3053699493408203e+01 -9.1849998474121094e+01 1.6057299804687500e+02 -2.8564001083374023e+01 -9.1849998474121094e+01 1.5791900634765625e+02 -2.3781200408935547e+01 -9.1849998474121094e+01 1.5576100158691406e+02 -1.8754501342773438e+01 -9.1849998474121094e+01 1.5412400817871094e+02 -1.3535200119018555e+01 -9.1849998474121094e+01 1.5302301025390625e+02 -8.1770401000976562e+00 -9.1849998474121094e+01 1.5246899414062500e+02 -2.7350199222564697e+00 -9.1849998474121094e+01 1.5246899414062500e+02 2.7350199222564697e+00 -9.1849998474121094e+01 1.5302301025390625e+02 8.1770401000976562e+00 -9.1849998474121094e+01 1.5412400817871094e+02 1.3535200119018555e+01 -9.1849998474121094e+01 1.5576100158691406e+02 1.8754501342773438e+01 -9.1849998474121094e+01 1.5791900634765625e+02 2.3781200408935547e+01 -9.1849998474121094e+01 1.6057299804687500e+02 2.8564001083374023e+01 -9.1849998474121094e+01 1.6369799804687500e+02 3.3053699493408203e+01 -9.1849998474121094e+01 1.6726100158691406e+02 3.7204196929931641e+01 -9.1849998474121094e+01 1.7122599792480469e+02 4.0972900390625000e+01 -9.1849998474121094e+01 2.0640000915527344e+02 -4.4807697296142578e+01 -1.9411799621582031e+02 2.0640000915527344e+02 -5.0126102447509766e+01 -1.8271299743652344e+02 2.0640000915527344e+02 4.4807697296142578e+01 -1.9411799621582031e+02 2.0640000915527344e+02 5.0126102447509766e+01 -1.8271299743652344e+02 2.1079200744628906e+02 4.4591899871826172e+01 -1.9411799621582031e+02 2.1147100830078125e+02 4.9868900299072266e+01 -1.8271299743652344e+02 2.1514099121093750e+02 4.3946697235107422e+01 -1.9411799621582031e+02 2.1617700195312500e+02 4.9148101806640625e+01 -1.8271299743652344e+02 2.1649000549316406e+02 4.9100002288818359e+01 -1.8271299743652344e+02 2.1940701293945312e+02 4.2878299713134766e+01 -1.9411799621582031e+02 2.2140599060058594e+02 4.7827301025390625e+01 -1.8271299743652344e+02 2.2354699707031250e+02 4.1396900177001953e+01 -1.9411799621582031e+02 2.2557299804687500e+02 4.6284099578857422e+01 -1.8271299743652344e+02 2.2616799926757812e+02 4.6063800811767578e+01 -1.8271299743652344e+02 2.2752200317382812e+02 3.9516899108886719e+01 -1.9411799621582031e+02 2.3072599792480469e+02 4.3827602386474609e+01 -1.8271299743652344e+02 2.3129400634765625e+02 3.7256198883056641e+01 -1.9411799621582031e+02 2.3422799682617188e+02 4.1645099639892578e+01 -1.8271299743652344e+02 2.3503599548339844e+02 4.1141700744628906e+01 -1.8271299743652344e+02 2.3482600402832031e+02 3.4636798858642578e+01 -1.9411799621582031e+02 2.3905099487304688e+02 3.8033599853515625e+01 -1.8271299743652344e+02 2.3808399963378906e+02 3.1683799743652344e+01 -1.9411799621582031e+02 2.4181100463867188e+02 3.5409599304199219e+01 -1.8271299743652344e+02 2.4273100280761719e+02 3.4535198211669922e+01 -1.8271299743652344e+02 2.4103700256347656e+02 2.8425699234008789e+01 -1.9411799621582031e+02 2.4603900146484375e+02 3.0682500839233398e+01 -1.8271299743652344e+02 2.4365599060058594e+02 2.4893800735473633e+01 -1.9411799621582031e+02 2.4803300476074219e+02 2.7816999435424805e+01 -1.8271299743652344e+02 2.4893899536132812e+02 2.6514900207519531e+01 -1.8271299743652344e+02 2.4591700744628906e+02 2.1122200012207031e+01 -1.9411799621582031e+02 2.5140299987792969e+02 2.2075201034545898e+01 -1.8271299743652344e+02 2.4779699707031250e+02 1.7147100448608398e+01 -1.9411799621582031e+02 2.5265499877929688e+02 1.9158700942993164e+01 -1.8271299743652344e+02 2.5340599060058594e+02 1.7409000396728516e+01 -1.8271299743652344e+02 2.4927799987792969e+02 1.3006999969482422e+01 -1.9411799621582031e+02 2.5492599487304688e+02 1.2564200401306152e+01 -1.8271299743652344e+02 2.5034698486328125e+02 8.7414999008178711e+00 -1.9411799621582031e+02 2.5550100708007812e+02 9.7663402557373047e+00 -1.8271299743652344e+02 2.5594801330566406e+02 7.5904698371887207e+00 -1.8271299743652344e+02 2.5099200439453125e+02 4.3919100761413574e+00 -1.9411799621582031e+02 2.5646200561523438e+02 2.5388000011444092e+00 -1.8271299743652344e+02 2.5120800781250000e+02 0.0000000000000000e+00 -1.9411799621582031e+02 2.5646200561523438e+02 0.0000000000000000e+00 -1.8271299743652344e+02 2.5099200439453125e+02 -4.3919100761413574e+00 -1.9411799621582031e+02 2.4927799987792969e+02 -1.3006999969482422e+01 -1.9411799621582031e+02 2.5340599060058594e+02 -1.7409000396728516e+01 -1.8271299743652344e+02 2.4779699707031250e+02 -1.7147100448608398e+01 -1.9411799621582031e+02 2.5265499877929688e+02 -1.9158700942993164e+01 -1.8271299743652344e+02 2.4591700744628906e+02 -2.1122200012207031e+01 -1.9411799621582031e+02 2.5646200561523438e+02 -2.5388000011444092e+00 -1.8271299743652344e+02 2.5594801330566406e+02 -7.5904698371887207e+00 -1.8271299743652344e+02 2.5034698486328125e+02 -8.7414999008178711e+00 -1.9411799621582031e+02 2.5550100708007812e+02 -9.7663402557373047e+00 -1.8271299743652344e+02 2.5492599487304688e+02 -1.2564200401306152e+01 -1.8271299743652344e+02 2.4103700256347656e+02 -2.8425699234008789e+01 -1.9411799621582031e+02 2.4273100280761719e+02 -3.4535198211669922e+01 -1.8271299743652344e+02 2.3808399963378906e+02 -3.1683799743652344e+01 -1.9411799621582031e+02 2.4181100463867188e+02 -3.5409599304199219e+01 -1.8271299743652344e+02 2.3482600402832031e+02 -3.4636798858642578e+01 -1.9411799621582031e+02 2.5140299987792969e+02 -2.2075201034545898e+01 -1.8271299743652344e+02 2.4893899536132812e+02 -2.6514900207519531e+01 -1.8271299743652344e+02 2.4365599060058594e+02 -2.4893800735473633e+01 -1.9411799621582031e+02 2.4803300476074219e+02 -2.7816999435424805e+01 -1.8271299743652344e+02 2.4603900146484375e+02 -3.0682500839233398e+01 -1.8271299743652344e+02 2.2752200317382812e+02 -3.9516899108886719e+01 -1.9411799621582031e+02 2.2616799926757812e+02 -4.6063800811767578e+01 -1.8271299743652344e+02 2.2354699707031250e+02 -4.1396900177001953e+01 -1.9411799621582031e+02 2.2557299804687500e+02 -4.6284099578857422e+01 -1.8271299743652344e+02 2.1940701293945312e+02 -4.2878299713134766e+01 -1.9411799621582031e+02 2.3905099487304688e+02 -3.8033599853515625e+01 -1.8271299743652344e+02 2.3503599548339844e+02 -4.1141700744628906e+01 -1.8271299743652344e+02 2.3129400634765625e+02 -3.7256198883056641e+01 -1.9411799621582031e+02 2.3422799682617188e+02 -4.1645099639892578e+01 -1.8271299743652344e+02 2.3072599792480469e+02 -4.3827602386474609e+01 -1.8271299743652344e+02 2.2140599060058594e+02 -4.7827301025390625e+01 -1.8271299743652344e+02 2.1649000549316406e+02 -4.9100002288818359e+01 -1.8271299743652344e+02 2.1514099121093750e+02 -4.3946697235107422e+01 -1.9411799621582031e+02 2.1617700195312500e+02 -4.9148101806640625e+01 -1.8271299743652344e+02 2.1079200744628906e+02 -4.4591899871826172e+01 -1.9411799621582031e+02 2.1147100830078125e+02 -4.9868900299072266e+01 -1.8271299743652344e+02 2.0640000915527344e+02 -5.1525897979736328e+01 -1.7858900451660156e+02 2.0640000915527344e+02 5.1525897979736328e+01 -1.7858900451660156e+02 2.1161300659179688e+02 5.1261501312255859e+01 -1.7858900451660156e+02 2.1161300659179688e+02 -5.1261501312255859e+01 -1.7858900451660156e+02 2.1677200317382812e+02 -5.0471202850341797e+01 -1.7858900451660156e+02 2.2182499694824219e+02 -4.9162899017333984e+01 -1.7858900451660156e+02 2.2672000122070312e+02 -4.7350101470947266e+01 -1.7858900451660156e+02 2.3140600585937500e+02 -4.5051498413085938e+01 -1.7858900451660156e+02 2.3583500671386719e+02 -4.2290599822998047e+01 -1.7858900451660156e+02 2.3996299743652344e+02 -3.9095699310302734e+01 -1.7858900451660156e+02 2.4374600219726562e+02 -3.5499599456787109e+01 -1.7858900451660156e+02 2.4714500427246094e+02 -3.1539299011230469e+01 -1.7858900451660156e+02 2.5012698364257812e+02 -2.7255399703979492e+01 -1.7858900451660156e+02 2.5266000366210938e+02 -2.2691699981689453e+01 -1.7858900451660156e+02 2.5471899414062500e+02 -1.7895198822021484e+01 -1.7858900451660156e+02 2.5628097534179688e+02 -1.2915100097656250e+01 -1.7858900451660156e+02 2.5733200073242188e+02 -7.8024301528930664e+00 -1.7858900451660156e+02 2.5786001586914062e+02 2.6097300052642822e+00 -1.7858900451660156e+02 2.5786001586914062e+02 -2.6097300052642822e+00 -1.7858900451660156e+02 2.5733200073242188e+02 7.8024301528930664e+00 -1.7858900451660156e+02 2.5628097534179688e+02 1.2915100097656250e+01 -1.7858900451660156e+02 2.5471899414062500e+02 1.7895198822021484e+01 -1.7858900451660156e+02 2.5266000366210938e+02 2.2691699981689453e+01 -1.7858900451660156e+02 2.5012698364257812e+02 2.7255399703979492e+01 -1.7858900451660156e+02 2.4714500427246094e+02 3.1539299011230469e+01 -1.7858900451660156e+02 2.4374600219726562e+02 3.5499599456787109e+01 -1.7858900451660156e+02 2.3996299743652344e+02 3.9095699310302734e+01 -1.7858900451660156e+02 2.3583500671386719e+02 4.2290599822998047e+01 -1.7858900451660156e+02 2.3140600585937500e+02 4.5051498413085938e+01 -1.7858900451660156e+02 2.2672000122070312e+02 4.7350101470947266e+01 -1.7858900451660156e+02 2.2182499694824219e+02 4.9162899017333984e+01 -1.7858900451660156e+02 2.1677200317382812e+02 5.0471202850341797e+01 -1.7858900451660156e+02 2.0640000915527344e+02 -4.3196399688720703e+01 -1.9563800048828125e+02 2.0640000915527344e+02 -4.4147499084472656e+01 -1.9503199768066406e+02 2.0640000915527344e+02 4.4147499084472656e+01 -1.9503199768066406e+02 2.0640000915527344e+02 4.3196399688720703e+01 -1.9563800048828125e+02 2.1072700500488281e+02 4.3934902191162109e+01 -1.9503199768066406e+02 2.1063398742675781e+02 4.2988300323486328e+01 -1.9563800048828125e+02 2.1501300048828125e+02 4.3299198150634766e+01 -1.9503199768066406e+02 2.1921501159667969e+02 4.2246498107910156e+01 -1.9503199768066406e+02 2.2329499816894531e+02 4.0786998748779297e+01 -1.9503199768066406e+02 2.2721099853515625e+02 3.8934600830078125e+01 -1.9503199768066406e+02 2.3092700195312500e+02 3.6707302093505859e+01 -1.9503199768066406e+02 2.3440699768066406e+02 3.4126502990722656e+01 -1.9503199768066406e+02 2.3761700439453125e+02 3.1216999053955078e+01 -1.9503199768066406e+02 2.4052700805664062e+02 2.8006799697875977e+01 -1.9503199768066406e+02 2.4310700988769531e+02 2.4527000427246094e+01 -1.9503199768066406e+02 2.4533499145507812e+02 2.0811000823974609e+01 -1.9503199768066406e+02 2.4718699645996094e+02 1.6894500732421875e+01 -1.9503199768066406e+02 2.4864700317382812e+02 1.2815299987792969e+01 -1.9503199768066406e+02 2.4969898986816406e+02 8.6127500534057617e+00 -1.9503199768066406e+02 2.5033500671386719e+02 4.3271799087524414e+00 -1.9503199768066406e+02 2.5054800415039062e+02 0.0000000000000000e+00 -1.9503199768066406e+02 2.5033500671386719e+02 -4.3271799087524414e+00 -1.9503199768066406e+02 2.4969898986816406e+02 -8.6127500534057617e+00 -1.9503199768066406e+02 2.4864700317382812e+02 -1.2815299987792969e+01 -1.9503199768066406e+02 2.4718699645996094e+02 -1.6894500732421875e+01 -1.9503199768066406e+02 2.4533499145507812e+02 -2.0811000823974609e+01 -1.9503199768066406e+02 2.4310700988769531e+02 -2.4527000427246094e+01 -1.9503199768066406e+02 2.4052700805664062e+02 -2.8006799697875977e+01 -1.9503199768066406e+02 2.3761700439453125e+02 -3.1216999053955078e+01 -1.9503199768066406e+02 2.3440699768066406e+02 -3.4126502990722656e+01 -1.9503199768066406e+02 2.3092700195312500e+02 -3.6707302093505859e+01 -1.9503199768066406e+02 2.2721099853515625e+02 -3.8934600830078125e+01 -1.9503199768066406e+02 2.2329499816894531e+02 -4.0786998748779297e+01 -1.9503199768066406e+02 2.1921501159667969e+02 -4.2246498107910156e+01 -1.9503199768066406e+02 2.1501300048828125e+02 -4.3299198150634766e+01 -1.9503199768066406e+02 2.1072700500488281e+02 -4.3934902191162109e+01 -1.9503199768066406e+02 2.1482699584960938e+02 4.2366401672363281e+01 -1.9563800048828125e+02 2.1893901062011719e+02 4.1336399078369141e+01 -1.9563800048828125e+02 2.2292999267578125e+02 3.9908199310302734e+01 -1.9563800048828125e+02 2.2676300048828125e+02 3.8095798492431641e+01 -1.9563800048828125e+02 2.3039900207519531e+02 3.5916400909423828e+01 -1.9563800048828125e+02 2.3380400085449219e+02 3.3391201019287109e+01 -1.9563800048828125e+02 2.3694400024414062e+02 3.0544500350952148e+01 -1.9563800048828125e+02 2.3979100036621094e+02 2.7403499603271484e+01 -1.9563800048828125e+02 2.4231700134277344e+02 2.3998600006103516e+01 -1.9563800048828125e+02 2.4449600219726562e+02 2.0362600326538086e+01 -1.9563800048828125e+02 2.4630799865722656e+02 1.6530500411987305e+01 -1.9563800048828125e+02 2.4773600769042969e+02 1.2539199829101562e+01 -1.9563800048828125e+02 2.4876600646972656e+02 8.4271402359008789e+00 -1.9563800048828125e+02 2.4938800048828125e+02 4.2339601516723633e+00 -1.9563800048828125e+02 2.4959599304199219e+02 0.0000000000000000e+00 -1.9563800048828125e+02 2.4938800048828125e+02 -4.2339601516723633e+00 -1.9563800048828125e+02 2.4876600646972656e+02 -8.4271402359008789e+00 -1.9563800048828125e+02 2.4773600769042969e+02 -1.2539199829101562e+01 -1.9563800048828125e+02 2.4630799865722656e+02 -1.6530500411987305e+01 -1.9563800048828125e+02 2.4449600219726562e+02 -2.0362600326538086e+01 -1.9563800048828125e+02 2.4231700134277344e+02 -2.3998600006103516e+01 -1.9563800048828125e+02 2.3979100036621094e+02 -2.7403499603271484e+01 -1.9563800048828125e+02 2.3694400024414062e+02 -3.0544500350952148e+01 -1.9563800048828125e+02 2.3380400085449219e+02 -3.3391201019287109e+01 -1.9563800048828125e+02 2.3039900207519531e+02 -3.5916400909423828e+01 -1.9563800048828125e+02 2.2676300048828125e+02 -3.8095798492431641e+01 -1.9563800048828125e+02 2.2292999267578125e+02 -3.9908199310302734e+01 -1.9563800048828125e+02 2.1893901062011719e+02 -4.1336399078369141e+01 -1.9563800048828125e+02 2.1482699584960938e+02 -4.2366401672363281e+01 -1.9563800048828125e+02 2.1063398742675781e+02 -4.2988300323486328e+01 -1.9563800048828125e+02 2.0635501098632812e+02 5.2000000000000000e+01 -9.3843902587890625e+01 1.9363600158691406e+02 5.1234901428222656e+01 -9.2276794433593750e+01 1.9800299072265625e+02 5.1671600341796875e+01 -9.2751899719238281e+01 1.9882600402832031e+02 5.1718299865722656e+01 -9.2856697082519531e+01 2.0262500000000000e+02 5.1933898925781250e+01 -9.3340202331542969e+01 1.9188400268554688e+02 5.0990501403808594e+01 -9.2136001586914062e+01 1.9306599426269531e+02 5.1163799285888672e+01 -9.2223602294921875e+01 1.8934300231933594e+02 5.0617603302001953e+01 -9.1947799682617188e+01 1.8961499023437500e+02 4.9933002471923828e+01 -9.1538902282714844e+01 2.0635600280761719e+02 5.2000000000000000e+01 -9.3841903686523438e+01 2.0635600280761719e+02 5.2000000000000000e+01 -9.3839897155761719e+01 2.0271900939941406e+02 5.1877403259277344e+01 -9.3002197265625000e+01 1.9811199951171875e+02 5.1495300292968750e+01 -9.2411102294921875e+01 2.0267199707031250e+02 5.1897899627685547e+01 -9.3172599792480469e+01 1.9381600952148438e+02 5.0836299896240234e+01 -9.1843299865722656e+01 1.9325601196289062e+02 5.0730400085449219e+01 -9.1785499572753906e+01 1.9821701049804688e+02 5.1392601013183594e+01 -9.2040100097656250e+01 1.9397898864746094e+02 5.0592399597167969e+01 -9.1301795959472656e+01 1.9342599487304688e+02 5.0463100433349609e+01 -9.1223899841308594e+01 1.8983900451660156e+02 4.9479499816894531e+01 -9.0864898681640625e+01 1.8665798950195312e+02 4.8396198272705078e+01 -9.0850006103515625e+01 1.8638198852539062e+02 4.9074096679687500e+01 -9.1582000732421875e+01 1.8067900085449219e+02 4.6340301513671875e+01 -9.1582000732421875e+01 1.7612298583984375e+02 4.3500400543212891e+01 -9.1582000732421875e+01 1.7187699890136719e+02 4.0214199066162109e+01 -9.1582000732421875e+01 1.6798600769042969e+02 3.6515197753906250e+01 -9.1582000732421875e+01 1.6448899841308594e+02 3.2441600799560547e+01 -9.1582000732421875e+01 1.6142199707031250e+02 2.8034999847412109e+01 -9.1582000732421875e+01 1.5881599426269531e+02 2.3340900421142578e+01 -9.1582000732421875e+01 1.5669900512695312e+02 1.8407199859619141e+01 -9.1582000732421875e+01 1.5509199523925781e+02 1.3284600257873535e+01 -9.1582000732421875e+01 1.5401100158691406e+02 8.0256500244140625e+00 -9.1582000732421875e+01 1.5346800231933594e+02 2.6843497753143311e+00 -9.1582000732421875e+01 1.5346800231933594e+02 -2.6843497753143311e+00 -9.1582000732421875e+01 1.5401100158691406e+02 -8.0256500244140625e+00 -9.1582000732421875e+01 1.5509199523925781e+02 -1.3284600257873535e+01 -9.1582000732421875e+01 1.5669900512695312e+02 -1.8407199859619141e+01 -9.1582000732421875e+01 1.5881599426269531e+02 -2.3340900421142578e+01 -9.1582000732421875e+01 1.6142199707031250e+02 -2.8034999847412109e+01 -9.1582000732421875e+01 1.6448899841308594e+02 -3.2441600799560547e+01 -9.1582000732421875e+01 1.6798600769042969e+02 -3.6515197753906250e+01 -9.1582000732421875e+01 1.7187699890136719e+02 -4.0214199066162109e+01 -9.1582000732421875e+01 1.7612298583984375e+02 -4.3500400543212891e+01 -9.1582000732421875e+01 1.8067900085449219e+02 -4.6340301513671875e+01 -9.1582000732421875e+01 1.8103399658203125e+02 4.5700199127197266e+01 -9.0850006103515625e+01 1.7654100036621094e+02 4.2899600982666016e+01 -9.0850006103515625e+01 1.7235400390625000e+02 3.9658699035644531e+01 -9.0850006103515625e+01 1.6851699829101562e+02 3.6010898590087891e+01 -9.0850006103515625e+01 1.6506799316406250e+02 3.1993501663208008e+01 -9.0850006103515625e+01 1.6204299926757812e+02 2.7647800445556641e+01 -9.0850006103515625e+01 1.5947399902343750e+02 2.3018499374389648e+01 -9.0850006103515625e+01 1.5738600158691406e+02 1.8152900695800781e+01 -9.0850006103515625e+01 1.5580099487304688e+02 1.3101000785827637e+01 -9.0850006103515625e+01 1.5473500061035156e+02 7.9147796630859375e+00 -9.0850006103515625e+01 1.5419900512695312e+02 2.6472799777984619e+00 -9.0850006103515625e+01 1.5419900512695312e+02 -2.6472799777984619e+00 -9.0850006103515625e+01 1.5473500061035156e+02 -7.9147796630859375e+00 -9.0850006103515625e+01 1.5580099487304688e+02 -1.3101000785827637e+01 -9.0850006103515625e+01 1.5738600158691406e+02 -1.8152900695800781e+01 -9.0850006103515625e+01 1.5947399902343750e+02 -2.3018499374389648e+01 -9.0850006103515625e+01 1.6204299926757812e+02 -2.7647800445556641e+01 -9.0850006103515625e+01 1.6506799316406250e+02 -3.1993501663208008e+01 -9.0850006103515625e+01 1.6851699829101562e+02 -3.6010898590087891e+01 -9.0850006103515625e+01 1.7235400390625000e+02 -3.9658699035644531e+01 -9.0850006103515625e+01 1.7654100036621094e+02 -4.2899600982666016e+01 -9.0850006103515625e+01 1.8103399658203125e+02 -4.5700199127197266e+01 -9.0850006103515625e+01 1.8665798950195312e+02 -4.8396198272705078e+01 -9.0850006103515625e+01 1.8638198852539062e+02 -4.9074096679687500e+01 -9.1582000732421875e+01 1.9342599487304688e+02 -5.0463100433349609e+01 -9.1223899841308594e+01 1.9397898864746094e+02 -5.0592399597167969e+01 -9.1301795959472656e+01 2.0635600280761719e+02 -5.2000000000000000e+01 -9.3841903686523438e+01 2.0635501098632812e+02 -5.2000000000000000e+01 -9.3843902587890625e+01 2.0267199707031250e+02 -5.1897899627685547e+01 -9.3172599792480469e+01 2.0635600280761719e+02 -5.2000000000000000e+01 -9.3839897155761719e+01 2.0271900939941406e+02 -5.1877403259277344e+01 -9.3002197265625000e+01 1.9821701049804688e+02 -5.1392601013183594e+01 -9.2040100097656250e+01 1.9811199951171875e+02 -5.1495300292968750e+01 -9.2411102294921875e+01 1.9381600952148438e+02 -5.0836299896240234e+01 -9.1843299865722656e+01 1.9325601196289062e+02 -5.0730400085449219e+01 -9.1785499572753906e+01 1.9363600158691406e+02 -5.1234901428222656e+01 -9.2276794433593750e+01 1.9800299072265625e+02 -5.1671600341796875e+01 -9.2751899719238281e+01 1.9882600402832031e+02 -5.1718299865722656e+01 -9.2856697082519531e+01 2.0262500000000000e+02 -5.1933898925781250e+01 -9.3340202331542969e+01 1.8934300231933594e+02 -5.0617603302001953e+01 -9.1947799682617188e+01 1.9188400268554688e+02 -5.0990501403808594e+01 -9.2136001586914062e+01 1.9306599426269531e+02 -5.1163799285888672e+01 -9.2223602294921875e+01 1.8961499023437500e+02 -4.9933002471923828e+01 -9.1538902282714844e+01 1.8983900451660156e+02 -4.9479499816894531e+01 -9.0864898681640625e+01 2.0640000915527344e+02 4.6999500274658203e+01 -7.7849998474121094e+01 1.9662800598144531e+02 4.5972400665283203e+01 -7.7849998474121094e+01 1.8728399658203125e+02 4.2936100006103516e+01 -7.7849998474121094e+01 1.7877400207519531e+02 3.8023300170898438e+01 -7.7849998474121094e+01 1.7147299194335938e+02 3.1448801040649414e+01 -7.7849998474121094e+01 1.6569699096679688e+02 2.3499698638916016e+01 -7.7849998474121094e+01 1.6170098876953125e+02 1.4523600578308105e+01 -7.7849998474121094e+01 1.5965800476074219e+02 4.9127297401428223e+00 -7.7849998474121094e+01 1.5965800476074219e+02 -4.9127297401428223e+00 -7.7849998474121094e+01 1.6170098876953125e+02 -1.4523600578308105e+01 -7.7849998474121094e+01 1.6569699096679688e+02 -2.3499698638916016e+01 -7.7849998474121094e+01 1.7147299194335938e+02 -3.1448801040649414e+01 -7.7849998474121094e+01 1.7877400207519531e+02 -3.8023300170898438e+01 -7.7849998474121094e+01 1.8728399658203125e+02 -4.2936100006103516e+01 -7.7849998474121094e+01 1.9662800598144531e+02 -4.5972400665283203e+01 -7.7849998474121094e+01 2.0640000915527344e+02 -4.6999500274658203e+01 -7.7849998474121094e+01 2.1617199707031250e+02 -4.5972400665283203e+01 -7.7849998474121094e+01 2.2551600646972656e+02 -4.2936100006103516e+01 -7.7849998474121094e+01 2.3402600097656250e+02 -3.8023300170898438e+01 -7.7849998474121094e+01 2.4132699584960938e+02 -3.1448801040649414e+01 -7.7849998474121094e+01 2.4710301208496094e+02 -2.3499698638916016e+01 -7.7849998474121094e+01 2.5109898376464844e+02 -1.4523600578308105e+01 -7.7849998474121094e+01 2.5314199829101562e+02 -4.9127297401428223e+00 -7.7849998474121094e+01 2.5314199829101562e+02 4.9127297401428223e+00 -7.7849998474121094e+01 2.5109898376464844e+02 1.4523600578308105e+01 -7.7849998474121094e+01 2.4710301208496094e+02 2.3499698638916016e+01 -7.7849998474121094e+01 2.4132699584960938e+02 3.1448801040649414e+01 -7.7849998474121094e+01 2.3402600097656250e+02 3.8023300170898438e+01 -7.7849998474121094e+01 2.2551600646972656e+02 4.2936100006103516e+01 -7.7849998474121094e+01 2.1617199707031250e+02 4.5972400665283203e+01 -7.7849998474121094e+01 1.6170098876953125e+02 1.4523600578308105e+01 -7.5850006103515625e+01 2.4132699584960938e+02 -3.1448801040649414e+01 -7.5850006103515625e+01 2.4710301208496094e+02 -2.3499698638916016e+01 -7.5850006103515625e+01 2.5109898376464844e+02 -1.4523600578308105e+01 -7.5850006103515625e+01 2.5314199829101562e+02 -4.9127297401428223e+00 -7.5850006103515625e+01 2.5314199829101562e+02 4.9127297401428223e+00 -7.5850006103515625e+01 1.5965800476074219e+02 4.9127297401428223e+00 -7.5850006103515625e+01 1.5965800476074219e+02 -4.9127297401428223e+00 -7.5850006103515625e+01 1.6170098876953125e+02 -1.4523600578308105e+01 -7.5850006103515625e+01 1.6569699096679688e+02 -2.3499698638916016e+01 -7.5850006103515625e+01 1.7147299194335938e+02 -3.1448801040649414e+01 -7.5850006103515625e+01 1.7877400207519531e+02 -3.8023300170898438e+01 -7.5850006103515625e+01 2.5109898376464844e+02 1.4523600578308105e+01 -7.5850006103515625e+01 2.4710301208496094e+02 2.3499698638916016e+01 -7.5850006103515625e+01 2.4132699584960938e+02 3.1448801040649414e+01 -7.5850006103515625e+01 1.7877400207519531e+02 3.8023300170898438e+01 -7.5850006103515625e+01 1.7147299194335938e+02 3.1448801040649414e+01 -7.5850006103515625e+01 1.6569699096679688e+02 2.3499698638916016e+01 -7.5850006103515625e+01 2.3402600097656250e+02 3.8023300170898438e+01 -7.5850006103515625e+01 2.2551600646972656e+02 4.2936100006103516e+01 -7.5850006103515625e+01 2.1617199707031250e+02 4.5972400665283203e+01 -7.5850006103515625e+01 1.8728399658203125e+02 -4.2936100006103516e+01 -7.5850006103515625e+01 1.9662800598144531e+02 -4.5972400665283203e+01 -7.5850006103515625e+01 2.0640000915527344e+02 -4.6999500274658203e+01 -7.5850006103515625e+01 2.0640000915527344e+02 4.6999500274658203e+01 -7.5850006103515625e+01 1.9662800598144531e+02 4.5972400665283203e+01 -7.5850006103515625e+01 1.8728399658203125e+02 4.2936100006103516e+01 -7.5850006103515625e+01 2.1617199707031250e+02 -4.5972400665283203e+01 -7.5850006103515625e+01 2.2551600646972656e+02 -4.2936100006103516e+01 -7.5850006103515625e+01 2.3402600097656250e+02 -3.8023300170898438e+01 -7.5850006103515625e+01 1.6361199951171875e+02 -1.3639299869537354e+00 -9.8350006103515625e+01 1.6439999389648438e+02 -1.5749900341033936e+00 -8.7849998474121094e+01 1.6439999389648438e+02 -1.5749900341033936e+00 -9.8350006103515625e+01 1.6518699645996094e+02 -1.3639299869537354e+00 -8.7849998474121094e+01 1.6518699645996094e+02 -1.3639299869537354e+00 -9.8350006103515625e+01 1.6576400756835938e+02 -7.8750002384185791e-01 -8.7849998474121094e+01 1.6576400756835938e+02 -7.8750002384185791e-01 -9.8350006103515625e+01 1.6597500610351562e+02 0.0000000000000000e+00 -8.7849998474121094e+01 1.6597500610351562e+02 0.0000000000000000e+00 -9.8350006103515625e+01 1.6576400756835938e+02 7.8750002384185791e-01 -8.7849998474121094e+01 1.6576400756835938e+02 7.8750002384185791e-01 -9.8350006103515625e+01 1.6518699645996094e+02 1.3639299869537354e+00 -8.7849998474121094e+01 1.6518699645996094e+02 1.3639299869537354e+00 -9.8350006103515625e+01 1.6439999389648438e+02 1.5749900341033936e+00 -8.7849998474121094e+01 1.6439999389648438e+02 1.5749900341033936e+00 -9.8350006103515625e+01 1.6361199951171875e+02 1.3639299869537354e+00 -8.7849998474121094e+01 1.6361199951171875e+02 1.3639299869537354e+00 -9.8350006103515625e+01 1.6303601074218750e+02 7.8750002384185791e-01 -8.7849998474121094e+01 1.6303601074218750e+02 7.8750002384185791e-01 -9.8350006103515625e+01 1.6282499694824219e+02 0.0000000000000000e+00 -8.7849998474121094e+01 1.6282499694824219e+02 0.0000000000000000e+00 -9.8350006103515625e+01 1.6303601074218750e+02 -7.8750002384185791e-01 -8.7849998474121094e+01 1.6303601074218750e+02 -7.8750002384185791e-01 -9.8350006103515625e+01 1.6361199951171875e+02 -1.3639299869537354e+00 -8.7849998474121094e+01 1.6439999389648438e+02 0.0000000000000000e+00 -9.9296401977539062e+01 1.7002700805664062e+02 -2.2575000762939453e+01 -9.8350006103515625e+01 1.7081399536132812e+02 -2.2364000320434570e+01 -8.7849998474121094e+01 1.7081399536132812e+02 -2.2364000320434570e+01 -9.8350006103515625e+01 1.7139099121093750e+02 -2.1787500381469727e+01 -8.7849998474121094e+01 1.7139099121093750e+02 -2.1787500381469727e+01 -9.8350006103515625e+01 1.7160198974609375e+02 -2.1000000000000000e+01 -8.7849998474121094e+01 1.7160198974609375e+02 -2.1000000000000000e+01 -9.8350006103515625e+01 1.7139099121093750e+02 -2.0212499618530273e+01 -8.7849998474121094e+01 1.7139099121093750e+02 -2.0212499618530273e+01 -9.8350006103515625e+01 1.7081399536132812e+02 -1.9635999679565430e+01 -8.7849998474121094e+01 1.7081399536132812e+02 -1.9635999679565430e+01 -9.8350006103515625e+01 1.7002700805664062e+02 -1.9424999237060547e+01 -8.7849998474121094e+01 1.7002700805664062e+02 -1.9424999237060547e+01 -9.8350006103515625e+01 1.6923899841308594e+02 -1.9635999679565430e+01 -8.7849998474121094e+01 1.6923899841308594e+02 -1.9635999679565430e+01 -9.8350006103515625e+01 1.6866299438476562e+02 -2.0212499618530273e+01 -8.7849998474121094e+01 1.6866299438476562e+02 -2.0212499618530273e+01 -9.8350006103515625e+01 1.6845199584960938e+02 -2.1000000000000000e+01 -8.7849998474121094e+01 1.6845199584960938e+02 -2.1000000000000000e+01 -9.8350006103515625e+01 1.6866299438476562e+02 -2.1787500381469727e+01 -8.7849998474121094e+01 1.6866299438476562e+02 -2.1787500381469727e+01 -9.8350006103515625e+01 1.6923899841308594e+02 -2.2364000320434570e+01 -8.7849998474121094e+01 1.6923899841308594e+02 -2.2364000320434570e+01 -9.8350006103515625e+01 1.7002700805664062e+02 -2.2575000762939453e+01 -8.7849998474121094e+01 1.7002700805664062e+02 -2.1000000000000000e+01 -9.9296401977539062e+01 1.8618699645996094e+02 -3.7736999511718750e+01 -9.8350006103515625e+01 1.8676400756835938e+02 -3.7160499572753906e+01 -8.7849998474121094e+01 1.8676400756835938e+02 -3.7160499572753906e+01 -9.8350006103515625e+01 1.8697500610351562e+02 -3.6373001098632812e+01 -8.7849998474121094e+01 1.8697500610351562e+02 -3.6373001098632812e+01 -9.8350006103515625e+01 1.8676400756835938e+02 -3.5585498809814453e+01 -8.7849998474121094e+01 1.8676400756835938e+02 -3.5585498809814453e+01 -9.8350006103515625e+01 1.8618699645996094e+02 -3.5008998870849609e+01 -8.7849998474121094e+01 1.8618699645996094e+02 -3.5008998870849609e+01 -9.8350006103515625e+01 1.8539999389648438e+02 -3.4798000335693359e+01 -8.7849998474121094e+01 1.8539999389648438e+02 -3.4798000335693359e+01 -9.8350006103515625e+01 1.8461199951171875e+02 -3.5008998870849609e+01 -8.7849998474121094e+01 1.8461199951171875e+02 -3.5008998870849609e+01 -9.8350006103515625e+01 1.8403599548339844e+02 -3.5585498809814453e+01 -8.7849998474121094e+01 1.8403599548339844e+02 -3.5585498809814453e+01 -9.8350006103515625e+01 1.8382499694824219e+02 -3.6373001098632812e+01 -8.7849998474121094e+01 1.8382499694824219e+02 -3.6373001098632812e+01 -9.8350006103515625e+01 1.8403599548339844e+02 -3.7160499572753906e+01 -8.7849998474121094e+01 1.8403599548339844e+02 -3.7160499572753906e+01 -9.8350006103515625e+01 1.8461199951171875e+02 -3.7736999511718750e+01 -8.7849998474121094e+01 1.8461199951171875e+02 -3.7736999511718750e+01 -9.8350006103515625e+01 1.8539999389648438e+02 -3.7948101043701172e+01 -8.7849998474121094e+01 1.8539999389648438e+02 -3.7948101043701172e+01 -9.8350006103515625e+01 1.8618699645996094e+02 -3.7736999511718750e+01 -8.7849998474121094e+01 1.8539999389648438e+02 -3.6373001098632812e+01 -9.9296401977539062e+01 2.2897499084472656e+02 -3.6373001098632812e+01 -9.8350006103515625e+01 2.2876399230957031e+02 -3.5585498809814453e+01 -8.7849998474121094e+01 2.2876399230957031e+02 -3.5585498809814453e+01 -9.8350006103515625e+01 2.2818699645996094e+02 -3.5008998870849609e+01 -8.7849998474121094e+01 2.2818699645996094e+02 -3.5008998870849609e+01 -9.8350006103515625e+01 2.2740000915527344e+02 -3.4798000335693359e+01 -8.7849998474121094e+01 2.2740000915527344e+02 -3.4798000335693359e+01 -9.8350006103515625e+01 2.2661300659179688e+02 -3.5008998870849609e+01 -8.7849998474121094e+01 2.2661300659179688e+02 -3.5008998870849609e+01 -9.8350006103515625e+01 2.2603599548339844e+02 -3.5585498809814453e+01 -8.7849998474121094e+01 2.2603599548339844e+02 -3.5585498809814453e+01 -9.8350006103515625e+01 2.2582499694824219e+02 -3.6373001098632812e+01 -8.7849998474121094e+01 2.2582499694824219e+02 -3.6373001098632812e+01 -9.8350006103515625e+01 2.2603599548339844e+02 -3.7160499572753906e+01 -8.7849998474121094e+01 2.2603599548339844e+02 -3.7160499572753906e+01 -9.8350006103515625e+01 2.2661300659179688e+02 -3.7736999511718750e+01 -8.7849998474121094e+01 2.2661300659179688e+02 -3.7736999511718750e+01 -9.8350006103515625e+01 2.2740000915527344e+02 -3.7948101043701172e+01 -8.7849998474121094e+01 2.2740000915527344e+02 -3.7948101043701172e+01 -9.8350006103515625e+01 2.2818699645996094e+02 -3.7736999511718750e+01 -8.7849998474121094e+01 2.2818699645996094e+02 -3.7736999511718750e+01 -9.8350006103515625e+01 2.2876399230957031e+02 -3.7160499572753906e+01 -8.7849998474121094e+01 2.2876399230957031e+02 -3.7160499572753906e+01 -9.8350006103515625e+01 2.2897499084472656e+02 -3.6373001098632812e+01 -8.7849998474121094e+01 2.2740000915527344e+02 -3.6373001098632812e+01 -9.9296401977539062e+01 2.4413700866699219e+02 -2.0212499618530273e+01 -9.8350006103515625e+01 2.4356100463867188e+02 -1.9635999679565430e+01 -8.7849998474121094e+01 2.4356100463867188e+02 -1.9635999679565430e+01 -9.8350006103515625e+01 2.4277299499511719e+02 -1.9424999237060547e+01 -8.7849998474121094e+01 2.4277299499511719e+02 -1.9424999237060547e+01 -9.8350006103515625e+01 2.4198600769042969e+02 -1.9635999679565430e+01 -8.7849998474121094e+01 2.4198600769042969e+02 -1.9635999679565430e+01 -9.8350006103515625e+01 2.4140899658203125e+02 -2.0212499618530273e+01 -8.7849998474121094e+01 2.4140899658203125e+02 -2.0212499618530273e+01 -9.8350006103515625e+01 2.4119799804687500e+02 -2.1000000000000000e+01 -8.7849998474121094e+01 2.4119799804687500e+02 -2.1000000000000000e+01 -9.8350006103515625e+01 2.4140899658203125e+02 -2.1787500381469727e+01 -8.7849998474121094e+01 2.4140899658203125e+02 -2.1787500381469727e+01 -9.8350006103515625e+01 2.4198600769042969e+02 -2.2364000320434570e+01 -8.7849998474121094e+01 2.4198600769042969e+02 -2.2364000320434570e+01 -9.8350006103515625e+01 2.4277299499511719e+02 -2.2575000762939453e+01 -8.7849998474121094e+01 2.4277299499511719e+02 -2.2575000762939453e+01 -9.8350006103515625e+01 2.4356100463867188e+02 -2.2364000320434570e+01 -8.7849998474121094e+01 2.4356100463867188e+02 -2.2364000320434570e+01 -9.8350006103515625e+01 2.4413700866699219e+02 -2.1787500381469727e+01 -8.7849998474121094e+01 2.4413700866699219e+02 -2.1787500381469727e+01 -9.8350006103515625e+01 2.4434800720214844e+02 -2.1000000000000000e+01 -8.7849998474121094e+01 2.4434800720214844e+02 -2.1000000000000000e+01 -9.8350006103515625e+01 2.4413700866699219e+02 -2.0212499618530273e+01 -8.7849998474121094e+01 2.4277299499511719e+02 -2.1000000000000000e+01 -9.9296401977539062e+01 2.4918800354003906e+02 1.3639299869537354e+00 -9.8350006103515625e+01 2.4840000915527344e+02 1.5749900341033936e+00 -8.7849998474121094e+01 2.4840000915527344e+02 1.5749900341033936e+00 -9.8350006103515625e+01 2.4761199951171875e+02 1.3639299869537354e+00 -8.7849998474121094e+01 2.4761199951171875e+02 1.3639299869537354e+00 -9.8350006103515625e+01 2.4703599548339844e+02 7.8750002384185791e-01 -8.7849998474121094e+01 2.4703599548339844e+02 7.8750002384185791e-01 -9.8350006103515625e+01 2.4682499694824219e+02 0.0000000000000000e+00 -8.7849998474121094e+01 2.4682499694824219e+02 0.0000000000000000e+00 -9.8350006103515625e+01 2.4703599548339844e+02 -7.8750002384185791e-01 -8.7849998474121094e+01 2.4703599548339844e+02 -7.8750002384185791e-01 -9.8350006103515625e+01 2.4761199951171875e+02 -1.3639299869537354e+00 -8.7849998474121094e+01 2.4761199951171875e+02 -1.3639299869537354e+00 -9.8350006103515625e+01 2.4840000915527344e+02 -1.5749900341033936e+00 -8.7849998474121094e+01 2.4840000915527344e+02 -1.5749900341033936e+00 -9.8350006103515625e+01 2.4918800354003906e+02 -1.3639299869537354e+00 -8.7849998474121094e+01 2.4918800354003906e+02 -1.3639299869537354e+00 -9.8350006103515625e+01 2.4976399230957031e+02 -7.8750002384185791e-01 -8.7849998474121094e+01 2.4976399230957031e+02 -7.8750002384185791e-01 -9.8350006103515625e+01 2.4997499084472656e+02 0.0000000000000000e+00 -8.7849998474121094e+01 2.4997499084472656e+02 0.0000000000000000e+00 -9.8350006103515625e+01 2.4976399230957031e+02 7.8750002384185791e-01 -8.7849998474121094e+01 2.4976399230957031e+02 7.8750002384185791e-01 -9.8350006103515625e+01 2.4918800354003906e+02 1.3639299869537354e+00 -8.7849998474121094e+01 2.4840000915527344e+02 0.0000000000000000e+00 -9.9296401977539062e+01 2.4277299499511719e+02 2.2575000762939453e+01 -9.8350006103515625e+01 2.4198600769042969e+02 2.2364000320434570e+01 -8.7849998474121094e+01 2.4198600769042969e+02 2.2364000320434570e+01 -9.8350006103515625e+01 2.4140899658203125e+02 2.1787500381469727e+01 -8.7849998474121094e+01 2.4140899658203125e+02 2.1787500381469727e+01 -9.8350006103515625e+01 2.4119799804687500e+02 2.1000000000000000e+01 -8.7849998474121094e+01 2.4119799804687500e+02 2.1000000000000000e+01 -9.8350006103515625e+01 2.4140899658203125e+02 2.0212499618530273e+01 -8.7849998474121094e+01 2.4140899658203125e+02 2.0212499618530273e+01 -9.8350006103515625e+01 2.4198600769042969e+02 1.9635999679565430e+01 -8.7849998474121094e+01 2.4198600769042969e+02 1.9635999679565430e+01 -9.8350006103515625e+01 2.4277299499511719e+02 1.9424999237060547e+01 -8.7849998474121094e+01 2.4277299499511719e+02 1.9424999237060547e+01 -9.8350006103515625e+01 2.4356100463867188e+02 1.9635999679565430e+01 -8.7849998474121094e+01 2.4356100463867188e+02 1.9635999679565430e+01 -9.8350006103515625e+01 2.4413700866699219e+02 2.0212499618530273e+01 -8.7849998474121094e+01 2.4413700866699219e+02 2.0212499618530273e+01 -9.8350006103515625e+01 2.4434800720214844e+02 2.1000000000000000e+01 -8.7849998474121094e+01 2.4434800720214844e+02 2.1000000000000000e+01 -9.8350006103515625e+01 2.4413700866699219e+02 2.1787500381469727e+01 -8.7849998474121094e+01 2.4413700866699219e+02 2.1787500381469727e+01 -9.8350006103515625e+01 2.4356100463867188e+02 2.2364000320434570e+01 -8.7849998474121094e+01 2.4356100463867188e+02 2.2364000320434570e+01 -9.8350006103515625e+01 2.4277299499511719e+02 2.2575000762939453e+01 -8.7849998474121094e+01 2.4277299499511719e+02 2.1000000000000000e+01 -9.9296401977539062e+01 2.2661300659179688e+02 3.7736999511718750e+01 -9.8350006103515625e+01 2.2603599548339844e+02 3.7160499572753906e+01 -8.7849998474121094e+01 2.2603599548339844e+02 3.7160499572753906e+01 -9.8350006103515625e+01 2.2582499694824219e+02 3.6373001098632812e+01 -8.7849998474121094e+01 2.2582499694824219e+02 3.6373001098632812e+01 -9.8350006103515625e+01 2.2603599548339844e+02 3.5585498809814453e+01 -8.7849998474121094e+01 2.2603599548339844e+02 3.5585498809814453e+01 -9.8350006103515625e+01 2.2661300659179688e+02 3.5008998870849609e+01 -8.7849998474121094e+01 2.2661300659179688e+02 3.5008998870849609e+01 -9.8350006103515625e+01 2.2740000915527344e+02 3.4798000335693359e+01 -8.7849998474121094e+01 2.2740000915527344e+02 3.4798000335693359e+01 -9.8350006103515625e+01 2.2818699645996094e+02 3.5008998870849609e+01 -8.7849998474121094e+01 2.2818699645996094e+02 3.5008998870849609e+01 -9.8350006103515625e+01 2.2876399230957031e+02 3.5585498809814453e+01 -8.7849998474121094e+01 2.2876399230957031e+02 3.5585498809814453e+01 -9.8350006103515625e+01 2.2897499084472656e+02 3.6373001098632812e+01 -8.7849998474121094e+01 2.2897499084472656e+02 3.6373001098632812e+01 -9.8350006103515625e+01 2.2876399230957031e+02 3.7160499572753906e+01 -8.7849998474121094e+01 2.2876399230957031e+02 3.7160499572753906e+01 -9.8350006103515625e+01 2.2818699645996094e+02 3.7736999511718750e+01 -8.7849998474121094e+01 2.2818699645996094e+02 3.7736999511718750e+01 -9.8350006103515625e+01 2.2740000915527344e+02 3.7948101043701172e+01 -8.7849998474121094e+01 2.2740000915527344e+02 3.7948101043701172e+01 -9.8350006103515625e+01 2.2661300659179688e+02 3.7736999511718750e+01 -8.7849998474121094e+01 2.2740000915527344e+02 3.6373001098632812e+01 -9.9296401977539062e+01 1.8382499694824219e+02 3.6373001098632812e+01 -9.8350006103515625e+01 1.8403599548339844e+02 3.5585498809814453e+01 -8.7849998474121094e+01 1.8403599548339844e+02 3.5585498809814453e+01 -9.8350006103515625e+01 1.8461199951171875e+02 3.5008998870849609e+01 -8.7849998474121094e+01 1.8461199951171875e+02 3.5008998870849609e+01 -9.8350006103515625e+01 1.8539999389648438e+02 3.4798000335693359e+01 -8.7849998474121094e+01 1.8539999389648438e+02 3.4798000335693359e+01 -9.8350006103515625e+01 1.8618699645996094e+02 3.5008998870849609e+01 -8.7849998474121094e+01 1.8618699645996094e+02 3.5008998870849609e+01 -9.8350006103515625e+01 1.8676400756835938e+02 3.5585498809814453e+01 -8.7849998474121094e+01 1.8676400756835938e+02 3.5585498809814453e+01 -9.8350006103515625e+01 1.8697500610351562e+02 3.6373001098632812e+01 -8.7849998474121094e+01 1.8697500610351562e+02 3.6373001098632812e+01 -9.8350006103515625e+01 1.8676400756835938e+02 3.7160499572753906e+01 -8.7849998474121094e+01 1.8676400756835938e+02 3.7160499572753906e+01 -9.8350006103515625e+01 1.8618699645996094e+02 3.7736999511718750e+01 -8.7849998474121094e+01 1.8618699645996094e+02 3.7736999511718750e+01 -9.8350006103515625e+01 1.8539999389648438e+02 3.7948101043701172e+01 -8.7849998474121094e+01 1.8539999389648438e+02 3.7948101043701172e+01 -9.8350006103515625e+01 1.8461199951171875e+02 3.7736999511718750e+01 -8.7849998474121094e+01 1.8461199951171875e+02 3.7736999511718750e+01 -9.8350006103515625e+01 1.8403599548339844e+02 3.7160499572753906e+01 -8.7849998474121094e+01 1.8403599548339844e+02 3.7160499572753906e+01 -9.8350006103515625e+01 1.8382499694824219e+02 3.6373001098632812e+01 -8.7849998474121094e+01 1.8539999389648438e+02 3.6373001098632812e+01 -9.9296401977539062e+01 1.6866299438476562e+02 2.0212499618530273e+01 -9.8350006103515625e+01 1.6923899841308594e+02 1.9635999679565430e+01 -8.7849998474121094e+01 1.6923899841308594e+02 1.9635999679565430e+01 -9.8350006103515625e+01 1.7002700805664062e+02 1.9424999237060547e+01 -8.7849998474121094e+01 1.7002700805664062e+02 1.9424999237060547e+01 -9.8350006103515625e+01 1.7081399536132812e+02 1.9635999679565430e+01 -8.7849998474121094e+01 1.7081399536132812e+02 1.9635999679565430e+01 -9.8350006103515625e+01 1.7139099121093750e+02 2.0212499618530273e+01 -8.7849998474121094e+01 1.7139099121093750e+02 2.0212499618530273e+01 -9.8350006103515625e+01 1.7160198974609375e+02 2.1000000000000000e+01 -8.7849998474121094e+01 1.7160198974609375e+02 2.1000000000000000e+01 -9.8350006103515625e+01 1.7139099121093750e+02 2.1787500381469727e+01 -8.7849998474121094e+01 1.7139099121093750e+02 2.1787500381469727e+01 -9.8350006103515625e+01 1.7081399536132812e+02 2.2364000320434570e+01 -8.7849998474121094e+01 1.7081399536132812e+02 2.2364000320434570e+01 -9.8350006103515625e+01 1.7002700805664062e+02 2.2575000762939453e+01 -8.7849998474121094e+01 1.7002700805664062e+02 2.2575000762939453e+01 -9.8350006103515625e+01 1.6923899841308594e+02 2.2364000320434570e+01 -8.7849998474121094e+01 1.6923899841308594e+02 2.2364000320434570e+01 -9.8350006103515625e+01 1.6866299438476562e+02 2.1787500381469727e+01 -8.7849998474121094e+01 1.6866299438476562e+02 2.1787500381469727e+01 -9.8350006103515625e+01 1.6845199584960938e+02 2.1000000000000000e+01 -8.7849998474121094e+01 1.6845199584960938e+02 2.1000000000000000e+01 -9.8350006103515625e+01 1.6866299438476562e+02 2.0212499618530273e+01 -8.7849998474121094e+01 1.7002700805664062e+02 2.1000000000000000e+01 -9.9296401977539062e+01 1.9244000244140625e+02 -3.9818000793457031e+01 -8.7849998474121094e+01 1.9060600280761719e+02 -3.4562500000000000e+01 -8.7849998474121094e+01 2.2036000061035156e+02 -3.9818000793457031e+01 -8.7849998474121094e+01 2.2219400024414062e+02 -3.4562500000000000e+01 -8.7849998474121094e+01 2.0086199951171875e+02 -4.7011100769042969e+01 -8.7849998474121094e+01 1.9600900268554688e+02 -4.4166599273681641e+01 -8.7849998474121094e+01 2.4341299438476562e+02 8.6051807403564453e+00 -8.7849998474121094e+01 2.4439999389648438e+02 0.0000000000000000e+00 -8.7849998474121094e+01 2.4341299438476562e+02 -8.6051807403564453e+00 -8.7849998474121094e+01 2.4050299072265625e+02 -1.6763299942016602e+01 -8.7849998474121094e+01 2.2219400024414062e+02 3.4562500000000000e+01 -8.7849998474121094e+01 2.2961000061035156e+02 3.0088100433349609e+01 -8.7849998474121094e+01 1.9060600280761719e+02 3.4562500000000000e+01 -8.7849998474121094e+01 2.3582099914550781e+02 2.4050500869750977e+01 -8.7849998474121094e+01 2.3582099914550781e+02 -2.4050500869750977e+01 -8.7849998474121094e+01 2.2961000061035156e+02 -3.0088100433349609e+01 -8.7849998474121094e+01 1.8319000244140625e+02 -3.0088100433349609e+01 -8.7849998474121094e+01 1.7697900390625000e+02 -2.4050500869750977e+01 -8.7849998474121094e+01 1.7229699707031250e+02 -1.6763299942016602e+01 -8.7849998474121094e+01 2.2036000061035156e+02 3.9818000793457031e+01 -8.7849998474121094e+01 1.9244000244140625e+02 3.9818000793457031e+01 -8.7849998474121094e+01 1.9600900268554688e+02 4.4166599273681641e+01 -8.7849998474121094e+01 2.4050299072265625e+02 1.6763299942016602e+01 -8.7849998474121094e+01 1.8319000244140625e+02 3.0088100433349609e+01 -8.7849998474121094e+01 1.6938699340820312e+02 -8.6051807403564453e+00 -8.7849998474121094e+01 1.6840000915527344e+02 0.0000000000000000e+00 -8.7849998474121094e+01 1.6938699340820312e+02 8.6051807403564453e+00 -8.7849998474121094e+01 2.0640000915527344e+02 -4.8000000000000000e+01 -8.7849998474121094e+01 2.1193798828125000e+02 -4.7011100769042969e+01 -8.7849998474121094e+01 2.1679100036621094e+02 -4.4166599273681641e+01 -8.7849998474121094e+01 1.7229699707031250e+02 1.6763299942016602e+01 -8.7849998474121094e+01 1.7697900390625000e+02 2.4050500869750977e+01 -8.7849998474121094e+01 2.1679100036621094e+02 4.4166599273681641e+01 -8.7849998474121094e+01 2.1193798828125000e+02 4.7011100769042969e+01 -8.7849998474121094e+01 2.0640000915527344e+02 4.8000000000000000e+01 -8.7849998474121094e+01 2.0086199951171875e+02 4.7011100769042969e+01 -8.7849998474121094e+01 1.9059700012207031e+02 3.4503200531005859e+01 -9.1849998474121094e+01 1.9059700012207031e+02 3.4503200531005859e+01 -8.8849998474121094e+01 1.8319900512695312e+02 3.0032299041748047e+01 -8.8849998474121094e+01 1.8319900512695312e+02 3.0032299041748047e+01 -9.1849998474121094e+01 1.7700498962402344e+02 2.4003398895263672e+01 -8.8849998474121094e+01 1.7700498962402344e+02 2.4003398895263672e+01 -9.1849998474121094e+01 1.7233599853515625e+02 1.6729301452636719e+01 -8.8849998474121094e+01 1.7233599853515625e+02 1.6729301452636719e+01 -9.1849998474121094e+01 1.6943399047851562e+02 8.5873603820800781e+00 -8.8849998474121094e+01 1.6943399047851562e+02 8.5873603820800781e+00 -9.1849998474121094e+01 1.6844999694824219e+02 0.0000000000000000e+00 -8.8849998474121094e+01 1.6844999694824219e+02 0.0000000000000000e+00 -9.1849998474121094e+01 1.6943399047851562e+02 -8.5873603820800781e+00 -8.8849998474121094e+01 1.6943399047851562e+02 -8.5873603820800781e+00 -9.1849998474121094e+01 1.7233599853515625e+02 -1.6729301452636719e+01 -8.8849998474121094e+01 1.7233599853515625e+02 -1.6729301452636719e+01 -9.1849998474121094e+01 1.7700498962402344e+02 -2.4003398895263672e+01 -8.8849998474121094e+01 1.7700498962402344e+02 -2.4003398895263672e+01 -9.1849998474121094e+01 1.8319900512695312e+02 -3.0032299041748047e+01 -8.8849998474121094e+01 1.8319900512695312e+02 -3.0032299041748047e+01 -9.1849998474121094e+01 1.9059700012207031e+02 -3.4503200531005859e+01 -8.8849998474121094e+01 1.9059700012207031e+02 -3.4503200531005859e+01 -9.1849998474121094e+01 2.2220300292968750e+02 -3.4503200531005859e+01 -9.1849998474121094e+01 2.2036000061035156e+02 -3.9818000793457031e+01 -9.1849998474121094e+01 2.1193798828125000e+02 -4.7011100769042969e+01 -9.1849998474121094e+01 2.1679100036621094e+02 -4.4166599273681641e+01 -9.1849998474121094e+01 2.3579501342773438e+02 -2.4003398895263672e+01 -9.1849998474121094e+01 2.4046400451660156e+02 -1.6729301452636719e+01 -9.1849998474121094e+01 2.4336599731445312e+02 -8.5873603820800781e+00 -9.1849998474121094e+01 2.4435000610351562e+02 0.0000000000000000e+00 -9.1849998474121094e+01 2.4336599731445312e+02 8.5873603820800781e+00 -9.1849998474121094e+01 2.4046400451660156e+02 1.6729301452636719e+01 -9.1849998474121094e+01 2.3579501342773438e+02 2.4003398895263672e+01 -9.1849998474121094e+01 2.2220300292968750e+02 3.4503200531005859e+01 -9.1849998474121094e+01 2.0086199951171875e+02 -4.7011100769042969e+01 -9.1849998474121094e+01 2.0640000915527344e+02 -4.8000000000000000e+01 -9.1849998474121094e+01 1.9600900268554688e+02 -4.4166599273681641e+01 -9.1849998474121094e+01 1.9244000244140625e+02 -3.9818000793457031e+01 -9.1849998474121094e+01 2.2959999084472656e+02 -3.0032299041748047e+01 -9.1849998474121094e+01 2.2036000061035156e+02 3.9818000793457031e+01 -9.1849998474121094e+01 2.1679100036621094e+02 4.4166599273681641e+01 -9.1849998474121094e+01 2.1193798828125000e+02 4.7011100769042969e+01 -9.1849998474121094e+01 2.2959999084472656e+02 3.0032299041748047e+01 -9.1849998474121094e+01 1.9244000244140625e+02 3.9818000793457031e+01 -9.1849998474121094e+01 1.9600900268554688e+02 4.4166599273681641e+01 -9.1849998474121094e+01 2.0086199951171875e+02 4.7011100769042969e+01 -9.1849998474121094e+01 2.0640000915527344e+02 4.8000000000000000e+01 -9.1849998474121094e+01 2.2220300292968750e+02 -3.4503200531005859e+01 -8.8849998474121094e+01 2.2959999084472656e+02 -3.0032299041748047e+01 -8.8849998474121094e+01 2.3579501342773438e+02 -2.4003398895263672e+01 -8.8849998474121094e+01 2.4046400451660156e+02 -1.6729301452636719e+01 -8.8849998474121094e+01 2.4336599731445312e+02 -8.5873603820800781e+00 -8.8849998474121094e+01 2.4435000610351562e+02 0.0000000000000000e+00 -8.8849998474121094e+01 2.4336599731445312e+02 8.5873603820800781e+00 -8.8849998474121094e+01 2.4046400451660156e+02 1.6729301452636719e+01 -8.8849998474121094e+01 2.3579501342773438e+02 2.4003398895263672e+01 -8.8849998474121094e+01 2.2959999084472656e+02 3.0032299041748047e+01 -8.8849998474121094e+01 2.2220300292968750e+02 3.4503200531005859e+01 -8.8849998474121094e+01 2.2219400024414062e+02 -3.4562500000000000e+01 -8.8849998474121094e+01 2.2961000061035156e+02 -3.0088100433349609e+01 -8.8849998474121094e+01 2.3582099914550781e+02 -2.4050500869750977e+01 -8.8849998474121094e+01 2.4050299072265625e+02 -1.6763299942016602e+01 -8.8849998474121094e+01 2.4341299438476562e+02 -8.6051807403564453e+00 -8.8849998474121094e+01 2.4439999389648438e+02 0.0000000000000000e+00 -8.8849998474121094e+01 2.4341299438476562e+02 8.6051807403564453e+00 -8.8849998474121094e+01 2.4050299072265625e+02 1.6763299942016602e+01 -8.8849998474121094e+01 2.3582099914550781e+02 2.4050500869750977e+01 -8.8849998474121094e+01 2.2961000061035156e+02 3.0088100433349609e+01 -8.8849998474121094e+01 2.2219400024414062e+02 3.4562500000000000e+01 -8.8849998474121094e+01 1.9060600280761719e+02 3.4562500000000000e+01 -8.8849998474121094e+01 1.8319000244140625e+02 3.0088100433349609e+01 -8.8849998474121094e+01 1.7697900390625000e+02 2.4050500869750977e+01 -8.8849998474121094e+01 1.7229699707031250e+02 1.6763299942016602e+01 -8.8849998474121094e+01 1.6938699340820312e+02 8.6051807403564453e+00 -8.8849998474121094e+01 1.6840000915527344e+02 0.0000000000000000e+00 -8.8849998474121094e+01 1.6938699340820312e+02 -8.6051807403564453e+00 -8.8849998474121094e+01 1.7229699707031250e+02 -1.6763299942016602e+01 -8.8849998474121094e+01 1.7697900390625000e+02 -2.4050500869750977e+01 -8.8849998474121094e+01 1.8319000244140625e+02 -3.0088100433349609e+01 -8.8849998474121094e+01 1.9060600280761719e+02 -3.4562500000000000e+01 -8.8849998474121094e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 64380 -> 93 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.6630001664161682e+01 1.6883499920368195e+02 1.0981900244951248e+02) (float-vector 6.8196401000022888e+01 1.7083799839019775e+02 -3.4893000125885010e+02) (float-vector 8.7171003222465515e+01 1.6798500716686249e+02 -3.4893101453781128e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0676199942827225e+02 1.4851300418376923e+02 -3.4893000125885010e+02) (float-vector 2.5140300393104553e+02 2.2075200453400612e+01 -1.8271300196647644e+02) (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -1.7426000535488129e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5054800510406494e+02 0.0000000000000000e+00 -1.9503200054168701e+02) (float-vector 2.5140300393104553e+02 2.2075200453400612e+01 -1.8271300196647644e+02) (float-vector 1.0676199942827225e+02 1.4851300418376923e+02 -3.4893000125885010e+02) (float-vector 1.3011500239372253e+02 9.2977002263069153e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6930200159549713e+02 -7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 8.5315600037574768e+01 -1.5731100738048553e+02 1.7576999962329865e+02) (float-vector 7.8207902610301971e+01 -1.3682000339031219e+02 2.1659399569034576e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6930200159549713e+02 -7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 2.0188400149345398e+02 -5.0311498343944550e+01 2.2556999325752258e+02) (float-vector 8.4689401090145111e+01 -1.6896800696849823e+02 1.3141700625419617e+02) (float-vector 8.5315600037574768e+01 -1.5731100738048553e+02 1.7576999962329865e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.6108302474021912e+01 6.7997202277183533e+01 -3.2391500473022461e+02) (float-vector -9.3664899468421936e+01 7.5719296932220459e+01 1.2136600166559219e+02) (float-vector -9.8219901323318481e+01 3.3143199980258942e+01 -1.1910899728536606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3318300247192383e+02 -2.5000001187436283e-01 -3.4893000125885010e+02) (float-vector 2.5054800510406494e+02 0.0000000000000000e+00 -1.9503200054168701e+02) (float-vector 1.3011500239372253e+02 9.2977002263069153e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5054800510406494e+02 0.0000000000000000e+00 -1.9503200054168701e+02) (float-vector 1.3318300247192383e+02 -2.5000001187436283e-01 -3.4893000125885010e+02) (float-vector 1.2700299918651581e+02 -1.0510499775409698e+02 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6114399135112762e+01 7.3818899691104889e+01 1.6179999709129333e+02) (float-vector -9.6251301467418671e+01 0.0000000000000000e+00 1.3361799716949463e+02) (float-vector -9.3664899468421936e+01 7.5719296932220459e+01 1.2136600166559219e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4408900737762451e+02 -3.5826299339532852e+01 -7.7849999070167542e+01) (float-vector 8.4689401090145111e+01 -1.6896800696849823e+02 1.3141700625419617e+02) (float-vector 2.0188400149345398e+02 -5.0311498343944550e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.4701701998710632e+01 -1.0245600342750549e+02 1.1462599784135818e+02) (float-vector -6.9195002317428589e+01 -1.2514199316501617e+02 1.5064600110054016e+02) (float-vector -5.3999498486518860e+01 -1.5666399896144867e+02 1.3258099555969238e+02) (float-vector -5.4294701665639877e+01 -1.5784099698066711e+02 -3.4893000125885010e+02) (float-vector -7.2561502456665039e+01 -1.2886199355125427e+02 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7866502106189728e+01 -1.2761400640010834e+02 2.2269700467586517e+02) (float-vector 1.6930200159549713e+02 -7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 7.8207902610301971e+01 -1.3682000339031219e+02 2.1659399569034576e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.5315600037574768e+01 -1.5731100738048553e+02 1.7576999962329865e+02) (float-vector 6.8196401000022888e+01 -1.5177400410175323e+02 1.9187499582767487e+02) (float-vector 7.8207902610301971e+01 -1.3682000339031219e+02 2.1659399569034576e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.8207902610301971e+01 -1.3682000339031219e+02 2.1659399569034576e+02) (float-vector 6.8196401000022888e+01 -1.5177400410175323e+02 1.9187499582767487e+02) (float-vector -2.6714500039815903e+01 -1.4998200535774231e+02 1.8634200096130371e+02) (float-vector -1.3772199861705303e+01 -1.3620300590991974e+02 2.1306599676609039e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7677401453256607e+01 1.6289700567722321e+02 -3.4893000125885010e+02) (float-vector -5.7923298329114914e+01 1.5181900560855865e+02 1.3257999718189240e+02) (float-vector -7.2674497961997986e+01 1.2875500321388245e+02 1.1462599784135818e+02) (float-vector -7.3498301208019257e+01 1.2705400586128235e+02 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 -1.7083799839019775e+02 -3.4893000125885010e+02) (float-vector -3.7831198424100876e+01 -1.6665999591350555e+02 -3.4893000125885010e+02) (float-vector -3.9583399891853333e+01 -1.6623400151729584e+02 1.1462599784135818e+02) (float-vector 8.4689401090145111e+01 -1.6896800696849823e+02 1.3141700625419617e+02) (float-vector 8.5657902061939240e+01 -1.6943299770355225e+02 -7.8020803630352020e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -7.7849999070167542e+01) (float-vector 2.4408900737762451e+02 -3.5826299339532852e+01 -7.7849999070167542e+01) (float-vector 2.0188400149345398e+02 -5.0311498343944550e+01 2.2556999325752258e+02) (float-vector 2.1515500545501709e+02 -2.6695599779486656e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.4294701665639877e+01 -1.5784099698066711e+02 -3.4893000125885010e+02) (float-vector -5.3999498486518860e+01 -1.5666399896144867e+02 1.3258099555969238e+02) (float-vector -4.4489800930023193e+01 -1.6341699659824371e+02 1.3258500397205353e+02) (float-vector -3.9583399891853333e+01 -1.6623400151729584e+02 1.1462599784135818e+02) (float-vector -3.7831198424100876e+01 -1.6665999591350555e+02 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9195002317428589e+01 -1.2514199316501617e+02 1.5064600110054016e+02) (float-vector -5.5958800017833710e+01 -1.4812399446964264e+02 1.5071099996566772e+02) (float-vector -5.3999498486518860e+01 -1.5666399896144867e+02 1.3258099555969238e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.9068600386381149e+01 -1.2794299423694611e+02 2.1376399695873260e+02) (float-vector -1.3772199861705303e+01 -1.3620300590991974e+02 2.1306599676609039e+02) (float-vector -2.6714500039815903e+01 -1.4998200535774231e+02 1.8634200096130371e+02) (float-vector -4.4533200562000275e+01 -1.3895900547504425e+02 1.8628600239753723e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.6251301467418671e+01 0.0000000000000000e+00 1.3361799716949463e+02) (float-vector -9.2589497566223145e+01 -7.5564101338386536e+01 1.3423599302768707e+02) (float-vector -9.6399903297424316e+01 -5.1399398595094681e+01 1.0968299955129623e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6002700030803680e+01 -7.4606798589229584e+01 1.6179999709129333e+02) (float-vector -9.2589497566223145e+01 -7.5564101338386536e+01 1.3423599302768707e+02) (float-vector -9.6251301467418671e+01 0.0000000000000000e+00 1.3361799716949463e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 -1.6451099514961243e+02 1.5994100272655487e+02) (float-vector 8.5315600037574768e+01 -1.5731100738048553e+02 1.7576999962329865e+02) (float-vector 8.4689401090145111e+01 -1.6896800696849823e+02 1.3141700625419617e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 -1.6451099514961243e+02 1.5994100272655487e+02) (float-vector 6.8196401000022888e+01 -1.5177400410175323e+02 1.9187499582767487e+02) (float-vector 8.5315600037574768e+01 -1.5731100738048553e+02 1.7576999962329865e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.4489800930023193e+01 -1.6341699659824371e+02 1.3258500397205353e+02) (float-vector -3.6547001451253891e+01 -1.6216500103473663e+02 1.5073800086975098e+02) (float-vector 6.8196401000022888e+01 -1.6451099514961243e+02 1.5994100272655487e+02) (float-vector 8.4689401090145111e+01 -1.6896800696849823e+02 1.3141700625419617e+02) (float-vector -3.9583399891853333e+01 -1.6623400151729584e+02 1.1462599784135818e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 -1.5177400410175323e+02 1.9187499582767487e+02) (float-vector 6.8196401000022888e+01 -1.6451099514961243e+02 1.5994100272655487e+02) (float-vector -3.6547001451253891e+01 -1.6216500103473663e+02 1.5073800086975098e+02) (float-vector -2.6714500039815903e+01 -1.4998200535774231e+02 1.8634200096130371e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7677401453256607e+01 1.6289700567722321e+02 -3.4893000125885010e+02) (float-vector -3.2944198697805405e+01 1.6729900240898132e+02 -3.4893000125885010e+02) (float-vector -3.9579000324010849e+01 1.6626299917697906e+02 -6.3664600253105164e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6304800063371658e+01 1.6661100089550018e+02 1.3258600234985352e+02) (float-vector -4.4998601078987122e+01 1.6426199674606323e+02 1.1462599784135818e+02) (float-vector -3.9579000324010849e+01 1.6626299917697906e+02 -6.3664600253105164e+01) (float-vector -3.2944198697805405e+01 1.6729900240898132e+02 -3.4893000125885010e+02) (float-vector 6.8196401000022888e+01 1.7083799839019775e+02 -3.4893000125885010e+02) (float-vector 8.6630001664161682e+01 1.6883499920368195e+02 1.0981900244951248e+02) (float-vector 6.8196401000022888e+01 1.6820000112056732e+02 1.4482000470161438e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.9579000324010849e+01 1.6626299917697906e+02 -6.3664600253105164e+01) (float-vector -4.4998601078987122e+01 1.6426199674606323e+02 1.1462599784135818e+02) (float-vector -4.9507301300764084e+01 1.6051499545574188e+02 1.3258300721645355e+02) (float-vector -5.7923298329114914e+01 1.5181900560855865e+02 1.3257999718189240e+02) (float-vector -4.7677401453256607e+01 1.6289700567722321e+02 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9507301300764084e+01 1.6051499545574188e+02 1.3258300721645355e+02) (float-vector -4.4998601078987122e+01 1.6426199674606323e+02 1.1462599784135818e+02) (float-vector -2.6304800063371658e+01 1.6661100089550018e+02 1.3258600234985352e+02) (float-vector -4.2366098612546921e+01 1.6014400124549866e+02 1.5073099732398987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3476401120424271e+01 1.4763100445270538e+02 1.8632400035858154e+02) (float-vector -9.2393895611166954e+00 1.3737300038337708e+02 2.1243099868297577e+02) (float-vector -2.2131899371743202e+01 1.3259899616241455e+02 2.1374799311161041e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2131899371743202e+01 1.3259899616241455e+02 2.1374799311161041e+02) (float-vector -9.2393895611166954e+00 1.3737300038337708e+02 2.1243099868297577e+02) (float-vector 7.7862098813056946e+01 1.3228699564933777e+02 2.2065299749374390e+02) (float-vector -1.4484800398349762e+01 1.2895099818706512e+02 2.1893900632858276e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4484800398349762e+01 1.2895099818706512e+02 2.1893900632858276e+02) (float-vector -3.0103499069809914e+01 1.1806800216436386e+02 2.1856600046157837e+02) (float-vector -2.2131899371743202e+01 1.3259899616241455e+02 2.1374799311161041e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2131899371743202e+01 1.3259899616241455e+02 2.1374799311161041e+02) (float-vector -3.0103499069809914e+01 1.1806800216436386e+02 2.1856600046157837e+02) (float-vector -3.8530301302671432e+01 1.1750900000333786e+02 2.1274599432945251e+02) (float-vector -4.8055700957775116e+01 1.3402099907398224e+02 1.8627899885177612e+02) (float-vector -3.3476401120424271e+01 1.4763100445270538e+02 1.8632400035858154e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0103499069809914e+01 1.1806800216436386e+02 2.1856600046157837e+02) (float-vector -2.6147600263357162e+01 1.0939399898052216e+02 2.2052499651908875e+02) (float-vector -4.8669401556253433e+01 6.8580597639083862e+01 2.1927699446678162e+02) (float-vector -5.9023000299930573e+01 7.0672802627086639e+01 2.1220800280570984e+02) (float-vector -3.8530301302671432e+01 1.1750900000333786e+02 2.1274599432945251e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0188400149345398e+02 5.0311498343944550e+01 2.2556999325752258e+02) (float-vector 2.5308600068092346e+02 2.2900499403476715e+01 -7.7849999070167542e+01) (float-vector 2.5674000382423401e+02 1.3033900409936905e+01 -7.7849999070167542e+01) (float-vector 2.1859599649906158e+02 1.3544600456953049e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.6590602993965149e+01 -1.6880899667739868e+02 -3.4893000125885010e+02) (float-vector 6.8196401000022888e+01 -1.7083799839019775e+02 -3.4893000125885010e+02) (float-vector 8.5657902061939240e+01 -1.6943299770355225e+02 -7.8020803630352020e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -7.7849999070167542e+01) (float-vector 2.5674000382423401e+02 1.3033900409936905e+01 -7.7849999070167542e+01) (float-vector 2.5308600068092346e+02 2.2900499403476715e+01 -7.7849999070167542e+01) (float-vector 2.5516301393508911e+02 1.8059799447655678e+01 -1.7426000535488129e+02) (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -1.7426000535488129e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -7.7849999070167542e+01) (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -7.7849999070167542e+01) (float-vector 2.1515500545501709e+02 -2.6695599779486656e+01 2.2556999325752258e+02) (float-vector 2.1975499391555786e+02 0.0000000000000000e+00 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5674000382423401e+02 1.3033900409936905e+01 -7.7849999070167542e+01) (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -7.7849999070167542e+01) (float-vector 2.1975499391555786e+02 0.0000000000000000e+00 2.2556999325752258e+02) (float-vector 2.1859599649906158e+02 1.3544600456953049e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.5958800017833710e+01 -1.4812399446964264e+02 1.5071099996566772e+02) (float-vector -3.6547001451253891e+01 -1.6216500103473663e+02 1.5073800086975098e+02) (float-vector -4.4489800930023193e+01 -1.6341699659824371e+02 1.3258500397205353e+02) (float-vector -5.3999498486518860e+01 -1.5666399896144867e+02 1.3258099555969238e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.6547001451253891e+01 -1.6216500103473663e+02 1.5073800086975098e+02) (float-vector -5.5958800017833710e+01 -1.4812399446964264e+02 1.5071099996566772e+02) (float-vector -4.4533200562000275e+01 -1.3895900547504425e+02 1.8628600239753723e+02) (float-vector -2.6714500039815903e+01 -1.4998200535774231e+02 1.8634200096130371e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.8207902610301971e+01 -1.3682000339031219e+02 2.1659399569034576e+02) (float-vector -1.3772199861705303e+01 -1.3620300590991974e+02 2.1306599676609039e+02) (float-vector -1.2629199773073196e+01 -1.2958300113677979e+02 2.1890999376773834e+02) (float-vector 7.7866502106189728e+01 -1.2761400640010834e+02 2.2269700467586517e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2629199773073196e+01 -1.2958300113677979e+02 2.1890999376773834e+02) (float-vector -1.3772199861705303e+01 -1.3620300590991974e+02 2.1306599676609039e+02) (float-vector -2.9068600386381149e+01 -1.2794299423694611e+02 2.1376399695873260e+02) (float-vector -3.3220700919628143e+01 -1.1372599750757217e+02 2.1834300458431244e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2589497566223145e+01 -7.5564101338386536e+01 1.3423599302768707e+02) (float-vector -9.6399903297424316e+01 -6.8011097609996796e+01 6.5145000815391541e+01) (float-vector -9.6399903297424316e+01 -5.1399398595094681e+01 1.0968299955129623e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.3664899468421936e+01 7.5719296932220459e+01 1.2136600166559219e+02) (float-vector -9.6251301467418671e+01 0.0000000000000000e+00 1.3361799716949463e+02) (float-vector -9.6399903297424316e+01 -5.1399398595094681e+01 1.0968299955129623e+02) (float-vector -9.6399903297424316e+01 -6.8011097609996796e+01 6.5145000815391541e+01) (float-vector -9.8315902054309845e+01 -2.7021599933505058e+01 -1.9364100694656372e+02) (float-vector -9.8219901323318481e+01 3.3143199980258942e+01 -1.1910899728536606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.6399903297424316e+01 -6.8011097609996796e+01 6.5145000815391541e+01) (float-vector -9.2589497566223145e+01 -7.5564101338386536e+01 1.3423599302768707e+02) (float-vector -8.4701701998710632e+01 -1.0245600342750549e+02 1.1462599784135818e+02) (float-vector -7.2561502456665039e+01 -1.2886199355125427e+02 -3.4893000125885010e+02) (float-vector -9.3838699162006378e+01 -7.4910499155521393e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.8669401556253433e+01 6.8580597639083862e+01 2.1927699446678162e+02) (float-vector -4.8669401556253433e+01 -6.8580701947212219e+01 2.1927699446678162e+02) (float-vector -5.9105198830366135e+01 -6.9969199597835541e+01 2.1223700046539307e+02) (float-vector -5.9023000299930573e+01 7.0672802627086639e+01 2.1220800280570984e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1706798374652863e+01 -1.0670699924230576e+02 2.0295099914073944e+02) (float-vector -3.3220700919628143e+01 -1.1372599750757217e+02 2.1834300458431244e+02) (float-vector -2.9068600386381149e+01 -1.2794299423694611e+02 2.1376399695873260e+02) (float-vector -4.4533200562000275e+01 -1.3895900547504425e+02 1.8628600239753723e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9105198830366135e+01 -6.9969199597835541e+01 2.1223700046539307e+02) (float-vector -4.8669401556253433e+01 -6.8580701947212219e+01 2.1927699446678162e+02) (float-vector -3.3220700919628143e+01 -1.1372599750757217e+02 2.1834300458431244e+02) (float-vector -5.1706798374652863e+01 -1.0670699924230576e+02 2.0295099914073944e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.8338700830936432e+01 -2.2243300452828407e+01 -2.8717300295829773e+02) (float-vector -9.8315902054309845e+01 -2.7021599933505058e+01 -1.9364100694656372e+02) (float-vector -9.6399903297424316e+01 -6.8011097609996796e+01 6.5145000815391541e+01) (float-vector -9.3838699162006378e+01 -7.4910499155521393e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.6108302474021912e+01 6.7997202277183533e+01 -3.2391500473022461e+02) (float-vector -9.8219901323318481e+01 3.3143199980258942e+01 -1.1910899728536606e+02) (float-vector -9.8315902054309845e+01 -2.7021599933505058e+01 -1.9364100694656372e+02) (float-vector -9.8338700830936432e+01 -2.2243300452828407e+01 -2.8717300295829773e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.6108302474021912e+01 6.7997202277183533e+01 -3.2391500473022461e+02) (float-vector -9.8338700830936432e+01 -2.2243300452828407e+01 -2.8717300295829773e+02) (float-vector -9.3838699162006378e+01 -7.4910499155521393e+01 -3.4893000125885010e+02) (float-vector -9.3838699162006378e+01 7.4910402297973633e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.1206202507019043e+01 1.4322899281978607e+02 2.0579800009727478e+02) (float-vector 1.6930200159549713e+02 7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 7.7862098813056946e+01 1.3228699564933777e+02 2.2065299749374390e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.1206202507019043e+01 1.4322899281978607e+02 2.0579800009727478e+02) (float-vector 8.4360197186470032e+01 1.5656499564647675e+02 1.7836900055408478e+02) (float-vector 1.6930200159549713e+02 7.4177101254463196e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 7.7862098813056946e+01 1.3228699564933777e+02 2.2065299749374390e+02) (float-vector -9.2393895611166954e+00 1.3737300038337708e+02 2.1243099868297577e+02) (float-vector 8.1206202507019043e+01 1.4322899281978607e+02 2.0579800009727478e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.5546799004077911e+01 1.6694700717926025e+02 1.4381900429725647e+02) (float-vector 6.8196401000022888e+01 1.6820000112056732e+02 1.4482000470161438e+02) (float-vector 8.6630001664161682e+01 1.6883499920368195e+02 1.0981900244951248e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 1.6820000112056732e+02 1.4482000470161438e+02) (float-vector 8.5546799004077911e+01 1.6694700717926025e+02 1.4381900429725647e+02) (float-vector 8.4360197186470032e+01 1.5656499564647675e+02 1.7836900055408478e+02) (float-vector 6.8196401000022888e+01 1.6195400059223175e+02 1.6789500415325165e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0188400149345398e+02 5.0311498343944550e+01 2.2556999325752258e+02) (float-vector 1.6930200159549713e+02 7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 8.4360197186470032e+01 1.5656499564647675e+02 1.7836900055408478e+02) (float-vector 8.5546799004077911e+01 1.6694700717926025e+02 1.4381900429725647e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3847902715206146e+01 1.0178600251674652e+02 1.3253200054168701e+02) (float-vector -6.9195002317428589e+01 1.2514199316501617e+02 1.5064600110054016e+02) (float-vector -8.6114399135112762e+01 7.3818899691104889e+01 1.6179999709129333e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.3847902715206146e+01 1.0178600251674652e+02 1.3253200054168701e+02) (float-vector -8.6114399135112762e+01 7.3818899691104889e+01 1.6179999709129333e+02) (float-vector -9.3664899468421936e+01 7.5719296932220459e+01 1.2136600166559219e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.3498301208019257e+01 1.2705400586128235e+02 -3.4893000125885010e+02) (float-vector -7.2674497961997986e+01 1.2875500321388245e+02 1.1462599784135818e+02) (float-vector -8.3847902715206146e+01 1.0178600251674652e+02 1.3253200054168701e+02) (float-vector -9.3664899468421936e+01 7.5719296932220459e+01 1.2136600166559219e+02) (float-vector -9.6108302474021912e+01 6.7997202277183533e+01 -3.2391500473022461e+02) (float-vector -9.3838699162006378e+01 7.4910402297973633e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2169401198625565e+01 1.5297399461269379e+02 1.5071499347686768e+02) (float-vector -4.8055700957775116e+01 1.3402099907398224e+02 1.8627899885177612e+02) (float-vector -6.8436399102210999e+01 9.3657903373241425e+01 1.8583300709724426e+02) (float-vector -8.6114399135112762e+01 7.3818899691104889e+01 1.6179999709129333e+02) (float-vector -6.9195002317428589e+01 1.2514199316501617e+02 1.5064600110054016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2169401198625565e+01 1.5297399461269379e+02 1.5071499347686768e+02) (float-vector -4.2366098612546921e+01 1.6014400124549866e+02 1.5073099732398987e+02) (float-vector -3.3476401120424271e+01 1.4763100445270538e+02 1.8632400035858154e+02) (float-vector -4.8055700957775116e+01 1.3402099907398224e+02 1.8627899885177612e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2169401198625565e+01 1.5297399461269379e+02 1.5071499347686768e+02) (float-vector -6.9195002317428589e+01 1.2514199316501617e+02 1.5064600110054016e+02) (float-vector -8.3847902715206146e+01 1.0178600251674652e+02 1.3253200054168701e+02) (float-vector -7.2674497961997986e+01 1.2875500321388245e+02 1.1462599784135818e+02) (float-vector -5.7923298329114914e+01 1.5181900560855865e+02 1.3257999718189240e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2169401198625565e+01 1.5297399461269379e+02 1.5071499347686768e+02) (float-vector -5.7923298329114914e+01 1.5181900560855865e+02 1.3257999718189240e+02) (float-vector -4.9507301300764084e+01 1.6051499545574188e+02 1.3258300721645355e+02) (float-vector -4.2366098612546921e+01 1.6014400124549866e+02 1.5073099732398987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9965600222349167e+01 1.5806500613689423e+02 1.6875800490379333e+02) (float-vector -3.3476401120424271e+01 1.4763100445270538e+02 1.8632400035858154e+02) (float-vector -4.2366098612546921e+01 1.6014400124549866e+02 1.5073099732398987e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 1.6195400059223175e+02 1.6789500415325165e+02) (float-vector -1.9965600222349167e+01 1.5806500613689423e+02 1.6875800490379333e+02) (float-vector -4.2366098612546921e+01 1.6014400124549866e+02 1.5073099732398987e+02) (float-vector -2.6304800063371658e+01 1.6661100089550018e+02 1.3258600234985352e+02) (float-vector 6.8196401000022888e+01 1.6820000112056732e+02 1.4482000470161438e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3476401120424271e+01 1.4763100445270538e+02 1.8632400035858154e+02) (float-vector -1.9965600222349167e+01 1.5806500613689423e+02 1.6875800490379333e+02) (float-vector 6.8196401000022888e+01 1.6195400059223175e+02 1.6789500415325165e+02) (float-vector 8.4360197186470032e+01 1.5656499564647675e+02 1.7836900055408478e+02) (float-vector 8.1206202507019043e+01 1.4322899281978607e+02 2.0579800009727478e+02) (float-vector -9.2393895611166954e+00 1.3737300038337708e+02 2.1243099868297577e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6930200159549713e+02 7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 6.8196401000022888e+01 8.2310996949672699e+01 2.2556999325752258e+02) (float-vector 7.7862098813056946e+01 1.3228699564933777e+02 2.2065299749374390e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.6930200159549713e+02 -7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 6.8196401000022888e+01 8.2310996949672699e+01 2.2556999325752258e+02) (float-vector 1.6930200159549713e+02 7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 2.0188400149345398e+02 5.0311498343944550e+01 2.2556999325752258e+02) (float-vector 2.1859599649906158e+02 1.3544600456953049e+01 2.2556999325752258e+02) (float-vector 2.1975499391555786e+02 0.0000000000000000e+00 2.2556999325752258e+02) (float-vector 2.1515500545501709e+02 -2.6695599779486656e+01 2.2556999325752258e+02) (float-vector 2.0188400149345398e+02 -5.0311498343944550e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3220700919628143e+01 -1.1372599750757217e+02 2.1834300458431244e+02) (float-vector -4.8669401556253433e+01 -6.8580701947212219e+01 2.1927699446678162e+02) (float-vector -4.8669401556253433e+01 6.8580597639083862e+01 2.1927699446678162e+02) (float-vector -2.6147600263357162e+01 1.0939399898052216e+02 2.2052499651908875e+02) (float-vector 6.8196401000022888e+01 8.2310996949672699e+01 2.2556999325752258e+02) (float-vector 1.6930200159549713e+02 -7.4177101254463196e+01 2.2556999325752258e+02) (float-vector 7.7866502106189728e+01 -1.2761400640010834e+02 2.2269700467586517e+02) (float-vector -1.2629199773073196e+01 -1.2958300113677979e+02 2.1890999376773834e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 6.8196401000022888e+01 8.2310996949672699e+01 2.2556999325752258e+02) (float-vector -2.6147600263357162e+01 1.0939399898052216e+02 2.2052499651908875e+02) (float-vector -3.0103499069809914e+01 1.1806800216436386e+02 2.1856600046157837e+02) (float-vector -1.4484800398349762e+01 1.2895099818706512e+02 2.1893900632858276e+02) (float-vector 7.7862098813056946e+01 1.3228699564933777e+02 2.2065299749374390e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.2561502456665039e+01 -1.2886199355125427e+02 -3.4893000125885010e+02) (float-vector -5.4294701665639877e+01 -1.5784099698066711e+02 -3.4893000125885010e+02) (float-vector -3.7831198424100876e+01 -1.6665999591350555e+02 -3.4893000125885010e+02) (float-vector 6.8196401000022888e+01 -1.7083799839019775e+02 -3.4893000125885010e+02) (float-vector 8.6590602993965149e+01 -1.6880899667739868e+02 -3.4893000125885010e+02) (float-vector 1.0676199942827225e+02 -1.4851300418376923e+02 -3.4893000125885010e+02) (float-vector 1.2700299918651581e+02 -1.0510499775409698e+02 -3.4893000125885010e+02) (float-vector 1.3318300247192383e+02 -2.5000001187436283e-01 -3.4893000125885010e+02) (float-vector 1.3011500239372253e+02 9.2977002263069153e+01 -3.4893000125885010e+02) (float-vector 1.0676199942827225e+02 1.4851300418376923e+02 -3.4893000125885010e+02) (float-vector 8.7171003222465515e+01 1.6798500716686249e+02 -3.4893101453781128e+02) (float-vector 6.8196401000022888e+01 1.7083799839019775e+02 -3.4893000125885010e+02) (float-vector -3.2944198697805405e+01 1.6729900240898132e+02 -3.4893000125885010e+02) (float-vector -4.7677401453256607e+01 1.6289700567722321e+02 -3.4893000125885010e+02) (float-vector -7.3498301208019257e+01 1.2705400586128235e+02 -3.4893000125885010e+02) (float-vector -9.3838699162006378e+01 7.4910402297973633e+01 -3.4893000125885010e+02) (float-vector -9.3838699162006378e+01 -7.4910499155521393e+01 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.2589497566223145e+01 -7.5564101338386536e+01 1.3423599302768707e+02) (float-vector -8.6002700030803680e+01 -7.4606798589229584e+01 1.6179999709129333e+02) (float-vector -7.5570598244667053e+01 -9.7256697714328766e+01 1.6836699843406677e+02) (float-vector -6.9195002317428589e+01 -1.2514199316501617e+02 1.5064600110054016e+02) (float-vector -8.4701701998710632e+01 -1.0245600342750549e+02 1.1462599784135818e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -7.7849999070167542e+01) (float-vector 2.5308600068092346e+02 2.2900499403476715e+01 -7.7849999070167542e+01) (float-vector 2.0188400149345398e+02 5.0311498343944550e+01 2.2556999325752258e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0676199942827225e+02 1.4851300418376923e+02 -3.4893000125885010e+02) (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -1.7426000535488129e+02) (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -7.7849999070167542e+01) (float-vector 8.6630001664161682e+01 1.6883499920368195e+02 1.0981900244951248e+02) (float-vector 8.7171003222465515e+01 1.6798500716686249e+02 -3.4893101453781128e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.6630001664161682e+01 1.6883499920368195e+02 1.0981900244951248e+02) (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -7.7849999070167542e+01) (float-vector 2.0188400149345398e+02 5.0311498343944550e+01 2.2556999325752258e+02) (float-vector 8.5546799004077911e+01 1.6694700717926025e+02 1.4381900429725647e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5308600068092346e+02 2.2900499403476715e+01 -7.7849999070167542e+01) (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -7.7849999070167542e+01) (float-vector 2.4027100205421448e+02 3.9455398917198181e+01 -1.7426000535488129e+02) (float-vector 2.5140300393104553e+02 2.2075200453400612e+01 -1.8271300196647644e+02) (float-vector 2.5516301393508911e+02 1.8059799447655678e+01 -1.7426000535488129e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.8436399102210999e+01 9.3657903373241425e+01 1.8583300709724426e+02) (float-vector -7.5413003563880920e+01 7.3064699769020081e+01 1.8625600636005402e+02) (float-vector -8.6114399135112762e+01 7.3818899691104889e+01 1.6179999709129333e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5413003563880920e+01 7.3064699769020081e+01 1.8625600636005402e+02) (float-vector -5.9023000299930573e+01 7.0672802627086639e+01 2.1220800280570984e+02) (float-vector -5.9105198830366135e+01 -6.9969199597835541e+01 2.1223700046539307e+02) (float-vector -7.5521297752857208e+01 -7.2314500808715820e+01 1.8625600636005402e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5413003563880920e+01 7.3064699769020081e+01 1.8625600636005402e+02) (float-vector -6.8436399102210999e+01 9.3657903373241425e+01 1.8583300709724426e+02) (float-vector -4.8055700957775116e+01 1.3402099907398224e+02 1.8627899885177612e+02) (float-vector -3.8530301302671432e+01 1.1750900000333786e+02 2.1274599432945251e+02) (float-vector -5.9023000299930573e+01 7.0672802627086639e+01 2.1220800280570984e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.6251301467418671e+01 0.0000000000000000e+00 1.3361799716949463e+02) (float-vector -8.6114399135112762e+01 7.3818899691104889e+01 1.6179999709129333e+02) (float-vector -7.5413003563880920e+01 7.3064699769020081e+01 1.8625600636005402e+02) (float-vector -7.5521297752857208e+01 -7.2314500808715820e+01 1.8625600636005402e+02) (float-vector -8.6002700030803680e+01 -7.4606798589229584e+01 1.6179999709129333e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4714499711990356e+02 -3.1539298593997955e+01 -1.7858900129795074e+02) (float-vector 1.0676199942827225e+02 -1.4851300418376923e+02 -3.4893000125885010e+02) (float-vector 8.6590602993965149e+01 -1.6880899667739868e+02 -3.4893000125885010e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4714499711990356e+02 -3.1539298593997955e+01 -1.7858900129795074e+02) (float-vector 8.6590602993965149e+01 -1.6880899667739868e+02 -3.4893000125885010e+02) (float-vector 8.5657902061939240e+01 -1.6943299770355225e+02 -7.8020803630352020e+01) (float-vector 8.4689401090145111e+01 -1.6896800696849823e+02 1.3141700625419617e+02) (float-vector 2.4408900737762451e+02 -3.5826299339532852e+01 -7.7849999070167542e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4866401255130768e+01 -1.2046899646520615e+02 1.6859500110149384e+02) (float-vector -5.1706798374652863e+01 -1.0670699924230576e+02 2.0295099914073944e+02) (float-vector -4.4533200562000275e+01 -1.3895900547504425e+02 1.8628600239753723e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5570598244667053e+01 -9.7256697714328766e+01 1.6836699843406677e+02) (float-vector -6.4866401255130768e+01 -1.2046899646520615e+02 1.6859500110149384e+02) (float-vector -6.9195002317428589e+01 -1.2514199316501617e+02 1.5064600110054016e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5521297752857208e+01 -7.2314500808715820e+01 1.8625600636005402e+02) (float-vector -5.9105198830366135e+01 -6.9969199597835541e+01 2.1223700046539307e+02) (float-vector -5.1706798374652863e+01 -1.0670699924230576e+02 2.0295099914073944e+02) (float-vector -6.4866401255130768e+01 -1.2046899646520615e+02 1.6859500110149384e+02) (float-vector -7.5570598244667053e+01 -9.7256697714328766e+01 1.6836699843406677e+02) (float-vector -8.6002700030803680e+01 -7.4606798589229584e+01 1.6179999709129333e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9195002317428589e+01 -1.2514199316501617e+02 1.5064600110054016e+02) (float-vector -6.4866401255130768e+01 -1.2046899646520615e+02 1.6859500110149384e+02) (float-vector -4.4533200562000275e+01 -1.3895900547504425e+02 1.8628600239753723e+02) (float-vector -5.5958800017833710e+01 -1.4812399446964264e+02 1.5071099996566772e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -1.7426000535488129e+02) (float-vector 2.4714499711990356e+02 -3.1539298593997955e+01 -1.7858900129795074e+02) (float-vector 2.4408900737762451e+02 -3.5826299339532852e+01 -7.7849999070167542e+01) (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -7.7849999070167542e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5594800710678101e+02 -7.5904699042439461e+00 -1.8271300196647644e+02) (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -1.7426000535488129e+02) (float-vector 2.5516301393508911e+02 1.8059799447655678e+01 -1.7426000535488129e+02) (float-vector 2.5140300393104553e+02 2.2075200453400612e+01 -1.8271300196647644e+02) (float-vector 2.5054800510406494e+02 0.0000000000000000e+00 -1.9503200054168701e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -1.7426000535488129e+02) (float-vector 2.5594800710678101e+02 -7.5904699042439461e+00 -1.8271300196647644e+02) (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -1.7426000535488129e+02) (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -7.7849999070167542e+01) (float-vector 2.5833299756050110e+02 2.6337499730288982e+00 -7.7849999070167542e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.4714499711990356e+02 -3.1539298593997955e+01 -1.7858900129795074e+02) (float-vector 2.5516301393508911e+02 -1.8059799447655678e+01 -1.7426000535488129e+02) (float-vector 2.5594800710678101e+02 -7.5904699042439461e+00 -1.8271300196647644e+02) (float-vector 2.5054800510406494e+02 0.0000000000000000e+00 -1.9503200054168701e+02) (float-vector 1.2700299918651581e+02 -1.0510499775409698e+02 -3.4893000125885010e+02) (float-vector 1.0676199942827225e+02 -1.4851300418376923e+02 -3.4893000125885010e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_torso_lift_link_XT3FoG.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_bellows_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 359 1 5 359 0 5 0 7 7 0 2 2 1 3 11 7 2 11 2 10 10 2 3 6 5 7 6 7 11 10 9 11 6 11 4 4 11 9 8 9 10 13 8 10 10 3 13 8 242 9 9 242 243 4 9 240 240 9 243 4 5 6 4 240 5 5 240 241 240 243 491 491 364 240 240 364 241 242 490 243 491 243 490 491 490 492 364 491 362 362 491 492 362 363 364 364 363 365 364 365 241 241 365 359 241 359 5 365 366 359 366 365 497 497 365 363 362 361 363 361 497 363 496 497 361 496 499 497 499 366 497 359 366 358 366 367 358 367 366 499 1 359 358 1 358 238 238 358 357 358 367 357 367 368 357 368 367 501 501 367 499 498 499 496 498 501 499 500 501 498 500 503 501 503 368 501 357 368 356 368 369 356 369 368 503 238 357 236 236 357 356 236 356 234 234 356 355 356 369 355 369 370 355 370 369 505 505 369 503 502 503 500 502 505 503 504 505 502 504 507 505 507 370 505 355 370 354 370 371 354 371 370 507 234 355 232 232 355 354 232 354 230 230 354 353 354 371 353 371 372 353 372 371 509 509 371 507 506 507 504 506 509 507 508 509 506 508 511 509 511 372 509 353 372 352 372 373 352 373 372 511 230 353 228 228 353 352 228 352 226 226 352 351 352 373 351 373 374 351 374 373 513 513 373 511 510 511 508 510 513 511 512 513 510 512 515 513 515 374 513 351 374 350 374 375 350 375 374 515 226 351 224 224 351 350 224 350 222 222 350 349 350 375 349 375 376 349 376 375 517 517 375 515 514 515 512 514 517 515 516 517 514 516 519 517 519 376 517 349 376 348 376 377 348 377 376 519 222 349 220 220 349 348 220 348 218 218 348 347 348 377 347 377 378 347 378 377 521 521 377 519 518 519 516 518 521 519 520 521 518 520 523 521 523 378 521 347 378 346 378 379 346 379 378 523 218 347 216 216 347 346 216 346 214 214 346 345 346 379 345 379 380 345 380 379 525 525 379 523 522 523 520 522 525 523 524 525 522 524 527 525 527 380 525 345 380 344 380 381 344 381 380 527 214 345 212 212 345 344 212 344 210 210 344 343 344 381 343 381 382 343 382 381 529 529 381 527 526 527 524 526 529 527 528 529 526 528 531 529 531 382 529 343 382 342 382 383 342 383 382 531 210 343 208 208 343 342 208 342 206 206 342 341 342 383 341 383 384 341 384 383 533 533 383 531 530 531 528 530 533 531 532 533 530 532 535 533 535 384 533 341 384 340 384 385 340 385 384 535 206 341 204 204 341 340 204 340 202 202 340 339 340 385 339 385 386 339 386 385 537 537 385 535 534 535 532 534 537 535 536 537 534 536 539 537 539 386 537 339 386 338 386 387 338 387 386 539 202 339 200 200 339 338 200 338 198 198 338 337 338 387 337 387 388 337 388 387 541 541 387 539 538 539 536 538 541 539 540 541 538 540 543 541 543 388 541 337 388 336 388 389 336 389 388 543 198 337 196 196 337 336 196 336 194 194 336 335 336 389 335 389 390 335 390 389 545 545 389 543 542 543 540 542 545 543 544 545 542 544 547 545 547 390 545 335 390 334 390 391 334 391 390 547 194 335 192 192 335 334 192 334 190 190 334 333 334 391 333 391 392 333 392 391 549 549 391 547 546 547 544 546 549 547 548 549 546 548 551 549 551 392 549 333 392 332 392 393 332 393 392 551 190 333 188 188 333 332 188 332 186 186 332 331 332 393 331 393 394 331 394 393 553 553 393 551 550 551 548 550 553 551 552 553 550 552 555 553 555 394 553 331 394 330 394 395 330 395 394 555 186 331 184 184 331 330 184 330 182 182 330 329 330 395 329 395 396 329 396 395 557 557 395 555 554 555 552 554 557 555 556 557 554 556 559 557 559 396 557 329 396 328 396 397 328 397 396 559 182 329 180 180 329 328 180 328 178 178 328 327 328 397 327 397 398 327 398 397 561 561 397 559 558 559 556 558 561 559 560 561 558 560 563 561 563 398 561 327 398 326 398 399 326 399 398 563 178 327 176 176 327 326 176 326 174 174 326 325 326 399 325 399 400 325 400 399 565 565 399 563 562 563 560 562 565 563 564 565 562 564 567 565 567 400 565 325 400 324 400 401 324 401 400 567 174 325 172 172 325 324 172 324 170 170 324 323 324 401 323 401 402 323 402 401 569 569 401 567 566 567 564 566 569 567 568 569 566 568 571 569 571 402 569 323 402 322 402 403 322 403 402 571 170 323 168 168 323 322 168 322 166 166 322 321 322 403 321 403 404 321 404 403 573 573 403 571 570 571 568 570 573 571 572 573 570 572 575 573 575 404 573 321 404 320 404 405 320 405 404 575 166 321 164 164 321 320 164 320 162 162 320 319 320 405 319 405 406 319 406 405 577 577 405 575 574 575 572 574 577 575 576 577 574 576 579 577 579 406 577 319 406 318 406 407 318 407 406 579 162 319 160 160 319 318 160 318 158 158 318 317 318 407 317 407 408 317 408 407 581 581 407 579 578 579 576 578 581 579 580 581 578 580 583 581 583 408 581 317 408 316 408 409 316 409 408 583 158 317 156 156 317 316 156 316 154 154 316 315 316 409 315 409 410 315 410 409 585 585 409 583 582 583 580 582 585 583 584 585 582 584 587 585 587 410 585 315 410 314 410 411 314 411 410 587 154 315 152 152 315 314 152 314 150 150 314 313 314 411 313 411 412 313 412 411 589 589 411 587 586 587 584 586 589 587 588 589 586 588 591 589 591 412 589 313 412 312 412 413 312 413 412 591 150 313 148 148 313 312 148 312 146 146 312 311 312 413 311 413 414 311 414 413 593 593 413 591 590 591 588 590 593 591 592 593 590 592 595 593 595 414 593 311 414 310 414 415 310 415 414 595 146 311 144 144 311 310 144 310 142 142 310 309 310 415 309 415 416 309 416 415 597 597 415 595 594 595 592 594 597 595 596 597 594 596 599 597 599 416 597 309 416 308 416 417 308 417 416 599 142 309 140 140 309 308 140 308 138 138 308 307 308 417 307 417 418 307 418 417 601 601 417 599 598 599 596 598 601 599 600 601 598 600 603 601 603 418 601 307 418 306 418 419 306 419 418 603 138 307 136 136 307 306 136 306 134 134 306 305 306 419 305 419 420 305 420 419 605 605 419 603 602 603 600 602 605 603 604 605 602 604 607 605 607 420 605 305 420 304 420 421 304 421 420 607 134 305 132 132 305 304 132 304 128 128 304 303 304 421 303 421 422 303 422 421 425 425 421 607 302 129 303 303 129 128 303 422 302 128 129 130 132 128 133 133 128 130 130 129 131 124 131 129 124 129 300 300 129 302 300 302 423 423 302 422 124 300 125 125 300 301 423 428 300 300 428 301 124 125 126 126 131 124 126 125 127 301 299 125 125 299 122 125 122 127 428 433 301 301 433 299 431 432 428 428 432 433 428 423 431 433 434 299 434 433 609 609 433 432 431 430 432 430 608 432 432 608 609 608 611 609 611 434 609 299 434 298 434 435 298 435 434 611 610 611 608 610 613 611 613 435 611 430 427 608 608 427 606 608 606 610 612 613 610 610 606 604 610 604 612 612 615 613 436 435 613 615 436 613 614 615 612 612 604 602 612 602 614 606 607 604 606 427 607 607 427 425 424 422 425 424 425 426 426 425 427 423 422 424 426 431 424 431 423 424 429 431 426 429 426 430 430 426 427 429 430 431 616 617 614 614 617 615 614 602 600 614 600 616 437 436 615 617 437 615 436 437 296 296 437 295 437 438 295 438 437 617 435 436 297 297 436 296 116 296 114 114 296 295 116 297 296 114 295 112 112 295 294 295 438 294 114 112 115 116 114 117 117 114 115 118 116 119 119 116 117 118 297 116 115 137 117 117 137 135 117 135 119 115 112 113 113 139 115 115 139 137 136 134 137 137 134 135 139 136 137 134 132 135 135 132 133 119 135 133 119 133 121 121 133 130 120 118 121 121 118 119 123 120 121 121 130 123 123 130 131 122 120 123 127 122 123 123 131 127 127 131 126 299 120 122 298 120 299 120 298 118 118 298 297 298 435 297 138 136 139 140 138 141 141 138 139 113 141 139 143 140 141 111 143 141 111 141 113 142 140 143 145 142 143 109 145 143 109 143 111 110 108 111 111 108 109 113 110 111 112 110 113 110 293 108 112 294 110 110 294 293 108 106 109 108 292 106 108 293 292 109 106 107 107 145 109 106 104 107 106 291 104 106 292 291 293 440 292 440 441 292 292 441 291 104 291 290 441 442 291 291 442 290 104 102 105 107 104 105 104 290 102 102 290 289 442 443 290 290 443 289 442 441 625 443 442 627 627 442 625 443 444 289 444 443 629 629 443 627 102 289 100 100 289 288 289 444 288 444 445 288 445 444 631 631 444 629 628 629 626 626 629 627 628 631 629 630 631 628 630 633 631 633 445 631 288 445 287 445 446 287 446 445 633 632 633 630 632 635 633 635 446 633 628 586 630 630 586 584 630 584 632 634 635 632 632 584 582 632 582 634 634 637 635 447 446 635 637 447 635 636 637 634 634 582 580 634 580 636 636 639 637 448 447 637 639 448 637 446 447 286 286 447 285 447 448 285 285 448 284 448 449 284 449 448 639 94 285 92 92 285 284 94 286 285 96 286 94 96 287 286 287 446 286 94 92 95 96 94 97 97 94 95 92 90 93 95 92 93 92 284 90 93 159 95 95 159 157 95 157 97 99 96 97 97 157 155 97 155 99 156 154 157 157 154 155 159 156 157 158 156 159 161 158 159 93 161 159 160 158 161 163 160 161 91 163 161 91 161 93 162 160 163 165 162 163 89 165 163 89 163 91 90 88 91 91 88 89 93 90 91 88 86 89 89 86 87 87 165 89 88 282 86 90 283 88 88 283 282 90 284 283 284 449 283 449 450 283 283 450 282 86 282 281 450 451 282 282 451 281 450 449 641 451 450 643 643 450 641 641 449 639 640 641 638 638 641 639 640 643 641 642 643 640 642 645 643 645 451 643 451 452 281 452 451 645 644 645 642 644 647 645 647 452 645 640 574 642 642 574 572 642 572 644 646 647 644 644 572 570 644 570 646 646 649 647 453 452 647 649 453 647 648 649 646 646 570 568 646 568 648 648 651 649 454 453 649 651 454 649 452 453 280 280 453 279 453 454 279 279 454 278 454 455 278 455 454 651 82 279 80 80 279 278 82 280 279 84 280 82 84 281 280 281 452 280 82 80 83 84 82 85 85 82 83 80 78 81 83 80 81 80 278 78 81 171 83 83 171 169 83 169 85 87 84 85 85 169 167 85 167 87 168 166 169 169 166 167 171 168 169 170 168 171 173 170 171 81 173 171 172 170 173 175 172 173 79 175 173 79 173 81 174 172 175 177 174 175 77 177 175 77 175 79 78 76 79 79 76 77 81 78 79 76 74 77 77 74 75 75 177 77 76 276 74 78 277 76 76 277 276 78 278 277 278 455 277 455 456 277 277 456 276 74 276 275 456 457 276 276 457 275 456 455 653 457 456 655 655 456 653 653 455 651 652 653 650 650 653 651 652 655 653 654 655 652 654 657 655 657 457 655 457 458 275 458 457 657 656 657 654 656 659 657 659 458 657 652 562 654 654 562 560 654 560 656 658 659 656 656 560 558 656 558 658 658 661 659 459 458 659 661 459 659 660 661 658 658 558 556 658 556 660 660 663 661 460 459 661 663 460 661 458 459 274 274 459 273 459 460 273 273 460 272 460 461 272 461 460 663 70 273 68 68 273 272 70 274 273 72 274 70 72 275 274 275 458 274 70 68 71 72 70 73 73 70 71 68 66 69 71 68 69 68 272 66 69 183 71 71 183 181 71 181 73 75 72 73 73 181 179 73 179 75 180 178 181 181 178 179 183 180 181 182 180 183 185 182 183 69 185 183 184 182 185 187 184 185 67 187 185 67 185 69 186 184 187 189 186 187 65 189 187 65 187 67 66 64 67 67 64 65 69 66 67 64 62 65 65 62 63 63 189 65 64 270 62 66 271 64 64 271 270 66 272 271 272 461 271 461 462 271 271 462 270 62 270 269 462 463 270 270 463 269 462 461 665 463 462 667 667 462 665 665 461 663 664 665 662 662 665 663 664 667 665 666 667 664 666 669 667 669 463 667 463 464 269 464 463 669 668 669 666 668 671 669 671 464 669 664 550 666 666 550 548 666 548 668 670 671 668 668 548 546 668 546 670 670 673 671 465 464 671 673 465 671 672 673 670 670 546 544 670 544 672 672 675 673 466 465 673 675 466 673 464 465 268 268 465 267 465 466 267 267 466 266 466 467 266 467 466 675 58 267 56 56 267 266 58 268 267 60 268 58 60 269 268 269 464 268 58 56 59 60 58 61 61 58 59 56 54 57 59 56 57 56 266 54 57 195 59 59 195 193 59 193 61 63 60 61 61 193 191 61 191 63 192 190 193 193 190 191 195 192 193 194 192 195 197 194 195 57 197 195 196 194 197 199 196 197 55 199 197 55 197 57 198 196 199 201 198 199 53 201 199 53 199 55 54 52 55 55 52 53 57 54 55 52 50 53 53 50 51 51 201 53 52 264 50 54 265 52 52 265 264 54 266 265 266 467 265 467 468 265 265 468 264 50 264 263 468 469 264 264 469 263 468 467 677 469 468 679 679 468 677 677 467 675 676 677 674 674 677 675 676 679 677 678 679 676 678 681 679 681 469 679 469 470 263 470 469 681 680 681 678 680 683 681 683 470 681 676 538 678 678 538 536 678 536 680 682 683 680 680 536 534 680 534 682 682 685 683 471 470 683 685 471 683 684 685 682 682 534 532 682 532 684 684 687 685 472 471 685 687 472 685 470 471 262 262 471 261 471 472 261 261 472 260 472 473 260 473 472 687 46 261 44 44 261 260 46 262 261 48 262 46 48 263 262 263 470 262 46 44 47 48 46 49 49 46 47 44 42 45 47 44 45 44 260 42 45 207 47 47 207 205 47 205 49 51 48 49 49 205 203 49 203 51 204 202 205 205 202 203 207 204 205 206 204 207 209 206 207 45 209 207 208 206 209 211 208 209 43 211 209 43 209 45 210 208 211 213 210 211 41 213 211 41 211 43 42 40 43 43 40 41 45 42 43 40 38 41 41 38 39 39 213 41 40 258 38 42 259 40 40 259 258 42 260 259 260 473 259 473 474 259 259 474 258 38 258 257 474 475 258 258 475 257 474 473 689 475 474 691 691 474 689 689 473 687 688 689 686 686 689 687 688 691 689 690 691 688 690 693 691 693 475 691 475 476 257 476 475 693 692 693 690 692 695 693 695 476 693 688 526 690 690 526 524 690 524 692 694 695 692 692 524 522 692 522 694 694 697 695 477 476 695 697 477 695 696 697 694 694 522 520 694 520 696 696 699 697 478 477 697 699 478 697 476 477 256 256 477 255 477 478 255 255 478 254 478 479 254 479 478 699 34 255 32 32 255 254 34 256 255 36 256 34 36 257 256 257 476 256 34 32 35 36 34 37 37 34 35 32 30 33 35 32 33 32 254 30 33 219 35 35 219 217 35 217 37 39 36 37 37 217 215 37 215 39 216 214 217 217 214 215 219 216 217 218 216 219 221 218 219 33 221 219 220 218 221 223 220 221 31 223 221 31 221 33 222 220 223 225 222 223 29 225 223 29 223 31 30 28 31 31 28 29 33 30 31 28 26 29 29 26 27 27 225 29 28 252 26 30 253 28 28 253 252 30 254 253 254 479 253 479 480 253 253 480 252 26 252 251 480 481 252 252 481 251 480 479 701 481 480 703 703 480 701 701 479 699 700 701 698 698 701 699 700 703 701 702 703 700 702 705 703 705 481 703 481 482 251 482 481 705 704 705 702 704 707 705 707 482 705 700 514 702 702 514 512 702 512 704 706 707 704 704 512 510 704 510 706 706 709 707 483 482 707 709 483 707 708 709 706 706 510 508 706 508 708 708 711 709 484 483 709 711 484 709 482 483 250 250 483 249 483 484 249 249 484 248 484 485 248 485 484 711 22 249 20 20 249 248 22 250 249 24 250 22 24 251 250 251 482 250 22 20 23 24 22 25 25 22 23 20 18 21 23 20 21 20 248 18 21 231 23 23 231 229 23 229 25 27 24 25 25 229 227 25 227 27 228 226 229 229 226 227 231 228 229 230 228 231 233 230 231 21 233 231 232 230 233 235 232 233 19 235 233 19 233 21 234 232 235 237 234 235 17 237 235 17 235 19 18 16 19 19 16 17 21 18 19 16 14 17 17 14 15 15 237 17 16 246 14 18 247 16 16 247 246 18 248 247 248 485 247 485 486 247 247 486 246 14 246 245 486 487 246 246 487 245 486 485 713 487 486 715 715 486 713 713 485 711 712 713 710 710 713 711 712 715 713 714 715 712 714 717 715 717 487 715 487 488 245 488 487 717 716 717 714 716 719 717 719 488 717 712 502 714 714 502 500 714 500 716 718 719 716 716 500 498 716 498 718 718 493 719 489 488 719 493 489 719 495 493 718 718 498 496 718 496 495 492 490 493 492 493 494 494 493 495 490 489 493 488 489 244 244 489 242 489 490 242 245 488 244 12 244 8 8 244 242 12 245 244 14 245 12 12 8 13 14 12 15 15 12 13 13 3 239 13 239 15 15 239 237 238 236 239 239 236 237 3 238 239 1 238 3 236 234 237 495 496 361 495 361 494 360 361 362 494 361 360 360 362 494 494 362 492 712 504 502 710 504 712 710 506 504 710 711 708 708 506 710 708 508 506 226 224 227 227 224 225 27 227 225 224 222 225 26 24 27 26 251 24 700 516 514 698 516 700 698 518 516 698 699 696 696 518 698 696 520 518 214 212 215 215 212 213 39 215 213 212 210 213 38 36 39 38 257 36 688 528 526 686 528 688 686 530 528 686 687 684 684 530 686 684 532 530 202 200 203 203 200 201 51 203 201 200 198 201 50 48 51 50 263 48 676 540 538 674 540 676 674 542 540 674 675 672 672 542 674 672 544 542 190 188 191 191 188 189 63 191 189 188 186 189 62 60 63 62 269 60 664 552 550 662 552 664 662 554 552 662 663 660 660 554 662 660 556 554 178 176 179 179 176 177 75 179 177 176 174 177 74 72 75 74 275 72 652 564 562 650 564 652 650 566 564 650 651 648 648 566 650 648 568 566 166 164 167 167 164 165 87 167 165 164 162 165 86 84 87 86 281 84 640 576 574 638 576 640 638 578 576 638 639 636 636 578 638 636 580 578 154 152 155 155 152 153 99 155 153 152 150 153 153 150 151 99 153 101 101 153 151 98 96 99 101 98 99 100 98 101 103 100 101 101 151 103 150 148 151 151 148 149 103 151 149 102 100 103 105 102 103 103 149 105 100 288 98 98 288 287 98 287 96 105 149 147 105 147 107 148 146 149 149 146 147 146 144 147 147 144 145 107 147 145 144 142 145 628 588 586 626 588 628 626 590 588 626 627 624 624 590 626 624 592 590 624 625 622 624 627 625 622 592 624 622 594 592 622 623 620 622 625 623 620 594 622 625 441 623 620 623 621 441 440 623 623 440 621 620 621 618 618 596 620 620 596 594 618 621 619 440 439 621 621 439 619 439 440 293 438 439 294 294 439 293 439 438 619 618 619 616 616 619 617 619 438 617 616 600 598 616 598 618 618 598 596))
                   (list :vertices (let ((mat (make-matrix 720 3))) (fvector-replace (array-entity mat) #f(1.9154699325561523e+01 1.4890000915527344e+02 -2.9780798339843750e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.9630801391601562e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.9780798339843750e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.9630801391601562e+02 3.2916400432586670e+00 1.2400000000000000e+02 -2.9830801391601562e+02 3.2916400432586670e+00 1.2400000000000000e+02 -2.9780798339843750e+02 -3.3208400726318359e+01 1.2400000000000000e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 1.2400000000000000e+02 -2.9780798339843750e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.9598901367187500e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.9598901367187500e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.9830801391601562e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.8525500488281250e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.8525500488281250e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.8475500488281250e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.8475500488281250e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.7401998901367188e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.7401998901367188e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.7288299560546875e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.7288299560546875e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.6214901733398438e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.6214901733398438e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.6164901733398438e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.6164901733398438e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.5091400146484375e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.5091400146484375e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.4977700805664062e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.4977700805664062e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.3904299926757812e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.3904299926757812e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.3854299926757812e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.3854299926757812e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.2780799865722656e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.2780799865722656e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.2667098999023438e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.2667098999023438e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.1593699645996094e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.1593699645996094e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.1543699645996094e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.1543699645996094e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.0470201110839844e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.0470201110839844e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.0356500244140625e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.0356500244140625e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.9283099365234375e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.9283099365234375e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.9233099365234375e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.9233099365234375e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.8159599304199219e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.8159599304199219e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.8045899963378906e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.8045899963378906e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.6972500610351562e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.6972500610351562e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.6922500610351562e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.6922500610351562e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.5849000549316406e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.5849000549316406e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.5735299682617188e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.5735299682617188e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.4661799621582031e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.4661799621582031e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.4611799621582031e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.4611799621582031e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.3538398742675781e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.3538398742675781e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.3424700927734375e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.3424700927734375e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.2351200103759766e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.2351200103759766e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.2301200103759766e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.2301200103759766e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.1227799987792969e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.1227799987792969e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.1114100646972656e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.1114100646972656e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.0040599822998047e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.0040599822998047e+02 4.8077301979064941e+00 1.2637999725341797e+02 -9.9906303405761719e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -9.9906303405761719e+01 1.9473199844360352e+01 1.4939999389648438e+02 -8.9171798706054688e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -8.9171798706054688e+01 1.9473199844360352e+01 1.4939999389648438e+02 -8.8034698486328125e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -8.8034698486328125e+01 4.8077301979064941e+00 1.2637999725341797e+02 -7.7300201416015625e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -7.7300201416015625e+01 4.8077301979064941e+00 1.2637999725341797e+02 -7.6800193786621094e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -7.6800193786621094e+01 1.9473199844360352e+01 1.4939999389648438e+02 -6.6065696716308594e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -6.6065696716308594e+01 1.9473199844360352e+01 1.4939999389648438e+02 -6.4928703308105469e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -6.4928703308105469e+01 4.8077301979064941e+00 1.2637999725341797e+02 -5.4194202423095703e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -5.4194202423095703e+01 4.8077301979064941e+00 1.2637999725341797e+02 -5.3694198608398438e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -5.3694198608398438e+01 1.9473199844360352e+01 1.4939999389648438e+02 -4.2959602355957031e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -4.2959602355957031e+01 1.9473199844360352e+01 1.4939999389648438e+02 -4.1822601318359375e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -4.1822601318359375e+01 4.8077301979064941e+00 1.2637999725341797e+02 -3.1088100433349609e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -3.1088100433349609e+01 4.8077301979064941e+00 1.2637999725341797e+02 -3.0588100433349609e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -3.0588100433349609e+01 1.9473199844360352e+01 1.4939999389648438e+02 -1.9853599548339844e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -1.9853599548339844e+01 1.9473199844360352e+01 1.4939999389648438e+02 -1.8716499328613281e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -1.8716499328613281e+01 4.8077301979064941e+00 1.2637999725341797e+02 -7.9819998741149902e+00 -3.3208400726318359e+01 1.2637999725341797e+02 -7.9819998741149902e+00 4.8077301979064941e+00 1.2637999725341797e+02 -7.4820098876953125e+00 -3.3208400726318359e+01 1.2637999725341797e+02 -7.4820098876953125e+00 1.9473199844360352e+01 1.4939999389648438e+02 3.2525200843811035e+00 -3.3208400726318359e+01 1.4939999389648438e+02 3.2525200843811035e+00 1.9473199844360352e+01 1.4939999389648438e+02 4.3895702362060547e+00 -3.3208400726318359e+01 1.4939999389648438e+02 4.3895702362060547e+00 4.8077301979064941e+00 1.2637999725341797e+02 1.5124100685119629e+01 -3.3208400726318359e+01 1.2637999725341797e+02 1.5124100685119629e+01 4.8077301979064941e+00 1.2637999725341797e+02 1.5624100685119629e+01 -3.3208400726318359e+01 1.2637999725341797e+02 1.5624100685119629e+01 1.9473199844360352e+01 1.4939999389648438e+02 2.6358600616455078e+01 -3.3208400726318359e+01 1.4939999389648438e+02 2.6358600616455078e+01 1.9473199844360352e+01 1.4939999389648438e+02 2.8500000000000000e+01 -3.3208400726318359e+01 1.4939999389648438e+02 2.8500000000000000e+01 3.2916400432586670e+00 1.2400000000000000e+02 2.8000000000000000e+01 3.2916400432586670e+00 1.2400000000000000e+02 2.8500000000000000e+01 -3.3208400726318359e+01 1.2400000000000000e+02 2.8000000000000000e+01 -3.3208400726318359e+01 1.2400000000000000e+02 2.8500000000000000e+01 1.9154699325561523e+01 1.4890000915527344e+02 2.6677099227905273e+01 1.9154699325561523e+01 1.4890000915527344e+02 2.8000000000000000e+01 -3.3208400726318359e+01 1.4890000915527344e+02 2.6677099227905273e+01 -3.3208400726318359e+01 1.4890000915527344e+02 2.8000000000000000e+01 4.4891901016235352e+00 1.2588000488281250e+02 1.5942599296569824e+01 -3.3208400726318359e+01 1.2588000488281250e+02 1.5942599296569824e+01 4.4891901016235352e+00 1.2588000488281250e+02 1.4805500030517578e+01 -3.3208400726318359e+01 1.2588000488281250e+02 1.4805500030517578e+01 1.9154699325561523e+01 1.4890000915527344e+02 4.0710401535034180e+00 -3.3208400726318359e+01 1.4890000915527344e+02 4.0710401535034180e+00 1.9154699325561523e+01 1.4890000915527344e+02 3.5710499286651611e+00 -3.3208400726318359e+01 1.4890000915527344e+02 3.5710499286651611e+00 4.4891901016235352e+00 1.2588000488281250e+02 -7.1634502410888672e+00 -3.3208400726318359e+01 1.2588000488281250e+02 -7.1634502410888672e+00 4.4891901016235352e+00 1.2588000488281250e+02 -8.3005294799804688e+00 -3.3208400726318359e+01 1.2588000488281250e+02 -8.3005294799804688e+00 1.9154699325561523e+01 1.4890000915527344e+02 -1.9034999847412109e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -1.9034999847412109e+01 1.9154699325561523e+01 1.4890000915527344e+02 -1.9534999847412109e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -1.9534999847412109e+01 4.4891901016235352e+00 1.2588000488281250e+02 -3.0269500732421875e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -3.0269500732421875e+01 4.4891901016235352e+00 1.2588000488281250e+02 -3.1406600952148438e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -3.1406600952148438e+01 1.9154699325561523e+01 1.4890000915527344e+02 -4.2141098022460938e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -4.2141098022460938e+01 1.9154699325561523e+01 1.4890000915527344e+02 -4.2641098022460938e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -4.2641098022460938e+01 4.4891901016235352e+00 1.2588000488281250e+02 -5.3375602722167969e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -5.3375602722167969e+01 4.4891901016235352e+00 1.2588000488281250e+02 -5.4512699127197266e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -5.4512699127197266e+01 1.9154699325561523e+01 1.4890000915527344e+02 -6.5247200012207031e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -6.5247200012207031e+01 1.9154699325561523e+01 1.4890000915527344e+02 -6.5747200012207031e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -6.5747200012207031e+01 4.4891901016235352e+00 1.2588000488281250e+02 -7.6481697082519531e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -7.6481697082519531e+01 4.4891901016235352e+00 1.2588000488281250e+02 -7.7618797302246094e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -7.7618797302246094e+01 1.9154699325561523e+01 1.4890000915527344e+02 -8.8353302001953125e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -8.8353302001953125e+01 1.9154699325561523e+01 1.4890000915527344e+02 -8.8853302001953125e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -8.8853302001953125e+01 4.4891901016235352e+00 1.2588000488281250e+02 -9.9587799072265625e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -9.9587799072265625e+01 4.4891901016235352e+00 1.2588000488281250e+02 -1.0072500610351562e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.0072500610351562e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.1145899963378906e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.1145899963378906e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.1195899963378906e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.1195899963378906e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.2269400024414062e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.2269400024414062e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.2383099365234375e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.2383099365234375e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.3456500244140625e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.3456500244140625e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.3506500244140625e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.3506500244140625e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.4579998779296875e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.4579998779296875e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.4693699645996094e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.4693699645996094e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.5767100524902344e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.5767100524902344e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.5817199707031250e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.5817199707031250e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.6890600585937500e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.6890600585937500e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.7004299926757812e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.7004299926757812e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.8077799987792969e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.8077799987792969e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.8127799987792969e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.8127799987792969e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.9201199340820312e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.9201199340820312e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.9314900207519531e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.9314900207519531e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.0388400268554688e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.0388400268554688e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.0438400268554688e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.0438400268554688e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.1511801147460938e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.1511801147460938e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.1625498962402344e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.1625498962402344e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.2699000549316406e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.2699000549316406e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.2748999023437500e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.2748999023437500e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.3822399902343750e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.3822399902343750e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.3936100769042969e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.3936100769042969e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.5009599304199219e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.5009599304199219e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.5059599304199219e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.5059599304199219e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.6133001708984375e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.6133001708984375e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.6246701049804688e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.6246701049804688e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.7320199584960938e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.7320199584960938e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.7370199584960938e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.7370199584960938e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.8443597412109375e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.8443597412109375e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.8557299804687500e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.8557299804687500e+02 1.7747200012207031e+01 9.3000000000000000e+01 -2.9830801391601562e+02 1.7747200012207031e+01 9.3000000000000000e+01 -2.9780798339843750e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.9598901367187500e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.9830801391601562e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.8525500488281250e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.8475500488281250e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.7401998901367188e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.7288299560546875e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.6214901733398438e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.6164901733398438e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.5091400146484375e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.4977700805664062e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.3904299926757812e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.3854299926757812e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.2780799865722656e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.2667098999023438e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.1593699645996094e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.1543699645996094e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.0470201110839844e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.0356500244140625e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.9283099365234375e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.9233099365234375e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.8159599304199219e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.8045899963378906e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.6972500610351562e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.6922500610351562e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.5849000549316406e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.5735299682617188e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.4661799621582031e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.4611799621582031e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.3538398742675781e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.3424700927734375e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.2351200103759766e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.2301200103759766e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.1227799987792969e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.1114100646972656e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.0040599822998047e+02 2.0127000808715820e+01 9.3527603149414062e+01 -9.9906303405761719e+01 4.3147197723388672e+01 9.8631004333496094e+01 -8.9171798706054688e+01 4.3147197723388672e+01 9.8631004333496094e+01 -8.8034698486328125e+01 2.0127000808715820e+01 9.3527603149414062e+01 -7.7300201416015625e+01 2.0127000808715820e+01 9.3527603149414062e+01 -7.6800193786621094e+01 4.3147197723388672e+01 9.8631004333496094e+01 -6.6065696716308594e+01 4.3147197723388672e+01 9.8631004333496094e+01 -6.4928703308105469e+01 2.0127000808715820e+01 9.3527603149414062e+01 -5.4194202423095703e+01 2.0127000808715820e+01 9.3527603149414062e+01 -5.3694198608398438e+01 4.3147197723388672e+01 9.8631004333496094e+01 -4.2959602355957031e+01 4.3147197723388672e+01 9.8631004333496094e+01 -4.1822601318359375e+01 2.0127000808715820e+01 9.3527603149414062e+01 -3.1088100433349609e+01 2.0127000808715820e+01 9.3527603149414062e+01 -3.0588100433349609e+01 4.3147197723388672e+01 9.8631004333496094e+01 -1.9853599548339844e+01 4.3147197723388672e+01 9.8631004333496094e+01 -1.8716499328613281e+01 2.0127000808715820e+01 9.3527603149414062e+01 -7.9819998741149902e+00 2.0127000808715820e+01 9.3527603149414062e+01 -7.4820098876953125e+00 4.3147197723388672e+01 9.8631004333496094e+01 3.2525200843811035e+00 4.3147197723388672e+01 9.8631004333496094e+01 4.3895702362060547e+00 2.0127000808715820e+01 9.3527603149414062e+01 1.5124100685119629e+01 2.0127000808715820e+01 9.3527603149414062e+01 1.5624100685119629e+01 4.3147197723388672e+01 9.8631004333496094e+01 2.6358600616455078e+01 4.3147197723388672e+01 9.8631004333496094e+01 2.8500000000000000e+01 1.7747200012207031e+01 9.3000000000000000e+01 2.8000000000000000e+01 1.7747200012207031e+01 9.3000000000000000e+01 2.8500000000000000e+01 4.2647201538085938e+01 9.8520195007324219e+01 2.8000000000000000e+01 4.2647201538085938e+01 9.8520195007324219e+01 2.6677099227905273e+01 1.9626998901367188e+01 9.3416694641113281e+01 1.5942599296569824e+01 1.9626998901367188e+01 9.3416694641113281e+01 1.4805500030517578e+01 4.2647201538085938e+01 9.8520195007324219e+01 4.0710401535034180e+00 4.2647201538085938e+01 9.8520195007324219e+01 3.5710499286651611e+00 1.9626998901367188e+01 9.3416694641113281e+01 -7.1634502410888672e+00 1.9626998901367188e+01 9.3416694641113281e+01 -8.3005294799804688e+00 4.2647201538085938e+01 9.8520195007324219e+01 -1.9034999847412109e+01 4.2647201538085938e+01 9.8520195007324219e+01 -1.9534999847412109e+01 1.9626998901367188e+01 9.3416694641113281e+01 -3.0269500732421875e+01 1.9626998901367188e+01 9.3416694641113281e+01 -3.1406600952148438e+01 4.2647201538085938e+01 9.8520195007324219e+01 -4.2141098022460938e+01 4.2647201538085938e+01 9.8520195007324219e+01 -4.2641098022460938e+01 1.9626998901367188e+01 9.3416694641113281e+01 -5.3375602722167969e+01 1.9626998901367188e+01 9.3416694641113281e+01 -5.4512699127197266e+01 4.2647201538085938e+01 9.8520195007324219e+01 -6.5247200012207031e+01 4.2647201538085938e+01 9.8520195007324219e+01 -6.5747200012207031e+01 1.9626998901367188e+01 9.3416694641113281e+01 -7.6481697082519531e+01 1.9626998901367188e+01 9.3416694641113281e+01 -7.7618797302246094e+01 4.2647201538085938e+01 9.8520195007324219e+01 -8.8353302001953125e+01 4.2647201538085938e+01 9.8520195007324219e+01 -8.8853302001953125e+01 1.9626998901367188e+01 9.3416694641113281e+01 -9.9587799072265625e+01 1.9626998901367188e+01 9.3416694641113281e+01 -1.0072500610351562e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.1145899963378906e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.1195899963378906e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.2269400024414062e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.2383099365234375e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.3456500244140625e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.3506500244140625e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.4579998779296875e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.4693699645996094e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.5767100524902344e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.5817199707031250e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.6890600585937500e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.7004299926757812e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.8077799987792969e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.8127799987792969e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.9201199340820312e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.9314900207519531e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.0388400268554688e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.0438400268554688e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.1511801147460938e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.1625498962402344e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.2699000549316406e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.2748999023437500e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.3822399902343750e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.3936100769042969e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.5009599304199219e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.5059599304199219e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.6133001708984375e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.6246701049804688e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.7320199584960938e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.7370199584960938e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.8443597412109375e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.8557299804687500e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.9630801391601562e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.9780798339843750e+02 -3.3208400726318359e+01 -1.2400000000000000e+02 -2.9780798339843750e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.9780798339843750e+02 3.2916400432586670e+00 -1.2400000000000000e+02 -2.9780798339843750e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.9780798339843750e+02 1.7747200012207031e+01 -9.3000000000000000e+01 -2.9780798339843750e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.9780798339843750e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.9630801391601562e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.8557299804687500e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.8443597412109375e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.7370199584960938e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.7320199584960938e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.6246701049804688e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.6133001708984375e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.5059599304199219e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.5009599304199219e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.3936100769042969e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.3822399902343750e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.2748999023437500e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.2699000549316406e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.1625498962402344e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.1511801147460938e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.0438400268554688e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.0388400268554688e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.9314900207519531e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.9201199340820312e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.8127799987792969e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.8077799987792969e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.7004299926757812e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.6890600585937500e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.5817199707031250e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.5767100524902344e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.4693699645996094e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.4579998779296875e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.3506500244140625e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.3456500244140625e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.2383099365234375e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.2269400024414062e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.1195899963378906e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.1145899963378906e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.0072500610351562e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -9.9587799072265625e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -8.8853302001953125e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -8.8353302001953125e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -7.7618797302246094e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -7.6481697082519531e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -6.5747200012207031e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -6.5247200012207031e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -5.4512699127197266e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -5.3375602722167969e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -4.2641098022460938e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -4.2141098022460938e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -3.1406600952148438e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -3.0269500732421875e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -1.9534999847412109e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -1.9034999847412109e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -8.3005294799804688e+00 1.9626998901367188e+01 -9.3416694641113281e+01 -7.1634502410888672e+00 4.2647201538085938e+01 -9.8520195007324219e+01 3.5710499286651611e+00 4.2647201538085938e+01 -9.8520195007324219e+01 4.0710401535034180e+00 1.9626998901367188e+01 -9.3416694641113281e+01 1.4805500030517578e+01 1.9626998901367188e+01 -9.3416694641113281e+01 1.5942599296569824e+01 4.2647201538085938e+01 -9.8520195007324219e+01 2.6677099227905273e+01 4.2647201538085938e+01 -9.8520195007324219e+01 2.8000000000000000e+01 1.7747200012207031e+01 -9.3000000000000000e+01 2.8000000000000000e+01 3.2916400432586670e+00 -1.2400000000000000e+02 2.8000000000000000e+01 1.9154699325561523e+01 -1.4890000915527344e+02 2.8000000000000000e+01 -3.3208400726318359e+01 -1.2400000000000000e+02 2.8000000000000000e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 2.8000000000000000e+01 1.7747200012207031e+01 -9.3000000000000000e+01 2.8500000000000000e+01 -3.3208400726318359e+01 -1.2400000000000000e+02 2.8500000000000000e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 2.8500000000000000e+01 3.2916400432586670e+00 -1.2400000000000000e+02 2.8500000000000000e+01 1.9473199844360352e+01 -1.4939999389648438e+02 2.8500000000000000e+01 4.3147197723388672e+01 -9.8631004333496094e+01 2.8500000000000000e+01 4.3147197723388672e+01 -9.8631004333496094e+01 2.6358600616455078e+01 2.0127000808715820e+01 -9.3527603149414062e+01 1.5624100685119629e+01 2.0127000808715820e+01 -9.3527603149414062e+01 1.5124100685119629e+01 4.3147197723388672e+01 -9.8631004333496094e+01 4.3895702362060547e+00 4.3147197723388672e+01 -9.8631004333496094e+01 3.2525200843811035e+00 2.0127000808715820e+01 -9.3527603149414062e+01 -7.4820098876953125e+00 2.0127000808715820e+01 -9.3527603149414062e+01 -7.9819998741149902e+00 4.3147197723388672e+01 -9.8631004333496094e+01 -1.8716499328613281e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -1.9853599548339844e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -3.0588100433349609e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -3.1088100433349609e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -4.1822601318359375e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -4.2959602355957031e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -5.3694198608398438e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -5.4194202423095703e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -6.4928703308105469e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -6.6065696716308594e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -7.6800193786621094e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -7.7300201416015625e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -8.8034698486328125e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -8.9171798706054688e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -9.9906303405761719e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -1.0040599822998047e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.1114100646972656e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.1227799987792969e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.2301200103759766e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.2351200103759766e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.3424700927734375e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.3538398742675781e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.4611799621582031e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.4661799621582031e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.5735299682617188e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.5849000549316406e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.6922500610351562e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.6972500610351562e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.8045899963378906e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.8159599304199219e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.9233099365234375e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.9283099365234375e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.0356500244140625e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.0470201110839844e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.1543699645996094e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.1593699645996094e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.2667098999023438e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.2780799865722656e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.3854299926757812e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.3904299926757812e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.4977700805664062e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.5091400146484375e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.6164901733398438e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.6214901733398438e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.7288299560546875e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.7401998901367188e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.8475500488281250e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.8525500488281250e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.9598901367187500e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.9830801391601562e+02 1.7747200012207031e+01 -9.3000000000000000e+01 -2.9830801391601562e+02 3.2916400432586670e+00 -1.2400000000000000e+02 -2.9830801391601562e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 -1.2400000000000000e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.9630801391601562e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.9630801391601562e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.8557299804687500e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.8557299804687500e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.8443597412109375e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.8443597412109375e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.7370199584960938e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.7370199584960938e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.7320199584960938e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.7320199584960938e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.6246701049804688e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.6246701049804688e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.6133001708984375e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.6133001708984375e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.5059599304199219e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.5059599304199219e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.5009599304199219e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.5009599304199219e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.3936100769042969e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.3936100769042969e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.3822399902343750e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.3822399902343750e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.2748999023437500e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.2748999023437500e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.2699000549316406e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.2699000549316406e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.1625498962402344e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.1625498962402344e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.1511801147460938e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.1511801147460938e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.0438400268554688e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.0438400268554688e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.0388400268554688e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.0388400268554688e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.9314900207519531e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.9314900207519531e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.9201199340820312e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.9201199340820312e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.8127799987792969e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.8127799987792969e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.8077799987792969e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.8077799987792969e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.7004299926757812e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.7004299926757812e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.6890600585937500e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.6890600585937500e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.5817199707031250e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.5817199707031250e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.5767100524902344e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.5767100524902344e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.4693699645996094e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.4693699645996094e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.4579998779296875e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.4579998779296875e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.3506500244140625e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.3506500244140625e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.3456500244140625e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.3456500244140625e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.2383099365234375e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.2383099365234375e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.2269400024414062e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.2269400024414062e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.1195899963378906e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.1195899963378906e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.1145899963378906e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.1145899963378906e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.0072500610351562e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.0072500610351562e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -9.9587799072265625e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -9.9587799072265625e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -8.8853302001953125e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -8.8853302001953125e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -8.8353302001953125e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -8.8353302001953125e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -7.7618797302246094e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -7.7618797302246094e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -7.6481697082519531e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -7.6481697082519531e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -6.5747200012207031e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -6.5747200012207031e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -6.5247200012207031e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -6.5247200012207031e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -5.4512699127197266e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -5.4512699127197266e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -5.3375602722167969e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -5.3375602722167969e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -4.2641098022460938e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -4.2641098022460938e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -4.2141098022460938e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -4.2141098022460938e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -3.1406600952148438e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -3.1406600952148438e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -3.0269500732421875e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -3.0269500732421875e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.9534999847412109e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -1.9534999847412109e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.9034999847412109e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -1.9034999847412109e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -8.3005294799804688e+00 4.4891901016235352e+00 -1.2588000488281250e+02 -8.3005294799804688e+00 -3.3208400726318359e+01 -1.2588000488281250e+02 -7.1634502410888672e+00 4.4891901016235352e+00 -1.2588000488281250e+02 -7.1634502410888672e+00 -3.3208400726318359e+01 -1.4890000915527344e+02 3.5710499286651611e+00 1.9154699325561523e+01 -1.4890000915527344e+02 3.5710499286651611e+00 -3.3208400726318359e+01 -1.4890000915527344e+02 4.0710401535034180e+00 1.9154699325561523e+01 -1.4890000915527344e+02 4.0710401535034180e+00 -3.3208400726318359e+01 -1.2588000488281250e+02 1.4805500030517578e+01 4.4891901016235352e+00 -1.2588000488281250e+02 1.4805500030517578e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 1.5942599296569824e+01 4.4891901016235352e+00 -1.2588000488281250e+02 1.5942599296569824e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 2.6677099227905273e+01 1.9154699325561523e+01 -1.4890000915527344e+02 2.6677099227905273e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 2.6358600616455078e+01 1.9473199844360352e+01 -1.4939999389648438e+02 2.6358600616455078e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 1.5624100685119629e+01 4.8077301979064941e+00 -1.2637999725341797e+02 1.5624100685119629e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 1.5124100685119629e+01 4.8077301979064941e+00 -1.2637999725341797e+02 1.5124100685119629e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 4.3895702362060547e+00 1.9473199844360352e+01 -1.4939999389648438e+02 4.3895702362060547e+00 -3.3208400726318359e+01 -1.4939999389648438e+02 3.2525200843811035e+00 1.9473199844360352e+01 -1.4939999389648438e+02 3.2525200843811035e+00 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.4820098876953125e+00 4.8077301979064941e+00 -1.2637999725341797e+02 -7.4820098876953125e+00 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.9819998741149902e+00 4.8077301979064941e+00 -1.2637999725341797e+02 -7.9819998741149902e+00 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.8716499328613281e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -1.8716499328613281e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.9853599548339844e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -1.9853599548339844e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -3.0588100433349609e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -3.0588100433349609e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -3.1088100433349609e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -3.1088100433349609e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -4.1822601318359375e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -4.1822601318359375e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -4.2959602355957031e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -4.2959602355957031e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -5.3694198608398438e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -5.3694198608398438e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -5.4194202423095703e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -5.4194202423095703e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -6.4928703308105469e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -6.4928703308105469e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -6.6065696716308594e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -6.6065696716308594e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.6800193786621094e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -7.6800193786621094e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.7300201416015625e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -7.7300201416015625e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -8.8034698486328125e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -8.8034698486328125e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -8.9171798706054688e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -8.9171798706054688e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -9.9906303405761719e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -9.9906303405761719e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.0040599822998047e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.0040599822998047e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.1114100646972656e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.1114100646972656e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.1227799987792969e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.1227799987792969e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.2301200103759766e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.2301200103759766e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.2351200103759766e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.2351200103759766e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.3424700927734375e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.3424700927734375e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.3538398742675781e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.3538398742675781e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.4611799621582031e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.4611799621582031e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.4661799621582031e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.4661799621582031e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.5735299682617188e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.5735299682617188e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.5849000549316406e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.5849000549316406e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.6922500610351562e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.6922500610351562e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.6972500610351562e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.6972500610351562e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.8045899963378906e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.8045899963378906e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.8159599304199219e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.8159599304199219e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.9233099365234375e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.9233099365234375e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.9283099365234375e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.9283099365234375e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.0356500244140625e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.0356500244140625e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.0470201110839844e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.0470201110839844e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.1543699645996094e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.1543699645996094e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.1593699645996094e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.1593699645996094e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.2667098999023438e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.2667098999023438e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.2780799865722656e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.2780799865722656e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.3854299926757812e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.3854299926757812e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.3904299926757812e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.3904299926757812e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.4977700805664062e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.4977700805664062e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.5091400146484375e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.5091400146484375e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.6164901733398438e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.6164901733398438e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.6214901733398438e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.6214901733398438e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.7288299560546875e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.7288299560546875e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.7401998901367188e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.7401998901367188e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.8475500488281250e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.8475500488281250e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.8525500488281250e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.8525500488281250e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.9598901367187500e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.9598901367187500e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 4308 -> 8 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 1.4890000224113464e+02 -2.9780799150466919e+02) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 -2.9830801486968994e+02) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 -2.9598900675773621e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 2.8500000014901161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 -2.9598900675773621e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3208400011062622e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 1.4890000224113464e+02 -2.9780799150466919e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 1.4890000224113464e+02 -2.9780799150466919e+02) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 -2.9830801486968994e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 2.8500000014901161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 -2.9830801486968994e+02) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 2.8500000014901161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 -2.9598900675773621e+02) (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 -2.9830801486968994e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_bellows_link_z6pUbZ.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_bellows_link2_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.000100 0.000100 0.000100 1.000000))
                    (list :diffuse (float-vector 0.000000 0.000000 0.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 359 1 5 359 0 5 0 7 7 0 2 2 1 3 11 7 2 11 2 10 10 2 3 6 5 7 6 7 11 10 9 11 6 11 4 4 11 9 8 9 10 13 8 10 10 3 13 8 242 9 9 242 243 4 9 240 240 9 243 4 5 6 4 240 5 5 240 241 240 243 491 491 364 240 240 364 241 242 490 243 491 243 490 491 490 492 364 491 362 362 491 492 362 363 364 364 363 365 364 365 241 241 365 359 241 359 5 365 366 359 366 365 497 497 365 363 362 361 363 361 497 363 496 497 361 496 499 497 499 366 497 359 366 358 366 367 358 367 366 499 1 359 358 1 358 238 238 358 357 358 367 357 367 368 357 368 367 501 501 367 499 498 499 496 498 501 499 500 501 498 500 503 501 503 368 501 357 368 356 368 369 356 369 368 503 238 357 236 236 357 356 236 356 234 234 356 355 356 369 355 369 370 355 370 369 505 505 369 503 502 503 500 502 505 503 504 505 502 504 507 505 507 370 505 355 370 354 370 371 354 371 370 507 234 355 232 232 355 354 232 354 230 230 354 353 354 371 353 371 372 353 372 371 509 509 371 507 506 507 504 506 509 507 508 509 506 508 511 509 511 372 509 353 372 352 372 373 352 373 372 511 230 353 228 228 353 352 228 352 226 226 352 351 352 373 351 373 374 351 374 373 513 513 373 511 510 511 508 510 513 511 512 513 510 512 515 513 515 374 513 351 374 350 374 375 350 375 374 515 226 351 224 224 351 350 224 350 222 222 350 349 350 375 349 375 376 349 376 375 517 517 375 515 514 515 512 514 517 515 516 517 514 516 519 517 519 376 517 349 376 348 376 377 348 377 376 519 222 349 220 220 349 348 220 348 218 218 348 347 348 377 347 377 378 347 378 377 521 521 377 519 518 519 516 518 521 519 520 521 518 520 523 521 523 378 521 347 378 346 378 379 346 379 378 523 218 347 216 216 347 346 216 346 214 214 346 345 346 379 345 379 380 345 380 379 525 525 379 523 522 523 520 522 525 523 524 525 522 524 527 525 527 380 525 345 380 344 380 381 344 381 380 527 214 345 212 212 345 344 212 344 210 210 344 343 344 381 343 381 382 343 382 381 529 529 381 527 526 527 524 526 529 527 528 529 526 528 531 529 531 382 529 343 382 342 382 383 342 383 382 531 210 343 208 208 343 342 208 342 206 206 342 341 342 383 341 383 384 341 384 383 533 533 383 531 530 531 528 530 533 531 532 533 530 532 535 533 535 384 533 341 384 340 384 385 340 385 384 535 206 341 204 204 341 340 204 340 202 202 340 339 340 385 339 385 386 339 386 385 537 537 385 535 534 535 532 534 537 535 536 537 534 536 539 537 539 386 537 339 386 338 386 387 338 387 386 539 202 339 200 200 339 338 200 338 198 198 338 337 338 387 337 387 388 337 388 387 541 541 387 539 538 539 536 538 541 539 540 541 538 540 543 541 543 388 541 337 388 336 388 389 336 389 388 543 198 337 196 196 337 336 196 336 194 194 336 335 336 389 335 389 390 335 390 389 545 545 389 543 542 543 540 542 545 543 544 545 542 544 547 545 547 390 545 335 390 334 390 391 334 391 390 547 194 335 192 192 335 334 192 334 190 190 334 333 334 391 333 391 392 333 392 391 549 549 391 547 546 547 544 546 549 547 548 549 546 548 551 549 551 392 549 333 392 332 392 393 332 393 392 551 190 333 188 188 333 332 188 332 186 186 332 331 332 393 331 393 394 331 394 393 553 553 393 551 550 551 548 550 553 551 552 553 550 552 555 553 555 394 553 331 394 330 394 395 330 395 394 555 186 331 184 184 331 330 184 330 182 182 330 329 330 395 329 395 396 329 396 395 557 557 395 555 554 555 552 554 557 555 556 557 554 556 559 557 559 396 557 329 396 328 396 397 328 397 396 559 182 329 180 180 329 328 180 328 178 178 328 327 328 397 327 397 398 327 398 397 561 561 397 559 558 559 556 558 561 559 560 561 558 560 563 561 563 398 561 327 398 326 398 399 326 399 398 563 178 327 176 176 327 326 176 326 174 174 326 325 326 399 325 399 400 325 400 399 565 565 399 563 562 563 560 562 565 563 564 565 562 564 567 565 567 400 565 325 400 324 400 401 324 401 400 567 174 325 172 172 325 324 172 324 170 170 324 323 324 401 323 401 402 323 402 401 569 569 401 567 566 567 564 566 569 567 568 569 566 568 571 569 571 402 569 323 402 322 402 403 322 403 402 571 170 323 168 168 323 322 168 322 166 166 322 321 322 403 321 403 404 321 404 403 573 573 403 571 570 571 568 570 573 571 572 573 570 572 575 573 575 404 573 321 404 320 404 405 320 405 404 575 166 321 164 164 321 320 164 320 162 162 320 319 320 405 319 405 406 319 406 405 577 577 405 575 574 575 572 574 577 575 576 577 574 576 579 577 579 406 577 319 406 318 406 407 318 407 406 579 162 319 160 160 319 318 160 318 158 158 318 317 318 407 317 407 408 317 408 407 581 581 407 579 578 579 576 578 581 579 580 581 578 580 583 581 583 408 581 317 408 316 408 409 316 409 408 583 158 317 156 156 317 316 156 316 154 154 316 315 316 409 315 409 410 315 410 409 585 585 409 583 582 583 580 582 585 583 584 585 582 584 587 585 587 410 585 315 410 314 410 411 314 411 410 587 154 315 152 152 315 314 152 314 150 150 314 313 314 411 313 411 412 313 412 411 589 589 411 587 586 587 584 586 589 587 588 589 586 588 591 589 591 412 589 313 412 312 412 413 312 413 412 591 150 313 148 148 313 312 148 312 146 146 312 311 312 413 311 413 414 311 414 413 593 593 413 591 590 591 588 590 593 591 592 593 590 592 595 593 595 414 593 311 414 310 414 415 310 415 414 595 146 311 144 144 311 310 144 310 142 142 310 309 310 415 309 415 416 309 416 415 597 597 415 595 594 595 592 594 597 595 596 597 594 596 599 597 599 416 597 309 416 308 416 417 308 417 416 599 142 309 140 140 309 308 140 308 138 138 308 307 308 417 307 417 418 307 418 417 601 601 417 599 598 599 596 598 601 599 600 601 598 600 603 601 603 418 601 307 418 306 418 419 306 419 418 603 138 307 136 136 307 306 136 306 134 134 306 305 306 419 305 419 420 305 420 419 605 605 419 603 602 603 600 602 605 603 604 605 602 604 607 605 607 420 605 305 420 304 420 421 304 421 420 607 134 305 132 132 305 304 132 304 128 128 304 303 304 421 303 421 422 303 422 421 425 425 421 607 302 129 303 303 129 128 303 422 302 128 129 130 132 128 133 133 128 130 130 129 131 124 131 129 124 129 300 300 129 302 300 302 423 423 302 422 124 300 125 125 300 301 423 428 300 300 428 301 124 125 126 126 131 124 126 125 127 301 299 125 125 299 122 125 122 127 428 433 301 301 433 299 431 432 428 428 432 433 428 423 431 433 434 299 434 433 609 609 433 432 431 430 432 430 608 432 432 608 609 608 611 609 611 434 609 299 434 298 434 435 298 435 434 611 610 611 608 610 613 611 613 435 611 430 427 608 608 427 606 608 606 610 612 613 610 610 606 604 610 604 612 612 615 613 436 435 613 615 436 613 614 615 612 612 604 602 612 602 614 606 607 604 606 427 607 607 427 425 424 422 425 424 425 426 426 425 427 423 422 424 426 431 424 431 423 424 429 431 426 429 426 430 430 426 427 429 430 431 616 617 614 614 617 615 614 602 600 614 600 616 437 436 615 617 437 615 436 437 296 296 437 295 437 438 295 438 437 617 435 436 297 297 436 296 116 296 114 114 296 295 116 297 296 114 295 112 112 295 294 295 438 294 114 112 115 116 114 117 117 114 115 118 116 119 119 116 117 118 297 116 115 137 117 117 137 135 117 135 119 115 112 113 113 139 115 115 139 137 136 134 137 137 134 135 139 136 137 134 132 135 135 132 133 119 135 133 119 133 121 121 133 130 120 118 121 121 118 119 123 120 121 121 130 123 123 130 131 122 120 123 127 122 123 123 131 127 127 131 126 299 120 122 298 120 299 120 298 118 118 298 297 298 435 297 138 136 139 140 138 141 141 138 139 113 141 139 143 140 141 111 143 141 111 141 113 142 140 143 145 142 143 109 145 143 109 143 111 110 108 111 111 108 109 113 110 111 112 110 113 110 293 108 112 294 110 110 294 293 108 106 109 108 292 106 108 293 292 109 106 107 107 145 109 106 104 107 106 291 104 106 292 291 293 440 292 440 441 292 292 441 291 104 291 290 441 442 291 291 442 290 104 102 105 107 104 105 104 290 102 102 290 289 442 443 290 290 443 289 442 441 625 443 442 627 627 442 625 443 444 289 444 443 629 629 443 627 102 289 100 100 289 288 289 444 288 444 445 288 445 444 631 631 444 629 628 629 626 626 629 627 628 631 629 630 631 628 630 633 631 633 445 631 288 445 287 445 446 287 446 445 633 632 633 630 632 635 633 635 446 633 628 586 630 630 586 584 630 584 632 634 635 632 632 584 582 632 582 634 634 637 635 447 446 635 637 447 635 636 637 634 634 582 580 634 580 636 636 639 637 448 447 637 639 448 637 446 447 286 286 447 285 447 448 285 285 448 284 448 449 284 449 448 639 94 285 92 92 285 284 94 286 285 96 286 94 96 287 286 287 446 286 94 92 95 96 94 97 97 94 95 92 90 93 95 92 93 92 284 90 93 159 95 95 159 157 95 157 97 99 96 97 97 157 155 97 155 99 156 154 157 157 154 155 159 156 157 158 156 159 161 158 159 93 161 159 160 158 161 163 160 161 91 163 161 91 161 93 162 160 163 165 162 163 89 165 163 89 163 91 90 88 91 91 88 89 93 90 91 88 86 89 89 86 87 87 165 89 88 282 86 90 283 88 88 283 282 90 284 283 284 449 283 449 450 283 283 450 282 86 282 281 450 451 282 282 451 281 450 449 641 451 450 643 643 450 641 641 449 639 640 641 638 638 641 639 640 643 641 642 643 640 642 645 643 645 451 643 451 452 281 452 451 645 644 645 642 644 647 645 647 452 645 640 574 642 642 574 572 642 572 644 646 647 644 644 572 570 644 570 646 646 649 647 453 452 647 649 453 647 648 649 646 646 570 568 646 568 648 648 651 649 454 453 649 651 454 649 452 453 280 280 453 279 453 454 279 279 454 278 454 455 278 455 454 651 82 279 80 80 279 278 82 280 279 84 280 82 84 281 280 281 452 280 82 80 83 84 82 85 85 82 83 80 78 81 83 80 81 80 278 78 81 171 83 83 171 169 83 169 85 87 84 85 85 169 167 85 167 87 168 166 169 169 166 167 171 168 169 170 168 171 173 170 171 81 173 171 172 170 173 175 172 173 79 175 173 79 173 81 174 172 175 177 174 175 77 177 175 77 175 79 78 76 79 79 76 77 81 78 79 76 74 77 77 74 75 75 177 77 76 276 74 78 277 76 76 277 276 78 278 277 278 455 277 455 456 277 277 456 276 74 276 275 456 457 276 276 457 275 456 455 653 457 456 655 655 456 653 653 455 651 652 653 650 650 653 651 652 655 653 654 655 652 654 657 655 657 457 655 457 458 275 458 457 657 656 657 654 656 659 657 659 458 657 652 562 654 654 562 560 654 560 656 658 659 656 656 560 558 656 558 658 658 661 659 459 458 659 661 459 659 660 661 658 658 558 556 658 556 660 660 663 661 460 459 661 663 460 661 458 459 274 274 459 273 459 460 273 273 460 272 460 461 272 461 460 663 70 273 68 68 273 272 70 274 273 72 274 70 72 275 274 275 458 274 70 68 71 72 70 73 73 70 71 68 66 69 71 68 69 68 272 66 69 183 71 71 183 181 71 181 73 75 72 73 73 181 179 73 179 75 180 178 181 181 178 179 183 180 181 182 180 183 185 182 183 69 185 183 184 182 185 187 184 185 67 187 185 67 185 69 186 184 187 189 186 187 65 189 187 65 187 67 66 64 67 67 64 65 69 66 67 64 62 65 65 62 63 63 189 65 64 270 62 66 271 64 64 271 270 66 272 271 272 461 271 461 462 271 271 462 270 62 270 269 462 463 270 270 463 269 462 461 665 463 462 667 667 462 665 665 461 663 664 665 662 662 665 663 664 667 665 666 667 664 666 669 667 669 463 667 463 464 269 464 463 669 668 669 666 668 671 669 671 464 669 664 550 666 666 550 548 666 548 668 670 671 668 668 548 546 668 546 670 670 673 671 465 464 671 673 465 671 672 673 670 670 546 544 670 544 672 672 675 673 466 465 673 675 466 673 464 465 268 268 465 267 465 466 267 267 466 266 466 467 266 467 466 675 58 267 56 56 267 266 58 268 267 60 268 58 60 269 268 269 464 268 58 56 59 60 58 61 61 58 59 56 54 57 59 56 57 56 266 54 57 195 59 59 195 193 59 193 61 63 60 61 61 193 191 61 191 63 192 190 193 193 190 191 195 192 193 194 192 195 197 194 195 57 197 195 196 194 197 199 196 197 55 199 197 55 197 57 198 196 199 201 198 199 53 201 199 53 199 55 54 52 55 55 52 53 57 54 55 52 50 53 53 50 51 51 201 53 52 264 50 54 265 52 52 265 264 54 266 265 266 467 265 467 468 265 265 468 264 50 264 263 468 469 264 264 469 263 468 467 677 469 468 679 679 468 677 677 467 675 676 677 674 674 677 675 676 679 677 678 679 676 678 681 679 681 469 679 469 470 263 470 469 681 680 681 678 680 683 681 683 470 681 676 538 678 678 538 536 678 536 680 682 683 680 680 536 534 680 534 682 682 685 683 471 470 683 685 471 683 684 685 682 682 534 532 682 532 684 684 687 685 472 471 685 687 472 685 470 471 262 262 471 261 471 472 261 261 472 260 472 473 260 473 472 687 46 261 44 44 261 260 46 262 261 48 262 46 48 263 262 263 470 262 46 44 47 48 46 49 49 46 47 44 42 45 47 44 45 44 260 42 45 207 47 47 207 205 47 205 49 51 48 49 49 205 203 49 203 51 204 202 205 205 202 203 207 204 205 206 204 207 209 206 207 45 209 207 208 206 209 211 208 209 43 211 209 43 209 45 210 208 211 213 210 211 41 213 211 41 211 43 42 40 43 43 40 41 45 42 43 40 38 41 41 38 39 39 213 41 40 258 38 42 259 40 40 259 258 42 260 259 260 473 259 473 474 259 259 474 258 38 258 257 474 475 258 258 475 257 474 473 689 475 474 691 691 474 689 689 473 687 688 689 686 686 689 687 688 691 689 690 691 688 690 693 691 693 475 691 475 476 257 476 475 693 692 693 690 692 695 693 695 476 693 688 526 690 690 526 524 690 524 692 694 695 692 692 524 522 692 522 694 694 697 695 477 476 695 697 477 695 696 697 694 694 522 520 694 520 696 696 699 697 478 477 697 699 478 697 476 477 256 256 477 255 477 478 255 255 478 254 478 479 254 479 478 699 34 255 32 32 255 254 34 256 255 36 256 34 36 257 256 257 476 256 34 32 35 36 34 37 37 34 35 32 30 33 35 32 33 32 254 30 33 219 35 35 219 217 35 217 37 39 36 37 37 217 215 37 215 39 216 214 217 217 214 215 219 216 217 218 216 219 221 218 219 33 221 219 220 218 221 223 220 221 31 223 221 31 221 33 222 220 223 225 222 223 29 225 223 29 223 31 30 28 31 31 28 29 33 30 31 28 26 29 29 26 27 27 225 29 28 252 26 30 253 28 28 253 252 30 254 253 254 479 253 479 480 253 253 480 252 26 252 251 480 481 252 252 481 251 480 479 701 481 480 703 703 480 701 701 479 699 700 701 698 698 701 699 700 703 701 702 703 700 702 705 703 705 481 703 481 482 251 482 481 705 704 705 702 704 707 705 707 482 705 700 514 702 702 514 512 702 512 704 706 707 704 704 512 510 704 510 706 706 709 707 483 482 707 709 483 707 708 709 706 706 510 508 706 508 708 708 711 709 484 483 709 711 484 709 482 483 250 250 483 249 483 484 249 249 484 248 484 485 248 485 484 711 22 249 20 20 249 248 22 250 249 24 250 22 24 251 250 251 482 250 22 20 23 24 22 25 25 22 23 20 18 21 23 20 21 20 248 18 21 231 23 23 231 229 23 229 25 27 24 25 25 229 227 25 227 27 228 226 229 229 226 227 231 228 229 230 228 231 233 230 231 21 233 231 232 230 233 235 232 233 19 235 233 19 233 21 234 232 235 237 234 235 17 237 235 17 235 19 18 16 19 19 16 17 21 18 19 16 14 17 17 14 15 15 237 17 16 246 14 18 247 16 16 247 246 18 248 247 248 485 247 485 486 247 247 486 246 14 246 245 486 487 246 246 487 245 486 485 713 487 486 715 715 486 713 713 485 711 712 713 710 710 713 711 712 715 713 714 715 712 714 717 715 717 487 715 487 488 245 488 487 717 716 717 714 716 719 717 719 488 717 712 502 714 714 502 500 714 500 716 718 719 716 716 500 498 716 498 718 718 493 719 489 488 719 493 489 719 495 493 718 718 498 496 718 496 495 492 490 493 492 493 494 494 493 495 490 489 493 488 489 244 244 489 242 489 490 242 245 488 244 12 244 8 8 244 242 12 245 244 14 245 12 12 8 13 14 12 15 15 12 13 13 3 239 13 239 15 15 239 237 238 236 239 239 236 237 3 238 239 1 238 3 236 234 237 495 496 361 495 361 494 360 361 362 494 361 360 360 362 494 494 362 492 712 504 502 710 504 712 710 506 504 710 711 708 708 506 710 708 508 506 226 224 227 227 224 225 27 227 225 224 222 225 26 24 27 26 251 24 700 516 514 698 516 700 698 518 516 698 699 696 696 518 698 696 520 518 214 212 215 215 212 213 39 215 213 212 210 213 38 36 39 38 257 36 688 528 526 686 528 688 686 530 528 686 687 684 684 530 686 684 532 530 202 200 203 203 200 201 51 203 201 200 198 201 50 48 51 50 263 48 676 540 538 674 540 676 674 542 540 674 675 672 672 542 674 672 544 542 190 188 191 191 188 189 63 191 189 188 186 189 62 60 63 62 269 60 664 552 550 662 552 664 662 554 552 662 663 660 660 554 662 660 556 554 178 176 179 179 176 177 75 179 177 176 174 177 74 72 75 74 275 72 652 564 562 650 564 652 650 566 564 650 651 648 648 566 650 648 568 566 166 164 167 167 164 165 87 167 165 164 162 165 86 84 87 86 281 84 640 576 574 638 576 640 638 578 576 638 639 636 636 578 638 636 580 578 154 152 155 155 152 153 99 155 153 152 150 153 153 150 151 99 153 101 101 153 151 98 96 99 101 98 99 100 98 101 103 100 101 101 151 103 150 148 151 151 148 149 103 151 149 102 100 103 105 102 103 103 149 105 100 288 98 98 288 287 98 287 96 105 149 147 105 147 107 148 146 149 149 146 147 146 144 147 147 144 145 107 147 145 144 142 145 628 588 586 626 588 628 626 590 588 626 627 624 624 590 626 624 592 590 624 625 622 624 627 625 622 592 624 622 594 592 622 623 620 622 625 623 620 594 622 625 441 623 620 623 621 441 440 623 623 440 621 620 621 618 618 596 620 620 596 594 618 621 619 440 439 621 621 439 619 439 440 293 438 439 294 294 439 293 439 438 619 618 619 616 616 619 617 619 438 617 616 600 598 616 598 618 618 598 596))
                   (list :vertices (let ((mat (make-matrix 720 3))) (fvector-replace (array-entity mat) #f(1.9154699325561523e+01 1.4890000915527344e+02 -2.9780798339843750e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.9630801391601562e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.9780798339843750e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.9630801391601562e+02 3.2916400432586670e+00 1.2400000000000000e+02 -2.9830801391601562e+02 3.2916400432586670e+00 1.2400000000000000e+02 -2.9780798339843750e+02 -3.3208400726318359e+01 1.2400000000000000e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 1.2400000000000000e+02 -2.9780798339843750e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.9598901367187500e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.9598901367187500e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.9830801391601562e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.8525500488281250e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.8525500488281250e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.8475500488281250e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.8475500488281250e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.7401998901367188e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.7401998901367188e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.7288299560546875e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.7288299560546875e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.6214901733398438e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.6214901733398438e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.6164901733398438e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.6164901733398438e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.5091400146484375e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.5091400146484375e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.4977700805664062e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.4977700805664062e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.3904299926757812e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.3904299926757812e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.3854299926757812e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.3854299926757812e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.2780799865722656e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.2780799865722656e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.2667098999023438e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.2667098999023438e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.1593699645996094e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.1593699645996094e+02 4.8077301979064941e+00 1.2637999725341797e+02 -2.1543699645996094e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -2.1543699645996094e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.0470201110839844e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.0470201110839844e+02 1.9473199844360352e+01 1.4939999389648438e+02 -2.0356500244140625e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -2.0356500244140625e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.9283099365234375e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.9283099365234375e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.9233099365234375e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.9233099365234375e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.8159599304199219e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.8159599304199219e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.8045899963378906e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.8045899963378906e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.6972500610351562e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.6972500610351562e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.6922500610351562e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.6922500610351562e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.5849000549316406e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.5849000549316406e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.5735299682617188e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.5735299682617188e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.4661799621582031e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.4661799621582031e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.4611799621582031e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.4611799621582031e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.3538398742675781e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.3538398742675781e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.3424700927734375e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.3424700927734375e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.2351200103759766e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.2351200103759766e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.2301200103759766e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.2301200103759766e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.1227799987792969e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.1227799987792969e+02 1.9473199844360352e+01 1.4939999389648438e+02 -1.1114100646972656e+02 -3.3208400726318359e+01 1.4939999389648438e+02 -1.1114100646972656e+02 4.8077301979064941e+00 1.2637999725341797e+02 -1.0040599822998047e+02 -3.3208400726318359e+01 1.2637999725341797e+02 -1.0040599822998047e+02 4.8077301979064941e+00 1.2637999725341797e+02 -9.9906303405761719e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -9.9906303405761719e+01 1.9473199844360352e+01 1.4939999389648438e+02 -8.9171798706054688e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -8.9171798706054688e+01 1.9473199844360352e+01 1.4939999389648438e+02 -8.8034698486328125e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -8.8034698486328125e+01 4.8077301979064941e+00 1.2637999725341797e+02 -7.7300201416015625e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -7.7300201416015625e+01 4.8077301979064941e+00 1.2637999725341797e+02 -7.6800193786621094e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -7.6800193786621094e+01 1.9473199844360352e+01 1.4939999389648438e+02 -6.6065696716308594e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -6.6065696716308594e+01 1.9473199844360352e+01 1.4939999389648438e+02 -6.4928703308105469e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -6.4928703308105469e+01 4.8077301979064941e+00 1.2637999725341797e+02 -5.4194202423095703e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -5.4194202423095703e+01 4.8077301979064941e+00 1.2637999725341797e+02 -5.3694198608398438e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -5.3694198608398438e+01 1.9473199844360352e+01 1.4939999389648438e+02 -4.2959602355957031e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -4.2959602355957031e+01 1.9473199844360352e+01 1.4939999389648438e+02 -4.1822601318359375e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -4.1822601318359375e+01 4.8077301979064941e+00 1.2637999725341797e+02 -3.1088100433349609e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -3.1088100433349609e+01 4.8077301979064941e+00 1.2637999725341797e+02 -3.0588100433349609e+01 -3.3208400726318359e+01 1.2637999725341797e+02 -3.0588100433349609e+01 1.9473199844360352e+01 1.4939999389648438e+02 -1.9853599548339844e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -1.9853599548339844e+01 1.9473199844360352e+01 1.4939999389648438e+02 -1.8716499328613281e+01 -3.3208400726318359e+01 1.4939999389648438e+02 -1.8716499328613281e+01 4.8077301979064941e+00 1.2637999725341797e+02 -7.9819998741149902e+00 -3.3208400726318359e+01 1.2637999725341797e+02 -7.9819998741149902e+00 4.8077301979064941e+00 1.2637999725341797e+02 -7.4820098876953125e+00 -3.3208400726318359e+01 1.2637999725341797e+02 -7.4820098876953125e+00 1.9473199844360352e+01 1.4939999389648438e+02 3.2525200843811035e+00 -3.3208400726318359e+01 1.4939999389648438e+02 3.2525200843811035e+00 1.9473199844360352e+01 1.4939999389648438e+02 4.3895702362060547e+00 -3.3208400726318359e+01 1.4939999389648438e+02 4.3895702362060547e+00 4.8077301979064941e+00 1.2637999725341797e+02 1.5124100685119629e+01 -3.3208400726318359e+01 1.2637999725341797e+02 1.5124100685119629e+01 4.8077301979064941e+00 1.2637999725341797e+02 1.5624100685119629e+01 -3.3208400726318359e+01 1.2637999725341797e+02 1.5624100685119629e+01 1.9473199844360352e+01 1.4939999389648438e+02 2.6358600616455078e+01 -3.3208400726318359e+01 1.4939999389648438e+02 2.6358600616455078e+01 1.9473199844360352e+01 1.4939999389648438e+02 2.8500000000000000e+01 -3.3208400726318359e+01 1.4939999389648438e+02 2.8500000000000000e+01 3.2916400432586670e+00 1.2400000000000000e+02 2.8000000000000000e+01 3.2916400432586670e+00 1.2400000000000000e+02 2.8500000000000000e+01 -3.3208400726318359e+01 1.2400000000000000e+02 2.8000000000000000e+01 -3.3208400726318359e+01 1.2400000000000000e+02 2.8500000000000000e+01 1.9154699325561523e+01 1.4890000915527344e+02 2.6677099227905273e+01 1.9154699325561523e+01 1.4890000915527344e+02 2.8000000000000000e+01 -3.3208400726318359e+01 1.4890000915527344e+02 2.6677099227905273e+01 -3.3208400726318359e+01 1.4890000915527344e+02 2.8000000000000000e+01 4.4891901016235352e+00 1.2588000488281250e+02 1.5942599296569824e+01 -3.3208400726318359e+01 1.2588000488281250e+02 1.5942599296569824e+01 4.4891901016235352e+00 1.2588000488281250e+02 1.4805500030517578e+01 -3.3208400726318359e+01 1.2588000488281250e+02 1.4805500030517578e+01 1.9154699325561523e+01 1.4890000915527344e+02 4.0710401535034180e+00 -3.3208400726318359e+01 1.4890000915527344e+02 4.0710401535034180e+00 1.9154699325561523e+01 1.4890000915527344e+02 3.5710499286651611e+00 -3.3208400726318359e+01 1.4890000915527344e+02 3.5710499286651611e+00 4.4891901016235352e+00 1.2588000488281250e+02 -7.1634502410888672e+00 -3.3208400726318359e+01 1.2588000488281250e+02 -7.1634502410888672e+00 4.4891901016235352e+00 1.2588000488281250e+02 -8.3005294799804688e+00 -3.3208400726318359e+01 1.2588000488281250e+02 -8.3005294799804688e+00 1.9154699325561523e+01 1.4890000915527344e+02 -1.9034999847412109e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -1.9034999847412109e+01 1.9154699325561523e+01 1.4890000915527344e+02 -1.9534999847412109e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -1.9534999847412109e+01 4.4891901016235352e+00 1.2588000488281250e+02 -3.0269500732421875e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -3.0269500732421875e+01 4.4891901016235352e+00 1.2588000488281250e+02 -3.1406600952148438e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -3.1406600952148438e+01 1.9154699325561523e+01 1.4890000915527344e+02 -4.2141098022460938e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -4.2141098022460938e+01 1.9154699325561523e+01 1.4890000915527344e+02 -4.2641098022460938e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -4.2641098022460938e+01 4.4891901016235352e+00 1.2588000488281250e+02 -5.3375602722167969e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -5.3375602722167969e+01 4.4891901016235352e+00 1.2588000488281250e+02 -5.4512699127197266e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -5.4512699127197266e+01 1.9154699325561523e+01 1.4890000915527344e+02 -6.5247200012207031e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -6.5247200012207031e+01 1.9154699325561523e+01 1.4890000915527344e+02 -6.5747200012207031e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -6.5747200012207031e+01 4.4891901016235352e+00 1.2588000488281250e+02 -7.6481697082519531e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -7.6481697082519531e+01 4.4891901016235352e+00 1.2588000488281250e+02 -7.7618797302246094e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -7.7618797302246094e+01 1.9154699325561523e+01 1.4890000915527344e+02 -8.8353302001953125e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -8.8353302001953125e+01 1.9154699325561523e+01 1.4890000915527344e+02 -8.8853302001953125e+01 -3.3208400726318359e+01 1.4890000915527344e+02 -8.8853302001953125e+01 4.4891901016235352e+00 1.2588000488281250e+02 -9.9587799072265625e+01 -3.3208400726318359e+01 1.2588000488281250e+02 -9.9587799072265625e+01 4.4891901016235352e+00 1.2588000488281250e+02 -1.0072500610351562e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.0072500610351562e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.1145899963378906e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.1145899963378906e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.1195899963378906e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.1195899963378906e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.2269400024414062e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.2269400024414062e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.2383099365234375e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.2383099365234375e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.3456500244140625e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.3456500244140625e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.3506500244140625e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.3506500244140625e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.4579998779296875e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.4579998779296875e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.4693699645996094e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.4693699645996094e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.5767100524902344e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.5767100524902344e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.5817199707031250e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.5817199707031250e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.6890600585937500e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.6890600585937500e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.7004299926757812e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.7004299926757812e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.8077799987792969e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.8077799987792969e+02 1.9154699325561523e+01 1.4890000915527344e+02 -1.8127799987792969e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -1.8127799987792969e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.9201199340820312e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.9201199340820312e+02 4.4891901016235352e+00 1.2588000488281250e+02 -1.9314900207519531e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -1.9314900207519531e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.0388400268554688e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.0388400268554688e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.0438400268554688e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.0438400268554688e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.1511801147460938e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.1511801147460938e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.1625498962402344e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.1625498962402344e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.2699000549316406e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.2699000549316406e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.2748999023437500e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.2748999023437500e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.3822399902343750e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.3822399902343750e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.3936100769042969e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.3936100769042969e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.5009599304199219e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.5009599304199219e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.5059599304199219e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.5059599304199219e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.6133001708984375e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.6133001708984375e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.6246701049804688e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.6246701049804688e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.7320199584960938e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.7320199584960938e+02 1.9154699325561523e+01 1.4890000915527344e+02 -2.7370199584960938e+02 -3.3208400726318359e+01 1.4890000915527344e+02 -2.7370199584960938e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.8443597412109375e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.8443597412109375e+02 4.4891901016235352e+00 1.2588000488281250e+02 -2.8557299804687500e+02 -3.3208400726318359e+01 1.2588000488281250e+02 -2.8557299804687500e+02 1.7747200012207031e+01 9.3000000000000000e+01 -2.9830801391601562e+02 1.7747200012207031e+01 9.3000000000000000e+01 -2.9780798339843750e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.9598901367187500e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.9830801391601562e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.8525500488281250e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.8475500488281250e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.7401998901367188e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.7288299560546875e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.6214901733398438e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.6164901733398438e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.5091400146484375e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.4977700805664062e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.3904299926757812e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.3854299926757812e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.2780799865722656e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.2667098999023438e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.1593699645996094e+02 2.0127000808715820e+01 9.3527603149414062e+01 -2.1543699645996094e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.0470201110839844e+02 4.3147197723388672e+01 9.8631004333496094e+01 -2.0356500244140625e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.9283099365234375e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.9233099365234375e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.8159599304199219e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.8045899963378906e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.6972500610351562e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.6922500610351562e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.5849000549316406e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.5735299682617188e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.4661799621582031e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.4611799621582031e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.3538398742675781e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.3424700927734375e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.2351200103759766e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.2301200103759766e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.1227799987792969e+02 4.3147197723388672e+01 9.8631004333496094e+01 -1.1114100646972656e+02 2.0127000808715820e+01 9.3527603149414062e+01 -1.0040599822998047e+02 2.0127000808715820e+01 9.3527603149414062e+01 -9.9906303405761719e+01 4.3147197723388672e+01 9.8631004333496094e+01 -8.9171798706054688e+01 4.3147197723388672e+01 9.8631004333496094e+01 -8.8034698486328125e+01 2.0127000808715820e+01 9.3527603149414062e+01 -7.7300201416015625e+01 2.0127000808715820e+01 9.3527603149414062e+01 -7.6800193786621094e+01 4.3147197723388672e+01 9.8631004333496094e+01 -6.6065696716308594e+01 4.3147197723388672e+01 9.8631004333496094e+01 -6.4928703308105469e+01 2.0127000808715820e+01 9.3527603149414062e+01 -5.4194202423095703e+01 2.0127000808715820e+01 9.3527603149414062e+01 -5.3694198608398438e+01 4.3147197723388672e+01 9.8631004333496094e+01 -4.2959602355957031e+01 4.3147197723388672e+01 9.8631004333496094e+01 -4.1822601318359375e+01 2.0127000808715820e+01 9.3527603149414062e+01 -3.1088100433349609e+01 2.0127000808715820e+01 9.3527603149414062e+01 -3.0588100433349609e+01 4.3147197723388672e+01 9.8631004333496094e+01 -1.9853599548339844e+01 4.3147197723388672e+01 9.8631004333496094e+01 -1.8716499328613281e+01 2.0127000808715820e+01 9.3527603149414062e+01 -7.9819998741149902e+00 2.0127000808715820e+01 9.3527603149414062e+01 -7.4820098876953125e+00 4.3147197723388672e+01 9.8631004333496094e+01 3.2525200843811035e+00 4.3147197723388672e+01 9.8631004333496094e+01 4.3895702362060547e+00 2.0127000808715820e+01 9.3527603149414062e+01 1.5124100685119629e+01 2.0127000808715820e+01 9.3527603149414062e+01 1.5624100685119629e+01 4.3147197723388672e+01 9.8631004333496094e+01 2.6358600616455078e+01 4.3147197723388672e+01 9.8631004333496094e+01 2.8500000000000000e+01 1.7747200012207031e+01 9.3000000000000000e+01 2.8000000000000000e+01 1.7747200012207031e+01 9.3000000000000000e+01 2.8500000000000000e+01 4.2647201538085938e+01 9.8520195007324219e+01 2.8000000000000000e+01 4.2647201538085938e+01 9.8520195007324219e+01 2.6677099227905273e+01 1.9626998901367188e+01 9.3416694641113281e+01 1.5942599296569824e+01 1.9626998901367188e+01 9.3416694641113281e+01 1.4805500030517578e+01 4.2647201538085938e+01 9.8520195007324219e+01 4.0710401535034180e+00 4.2647201538085938e+01 9.8520195007324219e+01 3.5710499286651611e+00 1.9626998901367188e+01 9.3416694641113281e+01 -7.1634502410888672e+00 1.9626998901367188e+01 9.3416694641113281e+01 -8.3005294799804688e+00 4.2647201538085938e+01 9.8520195007324219e+01 -1.9034999847412109e+01 4.2647201538085938e+01 9.8520195007324219e+01 -1.9534999847412109e+01 1.9626998901367188e+01 9.3416694641113281e+01 -3.0269500732421875e+01 1.9626998901367188e+01 9.3416694641113281e+01 -3.1406600952148438e+01 4.2647201538085938e+01 9.8520195007324219e+01 -4.2141098022460938e+01 4.2647201538085938e+01 9.8520195007324219e+01 -4.2641098022460938e+01 1.9626998901367188e+01 9.3416694641113281e+01 -5.3375602722167969e+01 1.9626998901367188e+01 9.3416694641113281e+01 -5.4512699127197266e+01 4.2647201538085938e+01 9.8520195007324219e+01 -6.5247200012207031e+01 4.2647201538085938e+01 9.8520195007324219e+01 -6.5747200012207031e+01 1.9626998901367188e+01 9.3416694641113281e+01 -7.6481697082519531e+01 1.9626998901367188e+01 9.3416694641113281e+01 -7.7618797302246094e+01 4.2647201538085938e+01 9.8520195007324219e+01 -8.8353302001953125e+01 4.2647201538085938e+01 9.8520195007324219e+01 -8.8853302001953125e+01 1.9626998901367188e+01 9.3416694641113281e+01 -9.9587799072265625e+01 1.9626998901367188e+01 9.3416694641113281e+01 -1.0072500610351562e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.1145899963378906e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.1195899963378906e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.2269400024414062e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.2383099365234375e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.3456500244140625e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.3506500244140625e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.4579998779296875e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.4693699645996094e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.5767100524902344e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.5817199707031250e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.6890600585937500e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.7004299926757812e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.8077799987792969e+02 4.2647201538085938e+01 9.8520195007324219e+01 -1.8127799987792969e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.9201199340820312e+02 1.9626998901367188e+01 9.3416694641113281e+01 -1.9314900207519531e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.0388400268554688e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.0438400268554688e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.1511801147460938e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.1625498962402344e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.2699000549316406e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.2748999023437500e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.3822399902343750e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.3936100769042969e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.5009599304199219e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.5059599304199219e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.6133001708984375e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.6246701049804688e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.7320199584960938e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.7370199584960938e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.8443597412109375e+02 1.9626998901367188e+01 9.3416694641113281e+01 -2.8557299804687500e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.9630801391601562e+02 4.2647201538085938e+01 9.8520195007324219e+01 -2.9780798339843750e+02 -3.3208400726318359e+01 -1.2400000000000000e+02 -2.9780798339843750e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.9780798339843750e+02 3.2916400432586670e+00 -1.2400000000000000e+02 -2.9780798339843750e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.9780798339843750e+02 1.7747200012207031e+01 -9.3000000000000000e+01 -2.9780798339843750e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.9780798339843750e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.9630801391601562e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.8557299804687500e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.8443597412109375e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.7370199584960938e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.7320199584960938e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.6246701049804688e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.6133001708984375e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.5059599304199219e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.5009599304199219e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.3936100769042969e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.3822399902343750e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.2748999023437500e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.2699000549316406e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.1625498962402344e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -2.1511801147460938e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.0438400268554688e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -2.0388400268554688e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.9314900207519531e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.9201199340820312e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.8127799987792969e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.8077799987792969e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.7004299926757812e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.6890600585937500e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.5817199707031250e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.5767100524902344e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.4693699645996094e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.4579998779296875e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.3506500244140625e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.3456500244140625e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.2383099365234375e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.2269400024414062e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.1195899963378906e+02 4.2647201538085938e+01 -9.8520195007324219e+01 -1.1145899963378906e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -1.0072500610351562e+02 1.9626998901367188e+01 -9.3416694641113281e+01 -9.9587799072265625e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -8.8853302001953125e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -8.8353302001953125e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -7.7618797302246094e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -7.6481697082519531e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -6.5747200012207031e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -6.5247200012207031e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -5.4512699127197266e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -5.3375602722167969e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -4.2641098022460938e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -4.2141098022460938e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -3.1406600952148438e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -3.0269500732421875e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -1.9534999847412109e+01 4.2647201538085938e+01 -9.8520195007324219e+01 -1.9034999847412109e+01 1.9626998901367188e+01 -9.3416694641113281e+01 -8.3005294799804688e+00 1.9626998901367188e+01 -9.3416694641113281e+01 -7.1634502410888672e+00 4.2647201538085938e+01 -9.8520195007324219e+01 3.5710499286651611e+00 4.2647201538085938e+01 -9.8520195007324219e+01 4.0710401535034180e+00 1.9626998901367188e+01 -9.3416694641113281e+01 1.4805500030517578e+01 1.9626998901367188e+01 -9.3416694641113281e+01 1.5942599296569824e+01 4.2647201538085938e+01 -9.8520195007324219e+01 2.6677099227905273e+01 4.2647201538085938e+01 -9.8520195007324219e+01 2.8000000000000000e+01 1.7747200012207031e+01 -9.3000000000000000e+01 2.8000000000000000e+01 3.2916400432586670e+00 -1.2400000000000000e+02 2.8000000000000000e+01 1.9154699325561523e+01 -1.4890000915527344e+02 2.8000000000000000e+01 -3.3208400726318359e+01 -1.2400000000000000e+02 2.8000000000000000e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 2.8000000000000000e+01 1.7747200012207031e+01 -9.3000000000000000e+01 2.8500000000000000e+01 -3.3208400726318359e+01 -1.2400000000000000e+02 2.8500000000000000e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 2.8500000000000000e+01 3.2916400432586670e+00 -1.2400000000000000e+02 2.8500000000000000e+01 1.9473199844360352e+01 -1.4939999389648438e+02 2.8500000000000000e+01 4.3147197723388672e+01 -9.8631004333496094e+01 2.8500000000000000e+01 4.3147197723388672e+01 -9.8631004333496094e+01 2.6358600616455078e+01 2.0127000808715820e+01 -9.3527603149414062e+01 1.5624100685119629e+01 2.0127000808715820e+01 -9.3527603149414062e+01 1.5124100685119629e+01 4.3147197723388672e+01 -9.8631004333496094e+01 4.3895702362060547e+00 4.3147197723388672e+01 -9.8631004333496094e+01 3.2525200843811035e+00 2.0127000808715820e+01 -9.3527603149414062e+01 -7.4820098876953125e+00 2.0127000808715820e+01 -9.3527603149414062e+01 -7.9819998741149902e+00 4.3147197723388672e+01 -9.8631004333496094e+01 -1.8716499328613281e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -1.9853599548339844e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -3.0588100433349609e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -3.1088100433349609e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -4.1822601318359375e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -4.2959602355957031e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -5.3694198608398438e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -5.4194202423095703e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -6.4928703308105469e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -6.6065696716308594e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -7.6800193786621094e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -7.7300201416015625e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -8.8034698486328125e+01 4.3147197723388672e+01 -9.8631004333496094e+01 -8.9171798706054688e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -9.9906303405761719e+01 2.0127000808715820e+01 -9.3527603149414062e+01 -1.0040599822998047e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.1114100646972656e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.1227799987792969e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.2301200103759766e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.2351200103759766e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.3424700927734375e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.3538398742675781e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.4611799621582031e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.4661799621582031e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.5735299682617188e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.5849000549316406e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.6922500610351562e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.6972500610351562e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.8045899963378906e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -1.8159599304199219e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.9233099365234375e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -1.9283099365234375e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.0356500244140625e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.0470201110839844e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.1543699645996094e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.1593699645996094e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.2667098999023438e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.2780799865722656e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.3854299926757812e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.3904299926757812e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.4977700805664062e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.5091400146484375e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.6164901733398438e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.6214901733398438e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.7288299560546875e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.7401998901367188e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.8475500488281250e+02 2.0127000808715820e+01 -9.3527603149414062e+01 -2.8525500488281250e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.9598901367187500e+02 4.3147197723388672e+01 -9.8631004333496094e+01 -2.9830801391601562e+02 1.7747200012207031e+01 -9.3000000000000000e+01 -2.9830801391601562e+02 3.2916400432586670e+00 -1.2400000000000000e+02 -2.9830801391601562e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 -1.2400000000000000e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.9830801391601562e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.9630801391601562e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.9630801391601562e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.8557299804687500e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.8557299804687500e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.8443597412109375e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.8443597412109375e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.7370199584960938e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.7370199584960938e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.7320199584960938e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.7320199584960938e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.6246701049804688e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.6246701049804688e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.6133001708984375e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.6133001708984375e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.5059599304199219e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.5059599304199219e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.5009599304199219e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.5009599304199219e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.3936100769042969e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.3936100769042969e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.3822399902343750e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.3822399902343750e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.2748999023437500e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.2748999023437500e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.2699000549316406e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.2699000549316406e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.1625498962402344e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.1625498962402344e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -2.1511801147460938e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -2.1511801147460938e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.0438400268554688e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.0438400268554688e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -2.0388400268554688e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -2.0388400268554688e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.9314900207519531e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.9314900207519531e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.9201199340820312e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.9201199340820312e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.8127799987792969e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.8127799987792969e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.8077799987792969e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.8077799987792969e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.7004299926757812e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.7004299926757812e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.6890600585937500e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.6890600585937500e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.5817199707031250e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.5817199707031250e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.5767100524902344e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.5767100524902344e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.4693699645996094e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.4693699645996094e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.4579998779296875e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.4579998779296875e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.3506500244140625e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.3506500244140625e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.3456500244140625e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.3456500244140625e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.2383099365234375e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.2383099365234375e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.2269400024414062e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.2269400024414062e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.1195899963378906e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.1195899963378906e+02 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.1145899963378906e+02 1.9154699325561523e+01 -1.4890000915527344e+02 -1.1145899963378906e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -1.0072500610351562e+02 4.4891901016235352e+00 -1.2588000488281250e+02 -1.0072500610351562e+02 -3.3208400726318359e+01 -1.2588000488281250e+02 -9.9587799072265625e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -9.9587799072265625e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -8.8853302001953125e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -8.8853302001953125e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -8.8353302001953125e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -8.8353302001953125e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -7.7618797302246094e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -7.7618797302246094e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -7.6481697082519531e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -7.6481697082519531e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -6.5747200012207031e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -6.5747200012207031e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -6.5247200012207031e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -6.5247200012207031e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -5.4512699127197266e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -5.4512699127197266e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -5.3375602722167969e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -5.3375602722167969e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -4.2641098022460938e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -4.2641098022460938e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -4.2141098022460938e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -4.2141098022460938e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -3.1406600952148438e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -3.1406600952148438e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -3.0269500732421875e+01 4.4891901016235352e+00 -1.2588000488281250e+02 -3.0269500732421875e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.9534999847412109e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -1.9534999847412109e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 -1.9034999847412109e+01 1.9154699325561523e+01 -1.4890000915527344e+02 -1.9034999847412109e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 -8.3005294799804688e+00 4.4891901016235352e+00 -1.2588000488281250e+02 -8.3005294799804688e+00 -3.3208400726318359e+01 -1.2588000488281250e+02 -7.1634502410888672e+00 4.4891901016235352e+00 -1.2588000488281250e+02 -7.1634502410888672e+00 -3.3208400726318359e+01 -1.4890000915527344e+02 3.5710499286651611e+00 1.9154699325561523e+01 -1.4890000915527344e+02 3.5710499286651611e+00 -3.3208400726318359e+01 -1.4890000915527344e+02 4.0710401535034180e+00 1.9154699325561523e+01 -1.4890000915527344e+02 4.0710401535034180e+00 -3.3208400726318359e+01 -1.2588000488281250e+02 1.4805500030517578e+01 4.4891901016235352e+00 -1.2588000488281250e+02 1.4805500030517578e+01 -3.3208400726318359e+01 -1.2588000488281250e+02 1.5942599296569824e+01 4.4891901016235352e+00 -1.2588000488281250e+02 1.5942599296569824e+01 -3.3208400726318359e+01 -1.4890000915527344e+02 2.6677099227905273e+01 1.9154699325561523e+01 -1.4890000915527344e+02 2.6677099227905273e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 2.6358600616455078e+01 1.9473199844360352e+01 -1.4939999389648438e+02 2.6358600616455078e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 1.5624100685119629e+01 4.8077301979064941e+00 -1.2637999725341797e+02 1.5624100685119629e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 1.5124100685119629e+01 4.8077301979064941e+00 -1.2637999725341797e+02 1.5124100685119629e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 4.3895702362060547e+00 1.9473199844360352e+01 -1.4939999389648438e+02 4.3895702362060547e+00 -3.3208400726318359e+01 -1.4939999389648438e+02 3.2525200843811035e+00 1.9473199844360352e+01 -1.4939999389648438e+02 3.2525200843811035e+00 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.4820098876953125e+00 4.8077301979064941e+00 -1.2637999725341797e+02 -7.4820098876953125e+00 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.9819998741149902e+00 4.8077301979064941e+00 -1.2637999725341797e+02 -7.9819998741149902e+00 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.8716499328613281e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -1.8716499328613281e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.9853599548339844e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -1.9853599548339844e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -3.0588100433349609e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -3.0588100433349609e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -3.1088100433349609e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -3.1088100433349609e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -4.1822601318359375e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -4.1822601318359375e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -4.2959602355957031e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -4.2959602355957031e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -5.3694198608398438e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -5.3694198608398438e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -5.4194202423095703e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -5.4194202423095703e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -6.4928703308105469e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -6.4928703308105469e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -6.6065696716308594e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -6.6065696716308594e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.6800193786621094e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -7.6800193786621094e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -7.7300201416015625e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -7.7300201416015625e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -8.8034698486328125e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -8.8034698486328125e+01 -3.3208400726318359e+01 -1.4939999389648438e+02 -8.9171798706054688e+01 1.9473199844360352e+01 -1.4939999389648438e+02 -8.9171798706054688e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -9.9906303405761719e+01 4.8077301979064941e+00 -1.2637999725341797e+02 -9.9906303405761719e+01 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.0040599822998047e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.0040599822998047e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.1114100646972656e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.1114100646972656e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.1227799987792969e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.1227799987792969e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.2301200103759766e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.2301200103759766e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.2351200103759766e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.2351200103759766e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.3424700927734375e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.3424700927734375e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.3538398742675781e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.3538398742675781e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.4611799621582031e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.4611799621582031e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.4661799621582031e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.4661799621582031e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.5735299682617188e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.5735299682617188e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.5849000549316406e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.5849000549316406e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.6922500610351562e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.6922500610351562e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.6972500610351562e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.6972500610351562e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.8045899963378906e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.8045899963378906e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -1.8159599304199219e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -1.8159599304199219e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.9233099365234375e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.9233099365234375e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -1.9283099365234375e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -1.9283099365234375e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.0356500244140625e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.0356500244140625e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.0470201110839844e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.0470201110839844e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.1543699645996094e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.1543699645996094e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.1593699645996094e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.1593699645996094e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.2667098999023438e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.2667098999023438e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.2780799865722656e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.2780799865722656e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.3854299926757812e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.3854299926757812e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.3904299926757812e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.3904299926757812e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.4977700805664062e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.4977700805664062e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.5091400146484375e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.5091400146484375e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.6164901733398438e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.6164901733398438e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.6214901733398438e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.6214901733398438e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.7288299560546875e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.7288299560546875e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.7401998901367188e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.7401998901367188e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.8475500488281250e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.8475500488281250e+02 -3.3208400726318359e+01 -1.2637999725341797e+02 -2.8525500488281250e+02 4.8077301979064941e+00 -1.2637999725341797e+02 -2.8525500488281250e+02 -3.3208400726318359e+01 -1.4939999389648438e+02 -2.9598901367187500e+02 1.9473199844360352e+01 -1.4939999389648438e+02 -2.9598901367187500e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 4308 -> 8 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 1.4890000224113464e+02 -2.9780799150466919e+02) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 -2.9830801486968994e+02) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 -2.9598900675773621e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 2.8500000014901161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 -2.9598900675773621e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3208400011062622e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector -3.3208400011062622e+01 1.4890000224113464e+02 -2.9780799150466919e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 1.4890000224113464e+02 -2.9780799150466919e+02) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 -2.9830801486968994e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 -1.4939999580383301e+02 2.8500000014901161e+01) (float-vector -3.3208400011062622e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 1.9473200663924217e+01 1.4939999580383301e+02 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 2.8500000014901161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 -2.9830801486968994e+02) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 -2.9830801486968994e+02) (float-vector 1.9473200663924217e+01 -1.4939999580383301e+02 2.8500000014901161e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 2.8500000014901161e+01) (float-vector 4.3147198855876923e+01 9.8631002008914948e+01 -2.9598900675773621e+02) (float-vector 4.3147198855876923e+01 -9.8631002008914948e+01 -2.9830801486968994e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_bellows_link2_yMXePw.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_pan_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 5.3125000000000000e+01 0.0000000000000000e+00 6.0300141771393896e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.178000 0.180500 0.188000 1.000000))
                    (list :diffuse (float-vector 0.356000 0.361000 0.376000 1.000000))))
                   (list :indices #i( 0 1 2 0 234 1 2 662 0 1135 1136 0 234 662 0 1136 234 0 0 662 1613 0 1613 1135 661 234 662 2 661 662 662 234 1506 662 1506 1613 1613 1506 1504 1613 1504 1614 1135 1613 1614 1505 1504 1506 1505 1506 235 235 1506 234 1503 1502 1504 1503 1504 1505 1614 1504 1502 1614 1502 1615 1135 1614 1133 1133 1614 1615 1501 1500 1502 1501 1502 1503 1615 1502 1500 1682 1501 1503 1682 1503 1505 1505 235 1682 1 234 235 1 235 228 235 234 562 228 235 562 1231 235 1215 1215 235 234 1682 235 1231 562 234 563 661 563 234 1215 234 1136 562 563 564 564 563 565 660 565 563 660 563 661 4 660 661 4 661 2 659 565 660 6 659 660 6 660 4 564 565 566 566 565 567 659 567 565 658 567 659 8 658 659 8 659 6 4 5 6 6 5 7 6 7 8 8 7 9 8 9 10 10 658 8 657 569 658 658 569 567 10 657 658 10 9 11 10 11 12 12 657 10 7 934 9 9 934 935 9 935 11 5 934 7 5 933 934 943 935 934 943 934 942 942 934 933 942 938 943 943 938 939 943 939 944 944 935 943 932 937 942 942 937 938 942 933 932 937 820 938 938 820 819 938 819 939 939 819 822 939 822 940 944 939 940 819 820 812 812 822 819 812 820 821 937 821 820 931 821 937 932 931 937 812 821 813 931 813 821 931 216 215 215 813 931 216 931 932 214 812 813 215 214 813 214 215 216 214 216 194 194 216 227 932 227 216 214 194 204 204 811 214 214 811 812 204 823 811 811 823 830 811 830 812 823 206 209 823 209 830 204 206 823 204 205 206 205 207 206 206 207 208 206 208 209 209 208 210 207 558 208 560 210 208 560 208 561 561 208 558 207 557 558 557 764 558 561 558 764 764 768 561 561 768 560 559 210 560 768 769 560 560 769 559 451 453 768 768 453 769 764 451 768 447 764 765 557 765 764 447 451 764 447 446 451 451 446 452 451 452 453 453 452 583 769 453 583 559 769 771 769 583 771 583 452 584 583 584 585 771 583 585 771 585 772 559 771 605 605 771 772 585 584 586 585 586 587 585 587 772 587 586 588 622 588 586 622 586 623 623 586 584 587 588 589 772 587 589 588 590 589 621 590 588 621 588 622 105 621 622 105 622 103 103 622 623 623 584 624 103 623 101 101 623 624 101 102 103 103 102 104 103 104 105 99 100 101 101 100 102 101 624 99 624 584 452 624 452 625 99 624 625 97 98 99 99 98 100 99 625 97 100 98 877 100 877 102 98 97 426 877 98 878 878 98 426 426 97 427 625 427 97 423 426 427 626 427 625 423 427 626 626 625 627 626 627 628 626 628 423 627 625 452 627 452 446 448 628 627 448 627 446 423 628 629 441 629 628 441 628 448 446 447 448 448 447 449 448 449 441 441 442 443 441 449 450 441 450 442 443 629 441 765 450 449 765 449 447 767 442 450 767 450 765 443 442 444 766 444 442 766 442 767 554 766 767 554 767 555 555 767 765 555 765 556 556 765 557 241 554 555 241 555 239 239 555 556 239 556 236 236 556 557 236 557 207 236 207 205 205 237 236 236 237 238 236 238 239 239 238 240 239 240 241 543 240 238 543 238 544 238 237 544 544 237 205 544 205 545 544 545 691 544 691 692 692 543 544 542 240 543 692 542 543 241 240 242 542 242 240 541 242 542 702 541 542 702 542 692 436 702 692 436 692 434 434 692 691 429 695 702 429 702 437 695 541 702 437 702 436 434 435 436 436 435 431 436 431 437 432 433 434 434 433 435 434 691 432 433 677 435 677 431 435 430 429 431 437 431 429 677 430 431 674 677 433 678 430 677 88 678 677 88 677 86 86 677 674 439 673 674 439 674 433 86 674 673 83 85 86 86 85 87 86 87 88 673 83 86 650 24 673 673 24 83 650 673 439 83 84 85 84 83 23 23 83 24 85 84 949 87 85 950 950 85 949 88 87 89 89 87 950 88 89 90 88 90 680 680 678 88 90 89 91 90 91 92 92 680 90 679 678 680 683 679 680 92 683 680 679 430 678 408 430 679 410 408 679 683 410 679 682 410 683 93 682 683 93 683 92 92 91 93 93 91 94 93 94 95 95 682 93 681 412 682 682 412 410 95 681 682 95 94 96 96 681 95 675 676 681 675 681 96 676 413 681 681 413 412 411 410 412 411 412 382 382 412 413 382 413 380 676 380 413 675 664 676 676 664 381 676 381 380 96 29 675 675 29 664 664 29 28 666 381 664 664 28 666 380 381 382 382 381 383 666 383 381 665 383 666 666 28 26 666 26 665 27 26 28 27 28 29 96 27 29 25 26 27 96 94 27 25 27 975 975 27 982 27 94 982 25 34 26 665 26 34 25 33 34 665 34 668 668 34 33 32 31 33 32 33 25 668 33 667 667 33 31 667 389 668 668 389 387 668 387 665 388 387 389 388 389 390 390 389 391 667 391 389 386 385 387 386 387 388 665 387 385 665 385 383 384 383 385 384 385 386 711 384 386 711 386 712 386 388 712 712 388 390 528 711 712 528 712 529 529 712 713 712 390 713 258 527 528 258 528 259 259 528 529 527 711 528 259 529 140 140 529 530 529 713 530 254 258 259 254 259 260 260 259 140 255 258 254 255 527 258 255 533 527 533 711 527 254 253 255 253 532 255 255 532 533 532 711 533 532 705 711 705 384 711 253 531 532 531 705 532 251 531 253 251 535 531 535 705 531 251 534 535 534 706 535 535 706 705 249 534 251 249 539 534 539 703 534 534 703 706 703 411 706 706 411 705 697 703 698 698 703 704 697 409 703 703 409 411 539 704 703 249 538 539 538 704 539 537 538 249 537 693 538 538 693 704 536 537 249 693 537 536 693 536 694 693 694 704 249 247 536 536 247 246 536 246 540 694 536 695 536 540 695 694 695 696 704 694 696 695 701 696 704 696 701 698 704 700 700 704 701 695 700 701 698 700 695 697 698 695 697 695 699 697 699 409 429 428 699 699 695 429 409 699 428 407 408 409 409 408 410 409 410 411 409 428 407 407 428 429 430 407 429 408 407 430 411 382 705 382 383 384 705 382 384 695 540 541 540 246 244 540 244 541 541 244 242 243 242 244 243 244 245 244 246 245 245 246 247 245 247 248 248 553 245 245 553 554 245 554 243 241 242 243 243 554 241 553 766 554 248 552 553 552 754 553 553 754 766 463 552 248 552 463 753 753 755 552 552 755 754 754 755 756 756 759 754 754 759 766 756 755 753 753 463 462 753 462 756 250 462 463 250 463 248 461 462 250 756 462 461 250 460 461 756 461 762 762 461 460 250 465 460 762 460 763 763 460 465 761 756 762 761 762 343 343 762 763 343 763 345 345 763 744 763 465 744 250 464 465 744 465 745 745 465 464 744 745 368 744 368 347 345 744 347 344 343 345 344 345 346 346 345 347 342 343 344 346 635 344 344 635 636 344 636 342 346 347 348 348 634 346 346 634 635 634 417 635 635 417 421 635 421 636 342 636 631 636 421 420 636 420 631 416 420 421 416 421 417 416 417 415 415 417 418 634 418 417 419 420 416 416 900 419 416 415 900 419 424 420 424 631 420 422 423 419 419 423 424 419 900 891 419 891 422 900 415 926 900 926 891 891 892 893 422 891 893 891 926 892 422 425 423 422 893 425 423 425 426 423 629 424 424 629 631 629 630 631 443 630 629 342 631 630 340 630 443 630 340 342 444 445 443 443 445 341 443 341 340 340 341 342 342 341 343 341 445 343 343 445 760 760 445 444 760 444 766 343 760 761 766 761 760 766 759 758 758 757 766 766 757 761 757 756 761 757 758 756 756 758 759 878 426 874 874 426 889 425 889 426 877 878 874 874 875 876 874 876 877 874 889 875 875 889 890 889 893 890 425 893 889 876 875 869 875 890 869 869 871 876 876 871 882 876 882 885 877 876 885 869 870 871 869 890 870 870 829 871 871 829 834 871 834 882 882 834 833 882 833 883 885 882 883 885 883 886 877 885 879 879 885 886 883 833 832 883 832 884 886 883 884 829 832 833 829 833 834 828 832 829 884 832 828 884 828 873 886 884 887 887 884 873 879 886 880 880 886 887 887 873 872 880 887 881 881 887 872 872 221 200 872 873 220 872 220 221 881 872 888 888 872 200 220 198 221 221 198 197 221 197 200 873 198 220 196 197 198 211 212 198 198 212 213 198 213 196 873 211 198 200 197 222 770 222 197 770 197 196 196 213 770 604 770 213 604 213 212 604 212 210 604 210 606 606 770 604 210 608 606 608 774 606 606 774 770 210 607 608 607 773 608 608 773 774 773 594 774 594 597 774 774 597 596 774 596 770 772 589 773 589 592 773 773 592 594 607 772 773 605 607 210 605 772 607 210 559 605 209 210 211 211 210 212 1219 212 210 1219 210 1220 1457 1220 210 1457 210 1458 212 1549 210 210 1549 1550 210 1550 1551 1551 1552 210 210 1552 1553 210 1553 1458 1553 1629 1458 1629 1457 1458 1552 1628 1553 1553 1628 1629 1551 1627 1552 1552 1627 1628 1550 1626 1551 1551 1626 1627 1626 1539 1627 1539 1540 1627 1627 1540 1543 1627 1543 1628 1546 1629 1628 1546 1628 1544 1544 1628 1543 1540 1542 1543 1543 1542 1544 1539 1538 1540 1538 1541 1540 1540 1541 1542 1537 1538 1539 1626 1537 1539 1537 1536 1538 1564 1541 1538 1564 1538 1565 1565 1538 1536 1563 1542 1541 1563 1541 1564 1521 1563 1564 1521 1564 1519 1519 1564 1565 1565 1536 1566 1519 1565 1517 1517 1565 1566 1517 1518 1519 1519 1518 1520 1519 1520 1521 1521 1520 1522 1521 1522 1523 1523 1563 1521 1518 1723 1520 1723 1522 1520 1517 1516 1518 1516 1722 1518 1518 1722 1723 1515 1516 1517 1517 1566 1515 1515 1514 1516 1514 1722 1516 1514 1721 1722 1731 1723 1722 1731 1722 1730 1730 1722 1721 1513 1512 1514 1513 1514 1515 1512 1721 1514 1515 1566 1567 1515 1567 1513 1511 1512 1513 1513 1567 1568 1513 1568 1511 1511 1510 1512 1510 1721 1512 1509 1510 1511 1511 1568 1569 1511 1569 1509 1567 1533 1568 1568 1533 1531 1568 1531 1569 1566 1535 1567 1567 1535 1533 1566 1536 1535 1533 1535 1534 1534 1535 1536 1532 1531 1533 1532 1533 1534 1530 1529 1531 1530 1531 1532 1569 1531 1529 1530 1532 1625 1625 1532 1534 1534 1536 1537 1625 1534 1626 1534 1537 1626 1624 1530 1625 1549 1624 1625 1549 1625 1550 1550 1625 1626 1528 1529 1530 1624 1528 1530 233 224 1528 1528 224 1529 1239 233 1528 1239 1528 1624 1239 1240 1241 1241 233 1239 1240 1239 1624 1241 1240 1242 1624 1242 1240 1241 1242 1243 1243 1242 1219 1219 1242 1244 1624 1244 1242 1243 1219 1720 1241 1243 1508 1508 1243 1720 1507 1241 1508 1507 1508 1509 1509 1508 1510 1508 1720 1510 121 1241 1507 1509 1570 1507 1507 1570 225 1507 225 121 1509 1569 1570 1569 1529 1570 1570 1529 224 1570 224 225 224 225 121 225 224 603 121 225 614 225 603 614 233 599 603 233 603 224 614 603 599 614 599 615 121 614 119 119 614 615 599 600 601 601 602 599 600 599 233 615 599 602 615 602 616 119 615 117 117 615 616 117 118 119 119 118 120 119 120 121 115 116 117 117 116 118 117 616 115 199 120 118 199 118 888 888 118 116 120 199 200 200 224 120 120 224 121 121 224 1241 200 233 224 1241 224 233 200 222 223 223 233 200 888 200 199 888 116 881 881 112 880 881 116 114 881 114 112 111 110 112 111 112 113 113 112 114 880 112 110 106 879 880 106 880 108 880 110 108 109 108 110 109 110 111 107 106 108 107 108 109 105 104 106 105 106 107 104 879 106 102 877 879 102 879 104 109 620 107 107 620 621 107 621 105 111 619 109 109 619 620 619 591 620 620 591 590 620 590 621 618 593 619 619 593 591 111 618 619 113 618 111 617 598 618 618 598 593 113 617 618 592 591 593 592 593 594 594 593 597 597 593 598 597 598 595 617 595 598 616 595 617 115 616 617 115 617 113 113 114 115 115 114 116 616 602 595 595 596 597 596 595 601 601 595 602 770 596 601 770 601 600 600 222 770 233 223 600 600 223 222 589 591 592 589 590 591 1510 1720 1721 1720 1219 1218 1729 1721 1720 1729 1720 1719 1719 1720 1218 1730 1721 1729 1719 1724 1729 1729 1724 1725 1729 1725 1730 1719 1238 1225 1225 1718 1719 1719 1718 1724 1719 1218 1238 1718 1697 1724 1724 1697 1703 1724 1703 1725 1725 1703 1702 1725 1702 1726 1730 1725 1726 1730 1726 1731 1726 1702 1701 1726 1701 1727 1731 1726 1727 1701 1702 1699 1699 1702 1703 1699 1703 1697 1697 1698 1699 1718 1698 1697 1699 1698 1700 1727 1701 1699 1727 1699 1728 1699 1700 1728 1731 1727 1717 1717 1727 1728 1717 1723 1731 1715 1716 1717 1717 1728 1715 1716 1732 1717 1717 1732 1723 1728 1700 1714 1728 1714 1715 1715 1714 1716 1716 1733 1732 1713 1733 1716 1713 1716 1714 1695 1713 1714 1695 1714 1700 1705 1042 1713 1705 1713 1695 1042 1734 1713 1734 1733 1713 1732 1733 1734 1732 1734 1043 1043 1734 1042 1042 1041 1043 1527 1526 1043 1527 1043 1041 1043 1526 1732 1525 1526 1527 1041 1560 1527 1527 1560 1561 1527 1561 1525 1525 1524 1526 1732 1526 1524 1523 1524 1525 1525 1561 1562 1525 1562 1523 1560 1547 1561 1561 1547 1548 1561 1548 1562 1562 1548 1542 1562 1542 1563 1523 1562 1563 1523 1522 1524 1723 1524 1522 1732 1524 1723 1548 1544 1542 1547 1544 1548 1547 1546 1544 1545 1546 1547 1560 1545 1547 1545 1383 1546 1383 1629 1546 1384 1383 1545 1559 1384 1545 1559 1545 1560 1041 1559 1560 1384 1559 1571 1571 1559 1041 1383 1384 1385 1385 1384 1333 1571 1333 1384 1385 1629 1383 1385 1333 1386 1386 1630 1385 1385 1630 1629 1386 1333 1332 1332 1631 1386 1386 1631 1630 1630 1456 1629 1631 1454 1630 1630 1454 1455 1630 1455 1456 1453 1253 1454 1454 1253 1255 1454 1255 1455 1631 1453 1454 1455 1255 207 1455 207 1456 1253 1254 1255 1255 1254 1256 1255 1256 207 1251 1252 1253 1253 1252 1254 1453 1251 1253 1254 1252 1480 1254 1480 1256 207 1256 205 1256 1480 1482 1256 1482 205 205 1482 1483 1483 1482 1679 1679 1482 1480 205 1483 1233 1233 1483 1484 1679 1484 1483 205 1233 1216 1216 1233 1234 1233 1484 1234 1234 1484 1485 1485 1484 1680 1680 1484 1679 1216 1234 1235 1235 1234 219 1234 1485 219 1485 1557 219 1680 1686 1485 1485 1686 1557 1680 1679 1388 1388 1486 1680 1680 1486 1686 1684 1557 1686 1486 1489 1686 1686 1489 1491 1686 1491 1684 219 1557 1558 1684 1558 1557 1684 1495 1685 1685 1558 1684 1684 1491 1493 1684 1493 1495 1489 1490 1491 1491 1490 1492 1491 1492 1493 1486 1488 1489 1489 1488 1490 1620 1492 1490 1620 1490 1621 1621 1490 1488 1493 1492 1494 1619 1494 1492 1619 1492 1620 1493 1494 1495 1495 1494 1496 1618 1496 1494 1618 1494 1619 1125 1618 1619 1125 1619 1123 1123 1619 1620 1123 1620 1121 1121 1620 1621 1121 1122 1123 1123 1122 1124 1123 1124 1125 1125 1124 1126 1125 1126 1127 1127 1618 1125 1617 1496 1618 1127 1617 1618 1127 1126 1128 1127 1128 1129 1129 1617 1127 1746 1128 1126 1746 1126 1124 1122 1746 1124 1122 1745 1746 1747 1128 1746 1745 1752 1746 1746 1752 1753 1746 1753 1747 1129 1128 1130 1747 1130 1128 1747 1753 1738 1747 1738 1754 1754 1132 1747 1747 1132 1130 1752 1750 1753 1753 1750 1739 1753 1739 1738 1749 1707 1750 1750 1707 1706 1750 1706 1739 1752 1749 1750 1739 1227 1226 1739 1706 1236 1739 1236 1227 1738 1739 1226 1226 1227 1228 1228 1227 219 1236 219 1227 1738 1226 1228 1228 219 1215 1738 1228 1215 1754 1738 1215 1754 1215 1214 1214 1134 1754 1754 1134 1132 1136 1214 1215 1214 1136 1134 1133 1132 1134 1133 1134 1135 1135 1134 1136 1131 1130 1132 1131 1132 1133 1133 1615 1131 1129 1130 1131 1131 1615 1616 1131 1616 1129 1615 1500 1616 1616 1500 1498 1616 1498 1617 1129 1616 1617 1499 1498 1500 1499 1500 1501 1497 1496 1498 1497 1498 1499 1617 1498 1496 1683 1497 1499 1683 1499 1501 1683 1501 1682 1685 1497 1683 1682 1555 1683 1683 1555 1554 1683 1554 1685 1495 1496 1497 1685 1495 1497 1685 1554 1558 1554 1555 219 219 1558 1554 219 1555 1556 1682 1556 1555 219 1556 218 1221 218 1556 1221 1556 1682 1221 1222 1215 1215 218 1221 1222 1221 1682 1222 1229 1215 1682 1229 1222 1215 219 218 1215 1229 1230 1215 1230 1231 1682 1230 1229 1231 1230 1682 217 218 195 195 218 219 218 609 219 218 217 684 218 684 609 195 232 217 217 232 684 195 230 232 684 232 230 1 229 230 1 230 231 231 230 195 684 230 229 2 1 3 228 229 1 1 231 3 229 228 684 228 562 684 684 562 564 684 564 685 564 566 685 685 566 568 685 568 686 609 684 685 609 685 610 610 685 686 566 567 568 567 569 568 568 569 570 657 570 569 568 570 571 571 570 572 656 572 570 656 570 657 12 656 657 655 572 656 14 655 656 14 656 12 12 11 13 12 13 14 14 13 15 14 15 16 16 655 14 654 575 655 655 575 572 16 654 655 16 15 17 16 17 18 18 654 16 936 15 935 935 15 13 936 17 15 935 13 11 944 936 935 930 945 936 930 936 944 945 19 936 936 19 17 18 17 19 18 19 20 20 19 21 945 21 19 20 21 22 22 652 20 20 652 653 20 653 18 22 21 23 23 21 945 22 23 24 24 651 22 22 651 652 651 581 652 652 581 582 652 582 653 653 582 576 653 576 654 18 653 654 581 578 582 582 578 576 579 580 581 581 580 578 651 579 581 577 576 578 580 688 578 578 688 577 579 438 580 438 689 580 580 689 688 439 438 579 650 439 579 650 579 651 438 439 440 689 438 440 440 439 433 440 433 432 689 440 690 690 440 432 690 432 691 691 545 546 691 546 690 205 203 545 545 203 202 545 202 546 546 202 226 546 226 547 690 546 547 202 203 204 204 226 202 204 203 205 205 1216 207 207 1216 1217 1217 1216 1687 1235 1687 1216 1217 1237 207 207 1237 1456 1217 1220 1237 1456 1237 1220 1223 1220 1217 1217 1687 1688 1217 1688 1223 1688 1687 1689 1235 1689 1687 1688 1689 1690 1223 1688 1690 1690 1689 1691 1691 1689 1235 1690 1691 1692 1690 1692 1223 1692 1691 1693 1235 1693 1691 1692 1693 1694 1223 1692 1694 1694 1693 1695 1235 1695 1693 1694 1695 1696 1223 1694 1698 1698 1694 1696 1704 1705 1695 1706 1704 1695 1706 1695 1235 1700 1696 1695 1235 219 1236 1706 1235 1236 1706 1707 1708 1708 1704 1706 1736 1704 1708 1704 1736 1705 1712 1042 1705 1705 1736 1712 1735 1736 1737 1736 1708 1737 1736 1735 1712 1708 1707 1709 1708 1709 1710 1737 1708 1710 1749 1709 1707 1748 1710 1709 1748 1709 1749 1737 1710 1748 1735 1737 1742 1742 1737 1748 1742 1741 1735 1712 1735 1741 1740 1741 1742 1742 1748 1751 1740 1742 1743 1743 1742 1751 1751 1748 1749 1751 1749 1752 1743 1751 1745 1745 1751 1752 1118 1743 1745 1118 1745 1120 1120 1745 1122 1117 1116 1118 1117 1118 1119 1119 1118 1120 1116 1743 1118 1119 1120 1121 1121 1120 1122 1121 1621 1119 1119 1621 1622 1119 1622 1117 1115 1116 1117 1117 1622 1623 1117 1623 1115 1115 1046 1116 1116 1046 1743 1047 1046 1115 1115 1623 1612 1115 1612 1047 1622 1487 1623 1623 1487 1387 1623 1387 1612 1387 1351 1612 1612 1351 1602 1612 1602 1047 1046 1047 1048 1048 1047 1049 1047 1602 1049 1049 1602 1603 1603 1602 1351 1062 1063 1049 1049 1063 1048 1049 1112 1062 1049 1603 1112 1603 1351 1604 1112 1603 1604 1062 1112 1113 1112 1604 1113 1062 1113 1108 1063 1062 1755 1755 1062 1108 1048 1063 1103 1781 1103 1063 1781 1063 1755 1755 1108 1756 1794 1781 1755 1794 1755 1795 1795 1755 1756 1780 1103 1781 1793 1780 1781 1793 1781 1794 1048 1103 1104 1780 1104 1103 1779 1104 1780 1792 1779 1780 1792 1780 1793 1818 1792 1793 1818 1793 1819 1819 1793 1794 1791 1779 1792 1817 1791 1792 1817 1792 1818 1778 1110 1779 1779 1110 1104 1791 1778 1779 1104 1110 1048 1048 1110 1111 1778 1111 1110 1777 1111 1778 1790 1777 1778 1790 1778 1791 1816 1790 1791 1816 1791 1817 1818 1816 1817 1815 1790 1816 1818 1815 1816 1782 1777 1790 1815 1782 1790 1776 1105 1777 1777 1105 1111 1782 1776 1777 1048 1111 1105 1048 1105 1042 1042 1105 1106 1776 1106 1105 1775 1106 1776 1775 1776 1782 1042 1106 1044 1775 1044 1106 1774 1044 1775 1782 1783 1775 1775 1783 1774 1044 1045 1042 1774 1045 1044 1773 1045 1774 1774 1783 1784 1774 1784 1773 1813 1784 1783 1813 1783 1814 1814 1783 1782 1773 1784 1785 1812 1785 1784 1812 1784 1813 1812 1813 1821 1821 1813 1814 1811 1785 1812 1821 1811 1812 1773 1785 1772 1772 1785 1786 1811 1786 1785 1810 1786 1811 1821 1810 1811 1772 1786 1771 1771 1786 1787 1810 1787 1786 1771 1055 1772 1772 1055 1056 1772 1056 1773 1770 1054 1771 1771 1054 1055 1771 1787 1770 1770 1787 1788 1809 1788 1787 1809 1787 1810 1809 1810 1821 1808 1788 1809 1821 1808 1809 1770 1788 1789 1808 1789 1788 1807 1768 1789 1789 1768 1769 1789 1769 1770 1833 1807 1789 1833 1789 1808 1806 1767 1807 1807 1767 1768 1832 1806 1807 1832 1807 1833 1767 1065 1768 1768 1065 1059 1768 1059 1769 1769 1059 1052 1769 1052 1770 1770 1052 1054 1052 1053 1054 1054 1053 1040 1054 1040 1055 1052 1051 1053 1051 1572 1053 1053 1572 1571 1053 1571 1040 1040 1041 1042 1055 1040 1042 1571 1041 1040 1055 1042 1056 1056 1042 1045 1048 1042 1711 1711 1042 1712 1773 1056 1045 1712 1741 1711 1744 1048 1711 1744 1711 1740 1740 1711 1741 1046 1048 1744 1743 1046 1744 1743 1744 1740 1333 1571 1572 1332 1333 1334 1334 1333 1335 1572 1335 1333 1580 1348 1572 1572 1348 1335 1051 1580 1572 1348 1349 1335 1335 1349 1350 1335 1350 1334 1346 1347 1348 1348 1347 1349 1580 1346 1348 1350 1349 1638 1347 1638 1349 1636 1334 1350 1636 1350 1637 1637 1350 1638 1448 1633 1636 1637 1450 1636 1636 1450 1449 1636 1449 1448 1633 1334 1636 1444 1445 1637 1637 1445 1450 1637 1638 1444 1139 1449 1450 1139 1450 1445 1138 1448 1449 1138 1449 1139 1137 1138 1139 1139 1140 1137 1445 1140 1139 1444 1140 1445 1443 1141 1444 1444 1141 1140 1638 1443 1444 1137 1140 1141 1137 1141 1142 1443 1142 1141 1442 1142 1443 1638 1442 1443 1639 1442 1638 1345 1639 1638 1345 1638 1347 1441 1145 1442 1442 1145 1142 1639 1441 1442 1440 1441 1639 1640 1440 1639 1640 1639 1345 1440 1158 1441 1158 1143 1441 1441 1143 1145 1143 1144 1145 1145 1144 1146 1145 1146 1142 1143 1158 1144 1144 1158 1156 1158 1160 1156 1440 1160 1158 1156 1160 1161 1439 1161 1160 1439 1160 1440 1156 1161 1154 1154 1161 1162 1162 1161 1439 1438 1162 1439 1439 1440 1640 1439 1640 1438 1154 1162 1153 1438 1153 1162 1437 1153 1438 1438 1640 1641 1438 1641 1437 1345 1343 1640 1343 1341 1640 1640 1341 1339 1640 1339 1641 1344 1343 1345 1344 1345 1346 1346 1345 1347 1342 1341 1343 1342 1343 1344 1340 1339 1341 1340 1341 1342 1338 1337 1339 1338 1339 1340 1339 1337 1641 1342 1579 1340 1340 1579 1578 1340 1578 1338 1342 1344 1579 1579 1344 1346 1579 1346 1580 1061 1578 1579 1061 1579 1050 1050 1579 1580 1577 1320 1578 1338 1578 1320 1060 1577 1578 1060 1578 1061 1320 1337 1338 1320 1321 1322 1322 1336 1320 1320 1336 1337 1577 1321 1320 1322 1321 1323 1323 1321 1324 1324 1321 1577 1336 1322 1642 1642 1322 1323 1641 1337 1336 1641 1336 1642 1437 1641 1642 1436 1151 1437 1437 1151 1153 1437 1642 1436 1435 1165 1436 1436 1165 1151 1642 1435 1436 1151 1152 1153 1151 1165 1152 1153 1152 1154 1157 1156 1154 1459 1157 1154 1459 1154 1152 1155 1156 1157 1470 1155 1157 1470 1157 1459 1144 1156 1159 1159 1156 1155 1469 1159 1155 1469 1155 1470 1459 1671 1470 1470 1671 1672 1470 1672 1469 1459 1152 1460 1459 1460 1671 1460 1152 1187 1460 1187 1461 1671 1460 1461 1164 1186 1187 1164 1187 1152 1461 1187 1186 1461 1186 1462 1671 1461 1670 1670 1461 1462 1182 1186 1164 1462 1186 1182 1462 1182 1463 1670 1462 1669 1669 1462 1463 1669 1358 1670 1358 1360 1670 1670 1360 1362 1670 1362 1671 1356 1357 1358 1358 1357 1359 1358 1359 1360 1669 1356 1358 1360 1359 1361 1360 1361 1362 1362 1361 1363 1362 1363 1364 1671 1362 1364 1671 1364 1672 1364 1363 1365 1364 1365 1366 1364 1366 1672 1609 1365 1363 1609 1363 1610 1363 1361 1610 1610 1361 1359 1610 1359 1611 1096 1609 1610 1096 1610 1098 1098 1610 1611 1608 1365 1609 1095 1608 1609 1095 1609 1096 1095 1096 1097 1097 1096 1098 1097 1098 1089 1089 1098 1099 1098 1611 1099 1089 1090 1077 1089 1099 1090 1757 1097 1089 1757 1089 1758 1758 1089 1077 1099 1611 1601 1099 1601 1090 1077 1090 1091 1090 1601 1600 1090 1600 1091 1317 1600 1601 1611 1357 1601 1601 1357 1355 1601 1355 1317 1611 1359 1357 1356 1355 1357 1354 1317 1355 1354 1355 1356 1668 1354 1356 1668 1356 1669 1318 1317 1354 1645 1318 1354 1645 1354 1668 1465 1645 1668 1465 1668 1464 1464 1668 1669 1669 1463 1464 1463 1181 1464 1464 1181 1180 1464 1180 1465 1465 1180 1179 1465 1179 1391 1391 1645 1465 1318 1645 1646 1646 1645 1391 1391 1198 1392 1391 1179 1199 1391 1199 1198 1646 1391 1392 1179 1180 1164 1164 1199 1179 1164 1180 1181 1163 1164 1152 1172 1171 1164 1177 1178 1164 1164 1181 1182 1195 1164 1196 1196 1164 1197 1195 1198 1164 1164 1198 1199 1171 1200 1164 1164 1200 1201 1164 1201 1202 1178 1203 1164 1164 1203 1204 1164 1204 1197 1202 1212 1164 1164 1212 1213 1164 1213 1177 1428 1172 1164 1428 1164 1429 1429 1164 1163 1402 1213 1212 1402 1212 1202 1202 1401 1402 1400 1213 1402 1663 1400 1402 1663 1402 1401 1201 1401 1202 1201 1407 1401 1663 1401 1662 1662 1401 1407 1200 1406 1201 1201 1406 1407 1662 1407 1406 1662 1406 1661 1661 1302 1662 1662 1302 1303 1662 1303 1663 1200 1405 1406 1661 1406 1405 1171 1405 1200 1171 1404 1405 1661 1405 1660 1660 1405 1404 1403 1404 1171 1660 1404 1659 1659 1404 1403 1659 1297 1660 1660 1297 1299 1660 1299 1661 1659 1410 1658 1658 1296 1659 1659 1296 1297 1659 1403 1410 1296 1295 1297 1297 1295 1298 1297 1298 1299 1299 1298 1300 1299 1300 1661 1300 1298 1301 1295 1593 1298 1298 1593 1594 1298 1594 1301 1300 1301 1302 1661 1300 1302 1302 1301 1303 1303 1301 1304 1301 1594 1595 1301 1595 1304 1101 1595 1594 1101 1594 1102 1102 1594 1593 1304 1595 1596 1100 1596 1595 1100 1595 1101 1088 1100 1101 1088 1101 1093 1093 1101 1102 1093 1102 1094 1102 1593 1094 1092 1093 1094 1094 1593 1592 1094 1592 1092 1295 1592 1593 1293 1591 1592 1293 1592 1295 1092 1592 1591 1081 1083 1092 1092 1083 1093 1092 1591 1081 1290 1590 1591 1290 1591 1293 1081 1591 1590 1292 1290 1293 1292 1293 1294 1294 1293 1295 1294 1295 1296 1292 1294 1658 1658 1294 1296 1291 1290 1292 1657 1291 1292 1657 1292 1658 1658 1409 1657 1658 1410 1411 1658 1411 1409 1656 1291 1657 1657 1409 1408 1657 1408 1656 1289 1290 1291 1656 1289 1291 1287 1288 1289 1289 1288 1290 1287 1289 1656 1288 1590 1290 1287 1285 1288 1285 1589 1288 1288 1589 1590 1286 1285 1287 1286 1287 1655 1655 1287 1656 1284 1283 1285 1284 1285 1286 1283 1588 1285 1285 1588 1589 1082 1590 1589 1082 1589 1084 1084 1589 1588 1081 1590 1082 1081 1082 1083 1083 1082 1084 1083 1084 1078 1078 1084 1085 1084 1588 1085 1283 1587 1588 1085 1588 1587 1078 1085 1079 1085 1587 1079 1078 1079 1072 1763 1083 1078 1763 1078 1764 1764 1078 1072 1762 1093 1083 1762 1083 1763 1802 1762 1763 1802 1763 1803 1803 1763 1764 1764 1072 1765 1803 1764 1804 1804 1764 1765 1828 1802 1803 1828 1803 1829 1829 1803 1804 1801 1762 1802 1827 1801 1802 1827 1802 1828 1829 1808 1828 1808 1827 1828 1829 1804 1830 1829 1830 1808 1804 1765 1805 1830 1804 1805 1830 1805 1831 1830 1831 1808 1805 1765 1766 1805 1766 1806 1831 1805 1806 1831 1806 1832 1808 1831 1832 1806 1766 1767 1765 1070 1766 1766 1070 1067 1766 1067 1767 1767 1067 1065 1066 1065 1067 1066 1067 1068 1068 1067 1069 1069 1067 1070 1064 1059 1065 1064 1065 1066 1064 1066 1573 1068 1573 1066 1069 1581 1068 1068 1581 1573 1069 1070 1071 1071 1582 1069 1069 1582 1581 1265 1573 1581 1265 1581 1267 1267 1581 1582 1265 1331 1573 1573 1331 1574 1573 1574 1064 1264 1265 1266 1266 1265 1267 1265 1264 1319 1319 1331 1265 1319 1330 1331 1331 1330 1574 1574 1330 1328 1574 1328 1575 1064 1574 1575 1329 1328 1330 1329 1330 1319 1264 1634 1319 1319 1634 1635 1319 1635 1329 1634 1264 1266 1634 1432 1433 1634 1433 1635 1634 1266 1647 1432 1634 1431 1431 1634 1647 1431 1175 1432 1432 1175 1169 1432 1169 1433 1433 1169 1168 1433 1168 1421 1433 1421 1635 1152 1168 1169 1169 1175 1152 1152 1175 1176 1431 1176 1175 1430 1176 1431 1431 1647 1430 1152 1176 1163 1430 1163 1176 1429 1163 1430 1430 1647 1648 1430 1648 1429 1429 1648 1428 1427 1172 1428 1428 1648 1427 1426 1170 1427 1427 1170 1172 1427 1648 1649 1427 1649 1426 1170 1171 1172 1170 1183 1171 1426 1183 1170 1425 1183 1426 1426 1649 1650 1426 1650 1425 1648 1269 1649 1649 1269 1279 1649 1279 1650 1268 1269 1270 1270 1269 1271 1268 1279 1269 1648 1271 1269 1268 1278 1279 1279 1278 1650 1277 1276 1278 1277 1278 1268 1650 1278 1276 1275 1276 1277 1268 1584 1277 1277 1584 1585 1277 1585 1275 1275 1274 1276 1650 1276 1651 1651 1276 1274 1273 1274 1275 1651 1274 1652 1274 1273 1652 1652 1416 1651 1651 1416 1415 1651 1415 1650 1650 1415 1424 1650 1424 1425 1415 1416 1190 1190 1193 1415 1415 1193 1185 1415 1185 1424 1190 1416 1417 1652 1417 1416 1190 1417 1205 1205 1417 1418 1653 1417 1652 1653 1418 1417 1190 1205 1206 1418 1206 1205 1420 1207 1418 1418 1207 1206 1653 1420 1418 1419 1420 1653 1652 1280 1653 1653 1280 1654 1653 1654 1419 1419 1208 1420 1420 1208 1207 1206 1207 1190 1190 1207 1208 1190 1208 1209 1419 1209 1208 1209 1210 1190 1413 1210 1209 1413 1209 1414 1414 1209 1419 1190 1210 1211 1412 1211 1210 1412 1210 1413 1414 1655 1413 1655 1656 1413 1656 1412 1413 1419 1655 1414 1654 1286 1655 1419 1654 1655 1654 1284 1286 1280 1282 1654 1282 1284 1654 1282 1283 1284 1280 1281 1282 1282 1281 1283 1273 1275 1280 1280 1275 1281 1652 1273 1280 1275 1586 1281 1281 1586 1587 1281 1587 1283 1275 1585 1586 1079 1587 1586 1079 1586 1080 1080 1586 1585 1080 1585 1073 1073 1585 1584 1072 1079 1080 1072 1080 1073 1072 1073 1070 1070 1073 1074 1073 1584 1074 1268 1583 1584 1074 1584 1583 1070 1074 1071 1074 1583 1071 1765 1072 1070 1071 1583 1582 1270 1582 1583 1270 1583 1268 1267 1582 1270 1270 1271 1267 1267 1271 1272 1267 1272 1266 1272 1271 1648 1647 1266 1272 1647 1272 1648 1408 1211 1412 1656 1408 1412 1408 1409 1189 1189 1188 1408 1408 1188 1211 1190 1211 1188 1188 1189 1190 1190 1189 1191 1189 1409 1191 1411 1191 1409 1190 1191 1192 1410 1192 1191 1410 1191 1411 1171 1193 1190 1171 1190 1194 1194 1190 1192 1403 1194 1192 1403 1192 1410 1171 1194 1403 1171 1183 1184 1171 1184 1185 1185 1193 1171 1425 1184 1183 1424 1185 1184 1424 1184 1425 1152 1165 1166 1152 1166 1167 1167 1173 1152 1152 1173 1174 1152 1174 1168 1435 1166 1165 1434 1167 1166 1434 1166 1435 1422 1173 1167 1422 1167 1423 1423 1167 1434 1421 1173 1422 1421 1174 1173 1421 1168 1174 1635 1421 1422 1635 1422 1644 1644 1422 1423 1644 1423 1434 1643 1644 1434 1643 1434 1642 1642 1434 1435 1325 1644 1643 1329 1635 1644 1329 1644 1327 1327 1644 1325 1642 1323 1643 1643 1323 1325 1323 1324 1325 1325 1324 1326 1325 1326 1327 1327 1326 1328 1327 1328 1329 1575 1328 1326 1575 1326 1576 1576 1326 1324 1576 1324 1577 1057 1575 1576 1057 1576 1058 1058 1576 1577 1064 1575 1057 1057 1058 1059 1057 1059 1064 1059 1058 1060 1058 1577 1060 1059 1060 1052 1052 1060 1061 1050 1051 1052 1052 1061 1050 1050 1580 1051 1808 1832 1833 1822 1808 1821 1822 1823 1808 1808 1823 1824 1808 1824 1825 1825 1826 1808 1808 1826 1827 1822 1797 1823 1823 1797 1798 1823 1798 1824 1824 1798 1799 1824 1799 1825 1825 1799 1800 1825 1800 1826 1826 1800 1801 1826 1801 1827 1799 1760 1800 1800 1760 1761 1800 1761 1801 1798 1759 1799 1799 1759 1760 1797 1758 1798 1798 1758 1759 1758 1077 1759 1759 1077 1076 1759 1076 1760 1760 1076 1088 1760 1088 1761 1761 1088 1093 1761 1093 1762 1801 1761 1762 1076 1087 1088 1087 1100 1088 1075 1076 1077 1075 1086 1076 1076 1086 1087 1077 1091 1075 1075 1091 1600 1600 1599 1075 1075 1599 1598 1075 1598 1086 1086 1598 1597 1086 1597 1087 1309 1597 1598 1309 1598 1312 1312 1598 1599 1312 1599 1315 1600 1315 1599 1317 1315 1600 1314 1312 1315 1314 1315 1316 1316 1315 1317 1311 1309 1312 1311 1312 1313 1313 1312 1314 1667 1313 1314 1667 1314 1646 1646 1314 1316 1316 1317 1318 1646 1316 1318 1392 1393 1646 1646 1393 1394 1646 1394 1667 1392 1198 1195 1392 1195 1393 1393 1195 1196 1393 1196 1394 1394 1196 1197 1394 1197 1395 1667 1394 1395 1395 1197 1204 1395 1204 1396 1667 1395 1396 1396 1204 1203 1396 1203 1397 1667 1396 1665 1665 1396 1397 1665 1313 1667 1310 1665 1308 1308 1665 1666 1665 1397 1666 1310 1311 1665 1665 1311 1313 1308 1309 1310 1310 1309 1311 1306 1307 1308 1308 1307 1309 1664 1306 1308 1308 1666 1664 1664 1666 1399 1666 1397 1398 1666 1398 1399 1664 1400 1663 1663 1305 1664 1664 1305 1306 1664 1399 1400 1305 1304 1306 1306 1304 1307 1303 1304 1305 1663 1303 1305 1304 1596 1307 1307 1596 1597 1087 1597 1596 1087 1596 1100 1307 1597 1309 1399 1213 1400 1398 1177 1399 1399 1177 1213 1397 1178 1398 1398 1178 1177 1397 1203 1178 1797 1757 1758 1796 1757 1797 1822 1796 1797 1756 1097 1757 1796 1756 1757 1795 1756 1796 1821 1795 1796 1821 1796 1822 1756 1108 1097 1095 1097 1107 1107 1097 1108 1107 1108 1109 1108 1113 1114 1108 1114 1109 1109 1607 1107 1107 1607 1608 1107 1608 1095 1114 1606 1109 1109 1606 1607 1113 1605 1114 1114 1605 1606 1113 1604 1605 1604 1379 1605 1605 1379 1377 1605 1377 1606 1377 1375 1606 1606 1375 1373 1606 1373 1607 1376 1375 1377 1376 1377 1378 1378 1377 1379 1378 1379 1380 1380 1379 1381 1604 1381 1379 1376 1378 1675 1675 1378 1380 1374 1375 1376 1376 1675 1374 1374 1373 1375 1372 1373 1374 1374 1675 1674 1374 1674 1372 1370 1371 1372 1372 1371 1373 1372 1674 1673 1372 1673 1370 1468 1673 1674 1468 1674 1467 1467 1674 1466 1466 1674 1675 1672 1368 1673 1469 1672 1673 1469 1673 1468 1370 1673 1368 1467 1144 1468 1468 1144 1159 1468 1159 1469 1466 1146 1467 1467 1146 1144 1142 1146 1147 1466 1147 1146 1142 1147 1148 1148 1149 1142 1142 1149 1150 1142 1150 1137 1148 1147 1466 1466 1471 1148 1148 1471 1472 1148 1472 1149 1149 1472 1473 1149 1473 1150 1150 1473 1474 1150 1474 1137 1472 1676 1473 1473 1676 1474 1471 1675 1472 1472 1675 1676 1466 1675 1471 1675 1380 1676 1676 1380 1353 1676 1353 1677 1474 1676 1677 1137 1474 1475 1474 1677 1475 1677 1353 1352 1677 1352 1678 1475 1677 1678 1137 1475 1259 1475 1476 1259 1475 1678 1476 1138 1137 1258 1258 1137 1259 1259 1262 1258 1259 1476 1477 1259 1477 1262 1477 1476 1678 1262 1477 1478 1678 1478 1477 1258 1262 1263 1478 1263 1262 1479 251 1478 1478 251 1263 1678 1479 1478 1258 1263 251 251 1261 1258 1446 1447 1258 1258 1447 1448 1258 1448 1138 1261 1446 1258 251 1260 1261 1260 1446 1261 1260 1451 1446 1632 1447 1446 1632 1446 1631 1631 1446 1451 1448 1447 1633 1633 1447 1632 1633 1632 1332 1332 1632 1631 1452 1453 1631 1631 1451 1452 1451 1245 1452 1245 1247 1452 1452 1247 1249 1452 1249 1453 1249 1251 1453 1247 1248 1249 1249 1248 1250 1249 1250 1251 1245 1246 1247 1247 1246 1248 1481 1250 1248 1481 1248 1479 1479 1248 1246 1251 1250 1252 1480 1252 1250 1480 1250 1481 1480 1481 1681 1681 1481 1479 1479 1246 251 1681 1479 1678 1245 251 1246 252 251 1245 1451 252 1245 1257 1451 1260 1257 252 1451 251 252 1257 1257 1260 251 250 249 251 250 251 252 252 251 253 248 249 250 252 464 250 248 247 249 256 466 464 256 464 257 257 464 252 464 466 745 254 256 253 253 256 257 254 466 256 253 257 252 254 468 466 745 466 468 752 364 745 745 364 366 745 366 368 745 468 752 254 467 468 752 468 467 260 467 254 260 139 467 467 139 137 467 137 469 752 467 469 260 140 139 138 137 139 138 139 140 136 137 138 469 137 136 469 136 470 470 752 469 138 141 136 136 141 470 470 141 132 470 132 471 471 751 470 470 751 752 751 362 752 752 362 364 360 361 362 362 361 363 362 363 364 751 360 362 364 363 365 364 365 366 642 365 363 642 363 644 644 363 361 360 359 361 644 361 645 361 359 645 645 49 644 644 49 48 644 48 642 645 359 357 645 357 646 646 39 645 645 39 49 358 357 359 358 359 360 356 355 357 356 357 358 646 357 355 646 355 647 647 41 646 646 41 39 354 353 355 354 355 356 355 353 647 750 354 356 356 358 750 750 358 360 750 360 751 749 354 750 751 472 750 750 472 459 750 459 749 352 353 354 749 352 354 352 351 353 647 353 351 350 351 352 352 371 350 371 352 749 647 351 648 351 350 648 350 371 372 350 372 373 648 350 373 747 372 371 747 371 748 748 371 749 373 372 374 374 372 747 373 374 375 648 373 640 640 373 375 375 374 261 261 374 376 376 374 747 640 375 638 638 375 261 638 639 640 638 261 639 261 262 263 261 376 262 62 261 263 639 261 62 640 639 61 639 62 61 50 61 62 50 62 36 62 63 36 263 63 62 52 60 61 52 61 50 61 60 640 59 58 60 59 60 52 640 60 58 640 58 648 42 57 58 42 58 59 648 58 57 52 868 59 42 59 909 59 868 909 52 866 868 909 868 866 909 910 907 909 907 42 909 866 910 865 838 866 865 866 867 867 866 52 866 838 910 907 910 911 910 838 1013 910 1013 911 838 839 840 839 838 865 840 1013 838 1012 1010 1013 840 1012 1013 911 1013 1010 907 911 908 911 1010 908 1009 908 1010 1012 1009 1010 1011 1009 1012 842 1011 1012 842 1012 840 840 839 841 840 841 842 841 847 842 847 1011 842 1007 1008 1011 1011 1008 1009 847 1007 1011 1008 904 1009 1009 904 908 907 908 904 904 905 906 904 906 907 1008 905 904 1006 902 1008 902 905 1008 1007 1006 1008 906 905 902 902 901 906 906 901 913 906 913 917 907 906 917 907 917 921 42 907 921 917 913 914 917 914 918 921 917 918 901 794 913 913 794 793 913 793 914 793 794 795 901 912 794 999 795 794 999 794 1000 794 912 1000 793 795 797 914 793 797 797 795 810 998 810 795 998 795 999 1003 998 999 1003 999 1004 1004 999 1000 1004 1000 1005 1000 912 1006 1000 1006 1005 850 1003 1004 850 1004 845 845 1004 1005 1002 998 1003 849 1002 1003 849 1003 850 841 849 850 841 850 845 845 846 841 845 1005 846 846 1005 1007 1005 1006 1007 912 903 1006 1006 903 902 903 912 901 901 902 903 846 1007 847 841 846 847 848 849 841 851 852 841 841 852 853 841 853 848 839 1035 841 841 1035 1038 841 1038 851 851 837 852 852 837 988 853 852 988 988 837 864 988 864 989 988 989 995 988 995 853 830 863 864 830 864 837 989 864 863 989 863 990 995 989 990 990 994 995 995 994 996 995 996 1001 853 995 1001 990 863 860 990 860 991 990 991 994 860 863 830 830 831 860 991 860 992 992 860 993 993 860 831 994 991 992 994 992 993 993 831 800 993 800 799 993 799 994 830 824 831 831 824 801 831 801 800 799 800 801 801 802 799 799 802 803 799 803 804 994 799 804 925 803 802 801 827 802 802 827 894 802 894 925 804 803 805 805 803 915 915 803 925 804 805 806 806 805 807 805 915 807 807 915 916 919 916 915 919 915 920 915 925 920 806 807 808 807 916 808 808 916 914 918 914 916 918 916 919 922 918 919 922 919 923 923 919 920 923 920 924 920 925 927 920 927 924 38 922 923 38 923 47 47 923 924 47 924 45 924 927 926 924 926 45 925 899 927 927 899 898 927 898 926 894 896 925 925 896 899 895 898 899 895 899 896 893 897 898 893 898 895 926 898 897 926 897 892 45 926 415 892 897 893 890 893 895 870 890 825 890 895 825 870 824 829 870 825 824 824 825 801 801 825 826 825 895 826 209 829 824 830 209 824 828 829 209 828 209 211 873 828 211 812 830 837 814 815 812 812 815 822 859 814 812 836 861 812 812 861 862 812 862 859 812 837 836 940 822 815 940 815 941 944 940 930 930 940 941 930 941 928 941 815 818 941 818 928 928 929 930 929 945 930 928 818 948 928 948 929 775 817 818 775 818 815 817 948 818 929 948 949 954 949 948 954 948 817 929 946 945 929 949 946 945 946 947 945 947 23 946 949 947 947 949 84 950 949 954 947 84 23 953 950 954 953 954 955 955 954 959 959 954 817 952 950 953 952 956 950 950 956 957 950 957 89 986 956 952 986 952 953 986 953 985 985 953 955 985 955 959 959 779 985 984 986 985 984 985 792 792 985 779 987 956 986 983 987 986 983 986 984 987 957 956 958 957 987 958 987 951 951 987 94 982 94 987 982 987 983 978 982 983 978 983 981 981 983 984 975 982 978 977 975 978 980 977 978 980 978 981 791 789 981 981 789 787 981 787 980 981 984 791 979 977 980 980 787 785 980 785 979 786 785 787 786 787 788 788 787 789 788 789 790 790 789 791 790 1022 788 788 1022 1028 788 1028 786 784 785 786 786 1028 1029 786 1029 784 784 783 785 979 785 783 781 783 784 784 1029 1030 784 1030 781 1028 1025 1029 1029 1025 1026 1029 1026 1030 1022 1024 1028 1028 1024 1025 1024 855 1025 1025 855 854 1025 854 1026 1026 854 844 1026 844 1027 1030 1026 1027 1030 1027 1031 781 1030 1031 1039 1031 1027 843 1039 1027 843 1027 844 837 843 844 844 854 837 837 854 855 837 855 856 1024 856 855 835 836 837 843 837 851 856 857 837 837 857 858 837 858 835 851 1039 843 851 1038 1039 1035 1036 1038 1038 1036 1037 1038 1037 1039 839 1033 1035 1033 1034 1035 1035 1034 1036 839 865 1033 1033 1032 1034 1033 865 964 1033 964 1032 1032 967 1034 1034 967 966 1034 966 1036 1032 969 967 1032 964 963 1032 963 969 966 967 968 968 967 969 971 972 966 966 968 971 966 972 1036 971 970 972 1036 972 970 1036 970 1037 960 970 971 1037 970 960 1037 960 1031 1039 1037 1031 960 961 962 960 971 961 1031 960 962 781 1031 782 1031 962 782 961 782 962 961 971 976 961 976 979 979 783 961 961 783 782 781 782 783 979 976 977 971 973 976 976 973 974 976 974 977 977 974 975 973 32 974 974 32 25 974 25 975 968 30 973 973 30 32 971 968 973 30 31 32 54 55 30 30 55 56 30 56 31 968 54 30 968 969 963 963 54 968 963 964 54 54 964 965 867 965 964 867 964 865 54 965 52 52 965 867 50 51 52 52 51 53 52 53 54 649 50 36 649 672 50 50 672 51 671 53 51 671 51 672 54 53 55 670 55 53 670 53 671 672 405 671 671 405 403 671 403 670 378 406 672 672 406 405 649 378 672 404 403 405 404 405 377 377 405 406 402 401 403 402 403 404 670 403 401 402 404 717 717 404 377 377 378 379 377 406 378 717 377 707 707 377 379 716 402 717 522 716 717 522 717 521 521 717 707 400 401 402 716 400 402 715 398 716 398 400 716 520 715 716 520 716 522 521 176 522 522 176 144 522 144 520 142 519 520 520 144 143 520 143 142 519 715 520 142 143 144 142 144 126 126 144 176 126 176 163 521 163 176 163 164 126 516 164 163 516 163 521 126 164 165 165 164 516 516 517 165 521 707 516 516 707 517 126 165 166 165 495 166 165 517 518 165 518 495 517 707 708 517 708 518 707 339 708 707 379 339 708 339 709 708 709 710 518 708 710 518 710 495 166 495 496 495 710 496 710 709 719 496 710 719 337 719 709 337 709 339 338 337 339 379 338 339 379 378 338 336 337 338 649 36 338 338 36 35 338 35 336 338 378 649 336 335 337 335 719 337 334 335 336 35 334 336 35 36 37 37 77 35 77 332 35 35 332 334 332 333 334 334 333 335 333 742 335 335 742 719 332 331 333 331 742 333 330 331 332 77 330 332 37 76 77 76 330 77 328 329 330 330 329 331 76 328 330 329 741 331 331 741 742 328 327 329 327 741 329 326 327 328 75 326 328 75 328 76 75 76 37 37 74 75 74 324 75 324 326 75 324 325 326 326 325 327 325 740 327 327 740 741 324 323 325 323 739 325 325 739 740 322 323 324 74 322 324 322 321 323 321 739 323 320 321 322 320 322 74 320 319 321 319 738 321 321 738 739 318 319 320 74 318 320 318 317 319 317 738 319 317 737 738 504 739 738 504 738 505 505 738 737 316 315 317 316 317 318 315 737 317 73 316 318 73 318 74 314 315 316 72 314 316 72 316 73 314 313 315 313 736 315 315 736 737 312 313 314 71 312 314 71 314 72 71 72 37 72 73 37 37 73 74 36 70 37 71 37 78 78 37 79 70 288 37 37 288 299 37 299 79 78 79 80 80 306 78 78 306 307 78 307 71 80 79 81 79 299 298 79 298 81 290 298 299 290 299 288 297 296 298 297 298 290 81 298 296 288 289 290 290 729 297 289 729 290 295 296 297 297 729 730 297 730 295 295 294 296 296 294 81 293 294 295 295 730 731 295 731 293 483 731 730 483 730 484 484 730 729 482 481 731 731 481 733 731 733 293 482 731 483 160 482 483 160 483 157 157 483 484 157 484 179 179 484 485 484 729 485 157 179 158 158 179 180 179 485 180 180 485 486 729 486 485 743 487 729 729 487 486 287 743 729 287 729 289 180 486 181 181 486 487 158 180 181 181 184 158 181 487 184 184 487 488 488 487 728 728 487 743 728 743 287 287 285 728 728 285 283 728 283 280 280 727 728 728 727 489 728 489 488 184 488 185 185 488 489 158 184 185 158 185 186 187 189 185 185 189 192 185 192 186 185 489 187 187 489 490 727 490 489 187 188 189 187 490 188 188 490 491 727 491 490 189 188 190 188 491 190 190 491 492 721 492 491 721 491 727 189 190 191 190 492 191 191 492 493 720 493 492 720 492 721 191 493 189 189 493 494 494 493 720 272 720 721 722 494 720 722 720 270 270 720 272 189 494 192 192 494 454 454 494 722 192 454 186 454 455 158 186 454 158 454 722 455 158 455 159 159 455 479 455 722 726 455 726 479 157 158 159 159 173 157 159 479 173 173 479 480 479 726 723 479 723 480 157 173 174 456 457 173 457 174 173 173 480 456 480 723 725 480 725 456 723 724 725 724 723 262 262 723 726 724 376 725 456 725 457 457 725 746 725 376 746 478 175 457 457 175 174 457 746 478 157 174 175 175 182 157 478 182 175 477 182 478 746 747 478 747 477 478 746 376 747 724 262 376 263 262 264 262 726 264 263 264 265 265 64 263 263 64 63 265 264 266 726 266 264 722 268 726 726 268 266 265 266 267 267 266 268 265 267 64 267 268 269 64 267 269 269 268 270 270 268 722 269 270 271 64 269 65 65 269 271 271 270 272 271 272 273 65 271 66 66 271 273 36 64 65 65 66 36 36 66 67 66 273 67 273 272 274 273 274 275 67 273 275 721 274 272 275 274 276 721 276 274 275 276 277 275 277 67 36 67 68 67 277 279 67 279 68 277 276 278 277 278 279 727 278 276 727 276 721 279 278 280 280 278 727 279 280 281 68 279 281 68 69 36 68 281 69 281 280 282 69 281 282 282 280 283 282 283 284 69 282 70 70 282 284 36 69 70 36 63 64 284 286 70 70 286 288 284 283 285 284 285 286 286 285 287 286 287 288 288 287 289 748 476 747 747 476 477 474 475 748 748 475 476 748 749 474 475 162 476 476 162 183 476 183 477 477 183 182 157 182 183 157 183 162 161 157 162 475 161 162 474 161 475 126 157 161 474 126 161 126 160 157 156 160 126 156 482 160 126 155 156 155 481 156 156 481 482 126 154 155 154 514 155 155 514 515 155 515 481 481 515 733 733 515 514 154 513 514 733 514 732 732 514 513 153 154 126 153 513 154 153 512 513 732 513 734 734 513 512 126 152 153 152 512 153 152 511 512 734 512 735 735 512 511 303 732 734 303 734 305 305 734 735 305 735 308 308 735 718 718 735 510 735 511 510 151 510 511 151 511 152 126 151 152 150 151 126 150 510 151 150 509 510 718 510 509 126 149 150 149 509 150 149 508 509 718 509 508 126 148 149 148 508 149 148 507 508 736 718 508 736 508 737 737 508 507 145 148 126 145 507 148 145 506 507 737 507 506 505 737 506 146 505 506 146 506 145 145 126 146 146 126 147 147 505 146 147 504 505 126 178 147 178 504 147 178 503 504 503 739 504 126 177 178 177 503 178 177 502 503 502 739 503 502 740 739 172 501 502 172 502 177 501 740 502 172 177 126 126 171 172 171 501 172 171 500 501 500 741 501 501 741 740 126 170 171 170 500 171 170 499 500 499 742 500 500 742 741 169 170 126 169 499 170 169 498 499 498 742 499 497 719 742 497 742 498 168 497 498 168 498 169 126 168 169 126 167 168 167 497 168 167 496 497 496 719 497 166 167 126 166 496 167 125 126 127 127 126 128 126 125 142 458 128 126 458 126 474 127 519 125 125 519 142 127 525 519 519 525 715 124 524 525 124 525 127 715 525 524 715 524 714 714 396 715 715 396 398 523 524 124 714 524 523 713 392 714 714 523 713 392 394 714 714 394 396 394 395 396 396 395 397 396 397 398 398 397 399 398 399 400 663 397 395 663 399 397 400 399 401 663 401 399 395 669 663 669 56 663 663 56 55 663 55 670 670 401 663 395 667 669 667 31 669 669 31 56 393 391 667 393 667 395 392 391 393 392 393 394 394 393 395 390 391 392 713 390 392 713 523 526 713 526 530 124 135 523 523 135 134 523 134 526 123 134 135 123 135 124 122 123 124 127 128 124 124 128 129 124 129 122 129 459 122 122 459 472 122 472 123 458 459 129 129 128 458 749 459 458 749 458 474 133 134 123 471 133 123 123 472 473 123 473 471 751 473 472 471 473 751 471 132 133 132 131 133 133 131 134 130 131 132 130 132 138 138 132 141 526 134 131 130 526 131 138 526 130 140 530 138 138 530 526 736 313 311 311 718 736 312 311 313 309 310 311 309 311 312 311 310 718 718 310 308 308 310 309 307 308 309 71 307 309 309 312 71 307 305 308 306 305 307 304 303 305 304 305 306 80 304 306 302 303 304 82 302 304 82 304 80 302 301 303 301 732 303 292 301 302 292 302 82 80 81 82 81 292 82 291 292 293 293 292 294 291 300 292 292 300 301 81 294 292 301 300 732 732 300 291 732 291 733 293 733 291 1019 836 835 1019 835 858 1018 861 1019 1019 861 836 1021 1018 1019 1019 858 1021 1021 858 857 1014 1017 1021 1021 1017 1018 1021 857 1023 1014 1021 1020 1020 1021 1023 1017 862 1018 1018 862 861 1014 859 1017 1017 859 862 1014 1015 859 1020 1015 1014 859 1015 814 814 1015 1016 1016 1015 1020 814 776 815 814 1016 776 1020 776 1016 775 776 777 777 776 778 815 776 775 1020 778 776 816 817 775 816 775 777 777 778 779 816 777 959 959 777 779 779 778 780 1022 780 778 1022 778 1020 780 792 779 790 791 780 780 791 792 790 780 1022 1020 1023 1022 1022 1023 1024 1023 857 856 1023 856 1024 791 984 792 959 817 816 951 94 91 951 91 89 89 958 951 89 957 958 801 826 827 827 826 894 894 826 895 894 895 896 414 45 415 415 418 414 43 45 414 632 414 418 632 637 414 414 637 43 43 44 45 45 44 46 45 46 47 641 44 43 641 43 637 643 46 44 643 44 641 47 46 48 642 48 46 642 46 643 47 48 38 38 48 49 38 39 40 38 49 39 40 922 38 40 39 41 40 41 42 42 921 40 40 921 922 921 918 922 41 57 42 647 57 41 648 57 647 369 642 643 369 643 641 367 642 369 367 365 642 366 365 367 366 367 368 368 367 369 368 369 347 349 348 347 347 369 370 347 370 349 348 349 633 633 349 637 370 637 349 348 633 634 634 633 632 633 637 632 370 641 637 369 641 370 632 418 634 808 914 796 796 914 797 796 798 808 808 798 809 808 809 806 796 797 798 797 810 798 997 809 798 997 798 998 798 810 998 806 809 997 996 804 806 996 806 997 1001 996 997 1001 997 1002 1002 997 998 994 804 996 848 1001 1002 848 1002 849 853 1001 848 1390 1681 1678 1390 1678 1352 1351 1389 1390 1351 1390 1352 1389 1681 1390 1679 1480 1681 1389 1679 1681 1387 1388 1389 1387 1389 1351 1388 1679 1389 1351 1352 1353 1353 1382 1351 1604 1351 1382 1380 1381 1353 1353 1381 1382 1382 1381 1604 1486 1388 1387 1387 1487 1486 1486 1487 1488 1622 1488 1487 1621 1488 1622 1633 1332 1334 1366 1367 1368 1368 1367 1369 1368 1369 1370 1672 1366 1368 1366 1365 1367 1369 1367 1608 1608 1367 1365 1370 1369 1371 1608 1371 1369 1607 1371 1608 1607 1373 1371 1820 1795 1821 1821 1814 1820 1819 1794 1820 1820 1794 1795 1820 1814 1819 1814 1782 1815 1814 1818 1819 1814 1815 1818 1463 1182 1181 195 219 193 550 193 219 550 219 551 219 609 610 219 610 611 611 612 219 219 612 613 219 613 551 613 689 551 689 550 551 612 688 613 613 688 689 611 687 612 612 687 688 610 686 611 611 686 687 686 573 687 573 574 687 687 574 577 687 577 688 568 571 686 686 571 573 571 572 573 573 572 574 572 575 574 574 575 576 574 576 577 654 576 575 690 550 689 548 549 690 690 549 550 690 547 548 549 193 550 548 194 549 549 194 193 547 226 548 548 226 194 193 194 195 195 194 201 204 194 226 194 227 201 231 195 933 933 195 201 932 933 201 932 201 227 3 231 933 3 933 5 2 3 4 4 3 5 1698 1696 1700 1224 1223 1698 1224 1698 1718 1223 1224 1225 1718 1225 1224 1223 1225 1220 1220 1225 1238 1218 1219 1220 1220 1238 1218 1456 1220 1457 1232 212 1219 1219 1244 1232 212 1232 1624 1232 1244 1624 212 1624 1549 1629 1456 1457 24 650 651))
                   (list :vertices (let ((mat (make-matrix 1834 3))) (fvector-replace (array-entity mat) #f(1.4437500000000000e+02 -1.2820799255371094e+02 -5.4500299072265625e+02 1.4437500000000000e+02 -1.0832199859619141e+02 -5.4500299072265625e+02 1.4390400695800781e+02 -1.2820799255371094e+02 -5.3782397460937500e+02 1.4339199829101562e+02 -1.0853099822998047e+02 -5.3465399169921875e+02 1.4250099182128906e+02 -1.2820799255371094e+02 -5.3076800537109375e+02 1.4211698913574219e+02 -1.0860600280761719e+02 -5.3089794921875000e+02 1.4018798828125000e+02 -1.2820799255371094e+02 -5.2395501708984375e+02 1.3852099609375000e+02 -1.0881999969482422e+02 -5.2030999755859375e+02 1.3700599670410156e+02 -1.2820799255371094e+02 -5.1750305175781250e+02 1.3672000122070312e+02 -1.0887300109863281e+02 -5.1770001220703125e+02 1.3300900268554688e+02 -1.2820799255371094e+02 -5.1152099609375000e+02 1.2992001342773438e+02 -1.0907199859619141e+02 -5.0783996582031250e+02 1.2826600646972656e+02 -1.2820799255371094e+02 -5.0611196899414062e+02 1.2808898925781250e+02 -1.0910200500488281e+02 -5.0632601928710938e+02 1.2285699462890625e+02 -1.2820799255371094e+02 -5.0136798095703125e+02 1.1824499511718750e+02 -1.0926699829101562e+02 -4.9818899536132812e+02 1.1687500000000000e+02 -1.2820799255371094e+02 -4.9737200927734375e+02 1.1679600524902344e+02 -1.0927899932861328e+02 -4.9755200195312500e+02 1.1042299652099609e+02 -1.2820799255371094e+02 -4.9418899536132812e+02 1.0437899780273438e+02 -1.0938999938964844e+02 -4.9208898925781250e+02 1.0361000061035156e+02 -1.2820799255371094e+02 -4.9187698364257812e+02 1.0359600067138672e+02 -1.0939200592041016e+02 -4.9197998046875000e+02 9.6553901672363281e+01 -1.2820799255371094e+02 -4.9047299194335938e+02 8.9375000000000000e+01 -1.0943199920654297e+02 -4.9000299072265625e+02 8.9375000000000000e+01 -1.2820799255371094e+02 -4.9000299072265625e+02 -5.8726299285888672e+01 -1.0736100006103516e+02 -5.0154501342773438e+02 -5.5779300689697266e+01 -1.2716600036621094e+02 -5.0047302246093750e+02 -5.1867801666259766e+01 -1.0878899383544922e+02 -4.9904901123046875e+02 -5.2899101257324219e+01 -1.2762899780273438e+02 -4.9942401123046875e+02 -5.1867801666259766e+01 -1.2776200103759766e+02 -4.9904901123046875e+02 -7.1494804382324219e+01 -1.0241300201416016e+02 -5.0619299316406250e+02 -7.6739196777343750e+01 -1.1989600372314453e+02 -5.0810098266601562e+02 -6.5745101928710938e+01 -1.0498200225830078e+02 -5.0410003662109375e+02 -6.9750999450683594e+01 -1.2304399871826172e+02 -5.0555801391601562e+02 -6.2773601531982422e+01 -1.2548300933837891e+02 -5.0301803588867188e+02 -1.3056700134277344e+02 -8.1984001159667969e+01 -5.2769299316406250e+02 -1.2324400329589844e+02 -8.7996803283691406e+01 -5.2502801513671875e+02 -1.6396499633789062e+02 2.6484399795532227e+01 -5.3984899902343750e+02 -6.5745101928710938e+01 1.0498200225830078e+02 -5.0410003662109375e+02 -7.6773300170898438e+01 1.1987899780273438e+02 -5.0811398315429688e+02 -7.1494804382324219e+01 1.0241300201416016e+02 -5.0619299316406250e+02 -8.0258506774902344e+01 1.1806699371337891e+02 -5.0938201904296875e+02 -8.0465194702148438e+01 9.7474594116210938e+01 -5.0945800781250000e+02 -5.1867801666259766e+01 1.2776200103759766e+02 -4.9904901123046875e+02 -5.3081501007080078e+01 1.2760399627685547e+02 -4.9949099731445312e+02 -5.1867801666259766e+01 1.0878899383544922e+02 -4.9904901123046875e+02 -5.5798400878906250e+01 1.2716199493408203e+02 -5.0048001098632812e+02 -5.8726299285888672e+01 1.0736100006103516e+02 -5.0154501342773438e+02 -6.2797599792480469e+01 1.2547600555419922e+02 -5.0302700805664062e+02 -6.9780097961425781e+01 1.2303200531005859e+02 -5.0556896972656250e+02 -1.2323200225830078e+02 -8.8005805969238281e+01 -5.2502398681640625e+02 -1.0632400512695312e+02 -1.0084199523925781e+02 -5.1886895751953125e+02 -9.0763702392578125e+01 -9.0742904663085938e+01 -5.1320599365234375e+02 -9.8162399291992188e+01 -1.0676599884033203e+02 -5.1589898681640625e+02 -8.0465194702148438e+01 -9.7474594116210938e+01 -5.0945800781250000e+02 -8.9116996765136719e+01 -1.1284200286865234e+02 -5.1260699462890625e+02 -8.0347000122070312e+01 -1.1801899719238281e+02 -5.0941497802734375e+02 -8.9030303955078125e+01 1.1289700317382812e+02 -5.1257495117187500e+02 -9.8076995849609375e+01 1.0682599639892578e+02 -5.1586798095703125e+02 -9.0763702392578125e+01 9.0742904663085938e+01 -5.1320599365234375e+02 -1.0633700561523438e+02 1.0083100128173828e+02 -5.1887396240234375e+02 -1.2323200225830078e+02 8.8005805969238281e+01 -5.2502398681640625e+02 -1.2324400329589844e+02 8.7996803283691406e+01 -5.2502801513671875e+02 -1.2721399688720703e+02 8.4868400573730469e+01 -5.2647296142578125e+02 -1.3411700439453125e+02 7.8659698486328125e+01 -5.2898504638671875e+02 -1.4047599792480469e+02 7.1886894226074219e+01 -5.3129998779296875e+02 -1.4627499389648438e+02 6.4556503295898438e+01 -5.3341003417968750e+02 -1.5016700744628906e+02 5.8809398651123047e+01 -5.3482696533203125e+02 -1.5474499511718750e+02 5.0852298736572266e+01 -5.3649298095703125e+02 -1.5864900207519531e+02 4.2529197692871094e+01 -5.3791400146484375e+02 -1.6186499023437500e+02 3.3846603393554688e+01 -5.3908496093750000e+02 -1.6364700317382812e+02 -2.7736600875854492e+01 -5.3973297119140625e+02 -1.6097100830078125e+02 -3.6498600006103516e+01 -5.3875897216796875e+02 -1.5773800659179688e+02 -4.4642002105712891e+01 -5.3758197021484375e+02 -1.5369898986816406e+02 -5.2811203002929688e+01 -5.3611303710937500e+02 -1.4899600219726562e+02 -6.0623199462890625e+01 -5.3440100097656250e+02 -1.4362899780273438e+02 -6.8060897827148438e+01 -5.3244696044921875e+02 -1.3716999816894531e+02 -7.5550300598144531e+01 -5.3009600830078125e+02 -1.6557400512695312e+02 -1.8846200942993164e+01 -5.4043499755859375e+02 -1.6578898620605469e+02 1.7565099716186523e+01 -5.4051300048828125e+02 -1.6675900268554688e+02 -9.8441801071166992e+00 -5.4086602783203125e+02 -1.6687100219726562e+02 8.5071296691894531e+00 -5.4090704345703125e+02 -1.6719799804687500e+02 -6.8146604299545288e-01 -5.4102600097656250e+02 -5.6474101543426514e-01 -1.2820799255371094e+02 -4.9000299072265625e+02 -5.6474101543426514e-01 -1.0943199920654297e+02 -4.9000299072265625e+02 -1.7963500976562500e+01 -1.0940699768066406e+02 -4.9123199462890625e+02 -1.7978700637817383e+01 -1.2820799255371094e+02 -4.9101702880859375e+02 -2.1648601531982422e+01 -1.0940100097656250e+02 -4.9149200439453125e+02 -3.5157100677490234e+01 -1.2820799255371094e+02 -4.9404598999023438e+02 -3.5044700622558594e+01 -1.0933799743652344e+02 -4.9454000854492188e+02 -4.3107101440429688e+01 -1.2820799255371094e+02 -4.9616198730468750e+02 -4.5810699462890625e+01 -1.0928800201416016e+02 -4.9698999023437500e+02 -4.5877899169921875e+01 -1.2818099975585938e+02 -4.9701101684570312e+02 -4.8628799438476562e+01 -1.2805099487304688e+02 -4.9791198730468750e+02 -4.8835502624511719e+01 -1.0912300109863281e+02 -4.9798199462890625e+02 -5.1355400085449219e+01 -1.2781800079345703e+02 -4.9886398315429688e+02 -5.1708400726318359e+01 -1.2778100585937500e+02 -4.9899102783203125e+02 8.9375000000000000e+01 1.2820799255371094e+02 -4.9000299072265625e+02 8.9375000000000000e+01 1.0943199920654297e+02 -4.9000299072265625e+02 9.6553901672363281e+01 1.2820799255371094e+02 -4.9047299194335938e+02 1.0027500152587891e+02 1.0941000366210938e+02 -4.9109399414062500e+02 1.0361000061035156e+02 1.2820799255371094e+02 -4.9187698364257812e+02 1.0348899841308594e+02 1.0938700103759766e+02 -4.9222201538085938e+02 1.1042299652099609e+02 1.2820799255371094e+02 -4.9418899536132812e+02 1.1456800079345703e+02 1.0930900573730469e+02 -4.9611199951171875e+02 1.1687500000000000e+02 1.2820799255371094e+02 -4.9737200927734375e+02 1.1670199584960938e+02 1.0927799987792969e+02 -4.9761599731445312e+02 1.2285699462890625e+02 1.2820799255371094e+02 -5.0136798095703125e+02 1.2694999694824219e+02 1.0913199615478516e+02 -5.0483898925781250e+02 1.2826600646972656e+02 1.2820799255371094e+02 -5.0611196899414062e+02 1.2809300231933594e+02 1.0910399627685547e+02 -5.0625198364257812e+02 1.3300900268554688e+02 1.2820799255371094e+02 -5.1152099609375000e+02 1.3648100280761719e+02 1.0889499664306641e+02 -5.1661303710937500e+02 1.3700599670410156e+02 1.2820799255371094e+02 -5.1750305175781250e+02 1.3688400268554688e+02 1.0887599945068359e+02 -5.1755499267578125e+02 1.4018798828125000e+02 1.2820799255371094e+02 -5.2395501708984375e+02 1.4243899536132812e+02 1.0861399841308594e+02 -5.3053997802734375e+02 1.4250099182128906e+02 1.2820799255371094e+02 -5.3076800537109375e+02 1.4247000122070312e+02 1.0860900115966797e+02 -5.3077197265625000e+02 1.4390400695800781e+02 1.2820799255371094e+02 -5.3782397460937500e+02 1.4437500000000000e+02 1.0832199859619141e+02 -5.4500299072265625e+02 1.4437500000000000e+02 1.2820799255371094e+02 -5.4500299072265625e+02 -7.2838500976562500e+01 1.3615599060058594e+02 -5.6266802978515625e+02 -6.8124000549316406e+01 1.3794400024414062e+02 -5.6190997314453125e+02 -7.2176704406738281e+01 -1.3638400268554688e+02 -5.6253997802734375e+02 -8.4612899780273438e+01 -1.3039801025390625e+02 -5.6339996337890625e+02 -8.4612899780273438e+01 1.3039801025390625e+02 -5.6339996337890625e+02 -7.7685295104980469e+01 -1.3397898864746094e+02 -5.6314703369140625e+02 -8.0288497924804688e+01 1.3268899536132812e+02 -5.6330200195312500e+02 -7.8185501098632812e+01 1.3366799926757812e+02 -5.6312298583984375e+02 -5.9728801727294922e+01 -1.4058000183105469e+02 -5.6008294677734375e+02 -6.3789600372314453e+01 -1.3944599914550781e+02 -5.6108996582031250e+02 -6.5947799682617188e+01 1.3874299621582031e+02 -5.6153704833984375e+02 -6.6242393493652344e+01 1.3865699768066406e+02 -5.6160699462890625e+02 -6.8127700805664062e+01 -1.3792599487304688e+02 -5.6189599609375000e+02 -7.0749000549316406e+01 -1.3700799560546875e+02 -5.6238299560546875e+02 -5.9172000885009766e+01 1.4072000122070312e+02 -5.5993005371093750e+02 -5.3183200836181641e+01 1.4190899658203125e+02 -5.5801098632812500e+02 -5.9667098999023438e+01 -1.4059199523925781e+02 -5.6006402587890625e+02 -5.2121097564697266e+01 1.4212001037597656e+02 -5.5767102050781250e+02 -5.2121097564697266e+01 -1.4212001037597656e+02 -5.5767102050781250e+02 -5.9663200378417969e+01 1.4057699584960938e+02 -5.6004699707031250e+02 -8.5030502319335938e+01 -1.3016600036621094e+02 -5.6339996337890625e+02 -8.5914497375488281e+01 -1.2967599487304688e+02 -5.6339996337890625e+02 -9.5328498840332031e+01 -1.2389499664306641e+02 -5.6339996337890625e+02 -1.7055700683593750e+02 -4.2505302429199219e+01 -5.6339996337890625e+02 -1.6679499816894531e+02 -5.1759899139404297e+01 -5.6339996337890625e+02 -1.6391999816894531e+02 -5.7442501068115234e+01 -5.6339996337890625e+02 -1.7067300415039062e+02 -4.2218700408935547e+01 -5.6339996337890625e+02 -1.7377301025390625e+02 -3.2310401916503906e+01 -5.6339996337890625e+02 -1.7499299621582031e+02 -2.6777299880981445e+01 -5.6339996337890625e+02 -1.7617799377441406e+02 -2.1398500442504883e+01 -5.6339996337890625e+02 -1.7752000427246094e+02 -1.1216300010681152e+01 -5.6339996337890625e+02 -1.7754800415039062e+02 -1.0640200614929199e+01 -5.6339996337890625e+02 -1.7802200317382812e+02 -9.2909896373748779e-01 -5.6339996337890625e+02 -1.7779499816894531e+02 5.6986198425292969e+00 -5.6339996337890625e+02 -1.7766700744628906e+02 9.4468002319335938e+00 -5.6339996337890625e+02 -1.7603099060058594e+02 2.1940799713134766e+01 -5.6339996337890625e+02 -1.3793000793457031e+02 9.1572296142578125e+01 -5.6339996337890625e+02 -1.3265299987792969e+02 9.6308403015136719e+01 -5.6339996337890625e+02 -1.7632499694824219e+02 2.0539300918579102e+01 -5.6339996337890625e+02 -9.0407295227050781e+01 1.2691499328613281e+02 -5.6339996337890625e+02 -9.4171394348144531e+01 1.2465299987792969e+02 -5.6339996337890625e+02 -1.0531099700927734e+02 -1.1704000091552734e+02 -5.6339996337890625e+02 -1.1582899475097656e+02 -1.0924900054931641e+02 -5.6339996337890625e+02 -1.2114099884033203e+02 -1.0520099639892578e+02 -5.6339996337890625e+02 -1.2716600036621094e+02 -1.0060800170898438e+02 -5.6339996337890625e+02 -1.3414900207519531e+02 -9.4957099914550781e+01 -5.6339996337890625e+02 -1.3578799438476562e+02 -9.3631500244140625e+01 -5.6339996337890625e+02 -1.4323300170898438e+02 -8.6490600585937500e+01 -5.6339996337890625e+02 -1.4526799011230469e+02 -8.4186096191406250e+01 -5.6339996337890625e+02 -1.5006500244140625e+02 -7.8756698608398438e+01 -5.6339996337890625e+02 -1.5551100158691406e+02 -7.1451698303222656e+01 -5.6339996337890625e+02 -1.2529199981689453e+02 1.0202600097656250e+02 -5.6339996337890625e+02 -1.2435100555419922e+02 1.0275600433349609e+02 -5.6339996337890625e+02 -1.1519899749755859e+02 1.0972499847412109e+02 -5.6339996337890625e+02 -9.9447196960449219e+01 -1.2106700134277344e+02 -5.6339996337890625e+02 -1.5627700805664062e+02 -7.0424499511718750e+01 -5.6339996337890625e+02 -1.6215899658203125e+02 -6.0923599243164062e+01 -5.6339996337890625e+02 -1.7422099304199219e+02 3.0591800689697266e+01 -5.6339996337890625e+02 -1.7207899475097656e+02 3.7801399230957031e+01 -5.6339996337890625e+02 -1.7128799438476562e+02 4.0464900970458984e+01 -5.6339996337890625e+02 -1.0513299560546875e+02 1.1716699981689453e+02 -5.6339996337890625e+02 -1.0312999725341797e+02 1.1853499603271484e+02 -5.6339996337890625e+02 -1.6752000427246094e+02 5.0138599395751953e+01 -5.6339996337890625e+02 -1.6610600280761719e+02 5.3006599426269531e+01 -5.6339996337890625e+02 -1.4030000305175781e+02 8.9445999145507812e+01 -5.6339996337890625e+02 -1.6258099365234375e+02 6.0161899566650391e+01 -5.6339996337890625e+02 -1.5824600219726562e+02 6.7333305358886719e+01 -5.6339996337890625e+02 -1.4916299438476562e+02 7.9710197448730469e+01 -5.6339996337890625e+02 -1.5726800537109375e+02 6.8951004028320312e+01 -5.6339996337890625e+02 -1.5123300170898438e+02 7.7296897888183594e+01 -5.6339996337890625e+02 -1.4447499084472656e+02 8.5177696228027344e+01 -5.6339996337890625e+02 6.9844902038574219e+01 -1.4300000000000000e+02 -5.4500299072265625e+02 5.1316200256347656e+01 -1.4300000000000000e+02 -5.4500299072265625e+02 1.4419700622558594e+02 -1.0756699371337891e+02 -5.4500299072265625e+02 1.3344400024414062e+02 1.4243600463867188e+02 -5.4500299072265625e+02 1.3470500183105469e+02 1.4177400207519531e+02 -5.4500299072265625e+02 1.4313000488281250e+02 1.0650000000000000e+02 -5.4500299072265625e+02 1.4426199340820312e+02 1.0766000366210938e+02 -5.4500299072265625e+02 1.4420899963378906e+02 1.0756400299072266e+02 -5.4500299072265625e+02 1.4407099914550781e+02 -1.0726100158691406e+02 -5.4500299072265625e+02 1.7304899215698242e+01 -1.4300000000000000e+02 -5.4500299072265625e+02 1.7684299945831299e+00 -1.4300000000000000e+02 -5.4500299072265625e+02 3.3375000000000000e+01 -1.0632099914550781e+02 -5.4500299072265625e+02 -5.6474101543426514e-01 -1.4300000000000000e+02 -5.4500299072265625e+02 3.3375000000000000e+01 1.0632099914550781e+02 -5.4500299072265625e+02 -5.6474101543426514e-01 1.4300000000000000e+02 -5.4500299072265625e+02 3.5414600372314453e+01 1.4300000000000000e+02 -5.4500299072265625e+02 1.4237500000000000e+02 1.0632099914550781e+02 -5.4500299072265625e+02 8.9375000000000000e+01 1.4300000000000000e+02 -5.4500299072265625e+02 1.4281399536132812e+02 1.0637000274658203e+02 -5.4500299072265625e+02 1.3013101196289062e+02 1.4300000000000000e+02 -5.4500299072265625e+02 1.3301600646972656e+02 1.4257499694824219e+02 -5.4500299072265625e+02 1.4237500000000000e+02 -1.0632099914550781e+02 -5.4500299072265625e+02 1.4303700256347656e+02 -1.0643400573730469e+02 -5.4500299072265625e+02 1.4313299560546875e+02 -1.0648699951171875e+02 -5.4500299072265625e+02 1.3294599914550781e+02 -1.4259600830078125e+02 -5.4500299072265625e+02 1.3013101196289062e+02 -1.4300000000000000e+02 -5.4500299072265625e+02 8.9375000000000000e+01 -1.4300000000000000e+02 -5.4500299072265625e+02 1.4343499755859375e+02 1.0662500000000000e+02 -5.4500299072265625e+02 1.4393701171875000e+02 1.0707200622558594e+02 -5.4500299072265625e+02 1.3602600097656250e+02 1.4107899475097656e+02 -5.4500299072265625e+02 1.3638400268554688e+02 1.4080599975585938e+02 -5.4500299072265625e+02 1.4328999328613281e+02 1.3164999389648438e+02 -5.4500299072265625e+02 1.4409700012207031e+02 1.3001200866699219e+02 -5.4500299072265625e+02 3.3799201965332031e+01 -1.4300000000000000e+02 -5.4500299072265625e+02 1.4362399291992188e+02 -1.0676000213623047e+02 -5.4500299072265625e+02 1.3632899475097656e+02 -1.4084999084472656e+02 -5.4500299072265625e+02 1.3596899414062500e+02 -1.4112100219726562e+02 -5.4500299072265625e+02 1.3470600891113281e+02 -1.4177299499511719e+02 -5.4500299072265625e+02 1.4432600402832031e+02 -1.0788200378417969e+02 -5.4500299072265625e+02 1.3337699890136719e+02 -1.4245899963378906e+02 -5.4500299072265625e+02 1.3833200073242188e+02 1.3873001098632812e+02 -5.4500299072265625e+02 1.4328999328613281e+02 -1.3164999389648438e+02 -5.4500299072265625e+02 1.3833200073242188e+02 -1.3873001098632812e+02 -5.4500299072265625e+02 -2.7956199645996094e+00 1.4300000000000000e+02 -5.4510894775390625e+02 -4.2159399986267090e+00 -1.4300000000000000e+02 -5.4507299804687500e+02 -6.7350702285766602e+00 -1.4300000000000000e+02 -5.4520294189453125e+02 -9.6085500717163086e+00 1.4300000000000000e+02 -5.4543402099609375e+02 -9.4351596832275391e+00 -1.4300000000000000e+02 -5.4550805664062500e+02 -1.5082499504089355e+01 1.4300000000000000e+02 -5.4622003173828125e+02 -1.5649498939514160e+01 -1.4300000000000000e+02 -5.4620800781250000e+02 -1.7053098678588867e+01 1.4300000000000000e+02 -5.4650299072265625e+02 -1.7049699783325195e+01 -1.4300000000000000e+02 -5.4650201416015625e+02 -1.8493200302124023e+01 1.4300000000000000e+02 -5.4671002197265625e+02 -2.2612699508666992e+01 -1.4300000000000000e+02 -5.4766796875000000e+02 -2.4430398941040039e+01 -1.4300000000000000e+02 -5.4804895019531250e+02 -2.7073501586914062e+01 1.4300000000000000e+02 -5.4878302001953125e+02 -2.8701999664306641e+01 -1.4300000000000000e+02 -5.4937799072265625e+02 -2.7201000213623047e+01 1.4300000000000000e+02 -5.4881298828125000e+02 -3.3056697845458984e+01 -1.4300000000000000e+02 -5.5073199462890625e+02 -3.3056697845458984e+01 1.4300000000000000e+02 -5.5073199462890625e+02 -3.5294300079345703e+01 -1.4298699951171875e+02 -5.5154699707031250e+02 -4.5977901458740234e+01 1.4270399475097656e+02 -5.5543499755859375e+02 -4.1710201263427734e+01 -1.4295199584960938e+02 -5.5388201904296875e+02 -4.1714298248291016e+01 1.4298899841308594e+02 -5.5388299560546875e+02 -3.9155403137207031e+01 1.4299200439453125e+02 -5.5295196533203125e+02 -4.3489799499511719e+01 -1.4294200134277344e+02 -5.5452899169921875e+02 -4.8152500152587891e+01 -1.4249800109863281e+02 -5.5622705078125000e+02 -4.9587100982666016e+01 1.4246299743652344e+02 -5.5674896240234375e+02 -1.2448899841308594e+02 9.0203201293945312e+01 -5.2616400146484375e+02 -1.2673500061035156e+02 9.5092994689941406e+01 -5.3020605468750000e+02 -1.2853099060058594e+02 8.6964401245117188e+01 -5.2760998535156250e+02 -1.3442300415039062e+02 8.8797500610351562e+01 -5.3286199951171875e+02 -1.3434100341796875e+02 8.1657402038574219e+01 -5.2968902587890625e+02 -1.3715800476074219e+02 8.6155700683593750e+01 -5.3380700683593750e+02 -1.3555300903320312e+02 8.0550094604492188e+01 -5.3012298583984375e+02 -1.4134100341796875e+02 8.2114700317382812e+01 -5.3525299072265625e+02 -1.4201399230957031e+02 7.3569999694824219e+01 -5.3243499755859375e+02 -1.4655599975585938e+02 7.6139801025390625e+01 -5.3705401611328125e+02 -1.4317298889160156e+02 7.2085205078125000e+01 -5.3285003662109375e+02 -1.4832598876953125e+02 7.4111602783203125e+01 -5.3766503906250000e+02 -1.4789900207519531e+02 6.6030899047851562e+01 -5.3454205322265625e+02 -1.5395500183105469e+02 6.6436203002929688e+01 -5.3960803222656250e+02 -1.5087400817871094e+02 6.1582099914550781e+01 -5.3560699462890625e+02 -1.5476701354980469e+02 6.5121200561523438e+01 -5.3988702392578125e+02 -1.5184498596191406e+02 6.0129501342773438e+01 -5.3595501708984375e+02 -1.5892100524902344e+02 5.8390098571777344e+01 -5.4132000732421875e+02 -1.5648199462890625e+02 5.1970096588134766e+01 -5.3761499023437500e+02 -1.6159400939941406e+02 5.3171897888183594e+01 -5.4224200439453125e+02 -1.5727900695800781e+02 5.0250900268554688e+01 -5.3790100097656250e+02 -1.6043299865722656e+02 4.3446800231933594e+01 -5.3903100585937500e+02 -1.6322499084472656e+02 4.9988998413085938e+01 -5.4280297851562500e+02 -1.6233200073242188e+02 3.8258998870849609e+01 -5.3971099853515625e+02 -1.6711000061035156e+02 4.0558498382568359e+01 -5.4414202880859375e+02 -1.6368499755859375e+02 3.4565399169921875e+01 -5.4019598388671875e+02 -1.6711700439453125e+02 4.0540798187255859e+01 -5.4414398193359375e+02 -1.6580699157714844e+02 2.7040901184082031e+01 -5.4095599365234375e+02 -1.6999099731445312e+02 3.1505599975585938e+01 -5.4513403320312500e+02 -1.7096299743652344e+02 2.7326999664306641e+01 -5.4546795654296875e+02 -1.7418199157714844e+02 3.6710500717163086e+00 -5.4657696533203125e+02 -1.6904699707031250e+02 -1.0623699054121971e-03 -5.4211804199218750e+02 -1.7352000427246094e+02 1.3059000015258789e+01 -5.4634899902343750e+02 -1.6874099731445312e+02 8.6831998825073242e+00 -5.4200799560546875e+02 -1.7341400146484375e+02 1.3764699935913086e+01 -5.4631195068359375e+02 -1.6823400878906250e+02 1.2977699279785156e+01 -5.4182598876953125e+02 -1.7212200927734375e+02 2.2340499877929688e+01 -5.4586798095703125e+02 -1.6764900207519531e+02 1.7930799484252930e+01 -5.4161700439453125e+02 -1.6605799865722656e+02 2.5801399230957031e+01 -5.4104602050781250e+02 -1.7421400451660156e+02 2.4324600696563721e+00 -5.4658801269531250e+02 -1.7416700744628906e+02 1.5627300599589944e-03 -5.4657104492187500e+02 -1.6907200622558594e+02 -6.9556504487991333e-01 -5.4212597656250000e+02 -1.7402899169921875e+02 -7.0669102668762207e+00 -5.4652398681640625e+02 -1.6862800598144531e+02 -1.0048099517822266e+01 -5.4196801757812500e+02 -1.7336300659179688e+02 -1.3760499954223633e+01 -5.4629498291015625e+02 -1.6824699401855469e+02 -1.2978400230407715e+01 -5.4183099365234375e+02 -1.6743199157714844e+02 -1.9238901138305664e+01 -5.4153900146484375e+02 -1.7309600830078125e+02 -1.6448699951171875e+01 -5.4620300292968750e+02 -1.6602699279785156e+02 -2.5793399810791016e+01 -5.4103497314453125e+02 -1.7142799377441406e+02 -2.5707201004028320e+01 -5.4562902832031250e+02 -1.7100100708007812e+02 -2.7335399627685547e+01 -5.4548199462890625e+02 -1.6548500061035156e+02 -2.8320400238037109e+01 -5.4084100341796875e+02 -1.6911099243164062e+02 -3.4549602508544922e+01 -5.4483099365234375e+02 -1.6277999877929688e+02 -3.7277198791503906e+01 -5.3987200927734375e+02 -1.6703001403808594e+02 -4.0527500152587891e+01 -5.4411401367187500e+02 -1.6238600158691406e+02 -3.8280498504638672e+01 -5.3973101806640625e+02 -1.6596501159667969e+02 -4.3588001251220703e+01 -5.4374700927734375e+02 -1.5950999450683594e+02 -4.5609397888183594e+01 -5.3870001220703125e+02 -1.6213000488281250e+02 -5.2287399291992188e+01 -5.4242596435546875e+02 -1.5725100708007812e+02 -5.0234298706054688e+01 -5.3789099121093750e+02 -1.6163900756835938e+02 -5.3196697235107422e+01 -5.4225701904296875e+02 -1.5542300415039062e+02 -5.3977703094482422e+01 -5.3723596191406250e+02 -1.5761900329589844e+02 -6.0641696929931641e+01 -5.4087103271484375e+02 -1.5089199829101562e+02 -6.1597000122070312e+01 -5.3561297607421875e+02 -1.5475300598144531e+02 -6.5110000610351562e+01 -5.3988299560546875e+02 -1.5065699768066406e+02 -6.1991199493408203e+01 -5.3552899169921875e+02 -1.5307901000976562e+02 -6.7718994140625000e+01 -5.3930499267578125e+02 -1.4521400451660156e+02 -6.9633094787597656e+01 -5.3358001708984375e+02 -1.4723300170898438e+02 -7.5462501525878906e+01 -5.3728802490234375e+02 -1.4315000915527344e+02 -7.2059700012207031e+01 -5.3284197998046875e+02 -1.4659500122070312e+02 -7.6177902221679688e+01 -5.3706799316406250e+02 -1.3865600585937500e+02 -7.7343597412109375e+01 -5.3123303222656250e+02 -1.4081500244140625e+02 -8.2662002563476562e+01 -5.3507202148437500e+02 -1.3431700134277344e+02 -8.1634201049804688e+01 -5.2968103027343750e+02 -1.3715499877929688e+02 -8.6151802062988281e+01 -5.3380700683593750e+02 -1.3194300842285156e+02 -8.3982398986816406e+01 -5.2883099365234375e+02 -1.3383399963378906e+02 -8.9318199157714844e+01 -5.3265899658203125e+02 -1.2448899841308594e+02 -9.0203201293945312e+01 -5.2616400146484375e+02 -1.2673500061035156e+02 -9.5093399047851562e+01 -5.3020605468750000e+02 -4.2769901275634766e+01 1.3164999389648438e+02 -4.9719400024414062e+02 -4.1653396606445312e+01 1.3727600097656250e+02 -5.0097198486328125e+02 -4.5650501251220703e+01 1.3158000183105469e+02 -4.9804699707031250e+02 -4.4806301116943359e+01 1.3713101196289062e+02 -5.0178701782226562e+02 -4.8507102966308594e+01 1.3139698791503906e+02 -4.9895300292968750e+02 -4.7967399597167969e+01 1.3686900329589844e+02 -5.0268197631835938e+02 -5.1333900451660156e+01 1.3110400390625000e+02 -4.9990902709960938e+02 -5.1093101501464844e+01 1.3648300170898438e+02 -5.0363702392578125e+02 -5.1700901031494141e+01 1.3105699157714844e+02 -5.0003701782226562e+02 -5.1879802703857422e+01 1.3103199768066406e+02 -5.0010000610351562e+02 -9.9270095825195312e+01 1.0911000061035156e+02 -5.1700598144531250e+02 -9.0386802673339844e+01 1.1512400054931641e+02 -5.1380004882812500e+02 -9.2040298461914062e+01 1.1980599975585938e+02 -5.1750201416015625e+02 -9.0136299133300781e+01 1.1529300689697266e+02 -5.1370898437500000e+02 -8.8764801025390625e+01 1.2191500091552734e+02 -5.1632800292968750e+02 -8.1327293395996094e+01 1.2056200408935547e+02 -5.1054501342773438e+02 -8.2616500854492188e+01 1.2531599426269531e+02 -5.1417297363281250e+02 -8.1229499816894531e+01 1.2061999511718750e+02 -5.1051004028320312e+02 -7.8924095153808594e+01 1.2735800170898438e+02 -5.1287902832031250e+02 -7.7672897338867188e+01 1.2250699615478516e+02 -5.0923800659179688e+02 -7.5560401916503906e+01 1.2897900390625000e+02 -5.1171899414062500e+02 -7.1844505310058594e+01 1.2520700836181641e+02 -5.0716000366210938e+02 -7.2674598693847656e+01 1.3015901184082031e+02 -5.1073599243164062e+02 -7.0500297546386719e+01 1.2582999420166016e+02 -5.0668103027343750e+02 -6.7283699035644531e+01 1.3236399841308594e+02 -5.0889898681640625e+02 -6.3284301757812500e+01 1.2846000671386719e+02 -5.0412100219726562e+02 -6.2183601379394531e+01 1.3394999694824219e+02 -5.0722998046875000e+02 -6.1999202728271484e+01 1.2879100036621094e+02 -5.0366799926757812e+02 -5.9144798278808594e+01 1.3489500427246094e+02 -5.0623501586914062e+02 -5.5995098114013672e+01 1.3033399963378906e+02 -5.0154800415039062e+02 -5.3152099609375000e+01 1.3084500122070312e+02 -5.0054699707031250e+02 -9.9451698303222656e+01 1.1503299713134766e+02 -5.2016003417968750e+02 -1.0359200286865234e+02 1.1215299987792969e+02 -5.2165997314453125e+02 -1.0757599639892578e+02 1.0305300140380859e+02 -5.2001397705078125e+02 -1.0974500274658203e+02 1.0763099670410156e+02 -5.2392602539062500e+02 -1.0768000030517578e+02 1.0297399902343750e+02 -5.2005200195312500e+02 -1.2180099487304688e+02 9.8771995544433594e+01 -5.2836401367187500e+02 -1.0978499603271484e+02 -1.0769000244140625e+02 -5.2392401123046875e+02 -1.0767800140380859e+02 -1.0297500610351562e+02 -5.2005102539062500e+02 -1.1013399505615234e+02 -1.0744100189208984e+02 -5.2405102539062500e+02 -5.1700901031494141e+01 -1.3105699157714844e+02 -5.0003701782226562e+02 -5.1879802703857422e+01 -1.3103199768066406e+02 -5.0010000610351562e+02 -5.1093101501464844e+01 -1.3648300170898438e+02 -5.0363702392578125e+02 -5.2960998535156250e+01 -1.3087399291992188e+02 -5.0048001098632812e+02 -5.5054000854492188e+01 -1.3581100463867188e+02 -5.0490802001953125e+02 -5.5975097656250000e+01 -1.3033799743652344e+02 -5.0154101562500000e+02 -6.2208000183105469e+01 -1.3402000427246094e+02 -5.0723397827148438e+02 -6.2001300811767578e+01 -1.2879100036621094e+02 -5.0366799926757812e+02 -6.2817996978759766e+01 -1.3386698913574219e+02 -5.0743197631835938e+02 -6.3259399414062500e+01 -1.2846800231933594e+02 -5.0411199951171875e+02 -7.0421600341796875e+01 -1.3118701171875000e+02 -5.0996398925781250e+02 -7.0470397949218750e+01 -1.2584300231933594e+02 -5.0666998291015625e+02 -7.2678199768066406e+01 -1.3018299865722656e+02 -5.1073599243164062e+02 -7.1841499328613281e+01 -1.2520800781250000e+02 -5.0715899658203125e+02 -7.7974792480468750e+01 -1.2782800292968750e+02 -5.1254998779296875e+02 -7.7638198852539062e+01 -1.2252500152587891e+02 -5.0922500610351562e+02 -8.2155395507812500e+01 -1.2568500518798828e+02 -5.1400500488281250e+02 -8.1319694519042969e+01 -1.2056999969482422e+02 -5.1054299926757812e+02 -8.2648498535156250e+01 -1.2539899444580078e+02 -5.1417901611328125e+02 -8.1321594238281250e+01 -1.2056900024414062e+02 -5.1054299926757812e+02 -9.1260101318359375e+01 -1.2039099884033203e+02 -5.1721697998046875e+02 -9.0224105834960938e+01 -1.1523699951171875e+02 -5.1374102783203125e+02 -9.2067001342773438e+01 -1.1986000061035156e+02 -5.1750701904296875e+02 -9.0384101867675781e+01 -1.1512800598144531e+02 -5.1379901123046875e+02 -1.0054899597167969e+02 -1.1427799987792969e+02 -5.2055700683593750e+02 -9.9356101989746094e+01 -1.0904900360107422e+02 -5.1703698730468750e+02 -1.0756199645996094e+02 -1.0306400299072266e+02 -5.2000897216796875e+02 -4.1655200958251953e+01 -1.3726699829101562e+02 -5.0096600341796875e+02 -4.2769901275634766e+01 -1.3164999389648438e+02 -4.9719400024414062e+02 -4.4803798675537109e+01 -1.3713699340820312e+02 -5.0179101562500000e+02 -4.5650897979736328e+01 -1.3158000183105469e+02 -4.9804699707031250e+02 -4.7966598510742188e+01 -1.3686900329589844e+02 -5.0268197631835938e+02 -4.8508098602294922e+01 -1.3139698791503906e+02 -4.9895300292968750e+02 -5.1335300445556641e+01 -1.3110299682617188e+02 -4.9990902709960938e+02 -5.1708400726318359e+01 1.2778100585937500e+02 -4.9899102783203125e+02 -4.8835502624511719e+01 1.0912300109863281e+02 -4.9798199462890625e+02 -4.5810699462890625e+01 1.0928800201416016e+02 -4.9698999023437500e+02 -4.8627902984619141e+01 1.2805099487304688e+02 -4.9791198730468750e+02 -5.1354099273681641e+01 1.2781800079345703e+02 -4.9886300659179688e+02 -3.5072200775146484e+01 1.0934100341796875e+02 -4.9439801025390625e+02 -4.3107101440429688e+01 1.2820799255371094e+02 -4.9616198730468750e+02 -4.5877399444580078e+01 1.2818099975585938e+02 -4.9701101684570312e+02 -2.5531599044799805e+01 1.0938899993896484e+02 -4.9209500122070312e+02 -1.7978700637817383e+01 1.2820799255371094e+02 -4.9101702880859375e+02 -3.5157100677490234e+01 1.2820799255371094e+02 -4.9404598999023438e+02 -1.7941598892211914e+01 1.0940200042724609e+02 -4.9145901489257812e+02 -5.6474101543426514e-01 1.0943199920654297e+02 -4.9000299072265625e+02 -5.6474101543426514e-01 1.2820799255371094e+02 -4.9000299072265625e+02 -4.1654502868652344e+01 -1.3727000427246094e+02 -5.0096798706054688e+02 -3.3416099548339844e+01 -1.3728399658203125e+02 -4.9880401611328125e+02 -3.4906799316406250e+01 -1.3164999389648438e+02 -4.9510198974609375e+02 -2.1981901168823242e+01 -1.3164999389648438e+02 -4.9282299804687500e+02 -5.6474101543426514e-01 -1.3727000427246094e+02 -4.9502398681640625e+02 -5.6474101543426514e-01 -1.3164999389648438e+02 -4.9108801269531250e+02 -1.1652400016784668e+01 -1.3727099609375000e+02 -4.9544900512695312e+02 -1.7852699279785156e+01 -1.3164999389648438e+02 -4.9209500122070312e+02 -2.1443000793457031e+01 -1.3726699829101562e+02 -4.9657299804687500e+02 -2.2617300033569336e+01 -1.3726599121093750e+02 -4.9670800781250000e+02 8.9375000000000000e+01 -1.3727000427246094e+02 -4.9502398681640625e+02 8.9375000000000000e+01 -1.3164999389648438e+02 -4.9108801269531250e+02 4.4405097961425781e+01 -1.3727000427246094e+02 -4.9502398681640625e+02 -2.1981998443603516e+01 1.3164999389648438e+02 -4.9282299804687500e+02 -2.2597499847412109e+01 1.3726000976562500e+02 -4.9669998168945312e+02 -3.4906799316406250e+01 1.3164999389648438e+02 -4.9510198974609375e+02 -3.3344001770019531e+01 1.3730200195312500e+02 -4.9880001831054688e+02 -4.1652400970458984e+01 1.3728100585937500e+02 -5.0097500610351562e+02 -5.6474101543426514e-01 1.3164999389648438e+02 -4.9108801269531250e+02 -5.6474101543426514e-01 1.3727000427246094e+02 -4.9502398681640625e+02 -1.7852699279785156e+01 1.3164999389648438e+02 -4.9209500122070312e+02 -1.1648599624633789e+01 1.3727200317382812e+02 -4.9544900512695312e+02 -2.1443599700927734e+01 1.3726100158691406e+02 -4.9656799316406250e+02 4.4405097961425781e+01 1.3727000427246094e+02 -4.9502398681640625e+02 8.9375000000000000e+01 1.3164999389648438e+02 -4.9108801269531250e+02 8.9375000000000000e+01 1.3727000427246094e+02 -4.9502398681640625e+02 -1.4273100280761719e+02 8.5955902099609375e+01 -5.4242895507812500e+02 -1.3739599609375000e+02 9.0999000549316406e+01 -5.4068701171875000e+02 -1.2726299285888672e+02 9.9390800476074219e+01 -5.3734997558593750e+02 -1.2472599792480469e+02 1.0128500366210938e+02 -5.3640100097656250e+02 -8.8781196594238281e+01 1.2636700439453125e+02 -5.2350201416015625e+02 -7.9853996276855469e+01 1.3117698669433594e+02 -5.2053399658203125e+02 -4.5993900299072266e+01 1.4124600219726562e+02 -5.1034600830078125e+02 -4.2797000885009766e+01 1.4144900512695312e+02 -5.0941098022460938e+02 -3.9767196655273438e+01 1.4153500366210938e+02 -5.0859396362304688e+02 -3.9689899444580078e+01 1.4153599548339844e+02 -5.0857400512695312e+02 -5.3784000396728516e+01 1.4010800170898438e+02 -5.1270501708984375e+02 -4.9075302124023438e+01 1.4092799377441406e+02 -5.1128201293945312e+02 -5.7608200073242188e+01 1.3944200134277344e+02 -5.1386102294921875e+02 -6.6208396911621094e+01 1.3696099853515625e+02 -5.1642700195312500e+02 -6.0493301391601562e+01 1.3861000061035156e+02 -5.1472198486328125e+02 -6.6882904052734375e+01 1.3669799804687500e+02 -5.1662304687500000e+02 -6.9932601928710938e+01 1.3550799560546875e+02 -5.1750799560546875e+02 -7.3089004516601562e+01 1.3427700805664062e+02 -5.1842395019531250e+02 -7.8539497375488281e+01 1.3188500976562500e+02 -5.2009704589843750e+02 -7.5002502441406250e+01 1.3353100585937500e+02 -5.1897900390625000e+02 -8.9348098754882812e+01 1.2600800323486328e+02 -5.2369897460937500e+02 -9.9780502319335938e+01 1.1939500427246094e+02 -5.2732702636718750e+02 -1.0244000244140625e+02 1.1756400299072266e+02 -5.2826800537109375e+02 -1.0400000000000000e+02 1.1648999786376953e+02 -5.2882000732421875e+02 -1.2234799957275391e+02 1.0306099700927734e+02 -5.3551098632812500e+02 -1.3541500854492188e+02 9.2871803283691406e+01 -5.4004003906250000e+02 -1.2737000274658203e+02 9.9310600280761719e+01 -5.3738897705078125e+02 -1.7749899291992188e+02 5.6824102401733398e+00 -5.5374700927734375e+02 -1.7692300415039062e+02 1.3726400375366211e+01 -5.5355999755859375e+02 -1.7567601013183594e+02 2.1880199432373047e+01 -5.5315600585937500e+02 -1.7543099975585938e+02 2.3477901458740234e+01 -5.5307604980468750e+02 -1.7315800476074219e+02 3.3100299835205078e+01 -5.5233801269531250e+02 -1.7168099975585938e+02 3.7672500610351562e+01 -5.5185803222656250e+02 -1.7009599304199219e+02 4.2576900482177734e+01 -5.5134301757812500e+02 -1.6595199584960938e+02 5.2472698211669922e+01 -5.4999603271484375e+02 -1.6575799560546875e+02 5.2844600677490234e+01 -5.4993304443359375e+02 -1.6137400817871094e+02 6.1257102966308594e+01 -5.4850695800781250e+02 -1.5775500488281250e+02 6.7018203735351562e+01 -5.4732800292968750e+02 -1.5609899902343750e+02 6.9653999328613281e+01 -5.4678900146484375e+02 -1.5012800598144531e+02 7.7646095275878906e+01 -5.4484301757812500e+02 -1.4866200256347656e+02 7.9292602539062500e+01 -5.4436499023437500e+02 -1.2737000274658203e+02 -9.9311798095703125e+01 -5.3739001464843750e+02 -1.3362300109863281e+02 -9.4340499877929688e+01 -5.3945098876953125e+02 -1.3479399108886719e+02 -9.3409500122070312e+01 -5.3983599853515625e+02 -1.4217401123046875e+02 -8.6522994995117188e+01 -5.4224798583984375e+02 -1.4474000549316406e+02 -8.3701698303222656e+01 -5.4308496093750000e+02 -1.4896998596191406e+02 -7.9050506591796875e+01 -5.4446502685546875e+02 -1.5505799865722656e+02 -7.1136398315429688e+01 -5.4645001220703125e+02 -1.5516899108886719e+02 -7.0991203308105469e+01 -5.4648602294921875e+02 -1.5999099731445312e+02 -6.3608802795410156e+01 -5.4805603027343750e+02 -1.6350000000000000e+02 -5.7221496582031250e+01 -5.4919799804687500e+02 -1.6478698730468750e+02 -5.4877601623535156e+01 -5.4961700439453125e+02 -1.6886900329589844e+02 -4.5770202636718750e+01 -5.5094396972656250e+02 -1.7008399963378906e+02 -4.2335300445556641e+01 -5.5133898925781250e+02 -1.7222000122070312e+02 -3.6294200897216797e+01 -5.5203302001953125e+02 -1.7469100952148438e+02 -2.7013500213623047e+01 -5.5283599853515625e+02 -1.7474398803710938e+02 -2.6723100662231445e+01 -5.5285296630859375e+02 -1.7647000122070312e+02 -1.7288499832153320e+01 -5.5341400146484375e+02 -1.7714500427246094e+02 -1.0603499412536621e+01 -5.5363299560546875e+02 -1.7746600341796875e+02 -7.4286499023437500e+00 -5.5373699951171875e+02 -1.7766299438476562e+02 2.5571000576019287e+00 -5.5380102539062500e+02 -1.7762899780273438e+02 3.8590998649597168e+00 -5.5378997802734375e+02 -1.1062899780273438e+02 -1.1174800109863281e+02 -5.3120501708984375e+02 -1.2052700042724609e+02 -1.0439500427246094e+02 -5.3486199951171875e+02 -1.2726000213623047e+02 -9.9393196105957031e+01 -5.3734997558593750e+02 -8.4204597473144531e+01 -1.2888999938964844e+02 -5.2197802734375000e+02 -9.1351203918457031e+01 -1.2482900238037109e+02 -5.2438995361328125e+02 -1.0090200042724609e+02 -1.1863300323486328e+02 -5.2772100830078125e+02 -9.8824302673339844e+01 -1.1998099517822266e+02 -5.2699700927734375e+02 -7.6415298461914062e+01 -1.3284399414062500e+02 -5.1943499755859375e+02 -7.7546501159667969e+01 -1.3236099243164062e+02 -5.1977697753906250e+02 -8.1914405822753906e+01 -1.3019099426269531e+02 -5.2120501708984375e+02 -6.9981407165527344e+01 -1.3558900451660156e+02 -5.1748699951171875e+02 -5.6342899322509766e+01 -1.3961399841308594e+02 -5.1347998046875000e+02 -6.1502502441406250e+01 -1.3844099426269531e+02 -5.1501800537109375e+02 -6.2528297424316406e+01 -1.3810099792480469e+02 -5.1531604003906250e+02 -6.9536201477050781e+01 -1.3577899169921875e+02 -5.1735302734375000e+02 -4.9069198608398438e+01 -1.4092900085449219e+02 -5.1127899169921875e+02 -4.9861301422119141e+01 -1.4081298828125000e+02 -5.1152200317382812e+02 -5.3228099822998047e+01 -1.4032200622558594e+02 -5.1255200195312500e+02 -4.2808902740478516e+01 -1.4145399475097656e+02 -5.0941998291015625e+02 -4.5994201660156250e+01 -1.4124499511718750e+02 -5.1034497070312500e+02 -3.2360797882080078e+01 -1.4154000854492188e+02 -5.0663601684570312e+02 -3.9611999511718750e+01 -1.4152699279785156e+02 -5.0854098510742188e+02 -3.9685398101806641e+01 -1.4152600097656250e+02 -5.0855999755859375e+02 -4.1248500823974609e+01 -1.4148999023437500e+02 -5.0899099731445312e+02 -3.1616098403930664e+01 -1.4154200744628906e+02 -5.0643997192382812e+02 -2.1425899505615234e+01 -1.4152400207519531e+02 -5.0445800781250000e+02 -1.3353600502014160e+01 -1.4152799987792969e+02 -5.0353198242187500e+02 -1.1052999496459961e+01 -1.4152899169921875e+02 -5.0326800537109375e+02 -5.6742000579833984e-01 -1.4152799987792969e+02 -5.0286602783203125e+02 1.9273899793624878e+00 -1.4152799987792969e+02 -5.0286602783203125e+02 1.7316499710083008e+01 -1.4152799987792969e+02 -5.0286602783203125e+02 3.3799900054931641e+01 -1.4152799987792969e+02 -5.0286602783203125e+02 4.4405097961425781e+01 -1.4152799987792969e+02 -5.0286602783203125e+02 5.1316200256347656e+01 -1.4152799987792969e+02 -5.0286602783203125e+02 6.9844902038574219e+01 -1.4152799987792969e+02 -5.0286602783203125e+02 8.9375000000000000e+01 -1.4152799987792969e+02 -5.0286602783203125e+02 -3.8850502014160156e+01 1.4153900146484375e+02 -5.0835400390625000e+02 -3.1512300491333008e+01 1.4155999755859375e+02 -5.0643402099609375e+02 -2.1642801284790039e+01 1.4151899719238281e+02 -5.0449597167968750e+02 -2.1408901214599609e+01 1.4151799011230469e+02 -5.0445001220703125e+02 -1.1052000045776367e+01 1.4153001403808594e+02 -5.0326901245117188e+02 -3.3138799667358398e+00 1.4152899169921875e+02 -5.0297201538085938e+02 -5.6587004661560059e-01 1.4152799987792969e+02 -5.0286602783203125e+02 8.9375000000000000e+01 1.4152799987792969e+02 -5.0286602783203125e+02 4.4405097961425781e+01 1.4152799987792969e+02 -5.0286602783203125e+02 3.5414901733398438e+01 1.4152799987792969e+02 -5.0286602783203125e+02 1.3788099670410156e+02 -1.3850498962402344e+02 -5.3729302978515625e+02 1.4282899475097656e+02 -1.3164999389648438e+02 -5.3796600341796875e+02 1.3646699523925781e+02 -1.3836199951171875e+02 -5.3239398193359375e+02 1.4145300292968750e+02 -1.3164999389648438e+02 -5.3104901123046875e+02 1.3399400329589844e+02 -1.3811300659179688e+02 -5.2382501220703125e+02 1.3918598937988281e+02 -1.3164999389648438e+02 -5.2437103271484375e+02 1.3186599731445312e+02 -1.3801499938964844e+02 -5.2049102783203125e+02 1.3606700134277344e+02 -1.3164999389648438e+02 -5.1804498291015625e+02 1.3214799499511719e+02 -1.3164999389648438e+02 -5.1218200683593750e+02 1.2646299743652344e+02 -1.3776800537109375e+02 -5.1202203369140625e+02 1.2749900054931641e+02 -1.3164999389648438e+02 -5.0687896728515625e+02 1.2428399658203125e+02 -1.3771299743652344e+02 -5.1012600708007812e+02 1.1591199493408203e+02 -1.3749900817871094e+02 -5.0283999633789062e+02 1.2219599914550781e+02 -1.3164999389648438e+02 -5.0222897338867188e+02 1.1633200073242188e+02 -1.3164999389648438e+02 -4.9831100463867188e+02 1.1419699859619141e+02 -1.3747599792480469e+02 -5.0205398559570312e+02 1.0320399475097656e+02 -1.3732899475097656e+02 -4.9701800537109375e+02 9.6412300109863281e+01 -1.3164999389648438e+02 -4.9154898071289062e+02 1.0228300476074219e+02 -1.3732499694824219e+02 -4.9688500976562500e+02 1.0332900238037109e+02 -1.3164999389648438e+02 -4.9292498779296875e+02 1.1000700378417969e+02 -1.3164999389648438e+02 -4.9519198608398438e+02 9.7909194946289062e+01 1.3729199218750000e+02 -4.9577297973632812e+02 9.6412300109863281e+01 1.3164999389648438e+02 -4.9154898071289062e+02 1.0216500091552734e+02 1.3733300781250000e+02 -4.9717599487304688e+02 1.0332900238037109e+02 1.3164999389648438e+02 -4.9292498779296875e+02 1.1118300628662109e+02 1.3742098999023438e+02 -5.0014901733398438e+02 1.1000700378417969e+02 1.3164999389648438e+02 -4.9519198608398438e+02 1.1407999420166016e+02 1.3747900390625000e+02 -5.0215203857421875e+02 1.1633200073242188e+02 1.3164999389648438e+02 -4.9831100463867188e+02 1.2219599914550781e+02 1.3164999389648438e+02 -5.0222897338867188e+02 1.2268599700927734e+02 1.3765299987792969e+02 -5.0810302734375000e+02 1.2749900054931641e+02 1.3164999389648438e+02 -5.0687896728515625e+02 1.2426900482177734e+02 1.3771099853515625e+02 -5.1006503295898438e+02 1.3606700134277344e+02 1.3164999389648438e+02 -5.1804498291015625e+02 1.3203599548339844e+02 1.3801098632812500e+02 -5.2034399414062500e+02 1.3147799682617188e+02 1.3797200012207031e+02 -5.1899395751953125e+02 1.3214799499511719e+02 1.3164999389648438e+02 -5.1218200683593750e+02 1.4145300292968750e+02 1.3164999389648438e+02 -5.3104901123046875e+02 1.3687199401855469e+02 1.3835899353027344e+02 -5.3227001953125000e+02 1.3683399963378906e+02 1.3834899902343750e+02 -5.3194201660156250e+02 1.3918598937988281e+02 1.3164999389648438e+02 -5.2437103271484375e+02 1.4282899475097656e+02 1.3164999389648438e+02 -5.3796600341796875e+02 1.2893598937988281e+02 1.4260700988769531e+02 -5.3376696777343750e+02 9.6510093688964844e+01 1.4155000305175781e+02 -5.0349496459960938e+02 1.2450900268554688e+02 1.4223001098632812e+02 -5.2295001220703125e+02 1.0760100555419922e+02 1.4167900085449219e+02 -5.0716699218750000e+02 1.1719699859619141e+02 1.4191200256347656e+02 -5.1383398437500000e+02 1.2979100036621094e+02 -1.4276300048828125e+02 -5.3822998046875000e+02 1.2659299468994141e+02 -1.4237100219726562e+02 -5.2698901367187500e+02 1.2034200286865234e+02 -1.4202600097656250e+02 -5.1711700439453125e+02 1.1154799652099609e+02 -1.4175700378417969e+02 -5.0942300415039062e+02 1.0093600463867188e+02 -1.4158700561523438e+02 -5.0454003906250000e+02 1.4362899780273438e+02 1.3001200866699219e+02 -5.3785998535156250e+02 1.4223300170898438e+02 1.3001200866699219e+02 -5.3083996582031250e+02 1.3993200683593750e+02 1.3001200866699219e+02 -5.2406195068359375e+02 1.3676600646972656e+02 1.3001200866699219e+02 -5.1764202880859375e+02 1.3278900146484375e+02 1.3001200866699219e+02 -5.1169003295898438e+02 1.2806900024414062e+02 1.3001200866699219e+02 -5.0630801391601562e+02 1.2268800354003906e+02 1.3001200866699219e+02 -5.0158898925781250e+02 1.1673600006103516e+02 1.3001200866699219e+02 -4.9761199951171875e+02 1.1031600189208984e+02 1.3001200866699219e+02 -4.9444601440429688e+02 1.0353800201416016e+02 1.3001200866699219e+02 -4.9214498901367188e+02 9.6517700195312500e+01 1.3001200866699219e+02 -4.9074899291992188e+02 8.9375000000000000e+01 1.3001200866699219e+02 -4.9028097534179688e+02 -5.6474101543426514e-01 1.3001200866699219e+02 -4.9028201293945312e+02 -5.6474101543426514e-01 1.3002301025390625e+02 -4.9028399658203125e+02 -1.7946100234985352e+01 1.3002301025390625e+02 -4.9129598999023438e+02 -3.5092300415039062e+01 1.3002301025390625e+02 -4.9432000732421875e+02 -4.3011501312255859e+01 1.3002200317382812e+02 -4.9642800903320312e+02 -4.3012897491455078e+01 1.3001200866699219e+02 -4.9642398071289062e+02 -5.1772197723388672e+01 1.2947900390625000e+02 -4.9934802246093750e+02 -5.1788097381591797e+01 1.2990299987792969e+02 -4.9943798828125000e+02 -5.1432899475097656e+01 1.2953298950195312e+02 -4.9916000366210938e+02 -4.8652599334716797e+01 1.2980000305175781e+02 -4.9819601440429688e+02 -4.5844100952148438e+01 1.2996099853515625e+02 -4.9728399658203125e+02 -5.1963703155517578e+01 1.2946900939941406e+02 -4.9935098266601562e+02 -1.2434200286865234e+02 8.9896598815917969e+01 -5.2592596435546875e+02 -1.2388499450683594e+02 8.9116798400878906e+01 -5.2555401611328125e+02 -1.0703199768066406e+02 1.0197400665283203e+02 -5.1930200195312500e+02 -5.3206501007080078e+01 1.2929399108886719e+02 -4.9979901123046875e+02 -6.3128097534179688e+01 1.2702499389648438e+02 -5.0338101196289062e+02 -5.5985900878906250e+01 1.2881399536132812e+02 -5.0080197143554688e+02 -7.0224700927734375e+01 1.2448000335693359e+02 -5.0594598388671875e+02 -7.7304901123046875e+01 1.2123600006103516e+02 -5.0850997924804688e+02 -8.0824600219726562e+01 1.1938399505615234e+02 -5.0978500366210938e+02 -8.9661300659179688e+01 1.1413100433349609e+02 -5.1298999023437500e+02 -9.8749694824218750e+01 1.0800099945068359e+02 -5.1629101562500000e+02 -1.2393499755859375e+02 -8.9135101318359375e+01 -5.2545294189453125e+02 8.9375000000000000e+01 -1.3001200866699219e+02 -4.9028097534179688e+02 9.6517700195312500e+01 -1.3001200866699219e+02 -4.9074899291992188e+02 1.0353800201416016e+02 -1.3001200866699219e+02 -4.9214498901367188e+02 1.1031600189208984e+02 -1.3001200866699219e+02 -4.9444601440429688e+02 1.1673600006103516e+02 -1.3001200866699219e+02 -4.9761199951171875e+02 1.2268800354003906e+02 -1.3001200866699219e+02 -5.0158898925781250e+02 1.2806900024414062e+02 -1.3001200866699219e+02 -5.0630801391601562e+02 1.3278900146484375e+02 -1.3001200866699219e+02 -5.1169003295898438e+02 1.3676600646972656e+02 -1.3001200866699219e+02 -5.1764202880859375e+02 1.3993200683593750e+02 -1.3001200866699219e+02 -5.2406195068359375e+02 1.4223300170898438e+02 -1.3001200866699219e+02 -5.3083996582031250e+02 1.4362899780273438e+02 -1.3001200866699219e+02 -5.3785998535156250e+02 1.4409700012207031e+02 -1.3001200866699219e+02 -5.4500299072265625e+02 -8.0913902282714844e+01 -1.1933500671386719e+02 -5.0981701660156250e+02 -5.1963703155517578e+01 -1.2946900939941406e+02 -4.9935098266601562e+02 -5.5966400146484375e+01 -1.2881800842285156e+02 -5.0079501342773438e+02 -5.3019798278808594e+01 -1.2932200622558594e+02 -4.9973199462890625e+02 -7.0195198059082031e+01 -1.2449199676513672e+02 -5.0593603515625000e+02 -6.3103599548339844e+01 -1.2703199768066406e+02 -5.0337200927734375e+02 -7.7270599365234375e+01 -1.2125299835205078e+02 -5.0849700927734375e+02 -8.9748504638671875e+01 -1.1407499694824219e+02 -5.1302203369140625e+02 -9.8835403442382812e+01 -1.0794000244140625e+02 -5.1632202148437500e+02 -1.0701799774169922e+02 -1.0198400115966797e+02 -5.1929699707031250e+02 -5.6474101543426514e-01 -1.3001200866699219e+02 -4.9028201293945312e+02 -5.6474101543426514e-01 -1.3002301025390625e+02 -4.9028399658203125e+02 -5.1794101715087891e+01 -1.2949000549316406e+02 -4.9928997802734375e+02 -5.1794101715087891e+01 -1.2949099731445312e+02 -4.9928997802734375e+02 -1.7946100234985352e+01 -1.3002301025390625e+02 -4.9129598999023438e+02 -3.5092300415039062e+01 -1.3002301025390625e+02 -4.9432000732421875e+02 -4.3011501312255859e+01 -1.3002200317382812e+02 -4.9642800903320312e+02 -4.3012897491455078e+01 -1.3001200866699219e+02 -4.9642398071289062e+02 -5.1434299468994141e+01 -1.2953298950195312e+02 -4.9916101074218750e+02 -4.8653499603271484e+01 -1.2980000305175781e+02 -4.9819699096679688e+02 -4.5844497680664062e+01 -1.2996099853515625e+02 -4.9728399658203125e+02 1.3434500122070312e+02 -1.4162400817871094e+02 -5.3765899658203125e+02 1.3074900817871094e+02 -1.4121000671386719e+02 -5.2516900634765625e+02 1.2377200317382812e+02 -1.4084700012207031e+02 -5.1421997070312500e+02 1.1398900604248047e+02 -1.4056399536132812e+02 -5.0569897460937500e+02 1.0220400238037109e+02 -1.4038400268554688e+02 -5.0029498291015625e+02 8.9375000000000000e+01 -1.4032299804687500e+02 -4.9844400024414062e+02 4.4405097961425781e+01 -1.4032299804687500e+02 -4.9844400024414062e+02 -5.6623101234436035e-01 -1.4032299804687500e+02 -4.9844400024414062e+02 -1.1391099929809570e+01 -1.4032299804687500e+02 -4.9885897827148438e+02 -3.9644001007080078e+01 -1.4152200317382812e+02 -5.0842498779296875e+02 -4.0261997222900391e+01 -1.4113000488281250e+02 -5.0616400146484375e+02 -3.2628498077392578e+01 -1.4033700561523438e+02 -5.0213302612304688e+02 -4.0764099121093750e+01 -1.4024501037597656e+02 -5.0430798339843750e+02 -4.1049400329589844e+01 -1.3965800476074219e+02 -5.0325000000000000e+02 -4.1001800537109375e+01 -1.3978399658203125e+02 -5.0342797851562500e+02 -4.1587299346923828e+01 -1.3763200378417969e+02 -5.0122500610351562e+02 -4.0953399658203125e+01 -1.3991099548339844e+02 -5.0360800170898438e+02 -4.0764400482177734e+01 -1.4024400329589844e+02 -5.0430603027343750e+02 -2.2097900390625000e+01 -1.4031800842285156e+02 -5.0008703613281250e+02 -4.3984699249267578e+01 -1.4023100280761719e+02 -5.0512301635742188e+02 -4.0838199615478516e+01 -1.4023100280761719e+02 -5.0433099365234375e+02 -5.0353298187255859e+01 -1.3964599609375000e+02 -5.0698297119140625e+02 -4.7208202362060547e+01 -1.3999800109863281e+02 -5.0603402709960938e+02 -1.1095800018310547e+02 -1.1018700408935547e+02 -5.2723199462890625e+02 -1.2757900238037109e+02 -9.7827499389648438e+01 -5.3338299560546875e+02 -1.2762699890136719e+02 -9.7777702331542969e+01 -5.3337902832031250e+02 -1.2762500000000000e+02 -9.7787002563476562e+01 -5.3340295410156250e+02 -5.4459300994873047e+01 -1.3899198913574219e+02 -5.0826000976562500e+02 -6.2560401916503906e+01 -1.3702200317382812e+02 -5.1077096557617188e+02 -7.0428695678710938e+01 -1.3427099609375000e+02 -5.1322198486328125e+02 -7.8245994567871094e+01 -1.3080699157714844e+02 -5.1574597167968750e+02 -8.2540000915527344e+01 -1.2862500000000000e+02 -5.1719201660156250e+02 -9.1845298767089844e+01 -1.2325399780273438e+02 -5.2039801025390625e+02 -1.0128899383544922e+02 -1.1706800079345703e+02 -5.2373895263671875e+02 -1.7379299926757812e+02 -2.6495000839233398e+01 -5.4884796142578125e+02 -1.3491799926757812e+02 -9.1896499633789062e+01 -5.3583300781250000e+02 -1.4988699340820312e+02 7.6299507141113281e+01 -5.4085198974609375e+02 -1.5570700073242188e+02 6.8414894104003906e+01 -5.4279998779296875e+02 -1.4266999816894531e+02 8.4512702941894531e+01 -5.3843304443359375e+02 -1.2762699890136719e+02 9.7776893615722656e+01 -5.3337799072265625e+02 -1.2757599639892578e+02 9.7810295104980469e+01 -5.3336499023437500e+02 -1.2758100128173828e+02 9.7825805664062500e+01 -5.3338299560546875e+02 -1.3552600097656250e+02 9.1363197326660156e+01 -5.3603704833984375e+02 -1.6084300231933594e+02 6.0143001556396484e+01 -5.4451898193359375e+02 -1.6529800415039062e+02 5.1500301361083984e+01 -5.4600903320312500e+02 -1.7230400085449219e+02 3.2468700408935547e+01 -5.4834997558593750e+02 -1.7451199340820312e+02 2.3025798797607422e+01 -5.4908801269531250e+02 -1.7596099853515625e+02 1.3460599899291992e+01 -5.4957098388671875e+02 -1.7667999267578125e+02 2.5073900222778320e+00 -5.4981103515625000e+02 -1.7664698791503906e+02 3.7841200828552246e+00 -5.4979998779296875e+02 -1.7648799133300781e+02 -7.2843999862670898e+00 -5.4974700927734375e+02 -1.7552200317382812e+02 -1.6954200744628906e+01 -5.4942498779296875e+02 -1.7139300537109375e+02 -3.5604202270507812e+01 -5.4804602050781250e+02 -1.6813500976562500e+02 -4.4911701202392578e+01 -5.4695703125000000e+02 -1.6416500854492188e+02 -5.3865398406982422e+01 -5.4563000488281250e+02 -1.5949699401855469e+02 -6.2458499908447266e+01 -5.4406896972656250e+02 -1.5480000305175781e+02 -6.9733100891113281e+01 -5.4249700927734375e+02 -1.4875698852539062e+02 -7.7686401367187500e+01 -5.4047296142578125e+02 -1.4212701416015625e+02 -8.5073905944824219e+01 -5.3825097656250000e+02 -1.6932800292968750e+02 4.1774299621582031e+01 -5.4735601806640625e+02 -5.0355598449707031e+01 1.3964599609375000e+02 -5.0698501586914062e+02 -5.8741199493408203e+01 1.3806599426269531e+02 -5.0958697509765625e+02 -1.2265699768066406e+02 1.0149900054931641e+02 -5.3154302978515625e+02 -1.0436499786376953e+02 1.1492499542236328e+02 -5.2484204101562500e+02 -1.0017800140380859e+02 1.1782900238037109e+02 -5.2334301757812500e+02 -8.9303901672363281e+01 1.2479399871826172e+02 -5.1950799560546875e+02 -7.9221702575683594e+01 1.3032800292968750e+02 -5.1607104492187500e+02 -7.5755401611328125e+01 1.3198600769042969e+02 -5.1492700195312500e+02 -6.7183006286621094e+01 1.3549501037597656e+02 -5.1221697998046875e+02 -3.9721599578857422e+01 1.4153100585937500e+02 -5.0845599365234375e+02 -4.0806301116943359e+01 1.4025500488281250e+02 -5.0432904052734375e+02 -4.0323101043701172e+01 1.4113900756835938e+02 -5.0618899536132812e+02 -4.0881999969482422e+01 1.4023800659179688e+02 -5.0435195922851562e+02 -4.1080699920654297e+01 1.3966799926757812e+02 -5.0326699829101562e+02 -4.0989002227783203e+01 1.3992098999023438e+02 -5.0362597656250000e+02 -4.0806900024414062e+01 1.4025401306152344e+02 -5.0432699584960938e+02 -4.1589698791503906e+01 1.3764299011230469e+02 -5.0123400878906250e+02 -4.1085899353027344e+01 1.3964801025390625e+02 -5.0324600219726562e+02 -4.3979099273681641e+01 1.4022399902343750e+02 -5.0511599731445312e+02 -4.7208396911621094e+01 1.3999900817871094e+02 -5.0603497314453125e+02 -5.6532996892929077e-01 1.4032299804687500e+02 -4.9844400024414062e+02 -1.1388799667358398e+01 1.4032499694824219e+02 -4.9885897827148438e+02 -3.2538299560546875e+01 1.4035600280761719e+02 -5.0212698364257812e+02 -2.2079500198364258e+01 1.4031199645996094e+02 -5.0007998657226562e+02 4.4405097961425781e+01 1.4032299804687500e+02 -4.9844400024414062e+02 8.9375000000000000e+01 1.4032299804687500e+02 -4.9844400024414062e+02 1.3337800598144531e+02 1.4146000671386719e+02 -5.3269702148437500e+02 9.7291900634765625e+01 1.4034600830078125e+02 -4.9913900756835938e+02 1.0960400390625000e+02 1.4048098754882812e+02 -5.0320101928710938e+02 1.2026999664306641e+02 1.4072599792480469e+02 -5.1058297729492188e+02 1.2841899108886719e+02 1.4106098937988281e+02 -5.2068798828125000e+02 -4.5185398101806641e+01 -1.0728800201416016e+02 -4.9886199951171875e+02 -4.5182701110839844e+01 -1.0704100036621094e+02 -5.1064495849609375e+02 -4.5188598632812500e+01 -1.0728800201416016e+02 -4.9886199951171875e+02 -4.5690299987792969e+01 -1.0702799987792969e+02 -5.1064495849609375e+02 -4.8041000366210938e+01 -1.0712899780273438e+02 -4.9983401489257812e+02 -5.2332500457763672e+01 -1.0639099884033203e+02 -5.1064495849609375e+02 -6.9291595458984375e+01 -1.0086199951171875e+02 -5.1064495849609375e+02 -7.6996398925781250e+01 -9.6804794311523438e+01 -5.1064495849609375e+02 -6.9942306518554688e+01 -1.0061199951171875e+02 -5.0802999877929688e+02 -6.5189895629882812e+01 -1.0267099761962891e+02 -5.1064495849609375e+02 -6.5093704223632812e+01 -1.0277999877929688e+02 -5.0622201538085938e+02 -6.5066101074218750e+01 -1.0271400451660156e+02 -5.1064495849609375e+02 -6.4330398559570312e+01 -1.0312099456787109e+02 -5.0593698120117188e+02 -5.8802501678466797e+01 -1.0491400146484375e+02 -5.1064495849609375e+02 -5.7526996612548828e+01 -1.0542900085449219e+02 -5.0338299560546875e+02 -5.4846397399902344e+01 -1.0581700134277344e+02 -5.1064495849609375e+02 -5.4885498046875000e+01 -1.0598000335693359e+02 -5.0238500976562500e+02 -5.0919601440429688e+01 -1.0680699920654297e+02 -5.0088696289062500e+02 -6.9942306518554688e+01 1.0061199951171875e+02 -5.0802999877929688e+02 -7.6996398925781250e+01 9.6804794311523438e+01 -5.1064495849609375e+02 -6.9291595458984375e+01 1.0086199951171875e+02 -5.1064495849609375e+02 -6.4330398559570312e+01 1.0312099456787109e+02 -5.0593698120117188e+02 -6.5093704223632812e+01 1.0277999877929688e+02 -5.0622201538085938e+02 -6.5066101074218750e+01 1.0271400451660156e+02 -5.1064495849609375e+02 -4.5690299987792969e+01 1.0702799987792969e+02 -5.1064495849609375e+02 -4.5182701110839844e+01 1.0704100036621094e+02 -5.1064495849609375e+02 -4.5185398101806641e+01 1.0728800201416016e+02 -4.9886199951171875e+02 -4.5188598632812500e+01 1.0728800201416016e+02 -4.9886199951171875e+02 -4.8041000366210938e+01 1.0712899780273438e+02 -4.9983401489257812e+02 -5.2332500457763672e+01 1.0639099884033203e+02 -5.1064495849609375e+02 -5.0919601440429688e+01 1.0680699920654297e+02 -5.0088696289062500e+02 -5.4846397399902344e+01 1.0581700134277344e+02 -5.1064495849609375e+02 -5.4885498046875000e+01 1.0598000335693359e+02 -5.0238500976562500e+02 -5.7526996612548828e+01 1.0542900085449219e+02 -5.0338299560546875e+02 -5.8802501678466797e+01 1.0491400146484375e+02 -5.1064495849609375e+02 -6.5189895629882812e+01 1.0267099761962891e+02 -5.1064495849609375e+02 3.4743099212646484e+01 -1.0657899475097656e+02 -5.3270001220703125e+02 3.8780601501464844e+01 -1.0682400512695312e+02 -5.2099798583984375e+02 1.4142799377441406e+02 -1.0653099822998047e+02 -5.3498797607421875e+02 4.5153697967529297e+01 -1.0704100036621094e+02 -5.1064495849609375e+02 8.9375000000000000e+01 -1.0743199920654297e+02 -4.9196099853515625e+02 -4.5187397003173828e+01 -1.0728800201416016e+02 -4.9884799194335938e+02 -2.1367401123046875e+01 -1.0740200042724609e+02 -4.9342999267578125e+02 -5.6474101543426514e-01 -1.0743199920654297e+02 -4.9196099853515625e+02 1.1719499969482422e+02 -1.0726699829101562e+02 -4.9984899902343750e+02 1.2844599914550781e+02 -1.0707200622558594e+02 -5.0915002441406250e+02 1.3673300170898438e+02 -1.0682099914550781e+02 -5.2116699218750000e+02 1.0383300018310547e+02 -1.0738999938964844e+02 -4.9397097778320312e+02 3.4743099212646484e+01 1.0657899475097656e+02 -5.3270001220703125e+02 8.9375000000000000e+01 1.0743199920654297e+02 -4.9196099853515625e+02 -5.6474101543426514e-01 1.0743199920654297e+02 -4.9196099853515625e+02 -2.5198699951171875e+01 1.0738899993896484e+02 -4.9402600097656250e+02 -4.5187397003173828e+01 1.0728800201416016e+02 -4.9884799194335938e+02 1.4050999450683594e+02 1.0661399841308594e+02 -5.3102398681640625e+02 9.9878601074218750e+01 1.0740999603271484e+02 -4.9301202392578125e+02 3.8780601501464844e+01 1.0682400512695312e+02 -5.2099798583984375e+02 4.5153697967529297e+01 1.0704100036621094e+02 -5.1064495849609375e+02 1.3476799011230469e+02 1.0689499664306641e+02 -5.1760296630859375e+02 1.2558299255371094e+02 1.0713300323486328e+02 -5.0625799560546875e+02 1.1365200042724609e+02 1.0730899810791016e+02 -4.9784799194335938e+02 -4.5160598754882812e+01 -1.0504199981689453e+02 -5.1260296630859375e+02 4.3699600219726562e+01 -1.0504199981689453e+02 -5.1260296630859375e+02 4.3699600219726562e+01 1.0504199981689453e+02 -5.1260296630859375e+02 -8.7343399047851562e+01 9.0658500671386719e+01 -5.1260296630859375e+02 -8.7343399047851562e+01 -9.0658500671386719e+01 -5.1260296630859375e+02 -8.4998397827148438e+01 9.1041999816894531e+01 -5.1260296630859375e+02 -8.5989105224609375e+01 -9.0813003540039062e+01 -5.1260296630859375e+02 -8.4323303222656250e+01 9.1236801147460938e+01 -5.1260296630859375e+02 -8.1123901367187500e+01 -9.2453399658203125e+01 -5.1260296630859375e+02 -7.5998405456542969e+01 -9.5072097778320312e+01 -5.1260296630859375e+02 -6.8436798095703125e+01 9.9054199218750000e+01 -5.1260296630859375e+02 -7.5998405456542969e+01 9.5072097778320312e+01 -5.1260296630859375e+02 -7.9544700622558594e+01 9.3185798645019531e+01 -5.1260296630859375e+02 -5.2011299133300781e+01 1.0441799926757812e+02 -5.1260296630859375e+02 -5.8241699218750000e+01 1.0299500274658203e+02 -5.1260296630859375e+02 -6.4434898376464844e+01 1.0081900024414062e+02 -5.1260296630859375e+02 -8.3232704162597656e+01 -9.1603500366210938e+01 -5.1260296630859375e+02 -4.5160598754882812e+01 1.0504199981689453e+02 -5.1260296630859375e+02 -4.5627899169921875e+01 1.0502899932861328e+02 -5.1260296630859375e+02 -6.8436798095703125e+01 -9.9054199218750000e+01 -5.1260296630859375e+02 -6.4434898376464844e+01 -1.0081900024414062e+02 -5.1260296630859375e+02 -5.8241699218750000e+01 -1.0299500274658203e+02 -5.1260296630859375e+02 -5.2011299133300781e+01 -1.0441799926757812e+02 -5.1260296630859375e+02 -4.5627899169921875e+01 -1.0502899932861328e+02 -5.1260296630859375e+02 4.4407798767089844e+01 -1.0675899505615234e+02 -5.1162701416015625e+02 4.4407798767089844e+01 1.0675899505615234e+02 -5.1162701416015625e+02 4.3748100280761719e+01 -1.0555899810791016e+02 -5.1253497314453125e+02 4.3885902404785156e+01 -1.0602899932861328e+02 -5.1234197998046875e+02 4.3885902404785156e+01 1.0602899932861328e+02 -5.1234197998046875e+02 4.3748500823974609e+01 1.0556200408935547e+02 -5.1253399658203125e+02 -8.9752098083496094e+01 -9.0697402954101562e+01 -5.1289703369140625e+02 -8.9752098083496094e+01 9.0697402954101562e+01 -5.1289703369140625e+02 -9.0744003295898438e+01 -9.0741996765136719e+01 -5.1319897460937500e+02 -9.0744003295898438e+01 9.0741996765136719e+01 -5.1319897460937500e+02 8.9375000000000000e+01 1.0774099731445312e+02 -4.9099798583984375e+02 8.9375000000000000e+01 1.0759600067138672e+02 -4.9120901489257812e+02 1.0002799987792969e+02 1.0757399749755859e+02 -4.9227499389648438e+02 1.4187100219726562e+02 1.0720399475097656e+02 -5.3066601562500000e+02 1.4124600219726562e+02 1.0677000427246094e+02 -5.3082696533203125e+02 8.9375000000000000e+01 1.0846199798583984e+02 -4.9029202270507812e+02 8.9375000000000000e+01 1.0803300476074219e+02 -4.9057400512695312e+02 1.0015599822998047e+02 1.0801000213623047e+02 -4.9165298461914062e+02 1.0024300384521484e+02 1.0865399932861328e+02 -4.9123901367187500e+02 8.9375000000000000e+01 1.0867600250244141e+02 -4.9015100097656250e+02 1.1449299621582031e+02 1.0855200195312500e+02 -4.9624099731445312e+02 1.2683999633789062e+02 1.0837400054931641e+02 -5.0494097900390625e+02 1.3634599304199219e+02 1.0813500213623047e+02 -5.1667901611328125e+02 1.1399800109863281e+02 1.0747200012207031e+02 -4.9717901611328125e+02 1.2610199737548828e+02 1.0729399871826172e+02 -5.0570703125000000e+02 1.3541999816894531e+02 1.0705400085449219e+02 -5.1721398925781250e+02 1.1429399871826172e+02 1.0790800476074219e+02 -4.9661499023437500e+02 1.2654199981689453e+02 1.0772900390625000e+02 -5.0524496459960938e+02 1.3597300720214844e+02 1.0748799896240234e+02 -5.1689001464843750e+02 1.4228900146484375e+02 1.0785099792480469e+02 -5.3056500244140625e+02 -5.6474101543426514e-01 1.0844400024414062e+02 -4.9026400756835938e+02 -5.6474101543426514e-01 1.0771399688720703e+02 -4.9097897338867188e+02 -4.5738201141357422e+01 1.0854299926757812e+02 -4.9717700195312500e+02 -4.5713001251220703e+01 1.0830199432373047e+02 -4.9724298095703125e+02 -2.5484800338745117e+01 1.0840100097656250e+02 -4.9235202026367188e+02 -4.5388401031494141e+01 1.0741400146484375e+02 -4.9822000122070312e+02 -2.5363300323486328e+01 1.0767099761962891e+02 -4.9305700683593750e+02 -4.5412498474121094e+01 1.0745899963378906e+02 -4.9814599609375000e+02 -4.5708801269531250e+01 1.0826200103759766e+02 -4.9725402832031250e+02 -4.5569000244140625e+01 1.0775099945068359e+02 -4.9766799926757812e+02 -4.5484600067138672e+01 1.0759300231933594e+02 -4.9792599487304688e+02 -4.5809398651123047e+01 1.0922499847412109e+02 -4.9698999023437500e+02 -7.9073799133300781e+01 9.5801506042480469e+01 -5.1050000000000000e+02 -8.1553901672363281e+01 9.4289199829101562e+01 -5.1142401123046875e+02 -8.0375503540039062e+01 9.4893905639648438e+01 -5.1122897338867188e+02 -8.5355400085449219e+01 9.2376296997070312e+01 -5.1204901123046875e+02 -8.4757698059082031e+01 9.2645401000976562e+01 -5.1195501708984375e+02 -7.9519798278808594e+01 9.6152999877929688e+01 -5.0985903930664062e+02 -8.0013793945312500e+01 9.6747100830078125e+01 -5.0948901367187500e+02 -8.7361099243164062e+01 9.1627098083496094e+01 -5.1235302734375000e+02 -9.0743698120117188e+01 9.0747993469238281e+01 -5.1319897460937500e+02 -8.9747802734375000e+01 9.1003501892089844e+01 -5.1287200927734375e+02 -8.8339302062988281e+01 9.1371498107910156e+01 -5.1256500244140625e+02 -7.8869300842285156e+01 9.5745597839355469e+01 -5.1096899414062500e+02 -7.0257499694824219e+01 1.0067600250244141e+02 -5.0725000000000000e+02 -6.4641998291015625e+01 1.0320200347900391e+02 -5.0516998291015625e+02 -5.1203601837158203e+01 1.0694299316406250e+02 -5.0015902709960938e+02 -5.7828800201416016e+01 1.0553599548339844e+02 -5.0263400268554688e+02 -7.0671096801757812e+01 1.0104799652099609e+02 -5.0661700439453125e+02 -6.5026199340820312e+01 1.0359100341796875e+02 -5.0454299926757812e+02 -5.8165901184082031e+01 1.0594499969482422e+02 -5.0201702880859375e+02 -5.1484600067138672e+01 1.0736899566650391e+02 -4.9955200195312500e+02 -7.1109504699707031e+01 1.0166400146484375e+02 -5.0624197387695312e+02 -6.5416404724121094e+01 1.0422100067138672e+02 -5.0416397094726562e+02 -5.8482597351074219e+01 1.0658899688720703e+02 -5.0163299560546875e+02 -5.1718200683593750e+01 1.0801900482177734e+02 -4.9916198730468750e+02 -4.8299201965332031e+01 1.0727799987792969e+02 -4.9911001586914062e+02 -4.8729400634765625e+01 1.0835800170898438e+02 -4.9810800170898438e+02 -4.8540996551513672e+01 1.0770999908447266e+02 -4.9850399780273438e+02 8.9375000000000000e+01 -1.0774099731445312e+02 -4.9099798583984375e+02 8.9375000000000000e+01 -1.0803300476074219e+02 -4.9057400512695312e+02 1.0421500396728516e+02 -1.0798999786376953e+02 -4.9263699340820312e+02 1.4217799377441406e+02 -1.0668600463867188e+02 -5.3484796142578125e+02 1.4281399536132812e+02 -1.0712000274658203e+02 -5.3473504638671875e+02 1.4324099731445312e+02 -1.0776699829101562e+02 -5.3466699218750000e+02 1.3838000488281250e+02 -1.0805899810791016e+02 -5.2036499023437500e+02 1.2980200195312500e+02 -1.0831300354003906e+02 -5.0793200683593750e+02 1.1815900421142578e+02 -1.0851000213623047e+02 -4.9831100463867188e+02 1.3741299438476562e+02 -1.0697799682617188e+02 -5.2082800292968750e+02 1.2900599670410156e+02 -1.0723300170898438e+02 -5.0863998413085938e+02 1.1759200286865234e+02 -1.0743000030517578e+02 -4.9920800781250000e+02 1.0403999328613281e+02 -1.0755400085449219e+02 -4.9324700927734375e+02 8.9375000000000000e+01 -1.0759600067138672e+02 -4.9120901489257812e+02 1.3799099731445312e+02 -1.0741300201416016e+02 -5.2054699707031250e+02 1.2948100280761719e+02 -1.0766799926757812e+02 -5.0821298217773438e+02 1.1793099975585938e+02 -1.0786499786376953e+02 -4.9866900634765625e+02 1.0433399963378906e+02 -1.0863400268554688e+02 -4.9223001098632812e+02 8.9375000000000000e+01 -1.0846199798583984e+02 -4.9029202270507812e+02 8.9375000000000000e+01 -1.0867600250244141e+02 -4.9015100097656250e+02 -5.6474101543426514e-01 -1.0771399688720703e+02 -4.9097897338867188e+02 -5.6474101543426514e-01 -1.0844400024414062e+02 -4.9026400756835938e+02 -2.1609001159667969e+01 -1.0841300201416016e+02 -4.9175000000000000e+02 -4.5809398651123047e+01 -1.0922499847412109e+02 -4.9698999023437500e+02 -4.5569000244140625e+01 -1.0775099945068359e+02 -4.9766799926757812e+02 -4.5484600067138672e+01 -1.0759300231933594e+02 -4.9792599487304688e+02 -2.1506299972534180e+01 -1.0768300628662109e+02 -4.9245797729492188e+02 -4.5412498474121094e+01 -1.0745899963378906e+02 -4.9814599609375000e+02 -4.5708801269531250e+01 -1.0826200103759766e+02 -4.9725402832031250e+02 -4.5713001251220703e+01 -1.0830199432373047e+02 -4.9724298095703125e+02 -4.5738201141357422e+01 -1.0854299926757812e+02 -4.9717700195312500e+02 -4.5388401031494141e+01 -1.0741400146484375e+02 -4.9822000122070312e+02 -8.1630599975585938e+01 -9.4220802307128906e+01 -5.1144097900390625e+02 -7.9073799133300781e+01 -9.5801506042480469e+01 -5.1050000000000000e+02 -7.8876502990722656e+01 -9.5756500244140625e+01 -5.1096801757812500e+02 -8.8339302062988281e+01 -9.1371498107910156e+01 -5.1256500244140625e+02 -8.9747802734375000e+01 -9.1003501892089844e+01 -5.1287200927734375e+02 -9.0743698120117188e+01 -9.0747993469238281e+01 -5.1319897460937500e+02 -8.5564102172851562e+01 -9.2310798645019531e+01 -5.1208001708984375e+02 -8.6218605041503906e+01 -9.2017005920410156e+01 -5.1218298339843750e+02 -8.0013793945312500e+01 -9.6747100830078125e+01 -5.0948901367187500e+02 -8.7361099243164062e+01 -9.1627098083496094e+01 -5.1235302734375000e+02 -8.1848197937011719e+01 -9.4099502563476562e+01 -5.1147799682617188e+02 -7.9519798278808594e+01 -9.6152999877929688e+01 -5.0985903930664062e+02 -8.3778701782226562e+01 -9.3112197875976562e+01 -5.1179699707031250e+02 -7.1109504699707031e+01 -1.0166400146484375e+02 -5.0624197387695312e+02 -6.5416404724121094e+01 -1.0422100067138672e+02 -5.0416397094726562e+02 -5.8482597351074219e+01 -1.0658899688720703e+02 -5.0163299560546875e+02 -7.0671096801757812e+01 -1.0104799652099609e+02 -5.0661700439453125e+02 -6.5026199340820312e+01 -1.0359100341796875e+02 -5.0454299926757812e+02 -5.8165901184082031e+01 -1.0594499969482422e+02 -5.0201702880859375e+02 -7.0257499694824219e+01 -1.0067600250244141e+02 -5.0725000000000000e+02 -6.4641998291015625e+01 -1.0320200347900391e+02 -5.0516998291015625e+02 -5.7828800201416016e+01 -1.0553599548339844e+02 -5.0263400268554688e+02 -5.1718200683593750e+01 -1.0801900482177734e+02 -4.9916198730468750e+02 -5.1484600067138672e+01 -1.0736899566650391e+02 -4.9955200195312500e+02 -5.1203601837158203e+01 -1.0694299316406250e+02 -5.0015902709960938e+02 -4.8299201965332031e+01 -1.0727799987792969e+02 -4.9911001586914062e+02 -4.8540996551513672e+01 -1.0770999908447266e+02 -4.9850399780273438e+02 -4.8729400634765625e+01 -1.0835800170898438e+02 -4.9810800170898438e+02 -4.5161197662353516e+01 1.0510099792480469e+02 -5.1260198974609375e+02 -4.5171501159667969e+01 1.0602700042724609e+02 -5.1233203125000000e+02 -4.5171997070312500e+01 1.0606600189208984e+02 -5.1232098388671875e+02 -4.5177600860595703e+01 1.0657700347900391e+02 -5.1188497924804688e+02 -4.5179298400878906e+01 1.0673500061035156e+02 -5.1161300659179688e+02 -4.5181301116943359e+01 1.0691400146484375e+02 -5.1130401611328125e+02 -4.5681499481201172e+01 1.0674600219726562e+02 -5.1162701416015625e+02 -4.5658699035644531e+01 1.0601599884033203e+02 -5.1234197998046875e+02 -5.2287300109863281e+01 1.0611299896240234e+02 -5.1162701416015625e+02 -5.8723503112792969e+01 1.0464399719238281e+02 -5.1162701416015625e+02 -6.5083602905273438e+01 1.0241000366210938e+02 -5.1162701416015625e+02 -6.9171195983886719e+01 1.0060700225830078e+02 -5.1162701416015625e+02 -7.6855804443359375e+01 9.6560798645019531e+01 -5.1162701416015625e+02 -5.2170001983642578e+01 1.0539299774169922e+02 -5.1234197998046875e+02 -5.8518699645996094e+01 1.0394300079345703e+02 -5.1234197998046875e+02 -6.4807899475097656e+01 1.0173400115966797e+02 -5.1234197998046875e+02 -6.8859100341796875e+01 9.9947303771972656e+01 -5.1234197998046875e+02 -7.6491401672363281e+01 9.5928199768066406e+01 -5.1234197998046875e+02 -8.0193099975585938e+01 9.4518806457519531e+01 -5.1194500732421875e+02 -7.9899307250976562e+01 9.3914901733398438e+01 -5.1243103027343750e+02 -8.4632598876953125e+01 9.2239700317382812e+01 -5.1230499267578125e+02 -8.5249900817871094e+01 9.1982200622558594e+01 -5.1235003662109375e+02 -8.7355499267578125e+01 9.1319892883300781e+01 -5.1248999023437500e+02 -8.4484001159667969e+01 9.1757995605468750e+01 -5.1252697753906250e+02 -8.5128303527832031e+01 9.1527702331542969e+01 -5.1253900146484375e+02 -8.7349601745605469e+01 9.0993904113769531e+01 -5.1257403564453125e+02 -4.5177600860595703e+01 -1.0657700347900391e+02 -5.1188497924804688e+02 -4.5179298400878906e+01 -1.0673500061035156e+02 -5.1161300659179688e+02 -4.5181301116943359e+01 -1.0691400146484375e+02 -5.1130401611328125e+02 -4.5171997070312500e+01 -1.0606600189208984e+02 -5.1232098388671875e+02 -4.5171501159667969e+01 -1.0602700042724609e+02 -5.1233203125000000e+02 -4.5161197662353516e+01 -1.0510099792480469e+02 -5.1260198974609375e+02 -4.5681499481201172e+01 -1.0674600219726562e+02 -5.1162701416015625e+02 -4.5658699035644531e+01 -1.0601599884033203e+02 -5.1234197998046875e+02 -5.2287300109863281e+01 -1.0611299896240234e+02 -5.1162701416015625e+02 -5.2170001983642578e+01 -1.0539299774169922e+02 -5.1234197998046875e+02 -5.8518699645996094e+01 -1.0394300079345703e+02 -5.1234197998046875e+02 -6.4807899475097656e+01 -1.0173400115966797e+02 -5.1234197998046875e+02 -6.8859100341796875e+01 -9.9947303771972656e+01 -5.1234197998046875e+02 -7.6491401672363281e+01 -9.5928199768066406e+01 -5.1234197998046875e+02 -5.8723503112792969e+01 -1.0464399719238281e+02 -5.1162701416015625e+02 -6.5083602905273438e+01 -1.0241000366210938e+02 -5.1162701416015625e+02 -6.9171195983886719e+01 -1.0060700225830078e+02 -5.1162701416015625e+02 -7.6855804443359375e+01 -9.6560798645019531e+01 -5.1162701416015625e+02 -8.7355499267578125e+01 -9.1319892883300781e+01 -5.1248999023437500e+02 -8.7349601745605469e+01 -9.0993904113769531e+01 -5.1257403564453125e+02 -8.6148597717285156e+01 -9.1649398803710938e+01 -5.1241198730468750e+02 -8.6070899963378906e+01 -9.1241500854492188e+01 -5.1255499267578125e+02 -8.3628494262695312e+01 -9.2697303771972656e+01 -5.1222998046875000e+02 -8.1670295715332031e+01 -9.3694900512695312e+01 -5.1207299804687500e+02 -8.3440498352050781e+01 -9.2177803039550781e+01 -5.1250701904296875e+02 -8.1417205810546875e+01 -9.3119895935058594e+01 -5.1246600341796875e+02 -4.0497600555419922e+01 1.2820799255371094e+02 -6.0000299072265625e+02 8.9375000000000000e+01 1.2820799255371094e+02 -6.0000299072265625e+02 6.7625000000000000e+01 1.0897399902343750e+02 -6.0000299072265625e+02 8.9375000000000000e+01 1.0897399902343750e+02 -6.0000299072265625e+02 1.4822999954223633e+01 2.9309900283813477e+01 -6.0000299072265625e+02 6.2321000099182129e+00 4.4189697265625000e+01 -6.0000299072265625e+02 8.9375000000000000e+01 -1.0897399902343750e+02 -6.0000299072265625e+02 8.9375000000000000e+01 -1.2820799255371094e+02 -6.0000299072265625e+02 6.7625000000000000e+01 -1.0897399902343750e+02 -6.0000299072265625e+02 -4.0497501373291016e+01 -1.2820799255371094e+02 -6.0000299072265625e+02 -6.1696102142333984e+01 1.2458000183105469e+02 -6.0000299072265625e+02 -5.4581897735595703e+01 1.2660600280761719e+02 -6.0000299072265625e+02 -5.3125000000000000e+01 7.4000000000000000e+01 -6.0000299072265625e+02 -4.7567100524902344e+01 1.2780700683593750e+02 -6.0000299072265625e+02 -3.6059497833251953e+01 7.2005302429199219e+01 -6.0000299072265625e+02 -1.9913900375366211e+01 6.6128799438476562e+01 -6.0000299072265625e+02 -5.5587701797485352e+00 5.6687198638916016e+01 -6.0000299072265625e+02 -9.2350799560546875e+01 1.0807900238037109e+02 -6.0000299072265625e+02 -8.7897193908691406e+01 1.1108999633789062e+02 -6.0000299072265625e+02 -7.0190498352050781e+01 7.2005302429199219e+01 -6.0000299072265625e+02 -7.8145401000976562e+01 1.1706700134277344e+02 -6.0000299072265625e+02 -6.9214599609375000e+01 1.2160299682617188e+02 -6.0000299072265625e+02 -4.4534099578857422e+01 -7.3499595642089844e+01 -6.0000299072265625e+02 -2.7815601348876953e+01 -6.9537200927734375e+01 -6.0000299072265625e+02 -1.0653900146484375e+02 9.7730003356933594e+01 -6.0000299072265625e+02 -8.6336097717285156e+01 6.6128799438476562e+01 -6.0000299072265625e+02 -1.1975499725341797e+02 8.7660202026367188e+01 -6.0000299072265625e+02 -1.0069100189208984e+02 5.6687198638916016e+01 -6.0000299072265625e+02 -1.2753300476074219e+02 8.1161697387695312e+01 -6.0000299072265625e+02 -1.3468099975585938e+02 7.3975502014160156e+01 -6.0000299072265625e+02 -1.1248199462890625e+02 4.4189697265625000e+01 -6.0000299072265625e+02 -1.4113800048828125e+02 6.6162399291992188e+01 -6.0000299072265625e+02 -1.2107299804687500e+02 2.9309900283813477e+01 -6.0000299072265625e+02 -1.5176600646972656e+02 4.8925197601318359e+01 -6.0000299072265625e+02 -1.4684899902343750e+02 5.7788700103759766e+01 -6.0000299072265625e+02 -1.2753300476074219e+02 -8.1161697387695312e+01 -6.0000299072265625e+02 -1.0695099639892578e+02 -5.0781803131103516e+01 -6.0000299072265625e+02 -9.3788604736328125e+01 -6.1826099395751953e+01 -6.0000299072265625e+02 -1.2600099945068359e+02 1.2849900245666504e+01 -6.0000299072265625e+02 -1.5905799865722656e+02 3.0033100128173828e+01 -6.0000299072265625e+02 -1.5584799194335938e+02 3.9647098541259766e+01 -6.0000299072265625e+02 -1.6276699829101562e+02 -1.0125200271606445e+01 -6.0000299072265625e+02 -1.6323300170898438e+02 0.0000000000000000e+00 -6.0000299072265625e+02 -1.2700000762939453e+02 -4.3026800155639648e+00 -6.0000299072265625e+02 -1.6276699829101562e+02 1.0125200271606445e+01 -6.0000299072265625e+02 -1.6137098693847656e+02 2.0164501190185547e+01 -6.0000299072265625e+02 -1.3468099975585938e+02 -7.3975502014160156e+01 -6.0000299072265625e+02 -1.4113800048828125e+02 -6.6162399291992188e+01 -6.0000299072265625e+02 -1.1721099853515625e+02 -3.7000000000000000e+01 -6.0000299072265625e+02 -7.8434402465820312e+01 -6.9537200927734375e+01 -6.0000299072265625e+02 -1.0319799804687500e+02 -1.0023999786376953e+02 -6.0000299072265625e+02 -1.1975499725341797e+02 -8.7660095214843750e+01 -6.0000299072265625e+02 -1.6137098693847656e+02 -2.0164501190185547e+01 -6.0000299072265625e+02 -1.2401599884033203e+02 -2.1223400115966797e+01 -6.0000299072265625e+02 -1.5905799865722656e+02 -3.0033100128173828e+01 -6.0000299072265625e+02 -7.0080398559570312e+01 -1.2120899963378906e+02 -6.0000299072265625e+02 -7.7613800048828125e+01 -1.1736500549316406e+02 -6.0000299072265625e+02 -6.1715801239013672e+01 -7.3499595642089844e+01 -6.0000299072265625e+02 -8.5240806579589844e+01 -1.1280900573730469e+02 -6.0000299072265625e+02 -9.3032798767089844e+01 -1.0760600280761719e+02 -6.0000299072265625e+02 -1.4684899902343750e+02 -5.7788700103759766e+01 -6.0000299072265625e+02 -1.5176600646972656e+02 -4.8925197601318359e+01 -6.0000299072265625e+02 -1.5584799194335938e+02 -3.9647098541259766e+01 -6.0000299072265625e+02 -1.2461400032043457e+01 -6.1826099395751953e+01 -6.0000299072265625e+02 7.0060902833938599e-01 -5.0781803131103516e+01 -6.0000299072265625e+02 2.0749799728393555e+01 -4.3026800155639648e+00 -6.0000299072265625e+02 1.9750699996948242e+01 1.2849900245666504e+01 -6.0000299072265625e+02 -6.2577903747558594e+01 -1.2427400207519531e+02 -6.0000299072265625e+02 -5.3125000000000000e+01 -7.4000000000000000e+01 -6.0000299072265625e+02 -6.0616199493408203e+01 -1.2493900299072266e+02 -6.0000299072265625e+02 1.0960799217224121e+01 -3.7000000000000000e+01 -6.0000299072265625e+02 1.7766199111938477e+01 -2.1223400115966797e+01 -6.0000299072265625e+02 -4.0497600555419922e+01 -1.2820799255371094e+02 -6.0000299072265625e+02 -4.6834098815917969e+01 -1.2788599395751953e+02 -6.0000299072265625e+02 -5.3743000030517578e+01 -1.2679100036621094e+02 -6.0000299072265625e+02 9.6553901672363281e+01 -1.2820799255371094e+02 -5.9953198242187500e+02 1.0017699432373047e+02 -1.0896099853515625e+02 -5.9893200683593750e+02 1.0361000061035156e+02 -1.2820799255371094e+02 -5.9812896728515625e+02 1.0348699951171875e+02 -1.0894600677490234e+02 -5.9777600097656250e+02 1.1042299652099609e+02 -1.2820799255371094e+02 -5.9581604003906250e+02 1.1449400329589844e+02 -1.0889700317382812e+02 -5.9393194580078125e+02 1.1687500000000000e+02 -1.2820799255371094e+02 -5.9263403320312500e+02 1.1669799804687500e+02 -1.0887799835205078e+02 -5.9238305664062500e+02 1.2285699462890625e+02 -1.2820799255371094e+02 -5.8863702392578125e+02 1.2690100097656250e+02 -1.0878700256347656e+02 -5.8521197509765625e+02 1.2826600646972656e+02 -1.2820799255371094e+02 -5.8389404296875000e+02 1.2808799743652344e+02 -1.0876899719238281e+02 -5.8374902343750000e+02 1.3300900268554688e+02 -1.2820799255371094e+02 -5.7848498535156250e+02 1.3645599365234375e+02 -1.0863899993896484e+02 -5.7343499755859375e+02 1.3700599670410156e+02 -1.2820799255371094e+02 -5.7250299072265625e+02 1.3687899780273438e+02 -1.0862599945068359e+02 -5.7244799804687500e+02 1.4018798828125000e+02 -1.2820799255371094e+02 -5.6604998779296875e+02 1.4243099975585938e+02 -1.0846299743652344e+02 -5.5949700927734375e+02 1.4250099182128906e+02 -1.2820799255371094e+02 -5.5923803710937500e+02 1.4246598815917969e+02 -1.0845999908447266e+02 -5.5923303222656250e+02 1.4390400695800781e+02 -1.2820799255371094e+02 -5.5218200683593750e+02 1.4437500000000000e+02 -1.0828000640869141e+02 -5.4500299072265625e+02 -5.2121097564697266e+01 -1.4212100219726562e+02 -5.5767102050781250e+02 -5.2121097564697266e+01 1.4212100219726562e+02 -5.5767102050781250e+02 -5.4997802734375000e+01 1.4154901123046875e+02 -5.5859399414062500e+02 -5.9111499786376953e+01 1.4073200988769531e+02 -5.5991296386718750e+02 -5.9523601531982422e+01 1.4061300659179688e+02 -5.6001104736328125e+02 -6.3834800720214844e+01 1.3936099243164062e+02 -5.6103802490234375e+02 -6.8125099182128906e+01 1.3793598937988281e+02 -5.6190197753906250e+02 -6.8126701354980469e+01 -1.3793400573730469e+02 -5.6190197753906250e+02 -6.6150703430175781e+01 1.3868899536132812e+02 -5.6158898925781250e+02 -6.4096504211425781e+01 -1.3934100341796875e+02 -5.6114898681640625e+02 -6.3830299377441406e+01 -1.3943399047851562e+02 -5.6109899902343750e+02 -5.9827899932861328e+01 -1.4047999572753906e+02 -5.6004400634765625e+02 -5.6987201690673828e+01 -1.4122200012207031e+02 -5.5929498291015625e+02 -5.5570503234863281e+01 -1.4148400878906250e+02 -5.5882196044921875e+02 -8.4612899780273438e+01 1.3039700317382812e+02 -5.6339996337890625e+02 -8.4612899780273438e+01 -1.3039700317382812e+02 -5.6339996337890625e+02 -8.2025100708007812e+01 1.3180500793457031e+02 -5.6336499023437500e+02 -8.3036804199218750e+01 -1.3121099853515625e+02 -5.6334197998046875e+02 -7.3099098205566406e+01 -1.3597700500488281e+02 -5.6263800048828125e+02 -7.1327095031738281e+01 1.3667799377441406e+02 -5.6246697998046875e+02 -7.7581703186035156e+01 -1.3402799987792969e+02 -5.6313995361328125e+02 -6.8157600402832031e+01 1.3792300415039062e+02 -5.6190698242187500e+02 -7.0531600952148438e+01 -1.3709298706054688e+02 -5.6235101318359375e+02 -7.3308296203613281e+01 1.3595800781250000e+02 -5.6272503662109375e+02 -7.4521499633789062e+01 1.3543200683593750e+02 -5.6286297607421875e+02 -7.7213104248046875e+01 1.3413099670410156e+02 -5.6304296875000000e+02 -1.4067601013183594e+02 8.9076698303222656e+01 -5.6339996337890625e+02 -1.4666500854492188e+02 8.2679901123046875e+01 -5.6339996337890625e+02 -8.7501098632812500e+01 1.2864199829101562e+02 -5.6339996337890625e+02 -9.5150703430175781e+01 1.2399200439453125e+02 -5.6339996337890625e+02 -1.0278200531005859e+02 1.1873600006103516e+02 -5.6339996337890625e+02 -1.2214399719238281e+02 1.0444499969482422e+02 -5.6339996337890625e+02 -1.2673500061035156e+02 1.0095700073242188e+02 -5.6339996337890625e+02 -1.5006900024414062e+02 7.8596000671386719e+01 -5.6339996337890625e+02 -1.7448500061035156e+02 -2.9207300186157227e+01 -5.6339996337890625e+02 -1.4777499389648438e+02 8.1495101928710938e+01 -5.6339996337890625e+02 -1.0680500030517578e+02 1.1596600341796875e+02 -5.6339996337890625e+02 -1.1738600158691406e+02 1.0806099700927734e+02 -5.6339996337890625e+02 -1.3491099548339844e+02 9.4399902343750000e+01 -5.6339996337890625e+02 -1.3509100341796875e+02 9.4233604431152344e+01 -5.6339996337890625e+02 -1.5926499938964844e+02 -6.5835601806640625e+01 -5.6339996337890625e+02 -1.5405799865722656e+02 -7.3503097534179688e+01 -5.6339996337890625e+02 -1.1936900329589844e+02 -1.0655800628662109e+02 -5.6339996337890625e+02 -1.1913600158691406e+02 -1.0673200225830078e+02 -5.6339996337890625e+02 -1.0812000274658203e+02 -1.1500400543212891e+02 -5.6339996337890625e+02 -9.8337997436523438e+01 -1.2186000061035156e+02 -5.6339996337890625e+02 -1.5417300415039062e+02 7.3411796569824219e+01 -5.6339996337890625e+02 -1.5957400512695312e+02 6.5294898986816406e+01 -5.6339996337890625e+02 -1.5986700439453125e+02 6.4854003906250000e+01 -5.6339996337890625e+02 -9.7371200561523438e+01 -1.2253700256347656e+02 -5.6339996337890625e+02 -8.6895301818847656e+01 -1.2908999633789062e+02 -5.6339996337890625e+02 -1.7793600463867188e+02 3.2421898841857910e+00 -5.6339996337890625e+02 -1.7789100646972656e+02 -5.7752699851989746e+00 -5.6339996337890625e+02 -1.6711799621582031e+02 5.0781997680664062e+01 -5.6339996337890625e+02 -1.7725000000000000e+02 -1.3094900131225586e+01 -5.6339996337890625e+02 -1.7699400329589844e+02 -1.6013999938964844e+01 -5.6339996337890625e+02 -1.6522000122070312e+02 5.5087200164794922e+01 -5.6339996337890625e+02 -1.7507299804687500e+02 -2.6991300582885742e+01 -5.6339996337890625e+02 -1.3298899841308594e+02 -9.5992103576660156e+01 -5.6339996337890625e+02 -1.4004600524902344e+02 -8.9691307067871094e+01 -5.6339996337890625e+02 -1.4406100463867188e+02 -8.5471199035644531e+01 -5.6339996337890625e+02 -1.3251000976562500e+02 -9.6420303344726562e+01 -5.6339996337890625e+02 -1.3147599792480469e+02 -9.7256500244140625e+01 -5.6339996337890625e+02 -1.7240699768066406e+02 -3.7036098480224609e+01 -5.6339996337890625e+02 -1.6963299560546875e+02 -4.4821998596191406e+01 -5.6339996337890625e+02 -1.6894699096679688e+02 -4.6745697021484375e+01 -5.6339996337890625e+02 -1.5346499633789062e+02 -7.4375999450683594e+01 -5.6339996337890625e+02 -1.4704800415039062e+02 -8.2331802368164062e+01 -5.6339996337890625e+02 -1.6941200256347656e+02 4.5578800201416016e+01 -5.6339996337890625e+02 -1.7277400207519531e+02 3.5834499359130859e+01 -5.6339996337890625e+02 -1.7286399841308594e+02 3.5482498168945312e+01 -5.6339996337890625e+02 -1.7531498718261719e+02 2.5875400543212891e+01 -5.6339996337890625e+02 -1.7637098693847656e+02 1.9501199722290039e+01 -5.6339996337890625e+02 -1.7713400268554688e+02 1.4891799926757812e+01 -5.6339996337890625e+02 -1.7794198608398438e+02 4.5322198867797852e+00 -5.6339996337890625e+02 -1.6471000671386719e+02 -5.6113002777099609e+01 -5.6339996337890625e+02 -1.6272999572753906e+02 -5.9649398803710938e+01 -5.6339996337890625e+02 1.4426199340820312e+02 -1.0761799621582031e+02 -5.4500299072265625e+02 1.4420899963378906e+02 -1.0752200317382812e+02 -5.4500299072265625e+02 3.3375000000000000e+01 -1.0627999877929688e+02 -5.4500299072265625e+02 3.3375000000000000e+01 1.0627999877929688e+02 -5.4500299072265625e+02 1.4407099914550781e+02 1.0722000122070312e+02 -5.4500299072265625e+02 1.4419700622558594e+02 1.0752500152587891e+02 -5.4500299072265625e+02 7.3971801757812500e+01 1.4300000000000000e+02 -5.4500299072265625e+02 1.3301899719238281e+02 -1.4257398986816406e+02 -5.4500299072265625e+02 1.3344400024414062e+02 -1.4243600463867188e+02 -5.4500299072265625e+02 1.4237500000000000e+02 1.0627999877929688e+02 -5.4500299072265625e+02 1.4303700256347656e+02 1.0639300537109375e+02 -5.4500299072265625e+02 1.4313299560546875e+02 1.0644599914550781e+02 -5.4500299072265625e+02 1.4343499755859375e+02 -1.0658399963378906e+02 -5.4500299072265625e+02 1.4313000488281250e+02 -1.0645899963378906e+02 -5.4500299072265625e+02 1.4393701171875000e+02 -1.0703100585937500e+02 -5.4500299072265625e+02 1.3470500183105469e+02 -1.4177299499511719e+02 -5.4500299072265625e+02 1.3602900695800781e+02 -1.4107800292968750e+02 -5.4500299072265625e+02 1.3638400268554688e+02 -1.4080599975585938e+02 -5.4500299072265625e+02 1.3294599914550781e+02 1.4259600830078125e+02 -5.4500299072265625e+02 2.4112100601196289e+00 -1.4300000000000000e+02 -5.4500299072265625e+02 1.8956800460815430e+01 -1.4300000000000000e+02 -5.4500299072265625e+02 1.4237500000000000e+02 -1.0627999877929688e+02 -5.4500299072265625e+02 1.4281399536132812e+02 -1.0632900238037109e+02 -5.4500299072265625e+02 1.0138899803161621e+01 1.4300000000000000e+02 -5.4500299072265625e+02 1.4362399291992188e+02 1.0671799468994141e+02 -5.4500299072265625e+02 1.3632699584960938e+02 1.4085200500488281e+02 -5.4500299072265625e+02 1.3596899414062500e+02 1.4112100219726562e+02 -5.4500299072265625e+02 1.4437500000000000e+02 1.0828000640869141e+02 -5.4500299072265625e+02 1.3470500183105469e+02 1.4177299499511719e+02 -5.4500299072265625e+02 1.4432600402832031e+02 1.0784100341796875e+02 -5.4500299072265625e+02 1.3337400817871094e+02 1.4246000671386719e+02 -5.4500299072265625e+02 -2.7227399826049805e+01 1.4300000000000000e+02 -5.4882098388671875e+02 -2.6693201065063477e+01 -1.4299899291992188e+02 -5.4875396728515625e+02 -2.1971000671386719e+01 1.4299899291992188e+02 -5.4755004882812500e+02 -2.4401700973510742e+01 -1.4299800109863281e+02 -5.4804199218750000e+02 -1.8511199951171875e+01 1.4299800109863281e+02 -5.4671301269531250e+02 -1.7049400329589844e+01 -1.4299899291992188e+02 -5.4650299072265625e+02 -1.7053001403808594e+01 1.4299899291992188e+02 -5.4650402832031250e+02 -1.5607399940490723e+01 -1.4299899291992188e+02 -5.4620098876953125e+02 -9.6177301406860352e+00 1.4300199890136719e+02 -5.4543499755859375e+02 -1.2297900199890137e+01 -1.4300000000000000e+02 -5.4583001708984375e+02 -7.1583199501037598e+00 1.4300199890136719e+02 -5.4531799316406250e+02 -6.6957902908325195e+00 -1.4300199890136719e+02 -5.4520098876953125e+02 -3.5735202789306641e+01 1.4299400329589844e+02 -5.5170703125000000e+02 -5.0187599182128906e+01 1.4238398742675781e+02 -5.5696704101562500e+02 -4.9590599060058594e+01 -1.4237199401855469e+02 -5.5675000000000000e+02 -4.1996299743652344e+01 1.4297999572753906e+02 -5.5398602294921875e+02 -5.0137401580810547e+01 1.4239099121093750e+02 -5.5694903564453125e+02 -4.4180099487304688e+01 -1.4291000366210938e+02 -5.5478100585937500e+02 -4.2183002471923828e+01 -1.4292599487304688e+02 -5.5405401611328125e+02 -1.2563699340820312e+02 9.5398704528808594e+01 -5.9452099609375000e+02 -1.2183699798583984e+02 9.0400001525878906e+01 -5.9891802978515625e+02 -1.3346199035644531e+02 8.8909698486328125e+01 -5.9452099609375000e+02 -1.2985899353027344e+02 8.3698501586914062e+01 -5.9891802978515625e+02 -1.4388899230957031e+02 6.8230300903320312e+01 -5.9891802978515625e+02 -1.4746899414062500e+02 7.3879898071289062e+01 -5.9452099609375000e+02 -1.3722999572753906e+02 7.6287597656250000e+01 -5.9891802978515625e+02 -1.4055099487304688e+02 8.1949195861816406e+01 -5.9452099609375000e+02 -1.3407899475097656e+02 8.8303405761718750e+01 -5.9452099609375000e+02 -1.6275599670410156e+02 4.8373600006103516e+01 -5.9452099609375000e+02 -1.6038099670410156e+02 5.3198501586914062e+01 -5.9452099609375000e+02 -1.5484899902343750e+02 5.0454399108886719e+01 -5.9891802978515625e+02 -1.5834100341796875e+02 5.7346199035644531e+01 -5.9452099609375000e+02 -1.4977900695800781e+02 5.9594898223876953e+01 -5.9891802978515625e+02 -1.5323799133300781e+02 6.5849998474121094e+01 -5.9452099609375000e+02 -1.4884799194335938e+02 7.1960098266601562e+01 -5.9452099609375000e+02 -1.6659800720214844e+02 3.8507202148437500e+01 -5.9452099609375000e+02 -1.5905799865722656e+02 4.0886302947998047e+01 -5.9891802978515625e+02 -1.6831800842285156e+02 3.2657299041748047e+01 -5.9452099609375000e+02 -1.6236900329589844e+02 3.0971801757812500e+01 -5.9891802978515625e+02 -1.6938899230957031e+02 2.9013900756835938e+01 -5.9452099609375000e+02 -1.6475399780273438e+02 2.0794799804687500e+01 -5.9891802978515625e+02 -1.7138899230957031e+02 1.9300600051879883e+01 -5.9452099609375000e+02 -1.7238800048828125e+02 1.1012099266052246e+01 -5.9452099609375000e+02 -1.6619299316406250e+02 1.0441699981689453e+01 -5.9891802978515625e+02 -1.7258599853515625e+02 9.3687200546264648e+00 -5.9452099609375000e+02 -1.6667500305175781e+02 0.0000000000000000e+00 -5.9891802978515625e+02 -1.7294799804687500e+02 -1.2357800006866455e+00 -5.9452099609375000e+02 -1.7244200134277344e+02 -1.1018799781799316e+01 -5.9452099609375000e+02 -1.6619299316406250e+02 -1.0441699981689453e+01 -5.9891802978515625e+02 -1.7243699645996094e+02 -1.1116299629211426e+01 -5.9452099609375000e+02 -1.6475399780273438e+02 -2.0794799804687500e+01 -5.9891802978515625e+02 -1.7110900878906250e+02 -2.0949199676513672e+01 -5.9452099609375000e+02 -1.6895100402832031e+02 -3.0714799880981445e+01 -5.9452099609375000e+02 -1.6236900329589844e+02 -3.0971801757812500e+01 -5.9891802978515625e+02 -1.6841000366210938e+02 -3.2684402465820312e+01 -5.9452099609375000e+02 -1.6838800048828125e+02 -3.2764198303222656e+01 -5.9452099609375000e+02 -1.5905799865722656e+02 -4.0886302947998047e+01 -5.9891802978515625e+02 -1.6528601074218750e+02 -4.2175098419189453e+01 -5.9452099609375000e+02 -1.6142498779296875e+02 -5.1284500122070312e+01 -5.9452099609375000e+02 -1.5484899902343750e+02 -5.0454399108886719e+01 -5.9891802978515625e+02 -1.6041200256347656e+02 -5.3211601257324219e+01 -5.9452099609375000e+02 -1.5680900573730469e+02 -6.0071098327636719e+01 -5.9452099609375000e+02 -1.4977900695800781e+02 -5.9594898223876953e+01 -5.9891802978515625e+02 -1.5143299865722656e+02 -6.8516593933105469e+01 -5.9452099609375000e+02 -1.4388899230957031e+02 -6.8230300903320312e+01 -5.9891802978515625e+02 -1.4886399841308594e+02 -7.1970497131347656e+01 -5.9452099609375000e+02 -1.4702600097656250e+02 -7.4441497802734375e+01 -5.9452099609375000e+02 -1.3722999572753906e+02 -7.6287597656250000e+01 -5.9891802978515625e+02 -1.4056399536132812e+02 -8.1936096191406250e+01 -5.9452099609375000e+02 -1.3407899475097656e+02 -8.8303298950195312e+01 -5.9452099609375000e+02 -1.2985899353027344e+02 -8.3698501586914062e+01 -5.9891802978515625e+02 -1.3345700073242188e+02 -8.8913795471191406e+01 -5.9452099609375000e+02 -1.2183699798583984e+02 -9.0400001525878906e+01 -5.9891802978515625e+02 -1.2563699340820312e+02 -9.5398704528808594e+01 -5.9452099609375000e+02 -1.1253500366210938e+02 1.0535700225830078e+02 -5.9452301025390625e+02 -7.5258598327636719e+01 1.2238999938964844e+02 -5.9891802978515625e+02 -7.9832504272460938e+01 1.2006700134277344e+02 -5.9891802978515625e+02 -8.2870300292968750e+01 1.2556199645996094e+02 -5.9452099609375000e+02 -9.0306404113769531e+01 1.2110099792480469e+02 -5.9452496337890625e+02 -8.9600799560546875e+01 1.1407999420166016e+02 -5.9891802978515625e+02 -9.3027297973632812e+01 1.1929599761962891e+02 -5.9452301025390625e+02 -8.9790100097656250e+01 1.1396399688720703e+02 -5.9891802978515625e+02 -9.7832000732421875e+01 1.1610800170898438e+02 -5.9452099609375000e+02 -9.4309501647949219e+01 1.1090899658203125e+02 -5.9891802978515625e+02 -1.0979399871826172e+02 1.0744100189208984e+02 -5.9452404785156250e+02 -1.0861399841308594e+02 1.0047499847412109e+02 -5.9891802978515625e+02 -1.0876000213623047e+02 1.0036399841308594e+02 -5.9891802978515625e+02 -4.0497501373291016e+01 1.3756599426269531e+02 -5.9477502441406250e+02 -4.0497501373291016e+01 1.3164999389648438e+02 -5.9891802978515625e+02 -4.1701702117919922e+01 1.3755799865722656e+02 -5.9477398681640625e+02 -4.7957099914550781e+01 1.3122599792480469e+02 -5.9891802978515625e+02 -7.8129699707031250e+01 1.2802499389648438e+02 -5.9452496337890625e+02 -7.5443603515625000e+01 1.2941999816894531e+02 -5.9452697753906250e+02 -7.0626304626464844e+01 1.2474200439453125e+02 -5.9891802978515625e+02 -7.1698898315429688e+01 1.3101499938964844e+02 -5.9453796386718750e+02 -6.9232398986816406e+01 1.2529399871826172e+02 -5.9891802978515625e+02 -6.7987503051757812e+01 1.3259700012207031e+02 -5.9454998779296875e+02 -6.3025600433349609e+01 1.2775099182128906e+02 -5.9891802978515625e+02 -6.5022300720214844e+01 1.3355700683593750e+02 -5.9456597900390625e+02 -6.2804603576660156e+01 1.2783799743652344e+02 -5.9891802978515625e+02 -6.0441402435302734e+01 1.3504100036621094e+02 -5.9459002685546875e+02 -5.5347499847412109e+01 1.2996099853515625e+02 -5.9891802978515625e+02 -5.6703498840332031e+01 1.3595100402832031e+02 -5.9461804199218750e+02 -5.1969402313232422e+01 1.3053900146484375e+02 -5.9891802978515625e+02 -5.3029800415039062e+01 1.3654699707031250e+02 -5.9464996337890625e+02 -4.9194000244140625e+01 1.3716900634765625e+02 -5.9468402099609375e+02 -4.0497501373291016e+01 -1.3164999389648438e+02 -5.9891802978515625e+02 -4.0497501373291016e+01 -1.3756500244140625e+02 -5.9477600097656250e+02 -4.5208599090576172e+01 -1.3736100769042969e+02 -5.9472698974609375e+02 -1.1542900085449219e+02 -1.0318199920654297e+02 -5.9452404785156250e+02 -1.0525699615478516e+02 -1.0299800109863281e+02 -5.9891802978515625e+02 -1.0004299926757812e+02 -1.1456500244140625e+02 -5.9451995849609375e+02 -9.5637802124023438e+01 -1.0996700286865234e+02 -5.9891802978515625e+02 -9.9243995666503906e+01 -1.1511199951171875e+02 -5.9451995849609375e+02 -9.5000198364257812e+01 -1.1042899322509766e+02 -5.9891802978515625e+02 -9.3875602722167969e+01 -1.1878600311279297e+02 -5.9452301025390625e+02 -8.7086402893066406e+01 -1.1571299743652344e+02 -5.9891802978515625e+02 -8.3536697387695312e+01 -1.2518499755859375e+02 -5.9452197265625000e+02 -7.9562004089355469e+01 -1.2020800018310547e+02 -5.9891802978515625e+02 -8.2614196777343750e+01 -1.2566000366210938e+02 -5.9452197265625000e+02 -7.9286903381347656e+01 -1.2037199401855469e+02 -5.9891802978515625e+02 -7.4134002685546875e+01 -1.3002999877929688e+02 -5.9452996826171875e+02 -7.1522697448730469e+01 -1.2433399963378906e+02 -5.9891802978515625e+02 -7.0209098815917969e+01 -1.3162100219726562e+02 -5.9454400634765625e+02 -6.7826499938964844e+01 -1.2584300231933594e+02 -5.9891802978515625e+02 -6.6191505432128906e+01 -1.3325099182128906e+02 -5.9455798339843750e+02 -6.3725299835205078e+01 -1.2751899719238281e+02 -5.9891802978515625e+02 -6.3995502471923828e+01 -1.3398901367187500e+02 -5.9456903076171875e+02 -6.1794601440429688e+01 -1.2817298889160156e+02 -5.9891802978515625e+02 -6.3712699890136719e+01 -1.3406500244140625e+02 -5.9457098388671875e+02 -6.1675796508789062e+01 -1.2821299743652344e+02 -5.9891802978515625e+02 -5.6979598999023438e+01 -1.3586399841308594e+02 -5.9461596679687500e+02 -5.5584300994873047e+01 -1.2985501098632812e+02 -5.9891802978515625e+02 -5.6468799591064453e+01 -1.3600100708007812e+02 -5.9461999511718750e+02 -5.4465202331542969e+01 -1.3015599060058594e+02 -5.9891802978515625e+02 -4.8821098327636719e+01 -1.3720500183105469e+02 -5.9468902587890625e+02 -4.7183700561523438e+01 -1.3130999755859375e+02 -5.9891802978515625e+02 -4.4817100524902344e+01 -1.3142999267578125e+02 -5.9891802978515625e+02 8.9375000000000000e+01 1.3727000427246094e+02 -5.9498205566406250e+02 8.9375000000000000e+01 1.3164999389648438e+02 -5.9891802978515625e+02 -5.3972401618957520e+00 1.3727799987792969e+02 -5.9497601318359375e+02 -1.0541199684143066e+01 1.3730398559570312e+02 -5.9495904541015625e+02 8.9375000000000000e+01 -1.3164999389648438e+02 -5.9891802978515625e+02 8.9375000000000000e+01 -1.3727000427246094e+02 -5.9498205566406250e+02 -5.3972997665405273e+00 -1.3727799987792969e+02 -5.9497705078125000e+02 -1.0430399894714355e+01 -1.3730299377441406e+02 -5.9495904541015625e+02 -1.2829400634765625e+02 -9.8726402282714844e+01 -5.8667895507812500e+02 -1.3241900634765625e+02 -9.5303604125976562e+01 -5.8667895507812500e+02 -1.3631799316406250e+02 -9.2067893981933594e+01 -5.8667895507812500e+02 -1.4353700256347656e+02 -8.4979202270507812e+01 -5.8667803955078125e+02 -1.4366999816894531e+02 -8.4848594665527344e+01 -5.8667803955078125e+02 -1.5036299133300781e+02 -7.7086601257324219e+01 -5.8667803955078125e+02 -1.5339100646972656e+02 -7.3015197753906250e+01 -5.8667803955078125e+02 -1.5492599487304688e+02 -7.0950798034667969e+01 -5.8667895507812500e+02 -1.6049299621582031e+02 -6.2206199645996094e+01 -5.8667895507812500e+02 -1.6203401184082031e+02 -5.9273601531982422e+01 -5.8667895507812500e+02 -1.6890499877929688e+02 -4.4538799285888672e+01 -5.8667895507812500e+02 -1.6527398681640625e+02 -5.3106098175048828e+01 -5.8667895507812500e+02 -1.7530099487304688e+02 -2.1692600250244141e+01 -5.8667803955078125e+02 -1.7368299865722656e+02 -2.9017599105834961e+01 -5.8667803955078125e+02 -1.7306700134277344e+02 -3.1806598663330078e+01 -5.8667803955078125e+02 -1.7248399353027344e+02 -3.3928901672363281e+01 -5.8667803955078125e+02 -1.6927101135253906e+02 -4.3674499511718750e+01 -5.8667895507812500e+02 -1.7705200195312500e+02 3.2167999744415283e+00 -5.8667895507812500e+02 -1.7720500183105469e+02 -1.2801899909973145e+00 -5.8667895507812500e+02 -1.7647399902343750e+02 -1.3009900093078613e+01 -5.8667895507812500e+02 -1.7667601013183594e+02 -1.1511300086975098e+01 -5.8667895507812500e+02 -1.7683200073242188e+02 9.7020292282104492e+00 -5.8667895507812500e+02 -1.7566398620605469e+02 1.9391099929809570e+01 -5.8667803955078125e+02 -1.7559201049804688e+02 1.9984899520874023e+01 -5.8667803955078125e+02 -1.6207901000976562e+02 5.9384700775146484e+01 -5.8667895507812500e+02 -1.6645700073242188e+02 5.0486400604248047e+01 -5.8667895507812500e+02 -1.6665199279785156e+02 5.0091598510742188e+01 -5.8667895507812500e+02 -1.7062998962402344e+02 3.9876701354980469e+01 -5.8667895507812500e+02 -1.7352000427246094e+02 3.0045398712158203e+01 -5.8667803955078125e+02 -1.7199699401855469e+02 3.5225399017333984e+01 -5.8667803955078125e+02 -1.1235500335693359e+02 1.1084300231933594e+02 -5.8667999267578125e+02 -1.0230100250244141e+02 1.1812700653076172e+02 -5.8667895507812500e+02 -1.0024800109863281e+02 1.1961399841308594e+02 -5.8667895507812500e+02 -1.5881199645996094e+02 6.4829605102539062e+01 -5.8667895507812500e+02 -1.5679598999023438e+02 6.8189399719238281e+01 -5.8667895507812500e+02 -1.5082099914550781e+02 7.6504997253417969e+01 -5.8667803955078125e+02 -1.4945800781250000e+02 7.8095901489257812e+01 -5.8667803955078125e+02 -1.4601600646972656e+02 8.2110504150390625e+01 -5.8667803955078125e+02 -1.4365699768066406e+02 8.4862098693847656e+01 -5.8667803955078125e+02 -1.3632200622558594e+02 9.2064094543457031e+01 -5.8667895507812500e+02 -1.3451300048828125e+02 9.3565597534179688e+01 -5.8667895507812500e+02 -1.2829400634765625e+02 9.8726600646972656e+01 -5.8667895507812500e+02 -1.2164199829101562e+02 1.0378400421142578e+02 -5.8667895507812500e+02 -9.2586799621582031e+01 1.2469699859619141e+02 -5.8667102050781250e+02 -8.7341598510742188e+01 1.2784400939941406e+02 -5.8667498779296875e+02 -8.4962196350097656e+01 1.2927099609375000e+02 -5.8667700195312500e+02 -7.7253196716308594e+01 1.3327400207519531e+02 -5.8668200683593750e+02 -7.5357597351074219e+01 1.3408200073242188e+02 -5.8668298339843750e+02 -6.9455802917480469e+01 1.3659500122070312e+02 -5.8668896484375000e+02 -6.3967502593994141e+01 1.3836898803710938e+02 -5.8669299316406250e+02 -6.1497699737548828e+01 1.3916799926757812e+02 -5.8669500732421875e+02 -5.8272201538085938e+01 1.3995100402832031e+02 -5.8669500732421875e+02 -5.7536098480224609e+01 1.4013000488281250e+02 -5.8669500732421875e+02 -5.2318698883056641e+01 1.4097200012207031e+02 -5.8669000244140625e+02 -4.9563999176025391e+01 1.4141699218750000e+02 -5.8668798828125000e+02 -3.9125801086425781e+01 1.4181600952148438e+02 -5.8675500488281250e+02 -4.0546802520751953e+01 1.4182899475097656e+02 -5.8673797607421875e+02 -4.0546997070312500e+01 1.4182899475097656e+02 -5.8673797607421875e+02 -4.1688301086425781e+01 1.4182099914550781e+02 -5.8670904541015625e+02 -4.5814498901367188e+01 1.4160899353027344e+02 -5.8669799804687500e+02 -2.3202301025390625e+01 1.4167498779296875e+02 -5.8695196533203125e+02 -1.3006400108337402e+01 1.4158399963378906e+02 -5.8707897949218750e+02 -1.0476600646972656e+01 1.4156199645996094e+02 -5.8710998535156250e+02 -5.3677401542663574e+00 1.4153700256347656e+02 -5.8713299560546875e+02 -4.5142002105712891e+00 1.4153700256347656e+02 -5.8713299560546875e+02 1.0024099349975586e+01 1.4153500366210938e+02 -5.8713403320312500e+02 7.3973701477050781e+01 1.4153001403808594e+02 -5.8713903808593750e+02 8.9375000000000000e+01 1.4152799987792969e+02 -5.8714001464843750e+02 -8.2397697448730469e+01 -1.3055700683593750e+02 -5.8667803955078125e+02 -8.5649200439453125e+01 -1.2888200378417969e+02 -5.8667602539062500e+02 -9.6224098205566406e+01 -1.2233799743652344e+02 -5.8667395019531250e+02 -9.7942398071289062e+01 -1.2116199493408203e+02 -5.8667602539062500e+02 -1.0249400329589844e+02 -1.1804599761962891e+02 -5.8667999267578125e+02 -1.1799500274658203e+02 -1.0657899475097656e+02 -5.8668103027343750e+02 -1.1864399719238281e+02 -1.0608499908447266e+02 -5.8668103027343750e+02 -5.8601497650146484e+01 -1.3983300781250000e+02 -5.8669500732421875e+02 -6.5253097534179688e+01 -1.3805900573730469e+02 -5.8669299316406250e+02 -6.7567398071289062e+01 -1.3728199768066406e+02 -5.8669104003906250e+02 -7.0261901855468750e+01 -1.3619000244140625e+02 -5.8668798828125000e+02 -7.5890197753906250e+01 -1.3390899658203125e+02 -5.8668200683593750e+02 -5.7286998748779297e+01 -1.4018299865722656e+02 -5.8669500732421875e+02 -5.2730098724365234e+01 -1.4089700317382812e+02 -5.8669299316406250e+02 -4.9168800354003906e+01 -1.4145500183105469e+02 -5.8669104003906250e+02 -4.6664901733398438e+01 -1.4156300354003906e+02 -5.8670404052734375e+02 -4.0546001434326172e+01 -1.4182800292968750e+02 -5.8673699951171875e+02 -4.0545898437500000e+01 -1.4182800292968750e+02 -5.8673699951171875e+02 -3.8465999603271484e+01 -1.4180999755859375e+02 -5.8676300048828125e+02 -3.0372200012207031e+01 -1.4173799133300781e+02 -5.8686297607421875e+02 -1.6004800796508789e+01 -1.4161099243164062e+02 -5.8703997802734375e+02 -7.2766399383544922e+00 -1.4154598999023438e+02 -5.8712500000000000e+02 -1.0365799903869629e+01 -1.4156100463867188e+02 -5.8710998535156250e+02 -5.3665399551391602e+00 -1.4153599548339844e+02 -5.8713403320312500e+02 2.3774700164794922e+00 -1.4153500366210938e+02 -5.8713403320312500e+02 1.9105701446533203e+01 -1.4153399658203125e+02 -5.8713500976562500e+02 8.9375000000000000e+01 -1.4152799987792969e+02 -5.8714001464843750e+02 1.0228300476074219e+02 -1.3732499694824219e+02 -5.9311901855468750e+02 9.6412300109863281e+01 -1.3164999389648438e+02 -5.9845697021484375e+02 1.0332900238037109e+02 -1.3164999389648438e+02 -5.9708099365234375e+02 1.0321799468994141e+02 -1.3732899475097656e+02 -5.9298400878906250e+02 1.1000700378417969e+02 -1.3164999389648438e+02 -5.9481402587890625e+02 1.1419499969482422e+02 -1.3747599792480469e+02 -5.8794897460937500e+02 1.1633200073242188e+02 -1.3164999389648438e+02 -5.9169500732421875e+02 1.1593600463867188e+02 -1.3750000000000000e+02 -5.8714996337890625e+02 1.2219599914550781e+02 -1.3164999389648438e+02 -5.8777600097656250e+02 1.2428099822998047e+02 -1.3771299743652344e+02 -5.7987701416015625e+02 1.2749900054931641e+02 -1.3164999389648438e+02 -5.8312603759765625e+02 1.2649099731445312e+02 -1.3776899719238281e+02 -5.7795001220703125e+02 1.3214799499511719e+02 -1.3164999389648438e+02 -5.7782397460937500e+02 1.3186299133300781e+02 -1.3801499938964844e+02 -5.6951300048828125e+02 1.3606700134277344e+02 -1.3164999389648438e+02 -5.7195996093750000e+02 1.3401800537109375e+02 -1.3811399841308594e+02 -5.6612701416015625e+02 1.3918598937988281e+02 -1.3164999389648438e+02 -5.6563500976562500e+02 1.3646299743652344e+02 -1.3836199951171875e+02 -5.5761096191406250e+02 1.4145300292968750e+02 -1.3164999389648438e+02 -5.5895697021484375e+02 1.3789099121093750e+02 -1.3850698852539062e+02 -5.5264099121093750e+02 1.4282899475097656e+02 -1.3164999389648438e+02 -5.5203997802734375e+02 1.4390400695800781e+02 1.2820799255371094e+02 -5.5218200683593750e+02 1.4340800476074219e+02 1.0841000366210938e+02 -5.5527001953125000e+02 1.4250099182128906e+02 1.2820799255371094e+02 -5.5923803710937500e+02 1.4211100769042969e+02 1.0845800018310547e+02 -5.5910601806640625e+02 1.4018798828125000e+02 1.2820799255371094e+02 -5.6604998779296875e+02 1.3855099487304688e+02 1.0859099578857422e+02 -5.6963494873046875e+02 1.3700599670410156e+02 1.2820799255371094e+02 -5.7250299072265625e+02 1.3671499633789062e+02 1.0862500000000000e+02 -5.7230297851562500e+02 1.3300900268554688e+02 1.2820799255371094e+02 -5.7848498535156250e+02 1.2995399475097656e+02 1.0874900054931641e+02 -5.8212799072265625e+02 1.2826600646972656e+02 1.2820799255371094e+02 -5.8389404296875000e+02 1.2808500671386719e+02 1.0876799774169922e+02 -5.8367596435546875e+02 1.2285699462890625e+02 1.2820799255371094e+02 -5.8863702392578125e+02 1.1827299499511719e+02 1.0887000274658203e+02 -5.9179901123046875e+02 1.1687500000000000e+02 1.2820799255371094e+02 -5.9263403320312500e+02 1.1679399871826172e+02 1.0887899780273438e+02 -5.9245098876953125e+02 1.1042299652099609e+02 1.2820799255371094e+02 -5.9581604003906250e+02 1.0439500427246094e+02 1.0894799804687500e+02 -5.9791198730468750e+02 1.0361000061035156e+02 1.2820799255371094e+02 -5.9812896728515625e+02 1.0359500122070312e+02 1.0894899749755859e+02 -5.9802301025390625e+02 9.6553901672363281e+01 1.2820799255371094e+02 -5.9953198242187500e+02 1.3789099121093750e+02 1.3850698852539062e+02 -5.5264099121093750e+02 1.4282899475097656e+02 1.3164999389648438e+02 -5.5203997802734375e+02 1.3646299743652344e+02 1.3836199951171875e+02 -5.5761096191406250e+02 1.4145300292968750e+02 1.3164999389648438e+02 -5.5895697021484375e+02 1.3401800537109375e+02 1.3811399841308594e+02 -5.6612701416015625e+02 1.3918598937988281e+02 1.3164999389648438e+02 -5.6563500976562500e+02 1.3186299133300781e+02 1.3801499938964844e+02 -5.6951300048828125e+02 1.3606700134277344e+02 1.3164999389648438e+02 -5.7195996093750000e+02 1.3214799499511719e+02 1.3164999389648438e+02 -5.7782397460937500e+02 1.2649099731445312e+02 1.3776899719238281e+02 -5.7795001220703125e+02 1.2749900054931641e+02 1.3164999389648438e+02 -5.8312603759765625e+02 1.2428099822998047e+02 1.3771299743652344e+02 -5.7987701416015625e+02 1.1593600463867188e+02 1.3750000000000000e+02 -5.8714996337890625e+02 1.2219599914550781e+02 1.3164999389648438e+02 -5.8777600097656250e+02 1.1633200073242188e+02 1.3164999389648438e+02 -5.9169500732421875e+02 1.1419499969482422e+02 1.3747599792480469e+02 -5.8794897460937500e+02 1.0321799468994141e+02 1.3732899475097656e+02 -5.9298400878906250e+02 9.6412300109863281e+01 1.3164999389648438e+02 -5.9845697021484375e+02 1.0228300476074219e+02 1.3732499694824219e+02 -5.9311901855468750e+02 1.0332900238037109e+02 1.3164999389648438e+02 -5.9708099365234375e+02 1.1000700378417969e+02 1.3164999389648438e+02 -5.9481402587890625e+02 1.2979899597167969e+02 1.4276599121093750e+02 -5.5171600341796875e+02 1.2661300659179688e+02 1.4237199401855469e+02 -5.6297198486328125e+02 1.2036499786376953e+02 1.4202700805664062e+02 -5.7286102294921875e+02 1.1156900024414062e+02 1.4175799560546875e+02 -5.8056903076171875e+02 1.0094799804687500e+02 1.4158700561523438e+02 -5.8546301269531250e+02 1.2036499786376953e+02 -1.4202700805664062e+02 -5.7286102294921875e+02 1.2661300659179688e+02 -1.4237199401855469e+02 -5.6297198486328125e+02 1.2979899597167969e+02 -1.4276599121093750e+02 -5.5171600341796875e+02 1.0094799804687500e+02 -1.4158700561523438e+02 -5.8546301269531250e+02 1.1156900024414062e+02 -1.4175799560546875e+02 -5.8056903076171875e+02 8.9375000000000000e+01 1.3001200866699219e+02 -5.9972503662109375e+02 9.6517700195312500e+01 1.3001200866699219e+02 -5.9925701904296875e+02 1.0353800201416016e+02 1.3001200866699219e+02 -5.9786096191406250e+02 1.1031600189208984e+02 1.3001200866699219e+02 -5.9555999755859375e+02 1.1673600006103516e+02 1.3001200866699219e+02 -5.9239398193359375e+02 1.2268800354003906e+02 1.3001200866699219e+02 -5.8841699218750000e+02 1.2806900024414062e+02 1.3001200866699219e+02 -5.8369702148437500e+02 1.3278900146484375e+02 1.3001200866699219e+02 -5.7831597900390625e+02 1.3676600646972656e+02 1.3001200866699219e+02 -5.7236395263671875e+02 1.3993200683593750e+02 1.3001200866699219e+02 -5.6594403076171875e+02 1.4223300170898438e+02 1.3001200866699219e+02 -5.5916601562500000e+02 1.4362899780273438e+02 1.3001200866699219e+02 -5.5214599609375000e+02 -4.0497600555419922e+01 1.3001200866699219e+02 -5.9972503662109375e+02 -4.7771598815917969e+01 1.2959899902343750e+02 -5.9972503662109375e+02 -1.2084600067138672e+02 8.9096595764160156e+01 -5.9972503662109375e+02 -1.0762699890136719e+02 9.9169403076171875e+01 -5.9972503662109375e+02 -9.3377700805664062e+01 1.0956300354003906e+02 -5.9972503662109375e+02 -8.8889602661132812e+01 1.1259700012207031e+02 -5.9972503662109375e+02 -7.9029899597167969e+01 1.1863999938964844e+02 -5.9972503662109375e+02 -6.9954704284667969e+01 1.2324900054931641e+02 -5.9972503662109375e+02 -6.2277202606201172e+01 1.2628799438476562e+02 -5.9972503662109375e+02 -5.4983299255371094e+01 1.2836499023437500e+02 -5.9972503662109375e+02 -1.2875199890136719e+02 8.2491600036621094e+01 -5.9972503662109375e+02 -1.3601799011230469e+02 7.5187698364257812e+01 -5.9972503662109375e+02 -1.4258099365234375e+02 6.7246498107910156e+01 -5.9972503662109375e+02 -1.4838500976562500e+02 5.8735500335693359e+01 -5.9972503662109375e+02 -1.5338299560546875e+02 4.9726799011230469e+01 -5.9972503662109375e+02 -1.5753099060058594e+02 4.0296798706054688e+01 -5.9972503662109375e+02 -1.6079400634765625e+02 3.0525199890136719e+01 -5.9972503662109375e+02 -1.6314500427246094e+02 2.0494998931884766e+01 -5.9972503662109375e+02 -1.6456300354003906e+02 1.0291099548339844e+01 -5.9972503662109375e+02 -1.6503700256347656e+02 0.0000000000000000e+00 -5.9972503662109375e+02 -1.6456300354003906e+02 -1.0291099548339844e+01 -5.9972503662109375e+02 -1.6314500427246094e+02 -2.0494998931884766e+01 -5.9972503662109375e+02 -1.6079400634765625e+02 -3.0525199890136719e+01 -5.9972503662109375e+02 -1.5753099060058594e+02 -4.0296798706054688e+01 -5.9972503662109375e+02 -1.5338299560546875e+02 -4.9726799011230469e+01 -5.9972503662109375e+02 -1.4838500976562500e+02 -5.8735500335693359e+01 -5.9972503662109375e+02 -1.4258099365234375e+02 -6.7246498107910156e+01 -5.9972503662109375e+02 -1.3601799011230469e+02 -7.5187698364257812e+01 -5.9972503662109375e+02 -1.2875199890136719e+02 -8.2491600036621094e+01 -5.9972503662109375e+02 -1.2084600067138672e+02 -8.9096595764160156e+01 -5.9972503662109375e+02 -1.0427700042724609e+02 -1.0168600463867188e+02 -5.9972503662109375e+02 -4.0497501373291016e+01 -1.3001200866699219e+02 -5.9972503662109375e+02 -4.0497600555419922e+01 -1.3001200866699219e+02 -5.9972503662109375e+02 -4.7017398834228516e+01 -1.2968099975585938e+02 -5.9972503662109375e+02 -5.4121597290039062e+01 -1.2855599975585938e+02 -5.9972503662109375e+02 -6.1171699523925781e+01 -1.2665499877929688e+02 -5.9972503662109375e+02 -6.3179405212402344e+01 -1.2597499847412109e+02 -5.9972503662109375e+02 -7.0836601257324219e+01 -1.2284700012207031e+02 -5.9972503662109375e+02 -7.8490898132324219e+01 -1.1894200134277344e+02 -5.9972503662109375e+02 -8.6208404541015625e+01 -1.1433100128173828e+02 -5.9972503662109375e+02 -9.4064201354980469e+01 -1.0908599853515625e+02 -5.9972503662109375e+02 8.9375000000000000e+01 -1.3001200866699219e+02 -5.9972503662109375e+02 1.4362899780273438e+02 -1.3001200866699219e+02 -5.5214599609375000e+02 1.4223300170898438e+02 -1.3001200866699219e+02 -5.5916601562500000e+02 1.3993200683593750e+02 -1.3001200866699219e+02 -5.6594403076171875e+02 1.3676600646972656e+02 -1.3001200866699219e+02 -5.7236395263671875e+02 1.3278900146484375e+02 -1.3001200866699219e+02 -5.7831597900390625e+02 1.2806900024414062e+02 -1.3001200866699219e+02 -5.8369702148437500e+02 1.2268800354003906e+02 -1.3001200866699219e+02 -5.8841699218750000e+02 1.1673600006103516e+02 -1.3001200866699219e+02 -5.9239398193359375e+02 1.1031600189208984e+02 -1.3001200866699219e+02 -5.9555999755859375e+02 1.0353800201416016e+02 -1.3001200866699219e+02 -5.9786096191406250e+02 9.6517700195312500e+01 -1.3001200866699219e+02 -5.9925701904296875e+02 1.3435398864746094e+02 1.4162699890136719e+02 -5.5228002929687500e+02 1.3077099609375000e+02 1.4121200561523438e+02 -5.6478698730468750e+02 1.2379799652099609e+02 1.4084799194335938e+02 -5.7575500488281250e+02 1.1401200103759766e+02 1.4056399536132812e+02 -5.8429302978515625e+02 1.0221700286865234e+02 1.4038400268554688e+02 -5.8970703125000000e+02 8.9375000000000000e+01 1.4032299804687500e+02 -5.9156195068359375e+02 -5.3807301521301270e+00 1.4033099365234375e+02 -5.9155603027343750e+02 -1.0505100250244141e+01 1.4035700988769531e+02 -5.9153601074218750e+02 -4.0525199890136719e+01 1.4066400146484375e+02 -5.9126904296875000e+02 -4.0525299072265625e+01 1.4066400146484375e+02 -5.9126904296875000e+02 -1.2752899169921875e+02 9.7794197082519531e+01 -5.9110101318359375e+02 -1.1162900543212891e+02 1.0988099670410156e+02 -5.9110302734375000e+02 -4.1706001281738281e+01 1.4066299438476562e+02 -5.9125604248046875e+02 -4.9486000061035156e+01 1.4024501037597656e+02 -5.9119598388671875e+02 -5.7322200775146484e+01 1.3895899963378906e+02 -5.9116296386718750e+02 -6.1216400146484375e+01 1.3800599670410156e+02 -5.9114703369140625e+02 -6.9049995422363281e+01 1.3546299743652344e+02 -5.9112194824218750e+02 -7.6745002746582031e+01 1.3218200683593750e+02 -5.9110601806640625e+02 -8.4369102478027344e+01 1.2822200012207031e+02 -5.9110101318359375e+02 -9.1942306518554688e+01 1.2368099975585938e+02 -5.9109997558593750e+02 -9.9565101623535156e+01 1.1862000274658203e+02 -5.9110101318359375e+02 -1.2752899169921875e+02 -9.7793998718261719e+01 -5.9110101318359375e+02 -1.3550700378417969e+02 -9.1175697326660156e+01 -5.9110101318359375e+02 -1.3551100158691406e+02 9.1171699523925781e+01 -5.9110101318359375e+02 -1.4277799987792969e+02 8.4037200927734375e+01 -5.9110101318359375e+02 -1.4987200927734375e+02 7.5761695861816406e+01 -5.9110101318359375e+02 -1.5578900146484375e+02 6.7527000427246094e+01 -5.9110101318359375e+02 -1.6102099609375000e+02 5.8807296752929688e+01 -5.9110101318359375e+02 -1.6554800415039062e+02 4.9605297088623047e+01 -5.9110101318359375e+02 -1.6948799133300781e+02 3.9488700866699219e+01 -5.9110101318359375e+02 -1.7235000610351562e+02 2.9753299713134766e+01 -5.9110101318359375e+02 -1.7440199279785156e+02 1.9791400909423828e+01 -5.9110101318359375e+02 -1.7562899780273438e+02 9.6075496673583984e+00 -5.9110198974609375e+02 -1.7600000000000000e+02 -1.2675499916076660e+00 -5.9110101318359375e+02 -1.7547599792480469e+02 -1.1399400711059570e+01 -5.9110198974609375e+02 -1.7411399841308594e+02 -2.1482198715209961e+01 -5.9110101318359375e+02 -1.7190100097656250e+02 -3.1497400283813477e+01 -5.9110101318359375e+02 -1.7132400512695312e+02 -3.3599102020263672e+01 -5.9110101318359375e+02 -1.6814300537109375e+02 -4.3249801635742188e+01 -5.9110198974609375e+02 -1.6418400573730469e+02 -5.2590400695800781e+01 -5.9110101318359375e+02 -1.5944999694824219e+02 -6.1601501464843750e+01 -5.9110101318359375e+02 -1.4941799926757812e+02 -7.6337600708007812e+01 -5.9110101318359375e+02 -1.5393699645996094e+02 -7.0261596679687500e+01 -5.9110101318359375e+02 -1.4279000854492188e+02 -8.4023803710937500e+01 -5.9110101318359375e+02 -1.1726999664306641e+02 -1.0561600494384766e+02 -5.9110394287109375e+02 -1.0180000305175781e+02 -1.1705999755859375e+02 -5.9110101318359375e+02 -9.5560798645019531e+01 -1.2133300018310547e+02 -5.9110101318359375e+02 -8.5050300598144531e+01 -1.2783600616455078e+02 -5.9110101318359375e+02 -7.5397796630859375e+01 -1.3280999755859375e+02 -5.9110803222656250e+02 -6.7189498901367188e+01 -1.3614199829101562e+02 -5.9112695312500000e+02 -6.4911003112792969e+01 -1.3691000366210938e+02 -5.9113403320312500e+02 -5.7077400207519531e+01 -1.3901199340820312e+02 -5.9116400146484375e+02 -4.9097099304199219e+01 -1.4028300476074219e+02 -5.9120098876953125e+02 -4.0524700164794922e+01 -1.4066400146484375e+02 -5.9126904296875000e+02 -4.0524597167968750e+01 -1.4066400146484375e+02 -5.9126904296875000e+02 -5.3801298141479492e+00 -1.4033099365234375e+02 -5.9155700683593750e+02 8.9375000000000000e+01 -1.4032299804687500e+02 -5.9156195068359375e+02 -1.0394300460815430e+01 -1.4035700988769531e+02 -5.9153601074218750e+02 1.3435398864746094e+02 -1.4162699890136719e+02 -5.5228002929687500e+02 1.3077099609375000e+02 -1.4121200561523438e+02 -5.6478698730468750e+02 1.1401200103759766e+02 -1.4056399536132812e+02 -5.8429302978515625e+02 1.2379799652099609e+02 -1.4084799194335938e+02 -5.7575500488281250e+02 1.0221700286865234e+02 -1.4038400268554688e+02 -5.8970703125000000e+02 3.4906101226806641e+01 -1.0644999694824219e+02 -5.5800799560546875e+02 3.4906101226806641e+01 1.0644999694824219e+02 -5.5800799560546875e+02 3.9415901184082031e+01 -1.0661100006103516e+02 -5.7030303955078125e+02 3.9415901184082031e+01 1.0661100006103516e+02 -5.7030303955078125e+02 4.6657497406005859e+01 -1.0675399780273438e+02 -5.8121398925781250e+02 4.6657497406005859e+01 1.0675399780273438e+02 -5.8121398925781250e+02 5.6235099792480469e+01 -1.0687100219726562e+02 -5.9014398193359375e+02 5.6235099792480469e+01 1.0687100219726562e+02 -5.9014398193359375e+02 6.7625000000000000e+01 -1.0695500183105469e+02 -5.9660601806640625e+02 6.7625000000000000e+01 1.0695500183105469e+02 -5.9660601806640625e+02 1.3676199340820312e+02 1.0659100341796875e+02 -5.6876599121093750e+02 1.4144299316406250e+02 1.0640999603271484e+02 -5.5492199707031250e+02 8.9375000000000000e+01 1.0697399902343750e+02 -5.9802899169921875e+02 6.7625000000000000e+01 1.0697399902343750e+02 -5.9802899169921875e+02 1.0384899902343750e+02 1.0694800567626953e+02 -5.9601403808593750e+02 1.1722200012207031e+02 1.0687100219726562e+02 -5.9012402343750000e+02 1.2847900390625000e+02 1.0674900054931641e+02 -5.8080499267578125e+02 8.9375000000000000e+01 -1.0697399902343750e+02 -5.9802899169921875e+02 6.7625000000000000e+01 -1.0697399902343750e+02 -5.9802899169921875e+02 1.4050100708007812e+02 -1.0646299743652344e+02 -5.5899603271484375e+02 1.3474400329589844e+02 -1.0663899993896484e+02 -5.7242797851562500e+02 9.9784202575683594e+01 -1.0696099853515625e+02 -5.9699700927734375e+02 1.2553699493408203e+02 -1.0678800201416016e+02 -5.8377600097656250e+02 1.1358100128173828e+02 -1.0689800262451172e+02 -5.9217901611328125e+02 6.7625000000000000e+01 -1.0798200225830078e+02 -5.9973901367187500e+02 6.7625000000000000e+01 -1.0725100708007812e+02 -5.9901800537109375e+02 6.7625000000000000e+01 1.0798200225830078e+02 -5.9973901367187500e+02 6.7625000000000000e+01 1.0725100708007812e+02 -5.9901800537109375e+02 8.9375000000000000e+01 1.0727899932861328e+02 -5.9899902343750000e+02 8.9375000000000000e+01 1.0756900024414062e+02 -5.9942596435546875e+02 1.0423299407958984e+02 1.0754199981689453e+02 -5.9735900878906250e+02 1.4219400024414062e+02 1.0656400299072266e+02 -5.5506298828125000e+02 1.4283099365234375e+02 1.0699700164794922e+02 -5.5517797851562500e+02 1.4325700378417969e+02 1.0764600372314453e+02 -5.5525097656250000e+02 1.3841200256347656e+02 1.0782799530029297e+02 -5.6957604980468750e+02 1.2983799743652344e+02 1.0798699951171875e+02 -5.8203204345703125e+02 1.1818999481201172e+02 1.0811000061035156e+02 -5.9167395019531250e+02 1.3744400024414062e+02 1.0674700164794922e+02 -5.6910504150390625e+02 1.2904100036621094e+02 1.0690599822998047e+02 -5.8131597900390625e+02 1.1762200164794922e+02 1.0702899932861328e+02 -5.9076800537109375e+02 1.0405599975585938e+02 1.0710700225830078e+02 -5.9674298095703125e+02 8.9375000000000000e+01 1.0713400268554688e+02 -5.9878601074218750e+02 1.3802301025390625e+02 1.0718099975585938e+02 -5.6939001464843750e+02 1.2951800537109375e+02 1.0734099578857422e+02 -5.8174700927734375e+02 1.1796099853515625e+02 1.0746399688720703e+02 -5.9131298828125000e+02 1.0435099792480469e+02 1.0818800354003906e+02 -5.9776904296875000e+02 8.9375000000000000e+01 1.0800000000000000e+02 -5.9971099853515625e+02 8.9375000000000000e+01 1.0821499633789062e+02 -5.9985296630859375e+02 8.9375000000000000e+01 -1.0727899932861328e+02 -5.9899902343750000e+02 8.9375000000000000e+01 -1.0713400268554688e+02 -5.9878601074218750e+02 9.9933403015136719e+01 -1.0712000274658203e+02 -5.9773895263671875e+02 1.4186300659179688e+02 -1.0705100250244141e+02 -5.5936096191406250e+02 1.4123800659179688e+02 -1.0661700439453125e+02 -5.5919598388671875e+02 8.9375000000000000e+01 -1.0800000000000000e+02 -5.9971099853515625e+02 8.9375000000000000e+01 -1.0756900024414062e+02 -5.9942596435546875e+02 1.0005999755859375e+02 -1.0755500030517578e+02 -5.9836700439453125e+02 1.0014600372314453e+02 -1.0820099639892578e+02 -5.9878497314453125e+02 8.9375000000000000e+01 -1.0821499633789062e+02 -5.9985296630859375e+02 1.1442100524902344e+02 -1.0813699340820312e+02 -5.9379998779296875e+02 1.2679399871826172e+02 -1.0802700042724609e+02 -5.8510705566406250e+02 1.3632200622558594e+02 -1.0787699890136719e+02 -5.7336499023437500e+02 1.1392800140380859e+02 -1.0705599975585938e+02 -5.9285302734375000e+02 1.2605599975585938e+02 -1.0694499969482422e+02 -5.8433001708984375e+02 1.3539599609375000e+02 -1.0679499816894531e+02 -5.7282000732421875e+02 1.1422300720214844e+02 -1.0749100494384766e+02 -5.9342199707031250e+02 1.2649700164794922e+02 -1.0738000488281250e+02 -5.8479699707031250e+02 1.3594999694824219e+02 -1.0723000335693359e+02 -5.7314904785156250e+02 1.4228199768066406e+02 -1.0769899749755859e+02 -5.5946704101562500e+02 -4.4558498382568359e+01 -7.3291503906250000e+01 -6.0600299072265625e+02 -6.1691501617431641e+01 -7.3291503906250000e+01 -6.0600299072265625e+02 -7.8362800598144531e+01 -6.9340301513671875e+01 -6.0600299072265625e+02 -9.3673500061035156e+01 -6.1650997161865234e+01 -6.0600299072265625e+02 -1.0679800415039062e+02 -5.0638099670410156e+01 -6.0600299072265625e+02 -1.1702899932861328e+02 -3.6895198822021484e+01 -6.0600299072265625e+02 -1.2381600189208984e+02 -2.1163299560546875e+01 -6.0600299072265625e+02 -1.2679100036621094e+02 -4.2905201911926270e+00 -6.0600299072265625e+02 -1.2579399108886719e+02 1.2813599586486816e+01 -6.0600299072265625e+02 -1.2088099670410156e+02 2.9226898193359375e+01 -6.0600299072265625e+02 -1.1231400299072266e+02 4.4064601898193359e+01 -6.0600299072265625e+02 -1.0055699920654297e+02 5.6526798248291016e+01 -6.0600299072265625e+02 -8.6241996765136719e+01 6.5941604614257812e+01 -6.0600299072265625e+02 -7.0142204284667969e+01 7.1801399230957031e+01 -6.0600299072265625e+02 -5.3125000000000000e+01 7.3790397644042969e+01 -6.0600299072265625e+02 -3.6107799530029297e+01 7.1801399230957031e+01 -6.0600299072265625e+02 -2.0007999420166016e+01 6.5941604614257812e+01 -6.0600299072265625e+02 -5.6934199333190918e+00 5.6526798248291016e+01 -6.0600299072265625e+02 6.0640201568603516e+00 4.4064601898193359e+01 -6.0600299072265625e+02 1.4630599975585938e+01 2.9226898193359375e+01 -6.0600299072265625e+02 1.9544401168823242e+01 1.2813599586486816e+01 -6.0600299072265625e+02 2.0540599822998047e+01 -4.2905201911926270e+00 -6.0600299072265625e+02 1.7565500259399414e+01 -2.1163299560546875e+01 -6.0600299072265625e+02 1.0779400825500488e+01 -3.6895198822021484e+01 -6.0600299072265625e+02 5.4820001125335693e-01 -5.0638099670410156e+01 -6.0600299072265625e+02 -1.2576499938964844e+01 -6.1650997161865234e+01 -6.0600299072265625e+02 -2.7887199401855469e+01 -6.9340301513671875e+01 -6.0600299072265625e+02 1.8142000198364258e+01 -8.6533403396606445e+00 -6.0600299072265625e+02 1.8142000198364258e+01 8.6533403396606445e+00 -6.0600299072265625e+02 1.4000300407409668e+01 2.5457199096679688e+01 -6.0600299072265625e+02 5.9573798179626465e+00 4.0781597137451172e+01 -6.0600299072265625e+02 -5.5191297531127930e+00 5.3735900878906250e+01 -6.0600299072265625e+02 -1.9762300491333008e+01 6.3567302703857422e+01 -6.0600299072265625e+02 -3.5944396972656250e+01 6.9704299926757812e+01 -6.0600299072265625e+02 -5.3125000000000000e+01 7.1790397644042969e+01 -6.0600299072265625e+02 1.4000300407409668e+01 -2.5457199096679688e+01 -6.0600299072265625e+02 5.9573798179626465e+00 -4.0781597137451172e+01 -6.0600299072265625e+02 -5.5191297531127930e+00 -5.3735900878906250e+01 -6.0600299072265625e+02 -1.9762300491333008e+01 -6.3567302703857422e+01 -6.0600299072265625e+02 -3.5944396972656250e+01 -6.9704299926757812e+01 -6.0600299072265625e+02 -5.3125000000000000e+01 -7.1790397644042969e+01 -6.0600299072265625e+02 -7.0305603027343750e+01 -6.9704299926757812e+01 -6.0600299072265625e+02 -8.6487701416015625e+01 -6.3567302703857422e+01 -6.0600299072265625e+02 -1.0073100280761719e+02 -5.3735900878906250e+01 -6.0600299072265625e+02 -1.1220700073242188e+02 -4.0781597137451172e+01 -6.0600299072265625e+02 -1.2025000000000000e+02 -2.5457199096679688e+01 -6.0600299072265625e+02 -1.2439200592041016e+02 -8.6533403396606445e+00 -6.0600299072265625e+02 -1.2439200592041016e+02 8.6533403396606445e+00 -6.0600299072265625e+02 -1.2025000000000000e+02 2.5457199096679688e+01 -6.0600299072265625e+02 -1.1220700073242188e+02 4.0781597137451172e+01 -6.0600299072265625e+02 -1.0073100280761719e+02 5.3735900878906250e+01 -6.0600299072265625e+02 -8.6487701416015625e+01 6.3567302703857422e+01 -6.0600299072265625e+02 -7.0305603027343750e+01 6.9704299926757812e+01 -6.0600299072265625e+02 -3.5986198425292969e+01 6.9534896850585938e+01 -5.9600299072265625e+02 -1.9843399047851562e+01 6.3412704467773438e+01 -5.9600299072265625e+02 -5.6348900794982910e+00 5.3605300903320312e+01 -5.9600299072265625e+02 5.8137402534484863e+00 4.0682399749755859e+01 -5.9600299072265625e+02 1.3837100028991699e+01 2.5395299911499023e+01 -5.9600299072265625e+02 1.7968698501586914e+01 8.6323003768920898e+00 -5.9600299072265625e+02 1.7968698501586914e+01 -8.6323003768920898e+00 -5.9600299072265625e+02 1.3837100028991699e+01 -2.5395299911499023e+01 -5.9600299072265625e+02 5.8137402534484863e+00 -4.0682399749755859e+01 -5.9600299072265625e+02 -5.6348900794982910e+00 -5.3605300903320312e+01 -5.9600299072265625e+02 -1.9843399047851562e+01 -6.3412704467773438e+01 -5.9600299072265625e+02 -3.5986198425292969e+01 -6.9534896850585938e+01 -5.9600299072265625e+02 -5.3125000000000000e+01 -7.1615898132324219e+01 -5.9600299072265625e+02 -7.0263801574707031e+01 -6.9534896850585938e+01 -5.9600299072265625e+02 -8.6406600952148438e+01 -6.3412704467773438e+01 -5.9600299072265625e+02 -1.0061500549316406e+02 -5.3605300903320312e+01 -5.9600299072265625e+02 -1.1206399536132812e+02 -4.0682399749755859e+01 -5.9600299072265625e+02 -1.2008699798583984e+02 -2.5395299911499023e+01 -5.9600299072265625e+02 -1.2421900177001953e+02 -8.6323003768920898e+00 -5.9600299072265625e+02 -1.2421900177001953e+02 8.6323003768920898e+00 -5.9600299072265625e+02 -1.2008699798583984e+02 2.5395299911499023e+01 -5.9600299072265625e+02 -1.1206399536132812e+02 4.0682399749755859e+01 -5.9600299072265625e+02 -1.0061500549316406e+02 5.3605300903320312e+01 -5.9600299072265625e+02 -8.6406600952148438e+01 6.3412704467773438e+01 -5.9600299072265625e+02 -7.0263801574707031e+01 6.9534896850585938e+01 -5.9600299072265625e+02 -5.3125000000000000e+01 7.1615898132324219e+01 -5.9600299072265625e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 11070 -> 108 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -4.9418899416923523e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -4.9187698960304260e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -4.9000298976898193e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.3076797723770142e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.1152098178863525e+02) (float-vector 1.4018799364566803e+02 1.2820799648761749e+02 -5.2395498752593994e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4018799364566803e+02 1.2820799648761749e+02 -5.2395498752593994e+02) (float-vector 1.4437499642372131e+02 1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.4437499642372131e+02 -1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.3076797723770142e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.5328502357006073e+01 -1.2389499694108963e+02 -5.6339997053146362e+02) (float-vector -9.1351203620433807e+01 -1.2482900172472000e+02 -5.2438998222351074e+02) (float-vector -6.2560401856899261e+01 -1.3702200353145599e+02 -5.1077097654342651e+02) (float-vector -7.0531599223613739e+01 -1.3709299266338348e+02 -5.6235098838806152e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1708400249481201e+01 -1.2778100371360779e+02 -4.9899101257324219e+02) (float-vector -4.8507101833820343e+01 1.3139699399471283e+02 -4.9895301461219788e+02) (float-vector -1.7978699877858162e+01 1.2820799648761749e+02 -4.9101701378822327e+02) (float-vector -1.7946099862456322e+01 -1.3002300262451172e+02 -4.9129599332809448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7451199889183044e+02 2.3025799542665482e+01 -5.4908800125122070e+02) (float-vector -1.7667999863624573e+02 2.5073899887502193e+00 -5.4981100559234619e+02) (float-vector -1.7802199721336365e+02 -9.2909898376092315e-01 -5.6339997053146362e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0142202079296112e+01 7.1801401674747467e+01 -6.0600298643112183e+02) (float-vector 2.0540600642561913e+01 -4.2905202135443687e+00 -6.0600298643112183e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -6.0000300407409668e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.0540600642561913e+01 -4.2905202135443687e+00 -6.0600298643112183e+02) (float-vector -7.0142202079296112e+01 7.1801401674747467e+01 -6.0600298643112183e+02) (float-vector -9.3673497438430786e+01 -6.1650998890399933e+01 -6.0600298643112183e+02) (float-vector -4.4558499008417130e+01 -7.3291502892971039e+01 -6.0600298643112183e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3468100130558014e+02 -7.3975503444671631e+01 -6.0000300407409668e+02) (float-vector -9.3673497438430786e+01 -6.1650998890399933e+01 -6.0600298643112183e+02) (float-vector -7.0142202079296112e+01 7.1801401674747467e+01 -6.0600298643112183e+02) (float-vector -1.4388899505138397e+02 6.8230301141738892e+01 -5.9891802072525024e+02) (float-vector -1.5905800461769104e+02 4.0886301547288895e+01 -5.9891802072525024e+02) (float-vector -1.6456300020217896e+02 1.0291099548339844e+01 -5.9972500801086426e+02) (float-vector -1.5753099322319031e+02 -4.0296800434589386e+01 -5.9972500801086426e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7235000431537628e+02 2.9753299430012703e+01 -5.9110099077224731e+02) (float-vector -1.7258599400520325e+02 9.3687204644083977e+00 -5.9452098608016968e+02) (float-vector -1.6456300020217896e+02 1.0291099548339844e+01 -5.9972500801086426e+02) (float-vector -1.5905800461769104e+02 4.0886301547288895e+01 -5.9891802072525024e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7235000431537628e+02 2.9753299430012703e+01 -5.9110099077224731e+02) (float-vector -1.7683200538158417e+02 9.7020296379923820e+00 -5.8667898178100586e+02) (float-vector -1.7411400377750397e+02 -2.1482199430465698e+01 -5.9110099077224731e+02) (float-vector -1.7258599400520325e+02 9.3687204644083977e+00 -5.9452098608016968e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7258599400520325e+02 9.3687204644083977e+00 -5.9452098608016968e+02) (float-vector -1.7411400377750397e+02 -2.1482199430465698e+01 -5.9110099077224731e+02) (float-vector -1.6528600454330444e+02 -4.2175099253654480e+01 -5.9452098608016968e+02) (float-vector -1.5753099322319031e+02 -4.0296800434589386e+01 -5.9972500801086426e+02) (float-vector -1.6456300020217896e+02 1.0291099548339844e+01 -5.9972500801086426e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6102099418640137e+02 5.8807298541069031e+01 -5.9110099077224731e+02) (float-vector -1.6752000153064728e+02 5.0138600170612335e+01 -5.6339997053146362e+02) (float-vector -1.7235000431537628e+02 2.9753299430012703e+01 -5.9110099077224731e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6102099418640137e+02 5.8807298541069031e+01 -5.9110099077224731e+02) (float-vector -1.4388899505138397e+02 6.8230301141738892e+01 -5.9891802072525024e+02) (float-vector -1.2752899527549744e+02 9.7794197499752045e+01 -5.9110099077224731e+02) (float-vector -1.5082100033760071e+02 7.6504997909069061e+01 -5.8667802810668945e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6102099418640137e+02 5.8807298541069031e+01 -5.9110099077224731e+02) (float-vector -1.7235000431537628e+02 2.9753299430012703e+01 -5.9110099077224731e+02) (float-vector -1.5905800461769104e+02 4.0886301547288895e+01 -5.9891802072525024e+02) (float-vector -1.4388899505138397e+02 6.8230301141738892e+01 -5.9891802072525024e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.0142202079296112e+01 7.1801401674747467e+01 -6.0600298643112183e+02) (float-vector -8.8889598846435547e+01 1.1259700357913971e+02 -5.9972500801086426e+02) (float-vector -1.4388899505138397e+02 6.8230301141738892e+01 -5.9891802072525024e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.8889598846435547e+01 1.1259700357913971e+02 -5.9972500801086426e+02) (float-vector -7.0142202079296112e+01 7.1801401674747467e+01 -6.0600298643112183e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -6.0000300407409668e+02) (float-vector -4.0497500449419022e+01 1.3165000081062317e+02 -5.9891802072525024e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0400000214576721e+02 1.1648999899625778e+02 -5.2881997823715210e+02) (float-vector -7.5755402445793152e+01 1.3198600709438324e+02 -5.1492702960968018e+02) (float-vector -8.0258503556251526e+01 1.1806699633598328e+02 -5.0938200950622559e+02) (float-vector -1.2673500180244446e+02 9.5092996954917908e+01 -5.3020602464675903e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.5923801660537720e+02) (float-vector 1.4437499642372131e+02 -1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.4437499642372131e+02 1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.4250099658966064e+02 1.2820799648761749e+02 -5.5923801660537720e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.5923801660537720e+02) (float-vector 1.4250099658966064e+02 1.2820799648761749e+02 -5.5923801660537720e+02) (float-vector 1.3300900161266327e+02 1.2820799648761749e+02 -5.7848501205444336e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.7848501205444336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3401800394058228e+02 1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.3300900161266327e+02 1.2820799648761749e+02 -5.7848501205444336e+02) (float-vector 1.4250099658966064e+02 1.2820799648761749e+02 -5.5923801660537720e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.8863699436187744e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -5.9581601619720459e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -5.9812897443771362e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.8863699436187744e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.7848501205444336e+02) (float-vector 1.3300900161266327e+02 1.2820799648761749e+02 -5.7848501205444336e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -5.9581601619720459e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -4.9000298976898193e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -4.9187698960304260e+02) (float-vector 8.9374996721744537e+01 -1.3165000081062317e+02 -4.9108800292015076e+02) (float-vector -1.7946099862456322e+01 -1.3002300262451172e+02 -4.9129599332809448e+02) (float-vector -1.7978699877858162e+01 1.2820799648761749e+02 -4.9101701378822327e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7451199889183044e+02 2.3025799542665482e+01 -5.4908800125122070e+02) (float-vector -1.7009599506855011e+02 4.2576901614665985e+01 -5.5134302377700806e+02) (float-vector -1.5570700168609619e+02 6.8414896726608276e+01 -5.4280000925064087e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7683200538158417e+02 9.7020296379923820e+00 -5.8667898178100586e+02) (float-vector -1.7235000431537628e+02 2.9753299430012703e+01 -5.9110099077224731e+02) (float-vector -1.6752000153064728e+02 5.0138600170612335e+01 -5.6339997053146362e+02) (float-vector -1.7009599506855011e+02 4.2576901614665985e+01 -5.5134302377700806e+02) (float-vector -1.7451199889183044e+02 2.3025799542665482e+01 -5.4908800125122070e+02) (float-vector -1.7802199721336365e+02 -9.2909898376092315e-01 -5.6339997053146362e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7009599506855011e+02 4.2576901614665985e+01 -5.5134302377700806e+02) (float-vector -1.6752000153064728e+02 5.0138600170612335e+01 -5.6339997053146362e+02) (float-vector -1.6102099418640137e+02 5.8807298541069031e+01 -5.9110099077224731e+02) (float-vector -1.5082100033760071e+02 7.6504997909069061e+01 -5.8667802810668945e+02) (float-vector -1.5570700168609619e+02 6.8414896726608276e+01 -5.4280000925064087e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9374996721744537e+01 -1.3001200556755066e+02 -5.9972500801086426e+02) (float-vector 2.0540600642561913e+01 -4.2905202135443687e+00 -6.0600298643112183e+02) (float-vector -4.4558499008417130e+01 -7.3291502892971039e+01 -6.0600298643112183e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9374996721744537e+01 -1.3001200556755066e+02 -5.9972500801086426e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -5.9812897443771362e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -5.9581601619720459e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -6.0000300407409668e+02) (float-vector 2.0540600642561913e+01 -4.2905202135443687e+00 -6.0600298643112183e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2752899527549744e+02 9.7794197499752045e+01 -5.9110099077224731e+02) (float-vector -9.0306401252746582e+01 1.2110099941492081e+02 -5.9452497959136963e+02) (float-vector -8.4962196648120880e+01 1.2927100062370300e+02 -5.8667701482772827e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.8889598846435547e+01 1.1259700357913971e+02 -5.9972500801086426e+02) (float-vector -9.0306401252746582e+01 1.2110099941492081e+02 -5.9452497959136963e+02) (float-vector -1.2752899527549744e+02 9.7794197499752045e+01 -5.9110099077224731e+02) (float-vector -1.4388899505138397e+02 6.8230301141738892e+01 -5.9891802072525024e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3541500270366669e+02 9.2871800065040588e+01 -5.4004001617431641e+02) (float-vector -1.5570700168609619e+02 6.8414896726608276e+01 -5.4280000925064087e+02) (float-vector -1.5082100033760071e+02 7.6504997909069061e+01 -5.8667802810668945e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2752899527549744e+02 9.7794197499752045e+01 -5.9110099077224731e+02) (float-vector -1.3541500270366669e+02 9.2871800065040588e+01 -5.4004001617431641e+02) (float-vector -1.5082100033760071e+02 7.6504997909069061e+01 -5.8667802810668945e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3541500270366669e+02 9.2871800065040588e+01 -5.4004001617431641e+02) (float-vector -1.2673500180244446e+02 9.5092996954917908e+01 -5.3020602464675903e+02) (float-vector -1.5570700168609619e+02 6.8414896726608276e+01 -5.4280000925064087e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3541500270366669e+02 9.2871800065040588e+01 -5.4004001617431641e+02) (float-vector -1.0400000214576721e+02 1.1648999899625778e+02 -5.2881997823715210e+02) (float-vector -1.2673500180244446e+02 9.5092996954917908e+01 -5.3020602464675903e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3541500270366669e+02 9.2871800065040588e+01 -5.4004001617431641e+02) (float-vector -1.2752899527549744e+02 9.7794197499752045e+01 -5.9110099077224731e+02) (float-vector -8.4962196648120880e+01 1.2927100062370300e+02 -5.8667701482772827e+02) (float-vector -1.0400000214576721e+02 1.1648999899625778e+02 -5.2881997823715210e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.0136798620223999e+02) (float-vector 1.2285699695348740e+02 1.2820799648761749e+02 -5.0136798620223999e+02) (float-vector 1.3214799761772156e+02 1.3165000081062317e+02 -5.1218199729919434e+02) (float-vector 1.4018799364566803e+02 1.2820799648761749e+02 -5.2395498752593994e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.1152098178863525e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4250099658966064e+02 1.2820799648761749e+02 -5.5923801660537720e+02) (float-vector 1.4437499642372131e+02 1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.3638399541378021e+02 1.4080600440502167e+02 -5.4500299692153931e+02) (float-vector 1.3401800394058228e+02 1.3811400532722473e+02 -5.6612700223922729e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4437499642372131e+02 1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.4018799364566803e+02 1.2820799648761749e+02 -5.2395498752593994e+02) (float-vector 1.3214799761772156e+02 1.3165000081062317e+02 -5.1218199729919434e+02) (float-vector 1.2841899693012238e+02 1.4106099307537079e+02 -5.2068799734115601e+02) (float-vector 1.3638399541378021e+02 1.4080600440502167e+02 -5.4500299692153931e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3401800394058228e+02 1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.1401200294494629e+02 1.4056399464607239e+02 -5.8429300785064697e+02) (float-vector 1.3300900161266327e+02 1.2820799648761749e+02 -5.7848501205444336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.0136798620223999e+02) (float-vector 1.1000700294971466e+02 -1.3165000081062317e+02 -4.9519199132919312e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -4.9187698960304260e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -4.9418899416923523e+02) (float-vector 1.2285699695348740e+02 1.2820799648761749e+02 -5.0136798620223999e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2121099084615707e+01 -1.4212100207805634e+02 -5.5767101049423218e+02) (float-vector -7.0531599223613739e+01 -1.3709299266338348e+02 -5.6235098838806152e+02) (float-vector -6.2560401856899261e+01 -1.3702200353145599e+02 -5.1077097654342651e+02) (float-vector -4.2808901518583298e+01 -1.4145399630069733e+02 -5.0941997766494751e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1708400249481201e+01 -1.2778100371360779e+02 -4.9899101257324219e+02) (float-vector -8.1321597099304199e+01 -1.2056899815797806e+02 -5.1054298877716064e+02) (float-vector -1.2673500180244446e+02 -9.5093399286270142e+01 -5.3020602464675903e+02) (float-vector -1.5542300045490265e+02 -5.3977701812982559e+01 -5.3723597526550293e+02) (float-vector -1.6675899922847748e+02 -9.8441801965236664e+00 -5.4086601734161377e+02) (float-vector -1.7451199889183044e+02 2.3025799542665482e+01 -5.4908800125122070e+02) (float-vector -1.5570700168609619e+02 6.8414896726608276e+01 -5.4280000925064087e+02) (float-vector -1.2673500180244446e+02 9.5092996954917908e+01 -5.3020602464675903e+02) (float-vector -8.0258503556251526e+01 1.1806699633598328e+02 -5.0938200950622559e+02) (float-vector -4.8507101833820343e+01 1.3139699399471283e+02 -4.9895301461219788e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5393699705600739e+02 -7.0261597633361816e+01 -5.9110099077224731e+02) (float-vector -1.6927100718021393e+02 -4.3674498796463013e+01 -5.8667898178100586e+02) (float-vector -1.6478699445724487e+02 -5.4877601563930511e+01 -5.4961699247360229e+02) (float-vector -1.4896999299526215e+02 -7.9050503671169281e+01 -5.4446500539779663e+02) (float-vector -1.4353699982166290e+02 -8.4979198873043060e+01 -5.8667802810668945e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7411400377750397e+02 -2.1482199430465698e+01 -5.9110099077224731e+02) (float-vector -1.6927100718021393e+02 -4.3674498796463013e+01 -5.8667898178100586e+02) (float-vector -1.5393699705600739e+02 -7.0261597633361816e+01 -5.9110099077224731e+02) (float-vector -1.6528600454330444e+02 -4.2175099253654480e+01 -5.9452098608016968e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4353699982166290e+02 -8.4979198873043060e+01 -5.8667802810668945e+02) (float-vector -1.3345700502395630e+02 -8.8913798332214355e+01 -5.9452098608016968e+02) (float-vector -1.5393699705600739e+02 -7.0261597633361816e+01 -5.9110099077224731e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6528600454330444e+02 -4.2175099253654480e+01 -5.9452098608016968e+02) (float-vector -1.5393699705600739e+02 -7.0261597633361816e+01 -5.9110099077224731e+02) (float-vector -1.3345700502395630e+02 -8.8913798332214355e+01 -5.9452098608016968e+02) (float-vector -1.3468100130558014e+02 -7.3975503444671631e+01 -6.0000300407409668e+02) (float-vector -1.5753099322319031e+02 -4.0296800434589386e+01 -5.9972500801086426e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5050299763679504e+01 -1.2783600389957428e+02 -5.9110099077224731e+02) (float-vector -1.3345700502395630e+02 -8.8913798332214355e+01 -5.9452098608016968e+02) (float-vector -1.4353699982166290e+02 -8.4979198873043060e+01 -5.8667802810668945e+02) (float-vector -1.3578799366950989e+02 -9.3631498515605927e+01 -5.6339997053146362e+02) (float-vector -9.5328502357006073e+01 -1.2389499694108963e+02 -5.6339997053146362e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3214799761772156e+02 1.3165000081062317e+02 -5.1218199729919434e+02) (float-vector 1.2268599867820740e+02 1.3765299320220947e+02 -5.0810301303863525e+02) (float-vector 1.2841899693012238e+02 1.4106099307537079e+02 -5.2068799734115601e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0441400855779648e+01 1.3504099845886230e+02 -5.9459000825881958e+02) (float-vector -4.1705999523401260e+01 1.4066299796104431e+02 -5.9125602245330811e+02) (float-vector -6.1497699469327927e+01 1.3916799426078796e+02 -5.8669501543045044e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.0306401252746582e+01 1.2110099941492081e+02 -5.9452497959136963e+02) (float-vector -6.0441400855779648e+01 1.3504099845886230e+02 -5.9459000825881958e+02) (float-vector -6.1497699469327927e+01 1.3916799426078796e+02 -5.8669501543045044e+02) (float-vector -8.4962196648120880e+01 1.2927100062370300e+02 -5.8667701482772827e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.0441400855779648e+01 1.3504099845886230e+02 -5.9459000825881958e+02) (float-vector -9.0306401252746582e+01 1.2110099941492081e+02 -5.9452497959136963e+02) (float-vector -8.8889598846435547e+01 1.1259700357913971e+02 -5.9972500801086426e+02) (float-vector -4.0497500449419022e+01 1.3165000081062317e+02 -5.9891802072525024e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -5.9581601619720459e+02) (float-vector 1.0321799665689468e+02 1.3732899725437164e+02 -5.9298402070999146e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -6.0000300407409668e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0321799665689468e+02 1.3732899725437164e+02 -5.9298402070999146e+02) (float-vector -4.1705999523401260e+01 1.4066299796104431e+02 -5.9125602245330811e+02) (float-vector -6.0441400855779648e+01 1.3504099845886230e+02 -5.9459000825881958e+02) (float-vector -4.0497500449419022e+01 1.3165000081062317e+02 -5.9891802072525024e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -6.0000300407409668e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1401200294494629e+02 1.4056399464607239e+02 -5.8429300785064697e+02) (float-vector 1.0321799665689468e+02 1.3732899725437164e+02 -5.9298402070999146e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -5.9581601619720459e+02) (float-vector 1.3300900161266327e+02 1.2820799648761749e+02 -5.7848501205444336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.1587300598621368e+01 -1.3763199746608734e+02 -5.0122499465942383e+02) (float-vector -5.1708400249481201e+01 -1.2778100371360779e+02 -4.9899101257324219e+02) (float-vector -1.7946099862456322e+01 -1.3002300262451172e+02 -4.9129599332809448e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1708400249481201e+01 -1.2778100371360779e+02 -4.9899101257324219e+02) (float-vector -4.1587300598621368e+01 -1.3763199746608734e+02 -5.0122499465942383e+02) (float-vector -6.2560401856899261e+01 -1.3702200353145599e+02 -5.1077097654342651e+02) (float-vector -8.1321597099304199e+01 -1.2056899815797806e+02 -5.1054298877716064e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9374996721744537e+01 -1.3727000355720520e+02 -4.9502399563789368e+02) (float-vector -1.1391099542379379e+01 -1.4032299816608429e+02 -4.9885898828506470e+02) (float-vector -4.1587300598621368e+01 -1.3763199746608734e+02 -5.0122499465942383e+02) (float-vector -1.7946099862456322e+01 -1.3002300262451172e+02 -4.9129599332809448e+02) (float-vector 8.9374996721744537e+01 -1.3165000081062317e+02 -4.9108800292015076e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.2560401856899261e+01 -1.3702200353145599e+02 -5.1077097654342651e+02) (float-vector -4.1587300598621368e+01 -1.3763199746608734e+02 -5.0122499465942383e+02) (float-vector -1.1391099542379379e+01 -1.4032299816608429e+02 -4.9885898828506470e+02) (float-vector -4.2808901518583298e+01 -1.4145399630069733e+02 -5.0941997766494751e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5542300045490265e+02 -5.3977701812982559e+01 -5.3723597526550293e+02) (float-vector -1.6911099851131439e+02 -3.4549601376056671e+01 -5.4483097791671753e+02) (float-vector -1.6675899922847748e+02 -9.8441801965236664e+00 -5.4086601734161377e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4723299443721771e+02 -7.5462497770786285e+01 -5.3728801012039185e+02) (float-vector -1.5542300045490265e+02 -5.3977701812982559e+01 -5.3723597526550293e+02) (float-vector -1.2673500180244446e+02 -9.5093399286270142e+01 -5.3020602464675903e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.2121099084615707e+01 -1.4212100207805634e+02 -5.5767101049423218e+02) (float-vector -6.5253101289272308e+01 -1.3805900514125824e+02 -5.8669298887252808e+02) (float-vector -7.0531599223613739e+01 -1.3709299266338348e+02 -5.6235098838806152e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.3995502889156342e+01 -1.3398900628089905e+02 -5.9456902742385864e+02) (float-vector -6.5253101289272308e+01 -1.3805900514125824e+02 -5.8669298887252808e+02) (float-vector -4.0524698793888092e+01 -1.4066399633884430e+02 -5.9126901626586914e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.5253101289272308e+01 -1.3805900514125824e+02 -5.8669298887252808e+02) (float-vector -6.3995502889156342e+01 -1.3398900628089905e+02 -5.9456902742385864e+02) (float-vector -8.5050299763679504e+01 -1.2783600389957428e+02 -5.9110099077224731e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.5253101289272308e+01 -1.3805900514125824e+02 -5.8669298887252808e+02) (float-vector -8.5050299763679504e+01 -1.2783600389957428e+02 -5.9110099077224731e+02) (float-vector -9.5328502357006073e+01 -1.2389499694108963e+02 -5.6339997053146362e+02) (float-vector -7.0531599223613739e+01 -1.3709299266338348e+02 -5.6235098838806152e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6208403110504150e+01 -1.1433099955320358e+02 -5.9972500801086426e+02) (float-vector -6.3995502889156342e+01 -1.3398900628089905e+02 -5.9456902742385864e+02) (float-vector -4.7017399221658707e+01 -1.2968100607395172e+02 -5.9972500801086426e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3345700502395630e+02 -8.8913798332214355e+01 -5.9452098608016968e+02) (float-vector -8.6208403110504150e+01 -1.1433099955320358e+02 -5.9972500801086426e+02) (float-vector -1.3468100130558014e+02 -7.3975503444671631e+01 -6.0000300407409668e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6208403110504150e+01 -1.1433099955320358e+02 -5.9972500801086426e+02) (float-vector -9.3673497438430786e+01 -6.1650998890399933e+01 -6.0600298643112183e+02) (float-vector -1.3468100130558014e+02 -7.3975503444671631e+01 -6.0000300407409668e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.3673497438430786e+01 -6.1650998890399933e+01 -6.0600298643112183e+02) (float-vector -8.6208403110504150e+01 -1.1433099955320358e+02 -5.9972500801086426e+02) (float-vector -4.7017399221658707e+01 -1.2968100607395172e+02 -5.9972500801086426e+02) (float-vector 8.9374996721744537e+01 -1.3001200556755066e+02 -5.9972500801086426e+02) (float-vector -4.4558499008417130e+01 -7.3291502892971039e+01 -6.0600298643112183e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.3995502889156342e+01 -1.3398900628089905e+02 -5.9456902742385864e+02) (float-vector -8.6208403110504150e+01 -1.1433099955320358e+02 -5.9972500801086426e+02) (float-vector -1.3345700502395630e+02 -8.8913798332214355e+01 -5.9452098608016968e+02) (float-vector -8.5050299763679504e+01 -1.2783600389957428e+02 -5.9110099077224731e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0760100185871124e+02 1.4167900383472443e+02 -5.0716698169708252e+02) (float-vector -5.6532997405156493e-01 1.4032299816608429e+02 -4.9844399094581604e+02) (float-vector -2.7227399870753288e+01 1.4300000667572021e+02 -5.4882097244262695e+02) (float-vector 1.1401200294494629e+02 1.4056399464607239e+02 -5.8429300785064697e+02) (float-vector 1.3401800394058228e+02 1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.3638399541378021e+02 1.4080600440502167e+02 -5.4500299692153931e+02) (float-vector 1.2841899693012238e+02 1.4106099307537079e+02 -5.2068799734115601e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.6208399832248688e+01 1.3696099817752838e+02 -5.1642698049545288e+02) (float-vector -7.5755402445793152e+01 1.3198600709438324e+02 -5.1492702960968018e+02) (float-vector -1.0400000214576721e+02 1.1648999899625778e+02 -5.2881997823715210e+02) (float-vector -8.4962196648120880e+01 1.2927100062370300e+02 -5.8667701482772827e+02) (float-vector -6.1497699469327927e+01 1.3916799426078796e+02 -5.8669501543045044e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7507299780845642e+02 -2.6991300284862518e+01 -5.6339997053146362e+02) (float-vector -1.6927100718021393e+02 -4.3674498796463013e+01 -5.8667898178100586e+02) (float-vector -1.7411400377750397e+02 -2.1482199430465698e+01 -5.9110099077224731e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7802199721336365e+02 -9.2909898376092315e-01 -5.6339997053146362e+02) (float-vector -1.7507299780845642e+02 -2.6991300284862518e+01 -5.6339997053146362e+02) (float-vector -1.7411400377750397e+02 -2.1482199430465698e+01 -5.9110099077224731e+02) (float-vector -1.7683200538158417e+02 9.7020296379923820e+00 -5.8667898178100586e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3578799366950989e+02 -9.3631498515605927e+01 -5.6339997053146362e+02) (float-vector -1.3362300395965576e+02 -9.4340503215789795e+01 -5.3945100307464600e+02) (float-vector -9.1351203620433807e+01 -1.2482900172472000e+02 -5.2438998222351074e+02) (float-vector -9.5328502357006073e+01 -1.2389499694108963e+02 -5.6339997053146362e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4723299443721771e+02 -7.5462497770786285e+01 -5.3728801012039185e+02) (float-vector -1.2673500180244446e+02 -9.5093399286270142e+01 -5.3020602464675903e+02) (float-vector -1.3362300395965576e+02 -9.4340503215789795e+01 -5.3945100307464600e+02) (float-vector -1.4896999299526215e+02 -7.9050503671169281e+01 -5.4446500539779663e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4896999299526215e+02 -7.9050503671169281e+01 -5.4446500539779663e+02) (float-vector -1.3362300395965576e+02 -9.4340503215789795e+01 -5.3945100307464600e+02) (float-vector -1.3578799366950989e+02 -9.3631498515605927e+01 -5.6339997053146362e+02) (float-vector -1.4353699982166290e+02 -8.4979198873043060e+01 -5.8667802810668945e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3362300395965576e+02 -9.4340503215789795e+01 -5.3945100307464600e+02) (float-vector -1.2673500180244446e+02 -9.5093399286270142e+01 -5.3020602464675903e+02) (float-vector -8.1321597099304199e+01 -1.2056899815797806e+02 -5.1054298877716064e+02) (float-vector -6.2560401856899261e+01 -1.3702200353145599e+02 -5.1077097654342651e+02) (float-vector -9.1351203620433807e+01 -1.2482900172472000e+02 -5.2438998222351074e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0760100185871124e+02 1.4167900383472443e+02 -5.0716698169708252e+02) (float-vector 8.9374996721744537e+01 1.4032299816608429e+02 -4.9844399094581604e+02) (float-vector -5.6532997405156493e-01 1.4032299816608429e+02 -4.9844399094581604e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1401200294494629e+02 1.4056399464607239e+02 -5.8429300785064697e+02) (float-vector -2.7227399870753288e+01 1.4300000667572021e+02 -5.4882097244262695e+02) (float-vector -4.9587100744247437e+01 1.4246299862861633e+02 -5.5674898624420166e+02) (float-vector -6.1497699469327927e+01 1.3916799426078796e+02 -5.8669501543045044e+02) (float-vector -4.1705999523401260e+01 1.4066299796104431e+02 -5.9125602245330811e+02) (float-vector 1.0321799665689468e+02 1.3732899725437164e+02 -5.9298402070999146e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.6208399832248688e+01 1.3696099817752838e+02 -5.1642698049545288e+02) (float-vector -4.7208398580551147e+01 1.3999900221824646e+02 -5.0603497028350830e+02) (float-vector -7.5755402445793152e+01 1.3198600709438324e+02 -5.1492702960968018e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.9587100744247437e+01 1.4246299862861633e+02 -5.5674898624420166e+02) (float-vector -4.7208398580551147e+01 1.3999900221824646e+02 -5.0603497028350830e+02) (float-vector -6.6208399832248688e+01 1.3696099817752838e+02 -5.1642698049545288e+02) (float-vector -6.1497699469327927e+01 1.3916799426078796e+02 -5.8669501543045044e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7208398580551147e+01 1.3999900221824646e+02 -5.0603497028350830e+02) (float-vector -4.8507101833820343e+01 1.3139699399471283e+02 -4.9895301461219788e+02) (float-vector -8.0258503556251526e+01 1.1806699633598328e+02 -5.0938200950622559e+02) (float-vector -7.5755402445793152e+01 1.3198600709438324e+02 -5.1492702960968018e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7208398580551147e+01 1.3999900221824646e+02 -5.0603497028350830e+02) (float-vector -2.2597499191761017e+01 1.3726000487804413e+02 -4.9669998884201050e+02) (float-vector -1.7978699877858162e+01 1.2820799648761749e+02 -4.9101701378822327e+02) (float-vector -4.8507101833820343e+01 1.3139699399471283e+02 -4.9895301461219788e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2597499191761017e+01 1.3726000487804413e+02 -4.9669998884201050e+02) (float-vector -4.7208398580551147e+01 1.3999900221824646e+02 -5.0603497028350830e+02) (float-vector -4.9587100744247437e+01 1.4246299862861633e+02 -5.5674898624420166e+02) (float-vector -2.7227399870753288e+01 1.4300000667572021e+02 -5.4882097244262695e+02) (float-vector -5.6532997405156493e-01 1.4032299816608429e+02 -4.9844399094581604e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3401800394058228e+02 -1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.5923801660537720e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.7848501205444336e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.3076797723770142e+02) (float-vector 1.3399399816989899e+02 -1.3811300694942474e+02 -5.2382498979568481e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.1152098178863525e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6675899922847748e+02 -9.8441801965236664e+00 -5.4086601734161377e+02) (float-vector -1.6911099851131439e+02 -3.4549601376056671e+01 -5.4483097791671753e+02) (float-vector -1.7379300296306610e+02 -2.6495000347495079e+01 -5.4884797334671021e+02) (float-vector -1.7667999863624573e+02 2.5073899887502193e+00 -5.4981100559234619e+02) (float-vector -1.7451199889183044e+02 2.3025799542665482e+01 -5.4908800125122070e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7507299780845642e+02 -2.6991300284862518e+01 -5.6339997053146362e+02) (float-vector -1.7802199721336365e+02 -9.2909898376092315e-01 -5.6339997053146362e+02) (float-vector -1.7667999863624573e+02 2.5073899887502193e+00 -5.4981100559234619e+02) (float-vector -1.7379300296306610e+02 -2.6495000347495079e+01 -5.4884797334671021e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7507299780845642e+02 -2.6991300284862518e+01 -5.6339997053146362e+02) (float-vector -1.7379300296306610e+02 -2.6495000347495079e+01 -5.4884797334671021e+02) (float-vector -1.6478699445724487e+02 -5.4877601563930511e+01 -5.4961699247360229e+02) (float-vector -1.6927100718021393e+02 -4.3674498796463013e+01 -5.8667898178100586e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6478699445724487e+02 -5.4877601563930511e+01 -5.4961699247360229e+02) (float-vector -1.7379300296306610e+02 -2.6495000347495079e+01 -5.4884797334671021e+02) (float-vector -1.6911099851131439e+02 -3.4549601376056671e+01 -5.4483097791671753e+02) (float-vector -1.5542300045490265e+02 -5.3977701812982559e+01 -5.3723597526550293e+02) (float-vector -1.4723299443721771e+02 -7.5462497770786285e+01 -5.3728801012039185e+02) (float-vector -1.4896999299526215e+02 -7.9050503671169281e+01 -5.4446500539779663e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0216499865055084e+02 1.3733300566673279e+02 -4.9717599153518677e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -4.9418899416923523e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -4.9000298976898193e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0216499865055084e+02 1.3733300566673279e+02 -4.9717599153518677e+02) (float-vector 1.2268599867820740e+02 1.3765299320220947e+02 -5.0810301303863525e+02) (float-vector 1.3214799761772156e+02 1.3165000081062317e+02 -5.1218199729919434e+02) (float-vector 1.2285699695348740e+02 1.2820799648761749e+02 -5.0136798620223999e+02) (float-vector 1.1042299866676331e+02 1.2820799648761749e+02 -4.9418899416923523e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2597499191761017e+01 1.3726000487804413e+02 -4.9669998884201050e+02) (float-vector -5.6532997405156493e-01 1.4032299816608429e+02 -4.9844399094581604e+02) (float-vector 8.9374996721744537e+01 1.4032299816608429e+02 -4.9844399094581604e+02) (float-vector 1.0216499865055084e+02 1.3733300566673279e+02 -4.9717599153518677e+02) (float-vector 8.9374996721744537e+01 1.2820799648761749e+02 -4.9000298976898193e+02) (float-vector -1.7978699877858162e+01 1.2820799648761749e+02 -4.9101701378822327e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9374996721744537e+01 1.4032299816608429e+02 -4.9844399094581604e+02) (float-vector 1.0760100185871124e+02 1.4167900383472443e+02 -5.0716698169708252e+02) (float-vector 1.2841899693012238e+02 1.4106099307537079e+02 -5.2068799734115601e+02) (float-vector 1.2268599867820740e+02 1.3765299320220947e+02 -5.0810301303863525e+02) (float-vector 1.0216499865055084e+02 1.3733300566673279e+02 -4.9717599153518677e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.3995502889156342e+01 -1.3398900628089905e+02 -5.9456902742385864e+02) (float-vector -4.0524698793888092e+01 -1.4066399633884430e+02 -5.9126901626586914e+02) (float-vector 1.0221700370311737e+02 -1.4038400352001190e+02 -5.8970701694488525e+02) (float-vector 8.9374996721744537e+01 -1.3001200556755066e+02 -5.9972500801086426e+02) (float-vector -4.7017399221658707e+01 -1.2968100607395172e+02 -5.9972500801086426e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2808901518583298e+01 -1.4145399630069733e+02 -5.0941997766494751e+02) (float-vector -1.1391099542379379e+01 -1.4032299816608429e+02 -4.9885898828506470e+02) (float-vector 8.9374996721744537e+01 -1.3727000355720520e+02 -4.9502399563789368e+02) (float-vector 1.1398900300264359e+02 -1.4056399464607239e+02 -5.0569897890090942e+02) (float-vector 1.3399399816989899e+02 -1.3811300694942474e+02 -5.2382498979568481e+02) (float-vector 1.2979899346828461e+02 -1.4276599884033203e+02 -5.5171602964401245e+02) (float-vector -5.2121099084615707e+01 -1.4212100207805634e+02 -5.5767101049423218e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 8.9374996721744537e+01 -1.3727000355720520e+02 -4.9502399563789368e+02) (float-vector 8.9374996721744537e+01 -1.3165000081062317e+02 -4.9108800292015076e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -4.9187698960304260e+02) (float-vector 1.1000700294971466e+02 -1.3165000081062317e+02 -4.9519199132919312e+02) (float-vector 1.1398900300264359e+02 -1.4056399464607239e+02 -5.0569897890090942e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3399399816989899e+02 -1.3811300694942474e+02 -5.2382498979568481e+02) (float-vector 1.1398900300264359e+02 -1.4056399464607239e+02 -5.0569897890090942e+02) (float-vector 1.1000700294971466e+02 -1.3165000081062317e+02 -4.9519199132919312e+02) (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.0136798620223999e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.1152098178863525e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3399399816989899e+02 -1.3811300694942474e+02 -5.2382498979568481e+02) (float-vector 1.3833199441432953e+02 -1.3873000442981720e+02 -5.4500299692153931e+02) (float-vector 1.2979899346828461e+02 -1.4276599884033203e+02 -5.5171602964401245e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.5923801660537720e+02) (float-vector 1.3401800394058228e+02 -1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.3833199441432953e+02 -1.3873000442981720e+02 -5.4500299692153931e+02) (float-vector 1.4437499642372131e+02 -1.2820799648761749e+02 -5.4500299692153931e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.3399399816989899e+02 -1.3811300694942474e+02 -5.2382498979568481e+02) (float-vector 1.4250099658966064e+02 -1.2820799648761749e+02 -5.3076797723770142e+02) (float-vector 1.4437499642372131e+02 -1.2820799648761749e+02 -5.4500299692153931e+02) (float-vector 1.3833199441432953e+02 -1.3873000442981720e+02 -5.4500299692153931e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.1593600362539291e+02 -1.3750000298023224e+02 -5.8714997768402100e+02) (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.8863699436187744e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -5.9812897443771362e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.0221700370311737e+02 -1.4038400352001190e+02 -5.8970701694488525e+02) (float-vector 1.1593600362539291e+02 -1.3750000298023224e+02 -5.8714997768402100e+02) (float-vector 1.0361000150442123e+02 -1.2820799648761749e+02 -5.9812897443771362e+02) (float-vector 8.9374996721744537e+01 -1.3001200556755066e+02 -5.9972500801086426e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2379799783229828e+02 -1.4084799587726593e+02 -5.7575500011444092e+02) (float-vector 1.1593600362539291e+02 -1.3750000298023224e+02 -5.8714997768402100e+02) (float-vector 1.0221700370311737e+02 -1.4038400352001190e+02 -5.8970701694488525e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2379799783229828e+02 -1.4084799587726593e+02 -5.7575500011444092e+02) (float-vector 1.3401800394058228e+02 -1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.3300900161266327e+02 -1.2820799648761749e+02 -5.7848501205444336e+02) (float-vector 1.2285699695348740e+02 -1.2820799648761749e+02 -5.8863699436187744e+02) (float-vector 1.1593600362539291e+02 -1.3750000298023224e+02 -5.8714997768402100e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2979899346828461e+02 -1.4276599884033203e+02 -5.5171602964401245e+02) (float-vector 1.3833199441432953e+02 -1.3873000442981720e+02 -5.4500299692153931e+02) (float-vector 1.3401800394058228e+02 -1.3811400532722473e+02 -5.6612700223922729e+02) (float-vector 1.2379799783229828e+02 -1.4084799587726593e+02 -5.7575500011444092e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.2979899346828461e+02 -1.4276599884033203e+02 -5.5171602964401245e+02) (float-vector 1.2379799783229828e+02 -1.4084799587726593e+02 -5.7575500011444092e+02) (float-vector 1.0221700370311737e+02 -1.4038400352001190e+02 -5.8970701694488525e+02) (float-vector -4.0524698793888092e+01 -1.4066399633884430e+02 -5.9126901626586914e+02) (float-vector -6.5253101289272308e+01 -1.3805900514125824e+02 -5.8669298887252808e+02) (float-vector -5.2121099084615707e+01 -1.4212100207805634e+02 -5.5767101049423218e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_head_pan_link_AHQehC.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_head_tilt_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.4253000000000000e+02 0.0000000000000000e+00 5.7999000000000002e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 8 0 6 6 0 2 8 128 0 0 128 1 1 128 129 1 129 2 8 127 128 127 126 128 128 126 169 128 169 129 6 7 8 7 127 8 28 89 127 28 127 7 89 91 127 127 91 126 28 7 29 29 7 6 29 89 28 29 30 89 89 30 90 89 90 91 91 90 92 91 92 93 91 93 126 30 27 90 90 27 174 90 174 92 93 92 94 92 174 178 92 178 94 93 94 88 93 88 126 88 94 95 94 178 95 95 178 179 174 201 178 178 201 202 178 202 179 88 95 87 95 179 87 87 179 85 85 179 180 179 202 203 179 203 180 201 190 202 202 190 191 202 191 203 203 191 192 203 192 204 180 203 204 190 102 191 191 102 104 191 104 192 189 100 190 190 100 102 201 189 190 100 101 102 102 101 103 102 103 104 104 103 105 104 105 106 192 104 106 198 105 103 198 103 199 199 103 101 100 99 101 199 101 200 99 200 101 210 198 199 210 199 211 211 199 200 197 105 198 209 197 198 209 198 210 186 209 210 186 210 187 187 210 211 211 200 212 187 211 188 188 211 212 187 188 51 51 53 187 187 53 55 187 55 186 188 212 213 213 47 188 188 47 49 188 49 51 49 50 51 51 50 52 51 52 53 53 52 54 53 54 55 50 136 52 52 136 54 49 48 50 48 135 50 50 135 136 47 48 49 47 46 48 46 135 48 46 134 135 134 158 135 135 158 159 135 159 136 45 44 46 45 46 47 44 134 46 42 44 45 42 45 213 213 45 47 42 43 44 43 134 44 40 41 42 41 43 42 40 42 171 171 42 213 171 213 214 214 213 212 38 40 171 175 38 171 175 171 176 176 171 214 38 39 40 40 39 41 39 133 41 41 133 43 38 37 39 37 132 39 39 132 133 36 37 38 36 38 175 36 6 37 6 14 37 37 14 132 22 6 36 22 36 21 21 36 175 21 9 22 21 175 9 9 10 11 22 9 11 9 175 10 10 175 176 10 176 11 22 11 6 6 11 23 11 176 23 23 176 177 176 214 177 6 23 16 23 177 16 16 177 17 17 177 97 177 214 215 177 215 97 214 212 215 215 212 200 215 200 99 97 215 99 98 97 99 98 99 100 96 97 98 172 96 98 172 98 189 189 98 100 25 26 96 96 26 97 24 25 96 24 96 172 24 3 25 172 3 24 4 3 172 4 172 173 173 172 189 173 189 201 12 5 173 173 5 4 12 173 174 174 173 201 3 4 5 25 3 6 3 5 6 5 12 13 6 5 13 174 13 12 27 13 174 6 13 27 30 6 27 29 6 30 224 223 30 30 223 22 30 22 29 30 29 371 371 224 30 489 223 224 371 489 224 222 22 223 223 489 222 222 489 490 373 489 371 373 376 489 489 376 509 489 509 490 371 29 372 371 372 373 372 374 373 373 374 375 373 375 376 376 375 377 376 377 378 376 378 509 509 378 508 509 508 510 490 509 510 378 377 379 378 379 380 378 380 508 375 446 377 377 446 447 377 447 379 374 446 375 374 445 446 445 457 446 446 457 458 446 458 447 379 447 381 381 447 448 447 458 459 447 459 448 380 379 381 380 381 382 382 381 383 381 384 383 381 448 384 508 380 382 508 382 499 499 382 383 383 384 385 383 385 386 499 383 386 448 385 384 386 385 387 385 388 387 448 388 385 499 386 498 498 386 387 498 506 499 499 506 507 499 507 508 510 508 507 506 503 507 510 507 511 511 507 503 505 502 506 506 502 503 498 505 506 502 424 503 511 503 423 423 503 424 491 510 511 491 511 422 422 511 423 490 510 491 219 490 491 219 491 220 220 491 231 231 491 422 25 422 26 26 422 423 231 422 25 423 424 26 26 424 425 502 425 424 26 425 426 501 426 425 501 425 502 426 427 26 500 427 426 500 426 501 504 500 501 504 501 505 505 501 502 488 427 500 494 488 500 494 500 504 26 427 428 488 428 427 486 487 488 487 428 488 486 488 494 492 493 494 494 493 486 492 494 495 495 494 504 487 486 512 512 486 493 487 414 428 414 487 415 415 487 512 26 428 414 414 415 26 421 26 415 512 516 415 415 516 421 512 493 513 513 514 512 512 514 516 492 513 493 496 264 513 496 513 492 264 434 513 513 434 514 434 432 514 514 432 515 514 515 516 433 432 434 433 434 246 246 434 264 431 430 432 431 432 433 519 515 432 519 432 430 516 515 517 518 517 515 518 515 519 430 435 519 519 435 520 519 520 518 429 430 431 435 430 429 429 436 435 435 436 437 435 437 438 435 438 520 473 476 429 473 429 431 480 436 429 476 480 429 480 437 436 438 437 439 482 439 437 480 482 437 438 439 440 438 440 520 440 439 441 441 439 482 440 441 442 440 442 521 520 440 521 442 441 369 369 441 484 484 441 482 442 369 370 527 521 442 527 442 370 6 22 369 369 22 370 6 369 484 484 482 485 6 484 234 234 484 485 485 482 483 234 485 232 485 483 232 232 233 234 234 233 33 234 33 6 232 483 478 232 478 233 478 483 479 479 483 482 479 482 480 477 478 479 403 477 479 403 479 481 481 479 480 478 477 233 233 477 405 233 405 33 405 477 403 403 404 405 403 481 404 476 475 481 404 481 475 481 480 476 405 404 406 404 475 406 405 406 33 33 406 407 407 406 475 407 475 474 474 475 476 474 476 473 473 471 474 474 471 472 474 472 407 33 407 400 407 472 400 471 469 472 472 469 470 472 470 400 433 246 471 471 246 469 473 433 471 431 433 473 246 468 469 468 467 469 469 467 466 469 466 470 463 467 468 463 468 261 261 468 246 462 466 467 462 467 463 465 466 462 465 470 466 450 461 462 450 462 463 465 462 456 456 462 461 456 464 465 464 470 465 455 412 456 412 402 456 456 402 464 456 461 455 402 401 464 464 401 470 400 470 401 400 401 33 33 401 402 402 412 33 33 412 413 455 413 412 33 413 409 454 409 413 454 413 455 409 410 33 453 410 409 453 409 454 455 460 454 454 460 459 454 459 453 452 410 453 453 459 458 453 458 452 33 410 411 452 411 410 451 411 452 452 458 457 452 457 451 33 411 408 451 408 411 443 408 451 451 457 444 451 444 443 445 444 457 229 218 444 444 218 217 229 444 445 443 444 217 225 228 445 445 228 229 372 225 445 372 445 374 228 218 229 216 217 218 216 218 6 228 6 218 443 217 216 6 32 216 216 32 235 443 216 235 235 32 399 235 399 443 443 399 408 399 32 33 399 33 408 31 32 2 2 32 33 33 32 111 111 32 112 31 112 32 6 33 32 18 2 33 18 33 35 35 33 111 111 112 113 35 111 130 130 111 113 130 18 35 18 19 20 20 2 18 19 18 130 130 113 144 19 130 131 131 130 144 113 112 114 113 114 115 144 113 115 144 115 145 131 144 156 156 144 145 115 114 116 115 116 117 145 115 117 170 155 114 114 155 116 112 170 114 117 116 118 154 118 116 154 116 155 117 118 119 145 117 146 146 117 119 119 118 120 153 120 118 153 118 154 165 153 154 165 154 166 166 154 155 152 120 153 164 152 153 164 153 165 119 120 121 121 120 122 152 122 120 151 122 152 163 151 152 163 152 164 140 163 164 140 164 141 141 164 165 162 151 163 139 162 163 139 163 140 150 124 151 151 124 122 162 150 151 161 150 162 138 161 162 138 162 139 149 125 150 150 125 124 161 149 150 123 122 124 123 124 125 149 123 125 148 123 149 160 148 149 160 149 161 137 160 161 137 161 138 159 148 160 136 159 160 136 160 137 147 121 148 148 121 123 159 147 148 121 122 123 147 119 121 146 119 147 158 146 147 158 147 159 157 145 146 157 146 158 134 157 158 156 145 157 133 156 157 133 157 134 43 133 134 132 156 133 132 131 156 14 15 132 132 15 34 34 131 132 34 20 131 131 20 19 34 15 20 14 2 15 20 15 2 6 2 14 2 129 31 31 129 112 129 169 170 129 170 112 126 168 169 169 168 167 169 167 170 170 167 155 166 155 167 143 166 167 143 167 168 142 165 166 142 166 143 142 143 80 168 84 143 143 84 82 143 82 80 79 78 80 79 80 81 81 80 82 80 78 142 81 82 83 83 82 84 83 84 85 85 84 86 168 86 84 85 180 83 83 180 81 81 180 181 81 181 79 180 204 181 79 181 77 77 181 182 181 204 205 181 205 182 204 192 193 204 193 205 205 193 194 205 194 206 182 205 206 192 106 193 193 106 108 193 108 194 194 108 110 194 110 195 206 194 195 206 195 207 182 206 183 183 206 207 195 110 109 195 109 196 207 195 196 108 109 110 106 107 108 108 107 109 106 105 107 196 109 107 196 107 197 197 107 105 207 196 208 208 196 197 183 207 184 184 207 208 208 197 209 184 208 185 185 208 209 68 183 184 68 184 67 67 184 64 64 184 185 64 185 63 63 185 60 60 185 186 185 209 186 63 62 64 62 65 64 64 65 66 64 66 67 67 66 68 66 69 68 65 139 66 66 139 140 66 140 69 62 139 65 62 138 139 58 137 138 58 138 61 61 138 62 54 136 137 54 137 56 56 137 58 55 54 56 55 56 57 57 56 58 186 55 57 57 58 59 186 57 59 60 186 59 59 58 60 58 61 60 60 61 62 60 62 63 68 69 70 69 140 70 68 70 71 71 183 68 71 70 72 70 73 72 70 140 141 70 141 73 72 183 71 72 182 183 72 73 74 72 74 75 75 182 72 141 74 73 142 76 141 141 76 74 141 165 142 75 74 76 75 76 77 77 182 75 77 76 78 142 78 76 77 78 79 85 86 87 87 86 88 88 86 168 126 88 168 6 16 17 25 6 26 26 6 17 29 22 6 29 6 225 225 6 228 17 97 26 26 226 227 227 230 26 26 230 22 26 22 25 420 419 26 420 26 421 26 419 522 26 522 226 226 522 524 226 524 227 419 417 522 522 417 523 522 523 524 418 417 419 418 419 420 416 417 418 416 523 417 524 523 525 525 523 521 528 521 523 528 523 416 524 525 227 525 521 526 227 525 526 526 521 527 520 521 528 518 520 528 518 528 418 418 528 416 418 517 518 516 517 421 421 517 420 418 420 517 526 527 230 230 527 370 227 526 230 230 370 22 221 220 22 221 22 222 25 22 220 219 220 221 222 490 221 221 490 219 25 220 231 29 225 372 448 459 460 449 388 448 448 460 449 449 460 461 455 461 460 449 450 392 392 389 449 449 389 388 449 461 450 387 388 389 387 389 390 390 389 391 389 392 391 391 392 393 450 393 392 463 397 450 450 397 393 391 393 394 394 393 395 393 397 395 394 497 391 391 497 498 391 498 390 498 387 390 497 505 498 395 495 497 395 497 394 495 504 497 497 504 505 395 397 396 395 396 398 398 495 395 463 396 397 396 261 265 398 396 265 261 396 463 398 265 495 495 265 496 495 496 492 265 264 496 264 265 266 279 280 265 265 280 281 265 281 266 313 314 265 265 314 315 265 315 279 261 328 265 265 328 329 265 329 307 307 344 265 265 344 345 265 345 313 329 328 1039 1039 1041 329 329 1041 1043 329 1043 307 1039 1040 1041 1048 1040 1039 1048 1039 328 969 1043 1041 969 1041 967 967 1041 1040 971 1042 1043 971 1043 969 307 1043 1042 967 968 969 969 968 970 969 970 971 951 950 967 967 950 968 967 1040 951 1386 970 968 1386 968 1387 1387 968 950 971 970 972 1385 972 970 1385 970 1386 624 1385 1386 624 1386 625 625 1386 1387 1387 950 1382 625 1387 626 626 1387 1382 613 624 625 613 625 609 609 625 626 611 624 613 611 1385 624 610 611 612 612 611 613 611 610 1385 744 743 610 744 610 612 1385 610 1384 1390 1384 610 1390 610 743 742 743 744 1217 742 744 1220 1217 744 1220 744 612 742 741 743 741 1390 743 975 1384 1390 1393 975 1390 1393 1390 741 740 741 742 740 1393 741 740 742 1218 1218 742 1217 1394 1393 740 740 1218 1394 986 975 1393 1394 986 1393 973 974 975 986 973 975 975 974 1384 981 983 986 986 983 973 981 986 1394 1394 1218 1398 1394 1398 981 981 982 983 981 1398 982 1218 1219 1398 1398 1219 1399 1398 1399 982 983 982 984 982 1399 984 1409 984 1399 1222 1409 1399 1222 1399 1219 1218 1217 1219 1219 1217 1216 1219 1216 1222 1222 1216 1221 1222 1221 1223 1223 1409 1222 1215 1216 1217 1216 1215 1221 1209 1215 1217 1209 1217 1220 1195 1194 1215 1195 1215 1209 1214 1221 1215 1214 1215 1194 1208 614 1209 614 1195 1209 1220 1208 1209 612 1208 1220 1208 612 614 612 613 614 614 613 615 614 615 616 616 1196 614 614 1196 1195 1194 1195 1196 1196 1214 1194 1196 1213 1214 1213 1221 1214 1212 1211 1213 1212 1213 1196 1211 1224 1213 1213 1224 1221 1223 1221 1224 1223 1224 1225 1225 1409 1223 1224 1229 1225 1229 1407 1225 1225 1407 1409 1407 985 1409 1409 985 984 980 984 985 980 985 978 1407 978 985 983 984 980 978 979 980 1035 983 980 1035 980 1036 1036 980 979 978 989 979 989 978 1407 979 989 990 979 990 988 1036 979 1029 1029 979 988 1029 340 1036 1036 340 354 1036 354 1035 977 1028 1029 1029 988 977 1028 341 1029 1029 341 340 340 341 342 342 354 340 342 353 354 354 353 1034 1035 354 1034 349 353 342 349 342 1028 1028 342 341 349 309 353 1034 353 309 1035 1034 1033 1034 309 1033 1033 983 1035 1032 983 1033 309 1032 1033 1032 973 983 973 1032 1042 309 1042 1032 971 972 973 973 972 974 973 1042 971 307 1042 309 306 307 308 308 307 309 306 343 307 307 343 344 308 1050 306 306 1050 1051 306 1051 343 308 309 310 310 1049 308 308 1049 1050 945 1051 1050 945 1050 947 947 1050 1049 1052 343 1051 1052 1051 945 344 343 1052 1052 345 344 945 908 1052 908 1069 1052 1052 1069 345 944 908 945 944 945 946 946 945 947 907 904 908 907 908 944 908 904 1069 1087 345 1069 902 1087 1069 902 1069 904 1087 313 345 1086 313 1087 900 1086 1087 900 1087 902 901 900 902 901 902 903 903 902 904 903 904 907 1425 901 903 1425 903 1426 903 907 1427 903 1427 1426 899 900 901 1424 899 901 1424 901 1425 899 898 900 898 1086 900 897 898 899 1423 897 899 1423 899 1424 646 1423 1424 646 1424 644 644 1424 1425 648 1422 1423 648 1423 649 1422 897 1423 649 1423 646 644 645 646 645 649 646 641 643 644 644 643 645 644 1425 641 641 642 643 641 1425 1426 641 1426 642 694 696 642 642 696 643 1426 694 642 1426 1427 694 694 695 696 694 1427 1429 694 1429 695 696 695 697 696 697 684 670 643 696 670 696 684 695 1429 1430 695 1430 697 1427 944 1429 1429 944 946 1429 946 1430 1427 907 944 1430 946 948 1430 948 1431 697 1430 698 698 1430 1431 684 697 698 684 698 681 698 1431 681 1431 948 949 1431 949 1432 681 1431 1432 946 947 948 948 947 941 948 941 949 949 941 943 1435 1432 949 1435 949 943 681 1432 682 736 682 1432 736 1432 1435 1438 736 1435 1438 1435 956 956 1435 943 941 942 943 943 942 956 956 942 953 956 953 957 957 1438 956 738 736 1438 1437 738 1438 1437 1438 957 957 953 952 952 1437 957 1436 739 1437 1436 1437 952 739 738 1437 737 736 738 737 738 739 1241 737 739 739 1238 1241 1238 739 1436 1434 1238 1436 1434 1436 954 954 1436 952 952 953 954 954 953 955 955 1434 954 1433 1434 955 1239 1434 1251 1251 1434 1433 1239 1238 1434 1238 1239 1240 1241 1238 1240 1239 1251 1240 1249 1250 1251 1240 1251 1250 1251 1433 1249 1241 1240 1189 1189 1240 1242 1240 1250 1242 1188 1189 680 680 1189 1190 1189 1188 1241 1189 1242 1190 1190 1242 1191 1242 1250 1169 1242 1169 1191 680 1190 1171 1171 1190 1191 1171 1191 1169 1169 1170 1171 1169 1185 1170 1250 1185 1169 1171 679 680 679 1171 1174 1174 1171 1170 1170 1185 1186 1170 1186 1183 1174 1170 1179 1179 1170 1183 1250 1186 1185 1183 1186 1187 1246 1187 1186 1246 1186 1250 1249 1246 1250 1247 1246 1249 1249 1433 1247 1246 1247 1248 1433 1428 1247 1247 1428 1248 955 958 1433 1433 958 1428 1428 960 962 1248 1428 1257 1257 1428 962 958 960 1428 1253 1246 1248 1257 1253 1248 1255 1254 1257 1257 1254 1253 1257 962 1255 1252 1246 1253 1252 1253 1254 1254 1255 1256 720 1252 1254 720 1254 1244 1244 1254 1256 1255 962 964 1255 964 1256 1244 1256 1245 1256 964 1245 1243 1244 1235 1235 1244 1245 1243 720 1244 1235 1245 1234 1234 1245 976 976 1245 966 964 966 1245 1234 1230 1235 1235 1230 1232 1235 1232 1236 1236 1243 1235 1234 976 1230 1230 1231 1232 1230 976 987 1230 987 1231 1236 1232 709 1231 1233 1232 1232 1233 1227 1232 1227 709 1236 709 707 707 704 1236 1236 704 1243 704 718 1243 1243 718 720 704 717 718 718 717 719 718 719 720 720 719 721 720 721 722 722 1252 720 719 717 1281 1281 721 719 704 716 717 1281 717 716 1280 1281 1282 1282 1281 1283 1281 716 1283 1280 1278 1281 1281 1278 721 703 716 704 1283 716 703 702 703 704 1283 703 1285 1285 703 702 702 704 715 707 727 704 704 727 728 704 728 715 1285 702 715 728 1273 715 715 1273 1275 715 1275 1285 728 727 1299 728 1299 1273 707 726 727 727 726 1299 1273 1299 1300 1299 726 714 1299 714 1312 1273 1274 1275 1273 1300 1301 1301 1300 1302 1301 1302 1291 1311 1302 1312 849 809 1302 1302 1311 849 809 805 1302 1302 805 1291 1290 1274 1291 1291 805 1290 1290 1275 1274 1288 1275 1290 1290 805 807 1290 807 1288 805 806 807 809 810 805 805 810 806 849 810 809 849 848 810 848 1105 810 806 810 1115 1115 810 1105 807 806 800 1115 800 806 807 800 808 1288 807 808 799 800 801 808 800 799 1116 801 800 1116 800 1115 1115 1105 1116 1116 1105 1104 1116 1104 358 1120 801 1116 364 1120 1116 364 1116 358 1100 1099 1104 1100 1104 1105 358 1104 1099 368 331 1099 368 1099 1100 358 1099 331 367 330 368 368 330 331 1100 1101 368 368 1101 367 330 316 331 331 316 358 367 366 330 316 330 1088 366 1088 330 365 366 367 1101 1102 367 367 1102 365 365 1103 366 366 1089 1088 366 1103 1089 1088 1089 1090 1088 1090 316 1089 851 856 856 1090 1089 1089 1103 829 1089 829 851 858 1096 1090 858 1090 856 316 1090 1096 851 850 856 856 850 857 856 857 858 850 851 852 852 851 829 850 852 1351 857 850 1359 1359 850 1351 858 857 859 857 1359 859 859 1359 1360 620 631 1359 1359 631 630 1359 630 1360 1359 1351 620 858 859 860 860 859 861 859 1360 861 860 1096 858 860 861 862 862 1095 860 860 1095 1096 872 862 861 861 1360 1361 861 1361 872 871 870 862 871 862 872 870 1094 862 862 1094 1095 317 1096 1095 317 1095 337 337 1095 1094 316 1096 317 316 317 318 318 362 316 316 362 363 316 363 358 318 317 321 321 1111 318 318 1111 1112 318 1112 362 1113 363 362 1113 362 1114 1114 362 1112 1114 1112 821 821 1112 1111 321 1110 1111 821 1111 823 823 1111 1110 317 346 321 346 1110 321 346 1109 1110 823 1110 825 825 1110 1109 822 821 823 822 823 824 824 823 825 824 825 826 826 825 819 825 1109 819 335 1108 1109 335 1109 346 819 1109 1108 317 335 346 337 335 317 334 333 335 334 335 336 336 335 337 333 1108 335 333 1107 1108 819 1108 817 817 1108 1107 332 333 334 332 1107 333 332 1106 1107 817 1107 815 815 1107 1106 815 816 817 817 816 818 817 818 819 813 814 815 815 814 816 815 1106 813 816 814 1400 818 816 1403 1403 816 1400 827 819 818 818 1403 827 826 819 827 827 1403 1404 827 1404 826 826 1404 1402 826 1402 824 1403 690 1404 1404 690 693 1404 693 1402 688 689 690 689 693 690 1403 688 690 689 692 693 1402 693 692 688 686 689 674 692 689 674 689 676 676 689 686 687 686 688 1403 687 688 685 686 687 685 687 1403 1403 1400 685 669 670 685 685 670 686 685 1400 1405 685 1405 669 1405 1400 1406 1406 1400 814 1406 1410 1405 1405 1410 664 1405 664 669 664 666 669 669 666 670 686 670 684 666 643 670 664 665 666 666 665 667 666 667 662 662 643 666 1413 665 664 1413 664 1410 1412 667 665 1412 665 1413 662 667 668 668 667 1412 668 1412 663 663 1412 1414 1413 875 1412 1412 875 877 1412 877 1414 1410 873 1413 1413 873 875 873 874 875 875 874 876 875 876 877 877 876 878 877 878 879 1414 877 879 874 1074 876 876 1074 1075 876 1075 878 873 855 874 855 1073 874 874 1073 1074 1073 301 1074 1074 301 299 1074 299 1075 1075 299 298 1075 298 1076 878 1075 1076 289 298 299 289 299 300 300 299 301 290 298 289 1076 298 290 1076 290 1077 878 1076 880 880 1076 1077 289 288 290 1077 290 288 1077 288 1078 880 1077 882 882 1077 1078 879 878 880 879 880 881 881 880 882 881 882 883 883 882 884 882 1078 884 1078 288 305 1078 305 1079 884 1078 1079 883 884 885 885 884 886 884 1079 886 1417 881 883 1417 883 1416 1416 883 885 885 886 887 1416 885 1420 1420 885 887 887 886 888 886 1079 1080 886 1080 888 887 888 889 1420 887 1419 1419 887 889 1419 656 1420 1420 656 654 1420 654 1416 1418 657 1419 1419 657 656 1419 889 1418 889 888 890 889 890 891 1418 889 891 891 890 892 888 1081 890 890 1081 1082 890 1082 892 891 892 893 1418 891 1421 1421 891 893 893 892 894 892 1082 1083 892 1083 894 1081 295 1082 1082 295 294 1082 294 1083 1083 294 292 1083 292 1084 894 1083 1084 893 894 895 895 894 896 894 1084 896 1084 292 274 1084 274 1085 896 1084 1085 291 274 292 291 292 293 293 292 294 293 294 295 295 303 293 293 303 304 293 304 287 1157 291 293 1157 293 1158 1158 293 287 1080 304 303 1080 303 1081 1081 303 295 1079 304 1080 888 1080 1081 1079 305 304 287 304 305 287 305 288 287 288 289 1159 287 289 1159 289 1160 1160 289 300 1158 287 1159 1025 1158 1159 1025 1159 1026 1026 1159 1160 1160 300 1161 1026 1160 1027 1027 1160 1161 300 301 302 1161 300 302 1161 302 1162 1027 1161 1023 1023 1161 1162 1022 1026 1027 1022 1027 1023 993 1025 1026 993 1026 1022 1022 1023 1019 1019 1341 1022 1022 1341 1342 1022 1342 993 1019 1023 1024 1023 1162 1024 1019 1020 1016 1019 1024 1020 1016 1340 1019 1019 1340 1341 1340 534 1341 1341 534 532 1341 532 1342 1016 1339 1340 1339 536 1340 1340 536 534 533 532 534 533 534 535 535 534 536 531 530 532 531 532 533 1342 532 530 533 535 537 537 531 533 535 536 537 537 536 538 1339 538 536 537 538 539 537 539 541 541 529 537 537 529 531 529 530 531 551 552 529 529 552 530 549 551 529 541 549 529 549 550 551 551 550 552 1343 530 552 1343 552 1344 1344 552 550 549 548 550 1344 550 1345 1345 550 548 994 1343 1344 994 1344 995 995 1344 1345 993 1342 1343 993 1343 994 1342 530 1343 992 993 994 992 1025 993 994 997 992 997 1157 992 992 1157 1158 992 1158 1025 994 996 997 996 1156 997 997 1156 1157 1156 291 1157 1155 272 1156 1156 272 291 996 1155 1156 995 996 994 995 1000 996 1000 1155 996 1154 273 1155 1155 273 272 1000 1154 1155 272 273 274 272 274 291 274 273 275 273 311 275 1154 311 273 1153 311 1154 999 1153 1154 999 1154 1000 995 999 1000 998 999 995 998 1003 999 1003 1153 999 1152 312 1153 1153 312 311 1003 1152 1153 275 311 312 275 312 313 313 312 314 1152 314 312 1151 314 1152 1002 1151 1152 1002 1152 1003 998 1002 1003 1001 1002 998 1001 1006 1002 1006 1151 1002 1150 315 1151 1151 315 314 1006 1150 1151 1001 1005 1006 1005 1150 1006 1149 279 1150 1150 279 315 1005 1149 1150 1004 1005 1001 1004 1009 1005 1009 1149 1005 1148 280 1149 1149 280 279 1009 1148 1149 1004 1008 1009 1008 1148 1009 1147 281 1148 1148 281 280 1008 1147 1148 1007 1008 1004 1007 1012 1008 1012 1147 1008 1146 266 1147 1147 266 281 1012 1146 1147 1007 1011 1012 1011 1146 1012 1145 267 1146 1146 267 266 1011 1145 1146 266 267 264 264 267 268 1145 268 267 1168 268 1145 1015 1168 1145 1015 1145 1011 1010 1011 1007 1010 1015 1011 1010 1014 1015 1014 1168 1015 1167 269 1168 1168 269 268 1014 1167 1168 264 268 269 269 282 264 1167 282 269 1166 282 1167 1018 1166 1167 1018 1167 1014 1013 1014 1010 1013 1018 1014 1013 1017 1018 1017 1166 1018 1165 283 1166 1166 283 282 1017 1165 1166 264 282 283 264 283 270 1165 270 283 1164 270 1165 1021 1164 1165 1021 1165 1017 1016 1017 1013 1016 1021 1017 1016 1020 1021 1020 1164 1021 1163 271 1164 1164 271 270 1020 1163 1164 264 270 271 319 320 271 271 320 264 1163 319 271 1162 319 1163 1024 1162 1163 1024 1163 1020 302 301 319 319 301 320 1162 302 319 1073 320 301 264 320 338 1072 338 320 1072 320 1073 855 1072 1073 339 338 1072 855 1097 1072 1072 1097 1098 1072 1098 339 264 338 339 332 334 339 339 334 351 339 351 264 332 339 1098 1098 1097 1106 1098 1106 332 855 811 1097 813 1106 1097 813 1097 811 811 812 813 812 811 854 854 811 855 813 812 814 1406 814 812 1406 812 1410 1410 812 854 854 855 873 1410 854 873 264 347 246 264 351 352 264 352 347 246 347 348 1071 348 347 352 1071 347 351 1091 352 352 1091 1071 334 1092 351 351 1092 1091 1070 1071 1091 1070 1091 866 866 1091 1092 1070 1068 1071 1071 1068 348 1070 864 1068 866 864 1070 865 864 866 865 866 867 867 866 868 866 1092 868 868 1092 1093 334 1093 1092 336 1093 334 868 1093 870 870 1093 1094 336 1094 1093 867 868 869 869 868 870 869 870 871 871 1362 869 869 1362 867 872 1361 871 871 1361 1362 867 1362 1358 634 1358 1362 634 1362 632 632 1362 1361 1360 628 1361 1361 628 627 1361 627 632 627 629 632 632 629 633 632 633 634 634 633 635 635 1358 634 635 633 636 633 629 623 623 618 633 633 618 613 633 613 636 635 636 637 637 1356 635 635 1356 1358 637 636 581 637 581 1365 1365 1356 637 1356 1357 1358 1365 1357 1356 867 1358 865 865 1358 1357 865 1357 863 905 863 1357 905 1357 1365 1381 905 1365 580 1381 1365 580 1365 581 905 906 863 939 940 905 905 940 906 1381 939 905 863 864 865 863 906 864 940 1068 906 1068 864 906 939 938 940 938 1067 940 940 1067 1068 937 938 939 1380 937 939 1380 939 1381 937 936 938 936 1066 938 938 1066 1067 1066 324 1067 1067 324 348 1067 348 1068 1065 250 1066 1066 250 324 936 1065 1066 935 934 936 935 936 937 934 1065 936 1064 249 1065 1065 249 250 934 1064 1065 933 932 934 933 934 935 932 1064 934 1378 933 935 1378 935 1379 1379 935 937 931 932 933 1366 931 933 1366 933 1378 931 930 932 930 1063 932 932 1063 1064 929 930 931 1377 929 931 1377 931 1366 929 928 930 928 1062 930 930 1062 1063 1062 259 1063 1063 259 258 1063 258 1064 1061 260 1062 1062 260 259 928 1061 1062 247 258 259 247 259 257 257 259 260 249 258 247 1064 258 249 247 248 249 1143 248 247 1143 247 1144 1144 247 257 249 248 250 248 322 250 1142 322 248 1142 248 1143 771 1142 1143 771 1143 767 767 1143 1144 1144 257 1121 767 1144 768 768 1144 1121 766 767 763 763 767 768 766 771 767 766 770 771 770 1142 771 1141 322 1142 770 1141 1142 769 770 766 769 774 770 774 1141 770 763 1326 766 766 1326 1327 766 1327 769 772 773 769 769 773 774 769 1327 1328 769 1328 772 773 1140 774 774 1140 1141 772 777 773 777 1139 773 773 1139 1140 1139 325 1140 1140 325 323 1140 323 1141 1138 326 1139 1139 326 325 777 1138 1139 772 776 777 776 1138 777 1137 284 1138 1138 284 326 776 1137 1138 246 325 326 246 326 284 284 285 246 1137 285 284 1136 285 1137 780 1136 1137 780 1137 776 775 776 772 775 780 776 775 779 780 779 1136 780 1135 286 1136 1136 286 285 779 1135 1136 246 285 286 246 286 244 1135 244 286 1134 244 1135 778 1134 1135 778 1135 779 746 778 779 746 779 775 745 778 746 745 1134 778 1133 245 1134 1134 245 244 745 1133 1134 244 245 246 246 245 261 261 245 262 1133 262 245 1132 262 1133 750 1132 1133 750 1133 745 745 746 747 747 750 745 747 749 750 749 1132 750 1131 263 1132 1132 263 262 749 1131 1132 261 262 263 263 276 261 1131 276 263 1130 276 1131 753 1130 1131 753 1131 749 748 749 747 748 753 749 748 752 753 752 1130 753 1129 277 1130 1130 277 276 752 1129 1130 261 276 277 261 277 278 1129 278 277 1128 278 1129 756 1128 1129 756 1129 752 751 752 748 751 756 752 751 755 756 755 1128 756 1127 297 1128 1128 297 278 755 1127 1128 297 261 278 242 261 297 1127 242 297 1126 242 1127 759 1126 1127 759 1127 755 754 755 751 754 759 755 754 758 759 758 1126 759 1125 239 1126 1126 239 242 758 1125 1126 757 758 754 757 762 758 762 1125 758 751 1334 754 754 1334 1335 754 1335 757 748 1333 751 751 1333 1334 1333 572 1334 1334 572 570 1334 570 1335 757 1335 1336 1335 570 568 1335 568 1336 569 568 570 569 570 571 571 570 572 571 572 573 573 572 574 1333 574 572 569 571 573 567 568 569 569 573 567 567 566 568 1336 568 566 565 566 567 567 573 565 573 574 575 573 575 553 565 573 553 575 574 576 1332 576 574 1332 574 1333 575 576 553 553 554 555 553 576 554 565 553 561 561 553 555 1331 554 576 1331 576 1332 747 1331 1332 747 1332 748 748 1332 1333 746 1330 1331 746 1331 747 1330 554 1331 555 554 556 1330 556 554 555 556 557 561 555 557 557 556 558 1329 558 556 1329 556 1330 775 1329 1330 775 1330 746 772 1328 1329 772 1329 775 1328 558 1329 557 558 559 559 558 560 1328 560 558 557 559 561 559 560 561 561 560 562 1327 562 560 1327 560 1328 561 562 563 561 563 565 563 562 564 1326 562 1327 1326 564 562 563 564 565 565 564 566 1337 566 564 1337 564 1326 763 1337 1326 760 1336 1337 760 1337 763 1336 566 1337 763 764 760 763 768 764 760 761 757 760 764 765 760 765 761 757 1336 760 764 1122 765 768 1121 764 764 1121 1122 765 1122 1123 765 1123 761 757 761 762 761 1123 1124 761 1124 762 1122 254 1123 1123 254 236 1123 236 1124 1121 255 1122 1122 255 254 1121 257 255 237 254 255 237 255 256 256 255 257 236 254 237 236 237 238 1124 236 238 1124 238 1125 762 1124 1125 238 237 239 1125 238 239 237 251 239 239 251 252 239 252 242 1058 252 251 1058 251 1059 1059 251 237 242 252 253 1057 253 252 1057 252 1058 920 1057 1058 920 1058 922 922 1058 1059 1059 237 1060 922 1059 924 924 1059 1060 921 920 922 921 922 923 923 922 924 923 924 925 925 924 926 924 1060 926 1060 237 256 1060 256 1061 926 1060 1061 925 926 927 927 926 928 926 1061 928 1376 923 925 1376 925 1375 1375 925 927 927 928 929 1375 927 1374 1374 927 929 1374 596 1375 1375 596 595 1375 595 1376 1376 595 593 1376 593 1372 1372 923 1376 594 593 595 594 595 579 579 595 596 579 596 577 1374 577 596 577 578 579 578 589 579 579 589 590 579 590 586 579 586 594 578 577 1374 578 1374 589 1366 590 589 589 1374 1377 589 1377 1366 586 590 591 590 1366 591 586 587 584 586 591 587 594 586 584 591 1366 1378 591 1378 587 584 587 588 587 1378 1379 587 1379 588 584 588 585 588 1379 585 1379 937 1380 585 1379 1380 583 584 585 585 1380 583 583 1380 1381 580 582 583 583 582 584 583 1381 580 580 581 582 581 636 582 584 582 601 636 609 582 582 609 605 582 605 601 636 613 609 608 605 609 609 626 608 603 604 605 605 604 606 605 606 601 603 605 608 1382 603 608 626 1382 608 1369 604 603 1369 603 1367 1382 1367 603 1368 606 604 1368 604 1369 601 606 607 607 606 1368 600 598 601 600 601 602 601 607 602 598 584 601 607 1368 602 602 1368 1370 602 1370 1371 1371 600 602 599 598 600 1371 599 600 597 594 598 597 598 599 594 584 598 1373 597 599 1373 599 1371 1370 917 1371 1371 917 919 1371 919 1373 1368 915 1370 1370 915 917 915 916 917 917 916 918 917 918 919 919 918 920 919 920 921 1373 919 921 916 1056 918 918 1056 1057 918 1057 920 915 914 916 914 1055 916 916 1055 1056 1055 240 1056 1056 240 253 1056 253 1057 1054 241 1055 1055 241 240 914 1054 1055 913 912 914 913 914 915 912 1054 914 1053 243 1054 1054 243 241 912 1053 1054 240 241 242 242 241 243 242 253 240 243 296 242 242 296 261 1053 296 243 910 1048 1053 1048 296 1053 910 1053 912 296 327 261 1048 327 296 261 327 328 328 327 1048 910 1040 1048 910 951 1040 909 910 911 911 910 912 909 951 910 950 951 909 1367 909 911 950 909 1367 911 912 913 1367 911 1369 1369 911 913 950 1367 1382 1369 913 1368 1368 913 915 1373 921 1372 1372 921 923 1372 597 1373 1372 593 592 1372 592 597 592 594 597 592 593 594 618 615 613 617 615 618 617 618 619 619 618 622 622 618 623 616 615 617 1203 617 619 1196 616 617 617 1203 1196 622 1205 619 619 1205 1206 619 1206 1203 1292 1205 622 1205 1292 1206 1203 1206 1207 1206 1292 1293 1206 1293 1207 622 729 1292 1292 729 731 1292 731 1293 622 621 729 729 621 730 729 730 731 1293 731 1294 731 730 1353 731 1353 1294 1350 730 621 1353 730 1350 620 621 622 1352 1350 621 620 1352 621 1351 852 1350 1351 1350 1352 1353 1350 853 853 1350 852 1353 853 1354 1294 1353 1354 852 829 853 853 829 828 1354 853 828 828 829 830 830 829 831 1103 831 829 828 830 1354 830 831 832 1354 830 832 832 831 833 833 831 834 834 831 835 1103 835 831 1102 1103 365 1102 835 1103 834 835 836 836 835 837 837 835 838 1102 838 835 1101 840 1102 840 838 1102 837 838 839 839 838 840 839 1324 837 837 1324 1325 837 1325 836 839 840 841 841 1322 839 839 1322 1324 841 840 842 842 840 843 843 840 1101 842 1321 841 841 1321 1322 1321 1320 1322 1322 1320 1323 1322 1323 1324 1323 1325 1324 1323 1304 1325 836 1325 1304 1364 834 836 836 1304 1364 1363 834 1364 1363 1364 1304 833 834 1363 1363 1355 833 1304 1303 1363 1363 1303 1310 1363 1310 1355 833 1355 832 1354 832 1355 1294 1354 1295 1295 1354 1355 1293 1294 1295 1297 1293 1295 1297 1295 1298 1295 1355 1298 1296 1293 1297 1207 1293 1296 1298 1309 1297 1297 1309 1308 1297 1308 1296 1355 1309 1298 1308 1309 1305 1305 1309 1310 1355 1310 1309 1305 1199 1308 1308 1199 1200 1308 1200 1202 1296 1308 1202 1197 1198 1199 1199 1198 1200 1305 1197 1199 1200 1198 1201 1200 1201 1202 1202 1201 1203 1202 1203 1204 1296 1202 1204 1196 1203 1201 1196 1201 1212 1212 1201 1198 1203 1207 1204 1207 1296 1204 1197 699 1198 1212 1198 1193 1193 1198 699 1193 1211 1212 711 1192 1193 1192 1210 1193 1193 1210 1211 1193 699 711 699 700 701 701 711 699 700 699 1197 701 710 711 711 1226 1192 710 1226 711 1192 1226 1224 1192 1224 1210 1210 1224 1211 1224 1226 1227 1227 1228 1224 1224 1228 1229 709 1227 1226 709 1226 710 705 709 710 705 710 701 707 709 705 705 706 707 1323 706 705 1323 705 701 707 706 708 1318 708 706 1320 1318 706 1320 706 1323 1306 1304 1323 1306 1323 1307 1307 1323 701 1307 701 700 1305 1306 1307 1307 700 1197 1307 1197 1305 1305 1304 1306 1303 1304 1305 1305 1310 1303 1320 1321 1319 1319 1318 1320 842 1319 1321 1317 1318 1319 844 1317 1319 844 1319 842 842 843 844 844 843 845 844 845 846 846 1317 844 1316 1315 1317 1317 1315 1318 846 1316 1317 1315 712 1318 1318 712 708 1313 1314 1315 1313 1315 1316 1314 713 1315 1315 713 712 847 1313 1316 847 1316 846 846 845 847 847 845 848 847 848 849 849 1313 847 1311 1312 1313 1312 1314 1313 849 1311 1313 1312 714 1314 1314 714 713 707 712 713 707 713 714 714 726 707 708 712 707 845 1100 848 848 1100 1105 843 1101 845 845 1101 1100 1233 1228 1227 1231 991 1233 1233 991 1408 1233 1408 1228 1229 1228 1407 1407 1228 1408 1407 1408 989 989 1408 990 991 990 1408 988 990 991 988 991 987 1231 987 991 987 977 988 976 977 987 976 965 977 977 1030 1028 1038 1030 977 1038 977 965 966 965 976 964 963 965 964 965 966 1038 965 963 1037 1031 1038 1031 1030 1038 963 1037 1038 1028 1030 1031 1028 1031 349 1037 349 1031 350 349 1037 963 1047 1037 1047 350 1037 962 961 963 962 963 964 961 1047 963 961 1046 1047 1046 355 1047 1047 355 350 349 350 310 350 355 310 310 309 349 310 355 356 310 356 357 1044 1045 310 310 357 1044 310 1045 1049 1046 356 355 1044 357 356 1044 356 1046 953 1045 1044 953 1044 959 959 1044 1046 942 1045 953 941 1049 1045 941 1045 942 947 1049 941 955 953 958 958 953 959 958 959 960 960 959 961 959 1046 961 960 961 962 620 1351 1352 622 623 620 623 631 620 629 630 623 623 630 631 627 628 629 629 628 630 1360 630 628 1374 929 1377 1061 256 260 257 260 256 324 325 246 246 348 324 250 323 324 324 323 325 250 322 323 1141 323 322 337 1094 336 1013 1339 1016 1010 1338 1013 1013 1338 1339 1338 538 1339 1010 1349 1338 1349 540 1338 1338 540 538 1007 1349 1010 1007 1348 1349 1348 542 1349 1349 542 540 539 538 540 539 540 541 541 540 542 541 542 543 543 542 544 1348 544 542 1004 1347 1348 1004 1348 1007 1347 544 1348 543 544 545 545 544 546 1347 546 544 545 549 543 543 549 541 545 546 547 545 547 549 547 546 548 1346 548 546 1346 546 1347 1001 1346 1347 1001 1347 1004 998 1345 1346 998 1346 1001 1345 548 1346 547 548 549 995 1345 998 1086 275 313 1085 275 1086 898 1085 1086 1085 274 275 896 1085 898 897 896 898 895 896 897 1422 895 897 1411 893 895 1411 895 1422 652 1411 1422 652 1422 648 1411 651 650 650 1421 1411 651 1411 652 1421 893 1411 647 651 652 647 652 648 647 648 645 645 648 649 640 651 647 640 647 655 655 647 645 640 650 651 638 639 640 639 650 640 655 656 640 640 656 657 640 657 638 639 638 1418 1418 638 657 639 1418 650 650 1418 1421 655 654 656 653 654 655 1416 654 653 653 655 658 1416 653 658 1416 658 1417 658 655 659 658 659 660 1417 658 660 1417 660 1415 1415 881 1417 660 659 661 1415 660 661 661 659 662 655 645 659 659 645 662 661 662 663 1415 661 663 662 668 663 645 643 662 663 1414 1415 1414 879 1415 1415 879 881 683 678 684 683 684 681 678 686 684 681 682 683 683 682 735 735 682 736 735 736 737 1237 683 735 737 1237 735 1241 1237 737 1237 1188 683 1241 1188 1237 680 683 1188 679 678 680 680 678 683 677 678 679 1174 677 679 677 676 678 676 686 678 675 676 677 1174 675 677 675 674 676 673 674 675 1172 673 675 1172 675 1173 1173 675 1174 673 672 674 672 691 674 674 691 692 671 672 673 671 1397 672 672 1397 1401 672 1401 691 691 1401 1402 1402 692 691 822 1402 1401 822 1401 820 820 1401 1397 733 1396 1397 733 1397 671 820 1397 1396 734 733 671 734 671 673 732 733 734 1395 1396 733 732 1395 733 1395 788 1396 1396 788 820 786 788 1395 1392 786 1395 1392 1395 732 786 787 788 788 787 820 781 783 786 786 783 787 781 786 1392 1391 781 1392 1260 1391 1392 1260 1392 732 781 782 783 1391 782 781 1263 1262 1391 1391 1262 1389 1389 782 1391 1263 1391 1260 732 1259 1260 1259 1263 1260 1259 1262 1263 1261 1262 1259 1266 1262 1261 1262 1266 1389 1259 1264 1261 1270 1266 1261 1270 1261 1264 1269 1268 1266 1269 1266 1270 1389 1266 1268 1180 1269 1270 1180 1270 1181 1181 1270 1264 1259 1176 1264 1181 1264 1176 1174 1180 1181 1174 1181 1176 1179 1178 1180 1179 1180 1174 1178 1269 1180 1173 1174 1175 1175 1174 1176 1175 1176 1259 1259 1173 1175 1259 1172 1173 732 1258 1259 1258 1172 1259 1172 1258 673 734 1258 732 734 673 1258 1267 1268 1269 1178 1177 1269 1269 1177 1265 1269 1265 1267 1389 1268 1388 1388 1268 1267 1388 790 1389 1389 790 789 1389 789 784 1389 784 782 1272 1383 1388 1388 1383 790 1388 1267 1272 1267 1271 1272 1279 1272 1271 1383 1272 1279 792 1383 793 793 1383 1279 1383 792 790 1277 1279 1278 1278 1279 1271 793 1279 795 795 1279 1277 791 792 793 791 793 794 794 793 795 790 792 791 785 790 791 785 791 1118 1118 791 794 794 795 796 1118 794 1119 794 796 1119 796 795 797 795 1277 797 796 797 798 1119 796 798 1119 798 1120 360 1118 1119 360 1119 361 361 1119 1120 797 802 798 798 802 803 798 803 801 1120 798 801 797 1277 1276 797 1276 802 802 1276 1280 802 1280 803 1276 1277 1278 1276 1278 1280 803 1280 1282 1282 1283 1284 803 1282 1284 1285 1286 1283 1283 1286 1287 1283 1287 1284 803 1284 804 804 1284 1287 804 1287 1286 1285 1289 1286 1289 808 1286 1286 808 799 1286 799 804 1285 1275 1289 1275 1288 1289 1288 808 1289 801 803 804 801 804 799 1278 1271 721 1267 1265 1271 721 1271 1265 722 721 723 721 1265 723 1177 725 1265 723 1265 725 722 723 724 724 723 725 1177 724 725 1177 1178 1179 1179 1182 1177 1177 1182 724 1182 722 724 1179 1183 1182 1182 1183 722 1183 1184 722 1183 1187 1184 722 1184 1252 1252 1184 1246 1184 1187 1246 361 1120 364 359 360 361 364 359 361 358 359 364 358 363 359 363 1117 359 359 1117 1118 359 1118 360 1113 1117 363 1117 1113 1114 1114 783 1117 1117 783 785 1117 785 1118 821 787 1114 1114 787 783 783 782 784 783 784 785 784 789 785 785 789 790 820 787 821 820 821 822 824 1402 822 1384 974 972 1384 972 1385))
                   (list :vertices (let ((mat (make-matrix 1439 3))) (fvector-replace (array-entity mat) #f(-1.4256500244140625e+02 1.0439500427246094e+02 -1.1239700317382812e+02 -1.4256500244140625e+02 1.0469599914550781e+02 -1.1205899810791016e+02 -1.4256500244140625e+02 1.0482199859619141e+02 -1.1175399780273438e+02 -1.4256500244140625e+02 -1.0483399963378906e+02 -1.1175700378417969e+02 -1.4256500244140625e+02 -1.0456199645996094e+02 -1.1224800109863281e+02 -1.4256500244140625e+02 -1.0439699554443359e+02 -1.1239399719238281e+02 -1.4256500244140625e+02 1.0300000000000000e+02 -2.9990000724792480e+00 -1.4256500244140625e+02 1.0375800323486328e+02 -1.1283300018310547e+02 -1.4256500244140625e+02 1.0424900054931641e+02 -1.1256100463867188e+02 -1.4256500244140625e+02 -1.0375800323486328e+02 -3.1648199558258057e+00 -1.4256500244140625e+02 -1.0424900054931641e+02 -3.4374499320983887e+00 -1.4256500244140625e+02 -1.0439500427246094e+02 -3.6014800071716309e+00 -1.4256500244140625e+02 -1.0406000518798828e+02 -1.1269499969482422e+02 -1.4256500244140625e+02 -1.0375399780273438e+02 -1.1281999969482422e+02 -1.4256500244140625e+02 1.0343900299072266e+02 -3.0478699207305908e+00 -1.4256500244140625e+02 1.0375399780273438e+02 -3.1775698661804199e+00 -1.4256500244140625e+02 -1.0482199859619141e+02 -4.2444996833801270e+00 -1.4256500244140625e+02 -1.0495100402832031e+02 -4.5602803230285645e+00 -1.4256500244140625e+02 1.0483399963378906e+02 -4.2411599159240723e+00 -1.4256500244140625e+02 1.0456199645996094e+02 -3.7497799396514893e+00 -1.4256500244140625e+02 1.0439699554443359e+02 -3.6035101413726807e+00 -1.4256500244140625e+02 -1.0366200256347656e+02 -3.1117699146270752e+00 -1.4256500244140625e+02 -1.0300000000000000e+02 -2.9990000724792480e+00 -1.4256500244140625e+02 -1.0469599914550781e+02 -3.9390799999237061e+00 -1.4256500244140625e+02 -1.0488700103759766e+02 -1.1166100311279297e+02 -1.4256500244140625e+02 -1.0500000000000000e+02 -1.1099900054931641e+02 -1.4256500244140625e+02 -1.0500000000000000e+02 -4.9990901947021484e+00 -1.4256500244140625e+02 -1.0343900299072266e+02 -1.1294999694824219e+02 -1.4256500244140625e+02 1.0366200256347656e+02 -1.1288599395751953e+02 -1.4256500244140625e+02 1.0300000000000000e+02 -1.1299900054931641e+02 -1.4256500244140625e+02 -1.0300000000000000e+02 -1.1299900054931641e+02 -1.4256500244140625e+02 1.0495100402832031e+02 -1.1143799591064453e+02 -1.4256500244140625e+02 1.0500000000000000e+02 -1.1099900054931641e+02 -1.4256500244140625e+02 1.0500000000000000e+02 -4.9990901947021484e+00 -1.4256500244140625e+02 1.0406000518798828e+02 -3.3032200336456299e+00 -1.4256500244140625e+02 1.0488700103759766e+02 -4.3371200561523438e+00 -1.5273399353027344e+02 -1.0282900238037109e+02 -3.9473102092742920e+00 -1.4689900207519531e+02 1.0292700195312500e+02 -3.1700599193572998e+00 -1.5327900695800781e+02 -1.0281999969482422e+02 -4.1091899871826172e+00 -1.5324400329589844e+02 1.0281999969482422e+02 -4.3352103233337402e+00 -1.6354901123046875e+02 -1.0264699554443359e+02 -7.1593999862670898e+00 -1.5799499511718750e+02 1.0273999786376953e+02 -5.2078299522399902e+00 -1.6360899353027344e+02 -1.0264600372314453e+02 -7.1918296813964844e+00 -1.6350300598144531e+02 1.0264699554443359e+02 -7.4533700942993164e+00 -1.6844200134277344e+02 1.0256400299072266e+02 -9.4667005538940430e+00 -1.7310099792480469e+02 -1.0248600006103516e+02 -1.2305900573730469e+01 -1.7295899963378906e+02 1.0248800659179688e+02 -1.2508399963378906e+01 -1.7348100280761719e+02 -1.0248000335693359e+02 -1.2510499954223633e+01 -1.7780000305175781e+02 1.0240699768066406e+02 -1.5767600059509277e+01 -1.8139900207519531e+02 -1.0234700012207031e+02 -1.9175600051879883e+01 -1.8125100708007812e+02 1.0234899902343750e+02 -1.9307498931884766e+01 -1.8211199951171875e+02 -1.0233399963378906e+02 -1.9775598526000977e+01 -1.8567599487304688e+02 1.0227400207519531e+02 -2.3845399856567383e+01 -1.8819400024414062e+02 -1.0223200225830078e+02 -2.7522298812866211e+01 -1.8806199645996094e+02 1.0223400115966797e+02 -2.7591501235961914e+01 -1.8907899475097656e+02 -1.0221700286865234e+02 -2.8648799896240234e+01 -1.9173699951171875e+02 1.0217300415039062e+02 -3.3360099792480469e+01 -1.9322999572753906e+02 -1.0214799499511719e+02 -3.7024700164794922e+01 -1.9313200378417969e+02 1.0214900207519531e+02 -3.7044799804687500e+01 -1.9408898925781250e+02 -1.0213299560546875e+02 -3.8756900787353516e+01 -1.9631799316406250e+02 -1.0209600067138672e+02 -4.7318599700927734e+01 -1.9572999572753906e+02 1.0210499572753906e+02 -4.3911502838134766e+01 -1.9626499938964844e+02 1.0209600067138672e+02 -4.7307300567626953e+01 -1.9693099975585938e+02 -1.0208499908447266e+02 -4.9674598693847656e+01 -1.9734199523925781e+02 -1.0207799530029297e+02 -5.8010002136230469e+01 -1.9748599243164062e+02 1.0207600402832031e+02 -5.5055500030517578e+01 -1.9734199523925781e+02 1.0207799530029297e+02 -5.7988098144531250e+01 -1.9748599243164062e+02 -1.0207600402832031e+02 -6.0942401885986328e+01 -1.9626499938964844e+02 -1.0209600067138672e+02 -6.8690597534179688e+01 -1.9693099975585938e+02 1.0208499908447266e+02 -6.6323402404785156e+01 -1.9631799316406250e+02 1.0209600067138672e+02 -6.8679397583007812e+01 -1.9572999572753906e+02 -1.0210499572753906e+02 -7.2086601257324219e+01 -1.9313200378417969e+02 -1.0214900207519531e+02 -7.8953201293945312e+01 -1.9408898925781250e+02 1.0213299560546875e+02 -7.7241195678710938e+01 -1.9322999572753906e+02 1.0214799499511719e+02 -7.8973297119140625e+01 -1.9173699951171875e+02 -1.0217300415039062e+02 -8.2637901306152344e+01 -1.8907899475097656e+02 1.0221700286865234e+02 -8.7349304199218750e+01 -1.8806199645996094e+02 -1.0223400115966797e+02 -8.8406501770019531e+01 -1.8819400024414062e+02 1.0223200225830078e+02 -8.8475799560546875e+01 -1.8567599487304688e+02 -1.0227400207519531e+02 -9.2152603149414062e+01 -1.8211199951171875e+02 1.0233399963378906e+02 -9.6222496032714844e+01 -1.8125100708007812e+02 -1.0234899902343750e+02 -9.6690498352050781e+01 -1.8139900207519531e+02 1.0234700012207031e+02 -9.6822502136230469e+01 -1.7780000305175781e+02 -1.0240699768066406e+02 -1.0023000335693359e+02 -1.7348100280761719e+02 1.0248000335693359e+02 -1.0348699951171875e+02 -1.7295899963378906e+02 -1.0248800659179688e+02 -1.0348899841308594e+02 -1.7310099792480469e+02 1.0248600006103516e+02 -1.0369200134277344e+02 -1.6844200134277344e+02 -1.0256400299072266e+02 -1.0653099822998047e+02 -1.6360899353027344e+02 1.0264600372314453e+02 -1.0880599975585938e+02 -1.5273399353027344e+02 1.0282900238037109e+02 -1.1205100250244141e+02 -1.4689900207519531e+02 -1.0292700195312500e+02 -1.1282800292968750e+02 -1.5327900695800781e+02 1.0281999969482422e+02 -1.1188899993896484e+02 -1.5324400329589844e+02 -1.0281999969482422e+02 -1.1166300201416016e+02 -1.6354901123046875e+02 1.0264699554443359e+02 -1.0883899688720703e+02 -1.5799499511718750e+02 -1.0273999786376953e+02 -1.1079000091552734e+02 -1.6350300598144531e+02 -1.0264699554443359e+02 -1.0854499816894531e+02 -1.4677600097656250e+02 -1.0492700195312500e+02 -1.1083399963378906e+02 -1.5239900207519531e+02 -1.0482800292968750e+02 -5.9128303527832031e+00 -1.5746900939941406e+02 -1.0473999786376953e+02 -1.0887000274658203e+02 -1.6282099914550781e+02 -1.0464599609375000e+02 -9.0081005096435547e+00 -1.6753601074218750e+02 -1.0456400299072266e+02 -1.0476599884033203e+02 -1.7239199829101562e+02 -1.0447899627685547e+02 -1.4164599418640137e+01 -1.7655400085449219e+02 -1.0440699768066406e+02 -9.8694694519042969e+01 -1.8070899963378906e+02 -1.0433399963378906e+02 -2.1165401458740234e+01 -1.8414300537109375e+02 -1.0427399444580078e+02 -9.0910705566406250e+01 -1.8742201232910156e+02 -1.0421700286865234e+02 -2.9716100692749023e+01 -1.8998399353027344e+02 -1.0417199707031250e+02 -8.1741897583007812e+01 -1.9225000000000000e+02 -1.0413300323486328e+02 -3.9456501007080078e+01 -1.9383200073242188e+02 -1.0410500335693359e+02 -7.1574302673339844e+01 -1.9498899841308594e+02 -1.0408499908447266e+02 -4.9977199554443359e+01 -1.9552400207519531e+02 -1.0407599639892578e+02 -6.0835498809814453e+01 -1.4677600097656250e+02 1.0492700195312500e+02 -5.1638398170471191e+00 -1.5239900207519531e+02 1.0482800292968750e+02 -1.1008500671386719e+02 -1.5746900939941406e+02 1.0473999786376953e+02 -7.1274499893188477e+00 -1.6282099914550781e+02 1.0464599609375000e+02 -1.0699000549316406e+02 -1.6753601074218750e+02 1.0456400299072266e+02 -1.1231600761413574e+01 -1.7239199829101562e+02 1.0447899627685547e+02 -1.0183300018310547e+02 -1.7655400085449219e+02 1.0440699768066406e+02 -1.7303298950195312e+01 -1.8070899963378906e+02 1.0433399963378906e+02 -9.4832504272460938e+01 -1.8414300537109375e+02 1.0427399444580078e+02 -2.5087301254272461e+01 -1.8742201232910156e+02 1.0421700286865234e+02 -8.6281997680664062e+01 -1.8998399353027344e+02 1.0417199707031250e+02 -3.4256000518798828e+01 -1.9225000000000000e+02 1.0413300323486328e+02 -7.6541404724121094e+01 -1.9383200073242188e+02 1.0410500335693359e+02 -4.4423698425292969e+01 -1.9498899841308594e+02 1.0408499908447266e+02 -6.6020698547363281e+01 -1.9552400207519531e+02 1.0407599639892578e+02 -5.5162601470947266e+01 -1.6350300598144531e+02 1.0340899658203125e+02 -1.0869400024414062e+02 -1.5271900939941406e+02 1.0359200286865234e+02 -1.1189900207519531e+02 -1.5264999389648438e+02 1.0423999786376953e+02 -1.1147299957275391e+02 -1.5253799438476562e+02 1.0467399597167969e+02 -1.1083599853515625e+02 -1.4683399963378906e+02 1.0477300262451172e+02 -4.4014997482299805e+00 -1.4687699890136719e+02 1.0434000396728516e+02 -3.7550199031829834e+00 -1.4689999389648438e+02 1.0369099426269531e+02 -3.3226499557495117e+00 -1.5796501159667969e+02 1.0350300598144531e+02 -5.3565998077392578e+00 -1.6838101196289062e+02 1.0332600402832031e+02 -9.6052198410034180e+00 -1.7771199035644531e+02 1.0316699981689453e+02 -1.5889499664306641e+01 -1.8556300354003906e+02 1.0303399658203125e+02 -2.3944801330566406e+01 -1.9160600280761719e+02 1.0293099975585938e+02 -3.3432300567626953e+01 -1.9558699035644531e+02 1.0286299896240234e+02 -4.3952899932861328e+01 -1.9733700561523438e+02 1.0283300018310547e+02 -5.5064201354980469e+01 -1.9678401184082031e+02 1.0284300231933594e+02 -6.6298904418945312e+01 -1.9395098876953125e+02 1.0289099884033203e+02 -7.7184700012207031e+01 -1.8895600891113281e+02 1.0297600555419922e+02 -8.7263595581054688e+01 -1.8200999450683594e+02 1.0309399414062500e+02 -9.6111701965332031e+01 -1.5768000793457031e+02 1.0458499908447266e+02 -6.3950300216674805e+00 -1.6789099121093750e+02 1.0440699768066406e+02 -1.0559499740600586e+01 -1.7703799438476562e+02 1.0424800109863281e+02 -1.6719600677490234e+01 -1.8473500061035156e+02 1.0411400604248047e+02 -2.4615900039672852e+01 -1.9065899658203125e+02 1.0401100158691406e+02 -3.3916397094726562e+01 -1.9456100463867188e+02 1.0394300079345703e+02 -4.4229701995849609e+01 -1.9627699279785156e+02 1.0391400146484375e+02 -5.5122100830078125e+01 -1.9573498535156250e+02 1.0392300415039062e+02 -6.6135398864746094e+01 -1.9295799255371094e+02 1.0397100067138672e+02 -7.6806503295898438e+01 -1.8806100463867188e+02 1.0405599975585938e+02 -8.6686798095703125e+01 -1.8125199890136719e+02 1.0417500305175781e+02 -9.5360504150390625e+01 -1.7281599426269531e+02 1.0432199859619141e+02 -1.0246299743652344e+02 -1.5785400390625000e+02 1.0415100097656250e+02 -5.7733597755432129e+00 -1.6818800354003906e+02 1.0397299957275391e+02 -9.9887199401855469e+00 -1.7744400024414062e+02 1.0381300354003906e+02 -1.6223499298095703e+01 -1.8523300170898438e+02 1.0367900085449219e+02 -2.4215000152587891e+01 -1.9122799682617188e+02 1.0357599639892578e+02 -3.3627399444580078e+01 -1.9517700195312500e+02 1.0350800323486328e+02 -4.4064601898193359e+01 -1.9691300964355469e+02 1.0347799682617188e+02 -5.5087497711181641e+01 -1.9636500549316406e+02 1.0348699951171875e+02 -6.6232894897460938e+01 -1.9355400085449219e+02 1.0353600311279297e+02 -7.7032203674316406e+01 -1.8859899902343750e+02 1.0362100219726562e+02 -8.7031105041503906e+01 -1.8170899963378906e+02 1.0373999786376953e+02 -9.5809303283691406e+01 -1.7317199707031250e+02 1.0388700103759766e+02 -1.0299699401855469e+02 -1.7340501403808594e+02 1.0323999786376953e+02 -1.0335700225830078e+02 -1.6334800720214844e+02 1.0405599975585938e+02 -1.0829299926757812e+02 -1.6310900878906250e+02 1.0448999786376953e+02 -1.0769499969482422e+02 -1.6350300598144531e+02 -1.0340899658203125e+02 -7.3036499023437500e+00 -1.4683399963378906e+02 -1.0477300262451172e+02 -1.1159700012207031e+02 -1.4687699890136719e+02 -1.0434000396728516e+02 -1.1224299621582031e+02 -1.4689999389648438e+02 -1.0369099426269531e+02 -1.1267500305175781e+02 -1.5271900939941406e+02 -1.0359200286865234e+02 -4.0988202095031738e+00 -1.5264999389648438e+02 -1.0423999786376953e+02 -4.5252299308776855e+00 -1.5253799438476562e+02 -1.0467399597167969e+02 -5.1621699333190918e+00 -1.5796501159667969e+02 -1.0350300598144531e+02 -1.1064100646972656e+02 -1.6838101196289062e+02 -1.0332600402832031e+02 -1.0639300537109375e+02 -1.7771199035644531e+02 -1.0316699981689453e+02 -1.0010900115966797e+02 -1.8556300354003906e+02 -1.0303399658203125e+02 -9.2053298950195312e+01 -1.9160600280761719e+02 -1.0293099975585938e+02 -8.2565795898437500e+01 -1.9558699035644531e+02 -1.0286299896240234e+02 -7.2045104980468750e+01 -1.9733700561523438e+02 -1.0283300018310547e+02 -6.0933799743652344e+01 -1.9678401184082031e+02 -1.0284300231933594e+02 -4.9699100494384766e+01 -1.9395098876953125e+02 -1.0289099884033203e+02 -3.8813400268554688e+01 -1.8895600891113281e+02 -1.0297600555419922e+02 -2.8734498977661133e+01 -1.8200999450683594e+02 -1.0309399414062500e+02 -1.9886299133300781e+01 -1.5768000793457031e+02 -1.0458499908447266e+02 -1.0960300445556641e+02 -1.6789099121093750e+02 -1.0440699768066406e+02 -1.0543800354003906e+02 -1.7703799438476562e+02 -1.0424800109863281e+02 -9.9278396606445312e+01 -1.8473500061035156e+02 -1.0411400604248047e+02 -9.1381996154785156e+01 -1.9065899658203125e+02 -1.0401100158691406e+02 -8.2081695556640625e+01 -1.9456100463867188e+02 -1.0394300079345703e+02 -7.1768402099609375e+01 -1.9627699279785156e+02 -1.0391400146484375e+02 -6.0875999450683594e+01 -1.9573498535156250e+02 -1.0392300415039062e+02 -4.9862701416015625e+01 -1.9295799255371094e+02 -1.0397100067138672e+02 -3.9191398620605469e+01 -1.8806100463867188e+02 -1.0405599975585938e+02 -2.9311201095581055e+01 -1.8125199890136719e+02 -1.0417500305175781e+02 -2.0637599945068359e+01 -1.7281599426269531e+02 -1.0432199859619141e+02 -1.3535300254821777e+01 -1.5785400390625000e+02 -1.0415100097656250e+02 -1.1022499847412109e+02 -1.6818800354003906e+02 -1.0397299957275391e+02 -1.0600900268554688e+02 -1.7744400024414062e+02 -1.0381300354003906e+02 -9.9774505615234375e+01 -1.8523300170898438e+02 -1.0367900085449219e+02 -9.1782897949218750e+01 -1.9122799682617188e+02 -1.0357599639892578e+02 -8.2370597839355469e+01 -1.9517700195312500e+02 -1.0350800323486328e+02 -7.1933502197265625e+01 -1.9691300964355469e+02 -1.0347799682617188e+02 -6.0910400390625000e+01 -1.9636500549316406e+02 -1.0348699951171875e+02 -4.9764999389648438e+01 -1.9355400085449219e+02 -1.0353600311279297e+02 -3.8965900421142578e+01 -1.8859899902343750e+02 -1.0362100219726562e+02 -2.8966798782348633e+01 -1.8170899963378906e+02 -1.0373999786376953e+02 -2.0188699722290039e+01 -1.7317199707031250e+02 -1.0388700103759766e+02 -1.3000699996948242e+01 -1.7340501403808594e+02 -1.0323999786376953e+02 -1.2640999794006348e+01 -1.6334800720214844e+02 -1.0405599975585938e+02 -7.7051401138305664e+00 -1.6310900878906250e+02 -1.0448999786376953e+02 -8.3034505844116211e+00 -1.4256500244140625e+02 1.0483399963378906e+02 -1.1175700378417969e+02 -1.4256500244140625e+02 1.0456199645996094e+02 -1.1224800109863281e+02 -1.4256500244140625e+02 1.0439699554443359e+02 -1.1239399719238281e+02 -1.4256500244140625e+02 -1.0469599914550781e+02 -1.1205899810791016e+02 -1.4256500244140625e+02 -1.0482199859619141e+02 -1.1175399780273438e+02 -1.4256500244140625e+02 -1.0439500427246094e+02 -1.1239700317382812e+02 -1.4256500244140625e+02 -1.0424900054931641e+02 -1.1256100463867188e+02 -1.4256500244140625e+02 -1.0375800323486328e+02 -1.1283300018310547e+02 -1.4256500244140625e+02 -1.0366200256347656e+02 -1.1288599395751953e+02 -1.4256500244140625e+02 1.0343900299072266e+02 -1.1294999694824219e+02 -1.4256500244140625e+02 -1.0484799957275391e+02 -4.2336497306823730e+00 -1.4256500244140625e+02 -1.0441400146484375e+02 -3.5847899913787842e+00 -1.4256500244140625e+02 1.0375399780273438e+02 -1.1281999969482422e+02 -1.4256500244140625e+02 1.0406000518798828e+02 -1.1269499969482422e+02 -1.4256500244140625e+02 -1.0376500701904297e+02 -3.1512300968170166e+00 -1.4256500244140625e+02 -1.0495100402832031e+02 -1.1143799591064453e+02 -1.4256500244140625e+02 1.0441400146484375e+02 -3.5847899913787842e+00 -1.4256500244140625e+02 1.0484799957275391e+02 -4.2336497306823730e+00 -1.4256500244140625e+02 1.0376500701904297e+02 -3.1512300968170166e+00 -1.4256500244140625e+02 1.0488700103759766e+02 -1.1166100311279297e+02 -8.7564903259277344e+01 6.9494300842285156e+01 -3.9322299957275391e+01 -8.7564903259277344e+01 6.1480602264404297e+01 -3.6056999206542969e+01 -8.7564903259277344e+01 7.0532096862792969e+01 -4.0674900054931641e+01 -8.7564903259277344e+01 7.1884696960449219e+01 -4.1712699890136719e+01 -8.7564903259277344e+01 5.7634700775146484e+01 -4.5341800689697266e+01 -8.7564903259277344e+01 5.5644901275634766e+01 -4.6974700927734375e+01 -8.7564903259277344e+01 7.3459701538085938e+01 -4.2365100860595703e+01 -8.7564903259277344e+01 5.3374801635742188e+01 -4.8188102722167969e+01 -8.7564903259277344e+01 8.1458000183105469e+01 -3.4366802215576172e+01 -8.7564903259277344e+01 8.1680603027343750e+01 -3.6056999206542969e+01 -8.7564903259277344e+01 1.0207500457763672e+02 -2.0969598770141602e+01 -8.7564903259277344e+01 6.9494300842285156e+01 -3.2791801452636719e+01 -8.7564903259277344e+01 7.0532096862792969e+01 -3.1439199447631836e+01 -8.7564903259277344e+01 5.5644901275634766e+01 -2.5139400482177734e+01 -8.7564903259277344e+01 5.3374801635742188e+01 -2.3925899505615234e+01 -8.7564903259277344e+01 6.1228302001953125e+01 -3.8618698120117188e+01 -8.7564903259277344e+01 6.0481101989746094e+01 -4.1081802368164062e+01 -8.7564903259277344e+01 5.9267601013183594e+01 -4.3352100372314453e+01 -8.7564903259277344e+01 6.8841896057128906e+01 -3.7747303009033203e+01 -8.7564903259277344e+01 6.8619400024414062e+01 -3.6056999206542969e+01 -8.7564903259277344e+01 6.1228302001953125e+01 -3.3495399475097656e+01 -8.7564903259277344e+01 6.8841896057128906e+01 -3.4366802215576172e+01 -8.7564903259277344e+01 5.7634700775146484e+01 -2.6772300720214844e+01 -8.7564903259277344e+01 5.9267601013183594e+01 -2.8761999130249023e+01 -8.7564903259277344e+01 6.0481101989746094e+01 -3.1032100677490234e+01 -8.7564903259277344e+01 1.0207500457763672e+02 -5.7999000549316406e+01 -8.7564903259277344e+01 8.1458000183105469e+01 -3.7747303009033203e+01 -8.7564903259277344e+01 8.0805694580078125e+01 -3.9322299957275391e+01 -8.7564903259277344e+01 -1.0207500457763672e+02 -2.0969598770141602e+01 -8.7564903259277344e+01 -1.0207500457763672e+02 -5.7999000549316406e+01 -8.7564903259277344e+01 -7.8158103942871094e+01 -3.7747303009033203e+01 -8.7564903259277344e+01 -7.8380599975585938e+01 -3.6056999206542969e+01 -8.7564903259277344e+01 -7.8158103942871094e+01 -3.4366802215576172e+01 -8.7564903259277344e+01 -7.7505599975585938e+01 -3.2791801452636719e+01 -8.7564903259277344e+01 -7.3540206909179688e+01 -2.9749000549316406e+01 -8.7564903259277344e+01 -7.1849998474121094e+01 -2.9526399612426758e+01 -8.7564903259277344e+01 -6.6194305419921875e+01 -3.9322299957275391e+01 -8.7564903259277344e+01 -6.7232101440429688e+01 -4.0674900054931641e+01 -8.7564903259277344e+01 -5.2344898223876953e+01 -4.6974700927734375e+01 -8.7564903259277344e+01 -5.0074802398681641e+01 -4.8188102722167969e+01 -8.7564903259277344e+01 7.9767799377441406e+01 -4.0674900054931641e+01 -8.7564903259277344e+01 7.8415298461914062e+01 -4.1712699890136719e+01 -8.7564903259277344e+01 7.6840202331542969e+01 -4.2365100860595703e+01 -8.7564903259277344e+01 -7.5115303039550781e+01 -4.1712699890136719e+01 -8.7564903259277344e+01 -7.6467796325683594e+01 -4.0674900054931641e+01 -8.7564903259277344e+01 -7.7505599975585938e+01 -3.9322299957275391e+01 -8.7564903259277344e+01 -7.6467796325683594e+01 -3.1439199447631836e+01 -8.7564903259277344e+01 -7.5115303039550781e+01 -3.0401399612426758e+01 -8.7564903259277344e+01 7.8415298461914062e+01 -3.0401399612426758e+01 -8.7564903259277344e+01 7.9767799377441406e+01 -3.1439199447631836e+01 -8.7564903259277344e+01 8.0805694580078125e+01 -3.2791801452636719e+01 -8.7564903259277344e+01 -6.5541900634765625e+01 -3.4366802215576172e+01 -8.7564903259277344e+01 -5.7181102752685547e+01 -3.1032100677490234e+01 -8.7564903259277344e+01 -6.6194305419921875e+01 -3.2791801452636719e+01 -8.7564903259277344e+01 -5.5967700958251953e+01 -2.8761999130249023e+01 -8.7564903259277344e+01 -6.5541900634765625e+01 -3.7747303009033203e+01 -8.7564903259277344e+01 -5.4334701538085938e+01 -4.5341800689697266e+01 -8.7564903259277344e+01 -6.5319396972656250e+01 -3.6056999206542969e+01 -8.7564903259277344e+01 -5.5967700958251953e+01 -4.3352100372314453e+01 -8.7564903259277344e+01 -5.7181102752685547e+01 -4.1081802368164062e+01 -8.7564903259277344e+01 5.0911602020263672e+01 -4.8935302734375000e+01 -8.7564903259277344e+01 7.5149902343750000e+01 -4.2587699890136719e+01 -8.7564903259277344e+01 -5.4334701538085938e+01 -2.6772300720214844e+01 -8.7564903259277344e+01 -5.2344898223876953e+01 -2.5139400482177734e+01 -8.7564903259277344e+01 -6.7232101440429688e+01 -3.1439199447631836e+01 -8.7564903259277344e+01 -5.0074802398681641e+01 -2.3925899505615234e+01 -8.7564903259277344e+01 -6.8584701538085938e+01 -3.0401399612426758e+01 -8.7564903259277344e+01 -5.7928302764892578e+01 -3.8618698120117188e+01 -8.7564903259277344e+01 -5.8180599212646484e+01 -3.6056999206542969e+01 -8.7564903259277344e+01 -5.7928302764892578e+01 -3.3495399475097656e+01 -8.7564903259277344e+01 -1.8154300689697266e+01 -4.8319297790527344e+01 -8.7564903259277344e+01 1.7854299545288086e+01 -4.8319297790527344e+01 -8.7564903259277344e+01 -1.5799000740051270e+01 -4.7134002685546875e+01 -8.7564903259277344e+01 1.5499000549316406e+01 -4.7134002685546875e+01 -8.7564903259277344e+01 -1.4079599380493164e+01 -4.5829097747802734e+01 -8.7564903259277344e+01 -6.8584701538085938e+01 -4.1712699890136719e+01 -8.7564903259277344e+01 -7.0159706115722656e+01 -4.2365100860595703e+01 -8.7564903259277344e+01 -4.7611698150634766e+01 -4.8935302734375000e+01 -8.7564903259277344e+01 -7.1849998474121094e+01 -4.2587699890136719e+01 -8.7564903259277344e+01 -7.3540206909179688e+01 -4.2365100860595703e+01 -8.7564903259277344e+01 9.6041002273559570e+00 -3.3862400054931641e+01 -8.7564903259277344e+01 1.0352700233459473e+01 -3.1194898605346680e+01 -8.7564903259277344e+01 -1.0652800559997559e+01 -3.1194898605346680e+01 -8.7564903259277344e+01 -7.0159706115722656e+01 -2.9749000549316406e+01 -8.7564903259277344e+01 -4.7611698150634766e+01 -2.3178699493408203e+01 -8.7564903259277344e+01 -1.1944399833679199e+01 -2.8743900299072266e+01 -8.7564903259277344e+01 7.1884696960449219e+01 -3.0401399612426758e+01 -8.7564903259277344e+01 7.3459701538085938e+01 -2.9749000549316406e+01 -8.7564903259277344e+01 5.0911602020263672e+01 -2.3178699493408203e+01 -8.7564903259277344e+01 7.5149902343750000e+01 -2.9526399612426758e+01 -8.7564903259277344e+01 7.6840202331542969e+01 -2.9749000549316406e+01 -8.7564903259277344e+01 4.8349998474121094e+01 -4.9187599182128906e+01 -8.7564903259277344e+01 2.2549999237060547e+01 -4.9187599182128906e+01 -8.7564903259277344e+01 2.0398799896240234e+01 -4.9010196685791016e+01 -8.7564903259277344e+01 9.4267101287841797e+00 -3.5618499755859375e+01 -8.7564903259277344e+01 7.5941700935363770e+00 -3.7382400512695312e+01 -8.7564903259277344e+01 -2.1089000701904297e+01 -2.3045101165771484e+01 -8.7564903259277344e+01 -1.8398000717163086e+01 -2.3704198837280273e+01 -8.7564903259277344e+01 1.5605199813842773e+01 -2.4913198471069336e+01 -8.7564903259277344e+01 -1.5905200004577637e+01 -2.4913198471069336e+01 -8.7564903259277344e+01 1.3421700477600098e+01 -2.6618499755859375e+01 -8.7564903259277344e+01 1.1644399642944336e+01 -2.8743900299072266e+01 -8.7564903259277344e+01 -4.5049999237060547e+01 -2.2926399230957031e+01 -8.7564903259277344e+01 -2.2849998474121094e+01 -2.2926399230957031e+01 -8.7564903259277344e+01 1.2951799392700195e+01 -4.5249202728271484e+01 -8.7564903259277344e+01 1.1846800804138184e+01 -4.4836601257324219e+01 -8.7564903259277344e+01 1.0884200096130371e+01 -4.4731697082519531e+01 -8.7564903259277344e+01 -2.0698801040649414e+01 -4.9010196685791016e+01 -8.7564903259277344e+01 -2.2849998474121094e+01 -4.9187599182128906e+01 -8.7564903259277344e+01 -4.5049999237060547e+01 -4.9187599182128906e+01 -8.7564903259277344e+01 -1.3721600532531738e+01 -2.6618499755859375e+01 -8.7564903259277344e+01 2.2549999237060547e+01 -2.2926399230957031e+01 -8.7564903259277344e+01 4.8349998474121094e+01 -2.2926399230957031e+01 -8.7564903259277344e+01 1.0880299568176270e+01 -4.4731697082519531e+01 -8.7564903259277344e+01 -1.1184199333190918e+01 -4.4731697082519531e+01 -8.7564903259277344e+01 1.8097999572753906e+01 -2.3704198837280273e+01 -8.7564903259277344e+01 2.0788999557495117e+01 -2.3045101165771484e+01 -8.7564903259277344e+01 1.3782000541687012e+01 -4.5831298828125000e+01 -8.7564903259277344e+01 1.3190500259399414e+01 -4.5387802124023438e+01 -8.7564903259277344e+01 -1.1920900344848633e+01 -4.4792201995849609e+01 -8.7564903259277344e+01 -1.2191499710083008e+01 -4.4846797943115234e+01 -8.7564903259277344e+01 -1.3291999816894531e+01 -4.5271099090576172e+01 -8.7564903259277344e+01 -7.8942198753356934e+00 -3.7382400512695312e+01 -8.7564903259277344e+01 -9.6815795898437500e+00 -3.5965000152587891e+01 -8.7564903259277344e+01 -9.4461402893066406e+00 -3.6531002044677734e+01 -8.7564903259277344e+01 -9.0366001129150391e+00 -3.6987098693847656e+01 -8.7564903259277344e+01 -9.9040899276733398e+00 -3.3862400054931641e+01 -8.7564903259277344e+01 -9.7267007827758789e+00 -3.5618202209472656e+01 -8.7564903259277344e+01 -8.4990301132202148e+00 -3.7282001495361328e+01 -8.7564903259277344e+01 8.9887399673461914e+00 -3.6744400024414062e+01 -8.7564903259277344e+01 9.3036298751831055e+00 -3.6218597412109375e+01 -8.7564903259277344e+01 8.5174999237060547e+00 -3.7136398315429688e+01 -8.7564903259277344e+01 7.9430899620056152e+00 -3.7350402832031250e+01 -9.4664001464843750e+01 1.0216400146484375e+02 -2.9990000724792480e+00 -9.4664001464843750e+01 -1.0216400146484375e+02 -2.9990000724792480e+00 -1.3188800048828125e+02 -1.0281999969482422e+02 -1.1195299530029297e+02 -1.3529499816894531e+02 1.0287699890136719e+02 -1.1251599884033203e+02 -1.3183699035644531e+02 -1.0281900024414062e+02 -1.1193700408935547e+02 -1.3189299011230469e+02 1.0281999969482422e+02 -1.1170099639892578e+02 -1.2432499694824219e+02 1.0269300079345703e+02 -1.0988600158691406e+02 -1.2152999877929688e+02 -1.0264600372314453e+02 -1.0876999664306641e+02 -1.2161399841308594e+02 1.0264699554443359e+02 -1.0860800170898438e+02 -1.2110500335693359e+02 -1.0263899993896484e+02 -1.0863899993896484e+02 -1.1412300109863281e+02 1.0252100372314453e+02 -1.0507400512695312e+02 -1.1205200195312500e+02 -1.0248600006103516e+02 -1.0365200042724609e+02 -1.1212900543212891e+02 1.0248800659179688e+02 -1.0356999969482422e+02 -1.1122400665283203e+02 -1.0247200012207031e+02 -1.0319599914550781e+02 -1.0375800323486328e+02 -1.0234700012207031e+02 -9.6791404724121094e+01 -1.0511700439453125e+02 1.0237000274658203e+02 -9.8280899047851562e+01 -1.0380099487304688e+02 1.0234799957275391e+02 -9.6778396606445312e+01 -1.0266300201416016e+02 -1.0232900238037109e+02 -9.5851303100585938e+01 -9.6965301513671875e+01 -1.0223300170898438e+02 -8.8454200744628906e+01 -9.7686203002929688e+01 1.0224500274658203e+02 -8.9793502807617188e+01 -9.6950599670410156e+01 1.0223200225830078e+02 -8.8489601135253906e+01 -9.5779296875000000e+01 -1.0221300506591797e+02 -8.6914398193359375e+01 -9.1928901672363281e+01 -1.0214799499511719e+02 -7.8960800170898438e+01 -9.2143501281738281e+01 1.0215200042724609e+02 -7.9968803405761719e+01 -9.1840805053710938e+01 1.0214599609375000e+02 -7.9018104553222656e+01 -9.0864006042480469e+01 -1.0213000488281250e+02 -7.6761093139648438e+01 -8.8838897705078125e+01 -1.0209600067138672e+02 -6.8674499511718750e+01 -8.8670593261718750e+01 1.0209300231933594e+02 -6.8723899841308594e+01 -8.8721702575683594e+01 1.0209400177001953e+02 -6.9219902038574219e+01 -8.8123703002929688e+01 -1.0208399963378906e+02 -6.5818695068359375e+01 -1.3552400207519531e+02 1.0487699890136719e+02 -1.1053399658203125e+02 -8.9666297912597656e+01 1.0407699584960938e+02 -1.8210599899291992e+01 -8.9529998779296875e+01 1.0407400512695312e+02 -2.0969598770141602e+01 -8.9529998779296875e+01 1.0407400512695312e+02 -5.7999000549316406e+01 -9.3128898620605469e+01 1.0413700103759766e+02 -5.4010701179504395e+00 -9.2030899047851562e+01 1.0411799621582031e+02 -6.4992203712463379e+00 -9.4628997802734375e+01 1.0416300201416016e+02 -4.9990901947021484e+00 -9.1687301635742188e+01 1.0411199951171875e+02 -7.4106998443603516e+00 -9.0073799133300781e+01 1.0408399963378906e+02 -1.5478399276733398e+01 -1.2495300292968750e+02 1.0469300079345703e+02 -1.0800000000000000e+02 -9.9283302307128906e+01 1.0424500274658203e+02 -8.8637397766113281e+01 -1.0644400024414062e+02 1.0436900329589844e+02 -9.6816101074218750e+01 -1.1512200164794922e+02 1.0452099609375000e+02 -1.0336199951171875e+02 -9.0644798278808594e+01 1.0409400177001953e+02 -6.8811897277832031e+01 -9.3942100524902344e+01 1.0415100097656250e+02 -7.9170005798339844e+01 -8.9529998779296875e+01 -1.0407400512695312e+02 -5.7999000549316406e+01 -8.9529998779296875e+01 -1.0407400512695312e+02 -2.0969598770141602e+01 -9.2375503540039062e+01 -1.0412400054931641e+02 -6.0186896324157715e+00 -9.3667701721191406e+01 -1.0414700317382812e+02 -5.1572799682617188e+00 -9.1687301635742188e+01 -1.0411199951171875e+02 -7.4106998443603516e+00 -9.4628997802734375e+01 -1.0416300201416016e+02 -4.9990901947021484e+00 -9.0073799133300781e+01 -1.0408399963378906e+02 -1.5478399276733398e+01 -8.9666297912597656e+01 -1.0407699584960938e+02 -1.8210599899291992e+01 -1.3224099731445312e+02 -1.0481999969482422e+02 -1.0999099731445312e+02 -1.2184999847412109e+02 -1.0463800048828125e+02 -1.0679800415039062e+02 -1.1232900238037109e+02 -1.0447200012207031e+02 -1.0155200195312500e+02 -1.0407900238037109e+02 -1.0432799530029297e+02 -9.4474899291992188e+01 -9.7445693969726562e+01 -1.0421199798583984e+02 -8.5862998962402344e+01 -9.2709197998046875e+01 -1.0412999725341797e+02 -7.6078895568847656e+01 -9.0068397521972656e+01 -1.0408399963378906e+02 -6.5534194946289062e+01 -8.9761100769042969e+01 1.0211199951171875e+02 -7.0184998512268066e+00 -8.9761100769042969e+01 -1.0211199951171875e+02 -7.0184998512268066e+00 -8.8147499084472656e+01 1.0208399963378906e+02 -1.5086100578308105e+01 -8.8147499084472656e+01 -1.0208399963378906e+02 -1.5086100578308105e+01 -8.7710998535156250e+01 1.0207700347900391e+02 -1.8013500213623047e+01 -8.7710998535156250e+01 -1.0207700347900391e+02 -1.8013500213623047e+01 -9.0766197204589844e+01 -1.0212300109863281e+02 -4.9855003356933594e+00 -9.0333702087402344e+01 1.0211800384521484e+02 -5.4992899894714355e+00 -9.0789901733398438e+01 1.0212300109863281e+02 -5.0430798530578613e+00 -9.0907997131347656e+01 -1.0212400054931641e+02 -4.6985602378845215e+00 -9.2163696289062500e+01 1.0213700103759766e+02 -3.6690700054168701e+00 -9.2525100708007812e+01 -1.0214099884033203e+02 -3.6204400062561035e+00 -9.2473403930664062e+01 1.0214099884033203e+02 -3.5860998630523682e+00 -9.3061698913574219e+01 -1.0214699554443359e+02 -3.2626900672912598e+00 -1.3542599487304688e+02 1.0472299957275391e+02 -1.1129100036621094e+02 -1.3534800720214844e+02 1.0429000091552734e+02 -1.1193399810791016e+02 -1.3530200195312500e+02 1.0364199829101562e+02 -1.1236399841308594e+02 -1.2436299896240234e+02 1.0345500183105469e+02 -1.0973999786376953e+02 -1.1419100189208984e+02 1.0328199768066406e+02 -1.0493899536132812e+02 -1.0521200561523438e+02 1.0312999725341797e+02 -9.8164398193359375e+01 -9.7803802490234375e+01 1.0300399780273438e+02 -8.9700897216796875e+01 -9.2278099060058594e+01 1.0290899658203125e+02 -7.9904396057128906e+01 -1.2470299530029297e+02 1.0453700256347656e+02 -1.0871900177001953e+02 -1.1473099517822266e+02 1.0436399841308594e+02 -1.0401300048828125e+02 -1.0592900085449219e+02 1.0421100616455078e+02 -9.7372703552246094e+01 -9.8666801452636719e+01 1.0408399963378906e+02 -8.9076103210449219e+01 -9.3249900817871094e+01 1.0399000549316406e+02 -7.9472801208496094e+01 -8.9905998229980469e+01 1.0393199920654297e+02 -6.8966400146484375e+01 -1.2449599456787109e+02 1.0410299682617188e+02 -1.0933000183105469e+02 -1.1440399932861328e+02 1.0392900085449219e+02 -1.0456700134277344e+02 -1.0549700164794922e+02 1.0377600097656250e+02 -9.7845802307128906e+01 -9.8147804260253906e+01 1.0364899444580078e+02 -8.9449096679687500e+01 -9.2666297912597656e+01 1.0355400085449219e+02 -7.9730400085449219e+01 -8.9282402038574219e+01 1.0349600219726562e+02 -6.9097999572753906e+01 -8.8867095947265625e+01 1.0285200500488281e+02 -6.9186904907226562e+01 -8.8775398254394531e+01 1.0391200256347656e+02 -5.7999000549316406e+01 -8.8563705444335938e+01 1.0376699829101562e+02 -5.7999000549316406e+01 -8.8138404846191406e+01 1.0347600555419922e+02 -5.7999000549316406e+01 -8.7854995727539062e+01 1.0304599761962891e+02 -5.7999000549316406e+01 -8.7713897705078125e+01 1.0283200073242188e+02 -5.7999000549316406e+01 -8.7827102661132812e+01 1.0306400299072266e+02 -2.0969598770141602e+01 -8.8544799804687500e+01 1.0379499816894531e+02 -2.0969598770141602e+01 -8.7971702575683594e+01 1.0306700134277344e+02 -1.8041099548339844e+01 -8.8685897827148438e+01 1.0379700469970703e+02 -1.8113000869750977e+01 -8.8403999328613281e+01 1.0307399749755859e+02 -1.5140900611877441e+01 -8.9107604980468750e+01 1.0380400085449219e+02 -1.5284099578857422e+01 -9.0721199035644531e+01 1.0383300018310547e+02 -7.2165002822875977e+00 -9.0017601013183594e+01 1.0310199737548828e+02 -7.0732102394104004e+00 -9.4632499694824219e+01 1.0396199798583984e+02 -4.2468800544738770e+00 -9.4633697509765625e+01 1.0389500427246094e+02 -3.9990398883819580e+00 -9.2636100769042969e+01 1.0386299896240234e+02 -4.5394201278686523e+00 -9.0557098388671875e+01 1.0310900115966797e+02 -5.6382904052734375e+00 -9.1177101135253906e+01 1.0384000396728516e+02 -6.0035495758056641e+00 -9.2283195495605469e+01 1.0313200378417969e+02 -3.9060599803924561e+00 -9.4640098571777344e+01 1.0352899932861328e+02 -3.6329498291015625e+00 -9.4650901794433594e+01 1.0291600036621094e+02 -3.2005798816680908e+00 -9.4646499633789062e+01 1.0316299438476562e+02 -3.2669799327850342e+00 -8.8563705444335938e+01 -1.0376699829101562e+02 -5.7999000549316406e+01 -8.8775398254394531e+01 -1.0391200256347656e+02 -5.7999000549316406e+01 -8.9321502685546875e+01 -1.0392200469970703e+02 -6.5641998291015625e+01 -1.3190400695800781e+02 -1.0358399963378906e+02 -1.1180099487304688e+02 -1.3197700500488281e+02 -1.0423199462890625e+02 -1.1137599945068359e+02 -1.3209500122070312e+02 -1.0466600036621094e+02 -1.1073999786376953e+02 -8.7854995727539062e+01 -1.0304599761962891e+02 -5.7999000549316406e+01 -8.8138404846191406e+01 -1.0347600555419922e+02 -5.7999000549316406e+01 -8.8691001892089844e+01 -1.0348600006103516e+02 -6.5733703613281250e+01 -8.8270797729492188e+01 -1.0284099578857422e+02 -6.5795600891113281e+01 -8.7713897705078125e+01 -1.0283200073242188e+02 -5.7999000549316406e+01 -9.1002700805664062e+01 -1.0288800048828125e+02 -7.6706001281738281e+01 -9.5902702331542969e+01 -1.0297100067138672e+02 -8.6829902648925781e+01 -1.0276499938964844e+02 -1.0308799743652344e+02 -9.5741600036621094e+01 -9.1999595642089844e+01 -1.0396800231933594e+02 -7.6337394714355469e+01 -9.6803199768066406e+01 -1.0405200195312500e+02 -8.6261695861816406e+01 -1.0352999877929688e+02 -1.0416900634765625e+02 -9.4997596740722656e+01 -1.1189799499511719e+02 -1.0431400299072266e+02 -1.0217800140380859e+02 -9.1401000976562500e+01 -1.0353299713134766e+02 -7.6557395935058594e+01 -9.6261901855468750e+01 -1.0361599731445312e+02 -8.6600997924804688e+01 -1.0306900024414062e+02 -1.0373400115966797e+02 -9.5441993713378906e+01 -1.1153800201416016e+02 -1.0388000488281250e+02 -1.0270899963378906e+02 -1.1130099487304688e+02 -1.0323300170898438e+02 -1.0306599426269531e+02 -1.2115200042724609e+02 -1.0340100097656250e+02 -1.0849600219726562e+02 -1.2131000518798828e+02 -1.0404799652099609e+02 -1.0809600067138672e+02 -1.2155500030517578e+02 -1.0448200225830078e+02 -1.0750000000000000e+02 -8.8544799804687500e+01 -1.0379499816894531e+02 -2.0969598770141602e+01 -8.7827102661132812e+01 -1.0306400299072266e+02 -2.0969598770141602e+01 -8.7971702575683594e+01 -1.0306700134277344e+02 -1.8041099548339844e+01 -8.8403999328613281e+01 -1.0307399749755859e+02 -1.5140900611877441e+01 -8.8685897827148438e+01 -1.0379700469970703e+02 -1.8113000869750977e+01 -8.9107604980468750e+01 -1.0380400085449219e+02 -1.5284099578857422e+01 -9.0721199035644531e+01 -1.0383300018310547e+02 -7.2165002822875977e+00 -9.0017601013183594e+01 -1.0310199737548828e+02 -7.0732102394104004e+00 -9.1098503112792969e+01 -1.0311699676513672e+02 -4.8811902999877930e+00 -9.3131294250488281e+01 -1.0314299774169922e+02 -3.5200600624084473e+00 -9.4632499694824219e+01 -1.0396199798583984e+02 -4.2468800544738770e+00 -9.3352897644042969e+01 -1.0387500000000000e+02 -4.2130298614501953e+00 -9.4633697509765625e+01 -1.0389500427246094e+02 -3.9990398883819580e+00 -9.4640098571777344e+01 -1.0352899932861328e+02 -3.6329498291015625e+00 -9.4646499633789062e+01 -1.0316299438476562e+02 -3.2669799327850342e+00 -9.4650901794433594e+01 -1.0291600036621094e+02 -3.2005798816680908e+00 -9.1634803771972656e+01 -1.0384700012207031e+02 -5.3636302947998047e+00 -1.0256499481201172e+02 -6.9132301330566406e+01 -3.4487899780273438e+01 -8.9719200134277344e+01 -6.8938095092773438e+01 -3.4375801086425781e+01 -1.0256499481201172e+02 -7.0280899047851562e+01 -3.3339298248291016e+01 -8.9719200134277344e+01 -7.0168800354003906e+01 -3.3145099639892578e+01 -1.0256499481201172e+02 -7.1849998474121094e+01 -3.2918899536132812e+01 -8.9719200134277344e+01 -7.1849998474121094e+01 -3.2694599151611328e+01 -1.0256499481201172e+02 -7.3419097900390625e+01 -3.3339298248291016e+01 -8.9719200134277344e+01 -7.3531204223632812e+01 -3.3145099639892578e+01 -1.0256499481201172e+02 -7.4567695617675781e+01 -3.4487899780273438e+01 -8.9719200134277344e+01 -7.4761894226074219e+01 -3.4375801086425781e+01 -1.0256499481201172e+02 -7.4988098144531250e+01 -3.6056999206542969e+01 -8.9719200134277344e+01 -7.5212394714355469e+01 -3.6056999206542969e+01 -1.0256499481201172e+02 -7.4567695617675781e+01 -3.7626098632812500e+01 -8.9719200134277344e+01 -7.4761894226074219e+01 -3.7738300323486328e+01 -1.0256499481201172e+02 -7.3419097900390625e+01 -3.8774799346923828e+01 -8.9719200134277344e+01 -7.3531204223632812e+01 -3.8968997955322266e+01 -1.0256499481201172e+02 -7.1849998474121094e+01 -3.9195198059082031e+01 -8.9719200134277344e+01 -7.1849998474121094e+01 -3.9419498443603516e+01 -1.0256499481201172e+02 -7.0280899047851562e+01 -3.8774799346923828e+01 -8.9719200134277344e+01 -7.0168800354003906e+01 -3.8968997955322266e+01 -1.0256499481201172e+02 -6.9132301330566406e+01 -3.7626098632812500e+01 -8.9719200134277344e+01 -6.8938095092773438e+01 -3.7738300323486328e+01 -1.0256499481201172e+02 -6.8711799621582031e+01 -3.6056999206542969e+01 -8.9719200134277344e+01 -6.8487602233886719e+01 -3.6056999206542969e+01 -1.0256499481201172e+02 7.7867698669433594e+01 -3.4487899780273438e+01 -8.9719200134277344e+01 7.8061897277832031e+01 -3.4375801086425781e+01 -1.0256499481201172e+02 7.6719001770019531e+01 -3.3339298248291016e+01 -8.9719200134277344e+01 7.6831199645996094e+01 -3.3145099639892578e+01 -1.0256499481201172e+02 7.5149902343750000e+01 -3.2918899536132812e+01 -8.9719200134277344e+01 7.5149902343750000e+01 -3.2694599151611328e+01 -1.0256499481201172e+02 7.3580902099609375e+01 -3.3339298248291016e+01 -8.9719200134277344e+01 7.3468795776367188e+01 -3.3145099639892578e+01 -1.0256499481201172e+02 7.2432197570800781e+01 -3.4487899780273438e+01 -8.9719200134277344e+01 7.2238105773925781e+01 -3.4375801086425781e+01 -1.0256499481201172e+02 7.2011795043945312e+01 -3.6056999206542969e+01 -8.9719200134277344e+01 7.1787605285644531e+01 -3.6056999206542969e+01 -1.0256499481201172e+02 7.2432197570800781e+01 -3.7626098632812500e+01 -8.9719200134277344e+01 7.2238105773925781e+01 -3.7738300323486328e+01 -1.0256499481201172e+02 7.3580902099609375e+01 -3.8774799346923828e+01 -8.9719200134277344e+01 7.3468795776367188e+01 -3.8968997955322266e+01 -1.0256499481201172e+02 7.5149902343750000e+01 -3.9195198059082031e+01 -8.9719200134277344e+01 7.5149902343750000e+01 -3.9419498443603516e+01 -1.0256499481201172e+02 7.6719001770019531e+01 -3.8774799346923828e+01 -8.9719200134277344e+01 7.6831199645996094e+01 -3.8968997955322266e+01 -1.0256499481201172e+02 7.7867698669433594e+01 -3.7626098632812500e+01 -8.9719200134277344e+01 7.8061897277832031e+01 -3.7738300323486328e+01 -1.0256499481201172e+02 7.8288101196289062e+01 -3.6056999206542969e+01 -8.9719200134277344e+01 7.8512397766113281e+01 -3.6056999206542969e+01 -8.9591804504394531e+01 5.8123100280761719e+01 -3.4113002777099609e+01 -8.9591804504394531e+01 5.8042297363281250e+01 -3.3846500396728516e+01 -1.0256499481201172e+02 5.7844001770019531e+01 -3.3890098571777344e+01 -8.9591804504394531e+01 5.0294002532958984e+01 -2.6283899307250977e+01 -8.9591804504394531e+01 4.8349998474121094e+01 -2.6092498779296875e+01 -1.0256499481201172e+02 4.8349998474121094e+01 -2.6318799972534180e+01 -8.9591804504394531e+01 5.2163200378417969e+01 -2.6850898742675781e+01 -1.0256499481201172e+02 5.2575199127197266e+01 -2.7283199310302734e+01 -8.9591804504394531e+01 5.2654998779296875e+01 -2.7113700866699219e+01 -1.0256499481201172e+02 5.5963596343994141e+01 -2.9985399246215820e+01 -8.9591804504394531e+01 5.5395999908447266e+01 -2.9010898590087891e+01 -8.9591804504394531e+01 5.3886001586914062e+01 -2.7771800994873047e+01 -8.9591804504394531e+01 5.7556098937988281e+01 -3.2243801116943359e+01 -8.9591804504394531e+01 5.6635299682617188e+01 -3.0520999908447266e+01 -8.9591804504394531e+01 5.6104297637939453e+01 -2.9874000549316406e+01 -8.9591804504394531e+01 5.7556098937988281e+01 -3.9870300292968750e+01 -8.9591804504394531e+01 5.8042297363281250e+01 -3.8267501831054688e+01 -1.0256499481201172e+02 5.7844001770019531e+01 -3.8223999023437500e+01 -8.9591804504394531e+01 5.8123100280761719e+01 -3.8000999450683594e+01 -8.9591804504394531e+01 5.8314598083496094e+01 -3.6056999206542969e+01 -8.9591804504394531e+01 5.6635299682617188e+01 -4.1593101501464844e+01 -1.0256499481201172e+02 5.5963596343994141e+01 -4.2128700256347656e+01 -8.9591804504394531e+01 5.6104297637939453e+01 -4.2240100860595703e+01 -8.9591804504394531e+01 5.5395999908447266e+01 -4.3102996826171875e+01 -1.0256499481201172e+02 5.2575199127197266e+01 -4.4830898284912109e+01 -8.9591804504394531e+01 5.3886001586914062e+01 -4.4342300415039062e+01 -8.9591804504394531e+01 4.8349998474121094e+01 -4.6021598815917969e+01 -8.9591804504394531e+01 5.0294002532958984e+01 -4.5830200195312500e+01 -1.0256499481201172e+02 4.8349998474121094e+01 -4.5795200347900391e+01 -8.9591804504394531e+01 5.2163200378417969e+01 -4.5263099670410156e+01 -8.9591804504394531e+01 5.2654998779296875e+01 -4.5000400543212891e+01 -8.9591804504394531e+01 2.2549999237060547e+01 -4.6021598815917969e+01 -1.0256499481201172e+02 2.2549999237060547e+01 -4.5795200347900391e+01 -8.9591804504394531e+01 1.5896400451660156e+01 -4.3474800109863281e+01 -8.9591804504394531e+01 1.7355001449584961e+01 -4.4560199737548828e+01 -9.0056205749511719e+01 1.5905599594116211e+01 -4.3472202301025391e+01 -1.0256499481201172e+02 1.8324699401855469e+01 -4.4830898284912109e+01 -9.0056205749511719e+01 1.4833900451660156e+01 -4.2207000732421875e+01 -1.0256499481201172e+02 1.4936399459838867e+01 -4.2128700256347656e+01 -9.0056205749511719e+01 1.4143199920654297e+01 -4.1391700744628906e+01 -9.0056205749511719e+01 1.2881899833679199e+01 -3.8436100006103516e+01 -1.0256499481201172e+02 1.3055999755859375e+01 -3.8223999023437500e+01 -9.0056205749511719e+01 1.2864600181579590e+01 -3.8270298004150391e+01 -8.9591804504394531e+01 1.2840800285339355e+01 -3.3840499877929688e+01 -8.9591804504394531e+01 1.2590900421142578e+01 -3.5724098205566406e+01 -9.0056205749511719e+01 1.2599100112915039e+01 -3.5724201202392578e+01 -1.0256499481201172e+02 1.3055999755859375e+01 -3.3890098571777344e+01 -8.9591804504394531e+01 1.8244701385498047e+01 -4.4997901916503906e+01 -8.9591804504394531e+01 1.8986501693725586e+01 -4.5362598419189453e+01 -8.9591804504394531e+01 2.0738000869750977e+01 -4.5855602264404297e+01 -8.9591804504394531e+01 1.5589600563049316e+01 -2.8926300048828125e+01 -8.9591804504394531e+01 1.4837400436401367e+01 -2.9904199600219727e+01 -1.0256499481201172e+02 1.4936399459838867e+01 -2.9985399246215820e+01 -8.9591804504394531e+01 1.3872600555419922e+01 -3.1158401489257812e+01 -8.9591804504394531e+01 1.2848599433898926e+01 -3.3781600952148438e+01 -8.9591804504394531e+01 1.7862400054931641e+01 -2.7263799667358398e+01 -1.0256499481201172e+02 1.8324699401855469e+01 -2.7283199310302734e+01 -8.9591804504394531e+01 1.8243299484252930e+01 -2.7125699996948242e+01 -8.9591804504394531e+01 2.0509698867797852e+01 -2.6303600311279297e+01 -1.0256499481201172e+02 2.2549999237060547e+01 -2.6318799972534180e+01 -8.9591804504394531e+01 2.2549999237060547e+01 -2.6092498779296875e+01 -8.9591804504394531e+01 -5.4823101043701172e+01 -3.8000999450683594e+01 -8.9591804504394531e+01 -5.4742298126220703e+01 -3.8267501831054688e+01 -1.0256499481201172e+02 -5.4544002532958984e+01 -3.8223999023437500e+01 -8.9591804504394531e+01 -4.6993999481201172e+01 -4.5830200195312500e+01 -8.9591804504394531e+01 -4.5049999237060547e+01 -4.6021598815917969e+01 -1.0256499481201172e+02 -4.5049999237060547e+01 -4.5795200347900391e+01 -8.9591804504394531e+01 -4.8863300323486328e+01 -4.5263099670410156e+01 -1.0256499481201172e+02 -4.9275199890136719e+01 -4.4830898284912109e+01 -8.9591804504394531e+01 -4.9354999542236328e+01 -4.5000400543212891e+01 -1.0256499481201172e+02 -5.2663597106933594e+01 -4.2128700256347656e+01 -8.9591804504394531e+01 -5.2096000671386719e+01 -4.3102996826171875e+01 -8.9591804504394531e+01 -5.0585998535156250e+01 -4.4342300415039062e+01 -8.9591804504394531e+01 -5.4256099700927734e+01 -3.9870300292968750e+01 -8.9591804504394531e+01 -5.3335201263427734e+01 -4.1593101501464844e+01 -8.9591804504394531e+01 -5.2804298400878906e+01 -4.2240100860595703e+01 -8.9591804504394531e+01 -5.4256099700927734e+01 -3.2243801116943359e+01 -8.9591804504394531e+01 -5.4742298126220703e+01 -3.3846500396728516e+01 -1.0256499481201172e+02 -5.4544002532958984e+01 -3.3890098571777344e+01 -8.9591804504394531e+01 -5.4823101043701172e+01 -3.4113002777099609e+01 -8.9591804504394531e+01 -5.5014598846435547e+01 -3.6056999206542969e+01 -8.9591804504394531e+01 -5.3335201263427734e+01 -3.0520999908447266e+01 -1.0256499481201172e+02 -5.2663597106933594e+01 -2.9985399246215820e+01 -8.9591804504394531e+01 -5.2804298400878906e+01 -2.9874000549316406e+01 -8.9591804504394531e+01 -5.2096000671386719e+01 -2.9010898590087891e+01 -1.0256499481201172e+02 -4.9275199890136719e+01 -2.7283199310302734e+01 -8.9591804504394531e+01 -5.0585998535156250e+01 -2.7771800994873047e+01 -8.9591804504394531e+01 -4.5049999237060547e+01 -2.6092498779296875e+01 -8.9591804504394531e+01 -4.6993999481201172e+01 -2.6283899307250977e+01 -1.0256499481201172e+02 -4.5049999237060547e+01 -2.6318799972534180e+01 -8.9591804504394531e+01 -4.8863300323486328e+01 -2.6850898742675781e+01 -8.9591804504394531e+01 -4.9354999542236328e+01 -2.7113700866699219e+01 -8.9591804504394531e+01 -2.2849998474121094e+01 -2.6092498779296875e+01 -1.0256499481201172e+02 -2.2849998474121094e+01 -2.6318799972534180e+01 -8.9591804504394531e+01 -1.2890899658203125e+01 -3.5724098205566406e+01 -8.9591804504394531e+01 -1.3140800476074219e+01 -3.3840499877929688e+01 -9.0056205749511719e+01 -1.2899000167846680e+01 -3.5724201202392578e+01 -1.0256499481201172e+02 -1.3355999946594238e+01 -3.3890098571777344e+01 -9.0056205749511719e+01 -1.3164600372314453e+01 -3.8270298004150391e+01 -1.0256499481201172e+02 -1.3355999946594238e+01 -3.8223999023437500e+01 -9.0056205749511719e+01 -1.3181900024414062e+01 -3.8436100006103516e+01 -1.0256499481201172e+02 -1.5236399650573730e+01 -4.2128700256347656e+01 -9.0056205749511719e+01 -1.4443200111389160e+01 -4.1391700744628906e+01 -9.0056205749511719e+01 -1.5133899688720703e+01 -4.2207000732421875e+01 -8.9591804504394531e+01 -1.7654899597167969e+01 -4.4560199737548828e+01 -8.9591804504394531e+01 -1.6196399688720703e+01 -4.3474800109863281e+01 -9.0056205749511719e+01 -1.6205598831176758e+01 -4.3472202301025391e+01 -1.0256499481201172e+02 -1.8624700546264648e+01 -4.4830898284912109e+01 -8.9591804504394531e+01 -2.0809700012207031e+01 -2.6303600311279297e+01 -1.0256499481201172e+02 -1.8624700546264648e+01 -2.7283199310302734e+01 -8.9591804504394531e+01 -1.8543298721313477e+01 -2.7125699996948242e+01 -8.9591804504394531e+01 -1.8162399291992188e+01 -2.7263799667358398e+01 -1.0256499481201172e+02 -1.5236399650573730e+01 -2.9985399246215820e+01 -8.9591804504394531e+01 -1.5889599800109863e+01 -2.8926300048828125e+01 -8.9591804504394531e+01 -1.3148699760437012e+01 -3.3781497955322266e+01 -8.9591804504394531e+01 -1.4172599792480469e+01 -3.1158300399780273e+01 -8.9591804504394531e+01 -1.5137399673461914e+01 -2.9904199600219727e+01 -8.9591804504394531e+01 -2.2849998474121094e+01 -4.6021598815917969e+01 -8.9591804504394531e+01 -2.1038000106811523e+01 -4.5855602264404297e+01 -1.0256499481201172e+02 -2.2849998474121094e+01 -4.5795200347900391e+01 -8.9591804504394531e+01 -1.9286399841308594e+01 -4.5362598419189453e+01 -8.9591804504394531e+01 -1.8544700622558594e+01 -4.4997901916503906e+01 -8.9565002441406250e+01 1.2396500587463379e+01 -3.8555500030517578e+01 -8.9565002441406250e+01 1.2352700233459473e+01 -3.8370697021484375e+01 -8.9565002441406250e+01 1.1476400375366211e+01 -3.9427997589111328e+01 -8.9565002441406250e+01 -8.7550897598266602e+00 -4.0922401428222656e+01 -8.9565002441406250e+01 -9.5522403717041016e+00 -4.0806598663330078e+01 -8.9565002441406250e+01 -1.1177900314331055e+01 -4.1065399169921875e+01 -8.9565002441406250e+01 1.1274299621582031e+01 -3.9671997070312500e+01 -8.9565002441406250e+01 1.0272999763488770e+01 -4.0312500000000000e+01 -8.9565002441406250e+01 1.0877900123596191e+01 -4.1065399169921875e+01 -8.9565002441406250e+01 9.9880704879760742e+00 -4.0494800567626953e+01 -8.9565002441406250e+01 1.2172900199890137e+01 -4.1219398498535156e+01 -8.9565002441406250e+01 1.2902799606323242e+01 -4.1306201934814453e+01 -8.9565002441406250e+01 1.3640399932861328e+01 -4.1530300140380859e+01 -8.9565002441406250e+01 9.8465099334716797e+00 -4.0585498809814453e+01 -8.9565002441406250e+01 8.5541000366210938e+00 -4.0928199768066406e+01 -8.9565002441406250e+01 8.2271699905395508e+00 -4.1014801025390625e+01 -8.9565002441406250e+01 -8.4183197021484375e+00 -4.0971500396728516e+01 -8.9565002441406250e+01 -1.0180500030517578e+01 -4.0500801086425781e+01 -8.9565002441406250e+01 -1.0486100196838379e+01 -4.0352199554443359e+01 -8.9565002441406250e+01 -1.1948200225830078e+01 -4.1094898223876953e+01 -8.9565002441406250e+01 -1.1070099830627441e+01 -4.0068000793457031e+01 -8.9565002441406250e+01 -1.3050099372863770e+01 -4.1335800170898438e+01 -8.9565002441406250e+01 -1.1688799858093262e+01 -3.9477401733398438e+01 -8.9565002441406250e+01 -1.3940400123596191e+01 -4.1530300140380859e+01 -8.9565002441406250e+01 -1.2294399261474609e+01 -3.8899196624755859e+01 -8.9565002441406250e+01 -1.2696400642395020e+01 -3.8555500030517578e+01 -8.9565002441406250e+01 -1.2652699470520020e+01 -3.8370697021484375e+01 -8.9565002441406250e+01 8.2107801437377930e+00 -4.1019100189208984e+01 -8.9565002441406250e+01 7.5868401527404785e+00 -4.1048702239990234e+01 -8.9565002441406250e+01 -7.8868298530578613e+00 -4.1048702239990234e+01 -9.0050102233886719e+01 1.2598600387573242e+01 -3.5732997894287109e+01 -8.9592102050781250e+01 1.2567300796508789e+01 -3.6069999694824219e+01 -8.9592498779296875e+01 1.2519499778747559e+01 -3.6415401458740234e+01 -8.9592498779296875e+01 -1.2819499969482422e+01 -3.6415401458740234e+01 -8.9592102050781250e+01 -1.2867300033569336e+01 -3.6069999694824219e+01 -9.0050102233886719e+01 -1.2898599624633789e+01 -3.5732997894287109e+01 -9.0049995422363281e+01 -1.6197700500488281e+01 -4.3465202331542969e+01 -8.9591804504394531e+01 -1.6196100234985352e+01 -4.3474498748779297e+01 -8.9782600402832031e+01 -1.5843100547790527e+01 -4.3173099517822266e+01 -8.9594604492187500e+01 -1.5894500732421875e+01 -4.3218097686767578e+01 -8.9597503662109375e+01 -1.5578100204467773e+01 -4.2976497650146484e+01 -8.9597503662109375e+01 1.5278100013732910e+01 -4.2976497650146484e+01 -8.9594604492187500e+01 1.5594500541687012e+01 -4.3218097686767578e+01 -8.9782600402832031e+01 1.5543100357055664e+01 -4.3173099517822266e+01 -8.9591804504394531e+01 1.5895999908447266e+01 -4.3474498748779297e+01 -9.0049995422363281e+01 1.5897700309753418e+01 -4.3465202331542969e+01 -8.7926704406738281e+01 8.0349998474121094e+01 -3.7450397491455078e+01 -8.9117897033691406e+01 7.8832099914550781e+01 -3.6056999206542969e+01 -8.9117897033691406e+01 7.8338798522949219e+01 -3.7898101806640625e+01 -8.9117897033691406e+01 7.6990997314453125e+01 -3.9245800018310547e+01 -8.7926704406738281e+01 7.8956703186035156e+01 -3.9863800048828125e+01 -8.7926704406738281e+01 7.9812202453613281e+01 -3.8748802185058594e+01 -8.9117897033691406e+01 7.5149902343750000e+01 -3.9739200592041016e+01 -8.7926704406738281e+01 7.6543304443359375e+01 -4.1257099151611328e+01 -8.7926704406738281e+01 7.7841697692871094e+01 -4.0719200134277344e+01 -8.9117897033691406e+01 7.3308898925781250e+01 -3.9245800018310547e+01 -8.7926704406738281e+01 7.3756599426269531e+01 -4.1257099151611328e+01 -8.7926704406738281e+01 7.5149902343750000e+01 -4.1440502166748047e+01 -8.9117897033691406e+01 7.1961204528808594e+01 -3.7898101806640625e+01 -8.7926704406738281e+01 7.1343299865722656e+01 -3.9863800048828125e+01 -8.7926704406738281e+01 7.2458297729492188e+01 -4.0719200134277344e+01 -8.9117897033691406e+01 7.1467895507812500e+01 -3.6056999206542969e+01 -8.7926704406738281e+01 6.9949996948242188e+01 -3.7450397491455078e+01 -8.7926704406738281e+01 7.0487800598144531e+01 -3.8748802185058594e+01 -8.9117897033691406e+01 7.1961204528808594e+01 -3.4216003417968750e+01 -8.7926704406738281e+01 6.9949996948242188e+01 -3.4663700103759766e+01 -8.7926704406738281e+01 6.9766502380371094e+01 -3.6056999206542969e+01 -8.9117897033691406e+01 7.3308898925781250e+01 -3.2868198394775391e+01 -8.7926704406738281e+01 7.1343299865722656e+01 -3.2250301361083984e+01 -8.7926704406738281e+01 7.0487800598144531e+01 -3.3365303039550781e+01 -8.9117897033691406e+01 7.5149902343750000e+01 -3.2374900817871094e+01 -8.7926704406738281e+01 7.3756599426269531e+01 -3.0857000350952148e+01 -8.7926704406738281e+01 7.2458297729492188e+01 -3.1394899368286133e+01 -8.9117897033691406e+01 7.6990997314453125e+01 -3.2868198394775391e+01 -8.7926704406738281e+01 7.6543304443359375e+01 -3.0857000350952148e+01 -8.7926704406738281e+01 7.5149902343750000e+01 -3.0673601150512695e+01 -8.9117897033691406e+01 7.8338798522949219e+01 -3.4216003417968750e+01 -8.7926704406738281e+01 7.8956703186035156e+01 -3.2250301361083984e+01 -8.7926704406738281e+01 7.7841697692871094e+01 -3.1394899368286133e+01 -8.7926704406738281e+01 8.0533401489257812e+01 -3.6056999206542969e+01 -8.7926704406738281e+01 8.0349998474121094e+01 -3.4663700103759766e+01 -8.7926704406738281e+01 7.9812202453613281e+01 -3.3365303039550781e+01 -8.9191596984863281e+01 -1.2609500885009766e+01 -3.6379402160644531e+01 -8.9199401855468750e+01 -1.2563899993896484e+01 -3.6654899597167969e+01 -8.7927001953125000e+01 -1.0800100326538086e+01 -3.6221599578857422e+01 -8.9223701477050781e+01 -1.2525799751281738e+01 -3.6930000305175781e+01 -8.7927604675292969e+01 -1.0648700714111328e+01 -3.6588100433349609e+01 -8.9191200256347656e+01 -1.2655300140380859e+01 -3.6048500061035156e+01 -8.7926704406738281e+01 -1.0873200416564941e+01 -3.5656700134277344e+01 -8.9190994262695312e+01 -1.2677899360656738e+01 -3.5717098236083984e+01 -8.9257301330566406e+01 -1.2441699981689453e+01 -3.7263198852539062e+01 -8.9314605712890625e+01 -1.2298700332641602e+01 -3.7830299377441406e+01 -8.7928695678710938e+01 -1.0418799400329590e+01 -3.7144699096679688e+01 -8.9320999145507812e+01 -1.2168000221252441e+01 -3.8082397460937500e+01 -8.9326393127441406e+01 -1.1690899848937988e+01 -3.8758399963378906e+01 -8.7930099487304688e+01 -1.0090899467468262e+01 -3.7512802124023438e+01 -8.9327400207519531e+01 -1.1598400115966797e+01 -3.8851802825927734e+01 -8.7931602478027344e+01 -9.7538194656372070e+00 -3.7891601562500000e+01 -8.9333000183105469e+01 -1.1108299255371094e+01 -3.9346401214599609e+01 -8.7933197021484375e+01 -9.4030494689941406e+00 -3.8086498260498047e+01 -8.9358001708984375e+01 -8.9015398025512695e+00 -4.0433002471923828e+01 -8.7937805175781250e+01 -8.3877401351928711e+00 -3.8462600708007812e+01 -8.7935600280761719e+01 -8.8782300949096680e+00 -3.8378101348876953e+01 -8.9340499877929688e+01 -1.0441499710083008e+01 -3.9826198577880859e+01 -8.9340599060058594e+01 -1.0436699867248535e+01 -3.9829803466796875e+01 -8.9348999023437500e+01 -9.6941595077514648e+00 -4.0195301055908203e+01 -8.9369499206542969e+01 -7.8892698287963867e+00 -4.0540599822998047e+01 -8.7940002441406250e+01 -7.8892698287963867e+00 -3.8548397064208984e+01 -8.9367301940917969e+01 -8.0804204940795898e+00 -4.0536197662353516e+01 -8.9359901428222656e+01 -8.7299299240112305e+00 -4.0454601287841797e+01 -8.9369499206542969e+01 7.5892801284790039e+00 -4.0540599822998047e+01 -8.7940002441406250e+01 7.5892801284790039e+00 -3.8548397064208984e+01 -8.7926704406738281e+01 -2.2849998474121094e+01 -2.4073499679565430e+01 -8.9190994262695312e+01 -2.2849998474121094e+01 -2.5879299163818359e+01 -8.7926704406738281e+01 -2.1242799758911133e+01 -2.4181900024414062e+01 -8.9190994262695312e+01 -2.0765998840332031e+01 -2.6094999313354492e+01 -8.7926704406738281e+01 -1.8786899566650391e+01 -2.4783401489257812e+01 -8.9190994262695312e+01 -1.9434000015258789e+01 -2.6578100204467773e+01 -8.7926704406738281e+01 -1.6511999130249023e+01 -2.5886800765991211e+01 -8.9190994262695312e+01 -1.8062200546264648e+01 -2.7075700759887695e+01 -8.7926704406738281e+01 -1.4519199371337891e+01 -2.7443099975585938e+01 -8.9190994262695312e+01 -1.2941100120544434e+01 -3.3732803344726562e+01 -8.7926704406738281e+01 -1.1035099983215332e+01 -3.4054100036621094e+01 -8.9190994262695312e+01 -1.3490599632263184e+01 -3.2325302124023438e+01 -8.7926704406738281e+01 -1.1718400001525879e+01 -3.1619701385498047e+01 -8.9190994262695312e+01 -1.3987099647521973e+01 -3.1053501129150391e+01 -8.7926704406738281e+01 -1.2897199630737305e+01 -2.9382900238037109e+01 -8.9190994262695312e+01 -1.5740800857543945e+01 -2.8773799896240234e+01 -8.9190994262695312e+01 -1.5778299331665039e+01 -2.8746299743652344e+01 -8.9195800781250000e+01 1.2284899711608887e+01 -3.6527702331542969e+01 -8.7927101135253906e+01 1.0472100257873535e+01 -3.6152999877929688e+01 -8.9199401855468750e+01 1.2263899803161621e+01 -3.6654899597167969e+01 -8.7927497863769531e+01 1.0374000549316406e+01 -3.6634799957275391e+01 -8.9223701477050781e+01 1.2225800514221191e+01 -3.6930000305175781e+01 -8.9288101196289062e+01 1.2129499435424805e+01 -3.7465900421142578e+01 -8.9320999145507812e+01 1.1868000030517578e+01 -3.8082397460937500e+01 -8.7928901672363281e+01 1.0064700126647949e+01 -3.7154998779296875e+01 -8.9322296142578125e+01 1.1754899978637695e+01 -3.8242599487304688e+01 -8.9326393127441406e+01 1.1390700340270996e+01 -3.8758598327636719e+01 -8.7929801940917969e+01 9.8633804321289062e+00 -3.7493499755859375e+01 -8.9333000183105469e+01 1.0808199882507324e+01 -3.9346500396728516e+01 -8.7931495666503906e+01 9.4711198806762695e+00 -3.7822998046875000e+01 -8.9333496093750000e+01 1.0763599395751953e+01 -3.9378597259521484e+01 -8.9340599060058594e+01 1.0136400222778320e+01 -3.9829898834228516e+01 -8.7933197021484375e+01 9.0973997116088867e+00 -3.8137001037597656e+01 -8.9348999023437500e+01 9.3938703536987305e+00 -4.0195400238037109e+01 -8.7935798645019531e+01 8.5287694931030273e+00 -3.8352500915527344e+01 -8.9351493835449219e+01 9.1733903884887695e+00 -4.0261600494384766e+01 -8.9358001708984375e+01 8.6011295318603516e+00 -4.0433101654052734e+01 -8.7937500000000000e+01 8.1602296829223633e+00 -3.8492198944091797e+01 -8.9367393493652344e+01 7.7799496650695801e+00 -4.0536300659179688e+01 -8.9190994262695312e+01 1.2377900123596191e+01 -3.5717098236083984e+01 -8.7926704406738281e+01 1.0573200225830078e+01 -3.5656700134277344e+01 -8.9191200256347656e+01 1.2355299949645996e+01 -3.6048500061035156e+01 -8.9191596984863281e+01 1.2309499740600586e+01 -3.6379402160644531e+01 -8.9190994262695312e+01 -4.5049999237060547e+01 -2.5879299163818359e+01 -8.7926704406738281e+01 -4.5049999237060547e+01 -2.4073499679565430e+01 -8.7926704406738281e+01 1.0735099792480469e+01 -3.4054100036621094e+01 -8.9190994262695312e+01 1.2641099929809570e+01 -3.3732898712158203e+01 -8.7926704406738281e+01 1.1418299674987793e+01 -3.1619701385498047e+01 -8.9190994262695312e+01 1.3190600395202637e+01 -3.2325302124023438e+01 -8.7926704406738281e+01 1.2597200393676758e+01 -2.9382900238037109e+01 -8.9190994262695312e+01 1.3686999320983887e+01 -3.1053600311279297e+01 -8.7926704406738281e+01 1.4219099998474121e+01 -2.7443099975585938e+01 -8.9190994262695312e+01 2.2549999237060547e+01 -2.5879299163818359e+01 -8.7926704406738281e+01 2.2549999237060547e+01 -2.4073499679565430e+01 -8.9190994262695312e+01 2.0465999603271484e+01 -2.6094999313354492e+01 -8.7926704406738281e+01 2.0942800521850586e+01 -2.4181900024414062e+01 -8.9190994262695312e+01 1.9134000778198242e+01 -2.6578100204467773e+01 -8.7926704406738281e+01 1.8486900329589844e+01 -2.4783401489257812e+01 -8.9190994262695312e+01 1.7762201309204102e+01 -2.7075700759887695e+01 -8.7926704406738281e+01 1.6211900711059570e+01 -2.5886800765991211e+01 -8.9190994262695312e+01 1.5478300094604492e+01 -2.8746299743652344e+01 -8.9190994262695312e+01 1.5440699577331543e+01 -2.8773799896240234e+01 -8.9190994262695312e+01 -4.7035602569580078e+01 -2.6074800491333008e+01 -8.7926704406738281e+01 -4.7387802124023438e+01 -2.4303798675537109e+01 -8.9190994262695312e+01 -4.8944801330566406e+01 -2.6653999328613281e+01 -8.7926704406738281e+01 -4.9635803222656250e+01 -2.4985700607299805e+01 -8.9190994262695312e+01 -5.0704399108886719e+01 -2.7594499588012695e+01 -8.7926704406738281e+01 -5.1707599639892578e+01 -2.6093200683593750e+01 -8.9190994262695312e+01 -5.2246700286865234e+01 -2.8860300064086914e+01 -8.7926704406738281e+01 -5.3523498535156250e+01 -2.7583400726318359e+01 -8.9190994262695312e+01 -5.3512496948242188e+01 -3.0402601242065430e+01 -8.7926704406738281e+01 -5.5013797760009766e+01 -2.9399400711059570e+01 -8.9190994262695312e+01 -5.4452999114990234e+01 -3.2162101745605469e+01 -8.7926704406738281e+01 -5.6121200561523438e+01 -3.1471200942993164e+01 -8.9190994262695312e+01 -5.5032199859619141e+01 -3.4071502685546875e+01 -8.7926704406738281e+01 -5.6803199768066406e+01 -3.3719200134277344e+01 -8.9190994262695312e+01 -5.5227699279785156e+01 -3.6056999206542969e+01 -8.7926704406738281e+01 -5.7033401489257812e+01 -3.6056999206542969e+01 -8.9190994262695312e+01 -5.5032199859619141e+01 -3.8042602539062500e+01 -8.7926704406738281e+01 -5.6803199768066406e+01 -3.8394897460937500e+01 -8.9190994262695312e+01 -5.4452999114990234e+01 -3.9951801300048828e+01 -8.7926704406738281e+01 -5.6121200561523438e+01 -4.0642898559570312e+01 -8.9190994262695312e+01 -5.3512496948242188e+01 -4.1711502075195312e+01 -8.7926704406738281e+01 -5.5013797760009766e+01 -4.2714599609375000e+01 -8.9190994262695312e+01 -5.2246700286865234e+01 -4.3253803253173828e+01 -8.7926704406738281e+01 -5.3523498535156250e+01 -4.4530601501464844e+01 -8.9190994262695312e+01 -5.0704399108886719e+01 -4.4519500732421875e+01 -8.7926704406738281e+01 -5.1707599639892578e+01 -4.6020900726318359e+01 -8.9190994262695312e+01 -4.8944801330566406e+01 -4.5459999084472656e+01 -8.7926704406738281e+01 -4.9635803222656250e+01 -4.7128200531005859e+01 -8.9190994262695312e+01 -4.7035602569580078e+01 -4.6039299011230469e+01 -8.7926704406738281e+01 -4.7387802124023438e+01 -4.7810302734375000e+01 -8.9190994262695312e+01 -4.5049999237060547e+01 -4.6234802246093750e+01 -8.7926704406738281e+01 -4.5049999237060547e+01 -4.8040401458740234e+01 -8.9190994262695312e+01 4.8349998474121094e+01 -2.5879299163818359e+01 -8.7926704406738281e+01 4.8349998474121094e+01 -2.4073499679565430e+01 -8.9190994262695312e+01 -2.2849998474121094e+01 -4.6234802246093750e+01 -8.7926704406738281e+01 -2.2849998474121094e+01 -4.8040401458740234e+01 -8.9190994262695312e+01 4.8349998474121094e+01 -4.6234802246093750e+01 -8.7926704406738281e+01 4.8349998474121094e+01 -4.8040401458740234e+01 -8.9190994262695312e+01 5.0335601806640625e+01 -4.6039299011230469e+01 -8.7926704406738281e+01 5.0687801361083984e+01 -4.7810302734375000e+01 -8.9190994262695312e+01 5.2244800567626953e+01 -4.5459999084472656e+01 -8.7926704406738281e+01 5.2935802459716797e+01 -4.7128200531005859e+01 -8.9190994262695312e+01 5.4004402160644531e+01 -4.4519500732421875e+01 -8.7926704406738281e+01 5.5007598876953125e+01 -4.6020900726318359e+01 -8.9190994262695312e+01 5.5546802520751953e+01 -4.3253803253173828e+01 -8.7926704406738281e+01 5.6823497772216797e+01 -4.4530601501464844e+01 -8.9190994262695312e+01 5.6812500000000000e+01 -4.1711502075195312e+01 -8.7926704406738281e+01 5.8313796997070312e+01 -4.2714599609375000e+01 -8.9190994262695312e+01 5.7753002166748047e+01 -3.9951801300048828e+01 -8.7926704406738281e+01 5.9421199798583984e+01 -4.0642898559570312e+01 -8.9190994262695312e+01 5.8332099914550781e+01 -3.8042602539062500e+01 -8.7926704406738281e+01 6.0103199005126953e+01 -3.8394897460937500e+01 -8.9190994262695312e+01 5.8527702331542969e+01 -3.6056999206542969e+01 -8.7926704406738281e+01 6.0333400726318359e+01 -3.6056999206542969e+01 -8.9190994262695312e+01 5.8332099914550781e+01 -3.4071502685546875e+01 -8.7926704406738281e+01 6.0103199005126953e+01 -3.3719200134277344e+01 -8.9190994262695312e+01 5.7753002166748047e+01 -3.2162101745605469e+01 -8.7926704406738281e+01 5.9421199798583984e+01 -3.1471200942993164e+01 -8.9190994262695312e+01 5.6812500000000000e+01 -3.0402601242065430e+01 -8.7926704406738281e+01 5.8313796997070312e+01 -2.9399400711059570e+01 -8.9190994262695312e+01 5.5546802520751953e+01 -2.8860300064086914e+01 -8.7926704406738281e+01 5.6823497772216797e+01 -2.7583400726318359e+01 -8.9190994262695312e+01 5.4004402160644531e+01 -2.7594499588012695e+01 -8.7926704406738281e+01 5.5007598876953125e+01 -2.6093200683593750e+01 -8.9190994262695312e+01 5.2244800567626953e+01 -2.6653999328613281e+01 -8.7926704406738281e+01 5.2935802459716797e+01 -2.4985700607299805e+01 -8.9190994262695312e+01 5.0335601806640625e+01 -2.6074800491333008e+01 -8.7926704406738281e+01 5.0687801361083984e+01 -2.4303798675537109e+01 -8.7926704406738281e+01 -1.6415100097656250e+01 -4.6166198730468750e+01 -8.7926704406738281e+01 -1.4845799446105957e+01 -4.4975299835205078e+01 -8.9190994262695312e+01 -1.6051898956298828e+01 -4.3631500244140625e+01 -8.9190994262695312e+01 -2.0999200820922852e+01 -4.6065097808837891e+01 -8.7926704406738281e+01 -2.0886699676513672e+01 -4.7878601074218750e+01 -8.9190994262695312e+01 -1.9210201263427734e+01 -4.5561702728271484e+01 -8.7926704406738281e+01 -1.8564500808715820e+01 -4.7248100280761719e+01 -8.9190994262695312e+01 -1.7543901443481445e+01 -4.4742198944091797e+01 -8.9190994262695312e+01 -1.6054100036621094e+01 -4.3633499145507812e+01 -8.9190994262695312e+01 2.2549999237060547e+01 -4.6234802246093750e+01 -8.7926704406738281e+01 2.2549999237060547e+01 -4.8040401458740234e+01 -8.9204994201660156e+01 -1.5208399772644043e+01 -4.2967201232910156e+01 -8.7930206298828125e+01 -1.3849300384521484e+01 -4.4262599945068359e+01 -8.9229301452636719e+01 -1.4971799850463867e+01 -4.2780399322509766e+01 -8.9268699645996094e+01 -1.4701100349426270e+01 -4.2564998626708984e+01 -8.9193405151367188e+01 -1.5759000778198242e+01 -4.3382202148437500e+01 -8.9195999145507812e+01 -1.5451499938964844e+01 -4.3147399902343750e+01 -8.9333496093750000e+01 -1.3847599983215332e+01 -4.2091102600097656e+01 -8.7932899475097656e+01 -1.3125300407409668e+01 -4.3979499816894531e+01 -8.9340400695800781e+01 -1.3757100105285645e+01 -4.2040798187255859e+01 -8.7935295104980469e+01 -1.2457099914550781e+01 -4.3718101501464844e+01 -8.9350799560546875e+01 -1.2830499649047852e+01 -4.1763702392578125e+01 -8.7936599731445312e+01 -1.2114600181579590e+01 -4.3647201538085938e+01 -8.9361602783203125e+01 -1.1876200675964355e+01 -4.1608402252197266e+01 -8.7940002441406250e+01 -1.1180300712585449e+01 -4.3565700531005859e+01 -8.9369499206542969e+01 -1.1180300712585449e+01 -4.1573497772216797e+01 -8.7926704406738281e+01 2.0586698532104492e+01 -4.7878601074218750e+01 -8.9190994262695312e+01 2.0699300765991211e+01 -4.6065097808837891e+01 -8.7926704406738281e+01 1.8264499664306641e+01 -4.7248100280761719e+01 -8.9190994262695312e+01 1.8910200119018555e+01 -4.5561702728271484e+01 -8.7926704406738281e+01 1.6115098953247070e+01 -4.6166198730468750e+01 -8.9190994262695312e+01 1.7243801116943359e+01 -4.4742198944091797e+01 -8.7926704406738281e+01 1.4545800209045410e+01 -4.4975299835205078e+01 -8.9190994262695312e+01 1.5753999710083008e+01 -4.3633499145507812e+01 -8.9190994262695312e+01 1.5751899719238281e+01 -4.3631500244140625e+01 -8.9369499206542969e+01 1.0880299568176270e+01 -4.1573497772216797e+01 -8.7940002441406250e+01 1.0880299568176270e+01 -4.3565700531005859e+01 -8.9332000732421875e+01 1.3752999305725098e+01 -4.2165302276611328e+01 -8.7932899475097656e+01 1.2825799942016602e+01 -4.3979701995849609e+01 -8.7930404663085938e+01 1.3498499870300293e+01 -4.4234600067138672e+01 -8.9195999145507812e+01 1.5151599884033203e+01 -4.3147399902343750e+01 -8.9204994201660156e+01 1.4908400535583496e+01 -4.2967399597167969e+01 -8.7929397583007812e+01 1.3799699783325195e+01 -4.4411201477050781e+01 -8.9229301452636719e+01 1.4671900749206543e+01 -4.2780399322509766e+01 -8.9305603027343750e+01 1.4108900070190430e+01 -4.2361099243164062e+01 -8.9193405151367188e+01 1.5459000587463379e+01 -4.3382202148437500e+01 -8.9367897033691406e+01 1.1022600173950195e+01 -4.1575397491455078e+01 -8.7935600280761719e+01 1.2100399971008301e+01 -4.3704902648925781e+01 -8.9337699890136719e+01 1.3552499771118164e+01 -4.2080902099609375e+01 -8.9340400695800781e+01 1.3457000732421875e+01 -4.2040798187255859e+01 -8.9353897094726562e+01 1.2259200096130371e+01 -4.1706600189208984e+01 -8.7926704406738281e+01 -6.6650001525878906e+01 -3.7450397491455078e+01 -8.9117897033691406e+01 -6.8167900085449219e+01 -3.6056999206542969e+01 -8.9117897033691406e+01 -6.8661201477050781e+01 -3.7898101806640625e+01 -8.9117897033691406e+01 -7.0008895874023438e+01 -3.9245800018310547e+01 -8.7926704406738281e+01 -6.8043296813964844e+01 -3.9863800048828125e+01 -8.7926704406738281e+01 -6.7187797546386719e+01 -3.8748802185058594e+01 -8.9117897033691406e+01 -7.1849998474121094e+01 -3.9739200592041016e+01 -8.7926704406738281e+01 -7.0456604003906250e+01 -4.1257099151611328e+01 -8.7926704406738281e+01 -6.9158195495605469e+01 -4.0719200134277344e+01 -8.9117897033691406e+01 -7.3691001892089844e+01 -3.9245800018310547e+01 -8.7926704406738281e+01 -7.3243301391601562e+01 -4.1257099151611328e+01 -8.7926704406738281e+01 -7.1849998474121094e+01 -4.1440502166748047e+01 -8.9117897033691406e+01 -7.5038795471191406e+01 -3.7898101806640625e+01 -8.7926704406738281e+01 -7.5656700134277344e+01 -3.9863800048828125e+01 -8.7926704406738281e+01 -7.4541702270507812e+01 -4.0719200134277344e+01 -8.9117897033691406e+01 -7.5532104492187500e+01 -3.6056999206542969e+01 -8.7926704406738281e+01 -7.7050003051757812e+01 -3.7450397491455078e+01 -8.7926704406738281e+01 -7.6512199401855469e+01 -3.8748802185058594e+01 -8.9117897033691406e+01 -7.5038795471191406e+01 -3.4216003417968750e+01 -8.7926704406738281e+01 -7.7050003051757812e+01 -3.4663700103759766e+01 -8.7926704406738281e+01 -7.7233398437500000e+01 -3.6056999206542969e+01 -8.9117897033691406e+01 -7.3691001892089844e+01 -3.2868198394775391e+01 -8.7926704406738281e+01 -7.5656700134277344e+01 -3.2250301361083984e+01 -8.7926704406738281e+01 -7.6512199401855469e+01 -3.3365303039550781e+01 -8.9117897033691406e+01 -7.1849998474121094e+01 -3.2374900817871094e+01 -8.7926704406738281e+01 -7.3243301391601562e+01 -3.0857000350952148e+01 -8.7926704406738281e+01 -7.4541702270507812e+01 -3.1394899368286133e+01 -8.9117897033691406e+01 -7.0008895874023438e+01 -3.2868198394775391e+01 -8.7926704406738281e+01 -7.0456604003906250e+01 -3.0857000350952148e+01 -8.7926704406738281e+01 -7.1849998474121094e+01 -3.0673601150512695e+01 -8.9117897033691406e+01 -6.8661201477050781e+01 -3.4216003417968750e+01 -8.7926704406738281e+01 -6.8043296813964844e+01 -3.2250301361083984e+01 -8.7926704406738281e+01 -6.9158195495605469e+01 -3.1394899368286133e+01 -8.7926704406738281e+01 -6.6466499328613281e+01 -3.6056999206542969e+01 -8.7926704406738281e+01 -6.6650001525878906e+01 -3.4663700103759766e+01 -8.7926704406738281e+01 -6.7187797546386719e+01 -3.3365303039550781e+01 -8.7660995483398438e+01 1.0882100105285645e+01 -4.4119297027587891e+01 -8.7659797668457031e+01 1.1979900360107422e+01 -4.4242500305175781e+01 -8.7662101745605469e+01 1.0880299568176270e+01 -4.4115699768066406e+01 -8.7661598205566406e+01 1.0880299568176270e+01 -4.4119297027587891e+01 -8.7708396911621094e+01 1.4171899795532227e+01 -4.5394199371337891e+01 -8.7707099914550781e+01 1.4169599533081055e+01 -4.5396900177001953e+01 -8.7582000732421875e+01 1.3955200195312500e+01 -4.5637100219726562e+01 -8.7658195495605469e+01 1.3510000228881836e+01 -4.4875598907470703e+01 -8.7658500671386719e+01 1.3238600730895996e+01 -4.4716999053955078e+01 -8.7660995483398438e+01 -1.1182099342346191e+01 -4.4119297027587891e+01 -8.7662696838378906e+01 -1.1182099342346191e+01 -4.4116001129150391e+01 -8.7658096313476562e+01 2.2549999237060547e+01 -4.8586299896240234e+01 -8.7658599853515625e+01 2.2549999237060547e+01 -4.8582599639892578e+01 -8.7658599853515625e+01 2.0497900009155273e+01 -4.8413398742675781e+01 -8.7658599853515625e+01 1.5823999404907227e+01 -4.6623497009277344e+01 -8.7658599853515625e+01 1.8070600509643555e+01 -4.7754299163818359e+01 -8.7658500671386719e+01 -1.3584399223327637e+01 -4.4742000579833984e+01 -8.7657493591308594e+01 -1.4481299400329590e+01 -4.5381500244140625e+01 -8.7659797668457031e+01 -1.2330900192260742e+01 -4.4254501342773438e+01 -8.7660095214843750e+01 -1.2022599220275879e+01 -4.4191200256347656e+01 -8.7657493591308594e+01 4.8349998474121094e+01 -4.8586200714111328e+01 -8.7657493591308594e+01 -1.6121999740600586e+01 -4.6626602172851562e+01 -8.7657493591308594e+01 -1.8369300842285156e+01 -4.7757701873779297e+01 -8.7657493591308594e+01 -2.0797298431396484e+01 -4.8416900634765625e+01 -8.7657493591308594e+01 -2.2849998474121094e+01 -4.8586200714111328e+01 -8.7657493591308594e+01 5.0794300079345703e+01 -4.8345497131347656e+01 -8.7657493591308594e+01 5.3144699096679688e+01 -4.7632499694824219e+01 -8.7657493591308594e+01 5.5310802459716797e+01 -4.6474597930908203e+01 -8.7657493591308594e+01 5.7209400177001953e+01 -4.4916599273681641e+01 -8.7657493591308594e+01 5.8767601013183594e+01 -4.3017902374267578e+01 -8.7657493591308594e+01 5.9925399780273438e+01 -4.0851802825927734e+01 -8.7657493591308594e+01 6.0638401031494141e+01 -3.8501300811767578e+01 -8.7657493591308594e+01 6.0879199981689453e+01 -3.6056999206542969e+01 -8.7657493591308594e+01 6.0638401031494141e+01 -3.3612697601318359e+01 -8.7657493591308594e+01 5.9925399780273438e+01 -3.1262300491333008e+01 -8.7657493591308594e+01 5.8767601013183594e+01 -2.9096199035644531e+01 -8.7657493591308594e+01 5.7209400177001953e+01 -2.7197500228881836e+01 -8.7657493591308594e+01 5.5310802459716797e+01 -2.5639400482177734e+01 -8.7657493591308594e+01 5.3144699096679688e+01 -2.4481599807739258e+01 -8.7657493591308594e+01 5.0794300079345703e+01 -2.3768600463867188e+01 -8.7657493591308594e+01 4.8349998474121094e+01 -2.3527799606323242e+01 -8.7657493591308594e+01 -4.5049999237060547e+01 -4.8586200714111328e+01 -8.7658004760742188e+01 2.2549999237060547e+01 -2.3527599334716797e+01 -8.7656402587890625e+01 2.2549999237060547e+01 -2.3524200439453125e+01 -8.7657493591308594e+01 -4.5049999237060547e+01 -2.3527799606323242e+01 -8.7657493591308594e+01 -4.7494300842285156e+01 -2.3768600463867188e+01 -8.7657493591308594e+01 -4.9844699859619141e+01 -2.4481599807739258e+01 -8.7657493591308594e+01 -5.2010799407958984e+01 -2.5639400482177734e+01 -8.7657493591308594e+01 -5.3909397125244141e+01 -2.7197500228881836e+01 -8.7657493591308594e+01 -5.5467597961425781e+01 -2.9096199035644531e+01 -8.7657493591308594e+01 -5.6625400543212891e+01 -3.1262300491333008e+01 -8.7657493591308594e+01 -5.7338401794433594e+01 -3.3612697601318359e+01 -8.7657493591308594e+01 -5.7579101562500000e+01 -3.6056999206542969e+01 -8.7657493591308594e+01 -5.7338401794433594e+01 -3.8501300811767578e+01 -8.7657493591308594e+01 -5.6625400543212891e+01 -4.0851802825927734e+01 -8.7657493591308594e+01 -5.5467597961425781e+01 -4.3017902374267578e+01 -8.7657493591308594e+01 -5.3909397125244141e+01 -4.4916599273681641e+01 -8.7657493591308594e+01 -5.2010799407958984e+01 -4.6474597930908203e+01 -8.7657493591308594e+01 -4.9844699859619141e+01 -4.7632499694824219e+01 -8.7657493591308594e+01 -4.7494300842285156e+01 -4.8345497131347656e+01 -8.7582000732421875e+01 9.6868305206298828e+00 -3.5627201080322266e+01 -8.7705703735351562e+01 1.0005099296569824e+01 -3.5637798309326172e+01 -8.7656402587890625e+01 1.0193499565124512e+01 -3.3962299346923828e+01 -8.7656402587890625e+01 2.0869100570678711e+01 -2.3637498855590820e+01 -8.7656402587890625e+01 1.8300699234008789e+01 -2.4266601562500000e+01 -8.7656402587890625e+01 1.5921401023864746e+01 -2.5420700073242188e+01 -8.7656402587890625e+01 1.3837199211120605e+01 -2.7048299789428711e+01 -8.7656402587890625e+01 1.2140899658203125e+01 -2.9076900482177734e+01 -8.7656402587890625e+01 1.0908100128173828e+01 -3.1416200637817383e+01 -8.7658599853515625e+01 -2.2849998474121094e+01 -2.3531499862670898e+01 -8.7658096313476562e+01 -2.2849998474121094e+01 -2.3527799606323242e+01 -8.7593803405761719e+01 7.5928001403808594e+00 -3.7721000671386719e+01 -8.7659202575683594e+01 8.0564002990722656e+00 -3.7946399688720703e+01 -8.7658096313476562e+01 8.8200597763061523e+00 -3.7658401489257812e+01 -8.7657196044921875e+01 9.4447708129882812e+00 -3.7135002136230469e+01 -8.7656700134277344e+01 9.8615293502807617e+00 -3.6435699462890625e+01 -8.7699897766113281e+01 7.5917201042175293e+00 -3.7974498748779297e+01 -8.7702697753906250e+01 7.5916600227355957e+00 -3.7981399536132812e+01 -8.7658599853515625e+01 -2.1170099258422852e+01 -2.3644599914550781e+01 -8.7658599853515625e+01 -1.8603099822998047e+01 -2.4273300170898438e+01 -8.7658599853515625e+01 -1.6225200653076172e+01 -2.5426799774169922e+01 -8.7658599853515625e+01 -1.4142200469970703e+01 -2.7053400039672852e+01 -8.7658599853515625e+01 -1.2446900367736816e+01 -2.9080900192260742e+01 -8.7658599853515625e+01 -1.1214699745178223e+01 -3.1419000625610352e+01 -8.7658599853515625e+01 -1.0500599861145020e+01 -3.3963500976562500e+01 -8.7657493591308594e+01 -1.0327699661254883e+01 -3.5638401031494141e+01 -8.7659202575683594e+01 -1.0331099510192871e+01 -3.5638500213623047e+01 -8.7662696838378906e+01 -7.8915896415710449e+00 -3.7998100280761719e+01 -8.7660995483398438e+01 -7.8915896415710449e+00 -3.7994796752929688e+01 -8.7657600402832031e+01 -1.0267999649047852e+01 -3.6099502563476562e+01 -8.7658004760742188e+01 -9.9561805725097656e+00 -3.6852798461914062e+01 -8.7658798217773438e+01 -9.4128799438476562e+00 -3.7461601257324219e+01 -8.7659904479980469e+01 -8.6981000900268555e+00 -3.7857299804687500e+01 -8.7657493591308594e+01 6.9422798156738281e+01 -3.4522499084472656e+01 -8.7657493591308594e+01 6.9220802307128906e+01 -3.6056999206542969e+01 -8.7657493591308594e+01 6.9422798156738281e+01 -3.7591598510742188e+01 -8.7657493591308594e+01 7.0015106201171875e+01 -3.9021701812744141e+01 -8.7657493591308594e+01 7.0957397460937500e+01 -4.0249599456787109e+01 -8.7657493591308594e+01 7.2185394287109375e+01 -4.1191898345947266e+01 -8.7657493591308594e+01 7.3615402221679688e+01 -4.1784202575683594e+01 -8.7657493591308594e+01 7.5149902343750000e+01 -4.1986301422119141e+01 -8.7657493591308594e+01 7.6684600830078125e+01 -4.1784202575683594e+01 -8.7657493591308594e+01 7.8114601135253906e+01 -4.1191898345947266e+01 -8.7657493591308594e+01 7.9342498779296875e+01 -4.0249599456787109e+01 -8.7657493591308594e+01 8.0284797668457031e+01 -3.9021701812744141e+01 -8.7657493591308594e+01 8.0877105712890625e+01 -3.7591598510742188e+01 -8.7657493591308594e+01 8.1079200744628906e+01 -3.6056999206542969e+01 -8.7657493591308594e+01 8.0877105712890625e+01 -3.4522499084472656e+01 -8.7657493591308594e+01 8.0284797668457031e+01 -3.3092399597167969e+01 -8.7657493591308594e+01 7.9342498779296875e+01 -3.1864400863647461e+01 -8.7657493591308594e+01 7.8114601135253906e+01 -3.0922201156616211e+01 -8.7657493591308594e+01 7.6684600830078125e+01 -3.0329900741577148e+01 -8.7657493591308594e+01 7.5149902343750000e+01 -3.0127799987792969e+01 -8.7657493591308594e+01 7.3615402221679688e+01 -3.0329900741577148e+01 -8.7657493591308594e+01 7.2185394287109375e+01 -3.0922201156616211e+01 -8.7657493591308594e+01 7.0957397460937500e+01 -3.1864400863647461e+01 -8.7657493591308594e+01 7.0015106201171875e+01 -3.3092399597167969e+01 -8.7657493591308594e+01 -7.7577102661132812e+01 -3.4522499084472656e+01 -8.7657493591308594e+01 -7.7779205322265625e+01 -3.6056999206542969e+01 -8.7657493591308594e+01 -7.7577102661132812e+01 -3.7591598510742188e+01 -8.7657493591308594e+01 -7.6984802246093750e+01 -3.9021701812744141e+01 -8.7657493591308594e+01 -7.6042503356933594e+01 -4.0249599456787109e+01 -8.7657493591308594e+01 -7.4814605712890625e+01 -4.1191898345947266e+01 -8.7657493591308594e+01 -7.3384597778320312e+01 -4.1784202575683594e+01 -8.7657493591308594e+01 -7.1849998474121094e+01 -4.1986301422119141e+01 -8.7657493591308594e+01 -7.0315399169921875e+01 -4.1784202575683594e+01 -8.7657493591308594e+01 -6.8885398864746094e+01 -4.1191898345947266e+01 -8.7657493591308594e+01 -6.7657402038574219e+01 -4.0249599456787109e+01 -8.7657493591308594e+01 -6.6715202331542969e+01 -3.9021701812744141e+01 -8.7657493591308594e+01 -6.6122802734375000e+01 -3.7591598510742188e+01 -8.7657493591308594e+01 -6.5920799255371094e+01 -3.6056999206542969e+01 -8.7657493591308594e+01 -6.6122802734375000e+01 -3.4522499084472656e+01 -8.7657493591308594e+01 -6.6715202331542969e+01 -3.3092399597167969e+01 -8.7657493591308594e+01 -6.7657402038574219e+01 -3.1864400863647461e+01 -8.7657493591308594e+01 -6.8885398864746094e+01 -3.0922201156616211e+01 -8.7657493591308594e+01 -7.0315399169921875e+01 -3.0329900741577148e+01 -8.7657493591308594e+01 -7.1849998474121094e+01 -3.0127799987792969e+01 -8.7657493591308594e+01 -7.3384597778320312e+01 -3.0329900741577148e+01 -8.7657493591308594e+01 -7.4814605712890625e+01 -3.0922201156616211e+01 -8.7657493591308594e+01 -7.6042503356933594e+01 -3.1864400863647461e+01 -8.7657493591308594e+01 -7.6984802246093750e+01 -3.3092399597167969e+01 -8.9736198425292969e+01 -1.4898900032043457e+01 -4.2297500610351562e+01 -8.9708297729492188e+01 -1.4317000389099121e+01 -4.1471801757812500e+01 -8.9885597229003906e+01 -1.4415100097656250e+01 -4.1409400939941406e+01 -9.0053794860839844e+01 -1.2898599624633789e+01 -3.5735202789306641e+01 -8.9887298583984375e+01 -1.2870699882507324e+01 -3.6506500244140625e+01 -8.9885597229003906e+01 -1.3149599075317383e+01 -3.8444103240966797e+01 -8.9852493286132812e+01 -1.2864800453186035e+01 -3.6667701721191406e+01 -8.9769294738769531e+01 -1.2848899841308594e+01 -3.7078998565673828e+01 -8.9641799926757812e+01 -1.2726499557495117e+01 -3.7884799957275391e+01 -8.9645500183105469e+01 -1.2729999542236328e+01 -3.7861499786376953e+01 -8.9708297729492188e+01 -1.3036700248718262e+01 -3.8471900939941406e+01 -8.9734703063964844e+01 -1.2815600395202637e+01 -3.7297496795654297e+01 -8.9743797302246094e+01 -1.2824399948120117e+01 -3.7240100860595703e+01 -8.9595199584960938e+01 -1.2862700462341309e+01 -3.8514698028564453e+01 -8.9595199584960938e+01 -1.4165599822998047e+01 -4.1567897796630859e+01 -8.9586799621582031e+01 -1.4062900543212891e+01 -4.1628402709960938e+01 -8.9724197387695312e+01 -1.4831399917602539e+01 -4.2243400573730469e+01 -8.9642601013183594e+01 -1.4374700546264648e+01 -4.1877899169921875e+01 -8.9617202758789062e+01 -1.4233099937438965e+01 -4.1764499664306641e+01 -9.0053703308105469e+01 -1.6196201324462891e+01 -4.3463901519775391e+01 -8.9947204589843750e+01 -1.5792099952697754e+01 -4.3099601745605469e+01 -8.9888999938964844e+01 -1.5562500000000000e+01 -4.2886699676513672e+01 -8.9773200988769531e+01 -1.5105799674987793e+01 -4.2463100433349609e+01 -8.9586799621582031e+01 1.3762899398803711e+01 -4.1628402709960938e+01 -8.9595199584960938e+01 1.3865600585937500e+01 -4.1567897796630859e+01 -8.9773200988769531e+01 1.4805800437927246e+01 -4.2463100433349609e+01 -8.9888999938964844e+01 1.5262500762939453e+01 -4.2886699676513672e+01 -8.9885597229003906e+01 1.4115200042724609e+01 -4.1409400939941406e+01 -8.9628303527832031e+01 1.2413499832153320e+01 -3.7970199584960938e+01 -8.9595199584960938e+01 1.2562699317932129e+01 -3.8514698028564453e+01 -8.9641799926757812e+01 1.2426500320434570e+01 -3.7884799957275391e+01 -8.9723495483398438e+01 1.2504799842834473e+01 -3.7368801116943359e+01 -8.9708297729492188e+01 1.2736699104309082e+01 -3.8471900939941406e+01 -8.9734703063964844e+01 1.2515700340270996e+01 -3.7297496795654297e+01 -8.9885597229003906e+01 1.2849599838256836e+01 -3.8444103240966797e+01 -8.9769294738769531e+01 1.2548900604248047e+01 -3.7078998565673828e+01 -9.0053794860839844e+01 1.2598600387573242e+01 -3.5735202789306641e+01 -8.9887298583984375e+01 1.2570699691772461e+01 -3.6506500244140625e+01 -8.9852493286132812e+01 1.2564799308776855e+01 -3.6667701721191406e+01 -9.0053703308105469e+01 1.5896199226379395e+01 -4.3463901519775391e+01 -8.9947204589843750e+01 1.5491999626159668e+01 -4.3099601745605469e+01 -8.9629302978515625e+01 1.4000699996948242e+01 -4.1818698883056641e+01 -8.9642601013183594e+01 1.4074700355529785e+01 -4.1877899169921875e+01 -8.9708297729492188e+01 1.4017000198364258e+01 -4.1471801757812500e+01 -8.9736198425292969e+01 1.4598900794982910e+01 -4.2297500610351562e+01 -8.9738502502441406e+01 1.4611800193786621e+01 -4.2307800292968750e+01 -8.9581100463867188e+01 1.4813400268554688e+01 -4.2612499237060547e+01 -8.9573005676269531e+01 1.4814900398254395e+01 -4.2616901397705078e+01 -8.9865600585937500e+01 1.5513700485229492e+01 -4.3140697479248047e+01 -8.9551399230957031e+01 1.5050900459289551e+01 -4.2812702178955078e+01 -8.9517105102539062e+01 1.4825400352478027e+01 -4.2646900177001953e+01 -9.0051895141601562e+01 1.5896899223327637e+01 -4.3464599609375000e+01 -8.9562294006347656e+01 1.4628999710083008e+01 -4.2466598510742188e+01 -8.9485198974609375e+01 1.4636099815368652e+01 -4.2538799285888672e+01 -8.9407104492187500e+01 1.4174499511718750e+01 -4.2275100708007812e+01 -8.9506698608398438e+01 1.3974699974060059e+01 -4.2029102325439453e+01 -8.9391799926757812e+01 1.3961099624633789e+01 -4.2188701629638672e+01 -8.9514503479003906e+01 1.3550100326538086e+01 -4.1782901763916016e+01 -8.9513900756835938e+01 1.3548900604248047e+01 -4.1786499023437500e+01 -8.9374900817871094e+01 1.3472499847412109e+01 -4.2000099182128906e+01 -8.9378601074218750e+01 1.3779199600219727e+01 -4.2114898681640625e+01 -8.9390502929687500e+01 1.1023500442504883e+01 -4.1546199798583984e+01 -8.9383605957031250e+01 1.2103699684143066e+01 -4.1654399871826172e+01 -8.9516899108886719e+01 1.2139499664306641e+01 -4.1420299530029297e+01 -8.9382598876953125e+01 1.2266299247741699e+01 -4.1670700073242188e+01 -8.9391403198242188e+01 1.0880200386047363e+01 -4.1545101165771484e+01 -8.9503601074218750e+01 1.0878999710083008e+01 -4.1314098358154297e+01 -8.9548500061035156e+01 1.0878600120544434e+01 -4.1221698760986328e+01 -9.0051895141601562e+01 -1.6197000503540039e+01 -4.3464599609375000e+01 -8.9551399230957031e+01 -1.5350899696350098e+01 -4.2812702178955078e+01 -8.9517105102539062e+01 -1.5125400543212891e+01 -4.2646900177001953e+01 -8.9573005676269531e+01 -1.5115000724792480e+01 -4.2616901397705078e+01 -8.9865600585937500e+01 -1.5813700675964355e+01 -4.3140697479248047e+01 -8.9581100463867188e+01 -1.5113400459289551e+01 -4.2612499237060547e+01 -8.9548500061035156e+01 -1.1178700447082520e+01 -4.1221698760986328e+01 -8.9503601074218750e+01 -1.1179100036621094e+01 -4.1314098358154297e+01 -8.9391403198242188e+01 -1.1180199623107910e+01 -4.1545101165771484e+01 -8.9504798889160156e+01 -1.4195500373840332e+01 -4.1982299804687500e+01 -8.9407196044921875e+01 -1.4161499977111816e+01 -4.2165901184082031e+01 -8.9374900817871094e+01 -1.3772500038146973e+01 -4.2000099182128906e+01 -8.9461700439453125e+01 -1.4820500373840332e+01 -4.2447002410888672e+01 -8.9553802490234375e+01 -1.4850000381469727e+01 -4.2407199859619141e+01 -8.9469703674316406e+01 -1.4864600181579590e+01 -4.2475902557373047e+01 -8.9514503479003906e+01 -1.3850100517272949e+01 -4.1782901763916016e+01 -8.9513900756835938e+01 -1.3848800659179688e+01 -4.1786499023437500e+01 -8.9515701293945312e+01 -1.3003299713134766e+01 -4.1532798767089844e+01 -8.9380798339843750e+01 -1.2839400291442871e+01 -4.1726501464843750e+01 -8.9386901855468750e+01 -1.1879599571228027e+01 -4.1576099395751953e+01 -8.9380104064941406e+01 -1.2950300216674805e+01 -4.1759098052978516e+01 -9.0052001953125000e+01 -1.2898599624633789e+01 -3.5734096527099609e+01 -8.9704605102539062e+01 -1.2813899993896484e+01 -3.6575801849365234e+01 -8.9576293945312500e+01 -1.2804100036621094e+01 -3.6501003265380859e+01 -8.9568504333496094e+01 -1.2744800567626953e+01 -3.6949001312255859e+01 -8.9510200500488281e+01 -1.2730799674987793e+01 -3.6915599822998047e+01 -8.9545097351074219e+01 -1.2774600028991699e+01 -3.6665599822998047e+01 -8.9578498840332031e+01 -1.2747200012207031e+01 -3.6954700469970703e+01 -8.9511093139648438e+01 -1.2415800094604492e+01 -3.8229396820068359e+01 -8.9490898132324219e+01 -1.2680100440979004e+01 -3.7043601989746094e+01 -8.9369102478027344e+01 -1.2359299659729004e+01 -3.7854797363281250e+01 -8.9409095764160156e+01 -1.2464799880981445e+01 -3.7587898254394531e+01 -8.9510406494140625e+01 -1.2591699600219727e+01 -3.7709197998046875e+01 -8.9564804077148438e+01 -1.2727000236511230e+01 -3.7105003356933594e+01 -8.9509895324707031e+01 -1.2410500526428223e+01 -3.8226299285888672e+01 -8.9363998413085938e+01 -1.2213899612426758e+01 -3.8109100341796875e+01 -8.9548500061035156e+01 -7.8875403404235840e+00 -4.0892398834228516e+01 -8.9503601074218750e+01 -7.8880200386047363e+00 -4.0799900054931641e+01 -8.9518600463867188e+01 -8.4034204483032227e+00 -4.0768798828125000e+01 -8.9370803833007812e+01 -1.1139299392700195e+01 -3.9381999969482422e+01 -8.9369293212890625e+01 -1.1372799873352051e+01 -3.9148097991943359e+01 -8.9511795043945312e+01 -1.1542300224304199e+01 -3.9324600219726562e+01 -8.9367095947265625e+01 -1.1729699134826660e+01 -3.8790699005126953e+01 -8.9375099182128906e+01 -1.0459199905395508e+01 -3.9866699218750000e+01 -8.9514297485351562e+01 -1.0386099815368652e+01 -4.0168399810791016e+01 -8.9376296997070312e+01 -1.0274100303649902e+01 -3.9956699371337891e+01 -8.9514999389648438e+01 -1.0096799850463867e+01 -4.0312698364257812e+01 -8.9377998352050781e+01 -9.9960603713989258e+00 -4.0091899871826172e+01 -8.9517898559570312e+01 -8.7251100540161133e+00 -4.0728099822998047e+01 -8.9384895324707031e+01 -8.9089298248291016e+00 -4.0466598510742188e+01 -8.9379798889160156e+01 -9.7088203430175781e+00 -4.0231601715087891e+01 -8.9388305664062500e+01 -8.3816604614257812e+00 -4.0529800415039062e+01 -8.9386299133300781e+01 -8.6897602081298828e+00 -4.0492900848388672e+01 -8.9390205383300781e+01 -8.0819101333618164e+00 -4.0565799713134766e+01 -8.9391403198242188e+01 -7.8892102241516113e+00 -4.0569000244140625e+01 -9.0052001953125000e+01 1.2598600387573242e+01 -3.5734096527099609e+01 -8.9704605102539062e+01 1.2513899803161621e+01 -3.6575801849365234e+01 -8.9576293945312500e+01 1.2504199981689453e+01 -3.6501003265380859e+01 -8.9545097351074219e+01 1.2474599838256836e+01 -3.6665599822998047e+01 -8.9578498840332031e+01 1.2447199821472168e+01 -3.6954700469970703e+01 -8.9568504333496094e+01 1.2444799423217773e+01 -3.6949001312255859e+01 -8.9510200500488281e+01 1.2430800437927246e+01 -3.6915599822998047e+01 -8.9548500061035156e+01 7.5876097679138184e+00 -4.0892398834228516e+01 -8.9503601074218750e+01 7.5880899429321289e+00 -4.0800003051757812e+01 -8.9503601074218750e+01 -7.8880200386047363e+00 -4.0800003051757812e+01 -8.9391403198242188e+01 7.5892200469970703e+00 -4.0569000244140625e+01 -8.9390800476074219e+01 1.2133800506591797e+01 -3.7699401855468750e+01 -8.9363998413085938e+01 1.1913900375366211e+01 -3.8109100341796875e+01 -8.9505096435546875e+01 1.2257300376892090e+01 -3.7819999694824219e+01 -8.9509895324707031e+01 1.2110499382019043e+01 -3.8226299285888672e+01 -8.9511093139648438e+01 1.2115799903869629e+01 -3.8229396820068359e+01 -8.9553100585937500e+01 1.2407299995422363e+01 -3.7226402282714844e+01 -8.9466201782226562e+01 1.2354799270629883e+01 -3.7153301239013672e+01 -8.9404899597167969e+01 1.2248899459838867e+01 -3.7484897613525391e+01 -8.9390205383300781e+01 7.7814397811889648e+00 -4.0565799713134766e+01 -8.9503601074218750e+01 7.5880899429321289e+00 -4.0799900054931641e+01 -8.9387702941894531e+01 8.1738805770874023e+00 -4.0518699645996094e+01 -8.9518394470214844e+01 8.1999893188476562e+00 -4.0758697509765625e+01 -8.9517700195312500e+01 8.5210208892822266e+00 -4.0711997985839844e+01 -8.9384895324707031e+01 8.6085205078125000e+00 -4.0466701507568359e+01 -8.9379798889160156e+01 9.4084701538085938e+00 -4.0231700897216797e+01 -8.9514801025390625e+01 9.8846502304077148e+00 -4.0271202087402344e+01 -8.9377502441406250e+01 9.7796306610107422e+00 -4.0051300048828125e+01 -8.9514099121093750e+01 1.0171099662780762e+01 -4.0121799468994141e+01 -8.9375099182128906e+01 1.0158999443054199e+01 -3.9867000579833984e+01 -8.9370803833007812e+01 1.0839099884033203e+01 -3.9382202148437500e+01 -8.9511703491210938e+01 1.1311399459838867e+01 -3.9256599426269531e+01 -8.9368904113769531e+01 1.1138299942016602e+01 -3.9082603454589844e+01 -8.9367095947265625e+01 1.1429600715637207e+01 -3.8790699005126953e+01 -8.9380195617675781e+01 7.2162200927734375e+01 -3.4332000732421875e+01 -8.9380195617675781e+01 7.3424896240234375e+01 -3.3069202423095703e+01 -8.9380195617675781e+01 7.5149902343750000e+01 -3.2606998443603516e+01 -8.9380195617675781e+01 7.6875000000000000e+01 -3.3069202423095703e+01 -8.9380195617675781e+01 7.8137802124023438e+01 -3.4332000732421875e+01 -8.9380195617675781e+01 7.8599998474121094e+01 -3.6056999206542969e+01 -8.9380195617675781e+01 7.8137802124023438e+01 -3.7782100677490234e+01 -8.9380195617675781e+01 7.6875000000000000e+01 -3.9044902801513672e+01 -8.9380195617675781e+01 7.5149902343750000e+01 -3.9507099151611328e+01 -8.9380195617675781e+01 7.3424896240234375e+01 -3.9044902801513672e+01 -8.9380195617675781e+01 7.2162200927734375e+01 -3.7782100677490234e+01 -8.9380195617675781e+01 7.1699905395507812e+01 -3.6056999206542969e+01 -8.9380195617675781e+01 -7.4837799072265625e+01 -3.4332000732421875e+01 -8.9380195617675781e+01 -7.3574996948242188e+01 -3.3069202423095703e+01 -8.9380195617675781e+01 -7.1849998474121094e+01 -3.2606998443603516e+01 -8.9380195617675781e+01 -7.0124900817871094e+01 -3.3069202423095703e+01 -8.9380195617675781e+01 -6.8862106323242188e+01 -3.4332000732421875e+01 -8.9380195617675781e+01 -6.8399902343750000e+01 -3.6056999206542969e+01 -8.9380195617675781e+01 -6.8862106323242188e+01 -3.7782100677490234e+01 -8.9380195617675781e+01 -7.0124900817871094e+01 -3.9044902801513672e+01 -8.9380195617675781e+01 -7.1849998474121094e+01 -3.9507099151611328e+01 -8.9380195617675781e+01 -7.3574996948242188e+01 -3.9044902801513672e+01 -8.9380195617675781e+01 -7.4837799072265625e+01 -3.7782100677490234e+01 -8.9380195617675781e+01 -7.5300003051757812e+01 -3.6056999206542969e+01 -8.9366104125976562e+01 1.2509200096130371e+01 -3.6064201354980469e+01 -8.9364799499511719e+01 1.2531499862670898e+01 -3.5722198486328125e+01 -8.9365798950195312e+01 1.2532499313354492e+01 -3.5722198486328125e+01 -8.9366500854492188e+01 1.2461899757385254e+01 -3.6405700683593750e+01 -8.9350097656250000e+01 1.2405299186706543e+01 -3.6666900634765625e+01 -8.9348602294921875e+01 1.2354199409484863e+01 -3.6928001403808594e+01 -8.9365898132324219e+01 2.2549999237060547e+01 -2.6033599853515625e+01 -8.9364501953125000e+01 2.2549999237060547e+01 -2.6033201217651367e+01 -8.9364501953125000e+01 2.0497501373291016e+01 -2.6245599746704102e+01 -8.9364501953125000e+01 1.2791000366210938e+01 -3.3768096923828125e+01 -8.9364501953125000e+01 1.3821100234985352e+01 -3.1129301071166992e+01 -8.9364501953125000e+01 1.5548200607299805e+01 -2.8883998870849609e+01 -8.9364501953125000e+01 1.7834600448608398e+01 -2.7211601257324219e+01 -8.9341400146484375e+01 1.2193899154663086e+01 -3.7477199554443359e+01 -8.9342498779296875e+01 1.1890900611877441e+01 -3.8095798492431641e+01 -8.9365798950195312e+01 4.8349998474121094e+01 -2.6033901214599609e+01 -8.9365798950195312e+01 5.6683799743652344e+01 -3.0488500595092773e+01 -8.9365798950195312e+01 4.8349998474121094e+01 -4.6080196380615234e+01 -8.9365798950195312e+01 5.2185699462890625e+01 -4.5317096710205078e+01 -8.9365798950195312e+01 5.0305400848388672e+01 -4.5887500762939453e+01 -8.9365798950195312e+01 5.3918498992919922e+01 -4.4390998840332031e+01 -8.9365798950195312e+01 5.5437400817871094e+01 -4.3144401550292969e+01 -8.9365798950195312e+01 5.7610099792480469e+01 -3.9892700195312500e+01 -8.9365798950195312e+01 5.6683799743652344e+01 -4.1625598907470703e+01 -8.9365798950195312e+01 5.8180500030517578e+01 -3.4101699829101562e+01 -8.9365798950195312e+01 5.8373001098632812e+01 -3.6056999206542969e+01 -8.9365798950195312e+01 5.8180500030517578e+01 -3.8012401580810547e+01 -8.9365798950195312e+01 5.7610099792480469e+01 -3.2221397399902344e+01 -8.9365798950195312e+01 5.5437400817871094e+01 -2.8969699859619141e+01 -8.9365798950195312e+01 5.3918498992919922e+01 -2.7723100662231445e+01 -8.9365798950195312e+01 5.2185699462890625e+01 -2.6796899795532227e+01 -8.9365798950195312e+01 5.0305400848388672e+01 -2.6226600646972656e+01 -8.9365798950195312e+01 2.2549999237060547e+01 -4.6080196380615234e+01 -8.9341606140136719e+01 -1.2191599845886230e+01 -3.8096099853515625e+01 -8.9365798950195312e+01 1.5857299804687500e+01 -4.3518402099609375e+01 -8.9365798950195312e+01 1.7324399948120117e+01 -4.4610198974609375e+01 -8.9365798950195312e+01 1.8965499877929688e+01 -4.5417201995849609e+01 -8.9365798950195312e+01 2.0727399826049805e+01 -4.5912998199462891e+01 -8.9340400695800781e+01 -1.2329999923706055e+01 -3.7842998504638672e+01 -8.9348602294921875e+01 -1.2654200553894043e+01 -3.6928001403808594e+01 -8.9365798950195312e+01 1.5855999946594238e+01 -4.3517002105712891e+01 -8.9350097656250000e+01 -1.2705300331115723e+01 -3.6666900634765625e+01 -8.9366500854492188e+01 -1.2761899948120117e+01 -3.6405700683593750e+01 -8.9368400573730469e+01 1.5556900024414062e+01 -4.3262500762939453e+01 -8.9371200561523438e+01 1.5242899894714355e+01 -4.3022800445556641e+01 -8.9366104125976562e+01 -1.2809099197387695e+01 -3.6064201354980469e+01 -8.9365798950195312e+01 -1.2832500457763672e+01 -3.5722198486328125e+01 -8.9367301940917969e+01 -1.2832900047302246e+01 -3.5722198486328125e+01 -8.9356101989746094e+01 1.5000999450683594e+01 -4.2860099792480469e+01 -8.9354995727539062e+01 1.4763999938964844e+01 -4.2692100524902344e+01 -8.9367202758789062e+01 -2.0797800064086914e+01 -2.6246999740600586e+01 -8.9367202758789062e+01 -1.3092399597167969e+01 -3.3768402099609375e+01 -8.9367202758789062e+01 -1.4122400283813477e+01 -3.1129899978637695e+01 -8.9367202758789062e+01 -1.8135299682617188e+01 -2.7212898254394531e+01 -8.9367202758789062e+01 -1.5849299430847168e+01 -2.8885099411010742e+01 -8.9367202758789062e+01 -2.2849998474121094e+01 -2.6034599304199219e+01 -8.9366104125976562e+01 -2.2849998474121094e+01 -2.6033699035644531e+01 -8.9354301452636719e+01 1.3766500473022461e+01 -4.2139297485351562e+01 -8.9357696533203125e+01 1.3464700698852539e+01 -4.2020401000976562e+01 -8.9352302551269531e+01 1.4143499374389648e+01 -4.2314701080322266e+01 -8.9365798950195312e+01 -4.5049999237060547e+01 -2.6033901214599609e+01 -8.9365798950195312e+01 -5.3383800506591797e+01 -4.1625598907470703e+01 -8.9365798950195312e+01 -4.8885597229003906e+01 -2.6796899795532227e+01 -8.9365798950195312e+01 -4.7005298614501953e+01 -2.6226600646972656e+01 -8.9365798950195312e+01 -5.0618499755859375e+01 -2.7723100662231445e+01 -8.9365798950195312e+01 -5.2137401580810547e+01 -2.8969699859619141e+01 -8.9365798950195312e+01 -5.4310096740722656e+01 -3.2221397399902344e+01 -8.9365798950195312e+01 -5.3383800506591797e+01 -3.0488500595092773e+01 -8.9365798950195312e+01 -5.4880397796630859e+01 -3.8012401580810547e+01 -8.9365798950195312e+01 -5.5073001861572266e+01 -3.6056999206542969e+01 -8.9365798950195312e+01 -5.4880397796630859e+01 -3.4101699829101562e+01 -8.9365798950195312e+01 -5.4310096740722656e+01 -3.9892700195312500e+01 -8.9365798950195312e+01 -5.2137401580810547e+01 -4.3144401550292969e+01 -8.9365798950195312e+01 -5.0618499755859375e+01 -4.4390998840332031e+01 -8.9365798950195312e+01 -4.8885597229003906e+01 -4.5317096710205078e+01 -8.9365798950195312e+01 -4.7005298614501953e+01 -4.5887500762939453e+01 -8.9365798950195312e+01 -4.5049999237060547e+01 -4.6080196380615234e+01 -8.9365798950195312e+01 -2.2849998474121094e+01 -4.6080196380615234e+01 -8.9357101440429688e+01 -1.3764900207519531e+01 -4.2019901275634766e+01 -8.9365798950195312e+01 -2.1027399063110352e+01 -4.5912998199462891e+01 -8.9365798950195312e+01 -1.9265600204467773e+01 -4.5417201995849609e+01 -8.9365798950195312e+01 -1.7624498367309570e+01 -4.4610198974609375e+01 -8.9365798950195312e+01 -1.6157299041748047e+01 -4.3518402099609375e+01 -8.9354499816894531e+01 -1.4767499923706055e+01 -4.2495197296142578e+01 -8.9354995727539062e+01 -1.5063899993896484e+01 -4.2692100524902344e+01 -8.9365798950195312e+01 -1.6155998229980469e+01 -4.3517002105712891e+01 -8.9356101989746094e+01 -1.5301000595092773e+01 -4.2860099792480469e+01 -8.9371200561523438e+01 -1.5542900085449219e+01 -4.3022800445556641e+01 -8.9368400573730469e+01 -1.5856899261474609e+01 -4.3262500762939453e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 8646 -> 21 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8907900154590607e+02 -1.0221700370311737e+02 -2.8648799285292625e+01) (float-vector -1.7779999971389771e+02 1.0240700095891953e+02 -1.5767600387334824e+01) (float-vector -1.6354900598526001e+02 -1.0264699906110764e+02 -7.1593998000025749e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4256499707698822e+02 1.0300000011920929e+02 -1.1299899965524673e+02) (float-vector -1.6354900598526001e+02 1.0264699906110764e+02 -1.0883899778127670e+02) (float-vector -1.6844199597835541e+02 -1.0256399959325790e+02 -1.0653100162744522e+02) (float-vector -1.4689899981021881e+02 -1.0292699933052063e+02 -1.1282800137996674e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8567599356174469e+02 -1.0227400064468384e+02 -9.2152602970600128e+01) (float-vector -1.6844199597835541e+02 -1.0256399959325790e+02 -1.0653100162744522e+02) (float-vector -1.6354900598526001e+02 1.0264699906110764e+02 -1.0883899778127670e+02) (float-vector -1.8211199343204498e+02 1.0233400017023087e+02 -9.6222497522830963e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9173699617385864e+02 1.0217300057411194e+02 -3.3360101282596588e+01) (float-vector -1.7779999971389771e+02 1.0240700095891953e+02 -1.5767600387334824e+01) (float-vector -1.8907900154590607e+02 -1.0221700370311737e+02 -2.8648799285292625e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8907900154590607e+02 -1.0221700370311737e+02 -2.8648799285292625e+01) (float-vector -1.9748599827289581e+02 -1.0207600146532059e+02 -6.0942400246858597e+01) (float-vector -1.9733700156211853e+02 1.0283300280570984e+02 -5.5064201354980469e+01) (float-vector -1.9173699617385864e+02 1.0217300057411194e+02 -3.3360101282596588e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7779999971389771e+02 1.0240700095891953e+02 -1.5767600387334824e+01) (float-vector -1.5799500048160553e+02 1.0273999720811844e+02 -5.2078301087021828e+00) (float-vector -1.6354900598526001e+02 -1.0264699906110764e+02 -7.1593998000025749e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5799500048160553e+02 1.0273999720811844e+02 -5.2078301087021828e+00) (float-vector -1.7779999971389771e+02 1.0240700095891953e+02 -1.5767600387334824e+01) (float-vector -1.9173699617385864e+02 1.0217300057411194e+02 -3.3360101282596588e+01) (float-vector -1.9733700156211853e+02 1.0283300280570984e+02 -5.5064201354980469e+01) (float-vector -1.4256499707698822e+02 1.0499999672174454e+02 -4.9990899860858917e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2432499974966049e+02 1.0269299894571304e+02 -1.0988599807024002e+02) (float-vector -1.4256499707698822e+02 1.0300000011920929e+02 -1.1299899965524673e+02) (float-vector -1.4689899981021881e+02 -1.0292699933052063e+02 -1.1282800137996674e+02) (float-vector -1.2115199863910675e+02 -1.0340099781751633e+02 -1.0849600285291672e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2115199863910675e+02 -1.0340099781751633e+02 -1.0849600285291672e+02) (float-vector -1.0266300290822983e+02 -1.0232900083065033e+02 -9.5851302146911621e+01) (float-vector -1.0511700063943863e+02 1.0237000137567520e+02 -9.8280899226665497e+01) (float-vector -1.2432499974966049e+02 1.0269299894571304e+02 -1.0988599807024002e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4256499707698822e+02 1.0499999672174454e+02 -4.9990899860858917e+00) (float-vector -1.9733700156211853e+02 1.0283300280570984e+02 -5.5064201354980469e+01) (float-vector -1.8211199343204498e+02 1.0233400017023087e+02 -9.6222497522830963e+01) (float-vector -1.6354900598526001e+02 1.0264699906110764e+02 -1.0883899778127670e+02) (float-vector -1.4256499707698822e+02 1.0300000011920929e+02 -1.1299899965524673e+02) (float-vector -1.2432499974966049e+02 1.0269299894571304e+02 -1.0988599807024002e+02) (float-vector -1.0511700063943863e+02 1.0237000137567520e+02 -9.8280899226665497e+01) (float-vector -9.2143498361110687e+01 1.0215199738740921e+02 -7.9968802630901337e+01) (float-vector -8.7713897228240967e+01 1.0283199697732925e+02 -5.7998999953269958e+01) (float-vector -9.2163696885108948e+01 1.0213699936866760e+02 -3.6690700799226761e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.7713897228240967e+01 1.0283199697732925e+02 -5.7998999953269958e+01) (float-vector -9.2143498361110687e+01 1.0215199738740921e+02 -7.9968802630901337e+01) (float-vector -9.0864002704620361e+01 -1.0213000327348709e+02 -7.6761096715927124e+01) (float-vector -8.7564900517463684e+01 -1.0207500308752060e+02 -5.7998999953269958e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.0864002704620361e+01 -1.0213000327348709e+02 -7.6761096715927124e+01) (float-vector -9.2143498361110687e+01 1.0215199738740921e+02 -7.9968802630901337e+01) (float-vector -1.0511700063943863e+02 1.0237000137567520e+02 -9.8280899226665497e+01) (float-vector -1.0266300290822983e+02 -1.0232900083065033e+02 -9.5851302146911621e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9408899545669556e+02 1.0213299840688705e+02 -7.7241197228431702e+01) (float-vector -1.8211199343204498e+02 1.0233400017023087e+02 -9.6222497522830963e+01) (float-vector -1.9733700156211853e+02 1.0283300280570984e+02 -5.5064201354980469e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.7710998952388763e+01 1.0207699984312057e+02 -1.8013499677181244e+01) (float-vector -9.2163696885108948e+01 1.0213699936866760e+02 -3.6690700799226761e+00) (float-vector -8.7713897228240967e+01 1.0283199697732925e+02 -5.7998999953269958e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.7710998952388763e+01 1.0207699984312057e+02 -1.8013499677181244e+01) (float-vector -8.7713897228240967e+01 1.0283199697732925e+02 -5.7998999953269958e+01) (float-vector -8.7564900517463684e+01 -1.0207500308752060e+02 -5.7998999953269958e+01) (float-vector -8.7564900517463684e+01 -1.0207500308752060e+02 -2.0969599485397339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.3061700463294983e+01 -1.0214699804782867e+02 -3.2626900356262922e+00) (float-vector -9.2163696885108948e+01 1.0213699936866760e+02 -3.6690700799226761e+00) (float-vector -8.7710998952388763e+01 1.0207699984312057e+02 -1.8013499677181244e+01) (float-vector -8.7564900517463684e+01 -1.0207500308752060e+02 -2.0969599485397339e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4256499707698822e+02 -1.0499999672174454e+02 -4.9990899860858917e+00) (float-vector -1.6354900598526001e+02 -1.0264699906110764e+02 -7.1593998000025749e+00) (float-vector -1.5799500048160553e+02 1.0273999720811844e+02 -5.2078301087021828e+00) (float-vector -1.4256499707698822e+02 1.0499999672174454e+02 -4.9990899860858917e+00) (float-vector -9.2163696885108948e+01 1.0213699936866760e+02 -3.6690700799226761e+00) (float-vector -9.3061700463294983e+01 -1.0214699804782867e+02 -3.2626900356262922e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2115199863910675e+02 -1.0340099781751633e+02 -1.0849600285291672e+02) (float-vector -1.4689899981021881e+02 -1.0292699933052063e+02 -1.1282800137996674e+02) (float-vector -1.6844199597835541e+02 -1.0256399959325790e+02 -1.0653100162744522e+02) (float-vector -1.8567599356174469e+02 -1.0227400064468384e+02 -9.2152602970600128e+01) (float-vector -1.9313199818134308e+02 -1.0214900225400925e+02 -7.8953199088573456e+01) (float-vector -1.9748599827289581e+02 -1.0207600146532059e+02 -6.0942400246858597e+01) (float-vector -1.8907900154590607e+02 -1.0221700370311737e+02 -2.8648799285292625e+01) (float-vector -1.6354900598526001e+02 -1.0264699906110764e+02 -7.1593998000025749e+00) (float-vector -1.4256499707698822e+02 -1.0499999672174454e+02 -4.9990899860858917e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9408899545669556e+02 1.0213299840688705e+02 -7.7241197228431702e+01) (float-vector -1.9313199818134308e+02 -1.0214900225400925e+02 -7.8953199088573456e+01) (float-vector -1.8567599356174469e+02 -1.0227400064468384e+02 -9.2152602970600128e+01) (float-vector -1.8211199343204498e+02 1.0233400017023087e+02 -9.6222497522830963e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9313199818134308e+02 -1.0214900225400925e+02 -7.8953199088573456e+01) (float-vector -1.9408899545669556e+02 1.0213299840688705e+02 -7.7241197228431702e+01) (float-vector -1.9733700156211853e+02 1.0283300280570984e+02 -5.5064201354980469e+01) (float-vector -1.9748599827289581e+02 -1.0207600146532059e+02 -6.0942400246858597e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.3061700463294983e+01 -1.0214699804782867e+02 -3.2626900356262922e+00) (float-vector -8.7564900517463684e+01 -1.0207500308752060e+02 -2.0969599485397339e+01) (float-vector -8.7564900517463684e+01 -1.0207500308752060e+02 -5.7998999953269958e+01) (float-vector -9.0864002704620361e+01 -1.0213000327348709e+02 -7.6761096715927124e+01) (float-vector -1.0266300290822983e+02 -1.0232900083065033e+02 -9.5851302146911621e+01) (float-vector -1.2115199863910675e+02 -1.0340099781751633e+02 -1.0849600285291672e+02) (float-vector -1.4256499707698822e+02 -1.0499999672174454e+02 -4.9990899860858917e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_head_tilt_link_5Zzdw4.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_shoulder_pan_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.1952500000000001e+02 0.0000000000000000e+00 3.4857999999999998e+02))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 3 4 8 0 0 8 9 0 9 1 3 1364 0 0 1364 1362 0 1362 4 4 7 8 9 8 1102 8 7 1102 1 9 1100 1100 9 1102 1102 7 1103 1102 1103 1104 1100 1102 1097 1097 1102 1104 6 7 4 7 6 1103 1103 6 16 1103 16 1086 1104 1103 1105 1105 1103 1086 1097 1104 409 409 1104 1105 1105 1086 1080 409 1105 411 411 1105 1080 408 409 410 410 409 411 409 408 1097 410 411 403 403 411 406 411 1080 406 403 1129 410 1129 408 410 1097 408 1098 1129 1141 408 1141 1098 408 1128 1129 1130 403 1130 1129 1128 1141 1129 1133 367 1128 1128 1130 1133 367 1140 1128 1128 1140 1141 1133 1130 1134 402 1134 1130 402 1130 403 1132 925 1133 1133 925 367 1133 1134 1132 1132 1134 1135 401 1135 1134 401 1134 402 392 401 402 392 402 403 403 406 392 404 405 406 406 405 407 392 406 407 406 1080 1079 406 1079 404 1079 1187 404 405 404 1188 1188 404 1187 407 405 1191 1191 405 1188 392 407 396 396 407 1191 1191 1188 1192 396 1191 1194 1194 1191 1192 1188 1187 1189 1192 1188 1189 1192 1189 1193 1194 1192 1195 1195 1192 1193 1195 1213 1194 1194 1213 1214 1194 1214 396 396 397 392 396 1214 397 1213 1210 1214 1214 1210 1211 1214 1211 397 1212 1209 1213 1213 1209 1210 1195 1212 1213 1209 1206 1210 1210 1206 1207 1210 1207 1211 1211 1207 1208 1211 1208 398 397 1211 398 392 397 398 398 399 392 398 1208 399 1207 1204 1208 1208 1204 1205 1208 1205 399 1206 1197 1207 1207 1197 1204 1197 1198 1204 1204 1198 1200 1204 1200 1205 1205 1200 1202 1205 1202 400 399 1205 400 392 399 400 392 400 390 400 1202 390 1200 1201 1202 1202 1201 1203 1202 1203 390 1198 1199 1200 1200 1199 1201 1215 1203 1201 1215 1201 783 783 1201 1199 390 1203 391 1061 391 1203 1061 1203 1215 390 391 392 1063 392 391 1060 1063 391 1060 391 1061 1061 1062 1060 1215 1216 1061 1061 1216 1062 783 782 1215 1215 782 1216 1217 1062 1216 1217 1216 789 789 1216 782 1062 1068 1060 1068 1062 1217 1060 1068 1069 1069 1068 1217 789 788 1217 1218 1069 1217 1218 1217 793 793 1217 788 1060 1069 979 979 1069 1070 1070 1069 1218 979 164 120 253 979 252 252 979 120 979 253 1060 979 1070 164 1073 164 1070 1070 1218 1073 120 164 165 1073 165 164 1072 165 1073 1073 1218 1220 1073 1220 1072 120 165 121 121 165 166 166 165 1071 1071 165 1072 1072 1220 1219 1072 1219 1071 791 1219 1220 791 1220 790 790 1220 1218 166 1219 791 1071 1219 166 121 166 159 159 166 167 791 167 166 790 167 791 790 792 167 790 1218 792 793 792 1218 167 792 793 159 167 160 167 788 789 167 789 160 167 793 788 784 160 789 784 789 782 782 783 784 783 785 784 783 1199 785 784 785 786 786 785 1198 1198 785 1199 784 786 787 787 786 1197 1197 786 1198 750 784 787 750 787 751 751 787 1197 1206 751 1197 749 750 751 749 751 1206 750 749 778 778 784 750 749 779 778 1206 779 749 1209 779 1206 778 779 780 780 779 1209 1212 780 1209 778 780 781 781 780 1212 1196 781 1212 1196 1212 1195 356 778 781 356 781 354 354 781 1196 1195 1193 1196 1196 1193 355 1196 355 354 354 355 356 356 355 357 357 778 356 355 360 357 360 803 357 357 803 778 803 820 778 778 820 784 360 802 803 802 819 803 803 819 820 355 359 360 359 802 360 359 774 802 774 818 802 802 818 819 818 162 819 819 162 161 819 161 820 817 163 818 818 163 162 774 817 818 158 161 162 158 162 153 153 162 163 160 161 158 820 161 160 158 159 160 153 1254 158 158 1254 1252 158 1252 159 820 160 784 159 1252 1310 159 1310 121 1251 1252 1253 1253 1252 1254 1251 1310 1252 1251 1309 1310 121 1310 1309 119 120 121 119 121 168 168 121 169 121 1309 169 1308 1307 1309 1308 1309 1251 169 1309 1307 168 169 170 170 169 171 171 169 172 169 1307 172 1306 1305 1307 1306 1307 1308 172 1307 1305 1304 1305 1306 1389 1304 1306 1389 1306 1390 1390 1306 1308 1304 1303 1305 172 1305 174 174 1305 1303 1302 1303 1304 1388 1302 1304 1388 1304 1389 1385 1388 1389 1389 1390 1385 1390 1308 1391 1385 1390 1391 1391 1308 1251 1391 1251 1392 1385 1391 1392 1392 1251 1253 1392 1253 1393 1393 1385 1392 1253 1254 1255 1393 1253 1255 1393 1255 1394 1394 1385 1393 1255 1254 1256 1255 1256 1257 1394 1255 1257 153 1256 1254 1257 1256 1258 152 1258 1256 152 1256 153 1257 1258 1259 1259 1367 1257 1394 1257 1395 1395 1257 1367 1259 1258 1260 1366 1367 1259 1259 1260 1366 1366 1381 1367 1367 1381 1395 1394 1395 1383 1395 1381 1382 1395 1382 1383 1380 1288 1381 1381 1288 1290 1381 1290 1382 1380 1381 1366 1382 1290 1292 1382 1292 1383 1383 1292 1294 1383 1294 1384 1383 1384 1394 1290 1291 1292 1292 1291 1293 1292 1293 1294 1288 1289 1290 1290 1289 1291 196 1293 1291 196 1291 202 202 1291 1289 1294 1293 1295 193 1295 1293 193 1293 196 1294 1295 1296 1296 1295 1297 189 1297 1295 189 1295 193 192 189 193 192 193 194 194 193 195 195 193 196 328 192 194 328 194 329 329 194 195 195 196 197 329 195 331 331 195 197 327 328 329 327 329 330 329 331 330 326 328 327 326 192 328 322 326 327 330 1225 327 327 1225 1224 327 1224 322 322 325 326 192 326 325 321 325 322 321 188 325 325 188 187 325 187 192 187 189 192 187 188 189 189 188 190 321 190 188 321 322 323 323 190 321 189 190 185 185 190 191 323 191 190 185 1297 189 1296 1297 1298 1298 1297 1299 185 1299 1297 1384 1294 1296 1384 1296 1385 1385 1296 1298 1298 1299 1300 1385 1298 1386 1386 1298 1300 1300 1299 1301 183 1301 1299 183 1299 185 1300 1301 1302 1386 1300 1387 1387 1300 1302 1386 1387 1385 1394 1384 1385 1385 1387 1388 1387 1302 1388 1302 1301 1303 179 1303 1301 179 1301 183 174 1303 179 177 178 179 179 178 180 179 180 174 177 179 182 182 179 183 174 175 172 174 180 181 174 181 175 312 181 180 312 180 314 314 180 178 311 175 181 311 181 312 310 311 312 310 312 313 312 314 313 313 314 315 314 178 315 313 315 316 316 1237 313 313 1237 1248 313 1248 310 320 316 315 315 178 177 315 177 320 319 316 320 320 177 182 320 182 319 317 318 319 319 318 316 186 317 319 319 182 184 319 184 186 182 183 184 184 183 185 184 185 186 185 191 186 317 186 324 324 186 191 324 318 317 323 318 324 324 191 323 323 322 318 322 1224 1222 322 1222 318 1223 1222 1224 1223 1224 1225 1225 1226 1223 330 1226 1225 1223 1226 1227 280 1227 1226 280 1226 330 330 331 332 330 332 280 279 278 280 280 332 333 280 333 279 278 1227 280 1223 1227 1228 278 1228 1227 1228 1229 1223 282 1229 1228 282 1228 278 1223 1229 1230 287 1230 1229 287 1229 282 1223 1230 1231 289 1231 1230 289 1230 287 282 286 287 290 289 287 290 287 291 291 287 286 282 285 286 209 286 285 286 209 291 291 209 215 291 215 290 288 289 290 290 215 214 290 214 288 208 214 215 208 215 209 208 209 205 205 209 210 285 210 209 213 214 208 205 1285 208 208 1285 1283 208 1283 213 213 212 214 288 214 212 211 212 213 288 212 292 292 212 211 211 213 216 292 211 216 288 292 289 289 292 293 216 293 292 216 213 217 216 217 218 218 295 216 216 295 293 289 293 294 293 295 294 294 1231 289 294 295 296 294 296 297 297 1233 294 294 1233 1231 218 296 295 218 217 219 219 296 218 296 298 297 219 298 296 297 298 299 297 299 242 242 1240 297 297 1240 1233 221 299 298 221 298 219 219 217 220 219 220 221 220 224 221 224 299 221 242 299 300 224 300 299 220 223 224 223 300 224 135 223 220 217 1279 220 220 1279 1277 220 1277 135 213 1281 217 217 1281 1279 1278 1277 1279 1278 1279 1280 1280 1279 1281 1276 1275 1277 1276 1277 1278 135 1277 1275 1375 1276 1278 1375 1278 1376 1376 1278 1280 1280 1281 1282 1376 1280 1377 1377 1280 1282 1368 1375 1376 1368 1376 1377 1374 1276 1375 1374 1375 1368 1274 1275 1276 1374 1274 1276 1373 1274 1374 1368 1373 1374 1272 1273 1274 1274 1273 1275 1373 1272 1274 1270 1271 1272 1272 1271 1273 1372 1270 1272 1372 1272 1373 133 1275 1273 133 1273 127 127 1273 1271 1270 1269 1271 127 1271 137 137 1271 1269 1268 1267 1269 1268 1269 1270 137 1269 124 124 1269 1267 124 123 137 123 138 137 137 138 139 137 139 127 122 123 124 122 124 141 141 124 142 124 1267 142 804 138 123 804 123 805 805 123 122 754 139 138 754 138 804 756 754 804 756 804 757 757 804 805 805 122 806 757 805 761 761 805 806 806 122 141 806 141 807 761 806 763 763 806 807 807 141 143 807 143 808 763 807 801 801 807 808 763 764 761 801 341 763 763 341 340 763 340 764 800 346 801 801 346 341 801 808 800 339 340 341 339 341 345 345 341 346 345 346 342 342 346 347 800 347 346 799 347 800 800 808 809 800 809 799 342 347 343 799 343 347 798 343 799 799 809 810 799 810 798 808 145 809 809 145 146 809 146 810 810 146 148 810 148 811 798 810 811 145 144 146 146 144 147 146 147 148 143 144 145 808 143 145 143 142 144 142 1265 144 144 1265 1263 144 1263 147 141 142 143 142 1267 1265 1264 1263 1265 1264 1265 1266 1266 1265 1267 1262 1261 1263 1262 1263 1264 147 1263 1261 1368 1262 1264 1368 1264 1369 1369 1264 1266 1266 1267 1268 1369 1266 1370 1370 1266 1268 1369 1373 1368 1369 1370 1373 1366 1262 1368 1377 1378 1368 1368 1378 1366 1366 1260 1262 1366 1378 1379 1366 1379 1380 1377 1282 1378 1378 1282 1284 1378 1284 1379 1379 1284 1286 1379 1286 1380 1380 1286 1288 1284 1285 1286 1286 1285 1287 1286 1287 1288 1282 1283 1284 1284 1283 1285 1282 1281 1283 213 1283 1281 205 1287 1285 1288 1287 1289 200 1287 205 200 1289 1287 205 206 200 205 210 206 200 206 207 281 207 206 281 206 285 285 206 210 200 207 198 283 198 207 283 207 281 281 282 283 281 285 282 283 282 278 283 278 284 284 198 283 198 199 200 284 199 198 284 278 277 277 199 284 277 278 279 199 277 279 200 199 201 279 201 199 333 203 279 279 203 201 200 201 202 202 201 203 202 1289 200 202 203 196 196 203 204 333 204 203 332 204 333 196 204 197 332 197 204 331 197 332 1260 1261 1262 1260 1258 1261 147 1261 150 150 1261 1258 150 1258 152 149 147 150 149 150 151 152 156 150 150 156 157 150 157 151 148 147 149 811 148 149 811 149 812 812 149 151 812 151 813 813 151 157 813 157 814 814 157 156 796 812 813 796 813 795 795 813 814 797 811 812 797 812 796 798 811 797 796 348 797 797 348 344 797 344 798 795 349 796 796 349 348 794 350 795 795 350 349 795 814 794 335 348 349 335 349 350 344 348 335 335 343 344 798 344 343 335 342 343 334 342 335 334 1025 342 342 1025 1026 342 1026 345 334 335 336 336 1024 334 334 1024 1025 1024 1022 1025 1025 1022 1023 1025 1023 1026 1026 1023 1010 1026 1010 1011 345 1026 1011 345 1011 339 1010 992 1011 1011 992 340 1011 340 339 1009 994 1010 1010 994 992 1023 1009 1010 1022 1020 1023 1023 1020 1009 479 996 1009 1009 996 994 479 1009 575 575 1009 1020 993 992 994 993 994 995 995 994 996 995 996 477 477 996 478 479 478 996 999 993 995 999 995 476 476 995 477 991 992 993 998 991 993 998 993 999 1001 998 999 1001 999 475 475 999 476 474 475 476 476 477 474 474 477 478 474 478 479 474 479 574 574 479 575 574 575 576 705 474 574 705 574 707 707 574 576 576 575 577 575 1020 577 576 577 578 707 576 711 576 578 711 706 705 707 706 707 709 709 707 711 711 578 580 711 580 712 709 711 714 714 711 712 578 577 579 578 579 580 577 1020 579 580 579 581 1019 581 579 1019 579 1020 580 581 582 580 582 712 582 581 583 583 581 1019 1018 583 1019 1021 1018 1019 1021 1019 1022 1022 1019 1020 582 583 584 584 583 585 1018 585 583 712 582 584 584 585 586 712 584 713 586 713 584 586 585 587 587 585 1018 586 587 588 588 713 586 588 702 713 715 712 713 715 713 716 716 713 702 714 712 715 717 714 715 717 715 718 718 715 716 716 702 703 718 716 719 719 716 703 381 717 718 381 718 383 383 718 719 710 714 717 379 710 717 379 717 381 710 709 714 377 708 710 708 709 710 377 710 379 378 377 379 378 379 380 380 379 381 376 377 378 377 376 708 380 957 378 378 957 958 378 958 376 380 381 382 382 956 380 380 956 957 956 943 957 957 943 944 957 944 958 944 977 958 958 977 978 958 978 376 943 273 944 273 272 944 944 272 977 942 275 943 943 275 273 956 942 943 226 272 273 226 273 274 274 273 275 225 272 226 272 225 977 225 226 227 225 227 976 977 225 976 227 226 228 227 228 229 976 227 229 975 972 976 976 229 975 977 976 978 978 976 972 229 228 230 975 229 230 968 973 975 975 973 972 975 230 968 228 235 230 968 230 235 968 234 969 969 974 968 968 974 973 968 235 234 731 972 973 731 973 732 732 973 974 732 974 725 725 974 967 969 967 974 969 234 232 969 232 970 970 967 969 966 727 967 725 967 726 726 967 727 970 966 967 725 726 706 706 732 725 706 731 732 708 706 709 706 726 727 706 727 705 708 731 706 705 727 728 966 728 727 721 722 705 705 722 723 705 723 474 705 728 721 965 721 728 965 728 966 961 722 721 961 721 965 723 722 961 474 723 724 723 961 724 724 961 962 963 962 961 963 961 964 964 961 965 964 965 971 971 965 966 971 966 970 970 231 971 971 231 240 971 240 964 237 963 964 964 240 239 964 239 237 233 239 240 233 240 231 231 232 233 970 232 231 233 232 234 233 234 228 228 234 235 226 1238 228 228 1238 1232 228 1232 233 274 1239 226 226 1239 1238 1232 1238 1231 1231 1238 1239 1232 1231 1233 1233 1242 1232 233 1232 1242 1231 1239 1223 274 1223 1239 274 275 267 267 1223 274 1221 1222 1223 267 1221 1223 266 267 268 267 275 276 267 276 268 266 1221 267 942 276 275 941 268 276 941 276 942 268 269 266 940 269 268 940 268 941 954 940 941 954 941 955 955 941 942 955 942 956 384 954 955 384 955 382 382 955 956 953 940 954 385 953 954 385 954 384 939 269 940 953 939 940 952 939 953 365 952 953 365 953 385 384 366 385 385 366 365 382 383 384 384 383 366 382 381 383 383 719 366 719 703 704 366 719 704 702 695 703 703 695 681 703 681 704 704 681 87 704 87 387 366 704 387 87 681 682 694 682 681 694 681 695 700 694 695 700 695 701 702 701 695 693 682 694 699 693 694 699 694 700 566 699 700 566 700 564 564 700 701 564 701 557 555 557 701 555 701 702 557 563 564 564 563 565 564 565 566 557 562 563 563 562 1033 1046 565 563 563 1033 1046 566 565 567 567 565 1047 1047 565 1046 1046 1033 1035 1046 1035 1045 1047 1046 1048 1048 1046 1045 1033 562 1034 1033 1034 1035 1035 1034 1037 1045 1035 1037 1037 1034 1038 1043 1038 1034 1043 1034 558 558 1034 562 1037 1038 1039 1045 1037 1039 1039 1038 1036 1042 1036 1038 1042 1038 1043 1032 1042 1043 1032 1043 556 556 1043 558 557 556 558 558 562 557 555 556 557 573 556 555 573 1032 556 1031 1030 1032 1031 1032 573 1030 1042 1032 1041 1036 1042 1030 1041 1042 1029 1028 1030 1029 1030 1031 1028 1041 1030 1012 1029 1031 1012 1031 590 590 1031 573 555 590 573 555 589 590 1012 590 589 1013 1012 1014 1012 589 1014 1013 1029 1012 1027 1028 1029 1013 1027 1029 1015 1013 1016 1013 1014 1016 1015 1027 1013 1014 589 587 1014 587 1018 1016 1014 1018 588 587 589 588 589 555 555 702 588 1016 1018 1021 1015 1016 1017 1017 1016 1021 1017 1021 1024 1024 1021 1022 338 1015 1017 338 1017 336 336 1017 1024 336 337 338 338 337 906 338 906 1015 336 335 337 906 337 904 335 904 337 906 904 907 906 907 1027 1015 906 1027 907 904 908 1027 907 1028 907 908 1028 911 912 908 908 904 911 908 912 1041 1028 908 1041 909 910 911 911 910 912 911 904 905 911 905 909 912 910 1036 1041 912 1036 1036 910 909 909 905 884 909 884 889 1040 1036 909 1040 909 889 1039 1036 1040 889 888 1040 1040 888 1045 1040 1045 1039 884 888 889 884 887 888 887 1045 888 1048 1045 887 886 887 884 886 1048 887 1044 1047 1048 1044 1048 886 886 860 1044 1049 1047 1044 860 859 1044 1044 859 1053 1044 1053 1049 1049 567 1047 569 567 1049 1049 1053 1051 1049 1051 569 859 861 1053 1053 861 1050 1053 1050 1051 859 860 416 859 416 861 886 416 860 416 417 418 418 821 416 416 821 822 416 822 861 886 417 416 884 885 886 885 417 886 418 417 419 858 419 417 885 858 417 418 419 420 418 420 821 420 419 421 421 419 851 851 419 852 858 852 419 857 852 858 885 905 858 905 857 858 884 905 885 904 903 905 903 856 905 905 856 857 856 852 857 851 852 853 853 852 854 856 854 852 855 854 856 855 856 903 913 855 903 913 903 914 914 903 904 914 904 335 914 897 892 892 894 914 914 894 896 914 896 913 897 914 898 898 914 335 892 897 893 893 897 898 892 893 894 894 893 895 894 895 896 896 895 900 913 896 900 900 895 603 900 603 607 913 900 607 603 604 596 607 603 608 608 603 596 895 604 603 608 913 607 462 855 913 609 462 913 609 913 608 608 596 609 609 596 463 463 462 609 595 463 596 596 604 605 596 605 595 895 605 604 595 605 606 606 605 895 893 891 895 895 891 902 895 902 606 595 606 602 606 902 901 606 901 602 901 902 890 890 902 891 882 901 878 878 901 890 602 901 882 451 595 602 451 602 449 602 882 449 449 882 871 871 882 878 449 450 451 871 872 449 872 873 449 449 873 874 449 874 450 451 450 452 452 595 451 452 450 454 454 597 452 452 597 595 465 595 597 465 597 466 466 597 467 467 597 598 454 598 597 464 465 462 462 465 466 464 595 465 462 466 467 467 468 462 467 598 468 462 468 469 468 598 469 469 598 599 23 599 598 23 598 454 462 469 460 460 469 470 469 599 470 460 461 462 470 488 460 460 488 592 460 592 461 591 488 470 470 599 591 591 490 488 591 599 601 591 601 490 489 488 490 610 490 601 489 490 613 613 490 610 599 600 601 610 601 611 611 601 600 613 610 611 611 600 612 611 612 641 611 641 613 600 599 23 612 600 23 612 23 17 641 612 17 17 19 641 641 19 26 641 26 642 613 641 642 17 18 19 22 18 17 22 17 23 19 18 20 20 26 19 20 25 26 642 26 25 642 25 643 613 642 614 614 642 643 24 25 20 24 29 25 643 25 29 643 29 644 614 643 615 615 643 644 487 613 614 487 614 494 494 614 615 489 613 487 487 488 489 494 495 487 487 495 496 487 496 488 493 492 494 494 492 495 494 615 493 495 492 831 496 495 849 849 495 831 488 496 592 849 853 496 496 853 592 849 831 850 850 851 849 849 851 853 853 854 592 592 854 461 461 854 462 462 854 855 462 463 464 464 463 595 850 421 851 420 421 422 422 421 423 423 421 850 420 422 827 821 420 827 422 423 424 827 422 828 422 424 828 827 828 829 821 827 824 824 827 829 822 821 823 823 821 824 823 824 825 825 824 826 826 824 440 824 829 440 861 822 823 861 823 862 862 823 825 826 865 825 825 865 866 825 866 862 861 862 1050 1055 862 866 1055 1050 862 865 1058 866 866 1058 1059 866 1059 1055 826 864 865 864 1057 865 865 1057 1058 1057 434 1058 1058 434 433 1058 433 1059 433 1052 1059 1059 1052 1054 1059 1054 1055 1055 1054 1050 1051 1050 1054 1051 1054 1052 1051 1052 570 570 1052 559 433 559 1052 433 434 435 435 560 433 433 560 559 559 560 561 571 570 559 571 559 572 572 559 561 560 435 676 676 684 560 560 684 561 561 684 696 561 696 572 572 696 697 572 697 571 568 570 571 571 697 698 571 698 568 696 691 697 697 691 692 697 692 698 684 690 696 696 690 691 690 687 691 691 687 688 691 688 692 692 688 689 692 689 693 698 692 693 698 693 699 568 698 699 693 689 682 688 91 689 91 90 689 689 90 89 689 89 682 682 89 88 682 88 87 85 88 89 85 89 86 86 89 90 86 90 79 79 90 91 79 91 80 688 80 91 79 80 76 76 1316 79 79 1316 1314 79 1314 86 76 80 81 81 80 688 687 81 688 76 81 77 687 77 81 76 77 73 73 1318 76 76 1318 1316 73 77 78 78 77 687 686 74 687 687 74 78 690 686 687 73 78 74 73 74 71 71 1320 73 73 1320 1318 71 74 75 686 75 74 71 75 72 72 75 686 70 65 71 70 71 72 65 1322 71 71 1322 1320 1319 1318 1320 1319 1320 1321 1321 1320 1322 1321 1322 1323 1323 1322 1324 65 1324 1322 1323 101 1321 1321 101 100 1321 100 1319 1323 1324 1325 1325 102 1323 1323 102 101 1325 1324 1326 63 1326 1324 63 1324 65 1325 1326 1327 1327 103 1325 1325 103 102 93 101 102 93 102 103 100 101 93 93 118 100 1319 100 118 93 117 118 1319 118 1317 1317 118 117 1317 1318 1319 1315 1316 1317 1317 1316 1318 1317 117 1315 112 117 93 1315 117 112 1313 1314 1315 1315 1314 1316 1315 112 1313 93 111 112 1313 112 111 1311 1312 1313 1313 1312 1314 1313 111 1311 86 1314 1312 1311 1365 1312 86 1312 84 84 1312 1365 84 85 86 3 83 84 84 83 85 84 1365 3 1311 1364 1365 3 1365 1364 2 82 3 3 82 83 2 1076 82 2 1 1076 82 1076 1075 82 1075 83 1074 1075 1076 83 1075 1093 1075 1144 1093 1075 1074 1144 1076 1096 1074 1144 1074 1096 1093 1144 1145 1144 1096 1147 1149 1145 1144 1149 1144 1150 1150 1144 1147 83 1093 1092 1093 1145 1092 1092 1145 1146 1148 1146 1145 1148 1145 1149 372 1148 1149 372 1149 371 371 1149 1150 85 1146 1148 85 1148 372 1092 1146 1077 1077 1146 85 1077 83 1092 1077 85 83 87 88 85 372 87 85 371 87 372 389 87 371 371 1150 389 388 387 87 388 87 389 389 1150 1151 389 1151 388 386 387 388 388 1151 1152 388 1152 386 386 366 387 361 366 386 386 1152 1153 386 1153 361 1151 1143 1152 1152 1143 1142 1152 1142 1153 1150 1147 1151 1151 1147 1143 1099 1142 1143 1147 1094 1143 1143 1094 1101 1143 1101 1099 1142 1099 1141 1153 1142 1141 1153 1141 1140 361 1153 1140 1141 1099 1098 1097 1098 1099 1101 1097 1099 1094 1097 1101 1094 1100 1097 1076 1 1100 1076 1100 1094 1094 1095 1076 1076 1095 1096 1096 1095 1147 1147 1095 1094 367 362 1140 361 1140 362 367 368 362 367 925 926 367 926 368 361 362 363 362 368 369 362 369 363 368 926 945 368 945 369 369 945 946 369 946 363 363 373 361 363 946 947 363 947 373 945 932 946 946 932 933 946 933 947 926 931 945 945 931 932 931 257 932 932 257 256 932 256 933 933 256 265 933 265 934 947 933 934 947 934 948 373 947 948 934 265 264 934 264 935 948 934 935 255 264 265 255 265 256 254 255 256 256 257 254 260 264 255 254 1244 255 255 1244 1243 255 1243 260 260 263 264 935 264 263 260 261 262 262 263 260 260 1243 1235 260 1235 261 1235 1243 1237 1237 1243 1244 1237 1244 1245 254 1245 1244 1236 1235 1237 1245 1246 1237 1237 1246 1247 1237 1247 1248 316 1236 1237 246 1246 1245 246 1245 254 249 1247 1246 249 1246 246 1248 1247 1249 303 1249 1247 303 1247 249 1248 1249 1250 310 1248 1250 305 1250 1249 305 1249 303 249 302 303 306 305 303 306 303 307 307 303 302 249 301 302 168 302 301 302 168 307 307 168 170 307 170 306 304 305 306 306 170 171 306 171 304 304 308 305 304 171 173 304 173 308 171 172 173 172 176 173 308 173 176 305 308 309 175 309 308 308 176 175 172 175 176 309 175 311 305 309 310 309 311 310 310 1250 305 301 119 168 252 301 249 252 120 301 301 120 119 249 251 252 252 251 253 246 248 249 248 250 249 249 250 251 246 247 248 254 258 246 246 258 259 246 259 247 924 248 247 924 247 919 919 247 259 919 259 930 930 259 258 254 257 258 930 258 931 931 258 257 929 919 930 929 930 926 926 930 931 926 928 929 920 919 929 1137 920 929 1137 929 1131 1131 929 928 925 927 926 926 927 928 1131 928 927 1131 927 1132 1132 1135 1131 1131 1135 1136 1131 1136 1137 1132 927 925 921 920 1137 1138 921 1137 1138 1137 1139 1139 1137 1136 394 1139 1136 394 1136 395 395 1136 1135 395 1135 401 392 394 395 395 401 392 393 394 392 393 1139 394 1124 1138 1139 1124 1139 1127 1127 1139 393 393 392 1064 1064 1127 393 1064 392 1063 1064 1063 1065 1065 1126 1064 1064 1126 1127 1126 1124 1127 1123 916 1126 1126 916 1124 1065 1123 1126 1065 1063 1066 1066 1123 1065 251 1066 1063 251 1063 1060 1067 1066 251 1067 1123 1066 1067 1122 1123 1122 917 1123 1123 917 916 251 250 1067 250 1122 1067 1060 253 251 250 918 1122 1122 918 917 916 917 248 248 917 918 248 918 250 248 915 916 915 248 924 916 915 1124 1124 915 924 919 923 924 1124 924 1125 1125 924 923 1125 1138 1124 923 922 1125 1125 922 1138 919 922 923 919 920 921 921 922 919 922 921 1138 1222 1235 1236 318 1222 1236 318 1236 316 1221 1234 1222 1222 1234 1235 261 1235 1234 261 1234 266 266 1234 1221 266 270 261 261 270 271 261 271 262 266 269 270 938 271 270 938 270 939 939 270 269 937 262 271 937 271 938 936 263 262 936 262 937 950 936 937 950 937 951 951 937 938 951 938 952 952 938 939 370 950 951 370 951 364 364 951 952 949 936 950 375 949 950 375 950 370 364 366 370 375 370 361 361 370 366 364 365 366 364 952 365 361 373 374 361 374 375 374 949 375 373 948 374 374 948 949 948 935 949 949 935 936 935 263 936 1363 1362 1364 1363 1364 1311 1361 1362 1363 1311 110 1363 1363 110 99 1363 99 1361 1361 1360 1362 4 1362 1360 1359 1360 1361 1361 99 98 1361 98 1359 98 99 93 99 110 93 93 110 111 1311 111 110 92 93 94 98 93 97 97 93 106 103 113 93 93 113 114 93 114 94 1345 106 93 1345 93 1343 1343 93 92 97 106 95 1347 95 106 1347 106 1345 1343 1344 1345 1345 1344 1346 1345 1346 1347 1341 1342 1343 1343 1342 1344 1343 92 1341 30 1346 1344 30 1344 33 33 1344 1342 1347 1346 1348 27 1348 1346 27 1346 30 30 31 27 33 34 30 30 34 35 30 35 31 27 28 24 27 31 32 27 32 28 24 1348 27 646 32 31 646 31 647 647 31 35 647 35 648 648 35 34 618 646 647 618 647 619 619 647 648 645 32 646 617 645 646 617 646 618 645 28 32 644 28 645 616 644 645 616 645 617 498 616 617 498 617 503 503 617 504 504 617 618 497 615 616 497 616 498 615 644 616 644 29 28 24 28 29 20 1350 24 24 1350 1348 18 1352 20 20 1352 1350 1349 1348 1350 1349 1350 1351 1351 1350 1352 1347 1348 1349 1351 96 1349 1349 96 95 1349 95 1347 1351 1352 1353 1353 107 1351 1351 107 96 1353 1352 1354 18 1354 1352 1353 1354 1355 1355 108 1353 1353 108 107 96 107 97 97 107 108 95 96 97 97 108 109 1359 98 97 1359 97 1357 1357 97 109 1355 109 108 1357 109 1355 1355 1354 1356 1355 1356 1357 1357 1356 1358 1357 1358 1359 1359 1358 1360 5 1360 1358 5 1358 14 14 1358 1356 14 1356 12 12 1356 1354 12 13 14 14 13 15 14 15 5 5 15 16 1086 16 15 1086 15 13 5 16 6 4 5 6 4 1360 5 12 11 13 11 1088 13 1088 1089 13 13 1089 1090 13 1090 1086 10 11 12 10 1088 11 21 1089 1088 21 1088 10 1106 1090 1089 1106 1089 21 1107 1108 1106 1106 1108 1109 1109 1110 1106 1106 1110 1111 1106 1111 1090 21 448 1106 1106 448 447 1106 447 1107 1108 1107 1157 1157 1107 447 1108 1157 1109 1109 1157 1161 1109 1161 1110 1110 1161 1162 1110 1162 1111 1157 458 1161 1161 458 453 1161 453 1162 1157 447 446 446 459 1157 1157 459 458 446 447 448 448 454 446 454 459 446 454 458 459 453 458 454 453 454 455 453 455 1159 453 1159 1162 455 454 456 448 23 454 454 450 457 454 457 456 1159 455 456 1159 456 1160 1162 1159 1160 1160 456 457 1160 457 450 450 874 1160 1160 874 873 1160 873 1163 1162 1160 1173 1173 1160 1163 1111 1162 1173 1173 1163 1174 1111 1173 1156 1156 1173 1174 1163 873 872 1163 872 1164 1174 1163 1164 1174 1164 1175 1156 1174 1154 1154 1174 1175 1164 872 871 1164 871 1165 1175 1164 1165 1175 1165 1176 1154 1175 1155 1155 1175 1176 1121 1154 1155 1154 1121 1156 1158 1116 1155 1155 1116 1115 1155 1115 1121 1155 1176 1158 1176 1165 1167 1176 1167 1177 1158 1176 1177 1165 881 1167 1167 881 880 1167 880 1168 1177 1167 1168 1177 1168 1178 1158 1177 1166 1166 1177 1178 1168 880 879 1168 879 1169 1178 1168 1169 878 879 880 878 880 881 883 878 881 1165 883 881 877 876 878 876 879 878 871 878 883 878 890 877 1169 879 876 869 875 876 869 876 877 1169 876 1170 876 875 1170 877 890 869 776 869 890 776 890 777 890 891 777 774 775 776 774 776 768 768 776 777 775 869 776 768 777 766 777 891 766 891 767 766 893 767 891 766 767 768 768 767 769 769 767 893 893 898 769 768 769 770 769 771 770 769 898 899 769 899 771 898 335 899 772 771 899 899 335 353 899 353 772 770 771 772 770 772 353 335 352 353 353 352 770 350 351 335 335 351 352 770 352 351 770 351 794 794 351 350 794 814 815 794 815 770 814 156 815 815 156 155 815 155 816 770 815 816 152 155 156 154 155 152 816 155 154 816 154 817 770 816 768 768 816 817 152 153 154 153 163 154 817 154 163 768 817 774 358 773 774 773 775 774 358 774 359 358 359 355 355 870 358 358 870 773 870 775 773 870 869 775 867 869 870 1190 1172 870 870 1172 867 355 1190 870 1193 1190 355 1189 1182 1190 1190 1182 1172 1193 1189 1190 1171 867 1172 1181 1171 1172 1181 1172 1182 867 868 869 1171 868 867 868 875 869 1170 875 868 1170 868 1171 1180 1170 1171 1180 1171 1181 1185 1180 1181 1185 1181 1186 1186 1181 1182 1179 1170 1180 1184 1179 1180 1184 1180 1185 1179 1169 1170 1178 1169 1179 1183 1178 1179 1183 1179 1184 1082 1183 1184 1082 1184 1083 1083 1184 1185 1166 1178 1183 1081 1166 1183 1081 1183 1082 1081 1082 1080 1080 1082 1083 1080 1083 1078 1083 1185 1078 1078 1079 1080 1080 1086 1085 1080 1085 1081 1085 1166 1081 1084 1158 1166 1084 1166 1085 1084 1085 1086 1084 1086 1087 1086 1090 1091 1086 1091 1087 1117 1084 1118 1118 1084 1087 1117 1158 1084 1117 1119 1158 1119 1120 1158 1158 1120 1116 1117 1118 1119 1119 1118 1114 1087 1114 1118 1091 1114 1087 1090 1115 1091 1091 1115 1114 1114 1115 1116 1119 1114 1120 1120 1114 1116 1090 1121 1115 1113 1121 1090 1156 1121 1113 1090 1112 1113 1156 1113 1112 1111 1156 1112 1090 1111 1112 1078 1186 1079 1079 1186 1187 1078 1185 1186 1186 1182 1187 1189 1187 1182 871 883 1165 443 444 23 23 444 445 23 445 22 443 23 448 444 443 21 21 443 448 21 445 444 22 445 21 21 18 22 10 12 21 21 12 18 12 1354 18 493 615 497 491 492 493 493 497 491 491 497 498 491 498 499 491 499 847 492 491 831 831 491 847 498 503 499 499 503 504 499 504 502 847 499 502 502 504 505 504 618 505 500 501 502 502 505 500 847 502 501 505 618 619 505 619 500 500 506 501 500 619 506 501 506 507 501 507 508 501 508 832 832 847 501 506 619 620 506 620 507 619 648 620 507 620 621 620 648 649 620 649 621 508 507 509 507 621 509 508 509 510 508 510 832 509 511 510 509 621 511 511 621 622 621 649 650 621 650 622 648 34 649 649 34 38 649 38 650 650 38 37 650 37 651 622 650 651 511 622 512 512 622 623 622 651 623 510 511 512 510 512 513 512 517 513 512 623 517 517 623 518 518 623 624 623 651 652 623 652 624 651 37 41 651 41 652 652 41 40 652 40 653 624 652 653 518 624 519 519 624 625 624 653 625 653 40 44 653 44 654 625 653 654 39 40 36 36 40 41 39 44 40 36 41 37 36 37 33 33 1342 36 36 1342 1340 36 1340 39 33 37 38 33 38 34 42 43 39 39 43 44 39 1340 1338 39 1338 42 1339 1338 1340 1339 1340 1341 1341 1340 1342 1337 1336 1338 1337 1338 1339 42 1338 1336 1339 115 1337 1341 116 1339 1339 116 115 1341 92 116 94 115 116 94 116 92 105 115 94 1337 115 105 1335 1336 1337 1337 105 1335 94 104 105 1335 105 104 1333 104 94 1333 94 1331 1331 94 114 1335 104 1333 1333 1334 1335 1335 1334 1336 1331 1332 1333 1333 1332 1334 1329 1330 1331 1331 1330 1332 1331 114 1329 1329 114 113 1327 1328 1329 1329 1328 1330 1329 113 1327 51 1332 1330 51 1330 54 54 1330 1328 48 1334 1332 48 1332 51 51 52 48 54 55 51 51 55 56 51 56 52 48 49 45 48 52 53 48 53 49 45 1334 48 45 49 50 658 50 49 658 49 659 659 49 53 659 53 660 660 53 52 630 658 659 630 659 631 631 659 660 657 50 658 629 657 658 629 658 630 45 50 46 657 46 50 656 46 657 628 656 657 628 657 629 526 628 629 526 629 531 531 629 630 523 627 628 523 628 524 524 628 526 627 656 628 525 524 526 525 526 527 531 527 526 530 527 531 531 630 530 530 529 527 525 527 834 527 529 834 522 524 525 522 525 833 833 525 834 522 523 524 514 521 522 521 523 522 514 522 833 833 834 842 842 843 833 833 843 844 833 844 514 842 834 841 842 841 428 428 427 842 842 427 843 845 844 843 845 843 426 426 843 427 425 426 427 427 428 425 425 428 429 428 841 429 425 429 430 426 425 845 845 425 846 430 846 425 832 844 845 845 846 832 832 846 847 848 847 846 848 846 430 430 429 431 430 431 423 423 848 430 841 839 429 429 839 431 423 431 432 432 431 838 838 431 839 423 432 424 850 848 423 838 836 432 432 836 424 835 837 838 838 837 836 838 839 835 835 839 840 841 840 839 834 840 841 835 840 539 529 534 840 840 534 536 840 536 539 834 529 840 536 538 539 539 538 540 539 540 541 539 541 835 534 535 536 535 537 536 536 537 538 529 533 534 534 533 535 533 632 535 535 632 633 535 633 537 537 633 634 537 634 538 538 634 540 540 634 635 633 662 634 634 662 663 634 663 635 632 661 633 633 661 662 661 56 662 662 56 55 662 55 663 663 55 61 663 61 664 635 663 664 54 61 55 54 60 61 664 61 60 664 60 665 635 664 636 636 664 665 59 58 60 59 60 54 665 60 58 54 1328 59 1327 1326 1328 59 1328 1326 1327 113 103 59 1326 63 62 63 64 64 63 65 62 67 63 63 67 68 63 68 59 670 67 62 62 671 670 62 64 671 68 67 670 59 68 69 69 68 668 668 68 670 57 58 59 59 69 57 57 69 667 667 69 668 667 668 669 668 670 669 666 57 667 638 666 667 638 667 639 639 667 669 666 58 57 665 58 666 637 665 666 637 666 638 546 637 638 546 638 551 551 638 552 552 638 639 552 639 553 553 639 640 639 669 640 547 551 552 547 552 550 550 552 553 546 551 547 544 546 547 544 547 837 837 547 550 548 549 550 550 553 548 837 550 549 548 553 554 553 640 554 548 554 593 593 439 548 548 439 594 548 594 549 594 830 549 830 837 549 830 836 837 835 544 837 829 828 830 829 830 594 828 836 830 439 440 594 440 829 594 439 435 440 435 442 440 826 440 442 435 441 442 826 442 863 442 1056 863 442 441 1056 863 864 826 863 1056 1057 863 1057 864 1056 441 436 1056 436 1057 436 441 435 435 434 436 1057 436 434 439 438 435 435 438 672 676 435 672 437 438 439 593 437 439 672 438 673 437 673 438 671 437 593 671 673 437 670 671 593 670 593 640 640 593 554 671 64 673 64 65 66 673 64 66 66 65 70 66 70 673 673 70 675 70 677 675 677 70 72 673 675 674 675 677 678 675 678 674 678 677 685 685 677 72 685 72 686 678 685 683 683 685 686 674 678 679 683 679 678 672 673 674 674 679 672 672 679 680 680 679 683 683 686 690 680 683 684 684 683 690 672 680 676 684 676 680 669 670 640 828 424 836 541 543 544 543 545 544 544 545 546 541 544 835 540 542 541 541 542 543 542 636 543 543 636 545 545 636 637 545 637 546 542 635 636 636 665 637 540 635 542 661 52 56 660 52 661 632 660 661 631 660 632 532 631 632 532 632 533 528 630 631 528 631 532 528 532 529 529 532 533 528 529 530 530 630 528 831 847 848 850 831 848 832 510 844 510 513 844 844 513 515 844 515 514 513 517 518 513 518 515 514 515 516 515 518 519 515 519 516 516 520 514 514 520 521 519 625 516 516 625 520 520 625 626 520 626 521 521 626 627 521 627 523 625 654 626 626 654 655 626 655 627 627 655 656 654 43 655 655 43 47 655 47 656 654 44 43 42 47 43 42 46 47 656 47 46 45 46 42 42 1336 45 45 1336 1334 568 699 566 566 567 568 567 569 568 568 569 570 569 1051 570 1233 1241 1242 233 1242 238 238 1242 1241 1240 1241 1233 238 1241 242 242 1241 1240 241 238 242 241 242 243 243 242 244 242 300 244 236 238 241 243 412 241 241 412 959 241 959 236 243 244 245 412 243 245 222 245 244 222 244 223 223 244 300 134 222 135 135 222 223 134 245 222 133 130 134 133 134 135 245 134 130 135 1275 133 131 132 133 133 132 128 128 130 133 127 126 133 133 126 136 133 136 131 132 131 742 742 131 136 737 128 132 737 132 742 128 129 130 736 129 128 736 128 737 735 736 737 742 743 737 737 743 744 737 744 735 735 987 736 736 987 980 736 980 129 130 129 980 481 130 980 481 980 480 987 480 980 986 482 987 987 482 480 735 986 987 744 986 735 744 743 986 986 743 741 986 741 985 985 483 986 986 483 482 480 482 413 413 482 483 480 413 481 481 413 245 245 130 481 413 414 245 245 414 415 245 415 412 414 413 720 415 414 960 960 414 720 959 412 415 415 960 959 960 720 724 724 962 960 959 960 962 720 413 474 474 724 720 413 473 474 474 473 475 413 472 473 1003 1001 473 473 1001 475 472 1003 473 471 472 413 1005 1003 472 471 1005 472 1002 1000 1003 1003 1000 1001 1005 1002 1003 1000 998 1001 990 997 1000 1000 997 998 1002 990 1000 989 990 1002 1004 989 1002 1004 1002 1005 1008 1004 1005 1008 1005 471 988 989 1004 1007 988 1004 1007 1004 1008 981 1007 1008 981 1008 486 486 1008 471 1006 988 1007 983 1006 1007 983 1007 981 981 486 485 984 983 981 981 485 984 413 485 486 413 486 471 484 485 413 984 485 484 413 483 484 984 484 985 985 484 483 748 984 985 748 985 738 985 741 739 985 739 738 738 740 748 748 740 734 748 734 747 747 984 748 738 739 740 740 739 741 740 741 742 742 741 743 742 136 740 740 136 126 740 126 734 125 126 127 734 126 125 127 140 125 734 125 140 127 139 140 140 733 734 733 140 139 733 139 754 747 734 733 747 733 745 733 754 745 752 753 754 754 753 755 745 754 755 752 754 756 745 746 747 745 755 746 755 753 1006 746 755 982 982 755 1006 753 752 988 1006 753 988 752 756 988 756 757 758 756 758 989 988 756 989 758 757 759 759 757 760 760 757 761 758 759 989 989 759 990 759 760 990 760 761 762 990 760 997 997 760 762 761 764 765 761 765 762 997 762 765 765 764 997 997 764 991 997 991 998 764 340 991 991 340 992 982 1006 983 982 983 984 746 982 747 747 982 984 959 962 963 236 959 963 236 963 237 236 237 238 238 237 239 238 239 233 708 730 731 730 972 731 708 376 729 729 730 708 729 972 730 978 972 729 376 978 729 1373 1370 1371 1373 1371 1372 1370 1268 1371 1371 1268 1270 1371 1270 1372 1396 1397 1398 1398 1402 1396 1397 1396 1442 1442 1396 1402 1398 1397 1399 1399 1397 1442 1398 1399 1400 1400 1401 1398 1398 1401 1402 1401 1444 1402 1402 1444 1442 1401 1400 1444 1399 1444 1400 1442 1444 1441 1399 1441 1444 1442 1420 1399 1418 1420 1442 1442 1441 1418 1440 1418 1441 1440 1441 1399 1418 1419 1420 1440 1419 1418 1420 1419 1421 1399 1420 1421 1422 1426 1419 1419 1426 1427 1419 1427 1421 1428 1422 1419 1428 1419 1440 1399 1428 1440 1428 1429 1423 1423 1422 1428 1399 1429 1428 1430 1431 1429 1429 1431 1432 1429 1432 1423 1430 1429 1399 1422 1423 1424 1424 1423 1399 1399 1423 1432 1399 1432 1431 1430 1435 1431 1435 1399 1431 1430 1434 1435 1434 1403 1435 1435 1403 1399 1433 1434 1430 1434 1433 1403 1430 1436 1433 1430 1399 1436 1433 1436 1437 1433 1437 1438 1403 1433 1438 1436 1399 1403 1403 1437 1436 1416 1417 1437 1437 1417 1439 1437 1439 1438 1403 1416 1437 1438 1439 1403 1403 1439 1417 1416 1412 1417 1403 1417 1412 1405 1412 1416 1405 1416 1403 1407 1411 1412 1407 1412 1405 1411 1406 1412 1412 1406 1404 1412 1404 1403 1403 1404 1405 1405 1404 1406 1405 1406 1407 1407 1406 1408 1408 1406 1411 1407 1408 1409 1411 1409 1408 1410 1411 1407 1410 1413 1411 1411 1413 1409 1407 1409 1413 1415 1407 1413 1410 1415 1413 1414 1410 1407 1410 1443 1414 1414 1415 1410 1414 1407 1415 1399 1421 1427 1427 1426 1399 1399 1426 1425 1399 1425 1424 1422 1425 1426 1424 1425 1422 1445 1446 1447 1479 1476 1445 1445 1476 1480 1482 1446 1445 1482 1445 1483 1483 1445 1480 1479 1445 1447 1447 1446 1448 1485 1479 1447 1485 1447 1448 1446 1453 1448 1448 1453 1485 1484 1479 1485 1485 1453 1486 1485 1486 1484 1446 1452 1453 1486 1453 1452 1484 1486 1472 1472 1486 1487 1486 1452 1487 1472 1468 1484 1484 1468 1479 1468 1472 1473 1487 1473 1472 1468 1467 1469 1468 1473 1467 1468 1469 1479 1469 1470 1479 1479 1470 1476 1469 1467 1470 1467 1471 1470 1475 1476 1470 1471 1463 1470 1470 1463 1477 1470 1477 1475 1475 1478 1476 1478 1456 1476 1476 1456 1480 1475 1477 1478 1477 1455 1478 1488 1455 1477 1488 1477 1462 1462 1477 1463 1478 1455 1456 1454 1451 1455 1455 1451 1456 1454 1455 1488 1487 1454 1488 1487 1488 1462 1462 1463 1464 1462 1464 1467 1467 1474 1462 1462 1474 1487 1464 1463 1465 1464 1465 1466 1464 1466 1467 1467 1466 1471 1467 1473 1474 1487 1474 1473 1450 1451 1487 1451 1454 1487 1487 1452 1449 1487 1449 1450 1449 1446 1450 1450 1446 1451 1449 1452 1446 1457 1458 1446 1446 1458 1459 1446 1459 1451 1481 1446 1482 1457 1446 1489 1489 1446 1481 1451 1459 1460 1451 1460 1456 1456 1460 1461 1461 1460 1483 1483 1460 1459 1480 1456 1461 1480 1461 1483 1483 1459 1482 1482 1459 1489 1482 1489 1481 1458 1489 1459 1457 1489 1458 1466 1463 1471 1466 1465 1463 1490 1491 1492 1492 1495 1490 1490 1604 1491 1490 2384 1604 1495 2383 1490 1490 2383 2384 1492 1494 1495 1494 2382 1495 1495 2382 2383 2382 2218 2383 2383 2218 2217 2383 2217 2384 2384 2217 2215 2384 2215 2385 1604 2384 2385 2216 2215 2217 2216 2217 2207 2207 2217 2218 2207 2218 2208 2382 2208 2218 2207 2208 2209 2207 2464 2216 2209 2463 2207 2207 2463 2464 2214 2215 2216 2216 2464 2465 2216 2465 2214 2463 2461 2464 2464 2461 2462 2464 2462 2465 2538 2460 2463 2463 2460 2461 2209 2538 2463 2460 1768 2461 2461 1768 1719 2461 1719 2462 2462 1719 2387 2465 2462 2387 2465 2387 2466 2214 2465 2466 1719 1623 2387 1623 1973 2387 2387 1973 1968 2387 1968 2388 2466 2387 2388 2466 2388 2467 2214 2466 2206 2206 2466 2467 2388 1968 1961 2388 1961 2389 2467 2388 2389 2467 2389 2468 2206 2467 2204 2204 2467 2468 2389 1961 1981 2389 1981 2390 2468 2389 2390 2468 2390 2469 2204 2468 2201 2201 2468 2469 2201 2203 2204 2204 2203 2205 2204 2205 2206 2199 2200 2201 2200 2202 2201 2201 2202 2203 2201 2469 2199 2309 2203 2310 2310 2203 2202 2309 2205 2203 2205 2212 2206 2309 2212 2205 2386 2212 2309 1606 2386 2309 1606 2309 1602 1602 2309 2310 2310 2202 2311 1602 2310 1603 1603 2310 2311 2202 2200 2311 2311 2200 2198 2311 2198 2312 1603 2311 1599 1599 2311 2312 1598 1602 1603 1598 1603 1599 1601 1602 1598 1601 1606 1602 1598 1599 1595 1601 1598 1526 1526 1598 1595 1595 1599 1600 1599 2312 1600 1595 1596 1592 1595 1600 1596 1526 1595 1592 1600 2312 2313 1600 2313 1596 1592 1596 1597 1596 2313 2314 1596 2314 1597 1592 1593 1589 1592 1597 1593 1592 1589 1526 1597 2314 2315 1597 2315 1593 2313 2193 2314 2314 2193 2192 2314 2192 2315 2192 2190 2315 2315 2190 2188 2315 2188 2316 1593 2315 2316 1589 1593 1594 1593 2316 1594 2316 2188 2187 2316 2187 2317 1594 2316 2317 2186 2187 2188 2186 2188 2189 2189 2188 2190 2189 2190 2191 2190 2192 2191 2191 2192 2193 2191 2193 2194 2194 2472 2191 2191 2472 2473 2191 2473 2189 2189 2473 2474 2189 2474 2186 2472 2394 2473 2473 2394 2395 2473 2395 2474 2471 2393 2472 2472 2393 2394 2194 2471 2472 2393 1977 2394 2394 1977 1964 2394 1964 2395 2395 1964 1963 2395 1963 2396 2474 2395 2396 1963 1964 1959 1964 1977 1959 1959 1977 1978 2393 1978 1977 2392 1978 2393 2471 2392 2393 1959 1978 1979 2392 1979 1978 2391 1979 2392 2470 2391 2392 2470 2392 2471 1979 1980 1959 2391 1980 1979 2390 1980 2391 2469 2390 2391 2469 2391 2470 2199 2469 2470 2199 2470 2196 2196 2470 2471 2196 2198 2199 2199 2198 2200 2194 2195 2196 2195 2197 2196 2196 2197 2198 2196 2471 2194 2312 2198 2197 2312 2197 2313 2197 2195 2313 2194 2193 2195 2313 2195 2193 2390 1981 1980 1959 1980 1981 1959 1981 1961 1958 1959 1960 1960 1959 1961 1941 1928 1959 1959 1928 2002 1959 2002 1963 1959 1958 6172 1941 1959 6160 6160 1959 6172 1941 1942 1928 6160 1942 1941 6159 6150 6160 6160 6150 1942 6160 6172 6159 6172 1958 6168 6172 6168 6167 6159 6172 6167 2598 6149 6159 6159 6149 6150 4974 2598 6159 6159 6167 4974 6150 6149 6151 1942 6150 6152 6150 6151 6152 6149 2600 4940 6149 4940 6151 2598 2600 6149 6151 4940 4943 6151 4943 6153 6152 6151 6153 6152 6153 6155 1942 6152 1943 1943 6152 6155 4943 4946 6153 6153 4946 4952 6153 4952 6154 6155 6153 6154 6155 6154 6156 1943 6155 1927 1927 6155 6156 1928 1942 1943 1928 1943 1927 1925 1926 1927 1927 1926 1928 1927 6156 1925 6156 6154 6140 6156 6140 6139 1925 6156 6139 1914 1901 1925 1925 1901 1926 1925 6139 1914 2398 1928 1926 2398 1926 2399 2399 1926 1901 1901 1902 1903 1914 1902 1901 2399 1901 2400 2400 1901 1903 2477 2398 2399 2477 2399 2478 2478 2399 2400 2400 1903 2401 2478 2400 2479 2479 2400 2401 1903 1902 1904 2401 1903 1904 2401 1904 2402 2479 2401 2480 2480 2401 2402 2176 2478 2479 2176 2479 2174 2174 2479 2480 2179 2477 2478 2179 2478 2176 2174 2175 2176 2175 2177 2176 2176 2177 2178 2176 2178 2179 2171 2173 2174 2174 2173 2175 2174 2480 2171 2177 2175 2321 2321 2175 2173 2320 2178 2177 2320 2177 2321 2179 2178 2180 2319 2180 2178 2319 2178 2320 1587 2319 2320 1587 2320 1588 1588 2320 2321 2321 2173 2322 1588 2321 1584 1584 2321 2322 1583 1587 1588 1583 1588 1584 1586 1587 1583 1586 1591 1587 1591 2319 1587 1589 1590 1586 1586 1590 1591 1526 1589 1586 1526 1586 1583 1590 2318 1591 1591 2318 2319 1589 1594 1590 1594 2317 1590 1590 2317 2318 2317 2183 2318 2318 2183 2182 2318 2182 2319 2187 2185 2317 2317 2185 2183 2181 2182 2183 2181 2183 2184 2184 2183 2185 2180 2182 2181 2182 2180 2319 2179 2180 2181 2184 2476 2181 2181 2476 2477 2181 2477 2179 2184 2185 2186 2186 2475 2184 2184 2475 2476 2185 2187 2186 2186 2474 2475 2474 2396 2475 2475 2396 2397 2475 2397 2476 2476 2397 2398 2476 2398 2477 2396 2002 2397 2397 2002 1928 2397 1928 2398 2396 1963 2002 1583 1584 1580 1529 1526 1583 1547 1544 1583 1583 1544 1541 1583 1541 1538 1547 1583 1550 1550 1583 1580 1538 1535 1583 1583 1535 1532 1583 1532 1529 1538 1539 1535 1541 1542 1538 1538 1542 1543 1538 1543 1539 1535 1536 1532 1535 1539 1540 1535 1540 1536 1532 1533 1529 1532 1536 1537 1532 1537 1533 1540 2353 1536 1536 2353 2354 1536 2354 1537 1539 2352 1540 1540 2352 2353 2352 2288 2353 2353 2288 2287 2353 2287 2354 2287 2285 2354 2354 2285 2283 2354 2283 2355 1537 2354 2355 1537 2355 1533 2355 2283 2282 2355 2282 2356 1533 2355 2356 2281 2282 2283 2281 2283 2284 2284 2283 2285 2284 2285 2286 2285 2287 2286 2286 2287 2288 2286 2288 2289 2289 2510 2286 2286 2510 2511 2286 2511 2284 2284 2511 2512 2284 2512 2281 2510 2432 2511 2511 2432 2433 2511 2433 2512 2509 2431 2510 2510 2431 2432 2289 2509 2510 2431 2104 2432 2432 2104 2103 2432 2103 2433 2433 2103 2101 2433 2101 2434 2512 2433 2434 2102 2101 2103 2102 2103 2104 2104 2113 2102 2431 2113 2104 2430 2113 2431 2509 2430 2431 2102 2113 2114 2430 2114 2113 2429 2114 2430 2508 2429 2430 2508 2430 2509 2102 2114 2110 2110 2114 2115 2429 2115 2114 2428 2115 2429 2507 2428 2429 2507 2429 2508 2294 2507 2508 2294 2508 2291 2291 2508 2509 2506 2428 2507 2296 2506 2507 2296 2507 2294 2291 2293 2294 2294 2293 2295 2294 2295 2296 2295 2297 2296 2296 2297 2298 2296 2298 2299 2299 2506 2296 2297 2295 2350 2350 2295 2293 2291 2292 2293 2350 2293 2351 2351 2293 2292 2349 2297 2350 1542 2349 2350 1542 2350 1543 1543 2350 2351 2349 2298 2297 2348 2298 2349 1546 2348 2349 1546 2349 1542 1541 1546 1542 1541 1545 1546 1545 2348 1546 2347 2302 2348 2302 2300 2348 2348 2300 2298 1545 2347 2348 1544 1545 1541 1544 1549 1545 1549 2347 1545 2346 2303 2347 2347 2303 2302 1549 2346 2347 2300 2302 2301 2301 2302 2303 2299 2298 2300 2299 2300 2301 2301 2303 2304 2304 2504 2301 2301 2504 2505 2301 2505 2299 2304 2303 2305 2346 2305 2303 2304 2305 2306 2306 2503 2304 2304 2503 2504 2503 2425 2504 2504 2425 2426 2504 2426 2505 2505 2426 2427 2505 2427 2506 2299 2505 2506 2425 2106 2426 2426 2106 2112 2426 2112 2427 2424 2105 2425 2425 2105 2106 2503 2424 2425 2105 2096 2106 2106 2096 2107 2107 2112 2106 2107 2111 2112 2427 2112 2111 2110 2111 2107 5260 2110 2107 2107 2096 5260 2110 2115 2111 2427 2111 2428 2428 2111 2115 2110 5250 5252 2110 5252 2102 5260 5250 2110 5259 5250 5260 5260 2096 5276 5260 5276 5259 5250 5249 5251 5250 5251 5252 5259 5249 5250 5252 5251 5253 5252 5253 5256 2102 5252 5256 2094 2101 2102 2102 5256 2094 5256 5253 5254 5256 5254 5257 2094 5256 5257 2093 2094 2095 2093 2100 2094 2094 2100 2101 2094 5257 2095 2434 2101 2100 2434 2100 2435 2435 2100 2093 2095 2118 2093 2435 2093 2436 2436 2093 2118 2513 2434 2435 2513 2435 2514 2514 2435 2436 2512 2434 2513 2281 2512 2513 2281 2513 2279 2279 2513 2514 2514 2436 2515 2279 2514 2276 2276 2514 2515 2436 2118 2437 2515 2436 2437 2515 2437 2516 2276 2515 2274 2274 2515 2516 2274 2275 2276 2275 2277 2276 2276 2277 2278 2276 2278 2279 2271 2273 2274 2274 2273 2275 2274 2516 2271 2277 2275 2358 2358 2275 2273 2357 2278 2277 2357 2277 2358 2279 2278 2280 2356 2280 2278 2356 2278 2357 1534 2356 2357 1534 2357 1530 1530 2357 2358 2282 2280 2356 1533 2356 1534 2279 2280 2281 2280 2282 2281 1529 1533 1534 1529 1534 1530 1529 1530 1526 1526 1530 1531 1530 2358 1531 1526 1531 1527 1531 2358 2359 1531 2359 1527 2358 2273 2359 2359 2273 2272 2359 2272 2360 1527 2359 2360 1526 1527 1523 1523 1527 1528 1527 2360 1528 2272 2270 2360 2360 2270 2268 2360 2268 2361 1528 2360 2361 2270 2272 2271 2271 2272 2273 2269 2268 2270 2269 2270 2271 2266 2267 2268 2266 2268 2269 2361 2268 2267 2361 2267 2362 1528 2361 1524 1524 2361 2362 1523 1528 1524 1523 1524 1520 1520 1524 1525 1524 2362 1525 2267 2265 2362 2362 2265 2263 2362 2263 2363 1525 2362 2363 2265 2267 2266 2264 2263 2265 2264 2265 2266 2261 2262 2263 2261 2263 2264 2363 2263 2262 2363 2262 2364 1525 2363 1521 1521 2363 2364 1520 1525 1521 1520 1521 1517 1517 1521 1522 1521 2364 1522 2262 2260 2364 2364 2260 2258 2364 2258 2365 1522 2364 2365 2260 2262 2261 2259 2258 2260 2259 2260 2261 2250 2257 2258 2250 2258 2259 2365 2258 2366 2258 2257 2366 1522 2365 1518 1518 2365 2366 1517 1522 1518 1517 1518 1514 1514 1518 1519 1518 2366 1519 2366 2257 2249 2366 2249 2256 2256 2368 2366 1519 2366 2368 2249 2257 2250 2249 2250 2251 2251 2256 2249 2251 2255 2256 2255 2367 2256 2256 2367 2368 1519 2368 1515 1515 2368 2367 1514 1519 1515 1514 1515 1511 1511 1515 1516 1515 2367 1516 2255 2253 2367 2367 2253 2252 2367 2252 2369 1516 2367 2369 2254 2253 2255 2254 2255 2251 2243 2252 2253 2243 2253 2254 2242 2252 2243 2369 2252 2370 2252 2242 2370 1516 2369 1512 1512 2369 2370 1511 1516 1512 1511 1512 1508 1508 1512 1513 1512 2370 1513 2370 2242 2240 2370 2240 2248 2248 2372 2370 1513 2370 2372 2241 2240 2242 2241 2242 2243 2239 2240 2241 2239 2248 2240 2239 2247 2248 2247 2371 2248 2248 2371 2372 1513 2372 1509 1509 2372 2371 1508 1513 1509 1508 1509 1505 1505 1509 1510 1509 2371 1510 2247 2245 2371 2371 2245 2244 2371 2244 2373 1510 2371 2373 2246 2245 2247 2246 2247 2239 2233 2244 2245 2233 2245 2246 2232 2244 2233 2373 2244 2374 2244 2232 2374 1510 2373 1506 1506 2373 2374 1505 1510 1506 1505 1506 1502 1502 1506 1507 1506 2374 1507 2374 2232 2230 2374 2230 2238 2238 2376 2374 1507 2374 2376 2231 2230 2232 2231 2232 2233 2229 2230 2231 2229 2238 2230 2229 2237 2238 2237 2375 2238 2238 2375 2376 1507 2376 1503 1503 2376 2375 1502 1507 1503 1502 1503 1499 1499 1503 1504 1503 2375 1504 2237 2235 2375 2375 2235 2234 2375 2234 2377 1504 2375 2377 2236 2235 2237 2236 2237 2229 2223 2234 2235 2223 2235 2236 2222 2234 2223 2377 2234 2222 2377 2222 2378 1504 2377 1500 1500 2377 2378 1499 1504 1500 1499 1500 1496 1496 1500 1501 1500 2378 1501 2222 2220 2378 2378 2220 2228 2378 2228 2379 1501 2378 2379 2221 2220 2222 2221 2222 2223 2219 2220 2221 2219 2228 2220 2219 2227 2228 2379 2228 2227 2379 2227 2380 1501 2379 1497 1497 2379 2380 1496 1501 1497 1496 1497 1493 1493 1497 1498 1497 2380 1498 2227 2225 2380 2380 2225 2224 2380 2224 2381 1498 2380 2381 2226 2225 2227 2226 2227 2219 2211 2224 2225 2211 2225 2226 2210 2224 2211 2381 2224 2210 2381 2210 2382 1498 2381 1494 1494 2381 2382 1493 1498 1494 1493 1494 1492 1526 1493 1492 1526 1492 1491 1526 1491 1601 1496 1493 1526 1496 1526 1499 1499 1526 1523 1491 1604 1605 1491 1605 1601 1601 1605 1606 1604 2385 1605 1605 2385 2386 1605 2386 1606 2385 2215 2213 2385 2213 2386 2386 2213 2212 2206 2212 2213 2206 2213 2214 2214 2213 2215 1499 1523 1520 1520 1517 1499 1517 1514 1499 1499 1514 1511 1499 1511 1502 1511 1508 1505 1502 1511 1505 2210 2208 2382 2209 2208 2210 2209 2210 2211 2211 2538 2209 2226 2537 2211 2211 2537 2538 2537 2459 2538 2538 2459 2460 2536 2458 2537 2537 2458 2459 2226 2536 2537 2219 2536 2226 2535 2457 2536 2536 2457 2458 2219 2535 2536 2457 1668 2458 2458 1668 1641 2458 1641 2459 2456 1685 2457 2457 1685 1668 2535 2456 2457 2534 2456 2535 2221 2534 2535 2221 2535 2219 2455 1684 2456 2456 1684 1685 2534 2455 2456 1684 1669 1685 1685 1669 1668 1682 1683 1684 1684 1683 1669 2455 1682 1684 2454 1682 2455 2533 2454 2455 2533 2455 2534 1682 1691 1683 2454 1691 1682 2453 1691 2454 2532 2453 2454 2532 2454 2533 2236 2532 2533 2236 2533 2223 2223 2533 2534 2531 2453 2532 2229 2531 2532 2229 2532 2236 2530 2452 2531 2531 2452 2453 2231 2530 2531 2231 2531 2229 2529 2451 2530 2530 2451 2452 2233 2529 2530 2233 2530 2231 2451 1693 2452 2452 1693 1692 2452 1692 2453 2450 1665 2451 2451 1665 1693 2529 2450 2451 1664 1692 1693 1664 1693 1665 1683 1691 1692 1683 1692 1664 2453 1692 1691 1664 1665 1662 1664 1662 5375 5375 1683 1664 1662 1665 1666 2450 1666 1665 1662 1666 1663 2449 1663 1666 2449 1666 2450 1661 1662 1663 2448 1661 1663 2448 1663 2449 2527 2448 2449 2527 2449 2528 2528 2449 2450 2447 1661 2448 2526 2447 2448 2526 2448 2527 2241 2526 2527 2241 2527 2239 2239 2527 2528 2528 2450 2529 2239 2528 2246 2246 2528 2529 2246 2529 2233 2243 2526 2241 2525 2447 2526 2243 2525 2526 2254 2525 2243 2524 2446 2525 2525 2446 2447 2254 2524 2525 2251 2524 2254 2523 2445 2524 2524 2445 2446 2251 2523 2524 2445 1657 2446 2446 1657 1659 2446 1659 2447 2444 1789 2445 2445 1789 1657 2523 2444 2445 1657 1658 1659 1657 1789 1658 1659 1658 1660 1659 1660 1661 2447 1659 1661 1661 1660 1662 1660 1658 5372 1662 1660 5374 5374 1660 5372 5375 1662 5374 5374 5372 5371 5375 5374 5370 5370 5374 5371 5372 1658 5361 5372 5361 5373 5371 5372 5373 3707 3705 5371 5371 5373 3707 5370 5371 3703 3703 5371 3705 5373 5361 5360 5373 5360 3709 3707 5373 3709 3706 3705 3707 3706 3707 3708 3708 3707 3709 3704 3703 3705 3704 3705 3706 3708 3737 3706 3706 3737 3740 3740 3704 3706 3708 3709 3595 3595 3738 3708 3708 3738 3737 3595 3709 3594 3709 5360 3594 3594 3586 3595 3595 3586 3738 3737 3738 3739 3738 3586 3756 3738 3756 3739 3586 3587 3588 3587 3586 3594 3756 3586 3588 5347 3587 3594 5347 3594 5349 5349 3594 5360 3588 3587 3589 3587 5347 5348 3587 5348 3589 3588 3589 3590 3756 3588 3764 3764 3588 3590 3590 3589 3591 3589 5348 5352 3589 5352 3591 3590 3591 3592 3764 3590 3766 3766 3590 3592 3592 3591 3593 3591 5352 5353 3591 5353 3593 5348 5350 5352 5352 5350 5351 5352 5351 5353 5353 5351 5331 5353 5331 5333 3593 5353 5333 3592 3593 3580 3580 3593 3581 3593 5333 3581 5331 5332 5333 5333 5332 3583 5333 3583 3581 1757 5330 5331 5331 5330 5332 5351 1757 5331 5334 3583 5332 5334 5332 5335 5335 5332 5330 1757 1730 5330 5335 5330 1728 1728 5330 1730 1730 1757 1731 1731 1757 1758 5351 1758 1757 1729 1728 1730 1729 1730 1731 1609 1727 1728 1609 1728 1729 1727 5335 1728 1609 1729 2439 2439 1729 1731 1607 1608 1609 1609 1689 1690 1608 1724 1609 1609 1724 1725 1609 1725 1726 1690 1727 1609 1726 1755 1609 1609 1755 1756 1609 1756 1689 1609 2116 1607 1609 2439 2116 1727 1690 5317 5317 1690 1689 5317 5318 1727 5318 5335 1727 5317 1689 5319 5318 5317 5321 5321 5317 5319 5321 5334 5318 5318 5334 5335 5321 5319 5322 3575 5321 5322 3575 3585 5321 5321 3585 5334 5319 1689 1756 5319 1756 5320 5322 5319 5320 5322 5320 5323 3575 5322 3577 3577 5322 5323 3574 3575 3576 3576 3575 3577 3574 3585 3575 3576 3577 3578 3578 3577 3579 3577 5323 3579 5323 5320 5314 5323 5314 5310 3579 5323 5310 3578 3579 3566 3566 3579 3567 3579 5310 3567 5309 3567 5310 5312 5309 5310 5312 5310 5313 5313 5310 5314 5313 5314 1755 5320 1755 5314 1755 1726 5313 5313 1726 1725 5313 1725 5312 5311 5309 5312 5312 1725 1724 5312 1724 5311 5306 5308 5311 5311 5308 5309 5311 1724 1754 5311 1754 5306 1608 1754 1724 1608 1753 1754 1754 1753 5289 5306 1754 5289 1688 1753 1608 1688 5289 1753 1688 5287 5289 5306 5289 5287 1608 1687 1688 5288 5287 1688 1688 1687 5288 5286 5287 5288 5306 5287 5286 5286 5288 5290 5290 5288 5291 5288 1687 5294 5288 5294 5291 1608 1752 1687 1687 1752 5294 5291 5294 5295 5294 1752 5297 5294 5297 5295 1608 1723 1752 1723 5297 1752 5278 5296 5297 5278 5297 1723 5295 5297 5296 1608 1722 1723 5279 5278 1723 1723 1722 5279 5277 5278 5279 5277 5296 5278 5295 5296 3565 3565 5296 5277 5279 5283 5277 5277 5283 5282 5277 5282 3553 3565 5277 3553 5279 1722 5283 1721 1722 1608 1722 1721 5283 1608 5261 1721 5283 1721 5261 1608 5258 5261 5258 5263 5261 5283 5261 5263 1607 5258 1608 1607 2116 2117 1607 2117 2095 2095 5258 1607 2438 2117 2116 2116 2439 2440 2116 2440 2438 2095 2117 2118 2437 2118 2117 2437 2117 2438 2095 5257 5258 5257 5254 5255 5257 5255 5258 5253 3883 5254 3880 5255 5254 3880 5254 3882 3882 5254 3883 5251 3874 5253 3874 3877 5253 5253 3877 3883 3878 3882 3883 3878 3883 3877 3881 3880 3882 3881 3882 3878 3877 3876 3878 3881 3878 3908 3876 3908 3878 3874 3876 3877 3874 3875 3876 3876 3875 3909 3909 3908 3876 3909 3907 3908 3907 3904 3908 3908 3904 3912 3908 3912 3881 3879 3880 3881 3881 3912 3879 3884 3879 3912 3884 3912 3885 3885 3912 3904 3546 3545 3879 3879 3545 3880 3546 3879 3884 3545 5255 3880 3545 3546 3547 3547 5265 3545 3545 5265 5267 3545 5267 5255 5255 5262 5258 5255 5267 5270 5255 5270 5262 5267 5265 5268 5268 5281 5267 5267 5281 5270 5270 5281 5262 5258 5262 5263 5262 5281 5283 5262 5283 5263 5281 5282 5283 5268 3549 5281 5281 3549 3551 5281 3551 5282 3553 5282 3551 3549 3550 3551 3554 3553 3551 3554 3551 3555 3555 3551 3550 3552 3553 3554 3552 3565 3553 3555 3857 3554 3554 3857 3829 3554 3829 3552 3550 3856 3555 3555 3856 3857 3856 3855 3857 3857 3855 3830 3857 3830 3829 3828 3829 3830 3552 3829 3564 3564 3829 3828 3564 3565 3552 3564 3563 3565 3565 3563 5295 3562 3563 3564 3564 3828 3562 3562 3561 3563 5295 3563 3561 5291 5295 3559 5295 3561 3559 3560 3559 3561 3560 3561 3562 3562 3828 3833 3562 3833 3560 3558 3559 3560 3560 3833 3831 3560 3831 3558 3558 3557 3559 3559 3557 5291 3556 3557 3558 3558 3831 3808 3558 3808 3556 3556 3573 3557 5291 3557 5293 5293 3557 3573 3572 3573 3556 3572 3556 3808 3808 3809 3810 3808 3810 3572 3831 3809 3808 3570 3571 3572 3572 3571 3573 3572 3810 3814 3572 3814 3570 5293 3573 5307 5307 3573 3571 5291 5293 5292 5307 5292 5293 5290 5291 5292 5307 5290 5292 5286 5290 5307 5307 3571 5308 5286 5307 5306 5306 5307 5308 5308 3571 3569 5308 3569 5309 3568 3567 3569 3568 3569 3570 3570 3569 3571 5309 3569 3567 3566 3567 3568 3570 3815 3568 3568 3815 3795 3568 3795 3566 3570 3814 3815 3814 3813 3815 3815 3813 3793 3815 3793 3795 3793 3794 3795 3795 3794 3578 3795 3578 3566 3672 3792 3793 3793 3792 3794 3813 3672 3793 3812 3670 3813 3813 3670 3672 3814 3812 3813 3810 3812 3814 3807 3668 3812 3812 3668 3670 3810 3807 3812 3668 3669 3670 3670 3669 3671 3670 3671 3672 3666 3667 3668 3668 3667 3669 3807 3666 3668 3671 3669 3803 3803 3669 3667 3672 3671 3673 3803 3801 3671 3671 3801 3673 3802 3800 3803 3803 3800 3801 3827 3802 3803 3803 3667 3827 3800 3798 3801 3801 3798 3799 3801 3799 3673 3623 3621 3800 3800 3621 3798 3802 3623 3800 3621 3619 3798 3619 3617 3798 3798 3617 3790 3798 3790 3799 3799 3790 3791 3799 3791 3675 3673 3799 3675 3617 3615 3790 3790 3615 3788 3790 3788 3791 3791 3788 3789 3791 3789 3657 3675 3791 3657 3674 3673 3675 3674 3675 3676 3676 3675 3657 3672 3673 3674 3672 3674 3792 3676 3792 3674 3676 3657 3677 3797 3792 3676 3677 3797 3676 3797 3794 3792 3796 3794 3797 3781 3796 3797 3781 3797 3677 3677 3657 3655 3677 3655 3780 3677 3780 3781 3781 3780 3782 3781 3782 3783 3783 3796 3781 3576 3578 3796 3796 3578 3794 3783 3576 3796 3783 3782 3584 3783 3584 3574 3574 3576 3783 3784 3584 3782 3784 3782 3785 3785 3782 3780 3582 3583 3584 3584 3583 3585 3584 3585 3574 3582 3584 3784 3768 3582 3784 3768 3784 3771 3771 3784 3785 3785 3780 3654 3771 3785 3658 3658 3785 3654 3770 3768 3771 3771 3658 3661 3771 3661 3770 3654 3656 3658 3658 3656 3659 3658 3659 3660 3658 3660 3661 3654 3655 3656 3654 3780 3655 3656 3655 3657 3789 3787 3656 3656 3787 3659 3657 3789 3656 3787 3660 3659 3786 3776 3787 3787 3776 3660 3789 3786 3787 3788 3786 3789 3786 3613 3611 3611 3779 3786 3786 3779 3776 3788 3613 3786 3775 3660 3776 3778 3775 3776 3778 3776 3779 3609 3778 3779 3609 3779 3611 3610 3609 3611 3610 3611 3612 3612 3611 3613 3608 3607 3609 3608 3609 3610 3607 3778 3609 3777 3775 3778 3607 3777 3778 3606 3605 3607 3606 3607 3608 3605 3777 3607 5414 3606 3608 5414 3608 5415 5415 3608 3610 3604 3605 3606 5412 3604 3606 5412 3606 5414 3604 3603 3605 3603 3773 3605 3605 3773 3777 3602 3603 3604 5411 3602 3604 5411 3604 5412 3602 3601 3603 3745 3759 3603 3745 3603 3601 3603 3759 3773 3600 3601 3602 5411 3600 3602 5407 5396 5411 5411 5396 3600 5412 5407 5411 3601 3600 3729 3729 3600 3730 3600 5396 3730 3744 3745 3601 3601 3729 3744 3744 3749 3745 3749 3759 3745 3749 3758 3759 3773 3759 3758 3749 3763 3758 3773 3758 3763 3748 3747 3749 3744 3748 3749 3747 3762 3749 3749 3762 3763 3762 3772 3763 3763 3772 3773 3773 3772 3774 3773 3774 3777 3762 3761 3772 3761 3701 3772 3772 3701 3700 3772 3700 3774 3747 3761 3762 3746 3747 3748 3746 3761 3747 3746 3760 3761 3760 3701 3761 3687 3700 3701 3687 3701 3686 3760 3686 3701 3699 3698 3700 3699 3700 3687 3774 3700 3698 3686 3685 3687 3687 3685 3752 3699 3687 3752 3684 3685 3686 3746 3684 3686 3686 3760 3746 3685 3684 3718 3718 3736 3685 3752 3685 3736 3736 3755 3752 3765 3699 3752 3765 3752 3755 3734 3735 3736 3718 3734 3736 3735 3754 3736 3736 3754 3755 3765 3755 3754 3754 3764 3765 3765 3764 3766 3765 3766 3769 3769 3699 3765 3735 3753 3754 3754 3753 3764 3734 3739 3735 3739 3753 3735 3739 3757 3753 3764 3753 3757 3764 3757 3756 3739 3756 3757 3734 3737 3739 3741 3740 3737 3741 3737 3734 3711 3702 3740 3740 3702 3704 3711 3740 3741 3710 3703 3711 3711 3703 3702 3741 3710 3711 3702 3703 3704 3710 3596 3703 3703 3596 5370 3597 3596 3710 3597 3710 3713 3713 3710 3741 3596 3597 3598 3596 3598 5382 3596 5382 5370 5370 5382 5383 5370 5383 5375 5382 3598 3721 5383 5382 5393 5393 5382 3721 3598 3597 3599 3721 3598 3599 3599 3597 3712 3599 3722 3721 3750 3722 3599 3599 3712 3750 3712 3597 3713 3712 3713 3714 3750 3712 3714 3750 3714 3751 3722 3750 3742 3742 3750 3751 3721 3722 3723 3742 3723 3722 3726 3742 3743 3726 3725 3742 3742 3725 3723 3742 3751 3743 3721 3723 3724 3723 3725 3724 3724 3725 3726 3724 3726 3727 3727 3726 3728 3743 3728 3726 5394 3721 3724 3724 3727 5394 5393 3721 5394 5394 3727 3733 5394 3733 5395 5392 5393 5394 5392 5394 5397 5397 5394 5395 3728 3733 3727 3728 3732 3733 3732 5395 3733 3731 3732 3728 3743 3731 3728 3731 3730 3732 3730 5395 3732 3729 3730 3731 3744 3729 3731 3744 3731 3743 3743 3751 3748 3743 3748 3744 3720 3748 3751 3751 3714 3716 3751 3716 3720 3719 3746 3748 3719 3748 3720 3717 3719 3720 3717 3720 3716 3714 3715 3716 3716 3715 3717 3714 3713 3715 3713 3741 3715 3715 3741 3717 3718 3719 3717 3717 3741 3734 3717 3734 3718 3718 3684 3719 3684 3746 3719 3730 5396 5395 5398 5395 5396 5398 5396 5399 5407 5408 5396 5396 5408 5409 5396 5409 5399 5397 5395 5398 1667 5397 5398 1667 5398 1620 1620 5398 5399 1669 5392 5397 1669 5397 1667 1620 1641 1667 1667 1641 1668 1667 1668 1669 1683 5392 1669 1683 5383 5392 5383 5393 5392 5375 5383 1683 1639 1640 1641 1641 1640 1642 1641 1642 1643 1620 1639 1641 1643 1695 1641 1641 1695 1696 1641 1696 1697 1698 1641 1699 1699 1641 1700 1697 1760 1641 1641 1760 1761 1641 1761 1700 1698 1715 1641 1641 1715 1717 1641 1717 1766 2459 1641 1766 1698 1699 5478 5478 1699 1700 5478 1700 5479 5479 1700 1761 1761 1760 5477 5479 1761 5477 1697 5477 1760 5477 5480 5481 5477 5481 5479 5490 5480 5477 5490 5477 1697 5479 5481 5482 5479 5482 5478 5478 5482 5463 5478 5463 1698 5481 3354 5482 5482 3354 5468 5482 5468 5463 5480 3356 5481 5481 3356 3354 3353 3352 3354 3353 3354 3355 3355 3354 3356 3354 3352 5468 5467 5463 5468 5468 5469 5467 5468 3352 5469 3351 3352 3353 3351 3364 3352 5469 3352 3364 5467 5469 5470 5469 3364 5470 5466 1715 5467 5467 1715 5463 5467 5470 5466 5466 5470 5464 5470 3364 3362 5470 3362 5464 3363 3362 3364 3363 3364 3351 3361 3360 3362 3361 3362 3363 5464 3362 3360 3351 4068 3363 3363 4068 4078 3363 4078 3361 3359 3360 3361 3361 4078 3359 3359 3358 3360 5464 3360 3358 3357 3358 3359 4078 4080 3359 3359 4080 4079 3359 4079 3357 3358 3357 3365 3358 3365 5452 3358 5452 5453 5464 3358 5453 3365 3357 3366 3365 3366 3367 3365 3367 5452 5453 5452 5454 5452 3367 5451 5452 5451 5454 5453 5454 5455 5465 5464 5453 5465 5453 5455 5466 5464 5465 5455 1712 5465 5465 1712 1765 5465 1765 5466 5455 5454 1798 5455 1798 1713 5455 1713 1712 1712 1713 1714 1714 1765 1712 1714 1715 1765 5466 1765 1715 1715 1716 1717 1716 1715 1714 1715 1698 5463 1714 5952 1716 1716 5952 5953 1716 5953 1717 1766 1717 1767 1717 5953 5954 1717 5954 1767 5952 5948 5953 5953 5948 5947 5953 5947 5954 5966 1767 5954 5968 5966 5954 5968 5954 5947 3119 5947 5948 3124 5968 5947 3124 5947 3119 5967 5966 5968 3123 5967 5968 3123 5968 3124 5965 1787 5966 5966 1787 1767 5967 5965 5966 5963 5965 5967 3121 5963 5967 3121 5967 3123 3122 3121 3123 3122 3123 3118 3118 3123 3124 3118 3124 3119 3116 3117 3118 3116 3118 3119 4322 4352 3118 4322 3118 3117 3122 3118 4353 4353 3118 4352 3117 3116 4308 3117 4308 4322 4307 4305 3116 4307 3116 3119 4308 3116 4305 4308 4305 4309 4309 4318 4308 4322 4308 4318 4304 4303 4305 4304 4305 4306 4306 4305 4307 4309 4305 4303 5948 4306 4307 5948 4307 3119 5951 4304 4306 5951 4306 5948 4302 4303 4304 4302 4304 5951 5950 4301 5951 5951 4301 4302 5949 5950 5951 5949 5951 5952 5952 5951 5948 4301 4303 4302 4301 3115 3113 3113 4303 4301 5943 3115 4301 5950 5943 4301 5944 5943 5950 5944 5950 5949 1805 5944 5949 1805 5949 1714 1714 5949 5952 5928 5943 5944 5928 5944 5939 5939 5944 1805 3114 3115 5943 3114 5943 5928 3114 3113 3115 3112 3113 3114 3112 3114 4331 3114 5928 5929 5929 4331 3114 5938 5929 5928 5938 5928 5939 1802 5938 5939 1802 5939 1804 5939 1805 1804 5937 5929 5938 1651 5937 5938 1651 5938 1802 5934 4332 5929 5929 4332 4331 5937 5934 5929 5936 5934 5937 1675 5936 5937 1675 5937 1651 5933 4334 5934 5934 4334 4332 5936 5933 5934 4331 4332 4333 4333 4332 4334 4333 4334 4326 4326 4334 4335 5933 4335 4334 4326 4327 4328 4326 4335 4327 4328 4337 4326 4326 4337 4338 4326 4338 4333 4327 4335 5933 4328 4327 4329 5932 4329 4327 5932 4327 5933 4328 4329 3108 3108 4329 4330 5930 4330 4329 5930 4329 5932 5931 5930 5932 5931 5932 5935 5935 5932 5933 5921 5920 5930 5920 4330 5930 5921 5930 5931 3108 4330 3107 5920 3107 4330 5914 3107 5920 5914 5920 5917 5917 5920 5921 5917 5921 1747 1747 5921 1748 1748 5921 5931 5916 5914 5917 5917 1747 1825 5917 1825 5916 5913 3100 5914 5916 5913 5914 3100 3107 5914 3107 3100 3108 3099 3100 3101 3101 3100 3102 3108 3100 3099 5913 3102 3100 5912 3102 5913 5915 5912 5913 5915 5913 5916 3101 3102 3103 3103 3102 3104 5912 3104 3102 3103 4406 3101 3101 4406 4386 3101 4386 3099 3103 3104 3105 3105 4405 3103 3103 4405 4406 3105 3104 3106 5911 3106 3104 5911 3104 5912 3105 3106 3087 3105 3087 4399 4399 4401 3105 3105 4401 4405 4401 4403 4405 4405 4403 4404 4405 4404 4406 4398 3205 4403 4403 3205 3203 4403 3203 4404 4401 4398 4403 4404 3203 3201 4404 3201 4385 4406 4404 4385 3202 3201 3203 3202 3203 3204 3204 3203 3205 3200 3201 3202 3201 3200 4385 3200 3202 4347 4363 4362 3200 3200 4347 4363 4385 3200 4362 4347 3202 4313 4347 4313 4348 4363 4347 4348 4312 4313 3202 4312 4317 4313 4348 4313 4317 4348 4317 4315 4315 4350 4348 4363 4348 4370 4370 4348 4350 4316 4315 4317 4312 4316 4317 4314 4315 4316 4314 4349 4315 4315 4349 4350 4370 4350 4371 4371 4350 4349 4372 4363 4370 4372 4370 4357 4357 4370 4371 4371 4349 4336 4357 4371 4339 4339 4371 4336 4314 3110 4349 4336 4349 3110 3112 4333 4336 3112 4336 3110 4333 4339 4336 4333 4338 4339 4339 4338 4357 4331 4333 3112 3110 3111 3112 3112 3111 3113 3111 3110 4314 3111 4311 3113 3111 4314 4311 3113 4311 4303 4310 4303 4311 4311 4314 4316 4311 4316 4310 4309 4303 4310 4310 4316 4318 4310 4318 4309 4321 4318 4316 4321 4316 4312 4322 4318 4321 4321 4320 4322 4320 4352 4322 4319 4320 4321 4320 4319 4352 4312 4324 4321 4321 4324 4325 4321 4325 4319 3202 4323 4312 4312 4323 4324 4351 4325 4324 4351 4324 4323 4352 4319 4325 4352 4325 4351 4353 4352 4354 4354 4352 4351 4323 3204 4351 4354 4351 3206 3206 4351 3204 3202 3204 4323 3204 3205 3206 3206 3205 3207 3206 3207 3208 3208 4354 3206 4356 4353 4354 4356 4354 3208 4355 3122 4353 4355 4353 4356 4382 4355 4356 4384 4382 4356 4384 4356 3208 3208 3207 3209 3208 3209 3210 3208 3210 4384 4383 4382 4384 4384 3210 3211 4384 3211 4383 4381 3130 4382 4382 3130 4355 4383 4381 4382 4378 4381 4383 4383 3211 3196 4383 3196 4378 3210 3197 3211 3211 3197 3196 3210 3209 3197 3186 3196 3197 3197 3209 4395 4419 3186 3197 4419 3197 4416 4416 3197 4395 3186 3195 3196 3196 3195 4380 4378 3196 4380 3188 3195 3186 4380 3195 3188 4378 4380 4379 4387 4379 4380 4380 3188 4387 3186 3187 3188 4387 3188 3187 4375 4374 4387 4387 4374 4379 4387 3187 4389 4375 4387 4388 4388 4387 4389 4378 4379 4374 4374 4375 4376 4374 4376 4378 4376 4375 4377 4388 4377 4375 4377 4388 4373 4388 4389 4392 4373 4388 3137 3137 4388 4392 4376 4377 4373 4373 3126 3128 4373 3128 4376 3137 3126 4373 3135 3136 3137 3137 3136 3127 3137 3127 3126 3137 4392 3135 3126 3127 3128 3128 3127 3129 4376 3128 3129 3129 3127 3125 5974 3125 3127 3136 5974 3127 3135 3134 3136 3134 5988 3136 3136 5988 5974 5972 5973 5974 5974 5973 3125 5988 5972 5974 5987 5985 5988 5988 5985 5972 3134 5987 5988 3133 3132 3134 3133 3134 3135 3132 5987 3134 5986 5984 5987 5987 5984 5985 3132 5986 5987 5984 1621 5985 5985 1621 1718 5985 1718 5972 5983 1622 5984 5984 1622 1621 5986 5983 5984 3132 3143 5986 5986 3143 5996 5986 5996 5983 5983 1624 1622 5983 5996 5997 5983 5997 1624 1621 1622 1623 1623 1622 1624 1621 1623 1718 1625 1623 1626 1627 1628 1623 1623 1628 1629 1623 1629 1630 1623 1624 1644 1623 1644 1626 1625 1652 1623 1623 1652 1653 1623 1653 1654 1623 1654 1678 1623 1678 1679 1627 1623 1680 1680 1623 1679 1718 1623 1719 1923 1924 1623 1923 1623 1938 1924 1972 1623 1623 1972 1970 1623 1970 1973 1630 2011 1623 1623 2011 2012 1623 2012 1938 1973 1970 1968 1961 1968 1969 1969 1968 1970 1969 1990 1961 5728 5726 1969 1969 5726 1990 1970 5728 1969 1961 1990 1991 5726 5713 1990 1990 5713 1991 5725 5717 5726 5726 5717 5713 5728 5725 5726 5727 5725 5728 5742 5727 5728 1970 5742 5728 2806 2804 5725 5725 2804 5717 5727 2806 5725 2807 2806 5727 2807 5727 5735 5742 5735 5727 5741 5735 5742 1972 5741 5742 1972 5742 1970 5740 4677 5735 5735 4677 4676 5735 4676 2807 5741 5740 5735 5739 5740 5741 1971 5739 5741 1971 5741 1972 1924 1971 1972 1967 1971 1924 1967 5739 1971 1967 5737 5739 5737 5738 5739 5739 5738 5740 1924 1966 1967 5750 5737 1967 5750 1967 1966 5737 5736 5738 5749 5736 5737 5749 5737 5750 5736 4674 5738 5738 4674 4680 5738 4680 5740 5736 2799 4674 2798 2799 5736 2798 5736 5749 2798 5749 5758 5767 5758 5749 5767 5749 5750 2796 2797 2798 2798 2797 2799 2796 2798 4618 5758 4618 2798 2799 2797 4674 2796 2795 2797 4674 2797 4675 4684 4675 2797 4684 2797 2795 2794 2795 2796 2795 2794 4669 2795 4669 4684 4683 4675 4684 4684 4669 4699 4684 4699 4683 4669 2794 4644 4669 4644 4670 4670 4699 4669 2796 4622 2794 4622 4643 2794 2794 4643 4644 4644 4643 4645 4645 4670 4644 4647 4673 4670 4647 4670 4645 4673 4698 4670 4670 4698 4699 4645 4643 4646 4645 4646 4647 4622 4621 4643 4643 4621 4623 4643 4623 4646 4620 4621 4622 4620 4623 4621 2796 4620 4622 4618 4619 4620 4620 4619 4617 4618 4620 2796 4617 4616 4620 4620 4616 4623 4616 4630 4623 4646 4623 4630 4616 4629 4630 4646 4630 4629 4627 4629 4616 4627 4646 4629 4626 4627 4616 4626 4656 4627 4627 4656 4646 4616 4628 4626 4628 4654 4626 4626 4654 4656 4654 4653 4656 4656 4653 4651 4656 4651 4646 4646 4651 4649 4646 4649 4647 4648 4649 4650 4650 4649 4651 4647 4649 4648 4648 4673 4647 4650 4672 4648 4648 4672 4673 4650 4651 4652 4652 4671 4650 4650 4671 4672 4673 4672 4698 4698 4672 4671 4652 2911 4671 4698 4671 2911 2912 4652 4642 4642 4652 4651 2912 2911 4652 2911 2912 2913 2911 4695 4698 2911 2913 4695 4698 4695 4692 4698 4692 4699 4695 4696 4692 4695 2913 4706 4695 4706 4696 2913 2912 2914 2914 2917 2913 2917 4706 2913 2887 2916 2914 2914 2916 2917 2914 2912 4640 2887 2914 4632 4632 2914 4640 4709 4706 2917 2916 4709 2917 2887 2915 2916 4711 4709 2916 4711 2916 2915 4708 4707 4709 4709 4707 4706 4711 4708 4709 4710 4708 4711 4719 4710 4711 4719 4711 2886 2886 4711 2915 2886 2915 2887 2863 2885 2886 2863 2886 2887 2885 4719 2886 4718 4710 4719 4721 4718 4719 4721 4719 2885 2865 2885 2863 2865 4721 2885 4720 4718 4721 4723 4720 4721 4723 4721 2865 2812 2803 4718 4718 2803 4710 4720 2812 4718 2810 2812 4720 4722 2810 4720 4722 4720 4723 2865 4734 4723 4723 4734 4735 4723 4735 4722 2808 2810 4722 4722 4735 2818 4722 2818 2808 2808 2809 2810 2810 2809 2811 2810 2811 2812 2818 2819 2808 2808 2819 2809 2816 2817 2818 2818 2817 2819 2816 2818 4736 4736 2818 4735 5702 2809 2819 5702 2819 5703 5703 2819 2817 2811 2809 5702 5701 5702 5703 5714 5702 5701 5702 5714 2811 5701 5703 5700 5700 5703 5704 5703 2817 5704 2816 2815 2817 5704 2817 2815 5700 5704 5699 5699 5704 5690 5704 2815 5690 5699 2038 5700 5700 2038 2037 5700 2037 5701 5698 2039 5699 5699 2039 2038 5699 5690 5698 2037 2038 1961 1961 2038 2039 1961 2036 2037 2037 2036 5715 5715 5701 2037 1992 2036 1961 5715 2036 1992 5715 1992 5716 5716 5714 5715 5715 5714 5701 1961 1991 1992 1992 1991 5713 5716 1992 5713 5716 5713 5717 5717 5718 5716 5716 5718 5714 2811 5714 5718 2811 5718 2813 5717 2813 5718 2804 2813 5717 2812 2811 2813 2812 2813 2803 2803 2813 2804 2803 2804 2805 2805 2804 2806 2803 2805 4710 2805 2806 2802 2805 2802 4708 4710 2805 4708 2802 2806 2807 2800 2801 2802 2802 2807 2800 4707 2802 2801 4708 2802 4707 2800 2807 4676 4676 4678 2800 2800 4678 4682 2800 4682 2801 2801 4682 4691 4691 4694 2801 2801 4694 4707 4707 4694 4693 4707 4693 4706 4691 4693 4694 4692 4693 4691 4699 4692 4691 4699 4691 4681 4681 4691 4682 4678 4681 4682 4681 4678 4683 4683 4699 4681 4683 4678 4675 4678 4679 4675 4675 4679 4680 4675 4680 4674 4678 4677 4679 4680 4679 5740 5740 4679 4677 4676 4677 4678 4692 4696 4697 4692 4697 4693 4706 4697 4696 4706 4693 4697 1960 1961 1962 1961 2039 2040 2040 2047 1961 1961 2047 2048 1961 2048 1962 1960 1962 5672 1962 2048 5688 1962 5688 5672 2047 5688 2048 5692 5691 2047 5692 2047 2040 5691 5688 2047 5698 2040 2039 5698 5692 2040 5690 5691 5692 5698 5690 5692 5690 5689 5691 5689 5693 5691 5691 5693 5688 5672 5688 5693 5672 5693 5677 5677 5693 2823 5689 2823 5693 2815 2825 5689 2815 5689 5690 2825 2823 5689 2822 2821 2823 2822 2823 2824 2824 2823 2825 5677 2823 2821 2824 2825 2814 2814 2825 2815 2814 2815 2816 2814 2816 4738 2814 4738 4758 2814 4758 2824 2824 4758 4759 2824 4759 2822 4738 4755 4758 4758 4755 4756 4758 4756 4759 4759 4756 4757 4759 4757 4760 2822 4759 4760 4755 2927 4756 4756 2927 2926 4756 2926 4757 4754 2928 4755 4755 2928 2927 4738 4754 4755 2908 2926 2927 2908 2927 2891 2891 2927 2928 2907 2926 2908 4769 4757 2926 2926 2907 4769 2906 2907 2908 4660 2908 2891 4660 2906 2908 2906 2905 2907 4769 2907 2905 4769 2905 4771 4757 4769 4770 4770 4769 4771 2904 2903 2905 2904 2905 2906 4771 2905 2903 4771 2903 4772 4770 4771 4773 4773 4771 4772 2902 2901 2903 2902 2903 2904 4772 2903 2901 2902 2904 4685 2904 2906 4685 2900 2901 2902 2902 4685 4686 4686 4705 2902 2902 4705 2900 2900 2899 2901 2899 4772 2901 2898 2899 2900 4705 4702 2900 2900 4702 2898 4704 4700 4705 4705 4700 4702 4686 4704 4705 4700 4701 4702 4702 4701 4703 4702 4703 2898 2896 2897 2898 2898 2897 2899 2898 4703 2896 4701 4716 4703 4703 4716 4717 4703 4717 2896 4700 2765 4701 2765 2763 4701 4701 2763 4716 2763 2761 4716 4716 2761 4714 4716 4714 4717 4717 4714 4712 4717 4712 2867 2896 4717 2867 4713 4712 4714 4713 4714 4715 4715 4714 2761 2871 2869 4712 2871 4712 4713 2867 4712 2869 4715 4732 4713 4713 4732 4733 4713 4733 2871 4715 2761 2759 2759 2757 4715 4715 2757 4732 2757 2755 4732 4732 2755 4728 4732 4728 4733 4733 4728 4726 4733 4726 2873 2871 4733 2873 4728 2755 2753 2753 4729 4728 4728 4729 4730 4728 4730 4726 4750 4729 4751 4751 4729 2753 4750 4730 4729 4726 4730 4731 4750 4731 4730 4752 4731 4750 4751 4768 4750 4750 4768 4752 4751 2753 2751 2751 4749 4751 4751 4749 4768 2750 2751 2752 2752 2751 2753 2750 4749 2751 2750 4748 4749 4768 4749 4748 4746 4748 2750 4746 2750 5825 5845 5825 2750 5845 2750 2752 2752 2753 2754 2752 2754 5845 5840 5825 5845 5845 2754 5847 5847 5840 5845 2754 2753 2755 2754 2755 2756 2756 5847 2754 2756 2755 2757 2756 2757 2758 5835 5849 2756 5835 2756 2758 5849 5847 2756 2758 2757 2759 2758 2759 2760 5835 2758 5836 5836 2758 2760 5834 5831 5835 5835 5836 5834 5831 5849 5835 5831 5846 5849 5846 5848 5849 5849 5848 5847 1986 1985 5831 5834 1986 5831 1985 5846 5831 1985 1983 5846 1983 1982 5846 5846 1982 5848 1984 1983 1985 1984 1985 1986 1982 1983 1984 1982 1984 1946 5848 1982 1946 1946 1984 2003 1986 2027 1984 2003 1984 5793 5793 1984 2027 1946 2003 2004 5796 2004 2003 5796 2003 5791 5791 2003 5793 5791 5793 5792 5808 5792 5793 5793 2027 5808 1986 2026 2027 5808 2027 2026 2025 2026 1986 2033 2035 1986 1986 2035 2025 5833 2033 1986 5833 1986 5834 5808 2026 5810 5810 2026 2025 5810 2025 5811 5811 2025 2035 5811 5816 5810 5810 5816 5809 5810 5809 5808 5811 2035 5812 5812 5815 5811 5811 5815 5816 5815 2774 5816 5816 2774 2776 5816 2776 5809 5812 5814 5815 5814 2772 5815 5815 2772 2774 2772 2773 2774 2774 2773 2775 2774 2775 2776 2770 2771 2772 2772 2771 2773 5814 2770 2772 5813 5814 5812 5813 2770 5814 2768 2769 2770 2770 2769 2771 5813 2768 2770 4688 2773 2771 2771 2769 4688 2768 2767 2769 2769 2767 4704 4688 2769 4704 4686 4687 4688 4688 4687 2773 4688 4704 4686 4704 2767 4700 2766 2765 2767 2766 2767 2768 2767 2765 4700 2764 2765 2766 2766 2768 5821 2764 2766 5823 5823 2766 5821 2764 2763 2765 2762 2763 2764 5838 2762 2764 5838 2764 5823 5823 5821 5824 5832 5838 5823 5832 5823 5824 5833 5837 5838 5833 5838 5832 5837 2762 5838 2760 2761 2762 2762 2761 2763 5837 2760 2762 5834 5836 5837 5834 5837 5833 5836 2760 5837 5832 2033 5833 5824 2032 5832 5832 2032 2033 2032 2031 2033 2031 2034 2033 2033 2034 2035 2030 2031 2032 5824 2030 2032 5822 5819 2031 2031 5819 2034 2030 5822 2031 2035 2034 5819 2035 5819 5812 5812 5819 5820 5822 5820 5819 5821 5820 5822 5824 5821 5822 5824 5822 2030 5812 5820 5813 5813 5820 2768 5821 2768 5820 2760 2759 2761 4686 4685 4687 4685 2906 4690 4685 4690 4687 4687 4690 4689 4687 4689 2773 4690 4658 4657 4690 4657 4689 4658 4690 4660 4660 4690 2906 4657 4658 4659 4660 2891 4658 4658 2891 4659 4657 4659 4661 4689 4657 4661 4659 2891 2888 4659 2888 4665 4661 4659 4663 4663 4659 4665 2891 2892 2888 2891 2928 2892 2888 2892 2893 2893 2892 4754 4754 2892 2928 2888 2893 2889 4739 4737 2893 2893 4737 2889 4754 4739 2893 4739 4754 4738 4738 4736 4739 4739 4736 4737 4736 4735 4737 4737 4735 4734 4737 4734 2889 4738 2816 4736 2888 2889 2864 2864 2889 2890 2889 4734 2890 2865 2890 4734 2864 2890 2865 2863 2864 2865 4665 2888 2864 4665 2864 4666 4666 2864 2863 2863 2887 4632 2863 4632 4633 4666 2863 4633 4667 4665 4666 4667 4666 4668 4668 4666 4633 4663 4665 4667 2780 4663 4667 2780 4667 2782 2782 4667 4668 4668 4633 4635 2782 4668 2784 2784 4668 4635 4633 4632 4634 4633 4634 4635 4632 4640 4634 4635 4634 2791 4634 4640 4637 4634 4637 2791 4635 2791 2786 2784 4635 2786 2783 2782 2784 2783 2784 2785 2785 2784 2786 2785 2786 2790 2790 2786 2791 2790 2791 2789 2789 2791 2792 2791 4637 2792 5777 2785 2790 5777 2790 5778 5778 2790 2789 2783 2785 5777 5774 5777 5778 5795 2783 5777 5795 5777 5774 5774 5778 5776 5776 5778 5779 5778 2789 5779 1987 2017 5774 5776 1987 5774 5797 5795 5774 5797 5774 2017 5794 2783 5795 5796 5794 5795 5796 5795 5797 2017 2016 5797 5797 2016 2004 5797 2004 5796 1946 2016 2017 1946 2017 1987 2004 2016 1946 1944 1945 1946 1946 1945 1947 1946 1947 1948 1987 1988 1946 1946 1988 1989 1946 1989 1944 5839 1946 1948 1946 5839 5848 5776 1988 1987 5775 1989 1988 5775 1988 5776 5760 1944 1989 5760 1989 5775 5776 5779 5775 5775 5779 5759 5775 5759 5760 5760 5759 5761 1944 5760 5762 5760 5761 5762 5759 2788 4612 5759 4612 5761 5779 2788 5759 5779 2789 2788 2787 2788 2789 2788 2787 4612 4612 2787 4613 4612 4613 4614 5761 4612 4614 2789 2792 2787 2787 2792 2793 4631 4613 2787 4631 2787 2793 2793 2792 4636 4636 2792 4637 2793 4636 4631 4624 4613 4631 4631 4636 4655 4631 4655 4624 4636 4637 4638 4654 4655 4636 4636 4638 4654 4638 4637 4639 4639 4637 4640 4639 4653 4638 4654 4638 4653 4628 4655 4654 4624 4655 4625 4625 4655 4628 4613 4624 4625 4613 4625 4616 4616 4625 4628 4614 4613 4615 4615 4613 4616 4615 4616 4617 4614 4615 5763 5763 4615 4617 5761 4614 5763 5763 4617 5764 5762 5761 5763 5762 5763 5765 5765 5763 5764 5764 4617 4619 5764 4619 5758 5765 5764 5766 5766 5764 5758 1945 5762 5765 1945 5765 1947 1947 5765 5766 1944 5762 1945 5766 5758 5767 1947 5766 1949 1949 5766 5767 5758 4619 4618 1949 5767 1965 1965 5767 5750 1948 1947 1949 1949 1965 1948 1948 1965 1966 1965 5750 1966 1948 1966 1924 1948 1924 5830 5830 5843 1948 1948 5843 5844 1948 5844 5839 1924 1923 5829 5830 1924 5829 5830 5829 5825 5825 5842 5830 5830 5842 5843 5847 5844 5843 5847 5843 5842 5848 5839 5844 5848 5844 5847 5842 5841 5847 5847 5841 5840 5825 5841 5842 5825 5829 5826 5825 5826 4746 5840 5841 5825 4742 4744 5826 5829 5827 5826 5826 5827 5828 5826 5828 4742 4746 5826 4744 4744 4745 4746 4745 4747 4746 4746 4747 4748 4742 4743 4744 4744 4743 4745 4767 4747 4745 4767 4745 4743 4748 4747 4767 4748 4767 4768 4743 4764 4767 4768 4767 4764 4742 4741 4743 4741 4764 4743 4764 4765 4766 4741 4765 4764 4768 4764 4761 4761 4764 4766 4752 4768 4761 4761 4762 4763 4761 4766 4762 4752 4761 4753 4753 4761 4763 4766 4776 4762 4762 4776 4777 4762 4777 4763 4753 4763 2965 4775 2965 4763 4763 4777 4778 4763 4778 4775 2862 4752 4753 2862 4753 2965 2964 2860 2965 2965 2860 2862 2964 2965 4775 4778 4792 4775 4775 4792 2962 4775 2962 2964 4777 4792 4778 4777 4791 4792 4787 2962 4792 4787 4792 4789 4789 4792 4791 2910 2961 2962 2962 2961 2963 2962 2963 2964 2910 2962 4787 2964 2963 2860 4866 2963 2961 2860 2963 4866 2910 2960 2961 4866 2961 4864 4864 2961 4865 4865 2961 2960 2860 4866 4883 4866 4864 4883 4863 4864 4865 4883 4864 4863 4863 4865 4867 4865 2960 4871 4867 4865 4869 4869 4865 4871 4883 4863 4884 4867 4884 4863 4869 4870 4867 4870 4884 4867 4870 4885 4884 4885 4896 4884 4896 4897 4884 4884 4897 4898 4884 4898 4883 4869 4868 4870 4868 4885 4870 4868 3014 4885 3014 3016 4885 4885 3016 4896 4896 3016 3022 4914 4897 4896 4896 3022 4914 4914 4898 4897 4883 4898 4899 4899 4898 4914 4914 3022 3020 4914 3020 4916 4899 4914 4915 4915 4914 4916 4883 4899 4892 4915 4892 4899 4883 4892 2860 2860 4892 4893 4915 4893 4892 4915 4916 4918 4918 2930 4915 4915 2930 4893 4893 4894 2860 4893 2930 4894 2860 2861 2862 2860 4894 4895 2860 4895 2861 4894 2930 2929 4894 2929 4895 4895 2929 2861 2929 2930 2931 2931 2966 2929 2929 2966 2967 2929 2967 2861 2931 2930 2940 4845 4843 2931 2931 4843 2966 2931 2940 4845 4843 4840 2966 2966 4840 2967 2861 2967 2968 2968 2967 4824 4824 2967 4840 4824 4840 4825 4825 4840 4826 4826 4840 4841 4843 4841 4840 4842 4841 4843 4845 4842 4843 4826 4841 4827 4827 4841 2858 4842 2858 4841 2856 2858 4842 4844 2856 4842 4844 4842 4845 2856 2857 2858 2858 2857 2859 2858 2859 2855 4827 2858 2855 2700 2701 2856 2856 2701 2857 2700 2856 4844 5711 2859 2857 5711 2857 5710 5710 2857 2701 2855 2859 2854 5712 2854 2859 5712 2859 5711 2854 2848 2855 4827 2855 2848 2849 2848 2854 5697 5683 2854 2854 5683 2849 5697 2854 5712 5711 5705 5712 5712 5705 5696 5712 5696 5697 5696 5684 5697 5697 5684 5683 2849 5683 5680 5680 5683 5684 5680 5684 5682 5682 5684 5685 5696 5685 5684 5695 5685 5696 5705 5695 5696 5682 5685 5681 5695 5681 5685 5681 2053 5682 5687 5680 5682 5687 5682 2023 2023 5682 2053 2054 2053 5681 5694 2054 5681 5694 5681 5695 5694 5695 5705 2049 2054 5694 5705 2049 5694 2045 2053 2054 2045 2054 2049 2052 2023 2053 2052 2053 2045 2024 2023 2052 2052 2045 6166 2024 2052 6166 1974 2023 2024 2024 6166 6173 6173 1974 2024 6166 2045 6165 6166 6165 6161 6173 6166 6161 6173 6161 6174 6174 6169 6173 6173 6169 1974 6174 6161 6175 6175 6171 6174 6174 6171 6169 6168 1974 6169 6168 6169 6170 6170 6169 6171 6170 6171 4968 4968 6171 2596 6175 2596 6171 6175 6161 2592 6175 2592 2594 2594 2596 6175 2594 2595 2596 2596 2595 2597 2596 2597 4968 4968 2597 4969 4968 4969 4970 4970 6170 4968 2597 4989 4969 2595 4989 2597 4970 4969 4971 4969 4989 4988 4969 4988 4971 4970 4971 4972 4970 4972 6167 6167 6170 4970 4972 4971 4973 4971 4988 4991 4991 4973 4971 4972 4973 4974 4974 6167 4972 6167 6168 6170 1958 1974 6168 1958 1960 1974 1974 1960 1975 5675 1975 1960 5675 1960 5676 5676 1960 5672 1974 1975 1976 5674 1976 1975 5674 1975 5675 5676 5679 5675 5675 5679 5673 5675 5673 5674 5676 5672 5677 5677 5678 5676 5676 5678 5679 5678 2833 5679 5679 2833 2831 5679 2831 5673 5677 2821 5678 5678 2821 2833 2832 2831 2833 2832 2833 2820 2820 2833 2821 2830 2829 2831 2830 2831 2832 5673 2831 2829 2820 4760 2832 2832 4760 4770 2832 4770 2830 2820 2821 2822 2822 4760 2820 4770 4760 4757 2830 4770 4773 2828 2829 2830 2830 4773 2828 2828 2827 2829 5673 2829 2827 2826 2827 2828 2828 4773 4774 2828 4774 2826 4773 4772 4774 4781 2826 4774 4781 4774 4782 4782 4774 4772 2827 2826 2834 2834 2826 2835 2835 2826 4781 2837 2835 4781 4783 2837 4781 4783 4781 4784 4784 4781 4782 4782 4772 2899 4784 4782 2897 2897 4782 2899 4786 4783 4784 4786 4784 2895 2895 4784 2897 2839 2837 4783 4785 2839 4783 4785 4783 4786 4793 4786 2895 4786 4793 4785 2867 2894 2895 2867 2895 2896 2896 2895 2897 2895 2894 4793 4793 2894 2866 4793 2866 4794 4785 4793 4794 2866 2894 2867 2866 2867 2868 2868 2867 2869 4794 2866 2868 4794 2868 4795 4785 4794 4797 4797 4794 4795 2868 2869 2870 4795 2868 2870 2870 2869 2871 2870 2871 2872 4795 2870 4796 2870 2872 4796 4797 4795 4798 4798 4795 4796 2841 4785 4797 2841 4797 2846 2846 4797 4798 4798 4796 4799 2846 4798 2844 2844 4798 4799 4796 2872 4816 4796 4816 4799 2844 4799 2842 4799 4816 4817 4799 4817 2842 2842 2843 2844 2844 2843 2845 2844 2845 2846 2846 2845 2847 2846 2847 2841 2845 2843 5668 2847 2845 5666 5666 2845 5668 2842 2853 2843 5668 2843 5669 2843 2853 5669 5668 5669 5670 5666 5668 5667 5667 5668 5670 2840 2847 5666 2840 5666 5663 5663 5666 5667 2841 2847 2840 2838 2839 2840 2840 2839 2841 2838 2840 5658 5658 2840 5663 5658 5663 5664 5664 5663 5665 5663 5667 5665 2836 2838 5658 5659 2836 5658 5659 5658 5661 5661 5658 5664 2836 2837 2838 2838 2837 2839 2841 2839 4785 2836 2835 2837 2834 2835 2836 2834 2836 5659 2827 2834 5659 2827 5659 5660 5660 5659 5661 5673 2827 5660 5660 5661 5662 5674 5673 5660 5674 5660 5662 5662 5661 2000 5662 2000 1999 5662 1999 1976 5662 1976 5674 1974 1999 2000 1974 2000 2001 5661 5664 2000 2000 5664 2001 1976 1999 1974 2001 2013 1974 1974 2013 2014 1974 2014 2015 2015 2022 1974 1974 2022 2023 5664 5665 2001 2001 5665 2013 5665 2014 2013 5665 5667 2014 5667 5670 2014 2014 5670 2015 5670 5671 2015 2015 5671 2022 5671 5687 2022 2022 5687 2023 5670 5669 5671 5669 5686 5671 5671 5686 5687 5686 5680 5687 2853 2851 5686 5686 2851 5680 5669 2853 5686 5680 2851 2849 2850 2849 2851 2850 2851 2852 2852 2851 2853 2852 2853 2842 4817 4807 2852 2852 4807 2850 2842 4817 2852 2848 2849 2850 2848 2850 4806 4806 2850 4807 2848 4806 4827 4806 4807 4808 4827 4806 4808 4827 4808 4826 4808 4807 4809 4826 4808 4809 4813 4825 4826 4813 4826 4814 4826 4809 4814 4807 4814 4809 4807 4813 4814 4812 4811 4813 4812 4813 4807 4811 4825 4813 4811 4824 4825 4810 4811 4812 4810 4824 4811 4815 2968 4824 4815 4824 4810 4810 4812 4815 4815 4812 2938 4815 2938 2939 2939 2968 4815 2861 2968 2939 2938 2861 2939 2872 2861 2938 2872 2938 4816 4816 2938 4812 2872 2862 2861 2872 2871 2873 2872 2873 2874 2874 2862 2872 2874 4727 2862 4727 4752 2862 4726 4725 2874 2874 4725 4727 2873 4726 2874 4727 4725 4752 4752 4725 4724 4752 4724 4731 4724 4725 4726 4726 4731 4724 4816 4812 4817 4817 4812 4807 4973 4975 4974 4974 4975 4976 4974 4976 2598 4991 4975 4973 4976 4975 4991 2598 4976 4977 4992 4977 4976 4976 4991 4992 2598 2599 2600 2598 4977 2599 2599 4977 4978 4978 4977 4992 2600 2599 2601 2601 2599 4965 4965 2599 4978 4940 2600 2601 2601 4941 4940 4953 4941 2601 2601 4965 4953 4953 4965 4966 4965 4978 4966 4966 4978 4979 4978 4992 4979 4953 4966 4964 4964 4966 4967 4966 4979 4967 4941 4953 4954 4954 4953 4964 4940 4941 4942 4954 4942 4941 4940 4942 4943 4942 4944 4943 4944 4942 4954 4944 4954 4945 4945 4954 4955 4954 4964 4955 4943 4944 4945 4943 4945 4946 4946 4945 4947 4945 4955 4947 4947 4955 4950 4950 4955 4956 4955 4964 4960 4955 4960 4956 4950 4951 4947 4947 4951 4952 4947 4952 4946 4948 4949 4950 4950 4949 4951 4950 4956 4948 4948 4956 4957 4956 4960 4961 4956 4961 4957 2603 2602 4948 4948 2602 4949 4948 4957 2603 2602 6140 4949 4949 6140 6154 4949 6154 4951 4951 6154 4952 6136 6139 6140 6136 6140 6135 6135 6140 6134 6134 6140 2602 2602 2603 2604 6134 2602 2604 2604 2606 6134 6134 2606 6123 6134 6123 6135 6135 6123 6124 6135 6124 6136 6123 2606 4998 6124 6123 6125 6123 4998 6125 2604 2605 2606 2606 2605 2607 4998 2606 2607 2604 2603 2605 4957 4982 2605 4957 2605 2603 2607 2605 4994 4994 2605 4982 2607 4999 4998 5022 4999 2607 2607 4994 5022 4994 4982 4995 5022 4994 4995 4961 4982 4957 4961 4984 4982 4995 4982 4984 4995 4984 4996 5022 4995 5023 5023 4995 4996 4999 5022 5014 5014 5022 5023 4998 4999 5000 5014 5000 4999 5003 5014 5015 5003 5002 5014 5014 5002 5000 5014 5023 5015 4998 5000 5001 5000 5002 5001 6125 4998 5001 5001 5002 5003 5001 5003 5004 6125 5001 6127 5001 5004 6127 5004 5003 5005 5015 5005 5003 5005 5010 5004 6127 5004 5010 6127 5010 6128 6126 6125 6127 6126 6127 6129 6129 6127 6128 6124 6125 6126 1915 6124 6126 1915 6126 1913 1913 6126 6129 6129 6128 6130 1913 6129 1902 1902 6129 6130 1913 1914 1915 1913 1902 1914 1915 1914 1916 6136 6124 1915 6136 1915 1916 1916 1914 6139 1916 6139 6136 1904 1902 1929 1929 1902 1930 1902 6130 1930 2402 1904 1929 1929 1930 1931 2402 1929 2403 2403 1929 1931 1931 1930 1932 1930 6130 6112 1930 6112 1932 1931 1932 1933 2403 1931 2404 2404 1931 1933 2481 2402 2403 2481 2403 2482 2482 2403 2404 2480 2402 2481 2171 2480 2481 2171 2481 2169 2169 2481 2482 2482 2404 2483 2169 2482 2166 2166 2482 2483 2404 1933 2405 2483 2404 2405 2483 2405 2484 2166 2483 2164 2164 2483 2484 2164 2165 2166 2165 2167 2166 2166 2167 2168 2166 2168 2169 2155 2163 2164 2164 2163 2165 2164 2484 2155 2167 2165 2325 2325 2165 2163 2324 2168 2167 2324 2167 2325 2169 2168 2170 2323 2170 2168 2323 2168 2324 1581 2323 2324 1581 2324 1582 1582 2324 2325 2322 2172 2323 2172 2170 2323 1585 2322 2323 1585 2323 1581 2169 2170 2171 2170 2172 2171 2171 2172 2173 2322 2173 2172 1584 2322 1585 1580 1584 1585 1580 1585 1581 1580 1581 1577 1550 1580 1577 1577 1578 1574 1577 1581 1582 1577 1582 1578 1577 1574 1550 1574 1578 1579 1582 2325 1578 1578 2325 2326 1578 2326 1579 1574 1575 1571 1574 1579 1575 1550 1574 1571 1579 2326 2327 1579 2327 1575 2325 2163 2326 2326 2163 2327 2163 2162 2327 2327 2162 2154 2327 2154 2161 2161 2329 2327 1575 2327 2329 1571 1575 1576 1575 2329 1576 2161 2328 2329 1576 2329 2328 2156 2160 2161 2156 2161 2154 2160 2328 2161 2154 2155 2156 2154 2162 2155 2155 2162 2163 2155 2484 2485 2155 2485 2156 2159 2160 2156 2156 2485 2486 2156 2486 2159 2159 2158 2160 2160 2158 2328 2148 2158 2159 2159 2486 2487 2159 2487 2148 2485 2407 2486 2486 2407 2408 2486 2408 2487 2484 2406 2485 2485 2406 2407 2484 2405 2406 2405 1950 2406 2406 1950 1917 2406 1917 2407 1917 2061 2407 2407 2061 2073 2407 2073 2408 1917 2060 2061 2060 2073 2061 2060 2072 2073 2408 2073 2072 1917 2059 2060 2063 2072 2060 2060 2059 6056 6056 6045 2060 2060 6045 2063 2063 2071 2072 2408 2072 2409 2409 2072 2071 2062 2071 2063 2409 2071 2410 2410 2071 2062 2487 2408 2409 2487 2409 2488 2488 2409 2410 2410 2062 2411 2488 2410 2489 2489 2410 2411 2062 2063 2064 2411 2062 2064 2411 2064 2412 2489 2411 2490 2490 2411 2412 2146 2488 2489 2146 2489 2144 2144 2489 2490 2148 2487 2488 2148 2488 2146 2144 2145 2146 2146 2145 2147 2146 2147 2148 2151 2152 2144 2144 2152 2153 2144 2153 2145 2144 2490 2151 2331 2147 2145 2331 2145 2153 2147 2157 2148 2157 2147 2331 2148 2157 2158 2328 2158 2157 2328 2157 2330 2330 2157 2331 1576 2328 1572 1572 2328 2330 1572 2330 1573 1573 2330 2331 1571 1572 1568 1568 1572 1573 1571 1576 1572 1568 1573 1569 1573 2331 1569 1568 1569 1565 1568 1565 1562 1568 1562 1571 1565 1569 1570 1569 2331 2333 1569 2333 1570 1565 1566 1562 1565 1570 1566 1570 2333 2332 1570 2332 1566 2153 2332 2333 2153 2333 2331 2152 2332 2153 2152 2150 2332 2332 2150 2149 2332 2149 2334 1566 2332 2334 1562 1566 1567 1566 2334 1567 2334 2149 2335 1567 2334 2335 2137 2149 2138 2138 2149 2150 2149 2137 2335 2138 2150 2151 2151 2150 2152 2136 2137 2138 2151 2491 2138 2138 2491 2492 2138 2492 2136 2136 2135 2137 2335 2137 2135 2134 2135 2136 2136 2492 2493 2136 2493 2134 2491 2413 2492 2492 2413 2414 2492 2414 2493 2493 2414 2415 2493 2415 2494 2134 2493 2494 2413 2068 2414 2414 2068 2070 2414 2070 2415 2412 2066 2413 2413 2066 2068 2491 2412 2413 2066 2067 2068 2068 2067 2069 2068 2069 2070 2070 2069 2074 2070 2074 2075 2415 2070 2075 6035 6033 2069 2069 6033 2074 2067 6035 2069 2066 2065 2067 6041 6035 2067 2065 6041 2067 6034 6032 6035 6035 6032 6033 6041 6034 6035 6032 6031 6033 6033 6031 6030 6033 6030 2074 2636 2638 6032 6032 2638 6031 6034 2636 6032 2631 2636 6034 6040 2631 6034 6040 6034 6041 2631 2630 2636 2636 2630 2637 2636 2637 2638 2630 2631 2632 2632 2631 2633 2633 2631 6040 6042 2633 6040 6042 6040 6043 6043 6040 6041 2632 2633 2634 2634 2633 2635 2635 2633 6042 6044 2635 6042 6044 6042 6045 6045 6042 6043 6043 6041 2065 6045 6043 2063 2063 6043 2065 6056 6044 6045 2625 2635 6044 6057 2625 6044 6057 6044 6056 2634 2635 2624 2624 2635 2625 2624 2625 2626 2626 2625 2627 2627 2625 6057 6058 2627 6057 6058 6057 6059 6059 6057 6056 6059 6056 2058 2058 6056 2059 6061 6058 6059 6061 6059 1955 1955 6059 2058 2629 2627 6058 6060 2629 6058 6060 6058 6061 6064 6060 6061 6064 6061 6069 6069 6061 1955 1919 1954 1955 1955 2058 1919 6069 1955 1954 1919 2058 2059 1919 2059 1917 1917 1918 1919 1950 1951 1917 1917 1951 1952 1917 1952 1918 1918 1952 6104 1919 1918 6085 6085 1918 6104 1952 1951 6100 6104 1952 6100 6104 6100 6099 6085 6104 6086 6086 6104 6099 1934 1919 6085 1934 6085 6082 6082 6085 6086 1919 1934 1935 6082 1935 1934 1935 1953 1919 1919 1953 1954 6068 1953 1935 6082 6068 1935 6081 6068 6082 6082 6086 6081 6066 6067 6068 6068 6067 1953 6081 6066 6068 6067 6069 1953 1953 6069 1954 6066 6065 6067 6065 6064 6067 6067 6064 6069 2616 6065 6066 6080 2616 6066 6080 6066 6081 6081 6086 6080 2614 2616 6080 6080 6086 2612 6080 2612 2614 5043 2612 6086 6086 6099 5043 2612 2613 2614 2613 2612 5050 5050 2612 5043 2614 2613 2615 2614 2615 2616 5063 5064 2613 2613 5050 5063 5064 2615 2613 5050 5043 5051 5063 5050 5051 5051 5043 5042 5063 5051 5067 5067 5051 5042 5042 5043 5044 5067 5042 5044 5044 5046 5067 5067 5046 5060 5067 5060 5063 5044 5043 5045 5044 5045 5046 5046 5045 5047 5046 5047 5048 5046 5048 5060 5047 5045 6099 5043 6099 5045 5048 5047 5049 6099 6102 5047 5047 6102 5049 5048 5049 2611 5039 5060 5048 5039 5048 2611 2611 5049 2610 6102 6103 5049 5049 6103 2610 6100 6101 6102 6102 6101 6103 6099 6100 6102 2608 2610 6103 2608 6103 6111 6111 6103 6101 2608 2609 2610 2610 2609 2611 2611 2609 5039 2609 2608 5006 5016 5017 2609 2609 5006 5016 5039 2609 5017 5006 2608 5007 2608 6111 5007 5006 5007 5008 5016 5006 5008 5016 5008 5015 5015 5020 5016 5016 5020 5021 5016 5021 5017 5039 5017 5040 5040 5017 5021 5020 5019 5021 5040 5021 5041 5041 5021 5019 5041 5066 5040 5040 5066 5060 5040 5060 5039 5041 5019 5038 5038 5066 5041 5018 5019 5020 5038 5019 5018 2651 2650 5038 5038 5018 2651 2650 5065 5038 5038 5065 5066 2651 5018 4993 4993 5018 5020 2649 2650 2651 2651 2652 2649 2652 2651 4993 2650 2649 5089 5089 5065 2650 5061 5066 5065 5089 5061 5065 5088 5061 5089 2649 2654 5089 5089 2654 5103 5089 5103 5088 2649 2652 2653 2649 2653 2654 2653 2679 2654 5108 2654 2679 2653 2678 2679 5108 2679 5109 5109 2679 2678 5109 5104 5108 5104 5109 5101 5109 2678 5111 5101 5109 5110 5110 5109 5111 2672 2678 2653 5111 2678 2672 5111 2672 5112 5110 5111 5114 5114 5111 5112 5110 5102 5101 5102 5110 2617 2617 5110 5114 5114 5112 5115 2617 5114 2622 2622 5114 5115 5112 2672 2671 5112 2671 5113 5115 5112 5113 2653 2671 2672 2653 2677 2671 2677 5113 2671 5115 5113 5116 5124 5116 5113 5124 5113 2677 2622 5115 2620 2620 5115 5116 2620 5116 2618 5123 2618 5116 5123 5116 5124 5126 5123 5124 5126 5124 2676 2676 5124 2677 2666 2676 2677 2666 2677 2653 2665 2676 2666 2665 5126 2676 5125 5123 5126 5128 5125 5126 5128 5126 2665 2628 2618 5123 5125 2628 5123 2626 2628 5125 5127 2626 5125 5127 5125 5128 5137 5127 5128 5137 5128 2667 2667 5128 2665 2665 2666 2657 2657 2667 2665 2657 2656 2667 2656 5137 2667 5136 5127 5137 5139 5136 5137 5139 5137 2656 2624 2626 5127 5136 2624 5127 2626 2627 2628 2628 2627 2629 2628 2629 2618 2618 2629 2619 2619 2629 6060 2618 2619 2620 2620 2619 2621 6064 2621 2619 2619 6060 6064 2620 2621 2622 2622 2621 2623 2623 2621 6065 6065 2621 6064 2622 2623 2617 2617 2623 2616 2616 2623 6065 2616 2615 2617 2615 5102 2617 5064 5086 2615 5086 5101 2615 2615 5101 5102 5063 5062 5064 5062 5086 5064 5062 5085 5086 5085 5101 5086 5087 5104 5101 5087 5101 5085 5085 5062 5087 5061 5062 5063 5087 5062 5061 5063 5060 5066 5063 5066 5061 5087 5061 5088 5088 5104 5087 5088 5103 5104 2634 2624 5136 2632 2634 5138 5138 2634 5136 5138 5136 5139 5140 2632 5138 5140 5138 5141 5141 5138 5139 2630 2632 5140 2637 2630 5140 5161 2637 5140 5161 5140 5141 5141 5139 2655 5163 5161 5141 5163 5141 2655 2655 5139 2656 2655 2656 2657 2657 2675 2655 2655 2675 5163 5162 5161 5163 5163 2675 2674 5163 2674 5162 5160 2637 5161 5162 5160 5161 5157 5160 5162 5162 2674 2673 5162 2673 5157 2668 2673 2674 2668 2674 2657 2657 2674 2675 2670 2673 2668 2673 2670 5159 5157 2673 5159 2668 2669 2670 5159 2670 2669 5157 5159 5158 5174 5158 5159 5159 2669 5174 2669 2668 2680 5174 2669 2680 5153 5158 5174 5174 2680 5176 5153 5174 5175 5175 5174 5176 5157 5158 5153 5153 5154 5155 5153 5155 5157 5175 5154 5153 5155 5154 5156 5175 5156 5154 5155 5156 5152 5152 5156 5175 5175 5176 5179 5152 5175 2647 2647 5175 5179 5152 2639 2641 5152 2641 5155 2647 2639 5152 2645 2646 2647 2647 2646 2648 2647 2648 2639 2647 5179 2645 2639 2640 2641 2639 2648 2640 2641 2640 2638 2641 2638 2642 5155 2641 2642 6016 2640 2648 6031 2638 2640 2640 6016 6031 6016 2648 6021 6021 2648 2646 6021 6022 6016 6031 6016 6022 6031 6022 6030 6021 6020 6022 6030 6022 6020 6019 6020 6021 6021 2646 6024 6019 6021 6017 6017 6021 6024 6030 6020 6019 6019 6018 6030 6030 6018 2076 2074 6030 2076 6017 6018 6019 6017 6024 6027 6027 2080 6017 6017 2080 6023 6017 6023 6018 2076 6018 6023 2080 2077 6023 2076 6023 2077 2077 2080 2078 2078 2080 2081 6027 2081 2080 6027 6024 6025 6027 6025 6028 6028 2081 6027 2078 2081 2082 2082 2081 2083 6028 2083 2081 6028 6025 6026 6028 6026 6029 6029 2083 6028 6024 2644 6025 6025 2644 2539 6025 2539 6026 2539 2541 6026 6026 2541 6036 6026 6036 6029 6029 2084 2083 6029 6036 6038 6029 6038 2084 2082 2083 2084 2082 2084 2085 2084 6038 2085 6036 6037 6038 6038 6037 6039 6038 6039 2085 2541 2543 6036 6036 2543 6037 6039 6037 6046 5221 6046 6037 5221 6037 2543 2085 6039 2087 2087 6039 6047 6039 6046 6047 2082 2085 2086 2086 2085 2087 2086 2087 2088 2088 2087 2089 2087 6047 2089 6047 6046 6050 6047 6050 6052 2089 6047 6052 2088 2089 2090 2090 2089 2091 2089 6052 2091 2420 2086 2088 2420 2088 2421 2421 2088 2090 2419 2086 2420 2498 2419 2420 2498 2420 2499 2499 2420 2421 2421 2090 2422 2499 2421 2500 2500 2421 2422 2131 2498 2499 2131 2499 2123 2123 2499 2500 2497 2419 2498 2124 2497 2498 2124 2498 2131 2123 2130 2131 2131 2130 2132 2131 2132 2124 2124 2125 2126 2124 2132 2133 2124 2133 2125 2126 2497 2124 2340 2133 2132 2340 2132 2341 2132 2130 2341 2123 2129 2130 2341 2130 2129 2341 2129 2342 1558 2340 2341 1558 2341 1554 1554 2341 2342 2339 2133 2340 1557 2339 2340 1557 2340 1558 2339 2125 2133 2338 2127 2339 2127 2125 2339 1561 2338 2339 1561 2339 1557 1556 1557 1553 1553 1557 1558 1556 1561 1557 1553 1558 1554 1553 1554 1550 1550 1571 1553 1553 1571 1556 1559 1560 1556 1556 1560 1561 1571 1559 1556 1560 2338 1561 1559 1564 1560 1564 2336 1560 1560 2336 2338 1562 1563 1559 1559 1563 1564 1571 1562 1559 1563 2337 1564 1564 2337 2336 1562 1567 1563 1567 2335 1563 1563 2335 2337 2143 2336 2337 2143 2337 2335 2335 2135 2143 2134 2142 2143 2134 2143 2135 2142 2336 2143 2141 2142 2134 2134 2494 2141 2141 2140 2142 2142 2140 2336 2128 2140 2141 2141 2494 2495 2141 2495 2128 2494 2415 2416 2494 2416 2495 2495 2416 2417 2495 2417 2496 2128 2495 2496 2415 2075 2416 2416 2075 2079 2416 2079 2417 2417 2079 2078 2417 2078 2418 2496 2417 2418 2496 2418 2497 2128 2496 2126 2126 2496 2497 2418 2078 2082 2418 2082 2419 2497 2418 2419 2077 2078 2076 2076 2078 2079 2076 2079 2075 2075 2074 2076 2419 2082 2086 2126 2125 2127 2126 2127 2128 2127 2139 2128 2338 2139 2127 2128 2139 2140 2336 2140 2139 2336 2139 2338 1550 1551 1547 1550 1554 1555 1550 1555 1551 1547 1551 1552 1555 2343 1551 1551 2343 2344 1551 2344 1552 1547 1548 1544 1547 1552 1548 1552 2344 2345 1552 2345 1548 2343 2308 2344 2344 2308 2307 2344 2307 2345 2345 2307 2305 2345 2305 2346 1548 2345 2346 1544 1548 1549 1548 2346 1549 2306 2305 2307 2306 2307 2119 2119 2307 2308 2119 2308 2120 2343 2120 2308 2119 2120 2121 2121 2501 2119 2119 2501 2502 2119 2502 2306 2306 2502 2503 2501 2423 2502 2502 2423 2424 2502 2424 2503 2500 2422 2501 2501 2422 2423 2121 2500 2501 2422 2109 2423 2423 2109 2108 2423 2108 2424 2424 2108 2105 2105 2108 2096 2096 2108 2109 2096 2109 2097 2422 2097 2109 2090 2097 2422 2096 2097 2098 2098 2097 2090 2096 2098 5276 2098 2090 2099 2098 2099 5272 5276 2098 5272 2090 2091 1630 2099 2090 1630 2099 1630 1612 5272 2099 5273 5273 2099 1612 5272 5273 5274 5276 5272 5271 5271 5272 5274 5259 5276 5271 3926 3924 5271 5271 5274 3926 5259 5271 3922 3922 5271 3924 5274 5273 5275 5274 5275 3928 3926 5274 3928 3925 3924 3926 3925 3926 3927 3927 3926 3928 3923 3922 3924 3923 3924 3925 3925 3927 3954 3923 3925 3953 3953 3925 3954 3927 3928 3540 3959 3954 3927 3959 3927 3540 3540 3928 3539 3928 5275 3539 3539 3538 3540 3540 3538 3959 3958 3954 3959 3959 3538 3964 3959 3964 3958 3537 3538 3539 3538 3537 3948 3963 3964 3538 3538 3948 3963 3537 3539 5275 3948 3537 3949 3537 5275 5284 3537 5284 3949 3948 3949 3950 3963 3948 3950 3950 3949 3951 3949 5284 5303 3949 5303 3951 5284 5275 5273 5284 5273 5285 5305 5303 5284 5305 5284 5285 5302 3952 5303 3951 5303 3952 5304 5302 5303 5304 5303 5305 3950 3951 3947 3947 3951 3952 3947 3952 3946 5302 3946 3952 3946 3945 3947 3962 3950 3947 3962 3947 3945 3943 3945 3946 3943 3946 5302 3943 3944 3945 3945 3961 3962 3945 3944 3961 3941 3942 3943 3942 3944 3943 5300 3941 3943 5300 3943 5302 3961 3944 3942 3941 3940 3942 3961 3942 3940 3940 3969 3961 3961 3969 3970 3961 3970 3962 3535 3536 3940 3535 3940 3941 3969 3940 3536 3536 3935 3969 3969 3935 3936 3969 3936 3970 3535 3534 3536 3536 3534 3935 3533 3534 3535 5298 3535 3941 3533 3535 5298 3534 3533 3900 3534 3900 3917 3935 3534 3917 3935 3917 3936 3917 3900 3916 3917 3916 3918 3936 3917 3918 3900 3533 3893 3900 3893 3901 3916 3900 3901 3901 3893 3892 3901 3892 3915 3901 3915 3916 3892 3893 3894 3915 3892 3894 3896 3914 3915 3915 3894 3896 3916 3915 3914 3894 3893 3895 3894 3895 3896 3896 3895 3897 3896 3897 3898 3898 3914 3896 3914 3891 3888 3898 3891 3914 3916 3914 3913 3913 3914 3888 3898 3897 3899 3898 3899 3647 3647 3891 3898 3645 3888 3891 3645 3891 3647 3646 3645 3647 3647 3899 3646 5327 5328 3899 3899 5328 3646 3897 5327 3899 3644 3645 3646 3644 3646 5336 5336 3646 5328 3644 3643 3645 3858 3645 3643 3858 3888 3645 3642 3643 3644 5336 3642 3644 5336 5328 5337 5337 5359 5336 5336 5359 3642 3640 3641 3642 3642 3641 3643 3640 3642 5354 5354 3642 5359 3634 3633 3640 3640 3633 3641 3634 3640 5354 3861 3643 3641 3861 3641 3867 3867 3641 3633 3633 3634 3635 3635 3843 3633 3867 3633 3868 3868 3633 3843 3864 3861 3867 3864 3867 3869 3869 3867 3868 3868 3843 3840 3869 3868 3870 3870 3868 3840 3842 3840 3843 3635 3842 3843 3839 3689 3840 3842 3839 3840 3870 3840 3689 3689 3688 3870 3870 3688 3664 3870 3664 3869 3869 3664 3662 3869 3662 3864 3663 3662 3664 3663 3664 3665 3664 3688 3665 3665 3688 3689 3665 3689 3690 3690 3689 3691 3839 3691 3689 3845 3663 3665 3845 3665 3853 3853 3665 3690 3690 3691 3692 3853 3690 3854 3854 3690 3692 3692 3691 3693 3838 3693 3691 3838 3691 3839 3692 3693 3694 3854 3692 3855 3855 3692 3694 3849 3853 3854 3849 3854 3856 3856 3854 3855 3855 3694 3830 3835 3828 3830 3835 3830 3694 3834 3828 3835 3694 3683 3835 3835 3683 3681 3835 3681 3834 3834 3833 3828 3832 3833 3834 3834 3681 3679 3834 3679 3832 3680 3679 3681 3680 3681 3682 3682 3681 3683 3667 3678 3679 3667 3679 3680 3679 3678 3804 3832 3679 3804 3827 3667 3680 3827 3680 3826 3826 3680 3682 3666 3678 3667 3804 3678 3666 3807 3806 3804 3804 3666 3807 3832 3804 3806 3805 3806 3807 3805 3807 3810 3832 3806 3805 3810 3811 3805 3805 3811 3831 3805 3831 3832 3810 3809 3811 3831 3811 3809 3832 3831 3833 3683 3696 3682 3682 3696 3823 3826 3682 3817 3817 3682 3823 3694 3695 3683 3683 3695 3696 3823 3696 3695 3817 3823 3818 3823 3695 3818 3817 3818 3819 3819 3821 3817 3817 3821 3824 3817 3824 3826 3826 3824 3825 3826 3825 3827 3821 3632 3824 3824 3632 3631 3824 3631 3825 3825 3631 3625 3825 3625 3802 3827 3825 3802 3630 3625 3631 3630 3631 3629 3629 3631 3632 3629 3632 3628 3821 3628 3632 3628 3627 3629 5366 5381 3629 5366 3629 3627 3630 3629 5377 5377 3629 5381 3624 3625 3630 3624 3630 5377 3624 5377 5378 5378 5377 5379 5377 5381 5379 5362 5376 5381 5362 5381 5366 5379 5381 5376 5378 5379 5380 5380 5379 1735 5379 5376 1735 3624 5378 5385 5385 5378 5380 5380 1735 1808 5385 5380 5386 5386 5380 1808 1735 1736 1737 1737 1808 1735 1735 5376 1736 1773 1736 5376 1773 5376 5362 1737 1736 1772 1772 1736 1773 1772 1773 1764 1764 1773 1774 1774 1773 5362 5403 5401 1772 1772 5401 1737 1764 5403 1772 5402 5400 5403 5403 5400 5401 5405 5402 5403 5405 5403 1764 5400 5390 5401 5401 5390 5391 5401 5391 1737 3614 3616 5400 5400 3616 5390 5402 3614 5400 3616 3618 5390 5390 3618 5388 5390 5388 5391 5391 5388 5389 5391 5389 1769 1737 5391 1769 1769 1771 1737 1737 1771 1808 1769 1770 1771 1769 5389 1770 5388 5384 5389 5389 5384 5387 5389 5387 1770 3618 3620 5388 5388 3620 5384 3620 3622 5384 3622 3624 5384 5384 3624 5385 5384 5385 5387 5387 5385 5386 5387 5386 1771 1770 5387 1771 1771 5386 1808 3622 3623 3624 3624 3623 3625 3620 3621 3622 3622 3621 3623 3618 3619 3620 3620 3619 3621 3616 3617 3618 3618 3617 3619 3614 3615 3616 3616 3615 3617 3612 3613 3614 3614 3613 3615 3612 3614 5402 3615 3613 3788 5404 3612 5402 5404 5402 5405 3610 3612 5404 5415 3610 5404 5417 5415 5404 5417 5404 5405 1734 5417 5405 1734 5405 1764 5416 5415 5417 1733 5416 5417 1733 5417 1734 5416 5414 5415 5413 5414 5416 1732 5413 5416 1732 5416 1733 1703 1732 1733 1703 1733 1734 1764 1703 1734 1648 1702 1703 1702 1732 1703 1764 1763 1703 5341 1648 1703 1703 1763 5341 1732 1702 5406 5406 5413 1732 1648 1701 1702 1702 1701 5406 5406 1701 5399 5399 5410 5406 5406 5410 5413 1620 1701 1648 1620 5399 1701 5399 5409 5410 5413 5410 5409 5409 5408 5412 5409 5412 5413 5413 5412 5414 5412 5408 5407 1618 1619 1620 1618 1620 1648 1619 1639 1620 1618 1648 5325 1619 1618 5329 5329 1618 5325 1639 1619 5316 5316 1619 5329 5316 1640 1639 5315 5299 5316 5316 5299 1640 5316 5329 5315 5329 5325 5324 5315 5329 5324 3533 5298 5315 5315 5298 5299 3893 3533 5315 5315 5324 3893 5299 5298 5300 1640 5299 5301 5299 5300 5301 1640 5301 1642 5301 5300 5302 5301 5302 5304 1642 5301 5304 5298 3941 5300 1642 5304 1643 1643 5304 5305 1672 1686 1643 1686 1694 1643 1643 1694 1695 1643 5305 1672 1672 5305 5285 5285 5273 1612 5285 1612 1711 1672 5285 1711 1612 1670 1711 1711 1670 1672 1670 1671 1672 1612 1710 1670 1710 5531 1670 1670 5531 5517 1670 5517 1671 1672 1671 1673 5517 5514 1671 1671 5514 1673 5516 5515 5517 5517 5515 5514 5531 5516 5517 1674 1673 5514 1674 5514 5504 5504 5514 5515 1672 1673 1674 1672 1674 1686 5502 1686 1674 5502 1674 5503 5503 1674 5504 5503 5504 5505 5504 5515 5505 5505 5515 3331 5516 3331 5515 5503 5505 5506 5505 3335 3344 5505 3344 5506 5505 3331 3335 5503 5506 5502 5502 5506 5507 5506 3344 3342 5506 3342 5507 3343 3342 3344 3343 3344 3334 3334 3344 3335 3334 3335 3336 3336 3335 3331 3334 3336 4028 4038 3343 3334 3334 4028 4038 3341 3342 3343 3341 3343 4040 4040 3343 4038 3341 3340 3342 5507 3342 3340 3339 3340 3341 3339 3341 4042 4042 3341 4040 4040 4038 4041 4042 4040 4043 4043 4040 4041 4048 3339 4042 4048 4042 4049 4049 4042 4043 3349 3350 3339 3339 3350 3340 3349 3339 4048 4050 3349 4048 4050 4048 4051 4051 4048 4049 4049 4043 3443 4051 4049 3441 3441 4049 3443 4053 4050 4051 4053 4051 3447 3447 4051 3441 3347 3349 4050 4052 3347 4050 4052 4050 4053 4064 4052 4053 4064 4053 4065 4065 4053 3447 3440 3446 3447 3440 3447 3441 4065 3447 3446 4067 4064 4065 4067 4065 3458 3458 4065 3446 3445 3446 3440 3445 3458 3446 3445 3457 3458 3457 4067 3458 4066 4064 4067 4069 4066 4067 4069 4067 3457 3456 3455 3457 3456 3457 3445 3457 3455 4076 3457 4076 4077 3454 3455 3456 3445 4058 3456 4058 3454 3456 3454 3453 3455 3455 3453 4076 4077 4076 4078 4076 3453 4082 4076 4082 4078 4077 4078 4068 4078 4082 4080 4081 4080 4082 4081 4082 3451 3451 4082 3453 3452 3451 3453 3452 3453 3454 3450 3449 3451 3450 3451 3452 4081 3451 3449 3450 3452 4070 3452 3454 4070 3450 4070 4071 4071 4070 4072 4070 3454 4075 4070 4075 4072 4058 4075 3454 4075 4056 4055 4075 4055 4074 4056 4075 4058 4072 4075 4074 3445 4056 4058 4055 4056 4057 4057 4056 3445 4055 4057 4059 4074 4055 4059 4074 4060 4061 4074 4059 4060 4072 4074 3302 3302 4074 4061 4059 4057 4054 4059 4054 4060 4063 4054 4057 4063 4057 3440 3440 4057 3445 4062 4054 4063 4046 4062 4063 4046 4063 3442 3442 4063 3440 3440 3441 3442 3442 3441 3443 3442 3443 3437 4046 3442 3437 3437 3443 3444 3443 4043 3444 3437 3438 3434 3437 3444 3438 3437 3434 4046 4043 4041 3444 3444 4041 3438 3434 3438 3439 4041 4039 3438 3438 4039 3439 3434 3435 3433 3434 3439 3435 4045 3434 3433 4046 3434 4045 4039 3435 3439 4038 4029 4039 4039 4029 3435 4041 4038 4039 3433 3435 3436 4029 4027 3435 3435 4027 3436 4028 4026 4029 4029 4026 4027 4038 4028 4029 4026 4025 4027 4027 4025 4024 4027 4024 3436 3433 3436 3431 3436 4024 3431 4002 3431 4024 4002 4024 4003 4003 4024 3990 3990 4024 4025 3990 4025 3991 3991 4025 3337 4026 3337 4025 3990 3991 3992 3990 3992 4004 4004 4003 3990 3993 4002 4003 4004 3993 4003 3993 3432 4002 3432 3431 4002 3431 3432 3433 3995 3432 3993 3433 3432 4023 4023 3432 3995 3993 3994 3995 4005 3994 3993 4005 3993 4004 4004 3992 4001 4004 4001 4005 4005 4001 4000 4005 4000 4006 4006 3994 4005 3981 4000 4001 3981 4001 3982 3982 4001 3983 3983 4001 3992 3972 3981 3974 3974 3981 3982 3972 3989 3981 3989 4000 3981 3974 3982 3977 3977 3982 3983 3977 3983 3980 3983 3992 3980 3980 3992 3991 3333 3977 3980 3333 3980 3338 3980 3991 3338 3991 3337 3338 3337 3333 3338 3331 3332 3333 3337 3331 3333 3333 3332 3975 3975 3977 3333 3336 3331 3337 3336 3337 4026 3332 3331 5516 3332 5516 5522 5522 3975 3332 3975 3976 3977 5522 3976 3975 5528 3976 5522 5530 5528 5522 5530 5522 5531 5531 5522 5516 3977 3976 3978 5528 3978 3976 3977 3978 3974 3974 3978 3979 5527 3979 3978 5527 3978 5528 5529 5527 5528 5529 5528 5530 5525 3973 5527 3973 3979 5527 5526 5525 5527 5526 5527 5529 3974 3979 3973 3973 3972 3974 3971 3972 3973 5525 3971 3973 5524 5523 5525 5523 3971 5525 5524 5525 5526 1849 5524 5526 1849 5526 1741 1741 5526 5529 5542 5523 5524 5542 5524 5543 5543 5524 1849 5523 3330 3971 3329 3330 5523 3329 5523 5542 3329 5542 5546 5553 5546 5542 5553 5542 5543 5543 1849 1811 1778 5553 5543 1778 5543 1811 5552 5546 5553 1777 5552 5553 1777 5553 1778 1708 1777 1778 1811 1812 1778 1778 1812 1813 1778 1813 1708 1708 1776 1777 1776 5552 1777 5550 5551 5552 5552 5551 5546 1776 5550 5552 1707 1776 1708 1707 1846 1776 1846 5550 1776 1846 5548 5550 5548 5549 5550 5550 5549 5551 1707 1845 1846 1845 5548 1846 5548 5547 5549 5566 5547 5548 5566 5548 1845 5547 4008 5549 5549 4008 4014 5549 4014 5551 5547 3319 4008 5564 3319 5547 5564 5547 5566 5565 5564 5566 5565 5566 5567 5567 5566 1845 3324 3320 5564 3324 5564 3316 3316 5564 5565 3320 3319 5564 3318 3319 3320 4008 3319 3318 3322 3318 3320 3322 3320 3323 3320 3324 3323 3323 3324 3316 3323 3316 3317 3323 3317 4044 4044 4047 3323 3323 4047 3322 3321 3318 3322 3321 3322 4036 4036 3322 4047 4008 3318 4013 4013 3318 3321 4013 3321 4016 4036 4016 3321 4035 4031 4036 4036 4031 4016 4047 4035 4036 4016 4017 4013 4017 4016 4031 4035 4033 4031 4030 4017 4031 4030 4031 4037 4037 4031 4033 4034 4033 4035 4047 4034 4035 4032 4033 4034 4045 4032 4034 4045 4034 4047 4044 4045 4047 3433 4032 4045 4046 4045 4044 3433 4023 4032 4032 4023 4033 4023 3995 4022 4022 4033 4023 3995 3994 3996 4022 3995 3996 3997 4021 4022 4022 3996 3997 4021 4037 4022 4037 4033 4022 3996 3994 3997 3997 3994 3998 4006 3998 3994 3997 3998 3999 3999 4020 3997 3997 4020 4021 4020 4037 4021 4015 4030 4037 4015 4037 4007 4020 4007 4037 3999 3325 4020 3325 4007 4020 3326 3999 3984 3984 3999 3998 3326 3325 3999 3984 3998 4006 3326 3984 3328 3328 3984 3985 4006 3985 3984 3325 3326 3327 3327 3326 3328 4007 3325 3327 4015 4007 4011 4011 4007 3327 3327 3328 3329 4011 3327 4009 4009 3327 3329 3329 3328 3330 5546 4009 3329 4009 4010 4011 5546 4010 4009 5551 4010 5546 4011 4010 4012 5551 4012 4010 4014 4012 5551 4011 4012 4013 4013 4012 4014 4013 4014 4008 4013 4017 4018 4013 4018 4011 4018 4017 4030 4011 4018 4019 4019 4018 4030 4011 4019 4015 4019 4030 4015 3330 3328 3971 3971 3328 3972 3328 3985 3986 3986 3987 3328 3328 3987 3988 3328 3988 3972 3972 3988 3989 3989 3988 4000 4000 3988 3987 4000 3987 3986 4000 3986 3985 4006 4000 3985 3317 3315 4044 4044 3315 4062 4044 4062 4046 3316 3315 3317 3314 3313 3315 3314 3315 3316 3315 3313 4062 4062 3313 4054 3312 3311 3313 3312 3313 3314 3313 3311 4054 5573 3312 3314 5573 3314 3316 5573 3316 5565 5575 5579 5573 5575 5573 5574 5574 5573 5565 5579 3312 5573 3310 3311 3312 5579 3310 3312 3310 3300 3311 3311 3300 4054 3301 3300 3310 5578 3301 3310 5578 3310 5579 5576 5578 5579 5576 5579 5575 5577 5578 5576 5577 3301 5578 3300 3301 3302 3302 3301 3303 3303 3301 5587 5587 3301 5577 4054 3300 4061 3302 4061 3300 3302 3303 3304 3302 3304 4072 3304 3303 3305 5587 3305 3303 3304 3305 3306 4072 3304 3306 4071 4072 4073 4072 3306 4073 3306 3305 3307 3306 3307 3308 4073 3306 3308 5587 3307 3305 3307 3309 3308 5592 3309 3307 5592 3307 5587 3308 3309 3298 3308 3298 3299 4073 3308 3299 5591 3298 3309 5591 3309 5592 5590 5591 5592 5590 5592 5589 5589 5592 5587 5589 5587 5588 5588 5587 5577 5588 1840 5589 5589 1840 1838 5589 1838 5590 5590 1838 5586 5590 5586 5591 1837 1836 1838 1837 1838 1839 1839 1838 1840 1838 1836 5586 5588 1839 1840 5572 1839 5588 5588 5577 5572 5576 5572 5577 1841 1837 5572 5576 1841 5572 5572 1837 1839 5575 1841 5576 1841 1842 1707 1841 1707 1837 5575 1842 1841 5574 1842 5575 1707 1842 1843 5574 1843 1842 5567 1843 5574 5574 5565 5567 1707 1843 1844 5567 1844 1843 5567 1845 1844 1844 1845 1707 1706 1707 1708 1837 1707 1862 1707 1706 5599 5601 1862 1707 5601 1707 5599 1835 1836 1837 1837 1862 1835 5600 1835 1862 5600 1862 5601 5599 5603 5601 5601 5603 5604 5601 5604 5600 1836 1835 5600 5600 5604 5586 5600 5586 1836 5603 3296 5604 5604 3296 5591 5604 5591 5586 5599 5602 5603 5602 3294 5603 5603 3294 3296 3294 3295 3296 3296 3295 3297 3296 3297 3298 3296 3298 5591 3292 3293 3294 3294 3293 3295 5602 3292 3294 3290 3291 3292 3292 3291 3293 3290 3292 5602 4086 3295 3293 3293 3291 4086 3290 3289 3291 3291 3289 4099 4086 3291 4099 4084 4085 4086 4086 4085 3295 4086 4099 4084 4099 3289 4097 4099 4097 4100 4084 4099 4100 3520 4083 4084 4084 4083 4085 4084 4100 3520 4087 3295 4085 4087 4085 4088 4088 4085 4083 3520 3462 4083 4088 4083 3460 3460 4083 3462 4071 4087 4088 4071 4088 3450 3450 4088 3460 3459 3450 3460 3459 3460 3461 3461 3460 3462 3461 3462 3463 3463 3462 3519 3519 3462 3520 4094 4092 3461 3461 4092 3459 3463 4094 3461 4102 4094 3463 3519 4102 3463 3519 3520 3521 4104 4102 3519 3521 4104 3519 3521 3520 3522 3520 4100 3522 3521 3522 3523 4106 4104 3521 3521 3523 4115 3521 4115 4106 4103 4101 4104 4104 4101 4102 4106 4103 4104 4105 4103 4106 4106 4115 4116 4106 4116 4105 4118 4116 4115 4118 4115 3525 3525 4115 3523 4105 4116 3383 4117 3383 4116 4117 4116 4118 3375 3374 4105 4105 3374 4103 4105 3383 3375 3381 3382 3383 3383 3382 3384 3383 3384 3375 3381 3383 4117 4119 3381 4117 4119 4117 4120 4120 4117 4118 3379 3380 3381 3381 3380 3382 3379 3381 4119 3380 3379 3385 3385 3379 3386 3386 3379 4129 4129 3379 4119 3380 3385 5418 3382 3380 5418 3386 3392 3385 5418 3385 5419 3385 3392 5419 3391 3392 3386 4129 3391 3386 4129 4119 4130 4130 4142 4129 4129 4142 3391 3389 3390 3391 3391 3390 3392 3389 3391 4143 4143 3391 4142 5419 3392 5433 3390 5433 3392 5419 5420 5418 5433 5420 5419 5418 5420 5421 5433 5421 5420 5418 5421 5422 5421 5423 5422 5423 5421 5433 5422 5423 5424 5422 5424 1745 5427 5432 5422 5427 5422 1745 5432 5418 5422 5423 5433 5424 1745 5424 5425 5424 5433 5434 5424 5434 5425 1745 5425 1743 5425 5434 1870 5425 1870 1743 5435 1870 5434 5435 5434 5436 5436 5434 5433 1743 1870 1744 1744 1870 1871 1871 1870 5435 1743 1744 1745 1745 1744 1746 1745 1746 5427 1744 1676 1746 5427 1746 1676 5427 1676 5428 5428 5432 5427 1675 1650 1676 1675 1676 1677 1744 1677 1676 5428 1676 1650 5428 1650 5426 5426 5431 5428 5428 5431 5432 5431 3382 5432 5432 3382 5418 5426 5430 5431 5430 3384 5431 5431 3384 3382 5429 5430 5426 5429 3376 5430 5430 3376 3384 3375 3384 3376 3374 3375 3376 3378 3374 3376 5429 3378 3376 5426 5440 5429 5429 5440 3378 3373 3374 3378 3373 3378 5441 5441 3378 5440 3373 3377 3374 3374 3377 4103 3373 3371 3372 3372 3377 3373 3371 3373 5443 5443 3373 5441 5441 5440 5442 5443 5441 5444 5444 5441 5442 5451 3371 5443 5451 5443 5456 5456 5443 5444 5444 5442 1800 5456 5444 1799 1799 5444 1800 5442 5440 5439 5442 5439 1803 1800 5442 1803 5426 5439 5440 1649 1801 5439 1649 5439 5426 1803 5439 1801 1801 1802 1803 1803 1802 1804 1803 1804 1800 1649 1651 1801 1801 1651 1802 1649 1650 1651 1650 1649 5426 1651 1650 1675 1677 5936 1675 1751 1750 1677 1751 1677 1744 1750 5935 1677 1677 5935 5936 5935 5933 5936 1750 5931 5935 1749 1748 1750 1749 1750 1751 1748 5931 1750 1751 1744 5857 1749 1751 5857 5857 1744 5856 5857 5856 5850 1749 5857 5860 5860 5857 5850 1744 1872 5856 5856 1872 5852 5856 5852 5851 5850 5856 5851 1744 1871 1872 1872 1871 1873 1872 1873 1874 1872 1874 5852 5852 1874 5853 5852 5853 5854 5851 5852 5854 1874 1873 1875 1874 1875 1740 5859 5853 1874 5859 1874 1740 1873 1871 5437 1875 1873 5437 5437 1871 5435 5437 5435 5438 5449 1875 5437 5449 5437 5438 5438 5435 5436 5438 5436 3388 3388 3398 5438 5438 3398 5450 5438 5450 5449 5448 1875 5449 5449 5450 5447 5449 5447 5448 3396 5447 5450 3396 5450 3398 3397 3396 3398 3397 3398 3387 3387 3398 3388 3395 3394 3396 3395 3396 3397 3394 5447 3396 3394 5446 5447 5448 5447 5446 3393 3394 3395 3394 3393 3404 3394 3404 5446 3397 4157 3395 3395 4157 4158 3395 4158 3393 3404 3393 3405 3405 3393 4165 4165 3393 4158 3404 3405 3403 3403 5462 3404 5446 3404 5462 3403 3405 3406 3406 3405 4165 4165 4158 4166 4167 3406 4165 4167 4165 4168 4168 4165 4166 3403 3406 3401 3401 3406 4167 4169 3401 4167 4169 4167 4170 4170 4167 4168 4168 4166 3505 4170 4168 3504 3504 4168 3505 4182 4169 4170 4182 4170 3502 3502 4170 3504 3399 3401 4169 4181 3399 4169 4181 4169 4182 4184 4181 4182 4184 4182 3500 3500 4182 3502 3501 3500 3502 3501 3502 3503 3503 3502 3504 3499 3498 3500 3499 3500 3501 3498 4184 3500 4183 4181 4184 4186 4183 4184 4186 4184 3498 3497 3496 3498 3497 3498 3499 4197 4198 3498 3498 3496 4197 3495 3496 3497 3499 4175 3497 3495 3497 4175 3495 3494 3496 4197 3496 3494 4197 3494 4200 4198 4197 4199 4199 4197 4200 4199 4185 4198 4199 4200 4203 4185 4199 3414 3414 4199 4203 4200 3494 3492 4200 3492 4201 4203 4200 4201 3493 3492 3494 3493 3494 3495 3491 3490 3492 3491 3492 3493 4201 3492 3490 4201 3490 4202 4203 4201 4204 4204 4201 4202 3489 3466 3490 3489 3490 3491 3490 3466 4214 3490 4214 4202 4204 4202 4205 4202 4214 4215 4202 4215 4205 3419 4203 4204 3419 4204 3417 3417 4204 4205 3417 4205 3415 4205 4215 3425 4205 3425 3415 4216 3425 4215 4216 4215 4217 4217 4215 4214 3423 3424 3425 3425 3424 3426 3425 3426 3415 3423 3425 4216 3415 3416 3417 3415 3426 3416 5486 3416 3426 5486 3426 5498 5498 3426 3424 3423 3422 3424 5498 3424 5499 5499 3424 3422 5488 5486 5498 5488 5498 5497 5497 5498 5499 5485 3416 5486 5485 5486 5487 5487 5486 5488 5487 5488 1878 1878 5488 1879 1880 1879 5488 5497 1880 5488 5496 1881 5497 5497 1881 1880 5497 5499 5496 1879 1880 1612 1612 1880 1881 1612 1878 1879 1612 1877 1878 1877 5487 1878 5484 5485 5487 5484 5487 1877 1830 1877 1612 5471 5484 1877 5471 1877 1830 5472 5483 5484 5472 5484 5471 5483 5485 5484 5471 1830 1829 5472 5471 5473 5471 1829 5473 1612 1829 1830 1612 1828 1829 5473 1829 1828 5473 1828 5474 5472 5473 5475 5475 5473 5474 1740 1828 1612 1740 1853 1828 5474 1828 1853 5474 1853 5457 5475 5474 5476 5476 5474 5457 3411 5472 5475 3411 5475 3409 3409 5475 5476 5476 5457 5459 3409 5476 3407 3407 5476 5459 3407 3408 3409 3409 3408 3410 3409 3410 3411 3400 3399 3407 3407 3399 3408 3407 5459 3400 5458 3400 5459 5460 5458 5459 5460 5459 5457 3399 3400 3401 3401 3400 3402 3402 3400 5458 3408 3399 4181 3410 3408 4181 4183 3410 4181 3412 3410 4183 4185 3412 4183 4185 4183 4186 3411 3410 3412 3411 3412 3413 3413 3412 3414 3414 3412 4185 3413 5472 3411 3414 3420 3413 3413 3420 5483 3413 5483 5472 3419 3420 3414 3414 4203 3419 3419 3418 3420 3420 3418 5483 5483 3418 5485 3417 3416 3418 3417 3418 3419 3418 3416 5485 3402 5458 3403 3403 5458 5462 5461 5462 5458 5461 5458 5460 3401 3402 3403 5457 1852 5460 5460 1852 1827 5460 1827 5461 5461 1827 5445 5461 5445 5446 5446 5462 5461 1826 1827 1740 1827 1852 1740 1827 1826 5445 1740 1852 1853 5457 1853 1852 1612 1739 1740 1740 1875 1876 1740 1876 1826 1739 5859 1740 5445 1826 1876 5445 1876 5448 5448 1876 1875 5448 5446 5445 5858 5853 5859 5870 5858 5859 1739 5870 5859 1612 1738 1739 1738 5870 1739 5869 5868 5870 5870 5868 5858 1738 5869 5870 1614 1738 1612 1614 5869 1738 5866 5867 5869 5869 5867 5868 1614 5866 5869 1612 1613 1614 1614 1613 1615 1614 1615 1616 1616 5866 1614 1616 5864 5866 5864 5865 5866 5866 5865 5867 1616 1615 1617 5879 5864 1616 5879 1616 1617 1617 1615 5886 1613 5886 1615 1617 5886 5879 5878 5864 5879 5879 5886 5887 5879 5887 5878 5864 5863 5865 5878 5863 5864 5877 5863 5878 5878 5887 5877 5863 3065 4506 5863 4506 5865 5877 3065 5863 3063 3065 5877 5877 5887 3061 5877 3061 3063 3063 3064 3065 3065 3064 3066 4506 3065 3066 3061 3062 3063 3063 3062 3064 3062 3061 4570 4570 3061 4571 3061 5887 4571 4576 3064 3062 3062 4570 4576 3066 3064 4546 4546 3064 4557 4576 4557 3064 4575 4557 4576 4576 4570 4603 4576 4603 4575 4570 4571 4572 4572 4603 4570 4575 4603 4595 4599 4595 4603 4599 4603 4572 4572 4571 4573 4572 4573 4569 4572 4569 4599 4600 4598 4599 4600 4599 4567 4567 4599 4569 4598 4595 4599 4568 4567 4569 4569 4573 4574 4569 4574 4568 4571 5907 4573 4573 5907 4574 5906 4568 4574 5906 4574 5907 4565 4567 4568 4565 4568 5906 4565 4566 4567 4567 4566 4600 4562 4564 4565 4564 4566 4565 5904 4562 4565 5904 4565 5906 5905 5904 5906 5905 5906 5908 5908 5906 5907 5903 5902 5904 5902 4562 5904 5903 5904 5905 1638 5903 5905 1638 5905 1610 1610 5905 5908 5908 5907 5909 1610 5908 1611 1611 5908 5909 1610 1611 1612 1612 1638 1610 1612 1611 1613 1611 5909 1613 5909 5907 5887 5909 5887 5886 1613 5909 5886 4571 5887 5907 1704 1705 1612 1709 1710 1612 1709 1612 1741 1741 1612 1705 1612 1831 1832 1612 1833 1834 1832 1854 1612 1612 1854 1855 1612 1855 1833 1834 1856 1612 1612 1856 1857 1612 1857 1704 1612 1881 1831 1612 1630 1638 5511 1856 1834 5511 5520 1856 1856 5520 1857 5520 5521 1857 1857 5521 1704 1704 5521 5535 1704 5535 1705 5520 5519 5521 5521 5519 5534 5521 5534 5535 5518 5519 5520 5511 5518 5520 5518 3217 5519 5519 3217 4266 5519 4266 5534 5534 4266 4268 5534 4268 5536 5535 5534 5536 3217 3219 4266 4266 3219 4267 4266 4267 4268 4268 4267 4269 4268 4269 5536 5536 4269 4271 5536 4271 5537 5535 5536 5538 5538 5536 5537 4269 4267 4270 4269 4270 4271 4270 4273 4271 4271 4273 4272 5537 4271 4272 5537 4272 5533 5538 5537 5539 5539 5537 5533 1705 5535 5538 1705 5538 1742 1742 5538 5539 5539 5533 5540 1742 5539 1847 1847 5539 5540 1741 1705 1742 1742 1847 1741 1741 1847 1848 1847 5540 1848 5540 5533 5532 5540 5532 5541 1848 5540 5541 1741 1848 1849 1849 1848 1850 1848 5541 1850 1741 5529 1709 1709 5529 5530 1709 5530 1710 1710 5530 5531 1849 1850 1811 1811 1850 1851 5541 1851 1850 1811 1851 1812 5541 5545 1851 1851 5545 5555 1851 5555 1812 1812 5555 5560 1812 5560 1813 5545 5554 5555 5555 5554 5558 5555 5558 5560 5532 5544 5545 5532 5545 5541 5545 5544 5554 4235 5558 5554 4235 5554 4236 4236 5554 5544 4241 5557 5558 4241 5558 4235 5560 5558 5557 4234 4235 3223 3223 4235 4236 4234 4241 4235 3223 4236 3221 4236 5544 3221 3221 3222 3223 3223 3222 3224 3223 3224 3225 4247 4234 3223 4247 3223 3225 3222 3221 5544 3222 5544 5532 4274 3224 3222 3222 5532 5533 5533 4274 3222 4272 4273 4274 4274 4273 3224 5533 4272 4274 4275 4276 4273 4273 4276 4277 4273 4277 3224 4270 4275 4273 4279 4275 4270 4294 4276 4275 4294 4275 4279 4277 4276 4294 3224 4277 4278 4295 4278 4277 4277 4294 4295 4279 4293 4294 4295 4294 4293 4279 4270 4280 4280 4293 4279 4280 4270 4267 4280 4267 4281 4281 4292 4280 4280 4292 4293 4295 4293 4297 4297 4293 4292 4292 4256 4258 4281 4256 4292 4297 4292 4291 4291 4292 4258 4281 4267 3219 4281 3219 3220 3220 4256 4281 4256 3220 3218 4259 4258 4256 4256 3218 4259 4257 4258 4259 4291 4258 4257 4259 3218 3216 4259 3216 4262 4257 4259 4260 4260 4259 4262 3217 3216 3218 3217 3218 3219 3219 3218 3220 3212 3215 3216 3212 3216 3217 4262 3216 3215 4262 3215 4263 4260 4262 4264 4264 4262 4263 3214 3215 3212 3215 3214 4232 4263 3215 4232 4263 4232 4233 4264 4263 4265 4265 4263 4233 4265 3482 4264 4264 3482 3508 4264 3508 4260 4265 4233 3471 3471 3483 4265 4265 3483 3482 4232 4230 4233 4233 4230 4231 4233 4231 3471 3469 3470 3471 3471 3470 3472 3472 3483 3471 3471 4231 3469 3472 3482 3483 3481 3482 3472 3481 3472 4220 4220 3472 3470 3469 3468 3470 4220 3470 4224 4224 3470 3468 4220 4221 3481 4221 4220 4222 4222 4220 4224 3481 3506 3482 4221 4255 3481 3481 4255 3506 4222 4223 4221 4223 4254 4221 4221 4254 4255 4222 4224 4226 4223 4222 3227 3227 4222 4226 3227 3229 4223 4223 3229 4254 3229 3233 4254 4254 3233 4251 4254 4251 4255 4255 4251 4249 4255 4249 3506 4250 4249 4251 4250 4251 4252 4252 4251 4253 4253 4251 3233 3229 3232 3233 3233 3232 3234 4253 3233 3234 3234 4242 4253 4253 4242 4285 4253 4285 4252 4252 4285 4286 4252 4286 4250 4248 4249 4250 4250 4286 4248 3509 3507 4248 4248 3507 4249 3509 4248 4287 4287 4248 4286 3508 3507 3509 3508 3509 3510 3510 3509 4290 4290 3509 4287 3482 3506 3507 3482 3507 3508 3506 4249 3507 4260 3508 3510 4260 3510 4261 4261 3510 4290 4261 4290 4291 4291 4290 4296 4290 4287 4296 4260 4261 4257 4291 4257 4261 4291 4296 4297 4300 4297 4296 4296 4287 4288 4296 4288 4300 4299 4295 4297 4299 4297 4300 4300 4288 4289 4300 4289 4299 4287 4286 4288 4288 4286 4289 4286 4283 4289 4289 4283 4284 4284 4298 4289 4299 4289 4298 4298 4295 4299 4298 4278 4295 3226 4278 4298 4284 3226 4298 4283 3225 4284 3225 3226 4284 4282 4247 4283 4283 4247 3225 4286 4282 4283 4285 4282 4286 4242 4246 4285 4285 4246 4282 3232 4239 4242 3232 4242 3234 4239 4246 4242 4239 4245 4246 4246 4245 4282 4234 4244 4245 4234 4245 4239 4245 4244 4282 4239 4240 4234 4234 4240 4241 4243 4244 4234 4243 4234 4247 4282 4244 4243 4282 4243 4247 4240 5557 4241 4239 4238 4240 4238 5556 4240 4240 5556 5557 5560 5557 5561 5561 5557 5556 1813 5560 5561 5561 5556 5562 1813 5561 1708 1708 5561 5562 5562 5556 5559 5562 5559 5563 1708 5562 1786 1786 5562 5563 5556 3231 5559 3231 3230 5559 5559 3230 5570 5559 5570 5563 1786 5563 1784 5563 5570 5568 5563 5568 1784 5569 5568 5570 5569 5570 5571 5571 5570 3230 3229 3228 3230 3230 3231 3229 5571 3230 3228 3228 3235 5571 5571 3235 5584 5571 5584 5569 1864 5568 5569 5569 5584 5585 5569 5585 1864 3235 3237 5584 5584 3237 5582 5584 5582 5585 3228 3227 3235 3235 3227 3236 3235 3236 3237 3227 3228 3229 3229 3231 3232 3232 3231 4237 5556 4237 3231 4237 4239 3232 4237 4238 4239 4238 4237 5556 3227 4226 3236 4226 4224 4225 4226 4225 4227 3236 4226 4227 4224 3468 4225 4225 3468 3480 4225 3480 4207 4227 4225 4207 4227 4207 4209 3236 4227 3238 3238 4227 4209 4206 4207 3480 4208 4209 4207 4207 4206 4208 4209 4208 3240 3238 4209 3240 3237 3236 3238 3237 3238 3239 3239 3238 3240 3239 3240 3241 3241 3240 3242 3240 4208 4212 3240 4212 3242 4208 4206 4210 4208 4210 4212 4212 4210 4211 4212 4211 4213 3242 4212 4213 3241 3242 3243 3243 3242 3244 3242 4213 3244 4213 4211 4193 4213 4193 4192 3244 4213 4192 4210 3465 4211 4211 3465 3464 4211 3464 4193 4191 4192 4193 4196 4191 4193 4196 4193 3464 4191 3246 4192 3244 4192 3246 3243 3244 3245 3245 3244 3246 3245 3246 3251 3251 3246 3252 4190 3252 3246 4190 3246 4191 4195 4190 4191 4195 4191 4196 4189 3252 4190 4194 4189 4190 4194 4190 4195 3251 3252 3250 3250 3252 3253 4189 3253 3252 4188 3253 4189 4187 4188 4189 4187 4189 4194 4195 3493 4194 4194 3493 3495 4194 3495 4187 4187 4173 4172 4172 4188 4187 4187 3495 4175 4187 4175 4173 4172 4173 4174 4174 4173 3499 3499 4173 4175 4172 4174 4176 4172 4176 4188 4176 4174 4171 4180 4171 4174 4180 4174 3501 3501 4174 3499 4176 4171 4177 4188 4176 4177 4171 4178 4177 4188 4177 4178 4178 3249 4188 4188 3249 3253 4171 3247 4178 4178 3247 3249 3247 3248 3249 3249 3248 3250 3250 3253 3249 3248 3247 3254 3254 3247 3255 3255 3247 4171 5612 3250 3248 3254 5612 3248 5612 5609 3250 3251 3250 5613 5613 3250 5609 5607 5609 5612 5622 5607 5612 3254 5622 5612 5607 5608 5609 5608 5607 5622 5608 5622 5610 5610 5622 5623 5621 5623 5622 5621 5622 3254 5609 5608 5610 5609 5610 5606 5606 5610 5611 5610 5623 5611 5605 1884 5606 5606 5611 5605 5614 5609 5606 5614 5606 1891 1891 5606 1884 5611 5623 5605 1882 1884 5605 5605 5623 1883 5605 1883 1882 1865 1882 1883 1882 1865 1884 1883 1887 1865 1887 1883 5624 5624 1883 5623 1865 1887 1888 1888 1887 5625 5625 1887 5624 5624 5623 5621 5625 5624 5626 5626 5624 5621 1863 1888 5625 5637 1863 5625 5625 5626 5638 5625 5638 5637 1865 1888 1863 1863 1864 1865 1864 1863 1818 1818 1863 1866 5637 1866 1863 5636 1866 5637 5637 5638 5639 5637 5639 5636 5626 3262 5638 5638 3262 3264 5638 3264 5639 5636 5639 5640 5639 3264 3266 5639 3266 5640 5635 1816 5636 5636 1816 1866 5636 5640 5635 1818 1866 1816 1816 1817 1818 5635 1817 1816 1824 1817 5635 5651 1824 5635 5653 5651 5635 5653 5635 5640 3268 5653 5640 3268 5640 3266 5652 5651 5653 3270 5652 5653 3270 5653 3268 5650 1819 5651 5651 1819 1824 5652 5650 5651 1784 1817 1824 1784 1824 1819 1818 1817 1784 1864 1818 5568 1784 5568 1818 1864 5585 1865 5585 5582 5580 5585 5580 1865 1884 1865 1885 1865 5580 1885 1886 1885 5580 1886 5580 5581 5581 5580 5582 5581 5582 5583 5583 5582 3237 5583 5597 5581 5581 5597 5598 5581 5598 1886 1884 1885 1886 1886 1889 1884 1886 5598 1889 5597 5595 5598 5598 5595 5593 5598 5593 1889 3241 3243 5597 5597 3243 5595 5583 3241 5597 5594 5593 5595 5594 5595 5596 5596 5595 3243 1892 1890 5593 1892 5593 5594 1889 5593 1890 1884 1889 1890 1884 1890 1891 1891 1890 1892 5594 5614 1892 1892 5614 1891 5596 5613 5594 5594 5613 5614 5613 5609 5614 5596 3251 5613 3245 3251 5596 5596 3243 3245 3239 3241 5583 5583 3237 3239 1782 1783 1784 1784 1783 1785 1784 1785 1786 1819 1820 1784 1784 1820 1782 5657 5654 1783 1783 5654 1785 1782 5657 1783 1785 1795 1786 1795 1785 5646 5646 1785 5654 1786 1795 1796 1786 1796 1708 5646 1796 1795 5645 5627 5646 5646 5627 1796 5654 5645 5646 1708 1796 1797 1797 1796 5627 5630 1797 5627 5630 5627 5631 5644 5631 5627 5644 5627 5645 5654 5644 5645 5643 5631 5644 5655 5643 5644 5655 5644 5654 5642 5631 5643 5642 5643 5655 5641 5631 5642 5642 5655 5641 5641 5655 3276 5656 3276 5655 5656 5655 5657 5657 5655 5654 3278 3280 5641 5641 3280 5631 5641 3276 3278 3276 3277 3278 3278 3277 3279 3278 3279 3280 3280 3279 3281 3280 3281 3282 5631 3280 5632 5632 3280 3282 3281 3279 4112 4112 3279 4127 3279 3277 4127 3282 3281 3283 4112 3283 3281 3282 3283 3284 5632 3282 5633 5633 3282 3284 5631 5632 5630 5630 5632 5633 5630 5633 5629 5629 5633 5634 5633 3284 5634 5629 1797 5630 5628 1779 5629 5629 1779 1797 5629 5634 5628 5628 5634 5617 5634 3284 5618 5634 5618 5617 1781 1780 5628 5628 1780 1779 5628 5617 1781 1779 1780 1708 1708 1797 1779 1708 1780 1781 1781 1814 1708 5616 1814 1781 5616 1781 5617 5617 5618 5619 5617 5619 5616 5615 1814 5616 5616 5619 5620 5616 5620 5615 1708 1814 1815 5615 1815 1814 1708 1815 1706 1706 1815 5615 5615 5620 5599 5615 5599 1706 5619 3290 5620 5620 3290 5602 5620 5602 5599 5618 3288 5619 5619 3288 3290 3288 3289 3290 3286 3287 3288 3288 3287 3289 5618 3286 3288 3284 3286 5618 3284 3285 3286 3286 3285 3287 4098 3289 3287 3287 3285 4098 4098 4097 3289 4096 4097 4098 4098 3285 4113 4098 4113 4096 3284 3283 3285 3285 3283 4113 4113 3283 4111 4113 4111 4114 4096 4113 4114 3526 4095 4096 4096 4095 4097 4096 4114 3526 4100 4097 4095 3526 3524 4095 4100 4095 3522 3522 4095 3524 3523 3522 3524 3523 3524 3525 3525 3524 3526 3525 3526 3527 3527 4118 3525 4120 4118 3527 4132 4119 4120 4132 4120 4133 4133 4120 4134 4134 4120 3527 4131 4119 4132 4142 4131 4132 4142 4132 4141 4141 4132 4133 4130 4119 4131 4130 4131 4142 4143 4142 4144 4144 4142 4141 4134 3518 4141 4141 4133 4134 4144 4141 3516 3516 4141 3518 4146 4143 4144 4146 4144 3514 3514 4144 3516 4145 3389 4143 4145 4143 4146 3514 3512 4146 4146 3512 3511 4146 3511 4153 4145 4146 4153 3513 3512 3514 3513 3514 3515 3515 3514 3516 3488 3511 3512 3488 3512 3513 3486 3511 3488 4153 3511 3486 4153 3486 4154 4145 4153 4156 4156 4153 4154 3485 3484 3486 3485 3486 3487 3487 3486 3488 4154 3486 3484 4154 3484 4155 4156 4154 4157 4157 4154 4155 3387 4145 4156 3387 4156 3397 3397 4156 4157 4157 4155 4158 4166 4158 4155 4166 4155 3473 3473 4155 3484 3505 4166 3473 3473 3474 3475 3473 3484 3474 3475 3505 3473 3475 3504 3505 3503 3504 3475 3503 3475 4159 3474 4159 3475 3474 3484 3485 4164 4159 3474 3485 4164 3474 3503 4159 4160 4160 4159 4161 4164 4161 4159 4160 4180 3503 3503 4180 3501 4160 4161 4162 4162 4179 4160 4160 4179 4180 4162 4161 3263 4163 3263 4161 4163 4161 4164 4162 3263 3261 3261 3259 4162 4162 3259 4179 3259 3257 4179 4179 3257 4171 4179 4171 4180 3258 3257 3259 3258 3259 3260 3260 3259 3261 3260 3261 3262 3262 3261 3263 5626 5621 3260 3260 5621 3258 5626 3260 3262 3256 3257 3258 3256 3258 5621 3256 3255 3257 3257 3255 4171 3254 3255 3256 3256 5621 3254 3262 3263 3264 3264 3263 3265 3265 3263 4163 3264 3265 3266 3266 3265 3267 3267 3265 4150 4150 3265 4163 4150 4163 4148 4148 4163 4164 4148 4149 4150 4150 4149 3269 4150 3269 3267 3266 3267 3268 3268 3267 3269 3268 3269 3270 3270 3269 3271 3271 3269 4151 4151 3269 4149 4148 4147 4149 4151 4149 4152 4152 4149 4147 4138 3271 4151 4138 4151 4136 4136 4151 4152 3270 3271 3272 3272 3271 3273 3273 3271 4138 3272 5652 3270 3272 3273 3274 5648 5647 3272 3272 5647 5652 3272 3274 5648 3274 3273 3275 4138 3275 3273 3274 3275 3276 3274 3276 5656 5648 3274 5656 5647 5648 5649 5648 5656 5649 5647 5649 5650 5647 5650 5652 5649 1782 1820 5649 1820 5650 5649 5656 5657 5649 5657 1782 5650 1820 1819 3276 3275 3277 4127 3277 4139 3275 4139 3277 4112 4127 4110 4110 4127 4128 4127 4139 4128 4110 4111 4112 4112 4111 3283 4110 4108 4111 4114 4111 4108 4107 3529 4108 4107 4108 4109 4109 4108 4110 4114 4108 3528 3528 4108 3529 3526 4114 3528 3526 3528 3527 3527 3528 3529 3527 3529 3530 3530 3529 3531 3531 3529 4107 4134 3527 3530 3530 3531 3518 3530 3518 4134 3518 3531 3532 4107 4121 3531 3531 4121 4122 3531 4122 3532 3517 3516 3518 3518 3532 3517 3517 3532 4122 3517 4122 4140 4140 4122 4121 4107 4126 4121 4140 4121 4126 4109 4125 4107 4107 4125 4126 4140 4126 4125 4109 4124 4125 4140 4125 4139 4139 4125 4124 4110 4124 4109 4110 4123 4124 4139 4124 4123 4128 4139 4123 4137 4140 4139 4137 4139 3275 4110 4128 4123 4138 4137 3275 4136 4135 4137 4136 4137 4138 4135 4140 4137 3513 4135 4136 4136 4152 3513 3513 3515 4135 3515 3517 4135 4135 3517 4140 3513 4152 3488 4152 4147 3488 3488 4147 3487 3485 3487 4147 3485 4147 4148 4148 4164 3485 3515 3516 3517 3387 3388 3389 3387 3389 4145 3389 3388 3390 3388 5436 3390 5436 5433 3390 4195 3491 3493 4196 3491 4195 4196 3489 3491 3464 3489 4196 3464 3466 3489 3464 3465 3466 3466 3465 3476 3476 4214 3466 3476 3465 3477 4210 3477 3465 3476 3477 3478 4217 4214 3476 3478 4217 3476 3478 3477 3479 4206 3479 3477 4206 3477 4210 3478 3479 3467 4219 4217 3478 3478 3467 4228 3478 4228 4219 4219 4216 4217 4218 4216 4219 4219 4228 4229 4219 4229 4218 4231 4229 4228 4231 4228 3469 3469 4228 3467 4218 4229 3429 4230 3429 4229 4230 4229 4231 3421 3423 4218 4218 3423 4216 4218 3429 3421 3427 3428 3429 3429 3428 3430 3429 3430 3421 3427 3429 4230 4232 3427 4230 3214 3213 3427 3427 3213 3428 3214 3427 4232 3428 3213 5508 3430 3428 5512 5512 3428 5508 3421 3430 3422 3422 3430 5500 5500 3430 5512 5512 5508 5513 5500 5512 5495 5495 5512 5513 5508 3213 5509 5508 5509 5510 5513 5508 5510 5513 5510 1855 5495 5513 1854 1854 5513 1855 5510 5509 5511 5510 5511 1833 1855 5510 1833 3213 3212 5509 5509 3212 5518 5509 5518 5511 1833 5511 1834 3212 3217 5518 3212 3213 3214 5495 1854 1832 5495 1832 1831 5495 1831 5496 5496 5500 5495 5496 1831 1881 5496 5499 5500 5499 3422 5500 3421 3422 3423 3467 3468 3469 3467 3479 3480 3467 3480 3468 3480 3479 4206 3225 3224 3226 3224 4278 3226 1630 1637 1638 5919 5903 1638 5919 1638 1637 1630 1636 1637 1637 1636 5919 5918 5903 5919 5919 1636 5927 5919 5927 5918 5918 5902 5903 3057 5902 5918 4584 3057 5918 5918 5927 5922 5918 5922 4584 1636 1635 5927 5927 1635 5923 5927 5923 5922 1635 1636 1630 1630 1656 1635 1635 1656 5923 5923 1656 5924 5923 5924 5925 5922 5923 5925 1630 1655 1656 5942 5924 1656 5942 1656 1655 5925 5924 5926 5941 5926 5924 5941 5924 5942 5925 5926 4590 5922 5925 4588 4588 5925 4590 4590 5926 3055 5940 3055 5926 5940 5926 5941 5942 5946 5941 5941 5946 5940 1655 5945 5942 5942 5945 5946 5940 5946 3165 4533 3165 5946 5945 5960 5946 5946 5960 5955 5946 5955 4533 3053 3055 5940 5940 3165 3053 3053 3054 3055 3165 3166 3053 3053 3166 3054 3165 4536 3166 4536 4549 3166 3054 3166 4549 3165 4535 4536 4535 4550 4536 4536 4550 4549 4548 4549 4550 3054 4549 4559 4559 4549 4548 4535 4551 4550 4551 4552 4550 4550 4552 4553 4550 4553 4548 4548 4553 4554 4559 4548 4560 4560 4548 4554 4559 4560 4579 4559 4579 3054 4560 4554 4561 4561 4580 4560 4560 4580 4581 4560 4581 4579 4561 4554 3167 3167 4580 4561 4554 4553 4555 3167 4554 4555 4555 4553 4523 4555 4523 3168 3167 4555 3168 3169 3168 4523 4526 4501 4523 4523 4501 4500 4523 4500 3169 4553 4526 4523 3167 3168 3169 3176 3167 3169 3176 3169 4470 3169 4500 4470 4500 4501 4502 4470 4500 4502 4502 4501 4503 4526 4503 4501 4525 4503 4526 4526 4553 4525 4525 4553 4552 4524 4499 4525 4525 4499 4503 4525 4552 4524 4498 4502 4503 4498 4503 4499 4498 4499 3162 4524 3162 4499 3164 3162 4524 4524 4552 4528 4524 4528 3164 4530 4528 4552 4551 4530 4552 4527 3164 4528 4527 4528 4529 4529 4528 4530 3163 3162 3164 3163 3164 4527 5958 5959 4527 4527 5959 3163 4529 5958 4527 4529 4530 4531 4529 4531 5955 5955 5958 4529 5956 5957 5958 5958 5957 5959 5955 5956 5958 3161 3163 5959 3161 5959 5969 5969 5959 5957 3161 3162 3163 3162 3161 4483 4483 3161 4484 3161 5969 4484 5969 5957 5970 4484 5969 5980 5982 5980 5969 5982 5969 5970 4483 4484 4485 4485 4484 4486 4484 5980 4486 3162 4483 4498 4498 4483 4485 4485 4486 4482 4498 4485 4497 4497 4485 4482 4482 4486 4487 4486 5980 4487 4481 4480 4482 4482 4487 4481 4497 4482 4480 4480 4496 4497 4496 4505 4497 4497 4505 4502 4497 4502 4498 4478 4479 4480 4478 4480 4481 4480 4479 4496 4478 4481 5979 5979 4481 4487 5979 4487 5980 5977 4478 5979 5978 5977 5979 5978 5979 5981 5981 5979 5980 5981 5980 5982 1680 5978 5981 1680 5981 1627 1627 5981 5982 1647 5976 5978 5976 5977 5978 1647 5978 1680 1680 1679 1647 1647 1679 1681 6010 1681 1679 6010 1679 6012 6012 1679 1678 1647 1681 1645 6001 1645 1681 6001 1681 6002 6002 1681 6010 1645 1646 1647 5991 1646 1645 1645 6001 5991 5991 6001 6002 5991 6002 5990 5990 6002 6003 6003 6002 6010 5990 5976 5991 5991 5976 1647 5991 1647 1646 5976 5975 5977 5990 5975 5976 5975 3159 4476 5975 4476 5977 5989 3159 5975 5989 5975 5990 5977 4476 4478 3159 4475 4476 4476 4475 4477 4476 4477 4478 4477 4479 4478 4496 4479 4477 4496 4477 4475 3159 3160 4475 4504 4475 3160 4475 4504 4496 4496 4504 4505 3160 4471 4504 4504 4471 4472 4504 4472 4505 3159 3158 3160 3160 3158 4471 4471 3158 4454 4471 4454 4472 4472 4454 4453 4472 4453 4473 4505 4472 4473 4474 4502 4505 4505 4473 4474 4473 4453 4455 4473 4455 4474 4474 4455 4470 4470 4502 4474 4453 4445 4455 4448 3176 4455 4448 4455 4447 4447 4455 4445 3176 4470 4455 4444 4442 4445 4445 4442 4446 4445 4446 4447 4453 4444 4445 4447 4446 4448 4448 4446 3192 4440 3192 4446 4440 4446 4449 4449 4446 4442 3189 3191 4440 3189 4440 4423 4423 4440 4449 3191 3192 4440 4423 4449 4422 4422 4449 3151 4449 4442 3151 4423 4422 4424 4423 4424 4425 4425 3189 4423 4422 3144 3146 4422 3146 4424 4422 3151 3144 4425 4424 4421 4424 3146 3148 4424 3148 4421 4425 4421 4426 4426 3177 4425 4425 3177 3189 4426 4421 4410 4426 4410 3183 3183 3178 4426 4426 3178 3177 3177 3178 3179 3177 3179 3189 3189 3179 3190 3189 3190 3191 3191 3190 3192 3192 3190 3193 4436 3193 3190 4436 3190 4437 4437 3190 3179 3192 3193 3194 4448 3192 3194 3199 3194 3193 4429 3199 3193 4429 3193 4436 4434 4429 4436 4434 4436 4438 4438 4436 4437 4427 4428 4429 4427 4429 4431 4428 3199 4429 4431 4429 4434 4451 4428 4427 4451 4427 4431 4430 3199 4428 4452 4430 4428 4452 4428 4451 4430 3198 3199 3198 4430 4452 4452 3170 3198 4451 4468 4452 4452 4468 3170 3170 3176 3198 3198 3176 3194 3198 3194 3199 3175 3167 3176 3170 3175 3176 3194 3176 4448 3175 3174 3167 3174 4580 3167 3173 3174 3175 4611 4580 3174 4594 4611 3174 4594 3174 3173 4609 4581 4580 4611 4609 4580 4610 4609 4611 4610 4611 4594 4593 4594 4595 4578 4595 4594 4578 4594 3173 4593 4610 4594 4604 4609 4610 4597 4604 4610 4597 4610 4593 4597 4593 4598 4598 4593 4595 4575 4595 4577 4577 4595 4578 4577 4578 4556 4556 4578 3173 4577 4556 4575 4575 4556 4558 4575 4558 4557 4540 4557 4558 4540 4558 4541 4541 4558 4556 4546 4557 4540 4540 4541 4542 4546 4540 4545 4545 4540 4542 4541 4537 4542 4541 4556 4537 4545 4542 4544 4544 4542 4543 4542 4537 4539 4542 4539 4543 4544 4507 4545 4545 4507 3066 4545 3066 4546 3066 4507 4506 4506 4507 4508 4544 4508 4507 4506 4508 4509 5865 4506 4509 4508 4510 4509 4544 4510 4508 4509 4510 4511 4509 4511 4512 5865 4509 5867 4509 4512 5867 4511 4510 4544 4512 4511 4513 4544 4543 4511 4511 4543 4513 4513 4518 4512 5867 4512 4518 5867 4518 5868 4513 4517 4518 4517 5868 4518 4516 4517 4513 4516 4513 4543 4543 4539 4547 4543 4547 4516 4514 4515 4516 4516 4515 4517 4516 4547 4514 4515 5868 4517 4515 5858 5868 4514 3067 4515 3067 5858 4515 3068 3067 4514 3068 4514 4519 4519 4514 4547 4519 4547 4520 4520 4547 4539 4495 3068 4519 4495 4519 4494 4494 4519 4520 3067 3068 3069 3069 3068 3070 3070 3068 4495 3067 3069 5855 3067 5855 5858 5858 5855 5853 5854 5853 5855 5854 5855 4463 4463 5855 3069 3070 4463 3069 4462 4463 3070 4495 4462 3070 4462 4461 4463 4461 5854 4463 5851 5854 4461 4460 4459 4461 4460 4461 4462 4461 4459 5851 4460 4462 4490 4495 4490 4462 4458 4459 4460 4490 4489 4460 4460 4489 4458 4458 4457 4459 4457 5851 4459 5850 5851 4457 4456 4457 4458 4464 3071 4457 4464 4457 4465 4465 4457 4456 4457 3071 5850 4456 4458 4489 4456 4489 4465 4465 4489 4488 4490 4488 4489 4465 4488 4464 3072 3071 4464 4464 4488 4466 4464 4466 3072 3071 3072 3073 5862 5850 3071 5862 3071 3073 3073 3072 3074 3074 3072 4466 3074 4466 4450 4450 4466 4467 4467 4466 4488 4491 4467 4488 4491 4488 4490 4450 4467 4451 4451 4467 4468 4468 4467 4491 4450 4451 4435 4435 4451 4431 4434 4433 4435 4434 4435 4431 4433 4450 4435 4432 4433 4434 3085 4432 4434 3085 4434 3083 3083 4434 4438 4432 4450 4433 3076 4432 3085 3076 3074 4432 4432 3074 4450 3075 3074 3076 3085 3075 3076 3073 3074 3075 3085 3086 3075 3073 3075 5874 5874 3075 3086 3073 5874 5862 5862 5874 5875 5874 3086 5875 3084 3086 3085 3086 3084 5881 5875 3086 5881 5862 5875 5861 5861 5875 5876 5875 5881 5876 5861 5850 5862 5860 5850 5861 5861 5872 5860 5861 5876 5872 5876 5881 5872 5860 5872 5873 5872 5881 5882 5872 5882 5873 5871 1749 5860 5860 5873 5871 5873 5882 5871 5871 5882 1868 5883 1868 5882 5883 5882 5884 5884 5882 5881 1867 1749 5871 5871 1868 1867 1749 1867 1821 1821 1867 1868 1821 1868 1861 1861 1868 1869 1869 1868 5883 1821 1822 1749 5888 1821 1861 1822 1821 5888 1860 1859 1861 1861 1869 1860 5888 1861 5891 5891 1861 1859 1860 1869 5885 5885 1869 5883 5885 5883 5880 5880 5897 5885 5885 5897 1860 5880 5883 5884 3080 3078 5880 5880 5884 3080 3078 5896 5880 5880 5896 5897 5896 5901 5897 5897 5901 5899 5897 5899 1860 3078 3097 5896 5896 3097 5901 5900 5899 5901 3093 5900 5901 3093 5901 3095 3095 5901 3097 5898 1858 5899 5900 5898 5899 1860 5899 1858 1858 1859 1860 5898 1859 1858 5891 1859 5898 5894 5891 5898 5894 5898 5900 3092 5894 5900 3092 5900 3093 3090 3092 3091 3091 3092 3093 3090 5894 3092 3089 3088 3090 3089 3090 3091 3088 5892 3090 3090 5892 5894 3091 3093 3094 4417 3089 3091 4417 3091 4418 3094 4418 3091 3094 3093 3095 3094 3095 3096 3096 4418 3094 3096 4413 4418 4416 4417 4418 4416 4418 4419 4419 4418 4413 3096 3095 3097 3096 3097 3098 3098 4413 3096 3098 3097 3078 3098 3078 3077 3077 4414 3098 3098 4414 4413 3077 3078 3079 3079 3078 3080 3079 4414 3077 4413 4414 4415 4439 4415 4414 3079 4439 4414 3079 3080 3081 3081 4439 3079 3081 3080 3082 3080 5884 3082 3081 3082 3083 3083 4438 3081 3081 4438 4439 4438 4437 4439 4439 4437 4415 4437 3179 4415 3182 3181 3179 3182 3179 3183 3183 3179 3178 4420 4415 3179 3179 3181 4420 3182 3183 4409 4409 3183 4410 4409 4410 4411 4407 3182 4409 4407 4409 4408 4408 4409 4411 4411 4410 4412 4421 4412 4410 4411 4412 3140 4408 4411 3142 3142 4411 3140 4391 4407 4408 4391 4408 4394 4394 4408 3142 3140 3141 3142 3142 3141 3143 3142 3143 3131 4394 3142 3131 4393 4391 4394 3133 4393 4394 3133 4394 3131 3131 3132 3133 3131 3143 3132 3143 3141 5996 5996 3141 5992 5996 5992 5997 3141 3139 5992 5992 3139 5993 5992 5993 5994 5997 5992 5994 5997 5994 1644 1624 5997 1644 5994 5993 5995 5994 5995 1626 1644 5994 1626 3139 3149 5993 5993 3149 6008 5993 6008 5995 1626 5995 1625 5995 6008 6009 5995 6009 1625 3149 3147 6008 6008 3147 6004 6008 6004 6009 3148 3147 3149 3148 3149 3138 3138 3149 3139 3146 3145 3147 3146 3147 3148 3147 3145 6004 6004 3145 6005 6004 6005 6006 6009 6004 6006 3144 3145 3146 3145 3144 3150 3150 6005 3145 6006 6005 6007 6015 6007 6005 3150 6015 6005 6006 6007 1653 6009 6006 1652 1652 6006 1653 1653 6007 1654 6013 1654 6007 6015 6013 6007 6014 6013 6015 3152 6014 6015 3152 6015 3150 6012 1678 6013 6013 1678 1654 6014 6012 6013 6011 6012 6014 3154 6011 6014 3154 6014 3152 3150 3151 3152 3152 3151 3153 3152 3153 3154 3154 3153 3155 3154 3155 3156 3156 6011 3154 3155 3153 4441 4441 3153 4442 3151 4442 3153 3150 3144 3151 4441 4442 4443 4443 4442 4444 4443 4454 4441 4441 4454 3158 4441 3158 3155 4443 4453 4454 4443 4444 4453 3156 3155 3157 3157 3155 3158 3157 3158 3159 3157 3159 5989 3156 3157 5998 5998 3157 5989 5998 5989 5999 5999 5989 5990 3156 5998 6011 6011 5998 5999 5999 5990 6000 6011 5999 6000 5990 6003 6000 6003 6010 6000 6000 6010 6011 6011 6010 6012 1625 6009 1652 4421 3148 3138 4421 3138 4412 3138 3139 3140 3140 4412 3138 3140 3139 3141 3135 4393 3133 3135 4392 4393 4392 4390 4393 4393 4390 4391 4392 4389 4390 4389 3185 4390 4390 3185 3184 4390 3184 4391 3184 4407 4391 3180 3184 3181 3181 3184 3185 3184 3180 4407 3181 3185 3186 3186 3185 3187 4389 3187 3185 3180 3181 3182 4420 3181 3186 3180 3182 4407 4420 3186 4419 4419 4413 4420 4420 4413 4415 3083 3082 3084 3083 3084 3085 5884 5881 3082 3082 5881 3084 4416 4397 4396 4396 4417 4416 4416 4395 4397 4396 4397 4398 4398 4397 4395 4401 4402 4396 4396 4398 4401 4396 4402 4417 4417 4402 4400 4417 4400 4399 4399 3089 4417 4401 4400 4402 4399 4400 4401 4399 3087 3089 3087 3088 3089 3087 3106 3088 5892 3088 3106 5892 3106 5911 5892 5893 5894 5911 5893 5892 5889 5895 5911 5911 5895 5893 5889 5911 5910 5910 5911 5912 5894 5893 5895 5894 5895 5889 5889 5891 5894 5889 5890 5891 5910 5890 5889 5910 5912 5915 5915 1822 5910 5910 1822 5888 5910 5888 5890 5891 5890 5888 1749 1822 1823 5915 1823 1822 5916 1823 5915 1823 1825 1749 5916 1825 1823 1747 1748 1749 1749 1825 1747 4395 3207 4398 4398 3207 3205 4395 3209 3207 4491 4492 4493 4492 4491 4494 4494 4491 4490 4468 4491 4469 4469 4491 4493 4494 4520 4492 4492 4520 4521 4492 4521 4493 4494 4490 4495 4469 4493 3171 3172 3171 4493 4493 4521 4522 4493 4522 3172 3170 4468 4469 3170 4469 3171 3170 3171 3172 3172 3175 3170 4522 4538 3172 3175 3172 4538 4521 4539 4522 4522 4539 4538 4520 4539 4521 4537 4538 4539 3175 4538 4556 4537 4556 4538 4556 3173 3175 4596 4597 4598 4601 4596 4598 4601 4598 4600 4596 4604 4597 4602 4596 4601 4602 4605 4596 4596 4605 4604 4600 4563 4601 4601 4563 3060 4601 3060 4602 4600 4566 4564 4600 4564 4563 3060 4563 4562 4562 4563 4564 3059 3058 3060 4562 3059 3060 3060 3058 4602 4602 3058 4605 3057 3058 3059 3058 3057 4591 4591 4605 3058 5902 3059 4562 3057 3059 5902 4591 3057 4584 4591 4584 4592 4592 4606 4591 4591 4606 4605 4583 4584 4585 4585 4584 4586 4592 4584 4583 4584 5922 4586 4583 4607 4592 4592 4607 4606 4583 4585 4607 4585 4586 4587 4585 4587 4607 4587 4586 4588 4588 4586 5922 4587 4588 4589 4587 4589 4608 4607 4587 4608 4607 4608 4606 4579 4609 4608 4579 4608 4582 4582 4608 4589 4606 4608 4609 4589 4588 4590 4589 4590 3056 4582 4589 3056 3054 4579 4582 3054 4582 3056 4581 4609 4579 4606 4609 4604 4604 4605 4606 3055 3054 3056 3056 4590 3055 1627 5982 1628 1628 5982 5970 1628 5970 1629 5970 5957 1631 5970 1631 1629 1630 1629 1631 1631 1632 1630 1632 1631 5956 5956 1631 5957 1630 1632 1633 1633 1632 5960 5960 1632 5956 5960 5956 5955 5945 1633 5960 1630 1633 1634 1634 1633 5945 1655 1634 5945 1634 1655 1630 1630 1911 1912 1939 1940 1630 1912 1956 1630 1630 1956 1957 1630 1957 1939 1630 1993 1994 1995 1996 1630 1630 1996 1997 1630 1997 1998 2005 2006 1630 1630 2006 2007 1994 2008 1630 1630 2008 2009 1630 2009 1995 1630 2010 2011 2007 2018 1630 1630 2018 2019 1630 2019 1993 1998 2020 1630 1630 2020 2021 1630 2021 2010 2005 1630 2028 2028 1630 1940 2055 2056 1630 1630 2056 2057 1630 2057 1911 1630 2091 2092 1630 2092 2055 2055 6055 2056 2057 2056 6055 2092 6054 2055 2055 6054 6055 2091 6053 2092 2092 6053 6054 2091 6052 6053 6052 6049 6053 6053 6049 6048 6053 6048 6054 6054 6048 6051 6054 6051 6055 6062 2057 6055 6062 6055 6051 6048 2548 6051 6062 6051 6063 6063 6051 2548 1911 2057 6062 6062 6063 6072 1911 6062 6073 6062 6072 6073 6063 2548 2547 6063 2547 5182 6063 5182 6072 6072 5182 5184 6072 5184 6074 6073 6072 6074 6073 6074 6076 1911 6073 1912 1912 6073 6076 5184 5185 6074 6074 5185 5187 6074 5187 6075 6076 6074 6075 5182 5183 5184 5184 5183 5185 5185 5183 5186 5185 5186 5187 5187 5186 5188 5187 5188 5189 6075 5187 5189 6075 5189 6071 6076 6075 6077 6077 6075 6071 5189 5188 5190 6071 5189 5190 2554 6070 6071 6071 5190 2554 6077 6071 6078 6078 6071 6070 1897 6076 6077 1897 6077 1898 1898 6077 6078 6078 6070 6079 1898 6078 1900 1900 6078 6079 1897 1898 1899 1899 1898 1900 1897 1899 1912 1912 6076 1897 1912 1899 1956 1899 6147 1956 1956 6147 6148 1956 6148 1957 6146 6144 6147 6147 6144 6145 6147 6145 6148 1899 6146 6147 6145 6158 6148 6148 6158 1939 6148 1939 1957 2588 6145 5077 5077 6145 6144 2588 6157 6145 6145 6157 6158 6163 1939 6158 6163 6158 6164 6164 6158 6157 1940 1939 6163 6165 1940 6163 6165 6163 6162 6162 6163 6164 6164 6157 5024 6162 6164 5026 5026 6164 5024 2588 2590 6157 5024 6157 2590 2590 2591 5024 5024 2591 5025 5024 5025 5026 5026 5025 5027 5026 5027 5028 5026 5028 6162 2591 5056 5025 5025 5056 5055 5025 5055 5027 2590 2589 2591 2591 2589 5056 2588 2589 2590 2589 2588 5076 5056 2589 5081 2589 5076 5081 5055 5056 5057 5056 5081 5057 5057 5081 5082 5081 5076 5100 5081 5100 5082 5076 2588 5077 5076 5077 5078 5078 5100 5076 5082 5100 5092 5096 5092 5100 5096 5100 5078 5057 5082 5053 5053 5082 5083 5082 5092 5083 5052 5053 5054 5052 5057 5053 5053 5083 5054 5054 5083 5084 5083 5092 5084 5037 5052 5054 5037 5054 2661 2662 2661 5054 5054 5084 2662 5084 5092 5091 5084 5091 2662 2661 2662 2659 2659 2662 2663 2663 2662 5091 2659 5037 2661 2659 5036 5037 5036 5052 5037 5012 5035 5036 5012 5036 5013 5013 5036 2659 5035 5059 5036 5036 5059 5052 5011 5034 5035 5011 5035 5012 5034 5059 5035 5011 5012 4990 5011 4990 2595 2595 5034 5011 2595 2593 5034 2593 5033 5034 5034 5033 5059 2594 2593 2595 2595 4990 4989 2592 2593 2594 2592 5033 2593 2592 5032 5033 5059 5033 5032 5030 5032 2592 5030 2592 6161 5030 5031 5032 5032 5031 5058 5032 5058 5059 5029 5031 5030 5058 5031 5029 5028 5029 5030 6161 6162 5030 5030 6162 5028 6161 6165 6162 2045 1940 6165 2044 1940 2045 2044 2045 2046 2049 2050 2045 2045 2050 2051 2045 2051 2046 2041 1940 2044 5706 2044 2046 2041 2044 5706 5706 2046 5708 5708 2046 2051 5708 2051 5709 5709 2051 2050 5709 2050 5705 5705 2050 2049 5710 5708 5709 5710 5709 5711 5711 5709 5705 5707 5706 5708 5707 5708 5710 5723 2041 5706 5723 5706 5707 5710 2701 5707 2701 2699 5707 5707 2699 5724 5707 5724 5723 5722 2041 5723 5723 5724 5721 5723 5721 5722 2697 5721 5724 2697 5724 2699 2698 2697 2699 2698 2699 2700 2700 2699 2701 2696 2695 2697 2696 2697 2698 2695 5721 2697 2695 5720 5721 5722 5721 5720 2694 2695 2696 2695 2694 2707 2695 2707 5720 4856 2694 2696 4856 2696 4857 4857 2696 2698 2707 2694 2708 4855 2694 4856 2694 4855 2708 2707 2708 2706 2706 5734 2707 5720 2707 5734 2706 2708 2709 2708 4855 4860 2708 4860 2709 4855 4856 4854 4860 4855 4854 4854 4856 4857 4853 2945 4854 4854 4857 4853 4859 4854 2945 4854 4859 4860 4860 4859 4861 4860 4861 4862 2709 4860 4862 2706 2709 2704 2709 4862 2704 4862 4861 4850 4862 4850 4851 2704 4862 4851 4859 2950 4861 4861 2950 2877 4861 2877 4850 2945 2948 4859 4859 2948 2950 2948 2949 2950 2950 2949 2951 2950 2951 2877 2945 2947 2948 2948 2947 2949 2949 2947 4930 2949 4930 4931 4931 4939 2949 2949 4939 2951 2877 2951 2952 4939 4936 2951 2951 4936 2952 4938 4937 4939 4939 4937 4936 4931 4938 4939 4931 4930 4932 4931 4932 4933 4933 4938 4931 2974 2972 4938 4938 2972 4937 4933 2974 4938 4921 4936 4937 4921 4937 4926 4926 4937 2972 2971 2970 2972 2971 2972 2973 2973 2972 2974 4926 2972 2970 4925 4921 4926 4926 4927 4925 4926 2970 4927 2969 2970 2971 2969 2984 2970 4927 2970 2984 4925 4927 4928 4927 2984 4928 4924 2876 4925 4925 2876 4921 4925 4928 4924 4924 4928 4929 4928 2984 2982 4928 2982 4929 2983 2982 2984 2983 2984 2969 2969 2971 6222 2983 2969 6222 2981 2982 2983 6238 2981 2983 6238 2983 6239 6239 2983 6222 2981 2980 2982 4929 2982 2980 2979 2980 2981 6233 2979 2981 6233 2981 6238 6235 6233 6238 6235 6238 6240 6240 6238 6239 6239 6222 6223 6240 6239 6241 6241 6239 6223 6241 3040 6240 6240 3040 3039 6240 3039 6235 6241 6223 3042 3042 3041 6241 6241 3041 3040 6222 6220 6223 6223 6220 6221 6223 6221 3042 3028 3041 3042 3028 3042 3037 3042 6221 3037 3040 3041 3028 3028 3039 3040 3026 3027 3028 3034 3035 3028 3028 3035 3036 3028 3036 3026 3037 3038 3028 3028 3038 3034 3033 3032 3028 3028 3032 3039 3028 3027 6176 6188 3033 3028 6188 3028 6189 6189 3028 6176 3031 3032 3033 3031 3033 6188 6203 3031 6188 6203 6188 6189 6189 6176 6190 6203 6189 6190 6190 6202 6203 6203 6202 6204 6203 6204 6205 6205 3031 6203 3029 3030 3031 3031 3030 3032 6205 3029 3031 6205 6204 6199 6205 6199 6206 6206 3029 6205 3029 3047 3030 6206 3047 3029 6206 6199 6201 6206 6201 3048 3048 3047 6206 3030 3047 3048 3030 3048 3049 3049 3048 3050 6201 6216 3048 3048 6216 3050 6199 6200 6201 6200 6215 6201 6201 6215 6216 6215 6211 6216 6216 6211 6213 6216 6213 3050 3049 3050 3051 3051 3050 3046 3050 6213 3046 6211 6212 6213 6213 6212 6214 6213 6214 3046 3003 2993 6211 6211 2993 6212 6215 3003 6211 2993 2995 6212 6212 2995 6228 6212 6228 6214 3046 6214 3045 6214 6228 6229 6214 6229 3045 2995 2997 6228 6228 2997 6226 6228 6226 6229 2993 2994 2995 2995 2994 2996 2995 2996 2997 2997 2996 2998 2997 2998 2988 6227 6226 2997 6227 2997 2988 6225 6224 6226 6225 6226 6227 6229 6226 6224 6247 6225 6227 2990 6247 6227 2990 6227 2988 2988 2989 2990 2988 2998 2989 2990 2989 2991 2990 2991 2985 2985 6247 2990 6246 6245 6247 6247 6245 6225 2985 6246 6247 2985 2986 2987 2985 2991 2992 2985 2992 2986 2987 6246 2985 6243 6244 6246 6246 6244 6245 2987 6243 6246 6244 3051 6245 6245 3051 3052 6245 3052 6225 6242 3049 6244 6244 3049 3051 6243 6242 6244 3051 3046 3052 3052 3046 3044 3052 3044 6224 3052 6224 6225 3045 3044 3046 3043 3044 3045 3043 6224 3044 6229 6224 3043 3045 6229 3043 6232 6231 6242 6242 6231 6236 6242 6236 6237 6237 3030 6242 6242 3030 3049 6232 6242 6243 6235 6236 6231 6235 6237 6236 6231 6232 6233 6231 6233 6235 6235 3039 6237 3039 3032 6237 6237 3032 3030 6233 6232 6234 6233 6234 6230 6230 2979 6233 6243 6230 6234 6243 6234 6232 6230 2977 2979 2977 6230 6243 2977 6243 2987 2977 2978 2979 2987 2978 2977 2979 2978 2980 2987 2986 2978 4900 2978 2986 4922 2980 2978 4922 2978 4900 4929 2980 4922 4900 4906 4922 4922 4906 4904 4923 4929 4922 4923 4922 4920 4920 4922 4904 4905 4906 4900 4900 2986 4905 4905 2986 2992 4903 4904 4905 4905 4904 4906 4905 2992 4908 4903 4905 4901 4901 4905 4908 4920 4904 4903 4901 4902 4903 4903 4902 4920 4901 4908 4911 4911 2956 4901 4901 2956 4907 4901 4907 4902 4908 2992 2991 4908 2991 4909 4911 4908 4909 4911 4909 4912 4912 2958 4911 4911 2958 2956 4909 2991 2989 4909 2989 4910 4912 4909 4910 4912 4910 4913 4913 2959 4912 4912 2959 2958 2957 2956 2958 2957 2958 2924 2924 2958 2959 2924 2959 2925 4913 2925 2959 4913 4910 4891 4913 4891 2937 2937 2925 4913 4910 2989 4890 4910 4890 4891 2989 2998 4890 4890 2998 4888 4890 4888 4891 4891 4888 4889 4891 4889 2937 2936 2923 2937 2937 2923 2925 2937 4889 2936 2923 2924 2925 2936 2935 2923 2923 2935 4818 2923 4818 4819 4819 4839 2923 2923 4839 2924 2934 2933 2935 2934 2935 2936 2935 2933 4818 4819 4818 4820 4818 2933 4823 4818 4823 4820 2884 2932 2933 2884 2933 2934 2932 4823 2933 4887 4882 2934 2934 4882 2884 2936 4887 2934 4886 4881 4887 4887 4881 4882 4889 4886 4887 4889 4887 2936 4881 4879 4882 4882 4879 4880 4882 4880 2884 2994 3004 4881 4881 3004 4879 4886 2994 4881 3004 3002 4879 4879 3002 4877 4879 4877 4880 4880 4877 4878 4880 4878 2882 2884 4880 2882 3002 3000 4877 4877 3000 4876 4877 4876 4878 4878 4876 4873 4878 4873 2880 2882 4878 2880 2880 2881 2882 2882 2881 2883 2882 2883 2884 2883 2932 2884 4802 4803 2883 2883 4803 2932 2881 4802 2883 2880 2879 2881 4805 4802 2881 2879 4805 2881 2878 2879 2880 2880 4873 2878 2879 2878 2909 4872 2909 2878 4872 2878 4873 2879 2909 2910 2909 2960 2910 4871 2960 2909 4871 2909 4872 4874 4871 4872 4874 4872 4875 4875 4872 4873 4869 4871 4874 3008 4869 4874 3008 4874 3010 3010 4874 4875 4875 4873 4876 3010 4875 3012 3012 4875 4876 3009 3008 3010 3009 3010 3011 3011 3010 3012 3007 3006 3008 3007 3008 3009 3006 4869 3008 3006 4868 4869 3005 3006 3007 3005 3014 3006 3006 3014 4868 6192 3005 3007 6192 3007 6202 6202 3007 3009 3013 3014 3005 3013 3005 6184 6184 3005 6192 3013 3016 3014 3015 3016 3013 6184 3015 3013 3015 3022 3016 3021 3022 3015 6183 3015 6184 3021 3015 6183 3021 3020 3022 3019 3018 3020 3019 3020 3021 4916 3020 3018 3017 3018 3019 6194 3019 3021 3017 3019 6197 6197 3019 6194 3018 3017 3024 4916 3018 4917 3018 3024 4917 4918 4916 4917 4918 4917 4919 4917 3024 4934 4917 4934 4919 3024 3017 3023 3024 3023 3025 3024 3025 4934 4934 3025 4932 4934 4932 4935 4919 4934 4935 4919 2943 2941 4919 2941 4918 4919 4935 2943 4918 2941 2930 2940 2930 2941 2940 2941 2942 2942 2941 2943 4845 2940 2942 2942 2943 2944 4845 2942 4852 4852 2942 2944 4852 4844 4845 4852 2944 4853 4853 4858 4852 4852 4858 4844 2944 2943 2945 4853 2944 2945 4853 4857 4858 4857 2698 4858 4858 2698 2700 4858 2700 4844 2945 2943 2946 2945 2946 2947 2943 4935 2946 4935 4930 2946 2946 4930 2947 4935 4932 4930 4933 4932 3025 4933 3025 2976 2976 2974 4933 3025 3023 2976 2975 2974 2976 3023 2975 2976 2973 2974 2975 2975 3023 6209 2973 2975 6218 6218 2975 6209 3023 3017 6207 6209 3023 6207 6209 6207 6210 6209 6210 6217 6218 6209 6219 6219 6209 6217 6220 2973 6218 6220 6218 6221 6221 6218 6219 2971 2973 6220 6222 2971 6220 6219 6217 3038 6221 6219 3037 3037 6219 3038 6217 6210 3034 3038 6217 3034 6210 6208 3034 3034 6208 3035 6207 6197 6208 6208 6197 6198 6208 6198 3035 6210 6207 6208 3035 6198 3036 6197 6194 6198 6198 6194 6195 6198 6195 3036 6207 3017 6197 3036 6195 3026 3027 3026 6177 6177 3026 6195 6176 3027 6177 6176 6177 6178 6177 6195 6178 6178 6179 6176 6176 6179 6180 6176 6180 6181 6190 6176 6181 6195 6179 6178 6195 6180 6179 6181 6180 6182 6194 6180 6195 6194 6182 6180 6182 6185 6181 6196 6185 6182 6194 6196 6182 3021 6196 6194 6187 6186 6196 6196 6186 6185 3021 6187 6196 6181 6185 6186 6181 6186 6184 6184 6186 6187 6184 6187 6183 6183 6187 3021 6184 6192 6181 6181 6192 6193 6202 6193 6192 6190 6181 6191 6181 6193 6191 6202 6191 6193 6190 6191 6202 6202 3009 6204 6204 3009 3011 6204 3011 6199 3011 3012 2999 6199 3011 2999 6199 2999 6200 2999 3000 3001 2999 3012 3000 2999 3001 6200 3012 4876 3000 3001 3000 3002 3001 3002 3003 3001 3003 6215 6200 3001 6215 3003 3002 3004 3003 3004 2993 2993 3004 2994 2996 2994 4886 2998 2996 4888 4888 2996 4886 4888 4886 4889 2879 2910 4787 2879 4787 4788 4788 4805 2879 4788 4787 4789 4788 4789 4790 4790 4804 4788 4788 4804 4805 4804 4800 4805 4805 4800 4802 2737 2740 4804 4804 2740 4800 4790 2737 4804 4790 4789 2746 4790 2746 2738 2738 2737 4790 4789 4791 2746 2744 2745 2746 2746 2745 2747 2746 2747 2738 2746 4791 2744 2737 2738 2739 2738 2747 2739 2747 2745 5806 2739 2747 5783 5783 2747 5806 2744 2743 2745 2745 2743 5803 5806 2745 5803 5806 5803 5807 5783 5806 5780 5780 5806 5807 5783 5780 5781 5783 5781 5784 2739 5783 5784 2021 2020 5780 5780 2020 1998 5780 1998 5781 5780 5807 2021 5781 1998 1997 5781 1997 5782 5784 5781 5782 5784 5782 5785 2739 5784 2741 2741 5784 5785 5782 1997 1996 5782 1996 5771 5785 5782 5771 5785 5771 5769 2741 5785 2736 2736 5785 5769 2736 2737 2741 2741 2737 2739 2736 2734 2735 2735 2740 2736 2736 2740 2737 2736 5769 2734 5768 2734 5769 5768 5769 5770 5770 5769 5771 2732 2733 2734 2734 2733 2735 2732 2734 5768 2740 2735 4800 4800 2735 4801 2733 4801 2735 2732 2731 2733 2731 4820 2733 4820 4822 2733 2733 4822 4801 2730 2731 2732 2730 2732 5768 2730 2729 2731 2729 4820 2731 4819 4820 4821 2729 4821 4820 4820 4823 4822 4801 4822 4803 4803 4822 4823 4803 4823 2932 4802 4801 4803 4800 4801 4802 2719 4821 2729 4821 4838 4819 2721 4838 4821 2721 4821 2719 2719 2720 2721 2720 2719 2728 2728 2719 2729 2721 2720 2722 2721 2722 2723 2721 2723 4837 4837 4838 2721 4819 4838 4839 4837 4839 4838 4836 2924 4839 4836 4839 4837 4829 2957 4836 4829 4836 4832 4832 4836 4837 2957 2924 4836 2955 2956 2957 2955 2957 4829 2922 2954 2955 2955 2954 2956 2922 2955 4828 4828 2955 4829 2956 2954 4907 2922 2953 2954 4907 2954 2953 2920 2921 2922 2921 2953 2922 4828 2920 2922 4829 4834 4828 4834 4848 4828 4828 4848 2920 2918 2919 2920 2920 2919 2921 2918 2920 4849 4849 2920 4848 4920 2953 2921 4920 2921 4923 4923 2921 2919 2918 2876 2919 4923 2919 4924 4924 2919 2876 4924 4929 4923 2875 2876 2877 2877 2876 2918 2876 2875 4921 2877 2952 2875 2875 2952 4936 2875 4936 4921 2877 2918 4850 4850 2918 4849 4850 4849 4851 4849 4848 4846 4851 4849 4846 4851 4846 2702 2704 4851 2702 2702 2703 2704 2703 2702 2710 2710 2702 2711 2702 4846 2711 2704 2703 2705 2704 2705 2706 2705 2703 5730 5730 2703 5731 2710 5731 2703 2710 2711 2712 2712 5748 2710 2710 5748 5731 2712 2711 2713 2713 2711 4846 2712 2713 2714 2714 5746 2712 2712 5746 5748 5746 5747 5748 5748 5747 5729 5748 5729 5731 5746 5743 5745 5745 5744 5746 5746 5744 5747 2714 5743 5746 5744 2006 5747 5747 2006 2005 5747 2005 5729 5729 2005 2028 5729 2028 5732 5732 5731 5729 2028 1940 2029 5732 2028 2029 5732 2029 5733 5733 5730 5732 5732 5730 5731 1940 2043 2029 2029 2043 5719 5733 2029 5719 2041 2042 1940 1940 2042 2043 5719 2043 2042 5719 2042 5722 5722 5720 5719 5733 5719 5720 5720 5734 5733 5733 5734 5730 2705 5730 2706 2706 5730 5734 5722 2042 2041 5744 2007 2006 5744 5745 2018 2018 2007 5744 5743 5756 5745 5745 5756 5757 5745 5757 2018 2018 5757 2019 5756 5751 5757 5757 5751 5755 5757 5755 2019 2726 2724 5756 5756 2724 5751 5743 2726 5756 2724 2722 5751 2722 2720 5751 5751 2720 5752 5751 5752 5755 5755 5752 5754 5755 5754 1993 2019 5755 1993 5752 5753 5754 2720 2728 5752 5752 2728 5772 5752 5772 5753 5754 5753 2008 5754 2008 1994 1993 5754 1994 5753 5772 5773 5753 5773 2008 2728 2730 5772 5772 2730 5768 5772 5768 5773 2728 2729 2730 5773 5768 5770 5773 5770 2009 2008 5773 2009 5770 5771 1995 2009 5770 1995 1995 5771 1996 2723 2722 2724 2723 2724 2725 4837 2723 2725 2725 2724 2726 2725 2726 2727 4837 2725 2727 4832 4837 2727 2727 2726 2718 2727 2718 2717 4835 4832 2727 4835 2727 2717 2718 2726 5743 2716 2717 2718 2716 2718 5743 2716 2715 2717 2715 4835 2717 4830 4832 4835 4847 4830 4835 2715 4847 4835 2714 2713 2715 2714 2715 2716 2713 4846 2715 4846 4847 2715 2716 5743 2714 4831 4830 4847 4831 4847 4833 4833 4847 4848 4846 4848 4847 4830 4831 4832 4832 4831 4833 4832 4833 4829 4829 4833 4834 4833 4848 4834 4902 2953 4920 4907 2953 4902 2021 5807 2010 5807 5803 5800 5807 5800 2010 2010 5800 2011 5798 5799 5800 5800 5799 2011 5798 5800 5802 5802 5800 5803 5802 5803 5804 5803 2743 5805 5803 5805 5804 5798 5802 5817 5817 5802 5804 5798 5817 5799 2011 5799 5801 5799 5817 5818 5799 5818 5801 2011 5801 2012 5801 5818 1938 5801 1938 2012 5827 1938 5818 5827 5818 5828 5828 5818 5817 1923 1938 5827 5829 1923 5827 5805 2748 5817 5817 5804 5805 5828 5817 4740 4740 5817 2748 4742 5828 4740 2748 2749 4740 4740 2749 4741 4740 4741 4742 2743 2742 2748 2748 2742 2749 2743 2748 5805 2749 4765 4741 2749 2742 4765 2742 2743 2744 4765 2742 4779 2742 2744 4779 4765 4779 4766 4766 4779 4780 4779 2744 4791 4779 4791 4780 4766 4780 4776 4780 4791 4776 4776 4791 4777 5028 5027 5029 5027 5055 5058 5058 5029 5027 5059 5058 5055 5059 5055 5052 5052 5055 5057 4988 4989 4990 4992 4991 4988 4992 4988 4985 4985 4988 4990 4985 4990 4986 5012 4986 4990 4985 4986 4987 4980 4992 4985 4980 4985 4981 4981 4985 4987 4979 4992 4980 4967 4979 4980 4967 4980 4963 4963 4980 4962 4962 4980 4981 4962 4981 2658 4981 4987 2658 2660 4958 4962 4962 4958 4960 4962 4960 4963 2658 2660 4962 4963 4960 4964 4964 4967 4963 4958 4959 4960 4960 4959 4961 4959 4958 4983 4983 4958 2660 4959 4983 4961 4961 4983 4984 4983 2660 2652 2652 4993 4983 4996 4984 4983 4996 4983 4997 4997 4983 4993 2660 2659 2652 2659 2663 2652 2652 2663 2664 2652 2664 2653 2658 2659 2660 2658 4987 2659 2659 4987 5013 5013 4987 5012 5012 4987 4986 2653 2664 5118 5133 2666 2653 5133 2653 5130 5130 2653 5118 2663 5117 5118 2663 5118 2664 5130 5118 5117 5130 5117 5122 5122 5129 5130 5130 5129 5131 5130 5131 5133 5105 5117 2663 5105 5122 5117 2663 5091 5105 5094 5107 5105 5094 5105 5090 5090 5105 5091 5107 5121 5105 5105 5121 5122 5121 5129 5122 5107 5120 5121 5121 5120 5129 5093 5106 5107 5093 5107 5094 5106 5120 5107 5093 5094 5095 5094 5090 5095 5090 5091 5092 5095 5090 5092 5098 5093 5095 5098 5095 5097 5097 5095 5096 5095 5092 5096 5099 5093 5098 5099 5106 5093 5097 5068 5098 5098 5068 2587 5098 2587 5099 2587 2585 5099 5099 2585 5106 2586 2585 2587 2586 2587 5068 2586 5068 5069 5069 5068 5070 5097 5070 5068 2584 2585 2586 2584 2586 6133 6133 2586 6137 6137 2586 5069 2584 2574 2585 5106 2585 2574 2575 2574 2584 2575 2584 6113 6113 2584 6133 6113 6133 6114 6114 6133 6132 6133 6137 6132 6113 6114 6115 2575 6113 2577 2577 6113 6115 2574 2575 2576 2576 2575 2577 2576 2577 2578 2578 2577 2579 2577 6115 2579 5119 2574 2576 5129 5119 2576 5129 2576 5131 2576 2578 5131 2578 2579 2580 5131 2578 2580 2580 2579 2581 2579 6115 6121 2579 6121 2581 2580 2581 2582 5131 2580 5132 5132 2580 2582 5133 5131 5132 5133 5132 5134 5134 2666 5133 5134 5132 5135 5134 5135 2657 5134 2657 2666 5132 5150 5135 5135 5150 5151 5135 5151 2657 2657 5151 2668 5150 5142 5151 5151 5142 5145 5151 5145 2668 2571 2569 5150 5150 2569 5142 5132 2571 5150 2570 2569 2571 2570 2571 2572 2572 2571 2573 2573 2571 5132 2568 2567 2569 2568 2569 2570 2569 2567 5142 6106 2568 2570 6106 2570 2572 2566 2567 2568 6109 2566 2568 6109 2568 6106 2566 2565 2567 2567 2565 5142 2564 2565 2566 6091 2564 2566 6091 2566 6109 2564 2563 2565 5142 2565 5149 5149 2565 2563 5142 5143 5144 5142 5144 5145 5142 5149 5143 5165 5143 5149 5149 2563 5165 2562 2561 2563 2562 2563 2564 5165 2563 2561 2562 2564 6091 2560 2561 2562 6091 6093 2562 2562 6093 6097 2562 6097 2560 2560 2559 2561 5165 2561 5166 5166 2561 2559 2558 2559 2560 2560 6097 6098 2560 6098 2558 6093 6095 6097 6097 6095 6096 6097 6096 6098 6098 6096 6083 6098 6083 6084 2558 6098 6084 2553 2555 2558 2558 2555 2559 2558 6084 2553 6083 6070 6084 6084 6070 2554 6084 2554 2553 1921 6079 6083 6083 6079 6070 6096 1921 6083 1899 1920 1921 1899 1921 1907 1907 1921 1922 1921 1920 6079 6096 1922 1921 1900 6079 1920 1900 1920 1899 1907 6146 1899 6142 6143 6146 6146 6143 6144 1907 6142 6146 1895 6138 6142 6138 6141 6142 6142 6141 6143 1895 6142 1907 6132 6137 6138 6132 6138 6131 6131 6138 1895 6138 6137 6141 6137 5069 6141 6141 5069 5071 6141 5071 6143 5069 5070 5071 5070 5072 5071 5071 5072 5073 5071 5073 5074 5071 5074 6143 5097 5072 5070 5073 5072 5097 5074 5073 5075 5097 5096 5073 5073 5096 5075 5075 5080 5074 6143 5074 5080 6143 5080 6144 5075 5079 5080 5079 6144 5080 5078 5079 5075 5078 5075 5096 5078 5077 5079 5077 6144 5079 1893 1894 1895 1893 1895 1896 1907 1908 1895 1895 1908 1909 1895 1909 1910 1910 1936 1895 1895 1936 1937 1895 1937 1896 6131 1895 1894 1907 1906 1908 6087 1908 1906 6087 1909 1908 1905 1906 1907 6087 1906 6090 6090 1906 1905 6090 6089 6087 6087 6089 6110 6110 1909 6087 6088 6089 6090 6090 1905 6095 6088 6090 6093 6093 6090 6095 1907 1922 1905 6095 1905 1922 6095 1922 6096 6091 6092 6093 6093 6092 6094 6093 6094 6088 6109 6092 6091 6094 6092 6109 6109 6088 6094 6106 6110 6109 6109 6110 6088 2572 6105 6106 6105 6107 6106 6106 6107 6108 6106 6108 6110 2582 2583 2572 2582 2572 2573 2572 2583 6105 6105 2583 6121 6105 6121 6107 2581 2583 2582 2581 6121 2583 5132 2582 2573 6121 6115 6122 6107 6121 6122 6114 6118 6115 6115 6118 6119 6115 6119 6117 6122 6115 6117 6122 6117 1937 6107 6122 1936 1936 6122 1937 6116 1896 6117 6117 6119 6120 6117 6120 6116 1937 6117 1896 1893 1896 6116 1894 1893 6116 1894 6116 6131 6116 6120 6131 6131 6120 6119 6131 6119 6132 6114 6132 6118 6118 6132 6119 6107 1936 6108 6108 1936 1910 6108 1910 1909 6110 6108 1909 6110 6089 6088 2553 2554 2555 2555 2554 2556 5190 2556 2554 5190 5188 2556 5193 5194 5188 5188 5194 5195 5188 5195 2556 5193 5188 5199 5199 5188 5186 5193 5199 5231 5193 5231 5194 5194 5231 5240 5194 5240 5195 2556 5195 5196 5195 5240 5239 5195 5239 5196 5234 5239 5240 5234 5240 5237 5237 5240 5231 5237 5231 5200 5200 5231 5199 5199 5186 5200 5200 5186 5201 5201 5186 5183 5201 5237 5200 5236 5234 5237 5236 5237 5238 5202 5238 5237 5202 5237 5201 5201 5183 5202 5182 2549 5183 5202 5183 2549 5202 2549 2551 2551 5238 5202 2551 2552 5238 5238 2552 5244 5238 5244 5236 2549 2550 2551 2551 2550 2552 2547 2548 2549 2549 2548 2550 2547 2549 5182 2550 2548 5222 5222 5224 2550 2550 5224 5228 2550 5228 2552 5228 5243 2552 2552 5243 5244 5244 5243 5245 5236 5244 5245 5245 5243 5242 5248 5242 5243 5248 5243 5227 5227 5243 5228 5224 5227 5228 5227 5224 5229 5229 5248 5227 5229 5224 5219 5229 5219 5230 5230 5248 5229 5219 5220 2545 5224 5225 5219 5219 5225 5226 5219 5226 5220 5230 5219 2545 5230 2545 2546 2546 5209 5230 5230 5209 5248 2545 2544 2546 5209 2546 2544 5213 5212 5209 5209 2544 5213 5212 5248 5209 2543 2542 2544 2543 2544 2545 5213 2544 2542 2541 2542 2543 2545 5221 2543 2541 2540 2542 5213 2542 5218 5218 2542 2540 2539 2540 2541 2540 2539 2643 2643 5181 2540 5218 2540 5181 5218 5216 5213 5181 5178 5218 5218 5178 5210 5218 5210 5216 5180 5178 5181 2643 5180 5181 5177 2684 5178 5180 5177 5178 5178 2684 5210 5210 2684 2687 5210 2687 2689 5216 5210 2689 2684 2686 2687 2687 2686 2688 2687 2688 2689 2689 2688 2690 2689 2690 2691 5216 2689 5214 5214 2689 2691 5173 2690 2688 5173 2688 5172 5172 2688 2686 2691 2690 2692 2692 2690 5173 2691 2692 2693 5247 5214 2691 2691 2693 5247 5214 5215 5216 5215 5214 5242 5247 5242 5214 5246 5242 5247 5247 2693 5233 5247 5233 5246 2693 2692 5203 5233 2693 5203 5173 5170 2692 5203 2692 5170 5203 5170 5204 5203 5204 5232 5203 5232 5233 5233 5232 5234 5233 5234 5235 5246 5233 5235 5204 5205 5232 5232 5205 5239 5232 5239 5234 5204 5170 5169 5204 5169 5205 5168 5169 5170 5173 5168 5170 5167 2555 5168 5168 2555 5169 5172 5167 5168 5172 5168 5173 5166 2559 5167 5167 2559 2555 5171 5166 5167 5171 5167 5172 2555 2556 2557 2555 2557 5207 2555 5207 5169 2556 5198 2557 2557 5198 5207 5191 5192 2556 2556 5196 5191 5192 5197 2556 2556 5197 5198 5207 5198 5197 5169 5207 5208 5207 5197 5208 5208 5197 5192 5208 5192 5191 5196 5208 5191 5196 5239 5208 5169 5208 5206 5239 5206 5208 5205 5169 5206 5205 5206 5239 5172 2686 5171 2684 2685 2686 5171 2686 2685 5164 5166 5171 5171 2685 5164 2683 2685 2684 2685 2683 5148 5164 2685 5148 2682 2683 2684 5177 2682 2684 2682 2681 2683 2681 5148 2683 2681 5147 5148 5164 5148 5147 2680 2668 2681 2680 2681 2682 5145 5147 2681 2668 5145 2681 5176 2680 2682 5176 2682 5177 5179 5176 5177 5179 5177 5180 2645 5179 5180 2645 5180 2643 2643 2644 2645 2645 2644 2646 2643 2539 2644 6024 2646 2644 5144 5146 5145 5145 5146 5147 5146 5144 5165 5165 5144 5143 5164 5147 5146 5146 5165 5164 5164 5165 5166 5235 5234 5236 5246 5235 5236 5236 5245 5246 5245 5242 5246 5241 5215 5242 5241 5242 5248 5211 5217 5241 5211 5241 5212 5212 5241 5248 5217 5215 5241 5216 5215 5217 5213 5216 5217 5213 5217 5211 5211 5212 5213 2545 5220 5221 5220 6046 5221 5226 6050 5220 5220 6050 6046 5225 6049 5226 5226 6049 6050 6052 6050 6049 5225 6048 6049 5224 5223 5225 5223 6048 5225 5223 5222 6048 6048 5222 2548 5222 5223 5224 5120 5119 5129 5106 5119 5120 2574 5119 5106 4993 5020 4997 4997 5020 5023 5015 5023 5020 5023 4996 4997 5015 5008 5005 5008 5007 5009 5008 5009 5005 5005 5009 5010 5007 6128 5009 5009 6128 5010 5007 6111 6128 6130 6128 6111 6111 6101 6112 6130 6111 6112 6100 1951 6101 6112 6101 1951 6112 1951 1932 1950 1932 1951 1933 1932 1950 2405 1933 1950 4533 5955 4531 4531 4532 4533 4532 4534 4533 4533 4534 4535 4533 4535 3165 4531 4530 4532 4534 4532 4551 4532 4530 4551 4534 4551 4535 1714 1799 1800 1800 1804 1805 1800 1805 1714 1713 1798 1714 1714 1798 1799 1798 5456 1799 5454 5456 1798 5454 5451 5456 3367 3369 5451 3369 3371 5451 3367 3366 3368 3367 3368 3369 3369 3368 3370 3369 3370 3371 3371 3370 3372 3370 3368 4091 3372 3370 4093 4093 3370 4091 3368 3366 4089 4091 3368 4089 3366 3357 4089 4089 3357 4079 4089 4079 4090 4091 4089 4092 4092 4089 4090 4093 4091 4094 4094 4091 4092 4092 4090 3459 4090 4079 4081 4090 4081 3448 3459 4090 3448 4079 4080 4081 3448 4081 3449 3448 3449 3450 3448 3450 3459 4102 4093 4094 4101 4093 4102 4101 3372 4093 3377 3372 4101 4103 3377 4101 4073 4087 4071 3299 3297 4073 4073 3297 4087 3297 3295 4087 3298 3297 3299 4054 4061 4060 4028 3336 4026 3351 3353 4068 4068 3353 4066 4068 4066 4069 3353 3355 4066 4066 3355 4064 3355 3356 3345 4064 3355 3345 3345 4052 4064 3345 3346 3347 3345 3356 3346 3345 3347 4052 5480 3346 3356 3347 3346 3348 3348 3346 5489 5489 3346 5480 3347 3348 3349 3349 3348 3350 3350 3348 5491 5491 3348 5489 5489 5480 5490 5491 5489 5492 5492 5489 5490 5493 3350 5491 5493 5491 5494 5494 5491 5492 3340 3350 5493 5501 5507 5493 5501 5493 5494 5507 3340 5493 5494 5492 1695 5494 1695 1694 5494 1694 5501 5492 5490 1696 1695 5492 1696 1696 5490 1697 5501 1694 1686 5501 1686 5502 5502 5507 5501 3893 5324 3895 3897 3895 5324 5324 5325 5327 5324 5327 3897 5325 1648 5326 5325 5326 5327 5327 5326 5328 5339 5328 5326 5339 5326 5340 5340 5326 5341 5341 5326 1648 5337 5328 5338 5338 5328 5339 5359 5338 5339 5359 5339 5358 5358 5339 5340 5358 5340 5341 5341 1763 5358 5356 5359 5358 5356 5358 1762 1762 5358 1763 5337 5338 5359 5354 5359 5356 5355 5354 5356 5355 5356 5357 5357 5356 1762 1762 1763 1764 1764 1810 1762 5357 1762 1810 5357 1810 1809 5357 1809 5363 5363 5355 5357 3634 5354 5355 5363 5369 5355 5369 3634 5355 5363 1809 1775 5363 1775 5364 5364 5369 5363 1775 1809 1764 1764 1809 1810 1764 1774 1775 5364 1775 1774 5364 1774 5365 5365 5368 5364 5364 5368 5369 5368 3636 5369 5369 3636 3634 3635 3634 3636 3635 3636 3637 3637 3636 3638 5368 3638 3636 5365 5367 5368 5367 3638 5368 3637 3638 3639 3639 3638 3627 5367 3627 3638 3639 3841 3637 3637 3841 3842 3637 3842 3635 3639 3627 3626 3626 3837 3639 3639 3837 3841 3626 3627 3628 5366 3627 5367 5366 5367 5365 5365 5362 5366 5365 1774 5362 3816 3626 3628 3816 3628 3821 3626 3816 3837 3821 3822 3816 3837 3816 3822 3819 3820 3821 3821 3820 3822 3837 3822 3820 3819 3836 3820 3820 3836 3837 3819 3818 3836 3818 3695 3836 3836 3695 3693 3836 3693 3838 3837 3836 3838 3694 3693 3695 3837 3838 3841 3841 3838 3839 3841 3839 3842 3625 3623 3802 3550 3849 3856 3549 3548 3550 3548 3849 3550 3547 3548 3549 5280 3547 3549 5268 5280 3549 3547 3546 3548 3548 3848 3849 3848 3548 3546 3547 5264 5265 5264 3547 5266 5266 3547 5280 5266 5280 5269 5269 5280 5268 5268 5265 5266 5268 5266 5269 5265 5264 5266 3848 3546 3850 3850 3546 3851 3851 3546 3884 3848 3850 3849 3849 3850 3851 3849 3851 3852 3851 3884 3852 3852 3884 3885 3846 3845 3852 3852 3845 3853 3852 3853 3849 3852 3885 3846 3846 3885 3886 3885 3904 3886 3844 3845 3846 3846 3886 3844 3844 3663 3845 3847 3663 3844 3844 3886 3887 3844 3887 3847 3886 3904 3887 3902 3903 3904 3887 3904 3903 3907 3902 3904 3847 3887 3648 3887 3903 3648 3847 3650 3663 3847 3648 3650 3650 3662 3663 3648 3649 3650 3650 3649 3651 3651 3653 3650 3650 3653 3662 3649 3648 3903 3903 3934 3649 3649 3934 3955 3651 3649 3955 3903 3933 3934 3955 3934 3956 3933 3956 3934 3955 3956 3957 3957 3966 3955 3955 3966 3965 3955 3965 3651 3957 3956 3958 3958 3956 3954 3960 3954 3956 3960 3956 3933 3958 3968 3957 3957 3968 3966 3965 3966 3967 3967 3966 3968 3651 3965 3938 3938 3965 3967 3651 3652 3653 3652 3651 3920 3920 3651 3938 3920 3938 3919 3919 3938 3939 3938 3967 3939 3919 3913 3920 3920 3913 3889 3920 3889 3652 3918 3916 3919 3919 3916 3913 3937 3918 3919 3919 3939 3937 3939 3967 3970 3970 3937 3939 3936 3918 3937 3970 3936 3937 3962 3970 3967 3962 3967 3963 3963 3967 3968 3963 3950 3962 3963 3968 3964 3958 3964 3968 3913 3890 3889 3913 3888 3890 3860 3889 3890 3860 3890 3888 3859 3889 3860 3859 3863 3889 3889 3863 3862 3889 3862 3652 3859 3860 3861 3861 3860 3858 3858 3860 3888 3864 3863 3859 3859 3861 3864 3862 3863 3864 3864 3865 3862 3652 3862 3865 3866 3653 3652 3652 3865 3866 3865 3662 3866 3864 3662 3865 3866 3662 3653 3858 3643 3861 3906 3932 3933 3906 3933 3902 3902 3933 3903 3932 3960 3933 3905 3906 3907 3906 3902 3907 3905 3932 3906 3905 3931 3932 3931 3960 3932 3930 3953 3960 3930 3960 3929 3931 3929 3960 3953 3954 3960 3911 3542 3931 3911 3931 3905 3542 3929 3931 3542 3541 3929 3929 3541 3922 3929 3922 3930 3930 3922 3921 3921 3953 3930 3921 3923 3953 3921 3922 3923 3922 3541 5259 3541 3542 3543 3541 3543 5249 3541 5249 5259 3543 3542 3544 3544 3542 3911 3543 3544 3871 3543 3871 3872 5249 3543 3872 5249 3872 5251 3872 3871 3873 3872 3873 3874 5251 3872 3874 3909 3871 3910 3910 3871 3544 3909 3873 3871 3910 3544 3911 3911 3905 3910 3910 3905 3907 3910 3907 3909 3909 3875 3873 3873 3875 3874 2123 2500 2121 2121 2122 2123 2122 2129 2123 2121 2120 2122 2342 2129 2122 2342 2122 2343 2122 2120 2343 1554 2342 1555 1555 2342 2343 2642 2638 2637 5155 2642 5160 5160 2642 2637 5157 5155 5160 2064 2063 2065 2064 2065 2066 2412 2064 2066 2490 2412 2491 2151 2490 2491 4641 4651 4653 4641 4653 4639 4639 4640 4641 4640 4642 4641 4642 4651 4641 4640 2912 4642 5791 5794 5796 5791 5792 5787 5787 5789 5791 5791 5789 5794 5789 2781 5794 5794 2781 2783 2779 2780 2781 2781 2780 2782 2781 2782 2783 5789 2779 2781 2778 2777 2779 2779 2777 2780 5786 2778 2779 5786 2779 5789 2777 4663 2780 2776 2775 2777 2776 2777 2778 2777 4662 4663 2777 2775 4662 2776 2778 5786 5789 5790 5786 5809 2776 5786 5809 5786 5790 5787 5788 5789 5789 5788 5790 5809 5790 5788 5808 5809 5788 5808 5788 5787 5787 5792 5808 4663 4662 4664 4662 2775 4689 4662 4689 4664 4663 4664 4661 4689 4661 4664 2773 4689 2775 1718 1719 1720 1768 1767 1719 1719 1767 1787 1719 1787 1788 1788 1806 1719 1719 1806 1807 1719 1807 1720 1718 1720 5971 1807 5971 1720 1718 5971 5972 5972 5971 5973 5962 5973 5971 5962 5971 1807 5961 5962 1807 1807 1806 5961 5961 1806 1788 5961 1788 5965 5965 1788 1787 5962 5961 5963 5963 5961 5965 5963 5964 5962 5964 5973 5962 5964 3125 5973 5964 5963 3121 3121 3125 5964 3125 3121 3120 3129 3125 3130 3130 3125 3120 3120 3121 3122 3120 3122 4355 3130 3120 4355 4381 3129 3130 4376 3129 4381 4378 4376 4381 1766 1767 1768 2459 1766 2460 2460 1766 1768 4369 4372 4357 4369 4357 4337 4337 4357 4338 4368 4360 4372 4368 4372 4369 4360 4363 4372 4342 4367 4368 4342 4368 4343 4343 4368 4369 4367 4360 4368 3108 4341 4342 3108 4342 4343 4341 4367 4342 4341 4366 4367 4366 4358 4367 4367 4358 4360 4340 4341 3108 4364 4341 4365 4365 4341 4340 4364 4366 4341 4358 4366 4386 4386 4366 4364 4358 4359 4360 4358 4386 4359 4359 4386 4385 4386 4364 3099 4406 4385 4386 3099 4364 4365 4365 4340 3109 3099 4365 3109 3108 3109 4340 3108 3099 3109 4343 4344 3108 3108 4344 4345 3108 4345 4328 4343 4369 4344 4369 4345 4344 4328 4345 4346 4369 4346 4345 4328 4346 4337 4337 4346 4369 4359 4385 4361 4361 4385 4362 4359 4361 4360 4361 4362 4363 4360 4361 4363 3697 3698 3699 3769 3697 3699 3661 3660 3697 3697 3660 3698 3770 3661 3697 3770 3697 3769 3774 3698 3775 3775 3698 3660 3777 3774 3775 3769 3766 3767 3769 3767 3770 3770 3767 3768 3766 3592 3767 3767 3592 3580 3767 3580 3768 3580 3582 3768 3580 3581 3582 3582 3581 3583 3585 3583 5334 2516 2437 2438 2516 2438 2517 2517 2438 2440 2271 2516 2517 2517 2440 2518 2271 2517 2269 2269 2517 2518 2518 2440 2439 2518 2439 2519 2269 2518 2266 2266 2518 2519 2439 1731 2441 2519 2439 2441 2519 2441 2520 2266 2519 2264 2264 2519 2520 2441 1731 1759 2441 1759 2442 2520 2441 2442 1731 1758 1759 1793 1792 1759 1793 1759 1794 1794 1759 1758 2442 1759 1792 2442 1792 2443 2520 2442 2521 2521 2442 2443 1791 1790 1792 1791 1792 1793 2443 1792 1790 2443 1790 2444 2521 2443 2522 2522 2443 2444 2261 2520 2521 2261 2521 2259 2259 2521 2522 2522 2444 2523 2259 2522 2250 2250 2522 2523 2444 1790 1789 1658 1789 1790 1658 1790 1791 5361 1658 1791 1791 5345 5361 5361 5345 5343 5361 5343 5360 5345 1791 1793 5345 1793 5343 5342 5343 5344 5343 1793 5344 5360 5343 5342 5349 5360 5346 5360 5342 5346 5342 5344 5346 5344 1793 1794 5344 1794 5350 5346 5344 5348 5348 5344 5350 5348 5349 5346 5348 5347 5349 5350 1794 1758 5350 1758 5351 2250 2523 2251 2264 2520 2261 5320 1756 1755 2223 2534 2221 2506 2427 2428 2351 2292 2352 1543 2351 1539 1539 2351 2352 2290 2292 2291 2292 2290 2352 2352 2290 2288 2289 2288 2290 2289 2290 2291 2291 2509 2289 6248 6249 6250 6322 6323 6248 6248 6323 6249 6250 6354 6248 6248 6354 6322 6250 6249 6251 6250 6251 6252 6252 6352 6250 6250 6352 6354 6352 6353 6354 6354 6353 6355 6354 6355 6356 6356 6322 6354 6350 6351 6352 6352 6351 6353 6252 6350 6352 6249 6355 6353 6249 6353 6251 6251 6353 6351 6356 6355 6357 6323 6357 6355 6323 6355 6249 6356 6357 6358 6320 6322 6356 6356 6358 6320 6358 6357 6359 6321 6359 6357 6321 6357 6323 6358 6359 6360 6320 6358 6360 6360 6359 6361 6319 6361 6359 6319 6359 6321 6320 6319 6321 6320 6321 6322 6322 6321 6323 6318 6319 6320 6320 6360 6318 6360 6361 6362 6318 6360 6362 6362 6361 6363 6317 6363 6361 6317 6361 6319 6318 6317 6319 6316 6317 6318 6318 6362 6316 6362 6363 6364 6316 6362 6364 6364 6363 6365 6315 6365 6363 6315 6363 6317 6316 6315 6317 6314 6315 6316 6316 6364 6314 6364 6365 6366 6314 6364 6366 6366 6365 6367 6313 6367 6365 6313 6365 6315 6314 6313 6315 6312 6313 6314 6314 6366 6312 6366 6367 6368 6312 6366 6368 6368 6367 6369 6311 6369 6367 6311 6367 6313 6312 6311 6313 6310 6311 6312 6312 6368 6310 6368 6369 6370 6310 6368 6370 6370 6369 6371 6309 6371 6369 6309 6369 6311 6310 6309 6311 6308 6309 6310 6310 6370 6308 6370 6371 6372 6308 6370 6372 6372 6371 6373 6307 6373 6371 6307 6371 6309 6308 6307 6309 6306 6307 6308 6308 6372 6306 6372 6373 6374 6306 6372 6374 6374 6373 6375 6305 6375 6373 6305 6373 6307 6306 6305 6307 6304 6305 6306 6306 6374 6304 6374 6375 6376 6304 6374 6376 6376 6375 6377 6303 6377 6375 6303 6375 6305 6304 6303 6305 6302 6303 6304 6304 6376 6302 6376 6377 6378 6302 6376 6378 6378 6377 6379 6301 6379 6377 6301 6377 6303 6302 6301 6303 6300 6301 6302 6302 6378 6300 6378 6379 6380 6300 6378 6380 6380 6379 6381 6299 6381 6379 6299 6379 6301 6300 6299 6301 6298 6299 6300 6300 6380 6298 6380 6381 6382 6298 6380 6382 6382 6381 6383 6297 6383 6381 6297 6381 6299 6298 6297 6299 6296 6297 6298 6298 6382 6296 6382 6383 6384 6296 6382 6384 6384 6383 6385 6295 6385 6383 6295 6383 6297 6296 6295 6297 6294 6295 6296 6296 6384 6294 6384 6385 6386 6294 6384 6386 6386 6385 6387 6293 6387 6385 6293 6385 6295 6294 6293 6295 6292 6293 6294 6294 6386 6292 6386 6387 6388 6292 6386 6388 6388 6387 6389 6291 6389 6387 6291 6387 6293 6292 6291 6293 6290 6291 6292 6292 6388 6290 6388 6389 6390 6290 6388 6390 6390 6389 6391 6289 6391 6389 6289 6389 6291 6290 6289 6291 6288 6289 6290 6290 6390 6288 6390 6391 6392 6288 6390 6392 6392 6391 6393 6287 6393 6391 6287 6391 6289 6288 6287 6289 6286 6287 6288 6288 6392 6286 6392 6393 6394 6286 6392 6394 6394 6393 6395 6285 6395 6393 6285 6393 6287 6286 6285 6287 6284 6285 6286 6286 6394 6284 6394 6395 6396 6284 6394 6396 6396 6395 6397 6283 6395 6285 6283 6397 6395 6284 6283 6285 6282 6283 6284 6284 6396 6282 6396 6397 6398 6282 6396 6398 6398 6397 6399 6281 6399 6397 6281 6397 6283 6282 6281 6283 6280 6281 6282 6282 6398 6280 6398 6399 6324 6280 6398 6324 6324 6399 6325 6279 6325 6399 6279 6399 6281 6280 6279 6281 6278 6279 6280 6280 6324 6278 6324 6325 6326 6278 6324 6326 6326 6325 6327 6277 6327 6325 6277 6325 6279 6278 6277 6279 6276 6277 6278 6278 6326 6276 6326 6327 6328 6276 6326 6328 6328 6327 6329 6275 6329 6327 6275 6327 6277 6276 6275 6277 6274 6275 6276 6276 6328 6274 6328 6329 6330 6274 6328 6330 6330 6329 6331 6273 6331 6329 6273 6329 6275 6274 6273 6275 6272 6273 6274 6274 6330 6272 6330 6331 6332 6272 6330 6332 6332 6331 6333 6271 6333 6331 6271 6331 6273 6272 6271 6273 6270 6271 6272 6272 6332 6270 6332 6333 6334 6270 6332 6334 6334 6333 6335 6269 6335 6333 6269 6333 6271 6270 6269 6271 6268 6269 6270 6270 6334 6268 6334 6335 6336 6268 6334 6336 6336 6335 6337 6267 6337 6335 6267 6335 6269 6268 6267 6269 6266 6267 6268 6268 6336 6266 6336 6337 6338 6266 6336 6338 6338 6337 6339 6265 6339 6337 6265 6337 6267 6266 6265 6267 6264 6265 6266 6266 6338 6264 6338 6339 6340 6264 6338 6340 6340 6339 6341 6263 6341 6339 6263 6339 6265 6264 6263 6265 6262 6263 6264 6264 6340 6262 6340 6341 6342 6262 6340 6342 6342 6341 6343 6261 6343 6341 6261 6341 6263 6262 6261 6263 6260 6261 6262 6262 6342 6260 6342 6343 6344 6260 6342 6344 6344 6343 6345 6259 6345 6343 6259 6343 6261 6260 6259 6261 6258 6259 6260 6260 6344 6258 6344 6345 6346 6258 6344 6346 6346 6345 6347 6257 6347 6345 6257 6345 6259 6258 6257 6259 6256 6257 6258 6258 6346 6256 6346 6347 6348 6256 6346 6348 6348 6347 6349 6255 6349 6347 6255 6347 6257 6256 6255 6257 6254 6255 6256 6256 6348 6254 6348 6349 6350 6254 6348 6350 6350 6349 6351 6253 6351 6349 6253 6349 6255 6254 6253 6255 6252 6253 6254 6254 6350 6252 6252 6251 6253 6251 6351 6253))
                   (list :vertices (let ((mat (make-matrix 6400 3))) (fvector-replace (array-entity mat) #f(-9.6963096618652344e+01 -4.6850399017333984e+01 -3.5008001708984375e+02 -9.7088905334472656e+01 -4.6593498229980469e+01 -3.4286401367187500e+02 -1.0166799926757812e+02 -4.8837799072265625e+01 -3.4282101440429688e+02 -1.0795400238037109e+02 -5.0696296691894531e+01 -3.5008001708984375e+02 -8.7103500366210938e+01 -4.0655200958251953e+01 -3.5008001708984375e+02 -7.8869796752929688e+01 -3.2421501159667969e+01 -3.5008001708984375e+02 -7.9081398010253906e+01 -3.2245201110839844e+01 -3.4313800048828125e+02 -8.3283798217773438e+01 -3.7290302276611328e+01 -3.4304199218750000e+02 -8.7280105590820312e+01 -4.0430400848388672e+01 -3.4298199462890625e+02 -9.1866600036621094e+01 -4.4034202575683594e+01 -3.4291299438476562e+02 -6.8338600158691406e+01 -9.1626005172729492e+00 -3.4358001708984375e+02 -6.9011398315429688e+01 -1.1518899917602539e+01 -3.4353500366210938e+02 -6.8828704833984375e+01 -1.1571000099182129e+01 -3.5008001708984375e+02 -7.1216400146484375e+01 -1.9242801666259766e+01 -3.4338699340820312e+02 -7.2674598693847656e+01 -2.2561901092529297e+01 -3.5008001708984375e+02 -7.2899993896484375e+01 -2.2443401336669922e+01 -3.4332598876953125e+02 -7.6297798156738281e+01 -2.8903400421142578e+01 -3.4320199584960938e+02 -6.7525199890136719e+01 1.2280599772930145e-01 -3.1479299926757812e+02 -6.7525001525878906e+01 0.0000000000000000e+00 -3.5008001708984375e+02 -6.7851997375488281e+01 5.8221197128295898e+00 -3.1479299926757812e+02 -6.8828704833984375e+01 1.1571000099182129e+01 -3.5008001708984375e+02 -6.7731300354003906e+01 -4.6268100738525391e+00 -3.4358001708984375e+02 -6.7525001525878906e+01 0.0000000000000000e+00 -3.4358001708984375e+02 -6.7525001525878906e+01 0.0000000000000000e+00 -3.1479299926757812e+02 -7.2674598693847656e+01 2.2561901092529297e+01 -3.5008001708984375e+02 -7.0443099975585938e+01 1.7174499511718750e+01 -3.1479299926757812e+02 -6.8828704833984375e+01 1.1571000099182129e+01 -3.1479299926757812e+02 -7.8869796752929688e+01 3.2421501159667969e+01 -3.5008001708984375e+02 -7.5495399475097656e+01 2.7665599822998047e+01 -3.1479299926757812e+02 -7.2674598693847656e+01 2.2561901092529297e+01 -3.1479299926757812e+02 -8.7103500366210938e+01 4.0655200958251953e+01 -3.5008001708984375e+02 -8.2755500793457031e+01 3.6769496917724609e+01 -3.1479299926757812e+02 -7.8869796752929688e+01 3.2421501159667969e+01 -3.1479299926757812e+02 -9.6963096618652344e+01 4.6850399017333984e+01 -3.5008001708984375e+02 -9.1859397888183594e+01 4.4029602050781250e+01 -3.1479299926757812e+02 -8.7103500366210938e+01 4.0655200958251953e+01 -3.1479299926757812e+02 -1.0795400238037109e+02 5.0696296691894531e+01 -3.5008001708984375e+02 -1.0235100555419922e+02 4.9081897735595703e+01 -3.1479299926757812e+02 -9.6963096618652344e+01 4.6850399017333984e+01 -3.1479299926757812e+02 -1.1952500152587891e+02 5.2000000000000000e+01 -3.5008001708984375e+02 -1.1370299530029297e+02 5.1673000335693359e+01 -3.1479299926757812e+02 -1.0795400238037109e+02 5.0696296691894531e+01 -3.1479299926757812e+02 -1.3109600830078125e+02 5.0696296691894531e+01 -3.5008001708984375e+02 -1.2534700012207031e+02 5.1673000335693359e+01 -3.1479299926757812e+02 -1.1952500152587891e+02 5.2000000000000000e+01 -3.1479299926757812e+02 -1.4208699035644531e+02 4.6850399017333984e+01 -3.5008001708984375e+02 -1.3669900512695312e+02 4.9081897735595703e+01 -3.1479299926757812e+02 -1.3109600830078125e+02 5.0696296691894531e+01 -3.1479299926757812e+02 -1.5194599914550781e+02 4.0655200958251953e+01 -3.5008001708984375e+02 -1.4719100952148438e+02 4.4029602050781250e+01 -3.1479299926757812e+02 -1.4208699035644531e+02 4.6850399017333984e+01 -3.1479299926757812e+02 -1.6018000793457031e+02 3.2421501159667969e+01 -3.5008001708984375e+02 -1.5629499816894531e+02 3.6769496917724609e+01 -3.1479299926757812e+02 -1.5194599914550781e+02 4.0655200958251953e+01 -3.1479299926757812e+02 -1.6637500000000000e+02 2.2561901092529297e+01 -3.5008001708984375e+02 -1.6355499267578125e+02 2.7665599822998047e+01 -3.1479299926757812e+02 -1.6018000793457031e+02 3.2421501159667969e+01 -3.1479299926757812e+02 -1.7119100952148438e+02 5.8831601142883301e+00 -3.1479299926757812e+02 -1.7022100830078125e+02 1.1571000099182129e+01 -3.1479299926757812e+02 -1.7022100830078125e+02 1.1571000099182129e+01 -3.5008001708984375e+02 -1.6860699462890625e+02 1.7174499511718750e+01 -3.1479299926757812e+02 -1.6637500000000000e+02 2.2561901092529297e+01 -3.1479299926757812e+02 -1.7152200317382812e+02 -5.4261600971221924e-01 -3.1478500366210938e+02 -1.7152499389648438e+02 0.0000000000000000e+00 -3.5008001708984375e+02 -1.7055999755859375e+02 -9.9722700119018555e+00 -3.1393499755859375e+02 -1.7022100830078125e+02 -1.1571000099182129e+01 -3.5008001708984375e+02 -1.7018200683593750e+02 -1.1561699867248535e+01 -3.1363800048828125e+02 -1.7152499389648438e+02 -2.0996099710464478e-01 -3.1479098510742188e+02 -1.7152499389648438e+02 0.0000000000000000e+00 -3.1479199218750000e+02 -1.7152499389648438e+02 1.2280599772930145e-01 -3.1479299926757812e+02 -1.6958999633789062e+02 -1.4054000854492188e+01 -3.1317300415039062e+02 -1.6637500000000000e+02 -2.2561901092529297e+01 -3.5008001708984375e+02 -1.6844500732421875e+02 -1.7630100250244141e+01 -3.1242098999023438e+02 -1.6018000793457031e+02 -3.2421501159667969e+01 -3.5008001708984375e+02 -1.6409100341796875e+02 -2.6793598175048828e+01 -3.0948400878906250e+02 -1.6615200805664062e+02 -2.2455801010131836e+01 -3.1087399291992188e+02 -1.5194599914550781e+02 -4.0655200958251953e+01 -3.5008001708984375e+02 -1.5785899353027344e+02 -3.5135898590087891e+01 -3.0519598388671875e+02 -1.5999198913574219e+02 -3.2280300140380859e+01 -3.0666400146484375e+02 -1.4208699035644531e+02 -4.6850399017333984e+01 -3.5008001708984375e+02 -1.4992199707031250e+02 -4.2189899444580078e+01 -2.9967300415039062e+02 -1.5181599426269531e+02 -4.0507099151611328e+01 -3.0098999023437500e+02 -1.0802099609375000e+02 -5.0428699493408203e+01 -3.4279000854492188e+02 -1.1225599670410156e+02 -5.1489498138427734e+01 -3.4277001953125000e+02 -1.1952500152587891e+02 -5.2000000000000000e+01 -3.5008001708984375e+02 -1.1952500152587891e+02 -5.2000000000000000e+01 -3.4276000976562500e+02 -1.3109600830078125e+02 -5.0696296691894531e+01 -3.5008001708984375e+02 -1.1952500152587891e+02 -5.2000000000000000e+01 -2.7821600341796875e+02 -1.3030000305175781e+02 -5.0871299743652344e+01 -2.8586300659179688e+02 -1.3107299804687500e+02 -5.0621402740478516e+01 -2.8640802001953125e+02 -1.4059500122070312e+02 -4.7539798736572266e+01 -2.9313000488281250e+02 -1.4201599121093750e+02 -4.6724899291992188e+01 -2.9412698364257812e+02 -9.7982696533203125e+01 4.2894401550292969e+01 -3.5258001708984375e+02 -8.8671203613281250e+01 3.6770103454589844e+01 -3.5258001708984375e+02 -1.5037899780273438e+02 3.6770103454589844e+01 -3.5258001708984375e+02 -7.5450706481933594e+01 1.9011798858642578e+01 -3.5258001708984375e+02 -7.2254203796386719e+01 8.3351097106933594e+00 -3.5258001708984375e+02 -8.4611099243164062e+01 -3.2939502716064453e+01 -3.5258001708984375e+02 -9.3148597717285156e+01 -4.0103397369384766e+01 -3.5258001708984375e+02 -1.0310799407958984e+02 -4.5105201721191406e+01 -3.5258001708984375e+02 -1.6109399414062500e+02 -2.4000000000000000e+01 -3.5258001708984375e+02 -1.6550799560546875e+02 -1.3766500473022461e+01 -3.5258001708984375e+02 -1.6744400024414062e+02 -2.7909300327301025e+00 -3.5258001708984375e+02 -1.6679600524902344e+02 8.3351097106933594e+00 -3.5258001708984375e+02 -1.4106700134277344e+02 4.2894401550292969e+01 -3.5258001708984375e+02 -1.3059500122070312e+02 4.6706100463867188e+01 -3.5258001708984375e+02 -8.1023094177246094e+01 2.8663599014282227e+01 -3.5258001708984375e+02 -7.1606193542480469e+01 -2.7909300327301025e+00 -3.5258001708984375e+02 -7.3541496276855469e+01 -1.3766500473022461e+01 -3.5258001708984375e+02 -7.7955795288085938e+01 -2.4000000000000000e+01 -3.5258001708984375e+02 -1.1395300292968750e+02 -4.7675399780273438e+01 -3.5258001708984375e+02 -1.2509700775146484e+02 -4.7675399780273438e+01 -3.5258001708984375e+02 -1.3594200134277344e+02 -4.5105201721191406e+01 -3.5258001708984375e+02 -1.6359899902343750e+02 1.9011798858642578e+01 -3.5258001708984375e+02 -1.5802699279785156e+02 2.8663599014282227e+01 -3.5258001708984375e+02 -1.1952500152587891e+02 4.8000000000000000e+01 -3.5258001708984375e+02 -1.0845500183105469e+02 4.6706100463867188e+01 -3.5258001708984375e+02 -1.4590100097656250e+02 -4.0103397369384766e+01 -3.5258001708984375e+02 -1.5443899536132812e+02 -3.2939502716064453e+01 -3.5258001708984375e+02 -3.0936100006103516e+01 -9.6074295043945312e+00 -3.4197900390625000e+02 -3.2741798400878906e+01 -9.6074295043945312e+00 -3.4091799926757812e+02 -3.2652797698974609e+01 -2.9996600151062012e+00 -3.4076300048828125e+02 -4.7360000610351562e+01 -5.1744599342346191e+00 -2.4820999145507812e+02 -4.2894699096679688e+01 -5.1744599342346191e+00 -2.4374499511718750e+02 -4.2843898773193359e+01 -2.9996600151062012e+00 -2.4380099487304688e+02 -2.1590101242065430e+01 -5.4014301300048828e+00 -2.3133200073242188e+02 -2.1167699813842773e+01 -5.4672899246215820e+00 -2.3120500183105469e+02 -2.1144998550415039e+01 -2.9996600151062012e+00 -2.3127398681640625e+02 -7.5188999176025391e+00 -8.5302000045776367e+00 -2.2833799743652344e+02 -3.4786000251770020e+00 -9.7153797149658203e+00 -2.2809700012207031e+02 -2.8845000267028809e+00 -9.6227502822875977e+00 -2.2809399414062500e+02 -1.2673900604248047e+01 -7.1309199333190918e+00 -2.2903900146484375e+02 -8.8366003036499023e+00 -8.1725702285766602e+00 -2.2851699829101562e+02 -8.8234004974365234e+00 -2.9996600151062012e+00 -2.2865499877929688e+02 -2.5341000556945801e+00 -9.6074295043945312e+00 -2.2809399414062500e+02 3.7734000682830811e+00 -2.9996600151062012e+00 -2.2865499877929688e+02 -1.7581001281738281e+01 -6.0268597602844238e+00 -2.3012701416015625e+02 -3.2652797698974609e+01 -2.9996600151062012e+00 -2.3639700317382812e+02 -3.7986999511718750e+01 -5.1744599342346191e+00 -2.3977099609375000e+02 -3.2690700531005859e+01 -5.1744599342346191e+00 -2.3633099365234375e+02 -2.5288301467895508e+01 -5.1744599342346191e+00 -2.3270800781250000e+02 -5.1334300994873047e+01 -5.1744599342346191e+00 -2.5311801147460938e+02 -5.1272796630859375e+01 -2.9996600151062012e+00 -2.5316300964355469e+02 -5.4773597717285156e+01 -5.1744599342346191e+00 -2.5841400146484375e+02 -5.7571197509765625e+01 -2.9996600151062012e+00 -2.6407199096679688e+02 -5.7640602111816406e+01 -5.1744599342346191e+00 -2.6404101562500000e+02 -5.9903701782226562e+01 -5.1744599342346191e+00 -2.6993701171875000e+02 -6.1463798522949219e+01 -2.9996600151062012e+00 -2.7605200195312500e+02 -6.1538200378417969e+01 -5.1744599342346191e+00 -2.7603598022460938e+02 -6.2526000976562500e+01 -5.1744599342346191e+00 -2.8227401733398438e+02 -6.2780597686767578e+01 -2.9996600151062012e+00 -2.8857998657226562e+02 -6.2856502532958984e+01 -5.1744599342346191e+00 -2.8857998657226562e+02 -6.1463798522949219e+01 -2.9996600151062012e+00 -3.0110800170898438e+02 -5.7571197509765625e+01 -2.9996600151062012e+00 -3.1308801269531250e+02 -5.7640602111816406e+01 -5.1744599342346191e+00 -3.1311898803710938e+02 -5.9903701782226562e+01 -5.1744599342346191e+00 -3.0722299194335938e+02 -6.1538200378417969e+01 -5.1744599342346191e+00 -3.0112399291992188e+02 -6.2526000976562500e+01 -5.1744599342346191e+00 -2.9488598632812500e+02 -5.1272796630859375e+01 -2.9996600151062012e+00 -3.2399697875976562e+02 -4.2843898773193359e+01 -2.9996600151062012e+00 -3.3335900878906250e+02 -4.2894699096679688e+01 -5.1744599342346191e+00 -3.3341500854492188e+02 -4.7360000610351562e+01 -5.1744599342346191e+00 -3.2894998168945312e+02 -5.1334300994873047e+01 -5.1744599342346191e+00 -3.2404199218750000e+02 -5.4773597717285156e+01 -5.1744599342346191e+00 -3.1874600219726562e+02 -3.5337299346923828e+01 -9.6074295043945312e+00 -3.3939297485351562e+02 -3.5145301818847656e+01 -7.3775596618652344e+00 -3.3942401123046875e+02 -3.4954799652099609e+01 -5.1744599342346191e+00 -3.3945401000976562e+02 -3.8733898162841797e+01 -5.1744599342346191e+00 -3.3683801269531250e+02 -2.2766599655151367e+01 -9.6074295043945312e+00 -3.4557901000976562e+02 -2.1144998550415039e+01 -2.9996600151062012e+00 -3.4588598632812500e+02 -2.1190200805664062e+01 -9.6074295043945312e+00 -3.4601101684570312e+02 -1.4156299591064453e+01 -9.6074295043945312e+00 -3.4793698120117188e+02 -8.8234004974365234e+00 -2.9996600151062012e+00 -3.4850500488281250e+02 -8.8286991119384766e+00 -9.6074295043945312e+00 -3.4857800292968750e+02 3.7734000682830811e+00 -2.9996600151062012e+00 -3.4850500488281250e+02 3.6317000389099121e+00 -9.6074295043945312e+00 -3.4875198364257812e+02 -5.2925000190734863e+00 -9.6074295043945312e+00 -3.4900299072265625e+02 2.0885999679565430e+01 -9.6074295043945312e+00 -3.4435202026367188e+02 1.6114700317382812e+01 -9.6074295043945312e+00 -3.4595199584960938e+02 1.6094900131225586e+01 -2.9996600151062012e+00 -3.4588598632812500e+02 1.2421599388122559e+01 -9.6074295043945312e+00 -3.4719000244140625e+02 3.7954001426696777e+00 -9.6074295043945312e+00 -3.4872299194335938e+02 2.7680799484252930e+01 -9.6074295043945312e+00 -3.4088900756835938e+02 2.7602798461914062e+01 -2.9996600151062012e+00 -3.4076300048828125e+02 2.8840299606323242e+01 -9.6074295043945312e+00 -3.4029901123046875e+02 3.7793800354003906e+01 -2.9996600151062012e+00 -3.3335900878906250e+02 3.6111400604248047e+01 -9.6074295043945312e+00 -3.3511798095703125e+02 4.7988399505615234e+01 -9.6074295043945312e+00 -3.2185098266601562e+02 4.6297500610351562e+01 -9.6074295043945312e+00 -3.2404699707031250e+02 4.6222702026367188e+01 -2.9996600151062012e+00 -3.2399697875976562e+02 4.2540798187255859e+01 -9.6074295043945312e+00 -3.2892401123046875e+02 3.7857601165771484e+01 -9.6074295043945312e+00 -3.3343600463867188e+02 5.2335502624511719e+01 -9.6074295043945312e+00 -3.1405401611328125e+02 5.2521099090576172e+01 -2.9996600151062012e+00 -3.1308801269531250e+02 5.2672901153564453e+01 -9.6074295043945312e+00 -3.1316000366210938e+02 5.5487499237060547e+01 -9.6074295043945312e+00 -3.0570098876953125e+02 5.6413799285888672e+01 -2.9996600151062012e+00 -3.0110800170898438e+02 5.6478702545166016e+01 -9.6074295043945312e+00 -3.0112100219726562e+02 5.6491500854492188e+01 -9.6074295043945312e+00 -2.7603900146484375e+02 5.7224697113037109e+01 -9.6074295043945312e+00 -2.7916900634765625e+02 5.6413799285888672e+01 -2.9996600151062012e+00 -2.7605200195312500e+02 5.7959098815917969e+01 -9.6074295043945312e+00 -2.8806701660156250e+02 5.7730499267578125e+01 -2.9996600151062012e+00 -2.8857998657226562e+02 5.7925701141357422e+01 -9.6074295043945312e+00 -2.8857800292968750e+02 5.7375801086425781e+01 -9.6074295043945312e+00 -2.9697497558593750e+02 5.2521099090576172e+01 -2.9996600151062012e+00 -2.6407199096679688e+02 5.2625999450683594e+01 -9.6074295043945312e+00 -2.6401998901367188e+02 5.5188701629638672e+01 -9.6074295043945312e+00 -2.7047698974609375e+02 4.6222702026367188e+01 -2.9996600151062012e+00 -2.5316300964355469e+02 4.7416603088378906e+01 -9.6074295043945312e+00 -2.5445600891113281e+02 5.1895397186279297e+01 -9.6074295043945312e+00 -2.6217898559570312e+02 3.5316299438476562e+01 -9.6074295043945312e+00 -2.4139300537109375e+02 3.7841598510742188e+01 -9.6074295043945312e+00 -2.4374400329589844e+02 3.7793800354003906e+01 -2.9996600151062012e+00 -2.4380099487304688e+02 4.1849800109863281e+01 -9.6074295043945312e+00 -2.4747698974609375e+02 4.6328300476074219e+01 -9.6074295043945312e+00 -2.5309199523925781e+02 2.7958400726318359e+01 -9.6074295043945312e+00 -2.3633700561523438e+02 2.7602798461914062e+01 -2.9996600151062012e+00 -2.3639700317382812e+02 2.7709400177001953e+01 -9.6074295043945312e+00 -2.3621499633789062e+02 1.9936300277709961e+01 -9.6074295043945312e+00 -2.3241900634765625e+02 1.6094900131225586e+01 -2.9996600151062012e+00 -2.3127398681640625e+02 1.6116998672485352e+01 -9.6074295043945312e+00 -2.3120999145507812e+02 2.6098999977111816e+00 -9.6074295043945312e+00 -2.2831199645996094e+02 3.7855000495910645e+00 -9.6074295043945312e+00 -2.2850000000000000e+02 1.1424999237060547e+01 -9.6074295043945312e+00 -2.2972399902343750e+02 -4.2461101531982422e+01 -5.6677299499511719e+01 -2.4422700500488281e+02 -4.2400100708007812e+01 -6.2000000000000000e+01 -2.4429400634765625e+02 -3.9353401184082031e+01 -5.6025596618652344e+01 -2.4159799194335938e+02 -3.2321201324462891e+01 -6.2000000000000000e+01 -2.3697200012207031e+02 -3.6207599639892578e+01 -5.5059196472167969e+01 -2.3927299499511719e+02 -3.2389499664306641e+01 -5.3580898284912109e+01 -2.3685299682617188e+02 -2.1223400115966797e+01 -4.8126899719238281e+01 -2.3174198913574219e+02 -2.3328300476074219e+01 -4.9250000000000000e+01 -2.3249900817871094e+02 -2.0940101623535156e+01 -6.2000000000000000e+01 -2.3190400695800781e+02 -2.7880800247192383e+01 -5.1547901153564453e+01 -2.3444999694824219e+02 -3.2174503326416016e+01 -5.3497699737548828e+01 -2.3671600341796875e+02 -8.7861995697021484e+00 -4.1000499725341797e+01 -2.2900601196289062e+02 -1.0895299911499023e+01 -4.2254398345947266e+01 -2.2922999572753906e+02 -8.7540998458862305e+00 -6.2000000000000000e+01 -2.2931399536132812e+02 -1.6117399215698242e+01 -4.5284599304199219e+01 -2.3025900268554688e+02 -2.1012901306152344e+01 -4.8009700775146484e+01 -2.3168099975585938e+02 -5.5760002136230469e+00 -3.9092102050781250e+01 -2.2866499328613281e+02 3.7040998935699463e+00 -6.2000000000000000e+01 -2.2931399536132812e+02 -3.0058999061584473e+00 -3.7550598144531250e+01 -2.2856298828125000e+02 2.6104001998901367e+00 -1.0392700195312500e+01 -2.2830499267578125e+02 -2.5319001674652100e+00 -1.0392700195312500e+01 -2.2808699035644531e+02 -4.2400100708007812e+01 -6.2000000000000000e+01 -3.3286602783203125e+02 -4.2459499359130859e+01 -5.6912700653076172e+01 -3.3293200683593750e+02 -3.8649600982666016e+01 -5.6912700653076172e+01 -3.3608599853515625e+02 -3.2321201324462891e+01 -6.2000000000000000e+01 -3.4018899536132812e+02 -3.5122100830078125e+01 -5.6912700653076172e+01 -3.3857299804687500e+02 -3.5249599456787109e+01 -3.3792201995849609e+01 -3.3897097778320312e+02 -3.2744697570800781e+01 -1.0392700195312500e+01 -3.4092300415039062e+02 -3.5378097534179688e+01 -1.0392700195312500e+01 -3.3937500000000000e+02 -5.0736198425292969e+01 -6.2000000000000000e+01 -3.2360800170898438e+02 -5.6965297698974609e+01 -6.2000000000000000e+01 -3.1281799316406250e+02 -5.7046497344970703e+01 -5.6912700653076172e+01 -3.1285501098632812e+02 -5.4210399627685547e+01 -5.6912700653076172e+01 -3.1842102050781250e+02 -5.0808097839355469e+01 -5.6912700653076172e+01 -3.2365997314453125e+02 -4.6876800537109375e+01 -5.6912700653076172e+01 -3.2851498413085938e+02 -6.0815200805664062e+01 -6.2000000000000000e+01 -3.0097000122070312e+02 -6.2117401123046875e+01 -6.2000000000000000e+01 -2.8857998657226562e+02 -6.2206100463867188e+01 -5.6912700653076172e+01 -2.8857998657226562e+02 -6.1879199981689453e+01 -5.6912700653076172e+01 -2.9481802368164062e+02 -6.0902000427246094e+01 -5.6912700653076172e+01 -3.0098797607421875e+02 -5.9285099029541016e+01 -5.6912700653076172e+01 -3.0702297973632812e+02 -6.0815200805664062e+01 -6.2000000000000000e+01 -2.7619000244140625e+02 -5.6965297698974609e+01 -6.2000000000000000e+01 -2.6434201049804688e+02 -5.7046497344970703e+01 -5.6912700653076172e+01 -2.6430599975585938e+02 -5.9285099029541016e+01 -5.6912700653076172e+01 -2.7013800048828125e+02 -6.0902000427246094e+01 -5.6912700653076172e+01 -2.7617199707031250e+02 -6.1879199981689453e+01 -5.6912700653076172e+01 -2.8234197998046875e+02 -4.2500701904296875e+01 -5.6685600280761719e+01 -2.4425999450683594e+02 -4.5370601654052734e+01 -5.6912700653076172e+01 -2.4703399658203125e+02 -5.0736198425292969e+01 -6.2000000000000000e+01 -2.5355300903320312e+02 -5.0808097839355469e+01 -5.6912700653076172e+01 -2.5350001525878906e+02 -5.4210399627685547e+01 -5.6912700653076172e+01 -2.5873898315429688e+02 5.7231502532958984e+01 -1.0392700195312500e+01 -2.7916799926757812e+02 5.5765098571777344e+01 -6.2000000000000000e+01 -2.7619000244140625e+02 5.7965999603271484e+01 -1.0392700195312500e+01 -2.8806701660156250e+02 5.7067302703857422e+01 -6.2000000000000000e+01 -2.8857998657226562e+02 5.2632297515869141e+01 -1.0392700195312500e+01 -2.6401699829101562e+02 5.1915298461914062e+01 -6.2000000000000000e+01 -2.6434201049804688e+02 5.5195201873779297e+01 -1.0392700195312500e+01 -2.7047500610351562e+02 5.6498100280761719e+01 -1.0392700195312500e+01 -2.7603701782226562e+02 5.1901599884033203e+01 -1.0392700195312500e+01 -2.6217599487304688e+02 4.7422302246093750e+01 -1.0392700195312500e+01 -2.5445199584960938e+02 4.5686199188232422e+01 -6.2000000000000000e+01 -2.5355300903320312e+02 3.7846199035644531e+01 -1.0392700195312500e+01 -2.4373899841308594e+02 3.7349998474121094e+01 -6.2000000000000000e+01 -2.4429400634765625e+02 4.1854797363281250e+01 -1.0392700195312500e+01 -2.4747200012207031e+02 4.6333801269531250e+01 -1.0392700195312500e+01 -2.5308799743652344e+02 3.5320503234863281e+01 -1.0392700195312500e+01 -2.4138699340820312e+02 2.7961799621582031e+01 -1.0392700195312500e+01 -2.3633099365234375e+02 2.7271099090576172e+01 -6.2000000000000000e+01 -2.3697200012207031e+02 2.7712799072265625e+01 -1.0392700195312500e+01 -2.3620899963378906e+02 1.9938899993896484e+01 -1.0392700195312500e+01 -2.3241200256347656e+02 1.5890000343322754e+01 -6.2000000000000000e+01 -2.3190400695800781e+02 1.6119100570678711e+01 -1.0392700195312500e+01 -2.3120300292968750e+02 1.1426700592041016e+01 -1.0392700195312500e+01 -2.2971800231933594e+02 3.7862000465393066e+00 -1.0392700195312500e+01 -2.2849400329589844e+02 -3.0939300537109375e+01 -1.0392700195312500e+01 -3.4198498535156250e+02 -2.2769001007080078e+01 -1.0392700195312500e+01 -3.4558499145507812e+02 -2.0940101623535156e+01 -6.2000000000000000e+01 -3.4525601196289062e+02 -8.8294000625610352e+00 -1.0392700195312500e+01 -3.4858502197265625e+02 -8.7540998458862305e+00 -6.2000000000000000e+01 -3.4784600830078125e+02 -1.4157599449157715e+01 -1.0392700195312500e+01 -3.4794400024414062e+02 -2.1192399978637695e+01 -1.0392700195312500e+01 -3.4601699829101562e+02 -5.2927002906799316e+00 -1.0392700195312500e+01 -3.4900997924804688e+02 3.6323001384735107e+00 -1.0392700195312500e+01 -3.4875900268554688e+02 3.7040998935699463e+00 -6.2000000000000000e+01 -3.4784600830078125e+02 3.7960999011993408e+00 -1.0392700195312500e+01 -3.4873001098632812e+02 1.2423299789428711e+01 -1.0392700195312500e+01 -3.4719699096679688e+02 1.5890000343322754e+01 -6.2000000000000000e+01 -3.4525601196289062e+02 1.6116800308227539e+01 -1.0392700195312500e+01 -3.4595901489257812e+02 2.0888698577880859e+01 -1.0392700195312500e+01 -3.4435800170898438e+02 2.7271099090576172e+01 -6.2000000000000000e+01 -3.4018899536132812e+02 3.6115798950195312e+01 -1.0392700195312500e+01 -3.3512399291992188e+02 3.7349998474121094e+01 -6.2000000000000000e+01 -3.3286602783203125e+02 2.8843900680541992e+01 -1.0392700195312500e+01 -3.4030398559570312e+02 2.7684200286865234e+01 -1.0392700195312500e+01 -3.4089498901367188e+02 4.6303100585937500e+01 -1.0392700195312500e+01 -3.2405099487304688e+02 4.5686199188232422e+01 -6.2000000000000000e+01 -3.2360800170898438e+02 4.2545898437500000e+01 -1.0392700195312500e+01 -3.2892901611328125e+02 3.7862201690673828e+01 -1.0392700195312500e+01 -3.3344097900390625e+02 4.7994098663330078e+01 -1.0392700195312500e+01 -3.2185501098632812e+02 5.2341697692871094e+01 -1.0392700195312500e+01 -3.1405700683593750e+02 5.1915298461914062e+01 -6.2000000000000000e+01 -3.1281799316406250e+02 5.2679100036621094e+01 -1.0392700195312500e+01 -3.1316302490234375e+02 5.5494201660156250e+01 -1.0392700195312500e+01 -3.0570300292968750e+02 5.5765098571777344e+01 -6.2000000000000000e+01 -3.0097000122070312e+02 5.6485401153564453e+01 -1.0392700195312500e+01 -3.0112200927734375e+02 5.7382598876953125e+01 -1.0392700195312500e+01 -2.9697601318359375e+02 5.7932498931884766e+01 -1.0392700195312500e+01 -2.8857800292968750e+02 -9.0248504638671875e+01 -9.9999904632568359e+00 -2.5361601257324219e+02 -9.8096305847167969e+01 -9.9999904632568359e+00 -2.7081298828125000e+02 -1.0200899505615234e+02 -9.9999904632568359e+00 -2.6131298828125000e+02 -1.0416500091552734e+02 -9.9999904632568359e+00 -2.6635000610351562e+02 -1.0665699768066406e+02 -9.9999904632568359e+00 -2.6521301269531250e+02 -4.9746498107910156e+01 -9.9999904632568359e+00 -2.4334399414062500e+02 -4.9658100128173828e+01 -9.9999904632568359e+00 -2.4334399414062500e+02 -5.1073497772216797e+01 -9.9999904632568359e+00 -2.4486700439453125e+02 -7.7379600524902344e+01 -9.9999904632568359e+00 -2.4796200561523438e+02 -6.2205501556396484e+01 -9.9999904632568359e+00 -2.6200900268554688e+02 -6.4656097412109375e+01 -9.9999904632568359e+00 -2.6839199829101562e+02 -6.3754699707031250e+01 -9.9999904632568359e+00 -2.4450599670410156e+02 -5.5376800537109375e+01 -9.9999904632568359e+00 -2.5018098449707031e+02 -5.9101100921630859e+01 -9.9999904632568359e+00 -2.5591600036621094e+02 -6.6425895690917969e+01 -9.9999904632568359e+00 -2.7499700927734375e+02 -6.7495597839355469e+01 -9.9999904632568359e+00 -2.8175100708007812e+02 -6.7853500366210938e+01 -9.9999904632568359e+00 -2.8857998657226562e+02 -6.7495597839355469e+01 -9.9999904632568359e+00 -2.9540899658203125e+02 -6.6425895690917969e+01 -9.9999904632568359e+00 -3.0216299438476562e+02 -6.6337501525878906e+01 -9.9999904632568359e+00 -3.0257202148437500e+02 -4.9966800689697266e+01 -9.9999904632568359e+00 -3.3349200439453125e+02 -6.2437000274658203e+01 -9.9999904632568359e+00 -3.3349200439453125e+02 -5.1073497772216797e+01 -9.9999904632568359e+00 -3.3229299926757812e+02 -5.5376800537109375e+01 -9.9999904632568359e+00 -3.2697900390625000e+02 -6.2437000274658203e+01 -9.9999904632568359e+00 -3.1462500000000000e+02 -6.2205501556396484e+01 -9.9999904632568359e+00 -3.1515197753906250e+02 -5.9101100921630859e+01 -9.9999904632568359e+00 -3.2124398803710938e+02 -9.1995094299316406e+01 -5.2000000000000000e+01 -3.3322201538085938e+02 -8.7531799316406250e+01 -5.2000000000000000e+01 -3.3293301391601562e+02 -5.8539901733398438e+01 -5.2000000000000000e+01 -3.2091998291015625e+02 -6.7205398559570312e+01 -5.2000000000000000e+01 -2.8857998657226562e+02 -6.6851104736328125e+01 -5.2000000000000000e+01 -2.8181900024414062e+02 -9.9027404785156250e+01 -5.2000000000000000e+01 -2.5936199951171875e+02 -4.9602901458740234e+01 -5.2000000000000000e+01 -3.3293301391601562e+02 -5.0591899871826172e+01 -5.2000000000000000e+01 -3.3186001586914062e+02 -5.4852500915527344e+01 -5.2000000000000000e+01 -3.2659799194335938e+02 -6.6851104736328125e+01 -5.2000000000000000e+01 -2.9534100341796875e+02 -1.1655699920654297e+02 -5.2000000000000000e+01 -3.4139697265625000e+02 -1.1948600006103516e+02 -5.2000000000000000e+01 -3.4274200439453125e+02 -6.1613498687744141e+01 -5.2000000000000000e+01 -3.1488800048828125e+02 -6.4039703369140625e+01 -5.2000000000000000e+01 -3.0856698608398438e+02 -6.5791900634765625e+01 -5.2000000000000000e+01 -3.0202801513671875e+02 -4.8959602355957031e+01 -5.2000000000000000e+01 -2.4355400085449219e+02 -4.9659698486328125e+01 -5.2000000000000000e+01 -2.4355400085449219e+02 -5.4852500915527344e+01 -5.2000000000000000e+01 -2.5056201171875000e+02 -6.0092899322509766e+01 -5.2000000000000000e+01 -2.4419599914550781e+02 -5.8539901733398438e+01 -5.2000000000000000e+01 -2.5624002075195312e+02 -7.3852302551269531e+01 -5.2000000000000000e+01 -2.4706999206542969e+02 -6.1613498687744141e+01 -5.2000000000000000e+01 -2.6227200317382812e+02 -8.6949806213378906e+01 -5.2000000000000000e+01 -2.5217100524902344e+02 -6.4039703369140625e+01 -5.2000000000000000e+01 -2.6859301757812500e+02 -6.5791900634765625e+01 -5.2000000000000000e+01 -2.7513198852539062e+02 -9.6825302124023438e+01 -5.2000000000000000e+01 -3.3408901977539062e+02 -1.0975500488281250e+02 -5.2000000000000000e+01 -2.6844598388671875e+02 -1.0146699523925781e+02 -5.2000000000000000e+01 -3.3535800170898438e+02 -1.0773800659179688e+02 -5.2000000000000000e+01 -3.3759497070312500e+02 -3.8352096557617188e+01 -1.1313100814819336e+01 -3.3855700683593750e+02 -3.8089397430419922e+01 -1.1105899810791016e+01 -3.3856100463867188e+02 -3.7972301483154297e+01 -3.3792201995849609e+01 -3.3816497802734375e+02 -3.7882701873779297e+01 -5.1104797363281250e+01 -3.3786300659179688e+02 -3.9879096984863281e+01 -4.9688598632812500e+01 -3.3788699340820312e+02 -4.2248401641845703e+01 -4.8520000457763672e+01 -3.3790798950195312e+02 -4.9966800689697266e+01 -1.5087200164794922e+01 -3.3849099731445312e+02 -4.7005298614501953e+01 -1.4861000061035156e+01 -3.3849499511718750e+02 -4.4075500488281250e+01 -1.4193300247192383e+01 -3.3850698852539062e+02 -4.3333999633789062e+01 -1.3950499534606934e+01 -3.3851098632812500e+02 -4.0817398071289062e+01 -1.2870400428771973e+01 -3.3852999877929688e+02 -4.5030799865722656e+01 -4.7631698608398438e+01 -3.3792300415039062e+02 -4.7936801910400391e+01 -4.7159900665283203e+01 -3.3793099975585938e+02 -4.8707099914550781e+01 -4.7108299255371094e+01 -3.3793197631835938e+02 -6.4521797180175781e+01 -1.4867500305175781e+01 -3.3849499511718750e+02 -6.3485198974609375e+01 -1.5032199859619141e+01 -3.3849200439453125e+02 -6.6571395874023438e+01 -2.1005699157714844e+01 -3.3838800048828125e+02 -6.2437000274658203e+01 -1.5087200164794922e+01 -3.3849099731445312e+02 -8.7531799316406250e+01 -4.7087200164794922e+01 -3.3793301391601562e+02 -7.9799102783203125e+01 -4.0788700103759766e+01 -3.3804299926757812e+02 -4.9602901458740234e+01 -4.7087200164794922e+01 -3.3793301391601562e+02 -7.2141296386718750e+01 -3.1595199584960938e+01 -3.3820300292968750e+02 -3.0054001808166504e+00 -3.7519500732421875e+01 -2.2856199645996094e+02 -3.0009000301361084e+00 -3.7261798858642578e+01 -2.2855599975585938e+02 -3.0042998790740967e+00 -3.7461097717285156e+01 -2.2856100463867188e+02 -3.0048999786376953e+00 -3.7489601135253906e+01 -2.2856100463867188e+02 -1.2327899932861328e+02 -5.0872602462768555e+00 -2.6849099731445312e+02 -1.1577100372314453e+02 -5.0872602462768555e+00 -2.6849099731445312e+02 -1.2324299621582031e+02 -1.1569499969482422e-01 -2.6857800292968750e+02 -1.1580699920654297e+02 -1.1569499969482422e-01 -2.6857800292968750e+02 -1.2324199676513672e+02 1.2622199952602386e-01 -2.6858200073242188e+02 -1.1580800628662109e+02 1.2622199952602386e-01 -2.6858200073242188e+02 -1.2324400329589844e+02 3.6813300848007202e-01 -2.6858599853515625e+02 -1.1580599975585938e+02 3.6813300848007202e-01 -2.6858599853515625e+02 -1.2322899627685547e+02 7.5456601381301880e-01 -2.6859301757812500e+02 -1.1660599517822266e+02 2.7189800739288330e+00 -2.6862698364257812e+02 -1.1754199981689453e+02 3.5612599849700928e+00 -2.6864199829101562e+02 -1.1870600128173828e+02 4.0425596237182617e+00 -2.6865100097656250e+02 -1.1996400451660156e+02 4.1078901290893555e+00 -2.6865197753906250e+02 -1.2117099761962891e+02 3.7497899532318115e+00 -2.6864498901367188e+02 -1.1600399780273438e+02 1.6123000383377075e+00 -2.6860800170898438e+02 -1.2218900299072266e+02 3.0093200206756592e+00 -2.6863299560546875e+02 -1.2290299987792969e+02 1.9713000059127808e+00 -2.6861398315429688e+02 -1.3575799560546875e+02 -9.7382097244262695e+00 -2.7257299804687500e+02 -1.3651100158691406e+02 -7.7012200355529785e+00 -2.7337597656250000e+02 -1.6575300598144531e+02 -9.7382097244262695e+00 -3.0256799316406250e+02 -1.3722999572753906e+02 -5.6389598846435547e+00 -2.7414599609375000e+02 -1.6712799072265625e+02 -1.2430599331855774e-01 -3.0417999267578125e+02 -1.6644300842285156e+02 -6.8338499069213867e+00 -3.0333001708984375e+02 -1.5152600097656250e+02 -1.2153099477291107e-01 -2.8857897949218750e+02 -1.3738299560546875e+02 -1.1569499969482422e-01 -2.7443502807617188e+02 -1.3741000366210938e+02 -5.1125302314758301e+00 -2.7433898925781250e+02 -1.3741900634765625e+02 -5.0872602462768555e+00 -2.7434799194335938e+02 -6.7523002624511719e+01 -1.1529699712991714e-01 -3.4343402099609375e+02 -6.7524795532226562e+01 -1.1161499656736851e-02 -3.4353598022460938e+02 -6.7525001525878906e+01 -9.0571603504940867e-04 -3.4356701660156250e+02 -6.7447402954101562e+01 -4.4469799995422363e+00 -3.4178900146484375e+02 -6.7452102661132812e+01 -4.1778101921081543e+00 -3.4204901123046875e+02 -6.7460403442382812e+01 -3.7047300338745117e+00 -3.4220999145507812e+02 -6.7436203002929688e+01 -5.0872602462768555e+00 -3.1416897583007812e+02 -6.7436203002929688e+01 -5.0872602462768555e+00 -3.4094000244140625e+02 -6.7436302185058594e+01 -5.0822501182556152e+00 -3.1417001342773438e+02 -6.7461402893066406e+01 -3.6427400112152100e+00 -3.1447198486328125e+02 -6.7441902160644531e+01 -4.7640199661254883e+00 -3.4148202514648438e+02 -6.7507202148437500e+01 -1.0213299989700317e+00 -3.1476599121093750e+02 -6.7441200256347656e+01 -4.8015699386596680e+00 -3.4144601440429688e+02 -6.7436599731445312e+01 -5.0663900375366211e+00 -3.4097998046875000e+02 -6.7436302185058594e+01 -5.0800399780273438e+00 -3.4095599365234375e+02 -6.7443099975585938e+01 -4.6941599845886230e+00 -3.4154998779296875e+02 -6.7447196960449219e+01 -4.4554500579833984e+00 -3.4177999877929688e+02 -8.7523605346679688e+01 -1.2153099477291107e-01 -2.8857897949218750e+02 -1.0166699981689453e+02 -1.1569499969482422e-01 -2.7443502807617188e+02 -1.0163100433349609e+02 -5.0872602462768555e+00 -2.7434799194335938e+02 -6.9230598449707031e+01 -5.0872602462768555e+00 -3.0674899291992188e+02 -6.9617195129394531e+01 -4.1534299850463867e+00 -3.0638500976562500e+02 -7.0130401611328125e+01 -3.1712601184844971e+00 -3.0589602661132812e+02 -7.0652099609375000e+01 -2.1728301048278809e+00 -3.0539898681640625e+02 -7.1046600341796875e+01 -1.4177600145339966e+00 -3.0502301025390625e+02 -7.1591697692871094e+01 -6.0551202297210693e-01 -3.0449798583984375e+02 -7.1902999877929688e+01 -1.4150999486446381e-01 -3.0419900512695312e+02 -7.1915596008300781e+01 -1.2430699914693832e-01 -3.0418597412109375e+02 -2.5893999099731445e+01 -1.9224601745605469e+01 -2.2824099731445312e+02 -3.0660400390625000e+01 -2.1263799667358398e+01 -2.2827699279785156e+02 -3.5296699523925781e+01 -2.2895999908447266e+01 -2.2830499267578125e+02 -4.9659698486328125e+01 -3.7261798858642578e+01 -2.2855599975585938e+02 -3.9826301574707031e+01 -2.4112800598144531e+01 -2.2832598876953125e+02 -4.4262496948242188e+01 -2.4902301788330078e+01 -2.2833999633789062e+02 -4.5896297454833984e+01 -2.5084400177001953e+01 -2.2834300231933594e+02 -4.9658100128173828e+01 -2.5261800765991211e+01 -2.2834600830078125e+02 -4.9746498107910156e+01 -2.5261800765991211e+01 -2.2834600830078125e+02 -3.2422997951507568e+00 -1.0500699996948242e+01 -2.2808900451660156e+02 -2.7954001426696777e+00 -1.0407999992370605e+01 -2.2808699035644531e+02 -4.5623998641967773e+00 -1.0898799896240234e+01 -2.2809599304199219e+02 -1.1046900749206543e+01 -1.2921899795532227e+01 -2.2813099670410156e+02 -1.5895999908447266e+01 -1.4608900070190430e+01 -2.2815998840332031e+02 -1.9907100677490234e+01 -1.6272199630737305e+01 -2.2818901062011719e+02 -2.1014900207519531e+01 -1.6818300247192383e+01 -2.2819900512695312e+02 -7.2992797851562500e+01 9.8919296264648438e+00 -3.0418701171875000e+02 -8.7525100708007812e+01 1.0533899813890457e-01 -2.8857998657226562e+02 -7.2217796325683594e+01 5.3301997184753418e+00 -3.0418701171875000e+02 -7.1918502807617188e+01 6.8739697337150574e-02 -3.0418597412109375e+02 -1.0348799896240234e+02 7.4603500366210938e+00 -2.7446801757812500e+02 -1.0269300079345703e+02 6.0389599800109863e+00 -2.7446301269531250e+02 -7.4589996337890625e+01 1.5723500251770020e+01 -3.0418701171875000e+02 -7.3112007141113281e+01 1.0593400001525879e+01 -3.0418701171875000e+02 -1.0228399658203125e+02 3.6742699146270752e+00 -2.7445401000976562e+02 -1.0166400146484375e+02 9.1658197343349457e-02 -2.7444100952148438e+02 -7.6404701232910156e+01 2.0104499816894531e+01 -3.0418701171875000e+02 -7.6632995605468750e+01 2.0655698776245117e+01 -3.0418701171875000e+02 -1.0546399688720703e+02 1.0992700576782227e+01 -2.7448098754882812e+02 -8.5862098693847656e+01 3.3662899017333984e+01 -3.0418701171875000e+02 -1.0840699768066406e+02 1.3739000320434570e+01 -2.7449099731445312e+02 -1.0562599945068359e+02 1.1283599853515625e+01 -2.7448202514648438e+02 -7.9215400695800781e+01 2.5328199386596680e+01 -3.0418701171875000e+02 -8.2026000976562500e+01 2.9289400100708008e+01 -3.0418701171875000e+02 -8.2304702758789062e+01 2.9682199478149414e+01 -3.0418701171875000e+02 -8.9569396972656250e+01 3.6975997924804688e+01 -3.0418701171875000e+02 -8.9842796325683594e+01 3.7220298767089844e+01 -3.0418701171875000e+02 -1.1011499786376953e+02 1.5246699333190918e+01 -2.7449700927734375e+02 -9.4196792602539062e+01 4.0309600830078125e+01 -3.0418701171875000e+02 -1.1174300384521484e+02 1.5910400390625000e+01 -2.7449899291992188e+02 -9.8649002075195312e+01 4.2770301818847656e+01 -3.0418701171875000e+02 -9.8869300842285156e+01 4.2892002105712891e+01 -3.0418701171875000e+02 -1.1549600219726562e+02 1.7439701080322266e+01 -2.7450497436523438e+02 -1.1952799987792969e+02 1.7699399948120117e+01 -2.7450601196289062e+02 -1.1564499664306641e+02 1.7500499725341797e+01 -2.7450497436523438e+02 -1.1419499969482422e+02 4.7307201385498047e+01 -3.0418701171875000e+02 -1.0380200195312500e+02 4.4934997558593750e+01 -3.0418701171875000e+02 -1.0880000305175781e+02 4.6375099182128906e+01 -3.0418701171875000e+02 -1.0893200683593750e+02 4.6413002014160156e+01 -3.0418701171875000e+02 -1.1950299835205078e+02 4.7605297088623047e+01 -3.0418701171875000e+02 -1.1952500152587891e+02 4.7606597900390625e+01 -3.0418701171875000e+02 -1.2160299682617188e+02 1.7805601119995117e+01 -2.7450698852539062e+02 -1.2485499572753906e+02 4.7307201385498047e+01 -3.0418701171875000e+02 -1.3011799621582031e+02 4.6413002014160156e+01 -3.0418701171875000e+02 -1.2348600006103516e+02 1.7255100250244141e+01 -2.7450399780273438e+02 -1.3020800781250000e+02 4.6387199401855469e+01 -3.0418701171875000e+02 -1.2733200073242188e+02 1.6130401611328125e+01 -2.7450000000000000e+02 -1.4036299133300781e+02 4.2791400909423828e+01 -3.0418701171875000e+02 -1.2736700439453125e+02 1.6105499267578125e+01 -2.7450000000000000e+02 -1.4018099975585938e+02 4.2892002105712891e+01 -3.0418701171875000e+02 -1.3524800109863281e+02 4.4934997558593750e+01 -3.0418701171875000e+02 -1.4485299682617188e+02 4.0309600830078125e+01 -3.0418701171875000e+02 -1.4920700073242188e+02 3.7220298767089844e+01 -3.0418701171875000e+02 -1.3066099548339844e+02 1.3750599861145020e+01 -2.7449099731445312e+02 -1.4944801330566406e+02 3.7005100250244141e+01 -3.0418701171875000e+02 -1.3219699096679688e+02 1.2652499198913574e+01 -2.7448699951171875e+02 -1.5318800354003906e+02 3.3662899017333984e+01 -3.0418701171875000e+02 -1.5674499511718750e+02 2.9682199478149414e+01 -3.0418701171875000e+02 -1.3343200683593750e+02 1.0897600173950195e+01 -2.7448098754882812e+02 -1.5699900817871094e+02 2.9324998855590820e+01 -3.0418701171875000e+02 -1.3565100097656250e+02 7.7449698448181152e+00 -2.7446899414062500e+02 -1.5983499145507812e+02 2.5328199386596680e+01 -3.0418701171875000e+02 -1.6241699218750000e+02 2.0655698776245117e+01 -3.0418701171875000e+02 -1.3570100402832031e+02 7.5651998519897461e+00 -2.7446899414062500e+02 -1.6262899780273438e+02 2.0144899368286133e+01 -3.0418701171875000e+02 -1.6446000671386719e+02 1.5723500251770020e+01 -3.0418701171875000e+02 -1.3679899597167969e+02 3.6740300655364990e+00 -2.7445401000976562e+02 -1.5152500915527344e+02 1.0533899813890457e-01 -2.8857998657226562e+02 -1.3738600158691406e+02 9.1658197343349457e-02 -2.7444100952148438e+02 -1.3728700256347656e+02 1.9447200298309326e+00 -2.7444799804687500e+02 -1.6593800354003906e+02 1.0593400001525879e+01 -3.0418701171875000e+02 -1.6605000305175781e+02 9.9349603652954102e+00 -3.0418701171875000e+02 -1.6682598876953125e+02 5.3860497474670410e+00 -3.0418701171875000e+02 -1.6713101196289062e+02 1.1243000626564026e-01 -3.0418701171875000e+02 -1.2036000061035156e+02 -3.7261798858642578e+01 -2.5784100341796875e+02 -1.2044899749755859e+02 -2.4880100250244141e+01 -2.5762500000000000e+02 -1.3012998962402344e+02 -3.7261798858642578e+01 -2.6761099243164062e+02 -1.2279800415039062e+02 -2.4101100921630859e+01 -2.5995498657226562e+02 -1.3575799560546875e+02 -1.0261799812316895e+01 -2.7257299804687500e+02 -1.6575300598144531e+02 -1.0261799812316895e+01 -3.0256799316406250e+02 -1.6493800354003906e+02 -1.2806200027465820e+01 -3.0181597900390625e+02 -1.2530900573730469e+02 -2.2855701446533203e+01 -2.6243499755859375e+02 -1.2637599945068359e+02 -2.2222299575805664e+01 -2.6348599243164062e+02 -1.3779699707031250e+02 -3.6458702087402344e+01 -2.7525799560546875e+02 -1.2852999877929688e+02 -2.0699600219726562e+01 -2.6560198974609375e+02 -1.4512200927734375e+02 -3.4088203430175781e+01 -2.8252499389648438e+02 -1.3162300109863281e+02 -1.7610700607299805e+01 -2.6861898803710938e+02 -1.5175900268554688e+02 -3.0281501770019531e+01 -2.8906802368164062e+02 -1.3388400268554688e+02 -1.4167400360107422e+01 -2.7079498291015625e+02 -1.3484300231933594e+02 -1.2234900474548340e+01 -2.7170602416992188e+02 -1.5740600585937500e+02 -2.5262300491333008e+01 -2.9459100341796875e+02 -1.6184001159667969e+02 -1.9326400756835938e+01 -2.9887899780273438e+02 -1.1919700622558594e+02 -2.5096601486206055e+01 -2.5639999389648438e+02 -6.1934001922607422e+01 -3.7273101806640625e+01 -2.2931199645996094e+02 -6.5382102966308594e+01 -2.5275299072265625e+01 -2.2964399719238281e+02 -6.5255096435546875e+01 -3.7274902343750000e+01 -2.3000599670410156e+02 -6.6226699829101562e+01 -2.5276100158691406e+01 -2.2971400451660156e+02 -7.8121498107910156e+01 -3.7281799316406250e+01 -2.3269300842285156e+02 -8.0612396240234375e+01 -2.5282100677490234e+01 -2.3336300659179688e+02 -8.0491897583007812e+01 -3.7281902313232422e+01 -2.3361599731445312e+02 -8.2255897521972656e+01 -2.5282800674438477e+01 -2.3377899169921875e+02 -9.3530296325683594e+01 -3.7282798767089844e+01 -2.3869499206542969e+02 -9.5066696166992188e+01 -2.5281999588012695e+01 -2.3940800476074219e+02 -9.4987098693847656e+01 -3.7282100677490234e+01 -2.3956201171875000e+02 -9.7395797729492188e+01 -2.5281799316406250e+01 -2.4043099975585938e+02 -1.0773899841308594e+02 -3.7276000976562500e+01 -2.4715499877929688e+02 -1.0839299774169922e+02 -2.5274900436401367e+01 -2.4762899780273438e+02 -1.0838600158691406e+02 -3.7275299072265625e+01 -2.4770199584960938e+02 -1.1123199462890625e+02 -2.5273099899291992e+01 -2.4948699951171875e+02 -1.1670099639892578e+02 -2.5267000198364258e+01 -2.5407400512695312e+02 -7.1917098999023438e+01 -6.2152698636054993e-02 -3.0418597412109375e+02 -1.0166600036621094e+02 -1.2016899883747101e-02 -2.7443798828125000e+02 -1.6713101196289062e+02 -5.9577394276857376e-03 -3.0418499755859375e+02 -1.3738400268554688e+02 -1.2016899883747101e-02 -2.7443798828125000e+02 -6.8623703002929688e+01 -3.7226099967956543e+00 -3.0854498291015625e+02 -6.8641998291015625e+01 -5.6130299568176270e+00 -3.0783001708984375e+02 -6.8623497009277344e+01 -2.6730298995971680e+00 -3.0880999755859375e+02 -6.8640403747558594e+01 -7.5841897726058960e-01 -3.0906500244140625e+02 -6.8652900695800781e+01 -1.1878099292516708e-02 -3.0908502197265625e+02 -6.8660293579101562e+01 3.6988303065299988e-02 -3.0908599853515625e+02 -6.8666900634765625e+01 3.7202302366495132e-02 -3.0905300903320312e+02 -6.7605895996093750e+01 -5.2953896522521973e+00 -3.1176199340820312e+02 -6.8656303405761719e+01 -5.8047800064086914e+00 -3.0773898315429688e+02 -6.8500694274902344e+01 -5.7396302223205566e+00 -3.0814001464843750e+02 -6.8492897033691406e+01 -5.7361698150634766e+00 -3.0816400146484375e+02 -6.8113601684570312e+01 -5.5679702758789062e+00 -3.0936300659179688e+02 -6.9000404357910156e+01 -5.9489598274230957e+00 -3.0685202026367188e+02 -6.9052597045898438e+01 -5.6769199371337891e+00 -3.0686300659179688e+02 -6.9188995361328125e+01 -5.2250599861145020e+00 -3.0677600097656250e+02 -6.9773895263671875e+01 1.0262199491262436e-01 -3.0739599609375000e+02 -6.8666999816894531e+01 1.2010899931192398e-01 -3.0905300903320312e+02 -6.8292106628417969e+01 1.2099500000476837e-01 -3.1093798828125000e+02 -6.9872604370117188e+01 5.5944900512695312e+00 -3.0725198364257812e+02 -7.0811103820800781e+01 1.1118599891662598e+01 -3.0725198364257812e+02 -7.2362297058105469e+01 1.6502899169921875e+01 -3.0725198364257812e+02 -7.4506599426269531e+01 2.1679698944091797e+01 -3.0725198364257812e+02 -7.7216995239257812e+01 2.6583900451660156e+01 -3.0725198364257812e+02 -8.0459495544433594e+01 3.1153699874877930e+01 -3.0725198364257812e+02 -8.4193199157714844e+01 3.5331802368164062e+01 -3.0725198364257812e+02 -8.8371299743652344e+01 3.9065498352050781e+01 -3.0725198364257812e+02 -9.2941101074218750e+01 4.2307998657226562e+01 -3.0725198364257812e+02 -9.7845298767089844e+01 4.5018402099609375e+01 -3.0725198364257812e+02 -1.0302200317382812e+02 4.7162700653076172e+01 -3.0725198364257812e+02 -1.0840599822998047e+02 4.8713901519775391e+01 -3.0725198364257812e+02 -1.1393099975585938e+02 4.9652400970458984e+01 -3.0725198364257812e+02 -1.1952500152587891e+02 4.9966701507568359e+01 -3.0725198364257812e+02 -1.2511900329589844e+02 4.9652400970458984e+01 -3.0725198364257812e+02 -1.3064399719238281e+02 4.8713901519775391e+01 -3.0725198364257812e+02 -1.3602799987792969e+02 4.7162700653076172e+01 -3.0725198364257812e+02 -1.4120500183105469e+02 4.5018402099609375e+01 -3.0725198364257812e+02 -1.4610899353027344e+02 4.2307998657226562e+01 -3.0725198364257812e+02 -1.5067900085449219e+02 3.9065498352050781e+01 -3.0725198364257812e+02 -1.5485699462890625e+02 3.5331802368164062e+01 -3.0725198364257812e+02 -1.5858999633789062e+02 3.1153699874877930e+01 -3.0725198364257812e+02 -1.6183300781250000e+02 2.6583900451660156e+01 -3.0725198364257812e+02 -1.6454299926757812e+02 2.1679698944091797e+01 -3.0725198364257812e+02 -1.6668798828125000e+02 1.6502899169921875e+01 -3.0725198364257812e+02 -1.6823899841308594e+02 1.1118599891662598e+01 -3.0725198364257812e+02 -1.6917100524902344e+02 5.6530799865722656e+00 -3.0725198364257812e+02 -1.6927600097656250e+02 1.1749500036239624e-01 -3.0739599609375000e+02 -6.8365997314453125e+01 5.7641901969909668e+00 -3.1088800048828125e+02 -6.9333099365234375e+01 1.1455999374389648e+01 -3.1088800048828125e+02 -7.0931297302246094e+01 1.7003599166870117e+01 -3.1088800048828125e+02 -7.3140701293945312e+01 2.2337499618530273e+01 -3.1088800048828125e+02 -7.5933296203613281e+01 2.7390501022338867e+01 -3.1088800048828125e+02 -7.9274200439453125e+01 3.2098899841308594e+01 -3.1088800048828125e+02 -8.3121200561523438e+01 3.6403800964355469e+01 -3.1088800048828125e+02 -8.7426101684570312e+01 4.0250801086425781e+01 -3.1088800048828125e+02 -9.2134498596191406e+01 4.3591701507568359e+01 -3.1088800048828125e+02 -9.7187500000000000e+01 4.6384300231933594e+01 -3.1088800048828125e+02 -1.0252100372314453e+02 4.8593700408935547e+01 -3.1088800048828125e+02 -1.0806900024414062e+02 5.0191902160644531e+01 -3.1088800048828125e+02 -1.1376100158691406e+02 5.1158996582031250e+01 -3.1088800048828125e+02 -1.1952500152587891e+02 5.1482700347900391e+01 -3.1088800048828125e+02 -1.2528899383544922e+02 5.1158996582031250e+01 -3.1088800048828125e+02 -1.3098100280761719e+02 5.0191902160644531e+01 -3.1088800048828125e+02 -1.3652899169921875e+02 4.8593700408935547e+01 -3.1088800048828125e+02 -1.4186199951171875e+02 4.6384300231933594e+01 -3.1088800048828125e+02 -1.4691500854492188e+02 4.3591701507568359e+01 -3.1088800048828125e+02 -1.5162399291992188e+02 4.0250801086425781e+01 -3.1088800048828125e+02 -1.5592900085449219e+02 3.6403800964355469e+01 -3.1088800048828125e+02 -1.5977600097656250e+02 3.2098899841308594e+01 -3.1088800048828125e+02 -1.6311700439453125e+02 2.7390501022338867e+01 -3.1088800048828125e+02 -1.6590901184082031e+02 2.2337499618530273e+01 -3.1088800048828125e+02 -1.6811900329589844e+02 1.7003599166870117e+01 -3.1088800048828125e+02 -1.6971699523925781e+02 1.1455999374389648e+01 -3.1088800048828125e+02 -1.7067700195312500e+02 5.8246302604675293e+00 -3.1088800048828125e+02 -1.7075799560546875e+02 1.2099500000476837e-01 -3.1093798828125000e+02 -1.7038301086425781e+02 1.2010899931192398e-01 -3.0905300903320312e+02 -1.7038301086425781e+02 -1.0454399883747101e-01 -3.0905099487304688e+02 -1.7038099670410156e+02 -3.2911899685859680e-01 -3.0904498291015625e+02 -1.6786399841308594e+02 -1.1339800834655762e+01 -3.0587100219726562e+02 -1.6961199951171875e+02 -8.5176801681518555e+00 -3.0816702270507812e+02 -1.6882899475097656e+02 -1.2071300506591797e+01 -3.0738000488281250e+02 -1.6910000610351562e+02 -1.2777199745178223e+01 -3.0944201660156250e+02 -1.6752799987792969e+02 -1.1333899497985840e+01 -3.0480899047851562e+02 -1.6948699951171875e+02 -1.3270099639892578e+01 -3.1022302246093750e+02 -1.6929100036621094e+02 -1.3011899948120117e+01 -3.0942898559570312e+02 -1.6878999328613281e+02 -1.2350699424743652e+01 -3.0739599609375000e+02 -1.6799899291992188e+02 -1.1713299751281738e+01 -3.0577401733398438e+02 -1.2354100036621094e+02 -5.0883098602294922e+01 -2.7419998168945312e+02 -1.3363499450683594e+02 -4.9226802825927734e+01 -2.8216101074218750e+02 -1.6785398864746094e+02 -1.5469499588012695e+01 -3.0661999511718750e+02 -1.6666400146484375e+02 -1.4173299789428711e+01 -3.0403598022460938e+02 -1.6845600891113281e+02 -1.6638700485229492e+01 -3.0945599365234375e+02 -1.6453100585937500e+02 -2.5312799453735352e+01 -3.0645498657226562e+02 -1.5889799499511719e+02 -3.3299598693847656e+01 -3.0206900024414062e+02 -1.5168798828125000e+02 -4.0186100006103516e+01 -2.9640499877929688e+02 -1.4315199279785156e+02 -4.5594902038574219e+01 -2.8967401123046875e+02 -1.6428900146484375e+02 -2.3510898590087891e+01 -3.0358300781250000e+02 -1.5917300415039062e+02 -3.0938400268554688e+01 -2.9913900756835938e+02 -1.5261999511718750e+02 -3.7377498626708984e+01 -2.9339599609375000e+02 -1.4485398864746094e+02 -4.2485301971435547e+01 -2.8655899047851562e+02 -1.3618099975585938e+02 -4.5987899780273438e+01 -2.7891098022460938e+02 -1.2695899963378906e+02 -4.7698699951171875e+01 -2.7078198242187500e+02 -1.6337699890136719e+02 -2.1480800628662109e+01 -3.0101300048828125e+02 -1.5866400146484375e+02 -2.8201601028442383e+01 -2.9659301757812500e+02 -1.5264399719238281e+02 -3.3986499786376953e+01 -2.9088400268554688e+02 -1.4553298950195312e+02 -3.8518997192382812e+01 -2.8409500122070312e+02 -1.3762800598144531e+02 -4.1550899505615234e+01 -2.7651300048828125e+02 -1.2927000427246094e+02 -4.2921100616455078e+01 -2.6847100830078125e+02 -1.1950000000000000e+02 -4.2921100616455078e+01 -2.5870001220703125e+02 -1.1718899536132812e+02 -4.7698699951171875e+01 -2.6101101684570312e+02 -1.1377099609375000e+02 -5.0883098602294922e+01 -2.6442999267578125e+02 -4.9659698486328125e+01 -4.2921100616455078e+01 -2.2977200317382812e+02 -4.9659698486328125e+01 -4.7698699951171875e+01 -2.3304000854492188e+02 -6.1784400939941406e+01 -4.2928901672363281e+01 -2.3052200317382812e+02 -4.9659698486328125e+01 -5.0883098602294922e+01 -2.3787400817871094e+02 -6.1383098602294922e+01 -4.7702701568603516e+01 -2.3376600646972656e+02 -6.0789802551269531e+01 -5.0884101867675781e+01 -2.3856199645996094e+02 -7.7773696899414062e+01 -4.2934997558593750e+01 -2.3386399841308594e+02 -9.2994300842285156e+01 -4.2935600280761719e+01 -2.3979299926757812e+02 -1.0703100585937500e+02 -4.2930999755859375e+01 -2.4814700317382812e+02 -7.6843101501464844e+01 -4.7705799102783203e+01 -2.3699800109863281e+02 -9.1559700012207031e+01 -4.7706100463867188e+01 -2.4273100280761719e+02 -1.0513199615478516e+02 -4.7703697204589844e+01 -2.5080902099609375e+02 -7.5467697143554688e+01 -5.0884998321533203e+01 -2.4162899780273438e+02 -8.9439895629882812e+01 -5.0885101318359375e+01 -2.4707199096679688e+02 -1.0232499694824219e+02 -5.0884399414062500e+01 -2.5474198913574219e+02 -5.8301997184753418e+00 -3.8634502410888672e+01 -2.2864300537109375e+02 -2.2785600662231445e+01 -4.5410598754882812e+01 -2.3113299560546875e+02 -1.7252099990844727e+01 -4.3278900146484375e+01 -2.2993099975585938e+02 -1.6337699890136719e+01 -4.2911602020263672e+01 -2.2979600524902344e+02 -1.1593500137329102e+01 -4.1006198883056641e+01 -2.2909800720214844e+02 -3.4655601501464844e+01 -4.9438701629638672e+01 -2.3517001342773438e+02 -3.0001399993896484e+01 -4.7976402282714844e+01 -2.3333000183105469e+02 -2.9155399322509766e+01 -4.7680900573730469e+01 -2.3305900573730469e+02 -2.5066999435424805e+01 -4.6252899169921875e+01 -2.3174800109863281e+02 -4.5849098205566406e+01 -5.1829597473144531e+01 -2.4129899597167969e+02 -4.2437602996826172e+01 -5.1334602355957031e+01 -2.3913600158691406e+02 -4.0179199218750000e+01 -5.0854602813720703e+01 -2.3788499450683594e+02 -3.9027500152587891e+01 -5.0609802246093750e+01 -2.3724700927734375e+02 -2.5412799835205078e+01 -6.7942099571228027e+00 -2.3240199279785156e+02 -2.1787601470947266e+01 -6.7223300933837891e+00 -2.3115800476074219e+02 -4.9876999855041504e+00 -9.4916801452636719e+00 -2.2814300537109375e+02 -4.6087002754211426e+00 -9.5478897094726562e+00 -2.2813198852539062e+02 -7.6061997413635254e+00 -8.8544492721557617e+00 -2.2832200622558594e+02 -1.8393699645996094e+01 -7.9236598014831543e+00 -2.2983500671386719e+02 -1.8018699645996094e+01 -7.9588303565979004e+00 -2.2976901245117188e+02 -1.7786899566650391e+01 -7.0433001518249512e+00 -2.3003100585937500e+02 -1.3001600265502930e+01 -8.4291095733642578e+00 -2.2888598632812500e+02 -1.2837599754333496e+01 -7.7997398376464844e+00 -2.2899499511718750e+02 -1.2496399879455566e+01 -8.4764394760131836e+00 -2.2879699707031250e+02 -7.6617999076843262e+00 -9.1301202774047852e+00 -2.2837600708007812e+02 -2.5572599411010742e+01 -7.5854101181030273e+00 -2.3201000976562500e+02 -2.5634000778198242e+01 -7.8890900611877441e+00 -2.3185899353027344e+02 -2.3853799819946289e+01 -7.7986097335815430e+00 -2.3127099609375000e+02 -2.2026300430297852e+01 -7.8404498100280762e+00 -2.3079100036621094e+02 -4.4612899780273438e+01 -9.3579893112182617e+00 -3.3532000732421875e+02 -4.4599296569824219e+01 -9.3588800430297852e+00 -3.3530798339843750e+02 -4.4574100494384766e+01 -9.3477392196655273e+00 -3.3533401489257812e+02 -3.5407497406005859e+01 -9.0004806518554688e+00 -2.3563000488281250e+02 -3.3553897857666016e+01 -8.7947206497192383e+00 -2.3484799194335938e+02 -3.3053901672363281e+01 -7.6000699996948242e+00 -2.3570300292968750e+02 -3.0814100265502930e+01 -8.4906797409057617e+00 -2.3369300842285156e+02 -3.8895099639892578e+01 -9.3528604507446289e+00 -2.3730599975585938e+02 -3.9484401702880859e+01 -9.3588800430297852e+00 -2.3770999145507812e+02 -3.9445899963378906e+01 -9.4085302352905273e+00 -2.3757000732421875e+02 -3.9547500610351562e+01 -9.4171800613403320e+00 -2.3762400817871094e+02 -4.3013401031494141e+01 -9.7126998901367188e+00 -2.3945700073242188e+02 -4.4599296569824219e+01 -9.3588800430297852e+00 -2.4185200500488281e+02 -4.5492599487304688e+01 -9.8671903610229492e+00 -2.4086500549316406e+02 -4.9253200531005859e+01 -9.3588800430297852e+00 -2.4650601196289062e+02 -4.7275600433349609e+01 -9.9556398391723633e+00 -2.4190199279785156e+02 -4.6182098388671875e+01 -9.9101104736328125e+00 -2.4125700378417969e+02 -6.4007400512695312e+01 -9.9443197250366211e+00 -3.0835598754882812e+02 -6.4072402954101562e+01 -9.9456300735473633e+00 -3.0816400146484375e+02 -6.2326499938964844e+01 -9.3588800430297852e+00 -3.0801098632812500e+02 -6.4580001831054688e+01 -9.9554605484008789e+00 -3.0666299438476562e+02 -6.4029998779296875e+01 -9.3588800430297852e+00 -3.0165298461914062e+02 -6.5385200500488281e+01 -9.9710807800292969e+00 -3.0428298950195312e+02 -6.6328300476074219e+01 -9.9999904632568359e+00 -3.0258898925781250e+02 -6.2441596984863281e+01 -9.9999904632568359e+00 -3.1460400390625000e+02 -5.9967903137207031e+01 -9.3588800430297852e+00 -3.1415499877929688e+02 -6.2531097412109375e+01 -9.9990997314453125e+00 -3.1416897583007812e+02 -6.3298500061035156e+01 -9.9706001281738281e+00 -3.1114797973632812e+02 -6.3960201263427734e+01 -9.9461097717285156e+00 -3.0854202270507812e+02 -4.9253200531005859e+01 -9.3588800430297852e+00 -3.3065399169921875e+02 -4.4890602111816406e+01 -9.4315996170043945e+00 -3.3522601318359375e+02 -4.5478500366210938e+01 -9.5530099868774414e+00 -3.3502502441406250e+02 -4.7749500274658203e+01 -9.8868598937988281e+00 -3.3424697875976562e+02 -3.9811298370361328e+01 -7.6507897377014160e+00 -3.3697000122070312e+02 -4.0189502716064453e+01 -7.8307995796203613e+00 -3.3682598876953125e+02 -4.3380599975585938e+01 -7.6000699996948242e+00 -3.3395498657226562e+02 -4.0566001892089844e+01 -8.0093097686767578e+00 -3.3669400024414062e+02 -4.0790000915527344e+01 -8.1129102706909180e+00 -3.3661801147460938e+02 -4.2853199005126953e+01 -8.8915796279907227e+00 -3.3592001342773438e+02 -3.9358100891113281e+01 -7.4341897964477539e+00 -3.3715502929687500e+02 -3.9703800201416016e+01 -7.5994100570678711e+00 -3.3701397705078125e+02 -3.6826499938964844e+01 -6.1640701293945312e+00 -3.3837500000000000e+02 -3.4967899322509766e+01 -5.1815500259399414e+00 -3.3944601440429688e+02 -3.8904300689697266e+01 -7.2140102386474609e+00 -3.3735202026367188e+02 -3.9067001342773438e+01 -7.2929797172546387e+00 -3.3728201293945312e+02 -6.5059600830078125e+01 -9.3588800430297852e+00 -2.9515298461914062e+02 -6.5403999328613281e+01 -9.3588800430297852e+00 -2.8857998657226562e+02 -6.5059600830078125e+01 -9.3588800430297852e+00 -2.8200701904296875e+02 -6.4029998779296875e+01 -9.3588800430297852e+00 -2.7550698852539062e+02 -6.2326499938964844e+01 -9.3588800430297852e+00 -2.6914901733398438e+02 -5.9967903137207031e+01 -9.3588800430297852e+00 -2.6300497436523438e+02 -5.6979801177978516e+01 -9.3588800430297852e+00 -2.5714099121093750e+02 -5.3395198822021484e+01 -9.3588800430297852e+00 -2.5162100219726562e+02 -5.6979801177978516e+01 -9.3588800430297852e+00 -3.2001998901367188e+02 -5.3395198822021484e+01 -9.3588800430297852e+00 -3.2553900146484375e+02 -3.8413799285888672e+01 -7.6000699996948242e+00 -2.3918299865722656e+02 -4.3380599975585938e+01 -7.6000699996948242e+00 -2.4320500183105469e+02 -4.7899700164794922e+01 -7.6000699996948242e+00 -2.4772499084472656e+02 -5.1921699523925781e+01 -7.6000699996948242e+00 -2.5269099426269531e+02 -5.5402500152587891e+01 -7.6000699996948242e+00 -2.5805099487304688e+02 -5.8304000854492188e+01 -7.6000699996948242e+00 -2.6374600219726562e+02 -6.0594303131103516e+01 -7.6000699996948242e+00 -2.6971200561523438e+02 -6.2248497009277344e+01 -7.6000699996948242e+00 -2.7588497924804688e+02 -6.3248203277587891e+01 -7.6000699996948242e+00 -2.8219799804687500e+02 -6.3582702636718750e+01 -7.6000699996948242e+00 -2.8857998657226562e+02 -6.3248203277587891e+01 -7.6000699996948242e+00 -2.9496197509765625e+02 -6.2248497009277344e+01 -7.6000699996948242e+00 -3.0127502441406250e+02 -6.0594303131103516e+01 -7.6000699996948242e+00 -3.0744799804687500e+02 -5.8304000854492188e+01 -7.6000699996948242e+00 -3.1341400146484375e+02 -5.5402500152587891e+01 -7.6000699996948242e+00 -3.1910897827148438e+02 -5.1921699523925781e+01 -7.6000699996948242e+00 -3.2446899414062500e+02 -4.7899700164794922e+01 -7.6000699996948242e+00 -3.2943600463867188e+02 -1.2841799926757812e+02 -9.0177200734615326e-02 -2.6925997924804688e+02 -1.2843798828125000e+02 -5.0931000709533691e+00 -2.6927798461914062e+02 -1.2923599243164062e+02 -5.0940499305725098e+00 -2.6939898681640625e+02 -1.3324099731445312e+02 -9.0177200734615326e-02 -2.7125799560546875e+02 -1.3319900512695312e+02 -5.0927400588989258e+00 -2.7133200073242188e+02 -1.3465299987792969e+02 -5.0923199653625488e+00 -2.7204098510742188e+02 -1.2841799926757812e+02 1.0114700347185135e-01 -2.6926300048828125e+02 -1.2841999816894531e+02 2.9246598482131958e-01 -2.6926699829101562e+02 -1.3324198913574219e+02 5.3996000438928604e-02 -2.7125997924804688e+02 -1.3324398803710938e+02 1.9816499948501587e-01 -2.7126397705078125e+02 -1.0659999847412109e+02 4.7647900581359863e+00 -2.7130499267578125e+02 -1.1230199432373047e+02 1.1829899787902832e+01 -2.7136901855468750e+02 -1.2111999511718750e+02 1.3792400360107422e+01 -2.7138598632812500e+02 -1.2551699829101562e+02 1.2507699966430664e+01 -2.7137500000000000e+02 -1.3190699768066406e+02 6.0742502212524414e+00 -2.7131701660156250e+02 -1.2837199401855469e+02 1.2154000997543335e+00 -2.6927999877929688e+02 -1.3316699218750000e+02 1.6213099956512451e+00 -2.7127700805664062e+02 -1.2756000518798828e+02 4.1058101654052734e+00 -2.6932000732421875e+02 -1.2584200286865234e+02 6.5532298088073730e+00 -2.6935501098632812e+02 -1.2925300598144531e+02 9.8399505615234375e+00 -2.7135101318359375e+02 -1.2341699981689453e+02 8.2887401580810547e+00 -2.6938000488281250e+02 -1.2056100463867188e+02 9.1250505447387695e+00 -2.6939099121093750e+02 -1.1759000396728516e+02 8.9727001190185547e+00 -2.6938900756835938e+02 -1.1654800415039062e+02 1.3558400154113770e+01 -2.7138400268554688e+02 -1.1483300018310547e+02 7.8476696014404297e+00 -2.6937298583984375e+02 -1.1259799957275391e+02 5.8703398704528809e+00 -2.6934497070312500e+02 -1.0885500335693359e+02 8.7897195816040039e+00 -2.7134100341796875e+02 -1.1113800048828125e+02 3.2554299831390381e+00 -2.6930902099609375e+02 -1.0580599975585938e+02 1.9816499948501587e-01 -2.7126397705078125e+02 -1.1062999725341797e+02 2.9246598482131958e-01 -2.6926699829101562e+02 -1.1063200378417969e+02 1.0114700347185135e-01 -2.6926300048828125e+02 -1.1063200378417969e+02 -9.0177200734615326e-02 -2.6925997924804688e+02 -1.0580799865722656e+02 5.3996000438928604e-02 -2.7125997924804688e+02 -1.0580900573730469e+02 -9.0177200734615326e-02 -2.7125799560546875e+02 -1.0583599853515625e+02 -5.0931000709533691e+00 -2.7125601196289062e+02 -1.0648600006103516e+02 -5.0940499305725098e+00 -2.7077801513671875e+02 -1.1065399932861328e+02 -5.0927400588989258e+00 -2.6934201049804688e+02 -1.1218400573730469e+02 -5.0923199653625488e+00 -2.6881597900390625e+02 -1.2639400482177734e+02 -6.7432498931884766e+00 -2.6841900634765625e+02 -1.2327899932861328e+02 -7.2264099121093750e+00 -2.6796902465820312e+02 -1.2927600097656250e+02 -6.3476600646972656e+00 -2.6927200317382812e+02 -1.2998800659179688e+02 -6.2499599456787109e+00 -2.6948300170898438e+02 -1.3738299560546875e+02 -5.0935697555541992e+00 -2.7431198120117188e+02 -1.3662100219726562e+02 -5.2251801490783691e+00 -2.7358801269531250e+02 -1.3461500549316406e+02 -5.5441799163818359e+00 -2.7208898925781250e+02 -1.3337899780273438e+02 -5.7406997680664062e+00 -2.7116598510742188e+02 -6.3479400634765625e+01 -9.8900804519653320e+00 -3.3349600219726562e+02 -6.4206695556640625e+01 -9.6762800216674805e+00 -3.3361898803710938e+02 -6.4909599304199219e+01 -9.3369503021240234e+00 -3.1416897583007812e+02 -6.2961101531982422e+01 -9.9724502563476562e+00 -3.3349298095703125e+02 -6.6735603332519531e+01 -7.5491099357604980e+00 -3.3690802001953125e+02 -6.7135902404785156e+01 -6.7087397575378418e+00 -3.3843298339843750e+02 -6.7367301940917969e+01 -5.8320798873901367e+00 -3.3995199584960938e+02 -6.7404998779296875e+01 -5.5642700195312500e+00 -3.4035998535156250e+02 -6.4704795837402344e+01 -9.4560995101928711e+00 -3.3385299682617188e+02 -6.4905197143554688e+01 -9.3336696624755859e+00 -3.3401800537109375e+02 -6.4939605712890625e+01 -9.3285999298095703e+00 -3.1416897583007812e+02 -6.6734901428222656e+01 -7.5473198890686035e+00 -3.1416897583007812e+02 -6.5368301391601562e+01 -9.0505495071411133e+00 -3.3439801025390625e+02 -6.5712699890136719e+01 -8.7774391174316406e+00 -3.3481198120117188e+02 -6.6310302734375000e+01 -8.1618995666503906e+00 -3.3582800292968750e+02 -6.6745903015136719e+01 -7.5364098548889160e+00 -3.1416897583007812e+02 -6.6724304199218750e+01 -7.5727100372314453e+00 -3.3686599731445312e+02 -1.1577100372314453e+02 -7.5501799583435059e+00 -2.6779299926757812e+02 -1.1577100372314453e+02 -7.4691200256347656e+00 -2.6781600952148438e+02 -1.2265399932861328e+02 -7.4641098976135254e+00 -2.6781900024414062e+02 -1.2101799774169922e+02 -8.0872192382812500e+00 -2.6742498779296875e+02 -1.1792500305175781e+02 -8.8594503402709961e+00 -2.6667098999023438e+02 -1.1577100372314453e+02 -9.2400903701782227e+00 -2.6614199829101562e+02 -6.5083396911621094e+01 -9.3633508682250977e+00 -3.1139001464843750e+02 -6.5614204406738281e+01 -9.4076995849609375e+00 -3.0862100219726562e+02 -6.7560096740722656e+01 -8.8625593185424805e+00 -3.0583898925781250e+02 -6.6032897949218750e+01 -9.4349994659423828e+00 -3.0721301269531250e+02 -6.8184005737304688e+01 -7.9911398887634277e+00 -3.0627899169921875e+02 -6.7681999206542969e+01 -7.9036998748779297e+00 -3.0783200073242188e+02 -6.8481498718261719e+01 -7.5755100250244141e+00 -3.0648898315429688e+02 -6.6952102661132812e+01 -9.2812194824218750e+00 -3.0540600585937500e+02 -6.6747596740722656e+01 -9.4220600128173828e+00 -3.0526098632812500e+02 -6.6339004516601562e+01 -9.7034597396850586e+00 -3.0496902465820312e+02 -6.8490104675292969e+01 -7.5483899116516113e+00 -3.0649502563476562e+02 -6.6859199523925781e+01 -7.6554398536682129e+00 -3.1165200805664062e+02 -6.7316894531250000e+01 -7.8086800575256348e+00 -3.0912597656250000e+02 -1.0616099548339844e+02 -7.5541100502014160e+00 -2.7015701293945312e+02 -1.0531300354003906e+02 -9.3457107543945312e+00 -2.6854000854492188e+02 -1.1205799865722656e+02 -7.5531001091003418e+00 -2.6812698364257812e+02 -1.0817700195312500e+02 -9.9582099914550781e+00 -2.6535098266601562e+02 -1.0902500152587891e+02 -9.9045600891113281e+00 -2.6543099975585938e+02 -1.1120800018310547e+02 -9.7098398208618164e+00 -2.6562100219726562e+02 -1.1476200103759766e+02 -9.3426704406738281e+00 -2.6600000000000000e+02 -1.1421199798583984e+02 -9.3984603881835938e+00 -2.6592300415039062e+02 -1.1173100280761719e+02 -9.3454103469848633e+00 -2.6633099365234375e+02 -1.1160199737548828e+02 -9.6689500808715820e+00 -2.6566101074218750e+02 -1.0113700103759766e+02 -7.5501799583435059e+00 -2.7385397338867188e+02 -9.9846199035644531e+01 -9.3445796966552734e+00 -2.7256301879882812e+02 -3.8987899780273438e+01 -5.4737300872802734e+01 -3.3652899169921875e+02 -3.8628601074218750e+01 -5.4924999237060547e+01 -3.3666598510742188e+02 -3.6687602996826172e+01 -5.6001800537109375e+01 -3.3763800048828125e+02 -3.5134502410888672e+01 -5.6905300140380859e+01 -3.3856500244140625e+02 -4.2926898956298828e+01 -5.4449699401855469e+01 -3.3345098876953125e+02 -4.4123096466064453e+01 -5.2685100555419922e+01 -3.3477801513671875e+02 -4.3969398498535156e+01 -5.2716300964355469e+01 -3.3482901000976562e+02 -4.2047199249267578e+01 -5.3300701141357422e+01 -3.3546002197265625e+02 -4.0382602691650391e+01 -5.4008800506591797e+01 -3.3599401855468750e+02 -3.9509201049804688e+01 -5.4465000152587891e+01 -3.3632901000976562e+02 -4.8941200256347656e+01 -5.2010498046875000e+01 -3.3315798950195312e+02 -4.8752799987792969e+01 -5.2655399322509766e+01 -3.3020401000976562e+02 -4.8367298126220703e+01 -5.2036300659179688e+01 -3.3335302734375000e+02 -4.6156803131103516e+01 -5.2272201538085938e+01 -3.3409899902343750e+02 -4.4218799591064453e+01 -5.2665699005126953e+01 -3.3474600219726562e+02 -4.7395797729492188e+01 -5.4449699401855469e+01 -3.2898199462890625e+02 -5.1373199462890625e+01 -5.4449699401855469e+01 -3.2407000732421875e+02 -5.4815299987792969e+01 -5.4449699401855469e+01 -3.1876998901367188e+02 -5.7684600830078125e+01 -5.4449699401855469e+01 -3.1313897705078125e+02 -5.9949401855468750e+01 -5.4449699401855469e+01 -3.0723800659179688e+02 -6.1585197448730469e+01 -5.4449699401855469e+01 -3.0113400268554688e+02 -6.2573902130126953e+01 -5.4449699401855469e+01 -2.9489099121093750e+02 -6.2904701232910156e+01 -5.4449699401855469e+01 -2.8857998657226562e+02 -6.2573902130126953e+01 -5.4449699401855469e+01 -2.8226901245117188e+02 -6.1585197448730469e+01 -5.4449699401855469e+01 -2.7602600097656250e+02 -5.9949401855468750e+01 -5.4449699401855469e+01 -2.6992199707031250e+02 -5.7684600830078125e+01 -5.4449699401855469e+01 -2.6402099609375000e+02 -5.4815299987792969e+01 -5.4449699401855469e+01 -2.5839001464843750e+02 -5.1373199462890625e+01 -5.4449699401855469e+01 -2.5308999633789062e+02 -4.5872100830078125e+01 -5.4449699401855469e+01 -2.4654800415039062e+02 -5.2850399017333984e+01 -5.2655399322509766e+01 -3.2514398193359375e+02 -5.6396598815917969e+01 -5.2655399322509766e+01 -3.1968298339843750e+02 -5.9352699279785156e+01 -5.2655399322509766e+01 -3.1388101196289062e+02 -6.1686100006103516e+01 -5.2655399322509766e+01 -3.0780300903320312e+02 -6.3371299743652344e+01 -5.2655399322509766e+01 -3.0151300048828125e+02 -6.4389900207519531e+01 -5.2655399322509766e+01 -2.9508200073242188e+02 -6.4730598449707031e+01 -5.2655399322509766e+01 -2.8857998657226562e+02 -6.4389900207519531e+01 -5.2655399322509766e+01 -2.8207800292968750e+02 -6.3371299743652344e+01 -5.2655399322509766e+01 -2.7564700317382812e+02 -6.1686100006103516e+01 -5.2655399322509766e+01 -2.6935699462890625e+02 -5.9352699279785156e+01 -5.2655399322509766e+01 -2.6327899169921875e+02 -5.6396598815917969e+01 -5.2655399322509766e+01 -2.5747698974609375e+02 -5.2850399017333984e+01 -5.2655399322509766e+01 -2.5201600646972656e+02 -4.7182998657226562e+01 -5.2655399322509766e+01 -2.4527600097656250e+02 -5.6606001853942871e+00 -3.8939201354980469e+01 -2.2866400146484375e+02 -5.7453002929687500e+00 -3.8786602020263672e+01 -2.2865599060058594e+02 -1.6861200332641602e+01 -4.3917400360107422e+01 -2.3015800476074219e+02 -1.1357899665832520e+01 -4.1414997100830078e+01 -2.2918798828125000e+02 -1.1124500274658203e+01 -4.1832302093505859e+01 -2.2923199462890625e+02 -1.6479799270629883e+01 -4.4591400146484375e+01 -2.3026800537109375e+02 -2.2230699539184570e+01 -4.6238002777099609e+01 -2.3155300903320312e+02 -2.4439599990844727e+01 -4.7144199371337891e+01 -2.3226199340820312e+02 -2.9203800201416016e+01 -4.8969997406005859e+01 -2.3407701110839844e+02 -3.2813796997070312e+01 -5.1882400512695312e+01 -2.3670100402832031e+02 -2.8475801467895508e+01 -5.0196201324462891e+01 -2.3446099853515625e+02 -2.3848499298095703e+01 -4.8163002014160156e+01 -2.3251699829101562e+02 -2.1701698303222656e+01 -4.7157802581787109e+01 -2.3175900268554688e+02 -4.1081699371337891e+01 -5.2273097991943359e+01 -2.4056401062011719e+02 -3.7849601745605469e+01 -5.1618900299072266e+01 -2.3848699951171875e+02 -3.3675498962402344e+01 -5.0472698211669922e+01 -2.3616500854492188e+02 -3.6857501983642578e+01 -5.3184299468994141e+01 -2.3919999694824219e+02 -3.9983997344970703e+01 -5.3942699432373047e+01 -2.4144099426269531e+02 -4.3081001281738281e+01 -5.4396499633789062e+01 -2.4396699523925781e+02 -4.4288299560546875e+01 -5.2645603179931641e+01 -2.4289900207519531e+02 -3.5368698120117188e+01 -9.9996299743652344e+00 -3.3938299560546875e+02 -3.3603999614715576e+00 -1.0107999801635742e+01 -2.2809300231933594e+02 -2.2250900268554688e+01 -1.4438099861145020e+01 -2.2865100097656250e+02 -2.4560400009155273e+01 -9.9735298156738281e+00 -2.3048100280761719e+02 -2.3486999511718750e+01 -1.2057900428771973e+01 -2.2910200500488281e+02 -2.1996099472045898e+01 -1.1802499771118164e+01 -2.2894200134277344e+02 -1.7183898925781250e+01 -1.1170000076293945e+01 -2.2855499267578125e+02 -1.1780799865722656e+01 -1.0674299240112305e+01 -2.2827899169921875e+02 -4.7753000259399414e+00 -1.0194700241088867e+01 -2.2810099792480469e+02 -3.4539798736572266e+01 -1.1272500038146973e+01 -2.3253700256347656e+02 -3.8780601501464844e+01 -1.1612400054931641e+01 -2.3374398803710938e+02 -4.2581497192382812e+01 -1.1716700553894043e+01 -2.3494699096679688e+02 -4.7141201019287109e+01 -1.1501000404357910e+01 -2.3655999755859375e+02 -4.9658100128173828e+01 -1.1166999816894531e+01 -2.3754299926757812e+02 -4.6835399627685547e+01 -1.4878600120544434e+01 -2.3215000915527344e+02 -4.9658100128173828e+01 -1.4486299514770508e+01 -2.3264500427246094e+02 -4.6400497436523438e+01 -1.9624000549316406e+01 -2.2927999877929688e+02 -4.9658100128173828e+01 -1.9441600799560547e+01 -2.2941200256347656e+02 -4.5974197387695312e+01 -1.1598800659179688e+01 -2.3612800598144531e+02 -4.5544200897216797e+01 -1.4980000495910645e+01 -2.3193499755859375e+02 -4.4947799682617188e+01 -1.9615100860595703e+01 -2.2922100830078125e+02 -4.1849098205566406e+01 -1.5043999671936035e+01 -2.3135099792480469e+02 -4.0895999908447266e+01 -1.9331899642944336e+01 -2.2906098937988281e+02 -3.7806297302246094e+01 -1.4793099403381348e+01 -2.3076400756835938e+02 -3.6609703063964844e+01 -1.8668800354003906e+01 -2.2889601135253906e+02 -3.3405200958251953e+01 -1.4213999748229980e+01 -2.3018299865722656e+02 -3.2081699371337891e+01 -1.7622598648071289e+01 -2.2872898864746094e+02 -2.9817199707031250e+01 -1.0687000274658203e+01 -2.3135900878906250e+02 -2.8623899459838867e+01 -1.3297599792480469e+01 -2.2962098693847656e+02 -2.7294000625610352e+01 -1.6191699981689453e+01 -2.2856298828125000e+02 -4.9746498107910156e+01 -1.9441600799560547e+01 -2.2941200256347656e+02 -4.9746498107910156e+01 -1.4486299514770508e+01 -2.3264500427246094e+02 -4.9746498107910156e+01 -1.1166999816894531e+01 -2.3754299926757812e+02 -1.1598799896240234e+02 -1.9445301055908203e+01 -2.5486401367187500e+02 -1.1382299804687500e+02 -1.4488200187683105e+01 -2.5726602172851562e+02 -1.1057900238037109e+02 -1.9449501037597656e+01 -2.5032499694824219e+02 -1.1054299926757812e+02 -1.1167500495910645e+01 -2.6090402221679688e+02 -1.0859099578857422e+02 -1.4490400314331055e+01 -2.5287399291992188e+02 -1.0557799530029297e+02 -1.1168100357055664e+01 -2.5673699951171875e+02 -9.6890701293945312e+01 -1.9455600738525391e+01 -2.4136300659179688e+02 -8.1911399841308594e+01 -1.9456300735473633e+01 -2.3478099060058594e+02 -6.6051803588867188e+01 -1.9451499938964844e+01 -2.3076100158691406e+02 -9.5350494384765625e+01 -1.4493499755859375e+01 -2.4420399475097656e+02 -8.0860603332519531e+01 -1.4493800163269043e+01 -2.3783700561523438e+02 -6.5518997192382812e+01 -1.4491399765014648e+01 -2.3394900512695312e+02 -9.3015098571777344e+01 -1.1168899536132812e+01 -2.4851199340820312e+02 -7.9267303466796875e+01 -1.1168999671936035e+01 -2.4247200012207031e+02 -6.4711402893066406e+01 -1.1168399810791016e+01 -2.3878199768066406e+02 -1.1211699676513672e+02 -1.1366100311279297e+01 -2.6148699951171875e+02 -1.1298699951171875e+02 -1.1425999641418457e+01 -2.6181997680664062e+02 -1.1557599639892578e+02 -1.4715399742126465e+01 -2.5844500732421875e+02 -1.1651399993896484e+02 -1.4767700195312500e+01 -2.5909298706054688e+02 -1.1805500030517578e+02 -1.9523300170898438e+01 -2.5666400146484375e+02 -1.1912200164794922e+02 -1.9468599319458008e+01 -2.5762799072265625e+02 -1.2468899536132812e+02 -1.8142898559570312e+01 -2.6265002441406250e+02 -1.2358999633789062e+02 -1.8505298614501953e+01 -2.6166799926757812e+02 -1.2386100006103516e+02 -1.6899301528930664e+01 -2.6271298217773438e+02 -1.1775000000000000e+02 -1.1423000335693359e+01 -2.6350399780273438e+02 -1.2220200347900391e+02 -1.4406000137329102e+01 -2.6283999633789062e+02 -1.2098400115966797e+02 -1.4563100814819336e+01 -2.6203601074218750e+02 -1.2015700531005859e+02 -1.2364899635314941e+01 -2.6364099121093750e+02 -1.1913699340820312e+02 -1.1346899986267090e+01 -2.6403997802734375e+02 -1.1501599884033203e+02 -1.1492799758911133e+01 -2.6252200317382812e+02 -1.1848200225830078e+02 -1.4773200035095215e+01 -2.6039801025390625e+02 -1.2118600463867188e+02 -1.9152999877929688e+01 -2.5950598144531250e+02 -1.2727400970458984e+02 -9.1937198638916016e+00 -2.6773101806640625e+02 -1.2222100067138672e+02 -1.1807800292968750e+01 -2.6471499633789062e+02 -1.2592600250244141e+02 -1.5944400787353516e+01 -2.6434201049804688e+02 -1.2880200195312500e+02 -1.3946599960327148e+01 -2.6686099243164062e+02 -1.2513400268554688e+02 -1.0652700424194336e+01 -2.6644799804687500e+02 -1.3091699218750000e+02 -1.1577700614929199e+01 -2.6870199584960938e+02 -1.3213800048828125e+02 -7.5271697044372559e+00 -2.7013598632812500e+02 -1.3244400024414062e+02 -1.0270199775695801e+01 -2.6987100219726562e+02 -1.3408100891113281e+02 -8.8778104782104492e+00 -2.7117602539062500e+02 -1.2957299804687500e+02 -8.4038391113281250e+00 -2.6875399780273438e+02 -1.3304800415039062e+02 -8.1593399047851562e+00 -2.7062298583984375e+02 -1.3305200195312500e+02 -7.8927903175354004e+00 -2.7061300659179688e+02 -1.3739700317382812e+02 -5.1030497550964355e+00 -2.7432598876953125e+02 -1.3693099975585938e+02 -5.4318299293518066e+00 -2.7386199951171875e+02 -1.3503999328613281e+02 -6.7079701423645020e+00 -2.7214898681640625e+02 -1.3312100219726562e+02 -7.9298000335693359e+00 -2.7063900756835938e+02 -3.6677700042724609e+01 -1.0388999938964844e+01 -3.3877798461914062e+02 -3.7872299194335938e+01 -1.0749899864196777e+01 -3.3857199096679688e+02 -3.7658401489257812e+01 -1.0390800476074219e+01 -3.3859197998046875e+02 -3.6552501678466797e+01 -3.3788497924804688e+01 -3.3837100219726562e+02 -3.6885299682617188e+01 -5.2940700531005859e+01 -3.3792901611328125e+02 -3.6452598571777344e+01 -5.3862697601318359e+01 -3.3804699707031250e+02 -3.5874900817871094e+01 -5.5093898773193359e+01 -3.3820501708984375e+02 -3.5127899169921875e+01 -5.6898002624511719e+01 -3.3856900024414062e+02 -3.7401798248291016e+01 -9.9273900985717773e+00 -3.3862799072265625e+02 -3.7387100219726562e+01 -9.8999099731445312e+00 -3.3863101196289062e+02 -3.7135997772216797e+01 -9.4304695129394531e+00 -3.3867498779296875e+02 -3.4961601257324219e+01 -5.1891798973083496e+00 -3.3945098876953125e+02 -3.5953102111816406e+01 -7.2358198165893555e+00 -3.3900100708007812e+02 -3.5983901977539062e+01 -7.2929301261901855e+00 -3.3899200439453125e+02 -1.0671199798583984e+02 -5.1147098541259766e+01 -3.4019299316406250e+02 -1.0737599945068359e+02 -5.1202499389648438e+01 -3.4032400512695312e+02 -1.0142900085449219e+02 -4.9449001312255859e+01 -3.4034500122070312e+02 -1.1948099517822266e+02 -5.2000000000000000e+01 -3.4275100708007812e+02 -6.5719795227050781e+01 -1.4331999778747559e+01 -3.3867599487304688e+02 -6.5244697570800781e+01 -1.4637299537658691e+01 -3.3855700683593750e+02 -6.8885299682617188e+01 -2.0095899581909180e+01 -3.3906799316406250e+02 -6.6647399902343750e+01 -1.3155999183654785e+01 -3.3919500732421875e+02 -6.6617103576660156e+01 -1.3227200508117676e+01 -3.3916198730468750e+02 -6.6321800231933594e+01 -1.3692599296569824e+01 -3.3895199584960938e+02 -6.7385299682617188e+01 -1.0970800399780273e+01 -3.4020800781250000e+02 -6.7093002319335938e+01 -1.2108700752258301e+01 -3.3967901611328125e+02 -7.0584197998046875e+01 -1.9451101303100586e+01 -3.4089700317382812e+02 -6.7618301391601562e+01 -9.2688798904418945e+00 -3.4098199462890625e+02 -6.8337402343750000e+01 -9.1618900299072266e+00 -3.4347702026367188e+02 -6.8220199584960938e+01 -9.1743497848510742e+00 -3.4249697875976562e+02 -6.8110305786132812e+01 -9.1916303634643555e+00 -3.4222000122070312e+02 -6.7661598205566406e+01 -9.2620801925659180e+00 -3.4109100341796875e+02 -1.1624600219726562e+02 -5.1943397521972656e+01 -3.4207998657226562e+02 -1.1222100067138672e+02 -5.1607299804687500e+01 -3.4128298950195312e+02 -9.6468795776367188e+01 -4.9315799713134766e+01 -3.3856500244140625e+02 -1.0029900360107422e+02 -5.0113300323486328e+01 -3.3909197998046875e+02 -1.0112200164794922e+02 -5.0245899200439453e+01 -3.3923300170898438e+02 -9.0525703430175781e+01 -4.6093898773193359e+01 -3.3860800170898438e+02 -8.9545799255371094e+01 -4.7622798919677734e+01 -3.3799899291992188e+02 -9.1393997192382812e+01 -4.8114299774169922e+01 -3.3805902099609375e+02 -9.1497398376464844e+01 -4.4578899383544922e+01 -3.4043402099609375e+02 -9.5812995910644531e+01 -4.9179199218750000e+01 -3.3847399902343750e+02 -8.2802497863769531e+01 -3.7742202758789062e+01 -3.4055999755859375e+02 -7.5727600097656250e+01 -2.9241201400756836e+01 -3.4071697998046875e+02 -8.1528999328613281e+01 -3.9020797729492188e+01 -3.3873300170898438e+02 -7.4208000183105469e+01 -3.0225299835205078e+01 -3.3888900756835938e+02 -6.7539398193359375e+01 -4.6439800262451172e+00 -3.4220599365234375e+02 -6.7468299865722656e+01 -4.4750599861145020e+00 -3.4200799560546875e+02 -6.7477798461914062e+01 -4.6498198509216309e+00 -3.4198400878906250e+02 -6.7484100341796875e+01 -4.7657499313354492e+00 -3.4196798706054688e+02 -6.7503799438476562e+01 -5.1269497871398926e+00 -3.4191900634765625e+02 -6.7525199890136719e+01 -5.5202798843383789e+00 -3.4186499023437500e+02 -6.7582504272460938e+01 -6.5720701217651367e+00 -3.4172201538085938e+02 -6.7587097167968750e+01 -6.6561698913574219e+00 -3.4170999145507812e+02 -6.7603202819824219e+01 -9.2152900695800781e+00 -3.4097299194335938e+02 -6.7587699890136719e+01 -9.1617698669433594e+00 -3.4096398925781250e+02 -6.7587699890136719e+01 -9.2061700820922852e+00 -3.4095098876953125e+02 -6.7610702514648438e+01 -9.2669696807861328e+00 -3.4097100830078125e+02 -6.7615798950195312e+01 -9.2689399719238281e+00 -3.4097799682617188e+02 -6.7605804443359375e+01 -9.2620801925659180e+00 -3.4096398925781250e+02 -6.7600402832031250e+01 -9.2523097991943359e+00 -3.4095800781250000e+02 -6.7587196350097656e+01 -7.1531500816345215e+00 -3.4156201171875000e+02 -3.5131202697753906e+01 -5.6901699066162109e+01 -3.3856698608398438e+02 -3.6303100585937500e+01 -5.5552799224853516e+01 -3.3796099853515625e+02 -3.9264598846435547e+01 -5.2719100952148438e+01 -3.3735702514648438e+02 -3.9635898590087891e+01 -5.3147399902343750e+01 -3.3690499877929688e+02 -3.7842098236083984e+01 -5.3982398986816406e+01 -3.3749301147460938e+02 -3.8805599212646484e+01 -5.2182998657226562e+01 -3.3752502441406250e+02 -4.9602901458740234e+01 -5.1344600677490234e+01 -3.3540798950195312e+02 -4.9602901458740234e+01 -4.9550201416015625e+01 -3.3723397827148438e+02 -4.8820098876953125e+01 -4.9503898620605469e+01 -3.3727200317382812e+02 -4.5925800323486328e+01 -5.1340599060058594e+01 -3.3605300903320312e+02 -4.8296001434326172e+01 -5.1256099700927734e+01 -3.3564697265625000e+02 -4.8905200958251953e+01 -5.1284900665283203e+01 -3.3553698730468750e+02 -4.8140296936035156e+01 -4.9492500305175781e+01 -3.3730300903320312e+02 -4.5525100708007812e+01 -4.9689399719238281e+01 -3.3741302490234375e+02 -4.2956401824951172e+01 -5.0261402130126953e+01 -3.3750799560546875e+02 -4.3559799194335938e+01 -5.1732601165771484e+01 -3.3642797851562500e+02 -4.1477500915527344e+01 -5.2362697601318359e+01 -3.3673797607421875e+02 -4.0726299285888672e+01 -5.1111301422119141e+01 -3.3757901000976562e+02 -8.7531799316406250e+01 -5.1344600677490234e+01 -3.3540798950195312e+02 -8.7531799316406250e+01 -4.9550201416015625e+01 -3.3723397827148438e+02 -9.1513099670410156e+01 -5.0118301391601562e+01 -3.3710101318359375e+02 -9.6061500549316406e+01 -5.0670200347900391e+01 -3.3739797973632812e+02 -1.0703100585937500e+02 -5.1614700317382812e+01 -3.3938500976562500e+02 -1.1634899902343750e+02 -5.1974800109863281e+01 -3.4185299682617188e+02 -1.1948300170898438e+02 -5.2000000000000000e+01 -3.4274798583984375e+02 -1.0062500000000000e+02 -5.1129199981689453e+01 -3.3804898071289062e+02 -1.1948400115966797e+02 -5.2000000000000000e+01 -3.4274499511718750e+02 -1.1645300292968750e+02 -5.1993701934814453e+01 -3.4162597656250000e+02 -1.0737799835205078e+02 -5.1902698516845703e+01 -3.3850799560546875e+02 -1.0102600097656250e+02 -5.1777297973632812e+01 -3.3676599121093750e+02 -9.6415100097656250e+01 -5.1655696868896484e+01 -3.3586599731445312e+02 -9.1727600097656250e+01 -5.1505100250244141e+01 -3.3537399291992188e+02 -6.7506797790527344e+01 -6.9730300903320312e+00 -3.4134997558593750e+02 -6.7260200500488281e+01 -8.5735301971435547e+00 -3.4044500732421875e+02 -6.7541503906250000e+01 -6.4718098640441895e+00 -3.4160000610351562e+02 -6.7450302124023438e+01 -4.4957399368286133e+00 -3.4182998657226562e+02 -6.6809997558593750e+01 -1.0057000160217285e+01 -3.3957400512695312e+02 -6.7448699951171875e+01 -5.2171297073364258e+00 -3.4130297851562500e+02 -6.7397697448730469e+01 -5.8650398254394531e+00 -3.4077899169921875e+02 -6.7470794677734375e+01 -4.7492399215698242e+00 -3.4181698608398438e+02 -6.7488502502441406e+01 -5.3711500167846680e+00 -3.4164199829101562e+02 -6.7341094970703125e+01 -6.2075800895690918e+00 -3.4042700195312500e+02 -6.7012496948242188e+01 -7.2991800308227539e+00 -3.3913497924804688e+02 -6.6468795776367188e+01 -8.3029899597167969e+00 -3.3784899902343750e+02 -6.6377197265625000e+01 -1.0986100196838379e+01 -3.3905200195312500e+02 -6.5968200683593750e+01 -8.9234104156494141e+00 -3.3703900146484375e+02 -6.5325202941894531e+01 -9.4924592971801758e+00 -3.3629598999023438e+02 -6.4995399475097656e+01 -9.7129907608032227e+00 -3.3601098632812500e+02 -6.4433502197265625e+01 -1.0000599861145020e+01 -3.3565701293945312e+02 -6.4060394287109375e+01 -1.0139299392700195e+01 -3.3550997924804688e+02 -6.3553600311279297e+01 -1.0271800041198730e+01 -3.3542901611328125e+02 -6.7443397521972656e+01 -6.1686000823974609e+00 -3.4119400024414062e+02 -6.7387901306152344e+01 -6.5897097587585449e+00 -3.4089498901367188e+02 -6.7054397583007812e+01 -7.9279494285583496e+00 -3.3981399536132812e+02 -6.6497993469238281e+01 -9.1487798690795898e+00 -3.3877200317382812e+02 -6.5991104125976562e+01 -9.8928203582763672e+00 -3.3814599609375000e+02 -6.5357093811035156e+01 -1.0558100700378418e+01 -3.3761001586914062e+02 -6.5042800903320312e+01 -1.0806400299072266e+01 -3.3741900634765625e+02 -6.4530097961425781e+01 -1.1111999511718750e+01 -3.3719900512695312e+02 -6.4206398010253906e+01 -1.1244999885559082e+01 -3.3711300659179688e+02 -6.3778305053710938e+01 -1.1354700088500977e+01 -3.3706097412109375e+02 -6.5804801940917969e+01 -1.1852400779724121e+01 -3.3860299682617188e+02 -6.5504501342773438e+01 -1.2191599845886230e+01 -3.3844302368164062e+02 -6.4980598449707031e+01 -1.2628999710083008e+01 -3.3825601196289062e+02 -6.4622200012207031e+01 -1.2824599266052246e+01 -3.3818298339843750e+02 -6.4118698120117188e+01 -1.2970399856567383e+01 -3.3813900756835938e+02 -6.3282497406005859e+01 -1.3102900505065918e+01 -3.3813699340820312e+02 -6.3111297607421875e+01 -1.1460200309753418e+01 -3.3705899047851562e+02 -6.2998302459716797e+01 -1.0359600067138672e+01 -3.3542599487304688e+02 -6.2437000274658203e+01 -1.3147200584411621e+01 -3.3813598632812500e+02 -6.2437000274658203e+01 -1.1495400428771973e+01 -3.3705801391601562e+02 -6.2437000274658203e+01 -1.0388999938964844e+01 -3.3542599487304688e+02 -4.9966800689697266e+01 -1.3147200584411621e+01 -3.3813598632812500e+02 -4.9966800689697266e+01 -1.1495400428771973e+01 -3.3705801391601562e+02 -4.9966800689697266e+01 -1.0388999938964844e+01 -3.3542599487304688e+02 -4.2491699218750000e+01 -9.6091604232788086e+00 -3.3701199340820312e+02 -4.0304199218750000e+01 -8.7581291198730469e+00 -3.3744400024414062e+02 -4.0067199707031250e+01 -8.6403493881225586e+00 -3.3748999023437500e+02 -3.9714401245117188e+01 -9.5350103378295898e+00 -3.3806198120117188e+02 -3.9466999053955078e+01 -9.3931503295898438e+00 -3.3808499145507812e+02 -3.9051902770996094e+01 -1.0402100563049316e+01 -3.3844000244140625e+02 -3.8796298980712891e+01 -1.0229299545288086e+01 -3.3844799804687500e+02 -4.2007099151611328e+01 -1.0560099601745605e+01 -3.3784802246093750e+02 -4.1434898376464844e+01 -1.1674500465393066e+01 -3.3836697387695312e+02 -4.4652599334716797e+01 -1.0137399673461914e+01 -3.3657397460937500e+02 -4.4289398193359375e+01 -1.1196799278259277e+01 -3.3763198852539062e+02 -4.3835498809814453e+01 -1.2509400367736816e+01 -3.3829901123046875e+02 -4.5274997711181641e+01 -1.0242200851440430e+01 -3.3644500732421875e+02 -4.4949901580810547e+01 -1.1323100090026855e+01 -3.3756802368164062e+02 -4.4535999298095703e+01 -1.2686200141906738e+01 -3.3827999877929688e+02 -4.7666797637939453e+01 -1.0460799217224121e+01 -3.3593801879882812e+02 -4.7499599456787109e+01 -1.1585599899291992e+01 -3.3731600952148438e+02 -4.7269298553466797e+01 -1.3117499351501465e+01 -3.3820599365234375e+02 -3.9164901733398438e+01 -9.1570005416870117e+00 -3.3809997558593750e+02 -3.8860599517822266e+01 -8.9142303466796875e+00 -3.3812799072265625e+02 -3.8491699218750000e+01 -8.6008901596069336e+00 -3.3817602539062500e+02 -3.8115100860595703e+01 -8.2637691497802734e+00 -3.3823800659179688e+02 -3.4964698791503906e+01 -5.1853599548339844e+00 -3.3944897460937500e+02 -3.6416999816894531e+01 -6.6925902366638184e+00 -3.3873800659179688e+02 -6.0308696746826172e+01 -6.2500000000000000e+01 -2.7629797363281250e+02 4.5267398834228516e+01 -6.2500000000000000e+01 -3.2330300903320312e+02 -5.6492401123046875e+01 -6.2500000000000000e+01 -2.6455200195312500e+02 5.1442398071289062e+01 -6.2500000000000000e+01 -3.1260800170898438e+02 5.5258697509765625e+01 -6.2500000000000000e+01 -3.0086199951171875e+02 5.6549602508544922e+01 -6.2500000000000000e+01 -2.8857998657226562e+02 5.5258697509765625e+01 -6.2500000000000000e+01 -2.7629797363281250e+02 5.1442398071289062e+01 -6.2500000000000000e+01 -2.6455200195312500e+02 4.5267398834228516e+01 -6.2500000000000000e+01 -2.5385697937011719e+02 3.7003597259521484e+01 -6.2500000000000000e+01 -2.4467900085449219e+02 2.7012300491333008e+01 -6.2500000000000000e+01 -2.3741999816894531e+02 -3.2062297821044922e+01 -6.2500000000000000e+01 -2.3741999816894531e+02 1.5729999542236328e+01 -6.2500000000000000e+01 -2.3239700317382812e+02 -6.1599700927734375e+01 -6.2500000000000000e+01 -2.8857998657226562e+02 -6.0308696746826172e+01 -6.2500000000000000e+01 -3.0086199951171875e+02 3.7003597259521484e+01 -6.2500000000000000e+01 -3.3248098754882812e+02 2.7012300491333008e+01 -6.2500000000000000e+01 -3.3974002075195312e+02 -4.2053699493408203e+01 -6.2500000000000000e+01 -2.4467900085449219e+02 -5.0317398071289062e+01 -6.2500000000000000e+01 -2.5385697937011719e+02 3.6500000953674316e+00 -6.2500000000000000e+01 -2.2982899475097656e+02 -8.6999998092651367e+00 -6.2500000000000000e+01 -2.2982899475097656e+02 -2.0780099868774414e+01 -6.2500000000000000e+01 -2.3239700317382812e+02 -5.6492401123046875e+01 -6.2500000000000000e+01 -3.1260800170898438e+02 -5.0317398071289062e+01 -6.2500000000000000e+01 -3.2330300903320312e+02 -4.2053699493408203e+01 -6.2500000000000000e+01 -3.3248098754882812e+02 -3.2062297821044922e+01 -6.2500000000000000e+01 -3.3974002075195312e+02 -2.0780099868774414e+01 -6.2500000000000000e+01 -3.4476300048828125e+02 1.5729999542236328e+01 -6.2500000000000000e+01 -3.4476300048828125e+02 -8.6999998092651367e+00 -6.2500000000000000e+01 -3.4733099365234375e+02 3.6500000953674316e+00 -6.2500000000000000e+01 -3.4733099365234375e+02 -4.4269798278808594e+01 -2.5000000000000000e+00 -3.2812301635742188e+02 -5.0839199066162109e+01 -2.5000000000000000e+00 -3.2368200683593750e+02 -5.1794300079345703e+01 -2.5000000000000000e+00 -3.1822399902343750e+02 -5.7081699371337891e+01 -2.5000000000000000e+00 -3.1286999511718750e+02 -5.7015098571777344e+01 -2.5000000000000000e+00 -3.0694000244140625e+02 -6.0939701080322266e+01 -2.5000000000000000e+00 -3.0099600219726562e+02 -5.9687999725341797e+01 -2.5000000000000000e+00 -2.9479699707031250e+02 -6.2244697570800781e+01 -2.5000000000000000e+00 -2.8857998657226562e+02 -6.0024997711181641e+01 -2.5000000000000000e+00 -2.8857998657226562e+02 -5.9687999725341797e+01 -2.5000000000000000e+00 -2.8236300659179688e+02 -6.0939701080322266e+01 -2.5000000000000000e+00 -2.7616400146484375e+02 -5.7015098571777344e+01 -2.5000000000000000e+00 -2.7022000122070312e+02 -5.7081699371337891e+01 -2.5000000000000000e+00 -2.6429000854492188e+02 -5.1794300079345703e+01 -2.5000000000000000e+00 -2.5893597412109375e+02 -5.0839199066162109e+01 -2.5000000000000000e+00 -2.5347799682617188e+02 -4.4269798278808594e+01 -2.5000000000000000e+00 -2.4903700256347656e+02 -4.2485301971435547e+01 -2.5000000000000000e+00 -2.4420001220703125e+02 -3.4793296813964844e+01 -2.5000000000000000e+00 -2.4098800659179688e+02 -3.2384899139404297e+01 -2.5000000000000000e+00 -2.3686100769042969e+02 -2.3808000564575195e+01 -2.5000000000000000e+00 -2.3516400146484375e+02 -2.0979400634765625e+01 -2.5000000000000000e+00 -2.3178300476074219e+02 -1.1827499389648438e+01 -2.5000000000000000e+00 -2.3183799743652344e+02 -8.7674999237060547e+00 -2.5000000000000000e+00 -2.2918798828125000e+02 5.8799999952316284e-01 -2.5000000000000000e+00 -2.3116398620605469e+02 3.7173998355865479e+00 -2.5000000000000000e+00 -2.2918798828125000e+02 1.2857899665832520e+01 -2.5000000000000000e+00 -2.3317599487304688e+02 1.5929401397705078e+01 -2.5000000000000000e+00 -2.3178300476074219e+02 2.4408500671386719e+01 -2.5000000000000000e+00 -2.3777799987792969e+02 2.7334800720214844e+01 -2.5000000000000000e+00 -2.3686100769042969e+02 3.4699699401855469e+01 -2.5000000000000000e+00 -2.4475599670410156e+02 3.7435298919677734e+01 -2.5000000000000000e+00 -2.4420001220703125e+02 4.3250301361083984e+01 -2.5000000000000000e+00 -2.5378298950195312e+02 4.5789199829101562e+01 -2.5000000000000000e+00 -2.5347799682617188e+02 4.9660602569580078e+01 -2.5000000000000000e+00 -2.6443600463867188e+02 5.2031597137451172e+01 -2.5000000000000000e+00 -2.6429000854492188e+02 5.3630699157714844e+01 -2.5000000000000000e+00 -2.7621902465820312e+02 5.5889598846435547e+01 -2.5000000000000000e+00 -2.7616400146484375e+02 5.4974998474121094e+01 -2.5000000000000000e+00 -2.8857998657226562e+02 5.7194698333740234e+01 -2.5000000000000000e+00 -2.8857998657226562e+02 5.3630699157714844e+01 -2.5000000000000000e+00 -3.0094097900390625e+02 5.5889598846435547e+01 -2.5000000000000000e+00 -3.0099600219726562e+02 4.9660602569580078e+01 -2.5000000000000000e+00 -3.1272399902343750e+02 5.2031597137451172e+01 -2.5000000000000000e+00 -3.1286999511718750e+02 4.3250301361083984e+01 -2.5000000000000000e+00 -3.2337799072265625e+02 4.5789199829101562e+01 -2.5000000000000000e+00 -3.2368200683593750e+02 3.4699699401855469e+01 -2.5000000000000000e+00 -3.3240399169921875e+02 3.7435298919677734e+01 -2.5000000000000000e+00 -3.3296002197265625e+02 2.4408500671386719e+01 -2.5000000000000000e+00 -3.3938198852539062e+02 2.7334800720214844e+01 -2.5000000000000000e+00 -3.4029901123046875e+02 1.2857899665832520e+01 -2.5000000000000000e+00 -3.4398400878906250e+02 1.5929401397705078e+01 -2.5000000000000000e+00 -3.4537698364257812e+02 5.8799999952316284e-01 -2.5000000000000000e+00 -3.4599600219726562e+02 3.7173998355865479e+00 -2.5000000000000000e+00 -3.4797299194335938e+02 -1.1827499389648438e+01 -2.5000000000000000e+00 -3.4532299804687500e+02 -8.7674999237060547e+00 -2.5000000000000000e+00 -3.4797299194335938e+02 -2.3808000564575195e+01 -2.5000000000000000e+00 -3.4199600219726562e+02 -2.0979400634765625e+01 -2.5000000000000000e+00 -3.4537698364257812e+02 -3.4793296813964844e+01 -2.5000000000000000e+00 -3.3617202758789062e+02 -3.2384899139404297e+01 -2.5000000000000000e+00 -3.4029901123046875e+02 -4.2485301971435547e+01 -2.5000000000000000e+00 -3.3296002197265625e+02 -1.2509700775146484e+02 -4.7675399780273438e+01 -3.5058001708984375e+02 -1.3098500061035156e+02 -5.0208698272705078e+01 -3.5058001708984375e+02 -1.3594200134277344e+02 -4.5105201721191406e+01 -3.5058001708984375e+02 -1.4187001037597656e+02 -4.6399898529052734e+01 -3.5058001708984375e+02 -1.4590100097656250e+02 -4.0103397369384766e+01 -3.5058001708984375e+02 -1.5163500976562500e+02 -4.0264301300048828e+01 -3.5058001708984375e+02 -1.5443899536132812e+02 -3.2939502716064453e+01 -3.5058001708984375e+02 -1.5978900146484375e+02 -3.2109699249267578e+01 -3.5058001708984375e+02 -1.6109399414062500e+02 -2.4000000000000000e+01 -3.5058001708984375e+02 -1.6592500305175781e+02 -2.2345001220703125e+01 -3.5058001708984375e+02 -1.6550799560546875e+02 -1.3766500473022461e+01 -3.5058001708984375e+02 -1.6973400878906250e+02 -1.1459800720214844e+01 -3.5058001708984375e+02 -1.6744400024414062e+02 -2.7909300327301025e+00 -3.5058001708984375e+02 -1.7102499389648438e+02 0.0000000000000000e+00 -3.5058001708984375e+02 -1.6679600524902344e+02 8.3351097106933594e+00 -3.5058001708984375e+02 -1.6973400878906250e+02 1.1459800720214844e+01 -3.5058001708984375e+02 -1.6359899902343750e+02 1.9011798858642578e+01 -3.5058001708984375e+02 -1.6592500305175781e+02 2.2345001220703125e+01 -3.5058001708984375e+02 -1.5802699279785156e+02 2.8663599014282227e+01 -3.5058001708984375e+02 -1.5978900146484375e+02 3.2109699249267578e+01 -3.5058001708984375e+02 -1.5037899780273438e+02 3.6770103454589844e+01 -3.5058001708984375e+02 -1.5163500976562500e+02 4.0264301300048828e+01 -3.5058001708984375e+02 -1.4106700134277344e+02 4.2894401550292969e+01 -3.5058001708984375e+02 -1.4187001037597656e+02 4.6399898529052734e+01 -3.5058001708984375e+02 -1.3059500122070312e+02 4.6706100463867188e+01 -3.5058001708984375e+02 -1.3098500061035156e+02 5.0208698272705078e+01 -3.5058001708984375e+02 -1.1952500152587891e+02 4.8000000000000000e+01 -3.5058001708984375e+02 -1.1952500152587891e+02 5.1500000000000000e+01 -3.5058001708984375e+02 -1.0845500183105469e+02 4.6706100463867188e+01 -3.5058001708984375e+02 -1.0806500244140625e+02 5.0208698272705078e+01 -3.5058001708984375e+02 -9.7982696533203125e+01 4.2894401550292969e+01 -3.5058001708984375e+02 -9.7180000305175781e+01 4.6399898529052734e+01 -3.5058001708984375e+02 -8.8671203613281250e+01 3.6770103454589844e+01 -3.5058001708984375e+02 -8.7415298461914062e+01 4.0264301300048828e+01 -3.5058001708984375e+02 -8.1023094177246094e+01 2.8663599014282227e+01 -3.5058001708984375e+02 -7.9260696411132812e+01 3.2109699249267578e+01 -3.5058001708984375e+02 -7.5450706481933594e+01 1.9011798858642578e+01 -3.5058001708984375e+02 -7.3125099182128906e+01 2.2345001220703125e+01 -3.5058001708984375e+02 -7.2254203796386719e+01 8.3351097106933594e+00 -3.5058001708984375e+02 -6.9316299438476562e+01 1.1459800720214844e+01 -3.5058001708984375e+02 -7.1606193542480469e+01 -2.7909300327301025e+00 -3.5058001708984375e+02 -6.8025001525878906e+01 0.0000000000000000e+00 -3.5058001708984375e+02 -7.3541496276855469e+01 -1.3766500473022461e+01 -3.5058001708984375e+02 -6.9316299438476562e+01 -1.1459800720214844e+01 -3.5058001708984375e+02 -7.7955795288085938e+01 -2.4000000000000000e+01 -3.5058001708984375e+02 -7.3125099182128906e+01 -2.2345001220703125e+01 -3.5058001708984375e+02 -8.4611099243164062e+01 -3.2939502716064453e+01 -3.5058001708984375e+02 -7.9260696411132812e+01 -3.2109699249267578e+01 -3.5058001708984375e+02 -9.3148597717285156e+01 -4.0103397369384766e+01 -3.5058001708984375e+02 -8.7415298461914062e+01 -4.0264301300048828e+01 -3.5058001708984375e+02 -1.0310799407958984e+02 -4.5105201721191406e+01 -3.5058001708984375e+02 -9.7180000305175781e+01 -4.6399898529052734e+01 -3.5058001708984375e+02 -1.1395300292968750e+02 -4.7675399780273438e+01 -3.5058001708984375e+02 -1.0806500244140625e+02 -5.0208698272705078e+01 -3.5058001708984375e+02 -1.1952500152587891e+02 -5.1500000000000000e+01 -3.5058001708984375e+02 -5.9687999725341797e+01 0.0000000000000000e+00 -2.8236300659179688e+02 -6.0024997711181641e+01 0.0000000000000000e+00 -2.8857998657226562e+02 -5.7015098571777344e+01 0.0000000000000000e+00 -2.7022000122070312e+02 -5.1794300079345703e+01 0.0000000000000000e+00 -2.5893597412109375e+02 -4.4269798278808594e+01 0.0000000000000000e+00 -2.4903700256347656e+02 -3.4793296813964844e+01 0.0000000000000000e+00 -2.4098800659179688e+02 -2.3808000564575195e+01 0.0000000000000000e+00 -2.3516400146484375e+02 -1.1827499389648438e+01 0.0000000000000000e+00 -2.3183799743652344e+02 5.8799999952316284e-01 0.0000000000000000e+00 -2.3116398620605469e+02 1.2857899665832520e+01 0.0000000000000000e+00 -2.3317599487304688e+02 2.4408500671386719e+01 0.0000000000000000e+00 -2.3777799987792969e+02 3.4699699401855469e+01 0.0000000000000000e+00 -2.4475599670410156e+02 4.3250301361083984e+01 0.0000000000000000e+00 -2.5378298950195312e+02 4.9660602569580078e+01 0.0000000000000000e+00 -2.6443600463867188e+02 5.3630699157714844e+01 0.0000000000000000e+00 -2.7621902465820312e+02 5.4974998474121094e+01 0.0000000000000000e+00 -2.8857998657226562e+02 5.3630699157714844e+01 0.0000000000000000e+00 -3.0094097900390625e+02 4.9660602569580078e+01 0.0000000000000000e+00 -3.1272399902343750e+02 4.3250301361083984e+01 0.0000000000000000e+00 -3.2337799072265625e+02 3.4699699401855469e+01 0.0000000000000000e+00 -3.3240399169921875e+02 2.4408500671386719e+01 0.0000000000000000e+00 -3.3938198852539062e+02 1.2857899665832520e+01 0.0000000000000000e+00 -3.4398400878906250e+02 5.8799999952316284e-01 0.0000000000000000e+00 -3.4599600219726562e+02 -1.1827499389648438e+01 0.0000000000000000e+00 -3.4532299804687500e+02 -2.3808000564575195e+01 0.0000000000000000e+00 -3.4199600219726562e+02 -3.4793296813964844e+01 0.0000000000000000e+00 -3.3617202758789062e+02 -4.4269798278808594e+01 0.0000000000000000e+00 -3.2812301635742188e+02 -5.1794300079345703e+01 0.0000000000000000e+00 -3.1822399902343750e+02 -5.7015098571777344e+01 0.0000000000000000e+00 -3.0694000244140625e+02 -5.9687999725341797e+01 0.0000000000000000e+00 -2.9479699707031250e+02 -1.8795799255371094e+01 -1.3483500480651855e+01 -2.3342999267578125e+02 -1.9295499801635742e+01 -1.2984299659729004e+01 -2.3357998657226562e+02 -1.8744501113891602e+01 -1.4205599784851074e+01 -2.3341499328613281e+02 -1.9295499801635742e+01 -3.4017398834228516e+01 -2.3357998657226562e+02 -1.8191799163818359e+01 -1.5426799774169922e+01 -2.3325500488281250e+02 -1.8186601638793945e+01 -1.5133400917053223e+01 -2.3325399780273438e+02 -1.8353101730346680e+01 -1.4251899719238281e+01 -2.3330099487304688e+02 -4.9682502746582031e+01 -3.4017398834228516e+01 -2.3357998657226562e+02 -4.9818298339843750e+01 -3.4011901855468750e+01 -2.3357998657226562e+02 -4.9746498107910156e+01 -2.5173099517822266e+01 -2.3342601013183594e+02 -5.0837402343750000e+01 -3.3616901397705078e+01 -2.3357998657226562e+02 -5.2484699249267578e+01 -2.5175100326538086e+01 -2.3346499633789062e+02 -5.2987800598144531e+01 -3.0765998840332031e+01 -2.3357998657226562e+02 -5.5156398773193359e+01 -2.5176898956298828e+01 -2.3357998657226562e+02 -5.3693397521972656e+01 -2.3792798995971680e+01 -2.3357998657226562e+02 -5.2481899261474609e+01 -2.3625699996948242e+01 -2.3357998657226562e+02 -4.9746498107910156e+01 -2.3248199462890625e+01 -2.3357998657226562e+02 -5.5169502258300781e+01 -2.5128200531005859e+01 -2.3357998657226562e+02 -5.5116897583007812e+01 -2.4724500656127930e+01 -2.3357998657226562e+02 -5.5178600311279297e+01 -2.4921199798583984e+01 -2.3357998657226562e+02 -4.9658100128173828e+01 -2.5173099517822266e+01 -2.3342601013183594e+02 -4.9658100128173828e+01 -2.3248199462890625e+01 -2.3357998657226562e+02 -2.1620100021362305e+01 -1.5566800117492676e+01 -2.3334500122070312e+02 -2.6651699066162109e+01 -1.7706998825073242e+01 -2.3342700195312500e+02 -2.2207799911499023e+01 -1.4434799194335938e+01 -2.3357998657226562e+02 -2.6997100830078125e+01 -1.6955499649047852e+01 -2.3357998657226562e+02 -3.1523298263549805e+01 -1.9475898742675781e+01 -2.3350900268554688e+02 -3.5978897094726562e+01 -2.0748001098632812e+01 -2.3357998657226562e+02 -3.5051700592041016e+01 -2.0464698791503906e+01 -2.3357998657226562e+02 -3.3485599517822266e+01 -1.9880498886108398e+01 -2.3357998657226562e+02 -3.1675300598144531e+01 -1.9086500167846680e+01 -2.3357998657226562e+02 -2.7897199630737305e+01 -1.7429300308227539e+01 -2.3357998657226562e+02 -3.0837598800659180e+01 -2.1244199752807617e+01 -2.3335699462890625e+02 -3.5593700408935547e+01 -2.2899101257324219e+01 -2.3338600158691406e+02 -4.0264400482177734e+01 -2.4120500564575195e+01 -2.3340701293945312e+02 -4.0016597747802734e+01 -2.1981599807739258e+01 -2.3357998657226562e+02 -3.6227600097656250e+01 -2.0823900222778320e+01 -2.3357998657226562e+02 -4.5094200134277344e+01 -2.2893499374389648e+01 -2.3357998657226562e+02 -4.2138198852539062e+01 -2.2462499618530273e+01 -2.3357998657226562e+02 -4.0691699981689453e+01 -2.2134700775146484e+01 -2.3357998657226562e+02 -4.4860900878906250e+01 -2.4887399673461914e+01 -2.3342100524902344e+02 -4.5896297454833984e+01 -2.4995698928833008e+01 -2.3342298889160156e+02 -4.6078498840332031e+01 -2.3037099838256836e+01 -2.3357998657226562e+02 -4.6587398529052734e+01 -2.3111301422119141e+01 -2.3357998657226562e+02 -2.5975900650024414e+01 -1.9173700332641602e+01 -2.3332099914550781e+02 -2.1014900207519531e+01 -1.6729600906372070e+01 -2.3327799987792969e+02 -2.0538299560546875e+01 -1.3603300094604492e+01 -2.3357998657226562e+02 -5.4866397857666016e+01 -2.4408201217651367e+01 -2.3357998657226562e+02 -1.9465599060058594e+01 -1.5980200767517090e+01 -2.3326499938964844e+02 -7.2578201293945312e+01 -9.9999904632568359e+00 -3.3846600341796875e+02 -7.2578201293945312e+01 -9.9999904632568359e+00 -3.0870898437500000e+02 -7.2314704895019531e+01 -9.9999904632568359e+00 -3.3815802001953125e+02 -7.1855796813964844e+01 -9.9999904632568359e+00 -3.3726000976562500e+02 -7.1815200805664062e+01 -9.9999904632568359e+00 -3.3712701416015625e+02 -7.1485694885253906e+01 -9.9999904632568359e+00 -3.3592999267578125e+02 -7.1439994812011719e+01 -9.9999904632568359e+00 -3.3554901123046875e+02 -7.1826797485351562e+01 -9.9999904632568359e+00 -3.3717001342773438e+02 -7.1839195251464844e+01 -9.9999904632568359e+00 -3.3720700073242188e+02 -7.1189498901367188e+01 -9.9999904632568359e+00 -3.3346200561523438e+02 -7.1189498901367188e+01 -9.9999904632568359e+00 -3.1416897583007812e+02 -7.1370399475097656e+01 -9.9999904632568359e+00 -3.1247500610351562e+02 -7.2231002807617188e+01 -9.9999904632568359e+00 -3.0905599975585938e+02 -7.2201499938964844e+01 -9.9999904632568359e+00 -3.0912899780273438e+02 -7.2091201782226562e+01 -9.9999904632568359e+00 -3.0948699951171875e+02 -7.1695999145507812e+01 -9.9999904632568359e+00 -3.1076898193359375e+02 -7.1476493835449219e+01 -9.9999904632568359e+00 -3.1148098754882812e+02 -7.2068298339843750e+01 -7.9740900993347168e+00 -3.3640701293945312e+02 -7.2147399902343750e+01 -7.7045001983642578e+00 -3.3642001342773438e+02 -7.2175598144531250e+01 -8.0366706848144531e+00 -3.3725000000000000e+02 -7.2161697387695312e+01 -7.7918200492858887e+00 -3.3688900756835938e+02 -7.2204795837402344e+01 -8.0491905212402344e+00 -3.3735098266601562e+02 -7.2087104797363281e+01 -8.7941904067993164e+00 -3.3752200317382812e+02 -7.2175598144531250e+01 -9.5675592422485352e+00 -3.3774200439453125e+02 -7.2499702453613281e+01 -9.6238203048706055e+00 -3.3836199951171875e+02 -7.2352798461914062e+01 -8.8626699447631836e+00 -3.3799298095703125e+02 -7.2294898986816406e+01 -8.5627403259277344e+00 -3.3784802246093750e+02 -7.1847602844238281e+01 -9.5105199813842773e+00 -3.3711499023437500e+02 -7.1887802124023438e+01 -8.8908700942993164e+00 -3.3683700561523438e+02 -7.1898300170898438e+01 -8.7284402847290039e+00 -3.3676400756835938e+02 -7.2171302795410156e+01 -7.8500499725341797e+00 -3.1337899780273438e+02 -7.2196197509765625e+01 -7.9954304695129395e+00 -3.1258801269531250e+02 -7.2147399902343750e+01 -7.7045001983642578e+00 -3.1416897583007812e+02 -7.2153396606445312e+01 -7.7414498329162598e+00 -3.1355300903320312e+02 -7.2552703857421875e+01 -9.8778600692749023e+00 -3.3843200683593750e+02 -7.2229995727539062e+01 -8.1965894699096680e+00 -3.1182400512695312e+02 -7.2469200134277344e+01 -9.4736795425415039e+00 -3.0921499633789062e+02 -7.2432998657226562e+01 -9.2803201675415039e+00 -3.0961001586914062e+02 -7.2312301635742188e+01 -8.6358194351196289e+00 -3.1092700195312500e+02 -7.1847496032714844e+01 -9.7556705474853516e+00 -3.3718801879882812e+02 -7.1847496032714844e+01 -9.7832098007202148e+00 -3.3719598388671875e+02 -7.1839195251464844e+01 -9.7668199539184570e+00 -3.3716400146484375e+02 -7.1735397338867188e+01 -9.2643499374389648e+00 -3.3640701293945312e+02 -7.1881195068359375e+01 -8.5232200622558594e+00 -3.3559799194335938e+02 -7.2343605041503906e+01 -9.7604398727416992e+00 -3.0913098144531250e+02 2.1802999973297119e+00 -6.3888198852539062e+01 -3.4686599731445312e+02 -2.5249898433685303e+00 -6.2500000000000000e+01 -3.4707998657226562e+02 6.8589997291564941e+00 -6.2500000000000000e+01 -3.4632199096679688e+02 1.6000099182128906e+01 -6.2500000000000000e+01 -3.4406900024414062e+02 1.1469200134277344e+01 -6.3888198852539062e+01 -3.4535699462890625e+02 6.8552098274230957e+00 -6.3888198852539062e+01 -3.4629898071289062e+02 2.4661300659179688e+01 -6.2500000000000000e+01 -3.4037899780273438e+02 2.0395500183105469e+01 -6.3888198852539062e+01 -3.4237701416015625e+02 1.5992399215698242e+01 -6.3888198852539062e+01 -3.4404598999023438e+02 3.2618400573730469e+01 -6.2500000000000000e+01 -3.3534698486328125e+02 2.8728300094604492e+01 -6.3888198852539062e+01 -3.3800302124023438e+02 2.4649999618530273e+01 -6.3888198852539062e+01 -3.4035800170898438e+02 3.9665302276611328e+01 -6.2500000000000000e+01 -3.2910400390625000e+02 3.6251602172851562e+01 -6.3888198852539062e+01 -3.3234997558593750e+02 3.2603801727294922e+01 -6.3888198852539062e+01 -3.3532800292968750e+02 4.5619499206542969e+01 -6.2500000000000000e+01 -3.2181201171875000e+02 4.2770603179931641e+01 -6.3888198852539062e+01 -3.2556301879882812e+02 3.9647800445556641e+01 -6.3888198852539062e+01 -3.2908801269531250e+02 5.0326801300048828e+01 -6.2500000000000000e+01 -3.1365902709960938e+02 4.8116500854492188e+01 -6.3888198852539062e+01 -3.1781799316406250e+02 4.5599597930908203e+01 -6.3888198852539062e+01 -3.2179800415039062e+02 5.3665298461914062e+01 -6.2500000000000000e+01 -3.0485598754882812e+02 5.2150802612304688e+01 -6.3888198852539062e+01 -3.0931600952148438e+02 5.0304901123046875e+01 -6.3888198852539062e+01 -3.1364797973632812e+02 5.5548500061035156e+01 -6.2500000000000000e+01 -2.9563098144531250e+02 5.4768997192382812e+01 -6.3888198852539062e+01 -3.0027700805664062e+02 5.3642002105712891e+01 -6.3888198852539062e+01 -3.0484899902343750e+02 5.5927501678466797e+01 -6.2500000000000000e+01 -2.8622399902343750e+02 5.5903301239013672e+01 -6.3888198852539062e+01 -2.9093499755859375e+02 5.5524402618408203e+01 -6.3888198852539062e+01 -2.9562802124023438e+02 5.4792697906494141e+01 -6.2500000000000000e+01 -2.7687899780273438e+02 5.5524402618408203e+01 -6.3888198852539062e+01 -2.8153198242187500e+02 5.5903301239013672e+01 -6.3888198852539062e+01 -2.8622500610351562e+02 5.2173397064208984e+01 -6.2500000000000000e+01 -2.6783599853515625e+02 5.3642002105712891e+01 -6.3888198852539062e+01 -2.7231100463867188e+02 5.4768997192382812e+01 -6.3888198852539062e+01 -2.7688299560546875e+02 4.8137500762939453e+01 -6.2500000000000000e+01 -2.5933001708984375e+02 5.0304901123046875e+01 -6.3888198852539062e+01 -2.6351199340820312e+02 5.2150802612304688e+01 -6.3888198852539062e+01 -2.6784399414062500e+02 4.2789398193359375e+01 -6.2500000000000000e+01 -2.5158200073242188e+02 4.5599597930908203e+01 -6.3888198852539062e+01 -2.5536199951171875e+02 4.8116500854492188e+01 -6.3888198852539062e+01 -2.5934201049804688e+02 3.6267700195312500e+01 -6.2500000000000000e+01 -2.4479199218750000e+02 3.9647800445556641e+01 -6.3888198852539062e+01 -2.4807199096679688e+02 4.2770603179931641e+01 -6.3888198852539062e+01 -2.5159698486328125e+02 2.8741199493408203e+01 -6.2500000000000000e+01 -2.3913600158691406e+02 3.2603801727294922e+01 -6.3888198852539062e+01 -2.4183200073242188e+02 3.6251602172851562e+01 -6.3888198852539062e+01 -2.4480999755859375e+02 2.0405000686645508e+01 -6.2500000000000000e+01 -2.3476100158691406e+02 2.4649999618530273e+01 -6.3888198852539062e+01 -2.3680200195312500e+02 2.8728300094604492e+01 -6.3888198852539062e+01 -2.3915701293945312e+02 1.1474900245666504e+01 -6.2500000000000000e+01 -2.3177999877929688e+02 1.5992399215698242e+01 -6.3888198852539062e+01 -2.3311399841308594e+02 2.0395500183105469e+01 -6.3888198852539062e+01 -2.3478298950195312e+02 2.1822998523712158e+00 -6.2500000000000000e+01 -2.3027000427246094e+02 6.8552098274230957e+00 -6.3888198852539062e+01 -2.3086099243164062e+02 1.1469200134277344e+01 -6.3888198852539062e+01 -2.3180299377441406e+02 -7.2322998046875000e+00 -6.2500000000000000e+01 -2.3027000427246094e+02 -2.5249898433685303e+00 -6.3888198852539062e+01 -2.3010400390625000e+02 2.1802999973297119e+00 -6.3888198852539062e+01 -2.3029400634765625e+02 -1.6524999618530273e+01 -6.2500000000000000e+01 -2.3177999877929688e+02 -1.1905200004577637e+01 -6.3888198852539062e+01 -2.3086099243164062e+02 -7.2304000854492188e+00 -6.3888198852539062e+01 -2.3029400634765625e+02 -2.5454999923706055e+01 -6.2500000000000000e+01 -2.3476100158691406e+02 -2.1042499542236328e+01 -6.3888198852539062e+01 -2.3311399841308594e+02 -1.6519199371337891e+01 -6.3888198852539062e+01 -2.3180299377441406e+02 -3.3791301727294922e+01 -6.2500000000000000e+01 -2.3913600158691406e+02 -2.9700099945068359e+01 -6.3888198852539062e+01 -2.3680200195312500e+02 -2.5445598602294922e+01 -6.3888198852539062e+01 -2.3478298950195312e+02 -4.1317703247070312e+01 -6.2500000000000000e+01 -2.4479199218750000e+02 -3.7653900146484375e+01 -6.3888198852539062e+01 -2.4183200073242188e+02 -3.3778297424316406e+01 -6.3888198852539062e+01 -2.3915701293945312e+02 -4.7839401245117188e+01 -6.2500000000000000e+01 -2.5158200073242188e+02 -4.4697898864746094e+01 -6.3888198852539062e+01 -2.4807199096679688e+02 -4.1301700592041016e+01 -6.3888198852539062e+01 -2.4480999755859375e+02 -5.3187500000000000e+01 -6.2500000000000000e+01 -2.5933001708984375e+02 -5.0649597167968750e+01 -6.3888198852539062e+01 -2.5536199951171875e+02 -4.7820602416992188e+01 -6.3888198852539062e+01 -2.5159698486328125e+02 -5.7223499298095703e+01 -6.2500000000000000e+01 -2.6783599853515625e+02 -5.5354999542236328e+01 -6.3888198852539062e+01 -2.6351199340820312e+02 -5.3166500091552734e+01 -6.3888198852539062e+01 -2.5934201049804688e+02 -5.9842697143554688e+01 -6.2500000000000000e+01 -2.7687899780273438e+02 -5.8692100524902344e+01 -6.3888198852539062e+01 -2.7231100463867188e+02 -5.7200801849365234e+01 -6.3888198852539062e+01 -2.6784399414062500e+02 -6.0977600097656250e+01 -6.2500000000000000e+01 -2.8622399902343750e+02 -6.0574501037597656e+01 -6.3888198852539062e+01 -2.8153198242187500e+02 -5.9819000244140625e+01 -6.3888198852539062e+01 -2.7688299560546875e+02 -6.0598499298095703e+01 -6.2500000000000000e+01 -2.9563098144531250e+02 -6.0953399658203125e+01 -6.3888198852539062e+01 -2.9093499755859375e+02 -6.0953399658203125e+01 -6.3888198852539062e+01 -2.8622500610351562e+02 -5.8715297698974609e+01 -6.2500000000000000e+01 -3.0485598754882812e+02 -5.9819000244140625e+01 -6.3888198852539062e+01 -3.0027700805664062e+02 -6.0574501037597656e+01 -6.3888198852539062e+01 -2.9562802124023438e+02 -5.5376899719238281e+01 -6.2500000000000000e+01 -3.1365902709960938e+02 -5.7200801849365234e+01 -6.3888198852539062e+01 -3.0931600952148438e+02 -5.8692100524902344e+01 -6.3888198852539062e+01 -3.0484899902343750e+02 -5.0669597625732422e+01 -6.2500000000000000e+01 -3.2181201171875000e+02 -5.3166500091552734e+01 -6.3888198852539062e+01 -3.1781799316406250e+02 -5.5354999542236328e+01 -6.3888198852539062e+01 -3.1364797973632812e+02 -4.4715400695800781e+01 -6.2500000000000000e+01 -3.2910400390625000e+02 -4.7820602416992188e+01 -6.3888198852539062e+01 -3.2556301879882812e+02 -5.0649597167968750e+01 -6.3888198852539062e+01 -3.2179800415039062e+02 -3.7668498992919922e+01 -6.2500000000000000e+01 -3.3534698486328125e+02 -4.1301700592041016e+01 -6.3888198852539062e+01 -3.3234997558593750e+02 -4.4697898864746094e+01 -6.3888198852539062e+01 -3.2908801269531250e+02 -2.9711399078369141e+01 -6.2500000000000000e+01 -3.4037899780273438e+02 -3.3778297424316406e+01 -6.3888198852539062e+01 -3.3800302124023438e+02 -3.7653900146484375e+01 -6.3888198852539062e+01 -3.3532800292968750e+02 -2.1050098419189453e+01 -6.2500000000000000e+01 -3.4406900024414062e+02 -2.5445598602294922e+01 -6.3888198852539062e+01 -3.4237701416015625e+02 -2.9700099945068359e+01 -6.3888198852539062e+01 -3.4035800170898438e+02 -1.1909100532531738e+01 -6.2500000000000000e+01 -3.4632199096679688e+02 -1.6519199371337891e+01 -6.3888198852539062e+01 -3.4535699462890625e+02 -2.1042499542236328e+01 -6.3888198852539062e+01 -3.4404598999023438e+02 -2.5249898433685303e+00 -6.3888198852539062e+01 -3.4705599975585938e+02 -7.2304000854492188e+00 -6.3888198852539062e+01 -3.4686599731445312e+02 -1.1905200004577637e+01 -6.3888198852539062e+01 -3.4629898071289062e+02 2.3286100387573242e+01 -7.4500000000000000e+01 -2.7746002197265625e+02 2.3156799316406250e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 4.8754798889160156e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 -2.0475001335144043e+00 -7.4500000000000000e+01 -2.7950799560546875e+02 -1.7661999464035034e+00 -7.4500000000000000e+01 -2.7963900756835938e+02 1.8644500732421875e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 -1.5884000062942505e+00 -7.4500000000000000e+01 -2.7989398193359375e+02 -9.9598899483680725e-02 -7.4500000000000000e+01 -2.8340399169921875e+02 -1.5615000724792480e+00 -7.4500000000000000e+01 -2.8020300292968750e+02 -2.0279701054096222e-01 -7.4500000000000000e+01 -2.8339498901367188e+02 -2.1254999637603760e+00 -7.4500000000000000e+01 -2.8339498901367188e+02 1.9458099365234375e+01 -7.4500000000000000e+01 -2.9933200073242188e+02 1.9238698959350586e+01 -7.4500000000000000e+01 -2.9955102539062500e+02 2.4252399444580078e+01 -7.4500000000000000e+01 -2.9924200439453125e+02 -5.1763000488281250e+00 -7.4500000000000000e+01 -2.9985400390625000e+02 -5.8145003318786621e+00 -7.4500000000000000e+01 -2.9973699951171875e+02 -1.0099100112915039e+01 -7.4500000000000000e+01 -3.4037500000000000e+02 -6.4408998489379883e+00 -7.4500000000000000e+01 -2.9951998901367188e+02 -7.7599997520446777e+00 -7.4500000000000000e+01 -2.9850198364257812e+02 -7.3954997062683105e+00 -7.4500000000000000e+01 -2.9889898681640625e+02 -9.1709995269775391e+00 -7.4500000000000000e+01 -2.8674798583984375e+02 -9.3494005203247070e+00 -7.4500000000000000e+01 -2.8649398803710938e+02 -9.3769998550415039e+00 -7.4500000000000000e+01 -2.8618499755859375e+02 -1.0099100112915039e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 -8.9767999649047852e+00 -7.4500000000000000e+01 -2.8389199829101562e+02 -8.9053993225097656e+00 -7.4500000000000000e+01 -2.8369500732421875e+02 -8.6859998703002930e+00 -7.4500000000000000e+01 -2.8347598266601562e+02 -8.3860998153686523e+00 -7.4500000000000000e+01 -2.8339498901367188e+02 -5.9898996353149414e+00 -7.4500000000000000e+01 -2.7979901123046875e+02 -5.7704997062683105e+00 -7.4500000000000000e+01 -2.7957901000976562e+02 -5.4706001281738281e+00 -7.4500000000000000e+01 -2.7949899291992188e+02 -2.1520001888275146e+00 -7.4500000000000000e+01 -2.7949899291992188e+02 1.8938800811767578e+01 -7.4500000000000000e+01 -2.9963101196289062e+02 1.5632100105285645e+01 -7.4500000000000000e+01 -2.9963101196289062e+02 6.0963001251220703e+00 -7.4500000000000000e+01 -3.4024499511718750e+02 1.5529699325561523e+01 -7.4500000000000000e+01 -2.9962301635742188e+02 1.5247900009155273e+01 -7.4500000000000000e+01 -2.9949200439453125e+02 -6.9821996688842773e+00 -7.4500000000000000e+01 -2.9922299194335938e+02 -8.5826005935668945e+00 -7.4500000000000000e+01 -2.9503500366210938e+02 -7.2558002471923828e+00 -7.4500000000000000e+01 -2.8688699340820312e+02 -8.7861995697021484e+00 -7.4500000000000000e+01 -2.8688699340820312e+02 1.9529300689697266e+01 -7.4500000000000000e+01 -2.9913601684570312e+02 5.8209902048110962e-01 -7.4500000000000000e+01 -2.9480297851562500e+02 5.8200299739837646e-01 -7.4500000000000000e+01 -2.9480297851562500e+02 -1.8215999603271484e+00 -7.4500000000000000e+01 -2.9625100708007812e+02 -8.0886001586914062e+00 -7.4500000000000000e+01 -2.9799398803710938e+02 -8.3106994628906250e+00 -7.4500000000000000e+01 -2.9749899291992188e+02 -8.4690999984741211e+00 -7.4500000000000000e+01 -2.9697000122070312e+02 -6.6491999626159668e+00 -7.4500000000000000e+01 -2.8339498901367188e+02 -6.0615000724792480e+00 -7.4500000000000000e+01 -2.7999697875976562e+02 4.7016201019287109e+01 -7.4500000000000000e+01 -3.0558801269531250e+02 2.8711700439453125e+01 -7.4500000000000000e+01 -2.9913101196289062e+02 4.5442501068115234e+01 -7.4500000000000000e+01 -3.0962100219726562e+02 2.8639499664306641e+01 -7.4500000000000000e+01 -2.9933200073242188e+02 4.3541198730468750e+01 -7.4500000000000000e+01 -3.1351000976562500e+02 2.8420099258422852e+01 -7.4500000000000000e+01 -2.9955102539062500e+02 4.1325199127197266e+01 -7.4500000000000000e+01 -3.1722900390625000e+02 2.8120199203491211e+01 -7.4500000000000000e+01 -2.9963101196289062e+02 3.6011699676513672e+01 -7.4500000000000000e+01 -3.2405599975585938e+02 3.8809600830078125e+01 -7.4500000000000000e+01 -3.2075198364257812e+02 2.4432399749755859e+01 -7.4500000000000000e+01 -2.9949398803710938e+02 1.0333299636840820e+01 -7.4500000000000000e+01 -3.3935699462890625e+02 2.4714799880981445e+01 -7.4500000000000000e+01 -2.9962301635742188e+02 1.3763400077819824e+01 -7.4500000000000000e+01 -2.9423498535156250e+02 1.3769800186157227e+01 -7.4500000000000000e+01 -2.9443698120117188e+02 1.5069199562072754e+01 -7.4500000000000000e+01 -2.9923901367187500e+02 1.3535999298095703e+01 -7.4500000000000000e+01 -2.9546801757812500e+02 1.3098299980163574e+01 -7.4500000000000000e+01 -2.9647100830078125e+02 -1.9592999219894409e+00 -7.4500000000000000e+01 -2.9610400390625000e+02 4.1949802637100220e-01 -7.4500000000000000e+01 -2.9358499145507812e+02 -2.1377999782562256e+00 -7.4500000000000000e+01 -2.9601098632812500e+02 -8.5745000839233398e+00 -7.4500000000000000e+01 -2.9635400390625000e+02 -8.6108999252319336e+00 -7.4500000000000000e+01 -2.9572998046875000e+02 -8.8894996643066406e+00 -7.4500000000000000e+01 -2.8687799072265625e+02 -8.5885000228881836e+00 -7.4500000000000000e+01 -2.9510598754882812e+02 2.2404798507690430e+01 -7.4500000000000000e+01 -3.3464599609375000e+02 2.4814199447631836e+01 -7.4500000000000000e+01 -2.9963101196289062e+02 1.8515499114990234e+01 -7.4500000000000000e+01 -3.3654800415039062e+02 1.4482500076293945e+01 -7.4500000000000000e+01 -3.3812100219726562e+02 1.2484600067138672e+01 -7.4500000000000000e+01 -2.9738198852539062e+02 2.4770601272583008e+01 -7.4500000000000000e+01 -2.8319100952148438e+02 2.5611598968505859e+01 -7.4500000000000000e+01 -2.8310498046875000e+02 2.9190299987792969e+01 -7.4500000000000000e+01 -2.8451699829101562e+02 2.9612899780273438e+01 -7.4500000000000000e+01 -2.8510998535156250e+02 2.6123701095581055e+01 -7.4500000000000000e+01 -3.3242999267578125e+02 2.9646999359130859e+01 -7.4500000000000000e+01 -3.2991497802734375e+02 3.2950496673583984e+01 -7.4500000000000000e+01 -3.2711700439453125e+02 1.2017700195312500e+01 -7.4500000000000000e+01 -2.9790197753906250e+02 1.1490200042724609e+01 -7.4500000000000000e+01 -2.9837301635742188e+02 1.0452099800109863e+01 -7.4500000000000000e+01 -2.9905899047851562e+02 9.8742008209228516e+00 -7.4500000000000000e+01 -2.9933599853515625e+02 6.6927099227905273e+00 -7.4500000000000000e+01 -2.9993899536132812e+02 7.3584003448486328e+00 -7.4500000000000000e+01 -2.9992602539062500e+02 8.0160102844238281e+00 -7.4500000000000000e+01 -2.9985800170898438e+02 2.4222898483276367e+01 -7.4500000000000000e+01 -2.9893301391601562e+02 2.5827299118041992e+01 -7.4500000000000000e+01 -2.8937597656250000e+02 2.1453100204467773e+01 -7.4500000000000000e+01 -2.8824499511718750e+02 1.4765299797058105e+01 -7.4500000000000000e+01 -2.8907800292968750e+02 1.4751099586486816e+01 -7.4500000000000000e+01 -2.8923199462890625e+02 5.0019998550415039e+00 -7.4500000000000000e+01 -2.9463800048828125e+02 5.0019998550415039e+00 -7.4500000000000000e+01 -2.9463897705078125e+02 1.0677599906921387e+01 -7.4500000000000000e+01 -2.8950799560546875e+02 1.3559999465942383e+01 -7.4500000000000000e+01 -2.9389398193359375e+02 1.3690699577331543e+01 -7.4500000000000000e+01 -2.9404800415039062e+02 1.5041299819946289e+01 -7.4500000000000000e+01 -2.9892999267578125e+02 4.5485000610351562e+00 -7.4500000000000000e+01 -2.9958901977539062e+02 3.6750998497009277e+00 -7.4500000000000000e+01 -2.9921298217773438e+02 -1.9694000482559204e+00 -7.4500000000000000e+01 -2.9922299194335938e+02 6.6919898986816406e+00 -7.4500000000000000e+01 -2.9993899536132812e+02 -2.0568001270294189e+00 -7.4500000000000000e+01 -2.9940399169921875e+02 -2.1993000507354736e+00 -7.4500000000000000e+01 -2.9954699707031250e+02 -4.5409998893737793e+00 -7.4500000000000000e+01 -2.9989498901367188e+02 -6.8505001068115234e+00 -7.4500000000000000e+01 -3.4077999877929688e+02 -3.9201998710632324e+00 -7.4500000000000000e+01 -2.9988598632812500e+02 2.1864099502563477e+01 -7.4500000000000000e+01 -2.8474798583984375e+02 2.2441101074218750e+01 -7.4500000000000000e+01 -2.8426000976562500e+02 2.3380199432373047e+01 -7.4500000000000000e+01 -2.8366601562500000e+02 2.7009300231933594e+01 -7.4500000000000000e+01 -2.8323501586914062e+02 2.7600299835205078e+01 -7.4500000000000000e+01 -2.8340899658203125e+02 2.8158399581909180e+01 -7.4500000000000000e+01 -2.8367098999023438e+02 2.9612998962402344e+01 -7.4500000000000000e+01 -2.8510998535156250e+02 2.9892801284790039e+01 -7.4500000000000000e+01 -2.8567098999023438e+02 4.9139896392822266e+01 -7.4500000000000000e+01 -2.7995898437500000e+02 3.0102800369262695e+01 -7.4500000000000000e+01 -2.8626098632812500e+02 4.9675399780273438e+01 -7.4500000000000000e+01 -2.8425500488281250e+02 2.5837600708007812e+01 -7.4500000000000000e+01 -2.8929098510742188e+02 2.5863601684570312e+01 -7.4500000000000000e+01 -2.8898300170898438e+02 2.5870698928833008e+01 -7.4500000000000000e+01 -2.8867501831054688e+02 2.4856399536132812e+01 -7.4500000000000000e+01 -2.8700900268554688e+02 2.4571399688720703e+01 -7.4500000000000000e+01 -2.8694702148437500e+02 2.5745599746704102e+01 -7.4500000000000000e+01 -2.8784701538085938e+02 1.8200300633907318e-01 -7.4500000000000000e+01 -2.8353500366210938e+02 3.6030301451683044e-01 -7.4500000000000000e+01 -2.8378900146484375e+02 3.8790002465248108e-01 -7.4500000000000000e+01 -2.8409799194335938e+02 1.3385999679565430e+01 -7.4500000000000000e+01 -2.9379299926757812e+02 1.4674600601196289e+01 -7.4500000000000000e+01 -2.8941799926757812e+02 4.9910002946853638e-01 -7.4500000000000000e+01 -2.9133099365234375e+02 -3.0289500951766968e-01 -7.4500000000000000e+01 -2.8680700683593750e+02 4.5490300655364990e-01 -7.4500000000000000e+01 -2.9175698852539062e+02 3.9789900183677673e-01 -7.4500000000000000e+01 -2.9267401123046875e+02 -2.5251998901367188e+00 -7.4500000000000000e+01 -2.9600201416015625e+02 -2.3886001110076904e+00 -7.4500000000000000e+01 -2.9598599243164062e+02 -2.7346999645233154e+00 -7.4500000000000000e+01 -2.8688699340820312e+02 -2.3370001316070557e+00 -7.4500000000000000e+01 -2.9598300170898438e+02 -6.0279595851898193e-01 -7.4500000000000000e+01 -2.8688699340820312e+02 2.3954401016235352e+01 -7.4500000000000000e+01 -2.8341299438476562e+02 2.5845600128173828e+01 -7.4500000000000000e+01 -2.8310299682617188e+02 2.5968299865722656e+01 -7.4500000000000000e+01 -2.8310598754882812e+02 2.8158500671386719e+01 -7.4500000000000000e+01 -2.8367098999023438e+02 2.8683200836181641e+01 -7.4500000000000000e+01 -2.8402899169921875e+02 3.0288999557495117e+01 -7.4500000000000000e+01 -2.8713598632812500e+02 3.0353599548339844e+01 -7.4500000000000000e+01 -2.8774700927734375e+02 4.9854301452636719e+01 -7.4500000000000000e+01 -2.8857998657226562e+02 9.2692098617553711e+00 -7.4500000000000000e+01 -2.9956298828125000e+02 9.2690992355346680e+00 -7.4500000000000000e+01 -2.9956298828125000e+02 2.2133399963378906e+01 -7.4500000000000000e+01 -2.8759802246093750e+02 2.1662799835205078e+01 -7.4500000000000000e+01 -2.8801699829101562e+02 2.5855400085449219e+01 -7.4500000000000000e+01 -2.8836700439453125e+02 5.4485998153686523e+00 -7.4500000000000000e+01 -2.9981698608398438e+02 1.8004000186920166e+00 -7.4500000000000000e+01 -3.4077999877929688e+02 -2.3809001445770264e+00 -7.4500000000000000e+01 -2.9963400268554688e+02 -2.5249898433685303e+00 -7.4500000000000000e+01 -3.4095901489257812e+02 2.5637500762939453e+01 -7.4500000000000000e+01 -2.8760900878906250e+02 2.5483301162719727e+01 -7.4500000000000000e+01 -2.8739498901367188e+02 2.5319398880004883e+01 -7.4500000000000000e+01 -2.8724499511718750e+02 2.5814800262451172e+01 -7.4500000000000000e+01 -2.8809298706054688e+02 2.4197399139404297e+01 -7.4500000000000000e+01 -2.8691699218750000e+02 2.4195701599121094e+01 -7.4500000000000000e+01 -2.8691699218750000e+02 2.3622499465942383e+01 -7.4500000000000000e+01 -2.8694400024414062e+02 9.5483102798461914e+00 -7.4500000000000000e+01 -2.9406500244140625e+02 9.6810007095336914e+00 -7.4500000000000000e+01 -2.9391299438476562e+02 9.8564004898071289e+00 -7.4500000000000000e+01 -2.9381399536132812e+02 4.9138998985290527e+00 -7.4500000000000000e+01 -2.9238900756835938e+02 4.8871998786926270e+00 -7.4500000000000000e+01 -2.9280401611328125e+02 4.8683996200561523e+00 -7.4500000000000000e+01 -2.9322000122070312e+02 5.3380002975463867e+00 -7.4500000000000000e+01 -2.8976898193359375e+02 5.1921000480651855e+00 -7.4500000000000000e+01 -2.9036300659179688e+02 1.0519000053405762e+01 -7.4500000000000000e+01 -2.8914401245117188e+02 5.0750999450683594e+00 -7.4500000000000000e+01 -2.9096298217773438e+02 1.0567299842834473e+01 -7.4500000000000000e+01 -2.8933999633789062e+02 -2.6805999279022217e+00 -7.4500000000000000e+01 -2.9971200561523438e+02 -2.9904999732971191e+00 -7.4500000000000000e+01 -2.9977700805664062e+02 4.8251499176025391e+01 -7.4500000000000000e+01 -3.0143801879882812e+02 4.9139896392822266e+01 -7.4500000000000000e+01 -2.9720101928710938e+02 3.0326200485229492e+01 -7.4500000000000000e+01 -2.8947399902343750e+02 4.9675399780273438e+01 -7.4500000000000000e+01 -2.9290499877929688e+02 3.0364099502563477e+01 -7.4500000000000000e+01 -2.8897399902343750e+02 3.0377901077270508e+01 -7.4500000000000000e+01 -2.8835998535156250e+02 5.0135998725891113e+00 -7.4500000000000000e+01 -2.9137500000000000e+02 4.9700999259948730e+00 -7.4500000000000000e+01 -2.9178302001953125e+02 4.9700002670288086e+00 -7.4500000000000000e+01 -2.9178399658203125e+02 2.8415999412536621e+00 -7.4500000000000000e+01 -2.9866998291015625e+02 2.2003002166748047e+00 -7.4500000000000000e+01 -2.9808700561523438e+02 1.6444998979568481e+00 -7.4500000000000000e+01 -2.9739401245117188e+02 7.9850202798843384e-01 -7.4500000000000000e+01 -2.9564199829101562e+02 -1.7401999235153198e+00 -7.4500000000000000e+01 -2.9643499755859375e+02 1.1065000295639038e+00 -7.4500000000000000e+01 -2.9643899536132812e+02 -1.7244999408721924e+00 -7.4500000000000000e+01 -2.9663598632812500e+02 -1.9485000371932983e+00 -7.4500000000000000e+01 -2.9911102294921875e+02 -3.3038001060485840e+00 -7.4500000000000000e+01 -2.9982699584960938e+02 -3.3039999008178711e+00 -7.4500000000000000e+01 -2.9982699584960938e+02 2.5127099990844727e+01 -7.4500000000000000e+01 -2.8712002563476562e+02 2.3135499954223633e+01 -7.4500000000000000e+01 -2.8705099487304688e+02 2.2661098480224609e+01 -7.4500000000000000e+01 -2.8725201416015625e+02 1.0054699897766113e+01 -7.4500000000000000e+01 -2.9377899169921875e+02 1.1028699874877930e+01 -7.4500000000000000e+01 -2.8969299316406250e+02 1.0837400436401367e+01 -7.4500000000000000e+01 -2.8963101196289062e+02 4.8784999847412109e+00 -7.4500000000000000e+01 -2.9384802246093750e+02 4.9231996536254883e+00 -7.4500000000000000e+01 -2.9424398803710938e+02 6.2465996742248535e+00 -7.4500000000000000e+01 -2.8791201782226562e+02 5.9671998023986816e+00 -7.4500000000000000e+01 -2.8829800415039062e+02 1.0489000320434570e+01 -7.4500000000000000e+01 -2.8885800170898438e+02 5.6702098846435547e+00 -7.4500000000000000e+01 -2.8884698486328125e+02 5.4850001335144043e+00 -7.4500000000000000e+01 -2.8929901123046875e+02 -3.1196999549865723e+00 -7.4500000000000000e+01 -2.9600799560546875e+02 -3.0504000186920166e+00 -7.4500000000000000e+01 -2.9601400756835938e+02 -2.8752000331878662e+00 -7.4500000000000000e+01 -2.9602102661132812e+02 5.9671001434326172e+00 -7.4500000000000000e+01 -2.8829800415039062e+02 -2.6998999118804932e+00 -7.4500000000000000e+01 -2.9601699829101562e+02 3.0401000976562500e+00 -7.4500000000000000e+01 -2.8549298095703125e+02 3.9549000263214111e+00 -7.4500000000000000e+01 -2.8466000366210938e+02 6.6292996406555176e+00 -7.4500000000000000e+01 -2.8333700561523438e+02 7.7157001495361328e+00 -7.4500000000000000e+01 -2.8314501953125000e+02 8.8405008316040039e+00 -7.4500000000000000e+01 -2.8310299682617188e+02 1.2460000038146973e+01 -7.4500000000000000e+01 -2.8423498535156250e+02 1.3257299423217773e+01 -7.4500000000000000e+01 -2.8496200561523438e+02 1.3971500396728516e+01 -7.4500000000000000e+01 -2.8598400878906250e+02 1.4402299880981445e+01 -7.4500000000000000e+01 -2.8698501586914062e+02 5.2379002571105957e+00 -7.4500000000000000e+01 -2.9524499511718750e+02 5.5828995704650879e+00 -7.4500000000000000e+01 -2.9570700073242188e+02 6.8171000480651855e+00 -7.4500000000000000e+01 -2.9613998413085938e+02 5.5831098556518555e+00 -7.4500000000000000e+01 -2.9570800781250000e+02 6.2548999786376953e+00 -7.4500000000000000e+01 -2.9607299804687500e+02 5.8145999908447266e+00 -7.4500000000000000e+01 -2.9589300537109375e+02 6.8190999031066895e+00 -7.4500000000000000e+01 -2.9613998413085938e+02 7.3436999320983887e+00 -7.4500000000000000e+01 -2.9611300659179688e+02 8.1900997161865234e+00 -7.4500000000000000e+01 -2.9584500122070312e+02 8.6087999343872070e+00 -7.4500000000000000e+01 -2.9556201171875000e+02 9.1963996887207031e+00 -7.4500000000000000e+01 -2.9487100219726562e+02 9.4849891662597656e+00 -7.4500000000000000e+01 -2.9420599365234375e+02 1.4540800094604492e+01 -7.4500000000000000e+01 -2.8956799316406250e+02 1.4364600181579590e+01 -7.4500000000000000e+01 -2.8966598510742188e+02 1.3171299934387207e+01 -7.4500000000000000e+01 -2.9375500488281250e+02 1.4166099548339844e+01 -7.4500000000000000e+01 -2.8970001220703125e+02 1.1117000579833984e+01 -7.4500000000000000e+01 -2.8970001220703125e+02 4.7245998382568359e+00 -7.4500000000000000e+01 -2.8413702392578125e+02 5.5638003349304199e+00 -7.4500000000000000e+01 -2.8370498657226562e+02 1.3257400512695312e+01 -7.4500000000000000e+01 -2.8496200561523438e+02 1.3643500328063965e+01 -7.4500000000000000e+01 -2.8545300292968750e+02 1.4402400016784668e+01 -7.4500000000000000e+01 -2.8698501586914062e+02 1.4656299591064453e+01 -7.4500000000000000e+01 -2.8800799560546875e+02 -3.8708999156951904e+00 -7.4500000000000000e+01 -2.9579800415039062e+02 -3.7148001194000244e+00 -7.4500000000000000e+01 -2.9589599609375000e+02 -3.9567997455596924e+00 -7.4500000000000000e+01 -2.9568698120117188e+02 -3.3747000694274902e+00 -7.4500000000000000e+01 -2.9598699951171875e+02 5.0996003150939941e+00 -7.4500000000000000e+01 -2.9494900512695312e+02 6.9972000122070312e+00 -7.4500000000000000e+01 -2.8726101684570312e+02 1.0426799774169922e+01 -7.4500000000000000e+01 -2.8850799560546875e+02 1.0351900100708008e+01 -7.4500000000000000e+01 -2.8823599243164062e+02 6.5717000961303711e+00 -7.4500000000000000e+01 -2.8757797241210938e+02 -4.0540995597839355e+00 -7.4500000000000000e+01 -2.9466098022460938e+02 -4.0773000717163086e+00 -7.4500000000000000e+01 -2.9496600341796875e+02 -4.0616998672485352e+00 -7.4500000000000000e+01 -2.9532598876953125e+02 6.2710100412368774e-01 -7.4500000000000000e+01 -2.9048300170898438e+02 9.1670501232147217e-01 -7.4500000000000000e+01 -2.8929299926757812e+02 -8.3498194813728333e-02 -7.4500000000000000e+01 -2.8658801269531250e+02 1.3337000608444214e+00 -7.4500000000000000e+01 -2.8814199829101562e+02 -1.2099298648536205e-02 -7.4500000000000000e+01 -2.8639099121093750e+02 1.8866000175476074e+00 -7.4500000000000000e+01 -2.8704101562500000e+02 2.4170999526977539e+00 -7.4500000000000000e+01 -2.8624002075195312e+02 1.0109200477600098e+01 -7.4500000000000000e+01 -2.8323199462890625e+02 1.0748000144958496e+01 -7.4500000000000000e+01 -2.8338900756835938e+02 1.1373100280761719e+01 -7.4500000000000000e+01 -2.8361599731445312e+02 1.1373200416564941e+01 -7.4500000000000000e+01 -2.8361700439453125e+02 1.1933900833129883e+01 -7.4500000000000000e+01 -2.8389498901367188e+02 8.5349998474121094e+00 -7.4500000000000000e+01 -2.8690200805664062e+02 8.1050996780395508e+00 -7.4500000000000000e+01 -2.8691299438476562e+02 8.8505001068115234e+00 -7.4500000000000000e+01 -2.8693301391601562e+02 1.0239000320434570e+01 -7.4500000000000000e+01 -2.8795498657226562e+02 1.0088100433349609e+01 -7.4500000000000000e+01 -2.8768701171875000e+02 7.6045999526977539e+00 -7.4500000000000000e+01 -2.8699899291992188e+02 6.9972996711730957e+00 -7.4500000000000000e+01 -2.8726101684570312e+02 9.9200000762939453e+00 -7.4500000000000000e+01 -2.8747201538085938e+02 9.7184000015258789e+00 -7.4500000000000000e+01 -2.8728802490234375e+02 9.1751098632812500e+00 -7.4500000000000000e+01 -2.8700701904296875e+02 9.4830999374389648e+00 -7.4500000000000000e+01 -2.8713500976562500e+02 -2.7712600708007812e+01 -7.4500000000000000e+01 -2.8224600219726562e+02 -2.7908100128173828e+01 -7.4500000000000000e+01 -2.8339498901367188e+02 -2.5559099197387695e+01 -7.4500000000000000e+01 -2.8339498901367188e+02 -2.7600299835205078e+01 -7.4500000000000000e+01 -2.8181799316406250e+02 -2.3758699417114258e+01 -7.4500000000000000e+01 -2.8011798095703125e+02 -2.3918199539184570e+01 -7.4500000000000000e+01 -2.8024102783203125e+02 -2.5174299240112305e+01 -7.4500000000000000e+01 -2.8353500366210938e+02 -2.4109498977661133e+01 -7.4500000000000000e+01 -2.8030401611328125e+02 -5.2066299438476562e+01 -7.4500000000000000e+01 -3.0558801269531250e+02 -3.5010799407958984e+01 -7.4500000000000000e+01 -2.8674798583984375e+02 -5.3301597595214844e+01 -7.4500000000000000e+01 -3.0143801879882812e+02 -5.4189998626708984e+01 -7.4500000000000000e+01 -2.9720101928710938e+02 -2.4807300567626953e+01 -7.4500000000000000e+01 -2.8023098754882812e+02 -2.4973299026489258e+01 -7.4500000000000000e+01 -2.8022302246093750e+02 -2.5455801010131836e+01 -7.4500000000000000e+01 -2.8340399169921875e+02 -2.5062099456787109e+01 -7.4500000000000000e+01 -2.8022198486328125e+02 -2.5159000396728516e+01 -7.4500000000000000e+01 -2.8022198486328125e+02 -2.6025800704956055e+01 -7.4500000000000000e+01 -2.8034600830078125e+02 -2.3603300094604492e+01 -7.4500000000000000e+01 -2.7977801513671875e+02 -2.3649000167846680e+01 -7.4500000000000000e+01 -2.7994998168945312e+02 -3.4729297637939453e+01 -7.4500000000000000e+01 -2.8687799072265625e+02 -3.5144100189208984e+01 -7.4500000000000000e+01 -2.9892901611328125e+02 -3.4626098632812500e+01 -7.4500000000000000e+01 -2.8688699340820312e+02 -3.3054000854492188e+01 -7.4500000000000000e+01 -2.8688699340820312e+02 -5.3804901123046875e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 -3.4528800964355469e+01 -7.4500000000000000e+01 -2.8347598266601562e+02 -3.4229400634765625e+01 -7.4500000000000000e+01 -2.8339300537109375e+02 -2.4310899734497070e+01 -7.4500000000000000e+01 -2.8030099487304688e+02 -2.4477201461791992e+01 -7.4500000000000000e+01 -2.8027099609375000e+02 -2.4641700744628906e+01 -7.4500000000000000e+01 -2.8024700927734375e+02 -1.1193900108337402e+01 -7.4500000000000000e+01 -2.9278399658203125e+02 -1.1413300514221191e+01 -7.4500000000000000e+01 -2.9300299072265625e+02 -3.5116199493408203e+01 -7.4500000000000000e+01 -2.9923901367187500e+02 -5.0492599487304688e+01 -7.4500000000000000e+01 -3.0962100219726562e+02 -3.4937602996826172e+01 -7.4500000000000000e+01 -2.9949200439453125e+02 -4.8591201782226562e+01 -7.4500000000000000e+01 -3.1351000976562500e+02 -5.4725502014160156e+01 -7.4500000000000000e+01 -2.9290499877929688e+02 -3.5189098358154297e+01 -7.4500000000000000e+01 -2.8649398803710938e+02 -5.4904300689697266e+01 -7.4500000000000000e+01 -2.8857998657226562e+02 -3.5216701507568359e+01 -7.4500000000000000e+01 -2.8618499755859375e+02 -5.4725502014160156e+01 -7.4500000000000000e+01 -2.8425500488281250e+02 -3.2452400207519531e+01 -7.4500000000000000e+01 -2.8338198852539062e+02 -3.2298301696777344e+01 -7.4500000000000000e+01 -2.8218701171875000e+02 -2.6808601379394531e+01 -7.4500000000000000e+01 -2.8072802734375000e+02 -2.7279199600219727e+01 -7.4500000000000000e+01 -2.8119299316406250e+02 -1.1120499610900879e+01 -7.4500000000000000e+01 -2.9257598876953125e+02 -2.5368499755859375e+01 -7.4500000000000000e+01 -2.8639099121093750e+02 -2.5439899444580078e+01 -7.4500000000000000e+01 -2.8658801269531250e+02 -3.1218299865722656e+01 -7.4500000000000000e+01 -2.9963101196289062e+02 -3.4553298950195312e+01 -7.4500000000000000e+01 -2.9963101196289062e+02 -3.4655998229980469e+01 -7.4500000000000000e+01 -2.9962301635742188e+02 -1.4663599967956543e+01 -7.4500000000000000e+01 -2.9472198486328125e+02 -1.4520700454711914e+01 -7.4500000000000000e+01 -2.9462500000000000e+02 -2.0876899719238281e+01 -7.4500000000000000e+01 -2.9308398437500000e+02 -1.4327500343322754e+01 -7.4500000000000000e+01 -2.9456900024414062e+02 -1.1713200569152832e+01 -7.4500000000000000e+01 -2.9308398437500000e+02 -1.4126500129699707e+01 -7.4500000000000000e+01 -2.9458001708984375e+02 -5.4189998626708984e+01 -7.4500000000000000e+01 -2.7995898437500000e+02 -3.4816299438476562e+01 -7.4500000000000000e+01 -2.8389001464843750e+02 -3.4746799468994141e+01 -7.4500000000000000e+01 -2.8369598388671875e+02 -3.2056701660156250e+01 -7.4500000000000000e+01 -2.8096099853515625e+02 -3.1856897354125977e+01 -7.4500000000000000e+01 -2.8035198974609375e+02 -3.1598602294921875e+01 -7.4500000000000000e+01 -2.7976000976562500e+02 -2.4995901107788086e+01 -7.4500000000000000e+01 -2.8378900146484375e+02 -2.4968299865722656e+01 -7.4500000000000000e+01 -2.8409799194335938e+02 -3.0698999404907227e+01 -7.4500000000000000e+01 -2.9933200073242188e+02 -3.0918399810791016e+01 -7.4500000000000000e+01 -2.9955102539062500e+02 -1.8575099945068359e+01 -7.4500000000000000e+01 -2.9992398071289062e+02 -1.9532600402832031e+01 -7.4500000000000000e+01 -3.3812100219726562e+02 -1.8574901580810547e+01 -7.4500000000000000e+01 -2.9992398071289062e+02 -4.3859703063964844e+01 -7.4500000000000000e+01 -3.2075198364257812e+02 -4.1061798095703125e+01 -7.4500000000000000e+01 -3.2405599975585938e+02 -1.3940400123596191e+01 -7.4500000000000000e+01 -2.9465698242187500e+02 -1.3790399551391602e+01 -7.4500000000000000e+01 -2.9479199218750000e+02 -1.2384699821472168e+01 -7.4500000000000000e+01 -2.9655999755859375e+02 -1.5383399963378906e+01 -7.4500000000000000e+01 -3.3935699462890625e+02 -1.2375400543212891e+01 -7.4500000000000000e+01 -2.9729397583007812e+02 -1.2282899856567383e+01 -7.4500000000000000e+01 -2.9711499023437500e+02 -1.2294199943542480e+01 -7.4500000000000000e+01 -2.9671798706054688e+02 -1.2254699707031250e+01 -7.4500000000000000e+01 -2.9691601562500000e+02 -1.1146400451660156e+01 -7.4500000000000000e+01 -3.4024499511718750e+02 -3.0627500534057617e+01 -7.4500000000000000e+01 -2.9913397216796875e+02 -1.9812398910522461e+01 -7.4500000000000000e+01 -2.9981500244140625e+02 -2.0704599380493164e+01 -7.4500000000000000e+01 -2.9960900878906250e+02 -3.8000598907470703e+01 -7.4500000000000000e+01 -3.2711700439453125e+02 -3.4696998596191406e+01 -7.4500000000000000e+01 -3.2991497802734375e+02 -3.1173799514770508e+01 -7.4500000000000000e+01 -3.3242999267578125e+02 -2.7454801559448242e+01 -7.4500000000000000e+01 -3.3464599609375000e+02 -2.3565599441528320e+01 -7.4500000000000000e+01 -3.3654800415039062e+02 -2.0878101348876953e+01 -7.4500000000000000e+01 -2.9321600341796875e+02 -2.0824399948120117e+01 -7.4500000000000000e+01 -2.9385000610351562e+02 -1.8200000762939453e+01 -7.4500000000000000e+01 -2.9611099243164062e+02 -2.0757799148559570e+01 -7.4500000000000000e+01 -2.9416000366210938e+02 -2.0757699966430664e+01 -7.4500000000000000e+01 -2.9416000366210938e+02 -1.6106000900268555e+01 -7.4500000000000000e+01 -2.9569699096679688e+02 -1.5560500144958496e+01 -7.4500000000000000e+01 -2.9539999389648438e+02 -1.5098199844360352e+01 -7.4500000000000000e+01 -2.9508297729492188e+02 -1.2778699874877930e+01 -7.4500000000000000e+01 -2.9776998901367188e+02 -1.3437399864196777e+01 -7.4500000000000000e+01 -2.9836099243164062e+02 -1.3945000648498535e+01 -7.4500000000000000e+01 -2.9871499633789062e+02 -1.4719900131225586e+01 -7.4500000000000000e+01 -2.8344299316406250e+02 -1.3892900466918945e+01 -7.4500000000000000e+01 -2.8380798339843750e+02 -1.2483200073242188e+01 -7.4500000000000000e+01 -2.8491198730468750e+02 -1.1949999809265137e+01 -7.4500000000000000e+01 -2.8560000610351562e+02 -1.1451900482177734e+01 -7.4500000000000000e+01 -2.8652502441406250e+02 -1.1164600372314453e+01 -7.4500000000000000e+01 -2.8731600952148438e+02 -2.1575899124145508e+01 -7.4500000000000000e+01 -2.9927600097656250e+02 -2.2554599761962891e+01 -7.4500000000000000e+01 -2.9871697998046875e+02 -2.3203199386596680e+01 -7.4500000000000000e+01 -2.9820498657226562e+02 -4.6375301361083984e+01 -7.4500000000000000e+01 -3.1722900390625000e+02 -1.7934600830078125e+01 -7.4500000000000000e+01 -2.9611398315429688e+02 -1.7307300567626953e+01 -7.4500000000000000e+01 -2.9606301879882812e+02 -2.0130998611450195e+01 -7.4500000000000000e+01 -2.8373501586914062e+02 -1.9056299209594727e+01 -7.4500000000000000e+01 -2.8335198974609375e+02 -1.7960800170898438e+01 -7.4500000000000000e+01 -2.8314901733398438e+02 -1.3892799377441406e+01 -7.4500000000000000e+01 -2.8380798339843750e+02 -1.3103799819946289e+01 -7.4500000000000000e+01 -2.8433401489257812e+02 -1.0832300186157227e+01 -7.4500000000000000e+01 -2.8936801147460938e+02 -1.0846500396728516e+01 -7.4500000000000000e+01 -2.9059698486328125e+02 -1.0894900321960449e+01 -7.4500000000000000e+01 -2.9111499023437500e+02 -2.3787698745727539e+01 -7.4500000000000000e+01 -2.9760000610351562e+02 -2.4393999099731445e+01 -7.4500000000000000e+01 -2.9674499511718750e+02 -2.4788999557495117e+01 -7.4500000000000000e+01 -2.9596099853515625e+02 -1.6692998886108398e+01 -7.4500000000000000e+01 -2.9592498779296875e+02 -1.6106100082397461e+01 -7.4500000000000000e+01 -2.9569699096679688e+02 -1.6825000762939453e+01 -7.4500000000000000e+01 -2.8310299682617188e+02 -1.5573400497436523e+01 -7.4500000000000000e+01 -2.8322198486328125e+02 -1.0969400405883789e+01 -7.4500000000000000e+01 -2.8814700317382812e+02 -1.0969300270080566e+01 -7.4500000000000000e+01 -2.8814700317382812e+02 -2.5085401535034180e+01 -7.4500000000000000e+01 -2.9511898803710938e+02 -2.5326499938964844e+01 -7.4500000000000000e+01 -2.9390499877929688e+02 -2.8501899719238281e+01 -7.4500000000000000e+01 -2.8688699340820312e+02 -1.9124200820922852e+01 -7.4500000000000000e+01 -2.9596600341796875e+02 -1.8811000823974609e+01 -7.4500000000000000e+01 -2.9604699707031250e+02 -1.8206399917602539e+01 -7.4500000000000000e+01 -2.9611001586914062e+02 -2.0998100280761719e+01 -7.4500000000000000e+01 -2.8419100952148438e+02 -2.1793199539184570e+01 -7.4500000000000000e+01 -2.8473898315429688e+02 -2.0272201538085938e+01 -7.4500000000000000e+01 -2.9516699218750000e+02 -2.0054698944091797e+01 -7.4500000000000000e+01 -2.9540899658203125e+02 -2.0529899597167969e+01 -7.4500000000000000e+01 -2.9476300048828125e+02 -2.0660400390625000e+01 -7.4500000000000000e+01 -2.9446701049804688e+02 -1.9804998397827148e+01 -7.4500000000000000e+01 -2.9561801147460938e+02 -1.9424600601196289e+01 -7.4500000000000000e+01 -2.9584399414062500e+02 -1.4467800140380859e+01 -7.4500000000000000e+01 -2.9901599121093750e+02 -1.5018400192260742e+01 -7.4500000000000000e+01 -2.9927200317382812e+02 -1.5595699310302734e+01 -7.4500000000000000e+01 -2.9948699951171875e+02 -1.6181299209594727e+01 -7.4500000000000000e+01 -2.9965600585937500e+02 -1.6781099319458008e+01 -7.4500000000000000e+01 -2.9978201293945312e+02 -2.3894901275634766e+01 -7.4500000000000000e+01 -2.8717398071289062e+02 -2.3347999572753906e+01 -7.4500000000000000e+01 -2.8634500122070312e+02 -2.2704299926757812e+01 -7.4500000000000000e+01 -2.8557397460937500e+02 -2.4447401046752930e+01 -7.4500000000000000e+01 -2.8827398681640625e+02 -2.5659299850463867e+01 -7.4500000000000000e+01 -2.8680700683593750e+02 -2.4817298889160156e+01 -7.4500000000000000e+01 -2.8926797485351562e+02 -1.7389099121093750e+01 -7.4500000000000000e+01 -2.9986798095703125e+02 -1.7979900360107422e+01 -7.4500000000000000e+01 -2.9991497802734375e+02 -2.5282400131225586e+01 -7.4500000000000000e+01 -2.9149401855468750e+02 -2.5282299041748047e+01 -7.4500000000000000e+01 -2.9149301147460938e+02 -2.5088199615478516e+01 -7.4500000000000000e+01 -2.9028399658203125e+02 -2.5959199905395508e+01 -7.4500000000000000e+01 -2.8688699340820312e+02 -2.5381399154663086e+01 -7.4500000000000000e+01 -2.9299899291992188e+02 -2.5341098785400391e+01 -7.4500000000000000e+01 -2.9208200073242188e+02 -2.3339599609375000e+01 -7.4500000000000000e+01 -2.7709899902343750e+02 -2.3327899932861328e+01 -7.4500000000000000e+01 -2.7729998779296875e+02 -2.3419300079345703e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 -3.1295499801635742e+01 -7.4500000000000000e+01 -2.7921600341796875e+02 -3.0939500808715820e+01 -7.4500000000000000e+01 -2.7870397949218750e+02 -3.0394399642944336e+01 -7.4500000000000000e+01 -2.7812200927734375e+02 -5.3301597595214844e+01 -7.4500000000000000e+01 -2.7572198486328125e+02 -4.6375301361083984e+01 -7.4500000000000000e+01 -2.5993099975585938e+02 -3.0213199615478516e+01 -7.4500000000000000e+01 -2.7792901611328125e+02 -4.3859703063964844e+01 -7.4500000000000000e+01 -2.5640802001953125e+02 -2.9723600387573242e+01 -7.4500000000000000e+01 -2.7754299926757812e+02 -4.1061798095703125e+01 -7.4500000000000000e+01 -2.5310400390625000e+02 -2.9194499969482422e+01 -7.4500000000000000e+01 -2.7721200561523438e+02 -3.8000598907470703e+01 -7.4500000000000000e+01 -2.5004299926757812e+02 -2.8229499816894531e+01 -7.4500000000000000e+01 -2.7678497314453125e+02 -3.4696998596191406e+01 -7.4500000000000000e+01 -2.4724499511718750e+02 -4.8591201782226562e+01 -7.4500000000000000e+01 -2.6364999389648438e+02 -5.0492599487304688e+01 -7.4500000000000000e+01 -2.6753900146484375e+02 -5.2066299438476562e+01 -7.4500000000000000e+01 -2.7157199096679688e+02 -2.7634199142456055e+01 -7.4500000000000000e+01 -2.7661099243164062e+02 -3.1173799514770508e+01 -7.4500000000000000e+01 -2.4472999572753906e+02 -2.6425798416137695e+01 -7.4500000000000000e+01 -2.7642898559570312e+02 -2.5716501235961914e+01 -7.4500000000000000e+01 -2.7640798950195312e+02 -2.3565599441528320e+01 -7.4500000000000000e+01 -2.4061199951171875e+02 -2.7454801559448242e+01 -7.4500000000000000e+01 -2.4251399230957031e+02 -2.5434200286865234e+01 -7.4500000000000000e+01 -2.7641998291015625e+02 -2.5142499923706055e+01 -7.4500000000000000e+01 -2.7644100952148438e+02 -1.9532600402832031e+01 -7.4500000000000000e+01 -2.3903900146484375e+02 -2.4851699829101562e+01 -7.4500000000000000e+01 -2.7647201538085938e+02 -2.4562000274658203e+01 -7.4500000000000000e+01 -2.7651300048828125e+02 -2.4278699874877930e+01 -7.4500000000000000e+01 -2.7655999755859375e+02 -1.5383399963378906e+01 -7.4500000000000000e+01 -2.3780400085449219e+02 -2.3810298919677734e+01 -7.4500000000000000e+01 -2.7664501953125000e+02 -1.1146400451660156e+01 -7.4500000000000000e+01 -2.3691500854492188e+02 -2.3728401184082031e+01 -7.4500000000000000e+01 -2.7666699218750000e+02 -1.0099100112915039e+01 -7.4500000000000000e+01 -2.3678498840332031e+02 -2.3551900863647461e+01 -7.4500000000000000e+01 -2.7676400756835938e+02 -2.3417200088500977e+01 -7.4500000000000000e+01 -2.7691299438476562e+02 4.3541198730468750e+01 -7.4500000000000000e+01 -2.6364999389648438e+02 2.3091400146484375e+01 -7.4500000000000000e+01 -2.7689297485351562e+02 2.3264699935913086e+01 -7.4500000000000000e+01 -2.7714999389648438e+02 1.9087800979614258e+01 -7.4500000000000000e+01 -2.7682598876953125e+02 -6.8505001068115234e+00 -7.4500000000000000e+01 -2.3637998962402344e+02 1.8868400573730469e+01 -7.4500000000000000e+01 -2.7704501342773438e+02 1.8796899795532227e+01 -7.4500000000000000e+01 -2.7724298095703125e+02 4.1325199127197266e+01 -7.4500000000000000e+01 -2.5993099975585938e+02 3.8809600830078125e+01 -7.4500000000000000e+01 -2.5640802001953125e+02 2.2812599182128906e+01 -7.4500000000000000e+01 -2.7675598144531250e+02 3.6011699676513672e+01 -7.4500000000000000e+01 -2.5310400390625000e+02 3.2950496673583984e+01 -7.4500000000000000e+01 -2.5004299926757812e+02 6.0963001251220703e+00 -7.4500000000000000e+01 -2.3691500854492188e+02 1.0333299636840820e+01 -7.4500000000000000e+01 -2.3780400085449219e+02 1.9387699127197266e+01 -7.4500000000000000e+01 -2.7674499511718750e+02 1.8004000186920166e+00 -7.4500000000000000e+01 -2.3637998962402344e+02 -2.5249898433685303e+00 -7.4500000000000000e+01 -2.3620100402832031e+02 2.2697500228881836e+01 -7.4500000000000000e+01 -2.7674499511718750e+02 1.8515499114990234e+01 -7.4500000000000000e+01 -2.4061199951171875e+02 1.4482500076293945e+01 -7.4500000000000000e+01 -2.3903900146484375e+02 2.9646999359130859e+01 -7.4500000000000000e+01 -2.4724499511718750e+02 2.6123701095581055e+01 -7.4500000000000000e+01 -2.4472999572753906e+02 2.2404798507690430e+01 -7.4500000000000000e+01 -2.4251399230957031e+02 4.8251499176025391e+01 -7.4500000000000000e+01 -2.7572198486328125e+02 4.7016201019287109e+01 -7.4500000000000000e+01 -2.7157199096679688e+02 4.5442501068115234e+01 -7.4500000000000000e+01 -2.6753900146484375e+02 -7.0750002861022949e+00 -7.2767799377441406e+01 -2.3366999816894531e+02 -1.1785200119018555e+01 -6.7129501342773438e+01 -2.3160000610351562e+02 -1.1593899726867676e+01 -7.2767799377441406e+01 -2.3423300170898438e+02 -1.2024800300598145e+01 -6.7129501342773438e+01 -2.3164900207519531e+02 -1.6050899505615234e+01 -7.2767799377441406e+01 -2.3516799926757812e+02 -2.4657699584960938e+01 -7.2767799377441406e+01 -2.3812199401855469e+02 -2.9352300643920898e+01 -6.7129501342773438e+01 -2.3746499633789062e+02 -2.8748899459838867e+01 -7.2767799377441406e+01 -2.4012300109863281e+02 -2.9987800598144531e+01 -6.7129501342773438e+01 -2.3783200073242188e+02 -3.2660900115966797e+01 -7.2767799377441406e+01 -2.4245401000976562e+02 -1.6340099334716797e+01 -6.7129501342773438e+01 -2.3252999877929688e+02 -2.0805500030517578e+01 -6.7129501342773438e+01 -2.3382299804687500e+02 -2.0415399551391602e+01 -7.2767799377441406e+01 -2.3646701049804688e+02 -2.1262800216674805e+01 -6.7129501342773438e+01 -2.3399700927734375e+02 -2.5152299880981445e+01 -6.7129501342773438e+01 -2.3547200012207031e+02 -3.9842098236083984e+01 -7.2767799377441406e+01 -2.4804299926757812e+02 -4.4158203125000000e+01 -6.7129501342773438e+01 -2.4859100341796875e+02 -4.3062099456787109e+01 -7.2767799377441406e+01 -2.5126298522949219e+02 -4.4969303131103516e+01 -6.7129501342773438e+01 -2.4950599670410156e+02 -4.6005302429199219e+01 -7.2767799377441406e+01 -2.5473800659179688e+02 -3.3378299713134766e+01 -6.7129501342773438e+01 -2.3978900146484375e+02 -3.7204299926757812e+01 -6.7129501342773438e+01 -2.4243000793457031e+02 -3.6367099761962891e+01 -7.2767799377441406e+01 -2.4510000610351562e+02 -3.7962196350097656e+01 -6.7129501342773438e+01 -2.4304899597167969e+02 -4.0805400848388672e+01 -6.7129501342773438e+01 -2.4536999511718750e+02 -5.0982501983642578e+01 -7.2767799377441406e+01 -2.6235601806640625e+02 -5.4678897857666016e+01 -6.7129501342773438e+01 -2.6383297729492188e+02 -5.2982597351074219e+01 -7.2767799377441406e+01 -2.6644702148437500e+02 -5.5350200653076172e+01 -6.7129501342773438e+01 -2.6540802001953125e+02 -5.4637901306152344e+01 -7.2767799377441406e+01 -2.7069000244140625e+02 -4.7240997314453125e+01 -6.7129501342773438e+01 -2.5207099914550781e+02 -5.0033802032470703e+01 -6.7129501342773438e+01 -2.5578698730468750e+02 -4.8651401519775391e+01 -7.2767799377441406e+01 -2.5844400024414062e+02 -5.0818302154541016e+01 -6.7129501342773438e+01 -2.5702801513671875e+02 -5.2518497467041016e+01 -6.7129501342773438e+01 -2.5971600341796875e+02 -5.9831600189208984e+01 -6.7129501342773438e+01 -2.8162197875976562e+02 -5.7435100555419922e+01 -7.2767799377441406e+01 -2.8402999877929688e+02 -5.6871803283691406e+01 -7.2767799377441406e+01 -2.7951101684570312e+02 -5.6501102447509766e+01 -6.7129501342773438e+01 -2.6811001586914062e+02 -5.7973300933837891e+01 -6.7129501342773438e+01 -2.7251898193359375e+02 -5.5937301635742188e+01 -7.2767799377441406e+01 -2.7505401611328125e+02 -5.8441699981689453e+01 -6.7129501342773438e+01 -2.7441998291015625e+02 -5.9085800170898438e+01 -6.7129501342773438e+01 -2.7703298950195312e+02 -6.0008701324462891e+01 -6.7129501342773438e+01 -2.8381698608398438e+02 -6.0205699920654297e+01 -6.7129501342773438e+01 -2.8625598144531250e+02 -5.7623302459716797e+01 -7.2767799377441406e+01 -2.8857998657226562e+02 -6.0205699920654297e+01 -6.7129501342773438e+01 -2.9090399169921875e+02 -5.7435100555419922e+01 -7.2767799377441406e+01 -2.9313000488281250e+02 -6.0008701324462891e+01 -6.7129501342773438e+01 -2.9334301757812500e+02 -5.9831600189208984e+01 -6.7129501342773438e+01 -2.9553799438476562e+02 -5.6871803283691406e+01 -7.2767799377441406e+01 -2.9764898681640625e+02 -5.9085800170898438e+01 -6.7129501342773438e+01 -3.0012701416015625e+02 -5.5937301635742188e+01 -7.2767799377441406e+01 -3.0210598754882812e+02 -5.8441699981689453e+01 -6.7129501342773438e+01 -3.0274002075195312e+02 -5.7973300933837891e+01 -6.7129501342773438e+01 -3.0464102172851562e+02 -5.4637901306152344e+01 -7.2767799377441406e+01 -3.0647000122070312e+02 -5.6501102447509766e+01 -6.7129501342773438e+01 -3.0904998779296875e+02 -5.2982597351074219e+01 -7.2767799377441406e+01 -3.1071298217773438e+02 -5.5350200653076172e+01 -6.7129501342773438e+01 -3.1175198364257812e+02 -5.4678897857666016e+01 -6.7129501342773438e+01 -3.1332702636718750e+02 -5.0982501983642578e+01 -7.2767799377441406e+01 -3.1480398559570312e+02 -5.2518497467041016e+01 -6.7129501342773438e+01 -3.1744400024414062e+02 -4.8651401519775391e+01 -7.2767799377441406e+01 -3.1871600341796875e+02 -5.0818302154541016e+01 -6.7129501342773438e+01 -3.2013198852539062e+02 -5.0033802032470703e+01 -6.7129501342773438e+01 -3.2137298583984375e+02 -4.6005302429199219e+01 -7.2767799377441406e+01 -3.2242199707031250e+02 -4.7240997314453125e+01 -6.7129501342773438e+01 -3.2508901977539062e+02 -4.3062099456787109e+01 -7.2767799377441406e+01 -3.2589700317382812e+02 -4.4969303131103516e+01 -6.7129501342773438e+01 -3.2765399169921875e+02 -4.4158203125000000e+01 -6.7129501342773438e+01 -3.2856900024414062e+02 -3.9842098236083984e+01 -7.2767799377441406e+01 -3.2911700439453125e+02 -4.0805400848388672e+01 -6.7129501342773438e+01 -3.3179000854492188e+02 -3.6367099761962891e+01 -7.2767799377441406e+01 -3.3205999755859375e+02 -3.7962196350097656e+01 -6.7129501342773438e+01 -3.3411099243164062e+02 -3.7204299926757812e+01 -6.7129501342773438e+01 -3.3473001098632812e+02 -3.2660900115966797e+01 -7.2767799377441406e+01 -3.3470599365234375e+02 -3.3378299713134766e+01 -6.7129501342773438e+01 -3.3737100219726562e+02 -2.8748899459838867e+01 -7.2767799377441406e+01 -3.3703802490234375e+02 -2.9987800598144531e+01 -6.7129501342773438e+01 -3.3932800292968750e+02 -2.9352300643920898e+01 -6.7129501342773438e+01 -3.3969500732421875e+02 -2.4657699584960938e+01 -7.2767799377441406e+01 -3.3903802490234375e+02 -2.5152299880981445e+01 -6.7129501342773438e+01 -3.4168801879882812e+02 -2.0415399551391602e+01 -7.2767799377441406e+01 -3.4069299316406250e+02 -2.1262800216674805e+01 -6.7129501342773438e+01 -3.4316302490234375e+02 -2.0805500030517578e+01 -6.7129501342773438e+01 -3.4333700561523438e+02 -1.6050899505615234e+01 -7.2767799377441406e+01 -3.4199200439453125e+02 -1.6340099334716797e+01 -6.7129501342773438e+01 -3.4463000488281250e+02 -1.1593899726867676e+01 -7.2767799377441406e+01 -3.4292700195312500e+02 2.0249900817871094e+00 -7.2767799377441406e+01 -3.4348999023437500e+02 6.7350997924804688e+00 -6.7129501342773438e+01 -3.4556002807617188e+02 6.5437998771667480e+00 -7.2767799377441406e+01 -3.4292700195312500e+02 6.9746999740600586e+00 -6.7129501342773438e+01 -3.4551098632812500e+02 1.1000800132751465e+01 -7.2767799377441406e+01 -3.4199200439453125e+02 -1.2024800300598145e+01 -6.7129501342773438e+01 -3.4551098632812500e+02 -1.1785200119018555e+01 -6.7129501342773438e+01 -3.4556002807617188e+02 -7.0750002861022949e+00 -7.2767799377441406e+01 -3.4348999023437500e+02 -7.1701998710632324e+00 -6.7129501342773438e+01 -3.4611999511718750e+02 -2.5249898433685303e+00 -7.2767799377441406e+01 -3.4367800903320312e+02 -2.5249898433685303e+00 -6.7129501342773438e+01 -3.4630700683593750e+02 2.1201000213623047e+00 -6.7129501342773438e+01 -3.4611999511718750e+02 1.9607700347900391e+01 -7.2767799377441406e+01 -3.3903802490234375e+02 2.4302299499511719e+01 -6.7129501342773438e+01 -3.3969500732421875e+02 2.3698799133300781e+01 -7.2767799377441406e+01 -3.3703802490234375e+02 2.4937799453735352e+01 -6.7129501342773438e+01 -3.3932800292968750e+02 2.7610898971557617e+01 -7.2767799377441406e+01 -3.3470599365234375e+02 1.1289999961853027e+01 -6.7129501342773438e+01 -3.4463000488281250e+02 1.5755399703979492e+01 -6.7129501342773438e+01 -3.4333700561523438e+02 1.5365300178527832e+01 -7.2767799377441406e+01 -3.4069299316406250e+02 1.6212800979614258e+01 -6.7129501342773438e+01 -3.4316302490234375e+02 2.0102199554443359e+01 -6.7129501342773438e+01 -3.4168801879882812e+02 3.4791999816894531e+01 -7.2767799377441406e+01 -3.2911700439453125e+02 3.9108100891113281e+01 -6.7129501342773438e+01 -3.2856900024414062e+02 3.8012100219726562e+01 -7.2767799377441406e+01 -3.2589700317382812e+02 3.9919296264648438e+01 -6.7129501342773438e+01 -3.2765399169921875e+02 4.0955200195312500e+01 -7.2767799377441406e+01 -3.2242199707031250e+02 2.8328300476074219e+01 -6.7129501342773438e+01 -3.3737100219726562e+02 3.2154300689697266e+01 -6.7129501342773438e+01 -3.3473001098632812e+02 3.1316999435424805e+01 -7.2767799377441406e+01 -3.3205999755859375e+02 3.2912197113037109e+01 -6.7129501342773438e+01 -3.3411099243164062e+02 3.5755397796630859e+01 -6.7129501342773438e+01 -3.3179000854492188e+02 4.5932399749755859e+01 -7.2767799377441406e+01 -3.1480398559570312e+02 4.9628898620605469e+01 -6.7129501342773438e+01 -3.1332702636718750e+02 4.7932498931884766e+01 -7.2767799377441406e+01 -3.1071298217773438e+02 5.0300098419189453e+01 -6.7129501342773438e+01 -3.1175198364257812e+02 4.9587902069091797e+01 -7.2767799377441406e+01 -3.0647000122070312e+02 4.2190898895263672e+01 -6.7129501342773438e+01 -3.2508901977539062e+02 4.4983699798583984e+01 -6.7129501342773438e+01 -3.2137298583984375e+02 4.3601402282714844e+01 -7.2767799377441406e+01 -3.1871600341796875e+02 4.5768299102783203e+01 -6.7129501342773438e+01 -3.2013198852539062e+02 4.7468402862548828e+01 -6.7129501342773438e+01 -3.1744400024414062e+02 5.4781501770019531e+01 -6.7129501342773438e+01 -2.9553799438476562e+02 5.2385097503662109e+01 -7.2767799377441406e+01 -2.9313000488281250e+02 5.1821701049804688e+01 -7.2767799377441406e+01 -2.9764898681640625e+02 5.1451099395751953e+01 -6.7129501342773438e+01 -3.0904998779296875e+02 5.2923198699951172e+01 -6.7129501342773438e+01 -3.0464102172851562e+02 5.0887302398681641e+01 -7.2767799377441406e+01 -3.0210598754882812e+02 5.3391696929931641e+01 -6.7129501342773438e+01 -3.0274002075195312e+02 5.4035800933837891e+01 -6.7129501342773438e+01 -3.0012701416015625e+02 5.4958702087402344e+01 -6.7129501342773438e+01 -2.9334301757812500e+02 5.5155601501464844e+01 -6.7129501342773438e+01 -2.9090399169921875e+02 5.2573200225830078e+01 -7.2767799377441406e+01 -2.8857998657226562e+02 5.5155601501464844e+01 -6.7129501342773438e+01 -2.8625598144531250e+02 5.2385097503662109e+01 -7.2767799377441406e+01 -2.8402999877929688e+02 5.4958702087402344e+01 -6.7129501342773438e+01 -2.8381698608398438e+02 5.4781501770019531e+01 -6.7129501342773438e+01 -2.8162197875976562e+02 5.1821701049804688e+01 -7.2767799377441406e+01 -2.7951101684570312e+02 5.4035800933837891e+01 -6.7129501342773438e+01 -2.7703298950195312e+02 5.0887302398681641e+01 -7.2767799377441406e+01 -2.7505401611328125e+02 5.3391696929931641e+01 -6.7129501342773438e+01 -2.7441998291015625e+02 5.2923198699951172e+01 -6.7129501342773438e+01 -2.7251898193359375e+02 4.9587902069091797e+01 -7.2767799377441406e+01 -2.7069000244140625e+02 5.1451099395751953e+01 -6.7129501342773438e+01 -2.6811001586914062e+02 4.7932498931884766e+01 -7.2767799377441406e+01 -2.6644702148437500e+02 5.0300098419189453e+01 -6.7129501342773438e+01 -2.6540802001953125e+02 4.9628898620605469e+01 -6.7129501342773438e+01 -2.6383297729492188e+02 4.5932399749755859e+01 -7.2767799377441406e+01 -2.6235601806640625e+02 4.7468402862548828e+01 -6.7129501342773438e+01 -2.5971600341796875e+02 4.3601402282714844e+01 -7.2767799377441406e+01 -2.5844400024414062e+02 4.5768299102783203e+01 -6.7129501342773438e+01 -2.5702801513671875e+02 4.4983699798583984e+01 -6.7129501342773438e+01 -2.5578698730468750e+02 4.0955200195312500e+01 -7.2767799377441406e+01 -2.5473800659179688e+02 4.2190898895263672e+01 -6.7129501342773438e+01 -2.5207099914550781e+02 3.8012100219726562e+01 -7.2767799377441406e+01 -2.5126298522949219e+02 3.9919296264648438e+01 -6.7129501342773438e+01 -2.4950599670410156e+02 3.9108100891113281e+01 -6.7129501342773438e+01 -2.4859100341796875e+02 3.4791999816894531e+01 -7.2767799377441406e+01 -2.4804299926757812e+02 3.5755397796630859e+01 -6.7129501342773438e+01 -2.4536999511718750e+02 3.1316999435424805e+01 -7.2767799377441406e+01 -2.4510000610351562e+02 3.2912197113037109e+01 -6.7129501342773438e+01 -2.4304899597167969e+02 3.2154300689697266e+01 -6.7129501342773438e+01 -2.4243000793457031e+02 2.7610898971557617e+01 -7.2767799377441406e+01 -2.4245401000976562e+02 2.8328300476074219e+01 -6.7129501342773438e+01 -2.3978900146484375e+02 2.3698799133300781e+01 -7.2767799377441406e+01 -2.4012300109863281e+02 2.4937799453735352e+01 -6.7129501342773438e+01 -2.3783200073242188e+02 2.4302299499511719e+01 -6.7129501342773438e+01 -2.3746499633789062e+02 1.9607700347900391e+01 -7.2767799377441406e+01 -2.3812199401855469e+02 2.0102199554443359e+01 -6.7129501342773438e+01 -2.3547200012207031e+02 1.5365300178527832e+01 -7.2767799377441406e+01 -2.3646701049804688e+02 1.6212800979614258e+01 -6.7129501342773438e+01 -2.3399700927734375e+02 1.5755399703979492e+01 -6.7129501342773438e+01 -2.3382299804687500e+02 1.1000800132751465e+01 -7.2767799377441406e+01 -2.3516799926757812e+02 1.1289999961853027e+01 -6.7129501342773438e+01 -2.3252999877929688e+02 6.5437998771667480e+00 -7.2767799377441406e+01 -2.3423300170898438e+02 6.9746999740600586e+00 -6.7129501342773438e+01 -2.3164900207519531e+02 6.7350997924804688e+00 -6.7129501342773438e+01 -2.3160000610351562e+02 2.0249900817871094e+00 -7.2767799377441406e+01 -2.3366999816894531e+02 2.1201000213623047e+00 -6.7129501342773438e+01 -2.3104000854492188e+02 -2.5249898433685303e+00 -7.2767799377441406e+01 -2.3348200988769531e+02 -2.5249898433685303e+00 -6.7129501342773438e+01 -2.3085301208496094e+02 -7.1701998710632324e+00 -6.7129501342773438e+01 -2.3104000854492188e+02 -1.6470399856567383e+01 -6.5548194885253906e+01 -3.4515899658203125e+02 -2.0977899551391602e+01 -6.5548194885253906e+01 -3.4385299682617188e+02 -2.5365699768066406e+01 -6.5548194885253906e+01 -3.4218902587890625e+02 -2.9605400085449219e+01 -6.5548194885253906e+01 -3.4017700195312500e+02 -3.3669399261474609e+01 -6.5548194885253906e+01 -3.3783099365234375e+02 -3.7531398773193359e+01 -6.5548194885253906e+01 -3.3516500854492188e+02 -4.1166500091552734e+01 -6.5548194885253906e+01 -3.3219702148437500e+02 -4.4550899505615234e+01 -6.5548194885253906e+01 -3.2894598388671875e+02 -4.7662799835205078e+01 -6.5548194885253906e+01 -3.2543399047851562e+02 -5.0481899261474609e+01 -6.5548194885253906e+01 -3.2168200683593750e+02 -5.2990001678466797e+01 -6.5548194885253906e+01 -3.1771600341796875e+02 -5.5170799255371094e+01 -6.5548194885253906e+01 -3.1356100463867188e+02 -5.7010200500488281e+01 -6.5548194885253906e+01 -3.0924401855468750e+02 -5.8496299743652344e+01 -6.5548194885253906e+01 -3.0479199218750000e+02 -5.9619400024414062e+01 -6.5548194885253906e+01 -3.0023599243164062e+02 -6.0372100830078125e+01 -6.5548194885253906e+01 -2.9560400390625000e+02 -6.0749698638916016e+01 -6.5548194885253906e+01 -2.9092599487304688e+02 -6.0749698638916016e+01 -6.5548194885253906e+01 -2.8623397827148438e+02 -6.0372100830078125e+01 -6.5548194885253906e+01 -2.8155599975585938e+02 -5.8496299743652344e+01 -6.5548194885253906e+01 -2.7236801147460938e+02 -5.9619400024414062e+01 -6.5548194885253906e+01 -2.7692401123046875e+02 -5.7010200500488281e+01 -6.5548194885253906e+01 -2.6791598510742188e+02 -5.5170799255371094e+01 -6.5548194885253906e+01 -2.6359899902343750e+02 -5.0481899261474609e+01 -6.5548194885253906e+01 -2.5547799682617188e+02 -5.2990001678466797e+01 -6.5548194885253906e+01 -2.5944400024414062e+02 -4.7662799835205078e+01 -6.5548194885253906e+01 -2.5172599792480469e+02 -4.4550899505615234e+01 -6.5548194885253906e+01 -2.4821400451660156e+02 -3.7531398773193359e+01 -6.5548194885253906e+01 -2.4199501037597656e+02 -4.1166500091552734e+01 -6.5548194885253906e+01 -2.4496301269531250e+02 -3.3669399261474609e+01 -6.5548194885253906e+01 -2.3932899475097656e+02 -2.9605400085449219e+01 -6.5548194885253906e+01 -2.3698300170898438e+02 -2.5365699768066406e+01 -6.5548194885253906e+01 -2.3497100830078125e+02 -2.0977899551391602e+01 -6.5548194885253906e+01 -2.3330700683593750e+02 -1.6470399856567383e+01 -6.5548194885253906e+01 -2.3200100708007812e+02 -1.1872500419616699e+01 -6.5548194885253906e+01 -2.3106298828125000e+02 -7.2139997482299805e+00 -6.5548194885253906e+01 -2.3049700927734375e+02 -2.5249898433685303e+00 -6.5548194885253906e+01 -2.3030799865722656e+02 2.1639001369476318e+00 -6.5548194885253906e+01 -2.3049700927734375e+02 6.8224101066589355e+00 -6.5548194885253906e+01 -2.3106298828125000e+02 1.1420300483703613e+01 -6.5548194885253906e+01 -2.3200100708007812e+02 1.5927801132202148e+01 -6.5548194885253906e+01 -2.3330700683593750e+02 2.0315601348876953e+01 -6.5548194885253906e+01 -2.3497100830078125e+02 2.4555299758911133e+01 -6.5548194885253906e+01 -2.3698300170898438e+02 2.8619300842285156e+01 -6.5548194885253906e+01 -2.3932899475097656e+02 3.2481399536132812e+01 -6.5548194885253906e+01 -2.4199501037597656e+02 3.6116397857666016e+01 -6.5548194885253906e+01 -2.4496301269531250e+02 3.9500900268554688e+01 -6.5548194885253906e+01 -2.4821400451660156e+02 4.2612701416015625e+01 -6.5548194885253906e+01 -2.5172599792480469e+02 4.5431800842285156e+01 -6.5548194885253906e+01 -2.5547799682617188e+02 4.7940002441406250e+01 -6.5548194885253906e+01 -2.5944400024414062e+02 5.0120800018310547e+01 -6.5548194885253906e+01 -2.6359899902343750e+02 5.1960201263427734e+01 -6.5548194885253906e+01 -2.6791598510742188e+02 5.3446300506591797e+01 -6.5548194885253906e+01 -2.7236801147460938e+02 5.4569301605224609e+01 -6.5548194885253906e+01 -2.7692401123046875e+02 5.5322097778320312e+01 -6.5548194885253906e+01 -2.8155599975585938e+02 5.5699699401855469e+01 -6.5548194885253906e+01 -2.8623397827148438e+02 5.5699699401855469e+01 -6.5548194885253906e+01 -2.9092599487304688e+02 5.5322097778320312e+01 -6.5548194885253906e+01 -2.9560400390625000e+02 5.3446300506591797e+01 -6.5548194885253906e+01 -3.0479199218750000e+02 5.4569301605224609e+01 -6.5548194885253906e+01 -3.0023599243164062e+02 5.1960201263427734e+01 -6.5548194885253906e+01 -3.0924401855468750e+02 5.0120800018310547e+01 -6.5548194885253906e+01 -3.1356100463867188e+02 4.5431800842285156e+01 -6.5548194885253906e+01 -3.2168200683593750e+02 4.7940002441406250e+01 -6.5548194885253906e+01 -3.1771600341796875e+02 4.2612701416015625e+01 -6.5548194885253906e+01 -3.2543399047851562e+02 3.9500900268554688e+01 -6.5548194885253906e+01 -3.2894598388671875e+02 3.2481399536132812e+01 -6.5548194885253906e+01 -3.3516500854492188e+02 3.6116397857666016e+01 -6.5548194885253906e+01 -3.3219702148437500e+02 2.8619300842285156e+01 -6.5548194885253906e+01 -3.3783099365234375e+02 2.4555299758911133e+01 -6.5548194885253906e+01 -3.4017700195312500e+02 2.0315601348876953e+01 -6.5548194885253906e+01 -3.4218902587890625e+02 1.5927801132202148e+01 -6.5548194885253906e+01 -3.4385299682617188e+02 1.1420300483703613e+01 -6.5548194885253906e+01 -3.4515899658203125e+02 6.8224101066589355e+00 -6.5548194885253906e+01 -3.4609698486328125e+02 2.1639001369476318e+00 -6.5548194885253906e+01 -3.4666299438476562e+02 -2.5249898433685303e+00 -6.5548194885253906e+01 -3.4685198974609375e+02 -7.2139997482299805e+00 -6.5548194885253906e+01 -3.4666299438476562e+02 -1.1872500419616699e+01 -6.5548194885253906e+01 -3.4609698486328125e+02 -1.1328700065612793e+01 -7.4288002014160156e+01 -3.4133700561523438e+02 -1.5655299186706543e+01 -7.4288002014160156e+01 -3.4042999267578125e+02 -1.9892200469970703e+01 -7.4288002014160156e+01 -3.3916900634765625e+02 -2.4010499954223633e+01 -7.4288002014160156e+01 -3.3756198120117188e+02 -2.7982000350952148e+01 -7.4288002014160156e+01 -3.3561999511718750e+02 -3.1779598236083984e+01 -7.4288002014160156e+01 -3.3335800170898438e+02 -3.5377403259277344e+01 -7.4288002014160156e+01 -3.3078900146484375e+02 -3.8750801086425781e+01 -7.4288002014160156e+01 -3.2793200683593750e+02 -4.1876701354980469e+01 -7.4288002014160156e+01 -3.2480599975585938e+02 -4.4733699798583984e+01 -7.4288002014160156e+01 -3.2143200683593750e+02 -4.7302497863769531e+01 -7.4288002014160156e+01 -3.1783499145507812e+02 -4.9565399169921875e+01 -7.4288002014160156e+01 -3.1403698730468750e+02 -5.1506900787353516e+01 -7.4288002014160156e+01 -3.1006600952148438e+02 -5.3113899230957031e+01 -7.4288002014160156e+01 -3.0594699096679688e+02 -5.4375297546386719e+01 -7.4288002014160156e+01 -3.0171002197265625e+02 -5.5282501220703125e+01 -7.4288002014160156e+01 -2.9738400268554688e+02 -5.5829299926757812e+01 -7.4288002014160156e+01 -2.9299700927734375e+02 -5.6012001037597656e+01 -7.4288002014160156e+01 -2.8857998657226562e+02 -5.5829299926757812e+01 -7.4288002014160156e+01 -2.8416299438476562e+02 -5.5282501220703125e+01 -7.4288002014160156e+01 -2.7977600097656250e+02 -5.4375297546386719e+01 -7.4288002014160156e+01 -2.7544998168945312e+02 -5.3113899230957031e+01 -7.4288002014160156e+01 -2.7121298217773438e+02 -5.1506900787353516e+01 -7.4288002014160156e+01 -2.6709500122070312e+02 -4.9565399169921875e+01 -7.4288002014160156e+01 -2.6312301635742188e+02 -4.7302497863769531e+01 -7.4288002014160156e+01 -2.5932501220703125e+02 -4.4733699798583984e+01 -7.4288002014160156e+01 -2.5572801208496094e+02 -4.1876701354980469e+01 -7.4288002014160156e+01 -2.5235398864746094e+02 -3.8750801086425781e+01 -7.4288002014160156e+01 -2.4922799682617188e+02 -3.5377403259277344e+01 -7.4288002014160156e+01 -2.4637100219726562e+02 -3.1779598236083984e+01 -7.4288002014160156e+01 -2.4380200195312500e+02 -2.7982000350952148e+01 -7.4288002014160156e+01 -2.4153999328613281e+02 -2.4010499954223633e+01 -7.4288002014160156e+01 -2.3959800720214844e+02 -1.9892200469970703e+01 -7.4288002014160156e+01 -2.3799101257324219e+02 -1.5655299186706543e+01 -7.4288002014160156e+01 -2.3672999572753906e+02 -1.1328700065612793e+01 -7.4288002014160156e+01 -2.3582200622558594e+02 -6.9419002532958984e+00 -7.4288002014160156e+01 -2.3527600097656250e+02 -2.5249898433685303e+00 -7.4288002014160156e+01 -2.3509300231933594e+02 1.8918999433517456e+00 -7.4288002014160156e+01 -2.3527600097656250e+02 6.2786898612976074e+00 -7.4288002014160156e+01 -2.3582200622558594e+02 1.0605199813842773e+01 -7.4288002014160156e+01 -2.3672999572753906e+02 1.4842200279235840e+01 -7.4288002014160156e+01 -2.3799101257324219e+02 1.8960399627685547e+01 -7.4288002014160156e+01 -2.3959800720214844e+02 2.2932001113891602e+01 -7.4288002014160156e+01 -2.4153999328613281e+02 2.6729499816894531e+01 -7.4288002014160156e+01 -2.4380200195312500e+02 3.0327299118041992e+01 -7.4288002014160156e+01 -2.4637100219726562e+02 3.3700702667236328e+01 -7.4288002014160156e+01 -2.4922799682617188e+02 3.6826599121093750e+01 -7.4288002014160156e+01 -2.5235398864746094e+02 3.9683700561523438e+01 -7.4288002014160156e+01 -2.5572801208496094e+02 4.2252399444580078e+01 -7.4288002014160156e+01 -2.5932501220703125e+02 4.4515300750732422e+01 -7.4288002014160156e+01 -2.6312301635742188e+02 4.6456897735595703e+01 -7.4288002014160156e+01 -2.6709500122070312e+02 4.8063800811767578e+01 -7.4288002014160156e+01 -2.7121298217773438e+02 5.0232398986816406e+01 -7.4288002014160156e+01 -2.7977600097656250e+02 4.9325298309326172e+01 -7.4288002014160156e+01 -2.7544998168945312e+02 5.0779201507568359e+01 -7.4288002014160156e+01 -2.8416299438476562e+02 5.0961898803710938e+01 -7.4288002014160156e+01 -2.8857998657226562e+02 5.0779201507568359e+01 -7.4288002014160156e+01 -2.9299700927734375e+02 5.0232398986816406e+01 -7.4288002014160156e+01 -2.9738400268554688e+02 4.9325298309326172e+01 -7.4288002014160156e+01 -3.0171002197265625e+02 4.8063800811767578e+01 -7.4288002014160156e+01 -3.0594699096679688e+02 4.6456897735595703e+01 -7.4288002014160156e+01 -3.1006600952148438e+02 4.4515300750732422e+01 -7.4288002014160156e+01 -3.1403698730468750e+02 4.2252399444580078e+01 -7.4288002014160156e+01 -3.1783499145507812e+02 3.9683700561523438e+01 -7.4288002014160156e+01 -3.2143200683593750e+02 3.6826599121093750e+01 -7.4288002014160156e+01 -3.2480599975585938e+02 3.3700702667236328e+01 -7.4288002014160156e+01 -3.2793200683593750e+02 3.0327299118041992e+01 -7.4288002014160156e+01 -3.3078900146484375e+02 2.6729499816894531e+01 -7.4288002014160156e+01 -3.3335800170898438e+02 2.2932001113891602e+01 -7.4288002014160156e+01 -3.3561999511718750e+02 1.8960399627685547e+01 -7.4288002014160156e+01 -3.3756198120117188e+02 1.4842200279235840e+01 -7.4288002014160156e+01 -3.3916900634765625e+02 1.0605199813842773e+01 -7.4288002014160156e+01 -3.4042999267578125e+02 6.2786898612976074e+00 -7.4288002014160156e+01 -3.4133700561523438e+02 1.8918999433517456e+00 -7.4288002014160156e+01 -3.4188397216796875e+02 -2.5249898433685303e+00 -7.4288002014160156e+01 -3.4206701660156250e+02 -6.9419002532958984e+00 -7.4288002014160156e+01 -3.4188397216796875e+02 1.9704000949859619e+00 -7.3682098388671875e+01 -3.4283200073242188e+02 -2.5249898433685303e+00 -7.3682098388671875e+01 -3.4301800537109375e+02 -7.0205001831054688e+00 -7.3682098388671875e+01 -3.4283200073242188e+02 -1.1485300064086914e+01 -7.3682098388671875e+01 -3.4227600097656250e+02 -1.5888800621032715e+01 -7.3682098388671875e+01 -3.4135198974609375e+02 -2.0201000213623047e+01 -7.3682098388671875e+01 -3.4006802368164062e+02 -2.4392499923706055e+01 -7.3682098388671875e+01 -3.3843298339843750e+02 -2.8434700012207031e+01 -7.3682098388671875e+01 -3.3645700073242188e+02 -3.2299800872802734e+01 -7.3682098388671875e+01 -3.3415402221679688e+02 -3.5961597442626953e+01 -7.3682098388671875e+01 -3.3153900146484375e+02 -3.9394901275634766e+01 -7.3682098388671875e+01 -3.2863101196289062e+02 -4.2576396942138672e+01 -7.3682098388671875e+01 -3.2545001220703125e+02 -4.5484302520751953e+01 -7.3682098388671875e+01 -3.2201702880859375e+02 -4.8098697662353516e+01 -7.3682098388671875e+01 -3.1835498046875000e+02 -5.0401901245117188e+01 -7.3682098388671875e+01 -3.1448999023437500e+02 -5.2377899169921875e+01 -7.3682098388671875e+01 -3.1044799804687500e+02 -5.4013500213623047e+01 -7.3682098388671875e+01 -3.0625598144531250e+02 -5.5297298431396484e+01 -7.3682098388671875e+01 -3.0194400024414062e+02 -5.6220600128173828e+01 -7.3682098388671875e+01 -2.9754000854492188e+02 -5.6777202606201172e+01 -7.3682098388671875e+01 -2.9307498168945312e+02 -5.6963100433349609e+01 -7.3682098388671875e+01 -2.8857998657226562e+02 -5.6777202606201172e+01 -7.3682098388671875e+01 -2.8408499145507812e+02 -5.6220600128173828e+01 -7.3682098388671875e+01 -2.7961999511718750e+02 -5.5297298431396484e+01 -7.3682098388671875e+01 -2.7521600341796875e+02 -5.4013500213623047e+01 -7.3682098388671875e+01 -2.7090399169921875e+02 -5.2377899169921875e+01 -7.3682098388671875e+01 -2.6671200561523438e+02 -5.0401901245117188e+01 -7.3682098388671875e+01 -2.6267001342773438e+02 -4.8098697662353516e+01 -7.3682098388671875e+01 -2.5880499267578125e+02 -4.5484302520751953e+01 -7.3682098388671875e+01 -2.5514299011230469e+02 -4.2576396942138672e+01 -7.3682098388671875e+01 -2.5170999145507812e+02 -3.9394901275634766e+01 -7.3682098388671875e+01 -2.4852900695800781e+02 -3.5961597442626953e+01 -7.3682098388671875e+01 -2.4562100219726562e+02 -3.2299800872802734e+01 -7.3682098388671875e+01 -2.4300601196289062e+02 -2.8434700012207031e+01 -7.3682098388671875e+01 -2.4070300292968750e+02 -2.4392499923706055e+01 -7.3682098388671875e+01 -2.3872700500488281e+02 -2.0201000213623047e+01 -7.3682098388671875e+01 -2.3709201049804688e+02 -1.5888800621032715e+01 -7.3682098388671875e+01 -2.3580799865722656e+02 -1.1485300064086914e+01 -7.3682098388671875e+01 -2.3488398742675781e+02 -7.0205001831054688e+00 -7.3682098388671875e+01 -2.3432800292968750e+02 -2.5249898433685303e+00 -7.3682098388671875e+01 -2.3414199829101562e+02 1.9704000949859619e+00 -7.3682098388671875e+01 -2.3432800292968750e+02 6.4352002143859863e+00 -7.3682098388671875e+01 -2.3488398742675781e+02 1.0838700294494629e+01 -7.3682098388671875e+01 -2.3580799865722656e+02 1.5151000022888184e+01 -7.3682098388671875e+01 -2.3709201049804688e+02 1.9342500686645508e+01 -7.3682098388671875e+01 -2.3872700500488281e+02 2.3384601593017578e+01 -7.3682098388671875e+01 -2.4070300292968750e+02 2.7249799728393555e+01 -7.3682098388671875e+01 -2.4300601196289062e+02 3.0911499023437500e+01 -7.3682098388671875e+01 -2.4562100219726562e+02 3.4344902038574219e+01 -7.3682098388671875e+01 -2.4852900695800781e+02 3.7526298522949219e+01 -7.3682098388671875e+01 -2.5170999145507812e+02 4.0434299468994141e+01 -7.3682098388671875e+01 -2.5514299011230469e+02 4.3048698425292969e+01 -7.3682098388671875e+01 -2.5880499267578125e+02 4.5351799011230469e+01 -7.3682098388671875e+01 -2.6267001342773438e+02 4.7327899932861328e+01 -7.3682098388671875e+01 -2.6671200561523438e+02 4.8963401794433594e+01 -7.3682098388671875e+01 -2.7090399169921875e+02 5.0247200012207031e+01 -7.3682098388671875e+01 -2.7521600341796875e+02 5.1170597076416016e+01 -7.3682098388671875e+01 -2.7961999511718750e+02 5.1727100372314453e+01 -7.3682098388671875e+01 -2.8408499145507812e+02 5.1913002014160156e+01 -7.3682098388671875e+01 -2.8857998657226562e+02 5.1727100372314453e+01 -7.3682098388671875e+01 -2.9307498168945312e+02 5.1170597076416016e+01 -7.3682098388671875e+01 -2.9754000854492188e+02 5.0247200012207031e+01 -7.3682098388671875e+01 -3.0194400024414062e+02 4.8963401794433594e+01 -7.3682098388671875e+01 -3.0625598144531250e+02 4.7327899932861328e+01 -7.3682098388671875e+01 -3.1044799804687500e+02 4.5351799011230469e+01 -7.3682098388671875e+01 -3.1448999023437500e+02 4.3048698425292969e+01 -7.3682098388671875e+01 -3.1835498046875000e+02 4.0434299468994141e+01 -7.3682098388671875e+01 -3.2201702880859375e+02 3.7526298522949219e+01 -7.3682098388671875e+01 -3.2545001220703125e+02 3.4344902038574219e+01 -7.3682098388671875e+01 -3.2863101196289062e+02 3.0911499023437500e+01 -7.3682098388671875e+01 -3.3153900146484375e+02 2.7249799728393555e+01 -7.3682098388671875e+01 -3.3415402221679688e+02 2.3384601593017578e+01 -7.3682098388671875e+01 -3.3645700073242188e+02 1.9342500686645508e+01 -7.3682098388671875e+01 -3.3843298339843750e+02 1.5151000022888184e+01 -7.3682098388671875e+01 -3.4006802368164062e+02 1.0838700294494629e+01 -7.3682098388671875e+01 -3.4135198974609375e+02 6.4352002143859863e+00 -7.3682098388671875e+01 -3.4227600097656250e+02 -2.4593200683593750e+01 -7.4306999206542969e+01 -2.7671099853515625e+02 -2.4595399856567383e+01 -7.3886001586914062e+01 -2.7672500610351562e+02 -2.4312398910522461e+01 -7.4306999206542969e+01 -2.7675698852539062e+02 -2.4304300308227539e+01 -7.3886001586914062e+01 -2.7677301025390625e+02 -2.3848199844360352e+01 -7.4306999206542969e+01 -2.7684100341796875e+02 -2.4013898849487305e+01 -7.3886001586914062e+01 -2.7682501220703125e+02 -2.3859600067138672e+01 -7.4011604309082031e+01 -2.7684997558593750e+02 -2.3864500045776367e+01 -7.3886001586914062e+01 -2.7685299682617188e+02 -2.3801900863647461e+01 -7.4306999206542969e+01 -2.7975601196289062e+02 -2.3526599884033203e+01 -7.4306999206542969e+01 -2.7727801513671875e+02 -2.3810699462890625e+01 -7.4017501831054688e+01 -2.7974398803710938e+02 -2.3537900924682617e+01 -7.4011604309082031e+01 -2.7728598022460938e+02 -2.3814701080322266e+01 -7.3886001586914062e+01 -2.7973800659179688e+02 -2.3542699813842773e+01 -7.3886001586914062e+01 -2.7728997802734375e+02 -2.4444398880004883e+01 -7.4306999206542969e+01 -2.8007400512695312e+02 -2.4273698806762695e+01 -7.4306999206542969e+01 -2.8010400390625000e+02 -2.4441999435424805e+01 -7.3886001586914062e+01 -2.8005902099609375e+02 -2.4281999588012695e+01 -7.4017501831054688e+01 -2.8009201049804688e+02 -2.4285800933837891e+01 -7.3886001586914062e+01 -2.8008700561523438e+02 -2.4618000030517578e+01 -7.4306999206542969e+01 -2.8004901123046875e+02 -2.4598701477050781e+01 -7.3886001586914062e+01 -2.8003601074218750e+02 -2.4792798995971680e+01 -7.4306999206542969e+01 -2.8003201293945312e+02 -2.4755901336669922e+01 -7.3886001586914062e+01 -2.8001998901367188e+02 -2.4968299865722656e+01 -7.4306999206542969e+01 -2.8002398681640625e+02 -2.4913499832153320e+01 -7.3886001586914062e+01 -2.8001098632812500e+02 -2.5060800552368164e+01 -7.4306999206542969e+01 -2.8002200317382812e+02 -2.5060600280761719e+01 -7.3886001586914062e+01 -2.8000799560546875e+02 -2.5161199569702148e+01 -7.4306999206542969e+01 -2.8002200317382812e+02 -2.5127399444580078e+01 -7.3886001586914062e+01 -2.8000701904296875e+02 -2.6075300216674805e+01 -7.4306999206542969e+01 -2.8015399169921875e+02 -2.6079399108886719e+01 -7.3886001586914062e+01 -2.8014001464843750e+02 -2.6082599639892578e+01 -7.4306999206542969e+01 -2.8015499877929688e+02 -2.6086500167846680e+01 -7.3886001586914062e+01 -2.8014099121093750e+02 -2.6925100326538086e+01 -7.4306999206542969e+01 -2.8056600952148438e+02 -2.6933700561523438e+01 -7.3886001586914062e+01 -2.8055398559570312e+02 -2.7923700332641602e+01 -7.3886001586914062e+01 -2.8220800781250000e+02 -2.7909299850463867e+01 -7.4306999206542969e+01 -2.8221099853515625e+02 -2.7824800491333008e+01 -7.3886001586914062e+01 -2.8181298828125000e+02 -2.7789300918579102e+01 -7.4306999206542969e+01 -2.8175299072265625e+02 -2.7556900024414062e+01 -7.3886001586914062e+01 -2.8126300048828125e+02 -2.7541999816894531e+01 -7.4306999206542969e+01 -2.8127200317382812e+02 -2.7479900360107422e+01 -7.3886093139648438e+01 -2.8110501098632812e+02 -2.7440599441528320e+01 -7.4306999206542969e+01 -2.8107501220703125e+02 -2.7027700424194336e+01 -7.3886001586914062e+01 -2.8064901733398438e+02 -2.7019699096679688e+01 -7.4306999206542969e+01 -2.8065899658203125e+02 -2.8144899368286133e+01 -7.4306999206542969e+01 -2.8359500122070312e+02 -2.8162300109863281e+01 -7.3886001586914062e+01 -2.8360998535156250e+02 -2.5559099197387695e+01 -7.4306999206542969e+01 -2.8359500122070312e+02 -2.5576499938964844e+01 -7.3886001586914062e+01 -2.8360998535156250e+02 -2.5165300369262695e+01 -7.4306999206542969e+01 -2.8406399536132812e+02 -2.5182699203491211e+01 -7.3886001586914062e+01 -2.8407897949218750e+02 -2.5565401077270508e+01 -7.4306999206542969e+01 -2.8635598754882812e+02 -2.5577800750732422e+01 -7.3886001586914062e+01 -2.8634197998046875e+02 -2.5959199905395508e+01 -7.4306999206542969e+01 -2.8668698120117188e+02 -2.5971601486206055e+01 -7.3886001586914062e+01 -2.8667300415039062e+02 -2.8670101165771484e+01 -7.4306999206542969e+01 -2.8668698120117188e+02 -2.8682399749755859e+01 -7.3886001586914062e+01 -2.8667300415039062e+02 -3.0824499130249023e+01 -7.4306999206542969e+01 -2.9910000610351562e+02 -3.0836799621582031e+01 -7.3886001586914062e+01 -2.9908499145507812e+02 -3.1218299865722656e+01 -7.4306999206542969e+01 -2.9943200683593750e+02 -3.1230699539184570e+01 -7.3886001586914062e+01 -2.9941699218750000e+02 -3.4553298950195312e+01 -7.4306999206542969e+01 -2.9943200683593750e+02 -3.4535800933837891e+01 -7.3886001586914062e+01 -2.9941699218750000e+02 -3.4947101593017578e+01 -7.4306999206542969e+01 -2.9896301269531250e+02 -3.4929698944091797e+01 -7.3886001586914062e+01 -2.9894900512695312e+02 -3.2816497802734375e+01 -7.4306999206542969e+01 -2.8668698120117188e+02 -3.2799003601074219e+01 -7.3886001586914062e+01 -2.8667300415039062e+02 -3.4626098632812500e+01 -7.4306999206542969e+01 -2.8668698120117188e+02 -3.4608600616455078e+01 -7.3886001586914062e+01 -2.8667300415039062e+02 -3.5019901275634766e+01 -7.4306999206542969e+01 -2.8621899414062500e+02 -3.5002399444580078e+01 -7.3886001586914062e+01 -2.8620401000976562e+02 -3.4619400024414062e+01 -7.4306999206542969e+01 -2.8392401123046875e+02 -3.4607002258300781e+01 -7.3886001586914062e+01 -2.8393899536132812e+02 -3.4228199005126953e+01 -7.4306999206542969e+01 -2.8359298706054688e+02 -3.4215801239013672e+01 -7.3886001586914062e+01 -2.8360800170898438e+02 -3.2276500701904297e+01 -7.4306999206542969e+01 -2.8358099365234375e+02 -3.2263599395751953e+01 -7.3886001586914062e+01 -2.8359500122070312e+02 -3.2099998474121094e+01 -7.4306999206542969e+01 -2.8221301269531250e+02 -3.2085399627685547e+01 -7.3886001586914062e+01 -2.8221398925781250e+02 -3.1406398773193359e+01 -7.3886001586914062e+01 -2.7985598754882812e+02 -3.1419601440429688e+01 -7.4306999206542969e+01 -2.7984899902343750e+02 -3.1675901412963867e+01 -7.3886001586914062e+01 -2.8048101806640625e+02 -3.1670000076293945e+01 -7.4306999206542969e+01 -2.8042297363281250e+02 -3.1879201889038086e+01 -7.3886001586914062e+01 -2.8112600708007812e+02 -3.1864200592041016e+01 -7.4306999206542969e+01 -2.8101501464843750e+02 -3.0071100234985352e+01 -7.3886001586914062e+01 -2.7808999633789062e+02 -3.0080801010131836e+01 -7.4306999206542969e+01 -2.7807901000976562e+02 -3.0562900543212891e+01 -7.3886001586914062e+01 -2.7858401489257812e+02 -3.0781600952148438e+01 -7.4306999206542969e+01 -2.7882598876953125e+02 -3.1023599624633789e+01 -7.3886001586914062e+01 -2.7918899536132812e+02 -3.1125801086425781e+01 -7.4306999206542969e+01 -2.7932101440429688e+02 -2.8159198760986328e+01 -7.3886001586914062e+01 -2.7698800659179688e+02 -2.8163999557495117e+01 -7.4306999206542969e+01 -2.7697399902343750e+02 -2.8798398971557617e+01 -7.3886001586914062e+01 -2.7725000000000000e+02 -2.9098098754882812e+01 -7.4306999206542969e+01 -2.7738800048828125e+02 -2.9456800460815430e+01 -7.3886001586914062e+01 -2.7762100219726562e+02 -2.9608699798583984e+01 -7.4306999206542969e+01 -2.7770599365234375e+02 -2.7587400436401367e+01 -7.4306999206542969e+01 -2.7680599975585938e+02 -2.7501701354980469e+01 -7.3886001586914062e+01 -2.7680099487304688e+02 -2.6411899566650391e+01 -7.4306999206542969e+01 -2.7662799072265625e+02 -2.5720399856567383e+01 -7.3886001586914062e+01 -2.7662301635742188e+02 -2.5720199584960938e+01 -7.4306999206542969e+01 -2.7660800170898438e+02 -2.6162199020385742e+01 -7.3886001586914062e+01 -2.7662899780273438e+02 -2.6833299636840820e+01 -7.3886001586914062e+01 -2.7668399047851562e+02 -2.4906400680541992e+01 -7.3886001586914062e+01 -2.7668197631835938e+02 -2.4876199722290039e+01 -7.4306999206542969e+01 -2.7667098999023438e+02 -2.5218698501586914e+01 -7.3886001586914062e+01 -2.7665002441406250e+02 -2.5160400390625000e+01 -7.4306999206542969e+01 -2.7663998413085938e+02 -2.5531599044799805e+01 -7.3886001586914062e+01 -2.7663000488281250e+02 -2.5445598602294922e+01 -7.4306999206542969e+01 -2.7661999511718750e+02 -3.1911701202392578e+01 -7.3500000000000000e+01 -2.8399301147460938e+02 -3.4213199615478516e+01 -7.3500000000000000e+01 -2.8400799560546875e+02 -3.4608600616455078e+01 -7.3500000000000000e+01 -2.8627301025390625e+02 -3.2323902130126953e+01 -7.3500000000000000e+01 -2.8627301025390625e+02 -2.8205699920654297e+01 -7.3500000000000000e+01 -2.8169198608398438e+02 -3.1688999176025391e+01 -7.3500000000000000e+01 -2.8226599121093750e+02 -2.8028200149536133e+01 -7.3500000000000000e+01 -2.7736599731445312e+02 -2.8625799179077148e+01 -7.3500000000000000e+01 -2.7761099243164062e+02 -2.7166599273681641e+01 -7.3500000000000000e+01 -2.8022900390625000e+02 -3.1230699539184570e+01 -7.3500000000000000e+01 -2.9901699829101562e+02 -2.9018800735473633e+01 -7.3500000000000000e+01 -2.8627301025390625e+02 -3.4535800933837891e+01 -7.3500000000000000e+01 -2.9901699829101562e+02 -2.5971601486206055e+01 -7.3500000000000000e+01 -2.8627301025390625e+02 -2.5576499938964844e+01 -7.3500000000000000e+01 -2.8400997924804688e+02 -2.8635900497436523e+01 -7.3500000000000000e+01 -2.8400997924804688e+02 -2.8317199707031250e+01 -7.3500000000000000e+01 -2.8213699340820312e+02 -2.9806400299072266e+01 -7.3500000000000000e+01 -2.7838900756835938e+02 -2.7807300567626953e+01 -7.3500000000000000e+01 -2.8087600708007812e+02 -2.9237600326538086e+01 -7.3500000000000000e+01 -2.7795498657226562e+02 -2.6200000762939453e+01 -7.3500000000000000e+01 -2.7975698852539062e+02 -2.5550498962402344e+01 -7.3500000000000000e+01 -2.7702902221679688e+02 -2.5727701187133789e+01 -7.3500000000000000e+01 -2.7702297973632812e+02 -3.1048299789428711e+01 -7.3500000000000000e+01 -2.8003298950195312e+02 -3.1300998687744141e+01 -7.3500000000000000e+01 -2.8061999511718750e+02 -2.6146499633789062e+01 -7.3500000000000000e+01 -2.7702798461914062e+02 -2.6783500671386719e+01 -7.3500000000000000e+01 -2.7707998657226562e+02 -2.7413200378417969e+01 -7.3500000000000000e+01 -2.7719000244140625e+02 -3.0261899948120117e+01 -7.3500000000000000e+01 -2.7884701538085938e+02 -3.0690099716186523e+01 -7.3500000000000000e+01 -2.7941000366210938e+02 -3.1492698669433594e+01 -7.3500000000000000e+01 -2.8122799682617188e+02 -3.1688600540161133e+01 -7.3500000000000000e+01 -2.8226300048828125e+02 -2.5251901626586914e+01 -7.3500000000000000e+01 -2.7704901123046875e+02 -2.5128499984741211e+01 -7.3500000000000000e+01 -2.7960800170898438e+02 -2.4954099655151367e+01 -7.3500000000000000e+01 -2.7707897949218750e+02 -2.5057998657226562e+01 -7.3500000000000000e+01 -2.7960800170898438e+02 -2.4657699584960938e+01 -7.3500000000000000e+01 -2.7711999511718750e+02 -2.4897699356079102e+01 -7.3500000000000000e+01 -2.7961099243164062e+02 -2.4723199844360352e+01 -7.3500000000000000e+01 -2.7962197875976562e+02 -2.4371999740600586e+01 -7.3500000000000000e+01 -2.7716699218750000e+02 -2.4549299240112305e+01 -7.3500000000000000e+01 -2.7963998413085938e+02 -2.4086799621582031e+01 -7.3500000000000000e+01 -2.7721801757812500e+02 -2.4376399993896484e+01 -7.3500000000000000e+01 -2.7966497802734375e+02 -2.3940000534057617e+01 -7.3500000000000000e+01 -2.7724600219726562e+02 -2.4375699996948242e+01 -7.3500000000000000e+01 -2.7966497802734375e+02 -2.4212001800537109e+01 -7.3500000000000000e+01 -2.7969400024414062e+02 -2.2547601699829102e+01 -7.3886001586914062e+01 -2.8572000122070312e+02 -2.2558401107788086e+01 -7.4306999206542969e+01 -2.8571002197265625e+02 -2.3373600006103516e+01 -7.3886001586914062e+01 -2.8675100708007812e+02 -2.3187500000000000e+01 -7.4306999206542969e+01 -2.8646401977539062e+02 -2.3849800109863281e+01 -7.3886001586914062e+01 -2.8752999877929688e+02 -2.3722400665283203e+01 -7.4306999206542969e+01 -2.8727499389648438e+02 -2.4250099182128906e+01 -7.3886001586914062e+01 -2.8835800170898438e+02 -2.4263599395751953e+01 -7.4306999206542969e+01 -2.8835202026367188e+02 -2.0042200088500977e+01 -7.3886001586914062e+01 -2.8392999267578125e+02 -2.0048299789428711e+01 -7.4306999206542969e+01 -2.8391702270507812e+02 -2.1207099914550781e+01 -7.3886001586914062e+01 -2.8457901000976562e+02 -2.0894800186157227e+01 -7.4306999206542969e+01 -2.8436199951171875e+02 -2.1392999649047852e+01 -7.4306999206542969e+01 -2.8470501708984375e+02 -2.1670099258422852e+01 -7.4306999206542969e+01 -2.8489599609375000e+02 -2.1905700683593750e+01 -7.3886001586914062e+01 -2.8510699462890625e+02 -2.1386199951171875e+01 -7.3886001586914062e+01 -2.8471401977539062e+02 -1.9005001068115234e+01 -7.4306999206542969e+01 -2.8354498291015625e+02 -1.8995599746704102e+01 -7.3886001586914062e+01 -2.8355801391601562e+02 -1.8505699157714844e+01 -7.4306999206542969e+01 -2.8345199584960938e+02 -1.8502901077270508e+01 -7.3886001586914062e+01 -2.8346801757812500e+02 -1.7938999176025391e+01 -7.4306999206542969e+01 -2.8334701538085938e+02 -1.7908699035644531e+01 -7.3886001586914062e+01 -2.8335897827148438e+02 -1.6828599929809570e+01 -7.4306999206542969e+01 -2.8330297851562500e+02 -1.6828899383544922e+01 -7.3886001586914062e+01 -2.8331698608398438e+02 -1.6828498840332031e+01 -7.4306999206542969e+01 -2.8330297851562500e+02 -1.3997099876403809e+01 -7.3886001586914062e+01 -2.8399597167968750e+02 -1.3989999771118164e+01 -7.4306999206542969e+01 -2.8398300170898438e+02 -1.4646300315856934e+01 -7.3886001586914062e+01 -2.8369702148437500e+02 -1.4784399986267090e+01 -7.4306999206542969e+01 -2.8363201904296875e+02 -1.5301500320434570e+01 -7.3886001586914062e+01 -2.8351699829101562e+02 -1.5296899795532227e+01 -7.4306999206542969e+01 -2.8350000000000000e+02 -1.5601900100708008e+01 -7.3886001586914062e+01 -2.8343499755859375e+02 -1.5609499931335449e+01 -7.4306999206542969e+01 -2.8341900634765625e+02 -1.6568899154663086e+01 -7.3886001586914062e+01 -2.8332598876953125e+02 -1.3228199958801270e+01 -7.4306999206542969e+01 -2.8448999023437500e+02 -1.3051099777221680e+01 -7.3886001586914062e+01 -2.8465701293945312e+02 -1.2947600364685059e+01 -7.4306999206542969e+01 -2.8475201416015625e+02 -1.2952099800109863e+01 -7.3886001586914062e+01 -2.8475601196289062e+02 -1.2630700111389160e+01 -7.4306999206542969e+01 -2.8504699707031250e+02 -1.2553500175476074e+01 -7.3886001586914062e+01 -2.8515499877929688e+02 -1.2117400169372559e+01 -7.4306999206542969e+01 -2.8570898437500000e+02 -1.2129600524902344e+01 -7.3886001586914062e+01 -2.8571701049804688e+02 -1.1635099411010742e+01 -7.4306999206542969e+01 -2.8660501098632812e+02 -1.1518400192260742e+01 -7.3886001586914062e+01 -2.8693301391601562e+02 -1.1180600166320801e+01 -7.3886001586914062e+01 -2.8818499755859375e+02 -1.1166100502014160e+01 -7.4306999206542969e+01 -2.8818197631835938e+02 -1.1787799835205078e+01 -7.3886001586914062e+01 -2.8631298828125000e+02 -1.1356299400329590e+01 -7.4306999206542969e+01 -2.8737301635742188e+02 -1.1107500076293945e+01 -7.3886001586914062e+01 -2.9108599853515625e+02 -1.1092900276184082e+01 -7.4306999206542969e+01 -2.9108801269531250e+02 -1.1077300071716309e+01 -7.3886001586914062e+01 -2.9079199218750000e+02 -1.1045799255371094e+01 -7.4306999206542969e+01 -2.9058300781250000e+02 -1.1041999816894531e+01 -7.3886001586914062e+01 -2.8948797607421875e+02 -1.1032000541687012e+01 -7.4306999206542969e+01 -2.8937799072265625e+02 -1.1318099975585938e+01 -7.4306999206542969e+01 -2.9254498291015625e+02 -1.1330699920654297e+01 -7.3886001586914062e+01 -2.9252999877929688e+02 -1.1713200569152832e+01 -7.4306999206542969e+01 -2.9288400268554688e+02 -1.1725800514221191e+01 -7.3886001586914062e+01 -2.9286898803710938e+02 -2.1068298339843750e+01 -7.4306999206542969e+01 -2.9288400268554688e+02 -2.1082000732421875e+01 -7.3886001586914062e+01 -2.9286898803710938e+02 -2.1077999114990234e+01 -7.4306999206542969e+01 -2.9321798706054688e+02 -2.1089199066162109e+01 -7.3886001586914062e+01 -2.9300500488281250e+02 -2.1021499633789062e+01 -7.4306999206542969e+01 -2.9388299560546875e+02 -2.1071798324584961e+01 -7.3886001586914062e+01 -2.9361798095703125e+02 -2.0951099395751953e+01 -7.4306999206542969e+01 -2.9420999145507812e+02 -2.0965299606323242e+01 -7.3886001586914062e+01 -2.9421401977539062e+02 -2.0847499847412109e+01 -7.4306999206542969e+01 -2.9453799438476562e+02 -2.0757900238037109e+01 -7.3886001586914062e+01 -2.9478601074218750e+02 -2.0707700729370117e+01 -7.4306999206542969e+01 -2.9485397338867188e+02 -2.0613199234008789e+01 -7.3886001586914062e+01 -2.9505099487304688e+02 -2.0430099487304688e+01 -7.4306999206542969e+01 -2.9528997802734375e+02 -2.0441598892211914e+01 -7.3886001586914062e+01 -2.9529898071289062e+02 -2.0193399429321289e+01 -7.4306999206542969e+01 -2.9555300903320312e+02 -2.0033798217773438e+01 -7.3886001586914062e+01 -2.9571301269531250e+02 -1.9922100067138672e+01 -7.4306999206542969e+01 -2.9577999877929688e+02 -1.9786600112915039e+01 -7.3886001586914062e+01 -2.9588897705078125e+02 -1.9512201309204102e+01 -7.4306999206542969e+01 -2.9602398681640625e+02 -1.9518600463867188e+01 -7.3886001586914062e+01 -2.9603698730468750e+02 -1.9186399459838867e+01 -7.4306999206542969e+01 -2.9615597534179688e+02 -1.9102600097656250e+01 -7.3886001586914062e+01 -2.9619699096679688e+02 -1.8850099563598633e+01 -7.4306999206542969e+01 -2.9624301147460938e+02 -1.8657600402832031e+01 -7.3886001586914062e+01 -2.9629098510742188e+02 -1.8210500717163086e+01 -7.4306999206542969e+01 -2.9630999755859375e+02 -1.8206001281738281e+01 -7.3886001586914062e+01 -2.9632501220703125e+02 -1.8205600738525391e+01 -7.4306999206542969e+01 -2.9630999755859375e+02 -1.7931699752807617e+01 -7.4306999206542969e+01 -2.9631399536132812e+02 -1.7761400222778320e+01 -7.3886001586914062e+01 -2.9632299804687500e+02 -1.7277700424194336e+01 -7.4306999206542969e+01 -2.9626101684570312e+02 -1.7158899307250977e+01 -7.3886001586914062e+01 -2.9625698852539062e+02 -1.6634799957275391e+01 -7.4306999206542969e+01 -2.9611599731445312e+02 -1.6573301315307617e+01 -7.3886001586914062e+01 -2.9611300659179688e+02 -1.6019899368286133e+01 -7.4306999206542969e+01 -2.9587701416015625e+02 -1.6013500213623047e+01 -7.3886001586914062e+01 -2.9589099121093750e+02 -1.4529700279235840e+01 -7.4017303466796875e+01 -2.9488400268554688e+02 -1.4529000282287598e+01 -7.4306999206542969e+01 -2.9486901855468750e+02 -1.4977600097656250e+01 -7.4306999206542969e+01 -2.9524200439453125e+02 -1.5455500602722168e+01 -7.4306999206542969e+01 -2.9556997680664062e+02 -1.5484600067138672e+01 -7.3886001586914062e+01 -2.9560501098632812e+02 -1.4986200332641602e+01 -7.3886001586914062e+01 -2.9526699829101562e+02 -1.4530099868774414e+01 -7.3886001586914062e+01 -2.9488998413085938e+02 -1.3948599815368652e+01 -7.3886001586914062e+01 -2.9493701171875000e+02 -1.2559800148010254e+01 -7.3886001586914062e+01 -2.9668399047851562e+02 -1.3948100090026855e+01 -7.4017303466796875e+01 -2.9493099975585938e+02 -1.2554399490356445e+01 -7.4007698059082031e+01 -2.9668399047851562e+02 -1.3946900367736816e+01 -7.4306999206542969e+01 -2.9491601562500000e+02 -1.2541199684143066e+01 -7.4306999206542969e+01 -2.9668399047851562e+02 -1.2548600196838379e+01 -7.4007698059082031e+01 -2.9717401123046875e+02 -1.2554100036621094e+01 -7.3886001586914062e+01 -2.9717498779296875e+02 -1.2577300071716309e+01 -7.3886001586914062e+01 -2.9720498657226562e+02 -1.3567500114440918e+01 -7.3886001586914062e+01 -2.9819100952148438e+02 -1.3558600425720215e+01 -7.4306999206542969e+01 -2.9820199584960938e+02 -1.3039899826049805e+01 -7.3886001586914062e+01 -2.9773101806640625e+02 -1.2923699378967285e+01 -7.4306999206542969e+01 -2.9763299560546875e+02 -1.2534999847412109e+01 -7.4306999206542969e+01 -2.9717401123046875e+02 -1.5100800514221191e+01 -7.3886001586914062e+01 -2.9907400512695312e+02 -1.5095099449157715e+01 -7.4306999206542969e+01 -2.9908801269531250e+02 -1.4490700721740723e+01 -7.3886001586914062e+01 -2.9878500366210938e+02 -1.4560000419616699e+01 -7.4306999206542969e+01 -2.9883798217773438e+02 -1.4018599510192871e+01 -7.3886001586914062e+01 -2.9850701904296875e+02 -1.4051899909973145e+01 -7.4306999206542969e+01 -2.9854598999023438e+02 -1.6817399978637695e+01 -7.3886001586914062e+01 -2.9957101440429688e+02 -1.6814901351928711e+01 -7.4306999206542969e+01 -2.9958502197265625e+02 -1.6168199539184570e+01 -7.3886001586914062e+01 -2.9943200683593750e+02 -1.6229499816894531e+01 -7.4306999206542969e+01 -2.9946200561523438e+02 -1.5629500389099121e+01 -7.3886001586914062e+01 -2.9927200317382812e+02 -1.5658300399780273e+01 -7.4306999206542969e+01 -2.9929797363281250e+02 -1.8571199417114258e+01 -7.3886001586914062e+01 -2.9970999145507812e+02 -1.8571498870849609e+01 -7.4306999206542969e+01 -2.9972399902343750e+02 -1.7914400100708008e+01 -7.3886001586914062e+01 -2.9969702148437500e+02 -1.7989400863647461e+01 -7.4306999206542969e+01 -2.9971502685546875e+02 -1.7364500045776367e+01 -7.3886001586914062e+01 -2.9965002441406250e+02 -1.7410999298095703e+01 -7.4306999206542969e+01 -2.9967001342773438e+02 -2.1484800338745117e+01 -7.3886001586914062e+01 -2.9908200073242188e+02 -2.1491001129150391e+01 -7.4306999206542969e+01 -2.9909500122070312e+02 -2.0491600036621094e+01 -7.3886001586914062e+01 -2.9944699096679688e+02 -2.0647001266479492e+01 -7.4306999206542969e+01 -2.9941699218750000e+02 -2.0123699188232422e+01 -7.3886001586914062e+01 -2.9952099609375000e+02 -2.0126798629760742e+01 -7.4306999206542969e+01 -2.9953701782226562e+02 -1.9543201446533203e+01 -7.3886001586914062e+01 -2.9963800048828125e+02 -1.9779800415039062e+01 -7.4306999206542969e+01 -2.9961700439453125e+02 -2.2441299438476562e+01 -7.4306999206542969e+01 -2.9855297851562500e+02 -2.2624698638916016e+01 -7.3886001586914062e+01 -2.9840298461914062e+02 -2.2666299819946289e+01 -7.4306999206542969e+01 -2.9837500000000000e+02 -2.2663200378417969e+01 -7.3886001586914062e+01 -2.9837100219726562e+02 -2.3069198608398438e+01 -7.4306999206542969e+01 -2.9805697631835938e+02 -2.3151199340820312e+01 -7.3886001586914062e+01 -2.9796099853515625e+02 -2.3634899139404297e+01 -7.4306999206542969e+01 -2.9747097778320312e+02 -2.3623600006103516e+01 -7.3886001586914062e+01 -2.9746099853515625e+02 -2.4879098892211914e+01 -7.3886001586914062e+01 -2.9505999755859375e+02 -2.4893301010131836e+01 -7.4306999206542969e+01 -2.9506399536132812e+02 -2.4480798721313477e+01 -7.3886001586914062e+01 -2.9612402343750000e+02 -2.4604900360107422e+01 -7.4306999206542969e+01 -2.9588299560546875e+02 -2.4099800109863281e+01 -7.3886001586914062e+01 -2.9681399536132812e+02 -2.4221900939941406e+01 -7.4306999206542969e+01 -2.9664401245117188e+02 -2.5127500534057617e+01 -7.3886001586914062e+01 -2.9210202026367188e+02 -2.5142099380493164e+01 -7.4306999206542969e+01 -2.9210000610351562e+02 -2.5160999298095703e+01 -7.3886001586914062e+01 -2.9261801147460938e+02 -2.5181499481201172e+01 -7.4306999206542969e+01 -2.9299798583984375e+02 -2.5117399215698242e+01 -7.3886001586914062e+01 -2.9384600830078125e+02 -2.5128000259399414e+01 -7.4306999206542969e+01 -2.9388201904296875e+02 -2.5083501815795898e+01 -7.4306999206542969e+01 -2.9151400756835938e+02 -2.5068899154663086e+01 -7.3886001586914062e+01 -2.9151599121093750e+02 -2.4687299728393555e+01 -7.3886001586914062e+01 -2.8957699584960938e+02 -2.4626800537109375e+01 -7.4306999206542969e+01 -2.8932897949218750e+02 -2.4920900344848633e+01 -7.3886001586914062e+01 -2.9053399658203125e+02 -2.4892900466918945e+01 -7.4306999206542969e+01 -2.9032598876953125e+02 -1.4718299865722656e+01 -7.3500000000000000e+01 -2.9044100952148438e+02 -2.1378900527954102e+01 -7.3500000000000000e+01 -2.9044100952148438e+02 -2.1457599639892578e+01 -7.3500000000000000e+01 -2.9246899414062500e+02 -1.5840999603271484e+01 -7.3500000000000000e+01 -2.9625100708007812e+02 -1.6451799392700195e+01 -7.3500000000000000e+01 -2.9649298095703125e+02 -1.5254399299621582e+01 -7.3500000000000000e+01 -2.9870501708984375e+02 -2.3762800216674805e+01 -7.3500000000000000e+01 -2.9659899902343750e+02 -2.0953599929809570e+01 -7.3500000000000000e+01 -2.9526098632812500e+02 -2.4119400024414062e+01 -7.3500000000000000e+01 -2.9595300292968750e+02 -2.1118499755859375e+01 -7.3500000000000000e+01 -2.9495800781250000e+02 -2.4494800567626953e+01 -7.3500000000000000e+01 -2.9495001220703125e+02 -2.1352001190185547e+01 -7.3500000000000000e+01 -2.9431597900390625e+02 -2.4720100402832031e+01 -7.3500000000000000e+01 -2.9380099487304688e+02 -2.1469499588012695e+01 -7.3500000000000000e+01 -2.9365798950195312e+02 -2.1488700866699219e+01 -7.3500000000000000e+01 -2.9298999023437500e+02 -1.8571199417114258e+01 -7.3500000000000000e+01 -2.8657800292968750e+02 -1.8570899963378906e+01 -7.3500000000000000e+01 -2.8657800292968750e+02 -1.9876800537109375e+01 -7.3500000000000000e+01 -2.8429400634765625e+02 -1.4513599395751953e+01 -7.3500000000000000e+01 -2.8845797729492188e+02 -1.1574200630187988e+01 -7.3500000000000000e+01 -2.8825500488281250e+02 -1.4624499320983887e+01 -7.3500000000000000e+01 -2.8794598388671875e+02 -1.1892899513244629e+01 -7.3500000000000000e+01 -2.8707299804687500e+02 -1.4742700576782227e+01 -7.3500000000000000e+01 -2.8764297485351562e+02 -1.2145300865173340e+01 -7.3500000000000000e+01 -2.8649200439453125e+02 -1.4900400161743164e+01 -7.3500000000000000e+01 -2.8735900878906250e+02 -1.4679499626159668e+01 -7.3500000000000000e+01 -2.9843301391601562e+02 -1.4234899520874023e+01 -7.3500000000000000e+01 -2.9817102050781250e+02 -1.5277099609375000e+01 -7.3500000000000000e+01 -2.9594601440429688e+02 -1.7089599609375000e+01 -7.3500000000000000e+01 -2.9664999389648438e+02 -1.6267898559570312e+01 -7.3500000000000000e+01 -2.9904498291015625e+02 -1.5756299972534180e+01 -7.3500000000000000e+01 -2.9889300537109375e+02 -1.7742500305175781e+01 -7.3500000000000000e+01 -2.9672198486328125e+02 -1.6885299682617188e+01 -7.3500000000000000e+01 -2.9917700195312500e+02 -1.6885099411010742e+01 -7.3500000000000000e+01 -2.9917700195312500e+02 -2.3318099975585938e+01 -7.3500000000000000e+01 -2.9720397949218750e+02 -2.3317899703979492e+01 -7.3500000000000000e+01 -2.9720397949218750e+02 -2.0757200241088867e+01 -7.3500000000000000e+01 -2.9554400634765625e+02 -2.2877000808715820e+01 -7.3500000000000000e+01 -2.9767001342773438e+02 -2.0284099578857422e+01 -7.3500000000000000e+01 -2.9602499389648438e+02 -2.2385499954223633e+01 -7.3500000000000000e+01 -2.9808300781250000e+02 -1.9999300003051758e+01 -7.3500000000000000e+01 -2.9622702026367188e+02 -2.1315299987792969e+01 -7.3500000000000000e+01 -2.9872000122070312e+02 -1.9693700790405273e+01 -7.3500000000000000e+01 -2.9639700317382812e+02 -2.1315200805664062e+01 -7.3500000000000000e+01 -2.9872000122070312e+02 -1.9214199066162109e+01 -7.3500000000000000e+01 -2.9658099365234375e+02 -2.0385499954223633e+01 -7.3500000000000000e+01 -2.9906100463867188e+02 -1.8712200164794922e+01 -7.3500000000000000e+01 -2.9668701171875000e+02 -1.9490200042724609e+01 -7.3500000000000000e+01 -2.9924200439453125e+02 -1.8217298507690430e+01 -7.3500000000000000e+01 -2.9672500610351562e+02 -1.4487000465393066e+01 -7.3500000000000000e+01 -2.8879299926757812e+02 -1.1441400527954102e+01 -7.3500000000000000e+01 -2.8950302124023438e+02 -1.2872699737548828e+01 -7.3500000000000000e+01 -2.9693298339843750e+02 -1.4261500358581543e+01 -7.3500000000000000e+01 -2.9518600463867188e+02 -1.2894200325012207e+01 -7.3500000000000000e+01 -2.9696099853515625e+02 -1.4746200561523438e+01 -7.3500000000000000e+01 -2.9558700561523438e+02 -1.3810000419616699e+01 -7.3500000000000000e+01 -2.9787298583984375e+02 -1.3809899330139160e+01 -7.3500000000000000e+01 -2.9787298583984375e+02 -1.3321899414062500e+01 -7.3500000000000000e+01 -2.9744699096679688e+02 -1.8893201828002930e+01 -7.3500000000000000e+01 -2.8394400024414062e+02 -1.8105798721313477e+01 -7.3500000000000000e+01 -2.8640197753906250e+02 -1.7866600036621094e+01 -7.3500000000000000e+01 -2.8375598144531250e+02 -1.7618900299072266e+01 -7.3500000000000000e+01 -2.8630300903320312e+02 -1.6837301254272461e+01 -7.3500000000000000e+01 -2.8371701049804688e+02 -1.4191400527954102e+01 -7.3500000000000000e+01 -2.8434500122070312e+02 -1.4786399841308594e+01 -7.3500000000000000e+01 -2.8407098388671875e+02 -1.5761500358581543e+01 -7.3500000000000000e+01 -2.8658499145507812e+02 -1.8564599990844727e+01 -7.3500000000000000e+01 -2.9930999755859375e+02 -1.7936800003051758e+01 -7.3500000000000000e+01 -2.9929797363281250e+02 -1.7410200119018555e+01 -7.3500000000000000e+01 -2.9925201416015625e+02 -2.1318799972534180e+01 -7.3500000000000000e+01 -2.9029199218750000e+02 -2.1085800170898438e+01 -7.3500000000000000e+01 -2.8971798706054688e+02 -2.3882501602172852e+01 -7.3500000000000000e+01 -2.8851501464843750e+02 -1.2464400291442871e+01 -7.3500000000000000e+01 -2.8593600463867188e+02 -1.2855299949645996e+01 -7.3500000000000000e+01 -2.8541799926757812e+02 -1.5239899635314941e+01 -7.3500000000000000e+01 -2.8695300292968750e+02 -1.3313899993896484e+01 -7.3500000000000000e+01 -2.8495800781250000e+02 -1.5488200187683105e+01 -7.3500000000000000e+01 -2.8675100708007812e+02 -1.5761199951171875e+01 -7.3500000000000000e+01 -2.8658499145507812e+02 -2.4761499404907227e+01 -7.3500000000000000e+01 -2.9263201904296875e+02 -2.4729499816894531e+01 -7.3500000000000000e+01 -2.9214001464843750e+02 -2.3882400512695312e+01 -7.3500000000000000e+01 -2.8851501464843750e+02 -2.0833200454711914e+01 -7.3500000000000000e+01 -2.8915200805664062e+02 -2.3498699188232422e+01 -7.3500000000000000e+01 -2.8772100830078125e+02 -2.0555000305175781e+01 -7.3500000000000000e+01 -2.8859899902343750e+02 -2.3043600082397461e+01 -7.3500000000000000e+01 -2.8697698974609375e+02 -2.2255699157714844e+01 -7.3500000000000000e+01 -2.8599301147460938e+02 -2.0180900573730469e+01 -7.3500000000000000e+01 -2.8798898315429688e+02 -1.9961299896240234e+01 -7.3500000000000000e+01 -2.8769900512695312e+02 -2.1646699905395508e+01 -7.3500000000000000e+01 -2.8541201782226562e+02 -1.9720998764038086e+01 -7.3500000000000000e+01 -2.8742401123046875e+02 -2.0984201431274414e+01 -7.3500000000000000e+01 -2.8491000366210938e+02 -1.9195400238037109e+01 -7.3500000000000000e+01 -2.8695498657226562e+02 -1.8893600463867188e+01 -7.3500000000000000e+01 -2.8675299072265625e+02 -1.7123300552368164e+01 -7.3500000000000000e+01 -2.8627200317382812e+02 -1.7034599304199219e+01 -7.3500000000000000e+01 -2.8627301025390625e+02 -1.6588098526000977e+01 -7.3500000000000000e+01 -2.8372500610351562e+02 -1.6810499191284180e+01 -7.3500000000000000e+01 -2.8628900146484375e+02 -1.5674600601196289e+01 -7.3500000000000000e+01 -2.8382800292968750e+02 -1.6449699401855469e+01 -7.3500000000000000e+01 -2.8634399414062500e+02 -1.6097400665283203e+01 -7.3500000000000000e+01 -2.8644000244140625e+02 -1.4489299774169922e+01 -7.3500000000000000e+01 -2.8912899780273438e+02 -1.4518200874328613e+01 -7.3500000000000000e+01 -2.8946301269531250e+02 -1.1475500106811523e+01 -7.3500000000000000e+01 -2.9075698852539062e+02 -1.4554799079895020e+01 -7.3500000000000000e+01 -2.8970599365234375e+02 -1.1503700256347656e+01 -7.3500000000000000e+01 -2.9103198242187500e+02 -1.1725800514221191e+01 -7.3500000000000000e+01 -2.9246899414062500e+02 -2.4303600311279297e+01 -7.3500000000000000e+01 -2.8968899536132812e+02 -2.4528600692749023e+01 -7.3500000000000000e+01 -2.9061199951171875e+02 -2.4671100616455078e+01 -7.3500000000000000e+01 -2.9155599975585938e+02 -1.8391401290893555e+01 -7.4306999206542969e+01 -2.8695199584960938e+02 -1.8397800445556641e+01 -7.3886001586914062e+01 -2.8693801879882812e+02 -1.8688199996948242e+01 -7.4306999206542969e+01 -2.8711300659179688e+02 -1.8687000274658203e+01 -7.3886001586914062e+01 -2.8709500122070312e+02 -1.8967998504638672e+01 -7.4306999206542969e+01 -2.8730200195312500e+02 -1.8957199096679688e+01 -7.3886001586914062e+01 -2.8727600097656250e+02 -1.9418901443481445e+01 -7.4306999206542969e+01 -2.8770800781250000e+02 -1.9429599761962891e+01 -7.3886001586914062e+01 -2.8769799804687500e+02 -1.7048000335693359e+01 -7.4306999206542969e+01 -2.8668698120117188e+02 -1.7047500610351562e+01 -7.3886001586914062e+01 -2.8667300415039062e+02 -1.7098300933837891e+01 -7.4306999206542969e+01 -2.8668698120117188e+02 -1.7123300552368164e+01 -7.3886001586914062e+01 -2.8667199707031250e+02 -1.7582201004028320e+01 -7.4306999206542969e+01 -2.8671600341796875e+02 -1.7568099975585938e+01 -7.3886001586914062e+01 -2.8669900512695312e+02 -1.8063100814819336e+01 -7.4306999206542969e+01 -2.8682199096679688e+02 -1.7996101379394531e+01 -7.3886001586914062e+01 -2.8678598022460938e+02 -1.6646900177001953e+01 -7.4306999206542969e+01 -2.8672900390625000e+02 -1.6850299835205078e+01 -7.3886001586914062e+01 -2.8668698120117188e+02 -1.6998800277709961e+01 -7.4306999206542969e+01 -2.8669000244140625e+02 -1.5953799247741699e+01 -7.4306999206542969e+01 -2.8695199584960938e+02 -1.5946999549865723e+01 -7.3886001586914062e+01 -2.8693899536132812e+02 -1.6295600891113281e+01 -7.4306999206542969e+01 -2.8681100463867188e+02 -1.6227899551391602e+01 -7.3886001586914062e+01 -2.8681799316406250e+02 -1.6531101226806641e+01 -7.3886001586914062e+01 -2.8673498535156250e+02 -1.5248199462890625e+01 -7.4306999206542969e+01 -2.8758401489257812e+02 -1.5235800743103027e+01 -7.3886001586914062e+01 -2.8757598876953125e+02 -1.5450900077819824e+01 -7.4306999206542969e+01 -2.8732699584960938e+02 -1.5513299942016602e+01 -7.3886001586914062e+01 -2.8724398803710938e+02 -1.5685100555419922e+01 -7.4306999206542969e+01 -2.8712002563476562e+02 -1.5718000411987305e+01 -7.3886001586914062e+01 -2.8707800292968750e+02 -1.4924900054931641e+01 -7.4306999206542969e+01 -2.8851000976562500e+02 -1.4910300254821777e+01 -7.3886001586914062e+01 -2.8850799560546875e+02 -1.4984799385070801e+01 -7.4306999206542969e+01 -2.8819201660156250e+02 -1.5005400657653809e+01 -7.3886001586914062e+01 -2.8806701660156250e+02 -1.5089499473571777e+01 -7.4306999206542969e+01 -2.8788302612304688e+02 -1.5104800224304199e+01 -7.3886001586914062e+01 -2.8781301879882812e+02 -1.4961500167846680e+01 -7.4306999206542969e+01 -2.8962500000000000e+02 -1.4946999549865723e+01 -7.3886001586914062e+01 -2.8962799072265625e+02 -1.4943699836730957e+01 -7.4306999206542969e+01 -2.8951599121093750e+02 -1.4914899826049805e+01 -7.3886001586914062e+01 -2.8941400146484375e+02 -1.4907499313354492e+01 -7.4306999206542969e+01 -2.8918298339843750e+02 -1.4888600349426270e+01 -7.3886001586914062e+01 -2.8911001586914062e+02 -1.4899999618530273e+01 -7.4306999206542969e+01 -2.8884698486328125e+02 -1.4886500358581543e+01 -7.3886001586914062e+01 -2.8880700683593750e+02 -1.5050700187683105e+01 -7.4306999206542969e+01 -2.9002600097656250e+02 -1.5038900375366211e+01 -7.3886001586914062e+01 -2.9004098510742188e+02 -2.0764301300048828e+01 -7.4306999206542969e+01 -2.9002600097656250e+02 -2.0786001205444336e+01 -7.3886001586914062e+01 -2.9004098510742188e+02 -2.0188899993896484e+01 -7.4306999206542969e+01 -2.8879299926757812e+02 -2.0201898574829102e+01 -7.3886001586914062e+01 -2.8878598022460938e+02 -2.0466400146484375e+01 -7.4306999206542969e+01 -2.8934600830078125e+02 -2.0472000122070312e+01 -7.3886001586914062e+01 -2.8932397460937500e+02 -2.0717899322509766e+01 -7.4306999206542969e+01 -2.8991299438476562e+02 -2.0717000961303711e+01 -7.3886001586914062e+01 -2.8987197875976562e+02 -1.9837299346923828e+01 -7.4306999206542969e+01 -2.8822000122070312e+02 -1.9854299545288086e+01 -7.3886001586914062e+01 -2.8821899414062500e+02 -1.9651298522949219e+01 -7.3886001586914062e+01 -2.8795098876953125e+02 -2.0285800933837891e+01 -7.4500000000000000e+01 -2.8943197631835938e+02 -2.0464200973510742e+01 -7.4500000000000000e+01 -2.8982601928710938e+02 -1.5211000442504883e+01 -7.4500000000000000e+01 -2.8982601928710938e+02 -1.5107000350952148e+01 -7.4500000000000000e+01 -2.8916998291015625e+02 -1.7010499954223633e+01 -7.4500000000000000e+01 -2.8689001464843750e+02 -1.5141300201416016e+01 -7.4500000000000000e+01 -2.8948599243164062e+02 -1.7054399490356445e+01 -7.4500000000000000e+01 -2.8688699340820312e+02 -1.5157600402832031e+01 -7.4500000000000000e+01 -2.8958599853515625e+02 -1.9273099899291992e+01 -7.4500000000000000e+01 -2.8784399414062500e+02 -1.9674200057983398e+01 -7.4500000000000000e+01 -2.8833599853515625e+02 -2.0012300491333008e+01 -7.4500000000000000e+01 -2.8888699340820312e+02 -1.8584400177001953e+01 -7.4500000000000000e+01 -2.8728399658203125e+02 -1.8847801208496094e+01 -7.4500000000000000e+01 -2.8746200561523438e+02 -1.7099599838256836e+01 -7.4500000000000000e+01 -2.8688699340820312e+02 -1.7555799484252930e+01 -7.4500000000000000e+01 -2.8691400146484375e+02 -1.8002799987792969e+01 -7.4500000000000000e+01 -2.8701300048828125e+02 -1.8304700851440430e+01 -7.4500000000000000e+01 -2.8713198852539062e+02 -1.5595800399780273e+01 -7.4500000000000000e+01 -2.8746499633789062e+02 -1.5804300308227539e+01 -7.4500000000000000e+01 -2.8727999877929688e+02 -1.5415900230407715e+01 -7.4500000000000000e+01 -2.8769299316406250e+02 -1.5273399353027344e+01 -7.4500000000000000e+01 -2.8796099853515625e+02 -1.5099900245666504e+01 -7.4500000000000000e+01 -2.8885202026367188e+02 -1.5123199462890625e+01 -7.4500000000000000e+01 -2.8853399658203125e+02 -1.6679700851440430e+01 -7.4500000000000000e+01 -2.8692599487304688e+02 -1.5178400039672852e+01 -7.4500000000000000e+01 -2.8824200439453125e+02 -1.6355300903320312e+01 -7.4500000000000000e+01 -2.8700198364257812e+02 -1.6046600341796875e+01 -7.4500000000000000e+01 -2.8712902832031250e+02 -6.4809002876281738e+00 -7.4306999206542969e+01 -2.8359500122070312e+02 -6.4685001373291016e+00 -7.3886001586914062e+01 -2.8360998535156250e+02 -5.8645000457763672e+00 -7.4306999206542969e+01 -2.8003100585937500e+02 -5.8520998954772949e+00 -7.3886001586914062e+01 -2.8004501342773438e+02 -5.4706001281738281e+00 -7.4306999206542969e+01 -2.7969900512695312e+02 -5.4583001136779785e+00 -7.3886001586914062e+01 -2.7971398925781250e+02 -2.1520001888275146e+00 -7.4306999206542969e+01 -2.7969900512695312e+02 -2.1695001125335693e+00 -7.3886001586914062e+01 -2.7971398925781250e+02 -1.7582999467849731e+00 -7.4306999206542969e+01 -2.8016799926757812e+02 -1.7757999897003174e+00 -7.3886001586914062e+01 -2.8018298339843750e+02 -2.3638000488281250e+00 -7.4306999206542969e+01 -2.8359500122070312e+02 -2.3812999725341797e+00 -7.3886001586914062e+01 -2.8360998535156250e+02 -2.0279701054096222e-01 -7.4306999206542969e+01 -2.8359500122070312e+02 -2.2029799222946167e-01 -7.3886001586914062e+01 -2.8360998535156250e+02 1.9110000133514404e-01 -7.4306999206542969e+01 -2.8406399536132812e+02 1.7350199818611145e-01 -7.3886001586914062e+01 -2.8407897949218750e+02 -2.0900300145149231e-01 -7.4306999206542969e+01 -2.8635598754882812e+02 -2.2129699587821960e-01 -7.3886001586914062e+01 -2.8634197998046875e+02 -6.0279595851898193e-01 -7.4306999206542969e+01 -2.8668698120117188e+02 -6.1520099639892578e-01 -7.3886001586914062e+01 -2.8667300415039062e+02 -2.9035000801086426e+00 -7.4306999206542969e+01 -2.8668698120117188e+02 -2.9158999919891357e+00 -7.3886001586914062e+01 -2.8667300415039062e+02 -4.2520999908447266e+00 -7.4306999206542969e+01 -2.9463299560546875e+02 -4.2666001319885254e+00 -7.3886001586914062e+01 -2.9463101196289062e+02 -4.1473002433776855e+00 -7.3886001586914062e+01 -2.9578598022460938e+02 -4.1342000961303711e+00 -7.4306999206542969e+01 -2.9577899169921875e+02 -4.2356996536254883e+00 -7.3886001586914062e+01 -2.9555300903320312e+02 -4.2568998336791992e+00 -7.4306999206542969e+01 -2.9536300659179688e+02 -4.2548999786376953e+00 -7.3886001586914062e+01 -2.9536398315429688e+02 -4.2599000930786133e+00 -7.4306999206542969e+01 -2.9535299682617188e+02 -4.2925996780395508e+00 -7.3886001586914062e+01 -2.9499099731445312e+02 -4.2771000862121582e+00 -7.4306999206542969e+01 -2.9495999145507812e+02 -4.2730002403259277e+00 -7.3886001586914062e+01 -2.9471902465820312e+02 -4.2587003707885742e+00 -7.4306999206542969e+01 -2.9472000122070312e+02 -3.1335000991821289e+00 -7.3886001586914062e+01 -2.9622201538085938e+02 -3.1324999332427979e+00 -7.4306999206542969e+01 -2.9620800781250000e+02 -3.4049000740051270e+00 -7.3886001586914062e+01 -2.9619900512695312e+02 -3.4024000167846680e+00 -7.4306999206542969e+01 -2.9618499755859375e+02 -3.7833001613616943e+00 -7.3886001586914062e+01 -2.9609298706054688e+02 -3.7785999774932861e+00 -7.4306999206542969e+01 -2.9608398437500000e+02 -3.7967000007629395e+00 -7.4306999206542969e+01 -2.9607901000976562e+02 -3.8266000747680664e+00 -7.3886001586914062e+01 -2.9608099365234375e+02 -4.0052003860473633e+00 -7.4306999206542969e+01 -2.9594601440429688e+02 -4.0178999900817871e+00 -7.3886001586914062e+01 -2.9595397949218750e+02 -4.0075001716613770e+00 -7.4306999206542969e+01 -2.9594299316406250e+02 -4.0185999870300293e+00 -7.3886001586914062e+01 -2.9595300292968750e+02 -2.4997999668121338e+00 -7.3886001586914062e+01 -2.9621499633789062e+02 -2.5015001296997070e+00 -7.4306999206542969e+01 -2.9620001220703125e+02 -2.6632997989654541e+00 -7.3886001586914062e+01 -2.9622998046875000e+02 -2.6891999244689941e+00 -7.4306999206542969e+01 -2.9621697998046875e+02 -2.8278999328613281e+00 -7.3886001586914062e+01 -2.9623498535156250e+02 -2.8772001266479492e+00 -7.4306999206542969e+01 -2.9622097778320312e+02 -2.9933001995086670e+00 -7.3886001586914062e+01 -2.9623202514648438e+02 -3.0643999576568604e+00 -7.4306999206542969e+01 -2.9621301269531250e+02 -2.3662998676300049e+00 -7.4306999206542969e+01 -2.9618499755859375e+02 -2.3775999546051025e+00 -7.4020294189453125e+01 -2.9619601440429688e+02 -2.3828999996185303e+00 -7.3886001586914062e+01 -2.9620098876953125e+02 -1.9397000074386597e+00 -7.3886001586914062e+01 -2.9663500976562500e+02 -2.1612999439239502e+00 -7.3886001586914062e+01 -2.9908200073242188e+02 -1.9345901012420654e+00 -7.4020294189453125e+01 -2.9662899780273438e+02 -2.1573998928070068e+00 -7.4006103515625000e+01 -2.9908499145507812e+02 -1.9234999418258667e+00 -7.4306999206542969e+01 -2.9661801147460938e+02 -2.1475000381469727e+00 -7.4306999206542969e+01 -2.9909301757812500e+02 -2.4461002349853516e+00 -7.4006103515625000e+01 -2.9943402099609375e+02 -2.4502000808715820e+00 -7.3886001586914062e+01 -2.9943002319335938e+02 -2.6635999679565430e+00 -7.3886001586914062e+01 -2.9948699951171875e+02 -2.4357998371124268e+00 -7.4306999206542969e+01 -2.9944198608398438e+02 -3.3327000141143799e+00 -7.3886001586914062e+01 -2.9961499023437500e+02 -3.3307001590728760e+00 -7.4306999206542969e+01 -2.9962899780273438e+02 -2.9963998794555664e+00 -7.3886001586914062e+01 -2.9955999755859375e+02 -3.0269000530242920e+00 -7.4306999206542969e+01 -2.9958099365234375e+02 -2.7265000343322754e+00 -7.4306999206542969e+01 -2.9951699829101562e+02 -3.9309999942779541e+00 -7.4306999206542969e+01 -2.9968600463867188e+02 -4.5380001068115234e+00 -7.3886001586914062e+01 -2.9967999267578125e+02 -4.5381999015808105e+00 -7.4306999206542969e+01 -2.9969497680664062e+02 -4.3312001228332520e+00 -7.3886001586914062e+01 -2.9968301391601562e+02 -3.9977998733520508e+00 -7.3886001586914062e+01 -2.9967498779296875e+02 -3.6647999286651611e+00 -7.3886001586914062e+01 -2.9965200805664062e+02 -6.3533000946044922e+00 -7.3886001586914062e+01 -2.9932400512695312e+02 -6.3593001365661621e+00 -7.4306999206542969e+01 -2.9933700561523438e+02 -5.7546000480651855e+00 -7.3886001586914062e+01 -2.9952999877929688e+02 -5.7645998001098633e+00 -7.4306999206542969e+01 -2.9954299926757812e+02 -5.1470999717712402e+00 -7.3886001586914062e+01 -2.9964199829101562e+02 -5.1526999473571777e+00 -7.4306999206542969e+01 -2.9965600585937500e+02 -4.5432000160217285e+00 -7.3886001586914062e+01 -2.9967999267578125e+02 -7.5903000831604004e+00 -7.3886001586914062e+01 -2.9837100219726562e+02 -7.6020002365112305e+00 -7.4306999206542969e+01 -2.9837997436523438e+02 -7.2430000305175781e+00 -7.3886001586914062e+01 -2.9874798583984375e+02 -7.2600998878479004e+00 -7.4306999206542969e+01 -2.9875201416015625e+02 -6.8513002395629883e+00 -7.3886001586914062e+01 -2.9905200195312500e+02 -6.8716001510620117e+00 -7.4306999206542969e+01 -2.9905599975585938e+02 -8.2601995468139648e+00 -7.3886001586914062e+01 -2.9692102050781250e+02 -8.2744998931884766e+00 -7.4306999206542969e+01 -2.9692501831054688e+02 -8.1126995086669922e+00 -7.3886001586914062e+01 -2.9741601562500000e+02 -8.1232995986938477e+00 -7.4306999206542969e+01 -2.9743002319335938e+02 -7.9028997421264648e+00 -7.3886001586914062e+01 -2.9788699340820312e+02 -7.9124002456665039e+00 -7.4306999206542969e+01 -2.9789999389648438e+02 -8.3758001327514648e+00 -7.4306999206542969e+01 -2.9633200073242188e+02 -8.3718996047973633e+00 -7.3886001586914062e+01 -2.9622500610351562e+02 -8.4109992980957031e+00 -7.4306999206542969e+01 -2.9572799682617188e+02 -8.3950996398925781e+00 -7.3886001586914062e+01 -2.9553198242187500e+02 -8.3892002105712891e+00 -7.4306999206542969e+01 -2.9512100219726562e+02 -8.3695001602172852e+00 -7.3886001586914062e+01 -2.9506100463867188e+02 -8.3840999603271484e+00 -7.4306999206542969e+01 -2.9505899047851562e+02 -7.0206999778747559e+00 -7.4306999206542969e+01 -2.8668698120117188e+02 -7.0034999847412109e+00 -7.3886001586914062e+01 -2.8667300415039062e+02 -8.7861995697021484e+00 -7.4306999206542969e+01 -2.8668698120117188e+02 -8.7687997817993164e+00 -7.3886001586914062e+01 -2.8667300415039062e+02 -9.1800003051757812e+00 -7.4306999206542969e+01 -2.8621899414062500e+02 -9.1626005172729492e+00 -7.3886001586914062e+01 -2.8620401000976562e+02 -8.7799005508422852e+00 -7.4306999206542969e+01 -2.8392602539062500e+02 -8.7674999237060547e+00 -7.3886001586914062e+01 -2.8394100952148438e+02 -8.3860998153686523e+00 -7.4306999206542969e+01 -2.8359500122070312e+02 -8.3737001419067383e+00 -7.3886001586914062e+01 -2.8360998535156250e+02 -6.1318998336791992e+00 -7.3500000000000000e+01 -2.8400997924804688e+02 -8.3737001419067383e+00 -7.3500000000000000e+01 -2.8400997924804688e+02 -8.7687997817993164e+00 -7.3500000000000000e+01 -2.8627301025390625e+02 -3.2536001205444336e+00 -7.3500000000000000e+01 -2.8627301025390625e+02 -6.1520099639892578e-01 -7.3500000000000000e+01 -2.8627301025390625e+02 -2.2029799222946167e-01 -7.3500000000000000e+01 -2.8400997924804688e+02 -2.1695001125335693e+00 -7.3500000000000000e+01 -2.8011300659179688e+02 -5.4583001136779785e+00 -7.3500000000000000e+01 -2.8011300659179688e+02 -2.8578000068664551e+00 -7.3500000000000000e+01 -2.8400997924804688e+02 -6.5332999229431152e+00 -7.3500000000000000e+01 -2.8627301025390625e+02 -7.7374000549316406e+00 -7.3500000000000000e+01 -2.9727798461914062e+02 -7.5501999855041504e+00 -7.3500000000000000e+01 -2.9769799804687500e+02 -4.5019998550415039e+00 -7.3500000000000000e+01 -2.9597000122070312e+02 -6.6316003799438477e+00 -7.3500000000000000e+01 -2.9871801757812500e+02 -4.2893996238708496e+00 -7.3500000000000000e+01 -2.9624700927734375e+02 -6.9730997085571289e+00 -7.3500000000000000e+01 -2.9845300292968750e+02 -7.2742004394531250e+00 -7.3500000000000000e+01 -2.9812600708007812e+02 -6.1901998519897461e+00 -7.3500000000000000e+01 -2.9895898437500000e+02 -5.6556000709533691e+00 -7.3500000000000000e+01 -2.9914297485351562e+02 -3.9999001026153564e+00 -7.3500000000000000e+01 -2.9644097900390625e+02 -5.1002001762390137e+00 -7.3500000000000000e+01 -2.9924499511718750e+02 -4.5373997688293457e+00 -7.3500000000000000e+01 -2.9928100585937500e+02 -7.8710999488830566e+00 -7.3500000000000000e+01 -2.9682998657226562e+02 -4.6219997406005859e+00 -7.3500000000000000e+01 -2.9565600585937500e+02 -7.9738001823425293e+00 -7.3500000000000000e+01 -2.9618899536132812e+02 -7.9952998161315918e+00 -7.3500000000000000e+01 -2.9554000854492188e+02 -4.6923003196716309e+00 -7.3500000000000000e+01 -2.9498300170898438e+02 -7.9725003242492676e+00 -7.3500000000000000e+01 -2.9510998535156250e+02 -4.5304999351501465e+00 -7.3500000000000000e+01 -2.9928100585937500e+02 -4.3322000503540039e+00 -7.3500000000000000e+01 -2.9928298950195312e+02 -3.4606001377105713e+00 -7.3500000000000000e+01 -2.9659500122070312e+02 -4.6624002456665039e+00 -7.3500000000000000e+01 -2.9457400512695312e+02 -4.6635999679565430e+00 -7.3500000000000000e+01 -2.9458401489257812e+02 -2.3378999233245850e+00 -7.3500000000000000e+01 -2.9659899902343750e+02 -2.4523999691009521e+00 -7.3500000000000000e+01 -2.9661199951171875e+02 -2.5593998432159424e+00 -7.3500000000000000e+01 -2.9904602050781250e+02 -2.6384999752044678e+00 -7.3500000000000000e+01 -2.9662899780273438e+02 -2.7596001625061035e+00 -7.3500000000000000e+01 -2.9909899902343750e+02 -2.8252000808715820e+00 -7.3500000000000000e+01 -2.9663500976562500e+02 -3.0715000629425049e+00 -7.3500000000000000e+01 -2.9916699218750000e+02 -3.0119998455047607e+00 -7.3500000000000000e+01 -2.9663101196289062e+02 -3.3865001201629639e+00 -7.3500000000000000e+01 -2.9921902465820312e+02 -3.1590001583099365e+00 -7.3500000000000000e+01 -2.9662100219726562e+02 -3.7004997730255127e+00 -7.3500000000000000e+01 -2.9925399780273438e+02 -4.0160999298095703e+00 -7.3500000000000000e+01 -2.9927502441406250e+02 1.4459300041198730e+01 -7.4306999206542969e+01 -2.8804202270507812e+02 1.4212599754333496e+01 -7.4306999206542969e+01 -2.8704800415039062e+02 1.4198600769042969e+01 -7.3886001586914062e+01 -2.8705297851562500e+02 1.4378200531005859e+01 -7.3886001586914062e+01 -2.8770501708984375e+02 1.4493100166320801e+01 -7.3886001586914062e+01 -2.8836898803710938e+02 1.4565600395202637e+01 -7.4306999206542969e+01 -2.8908602905273438e+02 1.4548899650573730e+01 -7.3886001586914062e+01 -2.8903601074218750e+02 1.4554900169372559e+01 -7.4014099121093750e+01 -2.8907498168945312e+02 1.4550300598144531e+01 -7.3886001586914062e+01 -2.8907000732421875e+02 1.1117000579833984e+01 -7.4306999206542969e+01 -2.8950000000000000e+02 1.4166099548339844e+01 -7.4306999206542969e+01 -2.8950000000000000e+02 1.1126499176025391e+01 -7.4013206481933594e+01 -2.8949002075195312e+02 1.4155499458312988e+01 -7.4014099121093750e+01 -2.8949002075195312e+02 1.1130700111389160e+01 -7.3886001586914062e+01 -2.8948501586914062e+02 1.4150799751281738e+01 -7.3886001586914062e+01 -2.8948501586914062e+02 1.0636400222778320e+01 -7.3886001586914062e+01 -2.8846200561523438e+02 1.0622000694274902e+01 -7.4306999206542969e+01 -2.8846499633789062e+02 1.0687399864196777e+01 -7.3886001586914062e+01 -2.8873300170898438e+02 1.0687000274658203e+01 -7.4306999206542969e+01 -2.8883099365234375e+02 1.0718299865722656e+01 -7.4306999206542969e+01 -2.8913000488281250e+02 1.0727900505065918e+01 -7.4013206481933594e+01 -2.8911999511718750e+02 1.0722499847412109e+01 -7.3886001586914062e+01 -2.8900799560546875e+02 1.0731999397277832e+01 -7.3886001586914062e+01 -2.8911599731445312e+02 1.0541600227355957e+01 -7.4306999206542969e+01 -2.8817300415039062e+02 1.0507299423217773e+01 -7.3886001586914062e+01 -2.8803399658203125e+02 1.0419400215148926e+01 -7.4306999206542969e+01 -2.8786901855468750e+02 1.0399000167846680e+01 -7.3886001586914062e+01 -2.8779400634765625e+02 1.0254800796508789e+01 -7.4306999206542969e+01 -2.8757699584960938e+02 1.0266999244689941e+01 -7.3886001586914062e+01 -2.8756900024414062e+02 1.0066699981689453e+01 -7.4306999206542969e+01 -2.8733700561523438e+02 9.9870996475219727e+00 -7.3886001586914062e+01 -2.8723599243164062e+02 9.8406105041503906e+00 -7.4306999206542969e+01 -2.8713000488281250e+02 9.7966899871826172e+00 -7.3886001586914062e+01 -2.8707901000976562e+02 9.5785999298095703e+00 -7.4306999206542969e+01 -2.8695898437500000e+02 9.5855998992919922e+00 -7.3886001586914062e+01 -2.8694598388671875e+02 8.5433006286621094e+00 -7.3886001586914062e+01 -2.8668698120117188e+02 8.5426998138427734e+00 -7.4306999206542969e+01 -2.8670199584960938e+02 8.6943101882934570e+00 -7.3886001586914062e+01 -2.8669802856445312e+02 8.8809995651245117e+00 -7.4306999206542969e+01 -2.8673498535156250e+02 9.2342891693115234e+00 -7.4306999206542969e+01 -2.8681600952148438e+02 9.3107099533081055e+00 -7.3886001586914062e+01 -2.8682501220703125e+02 9.0111904144287109e+00 -7.3886001586914062e+01 -2.8674398803710938e+02 8.0878992080688477e+00 -7.4306999206542969e+01 -2.8671398925781250e+02 8.2016000747680664e+00 -7.3886001586914062e+01 -2.8669100952148438e+02 7.6445002555847168e+00 -7.4306999206542969e+01 -2.8679000854492188e+02 7.6399998664855957e+00 -7.3886001586914062e+01 -2.8676998901367188e+02 7.5525903701782227e+00 -7.4306999206542969e+01 -2.8680599975585938e+02 7.6357002258300781e+00 -7.3886001586914062e+01 -2.8676998901367188e+02 6.8911004066467285e+00 -7.4306999206542969e+01 -2.8709097290039062e+02 6.8833103179931641e+00 -7.3886001586914062e+01 -2.8707901000976562e+02 6.4391098022460938e+00 -7.4306999206542969e+01 -2.8742901611328125e+02 6.4836001396179199e+00 -7.3886001586914062e+01 -2.8737100219726562e+02 6.0935001373291016e+00 -7.4306999206542969e+01 -2.8778399658203125e+02 6.1380996704101562e+00 -7.3886001586914062e+01 -2.8770898437500000e+02 5.7975997924804688e+00 -7.4306999206542969e+01 -2.8819201660156250e+02 5.7851099967956543e+00 -7.3886001586914062e+01 -2.8818399047851562e+02 5.4889001846313477e+00 -7.4306999206542969e+01 -2.8876300048828125e+02 5.5270099639892578e+00 -7.3886001586914062e+01 -2.8864898681640625e+02 5.2968997955322266e+00 -7.4306999206542969e+01 -2.8923199462890625e+02 5.3169002532958984e+00 -7.3886001586914062e+01 -2.8913500976562500e+02 5.1449999809265137e+00 -7.4306999206542969e+01 -2.8971697998046875e+02 5.1307997703552246e+00 -7.3886001586914062e+01 -2.8971298217773438e+02 4.9969000816345215e+00 -7.4306999206542969e+01 -2.9032000732421875e+02 4.9862999916076660e+00 -7.3886001586914062e+01 -2.9030001831054688e+02 4.8779997825622559e+00 -7.4306999206542969e+01 -2.9092898559570312e+02 4.8696999549865723e+00 -7.3886001586914062e+01 -2.9089001464843750e+02 4.8151001930236816e+00 -7.4306999206542969e+01 -2.9135198974609375e+02 4.8004999160766602e+00 -7.3886001586914062e+01 -2.9135000610351562e+02 4.7713003158569336e+00 -7.4306999206542969e+01 -2.9176199340820312e+02 4.7566995620727539e+00 -7.3886001586914062e+01 -2.9176000976562500e+02 4.7145996093750000e+00 -7.4306999206542969e+01 -2.9237402343750000e+02 4.7150998115539551e+00 -7.3886001586914062e+01 -2.9218301391601562e+02 4.6875996589660645e+00 -7.4306999206542969e+01 -2.9279299926757812e+02 4.6837000846862793e+00 -7.3886001586914062e+01 -2.9260800170898438e+02 4.6686000823974609e+00 -7.4306999206542969e+01 -2.9321200561523438e+02 4.6540002822875977e+00 -7.3886001586914062e+01 -2.9321200561523438e+02 4.6791996955871582e+00 -7.4306999206542969e+01 -2.9386199951171875e+02 4.6533002853393555e+00 -7.3886001586914062e+01 -2.9365701293945312e+02 4.7256999015808105e+00 -7.4306999206542969e+01 -2.9427499389648438e+02 4.6865100860595703e+00 -7.3886001586914062e+01 -2.9409500122070312e+02 4.8079996109008789e+00 -7.4306999206542969e+01 -2.9468600463867188e+02 4.7936997413635254e+00 -7.3886001586914062e+01 -2.9469000244140625e+02 4.9131002426147461e+00 -7.4306999206542969e+01 -2.9502099609375000e+02 4.9707999229431152e+00 -7.3886001586914062e+01 -2.9519400024414062e+02 5.0634002685546875e+00 -7.4306999206542969e+01 -2.9534201049804688e+02 5.1723003387451172e+00 -7.3886001586914062e+01 -2.9554501342773438e+02 5.4394998550415039e+00 -7.4306999206542969e+01 -2.9584698486328125e+02 5.4289002418518066e+00 -7.3886001586914062e+01 -2.9585702514648438e+02 6.8136000633239746e+00 -7.3886001586914062e+01 -2.9635400390625000e+02 6.8140001296997070e+00 -7.4306999206542969e+01 -2.9633999633789062e+02 6.4291100502014160e+00 -7.3886001586914062e+01 -2.9632501220703125e+02 6.2070899009704590e+00 -7.4306999206542969e+01 -2.9626699829101562e+02 6.0169997215270996e+00 -7.3886001586914062e+01 -2.9620098876953125e+02 6.0225000381469727e+00 -7.4306999206542969e+01 -2.9619100952148438e+02 5.8166999816894531e+00 -7.3886001586914062e+01 -2.9613998413085938e+02 5.7093997001647949e+00 -7.4306999206542969e+01 -2.9606301879882812e+02 5.5476999282836914e+00 -7.3886001586914062e+01 -2.9594400024414062e+02 5.5534000396728516e+00 -7.4306999206542969e+01 -2.9593798828125000e+02 7.3708000183105469e+00 -7.4306999206542969e+01 -2.9631100463867188e+02 7.1161999702453613e+00 -7.3886001586914062e+01 -2.9635000610351562e+02 7.8600897789001465e+00 -7.4306999206542969e+01 -2.9615597534179688e+02 7.8742103576660156e+00 -7.3886001586914062e+01 -2.9619500732421875e+02 8.2837905883789062e+00 -7.4306999206542969e+01 -2.9602200317382812e+02 7.9878001213073730e+00 -7.3886093139648438e+01 -2.9617199707031250e+02 8.7374000549316406e+00 -7.4306999206542969e+01 -2.9571597290039062e+02 8.7468004226684570e+00 -7.3886001586914062e+01 -2.9572702026367188e+02 9.6842899322509766e+00 -7.4008499145507812e+01 -2.9427297973632812e+02 9.6763992309570312e+00 -7.4306999206542969e+01 -2.9426300048828125e+02 9.3684101104736328e+00 -7.4306999206542969e+01 -2.9497299194335938e+02 9.6876001358032227e+00 -7.3886001586914062e+01 -2.9427700805664062e+02 9.3819103240966797e+00 -7.3886001586914062e+01 -2.9497900390625000e+02 9.3105001449584961e+00 -7.3886001586914062e+01 -2.9506298828125000e+02 9.2985000610351562e+00 -7.4306999206542969e+01 -2.9505499267578125e+02 1.0067099571228027e+01 -7.3886001586914062e+01 -2.9399298095703125e+02 1.3155799865722656e+01 -7.3886001586914062e+01 -2.9397000122070312e+02 1.0063899993896484e+01 -7.4008499145507812e+01 -2.9398901367187500e+02 1.3161100387573242e+01 -7.4016899108886719e+01 -2.9396502685546875e+02 1.0056200027465820e+01 -7.4306999206542969e+01 -2.9397900390625000e+02 1.3172800064086914e+01 -7.4306999206542969e+01 -2.9395498657226562e+02 1.3345800399780273e+01 -7.4306999206542969e+01 -2.9540600585937500e+02 1.3571799278259277e+01 -7.4306999206542969e+01 -2.9441000366210938e+02 1.3560100555419922e+01 -7.4016899108886719e+01 -2.9442098999023438e+02 1.2911100387573242e+01 -7.3886001586914062e+01 -2.9636599731445312e+02 1.2923899650573730e+01 -7.4306999206542969e+01 -2.9637301635742188e+02 1.3212300300598145e+01 -7.3886001586914062e+01 -2.9573397827148438e+02 1.3427900314331055e+01 -7.3886001586914062e+01 -2.9507000732421875e+02 1.3554699897766113e+01 -7.3886001586914062e+01 -2.9442501831054688e+02 1.1356100082397461e+01 -7.3886001586914062e+01 -2.9820599365234375e+02 1.1365300178527832e+01 -7.4306999206542969e+01 -2.9821701049804688e+02 1.1866399765014648e+01 -7.3886001586914062e+01 -2.9775000000000000e+02 1.1876500129699707e+01 -7.4306999206542969e+01 -2.9776000976562500e+02 1.2323399543762207e+01 -7.3886001586914062e+01 -2.9723999023437500e+02 1.2328800201416016e+01 -7.4306999206542969e+01 -2.9725701904296875e+02 9.2024097442626953e+00 -7.3886001586914062e+01 -2.9935900878906250e+02 9.2069997787475586e+00 -7.4306999206542969e+01 -2.9937298583984375e+02 9.8331995010375977e+00 -7.3886001586914062e+01 -2.9911999511718750e+02 9.7959003448486328e+00 -7.4306999206542969e+01 -2.9915197753906250e+02 1.0440400123596191e+01 -7.3886001586914062e+01 -2.9882101440429688e+02 1.0357500076293945e+01 -7.4306999206542969e+01 -2.9888299560546875e+02 6.6975097656250000e+00 -7.3886001586914062e+01 -2.9972500610351562e+02 6.6971001625061035e+00 -7.4306999206542969e+01 -2.9973901367187500e+02 7.3651099205017090e+00 -7.3886001586914062e+01 -2.9971099853515625e+02 7.3463001251220703e+00 -7.4306999206542969e+01 -2.9972698974609375e+02 8.0306100845336914e+00 -7.3886001586914062e+01 -2.9963897705078125e+02 7.9869003295898438e+00 -7.4306999206542969e+01 -2.9966101074218750e+02 3.7774999141693115e+00 -7.3886001586914062e+01 -2.9902398681640625e+02 3.7704000473022461e+00 -7.4306999206542969e+01 -2.9903701782226562e+02 4.6126999855041504e+00 -7.3886001586914062e+01 -2.9938500976562500e+02 4.6117000579833984e+00 -7.4306999206542969e+01 -2.9939999389648438e+02 5.1075000762939453e+00 -7.3886001586914062e+01 -2.9951000976562500e+02 5.1040997505187988e+00 -7.4306999206542969e+01 -2.9952401733398438e+02 5.4819002151489258e+00 -7.3886001586914062e+01 -2.9960501098632812e+02 5.4839997291564941e+00 -7.4306999206542969e+01 -2.9961999511718750e+02 2.9643001556396484e+00 -7.4306999206542969e+01 -2.9851202392578125e+02 2.7477998733520508e+00 -7.3886001586914062e+01 -2.9831500244140625e+02 2.6837999820709229e+00 -7.4306999206542969e+01 -2.9825698852539062e+02 2.6863000392913818e+00 -7.3886001586914062e+01 -2.9825402832031250e+02 2.3457999229431152e+00 -7.4306999206542969e+01 -2.9795001220703125e+02 2.2506999969482422e+00 -7.3886001586914062e+01 -2.9782400512695312e+02 1.8098000288009644e+00 -7.4306999206542969e+01 -2.9728100585937500e+02 1.8220000267028809e+00 -7.3886001586914062e+01 -2.9727301025390625e+02 1.2881000041961670e+00 -7.4306999206542969e+01 -2.9635598754882812e+02 1.1686000823974609e+00 -7.3886001586914062e+01 -2.9603897094726562e+02 7.9240000247955322e-01 -7.3886001586914062e+01 -2.9476101684570312e+02 7.7799803018569946e-01 -7.4306999206542969e+01 -2.9476400756835938e+02 1.4593000411987305e+00 -7.3886001586914062e+01 -2.9666998291015625e+02 9.8899799585342407e-01 -7.4306999206542969e+01 -2.9558102416992188e+02 6.6839897632598877e-01 -7.3886001586914062e+01 -2.9177902221679688e+02 6.5369898080825806e-01 -7.4306999206542969e+01 -2.9177798461914062e+02 6.1220002174377441e-01 -7.3886001586914062e+01 -2.9308099365234375e+02 5.9779798984527588e-01 -7.4306999206542969e+01 -2.9267800903320312e+02 6.6410100460052490e-01 -7.3886001586914062e+01 -2.9392098999023438e+02 6.1880099773406982e-01 -7.4306999206542969e+01 -2.9357098388671875e+02 6.9779902696609497e-01 -7.4306999206542969e+01 -2.9135299682617188e+02 7.1240299940109253e-01 -7.3886001586914062e+01 -2.9135501098632812e+02 1.5311000347137451e+00 -7.3886001586914062e+01 -2.8822601318359375e+02 1.5176000595092773e+00 -7.4306999206542969e+01 -2.8822000122070312e+02 1.0956000089645386e+00 -7.3886001586914062e+01 -2.8944500732421875e+02 1.1081000566482544e+00 -7.4306999206542969e+01 -2.8935098266601562e+02 8.0530399084091187e-01 -7.3886001586914062e+01 -2.9070401000976562e+02 8.2349801063537598e-01 -7.4306999206542969e+01 -2.9052001953125000e+02 3.1969001293182373e+00 -7.3886001586914062e+01 -2.8563897705078125e+02 3.1861000061035156e+00 -7.4306999206542969e+01 -2.8562899780273438e+02 2.3717000484466553e+00 -7.3886001586914062e+01 -2.8667501831054688e+02 2.5773999691009521e+00 -7.4306999206542969e+01 -2.8635900878906250e+02 1.9151999950408936e+00 -7.3886001586914062e+01 -2.8742797851562500e+02 2.0588998794555664e+00 -7.4306999206542969e+01 -2.8714300537109375e+02 5.6507000923156738e+00 -7.3886001586914062e+01 -2.8390100097656250e+02 5.6448001861572266e+00 -7.4306999206542969e+01 -2.8388800048828125e+02 4.5312099456787109e+00 -7.3886001586914062e+01 -2.8451098632812500e+02 4.8266000747680664e+00 -7.4306999206542969e+01 -2.8430899047851562e+02 4.3270998001098633e+00 -7.4306999206542969e+01 -2.8464801025390625e+02 4.0770001411437988e+00 -7.4306999206542969e+01 -2.8481799316406250e+02 3.8350000381469727e+00 -7.3886001586914062e+01 -2.8503201293945312e+02 4.3348999023437500e+00 -7.3886001586914062e+01 -2.8465802001953125e+02 6.6788096427917480e+00 -7.4306999206542969e+01 -2.8353100585937500e+02 6.5664997100830078e+00 -7.3886001586914062e+01 -2.8357501220703125e+02 7.1649999618530273e+00 -7.4306999206542969e+01 -2.8344500732421875e+02 7.1670999526977539e+00 -7.3886001586914062e+01 -2.8345401000976562e+02 7.7362999916076660e+00 -7.4306999206542969e+01 -2.8334399414062500e+02 7.4955101013183594e+00 -7.3886001586914062e+01 -2.8338699340820312e+02 8.8354902267456055e+00 -7.4306999206542969e+01 -2.8330297851562500e+02 8.8352003097534180e+00 -7.3886001586914062e+01 -2.8331698608398438e+02 1.1288000106811523e+01 -7.3886001586914062e+01 -2.8381298828125000e+02 1.1293799400329590e+01 -7.4306999206542969e+01 -2.8380001831054688e+02 1.0632400512695312e+01 -7.3886001586914062e+01 -2.8357800292968750e+02 1.0690400123596191e+01 -7.4306999206542969e+01 -2.8358001708984375e+02 9.9595003128051758e+00 -7.3886001586914062e+01 -2.8342300415039062e+02 1.0071599960327148e+01 -7.4306999206542969e+01 -2.8342898559570312e+02 1.3096700668334961e+01 -7.3886001586914062e+01 -2.8510400390625000e+02 1.3107700347900391e+01 -7.4306999206542969e+01 -2.8509500122070312e+02 1.2587600708007812e+01 -7.3886001586914062e+01 -2.8460800170898438e+02 1.2341799736022949e+01 -7.4306999206542969e+01 -2.8439599609375000e+02 1.1971299171447754e+01 -7.3886001586914062e+01 -2.8416601562500000e+02 1.1835399627685547e+01 -7.4306999206542969e+01 -2.8406900024414062e+02 1.3944399833679199e+01 -7.3886001586914062e+01 -2.8640802001953125e+02 1.3795799255371094e+01 -7.4306999206542969e+01 -2.8608001708984375e+02 1.3573500633239746e+01 -7.3886001586914062e+01 -2.8573300170898438e+02 1.3479599952697754e+01 -7.4306999206542969e+01 -2.8556698608398438e+02 1.3040699958801270e+01 -7.3500000000000000e+01 -2.9497097778320312e+02 1.3158899307250977e+01 -7.3500000000000000e+01 -2.9436999511718750e+02 1.0070100784301758e+01 -7.3500000000000000e+01 -2.9439300537109375e+02 9.7259998321533203e+00 -7.3500000000000000e+01 -2.9518197631835938e+02 1.2562399864196777e+01 -7.3500000000000000e+01 -2.9617102050781250e+02 1.2840899467468262e+01 -7.3500000000000000e+01 -2.9558599853515625e+02 9.0038003921508789e+00 -7.3500000000000000e+01 -2.9603298950195312e+02 1.1583900451660156e+01 -7.3500000000000000e+01 -2.9746697998046875e+02 1.2011400222778320e+01 -7.3500000000000000e+01 -2.9699002075195312e+02 8.1286001205444336e+00 -7.3500000000000000e+01 -2.9654602050781250e+02 9.6742105484008789e+00 -7.3500000000000000e+01 -2.9875399780273438e+02 9.0036993026733398e+00 -7.3500000000000000e+01 -2.9603298950195312e+02 1.0245800018310547e+01 -7.3500000000000000e+01 -2.9847198486328125e+02 1.1106500625610352e+01 -7.3500000000000000e+01 -2.9789401245117188e+02 7.1389098167419434e+00 -7.3500000000000000e+01 -2.9674899291992188e+02 7.9698004722595215e+00 -7.3500000000000000e+01 -2.9924398803710938e+02 9.0781002044677734e+00 -7.3500000000000000e+01 -2.9897900390625000e+02 3.0096001625061035e+00 -7.3500000000000000e+01 -2.9801300048828125e+02 3.9679999351501465e+00 -7.3500000000000000e+01 -2.9867300415039062e+02 5.1421003341674805e+00 -7.3500000000000000e+01 -2.9613500976562500e+02 3.9681000709533691e+00 -7.3500000000000000e+01 -2.9867300415039062e+02 5.6363101005554199e+00 -7.3500000000000000e+01 -2.9649697875976562e+02 4.7393999099731445e+00 -7.3500000000000000e+01 -2.9900598144531250e+02 6.3717999458312988e+00 -7.3500000000000000e+01 -2.9672000122070312e+02 5.5528998374938965e+00 -7.3500000000000000e+01 -2.9921099853515625e+02 6.8052997589111328e+00 -7.3500000000000000e+01 -2.9675399780273438e+02 6.7063999176025391e+00 -7.3500000000000000e+01 -2.9932498168945312e+02 7.3399000167846680e+00 -7.3500000000000000e+01 -2.9931198120117188e+02 2.5496001243591309e+00 -7.3500000000000000e+01 -2.9755899047851562e+02 4.8433003425598145e+00 -7.3500000000000000e+01 -2.9577197265625000e+02 2.1524999141693115e+00 -7.3500000000000000e+01 -2.9704800415039062e+02 4.6089997291564941e+00 -7.3500000000000000e+01 -2.9536398315429688e+02 1.8127999305725098e+00 -7.3500000000000000e+01 -2.9648300170898438e+02 9.7767000198364258e+00 -7.3500000000000000e+01 -2.8659500122070312e+02 1.0030099868774414e+01 -7.3500000000000000e+01 -2.8675399780273438e+02 1.1763299942016602e+01 -7.3500000000000000e+01 -2.8450701904296875e+02 1.3237699508666992e+01 -7.3500000000000000e+01 -2.8595001220703125e+02 1.0754400253295898e+01 -7.3500000000000000e+01 -2.8761102294921875e+02 1.3581699371337891e+01 -7.3500000000000000e+01 -2.8657598876953125e+02 1.0879499435424805e+01 -7.3500000000000000e+01 -2.8788900756835938e+02 1.3819100379943848e+01 -7.3500000000000000e+01 -2.8717800903320312e+02 1.1026700019836426e+01 -7.3500000000000000e+01 -2.8837600708007812e+02 4.0930004119873047e+00 -7.3500000000000000e+01 -2.8533801269531250e+02 5.8385000228881836e+00 -7.3500000000000000e+01 -2.8744500732421875e+02 6.2249898910522461e+00 -7.3500000000000000e+01 -2.8706600952148438e+02 1.2330399513244629e+01 -7.3500000000000000e+01 -2.8491400146484375e+02 1.0261099815368652e+01 -7.3500000000000000e+01 -2.8694497680664062e+02 1.2797299385070801e+01 -7.3500000000000000e+01 -2.8536901855468750e+02 1.0600399971008301e+01 -7.3500000000000000e+01 -2.8734799194335938e+02 1.0600900650024414e+01 -7.3500000000000000e+01 -2.8734899902343750e+02 1.1026800155639648e+01 -7.3500000000000000e+01 -2.8837600708007812e+02 1.4096500396728516e+01 -7.3500000000000000e+01 -2.8841900634765625e+02 1.3987899780273438e+01 -7.3500000000000000e+01 -2.8779199218750000e+02 3.4890000820159912e+00 -7.3500000000000000e+01 -2.8591201782226562e+02 5.4458999633789062e+00 -7.3500000000000000e+01 -2.8797299194335938e+02 2.7026998996734619e+00 -7.3500000000000000e+01 -2.8689898681640625e+02 5.1682000160217285e+00 -7.3500000000000000e+01 -2.8847302246093750e+02 4.9430003166198730e+00 -7.3500000000000000e+01 -2.8899301147460938e+02 9.7764005661010742e+00 -7.3500000000000000e+01 -2.8659500122070312e+02 1.1129300117492676e+01 -7.3500000000000000e+01 -2.8417999267578125e+02 9.4426002502441406e+00 -7.3500000000000000e+01 -2.8644799804687500e+02 1.0520700454711914e+01 -7.3500000000000000e+01 -2.8396200561523438e+02 9.0910100936889648e+00 -7.3500000000000000e+01 -2.8635202026367188e+02 9.8908996582031250e+00 -7.3500000000000000e+01 -2.8381698608398438e+02 8.7307004928588867e+00 -7.3500000000000000e+01 -2.8630001831054688e+02 8.8266000747680664e+00 -7.3500000000000000e+01 -2.8371701049804688e+02 8.5588006973266602e+00 -7.3500000000000000e+01 -2.8628799438476562e+02 8.8253002166748047e+00 -7.3500000000000000e+01 -2.8371701049804688e+02 8.1799001693725586e+00 -7.3500000000000000e+01 -2.8629199218750000e+02 7.5492997169494629e+00 -7.3500000000000000e+01 -2.8378298950195312e+02 7.5442099571228027e+00 -7.3500000000000000e+01 -2.8638101196289062e+02 6.6723103523254395e+00 -7.3500000000000000e+01 -2.8396099853515625e+02 6.6711001396179199e+00 -7.3500000000000000e+01 -2.8673999023437500e+02 5.8127102851867676e+00 -7.3500000000000000e+01 -2.8426699829101562e+02 4.7512998580932617e+00 -7.3500000000000000e+01 -2.8484500122070312e+02 1.1082300186157227e+01 -7.3500000000000000e+01 -2.8867098999023438e+02 1.1120400428771973e+01 -7.3500000000000000e+01 -2.8896902465820312e+02 1.4149499893188477e+01 -7.3500000000000000e+01 -2.8905297851562500e+02 1.1130700111389160e+01 -7.3500000000000000e+01 -2.8908602905273438e+02 1.4150799751281738e+01 -7.3500000000000000e+01 -2.8908602905273438e+02 2.2667999267578125e+00 -7.3500000000000000e+01 -2.8761801147460938e+02 1.8990000486373901e+00 -7.3500000000000000e+01 -2.8838299560546875e+02 4.7447996139526367e+00 -7.3500000000000000e+01 -2.8960897827148438e+02 1.8989000320434570e+00 -7.3500000000000000e+01 -2.8838299560546875e+02 4.5961003303527832e+00 -7.3500000000000000e+01 -2.9021298217773438e+02 1.4793000221252441e+00 -7.3500000000000000e+01 -2.8955700683593750e+02 4.4757003784179688e+00 -7.3500000000000000e+01 -2.9082299804687500e+02 1.1994000673294067e+00 -7.3500000000000000e+01 -2.9077200317382812e+02 1.5398999452590942e+00 -7.3500000000000000e+01 -2.9589099121093750e+02 4.4057002067565918e+00 -7.3500000000000000e+01 -2.9478601074218750e+02 1.1843000650405884e+00 -7.3500000000000000e+01 -2.9468200683593750e+02 4.2894997596740723e+00 -7.3500000000000000e+01 -2.9414099121093750e+02 1.0616000890731812e+00 -7.3500000000000000e+01 -2.9387899780273438e+02 4.2538099288940430e+00 -7.3500000000000000e+01 -2.9367102050781250e+02 1.0119000673294067e+00 -7.3500000000000000e+01 -2.9307400512695312e+02 4.2544999122619629e+00 -7.3500000000000000e+01 -2.9319699096679688e+02 1.0659999847412109e+00 -7.3500000000000000e+01 -2.9181997680664062e+02 4.2848000526428223e+00 -7.3500000000000000e+01 -2.9258297729492188e+02 4.3167996406555176e+00 -7.3500000000000000e+01 -2.9214901733398438e+02 1.1097999811172485e+00 -7.3500000000000000e+01 -2.9139797973632812e+02 4.3592000007629395e+00 -7.3500000000000000e+01 -2.9171801757812500e+02 4.4033999443054199e+00 -7.3500000000000000e+01 -2.9130300903320312e+02 1.8938800811767578e+01 -7.4306999206542969e+01 -2.9943200683593750e+02 1.8926500320434570e+01 -7.3886001586914062e+01 -2.9941699218750000e+02 1.5632100105285645e+01 -7.4306999206542969e+01 -2.9943200683593750e+02 1.5649600028991699e+01 -7.3886001586914062e+01 -2.9941699218750000e+02 1.5238200187683105e+01 -7.4306999206542969e+01 -2.9896398925781250e+02 1.5255700111389160e+01 -7.3886001586914062e+01 -2.9894900512695312e+02 1.8993801116943359e+01 -7.4306999206542969e+01 -2.7727697753906250e+02 1.9006200790405273e+01 -7.3886001586914062e+01 -2.7729098510742188e+02 1.9387699127197266e+01 -7.4306999206542969e+01 -2.7694500732421875e+02 1.9400098800659180e+01 -7.3886001586914062e+01 -2.7695999145507812e+02 2.2697500228881836e+01 -7.4306999206542969e+01 -2.7694500732421875e+02 2.2679698944091797e+01 -7.3886001586914062e+01 -2.7695999145507812e+02 2.3089900970458984e+01 -7.4306999206542969e+01 -2.7742098999023438e+02 2.3072099685668945e+01 -7.3886001586914062e+01 -2.7743597412109375e+02 2.1539199829101562e+01 -7.4306999206542969e+01 -2.8536901855468750e+02 2.1514499664306641e+01 -7.3886001586914062e+01 -2.8541897583007812e+02 2.1754499435424805e+01 -7.4306999206542969e+01 -2.8513699340820312e+02 2.1845800399780273e+01 -7.3886001586914062e+01 -2.8506500244140625e+02 2.2561599731445312e+01 -7.4306999206542969e+01 -2.8442001342773438e+02 2.3479299545288086e+01 -7.3886001586914062e+01 -2.8385699462890625e+02 2.3472499847412109e+01 -7.4306999206542969e+01 -2.8384399414062500e+02 2.2892700195312500e+01 -7.3886001586914062e+01 -2.8420300292968750e+02 2.2346601486206055e+01 -7.3886001586914062e+01 -2.8460800170898438e+02 2.5841999053955078e+01 -7.3886001586914062e+01 -2.8331698608398438e+02 2.5842300415039062e+01 -7.4306999206542969e+01 -2.8330297851562500e+02 2.5531700134277344e+01 -7.3886001586914062e+01 -2.8332202148437500e+02 2.5617099761962891e+01 -7.4306999206542969e+01 -2.8330401611328125e+02 2.4828399658203125e+01 -7.3886001586914062e+01 -2.8339898681640625e+02 2.4806699752807617e+01 -7.4306999206542969e+01 -2.8338800048828125e+02 2.4604900360107422e+01 -7.3886001586914062e+01 -2.8345599365234375e+02 2.4602201461791992e+01 -7.4306999206542969e+01 -2.8344299316406250e+02 2.4137298583984375e+01 -7.3886001586914062e+01 -2.8357601928710938e+02 2.4023099899291992e+01 -7.4306999206542969e+01 -2.8360098266601562e+02 2.8051000595092773e+01 -7.3886001586914062e+01 -2.8385601806640625e+02 2.8058300018310547e+01 -7.4306999206542969e+01 -2.8384399414062500e+02 2.7510299682617188e+01 -7.3886001586914062e+01 -2.8360400390625000e+02 2.7530300140380859e+01 -7.4306999206542969e+01 -2.8359600830078125e+02 2.6950300216674805e+01 -7.3886001586914062e+01 -2.8344198608398438e+02 2.6966100692749023e+01 -7.4306999206542969e+01 -2.8343002319335938e+02 2.5977001190185547e+01 -7.3886001586914062e+01 -2.8332098388671875e+02 2.5960498809814453e+01 -7.4306999206542969e+01 -2.8330599975585938e+02 2.9427400588989258e+01 -7.3886001586914062e+01 -2.8521798706054688e+02 2.9440099716186523e+01 -7.4306999206542969e+01 -2.8521099853515625e+02 2.9077098846435547e+01 -7.3886001586914062e+01 -2.8471499633789062e+02 2.9039100646972656e+01 -7.4306999206542969e+01 -2.8464801025390625e+02 2.8608499526977539e+01 -7.3886001586914062e+01 -2.8424502563476562e+02 2.8558099746704102e+01 -7.4306999206542969e+01 -2.8418499755859375e+02 3.0076499938964844e+01 -7.3886001586914062e+01 -2.8716598510742188e+02 3.0091098785400391e+01 -7.4306999206542969e+01 -2.8716400146484375e+02 2.9941299438476562e+01 -7.3886001586914062e+01 -2.8648199462890625e+02 2.9911001205444336e+01 -7.4306999206542969e+01 -2.8631698608398438e+02 2.9730800628662109e+01 -7.3886001586914062e+01 -2.8584100341796875e+02 2.9708801269531250e+01 -7.4306999206542969e+01 -2.8574899291992188e+02 3.0113401412963867e+01 -7.3886001586914062e+01 -2.8944500732421875e+02 3.0128000259399414e+01 -7.4306999206542969e+01 -2.8944702148437500e+02 3.0139900207519531e+01 -7.3886001586914062e+01 -2.8912698364257812e+02 3.0164501190185547e+01 -7.4306999206542969e+01 -2.8896398925781250e+02 3.0163599014282227e+01 -7.3886001586914062e+01 -2.8847399902343750e+02 3.0178100585937500e+01 -7.4306999206542969e+01 -2.8836199951171875e+02 3.0143499374389648e+01 -7.3886001586914062e+01 -2.8781900024414062e+02 3.0154300689697266e+01 -7.4306999206542969e+01 -2.8776101684570312e+02 2.8514501571655273e+01 -7.4306999206542969e+01 -2.9909802246093750e+02 2.8502099990844727e+01 -7.3886001586914062e+01 -2.9908300781250000e+02 2.8120199203491211e+01 -7.4306999206542969e+01 -2.9943200683593750e+02 2.8107799530029297e+01 -7.3886001586914062e+01 -2.9941699218750000e+02 2.4814199447631836e+01 -7.4306999206542969e+01 -2.9943200683593750e+02 2.4831600189208984e+01 -7.3886001586914062e+01 -2.9941699218750000e+02 2.4420000076293945e+01 -7.4306999206542969e+01 -2.9896600341796875e+02 2.4437301635742188e+01 -7.3886001586914062e+01 -2.9895098876953125e+02 2.6025098800659180e+01 -7.4306999206542969e+01 -2.8940499877929688e+02 2.6039600372314453e+01 -7.3886001586914062e+01 -2.8940701293945312e+02 2.6036199569702148e+01 -7.4306999206542969e+01 -2.8931298828125000e+02 2.6058500289916992e+01 -7.3886001586914062e+01 -2.8924200439453125e+02 2.6063199996948242e+01 -7.4306999206542969e+01 -2.8899401855468750e+02 2.6080600738525391e+01 -7.3886001586914062e+01 -2.8894100952148438e+02 2.6070600509643555e+01 -7.4306999206542969e+01 -2.8867300415039062e+02 2.6084798812866211e+01 -7.3886001586914062e+01 -2.8864199829101562e+02 2.6054399490356445e+01 -7.4306999206542969e+01 -2.8834899902343750e+02 2.6069099426269531e+01 -7.3886001586914062e+01 -2.8834799194335938e+02 2.6010398864746094e+01 -7.4306999206542969e+01 -2.8805200195312500e+02 2.6007699966430664e+01 -7.3886001586914062e+01 -2.8797500610351562e+02 2.5933700561523438e+01 -7.4306999206542969e+01 -2.8777999877929688e+02 2.5930999755859375e+01 -7.3886001586914062e+01 -2.8773001098632812e+02 2.5811800003051758e+01 -7.4306999206542969e+01 -2.8751098632812500e+02 2.5824600219726562e+01 -7.3886001586914062e+01 -2.8750399780273438e+02 2.5631200790405273e+01 -7.4306999206542969e+01 -2.8726101684570312e+02 2.5637100219726562e+01 -7.3886001586914062e+01 -2.8724600219726562e+02 2.5559600830078125e+01 -7.4306999206542969e+01 -2.8719500732421875e+02 2.5570199966430664e+01 -7.3886001586914062e+01 -2.8718399047851562e+02 2.5441299438476562e+01 -7.4306999206542969e+01 -2.8708599853515625e+02 2.5458000183105469e+01 -7.3886001586914062e+01 -2.8708099365234375e+02 2.5223100662231445e+01 -7.4306999206542969e+01 -2.8694497680664062e+02 2.5230100631713867e+01 -7.3886001586914062e+01 -2.8693200683593750e+02 2.4202400207519531e+01 -7.3886001586914062e+01 -2.8670199584960938e+02 2.4201999664306641e+01 -7.4306999206542969e+01 -2.8671701049804688e+02 2.4262399673461914e+01 -7.3886001586914062e+01 -2.8670401000976562e+02 2.4600900650024414e+01 -7.4306999206542969e+01 -2.8674899291992188e+02 2.4913599014282227e+01 -7.4306999206542969e+01 -2.8681799316406250e+02 2.5008199691772461e+01 -7.3886001586914062e+01 -2.8683297729492188e+02 2.4649599075317383e+01 -7.3886001586914062e+01 -2.8674200439453125e+02 2.2558198928833008e+01 -7.3886001586914062e+01 -2.8706298828125000e+02 2.2565299987792969e+01 -7.4306999206542969e+01 -2.8707598876953125e+02 2.2992898941040039e+01 -7.3886001586914062e+01 -2.8687200927734375e+02 2.3075698852539062e+01 -7.4306999206542969e+01 -2.8685998535156250e+02 2.3456501007080078e+01 -7.3886001586914062e+01 -2.8675198364257812e+02 2.3596199035644531e+01 -7.4306999206542969e+01 -2.8674502563476562e+02 2.3939300537109375e+01 -7.3886001586914062e+01 -2.8670199584960938e+02 2.2011199951171875e+01 -7.4306999206542969e+01 -2.8743899536132812e+02 2.2052099227905273e+01 -7.3886001586914062e+01 -2.8738998413085938e+02 2.1520000457763672e+01 -7.4306999206542969e+01 -2.8787698364257812e+02 2.1591499328613281e+01 -7.3886001586914062e+01 -2.8778500366210938e+02 2.1265798568725586e+01 -7.4306999206542969e+01 -2.8815600585937500e+02 2.1252000808715820e+01 -7.3886001586914062e+01 -2.8815002441406250e+02 1.9332500457763672e+01 -7.4306999206542969e+01 -2.9910098266601562e+02 1.9320199966430664e+01 -7.3886001586914062e+01 -2.9908697509765625e+02 2.2679698944091797e+01 -7.3500000000000000e+01 -2.7735998535156250e+02 1.9400098800659180e+01 -7.3500000000000000e+01 -2.7735998535156250e+02 2.0843399047851562e+01 -7.3500000000000000e+01 -2.8677099609375000e+02 1.5649600028991699e+01 -7.3500000000000000e+01 -2.9901699829101562e+02 1.8926500320434570e+01 -7.3500000000000000e+01 -2.9901699829101562e+02 2.0877300262451172e+01 -7.3500000000000000e+01 -2.8797299194335938e+02 2.9554401397705078e+01 -7.3500000000000000e+01 -2.8658200073242188e+02 2.9359800338745117e+01 -7.3500000000000000e+01 -2.8598999023437500e+02 2.6303800582885742e+01 -7.3500000000000000e+01 -2.8758599853515625e+02 2.6172901153564453e+01 -7.3500000000000000e+01 -2.8730801391601562e+02 2.9680601119995117e+01 -7.3500000000000000e+01 -2.8722100830078125e+02 2.6395799636840820e+01 -7.3500000000000000e+01 -2.8787899780273438e+02 2.6467201232910156e+01 -7.3500000000000000e+01 -2.8831100463867188e+02 2.9744699478149414e+01 -7.3500000000000000e+01 -2.8784600830078125e+02 2.1312400817871094e+01 -7.3500000000000000e+01 -2.8749902343750000e+02 2.1270799636840820e+01 -7.3500000000000000e+01 -2.8629199218750000e+02 2.1812398910522461e+01 -7.3500000000000000e+01 -2.8707000732421875e+02 2.2128900527954102e+01 -7.3500000000000000e+01 -2.8534701538085938e+02 2.5960498809814453e+01 -7.3500000000000000e+01 -2.8372100830078125e+02 2.5142398834228516e+01 -7.3500000000000000e+01 -2.8645700073242188e+02 2.6864898681640625e+01 -7.3500000000000000e+01 -2.8383200073242188e+02 2.5421899795532227e+01 -7.3500000000000000e+01 -2.8658102416992188e+02 2.7371799468994141e+01 -7.3500000000000000e+01 -2.8397900390625000e+02 2.5422100067138672e+01 -7.3500000000000000e+01 -2.8658102416992188e+02 2.7850799560546875e+01 -7.3500000000000000e+01 -2.8420199584960938e+02 2.5703899383544922e+01 -7.3500000000000000e+01 -2.8676599121093750e+02 2.8351900100708008e+01 -7.3500000000000000e+01 -2.8455200195312500e+02 2.5931600570678711e+01 -7.3500000000000000e+01 -2.8697500610351562e+02 2.8769298553466797e+01 -7.3500000000000000e+01 -2.8496997070312500e+02 2.9081798553466797e+01 -7.3500000000000000e+01 -2.8541897583007812e+02 2.5835399627685547e+01 -7.3500000000000000e+01 -2.8371701049804688e+02 2.5548700332641602e+01 -7.3500000000000000e+01 -2.8372100830078125e+02 2.4715499877929688e+01 -7.3500000000000000e+01 -2.8634799194335938e+02 2.4898899078369141e+01 -7.3500000000000000e+01 -2.8379199218750000e+02 2.4277999877929688e+01 -7.3500000000000000e+01 -2.8630398559570312e+02 2.4265399932861328e+01 -7.3500000000000000e+01 -2.8395501708984375e+02 2.4831600189208984e+01 -7.3500000000000000e+01 -2.9901699829101562e+02 2.8107799530029297e+01 -7.3500000000000000e+01 -2.9901699829101562e+02 2.6435199737548828e+01 -7.3500000000000000e+01 -2.8946600341796875e+02 2.9716800689697266e+01 -7.3500000000000000e+01 -2.8939300537109375e+02 2.2366498947143555e+01 -7.3500000000000000e+01 -2.8671301269531250e+02 2.2366701126098633e+01 -7.3500000000000000e+01 -2.8671301269531250e+02 2.2600999832153320e+01 -7.3500000000000000e+01 -2.8491699218750000e+02 2.2862400054931641e+01 -7.3500000000000000e+01 -2.8649398803710938e+02 2.3113901138305664e+01 -7.3500000000000000e+01 -2.8453601074218750e+02 2.3386999130249023e+01 -7.3500000000000000e+01 -2.8635900878906250e+02 2.3663999557495117e+01 -7.3500000000000000e+01 -2.8421099853515625e+02 2.3925399780273438e+01 -7.3500000000000000e+01 -2.8630300903320312e+02 2.4213399887084961e+01 -7.3500000000000000e+01 -2.8630200195312500e+02 2.9763898849487305e+01 -7.3500000000000000e+01 -2.8847302246093750e+02 2.6484500885009766e+01 -7.3500000000000000e+01 -2.8863497924804688e+02 2.9741098403930664e+01 -7.3500000000000000e+01 -2.8910000610351562e+02 2.6479900360107422e+01 -7.3500000000000000e+01 -2.8895898437500000e+02 2.6456300735473633e+01 -7.3500000000000000e+01 -2.8928198242187500e+02 2.8288200378417969e+01 -7.3882202148437500e+01 -2.9937402343750000e+02 2.8299499511718750e+01 -7.4308799743652344e+01 -2.9938400268554688e+02 2.8310199737548828e+01 -7.3882202148437500e+01 -2.9935501098632812e+02 2.8320199966430664e+01 -7.4308998107910156e+01 -2.9937802124023438e+02 2.8429800033569336e+01 -7.3882202148437500e+01 -2.9925399780273438e+02 2.8435998916625977e+01 -7.4308700561523438e+01 -2.9926199340820312e+02 2.8448900222778320e+01 -7.3883201599121094e+01 -2.9920898437500000e+02 2.8466501235961914e+01 -7.4308593750000000e+01 -2.9923199462890625e+02 2.8145000457763672e+01 -7.3885299682617188e+01 -2.9940798950195312e+02 2.8221899032592773e+01 -7.3883598327636719e+01 -2.9938998413085938e+02 2.4831600189208984e+01 -7.3724098205566406e+01 -2.9937600708007812e+02 2.8107799530029297e+01 -7.3693000793457031e+01 -2.9935900878906250e+02 2.4831600189208984e+01 -7.3695800781250000e+01 -2.9935397338867188e+02 2.8107799530029297e+01 -7.3692199707031250e+01 -2.9935900878906250e+02 2.4831600189208984e+01 -7.3590194702148438e+01 -2.9926998901367188e+02 2.8107799530029297e+01 -7.3551498413085938e+01 -2.9921298217773438e+02 2.8107799530029297e+01 -7.3550598144531250e+01 -2.9921200561523438e+02 2.4831600189208984e+01 -7.3512893676757812e+01 -2.9911801147460938e+02 2.4831600189208984e+01 -7.3559204101562500e+01 -2.9920898437500000e+02 2.4747900009155273e+01 -7.4308204650878906e+01 -2.9942599487304688e+02 2.4795700073242188e+01 -7.3884803771972656e+01 -2.9940899658203125e+02 2.4723300933837891e+01 -7.3882400512695312e+01 -2.9939300537109375e+02 2.4651498794555664e+01 -7.4309501647949219e+01 -2.9938198852539062e+02 2.4663499832153320e+01 -7.3880393981933594e+01 -2.9938000488281250e+02 2.4657800674438477e+01 -7.3880302429199219e+01 -2.9937500000000000e+02 2.4559499740600586e+01 -7.4310600280761719e+01 -2.9933999633789062e+02 2.4526700973510742e+01 -7.3878402709960938e+01 -2.9927502441406250e+02 2.4445999145507812e+01 -7.3880599975585938e+01 -2.9911801147460938e+02 2.4436300277709961e+01 -7.4309600830078125e+01 -2.9913699340820312e+02 2.4446298599243164e+01 -7.3880393981933594e+01 -2.9912298583984375e+02 2.4439500808715820e+01 -7.4310104370117188e+01 -2.9917202758789062e+02 2.4518800735473633e+01 -7.4310401916503906e+01 -2.9928298950195312e+02 2.8279800415039062e+01 -7.3595893859863281e+01 -2.9921200561523438e+02 2.8303501129150391e+01 -7.3553596496582031e+01 -2.9905001831054688e+02 2.8301099777221680e+01 -7.3551200866699219e+01 -2.9904898071289062e+02 2.8407199859619141e+01 -7.3720100402832031e+01 -2.9921200561523438e+02 2.8446100234985352e+01 -7.3696395874023438e+01 -2.9907400512695312e+02 2.8444801330566406e+01 -7.3692001342773438e+01 -2.9907299804687500e+02 2.8285200119018555e+01 -7.3793395996093750e+01 -2.9935900878906250e+02 2.8209699630737305e+01 -7.3719894409179688e+01 -2.9935900878906250e+02 2.4680801391601562e+01 -7.3809402465820312e+01 -2.9937600708007812e+02 2.4565999984741211e+01 -7.3740402221679688e+01 -2.9926998901367188e+02 2.4499698638916016e+01 -7.3700599670410156e+01 -2.9911801147460938e+02 2.4493299484252930e+01 -7.3696395874023438e+01 -2.9895999145507812e+02 2.4638299942016602e+01 -7.3551200866699219e+01 -2.9898501586914062e+02 2.4635900497436523e+01 -7.3553596496582031e+01 -2.9898397827148438e+02 2.4640899658203125e+01 -7.3563003540039062e+01 -2.9911801147460938e+02 2.4494600296020508e+01 -7.3692001342773438e+01 -2.9896099853515625e+02 2.4745000839233398e+01 -7.3746894836425781e+01 -2.9937600708007812e+02 2.4678998947143555e+01 -7.3630302429199219e+01 -2.9926998901367188e+02 2.9732000350952148e+01 -7.3500297546386719e+01 -2.8939501953125000e+02 3.0017898559570312e+01 -7.3639495849609375e+01 -2.8943301391601562e+02 2.9915500640869141e+01 -7.3553695678710938e+01 -2.8941900634765625e+02 2.9910900115966797e+01 -7.3552398681640625e+01 -2.8941900634765625e+02 3.0086399078369141e+01 -7.3754493713378906e+01 -2.8944201660156250e+02 3.0050899505615234e+01 -7.3694900512695312e+01 -2.8943698120117188e+02 2.6101900100708008e+01 -7.3694900512695312e+01 -2.8941598510742188e+02 2.6066501617431641e+01 -7.3754493713378906e+01 -2.8941101074218750e+02 2.6415300369262695e+01 -7.3500495910644531e+01 -2.8946301269531250e+02 2.6241600036621094e+01 -7.3552299499511719e+01 -2.8943698120117188e+02 2.6237199783325195e+01 -7.3553596496582031e+01 -2.8943600463867188e+02 2.6134901046752930e+01 -7.3639396667480469e+01 -2.8942098999023438e+02 3.0082000732421875e+01 -7.3692001342773438e+01 -2.8912298583984375e+02 2.9936599731445312e+01 -7.3551200866699219e+01 -2.8911297607421875e+02 3.0105600357055664e+01 -7.3692001342773438e+01 -2.8847399902343750e+02 3.0085601806640625e+01 -7.3692001342773438e+01 -2.8782299804687500e+02 3.0019001007080078e+01 -7.3692001342773438e+01 -2.8717398071289062e+02 2.9959798812866211e+01 -7.3551200866699219e+01 -2.8847302246093750e+02 2.9940198898315430e+01 -7.3551200866699219e+01 -2.8783300781250000e+02 2.9874698638916016e+01 -7.3551200866699219e+01 -2.8719400024414062e+02 2.6261299133300781e+01 -7.3551200866699219e+01 -2.8926199340820312e+02 2.6116300582885742e+01 -7.3692001342773438e+01 -2.8924798583984375e+02 2.6284198760986328e+01 -7.3551200866699219e+01 -2.8894998168945312e+02 2.6288600921630859e+01 -7.3551200866699219e+01 -2.8863900756835938e+02 2.6272001266479492e+01 -7.3551200866699219e+01 -2.8832901000976562e+02 2.6138599395751953e+01 -7.3692001342773438e+01 -2.8894400024414062e+02 2.6142900466918945e+01 -7.3692001342773438e+01 -2.8864099121093750e+02 2.6126901626586914e+01 -7.3692001342773438e+01 -2.8834201049804688e+02 2.9541698455810547e+01 -7.3551300048828125e+01 -2.8591702270507812e+02 2.9251199722290039e+01 -7.3551200866699219e+01 -2.8532098388671875e+02 2.9676898956298828e+01 -7.3692001342773438e+01 -2.8586199951171875e+02 2.9377199172973633e+01 -7.3692001342773438e+01 -2.8524700927734375e+02 2.9885099411010742e+01 -7.3692001342773438e+01 -2.8649600219726562e+02 2.9744100570678711e+01 -7.3551300048828125e+01 -2.8653298950195312e+02 2.6064199447631836e+01 -7.3692001342773438e+01 -2.8796099853515625e+02 2.6205598831176758e+01 -7.3551300048828125e+01 -2.8792599487304688e+02 2.5985200881958008e+01 -7.3692001342773438e+01 -2.8770898437500000e+02 2.6121000289916992e+01 -7.3551200866699219e+01 -2.8765698242187500e+02 2.5875200271606445e+01 -7.3692001342773438e+01 -2.8747497558593750e+02 2.6002099990844727e+01 -7.3551200866699219e+01 -2.8740399169921875e+02 2.8477701187133789e+01 -7.3551300048828125e+01 -2.8440100097656250e+02 2.7948898315429688e+01 -7.3551200866699219e+01 -2.8403298950195312e+02 2.8571199417114258e+01 -7.3692001342773438e+01 -2.8428900146484375e+02 2.8021900177001953e+01 -7.3692001342773438e+01 -2.8390698242187500e+02 2.9032299041748047e+01 -7.3692001342773438e+01 -2.8475201416015625e+02 2.8920099258422852e+01 -7.3551300048828125e+01 -2.8484500122070312e+02 2.5679899215698242e+01 -7.3692001342773438e+01 -2.8720599365234375e+02 2.5787200927734375e+01 -7.3551300048828125e+01 -2.8710800170898438e+02 2.5493700027465820e+01 -7.3692001342773438e+01 -2.8703497314453125e+02 2.5583398818969727e+01 -7.3551300048828125e+01 -2.8692001342773438e+02 2.5257999420166016e+01 -7.3692001342773438e+01 -2.8688101196289062e+02 2.5327899932861328e+01 -7.3551200866699219e+01 -2.8675299072265625e+02 2.5836000442504883e+01 -7.3501701354980469e+01 -2.8367999267578125e+02 2.5838699340820312e+01 -7.3553596496582031e+01 -2.8351699829101562e+02 2.5838600158691406e+01 -7.3552200317382812e+01 -2.8352099609375000e+02 2.5968599319458008e+01 -7.3551200866699219e+01 -2.8352499389648438e+02 2.5841598510742188e+01 -7.3754493713378906e+01 -2.8334399414062500e+02 2.5840999603271484e+01 -7.3694900512695312e+01 -2.8338000488281250e+02 2.5974599838256836e+01 -7.3692001342773438e+01 -2.8338000488281250e+02 2.5840400695800781e+01 -7.3639305114746094e+01 -2.8341400146484375e+02 2.6906799316406250e+01 -7.3551200866699219e+01 -2.8364102172851562e+02 2.7439701080322266e+01 -7.3551200866699219e+01 -2.8379501342773438e+02 2.6937900543212891e+01 -7.3692001342773438e+01 -2.8349899291992188e+02 2.7490098953247070e+01 -7.3692001342773438e+01 -2.8365798950195312e+02 2.4203100204467773e+01 -7.3754493713378906e+01 -2.8667501831054688e+02 2.4270299911499023e+01 -7.3551200866699219e+01 -2.8650000000000000e+02 2.4208000183105469e+01 -7.3552101135253906e+01 -2.8649801635742188e+02 2.4207899093627930e+01 -7.3553596496582031e+01 -2.8650201416015625e+02 2.4205099105834961e+01 -7.3639305114746094e+01 -2.8660601806640625e+02 2.4264699935913086e+01 -7.3692001342773438e+01 -2.8664599609375000e+02 2.4204200744628906e+01 -7.3694900512695312e+01 -2.8663900756835938e+02 2.4212099075317383e+01 -7.3502700805664062e+01 -2.8634899902343750e+02 2.4659198760986328e+01 -7.3692001342773438e+01 -2.8668499755859375e+02 2.5027700424194336e+01 -7.3692001342773438e+01 -2.8677801513671875e+02 2.4683198928833008e+01 -7.3551200866699219e+01 -2.8654098510742188e+02 2.5076700210571289e+01 -7.3551200866699219e+01 -2.8664099121093750e+02 2.4155899047851562e+01 -7.3692001342773438e+01 -2.8363101196289062e+02 2.3506099700927734e+01 -7.3692001342773438e+01 -2.8390802001953125e+02 2.3573400497436523e+01 -7.3551200866699219e+01 -2.8403698730468750e+02 2.5534198760986328e+01 -7.3692001342773438e+01 -2.8338000488281250e+02 2.5540399551391602e+01 -7.3551300048828125e+01 -2.8352600097656250e+02 2.4838701248168945e+01 -7.3692001342773438e+01 -2.8345599365234375e+02 2.4864299774169922e+01 -7.3551300048828125e+01 -2.8359899902343750e+02 2.4202701568603516e+01 -7.3551300048828125e+01 -2.8376901245117188e+02 2.3932199478149414e+01 -7.3551300048828125e+01 -2.8649899291992188e+02 2.3937299728393555e+01 -7.3692001342773438e+01 -2.8664401245117188e+02 2.3421001434326172e+01 -7.3551300048828125e+01 -2.8655200195312500e+02 2.2926399230957031e+01 -7.3551300048828125e+01 -2.8667898559570312e+02 2.2460599899291992e+01 -7.3551200866699219e+01 -2.8688497924804688e+02 2.3446298599243164e+01 -7.3692001342773438e+01 -2.8669500732421875e+02 2.2973899841308594e+01 -7.3692001342773438e+01 -2.8681701660156250e+02 2.2530399322509766e+01 -7.3692001342773438e+01 -2.8701300048828125e+02 2.1127799987792969e+01 -7.3597404479980469e+01 -2.8619799804687500e+02 2.1166200637817383e+01 -7.3586601257324219e+01 -2.8617999267578125e+02 2.1139299392700195e+01 -7.3601402282714844e+01 -2.8617501831054688e+02 2.0845800399780273e+01 -7.3500000000000000e+01 -2.8676599121093750e+02 2.1507301330566406e+01 -7.3839904785156250e+01 -2.8543402099609375e+02 2.1886899948120117e+01 -7.3692001342773438e+01 -2.8510601806640625e+02 2.1488300323486328e+01 -7.3788597106933594e+01 -2.8547201538085938e+02 2.1424999237060547e+01 -7.3700004577636719e+01 -2.8559899902343750e+02 2.1412099838256836e+01 -7.3695602416992188e+01 -2.8562500000000000e+02 2.1990100860595703e+01 -7.3551200866699219e+01 -2.8520797729492188e+02 2.2476301193237305e+01 -7.3551300048828125e+01 -2.8476501464843750e+02 2.3005500793457031e+01 -7.3551300048828125e+01 -2.8437298583984375e+02 2.2383600234985352e+01 -7.3692001342773438e+01 -2.8465301513671875e+02 2.2924900054931641e+01 -7.3692001342773438e+01 -2.8425100708007812e+02 2.1227701187133789e+01 -7.3757698059082031e+01 -2.8813800048828125e+02 2.1166601181030273e+01 -7.3645500183105469e+01 -2.8810900878906250e+02 2.1193399429321289e+01 -7.3694602966308594e+01 -2.8812200927734375e+02 2.1551000595092773e+01 -7.3692001342773438e+01 -2.8774398803710938e+02 2.1060100555419922e+01 -7.3553504943847656e+01 -2.8805899047851562e+02 2.1074399948120117e+01 -7.3559700012207031e+01 -2.8806600952148438e+02 2.1449201583862305e+01 -7.3551300048828125e+01 -2.8763897705078125e+02 2.0958398818969727e+01 -7.3509399414062500e+01 -2.8801101684570312e+02 2.0882299423217773e+01 -7.3500000000000000e+01 -2.8797598266601562e+02 2.2017299652099609e+01 -7.3692001342773438e+01 -2.8734298706054688e+02 2.2530300140380859e+01 -7.3692001342773438e+01 -2.8701300048828125e+02 2.1929899215698242e+01 -7.3551300048828125e+01 -2.8722698974609375e+02 2.2460500717163086e+01 -7.3551200866699219e+01 -2.8688497924804688e+02 2.2716001510620117e+01 -7.3884803771972656e+01 -2.7696801757812500e+02 2.2774299621582031e+01 -7.4308403015136719e+01 -2.7695300292968750e+02 2.2789598464965820e+01 -7.3882202148437500e+01 -2.7698498535156250e+02 2.2862300872802734e+01 -7.4309600830078125e+01 -2.7699499511718750e+02 2.2850099563598633e+01 -7.3880096435546875e+01 -2.7699801635742188e+02 2.2855798721313477e+01 -7.3880096435546875e+01 -2.7700299072265625e+02 2.2960300445556641e+01 -7.4310798645019531e+01 -2.7704302978515625e+02 2.2988000869750977e+01 -7.3877998352050781e+01 -2.7710598754882812e+02 2.3067100524902344e+01 -7.3880302429199219e+01 -2.7726699829101562e+02 2.3078001022338867e+01 -7.4309806823730469e+01 -2.7724700927734375e+02 2.3066999435424805e+01 -7.3880096435546875e+01 -2.7726199340820312e+02 2.3075799942016602e+01 -7.4310195922851562e+01 -2.7721499633789062e+02 2.2996601104736328e+01 -7.4310600280761719e+01 -2.7709698486328125e+02 2.3016498565673828e+01 -7.3697097778320312e+01 -2.7742498779296875e+02 2.3014999389648438e+01 -7.3692001342773438e+01 -2.7742498779296875e+02 2.2875000000000000e+01 -7.3554199218750000e+01 -2.7739797973632812e+02 2.2872098922729492e+01 -7.3551200866699219e+01 -2.7739700317382812e+02 1.9262901306152344e+01 -7.3692001342773438e+01 -2.9907699584960938e+02 1.9119499206542969e+01 -7.3551200866699219e+01 -2.9905099487304688e+02 1.9122098922729492e+01 -7.3553802490234375e+01 -2.9905200195312500e+02 1.9264299392700195e+01 -7.3696601867675781e+01 -2.9907699584960938e+02 1.9105798721313477e+01 -7.3882293701171875e+01 -2.9937402343750000e+02 1.9116901397705078e+01 -7.4308799743652344e+01 -2.9938400268554688e+02 1.9128799438476562e+01 -7.3882293701171875e+01 -2.9935501098632812e+02 1.9138799667358398e+01 -7.4308898925781250e+01 -2.9937802124023438e+02 1.9246999740600586e+01 -7.3882293701171875e+01 -2.9925601196289062e+02 1.9252899169921875e+01 -7.4308593750000000e+01 -2.9926400756835938e+02 1.9267400741577148e+01 -7.3883300781250000e+01 -2.9920898437500000e+02 1.9285001754760742e+01 -7.4308502197265625e+01 -2.9923199462890625e+02 1.8963500976562500e+01 -7.3885299682617188e+01 -2.9940798950195312e+02 1.9039999008178711e+01 -7.3883697509765625e+01 -2.9938998413085938e+02 2.2679698944091797e+01 -7.3559204101562500e+01 -2.7716699218750000e+02 2.2679698944091797e+01 -7.3510902404785156e+01 -2.7726699829101562e+02 2.2871299743652344e+01 -7.3561401367187500e+01 -2.7726699829101562e+02 2.2679698944091797e+01 -7.3695693969726562e+01 -2.7702297973632812e+02 2.2679698944091797e+01 -7.3586906433105469e+01 -2.7711099243164062e+02 2.2833900451660156e+01 -7.3627502441406250e+01 -2.7711099243164062e+02 2.2948099136352539e+01 -7.3738700866699219e+01 -2.7711099243164062e+02 2.2832500457763672e+01 -7.3808197021484375e+01 -2.7700100708007812e+02 2.2767400741577148e+01 -7.3744804382324219e+01 -2.7700100708007812e+02 2.2679698944091797e+01 -7.3721801757812500e+01 -2.7700100708007812e+02 2.3013200759887695e+01 -7.3699493408203125e+01 -2.7726699829101562e+02 1.9098499298095703e+01 -7.3595893859863281e+01 -2.9921200561523438e+02 1.9225898742675781e+01 -7.3720001220703125e+01 -2.9921200561523438e+02 1.9103899002075195e+01 -7.3793395996093750e+01 -2.9935900878906250e+02 1.9028398513793945e+01 -7.3719894409179688e+01 -2.9935900878906250e+02 1.8926500320434570e+01 -7.3693000793457031e+01 -2.9935900878906250e+02 1.8926500320434570e+01 -7.3692199707031250e+01 -2.9935900878906250e+02 1.8926500320434570e+01 -7.3551498413085938e+01 -2.9921298217773438e+02 1.8926500320434570e+01 -7.3550598144531250e+01 -2.9921200561523438e+02 1.9220399856567383e+01 -7.3882202148437500e+01 -2.7700299072265625e+02 1.9209199905395508e+01 -7.4308799743652344e+01 -2.7699301147460938e+02 1.9197700500488281e+01 -7.3882202148437500e+01 -2.7702200317382812e+02 1.9187700271606445e+01 -7.4308898925781250e+01 -2.7699899291992188e+02 1.9079099655151367e+01 -7.3882202148437500e+01 -2.7712197875976562e+02 1.9073101043701172e+01 -7.4308593750000000e+01 -2.7711297607421875e+02 1.9059099197387695e+01 -7.3883300781250000e+01 -2.7716799926757812e+02 1.9041400909423828e+01 -7.4308593750000000e+01 -2.7714498901367188e+02 1.9362998962402344e+01 -7.3885299682617188e+01 -2.7696899414062500e+02 1.9286399841308594e+01 -7.3883697509765625e+01 -2.7698699951171875e+02 1.9400098800659180e+01 -7.3693000793457031e+01 -2.7701699829101562e+02 1.9400098800659180e+01 -7.3692199707031250e+01 -2.7701800537109375e+02 1.9400098800659180e+01 -7.3551498413085938e+01 -2.7716400146484375e+02 1.9400098800659180e+01 -7.3550598144531250e+01 -2.7716500854492188e+02 1.5649600028991699e+01 -7.3723602294921875e+01 -2.9937600708007812e+02 1.5649600028991699e+01 -7.3695800781250000e+01 -2.9935397338867188e+02 1.5649600028991699e+01 -7.3589492797851562e+01 -2.9926898193359375e+02 1.5649600028991699e+01 -7.3512397766113281e+01 -2.9911599731445312e+02 1.5649600028991699e+01 -7.3559204101562500e+01 -2.9920898437500000e+02 1.5613599777221680e+01 -7.3884803771972656e+01 -2.9940899658203125e+02 1.5563799858093262e+01 -7.4308296203613281e+01 -2.9942599487304688e+02 1.5541000366210938e+01 -7.3882293701171875e+01 -2.9939300537109375e+02 1.5468999862670898e+01 -7.4309501647949219e+01 -2.9938198852539062e+02 1.5481100082397461e+01 -7.3880302429199219e+01 -2.9937899780273438e+02 1.5475199699401855e+01 -7.3880203247070312e+01 -2.9937500000000000e+02 1.5375800132751465e+01 -7.4310699462890625e+01 -2.9933898925781250e+02 1.5344000816345215e+01 -7.3878303527832031e+01 -2.9927398681640625e+02 1.5263600349426270e+01 -7.3880500793457031e+01 -2.9911599731445312e+02 1.5253600120544434e+01 -7.4309600830078125e+01 -2.9913601684570312e+02 1.5263899803161621e+01 -7.3880302429199219e+01 -2.9912100219726562e+02 1.5256700515747070e+01 -7.4310195922851562e+01 -2.9916998291015625e+02 1.5336000442504883e+01 -7.4310493469238281e+01 -2.9928201293945312e+02 1.9222698211669922e+01 -7.3793395996093750e+01 -2.7701699829101562e+02 1.9100601196289062e+01 -7.3720001220703125e+01 -2.7716500854492188e+02 1.9207000732421875e+01 -7.3551200866699219e+01 -2.7732598876953125e+02 1.9228099822998047e+01 -7.3595893859863281e+01 -2.7716500854492188e+02 1.9204498291015625e+01 -7.3553695678710938e+01 -2.7732598876953125e+02 1.9063400268554688e+01 -7.3692001342773438e+01 -2.7730102539062500e+02 1.9062099456787109e+01 -7.3696502685546875e+01 -2.7730102539062500e+02 1.9298198699951172e+01 -7.3719894409179688e+01 -2.7701699829101562e+02 1.5498399734497070e+01 -7.3809104919433594e+01 -2.9937600708007812e+02 1.5383399963378906e+01 -7.3740104675292969e+01 -2.9926898193359375e+02 1.5317399978637695e+01 -7.3700401306152344e+01 -2.9911599731445312e+02 1.5311599731445312e+01 -7.3696502685546875e+01 -2.9895898437500000e+02 1.5456500053405762e+01 -7.3551200866699219e+01 -2.9898397827148438e+02 1.5453999519348145e+01 -7.3553695678710938e+01 -2.9898300170898438e+02 1.5458700180053711e+01 -7.3562698364257812e+01 -2.9911599731445312e+02 1.5312899589538574e+01 -7.3692001342773438e+01 -2.9895898437500000e+02 1.5562700271606445e+01 -7.3746505737304688e+01 -2.9937600708007812e+02 1.5496700286865234e+01 -7.3629798889160156e+01 -2.9926898193359375e+02 1.3316100120544434e+01 -7.4309295654296875e+01 -2.9398098754882812e+02 1.3327600479125977e+01 -7.4011398315429688e+01 -2.9400100708007812e+02 1.3337599754333496e+01 -7.4309600830078125e+01 -2.9399298095703125e+02 1.3464500427246094e+01 -7.4009498596191406e+01 -2.9410202026367188e+02 1.3567700386047363e+01 -7.4309196472167969e+01 -2.9427499389648438e+02 1.3554500579833984e+01 -7.4309600830078125e+01 -2.9424099731445312e+02 1.3546999931335449e+01 -7.4011398315429688e+01 -2.9425100708007812e+02 1.3519199371337891e+01 -7.4310493469238281e+01 -2.9414999389648438e+02 1.3432100296020508e+01 -7.4310493469238281e+01 -2.9404800415039062e+02 1.3542200088500977e+01 -7.3880699157714844e+01 -2.9426199340820312e+02 1.3330200195312500e+01 -7.3880393981933594e+01 -2.9401098632812500e+02 1.3459300041198730e+01 -7.3878601074218750e+01 -2.9410699462890625e+02 1.3541799545288086e+01 -7.3880599975585938e+01 -2.9425601196289062e+02 1.3164199829101562e+01 -7.3885704040527344e+01 -2.9397000122070312e+02 1.3178899765014648e+01 -7.3885101318359375e+01 -2.9397100830078125e+02 1.3195499420166016e+01 -7.3884498596191406e+01 -2.9397198486328125e+02 1.3198699951171875e+01 -7.3884399414062500e+01 -2.9397198486328125e+02 1.3240999221801758e+01 -7.3882896423339844e+01 -2.9397900390625000e+02 1.3322400093078613e+01 -7.3880599975585938e+01 -2.9400500488281250e+02 1.3497200012207031e+01 -7.3692001342773438e+01 -2.9441699218750000e+02 1.3506500244140625e+01 -7.3723197937011719e+01 -2.9441897583007812e+02 1.3502699851989746e+01 -7.3726600646972656e+01 -2.9426199340820312e+02 1.3242599487304688e+01 -7.3524101257324219e+01 -2.9426199340820312e+02 1.3225499153137207e+01 -7.3600799560546875e+01 -2.9411300659179688e+02 1.3158100128173828e+01 -7.3527404785156250e+01 -2.9426501464843750e+02 1.3157400131225586e+01 -7.3551200866699219e+01 -2.9417398071289062e+02 1.3156300544738770e+01 -7.3692001342773438e+01 -2.9402801513671875e+02 1.3196599960327148e+01 -7.3730499267578125e+01 -2.9401000976562500e+02 1.3156199455261230e+01 -7.3728897094726562e+01 -2.9401699829101562e+02 1.3313899993896484e+01 -7.3821800231933594e+01 -2.9401000976562500e+02 1.3432499885559082e+01 -7.3762001037597656e+01 -2.9411300659179688e+02 1.3242500305175781e+01 -7.3522094726562500e+01 -2.9438201904296875e+02 1.3353000640869141e+01 -7.3551300048828125e+01 -2.9439700317382812e+02 1.3395400047302246e+01 -7.3596099853515625e+01 -2.9426199340820312e+02 1.3347099304199219e+01 -7.3658195495605469e+01 -2.9411300659179688e+02 1.3265500068664551e+01 -7.3762901306152344e+01 -2.9401000976562500e+02 1.0045000076293945e+01 -7.3885597229003906e+01 -2.9399801635742188e+02 9.7185993194580078e+00 -7.4307998657226562e+01 -2.9416900634765625e+02 9.9239902496337891e+00 -7.4308296203613281e+01 -2.9400198364257812e+02 9.8942098617553711e+00 -7.4308296203613281e+01 -2.9401901245117188e+02 9.9001102447509766e+00 -7.4005500793457031e+01 -2.9402600097656250e+02 9.8070106506347656e+00 -7.4308593750000000e+01 -2.9406802368164062e+02 9.7657003402709961e+00 -7.4005500793457031e+01 -2.9412600708007812e+02 9.7617998123168945e+00 -7.4308296203613281e+01 -2.9412002563476562e+02 9.9717998504638672e+00 -7.3884300231933594e+01 -2.9401498413085938e+02 9.7288894653320312e+00 -7.3884498596191406e+01 -2.9420300292968750e+02 9.7689895629882812e+00 -7.3882995605468750e+01 -2.9413000488281250e+02 9.8679103851318359e+00 -7.3882995605468750e+01 -2.9405599975585938e+02 9.9034004211425781e+00 -7.3882995605468750e+01 -2.9402999877929688e+02 1.0067500114440918e+01 -7.3692901611328125e+01 -2.9405099487304688e+02 1.0067500114440918e+01 -7.3692001342773438e+01 -2.9405099487304688e+02 1.0068599700927734e+01 -7.3551200866699219e+01 -2.9419699096679688e+02 1.0068599700927734e+01 -7.3550903320312500e+01 -2.9419799804687500e+02 1.3230500221252441e+01 -7.3551300048828125e+01 -2.9501901245117188e+02 1.3371700286865234e+01 -7.3692001342773438e+01 -2.9505499267578125e+02 1.3158300399780273e+01 -7.3692001342773438e+01 -2.9571200561523438e+02 1.3022999763488770e+01 -7.3551300048828125e+01 -2.9565899658203125e+02 1.2860399246215820e+01 -7.3692001342773438e+01 -2.9633798217773438e+02 1.2733400344848633e+01 -7.3551200866699219e+01 -2.9626699829101562e+02 9.8929996490478516e+00 -7.3792602539062500e+01 -2.9405099487304688e+02 9.7712993621826172e+00 -7.3718894958496094e+01 -2.9419799804687500e+02 9.8825998306274414e+00 -7.3551300048828125e+01 -2.9433599853515625e+02 9.9001102447509766e+00 -7.3594802856445312e+01 -2.9419799804687500e+02 9.8784999847412109e+00 -7.3555404663085938e+01 -2.9433502197265625e+02 9.7431993484497070e+00 -7.3692001342773438e+01 -2.9429400634765625e+02 9.7409000396728516e+00 -7.3699798583984375e+01 -2.9429299926757812e+02 9.9692907333374023e+00 -7.3719001770019531e+01 -2.9405099487304688e+02 1.2277999877929688e+01 -7.3692001342773438e+01 -2.9720397949218750e+02 1.2164299964904785e+01 -7.3551300048828125e+01 -2.9711300659179688e+02 1.1825300216674805e+01 -7.3692001342773438e+01 -2.9770898437500000e+02 1.1722399711608887e+01 -7.3551300048828125e+01 -2.9760598754882812e+02 1.1319800376892090e+01 -7.3692001342773438e+01 -2.9815997314453125e+02 1.1228799819946289e+01 -7.3551200866699219e+01 -2.9804699707031250e+02 8.7841005325317383e+00 -7.3692001342773438e+01 -2.9577099609375000e+02 9.5573091506958008e+00 -7.3551300048828125e+01 -2.9508297729492188e+02 8.8777999877929688e+00 -7.3551200866699219e+01 -2.9588299560546875e+02 9.4319000244140625e+00 -7.3692001342773438e+01 -2.9500799560546875e+02 1.0412099838256836e+01 -7.3692001342773438e+01 -2.9877001953125000e+02 1.0341199874877930e+01 -7.3551300048828125e+01 -2.9864300537109375e+02 9.8101100921630859e+00 -7.3692001342773438e+01 -2.9906698608398438e+02 9.7520999908447266e+00 -7.3551300048828125e+01 -2.9893301391601562e+02 9.1844100952148438e+00 -7.3692001342773438e+01 -2.9930401611328125e+02 9.1391105651855469e+00 -7.3551200866699219e+01 -2.9916598510742188e+02 7.1194000244140625e+00 -7.3692001342773438e+01 -2.9640798950195312e+02 6.8095002174377441e+00 -7.3553596496582031e+01 -2.9655398559570312e+02 6.8094000816345215e+00 -7.3552200317382812e+01 -2.9655798339843750e+02 7.1278100013732910e+00 -7.3551300048828125e+01 -2.9655297851562500e+02 6.8062000274658203e+00 -7.3502197265625000e+01 -2.9671200561523438e+02 6.8116002082824707e+00 -7.3639305114746094e+01 -2.9645098876953125e+02 6.8123002052307129e+00 -7.3694900512695312e+01 -2.9641699218750000e+02 6.8130898475646973e+00 -7.3754493713378906e+01 -2.9638098144531250e+02 8.0081996917724609e+00 -7.3692001342773438e+01 -2.9622598266601562e+02 8.0594997406005859e+00 -7.3551300048828125e+01 -2.9636199951171875e+02 8.0216999053955078e+00 -7.3692001342773438e+01 -2.9958200073242188e+02 7.9995999336242676e+00 -7.3551300048828125e+01 -2.9943798828125000e+02 7.3614001274108887e+00 -7.3692001342773438e+01 -2.9965298461914062e+02 7.3522000312805176e+00 -7.3551300048828125e+01 -2.9950799560546875e+02 6.6987996101379395e+00 -7.3692001342773438e+01 -2.9966598510742188e+02 6.7020101547241211e+00 -7.3551200866699219e+01 -2.9952099609375000e+02 5.7247996330261230e+00 -7.3551300048828125e+01 -2.9632199096679688e+02 5.2827000617980957e+00 -7.3551200866699219e+01 -2.9599899291992188e+02 5.7904000282287598e+00 -7.3692001342773438e+01 -2.9619198608398438e+02 5.3871998786926270e+00 -7.3692001342773438e+01 -2.9589700317382812e+02 6.4208097457885742e+00 -7.3692001342773438e+01 -2.9638201904296875e+02 6.3998003005981445e+00 -7.3551300048828125e+01 -2.9652600097656250e+02 5.5180897712707520e+00 -7.3551300048828125e+01 -2.9940399169921875e+02 6.7020101547241211e+00 -7.3551300048828125e+01 -2.9952099609375000e+02 5.4922003746032715e+00 -7.3692001342773438e+01 -2.9954800415039062e+02 3.8052000999450684e+00 -7.3692001342773438e+01 -2.9897299194335938e+02 4.6311001777648926e+00 -7.3692001342773438e+01 -2.9932998657226562e+02 3.8745999336242676e+00 -7.3551200866699219e+01 -2.9884500122070312e+02 4.6772999763488770e+00 -7.3551200866699219e+01 -2.9919100952148438e+02 4.7863001823425293e+00 -7.3551300048828125e+01 -2.9527999877929688e+02 4.5959000587463379e+00 -7.3551200866699219e+01 -2.9473901367187500e+02 4.9182000160217285e+00 -7.3692001342773438e+01 -2.9521899414062500e+02 4.7372999191284180e+00 -7.3692001342773438e+01 -2.9470397949218750e+02 5.1244997978210449e+00 -7.3692001342773438e+01 -2.9557800292968750e+02 5.0046000480651855e+00 -7.3551300048828125e+01 -2.9566000366210938e+02 2.7857999801635742e+00 -7.3692001342773438e+01 -2.9827099609375000e+02 2.8812999725341797e+00 -7.3551300048828125e+01 -2.9816101074218750e+02 2.2940998077392578e+00 -7.3692001342773438e+01 -2.9778500366210938e+02 2.4031000137329102e+00 -7.3551300048828125e+01 -2.9768899536132812e+02 1.8700000047683716e+00 -7.3692001342773438e+01 -2.9723999023437500e+02 1.9905098676681519e+00 -7.3551200866699219e+01 -2.9715798950195312e+02 4.4495997428894043e+00 -7.3551200866699219e+01 -2.9366400146484375e+02 4.4502997398376465e+00 -7.3551200866699219e+01 -2.9320401000976562e+02 4.5952000617980957e+00 -7.3692001342773438e+01 -2.9365899658203125e+02 4.5959000587463379e+00 -7.3692001342773438e+01 -2.9320999145507812e+02 4.6287999153137207e+00 -7.3692001342773438e+01 -2.9410202026367188e+02 4.4840998649597168e+00 -7.3551200866699219e+01 -2.9411898803710938e+02 1.5105999708175659e+00 -7.3692001342773438e+01 -2.9664199829101562e+02 1.6395000219345093e+00 -7.3551300048828125e+01 -2.9657400512695312e+02 1.2225999832153320e+00 -7.3692001342773438e+01 -2.9601800537109375e+02 1.3579000234603882e+00 -7.3551300048828125e+01 -2.9596398925781250e+02 8.4940403699874878e-01 -7.3692001342773438e+01 -2.9475000000000000e+02 9.9220198392868042e-01 -7.3551200866699219e+01 -2.9472100830078125e+02 4.5517997741699219e+00 -7.3550598144531250e+01 -2.9173800659179688e+02 4.5120000839233398e+00 -7.3551200866699219e+01 -2.9216598510742188e+02 4.5541000366210938e+00 -7.3551200866699219e+01 -2.9173898315429688e+02 4.6981000900268555e+00 -7.3691101074218750e+01 -2.9175399780273438e+02 4.6571998596191406e+00 -7.3692001342773438e+01 -2.9217800903320312e+02 4.6990003585815430e+00 -7.3692001342773438e+01 -2.9175399780273438e+02 4.6258096694946289e+00 -7.3692001342773438e+01 -2.9260501098632812e+02 4.4802999496459961e+00 -7.3551200866699219e+01 -2.9259500122070312e+02 8.6680102348327637e-01 -7.3551200866699219e+01 -2.9390002441406250e+02 7.2190201282501221e-01 -7.3692001342773438e+01 -2.9391500854492188e+02 6.7020303010940552e-01 -7.3692001342773438e+01 -2.9308001708984375e+02 8.1600302457809448e-01 -7.3551300048828125e+01 -2.9307800292968750e+02 7.2610402107238770e-01 -7.3692001342773438e+01 -2.9178500366210938e+02 8.7110000848770142e-01 -7.3551200866699219e+01 -2.9179998779296875e+02 4.5954999923706055e+00 -7.3551605224609375e+01 -2.9132598876953125e+02 4.4300003051757812e+00 -7.3500900268554688e+01 -2.9130599975585938e+02 4.7372999191284180e+00 -7.3693794250488281e+01 -2.9134197998046875e+02 4.7049002647399902e+00 -7.3639396667480469e+01 -2.9133901977539062e+02 4.6022000312805176e+00 -7.3553596496582031e+01 -2.9132598876953125e+02 4.5977997779846191e+00 -7.3552299499511719e+01 -2.9132598876953125e+02 4.7734999656677246e+00 -7.3754493713378906e+01 -2.9134698486328125e+02 4.7380003929138184e+00 -7.3694900512695312e+01 -2.9134197998046875e+02 7.3940402269363403e-01 -7.3754493713378906e+01 -2.9135800170898438e+02 7.7499502897262573e-01 -7.3694900512695312e+01 -2.9136199951171875e+02 8.0820202827453613e-01 -7.3639305114746094e+01 -2.9136499023437500e+02 9.1099798679351807e-01 -7.3553596496582031e+01 -2.9137600708007812e+02 9.1530400514602661e-01 -7.3552200317382812e+01 -2.9137701416015625e+02 1.0721000432968140e+00 -7.3501800537109375e+01 -2.9139398193359375e+02 4.7873997688293457e+00 -7.3551200866699219e+01 -2.9025500488281250e+02 4.9340000152587891e+00 -7.3551200866699219e+01 -2.8966000366210938e+02 4.9295997619628906e+00 -7.3692001342773438e+01 -2.9028698730468750e+02 5.0746998786926270e+00 -7.3692001342773438e+01 -2.8969799804687500e+02 4.8123998641967773e+00 -7.3692001342773438e+01 -2.9088000488281250e+02 4.6689000129699707e+00 -7.3551200866699219e+01 -2.9085601806640625e+02 1.0061999559402466e+00 -7.3551200866699219e+01 -2.9073901367187500e+02 8.6259901523590088e-01 -7.3692001342773438e+01 -2.9071398925781250e+02 1.1513000726699829e+00 -7.3692001342773438e+01 -2.8946099853515625e+02 1.2912000417709351e+00 -7.3551300048828125e+01 -2.8950198364257812e+02 1.5845999717712402e+00 -7.3692001342773438e+01 -2.8824899291992188e+02 1.7187000513076782e+00 -7.3551200866699219e+01 -2.8830599975585938e+02 5.3440999984741211e+00 -7.3551200866699219e+01 -2.8855899047851562e+02 5.6121897697448730e+00 -7.3551200866699219e+01 -2.8807601928710938e+02 5.4748997688293457e+00 -7.3692001342773438e+01 -2.8862399291992188e+02 5.7358002662658691e+00 -7.3692001342773438e+01 -2.8815298461914062e+02 5.2625999450683594e+00 -7.3692001342773438e+01 -2.8911401367187500e+02 5.1262998580932617e+00 -7.3551200866699219e+01 -2.8906301879882812e+02 2.0945000648498535e+00 -7.3551300048828125e+01 -2.8752401733398438e+02 2.5404000282287598e+00 -7.3551300048828125e+01 -2.8678900146484375e+02 3.3458001613616943e+00 -7.3551200866699219e+01 -2.8577899169921875e+02 1.9663000106811523e+00 -7.3692001342773438e+01 -2.8745498657226562e+02 2.4198000431060791e+00 -7.3692001342773438e+01 -2.8670700073242188e+02 3.2393999099731445e+00 -7.3692001342773438e+01 -2.8567901611328125e+02 6.3517999649047852e+00 -7.3551300048828125e+01 -2.8721499633789062e+02 6.7750997543334961e+00 -7.3551200866699219e+01 -2.8690600585937500e+02 6.4460000991821289e+00 -7.3692001342773438e+01 -2.8732601928710938e+02 6.8525099754333496e+00 -7.3692001342773438e+01 -2.8702999877929688e+02 6.0946097373962402e+00 -7.3692001342773438e+01 -2.8767098999023438e+02 5.9853897094726562e+00 -7.3551300048828125e+01 -2.8757501220703125e+02 3.8724999427795410e+00 -7.3692001342773438e+01 -2.8507598876953125e+02 3.9665000438690186e+00 -7.3551300048828125e+01 -2.8518798828125000e+02 4.5631999969482422e+00 -7.3692001342773438e+01 -2.8455999755859375e+02 4.6434001922607422e+00 -7.3551300048828125e+01 -2.8468200683593750e+02 5.6742997169494629e+00 -7.3692001342773438e+01 -2.8395397949218750e+02 5.7333002090454102e+00 -7.3551200866699219e+01 -2.8408798217773438e+02 8.1984996795654297e+00 -7.3692001342773438e+01 -2.8663302612304688e+02 8.5511093139648438e+00 -7.3553596496582031e+01 -2.8648800659179688e+02 8.5511999130249023e+00 -7.3552299499511719e+01 -2.8648300170898438e+02 8.1904993057250977e+00 -7.3551300048828125e+01 -2.8648800659179688e+02 8.5576000213623047e+00 -7.3501106262207031e+01 -2.8631799316406250e+02 8.5469903945922852e+00 -7.3639305114746094e+01 -2.8659100341796875e+02 8.5458002090454102e+00 -7.3694900512695312e+01 -2.8662500000000000e+02 8.5444002151489258e+00 -7.3754493713378906e+01 -2.8665997314453125e+02 7.6224102973937988e+00 -7.3692001342773438e+01 -2.8671398925781250e+02 7.5890998840332031e+00 -7.3551300048828125e+01 -2.8657202148437500e+02 6.5819001197814941e+00 -7.3692001342773438e+01 -2.8363201904296875e+02 6.6204099655151367e+00 -7.3551300048828125e+01 -2.8377200317382812e+02 7.5034098625183105e+00 -7.3692001342773438e+01 -2.8344500732421875e+02 7.5229001045227051e+00 -7.3551300048828125e+01 -2.8358901977539062e+02 8.8338003158569336e+00 -7.3692001342773438e+01 -2.8337500000000000e+02 8.8302097320556641e+00 -7.3551200866699219e+01 -2.8352099609375000e+02 8.7129001617431641e+00 -7.3551200866699219e+01 -2.8649499511718750e+02 8.6995992660522461e+00 -7.3692001342773438e+01 -2.8663998413085938e+02 9.0228004455566406e+00 -7.3692001342773438e+01 -2.8668698120117188e+02 9.3297996520996094e+00 -7.3692001342773438e+01 -2.8677099609375000e+02 9.6133098602294922e+00 -7.3692001342773438e+01 -2.8689501953125000e+02 9.6134004592895508e+00 -7.3692001342773438e+01 -2.8689501953125000e+02 9.6829996109008789e+00 -7.3551200866699219e+01 -2.8676699829101562e+02 9.0518999099731445e+00 -7.3551200866699219e+01 -2.8654400634765625e+02 9.3778991699218750e+00 -7.3551200866699219e+01 -2.8663302612304688e+02 9.6828899383544922e+00 -7.3551200866699219e+01 -2.8676699829101562e+02 8.8309097290039062e+00 -7.3551200866699219e+01 -2.8352099609375000e+02 8.8302097320556641e+00 -7.3551300048828125e+01 -2.8352099609375000e+02 8.8339996337890625e+00 -7.3692001342773438e+01 -2.8337500000000000e+02 9.9245004653930664e+00 -7.3551300048828125e+01 -2.8362399291992188e+02 1.0575500488281250e+01 -7.3551200866699219e+01 -2.8377398681640625e+02 1.1207099914550781e+01 -7.3551200866699219e+01 -2.8400100708007812e+02 9.9495096206665039e+00 -7.3692001342773438e+01 -2.8347998046875000e+02 1.0616200447082520e+01 -7.3692001342773438e+01 -2.8363400268554688e+02 1.1264900207519531e+01 -7.3692001342773438e+01 -2.8386700439453125e+02 1.0436999320983887e+01 -7.3551200866699219e+01 -2.8745599365234375e+02 1.0437300682067871e+01 -7.3551200866699219e+01 -2.8745700073242188e+02 1.0315500259399414e+01 -7.3692001342773438e+01 -2.8753701782226562e+02 1.0315599441528320e+01 -7.3692001342773438e+01 -2.8753701782226562e+02 1.0126800537109375e+01 -7.3551300048828125e+01 -2.8708700561523438e+02 9.9156999588012695e+00 -7.3551300048828125e+01 -2.8691299438476562e+02 1.0026999473571777e+01 -7.3692001342773438e+01 -2.8719299316406250e+02 9.8305902481079102e+00 -7.3692001342773438e+01 -2.8703201293945312e+02 1.1865300178527832e+01 -7.3551300048828125e+01 -2.8433999633789062e+02 1.1941099166870117e+01 -7.3692001342773438e+01 -2.8421597290039062e+02 1.2550299644470215e+01 -7.3692001342773438e+01 -2.8465301513671875e+02 1.2456500053405762e+01 -7.3551300048828125e+01 -2.8476397705078125e+02 1.3053199768066406e+01 -7.3692001342773438e+01 -2.8514297485351562e+02 1.2944100379943848e+01 -7.3551200866699219e+01 -2.8523901367187500e+02 1.0835300445556641e+01 -7.3551200866699219e+01 -2.8841799926757812e+02 1.0835399627685547e+01 -7.3551200866699219e+01 -2.8841799926757812e+02 1.0692999839782715e+01 -7.3692001342773438e+01 -2.8845001220703125e+02 1.0693099975585938e+01 -7.3692001342773438e+01 -2.8845001220703125e+02 1.0696999549865723e+01 -7.3551300048828125e+01 -2.8795999145507812e+02 1.0580200195312500e+01 -7.3551300048828125e+01 -2.8770101928710938e+02 1.0561400413513184e+01 -7.3692001342773438e+01 -2.8801300048828125e+02 1.0450599670410156e+01 -7.3692001342773438e+01 -2.8776800537109375e+02 1.3402299880981445e+01 -7.3551300048828125e+01 -2.8584399414062500e+02 1.3524700164794922e+01 -7.3692001342773438e+01 -2.8576498413085938e+02 1.3891699790954590e+01 -7.3692001342773438e+01 -2.8643301391601562e+02 1.3759500503540039e+01 -7.3551300048828125e+01 -2.8649398803710938e+02 1.4143499374389648e+01 -7.3692001342773438e+01 -2.8707098388671875e+02 1.4005100250244141e+01 -7.3551200866699219e+01 -2.8711700439453125e+02 1.0935500144958496e+01 -7.4008796691894531e+01 -2.8944097900390625e+02 1.0930599212646484e+01 -7.4309196472167969e+01 -2.8945401000976562e+02 1.1058099746704102e+01 -7.4307907104492188e+01 -2.8949600219726562e+02 1.0750499725341797e+01 -7.4308700561523438e+01 -2.8926000976562500e+02 1.0785699844360352e+01 -7.4309104919433594e+01 -2.8931399536132812e+02 1.0790900230407715e+01 -7.4008796691894531e+01 -2.8930700683593750e+02 1.0824000358581543e+01 -7.4309501647949219e+01 -2.8937200927734375e+02 1.0926100730895996e+01 -7.4309196472167969e+01 -2.8945098876953125e+02 1.0786999702453613e+01 -7.3882102966308594e+01 -2.8927902221679688e+02 1.1009999275207520e+01 -7.3883201599121094e+01 -2.8945498657226562e+02 1.0939699172973633e+01 -7.3881599426269531e+01 -2.8943698120117188e+02 1.0927200317382812e+01 -7.3881599426269531e+01 -2.8942498779296875e+02 1.0795099258422852e+01 -7.3881599426269531e+01 -2.8930300903320312e+02 1.1091400146484375e+01 -7.3885101318359375e+01 -2.8947500610351562e+02 1.0935200691223145e+01 -7.3551200866699219e+01 -2.8910101318359375e+02 1.0925399780273438e+01 -7.3551200866699219e+01 -2.8898800659179688e+02 1.0934099197387695e+01 -7.3552398681640625e+01 -2.8910101318359375e+02 1.0780399322509766e+01 -7.3692001342773438e+01 -2.8900201416015625e+02 1.0789999961853027e+01 -7.3692001342773438e+01 -2.8911199951171875e+02 1.0789099693298340e+01 -7.3694702148437500e+01 -2.8911199951171875e+02 1.0744799613952637e+01 -7.3692001342773438e+01 -2.8872399902343750e+02 1.0888799667358398e+01 -7.3551200866699219e+01 -2.8870202636718750e+02 1.4493000030517578e+01 -7.3694305419921875e+01 -2.8907202148437500e+02 1.4347599983215332e+01 -7.3552200317382812e+01 -2.8907800292968750e+02 1.4492199897766113e+01 -7.3692001342773438e+01 -2.8907202148437500e+02 1.4490900039672852e+01 -7.3692001342773438e+01 -2.8903799438476562e+02 1.4345300674438477e+01 -7.3551200866699219e+01 -2.8904501342773438e+02 1.4346599578857422e+01 -7.3551200866699219e+01 -2.8907800292968750e+02 1.4435400009155273e+01 -7.3692001342773438e+01 -2.8837600708007812e+02 1.4321399688720703e+01 -7.3692001342773438e+01 -2.8771798706054688e+02 1.4290900230407715e+01 -7.3551300048828125e+01 -2.8839401245117188e+02 1.4179200172424316e+01 -7.3551200866699219e+01 -2.8774899291992188e+02 1.4556099891662598e+01 -7.4308593750000000e+01 -2.8918798828125000e+02 1.4528800010681152e+01 -7.4009498596191406e+01 -2.8923199462890625e+02 1.4534399986267090e+01 -7.4309104919433594e+01 -2.8924099731445312e+02 1.4505200386047363e+01 -7.4309806823730469e+01 -2.8931201171875000e+02 1.4443200111389160e+01 -7.4007896423339844e+01 -2.8936700439453125e+02 1.4415999412536621e+01 -7.4309898376464844e+01 -2.8941299438476562e+02 1.4320899963378906e+01 -7.4309196472167969e+01 -2.8946499633789062e+02 1.4311800003051758e+01 -7.4009498596191406e+01 -2.8945800781250000e+02 1.4298499107360840e+01 -7.4308898925781250e+01 -2.8947799682617188e+02 1.4313400268554688e+01 -7.3881401062011719e+01 -2.8944900512695312e+02 1.4307200431823730e+01 -7.3881401062011719e+01 -2.8945300292968750e+02 1.4251800537109375e+01 -7.3882995605468750e+01 -2.8946499633789062e+02 1.4184299468994141e+01 -7.3885002136230469e+01 -2.8947799682617188e+02 1.4438699722290039e+01 -7.3879798889160156e+01 -2.8936300659179688e+02 1.4524200439453125e+01 -7.3881401062011719e+01 -2.8922799682617188e+02 1.4525099754333496e+01 -7.3881599426269531e+01 -2.8922299194335938e+02 1.0953200340270996e+01 -7.3793395996093750e+01 -2.8942800903320312e+02 1.1028699874877930e+01 -7.3719894409179688e+01 -2.8942800903320312e+02 1.1130700111389160e+01 -7.3693000793457031e+01 -2.8942800903320312e+02 1.0831099510192871e+01 -7.3720100402832031e+01 -2.8927999877929688e+02 1.0958600044250488e+01 -7.3596000671386719e+01 -2.8927999877929688e+02 1.1130700111389160e+01 -7.3550598144531250e+01 -2.8927999877929688e+02 1.1130700111389160e+01 -7.3551498413085938e+01 -2.8928100585937500e+02 1.1130700111389160e+01 -7.3692199707031250e+01 -2.8942700195312500e+02 1.4150799751281738e+01 -7.3524299621582031e+01 -2.8922299194335938e+02 1.4335899353027344e+01 -7.3573097229003906e+01 -2.8922299194335938e+02 1.4472900390625000e+01 -7.3706596374511719e+01 -2.8922299194335938e+02 1.4402099609375000e+01 -7.3749099731445312e+01 -2.8935800170898438e+02 1.4291799545288086e+01 -7.3815299987792969e+01 -2.8944998168945312e+02 1.4231800079345703e+01 -7.3756797790527344e+01 -2.8944998168945312e+02 1.4150799751281738e+01 -7.3557800292968750e+01 -2.8927801513671875e+02 1.4295100212097168e+01 -7.3645004272460938e+01 -2.8935800170898438e+02 1.4150799751281738e+01 -7.3735496520996094e+01 -2.8944998168945312e+02 1.4150799751281738e+01 -7.3695899963378906e+01 -2.8942199707031250e+02 1.4150799751281738e+01 -7.3606994628906250e+01 -2.8935800170898438e+02 -2.1614899635314941e+00 -7.4307701110839844e+01 -2.9916799926757812e+02 -2.1979000568389893e+00 -7.4308097839355469e+01 -2.9924301147460938e+02 -2.2030999660491943e+00 -7.4003501892089844e+01 -2.9923800659179688e+02 -2.2197000980377197e+00 -7.4308403015136719e+01 -2.9928900146484375e+02 -2.3046998977661133e+00 -7.4003501892089844e+01 -2.9936001586914062e+02 -2.2969999313354492e+00 -7.4308204650878906e+01 -2.9936599731445312e+02 -2.3148000240325928e+00 -7.4308097839355469e+01 -2.9938400268554688e+02 -2.3087999820709229e+00 -7.3883399963378906e+01 -2.9935699462890625e+02 -2.3016998767852783e+00 -7.3883399963378906e+01 -2.9934899902343750e+02 -2.2070999145507812e+00 -7.3883399963378906e+01 -2.9923400878906250e+02 -2.1999001502990723e+00 -7.3883804321289062e+01 -2.9921099853515625e+02 -2.3821001052856445e+00 -7.3582199096679688e+01 -2.9921200561523438e+02 -2.3647999763488770e+00 -7.3551101684570312e+01 -2.9906298828125000e+02 -2.2185997962951660e+00 -7.3693794250488281e+01 -2.9907699584960938e+02 -2.2190999984741211e+00 -7.3692001342773438e+01 -2.9907699584960938e+02 -2.2479999065399170e+00 -7.3711700439453125e+01 -2.9921200561523438e+02 -2.3643000125885010e+00 -7.3551200866699219e+01 -2.9906298828125000e+02 -2.3371000289916992e+00 -7.3765502929687500e+01 -2.9935000610351562e+02 -2.4660999774932861e+00 -7.3692001342773438e+01 -2.9937402343750000e+02 -2.4645998477935791e+00 -7.3710205078125000e+01 -2.9938000488281250e+02 -2.4328999519348145e+00 -7.3673095703125000e+01 -2.9935000610351562e+02 -2.4556000232696533e+00 -7.3819999694824219e+01 -2.9941101074218750e+02 -2.5124998092651367e+00 -7.3544898986816406e+01 -2.9921099853515625e+02 -2.5059001445770264e+00 -7.3551200866699219e+01 -2.9923400878906250e+02 -2.4742000102996826e+00 -7.3663299560546875e+01 -2.9934600830078125e+02 -2.0534999370574951e+00 -7.4012199401855469e+01 -2.9630801391601562e+02 -2.1919999122619629e+00 -7.4309898376464844e+01 -2.9620501708984375e+02 -2.2030000686645508e+00 -7.4014297485351562e+01 -2.9621499633789062e+02 -2.1988999843597412e+00 -7.4309806823730469e+01 -2.9620098876953125e+02 -2.3317999839782715e+00 -7.4307701110839844e+01 -2.9618200683593750e+02 -1.9338999986648560e+00 -7.4309402465820312e+01 -2.9648400878906250e+02 -1.9507999420166016e+00 -7.4309806823730469e+01 -2.9644598388671875e+02 -1.9578000307083130e+00 -7.4014297485351562e+01 -2.9645498657226562e+02 -1.9880999326705933e+00 -7.4310798645019531e+01 -2.9636099243164062e+02 -2.0798997879028320e+00 -7.4310897827148438e+01 -2.9626300048828125e+02 -1.9608000516891479e+00 -7.3880599975585938e+01 -2.9647698974609375e+02 -2.1726999282836914e+00 -7.3879501342773438e+01 -2.9624301147460938e+02 -2.0586998462677002e+00 -7.3877899169921875e+01 -2.9631298828125000e+02 -1.9630999565124512e+00 -7.3880004882812500e+01 -2.9646099853515625e+02 -2.3631999492645264e+00 -7.3885200500488281e+01 -2.9620001220703125e+02 -2.3453998565673828e+00 -7.3884498596191406e+01 -2.9619900512695312e+02 -2.3387000560760498e+00 -7.3884193420410156e+01 -2.9619900512695312e+02 -2.3192000389099121e+00 -7.3883506774902344e+01 -2.9620001220703125e+02 -2.2990000247955322e+00 -7.3882804870605469e+01 -2.9620098876953125e+02 -2.2944998741149902e+00 -7.3882598876953125e+01 -2.9620098876953125e+02 -2.2082998752593994e+00 -7.3880004882812500e+01 -2.9622097778320312e+02 -2.2875001430511475e+00 -7.3513198852539062e+01 -2.9660299682617188e+02 -2.1428000926971436e+00 -7.3551200866699219e+01 -2.9661599731445312e+02 -1.9912998676300049e+00 -7.3713302612304688e+01 -2.9663000488281250e+02 -1.9976000785827637e+00 -7.3692001342773438e+01 -2.9662899780273438e+02 -2.7125999927520752e+00 -7.3551200866699219e+01 -2.9928900146484375e+02 -2.6775999069213867e+00 -7.3692001342773438e+01 -2.9943099975585938e+02 -3.0072999000549316e+00 -7.3692001342773438e+01 -2.9950299072265625e+02 -3.0346999168395996e+00 -7.3551200866699219e+01 -2.9936001586914062e+02 -3.3404998779296875e+00 -7.3692001342773438e+01 -2.9955700683593750e+02 -3.3601000308990479e+00 -7.3551200866699219e+01 -2.9941299438476562e+02 -2.0729000568389893e+00 -7.3758102416992188e+01 -2.9633502197265625e+02 -2.3763999938964844e+00 -7.3692001342773438e+01 -2.9625897216796875e+02 -2.3668999671936035e+00 -7.3610496520996094e+01 -2.9634298706054688e+02 -2.2980999946594238e+00 -7.3602104187011719e+01 -2.9633502197265625e+02 -2.3600001335144043e+00 -7.3551200866699219e+01 -2.9640399169921875e+02 -2.3513998985290527e+00 -7.3531303405761719e+01 -2.9648001098632812e+02 -2.2874000072479248e+00 -7.3522399902343750e+01 -2.9647601318359375e+02 -2.3783998489379883e+00 -7.3750999450683594e+01 -2.9624200439453125e+02 -2.3807001113891602e+00 -7.3820800781250000e+01 -2.9622097778320312e+02 -2.3773999214172363e+00 -7.3723197937011719e+01 -2.9625000000000000e+02 -2.3152999877929688e+00 -7.3731101989746094e+01 -2.9623699951171875e+02 -2.2409000396728516e+00 -7.3760002136230469e+01 -2.9623699951171875e+02 -2.1877000331878662e+00 -7.3819602966308594e+01 -2.9623699951171875e+02 -2.1208999156951904e+00 -7.3586906433105469e+01 -2.9647601318359375e+02 -2.0020999908447266e+00 -7.3720199584960938e+01 -2.9647601318359375e+02 -2.1667001247406006e+00 -7.3652900695800781e+01 -2.9633502197265625e+02 -4.5373997688293457e+00 -7.3754493713378906e+01 -2.9965298461914062e+02 -4.5341997146606445e+00 -7.3553596496582031e+01 -2.9948101806640625e+02 -4.5362000465393066e+00 -7.3639305114746094e+01 -2.9958401489257812e+02 -4.3313999176025391e+00 -7.3692001342773438e+01 -2.9962399291992188e+02 -4.5367999076843262e+00 -7.3694900512695312e+01 -2.9961700439453125e+02 -4.3316998481750488e+00 -7.3551200866699219e+01 -2.9947900390625000e+02 -4.5341997146606445e+00 -7.3552200317382812e+01 -2.9947598266601562e+02 -4.5313000679016113e+00 -7.3501998901367188e+01 -2.9932098388671875e+02 -4.0004997253417969e+00 -7.3692001342773438e+01 -2.9961700439453125e+02 -3.6700000762939453e+00 -7.3692001342773438e+01 -2.9959402465820312e+02 -4.0071001052856445e+00 -7.3551200866699219e+01 -2.9947097778320312e+02 -3.6828999519348145e+00 -7.3551200866699219e+01 -2.9944900512695312e+02 -2.4757001399993896e+00 -7.3551200866699219e+01 -2.9641699218750000e+02 -2.4928998947143555e+00 -7.3692001342773438e+01 -2.9627297973632812e+02 -4.5401997566223145e+00 -7.3551200866699219e+01 -2.9947702026367188e+02 -4.5423002243041992e+00 -7.3692001342773438e+01 -2.9962200927734375e+02 -5.1231999397277832e+00 -7.3551200866699219e+01 -2.9943902587890625e+02 -5.7040996551513672e+00 -7.3551200866699219e+01 -2.9933300781250000e+02 -6.2701001167297363e+00 -7.3551200866699219e+01 -2.9913800048828125e+02 -5.1402997970581055e+00 -7.3692001342773438e+01 -2.9958401489257812e+02 -5.7402997016906738e+00 -7.3692001342773438e+01 -2.9947399902343750e+02 -6.3295998573303223e+00 -7.3692001342773438e+01 -2.9927099609375000e+02 -3.1577999591827393e+00 -7.3500404357910156e+01 -2.9660299682617188e+02 -3.1461999416351318e+00 -7.3553695678710938e+01 -2.9642199707031250e+02 -3.1465001106262207e+00 -7.3552398681640625e+01 -2.9642599487304688e+02 -3.0028998851776123e+00 -7.3551200866699219e+01 -2.9643600463867188e+02 -3.1351997852325439e+00 -7.3754493713378906e+01 -2.9624899291992188e+02 -3.1373999118804932e+00 -7.3694900512695312e+01 -2.9628500366210938e+02 -2.9960000514984131e+00 -7.3692001342773438e+01 -2.9629000854492188e+02 -3.1396000385284424e+00 -7.3639396667480469e+01 -2.9631799316406250e+02 -2.8264999389648438e+00 -7.3551200866699219e+01 -2.9643899536132812e+02 -2.6507000923156738e+00 -7.3551200866699219e+01 -2.9643301391601562e+02 -2.8275001049041748e+00 -7.3692001342773438e+01 -2.9629400634765625e+02 -2.6597001552581787e+00 -7.3692001342773438e+01 -2.9628802490234375e+02 -6.7393002510070801e+00 -7.3551300048828125e+01 -2.9888201904296875e+02 -6.8193998336791992e+00 -7.3692001342773438e+01 -2.9900399780273438e+02 -7.1054000854492188e+00 -7.3551300048828125e+01 -2.9859701538085938e+02 -7.4292001724243164e+00 -7.3551200866699219e+01 -2.9824600219726562e+02 -7.2038002014160156e+00 -7.3692001342773438e+01 -2.9870501708984375e+02 -7.5444002151489258e+00 -7.3692001342773438e+01 -2.9833499145507812e+02 -4.0580000877380371e+00 -7.3692001342773438e+01 -2.9599600219726562e+02 -4.1987996101379395e+00 -7.3692001342773438e+01 -2.9581298828125000e+02 -4.3281002044677734e+00 -7.3551200866699219e+01 -2.9588000488281250e+02 -3.4333000183105469e+00 -7.3551200866699219e+01 -2.9640100097656250e+02 -3.4129998683929443e+00 -7.3692001342773438e+01 -2.9625698852539062e+02 -3.8517000675201416e+00 -7.3692001342773438e+01 -2.9613302612304688e+02 -3.9149000644683838e+00 -7.3551300048828125e+01 -2.9626501464843750e+02 -4.1566996574401855e+00 -7.3551300048828125e+01 -2.9610299682617188e+02 -7.8515996932983398e+00 -7.3692001342773438e+01 -2.9785900878906250e+02 -8.2037000656127930e+00 -7.3692001342773438e+01 -2.9690798950195312e+02 -8.0619001388549805e+00 -7.3551200866699219e+01 -2.9687500000000000e+02 -8.0581998825073242e+00 -7.3692001342773438e+01 -2.9739599609375000e+02 -7.9213995933532715e+00 -7.3551300048828125e+01 -2.9734600830078125e+02 -7.7231001853942871e+00 -7.3551300048828125e+01 -2.9779101562500000e+02 -4.4642000198364258e+00 -7.3553695678710938e+01 -2.9460202026367188e+02 -4.4686999320983887e+00 -7.3552398681640625e+01 -2.9460202026367188e+02 -4.4702997207641602e+00 -7.3554397583007812e+01 -2.9460702514648438e+02 -4.6449003219604492e+00 -7.3500404357910156e+01 -2.9457598876953125e+02 -4.3618998527526855e+00 -7.3639396667480469e+01 -2.9461700439453125e+02 -4.2815999984741211e+00 -7.3812400817871094e+01 -2.9462899780273438e+02 -4.2934999465942383e+00 -7.3754493713378906e+01 -2.9462701416015625e+02 -4.3310003280639648e+00 -7.3695999145507812e+01 -2.9462701416015625e+02 -4.3288998603820801e+00 -7.3694900512695312e+01 -2.9462200927734375e+02 -4.4963998794555664e+00 -7.3551200866699219e+01 -2.9498699951171875e+02 -4.4327001571655273e+00 -7.3551200866699219e+01 -2.9560598754882812e+02 -4.3508000373840332e+00 -7.3692001342773438e+01 -2.9498999023437500e+02 -4.2918000221252441e+00 -7.3692001342773438e+01 -2.9556799316406250e+02 -8.1689004898071289e+00 -7.3551200866699219e+01 -2.9620700073242188e+02 -8.3426008224487305e+00 -7.3754493713378906e+01 -2.9506497192382812e+02 -8.3368997573852539e+00 -7.3692001342773438e+01 -2.9553298950195312e+02 -8.3070001602172852e+00 -7.3694900512695312e+01 -2.9506900024414062e+02 -8.2740001678466797e+00 -7.3639495849609375e+01 -2.9507299804687500e+02 -8.1714000701904297e+00 -7.3553695678710938e+01 -2.9508599853515625e+02 -8.1912994384765625e+00 -7.3551200866699219e+01 -2.9553601074218750e+02 -8.1668004989624023e+00 -7.3552398681640625e+01 -2.9508599853515625e+02 -7.9867997169494629e+00 -7.3500198364257812e+01 -2.9510900878906250e+02 -8.3140001296997070e+00 -7.3692001342773438e+01 -2.9622000122070312e+02 -2.9299001693725586e+00 -7.3785202026367188e+01 -2.8665600585937500e+02 -2.9649999141693115e+00 -7.3692001342773438e+01 -2.8661502075195312e+02 -3.0880000591278076e+00 -7.3551200866699219e+01 -2.8646902465820312e+02 -6.9351000785827637e+00 -7.3692001342773438e+01 -2.8661502075195312e+02 -6.9840002059936523e+00 -7.3785202026367188e+01 -2.8665600585937500e+02 -6.7638001441955566e+00 -7.3551200866699219e+01 -2.8646902465820312e+02 -4.3559798598289490e-01 -7.3882202148437500e+01 -2.8663000488281250e+02 -4.2449599504470825e-01 -7.4308799743652344e+01 -2.8663998413085938e+02 -4.1289600729942322e-01 -7.3882202148437500e+01 -2.8661099243164062e+02 -4.0280002355575562e-01 -7.4308898925781250e+01 -2.8663400268554688e+02 -2.9440200328826904e-01 -7.3882202148437500e+01 -2.8651101684570312e+02 -2.8839698433876038e-01 -7.4308593750000000e+01 -2.8652001953125000e+02 -2.7419599890708923e-01 -7.3883300781250000e+01 -2.8646499633789062e+02 -2.5659799575805664e-01 -7.4308593750000000e+01 -2.8648800659179688e+02 -5.7809799909591675e-01 -7.3885299682617188e+01 -2.8666400146484375e+02 -5.0159496068954468e-01 -7.3883697509765625e+01 -2.8664599609375000e+02 -6.1520099639892578e-01 -7.3693000793457031e+01 -2.8661502075195312e+02 -6.1520099639892578e-01 -7.3692199707031250e+01 -2.8661401367187500e+02 -6.1520099639892578e-01 -7.3551498413085938e+01 -2.8646902465820312e+02 -6.1520099639892578e-01 -7.3550598144531250e+01 -2.8646798706054688e+02 -8.7687997817993164e+00 -7.3512397766113281e+01 -2.8637200927734375e+02 -8.7687997817993164e+00 -7.3723503112792969e+01 -2.8663198852539062e+02 -8.7687997817993164e+00 -7.3695800781250000e+01 -2.8661001586914062e+02 -8.7687997817993164e+00 -7.3589302062988281e+01 -2.8652502441406250e+02 -8.7687997817993164e+00 -7.3559204101562500e+01 -2.8646499633789062e+02 -8.8046998977661133e+00 -7.3884803771972656e+01 -2.8666497802734375e+02 -8.8550996780395508e+00 -7.4308296203613281e+01 -2.8668200683593750e+02 -8.8774003982543945e+00 -7.3882293701171875e+01 -2.8664898681640625e+02 -8.9494991302490234e+00 -7.4309501647949219e+01 -2.8663800048828125e+02 -8.9373998641967773e+00 -7.3880302429199219e+01 -2.8663500976562500e+02 -8.9432001113891602e+00 -7.3880203247070312e+01 -2.8663098144531250e+02 -9.0429992675781250e+00 -7.4310699462890625e+01 -2.8659500122070312e+02 -9.0745000839233398e+00 -7.3878303527832031e+01 -2.8652999877929688e+02 -9.1548004150390625e+00 -7.3880500793457031e+01 -2.8637200927734375e+02 -9.1647996902465820e+00 -7.4309600830078125e+01 -2.8639099121093750e+02 -9.1546001434326172e+00 -7.3880302429199219e+01 -2.8637701416015625e+02 -9.1618003845214844e+00 -7.4310195922851562e+01 -2.8642498779296875e+02 -9.0824995040893555e+00 -7.4310493469238281e+01 -2.8653799438476562e+02 -5.1330000162124634e-01 -7.3719894409179688e+01 -2.8661502075195312e+02 -4.3779599666595459e-01 -7.3793395996093750e+01 -2.8661502075195312e+02 -3.1579998135566711e-01 -7.3720001220703125e+01 -2.8646798706054688e+02 -4.4310000538825989e-01 -7.3595893859863281e+01 -2.8646798706054688e+02 -4.1960102319717407e-01 -7.3553802490234375e+01 -2.8630700683593750e+02 -4.2220199108123779e-01 -7.3551200866699219e+01 -2.8630700683593750e+02 -2.7859899401664734e-01 -7.3692001342773438e+01 -2.8633200073242188e+02 -2.7729502320289612e-01 -7.3696502685546875e+01 -2.8633200073242188e+02 -8.9200000762939453e+00 -7.3809104919433594e+01 -2.8663198852539062e+02 -9.0350103378295898e+00 -7.3739997863769531e+01 -2.8652502441406250e+02 -9.1009998321533203e+00 -7.3700302124023438e+01 -2.8637200927734375e+02 -9.1066999435424805e+00 -7.3696502685546875e+01 -2.8621398925781250e+02 -8.9617996215820312e+00 -7.3551200866699219e+01 -2.8623898315429688e+02 -8.9643993377685547e+00 -7.3553802490234375e+01 -2.8623898315429688e+02 -8.9595994949340820e+00 -7.3562599182128906e+01 -2.8637200927734375e+02 -9.1054000854492188e+00 -7.3692001342773438e+01 -2.8621398925781250e+02 -8.8556995391845703e+00 -7.3746398925781250e+01 -2.8663198852539062e+02 -8.9216995239257812e+00 -7.3629600524902344e+01 -2.8652502441406250e+02 -1.3390100002288818e-01 -7.4308296203613281e+01 -2.8360098266601562e+02 -1.8429699540138245e-01 -7.3884803771972656e+01 -2.8361801147460938e+02 -1.1160200089216232e-01 -7.3882293701171875e+01 -2.8363400268554688e+02 -3.9599400013685226e-02 -7.4309501647949219e+01 -2.8364498901367188e+02 -5.1699098199605942e-02 -7.3880302429199219e+01 -2.8364801025390625e+02 -4.5895099639892578e-02 -7.3880203247070312e+01 -2.8365200805664062e+02 5.3898002952337265e-02 -7.4310699462890625e+01 -2.8368801879882812e+02 8.5503302514553070e-02 -7.3878303527832031e+01 -2.8375302124023438e+02 1.6579800844192505e-01 -7.3880500793457031e+01 -2.8391098022460938e+02 1.7580400407314301e-01 -7.4309600830078125e+01 -2.8389199829101562e+02 1.6550000011920929e-01 -7.3880302429199219e+01 -2.8390600585937500e+02 1.7280200123786926e-01 -7.4310195922851562e+01 -2.8385800170898438e+02 9.3497797846794128e-02 -7.4310493469238281e+01 -2.8374499511718750e+02 1.1770500242710114e-01 -7.3696502685546875e+01 -2.8406900024414062e+02 1.1630400270223618e-01 -7.3692001342773438e+01 -2.8406900024414062e+02 -2.4698199704289436e-02 -7.3553802490234375e+01 -2.8404400634765625e+02 -2.7201600372791290e-02 -7.3551200866699219e+01 -2.8404299926757812e+02 -8.5667991638183594e+00 -7.3551200866699219e+01 -2.8397598266601562e+02 -8.7117004394531250e+00 -7.3696502685546875e+01 -2.8395101928710938e+02 -8.7102994918823242e+00 -7.3692001342773438e+01 -2.8395101928710938e+02 -8.5692996978759766e+00 -7.3553802490234375e+01 -2.8397598266601562e+02 -8.7322998046875000e+00 -7.4308593750000000e+01 -2.8379501342773438e+02 -8.7146997451782227e+00 -7.3883300781250000e+01 -2.8381799316406250e+02 -8.7005004882812500e+00 -7.4308593750000000e+01 -2.8376300048828125e+02 -8.6946001052856445e+00 -7.3882202148437500e+01 -2.8377200317382812e+02 -8.5861005783081055e+00 -7.4308898925781250e+01 -2.8364898681640625e+02 -8.5760993957519531e+00 -7.3882202148437500e+01 -2.8367199707031250e+02 -8.5643997192382812e+00 -7.4308799743652344e+01 -2.8364300537109375e+02 -8.5532007217407227e+00 -7.3882202148437500e+01 -2.8365298461914062e+02 -8.4872999191284180e+00 -7.3883697509765625e+01 -2.8363699340820312e+02 -8.4106998443603516e+00 -7.3885299682617188e+01 -2.8361898803710938e+02 -2.2029799222946167e-01 -7.3559204101562500e+01 -2.8381799316406250e+02 -2.2029799222946167e-01 -7.3512397766113281e+01 -2.8391098022460938e+02 -2.9399499297142029e-02 -7.3562599182128906e+01 -2.8391098022460938e+02 -2.2029799222946167e-01 -7.3695800781250000e+01 -2.8367297363281250e+02 -2.2029799222946167e-01 -7.3589401245117188e+01 -2.8375802612304688e+02 -6.7300602793693542e-02 -7.3629600524902344e+01 -2.8375802612304688e+02 4.6000298112630844e-02 -7.3739997863769531e+01 -2.8375802612304688e+02 -6.8999394774436951e-02 -7.3809104919433594e+01 -2.8365100097656250e+02 -1.3340200483798981e-01 -7.3746398925781250e+01 -2.8365100097656250e+02 -2.2029799222946167e-01 -7.3723503112792969e+01 -2.8365100097656250e+02 1.1199799925088882e-01 -7.3700302124023438e+01 -2.8391098022460938e+02 -8.3737001419067383e+00 -7.3692199707031250e+01 -2.8366799926757812e+02 -8.3737001419067383e+00 -7.3693000793457031e+01 -2.8366799926757812e+02 -8.4756002426147461e+00 -7.3719894409179688e+01 -2.8366799926757812e+02 -8.5511007308959961e+00 -7.3793395996093750e+01 -2.8366799926757812e+02 -8.6732006072998047e+00 -7.3720001220703125e+01 -2.8381500244140625e+02 -8.5457000732421875e+00 -7.3595893859863281e+01 -2.8381500244140625e+02 -8.3737001419067383e+00 -7.3551498413085938e+01 -2.8381402587890625e+02 -8.3737001419067383e+00 -7.3550598144531250e+01 -2.8381500244140625e+02 -2.6241998672485352e+00 -7.3551200866699219e+01 -2.8381402587890625e+02 -2.4009997844696045e+00 -7.3785202026367188e+01 -2.8362701416015625e+02 -2.4506001472473145e+00 -7.3692001342773438e+01 -2.8366799926757812e+02 -6.4545998573303223e+00 -7.3785202026367188e+01 -2.8362701416015625e+02 -6.4196000099182129e+00 -7.3692001342773438e+01 -2.8366799926757812e+02 -6.2968897819519043e+00 -7.3551200866699219e+01 -2.8381402587890625e+02 -2.0822999477386475e+00 -7.4308296203613281e+01 -2.7970498657226562e+02 -2.1335000991821289e+00 -7.3884803771972656e+01 -2.7972201538085938e+02 -2.0606999397277832e+00 -7.3882293701171875e+01 -2.7973800659179688e+02 -1.9886000156402588e+00 -7.4309501647949219e+01 -2.7974899291992188e+02 -2.0006999969482422e+00 -7.3880302429199219e+01 -2.7975100708007812e+02 -1.9948999881744385e+00 -7.3880203247070312e+01 -2.7975601196289062e+02 -1.8947000503540039e+00 -7.4310699462890625e+01 -2.7979202270507812e+02 -1.8634999990463257e+00 -7.3878303527832031e+01 -2.7985699462890625e+02 -1.7832999229431152e+00 -7.3880500793457031e+01 -2.8001498413085938e+02 -1.7732000350952148e+00 -7.4309600830078125e+01 -2.7999600219726562e+02 -1.7835999727249146e+00 -7.3880302429199219e+01 -2.8001000976562500e+02 -1.7761000394821167e+00 -7.4310195922851562e+01 -2.7996200561523438e+02 -1.8554000854492188e+00 -7.4310493469238281e+01 -2.7984899902343750e+02 -1.8330999612808228e+00 -7.3692001342773438e+01 -2.8017300415039062e+02 -1.8316899538040161e+00 -7.3696601867675781e+01 -2.8017300415039062e+02 -1.9739998579025269e+00 -7.3553802490234375e+01 -2.8014801025390625e+02 -1.9765000343322754e+00 -7.3551200866699219e+01 -2.8014697265625000e+02 -5.7948999404907227e+00 -7.3692001342773438e+01 -2.8005499267578125e+02 -5.6512999534606934e+00 -7.3551200866699219e+01 -2.8007998657226562e+02 -5.6538896560668945e+00 -7.3553695678710938e+01 -2.8007998657226562e+02 -5.7962999343872070e+00 -7.3696502685546875e+01 -2.8005499267578125e+02 -5.6380000114440918e+00 -7.3882202148437500e+01 -2.7975601196289062e+02 -5.6490998268127441e+00 -7.4308799743652344e+01 -2.7974700927734375e+02 -5.6606001853942871e+00 -7.3882202148437500e+01 -2.7977600097656250e+02 -5.6705999374389648e+00 -7.4308898925781250e+01 -2.7975198364257812e+02 -5.7793998718261719e+00 -7.3882202148437500e+01 -2.7987600708007812e+02 -5.7852997779846191e+00 -7.4308593750000000e+01 -2.7986700439453125e+02 -5.7992000579833984e+00 -7.3883300781250000e+01 -2.7992199707031250e+02 -5.8169002532958984e+00 -7.4308593750000000e+01 -2.7989898681640625e+02 -5.4952998161315918e+00 -7.3885299682617188e+01 -2.7972299194335938e+02 -5.5718998908996582e+00 -7.3883697509765625e+01 -2.7974099731445312e+02 -2.1695001125335693e+00 -7.3559204101562500e+01 -2.7992098999023438e+02 -2.1695001125335693e+00 -7.3512199401855469e+01 -2.8001498413085938e+02 -1.9785999059677124e+00 -7.3562400817871094e+01 -2.8001498413085938e+02 -2.1695001125335693e+00 -7.3695800781250000e+01 -2.7977697753906250e+02 -2.1695001125335693e+00 -7.3589103698730469e+01 -2.7986199951171875e+02 -2.0164999961853027e+00 -7.3629402160644531e+01 -2.7986199951171875e+02 -1.9029999971389771e+00 -7.3739799499511719e+01 -2.7986199951171875e+02 -2.0181000232696533e+00 -7.3808998107910156e+01 -2.7975500488281250e+02 -2.0824999809265137e+00 -7.3746200561523438e+01 -2.7975500488281250e+02 -2.1695001125335693e+00 -7.3723304748535156e+01 -2.7975500488281250e+02 -1.8371000289916992e+00 -7.3700195312500000e+01 -2.8001498413085938e+02 -5.4583001136779785e+00 -7.3692199707031250e+01 -2.7977200317382812e+02 -5.4583001136779785e+00 -7.3693000793457031e+01 -2.7977099609375000e+02 -5.5601000785827637e+00 -7.3719894409179688e+01 -2.7977099609375000e+02 -5.6357002258300781e+00 -7.3793395996093750e+01 -2.7977099609375000e+02 -5.7576999664306641e+00 -7.3720001220703125e+01 -2.7991900634765625e+02 -5.6303000450134277e+00 -7.3595893859863281e+01 -2.7991900634765625e+02 -5.4583001136779785e+00 -7.3551498413085938e+01 -2.7991799926757812e+02 -5.4583001136779785e+00 -7.3550598144531250e+01 -2.7991900634765625e+02 -1.4433800697326660e+01 -7.4308799743652344e+01 -2.9480499267578125e+02 -1.4389800071716309e+01 -7.4012596130371094e+01 -2.9480099487304688e+02 -1.4387599945068359e+01 -7.4309196472167969e+01 -2.9479101562500000e+02 -1.4304899215698242e+01 -7.4309997558593750e+01 -2.9476699829101562e+02 -1.4228699684143066e+01 -7.4010902404785156e+01 -2.9478100585937500e+02 -1.4170900344848633e+01 -7.4310104370117188e+01 -2.9477502441406250e+02 -1.4046899795532227e+01 -7.4309104919433594e+01 -2.9482598876953125e+02 -1.4073300361633301e+01 -7.4309196472167969e+01 -2.9481500244140625e+02 -1.4072899818420410e+01 -7.4012596130371094e+01 -2.9482702636718750e+02 -1.4073300361633301e+01 -7.3881301879882812e+01 -2.9483398437500000e+02 -1.4054499626159668e+01 -7.3881996154785156e+01 -2.9484899902343750e+02 -1.4222700119018555e+01 -7.3879699707031250e+01 -2.9479000854492188e+02 -1.4390200614929199e+01 -7.3881301879882812e+01 -2.9480801391601562e+02 -1.4310699462890625e+01 -7.3880004882812500e+01 -2.9479000854492188e+02 -1.4274499893188477e+01 -7.3879699707031250e+01 -2.9478698730468750e+02 -1.4269899368286133e+01 -7.3879699707031250e+01 -2.9478698730468750e+02 -1.4301399230957031e+01 -7.3879898071289062e+01 -2.9478900146484375e+02 -1.4245400428771973e+01 -7.3879600524902344e+01 -2.9478799438476562e+02 -1.4229100227355957e+01 -7.3879600524902344e+01 -2.9478799438476562e+02 -1.4467000007629395e+01 -7.3883895874023438e+01 -2.9485299682617188e+02 -1.5378899574279785e+01 -7.3551300048828125e+01 -2.9577899169921875e+02 -1.5925599098205566e+01 -7.3551200866699219e+01 -2.9607400512695312e+02 -1.5454400062561035e+01 -7.3692001342773438e+01 -2.9565399169921875e+02 -1.5988400459289551e+01 -7.3692001342773438e+01 -2.9594299316406250e+02 -1.4502200126647949e+01 -7.3747299194335938e+01 -2.9492102050781250e+02 -1.4951299667358398e+01 -7.3692001342773438e+01 -2.9531402587890625e+02 -1.4491100311279297e+01 -7.3692001342773438e+01 -2.9493298339843750e+02 -1.4435700416564941e+01 -7.3612503051757812e+01 -2.9499398803710938e+02 -1.4863800048828125e+01 -7.3551300048828125e+01 -2.9542999267578125e+02 -1.4424900054931641e+01 -7.3596900939941406e+01 -2.9500601196289062e+02 -1.4393199920654297e+01 -7.3551300048828125e+01 -2.9504098510742188e+02 -1.4080900192260742e+01 -7.3791694641113281e+01 -2.9484600830078125e+02 -1.3984999656677246e+01 -7.3730606079101562e+01 -2.9496600341796875e+02 -1.3994099617004395e+01 -7.3692001342773438e+01 -2.9497399902343750e+02 -1.4157399177551270e+01 -7.3716903686523438e+01 -2.9484600830078125e+02 -1.4018700599670410e+01 -7.3661605834960938e+01 -2.9499301147460938e+02 -1.4084000587463379e+01 -7.3581100463867188e+01 -2.9504498291015625e+02 -1.4088299751281738e+01 -7.3595504760742188e+01 -2.9499301147460938e+02 -1.4108200073242188e+01 -7.3551200866699219e+01 -2.9506399536132812e+02 -1.4260300636291504e+01 -7.3549598693847656e+01 -2.9499301147460938e+02 -1.4260199546813965e+01 -7.3500404357910156e+01 -2.9518499755859375e+02 -1.4420000076293945e+01 -7.3605796813964844e+01 -2.9499499511718750e+02 -1.4364300727844238e+01 -7.3716201782226562e+01 -2.9484600830078125e+02 -1.4441300392150879e+01 -7.3790397644042969e+01 -2.9484600830078125e+02 -1.4260700225830078e+01 -7.3689399719238281e+01 -2.9484600830078125e+02 -1.8211599349975586e+01 -7.3553596496582031e+01 -2.9652499389648438e+02 -1.8211801528930664e+01 -7.3552299499511719e+01 -2.9652899169921875e+02 -1.7751800537109375e+01 -7.3551300048828125e+01 -2.9652700805664062e+02 -1.8216400146484375e+01 -7.3501197814941406e+01 -2.9669299316406250e+02 -1.8208700180053711e+01 -7.3639305114746094e+01 -2.9642098999023438e+02 -1.8206798553466797e+01 -7.3754493713378906e+01 -2.9635198974609375e+02 -1.7758699417114258e+01 -7.3692001342773438e+01 -2.9638098144531250e+02 -1.8207799911499023e+01 -7.3694900512695312e+01 -2.9638800048828125e+02 -1.7123600006103516e+01 -7.3551300048828125e+01 -2.9645700073242188e+02 -1.6511301040649414e+01 -7.3551300048828125e+01 -2.9630700683593750e+02 -1.7148799896240234e+01 -7.3692001342773438e+01 -2.9631399536132812e+02 -1.6555599212646484e+01 -7.3692001342773438e+01 -2.9616799926757812e+02 -1.2597000122070312e+01 -7.3727500915527344e+01 -2.9671401977539062e+02 -1.2605299949645996e+01 -7.3692001342773438e+01 -2.9672100830078125e+02 -1.2756000518798828e+01 -7.3538993835449219e+01 -2.9684002685546875e+02 -1.2719400405883789e+01 -7.3551200866699219e+01 -2.9681100463867188e+02 -1.2697899818420410e+01 -7.3577796936035156e+01 -2.9679400634765625e+02 -1.2480799674987793e+01 -7.4308296203613281e+01 -2.9679000854492188e+02 -1.2478400230407715e+01 -7.4004501342773438e+01 -2.9684100341796875e+02 -1.2473200798034668e+01 -7.4308296203613281e+01 -2.9705398559570312e+02 -1.2467600822448730e+01 -7.4308502197265625e+01 -2.9701400756835938e+02 -1.2476399421691895e+01 -7.4004501342773438e+01 -2.9701599121093750e+02 -1.2454500198364258e+01 -7.4308799743652344e+01 -2.9692102050781250e+02 -1.2470399856567383e+01 -7.4308403015136719e+01 -2.9684201049804688e+02 -1.2481800079345703e+01 -7.3882804870605469e+01 -2.9701599121093750e+02 -1.2482199668884277e+01 -7.3882804870605469e+01 -2.9701699829101562e+02 -1.2483799934387207e+01 -7.3882804870605469e+01 -2.9684100341796875e+02 -1.2484200477600098e+01 -7.3882804870605469e+01 -2.9684002685546875e+02 -1.9159500122070312e+01 -7.3551200866699219e+01 -2.9639300537109375e+02 -1.9607799530029297e+01 -7.3551200866699219e+01 -2.9622000122070312e+02 -1.9118801116943359e+01 -7.3692001342773438e+01 -2.9625299072265625e+02 -1.9544000625610352e+01 -7.3692001342773438e+01 -2.9608999633789062e+02 -1.8665500640869141e+01 -7.3692001342773438e+01 -2.9634799194335938e+02 -1.8685400009155273e+01 -7.3551300048828125e+01 -2.9649298095703125e+02 -1.2539199829101562e+01 -7.3695602416992188e+01 -2.9701699829101562e+02 -1.2683199882507324e+01 -7.3557800292968750e+01 -2.9701699829101562e+02 -1.2600500106811523e+01 -7.3692001342773438e+01 -2.9714001464843750e+02 -1.2592499732971191e+01 -7.3724998474121094e+01 -2.9714501953125000e+02 -1.2762200355529785e+01 -7.3536300659179688e+01 -2.9701699829101562e+02 -1.2716599464416504e+01 -7.3551200866699219e+01 -2.9705102539062500e+02 -1.2696400642395020e+01 -7.3575698852539062e+01 -2.9706698608398438e+02 -1.2684200286865234e+01 -7.3559600830078125e+01 -2.9684002685546875e+02 -1.2540999412536621e+01 -7.3696701049804688e+01 -2.9684002685546875e+02 -2.0070199966430664e+01 -7.3692001342773438e+01 -2.9575799560546875e+02 -2.0487501144409180e+01 -7.3692001342773438e+01 -2.9533401489257812e+02 -2.0161399841308594e+01 -7.3551300048828125e+01 -2.9587200927734375e+02 -2.0602500915527344e+01 -7.3551200866699219e+01 -2.9542401123046875e+02 -1.9817499160766602e+01 -7.3692001342773438e+01 -2.9593798828125000e+02 -1.9895099639892578e+01 -7.3551300048828125e+01 -2.9606100463867188e+02 -1.2738900184631348e+01 -7.3551200866699219e+01 -2.9708099365234375e+02 -1.2623400688171387e+01 -7.3692001342773438e+01 -2.9717001342773438e+02 -1.3080899238586426e+01 -7.3692001342773438e+01 -2.9769000244140625e+02 -1.3183600425720215e+01 -7.3551300048828125e+01 -2.9758599853515625e+02 -1.3602799415588379e+01 -7.3692001342773438e+01 -2.9814401245117188e+02 -1.3691100120544434e+01 -7.3551200866699219e+01 -2.9802899169921875e+02 -2.0941699981689453e+01 -7.3551300048828125e+01 -2.9487402343750000e+02 -2.1162399291992188e+01 -7.3551200866699219e+01 -2.9426599121093750e+02 -2.0810300827026367e+01 -7.3692001342773438e+01 -2.9481100463867188e+02 -2.1021499633789062e+01 -7.3692001342773438e+01 -2.9422900390625000e+02 -2.0662700653076172e+01 -7.3692001342773438e+01 -2.9508200073242188e+02 -2.0786800384521484e+01 -7.3551300048828125e+01 -2.9515798950195312e+02 -1.4050000190734863e+01 -7.3692001342773438e+01 -2.9845800781250000e+02 -1.4128799438476562e+01 -7.3551200866699219e+01 -2.9833599853515625e+02 -1.4518200874328613e+01 -7.3692001342773438e+01 -2.9873400878906250e+02 -1.4586999893188477e+01 -7.3551200866699219e+01 -2.9860498046875000e+02 -1.5123100280761719e+01 -7.3692001342773438e+01 -2.9902099609375000e+02 -1.5179100036621094e+01 -7.3551200866699219e+01 -2.9888598632812500e+02 -2.1222600936889648e+01 -7.3587799072265625e+01 -2.9271899414062500e+02 -2.1278999328613281e+01 -7.3566497802734375e+01 -2.9265902709960938e+02 -2.1292800903320312e+01 -7.3551200866699219e+01 -2.9299798583984375e+02 -2.1454900741577148e+01 -7.3500000000000000e+01 -2.9247201538085938e+02 -2.1147201538085938e+01 -7.3692001342773438e+01 -2.9300299072265625e+02 -2.1099599838256836e+01 -7.3778503417968750e+01 -2.9284997558593750e+02 -2.1137300491333008e+01 -7.3692298889160156e+01 -2.9280999755859375e+02 -2.1140199661254883e+01 -7.3685897827148438e+01 -2.9280700683593750e+02 -2.1129600524902344e+01 -7.3692001342773438e+01 -2.9362402343750000e+02 -2.1274600982666016e+01 -7.3551300048828125e+01 -2.9363800048828125e+02 -1.5694199562072754e+01 -7.3551200866699219e+01 -2.9907901000976562e+02 -1.5647899627685547e+01 -7.3692001342773438e+01 -2.9921697998046875e+02 -1.6182600021362305e+01 -7.3692001342773438e+01 -2.9937600708007812e+02 -1.6218999862670898e+01 -7.3551200866699219e+01 -2.9923400878906250e+02 -1.6827301025390625e+01 -7.3692001342773438e+01 -2.9951400756835938e+02 -1.6851900100708008e+01 -7.3551200866699219e+01 -2.9936999511718750e+02 -1.1366900444030762e+01 -7.4308593750000000e+01 -2.9268399047851562e+02 -1.1384500503540039e+01 -7.3882995605468750e+01 -2.9266101074218750e+02 -1.1395099639892578e+01 -7.4308700561523438e+01 -2.9271200561523438e+02 -1.1401900291442871e+01 -7.3882102966308594e+01 -2.9270300292968750e+02 -1.1513199806213379e+01 -7.4308998107910156e+01 -2.9282998657226562e+02 -1.1523300170898438e+01 -7.3882102966308594e+01 -2.9280700683593750e+02 -1.1532400131225586e+01 -7.4308799743652344e+01 -2.9283499145507812e+02 -1.1543899536132812e+01 -7.3882102966308594e+01 -2.9282501220703125e+02 -1.1610800743103027e+01 -7.3883506774902344e+01 -2.9284097290039062e+02 -1.1688300132751465e+01 -7.3885200500488281e+01 -2.9286001586914062e+02 -1.1725800514221191e+01 -7.3692199707031250e+01 -2.9281100463867188e+02 -1.1725800514221191e+01 -7.3693000793457031e+01 -2.9281198120117188e+02 -1.1725800514221191e+01 -7.3551498413085938e+01 -2.9266500854492188e+02 -1.1725800514221191e+01 -7.3550598144531250e+01 -2.9266400146484375e+02 -1.6852001190185547e+01 -7.3551200866699219e+01 -2.9936999511718750e+02 -1.7387800216674805e+01 -7.3551200866699219e+01 -2.9944699096679688e+02 -1.7925800323486328e+01 -7.3551200866699219e+01 -2.9949301147460938e+02 -1.8567800521850586e+01 -7.3551200866699219e+01 -2.9950601196289062e+02 -1.7371099472045898e+01 -7.3692001342773438e+01 -2.9959197998046875e+02 -1.7917699813842773e+01 -7.3692001342773438e+01 -2.9963897705078125e+02 -1.8570301055908203e+01 -7.3692001342773438e+01 -2.9965200805664062e+02 -1.1553700447082520e+01 -7.3595893859863281e+01 -2.9266400146484375e+02 -1.1529900550842285e+01 -7.3553398132324219e+01 -2.9250000000000000e+02 -1.1532099723815918e+01 -7.3551200866699219e+01 -2.9249899291992188e+02 -1.1426400184631348e+01 -7.3720100402832031e+01 -2.9266400146484375e+02 -1.1386899948120117e+01 -7.3696098327636719e+01 -2.9252200317382812e+02 -1.1388099670410156e+01 -7.3692001342773438e+01 -2.9252200317382812e+02 -1.1548399925231934e+01 -7.3793395996093750e+01 -2.9281198120117188e+02 -1.1623800277709961e+01 -7.3719894409179688e+01 -2.9281198120117188e+02 -1.9516199111938477e+01 -7.3551300048828125e+01 -2.9943600463867188e+02 -1.9535501480102539e+01 -7.3692001342773438e+01 -2.9958001708984375e+02 -2.0437500000000000e+01 -7.3551300048828125e+01 -2.9925000000000000e+02 -2.1398401260375977e+01 -7.3551200866699219e+01 -2.9889700317382812e+02 -2.0476099014282227e+01 -7.3692001342773438e+01 -2.9939099121093750e+02 -2.1460199356079102e+01 -7.3692001342773438e+01 -2.9902899169921875e+02 -1.1483400344848633e+01 -7.3500495910644531e+01 -2.9103500366210938e+02 -1.1203000068664551e+01 -7.3639396667480469e+01 -2.9107299804687500e+02 -1.1305399894714355e+01 -7.3553596496582031e+01 -2.9105899047851562e+02 -1.1309800148010254e+01 -7.3552299499511719e+01 -2.9105899047851562e+02 -1.1134400367736816e+01 -7.3754493713378906e+01 -2.9108200073242188e+02 -1.1169899940490723e+01 -7.3694900512695312e+01 -2.9107699584960938e+02 -2.2589899063110352e+01 -7.3692001342773438e+01 -2.9835598754882812e+02 -2.2502700805664062e+01 -7.3551300048828125e+01 -2.9824002075195312e+02 -2.3111301422119141e+01 -7.3692001342773438e+01 -2.9791900634765625e+02 -2.3011400222778320e+01 -7.3551300048828125e+01 -2.9781298828125000e+02 -2.3579200744628906e+01 -7.3692001342773438e+01 -2.9742398071289062e+02 -2.3467800140380859e+01 -7.3551200866699219e+01 -2.9732998657226562e+02 -1.1245599746704102e+01 -7.3551300048828125e+01 -2.8949499511718750e+02 -1.1381199836730957e+01 -7.3551200866699219e+01 -2.8822100830078125e+02 -1.1099999427795410e+01 -7.3692001342773438e+01 -2.8949002075195312e+02 -1.1237800598144531e+01 -7.3692001342773438e+01 -2.8819500732421875e+02 -1.1135100364685059e+01 -7.3692001342773438e+01 -2.9078701782226562e+02 -1.1280300140380859e+01 -7.3551200866699219e+01 -2.9077398681640625e+02 -2.3467899322509766e+01 -7.3551200866699219e+01 -2.9732998657226562e+02 -2.3927999496459961e+01 -7.3551300048828125e+01 -2.9670501708984375e+02 -2.4296600341796875e+01 -7.3551300048828125e+01 -2.9603698730468750e+02 -2.4683198928833008e+01 -7.3551200866699219e+01 -2.9500399780273438e+02 -2.4050800323486328e+01 -7.3692001342773438e+01 -2.9678298950195312e+02 -2.4428199768066406e+01 -7.3692001342773438e+01 -2.9609899902343750e+02 -2.4823200225830078e+01 -7.3692001342773438e+01 -2.9504400634765625e+02 -1.1839799880981445e+01 -7.3692001342773438e+01 -2.8633901977539062e+02 -1.2178299903869629e+01 -7.3692001342773438e+01 -2.8574899291992188e+02 -1.1970100402832031e+01 -7.3551300048828125e+01 -2.8640402221679688e+02 -1.2300300598144531e+01 -7.3551200866699219e+01 -2.8582901000976562e+02 -1.1572799682617188e+01 -7.3692001342773438e+01 -2.8695397949218750e+02 -1.1709400177001953e+01 -7.3551300048828125e+01 -2.8700399780273438e+02 -2.5100500106811523e+01 -7.3754493713378906e+01 -2.9210400390625000e+02 -2.5103000640869141e+01 -7.3692001342773438e+01 -2.9261999511718750e+02 -2.5064800262451172e+01 -7.3694900512695312e+01 -2.9210800170898438e+02 -2.5064199447631836e+01 -7.3693794250488281e+01 -2.9210800170898438e+02 -2.4922100067138672e+01 -7.3551399230957031e+01 -2.9212100219726562e+02 -2.4924301147460938e+01 -7.3552101135253906e+01 -2.9212100219726562e+02 -2.4957399368286133e+01 -7.3551200866699219e+01 -2.9262500000000000e+02 -2.4928699493408203e+01 -7.3553596496582031e+01 -2.9212100219726562e+02 -2.5031600952148438e+01 -7.3639305114746094e+01 -2.9211102294921875e+02 -2.4775798797607422e+01 -7.3502700805664062e+01 -2.9213500976562500e+02 -2.4914899826049805e+01 -7.3551300048828125e+01 -2.9382299804687500e+02 -2.5059598922729492e+01 -7.3692001342773438e+01 -2.9383901977539062e+02 -1.3185099601745605e+01 -7.3551300048828125e+01 -2.8481100463867188e+02 -1.4096199989318848e+01 -7.3551200866699219e+01 -2.8417398071289062e+02 -1.3089300155639648e+01 -7.3692001342773438e+01 -2.8470098876953125e+02 -1.4025400161743164e+01 -7.3692001342773438e+01 -2.8404598999023438e+02 -1.2597399711608887e+01 -7.3692001342773438e+01 -2.8519400024414062e+02 -1.2707400321960449e+01 -7.3551300048828125e+01 -2.8528900146484375e+02 -2.4863998413085938e+01 -7.3550003051757812e+01 -2.9153601074218750e+02 -2.4865699768066406e+01 -7.3551696777343750e+01 -2.9153601074218750e+02 -2.5010499954223633e+01 -7.3691001892089844e+01 -2.9152200317382812e+02 -2.5010799407958984e+01 -7.3692100524902344e+01 -2.9152200317382812e+02 -1.6836299896240234e+01 -7.3502799987792969e+01 -2.8367001342773438e+02 -1.6578701019287109e+01 -7.3551200866699219e+01 -2.8352902221679688e+02 -1.6830200195312500e+01 -7.3694900512695312e+01 -2.8338000488281250e+02 -1.6830900192260742e+01 -7.3639305114746094e+01 -2.8341400146484375e+02 -1.6571701049804688e+01 -7.3692001342773438e+01 -2.8338400268554688e+02 -1.6833101272583008e+01 -7.3553596496582031e+01 -2.8351699829101562e+02 -1.6833198547363281e+01 -7.3552101135253906e+01 -2.8352099609375000e+02 -1.6829399108886719e+01 -7.3754493713378906e+01 -2.8334399414062500e+02 -1.5638999938964844e+01 -7.3551300048828125e+01 -2.8363601684570312e+02 -1.5612500190734863e+01 -7.3692001342773438e+01 -2.8349200439453125e+02 -1.4666699409484863e+01 -7.3692001342773438e+01 -2.8375100708007812e+02 -1.4717700004577637e+01 -7.3551200866699219e+01 -2.8388800048828125e+02 -2.4720899581909180e+01 -7.3551300048828125e+01 -2.9057400512695312e+02 -2.4863901138305664e+01 -7.3692001342773438e+01 -2.9054598999023438e+02 -2.4631601333618164e+01 -7.3692001342773438e+01 -2.8959301757812500e+02 -2.4491699218750000e+01 -7.3551300048828125e+01 -2.8963400268554688e+02 -2.4196699142456055e+01 -7.3692001342773438e+01 -2.8838101196289062e+02 -2.4062700271606445e+01 -7.3551200866699219e+01 -2.8843798828125000e+02 -1.8980798721313477e+01 -7.3692001342773438e+01 -2.8361401367187500e+02 -1.7902599334716797e+01 -7.3692001342773438e+01 -2.8341699218750000e+02 -1.7887300491333008e+01 -7.3551300048828125e+01 -2.8356201171875000e+02 -1.8943500518798828e+01 -7.3551300048828125e+01 -2.8375500488281250e+02 -1.9957901000976562e+01 -7.3551200866699219e+01 -2.8411599731445312e+02 -2.0018199920654297e+01 -7.3692001342773438e+01 -2.8398300170898438e+02 -2.3670799255371094e+01 -7.3551300048828125e+01 -2.8762799072265625e+02 -2.3205398559570312e+01 -7.3551300048828125e+01 -2.8686599731445312e+02 -2.2398799896240234e+01 -7.3551200866699219e+01 -2.8585897827148438e+02 -2.2505100250244141e+01 -7.3692001342773438e+01 -2.8575997924804688e+02 -2.2505199432373047e+01 -7.3692001342773438e+01 -2.8575997924804688e+02 -2.3325700759887695e+01 -7.3692001342773438e+01 -2.8678399658203125e+02 -2.3798799514770508e+01 -7.3692001342773438e+01 -2.8755798339843750e+02 -2.1773599624633789e+01 -7.3551300048828125e+01 -2.8526300048828125e+02 -2.1868000030517578e+01 -7.3692001342773438e+01 -2.8515197753906250e+02 -2.1093500137329102e+01 -7.3551300048828125e+01 -2.8474798583984375e+02 -2.1174701690673828e+01 -7.3692001342773438e+01 -2.8462698364257812e+02 -1.4751199722290039e+01 -7.3553695678710938e+01 -2.8966702270507812e+02 -1.4746800422668457e+01 -7.3552299499511719e+01 -2.8966799926757812e+02 -1.4712699890136719e+01 -7.3551200866699219e+01 -2.8943899536132812e+02 -1.4573100090026855e+01 -7.3500404357910156e+01 -2.8970199584960938e+02 -1.4852600097656250e+01 -7.3639396667480469e+01 -2.8964700317382812e+02 -1.4920400619506836e+01 -7.3754493713378906e+01 -2.8963299560546875e+02 -1.4857299804687500e+01 -7.3692001342773438e+01 -2.8942098999023438e+02 -1.4885200500488281e+01 -7.3694900512695312e+01 -2.8964001464843750e+02 -1.4685000419616699e+01 -7.3551200866699219e+01 -2.8911901855468750e+02 -1.4682799339294434e+01 -7.3551200866699219e+01 -2.8879998779296875e+02 -1.4708000183105469e+01 -7.3551200866699219e+01 -2.8848300170898438e+02 -1.4830599784851074e+01 -7.3692001342773438e+01 -2.8911199951171875e+02 -1.4828399658203125e+01 -7.3692001342773438e+01 -2.8880499267578125e+02 -1.4852600097656250e+01 -7.3692001342773438e+01 -2.8850100708007812e+02 -1.4950099945068359e+01 -7.3692001342773438e+01 -2.8804998779296875e+02 -1.4811299324035645e+01 -7.3551300048828125e+01 -2.8800500488281250e+02 -1.5052200317382812e+01 -7.3692001342773438e+01 -2.8778799438476562e+02 -1.4920200347900391e+01 -7.3551300048828125e+01 -2.8772601318359375e+02 -1.5187099456787109e+01 -7.3692001342773438e+01 -2.8754400634765625e+02 -1.5064800262451172e+01 -7.3551200866699219e+01 -2.8746499633789062e+02 -1.4875399589538574e+01 -7.3551200866699219e+01 -2.9024499511718750e+02 -1.4992300033569336e+01 -7.3692001342773438e+01 -2.9009899902343750e+02 -1.5025599479675293e+01 -7.3785202026367188e+01 -2.9005700683593750e+02 -1.5473500251770020e+01 -7.3692001342773438e+01 -2.8720199584960938e+02 -1.5373899459838867e+01 -7.3551300048828125e+01 -2.8709600830078125e+02 -1.5684500694274902e+01 -7.3692001342773438e+01 -2.8703100585937500e+02 -1.5600799560546875e+01 -7.3551300048828125e+01 -2.8691101074218750e+02 -1.5920000076293945e+01 -7.3692001342773438e+01 -2.8688699340820312e+02 -1.5852199554443359e+01 -7.3551200866699219e+01 -2.8675799560546875e+02 -2.1094600677490234e+01 -7.3557693481445312e+01 -2.9024899291992188e+02 -2.1158700942993164e+01 -7.3528495788574219e+01 -2.9029199218750000e+02 -2.1218599319458008e+01 -7.3520698547363281e+01 -2.9033300781250000e+02 -2.1375398635864258e+01 -7.3500000000000000e+01 -2.9043798828125000e+02 -2.0802099227905273e+01 -7.3806396484375000e+01 -2.9005200195312500e+02 -2.0848701477050781e+01 -7.3720596313476562e+01 -2.9008297729492188e+02 -2.0876501083374023e+01 -7.3694000244140625e+01 -2.9010198974609375e+02 -2.0950399398803711e+01 -7.3623298645019531e+01 -2.9015200805664062e+02 -1.7046600341796875e+01 -7.3754493713378906e+01 -2.8664599609375000e+02 -1.6829999923706055e+01 -7.3551200866699219e+01 -2.8648400878906250e+02 -1.7040901184082031e+01 -7.3552299499511719e+01 -2.8646902465820312e+02 -1.7041099548339844e+01 -7.3553596496582031e+01 -2.8647299194335938e+02 -1.7044401168823242e+01 -7.3639396667480469e+01 -2.8657699584960938e+02 -1.6844499588012695e+01 -7.3692001342773438e+01 -2.8662899780273438e+02 -1.7045499801635742e+01 -7.3694900512695312e+01 -2.8661001586914062e+02 -1.7035299301147461e+01 -7.3500793457031250e+01 -2.8629800415039062e+02 -1.6519199371337891e+01 -7.3692001342773438e+01 -2.8667797851562500e+02 -1.6208900451660156e+01 -7.3692001342773438e+01 -2.8676300048828125e+02 -1.5920101165771484e+01 -7.3692001342773438e+01 -2.8688699340820312e+02 -1.6489601135253906e+01 -7.3551200866699219e+01 -2.8653601074218750e+02 -1.6161401748657227e+01 -7.3551200866699219e+01 -2.8662600708007812e+02 -1.5852499961853027e+01 -7.3551200866699219e+01 -2.8675799560546875e+02 -2.0770599365234375e+01 -7.3692001342773438e+01 -2.8985000610351562e+02 -2.0904998779296875e+01 -7.3551200866699219e+01 -2.8979400634765625e+02 -2.0524499893188477e+01 -7.3692001342773438e+01 -2.8929901123046875e+02 -2.0253200531005859e+01 -7.3692001342773438e+01 -2.8875900268554688e+02 -2.0656200408935547e+01 -7.3551200866699219e+01 -2.8923602294921875e+02 -2.0381898880004883e+01 -7.3551200866699219e+01 -2.8869100952148438e+02 -1.7123300552368164e+01 -7.3551200866699219e+01 -2.8646798706054688e+02 -1.8486200332641602e+01 -7.3551200866699219e+01 -2.8675500488281250e+02 -1.7123300552368164e+01 -7.3692001342773438e+01 -2.8661401367187500e+02 -1.7593999862670898e+01 -7.3551300048828125e+01 -2.8649700927734375e+02 -1.8052000045776367e+01 -7.3551300048828125e+01 -2.8659100341796875e+02 -1.8486099243164062e+01 -7.3551200866699219e+01 -2.8675500488281250e+02 -1.8423099517822266e+01 -7.3692001342773438e+01 -2.8688601684570312e+02 -1.8423000335693359e+01 -7.3692001342773438e+01 -2.8688601684570312e+02 -1.8012001037597656e+01 -7.3692001342773438e+01 -2.8673101806640625e+02 -1.7575500488281250e+01 -7.3692001342773438e+01 -2.8664199829101562e+02 -1.9809299468994141e+01 -7.3551200866699219e+01 -2.8782299804687500e+02 -1.9578199386596680e+01 -7.3551200866699219e+01 -2.8755798339843750e+02 -1.9696300506591797e+01 -7.3692001342773438e+01 -2.8791497802734375e+02 -1.9471900939941406e+01 -7.3692001342773438e+01 -2.8765802001953125e+02 -1.9901700973510742e+01 -7.3692001342773438e+01 -2.8818600463867188e+02 -2.0020799636840820e+01 -7.3551200866699219e+01 -2.8810198974609375e+02 -1.8792299270629883e+01 -7.3551300048828125e+01 -2.8692001342773438e+02 -1.8717000961303711e+01 -7.3692001342773438e+01 -2.8704501342773438e+02 -1.8991800308227539e+01 -7.3692001342773438e+01 -2.8722900390625000e+02 -1.9078599929809570e+01 -7.3551300048828125e+01 -2.8711199951171875e+02 -3.4621799468994141e+01 -7.4308296203613281e+01 -2.9942599487304688e+02 -3.4571800231933594e+01 -7.3884803771972656e+01 -2.9940899658203125e+02 -3.4644397735595703e+01 -7.3882293701171875e+01 -2.9939300537109375e+02 -3.4716400146484375e+01 -7.4309501647949219e+01 -2.9938198852539062e+02 -3.4704299926757812e+01 -7.3880302429199219e+01 -2.9937899780273438e+02 -3.4710197448730469e+01 -7.3880203247070312e+01 -2.9937500000000000e+02 -3.4809700012207031e+01 -7.4310699462890625e+01 -2.9933898925781250e+02 -3.4841499328613281e+01 -7.3878303527832031e+01 -2.9927398681640625e+02 -3.4921699523925781e+01 -7.3880500793457031e+01 -2.9911599731445312e+02 -3.4931800842285156e+01 -7.4309600830078125e+01 -2.9913601684570312e+02 -3.4921501159667969e+01 -7.3880302429199219e+01 -2.9912100219726562e+02 -3.4928703308105469e+01 -7.4310195922851562e+01 -2.9916998291015625e+02 -3.4849403381347656e+01 -7.4310493469238281e+01 -2.9928201293945312e+02 -3.4622699737548828e+01 -7.3746398925781250e+01 -2.9937600708007812e+02 -3.4687000274658203e+01 -7.3809104919433594e+01 -2.9937600708007812e+02 -3.4802001953125000e+01 -7.3740104675292969e+01 -2.9926898193359375e+02 -3.4868000030517578e+01 -7.3700401306152344e+01 -2.9911599731445312e+02 -3.4873798370361328e+01 -7.3696502685546875e+01 -2.9895800781250000e+02 -3.4728900909423828e+01 -7.3551200866699219e+01 -2.9898397827148438e+02 -3.4731399536132812e+01 -7.3553695678710938e+01 -2.9898300170898438e+02 -3.4726699829101562e+01 -7.3562698364257812e+01 -2.9911599731445312e+02 -3.4872497558593750e+01 -7.3692001342773438e+01 -2.9895898437500000e+02 -3.4535800933837891e+01 -7.3512397766113281e+01 -2.9911599731445312e+02 -3.4535800933837891e+01 -7.3559204101562500e+01 -2.9920898437500000e+02 -3.4688701629638672e+01 -7.3629699707031250e+01 -2.9926898193359375e+02 -3.4535800933837891e+01 -7.3723602294921875e+01 -2.9937600708007812e+02 -3.4535800933837891e+01 -7.3695800781250000e+01 -2.9935397338867188e+02 -3.4535800933837891e+01 -7.3589401245117188e+01 -2.9926898193359375e+02 -3.0872098922729492e+01 -7.4308593750000000e+01 -2.9923199462890625e+02 -3.0889699935913086e+01 -7.3883300781250000e+01 -2.9920898437500000e+02 -3.0903699874877930e+01 -7.4308593750000000e+01 -2.9926300048828125e+02 -3.0909700393676758e+01 -7.3882202148437500e+01 -2.9925500488281250e+02 -3.1018400192260742e+01 -7.4308898925781250e+01 -2.9937802124023438e+02 -3.1028301239013672e+01 -7.3882202148437500e+01 -2.9935501098632812e+02 -3.1039899826049805e+01 -7.4308799743652344e+01 -2.9938400268554688e+02 -3.1051000595092773e+01 -7.3882202148437500e+01 -2.9937402343750000e+02 -3.1117000579833984e+01 -7.3883697509765625e+01 -2.9938998413085938e+02 -3.1193698883056641e+01 -7.3885299682617188e+01 -2.9940798950195312e+02 -3.1230699539184570e+01 -7.3693000793457031e+01 -2.9935900878906250e+02 -3.1230699539184570e+01 -7.3692199707031250e+01 -2.9935900878906250e+02 -3.1230699539184570e+01 -7.3551498413085938e+01 -2.9921298217773438e+02 -3.1230699539184570e+01 -7.3550598144531250e+01 -2.9921200561523438e+02 -3.2779296875000000e+01 -7.3785202026367188e+01 -2.8665600585937500e+02 -3.2556797027587891e+01 -7.3551200866699219e+01 -2.8646902465820312e+02 -3.2729999542236328e+01 -7.3692001342773438e+01 -2.8661502075195312e+02 -3.1058700561523438e+01 -7.3595893859863281e+01 -2.9921200561523438e+02 -3.1035099029541016e+01 -7.3553695678710938e+01 -2.9905099487304688e+02 -3.1037601470947266e+01 -7.3551200866699219e+01 -2.9905099487304688e+02 -3.0931299209594727e+01 -7.3720001220703125e+01 -2.9921200561523438e+02 -3.0892700195312500e+01 -7.3696502685546875e+01 -2.9907598876953125e+02 -3.0894001007080078e+01 -7.3692001342773438e+01 -2.9907598876953125e+02 -3.1053298950195312e+01 -7.3793395996093750e+01 -2.9935900878906250e+02 -3.1128700256347656e+01 -7.3719894409179688e+01 -2.9935900878906250e+02 -3.4608600616455078e+01 -7.3512397766113281e+01 -2.8637200927734375e+02 -3.4608600616455078e+01 -7.3723503112792969e+01 -2.8663198852539062e+02 -3.4608600616455078e+01 -7.3695800781250000e+01 -2.8661001586914062e+02 -3.4608600616455078e+01 -7.3589401245117188e+01 -2.8652502441406250e+02 -3.4608600616455078e+01 -7.3559204101562500e+01 -2.8646499633789062e+02 -3.4694900512695312e+01 -7.4308296203613281e+01 -2.8668200683593750e+02 -3.4644500732421875e+01 -7.3884803771972656e+01 -2.8666497802734375e+02 -3.4717300415039062e+01 -7.3882293701171875e+01 -2.8664898681640625e+02 -3.4789199829101562e+01 -7.4309501647949219e+01 -2.8663800048828125e+02 -3.4777099609375000e+01 -7.3880302429199219e+01 -2.8663500976562500e+02 -3.4782901763916016e+01 -7.3880203247070312e+01 -2.8663098144531250e+02 -3.4882698059082031e+01 -7.4310699462890625e+01 -2.8659500122070312e+02 -3.4914299011230469e+01 -7.3878303527832031e+01 -2.8652999877929688e+02 -3.4994598388671875e+01 -7.3880500793457031e+01 -2.8637200927734375e+02 -3.5004600524902344e+01 -7.4309600830078125e+01 -2.8639099121093750e+02 -3.4994300842285156e+01 -7.3880302429199219e+01 -2.8637701416015625e+02 -3.5001598358154297e+01 -7.4310195922851562e+01 -2.8642498779296875e+02 -3.4922397613525391e+01 -7.4310493469238281e+01 -2.8653799438476562e+02 -2.8696399688720703e+01 -7.3785202026367188e+01 -2.8665600585937500e+02 -2.8731300354003906e+01 -7.3692001342773438e+01 -2.8661502075195312e+02 -2.8853900909423828e+01 -7.3551200866699219e+01 -2.8646902465820312e+02 -3.4759799957275391e+01 -7.3809104919433594e+01 -2.8663198852539062e+02 -3.4874801635742188e+01 -7.3739997863769531e+01 -2.8652502441406250e+02 -3.4940799713134766e+01 -7.3700302124023438e+01 -2.8637200927734375e+02 -3.4946502685546875e+01 -7.3696502685546875e+01 -2.8621398925781250e+02 -3.4801597595214844e+01 -7.3551200866699219e+01 -2.8623898315429688e+02 -3.4804199218750000e+01 -7.3553802490234375e+01 -2.8623898315429688e+02 -3.4799400329589844e+01 -7.3562599182128906e+01 -2.8637200927734375e+02 -3.4945098876953125e+01 -7.3692001342773438e+01 -2.8621398925781250e+02 -3.4695400238037109e+01 -7.3746398925781250e+01 -2.8663198852539062e+02 -3.4761501312255859e+01 -7.3629600524902344e+01 -2.8652502441406250e+02 -2.5613000869750977e+01 -7.4308593750000000e+01 -2.8648800659179688e+02 -2.5630599975585938e+01 -7.3883300781250000e+01 -2.8646499633789062e+02 -2.5644800186157227e+01 -7.4308593750000000e+01 -2.8652001953125000e+02 -2.5650699615478516e+01 -7.3882202148437500e+01 -2.8651101684570312e+02 -2.5759199142456055e+01 -7.4308898925781250e+01 -2.8663400268554688e+02 -2.5769199371337891e+01 -7.3882202148437500e+01 -2.8661099243164062e+02 -2.5780899047851562e+01 -7.4308799743652344e+01 -2.8663998413085938e+02 -2.5792001724243164e+01 -7.3882202148437500e+01 -2.8663000488281250e+02 -2.5857999801635742e+01 -7.3883697509765625e+01 -2.8664599609375000e+02 -2.5934598922729492e+01 -7.3885299682617188e+01 -2.8666400146484375e+02 -2.5971601486206055e+01 -7.3693000793457031e+01 -2.8661502075195312e+02 -2.5971601486206055e+01 -7.3692199707031250e+01 -2.8661401367187500e+02 -2.5971601486206055e+01 -7.3551498413085938e+01 -2.8646902465820312e+02 -2.5971601486206055e+01 -7.3550598144531250e+01 -2.8646798706054688e+02 -3.4406299591064453e+01 -7.3551200866699219e+01 -2.8397399902343750e+02 -3.4550800323486328e+01 -7.3695396423339844e+01 -2.8394897460937500e+02 -3.4549797058105469e+01 -7.3692001342773438e+01 -2.8394897460937500e+02 -3.4407100677490234e+01 -7.3552101135253906e+01 -2.8397399902343750e+02 -3.4394302368164062e+01 -7.3882293701171875e+01 -2.8365100097656250e+02 -3.4405399322509766e+01 -7.4308700561523438e+01 -2.8364199829101562e+02 -3.4415901184082031e+01 -7.3882293701171875e+01 -2.8367001342773438e+02 -3.4427799224853516e+01 -7.4308898925781250e+01 -2.8364801025390625e+02 -3.4534599304199219e+01 -7.3882293701171875e+01 -2.8376998901367188e+02 -3.4540298461914062e+01 -7.4308593750000000e+01 -2.8376199340820312e+02 -3.4554298400878906e+01 -7.3883300781250000e+01 -2.8381600952148438e+02 -3.4573101043701172e+01 -7.4308502197265625e+01 -2.8379501342773438e+02 -3.4241798400878906e+01 -7.3885498046875000e+01 -2.8361401367187500e+02 -3.4320999145507812e+01 -7.3883804321289062e+01 -2.8363299560546875e+02 -2.5799600601196289e+01 -7.3595893859863281e+01 -2.8646798706054688e+02 -2.5776000976562500e+01 -7.3553802490234375e+01 -2.8630700683593750e+02 -2.5778499603271484e+01 -7.3551200866699219e+01 -2.8630700683593750e+02 -2.5672100067138672e+01 -7.3720001220703125e+01 -2.8646798706054688e+02 -2.5633600234985352e+01 -7.3696502685546875e+01 -2.8633200073242188e+02 -2.5635000228881836e+01 -7.3692001342773438e+01 -2.8633200073242188e+02 -2.5794200897216797e+01 -7.3793395996093750e+01 -2.8661502075195312e+02 -2.5869699478149414e+01 -7.3719894409179688e+01 -2.8661502075195312e+02 -3.4512100219726562e+01 -7.3719100952148438e+01 -2.8381298828125000e+02 -3.4214500427246094e+01 -7.3551200866699219e+01 -2.8381198120117188e+02 -3.4215400695800781e+01 -7.3692001342773438e+01 -2.8366601562500000e+02 -3.4314098358154297e+01 -7.3719100952148438e+01 -2.8366500854492188e+02 -3.4215400695800781e+01 -7.3693000793457031e+01 -2.8366601562500000e+02 -3.4214500427246094e+01 -7.3550903320312500e+01 -2.8381298828125000e+02 -3.4383399963378906e+01 -7.3594894409179688e+01 -2.8381298828125000e+02 -3.4390399932861328e+01 -7.3792701721191406e+01 -2.8366500854492188e+02 -2.5540599822998047e+01 -7.3884803771972656e+01 -2.8361801147460938e+02 -2.5490098953247070e+01 -7.4308296203613281e+01 -2.8360098266601562e+02 -2.5467901229858398e+01 -7.3882293701171875e+01 -2.8363400268554688e+02 -2.5395799636840820e+01 -7.4309501647949219e+01 -2.8364498901367188e+02 -2.5407899856567383e+01 -7.3880302429199219e+01 -2.8364801025390625e+02 -2.5402101516723633e+01 -7.3880203247070312e+01 -2.8365200805664062e+02 -2.5302299499511719e+01 -7.4310699462890625e+01 -2.8368801879882812e+02 -2.5270799636840820e+01 -7.3878303527832031e+01 -2.8375302124023438e+02 -2.5190500259399414e+01 -7.3880500793457031e+01 -2.8391098022460938e+02 -2.5180500030517578e+01 -7.4309600830078125e+01 -2.8389199829101562e+02 -2.5190799713134766e+01 -7.3880302429199219e+01 -2.8390600585937500e+02 -2.5183500289916992e+01 -7.4310195922851562e+01 -2.8385800170898438e+02 -2.5262798309326172e+01 -7.4310493469238281e+01 -2.8374499511718750e+02 -2.5238599777221680e+01 -7.3696502685546875e+01 -2.8406900024414062e+02 -2.5239900588989258e+01 -7.3692001342773438e+01 -2.8406900024414062e+02 -2.5381000518798828e+01 -7.3553802490234375e+01 -2.8404400634765625e+02 -2.5383501052856445e+01 -7.3551200866699219e+01 -2.8404400634765625e+02 -3.2212299346923828e+01 -7.3692001342773438e+01 -2.8365298461914062e+02 -3.2249000549316406e+01 -7.3785202026367188e+01 -2.8361199951171875e+02 -3.2211799621582031e+01 -7.3691001892089844e+01 -2.8365399169921875e+02 -3.2083797454833984e+01 -7.3551696777343750e+01 -2.8379800415039062e+02 -3.2082302093505859e+01 -7.3550003051757812e+01 -2.8380001831054688e+02 -2.5576499938964844e+01 -7.3559204101562500e+01 -2.8381799316406250e+02 -2.5576499938964844e+01 -7.3512397766113281e+01 -2.8391098022460938e+02 -2.5385700225830078e+01 -7.3562599182128906e+01 -2.8391098022460938e+02 -2.5576499938964844e+01 -7.3695800781250000e+01 -2.8367297363281250e+02 -2.5576499938964844e+01 -7.3589302062988281e+01 -2.8375802612304688e+02 -2.5423599243164062e+01 -7.3629600524902344e+01 -2.8375802612304688e+02 -2.5310300827026367e+01 -7.3739997863769531e+01 -2.8375802612304688e+02 -2.5425199508666992e+01 -7.3809104919433594e+01 -2.8365100097656250e+02 -2.5489601135253906e+01 -7.3746398925781250e+01 -2.8365100097656250e+02 -2.5576499938964844e+01 -7.3723503112792969e+01 -2.8365100097656250e+02 -2.5244298934936523e+01 -7.3700302124023438e+01 -2.8391098022460938e+02 -3.2027198791503906e+01 -7.3691001892089844e+01 -2.8222201538085938e+02 -3.2027500152587891e+01 -7.3692100524902344e+01 -2.8222201538085938e+02 -3.1881198883056641e+01 -7.3550003051757812e+01 -2.8224099731445312e+02 -3.1882900238037109e+01 -7.3551696777343750e+01 -2.8224099731445312e+02 -2.8403799057006836e+01 -7.3551200866699219e+01 -2.8381402587890625e+02 -2.8181999206542969e+01 -7.3785202026367188e+01 -2.8362701416015625e+02 -2.8231100082397461e+01 -7.3692001342773438e+01 -2.8366799926757812e+02 -3.1881101608276367e+01 -7.3550003051757812e+01 -2.8224099731445312e+02 -3.1883098602294922e+01 -7.3551200866699219e+01 -2.8223898315429688e+02 -3.2027801513671875e+01 -7.3692001342773438e+01 -2.8222201538085938e+02 -3.1682201385498047e+01 -7.3551300048828125e+01 -2.8117800903320312e+02 -3.1484802246093750e+01 -7.3551200866699219e+01 -2.8055200195312500e+02 -3.1223899841308594e+01 -7.3551200866699219e+01 -2.7994601440429688e+02 -3.1823099136352539e+01 -7.3692001342773438e+01 -2.8114102172851562e+02 -3.1621400833129883e+01 -7.3692001342773438e+01 -2.8050100708007812e+02 -3.1354400634765625e+01 -7.3692001342773438e+01 -2.7988101196289062e+02 -2.8124698638916016e+01 -7.3552299499511719e+01 -2.8217199707031250e+02 -2.8288299560546875e+01 -7.3501106262207031e+01 -2.8214300537109375e+02 -2.7950498580932617e+01 -7.3754493713378906e+01 -2.8220300292968750e+02 -2.7985698699951172e+01 -7.3694900512695312e+01 -2.8219699096679688e+02 -2.8018598556518555e+01 -7.3639305114746094e+01 -2.8219100952148438e+02 -2.8120300292968750e+01 -7.3553596496582031e+01 -2.8217300415039062e+02 -3.0975099563598633e+01 -7.3692001342773438e+01 -2.7922100830078125e+02 -3.0853599548339844e+01 -7.3551300048828125e+01 -2.7930200195312500e+02 -3.0519100189208984e+01 -7.3692001342773438e+01 -2.7862200927734375e+02 -3.0409399032592773e+01 -7.3551300048828125e+01 -2.7871798706054688e+02 -3.0032598495483398e+01 -7.3692001342773438e+01 -2.7813299560546875e+02 -2.9936100006103516e+01 -7.3551200866699219e+01 -2.7824200439453125e+02 -2.7880199432373047e+01 -7.3692001342773438e+01 -2.8179602050781250e+02 -2.8018999099731445e+01 -7.3551300048828125e+01 -2.8175198364257812e+02 -2.7527500152587891e+01 -7.3692001342773438e+01 -2.8107199096679688e+02 -2.6967498779296875e+01 -7.3692001342773438e+01 -2.8050601196289062e+02 -2.7646800994873047e+01 -7.3551300048828125e+01 -2.8098800659179688e+02 -2.7052499771118164e+01 -7.3551200866699219e+01 -2.8038800048828125e+02 -2.7052400588989258e+01 -7.3551200866699219e+01 -2.8038800048828125e+02 -2.9425001144409180e+01 -7.3692001342773438e+01 -2.7766900634765625e+02 -2.9345100402832031e+01 -7.3551300048828125e+01 -2.7779098510742188e+02 -2.8773300170898438e+01 -7.3692001342773438e+01 -2.7730200195312500e+02 -2.8710401535034180e+01 -7.3551300048828125e+01 -2.7743399047851562e+02 -2.8140100479125977e+01 -7.3692001342773438e+01 -2.7704302978515625e+02 -2.8092399597167969e+01 -7.3551200866699219e+01 -2.7717999267578125e+02 -2.5127601623535156e+01 -7.3692001342773438e+01 -2.7994900512695312e+02 -2.5060199737548828e+01 -7.3694900512695312e+01 -2.7994497680664062e+02 -2.5059999465942383e+01 -7.3639305114746094e+01 -2.7991101074218750e+02 -2.5128000259399414e+01 -7.3551200866699219e+01 -2.7980398559570312e+02 -2.5059299468994141e+01 -7.3553596496582031e+01 -2.7980801391601562e+02 -2.5059299468994141e+01 -7.3552200317382812e+01 -2.7980398559570312e+02 -2.5058200836181641e+01 -7.3501602172851562e+01 -2.7964401245117188e+02 -2.5060499191284180e+01 -7.3754493713378906e+01 -2.7998098754882812e+02 -2.6102998733520508e+01 -7.3692001342773438e+01 -2.8008499145507812e+02 -2.6144399642944336e+01 -7.3551300048828125e+01 -2.7994497680664062e+02 -2.5720899581909180e+01 -7.3754493713378906e+01 -2.7665002441406250e+02 -2.5723999023437500e+01 -7.3553596496582031e+01 -2.7682302856445312e+02 -2.5722200393676758e+01 -7.3639305114746094e+01 -2.7671899414062500e+02 -2.6159898757934570e+01 -7.3692001342773438e+01 -2.7668698120117188e+02 -2.5721500396728516e+01 -7.3694900512695312e+01 -2.7668600463867188e+02 -2.6154199600219727e+01 -7.3551200866699219e+01 -2.7683300781250000e+02 -2.5724201202392578e+01 -7.3552299499511719e+01 -2.7682699584960938e+02 -2.5727100372314453e+01 -7.3501197814941406e+01 -2.7699099731445312e+02 -2.6826101303100586e+01 -7.3692001342773438e+01 -2.7674099731445312e+02 -2.7488901138305664e+01 -7.3692001342773438e+01 -2.7685699462890625e+02 -2.6807901382446289e+01 -7.3551200866699219e+01 -2.7688598632812500e+02 -2.7456600189208984e+01 -7.3551200866699219e+01 -2.7699899291992188e+02 -2.4905401229858398e+01 -7.3551200866699219e+01 -2.7980700683593750e+02 -2.4911201477050781e+01 -7.3692001342773438e+01 -2.7995300292968750e+02 -2.4751100540161133e+01 -7.3692001342773438e+01 -2.7996200561523438e+02 -2.4591499328613281e+01 -7.3692001342773438e+01 -2.7997900390625000e+02 -2.4432500839233398e+01 -7.3692001342773438e+01 -2.8000198364257812e+02 -2.4432399749755859e+01 -7.3692001342773438e+01 -2.8000198364257812e+02 -2.4408201217651367e+01 -7.3551200866699219e+01 -2.7985800170898438e+02 -2.4739301681518555e+01 -7.3551200866699219e+01 -2.7981698608398438e+02 -2.4573499679565430e+01 -7.3551200866699219e+01 -2.7983401489257812e+02 -2.4408599853515625e+01 -7.3551200866699219e+01 -2.7985800170898438e+02 -2.5541198730468750e+01 -7.3551200866699219e+01 -2.7683300781250000e+02 -2.5534400939941406e+01 -7.3692001342773438e+01 -2.7668801879882812e+02 -2.5235601425170898e+01 -7.3551200866699219e+01 -2.7685299682617188e+02 -2.4930799484252930e+01 -7.3551200866699219e+01 -2.7688400268554688e+02 -2.4627199172973633e+01 -7.3551200866699219e+01 -2.7692602539062500e+02 -2.5223499298095703e+01 -7.3692001342773438e+01 -2.7670800781250000e+02 -2.4913400650024414e+01 -7.3692001342773438e+01 -2.7674002075195312e+02 -2.4604499816894531e+01 -7.3692001342773438e+01 -2.7678298950195312e+02 -2.3832300186157227e+01 -7.4308898925781250e+01 -2.7986999511718750e+02 -2.3861700057983398e+01 -7.4012596130371094e+01 -2.7989898681640625e+02 -2.3856901168823242e+01 -7.4309295654296875e+01 -2.7990798950195312e+02 -2.3905399322509766e+01 -7.4310104370117188e+01 -2.7998300170898438e+02 -2.3970401763916016e+01 -7.4011001586914062e+01 -2.8002102661132812e+02 -2.4011800765991211e+01 -7.4310104370117188e+01 -2.8006500244140625e+02 -2.4118799209594727e+01 -7.4012596130371094e+01 -2.8008898925781250e+02 -2.4111301422119141e+01 -7.4309295654296875e+01 -2.8009799194335938e+02 -2.4139299392700195e+01 -7.4309104919433594e+01 -2.8010699462890625e+02 -2.4220100402832031e+01 -7.3883697509765625e+01 -2.8009399414062500e+02 -2.4224599838256836e+01 -7.3883895874023438e+01 -2.8009399414062500e+02 -2.4122598648071289e+01 -7.3881202697753906e+01 -2.8008300781250000e+02 -2.4152898788452148e+01 -7.3881904602050781e+01 -2.8008700561523438e+02 -2.4204000473022461e+01 -7.3883201599121094e+01 -2.8009399414062500e+02 -2.4210498809814453e+01 -7.3883506774902344e+01 -2.8009399414062500e+02 -2.4234699249267578e+01 -7.3884193420410156e+01 -2.8009301757812500e+02 -2.4245100021362305e+01 -7.3884498596191406e+01 -2.8009201049804688e+02 -2.4007299423217773e+01 -7.3879798889160156e+01 -2.8002999877929688e+02 -2.3974399566650391e+01 -7.3879501342773438e+01 -2.8001498413085938e+02 -2.3865699768066406e+01 -7.3881202697753906e+01 -2.7989300537109375e+02 -2.3863901138305664e+01 -7.3881301879882812e+01 -2.7988800048828125e+02 -2.4248199462890625e+01 -7.3551200866699219e+01 -2.7988699340820312e+02 -2.4248401641845703e+01 -7.3552497863769531e+01 -2.7988800048828125e+02 -2.4274999618530273e+01 -7.3692001342773438e+01 -2.8002999877929688e+02 -2.4275899887084961e+01 -7.3706596374511719e+01 -2.8003399658203125e+02 -2.4281999588012695e+01 -7.3816902160644531e+01 -2.8006698608398438e+02 -2.4276399612426758e+01 -7.3716201782226562e+01 -2.8003698730468750e+02 -2.3867198944091797e+01 -7.3837196350097656e+01 -2.7686798095703125e+02 -2.4338800430297852e+01 -7.3551200866699219e+01 -2.7697399902343750e+02 -2.3875499725341797e+01 -7.3692001342773438e+01 -2.7691000366210938e+02 -2.3873100280761719e+01 -7.3734001159667969e+01 -2.7689801025390625e+02 -2.4024499893188477e+01 -7.3692001342773438e+01 -2.7688198852539062e+02 -2.3911699295043945e+01 -7.3539199829101562e+01 -2.7709899902343750e+02 -2.3902999877929688e+01 -7.3551200866699219e+01 -2.7705300903320312e+02 -2.4051099777221680e+01 -7.3551200866699219e+01 -2.7702502441406250e+02 -2.3881500244140625e+01 -7.3661300659179688e+01 -2.7694100952148438e+02 -2.4314100265502930e+01 -7.3692001342773438e+01 -2.7682998657226562e+02 -2.3681800842285156e+01 -7.4007102966308594e+01 -2.7693301391601562e+02 -2.3675800323486328e+01 -7.4309104919433594e+01 -2.7691998291015625e+02 -2.3793600082397461e+01 -7.4307800292968750e+01 -2.7685601806640625e+02 -2.3534299850463867e+01 -7.4308700561523438e+01 -2.7714401245117188e+02 -2.3558700561523438e+01 -7.4309104919433594e+01 -2.7708499145507812e+02 -2.3565099716186523e+01 -7.4007102966308594e+01 -2.7709201049804688e+02 -2.3585998535156250e+01 -7.4309501647949219e+01 -2.7702001953125000e+02 -2.3670999526977539e+01 -7.4309196472167969e+01 -2.7692602539062500e+02 -2.3569900512695312e+01 -7.3881599426269531e+01 -2.7709500122070312e+02 -2.3569700241088867e+01 -7.3881599426269531e+01 -2.7709600830078125e+02 -2.3686601638793945e+01 -7.3881599426269531e+01 -2.7693701171875000e+02 -2.3687299728393555e+01 -7.3881599426269531e+01 -2.7693600463867188e+02 -2.4030199050903320e+01 -7.3798202514648438e+01 -2.8003500366210938e+02 -2.4185499191284180e+01 -7.3551300048828125e+01 -2.7988800048828125e+02 -2.4183399200439453e+01 -7.3507499694824219e+01 -2.7969699096679688e+02 -2.4023799896240234e+01 -7.3605201721191406e+01 -2.7988800048828125e+02 -2.4017299652099609e+01 -7.3551200866699219e+01 -2.7971600341796875e+02 -2.3872499465942383e+01 -7.3692001342773438e+01 -2.7973199462890625e+02 -2.3906801223754883e+01 -7.3729301452636719e+01 -2.7988800048828125e+02 -2.3868101119995117e+01 -7.3706703186035156e+01 -2.7973199462890625e+02 -2.4196300506591797e+01 -7.3692199707031250e+01 -2.8003500366210938e+02 -2.4099899291992188e+01 -7.3724296569824219e+01 -2.8003500366210938e+02 -2.3816499710083008e+01 -7.3678596496582031e+01 -2.7693600463867188e+02 -2.3759199142456055e+01 -7.3575897216796875e+01 -2.7709600830078125e+02 -2.3622499465942383e+01 -7.3707901000976562e+01 -2.7709600830078125e+02 -2.3599800109863281e+01 -7.3694099426269531e+01 -2.7728399658203125e+02 -2.3600500106811523e+01 -7.3692001342773438e+01 -2.7728302001953125e+02 -2.3745300292968750e+01 -7.3551200866699219e+01 -2.7726699829101562e+02 -2.3745498657226562e+01 -7.3551200866699219e+01 -2.7726699829101562e+02 -2.3723098754882812e+01 -7.3768798828125000e+01 -2.7693600463867188e+02 2.2697500228881836e+01 -7.4403999328613281e+01 -2.7691598510742188e+02 2.2697500228881836e+01 -7.4474296569824219e+01 -2.7684301757812500e+02 2.2779901504516602e+01 -7.4404800415039062e+01 -2.7692401123046875e+02 2.2793899536132812e+01 -7.4474601745605469e+01 -2.7685202026367188e+02 2.2980098724365234e+01 -7.4406105041503906e+01 -2.7702001953125000e+02 2.3104200363159180e+01 -7.4405799865722656e+01 -2.7720498657226562e+02 2.3118398666381836e+01 -7.4403999328613281e+01 -2.7742700195312500e+02 2.3027799606323242e+01 -7.4474998474121094e+01 -2.7696600341796875e+02 2.3172899246215820e+01 -7.4474899291992188e+01 -2.7718099975585938e+02 2.3189901351928711e+01 -7.4474296569824219e+01 -2.7744100952148438e+02 1.9387699127197266e+01 -7.4403999328613281e+01 -2.7691598510742188e+02 1.9387699127197266e+01 -7.4474296569824219e+01 -2.7684301757812500e+02 2.1862400054931641e+01 -7.4500000000000000e+01 -2.8475100708007812e+02 2.1725999832153320e+01 -7.4451400756835938e+01 -2.8501000976562500e+02 2.1726600646972656e+01 -7.4451606750488281e+01 -2.8500802612304688e+02 2.1542800903320312e+01 -7.4330001831054688e+01 -2.8536199951171875e+02 2.1557500839233398e+01 -7.4357002258300781e+01 -2.8531799316406250e+02 2.1552299499511719e+01 -7.4355697631835938e+01 -2.8534298706054688e+02 2.1589399337768555e+01 -7.4402694702148438e+01 -2.8526898193359375e+02 2.1589399337768555e+01 -7.4402603149414062e+01 -2.8526898193359375e+02 2.1584798812866211e+01 -7.4401000976562500e+01 -2.8527798461914062e+02 2.1691900253295898e+01 -7.4439201354980469e+01 -2.8507400512695312e+02 1.9172899246215820e+01 -7.4405097961425781e+01 -2.7697302246093750e+02 1.8952899932861328e+01 -7.4474601745605469e+01 -2.7709399414062500e+02 1.8893400192260742e+01 -7.4474296569824219e+01 -2.7725900268554688e+02 1.9015901565551758e+01 -7.4404899597167969e+01 -2.7713000488281250e+02 1.8965200424194336e+01 -7.4403999328613281e+01 -2.7727197265625000e+02 1.9136499404907227e+01 -7.4474700927734375e+01 -2.7691000366210938e+02 2.3459098815917969e+01 -7.4403999328613281e+01 -2.8381799316406250e+02 2.3425500869750977e+01 -7.4474296569824219e+01 -2.8375302124023438e+02 2.3425399780273438e+01 -7.4474296569824219e+01 -2.8375302124023438e+02 2.1569200515747070e+01 -7.4357299804687500e+01 -2.8532299804687500e+02 2.1733499526977539e+01 -7.4403999328613281e+01 -2.8511599731445312e+02 2.2544101715087891e+01 -7.4403999328613281e+01 -2.8439700317382812e+02 2.2500099182128906e+01 -7.4474296569824219e+01 -2.8433801269531250e+02 1.5209600448608398e+01 -7.4403999328613281e+01 -2.9895898437500000e+02 1.5137800216674805e+01 -7.4474296569824219e+01 -2.9894598388671875e+02 2.5843898773193359e+01 -7.4473098754882812e+01 -2.8320300292968750e+02 2.5843898773193359e+01 -7.4473899841308594e+01 -2.8319998168945312e+02 2.5614301681518555e+01 -7.4474296569824219e+01 -2.8320199584960938e+02 2.5845098495483398e+01 -7.4498199462890625e+01 -2.8313000488281250e+02 2.5843000411987305e+01 -7.4430305480957031e+01 -2.8325399780273438e+02 2.5616298675537109e+01 -7.4403999328613281e+01 -2.8327499389648438e+02 2.5842800140380859e+01 -7.4402503967285156e+01 -2.8327102661132812e+02 2.5842500686645508e+01 -7.4372703552246094e+01 -2.8328897094726562e+02 2.4788299560546875e+01 -7.4474296569824219e+01 -2.8328799438476562e+02 2.4801500320434570e+01 -7.4403999328613281e+01 -2.8335897827148438e+02 2.4013099670410156e+01 -7.4403999328613281e+01 -2.8357299804687500e+02 2.3987998962402344e+01 -7.4474296569824219e+01 -2.8350500488281250e+02 1.5632100105285645e+01 -7.4403999328613281e+01 -2.9946099853515625e+02 1.5632100105285645e+01 -7.4474296569824219e+01 -2.9953302001953125e+02 1.5558699607849121e+01 -7.4404701232910156e+01 -2.9945498657226562e+02 1.5546300888061523e+01 -7.4474601745605469e+01 -2.9952697753906250e+02 1.5356499671936035e+01 -7.4406105041503906e+01 -2.9936199951171875e+02 1.5228499412536621e+01 -7.4405799865722656e+01 -2.9917999267578125e+02 1.5309999465942383e+01 -7.4474899291992188e+01 -2.9941799926757812e+02 1.5160300254821777e+01 -7.4474899291992188e+01 -2.9920501708984375e+02 2.5964500427246094e+01 -7.4474296569824219e+01 -2.8320397949218750e+02 2.5961700439453125e+01 -7.4403999328613281e+01 -2.8327700805664062e+02 2.6972400665283203e+01 -7.4403999328613281e+01 -2.8340200805664062e+02 2.7540498733520508e+01 -7.4403999328613281e+01 -2.8356900024414062e+02 2.8072898864746094e+01 -7.4403999328613281e+01 -2.8381799316406250e+02 2.6988201141357422e+01 -7.4474296569824219e+01 -2.8333099365234375e+02 2.7565999984741211e+01 -7.4474296569824219e+01 -2.8350000000000000e+02 2.8109300613403320e+01 -7.4474296569824219e+01 -2.8375500488281250e+02 2.8109399795532227e+01 -7.4474296569824219e+01 -2.8375500488281250e+02 1.8938800811767578e+01 -7.4403999328613281e+01 -2.9946099853515625e+02 1.8938800811767578e+01 -7.4474296569824219e+01 -2.9953302001953125e+02 2.9528200149536133e+01 -7.4474296569824219e+01 -2.8515899658203125e+02 2.9528200149536133e+01 -7.4474296569824219e+01 -2.8516000366210938e+02 2.9116199493408203e+01 -7.4474296569824219e+01 -2.8458099365234375e+02 2.8621900558471680e+01 -7.4474296569824219e+01 -2.8410501098632812e+02 2.9465200424194336e+01 -7.4403999328613281e+01 -2.8519601440429688e+02 2.9061000823974609e+01 -7.4403999328613281e+01 -2.8462899780273438e+02 2.8576299667358398e+01 -7.4403999328613281e+01 -2.8416201782226562e+02 1.9153600692749023e+01 -7.4405097961425781e+01 -2.9940399169921875e+02 1.9373699188232422e+01 -7.4474601745605469e+01 -2.9928298950195312e+02 1.9432901382446289e+01 -7.4474296569824219e+01 -2.9911898803710938e+02 1.9310598373413086e+01 -7.4404899597167969e+01 -2.9924700927734375e+02 1.9361099243164062e+01 -7.4403999328613281e+01 -2.9910598754882812e+02 1.9190000534057617e+01 -7.4474601745605469e+01 -2.9946701049804688e+02 3.0008800506591797e+01 -7.4474296569824219e+01 -2.8628799438476562e+02 3.0192001342773438e+01 -7.4474296569824219e+01 -2.8714999389648438e+02 2.9938800811767578e+01 -7.4403999328613281e+01 -2.8630899047851562e+02 3.0119899749755859e+01 -7.4403999328613281e+01 -2.8716000366210938e+02 2.9735500335693359e+01 -7.4403999328613281e+01 -2.8573797607421875e+02 2.9802600860595703e+01 -7.4474296569824219e+01 -2.8570898437500000e+02 2.1277900695800781e+01 -7.4371101379394531e+01 -2.8816198730468750e+02 2.1295198440551758e+01 -7.4402694702148438e+01 -2.8817001342773438e+02 2.1308500289916992e+01 -7.4427200317382812e+01 -2.8817599487304688e+02 2.1354499816894531e+01 -7.4470100402832031e+01 -2.8819799804687500e+02 2.1361900329589844e+01 -7.4472396850585938e+01 -2.8820101928710938e+02 2.1449501037597656e+01 -7.4500000000000000e+01 -2.8824298095703125e+02 3.0226900100708008e+01 -7.4473098754882812e+01 -2.8945999145507812e+02 3.0229200363159180e+01 -7.4473800659179688e+01 -2.8946099853515625e+02 3.0266300201416016e+01 -7.4474296569824219e+01 -2.8896902465820312e+02 3.0315399169921875e+01 -7.4499694824218750e+01 -2.8947201538085938e+02 3.0175701141357422e+01 -7.4430198669433594e+01 -2.8945401000976562e+02 3.0141399383544922e+01 -7.4372703552246094e+01 -2.8944900512695312e+02 3.0193500518798828e+01 -7.4403999328613281e+01 -2.8896499633789062e+02 3.0159101486206055e+01 -7.4402503967285156e+01 -2.8945098876953125e+02 3.0279998779296875e+01 -7.4474296569824219e+01 -2.8836102294921875e+02 3.0255901336669922e+01 -7.4474296569824219e+01 -2.8775399780273438e+02 3.0207099914550781e+01 -7.4403999328613281e+01 -2.8836199951171875e+02 3.0183198928833008e+01 -7.4403999328613281e+01 -2.8775900268554688e+02 2.2028999328613281e+01 -7.4403999328613281e+01 -2.8746200561523438e+02 2.2579200744628906e+01 -7.4403999328613281e+01 -2.8710202026367188e+02 2.2073499679565430e+01 -7.4474296569824219e+01 -2.8751998901367188e+02 2.2614099502563477e+01 -7.4474296569824219e+01 -2.8716598510742188e+02 2.1592800140380859e+01 -7.4474296569824219e+01 -2.8794900512695312e+02 2.1540699005126953e+01 -7.4403999328613281e+01 -2.8789801025390625e+02 2.8543199539184570e+01 -7.4403999328613281e+01 -2.9910299682617188e+02 2.8614999771118164e+01 -7.4474296569824219e+01 -2.9911499023437500e+02 2.4200199127197266e+01 -7.4474296569824219e+01 -2.8681900024414062e+02 2.3106201171875000e+01 -7.4474296569824219e+01 -2.8695700073242188e+02 2.3609598159790039e+01 -7.4474296569824219e+01 -2.8684600830078125e+02 2.4198801040649414e+01 -7.4474296569824219e+01 -2.8681900024414062e+02 2.4201900482177734e+01 -7.4403999328613281e+01 -2.8674600219726562e+02 2.4201101303100586e+01 -7.4403999328613281e+01 -2.8674600219726562e+02 2.3600000381469727e+01 -7.4403999328613281e+01 -2.8677401733398438e+02 2.3084400177001953e+01 -7.4403999328613281e+01 -2.8688800048828125e+02 2.8120199203491211e+01 -7.4403999328613281e+01 -2.9946099853515625e+02 2.8335100173950195e+01 -7.4405097961425781e+01 -2.9940399169921875e+02 2.8555101394653320e+01 -7.4474601745605469e+01 -2.9928298950195312e+02 2.8492099761962891e+01 -7.4404899597167969e+01 -2.9924700927734375e+02 2.8371398925781250e+01 -7.4474700927734375e+01 -2.9946701049804688e+02 2.8120199203491211e+01 -7.4474296569824219e+01 -2.9953302001953125e+02 2.4585901260375977e+01 -7.4474296569824219e+01 -2.8685000610351562e+02 2.4905300140380859e+01 -7.4403999328613281e+01 -2.8684600830078125e+02 2.5209100723266602e+01 -7.4403999328613281e+01 -2.8697000122070312e+02 2.4884401321411133e+01 -7.4474296569824219e+01 -2.8691500854492188e+02 2.5174100875854492e+01 -7.4474296569824219e+01 -2.8703399658203125e+02 2.4596599578857422e+01 -7.4403999328613281e+01 -2.8677801513671875e+02 2.4814199447631836e+01 -7.4403999328613281e+01 -2.9946099853515625e+02 2.4814199447631836e+01 -7.4474296569824219e+01 -2.9953302001953125e+02 2.5423599243164062e+01 -7.4403999328613281e+01 -2.8710897827148438e+02 2.5209199905395508e+01 -7.4403999328613281e+01 -2.8697000122070312e+02 2.5174200057983398e+01 -7.4474296569824219e+01 -2.8703399658203125e+02 2.5379100799560547e+01 -7.4474296569824219e+01 -2.8716702270507812e+02 2.5609699249267578e+01 -7.4403999328613281e+01 -2.8727999877929688e+02 2.5555801391601562e+01 -7.4474296569824219e+01 -2.8732897949218750e+02 2.5786399841308594e+01 -7.4403999328613281e+01 -2.8752499389648438e+02 2.5722900390625000e+01 -7.4474296569824219e+01 -2.8756100463867188e+02 2.4730899810791016e+01 -7.4474601745605469e+01 -2.9952697753906250e+02 2.4743000030517578e+01 -7.4404701232910156e+01 -2.9945498657226562e+02 2.4540300369262695e+01 -7.4405998229980469e+01 -2.9936401367187500e+02 2.4411399841308594e+01 -7.4405799865722656e+01 -2.9918200683593750e+02 2.4391298294067383e+01 -7.4403999328613281e+01 -2.9896099853515625e+02 2.4494100570678711e+01 -7.4474899291992188e+01 -2.9942001342773438e+02 2.4343299865722656e+01 -7.4474899291992188e+01 -2.9920797729492188e+02 2.4319499969482422e+01 -7.4474296569824219e+01 -2.9894900512695312e+02 2.5906400680541992e+01 -7.4403999328613281e+01 -2.8778900146484375e+02 2.5837799072265625e+01 -7.4474296569824219e+01 -2.8781399536132812e+02 2.5981899261474609e+01 -7.4403999328613281e+01 -2.8805801391601562e+02 2.5910598754882812e+01 -7.4474296569824219e+01 -2.8807299804687500e+02 2.6025499343872070e+01 -7.4403999328613281e+01 -2.8835202026367188e+02 2.5953001022338867e+01 -7.4474296569824219e+01 -2.8835800170898438e+02 2.5841299057006836e+01 -7.4499504089355469e+01 -2.8937799072265625e+02 2.5993999481201172e+01 -7.4402503967285156e+01 -2.8940100097656250e+02 2.5977499008178711e+01 -7.4430305480957031e+01 -2.8939801025390625e+02 2.5926300048828125e+01 -7.4473098754882812e+01 -2.8939102172851562e+02 2.5924098968505859e+01 -7.4473899841308594e+01 -2.8938998413085938e+02 2.6011699676513672e+01 -7.4372703552246094e+01 -2.8940298461914062e+02 2.6007299423217773e+01 -7.4403999328613281e+01 -2.8930999755859375e+02 2.5934898376464844e+01 -7.4474296569824219e+01 -2.8930200195312500e+02 2.6034099578857422e+01 -7.4403999328613281e+01 -2.8899301147460938e+02 2.6041500091552734e+01 -7.4403999328613281e+01 -2.8867300415039062e+02 2.5961399078369141e+01 -7.4474296569824219e+01 -2.8898901367187500e+02 2.5968700408935547e+01 -7.4474296569824219e+01 -2.8867401123046875e+02 6.2479901313781738e-01 -7.4403999328613281e+01 -2.9177499389648438e+02 6.8429899215698242e-01 -7.4372703552246094e+01 -2.9135198974609375e+02 6.6650003194808960e-01 -7.4402503967285156e+01 -2.9135000610351562e+02 6.4999699592590332e-01 -7.4430305480957031e+01 -2.9134802246093750e+02 5.5240100622177124e-01 -7.4474296569824219e+01 -2.9176699829101562e+02 5.9860199689865112e-01 -7.4473098754882812e+01 -2.9134197998046875e+02 5.9640502929687500e-01 -7.4473899841308594e+01 -2.9134197998046875e+02 5.2599704265594482e-01 -7.4498100280761719e+01 -2.9133401489257812e+02 6.7809998989105225e-01 -7.4474296569824219e+01 -2.9478399658203125e+02 4.9590399861335754e-01 -7.4474296569824219e+01 -2.9267599487304688e+02 5.1720499992370605e-01 -7.4474296569824219e+01 -2.9357800292968750e+02 7.4960297346115112e-01 -7.4403999328613281e+01 -2.9476998901367188e+02 7.4949902296066284e-01 -7.4403999328613281e+01 -2.9476998901367188e+02 5.8990001678466797e-01 -7.4403999328613281e+01 -2.9357299804687500e+02 5.6880003213882446e-01 -7.4403999328613281e+01 -2.9267697143554688e+02 7.9500001668930054e-01 -7.4403999328613281e+01 -2.9051501464843750e+02 7.2339999675750732e-01 -7.4474296569824219e+01 -2.9050100708007812e+02 1.0104999542236328e+00 -7.4474296569824219e+01 -2.8932199096679688e+02 1.0801999568939209e+00 -7.4403999328613281e+01 -2.8934298706054688e+02 1.4239000082015991e+00 -7.4474296569824219e+01 -2.8817999267578125e+02 1.4908999204635620e+00 -7.4403999328613281e+01 -2.8820898437500000e+02 8.9190202951431274e-01 -7.4474296569824219e+01 -2.9561199951171875e+02 9.6130400896072388e-01 -7.4403999328613281e+01 -2.9559002685546875e+02 1.2616999149322510e+00 -7.4403999328613281e+01 -2.9636801147460938e+02 1.1956000328063965e+00 -7.4474296569824219e+01 -2.9639801025390625e+02 1.7857999801635742e+00 -7.4403999328613281e+01 -2.9729800415039062e+02 1.7254999876022339e+00 -7.4474296569824219e+01 -2.9733898925781250e+02 3.1117000579833984e+00 -7.4474296569824219e+01 -2.8555999755859375e+02 3.1649000644683838e+00 -7.4403999328613281e+01 -2.8560998535156250e+02 2.5541000366210938e+00 -7.4403999328613281e+01 -2.8634197998046875e+02 2.4957001209259033e+00 -7.4474296569824219e+01 -2.8629800415039062e+02 1.9710999727249146e+00 -7.4474296569824219e+01 -2.8709097290039062e+02 2.0339000225067139e+00 -7.4403999328613281e+01 -2.8712799072265625e+02 2.3245999813079834e+00 -7.4403999328613281e+01 -2.9797000122070312e+02 2.9465000629425049e+00 -7.4403999328613281e+01 -2.9853500366210938e+02 3.7565999031066895e+00 -7.4403999328613281e+01 -2.9906201171875000e+02 2.9017999172210693e+00 -7.4474296569824219e+01 -2.9859201049804688e+02 3.7218999862670898e+00 -7.4474296569824219e+01 -2.9912600708007812e+02 2.2716000080108643e+00 -7.4474296569824219e+01 -2.9802001953125000e+02 5.6035099029541016e+00 -7.4474296569824219e+01 -2.8379501342773438e+02 4.8116998672485352e+00 -7.4403999328613281e+01 -2.8428399658203125e+02 5.6329998970031738e+00 -7.4403999328613281e+01 -2.8386102294921875e+02 4.7746000289916992e+00 -7.4474296569824219e+01 -2.8422201538085938e+02 4.0147004127502441e+00 -7.4474296569824219e+01 -2.8473699951171875e+02 4.0592002868652344e+00 -7.4403999328613281e+01 -2.8479498291015625e+02 6.6951098442077637e+00 -7.4474296569824219e+01 -2.9984097290039062e+02 4.6024999618530273e+00 -7.4403999328613281e+01 -2.9942700195312500e+02 4.5794000625610352e+00 -7.4474296569824219e+01 -2.9949600219726562e+02 5.4658999443054199e+00 -7.4474296569824219e+01 -2.9972000122070312e+02 6.6944999694824219e+00 -7.4474296569824219e+01 -2.9984097290039062e+02 6.6967000961303711e+00 -7.4403999328613281e+01 -2.9976800537109375e+02 6.6964001655578613e+00 -7.4403999328613281e+01 -2.9976800537109375e+02 5.4787998199462891e+00 -7.4403999328613281e+01 -2.9964898681640625e+02 8.8379993438720703e+00 -7.4474296569824219e+01 -2.8320101928710938e+02 8.8362007141113281e+00 -7.4403999328613281e+01 -2.8327398681640625e+02 7.7258100509643555e+00 -7.4474296569824219e+01 -2.8324197387695312e+02 6.6536102294921875e+00 -7.4474296569824219e+01 -2.8343200683593750e+02 7.7332997322082520e+00 -7.4403999328613281e+01 -2.8331500244140625e+02 6.6716098785400391e+00 -7.4403999328613281e+01 -2.8350201416015625e+02 9.2387094497680664e+00 -7.4474296569824219e+01 -2.9947000122070312e+02 7.3525004386901855e+00 -7.4474296569824219e+01 -2.9982901000976562e+02 8.0017004013061523e+00 -7.4474296569824219e+01 -2.9976098632812500e+02 9.2160005569458008e+00 -7.4403999328613281e+01 -2.9940097045898438e+02 7.9911098480224609e+00 -7.4403999328613281e+01 -2.9968899536132812e+02 7.3481101989746094e+00 -7.4403999328613281e+01 -2.9975598144531250e+02 1.0077099800109863e+01 -7.4403999328613281e+01 -2.8339999389648438e+02 1.0090700149536133e+01 -7.4474296569824219e+01 -2.8332800292968750e+02 1.0698699951171875e+01 -7.4403999328613281e+01 -2.8355200195312500e+02 1.1305399894714355e+01 -7.4403999328613281e+01 -2.8377301025390625e+02 1.0719699859619141e+01 -7.4474296569824219e+01 -2.8348199462890625e+02 1.1334300041198730e+01 -7.4474296569824219e+01 -2.8370602416992188e+02 9.8072996139526367e+00 -7.4403999328613281e+01 -2.9917898559570312e+02 9.8358001708984375e+00 -7.4474296569824219e+01 -2.9924600219726562e+02 1.0371199607849121e+01 -7.4403999328613281e+01 -2.9890798950195312e+02 1.0405699729919434e+01 -7.4474296569824219e+01 -2.9897299194335938e+02 1.1383399963378906e+01 -7.4403999328613281e+01 -2.9824002075195312e+02 1.1428999900817871e+01 -7.4474296569824219e+01 -2.9829699707031250e+02 1.3184000015258789e+01 -7.4474296569824219e+01 -2.8502700805664062e+02 1.2401999473571777e+01 -7.4474296569824219e+01 -2.8431399536132812e+02 1.1885600090026855e+01 -7.4474296569824219e+01 -2.8398001098632812e+02 1.1849699974060059e+01 -7.4403999328613281e+01 -2.8404400634765625e+02 1.2358900070190430e+01 -7.4403999328613281e+01 -2.8437298583984375e+02 1.3129400253295898e+01 -7.4403999328613281e+01 -2.8507501220703125e+02 1.1948499679565430e+01 -7.4474296569824219e+01 -2.9783300781250000e+02 1.2408199310302734e+01 -7.4474296569824219e+01 -2.9732000732421875e+02 1.3012800216674805e+01 -7.4474296569824219e+01 -2.9642297363281250e+02 1.3012900352478027e+01 -7.4474296569824219e+01 -2.9642297363281250e+02 1.2949299812316895e+01 -7.4403999328613281e+01 -2.9638800048828125e+02 1.2351400375366211e+01 -7.4403999328613281e+01 -2.9727499389648438e+02 1.1897100448608398e+01 -7.4403999328613281e+01 -2.9778100585937500e+02 1.3821300506591797e+01 -7.4403999328613281e+01 -2.8606600952148438e+02 1.4240200042724609e+01 -7.4403999328613281e+01 -2.8703900146484375e+02 1.3885299682617188e+01 -7.4474296569824219e+01 -2.8603100585937500e+02 1.4309300422668457e+01 -7.4474296569824219e+01 -2.8701599121093750e+02 1.3503399848937988e+01 -7.4403999328613281e+01 -2.8555102539062500e+02 1.3563199996948242e+01 -7.4474296569824219e+01 -2.8550900268554688e+02 1.3442800521850586e+01 -7.4474296569824219e+01 -2.9543798828125000e+02 1.3373499870300293e+01 -7.4403999328613281e+01 -2.9541500854492188e+02 1.3600600242614746e+01 -7.4403999328613281e+01 -2.9441400146484375e+02 1.3672699928283691e+01 -7.4474296569824219e+01 -2.9442300415039062e+02 1.4487899780273438e+01 -7.4403999328613281e+01 -2.8803698730468750e+02 1.4594599723815918e+01 -7.4403999328613281e+01 -2.8908499145507812e+02 1.4559700012207031e+01 -7.4474296569824219e+01 -2.8802401733398438e+02 1.4667400360107422e+01 -7.4474296569824219e+01 -2.8908200073242188e+02 1.3596799850463867e+01 -7.4405296325683594e+01 -2.9426898193359375e+02 1.3172499656677246e+01 -7.4403999328613281e+01 -2.9392599487304688e+02 1.3171999931335449e+01 -7.4474296569824219e+01 -2.9385302734375000e+02 1.3326499938964844e+01 -7.4405403137207031e+01 -2.9395300292968750e+02 1.3351899147033691e+01 -7.4474800109863281e+01 -2.9388497924804688e+02 1.3451399803161621e+01 -7.4405998229980469e+01 -2.9402499389648438e+02 1.3545099258422852e+01 -7.4405998229980469e+01 -2.9413400268554688e+02 1.3497900009155273e+01 -7.4474899291992188e+01 -2.9396899414062500e+02 1.3607500076293945e+01 -7.4474899291992188e+01 -2.9409701538085938e+02 1.3668000221252441e+01 -7.4474700927734375e+01 -2.9425497436523438e+02 1.4166099548339844e+01 -7.4403999328613281e+01 -2.8952899169921875e+02 1.4308400154113770e+01 -7.4405097961425781e+01 -2.8950598144531250e+02 1.4585000038146973e+01 -7.4404899597167969e+01 -2.8919500732421875e+02 1.4656000137329102e+01 -7.4474601745605469e+01 -2.8921099853515625e+02 1.4530599594116211e+01 -7.4405601501464844e+01 -2.8932800292968750e+02 1.4434700012207031e+01 -7.4405700683593750e+01 -2.8943600463867188e+02 1.4592300415039062e+01 -7.4474800109863281e+01 -2.8936700439453125e+02 1.4480099678039551e+01 -7.4474800109863281e+01 -2.8949298095703125e+02 1.4332399368286133e+01 -7.4474700927734375e+01 -2.8957400512695312e+02 1.4166099548339844e+01 -7.4474296569824219e+01 -2.8960202026367188e+02 1.0055899620056152e+01 -7.4403999328613281e+01 -2.9394998168945312e+02 1.0055400848388672e+01 -7.4474296569824219e+01 -2.9387701416015625e+02 1.1117000579833984e+01 -7.4403999328613281e+01 -2.8952899169921875e+02 1.1117000579833984e+01 -7.4474296569824219e+01 -2.8960202026367188e+02 9.9139995574951172e+00 -7.4404701232910156e+01 -2.9397500610351562e+02 9.6485004425048828e+00 -7.4403999328613281e+01 -2.9425497436523438e+02 9.5787897109985352e+00 -7.4474296569824219e+01 -2.9423400878906250e+02 9.6936092376708984e+00 -7.4404594421386719e+01 -2.9415399169921875e+02 9.6314992904663086e+00 -7.4474494934082031e+01 -2.9411599731445312e+02 9.7883901596069336e+00 -7.4404899597167969e+01 -2.9404501342773438e+02 9.7425003051757812e+00 -7.4474601745605469e+01 -2.9398901367187500e+02 9.8893899917602539e+00 -7.4474601745605469e+01 -2.9390600585937500e+02 1.1053799629211426e+01 -7.4404502868652344e+01 -2.8952499389648438e+02 1.1043000221252441e+01 -7.4474403381347656e+01 -2.8959701538085938e+02 1.0723299980163574e+01 -7.4404899597167969e+01 -2.8927200317382812e+02 1.0802100181579590e+01 -7.4405403137207031e+01 -2.8939300537109375e+02 1.0916699409484863e+01 -7.4405296325683594e+01 -2.8948001098632812e+02 1.0689299583435059e+01 -7.4403999328613281e+01 -2.8913198852539062e+02 1.0882800102233887e+01 -7.4474700927734375e+01 -2.8954501342773438e+02 1.0748899459838867e+01 -7.4474800109863281e+01 -2.8944201660156250e+02 1.0656599998474121e+01 -7.4474601745605469e+01 -2.8930099487304688e+02 1.0616700172424316e+01 -7.4474296569824219e+01 -2.8913699340820312e+02 9.3434000015258789e+00 -7.4403999328613281e+01 -2.9495800781250000e+02 8.7187004089355469e+00 -7.4403999328613281e+01 -2.9569302368164062e+02 9.2807998657226562e+00 -7.4474296569824219e+01 -2.9492102050781250e+02 8.6718101501464844e+00 -7.4474296569824219e+01 -2.9563702392578125e+02 1.0586000442504883e+01 -7.4474296569824219e+01 -2.8884500122070312e+02 1.0522500038146973e+01 -7.4474296569824219e+01 -2.8848699951171875e+02 1.0658200263977051e+01 -7.4403999328613281e+01 -2.8883499145507812e+02 1.0593599319458008e+01 -7.4403999328613281e+01 -2.8847198486328125e+02 6.8156003952026367e+00 -7.4474296569824219e+01 -2.9623800659179688e+02 8.2702007293701172e+00 -7.4403999328613281e+01 -2.9599600219726562e+02 8.2360095977783203e+00 -7.4474296569824219e+01 -2.9593200683593750e+02 7.3569998741149902e+00 -7.4474296569824219e+01 -2.9620999145507812e+02 6.8165998458862305e+00 -7.4474296569824219e+01 -2.9623800659179688e+02 6.8144102096557617e+00 -7.4403999328613281e+01 -2.9631100463867188e+02 6.8147001266479492e+00 -7.4403999328613281e+01 -2.9631100463867188e+02 7.3668999671936035e+00 -7.4403999328613281e+01 -2.9628198242187500e+02 1.0327399253845215e+01 -7.4474296569824219e+01 -2.8791299438476562e+02 1.0169800758361816e+01 -7.4474296569824219e+01 -2.8763299560546875e+02 1.0393200874328613e+01 -7.4403999328613281e+01 -2.8788098144531250e+02 1.0230600357055664e+01 -7.4403999328613281e+01 -2.8759301757812500e+02 1.0514000892639160e+01 -7.4403999328613281e+01 -2.8818197631835938e+02 1.0444800376892090e+01 -7.4474296569824219e+01 -2.8820498657226562e+02 5.5125999450683594e+00 -7.4474296569824219e+01 -2.9577600097656250e+02 6.2139902114868164e+00 -7.4403999328613281e+01 -2.9623898315429688e+02 6.2314996719360352e+00 -7.4474296569824219e+01 -2.9616799926757812e+02 5.7629899978637695e+00 -7.4474296569824219e+01 -2.9597698974609375e+02 5.5127000808715820e+00 -7.4474296569824219e+01 -2.9577600097656250e+02 5.4602999687194824e+00 -7.4403999328613281e+01 -2.9582598876953125e+02 5.7246999740600586e+00 -7.4403999328613281e+01 -2.9603897094726562e+02 9.7783098220825195e+00 -7.4474296569824219e+01 -2.8720999145507812e+02 9.5298995971679688e+00 -7.4474296569824219e+01 -2.8704898071289062e+02 9.8229093551635742e+00 -7.4403999328613281e+01 -2.8715301513671875e+02 9.5646991729736328e+00 -7.4403999328613281e+01 -2.8698501586914062e+02 1.0045399665832520e+01 -7.4403999328613281e+01 -2.8735598754882812e+02 9.9919004440307617e+00 -7.4474296569824219e+01 -2.8740600585937500e+02 4.9069004058837891e+00 -7.4474296569824219e+01 -2.9466198730468750e+02 5.1524000167846680e+00 -7.4474296569824219e+01 -2.9529199218750000e+02 5.0082001686096191e+00 -7.4474296569824219e+01 -2.9498498535156250e+02 4.8361997604370117e+00 -7.4403999328613281e+01 -2.9467898559570312e+02 4.9402003288269043e+00 -7.4403999328613281e+01 -2.9501101684570312e+02 5.0887999534606934e+00 -7.4403999328613281e+01 -2.9532800292968750e+02 8.5357999801635742e+00 -7.4499000549316406e+01 -2.8688101196289062e+02 8.8654003143310547e+00 -7.4474296569824219e+01 -2.8683599853515625e+02 8.5415000915527344e+00 -7.4402503967285156e+01 -2.8673400878906250e+02 8.5409002304077148e+00 -7.4430305480957031e+01 -2.8675000000000000e+02 8.8766098022460938e+00 -7.4403999328613281e+01 -2.8676400756835938e+02 8.5389003753662109e+00 -7.4473098754882812e+01 -2.8680200195312500e+02 8.5388002395629883e+00 -7.4473899841308594e+01 -2.8680398559570312e+02 8.5422000885009766e+00 -7.4372703552246094e+01 -2.8671600341796875e+02 9.2257003784179688e+00 -7.4403999328613281e+01 -2.8684298706054688e+02 9.2040996551513672e+00 -7.4474296569824219e+01 -2.8691299438476562e+02 4.8264999389648438e+00 -7.4474296569824219e+01 -2.9425900268554688e+02 4.7807998657226562e+00 -7.4474296569824219e+01 -2.9385501098632812e+02 4.7705001831054688e+00 -7.4474296569824219e+01 -2.9321600341796875e+02 4.6975998878479004e+00 -7.4403999328613281e+01 -2.9321301269531250e+02 4.7081003189086914e+00 -7.4403999328613281e+01 -2.9385998535156250e+02 4.7543997764587402e+00 -7.4403999328613281e+01 -2.9427001953125000e+02 7.5602097511291504e+00 -7.4403999328613281e+01 -2.8683401489257812e+02 8.0904102325439453e+00 -7.4403999328613281e+01 -2.8674298095703125e+02 8.0966997146606445e+00 -7.4474296569824219e+01 -2.8681500244140625e+02 7.5790996551513672e+00 -7.4474296569824219e+01 -2.8690499877929688e+02 6.9452099800109863e+00 -7.4474296569824219e+01 -2.8717800903320312e+02 6.9064898490905762e+00 -7.4403999328613281e+01 -2.8711599731445312e+02 4.8727002143859863e+00 -7.4474296569824219e+01 -2.9177200317382812e+02 4.7892999649047852e+00 -7.4474296569824219e+01 -2.9279901123046875e+02 4.8161001205444336e+00 -7.4474296569824219e+01 -2.9238198852539062e+02 4.8726000785827637e+00 -7.4474296569824219e+01 -2.9177297973632812e+02 4.8003001213073730e+00 -7.4403999328613281e+01 -2.9176501464843750e+02 4.8001999855041504e+00 -7.4403999328613281e+01 -2.9176501464843750e+02 4.7435002326965332e+00 -7.4403999328613281e+01 -2.9237698364257812e+02 4.7165999412536621e+00 -7.4403999328613281e+01 -2.9279501342773438e+02 5.8840098381042480e+00 -7.4474296569824219e+01 -2.8824600219726562e+02 6.1714997291564941e+00 -7.4474296569824219e+01 -2.8784899902343750e+02 6.5067000389099121e+00 -7.4474296569824219e+01 -2.8750500488281250e+02 6.4583997726440430e+00 -7.4403999328613281e+01 -2.8744998168945312e+02 6.1157898902893066e+00 -7.4403999328613281e+01 -2.8780200195312500e+02 5.8221998214721680e+00 -7.4403999328613281e+01 -2.8820700073242188e+02 4.8286004066467285e+00 -7.4372703552246094e+01 -2.9135299682617188e+02 4.8464002609252930e+00 -7.4402503967285156e+01 -2.9135501098632812e+02 4.8629102706909180e+00 -7.4430305480957031e+01 -2.9135702514648438e+02 4.9141998291015625e+00 -7.4473098754882812e+01 -2.9136300659179688e+02 4.9164996147155762e+00 -7.4473899841308594e+01 -2.9136300659179688e+02 4.9948997497558594e+00 -7.4499099731445312e+01 -2.9137301635742188e+02 5.1730999946594238e+00 -7.4403999328613281e+01 -2.8972500610351562e+02 5.1729998588562012e+00 -7.4403999328613281e+01 -2.8972500610351562e+02 5.2434000968933105e+00 -7.4474296569824219e+01 -2.8974398803710938e+02 5.3927998542785645e+00 -7.4474296569824219e+01 -2.8926599121093750e+02 5.5812997817993164e+00 -7.4474296569824219e+01 -2.8880599975585938e+02 5.3241996765136719e+00 -7.4403999328613281e+01 -2.8924200439453125e+02 5.5152001380920410e+00 -7.4403999328613281e+01 -2.8877600097656250e+02 4.9784998893737793e+00 -7.4474296569824219e+01 -2.9094601440429688e+02 4.9065999984741211e+00 -7.4403999328613281e+01 -2.9093399047851562e+02 5.0253000259399414e+00 -7.4403999328613281e+01 -2.9032598876953125e+02 5.0964999198913574e+00 -7.4474296569824219e+01 -2.9034201049804688e+02 -2.3088699340820312e+01 -7.4403999328613281e+01 -2.9807800292968750e+02 -2.2457700729370117e+01 -7.4403999328613281e+01 -2.9857699584960938e+02 -2.1503400802612305e+01 -7.4403999328613281e+01 -2.9912200927734375e+02 -2.2499099731445312e+01 -7.4474296569824219e+01 -2.9863699340820312e+02 -2.1534299850463867e+01 -7.4474296569824219e+01 -2.9918798828125000e+02 -2.3657100677490234e+01 -7.4403999328613281e+01 -2.9748999023437500e+02 -2.3137500762939453e+01 -7.4474296569824219e+01 -2.9813198852539062e+02 -2.3712800979614258e+01 -7.4474296569824219e+01 -2.9753698730468750e+02 -2.4246898651123047e+01 -7.4403999328613281e+01 -2.9665802001953125e+02 -2.4309598922729492e+01 -7.4474296569824219e+01 -2.9669500732421875e+02 -2.4631698608398438e+01 -7.4403999328613281e+01 -2.9589501953125000e+02 -2.4921199798583984e+01 -7.4403999328613281e+01 -2.9507199096679688e+02 -2.4698699951171875e+01 -7.4474296569824219e+01 -2.9592300415039062e+02 -2.4991300582885742e+01 -7.4474296569824219e+01 -2.9509197998046875e+02 -1.8573099136352539e+01 -7.4474296569824219e+01 -2.9982598876953125e+02 -2.0655399322509766e+01 -7.4403999328613281e+01 -2.9944500732421875e+02 -2.0676401138305664e+01 -7.4474296569824219e+01 -2.9951501464843750e+02 -1.9796499252319336e+01 -7.4474296569824219e+01 -2.9971798706054688e+02 -1.8573301315307617e+01 -7.4474296569824219e+01 -2.9982598876953125e+02 -1.8571899414062500e+01 -7.4403999328613281e+01 -2.9975302124023438e+02 -1.8572000503540039e+01 -7.4403999328613281e+01 -2.9975302124023438e+02 -1.9784599304199219e+01 -7.4403999328613281e+01 -2.9964599609375000e+02 -2.5210599899291992e+01 -7.4403999328613281e+01 -2.9299798583984375e+02 -2.5244699478149414e+01 -7.4474601745605469e+01 -2.9209100341796875e+02 -2.5283399581909180e+01 -7.4474296569824219e+01 -2.9299798583984375e+02 -2.5171001434326172e+01 -7.4403999328613281e+01 -2.9209799194335938e+02 -2.5171499252319336e+01 -7.4404403686523438e+01 -2.9209799194335938e+02 -2.5243600845336914e+01 -7.4474296569824219e+01 -2.9209100341796875e+02 -2.5156799316406250e+01 -7.4403999328613281e+01 -2.9388497924804688e+02 -2.5229200363159180e+01 -7.4474296569824219e+01 -2.9389398193359375e+02 -1.7984600067138672e+01 -7.4474296569824219e+01 -2.9981698608398438e+02 -1.7407798767089844e+01 -7.4403999328613281e+01 -2.9969799804687500e+02 -1.6809999465942383e+01 -7.4403999328613281e+01 -2.9961401367187500e+02 -1.7399799346923828e+01 -7.4474296569824219e+01 -2.9977099609375000e+02 -1.6797700881958008e+01 -7.4474296569824219e+01 -2.9968600463867188e+02 -1.7988100051879883e+01 -7.4403999328613281e+01 -2.9974401855468750e+02 -2.5186000823974609e+01 -7.4474899291992188e+01 -2.9150399780273438e+02 -2.5185199737548828e+01 -7.4474098205566406e+01 -2.9150399780273438e+02 -2.5112800598144531e+01 -7.4404502868652344e+01 -2.9151098632812500e+02 -2.5112598419189453e+01 -7.4403900146484375e+01 -2.9151098632812500e+02 -1.6797599792480469e+01 -7.4474296569824219e+01 -2.9968600463867188e+02 -1.6204898834228516e+01 -7.4474296569824219e+01 -2.9956100463867188e+02 -1.5626400947570801e+01 -7.4474296569824219e+01 -2.9939401245117188e+02 -1.5055999755859375e+01 -7.4474296569824219e+01 -2.9918200683593750e+02 -1.5084000587463379e+01 -7.4403999328613281e+01 -2.9911499023437500e+02 -1.5649199485778809e+01 -7.4403999328613281e+01 -2.9932498168945312e+02 -1.6222499847412109e+01 -7.4403999328613281e+01 -2.9949099731445312e+02 -2.5184900283813477e+01 -7.4474296569824219e+01 -2.9150302124023438e+02 -2.4357299804687500e+01 -7.4474296569824219e+01 -2.8831198120117188e+02 -2.4290300369262695e+01 -7.4403999328613281e+01 -2.8834097290039062e+02 -2.4723999023437500e+01 -7.4474296569824219e+01 -2.8929800415039062e+02 -2.4992500305175781e+01 -7.4474296569824219e+01 -2.9030499267578125e+02 -2.4654600143432617e+01 -7.4403999328613281e+01 -2.8932000732421875e+02 -2.4921298980712891e+01 -7.4403999328613281e+01 -2.9032000732421875e+02 -2.5112400054931641e+01 -7.4403999328613281e+01 -2.9151098632812500e+02 -1.3496899604797363e+01 -7.4474296569824219e+01 -2.9828302001953125e+02 -1.4546499252319336e+01 -7.4403999328613281e+01 -2.9886401367187500e+02 -1.4512999534606934e+01 -7.4474296569824219e+01 -2.9892901611328125e+02 -1.3997400283813477e+01 -7.4474296569824219e+01 -2.9863198852539062e+02 -1.3541000366210938e+01 -7.4403999328613281e+01 -2.9822497558593750e+02 -1.4036399841308594e+01 -7.4403999328613281e+01 -2.9857000732421875e+02 -2.2632799148559570e+01 -7.4474296569824219e+01 -2.8564001464843750e+02 -2.2579500198364258e+01 -7.4403999328613281e+01 -2.8569000244140625e+02 -2.3210800170898438e+01 -7.4403999328613281e+01 -2.8644699096679688e+02 -2.3269298553466797e+01 -7.4474296569824219e+01 -2.8640402221679688e+02 -2.3810400009155273e+01 -7.4474296569824219e+01 -2.8722302246093750e+02 -2.3747499465942383e+01 -7.4403999328613281e+01 -2.8726000976562500e+02 -1.2902599334716797e+01 -7.4403999328613281e+01 -2.9765298461914062e+02 -1.2849699974060059e+01 -7.4474296569824219e+01 -2.9770300292968750e+02 -1.2511799812316895e+01 -7.4403999328613281e+01 -2.9719097900390625e+02 -1.2453700065612793e+01 -7.4474296569824219e+01 -2.9723501586914062e+02 -2.0090499877929688e+01 -7.4474296569824219e+01 -2.8382400512695312e+02 -2.0909700393676758e+01 -7.4403999328613281e+01 -2.8433700561523438e+02 -2.0060400009155273e+01 -7.4403999328613281e+01 -2.8389099121093750e+02 -2.0947401046752930e+01 -7.4474296569824219e+01 -2.8427499389648438e+02 -2.1732900619506836e+01 -7.4474296569824219e+01 -2.8481600952148438e+02 -2.1687999725341797e+01 -7.4403999328613281e+01 -2.8487301635742188e+02 -1.2445099830627441e+01 -7.4404800415039062e+01 -2.9706298828125000e+02 -1.2518500328063965e+01 -7.4403999328613281e+01 -2.9666598510742188e+02 -1.2461500167846680e+01 -7.4474296569824219e+01 -2.9662100219726562e+02 -1.2453299522399902e+01 -7.4404701232910156e+01 -2.9677899169921875e+02 -1.2385300636291504e+01 -7.4474601745605469e+01 -2.9675299072265625e+02 -1.2424900054931641e+01 -7.4404998779296875e+01 -2.9692102050781250e+02 -1.2352099418640137e+01 -7.4474601745605469e+01 -2.9691897583007812e+02 -1.2375800132751465e+01 -7.4474601745605469e+01 -2.9708499145507812e+02 -1.6828001022338867e+01 -7.4403999328613281e+01 -2.8327398681640625e+02 -1.7950199127197266e+01 -7.4474296569824219e+01 -2.8324600219726562e+02 -1.6826700210571289e+01 -7.4474296569824219e+01 -2.8320101928710938e+02 -1.7942199707031250e+01 -7.4403999328613281e+01 -2.8331900024414062e+02 -1.9031099319458008e+01 -7.4474296569824219e+01 -2.8344601440429688e+02 -1.9012401580810547e+01 -7.4403999328613281e+01 -2.8351699829101562e+02 -1.3924200057983398e+01 -7.4403999328613281e+01 -2.9489801025390625e+02 -1.3867099761962891e+01 -7.4474296569824219e+01 -2.9485299682617188e+02 -1.4774999618530273e+01 -7.4403999328613281e+01 -2.8360400390625000e+02 -1.3975899696350098e+01 -7.4403999328613281e+01 -2.8395700073242188e+02 -1.3940400123596191e+01 -7.4474296569824219e+01 -2.8389401245117188e+02 -1.3940500259399414e+01 -7.4474296569824219e+01 -2.8389401245117188e+02 -1.4751500129699707e+01 -7.4474296569824219e+01 -2.8353500366210938e+02 -1.5604199409484863e+01 -7.4403999328613281e+01 -2.8338998413085938e+02 -1.5591099739074707e+01 -7.4474296569824219e+01 -2.8331900024414062e+02 -1.4031100273132324e+01 -7.4405097961425781e+01 -2.9480099487304688e+02 -1.4548599243164062e+01 -7.4403999328613281e+01 -2.9484799194335938e+02 -1.4597599983215332e+01 -7.4474296569824219e+01 -2.9479400634765625e+02 -1.4446700096130371e+01 -7.4404998779296875e+01 -2.9477798461914062e+02 -1.4478300094604492e+01 -7.4474601745605469e+01 -2.9471298217773438e+02 -1.4308300018310547e+01 -7.4405700683593750e+01 -2.9473800659179688e+02 -1.4164199829101562e+01 -7.4405799865722656e+01 -2.9474600219726562e+02 -1.4316499710083008e+01 -7.4474800109863281e+01 -2.9466500854492188e+02 -1.4148099899291992e+01 -7.4474899291992188e+01 -2.9467498779296875e+02 -1.3992300033569336e+01 -7.4474700927734375e+01 -2.9473999023437500e+02 -1.2609199523925781e+01 -7.4403999328613281e+01 -2.8502700805664062e+02 -1.2093000411987305e+01 -7.4403999328613281e+01 -2.8569299316406250e+02 -1.2555500030517578e+01 -7.4474296569824219e+01 -2.8497799682617188e+02 -1.2032099723815918e+01 -7.4474296569824219e+01 -2.8565298461914062e+02 -1.3209999084472656e+01 -7.4403999328613281e+01 -2.8446798706054688e+02 -1.3164699554443359e+01 -7.4474296569824219e+01 -2.8441101074218750e+02 -1.6063800811767578e+01 -7.4474296569824219e+01 -2.9578500366210938e+02 -1.5039100646972656e+01 -7.4474296569824219e+01 -2.9516101074218750e+02 -1.5508999824523926e+01 -7.4474296569824219e+01 -2.9548300170898438e+02 -1.6032400131225586e+01 -7.4403999328613281e+01 -2.9585098266601562e+02 -1.5470800399780273e+01 -7.4403999328613281e+01 -2.9554501342773438e+02 -1.4995100021362305e+01 -7.4403999328613281e+01 -2.9521899414062500e+02 -1.1065799713134766e+01 -7.4474296569824219e+01 -2.8816400146484375e+02 -1.1258600234985352e+01 -7.4474296569824219e+01 -2.8734399414062500e+02 -1.1541700363159180e+01 -7.4474296569824219e+01 -2.8656399536132812e+02 -1.1137500762939453e+01 -7.4403999328613281e+01 -2.8817700195312500e+02 -1.1328399658203125e+01 -7.4403999328613281e+01 -2.8736499023437500e+02 -1.1608500480651855e+01 -7.4403999328613281e+01 -2.8659298706054688e+02 -1.8205200195312500e+01 -7.4372703552246094e+01 -2.9629702758789062e+02 -1.8202800750732422e+01 -7.4473098754882812e+01 -2.9621099853515625e+02 -1.8204198837280273e+01 -7.4430305480957031e+01 -2.9626199340820312e+02 -1.7932201385498047e+01 -7.4403999328613281e+01 -2.9628399658203125e+02 -1.8204700469970703e+01 -7.4402503967285156e+01 -2.9627902221679688e+02 -1.7933198928833008e+01 -7.4474296569824219e+01 -2.9621197509765625e+02 -1.8202699661254883e+01 -7.4473899841308594e+01 -2.9620800781250000e+02 -1.8200599670410156e+01 -7.4498802185058594e+01 -2.9613198852539062e+02 -1.7281999588012695e+01 -7.4403999328613281e+01 -2.9623202514648438e+02 -1.6643301010131836e+01 -7.4403999328613281e+01 -2.9608898925781250e+02 -1.7292798995971680e+01 -7.4474296569824219e+01 -2.9616000366210938e+02 -1.6664400100708008e+01 -7.4474296569824219e+01 -2.9601898193359375e+02 -1.0994099617004395e+01 -7.4473098754882812e+01 -2.9110101318359375e+02 -1.0991799354553223e+01 -7.4473899841308594e+01 -2.9110198974609375e+02 -1.0944199562072754e+01 -7.4474296569824219e+01 -2.9058999633789062e+02 -1.0909399986267090e+01 -7.4499397277832031e+01 -2.9111297607421875e+02 -1.1045300483703613e+01 -7.4430305480957031e+01 -2.9109399414062500e+02 -1.1016900062561035e+01 -7.4403999328613281e+01 -2.9058502197265625e+02 -1.1061800003051758e+01 -7.4402503967285156e+01 -2.9109201049804688e+02 -1.1079500198364258e+01 -7.4372703552246094e+01 -2.9109002685546875e+02 -1.1002900123596191e+01 -7.4403999328613281e+01 -2.8937701416015625e+02 -1.0930200576782227e+01 -7.4474296569824219e+01 -2.8937301635742188e+02 -1.8208398818969727e+01 -7.4474296569824219e+01 -2.9620800781250000e+02 -1.8209899902343750e+01 -7.4403999328613281e+01 -2.9628100585937500e+02 -1.8830200195312500e+01 -7.4474296569824219e+01 -2.9614300537109375e+02 -1.9154699325561523e+01 -7.4474296569824219e+01 -2.9605902099609375e+02 -1.9467498779296875e+01 -7.4474296569824219e+01 -2.9593200683593750e+02 -1.9499500274658203e+01 -7.4403999328613281e+01 -2.9599801635742188e+02 -1.9499401092529297e+01 -7.4403999328613281e+01 -2.9599801635742188e+02 -1.9177398681640625e+01 -7.4403999328613281e+01 -2.9612799072265625e+02 -1.8844400405883789e+01 -7.4403999328613281e+01 -2.9621499633789062e+02 -1.1289400100708008e+01 -7.4403999328613281e+01 -2.9254998779296875e+02 -1.1217400550842285e+01 -7.4474296569824219e+01 -2.9256100463867188e+02 -1.9862400054931641e+01 -7.4474296569824219e+01 -2.9569699096679688e+02 -1.9905099868774414e+01 -7.4403999328613281e+01 -2.9575601196289062e+02 -2.0173198699951172e+01 -7.4403999328613281e+01 -2.9553198242187500e+02 -2.0122699737548828e+01 -7.4474296569824219e+01 -2.9548001098632812e+02 -2.0407098770141602e+01 -7.4403999328613281e+01 -2.9527200317382812e+02 -2.0349599838256836e+01 -7.4474296569824219e+01 -2.9522698974609375e+02 -1.1713200569152832e+01 -7.4403999328613281e+01 -2.9291299438476562e+02 -1.1498399734497070e+01 -7.4405097961425781e+01 -2.9285601806640625e+02 -1.1278299331665039e+01 -7.4474601745605469e+01 -2.9273501586914062e+02 -1.1341300010681152e+01 -7.4404899597167969e+01 -2.9269900512695312e+02 -1.1461899757385254e+01 -7.4474700927734375e+01 -2.9291900634765625e+02 -1.1713200569152832e+01 -7.4474296569824219e+01 -2.9298599243164062e+02 -2.0852600097656250e+01 -7.4474296569824219e+01 -2.9418399047851562e+02 -2.0617000579833984e+01 -7.4474296569824219e+01 -2.9480697631835938e+02 -2.0752099990844727e+01 -7.4474296569824219e+01 -2.9450198364257812e+02 -2.0852600097656250e+01 -7.4474296569824219e+01 -2.9418499755859375e+02 -2.0923099517822266e+01 -7.4403999328613281e+01 -2.9420300292968750e+02 -2.0923000335693359e+01 -7.4403999328613281e+01 -2.9420300292968750e+02 -2.0820299148559570e+01 -7.4403999328613281e+01 -2.9452700805664062e+02 -2.0681800842285156e+01 -7.4403999328613281e+01 -2.9484100341796875e+02 -2.0878999710083008e+01 -7.4500000000000000e+01 -2.9308200073242188e+02 -2.1040599822998047e+01 -7.4403800964355469e+01 -2.9291299438476562e+02 -2.1039199829101562e+01 -7.4406898498535156e+01 -2.9291497802734375e+02 -2.0997900009155273e+01 -7.4455703735351562e+01 -2.9295797729492188e+02 -2.0968500137329102e+01 -7.4466598510742188e+01 -2.9298898315429688e+02 -2.0968399047851562e+01 -7.4466697692871094e+01 -2.9298898315429688e+02 -2.1059499740600586e+01 -7.4360694885253906e+01 -2.9289300537109375e+02 -2.0920999526977539e+01 -7.4474296569824219e+01 -2.9386599731445312e+02 -2.1048900604248047e+01 -7.4403999328613281e+01 -2.9321798706054688e+02 -2.0976100921630859e+01 -7.4474296569824219e+01 -2.9321701049804688e+02 -2.0992799758911133e+01 -7.4403999328613281e+01 -2.9387799072265625e+02 -6.0279595851898193e-01 -7.4403999328613281e+01 -2.8671701049804688e+02 -3.8800302147865295e-01 -7.4405097961425781e+01 -2.8665997314453125e+02 -1.6800299286842346e-01 -7.4474601745605469e+01 -2.8653900146484375e+02 -1.0859899967908859e-01 -7.4474296569824219e+01 -2.8637399291992188e+02 -2.3099699616432190e-01 -7.4404899597167969e+01 -2.8650201416015625e+02 -1.8039999902248383e-01 -7.4403999328613281e+01 -2.8636102294921875e+02 -3.5159999132156372e-01 -7.4474700927734375e+01 -2.8672299194335938e+02 -6.0279595851898193e-01 -7.4474296569824219e+01 -2.8678900146484375e+02 2.1970300376415253e-01 -7.4403999328613281e+01 -2.8406900024414062e+02 2.9140001535415649e-01 -7.4474296569824219e+01 -2.8408102416992188e+02 -2.8173999786376953e+00 -7.4474296569824219e+01 -2.8678900146484375e+02 -2.8789999485015869e+00 -7.4403999328613281e+01 -2.8671701049804688e+02 -2.8965001106262207e+00 -7.4357299804687500e+01 -2.8669598388671875e+02 -2.0279701054096222e-01 -7.4403999328613281e+01 -2.8356600952148438e+02 -2.0279701054096222e-01 -7.4474296569824219e+01 -2.8349301147460938e+02 -1.2879799306392670e-01 -7.4404701232910156e+01 -2.8357199096679688e+02 -1.1629600077867508e-01 -7.4474601745605469e+01 -2.8350100708007812e+02 7.3299296200275421e-02 -7.4406105041503906e+01 -2.8366500854492188e+02 2.0100200176239014e-01 -7.4405799865722656e+01 -2.8384701538085938e+02 1.1979800462722778e-01 -7.4474899291992188e+01 -2.8360900878906250e+02 2.6920500397682190e-01 -7.4474899291992188e+01 -2.8382199096679688e+02 -4.0664000511169434e+00 -7.4499603271484375e+01 -2.9465899658203125e+02 -4.1532001495361328e+00 -7.4473098754882812e+01 -2.9464700317382812e+02 -4.1510000228881836e+00 -7.4473800659179688e+01 -2.9464700317382812e+02 -4.2385997772216797e+00 -7.4372703552246094e+01 -2.9463500976562500e+02 -4.2209000587463379e+00 -7.4402503967285156e+01 -2.9463699340820312e+02 -4.2044000625610352e+00 -7.4430305480957031e+01 -2.9464001464843750e+02 -2.3539001941680908e+00 -7.4357299804687500e+01 -2.8358700561523438e+02 -2.3290998935699463e+00 -7.4403999328613281e+01 -2.8356600952148438e+02 -2.2423000335693359e+00 -7.4474296569824219e+01 -2.8349301147460938e+02 -4.1085000038146973e+00 -7.4403999328613281e+01 -2.9576599121093750e+02 -4.2480998039245605e+00 -7.4403999328613281e+01 -2.9496099853515625e+02 -4.1751999855041504e+00 -7.4474296569824219e+01 -2.9496301269531250e+02 -4.1588001251220703e+00 -7.4474296569824219e+01 -2.9533898925781250e+02 -4.2311000823974609e+00 -7.4403999328613281e+01 -2.9534899902343750e+02 -4.0437998771667480e+00 -7.4474296569824219e+01 -2.9573199462890625e+02 -1.6579999923706055e+00 -7.4474296569824219e+01 -2.8018600463867188e+02 -1.7296999692916870e+00 -7.4403999328613281e+01 -2.8017300415039062e+02 -3.1204998493194580e+00 -7.4499603271484375e+01 -2.9601998901367188e+02 -3.1260998249053955e+00 -7.4473098754882812e+01 -2.9610800170898438e+02 -3.1260001659393311e+00 -7.4473800659179688e+01 -2.9610601806640625e+02 -3.3883001804351807e+00 -7.4474296569824219e+01 -2.9608398437500000e+02 -3.1317000389099121e+00 -7.4372703552246094e+01 -2.9619400024414062e+02 -3.1305000782012939e+00 -7.4402503967285156e+01 -2.9617599487304688e+02 -3.3984000682830811e+00 -7.4403999328613281e+01 -2.9615597534179688e+02 -3.1294999122619629e+00 -7.4430305480957031e+01 -2.9616000366210938e+02 -4.1083998680114746e+00 -7.4403999328613281e+01 -2.9576599121093750e+02 -4.0437002182006836e+00 -7.4474296569824219e+01 -2.9573199462890625e+02 -3.7549998760223389e+00 -7.4474296569824219e+01 -2.9598599243164062e+02 -3.9367001056671143e+00 -7.4474296569824219e+01 -2.9586999511718750e+02 -3.7848000526428223e+00 -7.4403999328613281e+01 -2.9605200195312500e+02 -3.9857001304626465e+00 -7.4403999328613281e+01 -2.9592401123046875e+02 -2.1520001888275146e+00 -7.4403999328613281e+01 -2.7967001342773438e+02 -2.1520001888275146e+00 -7.4474296569824219e+01 -2.7959701538085938e+02 -2.0771999359130859e+00 -7.4404701232910156e+01 -2.7967599487304688e+02 -2.0645000934600830e+00 -7.4474601745605469e+01 -2.7960397338867188e+02 -1.8752999305725098e+00 -7.4406105041503906e+01 -2.7976901245117188e+02 -1.7479000091552734e+00 -7.4405799865722656e+01 -2.7995199584960938e+02 -1.8285999298095703e+00 -7.4474899291992188e+01 -2.7971398925781250e+02 -1.6796000003814697e+00 -7.4474899291992188e+01 -2.7992697143554688e+02 -3.0573000907897949e+00 -7.4474296569824219e+01 -2.9611199951171875e+02 -3.0622999668121338e+00 -7.4403999328613281e+01 -2.9618399047851562e+02 -2.8768999576568604e+00 -7.4403999328613281e+01 -2.9619198608398438e+02 -2.6907999515533447e+00 -7.4403999328613281e+01 -2.9618798828125000e+02 -2.5049998760223389e+00 -7.4403999328613281e+01 -2.9617199707031250e+02 -2.8760998249053955e+00 -7.4474296569824219e+01 -2.9611901855468750e+02 -2.6946001052856445e+00 -7.4474296569824219e+01 -2.9611502075195312e+02 -2.5136001110076904e+00 -7.4474296569824219e+01 -2.9609899902343750e+02 -5.4706001281738281e+00 -7.4403999328613281e+01 -2.7967001342773438e+02 -5.4706001281738281e+00 -7.4474296569824219e+01 -2.7959701538085938e+02 -2.3694999217987061e+00 -7.4403999328613281e+01 -2.9615597534179688e+02 -2.3777000904083252e+00 -7.4474296569824219e+01 -2.9608398437500000e+02 -5.6854000091552734e+00 -7.4405097961425781e+01 -2.7972702026367188e+02 -5.9054999351501465e+00 -7.4474601745605469e+01 -2.7984802246093750e+02 -5.9650001525878906e+00 -7.4474296569824219e+01 -2.8001300048828125e+02 -5.8423995971679688e+00 -7.4404899597167969e+01 -2.7988400268554688e+02 -5.8931002616882324e+00 -7.4403999328613281e+01 -2.8002600097656250e+02 -5.7217998504638672e+00 -7.4474700927734375e+01 -2.7966400146484375e+02 -1.8946000337600708e+00 -7.4403999328613281e+01 -2.9662100219726562e+02 -1.9050999879837036e+00 -7.4405403137207031e+01 -2.9647698974609375e+02 -2.3324999809265137e+00 -7.4404403686523438e+01 -2.9615301513671875e+02 -2.3345000743865967e+00 -7.4474403381347656e+01 -2.9607998657226562e+02 -2.1898000240325928e+00 -7.4405601501464844e+01 -2.9617300415039062e+02 -2.0616002082824707e+00 -7.4406196594238281e+01 -2.9623898315429688e+02 -1.9628999233245850e+00 -7.4406105041503906e+01 -2.9634402465820312e+02 -2.1675000190734863e+00 -7.4474800109863281e+01 -2.9610400390625000e+02 -2.0178000926971436e+00 -7.4474998474121094e+01 -2.9618099975585938e+02 -1.9024000167846680e+00 -7.4474899291992188e+01 -2.9630398559570312e+02 -1.8344999551773071e+00 -7.4474800109863281e+01 -2.9645898437500000e+02 -1.8220000267028809e+00 -7.4474296569824219e+01 -2.9662701416015625e+02 -6.4878997802734375e+00 -7.4357299804687500e+01 -2.8358700561523438e+02 -6.5053000450134277e+00 -7.4403999328613281e+01 -2.8356600952148438e+02 -6.5666999816894531e+00 -7.4474296569824219e+01 -2.8349301147460938e+02 -2.1186001300811768e+00 -7.4403999328613281e+01 -2.9909597778320312e+02 -2.0461001396179199e+00 -7.4474296569824219e+01 -2.9910202026367188e+02 -8.3860998153686523e+00 -7.4474296569824219e+01 -2.8349301147460938e+02 -8.3860998153686523e+00 -7.4403999328613281e+01 -2.8356600952148438e+02 -2.4279000759124756e+00 -7.4403999328613281e+01 -2.9946899414062500e+02 -2.2978000640869141e+00 -7.4404594421386719e+01 -2.9940798950195312e+02 -2.0634000301361084e+00 -7.4474403381347656e+01 -2.9919601440429688e+02 -2.1333000659942627e+00 -7.4404403686523438e+01 -2.9917599487304688e+02 -2.1957001686096191e+00 -7.4404800415039062e+01 -2.9930599975585938e+02 -2.1363999843597412e+00 -7.4474601745605469e+01 -2.9934799194335938e+02 -2.2557001113891602e+00 -7.4474494934082031e+01 -2.9946701049804688e+02 -2.4077999591827393e+00 -7.4474296569824219e+01 -2.9954000854492188e+02 -8.6008996963500977e+00 -7.4405097961425781e+01 -2.8362301635742188e+02 -8.8208999633789062e+00 -7.4474601745605469e+01 -2.8374401855468750e+02 -8.8803005218505859e+00 -7.4474296569824219e+01 -2.8390899658203125e+02 -8.7579002380371094e+00 -7.4404899597167969e+01 -2.8377999877929688e+02 -8.8085002899169922e+00 -7.4403999328613281e+01 -2.8392098999023438e+02 -8.6372995376586914e+00 -7.4474700927734375e+01 -2.8355999755859375e+02 -3.3170001506805420e+00 -7.4474296569824219e+01 -2.9973001098632812e+02 -3.3171000480651855e+00 -7.4474296569824219e+01 -2.9973001098632812e+02 -3.3267998695373535e+00 -7.4403999328613281e+01 -2.9965798950195312e+02 -3.3269000053405762e+00 -7.4403999328613281e+01 -2.9965798950195312e+02 -3.0083000659942627e+00 -7.4474296569824219e+01 -2.9968099975585938e+02 -2.7030999660491943e+00 -7.4474296569824219e+01 -2.9961700439453125e+02 -3.0216000080108643e+00 -7.4403999328613281e+01 -2.9960900878906250e+02 -2.7199001312255859e+00 -7.4403999328613281e+01 -2.9954598999023438e+02 -9.2086992263793945e+00 -7.4403999328613281e+01 -2.8621398925781250e+02 -9.2804002761840820e+00 -7.4474296569824219e+01 -2.8620098876953125e+02 -3.9254999160766602e+00 -7.4474296569824219e+01 -2.9978799438476562e+02 -4.5395998954772949e+00 -7.4474296569824219e+01 -2.9979699707031250e+02 -3.9293999671936035e+00 -7.4403999328613281e+01 -2.9971502685546875e+02 -4.5385999679565430e+00 -7.4403999328613281e+01 -2.9972399902343750e+02 -8.7861995697021484e+00 -7.4403999328613281e+01 -2.8671701049804688e+02 -8.7861995697021484e+00 -7.4474296569824219e+01 -2.8678900146484375e+02 -8.8601999282836914e+00 -7.4404701232910156e+01 -2.8671099853515625e+02 -8.8726997375488281e+00 -7.4474601745605469e+01 -2.8678198242187500e+02 -9.0623006820678711e+00 -7.4406105041503906e+01 -2.8661798095703125e+02 -9.1899995803833008e+00 -7.4405799865722656e+01 -2.8643600463867188e+02 -9.1089000701904297e+00 -7.4474899291992188e+01 -2.8667300415039062e+02 -9.2582006454467773e+00 -7.4474899291992188e+01 -2.8646099853515625e+02 -6.4008998870849609e+00 -7.4474296569824219e+01 -2.9943002319335938e+02 -5.7899999618530273e+00 -7.4474296569824219e+01 -2.9964199829101562e+02 -5.1648001670837402e+00 -7.4474296569824219e+01 -2.9975701904296875e+02 -6.3710999488830566e+00 -7.4403999328613281e+01 -2.9936401367187500e+02 -5.7719001770019531e+00 -7.4403999328613281e+01 -2.9957101440429688e+02 -5.1561999320983887e+00 -7.4403999328613281e+01 -2.9968499755859375e+02 -7.0304999351501465e+00 -7.4357299804687500e+01 -2.8669598388671875e+02 -7.0548996925354004e+00 -7.4403999328613281e+01 -2.8671701049804688e+02 -7.1406002044677734e+00 -7.4474296569824219e+01 -2.8678900146484375e+02 -7.2797999382019043e+00 -7.4403999328613281e+01 -2.9877297973632812e+02 -7.6248998641967773e+00 -7.4403999328613281e+01 -2.9839700317382812e+02 -7.3290996551513672e+00 -7.4474296569824219e+01 -2.9882699584960938e+02 -7.6824998855590820e+00 -7.4474296569824219e+01 -2.9844201660156250e+02 -6.8877000808715820e+00 -7.4403999328613281e+01 -2.9908001708984375e+02 -6.9279999732971191e+00 -7.4474296569824219e+01 -2.9914099121093750e+02 -8.3975992202758789e+00 -7.4372703552246094e+01 -2.9505801391601562e+02 -8.4154005050659180e+00 -7.4402503967285156e+01 -2.9505599975585938e+02 -8.4319000244140625e+00 -7.4430198669433594e+01 -2.9505300903320312e+02 -8.5723991394042969e+00 -7.4499694824218750e+01 -2.9503598022460938e+02 -8.4854993820190430e+00 -7.4473800659179688e+01 -2.9504699707031250e+02 -8.4832000732421875e+00 -7.4473098754882812e+01 -2.9504699707031250e+02 -8.1505002975463867e+00 -7.4403999328613281e+01 -2.9744000244140625e+02 -8.3028001785278320e+00 -7.4403999328613281e+01 -2.9693099975585938e+02 -8.2187995910644531e+00 -7.4474296569824219e+01 -2.9746499633789062e+02 -8.3737993240356445e+00 -7.4474296569824219e+01 -2.9694799804687500e+02 -7.9380002021789551e+00 -7.4403999328613281e+01 -2.9791400146484375e+02 -8.0022001266479492e+00 -7.4474296569824219e+01 -2.9794799804687500e+02 -8.4907999038696289e+00 -7.4474296569824219e+01 -2.9511401367187500e+02 -8.4181995391845703e+00 -7.4403999328613281e+01 -2.9511898803710938e+02 -8.5129003524780273e+00 -7.4474296569824219e+01 -2.9572900390625000e+02 -8.4771003723144531e+00 -7.4474296569824219e+01 -2.9634298706054688e+02 -8.4400997161865234e+00 -7.4403999328613281e+01 -2.9572900390625000e+02 -8.4046001434326172e+00 -7.4403999328613281e+01 -2.9633502197265625e+02 -2.5719900131225586e+01 -7.4372703552246094e+01 -2.7659500122070312e+02 -2.5439800262451172e+01 -7.4474296569824219e+01 -2.7651797485351562e+02 -2.5718299865722656e+01 -7.4473899841308594e+01 -2.7650601196289062e+02 -2.5718299865722656e+01 -7.4473098754882812e+01 -2.7650799560546875e+02 -2.5719299316406250e+01 -7.4430305480957031e+01 -2.7655999755859375e+02 -2.5443998336791992e+01 -7.4403999328613281e+01 -2.7659100341796875e+02 -2.5719600677490234e+01 -7.4402503967285156e+01 -2.7657699584960938e+02 -2.5716899871826172e+01 -7.4498603820800781e+01 -2.7643099975585938e+02 -2.5157800674438477e+01 -7.4403999328613281e+01 -2.7661199951171875e+02 -2.4872598648071289e+01 -7.4403999328613281e+01 -2.7664199829101562e+02 -2.4588600158691406e+01 -7.4403999328613281e+01 -2.7668197631835938e+02 -2.5151298522949219e+01 -7.4474296569824219e+01 -2.7653900146484375e+02 -2.4863698959350586e+01 -7.4474296569824219e+01 -2.7657000732421875e+02 -2.4577299118041992e+01 -7.4474296569824219e+01 -2.7660998535156250e+02 -2.6419000625610352e+01 -7.4474296569824219e+01 -2.7652600097656250e+02 -2.6413900375366211e+01 -7.4403999328613281e+01 -2.7659899902343750e+02 -2.7594200134277344e+01 -7.4403999328613281e+01 -2.7677700805664062e+02 -2.7611200332641602e+01 -7.4474296569824219e+01 -2.7670602416992188e+02 -2.8173500061035156e+01 -7.4403999328613281e+01 -2.7694699096679688e+02 -2.8197401046752930e+01 -7.4474296569824219e+01 -2.7687799072265625e+02 -2.4307500839233398e+01 -7.4403999328613281e+01 -2.7672799682617188e+02 -2.3842599868774414e+01 -7.4403999328613281e+01 -2.7681298828125000e+02 -2.4295299530029297e+01 -7.4474296569824219e+01 -2.7665600585937500e+02 -2.3828800201416016e+01 -7.4474296569824219e+01 -2.7674099731445312e+02 -2.9112100601196289e+01 -7.4403999328613281e+01 -2.7736199951171875e+02 -2.9147300720214844e+01 -7.4474296569824219e+01 -2.7729800415039062e+02 -2.9625499725341797e+01 -7.4403999328613281e+01 -2.7768200683593750e+02 -2.9667299270629883e+01 -7.4474296569824219e+01 -2.7762298583984375e+02 -3.0100099563598633e+01 -7.4403999328613281e+01 -2.7805700683593750e+02 -3.0148300170898438e+01 -7.4474296569824219e+01 -2.7800198364257812e+02 -2.3784000396728516e+01 -7.4404502868652344e+01 -2.7682800292968750e+02 -2.3760299682617188e+01 -7.4474403381347656e+01 -2.7675900268554688e+02 -2.3505498886108398e+01 -7.4404899597167969e+01 -2.7713702392578125e+02 -2.3560800552368164e+01 -7.4405403137207031e+01 -2.7700399780273438e+02 -2.3657400131225586e+01 -7.4405197143554688e+01 -2.7689700317382812e+02 -2.3497798919677734e+01 -7.4403999328613281e+01 -2.7728097534179688e+02 -2.3612300872802734e+01 -7.4474700927734375e+01 -2.7683999633789062e+02 -2.3499399185180664e+01 -7.4474800109863281e+01 -2.7696499633789062e+02 -2.3434598922729492e+01 -7.4474601745605469e+01 -2.7712100219726562e+02 -2.3425300598144531e+01 -7.4474296569824219e+01 -2.7728900146484375e+02 -3.0862100601196289e+01 -7.4474296569824219e+01 -2.7876400756835938e+02 -3.0804599761962891e+01 -7.4403999328613281e+01 -2.7880902099609375e+02 -3.1150499343872070e+01 -7.4403999328613281e+01 -2.7930599975585938e+02 -3.1212299346923828e+01 -7.4474296569824219e+01 -2.7926699829101562e+02 -3.1445600509643555e+01 -7.4403999328613281e+01 -2.7983599853515625e+02 -3.1510799407958984e+01 -7.4474296569824219e+01 -2.7980398559570312e+02 -2.3700599670410156e+01 -7.4474296569824219e+01 -2.7976699829101562e+02 -2.3772998809814453e+01 -7.4403999328613281e+01 -2.7975900268554688e+02 -3.1697198867797852e+01 -7.4403999328613281e+01 -2.8041299438476562e+02 -3.1892198562622070e+01 -7.4403999328613281e+01 -2.8100698852539062e+02 -3.2128700256347656e+01 -7.4403999328613281e+01 -2.8220800781250000e+02 -3.1962301254272461e+01 -7.4474296569824219e+01 -2.8098699951171875e+02 -3.2201000213623047e+01 -7.4474296569824219e+01 -2.8219900512695312e+02 -3.1765300750732422e+01 -7.4474296569824219e+01 -2.8038702392578125e+02 -2.4279100418090820e+01 -7.4403999328613281e+01 -2.8013299560546875e+02 -2.4134901046752930e+01 -7.4405197143554688e+01 -2.8013598632812500e+02 -2.3805101394653320e+01 -7.4405097961425781e+01 -2.7988201904296875e+02 -2.3738399505615234e+01 -7.4474601745605469e+01 -2.7991101074218750e+02 -2.3883399963378906e+01 -7.4405700683593750e+01 -2.8000302124023438e+02 -2.3997699737548828e+01 -7.4405799865722656e+01 -2.8009097290039062e+02 -2.3829999923706055e+01 -7.4474899291992188e+01 -2.8005297851562500e+02 -2.3963699340820312e+01 -7.4474899291992188e+01 -2.8015499877929688e+02 -2.4124000549316406e+01 -7.4474700927734375e+01 -2.8020797729492188e+02 -2.4292598724365234e+01 -7.4474296569824219e+01 -2.8020401000976562e+02 -3.2283802032470703e+01 -7.4357299804687500e+01 -2.8357199096679688e+02 -3.2301998138427734e+01 -7.4403999328613281e+01 -2.8355200195312500e+02 -3.2366100311279297e+01 -7.4474296569824219e+01 -2.8347900390625000e+02 -2.4461099624633789e+01 -7.4474296569824219e+01 -2.8017398071289062e+02 -2.4449199676513672e+01 -7.4403999328613281e+01 -2.8010202026367188e+02 -3.4228897094726562e+01 -7.4474296569824219e+01 -2.8349099731445312e+02 -3.4228401184082031e+01 -7.4403999328613281e+01 -2.8356399536132812e+02 -2.5061899185180664e+01 -7.4498497009277344e+01 -2.8019799804687500e+02 -2.5061401367187500e+01 -7.4473098754882812e+01 -2.8012200927734375e+02 -2.5061401367187500e+01 -7.4473899841308594e+01 -2.8012402343750000e+02 -2.4970800399780273e+01 -7.4474296569824219e+01 -2.8012500000000000e+02 -2.5060800552368164e+01 -7.4372703552246094e+01 -2.8003601074218750e+02 -2.5060899734497070e+01 -7.4402503967285156e+01 -2.8005401611328125e+02 -2.4968999862670898e+01 -7.4403999328613281e+01 -2.8005297851562500e+02 -2.5061100006103516e+01 -7.4430305480957031e+01 -2.8007098388671875e+02 -2.4800199508666992e+01 -7.4474296569824219e+01 -2.8013400268554688e+02 -2.4630100250244141e+01 -7.4474296569824219e+01 -2.8014999389648438e+02 -2.4794900894165039e+01 -7.4403999328613281e+01 -2.8006100463867188e+02 -2.4621500015258789e+01 -7.4403999328613281e+01 -2.8007800292968750e+02 -3.4442802429199219e+01 -7.4405097961425781e+01 -2.8362200927734375e+02 -3.4662101745605469e+01 -7.4474601745605469e+01 -2.8374499511718750e+02 -3.4719799041748047e+01 -7.4474296569824219e+01 -2.8390698242187500e+02 -3.4598800659179688e+01 -7.4404899597167969e+01 -2.8378100585937500e+02 -3.4648101806640625e+01 -7.4403999328613281e+01 -2.8391900634765625e+02 -3.4479598999023438e+01 -7.4474601745605469e+01 -2.8355999755859375e+02 -2.6908199310302734e+01 -7.4403999328613281e+01 -2.8058901977539062e+02 -2.6074298858642578e+01 -7.4403999328613281e+01 -2.8018200683593750e+02 -2.6865699768066406e+01 -7.4474296569824219e+01 -2.8064797973632812e+02 -2.6053701400756836e+01 -7.4474296569824219e+01 -2.8025201416015625e+02 -2.5160900115966797e+01 -7.4403999328613281e+01 -2.8005099487304688e+02 -2.5160100936889648e+01 -7.4474296569824219e+01 -2.8012402343750000e+02 -3.5048500061035156e+01 -7.4403999328613281e+01 -2.8621398925781250e+02 -3.5120201110839844e+01 -7.4474296569824219e+01 -2.8620098876953125e+02 -2.7895898818969727e+01 -7.4372703552246094e+01 -2.8221301269531250e+02 -2.7878299713134766e+01 -7.4402503967285156e+01 -2.8221600341796875e+02 -2.7761899948120117e+01 -7.4403999328613281e+01 -2.8176199340820312e+02 -2.7732700347900391e+01 -7.4499000549316406e+01 -2.8224200439453125e+02 -2.7692998886108398e+01 -7.4474296569824219e+01 -2.8178598022460938e+02 -2.7861900329589844e+01 -7.4430305480957031e+01 -2.8221899414062500e+02 -2.7811000823974609e+01 -7.4473098754882812e+01 -2.8222799682617188e+02 -2.7808799743652344e+01 -7.4473899841308594e+01 -2.8222900390625000e+02 -2.7417098999023438e+01 -7.4403900146484375e+01 -2.8109197998046875e+02 -2.7358299255371094e+01 -7.4474296569824219e+01 -2.8113497924804688e+02 -3.4626098632812500e+01 -7.4403999328613281e+01 -2.8671701049804688e+02 -3.4626098632812500e+01 -7.4474296569824219e+01 -2.8678900146484375e+02 -3.4699996948242188e+01 -7.4404701232910156e+01 -2.8671099853515625e+02 -3.4712501525878906e+01 -7.4474601745605469e+01 -2.8678198242187500e+02 -3.4902099609375000e+01 -7.4406105041503906e+01 -2.8661798095703125e+02 -3.5029800415039062e+01 -7.4405799865722656e+01 -2.8643600463867188e+02 -3.4948596954345703e+01 -7.4474899291992188e+01 -2.8667300415039062e+02 -3.5098098754882812e+01 -7.4474899291992188e+01 -2.8646099853515625e+02 -2.8024200439453125e+01 -7.4474296569824219e+01 -2.8349301147460938e+02 -2.8110500335693359e+01 -7.4403999328613281e+01 -2.8356600952148438e+02 -2.8135101318359375e+01 -7.4357299804687500e+01 -2.8358700561523438e+02 -3.2826301574707031e+01 -7.4357299804687500e+01 -2.8669598388671875e+02 -3.2850997924804688e+01 -7.4403999328613281e+01 -2.8671701049804688e+02 -3.2937602996826172e+01 -7.4474296569824219e+01 -2.8678900146484375e+02 -2.5559099197387695e+01 -7.4403999328613281e+01 -2.8356600952148438e+02 -2.5559099197387695e+01 -7.4474296569824219e+01 -2.8349301147460938e+02 -3.5047599792480469e+01 -7.4474296569824219e+01 -2.9894598388671875e+02 -3.4975799560546875e+01 -7.4403999328613281e+01 -2.9895800781250000e+02 -2.5485099792480469e+01 -7.4404701232910156e+01 -2.8357199096679688e+02 -2.5472600936889648e+01 -7.4474601745605469e+01 -2.8350100708007812e+02 -2.5282999038696289e+01 -7.4406105041503906e+01 -2.8366500854492188e+02 -2.5155300140380859e+01 -7.4405799865722656e+01 -2.8384701538085938e+02 -2.5136598587036133e+01 -7.4403999328613281e+01 -2.8406900024414062e+02 -2.5236400604248047e+01 -7.4474899291992188e+01 -2.8360900878906250e+02 -2.5087099075317383e+01 -7.4474899291992188e+01 -2.8382199096679688e+02 -2.5064901351928711e+01 -7.4474296569824219e+01 -2.8408102416992188e+02 -3.4553298950195312e+01 -7.4403999328613281e+01 -2.9946099853515625e+02 -3.4553298950195312e+01 -7.4474296569824219e+01 -2.9953302001953125e+02 -3.4626800537109375e+01 -7.4404701232910156e+01 -2.9945498657226562e+02 -3.4639297485351562e+01 -7.4474601745605469e+01 -2.9952600097656250e+02 -3.4828998565673828e+01 -7.4406105041503906e+01 -2.9936199951171875e+02 -3.4956897735595703e+01 -7.4405799865722656e+01 -2.9917999267578125e+02 -3.4875602722167969e+01 -7.4474899291992188e+01 -2.9941799926757812e+02 -3.5025100708007812e+01 -7.4474899291992188e+01 -2.9920501708984375e+02 -2.5536800384521484e+01 -7.4403999328613281e+01 -2.8636102294921875e+02 -2.5465000152587891e+01 -7.4474296569824219e+01 -2.8637399291992188e+02 -3.1218299865722656e+01 -7.4403999328613281e+01 -2.9946099853515625e+02 -3.1218299865722656e+01 -7.4474296569824219e+01 -2.9953302001953125e+02 -2.5959199905395508e+01 -7.4403999328613281e+01 -2.8671701049804688e+02 -2.5744400024414062e+01 -7.4405097961425781e+01 -2.8665997314453125e+02 -2.5524400711059570e+01 -7.4474601745605469e+01 -2.8653900146484375e+02 -2.5587400436401367e+01 -7.4404899597167969e+01 -2.8650201416015625e+02 -2.5708000183105469e+01 -7.4474700927734375e+01 -2.8672299194335938e+02 -2.5959199905395508e+01 -7.4474296569824219e+01 -2.8678900146484375e+02 -3.1003499984741211e+01 -7.4405097961425781e+01 -2.9940399169921875e+02 -3.0783500671386719e+01 -7.4474601745605469e+01 -2.9928298950195312e+02 -3.0724000930786133e+01 -7.4474296569824219e+01 -2.9911801147460938e+02 -3.0846500396728516e+01 -7.4404899597167969e+01 -2.9924700927734375e+02 -3.0795799255371094e+01 -7.4403999328613281e+01 -2.9910498046875000e+02 -3.0967199325561523e+01 -7.4474700927734375e+01 -2.9946701049804688e+02 -2.8584299087524414e+01 -7.4474296569824219e+01 -2.8678900146484375e+02 -2.8645599365234375e+01 -7.4403999328613281e+01 -2.8671701049804688e+02 -2.8663101196289062e+01 -7.4357299804687500e+01 -2.8669598388671875e+02 -1.5132400512695312e+01 -7.4474296569824219e+01 -2.8992398071289062e+02 -2.0466699600219727e+01 -7.4500000000000000e+01 -2.8982800292968750e+02 -2.0577899932861328e+01 -7.4485397338867188e+01 -2.8990100097656250e+02 -2.0609001159667969e+01 -7.4471199035644531e+01 -2.8992199707031250e+02 -2.0609100341796875e+01 -7.4471199035644531e+01 -2.8992199707031250e+02 -1.5073900222778320e+01 -7.4403999328613281e+01 -2.8999700927734375e+02 -2.0642299652099609e+01 -7.4456100463867188e+01 -2.8994400024414062e+02 -2.0756200790405273e+01 -7.4346801757812500e+01 -2.9002099609375000e+02 -1.5057300567626953e+01 -7.4357299804687500e+01 -2.9001800537109375e+02 -2.0682201385498047e+01 -7.4437995910644531e+01 -2.8997100830078125e+02 -2.0718900680541992e+01 -7.4402999877929688e+01 -2.8999600219726562e+02 -2.0732999801635742e+01 -7.4389602661132812e+01 -2.9000500488281250e+02 -1.5144700050354004e+01 -7.4499504089355469e+01 -2.8958898925781250e+02 -1.5061599731445312e+01 -7.4473800659179688e+01 -2.8960498046875000e+02 -1.5059400558471680e+01 -7.4473098754882812e+01 -2.8960601806640625e+02 -1.5008700370788574e+01 -7.4430305480957031e+01 -2.8961599731445312e+02 -1.4974699974060059e+01 -7.4372703552246094e+01 -2.8962298583984375e+02 -1.4992300033569336e+01 -7.4402503967285156e+01 -2.8961898803710938e+02 -2.0440200805664062e+01 -7.4403999328613281e+01 -2.8935900878906250e+02 -2.0374300003051758e+01 -7.4474296569824219e+01 -2.8938998413085938e+02 -2.0691101074218750e+01 -7.4403999328613281e+01 -2.8992398071289062e+02 -2.0163200378417969e+01 -7.4403999328613281e+01 -2.8880599975585938e+02 -2.0098800659179688e+01 -7.4474296569824219e+01 -2.8884100341796875e+02 -1.4929100036621094e+01 -7.4403999328613281e+01 -2.8884802246093750e+02 -1.4953599929809570e+01 -7.4403999328613281e+01 -2.8851300048828125e+02 -1.5025899887084961e+01 -7.4474296569824219e+01 -2.8852200317382812e+02 -1.4972399711608887e+01 -7.4403999328613281e+01 -2.8951098632812500e+02 -1.5044500350952148e+01 -7.4474296569824219e+01 -2.8950100708007812e+02 -1.4936500549316406e+01 -7.4403999328613281e+01 -2.8918099975585938e+02 -1.5009200096130371e+01 -7.4474296569824219e+01 -2.8917599487304688e+02 -1.5001899719238281e+01 -7.4474296569824219e+01 -2.8884899902343750e+02 -1.9813600540161133e+01 -7.4403999328613281e+01 -2.8823699951171875e+02 -1.9754199981689453e+01 -7.4474296569824219e+01 -2.8827899169921875e+02 -1.9397699356079102e+01 -7.4403999328613281e+01 -2.8772799682617188e+02 -1.9344600677490234e+01 -7.4474296569824219e+01 -2.8777700805664062e+02 -1.5116199493408203e+01 -7.4403999328613281e+01 -2.8789401245117188e+02 -1.5272500038146973e+01 -7.4403999328613281e+01 -2.8760000610351562e+02 -1.5183199882507324e+01 -7.4474296569824219e+01 -2.8792300415039062e+02 -1.5333700180053711e+01 -7.4474296569824219e+01 -2.8763897705078125e+02 -1.5012999534606934e+01 -7.4403999328613281e+01 -2.8819900512695312e+02 -1.5083499908447266e+01 -7.4474296569824219e+01 -2.8821701049804688e+02 -1.9344499588012695e+01 -7.4474296569824219e+01 -2.8777700805664062e+02 -1.8950599670410156e+01 -7.4403999328613281e+01 -2.8732601928710938e+02 -1.8906700134277344e+01 -7.4474296569824219e+01 -2.8738400268554688e+02 -1.8673200607299805e+01 -7.4403999328613281e+01 -2.8713800048828125e+02 -1.8635301589965820e+01 -7.4474296569824219e+01 -2.8720001220703125e+02 -1.8378799438476562e+01 -7.4403999328613281e+01 -2.8697799682617188e+02 -1.8347200393676758e+01 -7.4474296569824219e+01 -2.8704397583007812e+02 -1.5745900154113770e+01 -7.4474296569824219e+01 -2.8720199584960938e+02 -1.6001100540161133e+01 -7.4474296569824219e+01 -2.8704199218750000e+02 -1.5702400207519531e+01 -7.4403999328613281e+01 -2.8714300537109375e+02 -1.5967300415039062e+01 -7.4403999328613281e+01 -2.8697799682617188e+02 -1.5472000122070312e+01 -7.4403999328613281e+01 -2.8734698486328125e+02 -1.5524800300598145e+01 -7.4474296569824219e+01 -2.8739700317382812e+02 -1.7048398971557617e+01 -7.4372703552246094e+01 -2.8670098876953125e+02 -1.7051198959350586e+01 -7.4473098754882812e+01 -2.8678701782226562e+02 -1.7049501419067383e+01 -7.4430305480957031e+01 -2.8673602294921875e+02 -1.7098499298095703e+01 -7.4403999328613281e+01 -2.8671600341796875e+02 -1.7048999786376953e+01 -7.4402503967285156e+01 -2.8671899414062500e+02 -1.7098899841308594e+01 -7.4474296569824219e+01 -2.8678900146484375e+02 -1.7051300048828125e+01 -7.4473899841308594e+01 -2.8678900146484375e+02 -1.7053899765014648e+01 -7.4499198913574219e+01 -2.8686999511718750e+02 -1.7578300476074219e+01 -7.4403999328613281e+01 -2.8674502563476562e+02 -1.8054300308227539e+01 -7.4403999328613281e+01 -2.8685000610351562e+02 -1.7568700790405273e+01 -7.4474296569824219e+01 -2.8681701660156250e+02 -1.8032299041748047e+01 -7.4474296569824219e+01 -2.8691900634765625e+02 -1.7004798889160156e+01 -7.4474296569824219e+01 -2.8679202270507812e+02 -1.7000499725341797e+01 -7.4403999328613281e+01 -2.8671899414062500e+02 -1.6663599014282227e+01 -7.4474296569824219e+01 -2.8682897949218750e+02 -1.6326000213623047e+01 -7.4474296569824219e+01 -2.8690902709960938e+02 -1.6651699066162109e+01 -7.4403999328613281e+01 -2.8675698852539062e+02 -1.6304298400878906e+01 -7.4403999328613281e+01 -2.8683901977539062e+02 -1.2502899932861328e+02 -4.9192996978759766e+01 -3.5157998657226562e+02 -1.2113600158691406e+02 -5.1975002288818359e+01 -3.5157998657226562e+02 -1.1663600158691406e+02 -4.9415599822998047e+01 -3.5157998657226562e+02 -1.1255899810791016e+02 -5.1531299591064453e+01 -3.5157998657226562e+02 -1.0832600402832031e+02 -4.8216598510742188e+01 -3.5157998657226562e+02 -1.0417199707031250e+02 -4.9681800842285156e+01 -3.5157998657226562e+02 -1.0033900451660156e+02 -4.5630397796630859e+01 -3.5157998657226562e+02 -9.6204200744628906e+01 -4.6477298736572266e+01 -3.5157998657226562e+02 -9.2903099060058594e+01 -4.1731498718261719e+01 -3.5157998657226562e+02 -8.8872406005859375e+01 -4.2004898071289062e+01 -3.5157998657226562e+02 -8.6233398437500000e+01 -3.6632198333740234e+01 -3.5157998657226562e+02 -8.2376701354980469e+01 -3.6386699676513672e+01 -3.5157998657226562e+02 -8.0521400451660156e+01 -3.0479000091552734e+01 -3.5157998657226562e+02 -7.6894203186035156e+01 -2.9775999069213867e+01 -3.5157998657226562e+02 -7.5931495666503906e+01 -2.3448900222778320e+01 -3.5157998657226562e+02 -7.2574699401855469e+01 -2.2353099822998047e+01 -3.5157998657226562e+02 -7.2595703125000000e+01 -1.5744199752807617e+01 -3.5157998657226562e+02 -6.9535797119140625e+01 -1.4320500373840332e+01 -3.5157998657226562e+02 -7.0609893798828125e+01 -7.5866599082946777e+00 -3.5157998657226562e+02 -6.7860496520996094e+01 -5.8972201347351074e+00 -3.5157998657226562e+02 -7.0031303405761719e+01 7.8915297985076904e-01 -3.5157998657226562e+02 -6.7594497680664062e+01 2.6868600845336914e+00 -3.5157998657226562e+02 -7.0876602172851562e+01 9.1422796249389648e+00 -3.5157998657226562e+02 -6.8745002746582031e+01 1.1197700500488281e+01 -3.5157998657226562e+02 -7.3121398925781250e+01 1.7232299804687500e+01 -3.5157998657226562e+02 -7.1280700683593750e+01 1.9403099060058594e+01 -3.5157998657226562e+02 -7.6701202392578125e+01 2.4826801300048828e+01 -3.5157998657226562e+02 -7.5132301330566406e+01 2.7079200744628906e+01 -3.5157998657226562e+02 -8.1512901306152344e+01 3.1706899642944336e+01 -3.5157998657226562e+02 -8.0194900512695312e+01 3.4016696929931641e+01 -3.5157998657226562e+02 -8.7418197631835938e+01 3.7674900054931641e+01 -3.5157998657226562e+02 -8.6330200195312500e+01 4.0026298522949219e+01 -3.5157998657226562e+02 -9.4247100830078125e+01 4.2559097290039062e+01 -3.5157998657226562e+02 -9.3371101379394531e+01 4.4944000244140625e+01 -3.5157998657226562e+02 -1.0180299377441406e+02 4.6218898773193359e+01 -3.5157998657226562e+02 -1.0112500000000000e+02 4.8635898590087891e+01 -3.5157998657226562e+02 -1.0986900329589844e+02 4.8548999786376953e+01 -3.5157998657226562e+02 -1.0938099670410156e+02 5.1001102447509766e+01 -3.5157998657226562e+02 -1.1821299743652344e+02 4.9482597351074219e+01 -3.5157998657226562e+02 -1.1791400146484375e+02 5.1975002288818359e+01 -3.5157998657226562e+02 -1.2659400939941406e+02 4.8992599487304688e+01 -3.5157998657226562e+02 -1.2649099731445312e+02 5.1531299591064453e+01 -3.5157998657226562e+02 -1.3477200317382812e+02 4.7093101501464844e+01 -3.5157998657226562e+02 -1.3487799072265625e+02 4.9681800842285156e+01 -3.5157998657226562e+02 -1.4251199340820312e+02 4.3838897705078125e+01 -3.5157998657226562e+02 -1.4284600830078125e+02 4.6477298736572266e+01 -3.5157998657226562e+02 -1.4958999633789062e+02 3.9323501586914062e+01 -3.5157998657226562e+02 -1.5017799377441406e+02 4.2004898071289062e+01 -3.5157998657226562e+02 -1.5580299377441406e+02 3.3676898956298828e+01 -3.5157998657226562e+02 -1.5667300415039062e+02 3.6386699676513672e+01 -3.5157998657226562e+02 -1.6097299194335938e+02 2.7061399459838867e+01 -3.5157998657226562e+02 -1.6215600585937500e+02 2.9775999069213867e+01 -3.5157998657226562e+02 -1.6494999694824219e+02 1.9667400360107422e+01 -3.5157998657226562e+02 -1.6647499084472656e+02 2.2353099822998047e+01 -3.5157998657226562e+02 -1.6762100219726562e+02 1.1707600593566895e+01 -3.5157998657226562e+02 -1.6951400756835938e+02 1.4320500373840332e+01 -3.5157998657226562e+02 -1.6890699768066406e+02 3.4110000133514404e+00 -3.5157998657226562e+02 -1.7118899536132812e+02 5.8972201347351074e+00 -3.5157998657226562e+02 -1.6877299499511719e+02 -4.9836597442626953e+00 -3.5157998657226562e+02 -1.7145500183105469e+02 -2.6868600845336914e+00 -3.5157998657226562e+02 -1.6722300720214844e+02 -1.3234999656677246e+01 -3.5157998657226562e+02 -1.7030499267578125e+02 -1.1197700500488281e+01 -3.5157998657226562e+02 -1.6429998779296875e+02 -2.1105600357055664e+01 -3.5157998657226562e+02 -1.6776899719238281e+02 -1.9403099060058594e+01 -3.5157998657226562e+02 -1.6008900451660156e+02 -2.8368999481201172e+01 -3.5157998657226562e+02 -1.6391799926757812e+02 -2.7079200744628906e+01 -3.5157998657226562e+02 -1.5471099853515625e+02 -3.4816299438476562e+01 -3.5157998657226562e+02 -1.5885501098632812e+02 -3.4016696929931641e+01 -3.5157998657226562e+02 -1.4832099914550781e+02 -4.0261997222900391e+01 -3.5157998657226562e+02 -1.5272000122070312e+02 -4.0026298522949219e+01 -3.5157998657226562e+02 -1.4110299682617188e+02 -4.4549499511718750e+01 -3.5157998657226562e+02 -1.4567900085449219e+02 -4.4944000244140625e+01 -3.5157998657226562e+02 -1.3326300048828125e+02 -4.7555301666259766e+01 -3.5157998657226562e+02 -1.3792500305175781e+02 -4.8635898590087891e+01 -3.5157998657226562e+02 -1.2918099975585938e+02 -4.8548999786376953e+01 -3.5157998657226562e+02 -1.2966899108886719e+02 -5.1001102447509766e+01 -3.5157998657226562e+02 -8.7418197631835938e+01 3.7674900054931641e+01 -3.9658001708984375e+02 -8.6330200195312500e+01 4.0026298522949219e+01 -3.9658001708984375e+02 -8.1512901306152344e+01 3.1706899642944336e+01 -3.9658001708984375e+02 -8.0194900512695312e+01 3.4016696929931641e+01 -3.9658001708984375e+02 -7.6701202392578125e+01 2.4826801300048828e+01 -3.9658001708984375e+02 -7.5132301330566406e+01 2.7079200744628906e+01 -3.9658001708984375e+02 -7.3121398925781250e+01 1.7232299804687500e+01 -3.9658001708984375e+02 -7.1280700683593750e+01 1.9403099060058594e+01 -3.9658001708984375e+02 -7.0876602172851562e+01 9.1422796249389648e+00 -3.9658001708984375e+02 -6.8745002746582031e+01 1.1197700500488281e+01 -3.9658001708984375e+02 -7.0031303405761719e+01 7.8915297985076904e-01 -3.9658001708984375e+02 -6.7594497680664062e+01 2.6868600845336914e+00 -3.9658001708984375e+02 -7.0609893798828125e+01 -7.5866599082946777e+00 -3.9658001708984375e+02 -6.7860496520996094e+01 -5.8972201347351074e+00 -3.9658001708984375e+02 -7.2595703125000000e+01 -1.5744199752807617e+01 -3.9658001708984375e+02 -6.9535797119140625e+01 -1.4320500373840332e+01 -3.9658001708984375e+02 -7.5931495666503906e+01 -2.3448900222778320e+01 -3.9658001708984375e+02 -7.2574699401855469e+01 -2.2353099822998047e+01 -3.9658001708984375e+02 -8.0521400451660156e+01 -3.0479000091552734e+01 -3.9658001708984375e+02 -7.6894203186035156e+01 -2.9775999069213867e+01 -3.9658001708984375e+02 -8.6233398437500000e+01 -3.6632198333740234e+01 -3.9658001708984375e+02 -8.2376701354980469e+01 -3.6386699676513672e+01 -3.9658001708984375e+02 -9.2903099060058594e+01 -4.1731498718261719e+01 -3.9658001708984375e+02 -8.8872406005859375e+01 -4.2004898071289062e+01 -3.9658001708984375e+02 -1.0033900451660156e+02 -4.5630397796630859e+01 -3.9658001708984375e+02 -9.6204200744628906e+01 -4.6477298736572266e+01 -3.9658001708984375e+02 -1.0832600402832031e+02 -4.8216598510742188e+01 -3.9658001708984375e+02 -1.0417199707031250e+02 -4.9681800842285156e+01 -3.9658001708984375e+02 -1.1663600158691406e+02 -4.9415599822998047e+01 -3.9658001708984375e+02 -1.1255899810791016e+02 -5.1531299591064453e+01 -3.9658001708984375e+02 -1.2502899932861328e+02 -4.9192996978759766e+01 -3.9658001708984375e+02 -1.2113600158691406e+02 -5.1975002288818359e+01 -3.9658001708984375e+02 -1.2918099975585938e+02 -4.8548999786376953e+01 -3.9658001708984375e+02 -1.2966899108886719e+02 -5.1001102447509766e+01 -3.9658001708984375e+02 -1.3326300048828125e+02 -4.7555301666259766e+01 -3.9658001708984375e+02 -1.3792500305175781e+02 -4.8635898590087891e+01 -3.9658001708984375e+02 -1.4110299682617188e+02 -4.4549499511718750e+01 -3.9658001708984375e+02 -1.4567900085449219e+02 -4.4944000244140625e+01 -3.9658001708984375e+02 -1.4832099914550781e+02 -4.0261997222900391e+01 -3.9658001708984375e+02 -1.5272000122070312e+02 -4.0026298522949219e+01 -3.9658001708984375e+02 -1.5471099853515625e+02 -3.4816299438476562e+01 -3.9658001708984375e+02 -1.5885501098632812e+02 -3.4016696929931641e+01 -3.9658001708984375e+02 -1.6008900451660156e+02 -2.8368999481201172e+01 -3.9658001708984375e+02 -1.6391799926757812e+02 -2.7079200744628906e+01 -3.9658001708984375e+02 -1.6429998779296875e+02 -2.1105600357055664e+01 -3.9658001708984375e+02 -1.6776899719238281e+02 -1.9403099060058594e+01 -3.9658001708984375e+02 -1.6722300720214844e+02 -1.3234999656677246e+01 -3.9658001708984375e+02 -1.7030499267578125e+02 -1.1197700500488281e+01 -3.9658001708984375e+02 -1.6877299499511719e+02 -4.9836597442626953e+00 -3.9658001708984375e+02 -1.7145500183105469e+02 -2.6868600845336914e+00 -3.9658001708984375e+02 -1.6890699768066406e+02 3.4110000133514404e+00 -3.9658001708984375e+02 -1.7118899536132812e+02 5.8972201347351074e+00 -3.9658001708984375e+02 -1.6762100219726562e+02 1.1707600593566895e+01 -3.9658001708984375e+02 -1.6951400756835938e+02 1.4320500373840332e+01 -3.9658001708984375e+02 -1.6494999694824219e+02 1.9667400360107422e+01 -3.9658001708984375e+02 -1.6647499084472656e+02 2.2353099822998047e+01 -3.9658001708984375e+02 -1.6097299194335938e+02 2.7061399459838867e+01 -3.9658001708984375e+02 -1.6215600585937500e+02 2.9775999069213867e+01 -3.9658001708984375e+02 -1.5580299377441406e+02 3.3676898956298828e+01 -3.9658001708984375e+02 -1.5667300415039062e+02 3.6386699676513672e+01 -3.9658001708984375e+02 -1.4958999633789062e+02 3.9323501586914062e+01 -3.9658001708984375e+02 -1.5017799377441406e+02 4.2004898071289062e+01 -3.9658001708984375e+02 -1.4251199340820312e+02 4.3838897705078125e+01 -3.9658001708984375e+02 -1.4284600830078125e+02 4.6477298736572266e+01 -3.9658001708984375e+02 -1.3477200317382812e+02 4.7093101501464844e+01 -3.9658001708984375e+02 -1.3487799072265625e+02 4.9681800842285156e+01 -3.9658001708984375e+02 -1.2659400939941406e+02 4.8992599487304688e+01 -3.9658001708984375e+02 -1.2649099731445312e+02 5.1531299591064453e+01 -3.9658001708984375e+02 -1.1821299743652344e+02 4.9482597351074219e+01 -3.9658001708984375e+02 -1.1791400146484375e+02 5.1975002288818359e+01 -3.9658001708984375e+02 -1.0986900329589844e+02 4.8548999786376953e+01 -3.9658001708984375e+02 -1.0938099670410156e+02 5.1001102447509766e+01 -3.9658001708984375e+02 -1.0180299377441406e+02 4.6218898773193359e+01 -3.9658001708984375e+02 -1.0112500000000000e+02 4.8635898590087891e+01 -3.9658001708984375e+02 -9.4247100830078125e+01 4.2559097290039062e+01 -3.9658001708984375e+02 -9.3371101379394531e+01 4.4944000244140625e+01 -3.9658001708984375e+02 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 38331 -> 59 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0417199879884720e+02 -4.9681801348924637e+01 -3.9658001065254211e+02) (float-vector -1.3792499899864197e+02 -4.8635900020599365e+01 -3.9658001065254211e+02) (float-vector -4.6375300735235214e+01 -7.4500001966953278e+01 -3.1722900271415710e+02) (float-vector -2.5249898899346590e+00 -7.4500001966953278e+01 -3.4095901250839233e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -3.4018900990486145e+02) (float-vector -6.8745002150535583e+01 1.1197700165212154e+01 -3.9658001065254211e+02) (float-vector -7.6894201338291168e+01 -2.9775999486446381e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3363499939441681e+02 -4.9226801842451096e+01 -2.8216099739074707e+02) (float-vector -5.2066300064325333e+01 -7.4500001966953278e+01 -2.7157199382781982e+02) (float-vector -4.6375300735235214e+01 -7.4500001966953278e+01 -3.1722900271415710e+02) (float-vector -1.3792499899864197e+02 -4.8635900020599365e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7793800234794617e+01 -2.9996600933372974e+00 -3.3335900306701660e+02) (float-vector 5.2521098405122757e+01 -2.9996600933372974e+00 -3.1308799982070923e+02) (float-vector -9.3371100723743439e+01 4.4943999499082565e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5272000432014465e+02 -4.0026299655437469e+01 -3.9658001065254211e+02) (float-vector -1.5168799459934235e+02 -4.0186099708080292e+01 -2.9640498757362366e+02) (float-vector -1.3363499939441681e+02 -4.9226801842451096e+01 -2.8216099739074707e+02) (float-vector -1.3792499899864197e+02 -4.8635900020599365e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5272000432014465e+02 -4.0026299655437469e+01 -3.9658001065254211e+02) (float-vector -1.6776899993419647e+02 -1.9403100013732910e+01 -3.9658001065254211e+02) (float-vector -1.6844500601291656e+02 -1.7630100250244141e+01 -3.1242099404335022e+02) (float-vector -1.5168799459934235e+02 -4.0186099708080292e+01 -2.9640498757362366e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5132302939891815e+01 2.7079200372099876e+01 -3.9658001065254211e+02) (float-vector 3.7793800234794617e+01 -2.9996600933372974e+00 -3.3335900306701660e+02) (float-vector -9.3371100723743439e+01 4.4943999499082565e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.5132302939891815e+01 2.7079200372099876e+01 -3.9658001065254211e+02) (float-vector -6.8745002150535583e+01 1.1197700165212154e+01 -3.9658001065254211e+02) (float-vector 3.7793800234794617e+01 -2.9996600933372974e+00 -3.3335900306701660e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5017800033092499e+02 4.2004898190498352e+01 -3.9658001065254211e+02) (float-vector -1.6647499799728394e+02 2.2353099659085274e+01 -3.9658001065254211e+02) (float-vector -1.7118899524211884e+02 5.8972202241420746e+00 -3.9658001065254211e+02) (float-vector -1.6776899993419647e+02 -1.9403100013732910e+01 -3.9658001065254211e+02) (float-vector -1.5272000432014465e+02 -4.0026299655437469e+01 -3.9658001065254211e+02) (float-vector -1.3792499899864197e+02 -4.8635900020599365e+01 -3.9658001065254211e+02) (float-vector -1.0417199879884720e+02 -4.9681801348924637e+01 -3.9658001065254211e+02) (float-vector -7.6894201338291168e+01 -2.9775999486446381e+01 -3.9658001065254211e+02) (float-vector -6.8745002150535583e+01 1.1197700165212154e+01 -3.9658001065254211e+02) (float-vector -7.5132302939891815e+01 2.7079200372099876e+01 -3.9658001065254211e+02) (float-vector -9.3371100723743439e+01 4.4943999499082565e+01 -3.9658001065254211e+02) (float-vector -1.0938099771738052e+02 5.1001101732254028e+01 -3.9658001065254211e+02) (float-vector -1.3487799465656281e+02 4.9681801348924637e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2733200192451477e+02 1.6130400821566582e+01 -2.7450001239776611e+02) (float-vector -1.1827499605715275e+01 0.0000000000000000e+00 -2.3183800280094147e+02) (float-vector -8.1911399960517883e+01 -1.9456300884485245e+01 -2.3478099703788757e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4719100296497345e+02 4.4029600918292999e+01 -3.1479299068450928e+02) (float-vector -1.5977600216865540e+02 3.2098900526762009e+01 -3.1088799238204956e+02) (float-vector -1.6647499799728394e+02 2.2353099659085274e+01 -3.9658001065254211e+02) (float-vector -1.5017800033092499e+02 4.2004898190498352e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5150999650359154e+01 -7.3682099580764771e+01 -3.4006801247596741e+02) (float-vector -1.0417199879884720e+02 -4.9681801348924637e+01 -3.9658001065254211e+02) (float-vector -2.5249898899346590e+00 -7.4500001966953278e+01 -3.4095901250839233e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5150999650359154e+01 -7.3682099580764771e+01 -3.4006801247596741e+02) (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -3.4018900990486145e+02) (float-vector -7.6894201338291168e+01 -2.9775999486446381e+01 -3.9658001065254211e+02) (float-vector -1.0417199879884720e+02 -4.9681801348924637e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3700700849294662e+01 -7.4288003146648407e+01 -3.2793200016021729e+02) (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -3.3286601305007935e+02) (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -3.4018900990486145e+02) (float-vector 1.5150999650359154e+01 -7.3682099580764771e+01 -3.4006801247596741e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7793800234794617e+01 -2.9996600933372974e+00 -3.3335900306701660e+02) (float-vector -6.8745002150535583e+01 1.1197700165212154e+01 -3.9658001065254211e+02) (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -3.4018900990486145e+02) (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -3.3286601305007935e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0795400291681290e+02 5.0696298480033875e+01 -3.1479299068450928e+02) (float-vector -1.2534700334072113e+02 5.1672998815774918e+01 -3.1479299068450928e+02) (float-vector -1.3487799465656281e+02 4.9681801348924637e+01 -3.9658001065254211e+02) (float-vector -1.0938099771738052e+02 5.1001101732254028e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7067700624465942e+02 5.8246301487088203e+00 -3.1088799238204956e+02) (float-vector -1.6647499799728394e+02 2.2353099659085274e+01 -3.9658001065254211e+02) (float-vector -1.5977600216865540e+02 3.2098900526762009e+01 -3.1088799238204956e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6844500601291656e+02 -1.7630100250244141e+01 -3.1242099404335022e+02) (float-vector -1.6776899993419647e+02 -1.9403100013732910e+01 -3.9658001065254211e+02) (float-vector -1.7118899524211884e+02 5.8972202241420746e+00 -3.9658001065254211e+02) (float-vector -1.7067700624465942e+02 5.8246301487088203e+00 -3.1088799238204956e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7067700624465942e+02 5.8246301487088203e+00 -3.1088799238204956e+02) (float-vector -1.7118899524211884e+02 5.8972202241420746e+00 -3.9658001065254211e+02) (float-vector -1.6647499799728394e+02 2.2353099659085274e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4512200653553009e+02 -3.4088201820850372e+01 -2.8252500295639038e+02) (float-vector -1.2927000224590302e+02 -4.2921099811792374e+01 -2.6847100257873535e+02) (float-vector -1.3363499939441681e+02 -4.9226801842451096e+01 -2.8216099739074707e+02) (float-vector -1.5168799459934235e+02 -4.0186099708080292e+01 -2.9640498757362366e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2927000224590302e+02 -4.2921099811792374e+01 -2.6847100257873535e+02) (float-vector -1.0513199865818024e+02 -4.7703698277473450e+01 -2.5080901384353638e+02) (float-vector -3.1779598444700241e+01 -7.4288003146648407e+01 -2.4380199611186981e+02) (float-vector -5.2066300064325333e+01 -7.4500001966953278e+01 -2.7157199382781982e+02) (float-vector -1.3363499939441681e+02 -4.9226801842451096e+01 -2.8216099739074707e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9660600721836090e+01 0.0000000000000000e+00 -2.6443600654602051e+02) (float-vector 5.6413799524307251e+01 -2.9996600933372974e+00 -2.7605199813842773e+02) (float-vector 5.5188700556755066e+01 -9.6074296161532402e+00 -2.7047699689865112e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0938099771738052e+02 5.1001101732254028e+01 -3.9658001065254211e+02) (float-vector -9.3371100723743439e+01 4.4943999499082565e+01 -3.9658001065254211e+02) (float-vector 5.2521098405122757e+01 -2.9996600933372974e+00 -3.1308799982070923e+02) (float-vector 5.7730499655008316e+01 -2.9996600933372974e+00 -2.8858000040054321e+02) (float-vector 5.6413799524307251e+01 -2.9996600933372974e+00 -2.7605199813842773e+02) (float-vector 4.9660600721836090e+01 0.0000000000000000e+00 -2.6443600654602051e+02) (float-vector -1.0795400291681290e+02 5.0696298480033875e+01 -3.1479299068450928e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.6222701668739319e+01 -2.9996600933372974e+00 -2.5316300988197327e+02) (float-vector 3.4699700772762299e+01 0.0000000000000000e+00 -2.4475599825382233e+02) (float-vector -1.0795400291681290e+02 5.0696298480033875e+01 -3.1479299068450928e+02) (float-vector 4.9660600721836090e+01 0.0000000000000000e+00 -2.6443600654602051e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7067700624465942e+02 5.8246301487088203e+00 -3.1088799238204956e+02) (float-vector -1.6666400432586670e+02 -1.4173300005495548e+01 -3.0403599143028259e+02) (float-vector -1.6844500601291656e+02 -1.7630100250244141e+01 -3.1242099404335022e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6844500601291656e+02 -1.7630100250244141e+01 -3.1242099404335022e+02) (float-vector -1.6666400432586670e+02 -1.4173300005495548e+01 -3.0403599143028259e+02) (float-vector -1.4512200653553009e+02 -3.4088201820850372e+01 -2.8252500295639038e+02) (float-vector -1.5168799459934235e+02 -4.0186099708080292e+01 -2.9640498757362366e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2534700334072113e+02 5.1672998815774918e+01 -3.1479299068450928e+02) (float-vector -1.3602800667285919e+02 4.7162700444459915e+01 -3.0725198984146118e+02) (float-vector -1.4719100296497345e+02 4.4029600918292999e+01 -3.1479299068450928e+02) (float-vector -1.5017800033092499e+02 4.2004898190498352e+01 -3.9658001065254211e+02) (float-vector -1.3487799465656281e+02 4.9681801348924637e+01 -3.9658001065254211e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3602800667285919e+02 4.7162700444459915e+01 -3.0725198984146118e+02) (float-vector -1.4485299587249756e+02 4.0309600532054901e+01 -3.0418699979782104e+02) (float-vector -1.5977600216865540e+02 3.2098900526762009e+01 -3.1088799238204956e+02) (float-vector -1.4719100296497345e+02 4.4029600918292999e+01 -3.1479299068450928e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6262899339199066e+02 2.0144900307059288e+01 -3.0418699979782104e+02) (float-vector -1.7067700624465942e+02 5.8246301487088203e+00 -3.1088799238204956e+02) (float-vector -1.5977600216865540e+02 3.2098900526762009e+01 -3.1088799238204956e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7793800234794617e+01 -2.9996600933372974e+00 -3.3335900306701660e+02) (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -3.3286601305007935e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -3.1281799077987671e+02) (float-vector 5.2521098405122757e+01 -2.9996600933372974e+00 -3.1308799982070923e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -3.1281799077987671e+02) (float-vector 5.2923198789358139e+01 -6.7129500210285187e+01 -3.0464100837707520e+02) (float-vector 5.7067301124334335e+01 -6.1999998986721039e+01 -2.8858000040054321e+02) (float-vector 5.7730499655008316e+01 -2.9996600933372974e+00 -2.8858000040054321e+02) (float-vector 5.2521098405122757e+01 -2.9996600933372974e+00 -3.1308799982070923e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.6413799524307251e+01 -2.9996600933372974e+00 -2.7605199813842773e+02) (float-vector 5.7730499655008316e+01 -2.9996600933372974e+00 -2.8858000040054321e+02) (float-vector 5.7067301124334335e+01 -6.1999998986721039e+01 -2.8858000040054321e+02) (float-vector 5.3391698747873306e+01 -6.7129500210285187e+01 -2.7441999316215515e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -2.6434201002120972e+02) (float-vector 5.5188700556755066e+01 -9.6074296161532402e+00 -2.7047699689865112e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5249898899346590e+00 -7.2767801582813263e+01 -2.3348200321197510e+02) (float-vector -3.1779598444700241e+01 -7.4288003146648407e+01 -2.4380199611186981e+02) (float-vector -1.0513199865818024e+02 -4.7703698277473450e+01 -2.5080901384353638e+02) (float-vector -9.4987101852893829e+01 -3.7282101809978485e+01 -2.3956200480461121e+02) (float-vector -6.1934001743793488e+01 -3.7273101508617401e+01 -2.2931200265884399e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5365299768745899e+01 -7.2767801582813263e+01 -2.3646700382232666e+02) (float-vector 3.0911499634385109e+01 -7.3682099580764771e+01 -2.4562099575996399e+02) (float-vector -2.5249898899346590e+00 -7.2767801582813263e+01 -2.3348200321197510e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.8251498490571976e+01 -7.4500001966953278e+01 -2.7572199702262878e+02) (float-vector 4.3601401150226593e+01 -7.2767801582813263e+01 -2.5844401121139526e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -2.6434201002120972e+02) (float-vector 5.3391698747873306e+01 -6.7129500210285187e+01 -2.7441999316215515e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.3700700849294662e+01 -7.4288003146648407e+01 -3.2793200016021729e+02) (float-vector 4.5932400971651077e+01 -7.2767801582813263e+01 -3.1480398774147034e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -3.1281799077987671e+02) (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -3.3286601305007935e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.5932400971651077e+01 -7.2767801582813263e+01 -3.1480398774147034e+02) (float-vector 4.9325298517942429e+01 -7.4288003146648407e+01 -3.0171000957489014e+02) (float-vector 5.2923198789358139e+01 -6.7129500210285187e+01 -3.0464100837707520e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -3.1281799077987671e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 4.9325298517942429e+01 -7.4288003146648407e+01 -3.0171000957489014e+02) (float-vector 5.2573200315237045e+01 -7.2767801582813263e+01 -2.8858000040054321e+02) (float-vector 5.7067301124334335e+01 -6.1999998986721039e+01 -2.8858000040054321e+02) (float-vector 5.2923198789358139e+01 -6.7129500210285187e+01 -3.0464100837707520e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2573200315237045e+01 -7.2767801582813263e+01 -2.8858000040054321e+02) (float-vector 4.8251498490571976e+01 -7.4500001966953278e+01 -2.7572199702262878e+02) (float-vector 5.3391698747873306e+01 -6.7129500210285187e+01 -2.7441999316215515e+02) (float-vector 5.7067301124334335e+01 -6.1999998986721039e+01 -2.8858000040054321e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1779598444700241e+01 -7.4288003146648407e+01 -2.4380199611186981e+02) (float-vector -2.5249898899346590e+00 -7.2767801582813263e+01 -2.3348200321197510e+02) (float-vector 3.0911499634385109e+01 -7.3682099580764771e+01 -2.4562099575996399e+02) (float-vector 4.3601401150226593e+01 -7.2767801582813263e+01 -2.5844401121139526e+02) (float-vector 4.8251498490571976e+01 -7.4500001966953278e+01 -2.7572199702262878e+02) (float-vector 5.2573200315237045e+01 -7.2767801582813263e+01 -2.8858000040054321e+02) (float-vector 4.9325298517942429e+01 -7.4288003146648407e+01 -3.0171000957489014e+02) (float-vector 4.5932400971651077e+01 -7.2767801582813263e+01 -3.1480398774147034e+02) (float-vector 3.3700700849294662e+01 -7.4288003146648407e+01 -3.2793200016021729e+02) (float-vector 1.5150999650359154e+01 -7.3682099580764771e+01 -3.4006801247596741e+02) (float-vector -2.5249898899346590e+00 -7.4500001966953278e+01 -3.4095901250839233e+02) (float-vector -4.6375300735235214e+01 -7.4500001966953278e+01 -3.1722900271415710e+02) (float-vector -5.2066300064325333e+01 -7.4500001966953278e+01 -2.7157199382781982e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.1911399960517883e+01 -1.9456300884485245e+01 -2.3478099703788757e+02) (float-vector -6.6226698458194733e+01 -2.5276100262999535e+01 -2.2971400618553162e+02) (float-vector -6.1934001743793488e+01 -3.7273101508617401e+01 -2.2931200265884399e+02) (float-vector -9.4987101852893829e+01 -3.7282101809978485e+01 -2.3956200480461121e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1827499605715275e+01 0.0000000000000000e+00 -2.3183800280094147e+02) (float-vector 3.7734000943601131e+00 -2.9996600933372974e+00 -2.2865499556064606e+02) (float-vector -6.6226698458194733e+01 -2.5276100262999535e+01 -2.2971400618553162e+02) (float-vector -8.1911399960517883e+01 -1.9456300884485245e+01 -2.3478099703788757e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1952500045299530e+02 4.9966700375080109e+01 -3.0725198984146118e+02) (float-vector -1.3602800667285919e+02 4.7162700444459915e+01 -3.0725198984146118e+02) (float-vector -1.2534700334072113e+02 5.1672998815774918e+01 -3.1479299068450928e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1952500045299530e+02 4.9966700375080109e+01 -3.0725198984146118e+02) (float-vector -1.1827499605715275e+01 0.0000000000000000e+00 -2.3183800280094147e+02) (float-vector -1.2733200192451477e+02 1.6130400821566582e+01 -2.7450001239776611e+02) (float-vector -1.4485299587249756e+02 4.0309600532054901e+01 -3.0418699979782104e+02) (float-vector -1.3602800667285919e+02 4.7162700444459915e+01 -3.0725198984146118e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1827499605715275e+01 0.0000000000000000e+00 -2.3183800280094147e+02) (float-vector -1.1952500045299530e+02 4.9966700375080109e+01 -3.0725198984146118e+02) (float-vector 1.2857900001108646e+01 0.0000000000000000e+00 -2.3317599296569824e+02) (float-vector 3.7734000943601131e+00 -2.9996600933372974e+00 -2.2865499556064606e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7602799236774445e+01 -2.9996600933372974e+00 -2.3639699816703796e+02) (float-vector 1.2857900001108646e+01 0.0000000000000000e+00 -2.3317599296569824e+02) (float-vector -1.1952500045299530e+02 4.9966700375080109e+01 -3.0725198984146118e+02) (float-vector -1.2534700334072113e+02 5.1672998815774918e+01 -3.1479299068450928e+02) (float-vector -1.0795400291681290e+02 5.0696298480033875e+01 -3.1479299068450928e+02) (float-vector 3.4699700772762299e+01 0.0000000000000000e+00 -2.4475599825382233e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3565100729465485e+02 7.7449698001146317e+00 -2.7446898818016052e+02) (float-vector -1.6262899339199066e+02 2.0144900307059288e+01 -3.0418699979782104e+02) (float-vector -1.5977600216865540e+02 3.2098900526762009e+01 -3.1088799238204956e+02) (float-vector -1.4485299587249756e+02 4.0309600532054901e+01 -3.0418699979782104e+02) (float-vector -1.2733200192451477e+02 1.6130400821566582e+01 -2.7450001239776611e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3565100729465485e+02 7.7449698001146317e+00 -2.7446898818016052e+02) (float-vector -1.6666400432586670e+02 -1.4173300005495548e+01 -3.0403599143028259e+02) (float-vector -1.7067700624465942e+02 5.8246301487088203e+00 -3.1088799238204956e+02) (float-vector -1.6262899339199066e+02 2.0144900307059288e+01 -3.0418699979782104e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.4987101852893829e+01 -3.7282101809978485e+01 -2.3956200480461121e+02) (float-vector -1.1123199760913849e+02 -2.5273099541664124e+01 -2.4948699772357941e+02) (float-vector -1.3565100729465485e+02 7.7449698001146317e+00 -2.7446898818016052e+02) (float-vector -1.2733200192451477e+02 1.6130400821566582e+01 -2.7450001239776611e+02) (float-vector -8.1911399960517883e+01 -1.9456300884485245e+01 -2.3478099703788757e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0773900151252747e+02 -3.7275999784469604e+01 -2.4715499579906464e+02) (float-vector -1.1123199760913849e+02 -2.5273099541664124e+01 -2.4948699772357941e+02) (float-vector -9.4987101852893829e+01 -3.7282101809978485e+01 -2.3956200480461121e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3565100729465485e+02 7.7449698001146317e+00 -2.7446898818016052e+02) (float-vector -1.1123199760913849e+02 -2.5273099541664124e+01 -2.4948699772357941e+02) (float-vector -1.0773900151252747e+02 -3.7275999784469604e+01 -2.4715499579906464e+02) (float-vector -1.2927000224590302e+02 -4.2921099811792374e+01 -2.6847100257873535e+02) (float-vector -1.4512200653553009e+02 -3.4088201820850372e+01 -2.8252500295639038e+02) (float-vector -1.6666400432586670e+02 -1.4173300005495548e+01 -3.0403599143028259e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0773900151252747e+02 -3.7275999784469604e+01 -2.4715499579906464e+02) (float-vector -9.4987101852893829e+01 -3.7282101809978485e+01 -2.3956200480461121e+02) (float-vector -1.0513199865818024e+02 -4.7703698277473450e+01 -2.5080901384353638e+02) (float-vector -1.2927000224590302e+02 -4.2921099811792374e+01 -2.6847100257873535e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 1.5890000388026237e+01 -6.1999998986721039e+01 -2.3190400004386902e+02) (float-vector 1.5365299768745899e+01 -7.2767801582813263e+01 -2.3646700382232666e+02) (float-vector -2.5249898899346590e+00 -7.2767801582813263e+01 -2.3348200321197510e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.6226698458194733e+01 -2.5276100262999535e+01 -2.2971400618553162e+02) (float-vector 3.7734000943601131e+00 -2.9996600933372974e+00 -2.2865499556064606e+02) (float-vector 1.5890000388026237e+01 -6.1999998986721039e+01 -2.3190400004386902e+02) (float-vector -2.5249898899346590e+00 -7.2767801582813263e+01 -2.3348200321197510e+02) (float-vector -6.1934001743793488e+01 -3.7273101508617401e+01 -2.2931200265884399e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -2.3697200417518616e+02) (float-vector 1.5890000388026237e+01 -6.1999998986721039e+01 -2.3190400004386902e+02) (float-vector 3.7734000943601131e+00 -2.9996600933372974e+00 -2.2865499556064606e+02) (float-vector 1.2857900001108646e+01 0.0000000000000000e+00 -2.3317599296569824e+02) (float-vector 2.7602799236774445e+01 -2.9996600933372974e+00 -2.3639699816703796e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -2.4429400265216827e+02) (float-vector 4.6222701668739319e+01 -2.9996600933372974e+00 -2.5316300988197327e+02) (float-vector 4.9660600721836090e+01 0.0000000000000000e+00 -2.6443600654602051e+02) (float-vector 5.5188700556755066e+01 -9.6074296161532402e+00 -2.7047699689865112e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -2.6434201002120972e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -2.4429400265216827e+02) (float-vector 3.0911499634385109e+01 -7.3682099580764771e+01 -2.4562099575996399e+02) (float-vector 1.5365299768745899e+01 -7.2767801582813263e+01 -2.3646700382232666e+02) (float-vector 1.5890000388026237e+01 -6.1999998986721039e+01 -2.3190400004386902e+02) (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -2.3697200417518616e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0911499634385109e+01 -7.3682099580764771e+01 -2.4562099575996399e+02) (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -2.4429400265216827e+02) (float-vector 5.1915299147367477e+01 -6.1999998986721039e+01 -2.6434201002120972e+02) (float-vector 4.3601401150226593e+01 -7.2767801582813263e+01 -2.5844401121139526e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.7349998950958252e+01 -6.1999998986721039e+01 -2.4429400265216827e+02) (float-vector 2.7271099388599396e+01 -6.1999998986721039e+01 -2.3697200417518616e+02) (float-vector 2.7602799236774445e+01 -2.9996600933372974e+00 -2.3639699816703796e+02) (float-vector 3.4699700772762299e+01 0.0000000000000000e+00 -2.4475599825382233e+02) (float-vector 4.6222701668739319e+01 -2.9996600933372974e+00 -2.5316300988197327e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_shoulder_pan_link_wAdJg7.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_shoulder_lift_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.1700000000000000e+02 0.0000000000000000e+00 5.9999999999999901e+01))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 2 79 0 1 0 397 0 79 397 2 1 5 5 1 76 76 1 432 432 1 397 432 397 431 431 397 433 397 79 437 397 437 433 2 78 79 437 79 78 438 437 439 437 78 439 433 437 438 431 433 430 430 433 434 433 438 434 440 438 441 438 439 441 434 438 440 439 78 77 439 77 446 441 439 446 77 78 2 2 85 77 446 77 85 446 85 447 441 446 451 451 446 447 440 441 443 443 441 451 451 447 452 443 451 456 456 451 452 447 85 84 447 84 448 452 447 448 2 84 85 82 83 84 82 84 2 84 83 448 448 83 81 448 81 449 452 448 453 453 448 449 81 83 82 80 81 82 449 81 80 449 80 450 453 449 454 454 449 450 457 452 453 457 453 458 458 453 454 454 450 455 458 454 459 459 454 455 450 80 90 450 90 455 82 90 80 82 89 90 455 90 592 592 90 89 459 455 460 592 460 455 463 458 459 463 459 464 464 459 460 464 460 465 592 465 460 469 463 464 469 464 470 470 464 465 462 458 463 468 462 463 468 463 469 334 468 469 334 469 335 335 469 470 470 465 471 335 470 336 336 470 471 592 471 465 336 471 337 474 337 471 474 471 592 333 335 336 333 336 337 334 335 333 333 332 334 332 468 334 331 332 333 331 467 332 332 467 468 333 343 331 343 466 331 331 466 467 466 461 467 467 461 462 467 462 468 444 445 466 466 445 461 343 444 466 445 456 461 461 456 457 461 457 462 462 457 458 456 452 457 445 443 456 444 442 445 442 443 445 436 442 444 436 444 343 442 440 443 435 440 442 435 442 436 434 440 435 429 434 435 429 435 428 428 435 436 430 434 429 428 423 429 429 423 424 429 424 430 340 339 428 428 339 423 428 436 340 339 352 423 423 352 418 423 418 424 424 418 419 424 419 425 430 424 425 430 425 431 425 419 420 425 420 426 431 425 426 418 398 419 419 398 414 419 414 420 352 351 418 418 351 398 351 350 398 350 349 398 398 349 410 398 410 414 414 410 411 414 411 415 420 414 415 349 348 410 410 348 405 410 405 411 344 348 349 349 350 344 344 350 351 344 345 346 346 347 344 344 347 348 344 351 338 338 355 344 344 355 364 344 364 345 348 347 405 347 346 400 405 347 400 346 391 392 400 346 392 391 346 345 400 392 401 405 400 406 406 400 401 401 392 385 401 385 402 406 401 407 407 401 402 411 405 406 411 406 412 412 406 407 407 402 408 412 407 413 413 407 408 415 411 412 415 412 416 416 412 413 413 408 399 416 413 417 417 413 399 408 402 403 408 403 409 399 408 409 4 3 399 399 409 4 417 399 75 75 399 3 422 416 417 422 417 74 74 417 75 5 74 75 5 75 3 3 4 5 5 4 61 69 61 4 4 409 69 68 61 69 409 404 69 69 404 68 67 62 68 68 62 61 404 368 68 68 368 67 403 373 404 404 373 368 409 403 404 402 382 403 403 382 373 402 385 382 385 386 387 387 388 385 385 388 389 385 389 382 392 395 385 385 395 396 385 396 386 507 388 387 507 387 523 523 387 386 389 388 507 382 389 390 506 390 389 506 389 507 519 506 507 519 507 520 520 507 523 523 386 524 520 523 521 521 523 524 219 519 520 219 520 220 220 520 521 220 521 221 221 521 522 521 524 522 524 386 396 524 396 525 522 524 525 221 522 222 522 525 529 222 522 223 223 522 529 220 221 215 215 221 222 215 219 220 213 214 215 215 214 216 215 216 217 217 218 215 215 218 219 215 222 201 330 206 215 215 206 212 215 212 213 201 1021 215 215 1021 1019 215 1019 330 218 519 219 218 518 519 518 506 519 217 517 518 217 518 218 517 505 518 518 505 506 505 390 506 504 380 505 505 380 390 517 504 505 216 516 517 216 517 217 516 504 517 503 383 504 383 381 504 504 381 380 516 503 504 380 381 382 382 390 380 382 381 383 382 383 373 373 383 384 503 384 383 502 384 503 515 502 503 515 503 516 373 384 377 502 377 384 500 377 502 514 500 502 514 502 515 213 514 515 213 515 214 214 515 516 212 513 514 212 514 213 513 500 514 206 211 212 211 513 212 211 512 513 512 501 513 513 501 500 206 210 211 210 512 211 210 511 512 511 499 512 512 499 501 371 500 501 371 501 499 498 372 499 499 372 371 511 498 499 209 510 511 209 511 210 510 498 511 209 210 206 206 208 209 208 510 209 208 509 510 509 496 510 510 496 498 496 374 498 498 374 372 371 372 373 372 374 373 373 374 375 496 375 374 376 496 370 370 496 497 376 375 496 509 497 496 373 375 368 368 375 376 377 378 373 373 378 379 373 379 371 500 378 377 379 378 500 379 500 371 368 376 370 367 67 368 367 368 369 369 368 370 70 67 367 369 493 367 367 493 492 367 492 70 70 71 67 67 71 72 67 72 62 549 71 70 549 70 492 491 492 493 492 491 546 492 546 549 548 71 549 549 546 547 549 547 548 548 72 71 548 62 72 61 62 63 555 63 62 555 62 548 548 547 550 548 550 555 554 63 555 555 550 551 555 551 554 63 64 61 554 64 63 553 64 554 554 551 552 554 552 553 550 234 551 551 234 233 551 233 552 547 224 550 550 224 234 226 233 234 226 234 224 231 232 233 231 233 226 233 232 552 230 232 231 552 232 230 552 230 556 553 552 556 229 230 231 556 230 229 556 229 557 553 556 558 558 556 557 231 242 229 557 229 242 242 562 557 558 557 559 559 557 562 553 558 56 56 558 559 56 559 57 57 559 560 559 562 560 242 561 562 560 562 561 231 241 242 241 561 242 236 241 231 226 174 231 231 174 160 231 160 236 236 240 241 241 240 561 235 240 236 561 240 235 235 236 237 561 235 566 566 235 237 237 236 238 237 238 239 566 237 567 567 237 239 563 561 566 563 566 564 564 566 567 567 239 568 564 567 565 565 567 568 238 245 239 239 245 568 568 245 244 568 244 572 565 568 569 569 568 572 238 244 245 189 243 244 189 244 238 572 244 243 572 243 573 569 572 570 570 572 573 54 565 569 54 569 55 55 569 570 55 570 44 44 570 571 570 573 571 573 243 188 573 188 574 571 573 574 188 243 189 187 188 189 188 187 574 574 187 249 574 249 579 571 574 575 575 574 579 189 249 187 189 247 249 579 249 247 579 247 580 575 579 576 576 579 580 47 571 575 47 575 48 48 575 576 48 576 38 38 576 577 576 580 577 580 247 246 580 246 581 577 580 581 38 577 39 39 577 578 577 581 578 38 39 40 40 48 38 40 47 48 39 41 40 40 41 42 40 42 8 46 47 40 8 1027 40 40 1027 1025 40 1025 46 39 578 41 41 578 42 8 42 43 42 578 583 42 583 43 8 43 6 43 583 584 43 584 6 578 582 583 583 582 585 583 585 584 584 585 587 584 587 589 6 584 7 7 584 589 6 7 8 36 8 7 36 7 34 34 7 37 7 589 37 589 587 586 589 586 590 37 589 590 34 37 32 37 590 32 590 586 588 590 588 591 32 590 591 32 33 34 32 591 33 941 33 591 957 941 591 957 591 588 586 272 588 271 957 588 271 588 272 956 941 957 270 956 957 270 957 271 940 797 941 941 797 33 956 940 941 955 940 956 269 955 956 269 956 270 267 269 270 267 270 271 271 272 267 267 272 273 586 273 272 267 273 252 252 273 274 274 273 586 274 586 250 250 586 587 252 274 250 250 251 252 585 251 250 250 587 585 252 251 253 582 253 251 582 251 585 252 253 248 248 253 254 254 253 582 581 254 582 578 581 582 248 254 246 581 246 254 246 247 248 248 247 189 238 157 189 189 157 163 189 163 248 236 158 238 238 158 157 157 158 159 159 163 157 159 162 163 248 163 162 248 162 252 252 162 178 252 178 267 162 177 178 178 177 179 267 178 179 177 186 179 267 179 289 289 179 186 177 173 186 289 186 291 291 186 173 257 267 289 257 289 290 290 289 291 290 291 292 292 291 293 291 173 293 292 979 290 290 979 977 290 977 257 292 293 294 294 981 292 292 981 979 294 293 295 293 173 185 293 185 295 294 295 296 296 983 294 294 983 981 980 979 981 980 981 982 982 981 983 982 983 984 984 983 985 296 985 983 296 295 297 296 297 298 298 985 296 984 985 986 986 985 987 298 987 985 1094 982 984 1094 984 1095 1095 984 986 986 987 988 1095 986 1097 1097 986 988 988 987 989 300 989 987 300 987 298 988 989 990 1097 988 1085 1085 988 990 1085 1093 1097 1097 1093 1095 1093 1094 1095 1093 982 1094 1085 1096 1093 1096 980 1093 1093 980 982 1084 1096 1085 1084 978 1096 1096 978 980 978 979 980 976 977 978 978 977 979 1084 976 978 1083 1084 1085 1083 976 1084 974 975 976 976 975 977 1083 974 976 257 977 975 974 973 975 257 975 277 277 975 973 972 973 974 1092 972 974 1092 974 1083 1085 1092 1083 1085 1079 1092 1079 972 1092 970 971 972 972 971 973 1079 970 972 277 973 280 280 973 971 970 969 971 280 971 283 283 971 969 968 969 970 1106 968 970 1106 970 1079 968 967 969 283 969 196 196 969 967 966 967 968 1105 966 968 1105 968 1106 1079 1105 1106 1079 1104 1105 1104 966 1105 964 965 966 966 965 967 1104 964 966 196 967 194 194 967 965 964 963 965 194 965 192 192 965 963 962 963 964 1103 962 964 1103 964 1104 1103 1104 1079 1079 1102 1103 1102 962 1103 1020 1021 962 962 1021 963 1102 1020 962 192 963 201 201 963 1021 1020 1019 1021 1018 1019 1020 1101 1018 1020 1101 1020 1102 1079 1101 1102 1100 1101 1079 1100 1018 1101 1016 1017 1018 1018 1017 1019 1100 1016 1018 330 1019 1017 1016 1015 1017 330 1017 328 328 1017 1015 1014 1015 1016 1099 1014 1016 1099 1016 1100 1079 1099 1100 1079 1098 1099 1098 1014 1099 1012 1013 1014 1014 1013 1015 1098 1012 1014 328 1015 326 326 1015 1013 1012 1011 1013 326 1013 324 324 1013 1011 1010 1011 1012 1082 1010 1012 1082 1012 1098 1082 1098 1079 1079 1081 1082 1081 1010 1082 1008 1009 1010 1010 1009 1011 1081 1008 1010 324 1011 322 322 1011 1009 1008 1007 1009 322 1009 320 320 1009 1007 1006 1007 1008 1080 1006 1008 1080 1008 1081 1079 1080 1081 1078 1080 1079 1078 1006 1080 1004 1005 1006 1006 1005 1007 1078 1004 1006 320 1007 318 318 1007 1005 1004 1003 1005 318 1005 316 316 1005 1003 1002 1003 1004 1077 1002 1004 1077 1004 1078 1077 1078 1079 1079 1091 1077 1091 1002 1077 1000 1001 1002 1002 1001 1003 1091 1000 1002 316 1003 314 314 1003 1001 1000 999 1001 314 1001 312 312 1001 999 998 999 1000 1090 998 1000 1090 1000 1091 1079 1090 1091 1089 1090 1079 1089 998 1090 996 997 998 998 997 999 1089 996 998 312 999 310 310 999 997 996 995 997 310 997 308 308 997 995 994 995 996 1088 996 1089 1088 994 996 1079 1088 1089 1079 1087 1088 1087 994 1088 992 993 994 994 993 995 1087 992 994 308 995 306 306 995 993 992 991 993 306 993 304 304 993 991 990 991 992 1086 990 992 1086 992 1087 1086 1087 1079 1086 1079 1085 1085 990 1086 990 989 991 304 991 302 302 991 989 302 989 300 300 301 302 302 301 303 302 303 304 298 299 300 300 299 301 299 172 301 301 172 171 301 171 303 304 303 305 303 171 177 303 177 305 171 172 173 171 173 177 172 183 173 299 183 172 298 297 299 297 183 299 173 183 184 297 184 183 173 184 185 295 185 184 295 184 297 162 176 177 305 177 176 161 162 159 161 176 162 305 176 307 307 176 161 307 161 309 309 161 159 306 305 307 306 307 308 308 307 309 308 309 310 310 309 311 309 159 311 310 311 312 312 311 313 311 175 313 311 159 175 312 313 314 314 313 315 313 175 170 313 170 315 159 168 175 175 168 170 168 169 170 315 170 169 314 315 316 316 315 317 315 169 317 168 166 169 317 169 166 316 317 318 318 317 319 317 166 319 318 319 320 320 319 321 319 166 182 319 182 321 320 321 322 322 321 323 321 182 181 321 181 323 166 181 182 166 180 181 323 181 180 322 323 324 324 323 325 323 180 325 167 180 166 325 180 167 324 325 326 326 325 327 325 167 327 166 165 167 327 167 165 164 165 166 164 166 168 327 165 329 329 165 164 326 327 328 328 327 329 328 329 330 330 329 206 329 164 206 206 164 168 159 174 168 206 168 226 226 168 174 159 158 160 160 174 159 236 160 158 224 225 226 226 225 227 226 227 206 547 225 224 227 225 547 206 227 228 546 228 227 546 227 547 206 228 204 491 204 228 491 228 546 204 205 206 205 207 206 206 207 208 204 491 494 204 494 205 491 493 494 205 494 508 494 493 495 494 495 508 205 508 207 207 508 509 207 509 208 508 495 497 508 497 509 370 495 369 369 495 493 370 497 495 304 305 306 199 200 201 201 200 202 201 202 192 201 222 223 201 223 199 199 530 200 200 530 531 200 531 202 192 202 203 202 531 532 202 532 203 530 527 531 531 527 528 531 528 532 529 526 530 530 526 527 199 529 530 526 393 527 527 393 391 527 391 528 535 532 528 535 528 481 481 528 391 392 391 393 391 345 481 393 394 392 526 394 393 392 394 395 395 394 526 525 396 395 525 395 526 529 525 526 223 529 199 481 345 365 481 365 482 482 535 481 364 360 365 365 360 362 345 364 365 482 365 362 355 358 364 364 358 360 358 359 360 360 359 361 360 361 362 362 361 363 482 362 483 483 362 363 485 363 361 485 361 486 486 361 487 487 361 359 483 363 484 484 363 485 484 485 539 539 485 719 719 485 720 720 485 486 720 486 721 721 486 487 487 359 488 721 487 722 722 487 488 806 720 721 806 721 807 722 807 721 719 720 806 539 719 766 766 719 806 807 808 806 806 808 813 806 813 766 723 713 807 723 807 722 713 805 807 807 805 808 722 488 723 488 489 723 723 489 490 723 490 706 706 713 723 706 712 713 734 805 713 734 713 712 738 804 805 738 805 734 805 804 808 733 734 712 733 738 734 706 711 712 711 733 712 747 736 733 733 736 738 749 747 733 749 733 711 736 737 738 737 804 738 743 744 736 737 736 745 745 736 744 747 743 736 745 803 737 737 803 804 745 744 746 746 802 745 745 802 803 809 804 803 809 803 802 746 771 802 802 771 809 746 744 643 746 643 641 641 771 746 642 641 643 642 643 644 644 643 645 744 645 643 640 641 642 772 771 641 772 641 640 644 703 642 642 703 704 642 704 640 772 640 832 832 640 704 770 771 772 832 836 772 772 836 837 772 837 770 770 825 771 852 825 770 852 770 837 837 836 842 837 842 852 832 835 836 836 835 841 836 841 842 842 841 872 842 872 883 852 842 883 851 825 852 852 883 851 771 825 826 851 826 825 850 826 851 851 883 884 851 884 850 883 872 873 883 873 884 884 873 874 884 874 885 850 884 885 849 827 850 850 827 826 850 885 849 826 827 771 771 827 828 849 828 827 848 828 849 849 885 886 849 886 848 885 874 875 885 875 886 886 875 876 886 876 887 848 886 887 847 823 848 848 823 828 848 887 847 771 828 823 823 824 771 847 824 823 846 824 847 847 887 888 847 888 846 887 876 877 887 877 888 888 877 878 888 878 889 846 888 889 876 866 877 877 866 867 877 867 878 878 867 868 878 868 879 889 878 879 889 879 890 846 889 894 894 889 890 879 868 869 879 869 880 890 879 880 867 857 868 868 857 858 868 858 869 869 858 859 869 859 870 880 869 870 880 870 881 890 880 891 891 880 881 870 859 860 870 860 871 881 870 871 858 28 859 859 28 27 859 27 860 903 871 860 903 860 26 26 860 27 881 871 882 902 882 871 902 871 903 908 902 903 908 903 25 25 903 26 25 26 23 23 26 27 23 27 28 23 24 25 28 29 23 23 29 30 23 30 17 24 23 35 35 23 8 17 1031 23 23 1031 1029 23 1029 8 24 908 25 24 35 838 838 908 24 35 8 36 36 838 35 8 1029 1027 1028 1027 1029 1028 1029 1030 1030 1029 1031 1026 1025 1027 1026 1027 1028 1030 144 1028 1028 144 143 1028 143 1026 1030 1031 1032 1032 133 1030 1030 133 144 131 143 144 131 144 133 142 143 131 1026 143 142 1024 1025 1026 1026 142 1024 1024 1023 1025 46 1025 1023 1022 1023 1024 1024 142 141 1024 141 1022 131 141 142 131 140 141 1022 141 140 1074 1075 1022 1022 1075 1076 1022 1076 1023 1022 140 1074 46 1023 53 53 1023 1076 53 1076 51 51 1076 1075 1074 1073 1075 51 1075 58 58 1075 1073 1072 1071 1073 1072 1073 1074 58 1073 61 61 1073 1071 1070 1071 1072 1074 139 1072 1072 139 138 1072 138 1070 1070 1069 1071 61 1071 5 5 1071 1069 61 64 65 61 65 58 553 65 64 58 65 66 553 66 65 56 66 553 58 66 56 56 57 58 58 57 59 58 59 51 57 560 59 51 59 60 59 560 60 49 50 51 51 50 52 51 52 53 51 60 49 60 560 563 60 563 49 560 561 563 49 563 564 49 564 50 50 564 565 50 565 52 53 52 54 52 565 54 53 54 46 46 54 55 44 45 46 46 45 47 46 55 44 44 571 45 45 571 47 1068 1067 1069 1068 1069 1070 5 1069 2 2 1069 1067 1070 138 154 1070 154 1068 138 153 154 1068 154 153 138 152 153 1068 153 1066 1066 153 152 151 152 138 1066 152 1064 1064 152 151 1064 1065 1066 1066 1065 1067 1066 1067 1068 1062 1063 1064 1064 1063 1065 1064 151 1062 138 150 151 1062 151 150 1060 1061 1062 1062 1061 1063 1062 150 1060 88 1065 1063 88 1063 86 86 1063 1061 1060 1059 1061 86 1061 91 91 1061 1059 1058 1059 1060 1060 150 149 1060 149 1058 138 149 150 137 149 138 1058 149 137 1056 1057 1058 1058 1057 1059 1058 137 1056 91 1059 94 94 1059 1057 1056 1055 1057 94 1057 97 97 1057 1055 1054 1055 1056 1056 137 131 1056 131 1054 137 138 131 131 138 139 139 140 131 1074 140 139 130 131 132 133 134 131 131 134 135 131 135 136 136 145 131 131 145 146 131 146 132 1054 131 130 1032 134 133 1034 135 134 1034 134 1032 1036 136 135 1036 135 1034 1038 145 136 1038 136 1036 1040 146 145 1040 145 1038 1042 132 146 1042 146 1040 1038 1039 1040 1040 1039 1041 1040 1041 1042 1036 1037 1038 1038 1037 1039 1034 1035 1036 1036 1035 1037 124 1039 1037 124 1037 15 15 1037 1035 121 1041 1039 121 1039 124 1042 1041 1043 118 1043 1041 118 1041 121 121 122 118 124 125 121 121 125 126 121 126 122 118 119 115 118 122 123 118 123 119 115 1043 118 670 123 122 670 122 671 671 122 126 671 126 672 672 126 125 698 670 671 698 671 699 699 671 672 669 123 670 697 669 670 697 670 698 669 119 123 668 119 669 696 668 669 696 669 697 632 696 697 632 697 634 634 697 698 634 698 636 636 698 699 633 632 634 633 634 635 635 634 636 631 630 632 631 632 633 630 696 632 695 668 696 630 695 696 629 628 630 629 630 631 628 695 630 631 633 732 629 631 731 731 631 732 633 635 732 732 635 743 732 743 747 731 732 748 748 732 747 627 629 731 730 627 731 730 731 750 750 731 748 627 628 629 625 626 627 627 626 628 625 627 730 623 625 730 729 623 730 729 730 752 752 730 750 750 748 751 752 750 753 753 750 751 754 729 752 754 752 755 755 752 753 753 751 709 755 753 708 708 753 709 751 748 749 751 749 710 709 751 710 706 708 709 706 709 710 705 708 706 705 755 708 757 754 755 757 755 705 705 706 707 707 757 705 707 706 490 710 711 706 710 749 711 748 747 749 489 357 490 490 357 475 475 714 490 490 714 715 490 715 716 716 717 490 490 717 718 490 718 707 488 359 489 489 359 357 358 357 359 356 357 358 355 354 358 358 354 366 358 366 356 476 357 356 476 356 477 477 356 366 477 366 478 478 366 354 353 354 355 478 354 479 479 354 353 338 353 355 333 353 338 479 353 480 480 353 333 480 724 479 479 724 742 479 742 478 478 742 477 742 476 477 741 740 742 741 742 724 740 735 742 742 735 476 739 740 741 724 725 741 741 725 760 741 760 739 739 716 740 716 715 740 740 715 735 714 476 735 714 735 715 475 357 476 475 476 714 717 716 739 739 761 717 717 761 718 760 758 761 761 758 759 761 759 718 739 760 761 718 759 707 758 756 759 759 756 757 759 757 707 726 727 758 758 727 756 760 726 758 727 728 756 756 728 754 756 754 757 609 611 727 611 613 727 727 613 728 726 609 727 607 608 609 609 608 610 609 610 611 607 609 726 611 610 612 611 612 613 608 684 610 610 684 685 610 685 612 607 606 608 606 683 608 608 683 684 605 606 607 605 607 726 605 604 606 604 682 606 606 682 683 682 655 683 683 655 656 683 656 684 681 654 682 682 654 655 604 681 682 603 602 604 603 604 605 602 681 604 680 653 681 681 653 654 602 680 681 653 99 654 654 99 98 654 98 655 652 95 653 653 95 99 680 652 653 679 652 680 600 679 680 600 680 602 651 96 652 652 96 95 679 651 652 94 95 91 91 95 96 94 99 95 94 98 99 97 98 94 100 101 97 97 101 102 97 102 98 97 1055 100 100 105 101 656 102 101 656 101 657 657 101 105 655 98 102 655 102 656 684 656 657 657 105 658 684 657 685 685 657 658 100 104 105 658 105 104 658 104 659 685 658 686 686 658 659 612 685 686 686 659 687 612 686 614 614 686 687 659 104 108 659 108 660 687 659 660 103 104 100 103 108 104 103 107 108 660 108 107 660 107 661 687 660 688 688 660 661 106 107 103 106 111 107 661 107 111 661 111 662 688 661 689 689 661 662 615 687 688 615 688 617 617 688 689 689 662 690 617 689 619 619 689 690 616 615 617 616 617 618 618 617 619 618 619 620 619 621 620 619 690 621 690 662 663 690 663 691 621 690 691 620 621 622 621 691 622 620 622 623 618 620 729 620 623 729 616 618 728 728 618 729 728 729 754 613 616 728 612 614 613 613 614 615 613 615 616 614 687 615 623 622 624 623 624 625 625 624 626 622 692 624 624 692 693 624 693 626 626 693 694 626 694 628 692 665 693 693 665 666 693 666 694 691 664 692 692 664 665 622 691 692 664 113 665 665 113 117 665 117 666 666 117 116 666 116 667 694 666 667 112 116 117 112 117 113 112 113 109 109 113 114 664 114 113 663 114 664 691 663 664 109 114 110 663 110 114 109 110 106 106 1049 109 109 1049 1047 109 1047 112 106 110 111 662 111 110 662 110 663 103 1051 106 106 1051 1049 1048 1047 1049 1048 1049 1050 1050 1049 1051 1050 1051 1052 1052 1051 1053 103 1053 1051 100 1053 103 1052 1053 1054 1054 1053 1055 100 1055 1053 1054 130 1052 1052 130 156 1052 156 1050 1050 155 1048 1050 156 155 132 155 156 132 156 130 148 155 132 1048 155 148 132 147 148 1044 147 132 1044 132 1042 1048 148 1046 1046 148 147 1046 147 1044 1042 1043 1044 1044 1043 1045 1044 1045 1046 1046 1045 1047 1046 1047 1048 112 1047 1045 112 1045 115 115 1045 1043 115 116 112 115 119 120 115 120 116 667 116 120 667 120 668 668 120 119 694 667 695 695 667 668 628 694 695 91 96 92 651 92 96 91 92 86 86 92 93 650 93 92 650 92 651 678 650 651 678 651 679 648 93 650 649 648 650 649 650 678 86 93 87 648 87 93 86 87 88 88 87 89 593 89 87 593 87 648 595 593 648 595 648 649 592 89 593 595 592 593 88 89 82 82 1065 88 2 1067 82 82 1067 1065 594 474 592 594 592 595 649 594 595 472 474 594 594 649 472 472 473 474 474 473 333 474 333 337 473 472 596 472 649 596 596 649 678 473 596 597 597 596 598 596 678 598 480 333 473 473 597 480 338 342 333 333 342 343 338 341 342 343 342 436 436 342 341 340 341 338 436 341 340 338 339 340 338 351 352 338 352 339 480 597 724 597 599 724 599 601 724 724 601 725 597 598 599 599 598 600 599 600 601 601 600 602 601 602 603 601 603 725 603 605 725 725 605 726 725 726 760 598 679 600 598 678 679 635 637 743 743 637 639 743 639 744 635 636 637 637 636 638 637 638 639 646 645 639 646 639 647 647 639 638 744 639 645 636 699 638 638 699 700 638 700 647 647 700 701 647 701 646 644 645 646 646 701 702 646 702 644 700 673 701 701 673 674 701 674 702 699 672 700 700 672 673 672 125 673 673 125 129 673 129 674 674 129 128 674 128 675 702 674 675 702 675 703 644 702 703 128 127 675 675 127 676 675 676 677 703 675 677 15 127 128 15 128 124 124 128 129 124 129 125 11 14 15 14 127 15 15 1035 11 676 127 14 832 677 676 676 14 832 703 677 704 832 704 677 832 14 833 832 833 834 834 835 832 11 13 14 14 13 833 833 13 12 834 833 839 833 12 839 835 834 840 834 839 840 835 840 841 840 839 843 840 843 861 841 840 861 839 12 10 839 10 843 11 10 12 12 13 11 9 10 11 843 10 9 843 9 844 861 843 844 861 844 862 841 861 872 872 861 862 844 9 22 844 22 845 862 844 845 11 22 9 11 21 22 22 21 845 845 21 20 845 20 853 862 845 863 863 845 853 872 862 873 873 862 863 863 853 864 873 863 874 874 863 864 853 20 16 853 16 854 864 853 854 16 20 17 17 20 21 17 21 11 11 1035 1033 11 1033 17 1034 1033 1035 1032 1031 1033 1032 1033 1034 17 1033 1031 16 17 18 18 17 19 17 30 31 17 31 19 854 16 18 854 18 855 855 18 19 855 19 856 856 19 31 856 31 857 31 30 857 857 30 29 857 29 858 867 856 857 866 855 856 866 856 867 865 854 855 865 855 866 864 854 865 875 864 865 875 865 876 876 865 866 874 864 875 858 29 28 73 74 5 5 76 73 427 422 73 73 422 74 76 427 73 432 427 76 426 421 427 427 421 422 432 426 427 421 416 422 420 415 421 421 415 416 426 420 421 431 426 432 912 907 838 838 907 908 917 912 838 917 838 36 907 902 908 906 901 907 907 901 902 912 906 907 901 882 902 900 893 901 901 893 882 906 900 901 905 900 906 911 905 906 911 906 912 899 898 900 900 898 893 905 899 900 892 882 893 897 892 893 897 893 898 892 881 882 891 881 892 896 891 892 896 892 897 898 819 897 897 819 818 897 818 896 895 891 896 896 818 817 896 817 895 895 890 891 894 890 895 895 817 831 895 831 894 817 818 810 810 831 817 810 818 819 819 820 810 898 820 819 810 820 821 821 820 898 899 821 898 810 821 812 812 821 822 822 821 899 904 822 899 904 899 905 812 822 814 814 822 904 909 814 904 909 904 910 910 904 905 910 905 911 914 909 910 914 910 915 915 910 911 815 814 909 913 815 909 913 909 914 814 815 812 815 816 812 816 815 913 777 816 913 777 913 779 779 913 914 779 914 783 783 914 915 778 777 779 778 779 780 783 785 779 779 785 786 779 786 780 776 777 778 776 778 925 925 778 780 925 780 927 927 780 786 927 786 928 786 785 928 783 784 785 928 785 784 928 784 929 943 927 928 943 928 944 944 928 929 942 925 927 942 927 943 279 942 943 279 943 255 255 943 944 944 929 945 255 944 256 256 944 945 255 256 257 257 279 255 257 278 279 278 942 279 924 925 942 278 924 942 277 276 278 277 278 257 276 924 278 275 923 924 275 924 276 923 926 924 924 926 925 776 925 773 773 925 926 773 926 922 923 922 926 282 921 923 282 923 275 921 922 923 275 276 277 277 282 275 277 281 282 281 921 282 281 918 921 918 920 921 921 920 922 773 922 774 774 922 920 773 774 763 773 763 776 776 763 777 763 816 777 812 816 763 762 763 764 763 774 775 763 775 764 812 763 762 774 920 775 775 920 919 775 919 764 918 919 920 918 958 919 919 958 961 919 961 764 285 284 958 284 288 958 958 288 959 958 959 961 918 285 958 961 959 960 961 960 767 764 961 767 288 287 959 287 286 959 959 286 544 959 544 960 283 287 288 283 288 284 196 286 287 196 287 283 198 286 196 286 198 544 544 198 542 544 542 545 960 544 545 196 197 198 198 197 542 194 195 196 196 195 197 197 195 537 542 197 537 542 537 543 545 542 543 545 543 540 960 545 765 765 545 540 543 537 538 543 538 541 540 543 541 537 195 533 537 533 538 538 533 536 538 536 483 541 538 483 484 540 541 484 541 483 483 536 482 533 534 536 536 534 535 536 535 482 191 190 534 534 190 532 534 532 535 533 191 534 190 191 192 192 191 193 193 191 533 192 203 190 190 203 532 192 193 194 194 193 195 195 193 533 539 540 484 540 539 765 765 539 766 765 766 767 767 960 765 767 766 768 766 813 768 767 768 764 764 768 769 813 811 768 768 811 769 808 809 813 813 809 811 809 810 811 811 810 812 811 812 769 764 769 762 769 812 762 809 771 810 771 830 810 810 830 831 808 804 809 894 831 830 771 829 830 894 830 846 846 830 829 824 829 771 846 829 824 283 284 280 280 284 285 280 281 277 280 285 281 281 285 918 257 256 258 257 258 259 259 260 257 257 260 261 257 261 262 262 263 257 257 263 264 257 264 265 265 267 257 256 945 258 945 929 930 945 930 946 258 945 946 929 784 782 929 782 930 930 782 781 930 781 931 946 930 931 946 931 947 258 946 259 259 946 947 931 781 792 931 792 932 947 931 932 781 782 783 783 792 781 782 784 783 789 791 783 783 791 792 783 915 789 792 791 932 789 790 791 932 791 790 932 790 933 947 932 948 948 932 933 788 790 789 933 790 788 933 788 934 948 933 949 949 933 934 260 947 948 260 948 261 261 948 949 949 934 950 261 949 262 262 949 950 950 934 935 950 935 951 262 950 263 263 950 951 934 787 935 935 787 795 935 795 936 951 935 936 951 936 952 263 951 264 264 951 952 795 794 936 936 794 793 936 793 937 952 936 937 789 794 795 789 795 787 793 794 789 789 801 793 937 793 801 801 939 937 952 937 953 953 937 939 789 800 801 800 938 801 801 938 939 953 939 954 954 939 938 265 952 953 265 953 266 266 953 954 954 938 955 266 954 268 268 954 955 265 266 267 267 266 268 264 952 265 268 269 267 268 955 269 955 938 940 938 798 940 940 798 797 796 797 798 798 799 796 938 799 798 796 33 797 34 33 796 796 917 34 34 917 36 916 912 917 796 916 917 915 911 916 916 911 912 789 915 916 789 916 796 787 788 789 796 800 789 934 788 787 796 799 800 800 799 938 259 947 260 214 516 216 1107 1108 1109 1107 1122 1108 1132 1131 1107 1107 1131 1122 1132 1107 1133 1133 1107 1109 1108 1122 1123 1122 1131 1130 1122 1130 1123 1130 1131 1108 1108 1131 1132 1108 1132 1110 1110 1132 1133 1110 1133 1129 1133 1109 1129 1109 1108 1110 1109 1110 1111 1111 1110 1112 1129 1112 1110 1129 1109 1111 1129 1111 1112 1108 1123 1124 1130 1108 1134 1134 1108 1124 1123 1130 1134 1134 1124 1135 1123 1134 1125 1125 1134 1135 1124 1123 1125 1124 1125 1126 1135 1124 1126 1135 1126 1136 1125 1135 1127 1127 1135 1136 1126 1125 1127 1126 1127 1119 1119 1137 1126 1126 1137 1138 1126 1138 1136 1138 1142 1136 1127 1136 1128 1128 1136 1142 1119 1127 1128 1119 1128 1120 1141 1120 1128 1128 1142 1141 1140 1141 1142 1138 1140 1142 1137 1140 1138 1137 1139 1140 1137 1119 1139 1139 1118 1140 1139 1119 1118 1117 1118 1115 1115 1118 1119 1140 1118 1117 1115 1116 1117 1140 1117 1116 1121 1141 1140 1121 1140 1113 1113 1140 1116 1120 1141 1121 1113 1120 1121 1113 1119 1120 1113 1114 1115 1115 1119 1113 1113 1116 1114 1115 1114 1116 1143 1144 1145 1145 1148 1143 1144 1143 1173 1173 1143 1174 1174 1143 1148 1144 1173 1145 1146 1147 1145 1145 1147 1148 1145 1173 1174 1145 1174 1146 1174 1148 1175 1175 1148 1147 1146 1174 1175 1146 1175 1172 1175 1147 1172 1146 1153 1147 1172 1147 1153 1169 1146 1172 1172 1153 1169 1151 1152 1146 1146 1152 1153 1169 1151 1146 1169 1153 1152 1169 1170 1149 1149 1151 1169 1150 1170 1169 1169 1152 1150 1149 1150 1151 1151 1150 1152 1149 1160 1150 1160 1170 1150 1149 1170 1171 1160 1171 1170 1149 1159 1160 1166 1171 1160 1166 1160 1178 1178 1160 1159 1149 1171 1166 1166 1167 1149 1167 1166 1177 1177 1166 1178 1177 1178 1179 1178 1159 1179 1158 1159 1149 1179 1159 1158 1179 1165 1177 1179 1158 1165 1149 1165 1158 1149 1164 1165 1177 1165 1164 1163 1164 1149 1177 1164 1163 1149 1162 1163 1163 1162 1177 1149 1161 1162 1177 1162 1161 1157 1161 1149 1156 1177 1161 1156 1161 1157 1149 1156 1157 1149 1155 1156 1156 1155 1176 1176 1177 1156 1154 1155 1149 1155 1154 1176 1168 1167 1176 1176 1167 1177 1176 1154 1168 1149 1168 1154 1149 1167 1168 1180 1181 1182 1182 1185 1180 1180 1294 1181 1180 2071 1294 1185 2070 1180 1180 2070 2071 1182 1184 1185 1184 2069 1185 1185 2069 2070 2069 1905 2070 2070 1905 1904 2070 1904 2071 2071 1904 1902 2071 1902 2072 1294 2071 2072 1903 1902 1904 1903 1904 1894 1894 1904 1905 1894 1905 1895 2069 1895 1905 1894 1895 1896 1894 2151 1903 1896 2150 1894 1894 2150 2151 1901 1902 1903 1903 2151 2152 1903 2152 1901 2150 2148 2151 2151 2148 2149 2151 2149 2152 2225 2147 2150 2150 2147 2148 1896 2225 2150 2147 1456 2148 2148 1456 1409 2148 1409 2149 2149 1409 2074 2152 2149 2074 2152 2074 2153 1901 2152 2153 1409 1313 2074 1313 1659 2074 2074 1659 1654 2074 1654 2075 2153 2074 2075 2153 2075 2154 1901 2153 1893 1893 2153 2154 2075 1654 1648 2075 1648 2076 2154 2075 2076 2154 2076 2155 1893 2154 1891 1891 2154 2155 2076 1648 1667 2076 1667 2077 2155 2076 2077 2155 2077 2156 1891 2155 1888 1888 2155 2156 1888 1890 1891 1891 1890 1892 1891 1892 1893 1886 1887 1888 1887 1889 1888 1888 1889 1890 1888 2156 1886 1996 1890 1997 1997 1890 1889 1996 1892 1890 1892 1899 1893 1996 1899 1892 2073 1899 1996 1296 2073 1996 1296 1996 1292 1292 1996 1997 1997 1889 1998 1292 1997 1293 1293 1997 1998 1889 1887 1998 1998 1887 1885 1998 1885 1999 1293 1998 1289 1289 1998 1999 1288 1292 1293 1288 1293 1289 1291 1292 1288 1291 1296 1292 1288 1289 1285 1291 1288 1216 1216 1288 1285 1285 1289 1290 1289 1999 1290 1285 1286 1282 1285 1290 1286 1216 1285 1282 1290 1999 2000 1290 2000 1286 1282 1286 1287 1286 2000 2001 1286 2001 1287 1282 1283 1279 1282 1287 1283 1282 1279 1216 1287 2001 2002 1287 2002 1283 2000 1880 2001 2001 1880 1879 2001 1879 2002 1879 1877 2002 2002 1877 1875 2002 1875 2003 1283 2002 2003 1279 1283 1284 1283 2003 1284 2003 1875 1874 2003 1874 2004 1284 2003 2004 1873 1874 1875 1873 1875 1876 1876 1875 1877 1876 1877 1878 1877 1879 1878 1878 1879 1880 1878 1880 1881 1881 2159 1878 1878 2159 2160 1878 2160 1876 1876 2160 2161 1876 2161 1873 2159 2081 2160 2160 2081 2082 2160 2082 2161 2158 2080 2159 2159 2080 2081 1881 2158 2159 2080 1663 2081 2081 1663 1650 2081 1650 2082 2082 1650 1649 2082 1649 2083 2161 2082 2083 1649 1650 1646 1650 1663 1646 1646 1663 1664 2080 1664 1663 2079 1664 2080 2158 2079 2080 1646 1664 1665 2079 1665 1664 2078 1665 2079 2157 2078 2079 2157 2079 2158 1665 1666 1646 2078 1666 1665 2077 1666 2078 2156 2077 2078 2156 2078 2157 1886 2156 2157 1886 2157 1883 1883 2157 2158 1883 1885 1886 1886 1885 1887 1881 1882 1883 1882 1884 1883 1883 1884 1885 1883 2158 1881 1999 1885 1884 1999 1884 2000 1884 1882 2000 1881 1880 1882 2000 1882 1880 2077 1667 1666 1646 1666 1667 1646 1667 1648 1645 1646 1647 1647 1646 1648 1628 1615 1646 1646 1615 1688 1646 1688 1649 1646 1645 5856 1628 1646 5844 5844 1646 5856 1628 1629 1615 5844 1629 1628 5843 5834 5844 5844 5834 1629 5844 5856 5843 5856 1645 5852 5856 5852 5851 5843 5856 5851 2285 5833 5843 5843 5833 5834 4661 2285 5843 5843 5851 4661 5834 5833 5835 1629 5834 5836 5834 5835 5836 5833 2287 4627 5833 4627 5835 2285 2287 5833 5835 4627 4630 5835 4630 5837 5836 5835 5837 5836 5837 5839 1629 5836 1630 1630 5836 5839 4630 4633 5837 5837 4633 4639 5837 4639 5838 5839 5837 5838 5839 5838 5840 1630 5839 1614 1614 5839 5840 1615 1629 1630 1615 1630 1614 1612 1613 1614 1614 1613 1615 1614 5840 1612 5840 5838 5824 5840 5824 5823 1612 5840 5823 1601 1588 1612 1612 1588 1613 1612 5823 1601 2085 1615 1613 2085 1613 2086 2086 1613 1588 1588 1589 1590 1601 1589 1588 2086 1588 2087 2087 1588 1590 2164 2085 2086 2164 2086 2165 2165 2086 2087 2087 1590 2088 2165 2087 2166 2166 2087 2088 1590 1589 1591 2088 1590 1591 2088 1591 2089 2166 2088 2167 2167 2088 2089 1863 2165 2166 1863 2166 1861 1861 2166 2167 1866 2164 2165 1866 2165 1863 1861 1862 1863 1862 1864 1863 1863 1864 1865 1863 1865 1866 1858 1860 1861 1861 1860 1862 1861 2167 1858 1864 1862 2008 2008 1862 1860 2007 1865 1864 2007 1864 2008 1866 1865 1867 2006 1867 1865 2006 1865 2007 1277 2006 2007 1277 2007 1278 1278 2007 2008 2008 1860 2009 1278 2008 1274 1274 2008 2009 1273 1277 1278 1273 1278 1274 1276 1277 1273 1276 1281 1277 1281 2006 1277 1279 1280 1276 1276 1280 1281 1216 1279 1276 1216 1276 1273 1280 2005 1281 1281 2005 2006 1279 1284 1280 1284 2004 1280 1280 2004 2005 2004 1870 2005 2005 1870 1869 2005 1869 2006 1874 1872 2004 2004 1872 1870 1868 1869 1870 1868 1870 1871 1871 1870 1872 1867 1869 1868 1869 1867 2006 1866 1867 1868 1871 2163 1868 1868 2163 2164 1868 2164 1866 1871 1872 1873 1873 2162 1871 1871 2162 2163 1872 1874 1873 1873 2161 2162 2161 2083 2162 2162 2083 2084 2162 2084 2163 2163 2084 2085 2163 2085 2164 2083 1688 2084 2084 1688 1615 2084 1615 2085 2083 1649 1688 1273 1274 1270 1219 1216 1273 1237 1234 1273 1273 1234 1231 1273 1231 1228 1237 1273 1240 1240 1273 1270 1228 1225 1273 1273 1225 1222 1273 1222 1219 1228 1229 1225 1231 1232 1228 1228 1232 1233 1228 1233 1229 1225 1226 1222 1225 1229 1230 1225 1230 1226 1222 1223 1219 1222 1226 1227 1222 1227 1223 1230 2040 1226 1226 2040 2041 1226 2041 1227 1229 2039 1230 1230 2039 2040 2039 1975 2040 2040 1975 1974 2040 1974 2041 1974 1972 2041 2041 1972 1970 2041 1970 2042 1227 2041 2042 1227 2042 1223 2042 1970 1969 2042 1969 2043 1223 2042 2043 1968 1969 1970 1968 1970 1971 1971 1970 1972 1971 1972 1973 1972 1974 1973 1973 1974 1975 1973 1975 1976 1976 2197 1973 1973 2197 2198 1973 2198 1971 1971 2198 2199 1971 2199 1968 2197 2119 2198 2198 2119 2120 2198 2120 2199 2196 2118 2197 2197 2118 2119 1976 2196 2197 2118 1791 2119 2119 1791 1790 2119 1790 2120 2120 1790 1788 2120 1788 2121 2199 2120 2121 1789 1788 1790 1789 1790 1791 1791 1800 1789 2118 1800 1791 2117 1800 2118 2196 2117 2118 1789 1800 1801 2117 1801 1800 2116 1801 2117 2195 2116 2117 2195 2117 2196 1789 1801 1797 1797 1801 1802 2116 1802 1801 2115 1802 2116 2194 2115 2116 2194 2116 2195 1981 2194 2195 1981 2195 1978 1978 2195 2196 2193 2115 2194 1983 2193 2194 1983 2194 1981 1978 1980 1981 1981 1980 1982 1981 1982 1983 1982 1984 1983 1983 1984 1985 1983 1985 1986 1986 2193 1983 1984 1982 2037 2037 1982 1980 1978 1979 1980 2037 1980 2038 2038 1980 1979 2036 1984 2037 1232 2036 2037 1232 2037 1233 1233 2037 2038 2036 1985 1984 2035 1985 2036 1236 2035 2036 1236 2036 1232 1231 1236 1232 1231 1235 1236 1235 2035 1236 2034 1989 2035 1989 1987 2035 2035 1987 1985 1235 2034 2035 1234 1235 1231 1234 1239 1235 1239 2034 1235 2033 1990 2034 2034 1990 1989 1239 2033 2034 1987 1989 1988 1988 1989 1990 1986 1985 1987 1986 1987 1988 1988 1990 1991 1991 2191 1988 1988 2191 2192 1988 2192 1986 1991 1990 1992 2033 1992 1990 1991 1992 1993 1993 2190 1991 1991 2190 2191 2190 2112 2191 2191 2112 2113 2191 2113 2192 2192 2113 2114 2192 2114 2193 1986 2192 2193 2112 1793 2113 2113 1793 1799 2113 1799 2114 2111 1792 2112 2112 1792 1793 2190 2111 2112 1792 1783 1793 1793 1783 1794 1794 1799 1793 1794 1798 1799 2114 1799 1798 1797 1798 1794 4946 1797 1794 1794 1783 4946 1797 1802 1798 2114 1798 2115 2115 1798 1802 1797 4936 4938 1797 4938 1789 4946 4936 1797 4945 4936 4946 4946 1783 4962 4946 4962 4945 4936 4935 4937 4936 4937 4938 4945 4935 4936 4938 4937 4939 4938 4939 4942 1789 4938 4942 1781 1788 1789 1789 4942 1781 4942 4939 4940 4942 4940 4943 1781 4942 4943 1780 1781 1782 1780 1787 1781 1781 1787 1788 1781 4943 1782 2121 1788 1787 2121 1787 2122 2122 1787 1780 1782 1805 1780 2122 1780 2123 2123 1780 1805 2200 2121 2122 2200 2122 2201 2201 2122 2123 2199 2121 2200 1968 2199 2200 1968 2200 1966 1966 2200 2201 2201 2123 2202 1966 2201 1963 1963 2201 2202 2123 1805 2124 2202 2123 2124 2202 2124 2203 1963 2202 1961 1961 2202 2203 1961 1962 1963 1962 1964 1963 1963 1964 1965 1963 1965 1966 1958 1960 1961 1961 1960 1962 1961 2203 1958 1964 1962 2045 2045 1962 1960 2044 1965 1964 2044 1964 2045 1966 1965 1967 2043 1967 1965 2043 1965 2044 1224 2043 2044 1224 2044 1220 1220 2044 2045 1969 1967 2043 1223 2043 1224 1966 1967 1968 1967 1969 1968 1219 1223 1224 1219 1224 1220 1219 1220 1216 1216 1220 1221 1220 2045 1221 1216 1221 1217 1221 2045 2046 1221 2046 1217 2045 1960 2046 2046 1960 1959 2046 1959 2047 1217 2046 2047 1216 1217 1213 1213 1217 1218 1217 2047 1218 1959 1957 2047 2047 1957 1955 2047 1955 2048 1218 2047 2048 1957 1959 1958 1958 1959 1960 1956 1955 1957 1956 1957 1958 1953 1954 1955 1953 1955 1956 2048 1955 1954 2048 1954 2049 1218 2048 1214 1214 2048 2049 1213 1218 1214 1213 1214 1210 1210 1214 1215 1214 2049 1215 1954 1952 2049 2049 1952 1950 2049 1950 2050 1215 2049 2050 1952 1954 1953 1951 1950 1952 1951 1952 1953 1948 1949 1950 1948 1950 1951 2050 1950 1949 2050 1949 2051 1215 2050 1211 1211 2050 2051 1210 1215 1211 1210 1211 1207 1207 1211 1212 1211 2051 1212 1949 1947 2051 2051 1947 1945 2051 1945 2052 1212 2051 2052 1947 1949 1948 1946 1945 1947 1946 1947 1948 1937 1944 1945 1937 1945 1946 2052 1945 2053 1945 1944 2053 1212 2052 1208 1208 2052 2053 1207 1212 1208 1207 1208 1204 1204 1208 1209 1208 2053 1209 2053 1944 1936 2053 1936 1943 1943 2055 2053 1209 2053 2055 1936 1944 1937 1936 1937 1938 1938 1943 1936 1938 1942 1943 1942 2054 1943 1943 2054 2055 1209 2055 1205 1205 2055 2054 1204 1209 1205 1204 1205 1201 1201 1205 1206 1205 2054 1206 1942 1940 2054 2054 1940 1939 2054 1939 2056 1206 2054 2056 1941 1940 1942 1941 1942 1938 1930 1939 1940 1930 1940 1941 1929 1939 1930 2056 1939 2057 1939 1929 2057 1206 2056 1202 1202 2056 2057 1201 1206 1202 1201 1202 1198 1198 1202 1203 1202 2057 1203 2057 1929 1927 2057 1927 1935 1935 2059 2057 1203 2057 2059 1928 1927 1929 1928 1929 1930 1926 1927 1928 1926 1935 1927 1926 1934 1935 1934 2058 1935 1935 2058 2059 1203 2059 1199 1199 2059 2058 1198 1203 1199 1198 1199 1195 1195 1199 1200 1199 2058 1200 1934 1932 2058 2058 1932 1931 2058 1931 2060 1200 2058 2060 1933 1932 1934 1933 1934 1926 1920 1931 1932 1920 1932 1933 1919 1931 1920 2060 1931 2061 1931 1919 2061 1200 2060 1196 1196 2060 2061 1195 1200 1196 1195 1196 1192 1192 1196 1197 1196 2061 1197 2061 1919 1917 2061 1917 1925 1925 2063 2061 1197 2061 2063 1918 1917 1919 1918 1919 1920 1916 1917 1918 1916 1925 1917 1916 1924 1925 1924 2062 1925 1925 2062 2063 1197 2063 1193 1193 2063 2062 1192 1197 1193 1192 1193 1189 1189 1193 1194 1193 2062 1194 1924 1922 2062 2062 1922 1921 2062 1921 2064 1194 2062 2064 1923 1922 1924 1923 1924 1916 1910 1921 1922 1910 1922 1923 1909 1921 1910 2064 1921 1909 2064 1909 2065 1194 2064 1190 1190 2064 2065 1189 1194 1190 1189 1190 1186 1186 1190 1191 1190 2065 1191 1909 1907 2065 2065 1907 1915 2065 1915 2066 1191 2065 2066 1908 1907 1909 1908 1909 1910 1906 1907 1908 1906 1915 1907 1906 1914 1915 2066 1915 1914 2066 1914 2067 1191 2066 1187 1187 2066 2067 1186 1191 1187 1186 1187 1183 1183 1187 1188 1187 2067 1188 1914 1912 2067 2067 1912 1911 2067 1911 2068 1188 2067 2068 1913 1912 1914 1913 1914 1906 1898 1911 1912 1898 1912 1913 1897 1911 1898 2068 1911 1897 2068 1897 2069 1188 2068 1184 1184 2068 2069 1183 1188 1184 1183 1184 1182 1216 1183 1182 1216 1182 1181 1216 1181 1291 1186 1183 1216 1186 1216 1189 1189 1216 1213 1181 1294 1295 1181 1295 1291 1291 1295 1296 1294 2072 1295 1295 2072 2073 1295 2073 1296 2072 1902 1900 2072 1900 2073 2073 1900 1899 1893 1899 1900 1893 1900 1901 1901 1900 1902 1189 1213 1210 1210 1207 1189 1207 1204 1189 1189 1204 1201 1189 1201 1192 1201 1198 1195 1192 1201 1195 1897 1895 2069 1896 1895 1897 1896 1897 1898 1898 2225 1896 1913 2224 1898 1898 2224 2225 2224 2146 2225 2225 2146 2147 2223 2145 2224 2224 2145 2146 1913 2223 2224 1906 2223 1913 2222 2144 2223 2223 2144 2145 1906 2222 2223 2144 1355 2145 2145 1355 1331 2145 1331 2146 2143 1375 2144 2144 1375 1355 2222 2143 2144 2221 2143 2222 1908 2221 2222 1908 2222 1906 2142 1374 2143 2143 1374 1375 2221 2142 2143 1374 1356 1375 1375 1356 1355 1372 1373 1374 1374 1373 1356 2142 1372 1374 2141 1372 2142 2220 2141 2142 2220 2142 2221 1372 1381 1373 2141 1381 1372 2140 1381 2141 2219 2140 2141 2219 2141 2220 1923 2219 2220 1923 2220 1910 1910 2220 2221 2218 2140 2219 1916 2218 2219 1916 2219 1923 2217 2139 2218 2218 2139 2140 1918 2217 2218 1918 2218 1916 2216 2138 2217 2217 2138 2139 1920 2216 2217 1920 2217 1918 2138 1383 2139 2139 1383 1382 2139 1382 2140 2137 1352 2138 2138 1352 1383 2216 2137 2138 1351 1382 1383 1351 1383 1352 1373 1381 1382 1373 1382 1351 2140 1382 1381 1351 1352 1349 1351 1349 5059 5059 1373 1351 1349 1352 1353 2137 1353 1352 1349 1353 1350 2136 1350 1353 2136 1353 2137 1348 1349 1350 2135 1348 1350 2135 1350 2136 2214 2135 2136 2214 2136 2215 2215 2136 2137 2134 1348 2135 2213 2134 2135 2213 2135 2214 1928 2213 2214 1928 2214 1926 1926 2214 2215 2215 2137 2216 1926 2215 1933 1933 2215 2216 1933 2216 1920 1930 2213 1928 2212 2134 2213 1930 2212 2213 1941 2212 1930 2211 2133 2212 2212 2133 2134 1941 2211 2212 1938 2211 1941 2210 2132 2211 2211 2132 2133 1938 2210 2211 2132 1344 2133 2133 1344 1346 2133 1346 2134 2131 1478 2132 2132 1478 1344 2210 2131 2132 1344 1345 1346 1344 1478 1345 1346 1345 1347 1346 1347 1348 2134 1346 1348 1348 1347 1349 1347 1345 5056 1349 1347 5058 5058 1347 5056 5059 1349 5058 5058 5056 5055 5059 5058 5054 5054 5058 5055 5056 1345 5044 5056 5044 5057 5055 5056 5057 3394 3392 5055 5055 5057 3394 5054 5055 3390 3390 5055 3392 5057 5044 5043 5057 5043 3396 3394 5057 3396 3393 3392 3394 3393 3394 3395 3395 3394 3396 3391 3390 3392 3391 3392 3393 3395 3424 3393 3393 3424 3427 3427 3391 3393 3395 3396 3281 3281 3425 3395 3395 3425 3424 3281 3396 3280 3396 5043 3280 3280 3272 3281 3281 3272 3425 3424 3425 3426 3425 3272 3443 3425 3443 3426 3272 3273 3274 3273 3272 3280 3443 3272 3274 5030 3273 3280 5030 3280 5032 5032 3280 5043 3274 3273 3275 3273 5030 5031 3273 5031 3275 3274 3275 3276 3443 3274 3451 3451 3274 3276 3276 3275 3277 3275 5031 5035 3275 5035 3277 3276 3277 3278 3451 3276 3453 3453 3276 3278 3278 3277 3279 3277 5035 5036 3277 5036 3279 5031 5033 5035 5035 5033 5034 5035 5034 5036 5036 5034 5014 5036 5014 5016 3279 5036 5016 3278 3279 3266 3266 3279 3267 3279 5016 3267 5014 5015 5016 5016 5015 3269 5016 3269 3267 1446 5013 5014 5014 5013 5015 5034 1446 5014 5017 3269 5015 5017 5015 5018 5018 5015 5013 1446 1420 5013 5018 5013 1418 1418 5013 1420 1420 1446 1421 1421 1446 1447 5034 1447 1446 1419 1418 1420 1419 1420 1421 1299 1417 1418 1299 1418 1419 1417 5018 1418 1299 1419 2126 2126 1419 1421 1297 1298 1299 1299 1379 1380 1298 1414 1299 1299 1414 1415 1299 1415 1416 1380 1417 1299 1299 1416 1445 1299 1445 1379 1299 1803 1297 1299 2126 1803 1417 1380 5001 5001 1380 1379 5001 1379 5002 5002 1379 1445 5002 1445 5003 5003 1445 1416 4998 1416 1415 5003 1416 4998 4998 1415 4997 4997 1415 1414 4997 4995 4998 5006 5003 4998 5006 4998 4995 5005 5002 5003 5005 5003 5006 5004 5001 5002 5004 5002 5005 3261 5004 5005 3261 5005 3263 3263 5005 5006 3263 5006 3265 3265 5006 4995 3262 3261 3263 3262 3263 3264 3264 3263 3265 3260 3261 3262 3260 3271 3261 3261 3271 5004 5004 3271 5017 5004 5017 5001 3270 3269 3271 3270 3271 3260 3271 3269 5017 3472 3270 3260 3260 3262 3472 3268 3269 3270 3472 3471 3270 3268 3270 3473 3473 3270 3471 3268 3267 3269 3266 3267 3268 3266 3268 3456 3456 3268 3473 3473 3471 3474 3456 3473 3457 3457 3473 3474 3455 3266 3456 3455 3456 3457 3454 3278 3266 3454 3266 3455 3459 3454 3455 3459 3455 3460 3460 3455 3457 3460 3457 3344 3457 3474 3344 3344 3346 3460 3460 3346 3348 3460 3348 3459 3458 3454 3459 3459 3348 3384 3459 3384 3458 3346 3347 3348 3348 3347 3384 3344 3345 3346 3346 3345 3347 3384 3347 3385 3464 3385 3347 3464 3347 3465 3476 3465 3347 3476 3347 3345 3384 3385 3386 3458 3384 3386 3386 3385 3387 3463 3387 3385 3463 3385 3464 3466 3463 3464 3466 3464 3467 3467 3464 3465 3461 3387 3463 3462 3461 3463 3462 3463 3466 3386 3387 3374 3374 3387 3388 3461 3388 3387 3449 3448 3461 3449 3461 3450 3448 3388 3461 3450 3461 3462 3374 3388 3373 3447 3373 3388 3447 3388 3448 3433 3447 3448 3433 3448 3434 3434 3448 3449 3434 3449 3436 3436 3449 3450 3436 3450 3445 3462 3445 3450 3435 3434 3436 3431 3435 3436 3431 3436 3432 3436 3445 3446 3436 3446 3432 3433 3434 3435 3371 3433 3406 3406 3433 3435 3433 3371 3373 3373 3447 3433 3371 3372 3373 3372 3371 3405 3405 3371 3406 3405 3406 3404 3404 3406 3407 3406 3435 3407 3404 3421 3405 3405 3421 3423 3405 3423 3372 3403 3402 3404 3404 3407 3403 3402 3428 3404 3404 3428 3421 3407 3435 3438 3438 3403 3407 3401 3402 3403 3438 3401 3403 3401 3400 3402 3400 3428 3402 3399 3400 3401 3437 3399 3401 3437 3401 3438 3429 3437 3438 3429 3438 3430 3430 3438 3435 3430 3435 3431 3413 3429 3430 3431 3418 3430 3430 3418 3415 3430 3415 3413 3431 3432 3287 3287 3416 3431 3431 3416 3418 3416 3417 3418 3418 3417 3419 3418 3419 3415 3414 3413 3415 3415 3419 3420 3415 3420 3414 3417 5077 3419 3419 5077 3420 3416 3286 3417 3286 5078 3417 3417 5078 5077 3287 3286 3416 3286 3287 3288 5093 5078 3286 5093 3286 3288 3288 3287 3289 3288 3289 3290 5093 3288 3290 5089 5078 5093 5094 5089 5093 5093 3290 5094 3290 3289 3291 3290 3291 3292 5094 3290 3292 3292 3291 3293 3289 3462 3291 3291 3462 3466 3291 3466 3293 3292 3293 3294 5094 3292 5096 5096 3292 3294 3294 3293 3295 3293 3466 3467 3293 3467 3295 3294 3295 3296 5096 3294 5097 5097 3294 3296 5095 5094 5096 5095 5096 5098 5098 5096 5097 5097 3296 5086 5098 5097 5099 5099 5097 5086 1422 5095 5098 1422 5098 1423 1423 5098 5099 5099 5086 5087 1423 5099 1424 1424 5099 5087 3296 3298 5086 5086 3298 5084 5086 5084 5087 5087 5084 5085 5087 5085 1452 1424 5087 1452 1393 1423 1424 1452 1393 1424 1393 1422 1423 1338 1392 1393 1392 1422 1393 1452 1451 1393 5024 1338 1393 1393 1451 5024 1338 1391 1392 1392 1391 5088 1422 1392 5088 1310 1391 1338 1310 5081 1391 5088 1391 5081 5081 5092 5088 5088 5092 5095 5088 5095 1422 5080 5078 5081 1310 5080 5081 5078 5091 5081 5081 5091 5092 5095 5092 5091 5091 5094 5095 5078 5090 5091 5091 5090 5094 5080 5077 5078 5089 5090 5078 5094 5090 5089 5076 3420 5077 5079 5076 5077 5079 5077 5080 5076 3414 3420 3411 3413 3414 3411 3414 5076 3408 3410 3411 3410 3412 3411 3411 3412 3413 5076 3408 3411 3413 3412 3429 3429 3412 3410 3408 3409 3410 3429 3410 3409 3409 3437 3429 3285 3409 3408 3437 3409 3285 3285 3399 3437 3284 3283 3285 3285 3283 3399 3408 3284 3285 3399 3283 3400 3282 3283 3284 3283 3282 3397 3283 3397 3400 3282 3284 5066 5066 3284 3408 3397 3282 3390 3390 3282 5054 3282 5066 5054 3397 3390 3398 3428 3397 3398 3400 3397 3428 3389 3390 3391 3398 3390 3389 3398 3389 3427 3398 3427 3428 3428 3427 3424 3428 3424 3421 3427 3389 3391 3421 3422 3423 3421 3424 3426 3421 3426 3422 3426 3440 3422 3422 3440 3441 3422 3441 3423 3439 3372 3423 3423 3441 3442 3423 3442 3439 3441 3440 3451 3452 3442 3441 3441 3451 3452 3426 3444 3440 3451 3440 3444 3426 3443 3444 3451 3444 3443 3452 3451 3453 3452 3453 3458 3458 3386 3452 3452 3386 3439 3452 3439 3442 3453 3278 3454 3458 3453 3454 3374 3372 3439 3386 3374 3439 3373 3372 3374 5054 5066 5067 5054 5067 5059 5067 5066 5075 5075 5066 3408 5059 5067 1373 1373 5067 5074 5067 5075 5074 5075 3408 5076 5074 5075 5076 5074 5076 5079 1373 5074 1356 1356 5074 5079 1356 5079 1354 1354 5079 5080 1354 1355 1356 1310 1331 1354 1354 1331 1355 1354 5080 1310 1308 1309 1310 1308 1310 1338 1309 1329 1310 1310 1329 1331 1308 1338 5008 1309 1308 5012 5012 1308 5008 1329 1309 5000 5000 1309 5012 1329 1330 1331 5000 1330 1329 4999 4984 5000 5000 4984 1330 5000 5012 4999 5012 5008 5007 4999 5012 5007 3219 4983 4999 4999 4983 4984 3582 3219 4999 4999 5007 3582 4984 4983 4985 1330 4984 4986 4984 4985 4986 4983 3221 3630 4983 3630 4985 3219 3221 4983 4985 3630 3632 4985 3632 4987 4986 4985 4987 4986 4987 4989 1330 4986 1332 1332 4986 4989 3632 3635 4987 4987 3635 3641 4987 3641 4988 4989 4987 4988 4989 4988 4990 1332 4989 1333 1333 4989 4990 1331 1330 1332 1331 1332 1333 1359 1376 1333 1376 1384 1333 1333 1384 1385 1333 1385 1331 1333 4990 1359 1359 1361 1376 5183 1384 1376 5183 1376 5184 5184 1376 1361 5175 1385 1384 5175 1384 5183 1331 1385 1386 5175 5173 1385 1385 5173 1386 5174 5172 5175 5175 5172 5173 5183 5174 5175 5184 5188 5183 5183 5188 5174 3027 3037 5174 5174 3037 5172 5188 3027 5174 3037 3035 5172 5172 3035 5170 5172 5170 5173 5173 5170 5171 5173 5171 1386 3035 3033 5170 5170 3033 5161 5170 5161 5171 3034 3033 3035 3034 3035 3036 3036 3035 3037 3036 3037 3026 3026 3037 3027 3036 3026 3738 3034 3036 3740 3740 3036 3738 3032 3033 3034 3032 3034 3742 3742 3034 3740 3740 3738 3741 3742 3740 3743 3743 3740 3741 3738 3026 3731 3738 3731 3739 3741 3738 3739 3741 3739 3128 3743 3741 3134 3134 3741 3128 3754 3742 3743 3754 3743 3755 3755 3743 3134 3032 3742 3754 3754 3042 3032 3756 3042 3754 3756 3754 3757 3757 3754 3755 3755 3134 3133 3757 3755 3144 3144 3755 3133 3127 3133 3134 3127 3134 3128 3132 3133 3127 3132 3144 3133 3132 3143 3144 3143 3757 3144 3759 3756 3757 3759 3757 3143 3142 3141 3143 3142 3143 3132 3143 3141 3766 3143 3766 3759 3758 3756 3759 3759 3766 3767 3759 3767 3758 3141 3139 3766 3766 3139 3771 3766 3771 3767 3140 3139 3141 3140 3141 3142 3132 3748 3142 3748 3140 3142 3138 3139 3140 3748 3765 3140 3138 3140 3760 3760 3140 3765 3138 3136 3139 3136 3771 3139 3137 3136 3138 3137 3138 3760 3137 3760 3761 3761 3760 3762 3760 3765 3762 3761 3762 3763 3763 3776 3761 3761 3776 3777 3761 3777 3137 2984 2982 3776 3776 2982 3774 3776 3774 3777 3763 2984 3776 3777 3774 3772 3777 3772 3146 3137 3777 3146 3773 3772 3774 3773 3774 3775 3775 3774 2982 3206 3148 3772 3206 3772 3773 3146 3772 3148 3145 3137 3146 3145 3146 3147 3147 3146 3148 3147 3148 3149 3149 3148 3205 3205 3148 3206 3784 3782 3147 3147 3782 3145 3149 3784 3147 3792 3784 3149 3205 3792 3149 3205 3206 3207 3794 3792 3205 3207 3794 3205 3791 3783 3792 3792 3783 3784 3794 3791 3792 3783 3781 3784 3784 3781 3782 3059 3057 3783 3783 3057 3781 3791 3059 3783 3064 3059 3791 3793 3064 3791 3793 3791 3794 3796 3793 3794 3796 3794 3207 3061 3064 3793 3795 3061 3793 3795 3793 3796 3059 3064 3060 3060 3064 3061 3058 3057 3059 3060 3058 3059 3060 3061 3065 3060 3065 5123 3058 3060 5125 5125 3060 5123 3056 3057 3058 3056 3058 5133 5133 3058 5125 5125 5123 5126 5133 5125 5138 5138 5125 5126 5123 3065 5122 5123 5122 5124 5126 5123 5124 5126 5124 1489 5138 5126 1488 1488 5126 1489 5136 5133 5138 5136 5138 1487 1487 5138 1488 1404 1487 1488 1404 1488 1489 1403 1487 1404 5137 5136 1487 5137 1487 1403 5135 5134 5136 5135 5136 5137 5134 5133 5136 5137 1403 1402 5137 1402 5147 5147 5135 5137 1402 1403 1404 1404 1453 1402 5147 1402 1453 5147 1453 5148 5148 5146 5147 5147 5146 5135 3045 5134 5135 5146 3045 5135 5148 5151 5146 5151 3049 5146 5146 3049 3047 5146 3047 3045 5148 1453 1405 5148 1405 5145 5145 5151 5148 1404 1405 1453 1406 1405 1404 1489 1494 1404 1494 5633 1404 1404 5633 5636 1404 5636 1406 1405 1406 1407 1406 5636 5637 1406 5637 1407 5633 5635 5636 5636 5635 5632 5636 5632 5637 1494 5628 5633 5628 5634 5633 5633 5634 5635 5612 5627 5628 5612 5628 5623 5623 5628 1494 5628 5627 5634 5634 5627 3989 5634 3989 5635 2801 2802 5627 2801 5627 5612 5627 2802 3989 2801 5612 5613 5622 5613 5612 5622 5612 5623 1491 5622 5623 1491 5623 1493 5623 1494 1493 5621 5613 5622 1362 5621 5622 1362 5622 1491 1490 1362 1491 1490 1491 1492 1492 1491 1493 1492 1493 1489 1489 1493 1494 5124 5121 1492 1492 5121 1490 1489 5124 1492 1363 1362 1490 1363 1490 5121 1362 1363 1364 1364 5621 1362 1364 1363 1365 5109 1365 1363 5109 1363 5110 1363 5121 5110 5110 5121 5122 5124 5122 5121 5111 5112 5110 5110 5112 5113 5110 5113 5109 5110 5122 5111 5108 1365 5109 5109 5113 5114 5109 5114 5108 5112 3071 5113 5113 3071 3069 5113 3069 5114 5111 3063 5112 5112 3063 3071 5111 5122 3065 5111 3065 3063 3061 3062 3063 3065 3061 3063 3062 3071 3063 3070 3069 3071 3070 3071 3062 3062 3061 3795 3795 3070 3062 3068 3069 3070 3795 3806 3070 3068 3070 3807 3807 3070 3806 3796 3806 3795 3796 3805 3806 3807 3806 3808 3808 3806 3805 3809 3068 3807 3809 3807 3810 3810 3807 3808 3808 3805 3211 3810 3808 3213 3213 3808 3211 3207 3209 3805 3207 3805 3796 3211 3805 3209 3209 3210 3211 3211 3210 3212 3211 3212 3213 3207 3208 3209 3209 3208 3210 3207 3206 3208 3790 3785 3208 3208 3785 3210 3206 3790 3208 3212 3210 3785 3212 3785 3786 3786 3785 3787 3790 3787 3785 3789 3787 3790 3773 3789 3790 3773 3790 3206 3786 3787 3788 3788 3787 2976 3789 2976 3787 3788 3803 3786 3786 3803 3804 3786 3804 3212 3788 2976 2974 2974 2972 3788 3788 2972 3803 2972 2970 3803 3803 2970 3801 3803 3801 3804 3804 3801 3798 3804 3798 3214 3212 3804 3214 3212 3214 3213 3213 3214 3215 3214 3798 3215 3797 3215 3798 3797 3798 3799 3799 3798 3800 3800 3798 3801 3800 3801 3802 3802 3801 2970 3800 3813 3814 3800 3814 3799 3802 3817 3800 3800 3817 3818 3800 3818 3813 3799 3814 3815 3799 3815 3797 3829 3815 3814 3829 3814 3813 3818 3829 3813 3817 3829 3818 3802 2966 3817 2966 2964 3817 3817 2964 3829 3830 3815 3829 3827 3830 3829 3827 3829 2962 2962 3829 2964 3797 3815 3816 3830 3816 3815 3217 3215 3797 3797 3811 3217 3797 3816 3811 3830 3811 3816 3217 3811 3812 3830 3812 3811 3216 3215 3217 3216 3217 3204 3204 3217 3218 3217 3812 3218 3213 3215 3216 3824 3213 3216 3216 3204 3824 3203 3202 3204 3204 3218 3203 3824 3204 3831 3202 3831 3204 3203 3218 3812 3203 3812 3830 3201 3202 3203 3201 3203 3825 3825 3203 3830 3201 3200 3202 3834 3831 3202 3200 3834 3202 3199 3200 3201 3199 3201 3825 3199 3825 3826 3826 3825 3827 3825 3830 3827 3174 3198 3199 3199 3198 3200 3826 3842 3199 3199 3842 3174 3836 3834 3200 3200 3198 3836 3174 3197 3198 3836 3198 3197 3835 3833 3836 3836 3833 3834 3843 3835 3836 3836 3197 3844 3843 3836 3844 3172 3197 3174 3844 3197 3172 3844 3172 3845 3843 3844 3847 3847 3844 3845 3835 3843 3074 3074 3843 3847 3074 3076 3835 3835 3076 3833 3074 3075 3076 3084 3085 3074 3074 3085 3075 3074 3847 3084 3847 3845 3848 3084 3847 3848 3082 3083 3084 3084 3083 3085 3084 3848 3082 3083 5132 3085 3075 3085 5120 5120 3085 5132 3082 3081 3083 3081 5129 3083 3083 5129 5132 3080 3081 3082 3082 3848 3849 3082 3849 3080 3081 3080 3091 3081 5128 5129 3081 3091 5128 5131 5132 5129 5131 5129 5130 5130 5129 5128 5120 5132 5131 5130 1564 5131 5131 1564 5119 5131 5119 5120 5127 1565 5130 5130 1565 1564 5130 5128 5127 1563 1562 1564 1563 1564 1430 1430 1564 1565 1564 1562 5119 1562 1560 5119 5119 1560 5117 5119 5117 5120 1561 1560 1562 1561 1562 1563 1434 1559 1560 1434 1560 1561 1560 1559 5117 5117 1559 5116 5117 5116 5118 5120 5117 5118 5120 5118 3075 5118 5116 5115 5118 5115 3077 3075 5118 3077 5106 5115 5116 5106 5116 5107 5107 5116 1559 1433 1559 1434 5107 1559 1433 1435 5106 5107 1435 5107 1433 5104 5105 5106 5104 5106 1435 5105 5115 5106 1433 1434 1435 1435 1434 1436 1435 1436 5108 5108 5104 1435 1434 1365 1436 5108 1436 1365 5108 5114 5104 5114 3069 5100 5114 5100 5104 3068 3067 3069 3069 3067 5100 3066 3067 3068 3066 3068 3809 3067 3066 3072 3067 3072 5100 3072 3066 3073 3073 3066 3819 3819 3066 3809 3819 3809 3820 3820 3809 3821 3821 3809 3822 3822 3809 3810 3820 3832 3819 3819 3832 3078 3819 3078 3073 3078 3079 3073 3073 3079 3072 3076 3077 3078 3078 3077 3079 3076 3078 3833 3833 3078 3832 3072 3079 5101 5101 3079 5115 3077 5115 3079 3076 3075 3077 5105 5103 5115 5115 5103 5102 5115 5102 5101 5100 3072 5101 5101 5102 5100 5100 5102 5103 5100 5103 5104 5103 5105 5104 3820 3821 3832 3832 3821 3822 3832 3822 3831 3833 3832 3834 3834 3832 3831 3822 3810 3823 3831 3822 3823 3831 3823 3824 3823 3810 3824 3824 3810 3213 1364 1365 1366 1434 1366 1365 1366 5620 1364 1364 5620 5621 1441 1440 1366 1441 1366 1434 1440 5619 1366 1366 5619 5620 1434 1561 5541 1441 1434 5542 5542 1434 5541 1439 1440 1441 1439 1441 5542 1439 1438 1440 1438 5615 1440 1440 5615 5619 1437 1438 1439 1437 5605 1438 1438 5605 5615 5605 5614 5615 5615 5614 5616 5615 5616 5619 5601 5604 5605 5601 5605 1437 5605 5604 5614 1439 1514 1437 5601 1437 1514 5600 5598 5601 5601 1514 5600 5598 5604 5601 5598 2794 5604 5604 2794 4018 5604 4018 5614 5597 2787 5598 5600 5597 5598 2787 2794 5598 5599 5597 5600 5600 1514 1512 5600 1512 5599 1512 1514 1439 1439 1511 1512 5599 1512 1511 5594 5596 5599 5599 5596 5597 5599 1511 5594 5596 2789 5597 5597 2789 2787 5595 2791 5596 5596 2791 2789 5594 5595 5596 2788 2787 2789 2788 2789 2790 2790 2789 2791 2790 2791 2792 2792 2791 2793 5595 2793 2791 2792 4093 2790 2790 4093 4094 2790 4094 2788 2786 2787 2788 2788 4094 4074 2788 4074 2786 4093 4092 4094 4094 4092 4073 4094 4073 4074 4091 2890 4092 4092 2890 2888 4092 2888 4073 4093 4091 4092 4086 2892 4091 4091 2892 2890 4089 4086 4091 4089 4091 4093 2889 2888 2890 2889 2890 2891 2891 2890 2892 2887 2888 2889 2888 2887 4073 2887 2889 4035 4051 4050 2887 2887 4035 4051 4073 2887 4050 4035 2889 4001 4035 4001 4036 4051 4035 4036 4000 4001 2889 4000 4005 4001 4036 4001 4005 4036 4005 4003 4003 4038 4036 4051 4036 4058 4058 4036 4038 4004 4003 4005 4000 4004 4005 4002 4003 4004 4002 4037 4003 4003 4037 4038 4058 4038 4059 4059 4038 4037 4060 4051 4058 4060 4058 4045 4045 4058 4059 4059 4037 4024 4045 4059 4027 4027 4059 4024 4002 2797 4037 4024 4037 2797 2799 4021 4024 2799 4024 2797 4021 4027 4024 4021 4026 4027 4027 4026 4045 4019 4020 4021 4021 4020 4022 4021 4022 4014 4019 4021 2799 4014 4026 4021 4014 4025 4026 4025 4045 4026 4014 4015 4016 4014 4022 4023 4014 4023 4015 4016 4025 4014 5617 4023 4022 5617 4022 5618 5618 4022 4020 4015 4023 5617 4016 4015 4017 5616 4017 4015 5616 4015 5617 5619 5616 5617 5619 5617 5620 5620 5617 5618 5618 4020 5613 5620 5618 5621 5621 5618 5613 5613 4020 4019 5613 4019 2801 2799 2801 4019 2799 2800 2801 2801 2800 2802 2797 2798 2799 2799 2798 2800 3989 2802 2800 2798 3999 2800 2800 3999 3991 2800 3991 3989 2798 4002 3999 2798 2797 4002 3998 3991 3999 3999 4002 4004 3999 4004 3998 3997 3991 3998 3998 4004 4006 3998 4006 3997 4009 4006 4004 4009 4004 4000 3997 4006 3996 4010 3996 4006 4010 4006 4009 3996 3993 3997 3997 3993 3991 2804 2803 3996 3996 2803 3993 2804 3996 4010 4009 4008 4010 4008 4040 4010 4010 4040 2805 4010 2805 2804 2803 2804 2805 2803 2805 2806 3995 3993 2803 3995 2803 2806 2805 2811 2806 2806 5631 5632 5632 3995 2806 2811 5631 2806 3994 3993 3995 5632 3994 3995 5635 3994 5632 5637 5632 5631 5637 5631 5638 5650 5638 5631 2811 5650 5631 2805 2810 2811 2810 5650 2811 5649 5647 5650 5650 5647 5638 2810 5649 5650 1407 5637 5638 1407 5638 1455 5647 1455 5638 5646 1476 5647 5647 1476 1455 5649 5646 5647 5648 5646 5649 2808 5648 5649 2808 5649 2810 5645 1477 5646 5646 1477 1476 5648 5645 5646 1409 1455 1476 1409 1476 1477 1477 1495 1409 5645 1495 1477 5648 5655 5645 5645 5655 5653 5645 5653 1495 2808 2812 5648 5648 2812 5655 5654 5653 5655 5654 5655 5656 5656 5655 2812 1408 1410 5653 1408 5653 5654 1495 5653 1410 1409 1495 1410 1408 1409 1410 1311 1313 1408 1408 1313 1409 5667 1311 1408 5667 1408 5654 5670 5667 5654 5670 5654 5656 5666 1311 5667 5669 5666 5667 5669 5667 5670 1311 1312 1313 5666 1312 1311 5665 1312 5666 5668 5665 5666 5668 5666 5669 2819 5668 5669 2819 5669 2821 2821 5669 5670 2821 5670 2823 2823 5670 5656 2820 2819 2821 2820 2821 2822 2822 2821 2823 2818 2819 2820 2818 2830 2819 2819 2830 5668 2822 4081 2820 2820 4081 4082 2820 4082 2818 2822 2823 2824 2824 4080 2822 2822 4080 4081 4080 4078 4081 4081 4078 4079 4081 4079 4082 4079 4096 4082 4082 4096 2829 4082 2829 2818 2829 2830 2818 2827 2828 2829 2829 2828 2830 4096 4099 2829 2829 4099 2827 4079 4095 4096 4095 4097 4096 4096 4097 4099 4078 2871 4079 2871 4095 4079 2871 2867 4095 2867 2869 4095 4095 2869 4097 2869 2870 4097 4097 2870 4098 4097 4098 4099 4099 4098 4100 4099 4100 2827 4109 4110 4098 4115 4109 4098 4115 4098 2870 2869 2866 2870 2870 2866 2865 2870 2865 4115 4114 4109 4115 4115 2865 2864 4115 2864 4114 2864 2865 2866 2864 2866 2876 4114 2864 2876 4112 4113 4114 4114 4113 4109 4114 2876 4112 2876 2866 2877 2876 2877 2878 2876 2878 4129 2876 4129 4112 4112 4111 4113 4112 4129 4138 4112 4138 4111 4111 2833 4113 4113 2833 2835 4113 2835 4109 4111 2831 2833 4111 4138 2838 4111 2838 2831 4129 4135 4138 4138 4135 4131 4138 4131 2838 2837 2831 2838 2837 2838 2839 2839 2838 2840 2838 4131 2840 2831 2832 2833 2832 2831 2837 2839 5698 2837 2837 5698 5686 2837 5686 2832 2839 2840 2841 2841 5697 2839 2839 5697 5698 2841 2840 2842 2842 2840 4130 4130 2840 4131 2841 2842 2843 2843 5694 2841 2841 5694 5697 5694 5695 5697 5697 5695 5696 5697 5696 5698 5693 1369 5695 5695 1369 1368 5695 1368 5696 5694 5693 5695 5696 1368 1367 5696 1367 5687 5698 5696 5687 1313 1367 1368 1313 1368 1369 1341 1367 1313 5688 5687 1367 5688 1367 1341 5686 5687 5688 5698 5687 5686 5690 5686 5688 5690 5688 1340 1340 5688 1341 1313 1340 1341 1313 1339 1340 1339 5690 1340 5689 5686 5690 5692 5689 5690 5692 5690 1339 5689 2832 5686 2834 2832 5689 5691 2834 5689 5691 5689 5692 5677 5691 5692 5677 5692 1315 1315 5692 1339 1315 1339 1313 1315 1313 1316 1316 5677 1315 5676 5675 5677 5676 5677 1316 5675 5691 5677 2836 2834 5691 5675 2836 5691 5674 2826 5675 5674 5675 5676 2826 2836 5675 5679 5674 5676 5679 5676 1334 1334 5676 1316 1313 1334 1316 1313 1314 1334 1314 5679 1334 5678 5674 5679 5665 5678 5679 5665 5679 1314 2828 2826 5674 5678 2828 5674 2830 2828 5678 5668 2830 5678 5668 5678 5665 5665 1314 1312 1313 1312 1314 1317 1318 1313 1313 1318 1319 1313 1319 1320 1317 1313 1370 1370 1313 1369 1610 1611 1313 1610 1313 1625 1611 1658 1313 1313 1658 1656 1313 1656 1659 1320 1696 1313 1313 1696 1697 1313 1697 1625 1659 1656 1654 1648 1654 1655 1655 1654 1656 1655 1676 1648 5412 5410 1655 1655 5410 1676 1656 5412 1655 1648 1676 1677 5410 5397 1676 1676 5397 1677 5409 5401 5410 5410 5401 5397 5412 5409 5410 5411 5409 5412 5426 5411 5412 1656 5426 5412 2493 2491 5409 5409 2491 5401 5411 2493 5409 2494 2493 5411 2494 5411 5419 5426 5419 5411 5425 5419 5426 1658 5425 5426 1658 5426 1656 5424 4366 5419 5419 4366 4365 5419 4365 2494 5425 5424 5419 5423 5424 5425 1657 5423 5425 1657 5425 1658 1611 1657 1658 1653 1657 1611 1653 5423 1657 1653 5421 5423 5421 5422 5423 5423 5422 5424 1611 1652 1653 5434 5421 1653 5434 1653 1652 5421 5420 5422 5433 5420 5421 5433 5421 5434 5420 4363 5422 5422 4363 4369 5422 4369 5424 5420 2486 4363 2485 2486 5420 2485 5420 5433 2485 5433 5442 5451 5442 5433 5451 5433 5434 2483 2484 2485 2485 2484 2486 2483 2485 4307 5442 4307 2485 2486 2484 4363 2483 2482 2484 4363 2484 4364 4373 4364 2484 4373 2484 2482 2481 2482 2483 2482 2481 4358 2482 4358 4373 4372 4364 4373 4373 4358 4388 4373 4388 4372 4358 2481 4333 4358 4333 4359 4359 4388 4358 2483 4311 2481 4311 4332 2481 2481 4332 4333 4333 4332 4334 4334 4359 4333 4336 4362 4359 4336 4359 4334 4362 4387 4359 4359 4387 4388 4334 4332 4335 4334 4335 4336 4311 4310 4332 4332 4310 4312 4332 4312 4335 4309 4310 4311 4309 4312 4310 2483 4309 4311 4307 4308 4309 4309 4308 4306 4307 4309 2483 4306 4305 4309 4309 4305 4312 4305 4319 4312 4335 4312 4319 4305 4318 4319 4335 4319 4318 4316 4318 4305 4316 4335 4318 4315 4316 4305 4315 4345 4316 4316 4345 4335 4305 4317 4315 4317 4343 4315 4315 4343 4345 4343 4342 4345 4345 4342 4340 4345 4340 4335 4335 4340 4338 4335 4338 4336 4337 4338 4339 4339 4338 4340 4336 4338 4337 4337 4362 4336 4339 4361 4337 4337 4361 4362 4339 4340 4341 4341 4360 4339 4339 4360 4361 4362 4361 4387 4387 4361 4360 4341 2597 4360 4387 4360 2597 2598 4341 4331 4331 4341 4340 2598 2597 4341 2597 2598 2599 2597 4384 4387 2597 2599 4384 4387 4384 4381 4387 4381 4388 4384 4385 4381 4384 2599 4395 4384 4395 4385 2599 2598 2600 2600 2603 2599 2603 4395 2599 2574 2602 2600 2600 2602 2603 2600 2598 4329 2574 2600 4321 4321 2600 4329 4398 4395 2603 2602 4398 2603 2574 2601 2602 4400 4398 2602 4400 2602 2601 4397 4396 4398 4398 4396 4395 4400 4397 4398 4399 4397 4400 4409 4408 4400 4409 4400 2573 2573 4400 2601 2573 2601 2574 2550 2572 2573 2550 2573 2574 2572 4409 2573 4407 4408 4409 4411 4407 4409 4411 4409 2572 4407 2490 4408 2499 2490 4407 4410 2499 4407 4410 4407 4411 4413 4410 4411 4413 4411 2552 2552 4411 2572 2552 2572 2550 2550 2551 2552 2551 2577 2552 2552 2577 4424 2552 4424 4413 4412 4410 4413 4413 4424 4425 4413 4425 4412 2497 2499 4410 4412 2497 4410 2495 2497 4412 4412 4425 2505 4412 2505 2495 4426 2505 4425 4426 4425 4427 4427 4425 4424 4427 4424 2576 2576 4424 2577 2551 2576 2577 2575 2576 2551 2575 2579 2576 2579 4427 2576 4429 4426 4427 4429 4427 2579 2503 2505 4426 4428 2503 4426 4428 4426 4429 4429 2579 2614 4429 2614 4444 4428 4429 4444 2578 2579 2575 2578 2614 2579 2578 2613 2614 4444 2614 2613 4444 2613 4445 4428 4444 4447 4447 4444 4445 2501 2503 4428 2501 4428 4447 4447 4445 4448 2501 4447 2511 2511 4447 4448 4445 2613 2612 4445 2612 4446 4448 4445 4446 2593 2612 2613 2593 2613 2578 2592 2612 2593 4458 4446 2612 2612 2592 4458 4448 4446 4449 4459 4449 4446 4446 4458 4459 4458 2592 2590 4458 2590 4460 4459 4458 4460 2591 2590 2592 2591 2592 2593 4349 2593 2578 4349 2591 2593 2589 2590 2591 4349 4379 2591 2589 2591 4374 4374 2591 4379 2589 2587 2590 4460 2590 2587 2588 2587 2589 2588 2589 4374 2588 4374 4375 4375 4374 4376 4374 4379 4376 2586 2587 2588 4375 4394 2588 2588 4394 2586 2586 2585 2587 4460 2587 4461 2585 4461 2587 2584 2585 2586 4394 4391 2586 2586 4391 2584 4393 4389 4394 4394 4389 4391 4375 4393 4394 4389 4390 4391 4391 4390 4392 4391 4392 2584 2582 2583 2584 2584 2583 2585 2584 4392 2582 4390 4405 4392 4392 4405 4406 4392 4406 2582 4389 2452 4390 2452 2450 4390 4390 2450 4405 2450 2448 4405 4405 2448 4403 4405 4403 4406 4406 4403 4401 4406 4401 2554 2582 4406 2554 4402 4401 4403 4402 4403 4404 4404 4403 2448 2558 2556 4401 2558 4401 4402 2554 4401 2556 4404 4422 4402 4402 4422 4423 4402 4423 2558 4404 2448 2446 2446 2444 4404 4404 2444 4422 2444 2442 4422 4422 2442 4418 4422 4418 4423 4423 4418 4416 4423 4416 2560 2558 4423 2560 4418 2442 2440 2440 4419 4418 4418 4419 4420 4418 4420 4416 4440 4419 4441 4441 4419 2440 4440 4420 4419 4416 4420 4421 4440 4421 4420 4442 4421 4440 4441 4457 4440 4440 4457 4442 4441 2440 2438 2438 4439 4441 4441 4439 4457 2437 2438 2439 2439 2438 2440 2437 4439 2438 2437 4438 4439 4457 4439 4438 4436 4438 2437 4436 2437 5510 5530 5510 2437 5530 2437 2439 2439 2440 2441 2439 2441 5530 5525 5510 5530 5530 2441 5532 5532 5525 5530 2441 2440 2442 2441 2442 2443 2443 5532 2441 2443 2442 2444 2443 2444 2445 5520 5534 2443 5520 2443 2445 5534 5532 2443 2445 2444 2446 2445 2446 2447 5520 2445 5521 5521 2445 2447 5519 5516 5520 5520 5521 5519 5516 5534 5520 5516 5531 5534 5531 5533 5534 5534 5533 5532 1672 1671 5516 5519 1672 5516 1671 5531 5516 1671 1669 5531 1669 1668 5531 5531 1668 5533 1670 1669 1671 1670 1671 1672 1668 1669 1670 1668 1670 1633 5533 1668 1633 1633 1670 1689 1672 1712 1670 1689 1670 5478 5478 1670 1712 1633 1689 1690 5481 1690 1689 5481 1689 5476 5476 1689 5478 5476 5478 5477 5494 5477 5478 5478 1712 5494 1672 1711 1712 5494 1712 1711 1710 1711 1672 5494 1711 5496 5496 1711 1710 1672 1721 1710 5496 1710 5497 5497 1710 1721 5497 5501 5496 5496 5501 5495 5496 5495 5494 5497 1721 5498 5498 5500 5497 5497 5500 5501 1672 1720 1721 1721 1720 5493 5498 1721 5493 5498 5493 5499 5498 5499 5500 5499 2459 5500 5500 2459 2461 5500 2461 5501 5499 2457 2459 5493 5505 5499 5499 5505 2455 5499 2455 2457 1720 5504 5493 5493 5504 5505 5506 2455 5505 5506 5505 5507 5507 5505 5504 2453 2454 2455 2455 2454 2456 2455 2456 2457 2453 2455 5506 5508 2453 5506 5508 5506 5509 5509 5506 5507 5507 5504 1716 5509 5507 1715 1715 5507 1716 5509 1715 1717 5509 1717 5517 5517 5508 5509 2451 2453 5508 5517 5523 5508 5523 2451 5508 5517 1717 1718 5517 1718 5518 5518 5523 5517 1715 1716 1717 1717 1716 1718 1716 1719 1718 1716 5504 1719 1718 1719 1720 1718 1720 1672 5518 1718 1672 5518 1672 5519 5519 5522 5518 5518 5522 5523 5519 5521 5522 5521 2447 5522 5522 2447 2449 5522 2449 5523 2447 2446 2448 2447 2448 2449 2449 2448 2450 2449 2450 2451 5523 2449 2451 2451 2450 2452 2451 2452 2453 2453 2452 2454 2454 2452 4389 2456 2454 4393 4393 2454 4389 2457 2456 2458 2458 2456 4377 4377 2456 4393 4377 4393 4375 4375 4376 4377 4377 4376 2460 4377 2460 2458 2457 2458 2459 2459 2458 2460 2459 2460 2461 2461 2460 2462 4376 4378 2460 2460 4378 2462 4376 4379 4378 4351 2462 4378 4351 4378 4353 4379 4346 4378 4378 4346 4350 4378 4350 4353 4379 4347 4346 4347 4379 4349 4346 4347 4348 4346 4348 4350 4352 4353 4350 4350 4348 4352 4352 4351 4353 2464 4351 4352 2464 2462 4351 4352 4348 4354 4352 4354 4356 2464 4352 2467 2467 4352 4356 4347 2578 4348 4348 2578 2575 4348 2575 4354 4349 2578 4347 4354 2575 2551 4354 2551 4355 4356 4354 4355 4356 4355 4357 2467 4356 2469 2469 4356 4357 4355 2551 2550 4355 2550 4322 4357 4355 4322 4357 4322 4324 2469 4357 2471 2471 4357 4324 2468 2467 2469 2468 2469 2470 2470 2469 2471 2470 2471 2472 2472 2471 2473 2471 4324 2473 4322 4323 4324 4324 4323 2478 4324 2478 2473 2472 2473 2477 2477 2473 2478 5462 2472 2477 2470 2472 5462 2477 2478 2476 5462 2477 5463 5463 2477 2476 2476 2478 2479 4323 4326 2478 2478 4326 2479 2474 2475 2476 2476 2479 2474 5463 2476 5464 5464 2476 2475 5461 5462 5463 5461 5463 5460 5460 5463 5464 5460 5464 5459 5459 5464 5443 5464 2475 5443 2475 2474 4301 5443 2475 4301 5444 5443 5445 5443 4301 5445 5459 5443 5444 5444 1675 5459 5459 1675 1674 5459 1674 5460 5460 1674 1673 5460 1673 5461 1673 1674 1633 1633 1674 1675 1633 1675 1631 5444 1631 1675 1631 5444 5446 5444 5445 5446 1631 1632 1633 1631 5446 1632 5446 5445 5447 5446 5447 5449 1632 5446 5449 1633 1632 1634 1632 5449 1634 5449 5447 5448 5449 5448 5450 1634 5449 5450 1633 1634 1635 1635 1634 1636 1634 5450 1636 5450 5448 5442 5450 5442 5451 1636 5450 5451 5447 4306 5448 5448 4306 4308 5448 4308 5442 5442 4308 4307 4304 4305 4306 5447 4304 4306 4303 4302 4304 4304 4302 4305 4303 4304 5447 4302 4314 4305 4305 4314 4317 4302 4313 4314 4313 4344 4314 4314 4344 4317 4317 4344 4343 4343 4344 4325 4320 4325 4344 4320 4344 4313 4313 4302 4320 4320 4302 2474 4320 2474 2480 2480 4325 4320 2480 2479 4325 4325 2479 4326 4325 4326 4327 4325 4327 4343 4343 4327 4342 4327 4326 4328 4328 4342 4327 4328 4326 4329 4323 4329 4326 4328 4329 4330 4330 4342 4328 4330 4340 4342 4329 4331 4330 4331 4340 4330 4329 2598 4331 4321 4329 4323 4322 4321 4323 2550 2574 4321 2550 4321 4322 2474 2479 2480 4301 2474 4302 4301 4302 4303 5445 4301 4303 5445 4303 5447 1636 5451 1651 1651 5451 5434 1636 1651 1635 1635 1651 1652 1651 5434 1652 1635 1652 1611 1611 1610 5514 1635 1611 5515 5515 1611 5514 1610 1625 5512 5514 1610 5512 5514 5512 5511 5515 5514 5510 5510 5514 5511 5510 5527 5515 5515 5527 5528 5515 5528 1635 5510 5511 4436 5525 5526 5510 5510 5526 5527 5527 5526 5532 5532 5528 5527 1635 5528 5529 5532 5529 5528 5532 5526 5525 5533 5529 5532 1635 5529 5524 5533 5524 5529 5524 1633 1635 1633 5524 5533 1690 1701 1633 1633 1701 1702 1633 1702 1673 5482 1701 1690 5482 1690 5481 1702 1701 5482 1673 1702 5458 5482 5458 1702 5461 1673 5458 5461 5458 5462 5480 5462 5458 5482 5480 5458 5481 5480 5482 5476 5479 5481 5481 5479 5480 5479 2470 5480 5480 2470 5462 5474 2468 5479 5479 2468 2470 5476 5474 5479 5476 5477 5472 5472 5474 5476 5472 5477 5494 5472 5473 5474 5494 5473 5472 5494 5495 5473 5474 5473 5475 5495 5475 5473 5501 2463 5495 5495 2463 5471 5495 5471 5475 5474 5475 5471 5471 2465 2466 5471 2466 5474 2463 2465 5471 2463 2464 2465 2465 2464 2466 2461 2462 2463 2463 2462 2464 5501 2461 2463 2466 2464 2467 2466 2467 2468 5474 2466 2468 4434 4435 4436 4435 4437 4436 4436 4437 4438 4436 5511 4434 4432 4433 4434 4434 4433 4435 4432 4434 5511 4456 4437 4435 4456 4435 4433 4438 4437 4456 4438 4456 4457 4433 4453 4456 4457 4456 4453 4432 4431 4433 4431 4453 4433 4430 4431 4432 5511 5513 4432 4432 5513 4430 5511 5512 5513 5512 5503 5513 5513 5503 5502 5513 5502 4430 2435 2436 4430 4430 2436 4431 4430 5502 2435 2436 4454 4431 4431 4454 4453 2435 2429 2436 2436 2429 4454 2430 2429 2435 2430 2435 5490 5490 2435 5502 2429 2430 2431 4454 2429 4468 2429 2431 4468 4453 4454 4455 4454 4468 4455 4455 4468 4469 4468 2431 4480 4468 4480 4469 2431 2430 2432 2431 2432 2433 2433 4480 2431 2433 2432 2434 2432 2430 5488 2434 2432 5491 5491 2432 5488 2433 2434 2425 4479 4478 2433 4479 2433 2425 4478 4480 2433 2425 2434 2426 2426 2434 5468 5468 2434 5491 5491 5488 5492 5468 5491 5465 5465 5491 5492 5468 5465 5466 5468 5466 5469 2426 5468 5469 2424 2425 2426 2428 2424 2426 2426 5469 2428 5469 5466 5467 5469 5467 5470 2428 5469 5470 5465 1684 5466 5466 1684 1683 5466 1683 5467 5467 1683 1682 5467 1682 5455 5470 5467 5455 5470 5455 5453 2428 5470 2423 2423 5470 5453 2423 2424 2428 2423 2421 2422 2422 2427 2423 2423 2427 2424 2423 5453 2421 5452 2421 5453 5452 5453 5454 5454 5453 5455 2419 2420 2421 2421 2420 2422 2419 2421 5452 2417 2419 5452 5456 2417 5452 5456 5452 5457 5457 5452 5454 5454 5455 1681 5457 5454 1694 1694 5454 1681 5437 5456 5457 5437 5457 1680 1680 5457 1694 1320 1680 1694 1320 1694 1681 1681 1682 1320 1681 5455 1682 1320 1682 1683 1320 1683 1684 1684 1705 1320 5465 1705 1684 1320 1705 1706 1706 1705 5465 5465 5492 1706 1320 1706 1695 1706 5492 1695 5492 5488 5485 5492 5485 1695 1320 1695 1696 1695 5485 1696 5483 5484 5485 5485 5484 1696 5483 5485 5487 5487 5485 5488 5487 5488 5489 5488 2430 5490 5488 5490 5489 5483 5487 5502 5502 5487 5489 5483 5502 5484 1696 5484 5486 5484 5502 5503 5484 5503 5486 1696 5486 1697 5486 5503 1625 5486 1625 1697 5512 1625 5503 5502 5489 5490 1320 1319 1321 1321 1322 1320 1320 1322 1323 1320 1323 1324 1325 1326 1320 1320 1326 1327 1320 1327 1328 1324 1342 1320 1320 1342 1343 1320 1343 1325 1320 1598 1599 1626 1627 1320 1599 1643 1320 1320 1643 1644 1320 1644 1626 1320 1679 1680 1691 1692 1320 1320 1692 1693 1693 1703 1320 1320 1703 1704 1320 1704 1679 1691 1320 1713 1713 1320 1627 1741 1742 1320 1320 1742 1743 1320 1743 1598 1777 1778 1320 1320 1778 1779 1320 1779 1741 1786 1777 1320 1786 1320 1302 1302 1320 1328 1778 5737 1779 1779 5737 5738 1779 5738 1741 5736 5733 5737 5737 5733 5732 5737 5732 5738 1778 5736 5737 5738 5732 5735 5738 5735 5739 1741 5738 5739 1741 5739 1742 1743 1742 5739 5746 1743 5739 5746 5739 5735 5732 2235 5735 5746 5735 5747 5747 5735 2235 1598 1743 5746 5746 5747 5756 1598 5746 5757 5746 5756 5757 5747 2235 2234 5747 2234 4868 5747 4868 5756 5756 4868 4870 5756 4870 5758 5757 5756 5758 5757 5758 5760 1598 5757 1599 1599 5757 5760 4870 4871 5758 5758 4871 4873 5758 4873 5759 5760 5758 5759 4868 4869 4870 4870 4869 4871 4871 4869 4872 4871 4872 4873 4873 4872 4874 4873 4874 4875 5759 4873 4875 5759 4875 5755 5760 5759 5761 5761 5759 5755 4875 4874 4876 5755 4875 4876 2241 5754 5755 5755 4876 2241 5761 5755 5762 5762 5755 5754 1584 5760 5761 1584 5761 1585 1585 5761 5762 5762 5754 5763 1585 5762 1587 1587 5762 5763 1584 1585 1586 1586 1585 1587 1584 1586 1599 1599 5760 1584 1599 1586 1643 1586 5831 1643 1643 5831 5832 1643 5832 1644 5830 5828 5831 5831 5828 5829 5831 5829 5832 1586 5830 5831 5829 5842 5832 5832 5842 1626 5832 1626 1644 2275 5829 4764 4764 5829 5828 2275 5841 5829 5829 5841 5842 5847 1626 5842 5847 5842 5848 5848 5842 5841 1627 1626 5847 5849 1627 5847 5849 5847 5846 5846 5847 5848 5848 5841 4711 5846 5848 4713 4713 5848 4711 2275 2277 5841 4711 5841 2277 2277 2278 4711 4711 2278 4712 4711 4712 4713 4713 4712 4714 4713 4714 4715 4713 4715 5846 2278 4743 4712 4712 4743 4742 4712 4742 4714 2277 2276 2278 2278 2276 4743 2275 2276 2277 2276 2275 4763 4743 2276 4768 2276 4763 4768 4742 4743 4744 4743 4768 4744 4744 4768 4769 4768 4763 4787 4768 4787 4769 4763 2275 4764 4763 4764 4765 4765 4787 4763 4769 4787 4779 4783 4779 4787 4783 4787 4765 4744 4769 4740 4740 4769 4770 4769 4779 4770 4739 4740 4741 4739 4744 4740 4740 4770 4741 4741 4770 4771 4770 4779 4771 4724 4739 4741 4724 4741 2348 2349 2348 4741 4741 4771 2349 4771 4779 4778 4771 4778 2349 2348 2349 2346 2346 2349 2350 2350 2349 4778 2346 4724 2348 2346 4723 4724 4723 4739 4724 4699 4722 4723 4699 4723 4700 4700 4723 2346 4722 4746 4723 4723 4746 4739 4698 4721 4722 4698 4722 4699 4721 4746 4722 4698 4699 4677 4698 4677 2282 2282 4721 4698 2282 2280 4721 2280 4720 4721 4721 4720 4746 2279 2280 2281 2281 2280 2282 2279 4720 2280 2279 4719 4720 4746 4720 4719 4717 4719 2279 4717 2279 5845 5859 5845 2279 5859 2279 2281 2281 2282 2283 2281 2283 5859 5858 5845 5859 5859 2283 5855 5859 5855 5858 2283 2282 2284 2283 2284 4655 4655 5855 2283 5854 5853 5855 5854 5855 4655 5858 5855 5853 5857 5845 5858 5858 5853 5857 5852 1660 5853 5852 5853 5854 5857 5853 1660 5851 5852 5854 5851 5854 4657 4657 5854 4655 4655 2284 4656 4655 4656 4657 4657 4656 4658 4657 4658 4659 4657 4659 5851 4661 5851 4659 4659 4658 4660 4659 4660 4661 4656 4675 4658 4658 4675 4678 4678 4660 4658 2284 4676 4656 4656 4676 4675 4675 4676 4677 4679 4678 4675 4679 4675 4672 4672 4675 4677 4663 4662 4678 4678 4662 4660 4663 4678 4679 4660 4662 4661 4661 4662 4663 4661 4663 2285 2285 4663 4664 4679 4664 4663 2285 2286 2287 2285 4664 2286 2286 4664 4665 4665 4664 4679 2287 2286 2288 2288 2286 4652 4652 2286 4665 4627 2287 2288 2288 4628 4627 4640 4628 2288 2288 4652 4640 4640 4652 4653 4652 4665 4653 4653 4665 4666 4665 4679 4666 4640 4653 4651 4651 4653 4654 4653 4666 4654 4628 4640 4641 4641 4640 4651 4627 4628 4629 4641 4629 4628 4627 4629 4630 4629 4631 4630 4631 4629 4641 4631 4641 4632 4632 4641 4642 4641 4651 4642 4630 4631 4632 4630 4632 4633 4633 4632 4634 4632 4642 4634 4634 4642 4637 4637 4642 4643 4642 4651 4647 4642 4647 4643 4637 4638 4634 4634 4638 4639 4634 4639 4633 4635 4636 4637 4637 4636 4638 4637 4643 4635 4635 4643 4644 4643 4647 4648 4643 4648 4644 2290 2289 4635 4635 2289 4636 4635 4644 2290 2289 5824 4636 4636 5824 5838 4636 5838 4638 4638 5838 4639 5820 5823 5824 5820 5824 5819 5819 5824 5818 5818 5824 2289 2289 2290 2291 5818 2289 2291 2291 2293 5818 5818 2293 5807 5818 5807 5819 5819 5807 5808 5819 5808 5820 5807 2293 4685 5808 5807 5809 5807 4685 5809 2291 2292 2293 2293 2292 2294 4685 2293 2294 2291 2290 2292 4644 4669 2292 4644 2292 2290 2294 2292 4681 4681 2292 4669 2294 4686 4685 4709 4686 2294 2294 4681 4709 4681 4669 4682 4709 4681 4682 4648 4669 4644 4648 4671 4669 4682 4669 4671 4682 4671 4683 4709 4682 4710 4710 4682 4683 4686 4709 4701 4701 4709 4710 4685 4686 4687 4701 4687 4686 4690 4701 4702 4690 4689 4701 4701 4689 4687 4701 4710 4702 4685 4687 4688 4687 4689 4688 5809 4685 4688 4688 4689 4690 4688 4690 4691 5809 4688 5811 4688 4691 5811 4691 4690 4692 4702 4692 4690 4692 4697 4691 5811 4691 4697 5811 4697 5812 5810 5809 5811 5810 5811 5813 5813 5811 5812 5808 5809 5810 1602 5808 5810 1602 5810 1600 1600 5810 5813 5813 5812 5814 1600 5813 1589 1589 5813 5814 1600 1601 1602 1600 1589 1601 1602 1601 1603 5820 5808 1602 5820 1602 1603 1603 1601 5823 1603 5823 5820 1591 1589 1616 1616 1589 1617 1589 5814 1617 2089 1591 1616 1616 1617 1618 2089 1616 2090 2090 1616 1618 1618 1617 1619 1617 5814 5796 1617 5796 1619 1618 1619 1620 2090 1618 2091 2091 1618 1620 2168 2089 2090 2168 2090 2169 2169 2090 2091 2167 2089 2168 1858 2167 2168 1858 2168 1856 1856 2168 2169 2169 2091 2170 1856 2169 1853 1853 2169 2170 2091 1620 2092 2170 2091 2092 2170 2092 2171 1853 2170 1851 1851 2170 2171 1851 1852 1853 1852 1854 1853 1853 1854 1855 1853 1855 1856 1842 1850 1851 1851 1850 1852 1851 2171 1842 1854 1852 2012 2012 1852 1850 2011 1855 1854 2011 1854 2012 1856 1855 1857 2010 1857 1855 2010 1855 2011 1271 2010 2011 1271 2011 1272 1272 2011 2012 2009 1859 2010 1859 1857 2010 1275 2009 2010 1275 2010 1271 1856 1857 1858 1857 1859 1858 1858 1859 1860 2009 1860 1859 1274 2009 1275 1270 1274 1275 1270 1275 1271 1270 1271 1267 1240 1270 1267 1267 1268 1264 1267 1271 1272 1267 1272 1268 1267 1264 1240 1264 1268 1269 1272 2012 1268 1268 2012 2013 1268 2013 1269 1264 1265 1261 1264 1269 1265 1240 1264 1261 1269 2013 2014 1269 2014 1265 2012 1850 2013 2013 1850 2014 1850 1849 2014 2014 1849 1841 2014 1841 1848 1848 2016 2014 1265 2014 2016 1261 1265 1266 1265 2016 1266 1848 2015 2016 1266 2016 2015 1843 1847 1848 1843 1848 1841 1847 2015 1848 1841 1842 1843 1841 1849 1842 1842 1849 1850 1842 2171 2172 1842 2172 1843 1846 1847 1843 1843 2172 2173 1843 2173 1846 1846 1845 1847 1847 1845 2015 1835 1845 1846 1846 2173 2174 1846 2174 1835 2172 2094 2173 2173 2094 2095 2173 2095 2174 2171 2093 2172 2172 2093 2094 2171 2092 2093 2092 1637 2093 2093 1637 1604 2093 1604 2094 1604 1747 2094 2094 1747 1759 2094 1759 2095 1604 1746 1747 1746 1759 1747 1746 1758 1759 2095 1759 1758 1604 1745 1746 1749 1758 1746 1746 1745 5740 5740 5729 1746 1746 5729 1749 1749 1757 1758 2095 1758 2096 2096 1758 1757 1748 1757 1749 2096 1757 2097 2097 1757 1748 2174 2095 2096 2174 2096 2175 2175 2096 2097 2097 1748 2098 2175 2097 2176 2176 2097 2098 1748 1749 1750 2098 1748 1750 2098 1750 2099 2176 2098 2177 2177 2098 2099 1833 2175 2176 1833 2176 1831 1831 2176 2177 1835 2174 2175 1835 2175 1833 1831 1832 1833 1833 1832 1834 1833 1834 1835 1838 1839 1831 1831 1839 1840 1831 1840 1832 1831 2177 1838 2018 1834 1832 2018 1832 1840 1834 1844 1835 1844 1834 2018 1835 1844 1845 2015 1845 1844 2015 1844 2017 2017 1844 2018 1266 2015 1262 1262 2015 2017 1262 2017 1263 1263 2017 2018 1261 1262 1258 1258 1262 1263 1261 1266 1262 1258 1263 1259 1263 2018 1259 1258 1259 1255 1258 1255 1252 1258 1252 1261 1255 1259 1260 1259 2018 2020 1259 2020 1260 1255 1256 1252 1255 1260 1256 1260 2020 2019 1260 2019 1256 1840 2019 2020 1840 2020 2018 1839 2019 1840 1839 1837 2019 2019 1837 1836 2019 1836 2021 1256 2019 2021 1252 1256 1257 1256 2021 1257 2021 1836 2022 1257 2021 2022 1824 1836 1825 1825 1836 1837 1836 1824 2022 1825 1837 1838 1838 1837 1839 1823 1824 1825 1838 2178 1825 1825 2178 2179 1825 2179 1823 1823 1822 1824 2022 1824 1822 1821 1822 1823 1823 2179 2180 1823 2180 1821 2178 2100 2179 2179 2100 2101 2179 2101 2180 2180 2101 2102 2180 2102 2181 1821 2180 2181 2100 1754 2101 2101 1754 1756 2101 1756 2102 2099 1752 2100 2100 1752 1754 2178 2099 2100 1752 1753 1754 1754 1753 1755 1754 1755 1756 1756 1755 1760 1756 1760 1761 2102 1756 1761 5718 5716 1755 1755 5716 1760 5723 5718 1755 1753 5723 1755 1761 1760 1762 5716 5713 1760 1760 5713 1762 1762 1765 1761 2102 1761 2103 2103 1761 1765 1762 1764 1765 2103 1765 2104 2104 1765 1764 2181 2102 2103 2181 2103 2182 2182 2103 2104 2104 1764 2105 2182 2104 2183 2183 2104 2105 1828 2181 2182 1828 2182 1815 1815 2182 2183 1821 2181 1828 1815 1827 1828 1828 1827 1829 1828 1829 1821 1813 1814 1815 1814 1826 1815 1815 1826 1827 1815 2183 1813 1829 1827 2023 2023 1827 1826 1821 1829 1830 1829 2023 1830 1821 1830 1822 2022 1822 1830 1830 2023 2024 1830 2024 2022 1257 2022 1253 1253 2022 2024 1253 2024 1254 1254 2024 2023 1252 1253 1249 1249 1253 1254 1252 1257 1253 1249 1254 1250 1254 2023 1250 1249 1250 1246 1261 1252 1249 1261 1249 1246 1246 1250 1251 1250 2023 2025 1250 2025 1251 1246 1247 1243 1246 1251 1247 1243 1261 1246 1240 1261 1243 1243 1244 1240 1243 1247 1248 1243 1248 1244 1251 2026 1247 1247 2026 2027 1247 2027 1248 1251 2025 2026 2025 1814 2026 1814 1812 2026 2026 1812 1820 2026 1820 2027 2027 1820 1819 2027 1819 2028 1248 2027 2028 1248 2028 1244 1819 1817 2028 2028 1817 1816 2028 1816 2029 1244 2028 2029 1818 1817 1819 1818 1819 1811 1811 1819 1820 1811 1820 1812 1811 1812 1813 1813 2184 1811 1811 2184 2185 1811 2185 1818 1810 1817 1818 1818 2185 2186 1818 2186 1810 1810 1816 1817 1808 1809 1810 1809 1816 1810 1810 2186 2187 1810 2187 1808 2185 2107 2186 2186 2107 2108 2186 2108 2187 2184 2106 2185 2185 2106 2107 2106 1773 2107 2107 1773 1775 2107 1775 2108 2108 1775 1777 2108 1777 2109 2187 2108 2109 2187 2109 2188 1808 2187 2188 1777 1784 2109 2109 1784 1796 2109 1796 2110 2188 2109 2110 2188 2110 2189 1808 2188 1806 1806 2188 2189 2110 1796 1795 2110 1795 2111 2189 2110 2111 1783 1795 1796 1783 1796 1784 1792 1795 1783 2111 1795 1792 2189 2111 2190 1806 2189 1993 1993 2189 2190 1993 1992 1994 1993 1994 1806 2032 1994 1992 2032 1992 2033 1806 1994 1995 2031 1995 1994 2031 1994 2032 1242 2031 2032 1242 2032 1238 1238 2032 2033 1238 2033 1239 1237 1238 1234 1234 1238 1239 1237 1242 1238 1237 1241 1242 1241 2031 1242 2030 1995 2031 1241 2030 2031 1240 1241 1237 1240 1245 1241 1245 2030 1241 2029 1809 2030 1809 1807 2030 2030 1807 1995 1245 2029 2030 1240 1244 1245 1244 2029 1245 2029 1816 1809 1808 1807 1809 1806 1807 1808 1806 1995 1807 1783 1784 1785 1783 1785 4962 1785 1784 1777 1785 1777 1786 1785 1786 4958 4962 1785 4958 4962 4958 4957 4945 4962 4957 4958 1786 4959 4958 4959 4960 4957 4958 4960 4959 1786 1302 4960 4959 4961 4969 4961 4959 4969 4959 4970 4970 4959 1302 4960 4961 3617 4957 4960 3615 3615 4960 3617 3617 4961 3225 3223 3225 4961 3223 4961 4969 3616 3615 3617 3616 3617 3226 3226 3617 3225 3614 3613 3615 3614 3615 3616 3615 3613 4957 3614 3616 3643 3648 3643 3616 3648 3616 3226 3225 3224 3226 3226 3224 3648 3223 3224 3225 3224 3223 3637 3652 3653 3224 3224 3637 3652 3648 3224 3653 3647 3643 3648 3648 3653 3647 3652 3657 3653 3647 3653 3657 3652 3637 3639 3652 3639 3651 3651 3656 3652 3652 3656 3657 3637 3223 3638 3637 3638 3639 3639 3638 3640 3639 3640 3636 3651 3639 3636 3223 4969 3638 3638 4969 4988 3638 4988 3640 3636 3640 3641 3640 4988 3641 3635 3634 3636 3636 3641 3635 3651 3636 3634 3632 3634 3635 3632 3633 3634 3634 3650 3651 3634 3633 3650 3630 3631 3632 3631 3633 3632 3650 3633 3631 3650 3631 3629 3629 3658 3650 3650 3658 3659 3650 3659 3651 3651 3659 3656 3628 3656 3659 3658 3625 3659 3659 3625 3626 3659 3626 3628 3658 3629 3222 3222 3624 3658 3658 3624 3625 3624 3606 3625 3625 3606 3607 3625 3607 3626 3626 3607 3608 3608 3628 3626 3608 3627 3628 3627 3656 3628 3607 3605 3608 3608 3605 3602 3608 3602 3609 3609 3627 3608 3606 3605 3607 3220 3589 3606 3606 3589 3605 3624 3220 3606 3222 3220 3624 3219 3220 3221 3221 3220 3222 3220 3219 3589 3589 3219 3582 3589 3582 3590 3605 3589 3590 3581 3582 3583 3583 3582 3584 3590 3582 3581 3582 5007 3584 3590 3581 3604 3590 3604 3605 3604 3581 3583 3583 3584 3585 3604 3583 3585 3585 3584 3586 3586 3584 5007 5007 5008 5010 5007 5010 3586 3585 3586 3587 3587 3586 3588 3586 5010 3588 3587 3603 3585 3585 3603 3604 3605 3604 3603 3605 3603 3602 3603 3580 3577 3587 3580 3603 3602 3603 3577 3587 3588 3333 3333 3580 3587 3333 3588 3332 5010 5011 3588 3588 5011 3332 3332 3331 3333 3331 3580 3333 3331 3577 3580 3330 3329 3331 3330 3331 3332 3548 3331 3329 3548 3577 3331 3330 3332 5019 5019 3332 5011 3328 3329 3330 5019 3328 3330 3328 3327 3329 3548 3329 3551 3551 3329 3327 3551 3550 3548 3548 3550 3577 3549 3550 3551 3551 3327 3557 3549 3551 3554 3554 3551 3557 3549 3578 3550 3550 3578 3579 3550 3579 3577 3602 3577 3579 3602 3579 3578 3609 3602 3578 3549 3553 3578 3578 3553 3552 3578 3552 3338 3609 3578 3338 3554 3553 3549 3552 3553 3554 3554 3555 3552 3338 3552 3555 3337 3338 3339 3556 3339 3338 3338 3555 3556 3338 3337 3609 3609 3337 3627 3337 3654 3627 3627 3654 3656 3654 3655 3656 3644 3655 3654 3644 3654 3337 3656 3655 3657 3646 3657 3655 3646 3655 3644 3335 3623 3644 3644 3623 3645 3644 3645 3646 3337 3335 3644 3646 3645 3647 3647 3657 3646 3647 3645 3643 3649 3643 3645 3649 3645 3622 3622 3645 3623 3592 3622 3623 3592 3623 3335 3595 3621 3622 3595 3622 3591 3591 3622 3592 3621 3649 3622 3591 3592 3593 3576 3593 3592 3576 3592 3334 3335 3334 3592 3595 3591 3596 3596 3591 3593 3594 3595 3596 3594 3621 3595 3594 3620 3621 3620 3649 3621 3600 3594 3599 3599 3594 3596 3600 3620 3594 3599 3596 3598 3598 3596 3597 3596 3593 3597 3598 3560 3599 3599 3560 3230 3599 3230 3600 3230 3228 3600 3600 3228 3620 3229 3228 3230 3229 3230 3560 3229 3560 3561 3561 3560 3562 3598 3562 3560 3227 3228 3229 4935 3229 3561 3227 3229 4935 3228 3227 3618 3228 3618 3620 3618 3227 3611 3227 4935 4945 3611 3227 4945 4935 3561 4937 4937 3561 3563 4937 3563 4939 3561 3562 3563 3562 3564 3563 3563 3564 3565 3563 3565 3566 3563 3566 4939 4939 3566 3572 4939 3572 4940 3566 3565 3567 3567 3572 3566 3565 3564 3598 3598 3597 3565 3565 3597 3567 3598 3564 3562 3570 3571 3567 3567 3571 3572 3570 3567 3597 3571 4940 3572 3570 3569 3571 3569 4940 3571 3569 4941 4940 4943 4940 4941 3568 3231 3569 3568 3569 3570 3231 4941 3569 3597 3601 3570 3570 3601 3568 3597 3593 3601 3573 3568 3601 3573 3601 3574 3574 3601 3593 3232 3231 3568 3232 3568 3573 3541 3232 3573 3541 3573 3542 3542 3573 3574 3542 3574 3536 3536 3574 3575 3574 3593 3575 3575 3593 3576 3536 3575 3534 3534 3575 3576 3534 3535 3536 3536 3535 3542 3539 3541 3542 3542 3535 3543 3542 3543 3539 3534 3350 3535 3535 3350 3352 3535 3352 3543 3537 3350 3534 3534 3576 3537 3537 3576 3334 3537 3336 3350 3537 3334 3336 3336 3349 3350 3350 3349 3351 3350 3351 3352 3334 3335 3336 3336 3335 3337 3337 3339 3336 3336 3339 3349 3556 3349 3339 3555 3349 3556 3554 3349 3555 3558 3351 3349 3558 3349 3554 3554 3557 3558 3558 3557 3533 3558 3533 3559 3559 3351 3558 3557 3327 3319 3557 3319 3533 3532 3530 3533 3321 3532 3533 3321 3533 3319 3559 3533 3530 3559 3530 3376 3376 3375 3559 3559 3375 3351 3529 3376 3530 3532 3529 3530 3352 3375 3376 3352 3376 3377 3377 3376 3378 3529 3378 3376 3351 3375 3352 3543 3352 3377 3377 3378 3379 3543 3377 3544 3544 3377 3379 3379 3378 3380 3528 3380 3378 3528 3378 3529 3379 3380 3381 3544 3379 3545 3545 3379 3381 3539 3543 3544 3539 3544 3546 3546 3544 3545 3545 3381 3520 3546 3545 3547 3547 3545 3520 3236 3539 3546 3236 3546 3241 3241 3546 3547 3547 3520 3519 3241 3547 3240 3240 3547 3519 3518 3519 3520 3525 3518 3520 3525 3520 3381 3238 3519 3250 3250 3519 3518 3240 3519 3238 3238 3239 3240 3240 3239 3237 3240 3237 3241 3241 3237 3236 3235 3236 3237 4964 3235 3237 4964 3237 4965 3239 4965 3237 3238 3251 3239 4968 4965 3239 3251 4968 3239 3250 3251 3238 3250 3249 3251 3251 3249 4980 4980 4981 3251 3251 4981 4968 4967 4966 4968 4968 4966 4965 4968 4981 4967 4964 4965 4966 4954 4964 4953 4953 4964 4956 4956 4964 4948 4948 4964 4966 4954 3235 4964 4941 4953 4956 4941 4956 4948 4953 4951 4954 3231 4951 4953 3231 4953 4941 4943 4941 4944 4941 4948 4944 4944 4948 4949 4948 4966 4949 4944 4949 4947 4966 4947 4949 1782 4943 4944 1782 4944 1297 1297 4944 1298 1298 4944 4947 1298 4947 1411 4966 1411 4947 1412 1411 4966 4967 1412 4966 1411 1412 1298 1298 1412 1413 1413 1412 4967 4967 4981 4982 4967 4982 1413 1298 1413 1442 1413 4982 1442 4979 1442 4982 4979 4982 4980 4980 4982 4981 1298 1442 1377 1377 1442 4979 4973 1377 4979 4973 4979 4976 4976 4979 4980 4976 4980 3245 4980 3249 3247 4980 3247 3245 3244 3243 3245 3244 3245 3246 3246 3245 3247 3245 3243 4976 3246 3247 3248 3248 3247 3249 3248 3249 3250 3250 3518 3248 3248 3518 3523 3248 3523 3246 3246 3523 3521 3246 3521 3244 3522 3521 3523 3522 3523 3524 3524 3523 3518 3524 3518 3525 3525 3368 3524 3524 3368 3366 3524 3366 3522 3381 3370 3525 3525 3370 3368 3367 3366 3368 3367 3368 3369 3369 3368 3370 3381 3382 3370 3370 3382 3383 3370 3383 3369 3381 3380 3382 3512 3383 3382 3512 3382 3507 3507 3382 3526 3526 3382 3380 3369 3383 3512 3506 3369 3512 3506 3512 3507 3516 3367 3369 3516 3369 3506 3506 3507 3508 3508 3510 3506 3506 3510 3513 3506 3513 3516 3508 3507 3526 3508 3509 3510 3508 3526 3509 3510 3509 3511 3527 3511 3509 3509 3526 3527 3510 3511 3505 3527 3505 3511 3505 3314 3510 3510 3314 3318 3510 3318 3513 3505 3312 3314 3312 3505 3527 3312 3313 3314 3314 3313 3315 3315 3318 3314 3315 3317 3318 3513 3318 3317 3316 3317 3315 5050 5065 3315 5050 3315 3313 3316 3315 5061 5061 3315 5065 3316 3311 3317 3513 3317 3514 3514 3317 3311 3310 3311 3316 3310 3316 5061 3310 5061 5062 5062 5061 5063 5061 5065 5063 3308 3309 3310 3310 3309 3311 3308 3310 5068 5068 3310 5062 5062 5063 5064 5068 5062 5069 5069 5062 5064 5064 5063 1425 5063 5065 5060 5063 5060 1425 5064 1425 1496 5069 5064 1459 1459 5064 1496 5071 5068 5069 5071 5069 1458 1458 5069 1459 1457 1458 1459 1457 1459 1427 1427 1459 1496 1427 1496 1425 1425 1426 1427 1427 1426 1460 5083 5073 1427 1427 5073 1457 1460 5083 1427 5073 5071 1457 1457 5071 1458 5070 5068 5071 5073 5070 5071 5072 5070 5073 5083 5072 5073 5082 5072 5083 5085 5082 5083 5085 5083 1460 3302 3304 5072 5072 3304 5070 5082 3302 5072 3304 3306 5070 5070 3306 5068 3306 3308 5068 3304 3305 3306 3306 3305 3307 3306 3307 3308 3302 3303 3304 3304 3303 3305 3307 3305 3487 3305 3303 3487 3308 3307 3309 3309 3307 3489 3489 3307 3487 3487 3303 3479 3487 3479 3488 3489 3487 3490 3490 3487 3488 3302 3301 3303 3303 3301 3479 3479 3301 3477 3479 3477 3480 3488 3479 3480 3488 3480 3362 3490 3488 3360 3360 3488 3362 3480 3477 3478 3480 3478 3343 3362 3480 3343 3301 3299 3477 3477 3299 3475 3477 3475 3478 3478 3475 3476 3478 3476 3342 3343 3478 3342 3475 3299 3297 3297 3468 3475 3475 3468 3465 3475 3465 3476 3342 3476 3345 3344 3342 3345 3340 3341 3342 3342 3341 3343 3340 3342 3344 3344 3474 3340 3474 3469 3340 3340 3469 3341 3364 3343 3341 3364 3341 3469 3364 3469 3470 3470 3469 3471 3474 3471 3469 3363 3343 3364 3470 3486 3364 3364 3486 3363 3363 3362 3343 3361 3362 3363 3486 3481 3363 3363 3481 3361 3485 3483 3486 3486 3483 3481 3470 3485 3486 3359 3361 3481 3359 3481 3482 3482 3481 3483 3359 3360 3361 3361 3360 3362 3357 3358 3359 3359 3358 3360 3502 3357 3359 3502 3359 3482 3482 3483 3484 3504 3502 3482 3504 3482 3484 3501 3357 3502 3503 3501 3502 3503 3502 3504 3256 3503 3504 3256 3504 3254 3254 3504 3484 3484 3483 3264 3484 3264 3252 3254 3484 3252 3252 3253 3254 3254 3253 3255 3254 3255 3256 3264 3265 3252 3252 3265 3253 3262 3264 3485 3485 3264 3483 3472 3262 3485 3472 3485 3470 3470 3471 3472 4994 3255 3253 4994 3253 4995 3265 4995 3253 4993 3255 4994 4996 4993 4994 4996 4994 4997 4997 4994 4995 4992 3257 4993 4993 3257 3255 4991 4992 4993 4991 4993 4996 4997 1414 4996 4996 1414 1444 4996 1444 4991 4991 4972 4971 4971 4992 4991 4991 1444 4974 4991 4974 4972 1298 1443 1444 1298 1444 1414 1444 1443 4974 1378 4972 4974 1378 4974 1443 4971 4972 4973 4973 4972 1378 4971 4973 4975 4971 4975 4992 4975 4973 4976 1378 1377 4973 1298 1377 1378 1378 1443 1298 4975 4976 4977 4976 3243 4978 4976 4978 4977 4992 4975 4977 4992 4977 4978 4978 3259 4992 4992 3259 3257 4978 3243 3259 3242 3243 3244 3242 3259 3243 3258 3257 3259 3258 3259 3242 3256 3255 3257 3256 3257 3258 3258 3242 3497 3497 3499 3258 3258 3499 3503 3258 3503 3256 3244 3497 3242 3244 3521 3497 3497 3498 3499 3521 3498 3497 3494 3500 3521 3521 3500 3498 3494 3521 3522 3499 3498 3500 3499 3500 3494 3494 3495 3496 3494 3496 3499 3522 3495 3494 3522 3366 3493 3522 3493 3495 3496 3495 3493 3493 3353 3496 3496 3353 3355 3496 3355 3501 3499 3496 3501 3493 3365 3353 3366 3365 3493 3354 3365 3366 3354 3366 3367 3353 3365 3354 3353 3354 3355 3355 3354 3356 3355 3356 3357 3501 3355 3357 3499 3501 3503 3357 3356 3358 3358 3356 3492 3492 3356 3354 3492 3354 3517 3517 3354 3367 3517 3367 3516 3516 3514 3517 3517 3514 3515 3517 3515 3492 3516 3513 3514 3514 3311 3515 3515 3311 3491 3515 3491 3492 3311 3309 3491 3491 3309 3489 3491 3489 3492 3492 3489 3490 3492 3490 3358 3358 3490 3360 3467 3465 3468 3295 3467 3468 3295 3468 3297 3296 3295 3297 3296 3297 3298 3298 3297 3299 3298 3299 3300 3298 3300 5084 3300 3299 3301 3300 3301 3302 3300 3302 5082 5084 3300 5082 5084 5082 5085 1452 5085 1460 1460 1426 1461 1460 1461 1452 1461 1426 5060 1425 5060 1426 1452 1461 1462 1462 1461 5045 1461 5060 5045 5045 5060 5065 5049 1462 5045 5049 5045 5050 5045 5065 5050 1452 1462 1463 5048 1463 1462 5048 1462 5049 5050 5051 5049 5049 5051 5052 5049 5052 5048 5050 3313 5051 5051 3313 3324 5051 3324 5052 5048 5052 5053 5052 3324 3322 5052 3322 5053 5047 1463 5048 5048 5053 5047 5047 5053 5038 5053 3322 3320 5053 3320 5038 3321 3320 3322 3321 3322 3323 3323 3322 3324 3323 3324 3325 3325 3324 3313 3325 3313 3312 3312 3527 3325 3325 3527 3531 3325 3531 3323 3323 3531 3532 3323 3532 3321 3319 3320 3321 3320 3319 3326 3326 3319 3327 3326 3327 3328 3320 3326 5037 3326 3328 5037 5019 5042 3328 5037 3328 5042 3320 5037 5038 5038 5037 5039 5037 5042 5039 5038 5039 5040 5047 5038 5046 5046 5038 5040 5040 5039 1450 5039 5042 5041 5039 5041 1450 5040 1450 1498 5046 5040 1498 5046 1498 1497 5046 1497 5047 5047 1497 1463 1463 1497 1452 1452 1497 1498 1452 1498 1450 1450 1451 1452 1450 5041 1451 5024 1451 5041 5023 5009 5024 5024 5009 1338 5041 5023 5024 5022 5009 5023 5041 5022 5023 5008 1338 5009 5008 5009 5010 5010 5009 5011 5022 5011 5009 5021 5011 5022 5042 5021 5022 5042 5022 5041 5019 5011 5020 5020 5011 5021 5020 5021 5042 5020 5042 5019 3531 3529 3532 3527 3528 3531 3531 3528 3529 3527 3526 3528 3526 3380 3528 1297 1803 1804 1297 1804 1782 2125 1804 1803 1803 2126 2127 1803 2127 2125 1782 1804 1805 2124 1805 1804 2124 1804 2125 2203 2124 2125 2203 2125 2204 2204 2125 2127 2204 2127 2205 2205 2127 2126 1958 2203 2204 1958 2204 1956 1956 2204 2205 2205 2126 2206 1956 2205 1953 1953 2205 2206 2206 2126 2128 2206 2128 2207 1953 2206 1951 1951 2206 2207 2126 1421 2128 2128 1421 1448 2128 1448 2129 2207 2128 2129 2207 2129 2208 1951 2207 1948 1948 2207 2208 2129 1448 1481 2129 1481 2130 2208 2129 2130 2208 2130 2209 1948 2208 1946 1946 2208 2209 2130 1481 1479 2130 1479 2131 2209 2130 2131 1480 1479 1481 1480 1481 1482 1482 1481 1448 1345 1478 1479 1345 1479 1480 2131 1479 1478 2209 2131 2210 1937 2209 2210 1937 2210 1938 1946 2209 1937 5028 1480 1482 5044 1345 1480 1480 5028 5044 5028 1482 5026 5044 5028 5026 5044 5026 5043 5025 5026 5027 5026 1482 5027 5043 5026 5025 5032 5043 5029 5043 5025 5029 5025 5027 5029 5027 1482 1483 5027 1483 5033 5029 5027 5031 5031 5027 5033 5031 5032 5029 5031 5030 5032 5033 1483 1447 5033 1447 5034 1482 1448 1483 1483 1448 1447 1421 1447 1448 3231 3232 3233 3233 4951 3231 3233 3232 3234 3538 3234 3232 3538 3232 3540 3540 3232 3541 3233 3234 3235 3235 3234 3236 3234 3538 3539 3234 3539 3236 3538 3540 3539 3539 3540 3541 4963 3233 3235 4954 4963 3235 4952 3233 4963 4952 4963 4955 4955 4963 4954 4954 4951 4952 4954 4952 4955 4951 4950 4952 4950 3233 4952 3233 4950 4951 4945 4957 3611 3611 4957 3613 3610 3611 3612 3612 3611 3613 3618 3611 3619 3619 3611 3610 3612 3613 3614 3610 3612 3642 3612 3614 3642 3610 3642 3619 3619 3642 3649 3619 3649 3618 3620 3618 3649 3642 3643 3649 3642 3614 3643 3221 3222 3629 3221 3629 3630 3630 3629 3631 4990 4988 4969 4990 4969 4970 1359 4990 4970 4970 1302 1401 1359 4970 1401 1357 1358 1359 1359 1358 1360 1359 1360 1361 1401 1357 1359 1302 1357 1401 1302 1400 1357 1400 5212 1357 1357 5212 5198 1357 5198 1358 5198 5195 1358 1358 5195 1360 1361 1360 5195 5184 1361 5185 1361 5195 5185 5185 5195 5196 5198 5196 5195 5197 5196 5198 5212 5197 5198 5185 5196 5186 5186 5196 3018 5197 3018 5196 5185 5186 5187 5185 5187 5184 5184 5187 5188 5186 3031 5187 5187 3031 3029 5187 3029 5188 5186 3022 3031 5186 3018 3022 3030 3029 3031 3030 3031 3021 3021 3031 3022 3028 3027 3029 3028 3029 3030 5188 3029 3027 3727 3030 3021 3028 3030 3729 3729 3030 3727 3021 3022 3023 3021 3023 3717 3021 3717 3727 3023 3022 3018 3023 3018 3024 3023 3024 3715 3717 3023 3715 3717 3715 3718 3727 3717 3718 3715 3024 3714 3715 3714 3716 3718 3715 3716 3718 3716 3122 3727 3718 3728 3728 3718 3122 3716 3714 3713 3716 3713 3123 3122 3716 3123 3679 3713 3714 3679 3714 3680 3680 3714 3024 3691 3118 3713 3691 3713 3692 3692 3713 3679 3123 3713 3118 3120 3122 3123 3120 3123 3118 3118 3119 3120 3119 3118 3691 3682 3119 3691 3682 3691 3692 3693 3682 3692 3693 3692 3679 3682 3683 3684 3684 3119 3682 3694 3683 3682 3694 3682 3693 3120 3119 3712 3712 3119 3684 3684 3683 3685 3712 3684 3711 3711 3684 3685 3120 3712 3721 3721 3712 3722 3711 3722 3712 3686 3710 3711 3711 3685 3686 3710 3726 3711 3726 3722 3711 3685 3683 3686 3686 3683 3687 3686 3687 3688 3688 3709 3686 3686 3709 3710 3709 3726 3710 3688 3012 3709 3012 3696 3709 3709 3696 3726 3013 3688 3673 3673 3688 3687 3013 3012 3688 3673 3687 3695 3695 3687 3683 3013 3673 3015 3015 3673 3674 3695 3674 3673 3012 3013 3014 3014 3013 3015 3696 3012 3014 3014 3015 3016 3700 3696 3014 3700 3014 3698 3698 3014 3016 3698 3699 3700 5227 3699 3698 5227 3698 3016 3700 3699 3701 5232 3701 3699 5232 3699 5227 3016 5223 5227 5233 5232 5227 5233 5227 5234 5234 5227 5223 5230 3703 5232 3703 3701 5232 5231 5230 5232 5231 5232 5233 3700 3701 3702 3702 3701 3703 3702 3703 3697 5230 3697 3703 5229 5228 5230 5228 3697 5230 5229 5230 5231 1535 5229 5231 1535 5231 1464 1464 5231 5233 5247 5228 5229 5247 5229 1534 1534 5229 1535 5228 3006 3697 5245 3006 5228 5245 5228 5247 5246 5245 5247 5246 5247 5248 5248 5247 1534 1533 1534 1397 1397 1534 1535 5248 1534 1533 1397 1535 1464 1396 1397 1398 1397 1464 1398 1530 1531 1397 1397 1531 1532 1397 1532 1533 1530 1397 1526 1526 1397 1551 1397 1396 5281 5283 1551 1397 5283 1397 5284 5284 1397 5281 5248 1533 1532 5248 1532 5255 5255 1532 1531 5255 5246 5248 5255 1531 5256 5256 5254 5255 5255 5254 5246 3003 5245 5246 5254 3003 5246 5256 5260 5254 5260 2999 5254 5254 2999 3001 5254 3001 3003 5257 5259 5260 5257 5260 5256 5259 2997 5260 5260 2997 2999 2997 2998 2999 2999 2998 3000 2999 3000 3001 3001 3000 3002 3001 3002 3003 3000 2998 3744 3002 3000 3752 3752 3000 3744 2997 2987 2998 2998 2987 3744 2988 2987 2997 5259 2988 2997 2987 2988 2989 3744 2987 3751 2989 3751 2987 2989 2988 2990 5258 2988 5259 2990 2988 5268 5268 2988 5258 2989 2990 2991 2991 2990 2992 5268 2992 2990 2991 2992 2993 2989 2991 3762 3762 2991 2993 2993 2992 2994 5268 2994 2992 2993 2994 2995 3762 2993 3763 3763 2993 2995 3762 3765 3764 3762 3764 2989 3765 3746 3745 3765 3745 3764 3746 3765 3748 3745 3746 3747 3747 3746 3132 3132 3746 3748 3745 3747 3749 3764 3745 3749 3749 3747 3744 3753 3744 3747 3753 3747 3127 3127 3747 3132 3749 3744 3750 3764 3749 3750 3744 3751 3750 3752 3744 3753 3735 3752 3753 3735 3753 3129 3129 3753 3127 3127 3128 3129 3129 3128 3130 3129 3130 3124 3736 3735 3129 3736 3129 3124 3733 3735 3736 3733 3752 3735 3733 3002 3752 3010 3004 3733 3736 3734 3733 3733 3734 3737 3733 3737 3010 3004 3002 3733 3124 3121 3736 3736 3121 3734 3734 3121 3120 3120 3721 3734 3734 3721 3723 3734 3723 3737 3121 3122 3120 3124 3125 3121 3121 3125 3126 3121 3126 3122 3728 3122 3126 3125 3728 3126 3124 3131 3125 3730 3728 3125 3131 3730 3125 3124 3130 3131 3732 3730 3131 3130 3732 3131 3729 3727 3730 3730 3727 3728 3732 3729 3730 3731 3729 3732 3739 3731 3732 3739 3732 3130 3128 3739 3130 3026 3028 3731 3731 3028 3729 3026 3027 3028 3725 3009 3737 3737 3723 3724 3737 3724 3725 3010 3737 3009 3721 3722 3723 3723 3722 3724 3724 3722 3720 3724 3720 3725 3726 3720 3722 3706 3705 3720 3725 3720 3705 3719 3706 3720 3719 3720 3726 3704 3719 3726 3704 3726 3696 3708 3707 3719 3708 3719 3704 3707 3706 3719 3705 3706 3702 3702 3706 3707 3702 3008 3705 3725 3705 3008 3702 3707 3700 3697 3005 3702 3702 3005 3008 3700 3707 3708 3700 3708 3704 3704 3696 3700 3008 3005 3009 3008 3009 3725 3005 3006 3007 3009 3005 3007 3697 3006 3005 3009 3007 3010 3007 3011 3010 3011 3007 5245 3007 3006 5245 3010 3011 3003 3010 3003 3004 3011 5245 3003 3003 3002 3004 3764 3750 3751 2989 3764 3751 2994 2996 2995 2995 2996 2985 2995 2985 2986 3763 2995 2986 5274 2996 2994 5274 2994 5268 5273 2985 2996 5273 2996 5274 5271 5273 5274 5271 5274 5270 5270 5274 5268 5270 5268 5269 5269 5268 5258 5269 1529 5270 5270 1529 1527 5270 1527 5271 5271 1527 5267 5271 5267 5272 5272 5273 5271 5272 2985 5273 2983 2985 5272 5288 2983 5272 5288 5272 5267 1527 1525 5267 5282 5288 5267 5282 5267 1525 5283 5287 5288 5283 5288 5282 5287 2983 5288 1525 1524 5282 5282 1524 1551 5282 1551 5283 1524 1525 1526 1526 1525 1527 1526 1551 1524 1526 1527 1528 1530 1526 5253 5253 1526 1528 1528 1527 1529 5253 1528 5269 5269 1528 1529 5257 1530 5253 5257 5253 5258 5269 5258 5253 5256 1531 1530 5256 1530 5257 5258 5259 5257 5284 5287 5283 5284 5281 5285 5285 5286 5284 5284 5286 5287 5286 2981 5287 5287 2981 2983 5285 2979 5286 5286 2979 2981 2977 2979 5285 5306 2977 5285 5306 5285 5281 5300 5306 5281 5300 5281 1396 5301 5305 5306 5301 5306 5300 5305 2977 5306 1396 1503 5300 5300 1503 1502 5300 1502 5301 1398 1503 1396 1398 1502 1503 1470 1502 1398 5301 1502 1470 5301 1470 5302 5302 5305 5301 5302 5304 5305 5304 2975 5305 5305 2975 2977 5302 1470 5299 5302 5299 5303 5303 5304 5302 1398 1469 1470 1470 1469 5299 5314 5320 5299 5314 5299 1469 5320 5303 5299 5303 2973 5304 2971 2973 5303 5320 2971 5303 5304 2973 2975 2971 2972 2973 2973 2972 2974 2973 2974 2975 2969 2970 2971 2971 2970 2972 5319 2969 2971 5319 2971 5320 5315 5319 5320 5315 5320 5314 5316 5318 5319 5316 5319 5315 5318 2969 5319 2967 2968 2969 2969 2968 2970 5318 2967 2969 3802 2970 2968 2967 2966 2968 2968 2966 3802 2965 2966 2967 5317 2967 5318 2965 2967 5328 5328 2967 5317 5317 5318 5316 5316 5313 5317 5328 5317 5329 5329 5317 5330 5330 5317 5331 5331 5317 5313 5329 5341 5328 5328 5341 2963 5328 2963 2965 5329 5330 5341 5341 5330 5331 5331 5313 5332 5341 5331 5340 5340 5331 5332 5342 2963 5341 5342 5341 5343 5343 5341 5340 5333 1474 5340 5340 5332 5333 5343 5340 1472 1472 5340 1474 5332 5313 5333 5333 5313 1485 5333 1485 1484 1484 1474 5333 1473 1472 1474 1473 1474 1475 1474 1484 1475 1471 1472 1473 1471 5343 1472 1473 1509 1471 1471 1509 5334 5334 5343 1471 1473 1508 1509 5334 1509 1508 5334 1508 5335 5337 5334 5335 5337 5342 5334 5334 5342 5343 1507 1508 1473 5335 1508 1507 5335 1507 5336 5337 5335 5338 5338 5335 5336 2959 5337 5338 2959 2961 5337 5337 2961 5342 2961 2963 5342 2959 2960 2961 2961 2960 2962 2961 2962 2963 2957 2958 2959 2959 2958 2960 2959 5338 2957 5338 5336 5339 2957 5338 5339 2955 2956 2957 2957 2956 2958 2957 5339 2955 2958 2956 3841 2960 2958 3828 3828 2958 3841 3828 2962 2960 2963 2962 2964 3828 3827 2962 3826 3827 3828 3828 3841 3826 3841 2956 3839 3841 3839 3842 3826 3841 3842 3838 3837 3839 3838 3839 3840 3840 3839 2956 3842 3839 3837 3842 3837 3174 3171 3173 3837 3171 3837 3838 3174 3837 3173 3840 3854 3838 3838 3854 3855 3838 3855 3171 3840 2956 2954 2954 2952 3840 3840 2952 3854 2952 2950 3854 3854 2950 3852 3854 3852 3855 3855 3852 3850 3855 3850 3160 3171 3855 3160 3851 3850 3852 3851 3852 3853 3853 3852 2950 3189 3161 3850 3189 3850 3851 3160 3850 3161 3159 3160 3161 3159 3170 3160 3160 3170 3171 3189 3190 3161 3161 3190 3191 3161 3191 3159 3857 3846 3159 3159 3846 3170 3191 3857 3159 3171 3170 3172 3845 3172 3170 3845 3170 3846 3171 3172 3173 3173 3172 3174 3848 3845 3846 3848 3846 3849 3857 3849 3846 3856 3080 3849 3856 3849 3857 3093 3092 3856 3092 3080 3856 3858 3093 3856 3858 3856 3859 3859 3856 3857 3091 3080 3092 3091 3092 3090 3090 3092 3093 3090 3093 3088 3088 3093 3858 3860 3088 3858 3860 3858 3861 3861 3858 3859 3086 3087 3088 3088 3087 3089 3088 3089 3090 3086 3088 3860 3872 3086 3860 3872 3860 3873 3873 3860 3861 3861 3859 3190 3873 3861 3188 3188 3861 3190 3875 3872 3873 3875 3873 3186 3186 3873 3188 3187 3186 3188 3187 3188 3189 3189 3188 3190 3190 3859 3191 3859 3857 3191 3851 3871 3189 3189 3871 3187 3853 3870 3851 3851 3870 3871 3870 3862 3871 3871 3862 3865 3871 3865 3187 2946 2944 3870 3870 2944 3862 3853 2946 3870 3853 2950 2948 2948 2946 3853 2945 2944 2946 2945 2946 2947 2947 2946 2948 2943 2942 2944 2943 2944 2945 2944 2942 3862 2943 2945 5307 2947 5307 2945 2947 2948 2949 5312 5307 2947 5312 2947 2949 2949 2948 2950 2949 2950 2951 5312 2949 5324 5324 2949 2951 5311 5310 5312 5312 5310 5307 5311 5312 5324 5311 5324 5323 5323 5324 5325 5324 2951 5325 2951 2950 2952 2951 2952 2953 5325 2951 2953 5323 5325 5322 5322 5325 5326 5325 2953 5326 2953 2952 2954 2953 2954 2955 2955 5326 2953 5322 5326 5321 5321 5326 5327 5339 5327 5326 2955 5339 5326 2955 2954 2956 5339 5336 5327 5321 5327 1513 5336 1513 5327 1513 1505 5321 5321 1505 1504 5321 1504 5322 1473 1505 1513 1473 1513 1507 5336 1507 1513 1504 1505 1506 1506 1505 1473 1506 1555 1504 5322 1504 1555 1553 1552 1506 1506 1552 1555 1553 1506 5249 1473 5249 1506 1475 5244 1473 5244 5249 1473 1553 5249 5250 5250 5249 5251 5244 5251 5249 5243 5240 5244 1475 5243 5244 5240 5251 5244 1475 1484 1485 1475 1485 1398 1398 5243 1475 5242 5237 5243 5243 5237 5240 1398 5242 5243 5237 2918 5240 2918 2917 5240 5240 2917 5251 2917 2918 2916 2916 2918 2919 2919 2918 3925 5237 3925 2918 2916 2915 2917 5252 5251 2917 5252 2917 2915 2914 2915 2916 2915 2914 2922 2915 2922 5252 5250 5251 5252 5252 2922 5265 5252 5265 5250 2922 2914 2923 2922 2923 2924 2922 2924 5265 5265 2924 5263 5265 5263 5266 5250 5265 5266 5250 5266 1553 5266 5263 5261 5266 5261 1554 1553 5266 1554 5262 5261 5263 5262 5263 5264 5264 5263 2924 1574 1573 5261 1574 5261 5262 1554 5261 1573 5264 5279 5262 5262 5279 5280 5262 5280 1574 5264 2924 2926 2926 2928 5264 5264 2928 5279 2928 2930 5279 5279 2930 5277 5279 5277 5280 5280 5277 5275 5280 5275 1576 1574 5280 1576 5276 5275 5277 5276 5277 5278 5278 5277 2930 1579 1577 5275 1579 5275 5276 1576 5275 1577 1574 1576 1572 1572 1576 1577 1572 1577 1578 1578 1577 1579 5276 5298 1579 1579 5298 1578 5278 5297 5276 5276 5297 5298 5297 5293 5298 5298 5293 5290 5298 5290 1578 1578 5290 1572 5289 1572 5290 5293 5294 5290 5290 5294 5295 5290 5295 5289 1570 1572 5289 5295 5309 5289 5289 5309 1571 5289 1571 1570 5294 5309 5295 5293 5292 5294 5292 5308 5294 5294 5308 5309 5310 1571 5309 5310 5309 5307 5307 5309 5308 1554 1570 1571 1571 1575 1554 1575 1571 5310 1570 1554 1572 1552 1553 1554 1572 1554 1573 1554 1575 1552 1552 1575 5311 5311 1575 5310 5323 1555 1552 5323 1552 5311 5322 1555 5323 1572 1573 1574 5292 5291 5308 5308 5291 5296 5307 5308 2941 2941 5308 5296 5291 5292 5293 5291 5293 5296 5296 5293 2937 5296 2937 2935 2941 5296 2935 2935 2934 2941 2941 2934 2942 2941 2942 2943 2943 5307 2941 2934 2935 2936 2936 2935 2937 2942 2934 3862 3862 2934 3869 3869 2934 2936 2937 2940 2936 3869 2936 3879 3879 2936 2940 3862 3869 3868 3879 3868 3869 3867 3865 3862 3867 3862 3868 3879 3867 3868 3863 3867 3879 3879 2940 3880 3863 3879 3878 3878 3879 3880 2937 2939 2940 3880 2940 2939 3880 2939 3881 3878 3880 3883 3883 3880 3881 2938 2933 2939 2938 2939 2937 3881 2939 2933 2938 2937 5297 5297 2937 5293 2932 2933 2938 2932 2938 5278 5278 2938 5297 2932 2931 2933 3881 2933 3882 2931 3882 2933 2930 2931 2932 5278 2930 2932 2930 2929 2931 2929 3901 2931 2931 3901 3882 3884 3881 3882 3884 3882 3885 3885 3882 3886 3901 3886 3882 3900 3899 3901 3901 3899 3886 2929 3900 3901 3885 3886 3150 3899 3150 3886 3150 3175 3885 3885 3175 3177 3885 3177 3884 3150 3151 3152 3150 3152 3175 3899 3151 3150 3898 3151 3899 3900 3898 3899 3152 3151 3162 3162 3151 3163 3898 3163 3151 3175 3152 3176 3176 3152 3902 3162 3902 3152 3175 3176 3177 3177 3176 3178 3889 3178 3176 3889 3176 3890 3176 3902 3890 3890 3902 3903 3905 3903 3902 3905 3902 3162 3892 3889 3890 3892 3890 3893 3890 3903 3893 3888 3178 3889 3891 3888 3889 3891 3889 3892 3106 3891 3892 3106 3892 3104 3104 3892 3893 3104 3893 3102 3893 3903 3112 3893 3112 3102 3102 3103 3104 3104 3103 3105 3104 3105 3106 3106 3105 3107 3106 3107 3101 3101 3891 3106 3105 3103 5166 3107 3105 5164 5164 3105 5166 3102 3113 3103 5166 3103 5167 5167 3103 3113 3112 3113 3102 3112 3111 3113 5167 3113 5180 5180 3113 3111 5166 5167 5168 5168 5167 5169 5179 5169 5167 5179 5167 5180 5179 5180 5178 5178 5180 5181 5180 3111 5181 5178 1568 5179 5179 1568 5169 5168 5169 1567 1567 5169 1568 1302 1567 1568 1302 1568 1569 5178 1569 1568 5177 1569 5178 5178 5181 5177 5177 5181 5182 5181 3111 3109 5181 3109 5182 5176 1520 5177 5177 1520 1569 5177 5182 5176 1302 1569 1520 1302 1520 1521 5176 1521 1520 5182 5193 5176 5176 5193 5194 5176 5194 1521 3109 3117 5182 5182 3117 5193 3117 3115 5193 5193 3115 5189 5193 5189 5194 5194 5189 5191 5194 5191 1543 1521 5194 1543 1302 1521 1543 1302 1543 1522 1543 5191 1522 5189 5190 5191 5191 5190 5192 5191 5192 1522 3115 2900 5189 5189 2900 5190 2900 2899 5190 5190 2899 5199 5190 5199 5192 1522 5192 1523 5192 1544 1523 5192 5199 5201 5192 5201 1544 1302 1522 1523 1523 1544 1302 1302 1544 1545 1544 5201 1545 5199 5200 5201 5201 5200 5202 5201 5202 1545 2899 2904 5199 5199 2904 5200 5200 2904 3954 5202 5200 5215 5200 3954 5215 1545 5202 1394 1394 5202 5216 5202 5215 5216 1302 1545 1394 1394 1395 1302 1394 5216 1395 5216 5215 5217 5216 5217 5219 1395 5216 5219 5215 3954 3956 5215 3956 5217 3956 3957 5217 5217 3957 3959 5217 3959 5218 5219 5217 5218 5219 5218 5220 1395 5219 1432 1432 5219 5220 5218 3959 3960 5218 3960 5214 5220 5218 5214 3957 3958 3959 3958 3961 3959 3959 3961 3960 3960 3961 3962 5214 3960 3962 2909 5213 5214 5214 3962 2909 5220 5214 5221 5221 5214 5213 3962 3961 2911 3962 2911 2909 2908 2909 2910 2910 2909 2911 2909 2908 5225 2909 5225 5213 5221 5213 5222 5213 5225 5226 5213 5226 5222 5226 5225 5235 3924 5235 5225 3924 5225 2908 2910 3924 2908 2910 3923 3924 3923 5235 3924 3923 5239 5235 5226 5235 5236 5236 5235 5239 5222 5226 1540 1540 5226 5236 5236 5239 5241 1540 5236 1500 1500 5236 5241 3929 5238 5239 3929 5239 3923 5241 5239 5238 3922 3923 2910 3922 3929 3923 3922 3928 3929 3928 5238 3929 3928 5237 5238 5241 5238 5242 5242 5238 5237 3927 3926 3928 3927 3928 3922 3926 5237 3928 3926 3925 5237 3925 3926 3927 3925 3927 2919 2919 3927 3930 3922 3933 3927 3927 3933 3934 3927 3934 3930 2916 2919 2920 2920 2919 2921 2919 3930 2921 2921 3930 3941 3941 3930 3973 3930 3934 3973 3934 3933 3970 3973 3934 3970 3922 3932 3933 3933 3932 3970 3931 3932 3922 3931 3922 3935 3935 3922 2910 3970 3932 3931 3970 3931 3935 3970 3935 3971 3973 3970 3974 3974 3970 3971 3935 2910 2912 3971 3935 2912 2910 2911 2912 2912 2911 2913 3971 2912 3972 2912 2913 3972 3974 3971 3977 3977 3971 3972 3972 2913 3986 3972 3986 3977 2911 3966 2913 2913 3966 3986 3961 3965 2911 2911 3965 3966 3983 3966 3965 3986 3966 3983 3986 3983 3987 3987 3977 3986 3965 3982 3983 3983 3982 3981 3983 3981 3985 3987 3983 3985 3961 3964 3965 3965 3964 3982 3963 3964 3961 3958 3963 3961 3982 3964 3963 3967 3981 3982 3982 3963 3967 3968 3980 3981 3968 3981 3967 3985 3981 3980 3967 3963 3958 3967 3958 3968 3957 3955 3958 3968 3958 3955 3968 3955 3969 3969 3980 3968 3980 3944 3946 3969 3944 3980 3985 3980 3979 3979 3980 3946 3969 3955 2906 3969 2906 2907 2907 3944 3969 3944 2907 2905 3947 3946 3944 3944 2905 3947 3945 3946 3947 3979 3946 3945 3947 2905 2903 3947 2903 3950 3945 3947 3948 3948 3947 3950 2904 2903 2905 2904 2905 2906 2906 2905 2907 2899 2902 2903 2899 2903 2904 3950 2903 2902 3950 2902 3951 3948 3950 3952 3952 3950 3951 2901 2902 2899 2902 2901 3920 3951 2902 3920 2899 2900 2901 2901 2900 3114 2901 3114 3920 3920 3114 3918 3920 3918 3921 3951 3920 3921 3952 3951 3953 3953 3951 3921 3921 3918 3919 3921 3919 3157 3953 3921 3157 3114 3116 3918 3918 3116 3917 3918 3917 3919 3114 2900 3115 3114 3115 3116 3116 3115 3117 3116 3117 3108 3906 3917 3116 3906 3116 3108 3907 3916 3917 3907 3917 3906 3919 3917 3916 3108 3110 3906 3906 3110 3904 3906 3904 3907 3108 3109 3110 3108 3117 3109 3110 3109 3111 3110 3111 3112 3110 3112 3904 3904 3112 3903 3904 3903 3905 3907 3904 3905 3907 3905 3164 3164 3905 3162 3162 3163 3164 3164 3163 3165 3164 3165 3153 3164 3153 3916 3164 3916 3907 3894 3165 3163 3894 3163 3898 3153 3165 3166 3166 3165 3894 3153 3154 3155 3153 3166 3154 3155 3916 3153 3919 3916 3155 3155 3154 3156 3155 3156 3157 3157 3919 3155 3912 3156 3154 3912 3154 3913 3913 3154 3166 3894 3895 3166 3913 3166 3895 3914 3912 3913 3914 3913 3915 3915 3913 3895 3908 3156 3912 3910 3908 3912 3910 3912 3914 2914 3910 3914 2914 3914 2923 2923 3914 3915 3915 3895 3897 2923 3915 2925 2925 3915 3897 2924 2923 2925 2924 2925 2926 2926 2925 2927 2925 3897 2927 3896 3897 3895 3897 3896 2927 2926 2927 2928 2928 2927 2929 2927 3896 3900 2927 3900 2929 3895 3894 3896 3896 3894 3898 3896 3898 3900 2928 2929 2930 3911 3910 2914 2914 2916 3911 3910 3911 3909 3911 2916 3942 3911 3942 3909 3909 3908 3910 3908 3909 3167 3909 3942 3943 3909 3943 3167 2916 2920 3942 3942 2920 3939 3942 3939 3943 3943 3939 3937 3943 3937 3192 3167 3943 3192 3167 3168 3158 3167 3192 3168 3167 3158 3908 3908 3158 3156 3157 3156 3158 3158 3168 3169 3158 3169 3157 3157 3169 3953 3953 3169 3168 3953 3168 3952 3952 3168 3194 3952 3194 3948 3168 3193 3194 3194 3193 3195 3194 3195 3196 3948 3194 3196 3948 3949 3945 3948 3196 3949 3949 3196 3978 3196 3195 3978 3195 3193 3936 3195 3936 3975 3978 3195 3975 3949 3978 3979 3979 3978 3984 3978 3975 3984 3979 3945 3949 3979 3984 3985 3988 3985 3984 3984 3975 3976 3984 3976 3988 3975 3936 3974 3975 3974 3976 3976 3974 3977 3988 3976 3977 3987 3985 3988 3988 3977 3987 3940 3973 3974 3940 3974 3938 3938 3974 3936 3938 3939 3940 3940 3939 3941 3941 3973 3940 3936 3937 3938 3938 3937 3939 3936 3193 3937 3192 3937 3193 3168 3192 3193 3941 3939 2920 3941 2920 2921 2904 2906 3954 3954 2906 3955 3954 3955 3956 3956 3955 3957 1501 5241 5242 1501 5242 1398 1466 1500 1501 1466 1501 1398 1500 5241 1501 1398 1465 1466 1499 1500 1466 1465 5234 1466 1466 5234 5224 1466 5224 1499 1499 1540 1500 1538 1539 1499 1499 1539 1540 5224 1538 1499 5223 5205 5224 5224 5205 1538 5234 5223 5224 1465 5233 5234 1464 5233 1465 1398 1464 1465 1467 1468 1398 1398 1468 1469 1398 1485 1486 1398 1486 1467 5314 1468 1467 5314 1467 5315 5315 1467 1486 1469 1468 5314 1486 1485 5313 5315 1486 5316 5316 1486 5313 3016 5204 5223 5223 5204 5205 3016 3015 3017 3016 3017 5204 5204 3017 3660 5205 5204 5206 5204 3660 5206 1538 5205 5207 5205 5206 5207 5206 3660 3662 5206 3662 5208 5207 5206 5208 3017 3015 3660 3660 3015 3661 3660 3661 3662 3662 3661 3663 3663 3668 3662 3662 3668 5208 5208 3668 3667 5208 3667 5209 5207 5208 5210 5210 5208 5209 3663 3667 3668 3666 3665 3667 3666 3667 3663 5209 3667 3665 5209 3665 5203 5210 5209 5211 5211 5209 5203 1431 5207 5210 1431 5210 1399 1399 5210 5211 5211 5203 5212 1399 5211 1400 1400 5211 5212 1399 1400 1302 1399 1302 1431 1300 1301 1302 1302 1301 1303 1302 1303 1304 1304 1428 1302 1302 1428 1429 1302 1429 1430 1431 1302 1395 1430 1517 1302 1302 1517 1518 1302 1518 1519 1519 1566 1302 1302 1566 1567 1302 1328 1300 1431 1395 1432 1432 1536 1431 1432 5220 1536 1431 1536 1537 1536 5220 5221 1536 5221 1537 1431 1537 1538 1538 5207 1431 1538 1537 1539 1537 5221 5222 1537 5222 1539 5222 1540 1539 1328 5589 1300 1300 5589 5592 1300 5592 1301 1328 5587 5589 5603 5587 1328 5603 1328 1327 5587 5586 5588 5587 5588 5589 5602 5586 5587 5602 5587 5603 1327 1326 5603 5603 1326 5611 5603 5611 5602 2744 5586 5602 4273 2744 5602 5602 5611 5606 5602 5606 4273 1326 1325 5611 5611 1325 5607 5611 5607 5606 4277 4275 5606 5606 5607 5609 5606 5609 4277 4273 5606 4275 1325 1343 5607 5607 1343 5608 5607 5608 5609 5609 5608 5610 5609 5610 4279 4277 5609 4279 5625 5610 5608 5625 5608 5626 5626 5608 1343 5626 1343 1342 1342 5629 5626 5626 5629 5630 5626 5630 5625 5624 5610 5625 5625 5630 5624 4279 5610 2742 5624 2742 5610 2740 2742 5624 5624 5630 2852 5624 2852 2740 2740 2741 2742 2742 2741 2743 2743 4279 2742 2852 2853 2740 2740 2853 2741 4222 4224 2852 2852 4224 4225 2852 4225 2853 4222 2852 5630 4225 4238 2853 2741 2853 4238 4224 4239 4225 4225 4239 4238 4222 4223 4224 4223 4240 4224 4224 4240 4239 4237 4238 4239 4240 4241 4239 4239 4241 4242 4239 4242 4237 2741 4238 4248 4248 4238 4237 4237 4242 4243 4248 4237 4249 4249 4237 4243 4248 4249 4268 4248 4268 2741 2741 4268 4271 2741 4271 2743 4249 4270 4268 4270 4298 4268 4268 4298 4297 4268 4297 4271 4271 4297 4278 4271 4278 2743 4278 4279 2743 4276 4277 4278 4278 4277 4279 4276 4278 4297 4296 4276 4297 4296 4297 4295 4295 4297 4298 4274 4275 4276 4276 4275 4277 4274 4276 4296 4272 4274 4296 4272 4296 4281 4281 4296 4295 4272 4273 4274 4274 4273 4275 4281 4273 4272 4280 4273 4281 4281 4295 4280 4280 2744 4273 2745 2744 4280 4280 4295 4294 4280 4294 2745 2744 2745 2746 2744 2746 5586 2746 2745 2747 2747 2745 4291 4291 2745 4294 4293 4294 4295 4291 4294 4285 4285 4294 4293 4290 2747 4291 4291 4285 4290 4251 2746 2747 2747 4252 4251 4290 4252 2747 5586 2746 4251 5586 4251 5588 4251 4252 4253 4251 4253 4254 5588 4251 4254 4289 4252 4290 4289 4253 4252 4290 4285 4287 4290 4287 4289 4256 4255 4289 4289 4255 4253 4289 4287 4288 4289 4288 4256 4253 4255 4254 4254 4255 4256 4254 4256 4257 5588 4254 5590 4254 4257 5590 5589 5588 5590 5590 4257 4263 5590 4263 5591 5589 5590 5592 5592 5590 5591 4257 4256 4258 4258 4263 4257 4256 4288 4258 4261 4262 4258 4258 4262 4263 4261 4258 4288 4262 5591 4263 4261 4260 4262 4260 5591 4262 4260 5572 5591 5592 5591 5593 5593 5591 5572 1301 5592 5593 5593 5572 5571 1301 5593 1303 1303 5593 5571 1307 1305 5571 1307 5571 5564 5564 5571 5572 1303 5571 1305 1304 1303 1305 1304 1305 1306 1306 1305 1307 5564 1306 1307 5563 5549 5564 5564 5549 1306 5564 5572 5563 1306 5549 5551 1306 5551 1304 1304 5551 5554 1304 5554 1428 5549 5550 5551 5551 5550 5552 5551 5552 5554 5549 5548 5550 5563 5548 5549 5562 5548 5563 5563 5572 5562 5548 2752 4195 5548 4195 5550 5562 2752 5548 5550 4195 4198 5550 4198 5552 4195 2752 2753 2753 4196 4195 4195 4196 4197 4195 4197 4198 2750 2751 2752 2752 2751 2753 2750 2752 5562 4234 4196 2753 4234 2753 4235 2753 2751 4235 4233 4196 4234 4233 4197 4196 4197 4199 4198 4233 4199 4197 4200 4199 4233 4234 4231 4233 4233 4231 4232 4233 4232 4200 4235 4229 4234 4234 4229 4231 4235 2751 4246 4235 4246 4229 4229 4230 4231 4229 4246 4247 4229 4247 4230 4230 4226 4231 4231 4226 4228 4231 4228 4232 4230 4247 4245 4230 4245 4226 4264 4245 4247 4264 4247 4246 4264 4246 4265 4265 4246 2751 4266 4245 4264 4265 4292 4264 4264 4292 4284 4264 4284 4266 4265 2751 2749 2749 4259 4265 4265 4259 4292 2750 2749 2751 2748 2749 2750 2749 2748 4259 4259 2748 4260 4259 4260 4261 4261 4292 4259 4288 4284 4292 4288 4292 4261 4287 4284 4288 4285 4286 4287 4286 4282 4287 4287 4282 4284 4285 4293 4286 4286 4293 4299 4286 4299 4282 4282 4283 4284 4282 4299 4283 4299 4298 4300 4293 4298 4299 4299 4300 4283 4295 4298 4293 4298 4270 4269 4300 4298 4269 4300 4269 2861 4283 4300 2861 2861 4269 2854 2854 4269 4250 4250 4269 4249 4249 4269 4270 2860 2861 2862 2862 2861 2854 4283 2861 2860 4245 4267 2860 4245 2860 2862 4267 4283 2860 4267 4284 4283 4266 4267 4245 4266 4284 4267 2862 4227 4245 4226 4245 4227 4226 4227 4228 4211 4228 4227 4211 4227 2859 2862 2859 4227 4209 4236 4228 4209 4228 4210 4210 4228 4211 4232 4228 4236 4182 4210 4211 4182 4211 2859 2857 2858 2859 2859 2862 2857 2859 2858 4182 4180 4181 4182 4158 4180 4182 4158 4182 2858 4181 4210 4182 4181 4209 4210 4181 4180 4183 4183 4209 4181 4183 4180 4179 4183 4179 4184 4184 4208 4183 4183 4208 4209 4184 4179 4151 4184 4151 2757 2757 2755 4184 4184 2755 4208 2755 4203 4208 4208 4203 4236 4208 4236 4209 2754 2755 2756 2756 2755 2757 2755 2754 4203 4151 4152 2757 2757 4152 2756 4152 5540 2756 2754 2756 5540 4203 2754 4204 2754 5540 5543 2754 5543 4204 4203 4204 4205 4205 4236 4203 4232 4236 4205 4205 4204 4206 4205 4206 4202 4205 4202 4232 4204 5543 5553 4204 5553 4206 4202 4206 4207 4206 5553 4207 4201 4200 4202 4202 4207 4201 4200 4232 4202 5552 4201 4207 5552 4207 5553 5554 5552 5553 5554 5553 5555 5555 5553 5543 4198 4201 5552 4198 4200 4201 4198 4199 4200 5543 5540 5538 5543 5538 5544 5555 5543 5544 5539 5538 5540 5539 5540 4152 5537 1563 5538 5537 5538 5539 5544 5538 1563 5544 1563 1430 1429 5555 5544 1429 5544 1430 1561 1563 5537 5541 1561 5537 5541 5537 5536 5536 5537 5539 5542 5541 5535 5535 5541 5536 4150 4148 5536 5536 5539 4150 5535 5536 4146 4146 5536 4148 4149 4148 4150 4149 4150 4151 4151 4150 4152 4150 5539 4152 4147 4146 4148 4147 4148 4149 4149 4151 4179 4179 4178 4149 4149 4178 4147 4145 4146 4147 4145 4147 4178 4145 4178 4154 4154 4178 4177 4179 4177 4178 4180 4177 4179 4156 4155 4177 4154 4177 4153 4153 4177 4155 4180 4156 4177 4153 4146 4154 4154 4146 4145 2759 2758 4153 4153 2758 4146 4153 4155 2759 2761 2759 4155 2761 4155 4139 4139 4155 4156 2758 2759 2760 2760 2759 2761 4146 2758 5535 5547 5535 2758 5547 2758 2760 2760 2761 2762 2760 2762 5559 2760 5559 5547 5546 5535 5547 5547 5559 5560 5547 5560 5546 5545 5542 5535 5545 5535 5546 5546 5557 5545 5546 5560 5561 5546 5561 5557 5559 2773 5560 5560 2773 5566 5560 5566 5561 5559 2762 2773 2771 2773 2772 2772 2773 2762 2773 2771 5566 2770 2769 2771 2770 2771 2772 2769 5566 2771 2772 2762 2763 2763 4121 2772 2772 4121 4123 2772 4123 2770 2768 2769 2770 2770 4123 4127 2770 4127 2768 2766 2767 2768 2768 2767 2769 2768 4127 4128 2768 4128 2766 4123 4125 4127 4127 4125 4126 4127 4126 4128 4128 4126 4103 4128 4103 4102 2766 4128 4102 4125 2877 4126 4126 2877 2866 4126 2866 4103 4118 2880 4125 4125 2880 2877 4123 4118 4125 2878 2877 2879 2879 2877 2880 2879 2880 2881 2886 2881 2880 4118 2886 2880 4137 4135 2879 4137 2879 2881 2878 2879 4129 4129 2879 4135 2885 2863 2881 2885 2881 2886 2881 2863 4137 4119 2885 2886 4119 2886 4117 4117 2886 4118 2857 2863 2885 4141 2857 2885 2885 4119 4141 4141 4119 4117 4116 4117 4118 4141 4117 4140 4140 4117 4116 4116 4118 4120 4120 4118 4123 4140 4116 4120 4123 4124 4120 4124 4140 4120 4139 4140 4124 4139 4156 4140 4140 4156 4157 4140 4157 4141 4141 4157 2857 2857 4157 4158 4157 4180 4158 4157 4156 4180 2857 4158 2858 2857 2862 2863 2862 2854 2863 2863 2854 2856 4137 2863 4144 2863 2856 4159 2863 4159 4144 2854 2855 2856 2856 4189 4159 2856 2855 4212 4212 4189 2856 4163 4144 4159 4159 4189 4191 4159 4191 4163 4189 4190 4191 4212 4190 4189 4215 4190 4212 4242 4215 4212 4244 4242 4212 4244 4212 2855 2854 4244 2855 4243 4242 4244 2854 4243 4244 4215 4242 4214 4214 4242 4241 4214 4192 4215 4215 4192 4190 4191 4190 4192 4187 4191 4192 4187 4192 4188 4214 4188 4192 4213 4188 4214 4214 4241 4213 4219 4217 4241 4213 4241 4217 4240 4219 4241 2851 2849 4213 4213 2849 4188 4213 4217 2851 4187 4188 2849 2848 2849 2850 2850 2849 2851 2849 2848 4172 2849 4172 4187 2850 2851 4216 4216 2851 4217 4216 4217 4218 4218 4217 4219 5642 5643 4216 4216 5643 2850 4218 5642 4216 2848 2850 5643 5642 5641 5643 2848 5643 5651 5651 5643 5641 5640 5641 5642 5639 5640 5642 5639 5642 4218 4218 4219 4220 4218 4220 5639 5644 5640 5639 5630 5644 5639 5630 5639 4222 4222 5639 4220 4220 4219 4221 4220 4221 4222 4221 4219 4240 4221 4223 4222 4223 4221 4240 5629 5644 5630 1342 1324 5629 1324 1323 5629 5629 1323 5644 1323 1322 5644 1322 1321 5640 5644 1322 5640 5640 1321 5641 5652 5641 1321 5652 1321 1319 5651 5641 5652 5664 5651 5652 1318 5664 5652 1318 5652 1319 2848 5651 4173 4173 5651 5662 5664 5662 5651 5663 5662 5664 1317 5663 5664 1317 5664 1318 5661 4176 5662 4173 5662 4175 4175 5662 4176 5663 5661 5662 5660 5661 5663 1370 5660 5663 1370 5663 1317 1337 5658 5660 5658 5659 5660 5660 5659 5661 1337 5660 1370 1370 1369 1337 1337 1369 1371 5693 1371 1369 1337 1371 1335 5683 1335 1371 5683 1371 5684 5684 1371 5693 5685 5684 5693 5685 5693 5682 5682 5693 5694 5673 5683 5684 5673 5684 5672 5672 5684 5685 1335 5683 5673 1335 1336 1337 5673 1336 1335 5672 5658 5673 5673 5658 1337 5673 1337 1336 5658 5657 5659 5672 5657 5658 5657 2846 4165 5657 4165 5659 5671 2846 5657 5671 5657 5672 5659 4165 4167 5659 4167 5661 2846 4164 4165 4165 4164 4166 4165 4166 4167 4166 4168 4167 4167 4168 4169 4167 4169 4170 4167 4170 5661 5661 4170 4176 4170 4169 4171 4171 4176 4170 4169 4185 4186 4169 4168 4185 4186 4171 4169 4185 4168 4166 4185 4166 4164 4164 4193 4185 4185 4193 4194 4185 4194 4186 4187 4174 4186 4186 4174 4171 4186 4194 4191 4186 4191 4187 4174 4175 4171 4171 4175 4176 4172 4173 4174 4174 4173 4175 4187 4172 4174 4172 2848 4173 4163 4191 4194 4162 4144 4163 4194 4162 4163 4161 4142 4162 4162 4142 4144 4194 4161 4162 4142 4134 4144 4137 4144 4136 4136 4144 4134 4133 4131 4134 4134 4131 4135 4134 4135 4136 4142 4133 4134 4136 4135 4137 4132 4131 4133 4132 4133 4142 4130 4131 4132 4132 4142 4143 4132 4143 4130 4130 4143 2845 4130 2845 2842 4160 2845 4143 4160 4143 4161 4161 4143 4142 2847 2845 4160 2847 4160 4193 4193 4160 4161 4193 4161 4194 4193 4164 2847 2846 2845 2847 2846 2847 4164 2844 2845 2846 2844 2846 5671 2843 2842 2844 2844 2842 2845 2843 2844 5680 5680 2844 5671 5680 5671 5681 5681 5671 5672 2843 5680 5694 5694 5680 5681 5681 5672 5682 5694 5681 5682 5672 5685 5682 4249 4243 4250 4250 4243 2854 4121 2761 4139 4121 4139 4122 4122 4139 4124 4121 4122 4123 2763 2761 4121 2762 2761 2763 4123 4122 4124 4101 4102 4103 4108 4101 4103 4108 4103 2866 2764 4102 2785 2785 4102 4101 2766 4102 2764 2764 2765 2766 2785 2765 2764 2783 2784 2785 2785 2784 2765 2785 4101 2783 2766 2765 2767 2767 2765 5565 2765 5581 5565 2765 2784 5581 2783 2782 2784 2782 5585 2784 5581 2784 5585 5565 5581 5570 5581 5585 5570 5570 5568 5565 5565 5568 5569 5565 5569 2767 2767 5569 2769 5568 5567 5569 5569 5567 5566 5569 5566 2769 1558 1557 5568 5568 1557 5567 5570 1558 5568 5557 5566 5567 5557 5567 5558 5558 5567 5556 5556 5567 1557 5561 5566 5557 5545 5557 5558 5545 5558 5556 1556 1439 5556 5556 1439 5545 5556 1557 1556 1439 5542 5545 1510 1511 1439 1439 1556 1510 1510 1556 1557 1510 1557 1549 5573 1510 1549 1511 1510 5573 5594 1511 5573 5576 5575 5573 5573 1549 5576 5594 5573 5575 5594 5575 5574 5574 5595 5594 5574 5575 5576 5576 1549 1547 5576 1547 5582 5574 5576 5579 5579 5576 5582 5579 5580 5574 5574 5580 5595 5595 5580 5578 5595 5578 5577 5577 2793 5595 5579 5578 5580 5577 5578 5579 2775 5577 2777 2777 5577 5579 5577 2775 2793 2792 2793 2774 2774 2793 2775 2774 2775 2776 2776 2775 2777 2776 2777 2778 2777 2779 2778 2777 5579 2779 4087 2774 2776 4087 2776 4105 4105 2776 2778 2792 2774 4087 4087 4089 2792 2792 4089 4093 4087 4088 4089 4105 4088 4087 4089 4088 4090 4089 4090 4084 4084 4086 4089 4105 4090 4088 4084 4090 4105 4084 4085 4086 4104 4085 4084 4084 4105 4104 4086 4085 4083 4083 2894 4086 4086 2894 2892 4104 4083 4085 4104 4105 4106 4104 4106 4107 4107 2884 4104 4104 2884 4083 4083 2896 2894 2884 2896 4083 2893 2892 2894 2893 2894 2895 2895 2894 2896 2891 2892 2893 4042 4039 2893 2893 4039 2891 2895 4042 2893 2895 2896 2897 4044 4042 2895 4072 4044 2895 2895 2897 4072 2897 2896 2884 2897 2884 2898 4072 2897 2898 4071 4070 4072 4072 4070 4044 4072 2898 4071 4043 4041 4044 4044 4041 4042 4070 4043 4044 4069 2817 4070 4070 2817 4043 4071 4069 4070 4066 4069 4071 4071 2898 2883 4071 2883 4066 2898 2884 2883 2873 2882 2883 2873 2883 2884 2883 2882 4068 4066 2883 4068 4107 2873 2884 4107 4106 4101 4107 4101 4108 4108 2873 4107 4105 2778 4106 2783 4101 4106 2783 4106 2781 2781 4106 2778 2778 2779 2780 2778 2780 2781 2781 2780 2782 2781 2782 2783 2779 5584 2780 2780 5584 5585 2780 5585 2782 2779 5579 5584 5579 5582 5584 5584 5582 5583 5584 5583 5585 5570 5585 5583 5582 1546 5583 5570 5583 1548 1548 5583 1546 5582 1547 1546 1546 1547 1548 1548 1547 1549 1548 1549 1550 5570 1548 1550 1550 1558 5570 1549 1558 1550 1549 1557 1558 2868 2872 2873 2873 2872 2874 2873 2874 2875 2875 2882 2873 4108 2868 2873 4075 2875 2874 4075 2874 4077 4077 2874 2872 4068 2882 2875 4068 2875 4075 4066 4068 4067 4075 4067 4068 4066 4067 4062 4062 4064 4066 4066 4064 4069 4075 4062 4067 4062 4063 4064 4063 4062 4075 4064 4063 4065 4076 4065 4063 4063 4075 4076 4064 4065 4061 4065 4076 4061 4061 2815 4064 4064 2815 2816 4064 2816 4069 4069 2816 2817 2815 2814 2816 2816 2814 2812 2816 2812 2817 2813 2814 2815 4061 2813 2815 2824 2813 4061 4061 4076 2824 2824 2814 2813 2824 2823 2814 5656 2812 2814 2823 5656 2814 2812 2808 2807 2817 2812 2807 2817 2807 4043 2807 2808 2809 2807 2809 4043 2809 2808 2810 2809 2810 2805 2809 2805 4041 4043 2809 4041 4041 2805 4040 4041 4040 4042 4008 4007 4040 4040 4007 4013 4040 4013 4039 4042 4040 4039 4007 4008 4009 4009 4013 4007 4009 4012 4013 4039 4013 4012 4011 2891 4039 4039 4012 4011 4000 4011 4012 4000 4012 4009 2889 4011 4000 2889 2891 4011 2824 4076 4080 4076 4075 4077 4076 4077 4080 4080 4077 4078 4077 2872 4078 4078 2872 2871 2868 2871 2872 2867 2871 2868 2867 2868 2869 2869 2868 2866 2866 2868 4108 1515 1516 1430 1516 1541 1430 1430 1541 1542 1430 1542 1517 1430 1565 1515 5127 1515 1565 1516 1515 5127 5143 1516 5127 5143 5127 5128 5142 1516 5143 5128 5144 5143 5143 5144 5140 5143 5140 5142 5128 3091 5144 3090 5140 5144 3090 5144 3091 3089 3087 5140 5140 3087 5141 3089 5140 3090 5142 5140 5141 3087 3086 3094 3094 5141 3087 5142 5141 5139 5157 5139 5141 3094 5157 5141 3094 3086 3095 3094 3095 3096 3096 5157 3094 3095 3086 3872 3096 3095 3097 3097 3095 3872 3096 3097 3098 3098 5156 3096 3096 5156 5157 5156 5155 5157 5157 5155 5139 5153 5154 5156 5156 5154 5155 3098 5153 5156 3098 3097 3099 3098 3099 3100 3100 5153 3098 3099 3097 3874 3874 3097 3872 3874 3872 3875 3876 3099 3874 3876 3874 3877 3877 3874 3875 3100 3099 3101 3101 3099 3876 3101 3107 3100 3100 3107 5164 3100 5164 5153 3101 3876 3891 3877 3887 3876 3876 3887 3888 3876 3888 3891 3877 3875 3184 3887 3877 3184 3184 3875 3186 3183 3182 3184 3183 3184 3185 3185 3184 3186 3184 3182 3887 3887 3182 3180 3887 3180 3888 3888 3180 3178 3179 3178 3180 3179 3180 3181 3181 3180 3182 3181 3182 3183 3185 3866 3183 3181 3183 3866 3883 3179 3181 3883 3181 3878 3878 3181 3866 3177 3178 3179 3884 3177 3179 3884 3179 3883 3883 3881 3884 3185 3864 3866 3878 3866 3864 3878 3864 3863 3863 3864 3865 3865 3864 3185 3863 3865 3867 3187 3865 3185 3185 3186 3187 5153 5152 5154 5153 5164 5165 5153 5165 5152 5152 1519 1518 5152 1518 5154 5152 5165 1566 5152 1566 1519 5154 1518 1517 5154 1517 5155 5155 1517 1542 5155 1542 5139 5139 1542 1541 5139 1541 5142 5142 1541 1516 5165 5168 1566 1566 5168 1567 5165 5166 5168 5164 5166 5165 1428 5555 1429 1428 5554 5555 2748 5572 4260 5562 5572 2748 5562 2748 2750 5212 5203 5197 3019 5197 5203 5203 3665 3664 5203 3664 3019 3019 3018 5197 3018 3019 3020 3020 3019 3664 3664 3665 3666 3664 3666 3020 3024 3018 3020 3024 3020 3025 3020 3666 3669 3020 3669 3025 3663 3671 3666 3666 3671 3672 3666 3672 3669 3672 3681 3669 3669 3681 3680 3669 3680 3025 3680 3024 3025 3679 3680 3681 3672 3690 3681 3679 3681 3693 3693 3681 3690 3671 3690 3672 3663 3670 3671 3670 3690 3671 3661 3670 3663 3661 3678 3670 3678 3689 3670 3670 3689 3690 3693 3690 3694 3694 3690 3689 3694 3689 3695 3695 3683 3694 3695 3689 3674 3015 3674 3675 3689 3675 3674 3675 3676 3015 3015 3676 3677 3015 3677 3661 3689 3676 3675 3689 3677 3676 3678 3677 3689 3661 3677 3678 2963 2964 2965 2965 2964 2966 2975 2974 2976 2975 2976 2977 2977 2976 2978 2978 2976 3789 2977 2978 2979 2979 2978 2980 2980 2978 3775 3775 2978 3789 3775 3789 3773 3775 2982 2980 2979 2980 2981 2981 2980 2982 2981 2982 2983 2983 2982 2984 2983 2984 2985 2985 2984 2986 2986 2984 3763 1775 1776 1777 1777 1776 1778 1773 1774 1775 1775 1774 1776 1774 5731 1776 1776 5731 5736 1776 5736 1778 1773 1772 1774 1772 5722 1774 1774 5722 5731 1768 1772 1773 2106 1768 1773 1768 1771 1772 5721 5722 1772 1771 5721 1772 5721 5720 5722 5722 5720 5730 5722 5730 5731 5719 5720 5721 5712 5719 5721 5712 5721 1771 1770 1771 1768 1771 1770 5712 5711 5709 5712 5712 1770 1769 5712 1769 5711 5709 5719 5712 2228 2230 5719 5719 2230 5720 5709 2228 5719 5708 2226 5709 5711 5708 5709 2226 2228 5709 2226 2227 2228 2228 2227 2229 2228 2229 2230 2227 2226 2330 2330 2226 2331 5708 2331 2226 5707 2331 5708 5710 5707 5708 5710 5708 5711 2330 2331 2332 2332 2331 2333 5707 2333 2331 5704 2333 5707 5700 5704 5707 5700 5707 5710 5711 1767 5710 5710 1767 1766 5710 1766 5700 5711 1769 1767 1764 1766 1767 1764 1767 1768 1768 1767 1769 1763 1766 1764 1766 1763 5706 5700 1766 5706 1763 1764 1762 2105 1764 1768 1768 1769 1770 2105 1768 2106 2183 2105 2184 2184 2105 2106 1813 2183 2184 1813 1812 1814 2025 1826 1814 2023 1826 2025 5713 5701 1762 1762 5701 5706 1762 5706 1763 5700 5701 5702 5700 5706 5701 5702 5701 5713 5702 5704 5700 5702 5703 5704 5713 5703 5702 5704 5703 5705 5704 5705 5699 5699 2335 5704 5704 2335 2333 5713 5705 5703 5714 5699 5705 5714 5705 5713 5699 2327 2335 2327 5699 5714 2334 2333 2335 2334 2335 2326 2326 2335 2327 2332 2333 2334 2334 2326 4838 4838 4861 2334 2334 4861 4865 2334 4865 2332 2326 2327 2328 4838 2326 2328 2328 2327 2325 5714 2325 2327 2328 2325 2329 4838 2328 4841 4841 2328 2329 4841 4842 4838 4838 4842 4861 4839 4840 4841 4841 4840 4842 4841 2329 4846 4839 4841 4843 4843 4841 4846 2329 2325 2324 4846 2329 2324 4846 2324 4847 4843 4846 4848 4848 4846 4847 4843 4844 4839 4848 2360 4843 4843 2360 4845 4843 4845 4844 4848 4847 4849 4849 2361 4848 4848 2361 2360 2357 2360 2355 2355 2360 2361 2360 2357 4845 4845 2357 2356 4860 4844 4845 4845 2356 4860 4839 4844 4860 4860 2356 2368 4860 2368 4862 4839 4860 4861 4861 4860 4862 2355 2356 2357 2356 2355 2368 2368 2355 2369 2368 2369 2370 4862 2368 2370 4862 2370 4863 4861 4862 4865 4865 4862 4863 4861 4842 4840 4861 4840 4839 4863 2370 2372 4863 2372 4864 4865 4863 4866 4866 4863 4864 2370 2369 2371 2370 2371 2372 2371 2373 2372 2369 4834 2371 2373 2371 4834 2372 2373 2374 4857 2374 2373 4857 2373 4850 4850 2373 4834 2369 4833 4834 4850 4834 4833 4850 4833 4832 4832 4851 4850 4850 4851 4852 4850 4852 4857 4831 4832 4833 4831 4833 2369 2355 4831 2369 4828 4830 4831 4830 4832 4831 4837 4828 4831 4837 4831 2355 4832 4830 4851 4828 4829 4830 4851 4830 4829 4828 4835 4829 4851 4829 4835 4828 2252 4835 4835 2252 2250 4835 2250 4851 2251 2250 2252 2251 2252 2253 2253 2252 2254 2254 2252 4828 2249 2248 2250 2249 2250 2251 4851 2250 2248 2249 2251 5775 5775 2251 2253 2253 2254 2255 5775 2253 5793 5793 2253 2255 2255 2254 2256 2256 2254 4828 2255 2256 2257 5793 2255 5790 5790 2255 2257 2257 2256 2258 2258 2256 4836 4836 2256 4828 4836 4828 4837 4819 2258 4836 4819 4836 4821 4821 4836 4837 2257 2258 2259 2259 2258 2260 2260 2258 4819 5790 2257 2259 2269 2270 2259 2269 2259 2260 2259 5789 5790 2259 2270 5789 4819 2269 2260 2267 2268 2269 2268 2270 2269 4819 2267 2269 2268 5805 2270 5789 2270 5805 5789 5791 5790 5789 5805 5791 5805 5799 5806 2266 5799 5805 2266 5805 2268 5791 5805 5806 2267 2266 2268 2265 2264 2266 2265 2266 2267 2264 5799 2266 2263 2264 2265 2263 2265 4818 4818 2265 2267 2263 2262 2264 2262 5797 2264 2264 5797 5799 2261 2262 2263 4806 2261 2263 4816 4806 2263 4816 2263 4818 2262 2261 2271 2262 2271 5797 5797 5798 5799 5797 2271 5817 5797 5817 5798 2271 2261 2272 2271 2272 2273 2271 2273 5817 5798 5817 5816 5817 2273 5821 5817 5821 5816 5798 5802 5799 5798 5816 5802 5815 5803 5816 5802 5816 5803 5816 5821 5822 5816 5822 5815 5821 2273 4756 5822 5821 5825 5821 4756 5825 5815 5822 1582 1582 5822 5826 5822 5825 5826 5825 4756 4758 5825 4758 5827 5826 5825 5827 2273 4755 4756 4756 4755 4757 4756 4757 4758 2273 2272 2274 2273 2274 4755 4784 4755 4785 4785 4755 2274 4784 4757 4755 4757 4759 4758 4784 4759 4757 4760 4759 4784 4785 4782 4784 4784 4782 4783 4784 4783 4760 4785 2274 4786 4786 4780 4785 4785 4780 4782 2274 2272 4786 4786 2272 4793 4786 4793 4780 4780 4781 4782 4780 4793 4794 4780 4794 4781 4793 2272 2261 2261 4806 4793 4793 4806 4807 4793 4807 4794 4781 4794 4792 4794 4807 4808 4794 4808 4792 4781 4777 4782 4781 4792 4777 4777 4778 4779 4782 4777 4779 4777 4792 4778 4782 4779 4783 4765 4762 4783 4760 4783 4762 4765 4764 4766 4765 4766 4762 4761 4760 4762 4762 4766 4767 4762 4767 4761 4758 4759 4760 4758 4760 4761 4758 4761 5827 5827 4761 4767 5827 4767 5828 4766 5828 4767 4764 5828 4766 5830 5827 5828 5826 5827 5830 1594 5826 5830 1594 5830 1586 1582 5826 1594 1580 1581 1582 1580 1582 1583 1594 1595 1582 1582 1595 1596 1582 1596 1597 1597 1623 1582 1582 1623 1624 1582 1624 1583 5815 1582 1581 1581 1580 5800 1581 5800 5815 1580 1583 5800 5800 1583 5801 1624 5801 1583 5806 5801 1624 1623 5806 1624 5791 1623 5792 5792 1623 1597 5791 5806 1623 5792 1597 1596 5790 5791 5792 5790 5792 5794 5794 5792 1596 5790 5794 5793 5771 5773 5794 5794 5773 5772 5793 5794 5772 5794 1596 5771 5778 5776 5793 5793 5776 5775 5793 5772 5778 5772 5773 5774 5777 5778 5772 5772 5774 5777 5774 5773 5771 5771 1593 5774 5774 1593 1592 5774 1592 5779 5777 5774 5779 1592 1593 1594 1594 1593 1595 5771 1595 1593 1594 1609 1592 5779 1592 1609 5779 1609 5780 5777 5779 5781 5781 5779 5780 1594 1608 1609 5780 1609 1608 1586 1608 1594 1586 1607 1608 1608 1607 5763 1608 5763 5767 5780 1608 5767 5781 5780 5782 5782 5780 5767 5767 5763 5754 5767 5754 5768 5782 5767 5768 1587 5763 1607 1587 1607 1586 5768 5754 2241 5768 2241 2240 2245 5782 5768 2245 5768 2240 2247 5781 5782 2247 5782 2245 2240 2242 2245 2245 2242 2246 2245 2246 2247 2240 2241 2242 2242 2241 2243 4876 2243 2241 4876 4874 2243 4879 4880 4874 4874 4880 4881 4874 4881 2243 4879 4874 4885 4885 4874 4872 4879 4885 4917 4879 4917 4880 4880 4917 4926 4880 4926 4881 2243 4881 4882 4881 4926 4925 4881 4925 4882 4920 4925 4926 4920 4926 4923 4923 4926 4917 4923 4917 4886 4886 4917 4885 4885 4872 4886 4886 4872 4887 4887 4872 4869 4887 4923 4886 4922 4920 4923 4922 4923 4924 4888 4924 4923 4888 4923 4887 4887 4869 4888 4868 2236 4869 4888 4869 2236 4888 2236 2238 2238 4924 4888 2238 2239 4924 4924 2239 4930 4924 4930 4922 2236 2237 2238 2238 2237 2239 2234 2235 2236 2236 2235 2237 2234 2236 4868 2237 2235 4908 4908 4910 2237 2237 4910 4914 2237 4914 2239 4914 4929 2239 2239 4929 4930 4930 4929 4931 4922 4930 4931 4931 4929 4928 4934 4928 4929 4934 4929 4913 4913 4929 4914 4910 4913 4914 4913 4910 4915 4915 4934 4913 4915 4910 4905 4915 4905 4916 4916 4934 4915 4905 4906 2232 4910 4911 4905 4905 4911 4912 4905 4912 4906 4916 4905 2232 4916 2232 2233 2233 4895 4916 4916 4895 4934 2232 2231 2233 4895 2233 2231 4899 4898 4895 4895 2231 4899 4898 4934 4895 2230 2229 2231 2230 2231 2232 4899 2231 2229 2232 4907 2230 4907 5720 2230 2232 4906 4907 4906 5730 4907 4907 5730 5720 4912 5734 4906 4906 5734 5730 5731 5730 5734 4912 5733 5734 5731 5734 5736 5736 5734 5733 4911 5733 4912 4911 5732 5733 4910 4909 4911 4909 5732 4911 4909 4908 5732 5732 4908 2235 4908 4909 4910 4899 2229 4904 4904 2229 2227 4897 4898 4899 4904 4902 4899 4899 4902 4903 4899 4903 4897 4897 4903 4927 4897 4927 4898 4898 4927 4934 4903 4901 4927 4927 4901 4928 4927 4928 4934 4902 4901 4903 4900 4901 4902 4901 4900 4928 4931 4928 4932 4932 4928 4933 4933 4928 4900 4902 2377 4900 4900 2377 2379 4933 4900 2379 2379 2381 4933 4933 2381 4919 4933 4919 4932 4922 4931 4932 4932 4919 4921 4932 4921 4922 4919 2381 4889 4889 4918 4919 4919 4918 4920 4919 4920 4921 2379 2380 2381 2381 2380 4889 4889 2380 4856 4889 4856 4890 4889 4890 4918 4890 4891 4918 4918 4891 4925 4918 4925 4920 4921 4920 4922 4891 4892 4925 4925 4892 4894 4882 4925 4894 4890 4855 4891 4891 4855 4892 4890 4856 4855 4854 2242 4855 4854 4855 4856 2242 4893 4855 4855 4893 4894 4855 4894 4892 4853 2242 4854 4858 4853 4854 4858 4854 4859 4859 4854 4856 2242 2243 2244 4853 2246 2242 2242 2244 4893 2243 4884 2244 2244 4884 4893 4877 4878 2243 2243 4882 4877 4878 4883 2243 2243 4883 4884 4893 4884 4883 4893 4883 4894 4894 4883 4878 4894 4878 4877 4882 4894 4877 2247 2246 2248 4852 2248 2246 4852 2246 4853 2247 2248 2249 2249 5781 2247 4851 2248 4852 4857 4852 4853 4857 4853 4858 4858 2374 4857 4859 2376 4858 4858 2376 2374 2372 2374 2375 2375 2374 2376 2375 2376 2377 2377 2376 2378 4859 2378 2376 4859 4856 2380 2380 2378 4859 2377 2378 2379 2379 2378 2380 4896 2375 2377 4902 4896 2377 4896 2372 2375 4864 2372 4896 4904 4864 4896 4904 4896 4902 4866 4864 4867 4867 4864 4904 4904 2227 4867 2330 4866 4867 2330 4867 2227 2332 4865 4866 2332 4866 2330 2249 5777 5781 5775 5777 2249 5775 5776 5777 5777 5776 5778 5771 1596 1595 5806 5799 5801 5799 5802 5803 5799 5803 5801 5801 5803 5804 5801 5804 5800 5815 5804 5803 5800 5804 5815 2350 4778 4792 4792 4804 2350 4792 4808 4809 4792 4809 4804 2350 4804 4805 4817 4804 4809 4817 4805 4804 4808 4816 4809 4809 4816 4817 4808 4807 4816 4807 4806 4816 4817 4816 4818 4817 4818 4820 4820 2340 4817 4817 2340 4805 2350 4805 2351 2340 2351 4805 2346 2350 2339 2339 2350 2351 2339 2351 2340 2338 2339 2336 2336 2339 2340 2347 2346 2339 4670 2347 2339 2339 2338 4680 2339 4680 4670 2336 2337 2338 2336 2340 2341 2337 2336 4776 2336 2341 4776 2338 2337 4725 2337 4752 4725 4776 4752 2337 4775 4748 4776 4776 4748 4752 4776 2341 4790 4776 4790 4775 2340 2367 2341 4795 2341 2367 2340 2366 2367 4795 2367 4796 4796 2367 2366 4796 4791 4795 4791 4796 4788 4796 2366 4798 4788 4796 4797 4797 4796 4798 2359 2366 2340 4798 2366 2359 4798 2359 4799 4797 4798 4801 4801 4798 4799 4797 4789 4788 4789 4797 2304 2304 4797 4801 4801 4799 4802 2304 4801 2309 2309 4801 4802 4799 2359 2358 4799 2358 4800 4802 4799 4800 2340 2358 2359 2340 2365 2358 4800 2358 2365 4802 4800 4803 4811 4803 4800 4811 4800 2364 2364 4800 2365 2340 2364 2365 2353 2364 2340 4820 2353 2340 2353 2363 2364 2363 4811 2364 4810 4803 4811 4813 4810 4811 4813 4811 2363 2352 2363 2353 2352 4813 2363 2352 2353 2344 4821 2344 2353 4821 2353 4820 4820 4818 4819 4820 4819 4821 4821 4837 2344 2344 4837 2355 2355 2361 2344 2344 2361 2362 4849 2362 2361 2344 2362 2342 2342 2362 4849 4849 4847 4827 4849 4827 2342 2342 2343 2344 4827 4825 2342 2342 4825 2343 4826 4824 4827 4827 4824 4825 4847 4826 4827 4847 2324 4826 2317 2319 4826 4826 2319 4824 2324 2317 4826 2319 2321 4824 4824 2321 4822 4824 4822 4825 4825 4822 4823 4825 4823 2343 2321 2311 4822 4822 2311 4814 4822 4814 4823 2319 2320 2321 2321 2320 2322 2321 2322 2311 2317 2318 2319 2319 2318 2320 2320 2318 5724 2322 2320 5726 5726 2320 5724 2311 2322 2312 2312 2322 5728 5728 2322 5726 5726 5724 5727 5728 5726 5729 5729 5726 5727 5724 2318 5717 5724 5717 5725 5727 5724 5725 5727 5725 1751 5729 5727 1749 1749 5727 1751 5740 5728 5729 5741 2312 5728 5741 5728 5740 5743 5741 5740 5743 5740 1744 1744 5740 1745 2314 2312 5741 5742 2314 5741 5742 5741 5743 5745 5742 5743 5745 5743 1642 1642 5743 1744 1642 1744 1606 1606 1744 1745 1606 1745 1604 1604 1605 1606 1637 1638 1604 1604 1638 1639 1604 1639 1605 1605 1639 5788 1606 1605 5769 5769 1605 5788 1639 1638 5784 5788 1639 5784 5788 5784 5783 5769 5788 5770 5770 5788 5783 1621 1606 5769 1621 5769 5766 5766 5769 5770 1606 1621 1622 5766 1622 1621 5765 5752 5766 5766 5752 1622 5766 5770 5765 1622 1640 1606 5752 1640 1622 1606 1640 1641 1606 1641 1642 5752 5751 1640 5751 5753 1640 1640 5753 1641 5750 5751 5752 5765 5750 5752 5764 5750 5765 5765 5770 5764 2303 5749 5750 5750 5749 5751 5764 2303 5750 5749 5748 5751 5751 5748 5753 2303 2310 5749 2310 2308 5749 5749 2308 5748 5748 2308 2306 2306 5744 5748 5748 5744 5745 5748 5745 5753 2307 2306 2308 2307 2308 2309 2309 2308 2310 2309 2310 2304 2304 2310 2303 2309 4802 2307 2305 2306 2307 2307 4802 4803 2307 4803 2305 2315 2316 2305 2305 2316 2306 2315 2305 4810 4810 2305 4803 2313 2314 2315 2315 2314 2316 2313 2315 4812 4812 2315 4810 2316 2314 5742 2306 2316 5744 5744 2316 5742 2313 2312 2314 2311 2312 2313 2311 2313 4814 4814 2313 4812 4814 4812 4815 4823 4814 4815 4815 4812 4813 4815 4813 2352 4823 4815 2354 2354 4815 2352 2343 4823 2354 2344 2343 2354 2344 2354 2352 4812 4810 4813 5744 5742 5745 5753 5745 1642 5753 1642 1641 2301 2302 2303 2303 2302 2304 2301 2303 5764 2299 2300 2301 2301 2300 2302 5764 2299 2301 5764 5770 2299 2300 2299 4737 4737 2299 4730 4730 2299 5770 4750 4751 2300 2300 4737 4750 4751 2302 2300 4737 4730 4738 4750 4737 4738 4738 4730 4729 4750 4738 4754 4754 4738 4729 4729 4730 4731 4754 4729 4731 4731 4733 4754 4754 4733 4747 4754 4747 4750 4731 4730 4732 4731 4732 4733 4733 4732 4734 4733 4734 4735 4733 4735 4747 4727 4753 4747 4727 4747 4726 4726 4747 4735 4750 4747 4753 4735 4734 4736 4735 4736 2298 4726 4735 2298 2298 2296 4726 4726 2296 4704 4726 4704 4727 2297 2296 2298 2298 4736 2297 5786 5787 4736 4736 5787 2297 4734 5786 4736 2295 2296 2297 2295 2297 5787 5786 5785 5787 2295 5787 5795 5795 5787 5785 5784 5785 5786 5783 5784 5786 5783 5786 4734 4734 4732 5783 5770 5783 4730 4730 5783 4732 5784 1638 5785 5795 5785 5796 5796 5785 1638 1637 1619 1638 5796 1638 1619 5814 5795 5796 5814 5812 5795 4694 5795 5812 4694 5812 4696 4696 5812 4697 4693 2295 4694 4693 4694 4695 4695 4694 4696 2295 5795 4694 4695 4696 4692 4692 4696 4697 4703 4693 4695 4703 4695 4702 4702 4695 4692 2296 2295 4693 2296 4693 4703 4703 4704 2296 4702 4707 4703 4703 4707 4708 4703 4708 4704 4702 4710 4707 4684 4707 4710 4710 4683 4684 4683 4670 4684 4684 4670 4680 4680 4707 4684 4683 4671 4670 4646 4670 4648 4648 4670 4671 4646 4645 4670 4670 4645 2347 4645 4646 4647 4647 4646 4648 2347 4645 4649 4649 4645 4647 2345 2346 2347 2345 2347 4649 4649 4647 4650 4650 4667 4649 4649 4667 4668 4649 4668 2345 4650 4647 4651 4651 4654 4650 4654 4667 4650 4654 4666 4667 4666 4679 4667 4667 4679 4672 4667 4672 4668 4668 4672 4674 4668 4674 2345 4672 4673 4674 4672 4677 4673 2345 4674 2346 2346 4674 4700 4700 4674 4699 4699 4674 4673 4699 4673 4677 2282 4677 4676 2282 4676 2284 4705 4706 4707 4707 4706 4708 4680 4705 4707 2338 4705 4680 4725 4706 4705 4725 4705 2338 4728 4708 4706 4728 4706 4725 4727 4704 4708 4727 4708 4728 4725 4753 4728 4728 4753 4727 4725 4752 4753 4750 4753 4748 4748 4753 4752 4748 4749 4750 4750 4749 4751 4774 4749 4748 4774 4748 4775 4749 4772 4773 4749 4773 4751 4772 4749 4774 4751 4773 2302 4773 4788 2302 4772 4788 4773 4774 4788 4772 4775 4791 4774 4774 4791 4788 4775 4790 4791 2302 4788 4789 2302 4789 2304 1620 1619 1637 2092 1620 1637 1750 1749 1751 1750 1751 1752 1752 1751 1753 1751 5725 1753 2099 1750 1752 2177 2099 2178 1838 2177 2178 5725 5723 1753 5725 5717 5723 5717 5718 5723 2318 2323 5717 5717 2323 5715 5717 5715 5718 5718 5715 5716 2323 2325 5715 5715 2325 5714 5715 5714 5716 2318 2317 2323 2323 2317 2324 2323 2324 2325 5716 5714 5713 4818 2267 4819 1645 1660 5852 1645 1647 1660 1660 1647 1661 1648 1734 1647 5360 1661 1647 5360 1647 5361 1647 1734 5372 1647 5372 5361 1660 1661 1662 5359 1662 1661 5359 1661 5360 5361 5363 5360 5360 5363 5358 5360 5358 5359 5361 5362 5363 5361 5372 5377 5361 5377 5362 5362 2520 5363 5363 2520 2518 5363 2518 5358 5362 2508 2520 5362 5377 2510 5362 2510 2508 5373 2510 5377 5373 5377 5375 5375 5377 5372 2509 2508 2510 2509 2510 2511 2511 2510 2512 2512 2510 5373 2507 2508 2509 2507 2520 2508 2511 4448 2509 2509 4448 4449 2509 4449 2507 2511 2512 2501 2501 2512 2502 2502 2512 5373 2501 2502 2503 2503 2502 2504 2502 5373 5374 5388 2504 2502 5388 2502 5374 2503 2504 2505 2505 2504 2506 5387 2506 2504 5387 2504 5388 5383 5387 5388 5383 5388 5382 5382 5388 5374 5384 5386 5387 5384 5387 5383 5386 2506 5387 2505 2506 2495 2495 2506 2496 5386 2496 2506 5384 5385 5386 5398 5386 5385 2498 2496 5386 5386 5398 2498 5383 1723 5384 5384 1723 5385 5399 5398 5385 5399 5385 1723 2498 5398 5402 5400 5402 5398 5400 5398 5399 1723 1722 5399 5399 1722 1678 5399 1678 5400 1648 1722 1723 1723 1724 1648 5383 1724 1723 1678 1722 1648 1648 1677 1678 1678 1677 5397 5400 1678 5397 5400 5397 5401 5401 5402 5400 2491 2500 5401 5401 2500 5402 2490 2491 2492 2492 2491 2493 2490 2500 2491 2499 2498 2500 2499 2500 2490 2498 5402 2500 2490 2492 4399 2492 2493 2489 2492 2489 4397 4399 2492 4397 2489 2493 2494 2487 2488 2489 2489 2494 2487 4396 2489 2488 4397 2489 4396 2487 2494 4365 4365 4367 2487 2487 4367 4371 2487 4371 2488 2488 4371 4380 4380 4383 2488 2488 4383 4396 4396 4383 4382 4396 4382 4395 4380 4382 4383 4381 4382 4380 4388 4381 4380 4388 4380 4370 4370 4380 4371 4367 4370 4371 4370 4367 4372 4372 4388 4370 4372 4367 4364 4367 4368 4364 4364 4368 4369 4364 4369 4363 4367 4366 4368 4369 4368 5424 5424 4368 4366 4365 4366 4367 4381 4385 4386 4381 4386 4382 4395 4386 4385 4395 4382 4386 2497 2496 2498 2497 2498 2499 2495 2496 2497 1648 1724 1725 1648 1725 1726 1726 1733 1648 1648 1733 1734 5382 1725 1724 5382 1724 5383 5376 1726 1725 5376 1725 5382 5376 1733 1726 5376 5375 1733 5375 5372 1733 1733 5372 1734 5374 5375 5376 5382 5374 5376 5374 5373 5375 2519 2520 2507 2507 4449 2519 2517 2518 2519 2519 2518 2520 2519 4449 4459 2519 4459 2517 2515 2516 2517 2517 2516 2518 2517 4459 4462 2517 4462 2515 5358 2518 2516 2515 2514 2516 5358 2516 2514 2513 2514 2515 2515 4462 4463 2515 4463 2513 4459 4460 4462 4462 4460 4461 4462 4461 4463 4470 2513 4463 4470 4463 4471 4471 4463 4461 2514 2513 2521 2521 2513 2522 2522 2513 4470 2524 2522 4470 4472 2524 4470 4472 4470 4473 4473 4470 4471 4471 4461 2585 4473 4471 2583 2583 4471 2585 4475 4472 4473 4475 4473 2581 2581 4473 2583 2526 2524 4472 4474 2526 4472 4474 4472 4475 4482 4475 2581 4475 4482 4474 2554 2580 2581 2554 2581 2582 2582 2581 2583 2581 2580 4482 4482 2580 2553 4482 2553 4483 4474 4482 4483 2553 2580 2554 2553 2554 2555 2555 2554 2556 4483 2553 2555 4483 2555 4484 4474 4483 4486 4486 4483 4484 2555 2556 2557 4484 2555 2557 2557 2556 2558 2557 2558 2559 4484 2557 4485 2557 2559 4485 4486 4484 4487 4487 4484 4485 2528 4474 4486 2528 4486 2533 2533 4486 4487 4487 4485 4488 2533 4487 2531 2531 4487 4488 4485 2559 4505 4485 4505 4488 2531 4488 2529 4488 4505 4506 4488 4506 2529 2529 2530 2531 2531 2530 2532 2531 2532 2533 2533 2532 2534 2533 2534 2528 2532 2530 5354 2534 2532 5352 5352 2532 5354 2529 2540 2530 5354 2530 5355 2530 2540 5355 5354 5355 5356 5352 5354 5353 5353 5354 5356 2527 2534 5352 2527 5352 5349 5349 5352 5353 2528 2534 2527 2525 2526 2527 2527 2526 2528 2525 2527 5344 5344 2527 5349 5344 5349 5350 5350 5349 5351 5349 5353 5351 2523 2525 5344 5345 2523 5344 5345 5344 5347 5347 5344 5350 2523 2524 2525 2525 2524 2526 2528 2526 4474 2523 2522 2524 2521 2522 2523 2521 2523 5345 2514 2521 5345 2514 5345 5346 5346 5345 5347 5358 2514 5346 5346 5347 5348 5359 5358 5346 5359 5346 5348 5348 5347 1686 5348 1686 1685 5348 1685 1662 5348 1662 5359 1660 1685 1686 1660 1686 1687 5347 5350 1686 1686 5350 1687 1662 1685 1660 1687 1698 1660 1660 1698 1699 1660 1699 1700 1700 1707 1660 1660 1707 1708 1660 1708 1709 5857 1660 1709 1687 5351 1698 5351 1699 1698 5350 5351 1687 5351 5353 1699 5353 5356 1699 1699 5356 1700 5356 5357 1700 1700 5357 1707 5357 5371 1707 1707 5371 1708 5356 5355 5357 5355 5370 5357 5357 5370 5371 5370 5364 5371 5371 5364 5366 5371 5366 1708 2540 2538 5370 5370 2538 5364 5355 2540 5370 5364 2538 2536 2536 5367 5364 5364 5367 5368 5364 5368 5366 2537 2536 2538 2537 2538 2539 2539 2538 2540 2539 2540 2529 4506 4496 2539 2539 4496 2537 2529 4506 2539 2535 2536 2537 2535 2537 4495 4495 2537 4496 2536 2535 2541 2541 2535 2542 4516 2542 2535 2535 4495 4516 4495 4496 4497 4516 4495 4497 4516 4497 4515 4515 4530 4516 4516 4530 2545 4516 2545 2542 2545 2546 2542 2542 2546 2541 2543 2544 2545 2545 2544 2546 2543 2545 4531 4531 2545 4530 4515 4529 4530 4531 4530 4532 4532 4530 4529 4533 2543 4531 4533 4531 4534 4534 4531 4532 4532 4529 2653 4534 4532 2617 2617 4532 2653 4541 4533 4534 4541 4534 2617 2615 2616 2617 2617 2616 2626 2617 2653 2615 2617 2626 4541 2615 2653 2654 2653 4529 2654 2615 2654 2548 4583 2616 2615 4583 2615 4584 4584 2615 2548 2548 2654 2655 2655 2654 4513 4513 2654 4529 2548 2655 2625 2625 2655 4504 4504 2655 4513 4504 4513 4499 4499 4513 4500 4500 4513 4514 4513 4529 4514 4514 4529 4515 4500 4514 4502 4502 4514 4515 4499 4500 4501 4501 4500 4502 4499 4501 4504 4504 4501 2624 4504 2624 2625 2624 2548 2625 2559 2548 2624 2559 2624 4505 4505 2624 4501 4501 4502 4496 4505 4501 4506 4506 4501 4496 4496 4502 4503 4502 4515 4503 4497 4496 4498 4496 4503 4498 4515 4498 4503 4515 4497 4498 2559 2558 2560 2559 2560 2561 2561 2549 2559 2559 2549 2548 2560 4416 2561 4416 4415 2561 2561 4415 4417 2561 4417 2549 4414 4415 4416 4416 4421 4414 4417 4415 4442 4442 4415 4414 4417 4442 2549 4442 4414 4421 2549 4442 4443 4442 4457 4450 4442 4450 4443 2549 4443 2652 4443 4450 4452 4443 4452 2652 4450 4451 4452 4457 4453 4450 4450 4453 4455 4450 4455 4451 4464 2652 4452 4451 4466 4452 4452 4466 4467 4452 4467 4464 4455 4465 4451 4451 4465 4466 4455 4469 4465 4469 4480 4465 4465 4480 4466 4466 4480 4481 4466 4481 4467 4467 4481 4464 4464 4481 2649 4476 2649 4481 4476 4481 4478 4478 4481 4480 2566 2596 4476 2566 4476 4477 4477 4476 4478 2596 2649 4476 4477 4478 4479 4479 4493 4477 4477 4493 4494 4477 4494 2566 2425 2424 4479 4479 2424 4493 2424 2427 4493 4493 2427 4489 4493 4489 4494 4494 4489 4491 4494 4491 2568 2566 4494 2568 2427 2422 4489 4489 2422 4490 4489 4490 4491 4491 4490 4492 4491 4492 2570 2568 4491 2570 2567 2566 2568 2567 2568 2569 2569 2568 2570 2569 2570 2571 2570 2618 2571 2570 4492 2618 4569 4567 2569 2569 4567 2567 2571 4569 2569 2571 2618 2619 2571 2619 2620 4571 4569 2571 2620 4571 2571 4492 4512 2618 2618 4512 2619 2620 2619 2621 2621 2619 4507 4507 2619 4512 2620 2621 2622 4576 4571 2620 2622 4576 2620 4570 4568 4571 4571 4568 4569 4576 4570 4571 4575 4570 4576 4578 4575 4576 4578 4576 2622 2622 2621 2609 2622 2609 2623 2623 4578 2622 2609 2621 4507 2609 2610 2611 2623 2609 2611 2609 4507 4508 4508 4528 2609 2609 4528 2610 4580 4578 2623 4601 4580 2623 2623 2611 4601 2610 2646 2611 4601 2611 2646 4600 4579 4601 4601 4579 4580 4601 2646 4600 4579 4577 4580 4580 4577 4578 2676 2685 4579 4579 2685 4577 4598 2676 4579 4600 4598 4579 2685 2683 4577 4577 2683 4575 4577 4575 4578 2684 2683 2685 2684 2685 2675 2675 2685 2676 2682 2681 2683 2682 2683 2684 2683 2681 4575 4575 2681 4570 2680 2681 2682 2680 2691 2681 2681 2691 4570 2682 2684 5912 2680 2682 5896 5896 2682 5912 2690 2691 2680 2690 2680 5895 5895 2680 5896 2690 2689 2691 2691 2689 4568 4570 2691 4568 2688 2689 2690 2688 2690 5899 5899 2690 5895 5895 5896 5897 5899 5895 5900 5900 5895 5897 5884 2688 5899 5884 5899 5885 5885 5899 5900 2686 2687 2688 2688 2687 2689 2686 2688 5884 5883 5884 5885 5883 2686 5884 5890 5883 5885 5890 5885 2735 5885 5900 2735 5900 5897 2737 2735 5900 2737 2717 2734 2735 2717 2735 2736 2736 2735 2737 2735 2734 5890 5889 5883 5890 5890 2734 2716 5890 2716 5889 2716 2734 2717 2716 2717 2718 5889 2716 2718 5887 5888 5889 5889 5888 5883 5889 2718 5887 2718 2717 2719 2718 2719 2720 2718 2720 5872 5887 2718 5872 2720 2719 2715 2715 2719 2726 2726 2719 5921 5921 2719 2717 5872 2720 2715 5872 2715 5873 5887 5872 5873 5873 2715 5860 5873 5860 5874 5887 5873 5874 5874 5860 5865 5874 5865 5875 5874 5875 5886 5874 5886 5887 5865 5877 5875 5886 5875 5877 5865 5876 5877 5886 5877 5876 5887 5886 5888 5876 2694 5886 5886 2694 2696 5886 2696 5888 5868 2692 5876 5868 5876 5865 5876 2692 2694 2692 2693 2694 2694 2693 2695 2694 2695 2696 2696 2695 2697 2696 2697 2698 5888 2696 2698 5888 2698 5883 2698 2697 2699 2698 2699 2686 5883 2698 2686 2695 4563 2697 2697 4563 4564 2697 4564 2699 2693 4558 2695 2695 4558 4563 4558 4560 4563 4563 4560 4561 4563 4561 4564 4564 4561 4562 4564 4562 4565 2699 4564 4565 4560 2595 4561 4561 2595 2594 4561 2594 4562 4554 2647 4560 4560 2647 2595 4558 4554 4560 2566 2594 2595 2566 2595 2596 2595 2647 2596 2565 2594 2566 4562 2594 2565 2565 2566 2567 2567 4562 2565 4567 4562 2567 4566 4565 4567 4567 4565 4562 4569 4566 4567 2689 2687 4566 4566 2687 4565 4568 2689 4566 4568 4566 4569 2686 2699 2687 2699 4565 2687 2596 2647 2648 2596 2648 2649 4554 2648 2647 2649 2648 2650 4555 2650 2648 4555 2648 4553 4553 2648 4554 2649 2650 2651 4464 2649 2651 2651 2650 2547 2547 2650 4555 2547 4555 4572 4555 4553 4572 4552 4553 4554 4572 4553 4552 4572 4552 4573 4572 4581 2547 4573 4587 4572 4572 4587 4588 4572 4588 4581 4552 4554 4556 4556 4573 4552 4556 4554 4558 4558 4559 4556 4559 4573 4556 2693 4557 4558 4558 4557 4559 4557 4574 4559 4559 4574 4573 2693 2701 4557 4557 2701 4574 2692 2701 2693 2700 2701 2692 2700 2703 2701 2701 2703 4574 4574 2703 4585 4574 4585 4573 2702 2703 2700 2702 2709 2703 4585 2703 2709 5868 2702 2700 2700 2692 5868 2708 2709 2702 5867 2702 5868 2708 2702 5867 2708 2707 2709 4585 2709 4602 4602 2709 2707 2706 2705 2707 2706 2707 2708 4602 2707 4604 4604 2707 2705 2704 2705 2706 5878 2706 2708 2704 2706 5881 5881 2706 5878 2705 2704 2711 4604 2705 4605 2705 2711 4605 4603 4602 4604 4603 4604 4606 4606 4604 4605 4606 4605 4607 4605 2711 4621 4605 4621 4607 2711 2704 2710 2711 2710 2712 2711 2712 4621 4621 2712 4619 4621 4619 4622 4607 4621 4622 2712 2710 2663 4620 4619 2712 4620 2712 2663 4618 4617 4619 4618 4619 4620 4622 4619 4617 4622 4617 2633 4607 4622 2631 2631 4622 2633 2636 2634 4617 2636 4617 4618 2633 4617 2634 4620 4625 4618 4618 4625 4626 4618 4626 2636 2635 2634 2636 2635 2636 2637 2637 2636 2638 2636 4626 2638 2632 2633 2634 2632 2634 2635 2632 2631 2633 2630 2631 2632 4543 2630 2632 4543 2632 4544 4548 4544 2632 2632 2635 4548 4548 2635 2637 4548 2637 4550 4544 4548 4549 4549 4548 4550 4544 4545 4546 4544 4546 4543 4549 4545 4544 4549 4550 4551 2396 4545 4549 2396 4549 2397 2397 4549 4551 4545 2382 2384 4545 2384 4546 2382 4545 2396 4543 4546 4547 4546 2384 2386 4546 2386 4547 2382 2383 2384 2384 2383 2385 2384 2385 2386 2383 2382 2395 2395 2382 2396 2383 5404 5405 2383 5405 2385 2383 2395 5404 2386 2385 2387 2385 5405 5408 2385 5408 2387 2386 2387 2388 4547 2386 2388 2388 2387 2389 2389 2387 5391 5391 2387 5408 5391 5408 5407 5407 5408 5405 5407 5405 5406 5406 5405 5404 5406 1727 5407 5407 1727 5390 5407 5390 5391 5391 5390 5392 5391 5392 5394 5394 2389 5391 5390 1730 1732 5390 1732 5392 1727 1730 5390 1727 1728 1627 1727 1627 1730 5406 1728 1727 1730 1627 1731 1730 1731 1732 1731 1737 1732 5392 1732 1737 5392 1737 5393 5394 5392 5393 1731 1736 1737 5393 1737 1736 5393 1736 5389 5394 5393 5395 5395 5393 5389 1735 1736 1731 5389 1736 1735 1731 1740 1735 1735 1740 5378 5389 1735 5378 1731 1739 1740 1740 1739 5365 5378 1740 5365 5378 5365 5379 5378 5379 5389 5365 1739 5366 5366 5369 5365 5379 5365 5369 1738 1708 1739 1738 1739 1731 1708 5366 1739 5366 5368 5369 5379 5369 5380 5380 5369 5368 5389 5379 5380 5380 5368 5381 5396 5389 5380 5396 5380 5381 5381 5368 5367 5381 5367 2541 5381 2541 5396 5395 5389 5396 5396 2541 2546 5396 2546 5395 2541 5367 2536 5395 2546 2544 5395 2544 5394 2543 2389 2544 5394 2544 2389 2388 2389 2543 2388 2543 4533 4547 2388 4533 4542 4547 4533 4542 4533 4541 4543 4547 4542 4541 2628 4542 4542 2628 2630 4542 2630 4543 4541 2626 2628 2626 2627 2628 2628 2627 2629 2628 2629 2630 2630 2629 2631 2631 2629 4607 4607 2629 2627 2626 2616 2627 4607 2627 4606 4606 2627 2616 4582 2616 4583 4606 2616 4603 4603 2616 4582 2547 4581 4582 4582 4583 2547 4603 4582 4581 2547 4583 4584 2547 2548 2549 2651 2547 2652 2652 2547 2549 2547 4584 2548 2651 2652 4464 4603 4581 4588 4588 4602 4603 4588 4587 4602 4602 4587 4586 4602 4586 4585 4573 4586 4587 4585 4586 4573 1709 1708 1738 1709 1738 5850 1709 5850 5857 1738 1731 5850 5850 1731 5849 5850 5849 5845 5857 5850 5845 1731 1627 5849 5845 5849 5846 5845 5846 4717 4717 5846 4715 4715 4716 4717 4716 4718 4717 4717 4718 4719 4715 4714 4716 4745 4718 4716 4745 4716 4714 4719 4718 4745 4719 4745 4746 4714 4742 4745 4746 4745 4742 4746 4742 4739 4739 4742 4744 1713 1627 1714 1627 1728 1729 1627 1729 1714 5413 1691 1713 5413 1713 5416 5416 1713 1714 1714 1729 5403 5416 1714 5417 5417 1714 5403 5403 1729 1728 5403 1728 5406 5406 5404 5403 5417 5403 5404 5404 5418 5417 5417 5418 5414 5417 5414 5416 5416 5414 5415 5416 5415 5413 2393 2391 5414 5414 2391 5415 2393 5414 2394 2394 5414 5418 2394 5418 2395 5404 2395 5418 2392 2393 2394 2395 2396 2394 2394 2396 2397 2394 2397 2392 2392 2391 2393 2390 2391 2392 2391 2390 2398 2398 5415 2391 2397 4551 2392 2392 4551 4540 2392 4540 2390 2398 2390 2399 4540 4535 2390 2390 4535 2399 2398 2399 2400 2400 5432 2398 2398 5432 5415 2400 2399 2401 2401 2399 4535 2400 2401 2402 2402 5429 2400 2400 5429 5432 5429 5431 5432 5432 5431 5413 5432 5413 5415 5429 5430 5428 5428 5427 5429 5429 5427 5431 2402 5430 5429 5427 1692 5431 5431 1692 1691 5431 1691 5413 5427 5428 1703 1703 1693 5427 5427 1693 1692 5430 5440 5428 5428 5440 5441 5428 5441 1703 1703 5441 1704 5440 5435 5441 5441 5435 5439 5441 5439 1704 2413 2411 5440 5440 2411 5435 5430 2413 5440 2412 2411 2413 2412 2413 2414 2414 2413 2404 2404 2413 5430 2410 2409 2411 2410 2411 2412 2411 2409 5435 4526 2410 2412 4526 2412 2414 2408 2409 2410 2408 2410 4526 2408 2407 2409 2409 2407 5435 2406 2407 2408 4526 4527 2408 2408 4527 4510 2408 4510 2406 2407 2406 2415 5435 2407 5436 2407 2415 5436 5435 5436 5439 5436 5437 5438 5439 5436 5438 5436 2415 5456 5436 5456 5437 2415 2406 2416 2415 2416 2417 2415 2417 5456 2417 2416 2418 2406 4510 2416 2416 4510 4509 2416 4509 2418 2417 2418 2419 2419 2418 2420 2418 4509 2420 4509 4511 2420 2420 4511 4490 2420 4490 2422 4490 4511 4492 4492 4511 4512 4509 4512 4511 4507 4512 4509 4508 4507 4509 4508 4509 4510 4510 4527 4508 4508 4527 4528 4526 4528 4527 4525 2610 4528 4525 4528 4526 4521 4525 4526 4521 4526 2414 4518 2644 4525 4518 4525 4521 2644 2610 4525 2644 2645 2610 2610 2645 2646 2642 2643 2644 2644 2643 2645 2642 2644 4518 4600 2646 2645 4600 2645 4599 4599 2645 2643 2642 2641 2643 2643 2641 4596 4599 2643 4590 4590 2643 4596 4590 4597 4599 4599 4597 4598 4599 4598 4600 4590 4591 4592 4592 4594 4590 4590 4594 4597 4590 4596 4591 4596 2641 2640 4596 2640 4591 4592 4591 4608 4591 2640 4608 4592 4593 4594 4608 4593 4592 4608 2640 2607 4608 2607 4611 4611 4610 4608 4608 4610 4593 2607 2640 2608 2608 2640 2641 2606 2605 2607 2606 2607 2608 4611 2607 2605 4611 2605 4612 4612 4616 4611 4611 4616 4610 2604 2563 2605 2604 2605 2606 4612 2605 2563 4612 2563 4609 4609 4615 4612 4612 4615 4616 4615 2669 4616 4616 2669 2667 4616 2667 4610 4609 4614 4615 4614 2671 4615 4615 2671 2669 2668 2667 2669 2668 2669 2670 2670 2669 2671 2666 2665 2667 2666 2667 2668 4610 2667 2665 5917 2666 2668 5917 2668 5922 5922 2668 2670 2664 2665 2666 5914 2664 2666 5914 2666 5917 2674 2665 2664 2664 5914 5927 2664 5927 2674 5917 5918 5914 5927 5914 5918 5927 5918 5916 5916 5926 5927 5927 5926 5928 5927 5928 5930 2674 5927 5930 5917 5916 5918 5915 5916 5917 5916 5915 5926 5919 5920 5915 5915 5917 5919 5926 5915 5920 5919 5921 5920 5926 5920 5921 5919 5917 5922 5919 5922 5924 5924 2726 5919 5919 2726 5921 5921 2717 5926 5926 2717 2736 2736 2737 2738 5926 2736 5928 5928 2736 2738 2738 2737 2733 2737 5897 2733 2738 2733 2739 5928 2738 5929 5929 2738 2739 5930 5928 5929 5929 2739 5909 5930 5929 5931 5931 5929 5909 2739 2733 2731 2739 2731 5908 2739 5908 5909 5909 5908 5910 5909 5910 5911 5931 5909 5911 2672 5930 5931 2672 5931 2677 2677 5931 5911 2674 5930 2672 2672 2673 2674 2677 2678 2672 2672 2678 2679 2672 2679 2673 2675 2676 2677 2677 2676 2678 2677 5911 2675 4597 2679 2678 4597 2678 4598 4598 2678 2676 4594 2673 2679 4594 2679 4597 4594 4593 4595 4594 4595 4589 4589 2673 4594 4610 4595 4593 4589 4595 4610 4589 2665 2673 4610 2665 4589 2674 2673 2665 5911 2684 2675 5911 5910 2684 5912 2684 5910 5912 5910 5913 5913 5910 5908 5896 5912 5898 5898 5912 5913 5913 5908 2730 5898 5913 2732 2732 5913 2730 2730 5908 2731 2730 2731 2732 2732 2731 2733 2733 5898 2732 5897 5896 5898 5897 5898 2733 2715 2726 2727 5924 2727 2726 2727 2728 2715 5925 2728 2727 5925 2727 5924 5924 5922 5923 5924 5923 5925 5925 5923 5907 5925 5907 2729 2729 2728 5925 2715 2728 2729 2715 2729 2724 5907 5905 2729 2729 5905 2724 5906 5904 5907 5907 5904 5905 5923 5906 5907 5922 2670 5923 5923 2670 5906 2656 2658 5906 5906 2658 5904 2670 2656 5906 2658 2660 5904 5904 2660 5902 5904 5902 5905 5905 5902 5903 5905 5903 2724 2660 2662 5902 5902 2662 5893 5902 5893 5903 2658 2659 2660 2660 2659 2661 2660 2661 2662 2656 2657 2658 2658 2657 2659 4613 4624 2659 4613 2659 2657 2661 2659 4625 4625 2659 4624 2662 2661 2663 2663 2661 4620 4620 2661 4625 4625 4624 4626 4609 4623 4624 4609 4624 4613 4626 4624 4623 4613 4614 4609 4613 2657 4614 2563 2562 4609 2562 4623 4609 2562 2639 4623 4626 4623 2638 2638 4623 2639 2562 2563 2564 2564 2639 2562 2564 2563 2604 2637 2638 2564 2564 2638 2639 2564 2604 4539 4550 2637 2564 4550 2564 4539 2604 2606 4538 4539 2604 4538 4539 4538 4540 4551 4550 4539 4551 4539 4540 4538 2606 4537 4538 4537 4535 4540 4538 4535 4517 4537 2606 4517 2606 2608 4522 4536 4537 4522 4537 4523 4523 4537 4517 4535 4537 4536 2401 4535 2403 4535 4536 2403 4520 4519 4536 4536 4519 4524 4520 4536 4522 2403 4536 4524 2402 2401 2403 2402 2403 2404 2404 2403 2405 2403 4524 2405 4519 4521 4524 4524 4521 2414 4524 2414 2405 4519 4520 4521 4521 4520 4522 4521 4522 4518 4518 4522 4523 4517 2642 4518 4518 4523 4517 2608 2642 4517 2608 2641 2642 2414 2404 2405 2404 5430 2402 4614 2657 2671 2656 2671 2657 2670 2671 2656 2710 2662 2663 2710 2704 5891 2662 2710 5893 5893 2710 5891 5891 2704 5881 5891 5881 5892 5893 5891 5894 5894 5891 5892 5893 5894 5901 5903 5893 5901 5894 5892 2721 5901 5894 2721 5892 5881 5882 5892 5882 2722 2721 5892 2722 5881 5878 5882 5882 5878 5879 5882 5879 2723 2722 5882 2723 2721 2722 2715 2715 2722 2723 2715 2725 2721 2725 5901 2721 5903 5901 2725 2724 5903 2725 2724 2725 2715 2713 2714 2715 2715 2723 2713 2715 2714 5860 2723 5879 2713 2714 2713 5861 5861 2713 5879 5860 2714 5861 5860 5861 5862 5862 5863 5860 5860 5863 5864 5860 5864 5865 5861 5879 5862 5879 5863 5862 5879 5864 5863 5865 5864 5866 5878 5864 5879 5878 5866 5864 5866 5869 5865 5865 5869 5870 5865 5870 5868 5880 5869 5866 5878 5880 5866 2708 5880 5878 5871 5870 5880 5880 5870 5869 2708 5871 5880 5868 5870 5871 5868 5871 5867 5867 5871 2708 5438 5437 1680 5439 5438 1679 1679 5438 1680 1704 5439 1679 1720 1719 5504 2827 2826 2828 2825 2826 2827 2827 4100 2825 2825 2836 2826 2835 2836 2825 4109 2835 2825 4109 2825 4110 2835 2834 2836 2833 2834 2835 2833 2832 2834 1456 1455 1409 1454 1455 1456 2147 1454 1456 1454 1407 1455 1331 1407 1454 2146 1331 1454 2146 1454 2147 1331 1405 1407 1388 1405 1331 1405 1388 5145 1388 1331 1389 1388 1389 5158 5158 5145 1388 5149 5150 5145 5145 5150 5151 5158 5163 5145 5163 5149 5145 5158 1389 1390 5158 1390 5159 5159 5163 5158 1389 1331 1390 1331 1449 1390 5159 1390 1449 5159 1449 5160 5160 5162 5159 5159 5162 5163 5162 3041 5163 5163 3041 5149 5160 5161 5162 5161 3043 5162 5162 3043 3041 5171 5161 5160 5171 5160 1387 1387 5160 1449 1387 1449 1331 1331 1386 1387 1386 5171 1387 5161 3033 3043 3042 3041 3043 3042 3043 3032 3032 3043 3033 3040 3041 3042 3040 3042 3756 3038 3039 3040 3040 3039 3041 3038 3040 3758 3758 3040 3756 3050 3051 3038 3038 3051 3039 3038 3758 3050 5149 3039 5150 5150 3039 3051 3041 3039 5149 3050 3049 3051 5150 3051 5151 5151 3051 3049 3048 3049 3050 3050 3758 3767 3050 3767 3048 3048 3047 3049 3046 3047 3048 3048 3767 3046 3767 3771 3769 3767 3769 3046 3044 3045 3046 3046 3045 3047 3046 3769 3768 3046 3768 3044 3768 3769 3770 3770 3769 3771 3770 3771 3136 3768 3770 3779 3779 3770 3136 3778 3044 3768 3778 3768 3780 3780 3768 3779 3780 3779 3135 3135 3779 3136 3135 3136 3137 3135 3137 3145 3145 3780 3135 3782 3778 3780 3782 3780 3145 3781 3778 3782 3057 3055 3781 3781 3055 3778 3056 3055 3057 3054 3053 3055 3054 3055 3056 3055 3053 3778 3054 3056 5133 3052 3053 3054 3052 3054 5134 5134 3054 5133 3052 3044 3053 3053 3044 3778 3045 3044 3052 3045 3052 5134 3992 3993 3994 5635 3992 3994 3990 3991 3992 3992 3991 3993 3990 3992 5635 5635 3989 3990 3989 3991 3990 5614 4017 5616 5614 4018 4017 4016 4017 2795 2795 4017 4018 2795 4018 2794 2794 2787 2795 2795 2787 2786 2795 2786 2796 4074 4052 2786 2786 4052 4053 2786 4053 2796 2795 2796 4028 4053 4028 2796 4052 4029 4053 4053 4029 4028 4052 4054 4029 4074 4054 4052 4046 4074 4047 4047 4074 4073 4046 4054 4074 4029 4054 4055 4054 4046 4055 4028 4029 2795 2795 4029 4030 4029 4055 4030 4030 4055 4056 4055 4046 4048 4055 4048 4056 4046 4047 4048 4047 4049 4048 4047 4073 4049 4049 4073 4050 4049 4050 4051 4048 4049 4051 4056 4048 4060 4048 4051 4060 4030 4056 4031 4031 4056 4057 4056 4060 4057 2795 4030 4031 4031 4032 2795 4031 4057 4032 4025 4034 4057 4057 4034 4033 4057 4033 4032 4057 4060 4045 4057 4045 4025 2795 4032 4033 2795 4033 4016 4016 4033 4034 4016 4034 4025 3289 3446 3462 3462 3446 3445 3432 3446 3289 3432 3289 3287 5001 5017 5018 5001 5018 1417 1910 2221 1908 2193 2114 2115 2038 1979 2039 1233 2038 1229 1229 2038 2039 1977 1979 1978 1979 1977 2039 2039 1977 1975 1976 1975 1977 1976 1977 1978 1978 2196 1976))
                   (list :vertices (let ((mat (make-matrix 5932 3))) (fvector-replace (array-entity mat) #f(-6.0728001594543457e+00 2.1267601013183594e+01 -1.0745199584960938e+02 -7.4335002899169922e+00 2.2552499771118164e+01 -1.0683100128173828e+02 5.2499900817871094e+01 2.2561901092529297e+01 -1.0684999847412109e+02 -2.4610898971557617e+01 3.2316200256347656e+01 -1.0073899841308594e+02 -2.5028400421142578e+01 3.2420501708984375e+01 -1.0065399932861328e+02 5.2499900817871094e+01 3.2421501159667969e+01 -1.0065499877929688e+02 -6.0408699035644531e+01 4.3047397613525391e+01 -3.0829500198364258e+01 -6.2587299346923828e+01 4.0639698028564453e+01 -2.7590200424194336e+01 5.2499900817871094e+01 4.0655200958251953e+01 -2.7578498840332031e+01 1.4330299198627472e-01 1.0803600311279297e+01 -9.1347103118896484e+00 6.6269803047180176e-01 8.5731697082519531e+00 -8.7116394042968750e+00 5.2499900817871094e+01 1.1571000099182129e+01 -9.3037490844726562e+00 7.2440397739410400e-01 8.2020797729492188e+00 -8.6509599685668945e+00 8.7529999017715454e-01 7.0116500854492188e+00 -8.4749498367309570e+00 1.1286000013351440e+00 3.5138700008392334e+00 -8.1188697814941406e+00 5.2499900817871094e+01 0.0000000000000000e+00 -8.0000200271606445e+00 -2.6707000732421875e+00 1.6930999755859375e+01 -1.0833600044250488e+01 5.2499900817871094e+01 2.2561901092529297e+01 -1.3149599075317383e+01 -4.4117999076843262e+00 1.9358299255371094e+01 -1.1737600326538086e+01 -6.3121004104614258e+00 2.1518699645996094e+01 -1.2661399841308594e+01 -1.2669999599456787e+00 1.4435599327087402e+01 -1.0043900489807129e+01 -6.3830000162124634e-01 1.3036600112915039e+01 -9.6607198715209961e+00 -1.2439599633216858e-01 1.1568400382995605e+01 -9.3149003982543945e+00 5.2499900817871094e+01 3.2421501159667969e+01 -1.9344799041748047e+01 -2.5161499023437500e+01 3.2417697906494141e+01 -1.9349500656127930e+01 -2.3116100311279297e+01 3.1838800430297852e+01 -1.8886899948120117e+01 -2.2047798156738281e+01 3.1462699890136719e+01 -1.8598299026489258e+01 -1.7767099380493164e+01 2.9648899078369141e+01 -1.7280698776245117e+01 -1.3726499557495117e+01 2.7432199478149414e+01 -1.5824599266052246e+01 -9.9825000762939453e+00 2.4823099136352539e+01 -1.4307399749755859e+01 -9.1252002716064453e+00 2.4129899978637695e+01 -1.3937600135803223e+01 -7.4268002510070801e+00 2.2553400039672852e+01 -1.3167200088500977e+01 -6.5516098022460938e+01 3.7332099914550781e+01 -2.3801799774169922e+01 -6.8354499816894531e+01 3.4017002105712891e+01 -2.0670099258422852e+01 -3.5388397216796875e+01 3.4017002105712891e+01 -2.0670099258422852e+01 -2.7476900100708008e+01 3.3073101043701172e+01 -1.9873100280761719e+01 -3.1560302734375000e+01 3.3783302307128906e+01 -2.0469200134277344e+01 -6.2856502532958984e+01 4.0342098236083984e+01 -2.7189800262451172e+01 -5.3982601165771484e+01 4.9927600860595703e+01 -4.5466098785400391e+01 -5.5275802612304688e+01 4.8564502716064453e+01 -4.1412700653076172e+01 5.2499900817871094e+01 4.6850399017333984e+01 -3.7438098907470703e+01 -5.6860500335693359e+01 4.6880599975585938e+01 -3.7500999450683594e+01 -5.6891002655029297e+01 4.6847900390625000e+01 -3.7439399719238281e+01 -5.8723899841308594e+01 4.4879299163818359e+01 -3.3735000610351562e+01 -5.2193702697753906e+01 5.1798400878906250e+01 -5.5426097869873047e+01 -5.2706001281738281e+01 5.1264301300048828e+01 -5.1284202575683594e+01 5.2499900817871094e+01 5.0696296691894531e+01 -4.8429000854492188e+01 -5.3282901763916016e+01 5.0661003112792969e+01 -4.8436401367187500e+01 -5.3537799835205078e+01 5.0394298553466797e+01 -4.7177799224853516e+01 -5.3091800689697266e+01 5.0861198425292969e+01 -7.0822593688964844e+01 -5.2409999847412109e+01 5.1573001861572266e+01 -6.6649696350097656e+01 5.2499900817871094e+01 5.0696296691894531e+01 -7.1570999145507812e+01 -5.2053699493408203e+01 5.1944099426269531e+01 -6.2409301757812500e+01 5.2499900817871094e+01 5.2000000000000000e+01 -6.0000000000000000e+01 -5.2009002685546875e+01 5.1990596771240234e+01 -5.9999801635742188e+01 -5.2001499176025391e+01 5.1998397827148438e+01 -5.9596698760986328e+01 -5.5672298431396484e+01 4.8144599914550781e+01 -7.9649101257324219e+01 -5.4254699707031250e+01 4.9641502380371094e+01 -7.5482597351074219e+01 5.2499900817871094e+01 4.6850399017333984e+01 -8.2561904907226562e+01 -5.4096099853515625e+01 4.9808403015136719e+01 -7.4937202453613281e+01 -5.3272899627685547e+01 5.0671398162841797e+01 -7.1564697265625000e+01 5.2499900817871094e+01 4.0655200958251953e+01 -9.2421501159667969e+01 -6.2602199554443359e+01 4.0617500305175781e+01 -9.2390502929687500e+01 -6.1677700042724609e+01 4.1652000427246094e+01 -9.1130500793457031e+01 -5.9251499176025391e+01 4.4307998657226562e+01 -8.7217597961425781e+01 -5.7403900146484375e+01 4.6299400329589844e+01 -8.3671897888183594e+01 -5.6919300079345703e+01 4.6815898895263672e+01 -8.2546005249023438e+01 -3.5388397216796875e+01 3.4017002105712891e+01 -9.9329902648925781e+01 -3.2407699584960938e+01 3.3873401641845703e+01 -9.9453704833984375e+01 -2.8587699890136719e+01 3.3310001373291016e+01 -9.9930503845214844e+01 -6.8354499816894531e+01 3.4017002105712891e+01 -9.9329902648925781e+01 -6.7287696838378906e+01 3.5277198791503906e+01 -9.8203598022460938e+01 -6.4366806030273438e+01 3.8642898559570312e+01 -9.4795394897460938e+01 -1.1804400444030762e+01 2.6170299530029297e+01 -1.0493499755859375e+02 -1.5921299934387207e+01 2.8703098297119141e+01 -1.0336000061035156e+02 -2.0218299865722656e+01 3.0749000549316406e+01 -1.0193399810791016e+02 -8.9349002838134766e+00 2.3970199584960938e+01 -1.0614600372314453e+02 -1.4411000013351440e+00 1.4784399986267090e+01 -1.0985399627685547e+02 -2.8485000133514404e+00 1.7205999374389648e+01 -1.0907099914550781e+02 -3.7191998958587646e+00 1.8456800460815430e+01 -1.0861399841308594e+02 8.7529999017715454e-01 7.0116500854492188e+00 -1.1152500152587891e+02 5.5180400609970093e-01 9.1552104949951172e+00 -1.1118800354003906e+02 5.2499900817871094e+01 1.1571000099182129e+01 -1.1069599914550781e+02 -3.5999401006847620e-03 1.1287899971008301e+01 -1.1076000213623047e+02 -1.0100100189447403e-01 1.1570599555969238e+01 -1.1069400024414062e+02 -3.7619599699974060e-01 1.2368100166320801e+01 -1.1050800323486328e+02 5.2499900817871094e+01 -1.1571000099182129e+01 -1.1069599914550781e+02 1.2132000923156738e+00 -5.8221197128295898e+00 -1.1167299652099609e+02 5.2499900817871094e+01 0.0000000000000000e+00 -1.1200000000000000e+02 1.2132000923156738e+00 0.0000000000000000e+00 -1.1200000000000000e+02 1.1286000013351440e+00 3.5138700008392334e+00 -1.1188100433349609e+02 5.2499900817871094e+01 -2.2561901092529297e+01 -1.0684999847412109e+02 1.2132000923156738e+00 -1.7174499511718750e+01 -1.0908200073242188e+02 1.2132000923156738e+00 -1.1571000099182129e+01 -1.1069599914550781e+02 5.2499900817871094e+01 -3.2421501159667969e+01 -1.0065499877929688e+02 1.2132000923156738e+00 -2.7665599822998047e+01 -1.0402999877929688e+02 1.2132000923156738e+00 -2.2561901092529297e+01 -1.0684999847412109e+02 5.2499900817871094e+01 -4.0655200958251953e+01 -9.2421501159667969e+01 1.2132000923156738e+00 -3.6769496917724609e+01 -9.6769493103027344e+01 1.2132000923156738e+00 -3.2421501159667969e+01 -1.0065499877929688e+02 5.2499900817871094e+01 -4.6850399017333984e+01 -8.2561904907226562e+01 1.2132000923156738e+00 -4.4029602050781250e+01 -8.7665603637695312e+01 1.2132000923156738e+00 -4.0655200958251953e+01 -9.2421501159667969e+01 5.2499900817871094e+01 -5.0696296691894531e+01 -7.1570999145507812e+01 1.2132000923156738e+00 -4.9081897735595703e+01 -7.7174499511718750e+01 1.2132000923156738e+00 -4.6850399017333984e+01 -8.2561904907226562e+01 5.2499900817871094e+01 -5.2000000000000000e+01 -6.0000000000000000e+01 1.2132000923156738e+00 -5.1673000335693359e+01 -6.5822105407714844e+01 1.2132000923156738e+00 -5.0696296691894531e+01 -7.1570999145507812e+01 5.2499900817871094e+01 -5.0696296691894531e+01 -4.8429000854492188e+01 1.2132000923156738e+00 -5.1673000335693359e+01 -5.4177898406982422e+01 1.2132000923156738e+00 -5.2000000000000000e+01 -6.0000000000000000e+01 5.2499900817871094e+01 -4.6850399017333984e+01 -3.7438098907470703e+01 1.2132000923156738e+00 -4.9081897735595703e+01 -4.2825500488281250e+01 1.2132000923156738e+00 -5.0696296691894531e+01 -4.8429000854492188e+01 5.2499900817871094e+01 -4.0655200958251953e+01 -2.7578498840332031e+01 1.2132000923156738e+00 -4.4029602050781250e+01 -3.2334400177001953e+01 1.2132000923156738e+00 -4.6850399017333984e+01 -3.7438098907470703e+01 5.2499900817871094e+01 -3.2421501159667969e+01 -1.9344799041748047e+01 1.2132000923156738e+00 -3.6769496917724609e+01 -2.3230501174926758e+01 1.2132000923156738e+00 -4.0655200958251953e+01 -2.7578498840332031e+01 5.2499900817871094e+01 -2.2561901092529297e+01 -1.3149599075317383e+01 1.2132000923156738e+00 -2.7665599822998047e+01 -1.5970399856567383e+01 1.2132000923156738e+00 -3.2421501159667969e+01 -1.9344799041748047e+01 5.2499900817871094e+01 -1.1571000099182129e+01 -9.3037490844726562e+00 1.2132000923156738e+00 -1.7174499511718750e+01 -1.0918100357055664e+01 1.2132000923156738e+00 -2.2561901092529297e+01 -1.3149599075317383e+01 1.2132000923156738e+00 0.0000000000000000e+00 -8.0000200271606445e+00 1.2132000923156738e+00 -5.8221197128295898e+00 -8.3270101547241211e+00 1.2132000923156738e+00 -1.1571000099182129e+01 -9.3037490844726562e+00 5.5000000000000000e+01 -4.2447498321533203e+01 -8.1317901611328125e+01 5.5000000000000000e+01 -3.6387100219726562e+01 -9.0532402038574219e+01 5.5000000000000000e+01 -3.6387100219726562e+01 -2.9467599868774414e+01 5.5000000000000000e+01 2.3749898910522461e+01 -1.8863800048828125e+01 5.5000000000000000e+01 1.3623099327087402e+01 -1.4495500564575195e+01 5.5000000000000000e+01 2.7618398666381836e+00 -1.2580400466918945e+01 5.5000000000000000e+01 -8.2482700347900391e+00 -1.3221699714660645e+01 5.5000000000000000e+01 -2.8364999771118164e+01 -9.8100799560546875e+01 5.5000000000000000e+01 3.9685699462890625e+01 -8.6101600646972656e+01 5.5000000000000000e+01 4.4635299682617188e+01 -7.6246002197265625e+01 5.5000000000000000e+01 4.7178802490234375e+01 -6.5514404296875000e+01 5.5000000000000000e+01 4.7178802490234375e+01 -5.4485599517822266e+01 5.5000000000000000e+01 4.4635299682617188e+01 -4.3754001617431641e+01 5.5000000000000000e+01 3.9685699462890625e+01 -3.3898399353027344e+01 5.5000000000000000e+01 3.2596500396728516e+01 -2.5449798583984375e+01 5.5000000000000000e+01 -1.8813800811767578e+01 -1.6384799957275391e+01 5.5000000000000000e+01 -2.8364999771118164e+01 -2.1899198532104492e+01 5.5000000000000000e+01 -4.2447498321533203e+01 -3.8682098388671875e+01 5.5000000000000000e+01 -4.6219596862792969e+01 -4.9045799255371094e+01 5.5000000000000000e+01 -1.8813800811767578e+01 -1.0361499786376953e+02 5.5000000000000000e+01 -8.2482700347900391e+00 -1.0677799987792969e+02 5.5000000000000000e+01 2.7618398666381836e+00 -1.0741999816894531e+02 5.5000000000000000e+01 1.3623099327087402e+01 -1.0550399780273438e+02 5.5000000000000000e+01 2.3749898910522461e+01 -1.0113600158691406e+02 5.5000000000000000e+01 3.2596500396728516e+01 -9.4550201416015625e+01 5.5000000000000000e+01 -4.7500000000000000e+01 -6.0000000000000000e+01 5.5000000000000000e+01 -4.6219596862792969e+01 -7.0954200744628906e+01 -5.7500000000000000e+01 5.8500000000000000e+01 -6.0000000000000000e+01 -5.8800197601318359e+01 5.8500000000000000e+01 -7.2370697021484375e+01 -1.7650000000000000e+02 5.8500000000000000e+01 -6.0000000000000000e+01 -6.2644100189208984e+01 5.8500000000000000e+01 -8.4200798034667969e+01 -1.7519999694824219e+02 5.8500000000000000e+01 -4.7629299163818359e+01 -6.2644100189208984e+01 5.8500000000000000e+01 -3.5799201965332031e+01 -5.8800197601318359e+01 5.8500000000000000e+01 -4.7629299163818359e+01 -8.7250000000000000e+01 5.8500000000000000e+01 -1.1152899932861328e+02 -9.8613502502441406e+01 5.8500000000000000e+01 -1.1658799743652344e+02 -1.5681298828125000e+02 5.8500000000000000e+01 -1.0421700286865234e+02 -1.1078099822998047e+02 5.8500000000000000e+01 -1.1917400360107422e+02 -7.7186798095703125e+01 5.8500000000000000e+01 -1.0421700286865234e+02 -1.6513600158691406e+02 5.8500000000000000e+01 -9.4973197937011719e+01 -1.7135598754882812e+02 5.8500000000000000e+01 -8.4200798034667969e+01 -1.5681298828125000e+02 5.8500000000000000e+01 -1.5782899856567383e+01 -1.4675000000000000e+02 5.8500000000000000e+01 -8.4714899063110352e+00 -9.8613502502441406e+01 5.8500000000000000e+01 -3.4121899604797363e+00 -6.8863502502441406e+01 5.8500000000000000e+01 -9.4973197937011719e+01 -1.7519999694824219e+02 5.8500000000000000e+01 -7.2370697021484375e+01 -1.7135598754882812e+02 5.8500000000000000e+01 -3.5799201965332031e+01 -1.6513600158691406e+02 5.8500000000000000e+01 -2.5026800155639648e+01 -6.8863502502441406e+01 5.8500000000000000e+01 -2.5026800155639648e+01 -7.7186798095703125e+01 5.8500000000000000e+01 -1.5782899856567383e+01 -1.2321900177001953e+02 5.8500000000000000e+01 -1.1917400360107422e+02 -1.3538600158691406e+02 5.8500000000000000e+01 -1.1658799743652344e+02 -1.4675000000000000e+02 5.8500000000000000e+01 -1.1152899932861328e+02 -1.3538600158691406e+02 5.8500000000000000e+01 -3.4121899604797363e+00 -1.2321900177001953e+02 5.8500000000000000e+01 -8.2599902153015137e-01 -1.1078099822998047e+02 5.8500000000000000e+01 -8.2599902153015137e-01 -8.7250000000000000e+01 5.8500000000000000e+01 -8.4714899063110352e+00 -5.8419498443603516e+01 5.5239902496337891e+01 -4.7026000976562500e+01 -5.8326698303222656e+01 5.5355197906494141e+01 -4.7528198242187500e+01 -5.8311203002929688e+01 5.8000000000000000e+01 -4.7525398254394531e+01 -6.2199802398681641e+01 4.1379299163818359e+00 -8.4398399353027344e+01 -6.1897502899169922e+01 4.1131401062011719e+00 -8.3742401123046875e+01 -6.2187297821044922e+01 -5.0000000000000000e-01 -8.4404197692871094e+01 -5.8319801330566406e+01 3.6883900165557861e+00 -7.2515197753906250e+01 -5.8311203002929688e+01 -5.0000000000000000e-01 -7.2474601745605469e+01 -5.8315196990966797e+01 3.6868400573730469e+00 -7.2474197387695312e+01 -5.7000000000000000e+01 -5.0000000000000000e-01 -6.0000000000000000e+01 -5.7005401611328125e+01 3.2454099655151367e+00 -6.0805400848388672e+01 -5.7000000000000000e+01 3.2301499843597412e+00 -6.0000000000000000e+01 -6.7033096313476562e+01 5.8737401962280273e+00 -9.3216003417968750e+01 -6.6149101257324219e+01 5.2953400611877441e+00 -9.1846199035644531e+01 -6.8458999633789062e+01 -5.0000000000000000e-01 -9.5267105102539062e+01 -6.4587402343750000e+01 4.5409197807312012e+00 -8.9204696655273438e+01 -6.3157604217529297e+01 4.2165498733520508e+00 -8.6476402282714844e+01 -7.2096496582031250e+01 3.7287799835205078e+01 -9.9795295715332031e+01 -7.3340896606445312e+01 3.5356998443603516e+01 -1.0115700531005859e+02 -7.6852203369140625e+01 5.8000000000000000e+01 -1.0458899688720703e+02 -7.3599197387695312e+01 3.4904800415039062e+01 -1.0142900085449219e+02 -7.4758094787597656e+01 3.2548698425292969e+01 -1.0261000061035156e+02 -7.5643600463867188e+01 3.0111198425292969e+01 -1.0347000122070312e+02 -7.6164299011230469e+01 2.7992000579833984e+01 -1.0395899963378906e+02 -7.6475303649902344e+01 2.5633600234985352e+01 -1.0424599456787109e+02 -7.6514999389648438e+01 2.4889200210571289e+01 -1.0428299713134766e+02 -7.6457801818847656e+01 2.2551099777221680e+01 -1.0423000335693359e+02 -7.6121894836425781e+01 2.0201999664306641e+01 -1.0391999816894531e+02 -7.6852203369140625e+01 -5.0000000000000000e-01 -1.0458899688720703e+02 -7.5439903259277344e+01 1.7653999328613281e+01 -1.0327500152587891e+02 -7.4531394958496094e+01 1.5346300125122070e+01 -1.0238400268554688e+02 -7.4051094055175781e+01 1.4350599288940430e+01 -1.0189700317382812e+02 -7.2714302062988281e+01 1.2033600807189941e+01 -1.0048200225830078e+02 -7.1209106445312500e+01 9.9383602142333984e+00 -9.8770996093750000e+01 -7.0512397766113281e+01 9.0997800827026367e+00 -9.7932899475097656e+01 -6.8774200439453125e+01 7.2990598678588867e+00 -9.5696899414062500e+01 -6.8468101501464844e+01 7.0484299659729004e+00 -9.5260704040527344e+01 -6.5933303833007812e+01 4.5657001495361328e+01 -9.1498893737792969e+01 -6.8415496826171875e+01 4.2358600616455078e+01 -9.5207199096679688e+01 -6.8458999633789062e+01 5.8000000000000000e+01 -9.5267105102539062e+01 -6.8461097717285156e+01 4.2296199798583984e+01 -9.5265403747558594e+01 -7.1111801147460938e+01 3.8669300079345703e+01 -9.8655700683593750e+01 -5.9081302642822266e+01 5.4414802551269531e+01 -7.5665802001953125e+01 -6.0389801025390625e+01 5.2773899078369141e+01 -7.9881698608398438e+01 -6.2187297821044922e+01 5.8000000000000000e+01 -8.4404197692871094e+01 -6.1988300323486328e+01 5.0751296997070312e+01 -8.3952102661132812e+01 -6.2200302124023438e+01 5.0479900360107422e+01 -8.4398002624511719e+01 -6.3693702697753906e+01 4.8568401336669922e+01 -8.7539703369140625e+01 -5.7378501892089844e+01 5.6531997680664062e+01 -6.6728401184082031e+01 -5.8311203002929688e+01 5.8000000000000000e+01 -7.2474601745605469e+01 -5.7049598693847656e+01 5.6938800811767578e+01 -6.2437900543212891e+01 -5.7000000000000000e+01 5.8000000000000000e+01 -6.0000000000000000e+01 -5.7008300781250000e+01 5.6989700317382812e+01 -5.9999900817871094e+01 -5.8007797241210938e+01 5.5751800537109375e+01 -7.0950698852539062e+01 -5.8345500946044922e+01 5.5331401824951172e+01 -7.2467002868652344e+01 -5.8934799194335938e+01 5.4597698211669922e+01 -7.5113899230957031e+01 -5.7651699066162109e+01 5.6193599700927734e+01 -5.1181098937988281e+01 -5.7178798675537109e+01 5.6778999328613281e+01 -5.5371898651123047e+01 -5.7001399993896484e+01 5.6998199462890625e+01 -5.9591899871826172e+01 -6.1486602783203125e+01 5.1388401031494141e+01 -3.7234802246093750e+01 -6.0023899078369141e+01 5.3234100341796875e+01 -4.1192699432373047e+01 -6.2187297821044922e+01 5.8000000000000000e+01 -3.5595802307128906e+01 -5.8830200195312500e+01 5.4728298187255859e+01 -4.5294097900390625e+01 -6.7021400451660156e+01 4.4221199035644531e+01 -2.6801599502563477e+01 -6.4761901855468750e+01 4.7186500549316406e+01 -3.0484300613403320e+01 -6.8458999633789062e+01 5.8000000000000000e+01 -2.4732900619506836e+01 -6.3206703186035156e+01 4.9194599151611328e+01 -3.3424198150634766e+01 -6.2219799041748047e+01 5.0453201293945312e+01 -3.5610500335693359e+01 -6.9636505126953125e+01 8.1431903839111328e+00 -2.3166698455810547e+01 -7.1344802856445312e+01 1.0110500335693359e+01 -2.1069299697875977e+01 -7.6852203369140625e+01 -5.0000000000000000e-01 -1.5411299705505371e+01 -7.2935798645019531e+01 1.2381899833679199e+01 -1.9277200698852539e+01 -7.3252799987792969e+01 1.2902099609375000e+01 -1.8936901092529297e+01 -7.4486999511718750e+01 1.5249400138854980e+01 -1.7660400390625000e+01 -7.5453201293945312e+01 1.7693899154663086e+01 -1.6711999893188477e+01 -7.6013404846191406e+01 1.9698200225830078e+01 -1.6181100845336914e+01 -7.6411094665527344e+01 2.2063400268554688e+01 -1.5812499046325684e+01 -7.6466499328613281e+01 2.2657899856567383e+01 -1.5761699676513672e+01 -7.6511299133300781e+01 2.4988298416137695e+01 -1.5720600128173828e+01 -7.6277000427246094e+01 2.7348899841308594e+01 -1.5935999870300293e+01 -7.6852203369140625e+01 5.8000000000000000e+01 -1.5411299705505371e+01 -7.5712005615234375e+01 2.9878499984741211e+01 -1.6465000152587891e+01 -7.4909095764160156e+01 3.2187301635742188e+01 -1.7240800857543945e+01 -7.4683502197265625e+01 3.2721401214599609e+01 -1.7464000701904297e+01 -7.3487701416015625e+01 3.5102600097656250e+01 -1.8688098907470703e+01 -7.2096496582031250e+01 3.7287799835205078e+01 -2.0204700469970703e+01 -6.9476402282714844e+01 4.0921699523925781e+01 -2.3373401641845703e+01 -6.8487998962402344e+01 4.2250202178955078e+01 -2.4753698348999023e+01 -6.5393699645996094e+01 4.8849000930786133e+00 -2.9393098831176758e+01 -6.7013198852539062e+01 5.8596100807189941e+00 -2.6814001083374023e+01 -6.8458999633789062e+01 -5.0000000000000000e-01 -2.4732900619506836e+01 -6.8466400146484375e+01 7.0421099662780762e+00 -2.4738100051879883e+01 -6.8713798522949219e+01 7.2433900833129883e+00 -2.4384901046752930e+01 -6.2187297821044922e+01 -5.0000000000000000e-01 -3.5595802307128906e+01 -6.3157604217529297e+01 4.2165498733520508e+00 -3.3523601531982422e+01 -6.4475601196289062e+01 4.5016398429870605e+00 -3.0996900558471680e+01 -5.8311203002929688e+01 -5.0000000000000000e-01 -4.7525398254394531e+01 -5.9021396636962891e+01 3.7991399765014648e+00 -4.4557197570800781e+01 -6.2357002258300781e+01 4.1357898712158203e+00 -3.5659397125244141e+01 -5.7005401611328125e+01 3.2454099655151367e+00 -5.9194599151611328e+01 -5.7121398925781250e+01 3.3592000007629395e+00 -5.6186298370361328e+01 -5.8530597686767578e+01 3.6855299472808838e+00 -4.7561199188232422e+01 -8.7000000000000000e+01 5.8000000000000000e+01 -8.0385198593139648e+00 -8.7000000000000000e+01 -5.0000000000000000e-01 -8.0385198593139648e+00 -9.8458999633789062e+01 5.8000000000000000e+01 -2.9366600513458252e+00 -9.8458999633789062e+01 -5.0000000000000000e-01 -2.9366600513458252e+00 -1.1072800445556641e+02 5.8000000000000000e+01 -3.2872101664543152e-01 -1.1072800445556641e+02 -5.0000000000000000e-01 -3.2872101664543152e-01 -1.2327200317382812e+02 5.8000000000000000e+01 -3.2872101664543152e-01 -1.2327200317382812e+02 -5.0000000000000000e-01 -3.2872101664543152e-01 -1.3554100036621094e+02 5.8000000000000000e+01 -2.9366600513458252e+00 -1.3554100036621094e+02 -5.0000000000000000e-01 -2.9366600513458252e+00 -1.4700000000000000e+02 5.8000000000000000e+01 -8.0385198593139648e+00 -1.4700000000000000e+02 -5.0000000000000000e-01 -8.0385198593139648e+00 -1.5714801025390625e+02 5.8000000000000000e+01 -1.5411299705505371e+01 -1.5714801025390625e+02 -5.0000000000000000e-01 -1.5411299705505371e+01 -1.6554100036621094e+02 5.8000000000000000e+01 -2.4732900619506836e+01 -1.6554100036621094e+02 -5.0000000000000000e-01 -2.4732900619506836e+01 -1.7181300354003906e+02 5.8000000000000000e+01 -3.5595802307128906e+01 -1.7181300354003906e+02 -5.0000000000000000e-01 -3.5595802307128906e+01 -1.7568899536132812e+02 5.8000000000000000e+01 -4.7525398254394531e+01 -1.7568899536132812e+02 -5.0000000000000000e-01 -4.7525398254394531e+01 -1.7700000000000000e+02 5.8000000000000000e+01 -6.0000000000000000e+01 -1.7700000000000000e+02 -5.0000000000000000e-01 -6.0000000000000000e+01 -1.7568899536132812e+02 5.8000000000000000e+01 -7.2474601745605469e+01 -1.7568899536132812e+02 -5.0000000000000000e-01 -7.2474601745605469e+01 -1.7181300354003906e+02 5.8000000000000000e+01 -8.4404197692871094e+01 -1.7181300354003906e+02 -5.0000000000000000e-01 -8.4404197692871094e+01 -1.6554100036621094e+02 5.8000000000000000e+01 -9.5267105102539062e+01 -1.6554100036621094e+02 -5.0000000000000000e-01 -9.5267105102539062e+01 -1.5714801025390625e+02 5.8000000000000000e+01 -1.0458899688720703e+02 -1.5714801025390625e+02 -5.0000000000000000e-01 -1.0458899688720703e+02 -1.4700000000000000e+02 5.8000000000000000e+01 -1.1196099853515625e+02 -1.4700000000000000e+02 -5.0000000000000000e-01 -1.1196099853515625e+02 -1.3554100036621094e+02 5.8000000000000000e+01 -1.1706300354003906e+02 -1.3554100036621094e+02 -5.0000000000000000e-01 -1.1706300354003906e+02 -1.2327200317382812e+02 5.8000000000000000e+01 -1.1967100524902344e+02 -1.2327200317382812e+02 -5.0000000000000000e-01 -1.1967100524902344e+02 -1.1072800445556641e+02 5.8000000000000000e+01 -1.1967100524902344e+02 -1.1072800445556641e+02 -5.0000000000000000e-01 -1.1967100524902344e+02 -9.8458999633789062e+01 5.8000000000000000e+01 -1.1706300354003906e+02 -9.8458999633789062e+01 -5.0000000000000000e-01 -1.1706300354003906e+02 -8.7000000000000000e+01 5.8000000000000000e+01 -1.1196099853515625e+02 -8.7000000000000000e+01 -5.0000000000000000e-01 -1.1196099853515625e+02 -1.2617400169372559e+01 6.7341899871826172e+00 -1.0487699890136719e+02 -1.1551799774169922e+01 6.3283400535583496e+00 -1.0572999572753906e+02 -3.9142097473144531e+01 3.9620399475097656e+00 -7.7857803344726562e+01 -1.0734600067138672e+01 5.9177899360656738e+00 -1.0639700317382812e+02 -1.0444600105285645e+01 5.7324800491333008e+00 -1.0663899993896484e+02 -1.0003399848937988e+01 5.3636999130249023e+00 -1.0701700592041016e+02 -9.7313995361328125e+00 4.9890899658203125e+00 -1.0726899719238281e+02 -3.9644401550292969e+01 6.4255599975585938e+00 -7.8274101257324219e+01 -1.9232299804687500e+01 8.1760292053222656e+00 -9.9765197753906250e+01 -1.7137001037597656e+01 7.8327598571777344e+00 -1.0135900115966797e+02 -1.5025700569152832e+01 7.4007501602172852e+00 -1.0298699951171875e+02 -1.4627500534057617e+01 7.2964997291564941e+00 -1.0329800415039062e+02 -1.3271500587463379e+01 6.9414401054382324e+00 -1.0435900115966797e+02 -4.0934600830078125e+01 8.2491006851196289e+00 -7.9500602722167969e+01 -4.2677700042724609e+01 8.9589900970458984e+00 -8.1218894958496094e+01 -3.5388397216796875e+01 9.2135095596313477e+00 -8.8508201599121094e+01 -3.3494400024414062e+01 9.2281103134155273e+00 -8.9679000854492188e+01 -3.0985898971557617e+01 9.1820898056030273e+00 -9.1317306518554688e+01 -2.8295000076293945e+01 9.0646104812622070e+00 -9.3157798767089844e+01 -2.5246500015258789e+01 8.8539094924926758e+00 -9.5320899963378906e+01 -2.4774198532104492e+01 8.8081903457641602e+00 -9.5665901184082031e+01 -2.2200500488281250e+01 8.5588092803955078e+00 -9.7546195983886719e+01 -4.2238899230957031e+01 3.7785801887512207e+00 -7.3655502319335938e+01 -4.2695701599121094e+01 3.7515201568603516e+00 -7.3035705566406250e+01 -4.3312099456787109e+01 6.2268400192260742e+00 -7.3273895263671875e+01 -4.4661998748779297e+01 3.5045099258422852e+00 -6.7377403259277344e+01 -4.5000000000000000e+01 3.3447098731994629e+00 -6.3715698242187500e+01 -4.5330902099609375e+01 5.9938397407531738e+00 -6.7415100097656250e+01 -4.5669898986816406e+01 5.8431601524353027e+00 -6.3628398895263672e+01 -4.7128700256347656e+01 7.8214397430419922e+00 -6.7686103820800781e+01 -4.7500000000000000e+01 7.6721901893615723e+00 -6.3564598083496094e+01 -4.9577400207519531e+01 8.5014705657958984e+00 -6.8118400573730469e+01 -5.0000000000000000e+01 8.3416700363159180e+00 -6.3541194915771484e+01 -4.4928100585937500e+01 8.0522298812866211e+00 -7.4061294555664062e+01 -4.7119598388671875e+01 8.7484703063964844e+00 -7.5191200256347656e+01 -4.4155300140380859e+01 3.5681698322296143e+00 -6.8835403442382812e+01 -6.9702606201171875e+01 3.2568901062011719e+01 -1.0043600463867188e+02 -3.5388397216796875e+01 2.9182100296020508e+01 -1.0213500213623047e+02 -6.9982498168945312e+01 3.2229698181152344e+01 -1.0065699768066406e+02 -7.1237899780273438e+01 3.0462600708007812e+01 -1.0161700439453125e+02 -7.3141296386718750e+01 2.4718000411987305e+01 -1.0297600555419922e+02 -7.3098304748535156e+01 2.5276300430297852e+01 -1.0294599914550781e+02 -3.5388397216796875e+01 2.3655900955200195e+01 -1.0297500610351562e+02 -7.2761299133300781e+01 2.7045101165771484e+01 -1.0271299743652344e+02 -7.2197303771972656e+01 2.8634500503540039e+01 -1.0231600189208984e+02 -7.1914894104003906e+01 2.9172599792480469e+01 -1.0211000061035156e+02 -7.2715400695800781e+01 2.1202600479125977e+01 -1.0268099975585938e+02 -7.3079299926757812e+01 2.2964300155639648e+01 -1.0293299865722656e+02 -7.3103797912597656e+01 2.3656499862670898e+01 -1.0294999694824219e+02 -7.0472099304199219e+01 1.6814001083374023e+01 -1.0103800201416016e+02 -7.0992401123046875e+01 1.7560800552368164e+01 -1.0143299865722656e+02 -3.5388397216796875e+01 1.8206001281738281e+01 -1.0173300170898438e+02 -7.1365295410156250e+01 1.8216699600219727e+01 -1.0170800018310547e+02 -7.1976600646972656e+01 1.9291599273681641e+01 -1.0215699768066406e+02 -3.5388397216796875e+01 1.3589000701904297e+01 -9.8582496643066406e+01 -6.4755401611328125e+01 1.1525400161743164e+01 -9.5999893188476562e+01 -6.6638496398925781e+01 1.2876000404357910e+01 -9.7816604614257812e+01 -6.7393196105957031e+01 1.3504899978637695e+01 -9.8497596740722656e+01 -6.7485900878906250e+01 1.3594200134277344e+01 -9.8576705932617188e+01 -6.9023803710937500e+01 1.5076299667358398e+01 -9.9887603759765625e+01 -5.8670799255371094e+01 9.2135095596313477e+00 -8.8508201599121094e+01 -3.5388397216796875e+01 1.0446000099182129e+01 -9.3960205078125000e+01 -6.0219699859619141e+01 9.4568099975585938e+00 -9.0724998474121094e+01 -6.1911502838134766e+01 1.0022600173950195e+01 -9.2871192932128906e+01 -6.2848201751708984e+01 1.0447000503540039e+01 -9.3959899902343750e+01 -6.2869197845458984e+01 1.0456399917602539e+01 -9.3984199523925781e+01 -7.9918999671936035e+00 1.9024599075317383e+01 -1.0812200164794922e+02 -2.5355499267578125e+01 1.1245100021362305e+01 -9.9085998535156250e+01 -2.5864099502563477e+01 2.8234800338745117e+01 -1.0298600006103516e+02 -3.3687301635742188e+01 1.0779400825500488e+01 -9.4845199584960938e+01 -3.3714397430419922e+01 1.4055799484252930e+01 -9.9134605407714844e+01 -3.3572402954101562e+01 1.8633098602294922e+01 -1.0199200439453125e+02 -3.3279602050781250e+01 2.3918600082397461e+01 -1.0304599761962891e+02 -3.2873798370361328e+01 2.9227800369262695e+01 -1.0216200256347656e+02 -3.1277399063110352e+01 1.1087100028991699e+01 -9.6070106506347656e+01 -3.1254600524902344e+01 1.4466700553894043e+01 -9.9927703857421875e+01 -3.0919900894165039e+01 1.8925800323486328e+01 -1.0243900299072266e+02 -3.0312599182128906e+01 2.3943201065063477e+01 -1.0331100463867188e+02 -2.9503700256347656e+01 2.8932399749755859e+01 -1.0244000244140625e+02 -2.8554700851440430e+01 1.1253800392150879e+01 -9.7449493408203125e+01 -2.8406400680541992e+01 1.4657500267028809e+01 -1.0086599731445312e+02 -2.7865400314331055e+01 1.8923799514770508e+01 -1.0305300140380859e+02 -2.6987699508666992e+01 2.3611198425292969e+01 -1.0378500366210938e+02 -2.5010099411010742e+01 1.4577000617980957e+01 -1.0203299713134766e+02 -2.4240699768066406e+01 1.8555000305175781e+01 -1.0390100097656250e+02 -2.3115501403808594e+01 2.2826999664306641e+01 -1.0452500152587891e+02 -2.1733999252319336e+01 2.7015199661254883e+01 -1.0384899902343750e+02 -2.2078100204467773e+01 1.1023899078369141e+01 -1.0079000091552734e+02 -2.1500999450683594e+01 1.4182900428771973e+01 -1.0329899597167969e+02 -2.0511899948120117e+01 1.7802598953247070e+01 -1.0488999938964844e+02 -1.9184000015258789e+01 2.1615798950195312e+01 -1.0544499969482422e+02 -1.7615200042724609e+01 2.5340999603271484e+01 -1.0492199707031250e+02 -1.8831298828125000e+01 1.0582599639892578e+01 -1.0250800323486328e+02 -1.8009399414062500e+01 1.3470700263977051e+01 -1.0462100219726562e+02 -1.6815799713134766e+01 1.6667301177978516e+01 -1.0597499847412109e+02 -1.5321999549865723e+01 1.9981000900268555e+01 -1.0649099731445312e+02 -1.3617499351501465e+01 2.3213199615478516e+01 -1.0613700103759766e+02 -1.6517000198364258e+01 1.0109499931335449e+01 -1.0375499725341797e+02 -1.5515900611877441e+01 1.2735400199890137e+01 -1.0560300445556641e+02 -1.4183899879455566e+01 1.5578400611877441e+01 -1.0680799865722656e+02 -1.2588000297546387e+01 1.8495698928833008e+01 -1.0731100463867188e+02 -1.0808600425720215e+01 2.1340700149536133e+01 -1.0708699798583984e+02 -9.8329000473022461e+00 1.6623100280761719e+01 -1.0820800018310547e+02 -1.1520800590515137e+01 1.4160900115966797e+01 -1.0770600128173828e+02 -1.2986799240112305e+01 1.1738200187683105e+01 -1.0663499450683594e+02 -1.4171100616455078e+01 9.4538307189941406e+00 -1.0504100036621094e+02 -5.6658000946044922e+00 1.6605899810791016e+01 -1.0905300140380859e+02 -7.5483002662658691e+00 1.4640600204467773e+01 -1.0901499938964844e+02 -4.8029999732971191e+00 1.5527700424194336e+01 -1.0942099761962891e+02 -9.3048000335693359e+00 1.2625599861145020e+01 -1.0850299835205078e+02 -6.6986999511718750e+00 1.3750699996948242e+01 -1.0933499908447266e+02 -1.0877399444580078e+01 1.0627400398254395e+01 -1.0753200531005859e+02 -8.4788999557495117e+00 1.1928400039672852e+01 -1.0881500244140625e+02 -1.2214300155639648e+01 8.7116394042968750e+00 -1.0613600158691406e+02 -1.0089799880981445e+01 1.0115600585937500e+01 -1.0787899780273438e+02 -3.4052999019622803e+00 1.3438699722290039e+01 -1.1005500030517578e+02 -2.3445999622344971e+00 1.1353199958801270e+01 -1.1058799743652344e+02 -1.9723000526428223e+00 1.0420899391174316e+01 -1.1079499816894531e+02 -1.4152998924255371e+00 8.5805597305297852e+00 -1.1114800262451172e+02 -1.0873999595642090e+00 6.7317500114440918e+00 -1.1143099975585938e+02 -5.3198003768920898e+00 1.2018899917602539e+01 -1.0988500213623047e+02 -4.2699999809265137e+00 1.0282600402832031e+01 -1.1034799957275391e+02 -3.9005999565124512e+00 9.5047302246093750e+00 -1.1052799987792969e+02 -3.3458001613616943e+00 7.9672894477844238e+00 -1.1083399963378906e+02 -3.0157001018524170e+00 6.4212698936462402e+00 -1.1107800292968750e+02 -7.1357998847961426e+00 1.0560999870300293e+01 -1.0935000610351562e+02 -6.1104001998901367e+00 9.1796503067016602e+00 -1.0979399871826172e+02 -5.7486996650695801e+00 8.5582695007324219e+00 -1.0996399688720703e+02 -5.2033996582031250e+00 7.3269000053405762e+00 -1.1025000000000000e+02 -4.8758001327514648e+00 6.0857501029968262e+00 -1.1047200012207031e+02 -8.8072004318237305e+00 9.1021604537963867e+00 -1.0846299743652344e+02 -7.8256998062133789e+00 8.0684394836425781e+00 -1.0893700408935547e+02 -7.4786000251770020e+00 7.6010198593139648e+00 -1.0911499786376953e+02 -6.9535999298095703e+00 6.6713099479675293e+00 -1.0940799713134766e+02 -6.6353998184204102e+00 5.7310500144958496e+00 -1.0962500000000000e+02 -1.1483299255371094e+01 8.3667001724243164e+00 -1.0655300140380859e+02 -1.0291799545288086e+01 7.6792197227478027e+00 -1.0724599456787109e+02 -9.3783998489379883e+00 6.9731502532958984e+00 -1.0779599761962891e+02 -9.0546998977661133e+00 6.6525297164916992e+00 -1.0799900054931641e+02 -8.5635995864868164e+00 6.0128002166748047e+00 -1.0832399749755859e+02 -8.2634000778198242e+00 5.3633399009704590e+00 -1.0855100250244141e+02 -9.3933992385864258e+00 0.0000000000000000e+00 -1.0760700225830078e+02 -3.9142097473144531e+01 0.0000000000000000e+00 -7.7857803344726562e+01 -9.4779996871948242e+00 2.5002400875091553e+00 -1.0752200317382812e+02 -4.5000000000000000e+01 0.0000000000000000e+00 -6.3715698242187500e+01 -4.4615699768066406e+01 0.0000000000000000e+00 -6.7617500305175781e+01 -4.4236598968505859e+01 0.0000000000000000e+00 -6.8867202758789062e+01 -4.3477600097656250e+01 0.0000000000000000e+00 -7.1369300842285156e+01 -4.2245101928710938e+01 0.0000000000000000e+00 -7.3675300598144531e+01 -4.1629398345947266e+01 0.0000000000000000e+00 -7.4827095031738281e+01 -5.7305599212646484e+01 9.1100902557373047e+00 -8.5546501159667969e+01 -5.3429801940917969e+01 8.6853504180908203e+00 -7.3383697509765625e+01 -5.2005897521972656e+01 8.2423696517944336e+00 -6.0697998046875000e+01 -5.0000000000000000e+01 8.2423696517944336e+00 -6.0697998046875000e+01 -4.8086597442626953e+01 7.8619699478149414e+00 -6.0711299896240234e+01 -4.7547500610351562e+01 7.5019598007202148e+00 -6.0723800659179688e+01 -4.6464500427246094e+01 6.7787799835205078e+00 -6.0749099731445312e+01 -4.5740898132324219e+01 5.6964802742004395e+00 -6.0786899566650391e+01 -4.5380599975585938e+01 5.1576499938964844e+00 -6.0805702209472656e+01 -4.5000000000000000e+01 3.2454099655151367e+00 -6.0872497558593750e+01 -7.1130798339843750e+01 3.5996898651123047e+01 -9.9158599853515625e+01 -6.9831398010253906e+01 3.4861099243164062e+01 -9.8997100830078125e+01 -7.1101898193359375e+01 3.3322402954101562e+01 -1.0023899841308594e+02 -7.2357604980468750e+01 3.4284698486328125e+01 -1.0048799896240234e+02 -7.1366302490234375e+01 3.2959201812744141e+01 -1.0048799896240234e+02 -7.3465301513671875e+01 2.9063598632812500e+01 -1.0237100219726562e+02 -7.2554702758789062e+01 3.1053100585937500e+01 -1.0157500457763672e+02 -7.4001602172851562e+01 2.7324199676513672e+01 -1.0282500457763672e+02 -7.4322402954101562e+01 2.5382499694824219e+01 -1.0309200286865234e+02 -7.4304405212402344e+01 2.2841600418090820e+01 -1.0307700347900391e+02 -7.4363403320312500e+01 2.4768899917602539e+01 -1.0312599945068359e+02 -7.3958000183105469e+01 2.0907899856567383e+01 -1.0278900146484375e+02 -7.3255599975585938e+01 1.8818498611450195e+01 -1.0219000244140625e+02 -7.2321899414062500e+01 1.6938301086425781e+01 -1.0136699676513672e+02 -7.1829200744628906e+01 1.6131999969482422e+01 -1.0091799926757812e+02 -7.0461494445800781e+01 1.4272299766540527e+01 -9.9621803283691406e+01 -6.8928596496582031e+01 1.2617499351501465e+01 -9.8069396972656250e+01 -7.2612998962402344e+01 3.3881298065185547e+01 -1.0075399780273438e+02 -7.3761497497558594e+01 3.1768400192260742e+01 -1.0191600036621094e+02 -7.4642196655273438e+01 2.9567899703979492e+01 -1.0276499938964844e+02 -7.5161102294921875e+01 2.7646800994873047e+01 -1.0325000000000000e+02 -7.5471496582031250e+01 2.5504098892211914e+01 -1.0353499603271484e+02 -7.5511199951171875e+01 2.4827201843261719e+01 -1.0357099914550781e+02 -7.5454101562500000e+01 2.2700901031494141e+01 -1.0351899719238281e+02 -7.5118896484375000e+01 2.0566900253295898e+01 -1.0321099853515625e+02 -7.4439399719238281e+01 1.8258800506591797e+01 -1.0257199859619141e+02 -7.3536499023437500e+01 1.6178300857543945e+01 -1.0169299316406250e+02 -7.3060295104980469e+01 1.5284700393676758e+01 -1.0121399688720703e+02 -7.1739097595214844e+01 1.3218899726867676e+01 -9.9827499389648438e+01 -7.0259696960449219e+01 1.1373499870300293e+01 -9.8164703369140625e+01 -6.9578201293945312e+01 1.0643300056457520e+01 -9.7355499267578125e+01 -6.7887596130371094e+01 9.0993595123291016e+00 -9.5215003967285156e+01 -6.8222000122070312e+01 1.1965299606323242e+01 -9.7314903259277344e+01 -6.6467300415039062e+01 1.0592999458312988e+01 -9.5322105407714844e+01 -6.4723297119140625e+01 9.5500307083129883e+00 -9.3147201538085938e+01 -6.3843303680419922e+01 9.1466302871704102e+00 -9.1963203430175781e+01 -6.2298599243164062e+01 8.6612100601196289e+00 -8.9714500427246094e+01 -6.0894500732421875e+01 8.5186901092529297e+00 -8.7439002990722656e+01 -6.6209503173828125e+01 7.9142999649047852e+00 -9.2873001098632812e+01 -6.5363899230957031e+01 7.4504599571228027e+00 -9.1595298767089844e+01 -6.3880504608154297e+01 6.8807001113891602e+00 -8.9163803100585938e+01 -6.2533802032470703e+01 6.6930599212646484e+00 -8.6696701049804688e+01 -5.7652900695800781e+01 6.1764097213745117e+00 -7.2570602416992188e+01 -6.1261299133300781e+01 6.5919198989868164e+00 -8.3930000305175781e+01 -5.9583400726318359e+01 8.4178400039672852e+00 -8.4589195251464844e+01 -5.5864597320556641e+01 8.0038299560546875e+00 -7.2888206481933594e+01 -5.6334800720214844e+01 5.7431998252868652e+00 -6.0727199554443359e+01 -5.4505001068115234e+01 7.5721096992492676e+00 -6.0687797546386719e+01 -5.0000000000000000e+01 8.2423696517944336e+00 -5.9301998138427734e+01 -5.2005897521972656e+01 8.2423696517944336e+00 -5.9301998138427734e+01 -5.2000000000000000e+01 8.2301502227783203e+00 -6.0000000000000000e+01 -5.6330200195312500e+01 5.7301497459411621e+00 -6.0000000000000000e+01 -5.4500000000000000e+01 7.5603098869323730e+00 -6.0000000000000000e+01 -5.6334800720214844e+01 5.7431998252868652e+00 -5.9272800445556641e+01 -5.4505001068115234e+01 7.5721096992492676e+00 -5.9312198638916016e+01 -7.0145195007324219e+01 3.7315498352050781e+01 -9.8003799438476562e+01 -6.7457199096679688e+01 4.0826000213623047e+01 -9.4521598815917969e+01 -6.6036796569824219e+01 3.9522399902343750e+01 -9.4377197265625000e+01 -6.8813896179199219e+01 3.6134498596191406e+01 -9.7846405029296875e+01 -6.4997894287109375e+01 4.3948200225830078e+01 -9.0798698425292969e+01 -6.2794403076171875e+01 4.6688098907470703e+01 -8.6849304199218750e+01 -6.1128097534179688e+01 4.8730499267578125e+01 -8.3293403625488281e+01 -5.9484798431396484e+01 4.7134700775146484e+01 -8.3192993164062500e+01 -6.1211997985839844e+01 4.5170501708984375e+01 -8.6734504699707031e+01 -6.3493400573730469e+01 4.2532299041748047e+01 -9.0668403625488281e+01 -5.9576999664306641e+01 5.0611999511718750e+01 -7.9284805297851562e+01 -5.8316200256347656e+01 5.2129299163818359e+01 -7.5159996032714844e+01 -5.7875396728515625e+01 4.8942199707031250e+01 -7.9200904846191406e+01 -5.6565799713134766e+01 5.0398200988769531e+01 -7.5093498229980469e+01 -5.6419700622558594e+01 5.0559902191162109e+01 -7.4557701110839844e+01 -5.7288597106933594e+01 5.3358600616455078e+01 -7.0574905395507812e+01 -5.8175601959228516e+01 5.2297801971435547e+01 -7.4621902465820312e+01 -5.5497402191162109e+01 5.1576698303222656e+01 -7.0528297424316406e+01 -5.4873897552490234e+01 5.2260902404785156e+01 -6.6460403442382812e+01 -5.4548900604248047e+01 5.2616397857666016e+01 -6.2339099884033203e+01 -5.6689300537109375e+01 5.4072799682617188e+01 -6.6489097595214844e+01 -5.6377101898193359e+01 5.4444099426269531e+01 -6.2349498748779297e+01 -5.6331501007080078e+01 5.4498401641845703e+01 -5.9606700897216797e+01 -5.4501399993896484e+01 5.2668300628662109e+01 -5.9608501434326172e+01 -5.4676498413085938e+01 5.2476902008056641e+01 -5.5558300018310547e+01 -5.5144298553466797e+01 5.1964500427246094e+01 -5.1527500152587891e+01 -5.6499702453613281e+01 5.4298500061035156e+01 -5.5538501739501953e+01 -5.6949199676513672e+01 5.3763401031494141e+01 -5.1489799499511719e+01 -5.7681900024414062e+01 5.2888797760009766e+01 -4.7460899353027344e+01 -5.5906501770019531e+01 5.1126499176025391e+01 -4.7516101837158203e+01 -5.6315299987792969e+01 5.0675197601318359e+01 -4.5838199615478516e+01 -5.7508399963378906e+01 4.9351600646972656e+01 -4.1848400115966797e+01 -5.8978599548339844e+01 4.7705501556396484e+01 -3.7973800659179688e+01 -5.8075199127197266e+01 5.2418102264404297e+01 -4.5775699615478516e+01 -5.9223499298095703e+01 5.1038398742675781e+01 -4.1768901824951172e+01 -6.0640098571777344e+01 4.9324401855468750e+01 -3.7878200531005859e+01 -6.2317501068115234e+01 4.7275199890136719e+01 -3.4108200073242188e+01 -6.0717800140380859e+01 4.5735198974609375e+01 -3.4219200134277344e+01 -6.2298397064208984e+01 4.3920700073242188e+01 -3.1305398941040039e+01 -6.3843399047851562e+01 4.5389801025390625e+01 -3.1182899475097656e+01 -6.8512901306152344e+01 3.9460800170898438e+01 -2.4047401428222656e+01 -6.6073898315429688e+01 4.2591197967529297e+01 -2.7497900009155273e+01 -7.1130798339843750e+01 3.5996898651123047e+01 -2.0841400146484375e+01 -6.4606597900390625e+01 4.1224597930908203e+01 -2.7634700775146484e+01 -6.7127899169921875e+01 3.8205398559570312e+01 -2.4197299957275391e+01 -6.9831398010253906e+01 3.4861099243164062e+01 -2.1002899169921875e+01 -4.6144003868103027e+00 3.0490701198577881e+00 -1.1076200103759766e+02 -2.6191999912261963e+00 0.0000000000000000e+00 -1.1123800659179688e+02 -6.1444997787475586e+00 0.0000000000000000e+00 -1.0977700042724609e+02 -4.5271000862121582e+00 0.0000000000000000e+00 -1.1085800170898438e+02 -9.3933992385864258e+00 -5.3301997184753418e+00 -1.0730699920654297e+02 -3.9142097473144531e+01 -3.9639501571655273e+00 -7.7335899353027344e+01 -9.3933992385864258e+00 -1.0593400001525879e+01 -1.0641300201416016e+02 -3.9142097473144531e+01 -4.6219201087951660e+00 -7.7249305725097656e+01 -9.3933992385864258e+00 -1.5723500251770020e+01 -1.0493499755859375e+02 -3.9142097473144531e+01 -7.7005000114440918e+00 -7.5974205017089844e+01 -9.3933992385864258e+00 -2.0655698776245117e+01 -1.0289199829101562e+02 -3.9142097473144531e+01 -8.9288902282714844e+00 -7.5465301513671875e+01 -9.3933992385864258e+00 -2.5328199386596680e+01 -1.0030999755859375e+02 -3.9142097473144531e+01 -1.1043099403381348e+01 -7.3843101501464844e+01 -9.3933992385864258e+00 -2.9682199478149414e+01 -9.7220298767089844e+01 -3.9142097473144531e+01 -1.2627400398254395e+01 -7.2627403259277344e+01 -9.3933992385864258e+00 -3.3662899017333984e+01 -9.3662902832031250e+01 -3.9142097473144531e+01 -1.3843099594116211e+01 -7.1043098449707031e+01 -9.3933992385864258e+00 -3.7220298767089844e+01 -8.9682197570800781e+01 -3.9142097473144531e+01 -1.5465299606323242e+01 -6.8928894042968750e+01 -9.3933992385864258e+00 -4.0309600830078125e+01 -8.5328201293945312e+01 -3.9142097473144531e+01 -1.5974199295043945e+01 -6.7700500488281250e+01 -9.3933992385864258e+00 -4.2892002105712891e+01 -8.0655700683593750e+01 -9.3933992385864258e+00 -4.4934997558593750e+01 -7.5723495483398438e+01 -3.9142097473144531e+01 -1.7249300003051758e+01 -6.4621902465820312e+01 -9.3933992385864258e+00 -4.6413002014160156e+01 -7.0593399047851562e+01 -3.9142097473144531e+01 -1.7335899353027344e+01 -6.3963897705078125e+01 -9.3933992385864258e+00 -4.7307201385498047e+01 -6.5330200195312500e+01 -3.9142097473144531e+01 -1.7857799530029297e+01 -6.0000000000000000e+01 -9.3933992385864258e+00 -4.7606597900390625e+01 -6.0000000000000000e+01 -9.3933992385864258e+00 -4.7307201385498047e+01 -5.4669799804687500e+01 -3.9142097473144531e+01 -1.7335899353027344e+01 -5.6036098480224609e+01 -9.3933992385864258e+00 -4.6413002014160156e+01 -4.9406600952148438e+01 -3.9142097473144531e+01 -1.7249300003051758e+01 -5.5378101348876953e+01 -9.3933992385864258e+00 -4.4934997558593750e+01 -4.4276496887207031e+01 -3.9142097473144531e+01 -1.5974199295043945e+01 -5.2299499511718750e+01 -9.3933992385864258e+00 -4.2892002105712891e+01 -3.9344299316406250e+01 -3.9142097473144531e+01 -1.5465299606323242e+01 -5.1071098327636719e+01 -9.3933992385864258e+00 -4.0309600830078125e+01 -3.4671798706054688e+01 -3.9142097473144531e+01 -1.3843099594116211e+01 -4.8956901550292969e+01 -9.3933992385864258e+00 -3.7220298767089844e+01 -3.0317800521850586e+01 -3.9142097473144531e+01 -1.2627400398254395e+01 -4.7372596740722656e+01 -9.3933992385864258e+00 -3.3662899017333984e+01 -2.6337100982666016e+01 -3.9142097473144531e+01 -1.1043099403381348e+01 -4.6156898498535156e+01 -9.3933992385864258e+00 -2.9682199478149414e+01 -2.2779699325561523e+01 -3.9142097473144531e+01 -8.9288902282714844e+00 -4.4534702301025391e+01 -9.3933992385864258e+00 -2.5328199386596680e+01 -1.9690399169921875e+01 -3.9142097473144531e+01 -7.7005000114440918e+00 -4.4025802612304688e+01 -9.3933992385864258e+00 0.0000000000000000e+00 -1.2393400192260742e+01 -3.9142097473144531e+01 0.0000000000000000e+00 -4.2142200469970703e+01 -9.3933992385864258e+00 -5.3301997184753418e+00 -1.2692799568176270e+01 -3.9142097473144531e+01 -3.9639501571655273e+00 -4.2664100646972656e+01 -9.3933992385864258e+00 -1.0593400001525879e+01 -1.3586999893188477e+01 -3.9142097473144531e+01 -4.6219201087951660e+00 -4.2750701904296875e+01 -9.3933992385864258e+00 -1.5723500251770020e+01 -1.5065000534057617e+01 -9.3933992385864258e+00 -2.0655698776245117e+01 -1.7108001708984375e+01 -2.6691000461578369e+00 -5.7648997306823730e+00 -1.1116500091552734e+02 -6.2867999076843262e+00 -5.5971097946166992e+00 -1.0967600250244141e+02 -2.6691000461578369e+00 -1.1457300186157227e+01 -1.1019799804687500e+02 -2.6691000461578369e+00 -1.7005701065063477e+01 -1.0859899902343750e+02 -2.6691000461578369e+00 -2.2340200424194336e+01 -1.0638999938964844e+02 -2.6691000461578369e+00 -2.7393699645996094e+01 -1.0359700012207031e+02 -2.6691000461578369e+00 -3.2102802276611328e+01 -1.0025600433349609e+02 -2.6691000461578369e+00 -3.6408100128173828e+01 -9.6408096313476562e+01 -2.6691000461578369e+00 -4.0255599975585938e+01 -9.2102806091308594e+01 -2.6691000461578369e+00 -4.3596900939941406e+01 -8.7393699645996094e+01 -2.6691000461578369e+00 -4.6389900207519531e+01 -8.2340202331542969e+01 -2.6691000461578369e+00 -4.8599498748779297e+01 -7.7005699157714844e+01 -2.6691000461578369e+00 -5.0197998046875000e+01 -7.1457298278808594e+01 -2.6691000461578369e+00 -5.1165100097656250e+01 -6.5764900207519531e+01 -2.6691000461578369e+00 -5.1488899230957031e+01 -6.0000000000000000e+01 -2.6691000461578369e+00 -5.1165100097656250e+01 -5.4235099792480469e+01 -2.6691000461578369e+00 -5.0197998046875000e+01 -4.8542701721191406e+01 -2.6691000461578369e+00 -4.8599498748779297e+01 -4.2994300842285156e+01 -2.6691000461578369e+00 -4.6389900207519531e+01 -3.7659801483154297e+01 -2.6691000461578369e+00 -4.3596900939941406e+01 -3.2606300354003906e+01 -2.6691000461578369e+00 -4.0255599975585938e+01 -2.7897199630737305e+01 -2.6691000461578369e+00 -3.6408100128173828e+01 -2.3591899871826172e+01 -2.6691000461578369e+00 -3.2102802276611328e+01 -1.9744400024414062e+01 -2.6691000461578369e+00 -2.7393699645996094e+01 -1.6403099060058594e+01 -2.6691000461578369e+00 -2.2340200424194336e+01 -1.3610100746154785e+01 -2.6691000461578369e+00 -1.7005701065063477e+01 -1.1400500297546387e+01 -2.6691000461578369e+00 -1.1457300186157227e+01 -9.8020496368408203e+00 -2.6691000461578369e+00 -5.7648997306823730e+00 -8.8348999023437500e+00 -2.6191999912261963e+00 0.0000000000000000e+00 -8.7623004913330078e+00 -4.5271000862121582e+00 0.0000000000000000e+00 -9.1418695449829102e+00 -6.2867999076843262e+00 -1.1123900413513184e+01 -1.0873699951171875e+02 -6.2867999076843262e+00 -1.6510700225830078e+01 -1.0718499755859375e+02 -6.2867999076843262e+00 -2.1690000534057617e+01 -1.0504000091552734e+02 -6.2867999076843262e+00 -2.6596500396728516e+01 -1.0232800292968750e+02 -6.2867999076843262e+00 -3.1168500900268555e+01 -9.9083999633789062e+01 -6.2867999076843262e+00 -3.5348499298095703e+01 -9.5348503112792969e+01 -6.2867999076843262e+00 -3.9083999633789062e+01 -9.1168502807617188e+01 -6.2867999076843262e+00 -4.2327999114990234e+01 -8.6596496582031250e+01 -6.2867999076843262e+00 -4.5039798736572266e+01 -8.1689994812011719e+01 -6.2867999076843262e+00 -4.7185100555419922e+01 -7.6510696411132812e+01 -6.2867999076843262e+00 -4.8736999511718750e+01 -7.1123901367187500e+01 -6.2867999076843262e+00 -4.9676002502441406e+01 -6.5597099304199219e+01 -6.2867999076843262e+00 -4.9990299224853516e+01 -6.0000000000000000e+01 -6.2867999076843262e+00 -4.9676002502441406e+01 -5.4402900695800781e+01 -6.2867999076843262e+00 -4.8736999511718750e+01 -4.8876098632812500e+01 -6.2867999076843262e+00 -4.7185100555419922e+01 -4.3489299774169922e+01 -6.2867999076843262e+00 -4.5039798736572266e+01 -3.8309997558593750e+01 -6.2867999076843262e+00 -4.2327999114990234e+01 -3.3403499603271484e+01 -6.2867999076843262e+00 -3.9083999633789062e+01 -2.8831501007080078e+01 -6.2867999076843262e+00 -3.5348499298095703e+01 -2.4651498794555664e+01 -6.2867999076843262e+00 -3.1168500900268555e+01 -2.0916000366210938e+01 -6.2867999076843262e+00 -2.6596500396728516e+01 -1.7672000885009766e+01 -6.2867999076843262e+00 -2.1690000534057617e+01 -1.4960199356079102e+01 -6.2867999076843262e+00 -1.6510700225830078e+01 -1.2814899444580078e+01 -6.2867999076843262e+00 -1.1123900413513184e+01 -1.1262999534606934e+01 -6.2867999076843262e+00 -5.5971097946166992e+00 -1.0324000358581543e+01 -6.1444997787475586e+00 0.0000000000000000e+00 -1.0222599983215332e+01 -4.5000000000000000e+01 -3.5890898704528809e+00 -5.9038299560546875e+01 -4.5000000000000000e+01 3.2454099655151367e+00 -5.9127498626708984e+01 -4.5000000000000000e+01 -3.7156898975372314e+00 -6.0000000000000000e+01 -4.5000000000000000e+01 -3.2178699970245361e+00 -5.8142200469970703e+01 -4.5000000000000000e+01 -2.6273698806762695e+00 -5.7372600555419922e+01 -4.5000000000000000e+01 -1.8578199148178101e+00 -5.6782100677490234e+01 -4.5000000000000000e+01 -9.6170097589492798e-01 -5.6410900115966797e+01 -4.5000000000000000e+01 0.0000000000000000e+00 -5.6284301757812500e+01 -4.5000000000000000e+01 3.3447098731994629e+00 -5.6284301757812500e+01 -4.5000000000000000e+01 -9.6170097589492798e-01 -6.3589103698730469e+01 -4.5000000000000000e+01 -1.8578199148178101e+00 -6.3217899322509766e+01 -4.5000000000000000e+01 -2.6273698806762695e+00 -6.2627395629882812e+01 -4.5000000000000000e+01 -3.2178699970245361e+00 -6.1857799530029297e+01 -4.5000000000000000e+01 -3.5890898704528809e+00 -6.0961700439453125e+01 -4.8086597442626953e+01 7.8619699478149414e+00 -5.9288700103759766e+01 -4.7547500610351562e+01 7.5019598007202148e+00 -5.9276199340820312e+01 -4.6464500427246094e+01 6.7787799835205078e+00 -5.9250900268554688e+01 -4.5740898132324219e+01 5.6964802742004395e+00 -5.9213096618652344e+01 -4.5380599975585938e+01 5.1576499938964844e+00 -5.9194301605224609e+01 -4.1629398345947266e+01 -3.8375201225280762e+00 -7.4321907043457031e+01 -4.1629398345947266e+01 -7.4135699272155762e+00 -7.2840599060058594e+01 -4.1629398345947266e+01 -1.0484299659729004e+01 -7.0484306335449219e+01 -4.1629398345947266e+01 -1.2840600013732910e+01 -6.7413597106933594e+01 -4.1629398345947266e+01 -1.4321900367736816e+01 -6.3837497711181641e+01 -4.1629398345947266e+01 -1.4827099800109863e+01 -6.0000000000000000e+01 -4.1629398345947266e+01 -1.4321900367736816e+01 -5.6162498474121094e+01 -4.1629398345947266e+01 -1.2840600013732910e+01 -5.2586399078369141e+01 -4.1629398345947266e+01 -1.0484299659729004e+01 -4.9515701293945312e+01 -4.4615699768066406e+01 -1.9715400934219360e+00 -5.2641998291015625e+01 -4.4615699768066406e+01 0.0000000000000000e+00 -5.2382499694824219e+01 -4.4615699768066406e+01 -1.9715400934219360e+00 -6.7358001708984375e+01 -4.3477600097656250e+01 -2.9425599575042725e+00 -4.9017997741699219e+01 -4.3477600097656250e+01 0.0000000000000000e+00 -4.8630699157714844e+01 -4.4236598968505859e+01 0.0000000000000000e+00 -5.1132797241210938e+01 -4.4615699768066406e+01 -5.3863501548767090e+00 -6.5386398315429688e+01 -4.4615699768066406e+01 -3.8087401390075684e+00 -6.6596900939941406e+01 -4.3477600097656250e+01 -5.6846699714660645e+00 -6.9846099853515625e+01 -4.3477600097656250e+01 -2.9425599575042725e+00 -7.0982002258300781e+01 -4.1629398345947266e+01 -7.4135699272155762e+00 -4.7159400939941406e+01 -4.1629398345947266e+01 -3.8375201225280762e+00 -4.5678100585937500e+01 -4.2245101928710938e+01 0.0000000000000000e+00 -4.6324699401855469e+01 -4.1629398345947266e+01 0.0000000000000000e+00 -4.5172901153564453e+01 -4.3477600097656250e+01 -5.6846699714660645e+00 -5.0153900146484375e+01 -4.3477600097656250e+01 -8.0393495559692383e+00 -5.1960597991943359e+01 -4.4615699768066406e+01 -3.8087401390075684e+00 -5.3403102874755859e+01 -4.3477600097656250e+01 -9.8461503982543945e+00 -5.4315299987792969e+01 -4.4615699768066406e+01 -5.3863501548767090e+00 -5.4613601684570312e+01 -4.3477600097656250e+01 -1.0982000350952148e+01 -5.7057399749755859e+01 -4.4615699768066406e+01 -6.5969200134277344e+00 -5.6191299438476562e+01 -4.3477600097656250e+01 -1.1369299888610840e+01 -6.0000000000000000e+01 -4.4615699768066406e+01 -7.3579497337341309e+00 -5.8028499603271484e+01 -4.3477600097656250e+01 -1.0982000350952148e+01 -6.2942600250244141e+01 -4.4615699768066406e+01 -7.6175298690795898e+00 -6.0000000000000000e+01 -4.3477600097656250e+01 -9.8461503982543945e+00 -6.5684700012207031e+01 -4.4615699768066406e+01 -7.3579497337341309e+00 -6.1971500396728516e+01 -4.3477600097656250e+01 -8.0393495559692383e+00 -6.8039405822753906e+01 -4.4615699768066406e+01 -6.5969200134277344e+00 -6.3808700561523438e+01 -4.2677700042724609e+01 8.9589900970458984e+00 -3.8781097412109375e+01 -3.5388397216796875e+01 9.2135095596313477e+00 -3.1491800308227539e+01 -5.8670799255371094e+01 9.2135095596313477e+00 -3.1491800308227539e+01 -5.2131401062011719e+01 8.3561506271362305e+00 -5.6042999267578125e+01 -5.0000000000000000e+01 8.3416700363159180e+00 -5.6458801269531250e+01 -5.4189903259277344e+01 8.7960901260375977e+00 -4.3444801330566406e+01 -4.8878597259521484e+01 8.6001701354980469e+00 -4.9055198669433594e+01 -4.5614898681640625e+01 8.8355503082275391e+00 -4.2315700531005859e+01 -9.7313995361328125e+00 4.9890899658203125e+00 -1.2731299400329590e+01 -3.9142097473144531e+01 3.9620399475097656e+00 -4.2142200469970703e+01 -9.4779996871948242e+00 2.5002400875091553e+00 -1.2477999687194824e+01 -6.2847599029541016e+01 1.0445799827575684e+01 -2.6040100097656250e+01 -6.1093200683593750e+01 9.7147808074951172e+00 -2.8135700225830078e+01 -6.0098499298095703e+01 9.4273099899291992e+00 -2.9438699722290039e+01 -6.2848003387451172e+01 1.0446000099182129e+01 -2.6039798736572266e+01 -3.5388397216796875e+01 1.0446000099182129e+01 -2.6039798736572266e+01 -6.4690002441406250e+01 1.1483600616455078e+01 -2.4066499710083008e+01 -3.5388397216796875e+01 1.3589000701904297e+01 -2.1417499542236328e+01 -6.5689498901367188e+01 1.2158499717712402e+01 -2.3076801300048828e+01 -7.0944305419921875e+01 1.7488100051879883e+01 -1.8602899551391602e+01 -6.9607200622558594e+01 1.5727600097656250e+01 -1.9640098571777344e+01 -3.5388397216796875e+01 1.8206001281738281e+01 -1.8266899108886719e+01 -6.9263801574707031e+01 1.5337499618530273e+01 -1.9916500091552734e+01 -6.7540306091308594e+01 1.3633999824523926e+01 -2.1372598648071289e+01 -6.7488197326660156e+01 1.3592399597167969e+01 -2.1420499801635742e+01 -7.3088699340820312e+01 2.3044500350952148e+01 -1.7060199737548828e+01 -7.3028701782226562e+01 2.2598600387573242e+01 -1.7101499557495117e+01 -3.5388397216796875e+01 2.3655900955200195e+01 -1.7025299072265625e+01 -7.2597900390625000e+01 2.0824701309204102e+01 -1.7401000976562500e+01 -7.1990898132324219e+01 1.9321498870849609e+01 -1.7832300186157227e+01 -7.1361099243164062e+01 1.8218299865722656e+01 -1.8295999526977539e+01 -7.2883499145507812e+01 2.6562801361083984e+01 -1.7201799392700195e+01 -7.3137298583984375e+01 2.4792398452758789e+01 -1.7026800155639648e+01 -7.3105697631835938e+01 2.3656400680541992e+01 -1.7048500061035156e+01 -3.5388397216796875e+01 2.9182100296020508e+01 -1.7865200042724609e+01 -6.9861701965332031e+01 3.2378101348876953e+01 -1.9437900543212891e+01 -7.1157096862792969e+01 3.0592100143432617e+01 -1.8443399429321289e+01 -7.1401496887207031e+01 3.0191600799560547e+01 -1.8262001037597656e+01 -7.1913299560546875e+01 2.9172698974609375e+01 -1.7891099929809570e+01 -7.2271400451660156e+01 2.8459999084472656e+01 -1.7631599426269531e+01 -4.1491901397705078e+01 3.8385999202728271e+00 -4.4969902038574219e+01 -4.2164897918701172e+01 3.7779200077056885e+00 -4.6359699249267578e+01 -4.4102901458740234e+01 3.6032199859619141e+00 -5.0361396789550781e+01 -4.4218299865722656e+01 3.5699598789215088e+00 -5.1123100280761719e+01 -4.7500000000000000e+01 7.6721901893615723e+00 -5.6435398101806641e+01 -4.5669898986816406e+01 5.8431601524353027e+00 -5.6371601104736328e+01 -4.4759098052978516e+01 6.0869398117065430e+00 -5.0244701385498047e+01 -4.2071102142333984e+01 6.3090300559997559e+00 -4.4658798217773438e+01 -3.9644401550292969e+01 6.4255599975585938e+00 -4.1725898742675781e+01 -4.3576599121093750e+01 8.1336498260498047e+00 -4.3689601898193359e+01 -4.0934600830078125e+01 8.2491006851196289e+00 -4.0499401092529297e+01 -4.6504898071289062e+01 7.9136500358581543e+00 -4.9767097473144531e+01 -2.7265800476074219e+01 9.0025701522827148e+00 -2.6120100021362305e+01 -3.0241800308227539e+01 9.1562900543212891e+00 -2.8181299209594727e+01 -3.2945301055908203e+01 9.2238197326660156e+00 -2.9969999313354492e+01 -1.7276700973510742e+01 7.8579196929931641e+00 -1.8748199462890625e+01 -1.7904399871826172e+01 7.9668202400207520e+00 -1.9227499008178711e+01 -2.0623899459838867e+01 8.3686704635620117e+00 -2.1280801773071289e+01 -2.3515998840332031e+01 8.6972703933715820e+00 -2.3421800613403320e+01 -2.4773300170898438e+01 8.8037805557250977e+00 -2.4329900741577148e+01 -2.6524900436401367e+01 8.9521999359130859e+00 -2.5594900131225586e+01 -1.1419099807739258e+01 6.2694497108459473e+00 -1.4162599563598633e+01 -1.2483299255371094e+01 6.6884202957153320e+00 -1.5016400337219238e+01 -9.8614997863769531e+00 5.1975798606872559e+00 -1.2855100631713867e+01 -9.9127006530761719e+00 5.2623701095581055e+00 -1.2901700019836426e+01 -1.0329299926757812e+01 5.6490898132324219e+00 -1.3263699531555176e+01 -1.0937100410461426e+01 6.0319299697875977e+00 -1.3769599914550781e+01 -1.3789700508117676e+01 7.0897898674011230e+00 -1.6048299789428711e+01 -1.4622900009155273e+01 7.2970399856567383e+00 -1.6698400497436523e+01 -1.5203099250793457e+01 7.4412798881530762e+00 -1.7150899887084961e+01 -4.6144003868103027e+00 3.0490701198577881e+00 -9.2384204864501953e+00 -1.0361999273300171e+00 6.7039098739624023e+00 -8.8248300552368164e+00 -2.9644000530242920e+00 6.3934898376464844e+00 -9.1778097152709961e+00 -4.8758001327514648e+00 6.0857501029968262e+00 -9.5277500152587891e+00 -6.4896001815795898e+00 5.7212700843811035e+00 -1.0592499732971191e+01 -8.1176004409790039e+00 5.3535699844360352e+00 -1.1666599273681641e+01 -2.8498800277709961e+01 2.8776599884033203e+01 -1.7431900024414062e+01 -1.2411999702453613e+00 7.7583198547363281e+00 -8.7173004150390625e+00 -3.1712000370025635e+00 7.2798099517822266e+00 -9.0500097274780273e+00 -5.0308003425598145e+00 6.7752599716186523e+00 -9.6430797576904297e+00 -6.7864999771118164e+00 6.2537198066711426e+00 -1.0485799789428711e+01 -1.3036000728607178e+00 8.0784502029418945e+00 -8.7679700851440430e+00 -1.8253000974655151e+00 1.0002900123596191e+01 -9.1185598373413086e+00 -2.6059999465942383e+00 1.1930200576782227e+01 -9.5501003265380859e+00 -1.2792900085449219e+01 8.9551200866699219e+00 -1.4190600395202637e+01 -1.1333499908447266e+01 8.2898702621459961e+00 -1.3361199378967285e+01 -1.0143400192260742e+01 7.5783700942993164e+00 -1.2666299819946289e+01 -9.6045999526977539e+00 7.1701397895812988e+00 -1.2342300415039062e+01 -8.9260005950927734e+00 6.5079898834228516e+00 -1.1918099403381348e+01 -8.4630994796752930e+00 5.8369598388671875e+00 -1.1604700088500977e+01 -8.4063997268676758e+00 5.7246699333190918e+00 -1.1562899589538574e+01 -3.2321999073028564e+00 1.3137599945068359e+01 -9.8624305725097656e+00 -4.6266002655029297e+00 1.5290599822998047e+01 -1.0502300262451172e+01 -6.3513002395629883e+00 1.7382299423217773e+01 -1.1229700088500977e+01 -8.2280006408691406e+00 1.9240299224853516e+01 -1.1967799186706543e+01 -1.0995400428771973e+01 2.1477001190185547e+01 -1.2978899955749512e+01 -1.1835900306701660e+01 2.2068300247192383e+01 -1.3269900321960449e+01 -1.5489299774169922e+01 2.4278299331665039e+01 -1.4452199935913086e+01 -1.9392299652099609e+01 2.6122100830078125e+01 -1.5564300537109375e+01 -3.2337999343872070e+00 7.5475001335144043e+00 -9.0937595367431641e+00 -3.7544000148773193e+00 9.1557502746582031e+00 -9.3973293304443359e+00 -4.5290999412536621e+00 1.0763599395751953e+01 -9.7716493606567383e+00 -5.1486997604370117e+00 1.1768599510192871e+01 -1.0042900085449219e+01 -6.5248999595642090e+00 1.3554699897766113e+01 -1.0598500251770020e+01 -8.2224006652832031e+00 1.5279299736022949e+01 -1.1229899406433105e+01 -1.0064300537109375e+01 1.6798698425292969e+01 -1.1869999885559082e+01 -1.2770299911499023e+01 1.8604900360107422e+01 -1.2745400428771973e+01 -1.3589600563049316e+01 1.9076700210571289e+01 -1.2996999740600586e+01 -1.7135000228881836e+01 2.0808498382568359e+01 -1.4016900062561035e+01 -2.0887199401855469e+01 2.2192800521850586e+01 -1.4972700119018555e+01 -5.0928997993469238e+00 6.9900698661804199e+00 -9.6831302642822266e+00 -5.6052999496459961e+00 8.2790899276733398e+00 -9.9653606414794922e+00 -6.3637995719909668e+00 9.5631494522094727e+00 -1.0320400238037109e+01 -6.9688000679016113e+00 1.0362500190734863e+01 -1.0580599784851074e+01 -8.3097000122070312e+00 1.1774299621582031e+01 -1.1119299888610840e+01 -9.9594001770019531e+00 1.3123299598693848e+01 -1.1738200187683105e+01 -1.1744899749755859e+01 1.4295399665832520e+01 -1.2372099876403809e+01 -1.4359699249267578e+01 1.5659699440002441e+01 -1.3249099731445312e+01 -1.5149399757385254e+01 1.6008998870849609e+01 -1.3503399848937988e+01 -1.8554401397705078e+01 1.7253101348876953e+01 -1.4547600746154785e+01 -2.2132198333740234e+01 1.8175701141357422e+01 -1.5553099632263184e+01 -6.8466000556945801e+00 6.4164400100708008e+00 -1.0525199890136719e+01 -7.3408999443054199e+00 7.3905601501464844e+00 -1.0811300277709961e+01 -8.0685997009277344e+00 8.3562097549438477e+00 -1.1183799743652344e+01 -8.6476001739501953e+00 8.9541091918945312e+00 -1.1462300300598145e+01 -9.9285001754760742e+00 1.0001899719238281e+01 -1.2049299240112305e+01 -1.1501000404357910e+01 1.0990200042724609e+01 -1.2736899375915527e+01 -1.3199799537658691e+01 1.1834300041198730e+01 -1.3453300476074219e+01 -1.5682600021362305e+01 1.2791399955749512e+01 -1.4464199066162109e+01 -1.6431299209594727e+01 1.3030200004577637e+01 -1.4761899948120117e+01 -1.9653299331665039e+01 1.3848099708557129e+01 -1.6008998870849609e+01 -2.3027500152587891e+01 1.4392499923706055e+01 -1.7259000778198242e+01 -1.4368700027465820e+01 9.5174903869628906e+00 -1.5068599700927734e+01 -1.6671699523925781e+01 1.0145899772644043e+01 -1.6328899383544922e+01 -1.7366399765014648e+01 1.0300600051879883e+01 -1.6704700469970703e+01 -2.0358699798583984e+01 1.0819600105285645e+01 -1.8304201126098633e+01 -2.3501399993896484e+01 1.1146400451660156e+01 -1.9953899383544922e+01 -2.6708999633789062e+01 1.1274100303649902e+01 -2.1609199523925781e+01 -2.6451601028442383e+01 1.4648599624633789e+01 -1.8469499588012695e+01 -2.5777099609375000e+01 1.8756000518798828e+01 -1.6473098754882812e+01 -2.4749300003051758e+01 2.3207399368286133e+01 -1.5809200286865234e+01 -2.3465700149536133e+01 2.7581001281738281e+01 -1.6540800094604492e+01 -2.7485898971557617e+01 1.1274100303649902e+01 -2.2006299972534180e+01 -2.7276199340820312e+01 1.4665100097656250e+01 -1.8752201080322266e+01 -2.6657400131225586e+01 1.8842000961303711e+01 -1.6677898406982422e+01 -2.5690099716186523e+01 2.3393899917602539e+01 -1.5987500190734863e+01 -2.4469699859619141e+01 2.7872999191284180e+01 -1.6748800277709961e+01 -3.0536500930786133e+01 1.1149800300598145e+01 -2.3555000305175781e+01 -3.0485000610351562e+01 1.4544700622558594e+01 -1.9822099685668945e+01 -3.0092998504638672e+01 1.8956800460815430e+01 -1.7404800415039062e+01 -2.9404998779296875e+01 2.3886699676513672e+01 -1.6576801300048828e+01 -3.3173099517822266e+01 1.0859700202941895e+01 -2.4891799926757812e+01 -3.3196502685546875e+01 1.4165699958801270e+01 -2.0698299407958984e+01 -3.3012496948242188e+01 1.8722898483276367e+01 -1.7921001434326172e+01 -3.2644500732421875e+01 2.3953798294067383e+01 -1.6911798477172852e+01 -3.2139099121093750e+01 2.9195400238037109e+01 -1.7798700332641602e+01 -6.2533802032470703e+01 6.6930599212646484e+00 -3.3303302764892578e+01 -6.0894500732421875e+01 8.5186901092529297e+00 -3.2561000823974609e+01 -6.2188499450683594e+01 8.6387395858764648e+00 -3.0455200195312500e+01 -6.3774898529052734e+01 6.8534598350524902e+00 -3.1020000457763672e+01 -6.3094600677490234e+01 8.8735208511352539e+00 -2.9097400665283203e+01 -6.4644699096679688e+01 7.1327099800109863e+00 -2.9550699234008789e+01 -6.6190399169921875e+01 7.9028000831604004e+00 -2.7155000686645508e+01 -6.6406600952148438e+01 1.0551399230957031e+01 -2.4750198364257812e+01 -6.4703399658203125e+01 9.5399599075317383e+00 -2.6878799438476562e+01 -6.7336204528808594e+01 1.1230699539184570e+01 -2.3668800354003906e+01 -6.9066596984863281e+01 1.2752199172973633e+01 -2.1786300659179688e+01 -7.0687797546386719e+01 1.4550100326538086e+01 -2.0158100128173828e+01 -7.1011703491210938e+01 1.4966300010681152e+01 -1.9847000122070312e+01 -7.2276298522949219e+01 1.6859701156616211e+01 -1.8674400329589844e+01 -7.3269203186035156e+01 1.8851200103759766e+01 -1.7797800064086914e+01 -7.3846099853515625e+01 2.0493999481201172e+01 -1.7305400848388672e+01 -7.4256103515625000e+01 2.2439800262451172e+01 -1.6962600708007812e+01 -7.4313201904296875e+01 2.2929599761962891e+01 -1.6915300369262695e+01 -7.4359603881835938e+01 2.4850700378417969e+01 -1.6876998901367188e+01 -7.4117897033691406e+01 2.6795198440551758e+01 -1.7077499389648438e+01 -7.2709800720214844e+01 3.0759201049804688e+01 -1.8287200927734375e+01 -7.3535705566406250e+01 2.8873001098632812e+01 -1.7568899154663086e+01 -7.2477996826171875e+01 3.1193599700927734e+01 -1.8493400573730469e+01 -7.1252098083496094e+01 3.3118198394775391e+01 -1.9618999481201172e+01 -6.7829101562500000e+01 9.0523395538330078e+00 -2.4862699508666992e+01 -6.8724403381347656e+01 9.8183794021606445e+00 -2.3700500488281250e+01 -7.0392700195312500e+01 1.1524000167846680e+01 -2.1680599212646484e+01 -7.1957603454589844e+01 1.3527999877929688e+01 -1.9936998367309570e+01 -7.2270500183105469e+01 1.3990699768066406e+01 -1.9604200363159180e+01 -7.3492500305175781e+01 1.6091100692749023e+01 -1.8350898742675781e+01 -7.4452598571777344e+01 1.8294900894165039e+01 -1.7414899826049805e+01 -7.5010704040527344e+01 2.0109899520874023e+01 -1.6889499664306641e+01 -7.5407402038574219e+01 2.2257600784301758e+01 -1.6523799896240234e+01 -7.5462699890136719e+01 2.2798000335693359e+01 -1.6473400115966797e+01 -7.5507499694824219e+01 2.4917400360107422e+01 -1.6432600021362305e+01 -7.5273605346679688e+01 2.7062900543212891e+01 -1.6646400451660156e+01 -7.4710304260253906e+01 2.9357299804687500e+01 -1.7170600891113281e+01 -7.3911506652832031e+01 3.1443000793457031e+01 -1.7937301635742188e+01 -7.3687500000000000e+01 3.1923801422119141e+01 -1.8157501220703125e+01 -7.2502700805664062e+01 3.4057899475097656e+01 -1.9360500335693359e+01 -5.8359802246093750e+01 6.2847700119018555e+00 -4.4467697143554688e+01 -5.6449100494384766e+01 5.8544902801513672e+00 -5.6230602264404297e+01 -5.4623203277587891e+01 7.6830401420593262e+00 -5.6178199768066406e+01 -5.6593196868896484e+01 8.1117706298828125e+00 -4.4061000823974609e+01 -6.3557601928710938e+01 -9.9998700618743896e-01 -8.3793998718261719e+01 -6.2644100189208984e+01 -9.9998700618743896e-01 -8.4200798034667969e+01 -5.9778400421142578e+01 -9.9998700618743896e-01 -7.2162796020507812e+01 -5.8800197601318359e+01 -9.9998700618743896e-01 -7.2370697021484375e+01 -5.8500000000000000e+01 -9.9998700618743896e-01 -6.0000000000000000e+01 -5.7500000000000000e+01 -9.9998700618743896e-01 -6.0000000000000000e+01 -5.9778400421142578e+01 -9.9998700618743896e-01 -4.7837200164794922e+01 -5.8800197601318359e+01 -9.9998700618743896e-01 -4.7629299163818359e+01 -6.3557601928710938e+01 -9.9998700618743896e-01 -3.6206001281738281e+01 -6.2644100189208984e+01 -9.9998700618743896e-01 -3.5799201965332031e+01 -6.9672500610351562e+01 -9.9998700618743896e-01 -2.5614601135253906e+01 -6.8863502502441406e+01 -9.9998700618743896e-01 -2.5026800155639648e+01 -7.7855903625488281e+01 -9.9998700618743896e-01 -1.6526000976562500e+01 -7.7186798095703125e+01 -9.9998700618743896e-01 -1.5782899856567383e+01 -8.7750000000000000e+01 -9.9998700618743896e-01 -9.3375501632690430e+00 -8.7250000000000000e+01 -9.9998700618743896e-01 -8.4714899063110352e+00 -9.8922500610351562e+01 -9.9998700618743896e-01 -4.3632402420043945e+00 -9.8613502502441406e+01 -9.9998700618743896e-01 -3.4121899604797363e+00 -1.1088500213623047e+02 -9.9998700618743896e-01 -1.8205100297927856e+00 -1.1078099822998047e+02 -9.9998700618743896e-01 -8.2599902153015137e-01 -1.2311500549316406e+02 -9.9998700618743896e-01 -1.8205100297927856e+00 -1.2321900177001953e+02 -9.9998700618743896e-01 -8.2599902153015137e-01 -1.3507699584960938e+02 -9.9998700618743896e-01 -4.3632402420043945e+00 -1.3538600158691406e+02 -9.9998700618743896e-01 -3.4121899604797363e+00 -1.4625000000000000e+02 -9.9998700618743896e-01 -9.3375501632690430e+00 -1.4675000000000000e+02 -9.9998700618743896e-01 -8.4714899063110352e+00 -1.5614399719238281e+02 -9.9998700618743896e-01 -1.6526000976562500e+01 -1.5681298828125000e+02 -9.9998700618743896e-01 -1.5782899856567383e+01 -1.6432699584960938e+02 -9.9998700618743896e-01 -2.5614601135253906e+01 -1.6513600158691406e+02 -9.9998700618743896e-01 -2.5026800155639648e+01 -1.7044200134277344e+02 -9.9998700618743896e-01 -3.6206001281738281e+01 -1.7135598754882812e+02 -9.9998700618743896e-01 -3.5799201965332031e+01 -1.7422200012207031e+02 -9.9998700618743896e-01 -4.7837200164794922e+01 -1.7519999694824219e+02 -9.9998700618743896e-01 -4.7629299163818359e+01 -1.7550000000000000e+02 -9.9998700618743896e-01 -6.0000000000000000e+01 -1.7650000000000000e+02 -9.9998700618743896e-01 -6.0000000000000000e+01 -1.7422200012207031e+02 -9.9998700618743896e-01 -7.2162796020507812e+01 -1.7519999694824219e+02 -9.9998700618743896e-01 -7.2370697021484375e+01 -1.7044200134277344e+02 -9.9998700618743896e-01 -8.3793998718261719e+01 -1.7135598754882812e+02 -9.9998700618743896e-01 -8.4200798034667969e+01 -1.6432699584960938e+02 -9.9998700618743896e-01 -9.4385398864746094e+01 -1.6513600158691406e+02 -9.9998700618743896e-01 -9.4973197937011719e+01 -1.5614399719238281e+02 -9.9998700618743896e-01 -1.0347399902343750e+02 -1.5681298828125000e+02 -9.9998700618743896e-01 -1.0421700286865234e+02 -1.4625000000000000e+02 -9.9998700618743896e-01 -1.1066199493408203e+02 -1.4675000000000000e+02 -9.9998700618743896e-01 -1.1152899932861328e+02 -1.3507699584960938e+02 -9.9998700618743896e-01 -1.1563699340820312e+02 -1.3538600158691406e+02 -9.9998700618743896e-01 -1.1658799743652344e+02 -1.2311500549316406e+02 -9.9998700618743896e-01 -1.1817900085449219e+02 -1.2321900177001953e+02 -9.9998700618743896e-01 -1.1917400360107422e+02 -1.1088500213623047e+02 -9.9998700618743896e-01 -1.1817900085449219e+02 -1.1078099822998047e+02 -9.9998700618743896e-01 -1.1917400360107422e+02 -9.8922500610351562e+01 -9.9998700618743896e-01 -1.1563699340820312e+02 -9.8613502502441406e+01 -9.9998700618743896e-01 -1.1658799743652344e+02 -8.7750000000000000e+01 -9.9998700618743896e-01 -1.1066199493408203e+02 -8.7250000000000000e+01 -9.9998700618743896e-01 -1.1152899932861328e+02 -7.7855903625488281e+01 -9.9998700618743896e-01 -1.0347399902343750e+02 -7.7186798095703125e+01 -9.9998700618743896e-01 -1.0421700286865234e+02 -6.9672500610351562e+01 -9.9998700618743896e-01 -9.4385398864746094e+01 -6.8863502502441406e+01 -9.9998700618743896e-01 -9.4973197937011719e+01 5.3000000000000000e+01 4.7178802490234375e+01 -5.4485599517822266e+01 5.3000000000000000e+01 5.0208698272705078e+01 -4.8540199279785156e+01 5.3000000000000000e+01 4.4635299682617188e+01 -4.3754001617431641e+01 5.3000000000000000e+01 4.6399898529052734e+01 -3.7654998779296875e+01 5.3000000000000000e+01 3.9685699462890625e+01 -3.3898399353027344e+01 5.3000000000000000e+01 4.0264301300048828e+01 -2.7890300750732422e+01 5.3000000000000000e+01 3.2596500396728516e+01 -2.5449798583984375e+01 5.3000000000000000e+01 3.2109699249267578e+01 -1.9735698699951172e+01 5.3000000000000000e+01 2.3749898910522461e+01 -1.8863800048828125e+01 5.3000000000000000e+01 2.2345001220703125e+01 -1.3600099563598633e+01 5.3000000000000000e+01 1.3623099327087402e+01 -1.4495500564575195e+01 5.3000000000000000e+01 1.1459800720214844e+01 -9.7912597656250000e+00 5.3000000000000000e+01 2.7618398666381836e+00 -1.2580400466918945e+01 5.3000000000000000e+01 0.0000000000000000e+00 -8.5000400543212891e+00 5.3000000000000000e+01 -8.2482700347900391e+00 -1.3221699714660645e+01 5.3000000000000000e+01 -1.1459800720214844e+01 -9.7912597656250000e+00 5.3000000000000000e+01 -1.8813800811767578e+01 -1.6384799957275391e+01 5.3000000000000000e+01 -2.2345001220703125e+01 -1.3600099563598633e+01 5.3000000000000000e+01 -2.8364999771118164e+01 -2.1899198532104492e+01 5.3000000000000000e+01 -3.2109699249267578e+01 -1.9735698699951172e+01 5.3000000000000000e+01 -3.6387100219726562e+01 -2.9467599868774414e+01 5.3000000000000000e+01 -4.0264301300048828e+01 -2.7890300750732422e+01 5.3000000000000000e+01 -4.2447498321533203e+01 -3.8682098388671875e+01 5.3000000000000000e+01 -4.6399898529052734e+01 -3.7654998779296875e+01 5.3000000000000000e+01 -4.6219596862792969e+01 -4.9045799255371094e+01 5.3000000000000000e+01 -5.0208698272705078e+01 -4.8540199279785156e+01 5.3000000000000000e+01 -4.7500000000000000e+01 -6.0000000000000000e+01 5.3000000000000000e+01 -5.1500000000000000e+01 -6.0000000000000000e+01 5.3000000000000000e+01 -4.6219596862792969e+01 -7.0954200744628906e+01 5.3000000000000000e+01 -5.0208698272705078e+01 -7.1459800720214844e+01 5.3000000000000000e+01 -4.2447498321533203e+01 -8.1317901611328125e+01 5.3000000000000000e+01 -4.6399898529052734e+01 -8.2345001220703125e+01 5.3000000000000000e+01 -3.6387100219726562e+01 -9.0532402038574219e+01 5.3000000000000000e+01 -4.0264301300048828e+01 -9.2109703063964844e+01 5.3000000000000000e+01 -2.8364999771118164e+01 -9.8100799560546875e+01 5.3000000000000000e+01 -3.2109699249267578e+01 -1.0026399993896484e+02 5.3000000000000000e+01 -1.8813800811767578e+01 -1.0361499786376953e+02 5.3000000000000000e+01 -2.2345001220703125e+01 -1.0640000152587891e+02 5.3000000000000000e+01 -8.2482700347900391e+00 -1.0677799987792969e+02 5.3000000000000000e+01 -1.1459800720214844e+01 -1.1020899963378906e+02 5.3000000000000000e+01 2.7618398666381836e+00 -1.0741999816894531e+02 5.3000000000000000e+01 0.0000000000000000e+00 -1.1150000000000000e+02 5.3000000000000000e+01 1.3623099327087402e+01 -1.0550399780273438e+02 5.3000000000000000e+01 1.1459800720214844e+01 -1.1020899963378906e+02 5.3000000000000000e+01 2.3749898910522461e+01 -1.0113600158691406e+02 5.3000000000000000e+01 2.2345001220703125e+01 -1.0640000152587891e+02 5.3000000000000000e+01 3.2596500396728516e+01 -9.4550201416015625e+01 5.3000000000000000e+01 3.2109699249267578e+01 -1.0026399993896484e+02 5.3000000000000000e+01 3.9685699462890625e+01 -8.6101600646972656e+01 5.3000000000000000e+01 4.0264301300048828e+01 -9.2109703063964844e+01 5.3000000000000000e+01 4.4635299682617188e+01 -7.6246002197265625e+01 5.3000000000000000e+01 4.6399898529052734e+01 -8.2345001220703125e+01 5.3000000000000000e+01 4.7178802490234375e+01 -6.5514404296875000e+01 5.3000000000000000e+01 5.0208698272705078e+01 -7.1459800720214844e+01 5.3000000000000000e+01 5.1500000000000000e+01 -6.0000000000000000e+01 -1.6432699584960938e+02 9.9998700618743896e-01 -9.4385398864746094e+01 -1.5614399719238281e+02 9.9998700618743896e-01 -1.0347399902343750e+02 -6.3557601928710938e+01 9.9998700618743896e-01 -3.6206001281738281e+01 -1.4625000000000000e+02 9.9998700618743896e-01 -1.1066199493408203e+02 -1.3507699584960938e+02 9.9998700618743896e-01 -1.1563699340820312e+02 -1.2311500549316406e+02 9.9998700618743896e-01 -1.1817900085449219e+02 -7.7855903625488281e+01 9.9998700618743896e-01 -1.6526000976562500e+01 -8.7750000000000000e+01 9.9998700618743896e-01 -9.3375501632690430e+00 -1.5614399719238281e+02 9.9998700618743896e-01 -1.6526000976562500e+01 -1.6432699584960938e+02 9.9998700618743896e-01 -2.5614601135253906e+01 -1.7044200134277344e+02 9.9998700618743896e-01 -3.6206001281738281e+01 -1.7422200012207031e+02 9.9998700618743896e-01 -4.7837200164794922e+01 -1.7550000000000000e+02 9.9998700618743896e-01 -6.0000000000000000e+01 -1.7422200012207031e+02 9.9998700618743896e-01 -7.2162796020507812e+01 -1.7044200134277344e+02 9.9998700618743896e-01 -8.3793998718261719e+01 -6.9672500610351562e+01 9.9998700618743896e-01 -2.5614601135253906e+01 -1.1088500213623047e+02 9.9998700618743896e-01 -1.8205100297927856e+00 -1.2311500549316406e+02 9.9998700618743896e-01 -1.8205100297927856e+00 -1.3507699584960938e+02 9.9998700618743896e-01 -4.3632402420043945e+00 -9.8922500610351562e+01 9.9998700618743896e-01 -4.3632402420043945e+00 -1.4625000000000000e+02 9.9998700618743896e-01 -9.3375501632690430e+00 -1.1088500213623047e+02 9.9998700618743896e-01 -1.1817900085449219e+02 -9.8922500610351562e+01 9.9998700618743896e-01 -1.1563699340820312e+02 -8.7750000000000000e+01 9.9998700618743896e-01 -1.1066199493408203e+02 -7.7855903625488281e+01 9.9998700618743896e-01 -1.0347399902343750e+02 -6.9672500610351562e+01 9.9998700618743896e-01 -9.4385398864746094e+01 -6.3557601928710938e+01 9.9998700618743896e-01 -8.3793998718261719e+01 -5.9778400421142578e+01 9.9998700618743896e-01 -7.2162796020507812e+01 -5.8500000000000000e+01 9.9998700618743896e-01 -6.0000000000000000e+01 -5.9778400421142578e+01 9.9998700618743896e-01 -4.7837200164794922e+01 -5.9818099975585938e+01 4.3215599060058594e+01 -4.0314701080322266e+01 -6.0624397277832031e+01 4.3522499084472656e+01 -4.0972602844238281e+01 -6.1571800231933594e+01 4.1571098327636719e+01 -3.7077098846435547e+01 -6.1961097717285156e+01 4.1776500701904297e+01 -3.7395397186279297e+01 -6.1897502899169922e+01 4.1265701293945312e+01 -3.6475799560546875e+01 -6.3475498199462891e+01 3.9760196685791016e+01 -3.4012001037597656e+01 -5.6781600952148438e+01 4.6074401855468750e+01 -4.8450397491455078e+01 -5.6794200897216797e+01 4.6081798553466797e+01 -4.8479999542236328e+01 -5.6874801635742188e+01 4.6087398529052734e+01 -4.8502201080322266e+01 -5.6830101013183594e+01 4.6091098785400391e+01 -4.8516899108886719e+01 -5.6876300811767578e+01 4.6096897125244141e+01 -4.8540500640869141e+01 -5.6967998504638672e+01 4.6100299835205078e+01 -4.8553897857666016e+01 -5.8611301422119141e+01 4.6100299835205078e+01 -4.8553897857666016e+01 -5.6792697906494141e+01 4.5994697570800781e+01 -4.8136699676513672e+01 -5.6766498565673828e+01 4.6065498352050781e+01 -4.8414798736572266e+01 -5.9689296722412109e+01 4.3336399078369141e+01 -4.0552501678466797e+01 -5.9503299713134766e+01 4.3507999420166016e+01 -4.0978397369384766e+01 -6.0577796936035156e+01 4.3582397460937500e+01 -4.1127101898193359e+01 -5.8339099884033203e+01 4.4582500457763672e+01 -4.3645401000976562e+01 -5.9509696960449219e+01 4.4957000732421875e+01 -4.4666500091552734e+01 -5.8196300506591797e+01 4.4714302062988281e+01 -4.3972599029541016e+01 -5.7152000427246094e+01 4.5666900634765625e+01 -4.7070701599121094e+01 -6.2580600738525391e+01 4.1101898193359375e+01 -3.5942302703857422e+01 -6.0714099884033203e+01 4.3882999420166016e+01 -4.0708797454833984e+01 -6.0801101684570312e+01 4.3753799438476562e+01 -4.0459201812744141e+01 -6.0911098480224609e+01 4.3590400695800781e+01 -4.0143600463867188e+01 -6.2089801788330078e+01 4.1833301544189453e+01 -3.7177200317382812e+01 -6.0587100982666016e+01 4.4071498870849609e+01 -4.1129898071289062e+01 -5.9766399383544922e+01 4.5288997650146484e+01 -4.3848999023437500e+01 -5.9439598083496094e+01 4.5773902893066406e+01 -4.4932201385498047e+01 -5.9125301361083984e+01 4.6017597198486328e+01 -4.6188102722167969e+01 -5.9280799865722656e+01 4.5896999359130859e+01 -4.5566398620605469e+01 -5.7938999176025391e+01 4.6063800811767578e+01 -4.7509902954101562e+01 -5.7757999420166016e+01 4.6027702331542969e+01 -4.7346099853515625e+01 -5.7588100433349609e+01 4.5932800292968750e+01 -4.7194499969482422e+01 -5.7649398803710938e+01 4.5927600860595703e+01 -4.7119598388671875e+01 -6.2096500396728516e+01 4.1070701599121094e+01 -8.3757400512695312e+01 -6.3475498199462891e+01 3.9760196685791016e+01 -8.5987998962402344e+01 -6.1964298248291016e+01 4.1772201538085938e+01 -8.2612503051757812e+01 -6.0624397277832031e+01 4.3522499084472656e+01 -7.9027397155761719e+01 -6.0496898651123047e+01 4.2583702087402344e+01 -8.1044601440429688e+01 -6.1061100006103516e+01 4.2054897308349609e+01 -8.2082397460937500e+01 -5.9506099700927734e+01 4.4961601257324219e+01 -7.5319900512695312e+01 -5.8648601531982422e+01 4.4298599243164062e+01 -7.7142799377441406e+01 -6.0577796936035156e+01 4.3582397460937500e+01 -7.8872894287109375e+01 -5.9532299041748047e+01 4.3478801727294922e+01 -7.9008201599121094e+01 -6.0143199920654297e+01 4.2911899566650391e+01 -8.0297798156738281e+01 -5.8611301422119141e+01 4.6100299835205078e+01 -7.1446098327636719e+01 -5.6967998504638672e+01 4.6100299835205078e+01 -7.1446098327636719e+01 -5.6898899078369141e+01 4.6098499298095703e+01 -7.1453102111816406e+01 -5.6834400177001953e+01 4.6091796875000000e+01 -7.1480102539062500e+01 -5.7156902313232422e+01 4.5663799285888672e+01 -7.3078994750976562e+01 -5.7271701812744141e+01 4.5558799743652344e+01 -7.3391799926757812e+01 -5.8556602478027344e+01 4.4382900238037109e+01 -7.6892005920410156e+01 -5.6797199249267578e+01 4.6082897186279297e+01 -7.1515800476074219e+01 -5.6780200958251953e+01 4.6074699401855469e+01 -7.1548202514648438e+01 -5.6773597717285156e+01 4.6071601867675781e+01 -7.1560798645019531e+01 -5.6758998870849609e+01 4.6049999237060547e+01 -7.1646598815917969e+01 -5.6792697906494141e+01 4.5994697570800781e+01 -7.1863304138183594e+01 -5.9439598083496094e+01 4.5773902893066406e+01 -7.5067802429199219e+01 -5.9280799865722656e+01 4.5896999359130859e+01 -7.4433494567871094e+01 -5.9125301361083984e+01 4.6017597198486328e+01 -7.3811904907226562e+01 -6.0611198425292969e+01 4.4035099029541016e+01 -7.8861602783203125e+01 -5.9900802612304688e+01 4.5090103149414062e+01 -7.6730995178222656e+01 -5.9896099090576172e+01 4.5097000122070312e+01 -7.6714202880859375e+01 -6.1042900085449219e+01 4.3393898010253906e+01 -8.0156600952148438e+01 -6.2465400695800781e+01 4.1271297454833984e+01 -8.3693305969238281e+01 -6.1685600280761719e+01 4.2437797546386719e+01 -8.1921897888183594e+01 -6.1285099029541016e+01 4.3034198760986328e+01 -8.0882804870605469e+01 -5.8420898437500000e+01 4.6045200347900391e+01 -7.3022499084472656e+01 -5.8225502014160156e+01 4.6004001617431641e+01 -7.3196701049804688e+01 -5.8043899536132812e+01 4.5895496368408203e+01 -7.3356300354003906e+01 -5.7998897552490234e+01 4.5899101257324219e+01 -7.3302597045898438e+01 -1.2170500183105469e+02 5.9888198852539062e+01 -1.1828599548339844e+02 -1.1700000000000000e+02 5.8500000000000000e+01 -1.1850000000000000e+02 -1.2638400268554688e+02 5.8500000000000000e+01 -1.1774200439453125e+02 -1.3552500915527344e+02 5.8500000000000000e+01 -1.1548899841308594e+02 -1.3099400329589844e+02 5.9888198852539062e+01 -1.1677700042724609e+02 -1.2637999725341797e+02 5.9888198852539062e+01 -1.1771900177001953e+02 -1.4418600463867188e+02 5.8500000000000000e+01 -1.1179900360107422e+02 -1.3992098999023438e+02 5.9888198852539062e+01 -1.1379600524902344e+02 -1.3551699829101562e+02 5.9888198852539062e+01 -1.1546599578857422e+02 -1.5214300537109375e+02 5.8500000000000000e+01 -1.0676699829101562e+02 -1.4825299072265625e+02 5.9888198852539062e+01 -1.0942299652099609e+02 -1.4417498779296875e+02 5.9888198852539062e+01 -1.1177799987792969e+02 -1.5919000244140625e+02 5.8500000000000000e+01 -1.0052400207519531e+02 -1.5577700805664062e+02 5.9888198852539062e+01 -1.0377000427246094e+02 -1.5212899780273438e+02 5.9888198852539062e+01 -1.0674800109863281e+02 -1.6514498901367188e+02 5.8500000000000000e+01 -9.3231697082519531e+01 -1.6229598999023438e+02 5.9888198852539062e+01 -9.6982704162597656e+01 -1.5917300415039062e+02 5.9888198852539062e+01 -1.0050799560546875e+02 -1.6985200500488281e+02 5.8500000000000000e+01 -8.5078498840332031e+01 -1.6764100646972656e+02 5.9888198852539062e+01 -8.9237899780273438e+01 -1.6512500000000000e+02 5.9888198852539062e+01 -9.3218002319335938e+01 -1.7319000244140625e+02 5.8500000000000000e+01 -7.6275695800781250e+01 -1.7167599487304688e+02 5.9888198852539062e+01 -8.0735694885253906e+01 -1.6983000183105469e+02 5.9888198852539062e+01 -8.5068099975585938e+01 -1.7507299804687500e+02 5.8500000000000000e+01 -6.7051300048828125e+01 -1.7429399108886719e+02 5.9888198852539062e+01 -7.1696601867675781e+01 -1.7316700744628906e+02 5.9888198852539062e+01 -7.6268997192382812e+01 -1.7545300292968750e+02 5.8500000000000000e+01 -5.7644500732421875e+01 -1.7542800903320312e+02 5.9888198852539062e+01 -6.2354598999023438e+01 -1.7504901123046875e+02 5.9888198852539062e+01 -6.7048400878906250e+01 -1.7431799316406250e+02 5.8500000000000000e+01 -4.8298500061035156e+01 -1.7504901123046875e+02 5.9888198852539062e+01 -5.2951599121093750e+01 -1.7542800903320312e+02 5.9888198852539062e+01 -5.7645401000976562e+01 -1.7169799804687500e+02 5.8500000000000000e+01 -3.9255599975585938e+01 -1.7316700744628906e+02 5.9888198852539062e+01 -4.3730998992919922e+01 -1.7429399108886719e+02 5.9888198852539062e+01 -4.8303398132324219e+01 -1.6766198730468750e+02 5.8500000000000000e+01 -3.0750000000000000e+01 -1.6983000183105469e+02 5.9888198852539062e+01 -3.4931900024414062e+01 -1.7167599487304688e+02 5.9888198852539062e+01 -3.9264297485351562e+01 -1.6231399536132812e+02 5.8500000000000000e+01 -2.3002000808715820e+01 -1.6512500000000000e+02 5.9888198852539062e+01 -2.6781999588012695e+01 -1.6764100646972656e+02 5.9888198852539062e+01 -3.0762100219726562e+01 -1.5579299926757812e+02 5.8500000000000000e+01 -1.6212200164794922e+01 -1.5917300415039062e+02 5.9888198852539062e+01 -1.9492401123046875e+01 -1.6229598999023438e+02 5.9888198852539062e+01 -2.3017299652099609e+01 -1.4826600646972656e+02 5.8500000000000000e+01 -1.0556400299072266e+01 -1.5212899780273438e+02 5.9888198852539062e+01 -1.3251999855041504e+01 -1.5577700805664062e+02 5.9888198852539062e+01 -1.6230300903320312e+01 -1.3992999267578125e+02 5.8500000000000000e+01 -6.1812400817871094e+00 -1.4417498779296875e+02 5.9888198852539062e+01 -8.2222805023193359e+00 -1.4825299072265625e+02 5.9888198852539062e+01 -1.0576900482177734e+01 -1.3100000000000000e+02 5.8500000000000000e+01 -3.1999399662017822e+00 -1.3551699829101562e+02 5.9888198852539062e+01 -4.5336499214172363e+00 -1.3992098999023438e+02 5.9888198852539062e+01 -6.2035298347473145e+00 -1.2170700073242188e+02 5.8500000000000000e+01 -1.6897299289703369e+00 -1.2637999725341797e+02 5.9888198852539062e+01 -2.2814900875091553e+00 -1.3099400329589844e+02 5.9888198852539062e+01 -3.2234799861907959e+00 -1.1229299926757812e+02 5.8500000000000000e+01 -1.6897299289703369e+00 -1.1700000000000000e+02 5.9888198852539062e+01 -1.5242700576782227e+00 -1.2170500183105469e+02 5.9888198852539062e+01 -1.7138699293136597e+00 -1.0300000000000000e+02 5.8500000000000000e+01 -3.1999399662017822e+00 -1.0762000274658203e+02 5.9888198852539062e+01 -2.2814900875091553e+00 -1.1229499816894531e+02 5.9888198852539062e+01 -1.7138699293136597e+00 -9.4069999694824219e+01 5.8500000000000000e+01 -6.1812400817871094e+00 -9.8482604980468750e+01 5.9888198852539062e+01 -4.5336499214172363e+00 -1.0300599670410156e+02 5.9888198852539062e+01 -3.2234799861907959e+00 -8.5733802795410156e+01 5.8500000000000000e+01 -1.0556400299072266e+01 -8.9824996948242188e+01 5.9888198852539062e+01 -8.2222805023193359e+00 -9.4079498291015625e+01 5.9888198852539062e+01 -6.2035298347473145e+00 -7.8207298278808594e+01 5.8500000000000000e+01 -1.6212200164794922e+01 -8.1871192932128906e+01 5.9888198852539062e+01 -1.3251999855041504e+01 -8.5746696472167969e+01 5.9888198852539062e+01 -1.0576900482177734e+01 -7.1685600280761719e+01 5.8500000000000000e+01 -2.3002000808715820e+01 -7.4827201843261719e+01 5.9888198852539062e+01 -1.9492401123046875e+01 -7.8223396301269531e+01 5.9888198852539062e+01 -1.6230300903320312e+01 -6.6337501525878906e+01 5.8500000000000000e+01 -3.0750000000000000e+01 -6.8875404357910156e+01 5.9888198852539062e+01 -2.6781999588012695e+01 -7.1704399108886719e+01 5.9888198852539062e+01 -2.3017299652099609e+01 -6.2301597595214844e+01 5.8500000000000000e+01 -3.9255599975585938e+01 -6.4170097351074219e+01 5.9888198852539062e+01 -3.4931900024414062e+01 -6.6358497619628906e+01 5.9888198852539062e+01 -3.0762100219726562e+01 -5.9682296752929688e+01 5.8500000000000000e+01 -4.8298500061035156e+01 -6.0833000183105469e+01 5.9888198852539062e+01 -4.3730998992919922e+01 -6.2324199676513672e+01 5.9888198852539062e+01 -3.9264297485351562e+01 -5.8547500610351562e+01 5.8500000000000000e+01 -5.7644500732421875e+01 -5.8950599670410156e+01 5.9888198852539062e+01 -5.2951599121093750e+01 -5.9705997467041016e+01 5.9888198852539062e+01 -4.8303398132324219e+01 -5.8926502227783203e+01 5.8500000000000000e+01 -6.7051300048828125e+01 -5.8571701049804688e+01 5.9888198852539062e+01 -6.2354598999023438e+01 -5.8571701049804688e+01 5.9888198852539062e+01 -5.7645401000976562e+01 -6.0809700012207031e+01 5.8500000000000000e+01 -7.6275695800781250e+01 -5.9705997467041016e+01 5.9888198852539062e+01 -7.1696601867675781e+01 -5.8950599670410156e+01 5.9888198852539062e+01 -6.7048400878906250e+01 -6.4148200988769531e+01 5.8500000000000000e+01 -8.5078498840332031e+01 -6.2324199676513672e+01 5.9888198852539062e+01 -8.0735694885253906e+01 -6.0833000183105469e+01 5.9888198852539062e+01 -7.6268997192382812e+01 -6.8855499267578125e+01 5.8500000000000000e+01 -9.3231697082519531e+01 -6.6358497619628906e+01 5.9888198852539062e+01 -8.9237899780273438e+01 -6.4170097351074219e+01 5.9888198852539062e+01 -8.5068099975585938e+01 -7.4809700012207031e+01 5.8500000000000000e+01 -1.0052400207519531e+02 -7.1704399108886719e+01 5.9888198852539062e+01 -9.6982704162597656e+01 -6.8875404357910156e+01 5.9888198852539062e+01 -9.3218002319335938e+01 -8.1856597900390625e+01 5.8500000000000000e+01 -1.0676699829101562e+02 -7.8223396301269531e+01 5.9888198852539062e+01 -1.0377000427246094e+02 -7.4827201843261719e+01 5.9888198852539062e+01 -1.0050799560546875e+02 -8.9813705444335938e+01 5.8500000000000000e+01 -1.1179900360107422e+02 -8.5746696472167969e+01 5.9888198852539062e+01 -1.0942299652099609e+02 -8.1871192932128906e+01 5.9888198852539062e+01 -1.0674800109863281e+02 -9.8474899291992188e+01 5.8500000000000000e+01 -1.1548899841308594e+02 -9.4079498291015625e+01 5.9888198852539062e+01 -1.1379600524902344e+02 -8.9824996948242188e+01 5.9888198852539062e+01 -1.1177799987792969e+02 -1.0761599731445312e+02 5.8500000000000000e+01 -1.1774200439453125e+02 -1.0300599670410156e+02 5.9888198852539062e+01 -1.1677700042724609e+02 -9.8482604980468750e+01 5.9888198852539062e+01 -1.1546599578857422e+02 -1.1700000000000000e+02 5.9888198852539062e+01 -1.1847600555419922e+02 -1.1229499816894531e+02 5.9888198852539062e+01 -1.1828599548339844e+02 -1.0762000274658203e+02 5.9888198852539062e+01 -1.1771900177001953e+02 -1.4281100463867188e+02 7.0499893188476562e+01 -4.8879798889160156e+01 -1.4268200683593750e+02 7.0499893188476562e+01 -4.9542198181152344e+01 -1.6827999877929688e+02 7.0499893188476562e+01 -4.9542198181152344e+01 -1.1747699737548828e+02 7.0499893188476562e+01 -5.0928199768066406e+01 -1.1775899505615234e+02 7.0499893188476562e+01 -5.1059497833251953e+01 -1.3816999816894531e+02 7.0499893188476562e+01 -4.9542198181152344e+01 -1.1793699645996094e+02 7.0499893188476562e+01 -5.1313602447509766e+01 -1.1942499542236328e+02 7.0499893188476562e+01 -5.4824501037597656e+01 -1.1796399688720703e+02 7.0499893188476562e+01 -5.1623001098632812e+01 -1.1932199859619141e+02 7.0499893188476562e+01 -5.4815502166748047e+01 -1.1740000152587891e+02 7.0499893188476562e+01 -5.4815502166748047e+01 -1.3898300170898438e+02 7.0499893188476562e+01 -7.0751693725585938e+01 -1.3876399230957031e+02 7.0499893188476562e+01 -7.0971099853515625e+01 -1.4377699279785156e+02 7.0499893188476562e+01 -7.0661705017089844e+01 -1.1434899902343750e+02 7.0499893188476562e+01 -7.1274200439453125e+01 -1.1371099853515625e+02 7.0499893188476562e+01 -7.1156394958496094e+01 -1.0942600250244141e+02 7.0499893188476562e+01 -1.1179499816894531e+02 -1.1308399963378906e+02 7.0499893188476562e+01 -7.0939506530761719e+01 -1.1176499938964844e+02 7.0499893188476562e+01 -6.9921905517578125e+01 -1.1213000488281250e+02 7.0499893188476562e+01 -7.0319099426269531e+01 -1.1035399627685547e+02 7.0499893188476562e+01 -5.8167800903320312e+01 -1.1017599487304688e+02 7.0499893188476562e+01 -5.7914001464843750e+01 -1.1014799499511719e+02 7.0499893188476562e+01 -5.7604598999023438e+01 -1.0942600250244141e+02 7.0499893188476562e+01 -4.9542198181152344e+01 -1.1054799652099609e+02 7.0499893188476562e+01 -5.5312000274658203e+01 -1.1062000274658203e+02 7.0499893188476562e+01 -5.5115200042724609e+01 -1.1083900451660156e+02 7.0499893188476562e+01 -5.4895797729492188e+01 -1.1113899993896484e+02 7.0499893188476562e+01 -5.4815502166748047e+01 -1.1353500366210938e+02 7.0499893188476562e+01 -5.1218902587890625e+01 -1.1375500488281250e+02 7.0499893188476562e+01 -5.0999500274658203e+01 -1.1405400085449219e+02 7.0499893188476562e+01 -5.0919101715087891e+01 -1.1737299346923828e+02 7.0499893188476562e+01 -5.0919101715087891e+01 -1.3846400451660156e+02 7.0499893188476562e+01 -7.1051399230957031e+01 -1.3515699768066406e+02 7.0499893188476562e+01 -7.1051399230957031e+01 -1.2562100219726562e+02 7.0499893188476562e+01 -1.1166500091552734e+02 -1.3505500793457031e+02 7.0499893188476562e+01 -7.1042594909667969e+01 -1.3477299499511719e+02 7.0499893188476562e+01 -7.0912300109863281e+01 -1.1254299926757812e+02 7.0499893188476562e+01 -7.0642700195312500e+01 -1.1094200134277344e+02 7.0499893188476562e+01 -6.6454704284667969e+01 -1.1226899719238281e+02 7.0499893188476562e+01 -5.8307300567626953e+01 -1.1073899841308594e+02 7.0499893188476562e+01 -5.8307300567626953e+01 -1.3905400085449219e+02 7.0499893188476562e+01 -7.0555999755859375e+01 -1.1143700408935547e+02 7.0499893188476562e+01 -6.9414398193359375e+01 -1.1121399688720703e+02 7.0499893188476562e+01 -6.8919395446777344e+01 -1.1105599975585938e+02 7.0499893188476562e+01 -6.8390304565429688e+01 -1.1287599945068359e+02 7.0499893188476562e+01 -5.4815502166748047e+01 -1.1346399688720703e+02 7.0499893188476562e+01 -5.1416599273681641e+01 -1.6654100036621094e+02 7.0499893188476562e+01 -7.7007499694824219e+01 -1.4823699951171875e+02 7.0499893188476562e+01 -7.0550598144531250e+01 -1.6496800231933594e+02 7.0499893188476562e+01 -8.1040504455566406e+01 -1.4816500854492188e+02 7.0499893188476562e+01 -7.0751693725585938e+01 -1.6306599426269531e+02 7.0499893188476562e+01 -8.4929801940917969e+01 -1.4794500732421875e+02 7.0499893188476562e+01 -7.0971099853515625e+01 -1.6085000610351562e+02 7.0499893188476562e+01 -8.8648696899414062e+01 -1.4764498901367188e+02 7.0499893188476562e+01 -7.1051399230957031e+01 -1.5553698730468750e+02 7.0499893188476562e+01 -9.5475502014160156e+01 -1.5833500671386719e+02 7.0499893188476562e+01 -9.2171997070312500e+01 -1.4395700073242188e+02 7.0499893188476562e+01 -7.0914299011230469e+01 -1.2985800170898438e+02 7.0499893188476562e+01 -1.1077600097656250e+02 -1.4424000549316406e+02 7.0499893188476562e+01 -7.1043098449707031e+01 -1.3328799438476562e+02 7.0499893188476562e+01 -6.5655403137207031e+01 -1.3329499816894531e+02 7.0499893188476562e+01 -6.5856796264648438e+01 -1.3459399414062500e+02 7.0499893188476562e+01 -7.0658805847167969e+01 -1.3306100463867188e+02 7.0499893188476562e+01 -6.6887901306152344e+01 -1.3262300109863281e+02 7.0499893188476562e+01 -6.7891098022460938e+01 -1.1770299530029297e+02 7.0499893188476562e+01 -6.7670799255371094e+01 -1.2010700225830078e+02 7.0499893188476562e+01 -6.6223396301269531e+01 -1.1756599426269531e+02 7.0499893188476562e+01 -6.7524002075195312e+01 -1.1994400024414062e+02 7.0499893188476562e+01 -6.5004806518554688e+01 -1.1738699340820312e+02 7.0499893188476562e+01 -6.7431098937988281e+01 -1.1105599975585938e+02 7.0499893188476562e+01 -6.8390197753906250e+01 -1.1095099639892578e+02 7.0499893188476562e+01 -6.7773902893066406e+01 -1.1091400146484375e+02 7.0499893188476562e+01 -6.7150100708007812e+01 -1.1063600158691406e+02 7.0499893188476562e+01 -5.8298400878906250e+01 -1.1093699645996094e+02 7.0499893188476562e+01 -6.6525901794433594e+01 -1.4192999267578125e+02 7.0499893188476562e+01 -1.0606600189208984e+02 -1.4433898925781250e+02 7.0499893188476562e+01 -7.1051399230957031e+01 -1.3804000854492188e+02 7.0499893188476562e+01 -1.0796800231933594e+02 -1.3400801086425781e+02 7.0499893188476562e+01 -1.0954100036621094e+02 -1.3200999450683594e+02 7.0499893188476562e+01 -6.8801795959472656e+01 -1.4429600524902344e+02 7.0499893188476562e+01 -5.4611198425292969e+01 -1.4513699340820312e+02 7.0499893188476562e+01 -5.4524501800537109e+01 -1.4871501159667969e+02 7.0499893188476562e+01 -5.5936897277832031e+01 -1.4913800048828125e+02 7.0499893188476562e+01 -5.6530200958251953e+01 -1.4564900207519531e+02 7.0499893188476562e+01 -1.0384999847412109e+02 -1.4917199707031250e+02 7.0499893188476562e+01 -1.0133499908447266e+02 -1.5247599792480469e+02 7.0499893188476562e+01 -9.8536697387695312e+01 -1.3154299926757812e+02 7.0499893188476562e+01 -6.9321899414062500e+01 -1.3101499938964844e+02 7.0499893188476562e+01 -6.9793296813964844e+01 -1.2997700500488281e+02 7.0499893188476562e+01 -7.0478797912597656e+01 -1.2939900207519531e+02 7.0499893188476562e+01 -7.0756195068359375e+01 -1.2621800231933594e+02 7.0499893188476562e+01 -7.1359001159667969e+01 -1.2688300323486328e+02 7.0499893188476562e+01 -7.1346496582031250e+01 -1.2754100799560547e+02 7.0499893188476562e+01 -7.1278297424316406e+01 -1.4374800109863281e+02 7.0499893188476562e+01 -7.0352500915527344e+01 -1.4535200500488281e+02 7.0499893188476562e+01 -6.0795898437500000e+01 -1.4097799682617188e+02 7.0499893188476562e+01 -5.9664802551269531e+01 -1.3428999328613281e+02 7.0499893188476562e+01 -6.0498401641845703e+01 -1.3427600097656250e+02 7.0499893188476562e+01 -6.0652000427246094e+01 -1.2452700042724609e+02 7.0499893188476562e+01 -6.6058303833007812e+01 -1.2452700042724609e+02 7.0499893188476562e+01 -6.6058502197265625e+01 -1.3020298767089844e+02 7.0499893188476562e+01 -6.0928401947021484e+01 -1.3308499145507812e+02 7.0499893188476562e+01 -6.5314498901367188e+01 -1.3321598815917969e+02 7.0499893188476562e+01 -6.5467498779296875e+01 -1.3456599426269531e+02 7.0499893188476562e+01 -7.0349403381347656e+01 -1.2407299804687500e+02 7.0499893188476562e+01 -7.1009399414062500e+01 -1.2319999694824219e+02 7.0499893188476562e+01 -7.0632499694824219e+01 -1.1755599975585938e+02 7.0499893188476562e+01 -7.0642997741699219e+01 -1.2621699523925781e+02 7.0499893188476562e+01 -7.1359001159667969e+01 -1.1746800231933594e+02 7.0499893188476562e+01 -7.0824401855468750e+01 -1.1732599639892578e+02 7.0499893188476562e+01 -7.0966598510742188e+01 -1.1498400115966797e+02 7.0499893188476562e+01 -7.1314903259277344e+01 -1.1267500305175781e+02 7.0499893188476562e+01 -1.1219999694824219e+02 -1.1560499572753906e+02 7.0499893188476562e+01 -7.1305496215820312e+01 -1.4138899230957031e+02 7.0499893188476562e+01 -5.6167499542236328e+01 -1.4196600341796875e+02 7.0499893188476562e+01 -5.5680301666259766e+01 -1.4290499877929688e+02 7.0499893188476562e+01 -5.5086399078369141e+01 -1.4653399658203125e+02 7.0499893188476562e+01 -5.4654998779296875e+01 -1.4712500000000000e+02 7.0499893188476562e+01 -5.4828498840332031e+01 -1.4768299865722656e+02 7.0499893188476562e+01 -5.5090499877929688e+01 -1.4913800048828125e+02 7.0499893188476562e+01 -5.6530399322509766e+01 -1.4941799926757812e+02 7.0499893188476562e+01 -5.7090801239013672e+01 -1.6866500854492188e+02 7.0499893188476562e+01 -5.1378700256347656e+01 -1.4962800598144531e+02 7.0499893188476562e+01 -5.7680900573730469e+01 -1.6919999694824219e+02 7.0499893188476562e+01 -5.5674602508544922e+01 -1.4536300659179688e+02 7.0499893188476562e+01 -6.0710601806640625e+01 -1.4538900756835938e+02 7.0499893188476562e+01 -6.0403400421142578e+01 -1.4539599609375000e+02 7.0499893188476562e+01 -6.0095100402832031e+01 -1.4438099670410156e+02 7.0499893188476562e+01 -5.8429199218750000e+01 -1.4409600830078125e+02 7.0499893188476562e+01 -5.8367099761962891e+01 -1.4527099609375000e+02 7.0499893188476562e+01 -5.9267101287841797e+01 -1.1970700073242188e+02 7.0499893188476562e+01 -5.4955097198486328e+01 -1.1988499450683594e+02 7.0499893188476562e+01 -5.5208900451660156e+01 -1.1991299438476562e+02 7.0499893188476562e+01 -5.5518199920654297e+01 -1.3291099548339844e+02 7.0499893188476562e+01 -6.5213302612304688e+01 -1.3420001220703125e+02 7.0499893188476562e+01 -6.0838100433349609e+01 -1.2002400207519531e+02 7.0499893188476562e+01 -6.2751300811767578e+01 -1.1922200012207031e+02 7.0499893188476562e+01 -5.8226997375488281e+01 -1.1998000335693359e+02 7.0499893188476562e+01 -6.3177303314208984e+01 -1.1992300415039062e+02 7.0499893188476562e+01 -6.4093795776367188e+01 -1.1700000000000000e+02 7.0499893188476562e+01 -6.7421897888183594e+01 -1.1713600158691406e+02 7.0499893188476562e+01 -6.7406105041503906e+01 -1.1678999328613281e+02 7.0499893188476562e+01 -5.8307300567626953e+01 -1.1718799591064453e+02 7.0499893188476562e+01 -6.7402496337890625e+01 -1.1892200469970703e+02 7.0499893188476562e+01 -5.8307300567626953e+01 -1.4347900390625000e+02 7.0499893188476562e+01 -5.4833099365234375e+01 -1.4537100219726562e+02 7.0499893188476562e+01 -5.4522701263427734e+01 -1.4549299621582031e+02 7.0499893188476562e+01 -5.4526401519775391e+01 -1.4820800781250000e+02 7.0499893188476562e+01 -5.5448799133300781e+01 -1.4981399536132812e+02 7.0499893188476562e+01 -5.8556098937988281e+01 -1.4987899780273438e+02 7.0499893188476562e+01 -5.9166698455810547e+01 -1.6937899780273438e+02 7.0499893188476562e+01 -6.0000000000000000e+01 -1.2879400634765625e+02 7.0499893188476562e+01 -7.0983299255371094e+01 -1.4165798950195312e+02 7.0499893188476562e+01 -5.9017501831054688e+01 -1.4118798828125000e+02 7.0499893188476562e+01 -5.9437198638916016e+01 -1.4538000488281250e+02 7.0499893188476562e+01 -5.9787002563476562e+01 -1.2497399902343750e+02 7.0499893188476562e+01 -7.1236793518066406e+01 -1.2132500457763672e+02 7.0499893188476562e+01 -1.1219999694824219e+02 -1.1714400482177734e+02 7.0499893188476562e+01 -7.1053695678710938e+01 -1.1700000000000000e+02 7.0499893188476562e+01 -1.1237899780273438e+02 -1.4516299438476562e+02 7.0499893188476562e+01 -5.9029197692871094e+01 -1.4500799560546875e+02 7.0499893188476562e+01 -5.8815299987792969e+01 -1.4484399414062500e+02 7.0499893188476562e+01 -5.8664699554443359e+01 -1.4533999633789062e+02 7.0499893188476562e+01 -5.9513198852539062e+01 -1.4372200012207031e+02 7.0499893188476562e+01 -5.8336601257324219e+01 -1.4372099304199219e+02 7.0499893188476562e+01 -5.8336601257324219e+01 -1.4314801025390625e+02 7.0499893188476562e+01 -5.8363601684570312e+01 -1.2907299804687500e+02 7.0499893188476562e+01 -6.5484504699707031e+01 -1.2920600891113281e+02 7.0499893188476562e+01 -6.5333099365234375e+01 -1.2938099670410156e+02 7.0499893188476562e+01 -6.5234100341796875e+01 -1.2443900299072266e+02 7.0499893188476562e+01 -6.3809299468994141e+01 -1.2441200256347656e+02 7.0499893188476562e+01 -6.4224197387695312e+01 -1.2439299774169922e+02 7.0499893188476562e+01 -6.4639701843261719e+01 -1.2439299774169922e+02 7.0499893188476562e+01 -6.4639801025390625e+01 -1.2486299896240234e+02 7.0499893188476562e+01 -6.1189300537109375e+01 -1.2471699523925781e+02 7.0499893188476562e+01 -6.1782699584960938e+01 -1.3004399108886719e+02 7.0499893188476562e+01 -6.0564399719238281e+01 -1.2459999847412109e+02 7.0499893188476562e+01 -6.2382499694824219e+01 -1.3009199523925781e+02 7.0499893188476562e+01 -6.0759899139404297e+01 -1.1684400177001953e+02 7.0499893188476562e+01 -7.1131805419921875e+01 -1.1653500366210938e+02 7.0499893188476562e+01 -7.1197006225585938e+01 -1.6777600097656250e+02 7.0499893188476562e+01 -7.2858299255371094e+01 -1.6866500854492188e+02 7.0499893188476562e+01 -6.8621299743652344e+01 -1.4985099792480469e+02 7.0499893188476562e+01 -6.0893600463867188e+01 -1.6919999694824219e+02 7.0499893188476562e+01 -6.4325401306152344e+01 -1.4988900756835938e+02 7.0499893188476562e+01 -6.0394100189208984e+01 -1.4990299987792969e+02 7.0499893188476562e+01 -5.9780300140380859e+01 -1.2453900146484375e+02 7.0499893188476562e+01 -6.2794902801513672e+01 -1.2449500274658203e+02 7.0499893188476562e+01 -6.3202999114990234e+01 -1.2449500274658203e+02 7.0499893188476562e+01 -6.3204101562500000e+01 -1.2236700439453125e+02 7.0499893188476562e+01 -7.0089599609375000e+01 -1.2172499847412109e+02 7.0499893188476562e+01 -6.9506698608398438e+01 -1.2116999816894531e+02 7.0499893188476562e+01 -6.8813697814941406e+01 -1.2032399749755859e+02 7.0499893188476562e+01 -6.7062103271484375e+01 -1.1778499603271484e+02 7.0499893188476562e+01 -6.7855201721191406e+01 -1.2063100433349609e+02 7.0499893188476562e+01 -6.7858894348144531e+01 -1.1780100250244141e+02 7.0499893188476562e+01 -6.8055999755859375e+01 -1.1757700347900391e+02 7.0499893188476562e+01 -7.0531097412109375e+01 -1.1622100067138672e+02 7.0499893188476562e+01 -7.1247398376464844e+01 -1.4465199279785156e+02 7.0499893188476562e+01 -5.8540000915527344e+01 -1.4266101074218750e+02 7.0499893188476562e+01 -5.8470497131347656e+01 -1.4218600463867188e+02 7.0499893188476562e+01 -5.8671798706054688e+01 -1.2958000183105469e+02 7.0499893188476562e+01 -6.5198799133300781e+01 -1.3055400085449219e+02 7.0499893188476562e+01 -6.1113399505615234e+01 -1.3036199951171875e+02 7.0499893188476562e+01 -6.1050800323486328e+01 -1.2440299987792969e+02 7.0499893188476562e+01 -6.5267601013183594e+01 -1.2444799804687500e+02 7.0499893188476562e+01 -6.5664199829101562e+01 -1.2577200317382812e+02 7.0499893188476562e+01 -5.9332298278808594e+01 -1.2549200439453125e+02 7.0499893188476562e+01 -5.9717800140380859e+01 -1.3001400756835938e+02 7.0499893188476562e+01 -6.0277999877929688e+01 -1.2519499969482422e+02 7.0499893188476562e+01 -6.0267398834228516e+01 -1.2501000213623047e+02 7.0499893188476562e+01 -6.0719402313232422e+01 -1.2486299896240234e+02 7.0499893188476562e+01 -6.1189201354980469e+01 -1.1640500640869141e+02 7.0499893188476562e+01 -6.7428100585937500e+01 -1.1647499847412109e+02 7.0499893188476562e+01 -6.7433799743652344e+01 -1.1665000152587891e+02 7.0499893188476562e+01 -6.7440704345703125e+01 -1.2549200439453125e+02 7.0499893188476562e+01 -5.9717899322509766e+01 -1.1682499694824219e+02 7.0499893188476562e+01 -6.7436904907226562e+01 -1.2256500244140625e+02 7.0499893188476562e+01 -5.6912998199462891e+01 -1.2348000335693359e+02 7.0499893188476562e+01 -5.6079601287841797e+01 -1.2615400695800781e+02 7.0499893188476562e+01 -5.4756896972656250e+01 -1.2724099731445312e+02 7.0499893188476562e+01 -5.4564701080322266e+01 -1.2836499023437500e+02 7.0499893188476562e+01 -5.4522800445556641e+01 -1.3198500061035156e+02 7.0499893188476562e+01 -5.5655200958251953e+01 -1.3278199768066406e+02 7.0499893188476562e+01 -5.6382202148437500e+01 -1.3349600219726562e+02 7.0499893188476562e+01 -5.7404201507568359e+01 -1.3392700195312500e+02 7.0499893188476562e+01 -5.8405002593994141e+01 -1.2476300048828125e+02 7.0499893188476562e+01 -6.6664596557617188e+01 -1.2510800170898438e+02 7.0499893188476562e+01 -6.7127395629882812e+01 -1.2634199523925781e+02 7.0499893188476562e+01 -6.7559700012207031e+01 -1.2510800170898438e+02 7.0499893188476562e+01 -6.7127601623535156e+01 -1.2577999877929688e+02 7.0499893188476562e+01 -6.7492797851562500e+01 -1.2533999633789062e+02 7.0499893188476562e+01 -6.7313301086425781e+01 -1.2634399414062500e+02 7.0499893188476562e+01 -6.7559799194335938e+01 -1.2686899566650391e+02 7.0499893188476562e+01 -6.7532600402832031e+01 -1.2771500396728516e+02 7.0499893188476562e+01 -6.7265396118164062e+01 -1.2813400268554688e+02 7.0499893188476562e+01 -6.6982406616210938e+01 -1.2872099304199219e+02 7.0499893188476562e+01 -6.6291000366210938e+01 -1.2901000976562500e+02 7.0499893188476562e+01 -6.5625801086425781e+01 -1.3406599426269531e+02 7.0499893188476562e+01 -6.0988502502441406e+01 -1.3388999938964844e+02 7.0499893188476562e+01 -6.1086097717285156e+01 -1.3269599914550781e+02 7.0499893188476562e+01 -6.5175399780273438e+01 -1.3369099426269531e+02 7.0499893188476562e+01 -6.1119899749755859e+01 -1.3064199829101562e+02 7.0499893188476562e+01 -6.1119899749755859e+01 -1.2425000000000000e+02 7.0499893188476562e+01 -5.5557399749755859e+01 -1.2508900451660156e+02 7.0499893188476562e+01 -5.5125099182128906e+01 -1.3316899108886719e+02 7.0499893188476562e+01 -5.6872901916503906e+01 -1.3392700195312500e+02 7.0499893188476562e+01 -5.8405197143554688e+01 -1.3418099975585938e+02 7.0499893188476562e+01 -5.9427803039550781e+01 -1.1565399932861328e+02 7.0499893188476562e+01 -6.7217697143554688e+01 -1.1580999755859375e+02 7.0499893188476562e+01 -6.7316398620605469e+01 -1.1556800079345703e+02 7.0499893188476562e+01 -6.7107299804687500e+01 -1.1615000152587891e+02 7.0499893188476562e+01 -6.7406806945800781e+01 -1.1556800079345703e+02 7.0499893188476562e+01 -6.7107093811035156e+01 -1.2462500000000000e+02 7.0499893188476562e+01 -6.6369400024414062e+01 -1.2652200317382812e+02 7.0499893188476562e+01 -5.8680698394775391e+01 -1.2995199584960938e+02 7.0499893188476562e+01 -5.9928398132324219e+01 -1.2987699890136719e+02 7.0499893188476562e+01 -5.9655597686767578e+01 -1.2609699249267578e+02 7.0499893188476562e+01 -5.8998302459716797e+01 -1.1547100067138672e+02 7.0499893188476562e+01 -6.6081207275390625e+01 -1.1544799804687500e+02 7.0499893188476562e+01 -6.6385795593261719e+01 -1.1546300506591797e+02 7.0499893188476562e+01 -6.6746299743652344e+01 -1.2015199279785156e+02 7.0499893188476562e+01 -6.1903099060058594e+01 -1.2044200134277344e+02 7.0499893188476562e+01 -6.0713298797607422e+01 -1.1944100189208984e+02 7.0499893188476562e+01 -5.8007602691650391e+01 -1.2085899353027344e+02 7.0499893188476562e+01 -5.9562000274658203e+01 -1.1951300048828125e+02 7.0499893188476562e+01 -5.7810798645019531e+01 -1.2141200256347656e+02 7.0499893188476562e+01 -5.8461498260498047e+01 -1.2194200134277344e+02 7.0499893188476562e+01 -5.7659999847412109e+01 -1.2963398742675781e+02 7.0499893188476562e+01 -5.4652198791503906e+01 -1.3027299499511719e+02 7.0499893188476562e+01 -5.4808601379394531e+01 -1.3089799499511719e+02 7.0499893188476562e+01 -5.5036499023437500e+01 -1.3145899963378906e+02 7.0499893188476562e+01 -5.5315299987792969e+01 -1.2805999755859375e+02 7.0499893188476562e+01 -5.8321899414062500e+01 -1.2762999725341797e+02 7.0499893188476562e+01 -5.8333099365234375e+01 -1.2837600708007812e+02 7.0499893188476562e+01 -5.8353000640869141e+01 -1.2976400756835938e+02 7.0499893188476562e+01 -5.9374801635742188e+01 -1.2961299133300781e+02 7.0499893188476562e+01 -5.9106998443603516e+01 -1.2713000488281250e+02 7.0499893188476562e+01 -5.8419300079345703e+01 -1.2944500732421875e+02 7.0499893188476562e+01 -5.8892398834228516e+01 -1.2924299621582031e+02 7.0499893188476562e+01 -5.8708000183105469e+01 -1.2869999694824219e+02 7.0499893188476562e+01 -5.8426601409912109e+01 -1.2900799560546875e+02 7.0499893188476562e+01 -5.8554897308349609e+01 -9.1812500000000000e+01 7.0499893188476562e+01 -5.3666000366210938e+01 -9.1616897583007812e+01 7.0499893188476562e+01 -5.4815502166748047e+01 -9.3966003417968750e+01 7.0499893188476562e+01 -5.4815502166748047e+01 -9.1924804687500000e+01 7.0499893188476562e+01 -5.3237899780273438e+01 -9.5766296386718750e+01 7.0499893188476562e+01 -5.1538398742675781e+01 -9.5606903076171875e+01 7.0499893188476562e+01 -5.1661300659179688e+01 -9.4350799560546875e+01 7.0499893188476562e+01 -5.4955097198486328e+01 -9.5415596008300781e+01 7.0499893188476562e+01 -5.1724399566650391e+01 -6.7458801269531250e+01 7.0499893188476562e+01 -7.7007499694824219e+01 -8.4514198303222656e+01 7.0499893188476562e+01 -5.8167800903320312e+01 -6.6223503112792969e+01 7.0499893188476562e+01 -7.2858299255371094e+01 -6.5335105895996094e+01 7.0499893188476562e+01 -6.8621299743652344e+01 -9.4717803955078125e+01 7.0499893188476562e+01 -5.1651500701904297e+01 -9.4551803588867188e+01 7.0499893188476562e+01 -5.1643402099609375e+01 -9.4069305419921875e+01 7.0499893188476562e+01 -5.4824501037597656e+01 -9.4462898254394531e+01 7.0499893188476562e+01 -5.1642299652099609e+01 -9.4366104125976562e+01 7.0499893188476562e+01 -5.1642200469970703e+01 -9.3499198913574219e+01 7.0499893188476562e+01 -5.1766300201416016e+01 -9.5921798706054688e+01 7.0499893188476562e+01 -5.1197601318359375e+01 -9.5876098632812500e+01 7.0499893188476562e+01 -5.1369800567626953e+01 -8.4795799255371094e+01 7.0499893188476562e+01 -5.8298400878906250e+01 -8.4380905151367188e+01 7.0499893188476562e+01 -7.0349205017089844e+01 -8.4899002075195312e+01 7.0499893188476562e+01 -5.8307300567626953e+01 -8.6471000671386719e+01 7.0499893188476562e+01 -5.8307300567626953e+01 -6.5720199584960938e+01 7.0499893188476562e+01 -4.9542198181152344e+01 -8.4996200561523438e+01 7.0499893188476562e+01 -5.4895599365234375e+01 -8.5295600891113281e+01 7.0499893188476562e+01 -5.4813301086425781e+01 -9.5214202880859375e+01 7.0499893188476562e+01 -5.1720600128173828e+01 -9.5047798156738281e+01 7.0499893188476562e+01 -5.1690898895263672e+01 -9.4883300781250000e+01 7.0499893188476562e+01 -5.1667297363281250e+01 -1.0833100128173828e+02 7.0499893188476562e+01 -6.4203903198242188e+01 -1.0811199951171875e+02 7.0499893188476562e+01 -6.4423301696777344e+01 -8.4408798217773438e+01 7.0499893188476562e+01 -7.0658599853515625e+01 -6.9032501220703125e+01 7.0499893188476562e+01 -8.1040504455566406e+01 -8.4587402343750000e+01 7.0499893188476562e+01 -7.0912200927734375e+01 -7.0933799743652344e+01 7.0499893188476562e+01 -8.4929801940917969e+01 -6.4799598693847656e+01 7.0499893188476562e+01 -6.4325401306152344e+01 -8.4335899353027344e+01 7.0499893188476562e+01 -5.7914001464843750e+01 -6.4620704650878906e+01 7.0499893188476562e+01 -6.0000000000000000e+01 -8.4308296203613281e+01 7.0499893188476562e+01 -5.7604701995849609e+01 -6.4799598693847656e+01 7.0499893188476562e+01 -5.5674602508544922e+01 -8.7072700500488281e+01 7.0499893188476562e+01 -5.4801898956298828e+01 -8.7226799011230469e+01 7.0499893188476562e+01 -5.3607097625732422e+01 -9.2716499328613281e+01 7.0499893188476562e+01 -5.2147998809814453e+01 -9.2245803833007812e+01 7.0499893188476562e+01 -5.2613098144531250e+01 -1.0840399932861328e+02 7.0499893188476562e+01 -6.3995597839355469e+01 -9.4156501770019531e+01 7.0499893188476562e+01 -5.7810798645019531e+01 -9.4085098266601562e+01 7.0499893188476562e+01 -5.8007602691650391e+01 -8.8306800842285156e+01 7.0499893188476562e+01 -7.1051399230957031e+01 -8.4971702575683594e+01 7.0499893188476562e+01 -7.1051399230957031e+01 -8.4869102478027344e+01 7.0499893188476562e+01 -7.1042503356933594e+01 -1.0486100006103516e+02 7.0499893188476562e+01 -6.6141502380371094e+01 -1.0500399780273438e+02 7.0499893188476562e+01 -6.6044898986816406e+01 -9.8648101806640625e+01 7.0499893188476562e+01 -6.4503700256347656e+01 -1.0519800567626953e+02 7.0499893188476562e+01 -6.5988899230957031e+01 -1.0781200408935547e+02 7.0499893188476562e+01 -6.4503700256347656e+01 -1.0539899444580078e+02 7.0499893188476562e+01 -6.6000000000000000e+01 -6.5335105895996094e+01 7.0499893188476562e+01 -5.1378700256347656e+01 -8.4708694458007812e+01 7.0499893188476562e+01 -5.5309898376464844e+01 -8.4778305053710938e+01 7.0499893188476562e+01 -5.5116401672363281e+01 -8.7468299865722656e+01 7.0499893188476562e+01 -5.2381099700927734e+01 -8.7668098449707031e+01 7.0499893188476562e+01 -5.1772399902343750e+01 -8.7926498413085938e+01 7.0499893188476562e+01 -5.1180198669433594e+01 -9.4529197692871094e+01 7.0499893188476562e+01 -5.5208900451660156e+01 -9.4556694030761719e+01 7.0499893188476562e+01 -5.5518299102783203e+01 -8.8826004028320312e+01 7.0499893188476562e+01 -7.0751693725585938e+01 -8.8606605529785156e+01 7.0499893188476562e+01 -7.0971099853515625e+01 -1.0095000457763672e+02 7.0499893188476562e+01 -7.1344200134277344e+01 -9.9992500305175781e+01 7.0499893188476562e+01 -1.0954100036621094e+02 -7.5665397644042969e+01 7.0499893188476562e+01 -9.2171997070312500e+01 -7.8463302612304688e+01 7.0499893188476562e+01 -9.5475502014160156e+01 -1.0558499908447266e+02 7.0499893188476562e+01 -6.6077201843261719e+01 -1.0573499298095703e+02 7.0499893188476562e+01 -6.6211601257324219e+01 -1.0713999938964844e+02 7.0499893188476562e+01 -6.7979698181152344e+01 -1.0414200592041016e+02 7.0499893188476562e+01 -1.1077600097656250e+02 -1.0715000152587891e+02 7.0499893188476562e+01 -6.8713996887207031e+01 -1.0724200439453125e+02 7.0499893188476562e+01 -6.8535095214843750e+01 -1.0723099517822266e+02 7.0499893188476562e+01 -6.8138298034667969e+01 -1.0727000427246094e+02 7.0499893188476562e+01 -6.8335693359375000e+01 -1.0837899780273438e+02 7.0499893188476562e+01 -1.1166500091552734e+02 -8.8897499084472656e+01 7.0499893188476562e+01 -7.0554298400878906e+01 -9.9712600708007812e+01 7.0499893188476562e+01 -7.1234504699707031e+01 -9.8820404052734375e+01 7.0499893188476562e+01 -7.1028503417968750e+01 -8.1524497985839844e+01 7.0499893188476562e+01 -9.8536697387695312e+01 -8.4827995300292969e+01 7.0499893188476562e+01 -1.0133499908447266e+02 -8.8351303100585938e+01 7.0499893188476562e+01 -1.0384999847412109e+02 -9.2070198059082031e+01 7.0499893188476562e+01 -1.0606600189208984e+02 -9.5959503173828125e+01 7.0499893188476562e+01 -1.0796800231933594e+02 -9.8646995544433594e+01 7.0499893188476562e+01 -6.4636398315429688e+01 -9.8700698852539062e+01 7.0499893188476562e+01 -6.5269599914550781e+01 -1.0132499694824219e+02 7.0499893188476562e+01 -6.7530494689941406e+01 -9.8767196655273438e+01 7.0499893188476562e+01 -6.5579498291015625e+01 -9.8767303466796875e+01 7.0499893188476562e+01 -6.5579696655273438e+01 -1.0341899871826172e+02 7.0499893188476562e+01 -6.7116897583007812e+01 -1.0396499633789062e+02 7.0499893188476562e+01 -6.6819496154785156e+01 -1.0442700195312500e+02 7.0499893188476562e+01 -6.6502899169921875e+01 -1.0674600219726562e+02 7.0499893188476562e+01 -6.9190299987792969e+01 -1.0608799743652344e+02 7.0499893188476562e+01 -6.9781196594238281e+01 -1.0558000183105469e+02 7.0499893188476562e+01 -7.0134696960449219e+01 -1.0480500030517578e+02 7.0499893188476562e+01 -5.4862701416015625e+01 -1.0563199615478516e+02 7.0499893188476562e+01 -5.5228099822998047e+01 -1.0704199981689453e+02 7.0499893188476562e+01 -5.6331897735595703e+01 -1.0757499694824219e+02 7.0499893188476562e+01 -5.7019901275634766e+01 -1.0807300567626953e+02 7.0499893188476562e+01 -5.7945098876953125e+01 -1.0836000061035156e+02 7.0499893188476562e+01 -5.8736099243164062e+01 -9.7949195861816406e+01 7.0499893188476562e+01 -7.0696197509765625e+01 -9.6970397949218750e+01 7.0499893188476562e+01 -7.0137199401855469e+01 -9.6321800231933594e+01 7.0499893188476562e+01 -6.9625000000000000e+01 -7.3149803161621094e+01 7.0499893188476562e+01 -8.8648696899414062e+01 -1.0158999633789062e+02 7.0499893188476562e+01 -6.7533599853515625e+01 -1.0221800231933594e+02 7.0499893188476562e+01 -6.7483299255371094e+01 -9.9394004821777344e+01 7.0499893188476562e+01 -5.5155097961425781e+01 -1.0046900177001953e+02 7.0499893188476562e+01 -5.4771697998046875e+01 -1.0156399536132812e+02 7.0499893188476562e+01 -5.4568801879882812e+01 -1.0642099761962891e+02 7.0499893188476562e+01 -5.5753902435302734e+01 -1.0869300079345703e+02 7.0499893188476562e+01 -6.0788398742675781e+01 -1.0867899322509766e+02 7.0499893188476562e+01 -6.2016799926757812e+01 -1.0863000488281250e+02 7.0499893188476562e+01 -6.2534599304199219e+01 -9.5737297058105469e+01 7.0499893188476562e+01 -6.9019699096679688e+01 -9.5131095886230469e+01 7.0499893188476562e+01 -6.8165199279785156e+01 -9.4736099243164062e+01 7.0499893188476562e+01 -6.7381095886230469e+01 -1.0283200073242188e+02 7.0499893188476562e+01 -6.7345100402832031e+01 -1.0341899871826172e+02 7.0499893188476562e+01 -6.7116996765136719e+01 -1.0270000457763672e+02 7.0499893188476562e+01 -5.4522701263427734e+01 -1.0395199584960938e+02 7.0499893188476562e+01 -5.4642299652099609e+01 -1.0855599975585938e+02 7.0499893188476562e+01 -5.9567199707031250e+01 -1.0855599975585938e+02 7.0499893188476562e+01 -5.9567298889160156e+01 -9.4439605712890625e+01 7.0499893188476562e+01 -6.6538803100585938e+01 -9.4198501586914062e+01 7.0499893188476562e+01 -6.5324996948242188e+01 -9.1023200988769531e+01 7.0499893188476562e+01 -5.8307300567626953e+01 -1.0040100097656250e+02 7.0499893188476562e+01 -6.7385597229003906e+01 -1.0071399688720703e+02 7.0499893188476562e+01 -6.7467300415039062e+01 -1.0131900024414062e+02 7.0499893188476562e+01 -6.7530403137207031e+01 -9.8527000427246094e+01 7.0499893188476562e+01 -5.5611099243164062e+01 -9.7731796264648438e+01 7.0499893188476562e+01 -5.6158901214599609e+01 -9.9252799987792969e+01 7.0499893188476562e+01 -6.6586997985839844e+01 -9.9470298767089844e+01 7.0499893188476562e+01 -6.6829002380371094e+01 -9.8995201110839844e+01 7.0499893188476562e+01 -6.6182502746582031e+01 -9.8864700317382812e+01 7.0499893188476562e+01 -6.5887298583984375e+01 -9.9720100402832031e+01 7.0499893188476562e+01 -6.7037597656250000e+01 -1.0010000610351562e+02 7.0499893188476562e+01 -6.7264305114746094e+01 -1.0010000610351562e+02 7.0499893188476562e+01 -6.7264396667480469e+01 -1.0505699920654297e+02 7.0499893188476562e+01 -7.0435501098632812e+01 -1.0450699615478516e+02 7.0499893188476562e+01 -7.0692398071289062e+01 -1.0392900085449219e+02 7.0499893188476562e+01 -7.0907302856445312e+01 -1.0334400177001953e+02 7.0499893188476562e+01 -7.1076400756835938e+01 -1.0274399566650391e+02 7.0499893188476562e+01 -7.1202301025390625e+01 -9.5630104064941406e+01 7.0499893188476562e+01 -5.8593700408935547e+01 -9.6176994323730469e+01 7.0499893188476562e+01 -5.7765300750732422e+01 -9.6820693969726562e+01 7.0499893188476562e+01 -5.6993499755859375e+01 -9.5077697753906250e+01 7.0499893188476562e+01 -5.9693702697753906e+01 -9.3865699768066406e+01 7.0499893188476562e+01 -5.8226997375488281e+01 -9.4707695007324219e+01 7.0499893188476562e+01 -6.0688098907470703e+01 -1.0213600158691406e+02 7.0499893188476562e+01 -7.1288200378417969e+01 -1.0154499816894531e+02 7.0499893188476562e+01 -7.1334899902343750e+01 -9.4242599487304688e+01 7.0499893188476562e+01 -6.2914295196533203e+01 -9.4242797851562500e+01 7.0499893188476562e+01 -6.2913097381591797e+01 -9.4436805725097656e+01 7.0499893188476562e+01 -6.1703903198242188e+01 -9.3565795898437500e+01 7.0499893188476562e+01 -5.8307300567626953e+01 -9.4143707275390625e+01 7.0499893188476562e+01 -6.4418899536132812e+01 -9.4183898925781250e+01 7.0499893188476562e+01 -6.3501701354980469e+01 -9.6185501098632812e+01 7.0499893188476562e+01 -4.8519001007080078e+01 -9.6197097778320312e+01 7.0499893188476562e+01 -4.8720100402832031e+01 -9.6105796813964844e+01 7.0499893188476562e+01 -4.9542198181152344e+01 -8.8229598999023438e+01 7.0499893188476562e+01 -5.0635597229003906e+01 -8.8585502624511719e+01 7.0499893188476562e+01 -5.0123901367187500e+01 -8.9130699157714844e+01 7.0499893188476562e+01 -4.9542198181152344e+01 -6.6223503112792969e+01 7.0499893188476562e+01 -4.7141700744628906e+01 -7.3149803161621094e+01 7.0499893188476562e+01 -3.1351301193237305e+01 -8.9311897277832031e+01 7.0499893188476562e+01 -4.9348800659179688e+01 -7.5665397644042969e+01 7.0499893188476562e+01 -2.7828001022338867e+01 -8.9801399230957031e+01 7.0499893188476562e+01 -4.8962501525878906e+01 -7.8463302612304688e+01 7.0499893188476562e+01 -2.4524499893188477e+01 -9.0330497741699219e+01 7.0499893188476562e+01 -4.8632499694824219e+01 -8.1524497985839844e+01 7.0499893188476562e+01 -2.1463298797607422e+01 -9.1295600891113281e+01 7.0499893188476562e+01 -4.8205200195312500e+01 -8.4827995300292969e+01 7.0499893188476562e+01 -1.8665399551391602e+01 -7.0933799743652344e+01 7.0499893188476562e+01 -3.5070198059082031e+01 -6.9032501220703125e+01 7.0499893188476562e+01 -3.8959499359130859e+01 -6.7458801269531250e+01 7.0499893188476562e+01 -4.2992500305175781e+01 -9.1890899658203125e+01 7.0499893188476562e+01 -4.8031200408935547e+01 -8.8351303100585938e+01 7.0499893188476562e+01 -1.6149799346923828e+01 -9.3099304199218750e+01 7.0499893188476562e+01 -4.7848499298095703e+01 -9.3808502197265625e+01 7.0499893188476562e+01 -4.7828399658203125e+01 -9.5959503173828125e+01 7.0499893188476562e+01 -1.2032499313354492e+01 -9.2070198059082031e+01 7.0499893188476562e+01 -1.3933799743652344e+01 -9.4090797424316406e+01 7.0499893188476562e+01 -4.7840000152587891e+01 -9.4382598876953125e+01 7.0499893188476562e+01 -4.7861400604248047e+01 -9.9992500305175781e+01 7.0499893188476562e+01 -1.0458800315856934e+01 -9.4673400878906250e+01 7.0499893188476562e+01 -4.7892398834228516e+01 -9.4962997436523438e+01 7.0499893188476562e+01 -4.7933197021484375e+01 -9.4963104248046875e+01 7.0499893188476562e+01 -4.7933197021484375e+01 -9.5246299743652344e+01 7.0499893188476562e+01 -4.7979797363281250e+01 -1.0414200592041016e+02 7.0499893188476562e+01 -9.2235202789306641e+00 -9.5714797973632812e+01 7.0499893188476562e+01 -4.8065101623535156e+01 -1.0837899780273438e+02 7.0499893188476562e+01 -8.3351202011108398e+00 -9.5796699523925781e+01 7.0499893188476562e+01 -4.8087001800537109e+01 -1.0942600250244141e+02 7.0499893188476562e+01 -8.2045192718505859e+00 -9.5973197937011719e+01 7.0499893188476562e+01 -4.8183601379394531e+01 -9.6107902526855469e+01 7.0499893188476562e+01 -4.8333202362060547e+01 -1.6306599426269531e+02 7.0499893188476562e+01 -3.5070198059082031e+01 -1.4261599731445312e+02 7.0499893188476562e+01 -4.8312599182128906e+01 -1.4279000854492188e+02 7.0499893188476562e+01 -4.8569900512695312e+01 -1.3861300659179688e+02 7.0499893188476562e+01 -4.8245601654052734e+01 -1.1267500305175781e+02 7.0499893188476562e+01 -7.7996301651000977e+00 -1.3839300537109375e+02 7.0499893188476562e+01 -4.8465000152587891e+01 -1.3832199096679688e+02 7.0499893188476562e+01 -4.8662597656250000e+01 -1.6085000610351562e+02 7.0499893188476562e+01 -3.1351301193237305e+01 -1.5833500671386719e+02 7.0499893188476562e+01 -2.7828001022338867e+01 -1.4233799743652344e+02 7.0499893188476562e+01 -4.8176399230957031e+01 -1.5553698730468750e+02 7.0499893188476562e+01 -2.4524499893188477e+01 -1.5247599792480469e+02 7.0499893188476562e+01 -2.1463298797607422e+01 -1.2562100219726562e+02 7.0499893188476562e+01 -8.3351202011108398e+00 -1.2985800170898438e+02 7.0499893188476562e+01 -9.2235202789306641e+00 -1.3891300964355469e+02 7.0499893188476562e+01 -4.8165298461914062e+01 -1.2132500457763672e+02 7.0499893188476562e+01 -7.7996301651000977e+00 -1.1700000000000000e+02 7.0499893188476562e+01 -7.6206898689270020e+00 -1.4222300720214844e+02 7.0499893188476562e+01 -4.8165298461914062e+01 -1.3804000854492188e+02 7.0499893188476562e+01 -1.2032499313354492e+01 -1.3400801086425781e+02 7.0499893188476562e+01 -1.0458800315856934e+01 -1.4917199707031250e+02 7.0499893188476562e+01 -1.8665399551391602e+01 -1.4564900207519531e+02 7.0499893188476562e+01 -1.6149799346923828e+01 -1.4192999267578125e+02 7.0499893188476562e+01 -1.3933799743652344e+01 -1.6777600097656250e+02 7.0499893188476562e+01 -4.7141700744628906e+01 -1.6654100036621094e+02 7.0499893188476562e+01 -4.2992500305175781e+01 -1.6496800231933594e+02 7.0499893188476562e+01 -3.8959499359130859e+01 -1.1245000457763672e+02 6.8767799377441406e+01 -5.0899400711059570e+00 -1.0773999786376953e+02 6.3129501342773438e+01 -3.0201101303100586e+00 -1.0793099975585938e+02 6.8767799377441406e+01 -5.6532597541809082e+00 -1.0750000000000000e+02 6.3129501342773438e+01 -3.0690498352050781e+00 -1.0347399902343750e+02 6.8767799377441406e+01 -6.5877499580383301e+00 -9.4867294311523438e+01 6.8767799377441406e+01 -9.5425300598144531e+00 -9.0172698974609375e+01 6.3129501342773438e+01 -8.8849096298217773e+00 -9.0776199340820312e+01 6.8767799377441406e+01 -1.1542599678039551e+01 -8.9537200927734375e+01 6.3129501342773438e+01 -9.2518405914306641e+00 -8.6864097595214844e+01 6.8767799377441406e+01 -1.3873600006103516e+01 -1.0318499755859375e+02 6.3129501342773438e+01 -3.9500598907470703e+00 -9.8719596862792969e+01 6.3129501342773438e+01 -5.2434201240539551e+00 -9.9109703063964844e+01 6.8767799377441406e+01 -7.8871297836303711e+00 -9.8262199401855469e+01 6.3129501342773438e+01 -5.4168701171875000e+00 -9.4372802734375000e+01 6.3129501342773438e+01 -6.8919701576232910e+00 -7.9682998657226562e+01 6.8767799377441406e+01 -1.9463001251220703e+01 -7.5366897583007812e+01 6.3129501342773438e+01 -2.0010799407958984e+01 -7.6462997436523438e+01 6.8767799377441406e+01 -2.2683000564575195e+01 -7.4555702209472656e+01 6.3129501342773438e+01 -2.0926399230957031e+01 -7.3519805908203125e+01 6.8767799377441406e+01 -2.6157999038696289e+01 -8.6146697998046875e+01 6.3129501342773438e+01 -1.1209400177001953e+01 -8.2320693969726562e+01 6.3129501342773438e+01 -1.3850199699401855e+01 -8.3158004760742188e+01 6.8767799377441406e+01 -1.6519800186157227e+01 -8.1562805175781250e+01 6.3129501342773438e+01 -1.4469099998474121e+01 -7.8719604492187500e+01 6.3129501342773438e+01 -1.6790399551391602e+01 -6.8542602539062500e+01 6.8767799377441406e+01 -3.3776203155517578e+01 -6.4846099853515625e+01 6.3129501342773438e+01 -3.5252700805664062e+01 -6.6542495727539062e+01 6.8767799377441406e+01 -3.7867301940917969e+01 -6.4174896240234375e+01 6.3129501342773438e+01 -3.6828300476074219e+01 -6.4887100219726562e+01 6.8767799377441406e+01 -4.2109703063964844e+01 -7.2284103393554688e+01 6.3129501342773438e+01 -2.3490499496459961e+01 -6.9491294860839844e+01 6.3129501342773438e+01 -2.7207099914550781e+01 -7.0873603820800781e+01 6.8767799377441406e+01 -2.9864101409912109e+01 -6.8706695556640625e+01 6.3129501342773438e+01 -2.8447700500488281e+01 -6.7006599426269531e+01 6.3129501342773438e+01 -3.1136301040649414e+01 -5.9693500518798828e+01 6.3129501342773438e+01 -5.3041801452636719e+01 -6.2089900970458984e+01 6.8767799377441406e+01 -5.5450099945068359e+01 -6.2653305053710938e+01 6.8767799377441406e+01 -5.0931201934814453e+01 -6.3023902893066406e+01 6.3129501342773438e+01 -3.9529598236083984e+01 -6.1551803588867188e+01 6.3129501342773438e+01 -4.3939197540283203e+01 -6.3587703704833984e+01 6.8767799377441406e+01 -4.6474201202392578e+01 -6.1083297729492188e+01 6.3129501342773438e+01 -4.5839702606201172e+01 -6.0439197540283203e+01 6.3129501342773438e+01 -4.8452999114990234e+01 -5.9516300201416016e+01 6.3129501342773438e+01 -5.5236701965332031e+01 -5.9319400787353516e+01 6.3129501342773438e+01 -5.7675598144531250e+01 -6.1901802062988281e+01 6.8767799377441406e+01 -6.0000000000000000e+01 -5.9319400787353516e+01 6.3129501342773438e+01 -6.2324401855468750e+01 -6.2089900970458984e+01 6.8767799377441406e+01 -6.4549903869628906e+01 -5.9516300201416016e+01 6.3129501342773438e+01 -6.4763298034667969e+01 -5.9693500518798828e+01 6.3129501342773438e+01 -6.6958198547363281e+01 -6.2653305053710938e+01 6.8767799377441406e+01 -6.9068794250488281e+01 -6.0439197540283203e+01 6.3129501342773438e+01 -7.1547004699707031e+01 -6.3587703704833984e+01 6.8767799377441406e+01 -7.3525802612304688e+01 -6.1083297729492188e+01 6.3129501342773438e+01 -7.4160301208496094e+01 -6.1551803588867188e+01 6.3129501342773438e+01 -7.6060798645019531e+01 -6.4887100219726562e+01 6.8767799377441406e+01 -7.7890296936035156e+01 -6.3023902893066406e+01 6.3129501342773438e+01 -8.0470397949218750e+01 -6.6542495727539062e+01 6.8767799377441406e+01 -8.2132698059082031e+01 -6.4174896240234375e+01 6.3129501342773438e+01 -8.3171699523925781e+01 -6.4846099853515625e+01 6.3129501342773438e+01 -8.4747299194335938e+01 -6.8542602539062500e+01 6.8767799377441406e+01 -8.6223800659179688e+01 -6.7006599426269531e+01 6.3129501342773438e+01 -8.8863700866699219e+01 -7.0873603820800781e+01 6.8767799377441406e+01 -9.0135902404785156e+01 -6.8706695556640625e+01 6.3129501342773438e+01 -9.1552299499511719e+01 -6.9491294860839844e+01 6.3129501342773438e+01 -9.2792900085449219e+01 -7.3519805908203125e+01 6.8767799377441406e+01 -9.3842002868652344e+01 -7.2284103393554688e+01 6.3129501342773438e+01 -9.6509498596191406e+01 -7.6462997436523438e+01 6.8767799377441406e+01 -9.7317001342773438e+01 -7.4555702209472656e+01 6.3129501342773438e+01 -9.9073593139648438e+01 -7.5366897583007812e+01 6.3129501342773438e+01 -9.9989196777343750e+01 -7.9682998657226562e+01 6.8767799377441406e+01 -1.0053700256347656e+02 -7.8719604492187500e+01 6.3129501342773438e+01 -1.0320999908447266e+02 -8.3158004760742188e+01 6.8767799377441406e+01 -1.0347999572753906e+02 -8.1562805175781250e+01 6.3129501342773438e+01 -1.0553099822998047e+02 -8.2320693969726562e+01 6.3129501342773438e+01 -1.0615000152587891e+02 -8.6864097595214844e+01 6.8767799377441406e+01 -1.0612599945068359e+02 -8.6146697998046875e+01 6.3129501342773438e+01 -1.0879100036621094e+02 -9.0776199340820312e+01 6.8767799377441406e+01 -1.0845700073242188e+02 -8.9537200927734375e+01 6.3129501342773438e+01 -1.1074800109863281e+02 -9.0172698974609375e+01 6.3129501342773438e+01 -1.1111499786376953e+02 -9.4867294311523438e+01 6.8767799377441406e+01 -1.1045700073242188e+02 -9.4372802734375000e+01 6.3129501342773438e+01 -1.1310800170898438e+02 -9.9109703063964844e+01 6.8767799377441406e+01 -1.1211299896240234e+02 -9.8262199401855469e+01 6.3129501342773438e+01 -1.1458300018310547e+02 -9.8719596862792969e+01 6.3129501342773438e+01 -1.1475700378417969e+02 -1.0347399902343750e+02 6.8767799377441406e+01 -1.1341200256347656e+02 -1.0318499755859375e+02 6.3129501342773438e+01 -1.1604999542236328e+02 -1.0793099975585938e+02 6.8767799377441406e+01 -1.1434700012207031e+02 -1.2155000305175781e+02 6.8767799377441406e+01 -1.1490999603271484e+02 -1.2625999450683594e+02 6.3129501342773438e+01 -1.1698000335693359e+02 -1.2606899261474609e+02 6.8767799377441406e+01 -1.1434700012207031e+02 -1.2649999237060547e+02 6.3129501342773438e+01 -1.1693099975585938e+02 -1.3052600097656250e+02 6.8767799377441406e+01 -1.1341200256347656e+02 -1.0750000000000000e+02 6.3129501342773438e+01 -1.1693099975585938e+02 -1.0773999786376953e+02 6.3129501342773438e+01 -1.1698000335693359e+02 -1.1245000457763672e+02 6.8767799377441406e+01 -1.1490999603271484e+02 -1.1235500335693359e+02 6.3129501342773438e+01 -1.1754000091552734e+02 -1.1700000000000000e+02 6.8767799377441406e+01 -1.1509799957275391e+02 -1.1700000000000000e+02 6.3129501342773438e+01 -1.1772699737548828e+02 -1.2164500427246094e+02 6.3129501342773438e+01 -1.1754000091552734e+02 -1.3913301086425781e+02 6.8767799377441406e+01 -1.1045700073242188e+02 -1.4382701110839844e+02 6.3129501342773438e+01 -1.1111499786376953e+02 -1.4322399902343750e+02 6.8767799377441406e+01 -1.0845700073242188e+02 -1.4446299743652344e+02 6.3129501342773438e+01 -1.1074800109863281e+02 -1.4713600158691406e+02 6.8767799377441406e+01 -1.0612599945068359e+02 -1.3081500244140625e+02 6.3129501342773438e+01 -1.1604999542236328e+02 -1.3527999877929688e+02 6.3129501342773438e+01 -1.1475700378417969e+02 -1.3488999938964844e+02 6.8767799377441406e+01 -1.1211299896240234e+02 -1.3573800659179688e+02 6.3129501342773438e+01 -1.1458300018310547e+02 -1.3962699890136719e+02 6.3129501342773438e+01 -1.1310800170898438e+02 -1.5431700134277344e+02 6.8767799377441406e+01 -1.0053700256347656e+02 -1.5863299560546875e+02 6.3129501342773438e+01 -9.9989196777343750e+01 -1.5753700256347656e+02 6.8767799377441406e+01 -9.7317001342773438e+01 -1.5944400024414062e+02 6.3129501342773438e+01 -9.9073593139648438e+01 -1.6047999572753906e+02 6.8767799377441406e+01 -9.3842002868652344e+01 -1.4785299682617188e+02 6.3129501342773438e+01 -1.0879100036621094e+02 -1.5167900085449219e+02 6.3129501342773438e+01 -1.0615000152587891e+02 -1.5084199523925781e+02 6.8767799377441406e+01 -1.0347999572753906e+02 -1.5243699645996094e+02 6.3129501342773438e+01 -1.0553099822998047e+02 -1.5527999877929688e+02 6.3129501342773438e+01 -1.0320999908447266e+02 -1.6545700073242188e+02 6.8767799377441406e+01 -8.6223800659179688e+01 -1.6915400695800781e+02 6.3129501342773438e+01 -8.4747299194335938e+01 -1.6745700073242188e+02 6.8767799377441406e+01 -8.2132698059082031e+01 -1.6982499694824219e+02 6.3129501342773438e+01 -8.3171699523925781e+01 -1.6911299133300781e+02 6.8767799377441406e+01 -7.7890296936035156e+01 -1.6171600341796875e+02 6.3129501342773438e+01 -9.6509498596191406e+01 -1.6450900268554688e+02 6.3129501342773438e+01 -9.2792900085449219e+01 -1.6312600708007812e+02 6.8767799377441406e+01 -9.0135902404785156e+01 -1.6529299926757812e+02 6.3129501342773438e+01 -9.1552299499511719e+01 -1.6699301147460938e+02 6.3129501342773438e+01 -8.8863700866699219e+01 -1.7430700683593750e+02 6.3129501342773438e+01 -6.6958198547363281e+01 -1.7191000366210938e+02 6.8767799377441406e+01 -6.4549903869628906e+01 -1.7134700012207031e+02 6.8767799377441406e+01 -6.9068794250488281e+01 -1.7097599792480469e+02 6.3129501342773438e+01 -8.0470397949218750e+01 -1.7244799804687500e+02 6.3129501342773438e+01 -7.6060798645019531e+01 -1.7041200256347656e+02 6.8767799377441406e+01 -7.3525802612304688e+01 -1.7291699218750000e+02 6.3129501342773438e+01 -7.4160301208496094e+01 -1.7356100463867188e+02 6.3129501342773438e+01 -7.1547004699707031e+01 -1.7448399353027344e+02 6.3129501342773438e+01 -6.4763298034667969e+01 -1.7468099975585938e+02 6.3129501342773438e+01 -6.2324401855468750e+01 -1.7209799194335938e+02 6.8767799377441406e+01 -6.0000000000000000e+01 -1.7468099975585938e+02 6.3129501342773438e+01 -5.7675598144531250e+01 -1.7191000366210938e+02 6.8767799377441406e+01 -5.5450099945068359e+01 -1.7448399353027344e+02 6.3129501342773438e+01 -5.5236701965332031e+01 -1.7430700683593750e+02 6.3129501342773438e+01 -5.3041801452636719e+01 -1.7134700012207031e+02 6.8767799377441406e+01 -5.0931201934814453e+01 -1.7356100463867188e+02 6.3129501342773438e+01 -4.8452999114990234e+01 -1.7041200256347656e+02 6.8767799377441406e+01 -4.6474201202392578e+01 -1.7291699218750000e+02 6.3129501342773438e+01 -4.5839702606201172e+01 -1.7244799804687500e+02 6.3129501342773438e+01 -4.3939197540283203e+01 -1.6911299133300781e+02 6.8767799377441406e+01 -4.2109703063964844e+01 -1.7097599792480469e+02 6.3129501342773438e+01 -3.9529598236083984e+01 -1.6745700073242188e+02 6.8767799377441406e+01 -3.7867301940917969e+01 -1.6982499694824219e+02 6.3129501342773438e+01 -3.6828300476074219e+01 -1.6915400695800781e+02 6.3129501342773438e+01 -3.5252700805664062e+01 -1.6545700073242188e+02 6.8767799377441406e+01 -3.3776203155517578e+01 -1.6699301147460938e+02 6.3129501342773438e+01 -3.1136301040649414e+01 -1.6312600708007812e+02 6.8767799377441406e+01 -2.9864101409912109e+01 -1.6529299926757812e+02 6.3129501342773438e+01 -2.8447700500488281e+01 -1.6450900268554688e+02 6.3129501342773438e+01 -2.7207099914550781e+01 -1.6047999572753906e+02 6.8767799377441406e+01 -2.6157999038696289e+01 -1.6171600341796875e+02 6.3129501342773438e+01 -2.3490499496459961e+01 -1.5753700256347656e+02 6.8767799377441406e+01 -2.2683000564575195e+01 -1.5944400024414062e+02 6.3129501342773438e+01 -2.0926399230957031e+01 -1.5863299560546875e+02 6.3129501342773438e+01 -2.0010799407958984e+01 -1.5431700134277344e+02 6.8767799377441406e+01 -1.9463001251220703e+01 -1.5527999877929688e+02 6.3129501342773438e+01 -1.6790399551391602e+01 -1.5084199523925781e+02 6.8767799377441406e+01 -1.6519800186157227e+01 -1.5243699645996094e+02 6.3129501342773438e+01 -1.4469099998474121e+01 -1.5167900085449219e+02 6.3129501342773438e+01 -1.3850199699401855e+01 -1.4713600158691406e+02 6.8767799377441406e+01 -1.3873600006103516e+01 -1.4785299682617188e+02 6.3129501342773438e+01 -1.1209400177001953e+01 -1.4322399902343750e+02 6.8767799377441406e+01 -1.1542599678039551e+01 -1.4446299743652344e+02 6.3129501342773438e+01 -9.2518405914306641e+00 -1.4382701110839844e+02 6.3129501342773438e+01 -8.8849096298217773e+00 -1.3913301086425781e+02 6.8767799377441406e+01 -9.5425300598144531e+00 -1.3962699890136719e+02 6.3129501342773438e+01 -6.8919701576232910e+00 -1.3488999938964844e+02 6.8767799377441406e+01 -7.8871297836303711e+00 -1.3573800659179688e+02 6.3129501342773438e+01 -5.4168701171875000e+00 -1.3527999877929688e+02 6.3129501342773438e+01 -5.2434201240539551e+00 -1.3052600097656250e+02 6.8767799377441406e+01 -6.5877499580383301e+00 -1.3081500244140625e+02 6.3129501342773438e+01 -3.9500598907470703e+00 -1.2606899261474609e+02 6.8767799377441406e+01 -5.6532597541809082e+00 -1.2649999237060547e+02 6.3129501342773438e+01 -3.0690498352050781e+00 -1.2625999450683594e+02 6.3129501342773438e+01 -3.0201101303100586e+00 -1.2155000305175781e+02 6.8767799377441406e+01 -5.0899400711059570e+00 -1.2164500427246094e+02 6.3129501342773438e+01 -2.4597699642181396e+00 -1.1700000000000000e+02 6.8767799377441406e+01 -4.9017701148986816e+00 -1.1700000000000000e+02 6.3129501342773438e+01 -2.2726101875305176e+00 -1.1235500335693359e+02 6.3129501342773438e+01 -2.4597699642181396e+00 -1.0305500030517578e+02 6.1548198699951172e+01 -1.1657900238037109e+02 -9.8547195434570312e+01 6.1548198699951172e+01 -1.1527299499511719e+02 -9.4159400939941406e+01 6.1548198699951172e+01 -1.1360900115966797e+02 -8.9919700622558594e+01 6.1548198699951172e+01 -1.1159700012207031e+02 -8.5855697631835938e+01 6.1548198699951172e+01 -1.0925099945068359e+02 -8.1993598937988281e+01 6.1548198699951172e+01 -1.0658500671386719e+02 -7.8358596801757812e+01 6.1548198699951172e+01 -1.0361699676513672e+02 -7.4974098205566406e+01 6.1548198699951172e+01 -1.0036599731445312e+02 -7.1862304687500000e+01 6.1548198699951172e+01 -9.6853797912597656e+01 -6.9043197631835938e+01 6.1548198699951172e+01 -9.3102203369140625e+01 -6.6535003662109375e+01 6.1548198699951172e+01 -8.9135902404785156e+01 -6.4354202270507812e+01 6.1548198699951172e+01 -8.4980697631835938e+01 -6.2514797210693359e+01 6.1548198699951172e+01 -8.0663505554199219e+01 -6.1028701782226562e+01 6.1548198699951172e+01 -7.6212196350097656e+01 -5.9905700683593750e+01 6.1548198699951172e+01 -7.1655899047851562e+01 -5.9152900695800781e+01 6.1548198699951172e+01 -6.7023902893066406e+01 -5.8775299072265625e+01 6.1548198699951172e+01 -6.2346298217773438e+01 -5.8775299072265625e+01 6.1548198699951172e+01 -5.7653697967529297e+01 -5.9152900695800781e+01 6.1548198699951172e+01 -5.2976100921630859e+01 -6.1028701782226562e+01 6.1548198699951172e+01 -4.3787799835205078e+01 -5.9905700683593750e+01 6.1548198699951172e+01 -4.8344100952148438e+01 -6.2514797210693359e+01 6.1548198699951172e+01 -3.9336498260498047e+01 -6.4354202270507812e+01 6.1548198699951172e+01 -3.5019302368164062e+01 -6.9043197631835938e+01 6.1548198699951172e+01 -2.6897798538208008e+01 -6.6535003662109375e+01 6.1548198699951172e+01 -3.0864101409912109e+01 -7.1862304687500000e+01 6.1548198699951172e+01 -2.3146200180053711e+01 -7.4974098205566406e+01 6.1548198699951172e+01 -1.9633600234985352e+01 -8.1993598937988281e+01 6.1548198699951172e+01 -1.3414899826049805e+01 -7.8358596801757812e+01 6.1548198699951172e+01 -1.6382898330688477e+01 -8.5855697631835938e+01 6.1548198699951172e+01 -1.0749200820922852e+01 -8.9919700622558594e+01 6.1548198699951172e+01 -8.4027700424194336e+00 -9.4159400939941406e+01 6.1548198699951172e+01 -6.3910498619079590e+00 -9.8547195434570312e+01 6.1548198699951172e+01 -4.7269501686096191e+00 -1.0305500030517578e+02 6.1548198699951172e+01 -3.4213700294494629e+00 -1.0765299987792969e+02 6.1548198699951172e+01 -2.4827098846435547e+00 -1.1231099700927734e+02 6.1548198699951172e+01 -1.9170700311660767e+00 -1.1700000000000000e+02 6.1548198699951172e+01 -1.7280600070953369e+00 -1.2168900299072266e+02 6.1548198699951172e+01 -1.9170700311660767e+00 -1.2634700775146484e+02 6.1548198699951172e+01 -2.4827098846435547e+00 -1.3094499206542969e+02 6.1548198699951172e+01 -3.4213700294494629e+00 -1.3545300292968750e+02 6.1548198699951172e+01 -4.7269501686096191e+00 -1.3984100341796875e+02 6.1548198699951172e+01 -6.3910498619079590e+00 -1.4408000183105469e+02 6.1548198699951172e+01 -8.4027700424194336e+00 -1.4814401245117188e+02 6.1548198699951172e+01 -1.0749200820922852e+01 -1.5200599670410156e+02 6.1548198699951172e+01 -1.3414899826049805e+01 -1.5564100646972656e+02 6.1548198699951172e+01 -1.6382898330688477e+01 -1.5902600097656250e+02 6.1548198699951172e+01 -1.9633600234985352e+01 -1.6213800048828125e+02 6.1548198699951172e+01 -2.3146200180053711e+01 -1.6495700073242188e+02 6.1548198699951172e+01 -2.6897798538208008e+01 -1.6746499633789062e+02 6.1548198699951172e+01 -3.0864101409912109e+01 -1.6964599609375000e+02 6.1548198699951172e+01 -3.5019302368164062e+01 -1.7148500061035156e+02 6.1548198699951172e+01 -3.9336498260498047e+01 -1.7297099304199219e+02 6.1548198699951172e+01 -4.3787799835205078e+01 -1.7409400939941406e+02 6.1548198699951172e+01 -4.8344100952148438e+01 -1.7484700012207031e+02 6.1548198699951172e+01 -5.2976100921630859e+01 -1.7522500610351562e+02 6.1548198699951172e+01 -5.7653697967529297e+01 -1.7522500610351562e+02 6.1548198699951172e+01 -6.2346298217773438e+01 -1.7484700012207031e+02 6.1548198699951172e+01 -6.7023902893066406e+01 -1.7297099304199219e+02 6.1548198699951172e+01 -7.6212196350097656e+01 -1.7409400939941406e+02 6.1548198699951172e+01 -7.1655899047851562e+01 -1.7148500061035156e+02 6.1548198699951172e+01 -8.0663505554199219e+01 -1.6964599609375000e+02 6.1548198699951172e+01 -8.4980697631835938e+01 -1.6495700073242188e+02 6.1548198699951172e+01 -9.3102203369140625e+01 -1.6746499633789062e+02 6.1548198699951172e+01 -8.9135902404785156e+01 -1.6213800048828125e+02 6.1548198699951172e+01 -9.6853797912597656e+01 -1.5902600097656250e+02 6.1548198699951172e+01 -1.0036599731445312e+02 -1.5200599670410156e+02 6.1548198699951172e+01 -1.0658500671386719e+02 -1.5564100646972656e+02 6.1548198699951172e+01 -1.0361699676513672e+02 -1.4814401245117188e+02 6.1548198699951172e+01 -1.0925099945068359e+02 -1.4408000183105469e+02 6.1548198699951172e+01 -1.1159700012207031e+02 -1.3984100341796875e+02 6.1548198699951172e+01 -1.1360900115966797e+02 -1.3545300292968750e+02 6.1548198699951172e+01 -1.1527299499511719e+02 -1.3094499206542969e+02 6.1548198699951172e+01 -1.1657900238037109e+02 -1.2634700775146484e+02 6.1548198699951172e+01 -1.1751699829101562e+02 -1.2168900299072266e+02 6.1548198699951172e+01 -1.1808300018310547e+02 -1.1700000000000000e+02 6.1548198699951172e+01 -1.1827199554443359e+02 -1.1231099700927734e+02 6.1548198699951172e+01 -1.1808300018310547e+02 -1.0765299987792969e+02 6.1548198699951172e+01 -1.1751699829101562e+02 -1.0819599914550781e+02 7.0288002014160156e+01 -1.1275699615478516e+02 -1.0386999511718750e+02 7.0288002014160156e+01 -1.1184999847412109e+02 -9.9632797241210938e+01 7.0288002014160156e+01 -1.1058899688720703e+02 -9.5514602661132812e+01 7.0288002014160156e+01 -1.0898199462890625e+02 -9.1542999267578125e+01 7.0288002014160156e+01 -1.0704000091552734e+02 -8.7745399475097656e+01 7.0288002014160156e+01 -1.0477700042724609e+02 -8.4147697448730469e+01 7.0288002014160156e+01 -1.0220899963378906e+02 -8.0774299621582031e+01 7.0288002014160156e+01 -9.9351600646972656e+01 -7.7648399353027344e+01 7.0288002014160156e+01 -9.6225700378417969e+01 -7.4791297912597656e+01 7.0288002014160156e+01 -9.2852302551269531e+01 -7.2222595214843750e+01 7.0288002014160156e+01 -8.9254600524902344e+01 -6.9959701538085938e+01 7.0288002014160156e+01 -8.5457000732421875e+01 -6.8018104553222656e+01 7.0288002014160156e+01 -8.1485397338867188e+01 -6.6411193847656250e+01 7.0288002014160156e+01 -7.7367202758789062e+01 -6.5149795532226562e+01 7.0288002014160156e+01 -7.3130195617675781e+01 -6.4242599487304688e+01 7.0288002014160156e+01 -6.8803604125976562e+01 -6.3695697784423828e+01 7.0288002014160156e+01 -6.4416900634765625e+01 -6.3513099670410156e+01 7.0288002014160156e+01 -6.0000000000000000e+01 -6.3695697784423828e+01 7.0288002014160156e+01 -5.5583099365234375e+01 -6.4242599487304688e+01 7.0288002014160156e+01 -5.1196399688720703e+01 -6.5149795532226562e+01 7.0288002014160156e+01 -4.6869800567626953e+01 -6.6411193847656250e+01 7.0288002014160156e+01 -4.2632801055908203e+01 -6.8018104553222656e+01 7.0288002014160156e+01 -3.8514598846435547e+01 -6.9959701538085938e+01 7.0288002014160156e+01 -3.4542999267578125e+01 -7.2222595214843750e+01 7.0288002014160156e+01 -3.0745399475097656e+01 -7.4791297912597656e+01 7.0288002014160156e+01 -2.7147699356079102e+01 -7.7648399353027344e+01 7.0288002014160156e+01 -2.3774299621582031e+01 -8.0774299621582031e+01 7.0288002014160156e+01 -2.0648399353027344e+01 -8.4147697448730469e+01 7.0288002014160156e+01 -1.7791299819946289e+01 -8.7745399475097656e+01 7.0288002014160156e+01 -1.5222599983215332e+01 -9.1542999267578125e+01 7.0288002014160156e+01 -1.2959699630737305e+01 -9.5514602661132812e+01 7.0288002014160156e+01 -1.1018099784851074e+01 -9.9632797241210938e+01 7.0288002014160156e+01 -9.4111595153808594e+00 -1.0386999511718750e+02 7.0288002014160156e+01 -8.1497497558593750e+00 -1.0819599914550781e+02 7.0288002014160156e+01 -7.2425599098205566e+00 -1.1258300018310547e+02 7.0288002014160156e+01 -6.6957502365112305e+00 -1.1700000000000000e+02 7.0288002014160156e+01 -6.5130600929260254e+00 -1.2141699981689453e+02 7.0288002014160156e+01 -6.6957502365112305e+00 -1.2580400848388672e+02 7.0288002014160156e+01 -7.2425599098205566e+00 -1.3012998962402344e+02 7.0288002014160156e+01 -8.1497497558593750e+00 -1.3436700439453125e+02 7.0288002014160156e+01 -9.4111595153808594e+00 -1.3848500061035156e+02 7.0288002014160156e+01 -1.1018099784851074e+01 -1.4245700073242188e+02 7.0288002014160156e+01 -1.2959699630737305e+01 -1.4625500488281250e+02 7.0288002014160156e+01 -1.5222599983215332e+01 -1.4985198974609375e+02 7.0288002014160156e+01 -1.7791299819946289e+01 -1.5322599792480469e+02 7.0288002014160156e+01 -2.0648399353027344e+01 -1.5635200500488281e+02 7.0288002014160156e+01 -2.3774299621582031e+01 -1.5920899963378906e+02 7.0288002014160156e+01 -2.7147699356079102e+01 -1.6177700805664062e+02 7.0288002014160156e+01 -3.0745399475097656e+01 -1.6403999328613281e+02 7.0288002014160156e+01 -3.4542999267578125e+01 -1.6598199462890625e+02 7.0288002014160156e+01 -3.8514598846435547e+01 -1.6758898925781250e+02 7.0288002014160156e+01 -4.2632801055908203e+01 -1.6975698852539062e+02 7.0288002014160156e+01 -5.1196399688720703e+01 -1.6885000610351562e+02 7.0288002014160156e+01 -4.6869800567626953e+01 -1.7030400085449219e+02 7.0288002014160156e+01 -5.5583099365234375e+01 -1.7048699951171875e+02 7.0288002014160156e+01 -6.0000000000000000e+01 -1.7030400085449219e+02 7.0288002014160156e+01 -6.4416900634765625e+01 -1.6975698852539062e+02 7.0288002014160156e+01 -6.8803604125976562e+01 -1.6885000610351562e+02 7.0288002014160156e+01 -7.3130195617675781e+01 -1.6758898925781250e+02 7.0288002014160156e+01 -7.7367202758789062e+01 -1.6598199462890625e+02 7.0288002014160156e+01 -8.1485397338867188e+01 -1.6403999328613281e+02 7.0288002014160156e+01 -8.5457000732421875e+01 -1.6177700805664062e+02 7.0288002014160156e+01 -8.9254600524902344e+01 -1.5920899963378906e+02 7.0288002014160156e+01 -9.2852302551269531e+01 -1.5635200500488281e+02 7.0288002014160156e+01 -9.6225700378417969e+01 -1.5322599792480469e+02 7.0288002014160156e+01 -9.9351600646972656e+01 -1.4985198974609375e+02 7.0288002014160156e+01 -1.0220899963378906e+02 -1.4625500488281250e+02 7.0288002014160156e+01 -1.0477700042724609e+02 -1.4245700073242188e+02 7.0288002014160156e+01 -1.0704000091552734e+02 -1.3848500061035156e+02 7.0288002014160156e+01 -1.0898199462890625e+02 -1.3436700439453125e+02 7.0288002014160156e+01 -1.1058899688720703e+02 -1.3012998962402344e+02 7.0288002014160156e+01 -1.1184999847412109e+02 -1.2580400848388672e+02 7.0288002014160156e+01 -1.1275699615478516e+02 -1.2141699981689453e+02 7.0288002014160156e+01 -1.1330399322509766e+02 -1.1700000000000000e+02 7.0288002014160156e+01 -1.1348699951171875e+02 -1.1258300018310547e+02 7.0288002014160156e+01 -1.1330399322509766e+02 -1.2149500274658203e+02 6.9682098388671875e+01 -1.1425199890136719e+02 -1.1700000000000000e+02 6.9682098388671875e+01 -1.1443799591064453e+02 -1.1250499725341797e+02 6.9682098388671875e+01 -1.1425199890136719e+02 -1.0804000091552734e+02 6.9682098388671875e+01 -1.1369599914550781e+02 -1.0363599395751953e+02 6.9682098388671875e+01 -1.1277200317382812e+02 -9.9324005126953125e+01 6.9682098388671875e+01 -1.1148799896240234e+02 -9.5132499694824219e+01 6.9682098388671875e+01 -1.0985299682617188e+02 -9.1090400695800781e+01 6.9682098388671875e+01 -1.0787699890136719e+02 -8.7225196838378906e+01 6.9682098388671875e+01 -1.0557399749755859e+02 -8.3563499450683594e+01 6.9682098388671875e+01 -1.0295899963378906e+02 -8.0130096435546875e+01 6.9682098388671875e+01 -1.0005100250244141e+02 -7.6948699951171875e+01 6.9682098388671875e+01 -9.6869903564453125e+01 -7.4040702819824219e+01 6.9682098388671875e+01 -9.3436500549316406e+01 -7.1426300048828125e+01 6.9682098388671875e+01 -8.9774803161621094e+01 -6.9123199462890625e+01 6.9682098388671875e+01 -8.5909599304199219e+01 -6.7147094726562500e+01 6.9682098388671875e+01 -8.1867500305175781e+01 -6.5511596679687500e+01 6.9682098388671875e+01 -7.7675994873046875e+01 -6.4227798461914062e+01 6.9682098388671875e+01 -7.3363700866699219e+01 -6.3304500579833984e+01 6.9682098388671875e+01 -6.8960197448730469e+01 -6.2747901916503906e+01 6.9682098388671875e+01 -6.4495399475097656e+01 -6.2561901092529297e+01 6.9682098388671875e+01 -6.0000000000000000e+01 -6.2747901916503906e+01 6.9682098388671875e+01 -5.5504600524902344e+01 -6.3304500579833984e+01 6.9682098388671875e+01 -5.1039798736572266e+01 -6.4227798461914062e+01 6.9682098388671875e+01 -4.6636299133300781e+01 -6.5511596679687500e+01 6.9682098388671875e+01 -4.2323997497558594e+01 -6.7147094726562500e+01 6.9682098388671875e+01 -3.8132499694824219e+01 -6.9123199462890625e+01 6.9682098388671875e+01 -3.4090400695800781e+01 -7.1426300048828125e+01 6.9682098388671875e+01 -3.0225200653076172e+01 -7.4040702819824219e+01 6.9682098388671875e+01 -2.6563499450683594e+01 -7.6948699951171875e+01 6.9682098388671875e+01 -2.3130100250244141e+01 -8.0130096435546875e+01 6.9682098388671875e+01 -1.9948699951171875e+01 -8.3563499450683594e+01 6.9682098388671875e+01 -1.7040699005126953e+01 -8.7225196838378906e+01 6.9682098388671875e+01 -1.4426300048828125e+01 -9.1090400695800781e+01 6.9682098388671875e+01 -1.2123200416564941e+01 -9.5132499694824219e+01 6.9682098388671875e+01 -1.0147100448608398e+01 -9.9324005126953125e+01 6.9682098388671875e+01 -8.5116100311279297e+00 -1.0363599395751953e+02 6.9682098388671875e+01 -7.2277798652648926e+00 -1.0804000091552734e+02 6.9682098388671875e+01 -6.3044500350952148e+00 -1.1250499725341797e+02 6.9682098388671875e+01 -5.7479200363159180e+00 -1.1700000000000000e+02 6.9682098388671875e+01 -5.5619502067565918e+00 -1.2149500274658203e+02 6.9682098388671875e+01 -5.7479200363159180e+00 -1.2596000671386719e+02 6.9682098388671875e+01 -6.3044500350952148e+00 -1.3036399841308594e+02 6.9682098388671875e+01 -7.2277798652648926e+00 -1.3467599487304688e+02 6.9682098388671875e+01 -8.5116100311279297e+00 -1.3886801147460938e+02 6.9682098388671875e+01 -1.0147100448608398e+01 -1.4291000366210938e+02 6.9682098388671875e+01 -1.2123200416564941e+01 -1.4677500915527344e+02 6.9682098388671875e+01 -1.4426300048828125e+01 -1.5043699645996094e+02 6.9682098388671875e+01 -1.7040699005126953e+01 -1.5386999511718750e+02 6.9682098388671875e+01 -1.9948699951171875e+01 -1.5705099487304688e+02 6.9682098388671875e+01 -2.3130100250244141e+01 -1.5995899963378906e+02 6.9682098388671875e+01 -2.6563499450683594e+01 -1.6257398986816406e+02 6.9682098388671875e+01 -3.0225200653076172e+01 -1.6487699890136719e+02 6.9682098388671875e+01 -3.4090400695800781e+01 -1.6685299682617188e+02 6.9682098388671875e+01 -3.8132499694824219e+01 -1.6848799133300781e+02 6.9682098388671875e+01 -4.2323997497558594e+01 -1.6977200317382812e+02 6.9682098388671875e+01 -4.6636299133300781e+01 -1.7069599914550781e+02 6.9682098388671875e+01 -5.1039798736572266e+01 -1.7125199890136719e+02 6.9682098388671875e+01 -5.5504600524902344e+01 -1.7143798828125000e+02 6.9682098388671875e+01 -6.0000000000000000e+01 -1.7125199890136719e+02 6.9682098388671875e+01 -6.4495399475097656e+01 -1.7069599914550781e+02 6.9682098388671875e+01 -6.8960197448730469e+01 -1.6977200317382812e+02 6.9682098388671875e+01 -7.3363700866699219e+01 -1.6848799133300781e+02 6.9682098388671875e+01 -7.7675994873046875e+01 -1.6685299682617188e+02 6.9682098388671875e+01 -8.1867500305175781e+01 -1.6487699890136719e+02 6.9682098388671875e+01 -8.5909599304199219e+01 -1.6257398986816406e+02 6.9682098388671875e+01 -8.9774803161621094e+01 -1.5995899963378906e+02 6.9682098388671875e+01 -9.3436500549316406e+01 -1.5705099487304688e+02 6.9682098388671875e+01 -9.6869903564453125e+01 -1.5386999511718750e+02 6.9682098388671875e+01 -1.0005100250244141e+02 -1.5043699645996094e+02 6.9682098388671875e+01 -1.0295899963378906e+02 -1.4677500915527344e+02 6.9682098388671875e+01 -1.0557399749755859e+02 -1.4291000366210938e+02 6.9682098388671875e+01 -1.0787699890136719e+02 -1.3886801147460938e+02 6.9682098388671875e+01 -1.0985299682617188e+02 -1.3467599487304688e+02 6.9682098388671875e+01 -1.1148799896240234e+02 -1.3036399841308594e+02 6.9682098388671875e+01 -1.1277200317382812e+02 -1.2596000671386719e+02 6.9682098388671875e+01 -1.1369599914550781e+02 -9.4931900024414062e+01 7.0306900024414062e+01 -4.8130599975585938e+01 -9.4929595947265625e+01 6.9886001586914062e+01 -4.8145099639892578e+01 -9.5212600708007812e+01 7.0306900024414062e+01 -4.8176799774169922e+01 -9.5220794677734375e+01 6.9886001586914062e+01 -4.8193099975585938e+01 -9.5676895141601562e+01 7.0306900024414062e+01 -4.8261402130126953e+01 -9.5511100769042969e+01 6.9886001586914062e+01 -4.8245002746582031e+01 -9.5665405273437500e+01 7.0011604309082031e+01 -4.8269599914550781e+01 -9.5660598754882812e+01 6.9886001586914062e+01 -4.8273197174072266e+01 -9.5723197937011719e+01 7.0306900024414062e+01 -5.1175601959228516e+01 -9.5998397827148438e+01 7.0306900024414062e+01 -4.8698001861572266e+01 -9.5714401245117188e+01 7.0017501831054688e+01 -5.1163597106933594e+01 -9.5987197875976562e+01 7.0011604309082031e+01 -4.8706401824951172e+01 -9.5710296630859375e+01 6.9886001586914062e+01 -5.1158199310302734e+01 -9.5982299804687500e+01 6.9886001586914062e+01 -4.8709899902343750e+01 -9.5080596923828125e+01 7.0306900024414062e+01 -5.1493701934814453e+01 -9.5251396179199219e+01 7.0306900024414062e+01 -5.1524200439453125e+01 -9.5083099365234375e+01 6.9886001586914062e+01 -5.1479202270507812e+01 -9.5243095397949219e+01 7.0017501831054688e+01 -5.1512401580810547e+01 -9.5239196777343750e+01 6.9886001586914062e+01 -5.1506900787353516e+01 -9.4906997680664062e+01 7.0306900024414062e+01 -5.1468799591064453e+01 -9.4926399230957031e+01 6.9886001586914062e+01 -5.1456398010253906e+01 -9.4732299804687500e+01 7.0306900024414062e+01 -5.1452098846435547e+01 -9.4769203186035156e+01 6.9886001586914062e+01 -5.1440200805664062e+01 -9.4556800842285156e+01 7.0306900024414062e+01 -5.1443599700927734e+01 -9.4611602783203125e+01 6.9886001586914062e+01 -5.1430603027343750e+01 -9.4464302062988281e+01 7.0306900024414062e+01 -5.1442398071289062e+01 -9.4464401245117188e+01 6.9886001586914062e+01 -5.1427700042724609e+01 -9.4363800048828125e+01 7.0306900024414062e+01 -5.1442298889160156e+01 -9.4397705078125000e+01 6.9886001586914062e+01 -5.1427402496337891e+01 -9.3449699401855469e+01 7.0306900024414062e+01 -5.1573600769042969e+01 -9.3445602416992188e+01 6.9886001586914062e+01 -5.1559501647949219e+01 -9.3442497253417969e+01 7.0306900024414062e+01 -5.1574600219726562e+01 -9.3438499450683594e+01 6.9886001586914062e+01 -5.1560497283935547e+01 -9.2600006103515625e+01 7.0306900024414062e+01 -5.1985599517822266e+01 -9.2591400146484375e+01 6.9886001586914062e+01 -5.1973598480224609e+01 -9.1601295471191406e+01 6.9886001586914062e+01 -5.3628002166748047e+01 -9.1615806579589844e+01 7.0306900024414062e+01 -5.3630599975585938e+01 -9.1700202941894531e+01 6.9886001586914062e+01 -5.3233501434326172e+01 -9.1735694885253906e+01 7.0306900024414062e+01 -5.3172901153564453e+01 -9.1968093872070312e+01 6.9886100769042969e+01 -5.2683101654052734e+01 -9.1983001708984375e+01 7.0306900024414062e+01 -5.2692398071289062e+01 -9.2045097351074219e+01 6.9886100769042969e+01 -5.2524997711181641e+01 -9.2084495544433594e+01 7.0306900024414062e+01 -5.2495098114013672e+01 -9.2497299194335938e+01 6.9886001586914062e+01 -5.2068599700927734e+01 -9.2505401611328125e+01 7.0306900024414062e+01 -5.2079101562500000e+01 -9.1380096435546875e+01 7.0306900024414062e+01 -5.5015399932861328e+01 -9.1362701416015625e+01 6.9886001586914062e+01 -5.5030101776123047e+01 -9.3966003417968750e+01 7.0306900024414062e+01 -5.5015399932861328e+01 -9.3948501586914062e+01 6.9886001586914062e+01 -5.5030101776123047e+01 -9.4359802246093750e+01 7.0306900024414062e+01 -5.5483898162841797e+01 -9.4342300415039062e+01 6.9886001586914062e+01 -5.5498600006103516e+01 -9.3959602355957031e+01 7.0306900024414062e+01 -5.7776397705078125e+01 -9.3947296142578125e+01 6.9886001586914062e+01 -5.7761798858642578e+01 -9.3565795898437500e+01 7.0306900024414062e+01 -5.8107498168945312e+01 -9.3553497314453125e+01 6.9886001586914062e+01 -5.8092800140380859e+01 -9.0855003356933594e+01 7.0306900024414062e+01 -5.8107498168945312e+01 -9.0842597961425781e+01 6.9886001586914062e+01 -5.8092800140380859e+01 -8.8700599670410156e+01 7.0306900024414062e+01 -7.0520103454589844e+01 -8.8688201904296875e+01 6.9886001586914062e+01 -7.0505401611328125e+01 -8.8306800842285156e+01 7.0306900024414062e+01 -7.0851493835449219e+01 -8.8294403076171875e+01 6.9886001586914062e+01 -7.0836799621582031e+01 -8.4971702575683594e+01 7.0306900024414062e+01 -7.0851493835449219e+01 -8.4989196777343750e+01 6.9886001586914062e+01 -7.0836799621582031e+01 -8.4577903747558594e+01 7.0306900024414062e+01 -7.0383399963378906e+01 -8.4595298767089844e+01 6.9886001586914062e+01 -7.0368698120117188e+01 -8.6708595275878906e+01 7.0306900024414062e+01 -5.8107498168945312e+01 -8.6726005554199219e+01 6.9886001586914062e+01 -5.8092800140380859e+01 -8.4899002075195312e+01 7.0306900024414062e+01 -5.8107498168945312e+01 -8.4916503906250000e+01 6.9886001586914062e+01 -5.8092800140380859e+01 -8.4505203247070312e+01 7.0306900024414062e+01 -5.7638999938964844e+01 -8.4522705078125000e+01 6.9886001586914062e+01 -5.7624298095703125e+01 -8.4905700683593750e+01 7.0306900024414062e+01 -5.5344200134277344e+01 -8.4917999267578125e+01 6.9886001586914062e+01 -5.5358901977539062e+01 -8.5296897888183594e+01 7.0306900024414062e+01 -5.5013198852539062e+01 -8.5309196472167969e+01 6.9886001586914062e+01 -5.5027801513671875e+01 -8.7248603820800781e+01 7.0306900024414062e+01 -5.5000701904296875e+01 -8.7261497497558594e+01 6.9886001586914062e+01 -5.5015300750732422e+01 -8.7425003051757812e+01 7.0306900024414062e+01 -5.3632698059082031e+01 -8.7439598083496094e+01 6.9886001586914062e+01 -5.3634498596191406e+01 -8.8118598937988281e+01 6.9886001586914062e+01 -5.1275600433349609e+01 -8.8105499267578125e+01 7.0306900024414062e+01 -5.1269100189208984e+01 -8.7849197387695312e+01 6.9886001586914062e+01 -5.1900901794433594e+01 -8.7854995727539062e+01 7.0306900024414062e+01 -5.1843299865722656e+01 -8.7645797729492188e+01 6.9886001586914062e+01 -5.2546401977539062e+01 -8.7660903930664062e+01 7.0306900024414062e+01 -5.2435001373291016e+01 -8.9454002380371094e+01 6.9886001586914062e+01 -4.9509700775146484e+01 -8.9444198608398438e+01 7.0306900024414062e+01 -4.9498600006103516e+01 -8.8962196350097656e+01 6.9886001586914062e+01 -5.0004096984863281e+01 -8.8743400573730469e+01 7.0306900024414062e+01 -5.0246498107910156e+01 -8.8501495361328125e+01 6.9886001586914062e+01 -5.0609100341796875e+01 -8.8399299621582031e+01 7.0306900024414062e+01 -5.0741199493408203e+01 -9.1365905761718750e+01 6.9886001586914062e+01 -4.8407901763916016e+01 -9.1361099243164062e+01 7.0306900024414062e+01 -4.8393997192382812e+01 -9.0726699829101562e+01 6.9886001586914062e+01 -4.8670097351074219e+01 -9.0426994323730469e+01 7.0306900024414062e+01 -4.8807598114013672e+01 -9.0068199157714844e+01 6.9886001586914062e+01 -4.9040702819824219e+01 -8.9916297912597656e+01 7.0306900024414062e+01 -4.9126098632812500e+01 -9.1937698364257812e+01 7.0306900024414062e+01 -4.8225498199462891e+01 -9.2023300170898438e+01 6.9886001586914062e+01 -4.8220600128173828e+01 -9.3113197326660156e+01 7.0306900024414062e+01 -4.8048000335693359e+01 -9.3804595947265625e+01 6.9886001586914062e+01 -4.8042900085449219e+01 -9.3804901123046875e+01 7.0306900024414062e+01 -4.8028202056884766e+01 -9.3362800598144531e+01 6.9886001586914062e+01 -4.8049098968505859e+01 -9.2691696166992188e+01 6.9886001586914062e+01 -4.8103702545166016e+01 -9.4618606567382812e+01 6.9886001586914062e+01 -4.8101997375488281e+01 -9.4648895263671875e+01 7.0306900024414062e+01 -4.8090801239013672e+01 -9.4306404113769531e+01 6.9886001586914062e+01 -4.8070198059082031e+01 -9.4364601135253906e+01 7.0306900024414062e+01 -4.8060497283935547e+01 -9.3993499755859375e+01 6.9886001586914062e+01 -4.8049800872802734e+01 -9.4079498291015625e+01 7.0306900024414062e+01 -4.8039600372314453e+01 -8.7613296508789062e+01 6.9500000000000000e+01 -5.5412799835205078e+01 -8.5311798095703125e+01 6.9500000000000000e+01 -5.5427497863769531e+01 -8.4916503906250000e+01 6.9500000000000000e+01 -5.7693000793457031e+01 -8.7201103210449219e+01 6.9500000000000000e+01 -5.7693000793457031e+01 -9.1319297790527344e+01 6.9500000000000000e+01 -5.3112201690673828e+01 -8.7836105346679688e+01 6.9500000000000000e+01 -5.3685600280761719e+01 -9.1496902465820312e+01 6.9500000000000000e+01 -4.8785602569580078e+01 -9.0899307250976562e+01 6.9500000000000000e+01 -4.9030700683593750e+01 -9.2358406066894531e+01 6.9500000000000000e+01 -5.1648799896240234e+01 -8.8294403076171875e+01 6.9500000000000000e+01 -7.0437103271484375e+01 -9.0506301879882812e+01 6.9500000000000000e+01 -5.7693000793457031e+01 -8.4989196777343750e+01 6.9500000000000000e+01 -7.0437103271484375e+01 -9.3553497314453125e+01 6.9500000000000000e+01 -5.7693000793457031e+01 -9.3948501586914062e+01 6.9500000000000000e+01 -5.5429801940917969e+01 -9.0889198303222656e+01 6.9500000000000000e+01 -5.5429801940917969e+01 -9.1207801818847656e+01 6.9500000000000000e+01 -5.3557300567626953e+01 -8.9718696594238281e+01 6.9500000000000000e+01 -4.9809200286865234e+01 -9.1717697143554688e+01 6.9500000000000000e+01 -5.2295600891113281e+01 -9.0287498474121094e+01 6.9500000000000000e+01 -4.9374900817871094e+01 -9.3325103759765625e+01 6.9500000000000000e+01 -5.1177200317382812e+01 -9.3974594116210938e+01 6.9500000000000000e+01 -4.8449100494384766e+01 -9.3797294616699219e+01 6.9500000000000000e+01 -4.8442600250244141e+01 -8.8476699829101562e+01 6.9500000000000000e+01 -5.1453399658203125e+01 -8.8224098205566406e+01 6.9500000000000000e+01 -5.2039600372314453e+01 -9.3378601074218750e+01 6.9500000000000000e+01 -4.8448497772216797e+01 -9.2741600036621094e+01 6.9500000000000000e+01 -4.8500400543212891e+01 -9.2111801147460938e+01 6.9500000000000000e+01 -4.8610500335693359e+01 -8.9263099670410156e+01 6.9500000000000000e+01 -5.0267200469970703e+01 -8.8834899902343750e+01 6.9500000000000000e+01 -5.0829700469970703e+01 -8.8476699829101562e+01 6.9500000000000000e+01 -5.1453300476074219e+01 -8.8032295227050781e+01 6.9500000000000000e+01 -5.2648300170898438e+01 -8.7836402893066406e+01 6.9500000000000000e+01 -5.3682899475097656e+01 -9.4273200988769531e+01 6.9500000000000000e+01 -4.8468601226806641e+01 -9.4396499633789062e+01 6.9500000000000000e+01 -5.1027599334716797e+01 -9.4570899963378906e+01 6.9500000000000000e+01 -4.8498798370361328e+01 -9.4467102050781250e+01 6.9500000000000000e+01 -5.1027999877929688e+01 -9.4867294311523438e+01 6.9500000000000000e+01 -4.8540000915527344e+01 -9.4627403259277344e+01 6.9500000000000000e+01 -5.1031196594238281e+01 -9.4801795959472656e+01 6.9500000000000000e+01 -5.1041801452636719e+01 -9.5153099060058594e+01 6.9500000000000000e+01 -4.8587097167968750e+01 -9.4975700378417969e+01 6.9500000000000000e+01 -5.1059700012207031e+01 -9.5438301086425781e+01 6.9500000000000000e+01 -4.8638000488281250e+01 -9.5148597717285156e+01 6.9500000000000000e+01 -5.1084800720214844e+01 -9.5585006713867188e+01 6.9500000000000000e+01 -4.8665699005126953e+01 -9.5149299621582031e+01 6.9500000000000000e+01 -5.1084899902343750e+01 -9.5312995910644531e+01 6.9500000000000000e+01 -5.1114002227783203e+01 -9.6977394104003906e+01 6.9886001586914062e+01 -5.7140102386474609e+01 -9.6966697692871094e+01 7.0306900024414062e+01 -5.7130096435546875e+01 -9.6151397705078125e+01 6.9886001586914062e+01 -5.8171100616455078e+01 -9.6337493896484375e+01 7.0306900024414062e+01 -5.7884498596191406e+01 -9.5675201416015625e+01 6.9886001586914062e+01 -5.8950302124023438e+01 -9.5802597045898438e+01 7.0306900024414062e+01 -5.8694702148437500e+01 -9.5275001525878906e+01 6.9886001586914062e+01 -5.9777999877929688e+01 -9.5261497497558594e+01 7.0306900024414062e+01 -5.9772201538085938e+01 -9.9482795715332031e+01 6.9886001586914062e+01 -5.5350399017333984e+01 -9.9476699829101562e+01 7.0306900024414062e+01 -5.5337100982666016e+01 -9.8318000793457031e+01 6.9886001586914062e+01 -5.5998600006103516e+01 -9.8630302429199219e+01 7.0306900024414062e+01 -5.5782299041748047e+01 -9.8131996154785156e+01 7.0306900024414062e+01 -5.6125499725341797e+01 -9.7854896545410156e+01 7.0306900024414062e+01 -5.6316402435302734e+01 -9.7619400024414062e+01 6.9886001586914062e+01 -5.6527500152587891e+01 -9.8138900756835938e+01 6.9886001586914062e+01 -5.6134201049804688e+01 -1.0051999664306641e+02 7.0306900024414062e+01 -5.4964900970458984e+01 -1.0052899932861328e+02 6.9886001586914062e+01 -5.4977699279785156e+01 -1.0101900482177734e+02 7.0306900024414062e+01 -5.4872402191162109e+01 -1.0102199554443359e+02 6.9886001586914062e+01 -5.4887500762939453e+01 -1.0158599853515625e+02 7.0306900024414062e+01 -5.4767398834228516e+01 -1.0161600494384766e+02 6.9886001586914062e+01 -5.4778900146484375e+01 -1.0269699859619141e+02 7.0306900024414062e+01 -5.4722499847412109e+01 -1.0269599914550781e+02 6.9886001586914062e+01 -5.4737300872802734e+01 -1.0552799987792969e+02 6.9886001586914062e+01 -5.5415599822998047e+01 -1.0553500366210938e+02 7.0306900024414062e+01 -5.5402801513671875e+01 -1.0487899780273438e+02 6.9886001586914062e+01 -5.5116798400878906e+01 -1.0474099731445312e+02 7.0306900024414062e+01 -5.5051799774169922e+01 -1.0422399902343750e+02 6.9886001586914062e+01 -5.4937400817871094e+01 -1.0422799682617188e+02 7.0306900024414062e+01 -5.4919498443603516e+01 -1.0392300415039062e+02 6.9886001586914062e+01 -5.4855201721191406e+01 -1.0391600036621094e+02 7.0306900024414062e+01 -5.4838798522949219e+01 -1.0295599365234375e+02 6.9886001586914062e+01 -5.4745700836181641e+01 -1.0629700469970703e+02 7.0306900024414062e+01 -5.5910503387451172e+01 -1.0647399902343750e+02 6.9886001586914062e+01 -5.6076999664306641e+01 -1.0657700347900391e+02 7.0306900024414062e+01 -5.6171802520751953e+01 -1.0657299804687500e+02 6.9886001586914062e+01 -5.6176200866699219e+01 -1.0689400482177734e+02 7.0306900024414062e+01 -5.6466899871826172e+01 -1.0697200012207031e+02 6.9886001586914062e+01 -5.6575500488281250e+01 -1.0740800476074219e+02 7.0306900024414062e+01 -5.7129100799560547e+01 -1.0739500427246094e+02 6.9886001586914062e+01 -5.7137199401855469e+01 -1.0788999938964844e+02 7.0306900024414062e+01 -5.8024898529052734e+01 -1.0800699615478516e+02 6.9886001586914062e+01 -5.8353199005126953e+01 -1.0834400177001953e+02 6.9886001586914062e+01 -5.9604900360107422e+01 -1.0835900115966797e+02 7.0306900024414062e+01 -5.9602302551269531e+01 -1.0773699951171875e+02 6.9886001586914062e+01 -5.7732997894287109e+01 -1.0816899871826172e+02 7.0306900024414062e+01 -5.8792800903320312e+01 -1.0841799926757812e+02 6.9886001586914062e+01 -6.2505798339843750e+01 -1.0843199920654297e+02 7.0306900024414062e+01 -6.2507801055908203e+01 -1.0844799804687500e+02 6.9886001586914062e+01 -6.2212299346923828e+01 -1.0847900390625000e+02 7.0306900024414062e+01 -6.2002899169921875e+01 -1.0848300170898438e+02 6.9886001586914062e+01 -6.0907798767089844e+01 -1.0849300384521484e+02 7.0306900024414062e+01 -6.0798099517822266e+01 -1.0820700073242188e+02 7.0306900024414062e+01 -6.3965095520019531e+01 -1.0819400024414062e+02 6.9886001586914062e+01 -6.3950397491455078e+01 -1.0781200408935547e+02 7.0306900024414062e+01 -6.4303802490234375e+01 -1.0779900360107422e+02 6.9886001586914062e+01 -6.4289100646972656e+01 -9.8456802368164062e+01 7.0306900024414062e+01 -6.4303802490234375e+01 -9.8443000793457031e+01 6.9886001586914062e+01 -6.4289100646972656e+01 -9.8447097778320312e+01 7.0306900024414062e+01 -6.4637695312500000e+01 -9.8435798645019531e+01 6.9886001586914062e+01 -6.4425399780273438e+01 -9.8503593444824219e+01 7.0306900024414062e+01 -6.5302902221679688e+01 -9.8453300476074219e+01 6.9886001586914062e+01 -6.5037803649902344e+01 -9.8573898315429688e+01 7.0306900024414062e+01 -6.5630302429199219e+01 -9.8559700012207031e+01 6.9886001586914062e+01 -6.5633995056152344e+01 -9.8677497863769531e+01 7.0306900024414062e+01 -6.5957595825195312e+01 -9.8767105102539062e+01 6.9886001586914062e+01 -6.6205596923828125e+01 -9.8817398071289062e+01 7.0306900024414062e+01 -6.6273895263671875e+01 -9.8911796569824219e+01 6.9886001586914062e+01 -6.6471199035644531e+01 -9.9095001220703125e+01 7.0306900024414062e+01 -6.6709693908691406e+01 -9.9083404541015625e+01 6.9886001586914062e+01 -6.6718696594238281e+01 -9.9331604003906250e+01 7.0306900024414062e+01 -6.6972892761230469e+01 -9.9491294860839844e+01 6.9886001586914062e+01 -6.7132797241210938e+01 -9.9602897644042969e+01 7.0306900024414062e+01 -6.7199501037597656e+01 -9.9738395690917969e+01 6.9886001586914062e+01 -6.7308593750000000e+01 -1.0001300048828125e+02 7.0306900024414062e+01 -6.7444000244140625e+01 -1.0000599670410156e+02 6.9886001586914062e+01 -6.7457305908203125e+01 -1.0033900451660156e+02 7.0306900024414062e+01 -6.7575607299804688e+01 -1.0042200469970703e+02 6.9886001586914062e+01 -6.7616798400878906e+01 -1.0067500305175781e+02 7.0306900024414062e+01 -6.7663299560546875e+01 -1.0086700439453125e+02 6.9886001586914062e+01 -6.7710601806640625e+01 -1.0131500244140625e+02 7.0306900024414062e+01 -6.7730201721191406e+01 -1.0131900024414062e+02 6.9886001586914062e+01 -6.7745002746582031e+01 -1.0131900024414062e+02 7.0306900024414062e+01 -6.7730300903320312e+01 -1.0159300231933594e+02 7.0306900024414062e+01 -6.7733497619628906e+01 -1.0176399993896484e+02 6.9886001586914062e+01 -6.7742897033691406e+01 -1.0224700164794922e+02 7.0306900024414062e+01 -6.7680999755859375e+01 -1.0236599731445312e+02 6.9886001586914062e+01 -6.7676498413085938e+01 -1.0288999938964844e+02 7.0306900024414062e+01 -6.7536399841308594e+01 -1.0295200347900391e+02 6.9886001586914062e+01 -6.7532600402832031e+01 -1.0350499725341797e+02 7.0306900024414062e+01 -6.7297302246093750e+01 -1.0351199340820312e+02 6.9886001586914062e+01 -6.7310600280761719e+01 -1.0499499511718750e+02 7.0017303466796875e+01 -6.6303497314453125e+01 -1.0499600219726562e+02 7.0306900024414062e+01 -6.6289199829101562e+01 -1.0454700469970703e+02 7.0306900024414062e+01 -6.6662300109863281e+01 -1.0406999969482422e+02 7.0306900024414062e+01 -6.6989601135253906e+01 -1.0403999328613281e+02 6.9886001586914062e+01 -6.7024604797363281e+01 -1.0453900146484375e+02 6.9886001586914062e+01 -6.6687194824218750e+01 -1.0499499511718750e+02 6.9886001586914062e+01 -6.6310005187988281e+01 -1.0557600402832031e+02 6.9886001586914062e+01 -6.6357398986816406e+01 -1.0696499633789062e+02 6.9886001586914062e+01 -6.8104293823242188e+01 -1.0557699584960938e+02 7.0017303466796875e+01 -6.6350799560546875e+01 -1.0697100067138672e+02 7.0007698059082031e+01 -6.8104293823242188e+01 -1.0557799530029297e+02 7.0306900024414062e+01 -6.6335998535156250e+01 -1.0698399353027344e+02 7.0306900024414062e+01 -6.8104103088378906e+01 -1.0697600555419922e+02 7.0007698059082031e+01 -6.8594299316406250e+01 -1.0697100067138672e+02 6.9886001586914062e+01 -6.8594497680664062e+01 -1.0694800567626953e+02 6.9886001586914062e+01 -6.8625000000000000e+01 -1.0595800018310547e+02 6.9886001586914062e+01 -6.9610702514648438e+01 -1.0596600341796875e+02 7.0306900024414062e+01 -6.9622299194335938e+01 -1.0648500061035156e+02 6.9886001586914062e+01 -6.9150703430175781e+01 -1.0660099792480469e+02 7.0306900024414062e+01 -6.9052803039550781e+01 -1.0699000549316406e+02 7.0306900024414062e+01 -6.8593597412109375e+01 -1.0442399597167969e+02 6.9886001586914062e+01 -7.0494300842285156e+01 -1.0443000030517578e+02 7.0306900024414062e+01 -7.0507896423339844e+01 -1.0503400421142578e+02 6.9886001586914062e+01 -7.0205001831054688e+01 -1.0496500396728516e+02 7.0306900024414062e+01 -7.0258102416992188e+01 -1.0550600433349609e+02 6.9886001586914062e+01 -6.9927093505859375e+01 -1.0547299957275391e+02 7.0306900024414062e+01 -6.9965805053710938e+01 -1.0270800018310547e+02 6.9886001586914062e+01 -7.0990798950195312e+01 -1.0270999908447266e+02 7.0306900024414062e+01 -7.1005302429199219e+01 -1.0335700225830078e+02 6.9886001586914062e+01 -7.0851699829101562e+01 -1.0329599761962891e+02 7.0306900024414062e+01 -7.0882400512695312e+01 -1.0389599609375000e+02 6.9886001586914062e+01 -7.0692398071289062e+01 -1.0386700439453125e+02 7.0306900024414062e+01 -7.0717399597167969e+01 -1.0095400238037109e+02 6.9886001586914062e+01 -7.1129699707031250e+01 -1.0095400238037109e+02 7.0306900024414062e+01 -7.1144294738769531e+01 -1.0161100006103516e+02 6.9886001586914062e+01 -7.1116600036621094e+01 -1.0153599548339844e+02 7.0306900024414062e+01 -7.1135200500488281e+01 -1.0216099548339844e+02 6.9886001586914062e+01 -7.1069503784179688e+01 -1.0211399841308594e+02 7.0306900024414062e+01 -7.1089500427246094e+01 -9.8040199279785156e+01 6.9886001586914062e+01 -7.0501899719238281e+01 -9.8034004211425781e+01 7.0306900024414062e+01 -7.0515197753906250e+01 -9.9033401489257812e+01 6.9886001586914062e+01 -7.0866500854492188e+01 -9.8878005981445312e+01 7.0306900024414062e+01 -7.0837104797363281e+01 -9.9401397705078125e+01 6.9886001586914062e+01 -7.0940803527832031e+01 -9.9398200988769531e+01 7.0306900024414062e+01 -7.0957199096679688e+01 -9.9981796264648438e+01 6.9886001586914062e+01 -7.1057800292968750e+01 -9.9745201110839844e+01 7.0306900024414062e+01 -7.1037300109863281e+01 -9.7083801269531250e+01 7.0306900024414062e+01 -6.9972595214843750e+01 -9.6900405883789062e+01 6.9886001586914062e+01 -6.9822998046875000e+01 -9.6858802795410156e+01 7.0306900024414062e+01 -6.9794898986816406e+01 -9.6861900329589844e+01 6.9886001586914062e+01 -6.9790695190429688e+01 -9.6455795288085938e+01 7.0306900024414062e+01 -6.9476600646972656e+01 -9.6373901367187500e+01 6.9886001586914062e+01 -6.9381103515625000e+01 -9.5890205383300781e+01 7.0306900024414062e+01 -6.8890899658203125e+01 -9.5901397705078125e+01 6.9886001586914062e+01 -6.8881401062011719e+01 -9.4645904541015625e+01 6.9886001586914062e+01 -6.6479896545410156e+01 -9.4631797790527344e+01 7.0306900024414062e+01 -6.6483901977539062e+01 -9.5044296264648438e+01 6.9886001586914062e+01 -6.7544197082519531e+01 -9.4920097351074219e+01 7.0306900024414062e+01 -6.7303100585937500e+01 -9.5425300598144531e+01 6.9886001586914062e+01 -6.8234298706054688e+01 -9.5303100585937500e+01 7.0306900024414062e+01 -6.8063598632812500e+01 -9.4397598266601562e+01 6.9886001586914062e+01 -6.3521602630615234e+01 -9.4383003234863281e+01 7.0306900024414062e+01 -6.3520198822021484e+01 -9.4364097595214844e+01 6.9886001586914062e+01 -6.4037498474121094e+01 -9.4343605041503906e+01 7.0306900024414062e+01 -6.4417602539062500e+01 -9.4407699584960938e+01 6.9886001586914062e+01 -6.5265701293945312e+01 -9.4397003173828125e+01 7.0306900024414062e+01 -6.5302001953125000e+01 -9.4441505432128906e+01 7.0306900024414062e+01 -6.2934196472167969e+01 -9.4456100463867188e+01 6.9886001586914062e+01 -6.2935703277587891e+01 -9.4837799072265625e+01 6.9886001586914062e+01 -6.0996902465820312e+01 -9.4898200988769531e+01 7.0306900024414062e+01 -6.0748699188232422e+01 -9.4604202270507812e+01 6.9886001586914062e+01 -6.1954402923583984e+01 -9.4632202148437500e+01 7.0306900024414062e+01 -6.1746200561523438e+01 -1.0480699920654297e+02 6.9500000000000000e+01 -6.1860599517822266e+01 -9.8146202087402344e+01 6.9500000000000000e+01 -6.1860599517822266e+01 -9.8067497253417969e+01 6.9500000000000000e+01 -6.3889301300048828e+01 -1.0368399810791016e+02 6.9500000000000000e+01 -6.7671203613281250e+01 -1.0307299804687500e+02 6.9500000000000000e+01 -6.7913398742675781e+01 -1.0427100372314453e+02 6.9500000000000000e+01 -7.0125198364257812e+01 -9.5762298583984375e+01 6.9500000000000000e+01 -6.8019195556640625e+01 -9.8571395874023438e+01 6.9500000000000000e+01 -6.6680793762207031e+01 -9.5405601501464844e+01 6.9500000000000000e+01 -6.7373199462890625e+01 -9.8406501770019531e+01 6.9500000000000000e+01 -6.6378105163574219e+01 -9.5030303955078125e+01 6.9500000000000000e+01 -6.6370002746582031e+01 -9.8172996520996094e+01 6.9500000000000000e+01 -6.5735603332519531e+01 -9.4805000305175781e+01 6.9500000000000000e+01 -6.5221305847167969e+01 -9.8055496215820312e+01 6.9500000000000000e+01 -6.5077606201171875e+01 -9.8036399841308594e+01 6.9500000000000000e+01 -6.4409896850585938e+01 -1.0095400238037109e+02 6.9500000000000000e+01 -5.7998199462890625e+01 -1.0095400238037109e+02 6.9500000000000000e+01 -5.7998100280761719e+01 -9.9648200988769531e+01 6.9500000000000000e+01 -5.5714397430419922e+01 -1.0501100158691406e+02 6.9500000000000000e+01 -5.9878200531005859e+01 -1.0795100402832031e+02 6.9500000000000000e+01 -5.9674999237060547e+01 -1.0490100097656250e+02 6.9500000000000000e+01 -5.9365997314453125e+01 -1.0763200378417969e+02 6.9500000000000000e+01 -5.8492897033691406e+01 -1.0478199768066406e+02 6.9500000000000000e+01 -5.9063098907470703e+01 -1.0738000488281250e+02 6.9500000000000000e+01 -5.7911899566650391e+01 -1.0462500000000000e+02 6.9500000000000000e+01 -5.8778697967529297e+01 -1.0484600067138672e+02 6.9500000000000000e+01 -6.9852600097656250e+01 -1.0529000091552734e+02 6.9500000000000000e+01 -6.9591003417968750e+01 -1.0424800109863281e+02 6.9500000000000000e+01 -6.7366401672363281e+01 -1.0243499755859375e+02 6.9500000000000000e+01 -6.8070205688476562e+01 -1.0325700378417969e+02 6.9500000000000000e+01 -7.0464607238769531e+01 -1.0376899719238281e+02 6.9500000000000000e+01 -7.0313293457031250e+01 -1.0178299713134766e+02 6.9500000000000000e+01 -6.8142196655273438e+01 -1.0263999938964844e+02 6.9500000000000000e+01 -7.0596801757812500e+01 -9.6206901550292969e+01 6.9500000000000000e+01 -6.8623703002929688e+01 -9.6207099914550781e+01 6.9500000000000000e+01 -6.8623802185058594e+01 -9.8767799377441406e+01 6.9500000000000000e+01 -6.6964096069335938e+01 -9.6648094177246094e+01 6.9500000000000000e+01 -6.9090095520019531e+01 -9.9240898132324219e+01 6.9500000000000000e+01 -6.7444503784179688e+01 -9.7139595031738281e+01 6.9500000000000000e+01 -6.9502601623535156e+01 -9.9525802612304688e+01 6.9500000000000000e+01 -6.7647102355957031e+01 -9.8209800720214844e+01 6.9500000000000000e+01 -7.0139900207519531e+01 -9.9831405639648438e+01 6.9500000000000000e+01 -6.7816596984863281e+01 -1.0031100463867188e+02 6.9500000000000000e+01 -6.8000694274902344e+01 -9.9139495849609375e+01 6.9500000000000000e+01 -7.0481101989746094e+01 -1.0081300354003906e+02 6.9500000000000000e+01 -6.8106597900390625e+01 -1.0003499603271484e+02 6.9500000000000000e+01 -7.0661705017089844e+01 -1.0130800628662109e+02 6.9500000000000000e+01 -6.8144599914550781e+01 -1.0501100158691406e+02 6.9500000000000000e+01 -5.9878299713134766e+01 -1.0503800201416016e+02 6.9500000000000000e+01 -6.0213001251220703e+01 -1.0808399963378906e+02 6.9500000000000000e+01 -6.0922702789306641e+01 -1.0665200042724609e+02 6.9500000000000000e+01 -6.8353103637695312e+01 -1.0526399993896484e+02 6.9500000000000000e+01 -6.6606201171875000e+01 -1.0663100433349609e+02 6.9500000000000000e+01 -6.8381195068359375e+01 -1.0477899932861328e+02 6.9500000000000000e+01 -6.7006797790527344e+01 -1.0571499633789062e+02 6.9500000000000000e+01 -6.9292800903320312e+01 -1.0571499633789062e+02 6.9500000000000000e+01 -6.9292701721191406e+01 -1.0620299530029297e+02 6.9500000000000000e+01 -6.8867401123046875e+01 -1.0063199615478516e+02 6.9500000000000000e+01 -5.5364097595214844e+01 -1.0141899871826172e+02 6.9500000000000000e+01 -5.7822101593017578e+01 -1.0165800476074219e+02 6.9500000000000000e+01 -5.5176498413085938e+01 -1.0190599822998047e+02 6.9500000000000000e+01 -5.7722900390625000e+01 -1.0268799591064453e+02 6.9500000000000000e+01 -5.5136901855468750e+01 -1.0533399963378906e+02 6.9500000000000000e+01 -5.5764999389648438e+01 -1.0473900604248047e+02 6.9500000000000000e+01 -5.5491203308105469e+01 -1.0376300048828125e+02 6.9500000000000000e+01 -5.8004699707031250e+01 -1.0096099853515625e+02 6.9500000000000000e+01 -7.0730003356933594e+01 -1.0158800506591797e+02 6.9500000000000000e+01 -7.0717498779296875e+01 -1.0211499786376953e+02 6.9500000000000000e+01 -7.0672302246093750e+01 -9.8206199645996094e+01 6.9500000000000000e+01 -6.1712100982666016e+01 -9.8439300537109375e+01 6.9500000000000000e+01 -6.1138099670410156e+01 -9.5642501831054688e+01 6.9500000000000000e+01 -5.9935100555419922e+01 -1.0706099700927734e+02 6.9500000000000000e+01 -5.7355800628662109e+01 -1.0666999816894531e+02 6.9500000000000000e+01 -5.6837600708007812e+01 -1.0428500366210938e+02 6.9500000000000000e+01 -5.8372596740722656e+01 -1.0621099853515625e+02 6.9500000000000000e+01 -5.6378200531005859e+01 -1.0403700256347656e+02 6.9500000000000000e+01 -5.8171001434326172e+01 -1.0376399993896484e+02 6.9500000000000000e+01 -5.8004901885986328e+01 -9.4763504028320312e+01 6.9500000000000000e+01 -6.4052200317382812e+01 -9.4795501708984375e+01 6.9500000000000000e+01 -6.3559898376464844e+01 -9.5642593383789062e+01 6.9500000000000000e+01 -5.9935001373291016e+01 -9.8691902160644531e+01 6.9500000000000000e+01 -6.0572399139404297e+01 -9.6026298522949219e+01 6.9500000000000000e+01 -5.9141399383544922e+01 -9.8970001220703125e+01 6.9500000000000000e+01 -6.0018798828125000e+01 -9.6481498718261719e+01 6.9500000000000000e+01 -5.8396598815917969e+01 -9.8970001220703125e+01 6.9500000000000000e+01 -6.0018699645996094e+01 -9.7269401550292969e+01 6.9500000000000000e+01 -5.7413200378417969e+01 -9.9344093322753906e+01 6.9500000000000000e+01 -5.9408500671386719e+01 -9.9563705444335938e+01 6.9500000000000000e+01 -5.9118801116943359e+01 -9.7878395080566406e+01 6.9500000000000000e+01 -5.6832000732421875e+01 -9.9804000854492188e+01 6.9500000000000000e+01 -5.8844001770019531e+01 -9.8540901184082031e+01 6.9500000000000000e+01 -5.6330497741699219e+01 -1.0033000183105469e+02 6.9500000000000000e+01 -5.8374900817871094e+01 -1.0063099670410156e+02 6.9500000000000000e+01 -5.8172599792480469e+01 -1.0240200042724609e+02 6.9500000000000000e+01 -5.7692298889160156e+01 -1.0249099731445312e+02 6.9500000000000000e+01 -5.7693199157714844e+01 -1.0293699645996094e+02 6.9500000000000000e+01 -5.5145000457763672e+01 -1.0271500396728516e+02 6.9500000000000000e+01 -5.7709197998046875e+01 -1.0384999847412109e+02 6.9500000000000000e+01 -5.5248302459716797e+01 -1.0307499694824219e+02 6.9500000000000000e+01 -5.7763999938964844e+01 -1.0342800140380859e+02 6.9500000000000000e+01 -5.7860401153564453e+01 -1.0503599548339844e+02 6.9500000000000000e+01 -6.0548702239990234e+01 -1.0500700378417969e+02 6.9500000000000000e+01 -6.0883201599121094e+01 -1.0805000305175781e+02 6.9500000000000000e+01 -6.2176601409912109e+01 -1.0497000122070312e+02 6.9500000000000000e+01 -6.1125900268554688e+01 -1.0802099609375000e+02 6.9500000000000000e+01 -6.2452301025390625e+01 -1.0779900360107422e+02 6.9500000000000000e+01 -6.3889301300048828e+01 -9.5221397399902344e+01 6.9500000000000000e+01 -6.1109100341796875e+01 -9.4996398925781250e+01 6.9500000000000000e+01 -6.2031501770019531e+01 -9.4853897094726562e+01 6.9500000000000000e+01 -6.2975502014160156e+01 -1.0113400268554688e+02 7.0306900024414062e+01 -5.8371700286865234e+01 -1.0112699890136719e+02 6.9886001586914062e+01 -5.8358402252197266e+01 -1.0083699798583984e+02 7.0306900024414062e+01 -5.8532798767089844e+01 -1.0083799743652344e+02 6.9886001586914062e+01 -5.8514801025390625e+01 -1.0055699920654297e+02 7.0306900024414062e+01 -5.8722400665283203e+01 -1.0056799316406250e+02 6.9886001586914062e+01 -5.8696002960205078e+01 -1.0010600280761719e+02 7.0306900024414062e+01 -5.9127597808837891e+01 -1.0009499359130859e+02 6.9886001586914062e+01 -5.9117500305175781e+01 -1.0247699737548828e+02 7.0306900024414062e+01 -5.8107498168945312e+01 -1.0247799682617188e+02 6.9886001586914062e+01 -5.8092800140380859e+01 -1.0242700195312500e+02 7.0306900024414062e+01 -5.8106800079345703e+01 -1.0240200042724609e+02 6.9886001586914062e+01 -5.8092098236083984e+01 -1.0194300079345703e+02 7.0306900024414062e+01 -5.8136100769042969e+01 -1.0195700073242188e+02 6.9886001586914062e+01 -5.8119499206542969e+01 -1.0146199798583984e+02 7.0306900024414062e+01 -5.8242000579833984e+01 -1.0152899932861328e+02 6.9886001586914062e+01 -5.8206497192382812e+01 -1.0287799835205078e+02 7.0306900024414062e+01 -5.8148700714111328e+01 -1.0267499542236328e+02 6.9886001586914062e+01 -5.8106998443603516e+01 -1.0252600097656250e+02 7.0306900024414062e+01 -5.8110099792480469e+01 -1.0357099914550781e+02 7.0306900024414062e+01 -5.8371799468994141e+01 -1.0357800292968750e+02 6.9886001586914062e+01 -5.8358798980712891e+01 -1.0322900390625000e+02 7.0306900024414062e+01 -5.8231399536132812e+01 -1.0329700469970703e+02 6.9886001586914062e+01 -5.8238201141357422e+01 -1.0299400329589844e+02 6.9886001586914062e+01 -5.8155399322509766e+01 -1.0427700042724609e+02 7.0306900024414062e+01 -5.9004001617431641e+01 -1.0428900146484375e+02 6.9886001586914062e+01 -5.8995998382568359e+01 -1.0407400512695312e+02 7.0306900024414062e+01 -5.8746799468994141e+01 -1.0401200103759766e+02 6.9886001586914062e+01 -5.8664299011230469e+01 -1.0384000396728516e+02 7.0306900024414062e+01 -5.8540000915527344e+01 -1.0380699920654297e+02 6.9886001586914062e+01 -5.8498100280761719e+01 -1.0459999847412109e+02 7.0306900024414062e+01 -5.9929603576660156e+01 -1.0461500549316406e+02 6.9886001586914062e+01 -5.9927799224853516e+01 -1.0454000091552734e+02 7.0306900024414062e+01 -5.9611999511718750e+01 -1.0452000427246094e+02 6.9886001586914062e+01 -5.9487201690673828e+01 -1.0443600463867188e+02 7.0306900024414062e+01 -5.9302700042724609e+01 -1.0441999816894531e+02 6.9886001586914062e+01 -5.9232601165771484e+01 -1.0456400299072266e+02 7.0306900024414062e+01 -6.1045200347900391e+01 -1.0457800292968750e+02 6.9886001586914062e+01 -6.1048000335693359e+01 -1.0458100128173828e+02 7.0306900024414062e+01 -6.0935501098632812e+01 -1.0461000061035156e+02 6.9886001586914062e+01 -6.0833900451660156e+01 -1.0461799621582031e+02 7.0306900024414062e+01 -6.0603202819824219e+01 -1.0463600158691406e+02 6.9886001586914062e+01 -6.0529701232910156e+01 -1.0462500000000000e+02 7.0306900024414062e+01 -6.0267002105712891e+01 -1.0463899993896484e+02 6.9886001586914062e+01 -6.0227100372314453e+01 -1.0447399902343750e+02 7.0306900024414062e+01 -6.1446102142333984e+01 -1.0448600006103516e+02 6.9886001586914062e+01 -6.1460800170898438e+01 -9.8760795593261719e+01 7.0306900024414062e+01 -6.1446102142333984e+01 -9.8738998413085938e+01 6.9886001586914062e+01 -6.1460800170898438e+01 -9.9336196899414062e+01 7.0306900024414062e+01 -6.0212898254394531e+01 -9.9323196411132812e+01 6.9886001586914062e+01 -6.0206001281738281e+01 -9.9058601379394531e+01 7.0306900024414062e+01 -6.0766399383544922e+01 -9.9053100585937500e+01 6.9886001586914062e+01 -6.0743801116943359e+01 -9.8807197570800781e+01 7.0306900024414062e+01 -6.1332798004150391e+01 -9.8808105468750000e+01 6.9886001586914062e+01 -6.1292499542236328e+01 -9.9687797546386719e+01 7.0306900024414062e+01 -5.9640399932861328e+01 -9.9670799255371094e+01 6.9886001586914062e+01 -5.9638999938964844e+01 -9.9873703002929688e+01 6.9886001586914062e+01 -5.9371200561523438e+01 -9.9239295959472656e+01 7.0499893188476562e+01 -6.0851802825927734e+01 -9.9060806274414062e+01 7.0499893188476562e+01 -6.1246200561523438e+01 -1.0431400299072266e+02 7.0499893188476562e+01 -6.1246200561523438e+01 -1.0441799926757812e+02 7.0499893188476562e+01 -6.0589801788330078e+01 -1.0251499938964844e+02 7.0499893188476562e+01 -5.8309600830078125e+01 -1.0438399505615234e+02 7.0499893188476562e+01 -6.0906101226806641e+01 -1.0247100067138672e+02 7.0499893188476562e+01 -5.8307300567626953e+01 -1.0436800384521484e+02 7.0499893188476562e+01 -6.1006301879882812e+01 -1.0025199890136719e+02 7.0499893188476562e+01 -5.9264400482177734e+01 -9.9850807189941406e+01 7.0499893188476562e+01 -5.9755897521972656e+01 -9.9512802124023438e+01 7.0499893188476562e+01 -6.0306499481201172e+01 -1.0094100189208984e+02 7.0499893188476562e+01 -5.8703502655029297e+01 -1.0067700195312500e+02 7.0499893188476562e+01 -5.8882099151611328e+01 -1.0242500305175781e+02 7.0499893188476562e+01 -5.8306701660156250e+01 -1.0196900177001953e+02 7.0499893188476562e+01 -5.8334201812744141e+01 -1.0152199554443359e+02 7.0499893188476562e+01 -5.8432601928710938e+01 -1.0121999359130859e+02 7.0499893188476562e+01 -5.8551799774169922e+01 -1.0392900085449219e+02 7.0499893188476562e+01 -5.8884502410888672e+01 -1.0372100067138672e+02 7.0499893188476562e+01 -5.8700401306152344e+01 -1.0410899353027344e+02 7.0499893188476562e+01 -5.9112701416015625e+01 -1.0425200653076172e+02 7.0499893188476562e+01 -5.9381198883056641e+01 -1.0442499542236328e+02 7.0499893188476562e+01 -6.0271800994873047e+01 -1.0440200042724609e+02 7.0499893188476562e+01 -5.9954402923583984e+01 -1.0284500122070312e+02 7.0499893188476562e+01 -5.8345897674560547e+01 -1.0434700012207031e+02 7.0499893188476562e+01 -5.9661899566650391e+01 -1.0316999816894531e+02 7.0499893188476562e+01 -5.8422100067138672e+01 -1.0347899627685547e+02 7.0499893188476562e+01 -5.8548900604248047e+01 -1.1304399871826172e+02 7.0306900024414062e+01 -5.5015399932861328e+01 -1.1305699920654297e+02 6.9886001586914062e+01 -5.5030101776123047e+01 -1.1366099548339844e+02 7.0306900024414062e+01 -5.1450599670410156e+01 -1.1367300415039062e+02 6.9886001586914062e+01 -5.1465297698974609e+01 -1.1405400085449219e+02 7.0306900024414062e+01 -5.1118999481201172e+01 -1.1406700134277344e+02 6.9886001586914062e+01 -5.1133701324462891e+01 -1.1737299346923828e+02 7.0306900024414062e+01 -5.1118999481201172e+01 -1.1735600280761719e+02 6.9886001586914062e+01 -5.1133701324462891e+01 -1.1776699829101562e+02 7.0306900024414062e+01 -5.1588298797607422e+01 -1.1774900054931641e+02 6.9886001586914062e+01 -5.1603000640869141e+01 -1.1716099548339844e+02 7.0306900024414062e+01 -5.5015399932861328e+01 -1.1714400482177734e+02 6.9886001586914062e+01 -5.5030101776123047e+01 -1.1932199859619141e+02 7.0306900024414062e+01 -5.5015399932861328e+01 -1.1930500030517578e+02 6.9886001586914062e+01 -5.5030101776123047e+01 -1.1971600341796875e+02 7.0306900024414062e+01 -5.5483898162841797e+01 -1.1969900512695312e+02 6.9886001586914062e+01 -5.5498500823974609e+01 -1.1931599426269531e+02 7.0306900024414062e+01 -5.7776397705078125e+01 -1.1930400085449219e+02 6.9886001586914062e+01 -5.7761699676513672e+01 -1.1892200469970703e+02 7.0306900024414062e+01 -5.8107498168945312e+01 -1.1890999603271484e+02 6.9886001586914062e+01 -5.8092800140380859e+01 -1.1662200164794922e+02 7.0306900024414062e+01 -5.8107498168945312e+01 -1.1660900115966797e+02 6.9886001586914062e+01 -5.8092800140380859e+01 -1.1527299499511719e+02 7.0306900024414062e+01 -6.6052803039550781e+01 -1.1525800323486328e+02 6.9886001586914062e+01 -6.6050697326660156e+01 -1.1537799835205078e+02 6.9886001586914062e+01 -6.7206001281738281e+01 -1.1539099884033203e+02 7.0306900024414062e+01 -6.7199203491210938e+01 -1.1528900146484375e+02 6.9886001586914062e+01 -6.6973297119140625e+01 -1.1526799774169922e+02 7.0306999206542969e+01 -6.6782897949218750e+01 -1.1527000427246094e+02 6.9886001586914062e+01 -6.6783500671386719e+01 -1.1526499938964844e+02 7.0306999206542969e+01 -6.6772804260253906e+01 -1.1523199462890625e+02 6.9886001586914062e+01 -6.6411102294921875e+01 -1.1524800109863281e+02 7.0306900024414062e+01 -6.6379707336425781e+01 -1.1525200653076172e+02 6.9886001586914062e+01 -6.6138603210449219e+01 -1.1526600646972656e+02 7.0306900024414062e+01 -6.6140098571777344e+01 -1.1639199829101562e+02 6.9886001586914062e+01 -6.7642303466796875e+01 -1.1639299774169922e+02 7.0306900024414062e+01 -6.7627601623535156e+01 -1.1612000274658203e+02 6.9886001586914062e+01 -6.7619300842285156e+01 -1.1612300109863281e+02 7.0306900024414062e+01 -6.7604804992675781e+01 -1.1574199676513672e+02 6.9886001586914062e+01 -6.7513198852539062e+01 -1.1574600219726562e+02 7.0306900024414062e+01 -6.7503601074218750e+01 -1.1572799682617188e+02 7.0306900024414062e+01 -6.7498695373535156e+01 -1.1569800567626953e+02 6.9886001586914062e+01 -6.7501098632812500e+01 -1.1552000427246094e+02 7.0306900024414062e+01 -6.7365699768066406e+01 -1.1550699615478516e+02 6.9886001586914062e+01 -6.7373794555664062e+01 -1.1551800537109375e+02 7.0306900024414062e+01 -6.7362701416015625e+01 -1.1550600433349609e+02 6.9886001586914062e+01 -6.7373298645019531e+01 -1.1702500152587891e+02 6.9886001586914062e+01 -6.7634902954101562e+01 -1.1702399444580078e+02 7.0306900024414062e+01 -6.7620300292968750e+01 -1.1686199951171875e+02 6.9886001586914062e+01 -6.7649795532226562e+01 -1.1683599853515625e+02 7.0306900024414062e+01 -6.7636497497558594e+01 -1.1669699859619141e+02 6.9886001586914062e+01 -6.7655403137207031e+01 -1.1664800262451172e+02 7.0306900024414062e+01 -6.7640602111816406e+01 -1.1653199768066406e+02 6.9886001586914062e+01 -6.7652000427246094e+01 -1.1646099853515625e+02 7.0306900024414062e+01 -6.7633102416992188e+01 -1.1715900421142578e+02 7.0306900024414062e+01 -6.7604698181152344e+01 -1.1714699554443359e+02 7.0020301818847656e+01 -6.7615997314453125e+01 -1.1714199829101562e+02 6.9886001586914062e+01 -6.7621299743652344e+01 -1.1758500671386719e+02 6.9886001586914062e+01 -6.8054603576660156e+01 -1.1736399841308594e+02 6.9886001586914062e+01 -7.0501701354980469e+01 -1.1759000396728516e+02 7.0020301818847656e+01 -6.8049293518066406e+01 -1.1736799621582031e+02 7.0006202697753906e+01 -7.0504997253417969e+01 -1.1760199737548828e+02 7.0306900024414062e+01 -6.8038002014160156e+01 -1.1737699890136719e+02 7.0306900024414062e+01 -7.0513099670410156e+01 -1.1707899475097656e+02 7.0006202697753906e+01 -7.0853500366210938e+01 -1.1707500457763672e+02 6.9886001586914062e+01 -7.0850204467773438e+01 -1.1686100006103516e+02 6.9886001586914062e+01 -7.0906898498535156e+01 -1.1708900451660156e+02 7.0306900024414062e+01 -7.0861396789550781e+01 -1.1619200134277344e+02 6.9886001586914062e+01 -7.1034797668457031e+01 -1.1619400024414062e+02 7.0306900024414062e+01 -7.1049301147460938e+01 -1.1652899932861328e+02 6.9886001586914062e+01 -7.0979797363281250e+01 -1.1649800109863281e+02 7.0306900024414062e+01 -7.1000503540039062e+01 -1.1679799652099609e+02 7.0306900024414062e+01 -7.0937301635742188e+01 -1.1559400177001953e+02 7.0306900024414062e+01 -7.1105895996093750e+01 -1.1498699951171875e+02 6.9886001586914062e+01 -7.1100303649902344e+01 -1.1498699951171875e+02 7.0306900024414062e+01 -7.1115097045898438e+01 -1.1519400024414062e+02 6.9886001586914062e+01 -7.1102500915527344e+01 -1.1552699279785156e+02 6.9886001586914062e+01 -7.1094604492187500e+01 -1.1586000061035156e+02 6.9886001586914062e+01 -7.1071998596191406e+01 -1.1317200469970703e+02 6.9886001586914062e+01 -7.0743598937988281e+01 -1.1316600036621094e+02 7.0306900024414062e+01 -7.0757003784179688e+01 -1.1377000427246094e+02 6.9886001586914062e+01 -7.0950302124023438e+01 -1.1376000213623047e+02 7.0306900024414062e+01 -7.0962799072265625e+01 -1.1437799835205078e+02 6.9886001586914062e+01 -7.1061607360839844e+01 -1.1437200164794922e+02 7.0306900024414062e+01 -7.1075698852539062e+01 -1.1498200225830078e+02 6.9886001586914062e+01 -7.1100303649902344e+01 -1.1193499755859375e+02 6.9886001586914062e+01 -6.9790603637695312e+01 -1.1192300415039062e+02 7.0306900024414062e+01 -6.9799598693847656e+01 -1.1228199768066406e+02 6.9886001586914062e+01 -7.0167800903320312e+01 -1.1226499938964844e+02 7.0306900024414062e+01 -7.0171997070312500e+01 -1.1267399597167969e+02 6.9886001586914062e+01 -7.0472000122070312e+01 -1.1265299987792969e+02 7.0306900024414062e+01 -7.0476196289062500e+01 -1.1126500701904297e+02 6.9886001586914062e+01 -6.8341201782226562e+01 -1.1125000000000000e+02 7.0306900024414062e+01 -6.8344505310058594e+01 -1.1141200256347656e+02 6.9886001586914062e+01 -6.8836097717285156e+01 -1.1140200042724609e+02 7.0306900024414062e+01 -6.8850006103515625e+01 -1.1162200164794922e+02 6.9886001586914062e+01 -6.9306503295898438e+01 -1.1161299896240234e+02 7.0306900024414062e+01 -6.9319999694824219e+01 -1.1114899444580078e+02 7.0306900024414062e+01 -6.7751800537109375e+01 -1.1115299987792969e+02 6.9886001586914062e+01 -6.7645294189453125e+01 -1.1111400604248047e+02 7.0306900024414062e+01 -6.7148399353027344e+01 -1.1112999725341797e+02 6.9886001586914062e+01 -6.6951797485351562e+01 -1.1113599395751953e+02 7.0306900024414062e+01 -6.6541404724121094e+01 -1.1115599822998047e+02 6.9886001586914062e+01 -6.6481201171875000e+01 -1.1114100646972656e+02 7.0306900024414062e+01 -6.6479301452636719e+01 -1.1250399780273438e+02 7.0306900024414062e+01 -5.8107498168945312e+01 -1.1252199554443359e+02 6.9886001586914062e+01 -5.8092800140380859e+01 -1.1073899841308594e+02 7.0306900024414062e+01 -5.8107498168945312e+01 -1.1075600433349609e+02 6.9886001586914062e+01 -5.8092800140380859e+01 -1.1034500122070312e+02 7.0306900024414062e+01 -5.7638999938964844e+01 -1.1036199951171875e+02 6.9886001586914062e+01 -5.7624298095703125e+01 -1.1074499511718750e+02 7.0306900024414062e+01 -5.5346401214599609e+01 -1.1075799560546875e+02 6.9886001586914062e+01 -5.5361099243164062e+01 -1.1113899993896484e+02 7.0306900024414062e+01 -5.5015399932861328e+01 -1.1115100097656250e+02 6.9886001586914062e+01 -5.5030101776123047e+01 -1.1339299774169922e+02 6.9500000000000000e+01 -5.5429801940917969e+01 -1.1115100097656250e+02 6.9500000000000000e+01 -5.5429801940917969e+01 -1.1075600433349609e+02 6.9500000000000000e+01 -5.7693000793457031e+01 -1.1627099609375000e+02 6.9500000000000000e+01 -5.7693000793457031e+01 -1.1890999603271484e+02 6.9500000000000000e+01 -5.7693000793457031e+01 -1.1930500030517578e+02 6.9500000000000000e+01 -5.5429801940917969e+01 -1.1735600280761719e+02 6.9500000000000000e+01 -5.1533500671386719e+01 -1.1406700134277344e+02 6.9500000000000000e+01 -5.1533500671386719e+01 -1.1666699981689453e+02 6.9500000000000000e+01 -5.5429801940917969e+01 -1.1299200439453125e+02 6.9500000000000000e+01 -5.7693000793457031e+01 -1.1178799438476562e+02 6.9500000000000000e+01 -6.8698402404785156e+01 -1.1197499847412109e+02 6.9500000000000000e+01 -6.9118400573730469e+01 -1.1502300262451172e+02 6.9500000000000000e+01 -6.7390296936035156e+01 -1.1289299774169922e+02 6.9500000000000000e+01 -7.0138198852539062e+01 -1.1523600006103516e+02 6.9500000000000000e+01 -6.7667404174804688e+01 -1.1255200195312500e+02 6.9500000000000000e+01 -6.9872901916503906e+01 -1.1225099945068359e+02 6.9500000000000000e+01 -6.9545906066894531e+01 -1.1333499908447266e+02 6.9500000000000000e+01 -7.0378700256347656e+01 -1.1386899566650391e+02 6.9500000000000000e+01 -7.0562896728515625e+01 -1.1552500152587891e+02 6.9500000000000000e+01 -6.7861305236816406e+01 -1.1442500305175781e+02 6.9500000000000000e+01 -7.0664596557617188e+01 -1.1498799896240234e+02 6.9500000000000000e+01 -7.0700599670410156e+01 -1.1165399932861328e+02 6.9500000000000000e+01 -6.8249801635742188e+01 -1.1490299987792969e+02 6.9500000000000000e+01 -6.7075996398925781e+01 -1.1155100250244141e+02 6.9500000000000000e+01 -6.7608695983886719e+01 -1.1152999877929688e+02 6.9500000000000000e+01 -6.6960197448730469e+01 -1.1483300018310547e+02 6.9500000000000000e+01 -6.6402900695800781e+01 -1.1155300140380859e+02 6.9500000000000000e+01 -6.6530197143554688e+01 -1.1499500274658203e+02 6.9500000000000000e+01 -7.0700698852539062e+01 -1.1519300079345703e+02 6.9500000000000000e+01 -7.0702796936035156e+01 -1.1606399536132812e+02 6.9500000000000000e+01 -6.8015205383300781e+01 -1.1486299896240234e+02 6.9500000000000000e+01 -6.5993797302246094e+01 -1.1486199951171875e+02 6.9500000000000000e+01 -6.6003601074218750e+01 -1.1718700408935547e+02 6.9500000000000000e+01 -6.8018600463867188e+01 -1.1707299804687500e+02 6.9500000000000000e+01 -6.8031898498535156e+01 -1.1696600341796875e+02 6.9500000000000000e+01 -7.0465698242187500e+01 -1.1688700103759766e+02 6.9500000000000000e+01 -6.8048797607421875e+01 -1.1676499938964844e+02 6.9500000000000000e+01 -7.0518905639648438e+01 -1.1670000457763672e+02 6.9500000000000000e+01 -6.8055099487304688e+01 -1.1645399475097656e+02 6.9500000000000000e+01 -7.0587203979492188e+01 -1.1651300048828125e+02 6.9500000000000000e+01 -6.8051300048828125e+01 -1.1613899993896484e+02 6.9500000000000000e+01 -7.0638595581054688e+01 -1.1636599731445312e+02 6.9500000000000000e+01 -6.8041397094726562e+01 -1.1582499694824219e+02 6.9500000000000000e+01 -7.0673896789550781e+01 -1.1550900268554688e+02 6.9500000000000000e+01 -7.0695198059082031e+01 -1.3398399353027344e+02 7.0306900024414062e+01 -5.9461601257324219e+01 -1.3373799133300781e+02 7.0306900024414062e+01 -5.8467899322509766e+01 -1.3372399902343750e+02 6.9886001586914062e+01 -5.8472499847412109e+01 -1.3390299987792969e+02 6.9886001586914062e+01 -5.9125099182128906e+01 -1.3401800537109375e+02 6.9886001586914062e+01 -5.9788600921630859e+01 -1.3409100341796875e+02 7.0306900024414062e+01 -6.0505699157714844e+01 -1.3407400512695312e+02 6.9886001586914062e+01 -6.0455898284912109e+01 -1.3407998657226562e+02 7.0014099121093750e+01 -6.0494899749755859e+01 -1.3407499694824219e+02 6.9886001586914062e+01 -6.0490200042724609e+01 -1.3064199829101562e+02 7.0306900024414062e+01 -6.0919998168945312e+01 -1.3369099426269531e+02 7.0306900024414062e+01 -6.0919998168945312e+01 -1.3065100097656250e+02 7.0013298034667969e+01 -6.0909801483154297e+01 -1.3368000793457031e+02 7.0014099121093750e+01 -6.0909801483154297e+01 -1.3065600585937500e+02 6.9886001586914062e+01 -6.0905300140380859e+01 -1.3367601013183594e+02 6.9886001586914062e+01 -6.0905300140380859e+01 -1.3016099548339844e+02 6.9886001586914062e+01 -5.9882099151611328e+01 -1.3014698791503906e+02 7.0306900024414062e+01 -5.9885200500488281e+01 -1.3021199035644531e+02 6.9886001586914062e+01 -6.0153301239013672e+01 -1.3021199035644531e+02 7.0306900024414062e+01 -6.0250900268554688e+01 -1.3024299621582031e+02 7.0306900024414062e+01 -6.0549697875976562e+01 -1.3025300598144531e+02 7.0013298034667969e+01 -6.0540100097656250e+01 -1.3024800109863281e+02 6.9886001586914062e+01 -6.0427799224853516e+01 -1.3025698852539062e+02 6.9886001586914062e+01 -6.0535999298095703e+01 -1.3006700134277344e+02 7.0306900024414062e+01 -5.9592601776123047e+01 -1.3003199768066406e+02 6.9886001586914062e+01 -5.9454502105712891e+01 -1.2994400024414062e+02 7.0306900024414062e+01 -5.9288700103759766e+01 -1.2992399597167969e+02 6.9886001586914062e+01 -5.9214500427246094e+01 -1.2977999877929688e+02 7.0306900024414062e+01 -5.8996700286865234e+01 -1.2979200744628906e+02 6.9886001586914062e+01 -5.8988601684570312e+01 -1.2959199523925781e+02 7.0306900024414062e+01 -5.8756702423095703e+01 -1.2951199340820312e+02 6.9886001586914062e+01 -5.8655601501464844e+01 -1.2936599731445312e+02 7.0306900024414062e+01 -5.8549900054931641e+01 -1.2932200622558594e+02 6.9886001586914062e+01 -5.8498798370361328e+01 -1.2910400390625000e+02 7.0306900024414062e+01 -5.8379199981689453e+01 -1.2911100769042969e+02 6.9886001586914062e+01 -5.8366397857666016e+01 -1.2806799316406250e+02 6.9886001586914062e+01 -5.8107398986816406e+01 -1.2806799316406250e+02 7.0306900024414062e+01 -5.8122200012207031e+01 -1.2821899414062500e+02 6.9886001586914062e+01 -5.8117900848388672e+01 -1.2840600585937500e+02 7.0306900024414062e+01 -5.8155498504638672e+01 -1.2875900268554688e+02 7.0306900024414062e+01 -5.8235702514648438e+01 -1.2883599853515625e+02 6.9886001586914062e+01 -5.8245403289794922e+01 -1.2853599548339844e+02 6.9886001586914062e+01 -5.8163799285888672e+01 -1.2761299133300781e+02 7.0306900024414062e+01 -5.8133998870849609e+01 -1.2772700500488281e+02 6.9886001586914062e+01 -5.8111198425292969e+01 -1.2716999816894531e+02 7.0306900024414062e+01 -5.8210498809814453e+01 -1.2716500091552734e+02 6.9886001586914062e+01 -5.8189601898193359e+01 -1.2707799530029297e+02 7.0306900024414062e+01 -5.8226299285888672e+01 -1.2716099548339844e+02 6.9886001586914062e+01 -5.8190200805664062e+01 -1.2641600036621094e+02 7.0306900024414062e+01 -5.8511299133300781e+01 -1.2640799713134766e+02 6.9886001586914062e+01 -5.8498798370361328e+01 -1.2596400451660156e+02 7.0306900024414062e+01 -5.8848701477050781e+01 -1.2600900268554688e+02 6.9886001586914062e+01 -5.8790699005126953e+01 -1.2561899566650391e+02 7.0306900024414062e+01 -5.9203701019287109e+01 -1.2566299438476562e+02 6.9886001586914062e+01 -5.9129497528076172e+01 -1.2532299804687500e+02 7.0306900024414062e+01 -5.9611999511718750e+01 -1.2531000518798828e+02 6.9886001586914062e+01 -5.9604202270507812e+01 -1.2501400756835938e+02 7.0306900024414062e+01 -6.0183300018310547e+01 -1.2505200195312500e+02 6.9886001586914062e+01 -6.0069099426269531e+01 -1.2482199859619141e+02 7.0306900024414062e+01 -6.0651802062988281e+01 -1.2484200286865234e+02 6.9886001586914062e+01 -6.0554901123046875e+01 -1.2466999816894531e+02 7.0306900024414062e+01 -6.1137199401855469e+01 -1.2465599822998047e+02 6.9886001586914062e+01 -6.1133399963378906e+01 -1.2452200317382812e+02 7.0306900024414062e+01 -6.1739501953125000e+01 -1.2451100158691406e+02 6.9886001586914062e+01 -6.1719699859619141e+01 -1.2440299987792969e+02 7.0306900024414062e+01 -6.2349300384521484e+01 -1.2439499664306641e+02 6.9886001586914062e+01 -6.2310298919677734e+01 -1.2433999633789062e+02 7.0306900024414062e+01 -6.2771499633789062e+01 -1.2432499694824219e+02 6.9886001586914062e+01 -6.2769802093505859e+01 -1.2429600524902344e+02 7.0306900024414062e+01 -6.3181900024414062e+01 -1.2428200531005859e+02 6.9886001586914062e+01 -6.3180297851562500e+01 -1.2424000549316406e+02 7.0306900024414062e+01 -6.3794395446777344e+01 -1.2424000549316406e+02 6.9886001586914062e+01 -6.3603000640869141e+01 -1.2421300506591797e+02 7.0306900024414062e+01 -6.4213294982910156e+01 -1.2420899963378906e+02 6.9886001586914062e+01 -6.4028099060058594e+01 -1.2419400024414062e+02 7.0306900024414062e+01 -6.4632400512695312e+01 -1.2417900085449219e+02 6.9886001586914062e+01 -6.4631797790527344e+01 -1.2420400238037109e+02 7.0306900024414062e+01 -6.5282096862792969e+01 -1.2417800140380859e+02 6.9886001586914062e+01 -6.5076904296875000e+01 -1.2425099945068359e+02 7.0306900024414062e+01 -6.5694694519042969e+01 -1.2421199798583984e+02 6.9886001586914062e+01 -6.5514801025390625e+01 -1.2433300018310547e+02 7.0306900024414062e+01 -6.6106300354003906e+01 -1.2431900024414062e+02 6.9886001586914062e+01 -6.6109802246093750e+01 -1.2443800354003906e+02 7.0306900024414062e+01 -6.6441398620605469e+01 -1.2449599456787109e+02 6.9886001586914062e+01 -6.6613693237304688e+01 -1.2458799743652344e+02 7.0306900024414062e+01 -6.6762100219726562e+01 -1.2469699859619141e+02 6.9886001586914062e+01 -6.6964599609375000e+01 -1.2496399688720703e+02 7.0306900024414062e+01 -6.7266601562500000e+01 -1.2495400238037109e+02 6.9886001586914062e+01 -6.7276794433593750e+01 -1.2633900451660156e+02 6.9886001586914062e+01 -6.7774299621582031e+01 -1.2633900451660156e+02 7.0306900024414062e+01 -6.7759605407714844e+01 -1.2595400238037109e+02 6.9886001586914062e+01 -6.7744796752929688e+01 -1.2573200225830078e+02 7.0306900024414062e+01 -6.7686897277832031e+01 -1.2554199981689453e+02 6.9886001586914062e+01 -6.7620498657226562e+01 -1.2554700469970703e+02 7.0306900024414062e+01 -6.7611297607421875e+01 -1.2534199523925781e+02 6.9886001586914062e+01 -6.7560096740722656e+01 -1.2523399353027344e+02 7.0306900024414062e+01 -6.7483200073242188e+01 -1.2507299804687500e+02 6.9886001586914062e+01 -6.7363594055175781e+01 -1.2507799530029297e+02 7.0306900024414062e+01 -6.7358100891113281e+01 -1.2689599609375000e+02 7.0306900024414062e+01 -6.7730598449707031e+01 -1.2664100646972656e+02 6.9886001586914062e+01 -6.7769805908203125e+01 -1.2738500213623047e+02 7.0306900024414062e+01 -6.7575904846191406e+01 -1.2739899444580078e+02 6.9886100769042969e+01 -6.7614700317382812e+01 -1.2780900573730469e+02 7.0306900024414062e+01 -6.7441902160644531e+01 -1.2751300811767578e+02 6.9886100769042969e+01 -6.7591506958007812e+01 -1.2826199340820312e+02 7.0306900024414062e+01 -6.7135498046875000e+01 -1.2827200317382812e+02 6.9886001586914062e+01 -6.7146705627441406e+01 -1.2920899963378906e+02 7.0008399963378906e+01 -6.5693000793457031e+01 -1.2920098876953125e+02 7.0306900024414062e+01 -6.5683403015136719e+01 -1.2889300537109375e+02 7.0306900024414062e+01 -6.6392898559570312e+01 -1.2921301269531250e+02 6.9886001586914062e+01 -6.5696899414062500e+01 -1.2890699768066406e+02 6.9886001586914062e+01 -6.6398895263671875e+01 -1.2883599853515625e+02 6.9886001586914062e+01 -6.6483001708984375e+01 -1.2882299804687500e+02 7.0306900024414062e+01 -6.6475196838378906e+01 -1.2959199523925781e+02 6.9886001586914062e+01 -6.5413398742675781e+01 -1.3268099975585938e+02 6.9886001586914062e+01 -6.5389999389648438e+01 -1.2958900451660156e+02 7.0008399963378906e+01 -6.5409103393554688e+01 -1.3268600463867188e+02 7.0016899108886719e+01 -6.5385398864746094e+01 -1.2958100891113281e+02 7.0306900024414062e+01 -6.5398696899414062e+01 -1.3269799804687500e+02 7.0306900024414062e+01 -6.5375198364257812e+01 -1.3287100219726562e+02 7.0306900024414062e+01 -6.6826400756835938e+01 -1.3309700012207031e+02 7.0306900024414062e+01 -6.5829498291015625e+01 -1.3308499145507812e+02 7.0016899108886719e+01 -6.5840499877929688e+01 -1.3243600463867188e+02 6.9886001586914062e+01 -6.7786094665527344e+01 -1.3244900512695312e+02 7.0306900024414062e+01 -6.7793304443359375e+01 -1.3273699951171875e+02 6.9886001586914062e+01 -6.7153900146484375e+01 -1.3295300292968750e+02 6.9886001586914062e+01 -6.6489700317382812e+01 -1.3308000183105469e+02 6.9886001586914062e+01 -6.5845397949218750e+01 -1.3088099670410156e+02 6.9886001586914062e+01 -6.9625694274902344e+01 -1.3088999938964844e+02 7.0306900024414062e+01 -6.9637199401855469e+01 -1.3139100646972656e+02 6.9886001586914062e+01 -6.9169799804687500e+01 -1.3140100097656250e+02 7.0306900024414062e+01 -6.9180397033691406e+01 -1.3184800720214844e+02 6.9886001586914062e+01 -6.8659797668457031e+01 -1.3185400390625000e+02 7.0306900024414062e+01 -6.8676597595214844e+01 -1.2872700500488281e+02 6.9886001586914062e+01 -7.0779304504394531e+01 -1.2873199462890625e+02 7.0306900024414062e+01 -7.0793304443359375e+01 -1.2935798645019531e+02 6.9886001586914062e+01 -7.0540298461914062e+01 -1.2932099914550781e+02 7.0306900024414062e+01 -7.0572395324707031e+01 -1.2996501159667969e+02 6.9886001586914062e+01 -7.0240699768066406e+01 -1.2988198852539062e+02 7.0306900024414062e+01 -7.0302803039550781e+01 -1.2622299957275391e+02 6.9886001586914062e+01 -7.1144401550292969e+01 -1.2622200012207031e+02 7.0306900024414062e+01 -7.1159202575683594e+01 -1.2689000701904297e+02 6.9886001586914062e+01 -7.1130996704101562e+01 -1.2687100219726562e+02 7.0306900024414062e+01 -7.1146896362304688e+01 -1.2755599975585938e+02 6.9886001586914062e+01 -7.1059097290039062e+01 -1.2751199340820312e+02 7.0306900024414062e+01 -7.1080604553222656e+01 -1.2330199432373047e+02 6.9886001586914062e+01 -7.0443901062011719e+01 -1.2329499816894531e+02 7.0306900024414062e+01 -7.0456901550292969e+01 -1.2413800048828125e+02 6.9886001586914062e+01 -7.0804702758789062e+01 -1.2413700103759766e+02 7.0306900024414062e+01 -7.0819801330566406e+01 -1.2463299560546875e+02 6.9886001586914062e+01 -7.0929901123046875e+01 -1.2462899780273438e+02 7.0306900024414062e+01 -7.0944099426269531e+01 -1.2500700378417969e+02 6.9886001586914062e+01 -7.1024795532226562e+01 -1.2500900268554688e+02 7.0306900024414062e+01 -7.1040100097656250e+01 -1.2248899841308594e+02 7.0306900024414062e+01 -6.9931800842285156e+01 -1.2227299499511719e+02 6.9886001586914062e+01 -6.9735000610351562e+01 -1.2220899963378906e+02 7.0306900024414062e+01 -6.9676895141601562e+01 -1.2221099853515625e+02 6.9886001586914062e+01 -6.9674301147460938e+01 -1.2187100219726562e+02 7.0306900024414062e+01 -6.9369598388671875e+01 -1.2177600097656250e+02 6.9886001586914062e+01 -6.9243995666503906e+01 -1.2133499908447266e+02 7.0306900024414062e+01 -6.8701293945312500e+01 -1.2134700012207031e+02 6.9886001586914062e+01 -6.8693000793457031e+01 -1.2081299591064453e+02 7.0306900024414062e+01 -6.7775505065917969e+01 -1.2069400024414062e+02 6.9886001586914062e+01 -6.7459205627441406e+01 -1.2031699371337891e+02 6.9886001586914062e+01 -6.6181098937988281e+01 -1.2030299377441406e+02 7.0306900024414062e+01 -6.6183998107910156e+01 -1.2098400115966797e+02 6.9886001586914062e+01 -6.8089500427246094e+01 -1.2051399993896484e+02 7.0306900024414062e+01 -6.7001296997070312e+01 -1.2019300079345703e+02 6.9886001586914062e+01 -6.3199295043945312e+01 -1.2017900085449219e+02 7.0306900024414062e+01 -6.3197700500488281e+01 -1.2013700103759766e+02 6.9886001586914062e+01 -6.4501396179199219e+01 -1.2012300109863281e+02 7.0306900024414062e+01 -6.4097801208496094e+01 -1.2018900299072266e+02 6.9886001586914062e+01 -6.5340896606445312e+01 -1.2014400482177734e+02 7.0306900024414062e+01 -6.4991104125976562e+01 -1.2022299957275391e+02 7.0306900024414062e+01 -6.2772994995117188e+01 -1.2023699951171875e+02 6.9886001586914062e+01 -6.2774597167968750e+01 -1.2105599975585938e+02 6.9886001586914062e+01 -5.9645999908447266e+01 -1.2104299926757812e+02 7.0306900024414062e+01 -5.9640300750732422e+01 -1.2062100219726562e+02 6.9886001586914062e+01 -6.0864696502685547e+01 -1.2063299560546875e+02 7.0306900024414062e+01 -6.0770999908447266e+01 -1.2033000183105469e+02 6.9886001586914062e+01 -6.2124198913574219e+01 -1.2034899902343750e+02 7.0306900024414062e+01 -6.1939998626708984e+01 -1.2272200012207031e+02 6.9886001586914062e+01 -5.7059501647949219e+01 -1.2271100616455078e+02 7.0306900024414062e+01 -5.7049503326416016e+01 -1.2189699554443359e+02 6.9886001586914062e+01 -5.8094699859619141e+01 -1.2210199737548828e+02 7.0306900024414062e+01 -5.7779300689697266e+01 -1.2144000244140625e+02 6.9886001586914062e+01 -5.8847499847412109e+01 -1.2158399963378906e+02 7.0306900024414062e+01 -5.8562698364257812e+01 -1.2517599487304688e+02 6.9886001586914062e+01 -5.5321296691894531e+01 -1.2517000579833984e+02 7.0306900024414062e+01 -5.5307800292968750e+01 -1.2405599975585938e+02 6.9886001586914062e+01 -5.5931499481201172e+01 -1.2435199737548828e+02 7.0306900024414062e+01 -5.5729301452636719e+01 -1.2385199737548828e+02 7.0306900024414062e+01 -5.6068199157714844e+01 -1.2360200500488281e+02 7.0306900024414062e+01 -5.6237899780273438e+01 -1.2336000061035156e+02 6.9886001586914062e+01 -5.6452098846435547e+01 -1.2386000061035156e+02 6.9886001586914062e+01 -5.6078300476074219e+01 -1.2620400238037109e+02 7.0306900024414062e+01 -5.4950500488281250e+01 -1.2609100341796875e+02 6.9886001586914062e+01 -5.4995498657226562e+01 -1.2669000244140625e+02 7.0306900024414062e+01 -5.4864601135253906e+01 -1.2669199371337891e+02 6.9886001586914062e+01 -5.4873703002929688e+01 -1.2726100158691406e+02 7.0306900024414062e+01 -5.4763599395751953e+01 -1.2702099609375000e+02 6.9886001586914062e+01 -5.4807102203369141e+01 -1.2836100769042969e+02 7.0306900024414062e+01 -5.4722499847412109e+01 -1.2836000061035156e+02 6.9886001586914062e+01 -5.4737300872802734e+01 -1.3081300354003906e+02 6.9886001586914062e+01 -5.5233501434326172e+01 -1.3081900024414062e+02 7.0306900024414062e+01 -5.5220001220703125e+01 -1.3015699768066406e+02 6.9886001586914062e+01 -5.4998199462890625e+01 -1.3021501159667969e+02 7.0306900024414062e+01 -5.4999900817871094e+01 -1.2948399353027344e+02 6.9886001586914062e+01 -5.4843002319335938e+01 -1.2959700012207031e+02 7.0306900024414062e+01 -5.4848499298095703e+01 -1.3262200927734375e+02 6.9886001586914062e+01 -5.6524398803710938e+01 -1.3263299560546875e+02 7.0306900024414062e+01 -5.6514698028564453e+01 -1.3211299133300781e+02 6.9886001586914062e+01 -5.6028198242187500e+01 -1.3186700439453125e+02 7.0306900024414062e+01 -5.5816299438476562e+01 -1.3149600219726562e+02 6.9886001586914062e+01 -5.5586097717285156e+01 -1.3136000061035156e+02 7.0306900024414062e+01 -5.5489101409912109e+01 -1.3346899414062500e+02 6.9886001586914062e+01 -5.7828098297119141e+01 -1.3332099914550781e+02 7.0306900024414062e+01 -5.7499599456787109e+01 -1.3309800720214844e+02 6.9886001586914062e+01 -5.7153499603271484e+01 -1.3300498962402344e+02 7.0306900024414062e+01 -5.6987300872802734e+01 -1.3256600952148438e+02 6.9500000000000000e+01 -6.6390594482421875e+01 -1.3268400573730469e+02 6.9500000000000000e+01 -6.5789794921875000e+01 -1.2959500122070312e+02 6.9500000000000000e+01 -6.5813102722167969e+01 -1.2925100708007812e+02 6.9500000000000000e+01 -6.6602401733398438e+01 -1.3208700561523438e+02 6.9500000000000000e+01 -6.7590599060058594e+01 -1.3236599731445312e+02 6.9500000000000000e+01 -6.7006202697753906e+01 -1.2852899169921875e+02 6.9500000000000000e+01 -6.7452903747558594e+01 -1.3110899353027344e+02 6.9500000000000000e+01 -6.8886901855468750e+01 -1.3153601074218750e+02 6.9500000000000000e+01 -6.8410003662109375e+01 -1.2765399932861328e+02 6.9500000000000000e+01 -6.7965599060058594e+01 -1.2919900512695312e+02 6.9500000000000000e+01 -7.0173500061035156e+01 -1.2852899169921875e+02 6.9500000000000000e+01 -6.7452995300292969e+01 -1.2977099609375000e+02 6.9500000000000000e+01 -6.9891494750976562e+01 -1.3063099670410156e+02 6.9500000000000000e+01 -6.9313499450683594e+01 -1.2666400146484375e+02 6.9500000000000000e+01 -6.8168899536132812e+01 -1.2749500274658203e+02 6.9500000000000000e+01 -7.0664001464843750e+01 -1.2860299682617188e+02 6.9500000000000000e+01 -7.0399406433105469e+01 -1.2253499603271484e+02 6.9500000000000000e+01 -6.9433006286621094e+01 -1.2349300384521484e+02 6.9500000000000000e+01 -7.0092498779296875e+01 -1.2466699981689453e+02 6.9500000000000000e+01 -6.7555198669433594e+01 -1.2516101074218750e+02 6.9500000000000000e+01 -6.7916900634765625e+01 -1.2426399993896484e+02 6.9500000000000000e+01 -7.0425506591796875e+01 -1.2589700317382812e+02 6.9500000000000000e+01 -6.8140403747558594e+01 -1.2507799530029297e+02 6.9500000000000000e+01 -7.0631401062011719e+01 -1.2633000183105469e+02 6.9500000000000000e+01 -6.8173896789550781e+01 -1.2623100280761719e+02 6.9500000000000000e+01 -7.0744796752929688e+01 -1.2686499786376953e+02 6.9500000000000000e+01 -7.0732101440429688e+01 -1.2207499694824219e+02 6.9500000000000000e+01 -6.8978500366210938e+01 -1.2436799621582031e+02 6.9500000000000000e+01 -6.7191802978515625e+01 -1.2167699432373047e+02 6.9500000000000000e+01 -6.8468200683593750e+01 -1.2413399505615234e+02 6.9500000000000000e+01 -6.6783798217773438e+01 -1.2133800506591797e+02 6.9500000000000000e+01 -6.7902999877929688e+01 -1.2930200195312500e+02 6.9500000000000000e+01 -5.8015300750732422e+01 -1.2955500793457031e+02 6.9500000000000000e+01 -5.8174301147460938e+01 -1.3128800964355469e+02 6.9500000000000000e+01 -5.5927501678466797e+01 -1.3276300048828125e+02 6.9500000000000000e+01 -5.7370300292968750e+01 -1.3027900695800781e+02 6.9500000000000000e+01 -5.9031402587890625e+01 -1.3310700988769531e+02 6.9500000000000000e+01 -5.7996101379394531e+01 -1.3040499877929688e+02 6.9500000000000000e+01 -5.9308799743652344e+01 -1.3334399414062500e+02 6.9500000000000000e+01 -5.8598201751708984e+01 -1.3055198669433594e+02 6.9500000000000000e+01 -5.9795799255371094e+01 -1.2361799621582031e+02 6.9500000000000000e+01 -5.6757499694824219e+01 -1.2536400604248047e+02 6.9500000000000000e+01 -5.8864799499511719e+01 -1.2575000762939453e+02 6.9500000000000000e+01 -5.8485900878906250e+01 -1.3185499572753906e+02 6.9500000000000000e+01 -5.6334300994873047e+01 -1.2978599548339844e+02 6.9500000000000000e+01 -5.8364498138427734e+01 -1.3232199096679688e+02 6.9500000000000000e+01 -5.6789302825927734e+01 -1.3012500000000000e+02 6.9500000000000000e+01 -5.8768001556396484e+01 -1.3012600708007812e+02 6.9500000000000000e+01 -5.8768699645996094e+01 -1.3055198669433594e+02 6.9500000000000000e+01 -5.9796199798583984e+01 -1.3362200927734375e+02 6.9500000000000000e+01 -5.9838802337646484e+01 -1.3351300048828125e+02 6.9500000000000000e+01 -5.9211803436279297e+01 -1.2301399993896484e+02 6.9500000000000000e+01 -5.7332401275634766e+01 -1.2497100067138672e+02 6.9500000000000000e+01 -5.9392700195312500e+01 -1.2222799682617188e+02 6.9500000000000000e+01 -5.8318901062011719e+01 -1.2469300079345703e+02 6.9500000000000000e+01 -5.9893001556396484e+01 -1.2446800231933594e+02 6.9500000000000000e+01 -6.0413497924804688e+01 -1.2930099487304688e+02 6.9500000000000000e+01 -5.8015102386474609e+01 -1.3065400695800781e+02 6.9500000000000000e+01 -5.5600402832031250e+01 -1.2896800231933594e+02 6.9500000000000000e+01 -5.7868000030517578e+01 -1.3004598999023438e+02 6.9500000000000000e+01 -5.5381999969482422e+01 -1.2861601257324219e+02 6.9500000000000000e+01 -5.7771999359130859e+01 -1.2941600036621094e+02 6.9500000000000000e+01 -5.5236801147460938e+01 -1.2825599670410156e+02 6.9500000000000000e+01 -5.7719799041748047e+01 -1.2835200500488281e+02 6.9500000000000000e+01 -5.5136901855468750e+01 -1.2808399963378906e+02 6.9500000000000000e+01 -5.7708000183105469e+01 -1.2835000610351562e+02 6.9500000000000000e+01 -5.5136901855468750e+01 -1.2770499420166016e+02 6.9500000000000000e+01 -5.7712100982666016e+01 -1.2707400512695312e+02 6.9500000000000000e+01 -5.5203300476074219e+01 -1.2706900024414062e+02 6.9500000000000000e+01 -5.7801101684570312e+01 -1.2619699859619141e+02 6.9500000000000000e+01 -5.5381000518798828e+01 -1.2619599914550781e+02 6.9500000000000000e+01 -5.8159999847412109e+01 -1.2533800506591797e+02 6.9500000000000000e+01 -5.5686702728271484e+01 -1.2427600097656250e+02 6.9500000000000000e+01 -5.6265201568603516e+01 -1.3060699462890625e+02 6.9500000000000000e+01 -6.0090999603271484e+01 -1.3064500427246094e+02 6.9500000000000000e+01 -6.0388500213623047e+01 -1.3367498779296875e+02 6.9500000000000000e+01 -6.0472896575927734e+01 -1.3065600585937500e+02 6.9500000000000000e+01 -6.0505599975585938e+01 -1.3367601013183594e+02 6.9500000000000000e+01 -6.0505599975585938e+01 -1.2179199981689453e+02 6.9500000000000000e+01 -5.9037700653076172e+01 -1.2142399597167969e+02 6.9500000000000000e+01 -5.9802497863769531e+01 -1.2426999664306641e+02 6.9500000000000000e+01 -6.1029399871826172e+01 -1.2142399597167969e+02 6.9500000000000000e+01 -5.9802600860595703e+01 -1.2412100219726562e+02 6.9500000000000000e+01 -6.1632801055908203e+01 -1.2100399780273438e+02 6.9500000000000000e+01 -6.0976799011230469e+01 -1.2400099945068359e+02 6.9500000000000000e+01 -6.2242599487304688e+01 -1.2072399902343750e+02 6.9500000000000000e+01 -6.2191699981689453e+01 -1.2106499481201172e+02 6.9500000000000000e+01 -6.7311103820800781e+01 -1.2393099975585938e+02 6.9500000000000000e+01 -6.6205894470214844e+01 -1.2070899963378906e+02 6.9500000000000000e+01 -6.6102302551269531e+01 -1.2381400299072266e+02 6.9500000000000000e+01 -6.5561401367187500e+01 -1.2058699798583984e+02 6.9500000000000000e+01 -6.5298805236816406e+01 -1.2377899932861328e+02 6.9500000000000000e+01 -6.5091293334960938e+01 -1.2053699493408203e+02 6.9500000000000000e+01 -6.4493797302246094e+01 -1.2377899932861328e+02 6.9500000000000000e+01 -6.4617202758789062e+01 -1.2059100341796875e+02 6.9500000000000000e+01 -6.3240200042724609e+01 -1.2380999755859375e+02 6.9500000000000000e+01 -6.4002998352050781e+01 -1.2384200286865234e+02 6.9500000000000000e+01 -6.3569000244140625e+01 -1.2063500213623047e+02 6.9500000000000000e+01 -6.2818103790283203e+01 -1.2388400268554688e+02 6.9500000000000000e+01 -6.3137897491455078e+01 -1.2392800140380859e+02 6.9500000000000000e+01 -6.2722900390625000e+01 -1.3846400451660156e+02 7.0306900024414062e+01 -7.0851493835449219e+01 -1.3845098876953125e+02 6.9886001586914062e+01 -7.0836799621582031e+01 -1.3515699768066406e+02 7.0306900024414062e+01 -7.0851493835449219e+01 -1.3517500305175781e+02 6.9886001586914062e+01 -7.0836799621582031e+01 -1.3476300048828125e+02 7.0306900024414062e+01 -7.0383499145507812e+01 -1.3478100585937500e+02 6.9886001586914062e+01 -7.0368904113769531e+01 -1.3851899719238281e+02 7.0306900024414062e+01 -4.8696701049804688e+01 -1.3853100585937500e+02 6.9886001586914062e+01 -4.8711399078369141e+01 -1.3891300964355469e+02 7.0306900024414062e+01 -4.8365100860595703e+01 -1.3892500305175781e+02 6.9886001586914062e+01 -4.8379802703857422e+01 -1.4222300720214844e+02 7.0306900024414062e+01 -4.8365100860595703e+01 -1.4220500183105469e+02 6.9886001586914062e+01 -4.8379802703857422e+01 -1.4261500549316406e+02 7.0306900024414062e+01 -4.8841499328613281e+01 -1.4259700012207031e+02 6.9886001586914062e+01 -4.8856098175048828e+01 -1.4106401062011719e+02 7.0306900024414062e+01 -5.6789302825927734e+01 -1.4103900146484375e+02 6.9886001586914062e+01 -5.6839000701904297e+01 -1.4127899169921875e+02 7.0306900024414062e+01 -5.6556602478027344e+01 -1.4137100219726562e+02 6.9886001586914062e+01 -5.6484500885009766e+01 -1.4208699035644531e+02 7.0306900024414062e+01 -5.5839797973632812e+01 -1.4300399780273438e+02 6.9886001586914062e+01 -5.5276798248291016e+01 -1.4299800109863281e+02 7.0306900024414062e+01 -5.5263702392578125e+01 -1.4241799926757812e+02 6.9886001586914062e+01 -5.5622997283935547e+01 -1.4187200927734375e+02 6.9886001586914062e+01 -5.6028198242187500e+01 -1.4536698913574219e+02 6.9886001586914062e+01 -5.4737300872802734e+01 -1.4536698913574219e+02 7.0306900024414062e+01 -5.4722499847412109e+01 -1.4505699157714844e+02 6.9886001586914062e+01 -5.4742000579833984e+01 -1.4514199829101562e+02 7.0306900024414062e+01 -5.4724296569824219e+01 -1.4435299682617188e+02 6.9886001586914062e+01 -5.4818801879882812e+01 -1.4433200073242188e+02 7.0306900024414062e+01 -5.4807800292968750e+01 -1.4413000488281250e+02 6.9886001586914062e+01 -5.4876098632812500e+01 -1.4412699890136719e+02 7.0306900024414062e+01 -5.4863399505615234e+01 -1.4366200256347656e+02 6.9886001586914062e+01 -5.4996097564697266e+01 -1.4354800415039062e+02 7.0306900024414062e+01 -5.5020702362060547e+01 -1.4757600402832031e+02 6.9886001586914062e+01 -5.5276302337646484e+01 -1.4758299255371094e+02 7.0306900024414062e+01 -5.5263599395751953e+01 -1.4703500366210938e+02 6.9886001586914062e+01 -5.5024002075195312e+01 -1.4705499267578125e+02 7.0306900024414062e+01 -5.5015701293945312e+01 -1.4647500610351562e+02 6.9886001586914062e+01 -5.4861797332763672e+01 -1.4649101257324219e+02 7.0306900024414062e+01 -5.4850196838378906e+01 -1.4550199890136719e+02 6.9886001586914062e+01 -5.4741500854492188e+01 -1.4548599243164062e+02 7.0306900024414062e+01 -5.4726100921630859e+01 -1.4895201110839844e+02 6.9886001586914062e+01 -5.6638099670410156e+01 -1.4896499633789062e+02 7.0306900024414062e+01 -5.6630699157714844e+01 -1.4860198974609375e+02 6.9886001586914062e+01 -5.6135200500488281e+01 -1.4856399536132812e+02 7.0306900024414062e+01 -5.6067600250244141e+01 -1.4813299560546875e+02 6.9886001586914062e+01 -5.5665000915527344e+01 -1.4808300781250000e+02 7.0306900024414062e+01 -5.5604698181152344e+01 -1.4960198974609375e+02 6.9886001586914062e+01 -5.8585899353027344e+01 -1.4961599731445312e+02 7.0306900024414062e+01 -5.8583900451660156e+01 -1.4946598815917969e+02 6.9886001586914062e+01 -5.7901798248291016e+01 -1.4943600463867188e+02 7.0306900024414062e+01 -5.7736999511718750e+01 -1.4925601196289062e+02 6.9886001586914062e+01 -5.7260597229003906e+01 -1.4923399353027344e+02 7.0306900024414062e+01 -5.7168899536132812e+01 -1.4963800048828125e+02 6.9886001586914062e+01 -6.0865398406982422e+01 -1.4965299987792969e+02 7.0306900024414062e+01 -6.0867298126220703e+01 -1.4966499328613281e+02 6.9886001586914062e+01 -6.0546901702880859e+01 -1.4969000244140625e+02 7.0306900024414062e+01 -6.0383598327636719e+01 -1.4968901062011719e+02 6.9886001586914062e+01 -5.9894199371337891e+01 -1.4970300292968750e+02 7.0306900024414062e+01 -5.9781902313232422e+01 -1.4966900634765625e+02 6.9886001586914062e+01 -5.9239303588867188e+01 -1.4967900085449219e+02 7.0306900024414062e+01 -5.9181102752685547e+01 -1.4803999328613281e+02 7.0306900024414062e+01 -7.0517700195312500e+01 -1.4802700805664062e+02 6.9886001586914062e+01 -7.0502998352050781e+01 -1.4764498901367188e+02 7.0306900024414062e+01 -7.0851493835449219e+01 -1.4763299560546875e+02 6.9886001586914062e+01 -7.0836799621582031e+01 -1.4433898925781250e+02 7.0306900024414062e+01 -7.0851493835449219e+01 -1.4435699462890625e+02 6.9886001586914062e+01 -7.0836799621582031e+01 -1.4394499206542969e+02 7.0306900024414062e+01 -7.0385597229003906e+01 -1.4396199035644531e+02 6.9886001586914062e+01 -7.0370803833007812e+01 -1.4555000305175781e+02 7.0306900024414062e+01 -6.0825099945068359e+01 -1.4556500244140625e+02 6.9886001586914062e+01 -6.0827198028564453e+01 -1.4556098937988281e+02 7.0306900024414062e+01 -6.0733001708984375e+01 -1.4558399963378906e+02 6.9886001586914062e+01 -6.0662002563476562e+01 -1.4558799743652344e+02 7.0306900024414062e+01 -6.0414501190185547e+01 -1.4560600280761719e+02 6.9886001586914062e+01 -6.0360900878906250e+01 -1.4559599304199219e+02 7.0306900024414062e+01 -6.0092899322509766e+01 -1.4561000061035156e+02 6.9886001586914062e+01 -6.0062198638916016e+01 -1.4557899475097656e+02 7.0306900024414062e+01 -5.9769001007080078e+01 -1.4559399414062500e+02 6.9886001586914062e+01 -5.9767601013183594e+01 -1.4553500366210938e+02 7.0306900024414062e+01 -5.9471801757812500e+01 -1.4553298950195312e+02 6.9886001586914062e+01 -5.9394699096679688e+01 -1.4545899963378906e+02 7.0306900024414062e+01 -5.9199600219726562e+01 -1.4545599365234375e+02 6.9886001586914062e+01 -5.9150299072265625e+01 -1.4533700561523438e+02 7.0306900024414062e+01 -5.8931201934814453e+01 -1.4534999084472656e+02 6.9886001586914062e+01 -5.8923999786376953e+01 -1.4515599060058594e+02 7.0306900024414062e+01 -5.8680999755859375e+01 -1.4516200256347656e+02 6.9886001586914062e+01 -5.8665500640869141e+01 -1.4508500671386719e+02 7.0306900024414062e+01 -5.8615100860595703e+01 -1.4509500122070312e+02 6.9886001586914062e+01 -5.8604099273681641e+01 -1.4496600341796875e+02 7.0306900024414062e+01 -5.8506401062011719e+01 -1.4498298645019531e+02 6.9886001586914062e+01 -5.8500801086425781e+01 -1.4474800109863281e+02 7.0306900024414062e+01 -5.8364601135253906e+01 -1.4475500488281250e+02 6.9886001586914062e+01 -5.8351799011230469e+01 -1.4372700500488281e+02 6.9886001586914062e+01 -5.8122097015380859e+01 -1.4372700500488281e+02 7.0306900024414062e+01 -5.8136798858642578e+01 -1.4378700256347656e+02 6.9886001586914062e+01 -5.8123901367187500e+01 -1.4412599182128906e+02 7.0306900024414062e+01 -5.8169399261474609e+01 -1.4443899536132812e+02 7.0306900024414062e+01 -5.8237701416015625e+01 -1.4453298950195312e+02 6.9886001586914062e+01 -5.8253097534179688e+01 -1.4417498779296875e+02 6.9886001586914062e+01 -5.8162200927734375e+01 -1.4208300781250000e+02 6.9886001586914062e+01 -5.8483501434326172e+01 -1.4208999633789062e+02 7.0306900024414062e+01 -5.8496398925781250e+01 -1.4251800537109375e+02 6.9886001586914062e+01 -5.8291698455810547e+01 -1.4260099792480469e+02 7.0306900024414062e+01 -5.8279903411865234e+01 -1.4298098754882812e+02 6.9886001586914062e+01 -5.8172199249267578e+01 -1.4312100219726562e+02 7.0306900024414062e+01 -5.8165500640869141e+01 -1.4346400451660156e+02 6.9886001586914062e+01 -5.8122299194335938e+01 -1.4153599548339844e+02 7.0306900024414062e+01 -5.8859298706054688e+01 -1.4157701110839844e+02 6.9886001586914062e+01 -5.8809799194335938e+01 -1.4104499816894531e+02 7.0306900024414062e+01 -5.9297302246093750e+01 -1.4111700439453125e+02 6.9886001586914062e+01 -5.9205200195312500e+01 -1.4079100036621094e+02 7.0306900024414062e+01 -5.9576103210449219e+01 -1.4077700805664062e+02 6.9886001586914062e+01 -5.9569599151611328e+01 -1.3885800170898438e+02 7.0306900024414062e+01 -7.0521301269531250e+01 -1.3884500122070312e+02 6.9886001586914062e+01 -7.0506599426269531e+01 -1.4220500183105469e+02 6.9500000000000000e+01 -4.8779598236083984e+01 -1.3892500305175781e+02 6.9500000000000000e+01 -4.8779598236083984e+01 -1.4036799621582031e+02 6.9500000000000000e+01 -5.8191398620605469e+01 -1.3517500305175781e+02 6.9500000000000000e+01 -7.0437103271484375e+01 -1.3845098876953125e+02 6.9500000000000000e+01 -7.0437103271484375e+01 -1.4040200805664062e+02 6.9500000000000000e+01 -5.9393100738525391e+01 -1.4907899475097656e+02 6.9500000000000000e+01 -5.8002502441406250e+01 -1.4888499450683594e+02 6.9500000000000000e+01 -5.7409801483154297e+01 -1.4582901000976562e+02 6.9500000000000000e+01 -5.9005901336669922e+01 -1.4569799804687500e+02 6.9500000000000000e+01 -5.8727901458740234e+01 -1.4920599365234375e+02 6.9500000000000000e+01 -5.8641197204589844e+01 -1.4592100524902344e+02 6.9500000000000000e+01 -5.9298797607421875e+01 -1.4920599365234375e+02 6.9500000000000000e+01 -5.8641399383544922e+01 -1.4599198913574219e+02 6.9500000000000000e+01 -5.9731403350830078e+01 -1.4927000427246094e+02 6.9500000000000000e+01 -5.9265598297119141e+01 -1.4083700561523438e+02 6.9500000000000000e+01 -5.8919097900390625e+01 -1.4079600524902344e+02 6.9500000000000000e+01 -5.7712398529052734e+01 -1.4133700561523438e+02 6.9500000000000000e+01 -5.8489898681640625e+01 -1.4165400695800781e+02 6.9500000000000000e+01 -5.6766700744628906e+01 -1.4548500061035156e+02 6.9500000000000000e+01 -5.5140899658203125e+01 -1.4466699218750000e+02 6.9500000000000000e+01 -5.7876502990722656e+01 -1.4638999938964844e+02 6.9500000000000000e+01 -5.5252300262451172e+01 -1.4494700622558594e+02 6.9500000000000000e+01 -5.8000900268554688e+01 -1.4689700317382812e+02 6.9500000000000000e+01 -5.5399002075195312e+01 -1.4494700622558594e+02 6.9500000000000000e+01 -5.8000999450683594e+01 -1.4737600708007812e+02 6.9500000000000000e+01 -5.5622299194335938e+01 -1.4522900390625000e+02 6.9500000000000000e+01 -5.8185497283935547e+01 -1.4787699890136719e+02 6.9500000000000000e+01 -5.5971599578857422e+01 -1.4545700073242188e+02 6.9500000000000000e+01 -5.8395198822021484e+01 -1.4829400634765625e+02 6.9500000000000000e+01 -5.6390300750732422e+01 -1.4860699462890625e+02 6.9500000000000000e+01 -5.6839000701904297e+01 -1.4535998535156250e+02 6.9500000000000000e+01 -5.5137001037597656e+01 -1.4507398986816406e+02 6.9500000000000000e+01 -5.5141399383544922e+01 -1.4424000549316406e+02 6.9500000000000000e+01 -5.7767902374267578e+01 -1.4442401123046875e+02 6.9500000000000000e+01 -5.5212299346923828e+01 -1.4380299377441406e+02 6.9500000000000000e+01 -5.7724498748779297e+01 -1.4379000854492188e+02 6.9500000000000000e+01 -5.5374702453613281e+01 -1.4435699462890625e+02 6.9500000000000000e+01 -7.0437103271484375e+01 -1.4763299560546875e+02 6.9500000000000000e+01 -7.0437103271484375e+01 -1.4596000671386719e+02 6.9500000000000000e+01 -6.0885700225830078e+01 -1.4924200439453125e+02 6.9500000000000000e+01 -6.0812900543212891e+01 -1.4189100646972656e+02 6.9500000000000000e+01 -5.8132701873779297e+01 -1.4189199829101562e+02 6.9500000000000000e+01 -5.8132598876953125e+01 -1.4212599182128906e+02 6.9500000000000000e+01 -5.6336601257324219e+01 -1.4238700866699219e+02 6.9500000000000000e+01 -5.7913799285888672e+01 -1.4263899230957031e+02 6.9500000000000000e+01 -5.5955997467041016e+01 -1.4291200256347656e+02 6.9500000000000000e+01 -5.7778499603271484e+01 -1.4318899536132812e+02 6.9500000000000000e+01 -5.5631298065185547e+01 -1.4345001220703125e+02 6.9500000000000000e+01 -5.7722801208496094e+01 -1.4373800659179688e+02 6.9500000000000000e+01 -5.7722400665283203e+01 -1.4928900146484375e+02 6.9500000000000000e+01 -5.9892700195312500e+01 -1.4600999450683594e+02 6.9500000000000000e+01 -6.0055000305175781e+01 -1.4926600646972656e+02 6.9500000000000000e+01 -6.0519699096679688e+01 -1.4600500488281250e+02 6.9500000000000000e+01 -6.0378902435302734e+01 -1.4598100280761719e+02 6.9500000000000000e+01 -6.0701900482177734e+01 -1.4781300354003906e+02 6.9882202148437500e+01 -7.0793601989746094e+01 -1.4782400512695312e+02 7.0308700561523438e+01 -7.0803596496582031e+01 -1.4783500671386719e+02 6.9882202148437500e+01 -7.0775001525878906e+01 -1.4784500122070312e+02 7.0308998107910156e+01 -7.0798004150390625e+01 -1.4795500183105469e+02 6.9882202148437500e+01 -7.0673797607421875e+01 -1.4796099853515625e+02 7.0308700561523438e+01 -7.0682304382324219e+01 -1.4797399902343750e+02 6.9883193969726562e+01 -7.0628601074218750e+01 -1.4799099731445312e+02 7.0308601379394531e+01 -7.0651802062988281e+01 -1.4766999816894531e+02 6.9885200500488281e+01 -7.0827903747558594e+01 -1.4774699401855469e+02 6.9883598327636719e+01 -7.0809501647949219e+01 -1.4435699462890625e+02 6.9724098205566406e+01 -7.0796302795410156e+01 -1.4763299560546875e+02 6.9693000793457031e+01 -7.0779396057128906e+01 -1.4435699462890625e+02 6.9695800781250000e+01 -7.0773902893066406e+01 -1.4763299560546875e+02 6.9692199707031250e+01 -7.0778495788574219e+01 -1.4435699462890625e+02 6.9590202331542969e+01 -7.0690101623535156e+01 -1.4763299560546875e+02 6.9551498413085938e+01 -7.0632797241210938e+01 -1.4763299560546875e+02 6.9550697326660156e+01 -7.0632003784179688e+01 -1.4435699462890625e+02 6.9512802124023438e+01 -7.0537597656250000e+01 -1.4435699462890625e+02 6.9559097290039062e+01 -7.0628997802734375e+01 -1.4427299499511719e+02 7.0308204650878906e+01 -7.0846000671386719e+01 -1.4432099914550781e+02 6.9884796142578125e+01 -7.0828804016113281e+01 -1.4424800109863281e+02 6.9882400512695312e+01 -7.0812797546386719e+01 -1.4417601013183594e+02 7.0309494018554688e+01 -7.0802101135253906e+01 -1.4418899536132812e+02 6.9880401611328125e+01 -7.0799499511718750e+01 -1.4418299865722656e+02 6.9880302429199219e+01 -7.0795097351074219e+01 -1.4408500671386719e+02 7.0310600280761719e+01 -7.0760200500488281e+01 -1.4405200195312500e+02 6.9878402709960938e+01 -7.0694999694824219e+01 -1.4397099304199219e+02 6.9880500793457031e+01 -7.0537597656250000e+01 -1.4396099853515625e+02 7.0309600830078125e+01 -7.0556999206542969e+01 -1.4397099304199219e+02 6.9880401611328125e+01 -7.0542800903320312e+01 -1.4396501159667969e+02 7.0310104370117188e+01 -7.0591796875000000e+01 -1.4404399108886719e+02 7.0310501098632812e+01 -7.0703002929687500e+01 -1.4780500793457031e+02 6.9595901489257812e+01 -7.0632003784179688e+01 -1.4782899475097656e+02 6.9553596496582031e+01 -7.0469795227050781e+01 -1.4782600402832031e+02 6.9551300048828125e+01 -7.0469398498535156e+01 -1.4793199157714844e+02 6.9720100402832031e+01 -7.0632003784179688e+01 -1.4797100830078125e+02 6.9696395874023438e+01 -7.0493598937988281e+01 -1.4797000122070312e+02 6.9691894531250000e+01 -7.0493400573730469e+01 -1.4780999755859375e+02 6.9793403625488281e+01 -7.0779396057128906e+01 -1.4773500061035156e+02 6.9719902038574219e+01 -7.0779396057128906e+01 -1.4420600891113281e+02 6.9809402465820312e+01 -7.0796302795410156e+01 -1.4409098815917969e+02 6.9740402221679688e+01 -7.0690101623535156e+01 -1.4402499389648438e+02 6.9700599670410156e+01 -7.0537597656250000e+01 -1.4401799011230469e+02 6.9696395874023438e+01 -7.0380302429199219e+01 -1.4416299438476562e+02 6.9551300048828125e+01 -7.0404594421386719e+01 -1.4416099548339844e+02 6.9553703308105469e+01 -7.0404205322265625e+01 -1.4416598510742188e+02 6.9563003540039062e+01 -7.0537597656250000e+01 -1.4402000427246094e+02 6.9691894531250000e+01 -7.0380500793457031e+01 -1.4427000427246094e+02 6.9746894836425781e+01 -7.0796302795410156e+01 -1.4420401000976562e+02 6.9630302429199219e+01 -7.0690101623535156e+01 -1.4925700378417969e+02 6.9500297546386719e+01 -6.0814899444580078e+01 -1.4954299926757812e+02 6.9639396667480469e+01 -6.0852699279785156e+01 -1.4944000244140625e+02 6.9553703308105469e+01 -6.0839199066162109e+01 -1.4943600463867188e+02 6.9552398681640625e+01 -6.0838600158691406e+01 -1.4961099243164062e+02 6.9754501342773438e+01 -6.0861801147460938e+01 -1.4957598876953125e+02 6.9694900512695312e+01 -6.0857097625732422e+01 -1.4562701416015625e+02 6.9694900512695312e+01 -6.0836399078369141e+01 -1.4559201049804688e+02 6.9754501342773438e+01 -6.0831199645996094e+01 -1.4594000244140625e+02 6.9500495910644531e+01 -6.0882698059082031e+01 -1.4576699829101562e+02 6.9552299499511719e+01 -6.0857097625732422e+01 -1.4576199340820312e+02 6.9553596496582031e+01 -6.0856399536132812e+01 -1.4566000366210938e+02 6.9639396667480469e+01 -6.0841300964355469e+01 -1.4960700988769531e+02 6.9691894531250000e+01 -6.0542900085449219e+01 -1.4946200561523438e+02 6.9551300048828125e+01 -6.0532997131347656e+01 -1.4963099670410156e+02 6.9691894531250000e+01 -5.9893898010253906e+01 -1.4961099243164062e+02 6.9691894531250000e+01 -5.9243103027343750e+01 -1.4954400634765625e+02 6.9691894531250000e+01 -5.8593997955322266e+01 -1.4954400634765625e+02 6.9691894531250000e+01 -5.8593898773193359e+01 -1.4939999389648438e+02 6.9551300048828125e+01 -5.8614101409912109e+01 -1.4948500061035156e+02 6.9551300048828125e+01 -5.9893398284912109e+01 -1.4946499633789062e+02 6.9551300048828125e+01 -5.9252700805664062e+01 -1.4939999389648438e+02 6.9551300048828125e+01 -5.8614200592041016e+01 -1.4578599548339844e+02 6.9551300048828125e+01 -6.0682300567626953e+01 -1.4564100646972656e+02 6.9691894531250000e+01 -6.0667800903320312e+01 -1.4580899047851562e+02 6.9551300048828125e+01 -6.0369998931884766e+01 -1.4581399536132812e+02 6.9551300048828125e+01 -6.0058502197265625e+01 -1.4579699707031250e+02 6.9551300048828125e+01 -5.9749202728271484e+01 -1.4566400146484375e+02 6.9691894531250000e+01 -6.0363502502441406e+01 -1.4566799926757812e+02 6.9691894531250000e+01 -6.0061100006103516e+01 -1.4565199279785156e+02 6.9691894531250000e+01 -5.9762397766113281e+01 -1.4906700134277344e+02 6.9551300048828125e+01 -5.7336597442626953e+01 -1.4877600097656250e+02 6.9551300048828125e+01 -5.6740501403808594e+01 -1.4920201110839844e+02 6.9691894531250000e+01 -5.7282299041748047e+01 -1.4890199279785156e+02 6.9691894531250000e+01 -5.6667301177978516e+01 -1.4940998840332031e+02 6.9691894531250000e+01 -5.7916500091552734e+01 -1.4926899719238281e+02 6.9551300048828125e+01 -5.7953102111816406e+01 -1.4558898925781250e+02 6.9691894531250000e+01 -5.9380798339843750e+01 -1.4573100280761719e+02 6.9551300048828125e+01 -5.9345802307128906e+01 -1.4551000976562500e+02 6.9691894531250000e+01 -5.9129302978515625e+01 -1.4564601135253906e+02 6.9551300048828125e+01 -5.9076702117919922e+01 -1.4540000915527344e+02 6.9691894531250000e+01 -5.8895500183105469e+01 -1.4552700805664062e+02 6.9551300048828125e+01 -5.8823997497558594e+01 -1.4800299072265625e+02 6.9551300048828125e+01 -5.5821197509765625e+01 -1.4747399902343750e+02 6.9551300048828125e+01 -5.5452701568603516e+01 -1.4809599304199219e+02 6.9691894531250000e+01 -5.5709499359130859e+01 -1.4754701232910156e+02 6.9691894531250000e+01 -5.5326599121093750e+01 -1.4855700683593750e+02 6.9691894531250000e+01 -5.6172298431396484e+01 -1.4844499206542969e+02 6.9551300048828125e+01 -5.6265296936035156e+01 -1.4520500183105469e+02 6.9691894531250000e+01 -5.8626201629638672e+01 -1.4531199645996094e+02 6.9551300048828125e+01 -5.8527702331542969e+01 -1.4501899719238281e+02 6.9691894531250000e+01 -5.8454902648925781e+01 -1.4510800170898438e+02 6.9551300048828125e+01 -5.8340099334716797e+01 -1.4478300476074219e+02 6.9691894531250000e+01 -5.8300800323486328e+01 -1.4485299682617188e+02 6.9551300048828125e+01 -5.8172901153564453e+01 -1.4536100769042969e+02 6.9501701354980469e+01 -5.5100097656250000e+01 -1.4536399841308594e+02 6.9553596496582031e+01 -5.4936901092529297e+01 -1.4536399841308594e+02 6.9552200317382812e+01 -5.4941299438476562e+01 -1.4549400329589844e+02 6.9551300048828125e+01 -5.4945201873779297e+01 -1.4536698913574219e+02 6.9754501342773438e+01 -5.4764400482177734e+01 -1.4536599731445312e+02 6.9694900512695312e+01 -5.4800201416015625e+01 -1.4550000000000000e+02 6.9691894531250000e+01 -5.4799602508544922e+01 -1.4536500549316406e+02 6.9639396667480469e+01 -5.4833499908447266e+01 -1.4643199157714844e+02 6.9551300048828125e+01 -5.5060901641845703e+01 -1.4696499633789062e+02 6.9551300048828125e+01 -5.5215198516845703e+01 -1.4646301269531250e+02 6.9691894531250000e+01 -5.4918502807617188e+01 -1.4701499938964844e+02 6.9691894531250000e+01 -5.5078498840332031e+01 -1.4372799682617188e+02 6.9754501342773438e+01 -5.8094898223876953e+01 -1.4379499816894531e+02 6.9551300048828125e+01 -5.7920299530029297e+01 -1.4373300170898438e+02 6.9552101135253906e+01 -5.7918102264404297e+01 -1.4373300170898438e+02 6.9553596496582031e+01 -5.7922500610351562e+01 -1.4372999572753906e+02 6.9639396667480469e+01 -5.8025798797607422e+01 -1.4379000854492188e+02 6.9691894531250000e+01 -5.8065898895263672e+01 -1.4372900390625000e+02 6.9694900512695312e+01 -5.8059200286865234e+01 -1.4373699951171875e+02 6.9502693176269531e+01 -5.7768798828125000e+01 -1.4418399047851562e+02 6.9691894531250000e+01 -5.8104900360107422e+01 -1.4455300903320312e+02 6.9691894531250000e+01 -5.8198398590087891e+01 -1.4478300476074219e+02 6.9691894531250000e+01 -5.8300701141357422e+01 -1.4420799255371094e+02 6.9551300048828125e+01 -5.7961200714111328e+01 -1.4460200500488281e+02 6.9551300048828125e+01 -5.8061100006103516e+01 -1.4368099975585938e+02 6.9691894531250000e+01 -5.5051097869873047e+01 -1.4303100585937500e+02 6.9691894531250000e+01 -5.5328201293945312e+01 -1.4309799194335938e+02 6.9551300048828125e+01 -5.5457500457763672e+01 -1.4505900573730469e+02 6.9691894531250000e+01 -5.4800102233886719e+01 -1.4506498718261719e+02 6.9551300048828125e+01 -5.4945598602294922e+01 -1.4436399841308594e+02 6.9691894531250000e+01 -5.4875999450683594e+01 -1.4438900756835938e+02 6.9551300048828125e+01 -5.5019401550292969e+01 -1.4372799682617188e+02 6.9551300048828125e+01 -5.5189098358154297e+01 -1.4345700073242188e+02 6.9551300048828125e+01 -5.7918701171875000e+01 -1.4346200561523438e+02 6.9691894531250000e+01 -5.8064300537109375e+01 -1.4294599914550781e+02 6.9551300048828125e+01 -5.7971500396728516e+01 -1.4245100402832031e+02 6.9551300048828125e+01 -5.8099002838134766e+01 -1.4198599243164062e+02 6.9551300048828125e+01 -5.8304599761962891e+01 -1.4297099304199219e+02 6.9691894531250000e+01 -5.8115001678466797e+01 -1.4249899291992188e+02 6.9691894531250000e+01 -5.8236801147460938e+01 -1.4205500793457031e+02 6.9691894531250000e+01 -5.8432498931884766e+01 -1.4065299987792969e+02 6.9597404479980469e+01 -5.7618099212646484e+01 -1.4069099426269531e+02 6.9586700439453125e+01 -5.7600402832031250e+01 -1.4066400146484375e+02 6.9601295471191406e+01 -5.7595100402832031e+01 -1.4037100219726562e+02 6.9500000000000000e+01 -5.8186298370361328e+01 -1.4103199768066406e+02 6.9839904785156250e+01 -5.6853599548339844e+01 -1.4141200256347656e+02 6.9691894531250000e+01 -5.6525497436523438e+01 -1.4101300048828125e+02 6.9788597106933594e+01 -5.6891696929931641e+01 -1.4094999694824219e+02 6.9700004577636719e+01 -5.7019401550292969e+01 -1.4093699645996094e+02 6.9695602416992188e+01 -5.7045299530029297e+01 -1.4151499938964844e+02 6.9551300048828125e+01 -5.6628398895263672e+01 -1.4200100708007812e+02 6.9551300048828125e+01 -5.6185398101806641e+01 -1.4253099060058594e+02 6.9551300048828125e+01 -5.5792701721191406e+01 -1.4190899658203125e+02 6.9691894531250000e+01 -5.6072998046875000e+01 -1.4245001220703125e+02 6.9691894531250000e+01 -5.5671401977539062e+01 -1.4075300598144531e+02 6.9757698059082031e+01 -5.9558101654052734e+01 -1.4069200134277344e+02 6.9645500183105469e+01 -5.9529399871826172e+01 -1.4071800231933594e+02 6.9694602966308594e+01 -5.9541900634765625e+01 -1.4107600402832031e+02 6.9691894531250000e+01 -5.9163600921630859e+01 -1.4058500671386719e+02 6.9553504943847656e+01 -5.9479198455810547e+01 -1.4059899902343750e+02 6.9559799194335938e+01 -5.9486000061035156e+01 -1.4097399902343750e+02 6.9551300048828125e+01 -5.9059299468994141e+01 -1.4048300170898438e+02 6.9509399414062500e+01 -5.9431301116943359e+01 -1.4040699768066406e+02 6.9500000000000000e+01 -5.9395500183105469e+01 -1.4154200744628906e+02 6.9691894531250000e+01 -5.8763298034667969e+01 -1.4145500183105469e+02 6.9551300048828125e+01 -5.8646701812744141e+01 -1.4198500061035156e+02 6.9551300048828125e+01 -5.8304702758789062e+01 -1.4224099731445312e+02 6.9884796142578125e+01 -4.8388000488281250e+01 -1.4229899597167969e+02 7.0308403015136719e+01 -4.8372501373291016e+01 -1.4231500244140625e+02 6.9882202148437500e+01 -4.8404602050781250e+01 -1.4238700866699219e+02 7.0309600830078125e+01 -4.8415500640869141e+01 -1.4237500000000000e+02 6.9880096435546875e+01 -4.8418201446533203e+01 -1.4238099670410156e+02 6.9880096435546875e+01 -4.8422702789306641e+01 -1.4248498535156250e+02 7.0310798645019531e+01 -4.8463199615478516e+01 -1.4251300048828125e+02 6.9877998352050781e+01 -4.8525600433349609e+01 -1.4259199523925781e+02 6.9880302429199219e+01 -4.8686702728271484e+01 -1.4260299682617188e+02 7.0309799194335938e+01 -4.8667098999023438e+01 -1.4259199523925781e+02 6.9880096435546875e+01 -4.8681598663330078e+01 -1.4260099792480469e+02 7.0310195922851562e+01 -4.8634799957275391e+01 -1.4252200317382812e+02 7.0310699462890625e+01 -4.8517101287841797e+01 -1.4254200744628906e+02 6.9697097778320312e+01 -4.8845298767089844e+01 -1.4253999328613281e+02 6.9691894531250000e+01 -4.8845100402832031e+01 -1.4239999389648438e+02 6.9554199218750000e+01 -4.8817703247070312e+01 -1.4239700317382812e+02 6.9551300048828125e+01 -4.8817096710205078e+01 -1.3878799438476562e+02 6.9691894531250000e+01 -7.0496498107910156e+01 -1.3864399719238281e+02 6.9551300048828125e+01 -7.0471199035644531e+01 -1.3864700317382812e+02 6.9553802490234375e+01 -7.0471603393554688e+01 -1.3878900146484375e+02 6.9696594238281250e+01 -7.0496704101562500e+01 -1.3863099670410156e+02 6.9882301330566406e+01 -7.0794204711914062e+01 -1.3864199829101562e+02 7.0308700561523438e+01 -7.0803901672363281e+01 -1.3865399169921875e+02 6.9882301330566406e+01 -7.0774803161621094e+01 -1.3866400146484375e+02 7.0308898925781250e+01 -7.0798004150390625e+01 -1.3877200317382812e+02 6.9882301330566406e+01 -7.0675697326660156e+01 -1.3877799987792969e+02 7.0308601379394531e+01 -7.0683998107910156e+01 -1.3879199218750000e+02 6.9883300781250000e+01 -7.0628501892089844e+01 -1.3880999755859375e+02 7.0308601379394531e+01 -7.0651802062988281e+01 -1.3848799133300781e+02 6.9885200500488281e+01 -7.0827995300292969e+01 -1.3856500244140625e+02 6.9883598327636719e+01 -7.0809799194335938e+01 -1.4220500183105469e+02 6.9559204101562500e+01 -4.8587501525878906e+01 -1.4220500183105469e+02 6.9510902404785156e+01 -4.8686702728271484e+01 -1.4239599609375000e+02 6.9561401367187500e+01 -4.8686702728271484e+01 -1.4220500183105469e+02 6.9695701599121094e+01 -4.8442600250244141e+01 -1.4220500183105469e+02 6.9586906433105469e+01 -4.8530700683593750e+01 -1.4235900878906250e+02 6.9627502441406250e+01 -4.8530700683593750e+01 -1.4247299194335938e+02 6.9738700866699219e+01 -4.8530700683593750e+01 -1.4235700988769531e+02 6.9808197021484375e+01 -4.8421497344970703e+01 -1.4229199218750000e+02 6.9744804382324219e+01 -4.8421497344970703e+01 -1.4220500183105469e+02 6.9721801757812500e+01 -4.8421497344970703e+01 -1.4253799438476562e+02 6.9699600219726562e+01 -4.8686702728271484e+01 -1.3862300109863281e+02 6.9595901489257812e+01 -7.0632003784179688e+01 -1.3875100708007812e+02 6.9720100402832031e+01 -7.0632003784179688e+01 -1.3862899780273438e+02 6.9793403625488281e+01 -7.0779396057128906e+01 -1.3855299377441406e+02 6.9719902038574219e+01 -7.0779396057128906e+01 -1.3845098876953125e+02 6.9693000793457031e+01 -7.0779396057128906e+01 -1.3845098876953125e+02 6.9692199707031250e+01 -7.0778495788574219e+01 -1.3845098876953125e+02 6.9551498413085938e+01 -7.0632797241210938e+01 -1.3845098876953125e+02 6.9550697326660156e+01 -7.0632003784179688e+01 -1.3874499511718750e+02 6.9882202148437500e+01 -4.8422702789306641e+01 -1.3873399353027344e+02 7.0308700561523438e+01 -4.8412899017333984e+01 -1.3872300720214844e+02 6.9882202148437500e+01 -4.8441802978515625e+01 -1.3871299743652344e+02 7.0308998107910156e+01 -4.8418601989746094e+01 -1.3860400390625000e+02 6.9882202148437500e+01 -4.8541698455810547e+01 -1.3859799194335938e+02 7.0308601379394531e+01 -4.8533302307128906e+01 -1.3858399963378906e+02 6.9883300781250000e+01 -4.8588100433349609e+01 -1.3856600952148438e+02 7.0308601379394531e+01 -4.8564899444580078e+01 -1.3888800048828125e+02 6.9885200500488281e+01 -4.8388702392578125e+01 -1.3881100463867188e+02 6.9883598327636719e+01 -4.8406997680664062e+01 -1.3892500305175781e+02 6.9693000793457031e+01 -4.8437301635742188e+01 -1.3892500305175781e+02 6.9692199707031250e+01 -4.8438098907470703e+01 -1.3892500305175781e+02 6.9551498413085938e+01 -4.8583900451660156e+01 -1.3892500305175781e+02 6.9550697326660156e+01 -4.8584701538085938e+01 -1.3517500305175781e+02 6.9723602294921875e+01 -7.0796104431152344e+01 -1.3517500305175781e+02 6.9695800781250000e+01 -7.0773994445800781e+01 -1.3517500305175781e+02 6.9589500427246094e+01 -7.0689300537109375e+01 -1.3517500305175781e+02 6.9512397766113281e+01 -7.0536102294921875e+01 -1.3517500305175781e+02 6.9559204101562500e+01 -7.0628997802734375e+01 -1.3513900756835938e+02 6.9884796142578125e+01 -7.0828804016113281e+01 -1.3508898925781250e+02 7.0308296203613281e+01 -7.0845703125000000e+01 -1.3506600952148438e+02 6.9882301330566406e+01 -7.0812599182128906e+01 -1.3499400329589844e+02 7.0309494018554688e+01 -7.0802001953125000e+01 -1.3500599670410156e+02 6.9880401611328125e+01 -7.0799301147460938e+01 -1.3500000000000000e+02 6.9880203247070312e+01 -7.0794898986816406e+01 -1.3490100097656250e+02 7.0310699462890625e+01 -7.0758903503417969e+01 -1.3486898803710938e+02 6.9878303527832031e+01 -7.0694297790527344e+01 -1.3478900146484375e+02 6.9880500793457031e+01 -7.0536102294921875e+01 -1.3477900695800781e+02 7.0309600830078125e+01 -7.0555595397949219e+01 -1.3478900146484375e+02 6.9880401611328125e+01 -7.0541297912597656e+01 -1.3478199768066406e+02 7.0310195922851562e+01 -7.0589897155761719e+01 -1.3486100769042969e+02 7.0310501098632812e+01 -7.0702392578125000e+01 -1.3874800109863281e+02 6.9793403625488281e+01 -4.8437301635742188e+01 -1.3862599182128906e+02 6.9720100402832031e+01 -4.8584701538085938e+01 -1.3873199462890625e+02 6.9551300048828125e+01 -4.8746196746826172e+01 -1.3875299072265625e+02 6.9595901489257812e+01 -4.8584701538085938e+01 -1.3872900390625000e+02 6.9553703308105469e+01 -4.8745700836181641e+01 -1.3858799743652344e+02 6.9691894531250000e+01 -4.8721298217773438e+01 -1.3858700561523438e+02 6.9696502685546875e+01 -4.8721099853515625e+01 -1.3882299804687500e+02 6.9719902038574219e+01 -4.8437301635742188e+01 -1.3502299499511719e+02 6.9809104919433594e+01 -7.0796104431152344e+01 -1.3490800476074219e+02 6.9739997863769531e+01 -7.0689300537109375e+01 -1.3484199523925781e+02 6.9700401306152344e+01 -7.0536102294921875e+01 -1.3483700561523438e+02 6.9696502685546875e+01 -7.0378494262695312e+01 -1.3498100280761719e+02 6.9551300048828125e+01 -7.0403594970703125e+01 -1.3497898864746094e+02 6.9553703308105469e+01 -7.0403205871582031e+01 -1.3498400878906250e+02 6.9562705993652344e+01 -7.0536102294921875e+01 -1.3483799743652344e+02 6.9691894531250000e+01 -7.0378799438476562e+01 -1.3508799743652344e+02 6.9746498107910156e+01 -7.0796104431152344e+01 -1.3502200317382812e+02 6.9629806518554688e+01 -7.0689300537109375e+01 -1.3284100341796875e+02 7.0309402465820312e+01 -6.5400505065917969e+01 -1.3285299682617188e+02 7.0011398315429688e+01 -6.5420600891113281e+01 -1.3286300659179688e+02 7.0309600830078125e+01 -6.5412994384765625e+01 -1.3298899841308594e+02 7.0009498596191406e+01 -6.5521903991699219e+01 -1.3309300231933594e+02 7.0309196472167969e+01 -6.5695198059082031e+01 -1.3308000183105469e+02 7.0309600830078125e+01 -6.5661399841308594e+01 -1.3307200622558594e+02 7.0011398315429688e+01 -6.5670806884765625e+01 -1.3304400634765625e+02 7.0310501098632812e+01 -6.5569900512695312e+01 -1.3295700073242188e+02 7.0310501098632812e+01 -6.5467796325683594e+01 -1.3306700134277344e+02 6.9880798339843750e+01 -6.5681602478027344e+01 -1.3285499572753906e+02 6.9880401611328125e+01 -6.5430999755859375e+01 -1.3298399353027344e+02 6.9878601074218750e+01 -6.5526596069335938e+01 -1.3306700134277344e+02 6.9880500793457031e+01 -6.5675697326660156e+01 -1.3268899536132812e+02 6.9885704040527344e+01 -6.5390403747558594e+01 -1.3270401000976562e+02 6.9885093688964844e+01 -6.5391098022460938e+01 -1.3272000122070312e+02 6.9884498596191406e+01 -6.5391899108886719e+01 -1.3272399902343750e+02 6.9884399414062500e+01 -6.5392097473144531e+01 -1.3276599121093750e+02 6.9882896423339844e+01 -6.5398696899414062e+01 -1.3284700012207031e+02 6.9880500793457031e+01 -6.5425300598144531e+01 -1.3302198791503906e+02 6.9691894531250000e+01 -6.5837394714355469e+01 -1.3303099060058594e+02 6.9723197937011719e+01 -6.5838699340820312e+01 -1.3302799987792969e+02 6.9726600646972656e+01 -6.5681503295898438e+01 -1.3276800537109375e+02 6.9524101257324219e+01 -6.5681503295898438e+01 -1.3275000000000000e+02 6.9600898742675781e+01 -6.5532699584960938e+01 -1.3268299865722656e+02 6.9527404785156250e+01 -6.5684799194335938e+01 -1.3268199157714844e+02 6.9551300048828125e+01 -6.5593803405761719e+01 -1.3268099975585938e+02 6.9691894531250000e+01 -6.5448097229003906e+01 -1.3272200012207031e+02 6.9730499267578125e+01 -6.5429397583007812e+01 -1.3268099975585938e+02 6.9728904724121094e+01 -6.5437103271484375e+01 -1.3283898925781250e+02 6.9821800231933594e+01 -6.5429397583007812e+01 -1.3295799255371094e+02 6.9762001037597656e+01 -6.5532699584960938e+01 -1.3276800537109375e+02 6.9522094726562500e+01 -6.5801597595214844e+01 -1.3287800598144531e+02 6.9551300048828125e+01 -6.5817100524902344e+01 -1.3291999816894531e+02 6.9596099853515625e+01 -6.5681503295898438e+01 -1.3287199401855469e+02 6.9658195495605469e+01 -6.5532699584960938e+01 -1.3279100036621094e+02 6.9763000488281250e+01 -6.5429397583007812e+01 -1.2957000732421875e+02 6.9885597229003906e+01 -6.5418304443359375e+01 -1.2924400329589844e+02 7.0307998657226562e+01 -6.5589103698730469e+01 -1.2944898986816406e+02 7.0308296203613281e+01 -6.5422203063964844e+01 -1.2941900634765625e+02 7.0308403015136719e+01 -6.5439002990722656e+01 -1.2942500305175781e+02 7.0005500793457031e+01 -6.5445701599121094e+01 -1.2933200073242188e+02 7.0308601379394531e+01 -6.5488197326660156e+01 -1.2929100036621094e+02 7.0005500793457031e+01 -6.5546195983886719e+01 -1.2928700256347656e+02 7.0308296203613281e+01 -6.5539802551269531e+01 -1.2949700927734375e+02 6.9884300231933594e+01 -6.5434600830078125e+01 -1.2925399780273438e+02 6.9884498596191406e+01 -6.5622596740722656e+01 -1.2929399108886719e+02 6.9882995605468750e+01 -6.5550300598144531e+01 -1.2939299011230469e+02 6.9882995605468750e+01 -6.5476402282714844e+01 -1.2942799377441406e+02 6.9882995605468750e+01 -6.5449897766113281e+01 -1.2959300231933594e+02 6.9692901611328125e+01 -6.5471199035644531e+01 -1.2959300231933594e+02 6.9691894531250000e+01 -6.5471405029296875e+01 -1.2959399414062500e+02 6.9551300048828125e+01 -6.5617095947265625e+01 -1.2959399414062500e+02 6.9550903320312500e+01 -6.5618400573730469e+01 -1.3275599670410156e+02 6.9551300048828125e+01 -6.6439102172851562e+01 -1.3289700317382812e+02 6.9691894531250000e+01 -6.6475303649902344e+01 -1.3268299865722656e+02 6.9691894531250000e+01 -6.7132400512695312e+01 -1.3254800415039062e+02 6.9551300048828125e+01 -6.7078598022460938e+01 -1.3238499450683594e+02 6.9691894531250000e+01 -6.7757705688476562e+01 -1.3225799560546875e+02 6.9551300048828125e+01 -6.7686401367187500e+01 -1.2941799926757812e+02 6.9792594909667969e+01 -6.5470893859863281e+01 -1.2929600524902344e+02 6.9718894958496094e+01 -6.5618301391601562e+01 -1.2940800476074219e+02 6.9551300048828125e+01 -6.5756095886230469e+01 -1.2942500305175781e+02 6.9594802856445312e+01 -6.5618301391601562e+01 -1.2940399169921875e+02 6.9555297851562500e+01 -6.5754898071289062e+01 -1.2926800537109375e+02 6.9691894531250000e+01 -6.5713798522949219e+01 -1.2926599121093750e+02 6.9699798583984375e+01 -6.5713096618652344e+01 -1.2949400329589844e+02 6.9719001770019531e+01 -6.5470893859863281e+01 -1.3180300903320312e+02 6.9691894531250000e+01 -6.8623497009277344e+01 -1.3168899536132812e+02 6.9551300048828125e+01 -6.8532493591308594e+01 -1.3134999084472656e+02 6.9691894531250000e+01 -6.9128700256347656e+01 -1.3124699401855469e+02 6.9551300048828125e+01 -6.9025596618652344e+01 -1.3084500122070312e+02 6.9691894531250000e+01 -6.9580398559570312e+01 -1.3075399780273438e+02 6.9551300048828125e+01 -6.9466598510742188e+01 -1.2830899047851562e+02 6.9691894531250000e+01 -6.7191200256347656e+01 -1.2908200073242188e+02 6.9551300048828125e+01 -6.6502601623535156e+01 -1.2840299987792969e+02 6.9551300048828125e+01 -6.7302894592285156e+01 -1.2840299987792969e+02 6.9551300048828125e+01 -6.7302803039550781e+01 -1.2895700073242188e+02 6.9692001342773438e+01 -6.6428398132324219e+01 -1.2993699645996094e+02 6.9691894531250000e+01 -7.0189903259277344e+01 -1.2986599731445312e+02 6.9551300048828125e+01 -7.0062599182128906e+01 -1.2933500671386719e+02 6.9691894531250000e+01 -7.0486999511718750e+01 -1.2927700805664062e+02 6.9551300048828125e+01 -7.0353302001953125e+01 -1.2870899963378906e+02 6.9691894531250000e+01 -7.0724098205566406e+01 -1.2866400146484375e+02 6.9551300048828125e+01 -7.0585601806640625e+01 -1.2664399719238281e+02 6.9691894531250000e+01 -6.7827796936035156e+01 -1.2633399963378906e+02 6.9553596496582031e+01 -6.7973899841308594e+01 -1.2633399963378906e+02 6.9552200317382812e+01 -6.7978302001953125e+01 -1.2665299987792969e+02 6.9551300048828125e+01 -6.7973297119140625e+01 -1.2633100128173828e+02 6.9502197265625000e+01 -6.8131401062011719e+01 -1.2633700561523438e+02 6.9639396667480469e+01 -6.7870605468750000e+01 -1.2633700561523438e+02 6.9694900512695312e+01 -6.7837203979492188e+01 -1.2633800506591797e+02 6.9754501342773438e+01 -6.7801399230957031e+01 -1.2753300476074219e+02 6.9692001342773438e+01 -6.7645805358886719e+01 -1.2758499145507812e+02 6.9551300048828125e+01 -6.7782203674316406e+01 -1.2754699707031250e+02 6.9691894531250000e+01 -7.1001701354980469e+01 -1.2752500152587891e+02 6.9551300048828125e+01 -7.0857704162597656e+01 -1.2688599395751953e+02 6.9691894531250000e+01 -7.1073097229003906e+01 -1.2687699127197266e+02 6.9551300048828125e+01 -7.0927597045898438e+01 -1.2622399902343750e+02 6.9691894531250000e+01 -7.1086402893066406e+01 -1.2622700500488281e+02 6.9551300048828125e+01 -7.0940704345703125e+01 -1.2525000000000000e+02 6.9551300048828125e+01 -6.7741996765136719e+01 -1.2480799865722656e+02 6.9551300048828125e+01 -6.7418800354003906e+01 -1.2531499481201172e+02 6.9691894531250000e+01 -6.7611999511718750e+01 -1.2491200256347656e+02 6.9691894531250000e+01 -6.7317298889160156e+01 -1.2594599914550781e+02 6.9691894531250000e+01 -6.7802200317382812e+01 -1.2592500305175781e+02 6.9551300048828125e+01 -6.7946395874023438e+01 -1.2504300689697266e+02 6.9551300048828125e+01 -7.0824195861816406e+01 -1.2501700592041016e+02 6.9691894531250000e+01 -7.0967597961425781e+01 -1.2332999420166016e+02 6.9691894531250000e+01 -7.0392799377441406e+01 -1.2415599822998047e+02 6.9691894531250000e+01 -7.0749496459960938e+01 -1.2340000152587891e+02 6.9551300048828125e+01 -7.0264801025390625e+01 -1.2420199584960938e+02 6.9551300048828125e+01 -7.0611297607421875e+01 -1.2431099700927734e+02 6.9551300048828125e+01 -6.6700401306152344e+01 -1.2412100219726562e+02 6.9551300048828125e+01 -6.6158798217773438e+01 -1.2444300079345703e+02 6.9691894531250000e+01 -6.6638496398925781e+01 -1.2426200103759766e+02 6.9691894531250000e+01 -6.6123802185058594e+01 -1.2464900207519531e+02 6.9691894531250000e+01 -6.6997604370117188e+01 -1.2452999877929688e+02 6.9551300048828125e+01 -6.7080398559570312e+01 -1.2231100463867188e+02 6.9691894531250000e+01 -6.9691101074218750e+01 -1.2340000152587891e+02 6.9551300048828125e+01 -7.0264694213867188e+01 -1.2240599822998047e+02 6.9551300048828125e+01 -6.9581001281738281e+01 -1.2181900024414062e+02 6.9691894531250000e+01 -6.9205299377441406e+01 -1.2192800140380859e+02 6.9551300048828125e+01 -6.9108596801757812e+01 -1.2139499664306641e+02 6.9691894531250000e+01 -6.8660400390625000e+01 -1.2151499938964844e+02 6.9551300048828125e+01 -6.8578399658203125e+01 -1.2397499847412109e+02 6.9551300048828125e+01 -6.5084297180175781e+01 -1.2397499847412109e+02 6.9551300048828125e+01 -6.4624397277832031e+01 -1.2411999511718750e+02 6.9691894531250000e+01 -6.5079002380371094e+01 -1.2412100219726562e+02 6.9691894531250000e+01 -6.4629699707031250e+01 -1.2415399932861328e+02 6.9691894531250000e+01 -6.5521598815917969e+01 -1.2400899505615234e+02 6.9551300048828125e+01 -6.5538597106933594e+01 -1.2103600311279297e+02 6.9691894531250000e+01 -6.8062400817871094e+01 -1.2116500091552734e+02 6.9551300048828125e+01 -6.7994400024414062e+01 -1.2074800109863281e+02 6.9691894531250000e+01 -6.7437698364257812e+01 -1.2088300323486328e+02 6.9551300048828125e+01 -6.7383697509765625e+01 -1.2037400054931641e+02 6.9691894531250000e+01 -6.6169700622558594e+01 -1.2051699829101562e+02 6.9551300048828125e+01 -6.6140899658203125e+01 -1.2407700347900391e+02 6.9550605773925781e+01 -6.3158401489257812e+01 -1.2403699493408203e+02 6.9551300048828125e+01 -6.3585697174072266e+01 -1.2407899475097656e+02 6.9551300048828125e+01 -6.3158599853515625e+01 -1.2422299957275391e+02 6.9691101074218750e+01 -6.3174003601074219e+01 -1.2418199920654297e+02 6.9691894531250000e+01 -6.3598094940185547e+01 -1.2422399902343750e+02 6.9691894531250000e+01 -6.3174098968505859e+01 -1.2415100097656250e+02 6.9691894531250000e+01 -6.4024406433105469e+01 -1.2400499725341797e+02 6.9551300048828125e+01 -6.4015296936035156e+01 -1.2039200592041016e+02 6.9551300048828125e+01 -6.5319503784179688e+01 -1.2024700164794922e+02 6.9691894531250000e+01 -6.5334899902343750e+01 -1.2019499969482422e+02 6.9691894531250000e+01 -6.4500305175781250e+01 -1.2034100341796875e+02 6.9551300048828125e+01 -6.4497596740722656e+01 -1.2025099945068359e+02 6.9691894531250000e+01 -6.3205196380615234e+01 -1.2039600372314453e+02 6.9551300048828125e+01 -6.3220100402832031e+01 -1.2411999511718750e+02 6.9551605224609375e+01 -6.2745601654052734e+01 -1.2395499420166016e+02 6.9500900268554688e+01 -6.2726100921630859e+01 -1.2426200103759766e+02 6.9693901062011719e+01 -6.2762298583984375e+01 -1.2422999572753906e+02 6.9639396667480469e+01 -6.2758499145507812e+01 -1.2412699890136719e+02 6.9553596496582031e+01 -6.2746299743652344e+01 -1.2412300109863281e+02 6.9552200317382812e+01 -6.2745899200439453e+01 -1.2429899597167969e+02 6.9754501342773438e+01 -6.2766597747802734e+01 -1.2426300048828125e+02 6.9694900512695312e+01 -6.2762401580810547e+01 -1.2026399993896484e+02 6.9754501342773438e+01 -6.2777599334716797e+01 -1.2030000305175781e+02 6.9694900512695312e+01 -6.2781497955322266e+01 -1.2033300018310547e+02 6.9639396667480469e+01 -6.2785095214843750e+01 -1.2043599700927734e+02 6.9553596496582031e+01 -6.2796302795410156e+01 -1.2044000244140625e+02 6.9552200317382812e+01 -6.2796802520751953e+01 -1.2059700012207031e+02 6.9501800537109375e+01 -6.2813899993896484e+01 -1.2431199645996094e+02 6.9551300048828125e+01 -6.1675399780273438e+01 -1.2445899963378906e+02 6.9551300048828125e+01 -6.1080398559570312e+01 -1.2445499420166016e+02 6.9691894531250000e+01 -6.1707000732421875e+01 -1.2459999847412109e+02 6.9691894531250000e+01 -6.1118202209472656e+01 -1.2433700561523438e+02 6.9691894531250000e+01 -6.2300399780273438e+01 -1.2419400024414062e+02 6.9551300048828125e+01 -6.2275802612304688e+01 -1.2053099822998047e+02 6.9551300048828125e+01 -6.2158599853515625e+01 -1.2038800048828125e+02 6.9691894531250000e+01 -6.2134002685546875e+01 -1.2067600250244141e+02 6.9691894531250000e+01 -6.0881000518798828e+01 -1.2081600189208984e+02 6.9551300048828125e+01 -6.0921798706054688e+01 -1.2111000061035156e+02 6.9691894531250000e+01 -5.9668800354003906e+01 -1.2124399566650391e+02 6.9551300048828125e+01 -5.9725799560546875e+01 -1.2486899566650391e+02 6.9551300048828125e+01 -5.9979301452636719e+01 -1.2513700103759766e+02 6.9551300048828125e+01 -5.9496398925781250e+01 -1.2500000000000000e+02 6.9691894531250000e+01 -6.0043498992919922e+01 -1.2526099395751953e+02 6.9691894531250000e+01 -5.9573501586914062e+01 -1.2478800201416016e+02 6.9691894531250000e+01 -6.0534297943115234e+01 -1.2465100097656250e+02 6.9551300048828125e+01 -6.0482799530029297e+01 -1.2111000061035156e+02 6.9691894531250000e+01 -5.9668701171875000e+01 -1.2161900329589844e+02 6.9551300048828125e+01 -5.8944499969482422e+01 -1.2206500244140625e+02 6.9551300048828125e+01 -5.8208999633789062e+01 -1.2287099456787109e+02 6.9551300048828125e+01 -5.7198600769042969e+01 -1.2149099731445312e+02 6.9691894531250000e+01 -5.8875099182128906e+01 -1.2194499969482422e+02 6.9691894531250000e+01 -5.8127300262451172e+01 -1.2276399993896484e+02 6.9691894531250000e+01 -5.7099201202392578e+01 -1.2587699127197266e+02 6.9551300048828125e+01 -5.8635398864746094e+01 -1.2630001068115234e+02 6.9551300048828125e+01 -5.8326099395751953e+01 -1.2597100067138672e+02 6.9691894531250000e+01 -5.8746501922607422e+01 -1.2637699890136719e+02 6.9691894531250000e+01 -5.8449600219726562e+01 -1.2561999511718750e+02 6.9691894531250000e+01 -5.9091003417968750e+01 -1.2551000976562500e+02 6.9551300048828125e+01 -5.8994503021240234e+01 -1.2339799499511719e+02 6.9691894531250000e+01 -5.6496501922607422e+01 -1.2349200439453125e+02 6.9551300048828125e+01 -5.6607803344726562e+01 -1.2408799743652344e+02 6.9691894531250000e+01 -5.5979999542236328e+01 -1.2416799926757812e+02 6.9551300048828125e+01 -5.6101600646972656e+01 -1.2519900512695312e+02 6.9691894531250000e+01 -5.5374397277832031e+01 -1.2525799560546875e+02 6.9551300048828125e+01 -5.5507499694824219e+01 -1.2772299194335938e+02 6.9691894531250000e+01 -5.8053298950195312e+01 -1.2807600402832031e+02 6.9553596496582031e+01 -5.7907901763916016e+01 -1.2807600402832031e+02 6.9552200317382812e+01 -5.7903499603271484e+01 -1.2771600341796875e+02 6.9551300048828125e+01 -5.7907802581787109e+01 -1.2808300781250000e+02 6.9501098632812500e+01 -5.7737701416015625e+01 -1.2807199096679688e+02 6.9639396667480469e+01 -5.8011199951171875e+01 -1.2807099914550781e+02 6.9694900512695312e+01 -5.8044601440429688e+01 -1.2806900024414062e+02 6.9754501342773438e+01 -5.8080299377441406e+01 -1.2714700317382812e+02 6.9691894531250000e+01 -5.8133697509765625e+01 -1.2711399841308594e+02 6.9551300048828125e+01 -5.7991901397705078e+01 -1.2610700988769531e+02 6.9691894531250000e+01 -5.5051502227783203e+01 -1.2614500427246094e+02 6.9551300048828125e+01 -5.5192001342773438e+01 -1.2702799987792969e+02 6.9691894531250000e+01 -5.4864601135253906e+01 -1.2704800415039062e+02 6.9551300048828125e+01 -5.5009101867675781e+01 -1.2835900878906250e+02 6.9691894531250000e+01 -5.4795299530029297e+01 -1.2835499572753906e+02 6.9551300048828125e+01 -5.4940998077392578e+01 -1.2823800659179688e+02 6.9551300048828125e+01 -5.7914901733398438e+01 -1.2822500610351562e+02 6.9691894531250000e+01 -5.8060001373291016e+01 -1.2854798889160156e+02 6.9691894531250000e+01 -5.8106800079345703e+01 -1.2885501098632812e+02 6.9691894531250000e+01 -5.8190498352050781e+01 -1.2913800048828125e+02 6.9691894531250000e+01 -5.8315299987792969e+01 -1.2857699584960938e+02 6.9551300048828125e+01 -5.7964099884033203e+01 -1.2890299987792969e+02 6.9551300048828125e+01 -5.8053001403808594e+01 -1.2920799255371094e+02 6.9551300048828125e+01 -5.8187202453613281e+01 -1.2920799255371094e+02 6.9551300048828125e+01 -5.8187400817871094e+01 -1.2835598754882812e+02 6.9551300048828125e+01 -5.4940998077392578e+01 -1.2944999694824219e+02 6.9551300048828125e+01 -5.5043800354003906e+01 -1.3010099792480469e+02 6.9551300048828125e+01 -5.5193801879882812e+01 -1.3073199462890625e+02 6.9551300048828125e+01 -5.5420497894287109e+01 -1.2947499084472656e+02 6.9691894531250000e+01 -5.4900199890136719e+01 -1.3014100646972656e+02 6.9691894531250000e+01 -5.5053901672363281e+01 -1.3078999328613281e+02 6.9691894531250000e+01 -5.5286800384521484e+01 -1.2996199035644531e+02 6.9551300048828125e+01 -5.8876201629638672e+01 -1.2996199035644531e+02 6.9551300048828125e+01 -5.8876499176025391e+01 -1.2984100341796875e+02 6.9691894531250000e+01 -5.8956600189208984e+01 -1.2984100341796875e+02 6.9691894531250000e+01 -5.8956703186035156e+01 -1.2965199279785156e+02 6.9551300048828125e+01 -5.8507202148437500e+01 -1.2944099426269531e+02 6.9551300048828125e+01 -5.8333301544189453e+01 -1.2955200195312500e+02 6.9691894531250000e+01 -5.8613300323486328e+01 -1.2935600280761719e+02 6.9691894531250000e+01 -5.8451599121093750e+01 -1.3138999938964844e+02 6.9551300048828125e+01 -5.5760101318359375e+01 -1.3146600341796875e+02 6.9691894531250000e+01 -5.5635696411132812e+01 -1.3207499694824219e+02 6.9691894531250000e+01 -5.6072700500488281e+01 -1.3198100280761719e+02 6.9551300048828125e+01 -5.6184200286865234e+01 -1.3257800292968750e+02 6.9691894531250000e+01 -5.6562900543212891e+01 -1.3246899414062500e+02 6.9551300048828125e+01 -5.6659500122070312e+01 -1.3036000061035156e+02 6.9551300048828125e+01 -5.9838100433349609e+01 -1.3036000061035156e+02 6.9551300048828125e+01 -5.9838298797607422e+01 -1.3021800231933594e+02 6.9691894531250000e+01 -5.9869503021240234e+01 -1.3021800231933594e+02 6.9691894531250000e+01 -5.9869598388671875e+01 -1.3022200012207031e+02 6.9551300048828125e+01 -5.9380199432373047e+01 -1.3010501098632812e+02 6.9551300048828125e+01 -5.9121200561523438e+01 -1.3008599853515625e+02 6.9691894531250000e+01 -5.9433300018310547e+01 -1.2997599792480469e+02 6.9691894531250000e+01 -5.9187900543212891e+01 -1.3292700195312500e+02 6.9551300048828125e+01 -5.7263999938964844e+01 -1.3304998779296875e+02 6.9691894531250000e+01 -5.7185001373291016e+01 -1.3341699218750000e+02 6.9691894531250000e+01 -5.7852500915527344e+01 -1.3328399658203125e+02 6.9551300048828125e+01 -5.7913700103759766e+01 -1.3366799926757812e+02 6.9691894531250000e+01 -5.8490802764892578e+01 -1.3352999877929688e+02 6.9551300048828125e+01 -5.8536602020263672e+01 -1.3046101379394531e+02 7.0008705139160156e+01 -6.0861000061035156e+01 -1.3045599365234375e+02 7.0309196472167969e+01 -6.0874000549316406e+01 -1.3058300781250000e+02 7.0307899475097656e+01 -6.0915702819824219e+01 -1.3027499389648438e+02 7.0308700561523438e+01 -6.0680099487304688e+01 -1.3031100463867188e+02 7.0309104919433594e+01 -6.0733898162841797e+01 -1.3031600952148438e+02 7.0008705139160156e+01 -6.0726898193359375e+01 -1.3034899902343750e+02 7.0309494018554688e+01 -6.0792400360107422e+01 -1.3045098876953125e+02 7.0309196472167969e+01 -6.0870597839355469e+01 -1.3031199645996094e+02 6.9882102966308594e+01 -6.0698699951171875e+01 -1.3053500366210938e+02 6.9883193969726562e+01 -6.0874500274658203e+01 -1.3046499633789062e+02 6.9881599426269531e+01 -6.0856597900390625e+01 -1.3045201110839844e+02 6.9881599426269531e+01 -6.0844997406005859e+01 -1.3031999206542969e+02 6.9881599426269531e+01 -6.0722599029541016e+01 -1.3061599731445312e+02 6.9885093688964844e+01 -6.0895301818847656e+01 -1.3045999145507812e+02 6.9551300048828125e+01 -6.0520500183105469e+01 -1.3044999694824219e+02 6.9551300048828125e+01 -6.0407798767089844e+01 -1.3045899963378906e+02 6.9552398681640625e+01 -6.0520599365234375e+01 -1.3030500793457031e+02 6.9691894531250000e+01 -6.0422100067138672e+01 -1.3031500244140625e+02 6.9691894531250000e+01 -6.0531600952148438e+01 -1.3031401062011719e+02 6.9694694519042969e+01 -6.0531600952148438e+01 -1.3027000427246094e+02 6.9691894531250000e+01 -6.0144199371337891e+01 -1.3041400146484375e+02 6.9551300048828125e+01 -6.0121498107910156e+01 -1.3401800537109375e+02 6.9694305419921875e+01 -6.0492401123046875e+01 -1.3387300109863281e+02 6.9552200317382812e+01 -6.0498001098632812e+01 -1.3401699829101562e+02 6.9691894531250000e+01 -6.0492401123046875e+01 -1.3401600646972656e+02 6.9691894531250000e+01 -6.0458400726318359e+01 -1.3387001037597656e+02 6.9551300048828125e+01 -6.0464599609375000e+01 -1.3387200927734375e+02 6.9551300048828125e+01 -6.0498001098632812e+01 -1.3395999145507812e+02 6.9691894531250000e+01 -5.9795902252197266e+01 -1.3384599304199219e+02 6.9691894531250000e+01 -5.9137699127197266e+01 -1.3381600952148438e+02 6.9551300048828125e+01 -5.9814201354980469e+01 -1.3370401000976562e+02 6.9551300048828125e+01 -5.9169300079345703e+01 -1.3408100891113281e+02 7.0308601379394531e+01 -6.0608100891113281e+01 -1.3405400085449219e+02 7.0009498596191406e+01 -6.0652400970458984e+01 -1.3405899047851562e+02 7.0309104919433594e+01 -6.0661098480224609e+01 -1.3402999877929688e+02 7.0309799194335938e+01 -6.0732299804687500e+01 -1.3396800231933594e+02 7.0007896423339844e+01 -6.0787101745605469e+01 -1.3394099426269531e+02 7.0309898376464844e+01 -6.0832500457763672e+01 -1.3384599304199219e+02 7.0309196472167969e+01 -6.0885196685791016e+01 -1.3383700561523438e+02 7.0009498596191406e+01 -6.0877799987792969e+01 -1.3382400512695312e+02 7.0308998107910156e+01 -6.0897598266601562e+01 -1.3383799743652344e+02 6.9881401062011719e+01 -6.0868999481201172e+01 -1.3383198547363281e+02 6.9881401062011719e+01 -6.0873298645019531e+01 -1.3377699279785156e+02 6.9883102416992188e+01 -6.0884597778320312e+01 -1.3370899963378906e+02 6.9885093688964844e+01 -6.0898502349853516e+01 -1.3396400451660156e+02 6.9879898071289062e+01 -6.0782600402832031e+01 -1.3404899597167969e+02 6.9881401062011719e+01 -6.0647701263427734e+01 -1.3405000305175781e+02 6.9881599426269531e+01 -6.0642700195312500e+01 -1.3047799682617188e+02 6.9793502807617188e+01 -6.0847900390625000e+01 -1.3055400085449219e+02 6.9719902038574219e+01 -6.0847900390625000e+01 -1.3065600585937500e+02 6.9693000793457031e+01 -6.0847900390625000e+01 -1.3035600280761719e+02 6.9720100402832031e+01 -6.0700496673583984e+01 -1.3048399353027344e+02 6.9596000671386719e+01 -6.0700496673583984e+01 -1.3065600585937500e+02 6.9550697326660156e+01 -6.0700496673583984e+01 -1.3065600585937500e+02 6.9551498413085938e+01 -6.0701297760009766e+01 -1.3065600585937500e+02 6.9692199707031250e+01 -6.0847000122070312e+01 -1.3367601013183594e+02 6.9524299621582031e+01 -6.0642902374267578e+01 -1.3386100769042969e+02 6.9572998046875000e+01 -6.0642902374267578e+01 -1.3399800109863281e+02 6.9706596374511719e+01 -6.0642902374267578e+01 -1.3392700195312500e+02 6.9749099731445312e+01 -6.0777900695800781e+01 -1.3381700134277344e+02 6.9815299987792969e+01 -6.0870201110839844e+01 -1.3375698852539062e+02 6.9756904602050781e+01 -6.0870201110839844e+01 -1.3367601013183594e+02 6.9557800292968750e+01 -6.0697498321533203e+01 -1.3381999206542969e+02 6.9645004272460938e+01 -6.0777900695800781e+01 -1.3367601013183594e+02 6.9735496520996094e+01 -6.0870201110839844e+01 -1.3367601013183594e+02 6.9695899963378906e+01 -6.0841796875000000e+01 -1.3367601013183594e+02 6.9606994628906250e+01 -6.0777900695800781e+01 -1.1736399841308594e+02 7.0307701110839844e+01 -7.0587799072265625e+01 -1.1732699584960938e+02 7.0308097839355469e+01 -7.0663299560546875e+01 -1.1732199859619141e+02 7.0003501892089844e+01 -7.0657501220703125e+01 -1.1730500030517578e+02 7.0308403015136719e+01 -7.0708602905273438e+01 -1.1722000122070312e+02 7.0003501892089844e+01 -7.0780204772949219e+01 -1.1722800445556641e+02 7.0308204650878906e+01 -7.0785797119140625e+01 -1.1720999908447266e+02 7.0308097839355469e+01 -7.0803497314453125e+01 -1.1721599578857422e+02 6.9883399963378906e+01 -7.0777000427246094e+01 -1.1722299957275391e+02 6.9883399963378906e+01 -7.0768501281738281e+01 -1.1731799316406250e+02 6.9883399963378906e+01 -7.0654304504394531e+01 -1.1732499694824219e+02 6.9883804321289062e+01 -7.0630500793457031e+01 -1.1714299774169922e+02 6.9582199096679688e+01 -7.0631805419921875e+01 -1.1716000366210938e+02 6.9551101684570312e+01 -7.0483299255371094e+01 -1.1730599975585938e+02 6.9693702697753906e+01 -7.0496597290039062e+01 -1.1730599975585938e+02 6.9691894531250000e+01 -7.0496498107910156e+01 -1.1727699279785156e+02 6.9711700439453125e+01 -7.0631805419921875e+01 -1.1716099548339844e+02 6.9551300048828125e+01 -7.0483398437500000e+01 -1.1718799591064453e+02 6.9765594482421875e+01 -7.0769897460937500e+01 -1.1705899810791016e+02 6.9691894531250000e+01 -7.0794403076171875e+01 -1.1705999755859375e+02 6.9710205078125000e+01 -7.0799598693847656e+01 -1.1709199523925781e+02 6.9673095703125000e+01 -7.0769897460937500e+01 -1.1706900024414062e+02 6.9819999694824219e+01 -7.0831199645996094e+01 -1.1701200103759766e+02 6.9544898986816406e+01 -7.0630699157714844e+01 -1.1701899719238281e+02 6.9551300048828125e+01 -7.0654197692871094e+01 -1.1705099487304688e+02 6.9663299560546875e+01 -7.0765800476074219e+01 -1.1747200012207031e+02 7.0012199401855469e+01 -6.7727699279785156e+01 -1.1733300018310547e+02 7.0309898376464844e+01 -6.7624893188476562e+01 -1.1732199859619141e+02 7.0014404296875000e+01 -6.7635398864746094e+01 -1.1732599639892578e+02 7.0309898376464844e+01 -6.7621299743652344e+01 -1.1719300079345703e+02 7.0307701110839844e+01 -6.7602302551269531e+01 -1.1759100341796875e+02 7.0309402465820312e+01 -6.7903999328613281e+01 -1.1757399749755859e+02 7.0309799194335938e+01 -6.7865501403808594e+01 -1.1756700134277344e+02 7.0014404296875000e+01 -6.7875198364257812e+01 -1.1753700256347656e+02 7.0310798645019531e+01 -6.7781097412109375e+01 -1.1744499969482422e+02 7.0311004638671875e+01 -6.7683197021484375e+01 -1.1756400299072266e+02 6.9880599975585938e+01 -6.7896903991699219e+01 -1.1735200500488281e+02 6.9879501342773438e+01 -6.7662704467773438e+01 -1.1746600341796875e+02 6.9877899169921875e+01 -6.7732994079589844e+01 -1.1756200408935547e+02 6.9880004882812500e+01 -6.7880493164062500e+01 -1.1716199493408203e+02 6.9885200500488281e+01 -6.7620300292968750e+01 -1.1718000030517578e+02 6.9884498596191406e+01 -6.7619300842285156e+01 -1.1718600463867188e+02 6.9884201049804688e+01 -6.7618896484375000e+01 -1.1720600128173828e+02 6.9883506774902344e+01 -6.7620002746582031e+01 -1.1722599792480469e+02 6.9882804870605469e+01 -6.7621093750000000e+01 -1.1722999572753906e+02 6.9882598876953125e+01 -6.7621299743652344e+01 -1.1731700134277344e+02 6.9880004882812500e+01 -6.7640701293945312e+01 -1.1723799896240234e+02 6.9513298034667969e+01 -6.8023101806640625e+01 -1.1738199615478516e+02 6.9551300048828125e+01 -6.8036300659179688e+01 -1.1753399658203125e+02 6.9713302612304688e+01 -6.8049995422363281e+01 -1.1752700042724609e+02 6.9691894531250000e+01 -6.8049400329589844e+01 -1.1681199645996094e+02 6.9551300048828125e+01 -7.0709098815917969e+01 -1.1684700012207031e+02 6.9691894531250000e+01 -7.0850502014160156e+01 -1.1651799774169922e+02 6.9691894531250000e+01 -7.0922798156738281e+01 -1.1648999786376953e+02 6.9551300048828125e+01 -7.0779701232910156e+01 -1.1618500518798828e+02 6.9691894531250000e+01 -7.0977203369140625e+01 -1.1616500091552734e+02 6.9551300048828125e+01 -7.0832794189453125e+01 -1.1745200347900391e+02 6.9758102416992188e+01 -6.7754699707031250e+01 -1.1714900207519531e+02 6.9691894531250000e+01 -6.7679100036621094e+01 -1.1715800476074219e+02 6.9610496520996094e+01 -6.7763000488281250e+01 -1.1722700500488281e+02 6.9602104187011719e+01 -6.7754699707031250e+01 -1.1716500091552734e+02 6.9551300048828125e+01 -6.7823898315429688e+01 -1.1717399597167969e+02 6.9531402587890625e+01 -6.7899505615234375e+01 -1.1723799896240234e+02 6.9522399902343750e+01 -6.7896400451660156e+01 -1.1714699554443359e+02 6.9750999450683594e+01 -6.7661499023437500e+01 -1.1714400482177734e+02 6.9820800781250000e+01 -6.7640792846679688e+01 -1.1714799499511719e+02 6.9723197937011719e+01 -6.7669799804687500e+01 -1.1720999908447266e+02 6.9731101989746094e+01 -6.7656700134277344e+01 -1.1728399658203125e+02 6.9760002136230469e+01 -6.7656700134277344e+01 -1.1733700561523438e+02 6.9819602966308594e+01 -6.7656700134277344e+01 -1.1740399932861328e+02 6.9586906433105469e+01 -6.7896400451660156e+01 -1.1752300262451172e+02 6.9720199584960938e+01 -6.7896400451660156e+01 -1.1735800170898438e+02 6.9652999877929688e+01 -6.7754699707031250e+01 -1.1498799896240234e+02 6.9754501342773438e+01 -7.1073196411132812e+01 -1.1499100494384766e+02 6.9553596496582031e+01 -7.0900703430175781e+01 -1.1498899841308594e+02 6.9639396667480469e+01 -7.1004096984863281e+01 -1.1519400024414062e+02 6.9691894531250000e+01 -7.1044403076171875e+01 -1.1498799896240234e+02 6.9694900512695312e+01 -7.1037399291992188e+01 -1.1519300079345703e+02 6.9551300048828125e+01 -7.0898803710937500e+01 -1.1499100494384766e+02 6.9552200317382812e+01 -7.0896301269531250e+01 -1.1499399566650391e+02 6.9502006530761719e+01 -7.0741104125976562e+01 -1.1552500152587891e+02 6.9691894531250000e+01 -7.1036499023437500e+01 -1.1585500335693359e+02 6.9691894531250000e+01 -7.1014205932617188e+01 -1.1551800537109375e+02 6.9551300048828125e+01 -7.0890998840332031e+01 -1.1584200286865234e+02 6.9551300048828125e+01 -7.0869102478027344e+01 -1.1704900360107422e+02 6.9551300048828125e+01 -6.7837295532226562e+01 -1.1703199768066406e+02 6.9691894531250000e+01 -6.7692596435546875e+01 -1.1498499298095703e+02 6.9551300048828125e+01 -7.0896499633789062e+01 -1.1498300170898438e+02 6.9691894531250000e+01 -7.1042205810546875e+01 -1.1440200042724609e+02 6.9551300048828125e+01 -7.0859199523925781e+01 -1.1382099914550781e+02 6.9551300048828125e+01 -7.0752799987792969e+01 -1.1325500488281250e+02 6.9551300048828125e+01 -7.0557495117187500e+01 -1.1438500213623047e+02 6.9691894531250000e+01 -7.1003898620605469e+01 -1.1378499603271484e+02 6.9691894531250000e+01 -7.0894004821777344e+01 -1.1319499969482422e+02 6.9691894531250000e+01 -7.0690605163574219e+01 -1.1636699676513672e+02 6.9500404357910156e+01 -6.8023200988769531e+01 -1.1637899780273438e+02 6.9553703308105469e+01 -6.7841598510742188e+01 -1.1637899780273438e+02 6.9552398681640625e+01 -6.7846099853515625e+01 -1.1652199554443359e+02 6.9551300048828125e+01 -6.7855598449707031e+01 -1.1638999938964844e+02 6.9754501342773438e+01 -6.7669395446777344e+01 -1.1638800048828125e+02 6.9694900512695312e+01 -6.7705200195312500e+01 -1.1652899932861328e+02 6.9691894531250000e+01 -6.7709999084472656e+01 -1.1638499450683594e+02 6.9639396667480469e+01 -6.7738395690917969e+01 -1.1669799804687500e+02 6.9551300048828125e+01 -6.7859199523925781e+01 -1.1687400054931641e+02 6.9551300048828125e+01 -6.7853195190429688e+01 -1.1669699859619141e+02 6.9691894531250000e+01 -6.7713500976562500e+01 -1.1686499786376953e+02 6.9691894531250000e+01 -6.7707702636718750e+01 -1.1278600311279297e+02 6.9551300048828125e+01 -7.0301803588867188e+01 -1.1270600128173828e+02 6.9691894531250000e+01 -7.0423500061035156e+01 -1.1241999816894531e+02 6.9551300048828125e+01 -7.0017395019531250e+01 -1.1209599304199219e+02 6.9551300048828125e+01 -6.9665794372558594e+01 -1.1232099914550781e+02 6.9691894531250000e+01 -7.0124900817871094e+01 -1.1198099517822266e+02 6.9691894531250000e+01 -6.9755004882812500e+01 -1.1546699523925781e+02 6.9692001342773438e+01 -6.7416099548339844e+01 -1.1532600402832031e+02 6.9691894531250000e+01 -6.7232803344726562e+01 -1.1519700622558594e+02 6.9551300048828125e+01 -6.7300003051757812e+01 -1.1609199523925781e+02 6.9551300048828125e+01 -6.7821098327636719e+01 -1.1611199951171875e+02 6.9691894531250000e+01 -6.7676795959472656e+01 -1.1567299652099609e+02 6.9691894531250000e+01 -6.7553398132324219e+01 -1.1561000061035156e+02 6.9551300048828125e+01 -6.7684700012207031e+01 -1.1536800384521484e+02 6.9551300048828125e+01 -6.7523193359375000e+01 -1.1167299652099609e+02 6.9691894531250000e+01 -6.9279197692871094e+01 -1.1198099517822266e+02 6.9691894531250000e+01 -6.9755096435546875e+01 -1.1132099914550781e+02 6.9691894531250000e+01 -6.8327896118164062e+01 -1.1146300506591797e+02 6.9551300048828125e+01 -6.8294601440429688e+01 -1.1146699523925781e+02 6.9691894531250000e+01 -6.8816101074218750e+01 -1.1160399627685547e+02 6.9551300048828125e+01 -6.8765899658203125e+01 -1.1180199432373047e+02 6.9551300048828125e+01 -6.9210594177246094e+01 -1.1506099700927734e+02 6.9553703308105469e+01 -6.6022300720214844e+01 -1.1505599975585938e+02 6.9552398681640625e+01 -6.6021705627441406e+01 -1.1505500030517578e+02 6.9554405212402344e+01 -6.6026596069335938e+01 -1.1488000488281250e+02 6.9500404357910156e+01 -6.5996299743652344e+01 -1.1516300201416016e+02 6.9639396667480469e+01 -6.6037002563476562e+01 -1.1524300384521484e+02 6.9812301635742188e+01 -6.6048500061035156e+01 -1.1523199462890625e+02 6.9754501342773438e+01 -6.6046798706054688e+01 -1.1519400024414062e+02 6.9695899963378906e+01 -6.6046897888183594e+01 -1.1519599914550781e+02 6.9694900512695312e+01 -6.6041702270507812e+01 -1.1502899932861328e+02 6.9551300048828125e+01 -6.6406898498535156e+01 -1.1509200286865234e+02 6.9551300048828125e+01 -6.7025604248046875e+01 -1.1517400360107422e+02 6.9691894531250000e+01 -6.6409904479980469e+01 -1.1523299407958984e+02 6.9691894531250000e+01 -6.6988197326660156e+01 -1.1135599517822266e+02 6.9551300048828125e+01 -6.7626602172851562e+01 -1.1118199920654297e+02 6.9754501342773438e+01 -6.6484504699707031e+01 -1.1118800354003906e+02 6.9691894531250000e+01 -6.6953002929687500e+01 -1.1121799468994141e+02 6.9694900512695312e+01 -6.6488899230957031e+01 -1.1125099945068359e+02 6.9639495849609375e+01 -6.6492996215820312e+01 -1.1135400390625000e+02 6.9553703308105469e+01 -6.6505699157714844e+01 -1.1133400726318359e+02 6.9551300048828125e+01 -6.6956100463867188e+01 -1.1135800170898438e+02 6.9552398681640625e+01 -6.6506294250488281e+01 -1.1153800201416016e+02 6.9500297546386719e+01 -6.6528495788574219e+01 -1.1121099853515625e+02 6.9691894531250000e+01 -6.7639900207519531e+01 -1.1659500122070312e+02 6.9785202026367188e+01 -5.8076198577880859e+01 -1.1655999755859375e+02 6.9691894531250000e+01 -5.8034698486328125e+01 -1.1643700408935547e+02 6.9551300048828125e+01 -5.7888999938964844e+01 -1.1258999633789062e+02 6.9691894531250000e+01 -5.8034698486328125e+01 -1.1254100036621094e+02 6.9785202026367188e+01 -5.8076198577880859e+01 -1.1276100158691406e+02 6.9551300048828125e+01 -5.7888999938964844e+01 -1.1908899688720703e+02 6.9882301330566406e+01 -5.8049999237060547e+01 -1.1909999847412109e+02 7.0308700561523438e+01 -5.8059799194335938e+01 -1.1911199951171875e+02 6.9882301330566406e+01 -5.8030799865722656e+01 -1.1912200164794922e+02 7.0308998107910156e+01 -5.8054000854492188e+01 -1.1923100280761719e+02 6.9882301330566406e+01 -5.7931198120117188e+01 -1.1923699951171875e+02 7.0308601379394531e+01 -5.7939498901367188e+01 -1.1925099945068359e+02 6.9883300781250000e+01 -5.7884498596191406e+01 -1.1926799774169922e+02 7.0308601379394531e+01 -5.7907699584960938e+01 -1.1894699859619141e+02 6.9885200500488281e+01 -5.8083999633789062e+01 -1.1902300262451172e+02 6.9883598327636719e+01 -5.8065700531005859e+01 -1.1890999603271484e+02 6.9693000793457031e+01 -5.8035297393798828e+01 -1.1890999603271484e+02 6.9692199707031250e+01 -5.8034500122070312e+01 -1.1890999603271484e+02 6.9551498413085938e+01 -5.7888702392578125e+01 -1.1890999603271484e+02 6.9550697326660156e+01 -5.7887901306152344e+01 -1.1075600433349609e+02 6.9512397766113281e+01 -5.7791698455810547e+01 -1.1075600433349609e+02 6.9723503112792969e+01 -5.8051998138427734e+01 -1.1075600433349609e+02 6.9695800781250000e+01 -5.8029899597167969e+01 -1.1075600433349609e+02 6.9589401245117188e+01 -5.7944999694824219e+01 -1.1075600433349609e+02 6.9559204101562500e+01 -5.7884998321533203e+01 -1.1072000122070312e+02 6.9884796142578125e+01 -5.8084800720214844e+01 -1.1066999816894531e+02 7.0308296203613281e+01 -5.8101596832275391e+01 -1.1064799499511719e+02 6.9882301330566406e+01 -5.8068599700927734e+01 -1.1057599639892578e+02 7.0309494018554688e+01 -5.8057800292968750e+01 -1.1058799743652344e+02 6.9880302429199219e+01 -5.8055198669433594e+01 -1.1058200073242188e+02 6.9880203247070312e+01 -5.8050800323486328e+01 -1.1048200225830078e+02 7.0310699462890625e+01 -5.8014499664306641e+01 -1.1045099639892578e+02 6.9878303527832031e+01 -5.7950000762939453e+01 -1.1037000274658203e+02 6.9880500793457031e+01 -5.7791599273681641e+01 -1.1035999298095703e+02 7.0309600830078125e+01 -5.7811100006103516e+01 -1.1037000274658203e+02 6.9880302429199219e+01 -5.7796798706054688e+01 -1.1036299896240234e+02 7.0310195922851562e+01 -5.7845397949218750e+01 -1.1044200134277344e+02 7.0310501098632812e+01 -5.7958099365234375e+01 -1.1901200103759766e+02 6.9719902038574219e+01 -5.8035297393798828e+01 -1.1908700561523438e+02 6.9793403625488281e+01 -5.8035297393798828e+01 -1.1920899963378906e+02 6.9720100402832031e+01 -5.7887901306152344e+01 -1.1908199310302734e+02 6.9595901489257812e+01 -5.7887901306152344e+01 -1.1910499572753906e+02 6.9553802490234375e+01 -5.7727199554443359e+01 -1.1910299682617188e+02 6.9551300048828125e+01 -5.7726699829101562e+01 -1.1924600219726562e+02 6.9691894531250000e+01 -5.7751800537109375e+01 -1.1924800109863281e+02 6.9696502685546875e+01 -5.7751998901367188e+01 -1.1060500335693359e+02 6.9809104919433594e+01 -5.8051998138427734e+01 -1.1049000549316406e+02 6.9739997863769531e+01 -5.7944999694824219e+01 -1.1042399597167969e+02 6.9700302124023438e+01 -5.7791698455810547e+01 -1.1041799926757812e+02 6.9696502685546875e+01 -5.7634101867675781e+01 -1.1056300354003906e+02 6.9551300048828125e+01 -5.7659297943115234e+01 -1.1056099700927734e+02 6.9553802490234375e+01 -5.7658901214599609e+01 -1.1056500244140625e+02 6.9562599182128906e+01 -5.7791698455810547e+01 -1.1042000579833984e+02 6.9691894531250000e+01 -5.7634300231933594e+01 -1.1066899871826172e+02 6.9746398925781250e+01 -5.8051998138427734e+01 -1.1060299682617188e+02 6.9629600524902344e+01 -5.7944999694824219e+01 -1.1939099884033203e+02 7.0308296203613281e+01 -5.5021301269531250e+01 -1.1934100341796875e+02 6.9884796142578125e+01 -5.5038097381591797e+01 -1.1941300201416016e+02 6.9882301330566406e+01 -5.5054298400878906e+01 -1.1948500061035156e+02 7.0309494018554688e+01 -5.5064998626708984e+01 -1.1947299957275391e+02 6.9880302429199219e+01 -5.5067699432373047e+01 -1.1947900390625000e+02 6.9880203247070312e+01 -5.5072097778320312e+01 -1.1957900238037109e+02 7.0310699462890625e+01 -5.5108303070068359e+01 -1.1961100006103516e+02 6.9878303527832031e+01 -5.5172801971435547e+01 -1.1969100189208984e+02 6.9880500793457031e+01 -5.5331199645996094e+01 -1.1970099639892578e+02 7.0309600830078125e+01 -5.5311698913574219e+01 -1.1969100189208984e+02 6.9880302429199219e+01 -5.5326000213623047e+01 -1.1969800567626953e+02 7.0310195922851562e+01 -5.5277500152587891e+01 -1.1961899566650391e+02 7.0310501098632812e+01 -5.5164699554443359e+01 -1.1964300537109375e+02 6.9696502685546875e+01 -5.5488800048828125e+01 -1.1964099884033203e+02 6.9691894531250000e+01 -5.5488601684570312e+01 -1.1950000000000000e+02 6.9553802490234375e+01 -5.5464000701904297e+01 -1.1949800109863281e+02 6.9551300048828125e+01 -5.5463600158691406e+01 -1.1095800018310547e+02 6.9551300048828125e+01 -5.5396099090576172e+01 -1.1081299591064453e+02 6.9696502685546875e+01 -5.5370899200439453e+01 -1.1081500244140625e+02 6.9691894531250000e+01 -5.5371097564697266e+01 -1.1095600128173828e+02 6.9553802490234375e+01 -5.5395698547363281e+01 -1.1079299926757812e+02 7.0308601379394531e+01 -5.5215198516845703e+01 -1.1080999755859375e+02 6.9883300781250000e+01 -5.5238399505615234e+01 -1.1082500457763672e+02 7.0308601379394531e+01 -5.5183300018310547e+01 -1.1083100128173828e+02 6.9882301330566406e+01 -5.5191596984863281e+01 -1.1093900299072266e+02 7.0308998107910156e+01 -5.5068798065185547e+01 -1.1094900512695312e+02 6.9882301330566406e+01 -5.5091999053955078e+01 -1.1096099853515625e+02 7.0308700561523438e+01 -5.5063098907470703e+01 -1.1097200012207031e+02 6.9882301330566406e+01 -5.5072799682617188e+01 -1.1103800201416016e+02 6.9883598327636719e+01 -5.5057102203369141e+01 -1.1111400604248047e+02 6.9885200500488281e+01 -5.5038898468017578e+01 -1.1930500030517578e+02 6.9559204101562500e+01 -5.5237899780273438e+01 -1.1930500030517578e+02 6.9512397766113281e+01 -5.5331100463867188e+01 -1.1949600219726562e+02 6.9562599182128906e+01 -5.5331100463867188e+01 -1.1930500030517578e+02 6.9695800781250000e+01 -5.5093002319335938e+01 -1.1930500030517578e+02 6.9589401245117188e+01 -5.5177799224853516e+01 -1.1945800018310547e+02 6.9629600524902344e+01 -5.5177799224853516e+01 -1.1957099914550781e+02 6.9739997863769531e+01 -5.5177799224853516e+01 -1.1945600128173828e+02 6.9809104919433594e+01 -5.5070899963378906e+01 -1.1939199829101562e+02 6.9746398925781250e+01 -5.5070899963378906e+01 -1.1930500030517578e+02 6.9723503112792969e+01 -5.5070899963378906e+01 -1.1963700103759766e+02 6.9700302124023438e+01 -5.5331100463867188e+01 -1.1115100097656250e+02 6.9692199707031250e+01 -5.5088401794433594e+01 -1.1115100097656250e+02 6.9693000793457031e+01 -5.5087600708007812e+01 -1.1104899597167969e+02 6.9719902038574219e+01 -5.5087600708007812e+01 -1.1097399902343750e+02 6.9793403625488281e+01 -5.5087600708007812e+01 -1.1085200500488281e+02 6.9720100402832031e+01 -5.5234996795654297e+01 -1.1097899627685547e+02 6.9595901489257812e+01 -5.5234996795654297e+01 -1.1115100097656250e+02 6.9551498413085938e+01 -5.5234100341796875e+01 -1.1115100097656250e+02 6.9550697326660156e+01 -5.5234996795654297e+01 -1.1690100097656250e+02 6.9551300048828125e+01 -5.5233898162841797e+01 -1.1712400054931641e+02 6.9785202026367188e+01 -5.5046600341796875e+01 -1.1707399749755859e+02 6.9691894531250000e+01 -5.5088199615478516e+01 -1.1307099914550781e+02 6.9785202026367188e+01 -5.5046600341796875e+01 -1.1310499572753906e+02 6.9691894531250000e+01 -5.5088199615478516e+01 -1.1322800445556641e+02 6.9551300048828125e+01 -5.5233898162841797e+01 -1.1744300079345703e+02 7.0308296203613281e+01 -5.1125000000000000e+01 -1.1739099884033203e+02 6.9884796142578125e+01 -5.1141700744628906e+01 -1.1746399688720703e+02 6.9882301330566406e+01 -5.1157897949218750e+01 -1.1753600311279297e+02 7.0309494018554688e+01 -5.1168697357177734e+01 -1.1752399444580078e+02 6.9880302429199219e+01 -5.1171298980712891e+01 -1.1753000640869141e+02 6.9880203247070312e+01 -5.1175800323486328e+01 -1.1762999725341797e+02 7.0310699462890625e+01 -5.1212398529052734e+01 -1.1766199493408203e+02 6.9878303527832031e+01 -5.1276699066162109e+01 -1.1774200439453125e+02 6.9880500793457031e+01 -5.1435398101806641e+01 -1.1775199890136719e+02 7.0309600830078125e+01 -5.1415901184082031e+01 -1.1774100494384766e+02 6.9880302429199219e+01 -5.1430198669433594e+01 -1.1774900054931641e+02 7.0310195922851562e+01 -5.1381900787353516e+01 -1.1766999816894531e+02 7.0310501098632812e+01 -5.1268600463867188e+01 -1.1769200134277344e+02 6.9691894531250000e+01 -5.1592903137207031e+01 -1.1769300079345703e+02 6.9696594238281250e+01 -5.1593097686767578e+01 -1.1755100250244141e+02 6.9553802490234375e+01 -5.1568000793457031e+01 -1.1754799652099609e+02 6.9551300048828125e+01 -5.1567600250244141e+01 -1.1372999572753906e+02 6.9691894531250000e+01 -5.1475200653076172e+01 -1.1387400054931641e+02 6.9551300048828125e+01 -5.1500000000000000e+01 -1.1387100219726562e+02 6.9553703308105469e+01 -5.1499603271484375e+01 -1.1372900390625000e+02 6.9696502685546875e+01 -5.1474998474121094e+01 -1.1388699340820312e+02 6.9882202148437500e+01 -5.1176498413085938e+01 -1.1387599945068359e+02 7.0308700561523438e+01 -5.1166698455810547e+01 -1.1386399841308594e+02 6.9882202148437500e+01 -5.1195598602294922e+01 -1.1385399627685547e+02 7.0308998107910156e+01 -5.1172496795654297e+01 -1.1374600219726562e+02 6.9882202148437500e+01 -5.1295501708984375e+01 -1.1373999786376953e+02 7.0308601379394531e+01 -5.1287200927734375e+01 -1.1372599792480469e+02 6.9883300781250000e+01 -5.1341899871826172e+01 -1.1370800018310547e+02 7.0308601379394531e+01 -5.1318798065185547e+01 -1.1403000640869141e+02 6.9885200500488281e+01 -5.1142498016357422e+01 -1.1395300292968750e+02 6.9883598327636719e+01 -5.1160800933837891e+01 -1.1735600280761719e+02 6.9559204101562500e+01 -5.1341499328613281e+01 -1.1735600280761719e+02 6.9512207031250000e+01 -5.1435298919677734e+01 -1.1754599761962891e+02 6.9562500000000000e+01 -5.1435298919677734e+01 -1.1735600280761719e+02 6.9695800781250000e+01 -5.1196601867675781e+01 -1.1735600280761719e+02 6.9589103698730469e+01 -5.1281700134277344e+01 -1.1750900268554688e+02 6.9629402160644531e+01 -5.1281700134277344e+01 -1.1762200164794922e+02 6.9739898681640625e+01 -5.1281700134277344e+01 -1.1750700378417969e+02 6.9808998107910156e+01 -5.1174598693847656e+01 -1.1744199371337891e+02 6.9746200561523438e+01 -5.1174598693847656e+01 -1.1735600280761719e+02 6.9723297119140625e+01 -5.1174598693847656e+01 -1.1768800354003906e+02 6.9700195312500000e+01 -5.1435298919677734e+01 -1.1406700134277344e+02 6.9692199707031250e+01 -5.1192001342773438e+01 -1.1406700134277344e+02 6.9693000793457031e+01 -5.1191097259521484e+01 -1.1396499633789062e+02 6.9719902038574219e+01 -5.1191097259521484e+01 -1.1388899993896484e+02 6.9793403625488281e+01 -5.1191097259521484e+01 -1.1376699829101562e+02 6.9720100402832031e+01 -5.1338600158691406e+01 -1.1389499664306641e+02 6.9595901489257812e+01 -5.1338600158691406e+01 -1.1406700134277344e+02 6.9551498413085938e+01 -5.1337699890136719e+01 -1.1406700134277344e+02 6.9550697326660156e+01 -5.1338600158691406e+01 -1.0509099578857422e+02 7.0308799743652344e+01 -6.6224700927734375e+01 -1.0513500213623047e+02 7.0012596130371094e+01 -6.6221298217773438e+01 -1.0513700103759766e+02 7.0309196472167969e+01 -6.6211296081542969e+01 -1.0522000122070312e+02 7.0309997558593750e+01 -6.6187301635742188e+01 -1.0529599761962891e+02 7.0010902404785156e+01 -6.6201301574707031e+01 -1.0535400390625000e+02 7.0310104370117188e+01 -6.6194801330566406e+01 -1.0547800445556641e+02 7.0308998107910156e+01 -6.6246299743652344e+01 -1.0545200347900391e+02 7.0309303283691406e+01 -6.6235298156738281e+01 -1.0545200347900391e+02 7.0012596130371094e+01 -6.6247001647949219e+01 -1.0545200347900391e+02 6.9881294250488281e+01 -6.6253700256347656e+01 -1.0547000122070312e+02 6.9881996154785156e+01 -6.6269302368164062e+01 -1.0530200195312500e+02 6.9879699707031250e+01 -6.6209899902343750e+01 -1.0513500213623047e+02 6.9881294250488281e+01 -6.6227897644042969e+01 -1.0521399688720703e+02 6.9880004882812500e+01 -6.6209701538085938e+01 -1.0525099945068359e+02 6.9879699707031250e+01 -6.6207099914550781e+01 -1.0525499725341797e+02 6.9879699707031250e+01 -6.6206794738769531e+01 -1.0522399902343750e+02 6.9879898071289062e+01 -6.6209098815917969e+01 -1.0527999877929688e+02 6.9879699707031250e+01 -6.6207496643066406e+01 -1.0529599761962891e+02 6.9879600524902344e+01 -6.6208000183105469e+01 -1.0505799865722656e+02 6.9883895874023438e+01 -6.6272994995117188e+01 -1.0414600372314453e+02 6.9551300048828125e+01 -6.7198799133300781e+01 -1.0359899902343750e+02 6.9551300048828125e+01 -6.7494400024414062e+01 -1.0407099914550781e+02 6.9691894531250000e+01 -6.7074295043945312e+01 -1.0353700256347656e+02 6.9691894531250000e+01 -6.7362998962402344e+01 -1.0502299499511719e+02 6.9747299194335938e+01 -6.6340797424316406e+01 -1.0457400512695312e+02 6.9691894531250000e+01 -6.6733596801757812e+01 -1.0503400421142578e+02 6.9691894531250000e+01 -6.6353096008300781e+01 -1.0508900451660156e+02 6.9612396240234375e+01 -6.6414100646972656e+01 -1.0466100311279297e+02 6.9551300048828125e+01 -6.6850105285644531e+01 -1.0509999847412109e+02 6.9596900939941406e+01 -6.6426002502441406e+01 -1.0513199615478516e+02 6.9551300048828125e+01 -6.6460998535156250e+01 -1.0544400024414062e+02 6.9791694641113281e+01 -6.6266098022460938e+01 -1.0554000091552734e+02 6.9730598449707031e+01 -6.6386299133300781e+01 -1.0553099822998047e+02 6.9691894531250000e+01 -6.6393600463867188e+01 -1.0536800384521484e+02 6.9716903686523438e+01 -6.6266098022460938e+01 -1.0550600433349609e+02 6.9661605834960938e+01 -6.6413093566894531e+01 -1.0544099426269531e+02 6.9581100463867188e+01 -6.6464996337890625e+01 -1.0543700408935547e+02 6.9595397949218750e+01 -6.6413200378417969e+01 -1.0541699981689453e+02 6.9551300048828125e+01 -6.6484199523925781e+01 -1.0526499938964844e+02 6.9549598693847656e+01 -6.6413200378417969e+01 -1.0526499938964844e+02 6.9500404357910156e+01 -6.6605094909667969e+01 -1.0510499572753906e+02 6.9605796813964844e+01 -6.6414497375488281e+01 -1.0516099548339844e+02 6.9716102600097656e+01 -6.6266098022460938e+01 -1.0508399963378906e+02 6.9790397644042969e+01 -6.6266098022460938e+01 -1.0526399993896484e+02 6.9689399719238281e+01 -6.6266098022460938e+01 -1.0131300354003906e+02 6.9553596496582031e+01 -6.7944602966308594e+01 -1.0131300354003906e+02 6.9552200317382812e+01 -6.7949104309082031e+01 -1.0177300262451172e+02 6.9551300048828125e+01 -6.7946502685546875e+01 -1.0130899810791016e+02 6.9501197814941406e+01 -6.8113197326660156e+01 -1.0131599426269531e+02 6.9639396667480469e+01 -6.7841300964355469e+01 -1.0131800079345703e+02 6.9754501342773438e+01 -6.7772094726562500e+01 -1.0176599884033203e+02 6.9691894531250000e+01 -6.7800994873046875e+01 -1.0131700134277344e+02 6.9694900512695312e+01 -6.7807899475097656e+01 -1.0240100097656250e+02 6.9551300048828125e+01 -6.7877204895019531e+01 -1.0301399993896484e+02 6.9551300048828125e+01 -6.7726699829101562e+01 -1.0237599945068359e+02 6.9691894531250000e+01 -6.7733802795410156e+01 -1.0296900177001953e+02 6.9691894531250000e+01 -6.7588005065917969e+01 -1.0692800140380859e+02 6.9727500915527344e+01 -6.8133895874023438e+01 -1.0691999816894531e+02 6.9691894531250000e+01 -6.8140502929687500e+01 -1.0676900482177734e+02 6.9539001464843750e+01 -6.8260299682617188e+01 -1.0680599975585938e+02 6.9551300048828125e+01 -6.8231201171875000e+01 -1.0682699584960938e+02 6.9577796936035156e+01 -6.8214103698730469e+01 -1.0704399871826172e+02 7.0308296203613281e+01 -6.8209800720214844e+01 -1.0704699707031250e+02 7.0004501342773438e+01 -6.8261199951171875e+01 -1.0705200195312500e+02 7.0308296203613281e+01 -6.8474296569824219e+01 -1.0705699920654297e+02 7.0308502197265625e+01 -6.8434295654296875e+01 -1.0704900360107422e+02 7.0004501342773438e+01 -6.8435501098632812e+01 -1.0707099914550781e+02 7.0308799743652344e+01 -6.8341400146484375e+01 -1.0705500030517578e+02 7.0308403015136719e+01 -6.8261901855468750e+01 -1.0704299926757812e+02 6.9882804870605469e+01 -6.8435806274414062e+01 -1.0704299926757812e+02 6.9882804870605469e+01 -6.8436698913574219e+01 -1.0704100036621094e+02 6.9882804870605469e+01 -6.8261306762695312e+01 -1.0704100036621094e+02 6.9882804870605469e+01 -6.8260398864746094e+01 -1.0036599731445312e+02 6.9551300048828125e+01 -6.7812500000000000e+01 -9.9917205810546875e+01 6.9551300048828125e+01 -6.7640495300292969e+01 -1.0040599822998047e+02 6.9691894531250000e+01 -6.7672599792480469e+01 -9.9981002807617188e+01 6.9691894531250000e+01 -6.7509498596191406e+01 -1.0086000061035156e+02 6.9691894531250000e+01 -6.7768203735351562e+01 -1.0084000396728516e+02 6.9551300048828125e+01 -6.7912498474121094e+01 -1.0698600006103516e+02 6.9695701599121094e+01 -6.8436897277832031e+01 -1.0684199523925781e+02 6.9557800292968750e+01 -6.8436897277832031e+01 -1.0692500305175781e+02 6.9691894531250000e+01 -6.8559494018554688e+01 -1.0693199920654297e+02 6.9724998474121094e+01 -6.8565399169921875e+01 -1.0676300048828125e+02 6.9536300659179688e+01 -6.8436897277832031e+01 -1.0680799865722656e+02 6.9551300048828125e+01 -6.8471405029296875e+01 -1.0682900238037109e+02 6.9575698852539062e+01 -6.8486694335937500e+01 -1.0684099578857422e+02 6.9559593200683594e+01 -6.8260299682617188e+01 -1.0698399353027344e+02 6.9696701049804688e+01 -6.8260299682617188e+01 -9.9454902648925781e+01 6.9691894531250000e+01 -6.7178100585937500e+01 -9.9037498474121094e+01 6.9691894531250000e+01 -6.6754402160644531e+01 -9.9363700866699219e+01 6.9551300048828125e+01 -6.7291702270507812e+01 -9.8922500610351562e+01 6.9551300048828125e+01 -6.6843803405761719e+01 -9.9707496643066406e+01 6.9691894531250000e+01 -6.7357803344726562e+01 -9.9629997253417969e+01 6.9551300048828125e+01 -6.7481201171875000e+01 -1.0678599548339844e+02 6.9551300048828125e+01 -6.8500694274902344e+01 -1.0690200042724609e+02 6.9691894531250000e+01 -6.8589599609375000e+01 -1.0644400024414062e+02 6.9691894531250000e+01 -6.9109596252441406e+01 -1.0634099578857422e+02 6.9551300048828125e+01 -6.9006301879882812e+01 -1.0592199707031250e+02 6.9691894531250000e+01 -6.9564399719238281e+01 -1.0583399963378906e+02 6.9551300048828125e+01 -6.9448600769042969e+01 -9.8583305358886719e+01 6.9551300048828125e+01 -6.6293502807617188e+01 -9.8362602233886719e+01 6.9551300048828125e+01 -6.5685798645019531e+01 -9.8714698791503906e+01 6.9691894531250000e+01 -6.6230697631835938e+01 -9.8503501892089844e+01 6.9691894531250000e+01 -6.5648803710937500e+01 -9.8862297058105469e+01 6.9691894531250000e+01 -6.6501701354980469e+01 -9.8738296508789062e+01 6.9551300048828125e+01 -6.6578094482421875e+01 -1.0547499847412109e+02 6.9691894531250000e+01 -6.9878303527832031e+01 -1.0592199707031250e+02 6.9691894531250000e+01 -6.9564498901367188e+01 -1.0539600372314453e+02 6.9551300048828125e+01 -6.9755706787109375e+01 -1.0500700378417969e+02 6.9691894531250000e+01 -7.0153800964355469e+01 -1.0493800354003906e+02 6.9551300048828125e+01 -7.0025299072265625e+01 -1.0440200042724609e+02 6.9691894531250000e+01 -7.0440597534179688e+01 -1.0434600067138672e+02 6.9551300048828125e+01 -7.0306098937988281e+01 -9.8302398681640625e+01 6.9587799072265625e+01 -6.4139404296875000e+01 -9.8246093750000000e+01 6.9566505432128906e+01 -6.4079399108886719e+01 -9.8232200622558594e+01 6.9551300048828125e+01 -6.4417495727539062e+01 -9.8070198059082031e+01 6.9500000000000000e+01 -6.3892200469970703e+01 -9.8377799987792969e+01 6.9691894531250000e+01 -6.4423095703125000e+01 -9.8425498962402344e+01 6.9778503417968750e+01 -6.4270401000976562e+01 -9.8387702941894531e+01 6.9692298889160156e+01 -6.4230201721191406e+01 -9.8384902954101562e+01 6.9685897827148438e+01 -6.4227203369140625e+01 -9.8395500183105469e+01 6.9691894531250000e+01 -6.5043601989746094e+01 -9.8250503540039062e+01 6.9551300048828125e+01 -6.5058097839355469e+01 -1.0383100128173828e+02 6.9551300048828125e+01 -7.0499099731445312e+01 -1.0387699890136719e+02 6.9691894531250000e+01 -7.0637298583984375e+01 -1.0334199523925781e+02 6.9691894531250000e+01 -7.0795501708984375e+01 -1.0330599975585938e+02 6.9551300048828125e+01 -7.0654304504394531e+01 -1.0269799804687500e+02 6.9691894531250000e+01 -7.0933502197265625e+01 -1.0267300415039062e+02 6.9551300048828125e+01 -7.0789901733398438e+01 -1.0815799713134766e+02 7.0308601379394531e+01 -6.4103996276855469e+01 -1.0814099884033203e+02 6.9882995605468750e+01 -6.4081100463867188e+01 -1.0812999725341797e+02 7.0308700561523438e+01 -6.4132202148437500e+01 -1.0812299346923828e+02 6.9882102966308594e+01 -6.4123306274414062e+01 -1.0801200103759766e+02 7.0308998107910156e+01 -6.4250297546386719e+01 -1.0800199890136719e+02 6.9882102966308594e+01 -6.4227500915527344e+01 -1.0799299621582031e+02 7.0308799743652344e+01 -6.4255401611328125e+01 -1.0798099517822266e+02 6.9882102966308594e+01 -6.4245201110839844e+01 -1.0791400146484375e+02 6.9883506774902344e+01 -6.4261299133300781e+01 -1.0783699798583984e+02 6.9885200500488281e+01 -6.4280006408691406e+01 -1.0779900360107422e+02 6.9692199707031250e+01 -6.4230705261230469e+01 -1.0779900360107422e+02 6.9693000793457031e+01 -6.4231597900390625e+01 -1.0779900360107422e+02 6.9551498413085938e+01 -6.4085105895996094e+01 -1.0779900360107422e+02 6.9550697326660156e+01 -6.4084205627441406e+01 -1.0213700103759766e+02 6.9551300048828125e+01 -7.0867004394531250e+01 -1.0159899902343750e+02 6.9551300048828125e+01 -7.0913101196289062e+01 -1.0095700073242188e+02 6.9551300048828125e+01 -7.0925895690917969e+01 -1.0215399932861328e+02 6.9691894531250000e+01 -7.1011795043945312e+01 -1.0160700225830078e+02 6.9691894531250000e+01 -7.1058601379394531e+01 -1.0095500183105469e+02 6.9691894531250000e+01 -7.1071601867675781e+01 -1.0797100067138672e+02 6.9595901489257812e+01 -6.4084205627441406e+01 -1.0799500274658203e+02 6.9553398132324219e+01 -6.3919597625732422e+01 -1.0799299621582031e+02 6.9551300048828125e+01 -6.3919200897216797e+01 -1.0809899902343750e+02 6.9720100402832031e+01 -6.4084205627441406e+01 -1.0813800048828125e+02 6.9696098327636719e+01 -6.3941703796386719e+01 -1.0813699340820312e+02 6.9691894531250000e+01 -6.3941501617431641e+01 -1.0797700500488281e+02 6.9793403625488281e+01 -6.4231597900390625e+01 -1.0790100097656250e+02 6.9719902038574219e+01 -6.4231597900390625e+01 -1.0000900268554688e+02 6.9551300048828125e+01 -7.0855796813964844e+01 -9.9989501953125000e+01 6.9691894531250000e+01 -7.1000297546386719e+01 -9.9087600708007812e+01 6.9551300048828125e+01 -7.0670097351074219e+01 -9.8126701354980469e+01 6.9551300048828125e+01 -7.0317405700683594e+01 -9.9048896789550781e+01 6.9691894531250000e+01 -7.0810600280761719e+01 -9.8064895629882812e+01 6.9691894531250000e+01 -7.0449302673339844e+01 -1.0804199981689453e+02 6.9500495910644531e+01 -6.2454998016357422e+01 -1.0832199859619141e+02 6.9639396667480469e+01 -6.2492900848388672e+01 -1.0822000122070312e+02 6.9553596496582031e+01 -6.2479099273681641e+01 -1.0821499633789062e+02 6.9552299499511719e+01 -6.2478500366210938e+01 -1.0839099884033203e+02 6.9754501342773438e+01 -6.2502197265625000e+01 -1.0835500335693359e+02 6.9694900512695312e+01 -6.2497398376464844e+01 -9.6935104370117188e+01 6.9691894531250000e+01 -6.9776397705078125e+01 -9.7022300720214844e+01 6.9551300048828125e+01 -6.9659706115722656e+01 -9.6413703918457031e+01 6.9691894531250000e+01 -6.9338699340820312e+01 -9.6513702392578125e+01 6.9551300048828125e+01 -6.9232704162597656e+01 -9.5945800781250000e+01 6.9691894531250000e+01 -6.8844001770019531e+01 -9.6057304382324219e+01 6.9551300048828125e+01 -6.8750099182128906e+01 -1.0827899932861328e+02 6.9551300048828125e+01 -6.0915397644042969e+01 -1.0814399719238281e+02 6.9551300048828125e+01 -5.9640602111816406e+01 -1.0842499542236328e+02 6.9691894531250000e+01 -6.0909900665283203e+01 -1.0828700256347656e+02 6.9691894531250000e+01 -5.9615001678466797e+01 -1.0839000701904297e+02 6.9691894531250000e+01 -6.2207099914550781e+01 -1.0824500274658203e+02 6.9551300048828125e+01 -6.2194103240966797e+01 -9.6057197570800781e+01 6.9551300048828125e+01 -6.8750000000000000e+01 -9.5597106933593750e+01 6.9551300048828125e+01 -6.8124603271484375e+01 -9.5228393554687500e+01 6.9551300048828125e+01 -6.7457000732421875e+01 -9.4841896057128906e+01 6.9551300048828125e+01 -6.6423896789550781e+01 -9.5474304199218750e+01 6.9691894531250000e+01 -6.8203002929687500e+01 -9.5096794128417969e+01 6.9691894531250000e+01 -6.7519302368164062e+01 -9.4701797485351562e+01 6.9691894531250000e+01 -6.6463905334472656e+01 -1.0768499755859375e+02 6.9691894531250000e+01 -5.7759002685546875e+01 -1.0734700012207031e+02 6.9691894531250000e+01 -5.7169002532958984e+01 -1.0755500030517578e+02 6.9551300048828125e+01 -5.7824199676513672e+01 -1.0722499847412109e+02 6.9551300048828125e+01 -5.7248699188232422e+01 -1.0795199584960938e+02 6.9691894531250000e+01 -5.8373500823974609e+01 -1.0781600189208984e+02 6.9551300048828125e+01 -5.8424396514892578e+01 -9.4424598693847656e+01 6.9754501342773438e+01 -6.3524200439453125e+01 -9.4422103881835938e+01 6.9691894531250000e+01 -6.4039604187011719e+01 -9.4460197448730469e+01 6.9694900512695312e+01 -6.3527599334716797e+01 -9.4460899353027344e+01 6.9693901062011719e+01 -6.3527599334716797e+01 -9.4603004455566406e+01 6.9551399230957031e+01 -6.3541301727294922e+01 -9.4600799560546875e+01 6.9552101135253906e+01 -6.3541099548339844e+01 -9.4567703247070312e+01 6.9551300048828125e+01 -6.4044998168945312e+01 -9.4596397399902344e+01 6.9553596496582031e+01 -6.3540695190429688e+01 -9.4493499755859375e+01 6.9639396667480469e+01 -6.3530803680419922e+01 -9.4749298095703125e+01 6.9502693176269531e+01 -6.3555397033691406e+01 -9.4610198974609375e+01 6.9551300048828125e+01 -6.5243103027343750e+01 -9.4465499877929688e+01 6.9691894531250000e+01 -6.5259300231933594e+01 -1.0633999633789062e+02 6.9551300048828125e+01 -5.6230499267578125e+01 -1.0542900085449219e+02 6.9551300048828125e+01 -5.5593799591064453e+01 -1.0643599700927734e+02 6.9691894531250000e+01 -5.6120800018310547e+01 -1.0550000000000000e+02 6.9691894531250000e+01 -5.5466400146484375e+01 -1.0692800140380859e+02 6.9691894531250000e+01 -5.6613601684570312e+01 -1.0681800079345703e+02 6.9551300048828125e+01 -5.6709098815917969e+01 -9.4661102294921875e+01 6.9550094604492188e+01 -6.2956199645996094e+01 -9.4659400939941406e+01 6.9551696777343750e+01 -6.2955997467041016e+01 -9.4514602661132812e+01 6.9690895080566406e+01 -6.2941497802734375e+01 -9.4514198303222656e+01 6.9692100524902344e+01 -6.2941497802734375e+01 -1.0268899536132812e+02 6.9502799987792969e+01 -5.5089599609375000e+01 -1.0294599914550781e+02 6.9551300048828125e+01 -5.4949298858642578e+01 -1.0269499969482422e+02 6.9694900512695312e+01 -5.4800201416015625e+01 -1.0269400024414062e+02 6.9639396667480469e+01 -5.4833499908447266e+01 -1.0295300292968750e+02 6.9691894531250000e+01 -5.4803798675537109e+01 -1.0269200134277344e+02 6.9553596496582031e+01 -5.4936901092529297e+01 -1.0269200134277344e+02 6.9552101135253906e+01 -5.4941299438476562e+01 -1.0269599914550781e+02 6.9754501342773438e+01 -5.4764400482177734e+01 -1.0388600158691406e+02 6.9551300048828125e+01 -5.5055599212646484e+01 -1.0391300201416016e+02 6.9691894531250000e+01 -5.4912300109863281e+01 -1.0485800170898438e+02 6.9691894531250000e+01 -5.5171199798583984e+01 -1.0480699920654297e+02 6.9551300048828125e+01 -5.5307701110839844e+01 -9.4804100036621094e+01 6.9551300048828125e+01 -6.1993698120117188e+01 -9.4661201477050781e+01 6.9691894531250000e+01 -6.1965599060058594e+01 -9.4893501281738281e+01 6.9691894531250000e+01 -6.1013198852539062e+01 -9.5033401489257812e+01 6.9551300048828125e+01 -6.1054100036621094e+01 -9.5328399658203125e+01 6.9691894531250000e+01 -5.9800800323486328e+01 -9.5462303161621094e+01 6.9551300048828125e+01 -5.9858097076416016e+01 -1.0054399871826172e+02 6.9691894531250000e+01 -5.5033798217773438e+01 -1.0162200164794922e+02 6.9691894531250000e+01 -5.4836700439453125e+01 -1.0163800048828125e+02 6.9551300048828125e+01 -5.4981601715087891e+01 -1.0058200073242188e+02 6.9551300048828125e+01 -5.5174598693847656e+01 -9.9567100524902344e+01 6.9551300048828125e+01 -5.5535999298095703e+01 -9.9506896972656250e+01 6.9691894531250000e+01 -5.5403301239013672e+01 -9.5462394714355469e+01 6.9551300048828125e+01 -5.9858001708984375e+01 -9.5854202270507812e+01 6.9551300048828125e+01 -5.9047698974609375e+01 -9.6319602966308594e+01 6.9551300048828125e+01 -5.8286102294921875e+01 -9.7126296997070312e+01 6.9551300048828125e+01 -5.7279300689697266e+01 -9.7019905090332031e+01 6.9691894531250000e+01 -5.7179801940917969e+01 -9.6199295043945312e+01 6.9691894531250000e+01 -5.8203899383544922e+01 -9.5726295471191406e+01 6.9691894531250000e+01 -5.8978099822998047e+01 -9.7751403808593750e+01 6.9551300048828125e+01 -5.6682800292968750e+01 -9.7657005310058594e+01 6.9691894531250000e+01 -5.6571701049804688e+01 -9.8431602478027344e+01 6.9551300048828125e+01 -5.6167800903320312e+01 -9.8350395202636719e+01 6.9691894531250000e+01 -5.6046798706054688e+01 -1.0477400207519531e+02 6.9553703308105469e+01 -6.1086898803710938e+01 -1.0477799987792969e+02 6.9552398681640625e+01 -6.1087799072265625e+01 -1.0481200408935547e+02 6.9551300048828125e+01 -6.0858997344970703e+01 -1.0495200347900391e+02 6.9500404357910156e+01 -6.1122200012207031e+01 -1.0467299652099609e+02 6.9639396667480469e+01 -6.1066799163818359e+01 -1.0460499572753906e+02 6.9754501342773438e+01 -6.1053298950195312e+01 -1.0466799926757812e+02 6.9691894531250000e+01 -6.0841003417968750e+01 -1.0463999938964844e+02 6.9694900512695312e+01 -6.1060298919677734e+01 -1.0484000396728516e+02 6.9551300048828125e+01 -6.0539398193359375e+01 -1.0484200286865234e+02 6.9551300048828125e+01 -6.0219898223876953e+01 -1.0481700134277344e+02 6.9551300048828125e+01 -5.9902500152587891e+01 -1.0469499969482422e+02 6.9691894531250000e+01 -6.0532398223876953e+01 -1.0469699859619141e+02 6.9691894531250000e+01 -6.0224998474121094e+01 -1.0467199707031250e+02 6.9691894531250000e+01 -5.9920600891113281e+01 -1.0457499694824219e+02 6.9691894531250000e+01 -5.9469600677490234e+01 -1.0471399688720703e+02 6.9551300048828125e+01 -5.9425498962402344e+01 -1.0447299957275391e+02 6.9691894531250000e+01 -5.9207996368408203e+01 -1.0460499572753906e+02 6.9551300048828125e+01 -5.9146198272705078e+01 -1.0433799743652344e+02 6.9691894531250000e+01 -5.8964496612548828e+01 -1.0445999908447266e+02 6.9551300048828125e+01 -5.8885200500488281e+01 -1.0465000152587891e+02 6.9551300048828125e+01 -6.1664600372314453e+01 -1.0453300476074219e+02 6.9691894531250000e+01 -6.1518901824951172e+01 -1.0449900054931641e+02 6.9785202026367188e+01 -6.1477401733398438e+01 -1.0405100250244141e+02 6.9691894531250000e+01 -5.8621803283691406e+01 -1.0415100097656250e+02 6.9551300048828125e+01 -5.8515499114990234e+01 -1.0384000396728516e+02 6.9691894531250000e+01 -5.8450599670410156e+01 -1.0392399597167969e+02 6.9551300048828125e+01 -5.8331401824951172e+01 -1.0360500335693359e+02 6.9691894531250000e+01 -5.8307300567626953e+01 -1.0367300415039062e+02 6.9551300048828125e+01 -5.8178398132324219e+01 -9.8430496215820312e+01 6.9557693481445312e+01 -6.1668796539306641e+01 -9.8366294860839844e+01 6.9528495788574219e+01 -6.1712100982666016e+01 -9.8306404113769531e+01 6.9520698547363281e+01 -6.1752498626708984e+01 -9.8149597167968750e+01 6.9500000000000000e+01 -6.1858200073242188e+01 -9.8722900390625000e+01 6.9806396484375000e+01 -6.1471702575683594e+01 -9.8676399230957031e+01 6.9720603942871094e+01 -6.1503002166748047e+01 -9.8648506164550781e+01 6.9694000244140625e+01 -6.1521797180175781e+01 -9.8574600219726562e+01 6.9623298645019531e+01 -6.1571697235107422e+01 -1.0247799682617188e+02 6.9754501342773438e+01 -5.8065700531005859e+01 -1.0269499969482422e+02 6.9551300048828125e+01 -5.7904197692871094e+01 -1.0248400115966797e+02 6.9552299499511719e+01 -5.7888702392578125e+01 -1.0248400115966797e+02 6.9553596496582031e+01 -5.7893199920654297e+01 -1.0248100280761719e+02 6.9639396667480469e+01 -5.7996501922607422e+01 -1.0268099975585938e+02 6.9691894531250000e+01 -5.8049198150634766e+01 -1.0248000335693359e+02 6.9694900512695312e+01 -5.8029899597167969e+01 -1.0248999786376953e+02 6.9500701904296875e+01 -5.7717700958251953e+01 -1.0300599670410156e+02 6.9691894531250000e+01 -5.8098499298095703e+01 -1.0331600189208984e+02 6.9691894531250000e+01 -5.8183300018310547e+01 -1.0303500366210938e+02 6.9551300048828125e+01 -5.7955898284912109e+01 -1.0336399841308594e+02 6.9551300048828125e+01 -5.8045600891113281e+01 -1.0367300415039062e+02 6.9551300048828125e+01 -5.8178199768066406e+01 -9.8754501342773438e+01 6.9691894531250000e+01 -6.1269996643066406e+01 -9.8620101928710938e+01 6.9551300048828125e+01 -6.1213798522949219e+01 -9.9000495910644531e+01 6.9691894531250000e+01 -6.0718902587890625e+01 -9.9271903991699219e+01 6.9691894531250000e+01 -6.0178802490234375e+01 -9.8868896484375000e+01 6.9551300048828125e+01 -6.0656398773193359e+01 -9.9143196105957031e+01 6.9551300048828125e+01 -6.0110496520996094e+01 -1.0240200042724609e+02 6.9551300048828125e+01 -5.7888298034667969e+01 -1.0103900146484375e+02 6.9551300048828125e+01 -5.8174800872802734e+01 -1.0240200042724609e+02 6.9691894531250000e+01 -5.8034000396728516e+01 -1.0193099975585938e+02 6.9551300048828125e+01 -5.7917301177978516e+01 -1.0147300720214844e+02 6.9551300048828125e+01 -5.8010498046875000e+01 -1.0110200500488281e+02 6.9691894531250000e+01 -5.8306198120117188e+01 -1.0110200500488281e+02 6.9691894531250000e+01 -5.8306102752685547e+01 -1.0151300048828125e+02 6.9691894531250000e+01 -5.8150600433349609e+01 -1.0194999694824219e+02 6.9691894531250000e+01 -5.8061801910400391e+01 -9.9715705871582031e+01 6.9551300048828125e+01 -5.9242500305175781e+01 -9.9946899414062500e+01 6.9551300048828125e+01 -5.8978099822998047e+01 -9.9828697204589844e+01 6.9691894531250000e+01 -5.9334503173828125e+01 -1.0005299377441406e+02 6.9691894531250000e+01 -5.9077800750732422e+01 -9.9623298645019531e+01 6.9691894531250000e+01 -5.9605503082275391e+01 -9.9504302978515625e+01 6.9551300048828125e+01 -5.9521499633789062e+01 -1.0073299407958984e+02 6.9551300048828125e+01 -5.8340400695800781e+01 -1.0080799865722656e+02 6.9691894531250000e+01 -5.8465099334716797e+01 -1.0053300476074219e+02 6.9691894531250000e+01 -5.8649398803710938e+01 -1.0044599914550781e+02 6.9551300048828125e+01 -5.8532302856445312e+01 -8.4903297424316406e+01 7.0308296203613281e+01 -7.0845703125000000e+01 -8.4953300476074219e+01 6.9884796142578125e+01 -7.0828804016113281e+01 -8.4880599975585938e+01 6.9882301330566406e+01 -7.0812599182128906e+01 -8.4808601379394531e+01 7.0309494018554688e+01 -7.0801895141601562e+01 -8.4820701599121094e+01 6.9880401611328125e+01 -7.0799301147460938e+01 -8.4814895629882812e+01 6.9880203247070312e+01 -7.0794898986816406e+01 -8.4715400695800781e+01 7.0310699462890625e+01 -7.0758796691894531e+01 -8.4683593750000000e+01 6.9878303527832031e+01 -7.0694198608398438e+01 -8.4603302001953125e+01 6.9880500793457031e+01 -7.0536003112792969e+01 -8.4593299865722656e+01 7.0309600830078125e+01 -7.0555397033691406e+01 -8.4603500366210938e+01 6.9880401611328125e+01 -7.0541099548339844e+01 -8.4596405029296875e+01 7.0310195922851562e+01 -7.0589698791503906e+01 -8.4675605773925781e+01 7.0310501098632812e+01 -7.0702301025390625e+01 -8.4902397155761719e+01 6.9746398925781250e+01 -7.0796104431152344e+01 -8.4838005065917969e+01 6.9809104919433594e+01 -7.0796104431152344e+01 -8.4723098754882812e+01 6.9739997863769531e+01 -7.0689300537109375e+01 -8.4656997680664062e+01 6.9700401306152344e+01 -7.0536102294921875e+01 -8.4651298522949219e+01 6.9696502685546875e+01 -7.0378402709960938e+01 -8.4796195983886719e+01 6.9551300048828125e+01 -7.0403594970703125e+01 -8.4793701171875000e+01 6.9553703308105469e+01 -7.0403099060058594e+01 -8.4798400878906250e+01 6.9562705993652344e+01 -7.0536102294921875e+01 -8.4652603149414062e+01 6.9691894531250000e+01 -7.0378700256347656e+01 -8.4989196777343750e+01 6.9512397766113281e+01 -7.0536102294921875e+01 -8.4989196777343750e+01 6.9559204101562500e+01 -7.0628997802734375e+01 -8.4836296081542969e+01 6.9629699707031250e+01 -7.0689300537109375e+01 -8.4989196777343750e+01 6.9723602294921875e+01 -7.0796104431152344e+01 -8.4989196777343750e+01 6.9695800781250000e+01 -7.0773994445800781e+01 -8.4989196777343750e+01 6.9589500427246094e+01 -7.0689300537109375e+01 -8.8652999877929688e+01 7.0308601379394531e+01 -7.0651802062988281e+01 -8.8635398864746094e+01 6.9883300781250000e+01 -7.0628601074218750e+01 -8.8621299743652344e+01 7.0308601379394531e+01 -7.0683395385742188e+01 -8.8615295410156250e+01 6.9882202148437500e+01 -7.0675094604492188e+01 -8.8506698608398438e+01 7.0308998107910156e+01 -7.0798004150390625e+01 -8.8496696472167969e+01 6.9882202148437500e+01 -7.0774894714355469e+01 -8.8485099792480469e+01 7.0308700561523438e+01 -7.0803802490234375e+01 -8.8473999023437500e+01 6.9882202148437500e+01 -7.0793998718261719e+01 -8.8407997131347656e+01 6.9883598327636719e+01 -7.0809700012207031e+01 -8.8331398010253906e+01 6.9885200500488281e+01 -7.0827995300292969e+01 -8.8294403076171875e+01 6.9693000793457031e+01 -7.0779396057128906e+01 -8.8294403076171875e+01 6.9692199707031250e+01 -7.0778495788574219e+01 -8.8294403076171875e+01 6.9551498413085938e+01 -7.0632797241210938e+01 -8.8294403076171875e+01 6.9550697326660156e+01 -7.0632003784179688e+01 -8.6745704650878906e+01 6.9785202026367188e+01 -5.8076198577880859e+01 -8.6968299865722656e+01 6.9551300048828125e+01 -5.7888999938964844e+01 -8.6795097351074219e+01 6.9691894531250000e+01 -5.8034698486328125e+01 -8.8466400146484375e+01 6.9595901489257812e+01 -7.0632003784179688e+01 -8.8490005493164062e+01 6.9553703308105469e+01 -7.0471000671386719e+01 -8.8487495422363281e+01 6.9551300048828125e+01 -7.0470603942871094e+01 -8.8593803405761719e+01 6.9720100402832031e+01 -7.0632003784179688e+01 -8.8632400512695312e+01 6.9696502685546875e+01 -7.0495704650878906e+01 -8.8630996704101562e+01 6.9691894531250000e+01 -7.0495498657226562e+01 -8.8471801757812500e+01 6.9793403625488281e+01 -7.0779396057128906e+01 -8.8396301269531250e+01 6.9719902038574219e+01 -7.0779396057128906e+01 -8.4916503906250000e+01 6.9512397766113281e+01 -5.7791797637939453e+01 -8.4916503906250000e+01 6.9723503112792969e+01 -5.8051998138427734e+01 -8.4916503906250000e+01 6.9695800781250000e+01 -5.8029899597167969e+01 -8.4916503906250000e+01 6.9589401245117188e+01 -5.7945098876953125e+01 -8.4916503906250000e+01 6.9559204101562500e+01 -5.7884998321533203e+01 -8.4830101013183594e+01 7.0308296203613281e+01 -5.8101596832275391e+01 -8.4880599975585938e+01 6.9884796142578125e+01 -5.8084800720214844e+01 -8.4807800292968750e+01 6.9882301330566406e+01 -5.8068599700927734e+01 -8.4735801696777344e+01 7.0309494018554688e+01 -5.8057800292968750e+01 -8.4747901916503906e+01 6.9880302429199219e+01 -5.8055198669433594e+01 -8.4742095947265625e+01 6.9880203247070312e+01 -5.8050800323486328e+01 -8.4642295837402344e+01 7.0310699462890625e+01 -5.8014602661132812e+01 -8.4610702514648438e+01 6.9878303527832031e+01 -5.7950000762939453e+01 -8.4530395507812500e+01 6.9880500793457031e+01 -5.7791698455810547e+01 -8.4520401000976562e+01 7.0309600830078125e+01 -5.7811199188232422e+01 -8.4530700683593750e+01 6.9880302429199219e+01 -5.7796897888183594e+01 -8.4523498535156250e+01 7.0310195922851562e+01 -5.7845397949218750e+01 -8.4602699279785156e+01 7.0310501098632812e+01 -5.7958202362060547e+01 -9.0828704833984375e+01 6.9785202026367188e+01 -5.8076198577880859e+01 -9.0793800354003906e+01 6.9691894531250000e+01 -5.8034698486328125e+01 -9.0671096801757812e+01 6.9551300048828125e+01 -5.7888999938964844e+01 -8.4765205383300781e+01 6.9809104919433594e+01 -5.8051998138427734e+01 -8.4650199890136719e+01 6.9739997863769531e+01 -5.7945098876953125e+01 -8.4584304809570312e+01 6.9700302124023438e+01 -5.7791797637939453e+01 -8.4578498840332031e+01 6.9696502685546875e+01 -5.7634101867675781e+01 -8.4723396301269531e+01 6.9551300048828125e+01 -5.7659297943115234e+01 -8.4720901489257812e+01 6.9553802490234375e+01 -5.7658901214599609e+01 -8.4725601196289062e+01 6.9562599182128906e+01 -5.7791797637939453e+01 -8.4579902648925781e+01 6.9691894531250000e+01 -5.7634300231933594e+01 -8.4829597473144531e+01 6.9746398925781250e+01 -5.8051998138427734e+01 -8.4763603210449219e+01 6.9629600524902344e+01 -5.7945098876953125e+01 -9.3912101745605469e+01 7.0308601379394531e+01 -5.7907699584960938e+01 -9.3894401550292969e+01 6.9883300781250000e+01 -5.7884498596191406e+01 -9.3880195617675781e+01 7.0308601379394531e+01 -5.7939601898193359e+01 -9.3874298095703125e+01 6.9882301330566406e+01 -5.7931198120117188e+01 -9.3765800476074219e+01 7.0308998107910156e+01 -5.8054000854492188e+01 -9.3755798339843750e+01 6.9882301330566406e+01 -5.8030799865722656e+01 -9.3744102478027344e+01 7.0308700561523438e+01 -5.8059799194335938e+01 -9.3732994079589844e+01 6.9882301330566406e+01 -5.8049999237060547e+01 -9.3667098999023438e+01 6.9883598327636719e+01 -5.8065700531005859e+01 -9.3590499877929688e+01 6.9885200500488281e+01 -5.8083999633789062e+01 -9.3553497314453125e+01 6.9693000793457031e+01 -5.8035297393798828e+01 -9.3553497314453125e+01 6.9692199707031250e+01 -5.8034500122070312e+01 -9.3553497314453125e+01 6.9551498413085938e+01 -5.7888702392578125e+01 -9.3553497314453125e+01 6.9550697326660156e+01 -5.7887901306152344e+01 -8.5118705749511719e+01 6.9551300048828125e+01 -5.5393901824951172e+01 -8.4974197387695312e+01 6.9695396423339844e+01 -5.5368698120117188e+01 -8.4975196838378906e+01 6.9691894531250000e+01 -5.5368801116943359e+01 -8.5117897033691406e+01 6.9552101135253906e+01 -5.5393798828125000e+01 -8.5130805969238281e+01 6.9882301330566406e+01 -5.5071399688720703e+01 -8.5119705200195312e+01 7.0308700561523438e+01 -5.5061798095703125e+01 -8.5109100341796875e+01 6.9882301330566406e+01 -5.5089599609375000e+01 -8.5097198486328125e+01 7.0308898925781250e+01 -5.5068000793457031e+01 -8.4990501403808594e+01 6.9882301330566406e+01 -5.5190002441406250e+01 -8.4984695434570312e+01 7.0308601379394531e+01 -5.5181999206542969e+01 -8.4970695495605469e+01 6.9883300781250000e+01 -5.5236099243164062e+01 -8.4951896667480469e+01 7.0308502197265625e+01 -5.5215198516845703e+01 -8.5283195495605469e+01 6.9885498046875000e+01 -5.5034202575683594e+01 -8.5204101562500000e+01 6.9883804321289062e+01 -5.5053497314453125e+01 -9.3725502014160156e+01 6.9595901489257812e+01 -5.7887901306152344e+01 -9.3749099731445312e+01 6.9553802490234375e+01 -5.7727199554443359e+01 -9.3746498107910156e+01 6.9551300048828125e+01 -5.7726699829101562e+01 -9.3852897644042969e+01 6.9720100402832031e+01 -5.7887901306152344e+01 -9.3891395568847656e+01 6.9696502685546875e+01 -5.7751998901367188e+01 -9.3889999389648438e+01 6.9691894531250000e+01 -5.7751800537109375e+01 -9.3730895996093750e+01 6.9793403625488281e+01 -5.8035297393798828e+01 -9.3655403137207031e+01 6.9719902038574219e+01 -5.8035297393798828e+01 -8.5012901306152344e+01 6.9719100952148438e+01 -5.5232799530029297e+01 -8.5310493469238281e+01 6.9551300048828125e+01 -5.5231601715087891e+01 -8.5309600830078125e+01 6.9691894531250000e+01 -5.5085899353027344e+01 -8.5210899353027344e+01 6.9719100952148438e+01 -5.5085399627685547e+01 -8.5309600830078125e+01 6.9693000793457031e+01 -5.5085597991943359e+01 -8.5310493469238281e+01 6.9550903320312500e+01 -5.5232799530029297e+01 -8.5141601562500000e+01 6.9594894409179688e+01 -5.5232799530029297e+01 -8.5134605407714844e+01 6.9792701721191406e+01 -5.5085399627685547e+01 -9.3984497070312500e+01 6.9884796142578125e+01 -5.5038097381591797e+01 -9.4034904479980469e+01 7.0308296203613281e+01 -5.5021301269531250e+01 -9.4057205200195312e+01 6.9882301330566406e+01 -5.5054298400878906e+01 -9.4129196166992188e+01 7.0309494018554688e+01 -5.5064998626708984e+01 -9.4117095947265625e+01 6.9880302429199219e+01 -5.5067699432373047e+01 -9.4122901916503906e+01 6.9880203247070312e+01 -5.5072097778320312e+01 -9.4222702026367188e+01 7.0310699462890625e+01 -5.5108303070068359e+01 -9.4254302978515625e+01 6.9878303527832031e+01 -5.5172901153564453e+01 -9.4334602355957031e+01 6.9880500793457031e+01 -5.5331199645996094e+01 -9.4344604492187500e+01 7.0309600830078125e+01 -5.5311698913574219e+01 -9.4334297180175781e+01 6.9880302429199219e+01 -5.5326000213623047e+01 -9.4341598510742188e+01 7.0310195922851562e+01 -5.5277500152587891e+01 -9.4262298583984375e+01 7.0310501098632812e+01 -5.5164699554443359e+01 -9.4286499023437500e+01 6.9696502685546875e+01 -5.5488800048828125e+01 -9.4285102844238281e+01 6.9691894531250000e+01 -5.5488601684570312e+01 -9.4144096374511719e+01 6.9553802490234375e+01 -5.5464000701904297e+01 -9.4141601562500000e+01 6.9551300048828125e+01 -5.5463600158691406e+01 -8.7312805175781250e+01 6.9692001342773438e+01 -5.5073200225830078e+01 -8.7276100158691406e+01 6.9785202026367188e+01 -5.5031799316406250e+01 -8.7313194274902344e+01 6.9690895080566406e+01 -5.5073699951171875e+01 -8.7441200256347656e+01 6.9551696777343750e+01 -5.5218399047851562e+01 -8.7442802429199219e+01 6.9550003051757812e+01 -5.5220100402832031e+01 -9.3948501586914062e+01 6.9559204101562500e+01 -5.5237899780273438e+01 -9.3948501586914062e+01 6.9512397766113281e+01 -5.5331199645996094e+01 -9.4139396667480469e+01 6.9562599182128906e+01 -5.5331199645996094e+01 -9.3948501586914062e+01 6.9695800781250000e+01 -5.5093002319335938e+01 -9.3948501586914062e+01 6.9589401245117188e+01 -5.5177799224853516e+01 -9.4101501464843750e+01 6.9629600524902344e+01 -5.5177799224853516e+01 -9.4214797973632812e+01 6.9739997863769531e+01 -5.5177799224853516e+01 -9.4099800109863281e+01 6.9809104919433594e+01 -5.5070899963378906e+01 -9.4035400390625000e+01 6.9746398925781250e+01 -5.5070899963378906e+01 -9.3948501586914062e+01 6.9723503112792969e+01 -5.5070899963378906e+01 -9.4280799865722656e+01 6.9700302124023438e+01 -5.5331199645996094e+01 -8.7497894287109375e+01 6.9690895080566406e+01 -5.3642002105712891e+01 -8.7497596740722656e+01 6.9692100524902344e+01 -5.3642002105712891e+01 -8.7643898010253906e+01 6.9550003051757812e+01 -5.3660797119140625e+01 -8.7642105102539062e+01 6.9551696777343750e+01 -5.3660602569580078e+01 -9.1121299743652344e+01 6.9551300048828125e+01 -5.5233898162841797e+01 -9.1343093872070312e+01 6.9785202026367188e+01 -5.5046600341796875e+01 -9.1293899536132812e+01 6.9691894531250000e+01 -5.5088199615478516e+01 -8.7643898010253906e+01 6.9550094604492188e+01 -5.3660797119140625e+01 -8.7641899108886719e+01 6.9551300048828125e+01 -5.3659202575683594e+01 -8.7497299194335938e+01 6.9691894531250000e+01 -5.3641502380371094e+01 -8.7842796325683594e+01 6.9551300048828125e+01 -5.2598396301269531e+01 -8.8040298461914062e+01 6.9551300048828125e+01 -5.1971599578857422e+01 -8.8301193237304688e+01 6.9551300048828125e+01 -5.1366199493408203e+01 -8.7701904296875000e+01 6.9691894531250000e+01 -5.2561203002929688e+01 -8.7903594970703125e+01 6.9691894531250000e+01 -5.1921100616455078e+01 -8.8170700073242188e+01 6.9691894531250000e+01 -5.1301399230957031e+01 -9.1400398254394531e+01 6.9552200317382812e+01 -5.3591899871826172e+01 -9.1236701965332031e+01 6.9500999450683594e+01 -5.3562500000000000e+01 -9.1574600219726562e+01 6.9754501342773438e+01 -5.3623199462890625e+01 -9.1539299011230469e+01 6.9694900512695312e+01 -5.3616901397705078e+01 -9.1506500244140625e+01 6.9639396667480469e+01 -5.3611000061035156e+01 -9.1404800415039062e+01 6.9553596496582031e+01 -5.3592700958251953e+01 -8.8549896240234375e+01 6.9691894531250000e+01 -5.0641201019287109e+01 -8.8671501159667969e+01 6.9551300048828125e+01 -5.0721599578857422e+01 -8.9005905151367188e+01 6.9691894531250000e+01 -5.0042301177978516e+01 -8.9115600585937500e+01 6.9551300048828125e+01 -5.0138202667236328e+01 -8.9492401123046875e+01 6.9691894531250000e+01 -4.9553199768066406e+01 -8.9588905334472656e+01 6.9551300048828125e+01 -4.9662399291992188e+01 -9.1644897460937500e+01 6.9692001342773438e+01 -5.3215900421142578e+01 -9.1505996704101562e+01 6.9551300048828125e+01 -5.3171703338623047e+01 -9.1997497558593750e+01 6.9692001342773438e+01 -5.2491699218750000e+01 -9.2557601928710938e+01 6.9691894531250000e+01 -5.1926399230957031e+01 -9.1878196716308594e+01 6.9551300048828125e+01 -5.2407997131347656e+01 -9.2472595214843750e+01 6.9551300048828125e+01 -5.1808101654052734e+01 -9.0100105285644531e+01 6.9691894531250000e+01 -4.9089302062988281e+01 -9.0179901123046875e+01 6.9551300048828125e+01 -4.9211101531982422e+01 -9.0751800537109375e+01 6.9691894531250000e+01 -4.8722503662109375e+01 -9.0814704895019531e+01 6.9551300048828125e+01 -4.8853900909423828e+01 -9.1384902954101562e+01 6.9691894531250000e+01 -4.8462799072265625e+01 -9.1432701110839844e+01 6.9551300048828125e+01 -4.8600498199462891e+01 -9.4397499084472656e+01 6.9691894531250000e+01 -5.1369297027587891e+01 -9.4464797973632812e+01 6.9694900512695312e+01 -5.1364803314208984e+01 -9.4465003967285156e+01 6.9639396667480469e+01 -5.1331401824951172e+01 -9.4397094726562500e+01 6.9551300048828125e+01 -5.1223598480224609e+01 -9.4465797424316406e+01 6.9553596496582031e+01 -5.1228000640869141e+01 -9.4465797424316406e+01 6.9552200317382812e+01 -5.1223598480224609e+01 -9.4466796875000000e+01 6.9501602172851562e+01 -5.1064399719238281e+01 -9.4464599609375000e+01 6.9754501342773438e+01 -5.1400596618652344e+01 -9.3422096252441406e+01 6.9692001342773438e+01 -5.1504798889160156e+01 -9.3380699157714844e+01 6.9551300048828125e+01 -5.1365100860595703e+01 -9.3804100036621094e+01 6.9754501342773438e+01 -4.8070098876953125e+01 -9.3801002502441406e+01 6.9553596496582031e+01 -4.8242599487304688e+01 -9.3802902221679688e+01 6.9639396667480469e+01 -4.8139198303222656e+01 -9.3365196228027344e+01 6.9691894531250000e+01 -4.8107097625732422e+01 -9.3803504943847656e+01 6.9694900512695312e+01 -4.8105796813964844e+01 -9.3370903015136719e+01 6.9551300048828125e+01 -4.8252700805664062e+01 -9.3800903320312500e+01 6.9552200317382812e+01 -4.8246997833251953e+01 -9.3797897338867188e+01 6.9501304626464844e+01 -4.8410800933837891e+01 -9.2698898315429688e+01 6.9691894531250000e+01 -4.8161300659179688e+01 -9.2036201477050781e+01 6.9691894531250000e+01 -4.8277297973632812e+01 -9.2717102050781250e+01 6.9551300048828125e+01 -4.8305900573730469e+01 -9.2068397521972656e+01 6.9551300048828125e+01 -4.8419399261474609e+01 -9.4619598388671875e+01 6.9551300048828125e+01 -5.1227001190185547e+01 -9.4613899230957031e+01 6.9691894531250000e+01 -5.1372600555419922e+01 -9.4773902893066406e+01 6.9691894531250000e+01 -5.1382301330566406e+01 -9.4933601379394531e+01 6.9691894531250000e+01 -5.1398799896240234e+01 -9.5092605590820312e+01 6.9691894531250000e+01 -5.1421897888183594e+01 -9.5092697143554688e+01 6.9691894531250000e+01 -5.1421897888183594e+01 -9.5116798400878906e+01 6.9551300048828125e+01 -5.1278198242187500e+01 -9.4785804748535156e+01 6.9551300048828125e+01 -5.1237098693847656e+01 -9.4951499938964844e+01 6.9551300048828125e+01 -5.1254199981689453e+01 -9.5116500854492188e+01 6.9551300048828125e+01 -5.1278099060058594e+01 -9.3983901977539062e+01 6.9551300048828125e+01 -4.8253398895263672e+01 -9.3990699768066406e+01 6.9691894531250000e+01 -4.8107799530029297e+01 -9.4289398193359375e+01 6.9551300048828125e+01 -4.8273300170898438e+01 -9.4594299316406250e+01 6.9551300048828125e+01 -4.8304302215576172e+01 -9.4897796630859375e+01 6.9551300048828125e+01 -4.8346500396728516e+01 -9.4301498413085938e+01 6.9691894531250000e+01 -4.8128097534179688e+01 -9.4611694335937500e+01 6.9691894531250000e+01 -4.8159599304199219e+01 -9.4920501708984375e+01 6.9691894531250000e+01 -4.8202499389648438e+01 -9.5692794799804688e+01 7.0308898925781250e+01 -5.1290500640869141e+01 -9.5663299560546875e+01 7.0012596130371094e+01 -5.1318702697753906e+01 -9.5668098449707031e+01 7.0309303283691406e+01 -5.1328300476074219e+01 -9.5619598388671875e+01 7.0309997558593750e+01 -5.1402900695800781e+01 -9.5554595947265625e+01 7.0010993957519531e+01 -5.1440601348876953e+01 -9.5513298034667969e+01 7.0310104370117188e+01 -5.1484802246093750e+01 -9.5406303405761719e+01 7.0012596130371094e+01 -5.1508998870849609e+01 -9.5413795471191406e+01 7.0309303283691406e+01 -5.1517501831054688e+01 -9.5385795593261719e+01 7.0308998107910156e+01 -5.1526798248291016e+01 -9.5305000305175781e+01 6.9883804321289062e+01 -5.1513599395751953e+01 -9.5300506591796875e+01 6.9883895874023438e+01 -5.1513599395751953e+01 -9.5402397155761719e+01 6.9881202697753906e+01 -5.1503501892089844e+01 -9.5372200012207031e+01 6.9881996154785156e+01 -5.1507202148437500e+01 -9.5320999145507812e+01 6.9883193969726562e+01 -5.1513599395751953e+01 -9.5314498901367188e+01 6.9883506774902344e+01 -5.1513599395751953e+01 -9.5290306091308594e+01 6.9884201049804688e+01 -5.1513000488281250e+01 -9.5279998779296875e+01 6.9884498596191406e+01 -5.1512401580810547e+01 -9.5517700195312500e+01 6.9879798889160156e+01 -5.1450302124023438e+01 -9.5550697326660156e+01 6.9879501342773438e+01 -5.1435100555419922e+01 -9.5659301757812500e+01 6.9881202697753906e+01 -5.1313198089599609e+01 -9.5661094665527344e+01 6.9881294250488281e+01 -5.1307903289794922e+01 -9.5276901245117188e+01 6.9551300048828125e+01 -5.1306697845458984e+01 -9.5276603698730469e+01 6.9552505493164062e+01 -5.1307903289794922e+01 -9.5250000000000000e+01 6.9691894531250000e+01 -5.1449802398681641e+01 -9.5249198913574219e+01 6.9706596374511719e+01 -5.1454101562500000e+01 -9.5243095397949219e+01 6.9816902160644531e+01 -5.1486598968505859e+01 -9.5248703002929688e+01 6.9716201782226562e+01 -5.1457000732421875e+01 -9.5657806396484375e+01 6.9837196350097656e+01 -4.8287498474121094e+01 -9.5186203002929688e+01 6.9551300048828125e+01 -4.8393997192382812e+01 -9.5649597167968750e+01 6.9691894531250000e+01 -4.8330200195312500e+01 -9.5652000427246094e+01 6.9734001159667969e+01 -4.8317901611328125e+01 -9.5500602722167969e+01 6.9691894531250000e+01 -4.8302097320556641e+01 -9.5613304138183594e+01 6.9539199829101562e+01 -4.8518501281738281e+01 -9.5622100830078125e+01 6.9551300048828125e+01 -4.8473297119140625e+01 -9.5473999023437500e+01 6.9551300048828125e+01 -4.8445301055908203e+01 -9.5643600463867188e+01 6.9661300659179688e+01 -4.8361499786376953e+01 -9.5210899353027344e+01 6.9691894531250000e+01 -4.8250400543212891e+01 -9.5843299865722656e+01 7.0007102966308594e+01 -4.8353298187255859e+01 -9.5849296569824219e+01 7.0309196472167969e+01 -4.8340297698974609e+01 -9.5731498718261719e+01 7.0307800292968750e+01 -4.8275897979736328e+01 -9.5990699768066406e+01 7.0308700561523438e+01 -4.8563899993896484e+01 -9.5966300964355469e+01 7.0308998107910156e+01 -4.8505397796630859e+01 -9.5959999084472656e+01 7.0007102966308594e+01 -4.8511596679687500e+01 -9.5939102172851562e+01 7.0309494018554688e+01 -4.8439998626708984e+01 -9.5854103088378906e+01 7.0309196472167969e+01 -4.8345600128173828e+01 -9.5955101013183594e+01 6.9881599426269531e+01 -4.8515098571777344e+01 -9.5955299377441406e+01 6.9881599426269531e+01 -4.8516399383544922e+01 -9.5838500976562500e+01 6.9881599426269531e+01 -4.8356800079345703e+01 -9.5837699890136719e+01 6.9881599426269531e+01 -4.8356498718261719e+01 -9.5494903564453125e+01 6.9798202514648438e+01 -5.1455501556396484e+01 -9.5339607238769531e+01 6.9551300048828125e+01 -5.1308200836181641e+01 -9.5341697692871094e+01 6.9507499694824219e+01 -5.1117198944091797e+01 -9.5501304626464844e+01 6.9605201721191406e+01 -5.1308200836181641e+01 -9.5507797241210938e+01 6.9551300048828125e+01 -5.1135700225830078e+01 -9.5652496337890625e+01 6.9691894531250000e+01 -5.1151802062988281e+01 -9.5618202209472656e+01 6.9729301452636719e+01 -5.1308200836181641e+01 -9.5656898498535156e+01 6.9706703186035156e+01 -5.1152301788330078e+01 -9.5328804016113281e+01 6.9692199707031250e+01 -5.1455501556396484e+01 -9.5425201416015625e+01 6.9724296569824219e+01 -5.1455501556396484e+01 -9.5708496093750000e+01 6.9678596496582031e+01 -4.8356296539306641e+01 -9.5765800476074219e+01 6.9575897216796875e+01 -4.8516399383544922e+01 -9.5902603149414062e+01 6.9707901000976562e+01 -4.8516399383544922e+01 -9.5925193786621094e+01 6.9694000244140625e+01 -4.8703498840332031e+01 -9.5924598693847656e+01 6.9691894531250000e+01 -4.8703399658203125e+01 -9.5779800415039062e+01 6.9551300048828125e+01 -4.8687301635742188e+01 -9.5779594421386719e+01 6.9551200866699219e+01 -4.8687301635742188e+01 -9.5801895141601562e+01 6.9768798828125000e+01 -4.8356296539306641e+01 -1.4222300720214844e+02 7.0403999328613281e+01 -4.8336101531982422e+01 -1.4222300720214844e+02 7.0474296569824219e+01 -4.8263301849365234e+01 -1.4230500793457031e+02 7.0404800415039062e+01 -4.8343498229980469e+01 -1.4231900024414062e+02 7.0474601745605469e+01 -4.8272098541259766e+01 -1.4250500488281250e+02 7.0406105041503906e+01 -4.8440502166748047e+01 -1.4262899780273438e+02 7.0405799865722656e+01 -4.8625000000000000e+01 -1.4264300537109375e+02 7.0403999328613281e+01 -4.8847000122070312e+01 -1.4255300903320312e+02 7.0474998474121094e+01 -4.8385700225830078e+01 -1.4269799804687500e+02 7.0474899291992188e+01 -4.8601398468017578e+01 -1.4271501159667969e+02 7.0474296569824219e+01 -4.8861000061035156e+01 -1.3891300964355469e+02 7.0403999328613281e+01 -4.8336101531982422e+01 -1.3891300964355469e+02 7.0474296569824219e+01 -4.8263301849365234e+01 -1.4138699340820312e+02 7.0499893188476562e+01 -5.6170799255371094e+01 -1.4125099182128906e+02 7.0451400756835938e+01 -5.6429599761962891e+01 -1.4125199890136719e+02 7.0451599121093750e+01 -5.6428398132324219e+01 -1.4106799316406250e+02 7.0330101013183594e+01 -5.6782001495361328e+01 -1.4108300781250000e+02 7.0357002258300781e+01 -5.6737899780273438e+01 -1.4107699584960938e+02 7.0355697631835938e+01 -5.6762901306152344e+01 -1.4111399841308594e+02 7.0402694702148438e+01 -5.6689002990722656e+01 -1.4111399841308594e+02 7.0402694702148438e+01 -5.6689098358154297e+01 -1.4111000061035156e+02 7.0401000976562500e+01 -5.6697700500488281e+01 -1.4121699523925781e+02 7.0439193725585938e+01 -5.6494300842285156e+01 -1.3869799804687500e+02 7.0405105590820312e+01 -4.8393001556396484e+01 -1.3847799682617188e+02 7.0474601745605469e+01 -4.8513801574707031e+01 -1.3841799926757812e+02 7.0474296569824219e+01 -4.8679298400878906e+01 -1.3854100036621094e+02 7.0404899597167969e+01 -4.8550098419189453e+01 -1.3849000549316406e+02 7.0403999328613281e+01 -4.8691699981689453e+01 -1.3866200256347656e+02 7.0474700927734375e+01 -4.8329902648925781e+01 -1.4109399414062500e+02 7.0357299804687500e+01 -5.6743301391601562e+01 -1.4125900268554688e+02 7.0403999328613281e+01 -5.6536399841308594e+01 -1.4206900024414062e+02 7.0403999328613281e+01 -5.5816596984863281e+01 -1.4202499389648438e+02 7.0474296569824219e+01 -5.5758399963378906e+01 -1.4294999694824219e+02 7.0474296569824219e+01 -5.5173301696777344e+01 -1.4298400878906250e+02 7.0403999328613281e+01 -5.5237899780273438e+01 -1.3473500061035156e+02 7.0403999328613281e+01 -7.0378601074218750e+01 -1.3466299438476562e+02 7.0474296569824219e+01 -7.0366096496582031e+01 -1.4536898803710938e+02 7.0473197937011719e+01 -5.4622699737548828e+01 -1.4536898803710938e+02 7.0473899841308594e+01 -5.4620502471923828e+01 -1.4513899230957031e+02 7.0474296569824219e+01 -5.4622501373291016e+01 -1.4537001037597656e+02 7.0498199462890625e+01 -5.4549602508544922e+01 -1.4536799621582031e+02 7.0430297851562500e+01 -5.4674396514892578e+01 -1.4514100646972656e+02 7.0403999328613281e+01 -5.4695301055908203e+01 -1.4536799621582031e+02 7.0402503967285156e+01 -5.4691097259521484e+01 -1.4536799621582031e+02 7.0372703552246094e+01 -5.4708999633789062e+01 -1.4431298828125000e+02 7.0474296569824219e+01 -5.4707603454589844e+01 -1.4432600402832031e+02 7.0403999328613281e+01 -5.4779201507568359e+01 -1.4353799438476562e+02 7.0403999328613281e+01 -5.4993396759033203e+01 -1.4351300048828125e+02 7.0474296569824219e+01 -5.4924999237060547e+01 -1.3515699768066406e+02 7.0403999328613281e+01 -7.0880599975585938e+01 -1.3515699768066406e+02 7.0474296569824219e+01 -7.0953399658203125e+01 -1.3508399963378906e+02 7.0404701232910156e+01 -7.0874694824218750e+01 -1.3507099914550781e+02 7.0474601745605469e+01 -7.0946403503417969e+01 -1.3488200378417969e+02 7.0406105041503906e+01 -7.0782104492187500e+01 -1.3475399780273438e+02 7.0405799865722656e+01 -7.0600303649902344e+01 -1.3483500671386719e+02 7.0474899291992188e+01 -7.0837898254394531e+01 -1.3468499755859375e+02 7.0474899291992188e+01 -7.0625297546386719e+01 -1.4549000549316406e+02 7.0474296569824219e+01 -5.4624301910400391e+01 -1.4548699951171875e+02 7.0403999328613281e+01 -5.4697101593017578e+01 -1.4649699401855469e+02 7.0403999328613281e+01 -5.4821800231933594e+01 -1.4706599426269531e+02 7.0403999328613281e+01 -5.4988601684570312e+01 -1.4759799194335938e+02 7.0403999328613281e+01 -5.5238399505615234e+01 -1.4651300048828125e+02 7.0474296569824219e+01 -5.4750698089599609e+01 -1.4709100341796875e+02 7.0474296569824219e+01 -5.4920299530029297e+01 -1.4763400268554688e+02 7.0474296569824219e+01 -5.5175399780273438e+01 -1.3846400451660156e+02 7.0403999328613281e+01 -7.0880599975585938e+01 -1.3846400451660156e+02 7.0474296569824219e+01 -7.0953399658203125e+01 -1.4905300903320312e+02 7.0474296569824219e+01 -5.6579502105712891e+01 -1.4864100646972656e+02 7.0474296569824219e+01 -5.6000999450683594e+01 -1.4814700317382812e+02 7.0474296569824219e+01 -5.5525199890136719e+01 -1.4899000549316406e+02 7.0403999328613281e+01 -5.6616100311279297e+01 -1.4858599853515625e+02 7.0403999328613281e+01 -5.6048698425292969e+01 -1.4810099792480469e+02 7.0403999328613281e+01 -5.5582000732421875e+01 -1.3867900085449219e+02 7.0405105590820312e+01 -7.0823699951171875e+01 -1.3889900207519531e+02 7.0474601745605469e+01 -7.0702903747558594e+01 -1.3895800781250000e+02 7.0474296569824219e+01 -7.0539100646972656e+01 -1.3883599853515625e+02 7.0404899597167969e+01 -7.0666496276855469e+01 -1.3888600158691406e+02 7.0403999328613281e+01 -7.0526298522949219e+01 -1.3871499633789062e+02 7.0474700927734375e+01 -7.0886703491210938e+01 -1.4953399658203125e+02 7.0474296569824219e+01 -5.7708400726318359e+01 -1.4971701049804688e+02 7.0474296569824219e+01 -5.8569698333740234e+01 -1.4946398925781250e+02 7.0403999328613281e+01 -5.7728900909423828e+01 -1.4964500427246094e+02 7.0403999328613281e+01 -5.8579898834228516e+01 -1.4926100158691406e+02 7.0403999328613281e+01 -5.7157501220703125e+01 -1.4932798767089844e+02 7.0474296569824219e+01 -5.7129100799560547e+01 -1.4080299377441406e+02 7.0371101379394531e+01 -5.9581802368164062e+01 -1.4081999206542969e+02 7.0402694702148438e+01 -5.9589900970458984e+01 -1.4083399963378906e+02 7.0427200317382812e+01 -5.9596199035644531e+01 -1.4088000488281250e+02 7.0470100402832031e+01 -5.9618000030517578e+01 -1.4088700866699219e+02 7.0472396850585938e+01 -5.9621402740478516e+01 -1.4097500610351562e+02 7.0499893188476562e+01 -5.9663097381591797e+01 -1.4975199890136719e+02 7.0473098754882812e+01 -6.0880401611328125e+01 -1.4975399780273438e+02 7.0473800659179688e+01 -6.0880699157714844e+01 -1.4979100036621094e+02 7.0474296569824219e+01 -6.0388999938964844e+01 -1.4983999633789062e+02 7.0499702453613281e+01 -6.0892196655273438e+01 -1.4970100402832031e+02 7.0430198669433594e+01 -6.0873600006103516e+01 -1.4966600036621094e+02 7.0372703552246094e+01 -6.0869102478027344e+01 -1.4971899414062500e+02 7.0403999328613281e+01 -6.0385200500488281e+01 -1.4968399047851562e+02 7.0402503967285156e+01 -6.0871501922607422e+01 -1.4980499267578125e+02 7.0474296569824219e+01 -5.9780998229980469e+01 -1.4978100585937500e+02 7.0474296569824219e+01 -5.9173801422119141e+01 -1.4973199462890625e+02 7.0403999328613281e+01 -5.9781600952148438e+01 -1.4970800781250000e+02 7.0403999328613281e+01 -5.9179000854492188e+01 -1.4155400085449219e+02 7.0403999328613281e+01 -5.8882301330566406e+01 -1.4210400390625000e+02 7.0403999328613281e+01 -5.8521900177001953e+01 -1.4159800720214844e+02 7.0474296569824219e+01 -5.8940002441406250e+01 -1.4213900756835938e+02 7.0474296569824219e+01 -5.8585899353027344e+01 -1.4111801147460938e+02 7.0474296569824219e+01 -5.9368598937988281e+01 -1.4106599426269531e+02 7.0403999328613281e+01 -5.9317699432373047e+01 -1.4806799316406250e+02 7.0403999328613281e+01 -7.0522499084472656e+01 -1.4813999938964844e+02 7.0474296569824219e+01 -7.0534500122070312e+01 -1.4372499084472656e+02 7.0474296569824219e+01 -5.8238700866699219e+01 -1.4213900756835938e+02 7.0474296569824219e+01 -5.8585800170898438e+01 -1.4263099670410156e+02 7.0474296569824219e+01 -5.8377098083496094e+01 -1.4313499450683594e+02 7.0474296569824219e+01 -5.8266498565673828e+01 -1.4372399902343750e+02 7.0474296569824219e+01 -5.8238597869873047e+01 -1.4372700500488281e+02 7.0403999328613281e+01 -5.8165798187255859e+01 -1.4372601318359375e+02 7.0403999328613281e+01 -5.8165798187255859e+01 -1.4312500000000000e+02 7.0403999328613281e+01 -5.8194297790527344e+01 -1.4260899353027344e+02 7.0403999328613281e+01 -5.8307598114013672e+01 -1.4764498901367188e+02 7.0403999328613281e+01 -7.0880599975585938e+01 -1.4786000061035156e+02 7.0405105590820312e+01 -7.0823699951171875e+01 -1.4808000183105469e+02 7.0474601745605469e+01 -7.0702903747558594e+01 -1.4801699829101562e+02 7.0404899597167969e+01 -7.0666496276855469e+01 -1.4789601135253906e+02 7.0474700927734375e+01 -7.0886703491210938e+01 -1.4764498901367188e+02 7.0474296569824219e+01 -7.0953399658203125e+01 -1.4411099243164062e+02 7.0474296569824219e+01 -5.8270202636718750e+01 -1.4442999267578125e+02 7.0403999328613281e+01 -5.8265499114990234e+01 -1.4473399353027344e+02 7.0403999328613281e+01 -5.8390098571777344e+01 -1.4440899658203125e+02 7.0474296569824219e+01 -5.8335300445556641e+01 -1.4469900512695312e+02 7.0474296569824219e+01 -5.8453998565673828e+01 -1.4412200927734375e+02 7.0403999328613281e+01 -5.8198101043701172e+01 -1.4433898925781250e+02 7.0403999328613281e+01 -7.0880599975585938e+01 -1.4433898925781250e+02 7.0474296569824219e+01 -7.0953399658203125e+01 -1.4494900512695312e+02 7.0403999328613281e+01 -5.8529399871826172e+01 -1.4490400695800781e+02 7.0474296569824219e+01 -5.8587100982666016e+01 -1.4513499450683594e+02 7.0403999328613281e+01 -5.8700401306152344e+01 -1.4508099365234375e+02 7.0474296569824219e+01 -5.8749401092529297e+01 -1.4531100463867188e+02 7.0403999328613281e+01 -5.8945400238037109e+01 -1.4524800109863281e+02 7.0474296569824219e+01 -5.8981197357177734e+01 -1.4425599670410156e+02 7.0474601745605469e+01 -7.0946899414062500e+01 -1.4426800537109375e+02 7.0404701232910156e+01 -7.0875099182128906e+01 -1.4406498718261719e+02 7.0406105041503906e+01 -7.0783500671386719e+01 -1.4393598937988281e+02 7.0405799865722656e+01 -7.0602294921875000e+01 -1.4391600036621094e+02 7.0403999328613281e+01 -7.0380699157714844e+01 -1.4401899719238281e+02 7.0474899291992188e+01 -7.0839500427246094e+01 -1.4386799621582031e+02 7.0474899291992188e+01 -7.0627693176269531e+01 -1.4384399414062500e+02 7.0474296569824219e+01 -7.0368698120117188e+01 -1.4543099975585938e+02 7.0403999328613281e+01 -5.9209400177001953e+01 -1.4536300659179688e+02 7.0474296569824219e+01 -5.9234001159667969e+01 -1.4550698852539062e+02 7.0403999328613281e+01 -5.9477798461914062e+01 -1.4543600463867188e+02 7.0474296569824219e+01 -5.9492900848388672e+01 -1.4555099487304688e+02 7.0403999328613281e+01 -5.9771602630615234e+01 -1.4547799682617188e+02 7.0474296569824219e+01 -5.9778198242187500e+01 -1.4536599731445312e+02 7.0499504089355469e+01 -6.0798000335693359e+01 -1.4551899719238281e+02 7.0402503967285156e+01 -6.0820499420166016e+01 -1.4550199890136719e+02 7.0430297851562500e+01 -6.0818099975585938e+01 -1.4545098876953125e+02 7.0473098754882812e+01 -6.0810497283935547e+01 -1.4544900512695312e+02 7.0473800659179688e+01 -6.0810199737548828e+01 -1.4553700256347656e+02 7.0372703552246094e+01 -6.0823101043701172e+01 -1.4553199768066406e+02 7.0403999328613281e+01 -6.0729701995849609e+01 -1.4545999145507812e+02 7.0474296569824219e+01 -6.0721599578857422e+01 -1.4555899047851562e+02 7.0403999328613281e+01 -6.0412899017333984e+01 -1.4556700134277344e+02 7.0403999328613281e+01 -6.0093200683593750e+01 -1.4548599243164062e+02 7.0474296569824219e+01 -6.0408802032470703e+01 -1.4549400329589844e+02 7.0474296569824219e+01 -6.0093997955322266e+01 -1.2015000152587891e+02 7.0403999328613281e+01 -6.3194900512695312e+01 -1.2020899963378906e+02 7.0372703552246094e+01 -6.2771602630615234e+01 -1.2019200134277344e+02 7.0402503967285156e+01 -6.2769599914550781e+01 -1.2017499542236328e+02 7.0430297851562500e+01 -6.2767803192138672e+01 -1.2007699584960938e+02 7.0474296569824219e+01 -6.3187397003173828e+01 -1.2012400054931641e+02 7.0473197937011719e+01 -6.2762096405029297e+01 -1.2012100219726562e+02 7.0473899841308594e+01 -6.2761901855468750e+01 -1.2005099487304688e+02 7.0498199462890625e+01 -6.2754199981689453e+01 -1.2002100372314453e+02 7.0474296569824219e+01 -6.4095695495605469e+01 -1.2004200744628906e+02 7.0474296569824219e+01 -6.4998100280761719e+01 -1.2020300292968750e+02 7.0474296569824219e+01 -6.6204101562500000e+01 -1.2027500152587891e+02 7.0403999328613281e+01 -6.6189804077148438e+01 -1.2027500152587891e+02 7.0403999328613281e+01 -6.6189697265625000e+01 -1.2011499786376953e+02 7.0403999328613281e+01 -6.4993095397949219e+01 -1.2009400177001953e+02 7.0403999328613281e+01 -6.4097206115722656e+01 -1.2031999969482422e+02 7.0403999328613281e+01 -6.1934600830078125e+01 -1.2024800109863281e+02 7.0474296569824219e+01 -6.1921199798583984e+01 -1.2053600311279297e+02 7.0474296569824219e+01 -6.0741600036621094e+01 -1.2060499572753906e+02 7.0403999328613281e+01 -6.0762599945068359e+01 -1.2094899749755859e+02 7.0474296569824219e+01 -5.9600299835205078e+01 -1.2101600646972656e+02 7.0403999328613281e+01 -5.9628898620605469e+01 -1.2041699981689453e+02 7.0474296569824219e+01 -6.7032302856445312e+01 -1.2048600006103516e+02 7.0403999328613281e+01 -6.7010200500488281e+01 -1.2078700256347656e+02 7.0403999328613281e+01 -6.7787605285644531e+01 -1.2072100067138672e+02 7.0474296569824219e+01 -6.7818000793457031e+01 -1.2131100463867188e+02 7.0403999328613281e+01 -6.8717597961425781e+01 -1.2125099945068359e+02 7.0474296569824219e+01 -6.8758598327636719e+01 -1.2263700103759766e+02 7.0474296569824219e+01 -5.6979896545410156e+01 -1.2269000244140625e+02 7.0403999328613281e+01 -5.7029701232910156e+01 -1.2207900238037109e+02 7.0403999328613281e+01 -5.7761901855468750e+01 -1.2202099609375000e+02 7.0474296569824219e+01 -5.7718502044677734e+01 -1.2149600219726562e+02 7.0474296569824219e+01 -5.8511100769042969e+01 -1.2155899810791016e+02 7.0403999328613281e+01 -5.8548000335693359e+01 -1.2184999847412109e+02 7.0403999328613281e+01 -6.9389595031738281e+01 -1.2247100067138672e+02 7.0403999328613281e+01 -6.9954704284667969e+01 -1.2328199768066406e+02 7.0403999328613281e+01 -7.0482406616210938e+01 -1.2242700195312500e+02 7.0474296569824219e+01 -7.0012298583984375e+01 -1.2324699401855469e+02 7.0474296569824219e+01 -7.0546401977539062e+01 -1.2179700469970703e+02 7.0474296569824219e+01 -6.9439498901367188e+01 -1.2512899780273438e+02 7.0474296569824219e+01 -5.5214599609375000e+01 -1.2433700561523438e+02 7.0403999328613281e+01 -5.5704299926757812e+01 -1.2515799713134766e+02 7.0403999328613281e+01 -5.5281299591064453e+01 -1.2430000305175781e+02 7.0474296569824219e+01 -5.5641597747802734e+01 -1.2354000091552734e+02 7.0474296569824219e+01 -5.6157199859619141e+01 -1.2358399963378906e+02 7.0403999328613281e+01 -5.6214897155761719e+01 -1.2622000122070312e+02 7.0474296569824219e+01 -7.1261001586914062e+01 -1.2412699890136719e+02 7.0403999328613281e+01 -7.0847305297851562e+01 -1.2410400390625000e+02 7.0474296569824219e+01 -7.0916503906250000e+01 -1.2499099731445312e+02 7.0474296569824219e+01 -7.1140296936035156e+01 -1.2622200012207031e+02 7.0403999328613281e+01 -7.1188194274902344e+01 -1.2622100067138672e+02 7.0403999328613281e+01 -7.1188194274902344e+01 -1.2500399017333984e+02 7.0403999328613281e+01 -7.1068603515625000e+01 -1.2836299133300781e+02 7.0474296569824219e+01 -5.4620700836181641e+01 -1.2836100769042969e+02 7.0403999328613281e+01 -5.4693500518798828e+01 -1.2725099945068359e+02 7.0474296569824219e+01 -5.4662200927734375e+01 -1.2617899322509766e+02 7.0474296569824219e+01 -5.4851799011230469e+01 -1.2725800323486328e+02 7.0403999328613281e+01 -5.4734600067138672e+01 -1.2619699859619141e+02 7.0403999328613281e+01 -5.4922397613525391e+01 -1.2687799072265625e+02 7.0474296569824219e+01 -7.1248596191406250e+01 -1.2752700042724609e+02 7.0474296569824219e+01 -7.1181297302246094e+01 -1.2876400756835938e+02 7.0474296569824219e+01 -7.0890098571777344e+01 -1.2874099731445312e+02 7.0403999328613281e+01 -7.0820899963378906e+01 -1.2751599884033203e+02 7.0403999328613281e+01 -7.1109298706054688e+01 -1.2687300109863281e+02 7.0403999328613281e+01 -7.1175903320312500e+01 -1.2960200500488281e+02 7.0403999328613281e+01 -5.4819999694824219e+01 -1.2961601257324219e+02 7.0474296569824219e+01 -5.4748500823974609e+01 -1.3022399902343750e+02 7.0403999328613281e+01 -5.4972202301025391e+01 -1.3083000183105469e+02 7.0403999328613281e+01 -5.5193302154541016e+01 -1.3024499511718750e+02 7.0474296569824219e+01 -5.4902400970458984e+01 -1.3085900878906250e+02 7.0474296569824219e+01 -5.5126399993896484e+01 -1.2933200073242188e+02 7.0403999328613281e+01 -7.0599098205566406e+01 -1.2936100769042969e+02 7.0474296569824219e+01 -7.0666099548339844e+01 -1.2989599609375000e+02 7.0403999328613281e+01 -7.0328300476074219e+01 -1.2993099975585938e+02 7.0474296569824219e+01 -7.0392494201660156e+01 -1.3090800476074219e+02 7.0403999328613281e+01 -6.9659904479980469e+01 -1.3095399475097656e+02 7.0474296569824219e+01 -6.9716796875000000e+01 -1.3270899963378906e+02 7.0474296569824219e+01 -5.6447101593017578e+01 -1.3192700195312500e+02 7.0474296569824219e+01 -5.5734199523925781e+01 -1.3141099548339844e+02 7.0474296569824219e+01 -5.5400497436523438e+01 -1.3085900878906250e+02 7.0474296569824219e+01 -5.5126499176025391e+01 -1.3137500000000000e+02 7.0403999328613281e+01 -5.5463798522949219e+01 -1.3188398742675781e+02 7.0403999328613281e+01 -5.5792999267578125e+01 -1.3265399169921875e+02 7.0403999328613281e+01 -5.6495399475097656e+01 -1.3147300720214844e+02 7.0474296569824219e+01 -6.9252601623535156e+01 -1.3193299865722656e+02 7.0474296569824219e+01 -6.8740394592285156e+01 -1.3253800964355469e+02 7.0474296569824219e+01 -6.7843101501464844e+01 -1.3247399902343750e+02 7.0403999328613281e+01 -6.7807502746582031e+01 -1.3187600708007812e+02 7.0403999328613281e+01 -6.8694801330566406e+01 -1.3142199707031250e+02 7.0403999328613281e+01 -6.9200996398925781e+01 -1.3334600830078125e+02 7.0403999328613281e+01 -5.7485698699951172e+01 -1.3376499938964844e+02 7.0403999328613281e+01 -5.8458801269531250e+01 -1.3341000366210938e+02 7.0474296569824219e+01 -5.7450901031494141e+01 -1.3383399963378906e+02 7.0474296569824219e+01 -5.8435897827148438e+01 -1.3302799987792969e+02 7.0403999328613281e+01 -5.6970699310302734e+01 -1.3308799743652344e+02 7.0474296569824219e+01 -5.6929000854492188e+01 -1.3296798706054688e+02 7.0474296569824219e+01 -6.6857803344726562e+01 -1.3289801025390625e+02 7.0403999328613281e+01 -6.6835296630859375e+01 -1.3312600708007812e+02 7.0403999328613281e+01 -6.5833396911621094e+01 -1.3319799804687500e+02 7.0474296569824219e+01 -6.5843406677246094e+01 -1.3401300048828125e+02 7.0403999328613281e+01 -5.9456699371337891e+01 -1.3411999511718750e+02 7.0403999328613281e+01 -6.0504600524902344e+01 -1.3408500671386719e+02 7.0474296569824219e+01 -5.9444301605224609e+01 -1.3419200134277344e+02 7.0474296569824219e+01 -6.0501899719238281e+01 -1.3312199401855469e+02 7.0405296325683594e+01 -6.5689300537109375e+01 -1.3269799804687500e+02 7.0403999328613281e+01 -6.5346199035644531e+01 -1.3269700622558594e+02 7.0474296569824219e+01 -6.5273300170898438e+01 -1.3285099792480469e+02 7.0405403137207031e+01 -6.5372604370117188e+01 -1.3287701416015625e+02 7.0474700927734375e+01 -6.5304504394531250e+01 -1.3297599792480469e+02 7.0405998229980469e+01 -6.5444702148437500e+01 -1.3307000732421875e+02 7.0405998229980469e+01 -6.5554405212402344e+01 -1.3302299499511719e+02 7.0474899291992188e+01 -6.5388900756835938e+01 -1.3313198852539062e+02 7.0474899291992188e+01 -6.5517204284667969e+01 -1.3319300842285156e+02 7.0474700927734375e+01 -6.5674797058105469e+01 -1.3369099426269531e+02 7.0403999328613281e+01 -6.0949096679687500e+01 -1.3383300781250000e+02 7.0405105590820312e+01 -6.0925598144531250e+01 -1.3411000061035156e+02 7.0404899597167969e+01 -6.0614601135253906e+01 -1.3418099975585938e+02 7.0474601745605469e+01 -6.0630599975585938e+01 -1.3405599975585938e+02 7.0405601501464844e+01 -6.0748100280761719e+01 -1.3395999145507812e+02 7.0405700683593750e+01 -6.0855899810791016e+01 -1.3411700439453125e+02 7.0474800109863281e+01 -6.0786602020263672e+01 -1.3400498962402344e+02 7.0474800109863281e+01 -6.0912601470947266e+01 -1.3385699462890625e+02 7.0474700927734375e+01 -6.0994201660156250e+01 -1.3369099426269531e+02 7.0474296569824219e+01 -6.1021900177001953e+01 -1.2958100891113281e+02 7.0403999328613281e+01 -6.5369705200195312e+01 -1.2958000183105469e+02 7.0474296569824219e+01 -6.5296798706054688e+01 -1.3064199829101562e+02 7.0403999328613281e+01 -6.0949096679687500e+01 -1.3064199829101562e+02 7.0474296569824219e+01 -6.1021900177001953e+01 -1.2943899536132812e+02 7.0404701232910156e+01 -6.5394500732421875e+01 -1.2917399597167969e+02 7.0403999328613281e+01 -6.5674995422363281e+01 -1.2910400390625000e+02 7.0474296569824219e+01 -6.5653999328613281e+01 -1.2921899414062500e+02 7.0404594421386719e+01 -6.5573699951171875e+01 -1.2915701293945312e+02 7.0474494934082031e+01 -6.5535598754882812e+01 -1.2931300354003906e+02 7.0404899597167969e+01 -6.5465194702148438e+01 -1.2926800537109375e+02 7.0474601745605469e+01 -6.5408805847167969e+01 -1.2941400146484375e+02 7.0474601745605469e+01 -6.5325996398925781e+01 -1.3057899475097656e+02 7.0404502868652344e+01 -6.0944698333740234e+01 -1.3056799316406250e+02 7.0474494934082031e+01 -6.1016700744628906e+01 -1.3024800109863281e+02 7.0404998779296875e+01 -6.0691902160644531e+01 -1.3032699584960938e+02 7.0405403137207031e+01 -6.0812702178955078e+01 -1.3044198608398438e+02 7.0405197143554688e+01 -6.0900299072265625e+01 -1.3021400451660156e+02 7.0403999328613281e+01 -6.0551799774169922e+01 -1.3040800476074219e+02 7.0474700927734375e+01 -6.0964698791503906e+01 -1.3027400207519531e+02 7.0474700927734375e+01 -6.0862197875976562e+01 -1.3018199157714844e+02 7.0474601745605469e+01 -6.0721000671386719e+01 -1.3014199829101562e+02 7.0474296569824219e+01 -6.0557201385498047e+01 -1.2886799621582031e+02 7.0403999328613281e+01 -6.6378105163574219e+01 -1.2824400329589844e+02 7.0403999328613281e+01 -6.7113197326660156e+01 -1.2880599975585938e+02 7.0474296569824219e+01 -6.6340904235839844e+01 -1.2819700622558594e+02 7.0474296569824219e+01 -6.7057403564453125e+01 -1.3011099243164062e+02 7.0474296569824219e+01 -6.0264698028564453e+01 -1.3004699707031250e+02 7.0474296569824219e+01 -5.9907199859619141e+01 -1.3018299865722656e+02 7.0403999328613281e+01 -6.0254802703857422e+01 -1.3011900329589844e+02 7.0403999328613281e+01 -5.9891498565673828e+01 -1.2634100341796875e+02 7.0474296569824219e+01 -6.7657699584960938e+01 -1.2779499816894531e+02 7.0403999328613281e+01 -6.7416198730468750e+01 -1.2776100921630859e+02 7.0474296569824219e+01 -6.7351898193359375e+01 -1.2688200378417969e+02 7.0474296569824219e+01 -6.7629600524902344e+01 -1.2634199523925781e+02 7.0474296569824219e+01 -6.7657699584960938e+01 -1.2633900451660156e+02 7.0403999328613281e+01 -6.7730499267578125e+01 -1.2634000396728516e+02 7.0403999328613281e+01 -6.7730499267578125e+01 -1.2689199829101562e+02 7.0403999328613281e+01 -6.7701805114746094e+01 -1.2985198974609375e+02 7.0474296569824219e+01 -5.9332603454589844e+01 -1.2969499206542969e+02 7.0474296569824219e+01 -5.9053001403808594e+01 -1.2991799926757812e+02 7.0403999328613281e+01 -5.9301200866699219e+01 -1.2975599670410156e+02 7.0403999328613281e+01 -5.9012802124023438e+01 -1.3003900146484375e+02 7.0403999328613281e+01 -5.9601703643798828e+01 -1.2997000122070312e+02 7.0474296569824219e+01 -5.9624702453613281e+01 -1.2503799438476562e+02 7.0474296569824219e+01 -6.7195602416992188e+01 -1.2573899078369141e+02 7.0403999328613281e+01 -6.7658699035644531e+01 -1.2575699615478516e+02 7.0474296569824219e+01 -6.7587898254394531e+01 -1.2528799438476562e+02 7.0474296569824219e+01 -6.7396606445312500e+01 -1.2503799438476562e+02 7.0474296569824219e+01 -6.7195701599121094e+01 -1.2498500061035156e+02 7.0403999328613281e+01 -6.7246299743652344e+01 -1.2498500061035156e+02 7.0403999328613281e+01 -6.7246398925781250e+01 -1.2525000000000000e+02 7.0403999328613281e+01 -6.7458602905273438e+01 -1.2930299377441406e+02 7.0474296569824219e+01 -5.8630500793457031e+01 -1.2905499267578125e+02 7.0474296569824219e+01 -5.8468799591064453e+01 -1.2934799194335938e+02 7.0403999328613281e+01 -5.8572799682617188e+01 -1.2908999633789062e+02 7.0403999328613281e+01 -5.8404800415039062e+01 -1.2957000732421875e+02 7.0403999328613281e+01 -5.8776401519775391e+01 -1.2951699829101562e+02 7.0474296569824219e+01 -5.8825897216796875e+01 -1.2443199920654297e+02 7.0474296569824219e+01 -6.6081802368164062e+01 -1.2467700195312500e+02 7.0474296569824219e+01 -6.6712402343750000e+01 -1.2453299713134766e+02 7.0474296569824219e+01 -6.6404701232910156e+01 -1.2443199920654297e+02 7.0474296569824219e+01 -6.6081893920898438e+01 -1.2436100006103516e+02 7.0403999328613281e+01 -6.6099304199218750e+01 -1.2436100006103516e+02 7.0403999328613281e+01 -6.6099395751953125e+01 -1.2446500396728516e+02 7.0403999328613281e+01 -6.6430999755859375e+01 -1.2461399841308594e+02 7.0403999328613281e+01 -6.6747894287109375e+01 -1.2806098937988281e+02 7.0498901367187500e+01 -5.8301300048828125e+01 -1.2838999938964844e+02 7.0474296569824219e+01 -5.8256099700927734e+01 -1.2806700134277344e+02 7.0402503967285156e+01 -5.8153598785400391e+01 -1.2806600952148438e+02 7.0430297851562500e+01 -5.8170299530029297e+01 -1.2840199279785156e+02 7.0403999328613281e+01 -5.8184097290039062e+01 -1.2806401062011719e+02 7.0473098754882812e+01 -5.8221897125244141e+01 -1.2806401062011719e+02 7.0473899841308594e+01 -5.8224102020263672e+01 -1.2806700134277344e+02 7.0372703552246094e+01 -5.8135700225830078e+01 -1.2875099182128906e+02 7.0403999328613281e+01 -5.8263397216796875e+01 -1.2872900390625000e+02 7.0474296569824219e+01 -5.8333000183105469e+01 -1.2429500579833984e+02 7.0474296569824219e+01 -6.4636001586914062e+01 -1.2435100555419922e+02 7.0474296569824219e+01 -6.5679100036621094e+01 -1.2430599975585938e+02 7.0474296569824219e+01 -6.5274703979492188e+01 -1.2429500579833984e+02 7.0474296569824219e+01 -6.4636199951171875e+01 -1.2422299957275391e+02 7.0403999328613281e+01 -6.4633399963378906e+01 -1.2422299957275391e+02 7.0403999328613281e+01 -6.4633506774902344e+01 -1.2423300170898438e+02 7.0403999328613281e+01 -6.5279998779296875e+01 -1.2427899932861328e+02 7.0403999328613281e+01 -6.5690299987792969e+01 -1.2708499908447266e+02 7.0403999328613281e+01 -5.8254398345947266e+01 -1.2761500549316406e+02 7.0403999328613281e+01 -5.8162902832031250e+01 -1.2762199401855469e+02 7.0474296569824219e+01 -5.8235500335693359e+01 -1.2710399627685547e+02 7.0474296569824219e+01 -5.8324699401855469e+01 -1.2647000122070312e+02 7.0474296569824219e+01 -5.8597599029541016e+01 -1.2643199920654297e+02 7.0403999328613281e+01 -5.8535900115966797e+01 -1.2439800262451172e+02 7.0474296569824219e+01 -6.3192298889160156e+01 -1.2431400299072266e+02 7.0474296569824219e+01 -6.4218902587890625e+01 -1.2434100341796875e+02 7.0474296569824219e+01 -6.3801998138427734e+01 -1.2439800262451172e+02 7.0474296569824219e+01 -6.3193202972412109e+01 -1.2432499694824219e+02 7.0403999328613281e+01 -6.3184597015380859e+01 -1.2432499694824219e+02 7.0403999328613281e+01 -6.3185104370117188e+01 -1.2426800537109375e+02 7.0403999328613281e+01 -6.3796497344970703e+01 -1.2424199676513672e+02 7.0403999328613281e+01 -6.4214897155761719e+01 -1.2540900421142578e+02 7.0474296569824219e+01 -5.9665901184082031e+01 -1.2569699859619141e+02 7.0474296569824219e+01 -5.9269199371337891e+01 -1.2603199768066406e+02 7.0474296569824219e+01 -5.8924999237060547e+01 -1.2598300170898438e+02 7.0403999328613281e+01 -5.8870502471923828e+01 -1.2564100646972656e+02 7.0403999328613281e+01 -5.9222400665283203e+01 -1.2534700012207031e+02 7.0403999328613281e+01 -5.9627399444580078e+01 -1.2540900421142578e+02 7.0474296569824219e+01 -5.9666000366210938e+01 -1.2435399627685547e+02 7.0372703552246094e+01 -6.2773101806640625e+01 -1.2437100219726562e+02 7.0402503967285156e+01 -6.2775203704833984e+01 -1.2438800048828125e+02 7.0430297851562500e+01 -6.2777198791503906e+01 -1.2443900299072266e+02 7.0473098754882812e+01 -6.2783195495605469e+01 -1.2444099426269531e+02 7.0473800659179688e+01 -6.2783397674560547e+01 -1.2451999664306641e+02 7.0499099731445312e+01 -6.2792701721191406e+01 -1.2476799774169922e+02 7.0474296569824219e+01 -6.1163700103759766e+01 -1.2491799926757812e+02 7.0474296569824219e+01 -6.0686302185058594e+01 -1.2510601043701172e+02 7.0474296569824219e+01 -6.0226100921630859e+01 -1.2469799804687500e+02 7.0403999328613281e+01 -6.1144798278808594e+01 -1.2484899902343750e+02 7.0403999328613281e+01 -6.0661701202392578e+01 -1.2503999328613281e+02 7.0403999328613281e+01 -6.0195499420166016e+01 -1.2450299835205078e+02 7.0474296569824219e+01 -6.2366199493408203e+01 -1.2443199920654297e+02 7.0403999328613281e+01 -6.2354099273681641e+01 -1.2455000305175781e+02 7.0403999328613281e+01 -6.1745800018310547e+01 -1.2462099456787109e+02 7.0474296569824219e+01 -6.1761497497558594e+01 -9.6436302185058594e+01 7.0403999328613281e+01 -6.9498207092285156e+01 -9.7067298889160156e+01 7.0403999328613281e+01 -6.9996604919433594e+01 -9.8021697998046875e+01 7.0403999328613281e+01 -7.0541503906250000e+01 -9.7026000976562500e+01 7.0474296569824219e+01 -7.0056495666503906e+01 -9.7990806579589844e+01 7.0474296569824219e+01 -7.0607498168945312e+01 -9.5867904663085938e+01 7.0403999328613281e+01 -6.8909599304199219e+01 -9.6387496948242188e+01 7.0474296569824219e+01 -6.9552200317382812e+01 -9.5812202453613281e+01 7.0474296569824219e+01 -6.8956596374511719e+01 -9.5278099060058594e+01 7.0403999328613281e+01 -6.8078300476074219e+01 -9.5215400695800781e+01 7.0474296569824219e+01 -6.8115394592285156e+01 -9.4893402099609375e+01 7.0403999328613281e+01 -6.7314399719238281e+01 -9.4603904724121094e+01 7.0403999328613281e+01 -6.6491905212402344e+01 -9.4826301574707031e+01 7.0474296569824219e+01 -6.7342903137207031e+01 -9.4533798217773438e+01 7.0474296569824219e+01 -6.6511901855468750e+01 -9.8869705200195312e+01 7.0403999328613281e+01 -7.0864898681640625e+01 -9.8848701477050781e+01 7.0474296569824219e+01 -7.0934600830078125e+01 -9.9728599548339844e+01 7.0474296569824219e+01 -7.1137802124023438e+01 -1.0095199584960938e+02 7.0474296569824219e+01 -7.1246307373046875e+01 -1.0095299530029297e+02 7.0403999328613281e+01 -7.1173400878906250e+01 -9.9740501403808594e+01 7.0403999328613281e+01 -7.1065902709960938e+01 -9.4314498901367188e+01 7.0403999328613281e+01 -6.4417800903320312e+01 -9.4280303955078125e+01 7.0474601745605469e+01 -6.3510700225830078e+01 -9.4241699218750000e+01 7.0474296569824219e+01 -6.4418304443359375e+01 -9.4354003906250000e+01 7.0403999328613281e+01 -6.3517501831054688e+01 -9.4353599548339844e+01 7.0404403686523438e+01 -6.3517398834228516e+01 -9.4281501770019531e+01 7.0474296569824219e+01 -6.3510799407958984e+01 -9.4368194580078125e+01 7.0403999328613281e+01 -6.5305297851562500e+01 -9.4295799255371094e+01 7.0474296569824219e+01 -6.5313697814941406e+01 -1.0154000091552734e+02 7.0474296569824219e+01 -7.1236999511718750e+01 -1.0211700439453125e+02 7.0403999328613281e+01 -7.1118301391601562e+01 -1.0271500396728516e+02 7.0403999328613281e+01 -7.1033905029296875e+01 -1.0212500000000000e+02 7.0474296569824219e+01 -7.1190795898437500e+01 -1.0272700500488281e+02 7.0474296569824219e+01 -7.1105705261230469e+01 -1.0153699493408203e+02 7.0403999328613281e+01 -7.1164199829101562e+01 -9.4338996887207031e+01 7.0474899291992188e+01 -6.2923995971679688e+01 -9.4339897155761719e+01 7.0474105834960938e+01 -6.2923995971679688e+01 -9.4412300109863281e+01 7.0404502868652344e+01 -6.2931297302246094e+01 -9.4412498474121094e+01 7.0403900146484375e+01 -6.2931297302246094e+01 -1.0331999969482422e+02 7.0474296569824219e+01 -7.0981300354003906e+01 -1.0389900207519531e+02 7.0474296569824219e+01 -7.0814201354980469e+01 -1.0446900177001953e+02 7.0474296569824219e+01 -7.0601997375488281e+01 -1.0446900177001953e+02 7.0474296569824219e+01 -7.0601905822753906e+01 -1.0444100189208984e+02 7.0403999328613281e+01 -7.0534698486328125e+01 -1.0387599945068359e+02 7.0403999328613281e+01 -7.0744995117187500e+01 -1.0330300140380859e+02 7.0403999328613281e+01 -7.0910606384277344e+01 -9.4340194702148438e+01 7.0474296569824219e+01 -6.2923400878906250e+01 -9.5167694091796875e+01 7.0474296569824219e+01 -5.9732200622558594e+01 -9.5234703063964844e+01 7.0403999328613281e+01 -5.9760803222656250e+01 -9.4801101684570312e+01 7.0474296569824219e+01 -6.0717800140380859e+01 -9.4532600402832031e+01 7.0474296569824219e+01 -6.1724597930908203e+01 -9.4870498657226562e+01 7.0403999328613281e+01 -6.0739902496337891e+01 -9.4603797912597656e+01 7.0403999328613281e+01 -6.1740001678466797e+01 -9.4412696838378906e+01 7.0403999328613281e+01 -6.2931098937988281e+01 -1.0602799987792969e+02 7.0474296569824219e+01 -6.9703300476074219e+01 -1.0497800445556641e+02 7.0403999328613281e+01 -7.0283897399902344e+01 -1.0501200103759766e+02 7.0474296569824219e+01 -7.0348594665527344e+01 -1.0552799987792969e+02 7.0474296569824219e+01 -7.0051994323730469e+01 -1.0598400115966797e+02 7.0403999328613281e+01 -6.9645401000976562e+01 -1.0548899841308594e+02 7.0403999328613281e+01 -6.9990394592285156e+01 -9.6892295837402344e+01 7.0474296569824219e+01 -5.7060497283935547e+01 -9.6945503234863281e+01 7.0403999328613281e+01 -5.7110202789306641e+01 -9.6314201354980469e+01 7.0403999328613281e+01 -5.7867099761962891e+01 -9.6255699157714844e+01 7.0474296569824219e+01 -5.7823699951171875e+01 -9.5714706420898438e+01 7.0474296569824219e+01 -5.8643199920654297e+01 -9.5777603149414062e+01 7.0403999328613281e+01 -5.8680099487304688e+01 -1.0662200164794922e+02 7.0403999328613281e+01 -6.9072799682617188e+01 -1.0667499542236328e+02 7.0474296569824219e+01 -6.9122901916503906e+01 -1.0701300048828125e+02 7.0403999328613281e+01 -6.8611099243164062e+01 -1.0707099914550781e+02 7.0474296569824219e+01 -6.8654998779296875e+01 -9.9434600830078125e+01 7.0474296569824219e+01 -5.5244300842285156e+01 -9.8615303039550781e+01 7.0403999328613281e+01 -5.5757297515869141e+01 -9.9464698791503906e+01 7.0403999328613281e+01 -5.5310600280761719e+01 -9.8577606201171875e+01 7.0474296569824219e+01 -5.5694999694824219e+01 -9.7792198181152344e+01 7.0474296569824219e+01 -5.6236099243164062e+01 -9.7837097167968750e+01 7.0403999328613281e+01 -5.6293498992919922e+01 -1.0707999420166016e+02 7.0404800415039062e+01 -6.8483299255371094e+01 -1.0700699615478516e+02 7.0403999328613281e+01 -6.8085998535156250e+01 -1.0706400299072266e+02 7.0474296569824219e+01 -6.8040695190429688e+01 -1.0707200622558594e+02 7.0404701232910156e+01 -6.8199302673339844e+01 -1.0713999938964844e+02 7.0474601745605469e+01 -6.8173202514648438e+01 -1.0710000610351562e+02 7.0404998779296875e+01 -6.8340599060058594e+01 -1.0717300415039062e+02 7.0474601745605469e+01 -6.8338500976562500e+01 -1.0714899444580078e+02 7.0474601745605469e+01 -6.8505500793457031e+01 -1.0157500457763672e+02 7.0474296569824219e+01 -5.4666198730468750e+01 -1.0269799804687500e+02 7.0474296569824219e+01 -5.4620700836181641e+01 -1.0158300018310547e+02 7.0403999328613281e+01 -5.4738601684570312e+01 -1.0269699859619141e+02 7.0403999328613281e+01 -5.4693500518798828e+01 -1.0049399566650391e+02 7.0474296569824219e+01 -5.4866397857666016e+01 -1.0051299285888672e+02 7.0403999328613281e+01 -5.4936801910400391e+01 -1.0560099792480469e+02 7.0403999328613281e+01 -6.6317901611328125e+01 -1.0565800476074219e+02 7.0474296569824219e+01 -6.6272598266601562e+01 -1.0475000000000000e+02 7.0403999328613281e+01 -5.5024299621582031e+01 -1.0554900360107422e+02 7.0403999328613281e+01 -5.5377403259277344e+01 -1.0558499908447266e+02 7.0474296569824219e+01 -5.5313800811767578e+01 -1.0558499908447266e+02 7.0474296569824219e+01 -5.5313697814941406e+01 -1.0477400207519531e+02 7.0474296569824219e+01 -5.4955402374267578e+01 -1.0392100524902344e+02 7.0403999328613281e+01 -5.4810298919677734e+01 -1.0393399810791016e+02 7.0474296569824219e+01 -5.4738601684570312e+01 -1.0549400329589844e+02 7.0405197143554688e+01 -6.6221099853515625e+01 -1.0497599792480469e+02 7.0403999328613281e+01 -6.6267700195312500e+01 -1.0492700195312500e+02 7.0474296569824219e+01 -6.6213897705078125e+01 -1.0507799530029297e+02 7.0404998779296875e+01 -6.6197998046875000e+01 -1.0504700469970703e+02 7.0474601745605469e+01 -6.6132499694824219e+01 -1.0521700286865234e+02 7.0405700683593750e+01 -6.6157600402832031e+01 -1.0536100006103516e+02 7.0405799865722656e+01 -6.6165496826171875e+01 -1.0520899963378906e+02 7.0474800109863281e+01 -6.6085304260253906e+01 -1.0537700653076172e+02 7.0474899291992188e+01 -6.6094696044921875e+01 -1.0553299713134766e+02 7.0474700927734375e+01 -6.6159599304199219e+01 -1.0691600036621094e+02 7.0403999328613281e+01 -5.6447299957275391e+01 -1.0743199920654297e+02 7.0403999328613281e+01 -5.7113300323486328e+01 -1.0696999359130859e+02 7.0474296569824219e+01 -5.6398101806640625e+01 -1.0749299621582031e+02 7.0474296569824219e+01 -5.7073501586914062e+01 -1.0631500244140625e+02 7.0403999328613281e+01 -5.5887699127197266e+01 -1.0636000061035156e+02 7.0474296569824219e+01 -5.5830699920654297e+01 -1.0346099853515625e+02 7.0474296569824219e+01 -6.7205398559570312e+01 -1.0448600006103516e+02 7.0474296569824219e+01 -6.6581001281738281e+01 -1.0401599884033203e+02 7.0474296569824219e+01 -6.6902900695800781e+01 -1.0346099853515625e+02 7.0474296569824219e+01 -6.7205299377441406e+01 -1.0349299621582031e+02 7.0403999328613281e+01 -6.7271095275878906e+01 -1.0405399322509766e+02 7.0403999328613281e+01 -6.6964904785156250e+01 -1.0452999877929688e+02 7.0403999328613281e+01 -6.6639106750488281e+01 -1.0845899963378906e+02 7.0474296569824219e+01 -5.9584400177001953e+01 -1.0826600646972656e+02 7.0474296569824219e+01 -5.8763900756835938e+01 -1.0798300170898438e+02 7.0474296569824219e+01 -5.7984199523925781e+01 -1.0838800048828125e+02 7.0403999328613281e+01 -5.9597202301025391e+01 -1.0819700622558594e+02 7.0403999328613281e+01 -5.8784599304199219e+01 -1.0791699981689453e+02 7.0403999328613281e+01 -5.8013397216796875e+01 -1.0131999969482422e+02 7.0372703552246094e+01 -6.7716705322265625e+01 -1.0132200622558594e+02 7.0473197937011719e+01 -6.7630500793457031e+01 -1.0132099914550781e+02 7.0430297851562500e+01 -6.7682106018066406e+01 -1.0159300231933594e+02 7.0403999328613281e+01 -6.7704399108886719e+01 -1.0131999969482422e+02 7.0402503967285156e+01 -6.7698799133300781e+01 -1.0159199523925781e+02 7.0474296569824219e+01 -6.7631599426269531e+01 -1.0132200622558594e+02 7.0473899841308594e+01 -6.7628303527832031e+01 -1.0132499694824219e+02 7.0498802185058594e+01 -6.7551795959472656e+01 -1.0224299621582031e+02 7.0403999328613281e+01 -6.7652206420898438e+01 -1.0288199615478516e+02 7.0403999328613281e+01 -6.7508598327636719e+01 -1.0223200225830078e+02 7.0474296569824219e+01 -6.7580200195312500e+01 -1.0286100006103516e+02 7.0474296569824219e+01 -6.7438903808593750e+01 -1.0853099822998047e+02 7.0473098754882812e+01 -6.2521198272705078e+01 -1.0853300476074219e+02 7.0473800659179688e+01 -6.2521503448486328e+01 -1.0858100128173828e+02 7.0474296569824219e+01 -6.2010002136230469e+01 -1.0861600494384766e+02 7.0499397277832031e+01 -6.2532699584960938e+01 -1.0847999572753906e+02 7.0430297851562500e+01 -6.2514297485351562e+01 -1.0850799560546875e+02 7.0403999328613281e+01 -6.2004901885986328e+01 -1.0846299743652344e+02 7.0402503967285156e+01 -6.2512001037597656e+01 -1.0844599914550781e+02 7.0372703552246094e+01 -6.2509700775146484e+01 -1.0852199554443359e+02 7.0403999328613281e+01 -6.0796699523925781e+01 -1.0859500122070312e+02 7.0474296569824219e+01 -6.0793197631835938e+01 -1.0005699920654297e+02 7.0474296569824219e+01 -6.7352401733398438e+01 -1.0131700134277344e+02 7.0474296569824219e+01 -6.7628303527832031e+01 -1.0131500244140625e+02 7.0403999328613281e+01 -6.7701194763183594e+01 -1.0069499969482422e+02 7.0474296569824219e+01 -6.7563400268554688e+01 -1.0036999511718750e+02 7.0474296569824219e+01 -6.7478698730468750e+01 -1.0005799865722656e+02 7.0474296569824219e+01 -6.7352401733398438e+01 -1.0002599334716797e+02 7.0403999328613281e+01 -6.7417900085449219e+01 -1.0034799957275391e+02 7.0403999328613281e+01 -6.7547996520996094e+01 -1.0068099975585938e+02 7.0403999328613281e+01 -6.7634796142578125e+01 -1.0823600006103516e+02 7.0403999328613281e+01 -6.3969501495361328e+01 -1.0830799865722656e+02 7.0474296569824219e+01 -6.3980602264404297e+01 -9.9662605285644531e+01 7.0474296569824219e+01 -6.7116996765136719e+01 -9.9620002746582031e+01 7.0403999328613281e+01 -6.7176002502441406e+01 -9.9351799011230469e+01 7.0403999328613281e+01 -6.6951995849609375e+01 -9.9402397155761719e+01 7.0474296569824219e+01 -6.6899497985839844e+01 -9.9118003845214844e+01 7.0403999328613281e+01 -6.6691894531250000e+01 -9.9175399780273438e+01 7.0474296569824219e+01 -6.6647094726562500e+01 -1.0781200408935547e+02 7.0403999328613281e+01 -6.4332801818847656e+01 -1.0802700042724609e+02 7.0405105590820312e+01 -6.4276000976562500e+01 -1.0824699401855469e+02 7.0474601745605469e+01 -6.4155197143554688e+01 -1.0818400573730469e+02 7.0404899597167969e+01 -6.4118804931640625e+01 -1.0806299591064453e+02 7.0474700927734375e+01 -6.4338996887207031e+01 -1.0781200408935547e+02 7.0474296569824219e+01 -6.4405700683593750e+01 -9.8672500610351562e+01 7.0474296569824219e+01 -6.5604400634765625e+01 -9.8907997131347656e+01 7.0474296569824219e+01 -6.6227302551269531e+01 -9.8773002624511719e+01 7.0474296569824219e+01 -6.5921798706054688e+01 -9.8672500610351562e+01 7.0474296569824219e+01 -6.5604499816894531e+01 -9.8601997375488281e+01 7.0403999328613281e+01 -6.5622901916503906e+01 -9.8601997375488281e+01 7.0403999328613281e+01 -6.5623001098632812e+01 -9.8704803466796875e+01 7.0403999328613281e+01 -6.5947395324707031e+01 -9.8843200683593750e+01 7.0403999328613281e+01 -6.6260597229003906e+01 -9.8646095275878906e+01 7.0499893188476562e+01 -6.4501602172851562e+01 -9.8484504699707031e+01 7.0403800964355469e+01 -6.4333198547363281e+01 -9.8485794067382812e+01 7.0406898498535156e+01 -6.4334602355957031e+01 -9.8527107238769531e+01 7.0455703735351562e+01 -6.4378097534179688e+01 -9.8556503295898438e+01 7.0466598510742188e+01 -6.4408699035644531e+01 -9.8556602478027344e+01 7.0466697692871094e+01 -6.4408798217773438e+01 -9.8465599060058594e+01 7.0360694885253906e+01 -6.4313095092773438e+01 -9.8604003906250000e+01 7.0474296569824219e+01 -6.5285896301269531e+01 -9.8476097106933594e+01 7.0403999328613281e+01 -6.4637496948242188e+01 -9.8549003601074219e+01 7.0474296569824219e+01 -6.4637100219726562e+01 -9.8532196044921875e+01 7.0403999328613281e+01 -6.5298103332519531e+01 -1.1892200469970703e+02 7.0403999328613281e+01 -5.8136501312255859e+01 -1.1913699340820312e+02 7.0405105590820312e+01 -5.8079700469970703e+01 -1.1935699462890625e+02 7.0474601745605469e+01 -5.7958801269531250e+01 -1.1941600036621094e+02 7.0474296569824219e+01 -5.7794002532958984e+01 -1.1929400634765625e+02 7.0404899597167969e+01 -5.7922500610351562e+01 -1.1934500122070312e+02 7.0403999328613281e+01 -5.7781497955322266e+01 -1.1917299652099609e+02 7.0474700927734375e+01 -5.8142700195312500e+01 -1.1892200469970703e+02 7.0474296569824219e+01 -5.8209400177001953e+01 -1.1974500274658203e+02 7.0403999328613281e+01 -5.5488800048828125e+01 -1.1981599426269531e+02 7.0474296569824219e+01 -5.5501399993896484e+01 -1.1670800018310547e+02 7.0474296569824219e+01 -5.8209400177001953e+01 -1.1664599609375000e+02 7.0403999328613281e+01 -5.8136501312255859e+01 -1.1662899780273438e+02 7.0357299804687500e+01 -5.8115798950195312e+01 -1.1932199859619141e+02 7.0403999328613281e+01 -5.4986396789550781e+01 -1.1932199859619141e+02 7.0474296569824219e+01 -5.4913497924804688e+01 -1.1939600372314453e+02 7.0404701232910156e+01 -5.4992298126220703e+01 -1.1940900421142578e+02 7.0474601745605469e+01 -5.4920597076416016e+01 -1.1959799957275391e+02 7.0406105041503906e+01 -5.5085201263427734e+01 -1.1972600555419922e+02 7.0405799865722656e+01 -5.5267200469970703e+01 -1.1964499664306641e+02 7.0474899291992188e+01 -5.5029399871826172e+01 -1.1979400634765625e+02 7.0474899291992188e+01 -5.5242198944091797e+01 -1.1545899963378906e+02 7.0499595642089844e+01 -6.6079399108886719e+01 -1.1537200164794922e+02 7.0473098754882812e+01 -6.6067001342773438e+01 -1.1537400054931641e+02 7.0473800659179688e+01 -6.6067298889160156e+01 -1.1528600311279297e+02 7.0372703552246094e+01 -6.6054702758789062e+01 -1.1530400085449219e+02 7.0402503967285156e+01 -6.6057304382324219e+01 -1.1532099914550781e+02 7.0430297851562500e+01 -6.6059593200683594e+01 -1.1717099761962891e+02 7.0357299804687500e+01 -5.5007099151611328e+01 -1.1719599914550781e+02 7.0403999328613281e+01 -5.4986396789550781e+01 -1.1728300476074219e+02 7.0474296569824219e+01 -5.4913497924804688e+01 -1.1541700744628906e+02 7.0403999328613281e+01 -6.7185798645019531e+01 -1.1527700042724609e+02 7.0403999328613281e+01 -6.6380599975585938e+01 -1.1534999847412109e+02 7.0474296569824219e+01 -6.6382804870605469e+01 -1.1536599731445312e+02 7.0474296569824219e+01 -6.6759201049804688e+01 -1.1529399871826172e+02 7.0403999328613281e+01 -6.6768898010253906e+01 -1.1548099517822266e+02 7.0474296569824219e+01 -6.7152297973632812e+01 -1.1786699676513672e+02 7.0474296569824219e+01 -5.1605998992919922e+01 -1.1779499816894531e+02 7.0403999328613281e+01 -5.1593299865722656e+01 -1.1640500640869141e+02 7.0499595642089844e+01 -6.7440101623535156e+01 -1.1639899444580078e+02 7.0473098754882812e+01 -6.7527999877929688e+01 -1.1639899444580078e+02 7.0473800659179688e+01 -6.7525703430175781e+01 -1.1613700103759766e+02 7.0474296569824219e+01 -6.7503799438476562e+01 -1.1639299774169922e+02 7.0372703552246094e+01 -6.7614097595214844e+01 -1.1639499664306641e+02 7.0402503967285156e+01 -6.7596199035644531e+01 -1.1612699890136719e+02 7.0403999328613281e+01 -6.7575996398925781e+01 -1.1639600372314453e+02 7.0430297851562500e+01 -6.7579597473144531e+01 -1.1541700744628906e+02 7.0403999328613281e+01 -6.7185897827148438e+01 -1.1576999664306641e+02 7.0474296569824219e+01 -6.7405799865722656e+01 -1.1558800506591797e+02 7.0474296569824219e+01 -6.7290199279785156e+01 -1.1573999786376953e+02 7.0403999328613281e+01 -6.7472198486328125e+01 -1.1553900146484375e+02 7.0403999328613281e+01 -6.7344200134277344e+01 -1.1737299346923828e+02 7.0403999328613281e+01 -5.1089900970458984e+01 -1.1737299346923828e+02 7.0474296569824219e+01 -5.1017101287841797e+01 -1.1744800567626953e+02 7.0404800415039062e+01 -5.1096000671386719e+01 -1.1746100616455078e+02 7.0474601745605469e+01 -5.1024398803710938e+01 -1.1765000152587891e+02 7.0406105041503906e+01 -5.1189399719238281e+01 -1.1777700042724609e+02 7.0405799865722656e+01 -5.1371601104736328e+01 -1.1769599914550781e+02 7.0474899291992188e+01 -5.1133701324462891e+01 -1.1784500122070312e+02 7.0474899291992188e+01 -5.1346801757812500e+01 -1.1646799468994141e+02 7.0474296569824219e+01 -6.7531494140625000e+01 -1.1646299743652344e+02 7.0403999328613281e+01 -6.7604202270507812e+01 -1.1664800262451172e+02 7.0403999328613281e+01 -6.7611595153808594e+01 -1.1683399963378906e+02 7.0403999328613281e+01 -6.7607498168945312e+01 -1.1702000427246094e+02 7.0403999328613281e+01 -6.7591506958007812e+01 -1.1664900207519531e+02 7.0474296569824219e+01 -6.7538703918457031e+01 -1.1683000183105469e+02 7.0474296569824219e+01 -6.7534797668457031e+01 -1.1701100158691406e+02 7.0474296569824219e+01 -6.7519203186035156e+01 -1.1405400085449219e+02 7.0403999328613281e+01 -5.1089900970458984e+01 -1.1405400085449219e+02 7.0474296569824219e+01 -5.1017101287841797e+01 -1.1715499877929688e+02 7.0403999328613281e+01 -6.7575904846191406e+01 -1.1714699554443359e+02 7.0474296569824219e+01 -6.7503402709960938e+01 -1.1383999633789062e+02 7.0405105590820312e+01 -5.1146701812744141e+01 -1.1361999511718750e+02 7.0474601745605469e+01 -5.1267601013183594e+01 -1.1355999755859375e+02 7.0474296569824219e+01 -5.1433300018310547e+01 -1.1368299865722656e+02 7.0404899597167969e+01 -5.1304000854492188e+01 -1.1363200378417969e+02 7.0403999328613281e+01 -5.1445701599121094e+01 -1.1380300140380859e+02 7.0474700927734375e+01 -5.1083801269531250e+01 -1.1762999725341797e+02 7.0403999328613281e+01 -6.8040603637695312e+01 -1.1761999511718750e+02 7.0405403137207031e+01 -6.7896697998046875e+01 -1.1719200134277344e+02 7.0404403686523438e+01 -6.7573097229003906e+01 -1.1719100189208984e+02 7.0474403381347656e+01 -6.7500198364257812e+01 -1.1733499908447266e+02 7.0405601501464844e+01 -6.7592796325683594e+01 -1.1746299743652344e+02 7.0406303405761719e+01 -6.7659103393554688e+01 -1.1756200408935547e+02 7.0406105041503906e+01 -6.7764404296875000e+01 -1.1735800170898438e+02 7.0474800109863281e+01 -6.7523597717285156e+01 -1.1750700378417969e+02 7.0474998474121094e+01 -6.7601196289062500e+01 -1.1762300109863281e+02 7.0474998474121094e+01 -6.7724304199218750e+01 -1.1768999481201172e+02 7.0474700927734375e+01 -6.7878997802734375e+01 -1.1770299530029297e+02 7.0474296569824219e+01 -6.8047203063964844e+01 -1.1303699493408203e+02 7.0357299804687500e+01 -5.5007099151611328e+01 -1.1302000427246094e+02 7.0403999328613281e+01 -5.4986396789550781e+01 -1.1295800018310547e+02 7.0474296569824219e+01 -5.4913497924804688e+01 -1.1740600585937500e+02 7.0403999328613281e+01 -7.0515701293945312e+01 -1.1747899627685547e+02 7.0474296569824219e+01 -7.0522300720214844e+01 -1.1113899993896484e+02 7.0474296569824219e+01 -5.4913497924804688e+01 -1.1113899993896484e+02 7.0403999328613281e+01 -5.4986396789550781e+01 -1.1709700012207031e+02 7.0403999328613281e+01 -7.0889396667480469e+01 -1.1722700500488281e+02 7.0404594421386719e+01 -7.0827499389648438e+01 -1.1746199798583984e+02 7.0474403381347656e+01 -7.0615997314453125e+01 -1.1739200592041016e+02 7.0404403686523438e+01 -7.0595802307128906e+01 -1.1732900238037109e+02 7.0404800415039062e+01 -7.0725700378417969e+01 -1.1738899993896484e+02 7.0474601745605469e+01 -7.0767898559570312e+01 -1.1726900482177734e+02 7.0474494934082031e+01 -7.0886901855468750e+01 -1.1711700439453125e+02 7.0474296569824219e+01 -7.0959396362304688e+01 -1.1092399597167969e+02 7.0405105590820312e+01 -5.5043197631835938e+01 -1.1070399475097656e+02 7.0474601745605469e+01 -5.5163997650146484e+01 -1.1064500427246094e+02 7.0474296569824219e+01 -5.5328903198242188e+01 -1.1076699829101562e+02 7.0404899597167969e+01 -5.5200401306152344e+01 -1.1071699523925781e+02 7.0403999328613281e+01 -5.5341400146484375e+01 -1.1088800048828125e+02 7.0474700927734375e+01 -5.4980197906494141e+01 -1.1620800018310547e+02 7.0474296569824219e+01 -7.1150299072265625e+01 -1.1651699829101562e+02 7.0474296569824219e+01 -7.1100700378417969e+01 -1.1682199859619141e+02 7.0474296569824219e+01 -7.1036499023437500e+01 -1.1619800567626953e+02 7.0403999328613281e+01 -7.1078102111816406e+01 -1.1650299835205078e+02 7.0403999328613281e+01 -7.1029098510742188e+01 -1.1680500030517578e+02 7.0403999328613281e+01 -7.0965499877929688e+01 -1.1031600189208984e+02 7.0403999328613281e+01 -5.7633998870849609e+01 -1.1024499511718750e+02 7.0474296569824219e+01 -5.7621501922607422e+01 -1.1559999847412109e+02 7.0474296569824219e+01 -7.1207702636718750e+01 -1.1498499298095703e+02 7.0474296569824219e+01 -7.1216903686523438e+01 -1.1559599304199219e+02 7.0403999328613281e+01 -7.1134902954101562e+01 -1.1498600006103516e+02 7.0403999328613281e+01 -7.1144096374511719e+01 -1.1073899841308594e+02 7.0403999328613281e+01 -5.8136501312255859e+01 -1.1073899841308594e+02 7.0474296569824219e+01 -5.8209400177001953e+01 -1.1066500091552734e+02 7.0404701232910156e+01 -5.8130599975585938e+01 -1.1065200042724609e+02 7.0474601745605469e+01 -5.8202301025390625e+01 -1.1046299743652344e+02 7.0406105041503906e+01 -5.8037696838378906e+01 -1.1033499908447266e+02 7.0405799865722656e+01 -5.7855697631835938e+01 -1.1041600036621094e+02 7.0474899291992188e+01 -5.8093399047851562e+01 -1.1026699829101562e+02 7.0474899291992188e+01 -5.7880599975585938e+01 -1.1312400054931641e+02 7.0474296569824219e+01 -7.0850097656250000e+01 -1.1373500061035156e+02 7.0474296569824219e+01 -7.1061500549316406e+01 -1.1436000061035156e+02 7.0474296569824219e+01 -7.1176902770996094e+01 -1.1315399932861328e+02 7.0403999328613281e+01 -7.0783599853515625e+01 -1.1375299835205078e+02 7.0403999328613281e+01 -7.0991004943847656e+01 -1.1436899566650391e+02 7.0403999328613281e+01 -7.1104598999023438e+01 -1.1249499511718750e+02 7.0357299804687500e+01 -5.8115798950195312e+01 -1.1247000122070312e+02 7.0403999328613281e+01 -5.8136501312255859e+01 -1.1238499450683594e+02 7.0474296569824219e+01 -5.8209400177001953e+01 -1.1224500274658203e+02 7.0403999328613281e+01 -7.0193405151367188e+01 -1.1190000152587891e+02 7.0403999328613281e+01 -6.9817398071289062e+01 -1.1219599914550781e+02 7.0474296569824219e+01 -7.0247001647949219e+01 -1.1184299468994141e+02 7.0474296569824219e+01 -6.9861892700195312e+01 -1.1263700103759766e+02 7.0403999328613281e+01 -7.0500404357910156e+01 -1.1259700012207031e+02 7.0474296569824219e+01 -7.0561103820800781e+01 -1.1112699890136719e+02 7.0372703552246094e+01 -6.6477699279785156e+01 -1.1111000061035156e+02 7.0402503967285156e+01 -6.6475395202636719e+01 -1.1109300231933594e+02 7.0430198669433594e+01 -6.6473403930664062e+01 -1.1095300292968750e+02 7.0499702453613281e+01 -6.6456001281738281e+01 -1.1104000091552734e+02 7.0473800659179688e+01 -6.6466697692871094e+01 -1.1104199981689453e+02 7.0473098754882812e+01 -6.6467002868652344e+01 -1.1122200012207031e+02 7.0403999328613281e+01 -6.8351203918457031e+01 -1.1115100097656250e+02 7.0474296569824219e+01 -6.8367797851562500e+01 -1.1115100097656250e+02 7.0474296569824219e+01 -6.8367897033691406e+01 -1.1137500000000000e+02 7.0403999328613281e+01 -6.8860099792480469e+01 -1.1130599975585938e+02 7.0474296569824219e+01 -6.8885398864746094e+01 -1.1158700561523438e+02 7.0403999328613281e+01 -6.9333702087402344e+01 -1.1152300262451172e+02 7.0474296569824219e+01 -6.9368103027343750e+01 -1.1103399658203125e+02 7.0474296569824219e+01 -6.6533401489257812e+01 -1.1110700225830078e+02 7.0403999328613281e+01 -6.6539100646972656e+01 -1.1101199340820312e+02 7.0474296569824219e+01 -6.7149299621582031e+01 -1.1104799652099609e+02 7.0474296569824219e+01 -6.7763099670410156e+01 -1.1108499908447266e+02 7.0403999328613281e+01 -6.7148605346679688e+01 -1.1112000274658203e+02 7.0403999328613281e+01 -6.7754997253417969e+01 -9.3805198669433594e+01 7.0372703552246094e+01 -4.8014598846435547e+01 -9.4085205078125000e+01 7.0474296569824219e+01 -4.7937797546386719e+01 -9.3806800842285156e+01 7.0473899841308594e+01 -4.7926197052001953e+01 -9.3806800842285156e+01 7.0473197937011719e+01 -4.7928401947021484e+01 -9.3805793762207031e+01 7.0430297851562500e+01 -4.7980098724365234e+01 -9.4081092834472656e+01 7.0403999328613281e+01 -4.8010498046875000e+01 -9.3805496215820312e+01 7.0402503967285156e+01 -4.7996799468994141e+01 -9.3808097839355469e+01 7.0498603820800781e+01 -4.7851497650146484e+01 -9.4367195129394531e+01 7.0403999328613281e+01 -4.8031597137451172e+01 -9.4652397155761719e+01 7.0403999328613281e+01 -4.8062000274658203e+01 -9.4936500549316406e+01 7.0403999328613281e+01 -4.8101898193359375e+01 -9.4373802185058594e+01 7.0474296569824219e+01 -4.7958999633789062e+01 -9.4661399841308594e+01 7.0474296569824219e+01 -4.7989700317382812e+01 -9.4947799682617188e+01 7.0474296569824219e+01 -4.8029998779296875e+01 -9.3106101989746094e+01 7.0474296569824219e+01 -4.7946300506591797e+01 -9.3111198425292969e+01 7.0403999328613281e+01 -4.8019001007080078e+01 -9.1930900573730469e+01 7.0403999328613281e+01 -4.8197299957275391e+01 -9.1913795471191406e+01 7.0474296569824219e+01 -4.8126499176025391e+01 -9.1351501464843750e+01 7.0403999328613281e+01 -4.8366600036621094e+01 -9.1327697753906250e+01 7.0474296569824219e+01 -4.8297801971435547e+01 -9.5217506408691406e+01 7.0403999328613281e+01 -4.8148200988769531e+01 -9.5682395935058594e+01 7.0403999328613281e+01 -4.8232902526855469e+01 -9.5229797363281250e+01 7.0474296569824219e+01 -4.8076301574707031e+01 -9.5696205139160156e+01 7.0474296569824219e+01 -4.8161300659179688e+01 -9.1327598571777344e+01 7.0474296569824219e+01 -4.8297801971435547e+01 -9.0412902832031250e+01 7.0403999328613281e+01 -4.8782199859619141e+01 -9.0377799987792969e+01 7.0474296569824219e+01 -4.8718299865722656e+01 -8.9899597167968750e+01 7.0403999328613281e+01 -4.9102298736572266e+01 -8.9857696533203125e+01 7.0474296569824219e+01 -4.9042701721191406e+01 -8.9424995422363281e+01 7.0403999328613281e+01 -4.9476898193359375e+01 -8.9376701354980469e+01 7.0474296569824219e+01 -4.9422302246093750e+01 -9.5740997314453125e+01 7.0404502868652344e+01 -4.8248203277587891e+01 -9.5764801025390625e+01 7.0474403381347656e+01 -4.8179397583007812e+01 -9.6019599914550781e+01 7.0404899597167969e+01 -4.8557300567626953e+01 -9.5964294433593750e+01 7.0405403137207031e+01 -4.8424098968505859e+01 -9.5867698669433594e+01 7.0405197143554688e+01 -4.8317001342773438e+01 -9.6027297973632812e+01 7.0403999328613281e+01 -4.8701202392578125e+01 -9.5912796020507812e+01 7.0474700927734375e+01 -4.8259899139404297e+01 -9.6025695800781250e+01 7.0474700927734375e+01 -4.8385200500488281e+01 -9.6090499877929688e+01 7.0474601745605469e+01 -4.8540996551513672e+01 -9.6099800109863281e+01 7.0474296569824219e+01 -4.8709300994873047e+01 -8.8662902832031250e+01 7.0474296569824219e+01 -5.0184001922607422e+01 -8.8720497131347656e+01 7.0403999328613281e+01 -5.0228698730468750e+01 -8.8374603271484375e+01 7.0403999328613281e+01 -5.0725898742675781e+01 -8.8312797546386719e+01 7.0474296569824219e+01 -5.0687397003173828e+01 -8.8079498291015625e+01 7.0403999328613281e+01 -5.1256099700927734e+01 -8.8014198303222656e+01 7.0474296569824219e+01 -5.1223800659179688e+01 -9.5824401855468750e+01 7.0474296569824219e+01 -5.1186901092529297e+01 -9.5751998901367188e+01 7.0403999328613281e+01 -5.1178802490234375e+01 -8.7827896118164062e+01 7.0403999328613281e+01 -5.1833000183105469e+01 -8.7632904052734375e+01 7.0403999328613281e+01 -5.2427097320556641e+01 -8.7396301269531250e+01 7.0403999328613281e+01 -5.3628398895263672e+01 -8.7562705993652344e+01 7.0474296569824219e+01 -5.2407501220703125e+01 -8.7323997497558594e+01 7.0474296569824219e+01 -5.3619102478027344e+01 -8.7759704589843750e+01 7.0474296569824219e+01 -5.1807197570800781e+01 -9.5246002197265625e+01 7.0403999328613281e+01 -5.1552700042724609e+01 -9.5390197753906250e+01 7.0405197143554688e+01 -5.1556198120117188e+01 -9.5719902038574219e+01 7.0405105590820312e+01 -5.1302196502685547e+01 -9.5786697387695312e+01 7.0474601745605469e+01 -5.1331100463867188e+01 -9.5641601562500000e+01 7.0405700683593750e+01 -5.1423301696777344e+01 -9.5527404785156250e+01 7.0405799865722656e+01 -5.1511299133300781e+01 -9.5694999694824219e+01 7.0474899291992188e+01 -5.1472499847412109e+01 -9.5561401367187500e+01 7.0474899291992188e+01 -5.1575500488281250e+01 -9.5400993347167969e+01 7.0474700927734375e+01 -5.1628101348876953e+01 -9.5232398986816406e+01 7.0474296569824219e+01 -5.1624301910400391e+01 -8.7241302490234375e+01 7.0357299804687500e+01 -5.4992500305175781e+01 -8.7222999572753906e+01 7.0403999328613281e+01 -5.4971797943115234e+01 -8.7158905029296875e+01 7.0474296569824219e+01 -5.4899398803710938e+01 -9.5064002990722656e+01 7.0474296569824219e+01 -5.1594200134277344e+01 -9.5075897216796875e+01 7.0403999328613281e+01 -5.1522300720214844e+01 -8.5296195983886719e+01 7.0474296569824219e+01 -5.4911300659179688e+01 -8.5296699523925781e+01 7.0403999328613281e+01 -5.4984100341796875e+01 -9.4463104248046875e+01 7.0498497009277344e+01 -5.1617801666259766e+01 -9.4463600158691406e+01 7.0473197937011719e+01 -5.1542301177978516e+01 -9.4463600158691406e+01 7.0473899841308594e+01 -5.1544498443603516e+01 -9.4554199218750000e+01 7.0474296569824219e+01 -5.1545398712158203e+01 -9.4464195251464844e+01 7.0372703552246094e+01 -5.1456001281738281e+01 -9.4464103698730469e+01 7.0402503967285156e+01 -5.1473899841308594e+01 -9.4555999755859375e+01 7.0403999328613281e+01 -5.1472599029541016e+01 -9.4463996887207031e+01 7.0430297851562500e+01 -5.1490600585937500e+01 -9.4724899291992188e+01 7.0474296569824219e+01 -5.1553699493408203e+01 -9.4894897460937500e+01 7.0474296569824219e+01 -5.1570098876953125e+01 -9.4730201721191406e+01 7.0403999328613281e+01 -5.1481101989746094e+01 -9.4903602600097656e+01 7.0403999328613281e+01 -5.1497699737548828e+01 -8.5082206726074219e+01 7.0405105590820312e+01 -5.5042400360107422e+01 -8.4862998962402344e+01 7.0474601745605469e+01 -5.5164600372314453e+01 -8.4805198669433594e+01 7.0474296569824219e+01 -5.5326698303222656e+01 -8.4926300048828125e+01 7.0404899597167969e+01 -5.5200599670410156e+01 -8.4876998901367188e+01 7.0403999328613281e+01 -5.5339199066162109e+01 -8.5045501708984375e+01 7.0474700927734375e+01 -5.4979598999023438e+01 -9.2616897583007812e+01 7.0403999328613281e+01 -5.2009197235107422e+01 -9.3450706481933594e+01 7.0403999328613281e+01 -5.1602500915527344e+01 -9.2659400939941406e+01 7.0474296569824219e+01 -5.2068401336669922e+01 -9.3471397399902344e+01 7.0474296569824219e+01 -5.1672298431396484e+01 -9.4364097595214844e+01 7.0403999328613281e+01 -5.1471401214599609e+01 -9.4364997863769531e+01 7.0474296569824219e+01 -5.1544200897216797e+01 -8.4476600646972656e+01 7.0403999328613281e+01 -5.7633998870849609e+01 -8.4404792785644531e+01 7.0474296569824219e+01 -5.7621501922607422e+01 -9.1629104614257812e+01 7.0372703552246094e+01 -5.3632999420166016e+01 -9.1646797180175781e+01 7.0402503967285156e+01 -5.3636199951171875e+01 -9.1763198852539062e+01 7.0403999328613281e+01 -5.3182399749755859e+01 -9.1792297363281250e+01 7.0498901367187500e+01 -5.3662399291992188e+01 -9.1832099914550781e+01 7.0474296569824219e+01 -5.3206100463867188e+01 -9.1663101196289062e+01 7.0430297851562500e+01 -5.3639099121093750e+01 -9.1714096069335938e+01 7.0473098754882812e+01 -5.3648300170898438e+01 -9.1716201782226562e+01 7.0473899841308594e+01 -5.3648597717285156e+01 -9.2107902526855469e+01 7.0403999328613281e+01 -5.2512298583984375e+01 -9.2166702270507812e+01 7.0474296569824219e+01 -5.2555301666259766e+01 -8.4899002075195312e+01 7.0403999328613281e+01 -5.8136501312255859e+01 -8.4899002075195312e+01 7.0474296569824219e+01 -5.8209400177001953e+01 -8.4825096130371094e+01 7.0404701232910156e+01 -5.8130599975585938e+01 -8.4812500000000000e+01 7.0474601745605469e+01 -5.8202301025390625e+01 -8.4623001098632812e+01 7.0406105041503906e+01 -5.8037696838378906e+01 -8.4495300292968750e+01 7.0405799865722656e+01 -5.7855697631835938e+01 -8.4576400756835938e+01 7.0474899291992188e+01 -5.8093399047851562e+01 -8.4427001953125000e+01 7.0474899291992188e+01 -5.7880599975585938e+01 -9.1500793457031250e+01 7.0474296569824219e+01 -5.4913497924804688e+01 -9.1414497375488281e+01 7.0403999328613281e+01 -5.4986396789550781e+01 -9.1389999389648438e+01 7.0357299804687500e+01 -5.5007099151611328e+01 -8.6698699951171875e+01 7.0357299804687500e+01 -5.8115798950195312e+01 -8.6674102783203125e+01 7.0403999328613281e+01 -5.8136501312255859e+01 -8.6587501525878906e+01 7.0474296569824219e+01 -5.8209400177001953e+01 -9.3966003417968750e+01 7.0403999328613281e+01 -5.4986396789550781e+01 -9.3966003417968750e+01 7.0474296569824219e+01 -5.4913497924804688e+01 -8.4477500915527344e+01 7.0474296569824219e+01 -7.0366004943847656e+01 -8.4549301147460938e+01 7.0403999328613281e+01 -7.0378402709960938e+01 -9.4039901733398438e+01 7.0404701232910156e+01 -5.4992298126220703e+01 -9.4052497863769531e+01 7.0474601745605469e+01 -5.4920597076416016e+01 -9.4242103576660156e+01 7.0406105041503906e+01 -5.5085201263427734e+01 -9.4369796752929688e+01 7.0405799865722656e+01 -5.5267200469970703e+01 -9.4388496398925781e+01 7.0403999328613281e+01 -5.5488899230957031e+01 -9.4288696289062500e+01 7.0474899291992188e+01 -5.5029399871826172e+01 -9.4438003540039062e+01 7.0474899291992188e+01 -5.5242198944091797e+01 -9.4460197448730469e+01 7.0474296569824219e+01 -5.5501399993896484e+01 -8.4971702575683594e+01 7.0403999328613281e+01 -7.0880599975585938e+01 -8.4971702575683594e+01 7.0474296569824219e+01 -7.0953399658203125e+01 -8.4898200988769531e+01 7.0404701232910156e+01 -7.0874694824218750e+01 -8.4885795593261719e+01 7.0474601745605469e+01 -7.0946403503417969e+01 -8.4695999145507812e+01 7.0406105041503906e+01 -7.0781997680664062e+01 -8.4568199157714844e+01 7.0405799865722656e+01 -7.0600097656250000e+01 -8.4649505615234375e+01 7.0474899291992188e+01 -7.0837699890136719e+01 -8.4499900817871094e+01 7.0474899291992188e+01 -7.0625099182128906e+01 -9.3988296508789062e+01 7.0403999328613281e+01 -5.7781497955322266e+01 -9.4059997558593750e+01 7.0474296569824219e+01 -5.7794002532958984e+01 -8.8306800842285156e+01 7.0403999328613281e+01 -7.0880599975585938e+01 -8.8306800842285156e+01 7.0474296569824219e+01 -7.0953399658203125e+01 -9.3565795898437500e+01 7.0403999328613281e+01 -5.8136501312255859e+01 -9.3780693054199219e+01 7.0405105590820312e+01 -5.8079700469970703e+01 -9.4000694274902344e+01 7.0474601745605469e+01 -5.7958801269531250e+01 -9.3937705993652344e+01 7.0404899597167969e+01 -5.7922500610351562e+01 -9.3817001342773438e+01 7.0474700927734375e+01 -5.8142700195312500e+01 -9.3565795898437500e+01 7.0474296569824219e+01 -5.8209400177001953e+01 -8.8521598815917969e+01 7.0405105590820312e+01 -7.0823699951171875e+01 -8.8741600036621094e+01 7.0474601745605469e+01 -7.0702903747558594e+01 -8.8800994873046875e+01 7.0474296569824219e+01 -7.0537597656250000e+01 -8.8678596496582031e+01 7.0404899597167969e+01 -7.0666496276855469e+01 -8.8729202270507812e+01 7.0403999328613281e+01 -7.0525100708007812e+01 -8.8557899475097656e+01 7.0474700927734375e+01 -7.0886703491210938e+01 -9.0940696716308594e+01 7.0474296569824219e+01 -5.8209400177001953e+01 -9.0879501342773438e+01 7.0403999328613281e+01 -5.8136501312255859e+01 -9.0861999511718750e+01 7.0357299804687500e+01 -5.8115798950195312e+01 -1.0439299774169922e+02 7.0474296569824219e+01 -6.1344200134277344e+01 -9.9058395385742188e+01 7.0499893188476562e+01 -6.1247901916503906e+01 -9.8947196960449219e+01 7.0485298156738281e+01 -6.1321399688720703e+01 -9.8916000366210938e+01 7.0471199035644531e+01 -6.1342102050781250e+01 -9.8916000366210938e+01 7.0471199035644531e+01 -6.1342197418212891e+01 -1.0445100402832031e+02 7.0403999328613281e+01 -6.1416999816894531e+01 -9.8882804870605469e+01 7.0456100463867188e+01 -6.1364299774169922e+01 -9.8768898010253906e+01 7.0346801757812500e+01 -6.1440700531005859e+01 -1.0446800231933594e+02 7.0357299804687500e+01 -6.1437801361083984e+01 -9.8842796325683594e+01 7.0437995910644531e+01 -6.1390899658203125e+01 -9.8806098937988281e+01 7.0402999877929688e+01 -6.1415599822998047e+01 -9.8791999816894531e+01 7.0389595031738281e+01 -6.1424999237060547e+01 -1.0437999725341797e+02 7.0499504089355469e+01 -6.1008899688720703e+01 -1.0446300506591797e+02 7.0473800659179688e+01 -6.1025299072265625e+01 -1.0446599578857422e+02 7.0473098754882812e+01 -6.1025699615478516e+01 -1.0451599884033203e+02 7.0430297851562500e+01 -6.1035800933837891e+01 -1.0454999542236328e+02 7.0372703552246094e+01 -6.1042499542236328e+01 -1.0453300476074219e+02 7.0402503967285156e+01 -6.1039001464843750e+01 -9.9084899902343750e+01 7.0403999328613281e+01 -6.0778800964355469e+01 -9.9150703430175781e+01 7.0474296569824219e+01 -6.0809898376464844e+01 -9.8833999633789062e+01 7.0403999328613281e+01 -6.1343902587890625e+01 -9.9361892700195312e+01 7.0403999328613281e+01 -6.0226501464843750e+01 -9.9426200866699219e+01 7.0474296569824219e+01 -6.0260601043701172e+01 -1.0459599304199219e+02 7.0403999328613281e+01 -6.0267700195312500e+01 -1.0457099914550781e+02 7.0403999328613281e+01 -5.9933200836181641e+01 -1.0449900054931641e+02 7.0474296569824219e+01 -5.9942302703857422e+01 -1.0455300140380859e+02 7.0403999328613281e+01 -6.0931297302246094e+01 -1.0448099517822266e+02 7.0474296569824219e+01 -6.0920497894287109e+01 -1.0458899688720703e+02 7.0403999328613281e+01 -6.0601303100585938e+01 -1.0451599884033203e+02 7.0474296569824219e+01 -6.0596397399902344e+01 -1.0452300262451172e+02 7.0474296569824219e+01 -6.0269401550292969e+01 -9.9711402893066406e+01 7.0403999328613281e+01 -5.9657199859619141e+01 -9.9770904541015625e+01 7.0474296569824219e+01 -5.9699298858642578e+01 -1.0012699890136719e+02 7.0403999328613281e+01 -5.9147499084472656e+01 -1.0018000030517578e+02 7.0474296569824219e+01 -5.9197399139404297e+01 -1.0440900421142578e+02 7.0403999328613281e+01 -5.9314098358154297e+01 -1.0425299835205078e+02 7.0403999328613281e+01 -5.9019802093505859e+01 -1.0434199523925781e+02 7.0474296569824219e+01 -5.9342700958251953e+01 -1.0419099426269531e+02 7.0474296569824219e+01 -5.9059398651123047e+01 -1.0451200103759766e+02 7.0403999328613281e+01 -5.9619197845458984e+01 -1.0444200134277344e+02 7.0474296569824219e+01 -5.9637401580810547e+01 -1.0018000030517578e+02 7.0474296569824219e+01 -5.9197299957275391e+01 -1.0057499694824219e+02 7.0403999328613281e+01 -5.8745601654052734e+01 -1.0061799621582031e+02 7.0474296569824219e+01 -5.8803798675537109e+01 -1.0085199737548828e+02 7.0403999328613281e+01 -5.8557598114013672e+01 -1.0088999938964844e+02 7.0474296569824219e+01 -5.8619899749755859e+01 -1.0114599609375000e+02 7.0403999328613281e+01 -5.8397899627685547e+01 -1.0117800140380859e+02 7.0474296569824219e+01 -5.8463497161865234e+01 -1.0377899932861328e+02 7.0474296569824219e+01 -5.8621803283691406e+01 -1.0352400207519531e+02 7.0474296569824219e+01 -5.8462097167968750e+01 -1.0382299804687500e+02 7.0403999328613281e+01 -5.8563301086425781e+01 -1.0355799865722656e+02 7.0403999328613281e+01 -5.8397502899169922e+01 -1.0405300140380859e+02 7.0403999328613281e+01 -5.8766799926757812e+01 -1.0400000000000000e+02 7.0474296569824219e+01 -5.8816997528076172e+01 -1.0247699737548828e+02 7.0372703552246094e+01 -5.8121101379394531e+01 -1.0247399902343750e+02 7.0473098754882812e+01 -5.8207298278808594e+01 -1.0247599792480469e+02 7.0430297851562500e+01 -5.8155601501464844e+01 -1.0242700195312500e+02 7.0403999328613281e+01 -5.8135902404785156e+01 -1.0247599792480469e+02 7.0402503967285156e+01 -5.8138999938964844e+01 -1.0242600250244141e+02 7.0474296569824219e+01 -5.8208801269531250e+01 -1.0247399902343750e+02 7.0473800659179688e+01 -5.8209499359130859e+01 -1.0247100067138672e+02 7.0499198913574219e+01 -5.8290401458740234e+01 -1.0194699859619141e+02 7.0403999328613281e+01 -5.8164897918701172e+01 -1.0147100067138672e+02 7.0403999328613281e+01 -5.8269699096679688e+01 -1.0195600128173828e+02 7.0474296569824219e+01 -5.8237098693847656e+01 -1.0149300384521484e+02 7.0474296569824219e+01 -5.8339199066162109e+01 -1.0251999664306641e+02 7.0474296569824219e+01 -5.8211700439453125e+01 -1.0252500152587891e+02 7.0403999328613281e+01 -5.8138999938964844e+01 -1.0286100006103516e+02 7.0474296569824219e+01 -5.8249202728271484e+01 -1.0319899749755859e+02 7.0474296569824219e+01 -5.8328598022460938e+01 -1.0287300109863281e+02 7.0403999328613281e+01 -5.8177398681640625e+01 -1.0322100067138672e+02 7.0403999328613281e+01 -5.8259098052978516e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 35526 -> 45 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -7.2474598884582520e+01) (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -4.7525398433208466e+01) (float-vector -1.7700000107288361e+02 -5.0000002374872565e-01 -5.9999998658895493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6690999511629343e+00 -5.1488898694515228e+01 -5.9999998658895493e+01) (float-vector -2.6690999511629343e+00 -4.6389900147914886e+01 -8.2340203225612640e+01) (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.0458900034427643e+02) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -8.4404200315475464e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -7.2474598884582520e+01) (float-vector -1.7700000107288361e+02 -5.0000002374872565e-01 -5.9999998658895493e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -8.4404200315475464e+01) (float-vector -1.7181299626827240e+02 5.7999998331069946e+01 -8.4404200315475464e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -7.2474598884582520e+01) (float-vector -1.7125199735164642e+02 6.9682098925113678e+01 -5.5504601448774338e+01) (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -4.7525398433208466e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6554099321365356e+02 5.7999998331069946e+01 -2.4732900783419609e+01) (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -4.7525398433208466e+01) (float-vector -1.7125199735164642e+02 6.9682098925113678e+01 -5.5504601448774338e+01) (float-vector -1.5995900332927704e+02 6.9682098925113678e+01 -2.6563499122858047e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -7.2474598884582520e+01) (float-vector -1.7181299626827240e+02 5.7999998331069946e+01 -8.4404200315475464e+01) (float-vector -1.6598199307918549e+02 7.0288002490997314e+01 -8.1485398113727570e+01) (float-vector -1.7125199735164642e+02 6.9682098925113678e+01 -5.5504601448774338e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6690999511629343e+00 -3.6408100277185440e+01 -9.6408098936080933e+01) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -1.1967100203037262e+02) (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.0458900034427643e+02) (float-vector -2.6690999511629343e+00 -4.6389900147914886e+01 -8.2340203225612640e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6047999262809753e+02 6.8767800927162170e+01 -9.3841999769210815e+01) (float-vector -1.5714800357818604e+02 5.7999998331069946e+01 -1.0458900034427643e+02) (float-vector -1.4713600277900696e+02 6.8767800927162170e+01 -1.0612600296735764e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5714800357818604e+02 5.7999998331069946e+01 -1.0458900034427643e+02) (float-vector -1.7181299626827240e+02 5.7999998331069946e+01 -8.4404200315475464e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -8.4404200315475464e+01) (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.0458900034427643e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6047999262809753e+02 6.8767800927162170e+01 -9.3841999769210815e+01) (float-vector -1.6598199307918549e+02 7.0288002490997314e+01 -8.1485398113727570e+01) (float-vector -1.7181299626827240e+02 5.7999998331069946e+01 -8.4404200315475464e+01) (float-vector -1.5714800357818604e+02 5.7999998331069946e+01 -1.0458900034427643e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6554099321365356e+02 5.7999998331069946e+01 -2.4732900783419609e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -3.5595800727605820e+01) (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -4.7525398433208466e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7568899691104889e+02 5.7999998331069946e+01 -4.7525398433208466e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -3.5595800727605820e+01) (float-vector -1.7700000107288361e+02 -5.0000002374872565e-01 -5.9999998658895493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.5411299653351307e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -3.5595800727605820e+01) (float-vector -1.6554099321365356e+02 5.7999998331069946e+01 -2.4732900783419609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7700000107288361e+02 -5.0000002374872565e-01 -5.9999998658895493e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -3.5595800727605820e+01) (float-vector -2.6690999511629343e+00 -5.1488898694515228e+01 -5.9999998658895493e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -8.4404200315475464e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -4.8429001122713089e+01) (float-vector -9.2070199549198151e+01 7.0499897003173828e+01 -1.3933800160884857e+01) (float-vector -6.9959700107574463e+01 7.0288002490997314e+01 -3.4543000161647797e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3554100692272186e+02 5.7999998331069946e+01 -1.1706300079822540e+02) (float-vector -1.3036400079727173e+02 6.9682098925113678e+01 -1.1277200281620026e+02) (float-vector -1.4713600277900696e+02 6.8767800927162170e+01 -1.0612600296735764e+02) (float-vector -1.5714800357818604e+02 5.7999998331069946e+01 -1.0458900034427643e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3036400079727173e+02 6.9682098925113678e+01 -1.1277200281620026e+02) (float-vector -1.3554100692272186e+02 5.7999998331069946e+01 -1.1706300079822540e+02) (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector -1.1072800308465958e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector -1.1699999868869781e+02 7.0499897003173828e+01 -1.1237899959087372e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector -1.3554100692272186e+02 5.7999998331069946e+01 -1.1706300079822540e+02) (float-vector -1.5714800357818604e+02 5.7999998331069946e+01 -1.0458900034427643e+02) (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.0458900034427643e+02) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -1.1967100203037262e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4291000366210938e+02 6.9682098925113678e+01 -1.2123200111091137e+01) (float-vector -1.4699999988079071e+02 5.7999998331069946e+01 -8.0385198816657066e+00) (float-vector -1.6554099321365356e+02 5.7999998331069946e+01 -2.4732900783419609e+01) (float-vector -1.5995900332927704e+02 6.9682098925113678e+01 -2.6563499122858047e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4291000366210938e+02 6.9682098925113678e+01 -1.2123200111091137e+01) (float-vector -1.2596000730991364e+02 6.9682098925113678e+01 -6.3044498674571514e+00) (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -3.2872101292014122e-01) (float-vector -1.4699999988079071e+02 5.7999998331069946e+01 -8.0385198816657066e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -3.2872101292014122e-01) (float-vector -1.4699999988079071e+02 -5.0000002374872565e-01 -8.0385198816657066e+00) (float-vector -1.4699999988079071e+02 5.7999998331069946e+01 -8.0385198816657066e+00) (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -3.2872101292014122e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4699999988079071e+02 -5.0000002374872565e-01 -8.0385198816657066e+00) (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.5411299653351307e+01) (float-vector -1.6554099321365356e+02 5.7999998331069946e+01 -2.4732900783419609e+01) (float-vector -1.4699999988079071e+02 5.7999998331069946e+01 -8.0385198816657066e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5714800357818604e+02 -5.0000002374872565e-01 -1.5411299653351307e+01) (float-vector -1.4699999988079071e+02 -5.0000002374872565e-01 -8.0385198816657066e+00) (float-vector 1.2132000410929322e+00 -4.9081899225711823e+01 -4.2825501412153244e+01) (float-vector -2.6690999511629343e+00 -5.1488898694515228e+01 -5.9999998658895493e+01) (float-vector -1.7181299626827240e+02 -5.0000002374872565e-01 -3.5595800727605820e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1072800308465958e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -1.1200000345706940e+02) (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.0684999823570251e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1699999868869781e+02 7.0499897003173828e+01 -1.1237899959087372e+02) (float-vector -1.1072800308465958e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.0684999823570251e+02) (float-vector 5.2499901503324509e+01 4.0655199438333511e+01 -9.2421501874923706e+01) (float-vector -8.7745398283004761e+01 7.0288002490997314e+01 -1.0477700084447861e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6047999262809753e+02 6.8767800927162170e+01 -9.3841999769210815e+01) (float-vector -1.4713600277900696e+02 6.8767800927162170e+01 -1.0612600296735764e+02) (float-vector -1.3036400079727173e+02 6.9682098925113678e+01 -1.1277200281620026e+02) (float-vector -1.1699999868869781e+02 7.0499897003173828e+01 -1.1237899959087372e+02) (float-vector -8.7745398283004761e+01 7.0288002490997314e+01 -1.0477700084447861e+02) (float-vector -7.0933796465396881e+01 7.0499897003173828e+01 -8.4929801523685455e+01) (float-vector -6.9959700107574463e+01 7.0288002490997314e+01 -3.4543000161647797e+01) (float-vector -9.2070199549198151e+01 7.0499897003173828e+01 -1.3933800160884857e+01) (float-vector -1.0793100297451019e+02 6.8767800927162170e+01 -5.6532598100602627e+00) (float-vector -1.2596000730991364e+02 6.9682098925113678e+01 -6.3044498674571514e+00) (float-vector -1.4291000366210938e+02 6.9682098925113678e+01 -1.2123200111091137e+01) (float-vector -1.5995900332927704e+02 6.9682098925113678e+01 -2.6563499122858047e+01) (float-vector -1.7125199735164642e+02 6.9682098925113678e+01 -5.5504601448774338e+01) (float-vector -1.6598199307918549e+02 7.0288002490997314e+01 -8.1485398113727570e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -3.2872101292014122e-01) (float-vector 1.2132000410929322e+00 -4.0655199438333511e+01 -2.7578499168157578e+01) (float-vector 1.2132000410929322e+00 -4.9081899225711823e+01 -4.2825501412153244e+01) (float-vector -1.4699999988079071e+02 -5.0000002374872565e-01 -8.0385198816657066e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -1.1571000330150127e+01 -1.1069600284099579e+02) (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -1.1200000345706940e+02) (float-vector -1.1072800308465958e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -1.1967100203037262e+02) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -1.1967100203037262e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -1.1571000330150127e+01 -1.1069600284099579e+02) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -1.1967100203037262e+02) (float-vector -2.6690999511629343e+00 -3.6408100277185440e+01 -9.6408098936080933e+01) (float-vector 5.2499901503324509e+01 -3.2421499490737915e+01 -1.0065499693155289e+02)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -5.2000001072883606e+01 -5.9999998658895493e+01) (float-vector 5.2499901503324509e+01 -4.6850398182868958e+01 -8.2561902701854706e+01) (float-vector -2.6690999511629343e+00 -4.6389900147914886e+01 -8.2340203225612640e+01) (float-vector -2.6690999511629343e+00 -5.1488898694515228e+01 -5.9999998658895493e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6690999511629343e+00 -4.6389900147914886e+01 -8.2340203225612640e+01) (float-vector 5.2499901503324509e+01 -4.6850398182868958e+01 -8.2561902701854706e+01) (float-vector 5.2499901503324509e+01 -3.2421499490737915e+01 -1.0065499693155289e+02) (float-vector -2.6690999511629343e+00 -3.6408100277185440e+01 -9.6408098936080933e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -7.1570999920368195e+01) (float-vector -8.7745398283004761e+01 7.0288002490997314e+01 -1.0477700084447861e+02) (float-vector 5.2499901503324509e+01 4.0655199438333511e+01 -9.2421501874923706e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.7745398283004761e+01 7.0288002490997314e+01 -1.0477700084447861e+02) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -7.1570999920368195e+01) (float-vector -7.0933796465396881e+01 7.0499897003173828e+01 -8.4929801523685455e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.9959700107574463e+01 7.0288002490997314e+01 -3.4543000161647797e+01) (float-vector -7.0933796465396881e+01 7.0499897003173828e+01 -8.4929801523685455e+01) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -7.1570999920368195e+01) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -4.8429001122713089e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -3.2872101292014122e-01) (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -8.0000199377536774e+00) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -3.2872101292014122e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -8.0000199377536774e+00) (float-vector 5.2499901503324509e+01 -2.2561900317668915e+01 -1.3149599544703960e+01) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -3.2872101292014122e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -4.0655199438333511e+01 -2.7578499168157578e+01) (float-vector 1.2132000410929322e+00 -4.0655199438333511e+01 -2.7578499168157578e+01) (float-vector -1.2327200174331665e+02 -5.0000002374872565e-01 -3.2872101292014122e-01) (float-vector 5.2499901503324509e+01 -2.2561900317668915e+01 -1.3149599544703960e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.3149599544703960e+01) (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -8.0000199377536774e+00) (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -3.2872101292014122e-01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0793100297451019e+02 6.8767800927162170e+01 -5.6532598100602627e+00) (float-vector 5.2499901503324509e+01 3.2421499490737915e+01 -1.9344799220561981e+01) (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.3149599544703960e+01) (float-vector -1.2327200174331665e+02 5.7999998331069946e+01 -3.2872101292014122e-01) (float-vector -1.2596000730991364e+02 6.9682098925113678e+01 -6.3044498674571514e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 3.2421499490737915e+01 -1.9344799220561981e+01) (float-vector -1.0793100297451019e+02 6.8767800927162170e+01 -5.6532598100602627e+00) (float-vector -9.2070199549198151e+01 7.0499897003173828e+01 -1.3933800160884857e+01) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -4.8429001122713089e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -5.0696298480033875e+01 -4.8429001122713089e+01) (float-vector 5.2499901503324509e+01 -5.2000001072883606e+01 -5.9999998658895493e+01) (float-vector -2.6690999511629343e+00 -5.1488898694515228e+01 -5.9999998658895493e+01) (float-vector 1.2132000410929322e+00 -4.9081899225711823e+01 -4.2825501412153244e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -5.0696298480033875e+01 -4.8429001122713089e+01) (float-vector 1.2132000410929322e+00 -4.9081899225711823e+01 -4.2825501412153244e+01) (float-vector 1.2132000410929322e+00 -4.0655199438333511e+01 -2.7578499168157578e+01) (float-vector 5.2499901503324509e+01 -4.0655199438333511e+01 -2.7578499168157578e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -8.0000199377536774e+00) (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.3149599544703960e+01) (float-vector 5.4999999701976776e+01 2.3749899119138718e+01 -1.8863800913095474e+01) (float-vector 5.2499901503324509e+01 -2.2561900317668915e+01 -1.3149599544703960e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.4999999701976776e+01 2.3749899119138718e+01 -1.8863800913095474e+01) (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.3149599544703960e+01) (float-vector 5.2499901503324509e+01 3.2421499490737915e+01 -1.9344799220561981e+01) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -4.8429001122713089e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 5.2499901503324509e+01 -4.6850398182868958e+01 -8.2561902701854706e+01) (float-vector 5.2499901503324509e+01 -5.2000001072883606e+01 -5.9999998658895493e+01) (float-vector 5.2499901503324509e+01 -5.0696298480033875e+01 -4.8429001122713089e+01) (float-vector 5.2499901503324509e+01 -4.0655199438333511e+01 -2.7578499168157578e+01) (float-vector 5.2499901503324509e+01 -2.2561900317668915e+01 -1.3149599544703960e+01) (float-vector 5.4999999701976776e+01 2.3749899119138718e+01 -1.8863800913095474e+01) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -4.8429001122713089e+01) (float-vector 5.2499901503324509e+01 5.0696298480033875e+01 -7.1570999920368195e+01) (float-vector 5.2499901503324509e+01 4.0655199438333511e+01 -9.2421501874923706e+01) (float-vector 5.2499901503324509e+01 2.2561900317668915e+01 -1.0684999823570251e+02) (float-vector 5.2499901503324509e+01 0.0000000000000000e+00 -1.1200000345706940e+02) (float-vector 5.2499901503324509e+01 -1.1571000330150127e+01 -1.1069600284099579e+02) (float-vector 5.2499901503324509e+01 -3.2421499490737915e+01 -1.0065499693155289e+02)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_shoulder_lift_link_9Ygxyy.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_upperarm_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 2.1900000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 0 5 1 1212 5 0 1212 0 1210 1210 0 2 1 5 6 1214 6 5 1214 5 1212 1210 1211 1212 1212 1211 1213 1212 1213 1214 1208 1209 1210 1210 1209 1211 1210 2 1208 155 1213 1211 155 1211 152 152 1211 1209 1214 1213 1215 158 1215 1213 158 1213 155 152 154 155 154 156 155 155 156 157 155 157 158 157 159 158 158 159 160 158 160 161 161 1215 158 156 1329 157 157 1329 1330 157 1330 159 154 1328 156 156 1328 1329 1328 1269 1329 1329 1269 1270 1329 1270 1330 1330 1270 1271 1330 1271 1331 159 1330 1331 159 1331 160 1331 1271 1272 1331 1272 1332 160 1331 1332 1270 1136 1271 1271 1136 1135 1271 1135 1272 1269 1157 1270 1270 1157 1136 1134 1135 1136 1136 1157 1134 1134 1133 1135 1272 1135 1133 1272 1133 1273 1332 1272 1273 1132 1133 1134 1273 1133 1132 1273 1132 1274 1332 1273 1333 1333 1273 1274 1132 1134 1128 1274 1132 1128 1274 1128 1275 1333 1274 1334 1334 1274 1275 162 1332 1333 162 1333 163 163 1333 1334 1334 1275 1335 163 1334 165 165 1334 1335 161 162 163 161 163 164 163 165 164 160 162 161 160 1332 162 164 1217 161 161 1217 1215 164 165 166 164 166 167 167 1219 164 164 1219 1217 165 1335 166 166 168 167 166 1335 1336 166 1336 168 167 168 169 167 169 170 170 1221 167 167 1221 1219 1218 1217 1219 1218 1219 1220 1220 1219 1221 1220 1221 1222 1222 1221 1223 170 1223 1221 1220 8 1218 1222 9 1220 1220 9 8 1216 1217 1218 1218 8 7 1218 7 1216 7 8 1 1 8 9 1 9 10 1222 10 9 2 1 3 1 6 7 10 20 1 1240 3 1 1240 1 1238 1238 1 20 1216 7 6 1216 6 1214 1214 1215 1216 1216 1215 1217 10 19 20 1238 20 1236 1236 20 19 18 19 10 1236 19 1234 1234 19 18 1234 1235 1236 1236 1235 1237 1236 1237 1238 1232 1233 1234 1234 1233 1235 1234 18 1232 10 17 18 1232 18 17 1230 1231 1232 1232 1231 1233 1232 17 1230 188 1235 1233 188 1233 185 185 1233 1231 1230 1229 1231 185 1231 182 182 1231 1229 1228 1229 1230 1230 17 13 1230 13 1228 10 13 17 11 12 13 11 13 10 1228 13 12 1226 1227 1228 1228 1227 1229 1228 12 1226 1226 12 11 1226 11 1224 1224 11 10 1224 10 1222 1222 1223 1224 1224 1223 1225 1224 1225 1226 1226 1225 1227 179 1229 1227 179 1227 176 176 1227 1225 176 1225 173 173 1225 1223 173 1223 170 170 172 173 172 174 173 173 174 175 173 175 176 175 177 176 176 177 178 176 178 179 174 1341 175 175 1341 1342 175 1342 177 172 1340 174 174 1340 1341 1340 1281 1341 1341 1281 1282 1341 1282 1342 1342 1282 1283 1342 1283 1343 177 1342 1343 177 1343 178 1343 1283 1284 1343 1284 1344 178 1343 1344 1282 1137 1283 1283 1137 1148 1283 1148 1284 1281 1138 1282 1282 1138 1137 1137 1138 1129 1129 1148 1137 1129 1147 1148 1284 1148 1147 1284 1147 1285 1344 1284 1285 1285 1147 1154 1285 1154 1286 1344 1285 1345 1345 1285 1286 1151 1153 1154 1151 1154 1147 1286 1154 1153 1286 1153 1287 1345 1286 1346 1346 1286 1287 180 1344 1345 180 1345 181 181 1345 1346 1346 1287 1347 181 1346 183 183 1346 1347 179 180 181 179 181 182 181 183 182 178 180 179 178 1344 180 182 1229 179 182 183 184 182 184 185 183 1347 184 184 186 185 184 1347 1348 184 1348 186 185 186 187 185 187 188 186 1348 1349 186 1349 187 1347 1288 1348 1348 1288 1289 1348 1289 1349 1349 1289 1290 1349 1290 1350 187 1349 1350 187 189 188 187 1350 189 1350 1290 1291 1350 1291 1351 189 1350 1351 1289 1150 1290 1290 1150 1149 1290 1149 1291 1288 1151 1289 1289 1151 1150 1147 1149 1150 1147 1150 1151 1146 1149 1147 1291 1149 1146 1291 1146 1292 1351 1291 1292 1146 1147 1129 1292 1146 1129 1292 1129 1293 1351 1292 1352 1352 1292 1293 1293 1129 1127 1293 1127 1294 1352 1293 1353 1353 1293 1294 190 1351 1352 190 1352 192 192 1352 1353 1353 1294 1354 192 1353 193 193 1353 1354 190 192 191 191 192 193 188 189 190 188 190 191 189 1351 190 191 193 194 194 1237 191 191 1237 1235 191 1235 188 196 194 193 193 1354 196 195 66 194 195 194 196 66 1239 194 194 1239 1237 1238 1237 1239 1238 1239 1240 1240 1239 1241 66 1241 1239 1240 1241 1242 1242 3 1240 1242 1241 1243 54 1243 1241 54 1241 66 1242 1243 1244 1244 4 1242 1242 4 3 2 3 4 4 14 2 1244 14 4 1244 1243 1186 1244 1186 1188 1188 14 1244 49 1186 1243 49 1243 54 1186 1187 1188 44 1187 1186 44 1186 49 1188 1187 1189 1188 1189 1190 1190 15 1188 1188 15 14 2 14 15 2 15 16 1190 16 15 1190 1189 1191 1190 1191 1192 1192 16 1190 38 1191 1189 38 1189 41 41 1189 1187 41 1187 44 41 42 38 44 45 41 41 45 46 41 46 42 38 42 43 770 771 42 42 771 43 46 770 42 46 45 767 767 770 46 44 51 45 51 767 45 772 768 767 767 768 770 644 772 767 644 767 51 768 769 770 770 769 771 594 593 768 768 593 769 772 594 768 595 594 772 645 595 772 645 772 644 470 593 594 470 594 468 468 594 595 592 593 470 592 775 593 775 769 593 470 468 471 592 470 596 596 470 471 468 464 469 471 468 469 468 595 464 471 469 460 596 471 597 597 471 598 598 471 460 469 464 465 469 465 463 460 469 463 464 451 465 465 451 449 465 449 466 463 465 466 461 462 463 463 466 461 460 463 458 458 463 462 466 449 442 466 442 467 461 466 467 467 586 461 461 586 587 461 587 462 462 587 588 462 588 458 586 824 587 824 822 587 587 822 588 467 473 586 473 651 586 586 651 824 467 442 437 437 473 467 472 473 474 474 473 437 473 472 650 473 650 651 651 650 652 651 652 653 651 653 824 737 652 650 737 650 738 738 650 472 472 474 648 738 472 648 765 737 738 765 738 766 766 738 648 736 652 737 764 736 737 764 737 765 230 764 765 230 765 231 231 765 766 766 648 649 231 766 232 232 766 649 230 231 228 228 231 232 228 229 230 229 238 230 238 764 230 763 736 764 238 763 764 229 237 238 237 763 238 236 237 229 228 1114 229 229 1114 1112 229 1112 236 236 235 237 235 762 237 237 762 763 762 735 763 763 735 736 761 734 762 762 734 735 235 761 762 234 235 236 234 243 235 243 761 235 760 733 761 761 733 734 243 760 761 733 658 734 734 658 656 734 656 735 732 660 733 733 660 658 760 732 733 759 732 760 242 759 760 242 760 243 234 242 243 241 240 242 241 242 234 240 759 242 758 731 759 759 731 732 240 758 759 731 662 732 732 662 660 730 664 731 731 664 662 758 730 731 757 730 758 239 757 758 239 758 240 239 240 241 239 241 244 244 757 239 756 729 757 757 729 730 244 756 757 729 666 730 730 666 664 728 668 729 729 668 666 756 728 729 755 728 756 246 755 756 246 756 244 244 241 245 244 245 246 246 245 247 246 247 248 248 755 246 754 727 755 755 727 728 248 754 755 247 251 248 251 754 248 753 726 754 754 726 727 251 753 754 726 671 727 727 671 669 727 669 728 725 673 726 726 673 671 753 725 726 670 669 671 670 671 672 672 671 673 667 668 669 667 669 670 728 669 668 667 670 828 828 670 672 672 673 674 828 672 829 674 829 672 674 673 675 725 675 673 674 675 676 676 829 674 676 830 829 830 841 829 829 841 842 829 842 828 676 675 677 676 677 678 678 830 676 724 677 675 724 675 725 678 677 679 723 679 677 723 677 724 678 679 680 678 680 830 680 679 681 722 681 679 722 679 723 750 722 723 750 723 751 751 723 724 721 681 722 749 721 722 749 722 750 680 681 682 682 681 683 721 683 681 830 680 682 682 683 684 830 682 831 682 684 831 684 683 685 720 685 683 720 683 721 684 685 686 831 684 686 831 686 832 832 839 831 831 839 840 831 840 830 830 840 841 839 850 840 840 850 851 840 851 841 832 838 839 838 849 839 839 849 850 849 806 850 850 806 805 850 805 851 841 851 852 851 805 810 851 810 852 841 852 842 842 852 853 852 810 809 852 809 853 804 809 810 804 810 805 805 806 804 806 815 804 849 815 806 804 815 816 848 816 815 848 815 849 804 816 802 847 802 816 847 816 848 837 847 848 837 848 838 838 848 849 834 836 837 834 837 833 833 837 838 836 847 837 833 838 832 832 690 833 690 692 833 833 692 694 833 694 834 686 688 832 832 688 690 688 689 690 690 689 691 690 691 692 692 691 693 692 693 694 694 693 695 694 695 696 694 696 834 715 695 693 715 693 716 716 693 691 716 691 717 717 691 689 743 715 716 743 716 744 744 716 717 714 695 715 742 714 715 742 715 743 268 742 743 268 743 269 269 743 744 744 717 745 269 744 260 260 744 745 259 268 269 259 269 260 264 267 268 264 268 259 267 742 268 741 714 742 267 741 742 266 267 264 266 741 267 264 265 266 259 1092 264 264 1092 1090 264 1090 265 265 274 266 274 740 266 266 740 741 740 713 741 741 713 714 739 712 740 740 712 713 274 739 740 265 273 274 273 739 274 710 711 739 739 711 712 273 710 739 711 705 712 712 705 706 712 706 713 709 703 711 711 703 705 710 709 711 271 708 710 708 709 710 271 710 273 708 707 709 707 701 709 709 701 703 701 702 703 703 702 704 703 704 705 699 700 701 701 700 702 707 699 701 1065 699 707 1065 707 1066 1066 707 708 873 700 699 873 699 1065 702 700 823 873 872 700 700 872 823 871 872 873 871 873 989 989 873 1065 871 927 872 1002 927 871 1002 871 989 989 987 990 989 990 1002 989 1065 987 1001 927 1002 1002 990 1029 1002 1029 1001 872 927 928 1001 928 927 1000 928 1001 1001 1029 1030 1001 1030 1000 990 1018 1029 1029 1018 1019 1029 1019 1030 987 988 990 990 988 1018 988 1007 1018 1018 1007 1008 1018 1008 1019 1019 1008 1009 1019 1009 1020 1030 1019 1020 1030 1020 1031 1000 1030 1031 1020 1009 1010 1020 1010 1021 1031 1020 1021 1008 993 1009 1009 993 994 1009 994 1010 1007 992 1008 1008 992 993 992 277 993 993 277 276 993 276 994 994 276 287 994 287 995 1010 994 995 275 276 277 275 287 276 277 278 275 992 278 277 991 278 992 1007 991 992 275 278 279 991 279 278 984 279 991 986 984 991 986 991 1007 988 986 1007 985 983 986 983 984 986 985 986 988 983 982 984 982 280 984 984 280 279 275 279 202 202 279 280 202 280 200 982 200 280 200 982 201 201 982 983 201 983 270 270 983 1066 1066 983 985 200 201 202 201 270 202 202 270 271 1066 708 270 270 708 271 1066 985 1065 987 1065 985 987 985 988 202 271 272 272 271 273 272 273 265 265 1088 272 272 1088 1086 272 1086 202 265 1090 1088 1087 1086 1088 1087 1088 1089 1089 1088 1090 1085 1084 1086 1085 1086 1087 202 1086 1084 202 1084 275 1083 1082 1084 1083 1084 1085 275 1084 1082 1087 339 1085 1085 339 337 1085 337 1083 1081 1082 1083 1083 337 335 1083 335 1081 1081 1080 1082 275 1082 282 282 1082 1080 1079 1080 1081 1081 335 333 1081 333 1079 334 333 335 334 335 336 336 335 337 332 331 333 332 333 334 1079 333 331 1077 1078 1079 1079 1078 1080 1079 331 1077 330 329 331 330 331 332 1077 331 329 429 330 332 429 332 427 427 332 334 328 329 330 431 328 330 431 330 429 328 327 329 1077 329 1075 1075 329 327 326 327 328 433 326 328 433 328 431 429 430 431 431 430 432 431 432 433 433 432 434 433 434 379 379 326 433 324 325 326 326 325 327 379 324 326 379 380 381 379 434 380 381 324 379 322 323 324 324 323 325 378 322 324 381 378 324 1073 327 325 1073 325 1071 1071 325 323 1071 323 1069 1069 323 322 1069 1070 1071 1071 1070 1072 1071 1072 1073 1073 1072 1074 1073 1074 1075 1075 327 1073 199 1074 1072 199 1072 308 308 1072 1070 1069 1068 1070 308 1070 306 306 1070 1068 306 307 308 308 307 309 308 309 199 311 312 306 306 312 313 306 313 307 306 1068 311 1067 1068 1069 311 1068 1067 1125 1124 1067 1125 1067 1069 311 1067 316 316 1067 1124 1069 322 1125 1123 1124 1125 1125 322 377 1125 377 1123 1123 1122 1124 316 1124 205 205 1124 1122 1121 1122 1123 1123 377 375 1123 375 1121 376 375 377 376 377 378 378 377 322 374 373 375 374 375 376 1121 375 373 1119 1120 1121 1121 1120 1122 1121 373 1119 372 371 373 372 373 374 1119 373 371 387 372 374 387 374 385 385 374 376 370 371 372 389 370 372 389 372 387 370 369 371 1119 371 1117 1117 371 369 368 369 370 391 368 370 391 370 389 387 388 389 389 388 390 389 390 391 391 390 392 391 392 393 393 368 391 366 367 368 368 367 369 393 366 368 393 392 394 393 394 395 395 366 393 394 392 386 386 392 390 386 390 388 387 386 388 385 384 386 385 386 387 386 396 394 396 386 398 398 386 384 395 394 396 395 396 397 397 396 398 397 364 395 395 364 366 397 398 399 399 362 397 397 362 364 362 363 364 364 363 365 364 365 366 360 361 362 362 361 363 399 360 362 1111 365 363 1111 363 1109 1109 363 361 366 365 367 1113 367 365 1113 365 1111 1109 1110 1111 1111 1110 1112 1111 1112 1113 1107 1108 1109 1109 1108 1110 1109 361 1107 236 1112 1110 236 1110 234 234 1110 1108 1113 1112 1114 1113 1114 1115 1115 367 1113 1115 369 367 1115 1114 1116 1115 1116 1117 1117 369 1115 228 1116 1114 1117 1116 1118 225 1118 1116 225 1116 228 1117 1118 1119 1119 1118 1120 217 1120 1118 217 1118 225 203 1122 1120 203 1120 217 205 1122 203 203 204 205 205 204 206 205 206 207 207 208 205 205 208 209 205 209 210 210 211 205 205 211 212 205 212 213 319 316 205 319 205 320 320 205 213 512 477 212 212 477 213 211 512 212 511 482 512 512 482 477 517 511 512 517 512 211 510 489 511 511 489 482 516 510 511 516 511 517 522 516 517 522 517 210 210 517 211 515 510 516 521 515 516 521 516 522 527 521 522 527 522 209 209 522 210 520 515 521 526 520 521 526 521 527 514 509 515 515 509 510 520 514 515 519 514 520 525 519 520 525 520 526 530 525 526 530 526 531 531 526 527 524 519 525 529 524 525 529 525 530 518 513 519 519 513 514 524 518 519 523 518 524 528 523 524 528 524 529 534 528 529 534 529 535 535 529 530 507 523 528 533 507 528 533 528 534 454 453 523 523 453 518 507 454 523 456 455 507 455 454 507 532 456 507 532 507 533 538 532 533 538 533 539 539 533 534 457 456 532 537 457 532 537 532 538 543 537 538 543 538 544 544 538 539 539 534 540 544 539 545 545 539 540 545 547 544 544 547 548 544 548 543 545 540 506 506 546 545 545 546 547 540 534 535 540 535 541 506 540 541 204 216 506 506 541 204 216 215 506 506 215 546 215 214 546 546 214 551 546 551 547 214 215 203 203 215 216 203 216 204 204 541 206 541 535 536 541 536 206 535 530 536 536 530 531 536 531 207 206 536 207 531 527 208 207 531 208 208 527 209 217 218 203 203 218 219 203 219 214 217 222 218 553 219 218 553 218 560 218 222 560 551 214 219 551 219 553 552 551 553 552 553 555 555 553 560 560 222 221 560 221 561 555 560 565 565 560 561 217 221 222 220 221 217 561 221 220 561 220 562 565 561 566 566 561 562 557 555 565 557 565 570 570 565 566 566 562 567 570 566 571 571 566 567 562 220 227 562 227 563 567 562 563 217 227 220 217 226 227 563 227 226 563 226 564 567 563 568 568 563 564 571 567 572 572 567 568 568 564 569 572 568 573 573 568 569 564 226 224 564 224 569 225 224 226 225 226 217 223 224 225 224 223 646 569 224 646 573 569 574 569 646 574 574 646 647 649 647 646 649 646 233 233 646 223 225 233 223 228 232 225 225 232 233 232 649 233 648 647 649 648 474 647 474 437 441 474 441 647 437 440 441 440 585 441 647 441 585 437 439 440 439 584 440 440 584 585 584 579 585 647 585 579 583 578 584 584 578 579 439 583 584 438 439 437 438 583 439 582 577 583 583 577 578 438 582 583 577 573 578 578 573 574 578 574 579 574 647 579 577 572 573 576 572 577 582 576 577 581 576 582 436 581 582 436 582 438 437 436 438 435 436 437 435 581 436 580 575 581 581 575 576 435 580 581 575 571 576 576 571 572 559 570 575 575 570 571 580 559 575 558 559 580 447 558 580 447 580 435 437 447 435 437 446 447 447 446 550 550 558 447 558 556 559 550 556 558 556 557 559 559 557 570 556 554 557 549 554 556 549 556 550 554 555 557 554 552 555 548 552 554 548 554 549 543 548 549 543 549 542 542 549 550 547 552 548 547 551 552 542 550 444 550 446 445 550 445 444 442 443 444 444 445 442 444 443 542 442 445 446 442 446 437 449 456 442 442 456 457 442 457 443 443 457 537 542 443 537 542 537 543 449 455 456 454 455 449 449 453 454 449 452 453 453 452 518 448 452 449 452 448 513 518 452 513 448 449 450 448 450 508 513 448 508 513 508 514 508 450 501 508 501 509 514 508 509 450 449 451 450 500 501 451 500 450 464 500 451 501 500 502 464 595 500 645 643 500 500 643 502 500 595 645 502 503 501 643 635 502 502 635 503 642 641 643 643 641 635 645 642 643 644 642 645 48 47 642 642 47 641 644 48 642 640 635 641 47 56 641 641 56 55 641 55 640 47 48 49 49 56 47 49 48 50 50 48 644 51 50 644 49 50 44 44 50 51 54 55 49 49 55 56 54 53 55 640 55 53 52 53 54 66 72 54 54 72 73 54 73 52 640 53 639 639 53 52 639 52 638 638 52 73 638 73 616 616 73 72 66 71 72 616 72 71 616 71 617 617 633 616 616 633 634 616 634 638 638 634 637 638 637 639 639 637 636 639 636 640 640 636 635 504 635 636 504 636 505 505 636 637 505 637 495 495 637 634 497 504 505 497 505 495 501 503 504 501 504 497 503 635 504 509 501 497 509 497 510 510 497 489 495 496 497 497 496 498 497 498 489 495 634 496 496 634 498 489 498 499 633 499 498 633 498 634 489 499 490 632 490 499 632 499 633 617 632 633 631 490 632 618 631 632 618 632 617 489 490 491 631 491 490 615 491 631 619 615 631 619 631 618 617 70 618 618 70 69 618 69 619 617 71 70 66 69 70 70 71 66 66 68 69 619 69 68 619 68 620 620 615 619 67 68 66 620 68 67 64 65 66 66 65 67 59 64 66 59 66 195 620 67 621 621 67 65 621 614 620 620 614 615 621 65 622 622 613 621 621 613 614 622 65 64 622 64 623 623 612 622 622 612 613 612 486 613 613 486 494 613 494 614 614 494 493 614 493 615 493 492 615 615 492 491 489 492 493 489 493 482 482 493 494 482 494 486 486 487 482 612 487 486 482 487 488 488 487 612 482 488 480 611 480 488 611 488 612 480 481 482 610 481 480 610 480 611 624 610 611 624 611 623 623 611 612 609 481 610 625 609 610 625 610 624 481 483 482 609 483 481 608 483 609 626 608 609 626 609 625 624 57 625 625 57 63 625 63 626 626 63 62 626 62 627 627 608 626 59 62 63 59 63 57 57 58 59 624 58 57 58 64 59 623 64 58 623 58 624 59 60 61 61 62 59 80 81 59 59 81 82 59 82 60 195 1356 59 59 1356 1357 59 1357 80 629 60 82 629 82 630 630 82 81 628 60 629 630 605 629 629 605 606 629 606 628 630 81 603 603 604 630 630 604 605 604 479 605 605 479 476 605 476 606 606 476 475 606 475 607 628 606 607 475 476 477 479 477 476 478 477 479 604 478 479 603 602 604 602 478 604 321 213 478 478 213 477 602 321 478 482 484 477 477 484 485 477 485 475 607 475 485 607 485 608 485 484 608 482 483 484 608 484 483 627 607 608 627 62 61 627 61 628 628 607 627 628 61 60 320 213 321 602 320 321 602 319 320 602 603 781 785 319 602 602 781 785 314 316 319 785 314 319 784 314 785 785 781 782 785 782 784 77 782 781 77 781 79 79 781 603 79 603 81 78 77 79 78 79 80 80 79 81 76 75 77 76 77 78 75 782 77 80 1358 78 78 1358 1359 78 1359 76 80 1357 1358 1357 1298 1358 1358 1298 1299 1358 1299 1359 1359 1299 1300 1359 1300 1360 76 1359 1360 1298 1144 1299 1299 1144 1143 1299 1143 1300 1297 1145 1298 1298 1145 1144 1357 1297 1298 1356 1297 1357 1296 1169 1297 1297 1169 1145 1356 1296 1297 1128 1144 1145 1145 1169 1128 1143 1144 1128 1128 1168 1143 1300 1143 1168 1128 1167 1168 1300 1168 1301 1301 1168 1167 1142 1167 1128 1301 1167 1302 1302 1167 1142 1360 1300 1301 1360 1301 1361 1361 1301 1302 1302 1142 1303 1361 1302 1362 1362 1302 1303 1128 1141 1142 1303 1142 1141 1303 1141 1304 1362 1303 1363 1363 1303 1304 106 1361 1362 106 1362 104 104 1362 1363 74 1360 1361 74 1361 106 104 105 106 106 105 107 106 107 74 102 103 104 104 103 105 104 1363 102 1363 1304 1364 102 1363 1364 100 101 102 102 101 103 102 1364 100 105 103 787 787 103 101 786 107 105 786 105 787 787 101 789 783 786 787 783 787 788 788 787 789 100 99 101 789 101 99 789 99 790 788 789 791 791 789 790 98 97 99 98 99 100 790 99 97 96 97 98 98 1306 96 100 1305 98 98 1305 1306 96 95 97 97 95 790 94 95 96 96 1306 1307 96 1307 94 1305 1246 1306 1306 1246 1247 1306 1247 1307 1364 1245 1305 1305 1245 1246 100 1364 1305 1245 1175 1246 1246 1175 1185 1246 1185 1247 1247 1185 1184 1247 1184 1248 1307 1247 1248 1182 1184 1185 1182 1185 1175 1183 1184 1182 1248 1184 1183 1248 1183 1249 1307 1248 1308 1308 1248 1249 1249 1183 1182 1175 1181 1182 1249 1182 1250 1250 1182 1181 1308 1249 1309 1309 1249 1250 94 1307 1308 94 1308 92 92 1308 1309 1309 1250 1310 92 1309 90 90 1309 1310 1250 1181 1251 1310 1250 1251 1310 1251 1311 90 1310 88 88 1310 1311 88 89 90 90 89 91 90 91 92 92 91 93 92 93 94 794 93 91 794 91 795 91 89 795 88 87 89 795 89 87 86 87 88 88 1311 86 86 85 87 795 87 797 797 87 85 793 794 795 793 795 796 796 795 797 797 85 798 796 797 799 799 797 798 83 84 85 83 85 86 798 85 84 799 798 800 780 800 798 780 798 111 111 798 84 800 298 799 799 298 305 799 305 796 290 297 298 301 290 298 297 305 298 800 301 298 297 304 305 796 305 304 302 304 297 290 1078 297 297 1078 1076 297 1076 302 302 303 304 796 304 303 198 793 796 198 796 303 198 303 302 199 198 302 302 1076 1074 302 1074 199 1075 1074 1076 1075 1076 1077 1077 1076 1078 290 1080 1078 282 1080 290 281 282 283 283 282 284 281 285 282 282 285 286 282 286 275 290 295 282 282 295 296 282 296 284 1005 283 284 1005 284 1006 1006 284 296 1006 296 981 981 296 295 290 294 295 981 295 294 294 980 981 1015 1006 981 1015 981 1016 1016 981 980 1014 1005 1006 1014 1006 1015 1025 1014 1015 1025 1015 1026 1026 1015 1016 1016 980 1017 1026 1016 1027 1027 1016 1017 1036 1025 1026 1036 1026 1037 1037 1026 1027 1024 1014 1025 1035 1024 1025 1035 1025 1036 1040 1035 1036 1040 1036 1041 1041 1036 1037 1037 1027 1038 1041 1037 1042 1042 1037 1038 1042 921 1041 1041 921 933 1041 933 1040 996 1035 1040 1040 933 932 1040 932 996 910 932 933 910 933 921 919 910 921 1042 919 921 1042 1038 1043 1043 919 1042 919 920 910 1043 920 919 1043 1038 1039 1043 1039 1044 1044 920 1043 920 922 910 1044 922 920 923 922 1044 1045 923 1044 1045 1044 1046 1046 1044 1039 1038 1028 1039 1046 1039 1047 1047 1039 1028 1051 1045 1046 1051 1046 1052 1052 1046 1047 1047 1028 1048 1052 1047 1053 1053 1047 1048 1027 1017 1028 1038 1027 1028 1048 1028 1017 1048 1017 1049 1053 1048 1054 1054 1048 1049 1058 1052 1053 1058 1053 1059 1059 1053 1054 1054 1049 292 1059 1054 291 291 1054 292 1049 1017 980 1049 980 293 292 1049 293 290 291 292 290 292 293 289 291 290 289 1059 291 1064 1058 1059 1064 1059 289 288 289 290 288 1064 289 293 294 290 300 288 290 300 290 301 293 980 294 300 301 800 299 288 300 299 300 801 801 300 800 288 299 898 898 1064 288 898 299 899 960 899 299 960 299 801 801 800 780 975 960 801 975 801 780 959 899 960 974 959 960 974 960 975 898 899 900 959 900 899 957 900 959 973 957 959 973 959 974 126 973 974 126 974 127 127 974 975 127 975 128 128 975 780 126 127 123 123 127 128 123 125 126 125 973 126 972 957 973 125 972 973 123 124 125 124 972 125 971 958 972 972 958 957 124 971 972 122 124 123 122 971 124 970 956 971 971 956 958 122 970 971 903 957 958 903 958 956 955 894 956 956 894 903 970 955 956 969 955 970 114 969 970 114 970 122 114 122 123 113 114 115 114 123 115 113 969 114 968 953 969 969 953 955 113 968 969 113 115 116 116 968 113 967 954 968 968 954 953 116 967 968 115 121 116 121 967 116 966 952 967 967 952 954 121 966 967 888 953 954 888 954 952 951 889 952 952 889 888 966 951 952 965 951 966 120 965 966 120 966 121 115 120 121 119 120 115 119 965 120 964 950 965 965 950 951 119 964 965 950 891 951 951 891 889 888 889 890 889 891 890 890 891 892 950 892 891 949 893 950 893 892 950 964 949 950 890 892 882 882 892 893 882 893 883 949 883 893 948 883 949 963 948 949 963 949 964 882 883 884 948 884 883 947 884 948 962 947 948 962 948 963 117 962 963 117 963 118 118 963 964 961 947 962 138 961 962 138 962 117 117 118 115 115 138 117 115 118 119 118 964 119 133 137 115 115 137 138 115 123 139 115 139 140 140 1201 115 115 1201 1199 115 1199 133 137 961 138 133 136 137 136 944 137 137 944 961 135 136 133 135 944 136 135 943 944 943 945 944 944 945 946 944 946 961 961 946 947 945 887 946 887 886 946 946 886 885 946 885 947 941 881 945 945 881 887 943 941 945 880 886 887 880 887 881 882 885 886 882 886 880 884 885 882 947 885 884 880 1061 882 882 1061 1062 882 1062 890 1060 1055 1061 1061 1055 1056 1061 1056 1062 880 1060 1061 1062 1056 1057 1062 1057 1063 890 1062 1063 1055 1050 1056 1056 1050 1051 1056 1051 1057 917 916 1055 1055 916 1050 1060 917 1055 916 924 1050 1050 924 1045 1050 1045 1051 1057 1051 1052 1057 1052 1058 1063 1057 1058 1063 1058 1064 898 1063 1064 900 901 898 898 901 902 898 902 890 890 1063 898 957 901 900 902 901 957 890 902 903 902 957 903 890 903 894 890 894 895 955 895 894 895 896 890 953 896 895 953 895 955 890 896 897 897 896 953 890 897 888 897 953 888 924 923 1045 915 923 924 915 924 916 910 922 923 910 923 915 907 872 910 915 914 910 910 914 911 910 911 907 872 932 910 867 865 914 914 865 912 914 912 911 915 867 914 866 865 867 866 867 868 868 867 869 869 867 915 864 863 865 864 865 866 865 863 912 866 868 978 864 866 979 979 866 978 774 863 864 774 864 779 779 864 979 979 978 976 779 979 778 778 979 976 978 868 934 978 934 977 976 978 977 40 39 976 976 977 40 778 976 37 37 976 39 37 36 778 778 36 776 778 776 779 36 37 38 38 37 39 38 39 29 29 39 40 29 40 30 40 977 30 29 30 31 31 1193 29 29 1193 1191 29 1191 38 38 43 36 36 43 776 776 43 771 776 771 777 777 771 769 777 769 775 779 776 777 779 777 774 774 777 775 592 774 775 773 774 592 774 773 863 596 773 592 596 821 773 773 821 863 863 821 908 912 863 908 820 821 596 821 820 908 597 820 596 597 819 820 908 820 819 908 819 909 912 908 913 913 908 909 911 912 913 913 909 904 911 913 905 905 913 904 905 906 911 907 911 906 904 862 905 905 862 861 905 861 906 803 802 904 904 802 862 904 909 803 847 861 862 862 802 847 847 860 861 906 861 860 906 860 907 836 859 860 836 860 847 859 907 860 835 836 834 835 859 836 835 823 859 823 907 859 834 698 835 835 698 704 835 704 702 702 823 835 834 696 698 696 697 698 705 704 698 705 698 706 706 698 697 696 695 697 713 706 697 713 697 714 714 697 695 823 872 907 925 926 872 928 929 872 872 929 930 872 930 925 926 931 872 872 931 932 996 926 997 997 926 925 996 931 926 996 932 931 997 1034 996 996 1034 1035 997 925 998 998 1033 997 997 1033 1034 1033 1023 1034 1034 1023 1024 1034 1024 1035 1032 1022 1033 1033 1022 1023 998 1032 1033 998 925 930 998 930 999 999 1032 998 1031 1021 1032 1032 1021 1022 999 1031 1032 1021 1011 1022 1022 1011 1012 1022 1012 1023 1021 1010 1011 1010 995 1011 1011 995 1003 1011 1003 1012 1012 1003 1004 1012 1004 1013 1023 1012 1013 995 285 1003 1003 285 281 1003 281 1004 287 286 995 995 286 285 275 286 287 1004 281 283 1004 283 1005 1013 1004 1005 1013 1005 1014 1024 1013 1014 1023 1013 1024 1000 1031 999 999 929 1000 1000 929 928 999 930 929 802 803 804 804 803 817 817 803 909 601 809 804 804 817 601 601 817 600 600 817 599 599 817 818 817 909 818 818 909 819 599 818 598 598 818 819 598 460 599 599 460 600 600 460 459 600 459 601 458 459 460 589 459 590 590 459 458 459 589 601 590 458 591 591 458 588 591 858 590 858 811 590 590 811 589 601 589 811 601 811 812 858 812 811 822 857 858 822 858 591 857 812 858 591 588 822 824 846 822 846 857 822 846 856 857 856 813 857 857 813 812 812 813 601 601 813 814 856 814 813 845 855 856 845 856 846 855 814 856 825 845 846 825 846 824 824 653 655 824 655 825 655 657 825 825 657 659 825 659 826 826 845 825 826 844 845 844 855 845 659 661 826 826 661 663 826 663 827 827 844 826 657 658 659 659 658 660 659 660 661 661 660 662 661 662 663 663 662 664 663 664 665 663 665 827 665 664 666 665 666 667 827 665 667 666 668 667 827 667 828 828 842 843 828 843 827 842 853 843 827 843 844 843 853 854 843 854 844 853 809 808 853 808 854 844 854 855 854 808 807 854 807 855 807 808 601 601 808 809 601 814 807 855 807 814 657 656 658 655 656 657 655 654 656 735 656 654 653 654 655 653 652 654 735 654 736 736 654 652 598 819 597 1192 1191 1193 1192 1193 1194 1194 21 1192 1192 21 16 1194 1193 1195 31 1195 1193 1194 1195 1196 1196 22 1194 1194 22 21 16 21 2 2 21 22 2 22 23 1196 23 22 1196 1195 1197 1196 1197 1198 1198 23 1196 33 1197 1195 33 1195 31 31 30 32 31 32 33 32 30 977 33 32 34 977 935 32 32 935 34 977 934 935 935 934 936 34 935 937 935 936 937 33 34 35 34 937 35 35 937 938 937 936 939 937 939 938 934 877 936 936 877 878 936 878 939 934 868 877 868 870 877 877 870 874 877 874 878 878 874 876 939 878 876 939 876 940 938 939 940 874 875 876 940 876 875 940 875 941 938 940 942 942 940 941 875 874 879 875 879 941 941 879 881 942 941 943 132 938 942 132 942 134 134 942 943 134 943 135 133 132 134 133 134 135 33 131 132 33 132 133 131 938 132 35 938 131 35 131 33 133 1197 33 133 1199 1197 1198 1197 1199 1198 1199 1200 1200 1199 1201 1200 27 1198 1198 27 23 1200 1201 1202 1202 24 1200 1200 24 27 1202 1201 1203 140 1203 1201 1202 1203 1204 1204 25 1202 1202 25 24 1204 1203 1205 143 1205 1203 143 1203 140 139 141 140 140 141 142 140 142 143 142 144 143 143 144 145 143 145 146 146 1205 143 141 1319 142 142 1319 1320 142 1320 144 139 1318 141 141 1318 1319 1318 1259 1319 1319 1259 1260 1319 1260 1320 1320 1260 1261 1320 1261 1321 144 1320 1321 144 1321 145 1321 1261 1262 1321 1262 1322 145 1321 1322 1260 1164 1261 1261 1164 1163 1261 1163 1262 1259 1165 1260 1260 1165 1164 1163 1164 1134 1134 1164 1165 1134 1172 1163 1262 1163 1172 1262 1172 1263 1322 1262 1263 1134 1171 1172 1263 1172 1171 1263 1171 1264 1322 1263 1323 1323 1263 1264 1162 1171 1134 1264 1171 1162 1264 1162 1265 1323 1264 1324 1324 1264 1265 147 1322 1323 147 1323 148 148 1323 1324 1324 1265 1325 148 1324 150 150 1324 1325 146 147 148 146 148 149 148 150 149 145 147 146 145 1322 147 149 1207 146 146 1207 1205 149 150 151 149 151 152 152 1209 149 149 1209 1207 150 1325 151 151 153 152 151 1325 1326 151 1326 153 152 153 154 153 1326 1327 153 1327 154 1325 1266 1326 1326 1266 1267 1326 1267 1327 1327 1267 1268 1327 1268 1328 154 1327 1328 1266 1160 1267 1267 1160 1159 1267 1159 1268 1265 1161 1266 1266 1161 1160 1325 1265 1266 1159 1160 1134 1134 1160 1161 1134 1158 1159 1268 1159 1158 1268 1158 1269 1328 1268 1269 1134 1157 1158 1269 1158 1157 1128 1134 1141 1134 1161 1162 1134 1165 1166 1166 1177 1134 1134 1177 1178 1134 1178 1175 1304 1141 1134 1304 1134 1245 1245 1134 1175 1265 1162 1161 1173 1174 1175 1173 1175 1176 1175 1178 1179 1175 1179 1176 1174 1180 1175 1175 1180 1181 1253 1174 1173 1253 1173 1254 1254 1173 1176 1252 1180 1174 1252 1174 1253 1251 1181 1180 1251 1180 1252 1311 1251 1252 1311 1252 1312 1312 1252 1253 1312 1253 1313 1313 1253 1254 1254 1176 1255 1313 1254 1314 1314 1254 1255 83 1312 1313 83 1313 112 112 1313 1314 86 1311 1312 86 1312 83 84 83 111 111 83 112 111 112 109 112 1314 109 1314 1255 1315 109 1314 1315 109 110 111 110 109 129 129 109 130 109 1315 130 110 780 111 110 129 780 123 128 129 129 130 123 128 780 129 130 1315 1316 130 1316 123 1315 1255 1256 1315 1256 1316 1316 1256 1257 1316 1257 1317 123 1316 1317 123 1317 139 1317 1257 1258 1317 1258 1318 139 1317 1318 1256 1178 1257 1257 1178 1177 1257 1177 1258 1255 1179 1256 1256 1179 1178 1255 1176 1179 1258 1177 1166 1258 1166 1259 1318 1258 1259 1259 1166 1165 1364 1304 1245 1126 1127 1128 1128 1127 1129 1128 1129 1130 1128 1169 1170 1128 1170 1126 1275 1128 1130 1294 1127 1126 1294 1126 1295 1354 1294 1295 1295 1126 1170 1295 1170 1296 1354 1295 1355 1355 1295 1296 1296 1170 1169 1355 1296 1356 196 1354 1355 196 1355 195 195 1355 1356 1130 1129 1131 1275 1130 1276 1276 1130 1131 1129 1156 1131 1276 1131 1277 1277 1131 1156 1335 1275 1276 1335 1276 1336 1336 1276 1277 1277 1156 1278 1336 1277 1337 1337 1277 1278 1129 1155 1156 1278 1156 1155 1278 1155 1279 1337 1278 1338 1338 1278 1279 168 1336 1337 168 1337 169 169 1337 1338 1338 1279 1339 169 1338 171 171 1338 1339 1279 1155 1140 1279 1140 1280 1339 1279 1280 1140 1155 1129 1129 1139 1140 1280 1140 1139 1280 1139 1281 1339 1280 1340 1340 1280 1281 171 1339 172 172 1339 1340 169 171 170 170 171 172 1281 1139 1138 1129 1138 1139 1206 1205 1207 1206 1207 1208 1208 1207 1209 1204 1205 1206 1208 28 1206 1206 28 26 1206 26 1204 1208 2 28 2 24 28 28 24 26 24 25 26 1204 26 25 2 27 24 23 27 2 879 880 881 879 874 880 874 1060 880 870 918 874 874 918 1060 918 917 1060 917 918 915 915 918 870 868 869 870 915 870 869 916 917 915 197 198 199 199 309 310 199 310 197 310 793 197 197 793 198 309 792 310 310 792 793 307 791 309 309 791 792 791 790 792 792 790 794 792 794 793 307 788 791 313 788 307 313 312 788 788 312 318 788 318 783 311 318 312 311 317 318 783 318 317 783 315 784 783 317 315 784 786 783 316 315 317 316 317 311 314 315 316 784 315 314 784 782 786 782 107 786 75 108 782 782 108 107 74 107 108 74 108 75 74 75 76 76 1360 74 790 93 794 790 95 93 94 93 95 491 492 489 1107 1106 1108 234 1108 241 241 1108 1106 1105 1106 1107 1107 361 359 1107 359 1105 1103 1104 1105 1105 1104 1106 1105 359 357 1105 357 1103 358 357 359 358 359 360 360 359 361 356 355 357 356 357 358 1103 357 355 403 356 358 403 358 401 401 358 360 401 360 399 399 400 401 401 400 402 401 402 403 403 402 404 403 404 405 405 356 403 404 402 434 402 400 434 399 398 400 434 400 398 404 434 406 406 434 432 434 398 380 405 404 406 405 406 407 407 354 405 405 354 356 407 406 408 407 408 409 409 352 407 407 352 354 352 353 354 354 353 355 354 355 356 350 351 352 352 351 353 409 350 352 409 408 410 409 410 411 411 350 409 348 349 350 350 349 351 411 348 350 1099 353 351 1099 351 1097 1097 351 349 348 347 349 1097 349 1095 1095 349 347 346 347 348 413 346 348 413 348 411 346 345 347 1095 347 1093 1093 347 345 1093 1094 1095 1095 1094 1096 1095 1096 1097 1091 1092 1093 1093 1092 1094 1093 345 1091 344 343 345 344 345 346 1091 345 343 1089 1090 1091 1091 1090 1092 1091 343 1089 259 1094 1092 258 259 260 258 1094 259 260 261 258 258 261 262 258 262 253 253 1096 258 258 1096 1094 260 745 261 261 745 746 261 746 262 253 262 263 262 746 747 262 747 263 745 718 746 746 718 719 746 719 747 745 717 718 717 689 718 718 689 687 718 687 719 719 687 685 719 685 720 747 719 720 747 720 748 263 747 748 748 720 721 748 721 749 263 748 254 254 748 749 254 749 255 255 749 750 252 253 254 254 255 252 253 263 254 252 255 256 255 750 256 256 750 751 252 256 249 249 256 257 256 751 257 751 724 752 257 751 752 249 257 250 257 752 250 752 724 725 752 725 753 250 752 753 249 250 247 247 250 251 250 753 251 245 1104 247 247 1104 1102 247 1102 249 241 1106 245 245 1106 1104 1103 1102 1104 1101 1100 1102 1101 1102 1103 249 1102 1100 1103 355 1101 1099 1100 1101 1101 353 1099 1101 355 353 1099 1098 1100 249 1100 252 252 1100 1098 1097 1098 1099 1097 1096 1098 252 1098 253 253 1098 1096 686 685 687 686 687 688 688 687 689 1089 343 341 1089 341 1087 342 341 343 342 343 344 340 339 341 340 341 342 1087 341 339 419 340 342 419 342 417 417 342 344 417 344 415 415 344 346 415 416 417 417 416 418 417 418 419 419 418 420 419 420 421 421 340 419 414 420 418 414 418 416 415 414 416 413 414 415 415 346 413 413 412 414 422 414 424 424 414 412 422 420 414 421 420 422 421 422 423 423 338 421 421 338 340 423 422 424 423 424 425 425 336 423 423 336 338 336 337 338 338 337 339 338 339 340 425 334 336 425 424 426 425 426 427 427 334 425 427 426 428 428 426 406 406 426 424 427 428 429 429 428 430 430 428 406 406 432 430 406 424 408 424 412 410 408 424 410 411 410 412 411 412 413 381 380 382 380 398 382 381 382 383 383 378 381 383 382 384 398 384 382 383 384 385 385 376 383 383 376 378 1152 1153 1151 1288 1152 1151 1287 1153 1152 1287 1152 1288 1347 1287 1288 1365 1366 1367 1370 1369 1365 1370 1365 1371 1371 1365 1367 1365 1369 1420 1365 1420 1366 1368 1369 1370 1371 1821 1370 1370 1821 1822 1370 1822 1368 1367 1820 1371 1371 1820 1821 1820 1649 1821 1649 1647 1821 1821 1647 1657 1821 1657 1822 1822 1657 1656 1822 1656 1823 1368 1822 1823 1646 1656 1657 1646 1657 1647 1646 1647 1648 1648 1647 1649 1655 1656 1646 1646 1903 1655 1648 1902 1646 1646 1902 1903 1655 1654 1656 1823 1656 1654 1653 1654 1655 1655 1903 1904 1655 1904 1653 1902 1827 1903 1903 1827 1828 1903 1828 1904 1977 1826 1902 1902 1826 1827 1648 1977 1902 1826 1534 1827 1827 1534 1533 1827 1533 1828 1828 1533 1516 1828 1516 1829 1904 1828 1829 1516 1533 1514 1514 1533 1534 1514 1534 1535 1826 1535 1534 1901 1535 1826 1977 1901 1826 1535 1553 1514 1901 1553 1535 1900 1553 1901 1976 1900 1901 1976 1901 1977 1514 1553 1554 1900 1554 1553 1899 1554 1900 1975 1899 1900 1975 1900 1976 1665 1975 1976 1665 1976 1650 1650 1976 1977 1974 1899 1975 1658 1974 1975 1658 1975 1665 1650 1664 1665 1665 1664 1666 1665 1666 1658 1658 1659 1660 1658 1666 1667 1658 1667 1659 1660 1974 1658 1818 1667 1666 1818 1666 1819 1666 1664 1819 1650 1663 1664 1819 1664 1663 1819 1663 1820 1377 1818 1819 1377 1819 1367 1367 1819 1820 1817 1667 1818 1376 1817 1818 1376 1818 1377 1817 1659 1667 1816 1661 1817 1661 1659 1817 1375 1816 1817 1375 1817 1376 1372 1375 1376 1372 1376 1366 1366 1376 1377 1366 1377 1367 1420 1372 1366 1372 1373 1374 1374 1375 1372 1420 1373 1372 1374 1816 1375 1373 1383 1374 1383 1815 1374 1374 1815 1816 1373 1382 1383 1382 1814 1383 1383 1814 1815 1814 1676 1815 1676 1674 1815 1815 1674 1673 1815 1673 1816 1812 1677 1814 1814 1677 1676 1382 1812 1814 1675 1674 1676 1675 1676 1668 1668 1676 1677 1662 1673 1674 1662 1674 1675 1661 1673 1662 1816 1673 1661 1660 1661 1662 1675 1972 1662 1662 1972 1973 1662 1973 1660 1668 1971 1675 1675 1971 1972 1971 1896 1972 1972 1896 1897 1972 1897 1973 1973 1897 1898 1973 1898 1974 1660 1973 1974 1660 1659 1661 1974 1898 1899 1897 1557 1898 1898 1557 1555 1898 1555 1899 1896 1487 1897 1897 1487 1557 1487 1514 1557 1557 1514 1555 1514 1554 1555 1899 1555 1554 1514 1515 1516 1514 1528 1515 1487 1556 1514 1842 1528 1514 1842 1514 1843 1843 1514 1556 1829 1516 1515 1829 1515 1830 1904 1829 1905 1905 1829 1830 1830 1515 1552 1830 1552 1831 1905 1830 1906 1906 1830 1831 1653 1904 1905 1653 1905 1645 1645 1905 1906 1906 1831 1907 1645 1906 1643 1643 1906 1907 1831 1552 1551 1831 1551 1832 1907 1831 1832 1515 1551 1552 1515 1550 1551 1832 1551 1550 1832 1550 1833 1907 1832 1908 1908 1832 1833 1643 1907 1640 1640 1907 1908 1908 1833 1909 1640 1908 1638 1638 1908 1909 1833 1550 1549 1833 1549 1834 1909 1833 1834 1549 1550 1515 1515 1548 1549 1834 1549 1548 1834 1548 1835 1909 1834 1910 1910 1834 1835 1638 1909 1635 1635 1909 1910 1910 1835 1911 1635 1910 1633 1633 1910 1911 1835 1548 1547 1835 1547 1836 1911 1835 1836 1515 1547 1548 1546 1547 1515 1836 1547 1546 1836 1546 1837 1911 1836 1912 1912 1836 1837 1633 1911 1630 1630 1911 1912 1912 1837 1913 1630 1912 1628 1628 1912 1913 1837 1546 1545 1837 1545 1838 1913 1837 1838 1515 1545 1546 1515 1544 1545 1838 1545 1544 1838 1544 1839 1913 1838 1914 1914 1838 1839 1628 1913 1625 1625 1913 1914 1914 1839 1915 1625 1914 1623 1623 1914 1915 1839 1544 1530 1839 1530 1840 1915 1839 1840 1530 1544 1515 1515 1529 1530 1840 1530 1529 1840 1529 1841 1915 1840 1916 1916 1840 1841 1623 1915 1620 1620 1915 1916 1916 1841 1917 1620 1916 1618 1618 1916 1917 1841 1529 1528 1841 1528 1842 1917 1841 1842 1515 1528 1529 1917 1842 1918 1918 1842 1843 1618 1917 1615 1615 1917 1918 1615 1617 1618 1618 1617 1619 1618 1619 1620 1613 1614 1615 1614 1616 1615 1615 1616 1617 1615 1918 1613 1918 1843 1919 1613 1918 1919 1843 1556 1844 1919 1843 1844 1919 1844 1920 1613 1919 1610 1610 1919 1920 1610 1612 1613 1613 1612 1614 1616 1614 1760 1760 1614 1612 1759 1617 1616 1759 1616 1760 1760 1612 1761 1460 1759 1760 1460 1760 1461 1461 1760 1761 1610 1611 1612 1761 1612 1611 1761 1611 1762 1461 1761 1458 1458 1761 1762 1457 1460 1461 1457 1461 1458 1459 1460 1457 1459 1468 1460 1468 1759 1460 1456 1455 1457 1456 1457 1458 1432 1459 1457 1457 1455 1432 1458 1762 1456 1454 1455 1456 1456 1762 1763 1456 1763 1454 1454 1451 1455 1432 1455 1451 1449 1451 1454 1454 1763 1764 1454 1764 1449 1762 1607 1763 1763 1607 1606 1763 1606 1764 1764 1606 1604 1764 1604 1602 1602 1766 1764 1449 1764 1766 1449 1450 1451 1449 1766 1450 1602 1765 1766 1450 1766 1765 1594 1601 1602 1594 1602 1603 1603 1602 1604 1601 1765 1602 1603 1604 1605 1604 1606 1605 1605 1606 1607 1605 1607 1608 1608 1921 1605 1605 1921 1922 1605 1922 1603 1603 1922 1923 1603 1923 1594 1921 1846 1922 1922 1846 1847 1922 1847 1923 1920 1845 1921 1921 1845 1846 1608 1920 1921 1845 1523 1846 1846 1523 1522 1846 1522 1847 1847 1522 1496 1847 1496 1848 1923 1847 1848 1496 1522 1487 1487 1522 1523 1487 1523 1524 1845 1524 1523 1844 1524 1845 1920 1844 1845 1610 1920 1608 1608 1609 1610 1609 1611 1610 1608 1607 1609 1611 1609 1762 1762 1609 1607 1844 1556 1524 1524 1556 1487 1482 1484 1487 1487 1484 1488 1487 1488 1489 1489 1490 1487 1487 1490 1491 1487 1491 1492 1493 1494 1487 1487 1494 1495 1487 1495 1496 1492 1512 1487 1487 1512 1513 1487 1513 1493 1896 1482 1487 1848 1496 1495 1848 1495 1849 1849 1495 1494 1923 1848 1924 1924 1848 1849 1849 1494 1850 1924 1849 1925 1925 1849 1850 1594 1923 1924 1594 1924 1595 1595 1924 1925 1925 1850 1926 1595 1925 1598 1598 1925 1926 1850 1494 1493 1850 1493 1851 1926 1850 1851 1926 1851 1927 1598 1926 1587 1587 1926 1927 1587 1597 1598 1598 1597 1599 1598 1599 1595 1585 1586 1587 1586 1596 1587 1587 1596 1597 1587 1927 1585 1768 1599 1597 1768 1597 1596 1595 1599 1600 1600 1599 1768 1593 1594 1595 1595 1600 1593 1765 1593 1600 1765 1600 1767 1767 1600 1768 1593 1601 1594 1601 1593 1765 1450 1765 1452 1452 1765 1767 1452 1767 1453 1453 1767 1768 1451 1450 1452 1451 1452 1446 1446 1452 1453 1446 1453 1447 1453 1768 1447 1446 1447 1443 1432 1451 1446 1446 1443 1432 1443 1447 1448 1447 1768 1770 1447 1770 1448 1596 1770 1768 1596 1769 1770 1448 1770 1769 1443 1448 1444 1448 1769 1444 1443 1444 1438 1432 1443 1438 1438 1444 1445 1444 1769 1771 1444 1771 1445 1438 1439 1440 1438 1445 1439 1432 1438 1433 1433 1438 1440 1445 1771 1772 1445 1772 1439 1769 1592 1771 1771 1592 1772 1592 1591 1772 1772 1591 1589 1772 1589 1588 1588 1774 1772 1439 1772 1774 1583 1591 1592 1583 1592 1584 1769 1584 1592 1590 1589 1591 1590 1591 1583 1577 1588 1589 1577 1589 1590 1583 1929 1590 1590 1929 1930 1590 1930 1577 1575 1576 1577 1576 1588 1577 1577 1930 1931 1577 1931 1575 1929 1854 1930 1930 1854 1855 1930 1855 1931 1931 1855 1856 1931 1856 1932 1575 1931 1932 1854 1491 1855 1855 1491 1490 1855 1490 1856 1853 1492 1854 1854 1492 1491 1929 1853 1854 1852 1512 1853 1853 1512 1492 1928 1852 1853 1928 1853 1929 1583 1928 1929 1927 1852 1928 1585 1927 1928 1585 1928 1583 1851 1513 1852 1852 1513 1512 1927 1851 1852 1851 1493 1513 1583 1584 1585 1585 1584 1586 1586 1584 1769 1586 1769 1596 1856 1490 1489 1856 1489 1857 1932 1856 1857 1857 1489 1488 1857 1488 1858 1932 1857 1933 1933 1857 1858 1575 1932 1573 1573 1932 1933 1933 1858 1934 1573 1933 1580 1580 1933 1934 1858 1488 1484 1858 1484 1859 1934 1858 1859 1934 1859 1935 1580 1934 1567 1567 1934 1935 1567 1579 1580 1580 1579 1581 1580 1581 1573 1565 1566 1567 1566 1578 1567 1567 1578 1579 1567 1935 1565 1581 1579 1776 1776 1579 1578 1573 1581 1582 1775 1582 1581 1775 1581 1776 1776 1578 1777 1434 1775 1776 1434 1776 1435 1435 1776 1777 1777 1578 1566 1777 1566 1778 1435 1777 1436 1436 1777 1778 1434 1435 1432 1432 1435 1436 1432 1433 1434 1433 1442 1434 1442 1775 1434 1440 1441 1433 1433 1441 1442 1441 1773 1442 1442 1773 1775 1440 1439 1441 1439 1774 1441 1441 1774 1773 1588 1773 1774 1576 1773 1588 1576 1574 1773 1773 1574 1582 1773 1582 1775 1575 1574 1576 1573 1574 1575 1573 1582 1574 1432 1436 1427 1427 1474 1432 1474 1472 1432 1432 1472 1470 1432 1470 1464 1464 1466 1432 1432 1466 1459 1427 1436 1437 1436 1778 1437 1427 1437 1428 1437 1778 1779 1437 1779 1428 1566 1564 1778 1778 1564 1572 1778 1572 1779 1779 1572 1571 1779 1571 1780 1428 1779 1780 1563 1571 1572 1563 1572 1564 1563 1564 1565 1565 1564 1566 1570 1571 1563 1565 1936 1563 1563 1936 1937 1563 1937 1570 1570 1569 1571 1571 1569 1780 1562 1569 1570 1570 1937 1938 1570 1938 1562 1936 1861 1937 1937 1861 1862 1937 1862 1938 1938 1862 1863 1938 1863 1939 1562 1938 1939 1861 1539 1862 1862 1539 1543 1862 1543 1863 1860 1527 1861 1861 1527 1539 1936 1860 1861 1859 1511 1860 1860 1511 1527 1935 1859 1860 1935 1860 1936 1565 1935 1936 1859 1484 1511 1484 1510 1511 1511 1510 1527 1484 1509 1510 1527 1510 1536 1871 1536 1510 1871 1510 1872 1872 1510 1509 1508 1509 1484 1872 1509 1873 1873 1509 1508 1947 1871 1872 1947 1872 1948 1948 1872 1873 1870 1536 1871 1946 1870 1871 1946 1871 1947 1733 1946 1947 1733 1947 1730 1730 1947 1948 1948 1873 1949 1730 1948 1728 1728 1948 1949 1728 1729 1730 1729 1731 1730 1730 1731 1732 1730 1732 1733 1725 1727 1728 1728 1727 1729 1728 1949 1725 1731 1729 1791 1791 1729 1727 1790 1732 1731 1790 1731 1791 1733 1732 1734 1789 1734 1732 1789 1732 1790 1418 1789 1790 1418 1790 1419 1419 1790 1791 1791 1727 1792 1419 1791 1410 1410 1791 1792 1409 1418 1419 1409 1419 1410 1414 1417 1418 1414 1418 1409 1417 1789 1418 1408 1409 1410 1409 1373 1414 1409 1408 1373 1410 1411 1408 1410 1792 1411 1408 1411 1412 1408 1412 1403 1373 1408 1403 1411 1792 1793 1411 1793 1412 1403 1412 1413 1412 1793 1794 1412 1794 1413 1402 1403 1404 1403 1413 1404 1373 1403 1402 1413 1794 1795 1413 1795 1404 1793 1722 1794 1794 1722 1721 1794 1721 1795 1721 1719 1795 1795 1719 1717 1795 1717 1796 1404 1795 1796 1404 1405 1402 1404 1796 1405 1796 1717 1716 1796 1716 1797 1405 1796 1797 1715 1716 1717 1715 1717 1718 1718 1717 1719 1718 1719 1720 1719 1721 1720 1720 1721 1722 1720 1722 1723 1723 1951 1720 1720 1951 1952 1720 1952 1718 1718 1952 1953 1718 1953 1715 1951 1876 1952 1952 1876 1877 1952 1877 1953 1950 1875 1951 1951 1875 1876 1723 1950 1951 1875 1506 1876 1876 1506 1505 1876 1505 1877 1877 1505 1521 1877 1521 1878 1953 1877 1878 1505 1506 1484 1484 1521 1505 1484 1506 1507 1875 1507 1506 1874 1507 1875 1950 1874 1875 1484 1507 1508 1874 1508 1507 1873 1508 1874 1949 1873 1874 1949 1874 1950 1725 1949 1950 1723 1724 1725 1724 1726 1725 1725 1726 1727 1725 1950 1723 1723 1722 1724 1726 1724 1793 1793 1724 1722 1792 1727 1726 1792 1726 1793 1482 1483 1484 1484 1483 1485 1484 1485 1486 1486 1497 1484 1484 1497 1498 1484 1498 1499 1499 1500 1484 1484 1500 1501 1484 1501 1502 1484 1503 1504 1502 1517 1484 1484 1517 1518 1484 1518 1519 1504 1520 1484 1484 1520 1521 1519 1531 1484 1484 1531 1532 1484 1532 1503 1883 1531 1519 1883 1519 1884 1884 1519 1518 1882 1532 1531 1882 1531 1883 1881 1503 1532 1881 1532 1882 1957 1881 1882 1957 1882 1958 1958 1882 1883 1958 1883 1959 1959 1883 1884 1705 1957 1958 1705 1958 1703 1703 1958 1959 1956 1881 1957 1708 1956 1957 1708 1957 1705 1703 1704 1705 1704 1706 1705 1705 1706 1707 1705 1707 1708 1700 1702 1703 1703 1702 1704 1703 1959 1700 1706 1704 1801 1801 1704 1702 1800 1707 1706 1800 1706 1801 1708 1707 1709 1799 1709 1707 1799 1707 1800 1398 1799 1800 1398 1800 1399 1399 1800 1801 1801 1702 1802 1399 1801 1400 1400 1801 1802 1398 1399 1396 1396 1399 1400 1396 1397 1398 1397 1407 1398 1407 1799 1398 1396 1400 1391 1373 1397 1396 1373 1396 1391 1391 1400 1401 1400 1802 1401 1390 1391 1392 1391 1401 1392 1391 1390 1373 1401 1802 1803 1401 1803 1392 1392 1393 1390 1392 1803 1805 1392 1805 1393 1390 1393 1394 1390 1394 1385 1373 1390 1385 1393 1805 1804 1393 1804 1394 1697 1804 1805 1697 1805 1803 1696 1804 1697 1696 1688 1804 1804 1688 1695 1804 1695 1806 1394 1804 1806 1385 1394 1395 1394 1806 1395 1806 1695 1807 1395 1806 1807 1690 1694 1695 1690 1695 1688 1695 1694 1807 1688 1689 1690 1688 1696 1689 1689 1696 1697 1689 1697 1698 1698 1961 1689 1689 1961 1962 1689 1962 1690 1693 1694 1690 1690 1962 1963 1690 1963 1693 1693 1692 1694 1807 1694 1692 1682 1692 1693 1693 1963 1964 1693 1964 1682 1962 1887 1963 1963 1887 1888 1963 1888 1964 1961 1886 1962 1962 1886 1887 1886 1502 1887 1887 1502 1501 1887 1501 1888 1888 1501 1500 1888 1500 1889 1964 1888 1889 1964 1889 1965 1682 1964 1965 1889 1500 1499 1889 1499 1890 1965 1889 1890 1965 1890 1966 1682 1965 1680 1680 1965 1966 1890 1499 1498 1890 1498 1891 1966 1890 1891 1966 1891 1967 1680 1966 1678 1678 1966 1967 1678 1679 1680 1680 1679 1681 1680 1681 1682 1681 1691 1682 1682 1691 1692 1681 1808 1691 1681 1679 1808 1678 1687 1679 1808 1679 1687 1691 1808 1809 1808 1687 1810 1387 1809 1808 1387 1808 1388 1388 1808 1810 1807 1692 1691 1691 1809 1807 1386 1807 1809 1386 1809 1387 1386 1387 1384 1384 1387 1388 1384 1388 1379 1379 1388 1389 1388 1810 1389 1810 1687 1811 1389 1810 1811 1379 1389 1380 1389 1811 1380 1378 1379 1380 1378 1384 1379 1384 1385 1386 1373 1384 1378 1373 1385 1384 1380 1381 1378 1378 1381 1382 1378 1382 1373 1380 1811 1813 1380 1813 1381 1381 1813 1812 1381 1812 1382 1683 1812 1813 1683 1813 1811 1671 1812 1683 1671 1669 1812 1812 1669 1677 1671 1683 1672 1672 1683 1684 1811 1684 1683 1670 1669 1671 1670 1671 1672 1668 1669 1670 1668 1677 1669 1672 1969 1670 1670 1969 1970 1670 1970 1668 1668 1970 1971 1969 1894 1970 1970 1894 1895 1970 1895 1971 1968 1893 1969 1969 1893 1894 1672 1968 1969 1893 1485 1894 1894 1485 1483 1894 1483 1895 1895 1483 1482 1895 1482 1896 1971 1895 1896 1893 1486 1485 1892 1486 1893 1968 1892 1893 1892 1497 1486 1891 1497 1892 1967 1891 1892 1967 1892 1968 1891 1498 1497 1685 1967 1968 1685 1968 1672 1678 1967 1685 1672 1684 1685 1685 1684 1686 1685 1686 1678 1678 1686 1687 1687 1686 1811 1811 1686 1684 1414 1373 1415 1415 1373 1420 1402 1397 1373 1414 1415 1416 1416 1417 1414 1420 1424 1415 1415 1424 1425 1415 1425 1416 1425 1787 1416 1416 1787 1788 1416 1788 1417 1417 1788 1789 1787 1737 1788 1788 1737 1736 1788 1736 1789 1736 1734 1789 1734 1736 1735 1735 1736 1737 1735 1737 1738 1738 1737 1739 1787 1739 1737 1733 1734 1735 1738 1945 1735 1735 1945 1946 1735 1946 1733 1738 1739 1740 1740 1944 1738 1738 1944 1945 1739 1741 1740 1741 1739 1787 1740 1741 1742 1740 1742 1743 1743 1943 1740 1740 1943 1944 1943 1868 1944 1944 1868 1869 1944 1869 1945 1942 1867 1943 1943 1867 1868 1743 1942 1943 1743 1742 1744 1743 1744 1745 1745 1942 1743 1941 1866 1942 1942 1866 1867 1745 1941 1942 1866 1538 1867 1867 1538 1537 1867 1537 1868 1865 1540 1866 1866 1540 1538 1941 1865 1866 1940 1865 1941 1558 1940 1941 1558 1941 1745 1864 1541 1865 1865 1541 1540 1940 1864 1865 1539 1538 1540 1540 1541 1539 1539 1541 1542 1864 1542 1541 1863 1542 1864 1939 1863 1864 1939 1864 1940 1560 1939 1940 1560 1940 1558 1562 1939 1560 1558 1559 1560 1560 1559 1561 1560 1561 1562 1561 1568 1562 1562 1568 1569 1781 1568 1561 1781 1561 1782 1561 1559 1782 1558 1747 1559 1782 1559 1747 1782 1747 1783 1430 1781 1782 1430 1782 1431 1431 1782 1783 1558 1746 1747 1783 1747 1746 1745 1746 1558 1745 1744 1746 1783 1746 1784 1784 1746 1744 1431 1783 1422 1422 1783 1784 1421 1430 1431 1421 1431 1422 1420 1421 1422 1422 1423 1420 1422 1784 1423 1784 1744 1785 1423 1784 1785 1785 1744 1742 1785 1742 1786 1423 1785 1424 1424 1785 1786 1420 1423 1424 1369 1479 1420 1420 1479 1474 1420 1474 1421 1368 1477 1369 1369 1477 1478 1369 1478 1479 1479 1478 1480 1479 1480 1474 1477 1824 1478 1478 1824 1825 1478 1825 1480 1368 1823 1477 1477 1823 1824 1823 1654 1824 1824 1654 1652 1824 1652 1825 1825 1652 1651 1825 1651 1748 1480 1825 1748 1474 1480 1481 1480 1748 1481 1748 1642 1749 1748 1651 1644 1748 1644 1642 1481 1748 1749 1644 1651 1645 1645 1651 1652 1645 1652 1653 1653 1652 1654 1643 1644 1645 1643 1642 1644 1640 1641 1642 1640 1642 1643 1749 1642 1641 1638 1639 1640 1639 1641 1640 1749 1641 1750 1641 1639 1750 1638 1637 1639 1750 1639 1637 1635 1637 1638 1635 1636 1637 1750 1637 1751 1751 1637 1636 1475 1749 1750 1475 1750 1476 1476 1750 1751 1751 1636 1752 1476 1751 1473 1473 1751 1752 1634 1636 1635 1636 1634 1752 1633 1634 1635 1633 1632 1634 1752 1634 1632 1752 1632 1753 1473 1752 1471 1471 1752 1753 1471 1472 1473 1472 1476 1473 1472 1475 1476 1471 1470 1472 1474 1475 1472 1469 1470 1471 1471 1753 1469 1469 1464 1470 1462 1464 1469 1469 1753 1754 1469 1754 1462 1462 1463 1464 1464 1463 1465 1464 1465 1466 1462 1754 1755 1462 1755 1463 1463 1755 1756 1463 1756 1465 1466 1465 1467 1465 1756 1757 1465 1757 1467 1466 1467 1459 1459 1467 1468 1467 1757 1758 1467 1758 1468 1756 1622 1757 1757 1622 1621 1757 1621 1758 1621 1619 1758 1758 1619 1617 1758 1617 1759 1468 1758 1759 1619 1621 1620 1620 1621 1622 1620 1622 1623 1623 1622 1624 1756 1624 1622 1623 1624 1625 1624 1626 1625 1626 1624 1756 1755 1626 1756 1625 1626 1627 1755 1627 1626 1625 1627 1628 1628 1627 1629 1754 1629 1627 1754 1627 1755 1628 1629 1630 1629 1631 1630 1631 1629 1754 1753 1631 1754 1630 1631 1632 1753 1632 1631 1630 1632 1633 1474 1481 1475 1481 1749 1475 1426 1474 1427 1421 1474 1426 1426 1427 1428 1428 1429 1426 1426 1429 1430 1426 1430 1421 1428 1780 1429 1429 1780 1781 1429 1781 1430 1780 1569 1568 1780 1568 1781 1424 1786 1425 1786 1742 1741 1786 1741 1787 1425 1786 1787 1863 1543 1542 1539 1542 1543 1527 1538 1539 1525 1526 1527 1527 1536 1525 1526 1537 1527 1527 1537 1538 1869 1526 1525 1869 1525 1870 1870 1525 1536 1868 1537 1526 1868 1526 1869 1945 1869 1870 1945 1870 1946 1402 1406 1397 1397 1406 1407 1402 1405 1406 1405 1797 1406 1406 1797 1798 1406 1798 1407 1407 1798 1799 1797 1712 1798 1798 1712 1711 1798 1711 1799 1716 1714 1797 1797 1714 1712 1710 1711 1712 1710 1712 1713 1713 1712 1714 1709 1711 1710 1711 1709 1799 1708 1709 1710 1713 1955 1710 1710 1955 1956 1710 1956 1708 1713 1714 1715 1715 1954 1713 1713 1954 1955 1714 1716 1715 1715 1953 1954 1953 1878 1954 1954 1878 1879 1954 1879 1955 1955 1879 1880 1955 1880 1956 1956 1880 1881 1879 1504 1880 1880 1504 1503 1880 1503 1881 1878 1520 1879 1879 1520 1504 1878 1521 1520 1385 1395 1386 1395 1807 1386 1886 1517 1502 1885 1517 1886 1961 1885 1886 1885 1518 1517 1884 1518 1885 1960 1884 1885 1960 1885 1961 1698 1960 1961 1959 1884 1960 1700 1959 1960 1700 1960 1698 1698 1697 1699 1698 1699 1700 1699 1701 1700 1700 1701 1702 1803 1701 1699 1803 1699 1697 1802 1702 1701 1802 1701 1803 1820 1663 1649 1649 1663 1650 1648 1649 1650 1650 1977 1648 1978 1979 1980 2052 2053 1978 1978 2053 1979 1980 2084 1978 1978 2084 2052 1980 1979 1981 1980 1981 1982 1982 2082 1980 1980 2082 2084 2082 2083 2084 2084 2083 2085 2084 2085 2086 2086 2052 2084 2080 2081 2082 2082 2081 2083 1982 2080 2082 1979 2085 2083 1979 2083 1981 1981 2083 2081 2086 2085 2087 2053 2087 2085 2053 2085 1979 2086 2087 2088 2050 2052 2086 2086 2088 2050 2088 2087 2089 2051 2089 2087 2051 2087 2053 2088 2089 2090 2050 2088 2090 2090 2089 2091 2049 2091 2089 2049 2089 2051 2050 2049 2051 2050 2051 2052 2052 2051 2053 2048 2049 2050 2050 2090 2048 2090 2091 2092 2048 2090 2092 2092 2091 2093 2047 2093 2091 2047 2091 2049 2048 2047 2049 2046 2047 2048 2048 2092 2046 2092 2093 2094 2046 2092 2094 2094 2093 2095 2045 2095 2093 2045 2093 2047 2046 2045 2047 2044 2045 2046 2046 2094 2044 2094 2095 2096 2044 2094 2096 2096 2095 2097 2043 2097 2095 2043 2095 2045 2044 2043 2045 2042 2043 2044 2044 2096 2042 2096 2097 2098 2042 2096 2098 2098 2097 2099 2041 2099 2097 2041 2097 2043 2042 2041 2043 2040 2041 2042 2042 2098 2040 2098 2099 2100 2040 2098 2100 2100 2099 2101 2039 2101 2099 2039 2099 2041 2040 2039 2041 2038 2039 2040 2040 2100 2038 2100 2101 2102 2038 2100 2102 2102 2101 2103 2037 2103 2101 2037 2101 2039 2038 2037 2039 2036 2037 2038 2038 2102 2036 2102 2103 2104 2036 2102 2104 2104 2103 2105 2035 2105 2103 2035 2103 2037 2036 2035 2037 2034 2035 2036 2036 2104 2034 2104 2105 2106 2034 2104 2106 2106 2105 2107 2033 2107 2105 2033 2105 2035 2034 2033 2035 2032 2033 2034 2034 2106 2032 2106 2107 2108 2032 2106 2108 2108 2107 2109 2031 2109 2107 2031 2107 2033 2032 2031 2033 2030 2031 2032 2032 2108 2030 2108 2109 2110 2030 2108 2110 2110 2109 2111 2029 2111 2109 2029 2109 2031 2030 2029 2031 2028 2029 2030 2030 2110 2028 2110 2111 2112 2028 2110 2112 2112 2111 2113 2027 2113 2111 2027 2111 2029 2028 2027 2029 2026 2027 2028 2028 2112 2026 2112 2113 2114 2026 2112 2114 2114 2113 2115 2025 2115 2113 2025 2113 2027 2026 2025 2027 2024 2025 2026 2026 2114 2024 2114 2115 2116 2024 2114 2116 2116 2115 2117 2023 2117 2115 2023 2115 2025 2024 2023 2025 2022 2023 2024 2024 2116 2022 2116 2117 2118 2022 2116 2118 2118 2117 2119 2021 2119 2117 2021 2117 2023 2022 2021 2023 2020 2021 2022 2022 2118 2020 2118 2119 2120 2020 2118 2120 2120 2119 2121 2019 2121 2119 2019 2119 2021 2020 2019 2021 2018 2019 2020 2020 2120 2018 2120 2121 2122 2018 2120 2122 2122 2121 2123 2017 2123 2121 2017 2121 2019 2018 2017 2019 2016 2017 2018 2018 2122 2016 2122 2123 2124 2016 2122 2124 2124 2123 2125 2015 2125 2123 2015 2123 2017 2016 2015 2017 2014 2015 2016 2016 2124 2014 2124 2125 2126 2014 2124 2126 2126 2125 2127 2013 2125 2015 2013 2127 2125 2014 2013 2015 2012 2013 2014 2014 2126 2012 2126 2127 2128 2012 2126 2128 2128 2127 2129 2011 2129 2127 2011 2127 2013 2012 2011 2013 2010 2011 2012 2012 2128 2010 2128 2129 2054 2010 2128 2054 2054 2129 2055 2009 2055 2129 2009 2129 2011 2010 2009 2011 2008 2009 2010 2010 2054 2008 2054 2055 2056 2008 2054 2056 2056 2055 2057 2007 2057 2055 2007 2055 2009 2008 2007 2009 2006 2007 2008 2008 2056 2006 2056 2057 2058 2006 2056 2058 2058 2057 2059 2005 2059 2057 2005 2057 2007 2006 2005 2007 2004 2005 2006 2006 2058 2004 2058 2059 2060 2004 2058 2060 2060 2059 2061 2003 2061 2059 2003 2059 2005 2004 2003 2005 2002 2003 2004 2004 2060 2002 2060 2061 2062 2002 2060 2062 2062 2061 2063 2001 2063 2061 2001 2061 2003 2002 2001 2003 2000 2001 2002 2002 2062 2000 2062 2063 2064 2000 2062 2064 2064 2063 2065 1999 2065 2063 1999 2063 2001 2000 1999 2001 1998 1999 2000 2000 2064 1998 2064 2065 2066 1998 2064 2066 2066 2065 2067 1997 2067 2065 1997 2065 1999 1998 1997 1999 1996 1997 1998 1998 2066 1996 2066 2067 2068 1996 2066 2068 2068 2067 2069 1995 2069 2067 1995 2067 1997 1996 1995 1997 1994 1995 1996 1996 2068 1994 2068 2069 2070 1994 2068 2070 2070 2069 2071 1993 2071 2069 1993 2069 1995 1994 1993 1995 1992 1993 1994 1994 2070 1992 2070 2071 2072 1992 2070 2072 2072 2071 2073 1991 2073 2071 1991 2071 1993 1992 1991 1993 1990 1991 1992 1992 2072 1990 2072 2073 2074 1990 2072 2074 2074 2073 2075 1989 2075 2073 1989 2073 1991 1990 1989 1991 1988 1989 1990 1990 2074 1988 2074 2075 2076 1988 2074 2076 2076 2075 2077 1987 2077 2075 1987 2075 1989 1988 1987 1989 1986 1987 1988 1988 2076 1986 2076 2077 2078 1986 2076 2078 2078 2077 2079 1985 2079 2077 1985 2077 1987 1986 1985 1987 1984 1985 1986 1986 2078 1984 2078 2079 2080 1984 2078 2080 2080 2079 2081 1983 2081 2079 1983 2079 1985 1984 1983 1985 1982 1983 1984 1984 2080 1982 1982 1981 1983 1981 2081 1983))
                   (list :vertices (let ((mat (make-matrix 2130 3))) (fvector-replace (array-entity mat) #f(-5.4925502777099609e+01 3.4999799728393555e+00 3.6583801269531250e+01 -1.1293700408935547e+02 3.4999799728393555e+00 -3.9729099273681641e+01 -6.3516399383544922e+01 3.4999799728393555e+00 4.2408500671386719e+01 -1.2084799957275391e+02 3.4999799728393555e+00 -3.3009498596191406e+01 -1.2712900543212891e+02 3.4999799728393555e+00 -2.4746500015258789e+01 -4.7787597656250000e+01 3.4999799728393555e+00 2.9048299789428711e+01 -4.2436397552490234e+01 3.4999799728393555e+00 2.0154598236083984e+01 -3.9122200012207031e+01 3.4999799728393555e+00 1.0318599700927734e+01 -3.8000099182128906e+01 3.4999799728393555e+00 0.0000000000000000e+00 -3.9122200012207031e+01 3.4999799728393555e+00 -1.0318599700927734e+01 -4.2436397552490234e+01 3.4999799728393555e+00 -2.0154598236083984e+01 -4.7787597656250000e+01 3.4999799728393555e+00 -2.9048299789428711e+01 -5.4925502777099609e+01 3.4999799728393555e+00 -3.6583801269531250e+01 -6.3516399383544922e+01 3.4999799728393555e+00 -4.2408500671386719e+01 -1.3148699951171875e+02 3.4999799728393555e+00 -1.5326400756835938e+01 -1.3371899414062500e+02 3.4999799728393555e+00 -5.1896600723266602e+00 -1.3371899414062500e+02 3.4999799728393555e+00 5.1896600723266602e+00 -7.3158699035644531e+01 3.4999799728393555e+00 -4.6250400543212891e+01 -8.3401298522949219e+01 3.4999799728393555e+00 -4.7929599761962891e+01 -9.3765602111816406e+01 3.4999799728393555e+00 -4.7367599487304688e+01 -1.0376699829101562e+02 3.4999799728393555e+00 -4.4590801239013672e+01 -1.3148699951171875e+02 3.4999799728393555e+00 1.5326400756835938e+01 -1.2712900543212891e+02 3.4999799728393555e+00 2.4746500015258789e+01 -1.2084799957275391e+02 3.4999799728393555e+00 3.3009498596191406e+01 -1.0376699829101562e+02 3.4999799728393555e+00 4.4590801239013672e+01 -9.3765602111816406e+01 3.4999799728393555e+00 4.7367599487304688e+01 -8.3401298522949219e+01 3.4999799728393555e+00 4.7929599761962891e+01 -1.1293700408935547e+02 3.4999799728393555e+00 3.9729099273681641e+01 -7.3158699035644531e+01 3.4999799728393555e+00 4.6250400543212891e+01 -1.3686401367187500e+02 -5.0000000000000000e-01 1.0811399459838867e+01 -1.3386900329589844e+02 -3.9923801422119141e+00 2.0310501098632812e+01 -1.3350399780273438e+02 -5.0000000000000000e-01 2.1150300979614258e+01 -1.3346000671386719e+02 -4.0236701965332031e+00 2.1128000259399414e+01 -1.2806900024414062e+02 -5.0000000000000000e-01 3.0564800262451172e+01 -1.3093699645996094e+02 -4.2165498733520508e+00 2.6166700363159180e+01 -1.2998899841308594e+02 -4.3504199981689453e+00 2.7730901718139648e+01 -1.3800000000000000e+02 -3.2301499843597412e+00 0.0000000000000000e+00 -1.3799400329589844e+02 -3.2454099655151367e+00 7.9595297574996948e-01 -1.3800000000000000e+02 -5.0000000000000000e-01 0.0000000000000000e+00 -1.3687600708007812e+02 -3.6265201568603516e+00 1.0752799987792969e+01 -1.3685800170898438e+02 -3.6287300586700439e+00 1.0809600830078125e+01 -1.3686401367187500e+02 -5.0000000000000000e-01 -1.0811399459838867e+01 -1.3748100280761719e+02 -3.4953300952911377e+00 -7.3257098197937012e+00 -1.3799400329589844e+02 -3.2454099655151367e+00 -7.9595297574996948e-01 -1.3350399780273438e+02 -5.0000000000000000e-01 -2.1150300979614258e+01 -1.3512100219726562e+02 -3.8680999279022217e+00 -1.7062999725341797e+01 -1.3664900207519531e+02 -3.6267600059509277e+00 -1.0759299278259277e+01 -1.2805700683593750e+02 -5.0111398696899414e+00 -3.0556600570678711e+01 -1.2938700866699219e+02 -4.5015797615051270e+00 -2.8663799285888672e+01 -1.2806900024414062e+02 -5.0000000000000000e-01 -3.0564800262451172e+01 -1.3093699645996094e+02 -4.2165498733520508e+00 -2.6166700363159180e+01 -1.3328799438476562e+02 -4.0207500457763672e+00 -2.1050800323486328e+01 -1.2165799713134766e+02 -9.4509096145629883e+00 -3.7848598480224609e+01 -1.2368000030517578e+02 -7.7003197669982910e+00 -3.5835697174072266e+01 -1.2079499816894531e+02 -5.0000000000000000e-01 -3.8643501281738281e+01 -1.2568299102783203e+02 -6.2691602706909180e+00 -3.3603900909423828e+01 -1.2769000244140625e+02 -5.1518101692199707e+00 -3.1079000473022461e+01 -1.1448500061035156e+02 -2.7640199661254883e+01 -4.3504302978515625e+01 -1.1414600372314453e+02 -2.5701898574829102e+01 -4.3724296569824219e+01 -1.1200000000000000e+02 -5.8000000000000000e+01 -4.5033298492431641e+01 -1.1757899475097656e+02 -3.4237998962402344e+01 -4.1313400268554688e+01 -1.1618900299072266e+02 -3.1981597900390625e+01 -4.2339500427246094e+01 -1.1602400207519531e+02 -3.1669799804687500e+01 -4.2456798553466797e+01 -1.1511199951171875e+02 -2.9646900177001953e+01 -4.3086997985839844e+01 -1.1407099914550781e+02 -2.3813299179077148e+01 -4.3771999359130859e+01 -1.1424700164794922e+02 -2.1949499130249023e+01 -4.3659198760986328e+01 -1.1200000000000000e+02 -5.0000000000000000e-01 -4.5033298492431641e+01 -1.1468000030517578e+02 -2.0041999816894531e+01 -4.3375999450683594e+01 -1.1546099853515625e+02 -1.7912000656127930e+01 -4.2848999023437500e+01 -1.1647299957275391e+02 -1.5917799949645996e+01 -4.2135799407958984e+01 -1.1723500061035156e+02 -1.4680000305175781e+01 -4.1573799133300781e+01 -1.1878400421142578e+02 -1.2558799743652344e+01 -4.0363399505615234e+01 -1.2050099945068359e+02 -1.0602099418640137e+01 -3.8905899047851562e+01 -1.2079199981689453e+02 -1.0312800407409668e+01 -3.8640201568603516e+01 -1.2806900024414062e+02 -5.8000000000000000e+01 -3.0564800262451172e+01 -1.2798400115966797e+02 -4.6020900726318359e+01 -3.0497200012207031e+01 -1.2464399719238281e+02 -5.8000000000000000e+01 -3.4794700622558594e+01 -1.2375000000000000e+02 -4.1379898071289062e+01 -3.5762100219726562e+01 -1.2079499816894531e+02 -5.8000000000000000e+01 -3.8643501281738281e+01 -1.2076599884033203e+02 -3.8109397888183594e+01 -3.8613597869873047e+01 -1.1656499481201172e+02 -5.8000000000000000e+01 -4.2068801879882812e+01 -1.2001699829101562e+02 -3.7287799835205078e+01 -3.9329902648925781e+01 -1.1923799896240234e+02 -3.6400096893310547e+01 -3.9990699768066406e+01 -1.2806900024414062e+02 -5.8000000000000000e+01 3.0564800262451172e+01 -1.2793199920654297e+02 -4.5964199066162109e+01 3.0468700408935547e+01 -1.3087199401855469e+02 -4.9187103271484375e+01 2.6276599884033203e+01 -1.3103300476074219e+02 -5.8000000000000000e+01 2.6000000000000000e+01 -1.3336900329589844e+02 -5.1924198150634766e+01 2.1085699081420898e+01 -1.3350399780273438e+02 -5.8000000000000000e+01 2.1150300979614258e+01 -1.3453799438476562e+02 -5.3205402374267578e+01 1.8655799865722656e+01 -1.3545500183105469e+02 -5.8000000000000000e+01 1.6068899154663086e+01 -1.3684700012207031e+02 -5.5736301422119141e+01 1.0806599617004395e+01 -1.3686401367187500e+02 -5.8000000000000000e+01 1.0811399459838867e+01 -1.3690899658203125e+02 -5.5803600311279297e+01 1.0597800254821777e+01 -1.3771499633789062e+02 -5.8000000000000000e+01 5.4354701042175293e+00 -1.3794801330566406e+02 -5.6943302154541016e+01 2.3187398910522461e+00 -1.3800000000000000e+02 -5.8000000000000000e+01 0.0000000000000000e+00 -1.3786700439453125e+02 -5.6853599548339844e+01 4.7174701467156410e-03 -1.3771499633789062e+02 -5.8000000000000000e+01 -5.4354701042175293e+00 -1.3765499877929688e+02 -5.6621700286865234e+01 -5.9809699058532715e+00 -1.3686401367187500e+02 -5.8000000000000000e+01 -1.0811399459838867e+01 -1.3670599365234375e+02 -5.5582000732421875e+01 -1.0780300140380859e+01 -1.3545500183105469e+02 -5.8000000000000000e+01 -1.6068899154663086e+01 -1.3604701232910156e+02 -5.4858600616455078e+01 -1.4119000434875488e+01 -1.3350399780273438e+02 -5.8000000000000000e+01 -2.1150300979614258e+01 -1.3344700622558594e+02 -5.2009700775146484e+01 -2.1128999710083008e+01 -1.3103300476074219e+02 -5.8000000000000000e+01 -2.6000000000000000e+01 -1.3315499877929688e+02 -5.1688598632812500e+01 -2.1919099807739258e+01 -1.2902900695800781e+02 -4.7166297912597656e+01 -2.9197801589965820e+01 -1.2079499816894531e+02 -5.8000000000000000e+01 3.8643501281738281e+01 -1.2074200439453125e+02 -3.8082397460937500e+01 3.8590801239013672e+01 -1.2598800659179688e+02 -4.3832801818847656e+01 3.3241100311279297e+01 -1.2464399719238281e+02 -5.8000000000000000e+01 3.4794700622558594e+01 -1.1419200134277344e+02 -2.2320400238037109e+01 4.3694400787353516e+01 -1.1406599426269531e+02 -2.4209100723266602e+01 4.3775600433349609e+01 -1.1200000000000000e+02 -5.0000000000000000e-01 4.5033298492431641e+01 -1.1456300354003906e+02 -2.0458801269531250e+01 4.3452697753906250e+01 -1.1958200073242188e+02 -1.1607900619506836e+01 3.9701999664306641e+01 -1.1786299896240234e+02 -1.3767300605773926e+01 4.1094097137451172e+01 -1.1640299987792969e+02 -1.6040500640869141e+01 4.2186302185058594e+01 -1.1620700073242188e+02 -1.6393600463867188e+01 4.2326599121093750e+01 -1.1524099731445312e+02 -1.8433698654174805e+01 4.2999599456787109e+01 -1.1418700408935547e+02 -2.6050899505615234e+01 4.3697597503662109e+01 -1.1200000000000000e+02 -5.8000000000000000e+01 4.5033298492431641e+01 -1.1456400299072266e+02 -2.7952798843383789e+01 4.3452198028564453e+01 -1.1526100158691406e+02 -3.0025100708007812e+01 4.2985698699951172e+01 -1.1620199584960938e+02 -3.2006900787353516e+01 4.2329799652099609e+01 -1.1689200592041016e+02 -3.3192897796630859e+01 4.1829002380371094e+01 -1.1836499786376953e+02 -3.5317100524902344e+01 4.0699798583984375e+01 -1.2001699829101562e+02 -3.7287799835205078e+01 3.9329902648925781e+01 -1.1656499481201172e+02 -5.8000000000000000e+01 4.2068801879882812e+01 -1.2839399719238281e+02 -4.8454399108886719e+00 3.0112499237060547e+01 -1.2805900573730469e+02 -5.0071501731872559e+00 3.0557300567626953e+01 -1.2079499816894531e+02 -5.0000000000000000e-01 3.8643501281738281e+01 -1.2666599273681641e+02 -5.6798996925354004e+00 3.2408100128173828e+01 -1.2463800048828125e+02 -6.9786901473999023e+00 3.4800899505615234e+01 -1.2264499664306641e+02 -8.5566606521606445e+00 3.6893199920654297e+01 -1.2079100036621094e+02 -1.0314400672912598e+01 3.8639698028564453e+01 -1.2063700103759766e+02 -1.0460499763488770e+01 3.8784900665283203e+01 -1.0715000152587891e+02 -5.8000000000000000e+01 4.7504398345947266e+01 -1.0206900024414062e+02 -5.0000000000000000e-01 4.9454902648925781e+01 -1.0206900024414062e+02 -5.8000000000000000e+01 4.9454902648925781e+01 -9.6811401367187500e+01 -5.8000000000000000e+01 5.0863601684570312e+01 -9.1435501098632812e+01 -5.0000000000000000e-01 5.1715099334716797e+01 -9.1435501098632812e+01 -5.8000000000000000e+01 5.1715099334716797e+01 -8.6000000000000000e+01 -5.8000000000000000e+01 5.2000000000000000e+01 -8.0564605712890625e+01 -5.0000000000000000e-01 5.1715099334716797e+01 -8.0564605712890625e+01 -5.8000000000000000e+01 5.1715099334716797e+01 -7.5188598632812500e+01 -5.8000000000000000e+01 5.0863601684570312e+01 -6.9931198120117188e+01 -5.0000000000000000e-01 4.9454902648925781e+01 -6.9931198120117188e+01 -5.8000000000000000e+01 4.9454902648925781e+01 -6.4849693298339844e+01 -5.8000000000000000e+01 4.7504398345947266e+01 -6.0000000000000000e+01 -5.0000000000000000e-01 4.5033298492431641e+01 -6.0000000000000000e+01 -5.8000000000000000e+01 4.5033298492431641e+01 -5.5435199737548828e+01 -5.8000000000000000e+01 4.2068801879882812e+01 -5.1205200195312500e+01 -5.0000000000000000e-01 3.8643501281738281e+01 -5.1205200195312500e+01 -5.8000000000000000e+01 3.8643501281738281e+01 -4.7356502532958984e+01 -5.8000000000000000e+01 3.4794700622558594e+01 -4.3931098937988281e+01 -5.0000000000000000e-01 3.0564800262451172e+01 -4.3931098937988281e+01 -5.8000000000000000e+01 3.0564800262451172e+01 -4.0966701507568359e+01 -5.8000000000000000e+01 2.6000000000000000e+01 -3.8495700836181641e+01 -5.0000000000000000e-01 2.1150300979614258e+01 -3.8495700836181641e+01 -5.8000000000000000e+01 2.1150300979614258e+01 -3.6545101165771484e+01 -5.8000000000000000e+01 1.6068899154663086e+01 -3.5136402130126953e+01 -5.0000000000000000e-01 1.0811399459838867e+01 -3.5136402130126953e+01 -5.8000000000000000e+01 1.0811399459838867e+01 -3.4284900665283203e+01 -5.8000000000000000e+01 5.4354701042175293e+00 -3.4000000000000000e+01 -5.0000000000000000e-01 0.0000000000000000e+00 -3.4000000000000000e+01 -5.8000000000000000e+01 0.0000000000000000e+00 -3.4284900665283203e+01 -5.8000000000000000e+01 -5.4354701042175293e+00 -3.5136402130126953e+01 -5.0000000000000000e-01 -1.0811399459838867e+01 -3.5136402130126953e+01 -5.8000000000000000e+01 -1.0811399459838867e+01 -3.6545101165771484e+01 -5.8000000000000000e+01 -1.6068899154663086e+01 -3.8495700836181641e+01 -5.0000000000000000e-01 -2.1150300979614258e+01 -3.8495700836181641e+01 -5.8000000000000000e+01 -2.1150300979614258e+01 -4.0966701507568359e+01 -5.8000000000000000e+01 -2.6000000000000000e+01 -4.3931098937988281e+01 -5.0000000000000000e-01 -3.0564800262451172e+01 -4.3931098937988281e+01 -5.8000000000000000e+01 -3.0564800262451172e+01 -4.7356502532958984e+01 -5.8000000000000000e+01 -3.4794700622558594e+01 -5.1205200195312500e+01 -5.0000000000000000e-01 -3.8643501281738281e+01 -5.1205200195312500e+01 -5.8000000000000000e+01 -3.8643501281738281e+01 -5.5435199737548828e+01 -5.8000000000000000e+01 -4.2068801879882812e+01 -6.0000000000000000e+01 -5.0000000000000000e-01 -4.5033298492431641e+01 -6.0000000000000000e+01 -5.8000000000000000e+01 -4.5033298492431641e+01 -6.4849693298339844e+01 -5.8000000000000000e+01 -4.7504398345947266e+01 -6.9931198120117188e+01 -5.0000000000000000e-01 -4.9454902648925781e+01 -6.9931198120117188e+01 -5.8000000000000000e+01 -4.9454902648925781e+01 -7.5188598632812500e+01 -5.8000000000000000e+01 -5.0863601684570312e+01 -8.0564605712890625e+01 -5.0000000000000000e-01 -5.1715099334716797e+01 -8.0564605712890625e+01 -5.8000000000000000e+01 -5.1715099334716797e+01 -8.6000000000000000e+01 -5.8000000000000000e+01 -5.2000000000000000e+01 -9.1435501098632812e+01 -5.0000000000000000e-01 -5.1715099334716797e+01 -9.1435501098632812e+01 -5.8000000000000000e+01 -5.1715099334716797e+01 -9.6811401367187500e+01 -5.8000000000000000e+01 -5.0863601684570312e+01 -1.0206900024414062e+02 -5.0000000000000000e-01 -4.9454902648925781e+01 -1.0715000152587891e+02 -5.8000000000000000e+01 -4.7504398345947266e+01 -1.0206900024414062e+02 -5.8000000000000000e+01 -4.9454902648925781e+01 -1.4180400085449219e+02 -5.0908599853515625e+01 1.0597800254821777e+01 -1.4173600769042969e+02 -5.0847198486328125e+01 1.0806599617004395e+01 -2.2050000000000000e+02 -5.0863601684570312e+01 1.0811399459838867e+01 -2.1741400146484375e+02 -7.0116500854492188e+00 5.1525001525878906e+01 -2.1752899169921875e+02 -5.4324898719787598e+00 5.1685798645019531e+01 -2.2050000000000000e+02 -5.4354701042175293e+00 5.1715099334716797e+01 -2.2050000000000000e+02 -2.6000000000000000e+01 -4.5033298492431641e+01 -2.0495700073242188e+02 -2.5997501373291016e+01 -4.5028701782226562e+01 -2.2050000000000000e+02 -3.4794700622558594e+01 -3.8643501281738281e+01 -2.0473500061035156e+02 -2.6170299530029297e+01 -4.4934501647949219e+01 -2.0094599914550781e+02 -2.8523599624633789e+01 -4.3478801727294922e+01 -1.9699099731445312e+02 -3.0465099334716797e+01 -4.2141098022460938e+01 -1.9294700622558594e+02 -3.1996999740600586e+01 -4.0990100860595703e+01 -1.8888400268554688e+02 -3.3113098144531250e+01 -4.0093898773193359e+01 -1.8795100402832031e+02 -3.3310001373291016e+01 -3.9930500030517578e+01 -1.8444999694824219e+02 -3.3842002868652344e+01 -3.9480602264404297e+01 -1.8115100097656250e+02 -3.4017002105712891e+01 -3.9329902648925781e+01 -2.1281999206542969e+02 -1.8456800460815430e+01 -4.8614200592041016e+01 -2.1066200256347656e+02 -2.1058698654174805e+01 -4.7545001983642578e+01 -2.0805999755859375e+02 -2.3578901290893555e+01 -4.6346797943115234e+01 -2.2050000000000000e+02 -1.6068899154663086e+01 -4.9454902648925781e+01 -2.1436401367187500e+02 -1.6065200805664062e+01 -4.9443401336669922e+01 -2.1392199707031250e+02 -1.6846298217773438e+01 -4.9195499420166016e+01 -2.1663400268554688e+02 -1.0967599868774414e+01 -5.0830200195312500e+01 -2.1616299438476562e+02 -1.2368100166320801e+01 -5.0507698059082031e+01 -2.1518998718261719e+02 -1.4600999832153320e+01 -4.9908000946044922e+01 -2.1766799926757812e+02 -3.5138700008392334e+00 -5.1881099700927734e+01 -2.1752899169921875e+02 -5.4324898719787598e+00 -5.1685798645019531e+01 -2.2050000000000000e+02 -5.4354701042175293e+00 -5.1715099334716797e+01 -2.1741400146484375e+02 -7.0116500854492188e+00 -5.1525001525878906e+01 -2.1712300109863281e+02 -8.9947595596313477e+00 -5.1216098785400391e+01 -2.2050000000000000e+02 5.4354701042175293e+00 -5.1715099334716797e+01 -2.2050000000000000e+02 1.6068899154663086e+01 -4.9454902648925781e+01 -2.1775199890136719e+02 1.6068899154663086e+01 -4.9454902648925781e+01 -2.1775199890136719e+02 1.0811399459838867e+01 -5.0863601684570312e+01 -2.1775199890136719e+02 5.4354701042175293e+00 -5.1715099334716797e+01 -2.1775199890136719e+02 0.0000000000000000e+00 -5.2000000000000000e+01 -2.2050000000000000e+02 3.4794700622558594e+01 -3.8643501281738281e+01 -2.1775199890136719e+02 3.0564800262451172e+01 -4.2068801879882812e+01 -2.2050000000000000e+02 2.6000000000000000e+01 -4.5033298492431641e+01 -2.1775199890136719e+02 2.6000000000000000e+01 -4.5033298492431641e+01 -2.1775199890136719e+02 2.1150300979614258e+01 -4.7504398345947266e+01 -2.1775199890136719e+02 4.5033298492431641e+01 -2.6000000000000000e+01 -2.1775199890136719e+02 4.2068801879882812e+01 -3.0564800262451172e+01 -2.2050000000000000e+02 4.2068801879882812e+01 -3.0564800262451172e+01 -2.1775199890136719e+02 3.8643501281738281e+01 -3.4794700622558594e+01 -2.1775199890136719e+02 3.4794700622558594e+01 -3.8643501281738281e+01 -2.1775199890136719e+02 4.7504398345947266e+01 -2.1150300979614258e+01 -2.2050000000000000e+02 4.7504398345947266e+01 -2.1150300979614258e+01 -2.1775199890136719e+02 4.9454902648925781e+01 -1.6068899154663086e+01 -2.2050000000000000e+02 5.0863601684570312e+01 -1.0811399459838867e+01 -2.1775199890136719e+02 5.0863601684570312e+01 -1.0811399459838867e+01 -2.2050000000000000e+02 5.2000000000000000e+01 0.0000000000000000e+00 -2.1775199890136719e+02 5.2000000000000000e+01 0.0000000000000000e+00 -2.1775199890136719e+02 5.1715099334716797e+01 -5.4354701042175293e+00 -2.2050000000000000e+02 5.0863601684570312e+01 1.0811399459838867e+01 -2.2050000000000000e+02 4.7504398345947266e+01 2.1150300979614258e+01 -2.1775199890136719e+02 4.7504398345947266e+01 2.1150300979614258e+01 -2.1775199890136719e+02 4.9454902648925781e+01 1.6068899154663086e+01 -2.1775199890136719e+02 5.0863601684570312e+01 1.0811399459838867e+01 -2.1775199890136719e+02 5.1715099334716797e+01 5.4354701042175293e+00 -2.2050000000000000e+02 4.2068801879882812e+01 3.0564800262451172e+01 -2.2050000000000000e+02 3.4794700622558594e+01 3.8643501281738281e+01 -2.1775199890136719e+02 3.4794700622558594e+01 3.8643501281738281e+01 -2.1775199890136719e+02 3.8643501281738281e+01 3.4794700622558594e+01 -2.1775199890136719e+02 4.2068801879882812e+01 3.0564800262451172e+01 -2.1775199890136719e+02 4.5033298492431641e+01 2.6000000000000000e+01 -2.2050000000000000e+02 2.6000000000000000e+01 4.5033298492431641e+01 -2.2050000000000000e+02 1.6068899154663086e+01 4.9454902648925781e+01 -2.1775199890136719e+02 1.6068899154663086e+01 4.9454902648925781e+01 -2.1775199890136719e+02 2.1150300979614258e+01 4.7504398345947266e+01 -2.1775199890136719e+02 2.6000000000000000e+01 4.5033298492431641e+01 -2.1775199890136719e+02 3.0564800262451172e+01 4.2068801879882812e+01 -2.1766799926757812e+02 -3.5138700008392334e+00 5.1881099700927734e+01 -2.1775199890136719e+02 0.0000000000000000e+00 5.2000000000000000e+01 -2.2050000000000000e+02 5.4354701042175293e+00 5.1715099334716797e+01 -2.1775199890136719e+02 5.4354701042175293e+00 5.1715099334716797e+01 -2.1775199890136719e+02 1.0811399459838867e+01 5.0863601684570312e+01 -2.2050000000000000e+02 -1.6068899154663086e+01 4.9454902648925781e+01 -2.1507099914550781e+02 -1.4836999893188477e+01 4.9838401794433594e+01 -2.1590100097656250e+02 -1.3036600112915039e+01 5.0339302062988281e+01 -2.1663301086425781e+02 -1.0970800399780273e+01 5.0829498291015625e+01 -2.1713800048828125e+02 -8.9188203811645508e+00 5.1229396820068359e+01 -2.1726300048828125e+02 -8.2020797729492188e+00 5.1348999023437500e+01 -2.1002699279785156e+02 -2.1724500656127930e+01 4.7244499206542969e+01 -2.2050000000000000e+02 -2.6000000000000000e+01 4.5033298492431641e+01 -2.0741400146484375e+02 -2.4129899978637695e+01 4.6062397003173828e+01 -2.0570899963378906e+02 -2.5469501495361328e+01 4.5335399627685547e+01 -2.1212699890136719e+02 -1.9358299255371094e+01 4.8262397766113281e+01 -2.1374499511718750e+02 -1.7122798919677734e+01 4.9100002288818359e+01 -2.1435899353027344e+02 -1.6064599990844727e+01 4.9441799163818359e+01 -1.8115100097656250e+02 -3.4017002105712891e+01 3.9329902648925781e+01 -1.8468800354003906e+02 -3.3816596984863281e+01 3.9502300262451172e+01 -2.2050000000000000e+02 -3.4794700622558594e+01 3.8643501281738281e+01 -1.8844400024414062e+02 -3.3208999633789062e+01 4.0014503479003906e+01 -1.9244299316406250e+02 -3.2158100128173828e+01 4.0863903045654297e+01 -1.9449099731445312e+02 -3.1462699890136719e+01 4.1401699066162109e+01 -1.9844500732421875e+02 -2.9805500030517578e+01 4.2610198974609375e+01 -2.0219999694824219e+02 -2.7803798675537109e+01 4.3942600250244141e+01 -2.0492201232910156e+02 -2.5993600845336914e+01 4.5022701263427734e+01 -2.2050000000000000e+02 -4.2068801879882812e+01 3.0564800262451172e+01 -1.3196400451660156e+02 -4.1932300567626953e+01 3.0468700408935547e+01 -1.2328799438476562e+02 -3.4017002105712891e+01 3.9329902648925781e+01 -1.2408200073242188e+02 -3.4741798400878906e+01 3.8590801239013672e+01 -1.2983299255371094e+02 -3.9987800598144531e+01 3.3241100311279297e+01 -2.2050000000000000e+02 -4.7504398345947266e+01 2.1150300979614258e+01 -1.3920498657226562e+02 -4.8538200378417969e+01 1.8655799865722656e+01 -1.3792399597167969e+02 -4.7369400024414062e+01 2.1085699081420898e+01 -1.3518699645996094e+02 -4.4872398376464844e+01 2.6276599884033203e+01 -2.2050000000000000e+02 -5.0863601684570312e+01 -1.0811399459838867e+01 -1.4262199401855469e+02 -5.1654899597167969e+01 -5.9809699058532715e+00 -2.2050000000000000e+02 -5.2000000000000000e+01 0.0000000000000000e+00 -1.4285400390625000e+02 -5.1866500854492188e+01 4.7174701467156410e-03 -1.4294299316406250e+02 -5.1948200225830078e+01 2.3187398910522461e+00 -2.2050000000000000e+02 -4.7504398345947266e+01 -2.1150300979614258e+01 -1.4085899353027344e+02 -5.0046501159667969e+01 -1.4119000434875488e+01 -1.4158200073242188e+02 -5.0706302642822266e+01 -1.0780300140380859e+01 -1.3202099609375000e+02 -4.1983898162841797e+01 -3.0497200012207031e+01 -1.3316600036621094e+02 -4.3028900146484375e+01 -2.9197801589965820e+01 -2.2050000000000000e+02 -4.2068801879882812e+01 -3.0564800262451172e+01 -1.3768899536132812e+02 -4.7154502868652344e+01 -2.1919099807739258e+01 -1.3800999450683594e+02 -4.7447399139404297e+01 -2.1128999710083008e+01 -1.2737999725341797e+02 -3.7750099182128906e+01 -3.5762100219726562e+01 -1.2410900115966797e+02 -3.4766399383544922e+01 -3.8613597869873047e+01 -1.2328799438476562e+02 -3.4017002105712891e+01 -3.9329902648925781e+01 -2.2300000000000000e+02 -4.5487300872802734e+01 -1.5326400756835938e+01 -2.2300000000000000e+02 -4.7718601226806641e+01 -5.1896600723266602e+00 -2.2300000000000000e+02 -4.5500000000000000e+01 0.0000000000000000e+00 -2.2300000000000000e+02 -4.7718601226806641e+01 5.1896600723266602e+00 -2.2300000000000000e+02 -4.4359199523925781e+01 1.0124700546264648e+01 -2.2300000000000000e+02 -4.5487300872802734e+01 1.5326400756835938e+01 -2.2300000000000000e+02 -4.0993999481201172e+01 1.9741699218750000e+01 -2.2300000000000000e+02 -4.1129100799560547e+01 2.4746500015258789e+01 -2.2300000000000000e+02 -3.5573299407958984e+01 2.8368801116943359e+01 -2.2300000000000000e+02 -3.4847698211669922e+01 3.3009498596191406e+01 -2.2300000000000000e+02 -2.8368801116943359e+01 3.5573299407958984e+01 -2.2300000000000000e+02 -2.6936899185180664e+01 3.9729099273681641e+01 -2.2300000000000000e+02 -1.9741699218750000e+01 4.0993999481201172e+01 -2.2300000000000000e+02 -1.7766599655151367e+01 4.4590801239013672e+01 -2.2300000000000000e+02 -1.0124700546264648e+01 4.4359199523925781e+01 -2.2300000000000000e+02 -7.7655301094055176e+00 4.7367599487304688e+01 -2.2300000000000000e+02 0.0000000000000000e+00 4.5500000000000000e+01 -2.2300000000000000e+02 2.5986399650573730e+00 4.7929599761962891e+01 -2.2300000000000000e+02 1.0124700546264648e+01 4.4359199523925781e+01 -2.2300000000000000e+02 1.2841300010681152e+01 4.6250400543212891e+01 -2.2300000000000000e+02 1.9741699218750000e+01 4.0993999481201172e+01 -2.2300000000000000e+02 2.2483600616455078e+01 4.2408500671386719e+01 -2.2300000000000000e+02 2.8368801116943359e+01 3.5573299407958984e+01 -2.2300000000000000e+02 3.1074499130249023e+01 3.6583801269531250e+01 -2.2300000000000000e+02 3.5573299407958984e+01 2.8368801116943359e+01 -2.2300000000000000e+02 3.8212398529052734e+01 2.9048299789428711e+01 -2.2300000000000000e+02 4.0993999481201172e+01 1.9741699218750000e+01 -2.2300000000000000e+02 4.3563602447509766e+01 2.0154598236083984e+01 -2.2300000000000000e+02 4.4359199523925781e+01 1.0124700546264648e+01 -2.2300000000000000e+02 4.6877700805664062e+01 1.0318599700927734e+01 -2.2300000000000000e+02 4.5500000000000000e+01 0.0000000000000000e+00 -2.2300000000000000e+02 4.8000000000000000e+01 0.0000000000000000e+00 -2.2300000000000000e+02 4.4359199523925781e+01 -1.0124700546264648e+01 -2.2300000000000000e+02 4.6877700805664062e+01 -1.0318599700927734e+01 -2.2300000000000000e+02 4.0993999481201172e+01 -1.9741699218750000e+01 -2.2300000000000000e+02 4.3563602447509766e+01 -2.0154598236083984e+01 -2.2300000000000000e+02 3.5573299407958984e+01 -2.8368801116943359e+01 -2.2300000000000000e+02 3.8212398529052734e+01 -2.9048299789428711e+01 -2.2300000000000000e+02 2.8368801116943359e+01 -3.5573299407958984e+01 -2.2300000000000000e+02 3.1074499130249023e+01 -3.6583801269531250e+01 -2.2300000000000000e+02 1.9741699218750000e+01 -4.0993999481201172e+01 -2.2300000000000000e+02 2.2483600616455078e+01 -4.2408500671386719e+01 -2.2300000000000000e+02 1.0124700546264648e+01 -4.4359199523925781e+01 -2.2300000000000000e+02 1.2841300010681152e+01 -4.6250400543212891e+01 -2.2300000000000000e+02 0.0000000000000000e+00 -4.5500000000000000e+01 -2.2300000000000000e+02 2.5986399650573730e+00 -4.7929599761962891e+01 -2.2300000000000000e+02 -1.0124700546264648e+01 -4.4359199523925781e+01 -2.2300000000000000e+02 -7.7655301094055176e+00 -4.7367599487304688e+01 -2.2300000000000000e+02 -1.9741699218750000e+01 -4.0993999481201172e+01 -2.2300000000000000e+02 -1.7766599655151367e+01 -4.4590801239013672e+01 -2.2300000000000000e+02 -2.8368801116943359e+01 -3.5573299407958984e+01 -2.2300000000000000e+02 -2.6936899185180664e+01 -3.9729099273681641e+01 -2.2300000000000000e+02 -3.5573299407958984e+01 -2.8368801116943359e+01 -2.2300000000000000e+02 -3.4847698211669922e+01 -3.3009498596191406e+01 -2.2300000000000000e+02 -4.0993999481201172e+01 -1.9741699218750000e+01 -2.2300000000000000e+02 -4.1129100799560547e+01 -2.4746500015258789e+01 -2.2300000000000000e+02 -4.4359199523925781e+01 -1.0124700546264648e+01 -2.2250000000000000e+02 -4.3871799468994141e+01 1.0013400077819824e+01 -2.2100000000000000e+02 -4.4999900817871094e+01 0.0000000000000000e+00 -2.2250000000000000e+02 -4.4999900817871094e+01 0.0000000000000000e+00 -2.2100000000000000e+02 -4.3871799468994141e+01 -1.0013400077819824e+01 -2.2250000000000000e+02 -4.3871799468994141e+01 -1.0013400077819824e+01 -2.2100000000000000e+02 -4.0543498992919922e+01 -1.9524698257446289e+01 -2.2250000000000000e+02 -4.0543498992919922e+01 -1.9524698257446289e+01 -2.2100000000000000e+02 -3.5182399749755859e+01 -2.8056999206542969e+01 -2.2250000000000000e+02 -3.5182399749755859e+01 -2.8056999206542969e+01 -2.2100000000000000e+02 -2.8056999206542969e+01 -3.5182399749755859e+01 -2.2250000000000000e+02 -2.8056999206542969e+01 -3.5182399749755859e+01 -2.2100000000000000e+02 -1.9524698257446289e+01 -4.0543498992919922e+01 -2.2250000000000000e+02 -1.9524698257446289e+01 -4.0543498992919922e+01 -2.2100000000000000e+02 -1.0013400077819824e+01 -4.3871799468994141e+01 -2.2250000000000000e+02 -1.0013400077819824e+01 -4.3871799468994141e+01 -2.2100000000000000e+02 0.0000000000000000e+00 -4.4999900817871094e+01 -2.2250000000000000e+02 0.0000000000000000e+00 -4.4999900817871094e+01 -2.2100000000000000e+02 1.0013400077819824e+01 -4.3871799468994141e+01 -2.2250000000000000e+02 1.0013400077819824e+01 -4.3871799468994141e+01 -2.2100000000000000e+02 1.9524698257446289e+01 -4.0543498992919922e+01 -2.2250000000000000e+02 1.9524698257446289e+01 -4.0543498992919922e+01 -2.2100000000000000e+02 2.8056999206542969e+01 -3.5182399749755859e+01 -2.2250000000000000e+02 2.8056999206542969e+01 -3.5182399749755859e+01 -2.2100000000000000e+02 3.5182399749755859e+01 -2.8056999206542969e+01 -2.2250000000000000e+02 3.5182399749755859e+01 -2.8056999206542969e+01 -2.2100000000000000e+02 4.0543498992919922e+01 -1.9524698257446289e+01 -2.2250000000000000e+02 4.0543498992919922e+01 -1.9524698257446289e+01 -2.2100000000000000e+02 4.3871799468994141e+01 -1.0013400077819824e+01 -2.2250000000000000e+02 4.3871799468994141e+01 -1.0013400077819824e+01 -2.2100000000000000e+02 4.4999900817871094e+01 0.0000000000000000e+00 -2.2250000000000000e+02 4.4999900817871094e+01 0.0000000000000000e+00 -2.2100000000000000e+02 4.3871799468994141e+01 1.0013400077819824e+01 -2.2250000000000000e+02 4.3871799468994141e+01 1.0013400077819824e+01 -2.2100000000000000e+02 4.0543498992919922e+01 1.9524698257446289e+01 -2.2250000000000000e+02 4.0543498992919922e+01 1.9524698257446289e+01 -2.2100000000000000e+02 3.5182399749755859e+01 2.8056999206542969e+01 -2.2250000000000000e+02 3.5182399749755859e+01 2.8056999206542969e+01 -2.2100000000000000e+02 2.8056999206542969e+01 3.5182399749755859e+01 -2.2250000000000000e+02 2.8056999206542969e+01 3.5182399749755859e+01 -2.2100000000000000e+02 1.9524698257446289e+01 4.0543498992919922e+01 -2.2250000000000000e+02 1.9524698257446289e+01 4.0543498992919922e+01 -2.2100000000000000e+02 1.0013400077819824e+01 4.3871799468994141e+01 -2.2250000000000000e+02 1.0013400077819824e+01 4.3871799468994141e+01 -2.2100000000000000e+02 0.0000000000000000e+00 4.4999900817871094e+01 -2.2250000000000000e+02 0.0000000000000000e+00 4.4999900817871094e+01 -2.2100000000000000e+02 -1.0013400077819824e+01 4.3871799468994141e+01 -2.2250000000000000e+02 -1.0013400077819824e+01 4.3871799468994141e+01 -2.2100000000000000e+02 -1.9524698257446289e+01 4.0543498992919922e+01 -2.2250000000000000e+02 -1.9524698257446289e+01 4.0543498992919922e+01 -2.2100000000000000e+02 -2.8056999206542969e+01 3.5182399749755859e+01 -2.2250000000000000e+02 -2.8056999206542969e+01 3.5182399749755859e+01 -2.2100000000000000e+02 -3.5182399749755859e+01 2.8056999206542969e+01 -2.2250000000000000e+02 -3.5182399749755859e+01 2.8056999206542969e+01 -2.2100000000000000e+02 -4.0543498992919922e+01 1.9524698257446289e+01 -2.2250000000000000e+02 -4.0543498992919922e+01 1.9524698257446289e+01 -2.2100000000000000e+02 -4.3871799468994141e+01 1.0013400077819824e+01 -2.0409600830078125e+02 -6.6742901802062988e+00 -4.5015899658203125e+01 -2.0505799865722656e+02 -6.2974100112915039e+00 -4.5786998748779297e+01 -1.7739700317382812e+02 -3.9620399475097656e+00 -1.7857799530029297e+01 -2.0580400085449219e+02 -5.9177899360656738e+00 -4.6397296905517578e+01 -2.0617199707031250e+02 -5.6773400306701660e+00 -4.6704200744628906e+01 -2.0656199645996094e+02 -5.3357501029968262e+00 -4.7040702819824219e+01 -2.0680799865722656e+02 -4.9890899658203125e+00 -4.7268699645996094e+01 -1.7689498901367188e+02 -6.4255599975585938e+00 -1.8274101257324219e+01 -1.9730700683593750e+02 -8.1760292053222656e+00 -3.9765201568603516e+01 -1.9973699951171875e+02 -7.7708401679992676e+00 -4.1615200042724609e+01 -2.0165798950195312e+02 -7.3669500350952148e+00 -4.3099399566650391e+01 -2.0191999816894531e+02 -7.2976899147033691e+00 -4.3304397583007812e+01 -2.0326800537109375e+02 -6.9414401054382324e+00 -4.4359298706054688e+01 -1.8325000000000000e+02 -9.2269201278686523e+00 -2.9809900283813477e+01 -1.7560400390625000e+02 -8.2491006851196289e+00 -1.9500600814819336e+01 -1.8115100097656250e+02 -9.2135095596313477e+00 -2.8508199691772461e+01 -1.7386099243164062e+02 -8.9589900970458984e+00 -2.1218898773193359e+01 -1.8555299377441406e+02 -9.1820898056030273e+00 -3.1317300796508789e+01 -1.8617799377441406e+02 -9.1607599258422852e+00 -3.1737800598144531e+01 -1.8894499206542969e+02 -9.0233697891235352e+00 -3.3648403167724609e+01 -1.9176399230957031e+02 -8.8140392303466797e+00 -3.5661300659179688e+01 -1.9176899719238281e+02 -8.8135004043579102e+00 -3.5664798736572266e+01 -1.9457299804687500e+02 -8.5322294235229492e+00 -3.7720100402832031e+01 -1.7226100158691406e+02 -3.5703799724578857e+00 -8.8863992691040039e+00 -1.7153898620605469e+02 -3.3447098731994629e+00 -3.7156898975372314e+00 -1.7086898803710938e+02 -5.8431601524353027e+00 -3.6284298896789551e+00 -1.7428900146484375e+02 -3.7798299789428711e+00 -1.3684400558471680e+01 -1.7230500793457031e+02 -3.5839099884033203e+00 -9.1958599090576172e+00 -1.7164500427246094e+02 -6.0687098503112793e+00 -9.2969503402709961e+00 -1.7029299926757812e+02 -8.8017597198486328e+00 -1.6717199325561523e+01 -1.7239500427246094e+02 -8.1020603179931641e+00 -1.5437800407409668e+01 -1.7394700622558594e+02 -6.2771401405334473e+00 -1.4539100646972656e+01 -1.7454199218750000e+02 -3.8048000335693359e+00 -1.4256499290466309e+01 -1.6749600219726562e+02 -8.5808601379394531e+00 -1.0391299247741699e+01 -1.6988700866699219e+02 -7.8955898284912109e+00 -9.7340297698974609e+00 -1.6653900146484375e+02 -8.3416700363159180e+00 -3.5412299633026123e+00 -1.6903900146484375e+02 -7.6721901893615723e+00 -3.5645999908447266e+00 -2.0714601135253906e+02 0.0000000000000000e+00 -4.7606597900390625e+01 -1.7739700317382812e+02 0.0000000000000000e+00 -1.7857799530029297e+01 -2.0706098937988281e+02 -2.5002400875091553e+00 -4.7521999359130859e+01 -1.1891099548339844e+02 -2.9803400039672852e+01 -4.1900600433349609e+01 -1.1909200286865234e+02 -3.0037300109863281e+01 -4.1804100036621094e+01 -1.8115100097656250e+02 -2.9182100296020508e+01 -4.2134799957275391e+01 -1.2243399810791016e+02 -3.3351200103759766e+01 -3.9873203277587891e+01 -1.2061499786376953e+02 -3.1729600906372070e+01 -4.0960597991943359e+01 -1.1677099609375000e+02 -2.3910999298095703e+01 -4.2981899261474609e+01 -1.1685199737548828e+02 -2.5327499389648438e+01 -4.2942600250244141e+01 -1.8115100097656250e+02 -2.3655900955200195e+01 -4.2974700927734375e+01 -1.1722399902343750e+02 -2.6781200408935547e+01 -4.2761699676513672e+01 -1.1791100311279297e+02 -2.8286300659179688e+01 -4.2418701171875000e+01 -1.1849700164794922e+02 -2.9175300598144531e+01 -4.2115100860595703e+01 -1.1743699645996094e+02 -2.1082599639892578e+01 -4.2656299591064453e+01 -1.1696299743652344e+02 -2.2513198852539062e+01 -4.2889099121093750e+01 -1.1680599975585938e+02 -2.3656599044799805e+01 -4.2965000152587891e+01 -1.8115100097656250e+02 -1.8206001281738281e+01 -4.1733100891113281e+01 -1.2193600463867188e+02 -1.5470200538635254e+01 -4.0179599761962891e+01 -1.2023799896240234e+02 -1.7061100006103516e+01 -4.1174697875976562e+01 -1.1940299987792969e+02 -1.7989400863647461e+01 -4.1636600494384766e+01 -1.1923900604248047e+02 -1.8209999084472656e+01 -4.1723098754882812e+01 -1.1829399871826172e+02 -1.9485099792480469e+01 -4.2222999572753906e+01 -1.2730300140380859e+02 -1.1826299667358398e+01 -3.6457298278808594e+01 -1.2508699035644531e+02 -1.3139300346374512e+01 -3.8112098693847656e+01 -1.8115100097656250e+02 -1.3589000701904297e+01 -3.8582500457763672e+01 -1.2441300201416016e+02 -1.3597800254821777e+01 -3.8573699951171875e+01 -1.2381900024414062e+02 -1.4002700805664062e+01 -3.8981300354003906e+01 -1.3525801086425781e+02 -9.2135095596313477e+00 -2.8508199691772461e+01 -1.8115100097656250e+02 -1.0446000099182129e+01 -3.3960201263427734e+01 -1.3355799865722656e+02 -9.4273099899291992e+00 -3.0561100006103516e+01 -1.3169898986816406e+02 -9.9149303436279297e+00 -3.2546699523925781e+01 -1.3021600341796875e+02 -1.0479999542236328e+01 -3.3946300506591797e+01 -1.2949900817871094e+02 -1.0753000259399414e+01 -3.4622501373291016e+01 -2.0617799377441406e+02 -2.1006200790405273e+01 -4.7245498657226562e+01 -1.9168600463867188e+02 -1.1225000381469727e+01 -3.9345302581787109e+01 -1.8304299926757812e+02 -1.0810299873352051e+01 -3.4943401336669922e+01 -1.8301699829101562e+02 -1.4098299980163574e+01 -3.9196800231933594e+01 -1.8317500305175781e+02 -1.8668500900268555e+01 -4.2023700714111328e+01 -1.8349600219726562e+02 -2.3933900833129883e+01 -4.3060897827148438e+01 -1.8393998718261719e+02 -2.9217901229858398e+01 -4.2175300598144531e+01 -1.8526199340820312e+02 -1.1087100028991699e+01 -3.6070102691650391e+01 -1.8528500366210938e+02 -1.4466700553894043e+01 -3.9927700042724609e+01 -1.8561900329589844e+02 -1.8925800323486328e+01 -4.2438999176025391e+01 -1.8622698974609375e+02 -2.3943201065063477e+01 -4.3310600280761719e+01 -1.8703498840332031e+02 -2.8932399749755859e+01 -4.2440498352050781e+01 -1.8588299560546875e+02 -1.1140600204467773e+01 -3.6384502410888672e+01 -1.8592999267578125e+02 -1.4533499717712402e+01 -4.0137298583984375e+01 -1.8631201171875000e+02 -1.8953500747680664e+01 -4.2569499969482422e+01 -1.8698799133300781e+02 -2.3897600173950195e+01 -4.3404098510742188e+01 -1.8787899780273438e+02 -2.8803600311279297e+01 -4.2546398162841797e+01 -1.8871000671386719e+02 -1.1270199775695801e+01 -3.7819000244140625e+01 -1.8889999389648438e+02 -1.4666499137878418e+01 -4.1124401092529297e+01 -1.8949400329589844e+02 -1.8872798919677734e+01 -4.3234100341796875e+01 -1.9043299865722656e+02 -2.3468601226806641e+01 -4.3937297821044922e+01 -1.9162400817871094e+02 -2.7994100570678711e+01 -4.3163501739501953e+01 -1.9206599426269531e+02 -1.4536900520324707e+01 -4.2222702026367188e+01 -1.9287001037597656e+02 -1.8464000701904297e+01 -4.4045299530029297e+01 -1.9402900695800781e+02 -2.2668100357055664e+01 -4.4656196594238281e+01 -1.9544300842285156e+02 -2.6786699295043945e+01 -4.4002700805664062e+01 -1.9471600341796875e+02 -1.0997500419616699e+01 -4.0923698425292969e+01 -1.9531199645996094e+02 -1.4138899803161621e+01 -4.3401000976562500e+01 -1.9631799316406250e+02 -1.7728000640869141e+01 -4.4972000122070312e+01 -1.9766000366210938e+02 -2.1503700256347656e+01 -4.5522499084472656e+01 -1.9924099731445312e+02 -2.5191699981689453e+01 -4.5012397766113281e+01 -1.9770799255371094e+02 -1.0582599639892578e+01 -4.2508502960205078e+01 -1.9852999877929688e+02 -1.3470700263977051e+01 -4.4620597839355469e+01 -1.9972300720214844e+02 -1.6667301177978516e+01 -4.5975101470947266e+01 -2.0121699523925781e+02 -1.9981000900268555e+01 -4.6490798950195312e+01 -2.0292199707031250e+02 -2.3213199615478516e+01 -4.6136901855468750e+01 -2.0039300537109375e+02 -1.0018899917602539e+01 -4.3956897735595703e+01 -2.0142300415039062e+02 -1.2596500396728516e+01 -4.5763298034667969e+01 -2.0277699279785156e+02 -1.5377799987792969e+01 -4.6946498870849609e+01 -2.0438798522949219e+02 -1.8227298736572266e+01 -4.7448699951171875e+01 -2.0873999023437500e+02 -1.8845100402832031e+01 -4.8196701049804688e+01 -2.0689498901367188e+02 -1.6476699829101562e+01 -4.8272598266601562e+01 -2.0520100402832031e+02 -1.4048599243164062e+01 -4.7769599914550781e+01 -2.0372599792480469e+02 -1.1657899856567383e+01 -4.6707897186279297e+01 -2.0252899169921875e+02 -9.4004898071289062e+00 -4.5130100250244141e+01 -2.1087298583984375e+02 -1.6605899810791016e+01 -4.9052799224853516e+01 -2.0899101257324219e+02 -1.4640600204467773e+01 -4.9015296936035156e+01 -2.1196598815917969e+02 -1.5217499732971191e+01 -4.9521202087402344e+01 -2.0723399353027344e+02 -1.2625599861145020e+01 -4.8502899169921875e+01 -2.1006700134277344e+02 -1.3494199752807617e+01 -4.9422000885009766e+01 -2.0566200256347656e+02 -1.0627400398254395e+01 -4.7532398223876953e+01 -2.0828099060058594e+02 -1.1726699829101562e+01 -4.8900699615478516e+01 -2.0432501220703125e+02 -8.7116394042968750e+00 -4.6135997772216797e+01 -2.0666000366210938e+02 -9.9668502807617188e+00 -4.7972599029541016e+01 -2.1322599792480469e+02 -1.3280499458312988e+01 -5.0098400115966797e+01 -2.1419499206542969e+02 -1.1353199958801270e+01 -5.0587699890136719e+01 -2.1466499328613281e+02 -1.0144499778747559e+01 -5.0852500915527344e+01 -2.1515600585937500e+02 -8.4421005249023438e+00 -5.1171798706054688e+01 -2.1546900939941406e+02 -6.7164897918701172e+00 -5.1301399230957031e+01 -2.1130999755859375e+02 -1.1887400627136230e+01 -4.9923198699951172e+01 -2.1226899719238281e+02 -1.0282600402832031e+01 -5.0347896575927734e+01 -2.1273699951171875e+02 -9.2739496231079102e+00 -5.0577598571777344e+01 -2.1322599792480469e+02 -7.8515400886535645e+00 -5.0854198455810547e+01 -2.1352299499511719e+02 -6.4212698936462402e+00 -5.1077701568603516e+01 -2.0949200439453125e+02 -1.0456700325012207e+01 -4.9386699676513672e+01 -2.1042900085449219e+02 -9.1796503067016602e+00 -4.9793601989746094e+01 -2.1088699340820312e+02 -8.3736791610717773e+00 -5.0011001586914062e+01 -2.1136799621582031e+02 -7.2340402603149414e+00 -5.0269001007080078e+01 -2.1171400451660156e+02 -6.0761599540710449e+00 -5.0351398468017578e+01 -2.0781700134277344e+02 -9.0243797302246094e+00 -4.8502300262451172e+01 -2.0871299743652344e+02 -8.0684394836425781e+00 -4.8936901092529297e+01 -2.0915299987792969e+02 -7.4619102478027344e+00 -4.9164398193359375e+01 -2.0961700439453125e+02 -6.6010899543762207e+00 -4.9427200317382812e+01 -2.0990400695800781e+02 -5.7310500144958496e+00 -4.9625099182128906e+01 -2.0525099182128906e+02 -8.2661504745483398e+00 -4.6664901733398438e+01 -2.0632598876953125e+02 -7.6262297630310059e+00 -4.7292301177978516e+01 -2.0716099548339844e+02 -6.9731502532958984e+00 -4.7796497344970703e+01 -2.0757099914550781e+02 -6.5569901466369629e+00 -4.8054500579833984e+01 -2.0800498962402344e+02 -5.9643998146057129e+00 -4.8344398498535156e+01 -2.0835598754882812e+02 -5.3600702285766602e+00 -4.8446899414062500e+01 -1.7490998840332031e+02 0.0000000000000000e+00 -1.4827099800109863e+01 -1.7429399108886719e+02 0.0000000000000000e+00 -1.3675300598144531e+01 -1.7306199645996094e+02 0.0000000000000000e+00 -1.1369299888610840e+01 -1.7153898620605469e+02 0.0000000000000000e+00 -3.7156898975372314e+00 -1.7192300415039062e+02 0.0000000000000000e+00 -7.6175298690795898e+00 -1.7230300903320312e+02 0.0000000000000000e+00 -8.8672008514404297e+00 -1.6653900146484375e+02 -8.2423696517944336e+00 -6.9799000024795532e-01 -1.4299299621582031e+02 -8.2423696517944336e+00 -6.9799000024795532e-01 -1.4243200683593750e+02 -8.4922904968261719e+00 -7.8555903434753418e+00 -1.3984399414062500e+02 -8.8650598526000977e+00 -1.8529100418090820e+01 -1.6845298767089844e+02 -7.8619699478149414e+00 -7.1127301454544067e-01 -1.6899200439453125e+02 -7.5019598007202148e+00 -7.2384500503540039e-01 -1.7007499694824219e+02 -6.7787799835205078e+00 -7.4909901618957520e-01 -1.7079800415039062e+02 -5.6964802742004395e+00 -7.8689402341842651e-01 -1.7115899658203125e+02 -5.1576499938964844e+00 -8.0570995807647705e-01 -1.7153898620605469e+02 -3.2454099655151367e+00 -8.7248700857162476e-01 -1.2203100585937500e+02 -3.4902500152587891e+01 -3.8900798797607422e+01 -1.2090299987792969e+02 -3.6031200408935547e+01 -3.8900798797607422e+01 -1.2122299957275391e+02 -3.4196296691894531e+01 -3.9514400482177734e+01 -1.1949600219726562e+02 -3.2456497192382812e+01 -4.0749900817871094e+01 -1.1804500579833984e+02 -3.0619600296020508e+01 -4.1715099334716797e+01 -1.1787200164794922e+02 -3.0364299774169922e+01 -4.1825698852539062e+01 -1.1691699981689453e+02 -2.8703098297119141e+01 -4.2421501159667969e+01 -1.1625900268554688e+02 -2.7047599792480469e+01 -4.2817100524902344e+01 -1.1590400695800781e+02 -2.5444398880004883e+01 -4.3026100158691406e+01 -1.1582600402832031e+02 -2.3880500793457031e+01 -4.3071399688720703e+01 -1.1601000213623047e+02 -2.2337600708007812e+01 -4.2964202880859375e+01 -1.1646399688720703e+02 -2.0761100769042969e+01 -4.2695499420166016e+01 -1.1728300476074219e+02 -1.9006698608398438e+01 -4.2196300506591797e+01 -1.1834099578857422e+02 -1.7372999191284180e+01 -4.1522998809814453e+01 -1.2138600158691406e+02 -1.1920300483703613e+01 -3.8482402801513672e+01 -1.1966899871826172e+02 -1.3653400421142578e+01 -3.9924701690673828e+01 -1.1811300659179688e+02 -1.5552700042724609e+01 -4.1130500793457031e+01 -1.1734400177001953e+02 -1.6668201446533203e+01 -4.1692802429199219e+01 -1.1632299804687500e+02 -1.8473400115966797e+01 -4.2408500671386719e+01 -1.1553200531005859e+02 -2.0409301757812500e+01 -4.2938796997070312e+01 -1.1509300231933594e+02 -2.2147298812866211e+01 -4.3224201202392578e+01 -1.1491500091552734e+02 -2.3847499847412109e+01 -4.3338100433349609e+01 -1.1499000549316406e+02 -2.5570800781250000e+01 -4.3289901733398438e+01 -1.1533399963378906e+02 -2.7337800979614258e+01 -4.3068000793457031e+01 -1.1597000122070312e+02 -2.9163799285888672e+01 -4.2647800445556641e+01 -1.1689099884033203e+02 -3.0998199462890625e+01 -4.2014698028564453e+01 -1.1705799865722656e+02 -3.1280302047729492e+01 -4.1896999359130859e+01 -1.1845800018310547e+02 -3.3313503265380859e+01 -4.0870498657226562e+01 -1.2012300109863281e+02 -3.5244800567626953e+01 -3.9554801940917969e+01 -1.1913699340820312e+02 -1.6365200042724609e+01 -4.0994300842285156e+01 -1.2075099945068359e+02 -1.4652799606323242e+01 -3.9861499786376953e+01 -1.2253300476074219e+02 -1.3096099853515625e+01 -3.8508499145507812e+01 -1.2372799682617188e+02 -1.2194499969482422e+01 -3.7534797668457031e+01 -1.2987998962402344e+02 -9.0211601257324219e+00 -3.1475700378417969e+01 -1.2784999847412109e+02 -9.7964401245117188e+00 -3.3698303222656250e+01 -1.2580699920654297e+02 -1.0852600097656250e+01 -3.5700500488281250e+01 -1.2253600311279297e+02 -1.0912500381469727e+01 -3.7443199157714844e+01 -1.2453500366210938e+02 -9.4046602249145508e+00 -3.5482299804687500e+01 -1.2649700164794922e+02 -8.2067298889160156e+00 -3.3337100982666016e+01 -1.2844300842285156e+02 -7.3137898445129395e+00 -3.0949499130249023e+01 -1.3006900024414062e+02 -6.8389201164245605e+00 -2.8706998825073242e+01 -1.3157899475097656e+02 -8.6217508316040039e+00 -2.9393701553344727e+01 -1.3154100036621094e+02 -6.6900200843811035e+00 -2.6431900024414062e+01 -1.3311900329589844e+02 -8.5151796340942383e+00 -2.7287200927734375e+01 -2.1378298950195312e+02 -3.2172200679779053e+00 -5.1385898590087891e+01 -2.1016499328613281e+02 -2.8714499473571777e+00 -4.9898899078369141e+01 -2.1025199890136719e+02 0.0000000000000000e+00 -4.9990299224853516e+01 -2.1387001037597656e+02 0.0000000000000000e+00 -5.1488899230957031e+01 -2.0714601135253906e+02 4.9762101173400879e+00 -4.7345798492431641e+01 -1.7739700317382812e+02 3.7055599689483643e+00 -1.7407899856567383e+01 -2.0714601135253906e+02 9.8979501724243164e+00 -4.6566200256347656e+01 -1.7739700317382812e+02 4.2736496925354004e+00 -1.7338899612426758e+01 -2.0714601135253906e+02 1.4711200714111328e+01 -4.5276500701904297e+01 -1.7739700317382812e+02 7.2273001670837402e+00 -1.6218700408935547e+01 -2.0714601135253906e+02 1.9363300323486328e+01 -4.3490802764892578e+01 -1.7739700317382812e+02 8.2989301681518555e+00 -1.5812299728393555e+01 -2.0714601135253906e+02 2.3803298950195312e+01 -4.1228500366210938e+01 -1.7739700317382812e+02 1.0425600051879883e+01 -1.4344500541687012e+01 -2.0714601135253906e+02 2.7982400894165039e+01 -3.8514598846435547e+01 -1.7739700317382812e+02 1.1842000007629395e+01 -1.3366700172424316e+01 -2.0714601135253906e+02 3.1854997634887695e+01 -3.5378601074218750e+01 -1.7739700317382812e+02 1.3173899650573730e+01 -1.1863299369812012e+01 -2.0714601135253906e+02 3.5378601074218750e+01 -3.1854997634887695e+01 -1.7739700317382812e+02 1.4696699142456055e+01 -1.0144400596618652e+01 -2.0714601135253906e+02 3.8514598846435547e+01 -2.7982400894165039e+01 -1.7739700317382812e+02 1.5362799644470215e+01 -8.8751296997070312e+00 -2.0714601135253906e+02 4.1228500366210938e+01 -2.3803298950195312e+01 -2.0714601135253906e+02 4.3490802764892578e+01 -1.9363300323486328e+01 -1.7739700317382812e+02 1.6697299957275391e+01 -6.3324599266052246e+00 -2.0714601135253906e+02 4.5276500701904297e+01 -1.4711200714111328e+01 -1.7739700317382812e+02 1.6902898788452148e+01 -5.4984102249145508e+00 -2.0714601135253906e+02 4.6566200256347656e+01 -9.8979501724243164e+00 -1.7739700317382812e+02 1.7727600097656250e+01 -2.1524999141693115e+00 -2.0714601135253906e+02 4.7345798492431641e+01 -4.9762101173400879e+00 -1.7739700317382812e+02 1.7727600097656250e+01 -1.8666400909423828e+00 -2.0714601135253906e+02 4.7606597900390625e+01 0.0000000000000000e+00 -1.7739700317382812e+02 1.7727600097656250e+01 1.8666400909423828e+00 -2.0714601135253906e+02 4.7345798492431641e+01 4.9762101173400879e+00 -1.7739700317382812e+02 1.7727600097656250e+01 2.1524999141693115e+00 -2.0714601135253906e+02 4.6566200256347656e+01 9.8979501724243164e+00 -1.7739700317382812e+02 1.6902898788452148e+01 5.4984102249145508e+00 -2.0714601135253906e+02 4.5276500701904297e+01 1.4711200714111328e+01 -1.7739700317382812e+02 1.6697299957275391e+01 6.3324599266052246e+00 -2.0714601135253906e+02 4.3490802764892578e+01 1.9363300323486328e+01 -1.7739700317382812e+02 1.5362799644470215e+01 8.8751296997070312e+00 -2.0714601135253906e+02 4.1228500366210938e+01 2.3803298950195312e+01 -1.7739700317382812e+02 1.4696699142456055e+01 1.0144400596618652e+01 -2.0714601135253906e+02 3.8514598846435547e+01 2.7982400894165039e+01 -1.7739700317382812e+02 1.3173899650573730e+01 1.1863299369812012e+01 -2.0714601135253906e+02 3.5378601074218750e+01 3.1854997634887695e+01 -1.7739700317382812e+02 1.1842000007629395e+01 1.3366700172424316e+01 -2.0714601135253906e+02 3.1854997634887695e+01 3.5378601074218750e+01 -1.7739700317382812e+02 1.0425600051879883e+01 1.4344500541687012e+01 -2.0714601135253906e+02 2.7982400894165039e+01 3.8514598846435547e+01 -1.7739700317382812e+02 8.2989301681518555e+00 1.5812299728393555e+01 -2.0714601135253906e+02 2.3803298950195312e+01 4.1228500366210938e+01 -1.7739700317382812e+02 7.2273001670837402e+00 1.6218700408935547e+01 -2.0714601135253906e+02 0.0000000000000000e+00 4.7606597900390625e+01 -1.7739700317382812e+02 0.0000000000000000e+00 1.7857799530029297e+01 -2.0714601135253906e+02 4.9762101173400879e+00 4.7345798492431641e+01 -1.7739700317382812e+02 3.7055599689483643e+00 1.7407899856567383e+01 -2.0714601135253906e+02 9.8979501724243164e+00 4.6566200256347656e+01 -1.7739700317382812e+02 4.2736496925354004e+00 1.7338899612426758e+01 -2.0714601135253906e+02 1.4711200714111328e+01 4.5276500701904297e+01 -2.0714601135253906e+02 1.9363300323486328e+01 4.3490802764892578e+01 -2.1025199890136719e+02 0.0000000000000000e+00 4.9990299224853516e+01 -2.1387001037597656e+02 0.0000000000000000e+00 5.1488899230957031e+01 -2.1025199890136719e+02 5.2253599166870117e+00 4.9716499328613281e+01 -2.1387001037597656e+02 5.3819999694824219e+00 5.1206802368164062e+01 -2.1025199890136719e+02 1.0393500328063965e+01 4.8897899627685547e+01 -2.1025199890136719e+02 1.5447899818420410e+01 4.7543601989746094e+01 -2.1025199890136719e+02 2.0332901000976562e+01 4.5668502807617188e+01 -2.1025199890136719e+02 2.4995100021362305e+01 4.3292900085449219e+01 -2.1025199890136719e+02 2.9383600234985352e+01 4.0443099975585938e+01 -2.1025199890136719e+02 3.3450099945068359e+01 3.7150100708007812e+01 -2.1025199890136719e+02 3.7150100708007812e+01 3.3450099945068359e+01 -2.1025199890136719e+02 4.0443099975585938e+01 2.9383600234985352e+01 -2.1025199890136719e+02 4.3292900085449219e+01 2.4995100021362305e+01 -2.1025199890136719e+02 4.5668502807617188e+01 2.0332901000976562e+01 -2.1025199890136719e+02 4.7543601989746094e+01 1.5447899818420410e+01 -2.1025199890136719e+02 4.8897899627685547e+01 1.0393500328063965e+01 -2.1025199890136719e+02 4.9716499328613281e+01 5.2253599166870117e+00 -2.1025199890136719e+02 4.9990299224853516e+01 0.0000000000000000e+00 -2.1025199890136719e+02 4.9716499328613281e+01 -5.2253599166870117e+00 -2.1025199890136719e+02 4.8897899627685547e+01 -1.0393500328063965e+01 -2.1025199890136719e+02 4.7543601989746094e+01 -1.5447899818420410e+01 -2.1025199890136719e+02 4.5668502807617188e+01 -2.0332901000976562e+01 -2.1025199890136719e+02 4.3292900085449219e+01 -2.4995100021362305e+01 -2.1025199890136719e+02 4.0443099975585938e+01 -2.9383600234985352e+01 -2.1025199890136719e+02 3.7150100708007812e+01 -3.3450099945068359e+01 -2.1025199890136719e+02 3.3450099945068359e+01 -3.7150100708007812e+01 -2.1025199890136719e+02 2.9383600234985352e+01 -4.0443099975585938e+01 -2.1025199890136719e+02 2.4995100021362305e+01 -4.3292900085449219e+01 -2.1025199890136719e+02 2.0332901000976562e+01 -4.5668502807617188e+01 -2.1025199890136719e+02 1.5447899818420410e+01 -4.7543601989746094e+01 -2.1025199890136719e+02 1.0393500328063965e+01 -4.8897899627685547e+01 -2.1025199890136719e+02 5.2253599166870117e+00 -4.9716499328613281e+01 -2.1387001037597656e+02 1.0705100059509277e+01 5.0363700866699219e+01 -2.1387001037597656e+02 1.5910899162292480e+01 4.8968799591064453e+01 -2.1387001037597656e+02 2.0942399978637695e+01 4.7037399291992188e+01 -2.1387001037597656e+02 2.5744400024414062e+01 4.4590599060058594e+01 -2.1387001037597656e+02 3.0264400482177734e+01 4.1655399322509766e+01 -2.1387001037597656e+02 3.4452800750732422e+01 3.8263702392578125e+01 -2.1387001037597656e+02 3.8263702392578125e+01 3.4452800750732422e+01 -2.1387001037597656e+02 4.1655399322509766e+01 3.0264400482177734e+01 -2.1387001037597656e+02 4.4590599060058594e+01 2.5744400024414062e+01 -2.1387001037597656e+02 4.7037399291992188e+01 2.0942399978637695e+01 -2.1387001037597656e+02 4.8968799591064453e+01 1.5910899162292480e+01 -2.1387001037597656e+02 5.0363700866699219e+01 1.0705100059509277e+01 -2.1387001037597656e+02 5.1206802368164062e+01 5.3819999694824219e+00 -2.1387001037597656e+02 5.1488899230957031e+01 0.0000000000000000e+00 -2.1387001037597656e+02 5.1206802368164062e+01 -5.3819999694824219e+00 -2.1387001037597656e+02 5.0363700866699219e+01 -1.0705100059509277e+01 -2.1387001037597656e+02 4.8968799591064453e+01 -1.5910899162292480e+01 -2.1387001037597656e+02 4.7037399291992188e+01 -2.0942399978637695e+01 -2.1387001037597656e+02 4.4590599060058594e+01 -2.5744400024414062e+01 -2.1387001037597656e+02 4.1655399322509766e+01 -3.0264400482177734e+01 -2.1387001037597656e+02 3.8263702392578125e+01 -3.4452800750732422e+01 -2.1387001037597656e+02 3.4452800750732422e+01 -3.8263702392578125e+01 -2.1387001037597656e+02 3.0264400482177734e+01 -4.1655399322509766e+01 -2.1387001037597656e+02 2.5744400024414062e+01 -4.4590599060058594e+01 -2.1387001037597656e+02 2.0942399978637695e+01 -4.7037399291992188e+01 -2.1387001037597656e+02 1.5910899162292480e+01 -4.8968799591064453e+01 -2.1387001037597656e+02 1.0705100059509277e+01 -5.0363700866699219e+01 -2.1387001037597656e+02 5.3819999694824219e+00 -5.1206802368164062e+01 -1.3577200317382812e+02 -6.3501601219177246e+00 -1.7202299118041992e+01 -1.3996299743652344e+02 -7.8146996498107910e+00 -7.5280699729919434e+00 -1.4049400329589844e+02 -7.5719900131225586e+00 -6.8314403295516968e-01 -1.3815299987792969e+02 -5.9867501258850098e+00 -7.3342299461364746e+00 -1.3866500854492188e+02 -5.7430901527404785e+00 -7.1899902820587158e-01 -1.3749800109863281e+02 -8.1766204833984375e+00 -1.7738201141357422e+01 -1.6653900146484375e+02 -8.2423696517944336e+00 6.9799000024795532e-01 -1.4299299621582031e+02 -8.2423696517944336e+00 6.9799000024795532e-01 -1.4300000000000000e+02 -8.2301502227783203e+00 0.0000000000000000e+00 -1.3866999816894531e+02 -5.7301497459411621e+00 0.0000000000000000e+00 -1.4050000000000000e+02 -7.5603098869323730e+00 0.0000000000000000e+00 -1.3866500854492188e+02 -5.7430901527404785e+00 7.1899902820587158e-01 -1.4049400329589844e+02 -7.5719900131225586e+00 6.8314403295516968e-01 -1.2090299987792969e+02 -3.6031200408935547e+01 3.8900798797607422e+01 -1.2466699981689453e+02 -3.9931098937988281e+01 -3.5258300781250000e+01 -1.2993901062011719e+02 -4.5401802062988281e+01 -2.8618099212646484e+01 -1.3562600708007812e+02 -4.8000400543212891e+01 -2.1353799819946289e+01 -1.3140200805664062e+02 -4.3939197540283203e+01 -2.8618099212646484e+01 -1.2593099212646484e+02 -3.8667297363281250e+01 -3.5258300781250000e+01 -1.3400000000000000e+02 -4.9626399993896484e+01 -2.1353799819946289e+01 -1.3680400085449219e+02 -5.2549499511718750e+01 -1.3681099891662598e+01 -1.3855000305175781e+02 -5.0803501129150391e+01 -1.3681099891662598e+01 -1.3834199523925781e+02 -5.4157100677490234e+01 -5.7751498222351074e+00 -1.3862100219726562e+02 -5.4448600769042969e+01 2.2374401092529297e+00 -1.4015699768066406e+02 -5.2342002868652344e+01 -5.7751498222351074e+00 -1.4044900512695312e+02 -5.2620800018310547e+01 2.2374401092529297e+00 -1.3941299438476562e+02 -5.1630199432373047e+01 1.0250300407409668e+01 -1.3763000488281250e+02 -5.3412998199462891e+01 1.0250300407409668e+01 -1.3534700012207031e+02 -5.1029701232910156e+01 1.8130399703979492e+01 -1.3702999877929688e+02 -4.9346900939941406e+01 1.8130399703979492e+01 -1.3176199340820312e+02 -4.7296298980712891e+01 2.5690099716186523e+01 -1.2691100311279297e+02 -4.2257396697998047e+01 3.2698600769042969e+01 -1.3329600524902344e+02 -4.5761600494384766e+01 2.5690099716186523e+01 -1.2825700378417969e+02 -4.0910602569580078e+01 3.2698600769042969e+01 -1.2203100585937500e+02 -3.4902500152587891e+01 3.8900798797607422e+01 -1.7153898620605469e+02 0.0000000000000000e+00 3.7156898975372314e+00 -1.7153898620605469e+02 -3.3447098731994629e+00 3.7156898975372314e+00 -1.7153898620605469e+02 -3.2454099655151367e+00 8.7248700857162476e-01 -1.7153898620605469e+02 3.0579600334167480e+00 2.1107199192047119e+00 -1.7153898620605469e+02 2.4639401435852051e+00 2.7812099456787109e+00 -1.7153898620605469e+02 3.4742300510406494e+00 -1.3175599575042725e+00 -1.7153898620605469e+02 3.6886298656463623e+00 -4.4788199663162231e-01 -1.7153898620605469e+02 3.6886298656463623e+00 4.4788199663162231e-01 -1.7153898620605469e+02 3.4742300510406494e+00 1.3175599575042725e+00 -1.7153898620605469e+02 8.8923197984695435e-01 -3.6077499389648438e+00 -1.7153898620605469e+02 1.7267500162124634e+00 -3.2900600433349609e+00 -1.7153898620605469e+02 2.4639401435852051e+00 -2.7812099456787109e+00 -1.7153898620605469e+02 3.0579600334167480e+00 -2.1107199192047119e+00 -1.7153898620605469e+02 1.7267500162124634e+00 3.2900600433349609e+00 -1.7153898620605469e+02 8.8923197984695435e-01 3.6077499389648438e+00 -1.7115899658203125e+02 -5.1576499938964844e+00 8.0570995807647705e-01 -1.7079800415039062e+02 -5.6964802742004395e+00 7.8689402341842651e-01 -1.7007499694824219e+02 -6.7787799835205078e+00 7.4909901618957520e-01 -1.6899200439453125e+02 -7.5019598007202148e+00 7.2384500503540039e-01 -1.6845298767089844e+02 -7.8619699478149414e+00 7.1127301454544067e-01 -1.7306199645996094e+02 2.7208299636840820e+00 -1.1038999557495117e+01 -1.7490998840332031e+02 0.0000000000000000e+00 1.4827099800109863e+01 -1.7490998840332031e+02 3.5483198165893555e+00 -1.4396299362182617e+01 -1.7490998840332031e+02 6.8904700279235840e+00 -1.3128800392150879e+01 -1.7490998840332031e+02 9.8322000503540039e+00 -1.1098299980163574e+01 -1.7490998840332031e+02 1.2202400207519531e+01 -8.4227294921875000e+00 -1.7490998840332031e+02 1.3863599777221680e+01 -5.2577199935913086e+00 -1.7490998840332031e+02 1.4718999862670898e+01 -1.7871799468994141e+00 -1.7490998840332031e+02 1.4718999862670898e+01 1.7871799468994141e+00 -1.7490998840332031e+02 1.3863599777221680e+01 5.2577199935913086e+00 -1.7490998840332031e+02 1.2202400207519531e+01 8.4227294921875000e+00 -1.7490998840332031e+02 9.8322000503540039e+00 1.1098299980163574e+01 -1.7490998840332031e+02 6.8904700279235840e+00 1.3128800392150879e+01 -1.7490998840332031e+02 3.5483198165893555e+00 1.4396299362182617e+01 -1.7306199645996094e+02 2.7208299636840820e+00 1.1038999557495117e+01 -1.7306199645996094e+02 5.2835898399353027e+00 1.0067099571228027e+01 -1.7306199645996094e+02 7.5392699241638184e+00 8.5101099014282227e+00 -1.7306199645996094e+02 9.3567991256713867e+00 6.4585199356079102e+00 -1.7306199645996094e+02 1.0630499839782715e+01 4.0315999984741211e+00 -1.7306199645996094e+02 1.1286499977111816e+01 1.3703700304031372e+00 -1.7306199645996094e+02 1.1286499977111816e+01 -1.3703700304031372e+00 -1.7306199645996094e+02 1.0630499839782715e+01 -4.0315999984741211e+00 -1.7306199645996094e+02 9.3567991256713867e+00 -6.4585199356079102e+00 -1.7306199645996094e+02 7.5392699241638184e+00 -8.5101099014282227e+00 -1.7306199645996094e+02 5.2835898399353027e+00 -1.0067099571228027e+01 -1.7192300415039062e+02 1.8229500055313110e+00 7.3961601257324219e+00 -1.7192300415039062e+02 3.5400400161743164e+00 6.7449798583984375e+00 -1.7192300415039062e+02 5.0513100624084473e+00 5.7017798423767090e+00 -1.7192300415039062e+02 6.2691001892089844e+00 4.3272399902343750e+00 -1.7192300415039062e+02 7.1225199699401855e+00 2.7011599540710449e+00 -1.7192300415039062e+02 7.5619797706604004e+00 9.1819196939468384e-01 -1.7192300415039062e+02 7.5619797706604004e+00 -9.1819196939468384e-01 -1.7192300415039062e+02 7.1225199699401855e+00 -2.7011599540710449e+00 -1.7192300415039062e+02 6.2691001892089844e+00 -4.3272399902343750e+00 -1.7192300415039062e+02 5.0513100624084473e+00 -5.7017798423767090e+00 -1.7192300415039062e+02 3.5400400161743164e+00 -6.7449798583984375e+00 -1.7192300415039062e+02 1.8229500055313110e+00 -7.3961601257324219e+00 -1.7429399108886719e+02 0.0000000000000000e+00 1.3675300598144531e+01 -1.7306199645996094e+02 0.0000000000000000e+00 1.1369299888610840e+01 -1.7230300903320312e+02 0.0000000000000000e+00 8.8672008514404297e+00 -1.7192300415039062e+02 0.0000000000000000e+00 7.6175298690795898e+00 -1.6653900146484375e+02 -8.3416700363159180e+00 3.5412299633026123e+00 -1.4176799011230469e+02 -8.6234798431396484e+00 1.1612199783325195e+01 -1.6719900512695312e+02 -8.5409297943115234e+00 9.2484302520751953e+00 -1.3847200012207031e+02 -8.9893302917480469e+00 2.2088899612426758e+01 -1.6969400024414062e+02 -8.7662305831909180e+00 1.5698999404907227e+01 -1.3525801086425781e+02 -9.2135095596313477e+00 2.8508199691772461e+01 -1.7386099243164062e+02 -8.9589900970458984e+00 2.1218898773193359e+01 -1.8115100097656250e+02 -9.2135095596313477e+00 2.8508199691772461e+01 -2.0680799865722656e+02 -4.9890899658203125e+00 4.7268699645996094e+01 -1.7739700317382812e+02 -3.9620399475097656e+00 1.7857799530029297e+01 -2.0706098937988281e+02 -2.5002400875091553e+00 4.7521999359130859e+01 -1.8115100097656250e+02 -1.0446000099182129e+01 3.3960201263427734e+01 -1.3022399902343750e+02 -1.0465299606323242e+01 3.3950897216796875e+01 -1.3057600402832031e+02 -1.0311100006103516e+01 3.3639400482177734e+01 -1.3421800231933594e+02 -9.3139400482177734e+00 2.9794198989868164e+01 -1.3247000122070312e+02 -9.6852197647094727e+00 3.1752098083496094e+01 -1.2835299682617188e+02 -1.1285099983215332e+01 3.5606601715087891e+01 -1.8115100097656250e+02 -1.3589000701904297e+01 3.8582500457763672e+01 -1.2616899871826172e+02 -1.2468599319458008e+01 3.7326702117919922e+01 -1.8115100097656250e+02 -1.8206001281738281e+01 4.1733100891113281e+01 -1.1932600402832031e+02 -1.8081499099731445e+01 4.1678199768066406e+01 -1.2092700195312500e+02 -1.6376499176025391e+01 4.0780200958251953e+01 -1.2281099700927734e+02 -1.4756999969482422e+01 3.9635799407958984e+01 -1.2396799468994141e+02 -1.3896499633789062e+01 3.8881801605224609e+01 -1.2441500091552734e+02 -1.3606499671936035e+01 3.8566101074218750e+01 -1.1690299987792969e+02 -2.2791400909423828e+01 4.2917999267578125e+01 -1.1731000518798828e+02 -2.1395200729370117e+01 4.2719402313232422e+01 -1.8115100097656250e+02 -2.3655900955200195e+01 4.2974700927734375e+01 -1.1805299377441406e+02 -1.9876399993896484e+01 4.2346801757812500e+01 -1.1911100006103516e+02 -1.8346300125122070e+01 4.1793498992919922e+01 -1.1922500610351562e+02 -1.8206199645996094e+01 4.1732501983642578e+01 -1.1731000518798828e+02 -2.7015699386596680e+01 4.2718898773193359e+01 -1.1689700317382812e+02 -2.5589300155639648e+01 4.2920600891113281e+01 -1.1676499938964844e+02 -2.4207899093627930e+01 4.2984703063964844e+01 -1.1681800079345703e+02 -2.3656700134277344e+01 4.2958801269531250e+01 -1.8115100097656250e+02 -2.9182100296020508e+01 4.2134799957275391e+01 -1.2147799682617188e+02 -3.2538898468017578e+01 4.0456100463867188e+01 -1.1986300659179688e+02 -3.0945800781250000e+01 4.1384498596191406e+01 -1.1910700225830078e+02 -3.0056299209594727e+01 4.1796100616455078e+01 -1.1849500274658203e+02 -2.9175199508666992e+01 4.2115798950195312e+01 -1.1807499694824219e+02 -2.8569898605346680e+01 4.2335498809814453e+01 -1.7206700134277344e+02 -3.5439698696136475e+00 8.2815294265747070e+00 -1.7229301452636719e+02 -3.5694198608398438e+00 8.8642206192016602e+00 -1.7406300354003906e+02 -3.7692799568176270e+00 1.3441900253295898e+01 -1.7425100708007812e+02 -3.7801301479339600e+00 1.3690899848937988e+01 -1.6903900146484375e+02 -7.6721901893615723e+00 3.5645999908447266e+00 -1.7086898803710938e+02 -5.8431601524353027e+00 3.6284298896789551e+00 -1.7689498901367188e+02 -6.4255599975585938e+00 1.8274101257324219e+01 -1.7345399475097656e+02 -6.2435898780822754e+00 1.3694900512695312e+01 -1.6962200927734375e+02 -7.8582801818847656e+00 8.7041797637939453e+00 -1.7140200805664062e+02 -6.0310401916503906e+00 8.3506097793579102e+00 -1.7185800170898438e+02 -8.0687999725341797e+00 1.4519300460815430e+01 -1.7560400390625000e+02 -8.2491006851196289e+00 1.9500600814819336e+01 -1.8859800720214844e+02 -9.0442895889282227e+00 3.3404998779296875e+01 -1.8588200378417969e+02 -9.1713094711303711e+00 3.1538200378417969e+01 -1.8340499877929688e+02 -9.2257299423217773e+00 2.9908500671386719e+01 -1.9801600646972656e+02 -8.0676097869873047e+00 4.0302299499511719e+01 -1.9547399902343750e+02 -8.4246997833251953e+00 3.8389701843261719e+01 -1.9926199340820312e+02 -7.8579196929931641e+00 4.1251800537109375e+01 -1.9279100036621094e+02 -8.7198600769042969e+00 3.6408699035644531e+01 -1.9176701354980469e+02 -8.8055706024169922e+00 3.5669403076171875e+01 -1.9001400756835938e+02 -8.9521999359130859e+00 3.4405101776123047e+01 -2.0496701049804688e+02 -6.3372197151184082e+00 4.5713500976562500e+01 -2.0396299743652344e+02 -6.7203598022460938e+00 4.4909500122070312e+01 -2.0667800903320312e+02 -5.1975798606872559e+00 4.7144901275634766e+01 -2.0657398986816406e+02 -5.3225698471069336e+00 4.7051399230957031e+01 -2.0617100524902344e+02 -5.6779398918151855e+00 4.6703498840332031e+01 -2.0560200500488281e+02 -6.0319299697875977e+00 4.6230400085449219e+01 -2.0274899291992188e+02 -7.0897898674011230e+00 4.3951702117919922e+01 -2.0191099548339844e+02 -7.2962598800659180e+00 4.3298198699951172e+01 -2.0118800354003906e+02 -7.4744801521301270e+00 4.2734199523925781e+01 -1.3311900329589844e+02 -8.5151796340942383e+00 2.7287200927734375e+01 -1.3154100036621094e+02 -6.6900200843811035e+00 2.6431900024414062e+01 -1.3217799377441406e+02 -8.5471897125244141e+00 2.8601299285888672e+01 -1.3064199829101562e+02 -6.7443199157714844e+00 2.7851900100708008e+01 -1.2911898803710938e+02 -7.0823998451232910e+00 3.0047201156616211e+01 -1.3058599853515625e+02 -8.8241691589355469e+00 3.0637300491333008e+01 -1.2884600830078125e+02 -9.3795099258422852e+00 3.2639801025390625e+01 -1.2678599548339844e+02 -1.0313899993896484e+01 3.4767898559570312e+01 -1.2745200347900391e+02 -7.7288699150085449e+00 3.2201000213623047e+01 -1.2547600555419922e+02 -8.7953796386718750e+00 3.4483802795410156e+01 -1.2351499938964844e+02 -1.0137800216674805e+01 3.6509597778320312e+01 -1.2474499511718750e+02 -1.1503700256347656e+01 3.6660900115966797e+01 -1.2267299652099609e+02 -1.2984499931335449e+01 3.8396598815917969e+01 -1.2157999420166016e+02 -1.3893100738525391e+01 3.9246002197265625e+01 -1.1979299926757812e+02 -1.5625799179077148e+01 4.0544498443603516e+01 -1.1826799774169922e+02 -1.7473300933837891e+01 4.1570499420166016e+01 -1.1806300354003906e+02 -1.7761800765991211e+01 4.1702899932861328e+01 -1.1705199432373047e+02 -1.9435600280761719e+01 4.2338699340820312e+01 -1.1634200286865234e+02 -2.1105199813842773e+01 4.2768199920654297e+01 -1.1581999969482422e+02 -2.4208299636840820e+01 4.3074699401855469e+01 -1.1595299530029297e+02 -2.2644498825073242e+01 4.2997699737548828e+01 -1.1594699859619141e+02 -2.5733299255371094e+01 4.3000701904296875e+01 -1.1634300231933594e+02 -2.7305898666381836e+01 4.2767700195312500e+01 -1.1805899810791016e+02 -3.0640199661254883e+01 4.1705799102783203e+01 -1.1707399749755859e+02 -2.9014301300048828e+01 4.2325702667236328e+01 -1.1877999877929688e+02 -3.1607900619506836e+01 4.1234298706054688e+01 -1.2031600189208984e+02 -3.3327800750732422e+01 4.0175601959228516e+01 -1.2152100372314453e+02 -1.1795700073242188e+01 3.8363098144531250e+01 -1.2046799468994141e+02 -1.2808400154113770e+01 3.9268798828125000e+01 -1.1874500274658203e+02 -1.4733400344848633e+01 4.0651702880859375e+01 -1.1727400207519531e+02 -1.6779100418090820e+01 4.1743400573730469e+01 -1.1707600402832031e+02 -1.7098100662231445e+01 4.1884098052978516e+01 -1.1609999847412109e+02 -1.8946899414062500e+01 4.2559898376464844e+01 -1.1541400146484375e+02 -2.0788700103759766e+01 4.3016002655029297e+01 -1.1503800201416016e+02 -2.2485601425170898e+01 4.3259700775146484e+01 -1.1490999603271484e+02 -2.4208700180053711e+01 4.3341598510742188e+01 -1.1503299713134766e+02 -2.5889101028442383e+01 4.3263000488281250e+01 -1.1541500091552734e+02 -2.7622598648071289e+01 4.3015499114990234e+01 -1.1612100219726562e+02 -2.9507200241088867e+01 4.2546001434326172e+01 -1.1707199859619141e+02 -3.1303201675415039e+01 4.1887203216552734e+01 -1.1776799774169922e+02 -3.2373600006103516e+01 4.1385799407958984e+01 -1.1924900054931641e+02 -3.4279903411865234e+01 4.0259101867675781e+01 -1.3754299926757812e+02 -6.1146597862243652e+00 1.0806900024414062e+01 -1.3450700378417969e+02 -6.4714002609252930e+00 2.0494300842285156e+01 -1.3618899536132812e+02 -8.2973804473876953e+00 2.1144199371337891e+01 -1.3933200073242188e+02 -7.9420795440673828e+00 1.1121200561523438e+01 -1.9683299255371094e+02 -2.6250499725341797e+01 4.4353500366210938e+01 -2.0045599365234375e+02 -2.4590299606323242e+01 4.5368297576904297e+01 -2.1545199584960938e+02 -6.7317500114440918e+00 5.1430603027343750e+01 -2.1352299499511719e+02 -6.4212698936462402e+00 5.1077701568603516e+01 -2.1529800415039062e+02 -7.7583198547363281e+00 5.1282699584960938e+01 -2.1166299438476562e+02 -6.0857501029968262e+00 5.0472198486328125e+01 -2.1336799621582031e+02 -7.2798099517822266e+00 5.0949996948242188e+01 -2.0990400695800781e+02 -5.7310500144958496e+00 4.9625099182128906e+01 -2.1150801086425781e+02 -6.7752599716186523e+00 5.0356899261474609e+01 -2.0827600097656250e+02 -5.3633399009704590e+00 4.8551002502441406e+01 -2.0975300598144531e+02 -6.2537198066711426e+00 4.9514202117919922e+01 -2.1517098999023438e+02 -8.3766002655029297e+00 5.1182899475097656e+01 -2.1466400146484375e+02 -1.0147199630737305e+01 5.0851902008056641e+01 -2.1393299865722656e+02 -1.1930200576782227e+01 5.0449901580810547e+01 -2.1310700988769531e+02 -1.3484000205993652e+01 5.0041900634765625e+01 -2.1178999328613281e+02 -1.5456000328063965e+01 4.9444103240966797e+01 -2.0374600219726562e+02 -8.9551200866699219e+00 4.5809398651123047e+01 -2.0510198974609375e+02 -8.3434600830078125e+00 4.6578899383544922e+01 -2.0622399902343750e+02 -7.6943597793579102e+00 4.7232200622558594e+01 -2.0693499755859375e+02 -7.1701397895812988e+00 4.7657699584960938e+01 -2.0757000732421875e+02 -6.5579400062561035e+00 4.8053997039794922e+01 -2.0801800537109375e+02 -5.9414501190185547e+00 4.8353900909423828e+01 -2.0813299560546875e+02 -5.7246699333190918e+00 4.8437099456787109e+01 -2.1018800354003906e+02 -1.7382299423217773e+01 4.8770301818847656e+01 -2.0811399841308594e+02 -1.9416900634765625e+01 4.7957302093505859e+01 -2.0554399108886719e+02 -2.1477001190185547e+01 4.7021099090576172e+01 -2.0387400817871094e+02 -2.2618499755859375e+01 4.6450000762939453e+01 -2.1324099731445312e+02 -7.7967600822448730e+00 5.0863700866699219e+01 -2.1273599243164062e+02 -9.2762699127197266e+00 5.0577098846435547e+01 -2.1200999450683594e+02 -1.0763599395751953e+01 5.0228302001953125e+01 -2.1119299316406250e+02 -1.2056600570678711e+01 4.9874099731445312e+01 -2.0989300537109375e+02 -1.3691400527954102e+01 4.9354999542236328e+01 -2.0831700134277344e+02 -1.5279299736022949e+01 4.8770099639892578e+01 -2.0628199768066406e+02 -1.6942399978637695e+01 4.8065101623535156e+01 -2.0376899719238281e+02 -1.8604900360107422e+01 4.7254600524902344e+01 -2.0214199829101562e+02 -1.9512899398803711e+01 4.6761100769042969e+01 -1.9882998657226562e+02 -2.1047599792480469e+01 4.5828498840332031e+01 -1.9535299682617188e+02 -2.2285898208618164e+01 4.4956901550292969e+01 -2.1138299560546875e+02 -7.1901102066040039e+00 5.0277797698974609e+01 -2.1088600158691406e+02 -8.3755197525024414e+00 5.0010601043701172e+01 -2.1017498779296875e+02 -9.5631494522094727e+00 4.9679599761962891e+01 -2.0937800598144531e+02 -1.0590899467468262e+01 4.9339298248291016e+01 -2.0811199951171875e+02 -1.1881800651550293e+01 4.8835300445556641e+01 -2.0658000183105469e+02 -1.3123299598693848e+01 4.8261798858642578e+01 -2.0460699462890625e+02 -1.4405200004577637e+01 4.7563301086425781e+01 -2.0217900085449219e+02 -1.5659699440002441e+01 4.6750900268554688e+01 -2.0061300659179688e+02 -1.6328599929809570e+01 4.6250900268554688e+01 -1.9743600463867188e+02 -1.7418600082397461e+01 4.5291900634765625e+01 -1.9412300109863281e+02 -1.8233800888061523e+01 4.4371299743652344e+01 -2.0963099670410156e+02 -6.5678300857543945e+00 4.9436000823974609e+01 -2.0915199279785156e+02 -7.4632802009582520e+00 4.9163898468017578e+01 -2.0847099304199219e+02 -8.3562097549438477e+00 4.8816200256347656e+01 -2.0770700073242188e+02 -9.1244001388549805e+00 4.8451099395751953e+01 -2.0649899291992188e+02 -1.0081299781799316e+01 4.7900699615478516e+01 -2.0503799438476562e+02 -1.0990200042724609e+01 4.7263099670410156e+01 -2.0316200256347656e+02 -1.1912499427795410e+01 4.6472999572753906e+01 -2.0085699462890625e+02 -1.2791399955749512e+01 4.5535800933837891e+01 -1.9937199401855469e+02 -1.3245800018310547e+01 4.4948497772216797e+01 -1.9636698913574219e+02 -1.3951299667358398e+01 4.3795196533203125e+01 -1.9324398803710938e+02 -1.4423100471496582e+01 4.2644401550292969e+01 -2.0200599670410156e+02 -9.5692291259765625e+00 4.4840400695800781e+01 -1.9986698913574219e+02 -1.0145899772644043e+01 4.3671100616455078e+01 -1.9848999023437500e+02 -1.0439200401306152e+01 4.2927398681640625e+01 -1.9569799804687500e+02 -1.0883299827575684e+01 4.1440700531005859e+01 -1.9278800964355469e+02 -1.1163599967956543e+01 3.9916297912597656e+01 -1.8983000183105469e+02 -1.1274100303649902e+01 3.8390800476074219e+01 -1.9008799743652344e+02 -1.4648599624633789e+01 4.1530502319335938e+01 -1.9076199340820312e+02 -1.8756000518798828e+01 4.3526897430419922e+01 -1.9178999328613281e+02 -2.3207399368286133e+01 4.4190803527832031e+01 -1.9307299804687500e+02 -2.7581001281738281e+01 4.3459197998046875e+01 -1.8835000610351562e+02 -1.1263400077819824e+01 3.7635501861572266e+01 -1.8851899719238281e+02 -1.4664199829101562e+01 4.0995502471923828e+01 -1.8908700561523438e+02 -1.8900598526000977e+01 4.3143299102783203e+01 -1.8999600219726562e+02 -2.3541999816894531e+01 4.3860397338867188e+01 -1.9115400695800781e+02 -2.8116199493408203e+01 4.3073898315429688e+01 -1.8558799743652344e+02 -1.1116400718688965e+01 3.6235198974609375e+01 -1.8562300109863281e+02 -1.4503600120544434e+01 4.0037399291992188e+01 -1.8598300170898438e+02 -1.8942600250244141e+01 4.2506797790527344e+01 -1.8662600708007812e+02 -2.3921699523925781e+01 4.3358501434326172e+01 -1.8747999572753906e+02 -2.8867099761962891e+01 4.2494598388671875e+01 -1.8318800354003906e+02 -1.0832799911499023e+01 3.5017299652099609e+01 -1.8316300964355469e+02 -1.4129199981689453e+01 3.9243797302246094e+01 -1.8333200073242188e+02 -1.8693700790405273e+01 4.2048202514648438e+01 -1.8367500305175781e+02 -2.3943700790405273e+01 4.3072700500488281e+01 -1.8414700317382812e+02 -2.9208700180053711e+01 4.2186401367187500e+01 -2.1016499328613281e+02 -2.8714499473571777e+00 4.9898899078369141e+01 -2.1378298950195312e+02 -3.2172200679779053e+00 5.1385898590087891e+01 -2.2100000000000000e+02 -4.7047500610351562e+01 -2.0946899414062500e+01 -2.2100000000000000e+02 -5.0374599456787109e+01 -1.0707399368286133e+01 -2.2100000000000000e+02 -4.7718601226806641e+01 -5.1896600723266602e+00 -2.2100000000000000e+02 -5.1500000000000000e+01 0.0000000000000000e+00 -2.2100000000000000e+02 -4.7718601226806641e+01 5.1896600723266602e+00 -2.2100000000000000e+02 -5.0374599456787109e+01 1.0707399368286133e+01 -2.2100000000000000e+02 -4.5487300872802734e+01 1.5326400756835938e+01 -2.2100000000000000e+02 -4.7047500610351562e+01 2.0946899414062500e+01 -2.2100000000000000e+02 -4.1129100799560547e+01 2.4746500015258789e+01 -2.2100000000000000e+02 -4.1664398193359375e+01 3.0270900726318359e+01 -2.2100000000000000e+02 -3.4847698211669922e+01 3.3009498596191406e+01 -2.2100000000000000e+02 -3.4460201263427734e+01 3.8271999359130859e+01 -2.2100000000000000e+02 -2.6936899185180664e+01 3.9729099273681641e+01 -2.2100000000000000e+02 -2.5750000000000000e+01 4.4600299835205078e+01 -2.2100000000000000e+02 -1.7766599655151367e+01 4.4590801239013672e+01 -2.2100000000000000e+02 -1.5914399147033691e+01 4.8979400634765625e+01 -2.2100000000000000e+02 -7.7655301094055176e+00 4.7367599487304688e+01 -2.2100000000000000e+02 -5.3831896781921387e+00 5.1217899322509766e+01 -2.2100000000000000e+02 2.5986399650573730e+00 4.7929599761962891e+01 -2.2100000000000000e+02 5.3831896781921387e+00 5.1217899322509766e+01 -2.2100000000000000e+02 1.2841300010681152e+01 4.6250400543212891e+01 -2.2100000000000000e+02 1.5914399147033691e+01 4.8979400634765625e+01 -2.2100000000000000e+02 2.2483600616455078e+01 4.2408500671386719e+01 -2.2100000000000000e+02 2.5750000000000000e+01 4.4600299835205078e+01 -2.2100000000000000e+02 3.1074499130249023e+01 3.6583801269531250e+01 -2.2100000000000000e+02 3.4460201263427734e+01 3.8271999359130859e+01 -2.2100000000000000e+02 3.8212398529052734e+01 2.9048299789428711e+01 -2.2100000000000000e+02 4.1664398193359375e+01 3.0270900726318359e+01 -2.2100000000000000e+02 4.3563602447509766e+01 2.0154598236083984e+01 -2.2100000000000000e+02 4.7047500610351562e+01 2.0946899414062500e+01 -2.2100000000000000e+02 4.6877700805664062e+01 1.0318599700927734e+01 -2.2100000000000000e+02 5.0374599456787109e+01 1.0707399368286133e+01 -2.2100000000000000e+02 4.8000000000000000e+01 0.0000000000000000e+00 -2.2100000000000000e+02 5.1500000000000000e+01 0.0000000000000000e+00 -2.2100000000000000e+02 4.6877700805664062e+01 -1.0318599700927734e+01 -2.2100000000000000e+02 5.0374599456787109e+01 -1.0707399368286133e+01 -2.2100000000000000e+02 4.3563602447509766e+01 -2.0154598236083984e+01 -2.2100000000000000e+02 4.7047500610351562e+01 -2.0946899414062500e+01 -2.2100000000000000e+02 3.8212398529052734e+01 -2.9048299789428711e+01 -2.2100000000000000e+02 4.1664398193359375e+01 -3.0270900726318359e+01 -2.2100000000000000e+02 3.1074499130249023e+01 -3.6583801269531250e+01 -2.2100000000000000e+02 3.4460201263427734e+01 -3.8271999359130859e+01 -2.2100000000000000e+02 2.2483600616455078e+01 -4.2408500671386719e+01 -2.2100000000000000e+02 2.5750000000000000e+01 -4.4600299835205078e+01 -2.2100000000000000e+02 1.2841300010681152e+01 -4.6250400543212891e+01 -2.2100000000000000e+02 1.5914399147033691e+01 -4.8979400634765625e+01 -2.2100000000000000e+02 2.5986399650573730e+00 -4.7929599761962891e+01 -2.2100000000000000e+02 5.3831896781921387e+00 -5.1217899322509766e+01 -2.2100000000000000e+02 -7.7655301094055176e+00 -4.7367599487304688e+01 -2.2100000000000000e+02 -5.3831896781921387e+00 -5.1217899322509766e+01 -2.2100000000000000e+02 -1.7766599655151367e+01 -4.4590801239013672e+01 -2.2100000000000000e+02 -1.5914399147033691e+01 -4.8979400634765625e+01 -2.2100000000000000e+02 -2.6936899185180664e+01 -3.9729099273681641e+01 -2.2100000000000000e+02 -2.5750000000000000e+01 -4.4600299835205078e+01 -2.2100000000000000e+02 -3.4847698211669922e+01 -3.3009498596191406e+01 -2.2100000000000000e+02 -3.4460201263427734e+01 -3.8271999359130859e+01 -2.2100000000000000e+02 -4.1129100799560547e+01 -2.4746500015258789e+01 -2.2100000000000000e+02 -4.1664398193359375e+01 -3.0270900726318359e+01 -2.2100000000000000e+02 -4.5487300872802734e+01 -1.5326400756835938e+01 -1.0694699859619141e+02 -5.8500000000000000e+01 -4.7047500610351562e+01 -1.0191400146484375e+02 -5.8500000000000000e+01 -4.8979400634765625e+01 -3.4782199859619141e+01 -5.8500000000000000e+01 5.3831896781921387e+00 -9.6707504272460938e+01 -5.8500000000000000e+01 -5.0374599456787109e+01 -3.4500000000000000e+01 -5.8500000000000000e+01 0.0000000000000000e+00 -3.4782199859619141e+01 -5.8500000000000000e+01 -5.3831896781921387e+00 -3.5625396728515625e+01 -5.8500000000000000e+01 1.0707399368286133e+01 -3.7020603179931641e+01 -5.8500000000000000e+01 1.5914399147033691e+01 -1.3721800231933594e+02 -5.8500000000000000e+01 -5.3831896781921387e+00 -3.8952400207519531e+01 -5.8500000000000000e+01 2.0946899414062500e+01 -4.1399700164794922e+01 -5.8500000000000000e+01 2.5750000000000000e+01 -4.7728099822998047e+01 -5.8500000000000000e+01 -3.4460201263427734e+01 -4.4335700988769531e+01 -5.8500000000000000e+01 -3.0270900726318359e+01 -4.1399700164794922e+01 -5.8500000000000000e+01 -2.5750000000000000e+01 -3.8952400207519531e+01 -5.8500000000000000e+01 -2.0946899414062500e+01 -1.3637500000000000e+02 -5.8500000000000000e+01 -1.0707399368286133e+01 -1.3497898864746094e+02 -5.8500000000000000e+01 -1.5914399147033691e+01 -1.2766400146484375e+02 -5.8500000000000000e+01 -3.0270900726318359e+01 -1.2427199554443359e+02 -5.8500000000000000e+01 -3.4460201263427734e+01 -1.2046000671386719e+02 -5.8500000000000000e+01 -3.8271999359130859e+01 -9.1383193969726562e+01 -5.8500000000000000e+01 -5.1217899322509766e+01 -5.5729099273681641e+01 -5.8500000000000000e+01 -4.1664398193359375e+01 -5.1539802551269531e+01 -5.8500000000000000e+01 -3.8271999359130859e+01 -8.6000000000000000e+01 -5.8500000000000000e+01 -5.1500000000000000e+01 -8.0616798400878906e+01 -5.8500000000000000e+01 -5.1217899322509766e+01 -7.5292602539062500e+01 -5.8500000000000000e+01 -5.0374599456787109e+01 -7.0085693359375000e+01 -5.8500000000000000e+01 -4.8979400634765625e+01 -6.5053100585937500e+01 -5.8500000000000000e+01 -4.7047500610351562e+01 -6.0250099182128906e+01 -5.8500000000000000e+01 -4.4600299835205078e+01 -3.7020603179931641e+01 -5.8500000000000000e+01 -1.5914399147033691e+01 -3.5625396728515625e+01 -5.8500000000000000e+01 -1.0707399368286133e+01 -4.4335700988769531e+01 -5.8500000000000000e+01 3.0270900726318359e+01 -4.7728099822998047e+01 -5.8500000000000000e+01 3.4460201263427734e+01 -5.1539802551269531e+01 -5.8500000000000000e+01 3.8271999359130859e+01 -5.5729099273681641e+01 -5.8500000000000000e+01 4.1664398193359375e+01 -6.0250099182128906e+01 -5.8500000000000000e+01 4.4600299835205078e+01 -6.5053100585937500e+01 -5.8500000000000000e+01 4.7047500610351562e+01 -8.0616798400878906e+01 -5.8500000000000000e+01 5.1217899322509766e+01 -8.6000000000000000e+01 -5.8500000000000000e+01 5.1500000000000000e+01 -9.1383193969726562e+01 -5.8500000000000000e+01 5.1217899322509766e+01 -9.6707504272460938e+01 -5.8500000000000000e+01 5.0374599456787109e+01 -1.3304800415039062e+02 -5.8500000000000000e+01 -2.0946899414062500e+01 -1.3060000610351562e+02 -5.8500000000000000e+01 -2.5750000000000000e+01 -1.1627099609375000e+02 -5.8500000000000000e+01 -4.1664398193359375e+01 -1.1175000000000000e+02 -5.8500000000000000e+01 -4.4600299835205078e+01 -7.0085693359375000e+01 -5.8500000000000000e+01 4.8979400634765625e+01 -7.5292602539062500e+01 -5.8500000000000000e+01 5.0374599456787109e+01 -1.2046000671386719e+02 -5.8500000000000000e+01 3.8271999359130859e+01 -1.2427199554443359e+02 -5.8500000000000000e+01 3.4460201263427734e+01 -1.3750000000000000e+02 -5.8500000000000000e+01 0.0000000000000000e+00 -1.1627099609375000e+02 -5.8500000000000000e+01 4.1664398193359375e+01 -1.0191400146484375e+02 -5.8500000000000000e+01 4.8979400634765625e+01 -1.0694699859619141e+02 -5.8500000000000000e+01 4.7047500610351562e+01 -1.1175000000000000e+02 -5.8500000000000000e+01 4.4600299835205078e+01 -1.2766400146484375e+02 -5.8500000000000000e+01 3.0270900726318359e+01 -1.3060000610351562e+02 -5.8500000000000000e+01 2.5750000000000000e+01 -1.3304800415039062e+02 -5.8500000000000000e+01 2.0946899414062500e+01 -1.3497898864746094e+02 -5.8500000000000000e+01 1.5914399147033691e+01 -1.3637500000000000e+02 -5.8500000000000000e+01 1.0707399368286133e+01 -1.3721800231933594e+02 -5.8500000000000000e+01 5.3831896781921387e+00 -1.3304800415039062e+02 0.0000000000000000e+00 -2.0946899414062500e+01 -1.3637500000000000e+02 0.0000000000000000e+00 -1.0707399368286133e+01 -1.3371899414062500e+02 0.0000000000000000e+00 -5.1896600723266602e+00 -1.3750000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00 -1.3371899414062500e+02 0.0000000000000000e+00 5.1896600723266602e+00 -1.3637500000000000e+02 0.0000000000000000e+00 1.0707399368286133e+01 -1.3148699951171875e+02 0.0000000000000000e+00 1.5326400756835938e+01 -1.3304800415039062e+02 0.0000000000000000e+00 2.0946899414062500e+01 -1.2712900543212891e+02 0.0000000000000000e+00 2.4746500015258789e+01 -1.2766400146484375e+02 0.0000000000000000e+00 3.0270900726318359e+01 -1.2084799957275391e+02 0.0000000000000000e+00 3.3009498596191406e+01 -1.2046000671386719e+02 0.0000000000000000e+00 3.8271999359130859e+01 -1.1293700408935547e+02 0.0000000000000000e+00 3.9729099273681641e+01 -1.1175000000000000e+02 0.0000000000000000e+00 4.4600299835205078e+01 -1.0376699829101562e+02 0.0000000000000000e+00 4.4590801239013672e+01 -1.0191400146484375e+02 0.0000000000000000e+00 4.8979400634765625e+01 -9.3765602111816406e+01 0.0000000000000000e+00 4.7367599487304688e+01 -9.1383193969726562e+01 0.0000000000000000e+00 5.1217899322509766e+01 -8.3401298522949219e+01 0.0000000000000000e+00 4.7929599761962891e+01 -8.0616798400878906e+01 0.0000000000000000e+00 5.1217899322509766e+01 -7.3158699035644531e+01 0.0000000000000000e+00 4.6250400543212891e+01 -7.0085693359375000e+01 0.0000000000000000e+00 4.8979400634765625e+01 -6.3516399383544922e+01 0.0000000000000000e+00 4.2408500671386719e+01 -6.0250099182128906e+01 0.0000000000000000e+00 4.4600299835205078e+01 -5.4925502777099609e+01 0.0000000000000000e+00 3.6583801269531250e+01 -5.1539802551269531e+01 0.0000000000000000e+00 3.8271999359130859e+01 -4.7787597656250000e+01 0.0000000000000000e+00 2.9048299789428711e+01 -4.4335700988769531e+01 0.0000000000000000e+00 3.0270900726318359e+01 -4.2436397552490234e+01 0.0000000000000000e+00 2.0154598236083984e+01 -3.8952400207519531e+01 0.0000000000000000e+00 2.0946899414062500e+01 -3.9122200012207031e+01 0.0000000000000000e+00 1.0318599700927734e+01 -3.5625396728515625e+01 0.0000000000000000e+00 1.0707399368286133e+01 -3.8000099182128906e+01 0.0000000000000000e+00 0.0000000000000000e+00 -3.4500000000000000e+01 0.0000000000000000e+00 0.0000000000000000e+00 -3.9122200012207031e+01 0.0000000000000000e+00 -1.0318599700927734e+01 -3.5625396728515625e+01 0.0000000000000000e+00 -1.0707399368286133e+01 -4.2436397552490234e+01 0.0000000000000000e+00 -2.0154598236083984e+01 -3.8952400207519531e+01 0.0000000000000000e+00 -2.0946899414062500e+01 -4.7787597656250000e+01 0.0000000000000000e+00 -2.9048299789428711e+01 -4.4335700988769531e+01 0.0000000000000000e+00 -3.0270900726318359e+01 -5.4925502777099609e+01 0.0000000000000000e+00 -3.6583801269531250e+01 -5.1539802551269531e+01 0.0000000000000000e+00 -3.8271999359130859e+01 -6.3516399383544922e+01 0.0000000000000000e+00 -4.2408500671386719e+01 -6.0250099182128906e+01 0.0000000000000000e+00 -4.4600299835205078e+01 -7.3158699035644531e+01 0.0000000000000000e+00 -4.6250400543212891e+01 -7.0085693359375000e+01 0.0000000000000000e+00 -4.8979400634765625e+01 -8.3401298522949219e+01 0.0000000000000000e+00 -4.7929599761962891e+01 -8.0616798400878906e+01 0.0000000000000000e+00 -5.1217899322509766e+01 -9.3765602111816406e+01 0.0000000000000000e+00 -4.7367599487304688e+01 -9.1383193969726562e+01 0.0000000000000000e+00 -5.1217899322509766e+01 -1.0376699829101562e+02 0.0000000000000000e+00 -4.4590801239013672e+01 -1.0191400146484375e+02 0.0000000000000000e+00 -4.8979400634765625e+01 -1.1293700408935547e+02 0.0000000000000000e+00 -3.9729099273681641e+01 -1.1175000000000000e+02 0.0000000000000000e+00 -4.4600299835205078e+01 -1.2084799957275391e+02 0.0000000000000000e+00 -3.3009498596191406e+01 -1.2046000671386719e+02 0.0000000000000000e+00 -3.8271999359130859e+01 -1.2712900543212891e+02 0.0000000000000000e+00 -2.4746500015258789e+01 -1.2766400146484375e+02 0.0000000000000000e+00 -3.0270900726318359e+01 -1.3148699951171875e+02 0.0000000000000000e+00 -1.5326400756835938e+01 -1.3746699523925781e+02 -5.8432998657226562e+01 -5.4092998504638672e+00 -1.3775000000000000e+02 -5.8432998657226562e+01 0.0000000000000000e+00 -1.3746699523925781e+02 -5.8432998657226562e+01 5.4092998504638672e+00 -1.3661900329589844e+02 -5.8432998657226562e+01 1.0759400367736816e+01 -1.3521699523925781e+02 -5.8432998657226562e+01 1.5991600036621094e+01 -1.3327600097656250e+02 -5.8432998657226562e+01 2.1048599243164062e+01 -1.3081700134277344e+02 -5.8432998657226562e+01 2.5875000000000000e+01 -1.2786699676513672e+02 -5.8432998657226562e+01 3.0417900085449219e+01 -1.2445800018310547e+02 -5.8432998657226562e+01 3.4627502441406250e+01 -1.2062799835205078e+02 -5.8432998657226562e+01 3.8457698822021484e+01 -1.1641799926757812e+02 -5.8432998657226562e+01 4.1866600036621094e+01 -1.1187500000000000e+02 -5.8432998657226562e+01 4.4816799163818359e+01 -1.0704900360107422e+02 -5.8432998657226562e+01 4.7276000976562500e+01 -1.0199200439453125e+02 -5.8432998657226562e+01 4.9217201232910156e+01 -9.6759399414062500e+01 -5.8432998657226562e+01 5.0619098663330078e+01 -9.1409400939941406e+01 -5.8432998657226562e+01 5.1466499328613281e+01 -8.6000000000000000e+01 -5.8432998657226562e+01 5.1750000000000000e+01 -8.0590705871582031e+01 -5.8432998657226562e+01 5.1466499328613281e+01 -7.5240600585937500e+01 -5.8432998657226562e+01 5.0619098663330078e+01 -7.0008399963378906e+01 -5.8432998657226562e+01 4.9217201232910156e+01 -6.4951400756835938e+01 -5.8432998657226562e+01 4.7276000976562500e+01 -6.0125000000000000e+01 -5.8432998657226562e+01 4.4816799163818359e+01 -5.5582099914550781e+01 -5.8432998657226562e+01 4.1866600036621094e+01 -5.1372497558593750e+01 -5.8432998657226562e+01 3.8457698822021484e+01 -4.7542301177978516e+01 -5.8432998657226562e+01 3.4627502441406250e+01 -4.4133399963378906e+01 -5.8432998657226562e+01 3.0417900085449219e+01 -4.1183200836181641e+01 -5.8432998657226562e+01 2.5875000000000000e+01 -3.8724098205566406e+01 -5.8432998657226562e+01 2.1048599243164062e+01 -3.6782901763916016e+01 -5.8432998657226562e+01 1.5991600036621094e+01 -3.5380901336669922e+01 -5.8432998657226562e+01 1.0759400367736816e+01 -3.4533500671386719e+01 -5.8432998657226562e+01 5.4092998504638672e+00 -3.4250000000000000e+01 -5.8432998657226562e+01 0.0000000000000000e+00 -3.4533500671386719e+01 -5.8432998657226562e+01 -5.4092998504638672e+00 -3.5380901336669922e+01 -5.8432998657226562e+01 -1.0759400367736816e+01 -3.6782901763916016e+01 -5.8432998657226562e+01 -1.5991600036621094e+01 -3.8724098205566406e+01 -5.8432998657226562e+01 -2.1048599243164062e+01 -4.1183200836181641e+01 -5.8432998657226562e+01 -2.5875000000000000e+01 -4.4133399963378906e+01 -5.8432998657226562e+01 -3.0417900085449219e+01 -4.7542301177978516e+01 -5.8432998657226562e+01 -3.4627502441406250e+01 -5.1372497558593750e+01 -5.8432998657226562e+01 -3.8457698822021484e+01 -5.5582099914550781e+01 -5.8432998657226562e+01 -4.1866600036621094e+01 -6.0125000000000000e+01 -5.8432998657226562e+01 -4.4816799163818359e+01 -6.4951400756835938e+01 -5.8432998657226562e+01 -4.7276000976562500e+01 -7.0008399963378906e+01 -5.8432998657226562e+01 -4.9217201232910156e+01 -7.5240600585937500e+01 -5.8432998657226562e+01 -5.0619098663330078e+01 -8.0590705871582031e+01 -5.8432998657226562e+01 -5.1466499328613281e+01 -8.6000000000000000e+01 -5.8432998657226562e+01 -5.1750000000000000e+01 -9.1409400939941406e+01 -5.8432998657226562e+01 -5.1466499328613281e+01 -9.6759399414062500e+01 -5.8432998657226562e+01 -5.0619098663330078e+01 -1.0199200439453125e+02 -5.8432998657226562e+01 -4.9217201232910156e+01 -1.0704900360107422e+02 -5.8432998657226562e+01 -4.7276000976562500e+01 -1.1187500000000000e+02 -5.8432998657226562e+01 -4.4816799163818359e+01 -1.1641799926757812e+02 -5.8432998657226562e+01 -4.1866600036621094e+01 -1.2062799835205078e+02 -5.8432998657226562e+01 -3.8457698822021484e+01 -1.2445800018310547e+02 -5.8432998657226562e+01 -3.4627502441406250e+01 -1.2786699676513672e+02 -5.8432998657226562e+01 -3.0417900085449219e+01 -1.3081700134277344e+02 -5.8432998657226562e+01 -2.5875000000000000e+01 -1.3327600097656250e+02 -5.8432998657226562e+01 -2.1048599243164062e+01 -1.3521699523925781e+02 -5.8432998657226562e+01 -1.5991600036621094e+01 -1.3661900329589844e+02 -5.8432998657226562e+01 -1.0759400367736816e+01 -1.3764900207519531e+02 -5.8250000000000000e+01 -5.4284300804138184e+00 -1.3793299865722656e+02 -5.8250000000000000e+01 0.0000000000000000e+00 -1.3764900207519531e+02 -5.8250000000000000e+01 5.4284300804138184e+00 -1.3679798889160156e+02 -5.8250000000000000e+01 1.0797400474548340e+01 -1.3539099121093750e+02 -5.8250000000000000e+01 1.6048099517822266e+01 -1.3344299316406250e+02 -5.8250000000000000e+01 2.1122999191284180e+01 -1.3097499084472656e+02 -5.8250000000000000e+01 2.5966501235961914e+01 -1.2801499938964844e+02 -5.8250000000000000e+01 3.0525400161743164e+01 -1.2459400177001953e+02 -5.8250000000000000e+01 3.4749900817871094e+01 -1.2075000000000000e+02 -5.8250000000000000e+01 3.8593696594238281e+01 -1.1652500152587891e+02 -5.8250000000000000e+01 4.2014698028564453e+01 -1.1196699523925781e+02 -5.8250000000000000e+01 4.4975299835205078e+01 -1.0712300109863281e+02 -5.8250000000000000e+01 4.7443199157714844e+01 -1.0204800415039062e+02 -5.8250000000000000e+01 4.9391197204589844e+01 -9.6797500610351562e+01 -5.8250000000000000e+01 5.0798099517822266e+01 -9.1428504943847656e+01 -5.8250000000000000e+01 5.1648502349853516e+01 -8.6000000000000000e+01 -5.8250000000000000e+01 5.1933002471923828e+01 -8.0571502685546875e+01 -5.8250000000000000e+01 5.1648502349853516e+01 -7.5202499389648438e+01 -5.8250000000000000e+01 5.0798099517822266e+01 -6.9951805114746094e+01 -5.8250000000000000e+01 4.9391197204589844e+01 -6.4877006530761719e+01 -5.8250000000000000e+01 4.7443199157714844e+01 -6.0033500671386719e+01 -5.8250000000000000e+01 4.4975299835205078e+01 -5.5474601745605469e+01 -5.8250000000000000e+01 4.2014698028564453e+01 -5.1250000000000000e+01 -5.8250000000000000e+01 3.8593696594238281e+01 -4.7406299591064453e+01 -5.8250000000000000e+01 3.4749900817871094e+01 -4.3985298156738281e+01 -5.8250000000000000e+01 3.0525400161743164e+01 -4.1024700164794922e+01 -5.8250000000000000e+01 2.5966501235961914e+01 -3.8556900024414062e+01 -5.8250000000000000e+01 2.1122999191284180e+01 -3.6608798980712891e+01 -5.8250000000000000e+01 1.6048099517822266e+01 -3.5201900482177734e+01 -5.8250000000000000e+01 1.0797400474548340e+01 -3.4351501464843750e+01 -5.8250000000000000e+01 5.4284300804138184e+00 -3.4067001342773438e+01 -5.8250000000000000e+01 0.0000000000000000e+00 -3.4351501464843750e+01 -5.8250000000000000e+01 -5.4284300804138184e+00 -3.5201900482177734e+01 -5.8250000000000000e+01 -1.0797400474548340e+01 -3.6608798980712891e+01 -5.8250000000000000e+01 -1.6048099517822266e+01 -3.8556900024414062e+01 -5.8250000000000000e+01 -2.1122999191284180e+01 -4.1024700164794922e+01 -5.8250000000000000e+01 -2.5966501235961914e+01 -4.3985298156738281e+01 -5.8250000000000000e+01 -3.0525400161743164e+01 -4.7406299591064453e+01 -5.8250000000000000e+01 -3.4749900817871094e+01 -5.1250000000000000e+01 -5.8250000000000000e+01 -3.8593696594238281e+01 -5.5474601745605469e+01 -5.8250000000000000e+01 -4.2014698028564453e+01 -6.0033500671386719e+01 -5.8250000000000000e+01 -4.4975299835205078e+01 -6.4877006530761719e+01 -5.8250000000000000e+01 -4.7443199157714844e+01 -6.9951805114746094e+01 -5.8250000000000000e+01 -4.9391197204589844e+01 -7.5202499389648438e+01 -5.8250000000000000e+01 -5.0798099517822266e+01 -8.0571502685546875e+01 -5.8250000000000000e+01 -5.1648502349853516e+01 -8.6000000000000000e+01 -5.8250000000000000e+01 -5.1933002471923828e+01 -9.1428504943847656e+01 -5.8250000000000000e+01 -5.1648502349853516e+01 -9.6797500610351562e+01 -5.8250000000000000e+01 -5.0798099517822266e+01 -1.0204800415039062e+02 -5.8250000000000000e+01 -4.9391197204589844e+01 -1.0712300109863281e+02 -5.8250000000000000e+01 -4.7443199157714844e+01 -1.1196699523925781e+02 -5.8250000000000000e+01 -4.4975299835205078e+01 -1.1652500152587891e+02 -5.8250000000000000e+01 -4.2014698028564453e+01 -1.2075000000000000e+02 -5.8250000000000000e+01 -3.8593696594238281e+01 -1.2459400177001953e+02 -5.8250000000000000e+01 -3.4749900817871094e+01 -1.2801499938964844e+02 -5.8250000000000000e+01 -3.0525400161743164e+01 -1.3097499084472656e+02 -5.8250000000000000e+01 -2.5966501235961914e+01 -1.3344299316406250e+02 -5.8250000000000000e+01 -2.1122999191284180e+01 -1.3539099121093750e+02 -5.8250000000000000e+01 -1.6048099517822266e+01 -1.3679798889160156e+02 -5.8250000000000000e+01 -1.0797400474548340e+01 -7.7899299621582031e+01 -5.8500000000000000e+01 -4.9846000671386719e+01 -7.0008300781250000e+01 -5.8500000000000000e+01 -4.7901100158691406e+01 -7.0015998840332031e+01 -5.9888198852539062e+01 -4.7878101348876953e+01 -8.1938400268554688e+01 -5.9888198852539062e+01 -5.0312000274658203e+01 -8.6000000000000000e+01 -5.8500000000000000e+01 -5.0500000000000000e+01 -7.7903205871582031e+01 -5.9888198852539062e+01 -4.9822097778320312e+01 -7.3920402526855469e+01 -5.9888198852539062e+01 -4.9008998870849609e+01 -6.2531501770019531e+01 -5.8500000000000000e+01 -4.4715499877929688e+01 -5.5662502288818359e+01 -5.8500000000000000e+01 -4.0371803283691406e+01 -5.5677101135253906e+01 -5.9888198852539062e+01 -4.0352500915527344e+01 -5.9022399902343750e+01 -5.9888198852539062e+01 -4.2661598205566406e+01 -6.2542697906494141e+01 -5.9888198852539062e+01 -4.4694099426269531e+01 -6.6215202331542969e+01 -5.9888198852539062e+01 -4.6436702728271484e+01 -4.9579299926757812e+01 -5.8500000000000000e+01 -3.4982601165771484e+01 -4.4439300537109375e+01 -5.8500000000000000e+01 -2.8687198638916016e+01 -4.4459297180175781e+01 -5.9888198852539062e+01 -2.8673500061035156e+01 -4.6901199340820312e+01 -5.9888198852539062e+01 -3.1923099517822266e+01 -4.9596801757812500e+01 -5.9888198852539062e+01 -3.4965702056884766e+01 -5.2528400421142578e+01 -5.9888198852539062e+01 -3.7781600952148438e+01 -4.0375797271728516e+01 -5.8500000000000000e+01 -2.1648900985717773e+01 -3.7493900299072266e+01 -5.8500000000000000e+01 -1.4049900054931641e+01 -3.7517101287841797e+01 -5.9888198852539062e+01 -1.4043199539184570e+01 -3.8804401397705078e+01 -5.9888198852539062e+01 -1.7898900985717773e+01 -4.0397701263427734e+01 -5.9888198852539062e+01 -2.1638599395751953e+01 -4.2286701202392578e+01 -5.9888198852539062e+01 -2.5237800598144531e+01 -3.5868202209472656e+01 -5.8500000000000000e+01 -6.0870599746704102e+00 -3.5541000366210938e+01 -5.8500000000000000e+01 2.0334098339080811e+00 -3.5565200805664062e+01 -5.9888198852539062e+01 2.0324001312255859e+00 -3.5565200805664062e+01 -5.9888198852539062e+01 -2.0324001312255859e+00 -3.5892299652099609e+01 -5.9888198852539062e+01 -6.0841398239135742e+00 -3.6544300079345703e+01 -5.9888198852539062e+01 -1.0096400260925293e+01 -3.6520599365234375e+01 -5.8500000000000000e+01 1.0101299285888672e+01 -3.8781700134277344e+01 -5.8500000000000000e+01 1.7907501220703125e+01 -3.8804401397705078e+01 -5.9888198852539062e+01 1.7898900985717773e+01 -3.7517101287841797e+01 -5.9888198852539062e+01 1.4043199539184570e+01 -3.6544300079345703e+01 -5.9888198852539062e+01 1.0096400260925293e+01 -3.5892299652099609e+01 -5.9888198852539062e+01 6.0841398239135742e+00 -4.2265697479248047e+01 -5.8500000000000000e+01 2.5250000000000000e+01 -4.6882499694824219e+01 -5.8500000000000000e+01 3.1938501358032227e+01 -4.6901199340820312e+01 -5.9888198852539062e+01 3.1923099517822266e+01 -4.4459297180175781e+01 -5.9888198852539062e+01 2.8673500061035156e+01 -4.2286701202392578e+01 -5.9888198852539062e+01 2.5237800598144531e+01 -4.0397701263427734e+01 -5.9888198852539062e+01 2.1638599395751953e+01 -5.2512401580810547e+01 -5.8500000000000000e+01 3.7799800872802734e+01 -5.9009498596191406e+01 -5.8500000000000000e+01 4.2681999206542969e+01 -5.9022399902343750e+01 -5.9888198852539062e+01 4.2661598205566406e+01 -5.5677101135253906e+01 -5.9888198852539062e+01 4.0352500915527344e+01 -5.2528400421142578e+01 -5.9888198852539062e+01 3.7781600952148438e+01 -4.9596801757812500e+01 -5.9888198852539062e+01 3.4965702056884766e+01 -6.6205703735351562e+01 -5.8500000000000000e+01 4.6458900451660156e+01 -7.3914604187011719e+01 -5.8500000000000000e+01 4.9032497406005859e+01 -7.3920402526855469e+01 -5.9888198852539062e+01 4.9008998870849609e+01 -7.0015998840332031e+01 -5.9888198852539062e+01 4.7878101348876953e+01 -6.6215202331542969e+01 -5.9888198852539062e+01 4.6436702728271484e+01 -6.2542697906494141e+01 -5.9888198852539062e+01 4.4694099426269531e+01 -8.1936500549316406e+01 -5.8500000000000000e+01 5.0336200714111328e+01 -9.0063598632812500e+01 -5.8500000000000000e+01 5.0336200714111328e+01 -9.0061599731445312e+01 -5.9888198852539062e+01 5.0312000274658203e+01 -8.6000000000000000e+01 -5.9888198852539062e+01 5.0475700378417969e+01 -8.1938400268554688e+01 -5.9888198852539062e+01 5.0312000274658203e+01 -7.7903205871582031e+01 -5.9888198852539062e+01 4.9822097778320312e+01 -9.8085502624511719e+01 -5.8500000000000000e+01 4.9032497406005859e+01 -1.0579399871826172e+02 -5.8500000000000000e+01 4.6458900451660156e+01 -1.0578499603271484e+02 -5.9888198852539062e+01 4.6436702728271484e+01 -1.0198400115966797e+02 -5.9888198852539062e+01 4.7878101348876953e+01 -9.8079696655273438e+01 -5.9888198852539062e+01 4.9008998870849609e+01 -9.4096900939941406e+01 -5.9888198852539062e+01 4.9822097778320312e+01 -1.1299099731445312e+02 -5.8500000000000000e+01 4.2681999206542969e+01 -1.1948799896240234e+02 -5.8500000000000000e+01 3.7799800872802734e+01 -1.1947200012207031e+02 -5.9888198852539062e+01 3.7781600952148438e+01 -1.1632299804687500e+02 -5.9888198852539062e+01 4.0352500915527344e+01 -1.1297799682617188e+02 -5.9888198852539062e+01 4.2661598205566406e+01 -1.0945700073242188e+02 -5.9888198852539062e+01 4.4694099426269531e+01 -1.2973399353027344e+02 -5.8500000000000000e+01 2.5250000000000000e+01 -1.2754100799560547e+02 -5.9888198852539062e+01 2.8673500061035156e+01 -1.2511800384521484e+02 -5.8500000000000000e+01 3.1938501358032227e+01 -1.2509900665283203e+02 -5.9888198852539062e+01 3.1923099517822266e+01 -1.2240299987792969e+02 -5.9888198852539062e+01 3.4965702056884766e+01 -1.3321800231933594e+02 -5.8500000000000000e+01 1.7907501220703125e+01 -1.3160200500488281e+02 -5.9888198852539062e+01 2.1638599395751953e+01 -1.2971299743652344e+02 -5.9888198852539062e+01 2.5237800598144531e+01 -1.3547900390625000e+02 -5.8500000000000000e+01 1.0101299285888672e+01 -1.3448300170898438e+02 -5.9888198852539062e+01 1.4043199539184570e+01 -1.3319599914550781e+02 -5.9888198852539062e+01 1.7898900985717773e+01 -1.3643499755859375e+02 -5.9888198852539062e+01 -2.0324001312255859e+00 -1.3643499755859375e+02 -5.9888198852539062e+01 2.0324001312255859e+00 -1.3645899963378906e+02 -5.8500000000000000e+01 2.0334098339080811e+00 -1.3610800170898438e+02 -5.9888198852539062e+01 6.0841398239135742e+00 -1.3545599365234375e+02 -5.9888198852539062e+01 1.0096400260925293e+01 -1.3610800170898438e+02 -5.9888198852539062e+01 -6.0841398239135742e+00 -1.3613200378417969e+02 -5.8500000000000000e+01 -6.0870599746704102e+00 -1.3545599365234375e+02 -5.9888198852539062e+01 -1.0096400260925293e+01 -1.3450599670410156e+02 -5.8500000000000000e+01 -1.4049900054931641e+01 -1.3448300170898438e+02 -5.9888198852539062e+01 -1.4043199539184570e+01 -1.3162399291992188e+02 -5.8500000000000000e+01 -2.1648900985717773e+01 -1.3160200500488281e+02 -5.9888198852539062e+01 -2.1638599395751953e+01 -1.3319599914550781e+02 -5.9888198852539062e+01 -1.7898900985717773e+01 -1.1947200012207031e+02 -5.9888198852539062e+01 -3.7781600952148438e+01 -1.2240299987792969e+02 -5.9888198852539062e+01 -3.4965702056884766e+01 -1.2242099761962891e+02 -5.8500000000000000e+01 -3.4982601165771484e+01 -1.2509900665283203e+02 -5.9888198852539062e+01 -3.1923099517822266e+01 -1.2756100463867188e+02 -5.8500000000000000e+01 -2.8687198638916016e+01 -1.2754100799560547e+02 -5.9888198852539062e+01 -2.8673500061035156e+01 -1.2971299743652344e+02 -5.9888198852539062e+01 -2.5237800598144531e+01 -1.1632299804687500e+02 -5.9888198852539062e+01 -4.0352500915527344e+01 -1.1633699798583984e+02 -5.8500000000000000e+01 -4.0371803283691406e+01 -1.1297799682617188e+02 -5.9888198852539062e+01 -4.2661598205566406e+01 -1.0946899414062500e+02 -5.8500000000000000e+01 -4.4715499877929688e+01 -1.0945700073242188e+02 -5.9888198852539062e+01 -4.4694099426269531e+01 -1.0199200439453125e+02 -5.8500000000000000e+01 -4.7901100158691406e+01 -1.0198400115966797e+02 -5.9888198852539062e+01 -4.7878101348876953e+01 -1.0578499603271484e+02 -5.9888198852539062e+01 -4.6436702728271484e+01 -8.6000000000000000e+01 -5.9888198852539062e+01 -5.0475700378417969e+01 -9.0061599731445312e+01 -5.9888198852539062e+01 -5.0312000274658203e+01 -9.4100799560546875e+01 -5.8500000000000000e+01 -4.9846000671386719e+01 -9.4096900939941406e+01 -5.9888198852539062e+01 -4.9822097778320312e+01 -9.8079696655273438e+01 -5.9888198852539062e+01 -4.9008998870849609e+01 -6.1726802825927734e+01 -7.0499893188476562e+01 -3.7152900695800781e+01 -5.8741699218750000e+01 -7.0499893188476562e+01 -3.5021499633789062e+01 -1.0712199401855469e+02 -7.0499893188476562e+01 3.9030399322509766e+01 -5.5942699432373047e+01 -7.0499893188476562e+01 -3.2650897979736328e+01 -5.3349098205566406e+01 -7.0499893188476562e+01 -3.0057199478149414e+01 -6.4877799987792969e+01 -7.0499893188476562e+01 -3.9030399322509766e+01 -1.1027300262451172e+02 -7.0499893188476562e+01 3.7152900695800781e+01 -1.1325799560546875e+02 -7.0499893188476562e+01 3.5021499633789062e+01 -1.1605699920654297e+02 -7.0499893188476562e+01 3.2650897979736328e+01 -1.1865100097656250e+02 -7.0499893188476562e+01 3.0057199478149414e+01 -1.2102200317382812e+02 -7.0499893188476562e+01 2.7258298873901367e+01 -1.2664100646972656e+02 -7.0499893188476562e+01 1.7826999664306641e+01 -1.2797499847412109e+02 -7.0499893188476562e+01 1.4409899711608887e+01 -1.2902101135253906e+02 -7.0499893188476562e+01 1.0894499778747559e+01 -1.2977400207519531e+02 -7.0499893188476562e+01 7.3045501708984375e+00 -5.0978500366210938e+01 -7.0499893188476562e+01 -2.7258298873901367e+01 -4.8847103118896484e+01 -7.0499893188476562e+01 -2.4273099899291992e+01 -4.6969600677490234e+01 -7.0499893188476562e+01 -2.1122200012207031e+01 -4.5358596801757812e+01 -7.0499893188476562e+01 -1.7826999664306641e+01 -4.4025299072265625e+01 -7.0499893188476562e+01 -1.4409899711608887e+01 -4.2978698730468750e+01 -7.0499893188476562e+01 -1.0894499778747559e+01 -4.2978698730468750e+01 -7.0499893188476562e+01 1.0894499778747559e+01 -4.4025299072265625e+01 -7.0499893188476562e+01 1.4409899711608887e+01 -4.8847103118896484e+01 -7.0499893188476562e+01 2.4273099899291992e+01 -5.0978500366210938e+01 -7.0499893188476562e+01 2.7258298873901367e+01 -5.3349098205566406e+01 -7.0499893188476562e+01 3.0057199478149414e+01 -5.5942699432373047e+01 -7.0499893188476562e+01 3.2650897979736328e+01 -5.8741699218750000e+01 -7.0499893188476562e+01 3.5021499633789062e+01 -6.1726802825927734e+01 -7.0499893188476562e+01 3.7152900695800781e+01 -1.0382699584960938e+02 -7.0499893188476562e+01 4.0641399383544922e+01 -1.2315299987792969e+02 -7.0499893188476562e+01 2.4273099899291992e+01 -1.2502999877929688e+02 -7.0499893188476562e+01 2.1122200012207031e+01 -1.2902101135253906e+02 -7.0499893188476562e+01 -1.0894499778747559e+01 -9.6894500732421875e+01 -7.0499893188476562e+01 -4.3021297454833984e+01 -9.3304595947265625e+01 -7.0499893188476562e+01 -4.3774002075195312e+01 -4.2226001739501953e+01 -7.0499893188476562e+01 -7.3045501708984375e+00 -4.1772296905517578e+01 -7.0499893188476562e+01 -3.6647899150848389e+00 -4.1620700836181641e+01 -7.0499893188476562e+01 0.0000000000000000e+00 -4.5358596801757812e+01 -7.0499893188476562e+01 1.7826999664306641e+01 -4.6969600677490234e+01 -7.0499893188476562e+01 2.1122200012207031e+01 -1.3022799682617188e+02 -7.0499893188476562e+01 3.6647899150848389e+00 -1.3037901306152344e+02 -7.0499893188476562e+01 0.0000000000000000e+00 -1.3022799682617188e+02 -7.0499893188476562e+01 -3.6647899150848389e+00 -6.8173103332519531e+01 -7.0499893188476562e+01 4.0641399383544922e+01 -7.1590103149414062e+01 -7.0499893188476562e+01 4.1974700927734375e+01 -1.0040999603271484e+02 -7.0499893188476562e+01 4.1974700927734375e+01 -1.2797499847412109e+02 -7.0499893188476562e+01 -1.4409899711608887e+01 -1.2664100646972656e+02 -7.0499893188476562e+01 -1.7826999664306641e+01 -1.2502999877929688e+02 -7.0499893188476562e+01 -2.1122200012207031e+01 -4.1772296905517578e+01 -7.0499893188476562e+01 3.6647899150848389e+00 -4.2226001739501953e+01 -7.0499893188476562e+01 7.3045501708984375e+00 -8.9664802551269531e+01 -7.0499893188476562e+01 -4.4227699279785156e+01 -8.6000000000000000e+01 -7.0499893188476562e+01 -4.4379302978515625e+01 -8.2335197448730469e+01 -7.0499893188476562e+01 -4.4227699279785156e+01 -6.4877799987792969e+01 -7.0499893188476562e+01 3.9030399322509766e+01 -7.5105598449707031e+01 -7.0499893188476562e+01 4.3021297454833984e+01 -7.8695404052734375e+01 -7.0499893188476562e+01 4.3774002075195312e+01 -9.6894500732421875e+01 -7.0499893188476562e+01 4.3021297454833984e+01 -8.2335197448730469e+01 -7.0499893188476562e+01 4.4227699279785156e+01 -8.6000000000000000e+01 -7.0499893188476562e+01 4.4379302978515625e+01 -8.9664802551269531e+01 -7.0499893188476562e+01 4.4227699279785156e+01 -9.3304595947265625e+01 -7.0499893188476562e+01 4.3774002075195312e+01 -1.2315299987792969e+02 -7.0499893188476562e+01 -2.4273099899291992e+01 -1.2102200317382812e+02 -7.0499893188476562e+01 -2.7258298873901367e+01 -1.1865100097656250e+02 -7.0499893188476562e+01 -3.0057199478149414e+01 -1.1605699920654297e+02 -7.0499893188476562e+01 -3.2650897979736328e+01 -1.1325799560546875e+02 -7.0499893188476562e+01 -3.5021499633789062e+01 -1.1027300262451172e+02 -7.0499893188476562e+01 -3.7152900695800781e+01 -1.0712199401855469e+02 -7.0499893188476562e+01 -3.9030399322509766e+01 -1.0382699584960938e+02 -7.0499893188476562e+01 -4.0641399383544922e+01 -1.0040999603271484e+02 -7.0499893188476562e+01 -4.1974700927734375e+01 -7.8695404052734375e+01 -7.0499893188476562e+01 -4.3774002075195312e+01 -7.5105598449707031e+01 -7.0499893188476562e+01 -4.3021297454833984e+01 -7.1590103149414062e+01 -7.0499893188476562e+01 -4.1974700927734375e+01 -1.2977400207519531e+02 -7.0499893188476562e+01 -7.3045501708984375e+00 -6.8173103332519531e+01 -7.0499893188476562e+01 -4.0641399383544922e+01 -8.9889396667480469e+01 -6.8767799377441406e+01 4.6937301635742188e+01 -9.3976898193359375e+01 -6.3129501342773438e+01 4.9083499908447266e+01 -9.3752197265625000e+01 -6.8767799377441406e+01 4.6455902099609375e+01 -9.4183303833007812e+01 -6.3129501342773438e+01 4.9041301727294922e+01 -9.7561996459960938e+01 -6.8767799377441406e+01 4.5657001495361328e+01 -1.0491899871826172e+02 -6.8767799377441406e+01 4.3131298065185547e+01 -1.0911000061035156e+02 -6.3129501342773438e+01 4.4031398773193359e+01 -1.0841600036621094e+02 -6.8767799377441406e+01 4.1421600341796875e+01 -1.0965699768066406e+02 -6.3129501342773438e+01 4.3715396881103516e+01 -1.1175999450683594e+02 -6.8767799377441406e+01 3.9429100036621094e+01 -9.7900596618652344e+01 -6.3129501342773438e+01 4.8282398223876953e+01 -1.0174700164794922e+02 -6.3129501342773438e+01 4.7168300628662109e+01 -1.0129299926757812e+02 -6.8767799377441406e+01 4.4546298980712891e+01 -1.0214099884033203e+02 -6.3129501342773438e+01 4.7018798828125000e+01 -1.0549099731445312e+02 -6.3129501342773438e+01 4.5748199462890625e+01 -1.1789900207519531e+02 -6.8767799377441406e+01 3.4651302337646484e+01 -1.2186399841308594e+02 -6.3129501342773438e+01 3.4447402954101562e+01 -1.2065100097656250e+02 -6.8767799377441406e+01 3.1898698806762695e+01 -1.2256199645996094e+02 -6.3129501342773438e+01 3.3658699035644531e+01 -1.2316699981689453e+02 -6.8767799377441406e+01 2.8928300857543945e+01 -1.1257799530029297e+02 -6.3129501342773438e+01 4.2029102325439453e+01 -1.1587300109863281e+02 -6.3129501342773438e+01 3.9754199981689453e+01 -1.1492800140380859e+02 -6.8767799377441406e+01 3.7167098999023438e+01 -1.1652600097656250e+02 -6.3129501342773438e+01 3.9221202850341797e+01 -1.1897499847412109e+02 -6.3129501342773438e+01 3.7221500396728516e+01 -1.2742200469970703e+02 -6.8767799377441406e+01 2.2416299819946289e+01 -1.3092599487304688e+02 -6.3129501342773438e+01 2.1317800521850586e+01 -1.2913099670410156e+02 -6.8767799377441406e+01 1.8919099807739258e+01 -1.3150500488281250e+02 -6.3129501342773438e+01 1.9960601806640625e+01 -1.3054600524902344e+02 -6.8767799377441406e+01 1.5292799949645996e+01 -1.2451899719238281e+02 -6.3129501342773438e+01 3.1449899673461914e+01 -1.2692500305175781e+02 -6.3129501342773438e+01 2.8248399734497070e+01 -1.2542900085449219e+02 -6.8767799377441406e+01 2.5760299682617188e+01 -1.2760099792480469e+02 -6.3129501342773438e+01 2.7179599761962891e+01 -1.2906500244140625e+02 -6.3129501342773438e+01 2.4863698959350586e+01 -1.3536499023437500e+02 -6.3129501342773438e+01 5.9939599037170410e+00 -1.3293699645996094e+02 -6.8767799377441406e+01 3.8893198966979980e+00 -1.3245600891113281e+02 -6.8767799377441406e+01 7.7520599365234375e+00 -1.3249600219726562e+02 -6.3129501342773438e+01 1.7633499145507812e+01 -1.3376399230957031e+02 -6.3129501342773438e+01 1.3835000038146973e+01 -1.3165699768066406e+02 -6.8767799377441406e+01 1.1561900138854980e+01 -1.3416799926757812e+02 -6.3129501342773438e+01 1.2197899818420410e+01 -1.3472200012207031e+02 -6.3129501342773438e+01 9.9467601776123047e+00 -1.3551800537109375e+02 -6.3129501342773438e+01 4.1031799316406250e+00 -1.3568699645996094e+02 -6.3129501342773438e+01 2.0023000240325928e+00 -1.3309800720214844e+02 -6.8767799377441406e+01 0.0000000000000000e+00 -1.3568699645996094e+02 -6.3129501342773438e+01 -2.0023000240325928e+00 -1.3293699645996094e+02 -6.8767799377441406e+01 -3.8893198966979980e+00 -1.3551800537109375e+02 -6.3129501342773438e+01 -4.1031799316406250e+00 -1.3536499023437500e+02 -6.3129501342773438e+01 -5.9939599037170410e+00 -1.3245600891113281e+02 -6.8767799377441406e+01 -7.7520599365234375e+00 -1.3472200012207031e+02 -6.3129501342773438e+01 -9.9467601776123047e+00 -1.3165699768066406e+02 -6.8767799377441406e+01 -1.1561900138854980e+01 -1.3416799926757812e+02 -6.3129501342773438e+01 -1.2197899818420410e+01 -1.3376399230957031e+02 -6.3129501342773438e+01 -1.3835000038146973e+01 -1.3054600524902344e+02 -6.8767799377441406e+01 -1.5292799949645996e+01 -1.3249600219726562e+02 -6.3129501342773438e+01 -1.7633499145507812e+01 -1.2913099670410156e+02 -6.8767799377441406e+01 -1.8919099807739258e+01 -1.3150500488281250e+02 -6.3129501342773438e+01 -1.9960601806640625e+01 -1.3092599487304688e+02 -6.3129501342773438e+01 -2.1317800521850586e+01 -1.2742200469970703e+02 -6.8767799377441406e+01 -2.2416299819946289e+01 -1.2906500244140625e+02 -6.3129501342773438e+01 -2.4863698959350586e+01 -1.2542900085449219e+02 -6.8767799377441406e+01 -2.5760299682617188e+01 -1.2760099792480469e+02 -6.3129501342773438e+01 -2.7179599761962891e+01 -1.2692500305175781e+02 -6.3129501342773438e+01 -2.8248399734497070e+01 -1.2316699981689453e+02 -6.8767799377441406e+01 -2.8928300857543945e+01 -1.2451899719238281e+02 -6.3129501342773438e+01 -3.1449899673461914e+01 -1.2065100097656250e+02 -6.8767799377441406e+01 -3.1898698806762695e+01 -1.2256199645996094e+02 -6.3129501342773438e+01 -3.3658699035644531e+01 -1.2186399841308594e+02 -6.3129501342773438e+01 -3.4447402954101562e+01 -1.1789900207519531e+02 -6.8767799377441406e+01 -3.4651302337646484e+01 -1.1897499847412109e+02 -6.3129501342773438e+01 -3.7221500396728516e+01 -1.1492800140380859e+02 -6.8767799377441406e+01 -3.7167098999023438e+01 -1.1652600097656250e+02 -6.3129501342773438e+01 -3.9221202850341797e+01 -1.1587300109863281e+02 -6.3129501342773438e+01 -3.9754199981689453e+01 -1.1175999450683594e+02 -6.8767799377441406e+01 -3.9429100036621094e+01 -1.1257799530029297e+02 -6.3129501342773438e+01 -4.2029102325439453e+01 -1.0841600036621094e+02 -6.8767799377441406e+01 -4.1421600341796875e+01 -1.0965699768066406e+02 -6.3129501342773438e+01 -4.3715396881103516e+01 -1.0911000061035156e+02 -6.3129501342773438e+01 -4.4031398773193359e+01 -1.0491899871826172e+02 -6.8767799377441406e+01 -4.3131298065185547e+01 -1.0549099731445312e+02 -6.3129501342773438e+01 -4.5748199462890625e+01 -1.0129299926757812e+02 -6.8767799377441406e+01 -4.4546298980712891e+01 -1.0214099884033203e+02 -6.3129501342773438e+01 -4.7018798828125000e+01 -1.0174700164794922e+02 -6.3129501342773438e+01 -4.7168300628662109e+01 -9.7561996459960938e+01 -6.8767799377441406e+01 -4.5657001495361328e+01 -9.7900596618652344e+01 -6.3129501342773438e+01 -4.8282398223876953e+01 -9.3752197265625000e+01 -6.8767799377441406e+01 -4.6455902099609375e+01 -8.2110702514648438e+01 -6.8767799377441406e+01 -4.6937301635742188e+01 -7.8023200988769531e+01 -6.3129501342773438e+01 -4.9083499908447266e+01 -7.8247894287109375e+01 -6.8767799377441406e+01 -4.6455902099609375e+01 -7.7816802978515625e+01 -6.3129501342773438e+01 -4.9041301727294922e+01 -7.4438102722167969e+01 -6.8767799377441406e+01 -4.5657001495361328e+01 -9.4183303833007812e+01 -6.3129501342773438e+01 -4.9041301727294922e+01 -9.3976898193359375e+01 -6.3129501342773438e+01 -4.9083499908447266e+01 -8.9889396667480469e+01 -6.8767799377441406e+01 -4.6937301635742188e+01 -9.0001396179199219e+01 -6.3129501342773438e+01 -4.9566101074218750e+01 -8.6000000000000000e+01 -6.8767799377441406e+01 -4.7098201751708984e+01 -8.6000000000000000e+01 -6.3129501342773438e+01 -4.9727397918701172e+01 -8.1998695373535156e+01 -6.3129501342773438e+01 -4.9566101074218750e+01 -6.7080902099609375e+01 -6.8767799377441406e+01 -4.3131298065185547e+01 -6.2890499114990234e+01 -6.3129501342773438e+01 -4.4031398773193359e+01 -6.3583702087402344e+01 -6.8767799377441406e+01 -4.1421600341796875e+01 -6.2343097686767578e+01 -6.3129501342773438e+01 -4.3715396881103516e+01 -6.0239700317382812e+01 -6.8767799377441406e+01 -3.9429100036621094e+01 -7.4099502563476562e+01 -6.3129501342773438e+01 -4.8282398223876953e+01 -7.0252998352050781e+01 -6.3129501342773438e+01 -4.7168300628662109e+01 -7.0707298278808594e+01 -6.8767799377441406e+01 -4.4546298980712891e+01 -6.9858901977539062e+01 -6.3129501342773438e+01 -4.7018798828125000e+01 -6.6508499145507812e+01 -6.3129501342773438e+01 -4.5748199462890625e+01 -5.4101200103759766e+01 -6.8767799377441406e+01 -3.4651302337646484e+01 -5.0136497497558594e+01 -6.3129501342773438e+01 -3.4447402954101562e+01 -5.1348701477050781e+01 -6.8767799377441406e+01 -3.1898698806762695e+01 -4.9437797546386719e+01 -6.3129501342773438e+01 -3.3658699035644531e+01 -4.8832901000976562e+01 -6.8767799377441406e+01 -2.8928300857543945e+01 -5.9422401428222656e+01 -6.3129501342773438e+01 -4.2029102325439453e+01 -5.6126697540283203e+01 -6.3129501342773438e+01 -3.9754199981689453e+01 -5.7071701049804688e+01 -6.8767799377441406e+01 -3.7167098999023438e+01 -5.5473800659179688e+01 -6.3129501342773438e+01 -3.9221202850341797e+01 -5.3024700164794922e+01 -6.3129501342773438e+01 -3.7221500396728516e+01 -4.4578300476074219e+01 -6.8767799377441406e+01 -2.2416299819946289e+01 -4.1073699951171875e+01 -6.3129501342773438e+01 -2.1317800521850586e+01 -4.2868698120117188e+01 -6.8767799377441406e+01 -1.8919099807739258e+01 -4.0495498657226562e+01 -6.3129501342773438e+01 -1.9960601806640625e+01 -4.1453701019287109e+01 -6.8767799377441406e+01 -1.5292799949645996e+01 -4.7480899810791016e+01 -6.3129501342773438e+01 -3.1449899673461914e+01 -4.5075099945068359e+01 -6.3129501342773438e+01 -2.8248399734497070e+01 -4.6571002960205078e+01 -6.8767799377441406e+01 -2.5760299682617188e+01 -4.4399299621582031e+01 -6.3129501342773438e+01 -2.7179599761962891e+01 -4.2934803009033203e+01 -6.3129501342773438e+01 -2.4863698959350586e+01 -3.6635200500488281e+01 -6.3129501342773438e+01 -5.9939599037170410e+00 -3.9062599182128906e+01 -6.8767799377441406e+01 -3.8893198966979980e+00 -3.9544101715087891e+01 -6.8767799377441406e+01 -7.7520599365234375e+00 -3.9504100799560547e+01 -6.3129501342773438e+01 -1.7633499145507812e+01 -3.8235900878906250e+01 -6.3129501342773438e+01 -1.3835000038146973e+01 -4.0343002319335938e+01 -6.8767799377441406e+01 -1.1561900138854980e+01 -3.7832401275634766e+01 -6.3129501342773438e+01 -1.2197899818420410e+01 -3.7277500152587891e+01 -6.3129501342773438e+01 -9.9467601776123047e+00 -3.6482501983642578e+01 -6.3129501342773438e+01 -4.1031799316406250e+00 -3.6312900543212891e+01 -6.3129501342773438e+01 -2.0023000240325928e+00 -3.8901798248291016e+01 -6.8767799377441406e+01 0.0000000000000000e+00 -3.6312900543212891e+01 -6.3129501342773438e+01 2.0023000240325928e+00 -3.9062599182128906e+01 -6.8767799377441406e+01 3.8893198966979980e+00 -3.6482501983642578e+01 -6.3129501342773438e+01 4.1031799316406250e+00 -3.6635200500488281e+01 -6.3129501342773438e+01 5.9939599037170410e+00 -3.9544101715087891e+01 -6.8767799377441406e+01 7.7520599365234375e+00 -3.7277500152587891e+01 -6.3129501342773438e+01 9.9467601776123047e+00 -4.0343002319335938e+01 -6.8767799377441406e+01 1.1561900138854980e+01 -3.7832401275634766e+01 -6.3129501342773438e+01 1.2197899818420410e+01 -3.8235900878906250e+01 -6.3129501342773438e+01 1.3835000038146973e+01 -4.1453701019287109e+01 -6.8767799377441406e+01 1.5292799949645996e+01 -3.9504100799560547e+01 -6.3129501342773438e+01 1.7633499145507812e+01 -4.2868698120117188e+01 -6.8767799377441406e+01 1.8919099807739258e+01 -4.0495498657226562e+01 -6.3129501342773438e+01 1.9960601806640625e+01 -4.1073699951171875e+01 -6.3129501342773438e+01 2.1317800521850586e+01 -4.4578300476074219e+01 -6.8767799377441406e+01 2.2416299819946289e+01 -4.2934803009033203e+01 -6.3129501342773438e+01 2.4863698959350586e+01 -4.6571002960205078e+01 -6.8767799377441406e+01 2.5760299682617188e+01 -4.4399299621582031e+01 -6.3129501342773438e+01 2.7179599761962891e+01 -4.5075099945068359e+01 -6.3129501342773438e+01 2.8248399734497070e+01 -4.8832901000976562e+01 -6.8767799377441406e+01 2.8928300857543945e+01 -4.7480899810791016e+01 -6.3129501342773438e+01 3.1449899673461914e+01 -5.1348701477050781e+01 -6.8767799377441406e+01 3.1898698806762695e+01 -4.9437797546386719e+01 -6.3129501342773438e+01 3.3658699035644531e+01 -5.0136497497558594e+01 -6.3129501342773438e+01 3.4447402954101562e+01 -5.4101200103759766e+01 -6.8767799377441406e+01 3.4651302337646484e+01 -5.3024700164794922e+01 -6.3129501342773438e+01 3.7221500396728516e+01 -5.7071701049804688e+01 -6.8767799377441406e+01 3.7167098999023438e+01 -5.5473800659179688e+01 -6.3129501342773438e+01 3.9221202850341797e+01 -5.6126697540283203e+01 -6.3129501342773438e+01 3.9754199981689453e+01 -6.0239700317382812e+01 -6.8767799377441406e+01 3.9429100036621094e+01 -5.9422401428222656e+01 -6.3129501342773438e+01 4.2029102325439453e+01 -6.3583702087402344e+01 -6.8767799377441406e+01 4.1421600341796875e+01 -6.2343097686767578e+01 -6.3129501342773438e+01 4.3715396881103516e+01 -6.2890499114990234e+01 -6.3129501342773438e+01 4.4031398773193359e+01 -6.7080902099609375e+01 -6.8767799377441406e+01 4.3131298065185547e+01 -6.6508499145507812e+01 -6.3129501342773438e+01 4.5748199462890625e+01 -7.0707298278808594e+01 -6.8767799377441406e+01 4.4546298980712891e+01 -6.9858901977539062e+01 -6.3129501342773438e+01 4.7018798828125000e+01 -7.0252998352050781e+01 -6.3129501342773438e+01 4.7168300628662109e+01 -7.4438102722167969e+01 -6.8767799377441406e+01 4.5657001495361328e+01 -7.4099502563476562e+01 -6.3129501342773438e+01 4.8282398223876953e+01 -7.8247894287109375e+01 -6.8767799377441406e+01 4.6455902099609375e+01 -7.7816802978515625e+01 -6.3129501342773438e+01 4.9041301727294922e+01 -7.8023200988769531e+01 -6.3129501342773438e+01 4.9083499908447266e+01 -8.2110702514648438e+01 -6.8767799377441406e+01 4.6937301635742188e+01 -8.1998695373535156e+01 -6.3129501342773438e+01 4.9566101074218750e+01 -8.6000000000000000e+01 -6.8767799377441406e+01 4.7098201751708984e+01 -8.6000000000000000e+01 -6.3129501342773438e+01 4.9727397918701172e+01 -9.0001396179199219e+01 -6.3129501342773438e+01 4.9566101074218750e+01 -9.8030899047851562e+01 -6.1548198699951172e+01 -4.8811100006103516e+01 -1.0191900634765625e+02 -6.1548198699951172e+01 -4.7684700012207031e+01 -1.0570500183105469e+02 -6.1548198699951172e+01 -4.6249198913574219e+01 -1.0936299896240234e+02 -6.1548198699951172e+01 -4.4513603210449219e+01 -1.1286900329589844e+02 -6.1548198699951172e+01 -4.2489299774169922e+01 -1.1620099639892578e+02 -6.1548198699951172e+01 -4.0189502716064453e+01 -1.1933699798583984e+02 -6.1548198699951172e+01 -3.7629100799560547e+01 -1.2225600433349609e+02 -6.1548198699951172e+01 -3.4824600219726562e+01 -1.2494100189208984e+02 -6.1548198699951172e+01 -3.1794298171997070e+01 -1.2737299346923828e+02 -6.1548198699951172e+01 -2.8557699203491211e+01 -1.2953700256347656e+02 -6.1548198699951172e+01 -2.5135900497436523e+01 -1.3141799926757812e+02 -6.1548198699951172e+01 -2.1551198959350586e+01 -1.3300498962402344e+02 -6.1548198699951172e+01 -1.7826700210571289e+01 -1.3428700256347656e+02 -6.1548198699951172e+01 -1.3986499786376953e+01 -1.3525601196289062e+02 -6.1548198699951172e+01 -1.0055700302124023e+01 -1.3590499877929688e+02 -6.1548198699951172e+01 -6.0595898628234863e+00 -1.3623100280761719e+02 -6.1548198699951172e+01 -2.0242300033569336e+00 -1.3590499877929688e+02 -6.1548198699951172e+01 6.0595898628234863e+00 -1.3623100280761719e+02 -6.1548198699951172e+01 2.0242300033569336e+00 -1.3525601196289062e+02 -6.1548198699951172e+01 1.0055700302124023e+01 -1.3428700256347656e+02 -6.1548198699951172e+01 1.3986499786376953e+01 -1.3141799926757812e+02 -6.1548198699951172e+01 2.1551198959350586e+01 -1.3300498962402344e+02 -6.1548198699951172e+01 1.7826700210571289e+01 -1.2953700256347656e+02 -6.1548198699951172e+01 2.5135900497436523e+01 -1.2737299346923828e+02 -6.1548198699951172e+01 2.8557699203491211e+01 -1.2225600433349609e+02 -6.1548198699951172e+01 3.4824600219726562e+01 -1.2494100189208984e+02 -6.1548198699951172e+01 3.1794298171997070e+01 -1.1933699798583984e+02 -6.1548198699951172e+01 3.7629100799560547e+01 -1.1620099639892578e+02 -6.1548198699951172e+01 4.0189502716064453e+01 -1.1286900329589844e+02 -6.1548198699951172e+01 4.2489299774169922e+01 -1.0936299896240234e+02 -6.1548198699951172e+01 4.4513603210449219e+01 -1.0570500183105469e+02 -6.1548198699951172e+01 4.6249198913574219e+01 -1.0191900634765625e+02 -6.1548198699951172e+01 4.7684700012207031e+01 -9.8030899047851562e+01 -6.1548198699951172e+01 4.8811100006103516e+01 -9.4064201354980469e+01 -6.1548198699951172e+01 4.9620899200439453e+01 -9.0045196533203125e+01 -6.1548198699951172e+01 5.0108898162841797e+01 -8.6000000000000000e+01 -6.1548198699951172e+01 5.0271900177001953e+01 -8.1954795837402344e+01 -6.1548198699951172e+01 5.0108898162841797e+01 -7.7935798645019531e+01 -6.1548198699951172e+01 4.9620899200439453e+01 -7.3969100952148438e+01 -6.1548198699951172e+01 4.8811100006103516e+01 -7.0080497741699219e+01 -6.1548198699951172e+01 4.7684700012207031e+01 -6.6295104980468750e+01 -6.1548198699951172e+01 4.6249198913574219e+01 -6.2637500762939453e+01 -6.1548198699951172e+01 4.4513603210449219e+01 -5.9131397247314453e+01 -6.1548198699951172e+01 4.2489299774169922e+01 -5.5799598693847656e+01 -6.1548198699951172e+01 4.0189502716064453e+01 -5.2663597106933594e+01 -6.1548198699951172e+01 3.7629100799560547e+01 -4.9743801116943359e+01 -6.1548198699951172e+01 3.4824600219726562e+01 -4.7059101104736328e+01 -6.1548198699951172e+01 3.1794298171997070e+01 -4.4626998901367188e+01 -6.1548198699951172e+01 2.8557699203491211e+01 -4.2463298797607422e+01 -6.1548198699951172e+01 2.5135900497436523e+01 -4.0581798553466797e+01 -6.1548198699951172e+01 2.1551198959350586e+01 -3.8994899749755859e+01 -6.1548198699951172e+01 1.7826700210571289e+01 -3.7712902069091797e+01 -6.1548198699951172e+01 1.3986499786376953e+01 -3.6744098663330078e+01 -6.1548198699951172e+01 1.0055700302124023e+01 -3.6094596862792969e+01 -6.1548198699951172e+01 6.0595898628234863e+00 -3.5768901824951172e+01 -6.1548198699951172e+01 2.0242300033569336e+00 -3.6094596862792969e+01 -6.1548198699951172e+01 -6.0595898628234863e+00 -3.5768901824951172e+01 -6.1548198699951172e+01 -2.0242300033569336e+00 -3.6744098663330078e+01 -6.1548198699951172e+01 -1.0055700302124023e+01 -3.7712902069091797e+01 -6.1548198699951172e+01 -1.3986499786376953e+01 -4.0581798553466797e+01 -6.1548198699951172e+01 -2.1551198959350586e+01 -3.8994899749755859e+01 -6.1548198699951172e+01 -1.7826700210571289e+01 -4.2463298797607422e+01 -6.1548198699951172e+01 -2.5135900497436523e+01 -4.4626998901367188e+01 -6.1548198699951172e+01 -2.8557699203491211e+01 -4.9743801116943359e+01 -6.1548198699951172e+01 -3.4824600219726562e+01 -4.7059101104736328e+01 -6.1548198699951172e+01 -3.1794298171997070e+01 -5.2663597106933594e+01 -6.1548198699951172e+01 -3.7629100799560547e+01 -5.5799598693847656e+01 -6.1548198699951172e+01 -4.0189502716064453e+01 -5.9131397247314453e+01 -6.1548198699951172e+01 -4.2489299774169922e+01 -6.2637500762939453e+01 -6.1548198699951172e+01 -4.4513603210449219e+01 -6.6295104980468750e+01 -6.1548198699951172e+01 -4.6249198913574219e+01 -7.0080497741699219e+01 -6.1548198699951172e+01 -4.7684700012207031e+01 -7.3969100952148438e+01 -6.1548198699951172e+01 -4.8811100006103516e+01 -7.7935798645019531e+01 -6.1548198699951172e+01 -4.9620899200439453e+01 -8.1954795837402344e+01 -6.1548198699951172e+01 -5.0108898162841797e+01 -8.6000000000000000e+01 -6.1548198699951172e+01 -5.0271900177001953e+01 -9.0045196533203125e+01 -6.1548198699951172e+01 -5.0108898162841797e+01 -9.4064201354980469e+01 -6.1548198699951172e+01 -4.9620899200439453e+01 -8.2243705749511719e+01 -7.0288002014160156e+01 -4.5331501007080078e+01 -8.6000000000000000e+01 -7.0288002014160156e+01 -4.5486900329589844e+01 -8.9756301879882812e+01 -7.0288002014160156e+01 -4.5331501007080078e+01 -9.3486900329589844e+01 -7.0288002014160156e+01 -4.4866600036621094e+01 -9.7166397094726562e+01 -7.0288002014160156e+01 -4.4094997406005859e+01 -1.0076999664306641e+02 -7.0288002014160156e+01 -4.3022300720214844e+01 -1.0427200317382812e+02 -7.0288002014160156e+01 -4.1655700683593750e+01 -1.0764900207519531e+02 -7.0288002014160156e+01 -4.0004600524902344e+01 -1.1087899780273438e+02 -7.0288002014160156e+01 -3.8080101013183594e+01 -1.1393900299072266e+02 -7.0288002014160156e+01 -3.5895599365234375e+01 -1.1680799865722656e+02 -7.0288002014160156e+01 -3.3465797424316406e+01 -1.1946599578857422e+02 -7.0288002014160156e+01 -3.0807399749755859e+01 -1.2189599609375000e+02 -7.0288002014160156e+01 -2.7938699722290039e+01 -1.2408000183105469e+02 -7.0288002014160156e+01 -2.4878999710083008e+01 -1.2600499725341797e+02 -7.0288002014160156e+01 -2.1649400711059570e+01 -1.2765599822998047e+02 -7.0288002014160156e+01 -1.8271900177001953e+01 -1.2902200317382812e+02 -7.0288002014160156e+01 -1.4769499778747559e+01 -1.3009500122070312e+02 -7.0288002014160156e+01 -1.1166299819946289e+01 -1.3086700439453125e+02 -7.0288002014160156e+01 -7.4868798255920410e+00 -1.3133200073242188e+02 -7.0288002014160156e+01 -3.7562201023101807e+00 -1.3148699951171875e+02 -7.0288002014160156e+01 0.0000000000000000e+00 -1.3133200073242188e+02 -7.0288002014160156e+01 3.7562201023101807e+00 -1.3086700439453125e+02 -7.0288002014160156e+01 7.4868798255920410e+00 -1.3009500122070312e+02 -7.0288002014160156e+01 1.1166299819946289e+01 -1.2902200317382812e+02 -7.0288002014160156e+01 1.4769499778747559e+01 -1.2765599822998047e+02 -7.0288002014160156e+01 1.8271900177001953e+01 -1.2600499725341797e+02 -7.0288002014160156e+01 2.1649400711059570e+01 -1.2408000183105469e+02 -7.0288002014160156e+01 2.4878999710083008e+01 -1.2189599609375000e+02 -7.0288002014160156e+01 2.7938699722290039e+01 -1.1946599578857422e+02 -7.0288002014160156e+01 3.0807399749755859e+01 -1.1680799865722656e+02 -7.0288002014160156e+01 3.3465797424316406e+01 -1.1393900299072266e+02 -7.0288002014160156e+01 3.5895599365234375e+01 -1.1087899780273438e+02 -7.0288002014160156e+01 3.8080101013183594e+01 -1.0764900207519531e+02 -7.0288002014160156e+01 4.0004600524902344e+01 -1.0427200317382812e+02 -7.0288002014160156e+01 4.1655700683593750e+01 -1.0076999664306641e+02 -7.0288002014160156e+01 4.3022300720214844e+01 -9.7166397094726562e+01 -7.0288002014160156e+01 4.4094997406005859e+01 -9.3486900329589844e+01 -7.0288002014160156e+01 4.4866600036621094e+01 -8.9756301879882812e+01 -7.0288002014160156e+01 4.5331501007080078e+01 -8.6000000000000000e+01 -7.0288002014160156e+01 4.5486900329589844e+01 -8.2243705749511719e+01 -7.0288002014160156e+01 4.5331501007080078e+01 -7.8513099670410156e+01 -7.0288002014160156e+01 4.4866600036621094e+01 -7.4833602905273438e+01 -7.0288002014160156e+01 4.4094997406005859e+01 -7.1230400085449219e+01 -7.0288002014160156e+01 4.3022300720214844e+01 -6.7728103637695312e+01 -7.0288002014160156e+01 4.1655700683593750e+01 -6.4350601196289062e+01 -7.0288002014160156e+01 4.0004600524902344e+01 -6.1121097564697266e+01 -7.0288002014160156e+01 3.8080101013183594e+01 -5.8061397552490234e+01 -7.0288002014160156e+01 3.5895599365234375e+01 -5.5192501068115234e+01 -7.0288002014160156e+01 3.3465797424316406e+01 -5.2534198760986328e+01 -7.0288002014160156e+01 3.0807399749755859e+01 -5.0104396820068359e+01 -7.0288002014160156e+01 2.7938699722290039e+01 -4.7919898986816406e+01 -7.0288002014160156e+01 2.4878999710083008e+01 -4.5995399475097656e+01 -7.0288002014160156e+01 2.1649400711059570e+01 -4.4344299316406250e+01 -7.0288002014160156e+01 1.8271900177001953e+01 -4.2977699279785156e+01 -7.0288002014160156e+01 1.4769499778747559e+01 -4.1905002593994141e+01 -7.0288002014160156e+01 1.1166299819946289e+01 -4.1133499145507812e+01 -7.0288002014160156e+01 7.4868798255920410e+00 -4.0668399810791016e+01 -7.0288002014160156e+01 3.7562201023101807e+00 -4.0513099670410156e+01 -7.0288002014160156e+01 0.0000000000000000e+00 -4.0668399810791016e+01 -7.0288002014160156e+01 -3.7562201023101807e+00 -4.1133499145507812e+01 -7.0288002014160156e+01 -7.4868798255920410e+00 -4.1905002593994141e+01 -7.0288002014160156e+01 -1.1166299819946289e+01 -4.2977699279785156e+01 -7.0288002014160156e+01 -1.4769499778747559e+01 -4.4344299316406250e+01 -7.0288002014160156e+01 -1.8271900177001953e+01 -4.5995399475097656e+01 -7.0288002014160156e+01 -2.1649400711059570e+01 -4.7919898986816406e+01 -7.0288002014160156e+01 -2.4878999710083008e+01 -5.0104396820068359e+01 -7.0288002014160156e+01 -2.7938699722290039e+01 -5.2534198760986328e+01 -7.0288002014160156e+01 -3.0807399749755859e+01 -5.5192501068115234e+01 -7.0288002014160156e+01 -3.3465797424316406e+01 -5.8061397552490234e+01 -7.0288002014160156e+01 -3.5895599365234375e+01 -6.1121097564697266e+01 -7.0288002014160156e+01 -3.8080101013183594e+01 -6.4350601196289062e+01 -7.0288002014160156e+01 -4.0004600524902344e+01 -6.7728103637695312e+01 -7.0288002014160156e+01 -4.1655700683593750e+01 -7.1230400085449219e+01 -7.0288002014160156e+01 -4.3022300720214844e+01 -7.4833602905273438e+01 -7.0288002014160156e+01 -4.4094997406005859e+01 -7.8513099670410156e+01 -7.0288002014160156e+01 -4.4866600036621094e+01 -8.2165199279785156e+01 -6.9682098388671875e+01 -4.6279399871826172e+01 -8.6000000000000000e+01 -6.9682098388671875e+01 -4.6437999725341797e+01 -8.9834899902343750e+01 -6.9682098388671875e+01 -4.6279399871826172e+01 -9.3643501281738281e+01 -6.9682098388671875e+01 -4.5804702758789062e+01 -9.7399894714355469e+01 -6.9682098388671875e+01 -4.5017101287841797e+01 -1.0107800292968750e+02 -6.9682098388671875e+01 -4.3921897888183594e+01 -1.0465399932861328e+02 -6.9682098388671875e+01 -4.2526699066162109e+01 -1.0810200500488281e+02 -6.9682098388671875e+01 -4.0840999603271484e+01 -1.1139900207519531e+02 -6.9682098388671875e+01 -3.8876399993896484e+01 -1.1452300262451172e+02 -6.9682098388671875e+01 -3.6646102905273438e+01 -1.1745200347900391e+02 -6.9682098388671875e+01 -3.4165599822998047e+01 -1.2016600036621094e+02 -6.9682098388671875e+01 -3.1451601028442383e+01 -1.2264599609375000e+02 -6.9682098388671875e+01 -2.8522800445556641e+01 -1.2487599945068359e+02 -6.9682098388671875e+01 -2.5399200439453125e+01 -1.2684099578857422e+02 -6.9682098388671875e+01 -2.2102100372314453e+01 -1.2852700805664062e+02 -6.9682098388671875e+01 -1.8653900146484375e+01 -1.2992199707031250e+02 -6.9682098388671875e+01 -1.5078400611877441e+01 -1.3101699829101562e+02 -6.9682098388671875e+01 -1.1399899482727051e+01 -1.3180500793457031e+02 -6.9682098388671875e+01 -7.6434001922607422e+00 -1.3227899169921875e+02 -6.9682098388671875e+01 -3.8347799777984619e+00 -1.3243800354003906e+02 -6.9682098388671875e+01 0.0000000000000000e+00 -1.3227899169921875e+02 -6.9682098388671875e+01 3.8347799777984619e+00 -1.3180500793457031e+02 -6.9682098388671875e+01 7.6434001922607422e+00 -1.3101699829101562e+02 -6.9682098388671875e+01 1.1399899482727051e+01 -1.2992199707031250e+02 -6.9682098388671875e+01 1.5078400611877441e+01 -1.2852700805664062e+02 -6.9682098388671875e+01 1.8653900146484375e+01 -1.2684099578857422e+02 -6.9682098388671875e+01 2.2102100372314453e+01 -1.2487599945068359e+02 -6.9682098388671875e+01 2.5399200439453125e+01 -1.2264599609375000e+02 -6.9682098388671875e+01 2.8522800445556641e+01 -1.2016600036621094e+02 -6.9682098388671875e+01 3.1451601028442383e+01 -1.1745200347900391e+02 -6.9682098388671875e+01 3.4165599822998047e+01 -1.1452300262451172e+02 -6.9682098388671875e+01 3.6646102905273438e+01 -1.1139900207519531e+02 -6.9682098388671875e+01 3.8876399993896484e+01 -1.0810200500488281e+02 -6.9682098388671875e+01 4.0840999603271484e+01 -1.0465399932861328e+02 -6.9682098388671875e+01 4.2526699066162109e+01 -1.0107800292968750e+02 -6.9682098388671875e+01 4.3921897888183594e+01 -9.7399894714355469e+01 -6.9682098388671875e+01 4.5017101287841797e+01 -9.3643501281738281e+01 -6.9682098388671875e+01 4.5804702758789062e+01 -8.9834899902343750e+01 -6.9682098388671875e+01 4.6279399871826172e+01 -8.6000000000000000e+01 -6.9682098388671875e+01 4.6437999725341797e+01 -8.2165199279785156e+01 -6.9682098388671875e+01 4.6279399871826172e+01 -7.8356597900390625e+01 -6.9682098388671875e+01 4.5804702758789062e+01 -7.4600196838378906e+01 -6.9682098388671875e+01 4.5017101287841797e+01 -7.0921600341796875e+01 -6.9682098388671875e+01 4.3921897888183594e+01 -6.7346000671386719e+01 -6.9682098388671875e+01 4.2526699066162109e+01 -6.3897998809814453e+01 -6.9682098388671875e+01 4.0840999603271484e+01 -6.0600799560546875e+01 -6.9682098388671875e+01 3.8876399993896484e+01 -5.7477199554443359e+01 -6.9682098388671875e+01 3.6646102905273438e+01 -5.4548400878906250e+01 -6.9682098388671875e+01 3.4165599822998047e+01 -5.1834400177001953e+01 -6.9682098388671875e+01 3.1451601028442383e+01 -4.9353900909423828e+01 -6.9682098388671875e+01 2.8522800445556641e+01 -4.7123600006103516e+01 -6.9682098388671875e+01 2.5399200439453125e+01 -4.5159000396728516e+01 -6.9682098388671875e+01 2.2102100372314453e+01 -4.3473300933837891e+01 -6.9682098388671875e+01 1.8653900146484375e+01 -4.2078098297119141e+01 -6.9682098388671875e+01 1.5078400611877441e+01 -4.0982997894287109e+01 -6.9682098388671875e+01 1.1399899482727051e+01 -4.0195400238037109e+01 -6.9682098388671875e+01 7.6434001922607422e+00 -3.9720600128173828e+01 -6.9682098388671875e+01 3.8347799777984619e+00 -3.9562000274658203e+01 -6.9682098388671875e+01 0.0000000000000000e+00 -3.9720600128173828e+01 -6.9682098388671875e+01 -3.8347799777984619e+00 -4.0195400238037109e+01 -6.9682098388671875e+01 -7.6434001922607422e+00 -4.0982997894287109e+01 -6.9682098388671875e+01 -1.1399899482727051e+01 -4.2078098297119141e+01 -6.9682098388671875e+01 -1.5078400611877441e+01 -4.3473300933837891e+01 -6.9682098388671875e+01 -1.8653900146484375e+01 -4.5159000396728516e+01 -6.9682098388671875e+01 -2.2102100372314453e+01 -4.7123600006103516e+01 -6.9682098388671875e+01 -2.5399200439453125e+01 -4.9353900909423828e+01 -6.9682098388671875e+01 -2.8522800445556641e+01 -5.1834400177001953e+01 -6.9682098388671875e+01 -3.1451601028442383e+01 -5.4548400878906250e+01 -6.9682098388671875e+01 -3.4165599822998047e+01 -5.7477199554443359e+01 -6.9682098388671875e+01 -3.6646102905273438e+01 -6.0600799560546875e+01 -6.9682098388671875e+01 -3.8876399993896484e+01 -6.3897998809814453e+01 -6.9682098388671875e+01 -4.0840999603271484e+01 -6.7346000671386719e+01 -6.9682098388671875e+01 -4.2526699066162109e+01 -7.0921600341796875e+01 -6.9682098388671875e+01 -4.3921897888183594e+01 -7.4600196838378906e+01 -6.9682098388671875e+01 -4.5017101287841797e+01 -7.8356597900390625e+01 -6.9682098388671875e+01 -4.5804702758789062e+01 -2.6700000000000000e+02 -4.9321701049804688e+01 4.1978297233581543e+00 -2.6700000000000000e+02 -5.1290798187255859e+01 8.5588703155517578e+00 -2.6700000000000000e+02 -4.7902801513671875e+01 1.2472899436950684e+01 -2.6700000000000000e+02 -4.9182498931884766e+01 1.6884300231933594e+01 -2.6700000000000000e+02 -4.5105800628662109e+01 2.0389101028442383e+01 -2.6700000000000000e+02 -4.5732597351074219e+01 2.4749200820922852e+01 -2.6700000000000000e+02 -4.1011199951171875e+01 2.7718700408935547e+01 -2.6700000000000000e+02 -4.1035297393798828e+01 3.1938999176025391e+01 -2.6700000000000000e+02 -3.5736801147460938e+01 3.4250999450683594e+01 -2.6700000000000000e+02 -3.5218601226806641e+01 3.8257598876953125e+01 -2.6700000000000000e+02 -2.9434299468994141e+01 3.9797801971435547e+01 -2.6700000000000000e+02 -2.8441301345825195e+01 4.3532600402832031e+01 -2.6700000000000000e+02 -2.2284999847412109e+01 4.4199798583984375e+01 -2.6700000000000000e+02 -2.0888099670410156e+01 4.7620201110839844e+01 -2.6700000000000000e+02 -1.4494700431823730e+01 4.7330200195312500e+01 -2.6700000000000000e+02 -1.2765199661254883e+01 5.0408798217773438e+01 -2.6700000000000000e+02 -6.2873401641845703e+00 4.9098999023437500e+01 -2.6700000000000000e+02 -4.2941002845764160e+00 5.1822402954101562e+01 -2.6700000000000000e+02 2.1008200645446777e+00 4.9455402374267578e+01 -2.6700000000000000e+02 4.2941002845764160e+00 5.1822402954101562e+01 -2.6700000000000000e+02 1.0428600311279297e+01 4.8388999938964844e+01 -2.6700000000000000e+02 1.2765199661254883e+01 5.0408798217773438e+01 -2.6700000000000000e+02 1.8456399917602539e+01 4.5930500030517578e+01 -2.6700000000000000e+02 2.0888099670410156e+01 4.7620201110839844e+01 -2.6700000000000000e+02 2.5953199386596680e+01 4.2150699615478516e+01 -2.6700000000000000e+02 2.8441301345825195e+01 4.3532600402832031e+01 -2.6700000000000000e+02 3.2703399658203125e+01 3.7158298492431641e+01 -2.6700000000000000e+02 3.5218601226806641e+01 3.8257598876953125e+01 -2.6700000000000000e+02 3.8512798309326172e+01 3.1096899032592773e+01 -2.6700000000000000e+02 4.1035297393798828e+01 3.1938999176025391e+01 -2.6700000000000000e+02 4.3214199066162109e+01 2.4140899658203125e+01 -2.6700000000000000e+02 4.5732597351074219e+01 2.4749200820922852e+01 -2.6700000000000000e+02 4.6672401428222656e+01 1.6490400314331055e+01 -2.6700000000000000e+02 4.9182498931884766e+01 1.6884300231933594e+01 -2.6700000000000000e+02 4.8787998199462891e+01 8.3655099868774414e+00 -2.6700000000000000e+02 5.1290798187255859e+01 8.5588703155517578e+00 -2.6700000000000000e+02 4.9500000000000000e+01 0.0000000000000000e+00 -2.6700000000000000e+02 5.2000000000000000e+01 0.0000000000000000e+00 -2.6700000000000000e+02 4.8787998199462891e+01 -8.3655099868774414e+00 -2.6700000000000000e+02 5.1290798187255859e+01 -8.5588703155517578e+00 -2.6700000000000000e+02 4.6672401428222656e+01 -1.6490400314331055e+01 -2.6700000000000000e+02 4.9182498931884766e+01 -1.6884300231933594e+01 -2.6700000000000000e+02 4.3214199066162109e+01 -2.4140899658203125e+01 -2.6700000000000000e+02 4.5732597351074219e+01 -2.4749200820922852e+01 -2.6700000000000000e+02 3.8512798309326172e+01 -3.1096899032592773e+01 -2.6700000000000000e+02 4.1035297393798828e+01 -3.1938999176025391e+01 -2.6700000000000000e+02 3.2703399658203125e+01 -3.7158298492431641e+01 -2.6700000000000000e+02 3.5218601226806641e+01 -3.8257598876953125e+01 -2.6700000000000000e+02 2.5953199386596680e+01 -4.2150699615478516e+01 -2.6700000000000000e+02 2.8441301345825195e+01 -4.3532600402832031e+01 -2.6700000000000000e+02 1.8456399917602539e+01 -4.5930500030517578e+01 -2.6700000000000000e+02 2.0888099670410156e+01 -4.7620201110839844e+01 -2.6700000000000000e+02 1.0428600311279297e+01 -4.8388999938964844e+01 -2.6700000000000000e+02 1.2765199661254883e+01 -5.0408798217773438e+01 -2.6700000000000000e+02 2.1008200645446777e+00 -4.9455402374267578e+01 -2.6700000000000000e+02 4.2941002845764160e+00 -5.1822402954101562e+01 -2.6700000000000000e+02 -6.2873401641845703e+00 -4.9098999023437500e+01 -2.6700000000000000e+02 -4.2941002845764160e+00 -5.1822402954101562e+01 -2.6700000000000000e+02 -1.4494700431823730e+01 -4.7330200195312500e+01 -2.6700000000000000e+02 -1.2765199661254883e+01 -5.0408798217773438e+01 -2.6700000000000000e+02 -2.2284999847412109e+01 -4.4199798583984375e+01 -2.6700000000000000e+02 -2.0888099670410156e+01 -4.7620201110839844e+01 -2.6700000000000000e+02 -2.9434299468994141e+01 -3.9797801971435547e+01 -2.6700000000000000e+02 -2.8441301345825195e+01 -4.3532600402832031e+01 -2.6700000000000000e+02 -3.5736801147460938e+01 -3.4250999450683594e+01 -2.6700000000000000e+02 -3.5218601226806641e+01 -3.8257598876953125e+01 -2.6700000000000000e+02 -4.1011199951171875e+01 -2.7718700408935547e+01 -2.6700000000000000e+02 -4.1035297393798828e+01 -3.1938999176025391e+01 -2.6700000000000000e+02 -4.5105800628662109e+01 -2.0389101028442383e+01 -2.6700000000000000e+02 -4.5732597351074219e+01 -2.4749200820922852e+01 -2.6700000000000000e+02 -4.7902801513671875e+01 -1.2472899436950684e+01 -2.6700000000000000e+02 -4.9182498931884766e+01 -1.6884300231933594e+01 -2.6700000000000000e+02 -4.9321701049804688e+01 -4.1978297233581543e+00 -2.6700000000000000e+02 -5.1290798187255859e+01 -8.5588703155517578e+00 -2.6700000000000000e+02 -4.9500000000000000e+01 0.0000000000000000e+00 -2.6700000000000000e+02 -5.2000000000000000e+01 0.0000000000000000e+00 -2.2200000000000000e+02 4.3214199066162109e+01 2.4140899658203125e+01 -2.2200000000000000e+02 4.5732597351074219e+01 2.4749200820922852e+01 -2.2200000000000000e+02 3.8512798309326172e+01 3.1096899032592773e+01 -2.2200000000000000e+02 4.1035297393798828e+01 3.1938999176025391e+01 -2.2200000000000000e+02 3.2703399658203125e+01 3.7158298492431641e+01 -2.2200000000000000e+02 3.5218601226806641e+01 3.8257598876953125e+01 -2.2200000000000000e+02 2.5953199386596680e+01 4.2150699615478516e+01 -2.2200000000000000e+02 2.8441301345825195e+01 4.3532600402832031e+01 -2.2200000000000000e+02 1.8456399917602539e+01 4.5930500030517578e+01 -2.2200000000000000e+02 2.0888099670410156e+01 4.7620201110839844e+01 -2.2200000000000000e+02 1.0428600311279297e+01 4.8388999938964844e+01 -2.2200000000000000e+02 1.2765199661254883e+01 5.0408798217773438e+01 -2.2200000000000000e+02 2.1008200645446777e+00 4.9455402374267578e+01 -2.2200000000000000e+02 4.2941002845764160e+00 5.1822402954101562e+01 -2.2200000000000000e+02 -6.2873401641845703e+00 4.9098999023437500e+01 -2.2200000000000000e+02 -4.2941002845764160e+00 5.1822402954101562e+01 -2.2200000000000000e+02 -1.4494700431823730e+01 4.7330200195312500e+01 -2.2200000000000000e+02 -1.2765199661254883e+01 5.0408798217773438e+01 -2.2200000000000000e+02 -2.2284999847412109e+01 4.4199798583984375e+01 -2.2200000000000000e+02 -2.0888099670410156e+01 4.7620201110839844e+01 -2.2200000000000000e+02 -2.9434299468994141e+01 3.9797801971435547e+01 -2.2200000000000000e+02 -2.8441301345825195e+01 4.3532600402832031e+01 -2.2200000000000000e+02 -3.5736801147460938e+01 3.4250999450683594e+01 -2.2200000000000000e+02 -3.5218601226806641e+01 3.8257598876953125e+01 -2.2200000000000000e+02 -4.1011199951171875e+01 2.7718700408935547e+01 -2.2200000000000000e+02 -4.1035297393798828e+01 3.1938999176025391e+01 -2.2200000000000000e+02 -4.5105800628662109e+01 2.0389101028442383e+01 -2.2200000000000000e+02 -4.5732597351074219e+01 2.4749200820922852e+01 -2.2200000000000000e+02 -4.7902801513671875e+01 1.2472899436950684e+01 -2.2200000000000000e+02 -4.9182498931884766e+01 1.6884300231933594e+01 -2.2200000000000000e+02 -4.9321701049804688e+01 4.1978297233581543e+00 -2.2200000000000000e+02 -5.1290798187255859e+01 8.5588703155517578e+00 -2.2200000000000000e+02 -4.9500000000000000e+01 0.0000000000000000e+00 -2.2200000000000000e+02 -5.2000000000000000e+01 0.0000000000000000e+00 -2.2200000000000000e+02 -4.9321701049804688e+01 -4.1978297233581543e+00 -2.2200000000000000e+02 -5.1290798187255859e+01 -8.5588703155517578e+00 -2.2200000000000000e+02 -4.7902801513671875e+01 -1.2472899436950684e+01 -2.2200000000000000e+02 -4.9182498931884766e+01 -1.6884300231933594e+01 -2.2200000000000000e+02 -4.5105800628662109e+01 -2.0389101028442383e+01 -2.2200000000000000e+02 -4.5732597351074219e+01 -2.4749200820922852e+01 -2.2200000000000000e+02 -4.1011199951171875e+01 -2.7718700408935547e+01 -2.2200000000000000e+02 -4.1035297393798828e+01 -3.1938999176025391e+01 -2.2200000000000000e+02 -3.5736801147460938e+01 -3.4250999450683594e+01 -2.2200000000000000e+02 -3.5218601226806641e+01 -3.8257598876953125e+01 -2.2200000000000000e+02 -2.9434299468994141e+01 -3.9797801971435547e+01 -2.2200000000000000e+02 -2.8441301345825195e+01 -4.3532600402832031e+01 -2.2200000000000000e+02 -2.2284999847412109e+01 -4.4199798583984375e+01 -2.2200000000000000e+02 -2.0888099670410156e+01 -4.7620201110839844e+01 -2.2200000000000000e+02 -1.4494700431823730e+01 -4.7330200195312500e+01 -2.2200000000000000e+02 -1.2765199661254883e+01 -5.0408798217773438e+01 -2.2200000000000000e+02 -6.2873401641845703e+00 -4.9098999023437500e+01 -2.2200000000000000e+02 -4.2941002845764160e+00 -5.1822402954101562e+01 -2.2200000000000000e+02 2.1008200645446777e+00 -4.9455402374267578e+01 -2.2200000000000000e+02 4.2941002845764160e+00 -5.1822402954101562e+01 -2.2200000000000000e+02 1.0428600311279297e+01 -4.8388999938964844e+01 -2.2200000000000000e+02 1.2765199661254883e+01 -5.0408798217773438e+01 -2.2200000000000000e+02 1.8456399917602539e+01 -4.5930500030517578e+01 -2.2200000000000000e+02 2.0888099670410156e+01 -4.7620201110839844e+01 -2.2200000000000000e+02 2.5953199386596680e+01 -4.2150699615478516e+01 -2.2200000000000000e+02 2.8441301345825195e+01 -4.3532600402832031e+01 -2.2200000000000000e+02 3.2703399658203125e+01 -3.7158298492431641e+01 -2.2200000000000000e+02 3.5218601226806641e+01 -3.8257598876953125e+01 -2.2200000000000000e+02 3.8512798309326172e+01 -3.1096899032592773e+01 -2.2200000000000000e+02 4.1035297393798828e+01 -3.1938999176025391e+01 -2.2200000000000000e+02 4.3214199066162109e+01 -2.4140899658203125e+01 -2.2200000000000000e+02 4.5732597351074219e+01 -2.4749200820922852e+01 -2.2200000000000000e+02 4.6672401428222656e+01 -1.6490400314331055e+01 -2.2200000000000000e+02 4.9182498931884766e+01 -1.6884300231933594e+01 -2.2200000000000000e+02 4.8787998199462891e+01 -8.3655099868774414e+00 -2.2200000000000000e+02 5.1290798187255859e+01 -8.5588703155517578e+00 -2.2200000000000000e+02 4.9500000000000000e+01 0.0000000000000000e+00 -2.2200000000000000e+02 5.2000000000000000e+01 0.0000000000000000e+00 -2.2200000000000000e+02 4.8787998199462891e+01 8.3655099868774414e+00 -2.2200000000000000e+02 5.1290798187255859e+01 8.5588703155517578e+00 -2.2200000000000000e+02 4.6672401428222656e+01 1.6490400314331055e+01 -2.2200000000000000e+02 4.9182498931884766e+01 1.6884300231933594e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 12756 -> 48 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 4.2941002175211906e+00 -5.1822401583194733e+01) (float-vector -2.6699998974800110e+02 -2.0888099446892738e+01 -4.7620199620723724e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 -5.2000001072883606e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 5.2000001072883606e+01) (float-vector -2.6699998974800110e+02 -4.2941002175211906e+00 5.1822401583194733e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 5.1715098321437836e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 -5.1715098321437836e+01) (float-vector -2.6699998974800110e+02 4.2941002175211906e+00 -5.1822401583194733e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 -5.2000001072883606e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 5.2000001072883606e+01) (float-vector -2.6699998974800110e+02 -2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 -4.2941002175211906e+00 5.1822401583194733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 -4.2941002175211906e+00 5.1822401583194733e+01) (float-vector -2.6699998974800110e+02 2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 5.1715098321437836e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0129299759864807e+02 -6.8767800927162170e+01 -4.4546298682689667e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 -5.2000001072883606e+01) (float-vector -2.6699998974800110e+02 -2.0888099446892738e+01 -4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 -3.5218600183725357e+01 -3.8257598876953125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1605700105428696e+02 -7.0499897003173828e+01 -3.2650899142026901e+01) (float-vector -1.0129299759864807e+02 -6.8767800927162170e+01 -4.4546298682689667e+01) (float-vector -2.6699998974800110e+02 -3.5218600183725357e+01 -3.8257598876953125e+01) (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 -1.6884300857782364e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0107800364494324e+02 -6.9682098925113678e+01 4.3921899050474167e+01) (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 -3.5218600183725357e+01 3.8257598876953125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 -2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 5.2000001072883606e+01) (float-vector -7.4833601713180542e+01 -7.0288002490997314e+01 4.4094998389482498e+01) (float-vector -1.0107800364494324e+02 -6.9682098925113678e+01 4.3921899050474167e+01) (float-vector -2.6699998974800110e+02 -3.5218600183725357e+01 3.8257598876953125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1775199472904205e+02 3.8643501698970795e+01 -3.4794699400663376e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 -5.1715098321437836e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 -4.2408499866724014e+01) (float-vector -2.1387000381946564e+02 4.8968799412250519e+01 -1.5910899266600609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.1775199472904205e+02 4.2068801820278168e+01 3.0564799904823303e+01) (float-vector -2.6699998974800110e+02 3.5218600183725357e+01 3.8257598876953125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1775199472904205e+02 4.2068801820278168e+01 3.0564799904823303e+01) (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.1387000381946564e+02 5.1206801086664200e+01 5.3820000030100346e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1387000381946564e+02 5.1206801086664200e+01 5.3820000030100346e+00) (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -2.2050000727176666e+02 5.2000001072883606e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1775199472904205e+02 4.2068801820278168e+01 3.0564799904823303e+01) (float-vector -2.1775199472904205e+02 3.0564799904823303e+01 4.2068801820278168e+01) (float-vector -2.6699998974800110e+02 3.5218600183725357e+01 3.8257598876953125e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1775199472904205e+02 3.0564799904823303e+01 4.2068801820278168e+01) (float-vector -2.1775199472904205e+02 4.2068801820278168e+01 3.0564799904823303e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 4.2408499866724014e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 5.1715098321437836e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 3.5218600183725357e+01 3.8257598876953125e+01) (float-vector -2.1775199472904205e+02 3.0564799904823303e+01 4.2068801820278168e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 5.1715098321437836e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7787599265575409e+01 3.4999800845980644e+00 2.9048299416899681e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 4.2408499866724014e+01) (float-vector -2.1775199472904205e+02 4.2068801820278168e+01 3.0564799904823303e+01) (float-vector -2.1387000381946564e+02 5.1206801086664200e+01 5.3820000030100346e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0107800364494324e+02 -6.9682098925113678e+01 4.3921899050474167e+01) (float-vector -1.2902100384235382e+02 -7.0499897003173828e+01 1.0894499719142914e+01) (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 1.6884300857782364e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -1.2902100384235382e+02 -7.0499897003173828e+01 1.0894499719142914e+01) (float-vector -1.1605700105428696e+02 -7.0499897003173828e+01 -3.2650899142026901e+01) (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 -1.6884300857782364e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1775199472904205e+02 3.8643501698970795e+01 -3.4794699400663376e+01) (float-vector -2.1775199472904205e+02 2.1150300279259682e+01 -4.7504398971796036e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 -5.1715098321437836e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1387000381946564e+02 4.8968799412250519e+01 -1.5910899266600609e+01) (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 -1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 4.1035298258066177e+01 -3.1938999891281128e+01) (float-vector -2.1775199472904205e+02 3.8643501698970795e+01 -3.4794699400663376e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 -1.6884300857782364e+01) (float-vector -2.1387000381946564e+02 4.8968799412250519e+01 -1.5910899266600609e+01) (float-vector -2.2050000727176666e+02 5.2000001072883606e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 4.7504398971796036e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 5.2000001072883606e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 5.1715098321437836e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 4.7504398971796036e+01) (float-vector -6.0600798577070236e+01 -6.9682098925113678e+01 3.8876399397850037e+01) (float-vector -7.4833601713180542e+01 -7.0288002490997314e+01 4.4094998389482498e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 5.2000001072883606e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 -4.2941002175211906e+00 5.1822401583194733e+01) (float-vector -2.6699998974800110e+02 -2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 -3.5218600183725357e+01 3.8257598876953125e+01) (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 -4.9182500690221786e+01 -1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 -3.5218600183725357e+01 -3.8257598876953125e+01) (float-vector -2.6699998974800110e+02 -2.0888099446892738e+01 -4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 4.2941002175211906e+00 -5.1822401583194733e+01) (float-vector -2.6699998974800110e+02 2.0888099446892738e+01 -4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 4.1035298258066177e+01 -3.1938999891281128e+01) (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 -1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -2.6699998974800110e+02 4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.6699998974800110e+02 3.5218600183725357e+01 3.8257598876953125e+01) (float-vector -2.6699998974800110e+02 2.0888099446892738e+01 4.7620199620723724e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 -5.1715098321437836e+01) (float-vector -2.1775199472904205e+02 2.1150300279259682e+01 -4.7504398971796036e+01) (float-vector -2.6699998974800110e+02 2.0888099446892738e+01 -4.7620199620723724e+01) (float-vector -2.6699998974800110e+02 4.2941002175211906e+00 -5.1822401583194733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6699998974800110e+02 2.0888099446892738e+01 -4.7620199620723724e+01) (float-vector -2.1775199472904205e+02 2.1150300279259682e+01 -4.7504398971796036e+01) (float-vector -2.1775199472904205e+02 3.8643501698970795e+01 -3.4794699400663376e+01) (float-vector -2.6699998974800110e+02 4.1035298258066177e+01 -3.1938999891281128e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3931100517511368e+01 -5.7999998331069946e+01 3.0564799904823303e+01) (float-vector -4.7480899840593338e+01 -6.3129499554634094e+01 3.1449899077415466e+01) (float-vector -4.7919899225234985e+01 -7.0288002490997314e+01 2.4878999218344688e+01) (float-vector -6.0600798577070236e+01 -6.9682098925113678e+01 3.8876399397850037e+01) (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 4.7504398971796036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.5136401653289795e+01 -5.7999998331069946e+01 1.0811399668455124e+01) (float-vector -4.7480899840593338e+01 -6.3129499554634094e+01 3.1449899077415466e+01) (float-vector -4.3931100517511368e+01 -5.7999998331069946e+01 3.0564799904823303e+01) (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 2.1150300279259682e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3931100517511368e+01 -5.7999998331069946e+01 3.0564799904823303e+01) (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 4.7504398971796036e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 5.1715098321437836e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 4.2408499866724014e+01) (float-vector -4.7787599265575409e+01 3.4999800845980644e+00 2.9048299416899681e+01) (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 2.1150300279259682e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4284900873899460e+01 -5.7999998331069946e+01 -5.4354700259864330e+00) (float-vector -3.5136401653289795e+01 -5.7999998331069946e+01 1.0811399668455124e+01) (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 2.1150300279259682e+01) (float-vector -3.4000001847743988e+01 -5.0000002374872565e-01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0129299759864807e+02 -6.8767800927162170e+01 -4.4546298682689667e+01) (float-vector -7.8356601297855377e+01 -6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 -5.2000001072883606e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8356601297855377e+01 -6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 -4.7504398971796036e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 -5.2000001072883606e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.8356601297855377e+01 -6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -4.7123599797487259e+01 -6.9682098925113678e+01 -2.5399200618267059e+01) (float-vector -4.5075099915266037e+01 -6.3129499554634094e+01 -2.8248399496078491e+01) (float-vector -5.1205199211835861e+01 -5.7999998331069946e+01 -3.8643501698970795e+01) (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 -4.7504398971796036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4284900873899460e+01 -5.7999998331069946e+01 -5.4354700259864330e+00) (float-vector -3.8495700806379318e+01 -5.7999998331069946e+01 -2.1150300279259682e+01) (float-vector -4.5075099915266037e+01 -6.3129499554634094e+01 -2.8248399496078491e+01) (float-vector -4.7123599797487259e+01 -6.9682098925113678e+01 -2.5399200618267059e+01) (float-vector -3.9544101804494858e+01 -6.8767800927162170e+01 -7.7520599588751793e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2436398565769196e+01 3.4999800845980644e+00 -2.0154599100351334e+01) (float-vector -2.1387000381946564e+02 5.1206801086664200e+01 5.3820000030100346e+00) (float-vector -2.2050000727176666e+02 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -2.1387000381946564e+02 4.8968799412250519e+01 -1.5910899266600609e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3931100517511368e+01 -5.0000002374872565e-01 -3.0564799904823303e+01) (float-vector -4.2436398565769196e+01 3.4999800845980644e+00 -2.0154599100351334e+01) (float-vector -2.1387000381946564e+02 4.8968799412250519e+01 -1.5910899266600609e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 -4.2408499866724014e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2436398565769196e+01 3.4999800845980644e+00 -2.0154599100351334e+01) (float-vector -3.4000001847743988e+01 -5.0000002374872565e-01 0.0000000000000000e+00) (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 2.1150300279259682e+01) (float-vector -4.7787599265575409e+01 3.4999800845980644e+00 2.9048299416899681e+01) (float-vector -2.1387000381946564e+02 5.1206801086664200e+01 5.3820000030100346e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -5.0000002374872565e-01 -4.5033298432826996e+01) (float-vector -4.3931100517511368e+01 -5.0000002374872565e-01 -3.0564799904823303e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 -4.2408499866724014e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 -5.1715098321437836e+01) (float-vector -5.9999998658895493e+01 -5.0000002374872565e-01 -4.5033298432826996e+01) (float-vector -6.3516400754451752e+01 3.4999800845980644e+00 -4.2408499866724014e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -5.0000002374872565e-01 -4.5033298432826996e+01) (float-vector -8.0564603209495544e+01 -5.0000002374872565e-01 -5.1715098321437836e+01) (float-vector -8.6000002920627594e+01 -5.7999998331069946e+01 -5.2000001072883606e+01) (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 -4.7504398971796036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9999998658895493e+01 -5.0000002374872565e-01 -4.5033298432826996e+01) (float-vector -6.4849697053432465e+01 -5.7999998331069946e+01 -4.7504398971796036e+01) (float-vector -5.1205199211835861e+01 -5.7999998331069946e+01 -3.8643501698970795e+01) (float-vector -4.3931100517511368e+01 -5.0000002374872565e-01 -3.0564799904823303e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2902100384235382e+02 -7.0499897003173828e+01 1.0894499719142914e+01) (float-vector -1.0107800364494324e+02 -6.9682098925113678e+01 4.3921899050474167e+01) (float-vector -7.4833601713180542e+01 -7.0288002490997314e+01 4.4094998389482498e+01) (float-vector -6.0600798577070236e+01 -6.9682098925113678e+01 3.8876399397850037e+01) (float-vector -4.7919899225234985e+01 -7.0288002490997314e+01 2.4878999218344688e+01) (float-vector -4.0982998907566071e+01 -6.9682098925113678e+01 1.1399899609386921e+01) (float-vector -3.9544101804494858e+01 -6.8767800927162170e+01 -7.7520599588751793e+00) (float-vector -4.7123599797487259e+01 -6.9682098925113678e+01 -2.5399200618267059e+01) (float-vector -7.8356601297855377e+01 -6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -1.0129299759864807e+02 -6.8767800927162170e+01 -4.4546298682689667e+01) (float-vector -1.1605700105428696e+02 -7.0499897003173828e+01 -3.2650899142026901e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0982998907566071e+01 -6.9682098925113678e+01 1.1399899609386921e+01) (float-vector -3.5136401653289795e+01 -5.7999998331069946e+01 1.0811399668455124e+01) (float-vector -3.4284900873899460e+01 -5.7999998331069946e+01 -5.4354700259864330e+00) (float-vector -3.9544101804494858e+01 -6.8767800927162170e+01 -7.7520599588751793e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.0982998907566071e+01 -6.9682098925113678e+01 1.1399899609386921e+01) (float-vector -4.7919899225234985e+01 -7.0288002490997314e+01 2.4878999218344688e+01) (float-vector -4.7480899840593338e+01 -6.3129499554634094e+01 3.1449899077415466e+01) (float-vector -3.5136401653289795e+01 -5.7999998331069946e+01 1.0811399668455124e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8495700806379318e+01 -5.7999998331069946e+01 -2.1150300279259682e+01) (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 -2.1150300279259682e+01) (float-vector -4.3931100517511368e+01 -5.0000002374872565e-01 -3.0564799904823303e+01) (float-vector -5.1205199211835861e+01 -5.7999998331069946e+01 -3.8643501698970795e+01) (float-vector -4.5075099915266037e+01 -6.3129499554634094e+01 -2.8248399496078491e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 -2.1150300279259682e+01) (float-vector -3.8495700806379318e+01 -5.7999998331069946e+01 -2.1150300279259682e+01) (float-vector -3.4284900873899460e+01 -5.7999998331069946e+01 -5.4354700259864330e+00) (float-vector -3.4000001847743988e+01 -5.0000002374872565e-01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.3931100517511368e+01 -5.0000002374872565e-01 -3.0564799904823303e+01) (float-vector -3.8495700806379318e+01 -5.0000002374872565e-01 -2.1150300279259682e+01) (float-vector -3.4000001847743988e+01 -5.0000002374872565e-01 0.0000000000000000e+00) (float-vector -4.2436398565769196e+01 3.4999800845980644e+00 -2.0154599100351334e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_upperarm_roll_link_avRI5Z.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_elbow_flex_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.3300000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 2 14 0 0 14 15 0 15 16 16 22 0 0 22 23 0 23 24 24 25 0 0 25 26 0 26 27 1104 1 0 1104 0 1102 1102 0 27 1098 26 25 1098 25 1096 1096 25 24 1100 27 26 1100 26 1098 1102 27 1100 1100 1101 1102 1102 1101 1103 1102 1103 1104 1098 1099 1100 1100 1099 1101 1096 1097 1098 1098 1097 1099 1094 1095 1096 1096 1095 1097 1096 24 1094 174 1099 1097 1095 170 1097 1097 170 172 1097 172 174 172 173 174 174 173 175 174 175 176 174 176 1099 170 171 172 172 171 173 168 169 170 170 169 171 1095 168 170 662 173 171 662 171 663 663 171 169 638 175 173 638 173 662 640 638 662 640 662 639 639 662 663 663 169 664 639 663 642 642 663 664 168 167 169 664 169 167 664 167 665 642 664 641 641 664 665 641 580 642 642 580 575 642 575 639 644 583 641 641 583 581 641 581 580 641 665 644 575 580 576 576 580 581 574 573 575 574 575 576 639 575 573 576 581 582 574 576 759 576 582 759 582 581 583 582 583 578 582 578 760 759 582 760 577 578 579 578 583 584 578 584 579 578 577 760 760 577 761 760 761 795 759 760 776 776 760 795 795 761 793 795 793 796 776 795 774 774 795 796 774 775 776 776 775 777 776 777 759 726 725 774 774 725 775 774 796 726 725 724 775 775 724 770 775 770 777 710 724 725 725 726 710 710 726 727 726 796 727 710 727 717 796 794 727 727 794 717 717 716 710 717 718 716 794 792 717 717 792 718 793 791 794 794 791 792 796 793 794 791 789 792 792 789 790 792 790 718 716 718 719 718 790 719 789 787 790 790 787 788 790 788 719 763 764 789 789 764 787 791 763 789 764 765 787 787 765 785 787 785 788 788 785 786 788 786 720 719 788 720 716 719 720 720 721 716 720 786 721 785 783 786 786 783 784 786 784 721 765 766 785 785 766 783 766 767 783 783 767 782 783 782 784 784 782 768 784 768 722 721 784 722 716 721 722 716 722 714 722 768 714 768 769 714 782 771 768 768 771 773 768 773 769 767 778 782 782 778 771 771 772 773 778 779 771 772 771 780 780 771 779 772 839 773 773 839 840 773 840 769 780 838 772 772 838 839 780 779 781 781 837 780 780 837 838 838 837 906 839 838 905 905 838 906 840 839 905 769 840 715 715 840 909 909 840 905 905 906 908 909 905 910 910 905 908 910 730 909 732 715 909 732 909 731 731 909 730 910 908 798 798 728 910 728 729 910 910 729 730 729 706 730 730 706 707 730 707 731 731 707 708 731 708 732 706 403 707 707 403 401 707 401 708 705 403 706 729 705 706 728 705 729 711 705 728 711 728 798 525 405 705 705 405 403 525 705 711 402 401 403 402 403 404 404 403 405 524 404 405 524 405 525 711 712 525 525 712 713 525 713 524 797 712 711 711 798 797 736 734 712 712 734 713 736 712 797 734 704 713 713 704 524 733 703 734 734 703 704 736 733 734 735 733 736 735 736 881 736 797 881 314 212 733 733 212 703 735 314 733 212 214 703 703 214 699 703 699 704 212 213 214 212 314 213 213 314 315 315 314 735 882 315 735 735 881 882 213 315 309 309 315 316 882 316 315 308 309 310 309 316 310 308 1044 309 309 1044 1042 309 1042 213 310 316 882 310 311 308 310 882 311 308 311 312 311 882 884 311 884 312 308 312 299 299 312 313 312 884 842 312 842 313 882 883 884 884 883 841 884 841 842 842 841 843 845 313 842 842 843 845 299 313 305 845 305 313 844 305 845 845 843 846 845 846 844 841 811 843 843 811 812 843 812 846 841 802 811 883 802 841 802 804 811 811 804 808 811 808 812 812 808 810 846 812 810 846 810 847 844 846 847 808 809 810 847 810 809 847 809 848 844 847 855 855 847 848 809 808 813 809 813 848 848 813 815 848 815 849 855 848 854 854 848 849 854 300 855 855 300 307 855 307 844 853 301 854 854 301 300 854 849 853 299 300 285 285 300 301 299 307 300 299 306 307 844 307 306 844 306 305 305 306 299 285 1048 299 299 1048 1046 299 1046 308 1047 1046 1048 1047 1048 1049 1049 1048 1050 285 1050 1048 1045 1044 1046 1045 1046 1047 308 1046 1044 1076 1045 1047 1076 1047 1081 1081 1047 1049 1049 1050 1051 1081 1049 1069 1069 1049 1051 1071 1076 1081 1071 1081 1069 1069 1070 1071 1069 1051 1070 1051 1050 1052 1051 1052 1053 1070 1051 1053 1070 1053 1071 1077 1076 1071 1071 1053 999 1071 999 1077 1053 1052 997 1053 997 999 318 997 1052 318 1052 284 284 1052 1050 997 998 999 321 998 997 321 997 318 999 998 1000 324 1000 998 324 998 321 318 320 321 320 322 321 321 322 323 321 323 324 323 325 324 324 325 326 324 326 327 327 1000 324 325 323 196 196 323 322 196 322 197 197 322 320 318 319 320 197 320 319 186 196 197 197 201 186 319 201 197 186 195 196 325 196 195 195 326 325 191 195 186 191 328 195 195 328 326 186 190 191 331 191 190 331 329 191 191 329 328 326 328 327 327 328 329 327 329 330 329 331 330 330 331 332 190 332 331 330 332 333 333 1004 330 330 1004 1002 330 1002 327 327 1002 1000 1001 1000 1002 1001 1002 1003 1003 1002 1004 1003 1004 1005 1005 1004 1006 333 1006 1004 1055 1001 1003 1055 1003 1056 1056 1003 1005 999 1000 1001 1077 999 1001 1077 1001 1055 1055 1076 1077 1055 1075 1076 1075 1045 1076 1068 1075 1055 1068 1043 1075 1075 1043 1045 1043 1044 1045 1041 1042 1043 1043 1042 1044 1068 1041 1043 1055 1067 1068 1067 1041 1068 1039 1040 1041 1041 1040 1042 1067 1039 1041 213 1042 1040 1039 1038 1040 213 1040 215 215 1040 1038 1037 1038 1039 1066 1037 1039 1066 1039 1067 1055 1066 1067 1062 1066 1055 1062 1037 1066 1035 1036 1037 1037 1036 1038 1062 1035 1037 215 1038 217 217 1038 1036 1035 1034 1036 217 1036 221 221 1036 1034 1033 1034 1035 1061 1033 1035 1061 1035 1062 1055 1061 1062 1055 1060 1061 1060 1033 1061 1031 1032 1033 1033 1032 1034 1060 1031 1033 221 1034 226 226 1034 1032 1031 1030 1032 226 1032 238 238 1032 1030 1029 1030 1031 1054 1029 1031 1054 1031 1060 1054 1060 1055 1054 1055 1056 1056 1057 1054 1056 1005 1057 1054 1057 1058 1057 1005 1007 1057 1007 1058 1005 1006 1007 1007 1006 1008 1007 1008 1009 1058 1007 1009 1054 1058 1059 1058 1009 1059 1009 1008 1010 1009 1010 1011 1059 1009 1011 339 1010 1008 339 1008 336 336 1008 1006 336 1006 333 333 335 336 335 337 336 336 337 338 336 338 339 332 334 333 333 334 335 337 335 189 189 335 334 337 189 188 188 338 337 338 340 339 188 340 338 186 187 188 188 189 186 187 340 188 186 189 190 189 334 190 190 334 332 179 181 186 186 181 187 198 186 199 199 186 200 186 201 202 186 202 200 198 267 186 186 267 266 186 266 179 319 317 201 201 317 292 201 292 202 279 200 202 202 292 298 202 298 279 297 279 298 297 298 292 292 296 297 277 279 297 277 297 880 880 297 296 292 295 296 880 296 879 879 296 295 879 868 880 757 277 880 757 880 758 758 880 868 277 278 279 278 277 757 755 278 757 755 757 756 756 757 758 756 758 58 758 868 58 753 755 756 58 59 756 756 59 60 756 60 753 58 50 59 50 58 831 831 58 832 58 868 832 59 50 52 59 52 60 60 52 61 60 61 62 753 60 62 62 61 63 1119 63 61 1119 61 52 62 63 64 753 62 64 64 63 65 65 63 66 1117 66 63 1117 63 1119 65 753 64 65 752 753 752 754 753 753 754 755 65 66 67 67 752 65 67 66 68 68 66 1117 67 68 69 69 749 67 67 749 752 749 751 752 752 751 754 71 748 749 71 749 69 748 750 749 749 750 751 69 68 70 69 70 71 1115 70 68 1115 68 1117 71 70 72 72 70 1115 71 72 73 73 748 71 73 72 74 1115 1113 72 1113 74 72 1114 1113 1115 1114 1115 1116 1116 1115 1117 1116 1117 1118 1118 1117 1119 1118 20 1116 1116 20 19 1116 19 1114 1112 1113 1114 1114 19 18 1114 18 1112 4 18 19 19 20 4 4 20 21 1118 21 20 1118 1119 1120 1120 21 1118 1120 1119 1121 52 1121 1119 1120 1121 1122 1122 13 1120 1120 13 21 4 21 13 9 4 13 1122 9 13 1122 1121 1123 1122 1123 1124 1124 9 1122 1124 1123 1125 1121 44 1123 44 49 1123 1123 49 33 1123 33 1125 1124 1125 1126 1126 11 1124 1124 11 9 1126 1125 1127 1126 1127 1128 1128 10 1126 1126 10 11 10 9 11 8 9 10 1128 8 10 1128 1127 1129 1128 1129 1130 1130 8 1128 8 12 9 1130 12 8 9 12 4 1132 4 12 1132 12 1130 1130 1129 1131 1130 1131 1132 1132 1131 1133 1132 1133 1134 1134 4 1132 122 1131 1129 122 124 1131 1131 124 126 1131 126 1133 120 121 122 122 121 123 122 123 124 1129 120 122 124 123 125 124 125 126 126 125 127 126 127 128 1133 126 128 689 685 125 125 685 127 125 123 689 689 123 690 123 121 690 688 687 689 689 687 685 689 690 688 684 127 685 686 684 685 686 685 687 628 626 687 687 626 624 687 624 686 688 628 687 660 684 686 686 624 623 686 623 660 616 623 624 616 624 625 625 624 626 625 626 627 626 628 627 627 628 629 629 628 688 627 629 630 778 625 627 778 627 779 779 627 630 616 625 778 767 616 778 620 617 767 617 616 767 766 620 767 614 619 620 620 619 621 620 621 617 614 620 766 615 616 617 617 621 622 617 622 615 661 622 621 661 621 658 658 621 619 614 618 619 658 619 618 658 618 659 659 681 658 658 681 682 658 682 661 660 622 661 661 682 683 661 683 660 660 615 622 660 683 684 660 623 615 682 131 683 683 131 129 683 129 684 681 133 682 682 133 131 130 129 131 130 131 132 132 131 133 128 127 129 128 129 130 684 129 127 130 1135 1133 1133 128 130 130 132 1135 132 133 134 1135 132 134 134 133 135 681 135 133 134 135 136 1135 134 1137 134 136 1137 136 135 137 680 137 135 680 135 681 659 680 681 679 137 680 656 679 680 656 680 659 136 137 138 138 137 139 679 139 137 1137 136 138 138 139 140 1137 138 1139 138 140 1139 140 139 141 678 141 139 678 139 679 657 678 679 657 679 656 677 141 678 651 677 678 651 678 657 140 141 142 142 141 143 677 143 141 1139 140 142 142 143 144 1139 142 1082 1082 142 144 144 143 145 676 145 143 676 143 677 652 676 677 652 677 651 675 145 676 653 675 676 653 676 652 144 145 146 146 145 147 675 147 145 674 147 675 654 674 675 654 675 653 652 604 653 653 604 603 653 603 654 654 603 601 654 601 655 655 674 654 673 149 674 674 149 147 655 673 674 655 601 599 655 599 649 649 673 655 600 599 601 600 601 602 602 601 603 602 603 604 604 605 602 602 605 606 602 606 607 600 602 764 602 607 764 597 599 600 597 600 763 763 600 764 764 607 765 607 606 608 607 608 609 607 609 765 651 608 606 651 606 605 608 610 609 657 610 608 657 608 651 609 610 611 609 611 612 609 612 765 765 612 766 612 611 613 612 613 614 612 614 766 656 613 611 656 611 610 656 610 657 659 613 656 613 618 614 659 618 613 651 605 652 652 605 604 594 597 763 762 594 763 762 763 791 594 596 597 596 598 597 597 598 599 594 595 596 649 596 650 650 596 595 649 598 596 649 599 598 650 672 649 649 672 673 650 595 647 647 671 650 650 671 672 593 595 594 647 595 593 647 591 648 647 593 591 648 670 647 647 670 671 670 155 671 671 155 153 671 153 672 669 157 670 670 157 155 648 669 670 648 591 590 648 590 645 645 669 648 668 159 669 669 159 157 645 668 669 156 155 157 156 157 158 158 157 159 158 159 160 160 159 161 668 161 159 667 161 668 646 667 668 646 668 645 160 161 162 162 161 163 667 163 161 158 160 1091 1091 160 162 1089 156 158 1089 158 1091 1090 1089 1091 1090 1091 1092 1092 1091 1093 1091 162 1093 162 163 164 1093 162 164 1092 1093 1094 1094 1093 1095 166 1095 1093 1093 164 166 1094 23 1092 1092 23 22 1092 22 1090 1094 24 23 1088 1089 1090 1090 22 16 1090 16 1088 1086 1087 1088 1088 1087 1089 1088 16 15 1088 15 1086 1084 1085 1086 1086 1085 1087 1086 14 1084 1086 15 14 1084 1083 1085 1083 146 1085 146 148 1085 1085 148 150 1085 150 1087 1082 1083 1084 1082 144 1083 1083 144 146 146 147 148 148 147 149 148 149 150 150 149 151 150 151 152 1087 150 152 673 151 149 152 151 153 672 153 151 672 151 673 152 153 154 1087 152 154 154 1089 1087 154 153 155 154 155 156 154 156 1089 1084 1139 1082 1138 1139 1084 1084 14 2 1084 2 1138 1138 1137 1139 1136 1137 1138 1138 2 3 1138 3 1136 2 1 3 1 7 3 1136 3 7 1134 1135 1136 1136 1135 1137 1136 7 1134 1 4 7 1134 7 4 5 4 1 1106 5 1 1106 1 1104 4 5 6 6 17 4 4 17 18 1108 6 5 1108 5 1106 1104 1105 1106 1106 1105 1107 1106 1107 1108 1104 1103 1105 89 1107 1105 1103 97 1105 1105 97 99 1105 99 89 102 1103 1101 102 104 1103 1103 104 97 1099 30 1101 1101 30 109 1101 109 102 1099 176 30 176 175 177 176 177 30 569 177 175 569 175 638 30 177 178 568 178 177 568 177 569 571 568 569 571 569 638 571 638 570 570 638 640 570 568 571 513 515 570 570 515 568 640 513 570 639 572 640 640 572 513 513 514 515 513 572 514 515 514 374 515 374 378 515 378 512 515 512 568 521 374 514 514 572 573 514 573 574 514 574 521 639 573 572 520 394 521 521 394 374 521 574 759 521 759 520 519 395 520 520 395 394 520 759 777 520 777 519 394 395 396 374 394 379 379 394 396 395 397 396 519 397 395 518 397 519 519 777 518 777 770 517 777 517 518 517 398 518 518 398 397 397 398 399 396 397 399 398 400 399 517 400 398 516 400 517 516 517 723 723 517 770 723 770 724 516 723 710 710 723 724 710 400 516 399 400 401 709 401 400 709 400 710 732 709 710 732 710 716 708 401 709 708 709 732 399 401 402 406 399 402 406 402 407 407 402 404 396 399 406 385 396 406 385 406 386 386 406 407 522 386 407 522 407 523 523 407 404 523 404 524 702 701 523 523 701 522 524 702 523 432 386 522 701 564 522 522 564 432 385 386 387 432 387 386 387 432 433 433 432 434 563 434 432 563 432 564 566 563 564 566 564 567 701 567 564 562 434 563 565 562 563 565 563 566 434 435 433 562 435 434 561 436 562 436 435 562 559 561 562 559 562 565 229 559 565 229 565 219 219 565 566 227 558 559 227 559 228 558 561 559 228 559 229 221 228 229 221 229 219 219 220 221 219 566 220 221 220 222 221 222 217 226 228 221 226 227 228 224 225 226 225 227 226 238 245 226 226 245 246 226 246 224 246 556 224 224 556 557 224 557 225 225 557 558 225 558 227 556 555 557 557 555 560 557 560 558 246 551 556 551 554 556 556 554 555 245 551 246 244 550 551 244 551 245 550 553 551 551 553 554 553 431 554 554 431 430 554 430 555 552 421 553 553 421 431 550 552 553 243 549 550 243 550 244 549 552 550 538 422 552 552 422 421 549 538 552 421 422 423 423 431 421 423 430 431 422 424 423 423 424 425 423 425 414 429 430 423 442 429 423 442 423 443 443 423 414 538 424 422 425 424 538 414 425 426 537 426 425 537 425 538 414 426 418 536 418 426 536 426 537 547 536 537 547 537 548 548 537 538 535 418 536 546 535 536 546 536 547 418 419 414 535 419 418 534 420 535 420 419 535 545 534 535 545 535 546 239 545 546 239 546 240 240 546 547 234 544 545 234 545 239 544 534 545 238 239 240 234 239 232 232 239 238 240 241 238 240 547 241 238 241 242 241 547 548 241 548 242 238 242 243 242 548 549 242 549 243 548 538 549 243 244 238 238 244 245 232 238 370 370 238 369 238 1030 369 370 369 371 192 232 370 192 370 371 371 369 368 371 193 192 371 368 193 185 192 181 181 192 193 185 232 192 181 193 194 193 368 367 193 367 194 366 367 368 366 368 369 365 367 366 194 367 365 194 207 181 364 207 194 194 365 364 363 364 365 363 365 366 369 1028 366 366 1028 1026 366 1026 363 369 1030 1028 1027 1026 1028 1027 1028 1029 1029 1028 1030 1025 1024 1026 1025 1026 1027 363 1026 1024 1079 1025 1027 1079 1027 1080 1080 1027 1029 1080 1029 1054 1054 1079 1080 1054 1078 1079 1078 1025 1079 1023 1024 1025 1078 1023 1025 1023 1022 1024 363 1024 360 360 1024 1022 1021 1022 1023 1074 1021 1023 1074 1023 1078 1074 1078 1054 1054 1073 1074 1073 1021 1074 1019 1020 1021 1021 1020 1022 1073 1019 1021 360 1022 357 357 1022 1020 1019 1018 1020 357 1020 354 354 1020 1018 1017 1018 1019 1072 1017 1019 1072 1019 1073 1054 1072 1073 1065 1072 1054 1065 1017 1072 1015 1016 1017 1017 1016 1018 1065 1015 1017 354 1018 351 351 1018 1016 1015 1014 1016 351 1016 348 348 1016 1014 1013 1014 1015 1064 1013 1015 1064 1015 1065 1054 1064 1065 1054 1063 1064 1063 1013 1064 1059 1063 1054 1059 1011 1063 1063 1011 1013 1011 1012 1013 1013 1012 1014 348 1014 345 345 1014 1012 1011 1010 1012 345 1012 342 342 1012 1010 342 344 345 344 346 345 345 346 347 345 347 348 342 343 344 181 346 344 181 344 343 208 347 346 208 346 181 347 349 348 349 347 208 348 349 350 348 350 351 349 208 204 204 350 349 181 206 208 208 206 204 203 204 205 205 204 206 203 352 204 204 352 350 350 352 351 351 352 353 351 353 354 203 353 352 205 355 203 355 353 203 358 205 206 358 356 205 205 356 355 353 355 354 354 355 356 354 356 357 356 358 357 357 358 359 206 359 358 357 359 360 359 361 360 206 361 359 360 361 362 360 362 363 207 362 361 207 361 206 181 207 206 364 362 207 362 364 363 179 180 181 181 180 182 182 183 181 181 183 184 181 184 185 343 187 181 179 266 249 179 249 180 249 266 247 247 266 267 247 248 249 249 248 250 249 250 251 249 251 180 250 248 747 747 248 247 251 250 252 745 252 250 745 250 747 251 252 253 180 251 253 180 253 182 253 252 254 253 254 255 182 253 255 254 252 745 255 254 256 745 256 254 255 256 257 182 255 257 257 183 182 257 256 258 257 258 259 257 259 183 744 258 256 744 256 745 259 258 260 741 260 258 741 258 744 259 260 261 183 259 261 183 261 184 261 260 262 261 262 263 184 261 263 262 260 741 263 262 264 740 264 262 740 262 741 263 264 211 184 263 211 211 185 184 209 210 211 211 210 235 211 264 265 211 265 209 211 235 185 737 265 264 737 264 740 527 209 265 527 265 737 209 527 210 235 210 236 210 527 539 210 539 236 235 236 232 185 235 232 232 236 237 236 539 540 236 540 237 527 528 539 539 528 529 539 529 540 527 526 528 526 527 737 526 408 528 528 408 410 528 410 529 529 410 411 529 411 530 540 529 530 237 540 541 540 530 541 530 411 417 530 417 531 541 530 531 410 409 411 409 417 411 408 409 410 94 90 408 408 90 409 526 94 408 93 90 94 94 526 738 738 93 94 89 88 90 92 89 90 92 90 93 88 409 90 738 92 93 739 92 738 526 737 738 738 737 740 738 740 739 84 89 92 739 84 92 84 85 76 76 91 84 84 91 89 739 85 84 76 85 86 743 86 85 743 85 739 76 86 77 742 86 743 742 77 86 739 741 743 743 741 744 743 744 742 746 79 742 742 79 77 742 744 745 742 745 746 76 77 78 78 77 79 78 79 80 80 79 81 746 81 79 1109 76 78 1109 78 80 80 81 82 80 1111 1109 80 82 1111 82 81 75 75 81 746 82 75 83 1111 82 83 1110 1109 1111 1110 1111 1112 1112 1111 1113 1111 83 1113 83 75 74 1113 83 74 73 74 75 75 746 73 73 746 748 746 745 747 746 747 748 748 747 750 747 247 750 750 247 268 750 268 751 247 267 268 268 267 269 268 269 270 268 270 751 751 270 272 751 272 754 270 269 271 270 271 272 271 269 198 198 269 267 272 271 273 271 198 199 199 273 271 272 273 274 754 272 274 754 274 755 274 273 275 274 275 276 755 274 276 199 275 273 200 275 199 276 275 280 280 275 281 200 281 275 755 276 280 280 278 755 279 278 280 280 281 279 279 281 200 1112 18 17 1112 17 1110 1110 17 6 1108 1109 1110 1110 6 1108 1108 1107 1109 1107 76 1109 89 91 1107 1107 91 76 87 88 89 99 100 89 89 100 101 89 101 87 449 444 87 87 444 88 101 449 87 444 409 88 443 414 444 444 414 409 449 443 444 448 443 449 454 448 449 454 449 101 100 454 101 453 448 454 458 453 454 458 454 100 447 442 448 448 442 443 453 447 448 452 447 453 457 452 453 457 453 458 439 457 458 439 458 98 98 458 100 456 452 457 462 456 457 462 457 439 455 451 456 456 451 452 461 455 456 461 456 462 466 461 462 466 462 467 467 462 439 460 455 461 465 460 461 465 461 466 471 465 466 471 466 472 472 466 467 467 439 95 472 467 106 106 467 95 106 105 472 472 105 473 472 473 471 97 105 106 97 106 95 95 96 97 95 439 96 98 96 439 97 96 98 97 98 99 104 105 97 104 103 105 105 103 473 102 103 104 102 113 103 113 479 103 473 103 479 102 112 113 112 479 113 478 479 480 112 480 479 473 479 474 474 479 478 108 112 102 108 480 112 108 491 480 478 480 482 482 480 491 107 108 102 107 491 108 107 490 491 482 491 492 492 491 490 481 478 482 481 482 484 484 482 492 492 490 493 484 492 497 497 492 493 111 489 490 111 490 107 493 490 489 102 111 107 102 110 111 110 489 111 110 488 489 493 489 494 494 489 488 497 493 498 498 493 494 494 488 495 498 494 499 499 494 495 29 487 488 29 488 110 495 488 487 109 29 110 109 110 102 28 29 30 30 29 109 28 487 29 495 487 496 487 28 178 487 178 496 30 178 28 496 178 568 500 495 496 500 496 501 568 501 496 568 512 506 568 506 501 505 500 501 505 501 506 499 495 500 504 499 500 504 500 505 510 504 505 510 505 511 511 505 506 511 506 512 377 511 512 377 512 378 376 510 511 376 511 377 509 504 510 375 509 510 375 510 376 503 499 504 509 503 504 508 503 509 373 508 509 373 509 375 374 373 375 375 376 374 374 376 377 374 377 378 372 373 374 379 383 374 374 383 384 374 384 372 372 508 373 384 507 372 372 507 508 507 502 508 508 502 503 485 486 507 507 486 502 384 485 507 384 383 477 477 485 384 379 382 383 477 383 382 468 476 477 468 477 381 477 382 381 476 483 477 477 483 485 485 483 486 483 481 484 483 484 486 476 481 483 469 475 476 469 476 468 475 481 476 475 478 481 470 474 475 470 475 469 474 478 475 468 463 469 469 463 464 469 464 470 470 464 465 470 465 471 471 474 470 471 473 474 464 460 465 463 459 464 464 459 460 459 438 460 460 438 455 393 392 459 459 392 438 463 393 459 392 391 438 391 390 438 438 390 450 438 450 455 455 450 451 390 389 450 450 389 445 450 445 451 385 389 390 390 391 385 385 391 392 385 392 379 379 392 393 387 388 385 385 388 389 379 396 385 389 388 445 445 388 440 445 440 446 451 445 446 451 446 452 446 440 441 446 441 447 452 446 447 388 387 440 440 387 433 440 433 441 441 433 429 441 429 442 447 441 442 433 435 436 433 436 429 427 428 429 429 428 430 429 436 437 429 437 427 561 437 436 560 427 437 560 437 561 555 428 427 555 427 560 430 428 555 558 560 561 379 380 381 381 382 379 379 393 380 380 393 463 381 380 468 468 380 463 486 484 497 486 497 502 502 497 498 502 498 503 503 498 499 99 98 100 414 416 409 409 416 417 414 415 416 417 416 531 531 416 415 413 415 414 531 415 532 532 415 413 541 531 542 542 531 532 532 413 533 542 532 543 543 532 533 412 413 414 533 413 412 533 412 534 543 533 544 544 533 534 231 542 543 231 543 233 233 543 544 233 544 234 232 231 233 232 233 234 230 231 232 230 542 231 232 237 230 237 541 230 230 541 542 534 412 420 414 419 420 414 420 412 739 740 741 343 341 187 187 341 340 341 343 342 339 340 341 339 341 342 342 1010 339 216 215 217 216 217 218 217 222 223 217 223 218 214 215 216 214 216 699 216 218 699 214 213 215 699 218 700 699 700 702 704 699 702 218 223 700 223 222 567 700 223 567 220 567 222 220 566 567 700 567 701 702 700 701 704 702 524 716 715 732 714 715 716 769 715 714 1134 1133 1135 164 165 166 166 165 167 166 167 168 166 168 1095 164 163 165 665 167 165 665 165 666 666 165 163 666 163 667 644 665 666 644 666 643 643 666 667 643 667 646 643 584 644 646 585 643 643 585 579 643 579 584 644 584 583 579 585 577 577 585 586 646 586 585 645 586 646 577 586 587 587 586 588 645 588 586 577 587 761 587 588 589 587 589 761 588 590 589 645 590 588 589 590 591 589 591 592 589 592 762 761 589 762 761 762 793 592 594 762 793 762 791 592 591 593 592 593 594 615 623 616 630 629 631 630 631 632 779 630 632 688 691 629 691 631 629 631 633 632 691 633 631 688 690 691 634 633 691 690 695 691 691 695 693 691 693 634 632 633 634 632 634 635 635 634 636 634 693 692 634 692 636 692 693 694 694 693 695 119 694 695 119 695 121 690 121 695 117 694 119 697 692 694 697 694 698 698 694 117 696 692 697 636 692 696 911 697 698 911 696 697 698 117 115 698 115 911 116 115 117 116 117 118 118 117 119 40 114 115 40 115 116 115 114 912 911 115 912 40 116 1127 1127 116 118 118 119 120 1127 118 1129 1129 118 120 40 1127 1125 1125 33 38 1125 38 40 33 37 38 38 37 39 38 39 40 33 36 37 39 37 921 921 37 36 40 39 41 917 41 39 917 39 921 921 36 922 918 917 921 918 921 939 939 921 922 35 36 33 922 36 35 922 35 923 939 922 940 940 922 923 919 918 939 919 939 950 950 939 940 940 923 941 950 940 951 951 940 941 923 35 34 923 34 924 941 923 924 33 34 35 33 32 34 924 34 32 924 32 925 941 924 942 942 924 925 951 941 952 952 941 942 942 925 943 952 942 953 953 942 943 925 32 31 925 31 926 943 925 926 31 32 33 31 33 48 48 926 31 47 938 926 47 926 48 943 926 944 944 926 938 44 47 48 48 33 49 48 49 44 44 46 47 46 938 47 46 937 938 944 938 945 945 938 937 954 943 944 954 944 955 955 944 945 945 937 946 955 945 956 956 945 946 965 954 955 965 955 966 966 955 956 956 946 957 966 956 967 967 956 957 946 937 936 946 936 947 957 946 947 957 947 958 967 957 968 968 957 958 927 966 967 927 967 972 972 967 968 968 958 969 972 968 973 973 968 969 958 947 948 958 948 959 969 958 959 969 959 970 973 969 974 974 969 970 974 889 973 973 889 904 973 904 972 974 970 975 975 890 974 974 890 889 970 959 960 970 960 971 975 970 971 975 971 976 976 892 975 975 892 890 889 890 891 891 890 892 891 904 889 891 903 904 972 904 903 806 902 903 806 903 891 972 903 927 927 903 902 897 902 806 927 902 897 927 897 928 928 966 927 896 897 806 928 897 896 928 896 929 929 965 928 928 965 966 806 901 896 929 896 901 929 901 930 930 964 929 929 964 965 964 954 965 963 953 964 964 953 954 930 963 964 930 901 900 930 900 931 931 963 930 806 900 901 899 900 806 931 900 899 931 899 932 932 962 931 931 962 963 962 952 963 963 952 953 953 943 954 962 951 952 961 951 962 932 961 962 932 899 898 932 898 933 933 961 932 806 898 899 805 898 806 933 898 805 933 805 916 916 920 933 933 920 961 920 950 961 961 950 951 916 915 920 915 919 920 920 919 950 807 915 916 807 916 805 805 806 807 807 806 635 807 635 637 807 637 911 911 915 807 911 914 915 915 914 919 914 918 919 913 914 911 914 913 918 911 637 696 911 912 913 635 636 637 636 696 637 781 632 635 635 806 781 781 779 632 781 806 837 837 806 906 906 806 891 906 891 907 908 906 907 892 893 891 891 893 894 891 894 887 907 891 887 907 887 801 908 907 799 799 907 801 798 908 799 797 798 799 797 799 800 800 799 801 800 801 802 802 801 803 801 887 803 881 797 800 881 800 883 883 800 802 802 803 804 887 804 803 887 888 804 804 888 808 886 888 887 888 886 992 808 888 992 813 808 814 808 992 814 992 886 987 992 987 993 814 992 993 885 886 887 886 885 987 887 894 895 887 895 885 885 895 982 987 885 982 987 982 988 993 987 988 993 988 994 814 993 818 818 993 994 988 982 983 988 983 989 994 988 989 982 895 977 982 977 983 895 894 977 977 894 976 977 976 978 983 977 978 983 978 984 989 983 984 989 984 990 994 989 995 995 989 990 984 978 979 984 979 985 990 984 985 978 976 971 978 971 979 894 893 976 976 893 892 979 971 960 979 960 980 985 979 980 959 949 960 980 960 949 980 949 981 985 980 986 986 980 981 948 934 949 959 948 949 981 949 934 981 934 55 986 981 54 54 981 55 991 985 986 991 986 53 53 986 54 53 54 52 52 54 55 52 55 56 55 934 56 50 51 52 52 51 53 56 57 52 52 57 1121 51 991 53 996 991 51 50 996 51 831 996 50 995 990 996 996 990 991 831 995 996 824 994 995 824 995 831 818 994 824 816 817 818 817 819 818 818 819 820 818 820 814 824 825 818 818 825 826 818 826 816 856 819 817 856 817 857 857 817 816 850 820 819 850 819 856 814 820 821 821 820 850 813 814 815 814 821 815 849 815 821 849 821 850 853 849 850 853 850 852 852 850 856 852 302 853 853 302 301 851 303 852 852 303 302 852 856 851 285 301 302 302 303 285 285 303 304 851 304 303 285 286 284 285 304 286 284 1050 285 851 286 304 284 286 287 869 287 286 869 286 851 284 287 282 870 282 287 870 287 869 851 857 869 869 857 858 869 858 870 870 858 859 870 859 871 871 282 870 282 283 284 871 283 282 871 859 860 871 860 872 872 283 871 283 288 284 872 288 283 872 860 862 872 862 873 873 288 872 859 823 860 860 823 822 822 862 860 822 861 862 873 862 861 873 861 874 874 289 873 873 289 288 284 288 289 284 289 290 874 290 289 874 861 863 874 863 875 875 290 874 290 291 292 290 292 284 875 291 290 875 863 864 875 864 876 876 291 875 292 291 293 876 293 291 292 293 294 294 295 292 284 292 317 284 317 318 317 319 318 879 295 878 878 295 294 878 294 877 877 294 293 877 293 876 876 866 877 877 866 865 877 865 878 878 865 867 878 867 879 879 867 868 865 833 867 867 833 832 867 832 868 831 832 833 833 834 831 865 834 833 831 834 835 831 835 824 835 834 865 824 835 836 835 865 836 836 865 866 824 836 827 864 827 836 836 866 864 824 827 828 863 828 827 863 827 864 876 864 866 861 828 863 828 829 824 861 829 828 830 861 822 830 829 861 824 829 830 824 830 822 822 823 824 824 823 825 859 825 823 826 825 859 858 826 859 858 816 826 857 816 858 851 856 857 990 985 991 1121 57 44 56 44 57 42 43 44 44 43 45 45 46 44 42 44 56 56 934 42 42 934 935 42 935 43 43 935 936 43 936 45 45 936 937 45 937 46 947 936 935 947 935 948 948 935 934 882 881 883 913 912 917 913 917 918 912 114 41 912 41 917 41 114 40 120 119 121 1140 1141 1142 1145 1144 1140 1145 1140 1146 1146 1140 1142 1140 1144 1195 1140 1195 1141 1143 1144 1145 1146 1596 1145 1145 1596 1597 1145 1597 1143 1142 1595 1146 1146 1595 1596 1595 1424 1596 1424 1422 1596 1596 1422 1432 1596 1432 1597 1597 1432 1431 1597 1431 1598 1143 1597 1598 1421 1431 1432 1421 1432 1422 1421 1422 1423 1423 1422 1424 1430 1431 1421 1421 1678 1430 1423 1677 1421 1421 1677 1678 1430 1429 1431 1598 1431 1429 1428 1429 1430 1430 1678 1679 1430 1679 1428 1677 1602 1678 1678 1602 1603 1678 1603 1679 1752 1601 1677 1677 1601 1602 1423 1752 1677 1601 1309 1602 1602 1309 1308 1602 1308 1603 1603 1308 1291 1603 1291 1604 1679 1603 1604 1291 1308 1289 1289 1308 1309 1289 1309 1310 1601 1310 1309 1676 1310 1601 1752 1676 1601 1310 1328 1289 1676 1328 1310 1675 1328 1676 1751 1675 1676 1751 1676 1752 1289 1328 1329 1675 1329 1328 1674 1329 1675 1750 1674 1675 1750 1675 1751 1440 1750 1751 1440 1751 1425 1425 1751 1752 1749 1674 1750 1433 1749 1750 1433 1750 1440 1425 1439 1440 1440 1439 1441 1440 1441 1433 1433 1434 1435 1433 1441 1442 1433 1442 1434 1435 1749 1433 1593 1442 1441 1593 1441 1594 1441 1439 1594 1425 1438 1439 1594 1439 1438 1594 1438 1595 1152 1593 1594 1152 1594 1142 1142 1594 1595 1592 1442 1593 1151 1592 1593 1151 1593 1152 1592 1434 1442 1591 1436 1592 1436 1434 1592 1150 1591 1592 1150 1592 1151 1147 1150 1151 1147 1151 1141 1141 1151 1152 1141 1152 1142 1195 1147 1141 1147 1148 1149 1149 1150 1147 1195 1148 1147 1149 1591 1150 1148 1158 1149 1158 1590 1149 1149 1590 1591 1148 1157 1158 1157 1589 1158 1158 1589 1590 1589 1451 1590 1451 1449 1590 1590 1449 1448 1590 1448 1591 1587 1452 1589 1589 1452 1451 1157 1587 1589 1450 1449 1451 1450 1451 1443 1443 1451 1452 1437 1448 1449 1437 1449 1450 1436 1448 1437 1591 1448 1436 1435 1436 1437 1450 1747 1437 1437 1747 1748 1437 1748 1435 1443 1746 1450 1450 1746 1747 1746 1671 1747 1747 1671 1672 1747 1672 1748 1748 1672 1673 1748 1673 1749 1435 1748 1749 1435 1434 1436 1749 1673 1674 1672 1332 1673 1673 1332 1330 1673 1330 1674 1671 1262 1672 1672 1262 1332 1262 1289 1332 1332 1289 1330 1289 1329 1330 1674 1330 1329 1289 1290 1291 1289 1303 1290 1262 1331 1289 1617 1303 1289 1617 1289 1618 1618 1289 1331 1604 1291 1290 1604 1290 1605 1679 1604 1680 1680 1604 1605 1605 1290 1327 1605 1327 1606 1680 1605 1681 1681 1605 1606 1428 1679 1680 1428 1680 1420 1420 1680 1681 1681 1606 1682 1420 1681 1418 1418 1681 1682 1606 1327 1326 1606 1326 1607 1682 1606 1607 1290 1326 1327 1290 1325 1326 1607 1326 1325 1607 1325 1608 1682 1607 1683 1683 1607 1608 1418 1682 1415 1415 1682 1683 1683 1608 1684 1415 1683 1413 1413 1683 1684 1608 1325 1324 1608 1324 1609 1684 1608 1609 1324 1325 1290 1290 1323 1324 1609 1324 1323 1609 1323 1610 1684 1609 1685 1685 1609 1610 1413 1684 1410 1410 1684 1685 1685 1610 1686 1410 1685 1408 1408 1685 1686 1610 1323 1322 1610 1322 1611 1686 1610 1611 1290 1322 1323 1321 1322 1290 1611 1322 1321 1611 1321 1612 1686 1611 1687 1687 1611 1612 1408 1686 1405 1405 1686 1687 1687 1612 1688 1405 1687 1403 1403 1687 1688 1612 1321 1320 1612 1320 1613 1688 1612 1613 1290 1320 1321 1290 1319 1320 1613 1320 1319 1613 1319 1614 1688 1613 1689 1689 1613 1614 1403 1688 1400 1400 1688 1689 1689 1614 1690 1400 1689 1398 1398 1689 1690 1614 1319 1305 1614 1305 1615 1690 1614 1615 1305 1319 1290 1290 1304 1305 1615 1305 1304 1615 1304 1616 1690 1615 1691 1691 1615 1616 1398 1690 1395 1395 1690 1691 1691 1616 1692 1395 1691 1393 1393 1691 1692 1616 1304 1303 1616 1303 1617 1692 1616 1617 1290 1303 1304 1692 1617 1693 1693 1617 1618 1393 1692 1390 1390 1692 1693 1390 1392 1393 1393 1392 1394 1393 1394 1395 1388 1389 1390 1389 1391 1390 1390 1391 1392 1390 1693 1388 1693 1618 1694 1388 1693 1694 1618 1331 1619 1694 1618 1619 1694 1619 1695 1388 1694 1385 1385 1694 1695 1385 1387 1388 1388 1387 1389 1391 1389 1535 1535 1389 1387 1534 1392 1391 1534 1391 1535 1535 1387 1536 1235 1534 1535 1235 1535 1236 1236 1535 1536 1385 1386 1387 1536 1387 1386 1536 1386 1537 1236 1536 1233 1233 1536 1537 1232 1235 1236 1232 1236 1233 1234 1235 1232 1234 1243 1235 1243 1534 1235 1231 1230 1232 1231 1232 1233 1207 1234 1232 1232 1230 1207 1233 1537 1231 1229 1230 1231 1231 1537 1538 1231 1538 1229 1229 1226 1230 1207 1230 1226 1224 1226 1229 1229 1538 1539 1229 1539 1224 1537 1382 1538 1538 1382 1381 1538 1381 1539 1539 1381 1379 1539 1379 1377 1377 1541 1539 1224 1539 1541 1224 1225 1226 1224 1541 1225 1377 1540 1541 1225 1541 1540 1369 1376 1377 1369 1377 1378 1378 1377 1379 1376 1540 1377 1378 1379 1380 1379 1381 1380 1380 1381 1382 1380 1382 1383 1383 1696 1380 1380 1696 1697 1380 1697 1378 1378 1697 1698 1378 1698 1369 1696 1621 1697 1697 1621 1622 1697 1622 1698 1695 1620 1696 1696 1620 1621 1383 1695 1696 1620 1298 1621 1621 1298 1297 1621 1297 1622 1622 1297 1271 1622 1271 1623 1698 1622 1623 1271 1297 1262 1262 1297 1298 1262 1298 1299 1620 1299 1298 1619 1299 1620 1695 1619 1620 1385 1695 1383 1383 1384 1385 1384 1386 1385 1383 1382 1384 1386 1384 1537 1537 1384 1382 1619 1331 1299 1299 1331 1262 1257 1259 1262 1262 1259 1263 1262 1263 1264 1264 1265 1262 1262 1265 1266 1262 1266 1267 1268 1269 1262 1262 1269 1270 1262 1270 1271 1267 1287 1262 1262 1287 1288 1262 1288 1268 1671 1257 1262 1623 1271 1270 1623 1270 1624 1624 1270 1269 1698 1623 1699 1699 1623 1624 1624 1269 1625 1699 1624 1700 1700 1624 1625 1369 1698 1699 1369 1699 1370 1370 1699 1700 1700 1625 1701 1370 1700 1373 1373 1700 1701 1625 1269 1268 1625 1268 1626 1701 1625 1626 1701 1626 1702 1373 1701 1362 1362 1701 1702 1362 1372 1373 1373 1372 1374 1373 1374 1370 1360 1361 1362 1361 1371 1362 1362 1371 1372 1362 1702 1360 1543 1374 1372 1543 1372 1371 1370 1374 1375 1375 1374 1543 1368 1369 1370 1370 1375 1368 1540 1368 1375 1540 1375 1542 1542 1375 1543 1368 1376 1369 1376 1368 1540 1225 1540 1227 1227 1540 1542 1227 1542 1228 1228 1542 1543 1226 1225 1227 1226 1227 1221 1221 1227 1228 1221 1228 1222 1228 1543 1222 1221 1222 1218 1207 1226 1221 1221 1218 1207 1218 1222 1223 1222 1543 1545 1222 1545 1223 1371 1545 1543 1371 1544 1545 1223 1545 1544 1218 1223 1219 1223 1544 1219 1218 1219 1213 1207 1218 1213 1213 1219 1220 1219 1544 1546 1219 1546 1220 1213 1214 1215 1213 1220 1214 1207 1213 1208 1208 1213 1215 1220 1546 1547 1220 1547 1214 1544 1367 1546 1546 1367 1547 1367 1366 1547 1547 1366 1364 1547 1364 1363 1363 1549 1547 1214 1547 1549 1358 1366 1367 1358 1367 1359 1544 1359 1367 1365 1364 1366 1365 1366 1358 1352 1363 1364 1352 1364 1365 1358 1704 1365 1365 1704 1705 1365 1705 1352 1350 1351 1352 1351 1363 1352 1352 1705 1706 1352 1706 1350 1704 1629 1705 1705 1629 1630 1705 1630 1706 1706 1630 1631 1706 1631 1707 1350 1706 1707 1629 1266 1630 1630 1266 1265 1630 1265 1631 1628 1267 1629 1629 1267 1266 1704 1628 1629 1627 1287 1628 1628 1287 1267 1703 1627 1628 1703 1628 1704 1358 1703 1704 1702 1627 1703 1360 1702 1703 1360 1703 1358 1626 1288 1627 1627 1288 1287 1702 1626 1627 1626 1268 1288 1358 1359 1360 1360 1359 1361 1361 1359 1544 1361 1544 1371 1631 1265 1264 1631 1264 1632 1707 1631 1632 1632 1264 1263 1632 1263 1633 1707 1632 1708 1708 1632 1633 1350 1707 1348 1348 1707 1708 1708 1633 1709 1348 1708 1355 1355 1708 1709 1633 1263 1259 1633 1259 1634 1709 1633 1634 1709 1634 1710 1355 1709 1342 1342 1709 1710 1342 1354 1355 1355 1354 1356 1355 1356 1348 1340 1341 1342 1341 1353 1342 1342 1353 1354 1342 1710 1340 1356 1354 1551 1551 1354 1353 1348 1356 1357 1550 1357 1356 1550 1356 1551 1551 1353 1552 1209 1550 1551 1209 1551 1210 1210 1551 1552 1552 1353 1341 1552 1341 1553 1210 1552 1211 1211 1552 1553 1209 1210 1207 1207 1210 1211 1207 1208 1209 1208 1217 1209 1217 1550 1209 1215 1216 1208 1208 1216 1217 1216 1548 1217 1217 1548 1550 1215 1214 1216 1214 1549 1216 1216 1549 1548 1363 1548 1549 1351 1548 1363 1351 1349 1548 1548 1349 1357 1548 1357 1550 1350 1349 1351 1348 1349 1350 1348 1357 1349 1207 1211 1202 1202 1249 1207 1249 1247 1207 1207 1247 1245 1207 1245 1239 1239 1241 1207 1207 1241 1234 1202 1211 1212 1211 1553 1212 1202 1212 1203 1212 1553 1554 1212 1554 1203 1341 1339 1553 1553 1339 1347 1553 1347 1554 1554 1347 1346 1554 1346 1555 1203 1554 1555 1338 1346 1347 1338 1347 1339 1338 1339 1340 1340 1339 1341 1345 1346 1338 1340 1711 1338 1338 1711 1712 1338 1712 1345 1345 1344 1346 1346 1344 1555 1337 1344 1345 1345 1712 1713 1345 1713 1337 1711 1636 1712 1712 1636 1637 1712 1637 1713 1713 1637 1638 1713 1638 1714 1337 1713 1714 1636 1314 1637 1637 1314 1318 1637 1318 1638 1635 1302 1636 1636 1302 1314 1711 1635 1636 1634 1286 1635 1635 1286 1302 1710 1634 1635 1710 1635 1711 1340 1710 1711 1634 1259 1286 1259 1285 1286 1286 1285 1302 1259 1284 1285 1302 1285 1311 1646 1311 1285 1646 1285 1647 1647 1285 1284 1283 1284 1259 1647 1284 1648 1648 1284 1283 1722 1646 1647 1722 1647 1723 1723 1647 1648 1645 1311 1646 1721 1645 1646 1721 1646 1722 1508 1721 1722 1508 1722 1505 1505 1722 1723 1723 1648 1724 1505 1723 1503 1503 1723 1724 1503 1504 1505 1504 1506 1505 1505 1506 1507 1505 1507 1508 1500 1502 1503 1503 1502 1504 1503 1724 1500 1506 1504 1566 1566 1504 1502 1565 1507 1506 1565 1506 1566 1508 1507 1509 1564 1509 1507 1564 1507 1565 1193 1564 1565 1193 1565 1194 1194 1565 1566 1566 1502 1567 1194 1566 1185 1185 1566 1567 1184 1193 1194 1184 1194 1185 1189 1192 1193 1189 1193 1184 1192 1564 1193 1183 1184 1185 1184 1148 1189 1184 1183 1148 1185 1186 1183 1185 1567 1186 1183 1186 1187 1183 1187 1178 1148 1183 1178 1186 1567 1568 1186 1568 1187 1178 1187 1188 1187 1568 1569 1187 1569 1188 1177 1178 1179 1178 1188 1179 1148 1178 1177 1188 1569 1570 1188 1570 1179 1568 1497 1569 1569 1497 1496 1569 1496 1570 1496 1494 1570 1570 1494 1492 1570 1492 1571 1179 1570 1571 1179 1180 1177 1179 1571 1180 1571 1492 1491 1571 1491 1572 1180 1571 1572 1490 1491 1492 1490 1492 1493 1493 1492 1494 1493 1494 1495 1494 1496 1495 1495 1496 1497 1495 1497 1498 1498 1726 1495 1495 1726 1727 1495 1727 1493 1493 1727 1728 1493 1728 1490 1726 1651 1727 1727 1651 1652 1727 1652 1728 1725 1650 1726 1726 1650 1651 1498 1725 1726 1650 1281 1651 1651 1281 1280 1651 1280 1652 1652 1280 1296 1652 1296 1653 1728 1652 1653 1280 1281 1259 1259 1296 1280 1259 1281 1282 1650 1282 1281 1649 1282 1650 1725 1649 1650 1259 1282 1283 1649 1283 1282 1648 1283 1649 1724 1648 1649 1724 1649 1725 1500 1724 1725 1498 1499 1500 1499 1501 1500 1500 1501 1502 1500 1725 1498 1498 1497 1499 1501 1499 1568 1568 1499 1497 1567 1502 1501 1567 1501 1568 1257 1258 1259 1259 1258 1260 1259 1260 1261 1261 1272 1259 1259 1272 1273 1259 1273 1274 1274 1275 1259 1259 1275 1276 1259 1276 1277 1259 1278 1279 1277 1292 1259 1259 1292 1293 1259 1293 1294 1279 1295 1259 1259 1295 1296 1294 1306 1259 1259 1306 1307 1259 1307 1278 1658 1306 1294 1658 1294 1659 1659 1294 1293 1657 1307 1306 1657 1306 1658 1656 1278 1307 1656 1307 1657 1732 1656 1657 1732 1657 1733 1733 1657 1658 1733 1658 1734 1734 1658 1659 1480 1732 1733 1480 1733 1478 1478 1733 1734 1731 1656 1732 1483 1731 1732 1483 1732 1480 1478 1479 1480 1479 1481 1480 1480 1481 1482 1480 1482 1483 1475 1477 1478 1478 1477 1479 1478 1734 1475 1481 1479 1576 1576 1479 1477 1575 1482 1481 1575 1481 1576 1483 1482 1484 1574 1484 1482 1574 1482 1575 1173 1574 1575 1173 1575 1174 1174 1575 1576 1576 1477 1577 1174 1576 1175 1175 1576 1577 1173 1174 1171 1171 1174 1175 1171 1172 1173 1172 1182 1173 1182 1574 1173 1171 1175 1166 1148 1172 1171 1148 1171 1166 1166 1175 1176 1175 1577 1176 1165 1166 1167 1166 1176 1167 1166 1165 1148 1176 1577 1578 1176 1578 1167 1167 1168 1165 1167 1578 1580 1167 1580 1168 1165 1168 1169 1165 1169 1160 1148 1165 1160 1168 1580 1579 1168 1579 1169 1472 1579 1580 1472 1580 1578 1471 1579 1472 1471 1463 1579 1579 1463 1470 1579 1470 1581 1169 1579 1581 1160 1169 1170 1169 1581 1170 1581 1470 1582 1170 1581 1582 1465 1469 1470 1465 1470 1463 1470 1469 1582 1463 1464 1465 1463 1471 1464 1464 1471 1472 1464 1472 1473 1473 1736 1464 1464 1736 1737 1464 1737 1465 1468 1469 1465 1465 1737 1738 1465 1738 1468 1468 1467 1469 1582 1469 1467 1457 1467 1468 1468 1738 1739 1468 1739 1457 1737 1662 1738 1738 1662 1663 1738 1663 1739 1736 1661 1737 1737 1661 1662 1661 1277 1662 1662 1277 1276 1662 1276 1663 1663 1276 1275 1663 1275 1664 1739 1663 1664 1739 1664 1740 1457 1739 1740 1664 1275 1274 1664 1274 1665 1740 1664 1665 1740 1665 1741 1457 1740 1455 1455 1740 1741 1665 1274 1273 1665 1273 1666 1741 1665 1666 1741 1666 1742 1455 1741 1453 1453 1741 1742 1453 1454 1455 1455 1454 1456 1455 1456 1457 1456 1466 1457 1457 1466 1467 1456 1583 1466 1456 1454 1583 1453 1462 1454 1583 1454 1462 1466 1583 1584 1583 1462 1585 1162 1584 1583 1162 1583 1163 1163 1583 1585 1582 1467 1466 1466 1584 1582 1161 1582 1584 1161 1584 1162 1161 1162 1159 1159 1162 1163 1159 1163 1154 1154 1163 1164 1163 1585 1164 1585 1462 1586 1164 1585 1586 1154 1164 1155 1164 1586 1155 1153 1154 1155 1153 1159 1154 1159 1160 1161 1148 1159 1153 1148 1160 1159 1155 1156 1153 1153 1156 1157 1153 1157 1148 1155 1586 1588 1155 1588 1156 1156 1588 1587 1156 1587 1157 1458 1587 1588 1458 1588 1586 1446 1587 1458 1446 1444 1587 1587 1444 1452 1446 1458 1447 1447 1458 1459 1586 1459 1458 1445 1444 1446 1445 1446 1447 1443 1444 1445 1443 1452 1444 1447 1744 1445 1445 1744 1745 1445 1745 1443 1443 1745 1746 1744 1669 1745 1745 1669 1670 1745 1670 1746 1743 1668 1744 1744 1668 1669 1447 1743 1744 1668 1260 1669 1669 1260 1258 1669 1258 1670 1670 1258 1257 1670 1257 1671 1746 1670 1671 1668 1261 1260 1667 1261 1668 1743 1667 1668 1667 1272 1261 1666 1272 1667 1742 1666 1667 1742 1667 1743 1666 1273 1272 1460 1742 1743 1460 1743 1447 1453 1742 1460 1447 1459 1460 1460 1459 1461 1460 1461 1453 1453 1461 1462 1462 1461 1586 1586 1461 1459 1189 1148 1190 1190 1148 1195 1177 1172 1148 1189 1190 1191 1191 1192 1189 1195 1199 1190 1190 1199 1200 1190 1200 1191 1200 1562 1191 1191 1562 1563 1191 1563 1192 1192 1563 1564 1562 1512 1563 1563 1512 1511 1563 1511 1564 1511 1509 1564 1509 1511 1510 1510 1511 1512 1510 1512 1513 1513 1512 1514 1562 1514 1512 1508 1509 1510 1513 1720 1510 1510 1720 1721 1510 1721 1508 1513 1514 1515 1515 1719 1513 1513 1719 1720 1514 1516 1515 1516 1514 1562 1515 1516 1517 1515 1517 1518 1518 1718 1515 1515 1718 1719 1718 1643 1719 1719 1643 1644 1719 1644 1720 1717 1642 1718 1718 1642 1643 1518 1717 1718 1518 1517 1519 1518 1519 1520 1520 1717 1518 1716 1641 1717 1717 1641 1642 1520 1716 1717 1641 1313 1642 1642 1313 1312 1642 1312 1643 1640 1315 1641 1641 1315 1313 1716 1640 1641 1715 1640 1716 1333 1715 1716 1333 1716 1520 1639 1316 1640 1640 1316 1315 1715 1639 1640 1314 1313 1315 1315 1316 1314 1314 1316 1317 1639 1317 1316 1638 1317 1639 1714 1638 1639 1714 1639 1715 1335 1714 1715 1335 1715 1333 1337 1714 1335 1333 1334 1335 1335 1334 1336 1335 1336 1337 1336 1343 1337 1337 1343 1344 1556 1343 1336 1556 1336 1557 1336 1334 1557 1333 1522 1334 1557 1334 1522 1557 1522 1558 1205 1556 1557 1205 1557 1206 1206 1557 1558 1333 1521 1522 1558 1522 1521 1520 1521 1333 1520 1519 1521 1558 1521 1559 1559 1521 1519 1206 1558 1197 1197 1558 1559 1196 1205 1206 1196 1206 1197 1195 1196 1197 1197 1198 1195 1197 1559 1198 1559 1519 1560 1198 1559 1560 1560 1519 1517 1560 1517 1561 1198 1560 1199 1199 1560 1561 1195 1198 1199 1144 1254 1195 1195 1254 1249 1195 1249 1196 1143 1252 1144 1144 1252 1253 1144 1253 1254 1254 1253 1255 1254 1255 1249 1252 1599 1253 1253 1599 1600 1253 1600 1255 1143 1598 1252 1252 1598 1599 1598 1429 1599 1599 1429 1427 1599 1427 1600 1600 1427 1426 1600 1426 1523 1255 1600 1523 1249 1255 1256 1255 1523 1256 1523 1417 1524 1523 1426 1419 1523 1419 1417 1256 1523 1524 1419 1426 1420 1420 1426 1427 1420 1427 1428 1428 1427 1429 1418 1419 1420 1418 1417 1419 1415 1416 1417 1415 1417 1418 1524 1417 1416 1413 1414 1415 1414 1416 1415 1524 1416 1525 1416 1414 1525 1413 1412 1414 1525 1414 1412 1410 1412 1413 1410 1411 1412 1525 1412 1526 1526 1412 1411 1250 1524 1525 1250 1525 1251 1251 1525 1526 1526 1411 1527 1251 1526 1248 1248 1526 1527 1409 1411 1410 1411 1409 1527 1408 1409 1410 1408 1407 1409 1527 1409 1407 1527 1407 1528 1248 1527 1246 1246 1527 1528 1246 1247 1248 1247 1251 1248 1247 1250 1251 1246 1245 1247 1249 1250 1247 1244 1245 1246 1246 1528 1244 1244 1239 1245 1237 1239 1244 1244 1528 1529 1244 1529 1237 1237 1238 1239 1239 1238 1240 1239 1240 1241 1237 1529 1530 1237 1530 1238 1238 1530 1531 1238 1531 1240 1241 1240 1242 1240 1531 1532 1240 1532 1242 1241 1242 1234 1234 1242 1243 1242 1532 1533 1242 1533 1243 1531 1397 1532 1532 1397 1396 1532 1396 1533 1396 1394 1533 1533 1394 1392 1533 1392 1534 1243 1533 1534 1394 1396 1395 1395 1396 1397 1395 1397 1398 1398 1397 1399 1531 1399 1397 1398 1399 1400 1399 1401 1400 1401 1399 1531 1530 1401 1531 1400 1401 1402 1530 1402 1401 1400 1402 1403 1403 1402 1404 1529 1404 1402 1529 1402 1530 1403 1404 1405 1404 1406 1405 1406 1404 1529 1528 1406 1529 1405 1406 1407 1528 1407 1406 1405 1407 1408 1249 1256 1250 1256 1524 1250 1201 1249 1202 1196 1249 1201 1201 1202 1203 1203 1204 1201 1201 1204 1205 1201 1205 1196 1203 1555 1204 1204 1555 1556 1204 1556 1205 1555 1344 1343 1555 1343 1556 1199 1561 1200 1561 1517 1516 1561 1516 1562 1200 1561 1562 1638 1318 1317 1314 1317 1318 1302 1313 1314 1300 1301 1302 1302 1311 1300 1301 1312 1302 1302 1312 1313 1644 1301 1300 1644 1300 1645 1645 1300 1311 1643 1312 1301 1643 1301 1644 1720 1644 1645 1720 1645 1721 1177 1181 1172 1172 1181 1182 1177 1180 1181 1180 1572 1181 1181 1572 1573 1181 1573 1182 1182 1573 1574 1572 1487 1573 1573 1487 1486 1573 1486 1574 1491 1489 1572 1572 1489 1487 1485 1486 1487 1485 1487 1488 1488 1487 1489 1484 1486 1485 1486 1484 1574 1483 1484 1485 1488 1730 1485 1485 1730 1731 1485 1731 1483 1488 1489 1490 1490 1729 1488 1488 1729 1730 1489 1491 1490 1490 1728 1729 1728 1653 1729 1729 1653 1654 1729 1654 1730 1730 1654 1655 1730 1655 1731 1731 1655 1656 1654 1279 1655 1655 1279 1278 1655 1278 1656 1653 1295 1654 1654 1295 1279 1653 1296 1295 1160 1170 1161 1170 1582 1161 1661 1292 1277 1660 1292 1661 1736 1660 1661 1660 1293 1292 1659 1293 1660 1735 1659 1660 1735 1660 1736 1473 1735 1736 1734 1659 1735 1475 1734 1735 1475 1735 1473 1473 1472 1474 1473 1474 1475 1474 1476 1475 1475 1476 1477 1578 1476 1474 1578 1474 1472 1577 1477 1476 1577 1476 1578 1595 1438 1424 1424 1438 1425 1423 1424 1425 1425 1752 1423))
                   (list :vertices (let ((mat (make-matrix 1753 3))) (fvector-replace (array-entity mat) #f(3.3000000000000000e+01 2.1043399810791016e+01 -4.3696899414062500e+01 3.3000000000000000e+01 3.0239200592041016e+01 -3.7918800354003906e+01 3.3000000000000000e+01 -4.7284000396728516e+01 1.0792200088500977e+01 3.3000000000000000e+01 -4.3696899414062500e+01 2.1043399810791016e+01 3.3000000000000000e+01 -3.0239200592041016e+01 3.7918800354003906e+01 3.3000000000000000e+01 3.7918800354003906e+01 -3.0239200592041016e+01 3.3000000000000000e+01 4.3696899414062500e+01 -2.1043399810791016e+01 3.3000000000000000e+01 -3.7918800354003906e+01 3.0239200592041016e+01 3.3000000000000000e+01 -1.0792200088500977e+01 4.7284000396728516e+01 3.3000000000000000e+01 2.1043399810791016e+01 4.3696899414062500e+01 3.3000000000000000e+01 0.0000000000000000e+00 4.8500000000000000e+01 3.3000000000000000e+01 1.0792200088500977e+01 4.7284000396728516e+01 3.3000000000000000e+01 -2.1043399810791016e+01 4.3696899414062500e+01 3.3000000000000000e+01 3.0239200592041016e+01 3.7918800354003906e+01 3.3000000000000000e+01 -4.8500000000000000e+01 0.0000000000000000e+00 3.3000000000000000e+01 -4.7284000396728516e+01 -1.0792200088500977e+01 3.3000000000000000e+01 -4.3696899414062500e+01 -2.1043399810791016e+01 3.3000000000000000e+01 4.7284000396728516e+01 -1.0792200088500977e+01 3.3000000000000000e+01 4.8500000000000000e+01 0.0000000000000000e+00 3.3000000000000000e+01 4.7284000396728516e+01 1.0792200088500977e+01 3.3000000000000000e+01 4.3696899414062500e+01 2.1043399810791016e+01 3.3000000000000000e+01 3.7918800354003906e+01 3.0239200592041016e+01 3.3000000000000000e+01 -3.7918800354003906e+01 -3.0239200592041016e+01 3.3000000000000000e+01 -3.0239200592041016e+01 -3.7918800354003906e+01 3.3000000000000000e+01 -2.1043399810791016e+01 -4.3696899414062500e+01 3.3000000000000000e+01 -1.0792200088500977e+01 -4.7284000396728516e+01 3.3000000000000000e+01 0.0000000000000000e+00 -4.8500000000000000e+01 3.3000000000000000e+01 1.0792200088500977e+01 -4.7284000396728516e+01 -2.2748199462890625e+01 7.0116500854492188e+00 -5.1525001525878906e+01 -2.2956899642944336e+01 8.4111700057983398e+00 -5.1305801391601562e+01 3.0500000000000000e+01 8.3633098602294922e+00 -5.1014099121093750e+01 -2.7954601287841797e+01 1.9246200561523438e+01 4.8304199218750000e+01 -2.6347799301147461e+01 1.7014799118041992e+01 4.9137500762939453e+01 3.0500000000000000e+01 1.9134300231933594e+01 4.8023601531982422e+01 -2.4977300643920898e+01 1.4611200332641602e+01 4.9904998779296875e+01 -2.4261800765991211e+01 1.3036600112915039e+01 5.0339302062988281e+01 -2.3501399993896484e+01 1.0876399993896484e+01 5.0849800109863281e+01 -2.2987899780273438e+01 8.7240304946899414e+00 5.1262901306152344e+01 3.0500000000000000e+01 1.3911399841308594e+01 5.0104598999023438e+01 -2.2934900283813477e+01 8.4125404357910156e+00 5.1314300537109375e+01 3.0500000000000000e+01 8.3633098602294922e+00 5.1014099121093750e+01 -2.2899101257324219e+01 8.2020797729492188e+00 5.1348999023437500e+01 -4.0532001495361328e+01 2.9175199508666992e+01 4.3030002593994141e+01 -3.7616397857666016e+01 2.7595600128173828e+01 4.4073600769042969e+01 3.0500000000000000e+01 2.9010599136352539e+01 4.2787498474121094e+01 -3.3973602294921875e+01 2.5108100891113281e+01 4.5536598205566406e+01 -3.2748699188232422e+01 2.4129899978637695e+01 4.6062397003173828e+01 -3.0022399902343750e+01 2.1608499526977539e+01 4.7297599792480469e+01 -2.8035299301147461e+01 1.9358299255371094e+01 4.8262397766113281e+01 3.0500000000000000e+01 2.4357200622558594e+01 4.5942600250244141e+01 -5.9011898040771484e+01 3.4017002105712891e+01 3.9329902648925781e+01 -5.5310699462890625e+01 3.3798198699951172e+01 3.9518100738525391e+01 3.0500000000000000e+01 3.7530399322509766e+01 3.5550697326660156e+01 -5.1370502471923828e+01 3.3133598327636719e+01 4.0076999664306641e+01 -4.7167499542236328e+01 3.1981300354003906e+01 4.1002399444580078e+01 -4.5671298980712891e+01 3.1462699890136719e+01 4.1401699066162109e+01 -4.1533000946044922e+01 2.9717498779296875e+01 4.2671600341796875e+01 3.0500000000000000e+01 3.3663997650146484e+01 3.9632400512695312e+01 -9.5712196350097656e+01 3.4017002105712891e+01 3.9329902648925781e+01 -9.1765594482421875e+01 3.7617401123046875e+01 3.5629997253417969e+01 -8.8888198852539062e+01 4.0242401123046875e+01 3.2932502746582031e+01 3.0500000000000000e+01 4.1396800994873047e+01 3.1468997955322266e+01 -8.4251800537109375e+01 4.4472000122070312e+01 2.6751600265502930e+01 3.0500000000000000e+01 4.4295398712158203e+01 2.6651599884033203e+01 -8.3376701354980469e+01 4.5270397186279297e+01 2.5584899902343750e+01 -7.9340400695800781e+01 4.8952602386474609e+01 1.7539600372314453e+01 3.0500000000000000e+01 4.7193901062011719e+01 2.1834199905395508e+01 -7.9062400817871094e+01 4.9206199645996094e+01 1.6584501266479492e+01 3.0500000000000000e+01 4.8989097595214844e+01 1.6506299972534180e+01 -7.6869697570800781e+01 5.1206600189208984e+01 9.0486402511596680e+00 3.0500000000000000e+01 5.0784198760986328e+01 1.1178400039672852e+01 -7.6525703430175781e+01 5.1520401000976562e+01 5.6062297821044922e+00 3.0500000000000000e+01 5.1392101287841797e+01 5.5891900062561035e+00 -7.6001396179199219e+01 5.1998699188232422e+01 3.5883697867393494e-01 3.0500000000000000e+01 5.2000000000000000e+01 0.0000000000000000e+00 -7.6504501342773438e+01 5.1539802551269531e+01 -5.6102299690246582e+00 3.0500000000000000e+01 4.4295398712158203e+01 -2.6651599884033203e+01 -7.9031898498535156e+01 4.9234100341796875e+01 -1.6733299255371094e+01 3.0500000000000000e+01 4.7193901062011719e+01 -2.1834199905395508e+01 -7.8995803833007812e+01 4.9267002105712891e+01 -1.6600898742675781e+01 3.0500000000000000e+01 4.8989097595214844e+01 -1.6506299972534180e+01 -7.6731506347656250e+01 5.1332599639892578e+01 -8.3039398193359375e+00 3.0500000000000000e+01 5.0784198760986328e+01 -1.1178400039672852e+01 3.0500000000000000e+01 5.1392101287841797e+01 -5.5891900062561035e+00 -8.8130104064941406e+01 4.0934001922607422e+01 -3.2068801879882812e+01 -8.4294494628906250e+01 4.4433097839355469e+01 -2.6728500366210938e+01 -8.2856399536132812e+01 4.5745101928710938e+01 -2.4726299285888672e+01 -5.2211097717285156e+01 3.3310001373291016e+01 -3.9930500030517578e+01 -5.5906200408935547e+01 3.3861396789550781e+01 -3.9463901519775391e+01 3.0500000000000000e+01 3.7530399322509766e+01 -3.5550697326660156e+01 -5.9011898040771484e+01 3.4017002105712891e+01 -3.9329902648925781e+01 3.0500000000000000e+01 4.1396800994873047e+01 -3.1468997955322266e+01 -9.1767601013183594e+01 3.7615501403808594e+01 -3.5633300781250000e+01 -9.4733497619628906e+01 3.4909801483154297e+01 -3.8539600372314453e+01 -9.5712196350097656e+01 3.4017002105712891e+01 -3.9329902648925781e+01 -3.5427898406982422e+01 2.6170299530029297e+01 -4.4934501647949219e+01 -3.9401401519775391e+01 2.8625101089477539e+01 -4.3411998748779297e+01 3.0500000000000000e+01 2.9010599136352539e+01 -4.2787498474121094e+01 -4.0541500091552734e+01 2.9175199508666992e+01 -4.3030399322509766e+01 3.0500000000000000e+01 3.3663997650146484e+01 -3.9632400512695312e+01 -4.3549102783203125e+01 3.0626499176025391e+01 -4.2024002075195312e+01 -4.7789497375488281e+01 3.2180000305175781e+01 -4.0846599578857422e+01 3.0500000000000000e+01 1.9134300231933594e+01 -4.8023601531982422e+01 -2.7996400833129883e+01 1.9240699768066406e+01 -4.8291000366210938e+01 3.0500000000000000e+01 2.4357200622558594e+01 -4.5942600250244141e+01 -2.9610799789428711e+01 2.1176601409912109e+01 -4.7492599487304688e+01 -3.2358402252197266e+01 2.3800199508666992e+01 -4.6233596801757812e+01 -2.3999700546264648e+01 1.2368100166320801e+01 -5.0507698059082031e+01 -2.5024099349975586e+01 1.4704500198364258e+01 -4.9877597808837891e+01 3.0500000000000000e+01 1.3911399841308594e+01 -5.0104598999023438e+01 -2.3057399749755859e+01 9.0853004455566406e+00 -5.1200199127197266e+01 -2.3583398818969727e+01 1.1148300170898438e+01 -5.0790802001953125e+01 -2.6370100021362305e+01 1.7049299240112305e+01 -4.9125499725341797e+01 -2.7342699050903320e+01 1.8456800460815430e+01 -4.8614200592041016e+01 -2.2748199462890625e+01 7.0116500854492188e+00 5.1525001525878906e+01 -2.2494899749755859e+01 3.5138700008392334e+00 5.1881099700927734e+01 3.0500000000000000e+01 2.8151900768280029e+00 5.1923698425292969e+01 -2.2410299301147461e+01 0.0000000000000000e+00 5.2000000000000000e+01 3.0500000000000000e+01 -2.7986800670623779e+00 5.1619400024414062e+01 -2.2410299301147461e+01 -2.8151900768280029e+00 5.1923698425292969e+01 3.0500000000000000e+01 -8.4126596450805664e+00 5.1314903259277344e+01 -2.2410299301147461e+01 -8.4126596450805664e+00 5.1314903259277344e+01 3.0500000000000000e+01 -1.3829899787902832e+01 4.9810901641845703e+01 -2.2410299301147461e+01 -1.3911399841308594e+01 5.0104598999023438e+01 3.0500000000000000e+01 -1.9247200012207031e+01 4.8306800842285156e+01 -2.2410299301147461e+01 -1.9247200012207031e+01 4.8306800842285156e+01 3.0500000000000000e+01 -2.4214399337768555e+01 4.5673297882080078e+01 -2.2410299301147461e+01 -2.4357200622558594e+01 4.5942600250244141e+01 3.0500000000000000e+01 -2.9181699752807617e+01 4.3039798736572266e+01 -2.2410299301147461e+01 -2.9181699752807617e+01 4.3039798736572266e+01 3.0500000000000000e+01 -3.3466701507568359e+01 3.9400100708007812e+01 -2.2410299301147461e+01 -3.3663997650146484e+01 3.9632400512695312e+01 3.0500000000000000e+01 -3.7751701354980469e+01 3.5760299682617188e+01 -2.2410299301147461e+01 -3.7751701354980469e+01 3.5760299682617188e+01 3.0500000000000000e+01 -4.1154102325439453e+01 3.1284601211547852e+01 -2.2410299301147461e+01 -4.1396800994873047e+01 3.1468997955322266e+01 3.0500000000000000e+01 -4.4556598663330078e+01 2.6808799743652344e+01 -2.2410299301147461e+01 -4.4556598663330078e+01 2.6808799743652344e+01 3.0500000000000000e+01 -4.6917198181152344e+01 2.1706199645996094e+01 -2.2410299301147461e+01 -4.7193901062011719e+01 2.1834199905395508e+01 3.0500000000000000e+01 -4.9277999877929688e+01 1.6603599548339844e+01 -2.2410299301147461e+01 -4.9277999877929688e+01 1.6603599548339844e+01 3.0500000000000000e+01 -5.0486598968505859e+01 1.1112900733947754e+01 -2.2410299301147461e+01 -5.0784198760986328e+01 1.1178400039672852e+01 3.0500000000000000e+01 -5.1695201873779297e+01 5.6221499443054199e+00 -2.2410299301147461e+01 -5.1695201873779297e+01 5.6221499443054199e+00 3.0500000000000000e+01 -5.2000000000000000e+01 0.0000000000000000e+00 -2.2410299301147461e+01 -5.2000000000000000e+01 0.0000000000000000e+00 3.0500000000000000e+01 -5.1695201873779297e+01 -5.6221499443054199e+00 -2.2410299301147461e+01 -5.1695201873779297e+01 -5.6221499443054199e+00 3.0500000000000000e+01 -5.0486598968505859e+01 -1.1112900733947754e+01 -2.2410299301147461e+01 -5.0784198760986328e+01 -1.1178400039672852e+01 3.0500000000000000e+01 -4.9277999877929688e+01 -1.6603599548339844e+01 -2.2410299301147461e+01 -4.9277999877929688e+01 -1.6603599548339844e+01 3.0500000000000000e+01 -4.6917198181152344e+01 -2.1706199645996094e+01 -2.2410299301147461e+01 -4.7193901062011719e+01 -2.1834199905395508e+01 3.0500000000000000e+01 -4.4556598663330078e+01 -2.6808799743652344e+01 -2.2410299301147461e+01 -4.4556598663330078e+01 -2.6808799743652344e+01 3.0500000000000000e+01 -4.1154102325439453e+01 -3.1284601211547852e+01 -2.2410299301147461e+01 -4.1396800994873047e+01 -3.1468997955322266e+01 3.0500000000000000e+01 -3.7751701354980469e+01 -3.5760299682617188e+01 -2.2410299301147461e+01 -3.7751701354980469e+01 -3.5760299682617188e+01 3.0500000000000000e+01 -3.3466701507568359e+01 -3.9400100708007812e+01 -2.2410299301147461e+01 -3.3663997650146484e+01 -3.9632400512695312e+01 3.0500000000000000e+01 -2.9181699752807617e+01 -4.3039798736572266e+01 -2.2410299301147461e+01 -2.9181699752807617e+01 -4.3039798736572266e+01 3.0500000000000000e+01 -2.4214399337768555e+01 -4.5673297882080078e+01 -2.2410299301147461e+01 -2.4357200622558594e+01 -4.5942600250244141e+01 3.0500000000000000e+01 -1.9247200012207031e+01 -4.8306800842285156e+01 -2.2410299301147461e+01 -1.9247200012207031e+01 -4.8306800842285156e+01 3.0500000000000000e+01 -1.3829899787902832e+01 -4.9810901641845703e+01 -2.2410299301147461e+01 -1.3911399841308594e+01 -5.0104598999023438e+01 3.0500000000000000e+01 -8.4126596450805664e+00 -5.1314903259277344e+01 -2.2410299301147461e+01 -8.4126596450805664e+00 -5.1314903259277344e+01 3.0500000000000000e+01 -2.7986800670623779e+00 -5.1619400024414062e+01 -2.2410299301147461e+01 -2.8151900768280029e+00 -5.1923698425292969e+01 3.0500000000000000e+01 2.8151900768280029e+00 -5.1923698425292969e+01 -2.2410299301147461e+01 0.0000000000000000e+00 -5.2000000000000000e+01 -2.2494899749755859e+01 3.5138700008392334e+00 -5.1881099700927734e+01 -8.1500000000000000e+01 5.8500000000000000e+01 0.0000000000000000e+00 -8.1801895141601562e+01 5.8500000000000000e+01 -5.5680899620056152e+00 -1.8450000000000000e+02 5.8500000000000000e+01 0.0000000000000000e+00 -8.4195899963378906e+01 5.8500000000000000e+01 -1.6444000244140625e+01 -8.8871902465820312e+01 5.8500000000000000e+01 -2.6551000595092773e+01 -9.5611297607421875e+01 5.8500000000000000e+01 -3.5416500091552734e+01 -1.0409899902343750e+02 5.8500000000000000e+01 -4.2625999450683594e+01 -8.1801895141601562e+01 5.8500000000000000e+01 5.5680899620056152e+00 -1.8329598999023438e+02 5.8500000000000000e+01 1.1071000099182129e+01 -1.7973999023437500e+02 5.8500000000000000e+01 2.1624300003051758e+01 -1.7399899291992188e+02 5.8500000000000000e+01 3.1166400909423828e+01 -1.6633999633789062e+02 5.8500000000000000e+01 3.9251300811767578e+01 -1.5712300109863281e+02 5.8500000000000000e+01 4.5500900268554688e+01 -1.1393799591064453e+02 5.8500000000000000e+01 -4.7842300415039062e+01 -1.2466799926757812e+02 5.8500000000000000e+01 -5.0821502685546875e+01 -1.3578799438476562e+02 5.8500000000000000e+01 -5.1424400329589844e+01 -1.4677799987792969e+02 5.8500000000000000e+01 4.9622798919677734e+01 -1.3578799438476562e+02 5.8500000000000000e+01 5.1424400329589844e+01 -1.2466799926757812e+02 5.8500000000000000e+01 5.0821502685546875e+01 -8.4195899963378906e+01 5.8500000000000000e+01 1.6444000244140625e+01 -8.8871902465820312e+01 5.8500000000000000e+01 2.6551000595092773e+01 -9.5611297607421875e+01 5.8500000000000000e+01 3.5416500091552734e+01 -1.1393799591064453e+02 5.8500000000000000e+01 4.7842300415039062e+01 -1.0409899902343750e+02 5.8500000000000000e+01 4.2625999450683594e+01 -1.7399899291992188e+02 5.8500000000000000e+01 -3.1166400909423828e+01 -1.7973999023437500e+02 5.8500000000000000e+01 -2.1624300003051758e+01 -1.6633999633789062e+02 5.8500000000000000e+01 -3.9251300811767578e+01 -1.5712300109863281e+02 5.8500000000000000e+01 -4.5500900268554688e+01 -1.4677799987792969e+02 5.8500000000000000e+01 -4.9622798919677734e+01 -1.8329598999023438e+02 5.8500000000000000e+01 -1.1071000099182129e+01 -9.8982994079589844e+01 3.7287799835205078e+01 -3.9329902648925781e+01 -9.9336997985839844e+01 3.6887500762939453e+01 -3.9631099700927734e+01 -9.9533294677734375e+01 5.8000000000000000e+01 -3.9400100708007812e+01 -8.1006103515625000e+01 3.2454099655151367e+00 -7.9595297574996948e-01 -8.1000000000000000e+01 1.9999700784683228e+00 0.0000000000000000e+00 -8.2219200134277344e+01 3.6428000926971436e+00 -1.1177999496459961e+01 -8.2215797424316406e+01 1.9999700784683228e+00 -1.1178400039672852e+01 -8.2223304748535156e+01 3.6441700458526611e+00 -1.1212600708007812e+01 -8.5806098937988281e+01 1.9999700784683228e+00 -2.1834199905395508e+01 -8.5505798339843750e+01 4.0254001617431641e+00 -2.1173101425170898e+01 -9.1473495483398438e+01 5.2299499511718750e+00 -3.1297601699829102e+01 -8.9688598632812500e+01 4.5236296653747559e+00 -2.8777000427246094e+01 -9.1603195190429688e+01 1.9999700784683228e+00 -3.1468997955322266e+01 -8.8063400268554688e+01 4.2165498733520508e+00 -2.6166700363159180e+01 -8.5836502075195312e+01 4.0501298904418945e+00 -2.1818599700927734e+01 -9.8498901367187500e+01 1.0602099418640137e+01 -3.8905899047851562e+01 -9.7531105041503906e+01 9.6309204101562500e+00 -3.8025699615478516e+01 -9.9335998535156250e+01 1.9999700784683228e+00 -3.9632400512695312e+01 -9.5414604187011719e+01 7.7754197120666504e+00 -3.5935100555419922e+01 -9.3316596984863281e+01 6.2691602706909180e+00 -3.3603900909423828e+01 -9.1607597351074219e+01 5.3055901527404785e+00 -3.1465499877929688e+01 -1.0281100463867188e+02 3.1981597900390625e+01 -4.2339500427246094e+01 -1.0385300445556641e+02 2.9737800598144531e+01 -4.3063301086425781e+01 -1.0878600311279297e+02 5.8000000000000000e+01 -4.5673297882080078e+01 -1.0451499938964844e+02 2.7640199661254883e+01 -4.3504302978515625e+01 -1.0484500122070312e+02 2.5788700103759766e+01 -4.3718200683593750e+01 -1.0381800079345703e+02 5.8000000000000000e+01 -4.3039798736572266e+01 -9.9622200012207031e+01 3.6565097808837891e+01 -3.9873699188232422e+01 -1.0137000274658203e+02 3.4311801910400391e+01 -4.1274101257324219e+01 -1.0864300537109375e+02 1.9999700784683228e+00 -4.5942600250244141e+01 -1.0492900085449219e+02 2.3813299179077148e+01 -4.3771999359130859e+01 -1.0476700592041016e+02 2.2039199829101562e+01 -4.3668300628662109e+01 -1.0431999969482422e+02 2.0041999816894531e+01 -4.3375999450683594e+01 -1.0358000183105469e+02 1.8007301330566406e+01 -4.2877597808837891e+01 -1.0252700042724609e+02 1.5917799949645996e+01 -4.2135799407958984e+01 -1.0190299987792969e+02 1.4891300201416016e+01 -4.1676700592041016e+01 -1.0029399871826172e+02 1.2655799865722656e+01 -4.0426399230957031e+01 -9.9344497680664062e+01 1.1569700241088867e+01 -3.9622299194335938e+01 -8.1793395996093750e+01 5.6130302429199219e+01 9.0486402511596680e+00 -8.1001296997070312e+01 5.6998600006103516e+01 3.5883697867393494e-01 -8.1000000000000000e+01 5.8000000000000000e+01 0.0000000000000000e+00 -8.1028701782226562e+01 5.6968601226806641e+01 2.1984798368066549e-03 -8.1304801940917969e+01 5.8000000000000000e+01 -5.6221499443054199e+00 -8.1667404174804688e+01 5.6268497467041016e+01 -8.3039398193359375e+00 -8.2513397216796875e+01 5.8000000000000000e+01 -1.1112900733947754e+01 -8.2373199462890625e+01 5.5494701385498047e+01 -1.1139299392700195e+01 -8.3722000122070312e+01 5.8000000000000000e+01 -1.6603599548339844e+01 -8.3765899658203125e+01 5.3968101501464844e+01 -1.6733299255371094e+01 -8.6082801818847656e+01 5.8000000000000000e+01 -2.1706199645996094e+01 -8.5962600708007812e+01 5.1560199737548828e+01 -2.1765600204467773e+01 -8.8443397521972656e+01 5.8000000000000000e+01 -2.6808799743652344e+01 -8.7254898071289062e+01 5.0143600463867188e+01 -2.4726299285888672e+01 -9.1845901489257812e+01 5.8000000000000000e+01 -3.1284601211547852e+01 -9.1651901245117188e+01 4.5323902130126953e+01 -3.1436700820922852e+01 -9.5248298645019531e+01 5.8000000000000000e+01 -3.5760299682617188e+01 -9.2065994262695312e+01 4.4869899749755859e+01 -3.2068801879882812e+01 -9.8090202331542969e+01 3.8266498565673828e+01 -3.8539600372314453e+01 -8.1304801940917969e+01 5.8000000000000000e+01 5.6221499443054199e+00 -8.2513397216796875e+01 5.8000000000000000e+01 1.1112900733947754e+01 -8.2349395751953125e+01 5.5520900726318359e+01 1.1143100738525391e+01 -8.3722000122070312e+01 5.8000000000000000e+01 1.6603599548339844e+01 -8.4047401428222656e+01 5.3659599304199219e+01 1.7539600372314453e+01 -8.6082801818847656e+01 5.8000000000000000e+01 2.1706199645996094e+01 -8.5977096557617188e+01 5.1544300079345703e+01 2.1755899429321289e+01 -8.8443397521972656e+01 5.8000000000000000e+01 2.6808799743652344e+01 -8.7729606628417969e+01 4.9623298645019531e+01 2.5584899902343750e+01 -9.1845901489257812e+01 5.8000000000000000e+01 3.1284601211547852e+01 -9.1707000732421875e+01 4.5263397216796875e+01 3.1397201538085938e+01 -9.9340995788574219e+01 3.6858798980712891e+01 3.9626300811767578e+01 -9.8982994079589844e+01 3.7287799835205078e+01 3.9329902648925781e+01 -9.9533294677734375e+01 5.8000000000000000e+01 3.9400100708007812e+01 -9.2757598876953125e+01 4.4111801147460938e+01 3.2932502746582031e+01 -9.5248298645019531e+01 5.8000000000000000e+01 3.5760299682617188e+01 -1.0259700012207031e+02 1.6040500640869141e+01 4.2186302185058594e+01 -1.0372200012207031e+02 1.8342100143432617e+01 4.2974201202392578e+01 -1.0864300537109375e+02 1.9999700784683228e+00 4.5942600250244141e+01 -9.9335998535156250e+01 1.9999700784683228e+00 3.9632400512695312e+01 -9.9337097167968750e+01 1.1522900581359863e+01 3.9631000518798828e+01 -1.0108300018310547e+02 1.3692599296569824e+01 4.1052200317382812e+01 -1.0443700408935547e+02 2.0458801269531250e+01 4.3452697753906250e+01 -1.0479599761962891e+02 2.2233798980712891e+01 4.3686698913574219e+01 -1.0493399810791016e+02 2.4209100723266602e+01 4.3775600433349609e+01 -1.0482399749755859e+02 2.5961700439453125e+01 4.3705001831054688e+01 -1.0878600311279297e+02 5.8000000000000000e+01 4.5673297882080078e+01 -1.0443600463867188e+02 2.7952798843383789e+01 4.3452198028564453e+01 -1.0377700042724609e+02 2.9930799484252930e+01 4.3011699676513672e+01 -1.0279799652099609e+02 3.2006900787353516e+01 4.2329799652099609e+01 -1.0223799896240234e+02 3.2981498718261719e+01 4.1924701690673828e+01 -1.0070899963378906e+02 3.5219200134277344e+01 4.0759101867675781e+01 -1.0381800079345703e+02 5.8000000000000000e+01 4.3039798736572266e+01 -9.1603195190429688e+01 1.9999700784683228e+00 3.1468997955322266e+01 -9.2334098815917969e+01 5.6798996925354004e+00 3.2408100128173828e+01 -9.4176597595214844e+01 6.8467798233032227e+00 3.4593898773193359e+01 -9.6259994506835938e+01 8.4750595092773438e+00 3.6798999786376953e+01 -9.8362899780273438e+01 1.0460499763488770e+01 3.8784900665283203e+01 -9.9273002624511719e+01 1.1443199157714844e+01 3.9578899383544922e+01 -8.8867698669433594e+01 4.3214602470397949e+00 2.7501499176025391e+01 -9.0528099060058594e+01 4.8144998550415039e+00 3.0002199172973633e+01 -9.1619796752929688e+01 5.3376603126525879e+00 3.1456501007080078e+01 -8.5806098937988281e+01 1.9999700784683228e+00 2.1834199905395508e+01 -8.2215797424316406e+01 1.9999700784683228e+00 1.1178400039672852e+01 -8.2472694396972656e+01 3.6405899524688721e+00 1.1119799613952637e+01 -8.3726898193359375e+01 3.8510601520538330e+00 1.6618000030517578e+01 -8.6046302795410156e+01 4.0465598106384277e+00 2.1725099563598633e+01 -8.8063400268554688e+01 4.2165498733520508e+00 2.6166700363159180e+01 -8.1000000000000000e+01 3.2301499843597412e+00 0.0000000000000000e+00 -8.1006103515625000e+01 3.2454099655151367e+00 7.9595297574996948e-01 -8.1394500732421875e+01 3.4596300125122070e+00 6.3931899070739746e+00 -1.1375299835205078e+02 5.8000000000000000e+01 4.8306800842285156e+01 -1.1908899688720703e+02 1.9999700784683228e+00 5.0104598999023438e+01 -1.1917000579833984e+02 5.8000000000000000e+01 4.9810901641845703e+01 -1.2458699798583984e+02 5.8000000000000000e+01 5.1314903259277344e+01 -1.3018499755859375e+02 1.9999700784683228e+00 5.1923698425292969e+01 -1.3020100402832031e+02 5.8000000000000000e+01 5.1619400024414062e+01 -1.3581498718261719e+02 5.8000000000000000e+01 5.1923698425292969e+01 -1.4141300964355469e+02 1.9999700784683228e+00 5.1314903259277344e+01 -1.4136299133300781e+02 5.8000000000000000e+01 5.1014099121093750e+01 -1.4691099548339844e+02 5.8000000000000000e+01 5.0104598999023438e+01 -1.5224699401855469e+02 1.9999700784683228e+00 4.8306800842285156e+01 -1.5213400268554688e+02 5.8000000000000000e+01 4.8023601531982422e+01 -1.5735700988769531e+02 5.8000000000000000e+01 4.5942600250244141e+01 -1.6218200683593750e+02 1.9999700784683228e+00 4.3039798736572266e+01 -1.6201100158691406e+02 5.8000000000000000e+01 4.2787498474121094e+01 -1.6666400146484375e+02 5.8000000000000000e+01 3.9632400512695312e+01 -1.7075199890136719e+02 1.9999700784683228e+00 3.5760299682617188e+01 -1.7052999877929688e+02 5.8000000000000000e+01 3.5550697326660156e+01 -1.7439700317382812e+02 5.8000000000000000e+01 3.1468997955322266e+01 -1.7755700683593750e+02 1.9999700784683228e+00 2.6808799743652344e+01 -1.7729499816894531e+02 5.8000000000000000e+01 2.6651599884033203e+01 -1.8019400024414062e+02 5.8000000000000000e+01 2.1834199905395508e+01 -1.8227799987792969e+02 1.9999700784683228e+00 1.6603599548339844e+01 -1.8198899841308594e+02 5.8000000000000000e+01 1.6506299972534180e+01 -1.8378399658203125e+02 5.8000000000000000e+01 1.1178400039672852e+01 -1.8469500732421875e+02 1.9999700784683228e+00 5.6221499443054199e+00 -1.8439199829101562e+02 5.8000000000000000e+01 5.5891900062561035e+00 -1.8500000000000000e+02 5.8000000000000000e+01 0.0000000000000000e+00 -1.8469500732421875e+02 1.9999700784683228e+00 -5.6221499443054199e+00 -1.8439199829101562e+02 5.8000000000000000e+01 -5.5891900062561035e+00 -1.8378399658203125e+02 5.8000000000000000e+01 -1.1178400039672852e+01 -1.8227799987792969e+02 1.9999700784683228e+00 -1.6603599548339844e+01 -1.8198899841308594e+02 5.8000000000000000e+01 -1.6506299972534180e+01 -1.8019400024414062e+02 5.8000000000000000e+01 -2.1834199905395508e+01 -1.7755700683593750e+02 1.9999700784683228e+00 -2.6808799743652344e+01 -1.7729499816894531e+02 5.8000000000000000e+01 -2.6651599884033203e+01 -1.7439700317382812e+02 5.8000000000000000e+01 -3.1468997955322266e+01 -1.7075199890136719e+02 1.9999700784683228e+00 -3.5760299682617188e+01 -1.7052999877929688e+02 5.8000000000000000e+01 -3.5550697326660156e+01 -1.6666400146484375e+02 5.8000000000000000e+01 -3.9632400512695312e+01 -1.6218200683593750e+02 1.9999700784683228e+00 -4.3039798736572266e+01 -1.6201100158691406e+02 5.8000000000000000e+01 -4.2787498474121094e+01 -1.5735700988769531e+02 5.8000000000000000e+01 -4.5942600250244141e+01 -1.5224699401855469e+02 1.9999700784683228e+00 -4.8306800842285156e+01 -1.5213400268554688e+02 5.8000000000000000e+01 -4.8023601531982422e+01 -1.4691099548339844e+02 5.8000000000000000e+01 -5.0104598999023438e+01 -1.4141300964355469e+02 1.9999700784683228e+00 -5.1314903259277344e+01 -1.4136299133300781e+02 5.8000000000000000e+01 -5.1014099121093750e+01 -1.3581498718261719e+02 5.8000000000000000e+01 -5.1923698425292969e+01 -1.3018499755859375e+02 1.9999700784683228e+00 -5.1923698425292969e+01 -1.3020100402832031e+02 5.8000000000000000e+01 -5.1619400024414062e+01 -1.2458699798583984e+02 5.8000000000000000e+01 -5.1314903259277344e+01 -1.1908899688720703e+02 1.9999700784683228e+00 -5.0104598999023438e+01 -1.1375299835205078e+02 5.8000000000000000e+01 -4.8306800842285156e+01 -1.1917000579833984e+02 5.8000000000000000e+01 -4.9810901641845703e+01 -3.6164001464843750e+01 6.7081398963928223e+00 -4.4938098907470703e+01 -3.5144401550292969e+01 6.3148698806762695e+00 -4.5754997253417969e+01 -6.2765598297119141e+01 3.9620399475097656e+00 -1.7857799530029297e+01 -3.4358100891113281e+01 5.9177899360656738e+00 -4.6397296905517578e+01 -3.4033897399902344e+01 5.7084603309631348e+00 -4.6667800903320312e+01 -3.3615299224853516e+01 5.3515400886535645e+00 -4.7027599334716797e+01 -3.3354801177978516e+01 4.9890899658203125e+00 -4.7268699645996094e+01 -6.3267902374267578e+01 6.4255599975585938e+00 -1.8274101257324219e+01 -4.2855800628662109e+01 8.1760292053222656e+00 -3.9765201568603516e+01 -4.0613800048828125e+01 7.8058800697326660e+00 -4.1471099853515625e+01 -3.8585800170898438e+01 7.3860301971435547e+00 -4.3035999298095703e+01 -3.8247299194335938e+01 7.2970399856567383e+00 -4.3301002502441406e+01 -3.6895000457763672e+01 6.9414401054382324e+00 -4.4359298706054688e+01 -6.4558105468750000e+01 8.2491006851196289e+00 -1.9500600814819336e+01 -6.6301193237304688e+01 8.9589900970458984e+00 -2.1218898773193359e+01 -5.9011898040771484e+01 9.2135095596313477e+00 -2.8508199691772461e+01 -5.7037200927734375e+01 9.2276906967163086e+00 -2.9730298995971680e+01 -5.4609397888183594e+01 9.1820898056030273e+00 -3.1317300796508789e+01 -5.1613098144531250e+01 9.0471496582031250e+00 -3.3371200561523438e+01 -4.8664302825927734e+01 8.8367500305175781e+00 -3.5469299316406250e+01 -4.8396301269531250e+01 8.8104000091552734e+00 -3.5665298461914062e+01 -4.5721500396728516e+01 8.5473098754882812e+00 -3.7622200012207031e+01 -6.5883796691894531e+01 3.7792298793792725e+00 -1.3670900344848633e+01 -6.6224403381347656e+01 3.7592599391937256e+00 -1.3213600158691406e+01 -6.6838005065917969e+01 6.2341699600219727e+00 -1.3458199501037598e+01 -6.7816398620605469e+01 3.5686500072479248e+00 -8.8462800979614258e+00 -6.8207702636718750e+01 3.5218000411987305e+00 -7.7729201316833496e+00 -6.8875099182128906e+01 6.0101099014282227e+00 -7.8242998123168945e+00 -6.8623497009277344e+01 3.3447098731994629e+00 -3.7156898975372314e+00 -6.9293403625488281e+01 5.8431601524353027e+00 -3.6284298896789551e+00 -7.0665596008300781e+01 7.8375301361083984e+00 -8.1314401626586914e+00 -7.1123504638671875e+01 7.6721901893615723e+00 -3.5645999908447266e+00 -7.3103706359863281e+01 8.5187501907348633e+00 -8.6127500534057617e+00 -7.3623497009277344e+01 8.3416700363159180e+00 -3.5412299633026123e+00 -6.8445304870605469e+01 8.0594997406005859e+00 -1.4261799812316895e+01 -7.0624595642089844e+01 8.7562198638916016e+00 -1.5413500785827637e+01 -9.6412803649902344e+01 3.3474899291992188e+01 -3.9777000427246094e+01 -5.9011898040771484e+01 2.9182100296020508e+01 -4.2134799957275391e+01 -9.8328903198242188e+01 3.1784898757934570e+01 -4.0928199768066406e+01 -9.9908500671386719e+01 3.0037300109863281e+01 -4.1804100036621094e+01 -1.0222899627685547e+02 2.3910999298095703e+01 -4.2981899261474609e+01 -1.0213800048828125e+02 2.5392599105834961e+01 -4.2937599182128906e+01 -5.9011898040771484e+01 2.3655900955200195e+01 -4.2974700927734375e+01 -1.0177700042724609e+02 2.6781200408935547e+01 -4.2761699676513672e+01 -1.0104999542236328e+02 2.8354499816894531e+01 -4.2399200439453125e+01 -1.0049500274658203e+02 2.9173198699951172e+01 -4.2109703063964844e+01 -1.0156299591064453e+02 2.1082599639892578e+01 -4.2656299591064453e+01 -1.0205300140380859e+02 2.2580501556396484e+01 -4.2896598815917969e+01 -1.0219599914550781e+02 2.3656499862670898e+01 -4.2965499877929688e+01 -9.7148902893066406e+01 1.5543000221252441e+01 -4.0231399536132812e+01 -9.8912399291992188e+01 1.7219501495361328e+01 -4.1259201049804688e+01 -5.9011898040771484e+01 1.8206001281738281e+01 -4.1733100891113281e+01 -9.9597404479980469e+01 1.7989400863647461e+01 -4.1636600494384766e+01 -9.9760002136230469e+01 1.8210201263427734e+01 -4.1722499847412109e+01 -1.0075200653076172e+02 1.9556499481201172e+01 -4.2246498107910156e+01 -9.1800598144531250e+01 1.1882699966430664e+01 -3.6538997650146484e+01 -9.4120597839355469e+01 1.3274299621582031e+01 -3.8257698059082031e+01 -5.9011898040771484e+01 1.3589000701904297e+01 -3.8582500457763672e+01 -9.4587799072265625e+01 1.3595000267028809e+01 -3.8576400756835938e+01 -9.5181503295898438e+01 1.4002700805664062e+01 -3.8981300354003906e+01 -8.3742607116699219e+01 9.2135095596313477e+00 -2.8508199691772461e+01 -5.9011898040771484e+01 1.0446000099182129e+01 -3.3960201263427734e+01 -8.5524002075195312e+01 9.4438199996948242e+00 -3.0654199600219727e+01 -8.7480499267578125e+01 9.9735298156738281e+00 -3.2726398468017578e+01 -8.8782104492187500e+01 1.0475699424743652e+01 -3.3947898864746094e+01 -8.9500900268554688e+01 1.0753000259399414e+01 -3.4622501373291016e+01 -4.8759899139404297e+01 1.1237000465393066e+01 -3.9198997497558594e+01 -4.1100200653076172e+01 2.5276100158691406e+01 -4.4961299896240234e+01 -5.7235698699951172e+01 1.0791700363159180e+01 -3.4883701324462891e+01 -5.7262599945068359e+01 1.4072700500488281e+01 -3.9158901214599609e+01 -5.7114398956298828e+01 1.8647300720214844e+01 -4.2004100799560547e+01 -5.6810298919677734e+01 2.3924900054931641e+01 -4.3051898956298828e+01 -5.6389400482177734e+01 2.9224300384521484e+01 -4.2167102813720703e+01 -5.4900897979736328e+01 1.1087100028991699e+01 -3.6070102691650391e+01 -5.4878101348876953e+01 1.4466700553894043e+01 -3.9927700042724609e+01 -5.4543399810791016e+01 1.8925800323486328e+01 -4.2438999176025391e+01 -5.3936100006103516e+01 2.3943201065063477e+01 -4.3310600280761719e+01 -5.3127201080322266e+01 2.8932399749755859e+01 -4.2440498352050781e+01 -5.1862400054931641e+01 1.1262300491333008e+01 -3.7610099792480469e+01 -5.1696502685546875e+01 1.4663499832153320e+01 -4.0977703094482422e+01 -5.1132400512695312e+01 1.8904098510742188e+01 -4.3130901336669922e+01 -5.0227401733398438e+01 2.3551799774169922e+01 -4.3850002288818359e+01 -4.9073902130126953e+01 2.8132799148559570e+01 -4.3061698913574219e+01 -4.8399700164794922e+01 1.4560400009155273e+01 -4.2115497589111328e+01 -4.7615200042724609e+01 1.8516401290893555e+01 -4.3963600158691406e+01 -4.6475101470947266e+01 2.2758899688720703e+01 -4.4581699371337891e+01 -4.5078998565673828e+01 2.6916799545288086e+01 -4.3915699005126953e+01 -4.5590000152587891e+01 1.1012499809265137e+01 -4.0848098754882812e+01 -4.5004798889160156e+01 1.4163900375366211e+01 -4.3343700408935547e+01 -4.4008499145507812e+01 1.7770299911499023e+01 -4.4925899505615234e+01 -4.2674400329589844e+01 2.1567199707031250e+01 -4.5478599548339844e+01 -4.2454799652099609e+01 1.0582599639892578e+01 -4.2508502960205078e+01 -4.1632896423339844e+01 1.3470700263977051e+01 -4.4620597839355469e+01 -4.0439300537109375e+01 1.6667301177978516e+01 -4.5975101470947266e+01 -3.8945499420166016e+01 1.9981000900268555e+01 -4.6490798950195312e+01 -3.7241001129150391e+01 2.3213199615478516e+01 -4.6136901855468750e+01 -3.9977798461914062e+01 1.0070300102233887e+01 -4.3843399047851562e+01 -3.8964000701904297e+01 1.2675300598144531e+01 -4.5672901153564453e+01 -3.7622600555419922e+01 1.5491499900817871e+01 -4.6868598937988281e+01 -3.6020000457763672e+01 1.8379301071166992e+01 -4.7371303558349609e+01 -3.4235801696777344e+01 2.1195400238037109e+01 -4.7156097412109375e+01 -3.1531099319458008e+01 1.8946399688720703e+01 -4.8154903411865234e+01 -3.3373798370361328e+01 1.6559400558471680e+01 -4.8236400604248047e+01 -3.5064201354980469e+01 1.4112000465393066e+01 -4.7733600616455078e+01 -3.6534099578857422e+01 1.1703199386596680e+01 -4.6666999816894531e+01 -3.7723999023437500e+01 9.4306497573852539e+00 -4.5079799652099609e+01 -3.1171800613403320e+01 1.4640600204467773e+01 -4.9015296936035156e+01 -2.9289299011230469e+01 1.6605899810791016e+01 -4.9052799224853516e+01 -2.8325399398803711e+01 1.5392600059509277e+01 -4.9464698791503906e+01 -3.2928298950195312e+01 1.2625599861145020e+01 -4.8502899169921875e+01 -3.0222600936889648e+01 1.3638999938964844e+01 -4.9372901916503906e+01 -3.4500900268554688e+01 1.0627400398254395e+01 -4.7532398223876953e+01 -3.2005500793457031e+01 1.1840600013732910e+01 -4.8852802276611328e+01 -3.5837799072265625e+01 8.7116394042968750e+00 -4.6135997772216797e+01 -3.3620903015136719e+01 1.0050900459289551e+01 -4.7919898986816406e+01 -2.4710899353027344e+01 6.7317500114440918e+00 -5.1430603027343750e+01 -2.5024499893188477e+01 8.5201892852783203e+00 -5.1158500671386719e+01 -2.5552200317382812e+01 1.0300499916076660e+01 -5.0820102691650391e+01 -2.5968000411987305e+01 1.1353199958801270e+01 -5.0587699890136719e+01 -2.6988500595092773e+01 1.3369699478149414e+01 -5.0073699951171875e+01 -2.8903499603271484e+01 1.1961500167846680e+01 -4.9901798248291016e+01 -2.7893501281738281e+01 1.0282600402832031e+01 -5.0347896575927734e+01 -2.7480800628662109e+01 9.4041795730590820e+00 -5.0549598693847656e+01 -2.6954900741577148e+01 7.9168696403503418e+00 -5.0842697143554688e+01 -2.6639200210571289e+01 6.4212698936462402e+00 -5.1077701568603516e+01 -3.0720399856567383e+01 1.0515600204467773e+01 -4.9366001129150391e+01 -2.9733900070190430e+01 9.1796503067016602e+00 -4.9793601989746094e+01 -2.9329700469970703e+01 8.4778699874877930e+00 -4.9984600067138672e+01 -2.8812799453735352e+01 7.2864298820495605e+00 -5.0258399963378906e+01 -2.8499300003051758e+01 6.0857501029968262e+00 -5.0472198486328125e+01 -3.2393600463867188e+01 9.0682497024536133e+00 -4.8479999542236328e+01 -3.1449199676513672e+01 8.0684394836425781e+00 -4.8936901092529297e+01 -3.1061298370361328e+01 7.5404000282287598e+00 -4.9136898040771484e+01 -3.0563398361206055e+01 6.6407299041748047e+00 -4.9416603088378906e+01 -3.0258899688720703e+01 5.7310500144958496e+00 -4.9625099182128906e+01 -3.5020900726318359e+01 8.3229503631591797e+00 -4.6602001190185547e+01 -3.3880798339843750e+01 7.6561598777770996e+00 -4.7266098022460938e+01 -3.3001899719238281e+01 6.9731502532958984e+00 -4.7796497344970703e+01 -3.2640098571777344e+01 6.6109299659729004e+00 -4.8023700714111328e+01 -3.2174301147460938e+01 5.9917001724243164e+00 -4.8332901000976562e+01 -3.1886800765991211e+01 5.3633399009704590e+00 -4.8551002502441406e+01 -3.3016902923583984e+01 0.0000000000000000e+00 -4.7606597900390625e+01 -6.2765598297119141e+01 0.0000000000000000e+00 -1.7857799530029297e+01 -3.3101497650146484e+01 2.5002400875091553e+00 -4.7521999359130859e+01 -6.8623497009277344e+01 0.0000000000000000e+00 -3.7156898975372314e+00 -6.8239196777343750e+01 0.0000000000000000e+00 -7.6175298690795898e+00 -6.7860099792480469e+01 0.0000000000000000e+00 -8.8672008514404297e+00 -6.7101097106933594e+01 0.0000000000000000e+00 -1.1369299888610840e+01 -6.5868499755859375e+01 0.0000000000000000e+00 -1.3675300598144531e+01 -6.5252899169921875e+01 0.0000000000000000e+00 -1.4827099800109863e+01 -8.0939102172851562e+01 9.0223598480224609e+00 -2.3034500122070312e+01 -7.7340904235839844e+01 8.6410608291625977e+00 -1.2116200447082520e+01 -7.6006706237792969e+01 8.2423696517944336e+00 -6.9799000024795532e-01 -7.3623497009277344e+01 8.2423696517944336e+00 -6.9799000024795532e-01 -9.6968803405761719e+01 3.4902500152587891e+01 -3.8900798797607422e+01 -9.8097503662109375e+01 3.6031200408935547e+01 -3.8900798797607422e+01 -9.7631904602050781e+01 3.4327899932861328e+01 -3.9405597686767578e+01 -9.9450698852539062e+01 3.2516300201416016e+01 -4.0713100433349609e+01 -1.0095500183105469e+02 3.0619600296020508e+01 -4.1715099334716797e+01 -1.0204599761962891e+02 2.8777898788452148e+01 -4.2399101257324219e+01 -1.0274100494384766e+02 2.7047599792480469e+01 -4.2817100524902344e+01 -1.0308599853515625e+02 2.5516201019287109e+01 -4.3020198822021484e+01 -1.0317400360107422e+02 2.3880500793457031e+01 -4.3071399688720703e+01 -1.0300499725341797e+02 2.2411800384521484e+01 -4.2972900390625000e+01 -1.0253600311279297e+02 2.0761100769042969e+01 -4.2695499420166016e+01 -1.0176000213623047e+02 1.9084899902343750e+01 -4.2223300933837891e+01 -1.0065899658203125e+02 1.7372999191284180e+01 -4.1522998809814453e+01 -9.8736297607421875e+01 3.5391300201416016e+01 -3.9438899993896484e+01 -1.0048999786376953e+02 3.3379699707031250e+01 -4.0831302642822266e+01 -1.0194200134277344e+02 3.1280302047729492e+01 -4.1896999359130859e+01 -1.0299500274658203e+02 2.9246398925781250e+01 -4.2624000549316406e+01 -1.0366600036621094e+02 2.7337800979614258e+01 -4.3068000793457031e+01 -1.0400000000000000e+02 2.5649900436401367e+01 -4.3283699035644531e+01 -1.0408499908447266e+02 2.3847499847412109e+01 -4.3338100433349609e+01 -1.0392100524902344e+02 2.2229099273681641e+01 -4.3233398437500000e+01 -1.0346800231933594e+02 2.0409301757812500e+01 -4.2938796997070312e+01 -1.0271900177001953e+02 1.8559801101684570e+01 -4.2437198638916016e+01 -1.0165599822998047e+02 1.6668201446533203e+01 -4.1692802429199219e+01 -1.0102600097656250e+02 1.5742798805236816e+01 -4.1233402252197266e+01 -9.9408996582031250e+01 1.3739899635314941e+01 -3.9987300872802734e+01 -1.0000599670410156e+02 1.6536800384521484e+01 -4.1090999603271484e+01 -9.8329704284667969e+01 1.4730700492858887e+01 -3.9920299530029297e+01 -9.6467399597167969e+01 1.3096099853515625e+01 -3.8508499145507812e+01 -9.5467094421386719e+01 1.2334600448608398e+01 -3.7697399139404297e+01 -9.7614494323730469e+01 1.1920300483703613e+01 -3.8482402801513672e+01 -9.6651397705078125e+01 1.1069299697875977e+01 -3.7616802215576172e+01 -9.4558097839355469e+01 9.4685497283935547e+00 -3.5578601837158203e+01 -9.2502601623535156e+01 8.2067298889160156e+00 -3.3337100982666016e+01 -9.3290405273437500e+01 1.0909199714660645e+01 -3.5790397644042969e+01 -9.1149703979492188e+01 9.7964401245117188e+00 -3.3698303222656250e+01 -8.9285400390625000e+01 9.0729598999023438e+00 -3.1666200637817383e+01 -8.7496101379394531e+01 8.6337299346923828e+00 -2.9490299224853516e+01 -8.5881301879882812e+01 8.5151796340942383e+00 -2.7287200927734375e+01 -9.0715293884277344e+01 7.3741102218627930e+00 -3.1154500961303711e+01 -8.9002899169921875e+01 6.8536400794982910e+00 -2.8811199188232422e+01 -8.7459495544433594e+01 6.6900200843811035e+00 -2.6431900024414062e+01 -2.8237899780273438e+01 3.0490701198577881e+00 -5.0761600494384766e+01 -2.6242601394653320e+01 0.0000000000000000e+00 -5.1237697601318359e+01 -2.9767999649047852e+01 0.0000000000000000e+00 -4.9777400970458984e+01 -2.8150598526000977e+01 0.0000000000000000e+00 -5.0858100891113281e+01 -3.3016902923583984e+01 -2.5773599147796631e+00 -4.7536701202392578e+01 -3.3016902923583984e+01 -7.7018699645996094e+00 -4.6979400634765625e+01 -6.2765598297119141e+01 -3.9639501571655273e+00 -1.7335899353027344e+01 -3.3016902923583984e+01 -1.0578700065612793e+01 -4.6346199035644531e+01 -6.2765598297119141e+01 -4.6219201087951660e+00 -1.7249300003051758e+01 -6.2765598297119141e+01 -1.1043099403381348e+01 -1.3843099594116211e+01 -6.2765598297119141e+01 -8.9288902282714844e+00 -1.5465299606323242e+01 -3.3016902923583984e+01 -2.6716199874877930e+01 -3.9403400421142578e+01 -3.3016902923583984e+01 -1.2736100196838379e+01 -4.5871299743652344e+01 -3.3016902923583984e+01 -1.7621000289916992e+01 -4.4225399017333984e+01 -6.2765598297119141e+01 -7.7005000114440918e+00 -1.5974199295043945e+01 -3.3016902923583984e+01 -2.0628801345825195e+01 -4.2833896636962891e+01 -3.3016902923583984e+01 -2.2299301147460938e+01 -4.2061000823974609e+01 -3.3016902923583984e+01 -2.9647701263427734e+01 -3.7174900054931641e+01 -3.3016902923583984e+01 -3.0819799423217773e+01 -3.6283897399902344e+01 -6.2765598297119141e+01 -1.2627400398254395e+01 -1.2627400398254395e+01 -3.3016902923583984e+01 -3.4562198638916016e+01 -3.2738998413085938e+01 -6.2765598297119141e+01 -1.3843099594116211e+01 -1.1043099403381348e+01 -3.3016902923583984e+01 -3.7184497833251953e+01 -2.9651800155639648e+01 -3.3016902923583984e+01 -3.7899200439453125e+01 -2.8810300827026367e+01 -6.2765598297119141e+01 -1.5465299606323242e+01 -8.9288902282714844e+00 -3.3016902923583984e+01 -4.0791999816894531e+01 -2.4543800354003906e+01 -6.2765598297119141e+01 -1.5974199295043945e+01 -7.7005000114440918e+00 -3.3016902923583984e+01 -4.2861801147460938e+01 -2.0639699935913086e+01 -3.3016902923583984e+01 -4.3206600189208984e+01 -1.9989500045776367e+01 -6.2765598297119141e+01 -1.7249300003051758e+01 -4.6219201087951660e+00 -3.3016902923583984e+01 -4.5114498138427734e+01 -1.5200799942016602e+01 -3.3016902923583984e+01 -4.6395099639892578e+01 -1.0588500022888184e+01 -6.2765598297119141e+01 -1.7335899353027344e+01 -3.9639501571655273e+00 -3.3016902923583984e+01 -4.6493602752685547e+01 -1.0234000205993652e+01 -6.2765598297119141e+01 -1.7857799530029297e+01 0.0000000000000000e+00 -3.3016902923583984e+01 -4.7327499389648438e+01 -5.1471600532531738e+00 -3.3016902923583984e+01 -4.7606597900390625e+01 0.0000000000000000e+00 -3.3016902923583984e+01 -4.7327499389648438e+01 5.1471600532531738e+00 -3.3016902923583984e+01 -4.6493602752685547e+01 1.0234000205993652e+01 -6.2765598297119141e+01 -1.7335899353027344e+01 3.9639501571655273e+00 -3.3016902923583984e+01 -4.6395099639892578e+01 1.0588500022888184e+01 -6.2765598297119141e+01 -1.7249300003051758e+01 4.6219201087951660e+00 -3.3016902923583984e+01 -4.5114498138427734e+01 1.5200799942016602e+01 -3.3016902923583984e+01 -4.3206600189208984e+01 1.9989500045776367e+01 -6.2765598297119141e+01 -1.5974199295043945e+01 7.7005000114440918e+00 -3.3016902923583984e+01 -4.2861801147460938e+01 2.0639699935913086e+01 -6.2765598297119141e+01 -1.5465299606323242e+01 8.9288902282714844e+00 -3.3016902923583984e+01 -3.0819799423217773e+01 3.6283897399902344e+01 -6.2765598297119141e+01 -1.1043099403381348e+01 1.3843099594116211e+01 -6.2765598297119141e+01 -1.2627400398254395e+01 1.2627400398254395e+01 -3.3016902923583984e+01 -4.0791999816894531e+01 2.4543800354003906e+01 -3.3016902923583984e+01 -3.7899200439453125e+01 2.8810300827026367e+01 -6.2765598297119141e+01 -1.3843099594116211e+01 1.1043099403381348e+01 -3.3016902923583984e+01 -3.7184497833251953e+01 2.9651800155639648e+01 -3.3016902923583984e+01 -3.4562198638916016e+01 3.2738998413085938e+01 -3.3016902923583984e+01 -2.9647701263427734e+01 3.7174900054931641e+01 -3.3016902923583984e+01 -2.6716199874877930e+01 3.9403400421142578e+01 -6.2765598297119141e+01 -8.9288902282714844e+00 1.5465299606323242e+01 -3.3016902923583984e+01 -2.2299301147460938e+01 4.2061000823974609e+01 -6.2765598297119141e+01 -7.7005000114440918e+00 1.5974199295043945e+01 -3.3016902923583984e+01 -2.0628801345825195e+01 4.2833896636962891e+01 -3.3016902923583984e+01 -1.7621000289916992e+01 4.4225399017333984e+01 -6.2765598297119141e+01 -4.6219201087951660e+00 1.7249300003051758e+01 -3.3016902923583984e+01 -1.2736100196838379e+01 4.5871299743652344e+01 -6.2765598297119141e+01 -3.9639501571655273e+00 1.7335899353027344e+01 -3.3016902923583984e+01 -1.0578700065612793e+01 4.6346199035644531e+01 -3.3016902923583984e+01 -7.7018699645996094e+00 4.6979400634765625e+01 -6.2765598297119141e+01 0.0000000000000000e+00 1.7857799530029297e+01 -3.3016902923583984e+01 -2.5773599147796631e+00 4.7536701202392578e+01 -3.3016902923583984e+01 0.0000000000000000e+00 4.7606597900390625e+01 -2.6292600631713867e+01 -2.7875299453735352e+00 -5.1413299560546875e+01 -2.9910299301147461e+01 -8.0875101089477539e+00 -4.9331798553466797e+01 -2.9910299301147461e+01 -2.7064099311828613e+00 -4.9916999816894531e+01 -2.9910299301147461e+01 -1.8503301620483398e+01 -4.6439899444580078e+01 -2.9910299301147461e+01 -1.3373799324035645e+01 -4.8168201446533203e+01 -2.9910299301147461e+01 -2.8053899765014648e+01 -4.1376502990722656e+01 -2.9910299301147461e+01 -2.3415901184082031e+01 -4.4167102813720703e+01 -2.9910299301147461e+01 -3.6292797088623047e+01 -3.4378299713134766e+01 -2.9910299301147461e+01 -3.2363002777099609e+01 -3.8100700378417969e+01 -2.9910299301147461e+01 -4.2834598541259766e+01 -2.5772699356079102e+01 -2.9910299301147461e+01 -3.9796901702880859e+01 -3.0252899169921875e+01 -2.9910299301147461e+01 -4.7373500823974609e+01 -1.5961998939514160e+01 -2.9910299301147461e+01 -4.5370002746582031e+01 -2.0990400314331055e+01 -2.9910299301147461e+01 -4.8821598052978516e+01 1.0746399879455566e+01 -2.9910299301147461e+01 -4.9697299957275391e+01 5.4048900604248047e+00 -2.9910299301147461e+01 -4.9990299224853516e+01 0.0000000000000000e+00 -2.9910299301147461e+01 -4.9697299957275391e+01 -5.4048900604248047e+00 -2.9910299301147461e+01 -4.8821598052978516e+01 -1.0746399879455566e+01 -2.9910299301147461e+01 -4.5370002746582031e+01 2.0990400314331055e+01 -2.9910299301147461e+01 -4.7373500823974609e+01 1.5961998939514160e+01 -2.9910299301147461e+01 -3.9796901702880859e+01 3.0252899169921875e+01 -2.9910299301147461e+01 -4.2834598541259766e+01 2.5772699356079102e+01 -2.9910299301147461e+01 -3.2363002777099609e+01 3.8100700378417969e+01 -2.9910299301147461e+01 -3.6292797088623047e+01 3.4378299713134766e+01 -2.6292600631713867e+01 -8.3299293518066406e+00 -5.0810600280761719e+01 -2.6292600631713867e+01 -1.3774700164794922e+01 -4.9612102508544922e+01 -2.6292600631713867e+01 -1.9058000564575195e+01 -4.7831901550292969e+01 -2.6292600631713867e+01 -2.4117799758911133e+01 -4.5490997314453125e+01 -2.6292600631713867e+01 -2.8894899368286133e+01 -4.2616798400878906e+01 -2.6292600631713867e+01 -3.3333202362060547e+01 -3.9242900848388672e+01 -2.6292600631713867e+01 -3.7380699157714844e+01 -3.5408897399902344e+01 -2.6292600631713867e+01 -4.0989898681640625e+01 -3.1159700393676758e+01 -2.6292600631713867e+01 -4.4118602752685547e+01 -2.6545299530029297e+01 -2.6292600631713867e+01 -4.6729999542236328e+01 -2.1619598388671875e+01 -2.6292600631713867e+01 -4.8793598175048828e+01 -1.6440401077270508e+01 -2.6292600631713867e+01 -5.0285102844238281e+01 -1.1068600654602051e+01 -2.6292600631713867e+01 -5.1187000274658203e+01 -5.5669002532958984e+00 -2.6292600631713867e+01 -5.1488899230957031e+01 0.0000000000000000e+00 -2.6292600631713867e+01 -5.1187000274658203e+01 5.5669002532958984e+00 -2.6292600631713867e+01 -5.0285102844238281e+01 1.1068600654602051e+01 -2.6292600631713867e+01 -4.8793598175048828e+01 1.6440401077270508e+01 -2.6292600631713867e+01 -4.6729999542236328e+01 2.1619598388671875e+01 -2.6292600631713867e+01 -4.4118602752685547e+01 2.6545299530029297e+01 -2.6292600631713867e+01 -4.0989898681640625e+01 3.1159700393676758e+01 -2.6292600631713867e+01 -3.7380699157714844e+01 3.5408897399902344e+01 -2.6292600631713867e+01 -3.3333202362060547e+01 3.9242900848388672e+01 -2.6292600631713867e+01 -2.8894899368286133e+01 4.2616798400878906e+01 -2.6292600631713867e+01 -2.4117799758911133e+01 4.5490997314453125e+01 -2.9910299301147461e+01 -2.8053899765014648e+01 4.1376502990722656e+01 -2.9910299301147461e+01 -2.3415901184082031e+01 4.4167102813720703e+01 -2.9910299301147461e+01 -1.8503301620483398e+01 4.6439899444580078e+01 -2.6292600631713867e+01 -1.9058000564575195e+01 4.7831901550292969e+01 -2.6292600631713867e+01 -1.3774700164794922e+01 4.9612102508544922e+01 -2.9910299301147461e+01 -1.3373799324035645e+01 4.8168201446533203e+01 -2.9910299301147461e+01 -2.7064099311828613e+00 4.9916999816894531e+01 -2.9910299301147461e+01 -8.0875101089477539e+00 4.9331798553466797e+01 -2.6292600631713867e+01 -2.7875299453735352e+00 5.1413299560546875e+01 -2.6292600631713867e+01 -8.3299293518066406e+00 5.0810600280761719e+01 -2.9767999649047852e+01 0.0000000000000000e+00 4.9777400970458984e+01 -2.8150598526000977e+01 0.0000000000000000e+00 5.0858100891113281e+01 -2.6242601394653320e+01 0.0000000000000000e+00 5.1237697601318359e+01 -8.1556999206542969e+01 6.1318302154541016e+00 -1.1272800445556641e+01 -8.4872604370117188e+01 6.5036401748657227e+00 -2.1368900299072266e+01 -8.3204002380371094e+01 8.3294506072998047e+00 -2.2048999786376953e+01 -7.9771598815917969e+01 7.9591898918151855e+00 -1.1603300094604492e+01 -8.0335403442382812e+01 5.7430901527404785e+00 -7.1899902820587158e-01 -7.8505599975585938e+01 7.5719900131225586e+00 -6.8314403295516968e-01 -7.1710105895996094e+01 7.8619699478149414e+00 -7.1127301454544067e-01 -7.1170997619628906e+01 7.5019598007202148e+00 -7.2384500503540039e-01 -7.0087997436523438e+01 6.7787799835205078e+00 -7.4909901618957520e-01 -6.9364395141601562e+01 5.6964802742004395e+00 -7.8689402341842651e-01 -6.9004104614257812e+01 5.1576499938964844e+00 -8.0570995807647705e-01 -6.8623497009277344e+01 3.2454099655151367e+00 -8.7248700857162476e-01 -7.3623497009277344e+01 8.2423696517944336e+00 6.9799000024795532e-01 -7.6006706237792969e+01 8.2423696517944336e+00 6.9799000024795532e-01 -7.6000000000000000e+01 8.2301502227783203e+00 0.0000000000000000e+00 -6.8623497009277344e+01 0.0000000000000000e+00 3.7156898975372314e+00 -6.8623497009277344e+01 3.3447098731994629e+00 3.7156898975372314e+00 -6.8623497009277344e+01 3.2454099655151367e+00 8.7248700857162476e-01 -6.8623497009277344e+01 -3.7156898975372314e+00 0.0000000000000000e+00 -6.8623497009277344e+01 -3.5890898704528809e+00 9.6170097589492798e-01 -6.8623497009277344e+01 -3.2178699970245361e+00 1.8578199148178101e+00 -6.8623497009277344e+01 -2.6273698806762695e+00 2.6273698806762695e+00 -6.8623497009277344e+01 -1.8578199148178101e+00 3.2178699970245361e+00 -6.8623497009277344e+01 -9.6170097589492798e-01 3.5890898704528809e+00 -6.8623497009277344e+01 -9.6170097589492798e-01 -3.5890898704528809e+00 -6.8623497009277344e+01 -1.8578199148178101e+00 -3.2178699970245361e+00 -6.8623497009277344e+01 -2.6273698806762695e+00 -2.6273698806762695e+00 -6.8623497009277344e+01 -3.2178699970245361e+00 -1.8578199148178101e+00 -6.8623497009277344e+01 -3.5890898704528809e+00 -9.6170097589492798e-01 -7.1710105895996094e+01 7.8619699478149414e+00 7.1127301454544067e-01 -7.1170997619628906e+01 7.5019598007202148e+00 7.2384500503540039e-01 -7.0087997436523438e+01 6.7787799835205078e+00 7.4909901618957520e-01 -6.9364395141601562e+01 5.6964802742004395e+00 7.8689402341842651e-01 -6.9004104614257812e+01 5.1576499938964844e+00 8.0570995807647705e-01 -8.0330200195312500e+01 5.7301497459411621e+00 0.0000000000000000e+00 -7.8500000000000000e+01 7.5603098869323730e+00 0.0000000000000000e+00 -8.0335403442382812e+01 5.7430901527404785e+00 7.1899902820587158e-01 -7.8505599975585938e+01 7.5719900131225586e+00 6.8314403295516968e-01 -9.7194801330566406e+01 3.6965797424316406e+01 -3.8092098236083984e+01 -9.6034202575683594e+01 3.5805198669433594e+01 -3.8092098236083984e+01 -8.9762100219726562e+01 4.1855499267578125e+01 -3.1512300491333008e+01 -9.1144500732421875e+01 4.3237899780273438e+01 -3.1512300491333008e+01 -8.6379806518554688e+01 4.8189399719238281e+01 -2.4142999649047852e+01 -8.1267799377441406e+01 5.0020401000976562e+01 -1.6240699768066406e+01 -8.4810600280761719e+01 4.6620201110839844e+01 -2.4142999649047852e+01 -8.2979598999023438e+01 5.1732200622558594e+01 -1.6240699768066406e+01 -8.0964897155761719e+01 5.3836200714111328e+01 -8.0241003036499023e+00 -7.9163795471191406e+01 5.2035099029541016e+01 -8.0241003036499023e+00 -8.0331306457519531e+01 5.4498699188232422e+01 3.4620901942253113e-01 -7.8501296997070312e+01 5.2668701171875000e+01 3.4620901942253113e-01 -7.9289505004882812e+01 5.1914901733398438e+01 8.7462091445922852e+00 -8.1085098266601562e+01 5.3710502624511719e+01 8.7462091445922852e+00 -8.3251602172851562e+01 5.1448299407958984e+01 1.7032400131225586e+01 -8.1551704406738281e+01 4.9748397827148438e+01 1.7032400131225586e+01 -8.5296104431152344e+01 4.6153499603271484e+01 2.4999300003051758e+01 -8.6846504211425781e+01 4.7703899383544922e+01 2.4999300003051758e+01 -9.1834899902343750e+01 4.2521396636962891e+01 3.2385902404785156e+01 -9.0478599548339844e+01 4.1165100097656250e+01 3.2385902404785156e+01 -9.8097503662109375e+01 3.6031200408935547e+01 3.8900798797607422e+01 -9.6968803405761719e+01 3.4902500152587891e+01 3.8900798797607422e+01 -6.5252899169921875e+01 -3.8375201225280762e+00 -1.4321900367736816e+01 -6.5252899169921875e+01 -7.4135699272155762e+00 -1.2840600013732910e+01 -6.5252899169921875e+01 -1.0484299659729004e+01 -1.0484299659729004e+01 -6.5252899169921875e+01 -1.2840600013732910e+01 -7.4135699272155762e+00 -6.5252899169921875e+01 -1.4321900367736816e+01 -3.8375201225280762e+00 -6.5252899169921875e+01 -1.4827099800109863e+01 0.0000000000000000e+00 -6.5252899169921875e+01 -1.4321900367736816e+01 3.8375201225280762e+00 -6.5252899169921875e+01 -1.2840600013732910e+01 7.4135699272155762e+00 -6.5252899169921875e+01 -1.0484299659729004e+01 1.0484299659729004e+01 -6.8239196777343750e+01 -1.9715400934219360e+00 7.3579497337341309e+00 -6.8239196777343750e+01 0.0000000000000000e+00 7.6175298690795898e+00 -6.8239196777343750e+01 -1.9715400934219360e+00 -7.3579497337341309e+00 -6.7101097106933594e+01 -2.9425599575042725e+00 1.0982000350952148e+01 -6.7101097106933594e+01 0.0000000000000000e+00 1.1369299888610840e+01 -6.7860099792480469e+01 0.0000000000000000e+00 8.8672008514404297e+00 -6.8239196777343750e+01 -5.3863501548767090e+00 -5.3863501548767090e+00 -6.8239196777343750e+01 -3.8087401390075684e+00 -6.5969200134277344e+00 -6.7101097106933594e+01 -5.6846699714660645e+00 -9.8461503982543945e+00 -6.7101097106933594e+01 -2.9425599575042725e+00 -1.0982000350952148e+01 -6.5252899169921875e+01 -7.4135699272155762e+00 1.2840600013732910e+01 -6.5252899169921875e+01 -3.8375201225280762e+00 1.4321900367736816e+01 -6.5868499755859375e+01 0.0000000000000000e+00 1.3675300598144531e+01 -6.5252899169921875e+01 0.0000000000000000e+00 1.4827099800109863e+01 -6.7101097106933594e+01 -5.6846699714660645e+00 9.8461503982543945e+00 -6.7101097106933594e+01 -8.0393495559692383e+00 8.0393495559692383e+00 -6.8239196777343750e+01 -3.8087401390075684e+00 6.5969200134277344e+00 -6.7101097106933594e+01 -9.8461503982543945e+00 5.6846699714660645e+00 -6.8239196777343750e+01 -5.3863501548767090e+00 5.3863501548767090e+00 -6.7101097106933594e+01 -1.0982000350952148e+01 2.9425599575042725e+00 -6.8239196777343750e+01 -6.5969200134277344e+00 3.8087401390075684e+00 -6.7101097106933594e+01 -1.1369299888610840e+01 0.0000000000000000e+00 -6.8239196777343750e+01 -7.3579497337341309e+00 1.9715400934219360e+00 -6.7101097106933594e+01 -1.0982000350952148e+01 -2.9425599575042725e+00 -6.8239196777343750e+01 -7.6175298690795898e+00 0.0000000000000000e+00 -6.7101097106933594e+01 -9.8461503982543945e+00 -5.6846699714660645e+00 -6.8239196777343750e+01 -7.3579497337341309e+00 -1.9715400934219360e+00 -6.7101097106933594e+01 -8.0393495559692383e+00 -8.0393495559692383e+00 -6.8239196777343750e+01 -6.5969200134277344e+00 -3.8087401390075684e+00 -7.6432495117187500e+01 8.4565896987915039e+00 6.8334298133850098e+00 -7.3623497009277344e+01 8.3416700363159180e+00 3.5412299633026123e+00 -7.2575500488281250e+01 8.5917701721191406e+00 1.0703900337219238e+01 -7.8989105224609375e+01 8.8480100631713867e+00 1.8041299819946289e+01 -6.9519294738769531e+01 8.8209505081176758e+00 1.7265998840332031e+01 -8.3742607116699219e+01 9.2135095596313477e+00 2.8508199691772461e+01 -6.6301193237304688e+01 8.9589900970458984e+00 2.1218898773193359e+01 -5.9011898040771484e+01 9.2135095596313477e+00 2.8508199691772461e+01 -3.3354801177978516e+01 4.9890899658203125e+00 4.7268699645996094e+01 -6.2765598297119141e+01 3.9620399475097656e+00 1.7857799530029297e+01 -3.3101497650146484e+01 2.5002400875091553e+00 4.7521999359130859e+01 -5.9011898040771484e+01 1.0446000099182129e+01 3.3960201263427734e+01 -8.8775299072265625e+01 1.0463299751281738e+01 3.3951999664306641e+01 -8.8423995971679688e+01 1.0311100006103516e+01 3.3639400482177734e+01 -8.4624198913574219e+01 9.2921800613403320e+00 2.9605598449707031e+01 -8.6444198608398438e+01 9.6619701385498047e+00 3.1661499023437500e+01 -9.0443496704101562e+01 1.1186200141906738e+01 3.5436397552490234e+01 -5.9011898040771484e+01 1.3589000701904297e+01 3.8582500457763672e+01 -9.2727302551269531e+01 1.2407400131225586e+01 3.7249198913574219e+01 -9.9674095153808594e+01 1.8081499099731445e+01 4.1678199768066406e+01 -9.8013702392578125e+01 1.6320501327514648e+01 4.0745800018310547e+01 -5.9011898040771484e+01 1.8206001281738281e+01 4.1733100891113281e+01 -9.6030097961425781e+01 1.4633500099182129e+01 3.9534599304199219e+01 -9.5032402038574219e+01 1.3896499633789062e+01 3.8881801605224609e+01 -9.4585395812988281e+01 1.3607700347900391e+01 3.8565200805664062e+01 -1.0208399963378906e+02 2.2726400375366211e+01 4.2911800384521484e+01 -1.0169000244140625e+02 2.1395200729370117e+01 4.2719402313232422e+01 -5.9011898040771484e+01 2.3655900955200195e+01 4.2974700927734375e+01 -1.0090599822998047e+02 1.9807600021362305e+01 4.2325897216796875e+01 -9.9764999389648438e+01 1.8208700180053711e+01 4.1725898742675781e+01 -1.0169000244140625e+02 2.7015699386596680e+01 4.2718898773193359e+01 -1.0211499786376953e+02 2.5522298812866211e+01 4.2926700592041016e+01 -1.0223500061035156e+02 2.4207899093627930e+01 4.2984703063964844e+01 -1.0217900085449219e+02 2.3656801223754883e+01 4.2957599639892578e+01 -5.9011898040771484e+01 2.9182100296020508e+01 4.2134799957275391e+01 -9.7604400634765625e+01 3.2465499877929688e+01 4.0504898071289062e+01 -9.9279800415039062e+01 3.0787199020385742e+01 4.1463100433349609e+01 -9.9893501281738281e+01 3.0056299209594727e+01 4.1796100616455078e+01 -1.0050099945068359e+02 2.9174499511718750e+01 4.2113597869873047e+01 -1.0096699523925781e+02 2.8499198913574219e+01 4.2356700897216797e+01 -6.5340103149414062e+01 3.8239901065826416e+00 1.4695500373840332e+01 -6.5822799682617188e+01 3.7787501811981201e+00 1.3659199714660645e+01 -6.7785102844238281e+01 3.5948100090026855e+00 9.4458494186401367e+00 -6.7867698669433594e+01 3.5701999664306641e+00 8.8812103271484375e+00 -8.5881301879882812e+01 8.5151796340942383e+00 2.7287200927734375e+01 -8.7459495544433594e+01 6.6900200843811035e+00 2.6431900024414062e+01 -8.6678901672363281e+01 8.5353202819824219e+00 2.8407400131225586e+01 -8.9805999755859375e+01 7.0595698356628418e+00 2.9944601058959961e+01 -8.8221496582031250e+01 6.7282900810241699e+00 2.7642499923706055e+01 -8.8335601806640625e+01 8.8049201965332031e+00 3.0541999816894531e+01 -9.0153999328613281e+01 9.3795099258422852e+00 3.2639801025390625e+01 -9.2024993896484375e+01 1.0216699600219727e+01 3.4582202911376953e+01 -9.4157897949218750e+01 1.1441200256347656e+01 3.6575099945068359e+01 -9.6326599121093750e+01 1.2984499931335449e+01 3.8396598815917969e+01 -9.8387199401855469e+01 1.2662599563598633e+01 3.9146900177001953e+01 -9.7478897094726562e+01 1.1795700073242188e+01 3.8363098144531250e+01 -9.5392005920410156e+01 1.0067500114440918e+01 3.6417800903320312e+01 -9.3342605590820312e+01 8.6851100921630859e+00 3.4284801483154297e+01 -9.1547698974609375e+01 7.7288699150085449e+00 3.2201000213623047e+01 -9.7269500732421875e+01 1.3762099266052246e+01 3.9131702423095703e+01 -9.9151000976562500e+01 1.5565499305725098e+01 4.0505199432373047e+01 -1.0073200225830078e+02 1.7473300933837891e+01 4.1570499420166016e+01 -1.0190799713134766e+02 1.9360198974609375e+01 4.2314601898193359e+01 -1.0265800476074219e+02 2.1105199813842773e+01 4.2768199920654297e+01 -1.0318000030517578e+02 2.4208299636840820e+01 4.3074699401855469e+01 -1.0303500366210938e+02 2.2572799682617188e+01 4.2990402221679688e+01 -1.0306500244140625e+02 2.5659399032592773e+01 4.3007701873779297e+01 -1.0265699768066406e+02 2.7305898666381836e+01 4.2767700195312500e+01 -1.0094100189208984e+02 3.0640199661254883e+01 4.1705799102783203e+01 -1.0196600341796875e+02 2.8936700820922852e+01 4.2350200653076172e+01 -1.0035599517822266e+02 3.1435697555541992e+01 4.1324298858642578e+01 -9.8762100219726562e+01 3.3248996734619141e+01 4.0230998992919922e+01 -1.0020100402832031e+02 1.4666399955749512e+01 4.0609901428222656e+01 -1.0172600555419922e+02 1.6779100418090820e+01 4.1743400573730469e+01 -1.0286199951171875e+02 1.8863700866699219e+01 4.2534297943115234e+01 -1.0358600616455078e+02 2.0788700103759766e+01 4.3016002655029297e+01 -1.0395000457763672e+02 2.2406499862670898e+01 4.3251998901367188e+01 -1.0408999633789062e+02 2.4208700180053711e+01 4.3341598510742188e+01 -1.0397899627685547e+02 2.5807699203491211e+01 4.3270301818847656e+01 -1.0358499908447266e+02 2.7622598648071289e+01 4.3015499114990234e+01 -1.0291799926757812e+02 2.9421600341796875e+01 4.2571998596191406e+01 -1.0192800140380859e+02 3.1303201675415039e+01 4.1887203216552734e+01 -1.0136399841308594e+02 3.2183097839355469e+01 4.1481403350830078e+01 -9.9825897216796875e+01 3.4192398071289062e+01 4.0318099975585938e+01 -7.8907402038574219e+01 7.7800202369689941e+00 6.5504298210144043e+00 -8.0722694396972656e+01 5.9519400596618652e+00 6.3893799781799316e+00 -8.1342895507812500e+01 8.1601095199584961e+00 1.7271499633789062e+01 -8.3074699401855469e+01 6.3335900306701660e+00 1.6751199722290039e+01 -5.1184799194335938e+01 9.0213403701782227e+00 3.3671699523925781e+01 -5.4046703338623047e+01 9.1630201339721680e+00 3.1695802688598633e+01 -6.4558105468750000e+01 8.2491006851196289e+00 1.9500600814819336e+01 -5.6651302337646484e+01 9.2247104644775391e+00 2.9976900100708008e+01 -4.0900199890136719e+01 7.8579196929931641e+00 4.1251800537109375e+01 -4.1796501159667969e+01 8.0113401412963867e+00 4.0568000793457031e+01 -6.3267902374267578e+01 6.4255599975585938e+00 1.8274101257324219e+01 -4.4439399719238281e+01 8.3933496475219727e+00 3.8575599670410156e+01 -4.7240497589111328e+01 8.7071599960327148e+00 3.6504299163818359e+01 -4.8396503448486328e+01 8.8045597076416016e+00 3.5669799804687500e+01 -5.0148403167724609e+01 8.9521999359130859e+00 3.4405101776123047e+01 -3.5108699798583984e+01 6.2991399765014648e+00 4.5783798217773438e+01 -3.6147300720214844e+01 6.7023601531982422e+00 4.4951400756835938e+01 -3.3485000610351562e+01 5.1975798606872559e+00 4.7144901275634766e+01 -3.3558498382568359e+01 5.2886600494384766e+00 4.7078201293945312e+01 -3.3969497680664062e+01 5.6616702079772949e+00 4.6722198486328125e+01 -3.4560600280761719e+01 6.0319299697875977e+00 4.6230400085449219e+01 -3.7413200378417969e+01 7.0897898674011230e+00 4.3951702117919922e+01 -3.8248500823974609e+01 7.2966799736022949e+00 4.3300098419189453e+01 -3.8890899658203125e+01 7.4557700157165527e+00 4.2799201965332031e+01 -6.8442802429199219e+01 6.0789599418640137e+00 9.5557594299316406e+00 -6.5926300048828125e+01 6.2951998710632324e+00 1.4994299888610840e+01 -6.7452499389648438e+01 8.1200008392333984e+00 1.5932900428771973e+01 -7.0194000244140625e+01 7.9057803153991699e+00 1.0015700340270996e+01 -6.9293403625488281e+01 5.8431601524353027e+00 3.6284298896789551e+00 -7.1123504638671875e+01 7.6721901893615723e+00 3.5645999908447266e+00 -2.8237899780273438e+01 3.0490701198577881e+00 5.0761600494384766e+01 -2.4659700393676758e+01 6.7039098739624023e+00 5.1175197601318359e+01 -2.6587900161743164e+01 6.3934898376464844e+00 5.0822196960449219e+01 -2.8499300003051758e+01 6.0857501029968262e+00 5.0472198486328125e+01 -3.0113100051879883e+01 5.7212700843811035e+00 4.9407501220703125e+01 -3.1741102218627930e+01 5.3535699844360352e+00 4.8333400726318359e+01 -2.4864599227905273e+01 7.7583198547363281e+00 5.1282699584960938e+01 -2.6794599533081055e+01 7.2798099517822266e+00 5.0949996948242188e+01 -2.8654298782348633e+01 6.7752599716186523e+00 5.0356899261474609e+01 -3.0409999847412109e+01 6.2537198066711426e+00 4.9514202117919922e+01 -2.4954399108886719e+01 8.2085094451904297e+00 5.1210800170898438e+01 -2.5470100402832031e+01 1.0065799713134766e+01 5.0868598937988281e+01 -2.6229499816894531e+01 1.1930200576782227e+01 5.0449901580810547e+01 -2.6941999435424805e+01 1.3289199829101562e+01 5.0096000671386719e+01 -2.8303298950195312e+01 1.5362799644470215e+01 4.9474399566650391e+01 -2.9974800109863281e+01 1.7382299423217773e+01 4.8770301818847656e+01 -3.6416400909423828e+01 8.9551200866699219e+00 4.5809398651123047e+01 -3.5002201080322266e+01 8.3133001327514648e+00 4.6612697601318359e+01 -3.3840896606445312e+01 7.6292099952697754e+00 4.7289798736572266e+01 -3.3228099822998047e+01 7.1701397895812988e+00 4.7657699584960938e+01 -3.2568298339843750e+01 6.5297498703002930e+00 4.8069801330566406e+01 -3.2111297607421875e+01 5.8826198577880859e+00 4.8377597808837891e+01 -3.2030002593994141e+01 5.7246699333190918e+00 4.8437099456787109e+01 -4.3152400970458984e+01 2.6178499221801758e+01 4.4399700164794922e+01 -3.9371402740478516e+01 2.4415599822998047e+01 4.5469200134277344e+01 -3.5819400787353516e+01 2.2311000823974609e+01 4.6607700347900391e+01 -3.4618797302246094e+01 2.1477001190185547e+01 4.7021099090576172e+01 -3.1937000274658203e+01 1.9317399978637695e+01 4.7999603271484375e+01 -2.6884698867797852e+01 7.6562800407409668e+00 5.0887901306152344e+01 -2.7399198532104492e+01 9.2082605361938477e+00 5.0591598510742188e+01 -2.8152599334716797e+01 1.0763599395751953e+01 5.0228302001953125e+01 -2.8857400894165039e+01 1.1894599914550781e+01 4.9921100616455078e+01 -3.0200901031494141e+01 1.3614399909973145e+01 4.9381198883056641e+01 -3.1845901489257812e+01 1.5279299736022949e+01 4.8770099639892578e+01 -3.3771701812744141e+01 1.6861398696899414e+01 4.8101699829101562e+01 -3.6393798828125000e+01 1.8604900360107422e+01 4.7254600524902344e+01 -3.7563701629638672e+01 1.9269500732421875e+01 4.6897197723388672e+01 -4.1008300781250000e+01 2.0913900375366211e+01 4.5915397644042969e+01 -4.4641201019287109e+01 2.2233699798583984e+01 4.4996498107910156e+01 -2.8743398666381836e+01 7.0773897171020508e+00 5.0300098419189453e+01 -2.9249599456787109e+01 8.3211097717285156e+00 5.0024200439453125e+01 -2.9987298965454102e+01 9.5631494522094727e+00 4.9679599761962891e+01 -3.0675600051879883e+01 1.0462500572204590e+01 4.9384601593017578e+01 -3.1984298706054688e+01 1.1821299552917480e+01 4.8861000061035156e+01 -3.3582798004150391e+01 1.3123299598693848e+01 4.8261798858642578e+01 -3.5449501037597656e+01 1.4343299865722656e+01 4.7599800109863281e+01 -3.7983200073242188e+01 1.5659699440002441e+01 4.6750900268554688e+01 -3.9110500335693359e+01 1.6150598526000977e+01 4.6389301300048828e+01 -4.2417102813720703e+01 1.7326299667358398e+01 4.5382297515869141e+01 -4.5879600524902344e+01 1.8201301574707031e+01 4.4413898468017578e+01 -3.0496398925781250e+01 6.4825401306152344e+00 4.9458103179931641e+01 -3.0984399795532227e+01 7.4222698211669922e+00 4.9177898406982422e+01 -3.1692098617553711e+01 8.3562097549438477e+00 4.8816200256347656e+01 -3.2350700378417969e+01 9.0286703109741211e+00 4.8500198364257812e+01 -3.3600700378417969e+01 1.0036600112915039e+01 4.7928897857666016e+01 -3.5124500274658203e+01 1.0990200042724609e+01 4.7263099670410156e+01 -3.6900501251220703e+01 1.1868399620056152e+01 4.6514701843261719e+01 -3.9306098937988281e+01 1.2791399955749512e+01 4.5535800933837891e+01 -4.0374698638916016e+01 1.3126100540161133e+01 4.5111896514892578e+01 -4.3502700805664062e+01 1.3894000053405762e+01 4.3905498504638672e+01 -4.6767601013183594e+01 1.4406100273132324e+01 4.2698799133300781e+01 -3.8063800811767578e+01 9.5400800704956055e+00 4.4891902923583984e+01 -4.0295200347900391e+01 1.0145899772644043e+01 4.3671100616455078e+01 -4.1286800384521484e+01 1.0362400054931641e+01 4.3135200500488281e+01 -4.4192298889160156e+01 1.0847999572753906e+01 4.1584598541259766e+01 -4.7233802795410156e+01 1.1154100418090820e+01 3.9989501953125000e+01 -5.0332500457763672e+01 1.1274100303649902e+01 3.8390800476074219e+01 -5.0074996948242188e+01 1.4648599624633789e+01 4.1530502319335938e+01 -4.9400600433349609e+01 1.8756000518798828e+01 4.3526897430419922e+01 -4.8372802734375000e+01 2.3207399368286133e+01 4.4190803527832031e+01 -4.7089199066162109e+01 2.7581001281738281e+01 4.3459197998046875e+01 -5.1417598724365234e+01 1.1270700454711914e+01 3.7836498260498047e+01 -5.1226100921630859e+01 1.4666600227355957e+01 4.1136802673339844e+01 -5.0629501342773438e+01 1.8869899749755859e+01 4.3242900848388672e+01 -4.9687301635742188e+01 2.3461200714111328e+01 4.3944797515869141e+01 -4.8493499755859375e+01 2.7982101440429688e+01 4.3172199249267578e+01 -5.4341598510742188e+01 1.1135700225830078e+01 3.6353000640869141e+01 -5.4297599792480469e+01 1.4527500152587891e+01 4.0116298675537109e+01 -5.3919597625732422e+01 1.8951499938964844e+01 4.2556201934814453e+01 -5.3250801086425781e+01 2.3903099060058594e+01 4.3394401550292969e+01 -5.2367500305175781e+01 2.8817298889160156e+01 4.2535301208496094e+01 -5.6874397277832031e+01 1.0848100662231445e+01 3.5068401336669922e+01 -5.6898696899414062e+01 1.4150000572204590e+01 3.9276397705078125e+01 -5.6720996856689453e+01 1.8710401535034180e+01 4.2065502166748047e+01 -5.6364101409912109e+01 2.3949699401855469e+01 4.3081298828125000e+01 -5.5873100280761719e+01 2.9201499938964844e+01 4.2194602966308594e+01 -1.3021199035644531e+02 1.4999499320983887e+00 5.1424400329589844e+01 -1.4133200073242188e+02 1.4999499320983887e+00 5.0821502685546875e+01 -1.4412599182128906e+02 1.4999499320983887e+00 4.8746299743652344e+01 -1.5206199645996094e+02 1.4999499320983887e+00 4.7842300415039062e+01 -1.5469400024414062e+02 1.4999499320983887e+00 4.5048400878906250e+01 -1.6190100097656250e+02 1.4999499320983887e+00 4.2625999450683594e+01 -1.6417401123046875e+02 1.4999499320983887e+00 3.9091503143310547e+01 -1.7038899230957031e+02 1.4999499320983887e+00 3.5416500091552734e+01 -1.7209201049804688e+02 1.4999499320983887e+00 3.1174499511718750e+01 -1.7712800598144531e+02 1.4999499320983887e+00 2.6551000595092773e+01 -1.7804800415039062e+02 1.4999499320983887e+00 2.1694200515747070e+01 -1.8180400085449219e+02 1.4999499320983887e+00 1.6444000244140625e+01 -1.8174600219726562e+02 1.4999499320983887e+00 1.1126000404357910e+01 -1.8419801330566406e+02 1.4999499320983887e+00 5.5680899620056152e+00 -1.8300000000000000e+02 1.4999499320983887e+00 0.0000000000000000e+00 -1.8419801330566406e+02 1.4999499320983887e+00 -5.5680899620056152e+00 -1.8174600219726562e+02 1.4999499320983887e+00 -1.1126000404357910e+01 -1.8180400085449219e+02 1.4999499320983887e+00 -1.6444000244140625e+01 -1.7804800415039062e+02 1.4999499320983887e+00 -2.1694200515747070e+01 -1.7712800598144531e+02 1.4999499320983887e+00 -2.6551000595092773e+01 -1.7209201049804688e+02 1.4999499320983887e+00 -3.1174499511718750e+01 -1.7038899230957031e+02 1.4999499320983887e+00 -3.5416500091552734e+01 -1.6417401123046875e+02 1.4999499320983887e+00 -3.9091503143310547e+01 -1.6190100097656250e+02 1.4999499320983887e+00 -4.2625999450683594e+01 -1.5469400024414062e+02 1.4999499320983887e+00 -4.5048400878906250e+01 -1.5206199645996094e+02 1.4999499320983887e+00 -4.7842300415039062e+01 -1.4412599182128906e+02 1.4999499320983887e+00 -4.8746299743652344e+01 -1.4133200073242188e+02 1.4999499320983887e+00 -5.0821502685546875e+01 -1.3300000000000000e+02 1.4999499320983887e+00 -4.9999900817871094e+01 -1.3021199035644531e+02 1.4999499320983887e+00 -5.1424400329589844e+01 -1.2187400054931641e+02 1.4999499320983887e+00 -4.8746299743652344e+01 -1.1922200012207031e+02 1.4999499320983887e+00 -4.9622798919677734e+01 -1.1130599975585938e+02 1.4999499320983887e+00 -4.5048400878906250e+01 -1.0887700653076172e+02 1.4999499320983887e+00 -4.5500900268554688e+01 -1.0182599639892578e+02 1.4999499320983887e+00 -3.9091503143310547e+01 -9.9659599304199219e+01 1.4999499320983887e+00 -3.9251300811767578e+01 -9.3908500671386719e+01 1.4999499320983887e+00 -3.1174499511718750e+01 -9.2001296997070312e+01 1.4999499320983887e+00 -3.1166400909423828e+01 -8.7951599121093750e+01 1.4999499320983887e+00 -2.1694200515747070e+01 -8.6259902954101562e+01 1.4999499320983887e+00 -2.1624300003051758e+01 -8.4253700256347656e+01 1.4999499320983887e+00 -1.1126000404357910e+01 -8.2704093933105469e+01 1.4999499320983887e+00 -1.1071000099182129e+01 -8.3000099182128906e+01 1.4999499320983887e+00 0.0000000000000000e+00 -8.1500000000000000e+01 1.4999499320983887e+00 0.0000000000000000e+00 -8.4253700256347656e+01 1.4999499320983887e+00 1.1126000404357910e+01 -8.2704093933105469e+01 1.4999499320983887e+00 1.1071000099182129e+01 -8.7951599121093750e+01 1.4999499320983887e+00 2.1694200515747070e+01 -8.6259902954101562e+01 1.4999499320983887e+00 2.1624300003051758e+01 -9.3908500671386719e+01 1.4999499320983887e+00 3.1174499511718750e+01 -9.2001296997070312e+01 1.4999499320983887e+00 3.1166400909423828e+01 -1.0182599639892578e+02 1.4999499320983887e+00 3.9091503143310547e+01 -9.9659599304199219e+01 1.4999499320983887e+00 3.9251300811767578e+01 -1.1130599975585938e+02 1.4999499320983887e+00 4.5048400878906250e+01 -1.0887700653076172e+02 1.4999499320983887e+00 4.5500900268554688e+01 -1.2187400054931641e+02 1.4999499320983887e+00 4.8746299743652344e+01 -1.1922200012207031e+02 1.4999499320983887e+00 4.9622798919677734e+01 -1.3300000000000000e+02 1.4999499320983887e+00 4.9999900817871094e+01 -1.1130599975585938e+02 5.4999599456787109e+00 -4.5048400878906250e+01 -1.5469400024414062e+02 5.4999599456787109e+00 4.5048400878906250e+01 -1.6417401123046875e+02 5.4999599456787109e+00 3.9091503143310547e+01 -1.7209201049804688e+02 5.4999599456787109e+00 3.1174499511718750e+01 -1.7804800415039062e+02 5.4999599456787109e+00 2.1694200515747070e+01 -1.8174600219726562e+02 5.4999599456787109e+00 1.1126000404357910e+01 -1.0182599639892578e+02 5.4999599456787109e+00 -3.9091503143310547e+01 -9.3908500671386719e+01 5.4999599456787109e+00 -3.1174499511718750e+01 -8.7951599121093750e+01 5.4999599456787109e+00 -2.1694200515747070e+01 -1.8300000000000000e+02 5.4999599456787109e+00 0.0000000000000000e+00 -1.8174600219726562e+02 5.4999599456787109e+00 -1.1126000404357910e+01 -1.7804800415039062e+02 5.4999599456787109e+00 -2.1694200515747070e+01 -8.4253700256347656e+01 5.4999599456787109e+00 -1.1126000404357910e+01 -8.3000099182128906e+01 5.4999599456787109e+00 0.0000000000000000e+00 -8.4253700256347656e+01 5.4999599456787109e+00 1.1126000404357910e+01 -1.1130599975585938e+02 5.4999599456787109e+00 4.5048400878906250e+01 -1.2187400054931641e+02 5.4999599456787109e+00 4.8746299743652344e+01 -1.3300000000000000e+02 5.4999599456787109e+00 4.9999900817871094e+01 -1.7209201049804688e+02 5.4999599456787109e+00 -3.1174499511718750e+01 -1.6417401123046875e+02 5.4999599456787109e+00 -3.9091503143310547e+01 -1.5469400024414062e+02 5.4999599456787109e+00 -4.5048400878906250e+01 -8.7951599121093750e+01 5.4999599456787109e+00 2.1694200515747070e+01 -9.3908500671386719e+01 5.4999599456787109e+00 3.1174499511718750e+01 -1.4412599182128906e+02 5.4999599456787109e+00 4.8746299743652344e+01 -1.4412599182128906e+02 5.4999599456787109e+00 -4.8746299743652344e+01 -1.3300000000000000e+02 5.4999599456787109e+00 -4.9999900817871094e+01 -1.2187400054931641e+02 5.4999599456787109e+00 -4.8746299743652344e+01 -1.0182599639892578e+02 5.4999599456787109e+00 3.9091503143310547e+01 3.1000000000000000e+01 -5.1198097229003906e+01 5.5680899620056152e+00 3.1000000000000000e+01 -5.1500000000000000e+01 0.0000000000000000e+00 3.1000000000000000e+01 -4.8500000000000000e+01 0.0000000000000000e+00 3.1000000000000000e+01 -5.1198097229003906e+01 -5.5680899620056152e+00 3.1000000000000000e+01 -4.7284000396728516e+01 -1.0792200088500977e+01 3.1000000000000000e+01 -4.8804100036621094e+01 -1.6444000244140625e+01 3.1000000000000000e+01 -4.3696899414062500e+01 -2.1043399810791016e+01 3.1000000000000000e+01 -4.4128101348876953e+01 -2.6551000595092773e+01 3.1000000000000000e+01 -3.7918800354003906e+01 -3.0239200592041016e+01 3.1000000000000000e+01 -3.7388702392578125e+01 -3.5416500091552734e+01 3.1000000000000000e+01 -3.0239200592041016e+01 -3.7918800354003906e+01 3.1000000000000000e+01 -2.8901100158691406e+01 -4.2625999450683594e+01 3.1000000000000000e+01 -2.1043399810791016e+01 -4.3696899414062500e+01 3.1000000000000000e+01 -1.9062099456787109e+01 -4.7842300415039062e+01 3.1000000000000000e+01 -1.0792200088500977e+01 -4.7284000396728516e+01 3.1000000000000000e+01 -8.3317193984985352e+00 -5.0821502685546875e+01 3.1000000000000000e+01 0.0000000000000000e+00 -4.8500000000000000e+01 3.1000000000000000e+01 2.7881300449371338e+00 -5.1424400329589844e+01 3.1000000000000000e+01 1.0792200088500977e+01 -4.7284000396728516e+01 3.1000000000000000e+01 1.3777700424194336e+01 -4.9622798919677734e+01 3.1000000000000000e+01 2.1043399810791016e+01 -4.3696899414062500e+01 3.1000000000000000e+01 2.4122999191284180e+01 -4.5500900268554688e+01 3.1000000000000000e+01 3.0239200592041016e+01 -3.7918800354003906e+01 3.1000000000000000e+01 3.3340396881103516e+01 -3.9251300811767578e+01 3.1000000000000000e+01 3.7918800354003906e+01 -3.0239200592041016e+01 3.1000000000000000e+01 4.0998699188232422e+01 -3.1166400909423828e+01 3.1000000000000000e+01 4.3696899414062500e+01 -2.1043399810791016e+01 3.1000000000000000e+01 4.6740100860595703e+01 -2.1624300003051758e+01 3.1000000000000000e+01 4.7284000396728516e+01 -1.0792200088500977e+01 3.1000000000000000e+01 5.0295902252197266e+01 -1.1071000099182129e+01 3.1000000000000000e+01 4.8500000000000000e+01 0.0000000000000000e+00 3.1000000000000000e+01 5.1500000000000000e+01 0.0000000000000000e+00 3.1000000000000000e+01 4.7284000396728516e+01 1.0792200088500977e+01 3.1000000000000000e+01 5.0295902252197266e+01 1.1071000099182129e+01 3.1000000000000000e+01 4.3696899414062500e+01 2.1043399810791016e+01 3.1000000000000000e+01 4.6740100860595703e+01 2.1624300003051758e+01 3.1000000000000000e+01 3.7918800354003906e+01 3.0239200592041016e+01 3.1000000000000000e+01 4.0998699188232422e+01 3.1166400909423828e+01 3.1000000000000000e+01 3.0239200592041016e+01 3.7918800354003906e+01 3.1000000000000000e+01 3.3340396881103516e+01 3.9251300811767578e+01 3.1000000000000000e+01 2.1043399810791016e+01 4.3696899414062500e+01 3.1000000000000000e+01 2.4122999191284180e+01 4.5500900268554688e+01 3.1000000000000000e+01 1.0792200088500977e+01 4.7284000396728516e+01 3.1000000000000000e+01 1.3777700424194336e+01 4.9622798919677734e+01 3.1000000000000000e+01 0.0000000000000000e+00 4.8500000000000000e+01 3.1000000000000000e+01 2.7881300449371338e+00 5.1424400329589844e+01 3.1000000000000000e+01 -1.0792200088500977e+01 4.7284000396728516e+01 3.1000000000000000e+01 -8.3317193984985352e+00 5.0821502685546875e+01 3.1000000000000000e+01 -2.1043399810791016e+01 4.3696899414062500e+01 3.1000000000000000e+01 -1.9062099456787109e+01 4.7842300415039062e+01 3.1000000000000000e+01 -3.0239200592041016e+01 3.7918800354003906e+01 3.1000000000000000e+01 -2.8901100158691406e+01 4.2625999450683594e+01 3.1000000000000000e+01 -3.7918800354003906e+01 3.0239200592041016e+01 3.1000000000000000e+01 -3.7388702392578125e+01 3.5416500091552734e+01 3.1000000000000000e+01 -4.3696899414062500e+01 2.1043399810791016e+01 3.1000000000000000e+01 -4.4128101348876953e+01 2.6551000595092773e+01 3.1000000000000000e+01 -4.7284000396728516e+01 1.0792200088500977e+01 3.1000000000000000e+01 -4.8804100036621094e+01 1.6444000244140625e+01 -1.2489900207519531e+02 5.8500000000000000e+01 4.9846000671386719e+01 -1.1700800323486328e+02 5.8500000000000000e+01 4.7901100158691406e+01 -1.1701599884033203e+02 5.9888198852539062e+01 4.7878101348876953e+01 -1.2893800354003906e+02 5.9888198852539062e+01 5.0312000274658203e+01 -1.3300000000000000e+02 5.8500000000000000e+01 5.0500000000000000e+01 -1.2490299987792969e+02 5.9888198852539062e+01 4.9822097778320312e+01 -1.2092000579833984e+02 5.9888198852539062e+01 4.9008998870849609e+01 -1.0953199768066406e+02 5.8500000000000000e+01 4.4715499877929688e+01 -1.0266300201416016e+02 5.8500000000000000e+01 4.0371803283691406e+01 -1.0267700195312500e+02 5.9888198852539062e+01 4.0352500915527344e+01 -1.0602200317382812e+02 5.9888198852539062e+01 4.2661598205566406e+01 -1.0954300689697266e+02 5.9888198852539062e+01 4.4694099426269531e+01 -1.1321499633789062e+02 5.9888198852539062e+01 4.6436702728271484e+01 -9.6579299926757812e+01 5.8500000000000000e+01 3.4982601165771484e+01 -9.1439407348632812e+01 5.8500000000000000e+01 2.8687198638916016e+01 -9.1459297180175781e+01 5.9888198852539062e+01 2.8673500061035156e+01 -9.3901298522949219e+01 5.9888198852539062e+01 3.1923099517822266e+01 -9.6596801757812500e+01 5.9888198852539062e+01 3.4965702056884766e+01 -9.9528404235839844e+01 5.9888198852539062e+01 3.7781600952148438e+01 -8.7375801086425781e+01 5.8500000000000000e+01 2.1648900985717773e+01 -8.4493896484375000e+01 5.8500000000000000e+01 1.4049900054931641e+01 -8.4517097473144531e+01 5.9888198852539062e+01 1.4043199539184570e+01 -8.5804405212402344e+01 5.9888198852539062e+01 1.7898900985717773e+01 -8.7397705078125000e+01 5.9888198852539062e+01 2.1638599395751953e+01 -8.9286697387695312e+01 5.9888198852539062e+01 2.5237800598144531e+01 -8.2868202209472656e+01 5.8500000000000000e+01 6.0870599746704102e+00 -8.2540992736816406e+01 5.8500000000000000e+01 -2.0334098339080811e+00 -8.2565200805664062e+01 5.9888198852539062e+01 -2.0324001312255859e+00 -8.2565200805664062e+01 5.9888198852539062e+01 2.0324001312255859e+00 -8.2892295837402344e+01 5.9888198852539062e+01 6.0841398239135742e+00 -8.3544403076171875e+01 5.9888198852539062e+01 1.0096400260925293e+01 -8.3520599365234375e+01 5.8500000000000000e+01 -1.0101299285888672e+01 -8.5781700134277344e+01 5.8500000000000000e+01 -1.7907501220703125e+01 -8.5804405212402344e+01 5.9888198852539062e+01 -1.7898900985717773e+01 -8.4517097473144531e+01 5.9888198852539062e+01 -1.4043199539184570e+01 -8.3544403076171875e+01 5.9888198852539062e+01 -1.0096400260925293e+01 -8.2892295837402344e+01 5.9888198852539062e+01 -6.0841398239135742e+00 -8.9265800476074219e+01 5.8500000000000000e+01 -2.5250000000000000e+01 -9.3882499694824219e+01 5.8500000000000000e+01 -3.1938501358032227e+01 -9.3901298522949219e+01 5.9888198852539062e+01 -3.1923099517822266e+01 -9.1459297180175781e+01 5.9888198852539062e+01 -2.8673500061035156e+01 -8.9286697387695312e+01 5.9888198852539062e+01 -2.5237800598144531e+01 -8.7397705078125000e+01 5.9888198852539062e+01 -2.1638599395751953e+01 -9.9512298583984375e+01 5.8500000000000000e+01 -3.7799800872802734e+01 -1.0600999450683594e+02 5.8500000000000000e+01 -4.2681999206542969e+01 -1.0602200317382812e+02 5.9888198852539062e+01 -4.2661598205566406e+01 -1.0267700195312500e+02 5.9888198852539062e+01 -4.0352500915527344e+01 -9.9528404235839844e+01 5.9888198852539062e+01 -3.7781600952148438e+01 -9.6596801757812500e+01 5.9888198852539062e+01 -3.4965702056884766e+01 -1.1320600128173828e+02 5.8500000000000000e+01 -4.6458900451660156e+01 -1.2091500091552734e+02 5.8500000000000000e+01 -4.9032497406005859e+01 -1.2092000579833984e+02 5.9888198852539062e+01 -4.9008998870849609e+01 -1.1701599884033203e+02 5.9888198852539062e+01 -4.7878101348876953e+01 -1.1321499633789062e+02 5.9888198852539062e+01 -4.6436702728271484e+01 -1.0954300689697266e+02 5.9888198852539062e+01 -4.4694099426269531e+01 -1.2893598937988281e+02 5.8500000000000000e+01 -5.0336200714111328e+01 -1.3706399536132812e+02 5.8500000000000000e+01 -5.0336200714111328e+01 -1.3706199645996094e+02 5.9888198852539062e+01 -5.0312000274658203e+01 -1.3300000000000000e+02 5.9888198852539062e+01 -5.0475700378417969e+01 -1.2893800354003906e+02 5.9888198852539062e+01 -5.0312000274658203e+01 -1.2490299987792969e+02 5.9888198852539062e+01 -4.9822097778320312e+01 -1.4508500671386719e+02 5.8500000000000000e+01 -4.9032497406005859e+01 -1.5279400634765625e+02 5.8500000000000000e+01 -4.6458900451660156e+01 -1.5278500366210938e+02 5.9888198852539062e+01 -4.6436702728271484e+01 -1.4898399353027344e+02 5.9888198852539062e+01 -4.7878101348876953e+01 -1.4508000183105469e+02 5.9888198852539062e+01 -4.9008998870849609e+01 -1.4109700012207031e+02 5.9888198852539062e+01 -4.9822097778320312e+01 -1.5998999023437500e+02 5.8500000000000000e+01 -4.2681999206542969e+01 -1.6648800659179688e+02 5.8500000000000000e+01 -3.7799800872802734e+01 -1.6647200012207031e+02 5.9888198852539062e+01 -3.7781600952148438e+01 -1.6332299804687500e+02 5.9888198852539062e+01 -4.0352500915527344e+01 -1.5997799682617188e+02 5.9888198852539062e+01 -4.2661598205566406e+01 -1.5645700073242188e+02 5.9888198852539062e+01 -4.4694099426269531e+01 -1.7673399353027344e+02 5.8500000000000000e+01 -2.5250000000000000e+01 -1.7454100036621094e+02 5.9888198852539062e+01 -2.8673500061035156e+01 -1.7211799621582031e+02 5.8500000000000000e+01 -3.1938501358032227e+01 -1.7209899902343750e+02 5.9888198852539062e+01 -3.1923099517822266e+01 -1.6940299987792969e+02 5.9888198852539062e+01 -3.4965702056884766e+01 -1.8021800231933594e+02 5.8500000000000000e+01 -1.7907501220703125e+01 -1.7860198974609375e+02 5.9888198852539062e+01 -2.1638599395751953e+01 -1.7671299743652344e+02 5.9888198852539062e+01 -2.5237800598144531e+01 -1.8247898864746094e+02 5.8500000000000000e+01 -1.0101299285888672e+01 -1.8148300170898438e+02 5.9888198852539062e+01 -1.4043199539184570e+01 -1.8019599914550781e+02 5.9888198852539062e+01 -1.7898900985717773e+01 -1.8343499755859375e+02 5.9888198852539062e+01 2.0324001312255859e+00 -1.8343499755859375e+02 5.9888198852539062e+01 -2.0324001312255859e+00 -1.8345899963378906e+02 5.8500000000000000e+01 -2.0334098339080811e+00 -1.8310800170898438e+02 5.9888198852539062e+01 -6.0841398239135742e+00 -1.8245600891113281e+02 5.9888198852539062e+01 -1.0096400260925293e+01 -1.8310800170898438e+02 5.9888198852539062e+01 6.0841398239135742e+00 -1.8313198852539062e+02 5.8500000000000000e+01 6.0870599746704102e+00 -1.8245600891113281e+02 5.9888198852539062e+01 1.0096400260925293e+01 -1.8150599670410156e+02 5.8500000000000000e+01 1.4049900054931641e+01 -1.8148300170898438e+02 5.9888198852539062e+01 1.4043199539184570e+01 -1.7862400817871094e+02 5.8500000000000000e+01 2.1648900985717773e+01 -1.7860198974609375e+02 5.9888198852539062e+01 2.1638599395751953e+01 -1.8019599914550781e+02 5.9888198852539062e+01 1.7898900985717773e+01 -1.6647200012207031e+02 5.9888198852539062e+01 3.7781600952148438e+01 -1.6940299987792969e+02 5.9888198852539062e+01 3.4965702056884766e+01 -1.6942100524902344e+02 5.8500000000000000e+01 3.4982601165771484e+01 -1.7209899902343750e+02 5.9888198852539062e+01 3.1923099517822266e+01 -1.7456098937988281e+02 5.8500000000000000e+01 2.8687198638916016e+01 -1.7454100036621094e+02 5.9888198852539062e+01 2.8673500061035156e+01 -1.7671299743652344e+02 5.9888198852539062e+01 2.5237800598144531e+01 -1.6332299804687500e+02 5.9888198852539062e+01 4.0352500915527344e+01 -1.6333700561523438e+02 5.8500000000000000e+01 4.0371803283691406e+01 -1.5997799682617188e+02 5.9888198852539062e+01 4.2661598205566406e+01 -1.5646800231933594e+02 5.8500000000000000e+01 4.4715499877929688e+01 -1.5645700073242188e+02 5.9888198852539062e+01 4.4694099426269531e+01 -1.4899200439453125e+02 5.8500000000000000e+01 4.7901100158691406e+01 -1.4898399353027344e+02 5.9888198852539062e+01 4.7878101348876953e+01 -1.5278500366210938e+02 5.9888198852539062e+01 4.6436702728271484e+01 -1.3300000000000000e+02 5.9888198852539062e+01 5.0475700378417969e+01 -1.3706199645996094e+02 5.9888198852539062e+01 5.0312000274658203e+01 -1.4110099792480469e+02 5.8500000000000000e+01 4.9846000671386719e+01 -1.4109700012207031e+02 5.9888198852539062e+01 4.9822097778320312e+01 -1.4508000183105469e+02 5.9888198852539062e+01 4.9008998870849609e+01 -1.0872699737548828e+02 7.0499893188476562e+01 3.7152900695800781e+01 -1.0574199676513672e+02 7.0499893188476562e+01 3.5021499633789062e+01 -1.5412199401855469e+02 7.0499893188476562e+01 -3.9030399322509766e+01 -1.0294300079345703e+02 7.0499893188476562e+01 3.2650897979736328e+01 -1.0034899902343750e+02 7.0499893188476562e+01 3.0057199478149414e+01 -1.1187799835205078e+02 7.0499893188476562e+01 3.9030399322509766e+01 -1.5727299499511719e+02 7.0499893188476562e+01 -3.7152900695800781e+01 -1.6025799560546875e+02 7.0499893188476562e+01 -3.5021499633789062e+01 -1.6305700683593750e+02 7.0499893188476562e+01 -3.2650897979736328e+01 -1.6565100097656250e+02 7.0499893188476562e+01 -3.0057199478149414e+01 -1.6802099609375000e+02 7.0499893188476562e+01 -2.7258298873901367e+01 -1.7364099121093750e+02 7.0499893188476562e+01 -1.7826999664306641e+01 -1.7497499084472656e+02 7.0499893188476562e+01 -1.4409899711608887e+01 -1.7602099609375000e+02 7.0499893188476562e+01 -1.0894499778747559e+01 -1.7677400207519531e+02 7.0499893188476562e+01 -7.3045501708984375e+00 -9.7978500366210938e+01 7.0499893188476562e+01 2.7258298873901367e+01 -9.5847099304199219e+01 7.0499893188476562e+01 2.4273099899291992e+01 -9.3969596862792969e+01 7.0499893188476562e+01 2.1122200012207031e+01 -9.2358596801757812e+01 7.0499893188476562e+01 1.7826999664306641e+01 -9.1025299072265625e+01 7.0499893188476562e+01 1.4409899711608887e+01 -8.9978698730468750e+01 7.0499893188476562e+01 1.0894499778747559e+01 -8.9978698730468750e+01 7.0499893188476562e+01 -1.0894499778747559e+01 -9.1025299072265625e+01 7.0499893188476562e+01 -1.4409899711608887e+01 -9.5847099304199219e+01 7.0499893188476562e+01 -2.4273099899291992e+01 -9.7978500366210938e+01 7.0499893188476562e+01 -2.7258298873901367e+01 -1.0034899902343750e+02 7.0499893188476562e+01 -3.0057199478149414e+01 -1.0294300079345703e+02 7.0499893188476562e+01 -3.2650897979736328e+01 -1.0574199676513672e+02 7.0499893188476562e+01 -3.5021499633789062e+01 -1.0872699737548828e+02 7.0499893188476562e+01 -3.7152900695800781e+01 -1.5082701110839844e+02 7.0499893188476562e+01 -4.0641399383544922e+01 -1.7015299987792969e+02 7.0499893188476562e+01 -2.4273099899291992e+01 -1.7202999877929688e+02 7.0499893188476562e+01 -2.1122200012207031e+01 -1.7602099609375000e+02 7.0499893188476562e+01 1.0894499778747559e+01 -1.4389399719238281e+02 7.0499893188476562e+01 4.3021297454833984e+01 -1.4030499267578125e+02 7.0499893188476562e+01 4.3774002075195312e+01 -8.9225997924804688e+01 7.0499893188476562e+01 7.3045501708984375e+00 -8.8772293090820312e+01 7.0499893188476562e+01 3.6647899150848389e+00 -8.8620697021484375e+01 7.0499893188476562e+01 0.0000000000000000e+00 -9.2358596801757812e+01 7.0499893188476562e+01 -1.7826999664306641e+01 -9.3969596862792969e+01 7.0499893188476562e+01 -2.1122200012207031e+01 -1.7722799682617188e+02 7.0499893188476562e+01 -3.6647899150848389e+00 -1.7737899780273438e+02 7.0499893188476562e+01 0.0000000000000000e+00 -1.7722799682617188e+02 7.0499893188476562e+01 3.6647899150848389e+00 -1.1517299652099609e+02 7.0499893188476562e+01 -4.0641399383544922e+01 -1.1858999633789062e+02 7.0499893188476562e+01 -4.1974700927734375e+01 -1.4741000366210938e+02 7.0499893188476562e+01 -4.1974700927734375e+01 -1.7497499084472656e+02 7.0499893188476562e+01 1.4409899711608887e+01 -1.7364099121093750e+02 7.0499893188476562e+01 1.7826999664306641e+01 -1.7202999877929688e+02 7.0499893188476562e+01 2.1122200012207031e+01 -8.8772293090820312e+01 7.0499893188476562e+01 -3.6647899150848389e+00 -8.9225997924804688e+01 7.0499893188476562e+01 -7.3045501708984375e+00 -1.3666500854492188e+02 7.0499893188476562e+01 4.4227699279785156e+01 -1.3300000000000000e+02 7.0499893188476562e+01 4.4379302978515625e+01 -1.2933500671386719e+02 7.0499893188476562e+01 4.4227699279785156e+01 -1.1187799835205078e+02 7.0499893188476562e+01 -3.9030399322509766e+01 -1.2210600280761719e+02 7.0499893188476562e+01 -4.3021297454833984e+01 -1.2569500732421875e+02 7.0499893188476562e+01 -4.3774002075195312e+01 -1.4389399719238281e+02 7.0499893188476562e+01 -4.3021297454833984e+01 -1.2933500671386719e+02 7.0499893188476562e+01 -4.4227699279785156e+01 -1.3300000000000000e+02 7.0499893188476562e+01 -4.4379302978515625e+01 -1.3666500854492188e+02 7.0499893188476562e+01 -4.4227699279785156e+01 -1.4030499267578125e+02 7.0499893188476562e+01 -4.3774002075195312e+01 -1.7015299987792969e+02 7.0499893188476562e+01 2.4273099899291992e+01 -1.6802099609375000e+02 7.0499893188476562e+01 2.7258298873901367e+01 -1.6565100097656250e+02 7.0499893188476562e+01 3.0057199478149414e+01 -1.6305700683593750e+02 7.0499893188476562e+01 3.2650897979736328e+01 -1.6025799560546875e+02 7.0499893188476562e+01 3.5021499633789062e+01 -1.5727299499511719e+02 7.0499893188476562e+01 3.7152900695800781e+01 -1.5412199401855469e+02 7.0499893188476562e+01 3.9030399322509766e+01 -1.5082701110839844e+02 7.0499893188476562e+01 4.0641399383544922e+01 -1.4741000366210938e+02 7.0499893188476562e+01 4.1974700927734375e+01 -1.2569500732421875e+02 7.0499893188476562e+01 4.3774002075195312e+01 -1.2210600280761719e+02 7.0499893188476562e+01 4.3021297454833984e+01 -1.1858999633789062e+02 7.0499893188476562e+01 4.1974700927734375e+01 -1.7677400207519531e+02 7.0499893188476562e+01 7.3045501708984375e+00 -1.1517299652099609e+02 7.0499893188476562e+01 4.0641399383544922e+01 -1.3688899230957031e+02 6.8767799377441406e+01 -4.6937301635742188e+01 -1.4097698974609375e+02 6.3129501342773438e+01 -4.9083499908447266e+01 -1.4075199890136719e+02 6.8767799377441406e+01 -4.6455902099609375e+01 -1.4118299865722656e+02 6.3129501342773438e+01 -4.9041301727294922e+01 -1.4456201171875000e+02 6.8767799377441406e+01 -4.5657001495361328e+01 -1.5191900634765625e+02 6.8767799377441406e+01 -4.3131298065185547e+01 -1.5610900878906250e+02 6.3129501342773438e+01 -4.4031398773193359e+01 -1.5541600036621094e+02 6.8767799377441406e+01 -4.1421600341796875e+01 -1.5665699768066406e+02 6.3129501342773438e+01 -4.3715396881103516e+01 -1.5875999450683594e+02 6.8767799377441406e+01 -3.9429100036621094e+01 -1.4490100097656250e+02 6.3129501342773438e+01 -4.8282398223876953e+01 -1.4874699401855469e+02 6.3129501342773438e+01 -4.7168300628662109e+01 -1.4829299926757812e+02 6.8767799377441406e+01 -4.4546298980712891e+01 -1.4914099121093750e+02 6.3129501342773438e+01 -4.7018798828125000e+01 -1.5249099731445312e+02 6.3129501342773438e+01 -4.5748199462890625e+01 -1.6489900207519531e+02 6.8767799377441406e+01 -3.4651302337646484e+01 -1.6886399841308594e+02 6.3129501342773438e+01 -3.4447402954101562e+01 -1.6765100097656250e+02 6.8767799377441406e+01 -3.1898698806762695e+01 -1.6956199645996094e+02 6.3129501342773438e+01 -3.3658699035644531e+01 -1.7016699218750000e+02 6.8767799377441406e+01 -2.8928300857543945e+01 -1.5957800292968750e+02 6.3129501342773438e+01 -4.2029102325439453e+01 -1.6287300109863281e+02 6.3129501342773438e+01 -3.9754199981689453e+01 -1.6192799377441406e+02 6.8767799377441406e+01 -3.7167098999023438e+01 -1.6352600097656250e+02 6.3129501342773438e+01 -3.9221202850341797e+01 -1.6597500610351562e+02 6.3129501342773438e+01 -3.7221500396728516e+01 -1.7442199707031250e+02 6.8767799377441406e+01 -2.2416299819946289e+01 -1.7792601013183594e+02 6.3129501342773438e+01 -2.1317800521850586e+01 -1.7613099670410156e+02 6.8767799377441406e+01 -1.8919099807739258e+01 -1.7850500488281250e+02 6.3129501342773438e+01 -1.9960601806640625e+01 -1.7754598999023438e+02 6.8767799377441406e+01 -1.5292799949645996e+01 -1.7151899719238281e+02 6.3129501342773438e+01 -3.1449899673461914e+01 -1.7392500305175781e+02 6.3129501342773438e+01 -2.8248399734497070e+01 -1.7242900085449219e+02 6.8767799377441406e+01 -2.5760299682617188e+01 -1.7460099792480469e+02 6.3129501342773438e+01 -2.7179599761962891e+01 -1.7606500244140625e+02 6.3129501342773438e+01 -2.4863698959350586e+01 -1.8236500549316406e+02 6.3129501342773438e+01 -5.9939599037170410e+00 -1.7993701171875000e+02 6.8767799377441406e+01 -3.8893198966979980e+00 -1.7945599365234375e+02 6.8767799377441406e+01 -7.7520599365234375e+00 -1.7949600219726562e+02 6.3129501342773438e+01 -1.7633499145507812e+01 -1.8076400756835938e+02 6.3129501342773438e+01 -1.3835000038146973e+01 -1.7865699768066406e+02 6.8767799377441406e+01 -1.1561900138854980e+01 -1.8116799926757812e+02 6.3129501342773438e+01 -1.2197899818420410e+01 -1.8172200012207031e+02 6.3129501342773438e+01 -9.9467601776123047e+00 -1.8251800537109375e+02 6.3129501342773438e+01 -4.1031799316406250e+00 -1.8268699645996094e+02 6.3129501342773438e+01 -2.0023000240325928e+00 -1.8009799194335938e+02 6.8767799377441406e+01 0.0000000000000000e+00 -1.8268699645996094e+02 6.3129501342773438e+01 2.0023000240325928e+00 -1.7993701171875000e+02 6.8767799377441406e+01 3.8893198966979980e+00 -1.8251800537109375e+02 6.3129501342773438e+01 4.1031799316406250e+00 -1.8236500549316406e+02 6.3129501342773438e+01 5.9939599037170410e+00 -1.7945599365234375e+02 6.8767799377441406e+01 7.7520599365234375e+00 -1.8172200012207031e+02 6.3129501342773438e+01 9.9467601776123047e+00 -1.7865699768066406e+02 6.8767799377441406e+01 1.1561900138854980e+01 -1.8116799926757812e+02 6.3129501342773438e+01 1.2197899818420410e+01 -1.8076400756835938e+02 6.3129501342773438e+01 1.3835000038146973e+01 -1.7754598999023438e+02 6.8767799377441406e+01 1.5292799949645996e+01 -1.7949600219726562e+02 6.3129501342773438e+01 1.7633499145507812e+01 -1.7613099670410156e+02 6.8767799377441406e+01 1.8919099807739258e+01 -1.7850500488281250e+02 6.3129501342773438e+01 1.9960601806640625e+01 -1.7792601013183594e+02 6.3129501342773438e+01 2.1317800521850586e+01 -1.7442199707031250e+02 6.8767799377441406e+01 2.2416299819946289e+01 -1.7606500244140625e+02 6.3129501342773438e+01 2.4863698959350586e+01 -1.7242900085449219e+02 6.8767799377441406e+01 2.5760299682617188e+01 -1.7460099792480469e+02 6.3129501342773438e+01 2.7179599761962891e+01 -1.7392500305175781e+02 6.3129501342773438e+01 2.8248399734497070e+01 -1.7016699218750000e+02 6.8767799377441406e+01 2.8928300857543945e+01 -1.7151899719238281e+02 6.3129501342773438e+01 3.1449899673461914e+01 -1.6765100097656250e+02 6.8767799377441406e+01 3.1898698806762695e+01 -1.6956199645996094e+02 6.3129501342773438e+01 3.3658699035644531e+01 -1.6886399841308594e+02 6.3129501342773438e+01 3.4447402954101562e+01 -1.6489900207519531e+02 6.8767799377441406e+01 3.4651302337646484e+01 -1.6597500610351562e+02 6.3129501342773438e+01 3.7221500396728516e+01 -1.6192799377441406e+02 6.8767799377441406e+01 3.7167098999023438e+01 -1.6352600097656250e+02 6.3129501342773438e+01 3.9221202850341797e+01 -1.6287300109863281e+02 6.3129501342773438e+01 3.9754199981689453e+01 -1.5875999450683594e+02 6.8767799377441406e+01 3.9429100036621094e+01 -1.5957800292968750e+02 6.3129501342773438e+01 4.2029102325439453e+01 -1.5541600036621094e+02 6.8767799377441406e+01 4.1421600341796875e+01 -1.5665699768066406e+02 6.3129501342773438e+01 4.3715396881103516e+01 -1.5610900878906250e+02 6.3129501342773438e+01 4.4031398773193359e+01 -1.5191900634765625e+02 6.8767799377441406e+01 4.3131298065185547e+01 -1.5249099731445312e+02 6.3129501342773438e+01 4.5748199462890625e+01 -1.4829299926757812e+02 6.8767799377441406e+01 4.4546298980712891e+01 -1.4914099121093750e+02 6.3129501342773438e+01 4.7018798828125000e+01 -1.4874699401855469e+02 6.3129501342773438e+01 4.7168300628662109e+01 -1.4456201171875000e+02 6.8767799377441406e+01 4.5657001495361328e+01 -1.4490100097656250e+02 6.3129501342773438e+01 4.8282398223876953e+01 -1.4075199890136719e+02 6.8767799377441406e+01 4.6455902099609375e+01 -1.2911100769042969e+02 6.8767799377441406e+01 4.6937301635742188e+01 -1.2502301025390625e+02 6.3129501342773438e+01 4.9083499908447266e+01 -1.2524800109863281e+02 6.8767799377441406e+01 4.6455902099609375e+01 -1.2481700134277344e+02 6.3129501342773438e+01 4.9041301727294922e+01 -1.2143799591064453e+02 6.8767799377441406e+01 4.5657001495361328e+01 -1.4118299865722656e+02 6.3129501342773438e+01 4.9041301727294922e+01 -1.4097698974609375e+02 6.3129501342773438e+01 4.9083499908447266e+01 -1.3688899230957031e+02 6.8767799377441406e+01 4.6937301635742188e+01 -1.3700099182128906e+02 6.3129501342773438e+01 4.9566101074218750e+01 -1.3300000000000000e+02 6.8767799377441406e+01 4.7098201751708984e+01 -1.3300000000000000e+02 6.3129501342773438e+01 4.9727397918701172e+01 -1.2899899291992188e+02 6.3129501342773438e+01 4.9566101074218750e+01 -1.1408100128173828e+02 6.8767799377441406e+01 4.3131298065185547e+01 -1.0989099884033203e+02 6.3129501342773438e+01 4.4031398773193359e+01 -1.1058399963378906e+02 6.8767799377441406e+01 4.1421600341796875e+01 -1.0934300231933594e+02 6.3129501342773438e+01 4.3715396881103516e+01 -1.0723999786376953e+02 6.8767799377441406e+01 3.9429100036621094e+01 -1.2109899902343750e+02 6.3129501342773438e+01 4.8282398223876953e+01 -1.1725299835205078e+02 6.3129501342773438e+01 4.7168300628662109e+01 -1.1770700073242188e+02 6.8767799377441406e+01 4.4546298980712891e+01 -1.1685899353027344e+02 6.3129501342773438e+01 4.7018798828125000e+01 -1.1350900268554688e+02 6.3129501342773438e+01 4.5748199462890625e+01 -1.0110100555419922e+02 6.8767799377441406e+01 3.4651302337646484e+01 -9.7136497497558594e+01 6.3129501342773438e+01 3.4447402954101562e+01 -9.8348701477050781e+01 6.8767799377441406e+01 3.1898698806762695e+01 -9.6437698364257812e+01 6.3129501342773438e+01 3.3658699035644531e+01 -9.5832901000976562e+01 6.8767799377441406e+01 2.8928300857543945e+01 -1.0642199707031250e+02 6.3129501342773438e+01 4.2029102325439453e+01 -1.0312699890136719e+02 6.3129501342773438e+01 3.9754199981689453e+01 -1.0407199859619141e+02 6.8767799377441406e+01 3.7167098999023438e+01 -1.0247399902343750e+02 6.3129501342773438e+01 3.9221202850341797e+01 -1.0002500152587891e+02 6.3129501342773438e+01 3.7221500396728516e+01 -9.1578399658203125e+01 6.8767799377441406e+01 2.2416299819946289e+01 -8.8073699951171875e+01 6.3129501342773438e+01 2.1317800521850586e+01 -8.9868705749511719e+01 6.8767799377441406e+01 1.8919099807739258e+01 -8.7495498657226562e+01 6.3129501342773438e+01 1.9960601806640625e+01 -8.8453704833984375e+01 6.8767799377441406e+01 1.5292799949645996e+01 -9.4480903625488281e+01 6.3129501342773438e+01 3.1449899673461914e+01 -9.2075195312500000e+01 6.3129501342773438e+01 2.8248399734497070e+01 -9.3570899963378906e+01 6.8767799377441406e+01 2.5760299682617188e+01 -9.1399398803710938e+01 6.3129501342773438e+01 2.7179599761962891e+01 -8.9934806823730469e+01 6.3129501342773438e+01 2.4863698959350586e+01 -8.3635101318359375e+01 6.3129501342773438e+01 5.9939599037170410e+00 -8.6062698364257812e+01 6.8767799377441406e+01 3.8893198966979980e+00 -8.6544097900390625e+01 6.8767799377441406e+01 7.7520599365234375e+00 -8.6503997802734375e+01 6.3129501342773438e+01 1.7633499145507812e+01 -8.5235900878906250e+01 6.3129501342773438e+01 1.3835000038146973e+01 -8.7343002319335938e+01 6.8767799377441406e+01 1.1561900138854980e+01 -8.4832397460937500e+01 6.3129501342773438e+01 1.2197899818420410e+01 -8.4277603149414062e+01 6.3129501342773438e+01 9.9467601776123047e+00 -8.3482498168945312e+01 6.3129501342773438e+01 4.1031799316406250e+00 -8.3312896728515625e+01 6.3129501342773438e+01 2.0023000240325928e+00 -8.5901794433593750e+01 6.8767799377441406e+01 0.0000000000000000e+00 -8.3312896728515625e+01 6.3129501342773438e+01 -2.0023000240325928e+00 -8.6062698364257812e+01 6.8767799377441406e+01 -3.8893198966979980e+00 -8.3482498168945312e+01 6.3129501342773438e+01 -4.1031799316406250e+00 -8.3635101318359375e+01 6.3129501342773438e+01 -5.9939599037170410e+00 -8.6544097900390625e+01 6.8767799377441406e+01 -7.7520599365234375e+00 -8.4277603149414062e+01 6.3129501342773438e+01 -9.9467601776123047e+00 -8.7343002319335938e+01 6.8767799377441406e+01 -1.1561900138854980e+01 -8.4832397460937500e+01 6.3129501342773438e+01 -1.2197899818420410e+01 -8.5235900878906250e+01 6.3129501342773438e+01 -1.3835000038146973e+01 -8.8453704833984375e+01 6.8767799377441406e+01 -1.5292799949645996e+01 -8.6503997802734375e+01 6.3129501342773438e+01 -1.7633499145507812e+01 -8.9868705749511719e+01 6.8767799377441406e+01 -1.8919099807739258e+01 -8.7495498657226562e+01 6.3129501342773438e+01 -1.9960601806640625e+01 -8.8073699951171875e+01 6.3129501342773438e+01 -2.1317800521850586e+01 -9.1578399658203125e+01 6.8767799377441406e+01 -2.2416299819946289e+01 -8.9934806823730469e+01 6.3129501342773438e+01 -2.4863698959350586e+01 -9.3570899963378906e+01 6.8767799377441406e+01 -2.5760299682617188e+01 -9.1399398803710938e+01 6.3129501342773438e+01 -2.7179599761962891e+01 -9.2075195312500000e+01 6.3129501342773438e+01 -2.8248399734497070e+01 -9.5832901000976562e+01 6.8767799377441406e+01 -2.8928300857543945e+01 -9.4480903625488281e+01 6.3129501342773438e+01 -3.1449899673461914e+01 -9.8348701477050781e+01 6.8767799377441406e+01 -3.1898698806762695e+01 -9.6437698364257812e+01 6.3129501342773438e+01 -3.3658699035644531e+01 -9.7136497497558594e+01 6.3129501342773438e+01 -3.4447402954101562e+01 -1.0110100555419922e+02 6.8767799377441406e+01 -3.4651302337646484e+01 -1.0002500152587891e+02 6.3129501342773438e+01 -3.7221500396728516e+01 -1.0407199859619141e+02 6.8767799377441406e+01 -3.7167098999023438e+01 -1.0247399902343750e+02 6.3129501342773438e+01 -3.9221202850341797e+01 -1.0312699890136719e+02 6.3129501342773438e+01 -3.9754199981689453e+01 -1.0723999786376953e+02 6.8767799377441406e+01 -3.9429100036621094e+01 -1.0642199707031250e+02 6.3129501342773438e+01 -4.2029102325439453e+01 -1.1058399963378906e+02 6.8767799377441406e+01 -4.1421600341796875e+01 -1.0934300231933594e+02 6.3129501342773438e+01 -4.3715396881103516e+01 -1.0989099884033203e+02 6.3129501342773438e+01 -4.4031398773193359e+01 -1.1408100128173828e+02 6.8767799377441406e+01 -4.3131298065185547e+01 -1.1350900268554688e+02 6.3129501342773438e+01 -4.5748199462890625e+01 -1.1770700073242188e+02 6.8767799377441406e+01 -4.4546298980712891e+01 -1.1685899353027344e+02 6.3129501342773438e+01 -4.7018798828125000e+01 -1.1725299835205078e+02 6.3129501342773438e+01 -4.7168300628662109e+01 -1.2143799591064453e+02 6.8767799377441406e+01 -4.5657001495361328e+01 -1.2109899902343750e+02 6.3129501342773438e+01 -4.8282398223876953e+01 -1.2524800109863281e+02 6.8767799377441406e+01 -4.6455902099609375e+01 -1.2481700134277344e+02 6.3129501342773438e+01 -4.9041301727294922e+01 -1.2502301025390625e+02 6.3129501342773438e+01 -4.9083499908447266e+01 -1.2911100769042969e+02 6.8767799377441406e+01 -4.6937301635742188e+01 -1.2899899291992188e+02 6.3129501342773438e+01 -4.9566101074218750e+01 -1.3300000000000000e+02 6.8767799377441406e+01 -4.7098201751708984e+01 -1.3300000000000000e+02 6.3129501342773438e+01 -4.9727397918701172e+01 -1.3700099182128906e+02 6.3129501342773438e+01 -4.9566101074218750e+01 -1.4503100585937500e+02 6.1548198699951172e+01 4.8811100006103516e+01 -1.4891999816894531e+02 6.1548198699951172e+01 4.7684700012207031e+01 -1.5270500183105469e+02 6.1548198699951172e+01 4.6249198913574219e+01 -1.5636299133300781e+02 6.1548198699951172e+01 4.4513603210449219e+01 -1.5986900329589844e+02 6.1548198699951172e+01 4.2489299774169922e+01 -1.6320001220703125e+02 6.1548198699951172e+01 4.0189502716064453e+01 -1.6633599853515625e+02 6.1548198699951172e+01 3.7629100799560547e+01 -1.6925599670410156e+02 6.1548198699951172e+01 3.4824600219726562e+01 -1.7194099426269531e+02 6.1548198699951172e+01 3.1794298171997070e+01 -1.7437300109863281e+02 6.1548198699951172e+01 2.8557699203491211e+01 -1.7653700256347656e+02 6.1548198699951172e+01 2.5135900497436523e+01 -1.7841799926757812e+02 6.1548198699951172e+01 2.1551198959350586e+01 -1.8000500488281250e+02 6.1548198699951172e+01 1.7826700210571289e+01 -1.8128700256347656e+02 6.1548198699951172e+01 1.3986499786376953e+01 -1.8225599670410156e+02 6.1548198699951172e+01 1.0055700302124023e+01 -1.8290499877929688e+02 6.1548198699951172e+01 6.0595898628234863e+00 -1.8323100280761719e+02 6.1548198699951172e+01 2.0242300033569336e+00 -1.8290499877929688e+02 6.1548198699951172e+01 -6.0595898628234863e+00 -1.8323100280761719e+02 6.1548198699951172e+01 -2.0242300033569336e+00 -1.8225599670410156e+02 6.1548198699951172e+01 -1.0055700302124023e+01 -1.8128700256347656e+02 6.1548198699951172e+01 -1.3986499786376953e+01 -1.7841799926757812e+02 6.1548198699951172e+01 -2.1551198959350586e+01 -1.8000500488281250e+02 6.1548198699951172e+01 -1.7826700210571289e+01 -1.7653700256347656e+02 6.1548198699951172e+01 -2.5135900497436523e+01 -1.7437300109863281e+02 6.1548198699951172e+01 -2.8557699203491211e+01 -1.6925599670410156e+02 6.1548198699951172e+01 -3.4824600219726562e+01 -1.7194099426269531e+02 6.1548198699951172e+01 -3.1794298171997070e+01 -1.6633599853515625e+02 6.1548198699951172e+01 -3.7629100799560547e+01 -1.6320001220703125e+02 6.1548198699951172e+01 -4.0189502716064453e+01 -1.5986900329589844e+02 6.1548198699951172e+01 -4.2489299774169922e+01 -1.5636299133300781e+02 6.1548198699951172e+01 -4.4513603210449219e+01 -1.5270500183105469e+02 6.1548198699951172e+01 -4.6249198913574219e+01 -1.4891999816894531e+02 6.1548198699951172e+01 -4.7684700012207031e+01 -1.4503100585937500e+02 6.1548198699951172e+01 -4.8811100006103516e+01 -1.4106401062011719e+02 6.1548198699951172e+01 -4.9620899200439453e+01 -1.3704499816894531e+02 6.1548198699951172e+01 -5.0108898162841797e+01 -1.3300000000000000e+02 6.1548198699951172e+01 -5.0271900177001953e+01 -1.2895500183105469e+02 6.1548198699951172e+01 -5.0108898162841797e+01 -1.2493599700927734e+02 6.1548198699951172e+01 -4.9620899200439453e+01 -1.2096899414062500e+02 6.1548198699951172e+01 -4.8811100006103516e+01 -1.1708000183105469e+02 6.1548198699951172e+01 -4.7684700012207031e+01 -1.1329499816894531e+02 6.1548198699951172e+01 -4.6249198913574219e+01 -1.0963700103759766e+02 6.1548198699951172e+01 -4.4513603210449219e+01 -1.0613100433349609e+02 6.1548198699951172e+01 -4.2489299774169922e+01 -1.0279999542236328e+02 6.1548198699951172e+01 -4.0189502716064453e+01 -9.9663505554199219e+01 6.1548198699951172e+01 -3.7629100799560547e+01 -9.6743797302246094e+01 6.1548198699951172e+01 -3.4824600219726562e+01 -9.4059196472167969e+01 6.1548198699951172e+01 -3.1794298171997070e+01 -9.1626998901367188e+01 6.1548198699951172e+01 -2.8557699203491211e+01 -8.9463195800781250e+01 6.1548198699951172e+01 -2.5135900497436523e+01 -8.7581794738769531e+01 6.1548198699951172e+01 -2.1551198959350586e+01 -8.5995002746582031e+01 6.1548198699951172e+01 -1.7826700210571289e+01 -8.4712898254394531e+01 6.1548198699951172e+01 -1.3986499786376953e+01 -8.3743995666503906e+01 6.1548198699951172e+01 -1.0055700302124023e+01 -8.3094703674316406e+01 6.1548198699951172e+01 -6.0595898628234863e+00 -8.2768798828125000e+01 6.1548198699951172e+01 -2.0242300033569336e+00 -8.3094703674316406e+01 6.1548198699951172e+01 6.0595898628234863e+00 -8.2768798828125000e+01 6.1548198699951172e+01 2.0242300033569336e+00 -8.3743995666503906e+01 6.1548198699951172e+01 1.0055700302124023e+01 -8.4712898254394531e+01 6.1548198699951172e+01 1.3986499786376953e+01 -8.7581794738769531e+01 6.1548198699951172e+01 2.1551198959350586e+01 -8.5995002746582031e+01 6.1548198699951172e+01 1.7826700210571289e+01 -8.9463195800781250e+01 6.1548198699951172e+01 2.5135900497436523e+01 -9.1626998901367188e+01 6.1548198699951172e+01 2.8557699203491211e+01 -9.6743797302246094e+01 6.1548198699951172e+01 3.4824600219726562e+01 -9.4059196472167969e+01 6.1548198699951172e+01 3.1794298171997070e+01 -9.9663505554199219e+01 6.1548198699951172e+01 3.7629100799560547e+01 -1.0279999542236328e+02 6.1548198699951172e+01 4.0189502716064453e+01 -1.0613100433349609e+02 6.1548198699951172e+01 4.2489299774169922e+01 -1.0963700103759766e+02 6.1548198699951172e+01 4.4513603210449219e+01 -1.1329499816894531e+02 6.1548198699951172e+01 4.6249198913574219e+01 -1.1708000183105469e+02 6.1548198699951172e+01 4.7684700012207031e+01 -1.2096899414062500e+02 6.1548198699951172e+01 4.8811100006103516e+01 -1.2493599700927734e+02 6.1548198699951172e+01 4.9620899200439453e+01 -1.2895500183105469e+02 6.1548198699951172e+01 5.0108898162841797e+01 -1.3300000000000000e+02 6.1548198699951172e+01 5.0271900177001953e+01 -1.3704499816894531e+02 6.1548198699951172e+01 5.0108898162841797e+01 -1.4106401062011719e+02 6.1548198699951172e+01 4.9620899200439453e+01 -1.2924400329589844e+02 7.0288002014160156e+01 4.5331501007080078e+01 -1.3300000000000000e+02 7.0288002014160156e+01 4.5486900329589844e+01 -1.3675599670410156e+02 7.0288002014160156e+01 4.5331501007080078e+01 -1.4048699951171875e+02 7.0288002014160156e+01 4.4866600036621094e+01 -1.4416598510742188e+02 7.0288002014160156e+01 4.4094997406005859e+01 -1.4777000427246094e+02 7.0288002014160156e+01 4.3022300720214844e+01 -1.5127200317382812e+02 7.0288002014160156e+01 4.1655700683593750e+01 -1.5464900207519531e+02 7.0288002014160156e+01 4.0004600524902344e+01 -1.5787899780273438e+02 7.0288002014160156e+01 3.8080101013183594e+01 -1.6093899536132812e+02 7.0288002014160156e+01 3.5895599365234375e+01 -1.6380700683593750e+02 7.0288002014160156e+01 3.3465797424316406e+01 -1.6646600341796875e+02 7.0288002014160156e+01 3.0807399749755859e+01 -1.6889601135253906e+02 7.0288002014160156e+01 2.7938699722290039e+01 -1.7107998657226562e+02 7.0288002014160156e+01 2.4878999710083008e+01 -1.7300500488281250e+02 7.0288002014160156e+01 2.1649400711059570e+01 -1.7465600585937500e+02 7.0288002014160156e+01 1.8271900177001953e+01 -1.7602198791503906e+02 7.0288002014160156e+01 1.4769499778747559e+01 -1.7709500122070312e+02 7.0288002014160156e+01 1.1166299819946289e+01 -1.7786698913574219e+02 7.0288002014160156e+01 7.4868798255920410e+00 -1.7833200073242188e+02 7.0288002014160156e+01 3.7562201023101807e+00 -1.7848699951171875e+02 7.0288002014160156e+01 0.0000000000000000e+00 -1.7833200073242188e+02 7.0288002014160156e+01 -3.7562201023101807e+00 -1.7786698913574219e+02 7.0288002014160156e+01 -7.4868798255920410e+00 -1.7709500122070312e+02 7.0288002014160156e+01 -1.1166299819946289e+01 -1.7602198791503906e+02 7.0288002014160156e+01 -1.4769499778747559e+01 -1.7465600585937500e+02 7.0288002014160156e+01 -1.8271900177001953e+01 -1.7300500488281250e+02 7.0288002014160156e+01 -2.1649400711059570e+01 -1.7107998657226562e+02 7.0288002014160156e+01 -2.4878999710083008e+01 -1.6889601135253906e+02 7.0288002014160156e+01 -2.7938699722290039e+01 -1.6646600341796875e+02 7.0288002014160156e+01 -3.0807399749755859e+01 -1.6380700683593750e+02 7.0288002014160156e+01 -3.3465797424316406e+01 -1.6093899536132812e+02 7.0288002014160156e+01 -3.5895599365234375e+01 -1.5787899780273438e+02 7.0288002014160156e+01 -3.8080101013183594e+01 -1.5464900207519531e+02 7.0288002014160156e+01 -4.0004600524902344e+01 -1.5127200317382812e+02 7.0288002014160156e+01 -4.1655700683593750e+01 -1.4777000427246094e+02 7.0288002014160156e+01 -4.3022300720214844e+01 -1.4416598510742188e+02 7.0288002014160156e+01 -4.4094997406005859e+01 -1.4048699951171875e+02 7.0288002014160156e+01 -4.4866600036621094e+01 -1.3675599670410156e+02 7.0288002014160156e+01 -4.5331501007080078e+01 -1.3300000000000000e+02 7.0288002014160156e+01 -4.5486900329589844e+01 -1.2924400329589844e+02 7.0288002014160156e+01 -4.5331501007080078e+01 -1.2551300048828125e+02 7.0288002014160156e+01 -4.4866600036621094e+01 -1.2183399963378906e+02 7.0288002014160156e+01 -4.4094997406005859e+01 -1.1823000335693359e+02 7.0288002014160156e+01 -4.3022300720214844e+01 -1.1472799682617188e+02 7.0288002014160156e+01 -4.1655700683593750e+01 -1.1135099792480469e+02 7.0288002014160156e+01 -4.0004600524902344e+01 -1.0812100219726562e+02 7.0288002014160156e+01 -3.8080101013183594e+01 -1.0506100463867188e+02 7.0288002014160156e+01 -3.5895599365234375e+01 -1.0219300079345703e+02 7.0288002014160156e+01 -3.3465797424316406e+01 -9.9534194946289062e+01 7.0288002014160156e+01 -3.0807399749755859e+01 -9.7104400634765625e+01 7.0288002014160156e+01 -2.7938699722290039e+01 -9.4919898986816406e+01 7.0288002014160156e+01 -2.4878999710083008e+01 -9.2995399475097656e+01 7.0288002014160156e+01 -2.1649400711059570e+01 -9.1344299316406250e+01 7.0288002014160156e+01 -1.8271900177001953e+01 -8.9977699279785156e+01 7.0288002014160156e+01 -1.4769499778747559e+01 -8.8904998779296875e+01 7.0288002014160156e+01 -1.1166299819946289e+01 -8.8133399963378906e+01 7.0288002014160156e+01 -7.4868798255920410e+00 -8.7668502807617188e+01 7.0288002014160156e+01 -3.7562201023101807e+00 -8.7513099670410156e+01 7.0288002014160156e+01 0.0000000000000000e+00 -8.7668502807617188e+01 7.0288002014160156e+01 3.7562201023101807e+00 -8.8133399963378906e+01 7.0288002014160156e+01 7.4868798255920410e+00 -8.8904998779296875e+01 7.0288002014160156e+01 1.1166299819946289e+01 -8.9977699279785156e+01 7.0288002014160156e+01 1.4769499778747559e+01 -9.1344299316406250e+01 7.0288002014160156e+01 1.8271900177001953e+01 -9.2995399475097656e+01 7.0288002014160156e+01 2.1649400711059570e+01 -9.4919898986816406e+01 7.0288002014160156e+01 2.4878999710083008e+01 -9.7104400634765625e+01 7.0288002014160156e+01 2.7938699722290039e+01 -9.9534194946289062e+01 7.0288002014160156e+01 3.0807399749755859e+01 -1.0219300079345703e+02 7.0288002014160156e+01 3.3465797424316406e+01 -1.0506100463867188e+02 7.0288002014160156e+01 3.5895599365234375e+01 -1.0812100219726562e+02 7.0288002014160156e+01 3.8080101013183594e+01 -1.1135099792480469e+02 7.0288002014160156e+01 4.0004600524902344e+01 -1.1472799682617188e+02 7.0288002014160156e+01 4.1655700683593750e+01 -1.1823000335693359e+02 7.0288002014160156e+01 4.3022300720214844e+01 -1.2183399963378906e+02 7.0288002014160156e+01 4.4094997406005859e+01 -1.2551300048828125e+02 7.0288002014160156e+01 4.4866600036621094e+01 -1.2916499328613281e+02 6.9682098388671875e+01 4.6279399871826172e+01 -1.3300000000000000e+02 6.9682098388671875e+01 4.6437999725341797e+01 -1.3683499145507812e+02 6.9682098388671875e+01 4.6279399871826172e+01 -1.4064300537109375e+02 6.9682098388671875e+01 4.5804702758789062e+01 -1.4439999389648438e+02 6.9682098388671875e+01 4.5017101287841797e+01 -1.4807798767089844e+02 6.9682098388671875e+01 4.3921897888183594e+01 -1.5165400695800781e+02 6.9682098388671875e+01 4.2526699066162109e+01 -1.5510200500488281e+02 6.9682098388671875e+01 4.0840999603271484e+01 -1.5839900207519531e+02 6.9682098388671875e+01 3.8876399993896484e+01 -1.6152299499511719e+02 6.9682098388671875e+01 3.6646102905273438e+01 -1.6445199584960938e+02 6.9682098388671875e+01 3.4165599822998047e+01 -1.6716600036621094e+02 6.9682098388671875e+01 3.1451601028442383e+01 -1.6964599609375000e+02 6.9682098388671875e+01 2.8522800445556641e+01 -1.7187599182128906e+02 6.9682098388671875e+01 2.5399200439453125e+01 -1.7384100341796875e+02 6.9682098388671875e+01 2.2102100372314453e+01 -1.7552700805664062e+02 6.9682098388671875e+01 1.8653900146484375e+01 -1.7692199707031250e+02 6.9682098388671875e+01 1.5078400611877441e+01 -1.7801699829101562e+02 6.9682098388671875e+01 1.1399899482727051e+01 -1.7880499267578125e+02 6.9682098388671875e+01 7.6434001922607422e+00 -1.7927900695800781e+02 6.9682098388671875e+01 3.8347799777984619e+00 -1.7943798828125000e+02 6.9682098388671875e+01 0.0000000000000000e+00 -1.7927900695800781e+02 6.9682098388671875e+01 -3.8347799777984619e+00 -1.7880499267578125e+02 6.9682098388671875e+01 -7.6434001922607422e+00 -1.7801699829101562e+02 6.9682098388671875e+01 -1.1399899482727051e+01 -1.7692199707031250e+02 6.9682098388671875e+01 -1.5078400611877441e+01 -1.7552700805664062e+02 6.9682098388671875e+01 -1.8653900146484375e+01 -1.7384100341796875e+02 6.9682098388671875e+01 -2.2102100372314453e+01 -1.7187599182128906e+02 6.9682098388671875e+01 -2.5399200439453125e+01 -1.6964599609375000e+02 6.9682098388671875e+01 -2.8522800445556641e+01 -1.6716600036621094e+02 6.9682098388671875e+01 -3.1451601028442383e+01 -1.6445199584960938e+02 6.9682098388671875e+01 -3.4165599822998047e+01 -1.6152299499511719e+02 6.9682098388671875e+01 -3.6646102905273438e+01 -1.5839900207519531e+02 6.9682098388671875e+01 -3.8876399993896484e+01 -1.5510200500488281e+02 6.9682098388671875e+01 -4.0840999603271484e+01 -1.5165400695800781e+02 6.9682098388671875e+01 -4.2526699066162109e+01 -1.4807798767089844e+02 6.9682098388671875e+01 -4.3921897888183594e+01 -1.4439999389648438e+02 6.9682098388671875e+01 -4.5017101287841797e+01 -1.4064300537109375e+02 6.9682098388671875e+01 -4.5804702758789062e+01 -1.3683499145507812e+02 6.9682098388671875e+01 -4.6279399871826172e+01 -1.3300000000000000e+02 6.9682098388671875e+01 -4.6437999725341797e+01 -1.2916499328613281e+02 6.9682098388671875e+01 -4.6279399871826172e+01 -1.2535700225830078e+02 6.9682098388671875e+01 -4.5804702758789062e+01 -1.2159999847412109e+02 6.9682098388671875e+01 -4.5017101287841797e+01 -1.1792199707031250e+02 6.9682098388671875e+01 -4.3921897888183594e+01 -1.1434600067138672e+02 6.9682098388671875e+01 -4.2526699066162109e+01 -1.1089800262451172e+02 6.9682098388671875e+01 -4.0840999603271484e+01 -1.0760100555419922e+02 6.9682098388671875e+01 -3.8876399993896484e+01 -1.0447700500488281e+02 6.9682098388671875e+01 -3.6646102905273438e+01 -1.0154800415039062e+02 6.9682098388671875e+01 -3.4165599822998047e+01 -9.8834403991699219e+01 6.9682098388671875e+01 -3.1451601028442383e+01 -9.6353904724121094e+01 6.9682098388671875e+01 -2.8522800445556641e+01 -9.4123603820800781e+01 6.9682098388671875e+01 -2.5399200439453125e+01 -9.2159004211425781e+01 6.9682098388671875e+01 -2.2102100372314453e+01 -9.0473304748535156e+01 6.9682098388671875e+01 -1.8653900146484375e+01 -8.9078102111816406e+01 6.9682098388671875e+01 -1.5078400611877441e+01 -8.7982902526855469e+01 6.9682098388671875e+01 -1.1399899482727051e+01 -8.7195297241210938e+01 6.9682098388671875e+01 -7.6434001922607422e+00 -8.6720603942871094e+01 6.9682098388671875e+01 -3.8347799777984619e+00 -8.6561996459960938e+01 6.9682098388671875e+01 0.0000000000000000e+00 -8.6720603942871094e+01 6.9682098388671875e+01 3.8347799777984619e+00 -8.7195297241210938e+01 6.9682098388671875e+01 7.6434001922607422e+00 -8.7982902526855469e+01 6.9682098388671875e+01 1.1399899482727051e+01 -8.9078102111816406e+01 6.9682098388671875e+01 1.5078400611877441e+01 -9.0473304748535156e+01 6.9682098388671875e+01 1.8653900146484375e+01 -9.2159004211425781e+01 6.9682098388671875e+01 2.2102100372314453e+01 -9.4123603820800781e+01 6.9682098388671875e+01 2.5399200439453125e+01 -9.6353904724121094e+01 6.9682098388671875e+01 2.8522800445556641e+01 -9.8834403991699219e+01 6.9682098388671875e+01 3.1451601028442383e+01 -1.0154800415039062e+02 6.9682098388671875e+01 3.4165599822998047e+01 -1.0447700500488281e+02 6.9682098388671875e+01 3.6646102905273438e+01 -1.0760100555419922e+02 6.9682098388671875e+01 3.8876399993896484e+01 -1.1089800262451172e+02 6.9682098388671875e+01 4.0840999603271484e+01 -1.1434600067138672e+02 6.9682098388671875e+01 4.2526699066162109e+01 -1.1792199707031250e+02 6.9682098388671875e+01 4.3921897888183594e+01 -1.2159999847412109e+02 6.9682098388671875e+01 4.5017101287841797e+01 -1.2535700225830078e+02 6.9682098388671875e+01 4.5804702758789062e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 10494 -> 44 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 -4.3039798736572266e+01) (float-vector -2.6292599737644196e+01 -4.4118601828813553e+01 -2.6545299217104912e+01) (float-vector 3.0500000342726707e+01 -4.4556599110364914e+01 -2.6808800175786018e+01) (float-vector 3.0500000342726707e+01 -2.9181700199842453e+01 -4.3039798736572266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -5.0784200429916382e+01 -1.1178400367498398e+01) (float-vector -2.6292599737644196e+01 -5.1187001168727875e+01 5.5669001303613186e+00) (float-vector 3.0500000342726707e+01 -5.2000001072883606e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6889600455760956e+02 7.0288002490997314e+01 2.7938699349761009e+01) (float-vector -1.5165400505065918e+02 6.9682098925113678e+01 4.2526699602603912e+01) (float-vector -1.6666400432586670e+02 5.7999998331069946e+01 3.9632398635149002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -8.9977696537971497e+01 7.0288002490997314e+01 1.4769500121474266e+01) (float-vector -1.0506100207567215e+02 7.0288002490997314e+01 -3.5895600914955139e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 3.3663999289274216e+01 -3.9632398635149002e+01) (float-vector -1.2535700201988220e+02 6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector 3.0500000342726707e+01 2.4357199668884277e+01 -4.5942600816488266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -1.3911399990320206e+01 -5.0104599446058273e+01) (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 -4.3039798736572266e+01) (float-vector 3.0500000342726707e+01 -2.9181700199842453e+01 -4.3039798736572266e+01) (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 -5.1619399338960648e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 5.1619399338960648e+01) (float-vector -1.3020099699497223e+02 5.7999998331069946e+01 5.1619399338960648e+01) (float-vector 3.0500000342726707e+01 2.4357199668884277e+01 4.5942600816488266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5165400505065918e+02 6.9682098925113678e+01 4.2526699602603912e+01) (float-vector -1.4691099524497986e+02 5.7999998331069946e+01 5.0104599446058273e+01) (float-vector -1.6666400432586670e+02 5.7999998331069946e+01 3.9632398635149002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4691099524497986e+02 5.7999998331069946e+01 5.0104599446058273e+01) (float-vector -1.5165400505065918e+02 6.9682098925113678e+01 4.2526699602603912e+01) (float-vector -1.3300000131130219e+02 7.0499897003173828e+01 4.4379301369190216e+01) (float-vector -1.3020099699497223e+02 5.7999998331069946e+01 5.1619399338960648e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8019400537014008e+02 5.7999998331069946e+01 2.1834200248122215e+01) (float-vector -1.6889600455760956e+02 7.0288002490997314e+01 2.7938699349761009e+01) (float-vector -1.6666400432586670e+02 5.7999998331069946e+01 3.9632398635149002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8019400537014008e+02 5.7999998331069946e+01 2.1834200248122215e+01) (float-vector -1.7880499362945557e+02 6.9682098925113678e+01 7.6434002257883549e+00) (float-vector -1.6889600455760956e+02 7.0288002490997314e+01 2.7938699349761009e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8019400537014008e+02 5.7999998331069946e+01 2.1834200248122215e+01) (float-vector -1.6666400432586670e+02 5.7999998331069946e+01 3.9632398635149002e+01) (float-vector -1.6190099716186523e+02 1.4999499544501305e+00 4.2626000940799713e+01) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 2.6808800175786018e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 2.4357199668884277e+01 4.5942600816488266e+01) (float-vector -1.3020099699497223e+02 5.7999998331069946e+01 5.1619399338960648e+01) (float-vector -1.3300000131130219e+02 7.0499897003173828e+01 4.4379301369190216e+01) (float-vector -1.0812100023031235e+02 7.0288002490997314e+01 3.8080099970102310e+01) (float-vector 3.0500000342726707e+01 4.4295400381088257e+01 2.6651600375771523e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6716599464416504e+02 6.9682098925113678e+01 -3.1451601535081863e+01) (float-vector -1.7439700663089752e+02 5.7999998331069946e+01 -3.1468998640775681e+01) (float-vector -1.5735700726509094e+02 5.7999998331069946e+01 -4.5942600816488266e+01) (float-vector -1.4777000248432159e+02 7.0288002490997314e+01 -4.3022301048040390e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7880499362945557e+02 6.9682098925113678e+01 7.6434002257883549e+00) (float-vector -1.7945599555969238e+02 6.8767800927162170e+01 -7.7520599588751793e+00) (float-vector -1.6716599464416504e+02 6.9682098925113678e+01 -3.1451601535081863e+01) (float-vector -1.4777000248432159e+02 7.0288002490997314e+01 -4.3022301048040390e+01) (float-vector -1.2535700201988220e+02 6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -1.0506100207567215e+02 7.0288002490997314e+01 -3.5895600914955139e+01) (float-vector -8.9977696537971497e+01 7.0288002490997314e+01 1.4769500121474266e+01) (float-vector -1.0812100023031235e+02 7.0288002490997314e+01 3.8080099970102310e+01) (float-vector -1.3300000131130219e+02 7.0499897003173828e+01 4.4379301369190216e+01) (float-vector -1.5165400505065918e+02 6.9682098925113678e+01 4.2526699602603912e+01) (float-vector -1.6889600455760956e+02 7.0288002490997314e+01 2.7938699349761009e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6292599737644196e+01 -4.4118601828813553e+01 -2.6545299217104912e+01) (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 -4.8306800425052643e+01) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 -2.6808800175786018e+01) (float-vector -2.2410299628973007e+01 -5.0784200429916382e+01 -1.1178400367498398e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 -2.6808800175786018e+01) (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 -4.8306800425052643e+01) (float-vector -1.5735700726509094e+02 5.7999998331069946e+01 -4.5942600816488266e+01) (float-vector -1.7439700663089752e+02 5.7999998331069946e+01 -3.1468998640775681e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8419800698757172e+02 1.4999499544501305e+00 -5.5680898949503899e+00) (float-vector -2.6292599737644196e+01 -5.1187001168727875e+01 5.5669001303613186e+00) (float-vector -2.2410299628973007e+01 -5.0784200429916382e+01 -1.1178400367498398e+01) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 -2.6808800175786018e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 4.7193899750709534e+01 -2.1834200248122215e+01) (float-vector 3.0500000342726707e+01 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -1.0506100207567215e+02 7.0288002490997314e+01 -3.5895600914955139e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0506100207567215e+02 7.0288002490997314e+01 -3.5895600914955139e+01) (float-vector -1.2535700201988220e+02 6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector 3.0500000342726707e+01 3.3663999289274216e+01 -3.9632398635149002e+01) (float-vector 3.0500000342726707e+01 4.7193899750709534e+01 -2.1834200248122215e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3581499457359314e+02 5.7999998331069946e+01 -5.1923699676990509e+01) (float-vector -1.4777000248432159e+02 7.0288002490997314e+01 -4.3022301048040390e+01) (float-vector -1.5735700726509094e+02 5.7999998331069946e+01 -4.5942600816488266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3581499457359314e+02 5.7999998331069946e+01 -5.1923699676990509e+01) (float-vector -1.2535700201988220e+02 6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -1.4777000248432159e+02 7.0288002490997314e+01 -4.3022301048040390e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.2535700201988220e+02 6.9682098925113678e+01 -4.5804701745510101e+01) (float-vector -1.3581499457359314e+02 5.7999998331069946e+01 -5.1923699676990509e+01) (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 -5.1619399338960648e+01) (float-vector 3.0500000342726707e+01 2.4357199668884277e+01 -4.5942600816488266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 5.1619399338960648e+01) (float-vector -2.2410299628973007e+01 -1.3911399990320206e+01 5.0104599446058273e+01) (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 5.1923699676990509e+01) (float-vector -1.4691099524497986e+02 5.7999998331069946e+01 5.0104599446058273e+01) (float-vector -1.3020099699497223e+02 5.7999998331069946e+01 5.1619399338960648e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6292599737644196e+01 -5.1187001168727875e+01 5.5669001303613186e+00) (float-vector -2.6292599737644196e+01 -4.0989898145198822e+01 3.1159700825810432e+01) (float-vector 3.0500000342726707e+01 -4.4556599110364914e+01 2.6808800175786018e+01) (float-vector 3.0500000342726707e+01 -5.2000001072883606e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 4.8306800425052643e+01) (float-vector -1.4691099524497986e+02 5.7999998331069946e+01 5.0104599446058273e+01) (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 5.1923699676990509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4691099524497986e+02 5.7999998331069946e+01 5.0104599446058273e+01) (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 4.8306800425052643e+01) (float-vector -1.6190099716186523e+02 1.4999499544501305e+00 4.2626000940799713e+01) (float-vector -1.6666400432586670e+02 5.7999998331069946e+01 3.9632398635149002e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 4.8306800425052643e+01) (float-vector -2.6292599737644196e+01 -4.0989898145198822e+01 3.1159700825810432e+01) (float-vector -2.6292599737644196e+01 -5.1187001168727875e+01 5.5669001303613186e+00) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 2.6808800175786018e+01) (float-vector -1.6190099716186523e+02 1.4999499544501305e+00 4.2626000940799713e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7945599555969238e+02 6.8767800927162170e+01 -7.7520599588751793e+00) (float-vector -1.7439700663089752e+02 5.7999998331069946e+01 -3.1468998640775681e+01) (float-vector -1.6716599464416504e+02 6.9682098925113678e+01 -3.1451601535081863e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -5.0784200429916382e+01 -1.1178400367498398e+01) (float-vector 3.0500000342726707e+01 -5.2000001072883606e+01 0.0000000000000000e+00) (float-vector 3.0500000342726707e+01 -4.4556599110364914e+01 -2.6808800175786018e+01) (float-vector -2.6292599737644196e+01 -4.4118601828813553e+01 -2.6545299217104912e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -1.3911399990320206e+01 -5.0104599446058273e+01) (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 -5.1923699676990509e+01) (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 -4.3039798736572266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 -5.1923699676990509e+01) (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 -4.8306800425052643e+01) (float-vector -2.6292599737644196e+01 -4.4118601828813553e+01 -2.6545299217104912e+01) (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 -4.3039798736572266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 -5.1923699676990509e+01) (float-vector -1.3581499457359314e+02 5.7999998331069946e+01 -5.1923699676990509e+01) (float-vector -1.5735700726509094e+02 5.7999998331069946e+01 -4.5942600816488266e+01) (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 -4.8306800425052643e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 -5.1923699676990509e+01) (float-vector -2.2410299628973007e+01 -1.3911399990320206e+01 -5.0104599446058273e+01) (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 -5.1619399338960648e+01) (float-vector -1.3581499457359314e+02 5.7999998331069946e+01 -5.1923699676990509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -1.3911399990320206e+01 5.0104599446058273e+01) (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 4.3039798736572266e+01) (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 5.1923699676990509e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 4.3039798736572266e+01) (float-vector 3.0500000342726707e+01 -2.9181700199842453e+01 4.3039798736572266e+01) (float-vector 3.0500000342726707e+01 -4.4556599110364914e+01 2.6808800175786018e+01) (float-vector -2.6292599737644196e+01 -4.0989898145198822e+01 3.1159700825810432e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 4.3039798736572266e+01) (float-vector -2.2410299628973007e+01 -1.3911399990320206e+01 5.0104599446058273e+01) (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 5.1619399338960648e+01) (float-vector 3.0500000342726707e+01 -2.9181700199842453e+01 4.3039798736572266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3018499314785004e+02 1.9999700598418713e+00 5.1923699676990509e+01) (float-vector -2.2410299628973007e+01 -2.9181700199842453e+01 4.3039798736572266e+01) (float-vector -2.6292599737644196e+01 -4.0989898145198822e+01 3.1159700825810432e+01) (float-vector -1.5224699676036835e+02 1.9999700598418713e+00 4.8306800425052643e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8469500541687012e+02 1.9999700598418713e+00 5.6221499107778072e+00) (float-vector -1.8019400537014008e+02 5.7999998331069946e+01 2.1834200248122215e+01) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 2.6808800175786018e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8419800698757172e+02 1.4999499544501305e+00 -5.5680898949503899e+00) (float-vector -1.8469500541687012e+02 1.9999700598418713e+00 5.6221499107778072e+00) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 2.6808800175786018e+01) (float-vector -2.6292599737644196e+01 -5.1187001168727875e+01 5.5669001303613186e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8019400537014008e+02 5.7999998331069946e+01 2.1834200248122215e+01) (float-vector -1.8469500541687012e+02 1.9999700598418713e+00 5.6221499107778072e+00) (float-vector -1.8419800698757172e+02 1.4999499544501305e+00 -5.5680898949503899e+00) (float-vector -1.7755700647830963e+02 1.9999700598418713e+00 -2.6808800175786018e+01) (float-vector -1.7439700663089752e+02 5.7999998331069946e+01 -3.1468998640775681e+01) (float-vector -1.7945599555969238e+02 6.8767800927162170e+01 -7.7520599588751793e+00) (float-vector -1.7880499362945557e+02 6.9682098925113678e+01 7.6434002257883549e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector 3.2999999821186066e+01 4.7283999621868134e+01 1.0792200453579426e+01) (float-vector 3.0500000342726707e+01 4.4295400381088257e+01 2.6651600375771523e+01) (float-vector -1.0812100023031235e+02 7.0288002490997314e+01 3.8080099970102310e+01) (float-vector -8.9977696537971497e+01 7.0288002490997314e+01 1.4769500121474266e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 2.4357199668884277e+01 4.5942600816488266e+01) (float-vector 3.0500000342726707e+01 4.4295400381088257e+01 2.6651600375771523e+01) (float-vector 3.2999999821186066e+01 4.7283999621868134e+01 1.0792200453579426e+01) (float-vector 3.0500000342726707e+01 -5.2000001072883606e+01 0.0000000000000000e+00) (float-vector 3.0500000342726707e+01 -4.4556599110364914e+01 2.6808800175786018e+01) (float-vector 3.0500000342726707e+01 -2.9181700199842453e+01 4.3039798736572266e+01) (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 5.1619399338960648e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0500000342726707e+01 -4.4556599110364914e+01 -2.6808800175786018e+01) (float-vector 3.0500000342726707e+01 -5.2000001072883606e+01 0.0000000000000000e+00) (float-vector 3.2999999821186066e+01 4.7283999621868134e+01 1.0792200453579426e+01) (float-vector 3.0500000342726707e+01 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector 3.0500000342726707e+01 4.7193899750709534e+01 -2.1834200248122215e+01) (float-vector 3.0500000342726707e+01 3.3663999289274216e+01 -3.9632398635149002e+01) (float-vector 3.0500000342726707e+01 2.4357199668884277e+01 -4.5942600816488266e+01) (float-vector 3.0500000342726707e+01 -2.7986799832433462e+00 -5.1619399338960648e+01) (float-vector 3.0500000342726707e+01 -2.9181700199842453e+01 -4.3039798736572266e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_elbow_flex_link_1LO4Qr.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_forearm_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.9700000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 5 4 0 5 0 6 6 0 2 4 78 0 0 78 75 0 75 1 3 4 5 3 81 4 4 81 82 4 82 78 78 79 75 78 82 83 78 83 79 83 82 2097 2097 82 81 2097 81 2095 2095 81 3 2095 3 5 2093 2094 2095 2095 2094 2096 2095 2096 2097 5 2093 2095 2097 2096 2098 2097 2098 2099 2099 83 2097 2099 79 83 2099 2098 2100 2099 2100 2101 2101 80 2099 80 79 2099 75 79 80 75 80 76 2101 76 80 75 76 72 1 75 72 72 76 77 77 76 2101 72 73 69 72 77 73 1 72 69 7 11 1 1 11 12 1 12 2 7 1 69 7 8 9 9 10 7 7 10 11 7 69 8 11 2089 2091 2091 12 11 11 10 2089 2091 2 12 2093 6 2 2093 2 2091 2089 2090 2091 2091 2090 2092 2091 2092 2093 2093 2092 2094 5 6 2093 2092 2178 2094 2178 2179 2094 2094 2179 2180 2094 2180 2096 2092 2177 2178 2177 2267 2178 2178 2267 2268 2178 2268 2179 2179 2268 2269 2179 2269 2180 2096 2180 2181 2180 2269 2270 2180 2270 2181 2098 2096 2124 2096 2181 2124 2181 2270 2271 2181 2271 2124 2269 2212 2270 2270 2212 2213 2270 2213 2271 2268 2211 2269 2269 2211 2212 2211 140 2212 2212 140 138 2212 138 2213 2213 138 137 2213 137 2214 2271 2213 2214 2271 2214 2272 2124 2271 2272 2214 137 92 2214 92 2215 2272 2214 2215 92 137 90 90 137 138 90 138 139 139 138 140 90 91 92 1334 91 90 1334 90 1336 1336 90 139 91 109 92 2215 92 109 106 108 91 91 108 109 1328 106 91 1328 91 1334 2215 109 2216 2216 109 108 106 107 108 2216 108 2217 2217 108 107 2273 2215 2216 2273 2216 2274 2274 2216 2217 2217 107 2218 2274 2217 2275 2275 2217 2218 105 107 106 2218 107 105 2218 105 2219 2275 2218 2276 2276 2218 2219 2127 2274 2275 2127 2275 2128 2128 2275 2276 2126 2273 2274 2126 2274 2127 2126 2127 2100 2100 2127 2128 2100 2128 2102 2102 2128 2129 2128 2276 2129 2276 2219 2277 2129 2276 2277 2102 2129 2104 2104 2129 2130 2129 2277 2130 2101 2100 2102 2101 2102 2103 2103 2102 2104 2098 2126 2100 2124 2125 2098 2098 2125 2126 2124 2272 2125 2125 2272 2273 2125 2273 2126 2272 2215 2273 2103 2104 2105 2105 2104 2106 2130 2131 2104 2104 2131 2132 2104 2132 2106 2105 2106 2107 2107 2106 2108 2106 2132 2133 2106 2133 2108 2131 2279 2132 2132 2279 2280 2132 2280 2133 2130 2278 2131 2131 2278 2279 2278 2221 2279 2279 2221 2222 2279 2222 2280 2280 2222 2223 2280 2223 2281 2133 2280 2281 2221 115 2222 2222 115 114 2222 114 2223 2220 86 2221 2221 86 115 2278 2220 2221 85 114 115 85 115 86 101 113 114 101 114 85 2223 114 113 84 85 86 1319 101 85 1319 85 1324 1324 85 84 86 104 84 2220 104 86 84 104 105 84 105 106 1324 84 1330 1330 84 106 2219 105 104 2219 104 2220 2277 2219 2220 2277 2220 2278 2130 2277 2278 1330 106 1328 1326 1327 1328 1328 1327 1329 1328 1329 1330 1326 1328 1333 1333 1328 1334 1326 1333 1383 1418 1327 1326 1326 1383 1418 1329 1327 1418 1330 1329 1331 1331 1329 1384 1329 1418 1384 1384 1418 1467 1418 1383 1470 1418 1470 1467 1331 1384 1417 1417 1384 1466 1384 1467 1466 1330 1331 1324 1324 1331 1332 1417 1332 1331 1325 1332 1417 1325 1417 1416 1416 1417 1465 1417 1466 1465 1465 1466 1371 1466 1467 1468 1466 1468 1371 1416 1465 1462 1462 1465 1464 1465 1371 1464 1029 1027 1371 1464 1371 1027 1371 1468 1031 1371 1031 1029 1467 1469 1468 1468 1469 1033 1468 1033 1031 1030 1029 1031 1030 1031 1032 1032 1031 1033 1028 1027 1029 1028 1029 1030 1028 1030 1055 1055 1030 1032 1032 1033 1022 1055 1032 1056 1022 1056 1032 1022 1033 1034 1469 1034 1033 1022 1023 1024 1022 1034 1023 1024 1056 1022 1024 1057 1056 1057 1042 1056 1056 1042 1062 1056 1062 1055 1024 1023 948 1024 948 1025 1025 1057 1024 1025 912 1057 912 921 1057 1057 921 1042 1025 948 522 1025 522 747 747 912 1025 912 747 748 922 921 912 912 748 922 920 921 922 921 920 1042 885 920 883 883 920 922 1042 920 885 883 884 885 884 889 885 885 889 1042 880 882 883 883 882 884 883 922 880 888 887 884 884 887 889 888 884 882 1042 889 887 1042 887 1062 886 887 888 1062 887 886 1055 1062 1063 1062 886 1063 908 886 888 1063 886 908 1054 1055 1063 1054 1063 1036 1036 1063 907 1063 908 907 1028 1055 1054 1053 1019 1054 1054 1019 1021 1054 1021 1028 1054 1036 1053 1035 1036 909 1053 1036 1035 1036 907 909 888 907 908 909 907 888 905 909 888 909 905 1035 1053 1035 1052 1052 1035 1060 1035 905 904 1035 904 1060 888 904 905 906 904 888 1060 904 906 1052 1060 1050 1050 1060 1061 1060 906 1061 902 906 888 1061 906 902 1051 1050 1061 1051 1061 1038 1038 1061 901 1061 902 901 888 901 902 903 901 888 1038 901 903 1037 1038 903 1051 1038 1049 1049 1038 1037 899 903 888 903 899 1037 1049 1037 1048 1048 1037 1058 1037 899 898 1037 898 1058 888 898 899 900 898 888 1058 898 900 1048 1058 1047 1047 1058 1059 1058 900 1059 896 900 888 1059 900 896 1046 1047 1059 1046 1059 1065 1065 1059 895 1059 896 895 888 895 896 897 895 888 1065 895 897 1045 1046 1065 1045 1065 1064 1064 1065 897 891 897 888 1064 897 891 1064 891 890 1041 1045 1064 1041 1064 1044 1044 1064 890 888 890 891 894 893 890 894 890 888 1044 890 893 1041 1044 1043 1043 1044 893 892 893 894 1043 893 892 1203 894 888 1203 892 894 1203 1596 892 1043 892 1689 1689 892 1596 1039 1041 1043 1689 1039 1043 1039 1040 1041 1039 1689 1040 1040 974 1041 1040 1689 1665 1040 1665 974 974 971 975 1041 974 975 971 974 1664 1664 974 1665 1041 975 976 976 1045 1041 975 971 973 975 973 976 976 973 977 976 977 978 976 978 1045 1045 978 980 980 1046 1045 978 977 979 978 979 980 979 977 1437 1437 977 973 979 981 980 1437 1440 979 979 1440 981 980 981 982 980 982 983 980 983 1046 1046 983 985 985 1047 1046 983 982 984 983 984 985 1443 984 982 1443 982 981 1440 1443 981 1441 1442 1443 1443 1442 1444 1440 1441 1443 1444 984 1443 985 984 986 1444 986 984 985 986 987 985 987 1047 1047 987 989 1047 989 1048 987 986 988 987 988 989 988 986 1444 1442 1446 1444 1444 1446 1447 1444 1447 988 988 990 989 988 1447 990 989 990 991 989 991 992 989 992 1048 1048 992 994 1048 994 1049 992 991 993 992 993 994 991 990 1423 1423 993 991 1423 990 1447 1423 1447 1378 1378 1447 1446 1423 1378 1424 1424 1455 1423 1423 1455 993 994 993 995 993 996 995 1455 996 993 994 995 1049 1049 995 998 1049 998 1051 995 996 997 995 997 998 1455 997 996 1424 1456 1455 1456 1458 1455 1455 1458 997 998 997 999 1458 999 997 998 999 1000 1051 998 1000 1051 1000 1002 1002 1050 1051 1000 999 1001 1000 1001 1002 1458 1449 999 1449 1001 999 1456 1457 1458 1457 1449 1458 1448 1449 1450 1457 1450 1449 1448 1003 1449 1449 1003 1001 1001 1003 1002 1002 1003 1004 1448 1004 1003 1451 1006 1448 1451 1448 1452 1452 1448 1450 1006 1004 1448 1452 1450 1386 1414 1386 1450 1414 1450 1457 1375 1451 1452 1375 1452 1373 1373 1452 1386 1303 1315 1386 1303 1386 1414 1373 1386 1314 1314 1386 1315 1373 1374 1375 1314 1312 1373 1373 1312 1374 1313 1312 1314 1313 1314 1302 1302 1314 1315 1302 1315 1303 1302 1303 1304 1414 1304 1303 1302 1304 1305 1305 129 1302 1302 129 128 1302 128 1313 1311 1312 1313 1313 128 147 1313 147 1311 128 129 130 130 145 128 128 145 146 128 146 147 146 148 147 147 148 149 147 149 102 1311 147 102 2228 148 146 2228 146 2229 2229 146 145 2229 145 2230 2230 145 130 2286 2228 2229 2286 2229 2287 2287 2229 2230 2227 148 2228 2285 2227 2228 2285 2228 2286 2227 149 148 2226 149 2227 2284 2226 2227 2284 2227 2285 2137 2284 2285 2137 2285 2138 2138 2285 2286 2138 2286 2139 2139 2286 2287 2112 2137 2138 2138 2139 2112 2110 2136 2137 2110 2137 2112 2136 2284 2137 2283 2226 2284 2136 2283 2284 2108 2135 2136 2108 2136 2110 2135 2283 2136 2109 2108 2110 2109 2110 2111 2111 2110 2112 2107 2108 2109 2108 2133 2134 2134 2135 2108 2134 2282 2135 2135 2282 2283 2133 2281 2134 2134 2281 2282 2281 2224 2282 2282 2224 2225 2282 2225 2283 2281 2223 2224 2223 113 2224 2224 113 103 2224 103 2225 2225 103 150 2225 150 2226 2283 2225 2226 101 102 103 103 113 101 102 150 103 102 149 150 2226 150 149 1311 102 1317 1317 102 101 1317 101 1319 1316 1311 1317 1316 1317 1318 1319 1321 1317 1317 1321 1322 1317 1322 1318 1319 1320 1321 1320 1319 1323 1323 1319 1324 1322 1321 1415 1415 1321 1320 1318 1322 1385 1322 1415 1385 1318 1385 1316 1316 1385 1427 1427 1385 1460 1385 1415 1461 1385 1461 1460 1320 1416 1415 1415 1416 1462 1415 1462 1461 1320 1323 1416 1416 1323 1325 1323 1324 1325 1324 1332 1325 1460 1461 1372 1461 1462 1463 1461 1463 1372 1462 1464 1463 1372 1463 1018 1463 1464 1020 1463 1020 1018 1464 1026 1020 1464 1027 1026 1019 1018 1020 1019 1020 1021 1020 1026 1021 1017 1016 1018 1017 1018 1019 1372 1018 1016 1053 1017 1019 1014 1016 1017 1014 1017 1053 1014 1015 1016 1016 1015 1372 1012 1013 1014 1013 1015 1014 1052 1012 1014 1052 1014 1053 1459 1372 1015 1459 1015 1013 1460 1372 1459 1459 1013 1011 1426 1460 1459 1426 1459 1425 1425 1459 1011 1012 1011 1013 1010 1011 1012 1010 1012 1052 1050 1010 1052 1008 1009 1010 1010 1009 1011 1050 1008 1010 1425 1011 1009 1008 1007 1009 1009 1007 1425 1425 1375 1426 1425 1007 1451 1425 1451 1375 1005 1006 1007 1005 1007 1008 1007 1006 1451 1005 1008 1050 1002 1005 1050 1002 1004 1005 1004 1006 1005 1426 1375 1374 1426 1374 1427 1427 1460 1426 1374 1312 1310 1374 1310 1309 1427 1374 1309 1427 1309 1316 1309 1310 1311 1309 1311 1316 1311 1310 1312 1021 1026 1027 1021 1027 1028 2111 65 2109 65 64 2109 2109 64 68 2109 68 2107 60 64 65 60 65 61 2111 61 65 63 64 60 63 68 64 63 67 68 68 67 2107 2107 67 71 2107 71 2105 66 67 63 66 71 67 60 8 63 8 66 63 60 61 57 60 57 8 57 61 62 62 61 2111 57 58 54 57 62 58 57 54 8 2113 58 62 2113 62 2111 2111 2112 2113 2113 2112 2114 2113 2114 2115 2115 59 2113 59 58 2113 54 58 59 54 55 51 54 59 55 8 54 51 2115 55 59 51 55 56 56 55 2115 2115 2114 2116 2115 2116 2117 2117 56 2115 51 56 52 2117 52 56 2117 2116 2118 2117 2118 2119 2119 53 2117 53 52 2117 51 52 48 48 52 53 48 53 49 2119 49 53 2119 2118 2120 2119 2120 2121 2121 50 2119 50 49 2119 48 49 45 45 49 50 26 51 48 26 48 45 25 26 27 33 34 26 26 34 35 26 35 27 25 51 26 45 33 26 27 28 25 28 27 2075 2075 27 35 2075 35 2073 35 34 2073 33 32 34 2073 34 32 31 32 33 45 31 33 31 38 32 2073 32 2071 32 38 2071 2071 2072 2073 2073 2072 2074 2073 2074 2075 2069 2070 2071 2071 2070 2072 2071 38 37 2071 37 2069 31 37 38 36 37 31 36 41 37 37 41 2069 39 40 36 36 40 41 39 36 42 42 36 31 2069 41 40 39 44 40 2069 40 2067 2067 40 44 42 43 39 39 43 44 2067 44 2123 2123 44 43 2065 2066 2067 2067 2066 2068 2067 2068 2069 2123 2065 2067 2065 2151 2066 2066 2151 2152 2066 2152 2068 2069 2068 2070 2152 2153 2068 2068 2153 2154 2068 2154 2070 2151 2241 2152 2152 2241 2242 2152 2242 2153 2153 2242 2243 2153 2243 2154 2154 2155 2070 2154 2243 2244 2154 2244 2155 2070 2155 2156 2070 2156 2072 2155 2244 2245 2155 2245 2156 2243 2186 2244 2244 2186 2187 2244 2187 2245 2242 2185 2243 2243 2185 2186 2185 123 2186 2186 123 122 2186 122 2187 2187 122 120 2187 120 2188 2245 2187 2188 2245 2188 2246 2156 2245 2246 2188 120 119 2188 119 2189 2246 2188 2189 110 119 120 110 120 121 120 122 121 121 122 123 121 123 93 1277 110 121 1277 121 1283 1283 121 93 93 123 124 2185 124 123 93 124 94 2184 94 124 2184 124 2185 2242 2184 2185 2183 94 2184 2241 2183 2184 2241 2184 2242 93 94 95 95 94 96 2183 96 94 2182 96 2183 2240 2183 2241 2240 2182 2183 2151 2240 2241 2297 2182 2240 2150 2297 2240 2150 2240 2151 2239 98 2182 2182 98 96 2297 2239 2182 95 96 97 96 98 97 97 98 99 2239 99 98 2238 99 2239 2296 2238 2239 2296 2239 2297 2149 2296 2297 2149 2297 2150 2149 2150 2065 2065 2150 2151 2122 2148 2149 2122 2149 2065 2148 2296 2149 2295 2238 2296 2148 2295 2296 2120 2147 2148 2120 2148 2122 2147 2295 2148 2121 2120 2122 2121 2122 2123 2123 2122 2065 2118 2145 2120 2120 2145 2146 2146 2147 2120 2146 2294 2147 2147 2294 2295 2145 2293 2146 2146 2293 2294 2118 2144 2145 2144 2292 2145 2145 2292 2293 2116 2144 2118 2116 2143 2144 2143 2291 2144 2144 2291 2292 2291 2234 2292 2292 2234 2235 2292 2235 2293 2293 2235 2236 2293 2236 2294 2234 126 2235 2235 126 125 2235 125 2236 2233 134 2234 2234 134 126 2291 2233 2234 2290 2233 2291 2143 2290 2291 2232 135 2233 2233 135 134 2290 2232 2233 126 134 127 127 134 135 87 125 126 87 126 127 89 125 87 2236 125 89 87 88 89 1294 88 87 1294 87 1300 1300 87 127 127 135 129 1300 127 1305 1305 127 129 129 135 136 129 136 130 2231 130 136 2231 136 2232 2232 136 135 2230 130 2231 2288 2230 2231 2288 2231 2289 2289 2231 2232 2289 2232 2290 2141 2288 2289 2141 2289 2142 2142 2289 2290 2287 2230 2288 2140 2287 2288 2140 2288 2141 2114 2140 2141 2114 2141 2116 2116 2141 2142 2142 2143 2116 2142 2290 2143 2112 2140 2114 2112 2139 2140 2139 2287 2140 1304 1306 1305 1305 1306 1307 1305 1307 1300 1306 1304 1414 1307 1306 1387 1306 1414 1387 1300 1307 1308 1413 1308 1307 1307 1387 1413 1299 1294 1300 1299 1300 1301 1300 1308 1301 1301 1308 1413 1413 1299 1301 1424 1377 1413 1413 1377 1299 1413 1387 1456 1413 1456 1424 1292 1294 1299 1299 1377 1292 1376 1377 1378 1292 1377 1376 1424 1378 1377 1292 1293 1294 1292 1376 1293 1293 1376 1295 1378 1446 1376 1376 1446 1445 1376 1445 1295 1294 1293 1295 1294 1295 1296 1296 1295 1297 1295 1445 1297 1388 1297 1445 1388 1445 1442 1442 1445 1446 1296 1297 1285 1285 1297 1298 1298 1297 1388 1285 97 1296 1296 97 88 1296 88 1294 97 99 88 1285 95 97 88 99 100 88 100 89 2238 100 99 2237 89 100 2237 100 2238 2236 89 2237 2294 2236 2237 2294 2237 2295 2295 2237 2238 1288 93 95 1288 95 1285 1283 93 1288 1285 1287 1288 1287 1289 1288 1288 1289 1290 1288 1290 1283 1285 1286 1287 1285 1298 1286 1289 1287 1389 1287 1286 1389 1290 1289 1438 1438 1289 1389 1283 1290 1291 1291 1290 1390 1390 1290 1438 1390 1438 1435 1435 1438 1439 1438 1389 1439 1389 1286 1388 1389 1388 1441 1439 1389 1441 1286 1298 1388 1441 1388 1442 1439 1441 1440 1435 1439 1437 1437 1439 1440 1436 1435 1437 1437 973 1436 1434 1435 1436 1431 1434 1436 1431 1436 943 1436 973 972 1436 972 943 971 972 973 971 943 972 968 943 971 1776 971 1664 1848 968 971 971 1776 1849 971 1849 1848 968 969 943 1848 969 968 1847 969 1848 1848 1849 1850 1848 1850 1847 1849 1776 1779 1849 1779 1850 1664 1779 1776 1664 1778 1779 1850 1779 1778 1850 1778 1851 1847 1850 1851 1846 970 1847 1847 970 969 1847 1851 1846 943 969 970 943 970 944 1846 944 970 1846 1851 1852 1846 1852 1854 1854 965 1846 1846 965 944 1851 1778 1852 1778 1777 1852 1852 1777 1783 1852 1783 1853 1854 1852 1853 1854 1853 1855 1855 964 1854 1854 964 965 964 963 965 965 963 944 962 963 964 1855 962 964 961 962 1855 1856 961 1855 1856 1855 1857 1857 1855 1853 961 960 962 962 960 966 962 966 963 959 960 961 959 961 1856 1857 1858 1856 1856 1858 1860 1856 1860 959 1857 1853 1525 1525 1524 1857 1857 1524 1858 1524 1537 1858 1858 1537 1859 1858 1859 1860 1860 1859 1861 1860 1861 957 959 1860 957 1861 1859 1862 1520 1862 1859 1520 1859 1537 1526 1520 1537 1526 1537 1524 1524 1525 1526 1531 1520 1526 1525 1775 1526 1526 1775 1785 1526 1785 1531 1520 1521 1522 1531 1521 1520 1522 1862 1520 1522 1521 1523 1523 1864 1522 1522 1864 1862 1521 1798 1523 1523 1798 1799 1523 1799 1800 1868 1864 1523 1868 1523 1800 1521 1821 1798 1798 1821 1822 1798 1822 1799 1799 1802 1800 1799 1822 1823 1799 1823 1802 1821 1817 1822 1822 1817 1818 1822 1818 1823 1521 1816 1821 1821 1816 1817 1816 1746 1817 1817 1746 1743 1817 1743 1818 1818 1743 1744 1818 1744 1819 1823 1818 1819 1743 1530 1744 1743 1746 1530 1530 1746 1747 1816 1747 1746 1521 1747 1816 1530 1521 1531 1530 1747 1521 1529 1530 1531 1531 1785 1786 1531 1786 1529 1527 1528 1529 1529 1528 1530 1529 1786 1787 1529 1787 1527 1785 1655 1786 1655 1653 1786 1786 1653 1651 1786 1651 1787 1775 1662 1785 1785 1662 1655 1661 1655 1662 1661 1662 1660 1660 1662 1663 1775 1663 1662 1656 1655 1661 1690 1656 1661 1690 1661 1660 1659 1658 1660 1660 1663 1659 1660 1658 1690 1659 1663 1775 1607 1658 1659 1775 1607 1659 1607 1657 1658 1658 1657 1679 1690 1658 1679 1606 1607 1608 1606 1657 1607 1775 1608 1607 1679 1657 1606 1608 1666 1606 1679 1606 1689 1689 1606 1666 1664 1665 1608 1608 1665 1666 1782 1664 1608 1782 1608 1775 1525 1782 1775 1780 1781 1782 1782 1781 1783 1782 1783 1777 1780 1782 1525 1777 1664 1782 1777 1778 1664 1525 1853 1780 1853 1781 1780 1853 1783 1781 1689 1666 1665 1689 1596 1595 1595 1594 1689 1689 1594 1593 1689 1593 1679 1205 1595 1596 1205 1596 1203 1594 1595 1205 1204 1593 1594 1204 1594 1205 879 1204 1205 1205 1203 879 879 1203 888 879 888 881 881 888 882 879 881 880 880 881 882 878 879 880 880 922 878 877 876 878 878 876 879 922 877 878 922 748 713 922 713 923 923 874 922 922 874 877 874 876 877 820 873 874 873 875 874 874 875 876 820 874 923 820 821 822 822 872 820 820 872 873 923 821 820 1208 875 873 1208 873 1209 1209 873 872 1207 876 875 1207 875 1208 1209 1591 1208 1208 1591 1592 1208 1592 1207 1209 872 1210 1210 1590 1209 1209 1590 1591 1210 872 822 1210 822 1211 1211 1589 1210 1210 1589 1590 1591 1590 1679 1589 1679 1590 1679 1592 1591 1207 1592 1593 1679 1593 1592 1690 1679 1589 1211 1588 1589 1589 1588 1690 1211 822 823 1211 823 1198 1198 1588 1211 1198 1587 1588 1690 1588 1587 1690 1587 1691 1691 1656 1690 1197 1586 1587 1197 1587 1198 1691 1587 1586 827 1197 1198 1198 823 825 1198 825 827 1197 827 1212 1212 1586 1197 1212 1585 1586 1691 1586 1692 1586 1585 1692 1212 827 829 1212 829 1213 1213 1585 1212 1213 1584 1585 1692 1585 1584 1693 1652 1692 1692 1652 1654 1692 1654 1691 1692 1584 1693 1214 1583 1584 1214 1584 1213 1693 1584 1583 1213 833 1214 1214 833 835 1214 835 1215 1215 1583 1214 1215 1582 1583 1693 1583 1694 1694 1583 1582 1215 835 1216 1216 1582 1215 1216 1581 1582 1694 1582 1695 1582 1581 1695 1695 1647 1694 1694 1647 1649 1694 1649 1693 1696 1645 1695 1695 1645 1647 1695 1581 1580 1695 1580 1696 1217 1580 1581 1217 1581 1216 1218 1564 1580 1218 1580 1217 1696 1580 1564 1216 837 1217 837 839 1217 1217 839 841 1217 841 1218 1218 841 843 1218 843 1219 1219 1564 1218 839 840 841 841 840 842 841 842 843 837 838 839 839 838 840 929 840 930 930 840 838 929 842 840 843 842 844 929 844 842 930 736 929 929 736 735 929 735 931 931 844 929 930 838 928 928 737 930 930 737 736 490 735 736 490 736 491 491 736 737 488 734 735 488 735 490 735 734 931 489 488 490 489 490 491 492 493 491 491 493 494 491 494 489 491 737 492 487 488 489 508 487 489 508 489 509 509 489 494 509 494 510 510 494 493 622 509 510 622 623 509 509 623 624 509 624 508 507 487 508 508 624 625 508 625 507 623 611 624 624 611 612 624 612 625 622 610 623 623 610 611 610 585 611 611 585 588 611 588 612 612 588 590 612 590 613 625 612 613 625 613 626 507 625 626 613 590 593 613 593 614 626 613 614 626 614 627 507 626 506 506 626 627 614 593 595 614 595 615 627 614 615 627 615 628 506 627 505 505 627 628 505 482 506 506 482 485 506 485 507 507 485 487 482 484 485 485 484 486 485 486 487 487 486 488 484 733 486 486 733 734 486 734 488 482 483 484 483 733 484 483 732 733 931 734 733 931 733 933 933 733 732 481 483 482 481 732 483 481 731 732 933 732 932 932 732 731 932 848 933 933 848 846 933 846 931 931 846 844 845 844 846 845 846 847 847 846 848 847 848 849 849 848 850 932 850 848 1196 845 847 1196 847 849 843 844 845 1220 843 845 1220 845 1196 1219 843 1220 1196 1563 1220 1220 1563 1564 1220 1564 1219 1196 1579 1563 1564 1563 1697 1697 1563 1579 1696 1564 1697 1699 1629 1697 1697 1629 1641 1697 1641 1696 1697 1579 1699 1196 1578 1579 1699 1579 1578 1698 1630 1699 1699 1630 1629 1699 1578 1698 1629 1630 1631 1629 1631 1641 1641 1631 1642 1641 1642 1643 1696 1641 1643 1696 1643 1645 1643 1642 1644 1643 1644 1645 1789 1644 1642 1789 1642 1790 1642 1631 1790 1631 1630 1632 1790 1631 1632 1790 1632 1791 1554 1789 1790 1554 1790 1551 1551 1790 1791 1788 1644 1789 1538 1788 1789 1538 1789 1554 1551 1553 1554 1554 1553 1555 1554 1555 1538 1538 1539 1527 1538 1555 1556 1538 1556 1539 1527 1788 1538 1763 1556 1555 1763 1555 1764 1764 1555 1553 1762 1539 1556 1762 1556 1763 1527 1539 1540 1750 1540 1539 1750 1539 1762 1527 1540 1528 1527 1787 1788 1742 1528 1540 1742 1540 1750 1748 1530 1528 1748 1528 1741 1741 1528 1742 1740 1741 1742 1750 1751 1742 1742 1751 1752 1742 1752 1740 1820 1748 1741 1820 1741 1826 1741 1740 1826 1745 1530 1748 1745 1748 1820 1744 1530 1745 1819 1744 1745 1819 1745 1820 1824 1819 1820 1824 1820 1825 1825 1820 1826 1823 1819 1824 1802 1823 1824 1802 1824 1803 1803 1824 1825 1803 1825 1805 1825 1826 1827 1805 1825 1807 1807 1825 1827 1800 1802 1803 1800 1803 1804 1804 1803 1805 1804 1805 1806 1806 1805 1807 1806 1807 1808 1808 1807 1809 1807 1827 1809 1808 1871 1806 1806 1871 1870 1806 1870 1804 1804 1870 1869 1804 1869 1800 1800 1869 1867 1800 1867 1868 1866 1865 1867 1867 1865 1864 1867 1864 1868 1869 1866 1867 1412 1411 1866 1866 1411 1865 1869 1412 1866 1863 1864 1865 1411 1410 1865 1865 1410 1409 1865 1409 1863 1863 1862 1864 1861 1862 1863 1863 1409 955 1863 955 1861 1408 955 1409 1409 1410 1408 1408 1410 1411 1408 1411 1395 1395 1411 1412 956 955 1408 1395 1454 1408 1408 1454 958 1408 958 956 955 956 957 957 1861 955 957 956 958 957 958 959 959 958 960 1454 960 958 1395 1453 1454 1453 1429 1454 1454 1429 960 1429 966 960 1428 1429 1430 1453 1430 1429 1428 963 1429 1429 963 966 1405 1392 1453 1405 1453 1395 1392 1430 1453 1432 1428 1430 1432 1430 1391 1392 1391 1430 1280 1278 1392 1280 1392 1405 1278 1391 1392 1278 1276 1391 1276 1275 1391 1391 1275 1433 1391 1433 1432 1277 1276 1278 1277 1278 1279 1279 1278 1280 1275 1276 1277 1275 1277 1282 1275 1282 1433 1433 1282 1390 1433 1390 1434 1432 1433 1434 1282 1277 1283 1282 1283 1284 1284 1390 1282 1279 110 1277 110 111 112 112 119 110 1279 111 110 111 159 112 2189 119 112 2189 112 2190 2190 112 159 111 158 159 2190 159 2191 2191 159 158 2247 2189 2190 2247 2190 2248 2248 2190 2191 2246 2189 2247 2157 2246 2247 2157 2247 2158 2158 2247 2248 2248 2191 2249 2158 2248 2159 2159 2248 2249 2191 158 2192 2249 2191 2192 2249 2192 2250 2159 2249 2160 2160 2249 2250 2074 2158 2159 2074 2159 2076 2159 2160 2076 2072 2157 2158 2072 2158 2074 2075 2074 2076 2075 2076 2077 2077 2076 2078 2076 2160 2161 2076 2161 2078 2160 2250 2161 2161 2162 2078 2161 2250 2251 2161 2251 2162 2077 2078 2079 2079 2078 2080 2078 2162 2163 2078 2163 2080 2162 2251 2252 2162 2252 2163 2250 2193 2251 2251 2193 2194 2251 2194 2252 2252 2194 2195 2252 2195 2253 2163 2252 2253 2080 2163 2164 2163 2253 2164 2253 2195 2196 2253 2196 2254 2164 2253 2254 2194 169 2195 2195 169 167 2195 167 2196 2193 170 2194 2194 170 169 167 169 168 168 169 170 154 166 167 154 167 168 2196 167 166 2196 166 2197 2254 2196 2197 156 166 154 2197 166 156 154 155 156 1358 155 154 1358 154 1268 1268 154 168 155 162 156 2197 156 2198 2198 156 162 2254 2197 2255 2255 2197 2198 2198 162 2199 2255 2198 2256 2256 2198 2199 155 161 162 2199 162 161 2199 161 2200 2256 2199 2257 2257 2199 2200 2166 2255 2256 2166 2256 2167 2167 2256 2257 2165 2254 2255 2165 2255 2166 2164 2254 2165 2164 2165 2080 2080 2165 2166 2080 2166 2082 2166 2167 2082 2082 2167 2168 2167 2257 2168 2257 2200 2258 2168 2257 2258 2082 2168 2084 2168 2169 2084 2168 2258 2169 2081 2080 2082 2081 2082 2083 2083 2082 2084 2079 2080 2081 23 2081 2083 23 22 2081 2081 22 21 2081 21 2079 2079 21 30 2079 30 2077 19 20 21 21 22 19 20 30 21 19 22 23 19 23 14 51 20 19 51 19 14 25 29 20 20 29 30 25 20 51 30 29 2077 2077 29 28 2077 28 2075 25 28 29 8 51 13 13 51 14 13 17 8 8 17 18 8 18 9 8 69 66 13 14 15 15 16 13 13 16 17 14 23 24 14 24 15 2085 16 15 2085 15 2083 2083 15 24 17 16 2085 2083 2084 2085 2085 2084 2086 2085 2086 2087 17 2085 2087 2083 24 23 2087 2086 2088 2087 2088 2089 2089 9 2087 2087 9 18 2087 18 17 2089 2088 2090 2089 10 9 2088 2173 2090 2173 2174 2090 2090 2174 2175 2090 2175 2092 2088 2172 2173 2172 2262 2173 2173 2262 2263 2173 2263 2174 2174 2263 2264 2174 2264 2175 2092 2175 2176 2175 2264 2265 2175 2265 2176 2176 2177 2092 2176 2265 2266 2176 2266 2177 2264 2207 2265 2265 2207 2208 2265 2208 2266 2263 2206 2264 2264 2206 2207 2206 151 2207 2207 151 118 2207 118 2208 2208 118 133 2208 133 2209 2266 2208 2209 2266 2209 2267 2177 2266 2267 2209 133 132 2209 132 2210 2267 2209 2210 117 132 133 117 133 118 116 117 118 118 151 116 131 132 117 1347 131 117 1347 117 1345 1345 117 116 131 141 132 2210 132 141 139 140 131 131 140 141 1341 131 1347 1341 139 131 1345 1346 1347 1347 1346 1348 1347 1348 1341 1345 1344 1346 1348 1346 1381 1346 1344 1422 1346 1422 1381 1341 1348 1349 1421 1349 1348 1348 1381 1421 1421 1381 1477 1381 1422 1480 1381 1480 1477 1342 1349 1421 1342 1421 1420 1420 1421 1476 1421 1477 1476 1341 1349 1342 1340 1341 1342 1420 1340 1342 1337 1340 1420 1337 1420 1419 1419 1420 1475 1420 1476 1475 1475 1476 1369 1476 1477 1478 1476 1478 1369 1419 1475 1472 1472 1475 1474 1475 1369 1474 950 952 1369 1474 1369 952 1369 1478 949 1369 949 950 1477 1479 1478 1478 1479 945 1478 945 949 945 754 949 949 754 775 949 775 950 755 754 945 755 945 780 780 945 954 1479 954 945 754 755 756 754 756 775 780 756 755 779 756 780 783 779 780 953 783 780 780 954 953 1479 953 954 783 953 1072 1072 953 1399 1479 1399 953 782 779 783 1072 782 783 1071 1067 1072 1072 1067 782 1072 1399 1071 781 778 782 782 778 779 1067 781 782 1066 781 1067 1069 1066 1067 1071 1069 1067 1070 1069 1071 1399 1070 1071 1068 1066 1069 1074 1068 1069 1074 1069 1075 1075 1069 1070 656 660 1066 1066 660 781 1068 656 1066 653 656 1068 1073 653 1068 1073 1068 1074 1075 1091 1074 1074 1091 1073 1075 1070 1076 1076 1089 1075 1075 1089 1091 1400 1089 1076 1400 1076 1399 1399 1076 1070 1089 1090 1091 1090 1089 1400 1091 1090 1092 1090 1400 1092 1091 1092 1085 1085 1092 1093 1093 1092 1379 1092 1400 1380 1092 1380 1379 1085 1093 1086 1093 1379 1086 1085 1086 1084 1084 1086 1087 1379 1087 1086 1083 789 1084 1084 1087 1083 789 790 1084 1084 790 792 1084 792 1085 1083 1087 1088 1379 1088 1087 1083 1088 1082 1354 1082 1088 1354 1088 1379 1080 1081 1082 1082 1081 1083 1080 1082 1354 1078 1079 1080 1080 1079 1081 1080 1354 1078 1079 784 1081 1081 784 788 1081 788 1083 1078 1077 1079 1077 785 1079 1079 785 784 787 1077 1078 1078 1354 787 787 786 1077 1077 786 785 784 785 566 566 785 786 784 566 788 565 561 566 566 561 562 566 786 787 788 566 562 566 800 565 787 800 566 564 560 565 565 560 561 565 800 801 565 801 564 560 532 561 561 532 538 561 538 562 559 530 560 560 530 532 564 559 560 530 531 532 531 533 532 532 533 535 532 535 538 567 531 530 567 530 574 574 530 559 563 559 564 574 559 563 563 571 572 563 572 574 571 563 564 564 801 802 564 802 571 572 571 573 571 802 573 801 795 802 802 795 798 802 798 573 800 793 801 801 793 795 793 794 795 794 796 795 795 796 797 795 797 798 798 797 799 798 799 568 573 798 568 572 573 568 568 569 570 568 570 572 568 799 569 797 1112 799 799 1112 1113 799 1113 569 796 1111 797 797 1111 1112 1111 1105 1112 1112 1105 1104 1112 1104 1113 1113 1104 1101 1113 1101 678 569 1113 678 570 569 678 572 570 577 678 577 570 676 579 678 678 579 577 678 1101 676 1100 676 1101 1103 1100 1101 1103 1101 1104 676 677 579 1100 677 676 1099 677 1100 1102 1099 1100 1102 1100 1103 1104 1107 1103 1103 1107 1108 1103 1108 1102 1098 1099 1102 1102 1108 1109 1102 1109 1098 1096 683 1099 1099 683 677 1098 1096 1099 677 683 579 681 682 683 579 683 682 1096 681 683 1095 1094 1096 1094 681 1096 1095 1096 1098 679 680 681 681 680 682 1094 679 681 1095 1365 1094 1094 1365 1367 1094 1367 679 1097 1095 1098 1097 1361 1095 1095 1361 1365 1361 1360 1365 1365 1360 1366 1365 1366 1367 1367 1366 1368 1367 1368 1244 679 1367 1244 1366 1360 1359 1368 1366 1838 1838 1366 1359 1359 1360 1358 1358 1360 1361 1358 1361 1261 1261 1361 1097 1356 1357 1358 1358 1357 1359 1268 1363 1358 1358 1363 1364 1358 1364 1356 1261 155 1358 1357 1356 1839 1839 1356 1364 1839 1359 1357 1838 1359 1839 1839 1364 1840 1837 1838 1839 1837 1839 1842 1842 1839 1840 1840 1364 1363 1840 1363 1841 1842 1840 1843 1843 1840 1841 1512 1837 1842 1512 1842 1513 1513 1842 1843 1245 1368 1837 1368 1838 1837 1245 1837 1512 1243 1245 1512 1243 1512 1247 1247 1512 1513 1247 1513 1494 1513 1514 1494 1513 1843 1514 1494 1514 1515 1514 1843 1844 1514 1844 1515 1494 1515 1516 1515 1844 1845 1515 1845 1516 1843 1841 1844 1844 1841 1836 1844 1836 1845 1845 1836 1835 1845 1835 1833 1516 1845 1833 1266 1835 1836 1841 1362 1836 1836 1362 1267 1836 1267 1266 1841 1363 1362 1267 1362 1268 1268 1362 1363 1264 1266 1267 1264 1267 1268 1265 1266 1264 1265 1835 1266 1264 1263 1265 1834 1835 1265 1263 1834 1265 1262 1263 1264 1263 1262 1831 1831 1834 1263 1832 1833 1834 1834 1833 1835 1831 1832 1834 1830 1832 1831 1829 1830 1831 1829 1831 1269 1269 1831 1262 1269 1262 1270 1270 1262 1264 1270 1264 1271 1271 1404 1270 1269 1270 1801 1270 1872 1801 1270 1404 1872 1271 1403 1404 1872 1404 1403 1801 1872 1873 1872 1403 1873 1813 1269 1801 1801 1873 1813 1813 1873 1874 1873 1403 1402 1873 1402 1874 1402 1403 1271 1271 1401 1402 1874 1402 1401 1813 1874 1812 1812 1874 1875 1874 1401 1875 1812 1269 1813 1810 1811 1812 1812 1811 1269 1812 1875 1810 1875 1401 1397 1875 1397 1871 1810 1875 1808 1808 1875 1871 1271 1397 1401 1396 1397 1398 1398 1397 1271 1871 1397 1396 1407 1870 1871 1871 1396 1407 1398 1407 1396 1398 1406 1407 1870 1407 1869 1869 1407 1406 1405 1394 1406 1405 1406 1398 1869 1406 1394 1394 1393 1869 1393 1412 1869 1393 1394 1395 1395 1394 1405 1398 1274 1405 1405 1274 1281 1405 1281 1280 1273 1272 1274 1272 1281 1274 1398 1273 1274 1272 1280 1281 1279 1280 1272 1272 111 1279 1271 1264 1272 1271 1272 1273 1264 157 1272 1272 157 111 1271 1273 1398 157 158 111 168 170 157 157 170 171 157 171 158 1264 168 157 1268 168 1264 2192 158 171 2192 171 2193 2193 171 170 2250 2192 2193 1395 1412 1393 1808 1809 1810 1810 1809 1811 1809 1827 1828 1809 1828 1811 1811 1828 1829 1811 1829 1269 1827 1815 1828 1828 1815 1814 1828 1814 1829 1827 1826 1815 1749 1814 1815 1826 1752 1815 1815 1752 1751 1815 1751 1749 1749 1738 1814 1814 1738 1830 1814 1830 1829 1738 1749 1750 1750 1749 1751 1737 1738 1739 1738 1750 1739 1738 1737 1830 1737 1753 1830 1830 1753 1832 1737 1739 1753 1739 1517 1753 1753 1517 1832 1754 1518 1739 1739 1518 1517 1739 1750 1762 1739 1762 1754 1517 1518 1516 1832 1517 1833 1516 1833 1517 1516 1518 1519 1754 1519 1518 1516 1519 1494 1754 1494 1519 1247 1494 1495 1756 1495 1494 1756 1494 1754 682 1243 1247 682 1247 684 684 1247 1248 1247 1495 1248 1248 1495 1496 1755 1495 1756 1755 1496 1495 684 1248 685 685 1248 1249 1248 1496 1249 581 682 684 581 684 582 582 684 685 582 685 584 584 685 586 586 685 688 685 1249 688 688 1249 1250 1249 1496 1497 1249 1497 1250 586 688 687 1242 687 688 688 1250 1242 584 586 585 585 586 587 687 587 586 686 587 687 687 1242 686 686 1242 1251 1250 1498 1242 1242 1498 1499 1242 1499 1251 1250 1497 1498 1757 1498 1758 1758 1498 1497 1757 1499 1498 1251 1499 1500 1757 1500 1499 686 1251 689 689 1251 1252 1251 1500 1252 1252 1500 1501 1760 1501 1500 1760 1500 1757 689 1252 1241 1252 1501 1241 686 689 592 592 689 690 1241 690 689 690 1241 691 691 1241 1253 1241 1501 1502 1241 1502 1253 1759 1501 1760 1759 1502 1501 1253 1502 1503 1759 1503 1502 691 1253 692 692 1253 1254 1253 1503 1254 1254 1503 1504 1761 1503 1759 1761 1504 1503 1760 1768 1759 1759 1768 1769 1759 1769 1761 1761 1769 1770 1761 1770 1772 1772 1505 1761 1761 1505 1504 1254 1504 1255 1255 1504 1505 1255 1505 1256 1256 1505 1506 1772 1506 1505 1772 1770 1771 1772 1771 1773 1773 1506 1772 1256 1506 1240 1240 1506 1507 1773 1507 1506 694 1255 1256 694 1256 1240 693 1254 1255 693 1255 694 599 693 694 599 694 600 600 694 695 1240 695 694 597 692 693 597 693 599 692 1254 693 597 599 598 598 599 600 598 600 601 601 600 602 600 695 602 602 695 696 695 1240 696 601 602 603 603 602 604 602 696 604 616 598 601 616 601 617 617 601 603 603 604 605 617 603 618 618 603 605 605 604 606 604 696 697 604 697 606 605 606 607 606 697 698 606 698 607 696 1257 697 697 1257 1258 697 1258 698 708 607 698 698 1258 1259 698 1259 708 633 605 607 707 633 607 707 607 708 1239 707 708 708 1259 1260 708 1260 1239 1258 1509 1259 1259 1509 1510 1259 1510 1260 1260 1510 1511 1260 1511 1239 1239 1246 707 1239 1511 1485 1239 1485 1246 1726 1485 1511 1511 1510 1726 1510 1509 1736 1726 1510 1736 1258 1508 1509 1509 1508 1736 1736 1508 1773 1736 1773 1774 1726 1736 1727 1727 1736 1774 1257 1507 1508 1257 1508 1258 1508 1507 1773 1774 1773 1771 1774 1771 1557 1727 1774 1534 1534 1774 1557 1718 1726 1727 1718 1727 1544 1544 1727 1534 1712 1726 1718 1712 1483 1726 1726 1483 1485 1481 1482 1483 1483 1482 1484 1483 1484 1485 1709 1481 1483 1712 1709 1483 1485 1484 1486 1246 1485 1486 1964 1486 1484 1964 1484 1965 1965 1484 1482 1965 1482 1966 1966 1482 1481 378 1964 1965 378 1965 406 406 1965 408 408 1965 1966 377 1962 1964 377 1964 378 1962 1486 1964 377 378 379 378 406 379 379 406 397 408 397 406 407 397 408 408 1966 407 396 397 398 398 397 369 379 397 380 380 397 396 407 369 397 371 369 407 407 1966 1959 407 1959 371 370 369 371 370 371 1951 1951 371 1959 1951 1959 1949 1966 1949 1959 1966 1481 1949 1949 1481 1709 1949 1709 1951 370 1951 1952 1951 1709 1713 1951 1713 1952 365 369 370 370 1952 365 365 1952 1953 1952 1713 1715 1952 1715 1953 1712 1711 1713 1711 1715 1713 1713 1709 1712 1711 1714 1715 1953 1715 1714 1710 1711 1712 1710 1714 1711 1718 1720 1712 1712 1720 1721 1712 1721 1710 1954 1714 1710 1954 1710 1955 1955 1710 1721 1953 1714 1954 372 1953 1954 372 1954 373 373 1954 1955 373 1955 375 375 1955 376 376 1955 1956 1955 1721 1956 1721 1720 1956 376 1956 1957 1957 1956 1958 1958 1956 1948 1956 1720 1719 1956 1719 1948 374 375 376 374 376 2008 2008 376 1957 374 373 375 366 373 374 374 2008 2009 2009 366 374 364 365 366 366 365 367 367 372 366 366 372 373 2009 364 366 364 368 365 368 364 2009 365 368 369 365 1953 367 367 1953 372 398 369 368 2009 398 368 2009 396 398 380 396 2009 380 381 379 2009 381 380 381 395 379 381 2009 395 379 395 394 379 394 377 393 394 395 2009 390 395 395 390 392 395 392 393 392 391 393 393 391 394 390 391 392 386 389 390 390 389 391 2009 386 390 384 385 386 386 385 387 387 388 386 386 388 389 384 386 2009 400 391 389 400 389 401 401 389 388 1960 401 388 1960 388 1491 1491 388 387 1491 387 385 1246 1490 1491 1493 1246 1491 1491 385 1493 1491 1490 1960 1246 1489 1490 1960 1490 1489 400 1960 1961 400 401 1960 1960 1489 1961 1488 1489 1246 1961 1489 1488 403 402 1961 1961 402 399 1961 399 400 1963 403 1961 1961 1488 1963 1246 1487 1488 1963 1488 1487 1962 403 1963 1963 1487 1962 1246 1486 1487 1962 1487 1486 405 404 1962 1962 404 403 405 1962 377 394 404 405 377 394 405 394 403 404 391 403 394 391 402 403 399 391 400 399 402 391 1246 409 414 707 1246 414 1492 409 1246 1492 1246 1493 701 633 707 707 414 701 412 416 701 701 416 702 701 702 703 703 704 701 701 704 705 701 705 706 706 699 701 701 699 633 701 414 412 702 437 703 703 437 436 703 436 704 704 436 435 704 435 705 705 435 434 705 434 706 428 434 435 428 435 430 435 436 430 430 436 437 430 437 417 417 437 438 702 438 437 430 431 428 430 417 2009 2009 431 430 428 431 432 2009 432 431 428 432 429 429 432 2009 427 428 429 2009 427 429 425 426 427 427 426 428 2009 425 427 418 424 425 425 424 426 2009 418 425 424 441 426 426 441 442 426 442 428 424 440 441 1236 442 441 1236 441 440 428 442 443 1238 442 1236 1238 443 442 433 434 428 428 443 433 1238 433 443 434 433 1238 434 1238 706 706 1238 1236 1236 440 1237 706 1236 699 699 1236 1237 1237 440 439 1237 439 1235 699 1237 700 700 1237 1235 699 700 633 700 709 633 700 1235 709 1235 448 1234 1235 439 444 1235 444 448 709 1235 1234 439 440 424 424 444 439 424 420 444 420 448 444 420 447 448 1234 448 447 418 419 420 420 419 421 418 420 424 421 447 420 421 446 447 1234 447 446 445 446 421 445 1233 446 446 1233 1234 421 450 445 445 450 451 451 1126 445 445 1126 1233 1126 1127 1233 710 1234 1233 710 1233 711 711 1233 1127 451 456 1126 1126 456 1125 1126 1125 1127 450 456 451 450 455 456 455 459 456 459 1125 456 459 1124 1125 1127 1125 648 648 1125 649 649 1125 1124 455 458 459 458 1124 459 458 1123 1124 649 1124 650 650 1124 1123 635 648 649 635 649 650 634 648 635 634 711 648 711 1127 648 633 634 635 633 710 634 634 710 711 635 605 633 633 709 710 709 1234 710 618 605 619 635 619 605 630 617 618 630 618 631 631 618 619 631 619 632 642 632 619 642 619 635 632 503 631 631 503 504 504 630 631 629 617 630 504 629 630 629 616 617 628 616 629 505 629 504 505 628 629 503 477 504 504 477 479 504 479 505 505 479 482 477 478 479 478 480 479 479 480 481 479 481 482 474 476 477 477 476 478 503 474 477 474 475 476 475 726 476 476 726 727 476 727 478 473 475 474 473 725 475 475 725 726 727 726 937 937 726 725 727 728 478 935 728 727 935 727 937 939 862 937 937 862 860 937 860 935 937 725 939 473 724 725 939 725 724 938 864 939 939 864 862 939 724 938 861 860 862 861 862 863 863 862 864 859 858 860 859 860 861 935 860 858 859 861 1226 1226 861 863 863 864 865 1226 863 1227 1227 863 865 865 864 866 938 866 864 865 866 867 1227 865 1228 1228 865 1229 1229 865 867 1228 1570 1227 1227 1570 1571 1227 1571 1226 1229 1569 1228 1228 1569 1570 1229 867 1230 1230 1568 1229 1229 1568 1569 1704 1570 1569 1704 1569 1706 1569 1568 1706 1705 1571 1570 1705 1570 1704 1704 1622 1705 1706 1627 1704 1704 1627 1628 1704 1628 1622 1705 1622 1621 1705 1621 1703 1703 1571 1705 1622 1623 1621 1628 1623 1622 1627 1623 1628 1609 1626 1627 1627 1626 1623 1706 1609 1627 1621 1623 1624 1623 1795 1624 1623 1626 1795 1609 1625 1626 1795 1626 1625 1624 1795 1796 1795 1625 1797 1533 1796 1795 1533 1795 1535 1535 1795 1797 1611 1625 1609 1797 1625 1611 1797 1611 1784 1535 1797 1536 1536 1797 1784 1534 1533 1535 1534 1535 1536 1532 1533 1534 1532 1796 1533 1545 1544 1534 1545 1534 1546 1546 1534 1536 1534 1557 1532 1536 1784 1546 1546 1784 1735 1546 1735 1545 1543 1544 1545 1543 1545 1731 1731 1545 1735 1735 1613 1612 1731 1735 1669 1669 1735 1612 1613 1735 1784 1612 1613 1614 1614 1613 1615 1784 1615 1613 1614 1667 1612 1612 1667 1668 1612 1668 1669 1669 1668 1670 1669 1670 1671 1669 1671 1731 1683 1670 1668 1683 1668 1708 1708 1668 1667 1708 1667 1614 1614 1615 1616 1616 1708 1614 1616 1615 1611 1784 1611 1615 1616 1611 1617 1617 1707 1616 1616 1707 1708 1609 1610 1611 1617 1611 1610 1617 1610 1707 1707 1610 1609 1707 1609 1706 1706 1567 1707 1707 1567 1566 1707 1566 1708 1706 1568 1567 1231 1566 1567 1231 1567 1230 1230 1567 1568 1232 1565 1566 1232 1566 1231 1565 1708 1566 1230 817 1231 1231 817 1232 867 869 1230 1230 869 817 867 866 868 867 868 869 869 868 870 869 870 817 911 870 868 911 868 938 938 868 866 817 870 871 910 871 870 910 870 911 721 910 911 938 723 911 911 723 722 911 722 721 938 724 723 471 722 723 471 723 473 723 724 473 470 721 722 470 722 471 469 470 471 469 471 472 472 471 473 472 473 474 501 469 472 501 472 502 502 472 474 502 474 503 501 502 632 632 502 503 500 469 501 500 501 632 639 632 642 500 632 466 466 632 639 466 467 500 500 467 469 466 463 467 466 639 655 463 466 655 463 465 467 467 465 468 467 468 469 463 464 465 464 718 465 465 718 719 465 719 468 464 463 669 669 715 464 464 715 718 715 940 718 718 940 719 719 720 468 940 720 719 468 720 721 940 721 720 468 721 470 910 721 940 468 470 469 814 816 940 940 816 871 940 871 910 715 914 940 914 803 940 940 803 818 940 818 814 814 815 816 816 815 817 817 871 816 814 819 815 819 1232 815 815 1232 817 814 807 819 807 1199 819 819 1199 1232 1199 1562 1232 1562 1565 1232 1199 1200 1201 807 1200 1199 1199 1201 1562 1201 1200 1202 813 1200 807 1986 1200 813 1202 1200 1981 1981 1200 1986 1201 1202 1597 1202 1981 1597 1597 1981 1976 1981 1982 1976 1981 1986 1982 1597 1598 1201 1908 1598 1597 1976 1908 1597 1201 1598 1599 1598 1908 1599 1599 1908 1915 1976 1915 1908 1201 1599 1600 1913 1600 1599 1913 1599 1914 1599 1915 1914 1975 1914 1915 1975 1915 1976 1913 1914 1975 1912 1600 1913 1912 1913 1975 1600 1601 1201 1912 1601 1600 1911 1601 1912 1911 1912 1979 1979 1912 1975 1975 1976 1977 1979 1975 1980 1980 1975 1977 1977 1976 1978 1976 1982 1983 1976 1983 1978 1977 1978 205 1980 1977 206 206 1977 205 206 217 1980 1980 217 1971 1980 1971 1979 205 204 206 204 217 206 203 204 205 205 1978 203 203 207 204 207 203 1984 1984 203 1978 204 207 208 207 1988 208 207 1984 1988 1984 1978 1985 1988 1984 1985 1987 1988 1989 1989 1988 1990 208 1988 1987 1988 1985 1990 1985 1978 1983 1990 1985 1983 1986 1992 1990 1990 1992 1993 1990 1993 1989 1990 1983 1986 1995 1987 1989 1995 1989 1994 1994 1989 1993 1994 1993 1992 1986 1991 1992 1991 1994 1992 813 1991 1986 1982 1986 1983 813 812 1991 1991 812 1994 1997 1995 1994 1997 1994 1187 1187 1994 812 807 811 812 807 812 813 811 1187 812 1187 811 810 810 1194 1187 1187 1194 1997 810 811 807 807 809 810 809 1193 810 810 1193 1194 1194 1193 1997 809 1192 1193 1997 1193 1192 807 808 809 808 1192 809 808 1191 1192 1997 1192 1191 806 808 807 806 1191 808 806 1190 1191 1190 1997 1191 805 806 807 805 1190 806 805 1189 1190 1189 1998 1190 1998 1997 1190 1996 1995 1997 1998 1996 1997 212 211 1996 211 210 1996 1996 210 1995 1999 212 1996 1999 1996 1998 1995 210 209 209 1987 1995 199 209 210 210 211 199 199 211 212 199 212 200 200 212 1999 2000 200 1999 2000 1999 2001 2001 1999 1998 199 200 201 201 200 2000 2001 2007 2000 2000 2007 2002 2000 2002 201 2001 1998 1164 1164 1167 2001 2001 1167 2007 1188 1998 1189 1164 1998 1188 1164 1165 1166 1164 1166 1167 1164 1188 1165 1167 1166 1168 1167 1168 1169 1167 1169 2007 1184 1168 1166 1184 1166 1185 1185 1166 1165 1185 1165 1186 1165 1188 805 1165 805 1186 1188 1189 805 803 804 805 803 805 818 818 805 807 1186 805 804 913 1185 1186 913 1186 804 916 1184 1185 916 1185 913 913 804 803 916 913 914 914 913 803 914 915 916 915 1184 916 914 919 915 919 1183 915 915 1183 1184 914 918 919 918 1182 919 919 1182 1183 1182 1171 1183 1183 1171 1168 1183 1168 1184 917 1181 1182 917 1182 918 1181 1173 1182 1182 1173 1171 917 918 914 752 941 917 752 917 751 751 917 914 941 1181 917 941 1180 1181 1180 1176 1181 1181 1176 1173 753 941 752 753 1180 941 753 1163 1180 1163 1178 1180 1180 1178 1176 1175 1173 1176 1175 1176 1177 1177 1176 1178 1177 1178 1179 1162 1179 1178 1162 1178 1163 753 749 1163 1163 749 1159 1163 1159 1162 752 749 753 749 673 750 752 673 749 750 1159 749 1158 1157 1159 1158 1159 750 1162 1159 1157 750 673 674 750 674 675 675 1158 750 1156 1157 1158 1142 1156 1158 1142 1158 675 1156 195 1157 1162 1157 1160 1160 1157 195 193 194 195 195 196 193 196 195 1156 194 1160 195 193 192 194 194 192 1160 191 190 192 191 192 193 190 2006 192 1160 192 2006 189 190 191 2005 2006 190 190 189 2005 2005 2003 2006 1160 2006 2003 2004 2003 2005 2005 189 2002 2005 2002 2004 191 202 189 189 202 2002 2004 2002 2007 201 2002 202 191 201 202 199 201 191 204 208 199 199 208 209 191 2048 199 199 2048 2047 199 2047 204 208 1987 209 215 216 204 204 216 217 204 2047 2046 204 2046 215 350 2046 2047 350 2047 348 348 2047 2048 352 2045 2046 352 2046 350 215 2046 2045 348 349 350 350 349 351 350 351 352 346 347 348 348 347 349 348 2048 346 351 349 325 325 349 347 352 351 353 325 353 351 352 353 354 354 353 355 325 355 353 354 355 356 356 2044 354 354 2044 2045 354 2045 352 356 355 357 356 357 358 358 2043 356 356 2043 2044 218 2045 2044 218 2044 174 174 2044 2043 358 2042 2043 174 2043 239 239 2043 2042 360 2041 2042 360 2042 358 239 2042 241 241 2042 2041 238 174 239 238 239 240 240 239 241 240 241 242 242 241 243 243 241 244 241 2041 244 238 240 2022 2022 240 242 172 174 238 238 2022 2011 2011 172 238 2022 2023 2011 2022 2031 2023 2022 242 2031 2031 242 243 243 244 245 2031 243 245 2023 2031 2032 245 2032 2031 245 244 246 245 246 2032 2023 2032 2033 2033 2032 2034 2032 246 248 2032 248 2034 246 244 247 246 247 248 248 247 249 2034 248 249 251 2033 2034 2034 249 251 249 247 250 249 250 251 244 2040 247 247 2040 2039 247 2039 250 244 2041 2040 304 2039 2040 304 2040 362 362 2040 2041 306 2038 2039 306 2039 304 250 2039 2038 304 305 306 362 363 304 304 363 305 360 361 362 362 361 363 362 2041 360 361 305 363 306 305 307 361 307 305 306 307 308 308 2038 306 308 307 309 309 307 361 308 309 310 310 2037 308 308 2037 2038 310 309 311 361 311 309 310 311 312 312 2036 310 310 2036 2037 253 2038 2037 253 2037 256 256 2037 2036 312 2035 2036 256 2036 259 259 2036 2035 255 253 256 255 256 257 257 256 258 258 256 259 258 259 260 260 259 261 261 259 262 259 2035 262 257 258 2024 2024 258 260 257 2024 2023 2023 255 257 254 253 255 2023 254 255 2011 2023 2024 2033 254 2023 2011 2024 2025 2024 260 2025 2025 260 261 2025 2026 2011 263 2026 2025 2025 261 263 2011 2026 2027 263 264 2026 2026 264 266 2026 266 2027 261 262 263 263 262 264 264 262 265 264 265 266 266 265 267 2027 266 267 267 265 268 262 2064 265 265 2064 2063 265 2063 268 262 2035 2064 316 2063 2064 316 2064 314 314 2064 2035 318 2062 2063 318 2063 316 268 2063 2062 314 315 316 316 315 317 316 317 318 312 313 314 314 313 315 314 2035 312 361 317 315 315 313 361 312 311 313 361 313 311 360 359 361 361 359 317 358 359 360 358 357 359 317 359 357 317 357 355 323 355 325 323 321 355 355 321 319 355 319 317 322 321 323 322 323 324 324 323 325 324 325 326 326 325 327 325 347 327 326 2059 324 324 2059 2060 324 2060 322 326 327 328 328 2058 326 326 2058 2059 328 327 329 327 347 329 346 345 347 347 331 329 347 345 331 328 329 330 330 329 331 330 2057 328 328 2057 2058 330 331 332 332 2056 330 330 2056 2057 283 2058 2057 283 2057 286 286 2057 2056 332 2055 2056 286 2056 289 289 2056 2055 332 331 333 332 333 334 334 2055 332 334 2054 2055 289 2055 292 292 2055 2054 334 333 335 334 335 336 336 2054 334 335 333 331 336 335 337 331 337 335 336 337 338 338 2053 336 336 2053 2054 292 2054 295 295 2054 2053 338 2052 2053 295 2053 298 298 2053 2052 338 337 339 338 339 340 340 2052 338 331 339 337 340 339 341 341 339 331 340 341 342 342 2051 340 340 2051 2052 298 2052 301 301 2052 2051 342 2050 2051 301 2051 180 180 2051 2050 342 341 343 342 343 344 344 2050 342 331 343 341 344 343 345 331 345 343 344 345 346 346 2049 344 344 2049 2050 180 2050 193 193 2050 2049 346 2048 2049 193 2049 191 191 2049 2048 193 196 197 193 197 180 1156 197 196 180 197 198 1156 198 197 1143 1156 1142 1143 198 1156 180 198 182 198 1143 1145 198 1145 182 1143 1142 1144 1143 1144 1145 1142 675 665 1142 665 1144 1144 665 664 1144 664 1146 1145 1144 1146 1145 1146 1151 182 1145 1151 182 183 180 182 1151 183 1151 1146 1147 1151 1147 1152 183 1151 1152 1146 664 662 1146 662 1147 663 662 664 663 664 665 661 662 663 1147 662 661 1147 661 1148 1152 1147 1148 1152 1148 1153 183 1152 184 184 1152 1153 180 183 184 180 184 181 184 1153 181 1153 1148 1149 1153 1149 1154 181 1153 1154 661 668 1148 1148 668 667 1148 667 1149 663 668 661 657 667 668 663 657 668 657 666 667 1149 667 666 1149 666 1150 1154 1149 1150 1154 1150 1155 181 1154 178 178 1154 1155 178 180 181 178 179 180 178 1155 179 1155 1150 1140 1155 1140 1141 179 1155 1141 177 180 179 177 179 185 179 1141 185 303 301 180 303 180 177 302 301 303 2013 302 303 2013 303 177 300 298 301 300 301 302 2018 300 302 2018 302 2013 2013 2014 2009 2009 2018 2013 177 2014 2013 2009 2017 2018 2017 299 2018 299 300 2018 299 298 300 297 295 298 297 298 299 2017 297 299 296 295 297 296 297 2017 294 292 295 294 295 296 2021 294 296 2021 296 2017 293 292 294 293 294 2021 291 289 292 291 292 293 2020 291 293 2020 293 2021 2017 2020 2021 2017 2019 2020 2019 290 2020 290 291 2020 290 289 291 288 286 289 288 289 290 2019 288 290 2016 2019 2017 2016 287 2019 287 288 2019 287 286 288 285 283 286 285 286 287 2016 285 287 2016 2017 2009 2009 284 2016 284 285 2016 284 283 285 282 280 283 282 283 284 280 2058 283 2009 282 284 281 280 282 281 282 2009 279 277 280 279 280 281 277 2059 280 280 2059 2058 2012 279 281 2012 281 2009 278 277 279 278 279 2012 276 274 277 276 277 278 274 2060 277 277 2060 2059 2030 276 278 2030 278 2012 2009 2011 2012 2011 2030 2012 2011 2029 2030 2029 275 2030 275 276 2030 275 274 276 273 274 275 2029 273 275 2028 2029 2011 2028 272 2029 272 273 2029 272 271 273 273 271 274 270 271 272 2028 270 272 2011 2027 2028 269 2028 2027 269 270 2028 269 268 270 270 268 271 268 2062 271 271 2062 2061 271 2061 274 267 268 269 2027 267 269 274 2061 2060 322 2060 2061 322 2061 320 320 2061 2062 320 2062 318 318 319 320 320 319 321 320 321 322 318 317 319 2009 2010 2011 2010 173 2011 2011 173 172 2008 2010 2009 2010 226 173 226 2010 1939 1939 2010 2008 2008 1957 1958 1939 2008 1950 1950 2008 1958 1939 1940 1941 1939 1941 226 1940 1939 1950 226 227 173 226 1941 227 1940 1938 1941 1941 1938 1942 1941 1942 1945 227 1941 1945 1936 1938 1940 1950 1936 1940 1958 1948 1950 1950 1948 1936 1936 1937 1938 1937 1936 1948 1937 1716 1938 1938 1716 1725 1938 1725 1942 1937 1717 1716 1948 1717 1937 1948 1719 1717 1716 1717 1718 1717 1719 1718 1718 1725 1716 1718 1724 1725 1725 1724 1942 1718 1719 1720 1544 1724 1718 1544 1723 1724 1942 1724 1723 1543 1542 1544 1544 1542 1722 1722 1723 1544 1942 1723 1943 1943 1723 1722 1945 1942 1943 1943 1722 1944 1945 1943 1946 1946 1943 1944 1722 1542 1944 1541 1542 1543 1542 1541 1933 1944 1542 1933 1944 1933 1934 1946 1944 1947 1947 1944 1934 228 1945 1946 228 1946 224 224 1946 1947 227 1945 228 173 227 228 173 228 224 224 225 173 224 1947 225 1947 1934 1935 225 1947 1935 231 173 225 225 1935 231 172 173 174 230 174 173 230 173 231 1935 1924 231 231 1924 230 1934 1920 1935 1935 1920 1924 1923 1924 1920 1924 1923 230 229 174 230 230 1923 229 1920 1922 1923 1923 1922 1925 1923 1925 1929 229 1923 1929 1920 1921 1922 1934 1921 1920 1933 1921 1934 1921 1541 1728 1921 1728 1922 1933 1541 1921 1922 1728 1729 1922 1729 1925 1541 1543 1728 1728 1543 1729 1543 1734 1729 1925 1729 1734 1731 1733 1543 1543 1733 1734 1925 1734 1926 1926 1734 1733 1731 1732 1733 1926 1733 1927 1733 1732 1927 1929 1925 1926 1929 1926 1930 1930 1926 1927 1927 1732 1730 1927 1730 1928 1930 1927 1931 1931 1927 1928 1730 1732 1731 1678 1730 1731 1928 1730 1678 1928 1678 1919 1931 1928 1932 1932 1928 1919 233 1930 1931 233 1931 234 234 1931 1932 1932 1919 1917 234 1932 235 235 1932 1917 1918 1917 1919 1918 1919 1677 1677 1919 1678 1916 236 1917 1916 1917 1918 235 1917 236 234 235 174 174 235 236 174 233 234 229 232 174 174 232 233 174 236 218 218 236 237 237 236 1916 218 237 219 219 237 1916 218 219 220 220 219 1906 1906 219 1916 220 221 218 1905 220 1906 1905 221 220 218 221 222 222 221 1967 1967 221 1905 1905 1906 1879 1967 1905 1968 1968 1905 1879 222 1967 1969 1974 1969 1967 1974 1967 1968 218 222 215 215 222 223 1969 223 222 215 2045 218 213 214 215 215 214 216 215 223 213 1969 213 223 1972 214 213 1972 213 1969 1971 216 214 1971 214 1972 217 216 1971 1970 1971 1972 1979 1971 1970 1970 1972 1973 1973 1972 1969 1973 1969 1974 1888 1970 1973 1888 1973 1889 1974 1876 1973 1973 1876 1890 1973 1890 1889 1888 1889 1878 1878 1889 1890 1878 1890 1876 1876 1877 1878 1877 1876 1885 1885 1876 1887 1974 1887 1876 1878 1891 1888 1877 1901 1878 1878 1901 1902 1878 1902 1891 1885 1900 1877 1877 1900 1901 1900 1686 1901 1901 1686 1685 1901 1685 1902 1902 1685 1688 1902 1688 1903 1891 1902 1903 1888 1891 1892 1891 1903 1892 1903 1688 1605 1903 1605 1904 1892 1903 1904 1604 1605 1688 1688 1685 1604 1685 1686 1683 1604 1685 1683 1562 1603 1604 1604 1603 1605 1604 1683 1562 1904 1605 1603 1892 1904 1894 1904 1603 1894 1888 1892 1893 1893 1892 1894 1893 1970 1888 1893 1894 1895 1893 1895 1970 1895 1894 1909 1909 1894 1603 1562 1602 1603 1909 1603 1910 1910 1603 1602 1909 1910 1979 1979 1970 1909 1909 1970 1895 1910 1602 1911 1979 1910 1911 1201 1601 1602 1201 1602 1562 1911 1602 1601 1562 1683 1708 1562 1708 1565 1682 1672 1683 1682 1683 1684 1683 1686 1687 1683 1687 1684 1672 1670 1683 1899 1682 1684 1899 1684 1900 1684 1687 1900 1900 1687 1686 1885 1899 1900 1898 1682 1899 1883 1898 1899 1883 1899 1885 1884 1883 1885 1884 1885 1886 1885 1887 1886 1882 1881 1883 1882 1883 1884 1881 1898 1883 1974 1882 1884 1974 1884 1886 1886 1887 1974 1968 1882 1974 1879 1881 1882 1968 1879 1882 1879 1880 1881 1880 1897 1881 1881 1897 1898 1906 1880 1879 1880 1896 1897 1906 1896 1880 1896 1680 1897 1897 1680 1681 1897 1681 1898 1896 1674 1680 1907 1674 1896 1907 1896 1906 1906 1916 1907 1675 1674 1907 1907 1916 1918 1907 1918 1675 1673 1674 1671 1671 1674 1675 1680 1674 1673 1680 1673 1681 1671 1672 1673 1681 1673 1672 1671 1670 1672 1671 1675 1676 1731 1671 1676 1676 1675 1677 1675 1918 1677 1676 1677 1678 1731 1676 1678 1681 1672 1682 1898 1681 1682 232 1930 233 229 1929 232 232 1929 1930 410 384 2009 2009 2014 2015 2009 2015 452 2009 417 411 452 457 2009 2009 457 455 2009 455 449 411 413 2009 2009 413 415 2009 415 410 449 423 2009 2009 423 422 2009 422 419 419 418 2009 409 382 410 410 382 384 415 409 410 415 414 409 382 409 1492 382 383 384 1492 383 382 384 383 385 1493 385 383 1493 383 1492 413 412 414 413 414 415 411 412 413 416 412 417 417 412 411 417 438 416 416 438 702 421 419 422 421 422 423 423 449 421 421 449 450 449 455 450 457 458 455 452 454 457 457 454 458 454 1123 458 452 453 454 453 1122 454 454 1122 1123 2015 453 452 1120 1121 453 453 1121 1122 2015 1120 453 651 1123 1122 651 1122 652 652 1122 1121 650 1123 651 650 651 635 635 651 652 635 652 636 652 1121 636 1120 1116 1121 636 1121 637 637 1121 1116 636 637 635 635 637 642 642 637 643 637 1116 643 1114 1115 1116 1114 1116 1120 643 1116 1115 642 643 644 643 1115 644 644 645 642 642 645 646 642 646 639 644 1115 1129 644 1129 645 1129 646 645 639 646 647 646 1137 647 1129 1137 646 1115 1128 1129 1128 1137 1129 647 1137 1138 1136 1138 1137 1136 1137 1133 1133 1137 1128 639 647 641 647 1138 641 641 1138 1132 1134 1132 1138 1134 1138 1136 176 1134 1136 176 1136 186 186 1136 1133 1134 1135 1130 1135 1134 175 175 1134 176 1130 1132 1134 175 176 177 176 186 177 177 186 187 186 1133 187 175 177 185 177 187 188 188 2014 177 185 1135 175 1141 1130 1135 1141 1135 185 1140 1130 1141 1139 1131 1140 1140 1131 1130 1150 1139 1140 658 638 1139 1139 638 1131 1150 658 1139 1130 1131 1132 640 1132 1131 640 1131 638 638 639 640 657 639 638 657 638 658 658 666 657 666 658 1150 655 639 657 670 655 657 670 657 663 640 639 641 641 1132 640 673 670 663 673 663 674 674 663 665 672 670 673 751 672 673 751 673 752 671 670 672 716 671 672 716 672 717 717 672 751 751 914 717 717 914 716 715 671 716 716 914 715 669 670 671 715 669 671 669 463 670 463 655 670 674 665 675 2015 2014 188 188 1118 2015 2015 1118 1117 2015 1117 1114 1114 1120 2015 187 1118 188 1117 1118 1119 1133 1119 1118 187 1133 1118 1117 1119 1114 1114 1119 1115 1115 1119 1128 1133 1128 1119 252 253 254 2033 252 254 251 250 252 252 250 253 251 252 2033 250 2038 253 2004 2007 1174 1174 2007 1172 2007 1169 1170 2007 1170 1172 1172 1173 1174 1174 1173 1175 1174 1175 2004 1170 1171 1172 1172 1171 1173 1169 1168 1170 1170 1168 1171 2004 1175 1177 1177 1179 2004 2004 1179 2003 1161 1179 1162 1179 1161 2003 2003 1161 1160 1160 1161 1162 818 807 814 1532 1557 1558 1532 1558 1559 1559 1794 1532 1532 1794 1796 1557 1771 1558 1559 1558 1560 1770 1560 1558 1770 1558 1771 1559 1560 1547 1547 1793 1559 1559 1793 1794 1547 1560 1561 1769 1561 1560 1769 1560 1770 1547 1548 1549 1547 1561 1548 1549 1792 1547 1547 1792 1793 1792 1638 1793 1793 1638 1618 1793 1618 1794 1791 1634 1792 1634 1636 1792 1792 1636 1638 1549 1791 1792 1636 1637 1638 1638 1637 1639 1638 1639 1618 1634 1635 1636 1636 1635 1637 1632 1633 1634 1634 1633 1635 1791 1632 1634 1551 1791 1549 1549 1550 1551 1550 1552 1551 1551 1552 1553 1549 1548 1550 1766 1552 1550 1766 1550 1767 1767 1550 1548 1765 1553 1552 1765 1552 1766 1764 1553 1765 1755 1764 1765 1755 1765 1758 1758 1765 1766 1758 1766 1757 1757 1766 1767 1767 1548 1768 1757 1767 1760 1760 1767 1768 1768 1548 1561 1768 1561 1769 1758 1497 1755 1755 1497 1496 1756 1764 1755 1754 1763 1756 1756 1763 1764 1754 1762 1763 1632 1630 1633 1698 1633 1630 1698 1635 1633 1698 1578 1577 1698 1577 1700 1700 1635 1698 1700 1637 1635 1702 1637 1700 1577 1576 1700 1700 1576 1575 1700 1575 1702 1221 1576 1577 1221 1577 1195 1195 1577 1578 1195 1578 1196 849 1195 1196 1195 849 1221 1221 849 851 1221 851 1222 1222 1576 1221 1222 1575 1576 851 853 1222 1222 853 855 1222 855 1223 1223 1575 1222 849 850 851 851 850 852 851 852 853 853 852 854 853 854 855 855 854 856 855 856 857 1223 855 857 1223 857 1224 1224 1574 1223 1223 1574 1575 857 856 858 857 858 859 1224 857 1225 1225 857 859 1225 1573 1224 1224 1573 1574 1702 1575 1574 1702 1574 1701 1701 1574 1573 1225 1572 1573 1701 1573 1703 1573 1572 1703 1225 859 1226 1226 1572 1225 1226 1571 1572 1703 1572 1571 1703 1621 1619 1703 1619 1701 1620 1619 1621 1621 1624 1620 1618 1619 1620 1618 1640 1619 1701 1619 1640 1794 1618 1620 1794 1620 1624 1624 1796 1794 1618 1639 1640 1701 1640 1639 1701 1639 1702 1702 1639 1637 935 858 856 935 856 936 936 728 935 936 856 854 936 854 934 934 729 936 936 729 728 478 728 729 478 729 480 480 729 730 934 730 729 480 730 481 730 731 481 731 730 934 932 731 934 934 854 852 934 852 932 932 852 850 628 615 616 615 595 598 615 598 616 593 594 595 594 596 595 595 596 597 595 597 598 590 592 593 593 592 594 592 690 594 594 690 691 594 691 596 596 691 692 596 692 597 590 591 592 592 591 686 588 589 590 589 591 590 686 591 589 686 589 587 588 587 589 585 587 588 583 584 585 610 583 585 580 582 583 583 582 584 609 580 583 609 583 610 622 609 610 608 580 609 621 608 609 621 609 622 510 621 622 620 608 621 510 620 621 574 578 608 608 578 580 620 574 608 576 574 620 511 576 620 511 620 510 510 493 511 511 493 497 511 497 512 512 576 511 492 495 493 493 495 496 493 496 497 497 496 498 497 498 462 512 497 462 495 740 496 496 740 741 496 741 498 492 739 495 495 739 740 737 738 492 492 738 739 927 740 739 927 739 928 739 738 928 926 741 740 926 740 927 928 834 927 927 834 832 927 832 926 928 838 836 928 836 834 928 738 737 833 832 834 833 834 835 835 834 836 831 830 832 831 832 833 926 832 830 1213 831 833 829 830 831 829 831 1213 829 828 830 926 830 925 925 830 828 827 828 829 827 826 828 925 828 826 825 826 827 825 824 826 925 826 924 924 826 824 823 824 825 823 821 824 924 824 923 923 824 821 923 745 924 745 744 924 924 744 743 924 743 925 923 713 712 923 712 714 714 746 923 923 746 745 528 712 713 748 521 713 713 521 529 713 529 528 712 528 714 528 746 714 528 745 746 527 528 461 461 528 529 527 745 528 461 529 515 515 529 521 515 516 461 518 519 515 515 519 520 515 520 516 515 521 518 461 516 517 520 774 516 517 516 776 776 516 774 519 772 520 520 772 774 518 772 519 518 768 772 768 770 772 772 770 773 772 773 774 776 774 756 756 774 773 778 517 776 778 776 779 779 776 756 756 773 775 775 773 770 775 770 777 777 950 775 777 770 769 769 950 777 769 952 950 769 770 764 764 952 769 764 951 952 1474 952 951 946 951 764 1474 951 946 762 763 764 764 770 771 764 771 762 764 763 946 762 761 763 946 763 761 946 761 947 1473 1474 946 1473 946 947 1472 1474 1473 1471 1472 1473 1471 1473 1370 1370 1473 947 947 761 759 947 759 948 1370 947 948 760 759 761 760 761 762 758 757 759 758 759 760 948 759 757 948 757 522 948 1023 1370 522 757 758 522 758 765 765 758 760 765 760 766 766 760 762 766 762 767 767 762 771 523 765 766 523 766 524 524 766 767 522 765 523 521 522 523 523 524 521 521 524 525 524 767 525 525 767 768 767 771 768 768 771 770 525 768 526 526 768 518 521 525 526 518 521 526 748 522 521 747 522 748 1470 1471 1370 1470 1370 1469 1469 1370 1023 1467 1470 1469 1383 1471 1470 1383 1382 1471 1382 1472 1471 1333 1382 1383 1335 1339 1382 1335 1382 1333 1339 1419 1382 1382 1419 1472 1333 1334 1335 1334 1339 1335 1334 1338 1339 1339 1338 1419 1419 1338 1337 1336 1337 1338 1336 1338 1334 1337 1336 1340 1340 1336 1341 1336 139 1341 1469 1023 1034 659 517 778 781 659 778 517 659 514 514 659 660 660 659 781 461 517 514 513 461 514 656 513 514 514 660 656 460 461 462 513 462 461 461 460 527 512 462 513 512 513 539 656 539 513 653 539 656 653 654 539 654 653 1073 654 791 544 544 542 654 654 542 540 654 540 539 791 654 1073 1091 791 1073 1085 791 1091 1085 792 791 790 536 792 792 536 558 792 558 791 789 536 790 536 537 538 538 557 536 536 557 558 789 537 536 557 547 558 558 547 546 791 558 546 535 551 557 557 551 547 538 535 557 562 538 537 562 537 789 788 562 789 1083 788 789 533 534 535 534 552 535 535 552 551 534 533 567 533 531 567 534 576 552 534 567 576 552 553 551 552 576 575 552 575 553 576 567 574 512 575 576 574 572 578 572 577 578 578 577 579 578 579 580 579 581 580 579 682 581 580 581 582 680 1243 682 680 679 1243 1243 679 1244 1243 1244 1245 1244 1368 1245 539 556 575 575 556 555 575 555 554 553 575 554 539 575 512 549 555 556 549 556 548 548 556 539 550 554 555 550 555 549 551 553 554 551 554 550 549 545 550 550 545 547 550 547 551 548 543 549 549 543 545 539 541 548 548 541 543 541 542 543 543 542 544 543 544 545 545 544 546 545 546 547 791 546 544 541 540 542 539 540 541 462 498 499 462 499 460 741 742 498 498 742 743 498 743 499 499 743 744 499 744 460 460 744 745 460 745 527 743 742 925 925 742 741 925 741 926 822 821 823 835 836 837 837 836 838 1216 835 837 1240 1507 1257 696 1240 1257 1826 1740 1752 160 161 155 1261 160 155 160 165 161 2200 161 165 160 164 165 2200 165 2201 2201 165 164 2258 2200 2201 2201 164 2202 2258 2201 2259 2259 2201 2202 142 163 164 142 164 160 2202 164 163 2202 163 2203 2259 2202 2260 2260 2202 2203 2169 2258 2259 2169 2259 2170 2170 2259 2260 2260 2203 2261 2170 2260 2171 2171 2260 2261 2203 163 144 2203 144 2204 2261 2203 2204 144 163 142 142 143 144 143 153 144 2204 144 153 2204 153 2205 2261 2204 2262 2262 2204 2205 2171 2261 2172 2172 2261 2262 2262 2205 2263 2205 153 152 2205 152 2206 2263 2205 2206 143 152 153 116 151 152 116 152 143 2206 152 151 1345 116 1351 1351 116 143 1343 1344 1345 1343 1345 1350 1350 1345 1351 1343 1350 1380 1422 1344 1343 1343 1380 1422 1350 1351 1352 1379 1380 1350 1379 1350 1352 1422 1380 1400 1422 1400 1480 1480 1400 1399 1477 1480 1479 1480 1399 1479 1351 1354 1352 1352 1354 1379 1353 787 1351 1351 787 1354 1351 143 1353 1353 793 787 787 793 800 1353 794 793 796 794 1353 796 1353 1111 1111 1353 1355 1111 1355 1105 1105 1106 1104 1355 1106 1105 1104 1106 1107 1355 1107 1106 1261 1108 1107 1261 1107 1355 1110 1109 1261 1109 1108 1261 1261 1097 1110 1355 160 1261 1098 1109 1110 1098 1110 1097 1355 142 160 1353 143 142 1353 142 1355 2171 2172 2088 2086 2170 2171 2086 2171 2088 2084 2170 2086 2084 2169 2170 2210 141 2211 2211 141 140 2267 2210 2268 2268 2210 2211 69 70 66 66 70 71 69 73 74 69 74 70 71 70 2105 2105 70 74 2105 74 2103 74 73 2103 2103 73 77 2103 77 2101 2156 2157 2072 2156 2246 2157 1284 1291 1390 1434 1390 1435 1283 1291 1284 1432 1434 1431 1431 1428 1432 943 942 1431 1431 942 1428 942 967 1428 1428 967 963 942 943 944 944 967 942 944 963 967 1787 1648 1788 1648 1646 1788 1788 1646 1644 1787 1651 1648 1650 1648 1651 1650 1651 1652 1652 1651 1653 1649 1648 1650 1693 1649 1650 1693 1650 1652 1652 1653 1654 1654 1653 1655 1654 1655 1656 1691 1654 1656 1647 1648 1649 1645 1646 1647 1647 1646 1648 1645 1644 1646 1207 1593 1206 1206 1593 1204 1206 876 1207 1204 879 1206 1206 879 876 1387 1457 1456 1387 1414 1457 2121 2123 47 2123 43 47 47 46 2121 2121 46 50 42 46 47 42 47 43 45 46 42 45 50 46 42 31 45 2298 2299 2300 2303 2302 2298 2303 2298 2304 2304 2298 2300 2298 2302 2353 2298 2353 2299 2301 2302 2303 2304 2754 2303 2303 2754 2755 2303 2755 2301 2300 2753 2304 2304 2753 2754 2753 2582 2754 2582 2580 2754 2754 2580 2590 2754 2590 2755 2755 2590 2589 2755 2589 2756 2301 2755 2756 2579 2589 2590 2579 2590 2580 2579 2580 2581 2581 2580 2582 2588 2589 2579 2579 2836 2588 2581 2835 2579 2579 2835 2836 2588 2587 2589 2756 2589 2587 2586 2587 2588 2588 2836 2837 2588 2837 2586 2835 2760 2836 2836 2760 2761 2836 2761 2837 2910 2759 2835 2835 2759 2760 2581 2910 2835 2759 2467 2760 2760 2467 2466 2760 2466 2761 2761 2466 2449 2761 2449 2762 2837 2761 2762 2449 2466 2447 2447 2466 2467 2447 2467 2468 2759 2468 2467 2834 2468 2759 2910 2834 2759 2468 2486 2447 2834 2486 2468 2833 2486 2834 2909 2833 2834 2909 2834 2910 2447 2486 2487 2833 2487 2486 2832 2487 2833 2908 2832 2833 2908 2833 2909 2598 2908 2909 2598 2909 2583 2583 2909 2910 2907 2832 2908 2591 2907 2908 2591 2908 2598 2583 2597 2598 2598 2597 2599 2598 2599 2591 2591 2592 2593 2591 2599 2600 2591 2600 2592 2593 2907 2591 2751 2600 2599 2751 2599 2752 2599 2597 2752 2583 2596 2597 2752 2597 2596 2752 2596 2753 2310 2751 2752 2310 2752 2300 2300 2752 2753 2750 2600 2751 2309 2750 2751 2309 2751 2310 2750 2592 2600 2749 2594 2750 2594 2592 2750 2308 2749 2750 2308 2750 2309 2305 2308 2309 2305 2309 2299 2299 2309 2310 2299 2310 2300 2353 2305 2299 2305 2306 2307 2307 2308 2305 2353 2306 2305 2307 2749 2308 2306 2316 2307 2316 2748 2307 2307 2748 2749 2306 2315 2316 2315 2747 2316 2316 2747 2748 2747 2609 2748 2609 2607 2748 2748 2607 2606 2748 2606 2749 2745 2610 2747 2747 2610 2609 2315 2745 2747 2608 2607 2609 2608 2609 2601 2601 2609 2610 2595 2606 2607 2595 2607 2608 2594 2606 2595 2749 2606 2594 2593 2594 2595 2608 2905 2595 2595 2905 2906 2595 2906 2593 2601 2904 2608 2608 2904 2905 2904 2829 2905 2905 2829 2830 2905 2830 2906 2906 2830 2831 2906 2831 2907 2593 2906 2907 2593 2592 2594 2907 2831 2832 2830 2490 2831 2831 2490 2488 2831 2488 2832 2829 2420 2830 2830 2420 2490 2420 2447 2490 2490 2447 2488 2447 2487 2488 2832 2488 2487 2447 2448 2449 2447 2461 2448 2420 2489 2447 2775 2461 2447 2775 2447 2776 2776 2447 2489 2762 2449 2448 2762 2448 2763 2837 2762 2838 2838 2762 2763 2763 2448 2485 2763 2485 2764 2838 2763 2839 2839 2763 2764 2586 2837 2838 2586 2838 2578 2578 2838 2839 2839 2764 2840 2578 2839 2576 2576 2839 2840 2764 2485 2484 2764 2484 2765 2840 2764 2765 2448 2484 2485 2448 2483 2484 2765 2484 2483 2765 2483 2766 2840 2765 2841 2841 2765 2766 2576 2840 2573 2573 2840 2841 2841 2766 2842 2573 2841 2571 2571 2841 2842 2766 2483 2482 2766 2482 2767 2842 2766 2767 2482 2483 2448 2448 2481 2482 2767 2482 2481 2767 2481 2768 2842 2767 2843 2843 2767 2768 2571 2842 2568 2568 2842 2843 2843 2768 2844 2568 2843 2566 2566 2843 2844 2768 2481 2480 2768 2480 2769 2844 2768 2769 2448 2480 2481 2479 2480 2448 2769 2480 2479 2769 2479 2770 2844 2769 2845 2845 2769 2770 2566 2844 2563 2563 2844 2845 2845 2770 2846 2563 2845 2561 2561 2845 2846 2770 2479 2478 2770 2478 2771 2846 2770 2771 2448 2478 2479 2448 2477 2478 2771 2478 2477 2771 2477 2772 2846 2771 2847 2847 2771 2772 2561 2846 2558 2558 2846 2847 2847 2772 2848 2558 2847 2556 2556 2847 2848 2772 2477 2463 2772 2463 2773 2848 2772 2773 2463 2477 2448 2448 2462 2463 2773 2463 2462 2773 2462 2774 2848 2773 2849 2849 2773 2774 2556 2848 2553 2553 2848 2849 2849 2774 2850 2553 2849 2551 2551 2849 2850 2774 2462 2461 2774 2461 2775 2850 2774 2775 2448 2461 2462 2850 2775 2851 2851 2775 2776 2551 2850 2548 2548 2850 2851 2548 2550 2551 2551 2550 2552 2551 2552 2553 2546 2547 2548 2547 2549 2548 2548 2549 2550 2548 2851 2546 2851 2776 2852 2546 2851 2852 2776 2489 2777 2852 2776 2777 2852 2777 2853 2546 2852 2543 2543 2852 2853 2543 2545 2546 2546 2545 2547 2549 2547 2693 2693 2547 2545 2692 2550 2549 2692 2549 2693 2693 2545 2694 2393 2692 2693 2393 2693 2394 2394 2693 2694 2543 2544 2545 2694 2545 2544 2694 2544 2695 2394 2694 2391 2391 2694 2695 2390 2393 2394 2390 2394 2391 2392 2393 2390 2392 2401 2393 2401 2692 2393 2389 2388 2390 2389 2390 2391 2365 2392 2390 2390 2388 2365 2391 2695 2389 2387 2388 2389 2389 2695 2696 2389 2696 2387 2387 2384 2388 2365 2388 2384 2382 2384 2387 2387 2696 2697 2387 2697 2382 2695 2540 2696 2696 2540 2539 2696 2539 2697 2697 2539 2537 2697 2537 2535 2535 2699 2697 2382 2697 2699 2382 2383 2384 2382 2699 2383 2535 2698 2699 2383 2699 2698 2527 2534 2535 2527 2535 2536 2536 2535 2537 2534 2698 2535 2536 2537 2538 2537 2539 2538 2538 2539 2540 2538 2540 2541 2541 2854 2538 2538 2854 2855 2538 2855 2536 2536 2855 2856 2536 2856 2527 2854 2779 2855 2855 2779 2780 2855 2780 2856 2853 2778 2854 2854 2778 2779 2541 2853 2854 2778 2456 2779 2779 2456 2455 2779 2455 2780 2780 2455 2429 2780 2429 2781 2856 2780 2781 2429 2455 2420 2420 2455 2456 2420 2456 2457 2778 2457 2456 2777 2457 2778 2853 2777 2778 2543 2853 2541 2541 2542 2543 2542 2544 2543 2541 2540 2542 2544 2542 2695 2695 2542 2540 2777 2489 2457 2457 2489 2420 2415 2417 2420 2420 2417 2421 2420 2421 2422 2422 2423 2420 2420 2423 2424 2420 2424 2425 2426 2427 2420 2420 2427 2428 2420 2428 2429 2425 2445 2420 2420 2445 2446 2420 2446 2426 2829 2415 2420 2781 2429 2428 2781 2428 2782 2782 2428 2427 2856 2781 2857 2857 2781 2782 2782 2427 2783 2857 2782 2858 2858 2782 2783 2527 2856 2857 2527 2857 2528 2528 2857 2858 2858 2783 2859 2528 2858 2531 2531 2858 2859 2783 2427 2426 2783 2426 2784 2859 2783 2784 2859 2784 2860 2531 2859 2520 2520 2859 2860 2520 2530 2531 2531 2530 2532 2531 2532 2528 2518 2519 2520 2519 2529 2520 2520 2529 2530 2520 2860 2518 2701 2532 2530 2701 2530 2529 2528 2532 2533 2533 2532 2701 2526 2527 2528 2528 2533 2526 2698 2526 2533 2698 2533 2700 2700 2533 2701 2526 2534 2527 2534 2526 2698 2383 2698 2385 2385 2698 2700 2385 2700 2386 2386 2700 2701 2384 2383 2385 2384 2385 2379 2379 2385 2386 2379 2386 2380 2386 2701 2380 2379 2380 2376 2365 2384 2379 2379 2376 2365 2376 2380 2381 2380 2701 2703 2380 2703 2381 2529 2703 2701 2529 2702 2703 2381 2703 2702 2376 2381 2377 2381 2702 2377 2376 2377 2371 2365 2376 2371 2371 2377 2378 2377 2702 2704 2377 2704 2378 2371 2372 2373 2371 2378 2372 2365 2371 2366 2366 2371 2373 2378 2704 2705 2378 2705 2372 2702 2525 2704 2704 2525 2705 2525 2524 2705 2705 2524 2522 2705 2522 2521 2521 2707 2705 2372 2705 2707 2516 2524 2525 2516 2525 2517 2702 2517 2525 2523 2522 2524 2523 2524 2516 2510 2521 2522 2510 2522 2523 2516 2862 2523 2523 2862 2863 2523 2863 2510 2508 2509 2510 2509 2521 2510 2510 2863 2864 2510 2864 2508 2862 2787 2863 2863 2787 2788 2863 2788 2864 2864 2788 2789 2864 2789 2865 2508 2864 2865 2787 2424 2788 2788 2424 2423 2788 2423 2789 2786 2425 2787 2787 2425 2424 2862 2786 2787 2785 2445 2786 2786 2445 2425 2861 2785 2786 2861 2786 2862 2516 2861 2862 2860 2785 2861 2518 2860 2861 2518 2861 2516 2784 2446 2785 2785 2446 2445 2860 2784 2785 2784 2426 2446 2516 2517 2518 2518 2517 2519 2519 2517 2702 2519 2702 2529 2789 2423 2422 2789 2422 2790 2865 2789 2790 2790 2422 2421 2790 2421 2791 2865 2790 2866 2866 2790 2791 2508 2865 2506 2506 2865 2866 2866 2791 2867 2506 2866 2513 2513 2866 2867 2791 2421 2417 2791 2417 2792 2867 2791 2792 2867 2792 2868 2513 2867 2500 2500 2867 2868 2500 2512 2513 2513 2512 2514 2513 2514 2506 2498 2499 2500 2499 2511 2500 2500 2511 2512 2500 2868 2498 2514 2512 2709 2709 2512 2511 2506 2514 2515 2708 2515 2514 2708 2514 2709 2709 2511 2710 2367 2708 2709 2367 2709 2368 2368 2709 2710 2710 2511 2499 2710 2499 2711 2368 2710 2369 2369 2710 2711 2367 2368 2365 2365 2368 2369 2365 2366 2367 2366 2375 2367 2375 2708 2367 2373 2374 2366 2366 2374 2375 2374 2706 2375 2375 2706 2708 2373 2372 2374 2372 2707 2374 2374 2707 2706 2521 2706 2707 2509 2706 2521 2509 2507 2706 2706 2507 2515 2706 2515 2708 2508 2507 2509 2506 2507 2508 2506 2515 2507 2365 2369 2360 2360 2407 2365 2407 2405 2365 2365 2405 2403 2365 2403 2397 2397 2399 2365 2365 2399 2392 2360 2369 2370 2369 2711 2370 2360 2370 2361 2370 2711 2712 2370 2712 2361 2499 2497 2711 2711 2497 2505 2711 2505 2712 2712 2505 2504 2712 2504 2713 2361 2712 2713 2496 2504 2505 2496 2505 2497 2496 2497 2498 2498 2497 2499 2503 2504 2496 2498 2869 2496 2496 2869 2870 2496 2870 2503 2503 2502 2504 2504 2502 2713 2495 2502 2503 2503 2870 2871 2503 2871 2495 2869 2794 2870 2870 2794 2795 2870 2795 2871 2871 2795 2796 2871 2796 2872 2495 2871 2872 2794 2472 2795 2795 2472 2476 2795 2476 2796 2793 2460 2794 2794 2460 2472 2869 2793 2794 2792 2444 2793 2793 2444 2460 2868 2792 2793 2868 2793 2869 2498 2868 2869 2792 2417 2444 2417 2443 2444 2444 2443 2460 2417 2442 2443 2460 2443 2469 2804 2469 2443 2804 2443 2805 2805 2443 2442 2441 2442 2417 2805 2442 2806 2806 2442 2441 2880 2804 2805 2880 2805 2881 2881 2805 2806 2803 2469 2804 2879 2803 2804 2879 2804 2880 2666 2879 2880 2666 2880 2663 2663 2880 2881 2881 2806 2882 2663 2881 2661 2661 2881 2882 2661 2662 2663 2662 2664 2663 2663 2664 2665 2663 2665 2666 2658 2660 2661 2661 2660 2662 2661 2882 2658 2664 2662 2724 2724 2662 2660 2723 2665 2664 2723 2664 2724 2666 2665 2667 2722 2667 2665 2722 2665 2723 2351 2722 2723 2351 2723 2352 2352 2723 2724 2724 2660 2725 2352 2724 2343 2343 2724 2725 2342 2351 2352 2342 2352 2343 2347 2350 2351 2347 2351 2342 2350 2722 2351 2341 2342 2343 2342 2306 2347 2342 2341 2306 2343 2344 2341 2343 2725 2344 2341 2344 2345 2341 2345 2336 2306 2341 2336 2344 2725 2726 2344 2726 2345 2336 2345 2346 2345 2726 2727 2345 2727 2346 2335 2336 2337 2336 2346 2337 2306 2336 2335 2346 2727 2728 2346 2728 2337 2726 2655 2727 2727 2655 2654 2727 2654 2728 2654 2652 2728 2728 2652 2650 2728 2650 2729 2337 2728 2729 2337 2338 2335 2337 2729 2338 2729 2650 2649 2729 2649 2730 2338 2729 2730 2648 2649 2650 2648 2650 2651 2651 2650 2652 2651 2652 2653 2652 2654 2653 2653 2654 2655 2653 2655 2656 2656 2884 2653 2653 2884 2885 2653 2885 2651 2651 2885 2886 2651 2886 2648 2884 2809 2885 2885 2809 2810 2885 2810 2886 2883 2808 2884 2884 2808 2809 2656 2883 2884 2808 2439 2809 2809 2439 2438 2809 2438 2810 2810 2438 2454 2810 2454 2811 2886 2810 2811 2438 2439 2417 2417 2454 2438 2417 2439 2440 2808 2440 2439 2807 2440 2808 2883 2807 2808 2417 2440 2441 2807 2441 2440 2806 2441 2807 2882 2806 2807 2882 2807 2883 2658 2882 2883 2656 2657 2658 2657 2659 2658 2658 2659 2660 2658 2883 2656 2656 2655 2657 2659 2657 2726 2726 2657 2655 2725 2660 2659 2725 2659 2726 2415 2416 2417 2417 2416 2418 2417 2418 2419 2419 2430 2417 2417 2430 2431 2417 2431 2432 2432 2433 2417 2417 2433 2434 2417 2434 2435 2417 2436 2437 2435 2450 2417 2417 2450 2451 2417 2451 2452 2437 2453 2417 2417 2453 2454 2452 2464 2417 2417 2464 2465 2417 2465 2436 2816 2464 2452 2816 2452 2817 2817 2452 2451 2815 2465 2464 2815 2464 2816 2814 2436 2465 2814 2465 2815 2890 2814 2815 2890 2815 2891 2891 2815 2816 2891 2816 2892 2892 2816 2817 2638 2890 2891 2638 2891 2636 2636 2891 2892 2889 2814 2890 2641 2889 2890 2641 2890 2638 2636 2637 2638 2637 2639 2638 2638 2639 2640 2638 2640 2641 2633 2635 2636 2636 2635 2637 2636 2892 2633 2639 2637 2734 2734 2637 2635 2733 2640 2639 2733 2639 2734 2641 2640 2642 2732 2642 2640 2732 2640 2733 2331 2732 2733 2331 2733 2332 2332 2733 2734 2734 2635 2735 2332 2734 2333 2333 2734 2735 2331 2332 2329 2329 2332 2333 2329 2330 2331 2330 2340 2331 2340 2732 2331 2329 2333 2324 2306 2330 2329 2306 2329 2324 2324 2333 2334 2333 2735 2334 2323 2324 2325 2324 2334 2325 2324 2323 2306 2334 2735 2736 2334 2736 2325 2325 2326 2323 2325 2736 2738 2325 2738 2326 2323 2326 2327 2323 2327 2318 2306 2323 2318 2326 2738 2737 2326 2737 2327 2630 2737 2738 2630 2738 2736 2629 2737 2630 2629 2621 2737 2737 2621 2628 2737 2628 2739 2327 2737 2739 2318 2327 2328 2327 2739 2328 2739 2628 2740 2328 2739 2740 2623 2627 2628 2623 2628 2621 2628 2627 2740 2621 2622 2623 2621 2629 2622 2622 2629 2630 2622 2630 2631 2631 2894 2622 2622 2894 2895 2622 2895 2623 2626 2627 2623 2623 2895 2896 2623 2896 2626 2626 2625 2627 2740 2627 2625 2615 2625 2626 2626 2896 2897 2626 2897 2615 2895 2820 2896 2896 2820 2821 2896 2821 2897 2894 2819 2895 2895 2819 2820 2819 2435 2820 2820 2435 2434 2820 2434 2821 2821 2434 2433 2821 2433 2822 2897 2821 2822 2897 2822 2898 2615 2897 2898 2822 2433 2432 2822 2432 2823 2898 2822 2823 2898 2823 2899 2615 2898 2613 2613 2898 2899 2823 2432 2431 2823 2431 2824 2899 2823 2824 2899 2824 2900 2613 2899 2611 2611 2899 2900 2611 2612 2613 2613 2612 2614 2613 2614 2615 2614 2624 2615 2615 2624 2625 2614 2741 2624 2614 2612 2741 2611 2620 2612 2741 2612 2620 2624 2741 2742 2741 2620 2743 2320 2742 2741 2320 2741 2321 2321 2741 2743 2740 2625 2624 2624 2742 2740 2319 2740 2742 2319 2742 2320 2319 2320 2317 2317 2320 2321 2317 2321 2312 2312 2321 2322 2321 2743 2322 2743 2620 2744 2322 2743 2744 2312 2322 2313 2322 2744 2313 2311 2312 2313 2311 2317 2312 2317 2318 2319 2306 2317 2311 2306 2318 2317 2313 2314 2311 2311 2314 2315 2311 2315 2306 2313 2744 2746 2313 2746 2314 2314 2746 2745 2314 2745 2315 2616 2745 2746 2616 2746 2744 2604 2745 2616 2604 2602 2745 2745 2602 2610 2604 2616 2605 2605 2616 2617 2744 2617 2616 2603 2602 2604 2603 2604 2605 2601 2602 2603 2601 2610 2602 2605 2902 2603 2603 2902 2903 2603 2903 2601 2601 2903 2904 2902 2827 2903 2903 2827 2828 2903 2828 2904 2901 2826 2902 2902 2826 2827 2605 2901 2902 2826 2418 2827 2827 2418 2416 2827 2416 2828 2828 2416 2415 2828 2415 2829 2904 2828 2829 2826 2419 2418 2825 2419 2826 2901 2825 2826 2825 2430 2419 2824 2430 2825 2900 2824 2825 2900 2825 2901 2824 2431 2430 2618 2900 2901 2618 2901 2605 2611 2900 2618 2605 2617 2618 2618 2617 2619 2618 2619 2611 2611 2619 2620 2620 2619 2744 2744 2619 2617 2347 2306 2348 2348 2306 2353 2335 2330 2306 2347 2348 2349 2349 2350 2347 2353 2357 2348 2348 2357 2358 2348 2358 2349 2358 2720 2349 2349 2720 2721 2349 2721 2350 2350 2721 2722 2720 2670 2721 2721 2670 2669 2721 2669 2722 2669 2667 2722 2667 2669 2668 2668 2669 2670 2668 2670 2671 2671 2670 2672 2720 2672 2670 2666 2667 2668 2671 2878 2668 2668 2878 2879 2668 2879 2666 2671 2672 2673 2673 2877 2671 2671 2877 2878 2672 2674 2673 2674 2672 2720 2673 2674 2675 2673 2675 2676 2676 2876 2673 2673 2876 2877 2876 2801 2877 2877 2801 2802 2877 2802 2878 2875 2800 2876 2876 2800 2801 2676 2875 2876 2676 2675 2677 2676 2677 2678 2678 2875 2676 2874 2799 2875 2875 2799 2800 2678 2874 2875 2799 2471 2800 2800 2471 2470 2800 2470 2801 2798 2473 2799 2799 2473 2471 2874 2798 2799 2873 2798 2874 2491 2873 2874 2491 2874 2678 2797 2474 2798 2798 2474 2473 2873 2797 2798 2472 2471 2473 2473 2474 2472 2472 2474 2475 2797 2475 2474 2796 2475 2797 2872 2796 2797 2872 2797 2873 2493 2872 2873 2493 2873 2491 2495 2872 2493 2491 2492 2493 2493 2492 2494 2493 2494 2495 2494 2501 2495 2495 2501 2502 2714 2501 2494 2714 2494 2715 2494 2492 2715 2491 2680 2492 2715 2492 2680 2715 2680 2716 2363 2714 2715 2363 2715 2364 2364 2715 2716 2491 2679 2680 2716 2680 2679 2678 2679 2491 2678 2677 2679 2716 2679 2717 2717 2679 2677 2364 2716 2355 2355 2716 2717 2354 2363 2364 2354 2364 2355 2353 2354 2355 2355 2356 2353 2355 2717 2356 2717 2677 2718 2356 2717 2718 2718 2677 2675 2718 2675 2719 2356 2718 2357 2357 2718 2719 2353 2356 2357 2302 2412 2353 2353 2412 2407 2353 2407 2354 2301 2410 2302 2302 2410 2411 2302 2411 2412 2412 2411 2413 2412 2413 2407 2410 2757 2411 2411 2757 2758 2411 2758 2413 2301 2756 2410 2410 2756 2757 2756 2587 2757 2757 2587 2585 2757 2585 2758 2758 2585 2584 2758 2584 2681 2413 2758 2681 2407 2413 2414 2413 2681 2414 2681 2575 2682 2681 2584 2577 2681 2577 2575 2414 2681 2682 2577 2584 2578 2578 2584 2585 2578 2585 2586 2586 2585 2587 2576 2577 2578 2576 2575 2577 2573 2574 2575 2573 2575 2576 2682 2575 2574 2571 2572 2573 2572 2574 2573 2682 2574 2683 2574 2572 2683 2571 2570 2572 2683 2572 2570 2568 2570 2571 2568 2569 2570 2683 2570 2684 2684 2570 2569 2408 2682 2683 2408 2683 2409 2409 2683 2684 2684 2569 2685 2409 2684 2406 2406 2684 2685 2567 2569 2568 2569 2567 2685 2566 2567 2568 2566 2565 2567 2685 2567 2565 2685 2565 2686 2406 2685 2404 2404 2685 2686 2404 2405 2406 2405 2409 2406 2405 2408 2409 2404 2403 2405 2407 2408 2405 2402 2403 2404 2404 2686 2402 2402 2397 2403 2395 2397 2402 2402 2686 2687 2402 2687 2395 2395 2396 2397 2397 2396 2398 2397 2398 2399 2395 2687 2688 2395 2688 2396 2396 2688 2689 2396 2689 2398 2399 2398 2400 2398 2689 2690 2398 2690 2400 2399 2400 2392 2392 2400 2401 2400 2690 2691 2400 2691 2401 2689 2555 2690 2690 2555 2554 2690 2554 2691 2554 2552 2691 2691 2552 2550 2691 2550 2692 2401 2691 2692 2552 2554 2553 2553 2554 2555 2553 2555 2556 2556 2555 2557 2689 2557 2555 2556 2557 2558 2557 2559 2558 2559 2557 2689 2688 2559 2689 2558 2559 2560 2688 2560 2559 2558 2560 2561 2561 2560 2562 2687 2562 2560 2687 2560 2688 2561 2562 2563 2562 2564 2563 2564 2562 2687 2686 2564 2687 2563 2564 2565 2686 2565 2564 2563 2565 2566 2407 2414 2408 2414 2682 2408 2359 2407 2360 2354 2407 2359 2359 2360 2361 2361 2362 2359 2359 2362 2363 2359 2363 2354 2361 2713 2362 2362 2713 2714 2362 2714 2363 2713 2502 2501 2713 2501 2714 2357 2719 2358 2719 2675 2674 2719 2674 2720 2358 2719 2720 2796 2476 2475 2472 2475 2476 2460 2471 2472 2458 2459 2460 2460 2469 2458 2459 2470 2460 2460 2470 2471 2802 2459 2458 2802 2458 2803 2803 2458 2469 2801 2470 2459 2801 2459 2802 2878 2802 2803 2878 2803 2879 2335 2339 2330 2330 2339 2340 2335 2338 2339 2338 2730 2339 2339 2730 2731 2339 2731 2340 2340 2731 2732 2730 2645 2731 2731 2645 2644 2731 2644 2732 2649 2647 2730 2730 2647 2645 2643 2644 2645 2643 2645 2646 2646 2645 2647 2642 2644 2643 2644 2642 2732 2641 2642 2643 2646 2888 2643 2643 2888 2889 2643 2889 2641 2646 2647 2648 2648 2887 2646 2646 2887 2888 2647 2649 2648 2648 2886 2887 2886 2811 2887 2887 2811 2812 2887 2812 2888 2888 2812 2813 2888 2813 2889 2889 2813 2814 2812 2437 2813 2813 2437 2436 2813 2436 2814 2811 2453 2812 2812 2453 2437 2811 2454 2453 2318 2328 2319 2328 2740 2319 2819 2450 2435 2818 2450 2819 2894 2818 2819 2818 2451 2450 2817 2451 2818 2893 2817 2818 2893 2818 2894 2631 2893 2894 2892 2817 2893 2633 2892 2893 2633 2893 2631 2631 2630 2632 2631 2632 2633 2632 2634 2633 2633 2634 2635 2736 2634 2632 2736 2632 2630 2735 2635 2634 2735 2634 2736 2753 2596 2582 2582 2596 2583 2581 2582 2583 2583 2910 2581 2911 2912 2913 2985 2986 2911 2911 2986 2912 2913 2991 2911 2911 2991 2993 2911 2993 2985 2983 2984 2985 2985 2984 2986 2985 2993 2995 2985 2995 2983 2984 2994 2986 2986 2994 2992 2986 2992 2912 2983 2982 2984 2982 2996 2984 2984 2996 2994 2993 2992 2994 2993 2994 2995 2995 2994 2996 2991 2992 2993 2991 2990 2992 2912 2992 2990 2989 2988 2990 2989 2990 2991 2912 2990 2914 2914 2990 2988 2913 2912 2914 2913 2914 2915 2915 2914 2916 2914 2988 2916 2987 2988 2989 2987 3062 2988 2916 2988 3062 2915 2916 2917 2917 2916 2918 2916 3062 2918 2917 2987 2915 2915 2987 2989 2915 2989 2913 2913 2989 2991 3061 3062 2987 2917 3061 2987 3061 3060 3062 2918 3062 3060 2917 2918 2919 2919 2918 2920 2918 3060 2920 2919 3061 2917 3059 3060 3061 2919 3059 3061 3059 3058 3060 2920 3060 3058 2919 2920 2921 2921 2920 2922 2920 3058 2922 2921 3059 2919 3057 3058 3059 2921 3057 3059 3057 3056 3058 2922 3058 3056 2921 2922 2923 2923 2922 2924 2922 3056 2924 2923 3057 2921 3055 3056 3057 2923 3055 3057 3055 3054 3056 2924 3056 3054 2923 2924 2925 2925 2924 2926 2924 3054 2926 2925 3055 2923 3053 3054 3055 2925 3053 3055 3053 3052 3054 2926 3054 3052 2925 2926 2927 2927 2926 2928 2926 3052 2928 2927 3053 2925 3051 3052 3053 2927 3051 3053 3051 3050 3052 2928 3052 3050 2927 2928 2929 2929 2928 2930 2928 3050 2930 2929 3051 2927 3049 3050 3051 2929 3049 3051 3049 3048 3050 2930 3050 3048 2929 2930 2931 2931 2930 2932 2930 3048 2932 2931 3049 2929 3047 3048 3049 2931 3047 3049 3047 3046 3048 2932 3048 3046 2931 2932 2933 2933 2932 2934 2932 3046 2934 2933 3047 2931 3045 3046 3047 2933 3045 3047 3045 3044 3046 2934 3046 3044 2933 2934 2935 2935 2934 2936 2934 3044 2936 2935 3045 2933 3043 3044 3045 2935 3043 3045 3043 3042 3044 2936 3044 3042 2935 2936 2937 2937 2936 2938 2936 3042 2938 2937 3043 2935 3041 3042 3043 2937 3041 3043 3041 3040 3042 2938 3042 3040 2937 2938 2939 2939 2938 2940 2938 3040 2940 2939 3041 2937 3039 3040 3041 2939 3039 3041 3039 3038 3040 2940 3040 3038 2939 2940 2941 2941 2940 2942 2940 3038 2942 2941 3039 2939 3037 3038 3039 2941 3037 3039 3037 3036 3038 2942 3038 3036 2941 2942 2943 2943 2942 2944 2942 3036 2944 2943 3037 2941 3035 3036 3037 2943 3035 3037 3035 3034 3036 2944 3036 3034 2943 2944 2945 2945 2944 2946 2944 3034 2946 2945 3035 2943 3033 3034 3035 2945 3033 3035 3033 3032 3034 2946 3034 3032 2945 2946 2947 2947 2946 2948 2946 3032 2948 2947 3033 2945 3031 3032 3033 2947 3031 3033 3031 3030 3032 2948 3032 3030 2947 2948 2949 2949 2948 2950 2948 3030 2950 2949 3031 2947 3029 3030 3031 2949 3029 3031 3029 3028 3030 2950 3030 3028 2949 2950 2951 2951 2950 2952 2950 3028 2952 2951 3029 2949 3027 3028 3029 2951 3027 3029 3027 3026 3028 2952 3028 3026 2951 2952 2953 2953 2952 2954 2952 3026 2954 2953 3027 2951 3025 3026 3027 2953 3025 3027 3025 3024 3026 2954 3026 3024 2953 2954 2955 2955 2954 2956 2954 3024 2956 2955 3025 2953 3023 3024 3025 2955 3023 3025 3023 3022 3024 2956 3024 3022 2955 2956 2957 2957 2956 2958 2956 3022 2958 2957 3023 2955 3021 3022 3023 2957 3021 3023 3021 3020 3022 2958 3022 3020 2957 2958 2959 2959 2958 2960 2958 3020 2960 2959 3021 2957 3019 3020 3021 2959 3019 3021 3019 3018 3020 2960 3020 3018 2959 2960 2961 2961 2960 2962 2960 3018 2962 2961 3019 2959 3017 3018 3019 2961 3017 3019 3017 3016 3018 2962 3018 3016 2961 2962 2963 2963 2962 2964 2962 3016 2964 2963 3017 2961 3015 3016 3017 2963 3015 3017 3015 3014 3016 2964 3016 3014 2963 2964 2965 2965 2964 2966 2964 3014 2966 2965 3015 2963 3013 3014 3015 2965 3013 3015 3013 3012 3014 2966 3014 3012 2965 2966 2967 2967 2966 2968 2966 3012 2968 2967 3013 2965 3011 3012 3013 2967 3011 3013 3011 3010 3012 2968 3012 3010 2967 2968 2969 2969 2968 2970 2968 3010 2970 2969 3011 2967 3009 3010 3011 2969 3009 3011 3009 3008 3010 2970 3010 3008 2969 2970 2971 2971 2970 2972 2970 3008 2972 2971 3009 2969 3007 3008 3009 2971 3007 3009 3007 3006 3008 2972 3008 3006 2971 2972 2973 2973 2972 2974 2972 3006 2974 2973 3007 2971 3005 3006 3007 2973 3005 3007 3005 3004 3006 2974 3006 3004 2973 2974 2975 2975 2974 2976 2974 3004 2976 2975 3005 2973 3003 3004 3005 2975 3003 3005 3003 3002 3004 2976 3004 3002 2975 2976 2977 2977 2976 2978 2976 3002 2978 2977 3003 2975 3001 3002 3003 2977 3001 3003 3001 3000 3002 2978 3002 3000 2977 2978 2979 2979 2978 2980 2978 3000 2980 2979 3001 2977 2999 3000 3001 2979 2999 3001 2999 2998 3000 2980 3000 2998 2979 2980 2981 2981 2980 2982 2980 2998 2982 2981 2999 2979 2997 2998 2999 2981 2997 2999 2997 2996 2998 2982 2998 2996 2981 2982 2983 2983 2997 2981 2995 2996 2997 2983 2995 2997))
                   (list :vertices (let ((mat (make-matrix 3063 3))) (fvector-replace (array-entity mat) #f(-2.0000000000000000e+02 -1.0458499908447266e+01 4.5821598052978516e+01 -2.0000000000000000e+02 -2.0392499923706055e+01 4.2345500946044922e+01 -2.0200000000000000e+02 -2.0279201507568359e+01 4.2100502014160156e+01 -2.0200000000000000e+02 -5.0815896987915039e+00 4.6724399566650391e+01 -2.0000000000000000e+02 0.0000000000000000e+00 4.7000000000000000e+01 -2.0200000000000000e+02 -1.0399499893188477e+01 4.5553901672363281e+01 -2.0200000000000000e+02 -1.5007100105285645e+01 4.4539699554443359e+01 -2.0000000000000000e+02 -2.9303998947143555e+01 3.6746101379394531e+01 -2.0000000000000000e+02 -3.6746101379394531e+01 2.9303998947143555e+01 -2.0200000000000000e+02 -3.6553199768066406e+01 2.9140199661254883e+01 -2.0200000000000000e+02 -3.2321899414062500e+01 3.4121700286865234e+01 -2.0200000000000000e+02 -2.9144899368286133e+01 3.6536800384521484e+01 -2.0200000000000000e+02 -2.4230998992919922e+01 4.0272197723388672e+01 -2.0000000000000000e+02 -4.2345500946044922e+01 2.0392499923706055e+01 -2.0000000000000000e+02 -4.5821598052978516e+01 1.0458499908447266e+01 -2.0200000000000000e+02 -4.5604900360107422e+01 1.0398300170898438e+01 -2.0200000000000000e+02 -4.3661899566650391e+01 1.7396499633789062e+01 -2.0200000000000000e+02 -4.2133098602294922e+01 2.0279899597167969e+01 -2.0200000000000000e+02 -3.8901298522949219e+01 2.6375801086425781e+01 -2.0000000000000000e+02 -4.7000000000000000e+01 0.0000000000000000e+00 -2.0000000000000000e+02 -4.5821598052978516e+01 -1.0458499908447266e+01 -2.0200000000000000e+02 -4.5638599395751953e+01 -1.0428400039672852e+01 -2.0200000000000000e+02 -4.6930999755859375e+01 -2.5445199012756348e+00 -2.0200000000000000e+02 -4.6793701171875000e+01 -1.1184399947524071e-02 -2.0200000000000000e+02 -4.6380798339843750e+01 7.6036996841430664e+00 -2.0000000000000000e+02 -4.2345500946044922e+01 -2.0392499923706055e+01 -2.0000000000000000e+02 -3.6746101379394531e+01 -2.9303998947143555e+01 -2.0200000000000000e+02 -3.6634399414062500e+01 -2.9228300094604492e+01 -2.0200000000000000e+02 -4.1525100708007812e+01 -2.2015201568603516e+01 -2.0200000000000000e+02 -4.2195400238037109e+01 -2.0332698822021484e+01 -2.0200000000000000e+02 -4.5286800384521484e+01 -1.2573800086975098e+01 -2.0000000000000000e+02 -2.0392499923706055e+01 -4.2345500946044922e+01 -2.0200000000000000e+02 -2.8443201065063477e+01 -3.7416301727294922e+01 -2.0000000000000000e+02 -2.9303998947143555e+01 -3.6746101379394531e+01 -2.0200000000000000e+02 -2.9231500625610352e+01 -3.6669498443603516e+01 -2.0200000000000000e+02 -3.5821601867675781e+01 -3.0427200317382812e+01 -2.0000000000000000e+02 -1.0458499908447266e+01 -4.5821598052978516e+01 -2.0200000000000000e+02 -1.9734699249267578e+01 -4.2656002044677734e+01 -2.0200000000000000e+02 -2.0354900360107422e+01 -4.2282901763916016e+01 -2.0000000000000000e+02 0.0000000000000000e+00 -4.7000000000000000e+01 -2.0200000000000000e+02 -1.0103600502014160e+01 -4.5901100158691406e+01 -2.0200000000000000e+02 -1.0446400642395020e+01 -4.5785697937011719e+01 -2.0000000000000000e+02 1.0458499908447266e+01 -4.5821598052978516e+01 -2.0200000000000000e+02 1.0103600502014160e+01 -4.5901100158691406e+01 -2.0200000000000000e+02 0.0000000000000000e+00 -4.7000000000000000e+01 -2.0000000000000000e+02 2.0392499923706055e+01 -4.2345500946044922e+01 -2.0200000000000000e+02 1.9734699249267578e+01 -4.2656002044677734e+01 -2.0200000000000000e+02 1.0446400642395020e+01 -4.5785697937011719e+01 -2.0000000000000000e+02 2.9303998947143555e+01 -3.6746101379394531e+01 -2.0200000000000000e+02 2.8443201065063477e+01 -3.7416301727294922e+01 -2.0200000000000000e+02 2.0354900360107422e+01 -4.2282901763916016e+01 -2.0000000000000000e+02 3.6746101379394531e+01 -2.9303998947143555e+01 -2.0200000000000000e+02 3.5821601867675781e+01 -3.0427200317382812e+01 -2.0200000000000000e+02 2.9231500625610352e+01 -3.6669498443603516e+01 -2.0000000000000000e+02 4.2345500946044922e+01 -2.0392499923706055e+01 -2.0200000000000000e+02 4.1525100708007812e+01 -2.2015201568603516e+01 -2.0200000000000000e+02 3.6634399414062500e+01 -2.9228300094604492e+01 -2.0000000000000000e+02 4.5821598052978516e+01 -1.0458499908447266e+01 -2.0200000000000000e+02 4.5286800384521484e+01 -1.2573800086975098e+01 -2.0200000000000000e+02 4.2195400238037109e+01 -2.0332698822021484e+01 -2.0000000000000000e+02 4.7000000000000000e+01 0.0000000000000000e+00 -2.0200000000000000e+02 4.6930999755859375e+01 -2.5445199012756348e+00 -2.0200000000000000e+02 4.5638599395751953e+01 -1.0428400039672852e+01 -2.0000000000000000e+02 4.5821598052978516e+01 1.0458499908447266e+01 -2.0200000000000000e+02 4.6380798339843750e+01 7.6036996841430664e+00 -2.0200000000000000e+02 4.6793701171875000e+01 -1.1184399947524071e-02 -2.0000000000000000e+02 4.2345500946044922e+01 2.0392499923706055e+01 -2.0200000000000000e+02 4.3661899566650391e+01 1.7396499633789062e+01 -2.0200000000000000e+02 4.5604900360107422e+01 1.0398300170898438e+01 -2.0000000000000000e+02 3.6746101379394531e+01 2.9303998947143555e+01 -2.0200000000000000e+02 3.8901298522949219e+01 2.6375801086425781e+01 -2.0200000000000000e+02 4.2133098602294922e+01 2.0279899597167969e+01 -2.0000000000000000e+02 2.9303998947143555e+01 3.6746101379394531e+01 -2.0200000000000000e+02 3.2321899414062500e+01 3.4121700286865234e+01 -2.0200000000000000e+02 3.6553199768066406e+01 2.9140199661254883e+01 -2.0000000000000000e+02 2.0392499923706055e+01 4.2345500946044922e+01 -2.0200000000000000e+02 2.4230998992919922e+01 4.0272197723388672e+01 -2.0200000000000000e+02 2.9144899368286133e+01 3.6536800384521484e+01 -2.0000000000000000e+02 1.0458499908447266e+01 4.5821598052978516e+01 -2.0200000000000000e+02 1.5007100105285645e+01 4.4539699554443359e+01 -2.0200000000000000e+02 2.0279201507568359e+01 4.2100502014160156e+01 -2.0200000000000000e+02 0.0000000000000000e+00 4.6724399566650391e+01 -2.0200000000000000e+02 5.0815896987915039e+00 4.6724399566650391e+01 -2.0200000000000000e+02 1.0399499893188477e+01 4.5553901672363281e+01 -2.0000000000000000e+02 3.8271999359130859e+01 3.4460201263427734e+01 -2.0000000000000000e+02 4.4600299835205078e+01 2.5750000000000000e+01 -2.0000000000000000e+02 4.0385997772216797e+01 2.7382400512695312e+01 -2.0000000000000000e+02 3.0270900726318359e+01 -4.1664398193359375e+01 -2.0000000000000000e+02 2.0946899414062500e+01 -4.7047500610351562e+01 -2.0000000000000000e+02 2.0487998962402344e+01 -4.4284000396728516e+01 -2.0000000000000000e+02 1.0707399368286133e+01 5.0374599456787109e+01 -2.0000000000000000e+02 2.0946899414062500e+01 4.7047500610351562e+01 -2.0000000000000000e+02 1.5579899787902832e+01 4.6239601135253906e+01 -2.0000000000000000e+02 -1.0707399368286133e+01 -5.0374599456787109e+01 -2.0000000000000000e+02 -5.2754902839660645e+00 -4.8507701873779297e+01 -2.0000000000000000e+02 0.0000000000000000e+00 -5.1500000000000000e+01 -2.0000000000000000e+02 0.0000000000000000e+00 -4.8793701171875000e+01 -2.0000000000000000e+02 1.0707399368286133e+01 -5.0374599456787109e+01 -2.0000000000000000e+02 5.2754902839660645e+00 -4.8507701873779297e+01 -2.0000000000000000e+02 1.0489200592041016e+01 -4.7652900695800781e+01 -2.0000000000000000e+02 1.5579899787902832e+01 -4.6239601135253906e+01 -2.0000000000000000e+02 4.8979400634765625e+01 1.5914399147033691e+01 -2.0000000000000000e+02 5.1217899322509766e+01 5.3831896781921387e+00 -2.0000000000000000e+02 4.8150901794433594e+01 7.8939199447631836e+00 -2.0000000000000000e+02 3.7188701629638672e+01 3.1588401794433594e+01 -2.0000000000000000e+02 3.3555400848388672e+01 3.5423999786376953e+01 -2.0000000000000000e+02 3.0270900726318359e+01 4.1664398193359375e+01 -2.0000000000000000e+02 2.9528699874877930e+01 3.8844299316406250e+01 -2.0000000000000000e+02 2.5155799865722656e+01 4.1809303283691406e+01 -2.0000000000000000e+02 2.0487998962402344e+01 4.4284000396728516e+01 -2.0000000000000000e+02 -3.0270900726318359e+01 -4.1664398193359375e+01 -2.0000000000000000e+02 -3.8271999359130859e+01 -3.4460201263427734e+01 -2.0000000000000000e+02 -3.3555400848388672e+01 -3.5423999786376953e+01 -2.0000000000000000e+02 4.7015201568603516e+01 1.3053700447082520e+01 -2.0000000000000000e+02 4.5328201293945312e+01 1.8060400009155273e+01 -2.0000000000000000e+02 4.3109802246093750e+01 2.2855400085449219e+01 -2.0000000000000000e+02 -3.0270900726318359e+01 4.1664398193359375e+01 -2.0000000000000000e+02 -2.0946899414062500e+01 4.7047500610351562e+01 -2.0000000000000000e+02 -2.0487998962402344e+01 4.4284000396728516e+01 -2.0000000000000000e+02 -2.9528699874877930e+01 -3.8844299316406250e+01 -2.0000000000000000e+02 -2.5155799865722656e+01 -4.1809303283691406e+01 -2.0000000000000000e+02 -2.0946899414062500e+01 -4.7047500610351562e+01 -2.0000000000000000e+02 -2.0487998962402344e+01 -4.4284000396728516e+01 -2.0000000000000000e+02 -1.5579899787902832e+01 -4.6239601135253906e+01 -2.0000000000000000e+02 -1.0489200592041016e+01 -4.7652900695800781e+01 -2.0000000000000000e+02 2.5155799865722656e+01 -4.1809303283691406e+01 -2.0000000000000000e+02 2.9528699874877930e+01 -3.8844299316406250e+01 -2.0000000000000000e+02 3.8271999359130859e+01 -3.4460201263427734e+01 -2.0000000000000000e+02 4.8979400634765625e+01 -1.5914399147033691e+01 -2.0000000000000000e+02 4.4600299835205078e+01 -2.5750000000000000e+01 -2.0000000000000000e+02 4.3109802246093750e+01 -2.2855400085449219e+01 -2.0000000000000000e+02 -1.0707399368286133e+01 5.0374599456787109e+01 -2.0000000000000000e+02 -1.0489200592041016e+01 4.7652900695800781e+01 -2.0000000000000000e+02 -1.5579899787902832e+01 4.6239601135253906e+01 -2.0000000000000000e+02 3.3555400848388672e+01 -3.5423999786376953e+01 -2.0000000000000000e+02 3.7188701629638672e+01 -3.1588401794433594e+01 -2.0000000000000000e+02 4.0385997772216797e+01 -2.7382400512695312e+01 -2.0000000000000000e+02 1.0489200592041016e+01 4.7652900695800781e+01 -2.0000000000000000e+02 5.2754902839660645e+00 4.8507701873779297e+01 -2.0000000000000000e+02 0.0000000000000000e+00 5.1500000000000000e+01 -2.0000000000000000e+02 0.0000000000000000e+00 4.8793701171875000e+01 -2.0000000000000000e+02 -5.2754902839660645e+00 4.8507701873779297e+01 -2.0000000000000000e+02 -4.4600299835205078e+01 2.5750000000000000e+01 -2.0000000000000000e+02 -3.8271999359130859e+01 3.4460201263427734e+01 -2.0000000000000000e+02 -3.7188701629638672e+01 3.1588401794433594e+01 -2.0000000000000000e+02 4.5328201293945312e+01 -1.8060400009155273e+01 -2.0000000000000000e+02 4.7015201568603516e+01 -1.3053700447082520e+01 -2.0000000000000000e+02 5.1217899322509766e+01 -5.3831896781921387e+00 -2.0000000000000000e+02 4.8150901794433594e+01 -7.8939199447631836e+00 -2.0000000000000000e+02 4.8722099304199219e+01 -2.6416201591491699e+00 -2.0000000000000000e+02 4.8722099304199219e+01 2.6416201591491699e+00 -2.0000000000000000e+02 -2.5155799865722656e+01 4.1809303283691406e+01 -2.0000000000000000e+02 -2.9528699874877930e+01 3.8844299316406250e+01 -2.0000000000000000e+02 -3.3555400848388672e+01 3.5423999786376953e+01 -2.0000000000000000e+02 -5.1217899322509766e+01 -5.3831896781921387e+00 -2.0000000000000000e+02 -5.1217899322509766e+01 5.3831896781921387e+00 -2.0000000000000000e+02 -4.8722099304199219e+01 2.6416201591491699e+00 -2.0000000000000000e+02 -4.4600299835205078e+01 -2.5750000000000000e+01 -2.0000000000000000e+02 -4.0385997772216797e+01 -2.7382400512695312e+01 -2.0000000000000000e+02 -3.7188701629638672e+01 -3.1588401794433594e+01 -2.0000000000000000e+02 -4.8979400634765625e+01 1.5914399147033691e+01 -2.0000000000000000e+02 -4.7015201568603516e+01 1.3053700447082520e+01 -2.0000000000000000e+02 -4.8150901794433594e+01 7.8939199447631836e+00 -2.0000000000000000e+02 -4.0385997772216797e+01 2.7382400512695312e+01 -2.0000000000000000e+02 -4.3109802246093750e+01 2.2855400085449219e+01 -2.0000000000000000e+02 -4.5328201293945312e+01 1.8060400009155273e+01 -2.0000000000000000e+02 -4.8722099304199219e+01 -2.6416201591491699e+00 -2.0000000000000000e+02 -4.8150901794433594e+01 -7.8939199447631836e+00 -2.0000000000000000e+02 -4.8979400634765625e+01 -1.5914399147033691e+01 -2.0000000000000000e+02 -4.7015201568603516e+01 -1.3053700447082520e+01 -2.0000000000000000e+02 -4.5328201293945312e+01 -1.8060400009155273e+01 -2.0000000000000000e+02 -4.3109802246093750e+01 -2.2855400085449219e+01 -1.0869599914550781e+02 -7.4500000000000000e+01 -3.7333801269531250e+01 -1.1100199890136719e+02 -7.4500000000000000e+01 -3.4672100067138672e+01 -1.1114399719238281e+02 -5.4000000000000000e+01 -3.4794700622558594e+01 -1.1354299926757812e+02 -6.9123901367187500e+01 3.1929798126220703e+01 -1.1364199829101562e+02 -7.0792304992675781e+01 3.1801900863647461e+01 -1.1100199890136719e+02 -7.4500000000000000e+01 3.4672100067138672e+01 -1.1383300018310547e+02 -6.4923194885253906e+01 3.1552999496459961e+01 -1.1362600708007812e+02 -6.6236000061035156e+01 3.1822200775146484e+01 -1.1114399719238281e+02 -5.4000000000000000e+01 3.4794700622558594e+01 -1.1422900390625000e+02 -6.3430198669433594e+01 3.1027099609375000e+01 -1.1578900146484375e+02 -6.0237602233886719e+01 2.8810300827026367e+01 -1.1527999877929688e+02 -6.1045200347900391e+01 2.9561199188232422e+01 -1.1460600280761719e+02 -6.2416999816894531e+01 3.0514200210571289e+01 -1.1354299926757812e+02 -6.7767303466796875e+01 3.1929798126220703e+01 -1.1383700561523438e+02 -7.1989799499511719e+01 3.1547100067138672e+01 -1.1423600006103516e+02 -7.3482002258300781e+01 3.1017898559570312e+01 -1.1461599731445312e+02 -7.4500000000000000e+01 3.0499300003051758e+01 -1.2192299652099609e+02 -5.4792003631591797e+01 1.6058000564575195e+01 -1.2100399780273438e+02 -5.4878398895263672e+01 1.8743900299072266e+01 -1.2195500183105469e+02 -5.4000000000000000e+01 1.6068899154663086e+01 -1.1965999603271484e+02 -5.4993301391601562e+01 2.1907299041748047e+01 -1.1753299713134766e+02 -5.4000000000000000e+01 2.6000000000000000e+01 -1.1958900451660156e+02 -5.4999198913574219e+01 2.2058799743652344e+01 -1.1958000183105469e+02 -5.4999900817871094e+01 2.2077899932861328e+01 -1.1855900573730469e+02 -5.6580497741699219e+01 2.4137100219726562e+01 -1.1749099731445312e+02 -5.7991500854492188e+01 2.5975500106811523e+01 -1.1629199981689453e+02 -5.9575798034667969e+01 2.8039600372314453e+01 -1.2421499633789062e+02 -5.4000000000000000e+01 5.4354701042175293e+00 -1.2404900360107422e+02 -5.4621299743652344e+01 6.8354001045227051e+00 -1.2349900054931641e+02 -5.4649700164794922e+01 1.0152700424194336e+01 -1.2231900024414062e+02 -5.4754802703857422e+01 1.4900500297546387e+01 -1.2449599456787109e+02 -5.4522499084472656e+01 -6.4802402257919312e-01 -1.2421499633789062e+02 -5.4000000000000000e+01 -5.4354701042175293e+00 -1.2448500061035156e+02 -5.4540702819824219e+01 -1.2602800130844116e+00 -1.2422999572753906e+02 -5.4605201721191406e+01 -5.2890801429748535e+00 -1.2449699401855469e+02 -5.4518600463867188e+01 -5.3578996658325195e-01 -1.2450000000000000e+02 -5.4509098052978516e+01 0.0000000000000000e+00 -1.2449699401855469e+02 -5.4518600463867188e+01 5.3578996658325195e-01 -1.2449599456787109e+02 -5.4522499084472656e+01 6.4802402257919312e-01 -1.2445999908447266e+02 -5.4557800292968750e+01 2.0281100273132324e+00 -1.2416899871826172e+02 -5.4602802276611328e+01 5.4314699172973633e+00 -1.2192200469970703e+02 -5.4792499542236328e+01 -1.6058700561523438e+01 -1.2271600341796875e+02 -5.4714599609375000e+01 -1.3502599716186523e+01 -1.2195500183105469e+02 -5.4000000000000000e+01 -1.6068899154663086e+01 -1.2349900054931641e+02 -5.4649700164794922e+01 -1.0152700424194336e+01 -1.2420800018310547e+02 -5.4606502532958984e+01 -5.4344501495361328e+00 -1.1753299713134766e+02 -5.4000000000000000e+01 -2.6000000000000000e+01 -1.1753099822998047e+02 -5.8009300231933594e+01 -2.5998701095581055e+01 -1.1958000183105469e+02 -5.4999900817871094e+01 -2.2077899932861328e+01 -1.1958900451660156e+02 -5.4999198913574219e+01 -2.2058799743652344e+01 -1.1965999603271484e+02 -5.4993301391601562e+01 -2.1907299041748047e+01 -1.2152700042724609e+02 -5.4831298828125000e+01 -1.7331401824951172e+01 -1.1383300018310547e+02 -7.1968101501464844e+01 -3.1552999496459961e+01 -1.1362600708007812e+02 -7.0655197143554688e+01 -3.1822200775146484e+01 -1.1461599731445312e+02 -7.4500000000000000e+01 -3.0499300003051758e+01 -1.1460600280761719e+02 -7.4474296569824219e+01 -3.0514200210571289e+01 -1.1422900390625000e+02 -7.3461006164550781e+01 -3.1027099609375000e+01 -1.1362799835205078e+02 -6.6214096069335938e+01 -3.1819101333618164e+01 -1.1354299926757812e+02 -6.7767303466796875e+01 -3.1929798126220703e+01 -1.1354299926757812e+02 -6.9123901367187500e+01 -3.1929798126220703e+01 -1.1388199615478516e+02 -6.4696495056152344e+01 -3.1489000320434570e+01 -1.1423099517822266e+02 -6.3425502777099609e+01 -3.1025100708007812e+01 -1.1478900146484375e+02 -6.1998699188232422e+01 -3.0258899688720703e+01 -1.1547499847412109e+02 -6.0717800140380859e+01 -2.9277399063110352e+01 -1.1629199981689453e+02 -5.9575798034667969e+01 -2.8039600372314453e+01 -1.1750000000000000e+02 -5.8054500579833984e+01 -2.6057600021362305e+01 -1.0290399932861328e+02 -7.4500000000000000e+01 -4.1862598419189453e+01 -1.0306500244140625e+02 -5.4000000000000000e+01 -4.2068801879882812e+01 -9.9995498657226562e+01 -7.4500000000000000e+01 -4.4136199951171875e+01 -9.3650299072265625e+01 -5.4000000000000000e+01 -4.7504398345947266e+01 -9.3533699035644531e+01 -7.4500000000000000e+01 -4.7263397216796875e+01 -9.0054100036621094e+01 -7.4500000000000000e+01 -4.8947402954101562e+01 -8.3311401367187500e+01 -5.4000000000000000e+01 -5.0863601684570312e+01 -8.3247100830078125e+01 -7.4500000000000000e+01 -5.0598400115966797e+01 -7.9320899963378906e+01 -7.4500000000000000e+01 -5.1550701141357422e+01 -7.2500000000000000e+01 -5.4000000000000000e+01 -5.2000000000000000e+01 -7.2493003845214844e+01 -7.4500000000000000e+01 -5.1722499847412109e+01 -6.8280097961425781e+01 -7.4500000000000000e+01 -5.1828399658203125e+01 -6.1688598632812500e+01 -5.4000000000000000e+01 -5.0863601684570312e+01 -6.1741199493408203e+01 -7.4500000000000000e+01 -5.0586902618408203e+01 -5.7429500579833984e+01 -7.4500000000000000e+01 -4.9768199920654297e+01 -5.1349700927734375e+01 -5.4000000000000000e+01 -4.7504398345947266e+01 -5.1460899353027344e+01 -7.4500000000000000e+01 -4.7241699218750000e+01 -4.7258800506591797e+01 -7.4500000000000000e+01 -4.5463001251220703e+01 -4.1935203552246094e+01 -5.4000000000000000e+01 -4.2068801879882812e+01 -4.2100997924804688e+01 -7.4500000000000000e+01 -4.1833198547363281e+01 -3.8226699829101562e+01 -7.4500000000000000e+01 -3.9106800079345703e+01 -3.3856498718261719e+01 -5.4000000000000000e+01 -3.4794700622558594e+01 -3.4069999694824219e+01 -7.4500000000000000e+01 -3.4597900390625000e+01 -3.0740798950195312e+01 -7.4500000000000000e+01 -3.0986501693725586e+01 -2.7466699600219727e+01 -5.4000000000000000e+01 -2.6000000000000000e+01 -2.7718599319458008e+01 -7.4500000000000000e+01 -2.5851699829101562e+01 -2.5138599395751953e+01 -7.4500000000000000e+01 -2.1468500137329102e+01 -2.3045101165771484e+01 -5.4000000000000000e+01 -1.6068899154663086e+01 -2.3323699951171875e+01 -7.4500000000000000e+01 -1.5976799964904785e+01 -2.1672901153564453e+01 -7.4500000000000000e+01 -1.0981899261474609e+01 -2.0784898757934570e+01 -5.4000000000000000e+01 -5.4354701042175293e+00 -2.1077199935913086e+01 -7.4500000000000000e+01 -5.4042301177978516e+00 -2.0500000000000000e+01 -7.4500000000000000e+01 0.0000000000000000e+00 -2.0784898757934570e+01 -5.4000000000000000e+01 5.4354701042175293e+00 -2.1077199935913086e+01 -7.4500000000000000e+01 5.4042301177978516e+00 -2.1672901153564453e+01 -7.4500000000000000e+01 1.0981899261474609e+01 -2.3045101165771484e+01 -5.4000000000000000e+01 1.6068899154663086e+01 -2.3323699951171875e+01 -7.4500000000000000e+01 1.5976799964904785e+01 -2.5138599395751953e+01 -7.4500000000000000e+01 2.1468500137329102e+01 -2.7466699600219727e+01 -5.4000000000000000e+01 2.6000000000000000e+01 -2.7718599319458008e+01 -7.4500000000000000e+01 2.5851699829101562e+01 -3.0740798950195312e+01 -7.4500000000000000e+01 3.0986501693725586e+01 -3.3856498718261719e+01 -5.4000000000000000e+01 3.4794700622558594e+01 -3.4069999694824219e+01 -7.4500000000000000e+01 3.4597900390625000e+01 -3.8226699829101562e+01 -7.4500000000000000e+01 3.9106800079345703e+01 -4.1935203552246094e+01 -5.4000000000000000e+01 4.2068801879882812e+01 -4.2100997924804688e+01 -7.4500000000000000e+01 4.1833198547363281e+01 -4.7258800506591797e+01 -7.4500000000000000e+01 4.5463001251220703e+01 -5.1349700927734375e+01 -5.4000000000000000e+01 4.7504398345947266e+01 -5.1460899353027344e+01 -7.4500000000000000e+01 4.7241699218750000e+01 -5.7429500579833984e+01 -7.4500000000000000e+01 4.9768199920654297e+01 -6.1688598632812500e+01 -5.4000000000000000e+01 5.0863601684570312e+01 -6.1741199493408203e+01 -7.4500000000000000e+01 5.0586902618408203e+01 -6.8280097961425781e+01 -7.4500000000000000e+01 5.1828399658203125e+01 -7.2500000000000000e+01 -5.4000000000000000e+01 5.2000000000000000e+01 -7.2493003845214844e+01 -7.4500000000000000e+01 5.1722499847412109e+01 -7.9320899963378906e+01 -7.4500000000000000e+01 5.1550701141357422e+01 -8.3311401367187500e+01 -5.4000000000000000e+01 5.0863601684570312e+01 -8.3247100830078125e+01 -7.4500000000000000e+01 5.0598400115966797e+01 -9.0054100036621094e+01 -7.4500000000000000e+01 4.8947402954101562e+01 -9.3650299072265625e+01 -5.4000000000000000e+01 4.7504398345947266e+01 -9.3533699035644531e+01 -7.4500000000000000e+01 4.7263397216796875e+01 -9.9995498657226562e+01 -7.4500000000000000e+01 4.4136199951171875e+01 -1.0306500244140625e+02 -5.4000000000000000e+01 4.2068801879882812e+01 -1.0290399932861328e+02 -7.4500000000000000e+01 4.1862598419189453e+01 -1.0869599914550781e+02 -7.4500000000000000e+01 3.7333801269531250e+01 -8.3103500366210938e+01 -5.3500000000000000e+01 -4.9885501861572266e+01 -7.2500000000000000e+01 -5.4999900817871094e+01 -5.1000000000000000e+01 -7.2500000000000000e+01 -5.3500000000000000e+01 -5.1000000000000000e+01 -6.1896499633789062e+01 -5.4999900817871094e+01 -4.9885501861572266e+01 -6.1896499633789062e+01 -5.3500000000000000e+01 -4.9885501861572266e+01 -5.1756500244140625e+01 -5.4999900817871094e+01 -4.6590801239013672e+01 -5.1756500244140625e+01 -5.3500000000000000e+01 -4.6590801239013672e+01 -4.2522998809814453e+01 -5.4999900817871094e+01 -4.1259799957275391e+01 -4.2522998809814453e+01 -5.3500000000000000e+01 -4.1259799957275391e+01 -3.4599597930908203e+01 -5.4999900817871094e+01 -3.4125598907470703e+01 -3.4599597930908203e+01 -5.3500000000000000e+01 -3.4125598907470703e+01 -2.8332698822021484e+01 -5.4999900817871094e+01 -2.5500000000000000e+01 -2.8332698822021484e+01 -5.3500000000000000e+01 -2.5500000000000000e+01 -2.3996099472045898e+01 -5.4999900817871094e+01 -1.5759799957275391e+01 -2.3996099472045898e+01 -5.3500000000000000e+01 -1.5759799957275391e+01 -2.1779399871826172e+01 -5.4999900817871094e+01 -5.3309202194213867e+00 -2.1779399871826172e+01 -5.3500000000000000e+01 -5.3309202194213867e+00 -2.1779399871826172e+01 -5.4999900817871094e+01 5.3309202194213867e+00 -2.1779399871826172e+01 -5.3500000000000000e+01 5.3309202194213867e+00 -2.3996099472045898e+01 -5.4999900817871094e+01 1.5759799957275391e+01 -2.3996099472045898e+01 -5.3500000000000000e+01 1.5759799957275391e+01 -2.8332698822021484e+01 -5.4999900817871094e+01 2.5500000000000000e+01 -2.8332698822021484e+01 -5.3500000000000000e+01 2.5500000000000000e+01 -3.4599597930908203e+01 -5.4999900817871094e+01 3.4125598907470703e+01 -3.4599597930908203e+01 -5.3500000000000000e+01 3.4125598907470703e+01 -4.2522998809814453e+01 -5.4999900817871094e+01 4.1259799957275391e+01 -4.2522998809814453e+01 -5.3500000000000000e+01 4.1259799957275391e+01 -5.1756500244140625e+01 -5.4999900817871094e+01 4.6590801239013672e+01 -5.1756500244140625e+01 -5.3500000000000000e+01 4.6590801239013672e+01 -6.1896499633789062e+01 -5.4999900817871094e+01 4.9885501861572266e+01 -6.1896499633789062e+01 -5.3500000000000000e+01 4.9885501861572266e+01 -7.2500000000000000e+01 -5.4999900817871094e+01 5.1000000000000000e+01 -7.2500000000000000e+01 -5.3500000000000000e+01 5.1000000000000000e+01 -8.3103500366210938e+01 -5.4999900817871094e+01 4.9885501861572266e+01 -8.3103500366210938e+01 -5.3500000000000000e+01 4.9885501861572266e+01 -9.3243598937988281e+01 -5.4999900817871094e+01 4.6590801239013672e+01 -9.3243598937988281e+01 -5.3500000000000000e+01 4.6590801239013672e+01 -1.0247699737548828e+02 -5.4999900817871094e+01 4.1259799957275391e+01 -1.0247699737548828e+02 -5.3500000000000000e+01 4.1259799957275391e+01 -1.1040000152587891e+02 -5.4999900817871094e+01 3.4125598907470703e+01 -1.1040000152587891e+02 -5.3500000000000000e+01 3.4125598907470703e+01 -1.1666699981689453e+02 -5.4999900817871094e+01 2.5500000000000000e+01 -1.1666699981689453e+02 -5.3500000000000000e+01 2.5500000000000000e+01 -1.2100399780273438e+02 -5.4999900817871094e+01 1.5759799957275391e+01 -1.2100399780273438e+02 -5.3500000000000000e+01 1.5759799957275391e+01 -1.2322100067138672e+02 -5.4999900817871094e+01 5.3309202194213867e+00 -1.2322100067138672e+02 -5.3500000000000000e+01 5.3309202194213867e+00 -1.2322100067138672e+02 -5.4999900817871094e+01 -5.3309202194213867e+00 -1.2322100067138672e+02 -5.3500000000000000e+01 -5.3309202194213867e+00 -1.2100399780273438e+02 -5.4999900817871094e+01 -1.5759799957275391e+01 -1.2100399780273438e+02 -5.3500000000000000e+01 -1.5759799957275391e+01 -1.1666699981689453e+02 -5.4999900817871094e+01 -2.5500000000000000e+01 -1.1666699981689453e+02 -5.3500000000000000e+01 -2.5500000000000000e+01 -1.1040000152587891e+02 -5.4999900817871094e+01 -3.4125598907470703e+01 -1.1040000152587891e+02 -5.3500000000000000e+01 -3.4125598907470703e+01 -1.0247699737548828e+02 -5.4999900817871094e+01 -4.1259799957275391e+01 -1.0247699737548828e+02 -5.3500000000000000e+01 -4.1259799957275391e+01 -9.3243598937988281e+01 -5.4999900817871094e+01 -4.6590801239013672e+01 -9.3243598937988281e+01 -5.3500000000000000e+01 -4.6590801239013672e+01 -8.3103500366210938e+01 -5.4999900817871094e+01 -4.9885501861572266e+01 -1.1821299743652344e+02 -7.5000000000000000e+01 -2.4940999984741211e+01 -1.1846399688720703e+02 -7.4844505310058594e+01 -2.4762100219726562e+01 -1.1743400573730469e+02 -7.5000000000000000e+01 -2.6215400695800781e+01 -1.1778700256347656e+02 -7.4844703674316406e+01 -2.5918600082397461e+01 -1.1868900299072266e+02 -7.5000000000000000e+01 -2.4061401367187500e+01 -1.1875899505615234e+02 -7.4922599792480469e+01 -2.4097900390625000e+01 -1.1856600189208984e+02 -7.4844398498535156e+01 -2.4587900161743164e+01 -1.1883100128173828e+02 -7.4844398498535156e+01 -2.4134901046752930e+01 -1.1756900024414062e+02 -7.4844703674316406e+01 -2.6289501190185547e+01 -1.1706600189208984e+02 -7.4860404968261719e+01 -2.7026298522949219e+01 -1.1635400390625000e+02 -7.5000000000000000e+01 -2.7982900619506836e+01 -1.1656600189208984e+02 -7.4875999450683594e+01 -2.7758899688720703e+01 -1.1617600250244141e+02 -7.4888099670410156e+01 -2.8330101013183594e+01 -1.2324299621582031e+02 -7.4866600036621094e+01 -1.2532000541687012e+01 -1.2269599914550781e+02 -7.4859100341796875e+01 -1.4708999633789062e+01 -1.2258799743652344e+02 -7.4924095153808594e+01 -1.4677900314331055e+01 -1.2172300720214844e+02 -7.5000000000000000e+01 -1.7087598800659180e+01 -1.2238899993896484e+02 -7.5000000000000000e+01 -1.4622799873352051e+01 -1.2499600219726562e+02 -7.4977706909179688e+01 -6.3680601119995117e-01 -1.2499099731445312e+02 -7.4975402832031250e+01 -7.3578697443008423e-01 -1.2484899902343750e+02 -7.5000000000000000e+01 -6.3574695587158203e-01 -1.2496499633789062e+02 -7.4964302062988281e+01 -1.2120000123977661e+00 -1.2467400360107422e+02 -7.5000000000000000e+01 -2.0850899219512939e+00 -1.2492600250244141e+02 -7.4947898864746094e+01 -1.9183099269866943e+00 -1.2491200256347656e+02 -7.4941902160644531e+01 -2.1768798828125000e+00 -1.2474900054931641e+02 -7.4980201721191406e+01 -2.2648000717163086e+00 -1.2465299987792969e+02 -7.5000000000000000e+01 -2.2534098625183105e+00 -1.2452700042724609e+02 -7.4957305908203125e+01 -4.9822297096252441e+00 -1.2432699584960938e+02 -7.5000000000000000e+01 -4.9592199325561523e+00 -1.2378399658203125e+02 -7.5000000000000000e+01 -9.4597301483154297e+00 -1.2378299713134766e+02 -7.4935699462890625e+01 -9.8713006973266602e+00 -1.2367800140380859e+02 -7.5000000000000000e+01 -9.8495502471923828e+00 -1.2083499908447266e+02 -7.5000000000000000e+01 -1.9349699020385742e+01 -1.2093499755859375e+02 -7.4917396545410156e+01 -1.9388898849487305e+01 -1.2033600616455078e+02 -7.5000000000000000e+01 -2.0620300292968750e+01 -1.2472299957275391e+02 -7.4914100646972656e+01 -4.3963799476623535e+00 -1.2484999847412109e+02 -7.4931701660156250e+01 -2.9292700290679932e+00 -1.2490700531005859e+02 -7.4939697265625000e+01 -2.2709400653839111e+00 -1.2467099761962891e+02 -7.4906898498535156e+01 -4.9953999519348145e+00 -1.2443199920654297e+02 -7.4897201538085938e+01 -6.5244998931884766e+00 -1.2394499969482422e+02 -7.4877296447753906e+01 -9.6465902328491211e+00 -1.2390699768066406e+02 -7.4875694274902344e+01 -9.8946695327758789e+00 -1.2202899932861328e+02 -7.4855300903320312e+01 -1.6594900131225586e+01 -1.2069799804687500e+02 -7.4848800659179688e+01 -2.0131500244140625e+01 -1.2102700042724609e+02 -7.4849601745605469e+01 -1.9425699234008789e+01 -1.2499699401855469e+02 -7.4981697082519531e+01 -5.2349197864532471e-01 -1.2486299896240234e+02 -7.5000000000000000e+01 -5.2275198698043823e-01 -1.2486299896240234e+02 -7.5000000000000000e+01 5.2275198698043823e-01 -1.2499699401855469e+02 -7.4981697082519531e+01 5.2349197864532471e-01 -1.2490499877929688e+02 -7.5000000000000000e+01 1.2132099829614162e-02 -1.2500000000000000e+02 -7.4990798950195312e+01 0.0000000000000000e+00 -1.2490399932861328e+02 -7.5000000000000000e+01 0.0000000000000000e+00 -1.2499600219726562e+02 -7.4977706909179688e+01 6.3680601119995117e-01 -1.2484899902343750e+02 -7.5000000000000000e+01 6.3574695587158203e-01 -1.2325199890136719e+02 -7.5000000000000000e+01 1.1911499977111816e+01 -1.2216900634765625e+02 -7.5000000000000000e+01 1.5764899253845215e+01 -1.2223300170898438e+02 -7.4922096252441406e+01 1.5819100379943848e+01 -1.2084999847412109e+02 -7.4917198181152344e+01 1.9597200393676758e+01 -1.2079699707031250e+02 -7.5000000000000000e+01 1.9525600433349609e+01 -1.2077799987792969e+02 -7.5000000000000000e+01 1.9568300247192383e+01 -1.2354000091552734e+02 -7.4932296752929688e+01 1.1024099349975586e+01 -1.2340599822998047e+02 -7.5000000000000000e+01 1.0998499870300293e+01 -1.2439200592041016e+02 -7.4950698852539062e+01 6.1361198425292969e+00 -1.2422899627685547e+02 -7.5000000000000000e+01 6.1123399734497070e+00 -1.2452300262451172e+02 -7.4957000732421875e+01 5.0184698104858398e+00 -1.2441500091552734e+02 -7.5000000000000000e+01 5.0053601264953613e+00 -1.2479499816894531e+02 -7.5000000000000000e+01 1.2813199758529663e+00 -1.2465900421142578e+02 -7.5000000000000000e+01 2.9037599563598633e+00 -1.2452899932861328e+02 -7.5000000000000000e+01 4.3255100250244141e+00 -1.2466699981689453e+02 -7.4906501770019531e+01 5.0316996574401855e+00 -1.2477700042724609e+02 -7.4930496215820312e+01 3.5554201602935791e+00 -1.2478599548339844e+02 -7.4932395935058594e+01 3.4377000331878662e+00 -1.2487500000000000e+02 -7.4951599121093750e+01 2.2470901012420654e+00 -1.2493599700927734e+02 -7.4964698791503906e+01 1.4410599470138550e+00 -1.2497599792480469e+02 -7.4973503112792969e+01 8.9875996112823486e-01 -1.2365899658203125e+02 -7.4870903015136719e+01 1.1049600601196289e+01 -1.2372600555419922e+02 -7.4872901916503906e+01 1.0674599647521973e+01 -1.2426300048828125e+02 -7.4889198303222656e+01 7.6587800979614258e+00 -1.2453099822998047e+02 -7.4897399902343750e+01 6.1519098281860352e+00 -1.2464900207519531e+02 -7.4905296325683594e+01 5.1778602600097656e+00 -1.2266100311279297e+02 -7.4859901428222656e+01 1.4675199508666992e+01 -1.1988099670410156e+02 -7.4846794128417969e+01 2.1896799087524414e+01 -1.2094199371337891e+02 -7.4849296569824219e+01 1.9634201049804688e+01 -1.2159500122070312e+02 -7.4852600097656250e+01 1.7862699508666992e+01 -1.2233699798583984e+02 -7.4856300354003906e+01 1.5851700782775879e+01 -1.1868900299072266e+02 -7.5000000000000000e+01 2.4061401367187500e+01 -1.1875199890136719e+02 -7.4913597106933594e+01 2.4093900680541992e+01 -1.1883100128173828e+02 -7.4844398498535156e+01 2.4134901046752930e+01 -1.1692199707031250e+02 -7.5000000000000000e+01 2.7102699279785156e+01 -1.1654100036621094e+02 -7.4869697570800781e+01 2.7815099716186523e+01 -1.1706700134277344e+02 -7.4858200073242188e+01 2.7028100967407227e+01 -1.1850000000000000e+02 -7.5000000000000000e+01 2.4417499542236328e+01 -1.1856800079345703e+02 -7.4844200134277344e+01 2.4589101791381836e+01 -1.1760099792480469e+02 -7.5000000000000000e+01 2.5946498870849609e+01 -1.1773999786376953e+02 -7.4843597412109375e+01 2.6021299362182617e+01 -1.1846700286865234e+02 -7.4844100952148438e+01 2.4763700485229492e+01 -1.7010499572753906e+02 -3.5164501190185547e+01 2.7878099441528320e+01 -1.7188999938964844e+02 -3.5192699432373047e+01 2.9437900543212891e+01 -1.7167300415039062e+02 -3.8715499877929688e+01 2.9442501068115234e+01 -1.4165100097656250e+02 -6.5462203979492188e+01 2.9446401596069336e+01 -1.4159500122070312e+02 -6.3682601928710938e+01 2.7908100128173828e+01 -1.4481900024414062e+02 -6.3480495452880859e+01 2.7974401473999023e+01 -1.4172300720214844e+02 -6.7748001098632812e+01 3.0000000000000000e+01 -1.4503700256347656e+02 -6.5235801696777344e+01 2.9465000152587891e+01 -1.4584199523925781e+02 -6.3296897888183594e+01 2.7971599578857422e+01 -1.4868499755859375e+02 -6.4582801818847656e+01 2.9462299346923828e+01 -1.4828201293945312e+02 -6.2858798980712891e+01 2.7964899063110352e+01 -1.5134399414062500e+02 -6.1940498352050781e+01 2.7942100524902344e+01 -1.5194099426269531e+02 -6.3611404418945312e+01 2.9455900192260742e+01 -1.5182400512695312e+02 -6.1734901428222656e+01 2.7939100265502930e+01 -1.5505300903320312e+02 -6.2284397125244141e+01 2.9450799942016602e+01 -1.5426799011230469e+02 -6.0688999176025391e+01 2.7923799514770508e+01 -1.5706199645996094e+02 -5.9099700927734375e+01 2.7908800125122070e+01 -1.5802400207519531e+02 -6.0597698211669922e+01 2.9446498870849609e+01 -1.5722799682617188e+02 -5.8979103088378906e+01 2.7908100128173828e+01 -1.6068199157714844e+02 -5.8670497894287109e+01 2.9443399429321289e+01 -1.5956201171875000e+02 -5.7284500122070312e+01 2.7897600173950195e+01 -1.6189099121093750e+02 -5.5165599822998047e+01 2.7889101028442383e+01 -1.6320300292968750e+02 -5.6379501342773438e+01 2.9440999984741211e+01 -1.6193299865722656e+02 -5.5127300262451172e+01 2.7888898849487305e+01 -1.6406500244140625e+02 -5.2698398590087891e+01 2.7883199691772461e+01 -1.6547000122070312e+02 -5.3799301147460938e+01 2.9439300537109375e+01 -1.6438099670410156e+02 -5.2286899566650391e+01 2.7882499694824219e+01 -1.6580499267578125e+02 -5.3362102508544922e+01 2.9439098358154297e+01 -1.6562199401855469e+02 -5.0431800842285156e+01 2.7880800247192383e+01 -1.6769898986816406e+02 -5.0532897949218750e+01 2.9438400268554688e+01 -1.6616200256347656e+02 -4.9624900817871094e+01 2.7879999160766602e+01 -1.6762800598144531e+02 -4.6789001464843750e+01 2.7880100250244141e+01 -1.6831498718261719e+02 -4.4982898712158203e+01 2.7881900787353516e+01 -1.7047299194335938e+02 -4.4322097778320312e+01 2.9439300537109375e+01 -1.6925700378417969e+02 -4.7517501831054688e+01 2.9438499450683594e+01 -1.6877200317382812e+02 -4.3784698486328125e+01 2.7883001327514648e+01 -1.6934899902343750e+02 -4.1683597564697266e+01 2.7886501312255859e+01 -1.7108699035644531e+02 -4.2086997985839844e+01 2.9440299987792969e+01 -1.6982400512695312e+02 -3.8957996368408203e+01 2.7893501281738281e+01 -1.6990100097656250e+02 -3.8512496948242188e+01 2.7894599914550781e+01 -1.4531500244140625e+02 -6.7468894958496094e+01 3.0000000000000000e+01 -1.4919898986816406e+02 -6.6779098510742188e+01 3.0000000000000000e+01 -1.5270500183105469e+02 -6.5747299194335938e+01 3.0000000000000000e+01 -1.5605799865722656e+02 -6.4328994750976562e+01 3.0000000000000000e+01 -1.5925900268554688e+02 -6.2521598815917969e+01 3.0000000000000000e+01 -1.6212300109863281e+02 -6.0453498840332031e+01 3.0000000000000000e+01 -1.6483900451660156e+02 -5.7992500305175781e+01 3.0000000000000000e+01 -1.6727999877929688e+02 -5.5218399047851562e+01 3.0000000000000000e+01 -1.6764199829101562e+02 -5.4748199462890625e+01 3.0000000000000000e+01 -1.6968099975585938e+02 -5.1703899383544922e+01 3.0000000000000000e+01 -1.7135900878906250e+02 -4.8457099914550781e+01 3.0000000000000000e+01 -1.7266699218750000e+02 -4.5014797210693359e+01 3.0000000000000000e+01 -1.7332600402832031e+02 -4.2606700897216797e+01 3.0000000000000000e+01 -1.7395199584960938e+02 -3.8976699829101562e+01 3.0000000000000000e+01 -1.7419299316406250e+02 -3.5229000091552734e+01 3.0000000000000000e+01 -1.7188999938964844e+02 -1.7582201004028320e+01 2.9434999465942383e+01 -1.7315199279785156e+02 -1.8613298416137695e+01 2.9889301300048828e+01 -1.7419799804687500e+02 -2.3993400573730469e+01 3.0000000000000000e+01 -1.7190100097656250e+02 -1.1731699943542480e+01 2.9415300369262695e+01 -1.7216500854492188e+02 -1.3277799606323242e+01 2.9567899703979492e+01 -1.7296099853515625e+02 -1.7582298278808594e+01 2.9827199935913086e+01 -1.7010299682617188e+02 -1.7582201004028320e+01 2.7867799758911133e+01 -1.7010299682617188e+02 0.0000000000000000e+00 2.7867799758911133e+01 -1.7010800170898438e+02 -4.2502798140048981e-02 2.7875398635864258e+01 -1.7031599426269531e+02 -1.6596299409866333e+00 2.8151300430297852e+01 -1.7104199218750000e+02 -6.6275601387023926e+00 2.8878000259399414e+01 -1.7126100158691406e+02 -7.9972696304321289e+00 2.9046499252319336e+01 -1.7010299682617188e+02 -3.4597797393798828e+01 2.7867799758911133e+01 -1.7010299682617188e+02 -3.2521499633789062e+01 2.7867799758911133e+01 -1.7010299682617188e+02 -2.6017200469970703e+01 2.7867799758911133e+01 -1.8557000732421875e+02 -4.6515800476074219e+01 2.8530500411987305e+01 -1.8521299743652344e+02 -4.5802803039550781e+01 2.8922000885009766e+01 -1.8608699035644531e+02 -4.4696800231933594e+01 2.8558900833129883e+01 -1.8460600280761719e+02 -4.4616302490234375e+01 2.9353401184082031e+01 -1.8453199768066406e+02 -4.4471401214599609e+01 2.9406101226806641e+01 -1.8525000000000000e+02 -4.3644699096679688e+01 2.9173400878906250e+01 -1.8699499511718750e+02 -4.2215599060058594e+01 2.9371601104736328e+01 -1.8830799865722656e+02 -4.2900802612304688e+01 2.8922000885009766e+01 -1.8714900207519531e+02 -4.3701400756835938e+01 2.8558900833129883e+01 -1.8217199707031250e+02 -3.9799400329589844e+01 3.0000000000000000e+01 -1.8218598937988281e+02 -3.9806499481201172e+01 3.0000000000000000e+01 -1.8218299865722656e+02 -3.9808898925781250e+01 3.0000000000000000e+01 -1.8304200744628906e+02 -4.0234600067138672e+01 2.9981000900268555e+01 -1.8289599609375000e+02 -4.0379199981689453e+01 2.9972599029541016e+01 -1.8494898986816406e+02 -4.1184101104736328e+01 2.9804399490356445e+01 -1.8447700500488281e+02 -4.1634300231933594e+01 2.9719799041748047e+01 -1.8525099182128906e+02 -4.1334300994873047e+01 2.9758600234985352e+01 -1.8472500610351562e+02 -4.1828800201416016e+01 2.9655000686645508e+01 -1.8218099975585938e+02 -3.9811203002929688e+01 3.0000000000000000e+01 -1.8275100708007812e+02 -4.0524402618408203e+01 2.9972599029541016e+01 -1.8401300048828125e+02 -4.2100700378417969e+01 2.9719799041748047e+01 -1.8420899963378906e+02 -4.2345500946044922e+01 2.9655000686645508e+01 -1.8425300598144531e+02 -4.3924701690673828e+01 2.9526599884033203e+01 -1.8371600341796875e+02 -4.2873302459716797e+01 2.9758600234985352e+01 -1.8356500244140625e+02 -4.2575199127197266e+01 2.9804399490356445e+01 -1.8260699462890625e+02 -4.0669696807861328e+01 2.9981000900268555e+01 -1.8217900085449219e+02 -3.9813598632812500e+01 3.0000000000000000e+01 -1.8605099487304688e+02 -4.2862098693847656e+01 2.9173400878906250e+01 -1.8689500427246094e+02 -4.2163101196289062e+01 2.9406101226806641e+01 -1.8576499938964844e+02 -4.6906299591064453e+01 2.8316099166870117e+01 -1.8672200012207031e+02 -4.5523300170898438e+01 2.7857101440429688e+01 -1.8801599121093750e+02 -4.4354400634765625e+01 2.7857101440429688e+01 -1.8948799133300781e+02 -4.3541599273681641e+01 2.8316099166870117e+01 -1.8616600036621094e+02 -4.7729202270507812e+01 2.7659500122070312e+01 -1.8714300537109375e+02 -4.6094398498535156e+01 2.7173099517822266e+01 -1.8861900329589844e+02 -4.4795497894287109e+01 2.7173099517822266e+01 -1.9036500549316406e+02 -4.4033500671386719e+01 2.7659500122070312e+01 -1.8451300048828125e+02 -4.6418598175048828e+01 2.9358999252319336e+01 -1.8658900451660156e+02 -4.9289402008056641e+01 2.6044099807739258e+01 -1.8655300903320312e+02 -5.0047100067138672e+01 2.5175800323486328e+01 -1.8647399902343750e+02 -5.0419799804687500e+01 2.5175899505615234e+01 -1.8618899536132812e+02 -4.7790699005126953e+01 2.7598100662231445e+01 -1.8576399230957031e+02 -5.0264598846435547e+01 2.7600898742675781e+01 -1.8646000671386719e+02 -4.8515201568603516e+01 2.6874300003051758e+01 -1.8398500061035156e+02 -4.9875801086425781e+01 2.9359199523925781e+01 -1.8217800903320312e+02 -4.3896297454833984e+01 3.0000000000000000e+01 -1.8207299804687500e+02 -4.6203201293945312e+01 3.0000000000000000e+01 -1.8578900146484375e+02 -5.2997398376464844e+01 2.5176500320434570e+01 -1.8509500122070312e+02 -5.2779598236083984e+01 2.7601200103759766e+01 -1.8490699768066406e+02 -5.5286800384521484e+01 2.5176898956298828e+01 -1.8377000427246094e+02 -5.6221401214599609e+01 2.7601499557495117e+01 -1.8443099975585938e+02 -5.6524799346923828e+01 2.5177101135253906e+01 -1.8262500000000000e+02 -5.9878200531005859e+01 2.5177499771118164e+01 -1.8200799560546875e+02 -5.9493698120117188e+01 2.7601800918579102e+01 -1.8220999145507812e+02 -6.0486202239990234e+01 2.5177499771118164e+01 -1.8062699890136719e+02 -6.1517498016357422e+01 2.7601800918579102e+01 -1.8120999145507812e+02 -6.1951900482177734e+01 2.5177598953247070e+01 -1.7875300598144531e+02 -6.4851295471191406e+01 2.5177700042724609e+01 -1.7822900390625000e+02 -6.4347404479980469e+01 2.7601900100708008e+01 -1.7841400146484375e+02 -6.5162803649902344e+01 2.5177700042724609e+01 -1.7547500610351562e+02 -6.6873199462890625e+01 2.7601800918579102e+01 -1.7593200683593750e+02 -6.7438995361328125e+01 2.5177499771118164e+01 -1.7380699157714844e+02 -6.9006004333496094e+01 2.5177400588989258e+01 -1.7340199279785156e+02 -6.8402702331542969e+01 2.7601699829101562e+01 -1.7377899169921875e+02 -6.9022903442382812e+01 2.5177400588989258e+01 -1.7020800781250000e+02 -7.0270393371582031e+01 2.7601400375366211e+01 -1.7053399658203125e+02 -7.0919799804687500e+01 2.5176898956298828e+01 -1.6838900756835938e+02 -7.1833404541015625e+01 2.5176500320434570e+01 -1.6678300476074219e+02 -7.1728897094726562e+01 2.7601100921630859e+01 -1.6702400207519531e+02 -7.2414299011230469e+01 2.5176198959350586e+01 -1.6481800842285156e+02 -7.3097198486328125e+01 2.5175699234008789e+01 -1.6462998962402344e+02 -7.2395401000976562e+01 2.7600801467895508e+01 -1.6254100036621094e+02 -7.3554595947265625e+01 2.5175100326538086e+01 -1.6100199890136719e+02 -7.3124496459960938e+01 2.7600200653076172e+01 -1.6109899902343750e+02 -7.3844100952148438e+01 2.5174699783325195e+01 -1.5699699401855469e+02 -7.3393905639648438e+01 2.7599699020385742e+01 -1.5872799682617188e+02 -7.4003601074218750e+01 2.5174200057983398e+01 -1.5700000000000000e+02 -7.4119903564453125e+01 2.5173900604248047e+01 -1.8335800170898438e+02 -5.2233901977539062e+01 2.9359199523925781e+01 -1.8211500549316406e+02 -5.5461101531982422e+01 2.9359300613403320e+01 -1.8046200561523438e+02 -5.8530597686767578e+01 2.9359399795532227e+01 -1.7916600036621094e+02 -6.0429496765136719e+01 2.9359399795532227e+01 -1.7691600036621094e+02 -6.3085494995117188e+01 2.9359399795532227e+01 -1.7433099365234375e+02 -6.5456100463867188e+01 2.9359399795532227e+01 -1.7238500976562500e+02 -6.6891403198242188e+01 2.9359300613403320e+01 -1.6938899230957031e+02 -6.8643501281738281e+01 2.9359300613403320e+01 -1.6617800903320312e+02 -7.0011199951171875e+01 2.9359199523925781e+01 -1.6415899658203125e+02 -7.0636100769042969e+01 2.9359100341796875e+01 -1.6075700378417969e+02 -7.1319801330566406e+01 2.9358900070190430e+01 -1.5699099731445312e+02 -7.1572494506835938e+01 2.9358800888061523e+01 -1.8159199523925781e+02 -4.9352897644042969e+01 3.0000000000000000e+01 -1.8102101135253906e+02 -5.1500099182128906e+01 3.0000000000000000e+01 -1.7988999938964844e+02 -5.4438899993896484e+01 3.0000000000000000e+01 -1.7838400268554688e+02 -5.7235698699951172e+01 3.0000000000000000e+01 -1.7720300292968750e+02 -5.8966800689697266e+01 3.0000000000000000e+01 -1.7515000915527344e+02 -6.1388896942138672e+01 3.0000000000000000e+01 -1.7279299926757812e+02 -6.3550800323486328e+01 3.0000000000000000e+01 -1.7101899719238281e+02 -6.4859397888183594e+01 3.0000000000000000e+01 -1.6828900146484375e+02 -6.6456001281738281e+01 3.0000000000000000e+01 -1.6536399841308594e+02 -6.7701499938964844e+01 3.0000000000000000e+01 -1.6352600097656250e+02 -6.8270301818847656e+01 3.0000000000000000e+01 -1.6042700195312500e+02 -6.8892700195312500e+01 3.0000000000000000e+01 -1.5698200988769531e+02 -6.9122901916503906e+01 3.0000000000000000e+01 -1.5047900390625000e+02 -7.4120201110839844e+01 2.5174100875854492e+01 -1.3711700439453125e+02 -7.4120903015136719e+01 2.5174499511718750e+01 -1.3711700439453125e+02 -7.3394699096679688e+01 2.7600000381469727e+01 -1.1995899963378906e+02 -7.3439201354980469e+01 2.7525499343872070e+01 -1.1992800140380859e+02 -7.3389205932617188e+01 2.7596199035644531e+01 -1.1748900604248047e+02 -6.9123901367187500e+01 3.0000000000000000e+01 -1.3711700439453125e+02 -6.9123901367187500e+01 3.0000000000000000e+01 -1.1759799957275391e+02 -6.9958206176757812e+01 2.9929901123046875e+01 -1.1781199645996094e+02 -7.0556900024414062e+01 2.9790201187133789e+01 -1.3711700439453125e+02 -7.1573402404785156e+01 2.9358900070190430e+01 -1.1965299987792969e+02 -7.2946899414062500e+01 2.8222499847412109e+01 -1.1942499542236328e+02 -7.2632202148437500e+01 2.8562599182128906e+01 -1.1891099548339844e+02 -7.2061897277832031e+01 2.9045700073242188e+01 -1.1847700500488281e+02 -7.1564300537109375e+01 2.9343700408935547e+01 -1.1824900054931641e+02 -7.1303001403808594e+01 2.9500200271606445e+01 -1.2112500000000000e+02 -7.4120903015136719e+01 2.5174499511718750e+01 -1.2089800262451172e+02 -7.4104499816894531e+01 2.5439599990844727e+01 -1.2081900024414062e+02 -7.4094200134277344e+01 2.5543899536132812e+01 -1.2040299987792969e+02 -7.3960403442382812e+01 2.6268199920654297e+01 -1.2012599945068359e+02 -7.3697898864746094e+01 2.7019599914550781e+01 -1.8089799499511719e+02 -3.7602001190185547e+01 3.0000000000000000e+01 -1.8280899047851562e+02 -3.9799400329589844e+01 3.0000000000000000e+01 -1.4043200683593750e+02 -6.7767303466796875e+01 3.0000000000000000e+01 -1.7924299621582031e+02 -3.5085399627685547e+01 3.0000000000000000e+01 -1.3117399597167969e+02 -6.7767303466796875e+01 3.0000000000000000e+01 -1.1748900604248047e+02 -6.7767303466796875e+01 3.0000000000000000e+01 -1.7520199584960938e+02 -2.6445999145507812e+01 3.0000000000000000e+01 -1.7842500305175781e+02 -3.3533401489257812e+01 3.0000000000000000e+01 -1.1835300445556641e+02 -6.5461799621582031e+01 2.9429199218750000e+01 -1.1865399932861328e+02 -6.5092102050781250e+01 2.9224100112915039e+01 -1.3117399597167969e+02 -6.5458602905273438e+01 2.9434999465942383e+01 -1.1939399719238281e+02 -6.4406295776367188e+01 2.8701801300048828e+01 -1.1995200347900391e+02 -6.4002403259277344e+01 2.8290199279785156e+01 -1.1757999420166016e+02 -6.7001701354980469e+01 2.9940999984741211e+01 -1.1780699920654297e+02 -6.6345199584960938e+01 2.9793500900268555e+01 -1.1824200439453125e+02 -6.5598800659179688e+01 2.9505201339721680e+01 -1.4048199462890625e+02 -6.3671596527099609e+01 2.7867799758911133e+01 -1.4043200683593750e+02 -6.5458602905273438e+01 2.9434999465942383e+01 -1.4043200683593750e+02 -6.3671596527099609e+01 2.7867799758911133e+01 -1.3939599609375000e+02 -6.3671596527099609e+01 2.7867799758911133e+01 -1.3289100646972656e+02 -6.3671596527099609e+01 2.7867799758911133e+01 -1.3117399597167969e+02 -6.3671596527099609e+01 2.7867799758911133e+01 -1.2050299835205078e+02 -6.3671596527099609e+01 2.7867799758911133e+01 -1.8609799194335938e+02 -5.3047298431396484e+01 1.6401199340820312e+01 -1.8592399597167969e+02 -5.4105503082275391e+01 1.1650700569152832e+01 -1.8630699157714844e+02 -5.1790901184082031e+01 2.0599498748779297e+01 -1.8594400024414062e+02 -5.5188400268554688e+01 5.3065896034240723e-01 -1.8575000000000000e+02 -5.5674900054931641e+01 5.3085899353027344e-01 -1.8588699340820312e+02 -5.5127799987792969e+01 2.6502599716186523e+00 -1.8572500610351562e+02 -5.5726699829101562e+01 5.3087800741195679e-01 -1.8585299682617188e+02 -5.4736598968505859e+01 7.4658398628234863e+00 -1.8407901000976562e+02 -5.9138397216796875e+01 5.3210198879241943e-01 -1.8292201232910156e+02 -6.0927700042724609e+01 5.3257298469543457e-01 -1.7911599731445312e+02 -6.5651298522949219e+01 5.3344500064849854e-01 -1.8032699584960938e+02 -6.4433898925781250e+01 5.3332799673080444e-01 -1.8198300170898438e+02 -6.2380798339843750e+01 5.3295499086380005e-01 -1.7761099243164062e+02 -6.7164802551269531e+01 5.3358900547027588e-01 -1.7455799865722656e+02 -6.9554702758789062e+01 5.3351497650146484e-01 -1.7449400329589844e+02 -6.9595001220703125e+01 5.3350800275802612e-01 -1.7220300292968750e+02 -7.1021995544433594e+01 5.3324699401855469e-01 -1.6910800170898438e+02 -7.2518295288085938e+01 5.3263199329376221e-01 -1.6875399780273438e+02 -7.2689598083496094e+01 5.3256100416183472e-01 -1.6508799743652344e+02 -7.3925804138183594e+01 5.3148597478866577e-01 -1.6323399353027344e+02 -7.4294593811035156e+01 5.3078800439834595e-01 -1.6111799621582031e+02 -7.4715698242187500e+01 5.2999001741409302e-01 -1.5941299438476562e+02 -7.4816299438476562e+01 5.2992397546768188e-01 -1.2554399871826172e+02 -7.4730300903320312e+01 7.7211298942565918e+00 -1.2527700042724609e+02 -7.4620796203613281e+01 1.0857899665832520e+01 -1.5110699462890625e+02 -7.4981697082519531e+01 5.2345401048660278e-01 -1.2507399749755859e+02 -7.4968597412109375e+01 8.9738196134567261e-01 -1.2520299530029297e+02 -7.4949897766113281e+01 1.4346200227737427e+00 -1.2534099578857422e+02 -7.4922096252441406e+01 2.2312400341033936e+00 -1.2547699737548828e+02 -7.4880897521972656e+01 3.4099800586700439e+00 -1.2557398986816406e+02 -7.4820098876953125e+01 5.1513299942016602e+00 -1.5324099731445312e+02 -7.4981697082519531e+01 5.2345103025436401e-01 -1.5646499633789062e+02 -7.4990303039550781e+01 5.2980995178222656e-01 -1.2455000305175781e+02 -7.4473297119140625e+01 1.5080800056457520e+01 -1.2367200469970703e+02 -7.4355102539062500e+01 1.8468000411987305e+01 -1.2215599822998047e+02 -7.4203994750976562e+01 2.2795000076293945e+01 -1.6539999389648438e+02 -3.0843601226806641e+01 2.1151800155639648e+01 -1.6539900207519531e+02 -2.4674600601196289e+01 2.1150300979614258e+01 -1.6539999389648438e+02 -3.2812801361083984e+01 2.1152299880981445e+01 -1.4076100158691406e+02 -5.9060302734375000e+01 2.1414001464843750e+01 -1.3697299194335938e+02 -5.8967098236083984e+01 2.1149101257324219e+01 -1.3594299316406250e+02 -5.8967098236083984e+01 2.1149101257324219e+01 -1.4159600830078125e+02 -5.9015598297119141e+01 2.1414899826049805e+01 -1.4219099426269531e+02 -5.8938598632812500e+01 2.1375499725341797e+01 -1.4466899108886719e+02 -5.8618000030517578e+01 2.1211299896240234e+01 -1.4468600463867188e+02 -5.8615901947021484e+01 2.1211299896240234e+01 -1.4668400573730469e+02 -5.8289600372314453e+01 2.1204599380493164e+01 -1.4799400329589844e+02 -5.7954200744628906e+01 2.1200399398803711e+01 -1.4870800781250000e+02 -5.7771102905273438e+01 2.1198099136352539e+01 -1.4992900085449219e+02 -5.7361698150634766e+01 2.1194400787353516e+01 -1.5188198852539062e+02 -5.6542602539062500e+01 2.1188499450683594e+01 -1.5334400939941406e+02 -5.5766799926757812e+01 2.1184400558471680e+01 -1.5374499511718750e+02 -5.5553897857666016e+01 2.1183300018310547e+01 -1.5551599121093750e+02 -5.4399200439453125e+01 2.1178501129150391e+01 -1.5668000793457031e+02 -5.3507499694824219e+01 2.1175600051879883e+01 -1.5794200134277344e+02 -5.2377998352050781e+01 2.1172700881958008e+01 -1.5827799987792969e+02 -5.2077201843261719e+01 2.1171899795532227e+01 -1.5972999572753906e+02 -5.0520500183105469e+01 2.1168998718261719e+01 -1.6103399658203125e+02 -4.8844699859619141e+01 2.1166900634765625e+01 -1.6159599304199219e+02 -4.7989498138427734e+01 2.1166099548339844e+01 -1.6193899536132812e+02 -4.7466999053955078e+01 2.1165599822998047e+01 -1.6296400451660156e+02 -4.5596599578857422e+01 2.1164600372314453e+01 -1.6380599975585938e+02 -4.3662300109863281e+01 2.1164100646972656e+01 -1.6409599304199219e+02 -4.2789600372314453e+01 2.1164100646972656e+01 -1.6446900939941406e+02 -4.1668197631835938e+01 2.1163999557495117e+01 -1.6486898803710938e+02 -4.0028999328613281e+01 2.1164199829101562e+01 -1.6519898986816406e+02 -3.7957000732421875e+01 2.1165000915527344e+01 -1.6528298950195312e+02 -3.6984699249267578e+01 2.1165498733520508e+01 -1.6531098937988281e+02 -3.6662002563476562e+01 2.1165700912475586e+01 -1.6536900329589844e+02 -3.5969200134277344e+01 2.1197700500488281e+01 -1.6540899658203125e+02 -3.3285800933837891e+01 2.1166700363159180e+01 -1.6539799499511719e+02 0.0000000000000000e+00 2.1149101257324219e+01 -1.6539799499511719e+02 -2.0042200088500977e+01 2.1149101257324219e+01 -1.2410700225830078e+02 -5.9095699310302734e+01 2.1332899093627930e+01 -1.2298699951171875e+02 -6.0676300048828125e+01 2.3590101242065430e+01 -1.3380000305175781e+02 -5.8967098236083984e+01 2.1149101257324219e+01 -1.2977400207519531e+02 -5.8967098236083984e+01 2.1149101257324219e+01 -1.2419100189208984e+02 -5.8967098236083984e+01 2.1149101257324219e+01 -1.7781500244140625e+02 -2.1201801300048828e+01 3.2546600341796875e+01 -1.7829400634765625e+02 -2.2371801376342773e+01 3.2634498596191406e+01 -1.7725900268554688e+02 -2.2781599044799805e+01 3.1236600875854492e+01 -1.7011299133300781e+02 -3.8538899272680283e-02 2.7882900238037109e+01 -1.7011100769042969e+02 -3.9860203862190247e-02 2.7880399703979492e+01 -1.7052999877929688e+02 -1.5077600479125977e+00 2.8438798904418945e+01 -1.7046199035644531e+02 -1.5583599805831909e+00 2.8340900421142578e+01 -1.7122599792480469e+02 -3.6902399063110352e+00 2.9161199569702148e+01 -1.7170800781250000e+02 -6.2450799942016602e+00 2.9554700851440430e+01 -1.7198200988769531e+02 -6.0588698387145996e+00 2.9945199966430664e+01 -1.7241999816894531e+02 -7.3236198425292969e+00 3.0305299758911133e+01 -1.7011000061035156e+02 -4.1181501001119614e-02 2.7877901077270508e+01 -1.7038999938964844e+02 -1.6089700460433960e+00 2.8245100021362305e+01 -1.7139300537109375e+02 -6.4353299140930176e+00 2.9197700500488281e+01 -1.7170100402832031e+02 -7.7680897712707520e+00 2.9412399291992188e+01 -1.7394299316406250e+02 -1.1462800025939941e+01 3.1280498504638672e+01 -1.7367500305175781e+02 -1.2560199737548828e+01 3.0681900024414062e+01 -1.7208898925781250e+02 -7.5423698425292969e+00 2.9834098815917969e+01 -1.7297799682617188e+02 -1.2911499977111816e+01 3.0041500091552734e+01 -1.7541700744628906e+02 -1.7647600173950195e+01 3.1158700942993164e+01 -1.7437300109863281e+02 -1.8110799789428711e+01 3.0350700378417969e+01 -1.7620199584960938e+02 -1.7260000228881836e+01 3.2250099182128906e+01 -1.7583300781250000e+02 -2.3346200942993164e+01 3.0319299697875977e+01 -1.7422799682617188e+02 -1.2238100051879883e+01 3.1463102340698242e+01 -1.7684700012207031e+02 -2.5751701354980469e+01 3.0329599380493164e+01 -1.7827500915527344e+02 -2.5148900985717773e+01 3.1275100708007812e+01 -1.7929800415039062e+02 -2.4717100143432617e+01 3.2711902618408203e+01 -1.8009999084472656e+02 -3.2722301483154297e+01 3.0358999252319336e+01 -1.8153401184082031e+02 -3.2027698516845703e+01 3.1384502410888672e+01 -1.8252099609375000e+02 -3.1549301147460938e+01 3.2929199218750000e+01 -1.9297500610351562e+02 -4.3611198425292969e+01 2.8235799789428711e+01 -1.9361900329589844e+02 -4.3769199371337891e+01 2.8039899826049805e+01 -1.9478599548339844e+02 -4.4028800964355469e+01 2.7666900634765625e+01 -1.9480900573730469e+02 -4.4033500671386719e+01 2.7659500122070312e+01 -1.9045600891113281e+02 -4.2896697998046875e+01 2.8925201416015625e+01 -1.8845500183105469e+02 -4.2210601806640625e+01 2.9363300323486328e+01 -1.8800799560546875e+02 -4.2057300567626953e+01 2.9461101531982422e+01 -1.8484100341796875e+02 -4.0760902404785156e+01 2.9906700134277344e+01 -1.8702200317382812e+02 -4.1679500579833984e+01 2.9633001327514648e+01 -1.9109599304199219e+02 -4.5030002593994141e+01 2.5998199462890625e+01 -1.9140200805664062e+02 -4.5752700805664062e+01 2.4711999893188477e+01 -1.8928900146484375e+02 -4.6276100158691406e+01 2.4740800857543945e+01 -1.9144799804687500e+02 -4.6573600769042969e+01 2.3127901077270508e+01 -1.8924101257324219e+02 -4.6976997375488281e+01 2.3473798751831055e+01 -1.8757598876953125e+02 -4.7534500122070312e+01 2.5214799880981445e+01 -1.8748899841308594e+02 -4.8220298767089844e+01 2.4206899642944336e+01 -1.9104200744628906e+02 -4.4901500701904297e+01 2.6226900100708008e+01 -1.8908399963378906e+02 -4.5546199798583984e+01 2.5978000640869141e+01 -1.8746299743652344e+02 -4.6824100494384766e+01 2.6207000732421875e+01 -1.3380000305175781e+02 -5.5362300872802734e+01 1.0375599861145020e+01 -1.2533299255371094e+02 -5.5362300872802734e+01 1.0375599861145020e+01 -1.2558199310302734e+02 -5.5224197387695312e+01 6.4213299751281738e+00 -1.2557500457763672e+02 -5.5182201385498047e+01 5.2180299758911133e+00 -1.4103799438476562e+02 -5.5017898559570312e+01 5.1932603120803833e-01 -1.2548099517822266e+02 -5.5120597839355469e+01 3.4551599025726318e+00 -1.2534600830078125e+02 -5.5078998565673828e+01 2.2617599964141846e+00 -1.2520700836181641e+02 -5.5050800323486328e+01 1.4551900625228882e+00 -1.2507799530029297e+02 -5.5031799316406250e+01 9.1127103567123413e-01 -1.2499600219726562e+02 -5.5022197723388672e+01 6.3680601119995117e-01 -1.2499699401855469e+02 -5.5018199920654297e+01 5.2349197864532471e-01 -1.4173799133300781e+02 -5.5365798950195312e+01 1.0574299812316895e+01 -1.4144599914550781e+02 -5.5017898559570312e+01 5.1890403032302856e-01 -1.4200399780273438e+02 -5.5361099243164062e+01 1.0601599693298340e+01 -1.4379299926757812e+02 -5.4879901885986328e+01 5.1999801397323608e-01 -1.4132901000976562e+02 -5.5365600585937500e+01 1.0564000129699707e+01 -1.4143000793457031e+02 -5.5017898559570312e+01 5.1922398805618286e-01 -1.6179699707031250e+02 -3.2856399536132812e+01 1.0387299537658691e+01 -1.6179699707031250e+02 -3.3392997741699219e+01 1.0387799263000488e+01 -1.6144999694824219e+02 -3.4015300750732422e+01 5.2808201313018799e-01 -1.6144900512695312e+02 -3.5007598876953125e+01 5.2230900526046753e-01 -1.6179400634765625e+02 -3.5153602600097656e+01 1.0419700622558594e+01 -1.6141999816894531e+02 -3.6096496582031250e+01 5.2255797386169434e-01 -1.6177700805664062e+02 -3.5864799499511719e+01 1.0441900253295898e+01 -1.6130000305175781e+02 -3.7454200744628906e+01 5.2285200357437134e-01 -1.6165000915527344e+02 -3.7437999725341797e+01 1.0418900489807129e+01 -1.6124099731445312e+02 -3.7798198699951172e+01 5.2291399240493774e-01 -1.6156500244140625e+02 -3.7950798034667969e+01 1.0410799980163574e+01 -1.6096800231933594e+02 -3.9378898620605469e+01 5.2319800853729248e-01 -1.6135699462890625e+02 -3.9212699890136719e+01 1.0391099929809570e+01 -1.6075199890136719e+02 -4.0253097534179688e+01 5.2331900596618652e-01 -1.6100799560546875e+02 -4.0614799499511719e+01 1.0373399734497070e+01 -1.6015100097656250e+02 -4.2100799560546875e+01 5.2348798513412476e-01 -1.6043501281738281e+02 -4.2319202423095703e+01 1.0357099533081055e+01 -1.6008499145507812e+02 -4.2252498626708984e+01 5.2349299192428589e-01 -1.6039199829101562e+02 -4.2417999267578125e+01 1.0356499671936035e+01 -1.5937100219726562e+02 -4.3885601043701172e+01 5.2354300022125244e-01 -1.5971099853515625e+02 -4.3972297668457031e+01 1.0347100257873535e+01 -1.5841000366210938e+02 -4.5603500366210938e+01 5.2350199222564697e-01 -1.5883299255371094e+02 -4.5571098327636719e+01 1.0343099594116211e+01 -1.5794299316406250e+02 -4.6314701080322266e+01 5.2346199750900269e-01 -1.5814199829101562e+02 -4.6621299743652344e+01 1.0343800544738770e+01 -1.5784800720214844e+02 -4.6439403533935547e+01 5.2345103025436401e-01 -1.5805799865722656e+02 -4.6749401092529297e+01 1.0343999862670898e+01 -1.5675399780273438e+02 -4.7876102447509766e+01 5.2333003282546997e-01 -1.5694299316406250e+02 -4.8184101104736328e+01 1.0350000381469727e+01 -1.5541600036621094e+02 -4.9317298889160156e+01 5.2315396070480347e-01 -1.5570100402832031e+02 -4.9518600463867188e+01 1.0361700057983398e+01 -1.5455599975585938e+02 -5.0078998565673828e+01 5.2302700281143188e-01 -1.5484700012207031e+02 -5.0286800384521484e+01 1.0372599601745605e+01 -1.5393200683593750e+02 -5.0631099700927734e+01 5.2293598651885986e-01 -1.5433500671386719e+02 -5.0746997833251953e+01 1.0379099845886230e+01 -1.5323999023437500e+02 -5.1161399841308594e+01 5.2282398939132690e-01 -1.5333999633789062e+02 -5.1514499664306641e+01 1.0394599914550781e+01 -1.5160499572753906e+02 -5.2239803314208984e+01 5.2252596616744995e-01 -1.5182499694824219e+02 -5.2510997772216797e+01 1.0422200202941895e+01 -1.5047399902343750e+02 -5.2836898803710938e+01 5.2227300405502319e-01 -1.5076499938964844e+02 -5.3080497741699219e+01 1.0444999694824219e+01 -1.4987799072265625e+02 -5.3151397705078125e+01 5.2213901281356812e-01 -1.5023001098632812e+02 -5.3367900848388672e+01 1.0456600189208984e+01 -1.4805899047851562e+02 -5.3893001556396484e+01 5.2163201570510864e-01 -1.4855700683593750e+02 -5.4082599639892578e+01 1.0498600006103516e+01 -1.4759300231933594e+02 -5.4050098419189453e+01 5.2148401737213135e-01 -1.4751000976562500e+02 -5.4442901611328125e+01 1.0527999877929688e+01 -1.4579800415039062e+02 -5.4535301208496094e+01 5.2083802223205566e-01 -1.4608999633789062e+02 -5.4819900512695312e+01 1.0572199821472168e+01 -1.4571600341796875e+02 -5.4557403564453125e+01 5.2080899477005005e-01 -1.4577099609375000e+02 -5.4904598236083984e+01 1.0582099914550781e+01 -1.4405000305175781e+02 -5.5203502655029297e+01 1.0642300605773926e+01 -1.6144900512695312e+02 -3.2719898223876953e+01 5.2602297067642212e-01 -1.6144900512695312e+02 -3.1127899169921875e+01 5.2349197864532471e-01 -1.6179499816894531e+02 -2.7037700653076172e+01 1.0381999969482422e+01 -1.6144900512695312e+02 -2.6925699234008789e+01 5.2349197864532471e-01 -1.6144900512695312e+02 -2.1059200286865234e+01 5.2349197864532471e-01 -1.6179400634765625e+02 -2.1146699905395508e+01 1.0376599311828613e+01 -1.6179299926757812e+02 -2.0042200088500977e+01 1.0375599861145020e+01 -1.6144900512695312e+02 -1.9574399948120117e+01 5.2349197864532471e-01 -1.6179299926757812e+02 -1.5136799812316895e+01 1.0375599861145020e+01 -1.6144900512695312e+02 -1.5074100494384766e+01 5.2349197864532471e-01 -1.6144900512695312e+02 -8.5851593017578125e+00 5.2349197864532471e-01 -1.6179299926757812e+02 -8.6208000183105469e+00 1.0375599861145020e+01 -1.6144900512695312e+02 0.0000000000000000e+00 5.2349197864532471e-01 -1.6179299926757812e+02 0.0000000000000000e+00 1.0375599861145020e+01 -1.6179299926757812e+02 3.1027200222015381e+00 9.9008102416992188e+00 -1.6179299926757812e+02 2.8107199668884277e+00 9.9565391540527344e+00 -1.6143099975585938e+02 0.0000000000000000e+00 0.0000000000000000e+00 -1.6179299926757812e+02 7.5989300012588501e-01 1.0347700119018555e+01 -1.6179299926757812e+02 2.8107199668884277e+00 -9.9565391540527344e+00 -1.6179299926757812e+02 3.1027200222015381e+00 -9.9008102416992188e+00 -1.6179299926757812e+02 0.0000000000000000e+00 -1.0375599861145020e+01 -1.6179299926757812e+02 7.5989300012588501e-01 -1.0347700119018555e+01 -1.6144900512695312e+02 0.0000000000000000e+00 -5.2349197864532471e-01 -1.6179299926757812e+02 6.7072501182556152e+00 -7.8486204147338867e+00 -1.6179299926757812e+02 7.1814103126525879e+00 -7.4886698722839355e+00 -1.6179299926757812e+02 5.2816300392150879e+00 -8.9307403564453125e+00 -1.6179299926757812e+02 9.3647804260253906e+00 -4.3151998519897461e+00 -1.6179299926757812e+02 9.7622299194335938e+00 -3.5145900249481201e+00 -1.6179299926757812e+02 8.7017402648925781e+00 -5.6509399414062500e+00 -1.6179299926757812e+02 1.0306799888610840e+01 0.0000000000000000e+00 -1.6179299926757812e+02 1.0306799888610840e+01 1.1925100088119507e+00 -1.6179299926757812e+02 1.0306799888610840e+01 -1.1925100088119507e+00 -1.6179299926757812e+02 9.3647804260253906e+00 4.3151998519897461e+00 -1.6179299926757812e+02 8.7017402648925781e+00 5.6509399414062500e+00 -1.6179299926757812e+02 9.7622299194335938e+00 3.5145900249481201e+00 -1.6179299926757812e+02 6.7072501182556152e+00 7.8486204147338867e+00 -1.6179299926757812e+02 5.2816300392150879e+00 8.9307403564453125e+00 -1.6179299926757812e+02 7.1814103126525879e+00 7.4886698722839355e+00 -1.4427598571777344e+02 -5.6165599822998047e+01 1.6172601699829102e+01 -1.4607000732421875e+02 -5.5855800628662109e+01 1.6143100738525391e+01 -1.6350999450683594e+02 0.0000000000000000e+00 1.7812398910522461e+01 -1.2523999786376953e+02 -5.5496601104736328e+01 1.2093500137329102e+01 -1.3380000305175781e+02 -5.6383697509765625e+01 1.6023698806762695e+01 -1.2534999847412109e+02 -5.6213901519775391e+01 1.5491800308227539e+01 -1.2532499694824219e+02 -5.5917900085449219e+01 1.4409399986267090e+01 -1.2496499633789062e+02 -5.7752799987792969e+01 1.9182199478149414e+01 -1.2526999664306641e+02 -5.6911800384521484e+01 1.7425498962402344e+01 -1.2532900238037109e+02 -5.6403301239013672e+01 1.6016601562500000e+01 -1.6229400634765625e+02 0.0000000000000000e+00 1.4176700592041016e+01 -1.6290199279785156e+02 0.0000000000000000e+00 1.5994500160217285e+01 -1.6281500244140625e+02 -2.0042200088500977e+01 1.6023698806762695e+01 -1.6282099914550781e+02 -3.3338199615478516e+01 1.6039400100708008e+01 -1.6279501342773438e+02 -3.5883502960205078e+01 1.6079700469970703e+01 -1.6265299987792969e+02 -3.7607402801513672e+01 1.6051198959350586e+01 -1.6234800720214844e+02 -3.9461399078369141e+01 1.6039001464843750e+01 -1.6198399353027344e+02 -4.0926799774169922e+01 1.6031398773193359e+01 -1.6138699340820312e+02 -4.2708499908447266e+01 1.6024600982666016e+01 -1.5971200561523438e+02 -4.6108802795410156e+01 1.6019599914550781e+01 -1.6063000488281250e+02 -4.4436901092529297e+01 1.6020700454711914e+01 -1.5890200805664062e+02 -4.7340900421142578e+01 1.6020700454711914e+01 -1.5643901062011719e+02 -5.0236099243164062e+01 1.6031000137329102e+01 -1.5773699951171875e+02 -4.8840999603271484e+01 1.6024499893188477e+01 -1.5501100158691406e+02 -5.1519901275634766e+01 1.6040500640869141e+01 -1.5238800048828125e+02 -5.3361900329589844e+01 1.6063098907470703e+01 -1.5397100830078125e+02 -5.2321502685546875e+01 1.6048700332641602e+01 -1.5072299194335938e+02 -5.4255897521972656e+01 1.6080699920654297e+01 -1.4788400268554688e+02 -5.5375801086425781e+01 1.6116399765014648e+01 -1.4897599792480469e+02 -5.5000801086425781e+01 1.6101799011230469e+01 -1.4176699829101562e+02 -5.6399799346923828e+01 1.6273599624633789e+01 -1.2462599945068359e+02 -5.8359600067138672e+01 2.0228599548339844e+01 -1.8252099609375000e+02 -6.6103301048278809e+00 -4.5122001647949219e+01 -1.8252099609375000e+02 -5.6480798721313477e+00 -4.5190299987792969e+01 -1.7244799804687500e+02 -7.4031896591186523e+00 -3.0327100753784180e+01 -1.8252099609375000e+02 -2.4824699401855469e+01 3.8194099426269531e+01 -1.8252099609375000e+02 -5.6480798721313477e+00 4.5190299987792969e+01 -1.8252099609375000e+02 1.7218300700187683e-01 4.5603302001953125e+01 -1.8252099609375000e+02 4.6227602958679199e+00 4.5253700256347656e+01 -1.8252099609375000e+02 -1.9586999893188477e+01 4.1182998657226562e+01 -1.8252099609375000e+02 -1.5606300354003906e+01 4.2723800659179688e+01 -1.8252099609375000e+02 -6.6103301048278809e+00 4.5122001647949219e+01 -1.8252099609375000e+02 -1.3245900154113770e+01 4.3637599945068359e+01 -1.8252099609375000e+02 -3.0831501007080078e+01 3.3602199554443359e+01 -1.8252099609375000e+02 -2.5492599487304688e+01 3.7812900543212891e+01 -1.8252099609375000e+02 -3.1549301147460938e+01 -3.2929199218750000e+01 -1.8252099609375000e+02 -3.0831501007080078e+01 -3.3602199554443359e+01 -1.8135600280761719e+02 -2.9175701141357422e+01 -3.2855598449707031e+01 -1.8252099609375000e+02 -2.5492599487304688e+01 -3.7812900543212891e+01 -1.7829400634765625e+02 -2.2371801376342773e+01 -3.2634498596191406e+01 -1.8252099609375000e+02 -2.4824699401855469e+01 -3.8194099426269531e+01 -1.7781500244140625e+02 -2.1201700210571289e+01 -3.2546699523925781e+01 -1.7620899963378906e+02 -1.7278499603271484e+01 -3.2252201080322266e+01 -1.8252099609375000e+02 -1.5606300354003906e+01 -4.2723800659179688e+01 -1.7424499511718750e+02 -1.2283500671386719e+01 -3.1472101211547852e+01 -1.7394299316406250e+02 -1.1463800430297852e+01 -3.1279701232910156e+01 -1.8252099609375000e+02 -1.9586999893188477e+01 -4.1182998657226562e+01 -1.8252099609375000e+02 -1.3245900154113770e+01 -4.3637599945068359e+01 -1.7011299133300781e+02 -3.8538899272680283e-02 -2.7882900238037109e+01 -1.7121699523925781e+02 -3.6799900531768799e+00 -2.9169200897216797e+01 -1.7152999877929688e+02 -4.7094197273254395e+00 -2.9532798767089844e+01 -1.7010299682617188e+02 0.0000000000000000e+00 -2.7867799758911133e+01 -1.8252099609375000e+02 1.7218300700187683e-01 -4.5603302001953125e+01 -1.8252099609375000e+02 4.6227602958679199e+00 -4.5253700256347656e+01 -1.6539799499511719e+02 0.0000000000000000e+00 -2.1149101257324219e+01 -1.6539799499511719e+02 1.5488899946212769e+00 -2.1092298507690430e+01 -1.6539799499511719e+02 2.1366500854492188e+00 -2.0980199813842773e+01 -1.8252099609375000e+02 6.9508500099182129e+00 -4.5070800781250000e+01 -1.6539799499511719e+02 6.3244099617004395e+00 -2.0181400299072266e+01 -1.8252099609375000e+02 1.3574999809265137e+01 -4.3536300659179688e+01 -1.6539799499511719e+02 6.7868800163269043e+00 -1.9975500106811523e+01 -1.8252099609375000e+02 1.4653900146484375e+01 -4.3109199523925781e+01 -1.8252099609375000e+02 1.9897399902343750e+01 -4.1033901214599609e+01 -1.6539799499511719e+02 1.0765800476074219e+01 -1.8204000473022461e+01 -1.8252099609375000e+02 2.3927400588989258e+01 -3.8693698883056641e+01 -1.6539799499511719e+02 1.1095600128173828e+01 -1.7953599929809570e+01 -1.8252099609375000e+02 2.5777399063110352e+01 -3.7619300842285156e+01 -1.6539799499511719e+02 1.4638200759887695e+01 -1.5264599800109863e+01 -1.8252099609375000e+02 3.1084299087524414e+01 -3.3368400573730469e+01 -1.6539799499511719e+02 1.4843500137329102e+01 -1.5016499519348145e+01 -1.8252099609375000e+02 3.2004901885986328e+01 -3.2372600555419922e+01 -1.8252099609375000e+02 3.5700298309326172e+01 -2.8375598907470703e+01 -1.6539799499511719e+02 1.7737199783325195e+01 -1.1518600463867188e+01 -1.8252099609375000e+02 3.8430000305175781e+01 -2.4359500885009766e+01 -1.6539799499511719e+02 1.7839399337768555e+01 -1.1312700271606445e+01 -1.6539799499511719e+02 1.9898799896240234e+01 -7.1640000343322754e+00 -1.8252099609375000e+02 3.9522499084472656e+01 -2.2752099990844727e+01 -1.8252099609375000e+02 4.2466201782226562e+01 -1.6622699737548828e+01 -1.6539799499511719e+02 1.9930299758911133e+01 -7.0297098159790039e+00 -1.8252099609375000e+02 4.2922500610351562e+01 -1.5139499664306641e+01 -1.6539799499511719e+02 2.1009000778198242e+01 -2.4308001995086670e+00 -1.8252099609375000e+02 4.4465698242187500e+01 -1.0123700141906738e+01 -1.6539799499511719e+02 2.1009000778198242e+01 -2.3848400115966797e+00 -1.8252099609375000e+02 4.5216899871826172e+01 -5.1280303001403809e+00 -1.8252099609375000e+02 4.5476699829101562e+01 -3.3997299671173096e+00 -1.6539799499511719e+02 2.1009000778198242e+01 2.3848400115966797e+00 -1.8252099609375000e+02 4.5476699829101562e+01 3.3997299671173096e+00 -1.8252099609375000e+02 4.5216899871826172e+01 5.1280303001403809e+00 -1.6539799499511719e+02 2.1009000778198242e+01 2.4308001995086670e+00 -1.8252099609375000e+02 4.4465698242187500e+01 1.0123700141906738e+01 -1.6539799499511719e+02 1.9930299758911133e+01 7.0297098159790039e+00 -1.8252099609375000e+02 4.2922500610351562e+01 1.5139499664306641e+01 -1.6539799499511719e+02 1.9898799896240234e+01 7.1640000343322754e+00 -1.8252099609375000e+02 4.2466201782226562e+01 1.6622699737548828e+01 -1.6539799499511719e+02 1.7839399337768555e+01 1.1312700271606445e+01 -1.8252099609375000e+02 3.9522499084472656e+01 2.2752099990844727e+01 -1.8252099609375000e+02 3.8430000305175781e+01 2.4359500885009766e+01 -1.6539799499511719e+02 1.7737199783325195e+01 1.1518600463867188e+01 -1.8252099609375000e+02 3.5700298309326172e+01 2.8375598907470703e+01 -1.6539799499511719e+02 1.4843500137329102e+01 1.5016499519348145e+01 -1.8252099609375000e+02 3.2004901885986328e+01 3.2372600555419922e+01 -1.6539799499511719e+02 1.4638200759887695e+01 1.5264599800109863e+01 -1.6539799499511719e+02 6.3244099617004395e+00 2.0181400299072266e+01 -1.8252099609375000e+02 6.9508500099182129e+00 4.5070800781250000e+01 -1.6539799499511719e+02 2.1366500854492188e+00 2.0980199813842773e+01 -1.6539799499511719e+02 1.5488899946212769e+00 2.1092298507690430e+01 -1.8252099609375000e+02 3.1084299087524414e+01 3.3368400573730469e+01 -1.8252099609375000e+02 2.5777399063110352e+01 3.7619300842285156e+01 -1.6539799499511719e+02 1.1095600128173828e+01 1.7953599929809570e+01 -1.8252099609375000e+02 2.3927400588989258e+01 3.8693698883056641e+01 -1.6539799499511719e+02 1.0765800476074219e+01 1.8204000473022461e+01 -1.8252099609375000e+02 1.9897399902343750e+01 4.1033901214599609e+01 -1.6539799499511719e+02 6.7868800163269043e+00 1.9975500106811523e+01 -1.8252099609375000e+02 1.4653900146484375e+01 4.3109199523925781e+01 -1.8252099609375000e+02 1.3574999809265137e+01 4.3536300659179688e+01 -1.6229400634765625e+02 1.1889499664306641e+01 7.7211298942565918e+00 -1.6229400634765625e+02 9.8122301101684570e+00 1.0232100486755371e+01 -1.6229400634765625e+02 1.3338500022888184e+01 -4.8021702766418457e+00 -1.6229400634765625e+02 1.4082699775695801e+01 -1.6294099092483521e+00 -1.6281500244140625e+02 0.0000000000000000e+00 -1.6023698806762695e+01 -1.6367399597167969e+02 0.0000000000000000e+00 -1.7729600906372070e+01 -1.6350999450683594e+02 1.3045099973678589e+00 -1.7764499664306641e+01 -1.6229400634765625e+02 1.0382500886917114e+00 1.4138599395751953e+01 -1.6247500610351562e+02 0.0000000000000000e+00 -1.4143899917602539e+01 -1.6229400634765625e+02 1.0382500886917114e+00 -1.4138599395751953e+01 -1.6350999450683594e+02 5.3266301155090332e+00 -1.6997299194335938e+01 -1.6350999450683594e+02 9.0672397613525391e+00 -1.5331899642944336e+01 -1.6350999450683594e+02 1.2328700065612793e+01 -1.2856200218200684e+01 -1.6350999450683594e+02 1.4938699722290039e+01 -9.7013101577758789e+00 -1.6350999450683594e+02 1.6759300231933594e+01 -6.0337200164794922e+00 -1.6350999450683594e+02 1.7694299697875977e+01 2.0473001003265381e+00 -1.6350999450683594e+02 1.7694299697875977e+01 -2.0473001003265381e+00 -1.6350999450683594e+02 1.6759300231933594e+01 6.0337200164794922e+00 -1.6350999450683594e+02 1.4938699722290039e+01 9.7013101577758789e+00 -1.6350999450683594e+02 1.2328700065612793e+01 1.2856200218200684e+01 -1.6350999450683594e+02 9.0672397613525391e+00 1.5331899642944336e+01 -1.6350999450683594e+02 5.3266301155090332e+00 1.6997299194335938e+01 -1.6350999450683594e+02 1.3045099973678589e+00 1.7764499664306641e+01 -1.6229400634765625e+02 1.1889499664306641e+01 -7.7211298942565918e+00 -1.6229400634765625e+02 9.8122301101684570e+00 -1.0232100486755371e+01 -1.6229400634765625e+02 1.3338500022888184e+01 4.8021702766418457e+00 -1.6229400634765625e+02 1.4082699775695801e+01 1.6294099092483521e+00 -1.6229400634765625e+02 4.2393798828125000e+00 1.3527899742126465e+01 -1.6229400634765625e+02 7.2164497375488281e+00 1.2202400207519531e+01 -1.6229400634765625e+02 4.2393798828125000e+00 -1.3527899742126465e+01 -1.6229400634765625e+02 7.2164497375488281e+00 -1.2202400207519531e+01 -1.8081399536132812e+02 -3.4187702178955078e+01 3.0339200973510742e+01 -1.8217300415039062e+02 -3.3411701202392578e+01 3.1310699462890625e+01 -1.8227699279785156e+02 -3.6559200286865234e+01 3.0308399200439453e+01 -1.8348599243164062e+02 -3.5645000457763672e+01 3.1195600509643555e+01 -1.8493499755859375e+02 -3.5684101104736328e+01 3.2476600646972656e+01 -1.8437600708007812e+02 -3.4972297668457031e+01 3.2552200317382812e+01 -1.8313400268554688e+02 -3.2862800598144531e+01 3.2782699584960938e+01 -1.8397999572753906e+02 -3.8626102447509766e+01 3.0283000946044922e+01 -1.8450000000000000e+02 -3.8105899810791016e+01 3.0691501617431641e+01 -1.8502000427246094e+02 -3.7585601806640625e+01 3.1099998474121094e+01 -1.8580900573730469e+02 -3.6795700073242188e+01 3.2358501434326172e+01 -1.9478900146484375e+02 -4.4026901245117188e+01 2.7669898986816406e+01 -1.9479200744628906e+02 -4.4025001525878906e+01 2.7672899246215820e+01 -1.9376799011230469e+02 -4.3657897949218750e+01 2.8194999694824219e+01 -1.9391700744628906e+02 -4.3556102752685547e+01 2.8356698989868164e+01 -1.9320500183105469e+02 -4.3431697845458984e+01 2.8468801498413086e+01 -1.9343299865722656e+02 -4.3274497985839844e+01 2.8718500137329102e+01 -1.9100900268554688e+02 -4.2402900695800781e+01 2.9415401458740234e+01 -1.8889201354980469e+02 -4.1197898864746094e+01 3.0114299774169922e+01 -1.8804800415039062e+02 -4.0660900115966797e+01 3.0323398590087891e+01 -1.8970799255371094e+02 -4.0581401824951172e+01 3.1064300537109375e+01 -1.9124699401855469e+02 -4.1789497375488281e+01 3.0183900833129883e+01 -1.9154399108886719e+02 -4.2022602081298828e+01 3.0013999938964844e+01 -1.8733300781250000e+02 -3.8394001007080078e+01 3.2036201477050781e+01 -1.8789199829101562e+02 -3.8922801971435547e+01 3.1824901580810547e+01 -1.8620300292968750e+02 -3.9377201080322266e+01 3.0612800598144531e+01 -1.8825300598144531e+02 -3.9263801574707031e+01 3.1688701629638672e+01 -1.8896899414062500e+02 -3.9939800262451172e+01 3.1418600082397461e+01 -1.8701599121093750e+02 -5.3515098571777344e+01 5.4544502496719360e-01 -1.8865600585937500e+02 -5.2391799926757812e+01 5.8584702014923096e-01 -1.8695999145507812e+02 -5.3455596923828125e+01 2.5873799324035645e+00 -1.9060200500488281e+02 -5.1995998382568359e+01 6.4547997713088989e-01 -1.8860000610351562e+02 -5.2332500457763672e+01 2.5623400211334229e+00 -1.8691999816894531e+02 -5.3055202484130859e+01 7.2246799468994141e+00 -1.8697799682617188e+02 -5.2403499603271484e+01 1.1250800132751465e+01 -1.8712599182128906e+02 -5.1309299468994141e+01 1.5813499450683594e+01 -1.8856900024414062e+02 -5.1925800323486328e+01 7.0508098602294922e+00 -1.8864199829101562e+02 -5.1260898590087891e+01 1.0947000503540039e+01 -1.8881500244140625e+02 -5.0142200469970703e+01 1.5360899925231934e+01 -1.9093299865722656e+02 -4.9427299499511719e+01 1.6059299468994141e+01 -1.9086801147460938e+02 -4.9752101898193359e+01 1.5123499870300293e+01 -1.9063900756835938e+02 -5.0868198394775391e+01 1.0789899826049805e+01 -1.9053399658203125e+02 -5.1530399322509766e+01 6.9721899032592773e+00 -1.9053900146484375e+02 -5.1672599792480469e+01 5.4315299987792969e+00 -1.9054699707031250e+02 -5.1936000823974609e+01 2.5791499614715576e+00 -1.9113500976562500e+02 -4.8422798156738281e+01 1.8953399658203125e+01 -1.8901699829101562e+02 -4.8814300537109375e+01 1.9250499725341797e+01 -1.8729899597167969e+02 -5.0012599945068359e+01 1.9836099624633789e+01 -1.1568199920654297e+02 -7.4638702392578125e+01 2.9121700286865234e+01 -1.1723699951171875e+02 -7.3448501586914062e+01 2.8524400711059570e+01 -1.1756999969482422e+02 -7.3602401733398438e+01 2.8184799194335938e+01 -1.1545299530029297e+02 -7.4577003479003906e+01 2.9470300674438477e+01 -1.1517400360107422e+02 -7.4545394897460938e+01 2.9800899505615234e+01 -1.1586599731445312e+02 -7.3825698852539062e+01 2.9303400039672852e+01 -1.1597599792480469e+02 -7.4717605590820312e+01 2.8675298690795898e+01 -1.1812700653076172e+02 -7.3887001037597656e+01 2.7465200424194336e+01 -1.1847600555419922e+02 -7.4058601379394531e+01 2.6911399841308594e+01 -1.1898600006103516e+02 -7.4245101928710938e+01 2.6028598785400391e+01 -1.1954000091552734e+02 -7.4332801818847656e+01 2.5101301193237305e+01 -1.1962900543212891e+02 -7.4336898803710938e+01 2.4961400985717773e+01 -1.1987099456787109e+02 -7.4345405578613281e+01 2.4599901199340820e+01 -1.1993000030517578e+02 -7.4317001342773438e+01 2.4626399993896484e+01 -1.1666799926757812e+02 -7.3246704101562500e+01 2.9078100204467773e+01 -1.1728399658203125e+02 -7.2802497863769531e+01 2.8905300140380859e+01 -1.1531800079345703e+02 -6.9123901367187500e+01 3.0559801101684570e+01 -1.1599600219726562e+02 -6.9123901367187500e+01 3.0228099822998047e+01 -1.1609500122070312e+02 -7.0188400268554688e+01 3.0129301071166992e+01 -1.1529699707031250e+02 -7.2633598327636719e+01 3.0054698944091797e+01 -1.1473400115966797e+02 -7.0475494384765625e+01 3.0773500442504883e+01 -1.1463899993896484e+02 -6.9123901367187500e+01 3.0891500473022461e+01 -1.1491999816894531e+02 -7.1441200256347656e+01 3.0538999557495117e+01 -1.1668699645996094e+02 -7.1879295349121094e+01 2.9529298782348633e+01 -1.1629000091552734e+02 -7.0947105407714844e+01 2.9933300018310547e+01 -1.1599600219726562e+02 -6.7767303466796875e+01 3.0228099822998047e+01 -1.1531800079345703e+02 -6.7767303466796875e+01 3.0559801101684570e+01 -1.1463899993896484e+02 -6.7767303466796875e+01 3.0891500473022461e+01 -1.1870300292968750e+02 -6.2776000976562500e+01 2.7342100143432617e+01 -1.1721300506591797e+02 -6.1327201843261719e+01 2.7402799606323242e+01 -1.1821399688720703e+02 -6.3133499145507812e+01 2.7893299102783203e+01 -1.1675000000000000e+02 -6.1809101104736328e+01 2.8076200485229492e+01 -1.1771699523925781e+02 -6.3591400146484375e+01 2.8440599441528320e+01 -1.1705300140380859e+02 -6.4404701232910156e+01 2.9149000167846680e+01 -1.1668000030517578e+02 -6.5024894714355469e+01 2.9536399841308594e+01 -1.1628600311279297e+02 -6.5957801818847656e+01 2.9937900543212891e+01 -1.1607900238037109e+02 -6.6790100097656250e+01 3.0145000457763672e+01 -1.1627700042724609e+02 -6.2415397644042969e+01 2.8741300582885742e+01 -1.1564599609375000e+02 -6.3475303649902344e+01 2.9597200393676758e+01 -1.1529100036621094e+02 -6.4274307250976562e+01 3.0063100814819336e+01 -1.1491600036621094e+02 -6.5467605590820312e+01 3.0544500350952148e+01 -1.1471900177001953e+02 -6.6526702880859375e+01 3.0792198181152344e+01 -1.1948300170898438e+02 -5.8366397857666016e+01 2.3371000289916992e+01 -1.2050000000000000e+02 -5.6804798126220703e+01 2.1245599746704102e+01 -1.2105599975585938e+02 -5.9821502685546875e+01 2.3176700592041016e+01 -1.2211299896240234e+02 -5.8263301849365234e+01 2.0980300903320312e+01 -1.1958900451660156e+02 -5.5000701904296875e+01 2.2058799743652344e+01 -1.1965999603271484e+02 -5.5006900787353516e+01 2.1906999588012695e+01 -1.2060099792480469e+02 -5.6761997222900391e+01 2.1096199035644531e+01 -1.2221199798583984e+02 -5.8171901702880859e+01 2.0825399398803711e+01 -1.2383999633789062e+02 -5.5125698089599609e+01 1.0217100143432617e+01 -1.2409500122070312e+02 -5.5166000366210938e+01 1.0244100570678711e+01 -1.2375499725341797e+02 -5.5274200439453125e+01 1.2132599830627441e+01 -1.2330400085449219e+02 -5.5138198852539062e+01 1.2134299278259277e+01 -1.2328100585937500e+02 -5.5507102966308594e+01 1.4570299148559570e+01 -1.2259400177001953e+02 -5.5154701232910156e+01 1.4670499801635742e+01 -1.2251699829101562e+02 -5.5156497955322266e+01 1.4947599411010742e+01 -1.2301300048828125e+02 -5.5661903381347656e+01 1.5670700073242188e+01 -1.2218599700927734e+02 -5.5146400451660156e+01 1.5813199996948242e+01 -1.2241300201416016e+02 -5.5998703002929688e+01 1.7580398559570312e+01 -1.2140799713134766e+02 -5.5122600555419922e+01 1.7849899291992188e+01 -1.2106099700927734e+02 -5.5112102508544922e+01 1.8757900238037109e+01 -1.2168999481201172e+02 -5.6353000640869141e+01 1.9259700775146484e+01 -1.2063399505615234e+02 -5.5079898834228516e+01 1.9718299865722656e+01 -1.2115499877929688e+02 -5.6572898864746094e+01 2.0240200042724609e+01 -1.2012699890136719e+02 -5.5041900634765625e+01 2.0856899261474609e+01 -1.2274099731445312e+02 -5.7755397796630859e+01 2.0007598876953125e+01 -1.2321299743652344e+02 -5.7312500000000000e+01 1.9056900024414062e+01 -1.2377200317382812e+02 -5.6656200408935547e+01 1.7413000106811523e+01 -1.2414599609375000e+02 -5.6074699401855469e+01 1.5539900779724121e+01 -1.2427999877929688e+02 -5.5817699432373047e+01 1.4464900016784668e+01 -1.2448899841308594e+02 -5.5440998077392578e+01 1.2106300354003906e+01 -1.2471500396728516e+02 -5.5264396667480469e+01 1.0309999465942383e+01 -1.2498100280761719e+02 -5.5029197692871094e+01 9.2419803142547607e-01 -1.2443000030517578e+02 -5.5107601165771484e+01 6.8812999725341797e+00 -1.2447799682617188e+02 -5.5102600097656250e+01 6.4088702201843262e+00 -1.2459799957275391e+02 -5.5090099334716797e+01 5.2301301956176758e+00 -1.2477400207519531e+02 -5.5071800231933594e+01 3.4962301254272461e+00 -1.2489300537109375e+02 -5.5059299468994141e+01 2.3199298381805420e+00 -1.2492199707031250e+02 -5.5056301116943359e+01 2.0363898277282715e+00 -1.2495099639892578e+02 -5.5043102264404297e+01 1.4941099882125854e+00 -1.5541600036621094e+02 -4.9317298889160156e+01 -5.2315396070480347e-01 -1.5675399780273438e+02 -4.7876102447509766e+01 -5.2333003282546997e-01 -1.6130000305175781e+02 -3.7454200744628906e+01 -5.2285200357437134e-01 -1.6141999816894531e+02 -3.6096496582031250e+01 -5.2255797386169434e-01 -1.4143000793457031e+02 -5.5017898559570312e+01 -5.1922398805618286e-01 -1.2500000000000000e+02 -5.5009101867675781e+01 0.0000000000000000e+00 -1.4103799438476562e+02 -5.5017898559570312e+01 -5.1932603120803833e-01 -1.2499699401855469e+02 -5.5018199920654297e+01 -5.2349197864532471e-01 -1.6144900512695312e+02 -8.5852098464965820e+00 -5.2349197864532471e-01 -1.6144900512695312e+02 -1.9574399948120117e+01 -5.2349197864532471e-01 -1.6144900512695312e+02 -1.5074100494384766e+01 -5.2349197864532471e-01 -1.6144900512695312e+02 -2.1059200286865234e+01 -5.2349197864532471e-01 -1.6144900512695312e+02 -2.6925699234008789e+01 -5.2349197864532471e-01 -1.6144900512695312e+02 -3.1127899169921875e+01 -5.2349197864532471e-01 -1.6144900512695312e+02 -3.2719898223876953e+01 -5.2602297067642212e-01 -1.6144999694824219e+02 -3.4015300750732422e+01 -5.2808201313018799e-01 -1.6144900512695312e+02 -3.5007598876953125e+01 -5.2230900526046753e-01 -1.6124099731445312e+02 -3.7798301696777344e+01 -5.2291399240493774e-01 -1.6096800231933594e+02 -3.9378898620605469e+01 -5.2319800853729248e-01 -1.6075199890136719e+02 -4.0253097534179688e+01 -5.2331900596618652e-01 -1.6015100097656250e+02 -4.2100799560546875e+01 -5.2348798513412476e-01 -1.6008499145507812e+02 -4.2252498626708984e+01 -5.2349299192428589e-01 -1.5937100219726562e+02 -4.3885601043701172e+01 -5.2354300022125244e-01 -1.5841000366210938e+02 -4.5603500366210938e+01 -5.2350199222564697e-01 -1.5794299316406250e+02 -4.6314701080322266e+01 -5.2346199750900269e-01 -1.5784800720214844e+02 -4.6439403533935547e+01 -5.2345103025436401e-01 -1.5455599975585938e+02 -5.0078998565673828e+01 -5.2302700281143188e-01 -1.5393200683593750e+02 -5.0631099700927734e+01 -5.2293598651885986e-01 -1.5323999023437500e+02 -5.1161399841308594e+01 -5.2282398939132690e-01 -1.5160499572753906e+02 -5.2239803314208984e+01 -5.2252596616744995e-01 -1.5047399902343750e+02 -5.2836803436279297e+01 -5.2227300405502319e-01 -1.4987799072265625e+02 -5.3151397705078125e+01 -5.2213901281356812e-01 -1.4805899047851562e+02 -5.3893001556396484e+01 -5.2163201570510864e-01 -1.4759300231933594e+02 -5.4050098419189453e+01 -5.2148401737213135e-01 -1.4579800415039062e+02 -5.4535301208496094e+01 -5.2083802223205566e-01 -1.4571600341796875e+02 -5.4557403564453125e+01 -5.2080899477005005e-01 -1.4379299926757812e+02 -5.4879901885986328e+01 -5.1999801397323608e-01 -1.4144599914550781e+02 -5.5017898559570312e+01 -5.1890403032302856e-01 -1.2099099731445312e+02 -7.4380500793457031e+01 2.2331800460815430e+01 -1.2258599853515625e+02 -7.4496406555175781e+01 1.8148700714111328e+01 -1.2354700469970703e+02 -7.4587600708007812e+01 1.4863699913024902e+01 -1.2480300140380859e+02 -7.4786994934082031e+01 7.6887001991271973e+00 -1.2440699768066406e+02 -7.4701797485351562e+01 1.0753699302673340e+01 -1.2496200561523438e+02 -7.4856994628906250e+01 5.1684398651123047e+00 -1.5324099731445312e+02 -7.4981697082519531e+01 -5.2345103025436401e-01 -1.6508799743652344e+02 -7.3925804138183594e+01 -5.3148597478866577e-01 -1.7455799865722656e+02 -6.9554702758789062e+01 -5.3351497650146484e-01 -1.8032699584960938e+02 -6.4433898925781250e+01 -5.3332799673080444e-01 -1.8575000000000000e+02 -5.5674900054931641e+01 -5.3085899353027344e-01 -1.8595300292968750e+02 -5.5191699981689453e+01 -1.2574599822983146e-03 -1.8594400024414062e+02 -5.5188400268554688e+01 -5.3065896034240723e-01 -1.5110699462890625e+02 -7.4981697082519531e+01 -5.2345401048660278e-01 -1.8572500610351562e+02 -5.5726699829101562e+01 -5.3087800741195679e-01 -1.8407901000976562e+02 -5.9138397216796875e+01 -5.3210198879241943e-01 -1.8292201232910156e+02 -6.0927700042724609e+01 -5.3257298469543457e-01 -1.8198300170898438e+02 -6.2380798339843750e+01 -5.3295499086380005e-01 -1.7911599731445312e+02 -6.5651298522949219e+01 -5.3344500064849854e-01 -1.7761099243164062e+02 -6.7164802551269531e+01 -5.3358900547027588e-01 -1.7449400329589844e+02 -6.9595001220703125e+01 -5.3350800275802612e-01 -1.7220300292968750e+02 -7.1021995544433594e+01 -5.3324699401855469e-01 -1.6910800170898438e+02 -7.2518295288085938e+01 -5.3263199329376221e-01 -1.6875399780273438e+02 -7.2689598083496094e+01 -5.3256100416183472e-01 -1.6323399353027344e+02 -7.4294593811035156e+01 -5.3078800439834595e-01 -1.6111799621582031e+02 -7.4715698242187500e+01 -5.2999001741409302e-01 -1.5941299438476562e+02 -7.4816299438476562e+01 -5.2992397546768188e-01 -1.5646499633789062e+02 -7.4990303039550781e+01 -5.2980995178222656e-01 -1.9950000000000000e+02 -5.1715099334716797e+01 5.4354701042175293e+00 -1.9104200744628906e+02 -4.4901500701904297e+01 -2.6226900100708008e+01 -1.9109599304199219e+02 -4.5030002593994141e+01 -2.5998199462890625e+01 -1.9950000000000000e+02 -4.5033298492431641e+01 -2.6000000000000000e+01 -1.9140200805664062e+02 -4.5752700805664062e+01 -2.4711999893188477e+01 -1.9144799804687500e+02 -4.6573600769042969e+01 -2.3127901077270508e+01 -1.9113500976562500e+02 -4.8422798156738281e+01 -1.8953399658203125e+01 -1.9950000000000000e+02 -4.9454902648925781e+01 -1.6068899154663086e+01 -1.9036500549316406e+02 -4.4033500671386719e+01 -2.7659500122070312e+01 -1.9480900573730469e+02 -4.4033500671386719e+01 -2.7659500122070312e+01 -1.9480900573730469e+02 -4.0462097167968750e+01 -3.2662101745605469e+01 -1.9950000000000000e+02 -3.8643501281738281e+01 -3.4794700622558594e+01 -1.9480900573730469e+02 -3.9164100646972656e+01 -3.4207798004150391e+01 -1.9480900573730469e+02 -3.8616798400878906e+01 -3.4768600463867188e+01 -1.9480900573730469e+02 -2.1121099472045898e+01 -4.7428897857666016e+01 -1.9480900573730469e+02 -2.2334199905395508e+01 -4.6959300994873047e+01 -1.9950000000000000e+02 -2.1150300979614258e+01 -4.7504398345947266e+01 -1.9480900573730469e+02 -2.9068199157714844e+01 -4.3116497039794922e+01 -1.9950000000000000e+02 -3.0564800262451172e+01 -4.2068801879882812e+01 -1.9480900573730469e+02 -3.0500299453735352e+01 -4.1987098693847656e+01 -1.9480900573730469e+02 -3.5155899047851562e+01 -3.8315200805664062e+01 -1.9480900573730469e+02 -1.5103699684143066e+01 -4.9758098602294922e+01 -1.9950000000000000e+02 -1.0811399459838867e+01 -5.0863601684570312e+01 -1.9480900573730469e+02 -1.0780399322509766e+01 -5.0725299835205078e+01 -1.9950000000000000e+02 1.0811399459838867e+01 -5.0863601684570312e+01 -1.9480900573730469e+02 1.0780699729919434e+01 -5.0731101989746094e+01 -1.9480900573730469e+02 7.9257497787475586e+00 -5.1392398834228516e+01 -1.9950000000000000e+02 0.0000000000000000e+00 -5.2000000000000000e+01 -1.9480900573730469e+02 1.9633300602436066e-01 -5.1999599456787109e+01 -1.9480900573730469e+02 1.0099000064656138e-03 -5.1985698699951172e+01 -1.9480900573730469e+02 -7.5374798774719238e+00 -5.1450801849365234e+01 -1.9480900573730469e+02 3.0510301589965820e+01 -4.2000801086425781e+01 -1.9480900573730469e+02 2.9392999649047852e+01 -4.2895801544189453e+01 -1.9950000000000000e+02 3.0564800262451172e+01 -4.2068801879882812e+01 -1.9480900573730469e+02 2.2688199996948242e+01 -4.6789299011230469e+01 -1.9950000000000000e+02 2.1150300979614258e+01 -4.7504398345947266e+01 -1.9480900573730469e+02 2.1113901138305664e+01 -4.7412498474121094e+01 -1.9480900573730469e+02 1.5479000091552734e+01 -4.9642700195312500e+01 -1.9480900573730469e+02 3.5444198608398438e+01 -3.8048599243164062e+01 -1.9950000000000000e+02 3.8643501281738281e+01 -3.4794700622558594e+01 -1.9480900573730469e+02 3.8540500640869141e+01 -3.4699600219726562e+01 -1.9950000000000000e+02 4.9454902648925781e+01 -1.6068899154663086e+01 -1.9480900573730469e+02 4.9322696685791016e+01 -1.6028200149536133e+01 -1.9480900573730469e+02 4.8422401428222656e+01 -1.8954200744628906e+01 -1.9950000000000000e+02 4.5033298492431641e+01 -2.6000000000000000e+01 -1.9480900573730469e+02 4.5065998077392578e+01 -2.5943300247192383e+01 -1.9480900573730469e+02 4.5029300689697266e+01 -2.5997299194335938e+01 -1.9480900573730469e+02 4.0707599639892578e+01 -3.2355598449707031e+01 -1.9480900573730469e+02 5.1623001098632812e+01 5.4215798377990723e+00 -1.9480900573730469e+02 5.1855300903320312e+01 3.8766300678253174e+00 -1.9950000000000000e+02 5.1715099334716797e+01 5.4354701042175293e+00 -1.9480900573730469e+02 5.1855300903320312e+01 -3.8766300678253174e+00 -1.9950000000000000e+02 5.1715099334716797e+01 -5.4354701042175293e+00 -1.9480900573730469e+02 5.1623001098632812e+01 -5.4215798377990723e+00 -1.9480900573730469e+02 5.0702400207519531e+01 -1.1543699264526367e+01 -1.9480900573730469e+02 5.0702400207519531e+01 1.1543699264526367e+01 -1.9950000000000000e+02 4.9454902648925781e+01 1.6068899154663086e+01 -1.9480900573730469e+02 4.9322696685791016e+01 1.6028200149536133e+01 -1.9950000000000000e+02 4.5033298492431641e+01 2.6000000000000000e+01 -1.9480900573730469e+02 4.5029300689697266e+01 2.5997299194335938e+01 -1.9480900573730469e+02 4.5065998077392578e+01 2.5943300247192383e+01 -1.9480900573730469e+02 4.8422401428222656e+01 1.8954200744628906e+01 -1.9480900573730469e+02 4.0707599639892578e+01 3.2355598449707031e+01 -1.9950000000000000e+02 3.8643501281738281e+01 3.4794700622558594e+01 -1.9480900573730469e+02 3.8540500640869141e+01 3.4699600219726562e+01 -1.9480900573730469e+02 2.1113901138305664e+01 4.7412498474121094e+01 -1.9480900573730469e+02 2.2688199996948242e+01 4.6789299011230469e+01 -1.9950000000000000e+02 2.1150300979614258e+01 4.7504398345947266e+01 -1.9480900573730469e+02 2.9392999649047852e+01 4.2895801544189453e+01 -1.9950000000000000e+02 3.0564800262451172e+01 4.2068801879882812e+01 -1.9480900573730469e+02 3.0510301589965820e+01 4.2000801086425781e+01 -1.9480900573730469e+02 3.5444198608398438e+01 3.8048599243164062e+01 -1.9480900573730469e+02 1.5479000091552734e+01 4.9642700195312500e+01 -1.9950000000000000e+02 1.0811399459838867e+01 5.0863601684570312e+01 -1.9480900573730469e+02 1.0780699729919434e+01 5.0731101989746094e+01 -1.9950000000000000e+02 0.0000000000000000e+00 5.2000000000000000e+01 -1.9480900573730469e+02 1.0099000064656138e-03 5.1985698699951172e+01 -1.9480900573730469e+02 1.9633300602436066e-01 5.1999599456787109e+01 -1.9480900573730469e+02 7.9257497787475586e+00 5.1392398834228516e+01 -1.9480900573730469e+02 -7.5374798774719238e+00 5.1450801849365234e+01 -1.9950000000000000e+02 -1.0811399459838867e+01 5.0863601684570312e+01 -1.9480900573730469e+02 -1.0780399322509766e+01 5.0725299835205078e+01 -1.9480900573730469e+02 -3.0500299453735352e+01 4.1987098693847656e+01 -1.9480900573730469e+02 -2.9068199157714844e+01 4.3116497039794922e+01 -1.9950000000000000e+02 -3.0564800262451172e+01 4.2068801879882812e+01 -1.9480900573730469e+02 -2.2334199905395508e+01 4.6959300994873047e+01 -1.9950000000000000e+02 -2.1150300979614258e+01 4.7504398345947266e+01 -1.9480900573730469e+02 -2.1121099472045898e+01 4.7428897857666016e+01 -1.9480900573730469e+02 -1.5103699684143066e+01 4.9758098602294922e+01 -1.9480900573730469e+02 -3.5155899047851562e+01 3.8315200805664062e+01 -1.9950000000000000e+02 -3.8643501281738281e+01 3.4794700622558594e+01 -1.9480900573730469e+02 -3.8546100616455078e+01 3.4703399658203125e+01 -1.9950000000000000e+02 -4.5033298492431641e+01 2.6000000000000000e+01 -1.9480900573730469e+02 -4.0462097167968750e+01 3.2662101745605469e+01 -1.9950000000000000e+02 -4.9454902648925781e+01 1.6068899154663086e+01 -1.9053399658203125e+02 -5.1530300140380859e+01 -6.9730300903320312e+00 -1.9053900146484375e+02 -5.1672599792480469e+01 -5.4315299987792969e+00 -1.9950000000000000e+02 -5.1715099334716797e+01 -5.4354701042175293e+00 -1.9054699707031250e+02 -5.1935901641845703e+01 -2.5799300670623779e+00 -1.9060200500488281e+02 -5.1995998382568359e+01 -6.4547997713088989e-01 -1.9061399841308594e+02 -5.2000000000000000e+01 -1.5295400517061353e-03 -1.9093299865722656e+02 -4.9427402496337891e+01 -1.6059299468994141e+01 -1.9086801147460938e+02 -4.9751899719238281e+01 -1.5124300003051758e+01 -1.9063900756835938e+02 -5.0868000030517578e+01 -1.0790800094604492e+01 -1.8866600036621094e+02 -5.2395198822021484e+01 -1.3882101047784090e-03 -1.8865600585937500e+02 -5.2391799926757812e+01 -5.8584702014923096e-01 -1.8702600097656250e+02 -5.3518199920654297e+01 -1.2924699112772942e-03 -1.8701599121093750e+02 -5.3515098571777344e+01 -5.4544502496719360e-01 -1.8491799926757812e+02 -1.4022500038146973e+01 4.6196201324462891e+01 -1.8491799926757812e+02 7.3584299087524414e+00 4.7713500976562500e+01 -1.8491799926757812e+02 2.7288900375366211e+01 3.9825099945068359e+01 -1.8491799926757812e+02 4.1839900970458984e+01 2.4086099624633789e+01 -1.9124299621582031e+02 5.1426601409912109e+01 -3.8445599079132080e+00 -1.9124299621582031e+02 5.1426601409912109e+01 3.8445599079132080e+00 -1.8788200378417969e+02 5.0165199279785156e+01 3.7502598762512207e+00 -1.9124299621582031e+02 2.9149898529052734e+01 -4.2541198730468750e+01 -1.9124299621582031e+02 3.5151199340820312e+01 -3.7734100341796875e+01 -1.8788200378417969e+02 3.4289100646972656e+01 -3.6808597564697266e+01 -1.9124299621582031e+02 -4.0127601623535156e+01 3.2392101287841797e+01 -1.9124299621582031e+02 -3.4865299224853516e+01 3.7998500823974609e+01 -1.9124299621582031e+02 -2.2149600982666016e+01 4.6571098327636719e+01 -1.9124299621582031e+02 7.8602395057678223e+00 5.0967601776123047e+01 -1.9124299621582031e+02 1.5351099967956543e+01 4.9232299804687500e+01 -1.9124299621582031e+02 2.9149898529052734e+01 4.2541198730468750e+01 -1.9124299621582031e+02 4.8022197723388672e+01 1.8797500610351562e+01 -1.9124299621582031e+02 5.0283302307128906e+01 -1.1448300361633301e+01 -1.9124299621582031e+02 4.4693397521972656e+01 -2.5728799819946289e+01 -1.9124299621582031e+02 1.5351099967956543e+01 -4.9232299804687500e+01 -1.9124299621582031e+02 7.8602395057678223e+00 -5.0967601776123047e+01 -1.9124299621582031e+02 -7.4751400947570801e+00 -5.1025497436523438e+01 -1.9124299621582031e+02 -2.2149600982666016e+01 -4.6571098327636719e+01 -1.9124299621582031e+02 -2.8827899932861328e+01 -4.2760101318359375e+01 -1.8733300781250000e+02 -3.8394001007080078e+01 -3.2036201477050781e+01 -1.8789199829101562e+02 -3.8922801971435547e+01 -3.1824901580810547e+01 -1.8788200378417969e+02 -3.4010101318359375e+01 -3.7066398620605469e+01 -1.8970799255371094e+02 -4.0581401824951172e+01 -3.1064300537109375e+01 -1.9124699401855469e+02 -4.1789497375488281e+01 -3.0183900833129883e+01 -1.9124299621582031e+02 -4.0127601623535156e+01 -3.2392101287841797e+01 -1.8491799926757812e+02 -3.2639297485351562e+01 3.5572399139404297e+01 -1.8788200378417969e+02 -3.4010101318359375e+01 3.7066398620605469e+01 -1.9154399108886719e+02 -4.2022602081298828e+01 -3.0013999938964844e+01 -1.9343299865722656e+02 -4.3274497985839844e+01 -2.8718500137329102e+01 -1.9391700744628906e+02 -4.3556102752685547e+01 -2.8356698989868164e+01 -1.9479200744628906e+02 -4.4025001525878906e+01 -2.7672899246215820e+01 -1.9124299621582031e+02 -3.4865299224853516e+01 -3.7998500823974609e+01 -1.8825300598144531e+02 -3.9263801574707031e+01 -3.1688701629638672e+01 -1.8896899414062500e+02 -3.9939800262451172e+01 -3.1418600082397461e+01 -1.8491799926757812e+02 -3.2639297485351562e+01 -3.5572399139404297e+01 -1.8313400268554688e+02 -3.2862800598144531e+01 -3.2782699584960938e+01 -1.8437600708007812e+02 -3.4972297668457031e+01 -3.2552200317382812e+01 -1.8493499755859375e+02 -3.5684101104736328e+01 -3.2476600646972656e+01 -1.8580900573730469e+02 -3.6795700073242188e+01 -3.2358501434326172e+01 -1.9124299621582031e+02 4.0371101379394531e+01 -3.2088199615478516e+01 -1.9124299621582031e+02 4.8022197723388672e+01 -1.8797500610351562e+01 -1.9124299621582031e+02 4.4693397521972656e+01 2.5728799819946289e+01 -1.9124299621582031e+02 4.0371101379394531e+01 3.2088199615478516e+01 -1.9124299621582031e+02 3.5151199340820312e+01 3.7734100341796875e+01 -1.9124299621582031e+02 2.2500600814819336e+01 4.6402599334716797e+01 -1.9124299621582031e+02 1.9471000134944916e-01 5.1569702148437500e+01 -1.9124299621582031e+02 -7.4751400947570801e+00 5.1025497436523438e+01 -1.9124299621582031e+02 -1.4978899955749512e+01 4.9346801757812500e+01 -1.9124299621582031e+02 -2.8827899932861328e+01 4.2760101318359375e+01 -1.8491799926757812e+02 3.7793598175048828e+01 -3.0039400100708008e+01 -1.8788200378417969e+02 3.9380798339843750e+01 -3.1300998687744141e+01 -1.8491799926757812e+02 4.7072898864746094e+01 1.0717400550842285e+01 -1.8788200378417969e+02 4.9049900054931641e+01 1.1167500495910645e+01 -1.9124299621582031e+02 5.0283302307128906e+01 1.1448300361633301e+01 -1.8491799926757812e+02 -1.4022500038146973e+01 -4.6196201324462891e+01 -1.8491799926757812e+02 -2.0735399246215820e+01 -4.3597797393798828e+01 -1.8788200378417969e+02 -2.1606300354003906e+01 -4.5428699493408203e+01 -1.8491799926757812e+02 -6.9978799819946289e+00 -4.7767700195312500e+01 -1.8788200378417969e+02 -1.4611500740051270e+01 -4.8136302947998047e+01 -1.9124299621582031e+02 -1.4978899955749512e+01 -4.9346801757812500e+01 -1.8788200378417969e+02 -7.2917900085449219e+00 -4.9773902893066406e+01 -1.8788200378417969e+02 1.8993400037288666e-01 -5.0304801940917969e+01 -1.8491799926757812e+02 1.8227800726890564e-01 -4.8277198791503906e+01 -1.8491799926757812e+02 7.3584299087524414e+00 -4.7713500976562500e+01 -1.9124299621582031e+02 1.9471000134944916e-01 -5.1569702148437500e+01 -1.8788200378417969e+02 7.6674199104309082e+00 -4.9717399597167969e+01 -1.8491799926757812e+02 1.4371000289916992e+01 -4.6089000701904297e+01 -1.8788200378417969e+02 1.4974499702453613e+01 -4.8024700164794922e+01 -1.8788200378417969e+02 2.1948699951171875e+01 -4.5264301300048828e+01 -1.8491799926757812e+02 2.1064001083374023e+01 -4.3439899444580078e+01 -1.8491799926757812e+02 2.7288900375366211e+01 -3.9825099945068359e+01 -1.9124299621582031e+02 2.2500600814819336e+01 -4.6402599334716797e+01 -1.8788200378417969e+02 2.8434900283813477e+01 -4.1497699737548828e+01 -1.8491799926757812e+02 3.2907001495361328e+01 -3.5324901580810547e+01 -1.8491799926757812e+02 4.8143199920654297e+01 -3.5991101264953613e+00 -1.8491799926757812e+02 4.7072898864746094e+01 -1.0717400550842285e+01 -1.8788200378417969e+02 4.9049900054931641e+01 -1.1167500495910645e+01 -1.8491799926757812e+02 4.8143199920654297e+01 3.5991101264953613e+00 -1.8788200378417969e+02 5.0165199279785156e+01 -3.7502598762512207e+00 -1.8788200378417969e+02 -2.8120800018310547e+01 -4.1711200714111328e+01 -1.8491799926757812e+02 -2.6987400054931641e+01 -4.0030097961425781e+01 -1.8491799926757812e+02 4.1839900970458984e+01 -2.4086099624633789e+01 -1.8788200378417969e+02 4.3597198486328125e+01 -2.5097700119018555e+01 -1.8788200378417969e+02 4.6844200134277344e+01 -1.8336400985717773e+01 -1.8491799926757812e+02 4.4956100463867188e+01 -1.7597398757934570e+01 -1.8491799926757812e+02 4.4956100463867188e+01 1.7597398757934570e+01 -1.8788200378417969e+02 4.6844200134277344e+01 1.8336400985717773e+01 -1.8788200378417969e+02 4.3597198486328125e+01 2.5097700119018555e+01 -1.8788200378417969e+02 3.9380798339843750e+01 3.1300998687744141e+01 -1.8491799926757812e+02 3.7793598175048828e+01 3.0039400100708008e+01 -1.8491799926757812e+02 3.2907001495361328e+01 3.5324901580810547e+01 -1.8788200378417969e+02 3.4289100646972656e+01 3.6808597564697266e+01 -1.8788200378417969e+02 2.8434900283813477e+01 4.1497699737548828e+01 -1.8788200378417969e+02 2.1948699951171875e+01 4.5264301300048828e+01 -1.8491799926757812e+02 2.1064001083374023e+01 4.3439899444580078e+01 -1.8491799926757812e+02 1.4371000289916992e+01 4.6089000701904297e+01 -1.8788200378417969e+02 1.4974499702453613e+01 4.8024700164794922e+01 -1.8788200378417969e+02 7.6674199104309082e+00 4.9717399597167969e+01 -1.8788200378417969e+02 1.8993400037288666e-01 5.0304801940917969e+01 -1.8491799926757812e+02 1.8227800726890564e-01 4.8277198791503906e+01 -1.8491799926757812e+02 -6.9978799819946289e+00 4.7767700195312500e+01 -1.8788200378417969e+02 -7.2917900085449219e+00 4.9773902893066406e+01 -1.8788200378417969e+02 -1.4611500740051270e+01 4.8136302947998047e+01 -1.8788200378417969e+02 -2.1606300354003906e+01 4.5428699493408203e+01 -1.8491799926757812e+02 -2.0735399246215820e+01 4.3597797393798828e+01 -1.8491799926757812e+02 -2.6987400054931641e+01 4.0030097961425781e+01 -1.8788200378417969e+02 -2.8120800018310547e+01 4.1711200714111328e+01 -1.2112500000000000e+02 -7.4120903015136719e+01 -2.5174499511718750e+01 -1.2287899780273438e+02 -7.4270401000976562e+01 -2.0891300201416016e+01 -1.3711700439453125e+02 -7.4120903015136719e+01 -2.5174499511718750e+01 -1.2405200195312500e+02 -7.4402000427246094e+01 -1.7125099182128906e+01 -1.5047801208496094e+02 -7.4120201110839844e+01 -2.5174100875854492e+01 -1.2498999786376953e+02 -7.4552200317382812e+01 -1.2821099281311035e+01 -1.2539499664306641e+02 -7.4658401489257812e+01 -9.7812395095825195e+00 -1.2557999420166016e+02 -7.4771301269531250e+01 -6.5473299026489258e+00 -1.2554299926757812e+02 -7.4847900390625000e+01 -4.3558502197265625e+00 -1.2542399597167969e+02 -7.4899703979492188e+01 -2.8712699413299561e+00 -1.2528400421142578e+02 -7.4934799194335938e+01 -1.8669999837875366e+00 -1.2502600097656250e+02 -7.4974403381347656e+01 -7.3191303014755249e-01 -1.2514799499511719e+02 -7.4958396911621094e+01 -1.1888099908828735e+00 -1.8490699768066406e+02 -5.5286800384521484e+01 -2.5176898956298828e+01 -1.8443000793457031e+02 -5.6526000976562500e+01 -2.5177101135253906e+01 -1.8262399291992188e+02 -5.9879299163818359e+01 -2.5177499771118164e+01 -1.8220999145507812e+02 -6.0486202239990234e+01 -2.5177499771118164e+01 -1.8120899963378906e+02 -6.1952899932861328e+01 -2.5177598953247070e+01 -1.7875199890136719e+02 -6.4852203369140625e+01 -2.5177700042724609e+01 -1.7841400146484375e+02 -6.5162803649902344e+01 -2.5177700042724609e+01 -1.7593099975585938e+02 -6.7439804077148438e+01 -2.5177499771118164e+01 -1.7380699157714844e+02 -6.9006401062011719e+01 -2.5177400588989258e+01 -1.7377899169921875e+02 -6.9022903442382812e+01 -2.5177400588989258e+01 -1.7053399658203125e+02 -7.0920104980468750e+01 -2.5176898956298828e+01 -1.6838900756835938e+02 -7.1833297729492188e+01 -2.5176500320434570e+01 -1.6702400207519531e+02 -7.2414505004882812e+01 -2.5176198959350586e+01 -1.6481800842285156e+02 -7.3097198486328125e+01 -2.5175699234008789e+01 -1.6254100036621094e+02 -7.3554595947265625e+01 -2.5175100326538086e+01 -1.6109899902343750e+02 -7.3844100952148438e+01 -2.5174699783325195e+01 -1.5872799682617188e+02 -7.4003601074218750e+01 -2.5174200057983398e+01 -1.5700000000000000e+02 -7.4119903564453125e+01 -2.5173900604248047e+01 -1.8588699340820312e+02 -5.5127799987792969e+01 -2.6511499881744385e+00 -1.8585299682617188e+02 -5.4736598968505859e+01 -7.4666700363159180e+00 -1.8592399597167969e+02 -5.4105300903320312e+01 -1.1651599884033203e+01 -1.8609799194335938e+02 -5.3047100067138672e+01 -1.6402099609375000e+01 -1.8630699157714844e+02 -5.1790901184082031e+01 -2.0599498748779297e+01 -1.8655300903320312e+02 -5.0047100067138672e+01 -2.5175800323486328e+01 -1.8647299194335938e+02 -5.0420997619628906e+01 -2.5175899505615234e+01 -1.8578800964355469e+02 -5.2998699188232422e+01 -2.5176500320434570e+01 -1.7924299621582031e+02 -3.5085399627685547e+01 -3.0000000000000000e+01 -1.8217199707031250e+02 -3.9799400329589844e+01 -3.0000000000000000e+01 -1.8089799499511719e+02 -3.7602001190185547e+01 -3.0000000000000000e+01 -1.8280899047851562e+02 -3.9799400329589844e+01 -3.0000000000000000e+01 -1.7726100158691406e+02 -3.1079898834228516e+01 -3.0000000000000000e+01 -1.7419799804687500e+02 -2.3993400573730469e+01 -3.0000000000000000e+01 -1.7419400024414062e+02 -3.5164501190185547e+01 -3.0000000000000000e+01 -1.7254600524902344e+02 -4.5390098571777344e+01 -3.0000000000000000e+01 -1.8207299804687500e+02 -4.6204299926757812e+01 -3.0000000000000000e+01 -1.7349000549316406e+02 -4.1860599517822266e+01 -3.0000000000000000e+01 -1.8217800903320312e+02 -4.3896297454833984e+01 -3.0000000000000000e+01 -1.7403698730468750e+02 -3.8149200439453125e+01 -3.0000000000000000e+01 -1.5829199218750000e+02 -6.3119098663330078e+01 -3.0000000000000000e+01 -1.5505200195312500e+02 -6.4801902770996094e+01 -3.0000000000000000e+01 -1.5698200988769531e+02 -6.9122901916503906e+01 -3.0000000000000000e+01 -1.5161000061035156e+02 -6.6116493225097656e+01 -3.0000000000000000e+01 -1.4917098999023438e+02 -6.6785697937011719e+01 -3.0000000000000000e+01 -1.7842500305175781e+02 -3.3533401489257812e+01 -3.0000000000000000e+01 -1.7121200561523438e+02 -4.8781101226806641e+01 -3.0000000000000000e+01 -1.8102101135253906e+02 -5.1501197814941406e+01 -3.0000000000000000e+01 -1.8159199523925781e+02 -4.9353996276855469e+01 -3.0000000000000000e+01 -1.1748900604248047e+02 -6.7767303466796875e+01 -3.0000000000000000e+01 -1.1748900604248047e+02 -6.9123901367187500e+01 -3.0000000000000000e+01 -1.3189299011230469e+02 -6.7767303466796875e+01 -3.0000000000000000e+01 -1.3711700439453125e+02 -6.9123901367187500e+01 -3.0000000000000000e+01 -1.4159500122070312e+02 -6.7751701354980469e+01 -3.0000000000000000e+01 -1.4545500183105469e+02 -6.7451202392578125e+01 -3.0000000000000000e+01 -1.6241200256347656e+02 -6.0217498779296875e+01 -3.0000000000000000e+01 -1.7101899719238281e+02 -6.4859703063964844e+01 -3.0000000000000000e+01 -1.6512001037597656e+02 -5.7703800201416016e+01 -3.0000000000000000e+01 -1.7279200744628906e+02 -6.3551502227783203e+01 -3.0000000000000000e+01 -1.6750900268554688e+02 -5.4922599792480469e+01 -3.0000000000000000e+01 -1.7515000915527344e+02 -6.1389698028564453e+01 -3.0000000000000000e+01 -1.7720199584960938e+02 -5.8967601776123047e+01 -3.0000000000000000e+01 -1.6948699951171875e+02 -5.2027500152587891e+01 -3.0000000000000000e+01 -1.7838299560546875e+02 -5.7236598968505859e+01 -3.0000000000000000e+01 -1.7988999938964844e+02 -5.4439998626708984e+01 -3.0000000000000000e+01 -1.6042700195312500e+02 -6.8892700195312500e+01 -3.0000000000000000e+01 -1.6352600097656250e+02 -6.8270301818847656e+01 -3.0000000000000000e+01 -1.6132499694824219e+02 -6.1078399658203125e+01 -3.0000000000000000e+01 -1.6536299133300781e+02 -6.7701599121093750e+01 -3.0000000000000000e+01 -1.6828800964355469e+02 -6.6456306457519531e+01 -3.0000000000000000e+01 -1.4132901000976562e+02 -5.5365600585937500e+01 -1.0564000129699707e+01 -1.5805799865722656e+02 -4.6749698638916016e+01 -1.0343999862670898e+01 -1.5814199829101562e+02 -4.6621299743652344e+01 -1.0343800544738770e+01 -1.4173799133300781e+02 -5.5365798950195312e+01 -1.0574299812316895e+01 -1.4200399780273438e+02 -5.5361099243164062e+01 -1.0601599693298340e+01 -1.4405000305175781e+02 -5.5203502655029297e+01 -1.0642300605773926e+01 -1.4577099609375000e+02 -5.4904598236083984e+01 -1.0582099914550781e+01 -1.4608999633789062e+02 -5.4819900512695312e+01 -1.0572199821472168e+01 -1.4751000976562500e+02 -5.4442901611328125e+01 -1.0527999877929688e+01 -1.4855700683593750e+02 -5.4082698822021484e+01 -1.0498600006103516e+01 -1.5023001098632812e+02 -5.3368000030517578e+01 -1.0456600189208984e+01 -1.5076499938964844e+02 -5.3080398559570312e+01 -1.0444999694824219e+01 -1.5182499694824219e+02 -5.2511100769042969e+01 -1.0422200202941895e+01 -1.5333999633789062e+02 -5.1514598846435547e+01 -1.0394599914550781e+01 -1.5433500671386719e+02 -5.0747303009033203e+01 -1.0379099845886230e+01 -1.5484700012207031e+02 -5.0286800384521484e+01 -1.0372599601745605e+01 -1.5570100402832031e+02 -4.9518901824951172e+01 -1.0361700057983398e+01 -1.5694299316406250e+02 -4.8184398651123047e+01 -1.0350000381469727e+01 -1.5883200073242188e+02 -4.5571403503417969e+01 -1.0343099594116211e+01 -1.5971099853515625e+02 -4.3972599029541016e+01 -1.0347100257873535e+01 -1.6039199829101562e+02 -4.2418098449707031e+01 -1.0356499671936035e+01 -1.6043501281738281e+02 -4.2319499969482422e+01 -1.0357099533081055e+01 -1.6100799560546875e+02 -4.0615200042724609e+01 -1.0373399734497070e+01 -1.6135699462890625e+02 -3.9213100433349609e+01 -1.0391099929809570e+01 -1.6156500244140625e+02 -3.7950901031494141e+01 -1.0410799980163574e+01 -1.6165000915527344e+02 -3.7438400268554688e+01 -1.0418900489807129e+01 -1.6177700805664062e+02 -3.5865200042724609e+01 -1.0441900253295898e+01 -1.6179400634765625e+02 -3.5153602600097656e+01 -1.0419700622558594e+01 -1.6179699707031250e+02 -3.3393699645996094e+01 -1.0387799263000488e+01 -1.6179699707031250e+02 -3.2856502532958984e+01 -1.0387299537658691e+01 -1.6179499816894531e+02 -2.7037700653076172e+01 -1.0381999969482422e+01 -1.6179400634765625e+02 -2.1146800994873047e+01 -1.0376599311828613e+01 -1.6179299926757812e+02 -2.0042900085449219e+01 -1.0375599861145020e+01 -1.6179299926757812e+02 -1.5136799812316895e+01 -1.0375599861145020e+01 -1.6179299926757812e+02 -8.6208600997924805e+00 -1.0375599861145020e+01 -1.2499600219726562e+02 -5.5022197723388672e+01 -6.3680601119995117e-01 -1.2507499694824219e+02 -5.5031299591064453e+01 -8.9862304925918579e-01 -1.2520299530029297e+02 -5.5050102233886719e+01 -1.4364099502563477e+00 -1.2534199523925781e+02 -5.5077999114990234e+01 -2.2339198589324951e+00 -1.2547799682617188e+02 -5.5119201660156250e+01 -3.4140298366546631e+00 -1.2557398986816406e+02 -5.5180099487304688e+01 -5.1572899818420410e+00 -1.2554399871826172e+02 -5.5269901275634766e+01 -7.7299499511718750e+00 -1.3380000305175781e+02 -5.5362300872802734e+01 -1.0375599861145020e+01 -1.2533299255371094e+02 -5.5362300872802734e+01 -1.0375599861145020e+01 -1.6539999389648438e+02 -3.0843601226806641e+01 -2.1151800155639648e+01 -1.7010299682617188e+02 -3.2521499633789062e+01 -2.7867799758911133e+01 -1.7010299682617188e+02 -2.6017200469970703e+01 -2.7867799758911133e+01 -1.4668400573730469e+02 -5.8289600372314453e+01 -2.1204599380493164e+01 -1.4468600463867188e+02 -5.8615901947021484e+01 -2.1211299896240234e+01 -1.4584300231933594e+02 -6.3302398681640625e+01 -2.7972599029541016e+01 -1.4048199462890625e+02 -6.3671596527099609e+01 -2.7867799758911133e+01 -1.4148100280761719e+02 -6.3683399200439453e+01 -2.7904300689697266e+01 -1.4159600830078125e+02 -5.9015598297119141e+01 -2.1414899826049805e+01 -1.4494499206542969e+02 -6.3465400695800781e+01 -2.7975299835205078e+01 -1.4219099426269531e+02 -5.8938598632812500e+01 -2.1375499725341797e+01 -1.4466899108886719e+02 -5.8618000030517578e+01 -2.1211299896240234e+01 -1.5721000671386719e+02 -5.8952598571777344e+01 -2.7908298492431641e+01 -1.5334400939941406e+02 -5.5766799926757812e+01 -2.1184400558471680e+01 -1.5621699523925781e+02 -5.9624702453613281e+01 -2.7913099288940430e+01 -1.5188099670410156e+02 -5.6542697906494141e+01 -2.1188499450683594e+01 -1.4992800903320312e+02 -5.7361801147460938e+01 -2.1194400787353516e+01 -1.5181700134277344e+02 -6.1714702606201172e+01 -2.7939298629760742e+01 -1.5339100646972656e+02 -6.1105602264404297e+01 -2.7928899765014648e+01 -1.4825700378417969e+02 -6.2864803314208984e+01 -2.7965198516845703e+01 -1.5038900756835938e+02 -6.2267601013183594e+01 -2.7948598861694336e+01 -1.4799400329589844e+02 -5.7954200744628906e+01 -2.1200399398803711e+01 -1.4870800781250000e+02 -5.7771102905273438e+01 -2.1198099136352539e+01 -1.6103300476074219e+02 -4.8845001220703125e+01 -2.1166900634765625e+01 -1.5972999572753906e+02 -5.0520801544189453e+01 -2.1168998718261719e+01 -1.6426499938964844e+02 -5.2439498901367188e+01 -2.7882699966430664e+01 -1.6217898559570312e+02 -5.4874401092529297e+01 -2.7888198852539062e+01 -1.5827700805664062e+02 -5.2077499389648438e+01 -2.1171899795532227e+01 -1.6188000488281250e+02 -5.5153198242187500e+01 -2.7889200210571289e+01 -1.5794200134277344e+02 -5.2377998352050781e+01 -2.1172700881958008e+01 -1.5981300354003906e+02 -5.7077697753906250e+01 -2.7896600723266602e+01 -1.5667900085449219e+02 -5.3507701873779297e+01 -2.1175600051879883e+01 -1.5886500549316406e+02 -5.7832798004150391e+01 -2.7900499343872070e+01 -1.5551499938964844e+02 -5.4399299621582031e+01 -2.1178501129150391e+01 -1.5374499511718750e+02 -5.5553997039794922e+01 -2.1183300018310547e+01 -1.6159599304199219e+02 -4.7989498138427734e+01 -2.1166099548339844e+01 -1.6563099670410156e+02 -5.0437599182128906e+01 -2.7880701065063477e+01 -1.6193899536132812e+02 -4.7467399597167969e+01 -2.1165599822998047e+01 -1.6599301147460938e+02 -4.9907699584960938e+01 -2.7880100250244141e+01 -1.6296400451660156e+02 -4.5597099304199219e+01 -2.1164600372314453e+01 -1.6749900817871094e+02 -4.7071800231933594e+01 -2.7879999160766602e+01 -1.6380599975585938e+02 -4.3662700653076172e+01 -2.1164100646972656e+01 -1.6832199096679688e+02 -4.4984798431396484e+01 -2.7881799697875977e+01 -1.6409599304199219e+02 -4.2789600372314453e+01 -2.1164100646972656e+01 -1.6446800231933594e+02 -4.1668697357177734e+01 -2.1163999557495117e+01 -1.6866600036621094e+02 -4.4112201690673828e+01 -2.7882600784301758e+01 -1.6486898803710938e+02 -4.0029499053955078e+01 -2.1164199829101562e+01 -1.6949301147460938e+02 -4.1032501220703125e+01 -2.7887899398803711e+01 -1.6519898986816406e+02 -3.7957401275634766e+01 -2.1165000915527344e+01 -1.6980299377441406e+02 -3.8955497741699219e+01 -2.7893598556518555e+01 -1.6528298950195312e+02 -3.6984699249267578e+01 -2.1165498733520508e+01 -1.6539999389648438e+02 -3.2812801361083984e+01 -2.1152299880981445e+01 -1.6540899658203125e+02 -3.3286399841308594e+01 -2.1166799545288086e+01 -1.7010299682617188e+02 -3.4597797393798828e+01 -2.7867799758911133e+01 -1.6536900329589844e+02 -3.5969802856445312e+01 -2.1197700500488281e+01 -1.6531098937988281e+02 -3.6662002563476562e+01 -2.1165700912475586e+01 -1.6997900390625000e+02 -3.7775901794433594e+01 -2.7896900177001953e+01 -1.7010499572753906e+02 -3.5106498718261719e+01 -2.7877201080322266e+01 -1.7010299682617188e+02 -1.7582201004028320e+01 -2.7867799758911133e+01 -1.6539799499511719e+02 -2.0042900085449219e+01 -2.1149101257324219e+01 -1.6539900207519531e+02 -2.4674600601196289e+01 -2.1150300979614258e+01 -1.4076100158691406e+02 -5.9060302734375000e+01 -2.1414001464843750e+01 -1.3697299194335938e+02 -5.8967098236083984e+01 -2.1149101257324219e+01 -1.3939599609375000e+02 -6.3671596527099609e+01 -2.7867799758911133e+01 -1.3594299316406250e+02 -5.8967098236083984e+01 -2.1149101257324219e+01 -1.3289100646972656e+02 -6.3671596527099609e+01 -2.7867799758911133e+01 -1.3380000305175781e+02 -5.8967098236083984e+01 -2.1149101257324219e+01 -1.2977400207519531e+02 -5.8967098236083984e+01 -2.1149101257324219e+01 -1.2419100189208984e+02 -5.8967098236083984e+01 -2.1149101257324219e+01 -1.2410700225830078e+02 -5.9095699310302734e+01 -2.1332899093627930e+01 -1.3189299011230469e+02 -6.3671596527099609e+01 -2.7867799758911133e+01 -1.2182699584960938e+02 -6.2150299072265625e+01 -2.5695299148559570e+01 -1.2050299835205078e+02 -6.3671596527099609e+01 -2.7867799758911133e+01 -1.6282099914550781e+02 -3.3338798522949219e+01 -1.6039400100708008e+01 -1.2481500244140625e+02 -5.8041999816894531e+01 -1.9699199676513672e+01 -1.2496800231933594e+02 -5.7745899200439453e+01 -1.9169300079345703e+01 -1.2527400207519531e+02 -5.6894203186035156e+01 -1.7383399963378906e+01 -1.3380000305175781e+02 -5.6383697509765625e+01 -1.6023698806762695e+01 -1.2532700347900391e+02 -5.6405200958251953e+01 -1.6016000747680664e+01 -1.2524099731445312e+02 -5.5507400512695312e+01 -1.2181200027465820e+01 -1.2532900238037109e+02 -5.5941200256347656e+01 -1.4503999710083008e+01 -1.2534999847412109e+02 -5.6193099975585938e+01 -1.5423000335693359e+01 -1.2532399749755859e+02 -5.5364799499511719e+01 -1.0443599700927734e+01 -1.6281500244140625e+02 -2.0042900085449219e+01 -1.6023698806762695e+01 -1.6279501342773438e+02 -3.5883998870849609e+01 -1.6079700469970703e+01 -1.6265299987792969e+02 -3.7607700347900391e+01 -1.6051198959350586e+01 -1.6234800720214844e+02 -3.9461898803710938e+01 -1.6039001464843750e+01 -1.6198399353027344e+02 -4.0927200317382812e+01 -1.6031398773193359e+01 -1.6138699340820312e+02 -4.2708900451660156e+01 -1.6024600982666016e+01 -1.6063000488281250e+02 -4.4437301635742188e+01 -1.6020700454711914e+01 -1.5971200561523438e+02 -4.6109100341796875e+01 -1.6019599914550781e+01 -1.5890200805664062e+02 -4.7341297149658203e+01 -1.6020700454711914e+01 -1.5643798828125000e+02 -5.0236400604248047e+01 -1.6031000137329102e+01 -1.5773600769042969e+02 -4.8841300964355469e+01 -1.6024499893188477e+01 -1.5500999450683594e+02 -5.1520103454589844e+01 -1.6040500640869141e+01 -1.5238800048828125e+02 -5.3361999511718750e+01 -1.6063098907470703e+01 -1.5397100830078125e+02 -5.2321601867675781e+01 -1.6048700332641602e+01 -1.5072299194335938e+02 -5.4256000518798828e+01 -1.6080699920654297e+01 -1.4788400268554688e+02 -5.5375801086425781e+01 -1.6116399765014648e+01 -1.4897599792480469e+02 -5.5000801086425781e+01 -1.6101799011230469e+01 -1.4607000732421875e+02 -5.5855800628662109e+01 -1.6143100738525391e+01 -1.4427598571777344e+02 -5.6165599822998047e+01 -1.6172601699829102e+01 -1.4176699829101562e+02 -5.6399799346923828e+01 -1.6273599624633789e+01 -1.2089800262451172e+02 -7.4104499816894531e+01 -2.5439599990844727e+01 -1.1995899963378906e+02 -7.3439201354980469e+01 -2.7525499343872070e+01 -1.2038899993896484e+02 -7.3871200561523438e+01 -2.6569200515747070e+01 -1.3711700439453125e+02 -7.3394699096679688e+01 -2.7600000381469727e+01 -1.2081900024414062e+02 -7.4094200134277344e+01 -2.5543899536132812e+01 -1.2012599945068359e+02 -7.3697898864746094e+01 -2.7019599914550781e+01 -1.2040299987792969e+02 -7.3960403442382812e+01 -2.6268199920654297e+01 -1.1865399932861328e+02 -7.1799102783203125e+01 -2.9224100112915039e+01 -1.1891099548339844e+02 -7.2061897277832031e+01 -2.9045700073242188e+01 -1.3711700439453125e+02 -7.1573402404785156e+01 -2.9358900070190430e+01 -1.1942499542236328e+02 -7.2632202148437500e+01 -2.8562599182128906e+01 -1.1965299987792969e+02 -7.2946899414062500e+01 -2.8222499847412109e+01 -1.1992800140380859e+02 -7.3389205932617188e+01 -2.7596199035644531e+01 -1.1757999420166016e+02 -6.9889503479003906e+01 -2.9940999984741211e+01 -1.1780699920654297e+02 -7.0545997619628906e+01 -2.9793500900268555e+01 -1.1824200439453125e+02 -7.1292495727539062e+01 -2.9505201339721680e+01 -1.1846700286865234e+02 -7.1569297790527344e+01 -2.9351598739624023e+01 -1.5699699401855469e+02 -7.3393905639648438e+01 -2.7599699020385742e+01 -1.5699099731445312e+02 -7.1572494506835938e+01 -2.9358800888061523e+01 -1.1758300018310547e+02 -6.6990699768066406e+01 -2.9939298629760742e+01 -1.1786100006103516e+02 -6.6231895446777344e+01 -2.9758399963378906e+01 -1.1960700225830078e+02 -6.4242500305175781e+01 -2.8546199798583984e+01 -1.3189299011230469e+02 -6.5458602905273438e+01 -2.9434999465942383e+01 -1.1885599517822266e+02 -6.4883094787597656e+01 -2.9084199905395508e+01 -1.1835700225830078e+02 -6.5463806152343750e+01 -2.9425998687744141e+01 -1.1824300384521484e+02 -6.5596405029296875e+01 -2.9504100799560547e+01 -1.4153100585937500e+02 -6.5463699340820312e+01 -2.9445299148559570e+01 -1.6100199890136719e+02 -7.3124496459960938e+01 -2.7600200653076172e+01 -1.8646000671386719e+02 -4.8515201568603516e+01 -2.6874300003051758e+01 -1.8618899536132812e+02 -4.7790699005126953e+01 -2.7598100662231445e+01 -1.8576399230957031e+02 -5.0265899658203125e+01 -2.7600898742675781e+01 -1.8521299743652344e+02 -4.5802803039550781e+01 -2.8922000885009766e+01 -1.8460600280761719e+02 -4.4616302490234375e+01 -2.9353401184082031e+01 -1.8451300048828125e+02 -4.6419799804687500e+01 -2.9358999252319336e+01 -1.8356500244140625e+02 -4.2575199127197266e+01 -2.9804399490356445e+01 -1.8371600341796875e+02 -4.2873302459716797e+01 -2.9758600234985352e+01 -1.8425300598144531e+02 -4.3924800872802734e+01 -2.9526599884033203e+01 -1.8260699462890625e+02 -4.0669696807861328e+01 -2.9981000900268555e+01 -1.8217900085449219e+02 -3.9813598632812500e+01 -3.0000000000000000e+01 -1.8453199768066406e+02 -4.4471401214599609e+01 -2.9406101226806641e+01 -1.8616600036621094e+02 -4.7729202270507812e+01 -2.7659500122070312e+01 -1.8398399353027344e+02 -4.9876998901367188e+01 -2.9359199523925781e+01 -1.8576499938964844e+02 -4.6906299591064453e+01 -2.8316099166870117e+01 -1.8557000732421875e+02 -4.6517200469970703e+01 -2.8529800415039062e+01 -1.8658900451660156e+02 -4.9289402008056641e+01 -2.6044099807739258e+01 -1.8509500122070312e+02 -5.2780899047851562e+01 -2.7601200103759766e+01 -1.8200700378417969e+02 -5.9494701385498047e+01 -2.7601800918579102e+01 -1.8377000427246094e+02 -5.6222499847412109e+01 -2.7601499557495117e+01 -1.7822801208496094e+02 -6.4348304748535156e+01 -2.7601900100708008e+01 -1.8062600708007812e+02 -6.1518501281738281e+01 -2.7601800918579102e+01 -1.7340100097656250e+02 -6.8403099060058594e+01 -2.7601699829101562e+01 -1.7547399902343750e+02 -6.6874000549316406e+01 -2.7601800918579102e+01 -1.7020700073242188e+02 -7.0270698547363281e+01 -2.7601400375366211e+01 -1.8335699462890625e+02 -5.2235099792480469e+01 -2.9359199523925781e+01 -1.8211500549316406e+02 -5.5462200164794922e+01 -2.9359300613403320e+01 -1.8046099853515625e+02 -5.8531600952148438e+01 -2.9359399795532227e+01 -1.7916600036621094e+02 -6.0430500030517578e+01 -2.9359399795532227e+01 -1.7691500854492188e+02 -6.3086399078369141e+01 -2.9359399795532227e+01 -1.7433000183105469e+02 -6.5456893920898438e+01 -2.9359399795532227e+01 -1.7238500976562500e+02 -6.6891700744628906e+01 -2.9359300613403320e+01 -1.6938899230957031e+02 -6.8643798828125000e+01 -2.9359300613403320e+01 -1.6617700195312500e+02 -7.0011398315429688e+01 -2.9359199523925781e+01 -1.6415899658203125e+02 -7.0636100769042969e+01 -2.9359100341796875e+01 -1.6678201293945312e+02 -7.1729103088378906e+01 -2.7601100921630859e+01 -1.6462998962402344e+02 -7.2395401000976562e+01 -2.7600801467895508e+01 -1.6075700378417969e+02 -7.1319801330566406e+01 -2.9358900070190430e+01 -1.7189100646972656e+02 -3.5131900787353516e+01 -2.9437700271606445e+01 -1.7010800170898438e+02 -4.2502798140048981e-02 -2.7875398635864258e+01 -1.7190100097656250e+02 -1.1731699943542480e+01 -2.9415100097656250e+01 -1.7127500915527344e+02 -8.0832805633544922e+00 -2.9056598663330078e+01 -1.7081600952148438e+02 -5.1610498428344727e+00 -2.8682500839233398e+01 -1.7315599060058594e+02 -1.8632799148559570e+01 -2.9890100479125977e+01 -1.7296099853515625e+02 -1.7582298278808594e+01 -2.9827098846435547e+01 -1.7188999938964844e+02 -1.7582201004028320e+01 -2.9434999465942383e+01 -1.7217401123046875e+02 -1.3326199531555176e+01 -2.9571800231933594e+01 -1.4516900634765625e+02 -6.5219604492187500e+01 -2.9465200424194336e+01 -1.7175399780273438e+02 -3.7939102172851562e+01 -2.9443201065063477e+01 -1.7123899841308594e+02 -4.1394401550292969e+01 -2.9440601348876953e+01 -1.7036099243164062e+02 -4.4670398712158203e+01 -2.9439098358154297e+01 -1.6912100219726562e+02 -4.7818401336669922e+01 -2.9438400268554688e+01 -1.6751899719238281e+02 -5.0833499908447266e+01 -2.9438499450683594e+01 -1.6568200683593750e+02 -5.3524200439453125e+01 -2.9439199447631836e+01 -1.6346398925781250e+02 -5.6110900878906250e+01 -2.9440799713134766e+01 -1.6095001220703125e+02 -5.8450901031494141e+01 -2.9443099975585938e+01 -1.5994100952148438e+02 -5.9252601623535156e+01 -2.9444200515747070e+01 -1.5712599182128906e+02 -6.1154998779296875e+01 -2.9447700500488281e+01 -1.5092500305175781e+02 -6.3957901000976562e+01 -2.9457698822021484e+01 -1.5411999511718750e+02 -6.2726402282714844e+01 -2.9452199935913086e+01 -1.4865901184082031e+02 -6.4589096069335938e+01 -2.9462400436401367e+01 -1.8218598937988281e+02 -3.9806499481201172e+01 -3.0000000000000000e+01 -1.8304200744628906e+02 -4.0234600067138672e+01 -2.9981000900268555e+01 -1.8484100341796875e+02 -4.0760902404785156e+01 -2.9906700134277344e+01 -1.9478599548339844e+02 -4.4028800964355469e+01 -2.7666900634765625e+01 -1.8494898986816406e+02 -4.1184101104736328e+01 -2.9804399490356445e+01 -1.8525099182128906e+02 -4.1334300994873047e+01 -2.9758600234985352e+01 -1.8702200317382812e+02 -4.1679500579833984e+01 -2.9633001327514648e+01 -1.8689500427246094e+02 -4.2163101196289062e+01 -2.9406101226806641e+01 -1.8800799560546875e+02 -4.2057300567626953e+01 -2.9461101531982422e+01 -1.8699499511718750e+02 -4.2215599060058594e+01 -2.9371601104736328e+01 -1.8845500183105469e+02 -4.2210601806640625e+01 -2.9363300323486328e+01 -1.8830799865722656e+02 -4.2900802612304688e+01 -2.8922000885009766e+01 -1.9045600891113281e+02 -4.2896697998046875e+01 -2.8925201416015625e+01 -1.8948799133300781e+02 -4.3541599273681641e+01 -2.8316099166870117e+01 -1.9297500610351562e+02 -4.3611198425292969e+01 -2.8235799789428711e+01 -1.9361900329589844e+02 -4.3769199371337891e+01 -2.8039899826049805e+01 -1.8714300537109375e+02 -4.6094398498535156e+01 -2.7173099517822266e+01 -1.8672200012207031e+02 -4.5523300170898438e+01 -2.7857101440429688e+01 -1.8218099975585938e+02 -3.9811203002929688e+01 -3.0000000000000000e+01 -1.8275100708007812e+02 -4.0524402618408203e+01 -2.9972599029541016e+01 -1.8401300048828125e+02 -4.2100700378417969e+01 -2.9719799041748047e+01 -1.8420899963378906e+02 -4.2345500946044922e+01 -2.9655000686645508e+01 -1.8525000000000000e+02 -4.3644699096679688e+01 -2.9173400878906250e+01 -1.8218299865722656e+02 -3.9808898925781250e+01 -3.0000000000000000e+01 -1.8289599609375000e+02 -4.0379199981689453e+01 -2.9972599029541016e+01 -1.8447700500488281e+02 -4.1634300231933594e+01 -2.9719799041748047e+01 -1.8472500610351562e+02 -4.1828800201416016e+01 -2.9655000686645508e+01 -1.8605099487304688e+02 -4.2862098693847656e+01 -2.9173400878906250e+01 -1.8608699035644531e+02 -4.4696800231933594e+01 -2.8558900833129883e+01 -1.8714900207519531e+02 -4.3701400756835938e+01 -2.8558900833129883e+01 -1.8801599121093750e+02 -4.4354400634765625e+01 -2.7857101440429688e+01 -1.8861900329589844e+02 -4.4795497894287109e+01 -2.7173099517822266e+01 -1.8746299743652344e+02 -4.6824100494384766e+01 -2.6207000732421875e+01 -1.8908399963378906e+02 -4.5546199798583984e+01 -2.5978000640869141e+01 -1.8757598876953125e+02 -4.7534500122070312e+01 -2.5214799880981445e+01 -1.8748899841308594e+02 -4.8220298767089844e+01 -2.4206899642944336e+01 -1.8928900146484375e+02 -4.6276100158691406e+01 -2.4740800857543945e+01 -1.8924101257324219e+02 -4.6976997375488281e+01 -2.3473798751831055e+01 -1.8901699829101562e+02 -4.8814300537109375e+01 -1.9250499725341797e+01 -1.8695999145507812e+02 -5.3455501556396484e+01 -2.5882098674774170e+00 -1.8860000610351562e+02 -5.2332401275634766e+01 -2.5631201267242432e+00 -1.8856900024414062e+02 -5.1925800323486328e+01 -7.0516500473022461e+00 -1.8864199829101562e+02 -5.1260700225830078e+01 -1.0947800636291504e+01 -1.8881500244140625e+02 -5.0141899108886719e+01 -1.5361700057983398e+01 -1.8691999816894531e+02 -5.3055099487304688e+01 -7.2255101203918457e+00 -1.8697799682617188e+02 -5.2403301239013672e+01 -1.1251600265502930e+01 -1.8712599182128906e+02 -5.1309101104736328e+01 -1.5814300537109375e+01 -1.8729899597167969e+02 -5.0012599945068359e+01 -1.9836099624633789e+01 -1.7211300659179688e+02 -7.6239700317382812e+00 -2.9850799560546875e+01 -1.7131599426269531e+02 -4.8583698272705078e+00 -2.9228700637817383e+01 -1.7011100769042969e+02 -3.9860203862190247e-02 -2.7880399703979492e+01 -1.7011000061035156e+02 -4.1181501001119614e-02 -2.7877901077270508e+01 -1.7107800292968750e+02 -5.0092301368713379e+00 -2.8944601058959961e+01 -1.7172000122070312e+02 -7.8518400192260742e+00 -2.9425100326538086e+01 -1.7299099731445312e+02 -1.2958800315856934e+01 -3.0045700073242188e+01 -1.7437901306152344e+02 -1.8129798889160156e+01 -3.0351200103759766e+01 -1.7369100952148438e+02 -1.2606400489807129e+01 -3.0687900543212891e+01 -1.7542399597167969e+02 -1.7666200637817383e+01 -3.1159700393676758e+01 -1.7725900268554688e+02 -2.2781599044799805e+01 -3.1236600875854492e+01 -1.7583300781250000e+02 -2.3346200942993164e+01 -3.0319299697875977e+01 -1.7892498779296875e+02 -3.0306200027465820e+01 -3.0348999023437500e+01 -1.8009999084472656e+02 -3.2722301483154297e+01 -3.0358999252319336e+01 -1.8035699462890625e+02 -2.9640499114990234e+01 -3.1347301483154297e+01 -1.8153401184082031e+02 -3.2027698516845703e+01 -3.1384502410888672e+01 -1.8081399536132812e+02 -3.4187702178955078e+01 -3.0339200973510742e+01 -1.8217300415039062e+02 -3.3411701202392578e+01 -3.1310699462890625e+01 -1.8227699279785156e+02 -3.6559200286865234e+01 -3.0308399200439453e+01 -1.8348599243164062e+02 -3.5645000457763672e+01 -3.1195600509643555e+01 -1.8502000427246094e+02 -3.7585601806640625e+01 -3.1099998474121094e+01 -1.8450000000000000e+02 -3.8105899810791016e+01 -3.0691501617431641e+01 -1.8397999572753906e+02 -3.8626102447509766e+01 -3.0283000946044922e+01 -1.8620300292968750e+02 -3.9377201080322266e+01 -3.0612800598144531e+01 -1.8804800415039062e+02 -4.0660900115966797e+01 -3.0323398590087891e+01 -1.8889201354980469e+02 -4.1197898864746094e+01 -3.0114299774169922e+01 -1.9478900146484375e+02 -4.4026901245117188e+01 -2.7669898986816406e+01 -1.9376799011230469e+02 -4.3657897949218750e+01 -2.8194999694824219e+01 -1.9320500183105469e+02 -4.3431697845458984e+01 -2.8468801498413086e+01 -1.9100900268554688e+02 -4.2402900695800781e+01 -2.9415401458740234e+01 -1.2220200347900391e+02 -5.5144702911376953e+01 -1.5733899116516113e+01 -1.2303099822998047e+02 -5.5651298522949219e+01 -1.5601400375366211e+01 -1.2325900268554688e+02 -5.5519599914550781e+01 -1.4667499542236328e+01 -1.1965999603271484e+02 -5.5006900787353516e+01 -2.1906999588012695e+01 -1.2060099792480469e+02 -5.6761997222900391e+01 -2.1096199035644531e+01 -1.2143699645996094e+02 -5.6461597442626953e+01 -1.9745500564575195e+01 -1.2037199401855469e+02 -5.5054798126220703e+01 -2.0262998580932617e+01 -1.2169699859619141e+02 -5.6350200653076172e+01 -1.9247499465942383e+01 -1.2062100219726562e+02 -5.5071498870849609e+01 -1.9688800811767578e+01 -1.2242800140380859e+02 -5.5990699768066406e+01 -1.7539499282836914e+01 -1.2143299865722656e+02 -5.5126201629638672e+01 -1.7812299728393555e+01 -1.2162999725341797e+02 -5.5139499664306641e+01 -1.7357900619506836e+01 -1.2331199645996094e+02 -5.5141399383544922e+01 -1.2241899490356445e+01 -1.2296800231933594e+02 -5.5151599884033203e+01 -1.3558400154113770e+01 -1.2254499816894531e+02 -5.5147800445556641e+01 -1.4758299827575684e+01 -1.2373899841308594e+02 -5.5280399322509766e+01 -1.2227100372314453e+01 -1.2407600402832031e+02 -5.5199897766113281e+01 -1.0318599700927734e+01 -1.2381999969482422e+02 -5.5126201629638672e+01 -1.0294199943542480e+01 -1.2409000396728516e+02 -5.5198596954345703e+01 -1.0242500305175781e+01 -1.2383999633789062e+02 -5.5125698089599609e+01 -1.0217100143432617e+01 -1.2221199798583984e+02 -5.8171901702880859e+01 -2.0825399398803711e+01 -1.2299499511718750e+02 -5.7526802062988281e+01 -1.9529300689697266e+01 -1.2321800231933594e+02 -5.7307300567626953e+01 -1.9045000076293945e+01 -1.2378299713134766e+02 -5.6641899108886719e+01 -1.7372800827026367e+01 -1.2415599822998047e+02 -5.6056800842285156e+01 -1.5472100257873535e+01 -1.2426999664306641e+02 -5.5838199615478516e+01 -1.4559599876403809e+01 -1.2448100280761719e+02 -5.5450901031494141e+01 -1.2196999549865723e+01 -1.2469499969482422e+02 -5.5322097778320312e+01 -1.0378999710083008e+01 -1.2470700073242188e+02 -5.5319999694824219e+01 -1.0307099342346191e+01 -1.1958900451660156e+02 -5.5000701904296875e+01 -2.2058799743652344e+01 -1.2050000000000000e+02 -5.6804798126220703e+01 -2.1245599746704102e+01 -1.2211299896240234e+02 -5.8263301849365234e+01 -2.0980300903320312e+01 -1.2498200225830078e+02 -5.5030300140380859e+01 -9.1843402385711670e-01 -1.2425400543212891e+02 -5.5110099792480469e+01 -7.6662898063659668e+00 -1.2463299560546875e+02 -5.5096000671386719e+01 -5.3248400688171387e+00 -1.2464500427246094e+02 -5.5094001770019531e+01 -5.1822700500488281e+00 -1.2478599548339844e+02 -5.5070301055908203e+01 -3.4529001712799072e+00 -1.2488300323486328e+02 -5.5054100036621094e+01 -2.2757599353790283e+00 -1.2494800567626953e+02 -5.5043197631835938e+01 -1.4795099496841431e+00 -1.2496600341796875e+02 -5.5040199279785156e+01 -1.2593299150466919e+00 -1.1842499542236328e+02 -5.9823200225830078e+01 -2.5354501724243164e+01 -1.1721300506591797e+02 -6.1327201843261719e+01 -2.7402799606323242e+01 -1.1995800018310547e+02 -6.1275199890136719e+01 -2.5225999832153320e+01 -1.1870300292968750e+02 -6.2776000976562500e+01 -2.7342100143432617e+01 -1.1531800079345703e+02 -6.7767303466796875e+01 -3.0559801101684570e+01 -1.1599600219726562e+02 -6.7767303466796875e+01 -3.0228099822998047e+01 -1.1608200073242188e+02 -6.6776100158691406e+01 -3.0142499923706055e+01 -1.1472100067138672e+02 -6.6508895874023438e+01 -3.0789300918579102e+01 -1.1463899993896484e+02 -6.7767303466796875e+01 -3.0891500473022461e+01 -1.1633399963378906e+02 -6.5815101623535156e+01 -2.9888700485229492e+01 -1.1668099975585938e+02 -6.5021903991699219e+01 -2.9534698486328125e+01 -1.1723400115966797e+02 -6.4152893066406250e+01 -2.8957700729370117e+01 -1.1790700531005859e+02 -6.3403396606445312e+01 -2.8232601165771484e+01 -1.1496199798583984e+02 -6.5285499572753906e+01 -3.0485700607299805e+01 -1.1529199981689453e+02 -6.4270492553710938e+01 -3.0061201095581055e+01 -1.1581900024414062e+02 -6.3148998260498047e+01 -2.9366600036621094e+01 -1.1645899963378906e+02 -6.2167598724365234e+01 -2.8488901138305664e+01 -1.1599600219726562e+02 -6.9123901367187500e+01 -3.0228099822998047e+01 -1.1531800079345703e+02 -6.9123901367187500e+01 -3.0559801101684570e+01 -1.1463899993896484e+02 -6.9123901367187500e+01 -3.0891500473022461e+01 -1.1664400482177734e+02 -7.3263900756835938e+01 -2.9084800720214844e+01 -1.1728399658203125e+02 -7.2802497863769531e+01 -2.8905300140380859e+01 -1.1705300140380859e+02 -7.2486602783203125e+01 -2.9149000167846680e+01 -1.1517400360107422e+02 -7.4545394897460938e+01 -2.9800899505615234e+01 -1.1586599731445312e+02 -7.3825698852539062e+01 -2.9303400039672852e+01 -1.1564599609375000e+02 -7.3416000366210938e+01 -2.9597200393676758e+01 -1.1668000030517578e+02 -7.1866401672363281e+01 -2.9536399841308594e+01 -1.1628600311279297e+02 -7.0933403015136719e+01 -2.9937900543212891e+01 -1.1607900238037109e+02 -7.0101097106933594e+01 -3.0145000457763672e+01 -1.1529100036621094e+02 -7.2616897583007812e+01 -3.0063100814819336e+01 -1.1491600036621094e+02 -7.1423599243164062e+01 -3.0544500350952148e+01 -1.1471900177001953e+02 -7.0364601135253906e+01 -3.0792198181152344e+01 -1.1721300506591797e+02 -7.3462005615234375e+01 -2.8528699874877930e+01 -1.1993099975585938e+02 -7.4328498840332031e+01 -2.4627498626708984e+01 -1.1563300323486328e+02 -7.4688201904296875e+01 -2.9150400161743164e+01 -1.1961399841308594e+02 -7.4341903686523438e+01 -2.4956100463867188e+01 -1.1952500152587891e+02 -7.4337699890136719e+01 -2.5096500396728516e+01 -1.1897000122070312e+02 -7.4250801086425781e+01 -2.6026500701904297e+01 -1.1845800018310547e+02 -7.4065795898437500e+01 -2.6911500930786133e+01 -1.1810600280761719e+02 -7.3895698547363281e+01 -2.7466699600219727e+01 -1.1754699707031250e+02 -7.3614097595214844e+01 -2.8188199996948242e+01 -1.1610200500488281e+02 -7.4834197998046875e+01 -2.8485599517822266e+01 -1.1593800354003906e+02 -7.4783302307128906e+01 -2.8717300415039062e+01 -1.1985299682617188e+02 -7.4341995239257812e+01 -2.4591699600219727e+01 -1.2496299743652344e+02 -7.4919502258300781e+01 -2.9234900474548340e+00 -1.2497899627685547e+02 -7.4878799438476562e+01 -4.3862500190734863e+00 -1.2456700134277344e+02 -7.4731002807617188e+01 -9.7029800415039062e+00 -1.2489499664306641e+02 -7.4818901062011719e+01 -6.5386300086975098e+00 -1.2405400085449219e+02 -7.4648597717285156e+01 -1.2666500091552734e+01 -1.2299600219726562e+02 -7.4532600402832031e+01 -1.6847400665283203e+01 -1.2174499511718750e+02 -7.4431396484375000e+01 -2.0493099212646484e+01 -1.1965999603271484e+02 -5.4997802734375000e+01 -2.1907199859619141e+01 -1.1965999603271484e+02 -5.5002296447753906e+01 -2.1907100677490234e+01 -1.2153899383544922e+02 -5.4941097259521484e+01 -1.7332300186157227e+01 -1.2366300201416016e+02 -5.5021900177001953e+01 -1.0182599067687988e+01 -1.2354199981689453e+02 -5.4853500366210938e+01 -1.0159799575805664e+01 -1.2274800109863281e+02 -5.4888198852539062e+01 -1.3506299972534180e+01 -1.2283499908447266e+02 -5.5040199279785156e+01 -1.3525700569152832e+01 -1.2157399749755859e+02 -5.5045501708984375e+01 -1.7341300964355469e+01 -1.2472399902343750e+02 -5.4967002868652344e+01 -1.2553300857543945e+00 -1.2474600219726562e+02 -5.4955200195312500e+01 -6.3603097200393677e-01 -1.2454900360107422e+02 -5.4785099029541016e+01 -1.2556899785995483e+00 -1.2456300354003906e+02 -5.4772296905517578e+01 -6.4013701677322388e-01 -1.2442700195312500e+02 -5.5002700805664062e+01 -5.3046898841857910e+00 -1.2428200531005859e+02 -5.4826999664306641e+01 -5.2919402122497559e+00 -1.2480899810791016e+02 -5.4967899322509766e+01 -5.2331501245498657e-01 -1.2474700164794922e+02 -5.4951297760009766e+01 -5.2325701713562012e-01 -1.2465599822998047e+02 -5.4859798431396484e+01 -5.2550703287124634e-01 -1.2454800415039062e+02 -5.4706497192382812e+01 -5.2974903583526611e-01 -1.2456400299072266e+02 -5.4768398284912109e+01 -5.2775800228118896e-01 -1.2480899810791016e+02 -5.4970996856689453e+01 0.0000000000000000e+00 -1.2453500366210938e+02 -5.4709697723388672e+01 5.2950698137283325e-01 -1.2453799438476562e+02 -5.4700401306152344e+01 0.0000000000000000e+00 -1.2457100677490234e+02 -5.4763599395751953e+01 5.2799695730209351e-01 -1.2464600372314453e+02 -5.4862701416015625e+01 0.0000000000000000e+00 -1.2480599975585938e+02 -5.4980197906494141e+01 5.2285099029541016e-01 -1.2475199890136719e+02 -5.4944198608398438e+01 5.2355301380157471e-01 -1.2464399719238281e+02 -5.4871799468994141e+01 5.2496302127838135e-01 -1.2474600219726562e+02 -5.4955200195312500e+01 6.3603097200393677e-01 -1.2456300354003906e+02 -5.4772296905517578e+01 6.4013701677322388e-01 -1.2452100372314453e+02 -5.4796600341796875e+01 2.0258400440216064e+00 -1.2468899536132812e+02 -5.4977397918701172e+01 2.0288200378417969e+00 -1.2423300170898438e+02 -5.5010200500488281e+01 6.8561401367187500e+00 -1.2409700012207031e+02 -5.4836799621582031e+01 6.8398098945617676e+00 -1.2354199981689453e+02 -5.4853500366210938e+01 1.0159799575805664e+01 -1.2366300201416016e+02 -5.5021900177001953e+01 1.0182599067687988e+01 -1.2234400177001953e+02 -5.4907897949218750e+01 1.4903200149536133e+01 -1.1965999603271484e+02 -5.5002296447753906e+01 2.1907100677490234e+01 -1.2103000640869141e+02 -5.5037700653076172e+01 1.8748600006103516e+01 -1.2101099395751953e+02 -5.4959098815917969e+01 1.8743900299072266e+01 -1.1965999603271484e+02 -5.4997802734375000e+01 2.1907199859619141e+01 -1.2241200256347656e+02 -5.5046199798583984e+01 1.4919400215148926e+01 -1.1458799743652344e+02 -7.5000000000000000e+01 -2.9720300674438477e+01 -3.8556301116943359e+01 -7.5000000000000000e+01 3.8730800628662109e+01 -1.1421099853515625e+02 -7.5000000000000000e+01 -3.0206001281738281e+01 -1.0834799957275391e+02 -7.5000000000000000e+01 -3.6974800109863281e+01 -3.1142299652099609e+01 -7.5000000000000000e+01 3.0688600540161133e+01 -1.0834799957275391e+02 -7.5000000000000000e+01 3.6974800109863281e+01 -1.1421099853515625e+02 -7.5000000000000000e+01 3.0206001281738281e+01 -1.1479900360107422e+02 -7.5000000000000000e+01 2.9472398757934570e+01 -4.7501499176025391e+01 -7.5000000000000000e+01 4.5025798797607422e+01 -8.9885299682617188e+01 -7.5000000000000000e+01 4.8476699829101562e+01 -9.9731101989746094e+01 -7.5000000000000000e+01 4.3711799621582031e+01 -5.7574398040771484e+01 -7.5000000000000000e+01 4.9289699554443359e+01 -6.8320602416992188e+01 -7.5000000000000000e+01 5.1330101013183594e+01 -7.9255401611328125e+01 -7.5000000000000000e+01 5.1055000305175781e+01 -9.9731101989746094e+01 -7.5000000000000000e+01 -4.3711799621582031e+01 -4.7501499176025391e+01 -7.5000000000000000e+01 -4.5025798797607422e+01 -3.8556301116943359e+01 -7.5000000000000000e+01 -3.8730800628662109e+01 -3.1142299652099609e+01 -7.5000000000000000e+01 -3.0688600540161133e+01 -2.5593999862670898e+01 -7.5000000000000000e+01 -2.1261999130249023e+01 -2.2161600112915039e+01 -7.5000000000000000e+01 -1.0876299858093262e+01 -2.1000101089477539e+01 -7.5000000000000000e+01 0.0000000000000000e+00 -2.2161600112915039e+01 -7.5000000000000000e+01 1.0876299858093262e+01 -2.5593999862670898e+01 -7.5000000000000000e+01 2.1261999130249023e+01 -8.9885299682617188e+01 -7.5000000000000000e+01 -4.8476699829101562e+01 -7.9255401611328125e+01 -7.5000000000000000e+01 -5.1055000305175781e+01 -5.7574398040771484e+01 -7.5000000000000000e+01 -4.9289699554443359e+01 -6.8320602416992188e+01 -7.5000000000000000e+01 -5.1330101013183594e+01 -3.4228099822998047e+01 -5.3500000000000000e+01 -3.4460201263427734e+01 -4.2229099273681641e+01 -5.3500000000000000e+01 -4.1664398193359375e+01 -5.1553100585937500e+01 -5.3500000000000000e+01 -4.7047500610351562e+01 -6.1792602539062500e+01 -5.3500000000000000e+01 -5.0374599456787109e+01 -7.2500000000000000e+01 -5.3500000000000000e+01 -5.1500000000000000e+01 -8.3207504272460938e+01 -5.3500000000000000e+01 -5.0374599456787109e+01 -9.3446899414062500e+01 -5.3500000000000000e+01 -4.7047500610351562e+01 -1.0277099609375000e+02 -5.3500000000000000e+01 -4.1664398193359375e+01 -1.1077199554443359e+02 -5.3500000000000000e+01 -3.4460201263427734e+01 -1.1709999847412109e+02 -5.3500000000000000e+01 -2.5750000000000000e+01 -1.2147899627685547e+02 -5.3500000000000000e+01 -1.5914399147033691e+01 -1.2371800231933594e+02 -5.3500000000000000e+01 -5.3831896781921387e+00 -1.2371800231933594e+02 -5.3500000000000000e+01 5.3831896781921387e+00 -1.2147899627685547e+02 -5.3500000000000000e+01 1.5914399147033691e+01 -1.1709999847412109e+02 -5.3500000000000000e+01 2.5750000000000000e+01 -1.1077199554443359e+02 -5.3500000000000000e+01 3.4460201263427734e+01 -1.0277099609375000e+02 -5.3500000000000000e+01 4.1664398193359375e+01 -9.3446899414062500e+01 -5.3500000000000000e+01 4.7047500610351562e+01 -8.3207504272460938e+01 -5.3500000000000000e+01 5.0374599456787109e+01 -7.2500000000000000e+01 -5.3500000000000000e+01 5.1500000000000000e+01 -6.1792602539062500e+01 -5.3500000000000000e+01 5.0374599456787109e+01 -5.1553100585937500e+01 -5.3500000000000000e+01 4.7047500610351562e+01 -4.2229099273681641e+01 -5.3500000000000000e+01 4.1664398193359375e+01 -3.4228099822998047e+01 -5.3500000000000000e+01 3.4460201263427734e+01 -2.7899700164794922e+01 -5.3500000000000000e+01 2.5750000000000000e+01 -2.3520599365234375e+01 -5.3500000000000000e+01 1.5914399147033691e+01 -2.1282199859619141e+01 -5.3500000000000000e+01 5.3831896781921387e+00 -2.1282199859619141e+01 -5.3500000000000000e+01 -5.3831896781921387e+00 -2.3520599365234375e+01 -5.3500000000000000e+01 -1.5914399147033691e+01 -2.7899700164794922e+01 -5.3500000000000000e+01 -2.5750000000000000e+01 -2.0250000000000000e+02 5.1896600723266602e+00 -4.7718601226806641e+01 -2.0250000000000000e+02 0.0000000000000000e+00 -4.8000000000000000e+01 -2.0250000000000000e+02 0.0000000000000000e+00 -4.7500000000000000e+01 -2.0250000000000000e+02 -5.1896600723266602e+00 -4.7718601226806641e+01 -2.0250000000000000e+02 -1.0211000442504883e+01 -4.6389499664306641e+01 -2.0250000000000000e+02 -1.5326400756835938e+01 -4.5487300872802734e+01 -2.0250000000000000e+02 -1.9944700241088867e+01 -4.3109802246093750e+01 -2.0250000000000000e+02 -2.4746500015258789e+01 -4.1129100799560547e+01 -2.0250000000000000e+02 -2.8745800018310547e+01 -3.7814399719238281e+01 -2.0250000000000000e+02 -3.3009498596191406e+01 -3.4847698211669922e+01 -2.0250000000000000e+02 -3.6202697753906250e+01 -3.0750799179077148e+01 -2.0250000000000000e+02 -3.9729099273681641e+01 -2.6936899185180664e+01 -2.0250000000000000e+02 -4.1966800689697266e+01 -2.2249401092529297e+01 -2.0250000000000000e+02 -4.4590801239013672e+01 -1.7766599655151367e+01 -2.0250000000000000e+02 -4.5768600463867188e+01 -1.2707600593566895e+01 -2.0250000000000000e+02 -4.7367599487304688e+01 -7.7655301094055176e+00 -2.0250000000000000e+02 -4.7430297851562500e+01 -2.5715799331665039e+00 -2.0250000000000000e+02 -4.7929599761962891e+01 2.5986399650573730e+00 -2.0250000000000000e+02 -4.6874198913574219e+01 7.6845898628234863e+00 -2.0250000000000000e+02 -4.6250400543212891e+01 1.2841300010681152e+01 -2.0250000000000000e+02 -4.4126399993896484e+01 1.7581501007080078e+01 -2.0250000000000000e+02 -4.2408500671386719e+01 2.2483600616455078e+01 -2.0250000000000000e+02 -3.9315200805664062e+01 2.6656400680541992e+01 -2.0250000000000000e+02 -3.6583801269531250e+01 3.1074499130249023e+01 -2.0250000000000000e+02 -3.2665699005126953e+01 3.4484699249267578e+01 -2.0250000000000000e+02 -2.9048299789428711e+01 3.8212398529052734e+01 -2.0250000000000000e+02 -2.4488800048828125e+01 4.0700698852539062e+01 -2.0250000000000000e+02 -2.0154598236083984e+01 4.3563602447509766e+01 -2.0250000000000000e+02 -1.5166799545288086e+01 4.5013500213623047e+01 -2.0250000000000000e+02 -1.0318599700927734e+01 4.6877700805664062e+01 -2.0250000000000000e+02 -5.1355900764465332e+00 4.7221500396728516e+01 -2.0250000000000000e+02 0.0000000000000000e+00 4.8000000000000000e+01 -2.0250000000000000e+02 5.1355900764465332e+00 4.7221500396728516e+01 -2.0250000000000000e+02 1.0318599700927734e+01 4.6877700805664062e+01 -2.0250000000000000e+02 1.5166799545288086e+01 4.5013500213623047e+01 -2.0250000000000000e+02 2.0154598236083984e+01 4.3563602447509766e+01 -2.0250000000000000e+02 2.4488800048828125e+01 4.0700698852539062e+01 -2.0250000000000000e+02 2.9048299789428711e+01 3.8212398529052734e+01 -2.0250000000000000e+02 3.2665699005126953e+01 3.4484699249267578e+01 -2.0250000000000000e+02 3.6583801269531250e+01 3.1074499130249023e+01 -2.0250000000000000e+02 3.9315200805664062e+01 2.6656400680541992e+01 -2.0250000000000000e+02 4.2408500671386719e+01 2.2483600616455078e+01 -2.0250000000000000e+02 4.4126399993896484e+01 1.7581501007080078e+01 -2.0250000000000000e+02 4.6250400543212891e+01 1.2841300010681152e+01 -2.0250000000000000e+02 4.6874198913574219e+01 7.6845898628234863e+00 -2.0250000000000000e+02 4.7929599761962891e+01 2.5986399650573730e+00 -2.0250000000000000e+02 4.7430297851562500e+01 -2.5715799331665039e+00 -2.0250000000000000e+02 4.7367599487304688e+01 -7.7655301094055176e+00 -2.0250000000000000e+02 4.5768600463867188e+01 -1.2707600593566895e+01 -2.0250000000000000e+02 4.4590801239013672e+01 -1.7766599655151367e+01 -2.0250000000000000e+02 4.1966800689697266e+01 -2.2249401092529297e+01 -2.0250000000000000e+02 3.9729099273681641e+01 -2.6936899185180664e+01 -2.0250000000000000e+02 3.6202697753906250e+01 -3.0750799179077148e+01 -2.0250000000000000e+02 3.3009498596191406e+01 -3.4847698211669922e+01 -2.0250000000000000e+02 2.8745800018310547e+01 -3.7814399719238281e+01 -2.0250000000000000e+02 2.4746500015258789e+01 -4.1129100799560547e+01 -2.0250000000000000e+02 1.9944700241088867e+01 -4.3109802246093750e+01 -2.0250000000000000e+02 1.5326400756835938e+01 -4.5487300872802734e+01 -2.0250000000000000e+02 1.0211000442504883e+01 -4.6389499664306641e+01 -2.0079399108886719e+02 5.1896600723266602e+00 4.7718601226806641e+01 -2.0079399108886719e+02 1.0318599700927734e+01 4.6877700805664062e+01 -2.0079399108886719e+02 1.5326400756835938e+01 4.5487300872802734e+01 -2.0079399108886719e+02 2.0154598236083984e+01 4.3563602447509766e+01 -2.0079399108886719e+02 2.4746500015258789e+01 4.1129100799560547e+01 -2.0079399108886719e+02 2.9048299789428711e+01 3.8212398529052734e+01 -2.0079399108886719e+02 3.3009498596191406e+01 3.4847698211669922e+01 -2.0079399108886719e+02 3.6583801269531250e+01 3.1074499130249023e+01 -2.0079399108886719e+02 3.9729099273681641e+01 2.6936899185180664e+01 -2.0079399108886719e+02 4.2408500671386719e+01 2.2483600616455078e+01 -2.0079399108886719e+02 4.4590801239013672e+01 1.7766599655151367e+01 -2.0079399108886719e+02 4.6250400543212891e+01 1.2841300010681152e+01 -2.0079399108886719e+02 4.7367599487304688e+01 7.7655301094055176e+00 -2.0079399108886719e+02 4.7929599761962891e+01 2.5986399650573730e+00 -2.0079399108886719e+02 4.7929599761962891e+01 -2.5986399650573730e+00 -2.0079399108886719e+02 4.7367599487304688e+01 -7.7655301094055176e+00 -2.0079399108886719e+02 4.6250400543212891e+01 -1.2841300010681152e+01 -2.0079399108886719e+02 4.4590801239013672e+01 -1.7766599655151367e+01 -2.0079399108886719e+02 4.2408500671386719e+01 -2.2483600616455078e+01 -2.0079399108886719e+02 3.9729099273681641e+01 -2.6936899185180664e+01 -2.0079399108886719e+02 3.6583801269531250e+01 -3.1074499130249023e+01 -2.0079399108886719e+02 3.3009498596191406e+01 -3.4847698211669922e+01 -2.0079399108886719e+02 2.9048299789428711e+01 -3.8212398529052734e+01 -2.0079399108886719e+02 2.4746500015258789e+01 -4.1129100799560547e+01 -2.0079399108886719e+02 2.0154598236083984e+01 -4.3563602447509766e+01 -2.0079399108886719e+02 1.5326400756835938e+01 -4.5487300872802734e+01 -2.0079399108886719e+02 1.0318599700927734e+01 -4.6877700805664062e+01 -2.0079399108886719e+02 5.1896600723266602e+00 -4.7718601226806641e+01 -2.0079399108886719e+02 0.0000000000000000e+00 -4.8000000000000000e+01 -2.0079399108886719e+02 -5.1896600723266602e+00 -4.7718601226806641e+01 -2.0079399108886719e+02 -1.0318599700927734e+01 -4.6877700805664062e+01 -2.0079399108886719e+02 -1.5326400756835938e+01 -4.5487300872802734e+01 -2.0079399108886719e+02 -2.0154598236083984e+01 -4.3563602447509766e+01 -2.0079399108886719e+02 -2.4746500015258789e+01 -4.1129100799560547e+01 -2.0079399108886719e+02 -2.9048299789428711e+01 -3.8212398529052734e+01 -2.0079399108886719e+02 -3.3009498596191406e+01 -3.4847698211669922e+01 -2.0079399108886719e+02 -3.6583801269531250e+01 -3.1074499130249023e+01 -2.0079399108886719e+02 -3.9729099273681641e+01 -2.6936899185180664e+01 -2.0079399108886719e+02 -4.2408500671386719e+01 -2.2483600616455078e+01 -2.0079399108886719e+02 -4.4590801239013672e+01 -1.7766599655151367e+01 -2.0079399108886719e+02 -4.6250400543212891e+01 -1.2841300010681152e+01 -2.0079399108886719e+02 -4.7367599487304688e+01 -7.7655301094055176e+00 -2.0079399108886719e+02 -4.7929599761962891e+01 -2.5986399650573730e+00 -2.0079399108886719e+02 -4.7929599761962891e+01 2.5986399650573730e+00 -2.0079399108886719e+02 -4.7367599487304688e+01 7.7655301094055176e+00 -2.0079399108886719e+02 -4.6250400543212891e+01 1.2841300010681152e+01 -2.0079399108886719e+02 -4.4590801239013672e+01 1.7766599655151367e+01 -2.0079399108886719e+02 -4.2408500671386719e+01 2.2483600616455078e+01 -2.0079399108886719e+02 -3.9729099273681641e+01 2.6936899185180664e+01 -2.0079399108886719e+02 -3.6583801269531250e+01 3.1074499130249023e+01 -2.0079399108886719e+02 -3.3009498596191406e+01 3.4847698211669922e+01 -2.0079399108886719e+02 -2.9048299789428711e+01 3.8212398529052734e+01 -2.0079399108886719e+02 -2.4746500015258789e+01 4.1129100799560547e+01 -2.0079399108886719e+02 -2.0154598236083984e+01 4.3563602447509766e+01 -2.0079399108886719e+02 -1.5326400756835938e+01 4.5487300872802734e+01 -2.0079399108886719e+02 -1.0318599700927734e+01 4.6877700805664062e+01 -2.0079399108886719e+02 -5.1896600723266602e+00 4.7718601226806641e+01 -2.0079399108886719e+02 0.0000000000000000e+00 4.8000000000000000e+01 -2.0010598754882812e+02 5.2325701713562012e+00 -4.8113201141357422e+01 -2.0010598754882812e+02 0.0000000000000000e+00 -4.8396800994873047e+01 -2.0010598754882812e+02 -5.2325701713562012e+00 -4.8113201141357422e+01 -2.0010598754882812e+02 -1.0403900146484375e+01 -4.7265399932861328e+01 -2.0010598754882812e+02 -1.5453100204467773e+01 -4.5863399505615234e+01 -2.0010598754882812e+02 -2.0321300506591797e+01 -4.3923797607421875e+01 -2.0010598754882812e+02 -2.4951198577880859e+01 -4.1469100952148438e+01 -2.0010598754882812e+02 -2.9288499832153320e+01 -3.8528400421142578e+01 -2.0010598754882812e+02 -3.3282501220703125e+01 -3.5135898590087891e+01 -2.0010598754882812e+02 -3.6886199951171875e+01 -3.1331401824951172e+01 -2.0010598754882812e+02 -4.0057498931884766e+01 -2.7159700393676758e+01 -2.0010598754882812e+02 -4.2759197235107422e+01 -2.2669500350952148e+01 -2.0010598754882812e+02 -4.4959499359130859e+01 -1.7913499832153320e+01 -2.0010598754882812e+02 -4.6632801055908203e+01 -1.2947500228881836e+01 -2.0010598754882812e+02 -4.7759296417236328e+01 -7.8297200202941895e+00 -2.0010598754882812e+02 -4.8325901031494141e+01 -2.6201000213623047e+00 -2.0010598754882812e+02 -4.8325901031494141e+01 2.6201000213623047e+00 -2.0010598754882812e+02 -4.7759296417236328e+01 7.8297200202941895e+00 -2.0010598754882812e+02 -4.6632801055908203e+01 1.2947500228881836e+01 -2.0010598754882812e+02 -4.4959499359130859e+01 1.7913499832153320e+01 -2.0010598754882812e+02 -4.2759197235107422e+01 2.2669500350952148e+01 -2.0010598754882812e+02 -4.0057498931884766e+01 2.7159700393676758e+01 -2.0010598754882812e+02 -3.6886199951171875e+01 3.1331401824951172e+01 -2.0010598754882812e+02 -3.3282501220703125e+01 3.5135898590087891e+01 -2.0010598754882812e+02 -2.9288499832153320e+01 3.8528400421142578e+01 -2.0010598754882812e+02 -2.4951198577880859e+01 4.1469100952148438e+01 -2.0010598754882812e+02 -2.0321300506591797e+01 4.3923797607421875e+01 -2.0010598754882812e+02 -1.5453100204467773e+01 4.5863399505615234e+01 -2.0010598754882812e+02 -1.0403900146484375e+01 4.7265399932861328e+01 -2.0010598754882812e+02 -5.2325701713562012e+00 4.8113201141357422e+01 -2.0010598754882812e+02 0.0000000000000000e+00 4.8396800994873047e+01 -2.0010598754882812e+02 5.2325701713562012e+00 4.8113201141357422e+01 -2.0010598754882812e+02 1.0403900146484375e+01 4.7265399932861328e+01 -2.0010598754882812e+02 1.5453100204467773e+01 4.5863399505615234e+01 -2.0010598754882812e+02 2.0321300506591797e+01 4.3923797607421875e+01 -2.0010598754882812e+02 2.4951198577880859e+01 4.1469100952148438e+01 -2.0010598754882812e+02 2.9288499832153320e+01 3.8528400421142578e+01 -2.0010598754882812e+02 3.3282501220703125e+01 3.5135898590087891e+01 -2.0010598754882812e+02 3.6886199951171875e+01 3.1331401824951172e+01 -2.0010598754882812e+02 4.0057498931884766e+01 2.7159700393676758e+01 -2.0010598754882812e+02 4.2759197235107422e+01 2.2669500350952148e+01 -2.0010598754882812e+02 4.4959499359130859e+01 1.7913499832153320e+01 -2.0010598754882812e+02 4.6632801055908203e+01 1.2947500228881836e+01 -2.0010598754882812e+02 4.7759296417236328e+01 7.8297200202941895e+00 -2.0010598754882812e+02 4.8325901031494141e+01 2.6201000213623047e+00 -2.0010598754882812e+02 4.8325901031494141e+01 -2.6201000213623047e+00 -2.0010598754882812e+02 4.7759296417236328e+01 -7.8297200202941895e+00 -2.0010598754882812e+02 4.6632801055908203e+01 -1.2947500228881836e+01 -2.0010598754882812e+02 4.4959499359130859e+01 -1.7913499832153320e+01 -2.0010598754882812e+02 4.2759197235107422e+01 -2.2669500350952148e+01 -2.0010598754882812e+02 4.0057498931884766e+01 -2.7159700393676758e+01 -2.0010598754882812e+02 3.6886199951171875e+01 -3.1331401824951172e+01 -2.0010598754882812e+02 3.3282501220703125e+01 -3.5135898590087891e+01 -2.0010598754882812e+02 2.9288499832153320e+01 -3.8528400421142578e+01 -2.0010598754882812e+02 2.4951198577880859e+01 -4.1469100952148438e+01 -2.0010598754882812e+02 2.0321300506591797e+01 -4.3923797607421875e+01 -2.0010598754882812e+02 1.5453100204467773e+01 -4.5863399505615234e+01 -2.0010598754882812e+02 1.0403900146484375e+01 -4.7265399932861328e+01 -2.0039700317382812e+02 5.2011599540710449e+00 -4.7824302673339844e+01 -2.0039700317382812e+02 0.0000000000000000e+00 -4.8106300354003906e+01 -2.0039700317382812e+02 -5.2011599540710449e+00 -4.7824302673339844e+01 -2.0039700317382812e+02 -1.0341400146484375e+01 -4.6981597900390625e+01 -2.0039700317382812e+02 -1.5360400199890137e+01 -4.5588096618652344e+01 -2.0039700317382812e+02 -2.0199300765991211e+01 -4.3660099029541016e+01 -2.0039700317382812e+02 -2.4801399230957031e+01 -4.1220199584960938e+01 -2.0039700317382812e+02 -2.9112699508666992e+01 -3.8297100067138672e+01 -2.0039700317382812e+02 -3.3082702636718750e+01 -3.4924999237060547e+01 -2.0039700317382812e+02 -3.6664798736572266e+01 -3.1143400192260742e+01 -2.0039700317382812e+02 -3.9817096710205078e+01 -2.6996599197387695e+01 -2.0039700317382812e+02 -4.2502498626708984e+01 -2.2533399581909180e+01 -2.0039700317382812e+02 -4.4689701080322266e+01 -1.7805999755859375e+01 -2.0039700317382812e+02 -4.6352901458740234e+01 -1.2869800567626953e+01 -2.0039700317382812e+02 -4.7472599029541016e+01 -7.7827000617980957e+00 -2.0039700317382812e+02 -4.8035701751708984e+01 -2.6044199466705322e+00 -2.0039700317382812e+02 -4.8035701751708984e+01 2.6044199466705322e+00 -2.0039700317382812e+02 -4.7472599029541016e+01 7.7827000617980957e+00 -2.0039700317382812e+02 -4.6352901458740234e+01 1.2869800567626953e+01 -2.0039700317382812e+02 -4.4689701080322266e+01 1.7805999755859375e+01 -2.0039700317382812e+02 -4.2502498626708984e+01 2.2533399581909180e+01 -2.0039700317382812e+02 -3.9817096710205078e+01 2.6996599197387695e+01 -2.0039700317382812e+02 -3.6664798736572266e+01 3.1143400192260742e+01 -2.0039700317382812e+02 -3.3082702636718750e+01 3.4924999237060547e+01 -2.0039700317382812e+02 -2.9112699508666992e+01 3.8297100067138672e+01 -2.0039700317382812e+02 -2.4801399230957031e+01 4.1220199584960938e+01 -2.0039700317382812e+02 -2.0199300765991211e+01 4.3660099029541016e+01 -2.0039700317382812e+02 -1.5360400199890137e+01 4.5588096618652344e+01 -2.0039700317382812e+02 -1.0341400146484375e+01 4.6981597900390625e+01 -2.0039700317382812e+02 -5.2011599540710449e+00 4.7824302673339844e+01 -2.0039700317382812e+02 0.0000000000000000e+00 4.8106300354003906e+01 -2.0039700317382812e+02 5.2011599540710449e+00 4.7824302673339844e+01 -2.0039700317382812e+02 1.0341400146484375e+01 4.6981597900390625e+01 -2.0039700317382812e+02 1.5360400199890137e+01 4.5588096618652344e+01 -2.0039700317382812e+02 2.0199300765991211e+01 4.3660099029541016e+01 -2.0039700317382812e+02 2.4801399230957031e+01 4.1220199584960938e+01 -2.0039700317382812e+02 2.9112699508666992e+01 3.8297100067138672e+01 -2.0039700317382812e+02 3.3082702636718750e+01 3.4924999237060547e+01 -2.0039700317382812e+02 3.6664798736572266e+01 3.1143400192260742e+01 -2.0039700317382812e+02 3.9817096710205078e+01 2.6996599197387695e+01 -2.0039700317382812e+02 4.2502498626708984e+01 2.2533399581909180e+01 -2.0039700317382812e+02 4.4689701080322266e+01 1.7805999755859375e+01 -2.0039700317382812e+02 4.6352901458740234e+01 1.2869800567626953e+01 -2.0039700317382812e+02 4.7472599029541016e+01 7.7827000617980957e+00 -2.0039700317382812e+02 4.8035701751708984e+01 2.6044199466705322e+00 -2.0039700317382812e+02 4.8035701751708984e+01 -2.6044199466705322e+00 -2.0039700317382812e+02 4.7472599029541016e+01 -7.7827000617980957e+00 -2.0039700317382812e+02 4.6352901458740234e+01 -1.2869800567626953e+01 -2.0039700317382812e+02 4.4689701080322266e+01 -1.7805999755859375e+01 -2.0039700317382812e+02 4.2502498626708984e+01 -2.2533399581909180e+01 -2.0039700317382812e+02 3.9817096710205078e+01 -2.6996599197387695e+01 -2.0039700317382812e+02 3.6664798736572266e+01 -3.1143400192260742e+01 -2.0039700317382812e+02 3.3082702636718750e+01 -3.4924999237060547e+01 -2.0039700317382812e+02 2.9112699508666992e+01 -3.8297100067138672e+01 -2.0039700317382812e+02 2.4801399230957031e+01 -4.1220199584960938e+01 -2.0039700317382812e+02 2.0199300765991211e+01 -4.3660099029541016e+01 -2.0039700317382812e+02 1.5360400199890137e+01 -4.5588096618652344e+01 -2.0039700317382812e+02 1.0341400146484375e+01 -4.6981597900390625e+01 -9.1075401306152344e+01 -7.5000000000000000e+01 -4.6959602355957031e+01 -8.3302001953125000e+01 -7.5000000000000000e+01 -4.9331199645996094e+01 -8.3296905517578125e+01 -7.6388198852539062e+01 -4.9307498931884766e+01 -9.4783203125000000e+01 -7.6388198852539062e+01 -4.5290897369384766e+01 -9.8367698669433594e+01 -7.5000000000000000e+01 -4.3371700286865234e+01 -9.1066505432128906e+01 -7.6388198852539062e+01 -4.6937000274658203e+01 -8.7229499816894531e+01 -7.6388198852539062e+01 -4.8278800964355469e+01 -7.5248893737792969e+01 -7.5000000000000000e+01 -5.0425102233886719e+01 -6.7124504089355469e+01 -7.5000000000000000e+01 -5.0213001251220703e+01 -6.7127098083496094e+01 -7.6388198852539062e+01 -5.0188999176025391e+01 -7.1183006286621094e+01 -7.6388198852539062e+01 -5.0458599090576172e+01 -7.5247497558593750e+01 -7.6388198852539062e+01 -5.0400901794433594e+01 -7.9294197082519531e+01 -7.6388198852539062e+01 -5.0016399383544922e+01 -5.9139400482177734e+01 -7.5000000000000000e+01 -4.8700500488281250e+01 -5.1500301361083984e+01 -7.5000000000000000e+01 -4.5926700592041016e+01 -5.1510402679443359e+01 -7.6388198852539062e+01 -4.5904598236083984e+01 -5.5272197723388672e+01 -7.6388198852539062e+01 -4.7444801330566406e+01 -5.9145801544189453e+01 -7.6388198852539062e+01 -4.8677101135253906e+01 -6.3105998992919922e+01 -7.6388198852539062e+01 -4.9593898773193359e+01 -4.4405097961425781e+01 -7.5000000000000000e+01 -4.1963302612304688e+01 -3.8037502288818359e+01 -7.5000000000000000e+01 -3.6913101196289062e+01 -3.8054000854492188e+01 -7.6388198852539062e+01 -3.6895500183105469e+01 -4.1134597778320312e+01 -7.6388198852539062e+01 -3.9547599792480469e+01 -4.4418498992919922e+01 -7.6388198852539062e+01 -4.1943199157714844e+01 -4.7884597778320312e+01 -7.6388198852539062e+01 -4.4066802978515625e+01 -3.2562500000000000e+01 -7.5000000000000000e+01 -3.0906999588012695e+01 -2.8121900558471680e+01 -7.5000000000000000e+01 -2.4100299835205078e+01 -2.8143100738525391e+01 -7.6388198852539062e+01 -2.4088699340820312e+01 -3.0225299835205078e+01 -7.6388198852539062e+01 -2.7579799652099609e+01 -3.2581699371337891e+01 -7.6388198852539062e+01 -3.0892099380493164e+01 -3.5196899414062500e+01 -7.6388198852539062e+01 -3.4003997802734375e+01 -2.4830499649047852e+01 -7.5000000000000000e+01 -1.6669500350952148e+01 -2.2773899078369141e+01 -7.5000000000000000e+01 -8.8068199157714844e+00 -2.2797700881958008e+01 -7.6388198852539062e+01 -8.8026494979858398e+00 -2.3667200088500977e+01 -7.6388198852539062e+01 -1.2773400306701660e+01 -2.4853401184082031e+01 -7.6388198852539062e+01 -1.6661500930786133e+01 -2.6348600387573242e+01 -7.6388198852539062e+01 -2.0441299438476562e+01 -2.2005100250244141e+01 -7.5000000000000000e+01 -7.1619898080825806e-01 -2.2544101715087891e+01 -7.5000000000000000e+01 7.3930001258850098e+00 -2.2568099975585938e+01 -7.6388198852539062e+01 7.3894300460815430e+00 -2.2135398864746094e+01 -7.6388198852539062e+01 3.3476300239562988e+00 -2.2029399871826172e+01 -7.6388198852539062e+01 -7.1585595607757568e-01 -2.2250600814819336e+01 -7.6388198852539062e+01 -4.7746901512145996e+00 -2.4376998901367188e+01 -7.5000000000000000e+01 1.5310799598693848e+01 -2.7456199645996094e+01 -7.5000000000000000e+01 2.2832000732421875e+01 -2.7477800369262695e+01 -7.6388198852539062e+01 2.2820999145507812e+01 -2.5787399291992188e+01 -7.6388198852539062e+01 1.9124200820922852e+01 -2.4399999618530273e+01 -7.6388198852539062e+01 1.5303400039672852e+01 -2.3324600219726562e+01 -7.6388198852539062e+01 1.1383399963378906e+01 -3.1702001571655273e+01 -7.5000000000000000e+01 2.9761800765991211e+01 -3.7004398345947266e+01 -7.5000000000000000e+01 3.5920898437500000e+01 -3.7021499633789062e+01 -7.6388198852539062e+01 3.5903697967529297e+01 -3.4247497558593750e+01 -7.6388198852539062e+01 3.2932399749755859e+01 -3.1721599578857422e+01 -7.6388198852539062e+01 2.9747499465942383e+01 -2.9460100173950195e+01 -7.6388198852539062e+01 2.6369800567626953e+01 -4.3226200103759766e+01 -7.5000000000000000e+01 4.1149600982666016e+01 -5.0206199645996094e+01 -7.5000000000000000e+01 4.5312599182128906e+01 -5.0216899871826172e+01 -7.6388198852539062e+01 4.5290897369384766e+01 -4.6644699096679688e+01 -7.6388198852539062e+01 4.3350902557373047e+01 -4.3240303039550781e+01 -7.6388198852539062e+01 4.1129898071289062e+01 -4.0025600433349609e+01 -7.6388198852539062e+01 3.8642101287841797e+01 -5.7763496398925781e+01 -7.5000000000000000e+01 4.8301998138427734e+01 -6.5702598571777344e+01 -7.5000000000000000e+01 5.0040401458740234e+01 -6.5705795288085938e+01 -7.6388198852539062e+01 5.0016399383544922e+01 -6.1703201293945312e+01 -7.6388198852539062e+01 4.9307498931884766e+01 -5.7770599365234375e+01 -7.6388198852539062e+01 4.8278800964355469e+01 -5.3933502197265625e+01 -7.6388198852539062e+01 4.6937000274658203e+01 -7.3817604064941406e+01 -7.5000000000000000e+01 5.0482799530029297e+01 -8.1898597717285156e+01 -7.5000000000000000e+01 4.9617698669433594e+01 -8.1894096374511719e+01 -7.6388198852539062e+01 4.9593898773193359e+01 -7.7873001098632812e+01 -7.6388198852539062e+01 5.0188999176025391e+01 -7.3817001342773438e+01 -7.6388198852539062e+01 5.0458599090576172e+01 -6.9752502441406250e+01 -7.6388198852539062e+01 5.0400901794433594e+01 -9.7127197265625000e+01 -7.5000000000000000e+01 4.4087902069091797e+01 -9.3489700317382812e+01 -7.6388198852539062e+01 4.5904598236083984e+01 -8.9736099243164062e+01 -7.5000000000000000e+01 4.7467498779296875e+01 -8.9727798461914062e+01 -7.6388198852539062e+01 4.7444801330566406e+01 -8.5854301452636719e+01 -7.6388198852539062e+01 4.8677101135253906e+01 -1.0388000488281250e+02 -7.5000000000000000e+01 3.9566596984863281e+01 -1.0058200073242188e+02 -7.6388198852539062e+01 4.1943199157714844e+01 -9.7115394592285156e+01 -7.6388198852539062e+01 4.4066802978515625e+01 -1.0982099914550781e+02 -7.5000000000000000e+01 3.4020401000976562e+01 -1.0694599914550781e+02 -7.6388198852539062e+01 3.6895500183105469e+01 -1.0386499786376953e+02 -7.6388198852539062e+01 3.9547599792480469e+01 -1.1685700225830078e+02 -7.6388198852539062e+01 2.4088699340820312e+01 -1.1477500152587891e+02 -7.6388198852539062e+01 2.7579799652099609e+01 -1.1479499816894531e+02 -7.5000000000000000e+01 2.7593099594116211e+01 -1.1241800689697266e+02 -7.6388198852539062e+01 3.0892099380493164e+01 -1.0980300140380859e+02 -7.6388198852539062e+01 3.4003997802734375e+01 -1.1865100097656250e+02 -7.6388198852539062e+01 2.0441299438476562e+01 -1.1867400360107422e+02 -7.5000000000000000e+01 2.0451198577880859e+01 -1.2014699554443359e+02 -7.6388198852539062e+01 1.6661500930786133e+01 -1.2135600280761719e+02 -7.5000000000000000e+01 1.2779600143432617e+01 -1.2133300018310547e+02 -7.6388198852539062e+01 1.2773400306701660e+01 -1.2277399444580078e+02 -7.5000000000000000e+01 4.7770099639892578e+00 -1.2274900054931641e+02 -7.6388198852539062e+01 4.7746901512145996e+00 -1.2220200347900391e+02 -7.6388198852539062e+01 8.8026494979858398e+00 -1.2059999847412109e+02 -7.6388198852539062e+01 -1.5303400039672852e+01 -1.2167500305175781e+02 -7.6388198852539062e+01 -1.1383399963378906e+01 -1.2169899749755859e+02 -7.5000000000000000e+01 -1.1388799667358398e+01 -1.2243199920654297e+02 -7.6388198852539062e+01 -7.3894300460815430e+00 -1.2288899993896484e+02 -7.5000000000000000e+01 -3.3492398262023926e+00 -1.2286499786376953e+02 -7.6388198852539062e+01 -3.3476300239562988e+00 -1.2297100067138672e+02 -7.6388198852539062e+01 7.1585595607757568e-01 -1.1921299743652344e+02 -7.6388198852539062e+01 -1.9124200820922852e+01 -1.1923500061035156e+02 -7.5000000000000000e+01 -1.9133399963378906e+01 -1.1752200317382812e+02 -7.6388198852539062e+01 -2.2820999145507812e+01 -1.1556100463867188e+02 -7.5000000000000000e+01 -2.6382400512695312e+01 -1.1554000091552734e+02 -7.6388198852539062e+01 -2.6369800567626953e+01 -1.1077100372314453e+02 -7.5000000000000000e+01 -3.2948200225830078e+01 -1.1075299835205078e+02 -7.6388198852539062e+01 -3.2932399749755859e+01 -1.1327799987792969e+02 -7.6388198852539062e+01 -2.9747499465942383e+01 -9.8355300903320312e+01 -7.6388198852539062e+01 -4.3350902557373047e+01 -1.0176000213623047e+02 -7.6388198852539062e+01 -4.1129898071289062e+01 -1.0498999786376953e+02 -7.5000000000000000e+01 -3.8660602569580078e+01 -1.0497399902343750e+02 -7.6388198852539062e+01 -3.8642101287841797e+01 -1.0797899627685547e+02 -7.6388198852539062e+01 -3.5903697967529297e+01 -7.0683998107910156e+01 -8.7000000000000000e+01 -4.4342201232910156e+01 -6.7028404235839844e+01 -8.7000000000000000e+01 -4.4040699005126953e+01 -7.0648200988769531e+01 -8.7000000000000000e+01 4.4340698242187500e+01 -6.3410202026367188e+01 -8.7000000000000000e+01 -4.3438400268554688e+01 -5.9854198455810547e+01 -8.7000000000000000e+01 -4.2539501190185547e+01 -7.4351898193359375e+01 -8.7000000000000000e+01 -4.4340698242187500e+01 -7.4316101074218750e+01 -8.7000000000000000e+01 4.4342201232910156e+01 -7.7971694946289062e+01 -8.7000000000000000e+01 4.4040699005126953e+01 -8.1589805603027344e+01 -8.7000000000000000e+01 4.3438400268554688e+01 -8.5145896911621094e+01 -8.7000000000000000e+01 4.2539501190185547e+01 -8.8615592956542969e+01 -8.7000000000000000e+01 4.1349899291992188e+01 -9.8273300170898438e+01 -8.7000000000000000e+01 3.6128498077392578e+01 -1.0116899871826172e+02 -8.7000000000000000e+01 3.3876697540283203e+01 -1.0386800384521484e+02 -8.7000000000000000e+01 3.1393598556518555e+01 -1.0635399627685547e+02 -8.7000000000000000e+01 2.8696001052856445e+01 -5.6384498596191406e+01 -8.7000000000000000e+01 -4.1349899291992188e+01 -5.3024898529052734e+01 -8.7000000000000000e+01 -3.9877799987792969e+01 -4.9798297882080078e+01 -8.7000000000000000e+01 -3.8133399963378906e+01 -4.6726799011230469e+01 -8.7000000000000000e+01 -3.6128498077392578e+01 -4.3831401824951172e+01 -8.7000000000000000e+01 -3.3876697540283203e+01 -4.1131797790527344e+01 -8.7000000000000000e+01 -3.1393598556518555e+01 -2.9970800399780273e+01 -8.7000000000000000e+01 -1.2680199623107910e+01 -2.9068901062011719e+01 -8.7000000000000000e+01 -9.1248102188110352e+00 -2.8157899856567383e+01 -8.7000000000000000e+01 1.8160300254821777e+00 -2.8459299087524414e+01 -8.7000000000000000e+01 5.4715900421142578e+00 -2.9061599731445312e+01 -8.7000000000000000e+01 9.0897693634033203e+00 -2.9960500717163086e+01 -8.7000000000000000e+01 1.2645799636840820e+01 -3.1150100708007812e+01 -8.7000000000000000e+01 1.6115499496459961e+01 -3.2622200012207031e+01 -8.7000000000000000e+01 1.9475101470947266e+01 -6.6992797851562500e+01 -8.7000000000000000e+01 4.4036300659179688e+01 -9.1975196838378906e+01 -8.7000000000000000e+01 3.9877799987792969e+01 -9.5201797485351562e+01 -8.7000000000000000e+01 3.8133399963378906e+01 -1.1502899932861328e+02 -8.7000000000000000e+01 1.2680199623107910e+01 -1.0389400482177734e+02 -8.7000000000000000e+01 -3.1368200302124023e+01 -1.0119599914550781e+02 -8.7000000000000000e+01 -3.3853500366210938e+01 -3.8646400451660156e+01 -8.7000000000000000e+01 -2.8696001052856445e+01 -3.6392398834228516e+01 -8.7000000000000000e+01 -2.5802400588989258e+01 -3.4384998321533203e+01 -8.7000000000000000e+01 -2.2732500076293945e+01 -2.8463701248168945e+01 -8.7000000000000000e+01 -5.5071702003479004e+00 -2.8159299850463867e+01 -8.7000000000000000e+01 -1.8518599271774292e+00 -1.0860800170898438e+02 -8.7000000000000000e+01 2.5802400588989258e+01 -1.1061499786376953e+02 -8.7000000000000000e+01 2.2732500076293945e+01 -1.1236199951171875e+02 -8.7000000000000000e+01 1.9507299423217773e+01 -3.6371601104736328e+01 -8.7000000000000000e+01 2.5773199081420898e+01 -3.8623298645019531e+01 -8.7000000000000000e+01 2.8668600082397461e+01 -6.3375198364257812e+01 -8.7000000000000000e+01 4.3431098937988281e+01 -1.1593099975585938e+02 -8.7000000000000000e+01 9.1248102188110352e+00 -1.1653599548339844e+02 -8.7000000000000000e+01 5.5071702003479004e+00 -1.1684100341796875e+02 -8.7000000000000000e+01 1.8518599271774292e+00 -3.2637901306152344e+01 -8.7000000000000000e+01 -1.9507299423217773e+01 -3.1163200378417969e+01 -8.7000000000000000e+01 -1.6148900985717773e+01 -9.8302398681640625e+01 -8.7000000000000000e+01 -3.6107601165771484e+01 -9.5232498168945312e+01 -8.7000000000000000e+01 -3.8114997863769531e+01 -9.2007400512695312e+01 -8.7000000000000000e+01 -3.9862098693847656e+01 -3.4366600036621094e+01 -8.7000000000000000e+01 2.2701700210571289e+01 -4.1106399536132812e+01 -8.7000000000000000e+01 3.1368200302124023e+01 -4.3804000854492188e+01 -8.7000000000000000e+01 3.3853500366210938e+01 -5.9819797515869141e+01 -8.7000000000000000e+01 4.2529197692871094e+01 -4.6697601318359375e+01 -8.7000000000000000e+01 3.6107601165771484e+01 -4.9767501831054688e+01 -8.7000000000000000e+01 3.8114997863769531e+01 -5.2992702484130859e+01 -8.7000000000000000e+01 3.9862098693847656e+01 -5.6351100921630859e+01 -8.7000000000000000e+01 4.1336799621582031e+01 -1.1684200286865234e+02 -8.7000000000000000e+01 -1.8160300254821777e+00 -1.1654100036621094e+02 -8.7000000000000000e+01 -5.4715900421142578e+00 -1.1593899536132812e+02 -8.7000000000000000e+01 -9.0897693634033203e+00 -1.1503999328613281e+02 -8.7000000000000000e+01 -1.2645799636840820e+01 -1.1384999847412109e+02 -8.7000000000000000e+01 -1.6115499496459961e+01 -1.1237799835205078e+02 -8.7000000000000000e+01 -1.9475101470947266e+01 -1.1063300323486328e+02 -8.7000000000000000e+01 -2.2701700210571289e+01 -1.0862799835205078e+02 -8.7000000000000000e+01 -2.5773199081420898e+01 -1.0637699890136719e+02 -8.7000000000000000e+01 -2.8668600082397461e+01 -8.8648902893066406e+01 -8.7000000000000000e+01 -4.1336799621582031e+01 -8.5180198669433594e+01 -8.7000000000000000e+01 -4.2529197692871094e+01 -8.1624900817871094e+01 -8.7000000000000000e+01 -4.3431098937988281e+01 -1.1383700561523438e+02 -8.7000000000000000e+01 1.6148900985717773e+01 -7.8007202148437500e+01 -8.7000000000000000e+01 -4.4036300659179688e+01 -5.1797500610351562e+01 -8.5267799377441406e+01 4.2304298400878906e+01 -5.4208801269531250e+01 -7.9629501342773438e+01 4.6241203308105469e+01 -5.5361698150634766e+01 -8.5267799377441406e+01 4.3869400024414062e+01 -5.4407699584960938e+01 -7.9629501342773438e+01 4.6310699462890625e+01 -5.9043003082275391e+01 -8.5267799377441406e+01 4.5134799957275391e+01 -6.6655502319335938e+01 -8.5267799377441406e+01 4.6734199523925781e+01 -6.9793205261230469e+01 -7.9629501342773438e+01 4.9653701782226562e+01 -7.0534698486328125e+01 -8.5267799377441406e+01 4.7057201385498047e+01 -7.0425300598144531e+01 -7.9629501342773438e+01 4.9662601470947266e+01 -7.4427299499511719e+01 -8.5267799377441406e+01 4.7058799743652344e+01 -5.7989002227783203e+01 -7.9629501342773438e+01 4.7563098907470703e+01 -6.1863300323486328e+01 -7.9629501342773438e+01 4.8576499938964844e+01 -6.2816097259521484e+01 -8.5267799377441406e+01 4.6091899871826172e+01 -6.2278198242187500e+01 -7.9629501342773438e+01 4.8650001525878906e+01 -6.5806503295898438e+01 -7.9629501342773438e+01 4.9274898529052734e+01 -8.2146697998046875e+01 -8.5267799377441406e+01 4.6099700927734375e+01 -8.5656204223632812e+01 -7.9629501342773438e+01 4.7955501556396484e+01 -8.5920700073242188e+01 -8.5267799377441406e+01 4.5145599365234375e+01 -8.6660301208496094e+01 -7.9629501342773438e+01 4.7635997772216797e+01 -8.9602905273437500e+01 -8.5267799377441406e+01 4.3883201599121094e+01 -7.3797500610351562e+01 -7.9629501342773438e+01 4.9710502624511719e+01 -7.7793296813964844e+01 -7.9629501342773438e+01 4.9444900512695312e+01 -7.8306900024414062e+01 -8.5267799377441406e+01 4.6738899230957031e+01 -7.8627105712890625e+01 -7.9629501342773438e+01 4.9321498870849609e+01 -8.1754806518554688e+01 -7.9629501342773438e+01 4.8858600616455078e+01 -9.6592597961425781e+01 -8.5267799377441406e+01 4.0469600677490234e+01 -1.0016500091552734e+02 -7.9629501342773438e+01 4.1321399688720703e+01 -9.9852195739746094e+01 -8.5267799377441406e+01 3.8341899871826172e+01 -1.0135699462890625e+02 -7.9629501342773438e+01 4.0451900482177734e+01 -1.0292500305175781e+02 -8.5267799377441406e+01 3.5952198028564453e+01 -8.9472396850585938e+01 -7.9629501342773438e+01 4.6741401672363281e+01 -9.3178504943847656e+01 -7.9629501342773438e+01 4.5224102020263672e+01 -9.3168304443359375e+01 -8.5267799377441406e+01 4.2320999145507812e+01 -9.4306404113769531e+01 -7.9629501342773438e+01 4.4652397155761719e+01 -9.6750495910644531e+01 -7.9629501342773438e+01 4.3413501739501953e+01 -1.1182700347900391e+02 -7.9629501342773438e+01 3.0434099197387695e+01 -1.1081999969482422e+02 -8.5267799377441406e+01 2.7383100509643555e+01 -1.0842800140380859e+02 -8.5267799377441406e+01 3.0454000473022461e+01 -1.0340000152587891e+02 -7.9629501342773438e+01 3.8961196899414062e+01 -1.0643499755859375e+02 -7.9629501342773438e+01 3.6348499298095703e+01 -1.0578999328613281e+02 -8.5267799377441406e+01 3.3316898345947266e+01 -1.0762000274658203e+02 -7.9629501342773438e+01 3.5149101257324219e+01 -1.0925000000000000e+02 -7.9629501342773438e+01 3.3499900817871094e+01 -1.1292600250244141e+02 -7.9629501342773438e+01 2.8888500213623047e+01 -1.1414799499511719e+02 -7.9629501342773438e+01 2.7171001434326172e+01 -1.1294999694824219e+02 -8.5267799377441406e+01 2.4125200271606445e+01 -1.1619900512695312e+02 -7.9629501342773438e+01 2.3731599807739258e+01 -1.1480400085449219e+02 -8.5267799377441406e+01 2.0702400207519531e+01 -1.1712999725341797e+02 -7.9629501342773438e+01 2.1840398788452148e+01 -1.1796700286865234e+02 -7.9629501342773438e+01 2.0138299942016602e+01 -1.1636900329589844e+02 -8.5267799377441406e+01 1.7138299942016602e+01 -1.1943999481201172e+02 -7.9629501342773438e+01 1.6414501190185547e+01 -1.1763499450683594e+02 -8.5267799377441406e+01 1.3457000732421875e+01 -1.2011700439453125e+02 -7.9629501342773438e+01 1.4196800231933594e+01 -1.2060900115966797e+02 -7.9629501342773438e+01 1.2584099769592285e+01 -1.1859200286865234e+02 -8.5267799377441406e+01 9.6838502883911133e+00 -1.2146499633789062e+02 -7.9629501342773438e+01 8.6721200942993164e+00 -1.1923400115966797e+02 -8.5267799377441406e+01 5.8445301055908203e+00 -1.2180599975585938e+02 -7.9629501342773438e+01 6.1657400131225586e+00 -1.2200400543212891e+02 -7.9629501342773438e+01 4.7039399147033691e+00 -1.1955699920654297e+02 -8.5267799377441406e+01 1.9652799367904663e+00 -1.2222200012207031e+02 -7.9629501342773438e+01 7.0524299144744873e-01 -1.1955899810791016e+02 -8.5267799377441406e+01 -1.9273200035095215e+00 -1.2215100097656250e+02 -7.9629501342773438e+01 -2.0340099334716797e+00 -1.2211800384521484e+02 -7.9629501342773438e+01 -3.2979798316955566e+00 -1.1923900604248047e+02 -8.5267799377441406e+01 -5.8067998886108398e+00 -1.2169200134277344e+02 -7.9629501342773438e+01 -7.2798700332641602e+00 -1.1860000610351562e+02 -8.5267799377441406e+01 -9.6466503143310547e+00 -1.2114199829101562e+02 -7.9629501342773438e+01 -1.0179300308227539e+01 -1.2094599914550781e+02 -7.9629501342773438e+01 -1.1214599609375000e+01 -1.1764600372314453e+02 -8.5267799377441406e+01 -1.3420600891113281e+01 -1.1988700103759766e+02 -7.9629501342773438e+01 -1.5076499938964844e+01 -1.1638300323486328e+02 -8.5267799377441406e+01 -1.7102800369262695e+01 -1.1880799865722656e+02 -7.9629501342773438e+01 -1.8048500061035156e+01 -1.1851999664306641e+02 -7.9629501342773438e+01 -1.8840700149536133e+01 -1.1482099914550781e+02 -8.5267799377441406e+01 -2.0668300628662109e+01 -1.1685500335693359e+02 -7.9629501342773438e+01 -2.2482700347900391e+01 -1.1297000122070312e+02 -8.5267799377441406e+01 -2.4092498779296875e+01 -1.1520999908447266e+02 -7.9629501342773438e+01 -2.5427000045776367e+01 -1.1490200042724609e+02 -7.9629501342773438e+01 -2.5978900909423828e+01 -1.1084199523925781e+02 -8.5267799377441406e+01 -2.7352201461791992e+01 -1.1267399597167969e+02 -7.9629501342773438e+01 -2.9306499481201172e+01 -1.0845200347900391e+02 -8.5267799377441406e+01 -3.0424999237060547e+01 -1.1044699859619141e+02 -7.9629501342773438e+01 -3.2113998413085938e+01 -1.1018499755859375e+02 -7.9629501342773438e+01 -3.2444202423095703e+01 -1.0581700134277344e+02 -8.5267799377441406e+01 -3.3289997100830078e+01 -1.0745300292968750e+02 -7.9629501342773438e+01 -3.5371398925781250e+01 -1.0295400238037109e+02 -8.5267799377441406e+01 -3.5927600860595703e+01 -9.3202499389648438e+01 -8.5267799377441406e+01 -4.2304298400878906e+01 -9.0791206359863281e+01 -7.9629501342773438e+01 -4.6241203308105469e+01 -8.9638298034667969e+01 -8.5267799377441406e+01 -4.3869400024414062e+01 -9.0592399597167969e+01 -7.9629501342773438e+01 -4.6310699462890625e+01 -8.5957099914550781e+01 -8.5267799377441406e+01 -4.5134799957275391e+01 -1.0464900207519531e+02 -7.9629501342773438e+01 -3.7927299499511719e+01 -1.0449299621582031e+02 -7.9629501342773438e+01 -3.8069198608398438e+01 -9.9883201599121094e+01 -8.5267799377441406e+01 -3.8319801330566406e+01 -1.0132600402832031e+02 -7.9629501342773438e+01 -4.0520103454589844e+01 -9.6625198364257812e+01 -8.5267799377441406e+01 -4.0450099945068359e+01 -9.7972000122070312e+01 -7.9629501342773438e+01 -4.2708301544189453e+01 -9.4452796936035156e+01 -7.9629501342773438e+01 -4.4619400024414062e+01 -7.8344596862792969e+01 -8.5267799377441406e+01 -4.6734199523925781e+01 -7.5206802368164062e+01 -7.9629501342773438e+01 -4.9653701782226562e+01 -7.4465400695800781e+01 -8.5267799377441406e+01 -4.7057201385498047e+01 -7.4574798583984375e+01 -7.9629501342773438e+01 -4.9662601470947266e+01 -7.0572692871093750e+01 -8.5267799377441406e+01 -4.7058799743652344e+01 -8.7011100769042969e+01 -7.9629501342773438e+01 -4.7563098907470703e+01 -8.3136795043945312e+01 -7.9629501342773438e+01 -4.8576499938964844e+01 -8.2183898925781250e+01 -8.5267799377441406e+01 -4.6091899871826172e+01 -8.2721893310546875e+01 -7.9629501342773438e+01 -4.8650001525878906e+01 -7.9193504333496094e+01 -7.9629501342773438e+01 -4.9274898529052734e+01 -6.2853404998779297e+01 -8.5267799377441406e+01 -4.6099700927734375e+01 -5.9343799591064453e+01 -7.9629501342773438e+01 -4.7955501556396484e+01 -5.9079402923583984e+01 -8.5267799377441406e+01 -4.5145599365234375e+01 -5.8339698791503906e+01 -7.9629501342773438e+01 -4.7635997772216797e+01 -5.5397201538085938e+01 -8.5267799377441406e+01 -4.3883201599121094e+01 -7.1202598571777344e+01 -7.9629501342773438e+01 -4.9710502624511719e+01 -6.7206802368164062e+01 -7.9629501342773438e+01 -4.9444900512695312e+01 -6.6693199157714844e+01 -8.5267799377441406e+01 -4.6738899230957031e+01 -6.6373001098632812e+01 -7.9629501342773438e+01 -4.9321498870849609e+01 -6.3245296478271484e+01 -7.9629501342773438e+01 -4.8858600616455078e+01 -4.8407497406005859e+01 -8.5267799377441406e+01 -4.0469600677490234e+01 -4.4834899902343750e+01 -7.9629501342773438e+01 -4.1321399688720703e+01 -4.5147800445556641e+01 -8.5267799377441406e+01 -3.8341899871826172e+01 -4.3643001556396484e+01 -7.9629501342773438e+01 -4.0451900482177734e+01 -4.2075000762939453e+01 -8.5267799377441406e+01 -3.5952198028564453e+01 -5.5527603149414062e+01 -7.9629501342773438e+01 -4.6741401672363281e+01 -5.1821601867675781e+01 -7.9629501342773438e+01 -4.5224102020263672e+01 -5.1831699371337891e+01 -8.5267799377441406e+01 -4.2320999145507812e+01 -5.0693698883056641e+01 -7.9629501342773438e+01 -4.4652397155761719e+01 -4.8249599456787109e+01 -7.9629501342773438e+01 -4.3413501739501953e+01 -3.3173500061035156e+01 -7.9629501342773438e+01 -3.0434099197387695e+01 -3.4180202484130859e+01 -8.5267799377441406e+01 -2.7383100509643555e+01 -3.6572399139404297e+01 -8.5267799377441406e+01 -3.0454000473022461e+01 -4.1599601745605469e+01 -7.9629501342773438e+01 -3.8961196899414062e+01 -3.8564701080322266e+01 -7.9629501342773438e+01 -3.6348499298095703e+01 -3.9209999084472656e+01 -8.5267799377441406e+01 -3.3316898345947266e+01 -3.7379600524902344e+01 -7.9629501342773438e+01 -3.5149101257324219e+01 -3.5749900817871094e+01 -7.9629501342773438e+01 -3.3499900817871094e+01 -3.2073799133300781e+01 -7.9629501342773438e+01 -2.8888500213623047e+01 -3.0851999282836914e+01 -7.9629501342773438e+01 -2.7171001434326172e+01 -3.2049800872802734e+01 -8.5267799377441406e+01 -2.4125200271606445e+01 -2.8800699234008789e+01 -7.9629501342773438e+01 -2.3731599807739258e+01 -3.0195699691772461e+01 -8.5267799377441406e+01 -2.0702400207519531e+01 -2.7870298385620117e+01 -7.9629501342773438e+01 -2.1840398788452148e+01 -2.7032800674438477e+01 -7.9629501342773438e+01 -2.0138299942016602e+01 -2.8630599975585938e+01 -8.5267799377441406e+01 -1.7138299942016602e+01 -2.5559799194335938e+01 -7.9629501342773438e+01 -1.6414501190185547e+01 -2.7365200042724609e+01 -8.5267799377441406e+01 -1.3457000732421875e+01 -2.4883199691772461e+01 -7.9629501342773438e+01 -1.4196800231933594e+01 -2.4391201019287109e+01 -7.9629501342773438e+01 -1.2584099769592285e+01 -2.6408100128173828e+01 -8.5267799377441406e+01 -9.6838502883911133e+00 -2.3534599304199219e+01 -7.9629501342773438e+01 -8.6721200942993164e+00 -2.5765800476074219e+01 -8.5267799377441406e+01 -5.8445301055908203e+00 -2.3194198608398438e+01 -7.9629501342773438e+01 -6.1657400131225586e+00 -2.2995599746704102e+01 -7.9629501342773438e+01 -4.7039399147033691e+00 -2.5442798614501953e+01 -8.5267799377441406e+01 -1.9652799367904663e+00 -2.2777599334716797e+01 -7.9629501342773438e+01 -7.0524299144744873e-01 -2.5441299438476562e+01 -8.5267799377441406e+01 1.9273200035095215e+00 -2.2848999023437500e+01 -7.9629501342773438e+01 2.0340099334716797e+00 -2.2882101058959961e+01 -7.9629501342773438e+01 3.2979798316955566e+00 -2.5761098861694336e+01 -8.5267799377441406e+01 5.8067998886108398e+00 -2.3308399200439453e+01 -7.9629501342773438e+01 7.2798700332641602e+00 -2.6400299072265625e+01 -8.5267799377441406e+01 9.6466503143310547e+00 -2.3857599258422852e+01 -7.9629501342773438e+01 1.0179300308227539e+01 -2.4053699493408203e+01 -7.9629501342773438e+01 1.1214599609375000e+01 -2.7354299545288086e+01 -8.5267799377441406e+01 1.3420600891113281e+01 -2.5113100051879883e+01 -7.9629501342773438e+01 1.5076499938964844e+01 -2.8616800308227539e+01 -8.5267799377441406e+01 1.7102800369262695e+01 -2.6192300796508789e+01 -7.9629501342773438e+01 1.8048500061035156e+01 -2.6479999542236328e+01 -7.9629501342773438e+01 1.8840700149536133e+01 -3.0178998947143555e+01 -8.5267799377441406e+01 2.0668300628662109e+01 -2.8145198822021484e+01 -7.9629501342773438e+01 2.2482700347900391e+01 -3.2030399322509766e+01 -8.5267799377441406e+01 2.4092498779296875e+01 -2.9789899826049805e+01 -7.9629501342773438e+01 2.5427000045776367e+01 -3.0098199844360352e+01 -7.9629501342773438e+01 2.5978900909423828e+01 -3.4158100128173828e+01 -8.5267799377441406e+01 2.7352201461791992e+01 -3.2326099395751953e+01 -7.9629501342773438e+01 2.9306499481201172e+01 -3.6547798156738281e+01 -8.5267799377441406e+01 3.0424999237060547e+01 -3.4552700042724609e+01 -7.9629501342773438e+01 3.2113998413085938e+01 -3.4814598083496094e+01 -7.9629501342773438e+01 3.2444202423095703e+01 -3.9183097839355469e+01 -8.5267799377441406e+01 3.3289997100830078e+01 -3.7547397613525391e+01 -7.9629501342773438e+01 3.5371398925781250e+01 -4.2045997619628906e+01 -8.5267799377441406e+01 3.5927600860595703e+01 -4.0351303100585938e+01 -7.9629501342773438e+01 3.7927299499511719e+01 -4.0506999969482422e+01 -7.9629501342773438e+01 3.8069198608398438e+01 -4.5116901397705078e+01 -8.5267799377441406e+01 3.8319801330566406e+01 -4.3674098968505859e+01 -7.9629501342773438e+01 4.0520103454589844e+01 -4.8374797821044922e+01 -8.5267799377441406e+01 4.0450099945068359e+01 -4.7027999877929688e+01 -7.9629501342773438e+01 4.2708301544189453e+01 -5.0547203063964844e+01 -7.9629501342773438e+01 4.4619400024414062e+01 -1.0783499908447266e+02 -7.8048202514648438e+01 -3.5758701324462891e+01 -1.1059799957275391e+02 -7.8048202514648438e+01 -3.2799400329589844e+01 -1.1311399841308594e+02 -7.8048202514648438e+01 -2.9627399444580078e+01 -1.1536599731445312e+02 -7.8048202514648438e+01 -2.6263299942016602e+01 -1.1733999633789062e+02 -7.8048202514648438e+01 -2.2728899002075195e+01 -1.1902400207519531e+02 -7.8048202514648438e+01 -1.9046998977661133e+01 -1.2040599822998047e+02 -7.8048202514648438e+01 -1.5241600036621094e+01 -1.2147699737548828e+02 -7.8048202514648438e+01 -1.1337400436401367e+01 -1.2223000335693359e+02 -7.8048202514648438e+01 -7.3596200942993164e+00 -1.2266100311279297e+02 -7.8048202514648438e+01 -3.3341100215911865e+00 -1.2276699829101562e+02 -7.8048202514648438e+01 7.1296495199203491e-01 -1.2254699707031250e+02 -7.8048202514648438e+01 4.7554402351379395e+00 -1.2200199890136719e+02 -7.8048202514648438e+01 8.7670698165893555e+00 -1.2113600158691406e+02 -7.8048202514648438e+01 1.2721899986267090e+01 -1.1995399475097656e+02 -7.8048202514648438e+01 1.6594200134277344e+01 -1.1846499633789062e+02 -7.8048202514648438e+01 2.0358900070190430e+01 -1.1667800140380859e+02 -7.8048202514648438e+01 2.3991498947143555e+01 -1.1225699615478516e+02 -7.8048202514648438e+01 3.0767400741577148e+01 -1.1460399627685547e+02 -7.8048202514648438e+01 2.7468500137329102e+01 -1.0965299987792969e+02 -7.8048202514648438e+01 3.3866802215576172e+01 -1.0680699920654297e+02 -7.8048202514648438e+01 3.6746402740478516e+01 -1.0046800231933594e+02 -7.8048202514648438e+01 4.1773799896240234e+01 -1.0373899841308594e+02 -7.8048202514648438e+01 3.9387901306152344e+01 -9.7015998840332031e+01 -7.8048202514648438e+01 4.3888900756835938e+01 -9.3404899597167969e+01 -7.8048202514648438e+01 4.5719299316406250e+01 -8.5800300598144531e+01 -7.8048202514648438e+01 4.8480598449707031e+01 -8.9658294677734375e+01 -7.8048202514648438e+01 4.7253097534179688e+01 -8.1856201171875000e+01 -7.8048202514648438e+01 4.9393600463867188e+01 -7.7851303100585938e+01 -7.8048202514648438e+01 4.9986297607421875e+01 -7.3811698913574219e+01 -7.8048202514648438e+01 5.0254798889160156e+01 -6.9763603210449219e+01 -7.8048202514648438e+01 5.0197399139404297e+01 -6.5733299255371094e+01 -7.8048202514648438e+01 4.9814399719238281e+01 -6.1746799468994141e+01 -7.8048202514648438e+01 4.9108402252197266e+01 -5.7830097198486328e+01 -7.8048202514648438e+01 4.8083900451660156e+01 -5.4008499145507812e+01 -7.8048202514648438e+01 4.6747497558593750e+01 -5.0306900024414062e+01 -7.8048202514648438e+01 4.5108001708984375e+01 -4.6749099731445312e+01 -7.8048202514648438e+01 4.3175899505615234e+01 -4.3358402252197266e+01 -7.8048202514648438e+01 4.0963798522949219e+01 -4.0156700134277344e+01 -7.8048202514648438e+01 3.8486099243164062e+01 -3.7164699554443359e+01 -7.8048202514648438e+01 3.5758701324462891e+01 -3.4401901245117188e+01 -7.8048202514648438e+01 3.2799400329589844e+01 -3.1886201858520508e+01 -7.8048202514648438e+01 2.9627399444580078e+01 -2.9633899688720703e+01 -7.8048202514648438e+01 2.6263299942016602e+01 -2.7659601211547852e+01 -7.8048202514648438e+01 2.2728899002075195e+01 -2.5976099014282227e+01 -7.8048202514648438e+01 1.9046998977661133e+01 -2.4594299316406250e+01 -7.8048202514648438e+01 1.5241600036621094e+01 -2.3523200988769531e+01 -7.8048202514648438e+01 1.1337400436401367e+01 -2.2769701004028320e+01 -7.8048202514648438e+01 7.3596200942993164e+00 -2.2338800430297852e+01 -7.8048202514648438e+01 3.3341100215911865e+00 -2.2233200073242188e+01 -7.8048202514648438e+01 -7.1296495199203491e-01 -2.2453500747680664e+01 -7.8048202514648438e+01 -4.7554402351379395e+00 -2.2998500823974609e+01 -7.8048202514648438e+01 -8.7670698165893555e+00 -2.3864398956298828e+01 -7.8048202514648438e+01 -1.2721899986267090e+01 -2.5045799255371094e+01 -7.8048202514648438e+01 -1.6594200134277344e+01 -2.6534999847412109e+01 -7.8048202514648438e+01 -2.0358900070190430e+01 -2.8322198867797852e+01 -7.8048202514648438e+01 -2.3991498947143555e+01 -3.2742797851562500e+01 -7.8048202514648438e+01 -3.0767400741577148e+01 -3.0395999908447266e+01 -7.8048202514648438e+01 -2.7468500137329102e+01 -3.5347499847412109e+01 -7.8048202514648438e+01 -3.3866802215576172e+01 -3.8193099975585938e+01 -7.8048202514648438e+01 -3.6746402740478516e+01 -4.4532001495361328e+01 -7.8048202514648438e+01 -4.1773799896240234e+01 -4.1261199951171875e+01 -7.8048202514648438e+01 -3.9387901306152344e+01 -4.7984001159667969e+01 -7.8048202514648438e+01 -4.3888900756835938e+01 -5.1595100402832031e+01 -7.8048202514648438e+01 -4.5719299316406250e+01 -5.9199699401855469e+01 -7.8048202514648438e+01 -4.8480598449707031e+01 -5.5341800689697266e+01 -7.8048202514648438e+01 -4.7253097534179688e+01 -6.3143901824951172e+01 -7.8048202514648438e+01 -4.9393600463867188e+01 -6.7148796081542969e+01 -7.8048202514648438e+01 -4.9986297607421875e+01 -7.1188400268554688e+01 -7.8048202514648438e+01 -5.0254798889160156e+01 -7.5236495971679688e+01 -7.8048202514648438e+01 -5.0197399139404297e+01 -7.9266799926757812e+01 -7.8048202514648438e+01 -4.9814399719238281e+01 -8.3253196716308594e+01 -7.8048202514648438e+01 -4.9108402252197266e+01 -8.7169998168945312e+01 -7.8048202514648438e+01 -4.8083900451660156e+01 -9.0991500854492188e+01 -7.8048202514648438e+01 -4.6747497558593750e+01 -9.4693199157714844e+01 -7.8048202514648438e+01 -4.5108001708984375e+01 -9.8250900268554688e+01 -7.8048202514648438e+01 -4.3175899505615234e+01 -1.0164199829101562e+02 -7.8048202514648438e+01 -4.0963798522949219e+01 -1.0484299468994141e+02 -7.8048202514648438e+01 -3.8486099243164062e+01 -9.2494194030761719e+01 -8.6788002014160156e+01 -4.0856903076171875e+01 -9.5799903869628906e+01 -8.6788002014160156e+01 -3.9066299438476562e+01 -9.8946403503417969e+01 -8.6788002014160156e+01 -3.7008800506591797e+01 -1.0191200256347656e+02 -8.6788002014160156e+01 -3.4698501586914062e+01 -1.0467700195312500e+02 -8.6788002014160156e+01 -3.2151100158691406e+01 -1.0722200012207031e+02 -8.6788002014160156e+01 -2.9384099960327148e+01 -1.0952999877929688e+02 -8.6788002014160156e+01 -2.6416400909423828e+01 -1.1158499908447266e+02 -8.6788002014160156e+01 -2.3268299102783203e+01 -1.1337299346923828e+02 -8.6788002014160156e+01 -1.9961200714111328e+01 -1.1488199615478516e+02 -8.6788002014160156e+01 -1.6517700195312500e+01 -1.1610099792480469e+02 -8.6788002014160156e+01 -1.2961400032043457e+01 -1.1702299499511719e+02 -8.6788002014160156e+01 -9.3166208267211914e+00 -1.1764000701904297e+02 -8.6788002014160156e+01 -5.6081399917602539e+00 -1.1794900512695312e+02 -8.6788002014160156e+01 -1.8613899946212769e+00 -1.1794699859619141e+02 -8.6788002014160156e+01 1.8980499505996704e+00 -1.1763499450683594e+02 -8.6788002014160156e+01 5.6446199417114258e+00 -1.1701499938964844e+02 -8.6788002014160156e+01 9.3525600433349609e+00 -1.1609099578857422e+02 -8.6788002014160156e+01 1.2996699333190918e+01 -1.1486899566650391e+02 -8.6788002014160156e+01 1.6552000045776367e+01 -1.1335700225830078e+02 -8.6788002014160156e+01 1.9994199752807617e+01 -1.1156600189208984e+02 -8.6788002014160156e+01 2.3299800872802734e+01 -1.0950899505615234e+02 -8.6788002014160156e+01 2.6446300506591797e+01 -1.0719899749755859e+02 -8.6788002014160156e+01 2.9412200927734375e+01 -1.0465099334716797e+02 -8.6788002014160156e+01 3.2177101135253906e+01 -1.0188400268554688e+02 -8.6788002014160156e+01 3.4722202301025391e+01 -9.8916503906250000e+01 -8.6788002014160156e+01 3.7030200958251953e+01 -9.5768402099609375e+01 -8.6788002014160156e+01 3.9085102081298828e+01 -9.2461303710937500e+01 -8.6788002014160156e+01 4.0873100280761719e+01 -8.9017799377441406e+01 -8.6788002014160156e+01 4.2381900787353516e+01 -8.5461494445800781e+01 -8.6788002014160156e+01 4.3601200103759766e+01 -8.1816703796386719e+01 -8.6788002014160156e+01 4.4522598266601562e+01 -7.8108200073242188e+01 -8.6788002014160156e+01 4.5139801025390625e+01 -7.4361396789550781e+01 -8.6788002014160156e+01 4.5448799133300781e+01 -7.0601905822753906e+01 -8.6788002014160156e+01 4.5447299957275391e+01 -6.6855400085449219e+01 -8.6788002014160156e+01 4.5135299682617188e+01 -6.3147403717041016e+01 -8.6788002014160156e+01 4.4515098571777344e+01 -5.9503299713134766e+01 -8.6788002014160156e+01 4.3590698242187500e+01 -5.5948001861572266e+01 -8.6788002014160156e+01 4.2368499755859375e+01 -5.2505798339843750e+01 -8.6788002014160156e+01 4.0856903076171875e+01 -4.9200099945068359e+01 -8.6788002014160156e+01 3.9066299438476562e+01 -4.6053699493408203e+01 -8.6788002014160156e+01 3.7008800506591797e+01 -4.3087898254394531e+01 -8.6788002014160156e+01 3.4698501586914062e+01 -4.0322898864746094e+01 -8.6788002014160156e+01 3.2151100158691406e+01 -3.7777801513671875e+01 -8.6788002014160156e+01 2.9384099960327148e+01 -3.5469902038574219e+01 -8.6788002014160156e+01 2.6416400909423828e+01 -3.3414901733398438e+01 -8.6788002014160156e+01 2.3268299102783203e+01 -3.1626899719238281e+01 -8.6788002014160156e+01 1.9961200714111328e+01 -3.0118101119995117e+01 -8.6788002014160156e+01 1.6517700195312500e+01 -2.8898900985717773e+01 -8.6788002014160156e+01 1.2961400032043457e+01 -2.7977399826049805e+01 -8.6788002014160156e+01 9.3166208267211914e+00 -2.7360099792480469e+01 -8.6788002014160156e+01 5.6081399917602539e+00 -2.7051198959350586e+01 -8.6788002014160156e+01 1.8613899946212769e+00 -2.7052700042724609e+01 -8.6788002014160156e+01 -1.8980499505996704e+00 -2.7364698410034180e+01 -8.6788002014160156e+01 -5.6446199417114258e+00 -2.7984899520874023e+01 -8.6788002014160156e+01 -9.3525600433349609e+00 -2.8909299850463867e+01 -8.6788002014160156e+01 -1.2996699333190918e+01 -3.0131500244140625e+01 -8.6788002014160156e+01 -1.6552000045776367e+01 -3.1643100738525391e+01 -8.6788002014160156e+01 -1.9994199752807617e+01 -3.3433700561523438e+01 -8.6788002014160156e+01 -2.3299800872802734e+01 -3.5491199493408203e+01 -8.6788002014160156e+01 -2.6446300506591797e+01 -3.7801502227783203e+01 -8.6788002014160156e+01 -2.9412200927734375e+01 -4.0348899841308594e+01 -8.6788002014160156e+01 -3.2177101135253906e+01 -4.3115898132324219e+01 -8.6788002014160156e+01 -3.4722202301025391e+01 -4.6083599090576172e+01 -8.6788002014160156e+01 -3.7030200958251953e+01 -4.9231700897216797e+01 -8.6788002014160156e+01 -3.9085102081298828e+01 -5.2538799285888672e+01 -8.6788002014160156e+01 -4.0873100280761719e+01 -5.5982299804687500e+01 -8.6788002014160156e+01 -4.2381900787353516e+01 -5.9538600921630859e+01 -8.6788002014160156e+01 -4.3601200103759766e+01 -6.3183395385742188e+01 -8.6788002014160156e+01 -4.4522598266601562e+01 -6.6891899108886719e+01 -8.6788002014160156e+01 -4.5139801025390625e+01 -7.0638595581054688e+01 -8.6788002014160156e+01 -4.5448799133300781e+01 -7.4398101806640625e+01 -8.6788002014160156e+01 -4.5447299957275391e+01 -7.8144599914550781e+01 -8.6788002014160156e+01 -4.5135299682617188e+01 -8.1852600097656250e+01 -8.6788002014160156e+01 -4.4515098571777344e+01 -8.5496704101562500e+01 -8.6788002014160156e+01 -4.3590698242187500e+01 -8.9052001953125000e+01 -8.6788002014160156e+01 -4.2368499755859375e+01 -9.2912300109863281e+01 -8.6182106018066406e+01 -4.1711299896240234e+01 -9.6287101745605469e+01 -8.6182106018066406e+01 -3.9883201599121094e+01 -9.9499397277832031e+01 -8.6182106018066406e+01 -3.7782596588134766e+01 -1.0252700042724609e+02 -8.6182106018066406e+01 -3.5423999786376953e+01 -1.0535000610351562e+02 -8.6182106018066406e+01 -3.2823398590087891e+01 -1.0794799804687500e+02 -8.6182106018066406e+01 -2.9998500823974609e+01 -1.1030400085449219e+02 -8.6182106018066406e+01 -2.6968799591064453e+01 -1.1240200042724609e+02 -8.6182106018066406e+01 -2.3754798889160156e+01 -1.1422800445556641e+02 -8.6182106018066406e+01 -2.0378601074218750e+01 -1.1576799774169922e+02 -8.6182106018066406e+01 -1.6863100051879883e+01 -1.1701300048828125e+02 -8.6182106018066406e+01 -1.3232500076293945e+01 -1.1795400238037109e+02 -8.6182106018066406e+01 -9.5114107131958008e+00 -1.1858399963378906e+02 -8.6182106018066406e+01 -5.7253799438476562e+00 -1.1889900207519531e+02 -8.6182106018066406e+01 -1.9003100395202637e+00 -1.1889799499511719e+02 -8.6182106018066406e+01 1.9377499818801880e+00 -1.1857900238037109e+02 -8.6182106018066406e+01 5.7626399993896484e+00 -1.1794599914550781e+02 -8.6182106018066406e+01 9.5481300354003906e+00 -1.1700200653076172e+02 -8.6182106018066406e+01 1.3268400192260742e+01 -1.1575399780273438e+02 -8.6182106018066406e+01 1.6898000717163086e+01 -1.1421099853515625e+02 -8.6182106018066406e+01 2.0412300109863281e+01 -1.1238300323486328e+02 -8.6182106018066406e+01 2.3786998748779297e+01 -1.1028300476074219e+02 -8.6182106018066406e+01 2.6999300003051758e+01 -1.0792399597167969e+02 -8.6182106018066406e+01 3.0027101516723633e+01 -1.0532299804687500e+02 -8.6182106018066406e+01 3.2849899291992188e+01 -1.0249900054931641e+02 -8.6182106018066406e+01 3.5448200225830078e+01 -9.9468902587890625e+01 -8.6182106018066406e+01 3.7804397583007812e+01 -9.6254806518554688e+01 -8.6182106018066406e+01 3.9902400970458984e+01 -9.2878601074218750e+01 -8.6182106018066406e+01 4.1727699279785156e+01 -8.9363204956054688e+01 -8.6182106018066406e+01 4.3268100738525391e+01 -8.5732498168945312e+01 -8.6182106018066406e+01 4.4512802124023438e+01 -8.2011497497558594e+01 -8.6182106018066406e+01 4.5453498840332031e+01 -7.8225502014160156e+01 -8.6182106018066406e+01 4.6083698272705078e+01 -7.4400299072265625e+01 -8.6182106018066406e+01 4.6399101257324219e+01 -7.0562301635742188e+01 -8.6182106018066406e+01 4.6397602081298828e+01 -6.6737396240234375e+01 -8.6182106018066406e+01 4.6079097747802734e+01 -6.2951900482177734e+01 -8.6182106018066406e+01 4.5445800781250000e+01 -5.9231601715087891e+01 -8.6182106018066406e+01 4.4502101898193359e+01 -5.5601997375488281e+01 -8.6182106018066406e+01 4.3254402160644531e+01 -5.2087703704833984e+01 -8.6182106018066406e+01 4.1711299896240234e+01 -4.8712997436523438e+01 -8.6182106018066406e+01 3.9883201599121094e+01 -4.5500698089599609e+01 -8.6182106018066406e+01 3.7782596588134766e+01 -4.2472900390625000e+01 -8.6182106018066406e+01 3.5423999786376953e+01 -3.9650100708007812e+01 -8.6182106018066406e+01 3.2823398590087891e+01 -3.7051799774169922e+01 -8.6182106018066406e+01 2.9998500823974609e+01 -3.4695598602294922e+01 -8.6182106018066406e+01 2.6968799591064453e+01 -3.2597602844238281e+01 -8.6182106018066406e+01 2.3754798889160156e+01 -3.0772300720214844e+01 -8.6182106018066406e+01 2.0378601074218750e+01 -2.9231901168823242e+01 -8.6182106018066406e+01 1.6863100051879883e+01 -2.7987100601196289e+01 -8.6182106018066406e+01 1.3232500076293945e+01 -2.7046499252319336e+01 -8.6182106018066406e+01 9.5114107131958008e+00 -2.6416299819946289e+01 -8.6182106018066406e+01 5.7253799438476562e+00 -2.6100900650024414e+01 -8.6182106018066406e+01 1.9003100395202637e+00 -2.6102399826049805e+01 -8.6182106018066406e+01 -1.9377499818801880e+00 -2.6420900344848633e+01 -8.6182106018066406e+01 -5.7626399993896484e+00 -2.7054199218750000e+01 -8.6182106018066406e+01 -9.5481300354003906e+00 -2.7997900009155273e+01 -8.6182106018066406e+01 -1.3268400192260742e+01 -2.9245599746704102e+01 -8.6182106018066406e+01 -1.6898000717163086e+01 -3.0788700103759766e+01 -8.6182106018066406e+01 -2.0412300109863281e+01 -3.2616802215576172e+01 -8.6182106018066406e+01 -2.3786998748779297e+01 -3.4717300415039062e+01 -8.6182106018066406e+01 -2.6999300003051758e+01 -3.7076000213623047e+01 -8.6182106018066406e+01 -3.0027101516723633e+01 -3.9676597595214844e+01 -8.6182106018066406e+01 -3.2849899291992188e+01 -4.2501502990722656e+01 -8.6182106018066406e+01 -3.5448200225830078e+01 -4.5531196594238281e+01 -8.6182106018066406e+01 -3.7804397583007812e+01 -4.8745201110839844e+01 -8.6182106018066406e+01 -3.9902400970458984e+01 -5.2121398925781250e+01 -8.6182106018066406e+01 -4.1727699279785156e+01 -5.5636901855468750e+01 -8.6182106018066406e+01 -4.3268100738525391e+01 -5.9267498016357422e+01 -8.6182106018066406e+01 -4.4512802124023438e+01 -6.2988601684570312e+01 -8.6182106018066406e+01 -4.5453498840332031e+01 -6.6774597167968750e+01 -8.6182106018066406e+01 -4.6083698272705078e+01 -7.0599700927734375e+01 -8.6182106018066406e+01 -4.6399101257324219e+01 -7.4437797546386719e+01 -8.6182106018066406e+01 -4.6397602081298828e+01 -7.8262702941894531e+01 -8.6182106018066406e+01 -4.6079097747802734e+01 -8.2048202514648438e+01 -8.6182106018066406e+01 -4.5445800781250000e+01 -8.5768402099609375e+01 -8.6182106018066406e+01 -4.4502101898193359e+01 -8.9398101806640625e+01 -8.6182106018066406e+01 -4.3254402160644531e+01 -2.0100000000000000e+02 -1.2151499748229980e+01 -4.7985301971435547e+01 -2.0100000000000000e+02 -1.2765199661254883e+01 -5.0408798217773438e+01 -2.0100000000000000e+02 -4.0876302719116211e+00 -4.9330902099609375e+01 -2.0100000000000000e+02 -4.2941002845764160e+00 -5.1822402954101562e+01 -2.0100000000000000e+02 4.0876302719116211e+00 -4.9330902099609375e+01 -2.0100000000000000e+02 4.2941002845764160e+00 -5.1822402954101562e+01 -2.0100000000000000e+02 1.2151499748229980e+01 -4.7985301971435547e+01 -2.0100000000000000e+02 1.2765199661254883e+01 -5.0408798217773438e+01 -2.0100000000000000e+02 1.9883901596069336e+01 -4.5330799102783203e+01 -2.0100000000000000e+02 2.0888099670410156e+01 -4.7620201110839844e+01 -2.0100000000000000e+02 2.7073900222778320e+01 -4.1439701080322266e+01 -2.0100000000000000e+02 2.8441301345825195e+01 -4.3532600402832031e+01 -2.0100000000000000e+02 3.3525398254394531e+01 -3.6418300628662109e+01 -2.0100000000000000e+02 3.5218601226806641e+01 -3.8257598876953125e+01 -2.0100000000000000e+02 3.9062400817871094e+01 -3.0403499603271484e+01 -2.0100000000000000e+02 4.1035297393798828e+01 -3.1938999176025391e+01 -2.0100000000000000e+02 4.3533897399902344e+01 -2.3559400558471680e+01 -2.0100000000000000e+02 4.5732597351074219e+01 -2.4749200820922852e+01 -2.0100000000000000e+02 4.6818000793457031e+01 -1.6072599411010742e+01 -2.0100000000000000e+02 4.9182498931884766e+01 -1.6884300231933594e+01 -2.0100000000000000e+02 4.8824798583984375e+01 -8.1474199295043945e+00 -2.0100000000000000e+02 5.1290798187255859e+01 -8.5588703155517578e+00 -2.0100000000000000e+02 4.9500000000000000e+01 0.0000000000000000e+00 -2.0100000000000000e+02 5.2000000000000000e+01 0.0000000000000000e+00 -2.0100000000000000e+02 4.8824798583984375e+01 8.1474199295043945e+00 -2.0100000000000000e+02 5.1290798187255859e+01 8.5588703155517578e+00 -2.0100000000000000e+02 4.6818000793457031e+01 1.6072599411010742e+01 -2.0100000000000000e+02 4.9182498931884766e+01 1.6884300231933594e+01 -2.0100000000000000e+02 4.3533897399902344e+01 2.3559400558471680e+01 -2.0100000000000000e+02 4.5732597351074219e+01 2.4749200820922852e+01 -2.0100000000000000e+02 3.9062400817871094e+01 3.0403499603271484e+01 -2.0100000000000000e+02 4.1035297393798828e+01 3.1938999176025391e+01 -2.0100000000000000e+02 3.3525398254394531e+01 3.6418300628662109e+01 -2.0100000000000000e+02 3.5218601226806641e+01 3.8257598876953125e+01 -2.0100000000000000e+02 2.7073900222778320e+01 4.1439701080322266e+01 -2.0100000000000000e+02 2.8441301345825195e+01 4.3532600402832031e+01 -2.0100000000000000e+02 1.9883901596069336e+01 4.5330799102783203e+01 -2.0100000000000000e+02 2.0888099670410156e+01 4.7620201110839844e+01 -2.0100000000000000e+02 1.2151499748229980e+01 4.7985301971435547e+01 -2.0100000000000000e+02 1.2765199661254883e+01 5.0408798217773438e+01 -2.0100000000000000e+02 4.0876302719116211e+00 4.9330902099609375e+01 -2.0100000000000000e+02 4.2941002845764160e+00 5.1822402954101562e+01 -2.0100000000000000e+02 -4.0876302719116211e+00 4.9330902099609375e+01 -2.0100000000000000e+02 -4.2941002845764160e+00 5.1822402954101562e+01 -2.0100000000000000e+02 -1.2151499748229980e+01 4.7985301971435547e+01 -2.0100000000000000e+02 -1.2765199661254883e+01 5.0408798217773438e+01 -2.0100000000000000e+02 -1.9883901596069336e+01 4.5330799102783203e+01 -2.0100000000000000e+02 -2.0888099670410156e+01 4.7620201110839844e+01 -2.0100000000000000e+02 -2.7073900222778320e+01 4.1439701080322266e+01 -2.0100000000000000e+02 -2.8441301345825195e+01 4.3532600402832031e+01 -2.0100000000000000e+02 -3.3525398254394531e+01 3.6418300628662109e+01 -2.0100000000000000e+02 -3.5218601226806641e+01 3.8257598876953125e+01 -2.0100000000000000e+02 -3.9062400817871094e+01 3.0403499603271484e+01 -2.0100000000000000e+02 -4.1035297393798828e+01 3.1938999176025391e+01 -2.0100000000000000e+02 -4.3533897399902344e+01 2.3559400558471680e+01 -2.0100000000000000e+02 -4.5732597351074219e+01 2.4749200820922852e+01 -2.0100000000000000e+02 -4.6818000793457031e+01 1.6072599411010742e+01 -2.0100000000000000e+02 -4.9182498931884766e+01 1.6884300231933594e+01 -2.0100000000000000e+02 -4.8824798583984375e+01 8.1474199295043945e+00 -2.0100000000000000e+02 -5.1290798187255859e+01 8.5588703155517578e+00 -2.0100000000000000e+02 -4.9500000000000000e+01 0.0000000000000000e+00 -2.0100000000000000e+02 -5.2000000000000000e+01 0.0000000000000000e+00 -2.0100000000000000e+02 -4.8824798583984375e+01 -8.1474199295043945e+00 -2.0100000000000000e+02 -5.1290798187255859e+01 -8.5588703155517578e+00 -2.0100000000000000e+02 -4.6818000793457031e+01 -1.6072599411010742e+01 -2.0100000000000000e+02 -4.9182498931884766e+01 -1.6884300231933594e+01 -2.0100000000000000e+02 -4.3533897399902344e+01 -2.3559400558471680e+01 -2.0100000000000000e+02 -4.5732597351074219e+01 -2.4749200820922852e+01 -2.0100000000000000e+02 -3.9062400817871094e+01 -3.0403499603271484e+01 -2.0100000000000000e+02 -4.1035297393798828e+01 -3.1938999176025391e+01 -2.0100000000000000e+02 -3.3525398254394531e+01 -3.6418300628662109e+01 -2.0100000000000000e+02 -3.5218601226806641e+01 -3.8257598876953125e+01 -2.0100000000000000e+02 -2.7073900222778320e+01 -4.1439701080322266e+01 -2.0100000000000000e+02 -2.8441301345825195e+01 -4.3532600402832031e+01 -2.0100000000000000e+02 -1.9883901596069336e+01 -4.5330799102783203e+01 -2.0100000000000000e+02 -2.0888099670410156e+01 -4.7620201110839844e+01 -2.2900000000000000e+02 4.0876302719116211e+00 -4.9330902099609375e+01 -2.2900000000000000e+02 4.2941002845764160e+00 -5.1822402954101562e+01 -2.2900000000000000e+02 -4.0876302719116211e+00 -4.9330902099609375e+01 -2.2900000000000000e+02 -4.2941002845764160e+00 -5.1822402954101562e+01 -2.2900000000000000e+02 -1.2151499748229980e+01 -4.7985301971435547e+01 -2.2900000000000000e+02 -1.2765199661254883e+01 -5.0408798217773438e+01 -2.2900000000000000e+02 -1.9883901596069336e+01 -4.5330799102783203e+01 -2.2900000000000000e+02 -2.0888099670410156e+01 -4.7620201110839844e+01 -2.2900000000000000e+02 -2.7073900222778320e+01 -4.1439701080322266e+01 -2.2900000000000000e+02 -2.8441301345825195e+01 -4.3532600402832031e+01 -2.2900000000000000e+02 -3.3525398254394531e+01 -3.6418300628662109e+01 -2.2900000000000000e+02 -3.5218601226806641e+01 -3.8257598876953125e+01 -2.2900000000000000e+02 -3.9062400817871094e+01 -3.0403499603271484e+01 -2.2900000000000000e+02 -4.1035297393798828e+01 -3.1938999176025391e+01 -2.2900000000000000e+02 -4.3533897399902344e+01 -2.3559400558471680e+01 -2.2900000000000000e+02 -4.5732597351074219e+01 -2.4749200820922852e+01 -2.2900000000000000e+02 -4.6818000793457031e+01 -1.6072599411010742e+01 -2.2900000000000000e+02 -4.9182498931884766e+01 -1.6884300231933594e+01 -2.2900000000000000e+02 -4.8824798583984375e+01 -8.1474199295043945e+00 -2.2900000000000000e+02 -5.1290798187255859e+01 -8.5588703155517578e+00 -2.2900000000000000e+02 -4.9500000000000000e+01 0.0000000000000000e+00 -2.2900000000000000e+02 -5.2000000000000000e+01 0.0000000000000000e+00 -2.2900000000000000e+02 -4.8824798583984375e+01 8.1474199295043945e+00 -2.2900000000000000e+02 -5.1290798187255859e+01 8.5588703155517578e+00 -2.2900000000000000e+02 -4.6818000793457031e+01 1.6072599411010742e+01 -2.2900000000000000e+02 -4.9182498931884766e+01 1.6884300231933594e+01 -2.2900000000000000e+02 -4.3533897399902344e+01 2.3559400558471680e+01 -2.2900000000000000e+02 -4.5732597351074219e+01 2.4749200820922852e+01 -2.2900000000000000e+02 -3.9062400817871094e+01 3.0403499603271484e+01 -2.2900000000000000e+02 -4.1035297393798828e+01 3.1938999176025391e+01 -2.2900000000000000e+02 -3.3525398254394531e+01 3.6418300628662109e+01 -2.2900000000000000e+02 -3.5218601226806641e+01 3.8257598876953125e+01 -2.2900000000000000e+02 -2.7073900222778320e+01 4.1439701080322266e+01 -2.2900000000000000e+02 -2.8441301345825195e+01 4.3532600402832031e+01 -2.2900000000000000e+02 -1.9883901596069336e+01 4.5330799102783203e+01 -2.2900000000000000e+02 -2.0888099670410156e+01 4.7620201110839844e+01 -2.2900000000000000e+02 -1.2151499748229980e+01 4.7985301971435547e+01 -2.2900000000000000e+02 -1.2765199661254883e+01 5.0408798217773438e+01 -2.2900000000000000e+02 -4.0876302719116211e+00 4.9330902099609375e+01 -2.2900000000000000e+02 -4.2941002845764160e+00 5.1822402954101562e+01 -2.2900000000000000e+02 4.0876302719116211e+00 4.9330902099609375e+01 -2.2900000000000000e+02 4.2941002845764160e+00 5.1822402954101562e+01 -2.2900000000000000e+02 1.2151499748229980e+01 4.7985301971435547e+01 -2.2900000000000000e+02 1.2765199661254883e+01 5.0408798217773438e+01 -2.2900000000000000e+02 1.9883901596069336e+01 4.5330799102783203e+01 -2.2900000000000000e+02 2.0888099670410156e+01 4.7620201110839844e+01 -2.2900000000000000e+02 2.7073900222778320e+01 4.1439701080322266e+01 -2.2900000000000000e+02 2.8441301345825195e+01 4.3532600402832031e+01 -2.2900000000000000e+02 3.3525398254394531e+01 3.6418300628662109e+01 -2.2900000000000000e+02 3.5218601226806641e+01 3.8257598876953125e+01 -2.2900000000000000e+02 3.9062400817871094e+01 3.0403499603271484e+01 -2.2900000000000000e+02 4.1035297393798828e+01 3.1938999176025391e+01 -2.2900000000000000e+02 4.3533897399902344e+01 2.3559400558471680e+01 -2.2900000000000000e+02 4.5732597351074219e+01 2.4749200820922852e+01 -2.2900000000000000e+02 4.6818000793457031e+01 1.6072599411010742e+01 -2.2900000000000000e+02 4.9182498931884766e+01 1.6884300231933594e+01 -2.2900000000000000e+02 4.8824798583984375e+01 8.1474199295043945e+00 -2.2900000000000000e+02 5.1290798187255859e+01 8.5588703155517578e+00 -2.2900000000000000e+02 4.9500000000000000e+01 0.0000000000000000e+00 -2.2900000000000000e+02 5.2000000000000000e+01 0.0000000000000000e+00 -2.2900000000000000e+02 4.8824798583984375e+01 -8.1474199295043945e+00 -2.2900000000000000e+02 5.1290798187255859e+01 -8.5588703155517578e+00 -2.2900000000000000e+02 4.6818000793457031e+01 -1.6072599411010742e+01 -2.2900000000000000e+02 4.9182498931884766e+01 -1.6884300231933594e+01 -2.2900000000000000e+02 4.3533897399902344e+01 -2.3559400558471680e+01 -2.2900000000000000e+02 4.5732597351074219e+01 -2.4749200820922852e+01 -2.2900000000000000e+02 3.9062400817871094e+01 -3.0403499603271484e+01 -2.2900000000000000e+02 4.1035297393798828e+01 -3.1938999176025391e+01 -2.2900000000000000e+02 3.3525398254394531e+01 -3.6418300628662109e+01 -2.2900000000000000e+02 3.5218601226806641e+01 -3.8257598876953125e+01 -2.2900000000000000e+02 2.7073900222778320e+01 -4.1439701080322266e+01 -2.2900000000000000e+02 2.8441301345825195e+01 -4.3532600402832031e+01 -2.2900000000000000e+02 1.9883901596069336e+01 -4.5330799102783203e+01 -2.2900000000000000e+02 2.0888099670410156e+01 -4.7620201110839844e+01 -2.2900000000000000e+02 1.2151499748229980e+01 -4.7985301971435547e+01 -2.2900000000000000e+02 1.2765199661254883e+01 -5.0408798217773438e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 18354 -> 47 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -5.1290798932313919e+01 8.5588702932000160e+00) (float-vector -2.2900000214576721e+02 -4.1035298258066177e+01 3.1938999891281128e+01) (float-vector -1.6702400147914886e+02 -7.2414301335811615e+01 2.5176199153065681e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -2.8441300615668297e+01 -4.3532598763704300e+01) (float-vector -2.2900000214576721e+02 -4.1035298258066177e+01 -3.1938999891281128e+01) (float-vector -1.6481800377368927e+02 -7.3097199201583862e+01 -2.5175699964165688e+01) (float-vector -8.5768401622772217e+01 -8.6182102560997009e+01 -4.4502101838588715e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -5.1290798932313919e+01 -8.5588702932000160e+00) (float-vector -1.6481800377368927e+02 -7.3097199201583862e+01 -2.5175699964165688e+01) (float-vector -2.2900000214576721e+02 -4.1035298258066177e+01 -3.1938999891281128e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.3520600050687790e+01 -5.3500000387430191e+01 1.5914399176836014e+01) (float-vector -2.0784899592399597e+01 -5.4000001400709152e+01 5.4354700259864330e+00) (float-vector -2.0500000566244125e+01 -7.4500001966953278e+01 0.0000000000000000e+00) (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 2.1468499675393105e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.9267498552799225e+01 -8.6182102560997009e+01 -4.4512800872325897e+01) (float-vector -6.8280100822448730e+01 -7.4500001966953278e+01 -5.1828399300575256e+01) (float-vector -8.5768401622772217e+01 -8.6182102560997009e+01 -4.4502101838588715e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4401901066303253e+01 -7.8048199415206909e+01 3.2799400389194489e+01) (float-vector -3.4228101372718811e+01 -5.3500000387430191e+01 3.4460201859474182e+01) (float-vector -2.3520600050687790e+01 -5.3500000387430191e+01 1.5914399176836014e+01) (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 2.1468499675393105e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 2.8441300615668297e+01 4.3532598763704300e+01) (float-vector -1.9124299287796021e+02 2.2500600665807724e+01 4.6402599662542343e+01) (float-vector -2.2900000214576721e+02 1.2765199877321720e+01 5.0408799201250076e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9124299287796021e+02 2.2500600665807724e+01 4.6402599662542343e+01) (float-vector -2.2900000214576721e+02 2.8441300615668297e+01 4.3532598763704300e+01) (float-vector -2.2900000214576721e+02 4.1035298258066177e+01 3.1938999891281128e+01) (float-vector -1.9124299287796021e+02 4.0371101349592209e+01 3.2088201493024826e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -5.1290798932313919e+01 8.5588702932000160e+00) (float-vector -2.2900000214576721e+02 -5.1290798932313919e+01 -8.5588702932000160e+00) (float-vector -2.2900000214576721e+02 -4.1035298258066177e+01 -3.1938999891281128e+01) (float-vector -2.2900000214576721e+02 -2.8441300615668297e+01 -4.3532598763704300e+01) (float-vector -2.2900000214576721e+02 4.2941002175211906e+00 -5.1822401583194733e+01) (float-vector -2.2900000214576721e+02 2.8441300615668297e+01 -4.3532598763704300e+01) (float-vector -2.2900000214576721e+02 4.5732598751783371e+01 -2.4749200791120529e+01) (float-vector -2.2900000214576721e+02 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -2.2900000214576721e+02 4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.2900000214576721e+02 4.1035298258066177e+01 3.1938999891281128e+01) (float-vector -2.2900000214576721e+02 2.8441300615668297e+01 4.3532598763704300e+01) (float-vector -2.2900000214576721e+02 1.2765199877321720e+01 5.0408799201250076e+01) (float-vector -2.2900000214576721e+02 -4.2941002175211906e+00 5.1822401583194733e+01) (float-vector -2.2900000214576721e+02 -2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -2.2900000214576721e+02 -4.1035298258066177e+01 3.1938999891281128e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9480900466442108e+02 7.9257497563958168e+00 -5.1392398774623871e+01) (float-vector -1.9124299287796021e+02 2.9149899259209633e+01 -4.2541198432445526e+01) (float-vector -2.2900000214576721e+02 2.8441300615668297e+01 -4.3532598763704300e+01) (float-vector -2.2900000214576721e+02 4.2941002175211906e+00 -5.1822401583194733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -2.8441300615668297e+01 -4.3532598763704300e+01) (float-vector -8.5768401622772217e+01 -8.6182102560997009e+01 -4.4502101838588715e+01) (float-vector -6.8280100822448730e+01 -7.4500001966953278e+01 -5.1828399300575256e+01) (float-vector -2.2900000214576721e+02 4.2941002175211906e+00 -5.1822401583194733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9480900466442108e+02 7.9257497563958168e+00 -5.1392398774623871e+01) (float-vector -7.2499997913837433e+01 -5.4000001400709152e+01 -5.2000001072883606e+01) (float-vector -5.1349699497222900e+01 -5.4000001400709152e+01 -4.7504398971796036e+01) (float-vector -1.9124299287796021e+02 2.9149899259209633e+01 -4.2541198432445526e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.8280100822448730e+01 -7.4500001966953278e+01 -5.1828399300575256e+01) (float-vector -7.2499997913837433e+01 -5.4000001400709152e+01 -5.2000001072883606e+01) (float-vector -1.9480900466442108e+02 7.9257497563958168e+00 -5.1392398774623871e+01) (float-vector -2.2900000214576721e+02 4.2941002175211906e+00 -5.1822401583194733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6481800377368927e+02 -7.3097199201583862e+01 -2.5175699964165688e+01) (float-vector -1.1503999680280685e+02 -8.6999997496604919e+01 -1.2645799666643143e+01) (float-vector -8.5768401622772217e+01 -8.6182102560997009e+01 -4.4502101838588715e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0116899758577347e+02 -8.6999997496604919e+01 3.3876698464155197e+01) (float-vector -1.1503999680280685e+02 -8.6999997496604919e+01 -1.2645799666643143e+01) (float-vector -1.6702400147914886e+02 -7.2414301335811615e+01 2.5176199153065681e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -5.1290798932313919e+01 8.5588702932000160e+00) (float-vector -1.6702400147914886e+02 -7.2414301335811615e+01 2.5176199153065681e+01) (float-vector -1.1503999680280685e+02 -8.6999997496604919e+01 -1.2645799666643143e+01) (float-vector -1.6481800377368927e+02 -7.3097199201583862e+01 -2.5175699964165688e+01) (float-vector -2.2900000214576721e+02 -5.1290798932313919e+01 -8.5588702932000160e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.6100900024175644e+01 -8.6182102560997009e+01 1.9003100460395217e+00) (float-vector -2.8616800904273987e+01 -8.5267797112464905e+01 1.7102800309658051e+01) (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 2.1468499675393105e+01) (float-vector -2.0500000566244125e+01 -7.4500001966953278e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 2.1468499675393105e+01) (float-vector -2.8616800904273987e+01 -8.5267797112464905e+01 1.7102800309658051e+01) (float-vector -4.2472898960113525e+01 -8.6182102560997009e+01 3.5424001514911652e+01) (float-vector -3.4401901066303253e+01 -7.8048199415206909e+01 3.2799400389194489e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9124299287796021e+02 4.0371101349592209e+01 3.2088201493024826e+01) (float-vector -3.4228101372718811e+01 -5.3500000387430191e+01 3.4460201859474182e+01) (float-vector -6.1688598245382309e+01 -5.4000001400709152e+01 5.0863601267337799e+01) (float-vector -1.9124299287796021e+02 2.2500600665807724e+01 4.6402599662542343e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 -2.1468499675393105e+01) (float-vector -2.0500000566244125e+01 -7.4500001966953278e+01 0.0000000000000000e+00) (float-vector -2.0784899592399597e+01 -5.4000001400709152e+01 5.4354700259864330e+00) (float-vector -2.3045100271701813e+01 -5.4000001400709152e+01 -1.6068900004029274e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7365200221538544e+01 -8.5267797112464905e+01 -1.3457000255584717e+01) (float-vector -2.6100900024175644e+01 -8.6182102560997009e+01 1.9003100460395217e+00) (float-vector -2.0500000566244125e+01 -7.4500001966953278e+01 0.0000000000000000e+00) (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 -2.1468499675393105e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.5147798955440521e+01 -8.5267797112464905e+01 -3.8341898471117020e+01) (float-vector -2.7365200221538544e+01 -8.5267797112464905e+01 -1.3457000255584717e+01) (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 -2.1468499675393105e+01) (float-vector -3.8226701319217682e+01 -7.4500001966953278e+01 -3.9106801152229309e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.3856499940156937e+01 -5.4000001400709152e+01 -3.4794699400663376e+01) (float-vector -3.8226701319217682e+01 -7.4500001966953278e+01 -3.9106801152229309e+01) (float-vector -2.5138599798083305e+01 -7.4500001966953278e+01 -2.1468499675393105e+01) (float-vector -2.3045100271701813e+01 -5.4000001400709152e+01 -1.6068900004029274e+01) (float-vector -2.7899699285626411e+01 -5.3500000387430191e+01 -2.5750000029802322e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -5.1349699497222900e+01 -5.4000001400709152e+01 -4.7504398971796036e+01) (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 -4.5462999492883682e+01) (float-vector -3.8226701319217682e+01 -7.4500001966953278e+01 -3.9106801152229309e+01) (float-vector -3.3856499940156937e+01 -5.4000001400709152e+01 -3.4794699400663376e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.2499997913837433e+01 -5.4000001400709152e+01 -5.2000001072883606e+01) (float-vector -6.8280100822448730e+01 -7.4500001966953278e+01 -5.1828399300575256e+01) (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 -4.5462999492883682e+01) (float-vector -5.1349699497222900e+01 -5.4000001400709152e+01 -4.7504398971796036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.8226701319217682e+01 -7.4500001966953278e+01 -3.9106801152229309e+01) (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 -4.5462999492883682e+01) (float-vector -6.8280100822448730e+01 -7.4500001966953278e+01 -5.1828399300575256e+01) (float-vector -5.9267498552799225e+01 -8.6182102560997009e+01 -4.4512800872325897e+01) (float-vector -4.5147798955440521e+01 -8.5267797112464905e+01 -3.8341898471117020e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8788200616836548e+02 4.6844199299812317e+01 -1.8336400389671326e+01) (float-vector -1.9124299287796021e+02 5.1426600664854050e+01 -3.8445598911494017e+00) (float-vector -2.2900000214576721e+02 5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -2.2900000214576721e+02 4.5732598751783371e+01 -2.4749200791120529e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9124299287796021e+02 5.1426600664854050e+01 -3.8445598911494017e+00) (float-vector -1.9480900466442108e+02 5.0702400505542755e+01 1.1543699540197849e+01) (float-vector -2.2900000214576721e+02 4.9182500690221786e+01 1.6884300857782364e+01) (float-vector -2.2900000214576721e+02 5.2000001072883606e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9480900466442108e+02 5.0702400505542755e+01 1.1543699540197849e+01) (float-vector -1.9124299287796021e+02 4.0371101349592209e+01 3.2088201493024826e+01) (float-vector -2.2900000214576721e+02 4.1035298258066177e+01 3.1938999891281128e+01) (float-vector -2.2900000214576721e+02 4.9182500690221786e+01 1.6884300857782364e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -4.2941002175211906e+00 5.1822401583194733e+01) (float-vector -7.9320900142192841e+01 -7.4500001966953278e+01 5.1550701260566711e+01) (float-vector -2.2900000214576721e+02 -2.0888099446892738e+01 4.7620199620723724e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8788200616836548e+02 3.9380799978971481e+01 -3.1300999224185944e+01) (float-vector -1.9124299287796021e+02 2.9149899259209633e+01 -4.2541198432445526e+01) (float-vector -5.1349699497222900e+01 -5.4000001400709152e+01 -4.7504398971796036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8788200616836548e+02 3.9380799978971481e+01 -3.1300999224185944e+01) (float-vector -1.8788200616836548e+02 4.6844199299812317e+01 -1.8336400389671326e+01) (float-vector -2.2900000214576721e+02 4.5732598751783371e+01 -2.4749200791120529e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9124299287796021e+02 2.9149899259209633e+01 -4.2541198432445526e+01) (float-vector -1.8788200616836548e+02 3.9380799978971481e+01 -3.1300999224185944e+01) (float-vector -2.2900000214576721e+02 4.5732598751783371e+01 -2.4749200791120529e+01) (float-vector -2.2900000214576721e+02 2.8441300615668297e+01 -4.3532598763704300e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8788200616836548e+02 3.9380799978971481e+01 -3.1300999224185944e+01) (float-vector -5.1349699497222900e+01 -5.4000001400709152e+01 -4.7504398971796036e+01) (float-vector -3.3856499940156937e+01 -5.4000001400709152e+01 -3.4794699400663376e+01) (float-vector -2.7899699285626411e+01 -5.3500000387430191e+01 -2.5750000029802322e+01) (float-vector -1.8788200616836548e+02 4.6844199299812317e+01 -1.8336400389671326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.8788200616836548e+02 4.9049898982048035e+01 1.1167500168085098e+01) (float-vector -1.9480900466442108e+02 5.0702400505542755e+01 1.1543699540197849e+01) (float-vector -1.9124299287796021e+02 5.1426600664854050e+01 -3.8445598911494017e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.7899699285626411e+01 -5.3500000387430191e+01 -2.5750000029802322e+01) (float-vector -2.3045100271701813e+01 -5.4000001400709152e+01 -1.6068900004029274e+01) (float-vector -2.0784899592399597e+01 -5.4000001400709152e+01 5.4354700259864330e+00) (float-vector -2.3520600050687790e+01 -5.3500000387430191e+01 1.5914399176836014e+01) (float-vector -1.8788200616836548e+02 4.9049898982048035e+01 1.1167500168085098e+01) (float-vector -1.9124299287796021e+02 5.1426600664854050e+01 -3.8445598911494017e+00) (float-vector -1.8788200616836548e+02 4.6844199299812317e+01 -1.8336400389671326e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9480900466442108e+02 5.0702400505542755e+01 1.1543699540197849e+01) (float-vector -1.8788200616836548e+02 4.9049898982048035e+01 1.1167500168085098e+01) (float-vector -2.3520600050687790e+01 -5.3500000387430191e+01 1.5914399176836014e+01) (float-vector -3.4228101372718811e+01 -5.3500000387430191e+01 3.4460201859474182e+01) (float-vector -1.9124299287796021e+02 4.0371101349592209e+01 3.2088201493024826e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5732497274875641e+01 -8.6182102560997009e+01 4.4512800872325897e+01) (float-vector -1.0116899758577347e+02 -8.6999997496604919e+01 3.3876698464155197e+01) (float-vector -1.6702400147914886e+02 -7.2414301335811615e+01 2.5176199153065681e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5732497274875641e+01 -8.6182102560997009e+01 4.4512800872325897e+01) (float-vector -6.6737398505210876e+01 -8.6182102560997009e+01 4.6079099178314209e+01) (float-vector -4.2472898960113525e+01 -8.6182102560997009e+01 3.5424001514911652e+01) (float-vector -2.8616800904273987e+01 -8.5267797112464905e+01 1.7102800309658051e+01) (float-vector -2.6100900024175644e+01 -8.6182102560997009e+01 1.9003100460395217e+00) (float-vector -2.7365200221538544e+01 -8.5267797112464905e+01 -1.3457000255584717e+01) (float-vector -4.5147798955440521e+01 -8.5267797112464905e+01 -3.8341898471117020e+01) (float-vector -5.9267498552799225e+01 -8.6182102560997009e+01 -4.4512800872325897e+01) (float-vector -8.5768401622772217e+01 -8.6182102560997009e+01 -4.4502101838588715e+01) (float-vector -1.1503999680280685e+02 -8.6999997496604919e+01 -1.2645799666643143e+01) (float-vector -1.0116899758577347e+02 -8.6999997496604919e+01 3.3876698464155197e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 -2.0888099446892738e+01 4.7620199620723724e+01) (float-vector -7.9320900142192841e+01 -7.4500001966953278e+01 5.1550701260566711e+01) (float-vector -6.6737398505210876e+01 -8.6182102560997009e+01 4.6079099178314209e+01) (float-vector -8.5732497274875641e+01 -8.6182102560997009e+01 4.4512800872325897e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -8.5732497274875641e+01 -8.6182102560997009e+01 4.4512800872325897e+01) (float-vector -1.6702400147914886e+02 -7.2414301335811615e+01 2.5176199153065681e+01) (float-vector -2.2900000214576721e+02 -4.1035298258066177e+01 3.1938999891281128e+01) (float-vector -2.2900000214576721e+02 -2.0888099446892738e+01 4.7620199620723724e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.2472898960113525e+01 -8.6182102560997009e+01 3.5424001514911652e+01) (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 4.5462999492883682e+01) (float-vector -3.4401901066303253e+01 -7.8048199415206909e+01 3.2799400389194489e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.4401901066303253e+01 -7.8048199415206909e+01 3.2799400389194489e+01) (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 4.5462999492883682e+01) (float-vector -3.4228101372718811e+01 -5.3500000387430191e+01 3.4460201859474182e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -7.9320900142192841e+01 -7.4500001966953278e+01 5.1550701260566711e+01) (float-vector -6.1741199344396591e+01 -7.4500001966953278e+01 5.0586901605129242e+01) (float-vector -6.6737398505210876e+01 -8.6182102560997009e+01 4.6079099178314209e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.2900000214576721e+02 1.2765199877321720e+01 5.0408799201250076e+01) (float-vector -1.9124299287796021e+02 2.2500600665807724e+01 4.6402599662542343e+01) (float-vector -6.1688598245382309e+01 -5.4000001400709152e+01 5.0863601267337799e+01) (float-vector -6.1741199344396591e+01 -7.4500001966953278e+01 5.0586901605129242e+01) (float-vector -7.9320900142192841e+01 -7.4500001966953278e+01 5.1550701260566711e+01) (float-vector -2.2900000214576721e+02 -4.2941002175211906e+00 5.1822401583194733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -6.1741199344396591e+01 -7.4500001966953278e+01 5.0586901605129242e+01) (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 4.5462999492883682e+01) (float-vector -4.2472898960113525e+01 -8.6182102560997009e+01 3.5424001514911652e+01) (float-vector -6.6737398505210876e+01 -8.6182102560997009e+01 4.6079099178314209e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -4.7258801758289337e+01 -7.4500001966953278e+01 4.5462999492883682e+01) (float-vector -6.1741199344396591e+01 -7.4500001966953278e+01 5.0586901605129242e+01) (float-vector -6.1688598245382309e+01 -5.4000001400709152e+01 5.0863601267337799e+01) (float-vector -3.4228101372718811e+01 -5.3500000387430191e+01 3.4460201859474182e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_forearm_roll_link_q5DiHT.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_l_gripper_finger_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 -1.5424999999999999e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.178000 0.180500 0.188000 1.000000))
                    (list :diffuse (float-vector 0.356000 0.361000 0.376000 1.000000))))
                   (list :indices #i( 0 1 2 50 51 0 0 63 50 0 79 1 51 79 0 2 39 0 39 63 0 51 50 52 50 91 52 63 91 50 80 51 52 79 51 94 80 94 51 79 94 1 1 94 23 49 23 94 94 78 49 78 94 14 80 14 94 12 80 52 14 80 12 12 13 14 14 13 78 49 78 19 19 78 28 28 78 13 18 23 49 18 49 19 18 19 20 20 19 21 19 28 21 55 21 28 55 28 56 13 26 28 56 28 26 21 55 20 20 55 53 20 53 36 18 20 36 18 22 23 36 22 18 1 22 2 22 1 23 22 36 2 61 39 2 61 2 36 39 61 62 36 62 61 37 38 39 37 39 89 62 102 39 89 39 102 38 63 39 62 36 35 59 62 35 102 62 59 89 102 59 75 89 59 37 89 74 74 89 75 35 58 59 59 76 75 59 92 76 58 92 59 35 36 34 58 35 34 33 58 34 58 33 92 92 33 103 92 107 76 103 107 92 75 76 68 76 107 68 68 74 75 68 69 70 69 68 71 68 70 74 68 77 71 77 68 93 93 68 107 107 115 93 115 107 103 93 114 77 114 93 115 77 112 71 77 114 112 71 111 46 69 71 46 111 71 112 110 111 112 112 114 110 114 115 110 113 110 115 90 67 115 113 115 67 103 90 115 110 113 108 113 67 65 108 113 65 66 67 6 65 67 66 67 90 6 90 11 6 90 103 11 60 103 33 60 11 103 6 11 7 11 60 7 6 7 8 8 66 6 65 66 10 10 66 8 9 10 8 8 7 36 8 36 9 7 32 36 7 60 32 60 33 32 32 33 34 34 36 32 3 5 36 41 36 30 30 36 5 3 36 53 41 9 36 3 4 5 5 29 30 4 57 5 29 5 57 30 29 31 30 43 41 31 43 30 41 42 9 43 42 41 43 44 42 42 64 9 42 44 64 10 9 64 64 65 10 65 64 44 81 65 44 43 81 44 81 108 65 43 95 81 95 105 81 105 108 81 108 105 110 104 105 97 95 97 105 106 105 104 105 106 110 95 96 97 96 95 43 96 87 97 87 104 97 87 100 104 104 100 106 85 84 87 87 99 100 84 99 87 87 96 85 96 43 31 85 96 31 84 85 31 86 84 31 99 84 86 15 99 24 24 99 86 82 99 15 99 82 100 82 106 100 27 82 15 27 106 82 106 109 110 109 106 27 17 27 15 17 109 27 109 111 110 111 109 17 15 16 17 16 48 17 17 48 46 46 111 17 16 15 47 48 16 73 47 73 16 48 12 46 48 73 12 12 45 46 45 69 46 12 52 72 12 72 45 12 73 13 13 73 26 26 73 47 26 47 15 15 25 26 26 98 56 25 98 26 15 24 25 25 24 101 98 25 101 98 83 54 98 54 56 98 101 83 56 54 55 53 54 3 55 54 53 54 83 3 83 4 3 83 101 4 57 4 101 57 88 29 101 88 57 29 88 31 86 31 88 88 101 86 86 101 24 45 72 69 72 52 91 69 72 70 72 91 70 40 70 91 91 63 38 40 91 38 40 74 70 38 37 40 37 74 40))
                   (list :vertices (let ((mat (make-matrix 116 3))) (fvector-replace (array-entity mat) #f(2.9000000000000000e+01 1.6850000381469727e+01 1.1149999618530273e+01 2.9000000000000000e+01 1.7002201080322266e+01 1.1915399551391602e+01 -2.9000000000000000e+01 1.6850000381469727e+01 1.1149999618530273e+01 -2.9000000000000000e+01 3.0149999618530273e+01 1.2882100105285645e+01 2.9000000000000000e+01 3.0564199447631836e+01 1.2564200401306152e+01 -2.9000000000000000e+01 3.0881999969482422e+01 1.2149999618530273e+01 2.9000000000000000e+01 2.9915399551391602e+01 -1.2997799873352051e+01 -2.9000000000000000e+01 2.9149999618530273e+01 -1.3149999618530273e+01 -2.9000000000000000e+01 3.0149999618530273e+01 -1.2882100105285645e+01 -2.9000000000000000e+01 3.0881999969482422e+01 -1.2149999618530273e+01 2.9000000000000000e+01 3.0564199447631836e+01 -1.2564200401306152e+01 2.9000000000000000e+01 2.9149999618530273e+01 -1.3149999618530273e+01 3.0707099914550781e+01 1.8084600448608398e+01 1.1857099533081055e+01 3.0414199829101562e+01 1.8850000381469727e+01 1.2564200401306152e+01 3.0306600570678711e+01 1.8084600448608398e+01 1.2456599235534668e+01 3.0707099914550781e+01 2.9915399551391602e+01 1.1857099533081055e+01 3.0847801208496094e+01 2.9149999618530273e+01 1.1915399551391602e+01 3.1000000000000000e+01 2.9149999618530273e+01 1.1149999618530273e+01 -2.9000000000000000e+01 1.7850000381469727e+01 1.2882100105285645e+01 2.9000000000000000e+01 1.8084600448608398e+01 1.2997799873352051e+01 -2.9000000000000000e+01 1.8850000381469727e+01 1.3149999618530273e+01 2.9000000000000000e+01 1.8850000381469727e+01 1.3149999618530273e+01 -2.9000000000000000e+01 1.7118000030517578e+01 1.2149999618530273e+01 2.9000000000000000e+01 1.7435800552368164e+01 1.2564200401306152e+01 3.0000000000000000e+01 3.0564199447631836e+01 1.2149999618530273e+01 3.0306600570678711e+01 2.9915399551391602e+01 1.2456599235534668e+01 3.0414199829101562e+01 2.9149999618530273e+01 1.2564200401306152e+01 3.0847801208496094e+01 2.9915399551391602e+01 1.1149999618530273e+01 2.9765399932861328e+01 1.8850000381469727e+01 1.2997799873352051e+01 2.9000000000000000e+01 3.0997798919677734e+01 1.1915399551391602e+01 -2.9000000000000000e+01 3.1149999618530273e+01 1.1149999618530273e+01 2.9000000000000000e+01 3.1149999618530273e+01 1.1149999618530273e+01 -2.9000000000000000e+01 1.8850000381469727e+01 -1.3149999618530273e+01 2.9000000000000000e+01 1.8084600448608398e+01 -1.2997799873352051e+01 -2.9000000000000000e+01 1.7850000381469727e+01 -1.2882100105285645e+01 2.9000000000000000e+01 1.7435800552368164e+01 -1.2564200401306152e+01 -2.9000000000000000e+01 1.7118000030517578e+01 -1.2149999618530273e+01 2.9707099914550781e+01 1.7002201080322266e+01 -1.1442899703979492e+01 2.9765399932861328e+01 1.7002201080322266e+01 -1.1149999618530273e+01 2.9000000000000000e+01 1.6850000381469727e+01 -1.1149999618530273e+01 3.0414199829101562e+01 1.7435800552368164e+01 -1.1149999618530273e+01 -2.9000000000000000e+01 3.1149999618530273e+01 -1.1149999618530273e+01 2.9000000000000000e+01 3.0997798919677734e+01 -1.1915399551391602e+01 2.9000000000000000e+01 3.1149999618530273e+01 -1.1149999618530273e+01 2.9292900085449219e+01 3.0997798919677734e+01 -1.1857099533081055e+01 3.0847801208496094e+01 1.8084600448608398e+01 1.1149999618530273e+01 3.1000000000000000e+01 1.8850000381469727e+01 1.1149999618530273e+01 3.0703699111938477e+01 2.9149999618530273e+01 1.2130999565124512e+01 3.0847801208496094e+01 1.8850000381469727e+01 1.1915399551391602e+01 2.9000000000000000e+01 1.7868999481201172e+01 1.2853699684143066e+01 2.9707099914550781e+01 1.7002201080322266e+01 1.1442899703979492e+01 2.9541200637817383e+01 1.7002201080322266e+01 1.1691199302673340e+01 3.0306600570678711e+01 1.7435800552368164e+01 1.1691199302673340e+01 -2.9000000000000000e+01 2.9149999618530273e+01 1.3149999618530273e+01 2.9000000000000000e+01 2.9915399551391602e+01 1.2997799873352051e+01 2.9000000000000000e+01 2.9149999618530273e+01 1.3149999618530273e+01 2.9765399932861328e+01 2.9149999618530273e+01 1.2997799873352051e+01 2.9000000000000000e+01 3.0853700637817383e+01 1.2130999565124512e+01 2.9000000000000000e+01 1.7868999481201172e+01 -1.2853699684143066e+01 2.9541200637817383e+01 1.7435800552368164e+01 -1.2456599235534668e+01 2.9000000000000000e+01 1.8850000381469727e+01 -1.3149999618530273e+01 -2.9000000000000000e+01 1.6850000381469727e+01 -1.1149999618530273e+01 2.9000000000000000e+01 1.7002201080322266e+01 -1.1915399551391602e+01 2.9765399932861328e+01 1.7002201080322266e+01 1.1149999618530273e+01 2.9000000000000000e+01 3.0853700637817383e+01 -1.2130999565124512e+01 2.9541200637817383e+01 3.0564199447631836e+01 -1.2456599235534668e+01 2.9000000000000000e+01 3.0130998611450195e+01 -1.2853699684143066e+01 2.9707099914550781e+01 2.9915399551391602e+01 -1.2857099533081055e+01 3.0707099914550781e+01 1.8084600448608398e+01 -1.1857099533081055e+01 3.0847801208496094e+01 1.8084600448608398e+01 -1.1149999618530273e+01 3.0703699111938477e+01 1.7868999481201172e+01 -1.1149999618530273e+01 3.1000000000000000e+01 1.8850000381469727e+01 -1.1149999618530273e+01 3.0703699111938477e+01 1.7868999481201172e+01 1.1149999618530273e+01 3.0703699111938477e+01 1.8850000381469727e+01 1.2130999565124512e+01 3.0306600570678711e+01 1.7435800552368164e+01 -1.1691199302673340e+01 3.0000000000000000e+01 1.7435800552368164e+01 -1.2149999618530273e+01 3.0306600570678711e+01 1.8084600448608398e+01 -1.2456599235534668e+01 3.0847801208496094e+01 1.8850000381469727e+01 -1.1915399551391602e+01 2.9707099914550781e+01 1.8084600448608398e+01 1.2857099533081055e+01 2.9292900085449219e+01 1.7002201080322266e+01 1.1857099533081055e+01 3.0000000000000000e+01 1.7435800552368164e+01 1.2149999618530273e+01 2.9541200637817383e+01 3.0997798919677734e+01 -1.1691199302673340e+01 3.0703699111938477e+01 3.0130998611450195e+01 1.1149999618530273e+01 2.9000000000000000e+01 3.0130998611450195e+01 1.2853699684143066e+01 2.9707099914550781e+01 3.0997798919677734e+01 1.1442899703979492e+01 2.9765399932861328e+01 3.0997798919677734e+01 1.1149999618530273e+01 2.9541200637817383e+01 3.0997798919677734e+01 1.1691199302673340e+01 2.9981000900268555e+01 3.0853700637817383e+01 1.1149999618530273e+01 2.9292900085449219e+01 3.0997798919677734e+01 1.1857099533081055e+01 2.9541200637817383e+01 1.7002201080322266e+01 -1.1691199302673340e+01 2.9765399932861328e+01 2.9149999618530273e+01 -1.2997799873352051e+01 3.0414199829101562e+01 1.7435800552368164e+01 1.1149999618530273e+01 2.9707099914550781e+01 1.8084600448608398e+01 -1.2857099533081055e+01 3.0703699111938477e+01 1.8850000381469727e+01 -1.2130999565124512e+01 2.9541200637817383e+01 1.7435800552368164e+01 1.2456599235534668e+01 2.9707099914550781e+01 3.0997798919677734e+01 -1.1442899703979492e+01 2.9765399932861328e+01 3.0997798919677734e+01 -1.1149999618530273e+01 2.9981000900268555e+01 3.0853700637817383e+01 -1.1149999618530273e+01 2.9707099914550781e+01 2.9915399551391602e+01 1.2857099533081055e+01 3.0306600570678711e+01 3.0564199447631836e+01 1.1691199302673340e+01 3.0414199829101562e+01 3.0564199447631836e+01 1.1149999618530273e+01 2.9541200637817383e+01 3.0564199447631836e+01 1.2456599235534668e+01 2.9292900085449219e+01 1.7002201080322266e+01 -1.1857099533081055e+01 2.9765399932861328e+01 1.8850000381469727e+01 -1.2997799873352051e+01 3.0414199829101562e+01 3.0564199447631836e+01 -1.1149999618530273e+01 3.0306600570678711e+01 3.0564199447631836e+01 -1.1691199302673340e+01 3.0703699111938477e+01 3.0130998611450195e+01 -1.1149999618530273e+01 3.0414199829101562e+01 1.8850000381469727e+01 -1.2564200401306152e+01 3.0000000000000000e+01 3.0564199447631836e+01 -1.2149999618530273e+01 3.0847801208496094e+01 2.9915399551391602e+01 -1.1149999618530273e+01 3.0707099914550781e+01 2.9915399551391602e+01 -1.1857099533081055e+01 3.1000000000000000e+01 2.9149999618530273e+01 -1.1149999618530273e+01 3.0847801208496094e+01 2.9149999618530273e+01 -1.1915399551391602e+01 3.0306600570678711e+01 2.9915399551391602e+01 -1.2456599235534668e+01 3.0703699111938477e+01 2.9149999618530273e+01 -1.2130999565124512e+01 3.0414199829101562e+01 2.9149999618530273e+01 -1.2564200401306152e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 684 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8999999165534973e+01 1.6850000247359276e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 1.7117999494075775e+01 -1.2149999849498272e+01) (float-vector -2.8999999165534973e+01 3.1150000169873238e+01 -1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 3.0882000923156738e+01 1.2149999849498272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8999999165534973e+01 1.6850000247359276e+01 1.1149999685585499e+01) (float-vector 3.0999999493360519e+01 1.8850000575184822e+01 -1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 1.7117999494075775e+01 -1.2149999849498272e+01) (float-vector -2.8999999165534973e+01 1.6850000247359276e+01 1.1149999685585499e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9765399172902107e+01 3.0997799709439278e+01 1.1149999685585499e+01) (float-vector 2.8999999165534973e+01 1.6850000247359276e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 1.6850000247359276e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 3.0882000923156738e+01 1.2149999849498272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9292900115251541e+01 3.0997799709439278e+01 -1.1857099831104279e+01) (float-vector 2.9765399172902107e+01 3.0997799709439278e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 3.0882000923156738e+01 1.2149999849498272e+01) (float-vector -2.8999999165534973e+01 3.1150000169873238e+01 -1.1149999685585499e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0999999493360519e+01 1.8850000575184822e+01 -1.1149999685585499e+01) (float-vector 2.9292900115251541e+01 3.0997799709439278e+01 -1.1857099831104279e+01) (float-vector -2.8999999165534973e+01 3.1150000169873238e+01 -1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 1.7117999494075775e+01 -1.2149999849498272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9765399172902107e+01 3.0997799709439278e+01 1.1149999685585499e+01) (float-vector 2.9292900115251541e+01 3.0997799709439278e+01 -1.1857099831104279e+01) (float-vector 3.0999999493360519e+01 1.8850000575184822e+01 -1.1149999685585499e+01) (float-vector 2.8999999165534973e+01 1.6850000247359276e+01 1.1149999685585499e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_l_gripper_finger_link_HIat39.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_r_gripper_finger_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 0.0000000000000000e+00 1.5424999999999999e+01 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.178000 0.180500 0.188000 1.000000))
                    (list :diffuse (float-vector 0.356000 0.361000 0.376000 1.000000))))
                   (list :indices #i( 0 1 2 51 52 0 0 80 1 52 80 0 0 89 51 2 39 0 39 89 0 51 53 52 51 67 53 67 51 89 52 97 80 52 53 105 105 97 52 80 50 1 80 97 50 22 50 23 1 50 22 50 97 23 1 22 2 18 22 23 36 22 18 22 36 2 18 23 49 49 23 97 18 19 20 18 49 19 18 20 36 49 79 19 97 79 49 20 19 21 19 28 21 19 79 28 20 56 54 21 56 20 20 54 36 56 21 28 28 79 13 56 28 57 13 26 28 57 28 26 56 55 54 57 55 56 54 55 3 3 36 54 55 83 3 84 55 57 84 83 55 26 84 57 58 84 25 83 84 58 25 84 26 83 4 3 83 58 4 3 4 5 3 5 36 4 29 5 29 4 58 5 29 30 30 36 5 30 29 31 58 101 29 29 101 31 30 42 41 31 42 30 41 36 30 41 40 9 42 40 41 41 9 36 40 10 9 42 43 40 44 40 43 40 44 10 9 10 8 8 36 9 44 68 10 10 68 8 6 7 8 8 68 6 8 7 36 68 69 6 69 68 44 6 11 7 93 11 6 69 93 6 7 32 36 7 64 32 11 64 7 64 11 104 93 104 11 93 69 115 104 93 115 112 69 44 112 115 69 106 112 103 103 112 44 112 106 115 43 81 44 81 103 44 106 103 111 103 81 111 42 81 43 42 99 81 99 111 81 107 111 100 106 111 107 111 99 100 98 99 42 100 99 98 42 31 98 59 98 31 98 59 100 61 100 59 107 100 61 59 60 61 31 60 59 60 31 86 86 31 101 60 85 61 60 86 85 85 82 61 82 107 61 15 85 24 82 85 15 85 86 24 86 58 24 86 101 58 15 24 25 25 24 58 15 25 26 26 47 15 13 75 26 26 75 47 16 15 47 47 75 16 12 75 13 48 75 12 48 16 75 12 13 14 14 13 79 79 97 14 97 105 14 14 105 12 12 105 53 53 74 12 74 53 94 67 94 53 12 74 45 45 74 71 71 74 72 74 94 72 92 72 94 90 94 67 94 90 92 89 90 67 37 90 38 90 91 92 90 37 91 90 89 38 92 91 72 70 71 72 70 72 91 77 70 91 88 91 37 88 77 91 37 38 39 37 39 88 38 89 39 39 65 66 66 102 39 88 39 102 65 39 2 77 88 63 88 102 63 76 77 63 77 76 70 35 62 63 35 63 87 76 63 95 62 95 63 87 63 102 87 102 66 36 35 87 36 87 66 36 66 65 35 36 34 65 2 36 34 36 32 34 62 35 33 62 34 62 33 95 95 33 104 95 110 76 104 110 95 32 33 34 64 33 32 64 104 33 115 110 104 76 110 70 96 70 110 110 115 96 114 115 106 114 96 115 78 70 96 96 114 78 70 73 71 70 78 73 78 113 73 78 114 113 113 114 106 106 107 108 108 109 106 106 109 113 109 73 113 73 109 46 73 46 71 45 71 46 12 45 46 48 12 46 17 48 46 109 17 46 109 108 17 27 17 108 108 107 27 82 27 107 15 17 27 27 82 15 15 16 17 16 48 17))
                   (list :vertices (let ((mat (make-matrix 116 3))) (fvector-replace (array-entity mat) #f(2.9000000000000000e+01 -3.1149999618530273e+01 1.1149999618530273e+01 2.9000000000000000e+01 -3.0997798919677734e+01 1.1915399551391602e+01 -2.9000000000000000e+01 -3.1149999618530273e+01 1.1149999618530273e+01 -2.9000000000000000e+01 -1.7850000381469727e+01 1.2882100105285645e+01 2.9000000000000000e+01 -1.7435800552368164e+01 1.2564200401306152e+01 -2.9000000000000000e+01 -1.7118000030517578e+01 1.2149999618530273e+01 2.9000000000000000e+01 -1.8084600448608398e+01 -1.2997799873352051e+01 -2.9000000000000000e+01 -1.8850000381469727e+01 -1.3149999618530273e+01 -2.9000000000000000e+01 -1.7850000381469727e+01 -1.2882100105285645e+01 -2.9000000000000000e+01 -1.7118000030517578e+01 -1.2149999618530273e+01 2.9000000000000000e+01 -1.7435800552368164e+01 -1.2564200401306152e+01 2.9000000000000000e+01 -1.8850000381469727e+01 -1.3149999618530273e+01 3.0707099914550781e+01 -2.9915399551391602e+01 1.1857099533081055e+01 3.0414199829101562e+01 -2.9149999618530273e+01 1.2564200401306152e+01 3.0306600570678711e+01 -2.9915399551391602e+01 1.2456599235534668e+01 3.0707099914550781e+01 -1.8084600448608398e+01 1.1857099533081055e+01 3.0847801208496094e+01 -1.8850000381469727e+01 1.1915399551391602e+01 3.1000000000000000e+01 -1.8850000381469727e+01 1.1149999618530273e+01 -2.9000000000000000e+01 -3.0149999618530273e+01 1.2882100105285645e+01 2.9000000000000000e+01 -2.9915399551391602e+01 1.2997799873352051e+01 -2.9000000000000000e+01 -2.9149999618530273e+01 1.3149999618530273e+01 2.9000000000000000e+01 -2.9149999618530273e+01 1.3149999618530273e+01 -2.9000000000000000e+01 -3.0881999969482422e+01 1.2149999618530273e+01 2.9000000000000000e+01 -3.0564199447631836e+01 1.2564200401306152e+01 3.0000000000000000e+01 -1.7435800552368164e+01 1.2149999618530273e+01 3.0306600570678711e+01 -1.8084600448608398e+01 1.2456599235534668e+01 3.0414199829101562e+01 -1.8850000381469727e+01 1.2564200401306152e+01 3.0847801208496094e+01 -1.8084600448608398e+01 1.1149999618530273e+01 2.9765399932861328e+01 -2.9149999618530273e+01 1.2997799873352051e+01 2.9000000000000000e+01 -1.7002201080322266e+01 1.1915399551391602e+01 -2.9000000000000000e+01 -1.6850000381469727e+01 1.1149999618530273e+01 2.9000000000000000e+01 -1.6850000381469727e+01 1.1149999618530273e+01 -2.9000000000000000e+01 -2.9149999618530273e+01 -1.3149999618530273e+01 2.9000000000000000e+01 -2.9915399551391602e+01 -1.2997799873352051e+01 -2.9000000000000000e+01 -3.0149999618530273e+01 -1.2882100105285645e+01 2.9000000000000000e+01 -3.0564199447631836e+01 -1.2564200401306152e+01 -2.9000000000000000e+01 -3.0881999969482422e+01 -1.2149999618530273e+01 2.9707099914550781e+01 -3.0997798919677734e+01 -1.1442899703979492e+01 2.9765399932861328e+01 -3.0997798919677734e+01 -1.1149999618530273e+01 2.9000000000000000e+01 -3.1149999618530273e+01 -1.1149999618530273e+01 2.9000000000000000e+01 -1.7002201080322266e+01 -1.1915399551391602e+01 -2.9000000000000000e+01 -1.6850000381469727e+01 -1.1149999618530273e+01 2.9000000000000000e+01 -1.6850000381469727e+01 -1.1149999618530273e+01 2.9292900085449219e+01 -1.7002201080322266e+01 -1.1857099533081055e+01 2.9541200637817383e+01 -1.7435800552368164e+01 -1.2456599235534668e+01 3.0847801208496094e+01 -2.9915399551391602e+01 1.1149999618530273e+01 3.1000000000000000e+01 -2.9149999618530273e+01 1.1149999618530273e+01 3.0703699111938477e+01 -1.8850000381469727e+01 1.2130999565124512e+01 3.0847801208496094e+01 -2.9149999618530273e+01 1.1915399551391602e+01 2.9000000000000000e+01 -3.0130998611450195e+01 1.2853699684143066e+01 2.9000000000000000e+01 -3.0853700637817383e+01 1.2130999565124512e+01 2.9707099914550781e+01 -3.0997798919677734e+01 1.1442899703979492e+01 2.9541200637817383e+01 -3.0997798919677734e+01 1.1691199302673340e+01 3.0306600570678711e+01 -3.0564199447631836e+01 1.1691199302673340e+01 -2.9000000000000000e+01 -1.8850000381469727e+01 1.3149999618530273e+01 2.9000000000000000e+01 -1.8084600448608398e+01 1.2997799873352051e+01 2.9000000000000000e+01 -1.8850000381469727e+01 1.3149999618530273e+01 2.9765399932861328e+01 -1.8850000381469727e+01 1.2997799873352051e+01 2.9541200637817383e+01 -1.7435800552368164e+01 1.2456599235534668e+01 2.9765399932861328e+01 -1.7002201080322266e+01 1.1149999618530273e+01 2.9707099914550781e+01 -1.7002201080322266e+01 1.1442899703979492e+01 3.0414199829101562e+01 -1.7435800552368164e+01 1.1149999618530273e+01 2.9000000000000000e+01 -3.0130998611450195e+01 -1.2853699684143066e+01 2.9541200637817383e+01 -3.0564199447631836e+01 -1.2456599235534668e+01 2.9000000000000000e+01 -2.9149999618530273e+01 -1.3149999618530273e+01 -2.9000000000000000e+01 -3.1149999618530273e+01 -1.1149999618530273e+01 2.9000000000000000e+01 -3.0997798919677734e+01 -1.1915399551391602e+01 2.9981000900268555e+01 -3.0853700637817383e+01 1.1149999618530273e+01 2.9000000000000000e+01 -1.7868999481201172e+01 -1.2853699684143066e+01 2.9707099914550781e+01 -1.8084600448608398e+01 -1.2857099533081055e+01 3.0707099914550781e+01 -2.9915399551391602e+01 -1.1857099533081055e+01 3.0847801208496094e+01 -2.9915399551391602e+01 -1.1149999618530273e+01 3.0703699111938477e+01 -3.0130998611450195e+01 -1.1149999618530273e+01 3.1000000000000000e+01 -2.9149999618530273e+01 -1.1149999618530273e+01 3.0703699111938477e+01 -3.0130998611450195e+01 1.1149999618530273e+01 3.0703699111938477e+01 -2.9149999618530273e+01 1.2130999565124512e+01 3.0306600570678711e+01 -2.9915399551391602e+01 -1.2456599235534668e+01 3.0000000000000000e+01 -3.0564199447631836e+01 -1.2149999618530273e+01 3.0847801208496094e+01 -2.9149999618530273e+01 -1.1915399551391602e+01 2.9707099914550781e+01 -2.9915399551391602e+01 1.2857099533081055e+01 2.9292900085449219e+01 -3.0997798919677734e+01 1.1857099533081055e+01 2.9541200637817383e+01 -1.7002201080322266e+01 -1.1691199302673340e+01 3.0703699111938477e+01 -1.7868999481201172e+01 1.1149999618530273e+01 2.9000000000000000e+01 -1.7868999481201172e+01 1.2853699684143066e+01 2.9707099914550781e+01 -1.8084600448608398e+01 1.2857099533081055e+01 3.0306600570678711e+01 -1.7435800552368164e+01 1.1691199302673340e+01 2.9541200637817383e+01 -1.7002201080322266e+01 1.1691199302673340e+01 2.9000000000000000e+01 -3.0853700637817383e+01 -1.2130999565124512e+01 2.9541200637817383e+01 -3.0997798919677734e+01 -1.1691199302673340e+01 2.9765399932861328e+01 -3.0997798919677734e+01 1.1149999618530273e+01 2.9981000900268555e+01 -3.0853700637817383e+01 -1.1149999618530273e+01 3.0306600570678711e+01 -3.0564199447631836e+01 -1.1691199302673340e+01 3.0414199829101562e+01 -3.0564199447631836e+01 -1.1149999618530273e+01 2.9765399932861328e+01 -1.8850000381469727e+01 -1.2997799873352051e+01 3.0414199829101562e+01 -3.0564199447631836e+01 1.1149999618530273e+01 2.9707099914550781e+01 -2.9915399551391602e+01 -1.2857099533081055e+01 3.0703699111938477e+01 -2.9149999618530273e+01 -1.2130999565124512e+01 2.9541200637817383e+01 -3.0564199447631836e+01 1.2456599235534668e+01 2.9765399932861328e+01 -1.7002201080322266e+01 -1.1149999618530273e+01 2.9707099914550781e+01 -1.7002201080322266e+01 -1.1442899703979492e+01 3.0414199829101562e+01 -1.7435800552368164e+01 -1.1149999618530273e+01 2.9292900085449219e+01 -1.7002201080322266e+01 1.1857099533081055e+01 2.9292900085449219e+01 -3.0997798919677734e+01 -1.1857099533081055e+01 3.0000000000000000e+01 -1.7435800552368164e+01 -1.2149999618530273e+01 2.9765399932861328e+01 -2.9149999618530273e+01 -1.2997799873352051e+01 3.0000000000000000e+01 -3.0564199447631836e+01 1.2149999618530273e+01 3.0707099914550781e+01 -1.8084600448608398e+01 -1.1857099533081055e+01 3.0703699111938477e+01 -1.7868999481201172e+01 -1.1149999618530273e+01 3.0847801208496094e+01 -1.8084600448608398e+01 -1.1149999618530273e+01 3.1000000000000000e+01 -1.8850000381469727e+01 -1.1149999618530273e+01 3.0414199829101562e+01 -2.9149999618530273e+01 -1.2564200401306152e+01 3.0306600570678711e+01 -1.7435800552368164e+01 -1.1691199302673340e+01 3.0306600570678711e+01 -1.8084600448608398e+01 -1.2456599235534668e+01 3.0847801208496094e+01 -1.8850000381469727e+01 -1.1915399551391602e+01 3.0703699111938477e+01 -1.8850000381469727e+01 -1.2130999565124512e+01 3.0414199829101562e+01 -1.8850000381469727e+01 -1.2564200401306152e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 684 -> 6 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8999999165534973e+01 -3.0882000923156738e+01 -1.2149999849498272e+01) (float-vector -2.8999999165534973e+01 -3.1150000169873238e+01 1.1149999685585499e+01) (float-vector 2.9765399172902107e+01 -2.9149999842047691e+01 1.2997799552977085e+01) (float-vector 3.0999999493360519e+01 -2.9149999842047691e+01 -1.1149999685585499e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.8999999165534973e+01 -3.1150000169873238e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 -3.0882000923156738e+01 -1.2149999849498272e+01) (float-vector -2.8999999165534973e+01 -1.8850000575184822e+01 -1.3150000013411045e+01) (float-vector -2.8999999165534973e+01 -1.6850000247359276e+01 1.1149999685585499e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 3.0999999493360519e+01 -2.9149999842047691e+01 -1.1149999685585499e+01) (float-vector 2.8999999165534973e+01 -1.6850000247359276e+01 -1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 -1.8850000575184822e+01 -1.3150000013411045e+01) (float-vector -2.8999999165534973e+01 -3.0882000923156738e+01 -1.2149999849498272e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.8999999165534973e+01 -1.6850000247359276e+01 -1.1149999685585499e+01) (float-vector 2.9292900115251541e+01 -1.7002200707793236e+01 1.1857099831104279e+01) (float-vector -2.8999999165534973e+01 -1.6850000247359276e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 -1.8850000575184822e+01 -1.3150000013411045e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9292900115251541e+01 -1.7002200707793236e+01 1.1857099831104279e+01) (float-vector 2.9765399172902107e+01 -2.9149999842047691e+01 1.2997799552977085e+01) (float-vector -2.8999999165534973e+01 -3.1150000169873238e+01 1.1149999685585499e+01) (float-vector -2.8999999165534973e+01 -1.6850000247359276e+01 1.1149999685585499e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector 2.9292900115251541e+01 -1.7002200707793236e+01 1.1857099831104279e+01) (float-vector 2.8999999165534973e+01 -1.6850000247359276e+01 -1.1149999685585499e+01) (float-vector 3.0999999493360519e+01 -2.9149999842047691e+01 -1.1149999685585499e+01) (float-vector 2.9765399172902107e+01 -2.9149999842047691e+01 1.2997799552977085e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_r_gripper_finger_link_ICo2PH.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_wrist_flex_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.2450000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.043000 0.253000 0.383500 1.000000))
                    (list :diffuse (float-vector 0.086000 0.506000 0.767000 1.000000))))
                   (list :indices #i( 0 1 2 0 2 78 1 0 420 420 0 78 2 1 59 59 1 60 420 60 1 59 60 61 2 59 471 471 59 61 61 60 62 417 62 60 417 60 420 61 62 63 471 61 481 61 63 481 469 470 471 471 481 469 470 2 471 469 481 480 481 63 65 481 65 480 63 62 64 63 64 65 64 62 417 65 64 66 416 66 64 416 64 417 65 66 67 65 67 480 67 66 68 414 68 66 414 66 416 415 414 416 415 416 419 419 416 417 413 70 414 70 68 414 411 413 414 411 414 415 67 68 69 69 68 70 480 67 69 69 70 71 480 69 479 69 71 479 71 70 72 413 72 70 71 72 51 479 71 51 477 478 479 479 478 480 479 51 477 469 480 482 482 480 478 477 55 478 55 111 478 478 111 113 478 113 482 51 53 477 477 53 55 53 54 55 54 109 55 55 109 110 55 110 111 111 110 112 111 112 113 113 112 114 113 114 115 113 115 482 606 114 112 606 112 608 112 110 608 608 110 109 607 606 608 607 608 609 609 608 610 608 109 610 605 606 607 609 269 607 607 269 267 607 267 605 609 610 611 611 270 609 609 270 269 268 267 269 268 269 270 270 271 268 611 271 270 611 610 612 611 612 613 613 271 611 268 271 272 613 272 271 613 612 614 613 614 615 615 272 613 268 272 273 615 273 272 615 614 616 615 616 617 617 273 615 273 283 268 617 283 273 617 616 618 617 618 619 619 283 617 268 283 284 619 284 283 619 618 620 619 620 564 564 284 619 268 284 285 564 285 284 551 268 285 551 285 564 266 267 268 547 266 268 547 268 551 266 274 267 549 274 266 549 266 547 267 274 275 548 275 274 548 274 549 548 549 550 547 557 549 549 557 558 549 558 550 550 567 548 548 567 568 548 568 569 569 275 548 267 275 276 569 276 275 569 568 570 569 570 571 571 276 569 276 292 267 571 292 276 571 570 572 571 572 573 573 292 571 267 292 277 573 277 292 267 277 293 605 267 293 293 277 282 605 293 603 603 293 282 603 604 605 605 604 606 601 602 603 603 602 604 603 282 601 277 281 282 601 282 281 599 600 601 601 600 602 601 281 599 600 124 602 124 122 602 602 122 120 602 120 604 599 598 600 598 129 600 129 127 600 600 127 124 128 127 129 128 129 130 130 129 131 598 131 129 126 124 127 126 127 128 472 126 128 472 128 473 130 473 128 130 131 132 132 473 130 132 131 133 133 131 598 132 133 134 134 474 132 132 474 473 468 472 473 468 473 474 476 468 474 134 136 474 474 136 168 474 168 476 134 133 135 134 135 136 596 135 133 596 133 598 170 136 135 170 135 596 169 168 136 169 136 170 167 166 168 167 168 169 168 166 476 167 169 594 594 169 170 594 170 596 593 592 594 593 594 595 595 594 596 167 594 592 165 166 167 592 165 167 165 164 166 476 166 164 163 164 165 592 163 165 591 590 592 591 592 593 590 163 592 161 162 163 163 162 164 590 161 163 476 164 444 164 162 444 444 468 476 442 443 444 443 445 444 444 445 446 444 446 447 444 448 449 449 450 444 444 450 451 444 451 452 452 453 444 444 453 454 444 454 442 455 456 444 444 456 457 444 457 448 455 444 458 458 444 459 447 475 444 444 475 468 444 162 160 444 160 459 446 409 447 447 409 77 447 77 475 468 475 77 76 75 77 408 77 402 402 77 409 408 76 77 77 75 468 402 409 403 446 403 409 445 404 446 446 404 403 402 403 404 404 405 402 445 405 404 443 405 445 402 405 406 443 406 405 442 406 443 402 406 399 399 406 407 442 407 406 454 407 442 399 407 397 454 397 407 398 454 453 398 397 454 397 398 399 399 398 400 398 453 400 400 453 452 399 400 393 393 400 401 400 452 401 401 452 451 393 401 391 401 451 391 391 451 450 391 392 393 391 450 392 392 450 394 394 450 449 393 392 394 393 394 395 395 394 396 394 449 396 396 449 448 395 396 90 396 448 90 457 88 448 448 88 90 88 89 90 90 89 395 86 87 88 88 87 89 457 86 88 456 86 457 84 85 86 86 85 87 456 84 86 395 89 87 395 87 430 430 87 85 84 83 85 430 85 431 85 83 431 81 83 84 81 84 456 455 94 456 456 94 81 81 82 83 82 81 93 93 81 94 431 83 82 431 82 433 82 93 433 91 92 93 93 94 91 433 93 92 455 91 94 458 98 455 98 91 455 92 91 97 97 91 98 433 92 436 436 92 97 95 96 97 97 98 95 436 97 437 437 97 96 458 95 98 96 95 99 99 95 103 103 95 458 96 99 437 99 100 101 99 103 100 437 99 101 466 100 103 466 103 458 101 100 102 102 100 106 106 100 107 107 100 466 437 101 440 440 101 102 440 102 390 390 102 106 104 105 106 106 107 104 390 106 105 465 104 107 465 107 466 458 465 466 458 464 465 464 6 465 6 104 465 6 8 104 104 8 105 105 8 390 6 7 8 139 138 8 139 8 140 140 8 7 207 8 138 8 208 209 8 207 208 306 305 8 306 8 307 8 209 307 8 305 441 441 390 8 209 208 210 307 209 210 210 208 213 307 210 359 359 210 213 213 208 214 213 214 215 359 213 215 215 214 216 208 211 214 214 211 212 214 212 216 215 216 217 217 359 215 216 224 217 224 358 217 217 358 359 216 223 224 223 358 224 223 357 358 357 492 358 358 492 490 358 490 359 222 221 223 222 223 216 221 357 223 220 221 222 216 218 222 222 218 219 222 219 220 220 233 221 233 357 221 220 219 225 220 225 227 227 232 220 220 232 233 232 356 233 233 356 357 227 231 232 232 231 356 227 225 226 227 226 228 228 231 227 228 230 231 356 231 230 229 230 228 203 229 228 203 228 201 201 228 226 356 230 355 355 230 229 234 229 203 355 229 234 355 234 354 354 498 355 355 498 496 355 496 356 203 235 234 354 234 235 203 192 235 354 235 192 354 192 353 353 500 354 354 500 498 352 353 186 353 192 193 353 193 186 352 502 353 353 502 500 499 498 500 499 500 501 501 500 502 501 502 503 503 502 504 352 504 502 503 370 501 501 370 369 501 369 499 497 498 499 499 369 378 499 378 497 362 369 370 362 378 369 370 379 362 503 379 370 362 379 380 505 380 379 505 379 503 362 380 381 507 381 380 507 380 505 503 504 505 505 504 506 505 506 507 507 506 508 507 508 509 509 381 507 381 388 362 509 388 381 509 508 510 509 510 511 511 388 509 348 510 508 348 508 350 350 508 506 350 506 351 351 506 504 351 504 352 350 351 238 352 236 351 351 236 237 351 237 238 238 240 350 350 240 242 350 242 348 237 175 238 238 175 240 236 175 237 187 176 236 236 176 175 352 187 236 186 187 352 184 185 186 186 185 187 193 195 186 186 195 196 186 196 184 555 185 184 555 184 560 560 184 196 187 185 188 554 188 185 554 185 555 554 555 547 555 560 547 547 560 561 560 196 561 561 196 195 193 194 195 561 195 194 547 561 545 545 561 194 191 194 193 545 194 546 546 194 191 545 546 547 546 556 547 556 546 199 199 546 190 546 191 190 190 191 192 192 191 193 199 190 197 197 190 192 197 198 199 199 198 556 203 205 197 197 205 206 197 206 198 197 192 203 556 198 206 556 206 557 557 206 205 203 204 205 557 205 558 558 205 204 201 202 203 202 204 203 558 204 202 202 550 558 201 200 202 200 550 202 28 200 201 201 226 28 28 567 200 200 567 550 26 27 28 28 226 26 567 28 27 225 24 226 226 24 26 24 25 26 26 25 27 567 27 568 568 27 25 24 5 25 568 25 5 3 5 24 225 3 24 219 10 225 225 10 4 4 3 225 3 4 5 5 4 9 5 570 568 5 9 570 9 4 10 9 10 11 11 10 12 219 12 10 218 14 219 14 12 219 11 12 13 13 12 14 570 9 11 570 11 572 572 11 13 13 14 15 572 13 15 15 14 16 218 16 14 212 16 218 216 212 218 15 16 17 17 16 18 212 18 16 15 574 572 15 17 574 573 572 574 573 574 575 575 574 576 574 17 19 574 19 576 17 18 19 19 18 20 20 18 212 211 20 212 19 20 21 21 20 22 211 22 20 576 19 21 21 22 23 576 21 23 22 137 23 207 137 22 207 22 211 208 207 211 138 137 207 23 137 138 23 138 139 23 578 576 23 139 578 578 139 140 577 576 578 577 578 579 579 578 580 578 140 580 575 576 577 579 264 577 577 264 263 577 263 575 579 580 581 581 286 579 579 286 264 263 264 265 264 286 265 263 265 277 575 263 277 575 277 573 277 265 278 277 278 279 279 280 277 277 280 281 595 279 278 595 278 593 593 278 265 597 280 279 597 279 595 599 281 280 599 280 597 595 596 597 597 596 598 597 598 599 265 286 287 265 287 288 288 289 265 265 289 290 265 290 291 593 265 591 591 265 291 581 287 286 583 288 287 583 287 581 585 289 288 585 288 583 587 290 289 587 289 585 589 291 290 589 290 587 591 291 589 589 590 591 587 588 589 589 588 590 585 586 587 587 586 588 583 584 585 585 584 586 581 582 583 583 582 584 581 580 582 143 582 580 143 145 582 582 145 147 582 147 584 151 586 584 584 147 149 584 149 151 145 146 147 147 146 148 147 148 149 143 144 145 145 144 146 462 148 146 462 146 463 146 144 463 149 148 150 150 148 462 149 150 151 151 150 152 461 152 150 461 150 462 458 461 462 458 462 463 463 464 458 463 144 142 463 142 464 143 142 144 141 7 142 141 142 143 142 7 464 464 7 6 140 7 141 580 140 141 580 141 143 458 459 460 460 461 458 459 160 158 459 158 460 158 156 460 460 156 154 460 154 461 157 156 158 157 158 159 159 158 160 159 160 161 161 160 162 159 590 588 588 157 159 159 161 590 155 156 157 588 155 157 155 154 156 153 154 155 586 153 155 586 155 588 151 152 153 153 152 154 151 153 586 154 152 461 547 556 557 551 553 547 547 553 559 547 559 554 551 552 553 564 565 551 551 565 566 551 566 552 183 553 552 183 552 177 177 552 178 178 552 566 178 566 179 179 566 180 180 566 565 177 178 175 175 178 179 175 176 177 176 183 177 176 182 183 182 553 183 181 182 176 187 181 176 553 182 181 553 181 559 189 181 187 181 189 559 187 188 189 559 189 188 559 188 554 175 179 180 240 175 241 174 241 175 174 175 172 172 175 180 240 241 242 242 241 243 239 243 241 239 241 174 242 243 244 348 242 244 244 243 246 246 243 247 245 247 243 245 243 239 348 244 246 348 246 349 349 510 348 246 247 248 349 246 248 248 247 249 251 249 247 251 247 245 248 249 250 248 250 349 249 257 250 349 250 257 255 256 249 249 256 257 252 255 249 252 249 251 245 38 251 251 38 43 251 43 252 37 38 39 38 37 43 245 39 38 41 42 43 43 37 44 43 44 41 252 43 42 42 41 45 42 45 252 45 41 46 614 46 41 614 41 616 41 44 616 616 44 37 616 37 618 37 40 618 618 40 33 618 33 620 39 33 40 39 40 37 33 34 35 35 36 33 34 33 39 620 33 36 564 620 621 620 36 621 35 30 36 621 36 30 32 30 35 32 35 239 239 35 34 239 34 245 34 39 245 174 32 239 31 30 32 174 31 32 29 30 31 621 30 29 564 621 562 621 29 562 174 173 29 29 31 174 562 29 173 172 173 174 172 180 173 180 565 173 562 173 563 563 173 565 562 563 564 564 563 565 612 47 614 47 46 614 610 57 612 57 56 612 612 56 47 109 108 610 610 108 57 48 56 57 48 57 58 58 57 54 57 108 54 47 56 48 48 49 47 171 49 48 171 48 58 58 54 171 54 258 171 171 258 253 171 253 259 259 49 171 47 49 50 259 50 49 259 253 255 259 255 252 252 50 259 47 50 45 252 45 50 45 46 47 253 254 255 255 254 256 253 262 254 346 347 254 254 262 346 347 256 254 347 257 256 349 257 347 346 514 347 347 514 512 347 512 349 349 512 510 511 510 512 511 512 513 513 512 514 513 514 515 515 514 516 346 516 514 515 360 513 513 360 389 513 389 511 511 389 388 362 388 389 362 389 360 360 361 362 515 361 360 515 516 517 517 361 515 361 371 362 517 371 361 517 516 518 517 518 519 519 371 517 362 371 372 519 372 371 519 518 520 519 520 521 521 372 519 342 520 518 342 518 345 345 518 516 521 520 522 339 522 520 339 520 342 521 522 523 523 373 521 521 373 372 362 372 373 373 374 362 523 374 373 523 522 524 523 524 525 525 374 523 335 524 522 335 522 339 525 524 526 330 526 524 330 524 335 525 526 527 527 375 525 525 375 374 362 374 375 362 375 376 527 376 375 527 526 528 527 528 529 529 376 527 327 528 526 327 526 330 529 528 530 325 530 528 325 528 327 529 530 531 531 382 529 529 382 376 376 382 362 362 382 383 531 383 382 531 530 532 531 532 533 533 383 531 323 532 530 323 530 325 533 532 534 296 534 532 296 532 323 533 534 535 535 384 533 533 384 383 362 383 384 384 385 362 535 385 384 535 534 536 535 536 537 537 385 535 318 536 534 318 534 296 537 536 538 299 538 536 299 536 318 537 538 539 539 386 537 537 386 385 362 385 386 362 386 387 539 387 386 539 538 540 539 540 541 541 387 539 314 540 538 314 538 299 541 540 542 309 542 540 309 540 314 541 542 543 543 362 541 541 362 387 543 542 544 308 544 542 308 542 309 308 309 310 314 316 309 309 316 317 309 317 310 310 311 308 308 311 312 308 312 302 302 544 308 317 434 310 310 434 435 310 435 311 316 432 317 317 432 434 314 315 316 316 315 432 299 298 314 298 315 314 432 315 298 297 298 299 432 298 427 427 298 297 318 320 299 299 320 321 299 321 297 427 297 321 427 321 428 428 430 427 427 430 431 427 431 432 428 321 320 318 319 320 428 320 429 429 320 319 429 395 428 428 395 430 429 319 426 426 393 429 429 393 395 295 319 318 426 319 295 294 295 296 296 295 318 426 295 294 294 296 322 322 426 294 322 296 323 322 323 324 324 425 322 322 425 426 324 323 325 324 325 326 326 425 324 326 424 425 424 402 425 425 402 399 425 399 426 325 329 326 329 424 326 327 328 325 325 328 329 328 422 329 329 422 424 422 408 424 424 408 402 332 421 422 332 422 328 421 423 422 422 423 408 327 332 328 330 331 327 327 331 332 331 421 332 331 418 421 418 420 421 421 420 423 420 78 423 423 78 74 423 74 408 408 74 76 74 75 76 78 79 74 74 79 80 74 80 75 78 2 79 80 79 470 470 79 2 468 75 80 468 80 470 469 468 470 467 468 469 467 472 468 482 117 469 117 119 469 469 119 121 469 121 467 121 123 467 467 123 125 467 125 472 125 126 472 123 124 125 125 124 126 121 122 123 123 122 124 119 120 121 121 120 122 117 118 119 119 118 120 120 118 604 117 116 118 604 118 116 604 116 606 115 114 116 115 116 117 116 114 606 482 115 117 418 417 420 419 417 418 337 336 418 418 336 334 418 334 419 337 418 331 419 334 333 419 333 415 333 334 335 335 334 336 335 336 330 330 336 337 330 337 331 333 335 338 338 335 339 415 333 338 415 340 411 415 338 340 338 339 340 340 339 341 341 339 342 411 340 341 411 343 412 411 341 343 412 413 411 341 342 343 343 342 344 344 342 345 412 343 344 412 344 54 54 410 412 412 410 413 410 72 413 410 54 52 52 73 410 410 73 72 51 72 73 51 73 52 51 52 53 53 52 54 54 108 109 54 260 258 344 345 54 345 260 54 258 260 261 345 261 260 258 261 253 253 261 262 346 262 261 346 261 345 345 516 346 426 399 393 432 431 433 432 433 434 434 433 436 434 436 435 435 436 437 311 435 312 312 435 438 435 437 438 438 437 440 312 438 313 313 438 439 438 440 439 302 312 313 302 313 300 313 439 300 300 301 302 302 301 303 303 483 302 302 483 544 439 301 300 301 304 303 439 304 301 303 304 305 303 305 306 306 484 303 303 484 483 483 484 485 485 544 483 543 544 485 485 484 486 485 486 487 487 364 485 485 364 363 485 363 543 306 486 484 307 486 306 487 486 488 307 488 486 487 488 489 489 365 487 487 365 364 363 364 362 362 364 365 543 363 362 365 366 362 362 366 367 362 367 368 368 377 362 362 377 378 489 366 365 491 367 366 491 366 489 493 368 367 493 367 491 495 377 368 495 368 493 497 378 377 497 377 495 493 494 495 495 494 496 495 496 497 491 492 493 493 492 494 489 490 491 491 490 492 357 494 492 356 496 494 356 494 357 497 496 498 489 488 490 359 490 488 359 488 307 441 305 304 441 304 439 439 390 441 439 440 390 622 623 624 627 626 622 627 622 628 628 622 624 622 626 677 622 677 623 625 626 627 628 1078 627 627 1078 1079 627 1079 625 624 1077 628 628 1077 1078 1077 906 1078 906 904 1078 1078 904 914 1078 914 1079 1079 914 913 1079 913 1080 625 1079 1080 903 913 914 903 914 904 903 904 905 905 904 906 912 913 903 903 1160 912 905 1159 903 903 1159 1160 912 911 913 1080 913 911 910 911 912 912 1160 1161 912 1161 910 1159 1084 1160 1160 1084 1085 1160 1085 1161 1234 1083 1159 1159 1083 1084 905 1234 1159 1083 791 1084 1084 791 790 1084 790 1085 1085 790 773 1085 773 1086 1161 1085 1086 773 790 771 771 790 791 771 791 792 1083 792 791 1158 792 1083 1234 1158 1083 792 810 771 1158 810 792 1157 810 1158 1233 1157 1158 1233 1158 1234 771 810 811 1157 811 810 1156 811 1157 1232 1156 1157 1232 1157 1233 922 1232 1233 922 1233 907 907 1233 1234 1231 1156 1232 915 1231 1232 915 1232 922 907 921 922 922 921 923 922 923 915 915 916 917 915 923 924 915 924 916 917 1231 915 1075 924 923 1075 923 1076 923 921 1076 907 920 921 1076 921 920 1076 920 1077 634 1075 1076 634 1076 624 624 1076 1077 1074 924 1075 633 1074 1075 633 1075 634 1074 916 924 1073 918 1074 918 916 1074 632 1073 1074 632 1074 633 629 632 633 629 633 623 623 633 634 623 634 624 677 629 623 629 630 631 631 632 629 677 630 629 631 1073 632 630 640 631 640 1072 631 631 1072 1073 630 639 640 639 1071 640 640 1071 1072 1071 933 1072 933 931 1072 1072 931 930 1072 930 1073 1069 934 1071 1071 934 933 639 1069 1071 932 931 933 932 933 925 925 933 934 919 930 931 919 931 932 918 930 919 1073 930 918 917 918 919 932 1229 919 919 1229 1230 919 1230 917 925 1228 932 932 1228 1229 1228 1153 1229 1229 1153 1154 1229 1154 1230 1230 1154 1155 1230 1155 1231 917 1230 1231 917 916 918 1231 1155 1156 1154 814 1155 1155 814 812 1155 812 1156 1153 744 1154 1154 744 814 744 771 814 814 771 812 771 811 812 1156 812 811 771 772 773 771 785 772 744 813 771 1099 785 771 1099 771 1100 1100 771 813 1086 773 772 1086 772 1087 1161 1086 1162 1162 1086 1087 1087 772 809 1087 809 1088 1162 1087 1163 1163 1087 1088 910 1161 1162 910 1162 902 902 1162 1163 1163 1088 1164 902 1163 900 900 1163 1164 1088 809 808 1088 808 1089 1164 1088 1089 772 808 809 772 807 808 1089 808 807 1089 807 1090 1164 1089 1165 1165 1089 1090 900 1164 897 897 1164 1165 1165 1090 1166 897 1165 895 895 1165 1166 1090 807 806 1090 806 1091 1166 1090 1091 806 807 772 772 805 806 1091 806 805 1091 805 1092 1166 1091 1167 1167 1091 1092 895 1166 892 892 1166 1167 1167 1092 1168 892 1167 890 890 1167 1168 1092 805 804 1092 804 1093 1168 1092 1093 772 804 805 803 804 772 1093 804 803 1093 803 1094 1168 1093 1169 1169 1093 1094 890 1168 887 887 1168 1169 1169 1094 1170 887 1169 885 885 1169 1170 1094 803 802 1094 802 1095 1170 1094 1095 772 802 803 772 801 802 1095 802 801 1095 801 1096 1170 1095 1171 1171 1095 1096 885 1170 882 882 1170 1171 1171 1096 1172 882 1171 880 880 1171 1172 1096 801 787 1096 787 1097 1172 1096 1097 787 801 772 772 786 787 1097 787 786 1097 786 1098 1172 1097 1173 1173 1097 1098 880 1172 877 877 1172 1173 1173 1098 1174 877 1173 875 875 1173 1174 1098 786 785 1098 785 1099 1174 1098 1099 772 785 786 1174 1099 1175 1175 1099 1100 875 1174 872 872 1174 1175 872 874 875 875 874 876 875 876 877 870 871 872 871 873 872 872 873 874 872 1175 870 1175 1100 1176 870 1175 1176 1100 813 1101 1176 1100 1101 1176 1101 1177 870 1176 867 867 1176 1177 867 869 870 870 869 871 873 871 1017 1017 871 869 1016 874 873 1016 873 1017 1017 869 1018 717 1016 1017 717 1017 718 718 1017 1018 867 868 869 1018 869 868 1018 868 1019 718 1018 715 715 1018 1019 714 717 718 714 718 715 716 717 714 716 725 717 725 1016 717 713 712 714 713 714 715 689 716 714 714 712 689 715 1019 713 711 712 713 713 1019 1020 713 1020 711 711 708 712 689 712 708 706 708 711 711 1020 1021 711 1021 706 1019 864 1020 1020 864 863 1020 863 1021 1021 863 861 1021 861 859 859 1023 1021 706 1021 1023 706 707 708 706 1023 707 859 1022 1023 707 1023 1022 851 858 859 851 859 860 860 859 861 858 1022 859 860 861 862 861 863 862 862 863 864 862 864 865 865 1178 862 862 1178 1179 862 1179 860 860 1179 1180 860 1180 851 1178 1103 1179 1179 1103 1104 1179 1104 1180 1177 1102 1178 1178 1102 1103 865 1177 1178 1102 780 1103 1103 780 779 1103 779 1104 1104 779 753 1104 753 1105 1180 1104 1105 753 779 744 744 779 780 744 780 781 1102 781 780 1101 781 1102 1177 1101 1102 867 1177 865 865 866 867 866 868 867 865 864 866 868 866 1019 1019 866 864 1101 813 781 781 813 744 739 741 744 744 741 745 744 745 746 746 747 744 744 747 748 744 748 749 750 751 744 744 751 752 744 752 753 749 769 744 744 769 770 744 770 750 1153 739 744 1105 753 752 1105 752 1106 1106 752 751 1180 1105 1181 1181 1105 1106 1106 751 1107 1181 1106 1182 1182 1106 1107 851 1180 1181 851 1181 852 852 1181 1182 1182 1107 1183 852 1182 855 855 1182 1183 1107 751 750 1107 750 1108 1183 1107 1108 1183 1108 1184 855 1183 844 844 1183 1184 844 854 855 855 854 856 855 856 852 842 843 844 843 853 844 844 853 854 844 1184 842 1025 856 854 1025 854 853 852 856 857 857 856 1025 850 851 852 852 857 850 1022 850 857 1022 857 1024 1024 857 1025 850 858 851 858 850 1022 707 1022 709 709 1022 1024 709 1024 710 710 1024 1025 708 707 709 708 709 703 703 709 710 703 710 704 710 1025 704 703 704 700 689 708 703 703 700 689 700 704 705 704 1025 1027 704 1027 705 853 1027 1025 853 1026 1027 705 1027 1026 700 705 701 705 1026 701 700 701 695 689 700 695 695 701 702 701 1026 1028 701 1028 702 695 696 697 695 702 696 689 695 690 690 695 697 702 1028 1029 702 1029 696 1026 849 1028 1028 849 1029 849 848 1029 1029 848 846 1029 846 845 845 1031 1029 696 1029 1031 840 848 849 840 849 841 1026 841 849 847 846 848 847 848 840 834 845 846 834 846 847 840 1186 847 847 1186 1187 847 1187 834 832 833 834 833 845 834 834 1187 1188 834 1188 832 1186 1111 1187 1187 1111 1112 1187 1112 1188 1188 1112 1113 1188 1113 1189 832 1188 1189 1111 748 1112 1112 748 747 1112 747 1113 1110 749 1111 1111 749 748 1186 1110 1111 1109 769 1110 1110 769 749 1185 1109 1110 1185 1110 1186 840 1185 1186 1184 1109 1185 842 1184 1185 842 1185 840 1108 770 1109 1109 770 769 1184 1108 1109 1108 750 770 840 841 842 842 841 843 843 841 1026 843 1026 853 1113 747 746 1113 746 1114 1189 1113 1114 1114 746 745 1114 745 1115 1189 1114 1190 1190 1114 1115 832 1189 830 830 1189 1190 1190 1115 1191 830 1190 837 837 1190 1191 1115 745 741 1115 741 1116 1191 1115 1116 1191 1116 1192 837 1191 824 824 1191 1192 824 836 837 837 836 838 837 838 830 822 823 824 823 835 824 824 835 836 824 1192 822 838 836 1033 1033 836 835 830 838 839 1032 839 838 1032 838 1033 1033 835 1034 691 1032 1033 691 1033 692 692 1033 1034 1034 835 823 1034 823 1035 692 1034 693 693 1034 1035 691 692 689 689 692 693 689 690 691 690 699 691 699 1032 691 697 698 690 690 698 699 698 1030 699 699 1030 1032 697 696 698 696 1031 698 698 1031 1030 845 1030 1031 833 1030 845 833 831 1030 1030 831 839 1030 839 1032 832 831 833 830 831 832 830 839 831 689 693 684 684 731 689 731 729 689 689 729 727 689 727 721 721 723 689 689 723 716 684 693 694 693 1035 694 684 694 685 694 1035 1036 694 1036 685 823 821 1035 1035 821 829 1035 829 1036 1036 829 828 1036 828 1037 685 1036 1037 820 828 829 820 829 821 820 821 822 822 821 823 827 828 820 822 1193 820 820 1193 1194 820 1194 827 827 826 828 828 826 1037 819 826 827 827 1194 1195 827 1195 819 1193 1118 1194 1194 1118 1119 1194 1119 1195 1195 1119 1120 1195 1120 1196 819 1195 1196 1118 796 1119 1119 796 800 1119 800 1120 1117 784 1118 1118 784 796 1193 1117 1118 1116 768 1117 1117 768 784 1192 1116 1117 1192 1117 1193 822 1192 1193 1116 741 768 741 767 768 768 767 784 741 766 767 784 767 793 1128 793 767 1128 767 1129 1129 767 766 765 766 741 1129 766 1130 1130 766 765 1204 1128 1129 1204 1129 1205 1205 1129 1130 1127 793 1128 1203 1127 1128 1203 1128 1204 990 1203 1204 990 1204 987 987 1204 1205 1205 1130 1206 987 1205 985 985 1205 1206 985 986 987 986 988 987 987 988 989 987 989 990 982 984 985 985 984 986 985 1206 982 988 986 1048 1048 986 984 1047 989 988 1047 988 1048 990 989 991 1046 991 989 1046 989 1047 675 1046 1047 675 1047 676 676 1047 1048 1048 984 1049 676 1048 667 667 1048 1049 666 675 676 666 676 667 671 674 675 671 675 666 674 1046 675 665 666 667 666 630 671 666 665 630 667 668 665 667 1049 668 665 668 669 665 669 660 630 665 660 668 1049 1050 668 1050 669 660 669 670 669 1050 1051 669 1051 670 659 660 661 660 670 661 630 660 659 670 1051 1052 670 1052 661 1050 979 1051 1051 979 978 1051 978 1052 978 976 1052 1052 976 974 1052 974 1053 661 1052 1053 661 662 659 661 1053 662 1053 974 973 1053 973 1054 662 1053 1054 972 973 974 972 974 975 975 974 976 975 976 977 976 978 977 977 978 979 977 979 980 980 1208 977 977 1208 1209 977 1209 975 975 1209 1210 975 1210 972 1208 1133 1209 1209 1133 1134 1209 1134 1210 1207 1132 1208 1208 1132 1133 980 1207 1208 1132 763 1133 1133 763 762 1133 762 1134 1134 762 778 1134 778 1135 1210 1134 1135 762 763 741 741 778 762 741 763 764 1132 764 763 1131 764 1132 1207 1131 1132 741 764 765 1131 765 764 1130 765 1131 1206 1130 1131 1206 1131 1207 982 1206 1207 980 981 982 981 983 982 982 983 984 982 1207 980 980 979 981 983 981 1050 1050 981 979 1049 984 983 1049 983 1050 739 740 741 741 740 742 741 742 743 743 754 741 741 754 755 741 755 756 756 757 741 741 757 758 741 758 759 741 760 761 759 774 741 741 774 775 741 775 776 761 777 741 741 777 778 776 788 741 741 788 789 741 789 760 1140 788 776 1140 776 1141 1141 776 775 1139 789 788 1139 788 1140 1138 760 789 1138 789 1139 1214 1138 1139 1214 1139 1215 1215 1139 1140 1215 1140 1216 1216 1140 1141 962 1214 1215 962 1215 960 960 1215 1216 1213 1138 1214 965 1213 1214 965 1214 962 960 961 962 961 963 962 962 963 964 962 964 965 957 959 960 960 959 961 960 1216 957 963 961 1058 1058 961 959 1057 964 963 1057 963 1058 965 964 966 1056 966 964 1056 964 1057 655 1056 1057 655 1057 656 656 1057 1058 1058 959 1059 656 1058 657 657 1058 1059 655 656 653 653 656 657 653 654 655 654 664 655 664 1056 655 653 657 648 630 654 653 630 653 648 648 657 658 657 1059 658 647 648 649 648 658 649 648 647 630 658 1059 1060 658 1060 649 649 650 647 649 1060 1062 649 1062 650 647 650 651 647 651 642 630 647 642 650 1062 1061 650 1061 651 954 1061 1062 954 1062 1060 953 1061 954 953 945 1061 1061 945 952 1061 952 1063 651 1061 1063 642 651 652 651 1063 652 1063 952 1064 652 1063 1064 947 951 952 947 952 945 952 951 1064 945 946 947 945 953 946 946 953 954 946 954 955 955 1218 946 946 1218 1219 946 1219 947 950 951 947 947 1219 1220 947 1220 950 950 949 951 1064 951 949 939 949 950 950 1220 1221 950 1221 939 1219 1144 1220 1220 1144 1145 1220 1145 1221 1218 1143 1219 1219 1143 1144 1143 759 1144 1144 759 758 1144 758 1145 1145 758 757 1145 757 1146 1221 1145 1146 1221 1146 1222 939 1221 1222 1146 757 756 1146 756 1147 1222 1146 1147 1222 1147 1223 939 1222 937 937 1222 1223 1147 756 755 1147 755 1148 1223 1147 1148 1223 1148 1224 937 1223 935 935 1223 1224 935 936 937 937 936 938 937 938 939 938 948 939 939 948 949 938 1065 948 938 936 1065 935 944 936 1065 936 944 948 1065 1066 1065 944 1067 644 1066 1065 644 1065 645 645 1065 1067 1064 949 948 948 1066 1064 643 1064 1066 643 1066 644 643 644 641 641 644 645 641 645 636 636 645 646 645 1067 646 1067 944 1068 646 1067 1068 636 646 637 646 1068 637 635 636 637 635 641 636 641 642 643 630 641 635 630 642 641 637 638 635 635 638 639 635 639 630 637 1068 1070 637 1070 638 638 1070 1069 638 1069 639 940 1069 1070 940 1070 1068 928 1069 940 928 926 1069 1069 926 934 928 940 929 929 940 941 1068 941 940 927 926 928 927 928 929 925 926 927 925 934 926 929 1226 927 927 1226 1227 927 1227 925 925 1227 1228 1226 1151 1227 1227 1151 1152 1227 1152 1228 1225 1150 1226 1226 1150 1151 929 1225 1226 1150 742 1151 1151 742 740 1151 740 1152 1152 740 739 1152 739 1153 1228 1152 1153 1150 743 742 1149 743 1150 1225 1149 1150 1149 754 743 1148 754 1149 1224 1148 1149 1224 1149 1225 1148 755 754 942 1224 1225 942 1225 929 935 1224 942 929 941 942 942 941 943 942 943 935 935 943 944 944 943 1068 1068 943 941 671 630 672 672 630 677 659 654 630 671 672 673 673 674 671 677 681 672 672 681 682 672 682 673 682 1044 673 673 1044 1045 673 1045 674 674 1045 1046 1044 994 1045 1045 994 993 1045 993 1046 993 991 1046 991 993 992 992 993 994 992 994 995 995 994 996 1044 996 994 990 991 992 995 1202 992 992 1202 1203 992 1203 990 995 996 997 997 1201 995 995 1201 1202 996 998 997 998 996 1044 997 998 999 997 999 1000 1000 1200 997 997 1200 1201 1200 1125 1201 1201 1125 1126 1201 1126 1202 1199 1124 1200 1200 1124 1125 1000 1199 1200 1000 999 1001 1000 1001 1002 1002 1199 1000 1198 1123 1199 1199 1123 1124 1002 1198 1199 1123 795 1124 1124 795 794 1124 794 1125 1122 797 1123 1123 797 795 1198 1122 1123 1197 1122 1198 815 1197 1198 815 1198 1002 1121 798 1122 1122 798 797 1197 1121 1122 796 795 797 797 798 796 796 798 799 1121 799 798 1120 799 1121 1196 1120 1121 1196 1121 1197 817 1196 1197 817 1197 815 819 1196 817 815 816 817 817 816 818 817 818 819 818 825 819 819 825 826 1038 825 818 1038 818 1039 818 816 1039 815 1004 816 1039 816 1004 1039 1004 1040 687 1038 1039 687 1039 688 688 1039 1040 815 1003 1004 1040 1004 1003 1002 1003 815 1002 1001 1003 1040 1003 1041 1041 1003 1001 688 1040 679 679 1040 1041 678 687 688 678 688 679 677 678 679 679 680 677 679 1041 680 1041 1001 1042 680 1041 1042 1042 1001 999 1042 999 1043 680 1042 681 681 1042 1043 677 680 681 626 736 677 677 736 731 677 731 678 625 734 626 626 734 735 626 735 736 736 735 737 736 737 731 734 1081 735 735 1081 1082 735 1082 737 625 1080 734 734 1080 1081 1080 911 1081 1081 911 909 1081 909 1082 1082 909 908 1082 908 1005 737 1082 1005 731 737 738 737 1005 738 1005 899 1006 1005 908 901 1005 901 899 738 1005 1006 901 908 902 902 908 909 902 909 910 910 909 911 900 901 902 900 899 901 897 898 899 897 899 900 1006 899 898 895 896 897 896 898 897 1006 898 1007 898 896 1007 895 894 896 1007 896 894 892 894 895 892 893 894 1007 894 1008 1008 894 893 732 1006 1007 732 1007 733 733 1007 1008 1008 893 1009 733 1008 730 730 1008 1009 891 893 892 893 891 1009 890 891 892 890 889 891 1009 891 889 1009 889 1010 730 1009 728 728 1009 1010 728 729 730 729 733 730 729 732 733 728 727 729 731 732 729 726 727 728 728 1010 726 726 721 727 719 721 726 726 1010 1011 726 1011 719 719 720 721 721 720 722 721 722 723 719 1011 1012 719 1012 720 720 1012 1013 720 1013 722 723 722 724 722 1013 1014 722 1014 724 723 724 716 716 724 725 724 1014 1015 724 1015 725 1013 879 1014 1014 879 878 1014 878 1015 878 876 1015 1015 876 874 1015 874 1016 725 1015 1016 876 878 877 877 878 879 877 879 880 880 879 881 1013 881 879 880 881 882 881 883 882 883 881 1013 1012 883 1013 882 883 884 1012 884 883 882 884 885 885 884 886 1011 886 884 1011 884 1012 885 886 887 886 888 887 888 886 1011 1010 888 1011 887 888 889 1010 889 888 887 889 890 731 738 732 738 1006 732 683 731 684 678 731 683 683 684 685 685 686 683 683 686 687 683 687 678 685 1037 686 686 1037 1038 686 1038 687 1037 826 825 1037 825 1038 681 1043 682 1043 999 998 1043 998 1044 682 1043 1044 1120 800 799 796 799 800 784 795 796 782 783 784 784 793 782 783 794 784 784 794 795 1126 783 782 1126 782 1127 1127 782 793 1125 794 783 1125 783 1126 1202 1126 1127 1202 1127 1203 659 663 654 654 663 664 659 662 663 662 1054 663 663 1054 1055 663 1055 664 664 1055 1056 1054 969 1055 1055 969 968 1055 968 1056 973 971 1054 1054 971 969 967 968 969 967 969 970 970 969 971 966 968 967 968 966 1056 965 966 967 970 1212 967 967 1212 1213 967 1213 965 970 971 972 972 1211 970 970 1211 1212 971 973 972 972 1210 1211 1210 1135 1211 1211 1135 1136 1211 1136 1212 1212 1136 1137 1212 1137 1213 1213 1137 1138 1136 761 1137 1137 761 760 1137 760 1138 1135 777 1136 1136 777 761 1135 778 777 642 652 643 652 1064 643 1143 774 759 1142 774 1143 1218 1142 1143 1142 775 774 1141 775 1142 1217 1141 1142 1217 1142 1218 955 1217 1218 1216 1141 1217 957 1216 1217 957 1217 955 955 954 956 955 956 957 956 958 957 957 958 959 1060 958 956 1060 956 954 1059 959 958 1059 958 1060 1077 920 906 906 920 907 905 906 907 907 1234 905))
                   (list :vertices (let ((mat (make-matrix 1235 3))) (fvector-replace (array-entity mat) #f(-8.2532897949218750e+01 4.6002399444580078e+01 -3.0704399108886719e+01 -8.3498199462890625e+01 4.4944301605224609e+01 -3.1827098846435547e+01 -8.3556304931640625e+01 5.4500000000000000e+01 -3.1774402618408203e+01 -8.2532897949218750e+01 -4.6002399444580078e+01 3.0704399108886719e+01 -8.3498199462890625e+01 -4.4944301605224609e+01 3.1827098846435547e+01 -8.3628807067871094e+01 -5.2000000000000000e+01 3.1734802246093750e+01 -1.2745599365234375e+02 5.4500000000000000e+01 5.1915897369384766e+01 -1.2873800659179688e+02 5.4500000000000000e+01 5.1711898803710938e+01 -1.2450000000000000e+02 0.0000000000000000e+00 5.2000000000000000e+01 -8.6393104553222656e+01 -5.2000000000000000e+01 3.5381702423095703e+01 -8.7847801208496094e+01 -4.0176498413085938e+01 3.6886497497558594e+01 -9.0690200805664062e+01 -5.2000000000000000e+01 3.9171401977539062e+01 -9.0624801635742188e+01 -3.7132400512695312e+01 3.9241100311279297e+01 -9.4158302307128906e+01 -5.2000000000000000e+01 4.2229999542236328e+01 -9.4103797912597656e+01 -3.3318901062011719e+01 4.2190799713134766e+01 -9.9079299926757812e+01 -5.2000000000000000e+01 4.5069297790527344e+01 -9.9022399902343750e+01 -2.7927400588989258e+01 4.5172599792480469e+01 -1.0312599945068359e+02 -5.2000000000000000e+01 4.7404201507568359e+01 -1.0115200042724609e+02 -2.5592601776123047e+01 4.6463798522949219e+01 -1.0846699523925781e+02 -5.2000000000000000e+01 4.9196998596191406e+01 -1.0839799499511719e+02 -1.7650699615478516e+01 4.9408199310302734e+01 -1.1294200134277344e+02 -5.2000000000000000e+01 5.0699100494384766e+01 -1.0881700134277344e+02 -1.7191101074218750e+01 4.9578598022460938e+01 -1.1848400115966797e+02 -5.2000000000000000e+01 5.1392299652099609e+01 -7.8274200439453125e+01 -5.0670600891113281e+01 2.3815299987792969e+01 -8.0138694763183594e+01 -5.2000000000000000e+01 2.7130599975585938e+01 -7.7956497192382812e+01 -5.1018798828125000e+01 2.3155799865722656e+01 -7.8023002624511719e+01 -5.2000000000000000e+01 2.3120201110839844e+01 -7.7061401367187500e+01 -5.2000000000000000e+01 2.1297401428222656e+01 -7.7061401367187500e+01 -5.2000000000000000e+01 -2.1297401428222656e+01 -7.8023002624511719e+01 -5.2000000000000000e+01 -2.3120201110839844e+01 -7.7800399780273438e+01 -5.1189899444580078e+01 -2.2872400283813477e+01 -7.7964599609375000e+01 -5.1010002136230469e+01 -2.3149799346923828e+01 -8.3628807067871094e+01 -5.2000000000000000e+01 -3.1734802246093750e+01 -8.3530799865722656e+01 -4.4908603668212891e+01 -3.1802200317382812e+01 -8.1974899291992188e+01 -4.6614097595214844e+01 -2.9926700592041016e+01 -8.0138694763183594e+01 -5.2000000000000000e+01 -2.7130599975585938e+01 -9.0690200805664062e+01 -5.2000000000000000e+01 -3.9171401977539062e+01 -9.0628799438476562e+01 -3.7128097534179688e+01 -3.9239898681640625e+01 -8.7235298156738281e+01 -4.0847801208496094e+01 -3.6267601013183594e+01 -8.6393104553222656e+01 -5.2000000000000000e+01 -3.5381702423095703e+01 -9.9079299926757812e+01 -5.2000000000000000e+01 -4.5069297790527344e+01 -9.9009094238281250e+01 -2.7941900253295898e+01 -4.5197402954101562e+01 -9.3457000732421875e+01 -3.4027900695800781e+01 -4.1717201232910156e+01 -9.4158302307128906e+01 -5.2000000000000000e+01 -4.2229999542236328e+01 -1.0048400115966797e+02 -2.6325300216674805e+01 -4.6121799468994141e+01 -1.0312599945068359e+02 -5.2000000000000000e+01 -4.7404201507568359e+01 -1.0846699523925781e+02 -5.2000000000000000e+01 -4.9196998596191406e+01 -1.1621099853515625e+02 -9.0858306884765625e+00 -5.1335098266601562e+01 -1.0839000701904297e+02 -1.7658800125122070e+01 -4.9420200347900391e+01 -1.0813500213623047e+02 -1.7938199996948242e+01 -4.9357803344726562e+01 -1.1845700073242188e+02 5.4500000000000000e+01 -5.1519302368164062e+01 -1.1845899963378906e+02 6.6216001510620117e+00 -5.1556198120117188e+01 -1.2745599365234375e+02 5.4500000000000000e+01 -5.1915897369384766e+01 -1.2450000000000000e+02 0.0000000000000000e+00 -5.2000000000000000e+01 -1.2873800659179688e+02 5.4500000000000000e+01 -5.1711898803710938e+01 -1.1294200134277344e+02 -5.2000000000000000e+01 -5.0699100494384766e+01 -1.1848400115966797e+02 -5.2000000000000000e+01 -5.1392299652099609e+01 -1.1846300506591797e+02 -6.6171898841857910e+00 -5.1515800476074219e+01 -8.9034294128417969e+01 5.4500000000000000e+01 -3.8028602600097656e+01 -8.7847801208496094e+01 4.0176498413085938e+01 -3.6886497497558594e+01 -9.0619895935058594e+01 5.4500000000000000e+01 -3.9233100891113281e+01 -9.0624801635742188e+01 3.7132400512695312e+01 -3.9241100311279297e+01 -9.7378593444824219e+01 5.4500000000000000e+01 -4.4366901397705078e+01 -9.4103797912597656e+01 3.3318901062011719e+01 -4.2190799713134766e+01 -9.9017204284667969e+01 5.4500000000000000e+01 -4.5154003143310547e+01 -9.9022399902343750e+01 2.7927400588989258e+01 -4.5172599792480469e+01 -1.0682400512695312e+02 5.4500000000000000e+01 -4.8903598785400391e+01 -1.0115200042724609e+02 2.5592601776123047e+01 -4.6463798522949219e+01 -1.0841899871826172e+02 5.4500000000000000e+01 -4.9303901672363281e+01 -1.0839799499511719e+02 1.7650699615478516e+01 -4.9408199310302734e+01 -1.1698800659179688e+02 5.4500000000000000e+01 -5.1454498291015625e+01 -1.0881700134277344e+02 1.7191101074218750e+01 -4.9578598022460938e+01 -1.1689999389648438e+02 8.3308200836181641e+00 -5.1441596984863281e+01 -7.7990898132324219e+01 5.0981201171875000e+01 -2.3142000198364258e+01 -7.6946495056152344e+01 5.4500000000000000e+01 -2.1039400100708008e+01 -7.5152099609375000e+01 5.4092899322509766e+01 -1.6394498825073242e+01 -7.4780700683593750e+01 5.4500000000000000e+01 -1.5231199264526367e+01 -7.8274200439453125e+01 5.0670600891113281e+01 -2.3815299987792969e+01 -8.2130096435546875e+01 5.4500000000000000e+01 -3.0146099090576172e+01 -7.8102996826171875e+01 5.4500000000000000e+01 -2.3071300506591797e+01 -8.3556304931640625e+01 5.4500000000000000e+01 3.1774402618408203e+01 -8.3530799865722656e+01 4.4908603668212891e+01 3.1802200317382812e+01 -8.1974899291992188e+01 4.6614097595214844e+01 2.9926700592041016e+01 -8.2130096435546875e+01 5.4500000000000000e+01 3.0146099090576172e+01 -7.7964599609375000e+01 5.1010002136230469e+01 2.3149799346923828e+01 -7.8102996826171875e+01 5.4500000000000000e+01 2.3071300506591797e+01 -7.7800399780273438e+01 5.1189899444580078e+01 2.2872400283813477e+01 -7.6946495056152344e+01 5.4500000000000000e+01 2.1039400100708008e+01 -7.4801300048828125e+01 5.4477298736572266e+01 1.5298399925231934e+01 -7.4780700683593750e+01 5.4500000000000000e+01 1.5231199264526367e+01 -9.0619895935058594e+01 5.4500000000000000e+01 3.9233100891113281e+01 -9.0628799438476562e+01 3.7128097534179688e+01 3.9239898681640625e+01 -8.7235298156738281e+01 4.0847801208496094e+01 3.6267601013183594e+01 -8.9034294128417969e+01 5.4500000000000000e+01 3.8028602600097656e+01 -9.9017204284667969e+01 5.4500000000000000e+01 4.5154003143310547e+01 -9.9009094238281250e+01 2.7941900253295898e+01 4.5197402954101562e+01 -9.3457000732421875e+01 3.4027900695800781e+01 4.1717201232910156e+01 -9.7378593444824219e+01 5.4500000000000000e+01 4.4366901397705078e+01 -1.0048400115966797e+02 2.6325300216674805e+01 4.6121799468994141e+01 -1.0841899871826172e+02 5.4500000000000000e+01 4.9303901672363281e+01 -1.0813500213623047e+02 1.7938199996948242e+01 4.9357803344726562e+01 -1.0839000701904297e+02 1.7658800125122070e+01 4.9420200347900391e+01 -1.0682400512695312e+02 5.4500000000000000e+01 4.8903598785400391e+01 -1.1845700073242188e+02 5.4500000000000000e+01 5.1519302368164062e+01 -1.1846300506591797e+02 6.6171898841857910e+00 5.1515800476074219e+01 -1.1621099853515625e+02 9.0858306884765625e+00 5.1335098266601562e+01 -1.1698800659179688e+02 5.4500000000000000e+01 5.1454498291015625e+01 -1.2321499633789062e+02 -5.2000000000000000e+01 -5.1984100341796875e+01 -1.2873699951171875e+02 -5.2000000000000000e+01 -5.1569202423095703e+01 -1.3354000854492188e+02 -5.2000000000000000e+01 -5.1208202362060547e+01 -1.3780499267578125e+02 5.4500000000000000e+01 -5.0269100189208984e+01 -1.3882299804687500e+02 -5.2000000000000000e+01 -4.9720600128173828e+01 -1.3885700988769531e+02 5.4500000000000000e+01 -4.9873199462890625e+01 -1.4350601196289062e+02 -5.2000000000000000e+01 -4.8402202606201172e+01 -1.4761300659179688e+02 5.4500000000000000e+01 -4.6581001281738281e+01 -1.4834700012207031e+02 -5.2000000000000000e+01 -4.5919197082519531e+01 -1.4841799926757812e+02 5.4500000000000000e+01 -4.6074401855468750e+01 -1.5271798706054688e+02 -5.2000000000000000e+01 -4.3677402496337891e+01 -1.5648199462890625e+02 5.4500000000000000e+01 -4.1001399993896484e+01 -1.5693501281738281e+02 -5.2000000000000000e+01 -4.0314399719238281e+01 -1.5704501342773438e+02 5.4500000000000000e+01 -4.0463298797607422e+01 -1.6081201171875000e+02 -5.2000000000000000e+01 -3.7221000671386719e+01 -1.6405299377441406e+02 5.4500000000000000e+01 -3.3756801605224609e+01 -1.6424800109863281e+02 -5.2000000000000000e+01 -3.3126201629638672e+01 -1.6439799499511719e+02 5.4500000000000000e+01 -3.3259101867675781e+01 -1.7001800537109375e+02 5.4500000000000000e+01 -2.5141500473022461e+01 -1.6746699523925781e+02 -5.2000000000000000e+01 -2.9289100646972656e+01 -1.7018798828125000e+02 5.4500000000000000e+01 -2.4743999481201172e+01 -1.7000000000000000e+02 -5.2000000000000000e+01 -2.4637001037597656e+01 -1.7413499450683594e+02 5.4500000000000000e+01 -1.5505200386047363e+01 -1.7241799926757812e+02 -5.2000000000000000e+01 -2.0195899963378906e+01 -1.7418600463867188e+02 5.4500000000000000e+01 -1.5251199722290039e+01 -1.7396501159667969e+02 -5.2000000000000000e+01 -1.5180200576782227e+01 -1.7623500061035156e+02 5.4500000000000000e+01 -5.2393102645874023e+00 -1.7546899414062500e+02 -5.2000000000000000e+01 -1.0302200317382812e+01 -1.7623500061035156e+02 5.4500000000000000e+01 -5.1528801918029785e+00 -1.1689999389648438e+02 -8.3308200836181641e+00 5.1441596984863281e+01 -1.1845899963378906e+02 -6.6216001510620117e+00 5.1556198120117188e+01 -1.2321499633789062e+02 -5.2000000000000000e+01 5.1984100341796875e+01 -1.2873699951171875e+02 -5.2000000000000000e+01 5.1569202423095703e+01 -1.3354000854492188e+02 -5.2000000000000000e+01 5.1208202362060547e+01 -1.3780499267578125e+02 5.4500000000000000e+01 5.0269100189208984e+01 -1.3882299804687500e+02 -5.2000000000000000e+01 4.9720600128173828e+01 -1.3885700988769531e+02 5.4500000000000000e+01 4.9873199462890625e+01 -1.4350601196289062e+02 -5.2000000000000000e+01 4.8402202606201172e+01 -1.4761300659179688e+02 5.4500000000000000e+01 4.6581001281738281e+01 -1.4834700012207031e+02 -5.2000000000000000e+01 4.5919197082519531e+01 -1.4841799926757812e+02 5.4500000000000000e+01 4.6074401855468750e+01 -1.5271798706054688e+02 -5.2000000000000000e+01 4.3677402496337891e+01 -1.5648199462890625e+02 5.4500000000000000e+01 4.1001399993896484e+01 -1.5693501281738281e+02 -5.2000000000000000e+01 4.0314399719238281e+01 -1.5704501342773438e+02 5.4500000000000000e+01 4.0463298797607422e+01 -1.6081201171875000e+02 -5.2000000000000000e+01 3.7221000671386719e+01 -1.6405299377441406e+02 5.4500000000000000e+01 3.3756801605224609e+01 -1.6424800109863281e+02 -5.2000000000000000e+01 3.3126201629638672e+01 -1.6439799499511719e+02 5.4500000000000000e+01 3.3259101867675781e+01 -1.6746699523925781e+02 -5.2000000000000000e+01 2.9289100646972656e+01 -1.7001800537109375e+02 5.4500000000000000e+01 2.5141500473022461e+01 -1.7000000000000000e+02 -5.2000000000000000e+01 2.4637001037597656e+01 -1.7018798828125000e+02 5.4500000000000000e+01 2.4743999481201172e+01 -1.7241799926757812e+02 -5.2000000000000000e+01 2.0195899963378906e+01 -1.7413499450683594e+02 5.4500000000000000e+01 1.5505200386047363e+01 -1.7396501159667969e+02 -5.2000000000000000e+01 1.5180200576782227e+01 -1.7418600463867188e+02 5.4500000000000000e+01 1.5251199722290039e+01 -1.7546899414062500e+02 -5.2000000000000000e+01 1.0302200317382812e+01 -1.7623500061035156e+02 5.4500000000000000e+01 5.2393102645874023e+00 -1.7598699951171875e+02 -5.2000000000000000e+01 5.1271300315856934e+00 -1.7623500061035156e+02 5.4500000000000000e+01 5.1528801918029785e+00 -1.7650000000000000e+02 -5.2000000000000000e+01 0.0000000000000000e+00 -1.7598699951171875e+02 -5.2000000000000000e+01 -5.1271300315856934e+00 -1.1594799804687500e+02 -8.8181495666503906e+00 -5.1306999206542969e+01 -7.4031303405761719e+01 -5.2199901580810547e+01 -1.4834400177001953e+01 -7.4085899353027344e+01 -5.2212497711181641e+01 -1.4866800308227539e+01 -7.6944198608398438e+01 -4.9163402557373047e+01 -2.2299200057983398e+01 -7.2300102233886719e+01 -5.0468696594238281e+01 -1.4834400177001953e+01 -7.0526596069335938e+01 -5.2166301727294922e+01 -7.1510100364685059e+00 -7.1044494628906250e+01 -5.2394599914550781e+01 -7.5932698249816895e+00 -7.2385993957519531e+01 -5.2323402404785156e+01 -1.0982699394226074e+01 -7.2962203979492188e+01 -5.2292800903320312e+01 -1.2438300132751465e+01 -7.3854698181152344e+01 -5.2229000091552734e+01 -1.4367200851440430e+01 -7.0253402709960938e+01 -5.2428497314453125e+01 -4.7791600227355957e+00 -7.0485702514648438e+01 -5.2418498992919922e+01 -5.6054000854492188e+00 -7.0913902282714844e+01 -5.2400199890136719e+01 -7.1288299560546875e+00 -6.9635894775390625e+01 -5.2452697753906250e+01 -8.0365194007754326e-03 -6.9617797851562500e+01 -5.2453300476074219e+01 -1.0901100635528564e+00 -6.7504096984863281e+01 -5.1996200561523438e+01 6.2489897012710571e-01 -6.8080596923828125e+01 -5.1470298767089844e+01 -7.4027199745178223e+00 -6.9862098693847656e+01 -5.2444301605224609e+01 -2.8345000743865967e+00 -7.0016395568847656e+01 -5.2438602447509766e+01 -3.9357500076293945e+00 -7.0252296447753906e+01 -5.2429000854492188e+01 4.8872199058532715e+00 -7.0164001464843750e+01 -5.2432800292968750e+01 4.5926599502563477e+00 -6.8287002563476562e+01 -5.1282001495361328e+01 8.6108999252319336e+00 -6.7700103759765625e+01 -5.1817497253417969e+01 2.6233799457550049e+00 -6.9867607116699219e+01 -5.2444000244140625e+01 2.8594698905944824e+00 -6.9664001464843750e+01 -5.2451698303222656e+01 1.6682699918746948e+00 -6.9646202087402344e+01 -5.2452301025390625e+01 6.0474997758865356e-01 -7.0714302062988281e+01 -5.1986900329589844e+01 8.3217000961303711e+00 -7.1183006286621094e+01 -5.2388103485107422e+01 7.9929800033569336e+00 -7.0476501464843750e+01 -5.2419101715087891e+01 5.6353797912597656e+00 -7.4610099792480469e+01 -5.2174900054931641e+01 1.5998101234436035e+01 -7.4369598388671875e+01 -5.1847000122070312e+01 1.5908300399780273e+01 -7.3852005004882812e+01 -5.2229000091552734e+01 1.4359200477600098e+01 -7.2652999877929688e+01 -5.0130401611328125e+01 1.5908300399780273e+01 -7.2941299438476562e+01 -5.2294002532958984e+01 1.2390700340270996e+01 -7.2377502441406250e+01 -5.2324199676513672e+01 1.0980500221252441e+01 -7.1301605224609375e+01 -5.2381797790527344e+01 8.2893400192260742e+00 -1.1665800476074219e+02 -8.0856695175170898e+00 5.1417900085449219e+01 -1.1641400146484375e+02 -7.8417100906372070e+00 5.1417900085449219e+01 -1.1874400329589844e+02 -5.2513499259948730e+00 5.1614200592041016e+01 -1.1616899871826172e+02 -7.6000699996948242e+00 5.1441596984863281e+01 -1.0833200073242188e+02 -1.6674301147460938e+01 4.9478900909423828e+01 -1.0046400451660156e+02 -2.4795801162719727e+01 4.6247299194335938e+01 -1.0743899536132812e+02 -1.5564599990844727e+01 4.9605899810791016e+01 -1.0782600402832031e+02 -1.6168199539184570e+01 4.9478900909423828e+01 -1.0730899810791016e+02 -1.5683000564575195e+01 4.9578598022460938e+01 -9.9704200744628906e+01 -2.4035699844360352e+01 4.6247299194335938e+01 -9.8907402038574219e+01 -2.3347700119018555e+01 4.6463798522949219e+01 -9.3270301818847656e+01 -3.2230701446533203e+01 4.1837299346923828e+01 -8.6937301635742188e+01 -3.8786300659179688e+01 3.6403896331787109e+01 -8.5713699340820312e+01 -3.7562702178955078e+01 3.6403896331787109e+01 -8.7486106872558594e+01 -3.3767101287841797e+01 3.9332698822021484e+01 -9.2269302368164062e+01 -3.1229700088500977e+01 4.1837299346923828e+01 -9.1181098937988281e+01 -3.0396200180053711e+01 4.2190799713134766e+01 -9.6908401489257812e+01 -2.5171300888061523e+01 4.5358299255371094e+01 -8.1615402221679688e+01 -4.4306400299072266e+01 3.0134799957275391e+01 -7.7408096313476562e+01 -4.8680397033691406e+01 2.3236099243164062e+01 -8.0193603515625000e+01 -4.2884597778320312e+01 3.0134799957275391e+01 -7.5819595336914062e+01 -4.7091899871826172e+01 2.3236099243164062e+01 -7.3394996643066406e+01 -4.6622100830078125e+01 2.2873500823974609e+01 -7.3829399108886719e+01 -4.6225799560546875e+01 2.3815299987792969e+01 -7.8497604370117188e+01 -4.1967102050781250e+01 3.0704399108886719e+01 -7.9502098083496094e+01 -4.1050697326660156e+01 3.1770299911499023e+01 -8.4323501586914062e+01 -3.6652198791503906e+01 3.6886497497558594e+01 -7.0407096862792969e+01 -4.9347900390625000e+01 1.6394498825073242e+01 -6.9481697082519531e+01 -5.0192100524902344e+01 1.2997099876403809e+01 -6.8194702148437500e+01 -5.1366298675537109e+01 -7.8666200637817383e+00 -7.0022705078125000e+01 -4.9698699951171875e+01 -1.5298399925231934e+01 -7.1197799682617188e+01 -4.8626502990722656e+01 -1.8006000518798828e+01 -8.1060699462890625e+01 -4.4882499694824219e+01 -2.9351501464843750e+01 -7.3310096740722656e+01 -4.6699600219726562e+01 -2.2872400283813477e+01 -7.5336601257324219e+01 -4.7555801391601562e+01 -2.2299200057983398e+01 -7.6266700744628906e+01 -4.4002296447753906e+01 -2.7430500030517578e+01 -7.9617500305175781e+01 -4.3439300537109375e+01 -2.9351501464843750e+01 -7.7885902404785156e+01 -4.2525100708007812e+01 -2.9926700592041016e+01 -8.6320800781250000e+01 -3.9425201416015625e+01 -3.5773097991943359e+01 -8.3224494934082031e+01 -3.7654796600341797e+01 -3.5797302246093750e+01 -8.5074798583984375e+01 -3.8179199218750000e+01 -3.5773097991943359e+01 -8.3652198791503906e+01 -3.7264701843261719e+01 -3.6267601013183594e+01 -9.1589195251464844e+01 -3.1887199401855469e+01 -4.1350200653076172e+01 -9.0472099304199219e+01 -3.1043001174926758e+01 -4.1717201232910156e+01 -9.2612800598144531e+01 -3.2910800933837891e+01 -4.1350200653076172e+01 -9.9780097961425781e+01 -2.5502401351928711e+01 -4.5893402099609375e+01 -1.0710199737548828e+02 -1.6869199752807617e+01 -4.9249401092529297e+01 -1.0209300231933594e+02 -2.0441898345947266e+01 -4.7633499145507812e+01 -9.8997596740722656e+01 -2.4719900131225586e+01 -4.5893402099609375e+01 -9.8174697875976562e+01 -2.4016000747680664e+01 -4.6121799468994141e+01 -9.1999801635742188e+01 -2.9649299621582031e+01 -4.2590801239013672e+01 -1.1568199920654297e+02 -8.5519599914550781e+00 -5.1306999206542969e+01 -1.0763099670410156e+02 -1.7397600173950195e+01 -4.9249401092529297e+01 -1.1541400146484375e+02 -8.2888002395629883e+00 -5.1335098266601562e+01 -1.1305899810791016e+02 -1.0437399864196777e+01 -5.0808998107910156e+01 -1.0656200408935547e+02 -1.6364601135253906e+01 -4.9357803344726562e+01 -1.0953199768066406e+02 -5.4000000000000000e+01 4.7707000732421875e+01 -1.1944200134277344e+02 -5.4000000000000000e+01 4.9743400573730469e+01 -1.7290400695800781e+02 -5.4000000000000000e+01 1.2532600402832031e+01 -7.4564201354980469e+01 -5.4000000000000000e+01 2.5324199199676514e+00 -1.4421800231933594e+02 -5.4000000000000000e+01 -4.5947799682617188e+01 -7.5076599121093750e+01 -5.4000000000000000e+01 -7.5713400840759277e+00 -1.3456500244140625e+02 -5.4000000000000000e+01 -4.8976501464843750e+01 -1.2450000000000000e+02 -5.4000000000000000e+01 -4.9999900817871094e+01 -1.1443500518798828e+02 -5.4000000000000000e+01 -4.8976501464843750e+01 -1.0478199768066406e+02 -5.4000000000000000e+01 -4.5947799682617188e+01 -9.5936599731445312e+01 -5.4000000000000000e+01 -4.1038101196289062e+01 -7.6096199035644531e+01 -5.4000000000000000e+01 1.2532600402832031e+01 -7.9609794616699219e+01 -5.4000000000000000e+01 2.2019699096679688e+01 -8.4961303710937500e+01 -5.4000000000000000e+01 3.0605199813842773e+01 -1.0023500061035156e+02 -5.4000000000000000e+01 4.3717300415039062e+01 -1.7443600463867188e+02 -5.4000000000000000e+01 2.5324199199676514e+00 -1.7392300415039062e+02 -5.4000000000000000e+01 -7.5713400840759277e+00 -1.7138800048828125e+02 -5.4000000000000000e+01 -1.7365200042724609e+01 -1.6693200683593750e+02 -5.4000000000000000e+01 -2.6448200225830078e+01 -1.6074000549316406e+02 -5.4000000000000000e+01 -3.4448299407958984e+01 -8.8260398864746094e+01 -5.4000000000000000e+01 -3.4448299407958984e+01 -8.2067802429199219e+01 -5.4000000000000000e+01 -2.6448200225830078e+01 -7.7612396240234375e+01 -5.4000000000000000e+01 -1.7365200042724609e+01 -1.2955799865722656e+02 -5.4000000000000000e+01 4.9743400573730469e+01 -1.3946800231933594e+02 -5.4000000000000000e+01 4.7707000732421875e+01 -1.4876499938964844e+02 -5.4000000000000000e+01 4.3717300415039062e+01 -1.5706900024414062e+02 -5.4000000000000000e+01 3.7937896728515625e+01 -1.6403900146484375e+02 -5.4000000000000000e+01 3.0605199813842773e+01 -1.6938999938964844e+02 -5.4000000000000000e+01 2.2019699096679688e+01 -9.1931404113769531e+01 -5.4000000000000000e+01 3.7937896728515625e+01 -1.5306300354003906e+02 -5.4000000000000000e+01 -4.1038101196289062e+01 -6.7504096984863281e+01 5.1996200561523438e+01 -6.2489897012710571e-01 -6.7737403869628906e+01 5.1783401489257812e+01 2.6239101886749268e+00 -1.0500000000000000e+01 5.1933200836181641e+01 2.6337499618530273e+00 -7.3310096740722656e+01 4.6699600219726562e+01 2.2872400283813477e+01 -7.3327499389648438e+01 4.6683700561523438e+01 2.2899198532104492e+01 -1.0500000000000000e+01 4.6685798645019531e+01 2.2900499343872070e+01 -1.0656200408935547e+02 1.6364601135253906e+01 4.9357803344726562e+01 -1.0745300292968750e+02 1.5551899909973145e+01 4.9556900024414062e+01 -1.0500000000000000e+01 1.5566900253295898e+01 4.9615200042724609e+01 -1.0500000000000000e+01 5.2607102394104004e+00 5.1733200073242188e+01 -1.1541400146484375e+02 8.2888002395629883e+00 5.1335098266601562e+01 -1.1874800109863281e+02 5.2477698326110840e+00 5.1579097747802734e+01 -1.0500000000000000e+01 0.0000000000000000e+00 5.2000000000000000e+01 -1.0500000000000000e+01 -5.2607102394104004e+00 5.1733200073242188e+01 -1.0500000000000000e+01 2.5235601425170898e+01 4.5465999603271484e+01 -1.0500000000000000e+01 3.3871299743652344e+01 3.9455398559570312e+01 -8.7488700866699219e+01 3.3764701843261719e+01 3.9333297729492188e+01 -9.0472099304199219e+01 3.1043001174926758e+01 4.1717201232910156e+01 -9.6890701293945312e+01 2.5187398910522461e+01 4.5387599945068359e+01 -9.8174697875976562e+01 2.4016000747680664e+01 4.6121799468994141e+01 -1.0500000000000000e+01 4.1120296478271484e+01 3.1829498291015625e+01 -7.7885902404785156e+01 4.2525100708007812e+01 2.9926700592041016e+01 -7.9539001464843750e+01 4.1017101287841797e+01 3.1744499206542969e+01 -8.3652198791503906e+01 3.7264701843261719e+01 3.6267601013183594e+01 -1.0500000000000000e+01 5.0340000152587891e+01 1.3033900260925293e+01 -6.8080596923828125e+01 5.1470298767089844e+01 7.4027199745178223e+00 -6.9458595275878906e+01 5.0213199615478516e+01 1.3005399703979492e+01 -7.0022705078125000e+01 4.9698699951171875e+01 1.5298399925231934e+01 -6.8214294433593750e+01 5.1348297119140625e+01 -7.8695397377014160e+00 -1.0500000000000000e+01 5.1400299072265625e+01 -7.8741898536682129e+00 -6.8287002563476562e+01 5.1282001495361328e+01 -8.6108999252319336e+00 -1.0500000000000000e+01 4.8763099670410156e+01 -1.8059799194335938e+01 -7.0407096862792969e+01 4.9347900390625000e+01 -1.6394498825073242e+01 -1.0500000000000000e+01 4.4129497528076172e+01 -2.7506099700927734e+01 -7.3829399108886719e+01 4.6225799560546875e+01 -2.3815299987792969e+01 -7.1156097412109375e+01 4.8664600372314453e+01 -1.8018699645996094e+01 -1.0500000000000000e+01 3.7689201354980469e+01 -3.5826297760009766e+01 -7.8497604370117188e+01 4.1967102050781250e+01 -3.0704399108886719e+01 -7.6274200439453125e+01 4.3995498657226562e+01 -2.7423198699951172e+01 -9.1972503662109375e+01 2.9674200057983398e+01 -4.2628501892089844e+01 -9.1181098937988281e+01 3.0396200180053711e+01 -4.2190799713134766e+01 -1.0500000000000000e+01 2.9705900192260742e+01 -4.2679702758789062e+01 -8.4323501586914062e+01 3.6652198791503906e+01 -3.6886497497558594e+01 -8.3265602111816406e+01 3.7617401123046875e+01 -3.5763801574707031e+01 -9.8907402038574219e+01 2.3347700119018555e+01 -4.6463798522949219e+01 -1.0500000000000000e+01 2.0506500244140625e+01 -4.7785800933837891e+01 -1.0208599853515625e+02 2.0447601318359375e+01 -4.7642398834228516e+01 -1.0730899810791016e+02 1.5683000564575195e+01 -4.9578598022460938e+01 -1.0500000000000000e+01 1.0467500686645508e+01 -5.0935501098632812e+01 -1.1306200408935547e+02 1.0434200286865234e+01 -5.0788299560546875e+01 -1.1616899871826172e+02 7.6000699996948242e+00 -5.1441596984863281e+01 -1.0500000000000000e+01 0.0000000000000000e+00 -5.2000000000000000e+01 -1.0500000000000000e+01 -1.0467500686645508e+01 -5.0935501098632812e+01 -1.0500000000000000e+01 -2.0506500244140625e+01 -4.7785800933837891e+01 -1.0500000000000000e+01 -3.7689201354980469e+01 -3.5826297760009766e+01 -1.0500000000000000e+01 -2.9705900192260742e+01 -4.2679702758789062e+01 -1.0500000000000000e+01 -4.4129497528076172e+01 -2.7506099700927734e+01 -1.0500000000000000e+01 -4.8763099670410156e+01 -1.8059799194335938e+01 -1.0500000000000000e+01 -5.1400299072265625e+01 -7.8741898536682129e+00 -1.0500000000000000e+01 -5.1933200836181641e+01 2.6337499618530273e+00 -1.0500000000000000e+01 -5.0340000152587891e+01 1.3033900260925293e+01 -1.0500000000000000e+01 -4.6685798645019531e+01 2.2900499343872070e+01 -1.0500000000000000e+01 -4.1120296478271484e+01 3.1829498291015625e+01 -1.0500000000000000e+01 -3.3871299743652344e+01 3.9455398559570312e+01 -1.0500000000000000e+01 -2.5235601425170898e+01 4.5465999603271484e+01 -1.0500000000000000e+01 -1.5566900253295898e+01 4.9615200042724609e+01 -8.0000000000000000e+00 -1.0083699226379395e+01 -4.7440101623535156e+01 -8.0000000000000000e+00 0.0000000000000000e+00 -4.8500000000000000e+01 -8.0000000000000000e+00 1.9726699829101562e+01 4.4306900024414062e+01 -8.0000000000000000e+00 1.0083699226379395e+01 4.7440101623535156e+01 -8.0000000000000000e+00 0.0000000000000000e+00 4.8500000000000000e+01 -8.0000000000000000e+00 -1.0083699226379395e+01 4.7440101623535156e+01 -8.0000000000000000e+00 -1.9726699829101562e+01 4.4306900024414062e+01 -8.0000000000000000e+00 -2.8507598876953125e+01 3.9237300872802734e+01 -8.0000000000000000e+00 -3.6042499542236328e+01 3.2452800750732422e+01 -8.0000000000000000e+00 -4.8234298706054688e+01 5.0696101188659668e+00 -8.0000000000000000e+00 -4.8234298706054688e+01 -5.0696101188659668e+00 -8.0000000000000000e+00 1.0083699226379395e+01 -4.7440101623535156e+01 -8.0000000000000000e+00 1.9726699829101562e+01 -4.4306900024414062e+01 -8.0000000000000000e+00 2.8507598876953125e+01 -3.9237300872802734e+01 -8.0000000000000000e+00 3.6042499542236328e+01 -3.2452800750732422e+01 -8.0000000000000000e+00 4.2002201080322266e+01 -2.4250000000000000e+01 -8.0000000000000000e+00 4.6126201629638672e+01 -1.4987299919128418e+01 -8.0000000000000000e+00 -4.2002201080322266e+01 2.4250000000000000e+01 -8.0000000000000000e+00 -4.6126201629638672e+01 1.4987299919128418e+01 -8.0000000000000000e+00 -4.6126201629638672e+01 -1.4987299919128418e+01 -8.0000000000000000e+00 -4.2002201080322266e+01 -2.4250000000000000e+01 -8.0000000000000000e+00 -3.6042499542236328e+01 -3.2452800750732422e+01 -8.0000000000000000e+00 4.8234298706054688e+01 -5.0696101188659668e+00 -8.0000000000000000e+00 4.8234298706054688e+01 5.0696101188659668e+00 -8.0000000000000000e+00 4.6126201629638672e+01 1.4987299919128418e+01 -8.0000000000000000e+00 4.2002201080322266e+01 2.4250000000000000e+01 -8.0000000000000000e+00 3.6042499542236328e+01 3.2452800750732422e+01 -8.0000000000000000e+00 2.8507598876953125e+01 3.9237300872802734e+01 -8.0000000000000000e+00 -2.8507598876953125e+01 -3.9237300872802734e+01 -8.0000000000000000e+00 -1.9726699829101562e+01 -4.4306900024414062e+01 -1.1594799804687500e+02 8.8181495666503906e+00 5.1306999206542969e+01 -7.2669799804687500e+01 5.4675003051757812e+01 7.1675200462341309e+00 -7.2678298950195312e+01 5.4674301147460938e+01 7.2023901939392090e+00 -7.2333702087402344e+01 5.3973400115966797e+01 7.1510100364685059e+00 -7.2803901672363281e+01 5.4664299011230469e+01 7.7207698822021484e+00 -7.4031303405761719e+01 5.2199901580810547e+01 1.4834400177001953e+01 -7.3921897888183594e+01 5.4575397491455078e+01 1.2336400032043457e+01 -7.1986495971679688e+01 5.4724899291992188e+01 -6.0483998060226440e-01 -7.2003501892089844e+01 5.4723697662353516e+01 4.2252601124346256e-03 -7.1833702087402344e+01 5.4496200561523438e+01 -6.0291200876235962e-01 -7.2088897705078125e+01 5.4717601776123047e+01 3.0659999847412109e+00 -7.2203102111816406e+01 5.4709197998046875e+01 3.8716199398040771e+00 -7.2513107299804688e+01 5.3785701751708984e+01 -8.3217000961303711e+00 -7.2957000732421875e+01 5.4652698516845703e+01 -8.3971605300903320e+00 -7.2828895568847656e+01 5.4662399291992188e+01 -7.7299499511718750e+00 -7.2322303771972656e+01 5.4700698852539062e+01 -5.0931000709533691e+00 -7.2214904785156250e+01 5.4708499908447266e+01 -3.8766300678253174e+00 -7.1972000122070312e+01 5.4725898742675781e+01 -1.1243199110031128e+00 -7.4369598388671875e+01 5.1847000122070312e+01 -1.5908300399780273e+01 -7.3140304565429688e+01 5.4638900756835938e+01 -9.3511295318603516e+00 -1.1665800476074219e+02 8.0856695175170898e+00 -5.1417900085449219e+01 -1.0782600402832031e+02 1.6168199539184570e+01 -4.9478900909423828e+01 -1.1641400146484375e+02 7.8417100906372070e+00 -5.1417900085449219e+01 -1.0833200073242188e+02 1.6674301147460938e+01 -4.9478900909423828e+01 -1.0046400451660156e+02 2.4795801162719727e+01 -4.6247299194335938e+01 -9.9704200744628906e+01 2.4035699844360352e+01 -4.6247299194335938e+01 -9.3270301818847656e+01 3.2230701446533203e+01 -4.1837299346923828e+01 -8.6937301635742188e+01 3.8786300659179688e+01 -3.6403896331787109e+01 -8.5713699340820312e+01 3.7562702178955078e+01 -3.6403896331787109e+01 -9.2269302368164062e+01 3.1229700088500977e+01 -4.1837299346923828e+01 -8.1615402221679688e+01 4.4306400299072266e+01 -3.0134799957275391e+01 -8.0193603515625000e+01 4.2884597778320312e+01 -3.0134799957275391e+01 -7.5819595336914062e+01 4.7091899871826172e+01 -2.3236099243164062e+01 -7.7408096313476562e+01 4.8680397033691406e+01 -2.3236099243164062e+01 -7.2652999877929688e+01 5.0130401611328125e+01 -1.5908300399780273e+01 -7.0714302062988281e+01 5.1986900329589844e+01 -8.3217000961303711e+00 -7.0003799438476562e+01 5.2666297912597656e+01 -6.0291200876235962e-01 -7.5336601257324219e+01 4.7555801391601562e+01 2.2299200057983398e+01 -7.2300102233886719e+01 5.0468696594238281e+01 1.4834400177001953e+01 -7.0526596069335938e+01 5.2166301727294922e+01 7.1510100364685059e+00 -7.6944198608398438e+01 4.9163402557373047e+01 2.2299200057983398e+01 -8.1060699462890625e+01 4.4882499694824219e+01 2.9351501464843750e+01 -7.9617500305175781e+01 4.3439300537109375e+01 2.9351501464843750e+01 -8.6320800781250000e+01 3.9425201416015625e+01 3.5773097991943359e+01 -8.5074798583984375e+01 3.8179199218750000e+01 3.5773097991943359e+01 -9.1589195251464844e+01 3.1887199401855469e+01 4.1350200653076172e+01 -9.2612800598144531e+01 3.2910800933837891e+01 4.1350200653076172e+01 -9.9780097961425781e+01 2.5502401351928711e+01 4.5893402099609375e+01 -9.8997596740722656e+01 2.4719900131225586e+01 4.5893402099609375e+01 -1.0710199737548828e+02 1.6869199752807617e+01 4.9249401092529297e+01 -1.0763099670410156e+02 1.7397600173950195e+01 4.9249401092529297e+01 -1.1568199920654297e+02 8.5519599914550781e+00 5.1306999206542969e+01 -7.2594299316406250e+01 5.4999900817871094e+01 -3.6018500328063965e+00 -7.2630599975585938e+01 5.4999900817871094e+01 -3.8277499675750732e+00 -1.7365699768066406e+02 5.4999900817871094e+01 1.5356100082397461e+01 -7.3241706848144531e+01 5.4999900817871094e+01 -7.6276597976684570e+00 -7.3245300292968750e+01 5.4999900817871094e+01 -7.6415500640869141e+00 -7.4636901855468750e+01 5.4999900817871094e+01 -1.3023699760437012e+01 -7.5258796691894531e+01 5.4999900817871094e+01 1.5084800720214844e+01 -7.3425498962402344e+01 5.4999900817871094e+01 8.4665403366088867e+00 -7.3273399353027344e+01 5.4999900817871094e+01 7.6238498687744141e+00 -7.2682296752929688e+01 5.4999900817871094e+01 4.3489298820495605e+00 -7.2644096374511719e+01 5.4999900817871094e+01 3.8235800266265869e+00 -7.2402702331542969e+01 5.4999900817871094e+01 4.9648201465606689e-01 -7.2425598144531250e+01 5.4999900817871094e+01 6.7934598773717880e-03 -8.9375305175781250e+01 5.4999900817871094e+01 3.7663002014160156e+01 -8.2537498474121094e+01 5.4999900817871094e+01 2.9856300354003906e+01 -7.7403701782226562e+01 5.4999900817871094e+01 2.0837100982666016e+01 -9.7639396667480469e+01 5.4999900817871094e+01 4.3940399169921875e+01 -1.6958000183105469e+02 5.4999900817871094e+01 2.4899799346923828e+01 -1.6367300415039062e+02 5.4999900817871094e+01 3.3432201385498047e+01 -1.5617500305175781e+02 5.4999900817871094e+01 4.0607200622558594e+01 -1.4739100646972656e+02 5.4999900817871094e+01 4.6133201599121094e+01 -1.3767700195312500e+02 5.4999900817871094e+01 4.9785697937011719e+01 -1.2742799377441406e+02 5.4999900817871094e+01 5.1416698455810547e+01 -1.1705999755859375e+02 5.4999900817871094e+01 5.0959697723388672e+01 -1.0699400329589844e+02 5.4999900817871094e+01 4.8433399200439453e+01 -1.6367300415039062e+02 5.4999900817871094e+01 -3.3432201385498047e+01 -7.7403701782226562e+01 5.4999900817871094e+01 -2.0837100982666016e+01 -1.5617500305175781e+02 5.4999900817871094e+01 -4.0607200622558594e+01 -8.2537498474121094e+01 5.4999900817871094e+01 -2.9856300354003906e+01 -8.9375305175781250e+01 5.4999900817871094e+01 -3.7663002014160156e+01 -1.6958000183105469e+02 5.4999900817871094e+01 -2.4899799346923828e+01 -1.7365699768066406e+02 5.4999900817871094e+01 -1.5356100082397461e+01 -1.7573800659179688e+02 5.4999900817871094e+01 -5.1889400482177734e+00 -7.5258796691894531e+01 5.4999900817871094e+01 -1.5084800720214844e+01 -1.7573800659179688e+02 5.4999900817871094e+01 5.1889400482177734e+00 -1.2742799377441406e+02 5.4999900817871094e+01 -5.1416698455810547e+01 -1.3767700195312500e+02 5.4999900817871094e+01 -4.9785697937011719e+01 -1.1705999755859375e+02 5.4999900817871094e+01 -5.0959697723388672e+01 -1.0699400329589844e+02 5.4999900817871094e+01 -4.8433399200439453e+01 -9.7639396667480469e+01 5.4999900817871094e+01 -4.3940399169921875e+01 -1.4739100646972656e+02 5.4999900817871094e+01 -4.6133201599121094e+01 -1.0000000000000000e+01 5.2101597785949707e+00 5.1235698699951172e+01 -1.0000000000000000e+01 0.0000000000000000e+00 5.1500000000000000e+01 -1.0000000000000000e+01 0.0000000000000000e+00 4.8500000000000000e+01 -1.0000000000000000e+01 -5.2101597785949707e+00 5.1235698699951172e+01 -1.0000000000000000e+01 -1.0083699226379395e+01 4.7440101623535156e+01 -1.0000000000000000e+01 -1.5417199134826660e+01 4.9138099670410156e+01 -1.0000000000000000e+01 -1.9726699829101562e+01 4.4306900024414062e+01 -1.0000000000000000e+01 -2.4993000030517578e+01 4.5028797149658203e+01 -1.0000000000000000e+01 -2.8507598876953125e+01 3.9237300872802734e+01 -1.0000000000000000e+01 -3.3545700073242188e+01 3.9076000213623047e+01 -1.0000000000000000e+01 -3.6042499542236328e+01 3.2452800750732422e+01 -1.0000000000000000e+01 -4.0724899291992188e+01 3.1523399353027344e+01 -1.0000000000000000e+01 -4.2002201080322266e+01 2.4250000000000000e+01 -1.0000000000000000e+01 -4.6236900329589844e+01 2.2680299758911133e+01 -1.0000000000000000e+01 -4.6126201629638672e+01 1.4987299919128418e+01 -1.0000000000000000e+01 -4.9855899810791016e+01 1.2908599853515625e+01 -1.0000000000000000e+01 -4.8234298706054688e+01 5.0696101188659668e+00 -1.0000000000000000e+01 -5.1433898925781250e+01 2.6084201335906982e+00 -1.0000000000000000e+01 -4.8234298706054688e+01 -5.0696101188659668e+00 -1.0000000000000000e+01 -5.0906101226806641e+01 -7.7984900474548340e+00 -1.0000000000000000e+01 -4.6126201629638672e+01 -1.4987299919128418e+01 -1.0000000000000000e+01 -4.8294200897216797e+01 -1.7886201858520508e+01 -1.0000000000000000e+01 -4.2002201080322266e+01 -2.4250000000000000e+01 -1.0000000000000000e+01 -4.3705200195312500e+01 -2.7241600036621094e+01 -1.0000000000000000e+01 -3.6042499542236328e+01 -3.2452800750732422e+01 -1.0000000000000000e+01 -3.7326801300048828e+01 -3.5481800079345703e+01 -1.0000000000000000e+01 -2.8507598876953125e+01 -3.9237300872802734e+01 -1.0000000000000000e+01 -2.9420299530029297e+01 -4.2269302368164062e+01 -1.0000000000000000e+01 -1.9726699829101562e+01 -4.4306900024414062e+01 -1.0000000000000000e+01 -2.0309299468994141e+01 -4.7326301574707031e+01 -1.0000000000000000e+01 -1.0083699226379395e+01 -4.7440101623535156e+01 -1.0000000000000000e+01 -1.0366800308227539e+01 -5.0445796966552734e+01 -1.0000000000000000e+01 0.0000000000000000e+00 -4.8500000000000000e+01 -1.0000000000000000e+01 0.0000000000000000e+00 -5.1500000000000000e+01 -1.0000000000000000e+01 1.0083699226379395e+01 -4.7440101623535156e+01 -1.0000000000000000e+01 1.0366800308227539e+01 -5.0445796966552734e+01 -1.0000000000000000e+01 1.9726699829101562e+01 -4.4306900024414062e+01 -1.0000000000000000e+01 2.0309299468994141e+01 -4.7326301574707031e+01 -1.0000000000000000e+01 2.8507598876953125e+01 -3.9237300872802734e+01 -1.0000000000000000e+01 2.9420299530029297e+01 -4.2269302368164062e+01 -1.0000000000000000e+01 3.6042499542236328e+01 -3.2452800750732422e+01 -1.0000000000000000e+01 3.7326801300048828e+01 -3.5481800079345703e+01 -1.0000000000000000e+01 4.2002201080322266e+01 -2.4250000000000000e+01 -1.0000000000000000e+01 4.3705200195312500e+01 -2.7241600036621094e+01 -1.0000000000000000e+01 4.6126201629638672e+01 -1.4987299919128418e+01 -1.0000000000000000e+01 4.8294200897216797e+01 -1.7886201858520508e+01 -1.0000000000000000e+01 4.8234298706054688e+01 -5.0696101188659668e+00 -1.0000000000000000e+01 5.0906101226806641e+01 -7.7984900474548340e+00 -1.0000000000000000e+01 4.8234298706054688e+01 5.0696101188659668e+00 -1.0000000000000000e+01 5.1433898925781250e+01 2.6084201335906982e+00 -1.0000000000000000e+01 4.6126201629638672e+01 1.4987299919128418e+01 -1.0000000000000000e+01 4.9855899810791016e+01 1.2908599853515625e+01 -1.0000000000000000e+01 4.2002201080322266e+01 2.4250000000000000e+01 -1.0000000000000000e+01 4.6236900329589844e+01 2.2680299758911133e+01 -1.0000000000000000e+01 3.6042499542236328e+01 3.2452800750732422e+01 -1.0000000000000000e+01 4.0724899291992188e+01 3.1523399353027344e+01 -1.0000000000000000e+01 2.8507598876953125e+01 3.9237300872802734e+01 -1.0000000000000000e+01 3.3545700073242188e+01 3.9076000213623047e+01 -1.0000000000000000e+01 1.9726699829101562e+01 4.4306900024414062e+01 -1.0000000000000000e+01 2.4993000030517578e+01 4.5028797149658203e+01 -1.0000000000000000e+01 1.0083699226379395e+01 4.7440101623535156e+01 -1.0000000000000000e+01 1.5417199134826660e+01 4.9138099670410156e+01 -7.0056106567382812e+01 -5.2499900817871094e+01 2.9187200069427490e+00 -7.0728599548339844e+01 -5.2499900817871094e+01 5.5616497993469238e+00 -7.4564201354980469e+01 -5.2499900817871094e+01 2.5324199199676514e+00 -7.9609794616699219e+01 -5.2499900817871094e+01 2.2019699096679688e+01 -7.6096199035644531e+01 -5.2499900817871094e+01 1.2532600402832031e+01 -7.5129699707031250e+01 -5.2499900817871094e+01 1.6053098678588867e+01 -7.5076599121093750e+01 -5.2499900817871094e+01 -7.5713400840759277e+00 -7.2305801391601562e+01 -5.2499900817871094e+01 -9.9526004791259766e+00 -7.0687599182128906e+01 -5.2499900817871094e+01 -5.5443596839904785e+00 -7.0004402160644531e+01 -5.2499900817871094e+01 -2.6107399463653564e+00 -6.9796005249023438e+01 -5.2499900817871094e+01 -6.6837500780820847e-03 -7.0891502380371094e+01 -5.2499900817871094e+01 6.2020998001098633e+00 -7.2538505554199219e+01 -5.2499900817871094e+01 1.0496500015258789e+01 -7.2697898864746094e+01 -5.2499900817871094e+01 1.0838399887084961e+01 -7.0048599243164062e+01 -5.2499900817871094e+01 -2.8005800247192383e+00 -6.9791397094726562e+01 -5.2499900817871094e+01 5.0436701625585556e-02 -7.0047805786132812e+01 -5.2499900817871094e+01 2.8291299343109131e+00 -7.5400802612304688e+01 -5.2499900817871094e+01 -1.6612499237060547e+01 -7.5100402832031250e+01 -5.2499900817871094e+01 -1.5992899894714355e+01 -7.7612396240234375e+01 -5.2499900817871094e+01 -1.7365200042724609e+01 -7.5048606872558594e+01 -5.2499900817871094e+01 -1.5885800361633301e+01 -7.2714401245117188e+01 -5.2499900817871094e+01 -1.0836400032043457e+01 -7.7517601013183594e+01 -5.2499900817871094e+01 2.1092599868774414e+01 -8.0565200805664062e+01 -5.2499900817871094e+01 2.6869800567626953e+01 -8.4961303710937500e+01 -5.2499900817871094e+01 3.0605199813842773e+01 -8.6759498596191406e+01 -5.2499900817871094e+01 3.5041500091552734e+01 -9.1931404113769531e+01 -5.2499900817871094e+01 3.7937896728515625e+01 -9.4449996948242188e+01 -5.2499900817871094e+01 4.1824001312255859e+01 -1.0023500061035156e+02 -5.2499900817871094e+01 4.3717300415039062e+01 -1.0333200073242188e+02 -5.2499900817871094e+01 4.6948398590087891e+01 -1.0953199768066406e+02 -5.2499900817871094e+01 4.7707000732421875e+01 -1.1305300140380859e+02 -5.2499900817871094e+01 5.0211601257324219e+01 -1.1944200134277344e+02 -5.2499900817871094e+01 4.9743400573730469e+01 -1.2322799682617188e+02 -5.2499900817871094e+01 5.1484199523925781e+01 -1.2955799865722656e+02 -5.2499900817871094e+01 4.9743400573730469e+01 -1.3345300292968750e+02 -5.2499900817871094e+01 5.0715900421142578e+01 -1.3946800231933594e+02 -5.2499900817871094e+01 4.7707000732421875e+01 -1.4332299804687500e+02 -5.2499900817871094e+01 4.7936801910400391e+01 -1.4876499938964844e+02 -5.2499900817871094e+01 4.3717300415039062e+01 -1.5244700622558594e+02 -5.2499900817871094e+01 4.3257400512695312e+01 -1.5706900024414062e+02 -5.2499900817871094e+01 3.7937896728515625e+01 -1.6046301269531250e+02 -5.2499900817871094e+01 3.6863098144531250e+01 -1.6403900146484375e+02 -5.2499900817871094e+01 3.0605199813842773e+01 -1.6705400085449219e+02 -5.2499900817871094e+01 2.9007398605346680e+01 -1.6938999938964844e+02 -5.2499900817871094e+01 2.2019699096679688e+01 -1.7195700073242188e+02 -5.2499900817871094e+01 2.0001699447631836e+01 -1.7290400695800781e+02 -5.2499900817871094e+01 1.2532600402832031e+01 -1.7497900390625000e+02 -5.2499900817871094e+01 1.0203100204467773e+01 -1.7443600463867188e+02 -5.2499900817871094e+01 2.5324199199676514e+00 -1.7600000000000000e+02 -5.2499900817871094e+01 0.0000000000000000e+00 -1.7392300415039062e+02 -5.2499900817871094e+01 -7.5713400840759277e+00 -1.7497900390625000e+02 -5.2499900817871094e+01 -1.0203100204467773e+01 -1.7138800048828125e+02 -5.2499900817871094e+01 -1.7365200042724609e+01 -1.7195700073242188e+02 -5.2499900817871094e+01 -2.0001699447631836e+01 -1.6693200683593750e+02 -5.2499900817871094e+01 -2.6448200225830078e+01 -1.6705400085449219e+02 -5.2499900817871094e+01 -2.9007398605346680e+01 -1.6074000549316406e+02 -5.2499900817871094e+01 -3.4448299407958984e+01 -1.6046301269531250e+02 -5.2499900817871094e+01 -3.6863098144531250e+01 -1.5306300354003906e+02 -5.2499900817871094e+01 -4.1038101196289062e+01 -1.5244700622558594e+02 -5.2499900817871094e+01 -4.3257400512695312e+01 -1.4421800231933594e+02 -5.2499900817871094e+01 -4.5947799682617188e+01 -1.4332299804687500e+02 -5.2499900817871094e+01 -4.7936801910400391e+01 -1.3456500244140625e+02 -5.2499900817871094e+01 -4.8976501464843750e+01 -1.3345300292968750e+02 -5.2499900817871094e+01 -5.0715900421142578e+01 -1.2450000000000000e+02 -5.2499900817871094e+01 -4.9999900817871094e+01 -1.2322799682617188e+02 -5.2499900817871094e+01 -5.1484199523925781e+01 -1.1443500518798828e+02 -5.2499900817871094e+01 -4.8976501464843750e+01 -1.1305300140380859e+02 -5.2499900817871094e+01 -5.0211601257324219e+01 -1.0478199768066406e+02 -5.2499900817871094e+01 -4.5947799682617188e+01 -1.0333200073242188e+02 -5.2499900817871094e+01 -4.6948398590087891e+01 -9.5936599731445312e+01 -5.2499900817871094e+01 -4.1038101196289062e+01 -9.4449996948242188e+01 -5.2499900817871094e+01 -4.1824001312255859e+01 -8.8260398864746094e+01 -5.2499900817871094e+01 -3.4448299407958984e+01 -8.6759498596191406e+01 -5.2499900817871094e+01 -3.5041500091552734e+01 -8.2067802429199219e+01 -5.2499900817871094e+01 -2.6448200225830078e+01 -8.0565200805664062e+01 -5.2499900817871094e+01 -2.6869800567626953e+01 -7.7517601013183594e+01 -5.2499900817871094e+01 -2.1092599868774414e+01 -1.1639899444580078e+02 5.4999900817871094e+01 4.9846000671386719e+01 -1.0850799560546875e+02 5.4999900817871094e+01 4.7901100158691406e+01 -1.0851599884033203e+02 5.6388198852539062e+01 4.7878101348876953e+01 -1.2043800354003906e+02 5.6388198852539062e+01 5.0312000274658203e+01 -1.2450000000000000e+02 5.4999900817871094e+01 5.0500000000000000e+01 -1.1640299987792969e+02 5.6388198852539062e+01 4.9822097778320312e+01 -1.1241999816894531e+02 5.6388198852539062e+01 4.9008998870849609e+01 -1.0103199768066406e+02 5.4999900817871094e+01 4.4715499877929688e+01 -9.4162597656250000e+01 5.4999900817871094e+01 4.0371803283691406e+01 -9.4177093505859375e+01 5.6388198852539062e+01 4.0352500915527344e+01 -9.7522499084472656e+01 5.6388198852539062e+01 4.2661598205566406e+01 -1.0104299926757812e+02 5.6388198852539062e+01 4.4694099426269531e+01 -1.0471499633789062e+02 5.6388198852539062e+01 4.6436702728271484e+01 -8.8079299926757812e+01 5.4999900817871094e+01 3.4982601165771484e+01 -8.2939399719238281e+01 5.4999900817871094e+01 2.8687198638916016e+01 -8.2959304809570312e+01 5.6388198852539062e+01 2.8673500061035156e+01 -8.5401298522949219e+01 5.6388198852539062e+01 3.1923099517822266e+01 -8.8096794128417969e+01 5.6388198852539062e+01 3.4965702056884766e+01 -9.1028396606445312e+01 5.6388198852539062e+01 3.7781600952148438e+01 -7.8875801086425781e+01 5.4999900817871094e+01 2.1648900985717773e+01 -7.5993904113769531e+01 5.4999900817871094e+01 1.4049900054931641e+01 -7.6017097473144531e+01 5.6388198852539062e+01 1.4043199539184570e+01 -7.7304397583007812e+01 5.6388198852539062e+01 1.7898900985717773e+01 -7.8897697448730469e+01 5.6388198852539062e+01 2.1638599395751953e+01 -8.0786697387695312e+01 5.6388198852539062e+01 2.5237800598144531e+01 -7.4368202209472656e+01 5.4999900817871094e+01 6.0870599746704102e+00 -7.4041000366210938e+01 5.4999900817871094e+01 -2.0334098339080811e+00 -7.4065200805664062e+01 5.6388198852539062e+01 -2.0324001312255859e+00 -7.4065200805664062e+01 5.6388198852539062e+01 2.0324001312255859e+00 -7.4392295837402344e+01 5.6388198852539062e+01 6.0841398239135742e+00 -7.5044403076171875e+01 5.6388198852539062e+01 1.0096400260925293e+01 -7.5020599365234375e+01 5.4999900817871094e+01 -1.0101299285888672e+01 -7.7281700134277344e+01 5.4999900817871094e+01 -1.7907501220703125e+01 -7.7304397583007812e+01 5.6388198852539062e+01 -1.7898900985717773e+01 -7.6017097473144531e+01 5.6388198852539062e+01 -1.4043199539184570e+01 -7.5044403076171875e+01 5.6388198852539062e+01 -1.0096400260925293e+01 -7.4392295837402344e+01 5.6388198852539062e+01 -6.0841398239135742e+00 -8.0765800476074219e+01 5.4999900817871094e+01 -2.5250000000000000e+01 -8.5382499694824219e+01 5.4999900817871094e+01 -3.1938501358032227e+01 -8.5401298522949219e+01 5.6388198852539062e+01 -3.1923099517822266e+01 -8.2959304809570312e+01 5.6388198852539062e+01 -2.8673500061035156e+01 -8.0786697387695312e+01 5.6388198852539062e+01 -2.5237800598144531e+01 -7.8897697448730469e+01 5.6388198852539062e+01 -2.1638599395751953e+01 -9.1012298583984375e+01 5.4999900817871094e+01 -3.7799800872802734e+01 -9.7509506225585938e+01 5.4999900817871094e+01 -4.2681999206542969e+01 -9.7522499084472656e+01 5.6388198852539062e+01 -4.2661598205566406e+01 -9.4177093505859375e+01 5.6388198852539062e+01 -4.0352500915527344e+01 -9.1028396606445312e+01 5.6388198852539062e+01 -3.7781600952148438e+01 -8.8096794128417969e+01 5.6388198852539062e+01 -3.4965702056884766e+01 -1.0470599365234375e+02 5.4999900817871094e+01 -4.6458900451660156e+01 -1.1241500091552734e+02 5.4999900817871094e+01 -4.9032497406005859e+01 -1.1241999816894531e+02 5.6388198852539062e+01 -4.9008998870849609e+01 -1.0851599884033203e+02 5.6388198852539062e+01 -4.7878101348876953e+01 -1.0471499633789062e+02 5.6388198852539062e+01 -4.6436702728271484e+01 -1.0104299926757812e+02 5.6388198852539062e+01 -4.4694099426269531e+01 -1.2043599700927734e+02 5.4999900817871094e+01 -5.0336200714111328e+01 -1.2856399536132812e+02 5.4999900817871094e+01 -5.0336200714111328e+01 -1.2856199645996094e+02 5.6388198852539062e+01 -5.0312000274658203e+01 -1.2450000000000000e+02 5.6388198852539062e+01 -5.0475700378417969e+01 -1.2043800354003906e+02 5.6388198852539062e+01 -5.0312000274658203e+01 -1.1640299987792969e+02 5.6388198852539062e+01 -4.9822097778320312e+01 -1.3658499145507812e+02 5.4999900817871094e+01 -4.9032497406005859e+01 -1.4429399108886719e+02 5.4999900817871094e+01 -4.6458900451660156e+01 -1.4428498840332031e+02 5.6388198852539062e+01 -4.6436702728271484e+01 -1.4048400878906250e+02 5.6388198852539062e+01 -4.7878101348876953e+01 -1.3658000183105469e+02 5.6388198852539062e+01 -4.9008998870849609e+01 -1.3259700012207031e+02 5.6388198852539062e+01 -4.9822097778320312e+01 -1.5149000549316406e+02 5.4999900817871094e+01 -4.2681999206542969e+01 -1.5798799133300781e+02 5.4999900817871094e+01 -3.7799800872802734e+01 -1.5797200012207031e+02 5.6388198852539062e+01 -3.7781600952148438e+01 -1.5482299804687500e+02 5.6388198852539062e+01 -4.0352500915527344e+01 -1.5147801208496094e+02 5.6388198852539062e+01 -4.2661598205566406e+01 -1.4795700073242188e+02 5.6388198852539062e+01 -4.4694099426269531e+01 -1.6823400878906250e+02 5.4999900817871094e+01 -2.5250000000000000e+01 -1.6604100036621094e+02 5.6388198852539062e+01 -2.8673500061035156e+01 -1.6361799621582031e+02 5.4999900817871094e+01 -3.1938501358032227e+01 -1.6359899902343750e+02 5.6388198852539062e+01 -3.1923099517822266e+01 -1.6090299987792969e+02 5.6388198852539062e+01 -3.4965702056884766e+01 -1.7171800231933594e+02 5.4999900817871094e+01 -1.7907501220703125e+01 -1.7010200500488281e+02 5.6388198852539062e+01 -2.1638599395751953e+01 -1.6821299743652344e+02 5.6388198852539062e+01 -2.5237800598144531e+01 -1.7397900390625000e+02 5.4999900817871094e+01 -1.0101299285888672e+01 -1.7298300170898438e+02 5.6388198852539062e+01 -1.4043199539184570e+01 -1.7169601440429688e+02 5.6388198852539062e+01 -1.7898900985717773e+01 -1.7493499755859375e+02 5.6388198852539062e+01 2.0324001312255859e+00 -1.7493499755859375e+02 5.6388198852539062e+01 -2.0324001312255859e+00 -1.7495899963378906e+02 5.4999900817871094e+01 -2.0334098339080811e+00 -1.7460800170898438e+02 5.6388198852539062e+01 -6.0841398239135742e+00 -1.7395600891113281e+02 5.6388198852539062e+01 -1.0096400260925293e+01 -1.7460800170898438e+02 5.6388198852539062e+01 6.0841398239135742e+00 -1.7463200378417969e+02 5.4999900817871094e+01 6.0870599746704102e+00 -1.7395600891113281e+02 5.6388198852539062e+01 1.0096400260925293e+01 -1.7300599670410156e+02 5.4999900817871094e+01 1.4049900054931641e+01 -1.7298300170898438e+02 5.6388198852539062e+01 1.4043199539184570e+01 -1.7012399291992188e+02 5.4999900817871094e+01 2.1648900985717773e+01 -1.7010200500488281e+02 5.6388198852539062e+01 2.1638599395751953e+01 -1.7169601440429688e+02 5.6388198852539062e+01 1.7898900985717773e+01 -1.5797200012207031e+02 5.6388198852539062e+01 3.7781600952148438e+01 -1.6090299987792969e+02 5.6388198852539062e+01 3.4965702056884766e+01 -1.6092100524902344e+02 5.4999900817871094e+01 3.4982601165771484e+01 -1.6359899902343750e+02 5.6388198852539062e+01 3.1923099517822266e+01 -1.6606100463867188e+02 5.4999900817871094e+01 2.8687198638916016e+01 -1.6604100036621094e+02 5.6388198852539062e+01 2.8673500061035156e+01 -1.6821299743652344e+02 5.6388198852539062e+01 2.5237800598144531e+01 -1.5482299804687500e+02 5.6388198852539062e+01 4.0352500915527344e+01 -1.5483699035644531e+02 5.4999900817871094e+01 4.0371803283691406e+01 -1.5147801208496094e+02 5.6388198852539062e+01 4.2661598205566406e+01 -1.4796798706054688e+02 5.4999900817871094e+01 4.4715499877929688e+01 -1.4795700073242188e+02 5.6388198852539062e+01 4.4694099426269531e+01 -1.4049200439453125e+02 5.4999900817871094e+01 4.7901100158691406e+01 -1.4048400878906250e+02 5.6388198852539062e+01 4.7878101348876953e+01 -1.4428498840332031e+02 5.6388198852539062e+01 4.6436702728271484e+01 -1.2450000000000000e+02 5.6388198852539062e+01 5.0475700378417969e+01 -1.2856199645996094e+02 5.6388198852539062e+01 5.0312000274658203e+01 -1.3260099792480469e+02 5.4999900817871094e+01 4.9846000671386719e+01 -1.3259700012207031e+02 5.6388198852539062e+01 4.9822097778320312e+01 -1.3658000183105469e+02 5.6388198852539062e+01 4.9008998870849609e+01 -1.0022699737548828e+02 6.7000000000000000e+01 3.7152900695800781e+01 -9.7241699218750000e+01 6.7000000000000000e+01 3.5021499633789062e+01 -1.4562199401855469e+02 6.7000000000000000e+01 -3.9030399322509766e+01 -9.4442802429199219e+01 6.7000000000000000e+01 3.2650897979736328e+01 -9.1849105834960938e+01 6.7000000000000000e+01 3.0057199478149414e+01 -1.0337799835205078e+02 6.7000000000000000e+01 3.9030399322509766e+01 -1.4877299499511719e+02 6.7000000000000000e+01 -3.7152900695800781e+01 -1.5175799560546875e+02 6.7000000000000000e+01 -3.5021499633789062e+01 -1.5455700683593750e+02 6.7000000000000000e+01 -3.2650897979736328e+01 -1.5715100097656250e+02 6.7000000000000000e+01 -3.0057199478149414e+01 -1.5952099609375000e+02 6.7000000000000000e+01 -2.7258298873901367e+01 -1.6514100646972656e+02 6.7000000000000000e+01 -1.7826999664306641e+01 -1.6647499084472656e+02 6.7000000000000000e+01 -1.4409899711608887e+01 -1.6752099609375000e+02 6.7000000000000000e+01 -1.0894499778747559e+01 -1.6827400207519531e+02 6.7000000000000000e+01 -7.3045501708984375e+00 -8.9478500366210938e+01 6.7000000000000000e+01 2.7258298873901367e+01 -8.7347099304199219e+01 6.7000000000000000e+01 2.4273099899291992e+01 -8.5469604492187500e+01 6.7000000000000000e+01 2.1122200012207031e+01 -8.3858604431152344e+01 6.7000000000000000e+01 1.7826999664306641e+01 -8.2525299072265625e+01 6.7000000000000000e+01 1.4409899711608887e+01 -8.1478698730468750e+01 6.7000000000000000e+01 1.0894499778747559e+01 -8.1478698730468750e+01 6.7000000000000000e+01 -1.0894499778747559e+01 -8.2525299072265625e+01 6.7000000000000000e+01 -1.4409899711608887e+01 -8.7347099304199219e+01 6.7000000000000000e+01 -2.4273099899291992e+01 -8.9478500366210938e+01 6.7000000000000000e+01 -2.7258298873901367e+01 -9.1849105834960938e+01 6.7000000000000000e+01 -3.0057199478149414e+01 -9.4442802429199219e+01 6.7000000000000000e+01 -3.2650897979736328e+01 -9.7241699218750000e+01 6.7000000000000000e+01 -3.5021499633789062e+01 -1.0022699737548828e+02 6.7000000000000000e+01 -3.7152900695800781e+01 -1.4232699584960938e+02 6.7000000000000000e+01 -4.0641399383544922e+01 -1.6165299987792969e+02 6.7000000000000000e+01 -2.4273099899291992e+01 -1.6353001403808594e+02 6.7000000000000000e+01 -2.1122200012207031e+01 -1.6752099609375000e+02 6.7000000000000000e+01 1.0894499778747559e+01 -1.3539401245117188e+02 6.7000000000000000e+01 4.3021297454833984e+01 -1.3180500793457031e+02 6.7000000000000000e+01 4.3774002075195312e+01 -8.0725997924804688e+01 6.7000000000000000e+01 7.3045501708984375e+00 -8.0272300720214844e+01 6.7000000000000000e+01 3.6647899150848389e+00 -8.0120697021484375e+01 6.7000000000000000e+01 0.0000000000000000e+00 -8.3858604431152344e+01 6.7000000000000000e+01 -1.7826999664306641e+01 -8.5469604492187500e+01 6.7000000000000000e+01 -2.1122200012207031e+01 -1.6872799682617188e+02 6.7000000000000000e+01 -3.6647899150848389e+00 -1.6887899780273438e+02 6.7000000000000000e+01 0.0000000000000000e+00 -1.6872799682617188e+02 6.7000000000000000e+01 3.6647899150848389e+00 -1.0667300415039062e+02 6.7000000000000000e+01 -4.0641399383544922e+01 -1.1009000396728516e+02 6.7000000000000000e+01 -4.1974700927734375e+01 -1.3890998840332031e+02 6.7000000000000000e+01 -4.1974700927734375e+01 -1.6647499084472656e+02 6.7000000000000000e+01 1.4409899711608887e+01 -1.6514100646972656e+02 6.7000000000000000e+01 1.7826999664306641e+01 -1.6353001403808594e+02 6.7000000000000000e+01 2.1122200012207031e+01 -8.0272300720214844e+01 6.7000000000000000e+01 -3.6647899150848389e+00 -8.0725997924804688e+01 6.7000000000000000e+01 -7.3045501708984375e+00 -1.2816500854492188e+02 6.7000000000000000e+01 4.4227699279785156e+01 -1.2450000000000000e+02 6.7000000000000000e+01 4.4379302978515625e+01 -1.2083499908447266e+02 6.7000000000000000e+01 4.4227699279785156e+01 -1.0337799835205078e+02 6.7000000000000000e+01 -3.9030399322509766e+01 -1.1360599517822266e+02 6.7000000000000000e+01 -4.3021297454833984e+01 -1.1719499969482422e+02 6.7000000000000000e+01 -4.3774002075195312e+01 -1.3539401245117188e+02 6.7000000000000000e+01 -4.3021297454833984e+01 -1.2083499908447266e+02 6.7000000000000000e+01 -4.4227699279785156e+01 -1.2450000000000000e+02 6.7000000000000000e+01 -4.4379302978515625e+01 -1.2816500854492188e+02 6.7000000000000000e+01 -4.4227699279785156e+01 -1.3180500793457031e+02 6.7000000000000000e+01 -4.3774002075195312e+01 -1.6165299987792969e+02 6.7000000000000000e+01 2.4273099899291992e+01 -1.5952099609375000e+02 6.7000000000000000e+01 2.7258298873901367e+01 -1.5715100097656250e+02 6.7000000000000000e+01 3.0057199478149414e+01 -1.5455700683593750e+02 6.7000000000000000e+01 3.2650897979736328e+01 -1.5175799560546875e+02 6.7000000000000000e+01 3.5021499633789062e+01 -1.4877299499511719e+02 6.7000000000000000e+01 3.7152900695800781e+01 -1.4562199401855469e+02 6.7000000000000000e+01 3.9030399322509766e+01 -1.4232699584960938e+02 6.7000000000000000e+01 4.0641399383544922e+01 -1.3890998840332031e+02 6.7000000000000000e+01 4.1974700927734375e+01 -1.1719499969482422e+02 6.7000000000000000e+01 4.3774002075195312e+01 -1.1360599517822266e+02 6.7000000000000000e+01 4.3021297454833984e+01 -1.1009000396728516e+02 6.7000000000000000e+01 4.1974700927734375e+01 -1.6827400207519531e+02 6.7000000000000000e+01 7.3045501708984375e+00 -1.0667300415039062e+02 6.7000000000000000e+01 4.0641399383544922e+01 -1.2838900756835938e+02 6.5267898559570312e+01 -4.6937301635742188e+01 -1.3247700500488281e+02 5.9629501342773438e+01 -4.9083499908447266e+01 -1.3225199890136719e+02 6.5267898559570312e+01 -4.6455902099609375e+01 -1.3268299865722656e+02 5.9629501342773438e+01 -4.9041301727294922e+01 -1.3606199645996094e+02 6.5267898559570312e+01 -4.5657001495361328e+01 -1.4341899108886719e+02 6.5267898559570312e+01 -4.3131298065185547e+01 -1.4760899353027344e+02 5.9629501342773438e+01 -4.4031398773193359e+01 -1.4691600036621094e+02 6.5267898559570312e+01 -4.1421600341796875e+01 -1.4815699768066406e+02 5.9629501342773438e+01 -4.3715396881103516e+01 -1.5025999450683594e+02 6.5267898559570312e+01 -3.9429100036621094e+01 -1.3640100097656250e+02 5.9629501342773438e+01 -4.8282398223876953e+01 -1.4024700927734375e+02 5.9629501342773438e+01 -4.7168300628662109e+01 -1.3979299926757812e+02 6.5267898559570312e+01 -4.4546298980712891e+01 -1.4064100646972656e+02 5.9629501342773438e+01 -4.7018798828125000e+01 -1.4399099731445312e+02 5.9629501342773438e+01 -4.5748199462890625e+01 -1.5639900207519531e+02 6.5267898559570312e+01 -3.4651302337646484e+01 -1.6036399841308594e+02 5.9629501342773438e+01 -3.4447402954101562e+01 -1.5915100097656250e+02 6.5267898559570312e+01 -3.1898698806762695e+01 -1.6106199645996094e+02 5.9629501342773438e+01 -3.3658699035644531e+01 -1.6166700744628906e+02 6.5267898559570312e+01 -2.8928300857543945e+01 -1.5107800292968750e+02 5.9629501342773438e+01 -4.2029102325439453e+01 -1.5437300109863281e+02 5.9629501342773438e+01 -3.9754199981689453e+01 -1.5342800903320312e+02 6.5267898559570312e+01 -3.7167098999023438e+01 -1.5502600097656250e+02 5.9629501342773438e+01 -3.9221202850341797e+01 -1.5747499084472656e+02 5.9629501342773438e+01 -3.7221500396728516e+01 -1.6592199707031250e+02 6.5267898559570312e+01 -2.2416299819946289e+01 -1.6942599487304688e+02 5.9629501342773438e+01 -2.1317800521850586e+01 -1.6763099670410156e+02 6.5267898559570312e+01 -1.8919099807739258e+01 -1.7000498962402344e+02 5.9629501342773438e+01 -1.9960601806640625e+01 -1.6904600524902344e+02 6.5267898559570312e+01 -1.5292799949645996e+01 -1.6301899719238281e+02 5.9629501342773438e+01 -3.1449899673461914e+01 -1.6542500305175781e+02 5.9629501342773438e+01 -2.8248399734497070e+01 -1.6392900085449219e+02 6.5267898559570312e+01 -2.5760299682617188e+01 -1.6610099792480469e+02 5.9629501342773438e+01 -2.7179599761962891e+01 -1.6756500244140625e+02 5.9629501342773438e+01 -2.4863698959350586e+01 -1.7386500549316406e+02 5.9629501342773438e+01 -5.9939599037170410e+00 -1.7143699645996094e+02 6.5267898559570312e+01 -3.8893198966979980e+00 -1.7095599365234375e+02 6.5267898559570312e+01 -7.7520599365234375e+00 -1.7099600219726562e+02 5.9629501342773438e+01 -1.7633499145507812e+01 -1.7226399230957031e+02 5.9629501342773438e+01 -1.3835000038146973e+01 -1.7015699768066406e+02 6.5267898559570312e+01 -1.1561900138854980e+01 -1.7266799926757812e+02 5.9629501342773438e+01 -1.2197899818420410e+01 -1.7322200012207031e+02 5.9629501342773438e+01 -9.9467601776123047e+00 -1.7401799011230469e+02 5.9629501342773438e+01 -4.1031799316406250e+00 -1.7418701171875000e+02 5.9629501342773438e+01 -2.0023000240325928e+00 -1.7159800720214844e+02 6.5267898559570312e+01 0.0000000000000000e+00 -1.7418701171875000e+02 5.9629501342773438e+01 2.0023000240325928e+00 -1.7143699645996094e+02 6.5267898559570312e+01 3.8893198966979980e+00 -1.7401799011230469e+02 5.9629501342773438e+01 4.1031799316406250e+00 -1.7386500549316406e+02 5.9629501342773438e+01 5.9939599037170410e+00 -1.7095599365234375e+02 6.5267898559570312e+01 7.7520599365234375e+00 -1.7322200012207031e+02 5.9629501342773438e+01 9.9467601776123047e+00 -1.7015699768066406e+02 6.5267898559570312e+01 1.1561900138854980e+01 -1.7266799926757812e+02 5.9629501342773438e+01 1.2197899818420410e+01 -1.7226399230957031e+02 5.9629501342773438e+01 1.3835000038146973e+01 -1.6904600524902344e+02 6.5267898559570312e+01 1.5292799949645996e+01 -1.7099600219726562e+02 5.9629501342773438e+01 1.7633499145507812e+01 -1.6763099670410156e+02 6.5267898559570312e+01 1.8919099807739258e+01 -1.7000498962402344e+02 5.9629501342773438e+01 1.9960601806640625e+01 -1.6942599487304688e+02 5.9629501342773438e+01 2.1317800521850586e+01 -1.6592199707031250e+02 6.5267898559570312e+01 2.2416299819946289e+01 -1.6756500244140625e+02 5.9629501342773438e+01 2.4863698959350586e+01 -1.6392900085449219e+02 6.5267898559570312e+01 2.5760299682617188e+01 -1.6610099792480469e+02 5.9629501342773438e+01 2.7179599761962891e+01 -1.6542500305175781e+02 5.9629501342773438e+01 2.8248399734497070e+01 -1.6166700744628906e+02 6.5267898559570312e+01 2.8928300857543945e+01 -1.6301899719238281e+02 5.9629501342773438e+01 3.1449899673461914e+01 -1.5915100097656250e+02 6.5267898559570312e+01 3.1898698806762695e+01 -1.6106199645996094e+02 5.9629501342773438e+01 3.3658699035644531e+01 -1.6036399841308594e+02 5.9629501342773438e+01 3.4447402954101562e+01 -1.5639900207519531e+02 6.5267898559570312e+01 3.4651302337646484e+01 -1.5747499084472656e+02 5.9629501342773438e+01 3.7221500396728516e+01 -1.5342800903320312e+02 6.5267898559570312e+01 3.7167098999023438e+01 -1.5502600097656250e+02 5.9629501342773438e+01 3.9221202850341797e+01 -1.5437300109863281e+02 5.9629501342773438e+01 3.9754199981689453e+01 -1.5025999450683594e+02 6.5267898559570312e+01 3.9429100036621094e+01 -1.5107800292968750e+02 5.9629501342773438e+01 4.2029102325439453e+01 -1.4691600036621094e+02 6.5267898559570312e+01 4.1421600341796875e+01 -1.4815699768066406e+02 5.9629501342773438e+01 4.3715396881103516e+01 -1.4760899353027344e+02 5.9629501342773438e+01 4.4031398773193359e+01 -1.4341899108886719e+02 6.5267898559570312e+01 4.3131298065185547e+01 -1.4399099731445312e+02 5.9629501342773438e+01 4.5748199462890625e+01 -1.3979299926757812e+02 6.5267898559570312e+01 4.4546298980712891e+01 -1.4064100646972656e+02 5.9629501342773438e+01 4.7018798828125000e+01 -1.4024700927734375e+02 5.9629501342773438e+01 4.7168300628662109e+01 -1.3606199645996094e+02 6.5267898559570312e+01 4.5657001495361328e+01 -1.3640100097656250e+02 5.9629501342773438e+01 4.8282398223876953e+01 -1.3225199890136719e+02 6.5267898559570312e+01 4.6455902099609375e+01 -1.2061100006103516e+02 6.5267898559570312e+01 4.6937301635742188e+01 -1.1652299499511719e+02 5.9629501342773438e+01 4.9083499908447266e+01 -1.1674800109863281e+02 6.5267898559570312e+01 4.6455902099609375e+01 -1.1631699371337891e+02 5.9629501342773438e+01 4.9041301727294922e+01 -1.1293800354003906e+02 6.5267898559570312e+01 4.5657001495361328e+01 -1.3268299865722656e+02 5.9629501342773438e+01 4.9041301727294922e+01 -1.3247700500488281e+02 5.9629501342773438e+01 4.9083499908447266e+01 -1.2838900756835938e+02 6.5267898559570312e+01 4.6937301635742188e+01 -1.2850099182128906e+02 5.9629501342773438e+01 4.9566101074218750e+01 -1.2450000000000000e+02 6.5267898559570312e+01 4.7098201751708984e+01 -1.2450000000000000e+02 5.9629501342773438e+01 4.9727397918701172e+01 -1.2049900054931641e+02 5.9629501342773438e+01 4.9566101074218750e+01 -1.0558100128173828e+02 6.5267898559570312e+01 4.3131298065185547e+01 -1.0139099884033203e+02 5.9629501342773438e+01 4.4031398773193359e+01 -1.0208399963378906e+02 6.5267898559570312e+01 4.1421600341796875e+01 -1.0084299468994141e+02 5.9629501342773438e+01 4.3715396881103516e+01 -9.8739700317382812e+01 6.5267898559570312e+01 3.9429100036621094e+01 -1.1259899902343750e+02 5.9629501342773438e+01 4.8282398223876953e+01 -1.0875300598144531e+02 5.9629501342773438e+01 4.7168300628662109e+01 -1.0920699310302734e+02 6.5267898559570312e+01 4.4546298980712891e+01 -1.0835900115966797e+02 5.9629501342773438e+01 4.7018798828125000e+01 -1.0500899505615234e+02 5.9629501342773438e+01 4.5748199462890625e+01 -9.2601303100585938e+01 6.5267898559570312e+01 3.4651302337646484e+01 -8.8636505126953125e+01 5.9629501342773438e+01 3.4447402954101562e+01 -8.9848693847656250e+01 6.5267898559570312e+01 3.1898698806762695e+01 -8.7937698364257812e+01 5.9629501342773438e+01 3.3658699035644531e+01 -8.7332893371582031e+01 6.5267898559570312e+01 2.8928300857543945e+01 -9.7922401428222656e+01 5.9629501342773438e+01 4.2029102325439453e+01 -9.4626594543457031e+01 5.9629501342773438e+01 3.9754199981689453e+01 -9.5571693420410156e+01 6.5267898559570312e+01 3.7167098999023438e+01 -9.3973701477050781e+01 5.9629501342773438e+01 3.9221202850341797e+01 -9.1524597167968750e+01 5.9629501342773438e+01 3.7221500396728516e+01 -8.3078399658203125e+01 6.5267898559570312e+01 2.2416299819946289e+01 -7.9573699951171875e+01 5.9629501342773438e+01 2.1317800521850586e+01 -8.1368698120117188e+01 6.5267898559570312e+01 1.8919099807739258e+01 -7.8995506286621094e+01 5.9629501342773438e+01 1.9960601806640625e+01 -7.9953697204589844e+01 6.5267898559570312e+01 1.5292799949645996e+01 -8.5980895996093750e+01 5.9629501342773438e+01 3.1449899673461914e+01 -8.3575195312500000e+01 5.9629501342773438e+01 2.8248399734497070e+01 -8.5070899963378906e+01 6.5267898559570312e+01 2.5760299682617188e+01 -8.2899398803710938e+01 5.9629501342773438e+01 2.7179599761962891e+01 -8.1434799194335938e+01 5.9629501342773438e+01 2.4863698959350586e+01 -7.5135093688964844e+01 5.9629501342773438e+01 5.9939599037170410e+00 -7.7562698364257812e+01 6.5267898559570312e+01 3.8893198966979980e+00 -7.8044097900390625e+01 6.5267898559570312e+01 7.7520599365234375e+00 -7.8004005432128906e+01 5.9629501342773438e+01 1.7633499145507812e+01 -7.6735900878906250e+01 5.9629501342773438e+01 1.3835000038146973e+01 -7.8842994689941406e+01 6.5267898559570312e+01 1.1561900138854980e+01 -7.6332397460937500e+01 5.9629501342773438e+01 1.2197899818420410e+01 -7.5777595520019531e+01 5.9629501342773438e+01 9.9467601776123047e+00 -7.4982498168945312e+01 5.9629501342773438e+01 4.1031799316406250e+00 -7.4812896728515625e+01 5.9629501342773438e+01 2.0023000240325928e+00 -7.7401802062988281e+01 6.5267898559570312e+01 0.0000000000000000e+00 -7.4812896728515625e+01 5.9629501342773438e+01 -2.0023000240325928e+00 -7.7562698364257812e+01 6.5267898559570312e+01 -3.8893198966979980e+00 -7.4982498168945312e+01 5.9629501342773438e+01 -4.1031799316406250e+00 -7.5135093688964844e+01 5.9629501342773438e+01 -5.9939599037170410e+00 -7.8044097900390625e+01 6.5267898559570312e+01 -7.7520599365234375e+00 -7.5777595520019531e+01 5.9629501342773438e+01 -9.9467601776123047e+00 -7.8842994689941406e+01 6.5267898559570312e+01 -1.1561900138854980e+01 -7.6332397460937500e+01 5.9629501342773438e+01 -1.2197899818420410e+01 -7.6735900878906250e+01 5.9629501342773438e+01 -1.3835000038146973e+01 -7.9953697204589844e+01 6.5267898559570312e+01 -1.5292799949645996e+01 -7.8004005432128906e+01 5.9629501342773438e+01 -1.7633499145507812e+01 -8.1368698120117188e+01 6.5267898559570312e+01 -1.8919099807739258e+01 -7.8995506286621094e+01 5.9629501342773438e+01 -1.9960601806640625e+01 -7.9573699951171875e+01 5.9629501342773438e+01 -2.1317800521850586e+01 -8.3078399658203125e+01 6.5267898559570312e+01 -2.2416299819946289e+01 -8.1434799194335938e+01 5.9629501342773438e+01 -2.4863698959350586e+01 -8.5070899963378906e+01 6.5267898559570312e+01 -2.5760299682617188e+01 -8.2899398803710938e+01 5.9629501342773438e+01 -2.7179599761962891e+01 -8.3575195312500000e+01 5.9629501342773438e+01 -2.8248399734497070e+01 -8.7332893371582031e+01 6.5267898559570312e+01 -2.8928300857543945e+01 -8.5980895996093750e+01 5.9629501342773438e+01 -3.1449899673461914e+01 -8.9848693847656250e+01 6.5267898559570312e+01 -3.1898698806762695e+01 -8.7937698364257812e+01 5.9629501342773438e+01 -3.3658699035644531e+01 -8.8636505126953125e+01 5.9629501342773438e+01 -3.4447402954101562e+01 -9.2601303100585938e+01 6.5267898559570312e+01 -3.4651302337646484e+01 -9.1524597167968750e+01 5.9629501342773438e+01 -3.7221500396728516e+01 -9.5571693420410156e+01 6.5267898559570312e+01 -3.7167098999023438e+01 -9.3973701477050781e+01 5.9629501342773438e+01 -3.9221202850341797e+01 -9.4626594543457031e+01 5.9629501342773438e+01 -3.9754199981689453e+01 -9.8739700317382812e+01 6.5267898559570312e+01 -3.9429100036621094e+01 -9.7922401428222656e+01 5.9629501342773438e+01 -4.2029102325439453e+01 -1.0208399963378906e+02 6.5267898559570312e+01 -4.1421600341796875e+01 -1.0084299468994141e+02 5.9629501342773438e+01 -4.3715396881103516e+01 -1.0139099884033203e+02 5.9629501342773438e+01 -4.4031398773193359e+01 -1.0558100128173828e+02 6.5267898559570312e+01 -4.3131298065185547e+01 -1.0500899505615234e+02 5.9629501342773438e+01 -4.5748199462890625e+01 -1.0920699310302734e+02 6.5267898559570312e+01 -4.4546298980712891e+01 -1.0835900115966797e+02 5.9629501342773438e+01 -4.7018798828125000e+01 -1.0875300598144531e+02 5.9629501342773438e+01 -4.7168300628662109e+01 -1.1293800354003906e+02 6.5267898559570312e+01 -4.5657001495361328e+01 -1.1259899902343750e+02 5.9629501342773438e+01 -4.8282398223876953e+01 -1.1674800109863281e+02 6.5267898559570312e+01 -4.6455902099609375e+01 -1.1631699371337891e+02 5.9629501342773438e+01 -4.9041301727294922e+01 -1.1652299499511719e+02 5.9629501342773438e+01 -4.9083499908447266e+01 -1.2061100006103516e+02 6.5267898559570312e+01 -4.6937301635742188e+01 -1.2049900054931641e+02 5.9629501342773438e+01 -4.9566101074218750e+01 -1.2450000000000000e+02 6.5267898559570312e+01 -4.7098201751708984e+01 -1.2450000000000000e+02 5.9629501342773438e+01 -4.9727397918701172e+01 -1.2850099182128906e+02 5.9629501342773438e+01 -4.9566101074218750e+01 -1.3653099060058594e+02 5.8048198699951172e+01 4.8811100006103516e+01 -1.4041999816894531e+02 5.8048198699951172e+01 4.7684700012207031e+01 -1.4420500183105469e+02 5.8048198699951172e+01 4.6249198913574219e+01 -1.4786300659179688e+02 5.8048198699951172e+01 4.4513603210449219e+01 -1.5136900329589844e+02 5.8048198699951172e+01 4.2489299774169922e+01 -1.5469999694824219e+02 5.8048198699951172e+01 4.0189502716064453e+01 -1.5783599853515625e+02 5.8048198699951172e+01 3.7629100799560547e+01 -1.6075601196289062e+02 5.8048198699951172e+01 3.4824600219726562e+01 -1.6344100952148438e+02 5.8048198699951172e+01 3.1794298171997070e+01 -1.6587300109863281e+02 5.8048198699951172e+01 2.8557699203491211e+01 -1.6803700256347656e+02 5.8048198699951172e+01 2.5135900497436523e+01 -1.6991799926757812e+02 5.8048198699951172e+01 2.1551198959350586e+01 -1.7150500488281250e+02 5.8048198699951172e+01 1.7826700210571289e+01 -1.7278700256347656e+02 5.8048198699951172e+01 1.3986499786376953e+01 -1.7375599670410156e+02 5.8048198699951172e+01 1.0055700302124023e+01 -1.7440499877929688e+02 5.8048198699951172e+01 6.0595898628234863e+00 -1.7473100280761719e+02 5.8048198699951172e+01 2.0242300033569336e+00 -1.7440499877929688e+02 5.8048198699951172e+01 -6.0595898628234863e+00 -1.7473100280761719e+02 5.8048198699951172e+01 -2.0242300033569336e+00 -1.7375599670410156e+02 5.8048198699951172e+01 -1.0055700302124023e+01 -1.7278700256347656e+02 5.8048198699951172e+01 -1.3986499786376953e+01 -1.6991799926757812e+02 5.8048198699951172e+01 -2.1551198959350586e+01 -1.7150500488281250e+02 5.8048198699951172e+01 -1.7826700210571289e+01 -1.6803700256347656e+02 5.8048198699951172e+01 -2.5135900497436523e+01 -1.6587300109863281e+02 5.8048198699951172e+01 -2.8557699203491211e+01 -1.6075601196289062e+02 5.8048198699951172e+01 -3.4824600219726562e+01 -1.6344100952148438e+02 5.8048198699951172e+01 -3.1794298171997070e+01 -1.5783599853515625e+02 5.8048198699951172e+01 -3.7629100799560547e+01 -1.5469999694824219e+02 5.8048198699951172e+01 -4.0189502716064453e+01 -1.5136900329589844e+02 5.8048198699951172e+01 -4.2489299774169922e+01 -1.4786300659179688e+02 5.8048198699951172e+01 -4.4513603210449219e+01 -1.4420500183105469e+02 5.8048198699951172e+01 -4.6249198913574219e+01 -1.4041999816894531e+02 5.8048198699951172e+01 -4.7684700012207031e+01 -1.3653099060058594e+02 5.8048198699951172e+01 -4.8811100006103516e+01 -1.3256399536132812e+02 5.8048198699951172e+01 -4.9620899200439453e+01 -1.2854499816894531e+02 5.8048198699951172e+01 -5.0108898162841797e+01 -1.2450000000000000e+02 5.8048198699951172e+01 -5.0271900177001953e+01 -1.2045499420166016e+02 5.8048198699951172e+01 -5.0108898162841797e+01 -1.1643599700927734e+02 5.8048198699951172e+01 -4.9620899200439453e+01 -1.1246900177001953e+02 5.8048198699951172e+01 -4.8811100006103516e+01 -1.0858000183105469e+02 5.8048198699951172e+01 -4.7684700012207031e+01 -1.0479499816894531e+02 5.8048198699951172e+01 -4.6249198913574219e+01 -1.0113700103759766e+02 5.8048198699951172e+01 -4.4513603210449219e+01 -9.7631401062011719e+01 5.8048198699951172e+01 -4.2489299774169922e+01 -9.4299499511718750e+01 5.8048198699951172e+01 -4.0189502716064453e+01 -9.1163497924804688e+01 5.8048198699951172e+01 -3.7629100799560547e+01 -8.8243797302246094e+01 5.8048198699951172e+01 -3.4824600219726562e+01 -8.5559196472167969e+01 5.8048198699951172e+01 -3.1794298171997070e+01 -8.3126998901367188e+01 5.8048198699951172e+01 -2.8557699203491211e+01 -8.0963203430175781e+01 5.8048198699951172e+01 -2.5135900497436523e+01 -7.9081802368164062e+01 5.8048198699951172e+01 -2.1551198959350586e+01 -7.7495002746582031e+01 5.8048198699951172e+01 -1.7826700210571289e+01 -7.6212898254394531e+01 5.8048198699951172e+01 -1.3986499786376953e+01 -7.5244003295898438e+01 5.8048198699951172e+01 -1.0055700302124023e+01 -7.4594696044921875e+01 5.8048198699951172e+01 -6.0595898628234863e+00 -7.4268806457519531e+01 5.8048198699951172e+01 -2.0242300033569336e+00 -7.4594696044921875e+01 5.8048198699951172e+01 6.0595898628234863e+00 -7.4268806457519531e+01 5.8048198699951172e+01 2.0242300033569336e+00 -7.5244003295898438e+01 5.8048198699951172e+01 1.0055700302124023e+01 -7.6212898254394531e+01 5.8048198699951172e+01 1.3986499786376953e+01 -7.9081802368164062e+01 5.8048198699951172e+01 2.1551198959350586e+01 -7.7495002746582031e+01 5.8048198699951172e+01 1.7826700210571289e+01 -8.0963203430175781e+01 5.8048198699951172e+01 2.5135900497436523e+01 -8.3126998901367188e+01 5.8048198699951172e+01 2.8557699203491211e+01 -8.8243797302246094e+01 5.8048198699951172e+01 3.4824600219726562e+01 -8.5559196472167969e+01 5.8048198699951172e+01 3.1794298171997070e+01 -9.1163497924804688e+01 5.8048198699951172e+01 3.7629100799560547e+01 -9.4299499511718750e+01 5.8048198699951172e+01 4.0189502716064453e+01 -9.7631401062011719e+01 5.8048198699951172e+01 4.2489299774169922e+01 -1.0113700103759766e+02 5.8048198699951172e+01 4.4513603210449219e+01 -1.0479499816894531e+02 5.8048198699951172e+01 4.6249198913574219e+01 -1.0858000183105469e+02 5.8048198699951172e+01 4.7684700012207031e+01 -1.1246900177001953e+02 5.8048198699951172e+01 4.8811100006103516e+01 -1.1643599700927734e+02 5.8048198699951172e+01 4.9620899200439453e+01 -1.2045499420166016e+02 5.8048198699951172e+01 5.0108898162841797e+01 -1.2450000000000000e+02 5.8048198699951172e+01 5.0271900177001953e+01 -1.2854499816894531e+02 5.8048198699951172e+01 5.0108898162841797e+01 -1.3256399536132812e+02 5.8048198699951172e+01 4.9620899200439453e+01 -1.2074399566650391e+02 6.6788002014160156e+01 4.5331501007080078e+01 -1.2450000000000000e+02 6.6788002014160156e+01 4.5486900329589844e+01 -1.2825599670410156e+02 6.6788002014160156e+01 4.5331501007080078e+01 -1.3198699951171875e+02 6.6788002014160156e+01 4.4866600036621094e+01 -1.3566600036621094e+02 6.6788002014160156e+01 4.4094997406005859e+01 -1.3926998901367188e+02 6.6788002014160156e+01 4.3022300720214844e+01 -1.4277200317382812e+02 6.6788002014160156e+01 4.1655700683593750e+01 -1.4614900207519531e+02 6.6788002014160156e+01 4.0004600524902344e+01 -1.4937899780273438e+02 6.6788002014160156e+01 3.8080101013183594e+01 -1.5243899536132812e+02 6.6788002014160156e+01 3.5895599365234375e+01 -1.5530699157714844e+02 6.6788002014160156e+01 3.3465797424316406e+01 -1.5796600341796875e+02 6.6788002014160156e+01 3.0807399749755859e+01 -1.6039599609375000e+02 6.6788002014160156e+01 2.7938699722290039e+01 -1.6258000183105469e+02 6.6788002014160156e+01 2.4878999710083008e+01 -1.6450500488281250e+02 6.6788002014160156e+01 2.1649400711059570e+01 -1.6615599060058594e+02 6.6788002014160156e+01 1.8271900177001953e+01 -1.6752200317382812e+02 6.6788002014160156e+01 1.4769499778747559e+01 -1.6859500122070312e+02 6.6788002014160156e+01 1.1166299819946289e+01 -1.6936700439453125e+02 6.6788002014160156e+01 7.4868798255920410e+00 -1.6983200073242188e+02 6.6788002014160156e+01 3.7562201023101807e+00 -1.6998699951171875e+02 6.6788002014160156e+01 0.0000000000000000e+00 -1.6983200073242188e+02 6.6788002014160156e+01 -3.7562201023101807e+00 -1.6936700439453125e+02 6.6788002014160156e+01 -7.4868798255920410e+00 -1.6859500122070312e+02 6.6788002014160156e+01 -1.1166299819946289e+01 -1.6752200317382812e+02 6.6788002014160156e+01 -1.4769499778747559e+01 -1.6615599060058594e+02 6.6788002014160156e+01 -1.8271900177001953e+01 -1.6450500488281250e+02 6.6788002014160156e+01 -2.1649400711059570e+01 -1.6258000183105469e+02 6.6788002014160156e+01 -2.4878999710083008e+01 -1.6039599609375000e+02 6.6788002014160156e+01 -2.7938699722290039e+01 -1.5796600341796875e+02 6.6788002014160156e+01 -3.0807399749755859e+01 -1.5530699157714844e+02 6.6788002014160156e+01 -3.3465797424316406e+01 -1.5243899536132812e+02 6.6788002014160156e+01 -3.5895599365234375e+01 -1.4937899780273438e+02 6.6788002014160156e+01 -3.8080101013183594e+01 -1.4614900207519531e+02 6.6788002014160156e+01 -4.0004600524902344e+01 -1.4277200317382812e+02 6.6788002014160156e+01 -4.1655700683593750e+01 -1.3926998901367188e+02 6.6788002014160156e+01 -4.3022300720214844e+01 -1.3566600036621094e+02 6.6788002014160156e+01 -4.4094997406005859e+01 -1.3198699951171875e+02 6.6788002014160156e+01 -4.4866600036621094e+01 -1.2825599670410156e+02 6.6788002014160156e+01 -4.5331501007080078e+01 -1.2450000000000000e+02 6.6788002014160156e+01 -4.5486900329589844e+01 -1.2074399566650391e+02 6.6788002014160156e+01 -4.5331501007080078e+01 -1.1701300048828125e+02 6.6788002014160156e+01 -4.4866600036621094e+01 -1.1333399963378906e+02 6.6788002014160156e+01 -4.4094997406005859e+01 -1.0972999572753906e+02 6.6788002014160156e+01 -4.3022300720214844e+01 -1.0622800445556641e+02 6.6788002014160156e+01 -4.1655700683593750e+01 -1.0285100555419922e+02 6.6788002014160156e+01 -4.0004600524902344e+01 -9.9620994567871094e+01 6.6788002014160156e+01 -3.8080101013183594e+01 -9.6561294555664062e+01 6.6788002014160156e+01 -3.5895599365234375e+01 -9.3692604064941406e+01 6.6788002014160156e+01 -3.3465797424316406e+01 -9.1034194946289062e+01 6.6788002014160156e+01 -3.0807399749755859e+01 -8.8604400634765625e+01 6.6788002014160156e+01 -2.7938699722290039e+01 -8.6419898986816406e+01 6.6788002014160156e+01 -2.4878999710083008e+01 -8.4495399475097656e+01 6.6788002014160156e+01 -2.1649400711059570e+01 -8.2844299316406250e+01 6.6788002014160156e+01 -1.8271900177001953e+01 -8.1477699279785156e+01 6.6788002014160156e+01 -1.4769499778747559e+01 -8.0404998779296875e+01 6.6788002014160156e+01 -1.1166299819946289e+01 -7.9633399963378906e+01 6.6788002014160156e+01 -7.4868798255920410e+00 -7.9168495178222656e+01 6.6788002014160156e+01 -3.7562201023101807e+00 -7.9013099670410156e+01 6.6788002014160156e+01 0.0000000000000000e+00 -7.9168495178222656e+01 6.6788002014160156e+01 3.7562201023101807e+00 -7.9633399963378906e+01 6.6788002014160156e+01 7.4868798255920410e+00 -8.0404998779296875e+01 6.6788002014160156e+01 1.1166299819946289e+01 -8.1477699279785156e+01 6.6788002014160156e+01 1.4769499778747559e+01 -8.2844299316406250e+01 6.6788002014160156e+01 1.8271900177001953e+01 -8.4495399475097656e+01 6.6788002014160156e+01 2.1649400711059570e+01 -8.6419898986816406e+01 6.6788002014160156e+01 2.4878999710083008e+01 -8.8604400634765625e+01 6.6788002014160156e+01 2.7938699722290039e+01 -9.1034194946289062e+01 6.6788002014160156e+01 3.0807399749755859e+01 -9.3692604064941406e+01 6.6788002014160156e+01 3.3465797424316406e+01 -9.6561294555664062e+01 6.6788002014160156e+01 3.5895599365234375e+01 -9.9620994567871094e+01 6.6788002014160156e+01 3.8080101013183594e+01 -1.0285100555419922e+02 6.6788002014160156e+01 4.0004600524902344e+01 -1.0622800445556641e+02 6.6788002014160156e+01 4.1655700683593750e+01 -1.0972999572753906e+02 6.6788002014160156e+01 4.3022300720214844e+01 -1.1333399963378906e+02 6.6788002014160156e+01 4.4094997406005859e+01 -1.1701300048828125e+02 6.6788002014160156e+01 4.4866600036621094e+01 -1.2066500091552734e+02 6.6182098388671875e+01 4.6279399871826172e+01 -1.2450000000000000e+02 6.6182098388671875e+01 4.6437999725341797e+01 -1.2833499145507812e+02 6.6182098388671875e+01 4.6279399871826172e+01 -1.3214300537109375e+02 6.6182098388671875e+01 4.5804702758789062e+01 -1.3590000915527344e+02 6.6182098388671875e+01 4.5017101287841797e+01 -1.3957800292968750e+02 6.6182098388671875e+01 4.3921897888183594e+01 -1.4315399169921875e+02 6.6182098388671875e+01 4.2526699066162109e+01 -1.4660200500488281e+02 6.6182098388671875e+01 4.0840999603271484e+01 -1.4989900207519531e+02 6.6182098388671875e+01 3.8876399993896484e+01 -1.5302301025390625e+02 6.6182098388671875e+01 3.6646102905273438e+01 -1.5595201110839844e+02 6.6182098388671875e+01 3.4165599822998047e+01 -1.5866600036621094e+02 6.6182098388671875e+01 3.1451601028442383e+01 -1.6114599609375000e+02 6.6182098388671875e+01 2.8522800445556641e+01 -1.6337600708007812e+02 6.6182098388671875e+01 2.5399200439453125e+01 -1.6534100341796875e+02 6.6182098388671875e+01 2.2102100372314453e+01 -1.6702699279785156e+02 6.6182098388671875e+01 1.8653900146484375e+01 -1.6842199707031250e+02 6.6182098388671875e+01 1.5078400611877441e+01 -1.6951699829101562e+02 6.6182098388671875e+01 1.1399899482727051e+01 -1.7030499267578125e+02 6.6182098388671875e+01 7.6434001922607422e+00 -1.7077900695800781e+02 6.6182098388671875e+01 3.8347799777984619e+00 -1.7093800354003906e+02 6.6182098388671875e+01 0.0000000000000000e+00 -1.7077900695800781e+02 6.6182098388671875e+01 -3.8347799777984619e+00 -1.7030499267578125e+02 6.6182098388671875e+01 -7.6434001922607422e+00 -1.6951699829101562e+02 6.6182098388671875e+01 -1.1399899482727051e+01 -1.6842199707031250e+02 6.6182098388671875e+01 -1.5078400611877441e+01 -1.6702699279785156e+02 6.6182098388671875e+01 -1.8653900146484375e+01 -1.6534100341796875e+02 6.6182098388671875e+01 -2.2102100372314453e+01 -1.6337600708007812e+02 6.6182098388671875e+01 -2.5399200439453125e+01 -1.6114599609375000e+02 6.6182098388671875e+01 -2.8522800445556641e+01 -1.5866600036621094e+02 6.6182098388671875e+01 -3.1451601028442383e+01 -1.5595201110839844e+02 6.6182098388671875e+01 -3.4165599822998047e+01 -1.5302301025390625e+02 6.6182098388671875e+01 -3.6646102905273438e+01 -1.4989900207519531e+02 6.6182098388671875e+01 -3.8876399993896484e+01 -1.4660200500488281e+02 6.6182098388671875e+01 -4.0840999603271484e+01 -1.4315399169921875e+02 6.6182098388671875e+01 -4.2526699066162109e+01 -1.3957800292968750e+02 6.6182098388671875e+01 -4.3921897888183594e+01 -1.3590000915527344e+02 6.6182098388671875e+01 -4.5017101287841797e+01 -1.3214300537109375e+02 6.6182098388671875e+01 -4.5804702758789062e+01 -1.2833499145507812e+02 6.6182098388671875e+01 -4.6279399871826172e+01 -1.2450000000000000e+02 6.6182098388671875e+01 -4.6437999725341797e+01 -1.2066500091552734e+02 6.6182098388671875e+01 -4.6279399871826172e+01 -1.1685700225830078e+02 6.6182098388671875e+01 -4.5804702758789062e+01 -1.1309999847412109e+02 6.6182098388671875e+01 -4.5017101287841797e+01 -1.0942199707031250e+02 6.6182098388671875e+01 -4.3921897888183594e+01 -1.0584600067138672e+02 6.6182098388671875e+01 -4.2526699066162109e+01 -1.0239800262451172e+02 6.6182098388671875e+01 -4.0840999603271484e+01 -9.9100799560546875e+01 6.6182098388671875e+01 -3.8876399993896484e+01 -9.5977203369140625e+01 6.6182098388671875e+01 -3.6646102905273438e+01 -9.3048400878906250e+01 6.6182098388671875e+01 -3.4165599822998047e+01 -9.0334403991699219e+01 6.6182098388671875e+01 -3.1451601028442383e+01 -8.7853904724121094e+01 6.6182098388671875e+01 -2.8522800445556641e+01 -8.5623596191406250e+01 6.6182098388671875e+01 -2.5399200439453125e+01 -8.3659004211425781e+01 6.6182098388671875e+01 -2.2102100372314453e+01 -8.1973297119140625e+01 6.6182098388671875e+01 -1.8653900146484375e+01 -8.0578102111816406e+01 6.6182098388671875e+01 -1.5078400611877441e+01 -7.9482894897460938e+01 6.6182098388671875e+01 -1.1399899482727051e+01 -7.8695297241210938e+01 6.6182098388671875e+01 -7.6434001922607422e+00 -7.8220596313476562e+01 6.6182098388671875e+01 -3.8347799777984619e+00 -7.8061996459960938e+01 6.6182098388671875e+01 0.0000000000000000e+00 -7.8220596313476562e+01 6.6182098388671875e+01 3.8347799777984619e+00 -7.8695297241210938e+01 6.6182098388671875e+01 7.6434001922607422e+00 -7.9482894897460938e+01 6.6182098388671875e+01 1.1399899482727051e+01 -8.0578102111816406e+01 6.6182098388671875e+01 1.5078400611877441e+01 -8.1973297119140625e+01 6.6182098388671875e+01 1.8653900146484375e+01 -8.3659004211425781e+01 6.6182098388671875e+01 2.2102100372314453e+01 -8.5623596191406250e+01 6.6182098388671875e+01 2.5399200439453125e+01 -8.7853904724121094e+01 6.6182098388671875e+01 2.8522800445556641e+01 -9.0334403991699219e+01 6.6182098388671875e+01 3.1451601028442383e+01 -9.3048400878906250e+01 6.6182098388671875e+01 3.4165599822998047e+01 -9.5977203369140625e+01 6.6182098388671875e+01 3.6646102905273438e+01 -9.9100799560546875e+01 6.6182098388671875e+01 3.8876399993896484e+01 -1.0239800262451172e+02 6.6182098388671875e+01 4.0840999603271484e+01 -1.0584600067138672e+02 6.6182098388671875e+01 4.2526699066162109e+01 -1.0942199707031250e+02 6.6182098388671875e+01 4.3921897888183594e+01 -1.1309999847412109e+02 6.6182098388671875e+01 4.5017101287841797e+01 -1.1685700225830078e+02 6.6182098388671875e+01 4.5804702758789062e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 7386 -> 38 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4350600540637970e+02 -5.2000001072883606e+01 4.8402201384305954e+01) (float-vector -1.4841799437999725e+02 5.4499998688697815e+01 4.6074401587247849e+01) (float-vector -1.2745599448680878e+02 5.4499998688697815e+01 5.1915898919105530e+01) (float-vector -1.2321499735116959e+02 -5.2000001072883606e+01 5.1984101533889771e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -1.5566900372505188e+01 4.9615200608968735e+01) (float-vector -1.2321499735116959e+02 -5.2000001072883606e+01 5.1984101533889771e+01) (float-vector -1.2745599448680878e+02 5.4499998688697815e+01 5.1915898919105530e+01) (float-vector -1.0499999858438969e+01 5.2607101388275623e+00 5.1733199506998062e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4841799437999725e+02 5.4499998688697815e+01 4.6074401587247849e+01) (float-vector -1.4660200476646423e+02 6.6182099282741547e+01 4.0840998291969299e+01) (float-vector -1.2449999898672104e+02 6.7000001668930054e+01 4.4379301369190216e+01) (float-vector -1.2745599448680878e+02 5.4499998688697815e+01 5.1915898919105530e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 3.3756799995899200e+01) (float-vector -1.4841799437999725e+02 5.4499998688697815e+01 4.6074401587247849e+01) (float-vector -1.4350600540637970e+02 -5.2000001072883606e+01 4.8402201384305954e+01) (float-vector -1.6081200540065765e+02 -5.2000001072883606e+01 3.7220999598503113e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7241799831390381e+02 -5.2000001072883606e+01 2.0195899531245232e+01) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 1.5505200251936913e+01) (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 3.3756799995899200e+01) (float-vector -1.6081200540065765e+02 -5.2000001072883606e+01 3.7220999598503113e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4841799437999725e+02 5.4499998688697815e+01 4.6074401587247849e+01) (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 3.3756799995899200e+01) (float-vector -1.6257999837398529e+02 6.6788002848625183e+01 2.4878999218344688e+01) (float-vector -1.4660200476646423e+02 6.6182099282741547e+01 4.0840998291969299e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 3.3756799995899200e+01) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 1.5505200251936913e+01) (float-vector -1.7077900469303131e+02 6.6182099282741547e+01 3.8347800727933645e+00) (float-vector -1.6257999837398529e+02 6.6788002848625183e+01 2.4878999218344688e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -2.9705900698900223e+01 -4.2679701000452042e+01) (float-vector -1.0499999858438969e+01 -1.0467500425875187e+01 -5.0935499370098114e+01) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -4.1120298206806183e+01 3.1829498708248138e+01) (float-vector -1.0953199863433838e+02 -5.4000001400709152e+01 4.7706998884677887e+01) (float-vector -1.0499999858438969e+01 -3.3871300518512726e+01 3.9455398917198181e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0953199863433838e+02 -5.4000001400709152e+01 4.7706998884677887e+01) (float-vector -1.2321499735116959e+02 -5.2000001072883606e+01 5.1984101533889771e+01) (float-vector -1.0499999858438969e+01 -1.5566900372505188e+01 4.9615200608968735e+01) (float-vector -1.0499999858438969e+01 -3.3871300518512726e+01 3.9455398917198181e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -5.0340000540018082e+01 1.3033900409936905e+01) (float-vector -1.0499999858438969e+01 -5.1400300115346909e+01 -7.8741898760199547e+00) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01) (float-vector -1.0953199863433838e+02 -5.4000001400709152e+01 4.7706998884677887e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7241799831390381e+02 -5.2000001072883606e+01 2.0195899531245232e+01) (float-vector -1.6081200540065765e+02 -5.2000001072883606e+01 3.7220999598503113e+01) (float-vector -1.4350600540637970e+02 -5.2000001072883606e+01 4.8402201384305954e+01) (float-vector -1.2321499735116959e+02 -5.2000001072883606e+01 5.1984101533889771e+01) (float-vector -1.0953199863433838e+02 -5.4000001400709152e+01 4.7706998884677887e+01) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01) (float-vector -1.4350600540637970e+02 -5.2000001072883606e+01 -4.8402201384305954e+01) (float-vector -1.6081200540065765e+02 -5.2000001072883606e+01 -3.7220999598503113e+01) (float-vector -1.7241799831390381e+02 -5.2000001072883606e+01 -2.0195899531245232e+01) (float-vector -1.7649999260902405e+02 -5.2000001072883606e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7623500525951385e+02 5.4499998688697815e+01 -5.2393102087080479e+00) (float-vector -1.7077900469303131e+02 6.6182099282741547e+01 3.8347800727933645e+00) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 1.5505200251936913e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7649999260902405e+02 -5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -1.7623500525951385e+02 5.4499998688697815e+01 -5.2393102087080479e+00) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 1.5505200251936913e+01) (float-vector -1.7241799831390381e+02 -5.2000001072883606e+01 2.0195899531245232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -5.1400300115346909e+01 -7.8741898760199547e+00) (float-vector -1.0499999858438969e+01 -4.4129498302936554e+01 -2.7506100013852119e+01) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -4.4129498302936554e+01 -2.7506100013852119e+01) (float-vector -1.0499999858438969e+01 -2.9705900698900223e+01 -4.2679701000452042e+01) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3780499994754791e+02 5.4499998688697815e+01 -5.0269100815057755e+01) (float-vector -1.4761300384998322e+02 5.4499998688697815e+01 -4.6581000089645386e+01) (float-vector -1.4350600540637970e+02 -5.2000001072883606e+01 -4.8402201384305954e+01) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.4761300384998322e+02 5.4499998688697815e+01 -4.6581000089645386e+01) (float-vector -1.5107800066471100e+02 5.9629499912261963e+01 -4.2029101401567459e+01) (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 -3.3756799995899200e+01) (float-vector -1.6081200540065765e+02 -5.2000001072883606e+01 -3.7220999598503113e+01) (float-vector -1.4350600540637970e+02 -5.2000001072883606e+01 -4.8402201384305954e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3780499994754791e+02 5.4499998688697815e+01 -5.0269100815057755e+01) (float-vector -1.3566599786281586e+02 6.6788002848625183e+01 -4.4094998389482498e+01) (float-vector -1.5595200657844543e+02 6.6182099282741547e+01 -3.4165598452091217e+01) (float-vector -1.5107800066471100e+02 5.9629499912261963e+01 -4.2029101401567459e+01) (float-vector -1.4761300384998322e+02 5.4499998688697815e+01 -4.6581000089645386e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 5.1933199167251587e+01 2.6337499730288982e+00) (float-vector -1.0499999858438969e+01 5.0340000540018082e+01 1.3033900409936905e+01) (float-vector -9.6561297774314880e+01 6.6788002848625183e+01 3.5895600914955139e+01) (float-vector -8.0120697617530823e+01 6.7000001668930054e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 4.8763100057840347e+01 -1.8059799447655678e+01) (float-vector -1.0499999858438969e+01 5.1933199167251587e+01 2.6337499730288982e+00) (float-vector -8.0120697617530823e+01 6.7000001668930054e+01 0.0000000000000000e+00) (float-vector -9.7241699695587158e+01 6.7000001668930054e+01 -3.5021498799324036e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0942199826240540e+02 6.6182099282741547e+01 4.3921899050474167e+01) (float-vector -1.2745599448680878e+02 5.4499998688697815e+01 5.1915898919105530e+01) (float-vector -1.2449999898672104e+02 6.7000001668930054e+01 4.4379301369190216e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 4.1120298206806183e+01 3.1829498708248138e+01) (float-vector -1.0942199826240540e+02 6.6182099282741547e+01 4.3921899050474167e+01) (float-vector -9.6561297774314880e+01 6.6788002848625183e+01 3.5895600914955139e+01) (float-vector -1.0499999858438969e+01 5.0340000540018082e+01 1.3033900409936905e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0942199826240540e+02 6.6182099282741547e+01 4.3921899050474167e+01) (float-vector -1.0499999858438969e+01 2.5235600769519806e+01 4.5465998351573944e+01) (float-vector -1.0499999858438969e+01 5.2607101388275623e+00 5.1733199506998062e+01) (float-vector -1.2745599448680878e+02 5.4499998688697815e+01 5.1915898919105530e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7077900469303131e+02 6.6182099282741547e+01 3.8347800727933645e+00) (float-vector -1.6763100028038025e+02 6.5267898142337799e+01 -1.8919099122285843e+01) (float-vector -1.5595200657844543e+02 6.6182099282741547e+01 -3.4165598452091217e+01) (float-vector -1.3566599786281586e+02 6.6788002848625183e+01 -4.4094998389482498e+01) (float-vector -1.1674799770116806e+02 6.5267898142337799e+01 -4.6455901116132736e+01) (float-vector -9.7241699695587158e+01 6.7000001668930054e+01 -3.5021498799324036e+01) (float-vector -8.0120697617530823e+01 6.7000001668930054e+01 0.0000000000000000e+00) (float-vector -9.6561297774314880e+01 6.6788002848625183e+01 3.5895600914955139e+01) (float-vector -1.0942199826240540e+02 6.6182099282741547e+01 4.3921899050474167e+01) (float-vector -1.2449999898672104e+02 6.7000001668930054e+01 4.4379301369190216e+01) (float-vector -1.4660200476646423e+02 6.6182099282741547e+01 4.0840998291969299e+01) (float-vector -1.6257999837398529e+02 6.6788002848625183e+01 2.4878999218344688e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7623500525951385e+02 5.4499998688697815e+01 -5.2393102087080479e+00) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 -1.5505200251936913e+01) (float-vector -1.6763100028038025e+02 6.5267898142337799e+01 -1.8919099122285843e+01) (float-vector -1.7077900469303131e+02 6.6182099282741547e+01 3.8347800727933645e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 -1.5505200251936913e+01) (float-vector -1.7623500525951385e+02 5.4499998688697815e+01 -5.2393102087080479e+00) (float-vector -1.7649999260902405e+02 -5.2000001072883606e+01 0.0000000000000000e+00) (float-vector -1.7241799831390381e+02 -5.2000001072883606e+01 -2.0195899531245232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6081200540065765e+02 -5.2000001072883606e+01 -3.7220999598503113e+01) (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 -3.3756799995899200e+01) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 -1.5505200251936913e+01) (float-vector -1.7241799831390381e+02 -5.2000001072883606e+01 -2.0195899531245232e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.5595200657844543e+02 6.6182099282741547e+01 -3.4165598452091217e+01) (float-vector -1.6763100028038025e+02 6.5267898142337799e+01 -1.8919099122285843e+01) (float-vector -1.7413499951362610e+02 5.4499998688697815e+01 -1.5505200251936913e+01) (float-vector -1.6405299305915833e+02 5.4499998688697815e+01 -3.3756799995899200e+01) (float-vector -1.5107800066471100e+02 5.9629499912261963e+01 -4.2029101401567459e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3780499994754791e+02 5.4499998688697815e+01 -5.0269100815057755e+01) (float-vector -1.1698800325393677e+02 5.4499998688697815e+01 -5.1454499363899231e+01) (float-vector -1.1674799770116806e+02 6.5267898142337799e+01 -4.6455901116132736e+01) (float-vector -1.3566599786281586e+02 6.6788002848625183e+01 -4.4094998389482498e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -1.0467500425875187e+01 -5.0935499370098114e+01) (float-vector -1.0499999858438969e+01 2.0506499335169792e+01 -4.7785799950361252e+01) (float-vector -1.1698800325393677e+02 5.4499998688697815e+01 -5.1454499363899231e+01) (float-vector -1.3780499994754791e+02 5.4499998688697815e+01 -5.0269100815057755e+01) (float-vector -1.2449999898672104e+02 -5.4000001400709152e+01 -4.9999900162220001e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -9.7241699695587158e+01 6.7000001668930054e+01 -3.5021498799324036e+01) (float-vector -1.1674799770116806e+02 6.5267898142337799e+01 -4.6455901116132736e+01) (float-vector -1.0499999858438969e+01 3.7689201533794403e+01 -3.5826299339532852e+01) (float-vector -1.0499999858438969e+01 4.8763100057840347e+01 -1.8059799447655678e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1698800325393677e+02 5.4499998688697815e+01 -5.1454499363899231e+01) (float-vector -1.0499999858438969e+01 2.0506499335169792e+01 -4.7785799950361252e+01) (float-vector -1.0499999858438969e+01 3.7689201533794403e+01 -3.5826299339532852e+01) (float-vector -1.1674799770116806e+02 6.5267898142337799e+01 -4.6455901116132736e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 4.1120298206806183e+01 3.1829498708248138e+01) (float-vector -8.0000003799796104e+00 2.8507599607110023e+01 3.9237301796674728e+01) (float-vector -1.0499999858438969e+01 2.5235600769519806e+01 4.5465998351573944e+01) (float-vector -1.0942199826240540e+02 6.6182099282741547e+01 4.3921899050474167e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -5.0340000540018082e+01 1.3033900409936905e+01) (float-vector -8.0000003799796104e+00 -4.6126201748847961e+01 1.4987300150096416e+01) (float-vector -1.0499999858438969e+01 -5.1400300115346909e+01 -7.8741898760199547e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -4.1120298206806183e+01 3.1829498708248138e+01) (float-vector -8.0000003799796104e+00 -4.6126201748847961e+01 1.4987300150096416e+01) (float-vector -1.0499999858438969e+01 -5.0340000540018082e+01 1.3033900409936905e+01) (float-vector -1.0953199863433838e+02 -5.4000001400709152e+01 4.7706998884677887e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 2.5235600769519806e+01 4.5465998351573944e+01) (float-vector -8.0000003799796104e+00 2.8507599607110023e+01 3.9237301796674728e+01) (float-vector -8.0000003799796104e+00 -4.6126201748847961e+01 1.4987300150096416e+01) (float-vector -1.0499999858438969e+01 -4.1120298206806183e+01 3.1829498708248138e+01) (float-vector -1.0499999858438969e+01 -3.3871300518512726e+01 3.9455398917198181e+01) (float-vector -1.0499999858438969e+01 -1.5566900372505188e+01 4.9615200608968735e+01) (float-vector -1.0499999858438969e+01 5.2607101388275623e+00 5.1733199506998062e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.0499999858438969e+01 -2.9705900698900223e+01 -4.2679701000452042e+01) (float-vector -1.0499999858438969e+01 -4.4129498302936554e+01 -2.7506100013852119e+01) (float-vector -1.0499999858438969e+01 -5.1400300115346909e+01 -7.8741898760199547e+00) (float-vector -8.0000003799796104e+00 -4.6126201748847961e+01 1.4987300150096416e+01) (float-vector -8.0000003799796104e+00 2.8507599607110023e+01 3.9237301796674728e+01) (float-vector -1.0499999858438969e+01 4.1120298206806183e+01 3.1829498708248138e+01) (float-vector -1.0499999858438969e+01 5.0340000540018082e+01 1.3033900409936905e+01) (float-vector -1.0499999858438969e+01 5.1933199167251587e+01 2.6337499730288982e+00) (float-vector -1.0499999858438969e+01 4.8763100057840347e+01 -1.8059799447655678e+01) (float-vector -1.0499999858438969e+01 3.7689201533794403e+01 -3.5826299339532852e+01) (float-vector -1.0499999858438969e+01 2.0506499335169792e+01 -4.7785799950361252e+01) (float-vector -1.0499999858438969e+01 -1.0467500425875187e+01 -5.0935499370098114e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_wrist_flex_link_hyALBl.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_wrist_roll_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.3850000000000000e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.500000 0.500000 0.500000 1.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 1.000000))))
                   (list :indices #i( 0 1 2 74 75 0 0 75 1 2 80 0 0 80 82 0 82 74 72 73 74 74 73 75 74 82 84 74 84 72 73 83 75 75 83 81 75 81 1 72 71 73 71 85 73 73 85 83 82 81 83 82 83 84 84 83 85 80 81 82 80 79 81 1 81 79 78 77 79 78 79 80 1 79 3 3 79 77 2 1 3 2 3 4 4 3 5 3 77 5 76 77 78 76 151 77 5 77 151 4 5 6 6 5 7 5 151 7 6 76 4 4 76 78 4 78 2 2 78 80 150 151 76 6 150 76 150 149 151 7 151 149 6 7 8 8 7 9 7 149 9 8 150 6 148 149 150 8 148 150 148 147 149 9 149 147 8 9 10 10 9 11 9 147 11 10 148 8 146 147 148 10 146 148 146 145 147 11 147 145 10 11 12 12 11 13 11 145 13 12 146 10 144 145 146 12 144 146 144 143 145 13 145 143 12 13 14 14 13 15 13 143 15 14 144 12 142 143 144 14 142 144 142 141 143 15 143 141 14 15 16 16 15 17 15 141 17 16 142 14 140 141 142 16 140 142 140 139 141 17 141 139 16 17 18 18 17 19 17 139 19 18 140 16 138 139 140 18 138 140 138 137 139 19 139 137 18 19 20 20 19 21 19 137 21 20 138 18 136 137 138 20 136 138 136 135 137 21 137 135 20 21 22 22 21 23 21 135 23 22 136 20 134 135 136 22 134 136 134 133 135 23 135 133 22 23 24 24 23 25 23 133 25 24 134 22 132 133 134 24 132 134 132 131 133 25 133 131 24 25 26 26 25 27 25 131 27 26 132 24 130 131 132 26 130 132 130 129 131 27 131 129 26 27 28 28 27 29 27 129 29 28 130 26 128 129 130 28 128 130 128 127 129 29 129 127 28 29 30 30 29 31 29 127 31 30 128 28 126 127 128 30 126 128 126 125 127 31 127 125 30 31 32 32 31 33 31 125 33 32 126 30 124 125 126 32 124 126 124 123 125 33 125 123 32 33 34 34 33 35 33 123 35 34 124 32 122 123 124 34 122 124 122 121 123 35 123 121 34 35 36 36 35 37 35 121 37 36 122 34 120 121 122 36 120 122 120 119 121 37 121 119 36 37 38 38 37 39 37 119 39 38 120 36 118 119 120 38 118 120 118 117 119 39 119 117 38 39 40 40 39 41 39 117 41 40 118 38 116 117 118 40 116 118 116 115 117 41 117 115 40 41 42 42 41 43 41 115 43 42 116 40 114 115 116 42 114 116 114 113 115 43 115 113 42 43 44 44 43 45 43 113 45 44 114 42 112 113 114 44 112 114 112 111 113 45 113 111 44 45 46 46 45 47 45 111 47 46 112 44 110 111 112 46 110 112 110 109 111 47 111 109 46 47 48 48 47 49 47 109 49 48 110 46 108 109 110 48 108 110 108 107 109 49 109 107 48 49 50 50 49 51 49 107 51 50 108 48 106 107 108 50 106 108 106 105 107 51 107 105 50 51 52 52 51 53 51 105 53 52 106 50 104 105 106 52 104 106 104 103 105 53 105 103 52 53 54 54 53 55 53 103 55 54 104 52 102 103 104 54 102 104 102 101 103 55 103 101 54 55 56 56 55 57 55 101 57 56 102 54 100 101 102 56 100 102 100 99 101 57 101 99 56 57 58 58 57 59 57 99 59 58 100 56 98 99 100 58 98 100 98 97 99 59 99 97 58 59 60 60 59 61 59 97 61 60 98 58 96 97 98 60 96 98 96 95 97 61 97 95 60 61 62 62 61 63 61 95 63 62 96 60 94 95 96 62 94 96 94 93 95 63 95 93 62 63 64 64 63 65 63 93 65 64 94 62 92 93 94 64 92 94 92 91 93 65 93 91 64 65 66 66 65 67 65 91 67 66 92 64 90 91 92 66 90 92 90 89 91 67 91 89 66 67 68 68 67 69 67 89 69 68 90 66 88 89 90 68 88 90 88 87 89 69 89 87 68 69 70 70 69 71 69 87 71 70 88 68 86 87 88 70 86 88 86 85 87 71 87 85 70 71 72 72 86 70 84 85 86 72 84 86 152 153 154 152 155 153 154 160 152 152 160 161 152 161 162 162 171 152 152 171 172 152 172 173 174 152 175 175 152 176 173 180 152 152 180 181 152 181 176 174 182 152 152 182 183 152 183 184 1039 155 152 1039 152 1038 1038 152 1037 1037 152 184 1037 184 1036 1036 184 1035 1035 184 183 1036 963 1037 1037 963 964 1037 964 1038 1038 964 965 1038 965 1039 963 890 964 964 890 891 964 891 965 962 889 963 963 889 890 1036 962 963 1035 962 1036 961 888 962 962 888 889 1035 961 962 888 782 889 889 782 779 889 779 890 890 779 777 890 777 891 778 777 779 778 779 780 780 779 781 781 779 782 781 782 783 783 782 784 888 784 782 780 781 1157 1157 781 783 1157 1159 780 780 1159 778 1153 1156 1157 1156 1158 1157 1157 1158 1159 1157 783 1153 783 784 785 1153 783 785 1153 1154 1155 1155 1156 1153 1153 785 1154 1155 666 1156 666 639 1156 1156 639 1158 1128 1159 1158 1128 1158 641 641 1158 639 639 640 641 666 667 639 639 667 668 639 668 640 641 640 642 641 642 634 634 1128 641 668 1450 640 640 1450 1451 640 1451 642 667 1449 668 668 1449 1450 1449 1372 1450 1450 1372 1373 1450 1373 1451 1451 1373 1374 1451 1374 1452 642 1451 1452 1372 500 1373 1373 500 498 1373 498 1374 1371 502 1372 1372 502 500 1449 1371 1372 499 498 500 499 500 501 501 500 502 497 496 498 497 498 499 1374 498 496 501 1295 499 499 1295 1296 499 1296 497 501 502 503 503 1294 501 501 1294 1295 1294 1213 1295 1295 1213 1214 1295 1214 1296 1296 1214 1215 1296 1215 1297 497 1296 1297 1213 367 1214 367 362 1214 1214 362 363 1214 363 1215 1215 363 364 1215 364 1216 1297 1215 1216 1297 1216 1298 497 1297 495 495 1297 1298 364 359 1216 1216 359 360 1216 360 1217 1298 1216 1217 363 282 364 364 282 359 359 282 360 360 282 281 360 281 361 1217 360 361 1217 361 1218 1298 1217 1299 1299 1217 1218 361 281 356 361 356 1218 1218 356 357 1218 357 1219 1299 1218 1300 1300 1218 1219 493 1298 1299 493 1299 491 491 1299 1300 1300 1219 1301 491 1300 489 489 1300 1301 489 490 491 491 490 492 491 492 493 487 488 489 489 488 490 489 1301 487 1301 1219 1220 1301 1220 1302 487 1301 1302 485 486 487 487 486 488 487 1302 485 1378 490 488 1378 488 1379 1379 488 486 485 484 486 1379 486 1380 1380 486 484 483 484 485 485 1302 1303 485 1303 483 483 482 484 1380 484 1381 1381 484 482 1457 1379 1380 1457 1380 1458 1458 1380 1381 1381 482 1382 1458 1381 1459 1459 1381 1382 481 480 482 481 482 483 1382 482 480 1382 480 1383 1459 1382 1460 1460 1382 1383 632 1458 1459 632 1459 633 633 1459 1460 1460 1383 1461 633 1460 603 603 1460 1461 1383 480 478 1383 478 1384 1461 1383 1384 1461 1384 1462 603 1461 605 605 1461 1462 602 603 604 604 603 605 602 633 603 602 632 633 631 632 602 602 604 1140 602 1126 631 602 1140 1126 604 605 606 604 606 1167 604 1167 1140 605 612 606 605 1462 612 606 612 613 606 613 614 1167 606 1168 606 614 1168 1165 1166 1167 1167 1168 1165 1140 1167 1166 1165 1168 1169 1168 614 1170 1168 1170 1169 614 613 615 614 615 592 592 1170 614 1169 1170 1171 1122 1171 1170 1122 1170 592 592 593 594 592 615 616 592 616 593 594 1122 592 1122 1123 1124 594 1123 1122 1124 1171 1122 594 593 595 594 595 587 587 1123 594 587 1174 1123 1123 1174 1173 1123 1173 1124 587 588 589 587 595 596 587 596 588 587 589 1174 1172 1173 1174 1174 589 1175 1174 1175 1172 589 588 590 589 590 591 589 591 1175 1172 1175 1176 1175 591 1119 1175 1119 1176 590 622 591 591 622 623 591 623 624 624 1119 591 1119 1120 1121 624 1120 1119 1176 1119 1121 624 623 625 624 625 607 607 1120 624 622 1472 623 623 1472 1473 623 1473 625 607 625 626 625 1473 1474 625 1474 626 1472 1395 1473 1473 1395 1396 1473 1396 1474 1471 1394 1472 1472 1394 1395 622 1471 1472 1394 456 1395 1395 456 454 1395 454 1396 1396 454 452 1396 452 1397 1474 1396 1397 453 452 454 453 454 455 455 454 456 455 456 457 457 456 458 1394 458 456 457 1317 455 455 1317 1318 455 1318 453 451 452 453 453 1318 1319 453 1319 451 1317 1236 1318 1318 1236 1238 1318 1238 1319 1316 1235 1317 1317 1235 1236 457 1316 1317 1315 1233 1316 1316 1233 1235 459 1315 1316 459 1316 457 1233 335 1235 1235 335 1236 334 289 335 335 289 330 1233 334 335 335 330 1236 333 290 334 334 290 289 333 334 1233 338 290 333 333 1233 338 230 289 290 230 290 232 232 290 291 337 291 290 337 290 338 1232 337 338 338 1233 1234 338 1234 1232 336 291 337 1232 336 337 1231 336 1232 1313 1231 1232 1313 1232 1314 1314 1232 1234 1314 1234 1315 1315 1234 1233 463 1313 1314 463 1314 461 461 1314 1315 1312 1231 1313 465 1312 1313 465 1313 463 461 462 463 463 462 464 463 464 465 459 460 461 461 460 462 461 1315 459 1391 464 462 1391 462 1392 1392 462 460 465 464 466 1390 466 464 1390 464 1391 1468 1390 1391 1468 1391 1469 1469 1391 1392 1392 460 1393 1469 1392 1470 1470 1392 1393 596 1468 1469 596 1469 588 588 1469 1470 1467 1390 1468 595 1467 1468 595 1468 596 1466 1389 1467 1467 1389 1390 593 1466 1467 593 1467 595 1465 1388 1466 1466 1388 1389 616 1465 1466 616 1466 593 1388 468 1389 1389 468 466 1389 466 1390 1387 470 1388 1388 470 468 1465 1387 1388 467 466 468 467 468 469 469 468 470 465 466 467 469 1311 467 467 1311 1312 467 1312 465 469 470 471 471 1310 469 469 1310 1311 471 470 472 1387 472 470 471 472 473 473 1309 471 471 1309 1310 1309 1228 1310 1310 1228 1229 1310 1229 1311 1308 1227 1309 1309 1227 1228 473 1308 1309 473 472 474 473 474 475 475 1308 473 1307 1226 1308 1308 1226 1227 475 1307 1308 1226 345 1227 1227 345 346 1227 346 1228 1225 349 1226 349 344 1226 1226 344 345 1307 1225 1226 344 285 345 345 285 284 345 284 346 346 284 343 346 343 1228 234 283 284 234 284 236 236 284 285 283 343 284 283 342 343 1228 343 342 1228 342 1229 339 342 283 1229 342 339 1229 339 1230 1311 1229 1230 339 283 340 339 340 1230 1230 340 341 1230 341 1231 1311 1230 1312 1312 1230 1231 340 283 291 340 291 341 341 291 336 1231 341 336 232 291 283 231 230 232 231 232 233 233 232 234 232 283 234 229 230 231 233 214 231 231 214 213 231 213 229 229 228 230 228 289 230 227 228 229 229 213 205 229 205 227 205 213 204 204 213 214 204 214 215 233 215 214 235 204 215 235 215 233 233 234 235 235 234 236 235 236 237 237 204 235 237 236 238 236 285 238 237 238 239 239 206 237 237 206 204 239 238 240 238 279 240 238 285 286 238 286 279 348 286 285 348 285 349 349 285 344 347 286 348 351 279 286 351 286 352 352 286 347 1224 347 348 1224 348 1225 1225 348 349 352 347 1224 1223 351 352 1223 352 1224 350 279 351 1222 350 351 1222 351 1223 1304 1222 1223 1304 1223 1305 1305 1223 1224 1305 1224 1306 1306 1224 1225 1306 1225 1307 479 1305 1306 479 1306 477 477 1306 1307 481 1304 1305 481 1305 479 477 478 479 479 478 480 479 480 481 475 476 477 477 476 478 477 1307 475 1384 478 476 475 474 476 1384 476 1385 1385 476 474 1462 1384 1385 1385 474 1386 1462 1385 1463 1463 1385 1386 1386 474 472 1386 472 1387 1463 1386 1464 1464 1386 1387 612 1462 1463 612 1463 613 613 1463 1464 1464 1387 1465 613 1464 615 615 1464 1465 615 1465 616 483 1304 481 483 1303 1304 1303 1222 1304 1302 1221 1303 1303 1221 1222 1221 355 1222 355 350 1222 1220 354 1221 1221 354 355 1302 1220 1221 354 279 355 355 279 350 353 280 354 354 280 279 1220 353 354 1219 358 1220 358 353 1220 358 280 353 357 280 358 1219 357 358 240 279 280 240 280 242 242 280 281 357 281 280 356 281 357 242 281 244 244 281 282 241 240 242 241 242 243 243 242 244 239 240 241 243 211 241 241 211 207 241 207 239 243 244 245 245 212 243 243 212 211 207 211 192 192 211 212 192 206 207 239 207 206 192 204 206 202 203 204 204 203 205 202 204 192 225 203 202 225 202 223 223 202 192 227 205 203 227 203 225 223 224 225 225 224 226 225 226 227 221 222 223 223 222 224 223 192 221 219 220 221 221 220 222 221 192 190 221 190 219 220 294 222 222 294 295 222 295 224 219 278 220 278 293 220 220 293 294 277 276 278 277 278 219 276 292 278 278 292 293 275 276 277 219 189 277 277 189 193 277 193 275 273 274 275 275 274 276 275 193 198 275 198 273 271 272 273 273 272 274 273 198 199 273 199 271 272 299 274 274 299 300 274 300 276 271 270 272 270 298 272 272 298 299 269 268 270 269 270 271 268 297 270 270 297 298 267 268 269 271 218 269 269 218 217 269 217 267 265 266 267 267 266 268 267 217 216 267 216 265 199 216 217 199 217 218 271 199 218 198 197 199 199 197 200 199 200 201 201 208 199 199 208 209 199 209 210 210 216 199 265 216 210 265 210 263 263 210 209 263 209 261 261 209 208 261 208 259 259 208 201 259 201 257 257 201 200 257 258 259 259 258 260 259 260 261 261 260 262 261 262 263 263 262 264 263 264 265 262 302 264 260 309 262 262 309 310 262 310 302 258 308 260 260 308 309 257 256 258 256 307 258 258 307 308 255 254 256 255 256 257 254 306 256 256 306 307 253 254 255 257 200 255 255 200 197 255 197 253 251 252 253 253 252 254 253 197 196 253 196 251 193 196 197 193 197 198 195 196 193 251 196 195 249 250 251 251 250 252 251 195 249 193 194 195 249 195 194 189 191 193 193 191 194 249 194 247 247 194 191 247 248 249 249 248 250 248 313 250 250 313 314 250 314 252 247 246 248 246 312 248 248 312 313 245 246 247 247 191 245 245 244 246 244 282 246 282 311 246 246 311 312 245 191 212 192 212 191 191 190 192 189 190 191 219 190 189 365 312 366 366 312 311 369 313 312 369 312 370 370 312 365 370 365 1212 1212 365 366 366 311 367 1212 366 1213 1213 366 367 1211 370 1212 1293 1211 1212 1293 1212 1294 1294 1212 1213 1211 369 370 1210 369 1211 1292 1210 1211 1292 1211 1293 505 1292 1293 505 1293 503 503 1293 1294 1291 1210 1292 507 1291 1292 507 1292 505 503 504 505 505 504 506 505 506 507 503 502 504 1370 506 504 1370 504 1371 1371 504 502 507 506 508 1369 508 506 1369 506 1370 507 508 509 509 1291 507 509 508 510 1368 510 508 1368 508 1369 1446 1368 1369 1446 1369 1447 1447 1369 1370 1367 510 1368 1445 1367 1368 1445 1368 1446 509 510 511 511 510 512 1367 512 510 1366 512 1367 1444 1367 1445 1444 1366 1367 670 1445 672 672 1445 1446 670 1444 1445 1521 1366 1444 669 1521 1444 669 1444 670 1443 514 1366 1366 514 512 1521 1443 1366 1520 1443 1521 657 1520 1521 657 1521 669 657 669 658 658 669 670 656 655 657 656 657 658 655 1520 657 1519 1442 1520 1520 1442 1443 655 1519 1520 654 655 656 654 678 655 678 1519 655 654 656 1200 1200 656 1201 658 1201 656 676 677 654 654 677 678 654 1111 676 654 1200 1111 677 1518 678 678 1518 1519 676 675 677 675 1517 677 677 1517 1518 674 675 676 676 1111 1110 676 1110 674 1110 1111 1112 1111 1200 1199 1111 1199 1112 1196 674 1110 1196 1110 1197 1197 1110 1112 1197 1112 805 805 1112 803 1112 1199 794 1112 794 803 1193 1196 1197 1193 1197 807 807 1197 805 803 804 805 805 804 806 805 806 807 794 793 803 803 793 804 793 794 795 1199 795 794 793 795 796 953 804 793 953 793 954 954 793 796 952 806 804 952 804 953 1026 952 953 1026 953 1027 1027 953 954 954 796 955 1027 954 1028 1028 954 955 1100 1026 1027 1100 1027 1101 1101 1027 1028 1025 952 1026 1099 1025 1026 1099 1026 1100 1099 1100 176 176 1100 1101 1101 1028 1102 176 1101 175 175 1101 1102 1028 955 1029 1102 1028 1029 1102 1029 1103 175 1102 174 174 1102 1103 1029 955 882 1029 882 956 1103 1029 956 1103 956 1030 174 1103 1030 1031 182 174 1031 174 1030 1030 957 1031 1030 956 957 956 883 957 956 882 883 957 883 884 957 884 958 1031 957 958 1031 958 1032 1032 182 1031 1033 183 182 1033 182 1032 1032 958 959 1032 959 1033 958 884 885 958 885 959 959 885 886 959 886 960 1033 959 960 1033 960 1034 1034 183 1033 1035 183 1034 1034 960 961 1034 961 1035 960 886 887 960 887 961 885 788 886 886 788 786 886 786 887 887 786 784 887 784 888 961 887 888 785 784 786 785 786 787 787 786 788 1154 785 787 787 788 789 1154 787 789 1132 1155 1154 1132 1154 1133 1133 1154 789 789 788 790 1133 789 790 1131 1132 1133 790 802 1133 1133 802 1202 1133 1202 1131 790 788 791 790 791 792 792 802 790 792 801 802 802 801 1202 800 801 792 883 800 792 883 792 884 884 792 791 884 791 885 885 791 788 882 800 883 798 799 800 800 799 801 882 798 800 1202 801 799 798 797 799 1202 799 1198 1198 799 797 796 797 798 955 796 798 955 798 882 796 795 797 1198 797 1199 1199 797 795 1198 1199 1200 1200 1201 1198 1198 1201 1202 1131 1202 1201 1131 1201 658 671 1132 1131 671 1131 658 658 670 671 671 670 672 671 672 664 664 1132 671 664 1155 1132 664 665 666 664 672 673 664 673 665 664 666 1155 672 1446 673 673 1446 1447 673 1447 665 666 665 667 665 1447 1448 665 1448 667 1447 1370 1448 1448 1370 1371 1448 1371 1449 667 1448 1449 1099 176 1098 1098 176 181 1098 1025 1099 1097 1024 1098 1098 1024 1025 1098 181 1097 1097 181 180 1096 1023 1097 1097 1023 1024 1097 180 1096 1023 950 1024 1024 950 951 1024 951 1025 1025 951 952 950 808 951 951 808 806 951 806 952 949 810 950 950 810 808 1023 949 950 1022 949 1023 1096 1022 1023 948 813 949 949 813 810 1022 948 949 809 808 810 809 810 811 811 810 812 812 810 813 812 813 814 814 813 815 948 815 813 1194 811 812 1194 812 814 1193 809 811 1193 811 1194 807 808 809 807 809 1193 1193 1194 1195 1195 1196 1193 1134 1195 1194 1134 1194 1209 1209 1194 814 691 693 1195 1195 693 1196 691 1195 1134 693 674 1196 691 692 693 693 692 694 693 694 674 674 694 695 674 695 675 692 1514 694 694 1514 1515 694 1515 695 691 717 692 717 1513 692 692 1513 1514 1513 1436 1514 1514 1436 1437 1514 1437 1515 1515 1437 1438 1515 1438 1516 695 1515 1516 695 1516 675 675 1516 1517 1516 1438 1439 1516 1439 1517 1437 526 1438 1438 526 524 1438 524 1439 1436 528 1437 1437 528 526 525 524 526 525 526 527 527 526 528 523 522 524 523 524 525 1439 524 522 1439 522 1440 1517 1439 1440 1517 1440 1518 1440 522 520 1440 520 1441 1518 1440 1441 521 520 522 521 522 523 519 518 520 519 520 521 1441 520 518 1441 518 1442 1518 1441 1519 1519 1441 1442 517 516 518 517 518 519 1442 518 516 521 1363 519 519 1363 1364 519 1364 517 515 516 517 517 1364 1365 517 1365 515 515 514 516 1442 516 1443 1443 516 514 513 514 515 515 1365 1288 515 1288 513 1364 1283 1365 1365 1283 1284 1365 1284 1288 1288 1285 1289 1288 1284 1285 513 1288 1289 511 512 513 513 512 514 513 1289 511 1289 1285 1286 1289 1286 1290 511 1289 1290 1284 374 1285 1285 374 373 1285 373 1286 1286 373 372 1286 372 1287 1290 1286 1287 1290 1287 1291 511 1290 509 509 1290 1291 1287 372 371 1287 371 1210 1291 1287 1210 313 371 372 313 372 314 314 372 373 314 373 374 252 314 315 376 315 314 376 314 377 377 314 374 252 315 254 254 315 316 254 316 306 378 316 379 379 316 315 382 306 316 382 316 383 383 316 378 378 1280 383 378 379 1280 379 315 380 1280 379 380 383 1280 1281 1280 380 1282 1362 1281 1280 1362 1280 1363 1363 1280 1282 1279 382 383 383 1281 1279 1361 1279 1281 1361 1281 1362 523 1361 1362 523 1362 521 521 1362 1363 1363 1282 1364 1364 1282 1283 1282 375 1283 375 376 1283 1283 376 377 1283 377 1284 375 315 376 380 315 375 1282 380 375 1284 377 374 525 1361 523 527 1360 525 525 1360 1361 1360 1279 1361 1359 1278 1360 1360 1278 1279 527 1359 1360 527 528 529 529 1359 527 1358 1276 1359 1359 1276 1278 529 1358 1359 1276 386 1278 1278 386 1279 386 381 1279 1279 381 382 385 306 386 386 306 381 1276 385 386 381 306 382 385 307 306 384 307 385 384 385 1276 388 308 307 388 307 389 389 307 384 384 1276 389 1275 388 389 389 1276 1277 389 1277 1275 387 308 388 1275 387 388 391 309 308 391 308 392 392 308 387 392 387 1275 1272 391 392 1272 392 1274 1274 392 1275 390 309 391 390 391 1272 394 310 309 394 309 395 395 309 390 390 1272 395 1271 394 395 395 1272 1273 395 1273 1271 393 310 394 1271 393 394 397 302 310 397 310 398 398 310 393 1270 398 393 1270 393 1271 1269 397 398 1269 398 1270 396 302 397 396 397 1269 1268 396 1269 1350 1268 1269 1350 1269 1351 1351 1269 1270 1351 1270 1352 1352 1270 1271 545 1350 1351 545 1351 543 543 1351 1352 1349 1268 1350 547 1349 1350 547 1350 545 543 544 545 545 544 546 545 546 547 541 542 543 543 542 544 543 1352 541 1428 546 544 1428 544 1429 1429 544 542 547 546 548 1427 548 546 1427 546 1428 1505 1427 1428 1505 1428 1506 1506 1428 1429 1429 542 1430 1506 1429 1507 1507 1429 1430 710 1505 1506 710 1506 702 702 1506 1507 1504 1427 1505 709 1504 1505 709 1505 710 701 709 710 701 710 702 701 702 703 703 702 704 702 1507 704 1507 1430 1508 704 1507 1508 703 704 705 704 711 705 704 1508 711 705 1151 703 703 1151 1152 703 1152 701 705 711 712 705 712 713 713 1150 705 705 1150 1151 711 1508 1509 711 1509 712 713 712 714 712 1509 1510 712 1510 714 713 714 715 715 1149 713 713 1149 1150 1149 1104 1150 1150 1104 1105 1150 1105 1151 715 1134 1149 1149 1134 1209 1149 1209 1104 715 714 716 715 716 691 715 691 1134 691 716 717 714 1511 716 716 1511 1512 716 1512 717 717 1512 1513 1511 1434 1512 1512 1434 1435 1512 1435 1513 1510 1433 1511 1511 1433 1434 714 1510 1511 1433 534 1434 1434 534 532 1434 532 1435 1435 532 530 1435 530 1436 1513 1435 1436 531 530 532 531 532 533 533 532 534 533 534 535 535 534 536 1433 536 534 535 1356 533 533 1356 1357 533 1357 531 529 530 531 531 1357 1358 531 1358 529 1356 1275 1357 1357 1275 1277 1357 1277 1358 1355 1274 1356 1356 1274 1275 535 1355 1356 1354 1272 1355 1355 1272 1274 537 1354 1355 537 1355 535 1353 1273 1354 1354 1273 1272 539 1353 1354 539 1354 537 535 536 537 537 536 538 537 538 539 539 538 540 539 540 541 541 1353 539 1431 540 538 1431 538 1432 1432 538 536 1432 536 1433 1509 1431 1432 1509 1432 1510 1510 1432 1433 1430 540 1431 1508 1430 1431 1508 1431 1509 1430 542 540 541 540 542 541 1352 1353 1352 1271 1353 1353 1271 1273 1358 1277 1276 529 528 530 1436 530 528 818 820 1104 1104 820 1105 1104 1209 816 1104 816 818 816 817 818 818 817 819 818 819 820 820 819 821 820 821 1105 1151 1105 1191 1105 821 833 1105 833 1191 821 819 822 821 822 823 823 833 821 823 832 833 1191 833 832 1151 1191 1152 1152 1191 1192 1191 832 1192 831 830 832 831 832 823 1192 832 830 943 831 823 943 823 944 944 823 822 829 830 831 942 829 831 942 831 943 829 828 830 1192 830 828 827 828 829 941 827 829 941 829 942 1015 941 942 1015 942 1016 1016 942 943 940 827 941 1014 940 941 1014 941 1015 824 826 827 827 826 828 940 824 827 939 824 940 1013 939 940 1013 940 1014 1087 1013 1014 1087 1014 1088 1088 1014 1015 1012 939 1013 1086 1012 1013 1086 1013 1087 938 835 939 939 835 824 1012 938 939 1011 938 1012 1085 1011 1012 1085 1012 1086 1087 162 1086 1086 162 161 1086 161 1085 1087 1088 162 162 1088 171 1091 172 171 1091 171 1090 171 1088 1089 171 1089 1090 1092 173 172 1092 172 1091 1091 1018 1092 1092 1018 1019 1092 1019 1093 1093 173 1092 1093 1094 173 173 1094 180 1093 1019 1020 1093 1020 1094 1018 945 1019 1019 945 946 1019 946 1020 1020 946 947 1020 947 1021 1094 1020 1021 1094 1021 1095 180 1094 1095 180 1095 1096 1095 1021 1022 1095 1022 1096 1021 947 948 1021 948 1022 946 817 947 947 817 815 947 815 948 816 815 817 946 819 817 814 815 816 1209 814 816 945 822 819 945 819 946 944 822 945 1018 944 945 1017 943 944 1017 944 1018 1091 1017 1018 1016 943 1017 1090 1016 1017 1090 1017 1091 1089 1015 1016 1089 1016 1090 1088 1015 1089 1084 1011 1085 1085 161 160 1085 160 1084 1083 1010 1084 1084 1010 1011 1084 160 1083 1010 937 1011 1011 937 938 1009 936 1010 1010 936 937 1083 1009 1010 1082 1009 1083 1083 160 154 1083 154 1082 1008 935 1009 1009 935 936 1082 1008 1009 935 841 936 936 841 839 936 839 937 934 844 935 935 844 841 1008 934 935 1007 934 1008 1081 1007 1008 1081 1008 1082 1082 154 1081 1081 154 153 1080 1007 1081 1081 153 1080 1006 933 1007 1007 933 934 1080 1006 1007 933 846 934 934 846 844 932 848 933 933 848 846 1006 932 933 1005 932 1006 1079 1005 1006 1079 1006 1080 153 1079 1080 1078 1005 1079 153 1078 1079 1004 931 1005 1005 931 932 1078 1004 1005 931 850 932 932 850 848 930 853 931 931 853 850 1004 930 931 1003 930 1004 1077 1003 1004 1077 1004 1078 170 1077 1078 170 1078 153 1076 1003 1077 169 1077 170 169 1076 1077 1002 929 1003 1003 929 930 1076 1002 1003 1075 1002 1076 169 1075 1076 168 169 157 157 169 170 168 1075 169 157 170 153 153 155 156 153 156 157 1041 156 155 1041 155 1040 1040 155 1039 1042 157 156 1042 156 1041 1040 967 1041 1041 967 968 1041 968 1042 1039 966 1040 1040 966 967 1039 965 966 965 892 966 966 892 893 966 893 967 967 893 894 967 894 968 968 894 895 968 895 969 1042 968 969 893 762 894 894 762 765 894 765 895 892 773 893 893 773 762 762 763 764 762 764 765 763 762 772 772 762 773 765 764 766 765 766 767 895 765 767 766 764 1160 1160 764 763 1160 763 1161 1161 763 772 772 773 774 1161 772 774 1160 1161 1162 1129 1162 1161 1129 1161 1130 1130 1161 774 1162 1163 1160 1160 1163 1164 1160 1164 766 636 627 1162 1162 627 1163 636 1162 1129 1128 1129 1130 636 1129 634 634 1129 1128 634 635 636 636 635 637 636 637 627 634 642 643 634 643 635 643 1453 635 635 1453 1454 635 1454 637 627 637 638 637 1454 1455 637 1455 638 1453 1376 1454 1454 1376 1377 1454 1377 1455 1452 1375 1453 1453 1375 1376 643 1452 1453 642 1452 643 1452 1374 1375 1374 496 1375 1375 496 494 1375 494 1376 1376 494 492 1376 492 1377 493 492 494 493 494 495 495 494 496 495 496 497 495 1298 493 1377 492 490 1377 490 1378 1455 1377 1378 1455 1378 1456 1456 1378 1379 638 1455 1456 1456 1379 1457 638 1456 628 628 1456 1457 627 638 628 627 628 629 629 628 630 628 1457 630 630 1457 1458 629 630 631 631 630 632 630 1458 632 631 1125 629 627 629 1163 1163 629 1125 631 1126 1125 1125 1126 1127 1163 1125 1164 1164 1125 1127 1126 1140 1203 1126 1203 1127 1164 1127 768 768 1127 770 1127 1203 771 1127 771 770 766 1164 768 767 766 768 767 768 769 769 768 770 769 770 761 761 770 771 761 771 759 1203 759 771 759 760 761 897 769 761 897 761 898 898 761 760 896 767 769 896 769 897 895 767 896 969 895 896 969 896 970 970 896 897 970 897 971 971 897 898 898 760 899 971 898 972 972 898 899 1044 970 971 1044 971 1045 1045 971 972 1043 969 970 1043 970 1044 1042 969 1043 1043 1044 157 1043 157 1042 157 1044 163 163 1044 1045 1045 972 1046 163 1045 1046 972 899 973 1046 972 973 1046 973 1047 1047 163 1046 157 163 158 158 163 164 1047 164 163 1047 973 974 1047 974 1048 1048 164 1047 973 899 900 973 900 974 974 900 901 974 901 975 1048 974 975 1048 975 1049 1049 164 1048 158 164 165 1049 165 164 1049 975 976 1049 976 1050 1050 165 1049 975 901 902 975 902 976 976 902 903 976 903 977 1050 976 977 1050 977 1051 1051 165 1050 165 177 158 1051 177 165 1051 977 978 1051 978 1052 1052 177 1051 977 903 904 977 904 978 978 904 905 978 905 979 1052 978 979 1052 979 1053 1053 178 1052 1052 178 177 158 177 178 158 178 179 1053 1054 178 178 1054 179 1053 979 980 1053 980 1054 979 905 906 979 906 980 980 906 907 980 907 981 1054 980 981 1054 981 1055 179 1054 1055 981 907 908 981 908 982 1055 981 982 906 742 907 907 742 731 907 731 908 905 744 906 906 744 742 741 731 742 741 742 743 743 742 744 743 744 745 745 744 746 905 746 744 904 746 905 745 746 747 747 746 748 904 748 746 745 747 1124 1124 743 745 1124 1173 743 1173 741 743 1124 747 1171 747 748 749 749 1171 747 1169 1171 749 749 748 750 749 750 1169 1169 750 752 1169 752 1165 750 748 751 750 751 752 752 751 753 752 753 754 1165 752 754 1165 754 1166 754 753 755 754 755 756 1166 754 756 901 755 753 901 753 902 902 753 751 902 751 903 903 751 748 903 748 904 900 755 901 756 755 757 900 757 755 756 757 758 1166 756 758 758 757 759 759 757 760 899 760 757 899 757 900 1203 1166 758 1203 758 759 1140 1166 1203 732 731 741 1173 732 741 731 732 733 1172 733 732 1172 732 1173 731 733 734 908 731 734 734 733 735 735 733 1172 1172 1176 735 734 735 736 736 735 737 735 1176 737 908 734 909 909 734 736 982 908 909 909 736 910 982 909 983 983 909 910 736 737 738 910 736 738 738 737 739 1176 1121 737 737 1121 739 738 739 730 910 738 911 911 738 730 983 910 984 984 910 911 911 730 912 984 911 985 985 911 912 1057 983 984 1057 984 1058 1058 984 985 985 912 986 1058 985 1059 1059 985 986 912 730 729 912 729 913 986 912 913 986 913 987 1059 986 1060 1060 986 987 1059 1060 186 1059 186 1058 1058 186 185 1058 185 1057 158 185 186 158 186 187 187 186 188 186 1060 1061 186 1061 188 1060 987 1061 1061 987 988 1061 988 1062 188 1061 1062 188 1062 187 187 1064 158 187 1062 1063 187 1063 1064 1062 988 989 1062 989 1063 987 914 988 988 914 915 988 915 989 989 915 916 989 916 990 1063 989 990 1063 990 1064 990 916 917 990 917 991 1064 990 991 915 722 916 916 722 719 916 719 917 914 724 915 915 724 722 721 719 722 721 722 723 723 722 724 718 719 720 720 719 721 917 719 718 1109 720 721 1109 721 1177 1177 721 723 723 724 725 1177 723 1178 1178 723 725 1143 1109 1177 1143 1177 1144 1144 1177 1178 1139 1144 1178 1139 1178 1204 1204 1178 727 1178 725 727 725 724 726 725 726 727 727 726 728 1204 727 728 728 726 729 913 729 726 913 726 914 914 726 724 728 729 730 730 740 728 1204 728 740 730 739 740 1121 1204 740 1121 740 739 1120 1204 1121 607 1139 1120 1120 1139 1204 607 608 609 607 626 608 607 609 1139 609 1144 1139 609 608 610 609 610 611 611 1144 609 626 1475 608 608 1475 1476 608 1476 610 626 1474 1475 1474 1397 1475 1475 1397 1398 1475 1398 1476 1476 1398 1399 1476 1399 1477 610 1476 1477 1397 450 1398 1398 450 448 1398 448 1399 1397 452 450 449 448 450 449 450 451 451 450 452 447 446 448 447 448 449 1399 448 446 451 1320 449 449 1320 1321 449 1321 447 451 1319 1320 1319 1237 1320 1320 1237 1239 1320 1239 1321 1321 1239 1240 1321 1240 1322 447 1321 1322 1237 329 1239 1239 329 1240 328 287 329 329 287 324 1237 328 329 329 324 1240 327 288 328 328 288 287 327 328 1237 332 288 327 327 1237 332 226 287 288 226 288 228 228 288 289 331 289 288 331 288 332 1236 331 332 332 1237 1238 332 1238 1236 330 289 331 1236 330 331 1319 1238 1237 227 226 228 224 287 226 224 295 296 224 296 287 324 287 325 325 287 296 321 296 322 322 296 295 325 296 326 326 296 321 1240 324 325 1240 325 326 321 1241 326 326 1241 1242 326 1242 1240 321 322 1241 322 295 323 1241 322 323 1241 323 1243 1323 1242 1241 1323 1241 1324 1324 1241 1243 1322 1240 1242 1322 1242 1323 445 1322 1323 445 1323 443 443 1323 1324 1324 1243 1325 443 1324 441 441 1324 1325 441 442 443 443 442 444 443 444 445 445 444 446 445 446 447 447 1322 445 1400 446 444 1400 444 1401 1401 444 442 441 440 442 1401 442 1402 1402 442 440 1478 1400 1401 1478 1401 1479 1479 1401 1402 1399 446 1400 1477 1399 1400 1477 1400 1478 617 1477 1478 617 1478 618 618 1478 1479 1479 1402 1480 618 1479 620 620 1479 1480 611 617 618 611 618 619 619 618 620 610 617 611 610 1477 617 619 1143 611 611 1143 1144 619 620 597 597 1142 619 619 1142 1143 597 620 621 620 1480 621 597 598 599 597 621 598 599 1141 597 597 1141 1142 1141 1108 1142 1142 1108 1109 1142 1109 1143 599 1138 1141 1141 1138 1205 1141 1205 1108 599 598 600 599 600 601 599 601 1138 601 1181 1138 1138 1181 1180 1138 1180 1205 1108 1205 876 1205 1180 878 1205 878 876 1179 1180 1181 1179 881 1180 1180 881 880 1180 880 878 877 876 878 877 878 879 879 878 880 879 880 864 864 880 881 864 881 865 1179 865 881 864 865 866 921 879 864 921 864 922 922 864 866 920 877 879 920 879 921 994 920 921 994 921 995 995 921 922 922 866 923 995 922 996 996 922 923 1068 994 995 1068 995 1069 1069 995 996 993 920 994 1067 993 994 1067 994 1068 159 1067 1068 159 1068 166 166 1068 1069 1069 996 1070 166 1069 1070 996 923 997 1070 996 997 1070 997 1071 1071 166 1070 159 166 157 157 166 167 1071 167 166 1071 997 998 1071 998 1072 1072 167 1071 997 923 924 997 924 998 998 924 925 998 925 999 1072 998 999 1072 999 1073 1073 168 1072 1072 168 167 157 167 168 157 158 159 179 185 158 159 158 1066 158 1064 1065 158 1065 1066 1066 1067 159 1065 992 1066 1066 992 993 1066 993 1067 1064 991 1065 1065 991 992 991 918 992 992 918 919 992 919 993 993 919 920 918 875 919 919 875 877 919 877 920 917 718 918 918 718 875 991 917 918 718 874 875 875 874 876 875 876 877 720 873 718 718 873 874 874 873 1108 1108 876 874 1108 873 1109 873 720 1109 1057 185 179 1056 983 1057 1057 179 1056 179 1055 1056 1055 982 1056 1056 982 983 1073 1074 168 168 1074 1075 1073 999 1000 1073 1000 1074 1074 1000 1001 1074 1001 1075 1075 1001 1002 1000 927 1001 1001 927 928 1001 928 1002 999 926 1000 1000 926 927 999 925 926 925 855 926 926 855 857 926 857 927 927 857 859 927 859 928 928 859 861 928 861 929 1002 928 929 857 858 859 859 858 860 859 860 861 855 856 857 857 856 858 1206 1185 858 1206 858 856 1185 860 858 861 860 862 1185 862 860 861 862 854 929 861 854 929 854 930 852 853 854 854 862 863 854 863 852 930 854 853 1184 863 862 1184 862 1185 1107 852 863 1107 863 1184 851 850 852 852 850 853 851 852 1107 1106 851 1107 1146 1106 1107 1146 1107 1147 1147 1107 1184 1147 1184 1148 1148 1184 1185 649 1146 1147 649 1147 681 681 1147 1148 651 1145 1146 651 1146 649 1145 1106 1146 649 650 651 681 682 649 649 682 683 649 683 650 663 680 681 681 680 682 681 1148 663 680 1492 682 682 1492 1493 682 1493 683 683 1493 1494 683 1494 650 1492 1415 1493 1493 1415 1416 1493 1416 1494 1491 1414 1492 1492 1414 1415 680 1491 1492 663 679 680 679 1491 680 1490 1413 1491 1491 1413 1414 679 1490 1491 1413 574 1414 1414 574 572 1414 572 1415 1412 576 1413 1413 576 574 1490 1412 1413 1489 1412 1490 662 1489 1490 662 1490 679 662 679 663 661 660 662 661 662 663 660 1489 662 1488 1411 1489 1489 1411 1412 660 1488 1489 659 660 661 659 690 660 690 1488 660 661 663 1137 661 1117 659 661 1137 1117 663 1148 1137 1117 1137 1206 1137 1148 1185 1137 1185 1206 1116 1117 1118 659 1117 1116 1117 1206 1118 1206 856 872 1118 1206 872 1183 1116 1118 1183 1118 869 869 1118 871 1118 872 871 855 871 872 855 872 856 870 869 871 870 871 855 868 867 869 868 869 870 867 1183 869 924 868 870 924 870 925 925 870 855 866 867 868 923 866 868 923 868 924 866 865 867 1179 1183 867 867 865 1179 1181 1182 1179 1179 1182 1183 1182 1116 1183 1181 686 1182 686 688 1182 1182 688 1116 601 686 1181 601 685 686 686 685 687 686 687 688 688 687 689 688 689 659 659 1116 688 685 1485 687 687 1485 1486 687 1486 689 601 684 685 684 1484 685 685 1484 1485 600 684 601 600 1483 684 684 1483 1484 1483 1406 1484 1484 1406 1407 1484 1407 1485 1485 1407 1408 1485 1408 1486 1406 432 1407 1407 432 586 1407 586 1408 1405 434 1406 1406 434 432 1483 1405 1406 1482 1405 1483 600 1482 1483 598 1482 600 1481 1404 1482 1482 1404 1405 598 1481 1482 1404 436 1405 1405 436 434 433 432 434 433 434 435 435 434 436 435 436 437 437 436 438 1404 438 436 1403 438 1404 1481 1403 1404 437 438 439 439 438 440 1403 440 438 439 1326 437 437 1326 1327 437 1327 435 435 1327 1328 435 1328 433 1326 1245 1327 1327 1245 1246 1327 1246 1328 1325 1244 1326 1326 1244 1245 439 1325 1326 1244 319 1245 1245 319 320 1245 320 1246 1246 320 430 1246 430 1247 1328 1246 1247 319 294 320 294 430 320 318 294 319 1244 318 319 318 295 294 293 429 294 294 429 430 1247 430 429 1247 429 1248 1328 1247 1329 1329 1247 1248 293 428 429 1248 429 428 425 293 426 426 293 292 425 428 293 1248 428 1249 428 425 1249 1329 1248 1330 1330 1248 1249 1249 425 426 1249 426 1250 1330 1249 1331 1331 1249 1250 426 292 427 1250 426 427 1250 427 1251 1331 1250 1332 1332 1250 1251 585 1330 1331 585 1331 583 583 1331 1332 431 1329 1330 431 1330 585 583 584 585 585 584 586 585 586 431 581 582 583 583 582 584 583 1332 581 1408 586 584 1408 584 1409 1409 584 582 431 586 432 431 432 433 433 1329 431 433 1328 1329 581 580 582 1409 582 1410 1410 582 580 1486 1408 1409 1486 1409 1487 1487 1409 1410 1410 580 1411 1487 1410 1488 1488 1410 1411 579 578 580 579 580 581 1411 580 578 1411 578 1412 577 576 578 577 578 579 1412 578 576 581 1333 579 579 1333 1334 579 1334 577 581 1332 1333 1332 1251 1333 1333 1251 1252 1333 1252 1334 1334 1252 1253 1334 1253 1335 577 1334 1335 1251 423 1252 1252 423 424 1252 424 1253 427 422 1251 1251 422 423 422 292 423 423 292 301 423 301 424 424 301 419 424 419 1253 276 300 301 276 301 292 419 301 420 420 301 300 427 292 422 416 300 417 417 300 299 420 300 421 421 300 416 1253 419 420 1253 420 1254 1254 420 421 1254 421 1255 421 416 1255 1255 416 417 417 299 418 1255 417 1256 1256 417 418 1336 1254 1255 1336 1255 1337 1337 1255 1256 1335 1253 1254 1335 1254 1336 575 1335 1336 575 1336 573 573 1336 1337 1337 1256 1338 573 1337 571 571 1337 1338 1256 418 1257 1338 1256 1257 1338 1257 1339 571 1338 569 569 1338 1339 569 570 571 571 570 572 571 572 573 573 572 574 573 574 575 1415 572 570 569 568 570 1415 570 1416 1416 570 568 567 568 569 569 1339 567 567 566 568 1416 568 1417 1417 568 566 1494 1416 1417 1417 566 1418 1494 1417 1495 1495 1417 1418 565 564 566 565 566 567 1418 566 564 567 1339 1340 567 1340 565 563 564 565 565 1340 1341 565 1341 563 563 562 564 1418 564 1419 1419 564 562 561 562 563 563 1341 1342 563 1342 561 1340 1259 1341 1341 1259 1260 1341 1260 1342 1342 1260 1261 1342 1261 1343 561 1342 1343 559 560 561 561 560 562 561 1343 559 1343 1261 1262 1343 1262 1344 559 1343 1344 557 558 559 559 558 560 559 1344 557 1420 562 560 1420 560 1421 1421 560 558 557 556 558 1421 558 1422 1422 558 556 1498 1420 1421 1498 1421 1499 1499 1421 1422 1422 556 1423 1499 1422 1500 1500 1422 1423 555 554 556 555 556 557 1423 556 554 1423 554 1424 1500 1423 1501 1501 1423 1424 696 1499 1500 696 1500 697 697 1500 1501 1501 1424 1502 697 1501 699 699 1501 1502 1424 554 552 1424 552 1425 1502 1424 1425 1502 1425 1503 699 1502 706 706 1502 1503 698 697 699 698 699 700 699 706 700 700 706 707 706 1503 707 1503 1425 1426 1503 1426 1504 707 1503 1504 1425 552 550 1425 550 1426 1426 550 548 1426 548 1427 1504 1426 1427 707 1504 709 700 707 708 708 707 709 708 709 701 708 701 1135 708 1114 700 708 1135 1114 701 1152 1135 1114 1135 1208 1135 1152 1192 1135 1192 1208 1113 1114 1115 700 1114 1113 1114 1208 1115 700 1113 698 1189 698 1113 1189 1113 1190 1190 1113 1115 648 697 698 648 698 1189 1188 648 1189 1188 1189 1186 1186 1189 1190 1186 1190 838 838 1190 836 1190 1115 836 1186 1187 1188 838 840 1186 1186 840 842 1186 842 1187 836 837 838 838 837 839 838 839 840 834 835 836 836 835 837 836 1115 834 937 839 837 937 837 938 938 837 835 840 839 841 840 841 842 842 841 843 843 841 844 843 844 845 1187 842 843 1187 843 845 845 844 846 845 846 847 1207 1187 845 1207 845 847 1136 1188 1187 1136 1187 1207 1145 1136 1207 1145 1207 1106 1106 1207 847 847 846 848 847 848 849 1106 847 849 849 851 1106 849 848 850 849 850 851 644 1145 651 644 1136 1145 644 645 646 651 652 644 644 652 653 644 653 645 644 646 1136 651 650 652 650 1495 652 652 1495 1496 652 1496 653 653 1496 1497 653 1497 645 1495 1418 1496 1496 1418 1419 1496 1419 1497 650 1494 1495 1497 1419 1420 1497 1420 1498 645 1497 1498 1419 562 1420 645 1498 647 647 1498 1499 646 645 647 646 647 648 647 696 648 647 1499 696 646 648 1188 646 1188 1136 648 696 697 834 824 835 825 824 834 1115 825 834 824 825 826 1208 826 825 1115 1208 825 1208 828 826 1208 1192 828 547 548 549 549 548 550 549 1349 547 549 550 551 551 1348 549 549 1348 1349 551 550 552 551 552 553 553 1347 551 551 1347 1348 1347 1266 1348 1348 1266 1267 1348 1267 1349 1349 1267 1268 1266 403 1267 403 400 1267 1267 400 399 1267 399 1268 1265 402 1266 1266 402 403 1347 1265 1266 402 303 403 403 303 400 302 399 400 302 400 303 396 399 302 1268 399 396 264 302 303 264 303 266 266 303 304 402 304 303 401 304 402 1265 401 402 266 304 268 268 304 305 405 305 304 405 304 406 406 304 401 265 264 266 406 401 1265 1264 405 406 1264 406 1265 404 305 405 1263 404 405 1263 405 1264 1345 1263 1264 1345 1264 1346 1346 1264 1265 1346 1265 1347 555 1345 1346 555 1346 553 553 1346 1347 1344 1263 1345 557 1344 1345 557 1345 555 553 554 555 553 552 554 1344 1262 1263 1261 408 1262 1262 408 409 1262 409 1263 1260 412 1261 412 407 1261 1261 407 408 407 297 408 408 297 305 408 305 409 409 305 404 409 404 1263 268 305 297 411 298 297 411 297 412 412 297 407 1260 411 412 1259 411 1260 410 298 411 1259 410 411 414 299 298 414 298 415 415 298 410 415 410 1259 1258 415 1259 1340 1258 1259 1258 414 415 413 299 414 1257 413 414 1257 414 1258 418 299 413 418 413 1257 1339 1257 1258 1339 1258 1340 575 574 576 575 576 577 577 1335 575 690 1487 1488 659 689 690 689 1487 690 689 1486 1487 317 295 318 323 295 317 1243 323 317 1243 317 1244 317 318 1244 1325 1243 1244 441 1325 439 439 440 441 1402 440 1403 1480 1402 1403 1480 1403 1481 621 1480 1481 621 1481 598 987 913 914 1130 1159 1128 776 778 1130 1130 778 1159 1130 774 776 774 775 776 776 775 777 776 777 778 774 773 775 891 777 775 891 775 892 892 775 773 965 891 892 368 313 369 368 371 313 1210 371 368 1210 368 369 807 806 808 367 311 362 362 311 363 363 311 282 1470 1393 1471 588 1470 590 590 1470 1471 1393 460 458 1393 458 1394 1471 1393 1394 590 1471 622 457 458 459 459 458 460))
                   (list :vertices (let ((mat (make-matrix 1522 3))) (fvector-replace (array-entity mat) #f(-1.3350000000000000e+02 6.3129100799560547e+00 -4.9095703125000000e+01 -1.3350000000000000e+02 6.6317300796508789e+00 -5.1575401306152344e+01 -1.3350000000000000e+02 1.4307700157165527e+01 -4.7387100219726562e+01 -1.3350000000000000e+02 1.5030300140380859e+01 -4.9780399322509766e+01 -1.3350000000000000e+02 2.1912200927734375e+01 -4.4385898590087891e+01 -1.3350000000000000e+02 2.3018899917602539e+01 -4.6627498626708984e+01 -1.3350000000000000e+02 2.8919000625610352e+01 -4.0173797607421875e+01 -1.3350000000000000e+02 3.0379600524902344e+01 -4.2202800750732422e+01 -1.3350000000000000e+02 3.5137001037597656e+01 -3.4866001129150391e+01 -1.3350000000000000e+02 3.6911598205566406e+01 -3.6626899719238281e+01 -1.3350000000000000e+02 4.0396602630615234e+01 -2.8607099533081055e+01 -1.3350000000000000e+02 4.2436801910400391e+01 -3.0051900863647461e+01 -1.3350000000000000e+02 4.4554199218750000e+01 -2.1567899703979492e+01 -1.3350000000000000e+02 4.6804397583007812e+01 -2.2657199859619141e+01 -1.3350000000000000e+02 4.7496398925781250e+01 -1.3940299987792969e+01 -1.3350000000000000e+02 4.9895301818847656e+01 -1.4644400596618652e+01 -1.3350000000000000e+02 4.9143199920654297e+01 -5.9325699806213379e+00 -1.3350000000000000e+02 5.1625099182128906e+01 -6.2321400642395020e+00 -1.3350000000000000e+02 4.9449398040771484e+01 2.2370200157165527e+00 -1.3350000000000000e+02 5.1946800231933594e+01 2.3499698638916016e+00 -1.3350000000000000e+02 4.8406799316406250e+01 1.0345599174499512e+01 -1.3350000000000000e+02 5.0851596832275391e+01 1.0868100166320801e+01 -1.3350000000000000e+02 4.6043701171875000e+01 1.8171998977661133e+01 -1.3350000000000000e+02 4.8369197845458984e+01 1.9089799880981445e+01 -1.3350000000000000e+02 4.2424701690673828e+01 2.5502700805664062e+01 -1.3350000000000000e+02 4.4567398071289062e+01 2.6790700912475586e+01 -1.3350000000000000e+02 3.7648498535156250e+01 3.2137798309326172e+01 -1.3350000000000000e+02 3.9549900054931641e+01 3.3760902404785156e+01 -1.3350000000000000e+02 3.1845300674438477e+01 3.7896202087402344e+01 -1.3350000000000000e+02 3.3453598022460938e+01 3.9810199737548828e+01 -1.3350000000000000e+02 2.5173500061035156e+01 4.2620899200439453e+01 -1.3350000000000000e+02 2.6444900512695312e+01 4.4773498535156250e+01 -1.3350000000000000e+02 1.7814901351928711e+01 4.6183002471923828e+01 -1.3350000000000000e+02 1.8714700698852539e+01 4.8515598297119141e+01 -1.3350000000000000e+02 9.9704895019531250e+00 4.8485397338867188e+01 -1.3350000000000000e+02 1.0474100112915039e+01 5.0934200286865234e+01 -1.3350000000000000e+02 1.8540599346160889e+00 4.9465202331542969e+01 -1.3350000000000000e+02 1.9477000236511230e+00 5.1963500976562500e+01 -1.3350000000000000e+02 -6.3129100799560547e+00 4.9095703125000000e+01 -1.3350000000000000e+02 -6.6317300796508789e+00 5.1575401306152344e+01 -1.3350000000000000e+02 -1.4307700157165527e+01 4.7387100219726562e+01 -1.3350000000000000e+02 -1.5030300140380859e+01 4.9780399322509766e+01 -1.3350000000000000e+02 -2.1912200927734375e+01 4.4385898590087891e+01 -1.3350000000000000e+02 -2.3018899917602539e+01 4.6627498626708984e+01 -1.3350000000000000e+02 -2.8919000625610352e+01 4.0173797607421875e+01 -1.3350000000000000e+02 -3.0379600524902344e+01 4.2202800750732422e+01 -1.3350000000000000e+02 -3.5137001037597656e+01 3.4866001129150391e+01 -1.3350000000000000e+02 -3.6911598205566406e+01 3.6626899719238281e+01 -1.3350000000000000e+02 -4.0396602630615234e+01 2.8607099533081055e+01 -1.3350000000000000e+02 -4.2436801910400391e+01 3.0051900863647461e+01 -1.3350000000000000e+02 -4.4554199218750000e+01 2.1567899703979492e+01 -1.3350000000000000e+02 -4.6804397583007812e+01 2.2657199859619141e+01 -1.3350000000000000e+02 -4.7496398925781250e+01 1.3940299987792969e+01 -1.3350000000000000e+02 -4.9895301818847656e+01 1.4644400596618652e+01 -1.3350000000000000e+02 -4.9143199920654297e+01 5.9325699806213379e+00 -1.3350000000000000e+02 -5.1625099182128906e+01 6.2321400642395020e+00 -1.3350000000000000e+02 -4.9449398040771484e+01 -2.2370200157165527e+00 -1.3350000000000000e+02 -5.1946800231933594e+01 -2.3499698638916016e+00 -1.3350000000000000e+02 -4.8406799316406250e+01 -1.0345599174499512e+01 -1.3350000000000000e+02 -5.0851596832275391e+01 -1.0868100166320801e+01 -1.3350000000000000e+02 -4.6043701171875000e+01 -1.8171998977661133e+01 -1.3350000000000000e+02 -4.8369197845458984e+01 -1.9089799880981445e+01 -1.3350000000000000e+02 -4.2424701690673828e+01 -2.5502700805664062e+01 -1.3350000000000000e+02 -4.4567398071289062e+01 -2.6790700912475586e+01 -1.3350000000000000e+02 -3.7648498535156250e+01 -3.2137798309326172e+01 -1.3350000000000000e+02 -3.9549900054931641e+01 -3.3760902404785156e+01 -1.3350000000000000e+02 -3.1845300674438477e+01 -3.7896202087402344e+01 -1.3350000000000000e+02 -3.3453598022460938e+01 -3.9810199737548828e+01 -1.3350000000000000e+02 -2.5173500061035156e+01 -4.2620899200439453e+01 -1.3350000000000000e+02 -2.6444900512695312e+01 -4.4773498535156250e+01 -1.3350000000000000e+02 -1.7814901351928711e+01 -4.6183002471923828e+01 -1.3350000000000000e+02 -1.8714700698852539e+01 -4.8515598297119141e+01 -1.3350000000000000e+02 -9.9704895019531250e+00 -4.8485397338867188e+01 -1.3350000000000000e+02 -1.0474100112915039e+01 -5.0934200286865234e+01 -1.3350000000000000e+02 -1.8540599346160889e+00 -4.9465202331542969e+01 -1.3350000000000000e+02 -1.9477000236511230e+00 -5.1963500976562500e+01 -1.6150000000000000e+02 2.1912200927734375e+01 -4.4385898590087891e+01 -1.6150000000000000e+02 2.3018899917602539e+01 -4.6627498626708984e+01 -1.6150000000000000e+02 1.4307700157165527e+01 -4.7387100219726562e+01 -1.6150000000000000e+02 1.5030300140380859e+01 -4.9780399322509766e+01 -1.6150000000000000e+02 6.3129100799560547e+00 -4.9095703125000000e+01 -1.6150000000000000e+02 6.6317300796508789e+00 -5.1575401306152344e+01 -1.6150000000000000e+02 -1.8540599346160889e+00 -4.9465202331542969e+01 -1.6150000000000000e+02 -1.9477000236511230e+00 -5.1963500976562500e+01 -1.6150000000000000e+02 -9.9704895019531250e+00 -4.8485397338867188e+01 -1.6150000000000000e+02 -1.0474100112915039e+01 -5.0934200286865234e+01 -1.6150000000000000e+02 -1.7814901351928711e+01 -4.6183002471923828e+01 -1.6150000000000000e+02 -1.8714700698852539e+01 -4.8515598297119141e+01 -1.6150000000000000e+02 -2.5173500061035156e+01 -4.2620899200439453e+01 -1.6150000000000000e+02 -2.6444900512695312e+01 -4.4773498535156250e+01 -1.6150000000000000e+02 -3.1845300674438477e+01 -3.7896202087402344e+01 -1.6150000000000000e+02 -3.3453598022460938e+01 -3.9810199737548828e+01 -1.6150000000000000e+02 -3.7648498535156250e+01 -3.2137798309326172e+01 -1.6150000000000000e+02 -3.9549900054931641e+01 -3.3760902404785156e+01 -1.6150000000000000e+02 -4.2424701690673828e+01 -2.5502700805664062e+01 -1.6150000000000000e+02 -4.4567398071289062e+01 -2.6790700912475586e+01 -1.6150000000000000e+02 -4.6043701171875000e+01 -1.8171998977661133e+01 -1.6150000000000000e+02 -4.8369197845458984e+01 -1.9089799880981445e+01 -1.6150000000000000e+02 -4.8406799316406250e+01 -1.0345599174499512e+01 -1.6150000000000000e+02 -5.0851596832275391e+01 -1.0868100166320801e+01 -1.6150000000000000e+02 -4.9449398040771484e+01 -2.2370200157165527e+00 -1.6150000000000000e+02 -5.1946800231933594e+01 -2.3499698638916016e+00 -1.6150000000000000e+02 -4.9143199920654297e+01 5.9325699806213379e+00 -1.6150000000000000e+02 -5.1625099182128906e+01 6.2321400642395020e+00 -1.6150000000000000e+02 -4.7496398925781250e+01 1.3940299987792969e+01 -1.6150000000000000e+02 -4.9895301818847656e+01 1.4644400596618652e+01 -1.6150000000000000e+02 -4.4554199218750000e+01 2.1567899703979492e+01 -1.6150000000000000e+02 -4.6804397583007812e+01 2.2657199859619141e+01 -1.6150000000000000e+02 -4.0396602630615234e+01 2.8607099533081055e+01 -1.6150000000000000e+02 -4.2436801910400391e+01 3.0051900863647461e+01 -1.6150000000000000e+02 -3.5137001037597656e+01 3.4866001129150391e+01 -1.6150000000000000e+02 -3.6911598205566406e+01 3.6626899719238281e+01 -1.6150000000000000e+02 -2.8919000625610352e+01 4.0173797607421875e+01 -1.6150000000000000e+02 -3.0379600524902344e+01 4.2202800750732422e+01 -1.6150000000000000e+02 -2.1912200927734375e+01 4.4385898590087891e+01 -1.6150000000000000e+02 -2.3018899917602539e+01 4.6627498626708984e+01 -1.6150000000000000e+02 -1.4307700157165527e+01 4.7387100219726562e+01 -1.6150000000000000e+02 -1.5030300140380859e+01 4.9780399322509766e+01 -1.6150000000000000e+02 -6.3129100799560547e+00 4.9095703125000000e+01 -1.6150000000000000e+02 -6.6317300796508789e+00 5.1575401306152344e+01 -1.6150000000000000e+02 1.8540599346160889e+00 4.9465202331542969e+01 -1.6150000000000000e+02 1.9477000236511230e+00 5.1963500976562500e+01 -1.6150000000000000e+02 9.9704895019531250e+00 4.8485397338867188e+01 -1.6150000000000000e+02 1.0474100112915039e+01 5.0934200286865234e+01 -1.6150000000000000e+02 1.7814901351928711e+01 4.6183002471923828e+01 -1.6150000000000000e+02 1.8714700698852539e+01 4.8515598297119141e+01 -1.6150000000000000e+02 2.5173500061035156e+01 4.2620899200439453e+01 -1.6150000000000000e+02 2.6444900512695312e+01 4.4773498535156250e+01 -1.6150000000000000e+02 3.1845300674438477e+01 3.7896202087402344e+01 -1.6150000000000000e+02 3.3453598022460938e+01 3.9810199737548828e+01 -1.6150000000000000e+02 3.7648498535156250e+01 3.2137798309326172e+01 -1.6150000000000000e+02 3.9549900054931641e+01 3.3760902404785156e+01 -1.6150000000000000e+02 4.2424701690673828e+01 2.5502700805664062e+01 -1.6150000000000000e+02 4.4567398071289062e+01 2.6790700912475586e+01 -1.6150000000000000e+02 4.6043701171875000e+01 1.8171998977661133e+01 -1.6150000000000000e+02 4.8369197845458984e+01 1.9089799880981445e+01 -1.6150000000000000e+02 4.8406799316406250e+01 1.0345599174499512e+01 -1.6150000000000000e+02 5.0851596832275391e+01 1.0868100166320801e+01 -1.6150000000000000e+02 4.9449398040771484e+01 2.2370200157165527e+00 -1.6150000000000000e+02 5.1946800231933594e+01 2.3499698638916016e+00 -1.6150000000000000e+02 4.9143199920654297e+01 -5.9325699806213379e+00 -1.6150000000000000e+02 5.1625099182128906e+01 -6.2321400642395020e+00 -1.6150000000000000e+02 4.7496398925781250e+01 -1.3940299987792969e+01 -1.6150000000000000e+02 4.9895301818847656e+01 -1.4644400596618652e+01 -1.6150000000000000e+02 4.4554199218750000e+01 -2.1567899703979492e+01 -1.6150000000000000e+02 4.6804397583007812e+01 -2.2657199859619141e+01 -1.6150000000000000e+02 4.0396602630615234e+01 -2.8607099533081055e+01 -1.6150000000000000e+02 4.2436801910400391e+01 -3.0051900863647461e+01 -1.6150000000000000e+02 3.5137001037597656e+01 -3.4866001129150391e+01 -1.6150000000000000e+02 3.6911598205566406e+01 -3.6626899719238281e+01 -1.6150000000000000e+02 2.8919000625610352e+01 -4.0173797607421875e+01 -1.6150000000000000e+02 3.0379600524902344e+01 -4.2202800750732422e+01 -1.3850000000000000e+02 3.8939899444580078e+01 -2.6318799972534180e+01 -1.3850000000000000e+02 -2.4642400741577148e+01 4.0021800994873047e+01 -1.3850000000000000e+02 -1.7524200439453125e+01 4.3610698699951172e+01 -1.3850000000000000e+02 3.3931900024414062e+01 -3.2521099090576172e+01 -1.3850000000000000e+02 2.7947700500488281e+01 -3.7787899017333984e+01 -1.3850000000000000e+02 2.1159500122070312e+01 -4.1967498779296875e+01 -1.3850000000000000e+02 -4.6323898315429688e+01 -7.9430303573608398e+00 -1.3850000000000000e+02 -4.7000000000000000e+01 0.0000000000000000e+00 -1.3850000000000000e+02 -9.9018802642822266e+00 4.5944999694824219e+01 -1.3850000000000000e+02 -1.9947299957275391e+00 4.6957599639892578e+01 -1.3850000000000000e+02 5.9698200225830078e+00 4.6619300842285156e+01 -1.3850000000000000e+02 1.3762700080871582e+01 -4.4939800262451172e+01 -1.3850000000000000e+02 5.9698200225830078e+00 -4.6619300842285156e+01 -1.3850000000000000e+02 -1.9947299957275391e+00 -4.6957599639892578e+01 -1.3850000000000000e+02 -4.6323898315429688e+01 7.9430303573608398e+00 -1.3850000000000000e+02 -4.4315200805664062e+01 1.5657499313354492e+01 -1.3850000000000000e+02 -4.1031700134277344e+01 2.2921600341796875e+01 -1.3850000000000000e+02 -3.6567600250244141e+01 2.9526300430297852e+01 -1.3850000000000000e+02 -3.1051698684692383e+01 3.5281597137451172e+01 -1.3850000000000000e+02 1.3762700080871582e+01 4.4939800262451172e+01 -1.3850000000000000e+02 2.1159500122070312e+01 4.1967498779296875e+01 -1.3850000000000000e+02 2.7947700500488281e+01 3.7787899017333984e+01 -1.3850000000000000e+02 4.6830699920654297e+01 3.9858198165893555e+00 -1.3850000000000000e+02 4.5483398437500000e+01 1.1842999458312988e+01 -1.3850000000000000e+02 4.2827697753906250e+01 1.9359399795532227e+01 -1.3850000000000000e+02 -9.9018802642822266e+00 -4.5944999694824219e+01 -1.3850000000000000e+02 -1.7524200439453125e+01 -4.3610698699951172e+01 -1.3850000000000000e+02 -2.4642400741577148e+01 -4.0021800994873047e+01 -1.3850000000000000e+02 3.3931900024414062e+01 3.2521099090576172e+01 -1.3850000000000000e+02 3.8939899444580078e+01 2.6318799972534180e+01 -1.3850000000000000e+02 4.6830699920654297e+01 -3.9858198165893555e+00 -1.3850000000000000e+02 4.5483398437500000e+01 -1.1842999458312988e+01 -1.3850000000000000e+02 4.2827697753906250e+01 -1.9359399795532227e+01 -1.3850000000000000e+02 -3.1051698684692383e+01 -3.5281597137451172e+01 -1.3850000000000000e+02 -3.6567600250244141e+01 -2.9526300430297852e+01 -1.3850000000000000e+02 -4.4315200805664062e+01 -1.5657499313354492e+01 -1.3850000000000000e+02 -4.1031700134277344e+01 -2.2921600341796875e+01 -1.1900000000000000e+02 -3.0077999114990234e+01 6.3932499885559082e+00 -1.1900000000000000e+02 -3.0750000000000000e+01 0.0000000000000000e+00 -1.1900000000000000e+02 2.8091499328613281e+01 -1.2507100105285645e+01 -1.1900000000000000e+02 -3.0077999114990234e+01 -6.3932499885559082e+00 -1.1900000000000000e+02 -2.8091499328613281e+01 1.2507100105285645e+01 -1.1900000000000000e+02 3.0077999114990234e+01 -6.3932499885559082e+00 -1.1900000000000000e+02 3.0750000000000000e+01 0.0000000000000000e+00 -1.1900000000000000e+02 3.0077999114990234e+01 6.3932499885559082e+00 -1.1900000000000000e+02 2.8091499328613281e+01 1.2507100105285645e+01 -1.1900000000000000e+02 -2.4877300262451172e+01 1.8074399948120117e+01 -1.1900000000000000e+02 -2.0575801849365234e+01 2.2851699829101562e+01 -1.1900000000000000e+02 2.4877300262451172e+01 1.8074399948120117e+01 -1.1900000000000000e+02 2.0575801849365234e+01 2.2851699829101562e+01 -1.1900000000000000e+02 -2.8091499328613281e+01 -1.2507100105285645e+01 -1.1900000000000000e+02 -2.4877300262451172e+01 -1.8074399948120117e+01 -1.1900000000000000e+02 3.2142400741577148e+00 -3.0581501007080078e+01 -1.1900000000000000e+02 -2.0575801849365234e+01 -2.2851699829101562e+01 -1.1900000000000000e+02 9.5022306442260742e+00 -2.9245000839233398e+01 -1.1900000000000000e+02 1.5375000000000000e+01 -2.6630298614501953e+01 -1.1900000000000000e+02 1.5375000000000000e+01 2.6630298614501953e+01 -1.1900000000000000e+02 9.5022306442260742e+00 2.9245000839233398e+01 -1.1900000000000000e+02 3.2142400741577148e+00 3.0581501007080078e+01 -1.1900000000000000e+02 2.0575801849365234e+01 -2.2851699829101562e+01 -1.1900000000000000e+02 2.4877300262451172e+01 -1.8074399948120117e+01 -1.1900000000000000e+02 -1.5375000000000000e+01 -2.6630298614501953e+01 -1.1900000000000000e+02 -9.5022306442260742e+00 -2.9245000839233398e+01 -1.1900000000000000e+02 -3.2142400741577148e+00 -3.0581501007080078e+01 -1.1900000000000000e+02 -3.2142400741577148e+00 3.0581501007080078e+01 -1.1900000000000000e+02 -9.5022306442260742e+00 2.9245000839233398e+01 -1.1900000000000000e+02 -1.5375000000000000e+01 2.6630298614501953e+01 -1.2000000000000000e+02 -3.1056200027465820e+01 6.6011500358581543e+00 -1.2549999237060547e+02 -3.1750001907348633e+01 0.0000000000000000e+00 -1.2000000000000000e+02 -3.1750001907348633e+01 0.0000000000000000e+00 -1.2549999237060547e+02 -3.1056200027465820e+01 -6.6011500358581543e+00 -1.2000000000000000e+02 -3.1056200027465820e+01 -6.6011500358581543e+00 -1.2549999237060547e+02 -2.9005098342895508e+01 -1.2913900375366211e+01 -1.2000000000000000e+02 -2.9005098342895508e+01 -1.2913900375366211e+01 -1.2549999237060547e+02 -2.5686300277709961e+01 -1.8662099838256836e+01 -1.2000000000000000e+02 -2.5686300277709961e+01 -1.8662099838256836e+01 -1.2549999237060547e+02 -2.1244899749755859e+01 -2.3594800949096680e+01 -1.2000000000000000e+02 -2.1244899749755859e+01 -2.3594800949096680e+01 -1.2549999237060547e+02 -1.5875000953674316e+01 -2.7496299743652344e+01 -1.2000000000000000e+02 -1.5875000953674316e+01 -2.7496299743652344e+01 -1.2549999237060547e+02 -9.8112802505493164e+00 -3.0195999145507812e+01 -1.2000000000000000e+02 -9.8112802505493164e+00 -3.0195999145507812e+01 -1.2549999237060547e+02 -3.3187301158905029e+00 -3.1576000213623047e+01 -1.2000000000000000e+02 -3.3187301158905029e+00 -3.1576000213623047e+01 -1.2549999237060547e+02 3.3187301158905029e+00 -3.1576000213623047e+01 -1.2000000000000000e+02 3.3187301158905029e+00 -3.1576000213623047e+01 -1.2549999237060547e+02 9.8112802505493164e+00 -3.0195999145507812e+01 -1.2000000000000000e+02 9.8112802505493164e+00 -3.0195999145507812e+01 -1.2549999237060547e+02 1.5875000953674316e+01 -2.7496299743652344e+01 -1.2000000000000000e+02 1.5875000953674316e+01 -2.7496299743652344e+01 -1.2549999237060547e+02 2.1244899749755859e+01 -2.3594800949096680e+01 -1.2000000000000000e+02 2.1244899749755859e+01 -2.3594800949096680e+01 -1.2549999237060547e+02 2.5686300277709961e+01 -1.8662099838256836e+01 -1.2000000000000000e+02 2.5686300277709961e+01 -1.8662099838256836e+01 -1.2549999237060547e+02 2.9005098342895508e+01 -1.2913900375366211e+01 -1.2000000000000000e+02 2.9005098342895508e+01 -1.2913900375366211e+01 -1.2549999237060547e+02 3.1056200027465820e+01 -6.6011500358581543e+00 -1.2000000000000000e+02 3.1056200027465820e+01 -6.6011500358581543e+00 -1.2549999237060547e+02 3.1750001907348633e+01 0.0000000000000000e+00 -1.2000000000000000e+02 3.1750001907348633e+01 0.0000000000000000e+00 -1.2549999237060547e+02 3.1056200027465820e+01 6.6011500358581543e+00 -1.2000000000000000e+02 3.1056200027465820e+01 6.6011500358581543e+00 -1.2549999237060547e+02 2.9005098342895508e+01 1.2913900375366211e+01 -1.2000000000000000e+02 2.9005098342895508e+01 1.2913900375366211e+01 -1.2549999237060547e+02 2.5686300277709961e+01 1.8662099838256836e+01 -1.2000000000000000e+02 2.5686300277709961e+01 1.8662099838256836e+01 -1.2549999237060547e+02 2.1244899749755859e+01 2.3594800949096680e+01 -1.2000000000000000e+02 2.1244899749755859e+01 2.3594800949096680e+01 -1.2549999237060547e+02 1.5875000953674316e+01 2.7496299743652344e+01 -1.2000000000000000e+02 1.5875000953674316e+01 2.7496299743652344e+01 -1.2549999237060547e+02 9.8112802505493164e+00 3.0195999145507812e+01 -1.2000000000000000e+02 9.8112802505493164e+00 3.0195999145507812e+01 -1.2549999237060547e+02 3.3187301158905029e+00 3.1576000213623047e+01 -1.2000000000000000e+02 3.3187301158905029e+00 3.1576000213623047e+01 -1.2549999237060547e+02 -3.3187301158905029e+00 3.1576000213623047e+01 -1.2000000000000000e+02 -3.3187301158905029e+00 3.1576000213623047e+01 -1.2549999237060547e+02 -9.8112802505493164e+00 3.0195999145507812e+01 -1.2000000000000000e+02 -9.8112802505493164e+00 3.0195999145507812e+01 -1.2549999237060547e+02 -1.5875000953674316e+01 2.7496299743652344e+01 -1.2000000000000000e+02 -1.5875000953674316e+01 2.7496299743652344e+01 -1.2549999237060547e+02 -2.1244899749755859e+01 2.3594800949096680e+01 -1.2000000000000000e+02 -2.1244899749755859e+01 2.3594800949096680e+01 -1.2549999237060547e+02 -2.5686300277709961e+01 1.8662099838256836e+01 -1.2000000000000000e+02 -2.5686300277709961e+01 1.8662099838256836e+01 -1.2549999237060547e+02 -2.9005098342895508e+01 1.2913900375366211e+01 -1.2000000000000000e+02 -2.9005098342895508e+01 1.2913900375366211e+01 -1.2549999237060547e+02 -3.1056200027465820e+01 6.6011500358581543e+00 -1.2549999237060547e+02 1.3175199508666992e+01 -3.0036600112915039e+01 -1.2549999237060547e+02 1.7939399719238281e+01 -2.7458398818969727e+01 -1.2549999237060547e+02 2.2214300155639648e+01 -2.4131099700927734e+01 -1.2549999237060547e+02 2.5883100509643555e+01 -2.0145601272583008e+01 -1.2549999237060547e+02 -8.0516901016235352e+00 -3.1795598983764648e+01 -1.2549999237060547e+02 -2.7084898948669434e+00 -3.2687103271484375e+01 -1.2549999237060547e+02 2.7084898948669434e+00 -3.2687103271484375e+01 -1.2549999237060547e+02 8.0516901016235352e+00 -3.1795598983764648e+01 -1.2549999237060547e+02 -2.8845998764038086e+01 -1.5610699653625488e+01 -1.2549999237060547e+02 -2.5883100509643555e+01 -2.0145601272583008e+01 -1.2549999237060547e+02 -2.2214300155639648e+01 -2.4131099700927734e+01 -1.2549999237060547e+02 -1.7939399719238281e+01 -2.7458398818969727e+01 -1.2549999237060547e+02 -1.3175199508666992e+01 -3.0036600112915039e+01 -1.2549999237060547e+02 -3.1021999359130859e+01 1.0649800300598145e+01 -1.2549999237060547e+02 -3.2351898193359375e+01 5.3985700607299805e+00 -1.2549999237060547e+02 -3.2799198150634766e+01 0.0000000000000000e+00 -1.2549999237060547e+02 -3.2351898193359375e+01 -5.3985700607299805e+00 -1.2549999237060547e+02 -3.1021999359130859e+01 -1.0649800300598145e+01 -1.2549999237060547e+02 -1.3175199508666992e+01 3.0036600112915039e+01 -1.2549999237060547e+02 -1.7939399719238281e+01 2.7458398818969727e+01 -1.2549999237060547e+02 -2.2214300155639648e+01 2.4131099700927734e+01 -1.2549999237060547e+02 -2.5883100509643555e+01 2.0145601272583008e+01 -1.2549999237060547e+02 -2.8845998764038086e+01 1.5610699653625488e+01 -1.2549999237060547e+02 8.0516901016235352e+00 3.1795598983764648e+01 -1.2549999237060547e+02 2.7084898948669434e+00 3.2687103271484375e+01 -1.2549999237060547e+02 -2.7084898948669434e+00 3.2687103271484375e+01 -1.2549999237060547e+02 -8.0516901016235352e+00 3.1795598983764648e+01 -1.2549999237060547e+02 2.8845998764038086e+01 1.5610699653625488e+01 -1.2549999237060547e+02 2.5883100509643555e+01 2.0145601272583008e+01 -1.2549999237060547e+02 2.2214300155639648e+01 2.4131099700927734e+01 -1.2549999237060547e+02 1.7939399719238281e+01 2.7458398818969727e+01 -1.2549999237060547e+02 1.3175199508666992e+01 3.0036600112915039e+01 -1.2549999237060547e+02 2.8845998764038086e+01 -1.5610699653625488e+01 -1.2549999237060547e+02 3.1021999359130859e+01 -1.0649800300598145e+01 -1.2549999237060547e+02 3.2351898193359375e+01 -5.3985700607299805e+00 -1.2549999237060547e+02 3.2799198150634766e+01 0.0000000000000000e+00 -1.2549999237060547e+02 3.2351898193359375e+01 5.3985700607299805e+00 -1.2549999237060547e+02 3.1021999359130859e+01 1.0649800300598145e+01 -1.3024499511718750e+02 -4.9811901092529297e+01 -8.3118095397949219e+00 -1.3024499511718750e+02 -4.9854698181152344e+01 -8.1021804809570312e+00 -1.3024499511718750e+02 -5.0345001220703125e+01 -4.0642600059509277e+00 -1.3024499511718750e+02 -5.0508800506591797e+01 0.0000000000000000e+00 -1.3024499511718750e+02 -4.7757701873779297e+01 -1.6394701004028320e+01 -1.3024499511718750e+02 -4.7909400939941406e+01 -1.5994500160217285e+01 -1.3024499511718750e+02 -4.9041099548339844e+01 -1.2087499618530273e+01 -1.3024499511718750e+02 -4.4402301788330078e+01 -2.4028598785400391e+01 -1.3024499511718750e+02 -4.4723297119140625e+01 -2.3472599029541016e+01 -1.3024499511718750e+02 -4.6467098236083984e+01 -1.9797698974609375e+01 -1.3024499511718750e+02 -3.9837402343750000e+01 -3.1005899429321289e+01 -1.3024499511718750e+02 -4.0378898620605469e+01 -3.0342800140380859e+01 -1.3024499511718750e+02 -4.2689498901367188e+01 -2.6995201110839844e+01 -1.3024499511718750e+02 -3.4187599182128906e+01 -3.7136699676513672e+01 -1.3024499511718750e+02 -3.4988601684570312e+01 -3.6427101135253906e+01 -1.3024499511718750e+02 -3.7806400299072266e+01 -3.3493499755859375e+01 -1.3024499511718750e+02 -2.7606800079345703e+01 -4.2254299163818359e+01 -1.3024499511718750e+02 -2.8692201614379883e+01 -4.1567897796630859e+01 -1.3024499511718750e+02 -3.1943998336791992e+01 -3.9124401092529297e+01 -1.3024499511718750e+02 -2.0274200439453125e+01 -4.6219501495361328e+01 -1.3024499511718750e+02 -2.1652799606323242e+01 -4.5632198333740234e+01 -1.3024499511718750e+02 -2.5254400253295898e+01 -4.3741901397705078e+01 -1.3024499511718750e+02 -1.2389600753784180e+01 -4.8924400329589844e+01 -1.3024499511718750e+02 -1.4052400588989258e+01 -4.8514602661132812e+01 -1.3024499511718750e+02 -1.7910598754882812e+01 -4.7226501464843750e+01 -1.3024499511718750e+02 -1.0103000640869141e+01 -4.9488101959228516e+01 -1.3024499511718750e+02 -6.0881400108337402e+00 -5.0140499114990234e+01 -1.3024499511718750e+02 2.0337700843811035e+00 -5.0467800140380859e+01 -1.3024499511718750e+02 -2.0337700843811035e+00 -5.0467800140380859e+01 -1.3024499511718750e+02 -4.1676802635192871e+00 -5.0295597076416016e+01 -1.3024499511718750e+02 1.0103000640869141e+01 -4.9488101959228516e+01 -1.3024499511718750e+02 6.0881400108337402e+00 -5.0140499114990234e+01 -1.3024499511718750e+02 4.1676802635192871e+00 -5.0295597076416016e+01 -1.3024499511718750e+02 1.7910598754882812e+01 -4.7226501464843750e+01 -1.3024499511718750e+02 1.4052400588989258e+01 -4.8514602661132812e+01 -1.3024499511718750e+02 1.2389600753784180e+01 -4.8924400329589844e+01 -1.3024499511718750e+02 2.5254400253295898e+01 -4.3741901397705078e+01 -1.3024499511718750e+02 2.1652799606323242e+01 -4.5632198333740234e+01 -1.3024499511718750e+02 2.0274200439453125e+01 -4.6219501495361328e+01 -1.3024499511718750e+02 3.1943998336791992e+01 -3.9124401092529297e+01 -1.3024499511718750e+02 2.8692201614379883e+01 -4.1567897796630859e+01 -1.3024499511718750e+02 2.7606800079345703e+01 -4.2254299163818359e+01 -1.3024499511718750e+02 3.7806400299072266e+01 -3.3493499755859375e+01 -1.3024499511718750e+02 3.4988601684570312e+01 -3.6427101135253906e+01 -1.3024499511718750e+02 3.4187599182128906e+01 -3.7136699676513672e+01 -1.3024499511718750e+02 4.2689498901367188e+01 -2.6995201110839844e+01 -1.3024499511718750e+02 4.0378898620605469e+01 -3.0342800140380859e+01 -1.3024499511718750e+02 3.9837402343750000e+01 -3.1005899429321289e+01 -1.3024499511718750e+02 4.6467098236083984e+01 -1.9797698974609375e+01 -1.3024499511718750e+02 4.4723297119140625e+01 -2.3472599029541016e+01 -1.3024499511718750e+02 4.4402301788330078e+01 -2.4028598785400391e+01 -1.3024499511718750e+02 4.9041099548339844e+01 -1.2087499618530273e+01 -1.3024499511718750e+02 4.7909400939941406e+01 -1.5994500160217285e+01 -1.3024499511718750e+02 4.7757701873779297e+01 -1.6394701004028320e+01 -1.3024499511718750e+02 4.9811901092529297e+01 -8.3118095397949219e+00 -1.3024499511718750e+02 4.9854698181152344e+01 -8.1021804809570312e+00 -1.3024499511718750e+02 5.0345001220703125e+01 -4.0642600059509277e+00 -1.3024499511718750e+02 5.0508800506591797e+01 0.0000000000000000e+00 -1.3024499511718750e+02 4.9811901092529297e+01 8.3118095397949219e+00 -1.3024499511718750e+02 4.9854698181152344e+01 8.1021804809570312e+00 -1.3024499511718750e+02 5.0345001220703125e+01 4.0642600059509277e+00 -1.3024499511718750e+02 4.7757701873779297e+01 1.6394701004028320e+01 -1.3024499511718750e+02 4.7909400939941406e+01 1.5994500160217285e+01 -1.3024499511718750e+02 4.9041099548339844e+01 1.2087499618530273e+01 -1.3024499511718750e+02 4.4402301788330078e+01 2.4028598785400391e+01 -1.3024499511718750e+02 4.4723297119140625e+01 2.3472599029541016e+01 -1.3024499511718750e+02 4.6467098236083984e+01 1.9797698974609375e+01 -1.3024499511718750e+02 3.9837402343750000e+01 3.1005899429321289e+01 -1.3024499511718750e+02 4.0378898620605469e+01 3.0342800140380859e+01 -1.3024499511718750e+02 4.2689498901367188e+01 2.6995201110839844e+01 -1.3024499511718750e+02 3.4187599182128906e+01 3.7136699676513672e+01 -1.3024499511718750e+02 3.4988601684570312e+01 3.6427101135253906e+01 -1.3024499511718750e+02 3.7806400299072266e+01 3.3493499755859375e+01 -1.3024499511718750e+02 2.7606800079345703e+01 4.2254299163818359e+01 -1.3024499511718750e+02 2.8692201614379883e+01 4.1567897796630859e+01 -1.3024499511718750e+02 3.1943998336791992e+01 3.9124401092529297e+01 -1.3024499511718750e+02 2.0274200439453125e+01 4.6219501495361328e+01 -1.3024499511718750e+02 2.1652799606323242e+01 4.5632198333740234e+01 -1.3024499511718750e+02 2.5254400253295898e+01 4.3741901397705078e+01 -1.3024499511718750e+02 1.2389600753784180e+01 4.8924400329589844e+01 -1.3024499511718750e+02 1.4052400588989258e+01 4.8514602661132812e+01 -1.3024499511718750e+02 1.7910598754882812e+01 4.7226501464843750e+01 -1.3024499511718750e+02 1.0103000640869141e+01 4.9488101959228516e+01 -1.3024499511718750e+02 6.0881400108337402e+00 5.0140499114990234e+01 -1.3024499511718750e+02 -2.0337700843811035e+00 5.0467800140380859e+01 -1.3024499511718750e+02 2.0337700843811035e+00 5.0467800140380859e+01 -1.3024499511718750e+02 4.1676802635192871e+00 5.0295597076416016e+01 -1.3024499511718750e+02 -1.0103000640869141e+01 4.9488101959228516e+01 -1.3024499511718750e+02 -6.0881400108337402e+00 5.0140499114990234e+01 -1.3024499511718750e+02 -4.1676802635192871e+00 5.0295597076416016e+01 -1.3024499511718750e+02 -1.7910598754882812e+01 4.7226501464843750e+01 -1.3024499511718750e+02 -1.4052400588989258e+01 4.8514602661132812e+01 -1.3024499511718750e+02 -1.2389600753784180e+01 4.8924400329589844e+01 -1.3024499511718750e+02 -2.5254400253295898e+01 4.3741901397705078e+01 -1.3024499511718750e+02 -2.1652799606323242e+01 4.5632198333740234e+01 -1.3024499511718750e+02 -2.0274200439453125e+01 4.6219501495361328e+01 -1.3024499511718750e+02 -3.1943998336791992e+01 3.9124401092529297e+01 -1.3024499511718750e+02 -2.8692201614379883e+01 4.1567897796630859e+01 -1.3024499511718750e+02 -2.7606800079345703e+01 4.2254299163818359e+01 -1.3024499511718750e+02 -3.7806400299072266e+01 3.3493499755859375e+01 -1.3024499511718750e+02 -3.4988601684570312e+01 3.6427101135253906e+01 -1.3024499511718750e+02 -3.4187599182128906e+01 3.7136699676513672e+01 -1.3024499511718750e+02 -4.2689498901367188e+01 2.6995201110839844e+01 -1.3024499511718750e+02 -4.0378898620605469e+01 3.0342800140380859e+01 -1.3024499511718750e+02 -3.9837402343750000e+01 3.1005899429321289e+01 -1.3024499511718750e+02 -4.6467098236083984e+01 1.9797698974609375e+01 -1.3024499511718750e+02 -4.4723297119140625e+01 2.3472599029541016e+01 -1.3024499511718750e+02 -4.4402301788330078e+01 2.4028598785400391e+01 -1.3024499511718750e+02 -4.9041099548339844e+01 1.2087499618530273e+01 -1.3024499511718750e+02 -4.7909400939941406e+01 1.5994500160217285e+01 -1.3024499511718750e+02 -4.7757701873779297e+01 1.6394701004028320e+01 -1.3024499511718750e+02 -4.9811901092529297e+01 8.3118095397949219e+00 -1.3024499511718750e+02 -4.9854698181152344e+01 8.1021804809570312e+00 -1.3024499511718750e+02 -5.0345001220703125e+01 4.0642600059509277e+00 -1.3121099853515625e+02 -5.1083801269531250e+01 4.1238698959350586e+00 -1.3200000000000000e+02 -5.1083801269531250e+01 4.1238698959350586e+00 -1.3121099853515625e+02 -5.1250000000000000e+01 0.0000000000000000e+00 -1.3200000000000000e+02 -5.1250000000000000e+01 0.0000000000000000e+00 -1.3121099853515625e+02 -5.1083801269531250e+01 -4.1238698959350586e+00 -1.3200000000000000e+02 -5.1083801269531250e+01 -4.1238698959350586e+00 -1.3121099853515625e+02 -5.0586303710937500e+01 -8.2210302352905273e+00 -1.3200000000000000e+02 -5.0586303710937500e+01 -8.2210302352905273e+00 -1.3121099853515625e+02 -4.9760799407958984e+01 -1.2264900207519531e+01 -1.3200000000000000e+02 -4.9760799407958984e+01 -1.2264900207519531e+01 -1.3121099853515625e+02 -4.8612503051757812e+01 -1.6229198455810547e+01 -1.3200000000000000e+02 -4.8612503051757812e+01 -1.6229198455810547e+01 -1.3121099853515625e+02 -4.7148899078369141e+01 -2.0088199615478516e+01 -1.3200000000000000e+02 -4.7148899078369141e+01 -2.0088199615478516e+01 -1.3121099853515625e+02 -4.5379600524902344e+01 -2.3817100524902344e+01 -1.3200000000000000e+02 -4.5379600524902344e+01 -2.3817100524902344e+01 -1.3121099853515625e+02 -4.3315898895263672e+01 -2.7391399383544922e+01 -1.3200000000000000e+02 -4.3315898895263672e+01 -2.7391399383544922e+01 -1.3121099853515625e+02 -4.0971397399902344e+01 -3.0788000106811523e+01 -1.3200000000000000e+02 -4.0971397399902344e+01 -3.0788000106811523e+01 -1.3121099853515625e+02 -3.8361099243164062e+01 -3.3985000610351562e+01 -1.3200000000000000e+02 -3.8361099243164062e+01 -3.3985000610351562e+01 -1.3121099853515625e+02 -3.5502098083496094e+01 -3.6961601257324219e+01 -1.3200000000000000e+02 -3.5502098083496094e+01 -3.6961601257324219e+01 -1.3121099853515625e+02 -3.2412799835205078e+01 -3.9698501586914062e+01 -1.3200000000000000e+02 -3.2412799835205078e+01 -3.9698501586914062e+01 -1.3121099853515625e+02 -2.9113300323486328e+01 -4.2177902221679688e+01 -1.3200000000000000e+02 -2.9113300323486328e+01 -4.2177902221679688e+01 -1.3121099853515625e+02 -2.5625000000000000e+01 -4.4383800506591797e+01 -1.3200000000000000e+02 -2.5625000000000000e+01 -4.4383800506591797e+01 -1.3121099853515625e+02 -2.1970399856567383e+01 -4.6301799774169922e+01 -1.3200000000000000e+02 -2.1970399856567383e+01 -4.6301799774169922e+01 -1.3121099853515625e+02 -1.8173500061035156e+01 -4.7919601440429688e+01 -1.3200000000000000e+02 -1.8173500061035156e+01 -4.7919601440429688e+01 -1.3121099853515625e+02 -1.4258600234985352e+01 -4.9226501464843750e+01 -1.3200000000000000e+02 -1.4258600234985352e+01 -4.9226501464843750e+01 -1.3121099853515625e+02 -1.0251300811767578e+01 -5.0214202880859375e+01 -1.3200000000000000e+02 -1.0251300811767578e+01 -5.0214202880859375e+01 -1.3121099853515625e+02 -6.1774797439575195e+00 -5.0876300811767578e+01 -1.3200000000000000e+02 -6.1774797439575195e+00 -5.0876300811767578e+01 -1.3121099853515625e+02 -2.0635700225830078e+00 -5.1208400726318359e+01 -1.3200000000000000e+02 -2.0635700225830078e+00 -5.1208400726318359e+01 -1.3121099853515625e+02 2.0635700225830078e+00 -5.1208400726318359e+01 -1.3200000000000000e+02 2.0635700225830078e+00 -5.1208400726318359e+01 -1.3121099853515625e+02 6.1774797439575195e+00 -5.0876300811767578e+01 -1.3200000000000000e+02 6.1774797439575195e+00 -5.0876300811767578e+01 -1.3121099853515625e+02 1.0251300811767578e+01 -5.0214202880859375e+01 -1.3200000000000000e+02 1.0251300811767578e+01 -5.0214202880859375e+01 -1.3121099853515625e+02 1.4258600234985352e+01 -4.9226501464843750e+01 -1.3200000000000000e+02 1.4258600234985352e+01 -4.9226501464843750e+01 -1.3121099853515625e+02 1.8173500061035156e+01 -4.7919601440429688e+01 -1.3200000000000000e+02 1.8173500061035156e+01 -4.7919601440429688e+01 -1.3121099853515625e+02 2.1970399856567383e+01 -4.6301799774169922e+01 -1.3200000000000000e+02 2.1970399856567383e+01 -4.6301799774169922e+01 -1.3121099853515625e+02 2.5625000000000000e+01 -4.4383800506591797e+01 -1.3200000000000000e+02 2.5625000000000000e+01 -4.4383800506591797e+01 -1.3121099853515625e+02 2.9113300323486328e+01 -4.2177902221679688e+01 -1.3200000000000000e+02 2.9113300323486328e+01 -4.2177902221679688e+01 -1.3121099853515625e+02 3.2412799835205078e+01 -3.9698501586914062e+01 -1.3200000000000000e+02 3.2412799835205078e+01 -3.9698501586914062e+01 -1.3121099853515625e+02 3.5502098083496094e+01 -3.6961601257324219e+01 -1.3200000000000000e+02 3.5502098083496094e+01 -3.6961601257324219e+01 -1.3121099853515625e+02 3.8361099243164062e+01 -3.3985000610351562e+01 -1.3200000000000000e+02 3.8361099243164062e+01 -3.3985000610351562e+01 -1.3121099853515625e+02 4.0971397399902344e+01 -3.0788000106811523e+01 -1.3200000000000000e+02 4.0971397399902344e+01 -3.0788000106811523e+01 -1.3121099853515625e+02 4.3315898895263672e+01 -2.7391399383544922e+01 -1.3200000000000000e+02 4.3315898895263672e+01 -2.7391399383544922e+01 -1.3121099853515625e+02 4.5379600524902344e+01 -2.3817100524902344e+01 -1.3200000000000000e+02 4.5379600524902344e+01 -2.3817100524902344e+01 -1.3121099853515625e+02 4.7148899078369141e+01 -2.0088199615478516e+01 -1.3200000000000000e+02 4.7148899078369141e+01 -2.0088199615478516e+01 -1.3121099853515625e+02 4.8612503051757812e+01 -1.6229198455810547e+01 -1.3200000000000000e+02 4.8612503051757812e+01 -1.6229198455810547e+01 -1.3121099853515625e+02 4.9760799407958984e+01 -1.2264900207519531e+01 -1.3200000000000000e+02 4.9760799407958984e+01 -1.2264900207519531e+01 -1.3121099853515625e+02 5.0586303710937500e+01 -8.2210302352905273e+00 -1.3200000000000000e+02 5.0586303710937500e+01 -8.2210302352905273e+00 -1.3121099853515625e+02 5.1083801269531250e+01 -4.1238698959350586e+00 -1.3200000000000000e+02 5.1083801269531250e+01 -4.1238698959350586e+00 -1.3121099853515625e+02 5.1250000000000000e+01 0.0000000000000000e+00 -1.3200000000000000e+02 5.1250000000000000e+01 0.0000000000000000e+00 -1.3121099853515625e+02 5.1083801269531250e+01 4.1238698959350586e+00 -1.3200000000000000e+02 5.1083801269531250e+01 4.1238698959350586e+00 -1.3121099853515625e+02 5.0586303710937500e+01 8.2210302352905273e+00 -1.3200000000000000e+02 5.0586303710937500e+01 8.2210302352905273e+00 -1.3121099853515625e+02 4.9760799407958984e+01 1.2264900207519531e+01 -1.3200000000000000e+02 4.9760799407958984e+01 1.2264900207519531e+01 -1.3121099853515625e+02 4.8612503051757812e+01 1.6229198455810547e+01 -1.3200000000000000e+02 4.8612503051757812e+01 1.6229198455810547e+01 -1.3121099853515625e+02 4.7148899078369141e+01 2.0088199615478516e+01 -1.3200000000000000e+02 4.7148899078369141e+01 2.0088199615478516e+01 -1.3121099853515625e+02 4.5379600524902344e+01 2.3817100524902344e+01 -1.3200000000000000e+02 4.5379600524902344e+01 2.3817100524902344e+01 -1.3121099853515625e+02 4.3315898895263672e+01 2.7391399383544922e+01 -1.3200000000000000e+02 4.3315898895263672e+01 2.7391399383544922e+01 -1.3121099853515625e+02 4.0971397399902344e+01 3.0788000106811523e+01 -1.3200000000000000e+02 4.0971397399902344e+01 3.0788000106811523e+01 -1.3121099853515625e+02 3.8361099243164062e+01 3.3985000610351562e+01 -1.3200000000000000e+02 3.8361099243164062e+01 3.3985000610351562e+01 -1.3121099853515625e+02 3.5502098083496094e+01 3.6961601257324219e+01 -1.3200000000000000e+02 3.5502098083496094e+01 3.6961601257324219e+01 -1.3121099853515625e+02 3.2412799835205078e+01 3.9698501586914062e+01 -1.3200000000000000e+02 3.2412799835205078e+01 3.9698501586914062e+01 -1.3121099853515625e+02 2.9113300323486328e+01 4.2177902221679688e+01 -1.3200000000000000e+02 2.9113300323486328e+01 4.2177902221679688e+01 -1.3121099853515625e+02 2.5625000000000000e+01 4.4383800506591797e+01 -1.3200000000000000e+02 2.5625000000000000e+01 4.4383800506591797e+01 -1.3121099853515625e+02 2.1970399856567383e+01 4.6301799774169922e+01 -1.3200000000000000e+02 2.1970399856567383e+01 4.6301799774169922e+01 -1.3121099853515625e+02 1.8173500061035156e+01 4.7919601440429688e+01 -1.3200000000000000e+02 1.8173500061035156e+01 4.7919601440429688e+01 -1.3121099853515625e+02 1.4258600234985352e+01 4.9226501464843750e+01 -1.3200000000000000e+02 1.4258600234985352e+01 4.9226501464843750e+01 -1.3121099853515625e+02 1.0251300811767578e+01 5.0214202880859375e+01 -1.3200000000000000e+02 1.0251300811767578e+01 5.0214202880859375e+01 -1.3121099853515625e+02 6.1774797439575195e+00 5.0876300811767578e+01 -1.3200000000000000e+02 6.1774797439575195e+00 5.0876300811767578e+01 -1.3121099853515625e+02 2.0635700225830078e+00 5.1208400726318359e+01 -1.3200000000000000e+02 2.0635700225830078e+00 5.1208400726318359e+01 -1.3121099853515625e+02 -2.0635700225830078e+00 5.1208400726318359e+01 -1.3200000000000000e+02 -2.0635700225830078e+00 5.1208400726318359e+01 -1.3121099853515625e+02 -6.1774797439575195e+00 5.0876300811767578e+01 -1.3200000000000000e+02 -6.1774797439575195e+00 5.0876300811767578e+01 -1.3121099853515625e+02 -1.0251300811767578e+01 5.0214202880859375e+01 -1.3200000000000000e+02 -1.0251300811767578e+01 5.0214202880859375e+01 -1.3121099853515625e+02 -1.4258600234985352e+01 4.9226501464843750e+01 -1.3200000000000000e+02 -1.4258600234985352e+01 4.9226501464843750e+01 -1.3121099853515625e+02 -1.8173500061035156e+01 4.7919601440429688e+01 -1.3200000000000000e+02 -1.8173500061035156e+01 4.7919601440429688e+01 -1.3121099853515625e+02 -2.1970399856567383e+01 4.6301799774169922e+01 -1.3200000000000000e+02 -2.1970399856567383e+01 4.6301799774169922e+01 -1.3121099853515625e+02 -2.5625000000000000e+01 4.4383800506591797e+01 -1.3200000000000000e+02 -2.5625000000000000e+01 4.4383800506591797e+01 -1.3121099853515625e+02 -2.9113300323486328e+01 4.2177902221679688e+01 -1.3200000000000000e+02 -2.9113300323486328e+01 4.2177902221679688e+01 -1.3121099853515625e+02 -3.2412799835205078e+01 3.9698501586914062e+01 -1.3200000000000000e+02 -3.2412799835205078e+01 3.9698501586914062e+01 -1.3121099853515625e+02 -3.5502098083496094e+01 3.6961601257324219e+01 -1.3200000000000000e+02 -3.5502098083496094e+01 3.6961601257324219e+01 -1.3121099853515625e+02 -3.8361099243164062e+01 3.3985000610351562e+01 -1.3200000000000000e+02 -3.8361099243164062e+01 3.3985000610351562e+01 -1.3121099853515625e+02 -4.0971397399902344e+01 3.0788000106811523e+01 -1.3200000000000000e+02 -4.0971397399902344e+01 3.0788000106811523e+01 -1.3121099853515625e+02 -4.3315898895263672e+01 2.7391399383544922e+01 -1.3200000000000000e+02 -4.3315898895263672e+01 2.7391399383544922e+01 -1.3121099853515625e+02 -4.5379600524902344e+01 2.3817100524902344e+01 -1.3200000000000000e+02 -4.5379600524902344e+01 2.3817100524902344e+01 -1.3121099853515625e+02 -4.7148899078369141e+01 2.0088199615478516e+01 -1.3200000000000000e+02 -4.7148899078369141e+01 2.0088199615478516e+01 -1.3121099853515625e+02 -4.8612503051757812e+01 1.6229198455810547e+01 -1.3200000000000000e+02 -4.8612503051757812e+01 1.6229198455810547e+01 -1.3121099853515625e+02 -4.9760799407958984e+01 1.2264900207519531e+01 -1.3200000000000000e+02 -4.9760799407958984e+01 1.2264900207519531e+01 -1.3121099853515625e+02 -5.0586303710937500e+01 8.2210302352905273e+00 -1.3200000000000000e+02 -5.0586303710937500e+01 8.2210302352905273e+00 -1.3250000000000000e+02 -1.5693201065063477e+01 -4.6418998718261719e+01 -1.3250000000000000e+02 -1.7996198654174805e+01 -4.7451999664306641e+01 -1.3250000000000000e+02 -2.1073200225830078e+01 -4.4237098693847656e+01 -1.3250000000000000e+02 -2.1756099700927734e+01 -4.5850101470947266e+01 -1.3250000000000000e+02 -2.6157300949096680e+01 -4.1434200286865234e+01 -1.3250000000000000e+02 -4.3509597778320312e+00 -4.8806400299072266e+01 -1.3250000000000000e+02 -6.1172199249267578e+00 -5.0379898071289062e+01 -1.3250000000000000e+02 -1.0092900276184082e+01 -4.7949298858642578e+01 -1.3250000000000000e+02 -1.0151299476623535e+01 -4.9724300384521484e+01 -1.3250000000000000e+02 -1.4119500160217285e+01 -4.8746299743652344e+01 -1.3250000000000000e+02 -4.6863601684570312e+01 -1.4310799598693848e+01 -1.3250000000000000e+02 -4.9275302886962891e+01 -1.2145199775695801e+01 -1.3250000000000000e+02 -4.8227298736572266e+01 -8.6675901412963867e+00 -1.3250000000000000e+02 -5.0092700958251953e+01 -8.1408605575561523e+00 -1.3250000000000000e+02 -4.8913898468017578e+01 -2.9027500152587891e+00 -1.3250000000000000e+02 1.8415498733520508e+01 -4.5407798767089844e+01 -1.3250000000000000e+02 1.7996198654174805e+01 -4.7451999664306641e+01 -1.3250000000000000e+02 1.2915699958801270e+01 -4.7267101287841797e+01 -1.3250000000000000e+02 1.4119500160217285e+01 -4.8746299743652344e+01 -1.3250000000000000e+02 7.2346301078796387e+00 -4.8462902069091797e+01 -1.3250000000000000e+02 -3.5157798767089844e+01 -3.4131000518798828e+01 -1.3250000000000000e+02 -3.7986900329589844e+01 -3.3653400421142578e+01 -1.3250000000000000e+02 -3.8947799682617188e+01 -2.9733200073242188e+01 -1.3250000000000000e+02 -4.0571701049804688e+01 -3.0487600326538086e+01 -1.3250000000000000e+02 -4.2191101074218750e+01 -2.4917999267578125e+01 -1.3250000000000000e+02 1.0151299476623535e+01 -4.9724300384521484e+01 -1.3250000000000000e+02 6.1172199249267578e+00 -5.0379898071289062e+01 -1.3250000000000000e+02 1.4520300626754761e+00 -4.8978401184082031e+01 -1.3250000000000000e+02 2.0434801578521729e+00 -5.0708801269531250e+01 -1.3250000000000000e+02 -2.0434801578521729e+00 -5.0708801269531250e+01 -1.3250000000000000e+02 -4.2893398284912109e+01 -2.7124099731445312e+01 -1.3250000000000000e+02 -4.4936897277832031e+01 -2.3584699630737305e+01 -1.3250000000000000e+02 -4.4842102050781250e+01 -1.9753000259399414e+01 -1.3250000000000000e+02 -4.6688899993896484e+01 -1.9892299652099609e+01 -1.3250000000000000e+02 -4.8138202667236328e+01 -1.6070899963378906e+01 -1.3250000000000000e+02 -2.5374900817871094e+01 -4.3950698852539062e+01 -1.3250000000000000e+02 -2.8829299926757812e+01 -4.1766403198242188e+01 -1.3250000000000000e+02 -3.0874300003051758e+01 -3.8049602508544922e+01 -1.3250000000000000e+02 -3.2096599578857422e+01 -3.9311199188232422e+01 -1.3250000000000000e+02 -3.5155696868896484e+01 -3.6600997924804688e+01 -1.3250000000000000e+02 3.3074100494384766e+01 -3.6153800964355469e+01 -1.3250000000000000e+02 3.2096599578857422e+01 -3.9311199188232422e+01 -1.3250000000000000e+02 2.8565900802612305e+01 -3.9811801910400391e+01 -1.3250000000000000e+02 2.8829299926757812e+01 -4.1766403198242188e+01 -1.3250000000000000e+02 2.3656801223754883e+01 -4.2910999298095703e+01 -1.3250000000000000e+02 2.5374900817871094e+01 -4.3950698852539062e+01 -1.3250000000000000e+02 2.1756099700927734e+01 -4.5850101470947266e+01 -1.3250000000000000e+02 4.0640800476074219e+01 -2.7373699188232422e+01 -1.3250000000000000e+02 4.0571701049804688e+01 -3.0487600326538086e+01 -1.3250000000000000e+02 3.7118000030517578e+01 -3.1988300323486328e+01 -1.3250000000000000e+02 3.7986900329589844e+01 -3.3653400421142578e+01 -1.3250000000000000e+02 3.5155696868896484e+01 -3.6600997924804688e+01 -1.3250000000000000e+02 4.5933498382568359e+01 -1.7061800003051758e+01 -1.3250000000000000e+02 4.6688899993896484e+01 -1.9892299652099609e+01 -1.3250000000000000e+02 4.3593200683593750e+01 -2.2374799728393555e+01 -1.3250000000000000e+02 4.4936897277832031e+01 -2.3584699630737305e+01 -1.3250000000000000e+02 4.2893398284912109e+01 -2.7124099731445312e+01 -1.3250000000000000e+02 -2.6157300949096680e+01 4.1434200286865234e+01 -1.3250000000000000e+02 -2.5374900817871094e+01 4.3950698852539062e+01 -1.3250000000000000e+02 -2.1073200225830078e+01 4.4237098693847656e+01 -1.3250000000000000e+02 -2.1756099700927734e+01 4.5850101470947266e+01 -1.3250000000000000e+02 -1.5693201065063477e+01 4.6418998718261719e+01 -1.3250000000000000e+02 -3.5157798767089844e+01 3.4131000518798828e+01 -1.3250000000000000e+02 -3.5155696868896484e+01 3.6600997924804688e+01 -1.3250000000000000e+02 -3.0874300003051758e+01 3.8049602508544922e+01 -1.3250000000000000e+02 -3.2096599578857422e+01 3.9311199188232422e+01 -1.3250000000000000e+02 -2.8829299926757812e+01 4.1766403198242188e+01 -1.3250000000000000e+02 4.5933498382568359e+01 1.7061800003051758e+01 -1.3250000000000000e+02 4.8138202667236328e+01 1.6070899963378906e+01 -1.3250000000000000e+02 4.7629100799560547e+01 1.1509399414062500e+01 -1.3250000000000000e+02 4.9275302886962891e+01 1.2145199775695801e+01 -1.3250000000000000e+02 4.8656002044677734e+01 5.7953600883483887e+00 -1.3250000000000000e+02 -4.6863601684570312e+01 1.4310799598693848e+01 -1.3250000000000000e+02 -4.8138202667236328e+01 1.6070899963378906e+01 -1.3250000000000000e+02 -4.4842102050781250e+01 1.9753000259399414e+01 -1.3250000000000000e+02 -4.6688899993896484e+01 1.9892299652099609e+01 -1.3250000000000000e+02 -4.2191101074218750e+01 2.4917999267578125e+01 -1.3250000000000000e+02 4.8656002044677734e+01 -5.7953600883483887e+00 -1.3250000000000000e+02 5.0092700958251953e+01 -8.1408605575561523e+00 -1.3250000000000000e+02 4.7629100799560547e+01 -1.1509399414062500e+01 -1.3250000000000000e+02 4.9275302886962891e+01 -1.2145199775695801e+01 -1.3250000000000000e+02 4.8138202667236328e+01 -1.6070899963378906e+01 -1.3250000000000000e+02 5.0092700958251953e+01 8.1408605575561523e+00 -1.3250000000000000e+02 5.0585399627685547e+01 4.0836300849914551e+00 -1.3250000000000000e+02 4.9000000000000000e+01 0.0000000000000000e+00 -1.3250000000000000e+02 5.0750000000000000e+01 0.0000000000000000e+00 -1.3250000000000000e+02 5.0585399627685547e+01 -4.0836300849914551e+00 -1.3250000000000000e+02 4.0640800476074219e+01 2.7373699188232422e+01 -1.3250000000000000e+02 4.2893398284912109e+01 2.7124099731445312e+01 -1.3250000000000000e+02 4.3593200683593750e+01 2.2374799728393555e+01 -1.3250000000000000e+02 4.4936897277832031e+01 2.3584699630737305e+01 -1.3250000000000000e+02 4.6688899993896484e+01 1.9892299652099609e+01 -1.3250000000000000e+02 -4.4936897277832031e+01 2.3584699630737305e+01 -1.3250000000000000e+02 -4.2893398284912109e+01 2.7124099731445312e+01 -1.3250000000000000e+02 -3.8947799682617188e+01 2.9733200073242188e+01 -1.3250000000000000e+02 -4.0571701049804688e+01 3.0487600326538086e+01 -1.3250000000000000e+02 -3.7986900329589844e+01 3.3653400421142578e+01 -1.3250000000000000e+02 -5.0585399627685547e+01 -4.0836300849914551e+00 -1.3250000000000000e+02 -5.0750000000000000e+01 0.0000000000000000e+00 -1.3250000000000000e+02 -4.8913898468017578e+01 2.9027500152587891e+00 -1.3250000000000000e+02 -5.0585399627685547e+01 4.0836300849914551e+00 -1.3250000000000000e+02 -4.8227298736572266e+01 8.6675901412963867e+00 -1.3250000000000000e+02 -5.0092700958251953e+01 8.1408605575561523e+00 -1.3250000000000000e+02 -4.9275302886962891e+01 1.2145199775695801e+01 -1.3250000000000000e+02 3.3074100494384766e+01 3.6153800964355469e+01 -1.3250000000000000e+02 3.5155696868896484e+01 3.6600997924804688e+01 -1.3250000000000000e+02 3.7118000030517578e+01 3.1988300323486328e+01 -1.3250000000000000e+02 3.7986900329589844e+01 3.3653400421142578e+01 -1.3250000000000000e+02 4.0571701049804688e+01 3.0487600326538086e+01 -1.3250000000000000e+02 -1.7996198654174805e+01 4.7451999664306641e+01 -1.3250000000000000e+02 -1.4119500160217285e+01 4.8746299743652344e+01 -1.3250000000000000e+02 -1.0092900276184082e+01 4.7949298858642578e+01 -1.3250000000000000e+02 -1.0151299476623535e+01 4.9724300384521484e+01 -1.3250000000000000e+02 -4.3509597778320312e+00 4.8806400299072266e+01 -1.3250000000000000e+02 7.2346301078796387e+00 4.8462902069091797e+01 -1.3250000000000000e+02 1.0151299476623535e+01 4.9724300384521484e+01 -1.3250000000000000e+02 1.2915699958801270e+01 4.7267101287841797e+01 -1.3250000000000000e+02 1.4119500160217285e+01 4.8746299743652344e+01 -1.3250000000000000e+02 1.8415498733520508e+01 4.5407798767089844e+01 -1.3250000000000000e+02 -6.1172199249267578e+00 5.0379898071289062e+01 -1.3250000000000000e+02 -2.0434801578521729e+00 5.0708801269531250e+01 -1.3250000000000000e+02 1.4520300626754761e+00 4.8978401184082031e+01 -1.3250000000000000e+02 2.0434801578521729e+00 5.0708801269531250e+01 -1.3250000000000000e+02 6.1172199249267578e+00 5.0379898071289062e+01 -1.3250000000000000e+02 1.7996198654174805e+01 4.7451999664306641e+01 -1.3250000000000000e+02 2.1756099700927734e+01 4.5850101470947266e+01 -1.3250000000000000e+02 2.3656801223754883e+01 4.2910999298095703e+01 -1.3250000000000000e+02 2.5374900817871094e+01 4.3950698852539062e+01 -1.3250000000000000e+02 2.8565900802612305e+01 3.9811801910400391e+01 -1.3250000000000000e+02 2.8829299926757812e+01 4.1766403198242188e+01 -1.3250000000000000e+02 3.2096599578857422e+01 3.9311199188232422e+01 -1.3500000000000000e+02 -4.7309497833251953e+01 -8.1120100021362305e+00 -1.3500000000000000e+02 -4.6451198577880859e+01 -1.2094900131225586e+01 -1.3350000000000000e+02 -4.5907199859619141e+01 -1.4018700599670410e+01 -1.3350000000000000e+02 -4.5184898376464844e+01 -1.5963500022888184e+01 -1.3500000000000000e+02 -4.5258102416992188e+01 -1.5990700721740723e+01 -1.3350000000000000e+02 -4.3926998138427734e+01 -1.9349899291992188e+01 -1.3500000000000000e+02 -4.3738998413085938e+01 -1.9771200180053711e+01 -1.3350000000000000e+02 -4.1856201171875000e+01 -2.3384500503540039e+01 -1.3500000000000000e+02 -4.1904598236083984e+01 -2.3409299850463867e+01 -1.3350000000000000e+02 -4.1329998016357422e+01 -2.4409500122070312e+01 -1.3350000000000000e+02 -3.8152999877929688e+01 -2.9126399993896484e+01 -1.3500000000000000e+02 -3.9768402099609375e+01 -2.6878799438476562e+01 -1.3500000000000000e+02 -3.7345699310302734e+01 -3.0154500961303711e+01 -1.3500000000000000e+02 -2.5166700363159180e+01 -4.0873298645019531e+01 -1.3350000000000000e+02 -2.5152801513671875e+01 -4.0848098754882812e+01 -1.3350000000000000e+02 -2.5623500823974609e+01 -4.0588600158691406e+01 -1.3500000000000000e+02 -2.8542301177978516e+01 -3.8591899871826172e+01 -1.3350000000000000e+02 -3.0244199752807617e+01 -3.7273101806640625e+01 -1.3500000000000000e+02 -3.1712301254272461e+01 -3.6032199859619141e+01 -1.3350000000000000e+02 -3.1661499023437500e+01 -3.5976600646972656e+01 -1.3500000000000000e+02 -3.4653800964355469e+01 -3.3213001251220703e+01 -1.3350000000000000e+02 -3.4440299987792969e+01 -3.3434497833251953e+01 -1.3350000000000000e+02 -3.7300502777099609e+01 -3.0115600585937500e+01 -1.3350000000000000e+02 -2.0643100738525391e+01 -4.3334201812744141e+01 -1.3500000000000000e+02 -2.1609800338745117e+01 -4.2860401153564453e+01 -1.3350000000000000e+02 -1.7865499496459961e+01 -4.4460800170898438e+01 -1.3500000000000000e+02 -1.7897098541259766e+01 -4.4538700103759766e+01 -1.3350000000000000e+02 -1.5372900009155273e+01 -4.5471702575683594e+01 -1.3500000000000000e+02 -1.4055500030517578e+01 -4.5895999908447266e+01 -1.3350000000000000e+02 -1.0109099388122559e+01 -4.6909999847412109e+01 -1.3500000000000000e+02 -1.0112600326538086e+01 -4.6922603607177734e+01 -1.3350000000000000e+02 -9.8869209289550781e+00 -4.6970699310302734e+01 -1.3350000000000000e+02 -4.2621498107910156e+00 -4.7810401916503906e+01 -1.3500000000000000e+02 -6.0968399047851562e+00 -4.7611198425292969e+01 -1.3350000000000000e+02 -2.0347800254821777e+00 -4.7876399993896484e+01 -1.3500000000000000e+02 -2.0371701717376709e+00 -4.7956703186035156e+01 -1.3350000000000000e+02 1.4223400354385376e+00 -4.7978900909423828e+01 -1.3500000000000000e+02 2.0371701717376709e+00 -4.7956703186035156e+01 -1.3350000000000000e+02 6.0924901962280273e+00 -4.7562500000000000e+01 -1.3500000000000000e+02 6.0968399047851562e+00 -4.7611198425292969e+01 -1.3350000000000000e+02 7.0869898796081543e+00 -4.7473899841308594e+01 -1.3350000000000000e+02 1.2652199745178223e+01 -4.6302501678466797e+01 -1.3500000000000000e+02 1.0112600326538086e+01 -4.6922603607177734e+01 -1.3500000000000000e+02 1.4055500030517578e+01 -4.5895999908447266e+01 -1.3500000000000000e+02 2.8542301177978516e+01 -3.8591899871826172e+01 -1.3350000000000000e+02 2.8519699096679688e+01 -3.8563800811767578e+01 -1.3350000000000000e+02 2.7982999801635742e+01 -3.8999301910400391e+01 -1.3500000000000000e+02 2.5166700363159180e+01 -4.0873298645019531e+01 -1.3350000000000000e+02 2.3174001693725586e+01 -4.2035301208496094e+01 -1.3500000000000000e+02 2.1609800338745117e+01 -4.2860401153564453e+01 -1.3350000000000000e+02 2.1578699111938477e+01 -4.2795200347900391e+01 -1.3500000000000000e+02 1.7897098541259766e+01 -4.4538700103759766e+01 -1.3350000000000000e+02 1.8039699554443359e+01 -4.4481098175048828e+01 -1.3350000000000000e+02 1.4034899711608887e+01 -4.5834999084472656e+01 -1.3350000000000000e+02 3.2399200439453125e+01 -3.5415897369384766e+01 -1.3500000000000000e+02 3.1712301254272461e+01 -3.6032199859619141e+01 -1.3350000000000000e+02 3.4594100952148438e+01 -3.3155002593994141e+01 -1.3500000000000000e+02 3.4653800964355469e+01 -3.3213001251220703e+01 -1.3350000000000000e+02 3.6360500335693359e+01 -3.1335397720336914e+01 -1.3500000000000000e+02 3.7345699310302734e+01 -3.0154500961303711e+01 -1.3350000000000000e+02 3.9764900207519531e+01 -2.6876001358032227e+01 -1.3500000000000000e+02 3.9768402099609375e+01 -2.6878799438476562e+01 -1.3350000000000000e+02 3.9811397552490234e+01 -2.6815000534057617e+01 -1.3350000000000000e+02 4.2703498840332031e+01 -2.1918199539184570e+01 -1.3500000000000000e+02 4.1904598236083984e+01 -2.3409299850463867e+01 -1.3350000000000000e+02 4.3663799285888672e+01 -1.9738100051879883e+01 -1.3500000000000000e+02 4.3738998413085938e+01 -1.9771200180053711e+01 -1.3350000000000000e+02 4.4996101379394531e+01 -1.6713699340820312e+01 -1.3500000000000000e+02 4.5258102416992188e+01 -1.5990700721740723e+01 -1.3350000000000000e+02 4.6410301208496094e+01 -1.2082500457763672e+01 -1.3500000000000000e+02 4.6451198577880859e+01 -1.2094900131225586e+01 -1.3350000000000000e+02 4.6657100677490234e+01 -1.1274499893188477e+01 -1.3350000000000000e+02 4.7663101196289062e+01 -5.6770997047424316e+00 -1.3500000000000000e+02 4.7309497833251953e+01 -8.1120100021362305e+00 -1.3500000000000000e+02 4.7827098846435547e+01 -4.0706400871276855e+00 -1.3500000000000000e+02 4.6451198577880859e+01 1.2094900131225586e+01 -1.3350000000000000e+02 4.6410301208496094e+01 1.2082500457763672e+01 -1.3350000000000000e+02 4.6657100677490234e+01 1.1274499893188477e+01 -1.3500000000000000e+02 4.7309497833251953e+01 8.1120100021362305e+00 -1.3350000000000000e+02 4.7663101196289062e+01 5.6770997047424316e+00 -1.3500000000000000e+02 4.7827098846435547e+01 4.0706400871276855e+00 -1.3350000000000000e+02 4.7758602142333984e+01 4.0665903091430664e+00 -1.3500000000000000e+02 4.8000000000000000e+01 0.0000000000000000e+00 -1.3350000000000000e+02 4.8000000000000000e+01 0.0000000000000000e+00 -1.3350000000000000e+02 4.7758602142333984e+01 -4.0665903091430664e+00 -1.3350000000000000e+02 4.4996101379394531e+01 1.6713699340820312e+01 -1.3500000000000000e+02 4.5258102416992188e+01 1.5990700721740723e+01 -1.3350000000000000e+02 4.3663799285888672e+01 1.9738100051879883e+01 -1.3500000000000000e+02 4.3738998413085938e+01 1.9771200180053711e+01 -1.3350000000000000e+02 4.2703498840332031e+01 2.1918199539184570e+01 -1.3500000000000000e+02 4.1904598236083984e+01 2.3409299850463867e+01 -1.3350000000000000e+02 3.9811397552490234e+01 2.6815000534057617e+01 -1.3500000000000000e+02 3.9768402099609375e+01 2.6878799438476562e+01 -1.3350000000000000e+02 3.9764900207519531e+01 2.6876001358032227e+01 -1.3350000000000000e+02 3.6360500335693359e+01 3.1335397720336914e+01 -1.3500000000000000e+02 3.7345699310302734e+01 3.0154500961303711e+01 -1.3350000000000000e+02 3.4594100952148438e+01 3.3155002593994141e+01 -1.3500000000000000e+02 3.4653800964355469e+01 3.3213001251220703e+01 -1.3350000000000000e+02 3.2399200439453125e+01 3.5415897369384766e+01 -1.3500000000000000e+02 3.1712301254272461e+01 3.6032199859619141e+01 -1.3350000000000000e+02 2.8519699096679688e+01 3.8563800811767578e+01 -1.3500000000000000e+02 2.8542301177978516e+01 3.8591899871826172e+01 -1.3350000000000000e+02 2.7982999801635742e+01 3.8999301910400391e+01 -1.3350000000000000e+02 2.3174001693725586e+01 4.2035301208496094e+01 -1.3500000000000000e+02 2.5166700363159180e+01 4.0873298645019531e+01 -1.3500000000000000e+02 2.1609800338745117e+01 4.2860401153564453e+01 -1.3500000000000000e+02 6.0968399047851562e+00 4.7611198425292969e+01 -1.3350000000000000e+02 6.0924901962280273e+00 4.7562500000000000e+01 -1.3350000000000000e+02 7.0869898796081543e+00 4.7473899841308594e+01 -1.3500000000000000e+02 1.0112600326538086e+01 4.6922603607177734e+01 -1.3350000000000000e+02 1.2652199745178223e+01 4.6302501678466797e+01 -1.3500000000000000e+02 1.4055500030517578e+01 4.5895999908447266e+01 -1.3350000000000000e+02 1.4034899711608887e+01 4.5834999084472656e+01 -1.3500000000000000e+02 1.7897098541259766e+01 4.4538700103759766e+01 -1.3350000000000000e+02 1.8039699554443359e+01 4.4481098175048828e+01 -1.3350000000000000e+02 2.1578699111938477e+01 4.2795200347900391e+01 -1.3350000000000000e+02 1.4223400354385376e+00 4.7978900909423828e+01 -1.3500000000000000e+02 2.0371701717376709e+00 4.7956703186035156e+01 -1.3350000000000000e+02 -2.0347800254821777e+00 4.7876399993896484e+01 -1.3500000000000000e+02 -2.0371701717376709e+00 4.7956703186035156e+01 -1.3350000000000000e+02 -4.2621498107910156e+00 4.7810401916503906e+01 -1.3500000000000000e+02 -6.0968399047851562e+00 4.7611198425292969e+01 -1.3350000000000000e+02 -9.8869209289550781e+00 4.6970699310302734e+01 -1.3500000000000000e+02 -1.0112600326538086e+01 4.6922603607177734e+01 -1.3350000000000000e+02 -1.0109099388122559e+01 4.6909999847412109e+01 -1.3350000000000000e+02 -1.5372900009155273e+01 4.5471702575683594e+01 -1.3500000000000000e+02 -1.4055500030517578e+01 4.5895999908447266e+01 -1.3350000000000000e+02 -1.7865499496459961e+01 4.4460800170898438e+01 -1.3500000000000000e+02 -1.7897098541259766e+01 4.4538700103759766e+01 -1.3350000000000000e+02 -2.0643100738525391e+01 4.3334201812744141e+01 -1.3500000000000000e+02 -2.1609800338745117e+01 4.2860401153564453e+01 -1.3350000000000000e+02 -2.5152801513671875e+01 4.0848098754882812e+01 -1.3500000000000000e+02 -2.5166700363159180e+01 4.0873298645019531e+01 -1.3350000000000000e+02 -2.5623500823974609e+01 4.0588600158691406e+01 -1.3350000000000000e+02 -3.0244199752807617e+01 3.7273101806640625e+01 -1.3500000000000000e+02 -2.8542301177978516e+01 3.8591899871826172e+01 -1.3500000000000000e+02 -3.1712301254272461e+01 3.6032199859619141e+01 -1.3500000000000000e+02 -4.1904598236083984e+01 2.3409299850463867e+01 -1.3350000000000000e+02 -4.1329998016357422e+01 2.4409500122070312e+01 -1.3500000000000000e+02 -3.9768402099609375e+01 2.6878799438476562e+01 -1.3350000000000000e+02 -3.8152999877929688e+01 2.9126399993896484e+01 -1.3500000000000000e+02 -3.7345699310302734e+01 3.0154500961303711e+01 -1.3350000000000000e+02 -3.7300502777099609e+01 3.0115600585937500e+01 -1.3500000000000000e+02 -3.4653800964355469e+01 3.3213001251220703e+01 -1.3350000000000000e+02 -3.4440299987792969e+01 3.3434497833251953e+01 -1.3350000000000000e+02 -3.1661499023437500e+01 3.5976600646972656e+01 -1.3500000000000000e+02 -4.7309497833251953e+01 8.1120100021362305e+00 -1.3350000000000000e+02 -4.7243099212646484e+01 8.4906797409057617e+00 -1.3500000000000000e+02 -4.6451198577880859e+01 1.2094900131225586e+01 -1.3350000000000000e+02 -4.5907199859619141e+01 1.4018700599670410e+01 -1.3500000000000000e+02 -4.5258102416992188e+01 1.5990700721740723e+01 -1.3350000000000000e+02 -4.5184898376464844e+01 1.5963500022888184e+01 -1.3500000000000000e+02 -4.3738998413085938e+01 1.9771200180053711e+01 -1.3350000000000000e+02 -4.3926998138427734e+01 1.9349899291992188e+01 -1.3350000000000000e+02 -4.1856201171875000e+01 2.3384500503540039e+01 -1.3350000000000000e+02 -4.7243099212646484e+01 -8.4906797409057617e+00 -1.3350000000000000e+02 -4.7288497924804688e+01 -8.1095104217529297e+00 -1.3500000000000000e+02 -4.7827098846435547e+01 -4.0706400871276855e+00 -1.3350000000000000e+02 -4.7915699005126953e+01 -2.8435001373291016e+00 -1.3500000000000000e+02 -4.8000000000000000e+01 0.0000000000000000e+00 -1.3350000000000000e+02 -4.7915699005126953e+01 0.0000000000000000e+00 -1.3500000000000000e+02 -4.7827098846435547e+01 4.0706400871276855e+00 -1.3350000000000000e+02 -4.7915699005126953e+01 2.8435001373291016e+00 -1.3350000000000000e+02 -4.7288497924804688e+01 8.1095104217529297e+00 -1.3550000000000000e+02 4.7693599700927734e+01 4.0593099594116211e+00 -1.3550000000000000e+02 4.7866001129150391e+01 0.0000000000000000e+00 -1.3550000000000000e+02 4.7693599700927734e+01 -4.0593099594116211e+00 -1.3550000000000000e+02 4.7177501678466797e+01 -8.0893602371215820e+00 -1.3550000000000000e+02 4.6321498870849609e+01 -1.2061200141906738e+01 -1.3550000000000000e+02 4.5131698608398438e+01 -1.5946001052856445e+01 -1.3550000000000000e+02 4.3616897583007812e+01 -1.9715999603271484e+01 -1.3550000000000000e+02 4.1787700653076172e+01 -2.3343999862670898e+01 -1.3550000000000000e+02 3.9657398223876953e+01 -2.6803699493408203e+01 -1.3550000000000000e+02 3.7241500854492188e+01 -3.0070400238037109e+01 -1.3550000000000000e+02 3.4557201385498047e+01 -3.3120300292968750e+01 -1.3550000000000000e+02 3.1623800277709961e+01 -3.5931598663330078e+01 -1.3550000000000000e+02 2.8462699890136719e+01 -3.8484100341796875e+01 -1.3550000000000000e+02 2.5096500396728516e+01 -4.0759300231933594e+01 -1.3550000000000000e+02 2.1549501419067383e+01 -4.2740798950195312e+01 -1.3550000000000000e+02 1.7847101211547852e+01 -4.4414299011230469e+01 -1.3550000000000000e+02 1.4016200065612793e+01 -4.5767898559570312e+01 -1.3550000000000000e+02 1.0084300041198730e+01 -4.6791698455810547e+01 -1.3550000000000000e+02 6.0797901153564453e+00 -4.7478298187255859e+01 -1.3550000000000000e+02 2.0314500331878662e+00 -4.7822898864746094e+01 -1.3550000000000000e+02 -2.0314500331878662e+00 -4.7822898864746094e+01 -1.3550000000000000e+02 -6.0797901153564453e+00 -4.7478298187255859e+01 -1.3550000000000000e+02 -1.0084300041198730e+01 -4.6791698455810547e+01 -1.3550000000000000e+02 -1.4016200065612793e+01 -4.5767898559570312e+01 -1.3550000000000000e+02 -1.7847101211547852e+01 -4.4414299011230469e+01 -1.3550000000000000e+02 -2.1549501419067383e+01 -4.2740798950195312e+01 -1.3550000000000000e+02 -2.5096500396728516e+01 -4.0759300231933594e+01 -1.3550000000000000e+02 -2.8462699890136719e+01 -3.8484100341796875e+01 -1.3550000000000000e+02 -3.1623800277709961e+01 -3.5931598663330078e+01 -1.3550000000000000e+02 -3.4557201385498047e+01 -3.3120300292968750e+01 -1.3550000000000000e+02 -3.7241500854492188e+01 -3.0070400238037109e+01 -1.3550000000000000e+02 -3.9657398223876953e+01 -2.6803699493408203e+01 -1.3550000000000000e+02 -4.1787700653076172e+01 -2.3343999862670898e+01 -1.3550000000000000e+02 -4.3616897583007812e+01 -1.9715999603271484e+01 -1.3550000000000000e+02 -4.5131698608398438e+01 -1.5946001052856445e+01 -1.3550000000000000e+02 -4.6321498870849609e+01 -1.2061200141906738e+01 -1.3550000000000000e+02 -4.7177501678466797e+01 -8.0893602371215820e+00 -1.3550000000000000e+02 -4.7693599700927734e+01 -4.0593099594116211e+00 -1.3550000000000000e+02 -4.7866001129150391e+01 0.0000000000000000e+00 -1.3550000000000000e+02 -4.7693599700927734e+01 4.0593099594116211e+00 -1.3550000000000000e+02 -4.7177501678466797e+01 8.0893602371215820e+00 -1.3550000000000000e+02 -4.6321498870849609e+01 1.2061200141906738e+01 -1.3550000000000000e+02 -4.5131698608398438e+01 1.5946001052856445e+01 -1.3550000000000000e+02 -4.3616897583007812e+01 1.9715999603271484e+01 -1.3550000000000000e+02 -4.1787700653076172e+01 2.3343999862670898e+01 -1.3550000000000000e+02 -3.9657398223876953e+01 2.6803699493408203e+01 -1.3550000000000000e+02 -3.7241500854492188e+01 3.0070400238037109e+01 -1.3550000000000000e+02 -3.4557201385498047e+01 3.3120300292968750e+01 -1.3550000000000000e+02 -3.1623800277709961e+01 3.5931598663330078e+01 -1.3550000000000000e+02 -2.8462699890136719e+01 3.8484100341796875e+01 -1.3550000000000000e+02 -2.5096500396728516e+01 4.0759300231933594e+01 -1.3550000000000000e+02 -2.1549501419067383e+01 4.2740798950195312e+01 -1.3550000000000000e+02 -1.7847101211547852e+01 4.4414299011230469e+01 -1.3550000000000000e+02 -1.4016200065612793e+01 4.5767898559570312e+01 -1.3550000000000000e+02 -1.0084300041198730e+01 4.6791698455810547e+01 -1.3550000000000000e+02 -6.0797901153564453e+00 4.7478298187255859e+01 -1.3550000000000000e+02 -2.0314500331878662e+00 4.7822898864746094e+01 -1.3550000000000000e+02 2.0314500331878662e+00 4.7822898864746094e+01 -1.3550000000000000e+02 6.0797901153564453e+00 4.7478298187255859e+01 -1.3550000000000000e+02 1.0084300041198730e+01 4.6791698455810547e+01 -1.3550000000000000e+02 1.4016200065612793e+01 4.5767898559570312e+01 -1.3550000000000000e+02 1.7847101211547852e+01 4.4414299011230469e+01 -1.3550000000000000e+02 2.1549501419067383e+01 4.2740798950195312e+01 -1.3550000000000000e+02 2.5096500396728516e+01 4.0759300231933594e+01 -1.3550000000000000e+02 2.8462699890136719e+01 3.8484100341796875e+01 -1.3550000000000000e+02 3.1623800277709961e+01 3.5931598663330078e+01 -1.3550000000000000e+02 3.4557201385498047e+01 3.3120300292968750e+01 -1.3550000000000000e+02 3.7241500854492188e+01 3.0070400238037109e+01 -1.3550000000000000e+02 3.9657398223876953e+01 2.6803699493408203e+01 -1.3550000000000000e+02 4.1787700653076172e+01 2.3343999862670898e+01 -1.3550000000000000e+02 4.3616897583007812e+01 1.9715999603271484e+01 -1.3550000000000000e+02 4.5131698608398438e+01 1.5946001052856445e+01 -1.3550000000000000e+02 4.6321498870849609e+01 1.2061200141906738e+01 -1.3550000000000000e+02 4.7177501678466797e+01 8.0893602371215820e+00 -1.3586599731445312e+02 4.7328800201416016e+01 4.0282597541809082e+00 -1.3586599731445312e+02 4.7500000000000000e+01 0.0000000000000000e+00 -1.3586599731445312e+02 4.7328800201416016e+01 -4.0282597541809082e+00 -1.3586599731445312e+02 4.6816699981689453e+01 -8.0274906158447266e+00 -1.3586599731445312e+02 4.5967300415039062e+01 -1.1968900680541992e+01 -1.3586599731445312e+02 4.4786598205566406e+01 -1.5824099540710449e+01 -1.3586599731445312e+02 4.3283298492431641e+01 -1.9565299987792969e+01 -1.3586599731445312e+02 4.1468097686767578e+01 -2.3165500640869141e+01 -1.3586599731445312e+02 3.9354202270507812e+01 -2.6598699569702148e+01 -1.3586599731445312e+02 3.6956703186035156e+01 -2.9840400695800781e+01 -1.3586599731445312e+02 3.4292900085449219e+01 -3.2867099761962891e+01 -1.3586599731445312e+02 3.1381998062133789e+01 -3.5656898498535156e+01 -1.3586599731445312e+02 2.8245000839233398e+01 -3.8189800262451172e+01 -1.3586599731445312e+02 2.4904500961303711e+01 -4.0447601318359375e+01 -1.3586599731445312e+02 2.1384599685668945e+01 -4.2413902282714844e+01 -1.3586599731445312e+02 1.7710700988769531e+01 -4.4074699401855469e+01 -1.3586599731445312e+02 1.3909000396728516e+01 -4.5417900085449219e+01 -1.3586599731445312e+02 1.0007300376892090e+01 -4.6433898925781250e+01 -1.3586599731445312e+02 6.0332999229431152e+00 -4.7115299224853516e+01 -1.3586599731445312e+02 2.0159499645233154e+00 -4.7457199096679688e+01 -1.3586599731445312e+02 -2.0159499645233154e+00 -4.7457199096679688e+01 -1.3586599731445312e+02 -6.0332999229431152e+00 -4.7115299224853516e+01 -1.3586599731445312e+02 -1.0007300376892090e+01 -4.6433898925781250e+01 -1.3586599731445312e+02 -1.3909000396728516e+01 -4.5417900085449219e+01 -1.3586599731445312e+02 -1.7710700988769531e+01 -4.4074699401855469e+01 -1.3586599731445312e+02 -2.1384599685668945e+01 -4.2413902282714844e+01 -1.3586599731445312e+02 -2.4904500961303711e+01 -4.0447601318359375e+01 -1.3586599731445312e+02 -2.8245000839233398e+01 -3.8189800262451172e+01 -1.3586599731445312e+02 -3.1381998062133789e+01 -3.5656898498535156e+01 -1.3586599731445312e+02 -3.4292900085449219e+01 -3.2867099761962891e+01 -1.3586599731445312e+02 -3.6956703186035156e+01 -2.9840400695800781e+01 -1.3586599731445312e+02 -3.9354202270507812e+01 -2.6598699569702148e+01 -1.3586599731445312e+02 -4.1468097686767578e+01 -2.3165500640869141e+01 -1.3586599731445312e+02 -4.3283298492431641e+01 -1.9565299987792969e+01 -1.3586599731445312e+02 -4.4786598205566406e+01 -1.5824099540710449e+01 -1.3586599731445312e+02 -4.5967300415039062e+01 -1.1968900680541992e+01 -1.3586599731445312e+02 -4.6816699981689453e+01 -8.0274906158447266e+00 -1.3586599731445312e+02 -4.7328800201416016e+01 -4.0282597541809082e+00 -1.3586599731445312e+02 -4.7500000000000000e+01 0.0000000000000000e+00 -1.3586599731445312e+02 -4.7328800201416016e+01 4.0282597541809082e+00 -1.3586599731445312e+02 -4.6816699981689453e+01 8.0274906158447266e+00 -1.3586599731445312e+02 -4.5967300415039062e+01 1.1968900680541992e+01 -1.3586599731445312e+02 -4.4786598205566406e+01 1.5824099540710449e+01 -1.3586599731445312e+02 -4.3283298492431641e+01 1.9565299987792969e+01 -1.3586599731445312e+02 -4.1468097686767578e+01 2.3165500640869141e+01 -1.3586599731445312e+02 -3.9354202270507812e+01 2.6598699569702148e+01 -1.3586599731445312e+02 -3.6956703186035156e+01 2.9840400695800781e+01 -1.3586599731445312e+02 -3.4292900085449219e+01 3.2867099761962891e+01 -1.3586599731445312e+02 -3.1381998062133789e+01 3.5656898498535156e+01 -1.3586599731445312e+02 -2.8245000839233398e+01 3.8189800262451172e+01 -1.3586599731445312e+02 -2.4904500961303711e+01 4.0447601318359375e+01 -1.3586599731445312e+02 -2.1384599685668945e+01 4.2413902282714844e+01 -1.3586599731445312e+02 -1.7710700988769531e+01 4.4074699401855469e+01 -1.3586599731445312e+02 -1.3909000396728516e+01 4.5417900085449219e+01 -1.3586599731445312e+02 -1.0007300376892090e+01 4.6433898925781250e+01 -1.3586599731445312e+02 -6.0332999229431152e+00 4.7115299224853516e+01 -1.3586599731445312e+02 -2.0159499645233154e+00 4.7457199096679688e+01 -1.3586599731445312e+02 2.0159499645233154e+00 4.7457199096679688e+01 -1.3586599731445312e+02 6.0332999229431152e+00 4.7115299224853516e+01 -1.3586599731445312e+02 1.0007300376892090e+01 4.6433898925781250e+01 -1.3586599731445312e+02 1.3909000396728516e+01 4.5417900085449219e+01 -1.3586599731445312e+02 1.7710700988769531e+01 4.4074699401855469e+01 -1.3586599731445312e+02 2.1384599685668945e+01 4.2413902282714844e+01 -1.3586599731445312e+02 2.4904500961303711e+01 4.0447601318359375e+01 -1.3586599731445312e+02 2.8245000839233398e+01 3.8189800262451172e+01 -1.3586599731445312e+02 3.1381998062133789e+01 3.5656898498535156e+01 -1.3586599731445312e+02 3.4292900085449219e+01 3.2867099761962891e+01 -1.3586599731445312e+02 3.6956703186035156e+01 2.9840400695800781e+01 -1.3586599731445312e+02 3.9354202270507812e+01 2.6598699569702148e+01 -1.3586599731445312e+02 4.1468097686767578e+01 2.3165500640869141e+01 -1.3586599731445312e+02 4.3283298492431641e+01 1.9565299987792969e+01 -1.3586599731445312e+02 4.4786598205566406e+01 1.5824099540710449e+01 -1.3586599731445312e+02 4.5967300415039062e+01 1.1968900680541992e+01 -1.3586599731445312e+02 4.6816699981689453e+01 8.0274906158447266e+00 -1.3600000000000000e+02 4.6830699920654297e+01 3.9858198165893555e+00 -1.3600000000000000e+02 4.7000000000000000e+01 0.0000000000000000e+00 -1.3600000000000000e+02 4.6830699920654297e+01 -3.9858198165893555e+00 -1.3600000000000000e+02 4.6323898315429688e+01 -7.9430303573608398e+00 -1.3600000000000000e+02 4.5483398437500000e+01 -1.1842999458312988e+01 -1.3600000000000000e+02 4.4315200805664062e+01 -1.5657499313354492e+01 -1.3600000000000000e+02 4.2827697753906250e+01 -1.9359399795532227e+01 -1.3600000000000000e+02 4.1031700134277344e+01 -2.2921600341796875e+01 -1.3600000000000000e+02 3.8939899444580078e+01 -2.6318799972534180e+01 -1.3600000000000000e+02 3.6567600250244141e+01 -2.9526300430297852e+01 -1.3600000000000000e+02 3.3931900024414062e+01 -3.2521099090576172e+01 -1.3600000000000000e+02 3.1051698684692383e+01 -3.5281597137451172e+01 -1.3600000000000000e+02 2.7947700500488281e+01 -3.7787899017333984e+01 -1.3600000000000000e+02 2.4642400741577148e+01 -4.0021800994873047e+01 -1.3600000000000000e+02 2.1159500122070312e+01 -4.1967498779296875e+01 -1.3600000000000000e+02 1.7524200439453125e+01 -4.3610698699951172e+01 -1.3600000000000000e+02 1.3762700080871582e+01 -4.4939800262451172e+01 -1.3600000000000000e+02 9.9018802642822266e+00 -4.5944999694824219e+01 -1.3600000000000000e+02 5.9698200225830078e+00 -4.6619300842285156e+01 -1.3600000000000000e+02 1.9947299957275391e+00 -4.6957599639892578e+01 -1.3600000000000000e+02 -1.9947299957275391e+00 -4.6957599639892578e+01 -1.3600000000000000e+02 -5.9698200225830078e+00 -4.6619300842285156e+01 -1.3600000000000000e+02 -9.9018802642822266e+00 -4.5944999694824219e+01 -1.3600000000000000e+02 -1.3762700080871582e+01 -4.4939800262451172e+01 -1.3600000000000000e+02 -1.7524200439453125e+01 -4.3610698699951172e+01 -1.3600000000000000e+02 -2.1159500122070312e+01 -4.1967498779296875e+01 -1.3600000000000000e+02 -2.4642400741577148e+01 -4.0021800994873047e+01 -1.3600000000000000e+02 -2.7947700500488281e+01 -3.7787899017333984e+01 -1.3600000000000000e+02 -3.1051698684692383e+01 -3.5281597137451172e+01 -1.3600000000000000e+02 -3.3931900024414062e+01 -3.2521099090576172e+01 -1.3600000000000000e+02 -3.6567600250244141e+01 -2.9526300430297852e+01 -1.3600000000000000e+02 -3.8939899444580078e+01 -2.6318799972534180e+01 -1.3600000000000000e+02 -4.1031700134277344e+01 -2.2921600341796875e+01 -1.3600000000000000e+02 -4.2827697753906250e+01 -1.9359399795532227e+01 -1.3600000000000000e+02 -4.4315200805664062e+01 -1.5657499313354492e+01 -1.3600000000000000e+02 -4.5483398437500000e+01 -1.1842999458312988e+01 -1.3600000000000000e+02 -4.6323898315429688e+01 -7.9430303573608398e+00 -1.3600000000000000e+02 -4.6830699920654297e+01 -3.9858198165893555e+00 -1.3600000000000000e+02 -4.7000000000000000e+01 0.0000000000000000e+00 -1.3600000000000000e+02 -4.6830699920654297e+01 3.9858198165893555e+00 -1.3600000000000000e+02 -4.6323898315429688e+01 7.9430303573608398e+00 -1.3600000000000000e+02 -4.5483398437500000e+01 1.1842999458312988e+01 -1.3600000000000000e+02 -4.4315200805664062e+01 1.5657499313354492e+01 -1.3600000000000000e+02 -4.2827697753906250e+01 1.9359399795532227e+01 -1.3600000000000000e+02 -4.1031700134277344e+01 2.2921600341796875e+01 -1.3600000000000000e+02 -3.8939899444580078e+01 2.6318799972534180e+01 -1.3600000000000000e+02 -3.6567600250244141e+01 2.9526300430297852e+01 -1.3600000000000000e+02 -3.3931900024414062e+01 3.2521099090576172e+01 -1.3600000000000000e+02 -3.1051698684692383e+01 3.5281597137451172e+01 -1.3600000000000000e+02 -2.7947700500488281e+01 3.7787899017333984e+01 -1.3600000000000000e+02 -2.4642400741577148e+01 4.0021800994873047e+01 -1.3600000000000000e+02 -2.1159500122070312e+01 4.1967498779296875e+01 -1.3600000000000000e+02 -1.7524200439453125e+01 4.3610698699951172e+01 -1.3600000000000000e+02 -1.3762700080871582e+01 4.4939800262451172e+01 -1.3600000000000000e+02 -9.9018802642822266e+00 4.5944999694824219e+01 -1.3600000000000000e+02 -5.9698200225830078e+00 4.6619300842285156e+01 -1.3600000000000000e+02 -1.9947299957275391e+00 4.6957599639892578e+01 -1.3600000000000000e+02 1.9947299957275391e+00 4.6957599639892578e+01 -1.3600000000000000e+02 5.9698200225830078e+00 4.6619300842285156e+01 -1.3600000000000000e+02 9.9018802642822266e+00 4.5944999694824219e+01 -1.3600000000000000e+02 1.3762700080871582e+01 4.4939800262451172e+01 -1.3600000000000000e+02 1.7524200439453125e+01 4.3610698699951172e+01 -1.3600000000000000e+02 2.1159500122070312e+01 4.1967498779296875e+01 -1.3600000000000000e+02 2.4642400741577148e+01 4.0021800994873047e+01 -1.3600000000000000e+02 2.7947700500488281e+01 3.7787899017333984e+01 -1.3600000000000000e+02 3.1051698684692383e+01 3.5281597137451172e+01 -1.3600000000000000e+02 3.3931900024414062e+01 3.2521099090576172e+01 -1.3600000000000000e+02 3.6567600250244141e+01 2.9526300430297852e+01 -1.3600000000000000e+02 3.8939899444580078e+01 2.6318799972534180e+01 -1.3600000000000000e+02 4.1031700134277344e+01 2.2921600341796875e+01 -1.3600000000000000e+02 4.2827697753906250e+01 1.9359399795532227e+01 -1.3600000000000000e+02 4.4315200805664062e+01 1.5657499313354492e+01 -1.3600000000000000e+02 4.5483398437500000e+01 1.1842999458312988e+01 -1.3600000000000000e+02 4.6323898315429688e+01 7.9430303573608398e+00 -1.3300000000000000e+02 2.8061100006103516e+01 3.9108200073242188e+01 -1.3300000000000000e+02 2.3238599777221680e+01 4.2152599334716797e+01 -1.3300000000000000e+02 -2.5694999694824219e+01 4.0701900482177734e+01 -1.3300000000000000e+02 -3.0328599929809570e+01 3.7377201080322266e+01 -1.3300000000000000e+02 -4.7374900817871094e+01 -8.5143995285034180e+00 -1.3300000000000000e+02 -4.6035301208496094e+01 -1.4057800292968750e+01 -1.3263400268554688e+02 4.3148300170898438e+01 2.2146501541137695e+01 -1.3263400268554688e+02 4.5464797973632812e+01 1.6887800216674805e+01 -1.3300000000000000e+02 4.5121700286865234e+01 1.6760301589965820e+01 -1.3263400268554688e+02 -4.3065500259399414e+00 4.8308399200439453e+01 -1.3263400268554688e+02 1.4371899366378784e+00 4.8478698730468750e+01 -1.3300000000000000e+02 1.4263399839401245e+00 4.8112796783447266e+01 -1.3263400268554688e+02 -4.6385398864746094e+01 1.4164700508117676e+01 -1.3263400268554688e+02 -4.4384498596191406e+01 1.9551500320434570e+01 -1.3300000000000000e+02 -4.4049598693847656e+01 1.9403898239135742e+01 -1.3263400268554688e+02 -3.0559200286865234e+01 -3.7661399841308594e+01 -1.3263400268554688e+02 -3.4799098968505859e+01 -3.3782699584960938e+01 -1.3300000000000000e+02 -3.4536499023437500e+01 -3.3527698516845703e+01 -1.3263400268554688e+02 -9.9899196624755859e+00 -4.7459899902343750e+01 -1.3263400268554688e+02 -1.5533100128173828e+01 -4.5945301055908203e+01 -1.3300000000000000e+02 -1.5415800094604492e+01 -4.5598598480224609e+01 -1.3263400268554688e+02 2.3415399551391602e+01 -4.2473098754882812e+01 -1.3263400268554688e+02 1.8227600097656250e+01 -4.4944400787353516e+01 -1.3300000000000000e+02 1.8090099334716797e+01 -4.4605300903320312e+01 -1.3263400268554688e+02 4.0226200103759766e+01 -2.7094400405883789e+01 -1.3263400268554688e+02 3.6739299774169922e+01 -3.1661901473999023e+01 -1.3300000000000000e+02 3.6462001800537109e+01 -3.1422897338867188e+01 -1.3263400268554688e+02 4.8500000000000000e+01 0.0000000000000000e+00 -1.3263400268554688e+02 4.8159500122070312e+01 -5.7362298965454102e+00 -1.3300000000000000e+02 4.7796100616455078e+01 -5.6929001808166504e+00 -1.3263400268554688e+02 3.2736698150634766e+01 3.5784900665283203e+01 -1.3263400268554688e+02 7.1608400344848633e+00 4.7968399047851562e+01 -1.3263400268554688e+02 -2.0858200073242188e+01 4.3785697937011719e+01 -1.3263400268554688e+02 -4.1760601043701172e+01 2.4663700103759766e+01 -1.3263400268554688e+02 -4.8414798736572266e+01 -2.8731198310852051e+00 -1.3263400268554688e+02 -3.8550399780273438e+01 -2.9429800033569336e+01 -1.3263400268554688e+02 1.2783900260925293e+01 -4.6784797668457031e+01 -1.3263400268554688e+02 -4.7735198974609375e+01 -8.5791301727294922e+00 -1.3263400268554688e+02 -4.6385398864746094e+01 -1.4164700508117676e+01 -1.3263400268554688e+02 -4.4384498596191406e+01 -1.9551500320434570e+01 -1.3263400268554688e+02 -4.1760601043701172e+01 -2.4663700103759766e+01 -1.3263400268554688e+02 -2.5890399932861328e+01 4.1011402130126953e+01 -1.3263400268554688e+02 -3.0559200286865234e+01 3.7661399841308594e+01 -1.3263400268554688e+02 -3.4799098968505859e+01 3.3782699584960938e+01 -1.3263400268554688e+02 -3.8550399780273438e+01 2.9429800033569336e+01 -1.3263400268554688e+02 2.8274499893188477e+01 3.9405597686767578e+01 -1.3263400268554688e+02 2.3415399551391602e+01 4.2473098754882812e+01 -1.3263400268554688e+02 1.8227600097656250e+01 4.4944400787353516e+01 -1.3263400268554688e+02 1.2783900260925293e+01 4.6784797668457031e+01 -1.3300000000000000e+02 4.5121700286865234e+01 -1.6760301589965820e+01 -1.3300000000000000e+02 4.6787300109863281e+01 -1.1305999755859375e+01 -1.3263400268554688e+02 4.7143100738525391e+01 -1.1391899108886719e+01 -1.3263400268554688e+02 4.5464797973632812e+01 -1.6887800216674805e+01 -1.3300000000000000e+02 4.2822700500488281e+01 -2.1979299545288086e+01 -1.3263400268554688e+02 4.3148300170898438e+01 -2.2146501541137695e+01 -1.3300000000000000e+02 3.9922599792480469e+01 -2.6889900207519531e+01 -1.3300000000000000e+02 2.8061100006103516e+01 -3.9108200073242188e+01 -1.3300000000000000e+02 3.2489601135253906e+01 -3.5514801025390625e+01 -1.3263400268554688e+02 3.2736698150634766e+01 -3.5784900665283203e+01 -1.3263400268554688e+02 2.8274499893188477e+01 -3.9405597686767578e+01 -1.3300000000000000e+02 2.3238599777221680e+01 -4.2152599334716797e+01 -1.3300000000000000e+02 1.4263399839401245e+00 -4.8112796783447266e+01 -1.3300000000000000e+02 7.1067800521850586e+00 -4.7606399536132812e+01 -1.3263400268554688e+02 7.1608400344848633e+00 -4.7968399047851562e+01 -1.3263400268554688e+02 1.4371899366378784e+00 -4.8478698730468750e+01 -1.3300000000000000e+02 -4.2740697860717773e+00 -4.7943801879882812e+01 -1.3263400268554688e+02 -4.3065500259399414e+00 -4.8308399200439453e+01 -1.3300000000000000e+02 -9.9145202636718750e+00 -4.7101799011230469e+01 -1.3300000000000000e+02 -2.5694999694824219e+01 -4.0701900482177734e+01 -1.3300000000000000e+02 -2.0700700759887695e+01 -4.3455200195312500e+01 -1.3263400268554688e+02 -2.0858200073242188e+01 -4.3785697937011719e+01 -1.3263400268554688e+02 -2.5890399932861328e+01 -4.1011402130126953e+01 -1.3300000000000000e+02 -3.0328599929809570e+01 -3.7377201080322266e+01 -1.3300000000000000e+02 -4.4049598693847656e+01 -1.9403898239135742e+01 -1.3300000000000000e+02 -4.1445400238037109e+01 -2.4477600097656250e+01 -1.3300000000000000e+02 -4.7374900817871094e+01 8.5143995285034180e+00 -1.3300000000000000e+02 -4.8049400329589844e+01 2.8514900207519531e+00 -1.3263400268554688e+02 -4.8414798736572266e+01 2.8731198310852051e+00 -1.3263400268554688e+02 -4.7735198974609375e+01 8.5791301727294922e+00 -1.3300000000000000e+02 -4.6035301208496094e+01 1.4057800292968750e+01 -1.3300000000000000e+02 -3.4536499023437500e+01 3.3527698516845703e+01 -1.3300000000000000e+02 -3.8259498596191406e+01 2.9207700729370117e+01 -1.3300000000000000e+02 -9.9145202636718750e+00 4.7101799011230469e+01 -1.3300000000000000e+02 -1.5415800094604492e+01 4.5598598480224609e+01 -1.3263400268554688e+02 -1.5533100128173828e+01 4.5945301055908203e+01 -1.3263400268554688e+02 -9.9899196624755859e+00 4.7459899902343750e+01 -1.3300000000000000e+02 -4.2740697860717773e+00 4.7943801879882812e+01 -1.3300000000000000e+02 1.8090099334716797e+01 4.4605300903320312e+01 -1.3300000000000000e+02 1.2687399864196777e+01 4.6431701660156250e+01 -1.3300000000000000e+02 3.9922599792480469e+01 2.6889900207519531e+01 -1.3300000000000000e+02 3.6462001800537109e+01 3.1422897338867188e+01 -1.3263400268554688e+02 3.6739299774169922e+01 3.1661901473999023e+01 -1.3263400268554688e+02 4.0226200103759766e+01 2.7094400405883789e+01 -1.3300000000000000e+02 4.2822700500488281e+01 2.1979299545288086e+01 -1.3300000000000000e+02 4.7796100616455078e+01 5.6929001808166504e+00 -1.3300000000000000e+02 4.6787300109863281e+01 1.1305999755859375e+01 -1.3263400268554688e+02 4.7143100738525391e+01 1.1391899108886719e+01 -1.3263400268554688e+02 4.8159500122070312e+01 5.7362298965454102e+00 -1.3300000000000000e+02 4.8133998870849609e+01 0.0000000000000000e+00 -1.3300000000000000e+02 1.2687399864196777e+01 -4.6431701660156250e+01 -1.3300000000000000e+02 -3.8259498596191406e+01 -2.9207700729370117e+01 -1.3300000000000000e+02 -4.8049400329589844e+01 -2.8514900207519531e+00 -1.3300000000000000e+02 -4.1445400238037109e+01 2.4477600097656250e+01 -1.3300000000000000e+02 -2.0700700759887695e+01 4.3455200195312500e+01 -1.3300000000000000e+02 7.1067800521850586e+00 4.7606399536132812e+01 -1.3300000000000000e+02 3.2489601135253906e+01 3.5514801025390625e+01 -1.3044500732421875e+02 4.9413902282714844e+01 -1.2179399490356445e+01 -1.3044500732421875e+02 4.8273601531982422e+01 -1.6116100311279297e+01 -1.3044500732421875e+02 4.6820301055908203e+01 -1.9948200225830078e+01 -1.3044500732421875e+02 4.5063297271728516e+01 -2.3651100158691406e+01 -1.3044500732421875e+02 4.3013999938964844e+01 -2.7200500488281250e+01 -1.3044500732421875e+02 4.0685798645019531e+01 -3.0573400497436523e+01 -1.3044500732421875e+02 3.8093700408935547e+01 -3.3748100280761719e+01 -1.3044500732421875e+02 3.5254600524902344e+01 -3.6703998565673828e+01 -1.3044500732421875e+02 3.2186901092529297e+01 -3.9421798706054688e+01 -1.3044500732421875e+02 2.8910400390625000e+01 -4.1883899688720703e+01 -1.3044500732421875e+02 2.5446298599243164e+01 -4.4074401855468750e+01 -1.3044500732421875e+02 2.1817300796508789e+01 -4.5979103088378906e+01 -1.3044500732421875e+02 1.8046800613403320e+01 -4.7585498809814453e+01 -1.3044500732421875e+02 1.4159300804138184e+01 -4.8883399963378906e+01 -1.3044500732421875e+02 1.0179800033569336e+01 -4.9864200592041016e+01 -1.3044500732421875e+02 6.1343898773193359e+00 -5.0521701812744141e+01 -1.3044500732421875e+02 2.0492100715637207e+00 -5.0851501464843750e+01 -1.3044500732421875e+02 -2.0492100715637207e+00 -5.0851501464843750e+01 -1.3044500732421875e+02 -6.1343898773193359e+00 -5.0521701812744141e+01 -1.3044500732421875e+02 -1.0179800033569336e+01 -4.9864200592041016e+01 -1.3044500732421875e+02 -1.4159300804138184e+01 -4.8883399963378906e+01 -1.3044500732421875e+02 -1.8046800613403320e+01 -4.7585498809814453e+01 -1.3044500732421875e+02 -2.1817300796508789e+01 -4.5979103088378906e+01 -1.3044500732421875e+02 -2.8910400390625000e+01 -4.1883899688720703e+01 -1.3044500732421875e+02 -2.5446298599243164e+01 -4.4074401855468750e+01 -1.3044500732421875e+02 -3.2186901092529297e+01 -3.9421798706054688e+01 -1.3044500732421875e+02 -3.5254600524902344e+01 -3.6703998565673828e+01 -1.3044500732421875e+02 -4.0685798645019531e+01 -3.0573400497436523e+01 -1.3044500732421875e+02 -3.8093700408935547e+01 -3.3748100280761719e+01 -1.3044500732421875e+02 -4.3013999938964844e+01 -2.7200500488281250e+01 -1.3044500732421875e+02 -4.5063297271728516e+01 -2.3651100158691406e+01 -1.3044500732421875e+02 -4.8273601531982422e+01 -1.6116100311279297e+01 -1.3044500732421875e+02 -4.6820301055908203e+01 -1.9948200225830078e+01 -1.3044500732421875e+02 -4.9413902282714844e+01 -1.2179399490356445e+01 -1.3044500732421875e+02 -5.0233699798583984e+01 -8.1637496948242188e+00 -1.3044500732421875e+02 -5.0727699279785156e+01 -4.0951399803161621e+00 -1.3044500732421875e+02 -5.0892799377441406e+01 0.0000000000000000e+00 -1.3044500732421875e+02 -5.0727699279785156e+01 4.0951399803161621e+00 -1.3044500732421875e+02 -5.0233699798583984e+01 8.1637496948242188e+00 -1.3044500732421875e+02 -4.9413902282714844e+01 1.2179399490356445e+01 -1.3044500732421875e+02 -4.8273601531982422e+01 1.6116100311279297e+01 -1.3044500732421875e+02 -4.6820301055908203e+01 1.9948200225830078e+01 -1.3044500732421875e+02 -4.5063297271728516e+01 2.3651100158691406e+01 -1.3044500732421875e+02 -4.3013999938964844e+01 2.7200500488281250e+01 -1.3044500732421875e+02 -4.0685798645019531e+01 3.0573400497436523e+01 -1.3044500732421875e+02 -3.8093700408935547e+01 3.3748100280761719e+01 -1.3044500732421875e+02 -3.5254600524902344e+01 3.6703998565673828e+01 -1.3044500732421875e+02 -3.2186901092529297e+01 3.9421798706054688e+01 -1.3044500732421875e+02 -2.8910400390625000e+01 4.1883899688720703e+01 -1.3044500732421875e+02 -2.5446298599243164e+01 4.4074401855468750e+01 -1.3044500732421875e+02 -2.1817300796508789e+01 4.5979103088378906e+01 -1.3044500732421875e+02 -1.8046800613403320e+01 4.7585498809814453e+01 -1.3044500732421875e+02 -1.4159300804138184e+01 4.8883399963378906e+01 -1.3044500732421875e+02 -1.0179800033569336e+01 4.9864200592041016e+01 -1.3044500732421875e+02 -6.1343898773193359e+00 5.0521701812744141e+01 -1.3044500732421875e+02 -2.0492100715637207e+00 5.0851501464843750e+01 -1.3044500732421875e+02 2.0492100715637207e+00 5.0851501464843750e+01 -1.3044500732421875e+02 6.1343898773193359e+00 5.0521701812744141e+01 -1.3044500732421875e+02 1.0179800033569336e+01 4.9864200592041016e+01 -1.3044500732421875e+02 1.4159300804138184e+01 4.8883399963378906e+01 -1.3044500732421875e+02 1.8046800613403320e+01 4.7585498809814453e+01 -1.3044500732421875e+02 2.1817300796508789e+01 4.5979103088378906e+01 -1.3044500732421875e+02 2.8910400390625000e+01 4.1883899688720703e+01 -1.3044500732421875e+02 2.5446298599243164e+01 4.4074401855468750e+01 -1.3044500732421875e+02 3.2186901092529297e+01 3.9421798706054688e+01 -1.3044500732421875e+02 3.5254600524902344e+01 3.6703998565673828e+01 -1.3044500732421875e+02 4.0685798645019531e+01 3.0573400497436523e+01 -1.3044500732421875e+02 3.8093700408935547e+01 3.3748100280761719e+01 -1.3044500732421875e+02 4.3013999938964844e+01 2.7200500488281250e+01 -1.3044500732421875e+02 4.5063297271728516e+01 2.3651100158691406e+01 -1.3044500732421875e+02 4.8273601531982422e+01 1.6116100311279297e+01 -1.3044500732421875e+02 4.6820301055908203e+01 1.9948200225830078e+01 -1.3044500732421875e+02 4.9413902282714844e+01 1.2179399490356445e+01 -1.3044500732421875e+02 5.0233699798583984e+01 8.1637496948242188e+00 -1.3044500732421875e+02 5.0727699279785156e+01 4.0951399803161621e+00 -1.3044500732421875e+02 5.0892799377441406e+01 0.0000000000000000e+00 -1.3044500732421875e+02 5.0727699279785156e+01 -4.0951399803161621e+00 -1.3044500732421875e+02 5.0233699798583984e+01 -8.1637496948242188e+00 -1.3078900146484375e+02 5.0990398406982422e+01 4.1163601875305176e+00 -1.3078900146484375e+02 5.1156299591064453e+01 0.0000000000000000e+00 -1.3078900146484375e+02 5.0990398406982422e+01 -4.1163601875305176e+00 -1.3078900146484375e+02 5.0493797302246094e+01 -8.2060098648071289e+00 -1.3078900146484375e+02 4.9669799804687500e+01 -1.2242499351501465e+01 -1.3078900146484375e+02 4.8523601531982422e+01 -1.6199499130249023e+01 -1.3078900146484375e+02 4.7062797546386719e+01 -2.0051500320434570e+01 -1.3078900146484375e+02 4.5296596527099609e+01 -2.3773500442504883e+01 -1.3078900146484375e+02 4.3236801147460938e+01 -2.7341199874877930e+01 -1.3078900146484375e+02 4.0896499633789062e+01 -3.0731700897216797e+01 -1.3078900146484375e+02 3.8291000366210938e+01 -3.3922901153564453e+01 -1.3078900146484375e+02 3.5437198638916016e+01 -3.6894001007080078e+01 -1.3078900146484375e+02 3.2353500366210938e+01 -3.9625900268554688e+01 -1.3078900146484375e+02 2.9060098648071289e+01 -4.2100799560546875e+01 -1.3078900146484375e+02 2.5578100204467773e+01 -4.4302600860595703e+01 -1.3078900146484375e+02 2.1930299758911133e+01 -4.6217098236083984e+01 -1.3078900146484375e+02 1.8140298843383789e+01 -4.7831901550292969e+01 -1.3078900146484375e+02 1.4232600212097168e+01 -4.9136501312255859e+01 -1.3078900146484375e+02 1.0232600212097168e+01 -5.0122398376464844e+01 -1.3078900146484375e+02 6.1661601066589355e+00 -5.0783298492431641e+01 -1.3078900146484375e+02 2.0598201751708984e+00 -5.1114799499511719e+01 -1.3078900146484375e+02 -2.0598201751708984e+00 -5.1114799499511719e+01 -1.3078900146484375e+02 -6.1661601066589355e+00 -5.0783298492431641e+01 -1.3078900146484375e+02 -1.0232600212097168e+01 -5.0122398376464844e+01 -1.3078900146484375e+02 -1.4232600212097168e+01 -4.9136501312255859e+01 -1.3078900146484375e+02 -1.8140298843383789e+01 -4.7831901550292969e+01 -1.3078900146484375e+02 -2.1930299758911133e+01 -4.6217098236083984e+01 -1.3078900146484375e+02 -2.5578100204467773e+01 -4.4302600860595703e+01 -1.3078900146484375e+02 -2.9060098648071289e+01 -4.2100799560546875e+01 -1.3078900146484375e+02 -3.2353500366210938e+01 -3.9625900268554688e+01 -1.3078900146484375e+02 -3.5437198638916016e+01 -3.6894001007080078e+01 -1.3078900146484375e+02 -3.8291000366210938e+01 -3.3922901153564453e+01 -1.3078900146484375e+02 -4.0896499633789062e+01 -3.0731700897216797e+01 -1.3078900146484375e+02 -4.3236801147460938e+01 -2.7341199874877930e+01 -1.3078900146484375e+02 -4.5296596527099609e+01 -2.3773500442504883e+01 -1.3078900146484375e+02 -4.7062797546386719e+01 -2.0051500320434570e+01 -1.3078900146484375e+02 -4.8523601531982422e+01 -1.6199499130249023e+01 -1.3078900146484375e+02 -4.9669799804687500e+01 -1.2242499351501465e+01 -1.3078900146484375e+02 -5.0493797302246094e+01 -8.2060098648071289e+00 -1.3078900146484375e+02 -5.0990398406982422e+01 -4.1163601875305176e+00 -1.3078900146484375e+02 -5.1156299591064453e+01 0.0000000000000000e+00 -1.3078900146484375e+02 -5.0990398406982422e+01 4.1163601875305176e+00 -1.3078900146484375e+02 -5.0493797302246094e+01 8.2060098648071289e+00 -1.3078900146484375e+02 -4.9669799804687500e+01 1.2242499351501465e+01 -1.3078900146484375e+02 -4.8523601531982422e+01 1.6199499130249023e+01 -1.3078900146484375e+02 -4.7062797546386719e+01 2.0051500320434570e+01 -1.3078900146484375e+02 -4.5296596527099609e+01 2.3773500442504883e+01 -1.3078900146484375e+02 -4.3236801147460938e+01 2.7341199874877930e+01 -1.3078900146484375e+02 -4.0896499633789062e+01 3.0731700897216797e+01 -1.3078900146484375e+02 -3.8291000366210938e+01 3.3922901153564453e+01 -1.3078900146484375e+02 -3.5437198638916016e+01 3.6894001007080078e+01 -1.3078900146484375e+02 -3.2353500366210938e+01 3.9625900268554688e+01 -1.3078900146484375e+02 -2.9060098648071289e+01 4.2100799560546875e+01 -1.3078900146484375e+02 -2.5578100204467773e+01 4.4302600860595703e+01 -1.3078900146484375e+02 -2.1930299758911133e+01 4.6217098236083984e+01 -1.3078900146484375e+02 -1.8140298843383789e+01 4.7831901550292969e+01 -1.3078900146484375e+02 -1.4232600212097168e+01 4.9136501312255859e+01 -1.3078900146484375e+02 -1.0232600212097168e+01 5.0122398376464844e+01 -1.3078900146484375e+02 -6.1661601066589355e+00 5.0783298492431641e+01 -1.3078900146484375e+02 -2.0598201751708984e+00 5.1114799499511719e+01 -1.3078900146484375e+02 2.0598201751708984e+00 5.1114799499511719e+01 -1.3078900146484375e+02 6.1661601066589355e+00 5.0783298492431641e+01 -1.3078900146484375e+02 1.0232600212097168e+01 5.0122398376464844e+01 -1.3078900146484375e+02 1.4232600212097168e+01 4.9136501312255859e+01 -1.3078900146484375e+02 1.8140298843383789e+01 4.7831901550292969e+01 -1.3078900146484375e+02 2.1930299758911133e+01 4.6217098236083984e+01 -1.3078900146484375e+02 2.5578100204467773e+01 4.4302600860595703e+01 -1.3078900146484375e+02 2.9060098648071289e+01 4.2100799560546875e+01 -1.3078900146484375e+02 3.2353500366210938e+01 3.9625900268554688e+01 -1.3078900146484375e+02 3.5437198638916016e+01 3.6894001007080078e+01 -1.3078900146484375e+02 3.8291000366210938e+01 3.3922901153564453e+01 -1.3078900146484375e+02 4.0896499633789062e+01 3.0731700897216797e+01 -1.3078900146484375e+02 4.3236801147460938e+01 2.7341199874877930e+01 -1.3078900146484375e+02 4.5296596527099609e+01 2.3773500442504883e+01 -1.3078900146484375e+02 4.7062797546386719e+01 2.0051500320434570e+01 -1.3078900146484375e+02 4.8523601531982422e+01 1.6199499130249023e+01 -1.3078900146484375e+02 4.9669799804687500e+01 1.2242499351501465e+01 -1.3078900146484375e+02 5.0493797302246094e+01 8.2060098648071289e+00 -1.3225000000000000e+02 5.1017002105712891e+01 4.1184997558593750e+00 -1.3225000000000000e+02 5.1182998657226562e+01 0.0000000000000000e+00 -1.3225000000000000e+02 5.1017002105712891e+01 -4.1184997558593750e+00 -1.3225000000000000e+02 5.0520198822021484e+01 -8.2102994918823242e+00 -1.3225000000000000e+02 4.9695701599121094e+01 -1.2248899459838867e+01 -1.3225000000000000e+02 4.8548900604248047e+01 -1.6208000183105469e+01 -1.3225000000000000e+02 4.7087299346923828e+01 -2.0062000274658203e+01 -1.3225000000000000e+02 4.5320297241210938e+01 -2.3785900115966797e+01 -1.3225000000000000e+02 4.3259300231933594e+01 -2.7355499267578125e+01 -1.3225000000000000e+02 4.0917900085449219e+01 -3.0747798919677734e+01 -1.3225000000000000e+02 3.8311000823974609e+01 -3.3940597534179688e+01 -1.3225000000000000e+02 3.5455699920654297e+01 -3.6913303375244141e+01 -1.3225000000000000e+02 3.2370399475097656e+01 -3.9646598815917969e+01 -1.3225000000000000e+02 2.9075300216674805e+01 -4.2122798919677734e+01 -1.3225000000000000e+02 2.5591499328613281e+01 -4.4325798034667969e+01 -1.3225000000000000e+02 2.1941799163818359e+01 -4.6241298675537109e+01 -1.3225000000000000e+02 1.8149700164794922e+01 -4.7856899261474609e+01 -1.3225000000000000e+02 1.4240000724792480e+01 -4.9162200927734375e+01 -1.3225000000000000e+02 1.0237899780273438e+01 -5.0148597717285156e+01 -1.3225000000000000e+02 6.1693801879882812e+00 -5.0809799194335938e+01 -1.3225000000000000e+02 2.0608899593353271e+00 -5.1141502380371094e+01 -1.3225000000000000e+02 -2.0608899593353271e+00 -5.1141502380371094e+01 -1.3225000000000000e+02 -6.1693801879882812e+00 -5.0809799194335938e+01 -1.3225000000000000e+02 -1.0237899780273438e+01 -5.0148597717285156e+01 -1.3225000000000000e+02 -1.4240000724792480e+01 -4.9162200927734375e+01 -1.3225000000000000e+02 -1.8149700164794922e+01 -4.7856899261474609e+01 -1.3225000000000000e+02 -2.1941799163818359e+01 -4.6241298675537109e+01 -1.3225000000000000e+02 -2.5591499328613281e+01 -4.4325798034667969e+01 -1.3225000000000000e+02 -2.9075300216674805e+01 -4.2122798919677734e+01 -1.3225000000000000e+02 -3.2370399475097656e+01 -3.9646598815917969e+01 -1.3225000000000000e+02 -3.5455699920654297e+01 -3.6913303375244141e+01 -1.3225000000000000e+02 -3.8311000823974609e+01 -3.3940597534179688e+01 -1.3225000000000000e+02 -4.0917900085449219e+01 -3.0747798919677734e+01 -1.3225000000000000e+02 -4.3259300231933594e+01 -2.7355499267578125e+01 -1.3225000000000000e+02 -4.5320297241210938e+01 -2.3785900115966797e+01 -1.3225000000000000e+02 -4.7087299346923828e+01 -2.0062000274658203e+01 -1.3225000000000000e+02 -4.8548900604248047e+01 -1.6208000183105469e+01 -1.3225000000000000e+02 -4.9695701599121094e+01 -1.2248899459838867e+01 -1.3225000000000000e+02 -5.0520198822021484e+01 -8.2102994918823242e+00 -1.3225000000000000e+02 -5.1017002105712891e+01 -4.1184997558593750e+00 -1.3225000000000000e+02 -5.1182998657226562e+01 0.0000000000000000e+00 -1.3225000000000000e+02 -5.1017002105712891e+01 4.1184997558593750e+00 -1.3225000000000000e+02 -5.0520198822021484e+01 8.2102994918823242e+00 -1.3225000000000000e+02 -4.9695701599121094e+01 1.2248899459838867e+01 -1.3225000000000000e+02 -4.8548900604248047e+01 1.6208000183105469e+01 -1.3225000000000000e+02 -4.7087299346923828e+01 2.0062000274658203e+01 -1.3225000000000000e+02 -4.5320297241210938e+01 2.3785900115966797e+01 -1.3225000000000000e+02 -4.3259300231933594e+01 2.7355499267578125e+01 -1.3225000000000000e+02 -4.0917900085449219e+01 3.0747798919677734e+01 -1.3225000000000000e+02 -3.8311000823974609e+01 3.3940597534179688e+01 -1.3225000000000000e+02 -3.5455699920654297e+01 3.6913303375244141e+01 -1.3225000000000000e+02 -3.2370399475097656e+01 3.9646598815917969e+01 -1.3225000000000000e+02 -2.9075300216674805e+01 4.2122798919677734e+01 -1.3225000000000000e+02 -2.5591499328613281e+01 4.4325798034667969e+01 -1.3225000000000000e+02 -2.1941799163818359e+01 4.6241298675537109e+01 -1.3225000000000000e+02 -1.8149700164794922e+01 4.7856899261474609e+01 -1.3225000000000000e+02 -1.4240000724792480e+01 4.9162200927734375e+01 -1.3225000000000000e+02 -1.0237899780273438e+01 5.0148597717285156e+01 -1.3225000000000000e+02 -6.1693801879882812e+00 5.0809799194335938e+01 -1.3225000000000000e+02 -2.0608899593353271e+00 5.1141502380371094e+01 -1.3225000000000000e+02 2.0608899593353271e+00 5.1141502380371094e+01 -1.3225000000000000e+02 6.1693801879882812e+00 5.0809799194335938e+01 -1.3225000000000000e+02 1.0237899780273438e+01 5.0148597717285156e+01 -1.3225000000000000e+02 1.4240000724792480e+01 4.9162200927734375e+01 -1.3225000000000000e+02 1.8149700164794922e+01 4.7856899261474609e+01 -1.3225000000000000e+02 2.1941799163818359e+01 4.6241298675537109e+01 -1.3225000000000000e+02 2.5591499328613281e+01 4.4325798034667969e+01 -1.3225000000000000e+02 2.9075300216674805e+01 4.2122798919677734e+01 -1.3225000000000000e+02 3.2370399475097656e+01 3.9646598815917969e+01 -1.3225000000000000e+02 3.5455699920654297e+01 3.6913303375244141e+01 -1.3225000000000000e+02 3.8311000823974609e+01 3.3940597534179688e+01 -1.3225000000000000e+02 4.0917900085449219e+01 3.0747798919677734e+01 -1.3225000000000000e+02 4.3259300231933594e+01 2.7355499267578125e+01 -1.3225000000000000e+02 4.5320297241210938e+01 2.3785900115966797e+01 -1.3225000000000000e+02 4.7087299346923828e+01 2.0062000274658203e+01 -1.3225000000000000e+02 4.8548900604248047e+01 1.6208000183105469e+01 -1.3225000000000000e+02 4.9695701599121094e+01 1.2248899459838867e+01 -1.3225000000000000e+02 5.0520198822021484e+01 8.2102994918823242e+00 -1.3243299865722656e+02 5.0834598541259766e+01 4.1037797927856445e+00 -1.3243299865722656e+02 5.1000000000000000e+01 0.0000000000000000e+00 -1.3243299865722656e+02 5.0834598541259766e+01 -4.1037797927856445e+00 -1.3243299865722656e+02 5.0339500427246094e+01 -8.1809701919555664e+00 -1.3243299865722656e+02 4.9518001556396484e+01 -1.2205100059509277e+01 -1.3243299865722656e+02 4.8375301361083984e+01 -1.6149999618530273e+01 -1.3243299865722656e+02 4.6918899536132812e+01 -1.9990301132202148e+01 -1.3243299865722656e+02 4.5158199310302734e+01 -2.3700799942016602e+01 -1.3243299865722656e+02 4.3104598999023438e+01 -2.7257699966430664e+01 -1.3243299865722656e+02 4.0771499633789062e+01 -3.0637899398803711e+01 -1.3243299865722656e+02 3.8173999786376953e+01 -3.3819297790527344e+01 -1.3243299865722656e+02 3.5328899383544922e+01 -3.6781299591064453e+01 -1.3243299865722656e+02 3.2254699707031250e+01 -3.9504798889160156e+01 -1.3243299865722656e+02 2.8971200942993164e+01 -4.1972202301025391e+01 -1.3243299865722656e+02 2.5500000000000000e+01 -4.4167297363281250e+01 -1.3243299865722656e+02 2.1863300323486328e+01 -4.6075901031494141e+01 -1.3243299865722656e+02 1.8084800720214844e+01 -4.7685798645019531e+01 -1.3243299865722656e+02 1.4189100265502930e+01 -4.8986400604248047e+01 -1.3243299865722656e+02 1.0201299667358398e+01 -4.9969299316406250e+01 -1.3243299865722656e+02 6.1473302841186523e+00 -5.0628101348876953e+01 -1.3243299865722656e+02 2.0535600185394287e+00 -5.0958599090576172e+01 -1.3243299865722656e+02 -2.0535600185394287e+00 -5.0958599090576172e+01 -1.3243299865722656e+02 -6.1473302841186523e+00 -5.0628101348876953e+01 -1.3243299865722656e+02 -1.0201299667358398e+01 -4.9969299316406250e+01 -1.3243299865722656e+02 -1.4189100265502930e+01 -4.8986400604248047e+01 -1.3243299865722656e+02 -1.8084800720214844e+01 -4.7685798645019531e+01 -1.3243299865722656e+02 -2.1863300323486328e+01 -4.6075901031494141e+01 -1.3243299865722656e+02 -2.5500000000000000e+01 -4.4167297363281250e+01 -1.3243299865722656e+02 -2.8971200942993164e+01 -4.1972202301025391e+01 -1.3243299865722656e+02 -3.2254699707031250e+01 -3.9504798889160156e+01 -1.3243299865722656e+02 -3.5328899383544922e+01 -3.6781299591064453e+01 -1.3243299865722656e+02 -3.8173999786376953e+01 -3.3819297790527344e+01 -1.3243299865722656e+02 -4.0771499633789062e+01 -3.0637899398803711e+01 -1.3243299865722656e+02 -4.3104598999023438e+01 -2.7257699966430664e+01 -1.3243299865722656e+02 -4.5158199310302734e+01 -2.3700799942016602e+01 -1.3243299865722656e+02 -4.6918899536132812e+01 -1.9990301132202148e+01 -1.3243299865722656e+02 -4.8375301361083984e+01 -1.6149999618530273e+01 -1.3243299865722656e+02 -4.9518001556396484e+01 -1.2205100059509277e+01 -1.3243299865722656e+02 -5.0339500427246094e+01 -8.1809701919555664e+00 -1.3243299865722656e+02 -5.0834598541259766e+01 -4.1037797927856445e+00 -1.3243299865722656e+02 -5.1000000000000000e+01 0.0000000000000000e+00 -1.3243299865722656e+02 -5.0834598541259766e+01 4.1037797927856445e+00 -1.3243299865722656e+02 -5.0339500427246094e+01 8.1809701919555664e+00 -1.3243299865722656e+02 -4.9518001556396484e+01 1.2205100059509277e+01 -1.3243299865722656e+02 -4.8375301361083984e+01 1.6149999618530273e+01 -1.3243299865722656e+02 -4.6918899536132812e+01 1.9990301132202148e+01 -1.3243299865722656e+02 -4.5158199310302734e+01 2.3700799942016602e+01 -1.3243299865722656e+02 -4.3104598999023438e+01 2.7257699966430664e+01 -1.3243299865722656e+02 -4.0771499633789062e+01 3.0637899398803711e+01 -1.3243299865722656e+02 -3.8173999786376953e+01 3.3819297790527344e+01 -1.3243299865722656e+02 -3.5328899383544922e+01 3.6781299591064453e+01 -1.3243299865722656e+02 -3.2254699707031250e+01 3.9504798889160156e+01 -1.3243299865722656e+02 -2.8971200942993164e+01 4.1972202301025391e+01 -1.3243299865722656e+02 -2.5500000000000000e+01 4.4167297363281250e+01 -1.3243299865722656e+02 -2.1863300323486328e+01 4.6075901031494141e+01 -1.3243299865722656e+02 -1.8084800720214844e+01 4.7685798645019531e+01 -1.3243299865722656e+02 -1.4189100265502930e+01 4.8986400604248047e+01 -1.3243299865722656e+02 -1.0201299667358398e+01 4.9969299316406250e+01 -1.3243299865722656e+02 -6.1473302841186523e+00 5.0628101348876953e+01 -1.3243299865722656e+02 -2.0535600185394287e+00 5.0958599090576172e+01 -1.3243299865722656e+02 2.0535600185394287e+00 5.0958599090576172e+01 -1.3243299865722656e+02 6.1473302841186523e+00 5.0628101348876953e+01 -1.3243299865722656e+02 1.0201299667358398e+01 4.9969299316406250e+01 -1.3243299865722656e+02 1.4189100265502930e+01 4.8986400604248047e+01 -1.3243299865722656e+02 1.8084800720214844e+01 4.7685798645019531e+01 -1.3243299865722656e+02 2.1863300323486328e+01 4.6075901031494141e+01 -1.3243299865722656e+02 2.5500000000000000e+01 4.4167297363281250e+01 -1.3243299865722656e+02 2.8971200942993164e+01 4.1972202301025391e+01 -1.3243299865722656e+02 3.2254699707031250e+01 3.9504798889160156e+01 -1.3243299865722656e+02 3.5328899383544922e+01 3.6781299591064453e+01 -1.3243299865722656e+02 3.8173999786376953e+01 3.3819297790527344e+01 -1.3243299865722656e+02 4.0771499633789062e+01 3.0637899398803711e+01 -1.3243299865722656e+02 4.3104598999023438e+01 2.7257699966430664e+01 -1.3243299865722656e+02 4.5158199310302734e+01 2.3700799942016602e+01 -1.3243299865722656e+02 4.6918899536132812e+01 1.9990301132202148e+01 -1.3243299865722656e+02 4.8375301361083984e+01 1.6149999618530273e+01 -1.3243299865722656e+02 4.9518001556396484e+01 1.2205100059509277e+01 -1.3243299865722656e+02 5.0339500427246094e+01 8.1809701919555664e+00 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 9120 -> 30 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3044500350952148e+02 -1.4159300364553928e+01 -4.8883400857448578e+01) (float-vector -1.1900000274181366e+02 -9.5022302120923996e+00 -2.9245000332593918e+01) (float-vector -1.1900000274181366e+02 2.0575800910592079e+01 -2.2851699963212013e+01) (float-vector -1.3078899681568146e+02 2.9060099273920059e+01 -4.2100798338651657e+01) (float-vector -1.3078899681568146e+02 1.0232600383460522e+01 -5.0122398883104324e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6150000691413879e+02 2.3018900305032730e+01 -4.6627499163150787e+01) (float-vector -1.3078899681568146e+02 1.0232600383460522e+01 -5.0122398883104324e+01) (float-vector -1.3078899681568146e+02 2.9060099273920059e+01 -4.2100798338651657e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6150000691413879e+02 -5.1946800202131271e+01 -2.3499699309468269e+00) (float-vector -1.6150000691413879e+02 -4.6804398298263550e+01 2.2657200694084167e+01) (float-vector -1.3349999487400055e+02 -4.6804398298263550e+01 2.2657200694084167e+01) (float-vector -1.3044500350952148e+02 -5.0892800092697144e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3078899681568146e+02 2.9060099273920059e+01 -4.2100798338651657e+01) (float-vector -1.3349999487400055e+02 3.6911599338054657e+01 -3.6626901477575302e+01) (float-vector -1.6150000691413879e+02 3.6911599338054657e+01 -3.6626901477575302e+01) (float-vector -1.6150000691413879e+02 2.3018900305032730e+01 -4.6627499163150787e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 -3.0379600822925568e+01 4.2202800512313843e+01) (float-vector -1.3044500350952148e+02 -3.5254601389169693e+01 3.6704000085592270e+01) (float-vector -1.3349999487400055e+02 -4.6804398298263550e+01 2.2657200694084167e+01) (float-vector -1.6150000691413879e+02 -4.6804398298263550e+01 2.2657200694084167e+01) (float-vector -1.6150000691413879e+02 -3.6911599338054657e+01 3.6626901477575302e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3199999928474426e+02 -1.8173500895500183e+01 4.7919601202011108e+01) (float-vector -1.3349999487400055e+02 -3.0379600822925568e+01 4.2202800512313843e+01) (float-vector -1.6150000691413879e+02 -3.6911599338054657e+01 3.6626901477575302e+01) (float-vector -1.6150000691413879e+02 -1.5030300244688988e+01 4.9780398607254028e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3044500350952148e+02 -2.8910400345921516e+01 -4.1883900761604309e+01) (float-vector -1.6150000691413879e+02 -3.3453598618507385e+01 -3.9810199290513992e+01) (float-vector -1.6150000691413879e+02 -4.8369199037551880e+01 -1.9089799374341965e+01) (float-vector -1.3349999487400055e+02 -4.8369199037551880e+01 -1.9089799374341965e+01) (float-vector -1.3024500012397766e+02 -4.2689498513936996e+01 -2.6995200663805008e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6150000691413879e+02 -4.8369199037551880e+01 -1.9089799374341965e+01) (float-vector -1.6150000691413879e+02 -5.1946800202131271e+01 -2.3499699309468269e+00) (float-vector -1.3044500350952148e+02 -5.0892800092697144e+01 0.0000000000000000e+00) (float-vector -1.3349999487400055e+02 -4.8369199037551880e+01 -1.9089799374341965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 -4.6804398298263550e+01 2.2657200694084167e+01) (float-vector -1.3044500350952148e+02 -3.5254601389169693e+01 3.6704000085592270e+01) (float-vector -1.1900000274181366e+02 -2.4877300485968590e+01 1.8074400722980499e+01) (float-vector -1.1900000274181366e+02 -3.0750000849366188e+01 0.0000000000000000e+00) (float-vector -1.3044500350952148e+02 -5.0892800092697144e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.6150000691413879e+02 1.9477000460028648e+00 5.1963500678539276e+01) (float-vector -1.6150000691413879e+02 -1.5030300244688988e+01 4.9780398607254028e+01) (float-vector -1.6150000691413879e+02 -3.6911599338054657e+01 3.6626901477575302e+01) (float-vector -1.6150000691413879e+02 -4.6804398298263550e+01 2.2657200694084167e+01) (float-vector -1.6150000691413879e+02 -5.1946800202131271e+01 -2.3499699309468269e+00) (float-vector -1.6150000691413879e+02 -4.8369199037551880e+01 -1.9089799374341965e+01) (float-vector -1.6150000691413879e+02 -3.3453598618507385e+01 -3.9810199290513992e+01) (float-vector -1.6150000691413879e+02 -1.0474099777638912e+01 -5.0934199243783951e+01) (float-vector -1.6150000691413879e+02 2.3018900305032730e+01 -4.6627499163150787e+01) (float-vector -1.6150000691413879e+02 3.6911599338054657e+01 -3.6626901477575302e+01) (float-vector -1.6150000691413879e+02 4.6804398298263550e+01 -2.2657200694084167e+01) (float-vector -1.6150000691413879e+02 5.1946800202131271e+01 2.3499699309468269e+00) (float-vector -1.6150000691413879e+02 4.8369199037551880e+01 1.9089799374341965e+01) (float-vector -1.6150000691413879e+02 3.3453598618507385e+01 3.9810199290513992e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 4.9895301461219788e+01 -1.4644400216639042e+01) (float-vector -1.3078899681568146e+02 5.0990398973226547e+01 4.1163600981235504e+00) (float-vector -1.6150000691413879e+02 5.1946800202131271e+01 2.3499699309468269e+00) (float-vector -1.6150000691413879e+02 4.6804398298263550e+01 -2.2657200694084167e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 4.9895301461219788e+01 -1.4644400216639042e+01) (float-vector -1.6150000691413879e+02 4.6804398298263550e+01 -2.2657200694084167e+01) (float-vector -1.6150000691413879e+02 3.6911599338054657e+01 -3.6626901477575302e+01) (float-vector -1.3349999487400055e+02 3.6911599338054657e+01 -3.6626901477575302e+01) (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 -2.3651100695133209e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 -2.3651100695133209e+01) (float-vector -1.1900000274181366e+02 3.0077999457716942e+01 -6.3932500779628754e+00) (float-vector -1.3078899681568146e+02 5.0990398973226547e+01 4.1163600981235504e+00) (float-vector -1.3349999487400055e+02 4.9895301461219788e+01 -1.4644400216639042e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1900000274181366e+02 3.0077999457716942e+01 -6.3932500779628754e+00) (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 -2.3651100695133209e+01) (float-vector -1.3349999487400055e+02 3.6911599338054657e+01 -3.6626901477575302e+01) (float-vector -1.3078899681568146e+02 2.9060099273920059e+01 -4.2100798338651657e+01) (float-vector -1.1900000274181366e+02 2.0575800910592079e+01 -2.2851699963212013e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 -1.9477000460028648e+00 -5.1963500678539276e+01) (float-vector -1.3044500350952148e+02 -1.4159300364553928e+01 -4.8883400857448578e+01) (float-vector -1.3078899681568146e+02 1.0232600383460522e+01 -5.0122398883104324e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 -1.9477000460028648e+00 -5.1963500678539276e+01) (float-vector -1.3078899681568146e+02 1.0232600383460522e+01 -5.0122398883104324e+01) (float-vector -1.6150000691413879e+02 2.3018900305032730e+01 -4.6627499163150787e+01) (float-vector -1.6150000691413879e+02 -1.0474099777638912e+01 -5.0934199243783951e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 -1.9477000460028648e+00 -5.1963500678539276e+01) (float-vector -1.6150000691413879e+02 -1.0474099777638912e+01 -5.0934199243783951e+01) (float-vector -1.6150000691413879e+02 -3.3453598618507385e+01 -3.9810199290513992e+01) (float-vector -1.3044500350952148e+02 -2.8910400345921516e+01 -4.1883900761604309e+01) (float-vector -1.3044500350952148e+02 -1.4159300364553928e+01 -4.8883400857448578e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1900000274181366e+02 -2.4877300485968590e+01 -1.8074400722980499e+01) (float-vector -1.3024500012397766e+02 -4.2689498513936996e+01 -2.6995200663805008e+01) (float-vector -1.3349999487400055e+02 -4.8369199037551880e+01 -1.9089799374341965e+01) (float-vector -1.3044500350952148e+02 -5.0892800092697144e+01 0.0000000000000000e+00) (float-vector -1.1900000274181366e+02 -3.0750000849366188e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1900000274181366e+02 -2.4877300485968590e+01 -1.8074400722980499e+01) (float-vector -1.1900000274181366e+02 -3.0750000849366188e+01 0.0000000000000000e+00) (float-vector -1.1900000274181366e+02 -2.4877300485968590e+01 1.8074400722980499e+01) (float-vector -1.1900000274181366e+02 -9.5022302120923996e+00 2.9245000332593918e+01) (float-vector -1.1999999731779099e+02 1.5875000506639481e+01 2.7496300637722015e+01) (float-vector -1.1900000274181366e+02 2.8091499581933022e+01 1.2507099658250809e+01) (float-vector -1.1900000274181366e+02 3.0077999457716942e+01 -6.3932500779628754e+00) (float-vector -1.1900000274181366e+02 2.0575800910592079e+01 -2.2851699963212013e+01) (float-vector -1.1900000274181366e+02 -9.5022302120923996e+00 -2.9245000332593918e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3044500350952148e+02 -1.4159300364553928e+01 -4.8883400857448578e+01) (float-vector -1.3044500350952148e+02 -2.8910400345921516e+01 -4.1883900761604309e+01) (float-vector -1.3024500012397766e+02 -4.2689498513936996e+01 -2.6995200663805008e+01) (float-vector -1.1900000274181366e+02 -2.4877300485968590e+01 -1.8074400722980499e+01) (float-vector -1.1900000274181366e+02 -9.5022302120923996e+00 -2.9245000332593918e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 -3.0379600822925568e+01 4.2202800512313843e+01) (float-vector -1.3199999928474426e+02 -1.8173500895500183e+01 4.7919601202011108e+01) (float-vector -1.3024500012397766e+02 -1.0103000327944756e+01 4.9488101154565811e+01) (float-vector -1.1900000274181366e+02 -9.5022302120923996e+00 2.9245000332593918e+01) (float-vector -1.1900000274181366e+02 -2.4877300485968590e+01 1.8074400722980499e+01) (float-vector -1.3044500350952148e+02 -3.5254601389169693e+01 3.6704000085592270e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1900000274181366e+02 2.8091499581933022e+01 1.2507099658250809e+01) (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 2.3651100695133209e+01) (float-vector -1.3078899681568146e+02 5.0990398973226547e+01 4.1163600981235504e+00) (float-vector -1.1900000274181366e+02 3.0077999457716942e+01 -6.3932500779628754e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 2.3651100695133209e+01) (float-vector -1.3349999487400055e+02 3.9549898356199265e+01 3.3760901540517807e+01) (float-vector -1.6150000691413879e+02 3.3453598618507385e+01 3.9810199290513992e+01) (float-vector -1.6150000691413879e+02 4.8369199037551880e+01 1.9089799374341965e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3078899681568146e+02 5.0990398973226547e+01 4.1163600981235504e+00) (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 2.3651100695133209e+01) (float-vector -1.6150000691413879e+02 4.8369199037551880e+01 1.9089799374341965e+01) (float-vector -1.6150000691413879e+02 5.1946800202131271e+01 2.3499699309468269e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.1900000274181366e+02 -9.5022302120923996e+00 2.9245000332593918e+01) (float-vector -1.3024500012397766e+02 -1.0103000327944756e+01 4.9488101154565811e+01) (float-vector -1.3349999487400055e+02 1.9477000460028648e+00 5.1963500678539276e+01) (float-vector -1.3078899681568146e+02 2.1930299699306488e+01 4.6217098832130432e+01) (float-vector -1.1999999731779099e+02 1.5875000506639481e+01 2.7496300637722015e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 1.9477000460028648e+00 5.1963500678539276e+01) (float-vector -1.3024500012397766e+02 -1.0103000327944756e+01 4.9488101154565811e+01) (float-vector -1.3199999928474426e+02 -1.8173500895500183e+01 4.7919601202011108e+01) (float-vector -1.6150000691413879e+02 -1.5030300244688988e+01 4.9780398607254028e+01) (float-vector -1.6150000691413879e+02 1.9477000460028648e+00 5.1963500678539276e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3078899681568146e+02 2.1930299699306488e+01 4.6217098832130432e+01) (float-vector -1.3349999487400055e+02 1.9477000460028648e+00 5.1963500678539276e+01) (float-vector -1.6150000691413879e+02 1.9477000460028648e+00 5.1963500678539276e+01) (float-vector -1.6150000691413879e+02 3.3453598618507385e+01 3.9810199290513992e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 2.3651100695133209e+01) (float-vector -1.3044500350952148e+02 3.5254601389169693e+01 3.6704000085592270e+01) (float-vector -1.3349999487400055e+02 3.9549898356199265e+01 3.3760901540517807e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3349999487400055e+02 3.9549898356199265e+01 3.3760901540517807e+01) (float-vector -1.3044500350952148e+02 3.5254601389169693e+01 3.6704000085592270e+01) (float-vector -1.3078899681568146e+02 2.1930299699306488e+01 4.6217098832130432e+01) (float-vector -1.6150000691413879e+02 3.3453598618507385e+01 3.9810199290513992e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.3078899681568146e+02 2.1930299699306488e+01 4.6217098832130432e+01) (float-vector -1.3044500350952148e+02 3.5254601389169693e+01 3.6704000085592270e+01) (float-vector -1.3044500350952148e+02 4.5063298195600510e+01 2.3651100695133209e+01) (float-vector -1.1900000274181366e+02 2.8091499581933022e+01 1.2507099658250809e+01) (float-vector -1.1999999731779099e+02 1.5875000506639481e+01 2.7496300637722015e+01)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_wrist_roll_link_YEcpDN.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  (:_make_instance_gripper_link_geom0 ()
    (let (geom glv qhull
          (local-cds (make-coords :pos (float-vector 1.6644999999999999e+02 0.0000000000000000e+00 0.0000000000000000e+00))))
      (setq glv
       (instance gl::glvertices :init
                 (list ;; mesh list
                  (list ;; mesh description
                   (list :type :triangles)
                   (list :material (list
                    (list :ambient (float-vector 0.050000 0.050000 0.050000 0.000000))
                    (list :diffuse (float-vector 1.000000 1.000000 1.000000 0.000000))))
                   (list :indices #i( 0 1 2 46 47 0 0 47 1 0 2 897 0 897 46 0 1317 46 2 1356 0 0 1356 1317 2 0 1910 1910 0 1911 46 2050 0 0 2050 1911 46 1317 1318 1356 1398 1317 1317 1398 1318 46 1318 1319 1319 1318 1320 1572 1573 1318 1318 1573 1320 1318 1398 1572 1397 1398 1399 1399 1398 1356 1397 1572 1398 1574 1573 1572 1572 1575 1574 1397 1575 1572 1680 1320 1573 1680 1573 1574 1574 1575 1576 1574 1576 1577 1680 1574 1688 1688 1574 1577 1403 1575 1397 1403 1576 1575 1399 1403 1397 1399 1401 1403 1401 1578 1403 1403 1578 1576 1576 1578 1577 1577 1578 1579 1401 1579 1578 1577 1579 1580 1688 1577 1689 1577 1580 1689 1580 1579 1581 1400 1581 1579 1400 1579 1401 1400 1401 1402 1402 1401 1399 1402 1408 1400 1400 1408 1406 1400 1406 1409 1409 1581 1400 1497 1406 1408 1497 1408 1496 1496 1408 1402 1496 1495 1497 1497 1495 1498 1498 1406 1497 1494 1495 1496 1496 1402 1494 1493 1492 1494 1494 1492 1495 1494 1402 1678 1494 1678 1493 1492 1493 1354 1354 1493 1355 1355 1493 1356 1356 1493 1678 1354 1739 1492 1495 1492 1739 1353 1352 1354 1353 1354 4 4 1354 1355 1352 1739 1354 4 1355 2 2 1355 1356 1356 1678 1399 1402 1399 1678 2 1 3 2 3 4 897 2 898 2 4 898 2 1910 4 896 895 897 896 897 898 46 897 956 956 897 895 898 4 913 898 913 927 898 927 896 4 6 913 913 6 914 913 914 927 927 914 928 928 933 927 896 927 933 1300 1302 914 914 1302 1303 914 1303 928 914 6 1300 931 932 928 928 932 933 928 1303 931 896 933 894 894 933 886 886 933 932 931 930 932 886 932 887 932 930 887 886 887 888 888 892 886 886 892 893 886 893 894 894 893 895 894 895 896 892 966 893 893 966 957 893 957 895 888 966 892 957 966 958 958 966 967 888 967 966 957 958 959 895 957 959 895 959 956 959 958 960 959 960 956 955 46 956 956 960 955 958 1065 960 960 1065 1047 960 1047 955 44 46 955 1047 44 955 44 45 46 46 45 47 1319 2050 46 42 43 44 44 43 45 1047 42 44 40 41 42 42 41 43 40 42 1047 40 39 41 43 41 431 431 41 39 38 37 39 38 39 40 37 222 39 39 222 223 431 39 223 36 35 37 36 37 38 222 37 462 462 37 35 222 230 223 230 222 462 462 463 464 462 464 230 462 35 463 223 230 231 230 464 474 230 474 231 463 467 464 464 467 468 464 468 474 35 467 463 466 465 467 467 465 380 467 380 468 35 466 467 468 380 373 468 373 469 474 468 469 474 469 475 231 474 475 373 375 469 469 375 377 469 377 461 475 469 461 373 374 375 373 380 374 375 374 376 375 376 377 377 376 378 377 378 372 461 377 372 374 172 376 376 172 378 372 378 379 378 172 179 378 179 379 371 370 372 372 379 371 461 372 370 174 371 379 379 179 180 379 180 174 172 178 179 179 178 176 179 176 180 180 176 174 173 174 175 175 174 176 371 174 369 369 174 173 369 370 371 367 368 369 369 368 370 369 173 367 365 366 367 367 366 368 367 173 183 367 183 365 370 368 460 460 368 366 365 364 366 460 366 470 364 470 366 370 460 461 476 461 460 476 460 477 477 460 470 362 472 470 362 470 364 477 470 478 478 470 472 363 362 364 363 364 365 361 360 362 361 362 363 360 472 362 360 471 472 478 472 479 479 472 471 359 358 360 359 360 361 358 471 360 363 184 361 361 184 187 361 187 359 365 184 363 365 183 184 183 182 184 182 185 184 184 185 186 184 186 187 187 186 188 359 187 357 357 187 188 357 358 359 355 356 357 357 356 358 357 188 355 186 189 188 188 189 190 188 190 191 355 188 191 353 354 355 355 354 356 355 191 353 358 356 471 471 356 354 353 352 354 471 354 473 473 354 352 351 352 353 353 191 192 353 192 351 191 190 192 193 65 192 193 192 194 194 192 190 192 65 491 351 192 491 308 193 194 308 194 306 306 194 304 304 194 190 304 190 303 303 190 189 303 302 304 304 302 305 304 305 306 306 305 307 306 307 308 655 307 305 655 305 642 642 305 302 301 300 302 301 302 303 642 302 300 300 641 642 658 655 642 658 642 659 659 642 641 299 298 300 299 300 301 300 298 641 186 301 303 301 186 299 297 298 299 299 186 185 299 185 297 297 296 298 641 298 296 295 296 297 297 185 295 295 185 182 293 294 295 295 294 296 295 182 293 641 296 656 296 294 656 293 292 294 656 294 292 291 292 293 293 182 181 293 181 291 173 181 182 173 182 183 175 181 173 291 181 175 289 290 291 291 290 292 291 175 289 656 292 657 657 292 290 289 288 290 657 290 650 650 290 288 287 288 289 289 175 287 287 175 176 285 286 287 287 286 288 287 176 285 650 288 286 285 280 286 286 280 650 284 280 285 285 176 178 285 178 284 278 279 280 284 278 280 280 279 633 650 280 633 283 278 284 284 178 177 284 177 283 172 177 178 171 177 172 283 177 171 281 278 283 283 171 281 170 168 171 170 171 172 487 171 488 488 171 168 281 171 487 374 170 172 374 380 382 374 382 383 383 170 374 380 381 382 465 381 380 383 382 384 31 384 382 31 382 381 170 383 384 29 384 31 384 492 170 384 29 492 28 27 29 28 29 30 30 29 31 492 29 27 170 492 493 492 27 493 169 168 170 170 493 169 493 27 169 26 25 27 26 27 28 25 169 27 168 169 25 488 168 25 24 23 25 24 25 26 23 282 25 25 282 487 25 487 488 281 282 278 23 278 282 281 487 282 23 279 278 22 21 23 22 23 24 21 279 23 279 21 633 20 19 21 20 21 22 633 21 19 633 19 634 650 633 649 649 633 634 19 640 634 649 634 640 640 639 649 649 639 638 663 650 649 663 649 648 648 649 638 662 657 650 662 650 663 116 662 663 116 663 117 117 663 648 661 657 662 137 661 662 137 662 116 661 656 657 660 656 661 136 660 661 136 661 137 136 137 116 116 145 136 145 660 136 659 641 660 660 641 656 145 659 660 116 144 145 144 659 145 144 658 659 118 143 144 118 144 116 143 658 144 651 655 658 143 651 658 123 143 118 123 651 143 118 122 123 123 653 651 123 122 653 15 124 122 15 122 125 125 122 118 653 122 665 122 124 665 651 653 654 665 654 653 667 652 665 665 652 654 665 124 669 669 667 665 115 124 15 115 669 124 668 666 669 669 666 667 671 668 669 671 669 115 114 115 13 13 115 15 114 671 115 670 668 671 673 670 671 673 671 114 631 668 670 631 670 630 630 670 629 672 629 670 672 670 673 675 672 673 675 673 133 133 673 114 628 629 672 674 628 672 674 672 675 628 621 629 629 621 620 629 620 630 628 623 621 623 628 674 676 623 674 676 674 677 677 674 675 622 621 623 622 623 624 624 623 676 620 621 622 622 626 620 620 626 625 630 620 625 625 626 627 630 625 631 631 625 627 627 626 162 627 162 167 631 627 632 632 627 167 632 668 631 632 167 166 166 664 632 632 664 668 164 166 167 164 167 162 165 166 164 664 166 165 165 643 664 664 643 647 664 647 666 664 666 668 311 310 165 311 165 164 643 165 310 646 647 643 643 310 646 646 645 647 666 647 645 666 645 667 644 645 646 645 644 667 646 310 309 646 309 655 644 646 651 651 646 655 308 309 310 308 310 311 307 309 308 309 307 655 311 193 308 70 65 193 311 164 193 193 164 483 193 483 70 162 163 164 164 163 483 163 162 616 616 162 626 483 163 484 163 616 617 163 617 484 617 616 618 616 626 618 622 615 626 618 626 615 617 618 615 615 551 617 617 551 550 617 550 619 484 617 619 484 485 483 484 619 485 619 550 549 619 549 614 485 619 614 548 549 550 550 551 552 550 552 548 549 548 559 559 614 549 613 486 614 613 614 559 485 614 486 483 485 486 482 70 483 483 486 482 482 486 613 612 482 613 612 613 560 560 613 559 559 548 557 559 557 560 560 557 561 560 561 562 562 612 560 611 68 612 562 611 612 68 482 612 68 70 482 68 69 70 611 69 68 565 610 611 565 611 563 610 69 611 563 611 562 562 561 563 563 561 564 563 564 565 565 564 566 566 610 565 567 609 610 567 610 566 609 71 610 610 71 69 70 69 71 70 71 72 609 72 71 568 547 609 609 547 602 568 609 567 602 72 609 566 558 567 558 568 567 566 564 558 561 495 564 564 495 497 564 497 558 557 494 561 561 494 495 494 63 495 498 497 495 495 63 498 496 497 498 558 497 496 496 498 394 394 498 504 498 63 60 498 60 504 62 60 63 62 63 64 494 64 63 557 64 494 557 62 64 61 60 62 557 556 62 556 683 62 62 683 61 59 58 60 59 60 61 504 60 58 61 683 689 61 689 59 682 681 683 682 683 556 691 689 683 691 683 681 688 56 689 59 689 56 690 688 689 690 689 691 56 58 59 54 55 56 55 57 56 56 57 58 688 54 56 52 53 54 54 53 55 52 54 688 506 57 55 506 55 507 507 55 53 505 58 57 505 57 506 398 505 506 398 506 402 402 506 507 390 504 505 390 505 398 504 58 505 394 504 395 395 504 390 387 393 394 395 387 394 394 393 496 390 387 395 388 389 390 390 389 391 390 391 392 392 385 390 390 385 387 398 399 390 390 399 400 390 400 388 391 105 392 392 105 104 392 104 385 65 104 105 65 105 106 391 106 105 67 104 65 104 67 601 385 104 601 65 66 67 66 601 67 385 601 386 608 386 601 66 608 601 65 75 66 75 608 66 607 542 608 608 542 386 75 607 608 385 386 387 386 542 387 387 542 543 607 543 542 606 543 607 74 606 607 74 607 75 65 74 75 73 74 65 73 606 74 605 540 606 606 540 543 73 605 606 387 543 540 540 541 387 605 541 540 604 541 605 92 604 605 92 605 73 65 92 73 65 91 92 91 604 92 603 545 604 545 544 604 604 544 541 91 603 604 541 544 387 387 544 545 387 545 539 539 545 546 603 546 545 90 602 603 602 546 603 90 603 91 539 546 547 602 547 546 539 393 387 393 539 558 539 547 558 558 547 568 558 496 393 602 90 72 72 90 70 70 90 91 70 91 65 76 77 65 80 79 65 77 96 65 65 96 97 65 97 80 106 110 65 65 110 111 65 111 76 79 491 65 401 97 96 401 96 396 396 96 77 403 80 97 403 97 401 396 398 401 401 398 402 401 402 403 396 397 398 396 77 397 398 397 399 397 77 76 397 76 399 399 76 400 400 76 111 400 111 388 388 111 110 388 110 389 389 110 106 389 106 391 402 408 403 408 80 403 402 407 408 407 78 408 408 78 80 78 79 80 78 93 79 404 93 78 404 78 407 404 407 402 404 402 405 405 402 406 402 507 406 405 93 404 79 93 94 405 94 93 406 413 405 413 94 405 79 94 95 413 95 94 406 412 413 412 95 413 95 98 79 412 98 95 409 412 406 409 98 412 79 98 99 409 99 98 409 406 410 410 99 409 79 99 100 410 100 99 410 406 411 411 423 410 423 100 410 100 101 79 423 101 100 411 422 423 422 101 423 79 101 102 421 102 101 421 101 422 421 422 411 411 420 421 420 102 421 79 102 103 420 103 102 411 419 420 419 103 420 103 112 79 419 112 103 417 419 411 417 112 419 79 112 113 595 113 112 595 112 417 417 411 416 416 514 417 595 417 514 113 595 596 595 514 596 79 113 81 113 596 81 596 514 513 596 513 597 81 596 597 416 513 514 512 513 416 597 513 512 597 512 598 81 597 82 82 597 598 81 82 79 79 82 83 82 598 83 598 512 511 598 511 599 83 598 599 416 511 512 416 510 511 599 511 510 599 510 600 83 599 84 84 599 600 79 83 84 84 107 79 84 600 107 600 510 509 600 509 594 107 600 594 509 510 416 416 415 509 509 415 515 509 515 516 594 509 516 517 590 594 594 516 517 107 594 108 108 594 590 79 107 108 79 108 87 87 108 109 108 590 109 590 517 528 109 590 591 590 528 591 516 515 517 517 515 528 528 515 529 529 532 528 591 528 532 591 532 592 109 591 85 85 591 592 87 109 85 85 86 87 85 592 86 532 531 592 592 531 535 592 535 593 86 592 593 529 531 532 530 531 529 530 535 531 530 534 535 534 593 535 533 589 593 533 593 534 86 593 88 88 593 589 87 86 88 87 88 89 88 589 89 588 89 589 588 589 536 536 589 538 538 589 533 89 426 87 426 89 588 585 426 588 585 588 519 519 588 536 519 536 520 520 536 527 538 527 536 537 527 538 533 537 538 49 48 527 527 48 522 527 522 520 537 49 527 502 49 537 530 502 537 530 537 533 533 534 530 503 502 530 503 530 500 500 530 529 49 502 51 51 502 503 499 51 503 499 503 500 499 500 501 500 529 501 501 529 515 414 499 501 414 501 415 501 515 415 508 51 499 418 508 499 418 499 414 414 415 416 416 418 414 416 411 418 411 508 418 507 53 508 508 53 51 411 507 508 406 507 411 50 49 51 50 51 52 52 51 53 48 49 50 684 48 50 684 50 686 686 50 52 686 52 688 685 684 686 685 686 687 687 686 688 687 688 690 147 685 687 147 687 149 149 687 690 147 146 685 685 146 692 685 692 684 146 147 148 148 147 149 148 149 150 150 149 151 149 690 151 151 690 691 150 151 152 151 691 152 152 691 681 135 150 152 135 152 153 153 152 154 152 681 154 680 154 681 680 681 682 153 154 155 155 154 680 679 677 153 153 677 135 153 155 679 679 155 680 679 680 678 678 680 682 678 682 552 552 682 556 555 624 678 678 624 676 678 676 679 552 555 678 679 676 677 677 675 135 135 675 133 133 134 135 134 150 135 114 132 133 133 132 134 699 697 134 134 697 150 699 134 132 697 693 150 150 693 148 696 695 697 697 695 693 699 696 697 698 696 699 698 699 700 699 132 700 580 526 696 696 526 695 698 580 696 694 693 695 694 695 524 524 695 526 525 524 526 525 526 581 581 526 580 580 578 576 580 576 581 578 580 698 577 576 578 577 578 701 701 578 698 574 575 576 574 576 577 581 576 575 577 701 574 574 701 702 698 700 701 701 700 703 701 703 702 573 572 574 572 575 574 574 702 573 581 575 579 572 579 575 570 571 572 570 572 573 571 579 572 573 702 570 569 158 570 158 571 570 570 702 705 570 705 569 158 160 571 571 160 579 156 157 158 158 157 159 158 159 160 569 156 158 569 705 709 569 709 156 157 156 710 710 156 709 159 157 247 247 157 248 248 157 710 710 709 711 248 710 727 727 710 711 705 708 709 711 709 708 711 708 712 727 711 735 735 711 712 725 250 727 727 250 248 734 725 727 734 727 735 735 712 713 142 734 735 142 735 130 130 735 713 712 708 707 712 707 713 705 707 708 704 706 707 704 707 705 707 706 713 702 704 705 703 121 704 702 703 704 121 706 704 121 120 706 713 706 120 13 120 121 13 121 114 121 131 114 703 131 121 700 131 703 114 131 132 700 132 131 12 11 13 12 13 14 14 13 15 119 120 13 119 13 716 716 13 11 14 15 16 16 15 17 17 15 125 125 635 17 118 635 125 17 635 636 635 648 636 118 648 635 116 117 118 117 648 118 636 648 637 648 638 637 17 636 637 637 638 17 17 638 639 17 639 19 19 639 640 18 17 19 18 19 20 16 17 18 20 939 18 18 939 1231 18 1231 16 22 939 20 938 937 939 938 939 22 1231 939 1246 1246 939 937 16 1231 1232 1246 1232 1231 1245 1237 1246 1246 1237 1232 1246 937 1245 936 935 937 936 937 938 1245 937 935 938 848 936 22 848 938 934 935 936 936 848 854 936 854 934 934 945 935 934 854 852 934 852 945 853 852 854 853 854 855 855 854 848 851 850 852 851 852 853 945 852 850 935 945 946 849 946 945 945 850 849 849 850 851 851 856 849 853 1000 851 851 1000 999 851 999 856 855 1000 853 995 999 1000 995 1000 994 855 994 1000 998 997 999 998 999 995 999 997 856 994 993 995 993 1080 995 995 1080 998 992 993 994 847 992 994 847 994 855 28 30 992 992 30 993 847 26 992 992 26 28 847 848 26 855 848 847 26 848 24 24 848 22 24 1337 22 22 1337 1338 22 1338 1339 22 1339 2048 22 2048 24 24 1336 1337 1337 1336 1358 1337 1358 1338 1357 1358 1359 1358 1336 1359 1338 1358 1568 1357 1568 1358 1359 1394 1357 1394 1569 1357 1357 1569 1568 1392 1393 1359 1359 1393 1394 1392 1359 1679 1336 1679 1359 1393 1571 1394 1394 1571 1570 1394 1570 1569 1568 1569 1566 1566 1569 1570 1566 1570 1561 1561 1570 1571 1561 1571 1562 1393 1562 1571 1392 1390 1393 1390 1562 1393 1561 1562 1563 1563 1562 1564 1390 1564 1562 1824 1566 1561 1824 1561 1827 1561 1563 1827 1563 1564 1560 1827 1563 1560 1560 1564 1565 1389 1565 1564 1389 1564 1390 1559 1558 1560 1560 1565 1559 1827 1560 1828 1560 1558 1828 1384 1565 1389 1384 1559 1565 1384 1389 1382 1382 1389 1390 1382 1383 1384 1383 1550 1384 1384 1550 1559 1550 1558 1559 1550 1557 1558 1828 1558 1557 1550 1551 1552 1552 1557 1550 1383 1551 1550 1383 1382 1374 1374 1551 1383 1552 1551 1553 1374 1553 1551 1552 1553 1554 1557 1552 1829 1829 1552 1554 1828 1557 1829 1829 1554 1830 1834 1828 1829 1834 1829 1835 1835 1829 1830 1554 1553 1555 1554 1555 1549 1554 1549 1830 1549 1555 1556 1378 1556 1555 1378 1555 1376 1376 1555 1553 1548 1547 1549 1549 1556 1548 1830 1549 1547 1381 1556 1378 1381 1548 1556 1376 1377 1378 1377 1381 1378 1374 1375 1376 1376 1375 1377 1376 1553 1374 1369 1380 1377 1377 1380 1381 1631 1369 1377 1631 1377 1375 1380 1546 1381 1381 1546 1548 1369 1379 1380 1379 1544 1380 1380 1544 1546 1544 1545 1546 1546 1545 1547 1546 1547 1548 1541 1543 1544 1544 1543 1545 1379 1541 1544 1368 1379 1369 1368 1541 1379 1539 1540 1541 1540 1542 1541 1541 1542 1543 1368 1539 1541 1831 1545 1543 1831 1543 1825 1825 1543 1542 1825 1542 1540 1539 1537 1540 1825 1540 1826 1826 1540 1537 1837 1831 1825 1837 1825 1838 1838 1825 1826 1838 1826 1839 1537 1817 1826 1826 1817 1816 1826 1816 1839 1481 1837 1838 1481 1838 1483 1483 1838 1839 1462 1480 1481 1462 1481 1482 1482 1481 1483 1480 1837 1481 1483 1839 1482 1482 1839 1814 1482 1814 1462 1807 1462 1814 1807 1814 1808 1808 1814 1815 1839 1815 1814 1457 1807 1805 1805 1807 1808 1457 1462 1807 1805 1808 1806 1806 1808 1809 1808 1815 1809 1809 1815 1816 1839 1816 1815 1806 1809 1810 1809 1816 1810 1810 1816 1817 1812 1806 1810 1812 1810 1813 1810 1817 1813 1813 1817 1530 1537 1530 1817 1738 1812 1813 1738 1813 1529 1813 1530 1529 1811 1806 1812 1737 1811 1812 1737 1812 1738 1531 1737 1738 1531 1738 1529 1529 1530 1531 1531 1530 1532 1535 1532 1530 1535 1530 1536 1536 1530 1537 1532 1535 1363 1363 1535 1536 1536 1537 1538 1363 1536 1360 1360 1536 1538 1360 1362 1363 1363 1362 1364 1363 1364 1365 1363 1365 1532 1360 1361 1362 1360 1538 1361 1538 1537 1539 1361 1538 1539 1361 1539 1368 1368 1369 1361 1361 1369 1370 1628 1370 1369 1628 1369 1630 1630 1369 1631 1361 1370 1371 1625 1371 1370 1625 1370 1628 1627 1625 1628 1627 1628 1629 1628 1630 1629 1629 1630 1631 1629 1631 1632 1632 1631 1633 1375 1633 1631 1718 1627 1629 1718 1629 1719 1629 1632 1719 1626 1625 1627 1626 1627 1718 1717 1626 1718 1723 1717 1718 1723 1718 1724 1724 1718 1719 1624 1625 1626 1717 1624 1626 1621 1623 1624 1624 1623 1625 1621 1624 1717 1623 1371 1625 1621 1622 1623 1622 1371 1623 1619 1620 1621 1620 1622 1621 1716 1619 1621 1716 1621 1717 1620 1372 1622 1622 1372 1371 1371 1372 1361 1361 1372 1373 1620 1373 1372 1619 1618 1620 1618 1373 1620 1616 1618 1619 1616 1619 1716 1616 1617 1618 1617 1362 1618 1618 1362 1373 1361 1373 1362 1617 1364 1362 1615 1617 1616 1615 1364 1617 1613 1615 1616 1715 1613 1616 1715 1616 1716 1613 1614 1615 1614 1364 1615 1365 1364 1366 1614 1366 1364 1612 1614 1613 1614 1612 1367 1367 1366 1614 1365 1366 1367 1365 1367 1395 1395 1675 1365 1365 1675 1676 1365 1676 1532 1395 1367 1396 1396 1367 1610 1610 1367 1612 1611 1610 1612 1613 1611 1612 1608 1609 1610 1608 1610 1611 1430 1396 1610 1610 1609 1430 1608 1611 1684 1684 1611 1709 1709 1611 1613 1709 1613 1715 1708 1685 1709 1684 1709 1687 1687 1709 1685 1715 1708 1709 1708 1715 1707 1707 1715 1710 1710 1715 1716 1707 1704 1708 1708 1704 1685 1706 1705 1707 1707 1705 1704 1706 1707 1710 1710 1716 1722 1706 1710 1437 1437 1710 1722 1722 1716 1717 1722 1717 1723 1437 1722 1452 1452 1722 1723 1452 1723 1450 1450 1723 1724 1450 1451 1452 1452 1451 1453 1452 1453 1437 1450 1724 1451 1724 1719 1725 1451 1724 1725 1451 1725 1453 1437 1453 1454 1453 1725 1726 1453 1726 1454 1725 1719 1720 1725 1720 1726 1719 1632 1634 1719 1634 1720 1634 1636 1720 1720 1636 1639 1720 1639 1721 1726 1720 1721 1726 1721 1727 1454 1726 1727 1639 1641 1721 1721 1641 1643 1721 1643 1711 1727 1721 1711 1636 1638 1639 1639 1638 1640 1639 1640 1641 1641 1640 1642 1641 1642 1643 1643 1642 1644 1643 1644 1645 1711 1643 1645 1640 1385 1642 1642 1385 1382 1642 1382 1644 1638 1386 1640 1640 1386 1385 1636 1637 1638 1386 1638 1637 1374 1385 1386 1386 1387 1374 1637 1387 1386 1374 1382 1385 1382 1390 1391 1644 1382 1391 1391 1390 1392 1644 1391 1649 1649 1391 1392 1649 1392 1648 1648 1392 1679 1648 1645 1649 1649 1645 1644 1646 1647 1648 1648 1647 1645 1648 1679 1646 1336 1646 1679 1335 1334 1646 1646 1334 1647 1335 1646 1336 1712 1645 1647 1647 1334 1712 1711 1645 1712 1711 1712 1713 1713 1712 1714 1712 1334 1332 1712 1332 1714 1333 1332 1334 1333 1334 28 28 1334 1335 1331 1332 1333 1333 28 2120 1333 2120 2187 1333 2187 1331 28 1335 26 2120 28 2122 26 1912 28 28 1912 2122 26 1335 1336 26 1336 24 26 24 1912 1912 24 1913 1912 1913 1876 1912 1876 2122 2121 2120 2122 2122 1876 2121 1875 1874 1876 1875 1876 1877 1876 1913 1877 1874 2121 1876 24 2048 1913 1877 1913 2047 2047 1913 2048 2045 1875 1877 2045 1877 2047 1873 1874 1875 1873 1875 2045 2044 2043 2045 2044 2045 2046 2046 2045 2047 2045 2043 1873 2046 2047 2048 2048 1339 2046 2314 2316 2046 2046 2316 2318 2046 2318 2044 2046 1339 2314 2042 2043 2044 2044 2318 2042 2042 2041 2043 1873 2043 2041 2040 2041 2042 2042 2318 2319 2042 2319 2040 2332 2319 2318 2332 2318 2333 2333 2318 2316 1955 2331 2332 1955 2332 1956 1956 2332 2333 2331 2319 2332 1956 2333 1946 1946 2333 2311 2333 2316 2311 1945 1955 1956 1945 1956 1946 1951 1955 1945 1951 2331 1955 1950 1951 1945 1950 2330 1951 1951 2330 2331 1950 1945 1965 1965 2329 1950 1950 2329 2330 2329 2320 2330 2330 2320 2321 2330 2321 2331 1965 2328 2329 2328 2322 2329 2329 2322 2320 1967 2327 2328 1967 2328 1965 2327 2323 2328 2328 2323 2322 2322 2029 2320 2323 2026 2322 2322 2026 2027 2322 2027 2029 2325 2021 2323 2323 2021 2024 2323 2024 2026 2327 2325 2323 2024 2025 2026 2026 2025 2027 2027 2025 2028 2027 2028 2029 2024 2023 2025 1862 2028 2025 1862 2025 1856 1856 2025 2023 2021 2023 2024 2021 2022 2023 1856 2023 1854 2022 1854 2023 1854 1855 1856 1855 1860 1856 1856 1860 1861 1856 1861 1862 1852 1853 1854 1854 1853 1855 2020 1852 1854 2020 1854 2022 2020 2022 2021 2019 2018 2020 2019 2020 2021 2018 1852 2020 1850 1851 1852 1852 1851 1853 2018 1850 1852 2095 1855 1853 2095 1853 1851 1850 1849 1851 1849 2091 1851 1851 2091 2093 1851 2093 2095 1848 1849 1850 2016 1848 1850 2016 1850 2018 1848 1847 1849 1847 2086 1849 1849 2086 2091 2086 2087 2091 2091 2087 2092 2091 2092 2093 2093 2092 2094 2093 2094 2095 2087 2178 2092 2092 2178 2193 2092 2193 2094 2086 2084 2087 2178 2087 2084 2178 2084 2179 2178 2179 2193 2179 2084 2166 2179 2166 2180 2193 2179 2180 2166 2084 2167 2180 2166 2167 2180 2167 2181 2193 2180 2181 2167 2084 2082 2167 2082 2164 2164 2176 2167 2167 2176 2177 2181 2167 2177 2181 2177 2182 2181 2182 2192 2181 2192 2193 2176 2168 2177 2182 2177 2168 2175 1923 2176 2176 1923 2168 2164 2175 2176 1923 1922 2168 2182 2168 2183 2183 2168 1922 2192 2182 2183 2183 1922 1918 2183 1918 1917 2183 1917 2192 1918 1922 1915 1915 1922 1923 1915 1923 1920 2175 1920 1923 1916 1915 1920 2174 1916 1920 2174 1920 2175 2173 1916 2174 2163 2173 2174 2163 2174 2165 2165 2174 2175 2172 1928 2173 2173 1928 1916 2162 2172 2173 2162 2173 2163 2171 1927 2172 2172 1927 1928 2160 2171 2172 2160 2172 2162 1927 1916 1928 1926 1916 1927 2171 1926 1927 2170 1926 2171 2161 2170 2171 2161 2171 2160 1926 1929 1916 2170 1929 1926 1914 1915 1916 1916 1929 1930 1916 1930 1914 2169 1930 1929 2169 1929 2170 2159 2169 2170 2159 2170 2161 2157 1930 2169 2158 2157 2169 2158 2169 2159 2157 1914 1930 2153 1915 1914 2153 1914 2157 2152 2151 2157 2157 2151 2153 2152 2157 2158 2151 1321 2153 1321 1323 2153 2153 1323 1325 2153 1325 1915 2151 2152 1321 2152 2154 1321 2158 2154 2152 1321 2154 2155 2158 2155 2154 1321 2155 1319 1319 2155 2156 2156 2155 2158 1319 1320 1321 2049 2050 1319 1319 2156 2049 2049 2156 2053 2053 2156 2158 2051 2050 2049 2051 2049 2052 2052 2049 2053 2051 1911 2050 1881 1911 2051 2052 1881 2051 2052 2053 2054 1884 1882 2052 2052 1882 1881 2052 2054 1884 1880 1881 1882 1880 1911 1881 1910 1911 1880 1880 1882 1883 1883 1975 1880 1910 1880 1973 1973 1880 1975 1883 1882 1884 1883 1884 1885 1981 1978 1883 1885 1981 1883 1978 1976 1883 1883 1976 1975 1973 1975 1974 1974 1975 1976 1973 1974 4 4 1910 1973 4 1974 1353 1974 1976 1977 2231 1353 1974 1974 1977 2231 1977 1976 1978 1977 1978 1979 1977 1979 2245 2231 1977 2245 2229 1349 2231 1349 1351 2231 2231 1351 1353 2231 2245 2229 1351 1352 1353 1349 1350 1351 1351 1350 1352 1740 1741 1352 1352 1741 1742 1352 1742 1739 1352 1350 1740 1349 1348 1350 1740 1350 1348 1347 1348 1349 2228 1347 1349 2229 2230 1349 2230 2232 1349 1349 2232 2233 1349 2233 2228 2247 2232 2230 2230 2245 2247 2229 2245 2230 2247 2233 2232 2228 2233 2247 2228 2247 1963 1963 2247 2248 2247 2245 2246 2247 2246 2248 2245 1979 1980 2245 1980 2246 2246 1980 1982 2246 1982 2244 2248 2246 2244 1963 2248 1964 1964 2248 2249 2248 2244 2249 2244 1984 2243 2244 1982 1986 2244 1986 1984 2249 2244 2243 1964 2249 1968 1968 2249 2250 2249 2243 2250 1962 1963 1964 1964 1968 1962 1962 1968 1969 1968 2250 1969 1969 2250 2251 2250 2243 2241 2250 2241 2251 1962 1969 1970 1970 1969 1971 1969 2251 1971 1971 2251 2252 2251 2241 2242 2251 2242 2252 1970 1971 1972 1971 2252 1972 1972 2253 1970 1970 2253 2254 1970 2254 1962 1972 2252 2253 2252 2242 2240 2252 2240 2253 2241 1995 2242 2242 1995 1999 2242 1999 2240 1993 1994 1995 1995 1994 1996 1996 1999 1995 2241 1993 1995 1996 1998 1999 2240 1999 1998 1997 1998 1996 1909 1997 1996 1909 1996 1889 1889 1996 1994 2006 2005 1998 2006 1998 2007 2007 1998 1997 2240 1998 2005 1908 2007 1997 1908 1997 1909 1888 1908 1909 1888 1909 1889 1907 1906 1908 1907 1908 1888 2004 2006 1908 1906 2004 1908 2006 2007 1908 2004 2005 2006 2004 2003 2005 2003 2240 2005 2003 2239 2240 2253 2240 2239 2002 2001 2003 2002 2003 2004 2001 2239 2003 1904 2002 2004 1904 2004 1906 1905 1904 1906 1905 1906 1907 1903 1902 1904 1903 1904 1905 1902 2000 1904 2000 2002 1904 2000 2001 2002 2000 1841 2001 1841 2239 2001 1843 1841 2000 1902 1843 2000 1901 1879 1902 1901 1902 1903 1879 1843 1902 1878 1879 1901 2083 1878 1901 2083 1901 2081 2081 1901 1903 2081 2082 2083 2083 2082 2084 2083 2084 2085 2085 1878 2083 2079 2080 2081 2081 2080 2082 2081 1903 2079 2164 2082 2080 2079 2078 2080 2164 2080 2078 2077 2078 2079 2079 1903 1905 2079 1905 2077 2077 2075 2078 2164 2078 2165 2165 2078 2075 2165 2175 2164 2165 2075 2163 2074 2073 2075 2074 2075 2076 2076 2075 2077 2163 2075 2073 2163 2072 2162 2163 2073 2072 2071 2072 2073 2071 2073 2074 1888 2071 2074 1888 2074 1907 2076 1907 2074 2077 1907 2076 2077 1905 1907 1888 1889 1890 1890 2071 1888 1890 1889 1891 1889 1994 1891 1890 1891 1892 1892 2069 1890 1890 2069 2071 1892 1891 1893 1891 1994 1992 1891 1992 1893 1993 1992 1994 1991 1990 1992 1991 1992 1993 1893 1992 1990 2241 1991 1993 1983 1990 1991 2243 1991 2241 2243 1983 1991 1983 1989 1990 1893 1990 1989 1983 1984 1985 1985 1989 1983 2243 1984 1983 1989 1895 1893 1895 1989 1897 1897 1989 1985 1985 1984 1986 1985 1986 1987 1897 1985 1899 1985 1987 1899 1896 1895 1897 1896 1897 1898 1898 1897 1899 1894 1893 1895 1894 1895 1896 1898 2064 1896 1896 2064 2066 1896 2066 1894 1898 1899 1887 1887 2062 1898 1898 2062 2064 2062 2063 2064 2064 2063 2065 2064 2065 2066 2066 2065 2067 2066 2067 2068 1894 2066 2068 2160 2067 2065 2160 2065 2063 2062 2061 2063 2160 2063 2161 2161 2063 2061 2060 2061 2062 1887 2060 2062 2060 2059 2061 2161 2061 2159 2159 2061 2059 2058 2059 2060 2058 2060 1887 2058 2057 2059 2159 2059 2057 2055 2158 2159 2055 2159 2057 2056 2055 2057 2056 2057 2058 2056 2058 1887 2054 2055 2056 1884 2054 2056 1884 2056 1886 1886 2056 1887 2054 2053 2055 2053 2158 2055 1885 1886 1887 1887 1899 1900 1887 1900 1885 1885 1884 1886 1900 1981 1885 1899 1988 1900 1900 1988 1981 1899 1987 1988 1987 1982 1988 1988 1982 1981 1980 1978 1981 1980 1981 1982 1987 1986 1982 1979 1978 1980 2162 2067 2160 2162 2072 2070 2162 2070 2067 2068 2067 2069 2069 2067 2070 2069 2070 2071 2070 2072 2071 1892 2068 2069 1894 2068 1892 1892 1893 1894 1847 1846 1878 1878 1846 1879 2085 2086 1878 1878 2086 1847 1846 1847 1848 2014 1846 1848 2014 1848 2016 2009 2008 2014 2009 2014 2015 2015 2014 2016 2008 1846 2014 2015 2016 2017 2017 2016 2018 2015 2017 2324 2009 2015 2306 2306 2015 2324 2017 2018 2019 2324 2017 2019 2324 2019 2325 2325 2019 2021 2326 2324 2325 2326 2325 2327 1966 2326 2327 1966 2327 1967 1965 1945 1966 1965 1966 1967 1966 1945 2305 2305 2326 1966 1944 1937 1945 1944 1945 1946 1937 2305 1945 2303 2304 2305 2303 2305 1937 2305 2304 2326 1936 1345 1937 1345 1940 1937 1936 1937 1944 1940 2303 1937 2302 2300 2303 1940 2302 2303 2300 2304 2303 2300 2309 2304 2326 2304 2309 2295 2299 2300 2302 2295 2300 2299 2308 2300 2300 2308 2309 2326 2309 2308 2308 2324 2326 2299 2307 2308 2307 2324 2308 2295 2298 2299 2298 2307 2299 2298 2306 2307 2306 2324 2307 2296 2297 2298 2296 2298 2295 2297 2306 2298 2297 2009 2306 2010 2297 2296 2010 2009 2297 2008 2009 2010 2010 2011 2008 2010 2222 2011 2296 2222 2010 2008 2011 2012 2008 2012 2013 2013 1846 2008 2011 2227 2012 2011 2222 2224 2011 2224 2227 2222 2223 2224 2296 2223 2222 2224 2223 2225 2225 2223 2296 2295 2294 2296 2296 2294 2293 2296 2293 2225 2224 2225 2226 2225 2293 2290 2225 2290 2226 2291 2290 2293 2291 2293 2294 2292 2291 2294 2292 2294 2301 2301 2294 2295 2301 2295 2302 1938 2292 2301 1938 2301 1939 1939 2301 2302 1954 2273 2292 2273 2291 2292 1954 2292 1938 2273 2274 2291 2274 2290 2291 2273 1954 1953 2274 2273 2275 2273 1953 2275 1345 1953 1954 1345 1954 1938 1938 1939 1345 1345 1939 1940 1939 2302 1940 1343 1344 1345 1345 1344 1346 1345 1346 1347 1952 1953 1345 1347 1958 1345 1345 1958 1959 1345 1959 1952 1343 1345 1936 2275 1953 1952 2275 1952 2282 2282 1952 1959 2282 1959 2283 2283 1959 1958 1347 1957 1958 2283 1958 2284 2284 1958 1957 2286 2282 2283 2286 2283 2287 2287 2283 2284 2277 2275 2282 2277 2282 2286 2278 2277 2286 2278 2286 2280 2280 2286 2287 2287 2284 2288 2280 2287 2279 2279 2287 2288 2279 2130 2280 2280 2130 2143 2280 2143 2278 2130 2131 2132 2132 2141 2130 2130 2141 2142 2130 2142 2143 2279 2131 2130 2143 2142 2144 2143 2144 2140 2278 2143 2140 2216 2142 2141 2216 2144 2142 2216 2141 2217 2217 2141 2132 2013 2216 2217 2012 2227 2216 2012 2216 2013 2227 2145 2216 2216 2145 2144 2140 2144 2145 2140 2145 2138 2224 2138 2145 2227 2224 2145 2138 2139 2140 2224 2139 2138 2278 2140 2139 2226 2139 2224 2139 2276 2278 2226 2276 2139 2276 2277 2278 2276 2274 2277 2274 2276 2290 2226 2290 2276 2274 2275 2277 2146 1846 2013 2013 2217 2146 2146 2148 1846 2146 2217 2218 2146 2218 2148 1846 2148 2149 1846 2149 1879 2148 2218 2219 2148 2219 2149 2217 2132 2218 2218 2132 2137 2218 2137 2219 2219 2137 2136 2219 2136 2220 2149 2219 2220 1879 2149 2150 2149 2220 2150 2147 1843 1879 1879 2150 2147 2150 2220 2221 2150 2221 2147 2136 2134 2220 2220 2134 2133 2220 2133 2221 2221 2133 2128 2221 2128 2215 2147 2221 2215 1845 1843 2147 2147 2215 1845 2214 1845 2215 2126 2214 2215 2126 2215 2128 2127 2126 2128 2127 2128 2129 2128 2133 2129 2129 2133 2134 2129 2134 2135 2272 2127 2129 2135 2279 2129 2129 2279 2281 2129 2281 2272 2125 2126 2127 2272 2125 2127 2125 2124 2126 2124 2214 2126 2123 2124 2125 2272 2123 2125 2123 2214 2124 2213 2211 2123 2123 2211 2214 2213 2123 2260 2260 2123 2272 2212 2211 2213 2213 2260 2212 2208 2211 2212 2208 1842 2211 2211 1842 1844 2211 1844 2214 2214 1844 1845 1842 1843 1844 1844 1843 1845 1842 1841 1843 1840 1841 1842 2237 2238 1841 1841 2238 2239 2259 2237 1841 2259 1841 1840 1842 2210 1840 2210 2259 1840 2258 2237 2259 2259 2262 2258 2210 2262 2259 2258 2238 2237 2257 2238 2258 2258 2262 2263 2263 2257 2258 2266 2263 2262 2209 2266 2262 2209 2262 2210 1842 2209 2210 2208 2209 1842 2209 2208 2267 2267 2266 2209 2265 2263 2266 2267 2265 2266 2269 2265 2267 2260 2269 2267 2260 2267 2212 2212 2267 2208 2264 2261 2265 2265 2261 2263 2269 2264 2265 2268 2264 2269 2271 2268 2269 2271 2269 2260 2272 2271 2260 2270 2268 2271 2289 2270 2271 2272 2289 2271 1948 1947 2268 2268 1947 2264 2270 1948 2268 1949 1948 2270 2285 1949 2270 2289 2285 2270 2288 2285 2289 2281 2288 2289 2281 2289 2272 2284 1957 2285 2285 1957 1949 2288 2284 2285 1347 1948 1949 1949 1957 1347 1347 1947 1948 1942 1947 1347 1947 1942 2264 1941 1942 1347 2261 1942 1941 2264 1942 2261 1941 1347 1943 1941 1943 2255 1941 2255 2261 2261 2255 2256 2261 2256 2263 2255 1943 2236 2255 2236 2256 1943 1347 1960 1960 2236 1943 2234 2235 2236 1960 2234 2236 2256 2236 2235 2256 2235 2257 2263 2256 2257 2234 2238 2235 2257 2235 2238 1962 2254 2234 1962 2234 1960 2254 2238 2234 1960 1347 1961 1960 1961 1962 1962 1961 1963 1961 1347 2228 1963 1961 2228 1347 1346 1348 1457 1458 1346 1346 1458 1459 1346 1460 1457 1459 1471 1346 1346 1471 1472 1346 1472 1473 1473 1484 1346 1346 1484 1485 1346 1485 1348 1460 1346 1818 1818 1346 1344 1457 1460 1461 1461 1460 1818 1818 1819 1820 1818 1820 1461 1818 1344 1819 1343 1342 1344 1342 1823 1344 1344 1823 1822 1344 1822 1819 1819 1822 1820 1820 1822 1824 1820 1824 1832 1461 1820 1832 1821 1822 1823 1822 1821 1824 1342 1821 1823 1341 1340 1342 1341 1342 1343 1340 1821 1342 1821 1567 1566 1821 1566 1824 1340 1567 1821 1832 1824 1827 1832 1827 1833 1833 1827 1828 1833 1828 1834 1463 1832 1833 1463 1833 1468 1468 1833 1834 1468 1834 1469 1469 1834 1835 1463 1468 1462 1462 1468 1469 1462 1461 1463 1461 1832 1463 1457 1461 1462 1462 1469 1470 1470 1480 1462 1469 1835 1470 1835 1830 1836 1470 1835 1836 1470 1836 1480 1480 1836 1837 1836 1830 1831 1836 1831 1837 1830 1547 1831 1547 1545 1831 1457 1805 1458 1804 1803 1805 1804 1805 1806 1458 1805 1803 1458 1803 1459 1801 1800 1803 1801 1803 1804 1459 1803 1800 1802 1801 1804 1802 1804 1811 1811 1804 1806 1782 1783 1801 1783 1800 1801 1782 1801 1802 1783 1785 1800 1459 1800 1471 1471 1800 1785 1783 1782 1784 1785 1783 1786 1783 1784 1786 1782 1659 1658 1782 1658 1784 1659 1782 1802 1784 1658 1663 1784 1663 1788 1786 1784 1788 1786 1788 1792 1785 1786 1787 1787 1786 1792 1663 1653 1788 1788 1653 1655 1788 1655 1789 1792 1788 1789 1792 1789 1793 1787 1792 1796 1796 1792 1793 1472 1785 1787 1472 1787 1473 1473 1787 1796 1796 1793 1797 1473 1796 1484 1484 1796 1797 1797 1793 1794 1797 1794 1798 1484 1797 1485 1485 1797 1798 1793 1790 1794 1794 1790 1791 1794 1791 1795 1798 1794 1795 1798 1795 1799 1485 1798 1486 1486 1798 1799 1348 1485 1486 1348 1486 1464 1486 1799 1464 1799 1795 1780 1799 1780 1781 1464 1799 1781 1795 1791 1779 1795 1779 1780 1779 1770 1780 1780 1770 1777 1780 1777 1781 1781 1777 1778 1781 1778 1455 1464 1781 1455 1455 1348 1464 1455 1456 1348 1455 1778 1456 1777 1775 1778 1778 1775 1776 1778 1776 1456 1770 1774 1777 1777 1774 1775 1774 1771 1775 1775 1771 1773 1775 1773 1776 1776 1773 1772 1776 1772 1465 1456 1776 1465 1456 1465 1348 1348 1465 1466 1465 1772 1466 1769 1466 1772 1769 1772 1768 1768 1772 1773 1348 1466 1467 1467 1466 1769 1768 1743 1769 1769 1743 1474 1769 1474 1467 1767 1744 1768 1768 1744 1743 1773 1767 1768 1743 1744 1745 1743 1745 1474 1467 1474 1348 1348 1474 1475 1474 1745 1475 1744 1747 1745 1745 1747 1749 1745 1749 1757 1475 1745 1757 1767 1747 1744 1766 1747 1767 1773 1766 1767 1746 1747 1748 1747 1746 1749 1766 1748 1747 1765 1748 1766 1771 1765 1766 1771 1766 1773 1765 1746 1748 1746 1314 1525 1746 1525 1749 1315 1314 1746 1315 1746 1765 1315 1765 1771 1771 1732 1315 1774 1732 1771 1314 1315 1313 1313 1315 1316 1315 1732 1316 1525 1314 1313 1311 1312 1313 1313 1316 1311 1313 1526 1525 1312 1395 1313 1526 1313 1395 1316 1672 1311 1311 1672 1671 1311 1671 1312 1670 1671 1672 1316 1735 1672 1672 1735 1779 1672 1779 1670 1670 1669 1671 1312 1671 1669 1668 1669 1670 1670 1779 1791 1670 1791 1668 1779 1735 1770 1734 1735 1316 1735 1734 1770 1734 1733 1770 1770 1733 1774 1316 1733 1734 1316 1732 1733 1733 1732 1774 1650 1667 1668 1668 1667 1669 1668 1791 1790 1668 1790 1650 1650 1651 1652 1652 1666 1650 1650 1666 1667 1650 1790 1651 1312 1669 1667 1666 1312 1667 1652 1673 1666 1666 1673 1312 1651 1657 1652 1657 1674 1652 1652 1674 1673 1673 1395 1312 1673 1674 1395 1395 1674 1675 1657 1675 1674 1651 1656 1657 1656 1675 1657 1654 1676 1675 1654 1675 1656 1655 1654 1656 1655 1656 1651 1653 1654 1655 1653 1665 1654 1665 1676 1654 1532 1676 1677 1665 1677 1676 1653 1664 1665 1664 1677 1665 1663 1664 1653 1663 1662 1664 1664 1534 1677 1534 1664 1533 1533 1664 1662 1532 1677 1534 1531 1532 1533 1533 1532 1534 1662 1661 1533 1533 1661 1660 1533 1660 1531 1658 1661 1662 1658 1662 1663 1660 1661 1658 1658 1659 1660 1531 1660 1659 1736 1737 1531 1531 1659 1736 1659 1802 1736 1736 1802 1811 1736 1811 1737 1789 1655 1651 1789 1651 1790 1793 1789 1790 1396 1432 1395 1395 1432 1526 1430 1431 1396 1396 1431 1432 1526 1432 1431 1525 1526 1527 1526 1431 1527 1430 1428 1431 1527 1431 1528 1528 1431 1428 1429 1428 1430 1430 1609 1607 1430 1607 1429 1418 1428 1429 1429 1607 1605 1429 1605 1418 1606 1605 1607 1606 1607 1608 1608 1607 1609 1604 1603 1605 1604 1605 1606 1418 1605 1603 1686 1604 1606 1686 1606 1684 1684 1606 1608 1602 1603 1604 1694 1602 1604 1694 1604 1686 1602 1601 1603 1418 1603 1419 1419 1603 1601 1600 1601 1602 1600 1602 1694 1693 1600 1694 1698 1693 1694 1698 1694 1697 1697 1694 1686 1598 1599 1600 1600 1599 1601 1693 1598 1600 1419 1601 1421 1421 1601 1599 1418 1419 1420 1419 1421 1420 1420 1421 1422 1421 1599 1422 1598 1597 1599 1422 1599 1597 1596 1597 1598 1596 1598 1693 1596 1595 1597 1422 1597 1423 1423 1597 1595 1420 1422 1416 1416 1422 1423 1416 1423 1417 1423 1594 1417 1423 1595 1594 1593 1594 1595 1593 1595 1596 1692 1593 1596 1692 1596 1693 1591 1592 1593 1592 1594 1593 1591 1593 1692 1417 1594 1592 1415 1416 1417 1417 1592 1415 1591 1590 1592 1415 1592 1590 1583 1590 1591 1691 1583 1591 1691 1591 1692 1583 1589 1590 1415 1590 1404 1404 1590 1589 1404 1414 1415 1415 1414 1416 1404 1413 1414 1414 1508 1510 1510 1416 1414 1508 1414 1506 1506 1414 1413 1510 1420 1416 1508 1509 1510 1510 1509 1511 1510 1511 1512 1512 1420 1510 1506 1507 1508 1508 1507 1509 1505 1504 1506 1506 1504 1507 1506 1413 1505 1755 1509 1507 1755 1507 1756 1507 1504 1756 1511 1509 1755 1754 1511 1755 1760 1754 1755 1760 1755 1761 1761 1755 1756 1756 1504 1502 1756 1502 1750 1761 1756 1762 1762 1756 1750 1488 1760 1761 1488 1761 1490 1490 1761 1762 1762 1750 1763 1490 1762 1491 1491 1762 1763 1489 1488 1490 1489 1490 1477 1477 1490 1491 1487 1488 1489 1487 1760 1488 1477 1758 1489 1489 1758 1759 1489 1759 1487 1487 1759 1760 1758 1753 1759 1759 1753 1754 1759 1754 1760 1757 1752 1758 1758 1752 1753 1477 1757 1758 1752 1519 1753 1519 1517 1753 1753 1517 1516 1753 1516 1754 1516 1514 1754 1754 1514 1511 1514 1516 1515 1515 1516 1517 1515 1517 1518 1518 1517 1519 1513 1514 1515 1518 1425 1515 1515 1425 1424 1515 1424 1513 1513 1511 1514 1512 1511 1513 1513 1424 1512 1420 1424 1418 1418 1424 1425 1512 1424 1420 1418 1425 1426 1524 1426 1425 1524 1425 1518 1519 1524 1518 1519 1523 1524 1523 1426 1524 1426 1427 1418 1523 1427 1426 1418 1427 1428 1521 1428 1427 1521 1427 1523 1522 1521 1523 1522 1523 1519 1752 1522 1519 1520 1521 1522 1520 1522 1752 1520 1528 1521 1528 1428 1521 1525 1527 1520 1520 1527 1528 1749 1525 1520 1749 1520 1752 1757 1749 1752 1475 1757 1477 1348 1475 1476 1476 1475 1477 1476 1477 1478 1478 1477 1479 1477 1491 1479 1740 1348 1476 1478 1740 1476 1479 1764 1478 1478 1764 1740 1491 1763 1479 1479 1763 1764 1763 1751 1764 1751 1742 1764 1764 1742 1741 1764 1741 1740 1763 1750 1751 1750 1499 1751 1751 1499 1495 1495 1739 1751 1751 1739 1742 1750 1502 1501 1750 1501 1499 1498 1495 1499 1498 1499 1500 1499 1501 1500 1500 1501 1502 1500 1502 1503 1503 1502 1504 1503 1411 1500 1500 1411 1410 1500 1410 1498 1498 1410 1406 1406 1410 1404 1404 1410 1411 1404 1411 1412 1411 1503 1505 1505 1412 1411 1503 1504 1505 1505 1413 1412 1412 1413 1404 1404 1405 1406 1404 1589 1405 1406 1405 1407 1409 1406 1407 1405 1589 1585 1405 1585 1407 1585 1589 1583 1583 1584 1585 1585 1584 1586 1585 1586 1587 1407 1585 1587 1407 1588 1409 1407 1587 1588 1409 1588 1581 1587 1582 1588 1588 1582 1581 1587 1586 1582 1582 1586 1690 1690 1586 1584 1690 1584 1691 1584 1583 1691 1689 1582 1690 1702 1689 1690 1702 1690 1701 1701 1690 1691 1580 1581 1582 1689 1580 1582 1703 1688 1689 1703 1689 1702 1701 1445 1702 1702 1445 1444 1702 1444 1703 1700 1446 1701 1701 1446 1445 1701 1691 1700 1438 1444 1445 1438 1445 1446 1440 1444 1438 1444 1440 1682 1703 1444 1682 1438 1439 1440 1440 1439 1441 1440 1441 1326 1440 1326 1682 1682 1326 1324 1682 1324 1683 1703 1682 1683 1683 1324 1681 1681 1688 1683 1683 1688 1703 1680 1681 1324 1688 1681 1680 1324 1322 1680 1680 1322 1320 1321 1320 1322 1321 1322 1323 1323 1322 1324 1323 1324 1325 1325 1324 1326 1325 1326 1327 1325 1327 1915 1327 1326 1328 1327 1328 1329 1915 1327 1924 1329 1924 1327 1915 1924 1918 1918 1924 1925 1925 1924 2189 2189 1924 2191 1329 2191 1924 1917 1918 1919 1919 1918 1921 1918 1925 1921 2189 2205 1925 1925 2205 1921 2204 1919 1921 2204 1921 2205 1919 1931 1917 2203 1931 1919 2203 1919 2204 2198 2203 2204 2198 2204 2206 2206 2204 2205 2206 2205 2207 2189 2207 2205 2207 2115 2206 2206 2115 2112 2206 2112 2198 2118 2117 2207 2207 2117 2115 2186 2118 2207 2186 2207 2189 2114 2112 2115 2114 2115 2116 2115 2117 2116 2116 2117 2118 2116 2118 2119 2119 2118 2120 2120 2118 2186 2116 1874 2114 2116 2119 1874 2119 2120 2121 1874 2119 2121 2186 2187 2120 2186 2185 2187 1331 2187 2185 2184 2185 2186 1331 2185 1329 2185 2184 1329 1329 1330 1331 1331 1330 1332 1329 1328 1330 1329 2184 2188 1329 2188 2190 2190 2191 1329 2184 2186 2188 2188 2186 2189 2188 2189 2190 2189 2191 2190 1328 1433 1330 1330 1433 1731 1330 1731 1332 1328 1326 1433 1433 1326 1434 1434 1731 1433 1729 1730 1731 1434 1729 1731 1332 1731 1730 1326 1442 1434 1434 1442 1436 1434 1436 1443 1443 1729 1434 1326 1441 1442 1705 1442 1695 1695 1442 1441 1436 1442 1706 1706 1442 1705 1435 1436 1437 1443 1436 1435 1437 1436 1706 1435 1728 1443 1443 1728 1729 1437 1454 1435 1454 1727 1435 1435 1727 1728 1727 1711 1728 1728 1711 1713 1728 1713 1729 1729 1713 1730 1332 1730 1713 1714 1332 1713 1695 1704 1705 1695 1439 1696 1696 1685 1695 1695 1685 1704 1695 1441 1439 1696 1439 1438 1696 1438 1697 1697 1686 1696 1696 1686 1685 1684 1685 1686 1685 1684 1687 1697 1438 1449 1697 1449 1698 1438 1448 1449 1698 1449 1448 1446 1447 1438 1438 1447 1448 1698 1448 1699 1699 1448 1447 1699 1693 1698 1699 1447 1700 1700 1692 1699 1699 1692 1693 1700 1447 1446 1700 1691 1692 1873 1857 1874 2114 1874 1857 1858 1857 1873 1873 2041 1858 1857 1858 1859 1859 1872 1857 2114 1857 1872 2113 2112 2114 2114 1872 2113 1859 1871 1872 2113 1872 1871 2111 2112 2113 2113 1871 2111 2111 2110 2112 2198 2112 2110 2108 2110 2111 2111 1871 2108 1870 1869 1871 1870 1871 1859 1869 2108 1871 2107 2106 2108 2106 2109 2108 2108 2109 2110 1869 2107 2108 2198 2110 2109 2198 2109 2197 2197 2203 2198 2197 2109 2106 2105 2104 2106 2105 2106 2107 2197 2106 2104 2197 2104 2195 2195 2202 2197 2197 2202 2203 2202 1931 2203 2201 1932 2202 2202 1932 1931 2195 2201 2202 1917 1931 1932 1917 1932 1933 1933 1932 1934 2201 1934 1932 2200 1934 2201 2196 2200 2201 2196 2201 2195 1933 1934 1935 2200 1935 1934 2192 1917 1933 2192 1933 2199 2199 1933 1935 2199 1935 2200 2194 2199 2200 2194 2200 2196 2195 2100 2196 2196 2100 2099 2196 2099 2194 2195 2104 2102 2195 2102 2100 2088 2099 2100 2088 2100 2101 2101 2100 2102 2090 2099 2088 2194 2099 2090 2088 2089 2090 1860 2089 2088 1860 2088 1861 1861 2088 2101 2101 2102 2103 1861 2101 1863 1863 2101 2103 2103 2102 2104 2103 2104 2105 1863 2103 1865 1865 2103 2105 1862 1861 1863 1862 1863 1864 1864 1863 1865 1864 1865 1866 1866 1865 1867 2107 1867 1865 1865 2105 2107 1866 2030 1864 1864 2030 2028 1864 2028 1862 1866 1867 1868 1868 2031 1866 1866 2031 2030 1868 1867 1869 1867 2107 1869 1868 1869 1870 1870 2033 1868 1868 2033 2031 2029 2030 2031 2029 2031 2032 2032 2031 2033 2028 2030 2029 2320 2029 2032 2032 2033 2034 2320 2032 2034 2034 2033 2035 1870 2035 2033 1859 2035 1870 2034 2035 2036 2036 2035 2037 1859 2037 2035 2320 2034 2321 2321 2034 2036 2036 2037 2038 2321 2036 2319 2319 2036 2038 2038 2037 2039 2039 2037 1859 2041 2039 1859 1858 2041 1859 2038 2039 2040 2040 2039 2041 2319 2038 2040 2331 2321 2319 1855 2089 1860 2097 1855 2095 2097 2098 1855 1855 2098 2089 2098 2090 2089 2097 2090 2098 2095 2096 2097 2097 2096 2090 2095 2094 2096 2094 2194 2096 2194 2090 2096 2094 2193 2194 2193 2199 2194 2193 2192 2199 1471 1785 1472 1566 1567 1568 1340 1338 1567 1567 1338 1568 1339 1338 1340 1339 1340 1341 2314 1339 1341 1343 2312 1341 1341 2312 2313 1341 2313 2317 2314 1341 2315 2315 1341 2317 2314 2315 2316 2316 2315 2317 2311 2316 2317 2311 2317 2313 2312 2311 2313 2310 2311 2312 1343 2310 2312 1936 2310 1343 1944 2311 2310 1944 2310 1936 1946 2311 1944 2254 2239 2238 2253 2239 2254 2279 2288 2281 2135 2131 2279 2135 2134 2136 2135 2136 2131 2131 2136 2137 2131 2137 2132 2085 2084 2086 4 3 5 4 5 6 3 1 217 424 5 3 424 3 425 425 3 217 217 218 219 217 1 218 219 425 217 219 424 425 246 5 424 246 424 219 219 218 220 219 220 216 219 277 246 277 219 274 274 219 216 489 218 1 489 220 218 1 490 489 490 220 489 1 312 490 318 220 490 318 490 312 47 312 1 312 47 313 313 318 312 313 317 318 317 220 318 313 47 45 313 45 314 313 314 315 316 317 313 313 315 316 316 221 317 317 221 220 316 315 319 316 319 320 320 215 316 316 215 221 216 220 221 216 221 215 212 214 215 215 214 216 320 212 215 320 319 321 320 321 322 322 212 320 210 211 212 211 213 212 212 213 214 322 210 212 270 216 214 270 214 269 269 214 213 269 213 211 210 208 211 208 265 211 211 265 267 211 267 269 267 268 269 269 268 270 270 268 271 270 271 272 272 216 270 267 266 268 715 271 268 715 268 266 265 266 267 265 264 266 266 714 715 266 264 714 723 271 715 729 723 715 729 715 730 730 715 714 714 264 262 714 262 724 730 714 731 731 714 724 263 262 264 263 264 265 261 260 262 261 262 263 260 724 262 207 261 263 207 263 208 208 263 265 259 260 261 203 261 207 203 259 261 259 258 260 258 724 260 257 258 259 203 257 259 257 256 258 256 726 258 258 726 724 255 256 257 205 257 203 205 255 257 255 254 256 254 725 256 256 725 726 732 724 726 732 726 733 733 726 725 731 724 732 140 731 732 140 732 138 138 732 733 733 725 734 138 733 139 139 733 734 254 252 725 725 252 250 251 250 252 251 252 253 253 252 254 249 248 250 249 250 251 195 249 251 195 251 196 196 251 253 253 254 255 196 253 205 205 253 255 195 196 197 205 204 196 196 204 206 196 206 197 195 197 198 198 249 195 200 198 197 339 200 197 339 197 338 338 197 206 338 206 204 336 337 338 338 337 339 204 336 338 339 337 340 339 340 341 341 200 339 336 335 337 435 340 337 435 337 335 334 335 336 336 204 334 334 333 335 335 434 435 335 333 434 332 333 334 334 204 202 334 202 332 203 202 204 203 204 205 201 202 203 332 202 330 330 202 201 330 331 332 332 331 333 434 333 331 330 329 331 434 331 444 329 444 331 328 329 330 330 201 328 328 327 329 327 444 329 327 446 444 451 434 444 451 444 452 452 444 446 326 325 327 326 327 328 325 446 327 328 201 209 328 209 326 324 325 326 326 209 210 326 210 324 324 323 325 323 445 325 325 445 446 322 323 324 324 210 322 209 208 210 201 208 209 203 207 201 201 207 208 322 321 323 323 321 445 445 321 319 445 319 447 447 319 315 454 445 447 454 447 455 315 430 447 447 430 433 447 433 455 315 314 430 43 430 45 45 430 314 43 433 430 43 432 433 455 433 432 431 432 43 455 432 431 229 455 431 229 431 223 223 228 229 228 238 229 238 455 229 228 237 238 237 454 238 238 454 455 236 235 237 236 237 228 235 453 237 237 453 454 453 445 454 452 446 453 453 446 445 235 452 453 234 235 236 234 452 235 234 451 452 236 451 234 228 450 236 236 450 451 450 434 451 449 435 450 450 435 434 228 449 450 223 227 228 227 449 228 448 443 449 449 443 435 227 448 449 443 340 435 442 344 443 344 342 443 443 342 340 448 442 443 438 442 448 225 438 448 225 448 227 225 227 223 224 225 223 224 438 225 436 437 438 436 438 224 437 441 438 438 441 442 224 223 226 459 436 224 459 224 226 437 436 459 458 441 437 458 437 459 481 458 459 233 481 459 233 459 226 223 231 226 226 231 232 226 232 233 232 243 233 243 481 233 242 240 232 232 240 243 231 475 232 232 475 476 232 476 242 240 480 243 243 480 481 239 240 241 241 240 242 239 479 240 240 479 480 242 476 477 242 477 241 475 461 476 241 477 478 241 478 239 239 478 479 479 471 480 480 471 473 480 473 481 352 456 473 473 456 457 473 457 481 481 457 458 456 440 457 457 440 441 457 441 458 440 439 441 456 439 440 456 349 347 347 439 456 352 349 456 351 349 352 349 350 347 350 349 351 346 345 347 346 347 348 347 350 348 439 347 345 441 439 345 441 345 442 343 344 345 343 345 346 442 345 344 348 79 346 346 79 199 346 199 343 348 350 79 79 87 199 79 350 491 199 87 198 199 198 200 343 199 200 198 87 159 159 247 198 198 247 249 160 159 161 161 159 428 428 159 87 579 160 161 584 579 161 428 584 161 428 87 429 429 587 428 428 587 584 583 579 584 587 583 584 583 581 579 582 581 583 587 582 583 523 587 521 521 587 586 523 582 587 429 586 587 429 87 427 427 586 429 427 585 586 521 586 518 518 586 585 521 522 523 520 522 521 520 521 518 518 519 520 518 585 519 427 426 585 87 426 427 523 522 524 522 48 684 684 694 522 522 694 524 523 524 525 523 525 582 582 525 581 692 693 694 684 692 694 146 148 692 692 148 693 247 248 249 343 200 341 341 342 343 342 344 343 341 340 342 351 491 350 139 734 142 138 139 140 140 139 141 141 139 129 129 139 142 129 142 130 128 127 129 128 129 130 127 729 129 129 729 730 129 730 141 141 730 731 141 731 140 728 723 729 127 728 729 120 126 127 120 127 128 126 728 127 718 722 728 728 722 723 126 718 728 722 275 723 275 273 723 723 273 271 721 276 722 722 276 275 718 721 722 274 273 275 274 275 276 272 271 273 272 273 274 276 244 274 274 244 245 274 245 277 274 216 272 719 244 276 721 719 276 244 7 245 7 244 719 245 7 5 245 5 246 277 245 246 6 5 7 6 7 8 8 7 9 7 719 9 720 719 721 9 719 720 8 9 10 10 9 11 9 720 11 11 720 721 717 721 718 11 721 717 10 11 12 716 11 717 716 717 718 716 718 126 126 119 716 119 126 120 713 120 128 130 713 128 14 802 12 12 802 803 12 803 804 10 12 804 804 803 811 1299 804 811 804 1299 10 10 1299 1298 10 1298 8 1297 1298 1299 1299 811 1297 811 803 805 811 805 812 1297 811 812 805 806 807 812 805 807 805 803 1289 806 805 1289 812 807 813 1297 812 1306 1306 812 813 1307 813 807 1307 807 1308 1308 807 806 1308 806 1309 1309 806 1289 1289 803 1288 1288 1294 1289 1309 1289 1294 802 1288 803 1282 1287 1288 802 1282 1288 1287 1293 1288 1288 1293 1294 1294 1293 1309 1287 1292 1293 1309 1293 1292 1282 1286 1287 1286 1292 1287 1286 1291 1292 1309 1292 1310 1310 1292 1291 1281 1285 1286 1281 1286 1282 1290 1291 1286 1286 1285 1290 1310 1291 1290 1305 1309 1310 918 1305 1310 918 1310 915 915 1310 1290 1290 1285 839 1290 839 838 915 1290 838 1175 839 1285 1175 1285 1281 838 839 837 837 839 840 1175 840 839 915 838 837 837 916 915 915 916 917 915 917 918 835 836 837 837 840 835 837 767 916 837 836 767 1175 1174 840 840 1179 835 840 1174 1179 835 1179 1181 835 1181 836 767 836 1041 1182 1041 836 1182 836 1181 1179 1180 1181 1181 1180 1182 1184 1041 1182 1120 1184 1182 1120 1182 1121 1121 1182 1180 1041 1042 767 1184 1042 1041 1119 1183 1184 1183 1042 1184 1119 1184 1120 1119 1120 1116 1116 1120 1121 1119 1116 1127 1119 1127 1183 1183 1043 1042 1183 1127 1185 1183 1185 1043 767 1042 1043 767 1043 1040 1043 1185 1040 1127 1128 1185 1185 1128 1186 1185 1186 1040 1127 1116 1118 1127 1118 1128 1128 1118 1129 1128 1129 1130 1130 1186 1128 1040 1186 769 1190 769 1186 1130 1190 1186 1040 769 767 768 767 769 1190 768 769 1133 1189 1190 1133 1190 1131 1189 768 1190 1131 1190 1130 1130 1129 1131 1131 1129 1132 1131 1132 1133 1133 1132 1134 1134 1189 1133 1135 1188 1189 1135 1189 1134 1188 766 1189 1189 766 768 766 767 768 766 789 767 1188 789 766 1136 1108 1188 1188 1108 1187 1136 1188 1135 1187 789 1188 1134 1126 1135 1126 1136 1135 1134 1132 1126 1129 1093 1132 1132 1093 1095 1132 1095 1126 1118 1092 1129 1129 1092 1093 1092 738 1093 1096 1095 1093 1093 738 1096 1094 1095 1096 1126 1095 1094 1094 1096 1012 1012 1096 1102 1096 738 740 1096 740 1102 1012 1011 1094 1126 1094 1011 1006 1011 1012 1013 1006 1012 1012 1102 1013 1011 1006 1109 1011 1109 1126 1109 1108 1126 1126 1108 1136 1107 1108 1109 1109 1006 1110 1109 1110 1107 1107 1187 1108 1107 1110 1196 1196 1197 1107 1107 1197 1187 1006 1113 1110 1196 1110 1113 1006 1112 1113 1196 1113 1112 1195 770 1196 1196 1112 1195 770 791 1196 1196 791 1197 1187 1197 790 790 1197 791 1187 790 789 767 789 790 767 790 758 758 790 791 758 791 770 756 758 770 1195 756 770 756 757 758 1194 757 756 1194 756 1195 757 792 758 1193 792 757 1193 757 1194 1195 1111 1194 1194 1111 1115 1194 1115 1193 1192 792 1193 1193 1115 1114 1193 1114 1192 758 792 793 1192 793 792 1191 793 1192 1192 1114 1005 1192 1005 1191 1005 1114 1006 1006 1114 1115 1006 1115 1111 1111 1112 1006 1195 1112 1111 1004 1005 1006 1009 1004 1006 1009 1006 1013 1004 1191 1005 1008 1004 1009 1008 798 1004 1004 798 1191 1007 1008 1009 1007 799 1008 1008 799 798 794 798 758 758 798 799 798 794 1191 758 799 778 1007 778 799 1007 1009 1010 1010 778 1007 778 779 758 1010 779 778 1009 1019 1010 1019 780 1010 1010 780 779 758 779 780 780 787 758 1019 1018 780 780 1018 1017 780 1017 787 1009 1018 1019 1014 1017 1018 1014 1018 1009 1016 1017 1014 787 1017 1016 758 787 788 787 1016 788 1014 1015 1016 788 1016 1015 758 788 771 788 1015 771 1015 1014 1020 771 1015 1020 758 771 772 771 1020 772 1020 1014 1021 1020 1021 1022 772 1020 1022 772 773 758 772 1022 773 1021 1025 1022 773 1022 1025 758 773 774 773 1025 774 1021 1024 1025 774 1025 1024 758 774 761 774 781 761 774 1024 781 1023 1024 1021 1024 1023 781 761 781 782 781 1023 1026 781 1026 782 1021 1026 1023 1021 1002 1026 782 1026 1002 761 782 783 782 1002 783 1001 1002 1003 1003 1002 1021 783 1002 1001 783 784 761 783 1001 784 1003 1039 1001 784 1001 1039 1031 1038 1003 1003 1038 1039 1021 1105 1003 1003 1105 1031 1014 1104 1021 1021 1104 1105 1104 746 1105 1105 746 748 1105 748 1106 1031 1105 1106 1014 1103 1104 1103 744 1104 1104 744 746 1009 1103 1014 1009 1102 1103 1102 742 1103 1103 742 744 742 743 744 744 743 745 744 745 746 740 741 742 742 741 743 1102 740 742 1013 1102 1009 738 739 740 740 739 741 739 1268 741 741 1268 1269 741 1269 743 743 1269 745 745 1269 1270 1268 1271 1269 1269 1271 1272 1269 1272 1270 1267 826 1271 1271 826 825 1271 825 1272 1268 1267 1271 1272 825 833 1272 833 1264 1270 1272 1264 825 826 827 834 833 825 834 825 814 814 825 827 827 826 828 1267 828 826 827 828 829 829 828 830 1265 830 828 1265 828 1267 829 830 831 831 1276 829 827 829 1277 1277 829 1276 1265 1275 830 830 1275 831 1266 1265 1267 1266 1273 1265 1265 1273 1275 1273 1274 1275 1275 1274 1276 1275 1276 831 1277 1276 1278 1278 1276 1274 1273 1125 1274 1278 1274 1176 1176 1274 1125 1117 1123 1273 1123 1125 1273 1266 1117 1273 1123 1124 1125 1125 1124 1176 1176 1124 1177 1176 1177 1167 1167 1278 1176 1280 1277 1278 1280 1278 1167 1167 1168 1169 1167 1177 1168 1280 1167 1169 1279 1277 1280 1279 1280 1284 1280 1169 1284 1279 827 1277 815 827 1279 815 1279 1283 1283 1279 1284 1284 1169 1171 1284 1171 1173 1283 1284 1281 1281 1284 1173 1281 1282 1283 815 1283 817 817 1283 1282 1281 1173 1175 1171 1172 1173 1173 1172 1174 1173 1174 1175 1169 1170 1171 1171 1170 1172 1179 1174 1172 1179 1172 1177 1177 1172 1170 1169 1168 1170 1177 1170 1168 1124 1122 1177 1177 1122 1178 1177 1178 1179 1179 1178 1180 1178 1122 1121 1121 1180 1178 1117 1121 1122 1117 1122 1123 1123 1122 1124 1116 1121 1117 1116 1117 1118 1118 1117 737 737 1117 1266 1118 737 736 1118 736 1092 736 737 738 738 737 739 739 737 1268 1268 737 1266 1266 1267 1268 1092 736 738 817 1282 802 816 815 817 816 817 818 818 817 802 818 802 819 819 802 14 818 819 1255 816 818 1256 1256 818 1255 819 14 820 1250 1254 819 1250 819 820 1255 819 1254 820 14 821 821 14 1229 1229 14 16 820 821 822 822 1250 820 1236 1249 1250 1236 1250 822 1249 1254 1250 822 821 808 822 808 823 1236 822 823 808 821 1229 808 809 810 823 808 810 1244 809 808 1244 808 1237 1237 808 1229 823 810 824 1236 823 1238 1238 823 824 1242 824 810 1242 810 1243 1243 810 809 1243 809 1244 1241 1243 1244 1241 1244 1245 1245 1244 1237 1237 1230 1232 1237 1229 1230 1229 16 1230 16 1232 1230 1245 935 1241 935 946 940 1241 935 940 940 946 947 858 947 946 858 946 849 940 941 942 940 947 941 1241 940 942 860 941 947 860 947 858 849 857 858 858 857 859 858 859 860 849 856 857 856 996 857 857 996 990 857 990 859 860 859 861 867 861 859 859 990 867 861 943 860 943 941 860 866 865 861 866 861 867 865 950 861 861 950 943 867 990 989 867 989 866 864 865 866 985 864 866 866 989 987 866 987 985 864 863 865 950 865 863 943 950 944 944 950 951 863 951 950 862 863 864 862 953 863 863 953 951 864 868 862 864 985 868 862 868 869 862 869 870 870 954 862 862 954 953 952 951 953 952 953 949 949 953 954 944 951 952 949 1235 952 952 1235 1240 1240 944 952 948 842 949 949 954 948 842 1233 949 949 1233 1235 872 948 954 872 954 870 844 842 948 844 948 872 841 842 843 843 842 844 842 841 1233 1233 1234 1235 1233 841 1247 1233 1247 1234 841 843 1226 841 1226 1247 843 844 845 845 1221 843 1226 843 1221 1226 1221 1227 1247 1226 1253 1227 1253 1226 1234 1247 1248 1247 1253 1248 1248 1253 1249 1249 1253 1254 1252 1254 1253 1252 1253 1227 1227 1221 1220 1227 1220 1228 1227 1228 1252 1255 1254 1252 1251 1255 1252 1251 1252 1225 1225 1252 1228 1228 1220 1225 1219 1220 1221 1220 1219 1222 1225 1220 1222 1223 1224 1225 1225 1222 1223 1225 1224 1251 1222 1219 1217 1222 1217 1223 1223 1217 1218 1223 1218 1224 1218 1251 1224 1217 1153 1218 1258 1251 1218 1153 1258 1218 1152 1153 1217 1213 1152 1217 1213 1217 1215 1215 1217 1219 1152 1151 1153 1260 1258 1153 1153 1151 1260 1257 1256 1258 1258 1256 1251 1260 1257 1258 1259 1257 1260 1260 1151 1261 1260 1261 1259 814 816 1257 1257 816 1256 1259 814 1257 1256 1255 1251 814 815 816 814 827 815 834 814 1259 1259 1261 1263 1259 1263 834 832 833 834 834 1263 832 1261 1262 1263 1263 1262 1264 1263 1264 832 832 1264 833 1270 1264 1262 1261 751 1262 1262 751 1270 745 1270 747 1270 751 749 1270 749 747 746 745 747 746 747 748 748 747 749 748 749 750 750 749 751 1106 748 750 750 751 752 752 1100 750 750 1100 1101 1106 750 1097 1097 750 1101 1031 1106 1030 1030 1106 1097 1097 1098 1099 1097 1101 1098 1030 1097 1027 1027 1097 1099 1101 1100 1159 1101 1159 1098 1098 1159 1158 1098 1158 1099 1027 1099 1028 1099 1158 1143 1099 1143 1028 1027 1028 1029 1027 1029 1030 1030 1029 1031 1031 1029 1032 1137 1138 1029 1029 1138 1139 1029 1139 1140 1140 1141 1029 1029 1141 1142 1029 1142 1032 1029 1028 1137 1137 1028 1143 1137 1143 1144 1144 1200 1137 1137 1200 1201 1137 1201 1138 1138 1201 1202 1138 1202 1139 1139 1202 1203 1139 1203 1140 1140 1203 1204 1140 1204 1141 1141 1204 1205 1141 1205 1142 1142 1205 1198 1142 1198 1032 1204 759 1205 1205 759 797 1205 797 1198 1203 760 1204 1204 760 759 1202 762 1203 1203 762 760 759 760 761 761 760 762 761 797 759 761 796 797 1198 797 796 796 1032 1198 1031 1032 1033 796 1033 1032 795 796 761 795 1033 796 1033 1034 1031 795 1034 1033 1031 1034 1035 1031 1035 1036 1036 1037 1031 1031 1037 1038 801 1035 1034 801 1034 795 761 801 795 761 800 801 800 1035 801 800 1036 1035 786 1037 1036 786 1036 800 1038 1037 786 785 1039 1038 785 1038 786 761 785 786 786 800 761 761 784 785 784 1039 785 762 775 761 761 775 776 761 776 755 872 871 761 872 761 755 758 761 969 969 761 978 978 761 981 981 761 871 1202 775 762 1201 775 1202 1200 776 1201 1201 776 775 1144 1145 1200 1200 1145 1199 1199 777 1200 1200 777 776 1144 1143 1145 1145 1143 1157 1199 1145 1157 1199 753 777 753 1199 1206 1199 1157 1206 755 776 777 755 777 753 753 754 755 753 1206 754 1206 1157 1161 1206 1161 1207 754 1206 1207 1157 1143 1158 1158 1161 1157 1158 1160 1161 1161 1160 1207 1207 1160 1164 1207 1164 1208 754 1207 763 763 1207 1208 754 763 755 755 763 764 763 1208 764 1162 1209 1208 1162 1208 1163 1163 1208 1164 764 1208 1209 1159 1163 1164 1159 1164 1160 1159 1160 1158 1162 1163 1159 1159 1100 1165 1159 1165 1162 1162 1165 1166 1166 1209 1162 1100 752 1165 1165 752 1154 1165 1154 1166 1166 1154 1156 1166 1156 1209 752 751 1154 1154 751 1155 1154 1155 1148 1148 1156 1154 1147 1156 1148 1156 1147 1210 1209 1156 1210 1146 1147 1148 1146 1148 1149 1148 1155 1151 1148 1151 1149 1151 1155 1261 1155 751 1261 1150 1151 1152 1149 1151 1150 1150 1214 1149 1149 1214 1216 1149 1216 1146 1146 1216 1211 1146 1211 1147 1214 1091 1216 1216 1091 1089 1216 1089 1211 1210 1147 1211 1210 1211 1088 1088 1211 1089 755 1088 1089 1091 755 1089 1090 755 1091 1214 1090 1091 755 764 765 765 1088 755 1090 844 755 872 755 844 765 1210 1088 1209 1210 765 764 1209 765 845 844 846 846 844 1090 1212 846 1090 1212 1090 1214 846 1219 845 1212 1219 846 845 1219 1221 1215 1219 1212 1214 1215 1212 1150 1213 1214 1214 1213 1215 1150 1152 1213 870 871 872 870 869 871 981 871 869 868 984 869 869 984 982 869 982 981 978 981 980 980 981 982 980 982 983 982 984 983 983 984 985 868 985 984 983 985 986 986 1082 983 983 1082 1087 983 1087 980 980 979 978 980 1087 1071 980 1071 979 978 979 969 969 979 970 1071 970 979 1070 1056 1071 1056 1055 1071 1071 1055 970 1087 1070 1071 1069 1050 1070 1070 1050 1056 1087 1069 1070 1055 1056 1057 1057 1056 1050 1055 1057 970 970 1057 1058 1050 1052 1057 1057 1052 1061 1057 1061 1058 1050 1051 1052 1069 1051 1050 1051 1053 1052 1068 1053 1051 1068 1051 1069 1052 1053 1054 1067 1054 1053 1067 1053 1068 1067 1068 1086 1086 1068 1069 1066 1054 1067 1086 1066 1067 1052 1054 910 1066 910 1054 906 910 1066 907 906 1066 1086 907 1066 900 909 910 900 910 901 901 910 906 910 909 1052 906 907 908 901 906 911 911 906 908 1085 908 907 1085 907 1086 911 908 912 1084 912 908 1084 908 1085 1074 901 911 1074 911 1083 1083 911 912 1083 912 1084 1080 1083 1084 1080 1084 1081 1081 1084 1085 1081 1085 1082 1082 1085 1086 998 1080 1081 998 1081 991 991 1081 988 988 1081 1082 993 1079 1080 1079 1083 1080 1079 1074 1083 1077 1078 1079 1079 1078 1072 1077 1079 993 1072 1074 1079 993 30 1077 1077 30 32 1077 32 1078 1078 32 1072 1072 1073 1074 32 1073 1072 1074 1073 1075 1074 1075 1076 1076 901 1074 32 1075 1073 34 1076 1075 34 1075 32 30 31 32 32 31 33 32 33 34 34 33 35 34 35 36 34 36 899 899 1076 34 1076 899 901 899 900 901 36 38 899 899 38 900 904 903 900 904 900 905 903 909 900 900 38 1044 905 900 1044 1044 38 40 40 1049 1044 1064 905 1044 1064 1044 1049 1063 904 905 1063 905 1064 1060 1063 1064 1060 1064 1065 1049 1048 1064 1064 1048 1046 1064 1046 1065 40 1048 1049 1046 1048 40 1045 1046 40 1045 40 1047 1065 1046 1045 1065 1045 1047 958 1060 1065 958 967 961 961 1060 958 961 967 968 890 968 967 890 967 888 961 962 963 961 968 962 963 1060 961 891 962 968 891 968 890 888 889 890 890 889 885 890 885 891 888 887 889 887 929 889 889 929 925 889 925 885 884 883 885 891 885 883 885 925 884 883 964 891 964 962 891 882 881 883 882 883 884 881 973 883 883 973 964 884 925 924 884 924 882 873 881 882 920 873 882 882 924 922 882 922 920 873 880 881 973 881 880 964 973 965 965 973 974 880 974 973 875 880 873 875 976 880 880 976 974 873 874 875 873 920 874 875 874 876 875 876 877 877 977 875 875 977 976 975 974 976 975 976 972 972 976 977 965 974 975 972 1058 975 975 1058 1059 975 1059 965 971 970 972 972 977 971 970 1058 972 879 971 977 879 977 877 969 970 971 969 971 879 877 878 879 879 878 767 879 767 758 879 758 969 877 876 878 916 767 878 916 878 876 874 919 876 876 919 917 876 917 916 874 920 919 917 919 918 918 919 920 918 920 921 921 920 922 921 1305 918 921 922 923 923 1305 921 922 924 923 923 924 925 923 925 926 926 1304 923 923 1304 1305 1304 1308 1305 1305 1308 1309 931 1303 1304 931 1304 926 1303 1307 1304 1304 1307 1308 926 930 931 925 929 926 926 929 930 887 930 929 1303 1306 1307 1306 813 1307 1302 1306 1303 1302 1297 1306 1300 1301 1302 1302 1301 1295 1295 1297 1302 1295 1296 1297 1297 1296 1298 1301 8 1295 8 1296 1295 1300 8 1301 1300 6 8 8 1298 1296 758 793 794 1191 794 793 1058 1061 1062 1058 1062 1059 1052 903 1061 1061 903 902 1061 902 1062 1059 1062 1063 1062 902 904 1062 904 1063 965 1059 963 963 1059 1060 1059 1063 1060 963 964 965 963 962 964 902 903 904 1052 909 903 33 466 35 31 465 33 33 465 466 31 381 465 988 1082 986 1082 1086 1087 986 985 987 986 987 988 987 989 988 988 989 990 988 990 991 990 996 991 991 996 997 991 997 998 856 997 996 1086 1069 1087 1239 1248 1249 1239 1249 1236 1238 1239 1236 1239 1238 1234 1234 1248 1239 1238 824 1242 1234 1238 1235 1235 1238 1242 1235 1242 1240 1240 1242 1243 1241 942 1240 1240 942 944 1240 1243 1241 942 941 943 942 943 944 1374 1387 1388 1374 1388 1375 1637 1388 1387 1635 1375 1388 1635 1388 1637 1633 1375 1635 1634 1633 1635 1634 1635 1636 1635 1637 1636 1632 1633 1634 552 554 555 554 624 555 551 553 552 552 553 554 548 552 556 553 622 554 554 622 624 615 553 551 553 615 622 548 556 557 651 652 644 651 654 652 667 644 652 303 189 186))
                   (list :vertices (let ((mat (make-matrix 2334 3))) (fvector-replace (array-entity mat) #f(-2.1290100097656250e+02 6.1062999725341797e+01 0.0000000000000000e+00 -2.1289799499511719e+02 6.3064701080322266e+01 0.0000000000000000e+00 -3.0599902343750000e+02 6.1062999725341797e+01 0.0000000000000000e+00 -3.0600198364257812e+02 6.3064701080322266e+01 0.0000000000000000e+00 -3.0684500122070312e+02 6.0875499725341797e+01 0.0000000000000000e+00 -3.0769299316406250e+02 6.2689601898193359e+01 0.0000000000000000e+00 -3.1729699707031250e+02 5.5996997833251953e+01 0.0000000000000000e+00 -3.1814501953125000e+02 5.7811100006103516e+01 0.0000000000000000e+00 -3.1788000488281250e+02 5.5584400177001953e+01 0.0000000000000000e+00 -3.1930999755859375e+02 5.6985900878906250e+01 0.0000000000000000e+00 -3.1832299804687500e+02 5.4888401031494141e+01 0.0000000000000000e+00 -3.2019601440429688e+02 5.5593898773193359e+01 0.0000000000000000e+00 -3.1845001220703125e+02 5.4185600280761719e+01 0.0000000000000000e+00 -3.2045098876953125e+02 5.4188499450683594e+01 0.0000000000000000e+00 -3.1845001220703125e+02 -5.4185600280761719e+01 0.0000000000000000e+00 -3.2045098876953125e+02 -5.4188499450683594e+01 0.0000000000000000e+00 -3.1832400512695312e+02 -5.4883701324462891e+01 0.0000000000000000e+00 -3.2019998168945312e+02 -5.5584503173828125e+01 0.0000000000000000e+00 -3.1787600708007812e+02 -5.5587898254394531e+01 0.0000000000000000e+00 -3.1930300903320312e+02 -5.6993099212646484e+01 0.0000000000000000e+00 -3.1729699707031250e+02 -5.5996997833251953e+01 0.0000000000000000e+00 -3.1814501953125000e+02 -5.7811100006103516e+01 0.0000000000000000e+00 -3.0684500122070312e+02 -6.0875499725341797e+01 0.0000000000000000e+00 -3.0769299316406250e+02 -6.2689601898193359e+01 0.0000000000000000e+00 -3.0599902343750000e+02 -6.1062999725341797e+01 0.0000000000000000e+00 -3.0600198364257812e+02 -6.3064701080322266e+01 0.0000000000000000e+00 -2.1290100097656250e+02 -6.1062999725341797e+01 0.0000000000000000e+00 -2.1289799499511719e+02 -6.3064701080322266e+01 0.0000000000000000e+00 -2.1205499267578125e+02 -6.0875499725341797e+01 0.0000000000000000e+00 -2.1120700073242188e+02 -6.2689601898193359e+01 0.0000000000000000e+00 -2.0160299682617188e+02 -5.5996997833251953e+01 0.0000000000000000e+00 -2.0075399780273438e+02 -5.7811100006103516e+01 0.0000000000000000e+00 -2.0102000427246094e+02 -5.5584400177001953e+01 0.0000000000000000e+00 -1.9958999633789062e+02 -5.6985900878906250e+01 0.0000000000000000e+00 -2.0057701110839844e+02 -5.4888401031494141e+01 0.0000000000000000e+00 -1.9870401000976562e+02 -5.5593898773193359e+01 0.0000000000000000e+00 -2.0044999694824219e+02 -5.4185600280761719e+01 0.0000000000000000e+00 -1.9844900512695312e+02 -5.4188499450683594e+01 0.0000000000000000e+00 -2.0044999694824219e+02 5.4185600280761719e+01 0.0000000000000000e+00 -1.9844900512695312e+02 5.4188499450683594e+01 0.0000000000000000e+00 -2.0057901000976562e+02 5.4892398834228516e+01 0.0000000000000000e+00 -1.9870401000976562e+02 5.5593898773193359e+01 0.0000000000000000e+00 -2.0102700805664062e+02 5.5590999603271484e+01 0.0000000000000000e+00 -1.9958999633789062e+02 5.6985900878906250e+01 0.0000000000000000e+00 -2.0160299682617188e+02 5.5996997833251953e+01 0.0000000000000000e+00 -2.0075399780273438e+02 5.7811100006103516e+01 0.0000000000000000e+00 -2.1205499267578125e+02 6.0875499725341797e+01 0.0000000000000000e+00 -2.1120700073242188e+02 6.2689601898193359e+01 0.0000000000000000e+00 -3.1528100585937500e+02 2.9495100021362305e+01 -3.7383499145507812e+01 -3.0595898437500000e+02 2.9495100021362305e+01 -3.7383499145507812e+01 -3.1524597167968750e+02 2.2544599533081055e+01 -3.8416698455810547e+01 -3.0595898437500000e+02 2.2166698455810547e+01 -3.8464797973632812e+01 -3.1522500610351562e+02 1.4782699584960938e+01 -3.9027400970458984e+01 -3.0595898437500000e+02 1.4799299240112305e+01 -3.9238502502441406e+01 -3.1519897460937500e+02 5.1921000480651855e+00 -3.9782199859619141e+01 -3.0595898437500000e+02 7.4061698913574219e+00 -3.9703296661376953e+01 -3.1520300292968750e+02 3.5574899520725012e-03 -3.9679100036621094e+01 -3.0595898437500000e+02 0.0000000000000000e+00 -3.9858299255371094e+01 -3.0595898437500000e+02 -7.4061698913574219e+00 -3.9703296661376953e+01 -3.1521099853515625e+02 -1.2210500717163086e+01 -3.9436599731445312e+01 -3.0595898437500000e+02 -1.4799299240112305e+01 -3.9238502502441406e+01 -3.1522100830078125e+02 -1.4786499977111816e+01 -3.9130599975585938e+01 -3.1528100585937500e+02 -2.9495100021362305e+01 -3.7383499145507812e+01 -3.0595898437500000e+02 -2.2166698455810547e+01 -3.8464797973632812e+01 -3.0595898437500000e+02 -2.9495100021362305e+01 -3.7383499145507812e+01 -2.1380099487304688e+02 -5.2551399230957031e+01 -3.4000000000000000e+01 -2.7758801269531250e+02 -2.8748600006103516e+01 -3.4000000000000000e+01 -2.7665298461914062e+02 -2.7934400558471680e+01 -3.4000000000000000e+01 -3.0509899902343750e+02 -3.7052398681640625e+01 -3.4000000000000000e+01 -3.0130099487304688e+02 -3.6836700439453125e+01 -3.4000000000000000e+01 -3.0509899902343750e+02 -5.2551399230957031e+01 -3.4000000000000000e+01 -2.9940499877929688e+02 -3.6613899230957031e+01 -3.4000000000000000e+01 -2.9597399902343750e+02 -3.5998199462890625e+01 -3.4000000000000000e+01 -2.8169000244140625e+02 -3.1115900039672852e+01 -3.4000000000000000e+01 -2.8128601074218750e+02 -3.0923700332641602e+01 -3.4000000000000000e+01 -2.7902600097656250e+02 -2.9714799880981445e+01 -3.4000000000000000e+01 -2.6542300415039062e+02 -1.2063699722290039e+01 -3.4000000000000000e+01 -2.6433898925781250e+02 -9.1989603042602539e+00 -3.4000000000000000e+01 -2.6283300781250000e+02 2.4492299556732178e-01 -3.4000000000000000e+01 -2.1380099487304688e+02 5.2551399230957031e+01 -3.4000000000000000e+01 -2.6295199584960938e+02 -2.5970299243927002e+00 -3.4000000000000000e+01 -2.7715600585937500e+02 2.8400300979614258e+01 -3.4000000000000000e+01 -2.7841897583007812e+02 2.9334699630737305e+01 -3.4000000000000000e+01 -2.7997299194335938e+02 3.0254400253295898e+01 -3.4000000000000000e+01 -2.8179400634765625e+02 3.1164501190185547e+01 -3.4000000000000000e+01 -2.9597399902343750e+02 3.5998100280761719e+01 -3.4000000000000000e+01 -2.9940499877929688e+02 3.6613899230957031e+01 -3.4000000000000000e+01 -3.0509899902343750e+02 5.2551399230957031e+01 -3.4000000000000000e+01 -3.0130099487304688e+02 3.6836700439453125e+01 -3.4000000000000000e+01 -3.0509899902343750e+02 3.7052398681640625e+01 -3.4000000000000000e+01 -2.9350997924804688e+02 -3.5365100860595703e+01 -3.4000000000000000e+01 -2.9044500732421875e+02 -3.4428199768066406e+01 -3.4000000000000000e+01 -2.8529901123046875e+02 -3.2636898040771484e+01 -3.4000000000000000e+01 -2.6300100708007812e+02 3.0771501064300537e+00 -3.4000000000000000e+01 -2.6314700317382812e+02 4.1997399330139160e+00 -3.4000000000000000e+01 -2.6374301147460938e+02 7.1512999534606934e+00 -3.4000000000000000e+01 -2.6354101562500000e+02 -6.3052802085876465e+00 -3.4000000000000000e+01 -2.6336199951171875e+02 -5.4538798332214355e+00 -3.4000000000000000e+01 -2.6464797973632812e+02 1.0098299980163574e+01 -3.4000000000000000e+01 -2.6586999511718750e+02 1.3065599441528320e+01 -3.4000000000000000e+01 -2.6602398681640625e+02 1.3392700195312500e+01 -3.4000000000000000e+01 -2.6781298828125000e+02 1.6736700057983398e+01 -3.4000000000000000e+01 -2.6999600219726562e+02 2.0082000732421875e+01 -3.4000000000000000e+01 -2.7259698486328125e+02 2.3459499359130859e+01 -3.4000000000000000e+01 -2.7375399780273438e+02 -2.4815999984741211e+01 -3.4000000000000000e+01 -2.7114099121093750e+02 -2.1632600784301758e+01 -3.4000000000000000e+01 -2.6883999633789062e+02 -1.8385601043701172e+01 -3.4000000000000000e+01 -2.8479901123046875e+02 3.2442996978759766e+01 -3.4000000000000000e+01 -2.8894699096679688e+02 3.3939399719238281e+01 -3.4000000000000000e+01 -2.9350997924804688e+02 3.5365100860595703e+01 -3.4000000000000000e+01 -2.6841000366210938e+02 -1.7713901519775391e+01 -3.4000000000000000e+01 -2.6678402709960938e+02 -1.4903900146484375e+01 -3.4000000000000000e+01 -2.7522201538085938e+02 2.6440198898315430e+01 -3.4000000000000000e+01 -2.7665298461914062e+02 2.7934400558471680e+01 -3.4000000000000000e+01 -3.1945898437500000e+02 -3.3511798858642578e+01 -2.8404998779296875e+01 -3.1952801513671875e+02 -3.6583301544189453e+01 -2.6429599761962891e+01 -3.1956500244140625e+02 -5.3028598785400391e+01 -2.5379400253295898e+01 -3.1957000732421875e+02 -5.3114196777343750e+01 -2.5235601425170898e+01 -3.1957699584960938e+02 -5.3160598754882812e+01 -2.5021100997924805e+01 -3.1957800292968750e+02 5.3162197113037109e+01 -2.5013999938964844e+01 -3.1955700683593750e+02 4.0492099761962891e+01 -2.5609100341796875e+01 -3.1953601074218750e+02 3.7180599212646484e+01 -2.6194698333740234e+01 -3.1955700683593750e+02 -4.0492099761962891e+01 -2.5609100341796875e+01 -3.1955700683593750e+02 -5.2552303314208984e+01 -2.5609100341796875e+01 -3.1955599975585938e+02 -3.9960800170898438e+01 -2.5624200820922852e+01 -3.1957800292968750e+02 -5.3162197113037109e+01 -2.5013999938964844e+01 -3.1957699584960938e+02 5.3161300659179688e+01 -2.5021400451660156e+01 -3.1957400512695312e+02 5.3150096893310547e+01 -2.5118900299072266e+01 -3.1955700683593750e+02 5.2552303314208984e+01 -2.5609100341796875e+01 -3.1957299804687500e+02 5.3141502380371094e+01 -2.5155599594116211e+01 -3.1955798339843750e+02 5.2712600708007812e+01 -2.5587400436401367e+01 -3.1947698974609375e+02 3.4105697631835938e+01 -2.7906000137329102e+01 -3.1938201904296875e+02 3.1589199066162109e+01 -3.0607101440429688e+01 -3.1935699462890625e+02 -3.1129400253295898e+01 -3.1333301544189453e+01 -3.1935699462890625e+02 3.1129400253295898e+01 -3.1333301544189453e+01 -3.1934197998046875e+02 -3.0885299682617188e+01 -3.1768400192260742e+01 -3.1955999755859375e+02 -5.2875102996826172e+01 -2.5516201019287109e+01 -3.1956402587890625e+02 -5.3004001617431641e+01 -2.5408300399780273e+01 -3.1956198120117188e+02 5.2943901062011719e+01 -2.5466199874877930e+01 -3.1956100463867188e+02 5.2914398193359375e+01 -2.5489398956298828e+01 -3.1956600952148438e+02 5.3056499481201172e+01 -2.5341600418090820e+01 -3.1956698608398438e+02 5.3076400756835938e+01 -2.5310300827026367e+01 -3.1955798339843750e+02 5.2767799377441406e+01 -2.5569398880004883e+01 -3.1955700683593750e+02 -5.2648700714111328e+01 -2.5601200103759766e+01 -3.1955700683593750e+02 -5.2685901641845703e+01 -2.5593999862670898e+01 -3.1955999755859375e+02 -5.2842800140380859e+01 -2.5534999847412109e+01 -3.1929699707031250e+02 2.9987899780273438e+01 -3.3054599761962891e+01 -3.1927899169921875e+02 2.8828599929809570e+01 -3.3579101562500000e+01 -3.1932601928710938e+02 3.0657600402832031e+01 -3.2212497711181641e+01 -3.1924301147460938e+02 2.2035099029541016e+01 -3.4588897705078125e+01 -3.1934197998046875e+02 3.0885299682617188e+01 -3.1768400192260742e+01 -3.1919699096679688e+02 5.0747399330139160e+00 -3.5923500061035156e+01 -3.1920901489257812e+02 -1.1934599876403809e+01 -3.5585800170898438e+01 -3.1932601928710938e+02 -3.0657600402832031e+01 -3.2212497711181641e+01 -3.1927899169921875e+02 -2.8828599929809570e+01 -3.3579101562500000e+01 -3.1929299926757812e+02 -2.9825599670410156e+01 -3.3175899505615234e+01 -3.1714901733398438e+02 4.0492099761962891e+01 -2.9139999389648438e+01 -3.1714901733398438e+02 5.2551399230957031e+01 -2.9139999389648438e+01 -3.1342898559570312e+02 3.9740798950195312e+01 -3.0751298904418945e+01 -3.0668899536132812e+02 5.2551399230957031e+01 -3.3670501708984375e+01 -3.0983499145507812e+02 3.8875099182128906e+01 -3.2307598114013672e+01 -3.0668899536132812e+02 3.7844799041748047e+01 -3.3670501708984375e+01 -3.0983499145507812e+02 -3.8875099182128906e+01 -3.2307598114013672e+01 -3.0668899536132812e+02 -3.7844799041748047e+01 -3.3670501708984375e+01 -3.0668899536132812e+02 -5.2551399230957031e+01 -3.3670501708984375e+01 -3.1714901733398438e+02 -5.2551399230957031e+01 -2.9139999389648438e+01 -3.1714901733398438e+02 -4.0492099761962891e+01 -2.9139999389648438e+01 -3.1342898559570312e+02 -3.9740798950195312e+01 -3.0751298904418945e+01 -3.0513299560546875e+02 -6.2043498992919922e+01 -2.4887998580932617e+01 -2.1376701354980469e+02 -6.2043498992919922e+01 -2.4887998580932617e+01 -2.1376899719238281e+02 -6.2011398315429688e+01 -2.5371198654174805e+01 -3.0512802124023438e+02 -6.1894802093505859e+01 -2.6217599868774414e+01 -2.1377499389648438e+02 -6.1785198211669922e+01 -2.6732999801635742e+01 -2.1379100036621094e+02 -5.9158298492431641e+01 -3.1321001052856445e+01 -2.1378601074218750e+02 -6.0319801330566406e+01 -2.9968301773071289e+01 -3.0511502075195312e+02 -6.0615303039550781e+01 -2.9522300720214844e+01 -3.0511999511718750e+02 -6.1236099243164062e+01 -2.8342201232910156e+01 -3.0512600708007812e+02 -6.1823101043701172e+01 -2.6569999694824219e+01 -3.0511999511718750e+02 -6.1257999420166016e+01 -2.8300600051879883e+01 -2.1377999877929688e+02 -6.1228900909423828e+01 -2.8340200424194336e+01 -2.1377999877929688e+02 -6.1189701080322266e+01 -2.8453498840332031e+01 -3.0511001586914062e+02 -5.9511901855468750e+01 -3.0965299606323242e+01 -3.0510900878906250e+02 -5.9160499572753906e+01 -3.1322698593139648e+01 -2.1379100036621094e+02 -5.9131900787353516e+01 -3.1351699829101562e+01 -2.1379399108886719e+02 -5.8313999176025391e+01 -3.2052597045898438e+01 -3.0510900878906250e+02 -5.9131900787353516e+01 -3.1351699829101562e+01 -3.0510397338867188e+02 -5.7701599121093750e+01 -3.2482799530029297e+01 -2.1379699707031250e+02 -5.7165000915527344e+01 -3.2804500579833984e+01 -2.1379899597167969e+02 -5.6100799560546875e+01 -3.3268398284912109e+01 -3.0510101318359375e+02 -5.6152900695800781e+01 -3.3290798187255859e+01 -3.0510101318359375e+02 -5.6115898132324219e+01 -3.3301902770996094e+01 -2.1380000305175781e+02 -5.5496200561523438e+01 -3.3532001495361328e+01 -2.1380099487304688e+02 -5.3905700683593750e+01 -3.3902896881103516e+01 -3.0509899902343750e+02 -5.3040100097656250e+01 -3.3987400054931641e+01 -3.0509899902343750e+02 -5.4409900665283203e+01 -3.3816402435302734e+01 -3.0510000610351562e+02 5.5496200561523438e+01 -3.3532001495361328e+01 -3.0510101318359375e+02 5.6100799560546875e+01 -3.3268398284912109e+01 -2.1379899597167969e+02 5.6115898132324219e+01 -3.3302001953125000e+01 -3.0509899902343750e+02 5.3905700683593750e+01 -3.3902896881103516e+01 -2.1380099487304688e+02 5.3040100097656250e+01 -3.3987400054931641e+01 -2.1380099487304688e+02 5.4409900665283203e+01 -3.3816402435302734e+01 -2.1379100036621094e+02 5.9160499572753906e+01 -3.1322698593139648e+01 -2.1379100036621094e+02 5.9131900787353516e+01 -3.1351699829101562e+01 -3.0510601806640625e+02 5.8313999176025391e+01 -3.2052597045898438e+01 -2.1379600524902344e+02 5.7701599121093750e+01 -3.2482799530029297e+01 -3.0510299682617188e+02 5.7165000915527344e+01 -3.2804500579833984e+01 -2.1379800415039062e+02 5.6152900695800781e+01 -3.3290798187255859e+01 -3.0510900878906250e+02 5.9131900787353516e+01 -3.1351699829101562e+01 -3.0510900878906250e+02 5.9158298492431641e+01 -3.1321001052856445e+01 -2.1378999328613281e+02 5.9511901855468750e+01 -3.0965299606323242e+01 -2.1378399658203125e+02 6.0615303039550781e+01 -2.9522300720214844e+01 -3.0511401367187500e+02 6.0319801330566406e+01 -2.9968301773071289e+01 -2.1377999877929688e+02 6.1236099243164062e+01 -2.8342201232910156e+01 -3.0511901855468750e+02 6.1189701080322266e+01 -2.8453498840332031e+01 -3.0511999511718750e+02 6.1228900909423828e+01 -2.8340299606323242e+01 -2.1377999877929688e+02 6.1257999420166016e+01 -2.8300600051879883e+01 -3.0512500000000000e+02 6.1785198211669922e+01 -2.6732999801635742e+01 -3.0513299560546875e+02 6.2043498992919922e+01 -2.4887998580932617e+01 -2.1376701354980469e+02 6.2043498992919922e+01 -2.4887998580932617e+01 -3.0513098144531250e+02 6.2011398315429688e+01 -2.5371198654174805e+01 -2.1377200317382812e+02 6.1894802093505859e+01 -2.6217599868774414e+01 -2.1377400207519531e+02 6.1823101043701172e+01 -2.6569999694824219e+01 -1.9932200622558594e+02 -5.3162197113037109e+01 -2.5013999938964844e+01 -1.9932200622558594e+02 5.3161800384521484e+01 -2.5021400451660156e+01 -1.9934300231933594e+02 5.2551399230957031e+01 -2.5609100341796875e+01 -1.9934300231933594e+02 5.2552303314208984e+01 -2.5608999252319336e+01 -1.9934300231933594e+02 -5.2552303314208984e+01 -2.5609100341796875e+01 -1.9934300231933594e+02 5.2648700714111328e+01 -2.5601200103759766e+01 -1.9934300231933594e+02 5.2685901641845703e+01 -2.5593999862670898e+01 -1.9932800292968750e+02 5.3134002685546875e+01 -2.5181299209594727e+01 -1.9932200622558594e+02 -5.3161300659179688e+01 -2.5021400451660156e+01 -1.9932598876953125e+02 -5.3150096893310547e+01 -2.5118900299072266e+01 -1.9932701110839844e+02 -5.3141502380371094e+01 -2.5155599594116211e+01 -1.9934199523925781e+02 -5.2712600708007812e+01 -2.5587400436401367e+01 -1.9933999633789062e+02 5.2875102996826172e+01 -2.5516201019287109e+01 -1.9933601379394531e+02 5.3004001617431641e+01 -2.5408300399780273e+01 -1.9933999633789062e+02 5.2842800140380859e+01 -2.5534999847412109e+01 -1.9933499145507812e+02 5.3028503417968750e+01 -2.5379499435424805e+01 -1.9933000183105469e+02 5.3114196777343750e+01 -2.5235601425170898e+01 -1.9933799743652344e+02 -5.2943901062011719e+01 -2.5466199874877930e+01 -1.9933900451660156e+02 -5.2914398193359375e+01 -2.5489398956298828e+01 -1.9933399963378906e+02 -5.3056499481201172e+01 -2.5341600418090820e+01 -1.9933299255371094e+02 -5.3076400756835938e+01 -2.5310300827026367e+01 -1.9934199523925781e+02 -5.2767799377441406e+01 -2.5569398880004883e+01 -3.1726901245117188e+02 5.6781898498535156e+01 -2.5081901550292969e+01 -3.0754000854492188e+02 6.1332599639892578e+01 -2.4918298721313477e+01 -3.0682299804687500e+02 6.1667400360107422e+01 -2.4906799316406250e+01 -3.0669000244140625e+02 5.3858699798583984e+01 -3.3576400756835938e+01 -3.1715200805664062e+02 5.3353397369384766e+01 -2.9032699584960938e+01 -3.0669097900390625e+02 5.4284400939941406e+01 -3.3476699829101562e+01 -3.1715301513671875e+02 5.3664299011230469e+01 -2.8991100311279297e+01 -3.0669500732421875e+02 5.5388900756835938e+01 -3.3218101501464844e+01 -3.1715701293945312e+02 5.4047000885009766e+01 -2.8867099761962891e+01 -3.0669900512695312e+02 5.5949901580810547e+01 -3.2972499847412109e+01 -3.1715802001953125e+02 5.4127902984619141e+01 -2.8823099136352539e+01 -3.0670602416992188e+02 5.6997600555419922e+01 -3.2513801574707031e+01 -3.1716998291015625e+02 5.4838699340820312e+01 -2.8436399459838867e+01 -3.0671200561523438e+02 5.7501800537109375e+01 -3.2182296752929688e+01 -3.1717398071289062e+02 5.5065200805664062e+01 -2.8313199996948242e+01 -3.0671798706054688e+02 5.8103401184082031e+01 -3.1786899566650391e+01 -3.1717898559570312e+02 5.5268001556396484e+01 -2.8153799057006836e+01 -3.0672799682617188e+02 5.8881900787353516e+01 -3.1116201400756836e+01 -3.1718502807617188e+02 5.5463798522949219e+01 -2.7937900543212891e+01 -3.0672799682617188e+02 5.8889499664306641e+01 -3.1109699249267578e+01 -3.1720297241210938e+02 5.6006999969482422e+01 -2.7338899612426758e+01 -3.0674899291992188e+02 6.0015701293945312e+01 -2.9789899826049805e+01 -3.1720401000976562e+02 5.6049102783203125e+01 -2.7292400360107422e+01 -3.0674899291992188e+02 6.0029102325439453e+01 -2.9774200439453125e+01 -3.1721099853515625e+02 5.6186798095703125e+01 -2.7076999664306641e+01 -3.0677099609375000e+02 6.0861099243164062e+01 -2.8313699722290039e+01 -3.0677200317382812e+02 6.0874900817871094e+01 -2.8273200988769531e+01 -3.1722399902343750e+02 5.6377601623535156e+01 -2.6626600265502930e+01 -3.0679602050781250e+02 6.1427196502685547e+01 -2.6657798767089844e+01 -3.1724200439453125e+02 5.6639499664306641e+01 -2.6008600234985352e+01 -3.0679699707031250e+02 6.1432998657226562e+01 -2.6622200012207031e+01 -3.1724600219726562e+02 5.6671001434326172e+01 -2.5875900268554688e+01 -3.1724899291992188e+02 5.6698699951171875e+01 -2.5759199142456055e+01 -3.0681698608398438e+02 6.1639301300048828e+01 -2.5348499298095703e+01 -3.0754000854492188e+02 -6.1332599639892578e+01 -2.4918298721313477e+01 -3.1726901245117188e+02 -5.6781898498535156e+01 -2.5081901550292969e+01 -3.1724700927734375e+02 -5.6606597900390625e+01 -2.5861499786376953e+01 -3.0680401611328125e+02 -6.1530502319335938e+01 -2.6163000106811523e+01 -3.0682299804687500e+02 -6.1667598724365234e+01 -2.4906799316406250e+01 -3.0679898071289062e+02 -6.1462997436523438e+01 -2.6501399993896484e+01 -3.0679699707031250e+02 -6.1424999237060547e+01 -2.6619199752807617e+01 -3.0677398681640625e+02 -6.0926502227783203e+01 -2.8165899276733398e+01 -3.1722598266601562e+02 -5.6449699401855469e+01 -2.6559000015258789e+01 -3.0677200317382812e+02 -6.0871799468994141e+01 -2.8270799636840820e+01 -3.1722302246093750e+02 -5.6403701782226562e+01 -2.6635900497436523e+01 -3.0675500488281250e+02 -6.0312198638916016e+01 -2.9343801498413086e+01 -3.1720297241210938e+02 -5.5989002227783203e+01 -2.7330101013183594e+01 -3.0674899291992188e+02 -5.9988800048828125e+01 -2.9769500732421875e+01 -3.1719601440429688e+02 -5.5854701995849609e+01 -2.7554899215698242e+01 -3.0673400878906250e+02 -5.9254600524902344e+01 -3.0736299514770508e+01 -3.1719000244140625e+02 -5.5685199737548828e+01 -2.7753398895263672e+01 -3.0672799682617188e+02 -5.8889499664306641e+01 -3.1109699249267578e+01 -3.1718502807617188e+02 -5.5467098236083984e+01 -2.7935400009155273e+01 -3.0672799682617188e+02 -5.8881599426269531e+01 -3.1115900039672852e+01 -3.1716998291015625e+02 -5.4846000671386719e+01 -2.8453599929809570e+01 -3.0671099853515625e+02 -5.7514900207519531e+01 -3.2202198028564453e+01 -3.1716799926757812e+02 -5.4791900634765625e+01 -2.8498800277709961e+01 -3.0671099853515625e+02 -5.7514297485351562e+01 -3.2202697753906250e+01 -3.1716400146484375e+02 -5.4568202972412109e+01 -2.8628900527954102e+01 -3.0669900512695312e+02 -5.6023097991943359e+01 -3.2984199523925781e+01 -3.0669900512695312e+02 -5.5963699340820312e+01 -3.3002201080322266e+01 -3.1715899658203125e+02 -5.4119899749755859e+01 -2.8797100067138672e+01 -3.0669097900390625e+02 -5.4343799591064453e+01 -3.3492698669433594e+01 -3.1715200805664062e+02 -5.3482498168945312e+01 -2.9036300659179688e+01 -3.0669097900390625e+02 -5.4290100097656250e+01 -3.3499500274658203e+01 -3.1715100097656250e+02 -5.3357097625732422e+01 -2.9060600280761719e+01 -3.1715100097656250e+02 -5.3228797912597656e+01 -2.9085399627685547e+01 -3.0668899536132812e+02 -5.3023300170898438e+01 -3.3658298492431641e+01 -2.1207598876953125e+02 6.1667400360107422e+01 -2.4906799316406250e+01 -2.0685299682617188e+02 5.9224800109863281e+01 -2.4990999221801758e+01 -2.0162998962402344e+02 5.6781898498535156e+01 -2.5081901550292969e+01 -2.0165400695800781e+02 5.6643199920654297e+01 -2.5871200561523438e+01 -2.1210299682617188e+02 6.1424999237060547e+01 -2.6619199752807617e+01 -2.1210099792480469e+02 6.1462997436523438e+01 -2.6501399993896484e+01 -2.1209600830078125e+02 6.1530502319335938e+01 -2.6163000106811523e+01 -2.0166300964355469e+02 5.6588199615478516e+01 -2.6183700561523438e+01 -2.1212600708007812e+02 6.0926502227783203e+01 -2.8165899276733398e+01 -2.0167399597167969e+02 5.6449699401855469e+01 -2.6559000015258789e+01 -2.1212800598144531e+02 6.0871799468994141e+01 -2.8270799636840820e+01 -2.0167599487304688e+02 5.6403701782226562e+01 -2.6635900497436523e+01 -2.1214500427246094e+02 6.0312198638916016e+01 -2.9343801498413086e+01 -2.0169700622558594e+02 5.5989002227783203e+01 -2.7329999923706055e+01 -2.1215100097656250e+02 5.9988800048828125e+01 -2.9769500732421875e+01 -2.0170399475097656e+02 5.5854297637939453e+01 -2.7555400848388672e+01 -2.1216600036621094e+02 5.9254600524902344e+01 -3.0736299514770508e+01 -2.0171000671386719e+02 5.5685199737548828e+01 -2.7753398895263672e+01 -2.1217199707031250e+02 5.8889499664306641e+01 -3.1109699249267578e+01 -2.0171501159667969e+02 5.5467098236083984e+01 -2.7935400009155273e+01 -2.1217199707031250e+02 5.8881599426269531e+01 -3.1115900039672852e+01 -2.0172999572753906e+02 5.4846000671386719e+01 -2.8453599929809570e+01 -2.1218901062011719e+02 5.7514900207519531e+01 -3.2202198028564453e+01 -2.0173199462890625e+02 5.4791900634765625e+01 -2.8498800277709961e+01 -2.1218901062011719e+02 5.7514297485351562e+01 -3.2202697753906250e+01 -2.0173600769042969e+02 5.4568202972412109e+01 -2.8628900527954102e+01 -2.1220100402832031e+02 5.6023097991943359e+01 -3.2984199523925781e+01 -2.1220100402832031e+02 5.5963699340820312e+01 -3.3002201080322266e+01 -2.0174099731445312e+02 5.4119899749755859e+01 -2.8797100067138672e+01 -2.1220899963378906e+02 5.4343799591064453e+01 -3.3492698669433594e+01 -2.0174800109863281e+02 5.3482498168945312e+01 -2.9036300659179688e+01 -2.1220899963378906e+02 5.4290100097656250e+01 -3.3499500274658203e+01 -2.0174899291992188e+02 5.3357097625732422e+01 -2.9060600280761719e+01 -2.0174899291992188e+02 5.3228797912597656e+01 -2.9085399627685547e+01 -2.1221099853515625e+02 5.3023300170898438e+01 -3.3658298492431641e+01 -2.0175099182128906e+02 5.2551399230957031e+01 -2.9139999389648438e+01 -2.1221099853515625e+02 5.2551399230957031e+01 -3.3670501708984375e+01 -2.0175099182128906e+02 -5.2551399230957031e+01 -2.9139999389648438e+01 -2.1221099853515625e+02 -5.2551399230957031e+01 -3.3670501708984375e+01 -2.1221000671386719e+02 -5.3858699798583984e+01 -3.3576400756835938e+01 -2.0174800109863281e+02 -5.3353397369384766e+01 -2.9032699584960938e+01 -2.1220899963378906e+02 -5.4284400939941406e+01 -3.3476699829101562e+01 -2.0174600219726562e+02 -5.3664299011230469e+01 -2.8991100311279297e+01 -2.1220498657226562e+02 -5.5388900756835938e+01 -3.3218101501464844e+01 -2.0174301147460938e+02 -5.4047000885009766e+01 -2.8867099761962891e+01 -2.1220100402832031e+02 -5.5949901580810547e+01 -3.2972499847412109e+01 -2.0174099731445312e+02 -5.4127902984619141e+01 -2.8823099136352539e+01 -2.1219400024414062e+02 -5.6997600555419922e+01 -3.2513801574707031e+01 -2.0172999572753906e+02 -5.4838699340820312e+01 -2.8436399459838867e+01 -2.1218800354003906e+02 -5.7501800537109375e+01 -3.2182296752929688e+01 -2.0172599792480469e+02 -5.5065200805664062e+01 -2.8313199996948242e+01 -2.1218200683593750e+02 -5.8103401184082031e+01 -3.1786899566650391e+01 -2.0172200012207031e+02 -5.5268001556396484e+01 -2.8153799057006836e+01 -2.1217199707031250e+02 -5.8881900787353516e+01 -3.1116201400756836e+01 -2.0171501159667969e+02 -5.5463798522949219e+01 -2.7937900543212891e+01 -2.1217199707031250e+02 -5.8889499664306641e+01 -3.1109699249267578e+01 -2.0169700622558594e+02 -5.6006999969482422e+01 -2.7338899612426758e+01 -2.1215100097656250e+02 -6.0015701293945312e+01 -2.9789899826049805e+01 -2.0169599914550781e+02 -5.6049102783203125e+01 -2.7292400360107422e+01 -2.1215100097656250e+02 -6.0029102325439453e+01 -2.9774200439453125e+01 -2.0168901062011719e+02 -5.6186798095703125e+01 -2.7076999664306641e+01 -2.0165400695800781e+02 -5.6671001434326172e+01 -2.5875900268554688e+01 -2.1210299682617188e+02 -6.1432998657226562e+01 -2.6622200012207031e+01 -2.0165798950195312e+02 -5.6639499664306641e+01 -2.6008600234985352e+01 -2.1210398864746094e+02 -6.1427196502685547e+01 -2.6657798767089844e+01 -2.0167599487304688e+02 -5.6377601623535156e+01 -2.6626600265502930e+01 -2.1212800598144531e+02 -6.0874900817871094e+01 -2.8273200988769531e+01 -2.1212899780273438e+02 -6.0861099243164062e+01 -2.8313699722290039e+01 -2.0164999389648438e+02 -5.6698699951171875e+01 -2.5759199142456055e+01 -2.0162998962402344e+02 -5.6781898498535156e+01 -2.5081901550292969e+01 -2.0685299682617188e+02 -5.9224899291992188e+01 -2.4990999221801758e+01 -2.1208299255371094e+02 -6.1639301300048828e+01 -2.5348499298095703e+01 -2.1207701110839844e+02 -6.1667598724365234e+01 -2.4906799316406250e+01 -2.7469198608398438e+02 -2.3993799209594727e+01 -3.4131198883056641e+01 -2.7759201049804688e+02 -2.7011299133300781e+01 -3.4146202087402344e+01 -2.8700500488281250e+02 -2.8058099746704102e+01 -3.5488502502441406e+01 -2.6772201538085938e+02 -1.4406999588012695e+01 -3.4094699859619141e+01 -2.6934899902343750e+02 -1.7124200820922852e+01 -3.4103302001953125e+01 -2.9469601440429688e+02 -1.4680099487304688e+01 -3.8357997894287109e+01 -2.6977899169921875e+02 -1.7773799896240234e+01 -3.4105499267578125e+01 -2.7208001708984375e+02 -2.0914199829101562e+01 -3.4117500305175781e+01 -2.9469601440429688e+02 -2.8914300918579102e+01 -3.6582000732421875e+01 -2.9469601440429688e+02 -2.2055599212646484e+01 -3.7585300445556641e+01 -2.9469601440429688e+02 -1.4725299835205078e+01 -3.8355201721191406e+01 -2.6447900390625000e+02 -6.0945100784301758e+00 -3.4077598571777344e+01 -2.6527801513671875e+02 -8.8916406631469727e+00 -3.4081802368164062e+01 -2.9469601440429688e+02 -7.3690400123596191e+00 -3.8817600250244141e+01 -2.6636099243164062e+02 -1.1661100387573242e+01 -3.4087501525878906e+01 -2.6768099975585938e+02 -1.4323499679565430e+01 -3.4094501495361328e+01 -2.6430099487304688e+02 -5.2714900970458984e+00 -3.4076602935791016e+01 -2.9469601440429688e+02 0.0000000000000000e+00 -3.8971900939941406e+01 -2.6389102172851562e+02 -2.5101900100708008e+00 -3.4074501037597656e+01 -2.6394000244140625e+02 2.9742100238800049e+00 -3.4074703216552734e+01 -2.6408499145507812e+02 4.0592498779296875e+00 -3.4075500488281250e+01 -2.9469601440429688e+02 7.3690400123596191e+00 -3.8817600250244141e+01 -2.6377200317382812e+02 2.3673000931739807e-01 -3.4073799133300781e+01 -2.6378198242187500e+02 0.0000000000000000e+00 -3.4073902130126953e+01 -2.6680899047851562e+02 1.2629699707031250e+01 -3.4089900970458984e+01 -2.6696301269531250e+02 1.2946000099182129e+01 -3.4090702056884766e+01 -2.9469601440429688e+02 1.4680099487304688e+01 -3.8357997894287109e+01 -2.6558700561523438e+02 9.7610301971435547e+00 -3.4083400726318359e+01 -2.6468200683593750e+02 6.9122300148010254e+00 -3.4078697204589844e+01 -2.9469601440429688e+02 2.2055599212646484e+01 -3.7585300445556641e+01 -2.9469601440429688e+02 2.8914300918579102e+01 -3.6582000732421875e+01 -2.8700500488281250e+02 2.8058099746704102e+01 -3.5488502502441406e+01 -2.7759201049804688e+02 2.7011299133300781e+01 -3.4146202087402344e+01 -2.9469601440429688e+02 1.4725299835205078e+01 -3.8355201721191406e+01 -2.7616098022460938e+02 2.5565401077270508e+01 -3.4138797760009766e+01 -2.7353601074218750e+02 2.2681501388549805e+01 -3.4125099182128906e+01 -2.7093499755859375e+02 1.9414400100708008e+01 -3.4111499786376953e+01 -2.6875201416015625e+02 1.6179300308227539e+01 -3.4100101470947266e+01 -2.6772497558593750e+02 1.4324200630187988e+01 -3.4094799041748047e+01 -3.0599798583984375e+02 6.1948097229003906e+01 -2.4900398254394531e+01 -3.0545300292968750e+02 6.2030597686767578e+01 -2.4891700744628906e+01 -3.0528701782226562e+02 3.7069999694824219e+01 -3.3995597839355469e+01 -3.0544299316406250e+02 3.7098499298095703e+01 -3.3985099792480469e+01 -3.0621499633789062e+02 3.7456401824951172e+01 -3.3841098785400391e+01 -3.0573599243164062e+02 3.7191303253173828e+01 -3.3948898315429688e+01 -2.0047399902343750e+02 5.5945796966552734e+01 -2.5084299087524414e+01 -1.9959199523925781e+02 5.4562900543212891e+01 -2.5063699722290039e+01 -1.9960600280761719e+02 5.4635902404785156e+01 -2.5065900802612305e+01 -2.0041300964355469e+02 5.5902202606201172e+01 -2.5084499359130859e+01 -2.0049899291992188e+02 5.4324298858642578e+01 -2.7793800354003906e+01 -2.0050199890136719e+02 5.4147197723388672e+01 -2.7896699905395508e+01 -1.9964399719238281e+02 5.2551399230957031e+01 -2.6997100830078125e+01 -1.9968501281738281e+02 5.2551399230957031e+01 -2.7057899475097656e+01 -1.9968899536132812e+02 5.2565196990966797e+01 -2.7055200576782227e+01 -2.0139599609375000e+02 5.2551399230957031e+01 -2.8904100418090820e+01 -2.0056900024414062e+02 5.2551399230957031e+01 -2.8353199005126953e+01 -2.0052699279785156e+02 5.2551399230957031e+01 -2.8292400360107422e+01 -2.0051400756835938e+02 5.3087200164794922e+01 -2.8257499694824219e+01 -2.0051200866699219e+02 5.3288097381591797e+01 -2.8218700408935547e+01 -2.0047999572753906e+02 5.5031600952148438e+01 -2.7204500198364258e+01 -2.0044999694824219e+02 5.5637599945068359e+01 -2.6259599685668945e+01 -2.0047500610351562e+02 5.5165599822998047e+01 -2.7047800064086914e+01 -2.0044100952148438e+02 5.5747596740722656e+01 -2.5962499618530273e+01 -1.9967199707031250e+02 5.2884399414062500e+01 -2.7039499282836914e+01 -1.9967100524902344e+02 5.3009597778320312e+01 -2.7015300750732422e+01 -1.9966499328613281e+02 5.3543998718261719e+01 -2.6815000534057617e+01 -1.9966299438476562e+02 5.3654102325439453e+01 -2.6751001358032227e+01 -1.9965000915527344e+02 5.4094097137451172e+01 -2.6384500503540039e+01 -1.9964698791503906e+02 5.4177501678466797e+01 -2.6287000656127930e+01 -1.9963101196289062e+02 5.4471099853515625e+01 -2.5796800613403320e+01 -1.9962400817871094e+02 5.4539600372314453e+01 -2.5611999511718750e+01 -2.0057600402832031e+02 -5.2551002502441406e+01 -2.8342201232910156e+01 -2.0051499938964844e+02 -5.2551002502441406e+01 -2.8300600051879883e+01 -1.9967300415039062e+02 -5.2551601409912109e+01 -2.7066198348999023e+01 -1.9965699768066406e+02 -5.2551601409912109e+01 -2.6994100570678711e+01 -2.0046900939941406e+02 -5.5319900512695312e+01 -2.6839799880981445e+01 -2.0046299743652344e+02 -5.5429100036621094e+01 -2.6669300079345703e+01 -1.9957899475097656e+02 -5.4565502166748047e+01 -2.5062601089477539e+01 -1.9961898803710938e+02 -5.4627998352050781e+01 -2.5063699722290039e+01 -1.9962300109863281e+02 -5.4624698638916016e+01 -2.5077600479125977e+01 -2.0118499755859375e+02 -5.6466400146484375e+01 -2.5084499359130859e+01 -2.0046600341796875e+02 -5.5956501007080078e+01 -2.5088699340820312e+01 -2.0042599487304688e+02 -5.5894100189208984e+01 -2.5087499618530273e+01 -2.0043000793457031e+02 -5.5835498809814453e+01 -2.5626199722290039e+01 -2.0043699645996094e+02 -5.5788299560546875e+01 -2.5823900222778320e+01 -2.0048999023437500e+02 -5.4701202392578125e+01 -2.7520999908447266e+01 -2.0050799560546875e+02 -5.3734802246093750e+01 -2.8084899902343750e+01 -2.0049400329589844e+02 -5.4540599822998047e+01 -2.7647100448608398e+01 -2.0051098632812500e+02 -5.3431999206542969e+01 -2.8182899475097656e+01 -1.9961700439453125e+02 -5.4594402313232422e+01 -2.5402400970458984e+01 -1.9962200927734375e+02 -5.4565002441406250e+01 -2.5525600433349609e+01 -1.9963900756835938e+02 -5.4341396331787109e+01 -2.6051599502563477e+01 -1.9964300537109375e+02 -5.4273502349853516e+01 -2.6157699584960938e+01 -1.9965699768066406e+02 -5.3888599395751953e+01 -2.6581300735473633e+01 -1.9965901184082031e+02 -5.3788700103759766e+01 -2.6659799575805664e+01 -1.9966900634765625e+02 -5.3287597656250000e+01 -2.6932100296020508e+01 -1.9967100524902344e+02 -5.3099300384521484e+01 -2.6993000030517578e+01 -3.0528799438476562e+02 -3.7070198059082031e+01 -3.3995502471923828e+01 -3.0548797607421875e+02 -5.2551300048828125e+01 -3.3980998992919922e+01 -3.0640100097656250e+02 -3.7594699859619141e+01 -3.3782096862792969e+01 -3.0592199707031250e+02 -3.7278202056884766e+01 -3.3914302825927734e+01 -3.0544299316406250e+02 -3.7098499298095703e+01 -3.3985099792480469e+01 -3.0599798583984375e+02 -6.1948097229003906e+01 -2.4900398254394531e+01 -3.0545300292968750e+02 -6.2030597686767578e+01 -2.4891700744628906e+01 -2.1344799804687500e+02 6.2030597686767578e+01 -2.4891700744628906e+01 -2.1290100097656250e+02 6.1948097229003906e+01 -2.4900398254394531e+01 -2.1257600402832031e+02 -5.2550800323486328e+01 -3.3807800292968750e+01 -2.1290100097656250e+02 -6.1948097229003906e+01 -2.4900398254394531e+01 -2.1344799804687500e+02 -6.2030597686767578e+01 -2.4891700744628906e+01 -3.0508300781250000e+02 -2.9491600036621094e+01 -3.7378700256347656e+01 -3.0040698242187500e+02 -2.9354600906372070e+01 -3.7189800262451172e+01 -2.9933200073242188e+02 -2.9294698715209961e+01 -3.7107299804687500e+01 -3.0030999755859375e+02 -2.9349100112915039e+01 -3.7182300567626953e+01 -3.0030999755859375e+02 -2.2138799667358398e+01 -3.8244602203369141e+01 -3.0030999755859375e+02 2.2138799667358398e+01 -3.8244602203369141e+01 -3.0030999755859375e+02 2.9349100112915039e+01 -3.7182300567626953e+01 -2.9933200073242188e+02 2.9294698715209961e+01 -3.7107299804687500e+01 -3.0508300781250000e+02 2.9491600036621094e+01 -3.7378700256347656e+01 -3.0040698242187500e+02 2.9354600906372070e+01 -3.7189800262451172e+01 -3.0030999755859375e+02 -1.4780799865722656e+01 -3.9017402648925781e+01 -3.0030999755859375e+02 -7.3968801498413086e+00 -3.9481498718261719e+01 -3.0030999755859375e+02 0.0000000000000000e+00 -3.9636398315429688e+01 -3.0030999755859375e+02 7.3968801498413086e+00 -3.9481498718261719e+01 -3.0030999755859375e+02 1.4780799865722656e+01 -3.9017402648925781e+01 -2.8689001464843750e+02 3.0040201187133789e+01 -3.4792697906494141e+01 -2.8584100341796875e+02 2.9789199829101562e+01 -3.4720500946044922e+01 -2.8281701660156250e+02 2.8966499328613281e+01 -3.4511600494384766e+01 -2.8097799682617188e+02 2.8396800994873047e+01 -3.4383899688720703e+01 -2.7940100097656250e+02 2.7835700988769531e+01 -3.4273899078369141e+01 -2.7810998535156250e+02 2.7281299591064453e+01 -3.4182998657226562e+01 -2.9461602783203125e+02 3.0675298690795898e+01 -3.5801601409912109e+01 -2.9000100708007812e+02 3.0784000396728516e+01 -3.5006797790527344e+01 -2.9456698608398438e+02 3.1762800216674805e+01 -3.5319599151611328e+01 -3.0669201660156250e+02 3.2977199554443359e+01 -3.5601299285888672e+01 -3.0595898437500000e+02 3.2928897857666016e+01 -3.5648403167724609e+01 -3.0595898437500000e+02 3.2276298522949219e+01 -3.6113399505615234e+01 -3.0788900756835938e+02 3.3115100860595703e+01 -3.5461101531982422e+01 -3.1529800415039062e+02 3.2293300628662109e+01 -3.6118000030517578e+01 -3.0907299804687500e+02 3.3317001342773438e+01 -3.5239398956298828e+01 -3.1529901123046875e+02 3.2509597778320312e+01 -3.6020099639892578e+01 -3.1222000122070312e+02 3.3852802276611328e+01 -3.4530700683593750e+01 -3.1532897949218750e+02 3.4250801086425781e+01 -3.3830501556396484e+01 -3.0595898437500000e+02 3.1353801727294922e+01 -3.6770500183105469e+01 -2.9682098388671875e+02 3.2186698913574219e+01 -3.5444301605224609e+01 -2.9926602172851562e+02 3.1144001007080078e+01 -3.6492298126220703e+01 -3.0035202026367188e+02 3.1206699371337891e+01 -3.6575500488281250e+01 -2.9995999145507812e+02 3.2603801727294922e+01 -3.5571601867675781e+01 -2.9925799560546875e+02 3.2510501861572266e+01 -3.5543098449707031e+01 -3.0507400512695312e+02 3.2899600982666016e+01 -3.5664699554443359e+01 -3.0169601440429688e+02 3.2755901336669922e+01 -3.5619197845458984e+01 -3.0034500122070312e+02 3.2637500762939453e+01 -3.5582199096679688e+01 -3.0560202026367188e+02 3.2913902282714844e+01 -3.5661602020263672e+01 -3.0507400512695312e+02 3.1350097656250000e+01 -3.6765697479248047e+01 -3.0517199707031250e+02 3.2903701782226562e+01 -3.5666000366210938e+01 -2.9461602783203125e+02 -3.0675298690795898e+01 -3.5801601409912109e+01 -2.8230398559570312e+02 -2.8814399719238281e+01 -3.4476001739501953e+01 -2.8271200561523438e+02 -2.8935701370239258e+01 -3.4504302978515625e+01 -2.7855300903320312e+02 -2.7485898971557617e+01 -3.4214298248291016e+01 -2.8001699829101562e+02 -2.8065700531005859e+01 -3.4316902160644531e+01 -2.8634197998046875e+02 -2.9916200637817383e+01 -3.4755100250244141e+01 -2.8689001464843750e+02 -3.0043498992919922e+01 -3.4792697906494141e+01 -2.9150097656250000e+02 -3.1116201400756836e+01 -3.5109600067138672e+01 -2.9456698608398438e+02 -3.1762800216674805e+01 -3.5319599151611328e+01 -3.0595898437500000e+02 -3.2276298522949219e+01 -3.6113399505615234e+01 -3.0595898437500000e+02 -3.2928897857666016e+01 -3.5648403167724609e+01 -3.0715798950195312e+02 -3.3022399902343750e+01 -3.5556301116943359e+01 -3.0835400390625000e+02 -3.3186996459960938e+01 -3.5384498596191406e+01 -3.1529800415039062e+02 -3.2267101287841797e+01 -3.6127399444580078e+01 -3.0907299804687500e+02 -3.3317001342773438e+01 -3.5239398956298828e+01 -3.1222000122070312e+02 -3.3852802276611328e+01 -3.4530700683593750e+01 -3.1532897949218750e+02 -3.4250801086425781e+01 -3.3830501556396484e+01 -3.1529501342773438e+02 -3.2087299346923828e+01 -3.6335502624511719e+01 -3.0595898437500000e+02 -3.1353801727294922e+01 -3.6770500183105469e+01 -2.9926602172851562e+02 -3.1144001007080078e+01 -3.6492298126220703e+01 -3.0560498046875000e+02 -3.2914001464843750e+01 -3.5661499023437500e+01 -3.0517199707031250e+02 -3.2903701782226562e+01 -3.5666000366210938e+01 -3.0507400512695312e+02 -3.1350097656250000e+01 -3.6765697479248047e+01 -3.0507400512695312e+02 -3.2899600982666016e+01 -3.5664699554443359e+01 -3.0169601440429688e+02 -3.2755901336669922e+01 -3.5619197845458984e+01 -3.0035202026367188e+02 -3.1206699371337891e+01 -3.6575500488281250e+01 -3.0034500122070312e+02 -3.2637500762939453e+01 -3.5582199096679688e+01 -2.9995999145507812e+02 -3.2603801727294922e+01 -3.5571601867675781e+01 -2.9925799560546875e+02 -3.2510501861572266e+01 -3.5543098449707031e+01 -2.9682202148437500e+02 -3.2186698913574219e+01 -3.5444301605224609e+01 -3.1683001708984375e+02 3.8443199157714844e+01 -2.9624401092529297e+01 -3.1678302001953125e+02 3.8261398315429688e+01 -2.9739498138427734e+01 -3.1394400024414062e+02 3.7681198120117188e+01 -3.0980100631713867e+01 -3.1399099731445312e+02 3.7493198394775391e+01 -3.1000999450683594e+01 -3.1633099365234375e+02 3.6504699707031250e+01 -3.0851699829101562e+01 -3.1621798706054688e+02 3.6215599060058594e+01 -3.1184200286865234e+01 -3.1468701171875000e+02 3.5904800415039062e+01 -3.1868497848510742e+01 -3.1482800292968750e+02 3.5584598541259766e+01 -3.2043399810791016e+01 -3.1569702148437500e+02 3.4878299713134766e+01 -3.2722301483154297e+01 -3.1554098510742188e+02 3.4573997497558594e+01 -3.3218997955322266e+01 -3.1045098876953125e+02 3.6893199920654297e+01 -3.2433597564697266e+01 -3.1543600463867188e+02 3.4407798767089844e+01 -3.3521900177001953e+01 -3.1127899169921875e+02 3.5149299621582031e+01 -3.3205402374267578e+01 -3.0816702270507812e+02 3.4566200256347656e+01 -3.4233600616455078e+01 -3.0775698852539062e+02 3.5345302581787109e+01 -3.3963699340820312e+01 -3.0734597778320312e+02 3.6124401092529297e+01 -3.3693702697753906e+01 -3.0568099975585938e+02 3.4848102569580078e+01 -3.4407897949218750e+01 -3.0617401123046875e+02 3.4907798767089844e+01 -3.4347999572753906e+01 -3.0697100830078125e+02 3.5075798034667969e+01 -3.4172199249267578e+01 -3.0543499755859375e+02 3.4829299926757812e+01 -3.4424701690673828e+01 -3.0513800048828125e+02 3.4817100524902344e+01 -3.4432003021240234e+01 -2.9407000732421875e+02 3.3455902099609375e+01 -3.4339500427246094e+01 -2.9642599487304688e+02 3.3966197967529297e+01 -3.4372600555419922e+01 -2.9970300292968750e+02 3.4463001251220703e+01 -3.4406700134277344e+01 -3.0151300048828125e+02 3.4642902374267578e+01 -3.4419498443603516e+01 -2.8949801635742188e+02 3.2291000366210938e+01 -3.4257198333740234e+01 -2.7712500000000000e+02 2.7469999313354492e+01 -3.4036598205566406e+01 -2.7763699340820312e+02 2.7836399078369141e+01 -3.4045902252197266e+01 -2.7891601562500000e+02 2.8576499938964844e+01 -3.4068801879882812e+01 -2.8048397827148438e+02 2.9310298919677734e+01 -3.4096698760986328e+01 -2.8231701660156250e+02 3.0041299819946289e+01 -3.4129299163818359e+01 -2.8533599853515625e+02 3.1074399948120117e+01 -3.4182899475097656e+01 -2.7712301635742188e+02 -2.7472799301147461e+01 -3.4073101043701172e+01 -2.9407000732421875e+02 -3.3455902099609375e+01 -3.4339500427246094e+01 -2.9099899291992188e+02 -3.2689899444580078e+01 -3.4284099578857422e+01 -2.8583801269531250e+02 -3.1231601715087891e+01 -3.4191799163818359e+01 -2.8221197509765625e+02 -3.0002099990844727e+01 -3.4127399444580078e+01 -2.8180502319335938e+02 -2.9847400665283203e+01 -3.4120197296142578e+01 -2.7952798461914062e+02 -2.8879199981689453e+01 -3.4079700469970703e+01 -2.7807501220703125e+02 -2.8111499786376953e+01 -3.4053798675537109e+01 -2.9642599487304688e+02 -3.3966197967529297e+01 -3.4372600555419922e+01 -2.9970300292968750e+02 -3.4463001251220703e+01 -3.4406700134277344e+01 -3.0151300048828125e+02 -3.4642902374267578e+01 -3.4419498443603516e+01 -3.0513800048828125e+02 -3.4817100524902344e+01 -3.4432003021240234e+01 -3.0543701171875000e+02 -3.4829399108886719e+01 -3.4424499511718750e+01 -3.0568099975585938e+02 -3.4848102569580078e+01 -3.4407897949218750e+01 -3.0818301391601562e+02 -3.4651901245117188e+01 -3.4345397949218750e+01 -3.0739199829101562e+02 -3.6155200958251953e+01 -3.3824600219726562e+01 -3.0727600097656250e+02 -3.5162097930908203e+01 -3.4077499389648438e+01 -3.0774099731445312e+02 -3.5315299987792969e+01 -3.3901199340820312e+01 -3.0648602294921875e+02 -3.4963203430175781e+01 -3.4291301727294922e+01 -3.1468701171875000e+02 -3.5904800415039062e+01 -3.1868497848510742e+01 -3.1482800292968750e+02 -3.5584598541259766e+01 -3.2043399810791016e+01 -3.1127899169921875e+02 -3.5149299621582031e+01 -3.3205402374267578e+01 -3.1554098510742188e+02 -3.4573997497558594e+01 -3.3218997955322266e+01 -3.1543600463867188e+02 -3.4407798767089844e+01 -3.3521900177001953e+01 -3.1399099731445312e+02 -3.7493198394775391e+01 -3.1000999450683594e+01 -3.1045098876953125e+02 -3.6893199920654297e+01 -3.2433597564697266e+01 -3.1394400024414062e+02 -3.7681198120117188e+01 -3.0980100631713867e+01 -3.1620498657226562e+02 -3.6125202178955078e+01 -3.1200901031494141e+01 -3.1622299194335938e+02 -3.6188499450683594e+01 -3.1155200958251953e+01 -3.1675000000000000e+02 -3.8069698333740234e+01 -2.9797901153564453e+01 -3.1678198242187500e+02 -3.8254299163818359e+01 -2.9742099761962891e+01 -3.1711099243164062e+02 -4.0165802001953125e+01 -2.9165201187133789e+01 -3.1770501708984375e+02 -5.6500598907470703e+01 -2.5082599639892578e+01 -3.1818499755859375e+02 -5.6190700531005859e+01 -2.5083501815795898e+01 -3.1945401000976562e+02 -5.4144901275634766e+01 -2.5047899246215820e+01 -3.1928302001953125e+02 -5.4538497924804688e+01 -2.5057300567626953e+01 -3.1925000000000000e+02 -5.4616897583007812e+01 -2.5059200286865234e+01 -3.1895199584960938e+02 -5.5303997039794922e+01 -2.5075599670410156e+01 -3.1845700073242188e+02 -5.5876399993896484e+01 -2.5080699920654297e+01 -3.1840100097656250e+02 -5.5940898895263672e+01 -2.5081199645996094e+01 -3.1840100097656250e+02 -5.4324298858642578e+01 -2.7793800354003906e+01 -3.1839801025390625e+02 -5.4147197723388672e+01 -2.7896699905395508e+01 -3.1819702148437500e+02 -5.2551601409912109e+01 -2.8476800918579102e+01 -3.1899197387695312e+02 -5.2551898956298828e+01 -2.7522899627685547e+01 -3.1836102294921875e+02 -5.2551700592041016e+01 -2.8280298233032227e+01 -3.1838598632812500e+02 -5.3087200164794922e+01 -2.8257499694824219e+01 -3.1831298828125000e+02 -5.2551700592041016e+01 -2.8337699890136719e+01 -3.1923699951171875e+02 -5.4602802276611328e+01 -2.5102098464965820e+01 -3.1844900512695312e+02 -5.5862400054931641e+01 -2.5115699768066406e+01 -3.1845001220703125e+02 -5.5637599945068359e+01 -2.6259599685668945e+01 -3.1922799682617188e+02 -5.2884399414062500e+01 -2.7039499282836914e+01 -3.1918298339843750e+02 -5.2551998138427734e+01 -2.7048700332641602e+01 -3.1945602416992188e+02 -5.2552200317382812e+01 -2.6371799468994141e+01 -3.1921099853515625e+02 -5.2551998138427734e+01 -2.6979000091552734e+01 -3.1838800048828125e+02 -5.3288097381591797e+01 -2.8218700408935547e+01 -3.1841998291015625e+02 -5.5031600952148438e+01 -2.7204500198364258e+01 -3.1842498779296875e+02 -5.5165901184082031e+01 -2.7047399520874023e+01 -3.1922900390625000e+02 -5.3009597778320312e+01 -2.7015300750732422e+01 -3.1923498535156250e+02 -5.3543998718261719e+01 -2.6815000534057617e+01 -3.1923699951171875e+02 -5.3654102325439453e+01 -2.6751001358032227e+01 -3.1925000000000000e+02 -5.4094097137451172e+01 -2.6384500503540039e+01 -3.1925299072265625e+02 -5.4177799224853516e+01 -2.6286701202392578e+01 -3.1926901245117188e+02 -5.4471099853515625e+01 -2.5796800613403320e+01 -3.1832400512695312e+02 -4.0492099761962891e+01 -2.8342201232910156e+01 -3.1924301147460938e+02 -4.0492099761962891e+01 -2.6994100570678711e+01 -3.1838500976562500e+02 -4.0492099761962891e+01 -2.8300600051879883e+01 -3.1922702026367188e+02 -4.0492099761962891e+01 -2.7066198348999023e+01 -3.1836599731445312e+02 -4.0116100311279297e+01 -2.8330299377441406e+01 -3.1922097778320312e+02 -4.0044399261474609e+01 -2.7091300964355469e+01 -3.1816598510742188e+02 -3.7736099243164062e+01 -2.9069601058959961e+01 -3.1914599609375000e+02 -3.7211700439453125e+01 -2.7881299972534180e+01 -3.1784899902343750e+02 -3.5614898681640625e+01 -3.0690200805664062e+01 -3.1901101684570312e+02 -3.4681098937988281e+01 -2.9691101074218750e+01 -3.1744198608398438e+02 -3.4043201446533203e+01 -3.2974399566650391e+01 -3.1882901000976562e+02 -3.2791900634765625e+01 -3.2289299011230469e+01 -3.1737701416015625e+02 -3.3890998840332031e+01 -3.3312400817871094e+01 -3.1879998779296875e+02 -3.2607700347900391e+01 -3.2673599243164062e+01 -3.1730999755859375e+02 -3.3751201629638672e+01 -3.3655300140380859e+01 -3.1877099609375000e+02 -3.2438503265380859e+01 -3.3064201354980469e+01 -3.1871899414062500e+02 -3.0938100814819336e+01 -3.4778697967529297e+01 -3.1869799804687500e+02 -2.9155399322509766e+01 -3.5492599487304688e+01 -3.1726101684570312e+02 -3.1763099670410156e+01 -3.5931098937988281e+01 -3.1724102783203125e+02 -2.9398300170898438e+01 -3.6879402160644531e+01 -3.1724102783203125e+02 2.9398300170898438e+01 -3.6879402160644531e+01 -3.1869799804687500e+02 2.9155399322509766e+01 -3.5492599487304688e+01 -3.1720599365234375e+02 2.2470500946044922e+01 -3.7908901214599609e+01 -3.1866299438476562e+02 2.2284799575805664e+01 -3.6513702392578125e+01 -3.1715899658203125e+02 5.1750497817993164e+00 -3.9269599914550781e+01 -3.1717102050781250e+02 -1.2170399665832520e+01 -3.8925300598144531e+01 -3.1861599731445312e+02 5.1322598457336426e+00 -3.7863101959228516e+01 -3.1862802124023438e+02 -1.2069800376892090e+01 -3.7521701812744141e+01 -3.1872601318359375e+02 3.1229398727416992e+01 -3.4563400268554688e+01 -3.1877099609375000e+02 3.2438503265380859e+01 -3.3064201354980469e+01 -3.1726699829101562e+02 3.2149398803710938e+01 -3.5645401000976562e+01 -3.1730999755859375e+02 3.3751201629638672e+01 -3.3655300140380859e+01 -3.1737701416015625e+02 3.3890998840332031e+01 -3.3312400817871094e+01 -3.1879998779296875e+02 3.2607700347900391e+01 -3.2673599243164062e+01 -3.1744198608398438e+02 3.4043201446533203e+01 -3.2974399566650391e+01 -3.1882901000976562e+02 3.2791900634765625e+01 -3.2289299011230469e+01 -3.1887298583984375e+02 3.3147399902343750e+01 -3.1652399063110352e+01 -3.1753997802734375e+02 3.4337497711181641e+01 -3.2417697906494141e+01 -3.1792300415039062e+02 3.6019401550292969e+01 -3.0289100646972656e+01 -3.1904400634765625e+02 3.5164699554443359e+01 -2.9239698410034180e+01 -3.1916497802734375e+02 3.7710102081298828e+01 -2.7659698486328125e+01 -3.1821099853515625e+02 3.8154697418212891e+01 -2.8867500305175781e+01 -3.1924301147460938e+02 4.0492099761962891e+01 -2.6994100570678711e+01 -3.1922702026367188e+02 4.0492099761962891e+01 -2.7066198348999023e+01 -3.1838500976562500e+02 4.0492099761962891e+01 -2.8300600051879883e+01 -3.1832400512695312e+02 4.0492099761962891e+01 -2.8342201232910156e+01 -3.1832400512695312e+02 5.2551002502441406e+01 -2.8342201232910156e+01 -3.1838500976562500e+02 5.2551002502441406e+01 -2.8300600051879883e+01 -3.1922702026367188e+02 5.2551601409912109e+01 -2.7066198348999023e+01 -3.1924301147460938e+02 5.2551601409912109e+01 -2.6994100570678711e+01 -3.1843099975585938e+02 5.5319900512695312e+01 -2.6839799880981445e+01 -3.1843701171875000e+02 5.5429100036621094e+01 -2.6669300079345703e+01 -3.1932101440429688e+02 5.4565502166748047e+01 -2.5062601089477539e+01 -3.1928100585937500e+02 5.4627998352050781e+01 -2.5063699722290039e+01 -3.1927697753906250e+02 5.4624698638916016e+01 -2.5077600479125977e+01 -3.1771499633789062e+02 5.6466400146484375e+01 -2.5084499359130859e+01 -3.1843399047851562e+02 5.5956501007080078e+01 -2.5088699340820312e+01 -3.1847399902343750e+02 5.5894100189208984e+01 -2.5087499618530273e+01 -3.1847000122070312e+02 5.5835498809814453e+01 -2.5626199722290039e+01 -3.1846301269531250e+02 5.5788299560546875e+01 -2.5823900222778320e+01 -3.1841000366210938e+02 5.4701202392578125e+01 -2.7520999908447266e+01 -3.1839199829101562e+02 5.3734802246093750e+01 -2.8084899902343750e+01 -3.1840597534179688e+02 5.4540599822998047e+01 -2.7647100448608398e+01 -3.1838900756835938e+02 5.3431999206542969e+01 -2.8182899475097656e+01 -3.1928302001953125e+02 5.4594402313232422e+01 -2.5402400970458984e+01 -3.1927801513671875e+02 5.4565002441406250e+01 -2.5525600433349609e+01 -3.1926101684570312e+02 5.4341396331787109e+01 -2.6051599502563477e+01 -3.1925698852539062e+02 5.4273502349853516e+01 -2.6157699584960938e+01 -3.1924301147460938e+02 5.3888599395751953e+01 -2.6581300735473633e+01 -3.1923999023437500e+02 5.3788700103759766e+01 -2.6659799575805664e+01 -3.1923101806640625e+02 5.3287597656250000e+01 -2.6932100296020508e+01 -3.1922900390625000e+02 5.3099300384521484e+01 -2.6993000030517578e+01 -3.0595898437500000e+02 2.9161800384521484e+01 -3.5411499023437500e+01 -3.1528100585937500e+02 2.9161800384521484e+01 -3.5411499023437500e+01 -3.0595898437500000e+02 2.1916101455688477e+01 -3.6480503082275391e+01 -3.1524700927734375e+02 2.2581899642944336e+01 -3.6395198822021484e+01 -3.0595898437500000e+02 1.4632100105285645e+01 -3.7245502471923828e+01 -3.1522500610351562e+02 1.4615099906921387e+01 -3.7033401489257812e+01 -3.0595898437500000e+02 7.3224902153015137e+00 -3.7705101013183594e+01 -3.1519897460937500e+02 5.3296699523925781e+00 -3.7777099609375000e+01 -3.0595898437500000e+02 0.0000000000000000e+00 -3.7858299255371094e+01 -3.1520300292968750e+02 3.4686098806560040e-03 -3.7675899505615234e+01 -3.0595898437500000e+02 -7.3224902153015137e+00 -3.7705101013183594e+01 -3.1521099853515625e+02 -1.1974599838256836e+01 -3.7448200225830078e+01 -3.0595898437500000e+02 -1.4632100105285645e+01 -3.7245502471923828e+01 -3.1522100830078125e+02 -1.4619000434875488e+01 -3.7134799957275391e+01 -3.0595898437500000e+02 -2.1916101455688477e+01 -3.6480503082275391e+01 -3.1528100585937500e+02 -2.9161800384521484e+01 -3.5411499023437500e+01 -3.0595898437500000e+02 -2.9161800384521484e+01 -3.5411499023437500e+01 -2.9350997924804688e+02 -3.5365100860595703e+01 -3.2000000000000000e+01 -2.9603698730468750e+02 -3.6012096405029297e+01 -3.2000000000000000e+01 -3.0509899902343750e+02 -5.2551399230957031e+01 -3.2000000000000000e+01 -2.8179400634765625e+02 3.1164501190185547e+01 -3.2000000000000000e+01 -2.8000198364257812e+02 3.0270000457763672e+01 -3.2000000000000000e+01 -2.1380099487304688e+02 5.2551399230957031e+01 -3.2000000000000000e+01 -2.7751202392578125e+02 -2.8689699172973633e+01 -3.2000000000000000e+01 -2.7881301879882812e+02 -2.9584899902343750e+01 -3.2000000000000000e+01 -2.1380099487304688e+02 -5.2551399230957031e+01 -3.2000000000000000e+01 -2.8089099121093750e+02 -3.0730400085449219e+01 -3.2000000000000000e+01 -2.9940499877929688e+02 -3.6613899230957031e+01 -3.2000000000000000e+01 -3.0136801147460938e+02 -3.6843200683593750e+01 -3.2000000000000000e+01 -3.0509899902343750e+02 -3.7052398681640625e+01 -3.2000000000000000e+01 -2.9940499877929688e+02 3.6613899230957031e+01 -3.2000000000000000e+01 -3.0509899902343750e+02 5.2551399230957031e+01 -3.2000000000000000e+01 -3.0136801147460938e+02 3.6843200683593750e+01 -3.2000000000000000e+01 -3.0509899902343750e+02 3.7052398681640625e+01 -3.2000000000000000e+01 -2.8485400390625000e+02 3.2464702606201172e+01 -3.2000000000000000e+01 -2.6372299194335938e+02 7.0707201957702637e+00 -3.2000000000000000e+01 -2.6314700317382812e+02 4.1997399330139160e+00 -3.2000000000000000e+01 -2.6297598266601562e+02 2.8444499969482422e+00 -3.2000000000000000e+01 -2.6283200073242188e+02 9.1832995414733887e-02 -3.2000000000000000e+01 -2.8169000244140625e+02 -3.1115900039672852e+01 -3.2000000000000000e+01 -2.8519799804687500e+02 -3.2598201751708984e+01 -3.2000000000000000e+01 -2.9023599243164062e+02 -3.4361297607421875e+01 -3.2000000000000000e+01 -2.6989801025390625e+02 1.9942600250244141e+01 -3.2000000000000000e+01 -2.6776998901367188e+02 1.6664199829101562e+01 -3.2000000000000000e+01 -2.6602398681640625e+02 1.3392700195312500e+01 -3.2000000000000000e+01 -2.6295999145507812e+02 -2.6725499629974365e+00 -3.2000000000000000e+01 -2.6336199951171875e+02 -5.4538798332214355e+00 -3.2000000000000000e+01 -2.6359600830078125e+02 -6.5495400428771973e+00 -3.2000000000000000e+01 -2.6439602661132812e+02 -9.3712205886840820e+00 -3.2000000000000000e+01 -2.6546902465820312e+02 -1.2171699523925781e+01 -3.2000000000000000e+01 -2.6681100463867188e+02 -1.4954999923706055e+01 -3.2000000000000000e+01 -2.6576300048828125e+02 1.2831999778747559e+01 -3.2000000000000000e+01 -2.6459197998046875e+02 9.9398498535156250e+00 -3.2000000000000000e+01 -2.9603601074218750e+02 3.6012096405029297e+01 -3.2000000000000000e+01 -2.9350997924804688e+02 3.5365100860595703e+01 -3.2000000000000000e+01 -2.8897500610351562e+02 3.3948600769042969e+01 -3.2000000000000000e+01 -2.7848101806640625e+02 2.9374700546264648e+01 -3.2000000000000000e+01 -2.7724600219726562e+02 2.8476501464843750e+01 -3.2000000000000000e+01 -2.7665298461914062e+02 2.7934400558471680e+01 -3.2000000000000000e+01 -2.7120001220703125e+02 -2.1709899902343750e+01 -3.2000000000000000e+01 -2.7378601074218750e+02 -2.4852399826049805e+01 -3.2000000000000000e+01 -2.7665298461914062e+02 -2.7934400558471680e+01 -3.2000000000000000e+01 -2.7522201538085938e+02 2.6440198898315430e+01 -3.2000000000000000e+01 -2.7243301391601562e+02 2.3259901046752930e+01 -3.2000000000000000e+01 -2.6841000366210938e+02 -1.7713901519775391e+01 -3.2000000000000000e+01 -2.6892300415039062e+02 -1.8512500762939453e+01 -3.2000000000000000e+01 -3.1753399658203125e+02 3.6906799316406250e+01 -2.6227399826049805e+01 -3.1755798339843750e+02 4.0492099761962891e+01 -2.5539299011230469e+01 -3.1757901000976562e+02 5.3162197113037109e+01 -2.4944198608398438e+01 -3.1755798339843750e+02 5.2552303314208984e+01 -2.5539299011230469e+01 -3.1755999755859375e+02 5.2767799377441406e+01 -2.5499601364135742e+01 -3.1756298828125000e+02 5.2943901062011719e+01 -2.5396398544311523e+01 -3.1757901000976562e+02 -5.3161800384521484e+01 -2.4951599121093750e+01 -3.1757101440429688e+02 -5.3114196777343750e+01 -2.5165800094604492e+01 -3.1756500244140625e+02 -5.3004001617431641e+01 -2.5338500976562500e+01 -3.1757901000976562e+02 5.3161800384521484e+01 -2.4951599121093750e+01 -3.1757501220703125e+02 5.3150096893310547e+01 -2.5049098968505859e+01 -3.1756900024414062e+02 5.3076400756835938e+01 -2.5240499496459961e+01 -3.1734298706054688e+02 -3.0885299682617188e+01 -3.1698598861694336e+01 -3.1735800170898438e+02 3.1129400253295898e+01 -3.1263500213623047e+01 -3.1735800170898438e+02 -3.1129400253295898e+01 -3.1263500213623047e+01 -3.1746499633789062e+02 3.3643997192382812e+01 -2.8218299865722656e+01 -3.1746600341796875e+02 -3.3698497772216797e+01 -2.8171100616455078e+01 -3.1753601074218750e+02 -3.7030799865722656e+01 -2.6179901123046875e+01 -3.1755798339843750e+02 -4.0492099761962891e+01 -2.5539299011230469e+01 -3.1757901000976562e+02 -5.3162197113037109e+01 -2.4944198608398438e+01 -3.1755798339843750e+02 -5.2552303314208984e+01 -2.5539299011230469e+01 -3.1755798339843750e+02 -5.2648700714111328e+01 -2.5531400680541992e+01 -3.1756100463867188e+02 -5.2842800140380859e+01 -2.5465299606323242e+01 -3.1720999145507812e+02 -1.1837700843811035e+01 -3.5522598266601562e+01 -3.1719799804687500e+02 5.2687497138977051e+00 -3.5847801208496094e+01 -3.1734298706054688e+02 3.0885299682617188e+01 -3.1698598861694336e+01 -3.1724600219726562e+02 2.2323801040649414e+01 -3.4481800079345703e+01 -3.1732800292968750e+02 3.0657600402832031e+01 -3.2142700195312500e+01 -3.1727999877929688e+02 2.8828599929809570e+01 -3.3509300231933594e+01 -3.1729901123046875e+02 3.0004798889160156e+01 -3.2970996856689453e+01 -3.1729400634765625e+02 -2.9807399749755859e+01 -3.3118400573730469e+01 -3.1727999877929688e+02 -2.8828599929809570e+01 -3.3509300231933594e+01 -3.1732800292968750e+02 -3.0657600402832031e+01 -3.2142700195312500e+01 -3.0904098510742188e+02 3.8875099182128906e+01 -3.0472299575805664e+01 -3.0589398193359375e+02 3.7844799041748047e+01 -3.1835298538208008e+01 -3.0589398193359375e+02 5.2551399230957031e+01 -3.1835298538208008e+01 -3.1635400390625000e+02 5.2551399230957031e+01 -2.7304800033569336e+01 -3.1635400390625000e+02 4.0492099761962891e+01 -2.7304800033569336e+01 -3.1263400268554688e+02 3.9740798950195312e+01 -2.8916099548339844e+01 -3.1635400390625000e+02 -4.0492099761962891e+01 -2.7304800033569336e+01 -3.1635400390625000e+02 -5.2551399230957031e+01 -2.7304800033569336e+01 -3.1263400268554688e+02 -3.9740798950195312e+01 -2.8916099548339844e+01 -3.0589398193359375e+02 -5.2551399230957031e+01 -3.1835298538208008e+01 -3.0904098510742188e+02 -3.8875099182128906e+01 -3.0472299575805664e+01 -3.0589398193359375e+02 -3.7844799041748047e+01 -3.1835298538208008e+01 -2.1376701354980469e+02 -6.0045101165771484e+01 -2.4807300567626953e+01 -3.0513299560546875e+02 -6.0045101165771484e+01 -2.4807300567626953e+01 -3.0511502075195312e+02 -5.8917602539062500e+01 -2.8465000152587891e+01 -3.0511901855468750e+02 -5.9351600646972656e+01 -2.7663400650024414e+01 -2.1377999877929688e+02 -5.9384597778320312e+01 -2.7580400466918945e+01 -3.0511999511718750e+02 -5.9380298614501953e+01 -2.7578899383544922e+01 -2.1377400207519531e+02 -5.9881401062011719e+01 -2.6087499618530273e+01 -3.0512600708007812e+02 -5.9871200561523438e+01 -2.6134201049804688e+01 -2.1376899719238281e+02 -6.0019798278808594e+01 -2.5187799453735352e+01 -2.1377999877929688e+02 -5.9371097564697266e+01 -2.7621200561523438e+01 -2.1378498840332031e+02 -5.8786102294921875e+01 -2.8668699264526367e+01 -3.0510900878906250e+02 -5.7922199249267578e+01 -2.9734800338745117e+01 -2.1379100036621094e+02 -5.7746601104736328e+01 -2.9909198760986328e+01 -3.0510900878906250e+02 -5.7746601104736328e+01 -2.9909198760986328e+01 -3.0510900878906250e+02 -5.7744701385498047e+01 -2.9910699844360352e+01 -3.0510101318359375e+02 -5.5348899841308594e+01 -3.1453300476074219e+01 -3.0510101318359375e+02 -5.5394702911376953e+01 -3.1440101623535156e+01 -2.1379600524902344e+02 -5.6349899291992188e+01 -3.0966899871826172e+01 -3.0510397338867188e+02 -5.6465099334716797e+01 -3.0897899627685547e+01 -2.1379399108886719e+02 -5.7100799560546875e+01 -3.0462600708007812e+01 -2.1379100036621094e+02 -5.7744701385498047e+01 -2.9910799026489258e+01 -2.1379899597167969e+02 -5.5334999084472656e+01 -3.1424001693725586e+01 -2.1380000305175781e+02 -5.4876300811767578e+01 -3.1630601882934570e+01 -3.0509899902343750e+02 -5.3841800689697266e+01 -3.1888101577758789e+01 -2.1380099487304688e+02 -5.3858501434326172e+01 -3.1885198593139648e+01 -3.0509899902343750e+02 -5.2937198638916016e+01 -3.1990098953247070e+01 -3.0510397338867188e+02 5.6349899291992188e+01 -3.0966899871826172e+01 -3.0510101318359375e+02 5.5334999084472656e+01 -3.1424001693725586e+01 -2.1379899597167969e+02 5.5348899841308594e+01 -3.1453300476074219e+01 -3.0510000610351562e+02 5.4876300811767578e+01 -3.1630601882934570e+01 -2.1380099487304688e+02 5.3841800689697266e+01 -3.1888101577758789e+01 -3.0509899902343750e+02 5.3858501434326172e+01 -3.1885198593139648e+01 -2.1380099487304688e+02 5.2937198638916016e+01 -3.1990098953247070e+01 -2.1379800415039062e+02 5.5394702911376953e+01 -3.1440101623535156e+01 -2.1379600524902344e+02 5.6465099334716797e+01 -3.0897899627685547e+01 -3.0510601806640625e+02 5.7100799560546875e+01 -3.0462600708007812e+01 -2.1379100036621094e+02 5.7744701385498047e+01 -2.9910699844360352e+01 -3.0510900878906250e+02 5.7744701385498047e+01 -2.9910799026489258e+01 -3.0510900878906250e+02 5.7746601104736328e+01 -2.9909198760986328e+01 -3.0511999511718750e+02 5.9384597778320312e+01 -2.7580400466918945e+01 -3.0511901855468750e+02 5.9371097564697266e+01 -2.7621200561523438e+01 -2.1378399658203125e+02 5.8917602539062500e+01 -2.8465000152587891e+01 -3.0511401367187500e+02 5.8786102294921875e+01 -2.8668699264526367e+01 -2.1379100036621094e+02 5.7922199249267578e+01 -2.9734800338745117e+01 -2.1379100036621094e+02 5.7746601104736328e+01 -2.9909198760986328e+01 -2.1378100585937500e+02 5.9351600646972656e+01 -2.7663400650024414e+01 -2.1377999877929688e+02 5.9380298614501953e+01 -2.7578899383544922e+01 -3.0512600708007812e+02 5.9881401062011719e+01 -2.6087499618530273e+01 -2.1377400207519531e+02 5.9871200561523438e+01 -2.6134201049804688e+01 -3.0513098144531250e+02 6.0019798278808594e+01 -2.5187799453735352e+01 -2.1376701354980469e+02 6.0045101165771484e+01 -2.4807300567626953e+01 -3.0513299560546875e+02 6.0045101165771484e+01 -2.4807300567626953e+01 -2.0132099914550781e+02 -5.3162197113037109e+01 -2.4944198608398438e+01 -2.0132099914550781e+02 5.3161800384521484e+01 -2.4951599121093750e+01 -2.0132099914550781e+02 -5.3161800384521484e+01 -2.4951599121093750e+01 -2.0133900451660156e+02 5.2842800140380859e+01 -2.5465299606323242e+01 -2.0134199523925781e+02 5.2648700714111328e+01 -2.5531400680541992e+01 -2.0133499145507812e+02 5.3004001617431641e+01 -2.5338500976562500e+01 -2.0132899475097656e+02 5.3114196777343750e+01 -2.5165800094604492e+01 -2.0134199523925781e+02 -5.2552303314208984e+01 -2.5539299011230469e+01 -2.0134001159667969e+02 -5.2767799377441406e+01 -2.5499601364135742e+01 -2.0133699035644531e+02 -5.2943901062011719e+01 -2.5396398544311523e+01 -2.0134199523925781e+02 5.2552303314208984e+01 -2.5539199829101562e+01 -2.0134199523925781e+02 5.2551399230957031e+01 -2.5539299011230469e+01 -2.0132499694824219e+02 -5.3150096893310547e+01 -2.5049098968505859e+01 -2.0133100891113281e+02 -5.3076400756835938e+01 -2.5240499496459961e+01 -3.0597799682617188e+02 5.9857200622558594e+01 -2.4813798904418945e+01 -3.1642498779296875e+02 5.4972000122070312e+01 -2.4978200912475586e+01 -3.1635900878906250e+02 5.3407402038574219e+01 -2.7148500442504883e+01 -3.0589498901367188e+02 5.3829402923583984e+01 -3.1722698211669922e+01 -3.0589801025390625e+02 5.4822601318359375e+01 -3.1473598480224609e+01 -3.1635998535156250e+02 5.3452598571777344e+01 -2.7122100830078125e+01 -3.0589999389648438e+02 5.5268501281738281e+01 -3.1272199630737305e+01 -3.0590600585937500e+02 5.6262500762939453e+01 -3.0823501586914062e+01 -3.1637100219726562e+02 5.4105899810791016e+01 -2.6740200042724609e+01 -3.0591198730468750e+02 5.6995498657226562e+01 -3.0329700469970703e+01 -3.1637500000000000e+02 5.4213798522949219e+01 -2.6613800048828125e+01 -3.0591799926757812e+02 5.7619197845458984e+01 -2.9793500900268555e+01 -3.0591799926757812e+02 5.7625301361083984e+01 -2.9788299560546875e+01 -3.1639001464843750e+02 5.4631599426269531e+01 -2.6123800277709961e+01 -3.0597399902343750e+02 5.9833797454833984e+01 -2.5176500320434570e+01 -3.1641299438476562e+02 5.4924400329589844e+01 -2.5369201660156250e+01 -3.0593298339843750e+02 5.8638099670410156e+01 -2.8574901580810547e+01 -3.0594500732421875e+02 5.9206798553466797e+01 -2.7551200866699219e+01 -3.1639797973632812e+02 5.4732597351074219e+01 -2.5863601684570312e+01 -3.0594598388671875e+02 5.9217502593994141e+01 -2.7518701553344727e+01 -3.0596301269531250e+02 5.9701000213623047e+01 -2.6054399490356445e+01 -3.0594598388671875e+02 -5.9213199615478516e+01 -2.7517200469970703e+01 -3.1639797973632812e+02 -5.4754497528076172e+01 -2.5870399475097656e+01 -3.0596200561523438e+02 -5.9691101074218750e+01 -2.6099899291992188e+01 -3.1639901733398438e+02 -5.4781898498535156e+01 -2.5827499389648438e+01 -3.0597799682617188e+02 -5.9857200622558594e+01 -2.4813798904418945e+01 -3.1642498779296875e+02 -5.4972000122070312e+01 -2.4978200912475586e+01 -3.1637799072265625e+02 -5.4344596862792969e+01 -2.6511098861694336e+01 -3.0591799926757812e+02 -5.7625301361083984e+01 -2.9788299560546875e+01 -3.1637500000000000e+02 -5.4217102050781250e+01 -2.6611000061035156e+01 -3.0591799926757812e+02 -5.7619003295898438e+01 -2.9793100357055664e+01 -3.1636300659179688e+02 -5.3705497741699219e+01 -2.7012199401855469e+01 -3.0594500732421875e+02 -5.9187900543212891e+01 -2.7592500686645508e+01 -3.0593499755859375e+02 -5.8766101837158203e+01 -2.8375699996948242e+01 -3.0592001342773438e+02 -5.7796703338623047e+01 -2.9617500305175781e+01 -3.0589398193359375e+02 -5.2928802490234375e+01 -3.1825502395629883e+01 -3.1635498046875000e+02 -5.2938697814941406e+01 -2.7273500442504883e+01 -3.0590701293945312e+02 -5.6375000000000000e+01 -3.0755899429321289e+01 -3.0589999389648438e+02 -5.5329799652099609e+01 -3.1286798477172852e+01 -3.1635998535156250e+02 -5.3446899414062500e+01 -2.7100299835205078e+01 -3.0589999389648438e+02 -5.5282199859619141e+01 -3.1300600051879883e+01 -3.0589498901367188e+02 -5.3812999725341797e+01 -3.1725601196289062e+01 -2.0247499084472656e+02 5.4972000122070312e+01 -2.4978200912475586e+01 -2.1292201232910156e+02 5.9857200622558594e+01 -2.4813798904418945e+01 -2.1295399475097656e+02 5.9213199615478516e+01 -2.7517200469970703e+01 -2.0250199890136719e+02 5.4754497528076172e+01 -2.5870399475097656e+01 -2.1293798828125000e+02 5.9691101074218750e+01 -2.6099899291992188e+01 -2.0250099182128906e+02 5.4781898498535156e+01 -2.5827499389648438e+01 -2.0252198791503906e+02 5.4344596862792969e+01 -2.6511098861694336e+01 -2.1298199462890625e+02 5.7625301361083984e+01 -2.9788299560546875e+01 -2.0252500915527344e+02 5.4217102050781250e+01 -2.6611000061035156e+01 -2.1298199462890625e+02 5.7619003295898438e+01 -2.9793100357055664e+01 -2.0253700256347656e+02 5.3705497741699219e+01 -2.7012199401855469e+01 -2.1295500183105469e+02 5.9187900543212891e+01 -2.7592500686645508e+01 -2.1296499633789062e+02 5.8766101837158203e+01 -2.8375699996948242e+01 -2.1297999572753906e+02 5.7796703338623047e+01 -2.9617500305175781e+01 -2.1300601196289062e+02 5.2551399230957031e+01 -3.1835298538208008e+01 -2.0254600524902344e+02 5.2551399230957031e+01 -2.7304800033569336e+01 -2.1300601196289062e+02 5.2928802490234375e+01 -3.1825502395629883e+01 -2.0254499816894531e+02 5.2938697814941406e+01 -2.7273500442504883e+01 -2.1299299621582031e+02 5.6375000000000000e+01 -3.0755899429321289e+01 -2.1300000000000000e+02 5.5329799652099609e+01 -3.1286798477172852e+01 -2.0253999328613281e+02 5.3446899414062500e+01 -2.7100299835205078e+01 -2.1300000000000000e+02 5.5282199859619141e+01 -3.1300600051879883e+01 -2.1300500488281250e+02 5.3812999725341797e+01 -3.1725601196289062e+01 -2.1300601196289062e+02 -5.2551399230957031e+01 -3.1835298538208008e+01 -2.0254600524902344e+02 -5.2551399230957031e+01 -2.7304800033569336e+01 -2.0254100036621094e+02 -5.3407402038574219e+01 -2.7148500442504883e+01 -2.1300500488281250e+02 -5.3829402923583984e+01 -3.1722698211669922e+01 -2.1300199890136719e+02 -5.4822601318359375e+01 -3.1473598480224609e+01 -2.0253999328613281e+02 -5.3452598571777344e+01 -2.7122100830078125e+01 -2.1300000000000000e+02 -5.5268501281738281e+01 -3.1272199630737305e+01 -2.1299398803710938e+02 -5.6262500762939453e+01 -3.0823501586914062e+01 -2.0252899169921875e+02 -5.4105899810791016e+01 -2.6740200042724609e+01 -2.1298800659179688e+02 -5.6995498657226562e+01 -3.0329700469970703e+01 -2.0252500915527344e+02 -5.4213798522949219e+01 -2.6613800048828125e+01 -2.1298199462890625e+02 -5.7619197845458984e+01 -2.9793500900268555e+01 -2.1298199462890625e+02 -5.7625301361083984e+01 -2.9788299560546875e+01 -2.0250999450683594e+02 -5.4631599426269531e+01 -2.6123800277709961e+01 -2.1292201232910156e+02 -5.9857200622558594e+01 -2.4813798904418945e+01 -2.0247499084472656e+02 -5.4972000122070312e+01 -2.4978200912475586e+01 -2.1292599487304688e+02 -5.9833797454833984e+01 -2.5176500320434570e+01 -2.0248699951171875e+02 -5.4924400329589844e+01 -2.5369201660156250e+01 -2.1296699523925781e+02 -5.8638099670410156e+01 -2.8574901580810547e+01 -2.1295500183105469e+02 -5.9206798553466797e+01 -2.7551200866699219e+01 -2.0250199890136719e+02 -5.4732597351074219e+01 -2.5863601684570312e+01 -2.1295399475097656e+02 -5.9217502593994141e+01 -2.7518701553344727e+01 -2.1293699645996094e+02 -5.9701000213623047e+01 -2.6054399490356445e+01 -2.6564801025390625e+02 -8.9538097381591797e+00 -3.2109497070312500e+01 -2.6484799194335938e+02 -6.2575898170471191e+00 -3.2103797912597656e+01 -2.9500897216796875e+02 -7.2864298820495605e+00 -3.6844001770019531e+01 -2.7647399902343750e+02 2.5273698806762695e+01 -3.2184997558593750e+01 -2.7790499877929688e+02 2.6703498840332031e+01 -3.2194900512695312e+01 -2.8731799316406250e+02 2.7741100311279297e+01 -3.3538597106933594e+01 -2.7114901733398438e+02 1.9058599472045898e+01 -3.2148101806640625e+01 -2.7368399047851562e+02 2.2231201171875000e+01 -3.2165699005126953e+01 -2.9500897216796875e+02 1.4515399932861328e+01 -3.6389499664306641e+01 -2.6902197265625000e+02 1.5924200057983398e+01 -3.2133197784423828e+01 -2.9500897216796875e+02 2.8590000152587891e+01 -3.4633499145507812e+01 -2.9500897216796875e+02 2.1808300018310547e+01 -3.5625499725341797e+01 -2.9500897216796875e+02 1.4560099601745605e+01 -3.6386699676513672e+01 -2.9500897216796875e+02 7.2864298820495605e+00 -3.6844001770019531e+01 -2.6497399902343750e+02 6.7555298805236816e+00 -3.2104701995849609e+01 -2.6584301757812500e+02 9.4971599578857422e+00 -3.2110900878906250e+01 -2.6701400756835938e+02 1.2261099815368652e+01 -3.2119098663330078e+01 -2.6727600097656250e+02 1.2796999931335449e+01 -3.2120899200439453e+01 -2.6803601074218750e+02 1.4159600257873535e+01 -3.2126300811767578e+01 -2.6439801025390625e+02 4.0124702453613281e+00 -3.2100700378417969e+01 -2.9500897216796875e+02 0.0000000000000000e+00 -3.6996498107910156e+01 -2.6422799682617188e+02 2.7175498008728027e+00 -3.2099498748779297e+01 -2.6421099853515625e+02 -2.5533998012542725e+00 -3.2099399566650391e+01 -2.6408801269531250e+02 0.0000000000000000e+00 -3.2098499298095703e+01 -2.6408401489257812e+02 8.7736800312995911e-02 -3.2098499298095703e+01 -2.6461398315429688e+02 -5.2107601165771484e+00 -3.2102199554443359e+01 -2.9500897216796875e+02 -2.1808300018310547e+01 -3.5625499725341797e+01 -2.9500897216796875e+02 -2.8590000152587891e+01 -3.4633499145507812e+01 -2.8731799316406250e+02 -2.7741100311279297e+01 -3.3538597106933594e+01 -2.9500897216796875e+02 -1.4560099601745605e+01 -3.6386699676513672e+01 -2.9500897216796875e+02 -1.4515399932861328e+01 -3.6389499664306641e+01 -2.7790499877929688e+02 -2.6703498840332031e+01 -3.2194900512695312e+01 -2.7503698730468750e+02 -2.3754499435424805e+01 -3.2175102233886719e+01 -2.7245199584960938e+02 -2.0748699188232422e+01 -3.2157100677490234e+01 -2.7017501831054688e+02 -1.7691200256347656e+01 -3.2141300201416016e+01 -2.6966198730468750e+02 -1.6927700042724609e+01 -3.2137699127197266e+01 -2.6806198120117188e+02 -1.4290300369262695e+01 -3.2126502990722656e+01 -2.6799600219726562e+02 -1.4158800125122070e+01 -3.2125999450683594e+01 -2.6672100830078125e+02 -1.1629999160766602e+01 -3.2117099761962891e+01 -3.0519299316406250e+02 3.7069999694824219e+01 -3.1997699737548828e+01 -3.0567102050781250e+02 3.7475700378417969e+01 -3.1916399002075195e+01 -3.0544598388671875e+02 3.7215698242187500e+01 -3.1969598770141602e+01 -3.0527099609375000e+02 3.7098499298095703e+01 -3.1992599487304688e+01 -2.0139199829101562e+02 5.3685199737548828e+01 -2.4968500137329102e+01 -2.0187400817871094e+02 5.4521999359130859e+01 -2.4982599258422852e+01 -2.0182099914550781e+02 5.4482501983642578e+01 -2.4982999801635742e+01 -2.0191099548339844e+02 5.4549797058105469e+01 -2.4982299804687500e+01 -2.0149700927734375e+02 5.3880599975585938e+01 -2.4972099304199219e+01 -2.0148100280761719e+02 5.3851398468017578e+01 -2.4971500396728516e+01 -2.0186300659179688e+02 5.2551300048828125e+01 -2.6817100524902344e+01 -2.0153900146484375e+02 5.2551300048828125e+01 -2.6249601364135742e+01 -2.0154299926757812e+02 5.2580902099609375e+01 -2.6246400833129883e+01 -2.0152198791503906e+02 5.2551300048828125e+01 -2.6220899581909180e+01 -2.0142900085449219e+02 5.2551300048828125e+01 -2.6057100296020508e+01 -2.0197599792480469e+02 5.2551300048828125e+01 -2.6897701263427734e+01 -2.0193800354003906e+02 5.2551300048828125e+01 -2.6870800018310547e+01 -2.0194099426269531e+02 5.2567199707031250e+01 -2.6866600036621094e+01 -2.0192700195312500e+02 5.2867900848388672e+01 -2.6859600067138672e+01 -2.0191999816894531e+02 5.3495002746582031e+01 -2.6646099090576172e+01 -2.0190699768066406e+02 5.4017799377441406e+01 -2.6236598968505859e+01 -2.0150599670410156e+02 5.2766597747802734e+01 -2.6250499725341797e+01 -2.0150099182128906e+02 5.3193401336669922e+01 -2.6105201721191406e+01 -2.0149198913574219e+02 5.3549098968505859e+01 -2.5826599121093750e+01 -2.0147900390625000e+02 5.3792598724365234e+01 -2.5446399688720703e+01 -2.0188899230957031e+02 5.4375900268554688e+01 -2.5677799224853516e+01 -2.0142900085449219e+02 -5.2552101135253906e+01 -2.6057100296020508e+01 -2.0152198791503906e+02 -5.2551998138427734e+01 -2.6220899581909180e+01 -2.0153900146484375e+02 -5.2551998138427734e+01 -2.6249601364135742e+01 -2.0186300659179688e+02 -5.2551700592041016e+01 -2.6817100524902344e+01 -2.0193800354003906e+02 -5.2551700592041016e+01 -2.6870800018310547e+01 -2.0197599792480469e+02 -5.2551700592041016e+01 -2.6897701263427734e+01 -2.0182299804687500e+02 -5.4484699249267578e+01 -2.4980998992919922e+01 -2.0149800109863281e+02 -5.3880199432373047e+01 -2.4967399597167969e+01 -2.0150299072265625e+02 -5.3876003265380859e+01 -2.4999500274658203e+01 -2.0147999572753906e+02 -5.3847202301025391e+01 -2.4966699600219727e+01 -2.0138999938964844e+02 -5.3679298400878906e+01 -2.4963001251220703e+01 -2.0190399169921875e+02 -5.4544696807861328e+01 -2.4980600357055664e+01 -2.0187400817871094e+02 -5.4522499084472656e+01 -2.4980699539184570e+01 -2.0187699890136719e+02 -5.4518699645996094e+01 -2.4992000579833984e+01 -2.0187699890136719e+02 -5.4492801666259766e+01 -2.5302799224853516e+01 -2.0189698791503906e+02 -5.4252700805664062e+01 -2.5920000076293945e+01 -2.0191299438476562e+02 -5.3822498321533203e+01 -2.6423801422119141e+01 -2.0147000122070312e+02 -5.3872299194335938e+01 -2.5190799713134766e+01 -2.0148500061035156e+02 -5.3708900451660156e+01 -2.5611200332641602e+01 -2.0149600219726562e+02 -5.3416198730468750e+01 -2.5954000473022461e+01 -2.0150401306152344e+02 -5.3027702331542969e+01 -2.6180900573730469e+01 -2.0192399597167969e+02 -5.3251300811767578e+01 -2.6757400512695312e+01 -3.0519400024414062e+02 -3.7070198059082031e+01 -3.1997699737548828e+01 -3.0527099609375000e+02 -3.7098499298095703e+01 -3.1992599487304688e+01 -3.0571801757812500e+02 -3.7545299530029297e+01 -3.1901699066162109e+01 -3.0549499511718750e+02 -3.7261699676513672e+01 -3.1960401535034180e+01 -3.0517898559570312e+02 2.9158899307250977e+01 -3.5407497406005859e+01 -3.0056198120117188e+02 2.9023500442504883e+01 -3.5223400115966797e+01 -2.9958700561523438e+02 2.8968900680541992e+01 -3.5149299621582031e+01 -3.0046701049804688e+02 2.9018199920654297e+01 -3.5216300964355469e+01 -3.0046701049804688e+02 2.1889200210571289e+01 -3.6266403198242188e+01 -3.0046701049804688e+02 -2.1889200210571289e+01 -3.6266403198242188e+01 -3.0046701049804688e+02 -2.9018199920654297e+01 -3.5216300964355469e+01 -2.9958700561523438e+02 -2.8968900680541992e+01 -3.5149299621582031e+01 -3.0517898559570312e+02 -2.9158899307250977e+01 -3.5407497406005859e+01 -3.0056198120117188e+02 -2.9023500442504883e+01 -3.5223400115966797e+01 -3.0046701049804688e+02 1.4614099502563477e+01 -3.7030498504638672e+01 -3.0046701049804688e+02 7.3134298324584961e+00 -3.7489498138427734e+01 -3.0046701049804688e+02 0.0000000000000000e+00 -3.7642501831054688e+01 -3.0046701049804688e+02 -7.3134298324584961e+00 -3.7489498138427734e+01 -3.0046701049804688e+02 -1.4614099502563477e+01 -3.7030498504638672e+01 -2.9038000488281250e+02 2.9737501144409180e+01 -3.3344898223876953e+01 -2.9491998291015625e+02 3.0562000274658203e+01 -3.3759502410888672e+01 -2.9493200683593750e+02 2.9857900619506836e+01 -3.4205299377441406e+01 -2.8723800659179688e+02 2.9113800048828125e+01 -3.3056999206542969e+01 -2.8134201049804688e+02 2.7785400390625000e+01 -3.2514598846435547e+01 -2.8315798950195312e+02 2.8233800888061523e+01 -3.2682098388671875e+01 -2.8624298095703125e+02 2.8916200637817383e+01 -3.2965801239013672e+01 -2.7852200317382812e+02 2.6942298889160156e+01 -3.2252799987792969e+01 -2.7979202270507812e+02 2.7354700088500977e+01 -3.2370998382568359e+01 -3.0595898437500000e+02 3.1087299346923828e+01 -3.4532100677490234e+01 -3.1529800415039062e+02 3.1094999313354492e+01 -3.4526901245117188e+01 -3.0595898437500000e+02 3.0448600769042969e+01 -3.4987098693847656e+01 -3.0595898437500000e+02 3.1539100646972656e+01 -3.4210296630859375e+01 -3.0683401489257812e+02 3.1581300735473633e+01 -3.4168998718261719e+01 -3.0795800781250000e+02 3.1674900054931641e+01 -3.4073200225830078e+01 -3.0907299804687500e+02 3.1807798385620117e+01 -3.3927101135253906e+01 -3.1529998779296875e+02 3.1279199600219727e+01 -3.4442699432373047e+01 -3.1222000122070312e+02 3.2178699493408203e+01 -3.3436397552490234e+01 -3.1532897949218750e+02 3.2454200744628906e+01 -3.2951702117919922e+01 -2.9954202270507812e+02 3.0249300003051758e+01 -3.4723598480224609e+01 -3.0561300659179688e+02 3.1528499603271484e+01 -3.4219100952148438e+01 -3.0519598388671875e+02 3.1520799636840820e+01 -3.4221401214599609e+01 -3.0517398071289062e+02 3.0445600509643555e+01 -3.4983200073242188e+01 -3.0517300415039062e+02 3.1520002365112305e+01 -3.4221000671386719e+01 -3.0188699340820312e+02 3.1399398803710938e+01 -3.4160800933837891e+01 -3.0052301025390625e+02 3.0305700302124023e+01 -3.4798099517822266e+01 -3.0051898193359375e+02 3.1295400619506836e+01 -3.4109500885009766e+01 -3.0014602661132812e+02 3.1267099380493164e+01 -3.4095500946044922e+01 -2.9953799438476562e+02 3.1197198867797852e+01 -3.4061698913574219e+01 -2.9716000366210938e+02 3.0924100875854492e+01 -3.3929500579833984e+01 -2.8723800659179688e+02 -2.9114799499511719e+01 -3.3056999206542969e+01 -2.8658898925781250e+02 -2.8988401412963867e+01 -3.2997501373291016e+01 -2.8305200195312500e+02 -2.8208900451660156e+01 -3.2672401428222656e+01 -2.8224398803710938e+02 -2.8013900756835938e+01 -3.2597900390625000e+01 -2.8013101196289062e+02 -2.7454099655151367e+01 -3.2402400970458984e+01 -2.7879598999023438e+02 -2.7038299560546875e+01 -3.2278400421142578e+01 -2.9493200683593750e+02 -2.9857900619506836e+01 -3.4205299377441406e+01 -2.9164401245117188e+02 -2.9973600387573242e+01 -3.3460399627685547e+01 -2.9491998291015625e+02 -3.0562000274658203e+01 -3.3759502410888672e+01 -3.0707800292968750e+02 -3.1597801208496094e+01 -3.4152400970458984e+01 -3.0595898437500000e+02 -3.1539100646972656e+01 -3.4210296630859375e+01 -3.0595898437500000e+02 -3.1087299346923828e+01 -3.4532100677490234e+01 -3.0819500732421875e+02 -3.1699899673461914e+01 -3.4046600341796875e+01 -3.0907299804687500e+02 -3.1807798385620117e+01 -3.3927101135253906e+01 -3.1529800415039062e+02 -3.1074098587036133e+01 -3.4535602569580078e+01 -3.1222000122070312e+02 -3.2178699493408203e+01 -3.3436397552490234e+01 -3.1532897949218750e+02 -3.2454200744628906e+01 -3.2951702117919922e+01 -3.0595898437500000e+02 -3.0448600769042969e+01 -3.4987098693847656e+01 -3.1529501342773438e+02 -3.0923801422119141e+01 -3.4708103179931641e+01 -3.0561599731445312e+02 -3.1528499603271484e+01 -3.4219100952148438e+01 -2.9716000366210938e+02 -3.0924200057983398e+01 -3.3929500579833984e+01 -2.9954202270507812e+02 -3.0249300003051758e+01 -3.4723598480224609e+01 -3.0052301025390625e+02 -3.0305700302124023e+01 -3.4798099517822266e+01 -3.0014602661132812e+02 -3.1267099380493164e+01 -3.4095500946044922e+01 -2.9953799438476562e+02 -3.1197198867797852e+01 -3.4061698913574219e+01 -3.0517300415039062e+02 -3.1520002365112305e+01 -3.4221000671386719e+01 -3.0188699340820312e+02 -3.1399398803710938e+01 -3.4160800933837891e+01 -3.0051898193359375e+02 -3.1295400619506836e+01 -3.4109500885009766e+01 -3.0517398071289062e+02 -3.0445600509643555e+01 -3.4983200073242188e+01 -3.0519598388671875e+02 -3.1520799636840820e+01 -3.4221401214599609e+01 -3.1545001220703125e+02 3.2851699829101562e+01 -3.2206298828125000e+01 -3.1449899291992188e+02 3.4199302673339844e+01 -3.0638898849487305e+01 -3.1584399414062500e+02 3.4898399353027344e+01 -2.9669198989868164e+01 -3.1431201171875000e+02 3.4626201629638672e+01 -3.0405700683593750e+01 -3.1584997558593750e+02 3.4926898956298828e+01 -2.9633899688720703e+01 -3.1338302612304688e+02 3.6744098663330078e+01 -2.9248901367187500e+01 -3.1616198730468750e+02 3.7564998626708984e+01 -2.7944700241088867e+01 -3.1332098388671875e+02 3.6994800567626953e+01 -2.9221099853515625e+01 -3.1616500854492188e+02 3.7589401245117188e+01 -2.7929000854492188e+01 -3.1538998413085938e+02 3.2646499633789062e+01 -3.2575397491455078e+01 -3.1096499633789062e+02 3.3907398223876953e+01 -3.1669500350952148e+01 -3.0788699340820312e+02 3.3587600708007812e+01 -3.2735198974609375e+01 -3.0986099243164062e+02 3.6232601165771484e+01 -3.0640199661254883e+01 -3.0729699707031250e+02 3.4472202301025391e+01 -3.2142799377441406e+01 -3.0683099365234375e+02 3.5591899871826172e+01 -3.2040599822998047e+01 -3.0670300292968750e+02 3.4291999816894531e+01 -3.2351402282714844e+01 -3.0558801269531250e+02 3.4097999572753906e+01 -3.2556198120117188e+01 -3.0608099365234375e+02 3.4159198760986328e+01 -3.2493598937988281e+01 -3.0539001464843750e+02 3.4082302093505859e+01 -3.2569900512695312e+01 -3.0515100097656250e+02 3.4072002410888672e+01 -3.2576099395751953e+01 -2.9425698852539062e+02 3.2819499969482422e+01 -3.2452598571777344e+01 -2.9663500976562500e+02 3.3299301147460938e+01 -3.2497802734375000e+01 -2.9980200195312500e+02 3.3746101379394531e+01 -3.2542198181152344e+01 -3.0164700317382812e+02 3.3916500091552734e+01 -3.2559700012207031e+01 -2.7727899169921875e+02 2.7318998336791992e+01 -3.2097499847412109e+01 -2.7788900756835938e+02 2.7703300476074219e+01 -3.2063400268554688e+01 -2.7914398193359375e+02 2.8352800369262695e+01 -3.2093299865722656e+01 -2.8068301391601562e+02 2.9007200241088867e+01 -3.2129699707031250e+01 -2.8249099731445312e+02 2.9666900634765625e+01 -3.2172401428222656e+01 -2.8557101440429688e+02 3.0634300231933594e+01 -3.2245201110839844e+01 -2.8970901489257812e+02 3.1748600006103516e+01 -3.2343601226806641e+01 -2.7728302001953125e+02 -2.7315198898315430e+01 -3.2048900604248047e+01 -2.9425698852539062e+02 -3.2819499969482422e+01 -3.2452598571777344e+01 -2.9097399902343750e+02 -3.2059902191162109e+01 -3.2373802185058594e+01 -2.8591601562500000e+02 -3.0734199523925781e+01 -3.2253398895263672e+01 -2.8238601684570312e+02 -2.9630800247192383e+01 -3.2169898986816406e+01 -2.8158102416992188e+02 -2.9346099853515625e+01 -3.2150901794433594e+01 -2.7948001098632812e+02 -2.8505901336669922e+01 -3.2101200103759766e+01 -2.7816000366210938e+02 -2.7856800079345703e+01 -3.2069900512695312e+01 -2.9663598632812500e+02 -3.3299301147460938e+01 -3.2497802734375000e+01 -2.9980200195312500e+02 -3.3746101379394531e+01 -3.2542198181152344e+01 -3.0164700317382812e+02 -3.3916500091552734e+01 -3.2559700012207031e+01 -3.0515100097656250e+02 -3.4072002410888672e+01 -3.2576099395751953e+01 -3.0539199829101562e+02 -3.4082496643066406e+01 -3.2569801330566406e+01 -3.0558801269531250e+02 -3.4097999572753906e+01 -3.2556198120117188e+01 -3.0677099609375000e+02 -3.5550899505615234e+01 -3.1866100311279297e+01 -3.0786499023437500e+02 -3.3473400115966797e+01 -3.2586002349853516e+01 -3.0683099365234375e+02 -3.4326698303222656e+01 -3.2312602996826172e+01 -3.0731799316406250e+02 -3.4512199401855469e+01 -3.2226100921630859e+01 -3.0621701049804688e+02 -3.4182998657226562e+01 -3.2468700408935547e+01 -3.1096499633789062e+02 -3.3907398223876953e+01 -3.1669500350952148e+01 -3.1538998413085938e+02 -3.2646499633789062e+01 -3.2575397491455078e+01 -3.0986099243164062e+02 -3.6232601165771484e+01 -3.0640199661254883e+01 -3.1338302612304688e+02 -3.6744098663330078e+01 -2.9248901367187500e+01 -3.1332098388671875e+02 -3.6994800567626953e+01 -2.9221099853515625e+01 -3.1431201171875000e+02 -3.4626201629638672e+01 -3.0405700683593750e+01 -3.1449899291992188e+02 -3.4199302673339844e+01 -3.0638898849487305e+01 -3.1545001220703125e+02 -3.2851699829101562e+01 -3.2206298828125000e+01 -3.1584399414062500e+02 -3.4904899597167969e+01 -2.9676000595092773e+01 -3.1617401123046875e+02 -3.7690200805664062e+01 -2.7887701034545898e+01 -3.1616000366210938e+02 -3.7571998596191406e+01 -2.7961900711059570e+01 -3.1585699462890625e+02 -3.4971599578857422e+01 -2.9593799591064453e+01 -3.1745202636718750e+02 -5.3859199523925781e+01 -2.4968400955200195e+01 -3.1742999267578125e+02 -5.3894500732421875e+01 -2.4968999862670898e+01 -3.1700399780273438e+02 -5.4562900543212891e+01 -2.4981500625610352e+01 -3.1702600097656250e+02 -5.4527599334716797e+01 -2.4980901718139648e+01 -3.1694201660156250e+02 -5.2551601409912109e+01 -2.6905799865722656e+01 -3.1697198486328125e+02 -5.2551601409912109e+01 -2.6885099411010742e+01 -3.1697299194335938e+02 -5.2867900848388672e+01 -2.6859600067138672e+01 -3.1740100097656250e+02 -5.2551898956298828e+01 -2.6231800079345703e+01 -3.1742700195312500e+02 -5.3891403198242188e+01 -2.4978000640869141e+01 -3.1739398193359375e+02 -5.2766597747802734e+01 -2.6250499725341797e+01 -3.1739300537109375e+02 -5.2551898956298828e+01 -2.6267898559570312e+01 -3.1698001098632812e+02 -5.3495002746582031e+01 -2.6646099090576172e+01 -3.1699301147460938e+02 -5.4017799377441406e+01 -2.6236598968505859e+01 -3.1739898681640625e+02 -5.3193401336669922e+01 -2.6105201721191406e+01 -3.1740798950195312e+02 -5.3549098968505859e+01 -2.5826599121093750e+01 -3.1742098999023438e+02 -5.3792598724365234e+01 -2.5446399688720703e+01 -3.1701098632812500e+02 -5.4375900268554688e+01 -2.5677799224853516e+01 -3.1702398681640625e+02 -5.4523597717285156e+01 -2.4989000320434570e+01 -3.1694201660156250e+02 -4.0492099761962891e+01 -2.6905799865722656e+01 -3.1697198486328125e+02 -4.0492099761962891e+01 -2.6885099411010742e+01 -3.1739300537109375e+02 -4.0492099761962891e+01 -2.6267898559570312e+01 -3.1740100097656250e+02 -4.0492099761962891e+01 -2.6231800079345703e+01 -3.1640100097656250e+02 -3.2586299896240234e+01 -3.2083999633789062e+01 -3.1667001342773438e+02 -3.4720100402832031e+01 -2.9329898834228516e+01 -3.1686898803710938e+02 -3.7540199279785156e+01 -2.7512699127197266e+01 -3.1734899902343750e+02 -3.7307899475097656e+01 -2.6910999298095703e+01 -3.1724499511718750e+02 -3.4265598297119141e+01 -2.8822099685668945e+01 -3.1709399414062500e+02 -3.1960699081420898e+01 -3.1741500854492188e+01 -3.1707199096679688e+02 -3.1746500015258789e+01 -3.2151199340820312e+01 -3.1636102294921875e+02 -3.2388099670410156e+01 -3.2470600128173828e+01 -3.1705001831054688e+02 -3.1548101425170898e+01 -3.2568599700927734e+01 -3.1631900024414062e+02 -3.2204399108886719e+01 -3.2864101409912109e+01 -3.1627801513671875e+02 -3.0763700485229492e+01 -3.4504398345947266e+01 -3.1626098632812500e+02 -2.9113401412963867e+01 -3.5159400939941406e+01 -3.1700701904296875e+02 -3.0356500625610352e+01 -3.3924598693847656e+01 -3.1698999023437500e+02 -2.8991899490356445e+01 -3.4465999603271484e+01 -3.1698999023437500e+02 2.8991899490356445e+01 -3.4465999603271484e+01 -3.1626098632812500e+02 2.9113401412963867e+01 -3.5159400939941406e+01 -3.1695602416992188e+02 2.2450300216674805e+01 -3.5444000244140625e+01 -3.1622698974609375e+02 2.2544401168823242e+01 -3.6141399383544922e+01 -3.1617901611328125e+02 5.3208498954772949e+00 -3.7520801544189453e+01 -3.1619097900390625e+02 -1.1954699516296387e+01 -3.7192501068115234e+01 -3.1690798950195312e+02 5.2986097335815430e+00 -3.6817699432373047e+01 -3.1691900634765625e+02 -1.1904800415039062e+01 -3.6490600585937500e+01 -3.1628399658203125e+02 3.1097299575805664e+01 -3.4256900787353516e+01 -3.1631900024414062e+02 3.2204399108886719e+01 -3.2864101409912109e+01 -3.1701300048828125e+02 3.0632299423217773e+01 -3.3720001220703125e+01 -3.1705001831054688e+02 3.1548101425170898e+01 -3.2568599700927734e+01 -3.1707199096679688e+02 3.1746500015258789e+01 -3.2151199340820312e+01 -3.1636102294921875e+02 3.2388099670410156e+01 -3.2470600128173828e+01 -3.1709399414062500e+02 3.1960699081420898e+01 -3.1741500854492188e+01 -3.1640100097656250e+02 3.2586299896240234e+01 -3.2083999633789062e+01 -3.1686300659179688e+02 3.7434700012207031e+01 -2.7556900024414062e+01 -3.1734600830078125e+02 3.7194099426269531e+01 -2.6957201004028320e+01 -3.1724200439453125e+02 3.4216197967529297e+01 -2.8867099761962891e+01 -3.1666601562500000e+02 3.4674301147460938e+01 -2.9372499465942383e+01 -3.1693399047851562e+02 4.0492099761962891e+01 -2.6910999298095703e+01 -3.1697198486328125e+02 4.0492099761962891e+01 -2.6885099411010742e+01 -3.1739300537109375e+02 4.0492099761962891e+01 -2.6267898559570312e+01 -3.1739999389648438e+02 4.0492099761962891e+01 -2.6235900878906250e+01 -3.1747100830078125e+02 5.2552101135253906e+01 -2.6057100296020508e+01 -3.1692401123046875e+02 5.2551700592041016e+01 -2.6897701263427734e+01 -3.1696200561523438e+02 5.2551700592041016e+01 -2.6870800018310547e+01 -3.1703698730468750e+02 5.2551700592041016e+01 -2.6817100524902344e+01 -3.1736099243164062e+02 5.2551998138427734e+01 -2.6249601364135742e+01 -3.1737802124023438e+02 5.2551998138427734e+01 -2.6220899581909180e+01 -3.1707699584960938e+02 5.4484699249267578e+01 -2.4980998992919922e+01 -3.1740200805664062e+02 5.3880199432373047e+01 -2.4967399597167969e+01 -3.1739700317382812e+02 5.3876003265380859e+01 -2.4999500274658203e+01 -3.1742001342773438e+02 5.3847202301025391e+01 -2.4966699600219727e+01 -3.1751000976562500e+02 5.3679298400878906e+01 -2.4963001251220703e+01 -3.1699600219726562e+02 5.4544696807861328e+01 -2.4980600357055664e+01 -3.1702600097656250e+02 5.4522499084472656e+01 -2.4980699539184570e+01 -3.1702301025390625e+02 5.4518699645996094e+01 -2.4992000579833984e+01 -3.1702301025390625e+02 5.4492801666259766e+01 -2.5302799224853516e+01 -3.1700302124023438e+02 5.4252700805664062e+01 -2.5920000076293945e+01 -3.1698699951171875e+02 5.3822498321533203e+01 -2.6423801422119141e+01 -3.1742999267578125e+02 5.3872299194335938e+01 -2.5190799713134766e+01 -3.1741500854492188e+02 5.3708900451660156e+01 -2.5611200332641602e+01 -3.1740399169921875e+02 5.3416198730468750e+01 -2.5954000473022461e+01 -3.1739599609375000e+02 5.3027702331542969e+01 -2.6180900573730469e+01 -3.1697601318359375e+02 5.3251300811767578e+01 -2.6757400512695312e+01 -3.0895199584960938e+02 2.4698799133300781e+01 3.8206600189208984e+01 -3.0649398803710938e+02 1.3303299903869629e+01 3.9270797729492188e+01 -3.0649398803710938e+02 4.8161701202392578e+01 3.9270797729492188e+01 -3.1695300292968750e+02 4.8161701202392578e+01 3.4743099212646484e+01 -3.1695300292968750e+02 4.4766899108886719e+01 3.4743099212646484e+01 -3.1288497924804688e+02 3.6031299591064453e+01 3.6504100799560547e+01 -2.1289900207519531e+02 6.3064201354980469e+01 0.0000000000000000e+00 -2.1120700073242188e+02 6.2689201354980469e+01 0.0000000000000000e+00 -2.0160299682617188e+02 5.5998798370361328e+01 0.0000000000000000e+00 -2.0075500488281250e+02 5.7812500000000000e+01 0.0000000000000000e+00 -2.0102700805664062e+02 5.5592800140380859e+01 0.0000000000000000e+00 -1.9958999633789062e+02 5.6987300872802734e+01 0.0000000000000000e+00 -2.0057901000976562e+02 5.4894203186035156e+01 0.0000000000000000e+00 -1.9870401000976562e+02 5.5595302581787109e+01 0.0000000000000000e+00 -2.0044999694824219e+02 5.4187500000000000e+01 0.0000000000000000e+00 -1.9844900512695312e+02 5.4189903259277344e+01 0.0000000000000000e+00 -2.0044999694824219e+02 -5.4187500000000000e+01 0.0000000000000000e+00 -1.9844900512695312e+02 -5.4189903259277344e+01 0.0000000000000000e+00 -2.0057701110839844e+02 -5.4890201568603516e+01 0.0000000000000000e+00 -1.9870401000976562e+02 -5.5595302581787109e+01 0.0000000000000000e+00 -2.0102099609375000e+02 -5.5586200714111328e+01 0.0000000000000000e+00 -1.9958999633789062e+02 -5.6987300872802734e+01 0.0000000000000000e+00 -2.0160299682617188e+02 -5.5998798370361328e+01 0.0000000000000000e+00 -2.0075500488281250e+02 -5.7812500000000000e+01 0.0000000000000000e+00 -2.1120700073242188e+02 -6.2689201354980469e+01 0.0000000000000000e+00 -2.1289900207519531e+02 -6.3064201354980469e+01 0.0000000000000000e+00 -3.0600198364257812e+02 -6.3064201354980469e+01 0.0000000000000000e+00 -3.0769299316406250e+02 -6.2689201354980469e+01 0.0000000000000000e+00 -3.1729699707031250e+02 -5.5998798370361328e+01 0.0000000000000000e+00 -3.1814501953125000e+02 -5.7812500000000000e+01 0.0000000000000000e+00 -3.1787899780273438e+02 -5.5586200714111328e+01 0.0000000000000000e+00 -3.1930999755859375e+02 -5.6987300872802734e+01 0.0000000000000000e+00 -3.1832299804687500e+02 -5.4890201568603516e+01 0.0000000000000000e+00 -3.2019601440429688e+02 -5.5595302581787109e+01 0.0000000000000000e+00 -3.1845001220703125e+02 -5.4187500000000000e+01 0.0000000000000000e+00 -3.2045098876953125e+02 -5.4189903259277344e+01 0.0000000000000000e+00 -3.1845001220703125e+02 5.4187500000000000e+01 0.0000000000000000e+00 -3.2045098876953125e+02 5.4189903259277344e+01 0.0000000000000000e+00 -3.1832098388671875e+02 5.4894203186035156e+01 0.0000000000000000e+00 -3.2019601440429688e+02 5.5595302581787109e+01 0.0000000000000000e+00 -3.1787298583984375e+02 5.5592800140380859e+01 0.0000000000000000e+00 -3.1930999755859375e+02 5.6987300872802734e+01 0.0000000000000000e+00 -3.1729699707031250e+02 5.5998798370361328e+01 0.0000000000000000e+00 -3.1814501953125000e+02 5.7812500000000000e+01 0.0000000000000000e+00 -3.0769299316406250e+02 6.2689201354980469e+01 0.0000000000000000e+00 -3.0600198364257812e+02 6.3064201354980469e+01 0.0000000000000000e+00 -3.0507699584960938e+02 -6.2086101531982422e+01 2.7053098678588867e+01 -3.0509100341796875e+02 -6.2153202056884766e+01 2.6086698532104492e+01 -2.1380900573730469e+02 -6.2153202056884766e+01 2.6086698532104492e+01 -3.0490802001953125e+02 -5.0701698303222656e+01 3.9367599487304688e+01 -3.0491400146484375e+02 -5.2387401580810547e+01 3.8916801452636719e+01 -2.1399000549316406e+02 -5.1592800140380859e+01 3.9173000335693359e+01 -3.0490499877929688e+02 -4.8493301391601562e+01 3.9596000671386719e+01 -2.1399499511718750e+02 -4.9412498474121094e+01 3.9544002532958984e+01 -3.0490402221679688e+02 -4.8161701202392578e+01 3.9599998474121094e+01 -2.1399499511718750e+02 -4.9128601074218750e+01 3.9566497802734375e+01 -2.1399499511718750e+02 -4.8161701202392578e+01 3.9599998474121094e+01 -3.0491598510742188e+02 -5.2833900451660156e+01 3.8797401428222656e+01 -2.1396000671386719e+02 -5.6228298187255859e+01 3.7035800933837891e+01 -2.1396099853515625e+02 -5.6174503326416016e+01 3.7080200195312500e+01 -2.1397599792480469e+02 -5.4268199920654297e+01 3.8198097229003906e+01 -2.1398001098632812e+02 -5.3697002410888672e+01 3.8459201812744141e+01 -2.1398599243164062e+02 -5.2381599426269531e+01 3.8905399322509766e+01 -3.0498098754882812e+02 -5.9308399200439453e+01 3.4060096740722656e+01 -2.1392900085449219e+02 -5.8765300750732422e+01 3.4741199493408203e+01 -3.0495898437500000e+02 -5.7891902923583984e+01 3.5665901184082031e+01 -2.1394099426269531e+02 -5.7891902923583984e+01 3.5665901184082031e+01 -3.0494699096679688e+02 -5.6937999725341797e+01 3.6507499694824219e+01 -3.0492800903320312e+02 -5.4863201141357422e+01 3.7891899108886719e+01 -3.0493997192382812e+02 -5.6212802886962891e+01 3.7011001586914062e+01 -3.0494500732421875e+02 -5.6715297698974609e+01 3.6683101654052734e+01 -2.1386698913574219e+02 -6.1322998046875000e+01 3.0288000106811523e+01 -3.0498199462890625e+02 -5.9363601684570312e+01 3.3997402191162109e+01 -3.0500701904296875e+02 -6.0545600891113281e+01 3.2129898071289062e+01 -2.1387300109863281e+02 -6.1191303253173828e+01 3.0721599578857422e+01 -2.1390100097656250e+02 -6.0222000122070312e+01 3.2709800720214844e+01 -2.1390399169921875e+02 -6.0074798583984375e+01 3.2953800201416016e+01 -2.1391900634765625e+02 -5.9279300689697266e+01 3.4039600372314453e+01 -3.0501498413085938e+02 -6.0820198059082031e+01 3.1580198287963867e+01 -3.0503298950195312e+02 -6.1311801910400391e+01 3.0281700134277344e+01 -2.1384399414062500e+02 -6.1837596893310547e+01 2.8595300674438477e+01 -2.1383999633789062e+02 -6.1901496887207031e+01 2.8286998748779297e+01 -3.0504299926757812e+02 -6.1606998443603516e+01 2.9501701354980469e+01 -3.0507299804687500e+02 -6.2053699493408203e+01 2.7335399627685547e+01 -3.0490402221679688e+02 4.8161701202392578e+01 3.9599998474121094e+01 -2.1399499511718750e+02 4.8161701202392578e+01 3.9599998474121094e+01 -2.1382299804687500e+02 6.2086101531982422e+01 2.7053098678588867e+01 -2.1380900573730469e+02 6.2153202056884766e+01 2.6086698532104492e+01 -3.0509100341796875e+02 6.2153202056884766e+01 2.6086698532104492e+01 -2.1386698913574219e+02 6.1311801910400391e+01 3.0281700134277344e+01 -2.1385600280761719e+02 6.1606998443603516e+01 2.9501701354980469e+01 -3.0505999755859375e+02 6.1901496887207031e+01 2.8286998748779297e+01 -2.1382699584960938e+02 6.2053699493408203e+01 2.7335399627685547e+01 -2.1391900634765625e+02 5.9308399200439453e+01 3.4060096740722656e+01 -2.1391799926757812e+02 5.9363601684570312e+01 3.3997402191162109e+01 -3.0503298950195312e+02 6.1322998046875000e+01 3.0288000106811523e+01 -2.1389299011230469e+02 6.0545600891113281e+01 3.2129898071289062e+01 -3.0505599975585938e+02 6.1837596893310547e+01 2.8595300674438477e+01 -2.1388499450683594e+02 6.0820198059082031e+01 3.1580198287963867e+01 -3.0502700805664062e+02 6.1191303253173828e+01 3.0721599578857422e+01 -3.0499899291992188e+02 6.0222000122070312e+01 3.2709800720214844e+01 -3.0499600219726562e+02 6.0074798583984375e+01 3.2953800201416016e+01 -3.0498098754882812e+02 5.9279300689697266e+01 3.4039600372314453e+01 -3.0497100830078125e+02 5.8765300750732422e+01 3.4741199493408203e+01 -2.1394099426269531e+02 5.7891902923583984e+01 3.5665901184082031e+01 -3.0495898437500000e+02 5.7891902923583984e+01 3.5665901184082031e+01 -2.1395300292968750e+02 5.6937999725341797e+01 3.6507499694824219e+01 -2.1398599243164062e+02 5.2387401580810547e+01 3.8916801452636719e+01 -2.1398399353027344e+02 5.2833900451660156e+01 3.8797401428222656e+01 -3.0493997192382812e+02 5.6228298187255859e+01 3.7035800933837891e+01 -2.1397200012207031e+02 5.4863201141357422e+01 3.7891899108886719e+01 -2.1396000671386719e+02 5.6212802886962891e+01 3.7011001586914062e+01 -2.1395500183105469e+02 5.6715297698974609e+01 3.6683101654052734e+01 -3.0493899536132812e+02 5.6174503326416016e+01 3.7080200195312500e+01 -3.0492401123046875e+02 5.4268199920654297e+01 3.8198097229003906e+01 -3.0491998291015625e+02 5.3697002410888672e+01 3.8459201812744141e+01 -3.0491400146484375e+02 5.2381599426269531e+01 3.8905399322509766e+01 -3.0491000366210938e+02 5.1592800140380859e+01 3.9173000335693359e+01 -2.1399200439453125e+02 5.0701698303222656e+01 3.9367599487304688e+01 -2.1399499511718750e+02 4.8493301391601562e+01 3.9596000671386719e+01 -3.0490499877929688e+02 4.9412498474121094e+01 3.9544002532958984e+01 -3.0490499877929688e+02 4.9128601074218750e+01 3.9566497802734375e+01 -1.9936599731445312e+02 -5.3272701263427734e+01 2.6267299652099609e+01 -1.9936599731445312e+02 -5.3272197723388672e+01 2.6269701004028320e+01 -1.9942500305175781e+02 -5.2927299499511719e+01 2.7952398300170898e+01 -1.9953900146484375e+02 -4.8161800384521484e+01 3.1211898803710938e+01 -1.9953599548339844e+02 -4.9113998413085938e+01 3.1122400283813477e+01 -1.9952900695800781e+02 4.9853401184082031e+01 3.0923999786376953e+01 -1.9953300476074219e+02 4.9488201141357422e+01 3.1036899566650391e+01 -1.9936599731445312e+02 5.3272602081298828e+01 2.6269701004028320e+01 -1.9953900146484375e+02 4.8161800384521484e+01 3.1211898803710938e+01 -1.9953900146484375e+02 4.8161701202392578e+01 3.1211898803710938e+01 -1.9941200256347656e+02 -5.3052898406982422e+01 2.7590099334716797e+01 -1.9939898681640625e+02 5.3149700164794922e+01 2.7224899291992188e+01 -1.9942300415039062e+02 5.2942699432373047e+01 2.7912199020385742e+01 -1.9945498657226562e+02 5.2495800018310547e+01 2.8812000274658203e+01 -1.9947500610351562e+02 5.2073299407958984e+01 2.9391799926757812e+01 -1.9950000000000000e+02 5.1354198455810547e+01 3.0092800140380859e+01 -1.9951400756835938e+02 5.0763900756835938e+01 3.0500200271606445e+01 -1.9951499938964844e+02 -5.0723098754882812e+01 3.0524099349975586e+01 -1.9950099182128906e+02 -5.1319099426269531e+01 3.0120700836181641e+01 -1.9952900695800781e+02 -4.9809001922607422e+01 3.0939300537109375e+01 -1.9947599792480469e+02 -5.2044200897216797e+01 2.9426099777221680e+01 -1.9945600891113281e+02 -5.2472599029541016e+01 2.8848600387573242e+01 -3.1931399536132812e+02 3.2958000183105469e+01 3.2552600860595703e+01 -3.1934100341796875e+02 3.7412300109863281e+01 3.1794399261474609e+01 -3.1936099243164062e+02 -4.4766899108886719e+01 3.1211898803710938e+01 -3.1935501098632812e+02 -4.0767101287841797e+01 3.1400798797607422e+01 -3.1933502197265625e+02 -3.6212398529052734e+01 3.1975601196289062e+01 -3.1953399658203125e+02 -5.3272701263427734e+01 2.6267299652099609e+01 -3.1953399658203125e+02 -5.3272399902343750e+01 2.6269701004028320e+01 -3.1936099243164062e+02 -4.8161800384521484e+01 3.1211898803710938e+01 -3.1950000000000000e+02 -5.3149700164794922e+01 2.7224899291992188e+01 -3.1922998046875000e+02 1.6044300079345703e+01 3.4974899291992188e+01 -3.1935699462890625e+02 4.1614902496337891e+01 3.1332199096679688e+01 -3.1935998535156250e+02 4.2737499237060547e+01 3.1263500213623047e+01 -3.1936099243164062e+02 4.4766899108886719e+01 3.1211898803710938e+01 -3.1947698974609375e+02 -5.2942699432373047e+01 2.7912199020385742e+01 -3.1944500732421875e+02 -5.2495800018310547e+01 2.8812000274658203e+01 -3.1942498779296875e+02 -5.2073299407958984e+01 2.9391799926757812e+01 -3.1932397460937500e+02 -3.4482799530029297e+01 3.2268100738525391e+01 -3.1931399536132812e+02 -3.2958000183105469e+01 3.2552600860595703e+01 -3.1923699951171875e+02 -1.8085901260375977e+01 3.4772602081298828e+01 -3.1936099243164062e+02 4.8161701202392578e+01 3.1211898803710938e+01 -3.1936099243164062e+02 4.8161800384521484e+01 3.1211898803710938e+01 -3.1953399658203125e+02 5.3272602081298828e+01 2.6269701004028320e+01 -3.1936401367187500e+02 4.9113998413085938e+01 3.1122400283813477e+01 -3.1949899291992188e+02 5.3140598297119141e+01 2.7264499664306641e+01 -3.1947500610351562e+02 5.2927299499511719e+01 2.7952398300170898e+01 -3.1940002441406250e+02 -5.1354198455810547e+01 3.0092800140380859e+01 -3.1938601684570312e+02 -5.0763698577880859e+01 3.0500400543212891e+01 -3.1936499023437500e+02 -4.9159500122070312e+01 3.1113599777221680e+01 -3.1937100219726562e+02 -4.9853401184082031e+01 3.0923999786376953e+01 -3.1921301269531250e+02 -9.5675001144409180e+00 3.5455600738525391e+01 -3.1920401000976562e+02 -1.0257400274276733e+00 3.5717300415039062e+01 -3.1920999145507812e+02 7.5184102058410645e+00 3.5557003021240234e+01 -3.1938497924804688e+02 5.0723098754882812e+01 3.0524099349975586e+01 -3.1939898681640625e+02 5.1319099426269531e+01 3.0120700836181641e+01 -3.1937100219726562e+02 4.9809001922607422e+01 3.0939300537109375e+01 -3.1942401123046875e+02 5.2044200897216797e+01 2.9426099777221680e+01 -3.1944400024414062e+02 5.2472698211669922e+01 2.8848501205444336e+01 -3.1722598266601562e+02 5.6893596649169922e+01 2.6313199996948242e+01 -3.0677999877929688e+02 6.1777099609375000e+01 2.6118900299072266e+01 -3.0673400878906250e+02 6.1534900665283203e+01 2.8247499465942383e+01 -3.1717199707031250e+02 5.6671501159667969e+01 2.7970600128173828e+01 -3.0672799682617188e+02 6.1473102569580078e+01 2.8547599792480469e+01 -3.0672399902343750e+02 6.1429401397705078e+01 2.8691900253295898e+01 -3.0668301391601562e+02 6.0846401214599609e+01 3.0617700576782227e+01 -3.1717102050781250e+02 5.6666297912597656e+01 2.8009298324584961e+01 -3.0667098999023438e+02 6.0583499908447266e+01 3.1158599853515625e+01 -3.1713299560546875e+02 5.6301002502441406e+01 2.9183198928833008e+01 -3.1712100219726562e+02 5.6116699218750000e+01 2.9545400619506836e+01 -3.0663998413085938e+02 5.9904800415039062e+01 3.2554298400878906e+01 -3.1708300781250000e+02 5.5523498535156250e+01 3.0711999893188477e+01 -3.0663497924804688e+02 5.9761798858642578e+01 3.2791900634765625e+01 -3.0662097167968750e+02 5.9298297882080078e+01 3.3425899505615234e+01 -3.1707400512695312e+02 5.5304901123046875e+01 3.1005998611450195e+01 -3.0659698486328125e+02 5.8488296508789062e+01 3.4533702850341797e+01 -3.1705200195312500e+02 5.4790897369384766e+01 3.1697601318359375e+01 -3.0657699584960938e+02 5.7638500213623047e+01 3.5434902191162109e+01 -3.1703298950195312e+02 5.4202796936035156e+01 3.2260101318359375e+01 -3.0657699584960938e+02 5.7634498596191406e+01 3.5438102722167969e+01 -3.0654699707031250e+02 5.5966999053955078e+01 3.6813400268554688e+01 -3.1701300048828125e+02 5.3552200317382812e+01 3.2882198333740234e+01 -3.0654202270507812e+02 5.5575901031494141e+01 3.7043003082275391e+01 -3.1699899291992188e+02 5.2909797668457031e+01 3.3316501617431641e+01 -3.1699099731445312e+02 5.2534400939941406e+01 3.3570301055908203e+01 -3.0652301025390625e+02 5.4110603332519531e+01 3.7903396606445312e+01 -3.1697399902343750e+02 5.1421096801757812e+01 3.4075302124023438e+01 -3.1695800781250000e+02 4.9828498840332031e+01 3.4579799652099609e+01 -3.0650299072265625e+02 5.1504699707031250e+01 3.8854301452636719e+01 -3.1696798706054688e+02 5.0973602294921875e+01 3.4278301239013672e+01 -3.0651599121093750e+02 5.3265003204345703e+01 3.8256401062011719e+01 -3.0651797485351562e+02 5.3554401397705078e+01 3.8158100128173828e+01 -3.1695800781250000e+02 4.9787300109863281e+01 3.4590599060058594e+01 -3.0649398803710938e+02 4.9104000091552734e+01 3.9238201141357422e+01 -3.0649502563476562e+02 4.9380500793457031e+01 3.9216201782226562e+01 -3.0650000000000000e+02 5.0758201599121094e+01 3.8981502532958984e+01 -3.1695300292968750e+02 -4.4766899108886719e+01 3.4743099212646484e+01 -3.1695300292968750e+02 -4.8161701202392578e+01 3.4743099212646484e+01 -3.1192098999023438e+02 -3.3617599487304688e+01 3.6921298980712891e+01 -3.0649398803710938e+02 -4.8161701202392578e+01 3.9270797729492188e+01 -3.0828500366210938e+02 -2.2198099136352539e+01 3.8495399475097656e+01 -3.0649398803710938e+02 -1.3303299903869629e+01 3.9270797729492188e+01 -3.0649398803710938e+02 -4.8484798431396484e+01 3.9266899108886719e+01 -3.0649899291992188e+02 -5.0636299133300781e+01 3.9044200897216797e+01 -3.1695800781250000e+02 -4.9828800201416016e+01 3.4579002380371094e+01 -3.0649899291992188e+02 -5.0762199401855469e+01 3.9010498046875000e+01 -3.0651101684570312e+02 -5.2713199615478516e+01 3.8487998962402344e+01 -3.1695800781250000e+02 -4.9865100860595703e+01 3.4575500488281250e+01 -3.0651599121093750e+02 -5.3257701873779297e+01 3.8244800567626953e+01 -3.1696899414062500e+02 -5.1049301147460938e+01 3.4252201080322266e+01 -3.1697399902343750e+02 -5.1422397613525391e+01 3.4078800201416016e+01 -3.0652999877929688e+02 -5.4689800262451172e+01 3.7604999542236328e+01 -3.1699200439453125e+02 -5.2603698730468750e+01 3.3529899597167969e+01 -3.0654202270507812e+02 -5.5566898345947266e+01 3.7031799316406250e+01 -3.1699899291992188e+02 -5.2910701751708984e+01 3.3318199157714844e+01 -3.0655599975585938e+02 -5.6493301391601562e+01 3.6426399230957031e+01 -3.1701498413085938e+02 -5.3612300872802734e+01 3.2834701538085938e+01 -3.0662097167968750e+02 -5.9306701660156250e+01 3.3434497833251953e+01 -3.0661300659179688e+02 -5.9070098876953125e+01 3.3809101104736328e+01 -3.1705297851562500e+02 -5.4840698242187500e+01 3.1639200210571289e+01 -3.0657699584960938e+02 -5.7638500213623047e+01 3.5434902191162109e+01 -3.1703298950195312e+02 -5.4202499389648438e+01 3.2260299682617188e+01 -3.0657699584960938e+02 -5.7634597778320312e+01 3.5438198089599609e+01 -3.0655899047851562e+02 -5.6710102081298828e+01 3.6255298614501953e+01 -3.1707400512695312e+02 -5.5303497314453125e+01 3.1005100250244141e+01 -3.1708499145507812e+02 -5.5562896728515625e+01 3.0649700164794922e+01 -3.0665298461914062e+02 -6.0219200134277344e+01 3.1989601135253906e+01 -3.1712100219726562e+02 -5.6113498687744141e+01 2.9543998718261719e+01 -3.1717199707031250e+02 -5.6673297882080078e+01 2.7970500946044922e+01 -3.0670800781250000e+02 -6.1249599456787109e+01 2.9430400848388672e+01 -3.1713500976562500e+02 -5.6327400207519531e+01 2.9114601135253906e+01 -3.0667098999023438e+02 -6.0594600677490234e+01 3.1166101455688477e+01 -3.0666400146484375e+02 -6.0485900878906250e+01 3.1454298019409180e+01 -3.1717300415039062e+02 -5.6682003021240234e+01 2.7941699981689453e+01 -3.1722598266601562e+02 -5.6893596649169922e+01 2.6313199996948242e+01 -3.0677999877929688e+02 -6.1777099609375000e+01 2.6118900299072266e+01 -3.0676000976562500e+02 -6.1713199615478516e+01 2.7046798706054688e+01 -3.0675399780273438e+02 -6.1681999206542969e+01 2.7321500778198242e+01 -3.0672500610351562e+02 -6.1402000427246094e+01 2.8687400817871094e+01 -2.1211900329589844e+02 6.1777099609375000e+01 2.6118900299072266e+01 -2.0167399597167969e+02 5.6893596649169922e+01 2.6313199996948242e+01 -2.0172700500488281e+02 5.6682003021240234e+01 2.7941699981689453e+01 -2.1213999938964844e+02 6.1713199615478516e+01 2.7046798706054688e+01 -2.1214599609375000e+02 6.1681999206542969e+01 2.7321500778198242e+01 -2.0172799682617188e+02 5.6673297882080078e+01 2.7970500946044922e+01 -2.1217500305175781e+02 6.1402000427246094e+01 2.8687400817871094e+01 -2.1219200134277344e+02 6.1249599456787109e+01 2.9430400848388672e+01 -2.0176499938964844e+02 5.6327400207519531e+01 2.9114601135253906e+01 -2.1222900390625000e+02 6.0594600677490234e+01 3.1166101455688477e+01 -2.0177899169921875e+02 5.6113498687744141e+01 2.9543998718261719e+01 -2.0184700012207031e+02 5.4840698242187500e+01 3.1639200210571289e+01 -2.0182600402832031e+02 5.5303497314453125e+01 3.1005100250244141e+01 -2.1227900695800781e+02 5.9306701660156250e+01 3.3434497833251953e+01 -2.0181498718261719e+02 5.5562896728515625e+01 3.0649700164794922e+01 -2.1224699401855469e+02 6.0219200134277344e+01 3.1989601135253906e+01 -2.1223600769042969e+02 6.0485900878906250e+01 3.1454298019409180e+01 -2.1228698730468750e+02 5.9070098876953125e+01 3.3809101104736328e+01 -2.1232299804687500e+02 5.7638500213623047e+01 3.5434902191162109e+01 -2.0186700439453125e+02 5.4202499389648438e+01 3.2260299682617188e+01 -2.1232299804687500e+02 5.7634597778320312e+01 3.5438198089599609e+01 -2.0188499450683594e+02 5.3612300872802734e+01 3.2834701538085938e+01 -2.1234098815917969e+02 5.6710102081298828e+01 3.6255298614501953e+01 -2.1234400939941406e+02 5.6493301391601562e+01 3.6426399230957031e+01 -2.0190100097656250e+02 5.2910701751708984e+01 3.3318199157714844e+01 -2.1235699462890625e+02 5.5566898345947266e+01 3.7031799316406250e+01 -2.0190800476074219e+02 5.2604000091552734e+01 3.3529598236083984e+01 -2.1236999511718750e+02 5.4689800262451172e+01 3.7604999542236328e+01 -2.0192599487304688e+02 5.1422397613525391e+01 3.4078800201416016e+01 -2.1238400268554688e+02 5.3257701873779297e+01 3.8244800567626953e+01 -2.0193099975585938e+02 5.1049301147460938e+01 3.4252201080322266e+01 -2.1238900756835938e+02 5.2713199615478516e+01 3.8487998962402344e+01 -2.0193800354003906e+02 5.0426403045654297e+01 3.4444599151611328e+01 -2.1240100097656250e+02 5.0762199401855469e+01 3.9010498046875000e+01 -2.0194000244140625e+02 4.9821498870849609e+01 3.4524299621582031e+01 -2.1240100097656250e+02 5.0636299133300781e+01 3.9044200897216797e+01 -2.0194700622558594e+02 4.8161701202392578e+01 3.4743099212646484e+01 -2.1240599060058594e+02 4.8484798431396484e+01 3.9266899108886719e+01 -2.1240599060058594e+02 4.8161701202392578e+01 3.9270797729492188e+01 -2.0194700622558594e+02 -4.8161701202392578e+01 3.4743099212646484e+01 -2.1240599060058594e+02 -4.8161701202392578e+01 3.9270797729492188e+01 -2.0194200134277344e+02 -4.9787300109863281e+01 3.4590599060058594e+01 -2.1240599060058594e+02 -4.9104000091552734e+01 3.9238201141357422e+01 -2.1240499877929688e+02 -4.9380500793457031e+01 3.9216201782226562e+01 -2.0194200134277344e+02 -4.9828498840332031e+01 3.4579799652099609e+01 -2.1240000915527344e+02 -5.0758201599121094e+01 3.8981502532958984e+01 -2.1239698791503906e+02 -5.1504699707031250e+01 3.8854301452636719e+01 -2.0193199157714844e+02 -5.0973602294921875e+01 3.4278301239013672e+01 -2.1238400268554688e+02 -5.3265003204345703e+01 3.8256401062011719e+01 -2.0192599487304688e+02 -5.1421096801757812e+01 3.4075302124023438e+01 -2.1238200378417969e+02 -5.3554401397705078e+01 3.8158100128173828e+01 -2.1237699890136719e+02 -5.4110603332519531e+01 3.7903396606445312e+01 -2.0190901184082031e+02 -5.2534400939941406e+01 3.3570301055908203e+01 -2.1235800170898438e+02 -5.5575901031494141e+01 3.7043003082275391e+01 -2.0190100097656250e+02 -5.2909797668457031e+01 3.3316501617431641e+01 -2.0188699340820312e+02 -5.3552200317382812e+01 3.2882198333740234e+01 -2.1235301208496094e+02 -5.5966999053955078e+01 3.6813400268554688e+01 -2.0186700439453125e+02 -5.4202796936035156e+01 3.2260101318359375e+01 -2.1232299804687500e+02 -5.7634498596191406e+01 3.5438102722167969e+01 -2.1232299804687500e+02 -5.7638500213623047e+01 3.5434902191162109e+01 -2.0184800720214844e+02 -5.4790897369384766e+01 3.1697601318359375e+01 -2.1230299377441406e+02 -5.8488296508789062e+01 3.4533702850341797e+01 -2.0182600402832031e+02 -5.5304901123046875e+01 3.1005998611450195e+01 -2.1227900695800781e+02 -5.9298297882080078e+01 3.3425899505615234e+01 -2.0181700134277344e+02 -5.5523300170898438e+01 3.0712301254272461e+01 -2.1226499938964844e+02 -5.9761798858642578e+01 3.2791900634765625e+01 -2.1225999450683594e+02 -5.9904800415039062e+01 3.2554298400878906e+01 -2.0177899169921875e+02 -5.6116699218750000e+01 2.9545400619506836e+01 -2.1222900390625000e+02 -6.0583499908447266e+01 3.1158599853515625e+01 -2.0176699829101562e+02 -5.6301002502441406e+01 2.9183198928833008e+01 -2.1221701049804688e+02 -6.0846401214599609e+01 3.0617700576782227e+01 -2.0174699401855469e+02 -5.6515899658203125e+01 2.8565200805664062e+01 -2.1217500305175781e+02 -6.1429401397705078e+01 2.8691900253295898e+01 -2.0172700500488281e+02 -5.6617198944091797e+01 2.7961399078369141e+01 -2.1211900329589844e+02 -6.1777099609375000e+01 2.6118900299072266e+01 -2.0167399597167969e+02 -5.6893596649169922e+01 2.6313199996948242e+01 -2.1216600036621094e+02 -6.1534900665283203e+01 2.8247499465942383e+01 -2.1217199707031250e+02 -6.1473102569580078e+01 2.8547599792480469e+01 -3.1500302124023438e+02 7.6922802925109863e+00 3.9408100128173828e+01 -3.1499798583984375e+02 -4.2878498788923025e-04 3.9552497863769531e+01 -3.0813101196289062e+02 3.7285101413726807e+00 3.9175998687744141e+01 -3.1500598144531250e+02 -9.7887496948242188e+00 3.9304401397705078e+01 -3.0821697998046875e+02 -4.9552297592163086e+00 3.9150302886962891e+01 -3.1499697875976562e+02 -1.0494600534439087e+00 3.9572200775146484e+01 -3.0801599121093750e+02 -3.1563800573348999e-01 3.9209102630615234e+01 -3.0802499389648438e+02 0.0000000000000000e+00 3.9206501007080078e+01 -3.1502999877929688e+02 -1.8504100799560547e+01 3.8605602264404297e+01 -3.1510800170898438e+02 -3.3720096588134766e+01 3.6334201812744141e+01 -3.1461901855468750e+02 -3.2514999389648438e+01 3.6538101196289062e+01 -3.1098199462890625e+02 -2.1469301223754883e+01 3.8054298400878906e+01 -3.1007501220703125e+02 -1.7110500335693359e+01 3.8432697296142578e+01 -3.1502597045898438e+02 -1.7137899398803711e+01 3.8715103149414062e+01 -3.0919097900390625e+02 -1.2866299629211426e+01 3.8801200866699219e+01 -3.0878201293945312e+02 -1.0073800086975098e+01 3.8961601257324219e+01 -3.0854098510742188e+02 8.1958198547363281e+00 3.9046501159667969e+01 -3.0919097900390625e+02 1.2866299629211426e+01 3.8801200866699219e+01 -3.1502301025390625e+02 1.6415399551391602e+01 3.8812599182128906e+01 -3.1013699340820312e+02 1.7107799530029297e+01 3.8406700134277344e+01 -3.1502597045898438e+02 1.7135400772094727e+01 3.8709499359130859e+01 -3.1164898681640625e+02 2.3887998580932617e+01 3.7776199340820312e+01 -3.1510800170898438e+02 3.3720096588134766e+01 3.6334201812744141e+01 -3.0623400878906250e+02 8.4742298126220703e+00 3.9372699737548828e+01 -3.0606900024414062e+02 3.8552300930023193e+00 3.9426597595214844e+01 -3.0602301025390625e+02 -3.2636201381683350e-01 3.9440299987792969e+01 -3.0610400390625000e+02 -5.1235499382019043e+00 3.9415901184082031e+01 -3.0632998657226562e+02 -1.0416000366210938e+01 3.9337398529052734e+01 -3.0558401489257812e+02 6.2122200012207031e+01 2.6099000930786133e+01 -2.1331599426269531e+02 -6.2122200012207031e+01 2.6099000930786133e+01 -2.0051699829101562e+02 5.6057201385498047e+01 2.6323200225830078e+01 -2.0045700073242188e+02 5.6013599395751953e+01 2.6323699951171875e+01 -1.9963600158691406e+02 5.4674098968505859e+01 2.6307399749755859e+01 -1.9965000915527344e+02 5.4747001647949219e+01 2.6309400558471680e+01 -2.0130999755859375e+02 4.8161701202392578e+01 3.4319000244140625e+01 -2.0072300720214844e+02 4.8161701202392578e+01 3.3895500183105469e+01 -2.0070199584960938e+02 5.0197399139404297e+01 3.3635501861572266e+01 -2.0076499938964844e+02 4.8161701202392578e+01 3.3956298828125000e+01 -2.0050599670410156e+02 5.5822799682617188e+01 2.7790199279785156e+01 -2.0054100036621094e+02 5.5503601074218750e+01 2.8844799041748047e+01 -2.0058799743652344e+02 5.4815799713134766e+01 3.0224901199340820e+01 -2.0061700439453125e+02 5.4166202545166016e+01 3.1114200592041016e+01 -2.0065299987792969e+02 5.3061599731445312e+01 3.2188697814941406e+01 -2.0067399597167969e+02 5.2155097961425781e+01 3.2813301086425781e+01 -2.0069599914550781e+02 5.0757499694824219e+01 3.3462600708007812e+01 -1.9988600158691406e+02 4.8175899505615234e+01 3.2657100677490234e+01 -1.9986100769042969e+02 4.9869400024414062e+01 3.2444099426269531e+01 -1.9985600280761719e+02 5.0339302062988281e+01 3.2298999786376953e+01 -1.9983700561523438e+02 5.1511802673339844e+01 3.1754098892211914e+01 -1.9981900024414062e+02 5.2272098541259766e+01 3.1230098724365234e+01 -1.9978800964355469e+02 5.3198596954345703e+01 3.0328399658203125e+01 -1.9976200866699219e+02 5.3743198394775391e+01 2.9582201004028320e+01 -1.9972300720214844e+02 5.4319900512695312e+01 2.8424301147460938e+01 -1.9969200134277344e+02 5.4587402343750000e+01 2.7539499282836914e+01 -1.9988099670410156e+02 4.8161701202392578e+01 3.2660999298095703e+01 -1.9983999633789062e+02 4.8161701202392578e+01 3.2600101470947266e+01 -1.9985299682617188e+02 -4.8161701202392578e+01 3.2597198486328125e+01 -1.9986900329589844e+02 -4.8161701202392578e+01 3.2669300079345703e+01 -2.0071099853515625e+02 -4.8161598205566406e+01 3.3903800964355469e+01 -2.0077200317382812e+02 -4.8161598205566406e+01 3.3945301055908203e+01 -1.9986500549316406e+02 -4.9387500762939453e+01 3.2554298400878906e+01 -2.0052499389648438e+02 -5.5673202514648438e+01 2.8350799560546875e+01 -2.0083700561523438e+02 -5.6300598144531250e+01 2.6321699142456055e+01 -2.0047000122070312e+02 -5.6005599975585938e+01 2.6324300765991211e+01 -2.0050900268554688e+02 -5.6068099975585938e+01 2.6325000762939453e+01 -2.0070600891113281e+02 -4.9622901916503906e+01 3.3766700744628906e+01 -2.0069700622558594e+02 -5.0689399719238281e+01 3.3486103057861328e+01 -2.0067599487304688e+02 -5.2092498779296875e+01 3.2849800109863281e+01 -2.0065499877929688e+02 -5.3007598876953125e+01 3.2231498718261719e+01 -2.0061900329589844e+02 -5.4121501922607422e+01 3.1166700363159180e+01 -2.0058900451660156e+02 -5.4780097961425781e+01 3.0281101226806641e+01 -2.0054299926757812e+02 -5.5479797363281250e+01 2.8906398773193359e+01 -1.9985699462890625e+02 -5.0282199859619141e+01 3.2318801879882812e+01 -1.9983799743652344e+02 -5.1459201812744141e+01 3.1784799575805664e+01 -1.9981999206542969e+02 -5.2226799011230469e+01 3.1265899658203125e+01 -1.9979000854492188e+02 -5.3161098480224609e+01 3.0372501373291016e+01 -1.9976399230957031e+02 -5.3713401794433594e+01 2.9629400253295898e+01 -1.9972399902343750e+02 -5.4299999237060547e+01 2.8476100921630859e+01 -1.9970799255371094e+02 -5.4462100982666016e+01 2.8009698867797852e+01 -1.9966799926757812e+02 -5.4734798431396484e+01 2.6322200775146484e+01 -1.9966200256347656e+02 -5.4739097595214844e+01 2.6308198928833008e+01 -1.9962200927734375e+02 -5.4676601409912109e+01 2.6307399749755859e+01 -3.1663299560546875e+02 4.2921901702880859e+01 3.4912300109863281e+01 -3.1645501708984375e+02 4.1891300201416016e+01 3.5029800415039062e+01 -3.1579199218750000e+02 3.7972698211669922e+01 3.5589797973632812e+01 -3.1530801391601562e+02 3.4964099884033203e+01 3.6116397857666016e+01 -3.1533898925781250e+02 -3.5187099456787109e+01 3.6065998077392578e+01 -3.1560501098632812e+02 -3.6837001800537109e+01 3.5777801513671875e+01 -3.1632000732421875e+02 -4.1108398437500000e+01 3.5128501892089844e+01 -3.1838299560546875e+02 5.6057201385498047e+01 2.6323200225830078e+01 -3.1926400756835938e+02 5.4674098968505859e+01 2.6307399749755859e+01 -3.1925000000000000e+02 5.4747001647949219e+01 2.6309400558471680e+01 -3.1844299316406250e+02 5.6013599395751953e+01 2.6323699951171875e+01 -3.1905999755859375e+02 4.8161701202392578e+01 3.2600101470947266e+01 -3.1901898193359375e+02 4.8161701202392578e+01 3.2660999298095703e+01 -3.1901400756835938e+02 4.8175899505615234e+01 3.2657703399658203e+01 -3.1758999633789062e+02 4.8161701202392578e+01 3.4319000244140625e+01 -3.1817700195312500e+02 4.8161701202392578e+01 3.3895500183105469e+01 -3.1813497924804688e+02 4.8161701202392578e+01 3.3956298828125000e+01 -3.1819400024414062e+02 4.9622901916503906e+01 3.3766700744628906e+01 -3.1835699462890625e+02 5.5479797363281250e+01 2.8906398773193359e+01 -3.1839199829101562e+02 5.5808700561523438e+01 2.7850999832153320e+01 -3.1820300292968750e+02 5.0689399719238281e+01 3.3486103057861328e+01 -3.1822399902343750e+02 5.2092498779296875e+01 3.2849800109863281e+01 -3.1824499511718750e+02 5.3007598876953125e+01 3.2231498718261719e+01 -3.1828100585937500e+02 5.4121501922607422e+01 3.1166700363159180e+01 -3.1831100463867188e+02 5.4780300140380859e+01 3.0280799865722656e+01 -3.1903500366210938e+02 4.9387500762939453e+01 3.2554298400878906e+01 -3.1904299926757812e+02 5.0282199859619141e+01 3.2318801879882812e+01 -3.1906198120117188e+02 5.1459201812744141e+01 3.1784799575805664e+01 -3.1907901000976562e+02 5.2226799011230469e+01 3.1265899658203125e+01 -3.1911001586914062e+02 5.3161098480224609e+01 3.0372501373291016e+01 -3.1913598632812500e+02 5.3713500976562500e+01 2.9629199981689453e+01 -3.1917599487304688e+02 5.4299999237060547e+01 2.8476100921630859e+01 -3.1920599365234375e+02 5.4575599670410156e+01 2.7590398788452148e+01 -3.1791101074218750e+02 4.4766899108886719e+01 3.4156299591064453e+01 -3.1811199951171875e+02 4.4766899108886719e+01 3.3935497283935547e+01 -3.1866799926757812e+02 4.4766899108886719e+01 3.3326202392578125e+01 -3.1903298950195312e+02 4.4766899108886719e+01 3.2586399078369141e+01 -3.1916497802734375e+02 4.4766899108886719e+01 3.2318199157714844e+01 -3.1714901733398438e+02 3.7908699035644531e+01 3.5189300537109375e+01 -3.1770700073242188e+02 4.2892898559570312e+01 3.4360698699951172e+01 -3.1913598632812500e+02 4.2796298980712891e+01 3.2449199676513672e+01 -3.1856701660156250e+02 4.2849601745605469e+01 3.3513900756835938e+01 -3.1759197998046875e+02 4.1850101470947266e+01 3.4503601074218750e+01 -3.1850900268554688e+02 4.1785797119140625e+01 3.3652202606201172e+01 -3.1911798095703125e+02 4.1704799652099609e+01 3.2559303283691406e+01 -3.1827999877929688e+02 3.7782501220703125e+01 3.4345703125000000e+01 -3.1904199218750000e+02 3.7609802246093750e+01 3.3164699554443359e+01 -3.1666897583007812e+02 3.3666099548339844e+01 3.6110301971435547e+01 -3.1801998901367188e+02 3.3501899719238281e+01 3.5310802459716797e+01 -3.1895001220703125e+02 3.3252899169921875e+01 3.4059902191162109e+01 -3.1666897583007812e+02 -3.3666099548339844e+01 3.6110301971435547e+01 -3.1801998901367188e+02 -3.3501899719238281e+01 3.5310802459716797e+01 -3.1659100341796875e+02 -1.8474500656127930e+01 3.8377502441406250e+01 -3.1895001220703125e+02 -3.3252899169921875e+01 3.4059902191162109e+01 -3.1794198608398438e+02 -1.8384300231933594e+01 3.7566699981689453e+01 -3.1887200927734375e+02 -1.8247699737548828e+01 3.6299301147460938e+01 -3.1656701660156250e+02 -9.7730197906494141e+00 3.9075099945068359e+01 -3.1655801391601562e+02 -1.0477900505065918e+00 3.9342300415039062e+01 -3.1656399536132812e+02 7.6799402236938477e+00 3.9178600311279297e+01 -3.1658398437500000e+02 1.6388999938964844e+01 3.8584197998046875e+01 -3.1791799926757812e+02 -9.7253303527832031e+00 3.8260898590087891e+01 -3.1790899658203125e+02 -1.0426599979400635e+00 3.8526798248291016e+01 -3.1791400146484375e+02 7.6424498558044434e+00 3.8363800048828125e+01 -3.1793499755859375e+02 1.6309000015258789e+01 3.7772399902343750e+01 -3.1884802246093750e+02 -9.6530895233154297e+00 3.6988399505615234e+01 -3.1883901977539062e+02 -1.0349099636077881e+00 3.7252300262451172e+01 -3.1884500122070312e+02 7.5856399536132812e+00 3.7090499877929688e+01 -3.1886499023437500e+02 1.6187799453735352e+01 3.6503398895263672e+01 -3.1898300170898438e+02 -3.4746402740478516e+01 3.3729900360107422e+01 -3.1810998535156250e+02 -3.4971698760986328e+01 3.4959098815917969e+01 -3.1683401489257812e+02 -3.5126102447509766e+01 3.5777400970458984e+01 -3.1901800537109375e+02 -3.6437900543212891e+01 3.3384098052978516e+01 -3.1821099853515625e+02 -3.6633201599121094e+01 3.4586002349853516e+01 -3.1910397338867188e+02 -4.0879802703857422e+01 3.2658302307128906e+01 -3.1846401977539062e+02 -4.0980899810791016e+01 3.3770999908447266e+01 -3.1916497802734375e+02 -4.4766899108886719e+01 3.2318199157714844e+01 -3.1903298950195312e+02 -4.4766899108886719e+01 3.2586399078369141e+01 -3.1866799926757812e+02 -4.4766899108886719e+01 3.3326202392578125e+01 -3.1811199951171875e+02 -4.4766899108886719e+01 3.3935497283935547e+01 -3.1701998901367188e+02 -3.6772399902343750e+01 3.5421100616455078e+01 -3.1750399780273438e+02 -4.1059799194335938e+01 3.4623897552490234e+01 -3.1791101074218750e+02 -4.4766899108886719e+01 3.4156299591064453e+01 -3.1904699707031250e+02 -4.8161701202392578e+01 3.2597198486328125e+01 -3.1903100585937500e+02 -4.8161701202392578e+01 3.2669300079345703e+01 -3.1818899536132812e+02 -4.8161598205566406e+01 3.3903800964355469e+01 -3.1812799072265625e+02 -4.8161598205566406e+01 3.3945301055908203e+01 -3.1927801513671875e+02 -5.4676601409912109e+01 2.6307399749755859e+01 -3.1923800659179688e+02 -5.4739097595214844e+01 2.6308198928833008e+01 -3.1923199462890625e+02 -5.4735401153564453e+01 2.6322299957275391e+01 -3.1806298828125000e+02 -5.6300598144531250e+01 2.6321699142456055e+01 -3.1842999267578125e+02 -5.6005599975585938e+01 2.6324300765991211e+01 -3.1839099121093750e+02 -5.6068099975585938e+01 2.6325000762939453e+01 -3.1839401245117188e+02 -5.5822799682617188e+01 2.7790199279785156e+01 -3.1820397949218750e+02 -5.0757499694824219e+01 3.3462600708007812e+01 -3.1819400024414062e+02 -4.9692897796630859e+01 3.3753101348876953e+01 -3.1835897827148438e+02 -5.5503601074218750e+01 2.8844799041748047e+01 -3.1831198120117188e+02 -5.4815799713134766e+01 3.0224901199340820e+01 -3.1828298950195312e+02 -5.4166202545166016e+01 3.1114200592041016e+01 -3.1824697875976562e+02 -5.3061599731445312e+01 3.2188697814941406e+01 -3.1822601318359375e+02 -5.2154800415039062e+01 3.2813499450683594e+01 -3.1920800781250000e+02 -5.4587402343750000e+01 2.7539499282836914e+01 -3.1917700195312500e+02 -5.4319900512695312e+01 2.8424301147460938e+01 -3.1913800048828125e+02 -5.3743198394775391e+01 2.9582201004028320e+01 -3.1911199951171875e+02 -5.3198596954345703e+01 3.0328399658203125e+01 -3.1908099365234375e+02 -5.2272098541259766e+01 3.1230098724365234e+01 -3.1906301879882812e+02 -5.1511501312255859e+01 3.1754299163818359e+01 -3.1904400634765625e+02 -5.0339302062988281e+01 3.2298999786376953e+01 -3.1903500366210938e+02 -4.9446197509765625e+01 3.2542900085449219e+01 -3.1615798950195312e+02 4.4766899108886719e+01 3.2907699584960938e+01 -3.1615798950195312e+02 4.8161701202392578e+01 3.2907699584960938e+01 -3.1198999023437500e+02 3.5788497924804688e+01 3.4712001800537109e+01 -3.0569900512695312e+02 4.8161701202392578e+01 3.7435401916503906e+01 -3.0812200927734375e+02 2.4574600219726562e+01 3.6386299133300781e+01 -3.0569900512695312e+02 1.3303299903869629e+01 3.7435401916503906e+01 -3.0490402221679688e+02 -4.8161701202392578e+01 3.7599998474121094e+01 -2.1399499511718750e+02 -4.8161701202392578e+01 3.7599998474121094e+01 -3.0490499877929688e+02 -4.8445899963378906e+01 3.7596599578857422e+01 -2.1399499511718750e+02 -4.8990497589111328e+01 3.7571300506591797e+01 -3.0490802001953125e+02 -5.0488098144531250e+01 3.7372299194335938e+01 -2.1399000549316406e+02 -5.0955001831054688e+01 3.7270401000976562e+01 -3.0491400146484375e+02 -5.1784297943115234e+01 3.7016799926757812e+01 -2.1398599243164062e+02 -5.1776599884033203e+01 3.6997398376464844e+01 -3.0491598510742188e+02 -5.2166397094726562e+01 3.6912002563476562e+01 -2.1398001098632812e+02 -5.2906299591064453e+01 3.6622200012207031e+01 -3.0492898559570312e+02 -5.4038799285888672e+01 3.6062301635742188e+01 -2.1386698913574219e+02 -5.9433799743652344e+01 2.9615200042724609e+01 -3.0503298950195312e+02 -5.9426097869873047e+01 2.9610399246215820e+01 -3.0501498413085938e+02 -5.9011798858642578e+01 3.0725900650024414e+01 -2.1397801208496094e+02 -5.3118900299072266e+01 3.6528198242187500e+01 -2.1396200561523438e+02 -5.4904598236083984e+01 3.5526302337646484e+01 -3.0493997192382812e+02 -5.5057102203369141e+01 3.5373500823974609e+01 -2.1396000671386719e+02 -5.5068599700927734e+01 3.5392997741699219e+01 -3.0494699096679688e+02 -5.5684299468994141e+01 3.4949398040771484e+01 -2.1394099426269531e+02 -5.6501899719238281e+01 3.4227901458740234e+01 -3.0495898437500000e+02 -5.6501899719238281e+01 3.4227901458740234e+01 -2.1393099975585938e+02 -5.7150501251220703e+01 3.3549900054931641e+01 -3.0498098754882812e+02 -5.7707099914550781e+01 3.2843898773193359e+01 -2.1391900634765625e+02 -5.7685401916503906e+01 3.2829399108886719e+01 -3.0498400878906250e+02 -5.7853797912597656e+01 3.2675601959228516e+01 -2.1390399169921875e+02 -5.8372898101806641e+01 3.1903301239013672e+01 -2.1387599182128906e+02 -5.9273399353027344e+01 3.0130998611450195e+01 -3.0504598999023438e+02 -5.9727699279785156e+01 2.8798099517822266e+01 -2.1384399414062500e+02 -5.9883800506591797e+01 2.8167400360107422e+01 -3.0507699584960938e+02 -6.0096900939941406e+01 2.6845499038696289e+01 -2.1380900573730469e+02 -6.0154399871826172e+01 2.6018800735473633e+01 -3.0509100341796875e+02 -6.0154399871826172e+01 2.6018800735473633e+01 -2.1399499511718750e+02 4.8161701202392578e+01 3.7599998474121094e+01 -3.0490402221679688e+02 4.8161701202392578e+01 3.7599998474121094e+01 -3.0509100341796875e+02 6.0154399871826172e+01 2.6018800735473633e+01 -2.1380900573730469e+02 6.0154399871826172e+01 2.6018800735473633e+01 -2.1382299804687500e+02 6.0096900939941406e+01 2.6845499038696289e+01 -3.0505599975585938e+02 5.9883800506591797e+01 2.8167400360107422e+01 -2.1385400390625000e+02 5.9727699279785156e+01 2.8798099517822266e+01 -3.0503298950195312e+02 5.9433799743652344e+01 2.9615200042724609e+01 -2.1386698913574219e+02 5.9426097869873047e+01 2.9610399246215820e+01 -2.1388499450683594e+02 5.9011798858642578e+01 3.0725900650024414e+01 -2.1397100830078125e+02 5.4038799285888672e+01 3.6062301635742188e+01 -3.0493798828125000e+02 5.4904598236083984e+01 3.5526302337646484e+01 -2.1396000671386719e+02 5.5057102203369141e+01 3.5373500823974609e+01 -3.0493997192382812e+02 5.5068599700927734e+01 3.5392997741699219e+01 -2.1395300292968750e+02 5.5684299468994141e+01 3.4949398040771484e+01 -3.0495898437500000e+02 5.6501899719238281e+01 3.4227901458740234e+01 -2.1394099426269531e+02 5.6501899719238281e+01 3.4227901458740234e+01 -3.0496902465820312e+02 5.7150501251220703e+01 3.3549900054931641e+01 -2.1391900634765625e+02 5.7707099914550781e+01 3.2843898773193359e+01 -3.0498098754882812e+02 5.7685401916503906e+01 3.2829399108886719e+01 -2.1391600036621094e+02 5.7853797912597656e+01 3.2675601959228516e+01 -3.0499600219726562e+02 5.8372898101806641e+01 3.1903301239013672e+01 -3.0502398681640625e+02 5.9273399353027344e+01 3.0130998611450195e+01 -2.1399499511718750e+02 4.8445899963378906e+01 3.7596599578857422e+01 -3.0490499877929688e+02 4.8990497589111328e+01 3.7571300506591797e+01 -2.1399200439453125e+02 5.0488098144531250e+01 3.7372299194335938e+01 -3.0491000366210938e+02 5.0955001831054688e+01 3.7270401000976562e+01 -2.1398599243164062e+02 5.1784297943115234e+01 3.7016799926757812e+01 -3.0491400146484375e+02 5.1776599884033203e+01 3.6997398376464844e+01 -2.1398399353027344e+02 5.2166397094726562e+01 3.6912002563476562e+01 -3.0491998291015625e+02 5.2906299591064453e+01 3.6622200012207031e+01 -3.0492202758789062e+02 5.3118900299072266e+01 3.6528198242187500e+01 -3.0509100341796875e+02 6.0154399871826172e+01 2.6017000198364258e+01 -2.1380900573730469e+02 6.0154399871826172e+01 2.6017000198364258e+01 -2.1380900573730469e+02 -6.0154399871826172e+01 2.6017000198364258e+01 -3.0509100341796875e+02 -6.0154399871826172e+01 2.6017000198364258e+01 -2.0139799499511719e+02 5.3149700164794922e+01 2.7155099868774414e+01 -2.0136499023437500e+02 5.3272602081298828e+01 2.6199899673461914e+01 -2.0152699279785156e+02 4.9853401184082031e+01 3.0854198455810547e+01 -2.0153399658203125e+02 -4.9113998413085938e+01 3.1052600860595703e+01 -2.0153700256347656e+02 -4.8161800384521484e+01 3.1142101287841797e+01 -2.0142399597167969e+02 -5.2927299499511719e+01 2.7882600784301758e+01 -2.0153099060058594e+02 4.9488201141357422e+01 3.0967000961303711e+01 -2.0141099548339844e+02 -5.3052898406982422e+01 2.7520299911499023e+01 -2.0153700256347656e+02 4.8161701202392578e+01 3.1142101287841797e+01 -2.0153700256347656e+02 4.8161800384521484e+01 3.1142101287841797e+01 -2.0136499023437500e+02 -5.3272701263427734e+01 2.6197500228881836e+01 -2.0136499023437500e+02 -5.3272602081298828e+01 2.6199899673461914e+01 -2.0147000122070312e+02 5.2157199859619141e+01 2.9219699859619141e+01 -2.0149800109863281e+02 5.1354198455810547e+01 3.0022998809814453e+01 -2.0150999450683594e+02 5.0876800537109375e+01 3.0361700057983398e+01 -2.0145399475097656e+02 5.2495800018310547e+01 2.8742198944091797e+01 -2.0141799926757812e+02 5.2987998962402344e+01 2.7718198776245117e+01 -2.0145899963378906e+02 -5.2400199890136719e+01 2.8889299392700195e+01 -2.0147499084472656e+02 -5.2044200897216797e+01 2.9356300354003906e+01 -2.0152899169921875e+02 -4.9683399200439453e+01 3.0910400390625000e+01 -2.0150199890136719e+02 -5.1213996887207031e+01 3.0131200790405273e+01 -2.0151300048828125e+02 -5.0723098754882812e+01 3.0454299926757812e+01 -3.1753500366210938e+02 -5.3272701263427734e+01 2.6197500228881836e+01 -3.1736300659179688e+02 -4.4766899108886719e+01 3.1142101287841797e+01 -3.1732601928710938e+02 -3.4482799530029297e+01 3.2198299407958984e+01 -3.1733502197265625e+02 -3.6002799987792969e+01 3.1939302444458008e+01 -3.1735598754882812e+02 -4.0667198181152344e+01 3.1340099334716797e+01 -3.1736300659179688e+02 4.4766899108886719e+01 3.1142101287841797e+01 -3.1736099243164062e+02 4.2737499237060547e+01 3.1193698883056641e+01 -3.1736300659179688e+02 4.8161701202392578e+01 3.1142101287841797e+01 -3.1753500366210938e+02 -5.3272602081298828e+01 2.6199899673461914e+01 -3.1736300659179688e+02 -4.8161800384521484e+01 3.1142101287841797e+01 -3.1750198364257812e+02 -5.3149700164794922e+01 2.7155099868774414e+01 -3.1735800170898438e+02 4.1696102142333984e+01 3.1256500244140625e+01 -3.1734201049804688e+02 3.7450397491455078e+01 3.1719099044799805e+01 -3.1731600952148438e+02 3.2958000183105469e+01 3.2482898712158203e+01 -3.1740200805664062e+02 -5.1354198455810547e+01 3.0022998809814453e+01 -3.1742999267578125e+02 -5.2157199859619141e+01 2.9219699859619141e+01 -3.1721499633789062e+02 -9.8107404708862305e+00 3.5372200012207031e+01 -3.1727798461914062e+02 -2.6897100448608398e+01 3.3547302246093750e+01 -3.1731600952148438e+02 -3.2958000183105469e+01 3.2482898712158203e+01 -3.1744598388671875e+02 -5.2495800018310547e+01 2.8742198944091797e+01 -3.1748199462890625e+02 -5.2987998962402344e+01 2.7718198776245117e+01 -3.1723098754882812e+02 1.5947299003601074e+01 3.4914096832275391e+01 -3.1721099853515625e+02 7.3723797798156738e+00 3.5493400573730469e+01 -3.1720501708984375e+02 -1.2206400632858276e+00 3.5646202087402344e+01 -3.1736300659179688e+02 4.8161800384521484e+01 3.1142101287841797e+01 -3.1753500366210938e+02 5.3272602081298828e+01 2.6199899673461914e+01 -3.1736599731445312e+02 4.9113998413085938e+01 3.1052600860595703e+01 -3.1749600219726562e+02 5.3108699798583984e+01 2.7323200225830078e+01 -3.1747601318359375e+02 5.2927299499511719e+01 2.7882600784301758e+01 -3.1738998413085938e+02 -5.0876697540283203e+01 3.0361799240112305e+01 -3.1736697387695312e+02 -4.9289199829101562e+01 3.1016201019287109e+01 -3.1737301635742188e+02 -4.9853401184082031e+01 3.0854198455810547e+01 -3.1744097900390625e+02 5.2400199890136719e+01 2.8889200210571289e+01 -3.1742501831054688e+02 5.2044200897216797e+01 2.9356300354003906e+01 -3.1737100219726562e+02 4.9683399200439453e+01 3.0910400390625000e+01 -3.1739801025390625e+02 5.1213996887207031e+01 3.0131200790405273e+01 -3.1738598632812500e+02 5.0723098754882812e+01 3.0454299926757812e+01 -3.0593600463867188e+02 5.9966602325439453e+01 2.6026201248168945e+01 -3.1638101196289062e+02 5.5083099365234375e+01 2.6220399856567383e+01 -3.0593600463867188e+02 5.9966499328613281e+01 2.6028400421142578e+01 -3.0589199829101562e+02 5.9701599121093750e+01 2.8143501281738281e+01 -3.1633697509765625e+02 5.4890598297119141e+01 2.7533899307250977e+01 -3.0588900756835938e+02 5.9662899017333984e+01 2.8268299102783203e+01 -3.1632998657226562e+02 5.4860099792480469e+01 2.7741199493408203e+01 -3.1630502319335938e+02 5.4614101409912109e+01 2.8497999191284180e+01 -3.0585198974609375e+02 5.9101898193359375e+01 3.0076900482177734e+01 -3.1629602050781250e+02 5.4464702606201172e+01 2.8782999038696289e+01 -3.1623901367187500e+02 5.3417602539062500e+01 3.0492101669311523e+01 -3.1625698852539062e+02 5.3832099914550781e+01 2.9948801040649414e+01 -3.0580401611328125e+02 5.7811100006103516e+01 3.2368896484375000e+01 -3.1626000976562500e+02 5.3899799346923828e+01 2.9860099792480469e+01 -3.0581500244140625e+02 5.8216400146484375e+01 3.1822301864624023e+01 -3.0584500122070312e+02 5.8933799743652344e+01 3.0408399581909180e+01 -3.0578198242187500e+02 5.7013599395751953e+01 3.3444400787353516e+01 -3.0576800537109375e+02 5.6375102996826172e+01 3.4112400054931641e+01 -3.1622399902343750e+02 5.2946002960205078e+01 3.0931800842285156e+01 -3.0576800537109375e+02 5.6371700286865234e+01 3.4115200042724609e+01 -3.1620401000976562e+02 5.2293502807617188e+01 3.1540199279785156e+01 -3.0574099731445312e+02 5.4802803039550781e+01 3.5391700744628906e+01 -3.1619598388671875e+02 5.1929000854492188e+01 3.1779899597167969e+01 -3.0573898315429688e+02 5.4590602874755859e+01 3.5510799407958984e+01 -3.0572100830078125e+02 5.3044399261474609e+01 3.6378997802734375e+01 -3.1617599487304688e+02 5.0741298675537109e+01 3.2366397857666016e+01 -3.1618899536132812e+02 5.1628799438476562e+01 3.1977399826049805e+01 -3.0570001220703125e+02 4.8978199005126953e+01 3.7407100677490234e+01 -3.1616198730468750e+02 4.9450599670410156e+01 3.2786701202392578e+01 -3.0570401000976562e+02 5.0412700653076172e+01 3.7187198638916016e+01 -3.1616299438476562e+02 4.9483398437500000e+01 3.2778598785400391e+01 -3.0570599365234375e+02 5.0913200378417969e+01 3.7110401153564453e+01 -3.1616900634765625e+02 5.0221302032470703e+01 3.2594402313232422e+01 -3.0571697998046875e+02 5.2583797454833984e+01 3.6555099487304688e+01 -3.0571899414062500e+02 5.2834999084472656e+01 3.6471603393554688e+01 -3.0569900512695312e+02 -4.8161701202392578e+01 3.7435401916503906e+01 -3.1615798950195312e+02 -4.8161701202392578e+01 3.2907699584960938e+01 -3.1615798950195312e+02 -4.4766899108886719e+01 3.2907699584960938e+01 -3.1116299438476562e+02 -3.3710899353027344e+01 3.5070301055908203e+01 -3.0753900146484375e+02 -2.2392301559448242e+01 3.6638698577880859e+01 -3.0569900512695312e+02 -1.3303299903869629e+01 3.7435401916503906e+01 -3.0569900512695312e+02 -4.8441600799560547e+01 3.7432102203369141e+01 -3.1616299438476562e+02 -4.9481601715087891e+01 3.2760398864746094e+01 -3.0570401000976562e+02 -5.0417098999023438e+01 3.7214900970458984e+01 -3.1616400146484375e+02 -4.9687900543212891e+01 3.2737400054931641e+01 -3.0570401000976562e+02 -5.0453201293945312e+01 3.7211002349853516e+01 -3.1617098999023438e+02 -5.0451301574707031e+01 3.2518302917480469e+01 -3.0571301269531250e+02 -5.2106101989746094e+01 3.6757301330566406e+01 -3.1617599487304688e+02 -5.0744998931884766e+01 3.2377101898193359e+01 -3.0571801757812500e+02 -5.2576400756835938e+01 3.6543800354003906e+01 -3.0572998046875000e+02 -5.3950099945068359e+01 3.5919902801513672e+01 -3.1619302368164062e+02 -5.1836700439453125e+01 3.1852201461791992e+01 -3.0573898315429688e+02 -5.4577899932861328e+01 3.5494899749755859e+01 -3.1619598388671875e+02 -5.1931999206542969e+01 3.1784698486328125e+01 -3.1620898437500000e+02 -5.2483303070068359e+01 3.1393899917602539e+01 -3.0575299072265625e+02 -5.5570301055908203e+01 3.4823200225830078e+01 -3.1622399902343750e+02 -5.2944801330566406e+01 3.0932701110839844e+01 -3.0576800537109375e+02 -5.6371902465820312e+01 3.4115299224853516e+01 -3.0576800537109375e+02 -5.6375102996826172e+01 3.4112400054931641e+01 -3.1624499511718750e+02 -5.3570598602294922e+01 3.0307399749755859e+01 -3.0579998779296875e+02 -5.7705497741699219e+01 3.2583198547363281e+01 -3.1625698852539062e+02 -5.3827301025390625e+01 2.9945699691772461e+01 -3.0580401611328125e+02 -5.7825000762939453e+01 3.2381797790527344e+01 -3.1626599121093750e+02 -5.4029300689697266e+01 2.9661100387573242e+01 -3.0583999633789062e+02 -5.8844699859619141e+01 3.0663000106811523e+01 -3.1629602050781250e+02 -5.4454097747802734e+01 2.8778999328613281e+01 -3.0584500122070312e+02 -5.8937400817871094e+01 3.0412799835205078e+01 -3.1631298828125000e+02 -5.4696498870849609e+01 2.8275699615478516e+01 -3.0587899780273438e+02 -5.9548297882080078e+01 2.8764699935913086e+01 -3.1633697509765625e+02 -5.4909198760986328e+01 2.7536399841308594e+01 -3.0588900756835938e+02 -5.9642299652099609e+01 2.8265598297119141e+01 -3.1633801269531250e+02 -5.4915802001953125e+01 2.7513500213623047e+01 -3.0591900634765625e+02 -5.9910499572753906e+01 2.6842399597167969e+01 -3.1638101196289062e+02 -5.5083099365234375e+01 2.6220399856567383e+01 -3.0593600463867188e+02 -5.9966499328613281e+01 2.6028400421142578e+01 -3.0593600463867188e+02 -5.9966602325439453e+01 2.6026201248168945e+01 -2.0251899719238281e+02 5.5083099365234375e+01 2.6220399856567383e+01 -2.1296400451660156e+02 5.9966602325439453e+01 2.6026201248168945e+01 -2.1296400451660156e+02 5.9966499328613281e+01 2.6028400421142578e+01 -2.1298100280761719e+02 5.9910499572753906e+01 2.6842399597167969e+01 -2.0256201171875000e+02 5.4915802001953125e+01 2.7513500213623047e+01 -2.1301100158691406e+02 5.9642299652099609e+01 2.8265598297119141e+01 -2.0256300354003906e+02 5.4909198760986328e+01 2.7536399841308594e+01 -2.1302099609375000e+02 5.9548297882080078e+01 2.8764699935913086e+01 -2.0258699035644531e+02 5.4696498870849609e+01 2.8275699615478516e+01 -2.1305499267578125e+02 5.8937400817871094e+01 3.0412799835205078e+01 -2.0260398864746094e+02 5.4454097747802734e+01 2.8778999328613281e+01 -2.1306001281738281e+02 5.8844699859619141e+01 3.0663000106811523e+01 -2.0263299560546875e+02 5.4029300689697266e+01 2.9661100387573242e+01 -2.1309599304199219e+02 5.7825000762939453e+01 3.2381797790527344e+01 -2.0264300537109375e+02 5.3827301025390625e+01 2.9945699691772461e+01 -2.1310000610351562e+02 5.7705497741699219e+01 3.2583198547363281e+01 -2.0265499877929688e+02 5.3570598602294922e+01 3.0307399749755859e+01 -2.1313198852539062e+02 5.6375102996826172e+01 3.4112400054931641e+01 -2.0267599487304688e+02 5.2944801330566406e+01 3.0932701110839844e+01 -2.1313198852539062e+02 5.6371902465820312e+01 3.4115299224853516e+01 -2.1314700317382812e+02 5.5570301055908203e+01 3.4823200225830078e+01 -2.0269100952148438e+02 5.2483303070068359e+01 3.1393899917602539e+01 -2.1316101074218750e+02 5.4577899932861328e+01 3.5494899749755859e+01 -2.0270399475097656e+02 5.1931999206542969e+01 3.1784698486328125e+01 -2.0270698547363281e+02 5.1836799621582031e+01 3.1852201461791992e+01 -2.1316899108886719e+02 5.3950099945068359e+01 3.5919902801513672e+01 -2.0272399902343750e+02 5.0744998931884766e+01 3.2377101898193359e+01 -2.1318200683593750e+02 5.2576400756835938e+01 3.6543800354003906e+01 -2.1318699645996094e+02 5.2106101989746094e+01 3.6757301330566406e+01 -2.0272900390625000e+02 5.0451301574707031e+01 3.2518302917480469e+01 -2.1319599914550781e+02 5.0453201293945312e+01 3.7211002349853516e+01 -2.0273399353027344e+02 4.9957302093505859e+01 3.2670898437500000e+01 -2.1319599914550781e+02 5.0417098999023438e+01 3.7214900970458984e+01 -2.0273600769042969e+02 4.9477699279785156e+01 3.2734100341796875e+01 -2.1320100402832031e+02 4.8441600799560547e+01 3.7432102203369141e+01 -2.0274198913574219e+02 4.8161701202392578e+01 3.2907699584960938e+01 -2.1320100402832031e+02 4.8161701202392578e+01 3.7435401916503906e+01 -2.1320100402832031e+02 -4.8161701202392578e+01 3.7435401916503906e+01 -2.0274198913574219e+02 -4.8161701202392578e+01 3.2907699584960938e+01 -2.1316101074218750e+02 -5.4590602874755859e+01 3.5510799407958984e+01 -2.1317900085449219e+02 -5.3044399261474609e+01 3.6378997802734375e+01 -2.0272399902343750e+02 -5.0741298675537109e+01 3.2366397857666016e+01 -2.1319999694824219e+02 -4.8978199005126953e+01 3.7407100677490234e+01 -2.0273800659179688e+02 -4.9450599670410156e+01 3.2786701202392578e+01 -2.1319599914550781e+02 -5.0412700653076172e+01 3.7187198638916016e+01 -2.0273699951171875e+02 -4.9483398437500000e+01 3.2778598785400391e+01 -2.1319400024414062e+02 -5.0913200378417969e+01 3.7110401153564453e+01 -2.0273100280761719e+02 -5.0221302032470703e+01 3.2594402313232422e+01 -2.1318299865722656e+02 -5.2583797454833984e+01 3.6555099487304688e+01 -2.1318099975585938e+02 -5.2834999084472656e+01 3.6471603393554688e+01 -2.0271099853515625e+02 -5.1628799438476562e+01 3.1977399826049805e+01 -2.0270399475097656e+02 -5.1929000854492188e+01 3.1779899597167969e+01 -2.1315798950195312e+02 -5.4802803039550781e+01 3.5391700744628906e+01 -2.0269599914550781e+02 -5.2293502807617188e+01 3.1540199279785156e+01 -2.1313198852539062e+02 -5.6371700286865234e+01 3.4115200042724609e+01 -2.0267599487304688e+02 -5.2946002960205078e+01 3.0931800842285156e+01 -2.1313198852539062e+02 -5.6375102996826172e+01 3.4112400054931641e+01 -2.0266099548339844e+02 -5.3417602539062500e+01 3.0492101669311523e+01 -2.1311799621582031e+02 -5.7013599395751953e+01 3.3444400787353516e+01 -2.1309599304199219e+02 -5.7811100006103516e+01 3.2368896484375000e+01 -2.0264300537109375e+02 -5.3832099914550781e+01 2.9948801040649414e+01 -2.0263999938964844e+02 -5.3899799346923828e+01 2.9860099792480469e+01 -2.1308399963378906e+02 -5.8216400146484375e+01 3.1822301864624023e+01 -2.0260398864746094e+02 -5.4464702606201172e+01 2.8782999038696289e+01 -2.1305499267578125e+02 -5.8933799743652344e+01 3.0408399581909180e+01 -2.1304798889160156e+02 -5.9101898193359375e+01 3.0076900482177734e+01 -2.0259500122070312e+02 -5.4614101409912109e+01 2.8497999191284180e+01 -2.1301100158691406e+02 -5.9662899017333984e+01 2.8268299102783203e+01 -2.0257798767089844e+02 -5.4784397125244141e+01 2.8007900238037109e+01 -2.0256201171875000e+02 -5.4864398956298828e+01 2.7529100418090820e+01 -2.1300799560546875e+02 -5.9701599121093750e+01 2.8143501281738281e+01 -2.0251899719238281e+02 -5.5083099365234375e+01 2.6220399856567383e+01 -2.1296400451660156e+02 -5.9966499328613281e+01 2.6028400421142578e+01 -2.1296400451660156e+02 -5.9966602325439453e+01 2.6026201248168945e+01 -3.1521200561523438e+02 3.3339103698730469e+01 3.4373600006103516e+01 -3.1171899414062500e+02 2.3499000549316406e+01 3.5811698913574219e+01 -3.1513101196289062e+02 1.6941101074218750e+01 3.6717399597167969e+01 -3.1023898315429688e+02 1.6914400100708008e+01 3.6421100616455078e+01 -3.1512698364257812e+02 1.6131599426269531e+01 3.6833000183105469e+01 -3.0929602050781250e+02 1.2720600128173828e+01 3.6809299468994141e+01 -3.1510699462890625e+02 7.4576101303100586e+00 3.7419097900390625e+01 -3.1511102294921875e+02 -9.9241695404052734e+00 3.7296501159667969e+01 -3.1510202026367188e+02 -1.2347700595855713e+00 3.7573699951171875e+01 -3.0831701660156250e+02 -4.8338198661804199e+00 3.7155399322509766e+01 -3.0864999389648438e+02 8.1345996856689453e+00 3.7050098419189453e+01 -3.0823999023437500e+02 3.7528901100158691e+00 3.7177997589111328e+01 -3.1510299682617188e+02 -4.6869897050783038e-04 3.7551700592041016e+01 -3.0812899780273438e+02 0.0000000000000000e+00 3.7209297180175781e+01 -3.0812002563476562e+02 -3.1206300854682922e-01 3.7211803436279297e+01 -3.1475897216796875e+02 -3.2236698150634766e+01 3.4560100555419922e+01 -3.1521200561523438e+02 -3.3339103698730469e+01 3.4373600006103516e+01 -3.1517498779296875e+02 -2.7208099365234375e+01 3.5450397491455078e+01 -3.0886599731445312e+02 -9.8149805068969727e+00 3.6974800109863281e+01 -3.0929602050781250e+02 -1.2720600128173828e+01 3.6809299468994141e+01 -3.1513699340820312e+02 -1.6924400329589844e+01 3.6548801422119141e+01 -3.1018399047851562e+02 -1.6916700363159180e+01 3.6443500518798828e+01 -3.1113601684570312e+02 -2.1412099838256836e+01 3.6051601409912109e+01 -3.0561300659179688e+02 -1.0264599800109863e+01 3.7470199584960938e+01 -3.0557000732421875e+02 8.5072498321533203e+00 3.7486099243164062e+01 -3.0550302124023438e+02 -5.0552501678466797e+00 3.7508201599121094e+01 -3.0546398925781250e+02 -3.2636201381683350e-01 3.7520198822021484e+01 -3.0548797607421875e+02 3.9248499870300293e+00 3.7513000488281250e+01 -2.0152198791503906e+02 5.4006496429443359e+01 2.6219099044799805e+01 -2.0153900146484375e+02 5.4087402343750000e+01 2.6221200942993164e+01 -2.0151499938964844e+02 5.3974201202392578e+01 2.6218299865722656e+01 -2.0193299865722656e+02 5.4626499176025391e+01 2.6225601196289062e+01 -2.0196099853515625e+02 5.4664100646972656e+01 2.6225900650024414e+01 -2.0203199768066406e+02 5.4761398315429688e+01 2.6226699829101562e+01 -2.0154499816894531e+02 5.3868499755859375e+01 2.7312398910522461e+01 -2.0195199584960938e+02 5.4486198425292969e+01 2.7437700271606445e+01 -2.0197599792480469e+02 5.4280696868896484e+01 2.8151399612426758e+01 -2.0204100036621094e+02 5.3226097106933594e+01 3.0053699493408203e+01 -2.0202000427246094e+02 5.3655799865722656e+01 2.9448600769042969e+01 -2.0207501220703125e+02 5.2207897186279297e+01 3.1070899963378906e+01 -2.0208999633789062e+02 5.1602600097656250e+01 3.1500000000000000e+01 -2.0211599731445312e+02 4.9842800140380859e+01 3.2266399383544922e+01 -2.0211100769042969e+02 5.0305400848388672e+01 3.2123497009277344e+01 -2.0215399169921875e+02 4.8161701202392578e+01 3.2508899688720703e+01 -2.0212399291992188e+02 4.8161701202392578e+01 3.2487998962402344e+01 -2.0169400024414062e+02 4.8161701202392578e+01 3.1834699630737305e+01 -2.0156700134277344e+02 5.3683200836181641e+01 2.7956501007080078e+01 -2.0160700988769531e+02 5.3119499206542969e+01 2.9127300262451172e+01 -2.0162600708007812e+02 5.2731903076171875e+01 2.9673398971557617e+01 -2.0165798950195312e+02 5.1813201904296875e+01 3.0591600418090820e+01 -2.0167199707031250e+02 5.1267002105712891e+01 3.0978799819946289e+01 -2.0169099426269531e+02 5.0096298217773438e+01 3.1541702270507812e+01 -2.0169599914550781e+02 4.9678798675537109e+01 3.1670700073242188e+01 -2.0170300292968750e+02 4.8161800384521484e+01 3.1870801925659180e+01 -2.0170300292968750e+02 4.8161701202392578e+01 3.1870801925659180e+01 -2.0229400634765625e+02 -4.8161701202392578e+01 3.2639801025390625e+01 -2.0217601013183594e+02 -4.8161701202392578e+01 3.2493698120117188e+01 -2.0215299987792969e+02 -4.8161701202392578e+01 3.2464599609375000e+01 -2.0174198913574219e+02 -4.8161800384521484e+01 3.1955997467041016e+01 -2.0172000122070312e+02 -4.8161800384521484e+01 3.1866598129272461e+01 -2.0171099853515625e+02 -4.8161800384521484e+01 3.1830501556396484e+01 -2.0193199157714844e+02 -5.4627601623535156e+01 2.6225000381469727e+01 -2.0195401000976562e+02 -5.4657897949218750e+01 2.6225299835205078e+01 -2.0193800354003906e+02 -5.4618198394775391e+01 2.6249200820922852e+01 -2.0202200317382812e+02 -5.4752902984619141e+01 2.6226301193237305e+01 -2.0153500366210938e+02 -5.4077899932861328e+01 2.6219699859619141e+01 -2.0152500915527344e+02 -5.4003101348876953e+01 2.6230800628662109e+01 -2.0151998901367188e+02 -5.4006999969482422e+01 2.6217700958251953e+01 -2.0151199340820312e+02 -5.3970600128173828e+01 2.6216701507568359e+01 -2.0169900512695312e+02 -4.9250801086425781e+01 3.1768600463867188e+01 -2.0212001037597656e+02 -4.9368400573730469e+01 3.2374797821044922e+01 -2.0211399841308594e+02 -5.0090000152587891e+01 3.2194698333740234e+01 -2.0208000183105469e+02 -5.2030197143554688e+01 3.1207901000976562e+01 -2.0209400939941406e+02 -5.1407798767089844e+01 3.1617198944091797e+01 -2.0204600524902344e+02 -5.3082801818847656e+01 3.0226598739624023e+01 -2.0202600097656250e+02 -5.3534400939941406e+01 2.9634998321533203e+01 -2.0169299316406250e+02 -4.9902000427246094e+01 3.1605998992919922e+01 -2.0167500305175781e+02 -5.1091201782226562e+01 3.1084600448608398e+01 -2.0166300964355469e+02 -5.1652801513671875e+01 3.0715198516845703e+01 -2.0163198852539062e+02 -5.2602600097656250e+01 2.9829500198364258e+01 -2.0161299133300781e+02 -5.3010002136230469e+01 2.9295499801635742e+01 -2.0157299804687500e+02 -5.3613700866699219e+01 2.8144399642944336e+01 -2.0155900573730469e+02 -5.3757499694824219e+01 2.7730100631713867e+01 -2.0198300170898438e+02 -5.4203598022460938e+01 2.8359600067138672e+01 -2.0196699523925781e+02 -5.4363101959228516e+01 2.7900600433349609e+01 -3.1570397949218750e+02 3.9318302154541016e+01 3.3417999267578125e+01 -3.1591400146484375e+02 4.1831096649169922e+01 3.3103801727294922e+01 -3.1599700927734375e+02 4.2829700469970703e+01 3.3018100738525391e+01 -3.1374499511718750e+02 3.4981197357177734e+01 3.4222900390625000e+01 -3.1557101440429688e+02 3.7729598999023438e+01 3.3616699218750000e+01 -3.1529400634765625e+02 3.4345600128173828e+01 3.4200099945068359e+01 -3.0987997436523438e+02 2.4020999908447266e+01 3.5874500274658203e+01 -3.0745898437500000e+02 1.3003899574279785e+01 3.6909400939941406e+01 -3.0745898437500000e+02 -1.3003899574279785e+01 3.6909400939941406e+01 -3.0721301269531250e+02 -1.0034799575805664e+01 3.7050399780273438e+01 -3.0689401245117188e+02 -4.9427099227905273e+00 3.7205497741699219e+01 -3.0677899169921875e+02 -3.1911098957061768e-01 3.7254199981689453e+01 -3.0684899902343750e+02 3.8375802040100098e+00 3.7224899291992188e+01 -3.0708798217773438e+02 8.3172302246093750e+00 3.7114898681640625e+01 -3.1583099365234375e+02 -4.0841499328613281e+01 3.3205402374267578e+01 -3.1570397949218750e+02 -3.9314197540283203e+01 3.3420001983642578e+01 -3.1291799926757812e+02 -3.2950599670410156e+01 3.4576301574707031e+01 -3.1545401000976562e+02 -3.6320297241210938e+01 3.3840599060058594e+01 -3.1533300781250000e+02 -3.4834899902343750e+01 3.4097297668457031e+01 -3.0929800415039062e+02 -2.1888000488281250e+01 3.6123500823974609e+01 -3.1746301269531250e+02 5.3800697326660156e+01 2.6215198516845703e+01 -3.1698199462890625e+02 5.4632499694824219e+01 2.6226301193237305e+01 -3.1703698730468750e+02 5.4590602874755859e+01 2.6226900100708008e+01 -3.1694497680664062e+02 5.4660400390625000e+01 2.6226001739501953e+01 -3.1736001586914062e+02 5.3992000579833984e+01 2.6218000411987305e+01 -3.1737597656250000e+02 5.3962799072265625e+01 2.6217599868774414e+01 -3.1719699096679688e+02 4.8161800384521484e+01 3.1870801925659180e+01 -3.1719699096679688e+02 4.8161701202392578e+01 3.1870801925659180e+01 -3.1720501708984375e+02 4.8161701202392578e+01 3.1834699630737305e+01 -3.1674600219726562e+02 4.8161701202392578e+01 3.2508899688720703e+01 -3.1677600097656250e+02 4.8161701202392578e+01 3.2487998962402344e+01 -3.1677999877929688e+02 4.9368400573730469e+01 3.2374797821044922e+01 -3.1678598022460938e+02 5.0090000152587891e+01 3.2194698333740234e+01 -3.1682000732421875e+02 5.2030197143554688e+01 3.1207901000976562e+01 -3.1680599975585938e+02 5.1407798767089844e+01 3.1617198944091797e+01 -3.1685299682617188e+02 5.3082801818847656e+01 3.0226598739624023e+01 -3.1687399291992188e+02 5.3534400939941406e+01 2.9634901046752930e+01 -3.1694097900390625e+02 5.4434097290039062e+01 2.7651000976562500e+01 -3.1691699218750000e+02 5.4203598022460938e+01 2.8359600067138672e+01 -3.1734899902343750e+02 5.3821498870849609e+01 2.7504800796508789e+01 -3.1732699584960938e+02 5.3613700866699219e+01 2.8144399642944336e+01 -3.1728698730468750e+02 5.3010002136230469e+01 2.9295400619506836e+01 -3.1726800537109375e+02 5.2602600097656250e+01 2.9829500198364258e+01 -3.1723699951171875e+02 5.1652801513671875e+01 3.0715198516845703e+01 -3.1722500610351562e+02 5.1091201782226562e+01 3.1084600448608398e+01 -3.1720700073242188e+02 4.9902000427246094e+01 3.1605998992919922e+01 -3.1720098876953125e+02 4.9250801086425781e+01 3.1768600463867188e+01 -3.1726397705078125e+02 4.4766899108886719e+01 3.1695198059082031e+01 -3.1719799804687500e+02 4.4766899108886719e+01 3.1829301834106445e+01 -3.1701599121093750e+02 4.4766899108886719e+01 3.2199302673339844e+01 -3.1673800659179688e+02 4.4766899108886719e+01 3.2503898620605469e+01 -3.1663702392578125e+02 4.4766899108886719e+01 3.2614398956298828e+01 -3.1599301147460938e+02 3.3312099456787109e+01 3.4261699676513672e+01 -3.1724899291992188e+02 4.2766899108886719e+01 3.1786598205566406e+01 -3.1653402709960938e+02 4.2815101623535156e+01 3.2742298126220703e+01 -3.1696502685546875e+02 4.2793601989746094e+01 3.2318901062011719e+01 -3.1723898315429688e+02 4.1739898681640625e+01 3.1868598937988281e+01 -3.1693701171875000e+02 4.1779499053955078e+01 3.2414100646972656e+01 -3.1648001098632812e+02 4.1810901641845703e+01 3.2839599609375000e+01 -3.1624798583984375e+02 3.7697502136230469e+01 3.3415802001953125e+01 -3.1719299316406250e+02 3.7548698425292969e+01 3.2403598785400391e+01 -3.1681298828125000e+02 3.7634700775146484e+01 3.2993801116943359e+01 -3.1713400268554688e+02 3.3105400085449219e+01 3.3236499786376953e+01 -3.1666897583007812e+02 3.3229900360107422e+01 3.3861900329589844e+01 -3.1590802001953125e+02 1.6118598937988281e+01 3.6718799591064453e+01 -3.1713400268554688e+02 -3.3105400085449219e+01 3.3236499786376953e+01 -3.1666897583007812e+02 -3.3229900360107422e+01 3.3861900329589844e+01 -3.1709600830078125e+02 -2.7017499923706055e+01 3.4305599212646484e+01 -3.1599301147460938e+02 -3.3312099456787109e+01 3.4261699676513672e+01 -3.1663098144531250e+02 -2.7118999481201172e+01 3.4935001373291016e+01 -3.1595599365234375e+02 -2.7186100006103516e+01 3.5337501525878906e+01 -3.1588198852539062e+02 -1.2337599992752075e+00 3.7458801269531250e+01 -3.1589199829101562e+02 -9.9161300659179688e+00 3.7181797027587891e+01 -3.1588800048828125e+02 7.4515299797058105e+00 3.7304302215576172e+01 -3.1703201293945312e+02 -9.8546104431152344e+00 3.6138500213623047e+01 -3.1702301025390625e+02 -1.2261300086975098e+00 3.6413700103759766e+01 -3.1702798461914062e+02 7.4053401947021484e+00 3.6260200500488281e+01 -3.1704800415039062e+02 1.6018598556518555e+01 3.5678401947021484e+01 -3.1656701660156250e+02 -9.8916301727294922e+00 3.6774700164794922e+01 -3.1655801391601562e+02 -1.2307199239730835e+00 3.7050998687744141e+01 -3.1656301879882812e+02 7.4331803321838379e+00 3.6896900177001953e+01 -3.1658300781250000e+02 1.6078800201416016e+01 3.6312900543212891e+01 -3.1608001708984375e+02 -3.4804500579833984e+01 3.3952999114990234e+01 -3.1671899414062500e+02 -3.4727302551269531e+01 3.3543800354003906e+01 -3.1715499877929688e+02 -3.4614601135253906e+01 3.2929199218750000e+01 -3.1616699218750000e+02 -3.6288101196289062e+01 3.3666202545166016e+01 -3.1676699829101562e+02 -3.6217498779296875e+01 3.3249500274658203e+01 -3.1690798950195312e+02 -4.0776599884033203e+01 3.2528003692626953e+01 -3.1642498779296875e+02 -4.0816799163818359e+01 3.2954498291015625e+01 -3.1663702392578125e+02 -4.4766899108886719e+01 3.2614398956298828e+01 -3.1673800659179688e+02 -4.4766899108886719e+01 3.2503898620605469e+01 -3.1701599121093750e+02 -4.4766899108886719e+01 3.2199302673339844e+01 -3.1719799804687500e+02 -4.4766899108886719e+01 3.1829301834106445e+01 -3.1717498779296875e+02 -3.6117900848388672e+01 3.2646896362304688e+01 -3.1722900390625000e+02 -4.0724899291992188e+01 3.1970500946044922e+01 -3.1726397705078125e+02 -4.4766899108886719e+01 3.1695198059082031e+01 -3.1718298339843750e+02 -4.8161800384521484e+01 3.1819898605346680e+01 -3.1727600097656250e+02 -4.8161800384521484e+01 3.1656600952148438e+01 -3.1673602294921875e+02 -4.8161701202392578e+01 3.2495300292968750e+01 -3.1676599121093750e+02 -4.8161701202392578e+01 3.2473697662353516e+01 -3.1684100341796875e+02 -4.8161701202392578e+01 3.2420200347900391e+01 -3.1716497802734375e+02 -4.8161800384521484e+01 3.1852300643920898e+01 -3.1748501586914062e+02 -5.3716102600097656e+01 2.6211301803588867e+01 -3.1733999633789062e+02 -5.3980499267578125e+01 2.6257099151611328e+01 -3.1736801147460938e+02 -5.3955398559570312e+01 2.6215499877929688e+01 -3.1735101318359375e+02 -5.3989299774169922e+01 2.6216100692749023e+01 -3.1694400024414062e+02 -5.4645099639892578e+01 2.6224800109863281e+01 -3.1697299194335938e+02 -5.4622097015380859e+01 2.6225000381469727e+01 -3.1696701049804688e+02 -5.4614498138427734e+01 2.6248899459838867e+01 -3.1708300781250000e+02 -5.4536499023437500e+01 2.6225900650024414e+01 -3.1694799804687500e+02 -5.4486198425292969e+01 2.7437700271606445e+01 -3.1692401123046875e+02 -5.4280696868896484e+01 2.8151399612426758e+01 -3.1685900878906250e+02 -5.3226097106933594e+01 3.0053699493408203e+01 -3.1687997436523438e+02 -5.3655799865722656e+01 2.9448600769042969e+01 -3.1682501220703125e+02 -5.2207897186279297e+01 3.1070899963378906e+01 -3.1680999755859375e+02 -5.1602500915527344e+01 3.1500000000000000e+01 -3.1678198242187500e+02 -4.9590599060058594e+01 3.2328697204589844e+01 -3.1678900146484375e+02 -5.0305400848388672e+01 3.2123497009277344e+01 -3.1720199584960938e+02 -4.9451198577880859e+01 3.1726900100708008e+01 -3.1720901489257812e+02 -5.0096298217773438e+01 3.1541702270507812e+01 -3.1722799682617188e+02 -5.1266902923583984e+01 3.0978899002075195e+01 -3.1724200439453125e+02 -5.1813201904296875e+01 3.0591600418090820e+01 -3.1727401733398438e+02 -5.2731903076171875e+01 2.9673398971557617e+01 -3.1729299926757812e+02 -5.3119499206542969e+01 2.9127300262451172e+01 -3.1733300781250000e+02 -5.3683200836181641e+01 2.7956501007080078e+01 -3.1735501098632812e+02 -5.3868499755859375e+01 2.7312398910522461e+01 )) mat)))
                  )
                 ))
      (send glv :transform local-cds)
      (send glv :calc-normals)
      (setq qhull
            ;; qhull 14028 -> 40 faces
            (instance faceset :init :faces (list
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1923699378967285e+02 -5.3654100745916367e+01 -2.6751000434160233e+01) (float-vector -3.0512800812721252e+02 -6.1894800513982773e+01 -2.6217600330710411e+01) (float-vector -3.0510398745536804e+02 -5.7701598852872849e+01 -3.2482799142599106e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1717300415039062e+02 -5.6682001799345016e+01 2.7941700071096420e+01) (float-vector -3.0600199103355408e+02 -6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -3.0512800812721252e+02 -6.1894800513982773e+01 -2.6217600330710411e+01) (float-vector -3.1923699378967285e+02 -5.3654100745916367e+01 -2.6751000434160233e+01) (float-vector -3.2045099139213562e+02 -5.4188501089811325e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1861600279808044e+02 5.1322598010301590e+00 -3.7863101810216904e+01) (float-vector -3.1522101163864136e+02 -1.4786499552428722e+01 -3.9130598306655884e+01) (float-vector -3.0595898628234863e+02 0.0000000000000000e+00 -3.9858300238847733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1820398569107056e+02 -5.0757501274347305e+01 3.3462598919868469e+01) (float-vector -3.1717300415039062e+02 -5.6682001799345016e+01 2.7941700071096420e+01) (float-vector -3.2045099139213562e+02 -5.4188501089811325e+01 0.0000000000000000e+00) (float-vector -3.1894999742507935e+02 -3.3252898603677750e+01 3.4059900790452957e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1522101163864136e+02 -1.4786499552428722e+01 -3.9130598306655884e+01) (float-vector -2.1220499277114868e+02 -5.5388901382684708e+01 -3.3218100666999817e+01) (float-vector -2.1221099793910980e+02 5.2551399916410446e+01 -3.3670499920845032e+01) (float-vector -3.0595898628234863e+02 0.0000000000000000e+00 -3.9858300238847733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1869798898696899e+02 -2.9155399650335312e+01 -3.5492599010467529e+01) (float-vector -3.1522101163864136e+02 -1.4786499552428722e+01 -3.9130598306655884e+01) (float-vector -3.1861600279808044e+02 5.1322598010301590e+00 -3.7863101810216904e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1869798898696899e+02 -2.9155399650335312e+01 -3.5492599010467529e+01) (float-vector -3.1923699378967285e+02 -5.3654100745916367e+01 -2.6751000434160233e+01) (float-vector -3.0510398745536804e+02 -5.7701598852872849e+01 -3.2482799142599106e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1869798898696899e+02 -2.9155399650335312e+01 -3.5492599010467529e+01) (float-vector -3.0510398745536804e+02 -5.7701598852872849e+01 -3.2482799142599106e+01) (float-vector -2.1220499277114868e+02 -5.5388901382684708e+01 -3.3218100666999817e+01) (float-vector -3.1522101163864136e+02 -1.4786499552428722e+01 -3.9130598306655884e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1221099793910980e+02 5.2551399916410446e+01 -3.3670499920845032e+01) (float-vector -2.1379099786281586e+02 5.9131901711225510e+01 -3.1351700425148010e+01) (float-vector -3.0509901046752930e+02 5.3905699402093887e+01 -3.3902898430824280e+01) (float-vector -3.1724101305007935e+02 2.9398299753665924e+01 -3.6879401654005051e+01) (float-vector -3.1861600279808044e+02 5.1322598010301590e+00 -3.7863101810216904e+01) (float-vector -3.0595898628234863e+02 0.0000000000000000e+00 -3.9858300238847733e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0162999629974365e+02 5.6781899183988571e+01 -2.5081900879740715e+01) (float-vector -2.1379099786281586e+02 5.9131901711225510e+01 -3.1351700425148010e+01) (float-vector -1.9964399933815002e+02 5.2551399916410446e+01 -2.6997100561857224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1237699687480927e+02 -5.4110601544380188e+01 3.7903398275375366e+01) (float-vector -3.0498200654983521e+02 -5.9363599866628647e+01 3.3997401595115662e+01) (float-vector -3.0490401387214661e+02 -4.8161700367927551e+01 3.9599999785423279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1717300415039062e+02 -5.6682001799345016e+01 2.7941700071096420e+01) (float-vector -3.0498200654983521e+02 -5.9363599866628647e+01 3.3997401595115662e+01) (float-vector -3.0600199103355408e+02 -6.3064701855182648e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0498200654983521e+02 -5.9363599866628647e+01 3.3997401595115662e+01) (float-vector -3.1717300415039062e+02 -5.6682001799345016e+01 2.7941700071096420e+01) (float-vector -3.1820398569107056e+02 -5.0757501274347305e+01 3.3462598919868469e+01) (float-vector -3.0490401387214661e+02 -4.8161700367927551e+01 3.9599999785423279e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1379099786281586e+02 5.9131901711225510e+01 -3.1351700425148010e+01) (float-vector -3.0672800540924072e+02 5.8889500796794891e+01 -3.1109699979424477e+01) (float-vector -3.0509901046752930e+02 5.3905699402093887e+01 -3.3902898430824280e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0509901046752930e+02 5.3905699402093887e+01 -3.3902898430824280e+01) (float-vector -3.0672800540924072e+02 5.8889500796794891e+01 -3.1109699979424477e+01) (float-vector -3.1924000382423401e+02 5.3788699209690094e+01 -2.6659799739718437e+01) (float-vector -3.1724101305007935e+02 2.9398299753665924e+01 -3.6879401654005051e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0672800540924072e+02 5.8889500796794891e+01 -3.1109699979424477e+01) (float-vector -3.0600199103355408e+02 6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -3.1931000947952271e+02 5.6987300515174866e+01 0.0000000000000000e+00) (float-vector -3.1924000382423401e+02 5.3788699209690094e+01 -2.6659799739718437e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1379099786281586e+02 5.9131901711225510e+01 -3.1351700425148010e+01) (float-vector -2.0162999629974365e+02 5.6781899183988571e+01 -2.5081900879740715e+01) (float-vector -2.1289800107479095e+02 6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -3.0600199103355408e+02 6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -3.0672800540924072e+02 5.8889500796794891e+01 -3.1109699979424477e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1384400129318237e+02 -6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -3.0498200654983521e+02 -5.9363599866628647e+01 3.3997401595115662e+01) (float-vector -2.1237699687480927e+02 -5.4110601544380188e+01 3.7903398275375366e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0600199103355408e+02 -6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -3.0498200654983521e+02 -5.9363599866628647e+01 3.3997401595115662e+01) (float-vector -2.1384400129318237e+02 -6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -2.1289800107479095e+02 -6.3064701855182648e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1237699687480927e+02 -5.4110601544380188e+01 3.7903398275375366e+01) (float-vector -2.0071099698543549e+02 -4.8161599785089493e+01 3.3903799951076508e+01) (float-vector -2.0174700021743774e+02 -5.6515898555517197e+01 2.8565200045704842e+01) (float-vector -2.1384400129318237e+02 -6.1837598681449890e+01 2.8595300391316414e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1289800107479095e+02 -6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -2.1376900374889374e+02 -6.2011398375034332e+01 -2.5371199473738670e+01) (float-vector -3.0512800812721252e+02 -6.1894800513982773e+01 -2.6217600330710411e+01) (float-vector -3.0600199103355408e+02 -6.3064701855182648e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0512800812721252e+02 -6.1894800513982773e+01 -2.6217600330710411e+01) (float-vector -2.1376900374889374e+02 -6.2011398375034332e+01 -2.5371199473738670e+01) (float-vector -2.0685300230979919e+02 -5.9224899858236313e+01 -2.4991000071167946e+01) (float-vector -2.1220499277114868e+02 -5.5388901382684708e+01 -3.3218100666999817e+01) (float-vector -3.0510398745536804e+02 -5.7701598852872849e+01 -3.2482799142599106e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0685300230979919e+02 -5.9224899858236313e+01 -2.4991000071167946e+01) (float-vector -1.9967100024223328e+02 -5.3099300712347031e+01 -2.6993000879883766e+01) (float-vector -2.1220499277114868e+02 -5.5388901382684708e+01 -3.3218100666999817e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9967100024223328e+02 -5.3099300712347031e+01 -2.6993000879883766e+01) (float-vector -1.9844900071620941e+02 -5.4189901798963547e+01 0.0000000000000000e+00) (float-vector -1.9844900071620941e+02 5.4188501089811325e+01 0.0000000000000000e+00) (float-vector -2.0162999629974365e+02 5.6781899183988571e+01 -2.5081900879740715e+01) (float-vector -1.9964399933815002e+02 5.2551399916410446e+01 -2.6997100561857224e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9967100024223328e+02 -5.3099300712347031e+01 -2.6993000879883766e+01) (float-vector -1.9964399933815002e+02 5.2551399916410446e+01 -2.6997100561857224e+01) (float-vector -2.1379099786281586e+02 5.9131901711225510e+01 -3.1351700425148010e+01) (float-vector -2.1221099793910980e+02 5.2551399916410446e+01 -3.3670499920845032e+01) (float-vector -2.1220499277114868e+02 -5.5388901382684708e+01 -3.3218100666999817e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1289800107479095e+02 -6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -2.1384400129318237e+02 -6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -2.0174700021743774e+02 -5.6515898555517197e+01 2.8565200045704842e+01) (float-vector -1.9844900071620941e+02 -5.4189901798963547e+01 0.0000000000000000e+00) (float-vector -1.9967100024223328e+02 -5.3099300712347031e+01 -2.6993000879883766e+01) (float-vector -2.0685300230979919e+02 -5.9224899858236313e+01 -2.4991000071167946e+01) (float-vector -2.1376900374889374e+02 -6.2011398375034332e+01 -2.5371199473738670e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1237699687480927e+02 -5.4110601544380188e+01 3.7903398275375366e+01) (float-vector -2.1398399770259857e+02 5.2833899855613708e+01 3.8797400891780853e+01) (float-vector -1.9986100494861603e+02 4.9869399517774582e+01 3.2444100826978683e+01) (float-vector -2.0071099698543549e+02 -4.8161599785089493e+01 3.3903799951076508e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.0174700021743774e+02 -5.6515898555517197e+01 2.8565200045704842e+01) (float-vector -2.0071099698543549e+02 -4.8161599785089493e+01 3.3903799951076508e+01) (float-vector -1.9986100494861603e+02 4.9869399517774582e+01 3.2444100826978683e+01) (float-vector -2.0050600171089172e+02 5.5822800844907761e+01 2.7790199965238571e+01) (float-vector -1.9844900071620941e+02 5.4188501089811325e+01 0.0000000000000000e+00) (float-vector -1.9844900071620941e+02 -5.4189901798963547e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1385599672794342e+02 6.1606999486684799e+01 2.9501700773835182e+01) (float-vector -2.0050600171089172e+02 5.5822800844907761e+01 2.7790199965238571e+01) (float-vector -1.9986100494861603e+02 4.9869399517774582e+01 3.2444100826978683e+01) (float-vector -2.1398399770259857e+02 5.2833899855613708e+01 3.8797400891780853e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -1.9844900071620941e+02 5.4188501089811325e+01 0.0000000000000000e+00) (float-vector -2.0050600171089172e+02 5.5822800844907761e+01 2.7790199965238571e+01) (float-vector -2.1385599672794342e+02 6.1606999486684799e+01 2.9501700773835182e+01) (float-vector -2.1289800107479095e+02 6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -2.0162999629974365e+02 5.6781899183988571e+01 -2.5081900879740715e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1923699378967285e+02 -5.3654100745916367e+01 -2.6751000434160233e+01) (float-vector -3.1869798898696899e+02 -2.9155399650335312e+01 -3.5492599010467529e+01) (float-vector -3.1861600279808044e+02 5.1322598010301590e+00 -3.7863101810216904e+01) (float-vector -3.1724101305007935e+02 2.9398299753665924e+01 -3.6879401654005051e+01) (float-vector -3.1924000382423401e+02 5.3788699209690094e+01 -2.6659799739718437e+01) (float-vector -3.1931000947952271e+02 5.6987300515174866e+01 0.0000000000000000e+00) (float-vector -3.1906199455261230e+02 5.1459200680255890e+01 3.1784798949956894e+01) (float-vector -3.1887200474739075e+02 -1.8247699365019798e+01 3.6299299448728561e+01) (float-vector -3.1894999742507935e+02 -3.3252898603677750e+01 3.4059900790452957e+01) (float-vector -3.2045099139213562e+02 -5.4188501089811325e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -2.1385599672794342e+02 6.1606999486684799e+01 2.9501700773835182e+01) (float-vector -3.0505600571632385e+02 6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -3.0600199103355408e+02 6.3064701855182648e+01 0.0000000000000000e+00) (float-vector -2.1289800107479095e+02 6.3064701855182648e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0505600571632385e+02 6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -2.1385599672794342e+02 6.1606999486684799e+01 2.9501700773835182e+01) (float-vector -2.1398399770259857e+02 5.2833899855613708e+01 3.8797400891780853e+01) (float-vector -3.0652299523353577e+02 5.4110601544380188e+01 3.7903398275375366e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1906199455261230e+02 5.1459200680255890e+01 3.1784798949956894e+01) (float-vector -3.1655800342559814e+02 -1.0477900505065918e+00 3.9342299103736877e+01) (float-vector -3.1887200474739075e+02 -1.8247699365019798e+01 3.6299299448728561e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1655800342559814e+02 -1.0477900505065918e+00 3.9342299103736877e+01) (float-vector -3.1906199455261230e+02 5.1459200680255890e+01 3.1784798949956894e+01) (float-vector -3.0652299523353577e+02 5.4110601544380188e+01 3.7903398275375366e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0490401387214661e+02 -4.8161700367927551e+01 3.9599999785423279e+01) (float-vector -3.1655800342559814e+02 -1.0477900505065918e+00 3.9342299103736877e+01) (float-vector -3.0652299523353577e+02 5.4110601544380188e+01 3.7903398275375366e+01) (float-vector -2.1398399770259857e+02 5.2833899855613708e+01 3.8797400891780853e+01) (float-vector -2.1237699687480927e+02 -5.4110601544380188e+01 3.7903398275375366e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1894999742507935e+02 -3.3252898603677750e+01 3.4059900790452957e+01) (float-vector -3.1887200474739075e+02 -1.8247699365019798e+01 3.6299299448728561e+01) (float-vector -3.1655800342559814e+02 -1.0477900505065918e+00 3.9342299103736877e+01) (float-vector -3.0490401387214661e+02 -4.8161700367927551e+01 3.9599999785423279e+01) (float-vector -3.1820398569107056e+02 -5.0757501274347305e+01 3.3462598919868469e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1717100739479065e+02 5.6666299700737000e+01 2.8009299188852310e+01) (float-vector -3.1906199455261230e+02 5.1459200680255890e+01 3.1784798949956894e+01) (float-vector -3.1931000947952271e+02 5.6987300515174866e+01 0.0000000000000000e+00)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.1906199455261230e+02 5.1459200680255890e+01 3.1784798949956894e+01) (float-vector -3.1717100739479065e+02 5.6666299700737000e+01 2.8009299188852310e+01) (float-vector -3.0505600571632385e+02 6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -3.0652299523353577e+02 5.4110601544380188e+01 3.7903398275375366e+01)))))
              (instance face :init :vertices
                (mapcar #'(lambda (v) (send local-cds :transform-vector v))
                  (nreverse (list  (float-vector -3.0505600571632385e+02 6.1837598681449890e+01 2.8595300391316414e+01) (float-vector -3.1717100739479065e+02 5.6666299700737000e+01 2.8009299188852310e+01) (float-vector -3.1931000947952271e+02 5.6987300515174866e+01 0.0000000000000000e+00) (float-vector -3.0600199103355408e+02 6.3064701855182648e+01 0.0000000000000000e+00)))))
              ))
             )
      (setq geom (instance collada-body :init :replace-obj qhull :name "file:///tmp/collada_model_reader_gripper_link_z97RHf.dae"))
      (when glv
        (setq (geom . gl::aglvertices) glv)
        (send geom :assoc glv))
      geom))
  )


(provide :fetch "(ip-172-30-1-179 4.4.0-1072-aws x86_64) at 2018-12-17 11:22:22 PST")

